/* make_cfg.c - How to make a Filter-Datafile 
 *              MD 10/90
 *              MD 5/91  - Changed to allow simple char conversion
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

char outbuff[5000];

int get_hex(char **p)
{
  char *p2,c;
  int num=-1,i;
  
  p2=*p;
  while(!isxdigit(*p2)&&*p2)
    p2++;
  for(num=-1,i=0;isxdigit(*p2)&&i<2;i++,p2++)
  {
    if(num==-1)
      num=0;
    num<<=4;
    c=toupper(*p2);
    num+=(c>='0'&&c<='9')?c-'0':10+(c-'A');
  }
  *p=p2;
  return num;
}

void make_filter(FILE *in,FILE *out)
{
  char str[256];
  char *buffptr,*strptr,*lenptr;
  char to_conv,count;
  int store;
  
  buffptr=outbuff;
  while(fgets(str,255,in))
  {
    strptr=str;
    if(*strptr&&!isspace(*strptr)) /* Ignore empty lines and comments */
    {
      count=0;
      to_conv=*strptr;
      if(to_conv=='\\') /* escape conversion */
      {
        *buffptr++=0; /* write zero to identify escape... */
        to_conv=*(++strptr); /* ...and get escape char */
        strptr++;
      }
      else
        to_conv=get_hex(&strptr); /* normal conversion */
      *buffptr++=to_conv; /* store conversion char and...*/
      lenptr=buffptr++; /* save pointer to length byte */
      while((store=get_hex(&strptr))!=-1)
      {
        *buffptr++=store;
        count++;
      }
      *lenptr=count;
    }
  }
  fwrite(outbuff,1,buffptr-outbuff,out);
}

int main(int argc,char **argv)
{
  FILE *in_file,*out_file;
  int i;

  if(argc<2)
  {
    puts("Benutzung: make_cfg <Datei>");
    return 1;
  }
  else
  {
    for(i=1;i<argc;i++)
    {
      if(!(in_file=fopen(argv[i],"r")))
        puts("Kann Quelldatei nicht ffnen");
      else
      {
        char targname[80],*lastdot;
        
        strcpy(targname,argv[i]);
        if((lastdot=strrchr(targname,'.'))>strrchr(targname,'\\'))
          strcpy(lastdot,".FLT");
        else
          strcat(targname,".FLT");
        if(!(out_file=fopen(targname,"wb")))
        {
          puts("Kann Zieldatei nicht ffnen");
          fclose(in_file);
        }
        else
        {
          make_filter(in_file,out_file);
          fclose(in_file);
          fclose(out_file);
        } 
      }
    }
  }
  return 0;
}
