// Persistence of Vision Raytracer
#include "shapes.inc"		 
#include "colors.inc"
#include "textures.inc"

#declare xlook=0
#declare lrot=0
#declare xview=0
#declare zview= -180

#include "bounce.inc"

camera {
        location <xview 30.0 zview>
        up <0.0 1.0 0.0>
        right <1.333 0.0 0.0>
		look_at <xlook 40.0 0.0>
 }
object {
	light_source {< 0 80 -180 >
		colour White
	}
}

object {
	sphere { <x1 y1 0> 10 }
		texture {
			reflection .2
			color Gold
		}
		translate < 0 10 0>
}

object {
	sphere { <0 y2 0> 5 }
		texture {
			reflection .1
			color Red
		}
		translate < 0 5 0>
}

object {
	sphere { <x3 y3 z3> 8 }
		texture {
			reflection .2
			color Silver
		}
		translate < 0 8 0>
}

object {
	sphere { <-30 y4 30> 4 }
		texture {
			reflection .1
			color Blue
		}
		translate < 0 4 0>
}

object {
	sphere { <-110 y5 70> 12 }
		texture {
			reflection .2
			color Brass
		}
		translate < 0 12 0>
}

object {
	sphere { <50 y6 130> 30  }
		texture {
			reflection .1
			color Aquamarine
		}
		translate < 0 30 0>
}


object {
	sphere { <x7 y7 -30> 5 }
		texture {
			reflection .1
			color Magenta
		}
		translate < 0 5 0>
}


object {
	plane { <0.0 1.0 0.0> 0.0  }
   
         texture {
         	 checker color White color Red
         	 reflection 0.2
		 	scale <15.0 15.0 15.0>
          }
 }

object { /* Sky */
   sphere { <0 -39000 0> 40000 inverse  }

   texture {
      bozo
      turbulence 0.6
      colour_map {
         [0 0.5 colour red 0.4 green 0.5 blue 1
                  colour red 0.4 green 0.5 blue 1.0]
         [0.5 0.7 colour red 0.4 green 0.5 blue 1
                  colour red 1 green 1 blue 1.0]
         [0.7 1 colour red 1 green 1 blue 1
                  colour red 0.7 green 0.7 blue 0.7]
       }
      scale <500 500 500>
      ambient 1
      diffuse 0
    }

   colour red 0.4 green 0.5 blue 1
 }

