// Makes a very lumpy face by using the vertex points from a triangle mesh
// data set as the centers for blob components.
// The data set used to calculate the centers for the blob components was
// provided by Mira Imaging.
// Dan Farmer

#include "colors.inc"
#include "textures.inc"
#declare PoliticallyCorrectCaucasianFlesh = color Flesh

camera {
    location  <0 0 -25>
    direction <0 0 2>
    up <0 1 0>
    right <1.3333 0 0>
    look_at <0 0 0>
}

object { light_source { <-35 100 -100> color red 1 green 1 blue 1}}

default { texture { Phong_Shiny color PoliticallyCorrectCaucasianFlesh } }
#declare Density = 0.75
#declare Radius = 0.75
object {
    blob {
        threshold 0.65
        component Density Radius < -0.78 -0.61 -0.50 >
        component Density Radius < -0.50 -0.65 -0.65 >
        component Density Radius < -0.78 -0.71 -0.64 >
        component Density Radius < -0.71 -0.97 -0.76 >
        component Density Radius < 0.00 0.01 0.00 >
        component Density Radius < 0.26 0.01 -0.22 >
        component Density Radius < 0.28 -0.18 -0.23 >
        component Density Radius < -0.04 -0.23 -0.02 >
        component Density Radius < 0.20 -0.36 -0.38 >
        component Density Radius < -0.08 -0.38 -0.12 >
        component Density Radius < -0.09 -0.50 -0.54 >
        component Density Radius < 0.05 -0.49 -0.66 >
        component Density Radius < -0.12 -0.65 -0.91 >
        component Density Radius < -0.54 -0.54 -0.35 >
        component Density Radius < -0.76 -0.73 -0.30 >
        component Density Radius < -0.60 -0.67 -0.12 >
        component Density Radius < -0.23 -0.47 0.06 >
        component Density Radius < -0.18 -0.27 0.13 >
        component Density Radius < -0.14 0.01 0.19 >
        component Density Radius < -0.38 -0.94 0.33 >
        component Density Radius < -0.73 -1.20 -0.10 >
        component Density Radius < -0.57 -1.38 0.23 >
        component Density Radius < -0.85 -1.71 -0.17 >
        component Density Radius < -0.83 -1.81 0.01 >
        component Density Radius < -1.17 -2.06 -0.35 >
        component Density Radius < -1.20 -2.17 -0.24 >
        component Density Radius < -1.39 -2.20 -0.53 >
        component Density Radius < -1.46 -2.28 -0.44 >
        component Density Radius < -1.81 -2.43 -0.70 >
        component Density Radius < -1.40 -2.15 -0.78 >
        component Density Radius < -1.24 -2.21 -1.07 >
        component Density Radius < -1.70 -2.45 -1.02 >
        component Density Radius < -0.97 -1.76 -0.87 >
        component Density Radius < -0.35 -0.99 -1.14 >
        component Density Radius < -0.55 -1.49 -1.17 >
        component Density Radius < -0.78 -1.46 -0.84 >
        component Density Radius < -0.77 -1.82 -1.13 >
        component Density Radius < -1.61 -2.59 -1.85 >
        component Density Radius < -1.07 -2.38 -1.78 >
        component Density Radius < -0.49 -1.92 -1.70 >
        component Density Radius < -0.24 -1.52 -1.70 >
        component Density Radius < 0.05 -0.75 -1.68 >
        component Density Radius < 0.27 -0.55 -1.18 >
        component Density Radius < 0.58 -0.33 -0.71 >
        component Density Radius < 0.40 -0.43 -0.91 >
        component Density Radius < 0.64 -0.43 -1.06 >
        component Density Radius < 0.65 -0.63 -1.37 >
        component Density Radius < 0.92 -0.52 -1.28 >
        component Density Radius < 0.58 -0.67 -1.61 >
        component Density Radius < 0.52 -0.48 -1.90 >
        component Density Radius < 0.42 -0.62 -2.04 >
        component Density Radius < 0.41 -0.86 -2.26 >
        component Density Radius < -0.03 -1.33 -2.41 >
        component Density Radius < -0.26 -1.69 -3.03 >
        component Density Radius < -0.40 -1.84 -2.26 >
        component Density Radius < 0.67 -0.52 -2.20 >
        component Density Radius < 0.79 -0.26 -1.93 >
        component Density Radius < 0.69 -0.40 -1.78 >
        component Density Radius < 0.72 -0.16 -0.57 >
        component Density Radius < 0.74 0.01 -0.54 >
        component Density Radius < 1.28 0.01 -0.90 >
        component Density Radius < 1.07 -0.15 -0.81 >
        component Density Radius < 0.78 -0.32 -0.84 >
        component Density Radius < 1.04 -0.34 -0.98 >
        component Density Radius < 1.20 -0.35 -1.17 >
        component Density Radius < 1.31 -0.16 -1.01 >
        component Density Radius < 0.73 -0.54 -1.63 >
        component Density Radius < 0.81 -0.55 -1.54 >
        component Density Radius < 0.95 -0.44 -1.48 >
        component Density Radius < 1.03 -0.39 -1.51 >
        component Density Radius < 1.02 -0.31 -1.59 >
        component Density Radius < 1.31 -0.20 -1.33 >
        component Density Radius < 0.93 -0.16 -1.81 >
        component Density Radius < 0.91 -0.23 -1.73 >
        component Density Radius < 0.84 -0.15 -1.96 >
        component Density Radius < 0.81 -0.29 -1.83 >
        component Density Radius < 1.44 0.01 -1.11 >
        component Density Radius < 1.38 -0.17 -1.14 >
        component Density Radius < 1.35 0.01 -1.42 >
        component Density Radius < 0.88 0.00 -1.96 >
        component Density Radius < 0.80 0.00 -2.19 >
        component Density Radius < 0.79 -0.13 -2.19 >
        component Density Radius < 0.78 -0.27 -2.17 >
        component Density Radius < 0.95 0.00 -2.44 >
        component Density Radius < 0.95 -0.15 -2.45 >
        component Density Radius < 0.90 -0.37 -2.44 >
        component Density Radius < 0.77 -0.60 -2.49 >
        component Density Radius < 0.55 -0.92 -2.60 >
        component Density Radius < 0.19 -1.25 -2.81 >
        component Density Radius < 0.12 -1.36 -2.98 >
        component Density Radius < 0.28 -1.16 -3.18 >
        component Density Radius < 0.18 -1.12 -2.97 >
        component Density Radius < 0.58 -0.90 -3.07 >
        component Density Radius < 0.82 -0.01 -3.46 >
        component Density Radius < 1.02 -0.18 -3.05 >
        component Density Radius < 1.02 0.00 -3.05 >
        component Density Radius < 0.80 -0.33 -3.39 >
        component Density Radius < 0.99 -0.35 -3.06 >
        component Density Radius < 0.81 -0.67 -3.06 >
        component Density Radius < 0.73 -0.64 -3.35 >
        component Density Radius < 0.60 -0.88 -3.30 >
        component Density Radius < 0.32 -1.14 -3.63 >
        component Density Radius < 0.58 -0.77 -3.61 >
        component Density Radius < 0.68 -0.60 -3.60 >
        component Density Radius < 0.77 -0.32 -3.55 >
        component Density Radius < 0.95 -0.01 -3.88 >
        component Density Radius < 0.90 -0.38 -3.91 >
        component Density Radius < 0.78 -0.62 -3.90 >
        component Density Radius < 0.68 -0.78 -3.93 >
        component Density Radius < 0.35 -1.12 -3.99 >
        component Density Radius < -0.11 -1.51 -4.04 >
        component Density Radius < -0.17 -1.55 -3.65 >
        component Density Radius < -1.00 -2.36 -2.29 >
        component Density Radius < -1.59 -2.61 -2.30 >
        component Density Radius < -1.52 -2.58 -2.87 >
        component Density Radius < -0.95 -2.25 -2.94 >
        component Density Radius < -1.41 -2.40 -3.45 >
        component Density Radius < -0.92 -2.05 -3.64 >
        component Density Radius < -1.36 -2.31 -3.69 >
        component Density Radius < -0.89 -1.94 -4.08 >
        component Density Radius < -1.25 -2.15 -4.16 >
        component Density Radius < -0.88 -1.84 -4.45 >
        component Density Radius < -0.89 -1.60 -4.78 >
        component Density Radius < -1.12 -1.72 -4.81 >
        component Density Radius < -1.03 -1.23 -5.15 >
        component Density Radius < -0.12 -1.31 -4.74 >
        component Density Radius < -0.11 -0.95 -4.97 >
        component Density Radius < -1.15 -1.97 -4.53 >
        component Density Radius < -0.59 -1.84 -3.65 >
        component Density Radius < -0.08 -1.46 -4.38 >
        component Density Radius < 0.43 -1.14 -4.34 >
        component Density Radius < 1.05 -0.01 -4.35 >
        component Density Radius < 1.01 -0.34 -4.37 >
        component Density Radius < 0.84 -0.34 -4.70 >
        component Density Radius < 0.87 -0.01 -4.69 >
        component Density Radius < 0.42 -0.02 -5.00 >
        component Density Radius < 0.44 -0.35 -4.97 >
        component Density Radius < 0.45 -0.67 -4.88 >
        component Density Radius < 0.80 -0.61 -4.59 >
        component Density Radius < 0.89 -0.62 -4.36 >
        component Density Radius < 0.77 -0.79 -4.35 >
        component Density Radius < 0.45 -0.96 -4.67 >
        component Density Radius < -0.07 -0.02 -5.17 >
        component Density Radius < -0.09 -0.37 -5.13 >
        component Density Radius < -0.94 -0.02 -5.46 >
        component Density Radius < -0.85 -0.42 -5.38 >
        component Density Radius < -0.96 -0.78 -5.33 >
        component Density Radius < -0.10 -0.68 -5.07 >
        component Density Radius < -1.55 -2.34 -0.36 >
        component Density Radius < -1.24 -2.27 -0.08 >
        component Density Radius < -1.85 -2.42 -0.08 >
        component Density Radius < -1.51 -2.24 0.18 >
        component Density Radius < -0.83 -1.88 0.23 >
        component Density Radius < -1.01 -1.83 0.50 >
        component Density Radius < -1.89 -2.33 0.36 >
        component Density Radius < -1.71 -2.22 0.47 >
        component Density Radius < -1.91 -2.24 0.71 >
        component Density Radius < -1.39 -1.79 0.98 >
        component Density Radius < -1.22 -1.78 0.73 >
        component Density Radius < -0.58 -1.42 0.44 >
        component Density Radius < -0.70 -1.41 0.70 >
        component Density Radius < -0.85 -1.38 0.88 >
        component Density Radius < -1.04 -1.37 1.14 >
        component Density Radius < -1.22 -1.39 1.40 >
        component Density Radius < -1.54 -1.79 1.25 >
        component Density Radius < -1.89 -2.07 1.10 >
        component Density Radius < -1.86 -1.73 1.62 >
        component Density Radius < -1.49 -1.35 1.80 >
        component Density Radius < -0.99 -1.01 1.51 >
        component Density Radius < -1.85 -1.49 1.91 >
        component Density Radius < -1.88 -1.23 2.17 >
        component Density Radius < -2.04 -1.05 2.38 >
        component Density Radius < -2.03 -0.86 2.45 >
        component Density Radius < -1.68 -0.93 2.28 >
        component Density Radius < -2.38 -0.97 2.50 >
        component Density Radius < -2.37 -0.74 2.56 >
        component Density Radius < -2.35 -0.48 2.65 >
        component Density Radius < -1.96 -0.52 2.58 >
        component Density Radius < -2.33 -0.21 2.68 >
        component Density Radius < -1.92 -0.27 2.63 >
        component Density Radius < -2.34 0.02 2.68 >
        component Density Radius < -1.90 0.03 2.65 >
        component Density Radius < -1.50 0.03 2.49 >
        component Density Radius < -1.53 -0.32 2.47 >
        component Density Radius < -1.57 -0.60 2.43 >
        component Density Radius < -1.26 -1.00 1.91 >
        component Density Radius < -0.82 -0.97 1.22 >
        component Density Radius < -0.63 -1.00 0.99 >
        component Density Radius < -0.52 -0.98 0.84 >
        component Density Radius < -0.43 -1.02 0.57 >
        component Density Radius < -0.27 -0.60 0.39 >
        component Density Radius < -0.31 -0.60 0.67 >
        component Density Radius < -0.24 -0.32 0.42 >
        component Density Radius < -0.23 0.01 0.47 >
        component Density Radius < -0.29 -0.35 0.70 >
        component Density Radius < -0.27 0.02 0.70 >
        component Density Radius < -0.42 -0.61 0.90 >
        component Density Radius < -0.40 -0.36 0.89 >
        component Density Radius < -0.40 0.02 0.90 >
        component Density Radius < -0.53 -0.35 1.06 >
        component Density Radius < -0.52 0.02 1.07 >
        component Density Radius < -0.66 -0.37 1.28 >
        component Density Radius < -0.65 0.02 1.30 >
        component Density Radius < -0.80 -0.38 1.59 >
        component Density Radius < -0.79 0.02 1.61 >
        component Density Radius < -1.25 -0.35 2.26 >
        component Density Radius < -1.04 0.02 2.07 >
        component Density Radius < -1.03 -0.35 2.03 >
        component Density Radius < -1.10 -0.64 1.99 >
        component Density Radius < -0.84 -0.62 1.55 >
        component Density Radius < -0.71 -0.61 1.27 >
        component Density Radius < -0.54 -0.61 1.05 >
        component Density Radius < -1.09 -2.00 -0.48 >
        component Density Radius < -0.99 -1.91 -0.69 >
        component Density Radius < -0.79 -1.65 -0.41 >
        component Density Radius < -0.74 -1.53 -0.67 >
        component Density Radius < -0.69 -1.15 -0.35 >
        component Density Radius < -0.67 -1.11 -0.57 >
        component Density Radius < -0.70 -0.91 -0.53 >
        component Density Radius < -0.78 0.73 -0.65 >
        component Density Radius < -0.50 0.67 -0.66 >
        component Density Radius < -0.78 0.63 -0.51 >
        component Density Radius < -0.72 0.98 -0.77 >
        component Density Radius < -0.04 0.26 -0.02 >
        component Density Radius < 0.28 0.21 -0.23 >
        component Density Radius < -0.08 0.41 -0.13 >
        component Density Radius < 0.20 0.39 -0.39 >
        component Density Radius < -0.09 0.52 -0.55 >
        component Density Radius < 0.05 0.51 -0.67 >
        component Density Radius < -0.12 0.67 -0.92 >
        component Density Radius < -0.54 0.56 -0.36 >
        component Density Radius < -0.76 0.75 -0.31 >
        component Density Radius < -0.60 0.69 -0.13 >
        component Density Radius < -0.23 0.50 0.05 >
        component Density Radius < -0.18 0.30 0.13 >
        component Density Radius < -0.39 0.97 0.32 >
        component Density Radius < -0.74 1.22 -0.12 >
        component Density Radius < -0.58 1.41 0.21 >
        component Density Radius < -0.84 1.83 -0.02 >
        component Density Radius < -0.86 1.73 -0.19 >
        component Density Radius < -1.21 2.19 -0.27 >
        component Density Radius < -1.18 2.08 -0.38 >
        component Density Radius < -1.47 2.29 -0.47 >
        component Density Radius < -1.40 2.21 -0.56 >
        component Density Radius < -1.82 2.44 -0.73 >
        component Density Radius < -1.41 2.16 -0.81 >
        component Density Radius < -1.71 2.45 -1.05 >
        component Density Radius < -1.25 2.22 -1.10 >
        component Density Radius < -0.98 1.77 -0.90 >
        component Density Radius < -0.36 1.00 -1.15 >
        component Density Radius < -0.56 1.50 -1.19 >
        component Density Radius < -0.79 1.47 -0.86 >
        component Density Radius < -0.78 1.83 -1.16 >
        component Density Radius < -1.62 2.58 -1.89 >
        component Density Radius < -1.08 2.38 -1.81 >
        component Density Radius < -0.50 1.92 -1.73 >
        component Density Radius < -0.25 1.52 -1.72 >
        component Density Radius < 0.05 0.76 -1.69 >
        component Density Radius < 0.27 0.56 -1.19 >
        component Density Radius < 0.40 0.45 -0.92 >
        component Density Radius < 0.58 0.35 -0.71 >
        component Density Radius < 0.64 0.45 -1.07 >
        component Density Radius < 0.65 0.64 -1.38 >
        component Density Radius < 0.92 0.54 -1.29 >
        component Density Radius < 0.58 0.68 -1.62 >
        component Density Radius < 0.52 0.49 -1.91 >
        component Density Radius < 0.42 0.62 -2.05 >
        component Density Radius < 0.41 0.86 -2.27 >
        component Density Radius < -0.04 1.32 -2.43 >
        component Density Radius < -0.41 1.83 -2.29 >
        component Density Radius < -0.27 1.67 -3.05 >
        component Density Radius < 0.67 0.52 -2.21 >
        component Density Radius < 0.79 0.27 -1.93 >
        component Density Radius < 0.69 0.41 -1.79 >
        component Density Radius < 0.72 0.19 -0.57 >
        component Density Radius < 1.07 0.17 -0.81 >
        component Density Radius < 0.78 0.34 -0.84 >
        component Density Radius < 1.04 0.36 -0.99 >
        component Density Radius < 1.20 0.37 -1.18 >
        component Density Radius < 1.31 0.18 -1.01 >
        component Density Radius < 0.73 0.55 -1.64 >
        component Density Radius < 0.81 0.56 -1.55 >
        component Density Radius < 0.95 0.45 -1.49 >
        component Density Radius < 1.03 0.40 -1.52 >
        component Density Radius < 1.31 0.22 -1.33 >
        component Density Radius < 1.02 0.32 -1.59 >
        component Density Radius < 0.91 0.24 -1.73 >
        component Density Radius < 0.93 0.17 -1.81 >
        component Density Radius < 0.84 0.16 -1.96 >
        component Density Radius < 0.81 0.30 -1.83 >
        component Density Radius < 1.38 0.19 -1.14 >
        component Density Radius < 0.79 0.13 -2.19 >
        component Density Radius < 0.78 0.27 -2.17 >
        component Density Radius < 0.95 0.15 -2.45 >
        component Density Radius < 0.90 0.37 -2.45 >
        component Density Radius < 0.77 0.60 -2.50 >
        component Density Radius < 0.54 0.92 -2.61 >
        component Density Radius < 0.18 1.24 -2.83 >
        component Density Radius < 0.11 1.35 -3.00 >
        component Density Radius < 0.27 1.15 -3.20 >
        component Density Radius < 0.17 1.11 -2.99 >
        component Density Radius < 0.57 0.89 -3.08 >
        component Density Radius < 1.02 0.17 -3.05 >
        component Density Radius < 0.80 0.32 -3.39 >
        component Density Radius < 0.99 0.34 -3.06 >
        component Density Radius < 0.81 0.66 -3.07 >
        component Density Radius < 0.73 0.63 -3.36 >
        component Density Radius < 0.60 0.87 -3.31 >
        component Density Radius < 0.31 1.12 -3.65 >
        component Density Radius < 0.58 0.75 -3.62 >
        component Density Radius < 0.68 0.58 -3.61 >
        component Density Radius < 0.77 0.30 -3.55 >
        component Density Radius < 0.90 0.36 -3.92 >
        component Density Radius < 0.78 0.60 -3.91 >
        component Density Radius < 0.68 0.76 -3.94 >
        component Density Radius < 0.34 1.09 -4.01 >
        component Density Radius < -0.12 1.48 -4.06 >
        component Density Radius < -0.18 1.53 -3.67 >
        component Density Radius < -1.01 2.35 -2.32 >
        component Density Radius < -1.60 2.60 -2.34 >
        component Density Radius < -1.53 2.56 -2.91 >
        component Density Radius < -0.96 2.23 -2.97 >
        component Density Radius < -1.42 2.37 -3.48 >
        component Density Radius < -1.37 2.28 -3.72 >
        component Density Radius < -0.93 2.02 -3.67 >
        component Density Radius < -1.26 2.11 -4.19 >
        component Density Radius < -0.90 1.91 -4.11 >
        component Density Radius < -1.13 1.67 -4.83 >
        component Density Radius < -0.90 1.56 -4.80 >
        component Density Radius < -0.89 1.80 -4.48 >
        component Density Radius < -1.04 1.18 -5.17 >
        component Density Radius < -0.13 1.27 -4.76 >
        component Density Radius < -0.12 0.91 -4.98 >
        component Density Radius < -1.16 1.93 -4.56 >
        component Density Radius < -0.60 1.81 -3.68 >
        component Density Radius < -0.09 1.43 -4.40 >
        component Density Radius < 0.42 1.11 -4.36 >
        component Density Radius < 1.01 0.31 -4.37 >
        component Density Radius < 0.84 0.31 -4.70 >
        component Density Radius < 0.44 0.31 -4.97 >
        component Density Radius < 0.45 0.63 -4.89 >
        component Density Radius < 0.80 0.58 -4.60 >
        component Density Radius < 0.89 0.59 -4.37 >
        component Density Radius < 0.77 0.76 -4.36 >
        component Density Radius < 0.44 0.93 -4.68 >
        component Density Radius < -0.09 0.33 -5.13 >
        component Density Radius < -0.85 0.37 -5.39 >
        component Density Radius < -0.10 0.64 -5.08 >
        component Density Radius < -0.96 0.73 -5.34 >
        component Density Radius < -1.25 2.29 -0.11 >
        component Density Radius < -1.56 2.36 -0.39 >
        component Density Radius < -1.86 2.44 -0.11 >
        component Density Radius < -1.52 2.26 0.15 >
        component Density Radius < -1.02 1.86 0.47 >
        component Density Radius < -0.84 1.91 0.20 >
        component Density Radius < -1.72 2.25 0.44 >
        component Density Radius < -1.90 2.35 0.33 >
        component Density Radius < -1.92 2.27 0.68 >
        component Density Radius < -1.23 1.81 0.70 >
        component Density Radius < -1.40 1.83 0.95 >
        component Density Radius < -0.59 1.45 0.42 >
        component Density Radius < -0.71 1.45 0.68 >
        component Density Radius < -0.86 1.42 0.86 >
        component Density Radius < -1.05 1.41 1.12 >
        component Density Radius < -1.55 1.83 1.22 >
        component Density Radius < -1.23 1.43 1.38 >
        component Density Radius < -1.90 2.10 1.07 >
        component Density Radius < -1.87 1.77 1.60 >
        component Density Radius < -1.50 1.40 1.78 >
        component Density Radius < -1.00 1.06 1.50 >
        component Density Radius < -1.86 1.54 1.89 >
        component Density Radius < -1.89 1.28 2.15 >
        component Density Radius < -1.69 0.98 2.27 >
        component Density Radius < -2.04 0.91 2.44 >
        component Density Radius < -2.05 1.10 2.36 >
        component Density Radius < -2.37 0.79 2.55 >
        component Density Radius < -2.39 1.02 2.49 >
        component Density Radius < -1.96 0.58 2.57 >
        component Density Radius < -2.35 0.53 2.64 >
        component Density Radius < -1.92 0.33 2.63 >
        component Density Radius < -2.33 0.26 2.68 >
        component Density Radius < -1.53 0.38 2.47 >
        component Density Radius < -1.57 0.66 2.42 >
        component Density Radius < -1.27 1.05 1.90 >
        component Density Radius < -0.83 1.01 1.21 >
        component Density Radius < -0.64 1.04 0.98 >
        component Density Radius < -0.53 1.02 0.83 >
        component Density Radius < -0.44 1.05 0.56 >
        component Density Radius < -0.27 0.63 0.38 >
        component Density Radius < -0.31 0.64 0.66 >
        component Density Radius < -0.24 0.35 0.42 >
        component Density Radius < -0.29 0.39 0.69 >
        component Density Radius < -0.42 0.65 0.89 >
        component Density Radius < -0.40 0.40 0.88 >
        component Density Radius < -0.53 0.39 1.05 >
        component Density Radius < -0.66 0.41 1.27 >
        component Density Radius < -0.80 0.43 1.58 >
        component Density Radius < -1.25 0.40 2.25 >
        component Density Radius < -1.03 0.40 2.02 >
        component Density Radius < -1.10 0.69 1.98 >
        component Density Radius < -0.84 0.67 1.54 >
        component Density Radius < -0.71 0.65 1.26 >
        component Density Radius < -0.54 0.65 1.04 >
        component Density Radius < -1.00 1.92 -0.72 >
        component Density Radius < -1.10 2.02 -0.51 >
        component Density Radius < -0.80 1.67 -0.43 >
        component Density Radius < -0.75 1.55 -0.69 >
        component Density Radius < -0.70 1.17 -0.37 >
        component Density Radius < -0.68 1.13 -0.59 >
        component Density Radius < -0.71 0.93 -0.54 >
        component Density Radius < 0.73 -0.29 -1.67 >
        component Density Radius < 0.73 0.30 -1.67 >
        component Density Radius < 0.45 -0.83 -2.84 >
        component Density Radius < 0.65 -0.55 -2.76 >
        component Density Radius < 0.76 -0.32 -2.72 >
        component Density Radius < 0.81 -0.14 -2.75 >
        component Density Radius < 0.79 0.00 -2.74 >
        component Density Radius < 0.81 0.13 -2.75 >
        component Density Radius < 0.76 0.31 -2.72 >
        component Density Radius < 0.65 0.54 -2.77 >
        component Density Radius < 0.45 0.82 -2.85 >
        component Density Radius < 0.53 -0.85 -2.95 >
        component Density Radius < 0.75 -0.64 -2.89 >
        component Density Radius < 0.92 -0.36 -2.88 >
        component Density Radius < 0.93 -0.15 -2.86 >
        component Density Radius < 0.94 0.00 -2.85 >
        component Density Radius < 0.93 0.14 -2.86 >
        component Density Radius < 0.92 0.35 -2.89 >
        component Density Radius < 0.75 0.63 -2.90 >
        component Density Radius < 0.53 0.84 -2.96 >
    sturm          // Highly recommended
    }
    rotate <0 90 90>       // Turn the face upright and facing screen
//    rotate <0 45 0>        // Now adjust it the way I really want it.
}
// 431 Blob elements.
// Created from file: FACE.HSM

// A pair of simple eyes.  Not placed quite correctly yet.
/******
object {
    sphere {<1.25 -0.5 -0.15> 0.5 }
    texture {
        color White
    }
}
object {
    sphere {<-1.25 -0.5 -0.15> 0.5 }
    texture {
        color White
    }
}
********/
