// "HAVESEAT.POV" POV-Ray 2.0 Scene File
//
//	by Sami.Rosenblad@Helsinki.FI
//
//
// This is a picture of a room with a glass table
// and two chairs. "Have a seat!"
// I was about to place an ashtray on the table, but
// I don't smoke. B-)
//
// Note: all distances are measured in millimetres


#include "colors.inc"
#include "textures.inc"
#include "chair.inc"
#include "table.inc"
#include "poster.inc"
#include "room.inc"

// declare textures

#declare Sky = texture {
	pigment { bozo turbulence 4 scale 5e5 color_map {
		[ 0.6	color rgb <0.5, 0.5, 1.0> ]
		[ 0.7	color rgb <1.0, 1.0, 1.0> ]
		[ 1.01	color rgb <0.8, 0.8, 0.8> ] }
	}
	finish { ambient 1 diffuse 0 }
}
#declare Grass = texture {
	pigment { rgb <0.1, 0.6, 0.12> }
	finish { ambient 0.96 diffuse 0.2 crand 0.05 }
}

// use grass color as background to fill the gap in the horizon

background { color rgb <0.1, 0.6, 0.12> }

camera {
	location <1000, 900, -4000>
	direction 1.6*z
	right 4/3*x
	look_at <200, 700, 0>
}

// daylight thru the window and another light in the room

light_source { <-10000, 8000, 1000> color rgb <2, 2, 2> }
light_source { <1300, 1700, -2000> color rgb <1, 1, 0.8> }

// construct the scene

plane { y, 1e5 texture { Sky } }
plane { y, -rh/2-t texture { Grass } }
object { Room }
object { Chair	rotate -142*y translate <-260, h+r, -600> }
object { Chair	rotate   34*y translate < 900, h+r,  440> }
object { Table	rotate 20*y translate <500, q, -300> }
object { Poster translate <-900, 200, 3000> }
