/*
  Lissajous figure PoV 1.0 datafile LISS99.pov
  Generated on Fri Jun 26 18:53:24 1992
  with LISSAJOU V 1.4
  by Dan Farmer and Aaron C. Caba
*/

#include "shapes.inc"
#include "colors.inc"
#include "textures.inc"

#declare Liss_Rotation = 90

#declare Sph1_Radius = 10
#declare Lis1_Texture = texture {
    Metal
}                        // end texture block 
#declare Color0 = color Orange
#declare Color1 = color Orange
#declare Color2 = color Orange


#declare Sph2_Radius = 6
#declare Liss2_Texture = texture {
    Metal
    color CoolCopper
}

camera {
  location  <0.0  0.0 -440.0>
  direction <0.0  0.0    2.0>
  up        <0.0  1.0    0.0>
  right <1.33333  0.0    0.0>
  look_at   <0.0  0.0    0.0>
}                             // end viewpoint block

// basic light source 
object {
  light_source { <150.0  100.0  -500.0 > color White }
  texture { ambient 1 diffuse 0 color White }
}                             // end lightsource block 

// Put all colors into declarations for ease of changing 


// The Inner Lissajous object:
composite {

  object {
      sphere { <0.360845 0.608321 -99.997498> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-0.430529 0.722138 -99.996468> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-0.500720 0.835647 -99.995255> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-2.386673 0.095079 -99.971466> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <2.519746 0.105984 -99.968193> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <2.652777 0.117481 -99.964737> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <1.791014 -3.653815 -99.917175> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-1.841317 -3.777637 -99.911659> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-1.891075 -3.901693 -99.905960> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <3.337637 4.680460 -99.834633> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-3.425611 4.781334 -99.826874> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-7.369513 0.917708 -99.723862> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <7.499473 0.950806 -99.713860> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <3.305770 -8.480632 -99.584892> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-3.334919 -8.611870 -99.572655> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <6.866881 8.130889 -99.432060> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <6.970752 8.216799 -99.417770> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-7.075025 8.302272 -99.403297> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-12.053297 2.515474 -99.239059> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-12.177250 2.569571 -99.222534> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <12.301001 2.624227 -99.205841> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <3.995315 -13.396792 -99.017998> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <4.003037 -13.532329 -98.999252> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-4.010171 -13.667941 -98.980331> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <11.061040 11.061207 -98.768936> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-11.178969 11.129604 -98.747978> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-11.297237 11.197512 -98.726837> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-16.579769 4.944299 -98.491959> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <16.694605 5.018937 -98.468781> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <16.809162 5.094100 -98.445427> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <3.872662 -18.555080 -98.187126> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-3.857935 -18.691942 -98.161743> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-3.842612 -18.828794 -98.136185> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <15.740471 13.293903 -97.854530> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-15.869887 13.342945 -97.826950> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-20.708723 8.124963 -97.494278> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <20.811625 8.218705 -97.464500> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <2.898870 -23.705137 -97.106453> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-2.861669 -23.840157 -97.074493> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <20.665590 14.737107 -96.725128> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <20.803501 14.765883 -96.691170> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-20.941605 14.794092 -96.657043> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-24.248556 11.885618 -96.284683> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-24.337334 11.996228 -96.248558> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <24.425697 12.107269 -96.212265> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <1.139672 -28.597250 -95.817001> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <1.080979 -28.727459 -95.778725> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-1.021712 -28.857498 -95.740280> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <25.997072 15.421506 -95.322243> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-26.140776 15.428387 -95.281815> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-26.284592 15.434677 -95.241226> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-27.299992 16.357609 -94.800522> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <27.371954 16.483435 -94.757965> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <27.443445 16.609631 -94.715248> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-1.477864 -33.382267 -94.252007> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <1.557823 -33.504517 -94.207329> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <1.638329 -33.626514 -94.162483> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <31.490849 15.263590 -93.676834> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-31.637247 15.247891 -93.630051> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-29.676729 21.361240 -93.075180> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <29.729845 21.499847 -93.026299> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-4.878612 -37.811539 -92.447212> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <4.978610 -37.922897 -92.396248> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <36.882362 14.283215 -91.845963> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <37.028347 14.245281 -91.793098> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-37.174274 14.206746 -91.740074> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-31.274975 26.651073 -91.167953> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-31.308119 26.799543 -91.113045> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <31.340702 26.948242 -91.057961> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-8.891024 -41.679531 -90.464172> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-9.008986 -41.777660 -90.407219> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <9.127413 -41.875397 -90.350105> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <42.347084 12.425320 -89.734810> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-42.489510 12.364711 -89.675835> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-42.631802 12.303509 -89.616699> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-32.125881 32.411018 -88.980072> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <32.137211 32.566761 -88.919098> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <32.147953 32.722652 -88.857964> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-13.666819 -45.099285 -88.200188> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <13.801296 -45.181355 -88.137222> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <13.936180 -45.262970 -88.074097> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <47.619255 9.718966 -87.395355> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-47.755001 9.636269 -87.330421> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-32.133221 38.390305 -86.565819> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <32.121822 38.550274 -86.498932> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-19.026249 -47.869495 -85.711800> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <19.174957 -47.933289 -85.642982> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <52.455986 6.297392 -84.904137> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <52.582321 6.194153 -84.833557> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-52.708359 6.090374 -84.762825> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-31.303961 44.310543 -84.003799> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-31.269949 44.471603 -83.931320> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <31.235321 44.632648 -83.858696> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-24.717468 -49.867916 -83.079704> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-24.877569 -49.912090 -83.005356> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <25.037943 -49.955715 -82.930862> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <57.010838 2.019352 -82.132126> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-57.124676 1.896396 -82.055923> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-57.238144 1.772941 -81.979584> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-29.582392 50.375797 -81.161324> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <29.525076 50.534832 -81.083298> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <29.467148 50.693768 -81.005119> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-30.950161 -51.139484 -80.167580> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <31.119202 -51.161995 -80.087738> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <31.288439 -51.183914 -80.007751> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <61.043045 -2.973176 -79.151161> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-61.141727 -3.114078 -79.069534> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-26.984165 56.305527 -78.112373> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <26.903896 56.459354 -78.028984> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-37.466568 -51.568630 -77.051491> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <37.641567 -51.568321 -76.966362> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <64.375046 -8.450325 -76.055542> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <64.456665 -8.606668 -75.968826> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-64.537796 -8.763398 -75.881981> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-23.632254 61.834866 -74.953094> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-23.530378 61.980640 -74.864685> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <23.427929 62.126160 -74.776146> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-43.973408 -51.142464 -73.829453> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-44.151215 -51.119217 -73.739380> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <44.329060 -51.095341 -73.649170> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <67.104378 -14.625413 -72.684937> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-67.166405 -14.795227 -72.593224> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-67.227890 -14.965363 -72.501373> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-19.380898 67.151237 -71.519867> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <19.257994 67.285805 -71.426537> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <19.134552 67.420036 -71.333076> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-50.707096 -49.818039 -70.334579> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <50.884640 -49.770912 -70.239662> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <51.062134 -49.723156 -70.144608> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <69.058472 -21.261524 -69.129410> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-69.099136 -21.442129 -69.032921> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-14.361581 71.990959 -67.904694> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <14.219215 72.111511 -67.806664> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-57.371464 -47.590508 -66.660774> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <57.545532 -47.519604 -66.561241> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <70.158852 -28.064718 -65.498901> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <70.177391 -28.253048 -65.398010> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-70.195305 -28.441547 -65.296997> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-8.799916 76.147675 -64.219101> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-8.640458 76.252113 -64.116753> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <8.480565 76.356079 -64.014290> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-63.677879 -44.565197 -62.921146> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-63.845520 -44.471649 -62.817368> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <64.012939 -44.377499 -62.713482> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <70.421005 -35.293873 -61.605396> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-70.415817 -35.487118 -61.500225> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-70.409988 -35.680447 -61.394943> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-2.471656 79.756813 -60.272232> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <2.296869 79.842430 -60.165691> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <2.121711 79.927528 -60.059048> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-69.852768 -40.605251 -58.922024> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <70.010757 -40.489380 -58.814148> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <70.168457 -40.372932 -58.706169> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <69.773399 -42.650642 -57.555157> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-69.743904 -42.845627 -57.445976> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <4.390505 82.616150 -56.172016> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-4.578074 82.680969 -56.061562> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-75.607880 -35.824123 -54.772995> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <75.753288 -35.687275 -54.661297> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <68.255112 -49.820274 -53.471302> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <68.201805 -50.013859 -53.358486> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-68.147850 -50.207359 -53.245579> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <11.488211 84.614174 -52.042892> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <11.685545 84.657181 -51.928894> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-11.883106 84.699577 -51.814804> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-80.705276 -30.435549 -50.599766> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-80.835815 -30.279936 -50.484619> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <80.965919 -30.123838 -50.369377> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <65.785805 -57.072403 -49.142334> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-65.708298 -57.261364 -49.026066> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-65.630165 -57.450165 -48.909714> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <19.099627 85.806053 -47.671009> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-19.304045 85.825424 -47.553658> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-19.508610 85.844154 -47.436218> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-85.324936 -24.217552 -46.186203> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <85.437752 -24.044714 -46.067799> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <85.550072 -23.871450 -45.949314> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <62.412281 -64.091026 -44.688339> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-62.311275 -64.272209 -44.568916> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <26.921759 86.086540 -43.177841> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-27.130135 86.081436 -43.057434> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-89.232330 -17.390814 -41.655136> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <89.325233 -17.203138 -41.533779> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <58.291336 -70.587769 -40.242851> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <58.168510 -70.758446 -40.120651> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-58.045113 -70.928802 -39.998379> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <34.625309 85.460869 -38.697910> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <34.834446 85.431519 -38.574825> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-35.043564 85.401512 -38.451672> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-92.278915 -10.250459 -37.142025> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-92.350639 -10.050892 -37.018089> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <92.421768 -9.851040 -36.894089> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <53.247654 -76.805344 -35.575642> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-53.103901 -76.962395 -35.450890> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-52.959618 -77.119049 -35.326077> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <42.508522 83.887306 -33.999195> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-42.715240 83.833069 -33.873669> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-42.921848 83.778168 -33.748077> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-94.567856 -2.511771 -32.413139> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <94.616356 -2.302838 -32.286865> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <94.664230 -2.093698 -32.160538> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <47.445236 -82.457291 -30.817919> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-47.282421 -82.598053 -30.690937> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <50.240513 81.378342 -29.213984> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-50.441589 81.299637 -29.086330> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-95.956299 5.525424 -27.601789> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <95.980476 5.740664 -27.473501> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <41.140423 -87.325256 -26.110634> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <40.961170 -87.447868 -25.981791> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-40.781502 -87.569954 -25.852903> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <57.508175 78.059914 -24.483854> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <57.700745 77.958229 -24.354446> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-57.893040 77.855927 -24.224995> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-96.410347 13.524612 -22.850155> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-96.410187 13.742938 -22.720217> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <96.409355 13.961306 -22.590239> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <34.078316 -91.590416 -21.209993> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-33.884647 -91.692329 -21.079563> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-33.690632 -91.793663 -20.949095> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <64.591995 73.791130 -19.563835> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-64.772865 73.667068 -19.432949> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-64.953384 73.542435 -19.302027> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-95.936874 21.800720 -17.912146> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <95.911446 22.019012 -17.780840> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <95.885345 22.237259 -17.649502> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <26.520739 -95.039009 -16.255392> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-26.315411 -95.118477 -16.123705> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <71.180443 68.704865 -14.594043> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-71.346794 68.560081 -14.462010> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-94.508858 30.015474 -12.928567> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <94.458321 30.230478 -12.796227> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <18.789818 -97.555954 -11.392025> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <18.575983 -97.612282 -11.259436> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-18.361961 -97.667969 -11.126826> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <77.021675 63.033199 -9.719946> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <77.171432 62.870163 -9.587121> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-77.320702 62.706661 -9.454279> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-92.214874 37.837727 -8.045118> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-92.140472 38.046448 -7.912096> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <92.065437 38.254959 -7.779058> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <10.578735 -99.234764 -6.368016> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-10.359242 -99.266373 -6.234833> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-10.139643 -99.297318 -6.101639> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <82.342461 56.548492 -4.689114> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-82.472908 56.368999 -4.555808> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-82.602821 56.189110 -4.422494> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-88.959953 45.574924 -3.008885> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <88.862030 45.774136 -2.875494> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <88.763504 45.973057 -2.742099> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <2.212481 -99.966705 -1.327806> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-1.990543 -99.973053 -1.194368> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <86.895287 49.488224 0.353649> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-87.004471 49.294884 0.487096> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-84.839455 52.897312 2.035003> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <84.719414 53.084068 2.168422> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-5.965070 -99.757629 3.582423> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-6.186255 -99.739273 3.715782> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <6.407375 -99.720261 3.849135> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <90.525558 42.159595 5.262252> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <90.612495 41.955502 5.395511> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-90.698807 41.751156 5.528760> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-80.053535 59.525288 6.940594> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-79.913673 59.697296 7.073714> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <79.773308 59.868870 7.206822> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-14.276989 -98.599777 8.616973> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <14.494198 -98.556366 8.749917> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <14.711258 -98.512306 8.882846> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <93.377800 34.273651 10.290916> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-93.440689 34.061497 10.423647> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-93.502922 33.849174 10.556358> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-74.414742 65.721817 11.961949> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <74.256630 65.876236 12.094429> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <74.098053 66.030151 12.226887> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-22.379639 -96.505882 13.629601> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <22.589697 -96.438164 13.761791> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <95.303650 26.140514 15.293398> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-95.341675 25.923460 15.425262> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-68.128685 71.211533 16.952871> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <67.954735 71.346184 17.084373> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-29.954855 -93.601967 18.476418> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-30.155020 -93.511681 18.607552> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <30.354877 -93.420792 18.738653> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <96.266922 18.100061 20.126272> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <96.280388 17.881346 20.256971> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-96.293175 17.662630 20.387634> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-61.479141 75.804771 21.770435> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-61.292370 75.918419 21.900663> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <61.105286 76.031479 22.030853> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-37.303787 -89.780136 23.408443> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <37.490959 -89.668182 23.538164> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <37.677750 -89.555687 23.667841> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <96.313301 9.836399 25.039833> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-96.301567 9.619192 25.169008> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-96.289177 9.402069 25.298138> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-54.209064 79.689400 26.664145> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <54.011993 79.780037 26.792736> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <53.814693 79.870041 26.921282> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-44.111565 -85.172531 28.280914> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <44.283100 -85.040825 28.408890> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <95.413589 1.689269 29.889690> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-95.377136 1.476790 30.017012> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-46.605324 82.682060 31.490015> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <46.401028 82.748611 31.616646> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-50.129189 -80.006256 32.955471> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-50.283230 -79.857468 33.081436> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <50.436771 -79.708244 33.207340> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <93.653145 -6.016125 34.538300> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <93.593483 -6.220994 34.663506> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-93.533211 -6.425617 34.788647> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-38.994781 84.707596 36.111359> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-38.786514 84.750076 36.235771> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <38.578178 84.791901 36.360119> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-55.601089 -74.088951 37.674210> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <55.735142 -73.925102 37.797794> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <55.868641 -73.760895 37.921307> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <90.976639 -13.584524 39.226410> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-90.894417 -13.778637 39.349129> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-90.811623 -13.972426 39.471775> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-31.083559 85.859314 40.767521> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <30.874407 85.876846 40.889339> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <30.665277 85.893723 41.011086> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-60.284073 -67.651947 42.297100> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <60.396442 -67.475807 42.417988> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <87.475876 -20.693972 43.814724> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-87.372765 -20.874546 43.934643> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-23.198578 86.069313 45.319962> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <22.991783 86.062111 45.438877> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-64.030960 -60.989079 46.694416> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-64.120949 -60.803822 46.812382> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <64.210312 -60.618362 46.930264> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <83.342331 -27.078730 48.174671> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <83.220825 -27.243690 48.291569> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-83.098854 -27.408195 48.408382> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-15.662923 85.383919 49.641300> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-15.461477 85.353226 49.757103> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <15.260218 85.321907 49.872814> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-67.003418 -53.851238 51.093895> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <67.069519 -53.659687 51.208565> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <67.134987 -53.468014 51.323143> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <78.432228 -32.996513 52.532047> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-78.294144 -33.143223 52.645550> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-78.155655 -33.289425 52.758965> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-8.183507 83.796486 53.955345> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <7.990579 83.742699 54.067654> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <7.797917 83.688316 54.179867> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-69.061623 -46.533730 55.363384> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <69.103348 -46.339081 55.474468> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <72.941742 -38.187489 56.755775> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-72.789680 -38.314041 56.865597> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-1.080295 81.360245 58.132118> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <0.898782 81.284805 58.240650> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-70.176956 -39.352905 59.384708> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-70.194893 -39.158344 59.492023> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <70.212189 -38.963829 59.599236> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <67.136925 -42.480637 60.729141> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <66.973991 -42.586079 60.835110> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-66.810799 -42.690929 60.940968> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <5.373208 78.231270 62.056404> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <5.541036 78.136467 62.160995> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-5.708459 78.041168 62.265472> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-70.415047 -32.038353 63.366123> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <70.408897 -31.847048 63.469303> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <70.402130 -31.655870 63.572372> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <60.810909 -46.058506 64.657928> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-60.639771 -46.141125 64.759666> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-60.468456 -46.223129 64.861298> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <11.432688 74.312431 65.931450> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-11.584080 74.199867 66.031723> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-11.735008 74.086868 66.131882> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-69.754951 -24.904694 67.186325> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <69.725510 -24.719767 67.285110> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <54.231747 -48.757751 68.422211> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-54.055538 -48.816807 68.519470> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <16.830568 69.765152 69.638748> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-16.963423 69.637253 69.734459> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-68.284927 -18.243652 70.741341> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-68.233948 -18.067808 70.835602> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <68.182404 -17.892248 70.929733> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <47.697464 -50.522263 71.919769> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <47.519394 -50.558067 72.012421> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-47.341316 -50.593239 72.104950> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <21.380476 64.826706 73.077858> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <21.493595 64.686470 73.168884> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-21.606157 64.545937 73.259781> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-65.975945 -11.801128 74.215286> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <65.904396 -11.637375 74.304657> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <65.832329 -11.473976 74.393898> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <40.972076 -51.443363 75.331726> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-40.795258 -51.455391 75.419426> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-40.618519 -51.466797 75.506989> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <25.270790 59.332287 76.426872> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-25.362272 59.182232 76.512863> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-25.453167 59.031960 76.598724> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-62.922970 -5.863998 77.500412> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <62.832779 -5.714897 77.584671> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <34.352402 -51.473202 78.552032> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-34.179996 -51.461983 78.634544> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <28.323057 53.521935 79.581451> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-28.391920 53.365108 79.662186> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-59.311249 -0.656710 80.509285> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-59.205074 -0.524063 80.588364> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <59.098499 -0.391890 80.667305> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <28.121449 -50.672592 81.495232> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <27.956280 -50.639656 81.572495> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-27.791348 -50.606144 81.649612> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <30.461468 47.673420 82.458138> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <30.507765 47.513027 82.533562> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-30.553444 47.352581 82.608841> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-55.032909 4.024645 83.397728> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <54.912811 4.138462 83.471291> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <54.792381 4.251758 83.544708> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <22.051439 -49.040054 84.313744> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-21.896563 -48.986134 84.385422> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-21.741995 -48.931679 84.456947> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <31.788500 41.586575 85.205917> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-31.811480 41.425667 85.275696> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-31.833843 41.264793 85.345322> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-50.277802 7.962988 86.073997> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <50.146542 8.056378 86.141853> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <16.420959 -46.643940 86.917747> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-16.279062 -46.570751 86.983658> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <32.237114 35.538731 87.736923> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-32.237057 35.380486 87.800873> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-45.293381 11.032606 88.469154> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-45.154087 11.104943 88.531288> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <45.014614 11.176696 88.593262> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <11.454072 -43.645618 89.240486> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <11.327149 -43.555649 89.300621> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-11.200664 -43.465252 89.360603> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <31.847746 29.801607 89.986588> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <31.825945 29.648937 90.044708> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-31.803566 29.496460 90.102676> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-39.920475 13.362342 90.707237> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <39.775970 13.412259 90.763336> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <39.631371 13.461576 90.819275> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <6.965946 -39.963787 91.402252> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-6.856509 -39.858910 91.456306> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-6.747560 -39.753674 91.510193> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <30.632524 24.176487 92.071419> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-30.589487 24.032484 92.123413> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-34.408188 14.835372 92.714554> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <34.261627 14.862484 92.764473> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <3.173499 -35.765411 93.331474> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-3.083343 -35.648254 93.379311> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <28.640194 18.931341 93.922005> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-28.577419 18.798803 93.967743> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-29.021982 15.440047 94.442200> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-28.876469 15.444995 94.485985> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <28.731024 15.449345 94.529602> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <0.207895 -31.280249 94.981590> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <0.137879 -31.153856 95.023254> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-0.068425 -31.027252 95.064743> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <26.014538 14.286900 95.494125> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <25.934340 14.167994 95.533646> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-25.853693 14.049490 95.572998> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-23.586281 15.218141 95.979660> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <23.444941 15.200781 96.017036> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <23.303751 15.182840 96.054237> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-2.046051 -26.372601 96.438065> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <2.094362 -26.239683 96.473274> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <2.142089 -26.106634 96.508316> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <22.687603 10.081276 96.869194> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-22.591661 9.978637 96.902237> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-18.364836 14.167164 97.272934> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <18.230713 14.128378 97.303802> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-3.466112 -21.274963 97.649178> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <3.492099 -21.138628 97.677856> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <18.809765 6.528543 97.997810> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-18.700556 6.444149 98.024292> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-13.594571 12.386368 98.294281> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-13.470258 12.327952 98.318733> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <13.346249 12.269025 98.343018> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-4.032647 -16.242701 98.589615> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-4.036713 -16.106073 98.611862> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <4.040185 -15.969480 98.633934> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <14.598764 3.762224 98.857079> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <14.479247 3.697159 98.877106> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-14.359488 3.632636 98.896965> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-9.120082 9.833124 99.096588> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <9.008505 9.756183 99.114395> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <8.897300 9.678778 99.132027> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-3.776741 -11.119412 99.308083> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <3.758518 -10.985600 99.323662> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <3.739713 -10.851904 99.339073> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <9.929811 1.685583 99.491493> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-9.802575 1.641600 99.504845> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-5.173343 6.614810 99.646782> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <5.076950 6.521347 99.657898> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-2.688264 -6.159856 99.773888> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <2.648405 -6.031953 99.782768> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <5.024534 0.423428 99.872795> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <-4.892625 0.401373 99.879433> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-1.921200 2.920459 99.938881> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-1.841660 2.813133 99.943459> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <1.762603 2.705464 99.947853> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <-0.859478 -1.598422 99.983528> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <-0.799575 -1.479134 99.985863> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object
  object {
      sphere { <0.739145 -1.360117 99.988014> Sph1_Radius }
      color Color2
      texture { Lis1_Texture color Color2 }
  } // end object
  object {
      sphere { <0.133448 0.000296 99.999908> Sph1_Radius }
      color Color0
      texture { Lis1_Texture color Color0 }
  } // end object
  object {
      sphere { <0.000000 0.000000 100.000000> Sph1_Radius }
      color Color1
      texture { Lis1_Texture color Color1 }
  } // end object

rotate <0 Liss_Rotation 0>
} // end composite 
/*
  Parameters used for this generation:
    R1 = 100   A = .15   B = 0.25
    X-Exponent = 1
    Y-Exponent = 1
    Z-Exponent = 1
    Sphere Radius = 8
    Number of Spheres generated:  500
    Axis = Z
    Algorithm = #1

    Minimum X = -96.410347      Maximum X = 96.409355
    Minimum Y = -99.973053      Maximum Y = 86.086540
    Minimum Z = -99.997498      Maximum Z = 100.000000

    Min/Max XYZs with RADIUS figured in:
    Leftmost Point = -104.410347     Rightmost Point = 104.409355
      Lowest Point = -107.973053       Highest Point = 94.086540
     Nearest Point = -107.997498      Farthest Point = 108.000000
*/ 


// The Outer Lissajous object:
composite {

  object {
      sphere { <0.389712 0.656987 -107.997299> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-0.464972 0.779909 -107.996185> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-0.540778 0.902499 -107.994873> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-2.577607 0.102685 -107.969185> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.721326 0.114463 -107.965645> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.865000 0.126879 -107.961914> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <1.934295 -3.946120 -107.910553> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-1.988622 -4.079848 -107.904587> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-2.042361 -4.213829 -107.898438> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <3.604648 5.054897 -107.821404> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-3.699660 5.163841 -107.813019> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-7.959074 0.991124 -107.701767> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <8.099431 1.026870 -107.690971> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <3.570231 -9.159082 -107.551682> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-3.601712 -9.300819 -107.538467> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <7.416232 8.781361 -107.386627> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <7.528412 8.874143 -107.371193> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-7.641027 8.966454 -107.355568> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-13.017561 2.716712 -107.178185> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-13.151430 2.775137 -107.160339> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <13.285081 2.834166 -107.142311> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <4.314940 -14.468536 -106.939438> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <4.323281 -14.614915 -106.919189> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-4.330985 -14.761376 -106.898758> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <11.945924 11.946103 -106.670456> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-12.073287 12.019972 -106.647812> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-12.201016 12.093312 -106.624985> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-17.906151 5.339843 -106.371315> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <18.030174 5.420452 -106.346283> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <18.153894 5.501627 -106.321060> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <4.182475 -20.039488 -106.042091> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-4.166570 -20.187298 -106.014679> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-4.150021 -20.335098 -105.987083> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <16.999708 14.357415 -105.682899> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-17.139479 14.410380 -105.653107> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-22.365421 8.774960 -105.293816> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <22.476555 8.876202 -105.261665> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <3.130779 -25.601547 -104.874969> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-3.090603 -25.747370 -104.840454> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <22.318836 15.916077 -104.463142> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <22.467781 15.947154 -104.426468> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-22.616934 15.977619 -104.389610> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-26.188440 12.836468 -103.987457> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-26.284321 12.955927 -103.948441> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <26.379753 13.075850 -103.909241> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <1.230845 -30.885029 -103.482368> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <1.167457 -31.025656 -103.441025> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-1.103449 -31.166098 -103.399498> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <28.076839 16.655226 -102.948021> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-28.232038 16.662657 -102.904366> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-28.387358 16.669453 -102.860527> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-29.483990 17.666218 -102.384567> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <29.561710 17.802109 -102.338608> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <29.638920 17.938400 -102.292465> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-1.596094 -36.052849 -101.792160> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <1.682449 -36.184879 -101.743912> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <1.769395 -36.316635 -101.695480> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.010117 16.484676 -101.170982> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-34.168228 16.467724 -101.120453> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-32.050865 23.070141 -100.521194> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <32.108234 23.219835 -100.468407> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-5.268901 -40.836460 -99.842987> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <5.376899 -40.956730 -99.787949> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <39.832951 15.425871 -99.193642> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <39.990612 15.384904 -99.136551> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-40.148216 15.343286 -99.079285> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-33.776974 28.783161 -98.461395> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-33.812767 28.943506 -98.402084> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <33.847958 29.104101 -98.342598> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-9.602305 -45.013893 -97.701302> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-9.729705 -45.119873 -97.639793> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <9.857605 -45.225430 -97.578117> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <45.734852 13.419345 -96.913597> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-45.888672 13.353888 -96.849899> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-46.042343 13.287789 -96.786041> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-34.695950 35.003899 -96.098480> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.708187 35.172100 -96.032623> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.719788 35.340466 -95.966599> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-14.760164 -48.707230 -95.256195> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <14.905400 -48.795864 -95.188194> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <15.051075 -48.884007 -95.120026> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <51.428795 10.496483 -94.386986> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-51.575401 10.407170 -94.316856> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-34.703880 41.461529 -93.491081> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.691566 41.634296 -93.418846> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-20.548349 -51.699055 -92.568748> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <20.708954 -51.767952 -92.494423> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <56.652466 6.801183 -91.696465> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <56.788906 6.689685 -91.620239> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-56.925026 6.577604 -91.543854> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-33.808277 47.855385 -90.724098> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-33.771545 48.029331 -90.645828> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <33.734146 48.203262 -90.567398> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-26.694866 -53.857349 -89.726082> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-26.867775 -53.905060 -89.645790> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <27.040977 -53.952171 -89.565331> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <61.571705 2.180901 -88.702698> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-61.694649 2.048108 -88.620399> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-61.817196 1.914776 -88.537949> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-31.948982 54.405861 -87.654236> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <31.887081 54.577618 -87.569962> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <31.824518 54.749268 -87.485527> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-33.426174 -55.230644 -86.580986> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <33.608738 -55.254951 -86.494759> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <33.791515 -55.278625 -86.408371> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <65.926491 -3.211030 -85.483261> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-66.033066 -3.363205 -85.395103> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-29.142899 60.809967 -84.361359> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <29.056208 60.976101 -84.271301> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-40.463890 -55.694122 -83.215614> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <40.652889 -55.693787 -83.123672> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <69.525047 -9.126351 -82.139984> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <69.613205 -9.295200 -82.046333> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-69.700821 -9.464470 -81.952538> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-25.522833 66.781654 -80.949341> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-25.412807 66.939095 -80.853859> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <25.302164 67.096252 -80.758240> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-47.491280 -55.233860 -79.735809> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-47.683311 -55.208755 -79.638527> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <47.875381 -55.182968 -79.541107> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <72.472725 -15.795445 -78.499733> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-72.539719 -15.978846 -78.400681> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-72.606117 -16.162592 -78.301483> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-20.931370 72.523338 -77.241463> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <20.798634 72.668671 -77.140663> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <20.665318 72.813637 -77.039719> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-54.763664 -53.803482 -75.961349> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <54.955410 -53.752586 -75.858833> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <55.147106 -53.701008 -75.756180> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <74.583145 -22.962446 -74.659760> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-74.627068 -23.157499 -74.555557> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-15.510507 77.750237 -73.337067> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <15.356752 77.880432 -73.231201> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-61.961178 -51.397751 -71.993637> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <62.149174 -51.321175 -71.886139> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <75.771561 -30.309896 -70.738815> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <75.791580 -30.513292 -70.629852> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-75.810928 -30.716871 -70.520752> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-9.503909 82.239487 -69.356636> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-9.331695 82.352280 -69.246094> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <9.159010 82.464569 -69.135429> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-68.772110 -48.130413 -67.954834> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-68.953163 -48.029385 -67.842758> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <69.133980 -47.927700 -67.730560> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <76.054680 -38.117382 -66.533829> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-76.049080 -38.326084 -66.420242> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-76.042793 -38.534882 -66.306541> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-2.669388 86.137360 -65.094009> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.480619 86.229828 -64.978951> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.291448 86.321724 -64.863770> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-75.440987 -43.853672 -63.635784> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <75.611618 -43.728531 -63.519279> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <75.781929 -43.602768 -63.402664> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <75.355270 -46.062691 -62.159569> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-75.323418 -46.273277 -62.041653> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <4.741745 89.225441 -60.665779> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-4.944320 89.295448 -60.546486> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-81.656509 -38.690056 -59.154835> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <81.813553 -38.542259 -59.034203> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <73.715515 -53.805897 -57.749008> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <73.657944 -54.014965 -57.627167> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-73.599678 -54.223949 -57.505222> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <12.407268 91.383308 -56.206326> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <12.620389 91.429756 -56.083206> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-12.833755 91.475540 -55.959988> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-87.161697 -32.870392 -54.647747> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-87.302681 -32.702332 -54.523388> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <87.443192 -32.533745 -54.398930> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <71.048668 -61.638195 -53.073719> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-70.964966 -61.842274 -52.948154> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-70.880577 -62.046177 -52.822491> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <20.627596 92.670540 -51.484688> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-20.848368 92.691460 -51.357948> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-21.069298 92.711693 -51.231117> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-92.150932 -26.154955 -49.881100> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <92.272774 -25.968290 -49.753223> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <92.394073 -25.781166 -49.625259> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <67.405258 -69.218307 -48.263405> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-67.296173 -69.413986 -48.134430> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <29.075499 92.973465 -46.632069> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-29.300545 92.967949 -46.502029> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-96.370918 -18.782080 -44.987545> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <96.471252 -18.579390 -44.856480> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <62.954639 -76.234787 -43.462280> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <62.821991 -76.419121 -43.330303> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-62.688721 -76.603104 -43.198250> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <37.395332 92.297737 -41.793743> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <37.621201 92.266037 -41.660809> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-37.847046 92.233627 -41.527802> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-99.661224 -11.070496 -40.113388> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-99.738693 -10.854963 -39.979538> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <99.815506 -10.639123 -39.845615> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <57.507465 -82.949776 -38.421692> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-57.352211 -83.119385 -38.286961> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-57.196384 -83.288567 -38.152164> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <45.909203 90.598289 -36.719131> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-46.132458 90.539711 -36.583561> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-46.355598 90.480423 -36.447926> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-102.133286 -2.712713 -35.006191> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <102.185669 -2.487065 -34.869816> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <102.237366 -2.261194 -34.733379> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <51.240856 -89.053879 -33.283352> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-51.065018 -89.205902 -33.146214> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <54.259754 87.888603 -31.551102> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-54.476917 87.803612 -31.413237> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-103.632797 5.967457 -29.809933> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <103.658913 6.199917 -29.671381> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <44.431656 -94.311279 -28.199484> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <44.238064 -94.443695 -28.060333> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-44.044022 -94.575546 -27.921135> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <62.108829 84.304710 -26.442564> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <62.316803 84.194885 -26.302803> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-62.524487 84.084404 -26.162994> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-104.123177 14.606581 -24.678167> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-104.123001 14.842374 -24.537834> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <104.122101 15.078210 -24.397457> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <36.804581 -98.917648 -22.906794> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-36.595421 -99.027710 -22.765928> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-36.385883 -99.137154 -22.625021> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <69.759354 79.694420 -21.128942> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-69.954697 79.560432 -20.987585> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-70.149651 79.425827 -20.846189> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-103.611824 23.544777 -19.345118> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <103.584358 23.780533 -19.203308> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <103.556175 24.016241 -19.061462> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <28.642397 -102.642128 -17.555824> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-28.420643 -102.727959 -17.413601> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <76.874878 74.201256 -15.761566> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-77.054543 74.044891 -15.618971> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-102.069565 32.416710 -13.962852> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <102.014992 32.648918 -13.819925> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <20.293003 -105.360435 -12.303387> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <20.062063 -105.421265 -12.160191> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-19.830917 -105.481407 -12.016972> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <83.183411 68.075859 -10.497541> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <83.345146 67.899773 -10.354091> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-83.506363 67.723190 -10.210621> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-99.592064 40.864742 -8.688727> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-99.511711 41.090164 -8.545063> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <99.430672 41.315357 -8.401383> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <11.425034 -107.173546 -6.877457> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-11.187982 -107.207687 -6.733620> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-10.950814 -107.241104 -6.589770> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <88.929855 61.072372 -5.064242> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-89.070740 60.878521 -4.920272> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-89.211044 60.684238 -4.776294> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-96.076744 49.220917 -3.249596> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <95.970993 49.436066 -3.105534> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <95.864578 49.650902 -2.961467> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.389479 -107.964043 -1.434030> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-2.149787 -107.970894 -1.289918> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <93.846909 53.447281 0.381941> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-93.964821 53.238472 0.526063> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-91.626610 57.129097 2.197803> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <91.496971 57.330795 2.341896> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-6.442275 -107.738235 3.869017> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-6.681155 -107.718422 4.013045> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <6.919966 -107.697876 4.157066> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <97.767609 45.532364 5.683233> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <97.861496 45.311939 5.827152> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-97.954712 45.091248 5.971061> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-86.457817 64.287315 7.495842> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-86.306770 64.473083 7.639611> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <86.155167 64.658379 7.783368> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-15.419148 -106.487755 9.306331> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <15.653734 -106.440872 9.449911> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <15.888159 -106.393288 9.593473> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <100.848030 37.015541 11.114189> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-100.915939 36.786415 11.257538> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-100.983154 36.557106 11.400867> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-80.367928 70.979561 12.918905> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <80.197159 71.146332 13.061983> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <80.025902 71.312569 13.205037> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-24.170010 -104.226357 14.719969> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <24.396872 -104.153214 14.862735> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <102.927940 28.231754 16.516870> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-102.969009 27.997337 16.659285> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-73.578979 76.908455 18.309101> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <73.391113 77.053879 18.451122> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-32.351242 -101.090126 19.954531> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-32.567421 -100.992615 20.096157> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <32.783268 -100.894455 20.237745> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <103.968277 19.548065 21.736374> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <103.982819 19.311853 21.877529> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-103.996628 19.075640 22.018646> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-66.397469 81.869156 23.512070> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-66.195755 81.991890 23.652716> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <65.993706 82.113998 23.793322> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-40.288090 -96.962540 25.281118> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <40.490234 -96.841637 25.421217> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <40.691971 -96.720139 25.561268> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <104.018364 10.623311 27.043020> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-104.005692 10.388727 27.182529> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-103.992310 10.154235 27.321989> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-58.545792 86.064552 28.797276> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <58.332954 86.162437 28.936155> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <58.119865 86.259644 29.074986> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-47.640491 -91.986328 30.543388> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <47.825748 -91.844093 30.681602> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <103.046677 1.824410 32.280865> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-103.007309 1.594934 32.418373> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-50.333748 89.296623 34.009216> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <50.113110 89.368500 34.145977> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-54.139523 -86.406761 35.591911> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-54.305889 -86.246063 35.727951> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <54.471714 -86.084908 35.863930> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <101.145401 -6.497415 37.301361> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <101.080963 -6.718674 37.436584> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-101.015869 -6.939667 37.571739> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-42.114365 91.484200 39.000267> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-41.889435 91.530083 39.134632> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <41.664433 91.575249 39.268929> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-60.049175 -80.016068 40.688148> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <60.193951 -79.839111 40.821617> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <60.338135 -79.661766 40.955013> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <98.254776 -14.671287 42.364525> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-98.165970 -14.880928 42.497059> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-98.076546 -15.090220 42.629517> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-33.570244 92.728058 44.028919> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <33.344360 92.746994 44.160484> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <33.118500 92.765221 44.291969> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-65.106804 -73.064102 45.680870> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <65.228157 -72.873871 45.811424> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <94.473946 -22.349491 47.319904> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-94.362587 -22.544510 47.449413> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-25.054464 92.954865 48.945557> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <24.831127 92.947075 49.073986> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-69.153435 -65.868202 50.429970> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-69.250626 -65.668129 50.557373> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <69.347137 -65.467827 50.684685> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <90.009712 -29.245029 52.028645> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <89.878494 -29.423185 52.154896> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-89.746758 -29.600851 52.281052> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-16.915956 92.214638 53.612606> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-16.698395 92.181488 53.737671> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <16.481035 92.147659 53.862637> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-72.363686 -58.159340 55.181408> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <72.435081 -57.952465 55.305252> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <72.505783 -57.745457 55.428993> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <84.706802 -35.636234 56.734612> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-84.557671 -35.794682 56.857197> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-84.408104 -35.952579 56.979679> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-8.838187 90.500206 58.271770> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <8.629826 90.442116 58.393066> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <8.421750 90.383385 58.514256> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-74.586555 -50.256428 59.792458> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <74.631622 -50.046207 59.912426> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <78.777084 -41.242489 61.296238> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-78.612862 -41.379166 61.414845> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-1.166718 87.869064 62.782688> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <0.970685 87.787582 62.899902> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-75.791115 -42.501137 64.135483> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-75.810486 -42.291012 64.251389> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <75.829163 -42.080936 64.367172> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <72.507881 -45.879086 65.587471> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <72.331909 -45.992962 65.701920> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-72.155663 -46.106205 65.816246> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <5.803064 84.489769 67.020920> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <5.984318 84.387383 67.133873> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-6.165135 84.284462 67.246712> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-76.048248 -34.601421 68.435417> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <76.041611 -34.394810 68.546852> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <76.034294 -34.188339 68.658165> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <65.675781 -49.743187 69.830559> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-65.490952 -49.832417 69.940445> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-65.305931 -49.920982 70.050201> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <12.347302 80.257431 71.205963> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-12.510806 80.135857 71.314262> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-12.673808 80.013817 71.422432> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-75.335350 -26.897068 72.561234> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <75.303551 -26.697348 72.667915> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <58.570286 -52.658375 73.895988> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-58.379982 -52.722153 74.001030> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <18.177015 75.346359 75.209854> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-18.320498 75.208237 75.313217> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-73.747726 -19.703144 76.400650> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-73.692665 -19.513233 76.502449> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <73.637001 -19.323627 76.604111> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <51.513260 -54.564045 77.673347> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <51.320946 -54.602711 77.773415> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-51.128624 -54.640697 77.873344> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <23.090916 70.012848 78.924088> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <23.213083 69.861389 79.022392> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-23.334650 69.709610 79.120567> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-71.254021 -12.745218 80.152504> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <71.176743 -12.568364 80.249031> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <71.098915 -12.391894 80.345413> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <44.249840 -55.558834 81.358269> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-44.058880 -55.571823 81.452980> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-43.868000 -55.584137 81.547546> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <27.292454 64.078865 82.541023> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-27.391254 63.916809 82.633896> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-27.489422 63.754513 82.726624> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-67.956802 -6.333118 83.700439> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <67.859406 -6.172089 83.791451> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <37.100594 -55.591057 84.836197> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-36.914398 -55.578941 84.925308> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <30.588902 57.803688 85.947968> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-30.663273 57.634315 86.035164> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-64.056152 -0.709247 86.950027> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-63.941479 -0.565988 87.035431> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <63.826378 -0.423241 87.120689> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <30.371164 -54.726398 88.014847> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <30.192781 -54.690826 88.098297> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-30.014654 -54.654633 88.181580> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <32.898384 51.487293 89.054787> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <32.948383 51.314068 89.136246> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-32.997719 51.140789 89.217545> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-59.435543 4.346617 90.069550> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <59.305836 4.469539 90.148994> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <59.175770 4.591899 90.228279> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <23.815554 -52.963261 91.058838> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-23.648287 -52.905025 91.136253> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-23.481354 -52.846214 91.213509> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.331581 44.913498 92.022392> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-34.356396 44.739719 92.097748> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-34.380550 44.565975 92.172943> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-54.300026 8.600027 92.959923> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <54.158264 8.700888 93.033203> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <17.734636 -50.375458 93.871170> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-17.581388 -50.296413 93.942352> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.816082 38.381828 94.755875> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-34.816021 38.210926 94.824944> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-48.916851 11.915215 95.546684> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-48.766415 11.993339 95.613792> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <48.615784 12.070832 95.680725> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <12.370398 -47.137268 96.379723> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <12.233321 -47.040100 96.444672> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-12.096717 -46.942474 96.509445> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.395565 32.185734 97.185509> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <34.372021 32.020851 97.248283> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-34.347851 31.856176 97.310890> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-43.114113 14.431330 97.963821> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <42.958050 14.485240 98.024406> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <42.801880 14.538503 98.084816> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <7.523221 -43.160889 98.714432> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-7.405029 -43.047623 98.772812> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-7.287365 -42.933968 98.831009> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <33.083126 26.110605 99.437134> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-33.036644 25.955082 99.493286> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-37.160843 16.022202 100.131714> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <37.002556 16.051483 100.185631> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <3.427379 -38.626644 100.797997> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-3.330010 -38.500114 100.849655> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <30.931408 20.445848 101.435768> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-30.863613 20.302708 101.485161> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-31.343740 16.675251 101.997581> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-31.186584 16.680593 102.044868> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <31.029507 16.685291 102.091972> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <0.224526 -33.782669 102.580116> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <0.148909 -33.646164 102.625114> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-0.073899 -33.509430 102.669922> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <28.095701 15.429852 103.133659> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <28.009087 15.301434 103.176338> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-27.921989 15.173449 103.218842> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-25.473183 16.435593 103.658035> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <25.320536 16.416843 103.698395> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <25.168053 16.397469 103.738579> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-2.209735 -28.482409 104.153107> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.261911 -28.338858 104.191139> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.313457 -28.195164 104.228981> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <24.502611 10.887778 104.618729> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-24.398994 10.776928 104.654419> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-19.834023 15.300537 105.054771> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <19.689171 15.258648 105.088104> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-3.743401 -22.976961 105.461113> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <3.771467 -22.829718 105.492088> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <20.314547 7.050826 105.837639> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-20.196602 6.959682 105.866234> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-14.682137 13.377276 106.157822> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-14.547878 13.314188 106.184235> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <14.413948 13.250546 106.210457> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-4.355258 -17.542116 106.476784> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-4.359650 -17.394560 106.500809> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <4.363400 -17.247038 106.524651> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <15.766665 4.063202 106.765640> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <15.637587 3.992931 106.787277> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-15.508246 3.923247 106.808716> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-9.849689 10.619774 107.024315> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <9.729185 10.536677 107.043549> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <9.609083 10.453080 107.062592> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-4.078880 -12.008965 107.252724> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <4.059199 -11.864448 107.269554> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <4.038890 -11.720057 107.286194> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <10.724196 1.820430 107.450813> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-10.586781 1.772928 107.465233> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-5.587210 7.143995 107.618523> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <5.483106 7.043054 107.630531> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-2.903325 -6.652645 107.755806> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <2.860277 -6.514510 107.765396> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <5.426497 0.457302 107.862617> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-5.284035 0.433483 107.869789> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-2.074896 3.154096 107.933990> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-1.988993 3.038184 107.938934> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <1.903612 2.921901 107.943680> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-0.928236 -1.726296 107.982216> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <-0.863541 -1.597464 107.984734> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <0.798277 -1.468927 107.987061> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <0.144124 0.000320 107.999901> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object
  object {
      sphere { <0.000000 0.000000 108.000000> Sph2_Radius }

      texture { Liss2_Texture   }
  } // end object

rotate <0 Liss_Rotation 0>
} // end composite 
/*
  Parameters used for this generation:
    R1 = 108   A = 0.15   B = 0.25
    X-Exponent = 1
    Y-Exponent = 1
    Z-Exponent = 1
    Sphere Radius = 2
    Number of Spheres generated:  500
    Axis = Z
    Algorithm = #1

    Minimum X = -104.123177      Maximum X = 104.122101
    Minimum Y = -107.970894      Maximum Y = 92.973465
    Minimum Z = -107.997299      Maximum Z = 108.000000

    Min/Max XYZs with RADIUS figured in:
    Leftmost Point = -106.123177     Rightmost Point = 106.122101
      Lowest Point = -109.970894       Highest Point = 94.973465
     Nearest Point = -109.997299      Farthest Point = 110.000000
*/ 

 
