
// This file is a POV V2.0 document that describes
// the image of an 57 chevy convertable. This image was
// converted from 57chevy.obj found on avalon.chinalake.navy.mil
// by Keith Rule (keithr@lucy1.pen.tek.com).
//
// The original file "57chevy.obj" had no comments or restrictions
// associated with it, and no additional restrictions have been
// added to this version of the file.
//
// This file was automatically generated from 57chevy.obj. Occasional
// warnings will be reported by povray about this file. These
// warnings, though annoying, do not affect the resultant raytraced
// image.

#include "colors.inc"
#include "textures.inc"

camera {
   location  <-5, 5, 20>
   direction <0, 0,  1>
   up        <0, 1,  0>
   right   <4/3, 0,  0>
   look_at   <1, 0, 0>
}

light_source {<2, 3, 21> color White}
light_source {<0, 10 0> color White}
light_source {<-5, 5, 26> color White}

plane {
   y, -12
 
   pigment {
      granite
      color_map { [0.0 1.01 color White color Gold] }
      quick_color White
   }
   finish {
      reflection 0.15
      ambient 0.075  diffuse 0.5
   }

   scale 0.25
}

// The 57chevy pov model start after this line and continues
// until the end of the file
#declare cover = texture {pigment {color White} finish {Metal}}
#declare visors = texture {pigment {color White} finish {Metal}}
#declare hood = texture {pigment {color Red} finish{SilverFinish}}
#declare black = texture {pigment {color Black} finish {Metal}}
#declare net = texture {pigment {color Red} finish{SilverFinish}}
#declare mirror = texture {pigment {Silver1_Colour} finish{SilverFinish}}
#declare logo = texture{Polished_Chrome}
#declare steer1 = texture{Copper_Metal}
#declare steer2 = texture{Copper_Metal}
#declare interior = texture {pigment {color White} finish {Metal}}
#declare handles = texture{Polished_Chrome}
#declare orn = texture{Polished_Chrome}
#declare trim = texture{Polished_Chrome}
#declare bottom = texture {pigment {color Black} finish {Metal}}
#declare hlight = texture{Glass}
#declare fseat = texture {pigment {color Black} finish {Metal}}
#declare bseat = texture {pigment {color Black} finish {Metal}}
#declare rlight = texture{Green_Glass}
#declare wlight = texture{Green_Glass}
#declare sidep = texture {pigment {color White} finish{SilverFinish}}
#declare trunk = texture {pigment {color Red} finish{SilverFinish}}
#declare glass = texture{Glass}
#declare rftire = texture {pigment {color Black} finish {Metal}}
#declare rfwhitew = texture {pigment {color White} finish {Metal}}
#declare btires = texture {pigment {color Black} finish {Metal}}
#declare bwhitew = texture {pigment {color White} finish {Metal}}
#declare lftire = texture {pigment {color Black} finish {Metal}}
#declare lfwhitew = texture {pigment {color White} finish {Metal}}
#declare doors = texture {pigment {color Red} finish{SilverFinish}}
#declare alight = texture{pigment {color White} finish{SilverFinish}}
#declare embwhite = texture {pigment {color White} finish {Metal}}
#declare embred = texture {pigment {color Red} finish {Metal}}
#declare embblue = texture {pigment {color Blue} finish {Metal}}
#declare rubber = texture {pigment {color Black} finish {Metal}}
#declare blacko = texture {pigment {color Black} finish {Metal}}
#declare grill = texture{Polished_Chrome}
#declare body = texture {pigment {color Red} finish{SilverFinish}}
#declare chrome = texture{Polished_Chrome}
#declare lfrim = texture{Polished_Chrome}
#declare brims = texture{Polished_Chrome}
#declare rfrim = texture{Polished_Chrome}
union {
  // cover
  union {
    triangle {
      < 5.434242, 0.622224, 0.000000>,
      < 5.385889, 0.605628, 1.166630>,
      < 5.435663, 0.594303, 1.148942>
    }
    triangle {
      < 5.434242, 0.622224, 0.000000>,
      < 5.435663, 0.594303, 1.148942>,
      < 5.484661, 0.611664, 0.000000>
    }
    triangle {
      < 4.432414, 0.693152, 0.000000>,
      < 4.718122, 0.742822, 0.000000>,
      < 5.064101, 0.764874, 0.000000>
    }
    triangle {
      < 4.432414, 0.693152, 0.000000>,
      < 5.064101, 0.764874, 0.000000>,
      < 5.256576, 0.737194, 0.000000>
    }
    triangle {
      < 4.432414, 0.693152, 0.000000>,
      < 5.256576, 0.737194, 0.000000>,
      < 5.331141, 0.702180, 0.000000>
    }
    triangle {
      < 4.432414, 0.693152, 0.000000>,
      < 5.331141, 0.702180, 0.000000>,
      < 5.385342, 0.657458, 0.000000>
    }
    triangle {
      < 4.432414, 0.693152, 0.000000>,
      < 5.385342, 0.657458, 0.000000>,
      < 5.434242, 0.622224, 0.000000>
    }
    triangle {
      < 4.432414, 0.693152, 0.000000>,
      < 5.434242, 0.622224, 0.000000>,
      < 5.484661, 0.611664, 0.000000>
    }
    triangle {
      < 4.432414, 0.693152, 0.000000>,
      < 5.484661, 0.611664, 0.000000>,
      < 4.404754, 0.660973, 0.000000>
    }
    triangle {
      < 4.418221, 0.650336, 1.195427>,
      < 4.432414, 0.693152, 0.000000>,
      < 4.404754, 0.660973, 0.000000>
    }
    triangle {
      < 4.418221, 0.650336, 1.195427>,
      < 4.404754, 0.660973, 0.000000>,
      < 4.392016, 0.617258, 1.175757>
    }
    triangle {
      < 4.428919, 0.607497, 1.904914>,
      < 4.418221, 0.650336, 1.195427>,
      < 4.392016, 0.617258, 1.175757>
    }
    triangle {
      < 4.428919, 0.607497, 1.904914>,
      < 4.392016, 0.617258, 1.175757>,
      < 4.401617, 0.573519, 1.900152>
    }
    triangle {
      < 4.424780, 0.592930, 2.060147>,
      < 4.428919, 0.607497, 1.904914>,
      < 4.401617, 0.573519, 1.900152>
    }
    triangle {
      < 4.424780, 0.592930, 2.060147>,
      < 4.401617, 0.573519, 1.900152>,
      < 4.398887, 0.558645, 2.058646>
    }
    triangle {
      < 4.418779, 0.560729, 2.314312>,
      < 4.424780, 0.592930, 2.060147>,
      < 4.398887, 0.558645, 2.058646>
    }
    triangle {
      < 4.418779, 0.560729, 2.314312>,
      < 4.398887, 0.558645, 2.058646>,
      < 4.389600, 0.525768, 2.318152>
    }
    triangle {
      < 4.221811, 0.524919, 2.347221>,
      < 4.418779, 0.560729, 2.314312>,
      < 4.389600, 0.525768, 2.318152>
    }
    triangle {
      < 4.221811, 0.524919, 2.347221>,
      < 4.389600, 0.525768, 2.318152>,
      < 4.228822, 0.489205, 2.351752>
    }
    triangle {
      < 3.826275, 0.194423, 2.363789>,
      < 3.625001, 0.162232, 2.369808>,
      < 3.620496, 0.449908, 2.364905>
    }
    triangle {
      < 3.826275, 0.194423, 2.363789>,
      < 3.620496, 0.449908, 2.364905>,
      < 4.221811, 0.524919, 2.347221>
    }
    triangle {
      < 3.826275, 0.194423, 2.363789>,
      < 4.221811, 0.524919, 2.347221>,
      < 4.228822, 0.489205, 2.351752>
    }
    triangle {
      < 3.826275, 0.194423, 2.363789>,
      < 4.228822, 0.489205, 2.351752>,
      < 4.027549, 0.303414, 2.357771>
    }
    triangle {
      < 3.003972, 0.446481, 2.364837>,
      < 3.620496, 0.449908, 2.364905>,
      < 3.625001, 0.162232, 2.369808>
    }
    triangle {
      < 3.003972, 0.446481, 2.364837>,
      < 3.625001, 0.162232, 2.369808>,
      < 3.005907, 0.147293, 2.369739>
    }
    triangle {
      < 2.545230, 0.389126, 2.372676>,
      < 2.741663, 0.429941, 2.365067>,
      < 2.741663, 0.104686, 2.369974>
    }
    triangle {
      < 2.545230, 0.389126, 2.372676>,
      < 2.741663, 0.104686, 2.369974>,
      < 2.540798, 0.072298, 2.370153>
    }
    triangle {
      < 2.747468, 0.385772, 2.632364>,
      < 2.551353, 0.341970, 2.644864>,
      < 2.546063, 0.324703, 2.677072>
    }
    triangle {
      < 2.747468, 0.385772, 2.632364>,
      < 2.546063, 0.324703, 2.677072>,
      < 2.745803, 0.369686, 2.664615>
    }
    triangle {
      < 3.012384, 0.414965, 2.620832>,
      < 2.747468, 0.385772, 2.632364>,
      < 2.745803, 0.369686, 2.664615>
    }
    triangle {
      < 3.012384, 0.414965, 2.620832>,
      < 2.745803, 0.369686, 2.664615>,
      < 3.013547, 0.399663, 2.652796>
    }
    triangle {
      < 3.613985, 0.434661, 2.602803>,
      < 3.012384, 0.414965, 2.620832>,
      < 3.013547, 0.399663, 2.652796>
    }
    triangle {
      < 3.613985, 0.434661, 2.602803>,
      < 3.013547, 0.399663, 2.652796>,
      < 3.618461, 0.419610, 2.634592>
    }
    triangle {
      < 4.270647, 0.444412, 2.589442>,
      < 3.613985, 0.434661, 2.602803>,
      < 3.618461, 0.419610, 2.634592>
    }
    triangle {
      < 4.270647, 0.444412, 2.589442>,
      < 3.618461, 0.419610, 2.634592>,
      < 4.278938, 0.429553, 2.620985>
    }
    triangle {
      < 4.622761, 0.450151, 2.523951>,
      < 4.270647, 0.444412, 2.589442>,
      < 4.278938, 0.429553, 2.620985>
    }
    triangle {
      < 4.622761, 0.450151, 2.523951>,
      < 4.278938, 0.429553, 2.620985>,
      < 4.633741, 0.426260, 2.557898>
    }
    triangle {
      < 4.785600, 0.475304, 2.493907>,
      < 4.622761, 0.450151, 2.523951>,
      < 4.633741, 0.426260, 2.557898>
    }
    triangle {
      < 4.785600, 0.475304, 2.493907>,
      < 4.633741, 0.426260, 2.557898>,
      < 4.812309, 0.452697, 2.525539>
    }
    triangle {
      < 4.989048, 0.510983, 2.344278>,
      < 4.785600, 0.475304, 2.493907>,
      < 4.812309, 0.452697, 2.525539>
    }
    triangle {
      < 4.989048, 0.510983, 2.344278>,
      < 4.812309, 0.452697, 2.525539>,
      < 5.027698, 0.491304, 2.367082>
    }
    triangle {
      < 5.158484, 0.534896, 2.125506>,
      < 4.989048, 0.510983, 2.344278>,
      < 5.027698, 0.491304, 2.367082>
    }
    triangle {
      < 5.158484, 0.534896, 2.125506>,
      < 5.027698, 0.491304, 2.367082>,
      < 5.203112, 0.518845, 2.137795>
    }
    triangle {
      < 5.288443, 0.570033, 1.801380>,
      < 5.158484, 0.534896, 2.125506>,
      < 5.203112, 0.518845, 2.137795>
    }
    triangle {
      < 5.288443, 0.570033, 1.801380>,
      < 5.203112, 0.518845, 2.137795>,
      < 5.336588, 0.556670, 1.801338>
    }
    triangle {
      < 5.385889, 0.605628, 1.166630>,
      < 5.288443, 0.570033, 1.801380>,
      < 5.336588, 0.556670, 1.801338>
    }
    triangle {
      < 5.385889, 0.605628, 1.166630>,
      < 5.336588, 0.556670, 1.801338>,
      < 5.435663, 0.594303, 1.148942>
    }
    triangle {
      < 3.618905, 0.542040, 2.455939>,
      < 4.239403, 0.570685, 2.435800>,
      < 4.223581, 0.566358, 2.385487>
    }
    triangle {
      < 3.618905, 0.542040, 2.455939>,
      < 4.223581, 0.566358, 2.385487>,
      < 3.621246, 0.521366, 2.405981>
    }
    triangle {
      < 4.701459, 0.701893, 1.193508>,
      < 4.704282, 0.659491, 1.897840>,
      < 4.987030, 0.677147, 1.870296>
    }
    triangle {
      < 4.701459, 0.701893, 1.193508>,
      < 4.987030, 0.677147, 1.870296>,
      < 5.026673, 0.725213, 1.186033>
    }
    triangle {
      < 5.338792, 0.639450, 1.167928>,
      < 5.244813, 0.603248, 1.813822>,
      < 5.288443, 0.570033, 1.801380>
    }
    triangle {
      < 5.338792, 0.639450, 1.167928>,
      < 5.288443, 0.570033, 1.801380>,
      < 5.385889, 0.605628, 1.166630>
    }
    triangle {
      < 5.244813, 0.603248, 1.813822>,
      < 5.117917, 0.568415, 2.124657>,
      < 5.158484, 0.534896, 2.125506>
    }
    triangle {
      < 5.244813, 0.603248, 1.813822>,
      < 5.158484, 0.534896, 2.125506>,
      < 5.288443, 0.570033, 1.801380>
    }
    triangle {
      < 5.117917, 0.568415, 2.124657>,
      < 4.958674, 0.544603, 2.334138>,
      < 4.989048, 0.510983, 2.344278>
    }
    triangle {
      < 5.117917, 0.568415, 2.124657>,
      < 4.989048, 0.510983, 2.344278>,
      < 5.158484, 0.534896, 2.125506>
    }
    triangle {
      < 4.958674, 0.544603, 2.334138>,
      < 4.787219, 0.505571, 2.464559>,
      < 4.785600, 0.475304, 2.493907>
    }
    triangle {
      < 4.958674, 0.544603, 2.334138>,
      < 4.785600, 0.475304, 2.493907>,
      < 4.989048, 0.510983, 2.344278>
    }
    triangle {
      < 4.787219, 0.505571, 2.464559>,
      < 4.618881, 0.477340, 2.506838>,
      < 4.622761, 0.450151, 2.523951>
    }
    triangle {
      < 4.787219, 0.505571, 2.464559>,
      < 4.622761, 0.450151, 2.523951>,
      < 4.785600, 0.475304, 2.493907>
    }
    triangle {
      < 4.618881, 0.477340, 2.506838>,
      < 4.268123, 0.465431, 2.563106>,
      < 4.270647, 0.444412, 2.589442>
    }
    triangle {
      < 4.618881, 0.477340, 2.506838>,
      < 4.270647, 0.444412, 2.589442>,
      < 4.622761, 0.450151, 2.523951>
    }
    triangle {
      < 4.268123, 0.465431, 2.563106>,
      < 3.613815, 0.452417, 2.578444>,
      < 3.613985, 0.434661, 2.602803>
    }
    triangle {
      < 4.268123, 0.465431, 2.563106>,
      < 3.613985, 0.434661, 2.602803>,
      < 4.270647, 0.444412, 2.589442>
    }
    triangle {
      < 3.613815, 0.452417, 2.578444>,
      < 3.012785, 0.432675, 2.596567>,
      < 3.012384, 0.414965, 2.620832>
    }
    triangle {
      < 3.613815, 0.452417, 2.578444>,
      < 3.012384, 0.414965, 2.620832>,
      < 3.613985, 0.434661, 2.602803>
    }
    triangle {
      < 3.012785, 0.432675, 2.596567>,
      < 2.748731, 0.403968, 2.607859>,
      < 2.747468, 0.385772, 2.632364>
    }
    triangle {
      < 3.012785, 0.432675, 2.596567>,
      < 2.747468, 0.385772, 2.632364>,
      < 3.012384, 0.414965, 2.620832>
    }
    triangle {
      < 2.748731, 0.403968, 2.607859>,
      < 2.560904, 0.362517, 2.620014>,
      < 2.551353, 0.341970, 2.644864>
    }
    triangle {
      < 2.748731, 0.403968, 2.607859>,
      < 2.551353, 0.341970, 2.644864>,
      < 2.747468, 0.385772, 2.632364>
    }
    triangle {
      < 2.548000, 0.442103, 2.406947>,
      < 2.741663, 0.469345, 2.404651>,
      < 2.741663, 0.429941, 2.365067>
    }
    triangle {
      < 2.548000, 0.442103, 2.406947>,
      < 2.741663, 0.429941, 2.365067>,
      < 2.545230, 0.389126, 2.372676>
    }
    triangle {
      < 3.004172, 0.497903, 2.405437>,
      < 3.621246, 0.521366, 2.405981>,
      < 3.620496, 0.449908, 2.364905>
    }
    triangle {
      < 3.004172, 0.497903, 2.405437>,
      < 3.620496, 0.449908, 2.364905>,
      < 3.003972, 0.446481, 2.364837>
    }
    triangle {
      < 3.621246, 0.521366, 2.405981>,
      < 4.223581, 0.566358, 2.385487>,
      < 4.221811, 0.524919, 2.347221>
    }
    triangle {
      < 3.621246, 0.521366, 2.405981>,
      < 4.221811, 0.524919, 2.347221>,
      < 3.620496, 0.449908, 2.364905>
    }
    triangle {
      < 4.223581, 0.566358, 2.385487>,
      < 4.672771, 0.611462, 2.344215>,
      < 4.418779, 0.560729, 2.314312>
    }
    triangle {
      < 4.223581, 0.566358, 2.385487>,
      < 4.418779, 0.560729, 2.314312>,
      < 4.221811, 0.524919, 2.347221>
    }
    triangle {
      < 4.672771, 0.611462, 2.344215>,
      < 4.691594, 0.643280, 2.065812>,
      < 4.424780, 0.592930, 2.060147>
    }
    triangle {
      < 4.672771, 0.611462, 2.344215>,
      < 4.424780, 0.592930, 2.060147>,
      < 4.418779, 0.560729, 2.314312>
    }
    triangle {
      < 4.691594, 0.643280, 2.065812>,
      < 4.704282, 0.659491, 1.897840>,
      < 4.428919, 0.607497, 1.904914>
    }
    triangle {
      < 4.691594, 0.643280, 2.065812>,
      < 4.428919, 0.607497, 1.904914>,
      < 4.424780, 0.592930, 2.060147>
    }
    triangle {
      < 4.704282, 0.659491, 1.897840>,
      < 4.701459, 0.701893, 1.193508>,
      < 4.418221, 0.650336, 1.195427>
    }
    triangle {
      < 4.704282, 0.659491, 1.897840>,
      < 4.418221, 0.650336, 1.195427>,
      < 4.428919, 0.607497, 1.904914>
    }
    triangle {
      < 4.701459, 0.701893, 1.193508>,
      < 4.718122, 0.742822, 0.000000>,
      < 4.432414, 0.693152, 0.000000>
    }
    triangle {
      < 4.701459, 0.701893, 1.193508>,
      < 4.432414, 0.693152, 0.000000>,
      < 4.418221, 0.650336, 1.195427>
    }
    triangle {
      < 5.385342, 0.657458, 0.000000>,
      < 5.338792, 0.639450, 1.167928>,
      < 5.385889, 0.605628, 1.166630>
    }
    triangle {
      < 5.385342, 0.657458, 0.000000>,
      < 5.385889, 0.605628, 1.166630>,
      < 5.434242, 0.622224, 0.000000>
    }
    triangle {
      < 5.285878, 0.680465, 1.172548>,
      < 5.331141, 0.702180, 0.000000>,
      < 5.256576, 0.737194, 0.000000>
    }
    triangle {
      < 5.285878, 0.680465, 1.172548>,
      < 5.256576, 0.737194, 0.000000>,
      < 5.214001, 0.708682, 1.178558>
    }
    triangle {
      < 4.691594, 0.643280, 2.065812>,
      < 4.672771, 0.611462, 2.344215>,
      < 4.823652, 0.614626, 2.331454>
    }
    triangle {
      < 4.691594, 0.643280, 2.065812>,
      < 4.823652, 0.614626, 2.331454>,
      < 4.916988, 0.650447, 2.087875>
    }
    triangle {
      < 4.704282, 0.659491, 1.897840>,
      < 4.691594, 0.643280, 2.065812>,
      < 4.916988, 0.650447, 2.087875>
    }
    triangle {
      < 4.704282, 0.659491, 1.897840>,
      < 4.916988, 0.650447, 2.087875>,
      < 4.987030, 0.677147, 1.870296>
    }
    triangle {
      < 4.672771, 0.611462, 2.344215>,
      < 4.656408, 0.597022, 2.391192>,
      < 4.740355, 0.605217, 2.376164>
    }
    triangle {
      < 4.672771, 0.611462, 2.344215>,
      < 4.223581, 0.566358, 2.385487>,
      < 4.239403, 0.570685, 2.435800>
    }
    triangle {
      < 4.672771, 0.611462, 2.344215>,
      < 4.239403, 0.570685, 2.435800>,
      < 4.656408, 0.597022, 2.391192>
    }
    triangle {
      < 3.621246, 0.521366, 2.405981>,
      < 3.004172, 0.497903, 2.405437>,
      < 3.007305, 0.518574, 2.460711>
    }
    triangle {
      < 3.621246, 0.521366, 2.405981>,
      < 3.007305, 0.518574, 2.460711>,
      < 3.618905, 0.542040, 2.455939>
    }
    triangle {
      < 2.741663, 0.469345, 2.404651>,
      < 2.548000, 0.442103, 2.406947>,
      < 2.552408, 0.460174, 2.465842>
    }
    triangle {
      < 2.741663, 0.469345, 2.404651>,
      < 2.552408, 0.460174, 2.465842>,
      < 2.741663, 0.489858, 2.463518>
    }
    triangle {
      < 5.205453, 0.643570, 1.806886>,
      < 5.285878, 0.680465, 1.172548>,
      < 5.214001, 0.708682, 1.178558>
    }
    triangle {
      < 5.205453, 0.643570, 1.806886>,
      < 5.214001, 0.708682, 1.178558>,
      < 5.144625, 0.666302, 1.842752>
    }
    triangle {
      < 5.089981, 0.609728, 2.113854>,
      < 5.205453, 0.643570, 1.806886>,
      < 5.144625, 0.666302, 1.842752>
    }
    triangle {
      < 5.089981, 0.609728, 2.113854>,
      < 5.144625, 0.666302, 1.842752>,
      < 5.043014, 0.634781, 2.109938>
    }
    triangle {
      < 4.941820, 0.581944, 2.331707>,
      < 5.089981, 0.609728, 2.113854>,
      < 5.043014, 0.634781, 2.109938>
    }
    triangle {
      < 4.941820, 0.581944, 2.331707>,
      < 5.043014, 0.634781, 2.109938>,
      < 4.906283, 0.596543, 2.339461>
    }
    triangle {
      < 4.639228, 0.546976, 2.457393>,
      < 4.613291, 0.510517, 2.493807>,
      < 4.790792, 0.538795, 2.438505>
    }
    triangle {
      < 4.639228, 0.546976, 2.457393>,
      < 4.790792, 0.538795, 2.438505>,
      < 4.795737, 0.568216, 2.413139>
    }
    triangle {
      < 4.262087, 0.513910, 2.538564>,
      < 4.613291, 0.510517, 2.493807>,
      < 4.639228, 0.546976, 2.457393>
    }
    triangle {
      < 4.262087, 0.513910, 2.538564>,
      < 4.639228, 0.546976, 2.457393>,
      < 4.254616, 0.548587, 2.507485>
    }
    triangle {
      < 3.614235, 0.493614, 2.553829>,
      < 4.262087, 0.513910, 2.538564>,
      < 4.254616, 0.548587, 2.507485>
    }
    triangle {
      < 3.614235, 0.493614, 2.553829>,
      < 4.254616, 0.548587, 2.507485>,
      < 3.616533, 0.516730, 2.522926>
    }
    triangle {
      < 3.010870, 0.475408, 2.569852>,
      < 3.614235, 0.493614, 2.553829>,
      < 3.616533, 0.516730, 2.522926>
    }
    triangle {
      < 3.010870, 0.475408, 2.569852>,
      < 3.616533, 0.516730, 2.522926>,
      < 3.009872, 0.502667, 2.534627>
    }
    triangle {
      < 2.550806, 0.402855, 2.590981>,
      < 2.741663, 0.445995, 2.581111>,
      < 2.741663, 0.471711, 2.543222>
    }
    triangle {
      < 2.550806, 0.402855, 2.590981>,
      < 2.741663, 0.471711, 2.543222>,
      < 2.551643, 0.441419, 2.544901>
    }
    triangle {
      < 2.741663, 0.489858, 2.463518>,
      < 2.552408, 0.460174, 2.465842>,
      < 2.551643, 0.441419, 2.544901>
    }
    triangle {
      < 2.741663, 0.489858, 2.463518>,
      < 2.551643, 0.441419, 2.544901>,
      < 2.741663, 0.471711, 2.543222>
    }
    triangle {
      < 3.618905, 0.542040, 2.455939>,
      < 3.007305, 0.518574, 2.460711>,
      < 3.009872, 0.502667, 2.534627>
    }
    triangle {
      < 3.618905, 0.542040, 2.455939>,
      < 3.009872, 0.502667, 2.534627>,
      < 3.616533, 0.516730, 2.522926>
    }
    triangle {
      < 4.239403, 0.570685, 2.435800>,
      < 3.618905, 0.542040, 2.455939>,
      < 3.616533, 0.516730, 2.522926>
    }
    triangle {
      < 4.239403, 0.570685, 2.435800>,
      < 3.616533, 0.516730, 2.522926>,
      < 4.254616, 0.548587, 2.507485>
    }
    triangle {
      < 4.656408, 0.597022, 2.391192>,
      < 4.239403, 0.570685, 2.435800>,
      < 4.254616, 0.548587, 2.507485>
    }
    triangle {
      < 4.656408, 0.597022, 2.391192>,
      < 4.254616, 0.548587, 2.507485>,
      < 4.639228, 0.546976, 2.457393>
    }
    triangle {
      < 4.656408, 0.597022, 2.391192>,
      < 4.639228, 0.546976, 2.457393>,
      < 4.795737, 0.568216, 2.413139>
    }
    triangle {
      < 4.656408, 0.597022, 2.391192>,
      < 4.795737, 0.568216, 2.413139>,
      < 4.740355, 0.605217, 2.376164>
    }
    triangle {
      < 4.916988, 0.650447, 2.087875>,
      < 4.823652, 0.614626, 2.331454>,
      < 4.906283, 0.596543, 2.339461>
    }
    triangle {
      < 4.916988, 0.650447, 2.087875>,
      < 4.906283, 0.596543, 2.339461>,
      < 5.043014, 0.634781, 2.109938>
    }
    triangle {
      < 4.987030, 0.677147, 1.870296>,
      < 4.916988, 0.650447, 2.087875>,
      < 5.043014, 0.634781, 2.109938>
    }
    triangle {
      < 4.987030, 0.677147, 1.870296>,
      < 5.043014, 0.634781, 2.109938>,
      < 5.144625, 0.666302, 1.842752>
    }
    triangle {
      < 5.026673, 0.725213, 1.186033>,
      < 4.987030, 0.677147, 1.870296>,
      < 5.144625, 0.666302, 1.842752>
    }
    triangle {
      < 5.026673, 0.725213, 1.186033>,
      < 5.144625, 0.666302, 1.842752>,
      < 5.214001, 0.708682, 1.178558>
    }
    triangle {
      < 4.718122, 0.742822, 0.000000>,
      < 4.701459, 0.701893, 1.193508>,
      < 5.026673, 0.725213, 1.186033>
    }
    triangle {
      < 4.718122, 0.742822, 0.000000>,
      < 5.026673, 0.725213, 1.186033>,
      < 5.064101, 0.764874, 0.000000>
    }
    triangle {
      < 5.214001, 0.708682, 1.178558>,
      < 5.256576, 0.737194, 0.000000>,
      < 5.064101, 0.764874, 0.000000>
    }
    triangle {
      < 5.214001, 0.708682, 1.178558>,
      < 5.064101, 0.764874, 0.000000>,
      < 5.026673, 0.725213, 1.186033>
    }
    triangle {
      < 4.823652, 0.614626, 2.331454>,
      < 4.672771, 0.611462, 2.344215>,
      < 4.740355, 0.605217, 2.376164>
    }
    triangle {
      < 4.906283, 0.596543, 2.339461>,
      < 4.823652, 0.614626, 2.331454>,
      < 4.740355, 0.605217, 2.376164>
    }
    triangle {
      < 4.906283, 0.596543, 2.339461>,
      < 4.740355, 0.605217, 2.376164>,
      < 4.795737, 0.568216, 2.413139>
    }
    triangle {
      < 4.941820, 0.581944, 2.331707>,
      < 4.906283, 0.596543, 2.339461>,
      < 4.795737, 0.568216, 2.413139>
    }
    triangle {
      < 4.941820, 0.581944, 2.331707>,
      < 4.795737, 0.568216, 2.413139>,
      < 4.790792, 0.538795, 2.438505>
    }
    triangle {
      < 2.551643, 0.441419, 2.544901>,
      < 2.552408, 0.460174, 2.465842>,
      < 2.502712, 0.425749, 2.460111>
    }
    triangle {
      < 2.551643, 0.441419, 2.544901>,
      < 2.502712, 0.425749, 2.460111>,
      < 2.504147, 0.419260, 2.549422>
    }
    triangle {
      < 2.550806, 0.402855, 2.590981>,
      < 2.551643, 0.441419, 2.544901>,
      < 2.504147, 0.419260, 2.549422>
    }
    triangle {
      < 2.550806, 0.402855, 2.590981>,
      < 2.504147, 0.419260, 2.549422>,
      < 2.514148, 0.378683, 2.591621>
    }
    triangle {
      < 2.552408, 0.460174, 2.465842>,
      < 2.548000, 0.442103, 2.406947>,
      < 2.500342, 0.396514, 2.397297>
    }
    triangle {
      < 2.552408, 0.460174, 2.465842>,
      < 2.500342, 0.396514, 2.397297>,
      < 2.502712, 0.425749, 2.460111>
    }
    triangle {
      < 2.548000, 0.442103, 2.406947>,
      < 2.545230, 0.389126, 2.372676>,
      < 2.516668, 0.369361, 2.375542>
    }
    triangle {
      < 2.548000, 0.442103, 2.406947>,
      < 2.516668, 0.369361, 2.375542>,
      < 2.500342, 0.396514, 2.397297>
    }
    triangle {
      < 2.551353, 0.341970, 2.644864>,
      < 2.560904, 0.362517, 2.620014>,
      < 2.526680, 0.347239, 2.621296>
    }
    triangle {
      < 2.551353, 0.341970, 2.644864>,
      < 2.526680, 0.347239, 2.621296>,
      < 2.519179, 0.330571, 2.647243>
    }
    triangle {
      < 2.546063, 0.324703, 2.677072>,
      < 2.551353, 0.341970, 2.644864>,
      < 2.519179, 0.330571, 2.647243>
    }
    triangle {
      < 2.546063, 0.324703, 2.677072>,
      < 2.519179, 0.330571, 2.647243>,
      < 2.517581, 0.312552, 2.679691>
    }
    triangle {
      < 2.545230, 0.389126, 2.372676>,
      < 2.540798, 0.072298, 2.370153>,
      < 2.514071, 0.073017, 2.373586>
    }
    triangle {
      < 2.545230, 0.389126, 2.372676>,
      < 2.514071, 0.073017, 2.373586>,
      < 2.516668, 0.369361, 2.375542>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.460616, 0.316862, 2.600444>,
      < 2.460616, 0.325664, 2.551812>
    }
    triangle {
      < 5.338792, 0.639450, 1.167928>,
      < 5.385342, 0.657458, 0.000000>,
      < 5.331141, 0.702180, 0.000000>
    }
    triangle {
      < 5.338792, 0.639450, 1.167928>,
      < 5.331141, 0.702180, 0.000000>,
      < 5.285878, 0.680465, 1.172548>
    }
    triangle {
      < 5.244813, 0.603248, 1.813822>,
      < 5.338792, 0.639450, 1.167928>,
      < 5.285878, 0.680465, 1.172548>
    }
    triangle {
      < 5.244813, 0.603248, 1.813822>,
      < 5.285878, 0.680465, 1.172548>,
      < 5.205453, 0.643570, 1.806886>
    }
    triangle {
      < 5.117917, 0.568415, 2.124657>,
      < 5.244813, 0.603248, 1.813822>,
      < 5.205453, 0.643570, 1.806886>
    }
    triangle {
      < 5.117917, 0.568415, 2.124657>,
      < 5.205453, 0.643570, 1.806886>,
      < 5.089981, 0.609728, 2.113854>
    }
    triangle {
      < 4.958674, 0.544603, 2.334138>,
      < 5.117917, 0.568415, 2.124657>,
      < 5.089981, 0.609728, 2.113854>
    }
    triangle {
      < 4.958674, 0.544603, 2.334138>,
      < 5.089981, 0.609728, 2.113854>,
      < 4.941820, 0.581944, 2.331707>
    }
    triangle {
      < 4.787219, 0.505571, 2.464559>,
      < 4.958674, 0.544603, 2.334138>,
      < 4.941820, 0.581944, 2.331707>
    }
    triangle {
      < 4.787219, 0.505571, 2.464559>,
      < 4.941820, 0.581944, 2.331707>,
      < 4.790792, 0.538795, 2.438505>
    }
    triangle {
      < 4.618881, 0.477340, 2.506838>,
      < 4.787219, 0.505571, 2.464559>,
      < 4.790792, 0.538795, 2.438505>
    }
    triangle {
      < 4.618881, 0.477340, 2.506838>,
      < 4.790792, 0.538795, 2.438505>,
      < 4.613291, 0.510517, 2.493807>
    }
    triangle {
      < 4.268123, 0.465431, 2.563106>,
      < 4.618881, 0.477340, 2.506838>,
      < 4.613291, 0.510517, 2.493807>
    }
    triangle {
      < 4.268123, 0.465431, 2.563106>,
      < 4.613291, 0.510517, 2.493807>,
      < 4.262087, 0.513910, 2.538564>
    }
    triangle {
      < 3.613815, 0.452417, 2.578444>,
      < 4.268123, 0.465431, 2.563106>,
      < 4.262087, 0.513910, 2.538564>
    }
    triangle {
      < 3.613815, 0.452417, 2.578444>,
      < 4.262087, 0.513910, 2.538564>,
      < 3.614235, 0.493614, 2.553829>
    }
    triangle {
      < 3.012785, 0.432675, 2.596567>,
      < 3.613815, 0.452417, 2.578444>,
      < 3.614235, 0.493614, 2.553829>
    }
    triangle {
      < 3.012785, 0.432675, 2.596567>,
      < 3.614235, 0.493614, 2.553829>,
      < 3.010870, 0.475408, 2.569852>
    }
    triangle {
      < 2.748731, 0.403968, 2.607859>,
      < 3.012785, 0.432675, 2.596567>,
      < 3.010870, 0.475408, 2.569852>
    }
    triangle {
      < 2.748731, 0.403968, 2.607859>,
      < 3.010870, 0.475408, 2.569852>,
      < 2.741663, 0.445995, 2.581111>
    }
    triangle {
      < 2.560904, 0.362517, 2.620014>,
      < 2.748731, 0.403968, 2.607859>,
      < 2.741663, 0.445995, 2.581111>
    }
    triangle {
      < 2.560904, 0.362517, 2.620014>,
      < 2.741663, 0.445995, 2.581111>,
      < 2.550806, 0.402855, 2.590981>
    }
    triangle {
      < 2.560904, 0.362517, 2.620014>,
      < 2.550806, 0.402855, 2.590981>,
      < 2.514148, 0.378683, 2.591621>
    }
    triangle {
      < 2.560904, 0.362517, 2.620014>,
      < 2.514148, 0.378683, 2.591621>,
      < 2.526680, 0.347239, 2.621296>
    }
    triangle {
      < 3.010870, 0.475408, 2.569852>,
      < 3.009872, 0.502667, 2.534627>,
      < 2.741663, 0.471711, 2.543222>
    }
    triangle {
      < 3.010870, 0.475408, 2.569852>,
      < 2.741663, 0.471711, 2.543222>,
      < 2.741663, 0.445995, 2.581111>
    }
    triangle {
      < 3.009872, 0.502667, 2.534627>,
      < 3.007305, 0.518574, 2.460711>,
      < 2.741663, 0.489858, 2.463518>
    }
    triangle {
      < 3.009872, 0.502667, 2.534627>,
      < 2.741663, 0.489858, 2.463518>,
      < 2.741663, 0.471711, 2.543222>
    }
    triangle {
      < 3.007305, 0.518574, 2.460711>,
      < 3.004172, 0.497903, 2.405437>,
      < 2.741663, 0.469345, 2.404651>
    }
    triangle {
      < 3.007305, 0.518574, 2.460711>,
      < 2.741663, 0.469345, 2.404651>,
      < 2.741663, 0.489858, 2.463518>
    }
    triangle {
      < 3.004172, 0.497903, 2.405437>,
      < 3.003972, 0.446481, 2.364837>,
      < 2.741663, 0.429941, 2.365067>
    }
    triangle {
      < 3.004172, 0.497903, 2.405437>,
      < 2.741663, 0.429941, 2.365067>,
      < 2.741663, 0.469345, 2.404651>
    }
    triangle {
      < 3.003972, 0.446481, 2.364837>,
      < 3.005907, 0.147293, 2.369739>,
      < 2.741663, 0.104686, 2.369974>
    }
    triangle {
      < 3.003972, 0.446481, 2.364837>,
      < 2.741663, 0.104686, 2.369974>,
      < 2.741663, 0.429941, 2.365067>
    }
    triangle {
      < 2.467705, 0.287114, 2.652975>,
      < 2.460616, 0.288251, 2.684928>,
      < 2.489098, 0.300401, 2.682310>
    }
    triangle {
      < 2.467705, 0.287114, 2.652975>,
      < 2.489098, 0.300401, 2.682310>,
      < 2.491296, 0.312285, 2.649947>
    }
    triangle {
      < 2.468724, 0.301969, 2.633654>,
      < 2.467705, 0.287114, 2.652975>,
      < 2.491296, 0.312285, 2.649947>
    }
    triangle {
      < 2.468724, 0.301969, 2.633654>,
      < 2.491296, 0.312285, 2.649947>,
      < 2.495954, 0.327057, 2.625640>
    }
    triangle {
      < 2.460616, 0.316862, 2.600444>,
      < 2.468724, 0.301969, 2.633654>,
      < 2.495954, 0.327057, 2.625640>
    }
    triangle {
      < 2.460616, 0.316862, 2.600444>,
      < 2.495954, 0.327057, 2.625640>,
      < 2.482818, 0.350019, 2.594634>
    }
    triangle {
      < 2.460616, 0.325664, 2.551812>,
      < 2.460616, 0.316862, 2.600444>,
      < 2.482818, 0.350019, 2.594634>
    }
    triangle {
      < 2.460616, 0.325664, 2.551812>,
      < 2.482818, 0.350019, 2.594634>,
      < 2.474690, 0.377990, 2.550191>
    }
    triangle {
      < 2.460616, 0.310771, 2.455012>,
      < 2.460616, 0.325664, 2.551812>,
      < 2.474690, 0.377990, 2.550191>
    }
    triangle {
      < 2.460616, 0.310771, 2.455012>,
      < 2.474690, 0.377990, 2.550191>,
      < 2.473377, 0.373009, 2.456596>
    }
    triangle {
      < 2.460616, 0.270206, 2.401771>,
      < 2.460616, 0.310771, 2.455012>,
      < 2.473377, 0.373009, 2.456596>
    }
    triangle {
      < 2.460616, 0.270206, 2.401771>,
      < 2.473377, 0.373009, 2.456596>,
      < 2.472240, 0.337269, 2.396533>
    }
    triangle {
      < 2.460616, 0.216943, 2.375371>,
      < 2.460616, 0.270206, 2.401771>,
      < 2.472240, 0.337269, 2.396533>
    }
    triangle {
      < 2.460616, 0.216943, 2.375371>,
      < 2.472240, 0.337269, 2.396533>,
      < 2.489942, 0.302583, 2.378918>
    }
    triangle {
      < 2.460616, 0.074454, 2.380452>,
      < 2.460616, 0.216943, 2.375371>,
      < 2.489942, 0.302583, 2.378918>
    }
    triangle {
      < 2.460616, 0.074454, 2.380452>,
      < 2.489942, 0.302583, 2.378918>,
      < 2.487343, 0.073735, 2.377019>
    }
    triangle {
      < 2.516668, 0.369361, 2.375542>,
      < 2.514071, 0.073017, 2.373586>,
      < 2.487343, 0.073735, 2.377019>
    }
    triangle {
      < 2.516668, 0.369361, 2.375542>,
      < 2.487343, 0.073735, 2.377019>,
      < 2.489942, 0.302583, 2.378918>
    }
    triangle {
      < 2.500342, 0.396514, 2.397297>,
      < 2.516668, 0.369361, 2.375542>,
      < 2.489942, 0.302583, 2.378918>
    }
    triangle {
      < 2.500342, 0.396514, 2.397297>,
      < 2.489942, 0.302583, 2.378918>,
      < 2.472240, 0.337269, 2.396533>
    }
    triangle {
      < 2.502712, 0.425749, 2.460111>,
      < 2.500342, 0.396514, 2.397297>,
      < 2.472240, 0.337269, 2.396533>
    }
    triangle {
      < 2.502712, 0.425749, 2.460111>,
      < 2.472240, 0.337269, 2.396533>,
      < 2.473377, 0.373009, 2.456596>
    }
    triangle {
      < 2.504147, 0.419260, 2.549422>,
      < 2.502712, 0.425749, 2.460111>,
      < 2.473377, 0.373009, 2.456596>
    }
    triangle {
      < 2.504147, 0.419260, 2.549422>,
      < 2.473377, 0.373009, 2.456596>,
      < 2.474690, 0.377990, 2.550191>
    }
    triangle {
      < 2.514148, 0.378683, 2.591621>,
      < 2.504147, 0.419260, 2.549422>,
      < 2.474690, 0.377990, 2.550191>
    }
    triangle {
      < 2.514148, 0.378683, 2.591621>,
      < 2.474690, 0.377990, 2.550191>,
      < 2.482818, 0.350019, 2.594634>
    }
    triangle {
      < 2.526680, 0.347239, 2.621296>,
      < 2.514148, 0.378683, 2.591621>,
      < 2.482818, 0.350019, 2.594634>
    }
    triangle {
      < 2.526680, 0.347239, 2.621296>,
      < 2.482818, 0.350019, 2.594634>,
      < 2.495954, 0.327057, 2.625640>
    }
    triangle {
      < 2.519179, 0.330571, 2.647243>,
      < 2.526680, 0.347239, 2.621296>,
      < 2.495954, 0.327057, 2.625640>
    }
    triangle {
      < 2.519179, 0.330571, 2.647243>,
      < 2.495954, 0.327057, 2.625640>,
      < 2.491296, 0.312285, 2.649947>
    }
    triangle {
      < 2.517581, 0.312552, 2.679691>,
      < 2.519179, 0.330571, 2.647243>,
      < 2.491296, 0.312285, 2.649947>
    }
    triangle {
      < 2.517581, 0.312552, 2.679691>,
      < 2.491296, 0.312285, 2.649947>,
      < 2.489098, 0.300401, 2.682310>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.468724, 0.301969, 2.633654>,
      < 2.460616, 0.316862, 2.600444>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.467705, 0.287114, 2.652975>,
      < 2.468724, 0.301969, 2.633654>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.460616, 0.288251, 2.684928>,
      < 2.467705, 0.287114, 2.652975>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.460616, 0.074454, 2.380452>,
      < 2.460616, 0.288251, 2.684928>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.460616, 0.216943, 2.375371>,
      < 2.460616, 0.074454, 2.380452>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.460616, 0.270206, 2.401771>,
      < 2.460616, 0.216943, 2.375371>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.460616, 0.310771, 2.455012>,
      < 2.460616, 0.270206, 2.401771>
    }
    triangle {
      < 2.462304, 0.265804, 2.526269>,
      < 2.460616, 0.325664, 2.551812>,
      < 2.460616, 0.310771, 2.455012>
    }
    triangle {
      < 5.484661, 0.611664, 0.000000>,
      < 5.435663, 0.594303, -1.148942>,
      < 5.385889, 0.605628, -1.166630>
    }
    triangle {
      < 5.484661, 0.611664, 0.000000>,
      < 5.385889, 0.605628, -1.166630>,
      < 5.434242, 0.622224, 0.000000>
    }
    triangle {
      < 4.404754, 0.660973, 0.000000>,
      < 5.484661, 0.611664, 0.000000>,
      < 5.434242, 0.622224, 0.000000>
    }
    triangle {
      < 4.404754, 0.660973, 0.000000>,
      < 5.434242, 0.622224, 0.000000>,
      < 5.385342, 0.657458, 0.000000>
    }
    triangle {
      < 4.404754, 0.660973, 0.000000>,
      < 5.385342, 0.657458, 0.000000>,
      < 5.331141, 0.702180, 0.000000>
    }
    triangle {
      < 4.404754, 0.660973, 0.000000>,
      < 5.331141, 0.702180, 0.000000>,
      < 5.256576, 0.737194, 0.000000>
    }
    triangle {
      < 4.404754, 0.660973, 0.000000>,
      < 5.256576, 0.737194, 0.000000>,
      < 5.064101, 0.764874, 0.000000>
    }
    triangle {
      < 4.404754, 0.660973, 0.000000>,
      < 5.064101, 0.764874, 0.000000>,
      < 4.718122, 0.742822, 0.000000>
    }
    triangle {
      < 4.404754, 0.660973, 0.000000>,
      < 4.718122, 0.742822, 0.000000>,
      < 4.432414, 0.693152, 0.000000>
    }
    triangle {
      < 4.392016, 0.617258, -1.175757>,
      < 4.404754, 0.660973, 0.000000>,
      < 4.432414, 0.693152, 0.000000>
    }
    triangle {
      < 4.392016, 0.617258, -1.175757>,
      < 4.432414, 0.693152, 0.000000>,
      < 4.418221, 0.650336, -1.195427>
    }
    triangle {
      < 4.401617, 0.573519, -1.900152>,
      < 4.392016, 0.617258, -1.175757>,
      < 4.418221, 0.650336, -1.195427>
    }
    triangle {
      < 4.401617, 0.573519, -1.900152>,
      < 4.418221, 0.650336, -1.195427>,
      < 4.428919, 0.607497, -1.904914>
    }
    triangle {
      < 4.398887, 0.558645, -2.058646>,
      < 4.401617, 0.573519, -1.900152>,
      < 4.428919, 0.607497, -1.904914>
    }
    triangle {
      < 4.398887, 0.558645, -2.058646>,
      < 4.428919, 0.607497, -1.904914>,
      < 4.424780, 0.592930, -2.060147>
    }
    triangle {
      < 4.389600, 0.525768, -2.318152>,
      < 4.398887, 0.558645, -2.058646>,
      < 4.424780, 0.592930, -2.060147>
    }
    triangle {
      < 4.389600, 0.525768, -2.318152>,
      < 4.424780, 0.592930, -2.060147>,
      < 4.418779, 0.560729, -2.314312>
    }
    triangle {
      < 4.228822, 0.489205, -2.351752>,
      < 4.389600, 0.525768, -2.318152>,
      < 4.418779, 0.560729, -2.314312>
    }
    triangle {
      < 4.228822, 0.489205, -2.351752>,
      < 4.418779, 0.560729, -2.314312>,
      < 4.221811, 0.524919, -2.347221>
    }
    triangle {
      < 4.027549, 0.303414, -2.357771>,
      < 4.228822, 0.489205, -2.351752>,
      < 4.221811, 0.524919, -2.347221>
    }
    triangle {
      < 4.027549, 0.303414, -2.357771>,
      < 4.221811, 0.524919, -2.347221>,
      < 3.620496, 0.449908, -2.364905>
    }
    triangle {
      < 4.027549, 0.303414, -2.357771>,
      < 3.620496, 0.449908, -2.364905>,
      < 3.625001, 0.162232, -2.369808>
    }
    triangle {
      < 4.027549, 0.303414, -2.357771>,
      < 3.625001, 0.162232, -2.369808>,
      < 3.826275, 0.194423, -2.363789>
    }
    triangle {
      < 3.005907, 0.147293, -2.369739>,
      < 3.625001, 0.162232, -2.369808>,
      < 3.620496, 0.449908, -2.364905>
    }
    triangle {
      < 3.005907, 0.147293, -2.369739>,
      < 3.620496, 0.449908, -2.364905>,
      < 3.003972, 0.446481, -2.364837>
    }
    triangle {
      < 2.540798, 0.072298, -2.370153>,
      < 2.741663, 0.104686, -2.369974>,
      < 2.741663, 0.429941, -2.365067>
    }
    triangle {
      < 2.540798, 0.072298, -2.370153>,
      < 2.741663, 0.429941, -2.365067>,
      < 2.545230, 0.389126, -2.372676>
    }
    triangle {
      < 2.745803, 0.369686, -2.664615>,
      < 2.546063, 0.324703, -2.677072>,
      < 2.551353, 0.341970, -2.644864>
    }
    triangle {
      < 2.745803, 0.369686, -2.664615>,
      < 2.551353, 0.341970, -2.644864>,
      < 2.747468, 0.385772, -2.632364>
    }
    triangle {
      < 3.013547, 0.399663, -2.652796>,
      < 2.745803, 0.369686, -2.664615>,
      < 2.747468, 0.385772, -2.632364>
    }
    triangle {
      < 3.013547, 0.399663, -2.652796>,
      < 2.747468, 0.385772, -2.632364>,
      < 3.012384, 0.414965, -2.620832>
    }
    triangle {
      < 3.618461, 0.419610, -2.634592>,
      < 3.013547, 0.399663, -2.652796>,
      < 3.012384, 0.414965, -2.620832>
    }
    triangle {
      < 3.618461, 0.419610, -2.634592>,
      < 3.012384, 0.414965, -2.620832>,
      < 3.613985, 0.434661, -2.602803>
    }
    triangle {
      < 4.278938, 0.429553, -2.620985>,
      < 3.618461, 0.419610, -2.634592>,
      < 3.613985, 0.434661, -2.602803>
    }
    triangle {
      < 4.278938, 0.429553, -2.620985>,
      < 3.613985, 0.434661, -2.602803>,
      < 4.270647, 0.444412, -2.589442>
    }
    triangle {
      < 4.633741, 0.426260, -2.557898>,
      < 4.278938, 0.429553, -2.620985>,
      < 4.270647, 0.444412, -2.589442>
    }
    triangle {
      < 4.633741, 0.426260, -2.557898>,
      < 4.270647, 0.444412, -2.589442>,
      < 4.622761, 0.450151, -2.523951>
    }
    triangle {
      < 4.812309, 0.452697, -2.525539>,
      < 4.633741, 0.426260, -2.557898>,
      < 4.622761, 0.450151, -2.523951>
    }
    triangle {
      < 4.812309, 0.452697, -2.525539>,
      < 4.622761, 0.450151, -2.523951>,
      < 4.785600, 0.475304, -2.493907>
    }
    triangle {
      < 5.027698, 0.491304, -2.367082>,
      < 4.812309, 0.452697, -2.525539>,
      < 4.785600, 0.475304, -2.493907>
    }
    triangle {
      < 5.027698, 0.491304, -2.367082>,
      < 4.785600, 0.475304, -2.493907>,
      < 4.989048, 0.510983, -2.344278>
    }
    triangle {
      < 5.203112, 0.518845, -2.137795>,
      < 5.027698, 0.491304, -2.367082>,
      < 4.989048, 0.510983, -2.344278>
    }
    triangle {
      < 5.203112, 0.518845, -2.137795>,
      < 4.989048, 0.510983, -2.344278>,
      < 5.158484, 0.534896, -2.125506>
    }
    triangle {
      < 5.336588, 0.556670, -1.801338>,
      < 5.203112, 0.518845, -2.137795>,
      < 5.158484, 0.534896, -2.125506>
    }
    triangle {
      < 5.336588, 0.556670, -1.801338>,
      < 5.158484, 0.534896, -2.125506>,
      < 5.288443, 0.570033, -1.801380>
    }
    triangle {
      < 5.435663, 0.594303, -1.148942>,
      < 5.336588, 0.556670, -1.801338>,
      < 5.288443, 0.570033, -1.801380>
    }
    triangle {
      < 5.435663, 0.594303, -1.148942>,
      < 5.288443, 0.570033, -1.801380>,
      < 5.385889, 0.605628, -1.166630>
    }
    triangle {
      < 3.621246, 0.521366, -2.405981>,
      < 4.223581, 0.566358, -2.385487>,
      < 4.239403, 0.570685, -2.435800>
    }
    triangle {
      < 3.621246, 0.521366, -2.405981>,
      < 4.239403, 0.570685, -2.435800>,
      < 3.618905, 0.542040, -2.455939>
    }
    triangle {
      < 5.026673, 0.725213, -1.186033>,
      < 4.987030, 0.677147, -1.870296>,
      < 4.704282, 0.659491, -1.897840>
    }
    triangle {
      < 5.026673, 0.725213, -1.186033>,
      < 4.704282, 0.659491, -1.897840>,
      < 4.701459, 0.701893, -1.193508>
    }
    triangle {
      < 5.385889, 0.605628, -1.166630>,
      < 5.288443, 0.570033, -1.801380>,
      < 5.244813, 0.603248, -1.813822>
    }
    triangle {
      < 5.385889, 0.605628, -1.166630>,
      < 5.244813, 0.603248, -1.813822>,
      < 5.338792, 0.639450, -1.167928>
    }
    triangle {
      < 5.288443, 0.570033, -1.801380>,
      < 5.158484, 0.534896, -2.125506>,
      < 5.117917, 0.568415, -2.124657>
    }
    triangle {
      < 5.288443, 0.570033, -1.801380>,
      < 5.117917, 0.568415, -2.124657>,
      < 5.244813, 0.603248, -1.813822>
    }
    triangle {
      < 5.158484, 0.534896, -2.125506>,
      < 4.989048, 0.510983, -2.344278>,
      < 4.958674, 0.544603, -2.334138>
    }
    triangle {
      < 5.158484, 0.534896, -2.125506>,
      < 4.958674, 0.544603, -2.334138>,
      < 5.117917, 0.568415, -2.124657>
    }
    triangle {
      < 4.989048, 0.510983, -2.344278>,
      < 4.785600, 0.475304, -2.493907>,
      < 4.787219, 0.505571, -2.464559>
    }
    triangle {
      < 4.989048, 0.510983, -2.344278>,
      < 4.787219, 0.505571, -2.464559>,
      < 4.958674, 0.544603, -2.334138>
    }
    triangle {
      < 4.785600, 0.475304, -2.493907>,
      < 4.622761, 0.450151, -2.523951>,
      < 4.618881, 0.477340, -2.506838>
    }
    triangle {
      < 4.785600, 0.475304, -2.493907>,
      < 4.618881, 0.477340, -2.506838>,
      < 4.787219, 0.505571, -2.464559>
    }
    triangle {
      < 4.622761, 0.450151, -2.523951>,
      < 4.270647, 0.444412, -2.589442>,
      < 4.268123, 0.465431, -2.563106>
    }
    triangle {
      < 4.622761, 0.450151, -2.523951>,
      < 4.268123, 0.465431, -2.563106>,
      < 4.618881, 0.477340, -2.506838>
    }
    triangle {
      < 4.270647, 0.444412, -2.589442>,
      < 3.613985, 0.434661, -2.602803>,
      < 3.613815, 0.452417, -2.578444>
    }
    triangle {
      < 4.270647, 0.444412, -2.589442>,
      < 3.613815, 0.452417, -2.578444>,
      < 4.268123, 0.465431, -2.563106>
    }
    triangle {
      < 3.613985, 0.434661, -2.602803>,
      < 3.012384, 0.414965, -2.620832>,
      < 3.012785, 0.432675, -2.596567>
    }
    triangle {
      < 3.613985, 0.434661, -2.602803>,
      < 3.012785, 0.432675, -2.596567>,
      < 3.613815, 0.452417, -2.578444>
    }
    triangle {
      < 3.012384, 0.414965, -2.620832>,
      < 2.747468, 0.385772, -2.632364>,
      < 2.748731, 0.403968, -2.607859>
    }
    triangle {
      < 3.012384, 0.414965, -2.620832>,
      < 2.748731, 0.403968, -2.607859>,
      < 3.012785, 0.432675, -2.596567>
    }
    triangle {
      < 2.747468, 0.385772, -2.632364>,
      < 2.551353, 0.341970, -2.644864>,
      < 2.560904, 0.362517, -2.620014>
    }
    triangle {
      < 2.747468, 0.385772, -2.632364>,
      < 2.560904, 0.362517, -2.620014>,
      < 2.748731, 0.403968, -2.607859>
    }
    triangle {
      < 2.545230, 0.389126, -2.372676>,
      < 2.741663, 0.429941, -2.365067>,
      < 2.741663, 0.469345, -2.404651>
    }
    triangle {
      < 2.545230, 0.389126, -2.372676>,
      < 2.741663, 0.469345, -2.404651>,
      < 2.548000, 0.442103, -2.406947>
    }
    triangle {
      < 3.003972, 0.446481, -2.364837>,
      < 3.620496, 0.449908, -2.364905>,
      < 3.621246, 0.521366, -2.405981>
    }
    triangle {
      < 3.003972, 0.446481, -2.364837>,
      < 3.621246, 0.521366, -2.405981>,
      < 3.004172, 0.497903, -2.405437>
    }
    triangle {
      < 3.620496, 0.449908, -2.364905>,
      < 4.221811, 0.524919, -2.347221>,
      < 4.223581, 0.566358, -2.385487>
    }
    triangle {
      < 3.620496, 0.449908, -2.364905>,
      < 4.223581, 0.566358, -2.385487>,
      < 3.621246, 0.521366, -2.405981>
    }
    triangle {
      < 4.221811, 0.524919, -2.347221>,
      < 4.418779, 0.560729, -2.314312>,
      < 4.672771, 0.611462, -2.344215>
    }
    triangle {
      < 4.221811, 0.524919, -2.347221>,
      < 4.672771, 0.611462, -2.344215>,
      < 4.223581, 0.566358, -2.385487>
    }
    triangle {
      < 4.418779, 0.560729, -2.314312>,
      < 4.424780, 0.592930, -2.060147>,
      < 4.691594, 0.643280, -2.065812>
    }
    triangle {
      < 4.418779, 0.560729, -2.314312>,
      < 4.691594, 0.643280, -2.065812>,
      < 4.672771, 0.611462, -2.344215>
    }
    triangle {
      < 4.424780, 0.592930, -2.060147>,
      < 4.428919, 0.607497, -1.904914>,
      < 4.704282, 0.659491, -1.897840>
    }
    triangle {
      < 4.424780, 0.592930, -2.060147>,
      < 4.704282, 0.659491, -1.897840>,
      < 4.691594, 0.643280, -2.065812>
    }
    triangle {
      < 4.428919, 0.607497, -1.904914>,
      < 4.418221, 0.650336, -1.195427>,
      < 4.701459, 0.701893, -1.193508>
    }
    triangle {
      < 4.428919, 0.607497, -1.904914>,
      < 4.701459, 0.701893, -1.193508>,
      < 4.704282, 0.659491, -1.897840>
    }
    triangle {
      < 4.418221, 0.650336, -1.195427>,
      < 4.432414, 0.693152, 0.000000>,
      < 4.718122, 0.742822, 0.000000>
    }
    triangle {
      < 4.418221, 0.650336, -1.195427>,
      < 4.718122, 0.742822, 0.000000>,
      < 4.701459, 0.701893, -1.193508>
    }
    triangle {
      < 5.434242, 0.622224, 0.000000>,
      < 5.385889, 0.605628, -1.166630>,
      < 5.338792, 0.639450, -1.167928>
    }
    triangle {
      < 5.434242, 0.622224, 0.000000>,
      < 5.338792, 0.639450, -1.167928>,
      < 5.385342, 0.657458, 0.000000>
    }
    triangle {
      < 5.214001, 0.708682, -1.178558>,
      < 5.256576, 0.737194, 0.000000>,
      < 5.331141, 0.702180, 0.000000>
    }
    triangle {
      < 5.214001, 0.708682, -1.178558>,
      < 5.331141, 0.702180, 0.000000>,
      < 5.285878, 0.680465, -1.172548>
    }
    triangle {
      < 4.916988, 0.650447, -2.087875>,
      < 4.823652, 0.614626, -2.331454>,
      < 4.672771, 0.611462, -2.344215>
    }
    triangle {
      < 4.916988, 0.650447, -2.087875>,
      < 4.672771, 0.611462, -2.344215>,
      < 4.691594, 0.643280, -2.065812>
    }
    triangle {
      < 4.987030, 0.677147, -1.870296>,
      < 4.916988, 0.650447, -2.087875>,
      < 4.691594, 0.643280, -2.065812>
    }
    triangle {
      < 4.987030, 0.677147, -1.870296>,
      < 4.691594, 0.643280, -2.065812>,
      < 4.704282, 0.659491, -1.897840>
    }
    triangle {
      < 4.740355, 0.605217, -2.376164>,
      < 4.656408, 0.597022, -2.391192>,
      < 4.672771, 0.611462, -2.344215>
    }
    triangle {
      < 4.656408, 0.597022, -2.391192>,
      < 4.239403, 0.570685, -2.435800>,
      < 4.223581, 0.566358, -2.385487>
    }
    triangle {
      < 4.656408, 0.597022, -2.391192>,
      < 4.223581, 0.566358, -2.385487>,
      < 4.672771, 0.611462, -2.344215>
    }
    triangle {
      < 3.618905, 0.542040, -2.455939>,
      < 3.007305, 0.518574, -2.460711>,
      < 3.004172, 0.497903, -2.405437>
    }
    triangle {
      < 3.618905, 0.542040, -2.455939>,
      < 3.004172, 0.497903, -2.405437>,
      < 3.621246, 0.521366, -2.405981>
    }
    triangle {
      < 2.741663, 0.489858, -2.463518>,
      < 2.552408, 0.460174, -2.465842>,
      < 2.548000, 0.442103, -2.406947>
    }
    triangle {
      < 2.741663, 0.489858, -2.463518>,
      < 2.548000, 0.442103, -2.406947>,
      < 2.741663, 0.469345, -2.404651>
    }
    triangle {
      < 5.144625, 0.666302, -1.842752>,
      < 5.214001, 0.708682, -1.178558>,
      < 5.285878, 0.680465, -1.172548>
    }
    triangle {
      < 5.144625, 0.666302, -1.842752>,
      < 5.285878, 0.680465, -1.172548>,
      < 5.205453, 0.643570, -1.806886>
    }
    triangle {
      < 5.043014, 0.634781, -2.109938>,
      < 5.144625, 0.666302, -1.842752>,
      < 5.205453, 0.643570, -1.806886>
    }
    triangle {
      < 5.043014, 0.634781, -2.109938>,
      < 5.205453, 0.643570, -1.806886>,
      < 5.089981, 0.609728, -2.113854>
    }
    triangle {
      < 4.906283, 0.596543, -2.339461>,
      < 5.043014, 0.634781, -2.109938>,
      < 5.089981, 0.609728, -2.113854>
    }
    triangle {
      < 4.906283, 0.596543, -2.339461>,
      < 5.089981, 0.609728, -2.113854>,
      < 4.941820, 0.581944, -2.331707>
    }
    triangle {
      < 4.795737, 0.568216, -2.413139>,
      < 4.790792, 0.538795, -2.438505>,
      < 4.613291, 0.510517, -2.493807>
    }
    triangle {
      < 4.795737, 0.568216, -2.413139>,
      < 4.613291, 0.510517, -2.493807>,
      < 4.639228, 0.546976, -2.457393>
    }
    triangle {
      < 4.254616, 0.548587, -2.507485>,
      < 4.639228, 0.546976, -2.457393>,
      < 4.613291, 0.510517, -2.493807>
    }
    triangle {
      < 4.254616, 0.548587, -2.507485>,
      < 4.613291, 0.510517, -2.493807>,
      < 4.262087, 0.513910, -2.538564>
    }
    triangle {
      < 3.616533, 0.516730, -2.522926>,
      < 4.254616, 0.548587, -2.507485>,
      < 4.262087, 0.513910, -2.538564>
    }
    triangle {
      < 3.616533, 0.516730, -2.522926>,
      < 4.262087, 0.513910, -2.538564>,
      < 3.614235, 0.493614, -2.553829>
    }
    triangle {
      < 3.009872, 0.502667, -2.534627>,
      < 3.616533, 0.516730, -2.522926>,
      < 3.614235, 0.493614, -2.553829>
    }
    triangle {
      < 3.009872, 0.502667, -2.534627>,
      < 3.614235, 0.493614, -2.553829>,
      < 3.010870, 0.475408, -2.569852>
    }
    triangle {
      < 2.551643, 0.441419, -2.544901>,
      < 2.741663, 0.471711, -2.543222>,
      < 2.741663, 0.445995, -2.581111>
    }
    triangle {
      < 2.551643, 0.441419, -2.544901>,
      < 2.741663, 0.445995, -2.581111>,
      < 2.550806, 0.402855, -2.590981>
    }
    triangle {
      < 2.741663, 0.471711, -2.543222>,
      < 2.551643, 0.441419, -2.544901>,
      < 2.552408, 0.460174, -2.465842>
    }
    triangle {
      < 2.741663, 0.471711, -2.543222>,
      < 2.552408, 0.460174, -2.465842>,
      < 2.741663, 0.489858, -2.463518>
    }
    triangle {
      < 3.616533, 0.516730, -2.522926>,
      < 3.009872, 0.502667, -2.534627>,
      < 3.007305, 0.518574, -2.460711>
    }
    triangle {
      < 3.616533, 0.516730, -2.522926>,
      < 3.007305, 0.518574, -2.460711>,
      < 3.618905, 0.542040, -2.455939>
    }
    triangle {
      < 4.254616, 0.548587, -2.507485>,
      < 3.616533, 0.516730, -2.522926>,
      < 3.618905, 0.542040, -2.455939>
    }
    triangle {
      < 4.254616, 0.548587, -2.507485>,
      < 3.618905, 0.542040, -2.455939>,
      < 4.239403, 0.570685, -2.435800>
    }
    triangle {
      < 4.639228, 0.546976, -2.457393>,
      < 4.254616, 0.548587, -2.507485>,
      < 4.239403, 0.570685, -2.435800>
    }
    triangle {
      < 4.639228, 0.546976, -2.457393>,
      < 4.239403, 0.570685, -2.435800>,
      < 4.656408, 0.597022, -2.391192>
    }
    triangle {
      < 4.740355, 0.605217, -2.376164>,
      < 4.795737, 0.568216, -2.413139>,
      < 4.639228, 0.546976, -2.457393>
    }
    triangle {
      < 4.740355, 0.605217, -2.376164>,
      < 4.639228, 0.546976, -2.457393>,
      < 4.656408, 0.597022, -2.391192>
    }
    triangle {
      < 5.043014, 0.634781, -2.109938>,
      < 4.906283, 0.596543, -2.339461>,
      < 4.823652, 0.614626, -2.331454>
    }
    triangle {
      < 5.043014, 0.634781, -2.109938>,
      < 4.823652, 0.614626, -2.331454>,
      < 4.916988, 0.650447, -2.087875>
    }
    triangle {
      < 5.144625, 0.666302, -1.842752>,
      < 5.043014, 0.634781, -2.109938>,
      < 4.916988, 0.650447, -2.087875>
    }
    triangle {
      < 5.144625, 0.666302, -1.842752>,
      < 4.916988, 0.650447, -2.087875>,
      < 4.987030, 0.677147, -1.870296>
    }
    triangle {
      < 5.214001, 0.708682, -1.178558>,
      < 5.144625, 0.666302, -1.842752>,
      < 4.987030, 0.677147, -1.870296>
    }
    triangle {
      < 5.214001, 0.708682, -1.178558>,
      < 4.987030, 0.677147, -1.870296>,
      < 5.026673, 0.725213, -1.186033>
    }
    triangle {
      < 5.064101, 0.764874, 0.000000>,
      < 5.026673, 0.725213, -1.186033>,
      < 4.701459, 0.701893, -1.193508>
    }
    triangle {
      < 5.064101, 0.764874, 0.000000>,
      < 4.701459, 0.701893, -1.193508>,
      < 4.718122, 0.742822, 0.000000>
    }
    triangle {
      < 5.026673, 0.725213, -1.186033>,
      < 5.064101, 0.764874, 0.000000>,
      < 5.256576, 0.737194, 0.000000>
    }
    triangle {
      < 5.026673, 0.725213, -1.186033>,
      < 5.256576, 0.737194, 0.000000>,
      < 5.214001, 0.708682, -1.178558>
    }
    triangle {
      < 4.740355, 0.605217, -2.376164>,
      < 4.672771, 0.611462, -2.344215>,
      < 4.823652, 0.614626, -2.331454>
    }
    triangle {
      < 4.795737, 0.568216, -2.413139>,
      < 4.740355, 0.605217, -2.376164>,
      < 4.823652, 0.614626, -2.331454>
    }
    triangle {
      < 4.795737, 0.568216, -2.413139>,
      < 4.823652, 0.614626, -2.331454>,
      < 4.906283, 0.596543, -2.339461>
    }
    triangle {
      < 4.790792, 0.538795, -2.438505>,
      < 4.795737, 0.568216, -2.413139>,
      < 4.906283, 0.596543, -2.339461>
    }
    triangle {
      < 4.790792, 0.538795, -2.438505>,
      < 4.906283, 0.596543, -2.339461>,
      < 4.941820, 0.581944, -2.331707>
    }
    triangle {
      < 2.504147, 0.419260, -2.549422>,
      < 2.502712, 0.425749, -2.460111>,
      < 2.552408, 0.460174, -2.465842>
    }
    triangle {
      < 2.504147, 0.419260, -2.549422>,
      < 2.552408, 0.460174, -2.465842>,
      < 2.551643, 0.441419, -2.544901>
    }
    triangle {
      < 2.514148, 0.378683, -2.591621>,
      < 2.504147, 0.419260, -2.549422>,
      < 2.551643, 0.441419, -2.544901>
    }
    triangle {
      < 2.514148, 0.378683, -2.591621>,
      < 2.551643, 0.441419, -2.544901>,
      < 2.550806, 0.402855, -2.590981>
    }
    triangle {
      < 2.502712, 0.425749, -2.460111>,
      < 2.500342, 0.396514, -2.397297>,
      < 2.548000, 0.442103, -2.406947>
    }
    triangle {
      < 2.502712, 0.425749, -2.460111>,
      < 2.548000, 0.442103, -2.406947>,
      < 2.552408, 0.460174, -2.465842>
    }
    triangle {
      < 2.500342, 0.396514, -2.397297>,
      < 2.516668, 0.369361, -2.375542>,
      < 2.545230, 0.389126, -2.372676>
    }
    triangle {
      < 2.500342, 0.396514, -2.397297>,
      < 2.545230, 0.389126, -2.372676>,
      < 2.548000, 0.442103, -2.406947>
    }
    triangle {
      < 2.519179, 0.330571, -2.647243>,
      < 2.526680, 0.347239, -2.621296>,
      < 2.560904, 0.362517, -2.620014>
    }
    triangle {
      < 2.519179, 0.330571, -2.647243>,
      < 2.560904, 0.362517, -2.620014>,
      < 2.551353, 0.341970, -2.644864>
    }
    triangle {
      < 2.517581, 0.312552, -2.679691>,
      < 2.519179, 0.330571, -2.647243>,
      < 2.551353, 0.341970, -2.644864>
    }
    triangle {
      < 2.517581, 0.312552, -2.679691>,
      < 2.551353, 0.341970, -2.644864>,
      < 2.546063, 0.324703, -2.677072>
    }
    triangle {
      < 2.516668, 0.369361, -2.375542>,
      < 2.514071, 0.073017, -2.373586>,
      < 2.540798, 0.072298, -2.370153>
    }
    triangle {
      < 2.516668, 0.369361, -2.375542>,
      < 2.540798, 0.072298, -2.370153>,
      < 2.545230, 0.389126, -2.372676>
    }
    triangle {
      < 2.460616, 0.325664, -2.551812>,
      < 2.460616, 0.316862, -2.600444>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 5.285878, 0.680465, -1.172548>,
      < 5.331141, 0.702180, 0.000000>,
      < 5.385342, 0.657458, 0.000000>
    }
    triangle {
      < 5.285878, 0.680465, -1.172548>,
      < 5.385342, 0.657458, 0.000000>,
      < 5.338792, 0.639450, -1.167928>
    }
    triangle {
      < 5.205453, 0.643570, -1.806886>,
      < 5.285878, 0.680465, -1.172548>,
      < 5.338792, 0.639450, -1.167928>
    }
    triangle {
      < 5.205453, 0.643570, -1.806886>,
      < 5.338792, 0.639450, -1.167928>,
      < 5.244813, 0.603248, -1.813822>
    }
    triangle {
      < 5.089981, 0.609728, -2.113854>,
      < 5.205453, 0.643570, -1.806886>,
      < 5.244813, 0.603248, -1.813822>
    }
    triangle {
      < 5.089981, 0.609728, -2.113854>,
      < 5.244813, 0.603248, -1.813822>,
      < 5.117917, 0.568415, -2.124657>
    }
    triangle {
      < 4.941820, 0.581944, -2.331707>,
      < 5.089981, 0.609728, -2.113854>,
      < 5.117917, 0.568415, -2.124657>
    }
    triangle {
      < 4.941820, 0.581944, -2.331707>,
      < 5.117917, 0.568415, -2.124657>,
      < 4.958674, 0.544603, -2.334138>
    }
    triangle {
      < 4.790792, 0.538795, -2.438505>,
      < 4.941820, 0.581944, -2.331707>,
      < 4.958674, 0.544603, -2.334138>
    }
    triangle {
      < 4.790792, 0.538795, -2.438505>,
      < 4.958674, 0.544603, -2.334138>,
      < 4.787219, 0.505571, -2.464559>
    }
    triangle {
      < 4.613291, 0.510517, -2.493807>,
      < 4.790792, 0.538795, -2.438505>,
      < 4.787219, 0.505571, -2.464559>
    }
    triangle {
      < 4.613291, 0.510517, -2.493807>,
      < 4.787219, 0.505571, -2.464559>,
      < 4.618881, 0.477340, -2.506838>
    }
    triangle {
      < 4.262087, 0.513910, -2.538564>,
      < 4.613291, 0.510517, -2.493807>,
      < 4.618881, 0.477340, -2.506838>
    }
    triangle {
      < 4.262087, 0.513910, -2.538564>,
      < 4.618881, 0.477340, -2.506838>,
      < 4.268123, 0.465431, -2.563106>
    }
    triangle {
      < 3.614235, 0.493614, -2.553829>,
      < 4.262087, 0.513910, -2.538564>,
      < 4.268123, 0.465431, -2.563106>
    }
    triangle {
      < 3.614235, 0.493614, -2.553829>,
      < 4.268123, 0.465431, -2.563106>,
      < 3.613815, 0.452417, -2.578444>
    }
    triangle {
      < 3.010870, 0.475408, -2.569852>,
      < 3.614235, 0.493614, -2.553829>,
      < 3.613815, 0.452417, -2.578444>
    }
    triangle {
      < 3.010870, 0.475408, -2.569852>,
      < 3.613815, 0.452417, -2.578444>,
      < 3.012785, 0.432675, -2.596567>
    }
    triangle {
      < 2.741663, 0.445995, -2.581111>,
      < 3.010870, 0.475408, -2.569852>,
      < 3.012785, 0.432675, -2.596567>
    }
    triangle {
      < 2.741663, 0.445995, -2.581111>,
      < 3.012785, 0.432675, -2.596567>,
      < 2.748731, 0.403968, -2.607859>
    }
    triangle {
      < 2.550806, 0.402855, -2.590981>,
      < 2.741663, 0.445995, -2.581111>,
      < 2.748731, 0.403968, -2.607859>
    }
    triangle {
      < 2.550806, 0.402855, -2.590981>,
      < 2.748731, 0.403968, -2.607859>,
      < 2.560904, 0.362517, -2.620014>
    }
    triangle {
      < 2.526680, 0.347239, -2.621296>,
      < 2.514148, 0.378683, -2.591621>,
      < 2.550806, 0.402855, -2.590981>
    }
    triangle {
      < 2.526680, 0.347239, -2.621296>,
      < 2.550806, 0.402855, -2.590981>,
      < 2.560904, 0.362517, -2.620014>
    }
    triangle {
      < 2.741663, 0.445995, -2.581111>,
      < 2.741663, 0.471711, -2.543222>,
      < 3.009872, 0.502667, -2.534627>
    }
    triangle {
      < 2.741663, 0.445995, -2.581111>,
      < 3.009872, 0.502667, -2.534627>,
      < 3.010870, 0.475408, -2.569852>
    }
    triangle {
      < 2.741663, 0.471711, -2.543222>,
      < 2.741663, 0.489858, -2.463518>,
      < 3.007305, 0.518574, -2.460711>
    }
    triangle {
      < 2.741663, 0.471711, -2.543222>,
      < 3.007305, 0.518574, -2.460711>,
      < 3.009872, 0.502667, -2.534627>
    }
    triangle {
      < 2.741663, 0.489858, -2.463518>,
      < 2.741663, 0.469345, -2.404651>,
      < 3.004172, 0.497903, -2.405437>
    }
    triangle {
      < 2.741663, 0.489858, -2.463518>,
      < 3.004172, 0.497903, -2.405437>,
      < 3.007305, 0.518574, -2.460711>
    }
    triangle {
      < 2.741663, 0.469345, -2.404651>,
      < 2.741663, 0.429941, -2.365067>,
      < 3.003972, 0.446481, -2.364837>
    }
    triangle {
      < 2.741663, 0.469345, -2.404651>,
      < 3.003972, 0.446481, -2.364837>,
      < 3.004172, 0.497903, -2.405437>
    }
    triangle {
      < 2.741663, 0.429941, -2.365067>,
      < 2.741663, 0.104686, -2.369974>,
      < 3.005907, 0.147293, -2.369739>
    }
    triangle {
      < 2.741663, 0.429941, -2.365067>,
      < 3.005907, 0.147293, -2.369739>,
      < 3.003972, 0.446481, -2.364837>
    }
    triangle {
      < 2.491296, 0.312285, -2.649947>,
      < 2.489098, 0.300401, -2.682310>,
      < 2.460616, 0.288251, -2.684928>
    }
    triangle {
      < 2.491296, 0.312285, -2.649947>,
      < 2.460616, 0.288251, -2.684928>,
      < 2.467705, 0.287114, -2.652975>
    }
    triangle {
      < 2.495954, 0.327057, -2.625640>,
      < 2.491296, 0.312285, -2.649947>,
      < 2.467705, 0.287114, -2.652975>
    }
    triangle {
      < 2.495954, 0.327057, -2.625640>,
      < 2.467705, 0.287114, -2.652975>,
      < 2.468724, 0.301969, -2.633654>
    }
    triangle {
      < 2.482818, 0.350019, -2.594634>,
      < 2.495954, 0.327057, -2.625640>,
      < 2.468724, 0.301969, -2.633654>
    }
    triangle {
      < 2.482818, 0.350019, -2.594634>,
      < 2.468724, 0.301969, -2.633654>,
      < 2.460616, 0.316862, -2.600444>
    }
    triangle {
      < 2.474690, 0.377990, -2.550191>,
      < 2.482818, 0.350019, -2.594634>,
      < 2.460616, 0.316862, -2.600444>
    }
    triangle {
      < 2.474690, 0.377990, -2.550191>,
      < 2.460616, 0.316862, -2.600444>,
      < 2.460616, 0.325664, -2.551812>
    }
    triangle {
      < 2.473377, 0.373009, -2.456596>,
      < 2.474690, 0.377990, -2.550191>,
      < 2.460616, 0.325664, -2.551812>
    }
    triangle {
      < 2.473377, 0.373009, -2.456596>,
      < 2.460616, 0.325664, -2.551812>,
      < 2.460616, 0.310771, -2.455012>
    }
    triangle {
      < 2.472240, 0.337269, -2.396533>,
      < 2.473377, 0.373009, -2.456596>,
      < 2.460616, 0.310771, -2.455012>
    }
    triangle {
      < 2.472240, 0.337269, -2.396533>,
      < 2.460616, 0.310771, -2.455012>,
      < 2.460616, 0.270206, -2.401771>
    }
    triangle {
      < 2.489942, 0.302583, -2.378918>,
      < 2.472240, 0.337269, -2.396533>,
      < 2.460616, 0.270206, -2.401771>
    }
    triangle {
      < 2.489942, 0.302583, -2.378918>,
      < 2.460616, 0.270206, -2.401771>,
      < 2.460616, 0.216943, -2.375371>
    }
    triangle {
      < 2.487343, 0.073735, -2.377019>,
      < 2.489942, 0.302583, -2.378918>,
      < 2.460616, 0.216943, -2.375371>
    }
    triangle {
      < 2.487343, 0.073735, -2.377019>,
      < 2.460616, 0.216943, -2.375371>,
      < 2.460616, 0.074454, -2.380452>
    }
    triangle {
      < 2.489942, 0.302583, -2.378918>,
      < 2.487343, 0.073735, -2.377019>,
      < 2.514071, 0.073017, -2.373586>
    }
    triangle {
      < 2.489942, 0.302583, -2.378918>,
      < 2.514071, 0.073017, -2.373586>,
      < 2.516668, 0.369361, -2.375542>
    }
    triangle {
      < 2.472240, 0.337269, -2.396533>,
      < 2.489942, 0.302583, -2.378918>,
      < 2.516668, 0.369361, -2.375542>
    }
    triangle {
      < 2.472240, 0.337269, -2.396533>,
      < 2.516668, 0.369361, -2.375542>,
      < 2.500342, 0.396514, -2.397297>
    }
    triangle {
      < 2.473377, 0.373009, -2.456596>,
      < 2.472240, 0.337269, -2.396533>,
      < 2.500342, 0.396514, -2.397297>
    }
    triangle {
      < 2.473377, 0.373009, -2.456596>,
      < 2.500342, 0.396514, -2.397297>,
      < 2.502712, 0.425749, -2.460111>
    }
    triangle {
      < 2.474690, 0.377990, -2.550191>,
      < 2.473377, 0.373009, -2.456596>,
      < 2.502712, 0.425749, -2.460111>
    }
    triangle {
      < 2.474690, 0.377990, -2.550191>,
      < 2.502712, 0.425749, -2.460111>,
      < 2.504147, 0.419260, -2.549422>
    }
    triangle {
      < 2.482818, 0.350019, -2.594634>,
      < 2.474690, 0.377990, -2.550191>,
      < 2.504147, 0.419260, -2.549422>
    }
    triangle {
      < 2.482818, 0.350019, -2.594634>,
      < 2.504147, 0.419260, -2.549422>,
      < 2.514148, 0.378683, -2.591621>
    }
    triangle {
      < 2.495954, 0.327057, -2.625640>,
      < 2.482818, 0.350019, -2.594634>,
      < 2.514148, 0.378683, -2.591621>
    }
    triangle {
      < 2.495954, 0.327057, -2.625640>,
      < 2.514148, 0.378683, -2.591621>,
      < 2.526680, 0.347239, -2.621296>
    }
    triangle {
      < 2.491296, 0.312285, -2.649947>,
      < 2.495954, 0.327057, -2.625640>,
      < 2.526680, 0.347239, -2.621296>
    }
    triangle {
      < 2.491296, 0.312285, -2.649947>,
      < 2.526680, 0.347239, -2.621296>,
      < 2.519179, 0.330571, -2.647243>
    }
    triangle {
      < 2.489098, 0.300401, -2.682310>,
      < 2.491296, 0.312285, -2.649947>,
      < 2.519179, 0.330571, -2.647243>
    }
    triangle {
      < 2.489098, 0.300401, -2.682310>,
      < 2.519179, 0.330571, -2.647243>,
      < 2.517581, 0.312552, -2.679691>
    }
    triangle {
      < 2.460616, 0.316862, -2.600444>,
      < 2.468724, 0.301969, -2.633654>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 2.468724, 0.301969, -2.633654>,
      < 2.467705, 0.287114, -2.652975>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 2.467705, 0.287114, -2.652975>,
      < 2.460616, 0.288251, -2.684928>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 2.460616, 0.288251, -2.684928>,
      < 2.460616, 0.074454, -2.380452>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 2.460616, 0.074454, -2.380452>,
      < 2.460616, 0.216943, -2.375371>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 2.460616, 0.216943, -2.375371>,
      < 2.460616, 0.270206, -2.401771>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 2.460616, 0.270206, -2.401771>,
      < 2.460616, 0.310771, -2.455012>,
      < 2.462304, 0.265804, -2.526269>
    }
    triangle {
      < 2.460616, 0.310771, -2.455012>,
      < 2.460616, 0.325664, -2.551812>,
      < 2.462304, 0.265804, -2.526269>
    }
    texture {cover}
  }
  // visors
  union {
    triangle {
      < -1.386997, 1.810477, 0.553382>,
      < -0.847336, 1.812592, 0.495734>,
      < -0.829910, 1.809586, 0.704059>
    }
    triangle {
      < -1.386997, 1.810477, 0.553382>,
      < -0.829910, 1.809586, 0.704059>,
      < -1.381218, 1.808014, 0.747223>
    }
    triangle {
      < -0.918141, 1.844214, 0.431761>,
      < -0.971614, 1.844283, 0.430044>,
      < -1.113268, 1.843796, 0.443377>
    }
    triangle {
      < -0.918141, 1.844214, 0.431761>,
      < -1.113268, 1.843796, 0.443377>,
      < -1.310705, 1.842856, 0.468886>
    }
    triangle {
      < -0.918141, 1.844214, 0.431761>,
      < -1.310705, 1.842856, 0.468886>,
      < -1.363379, 1.841794, 0.497358>
    }
    triangle {
      < -0.918141, 1.844214, 0.431761>,
      < -1.363379, 1.841794, 0.497358>,
      < -0.882134, 1.843493, 0.450915>
    }
    triangle {
      < -1.210958, 1.791631, 1.717412>,
      < -0.755690, 1.793363, 1.688226>,
      < -0.765703, 1.813236, 1.473408>
    }
    triangle {
      < -1.210958, 1.791631, 1.717412>,
      < -0.765703, 1.813236, 1.473408>,
      < -1.328613, 1.812725, 1.489286>
    }
    triangle {
      < -0.860821, 1.734085, 1.852718>,
      < -1.050846, 1.733726, 1.860364>,
      < -1.116471, 1.741364, 1.826523>
    }
    triangle {
      < -0.860821, 1.734085, 1.852718>,
      < -1.116471, 1.741364, 1.826523>,
      < -0.805552, 1.741356, 1.821338>
    }
    triangle {
      < -0.812516, 1.835775, 0.912857>,
      < -1.375471, 1.834746, 0.941537>,
      < -1.361269, 1.831074, 1.135756>
    }
    triangle {
      < -0.812516, 1.835775, 0.912857>,
      < -1.361269, 1.831074, 1.135756>,
      < -0.795932, 1.831945, 1.111237>
    }
    triangle {
      < -1.361258, 1.801887, 1.134906>,
      < -0.795921, 1.802759, 1.110387>,
      < -0.779355, 1.794924, 1.308751>
    }
    triangle {
      < -1.361258, 1.801887, 1.134906>,
      < -0.779355, 1.794924, 1.308751>,
      < -1.347077, 1.794057, 1.329099>
    }
    triangle {
      < -0.779341, 1.824083, 1.310276>,
      < -1.347064, 1.823216, 1.330625>,
      < -1.328613, 1.812725, 1.489286>
    }
    triangle {
      < -0.779341, 1.824083, 1.310276>,
      < -1.328613, 1.812725, 1.489286>,
      < -0.765703, 1.813236, 1.473408>
    }
    triangle {
      < -1.381269, 1.837211, 0.747618>,
      < -0.829962, 1.838783, 0.704454>,
      < -0.847366, 1.841783, 0.496471>
    }
    triangle {
      < -1.381269, 1.837211, 0.747618>,
      < -0.847366, 1.841783, 0.496471>,
      < -1.387026, 1.839668, 0.554118>
    }
    triangle {
      < -1.375471, 1.834746, 0.941537>,
      < -0.812516, 1.835775, 0.912857>,
      < -0.829962, 1.838783, 0.704454>
    }
    triangle {
      < -1.375471, 1.834746, 0.941537>,
      < -0.829962, 1.838783, 0.704454>,
      < -1.381269, 1.837211, 0.747618>
    }
    triangle {
      < -1.347064, 1.823216, 1.330625>,
      < -0.779341, 1.824083, 1.310276>,
      < -0.795932, 1.831945, 1.111237>
    }
    triangle {
      < -1.347064, 1.823216, 1.330625>,
      < -0.795932, 1.831945, 1.111237>,
      < -1.361269, 1.831074, 1.135756>
    }
    triangle {
      < -1.050702, 1.762205, 1.866761>,
      < -0.860677, 1.762564, 1.859115>,
      < -0.805434, 1.769872, 1.827577>
    }
    triangle {
      < -1.050702, 1.762205, 1.866761>,
      < -0.805434, 1.769872, 1.827577>,
      < -1.116354, 1.769880, 1.832762>
    }
    triangle {
      < -0.755690, 1.793363, 1.688226>,
      < -1.210958, 1.791631, 1.717412>,
      < -1.178474, 1.781720, 1.778240>
    }
    triangle {
      < -0.755690, 1.793363, 1.688226>,
      < -1.178474, 1.781720, 1.778240>,
      < -0.769935, 1.781540, 1.773515>
    }
    triangle {
      < -1.116354, 1.769880, 1.832762>,
      < -0.805434, 1.769872, 1.827577>,
      < -0.769935, 1.781540, 1.773515>
    }
    triangle {
      < -1.116354, 1.769880, 1.832762>,
      < -0.769935, 1.781540, 1.773515>,
      < -1.178474, 1.781720, 1.778240>
    }
    triangle {
      < -1.387026, 1.839668, 0.554118>,
      < -0.847366, 1.841783, 0.496471>,
      < -0.882134, 1.843493, 0.450915>
    }
    triangle {
      < -1.387026, 1.839668, 0.554118>,
      < -0.882134, 1.843493, 0.450915>,
      < -1.363379, 1.841794, 0.497358>
    }
    triangle {
      < -1.301888, 1.791686, 1.718407>,
      < -1.210958, 1.791631, 1.717412>,
      < -1.328613, 1.812725, 1.489286>
    }
    triangle {
      < -1.050702, 1.762205, 1.866761>,
      < -1.116354, 1.769880, 1.832762>,
      < -1.116471, 1.741364, 1.826523>
    }
    triangle {
      < -1.050702, 1.762205, 1.866761>,
      < -1.116471, 1.741364, 1.826523>,
      < -1.050846, 1.733726, 1.860364>
    }
    triangle {
      < -1.116354, 1.769880, 1.832762>,
      < -1.178474, 1.781720, 1.778240>,
      < -1.178577, 1.752985, 1.773086>
    }
    triangle {
      < -1.116354, 1.769880, 1.832762>,
      < -1.178577, 1.752985, 1.773086>,
      < -1.116471, 1.741364, 1.826523>
    }
    triangle {
      < -1.178474, 1.781720, 1.778240>,
      < -1.210958, 1.791631, 1.717412>,
      < -1.211029, 1.762605, 1.714249>
    }
    triangle {
      < -1.178474, 1.781720, 1.778240>,
      < -1.211029, 1.762605, 1.714249>,
      < -1.178577, 1.752985, 1.773086>
    }
    triangle {
      < -1.210958, 1.791631, 1.717412>,
      < -1.301888, 1.791686, 1.718407>,
      < -1.301932, 1.762607, 1.715779>
    }
    triangle {
      < -1.210958, 1.791631, 1.717412>,
      < -1.301932, 1.762607, 1.715779>,
      < -1.211029, 1.762605, 1.714249>
    }
    triangle {
      < -1.301888, 1.791686, 1.718407>,
      < -1.328613, 1.812725, 1.489286>,
      < -1.328655, 1.783624, 1.486896>
    }
    triangle {
      < -1.301888, 1.791686, 1.718407>,
      < -1.328655, 1.783624, 1.486896>,
      < -1.301932, 1.762607, 1.715779>
    }
    triangle {
      < -1.328613, 1.812725, 1.489286>,
      < -1.347064, 1.823216, 1.330625>,
      < -1.347077, 1.794057, 1.329099>
    }
    triangle {
      < -1.328613, 1.812725, 1.489286>,
      < -1.347077, 1.794057, 1.329099>,
      < -1.328655, 1.783624, 1.486896>
    }
    triangle {
      < -1.347064, 1.823216, 1.330625>,
      < -1.361269, 1.831074, 1.135756>,
      < -1.361258, 1.801887, 1.134906>
    }
    triangle {
      < -1.347064, 1.823216, 1.330625>,
      < -1.361258, 1.801887, 1.134906>,
      < -1.347077, 1.794057, 1.329099>
    }
    triangle {
      < -1.361269, 1.831074, 1.135756>,
      < -1.375471, 1.834746, 0.941537>,
      < -1.375439, 1.805550, 0.941064>
    }
    triangle {
      < -1.361269, 1.831074, 1.135756>,
      < -1.375439, 1.805550, 0.941064>,
      < -1.361258, 1.801887, 1.134906>
    }
    triangle {
      < -1.375471, 1.834746, 0.941537>,
      < -1.381269, 1.837211, 0.747618>,
      < -1.381218, 1.808014, 0.747223>
    }
    triangle {
      < -1.375471, 1.834746, 0.941537>,
      < -1.381218, 1.808014, 0.747223>,
      < -1.375439, 1.805550, 0.941064>
    }
    triangle {
      < -1.381269, 1.837211, 0.747618>,
      < -1.387026, 1.839668, 0.554118>,
      < -1.386997, 1.810477, 0.553382>
    }
    triangle {
      < -1.381269, 1.837211, 0.747618>,
      < -1.386997, 1.810477, 0.553382>,
      < -1.381218, 1.808014, 0.747223>
    }
    triangle {
      < -1.387026, 1.839668, 0.554118>,
      < -1.363379, 1.841794, 0.497358>,
      < -1.363381, 1.812614, 0.496280>
    }
    triangle {
      < -1.387026, 1.839668, 0.554118>,
      < -1.363381, 1.812614, 0.496280>,
      < -1.386997, 1.810477, 0.553382>
    }
    triangle {
      < -1.363379, 1.841794, 0.497358>,
      < -1.310705, 1.842856, 0.468886>,
      < -1.310707, 1.813676, 0.467807>
    }
    triangle {
      < -1.363379, 1.841794, 0.497358>,
      < -1.310707, 1.813676, 0.467807>,
      < -1.363381, 1.812614, 0.496280>
    }
    triangle {
      < -1.310705, 1.842856, 0.468886>,
      < -1.113268, 1.843796, 0.443377>,
      < -1.113270, 1.814616, 0.442299>
    }
    triangle {
      < -1.310705, 1.842856, 0.468886>,
      < -1.113270, 1.814616, 0.442299>,
      < -1.310707, 1.813676, 0.467807>
    }
    triangle {
      < -1.113268, 1.843796, 0.443377>,
      < -0.971614, 1.844283, 0.430044>,
      < -0.971617, 1.815103, 0.428965>
    }
    triangle {
      < -1.113268, 1.843796, 0.443377>,
      < -0.971617, 1.815103, 0.428965>,
      < -1.113270, 1.814616, 0.442299>
    }
    triangle {
      < -0.971614, 1.844283, 0.430044>,
      < -0.918141, 1.844214, 0.431761>,
      < -0.918143, 1.815035, 0.430682>
    }
    triangle {
      < -0.971614, 1.844283, 0.430044>,
      < -0.918143, 1.815035, 0.430682>,
      < -0.971617, 1.815103, 0.428965>
    }
    triangle {
      < -0.918141, 1.844214, 0.431761>,
      < -0.882134, 1.843493, 0.450915>,
      < -0.882136, 1.814314, 0.449837>
    }
    triangle {
      < -0.918141, 1.844214, 0.431761>,
      < -0.882136, 1.814314, 0.449837>,
      < -0.918143, 1.815035, 0.430682>
    }
    triangle {
      < -0.882134, 1.843493, 0.450915>,
      < -0.847366, 1.841783, 0.496471>,
      < -0.847336, 1.812592, 0.495734>
    }
    triangle {
      < -0.882134, 1.843493, 0.450915>,
      < -0.847336, 1.812592, 0.495734>,
      < -0.882136, 1.814314, 0.449837>
    }
    triangle {
      < -0.847366, 1.841783, 0.496471>,
      < -0.829962, 1.838783, 0.704454>,
      < -0.829910, 1.809586, 0.704059>
    }
    triangle {
      < -0.847366, 1.841783, 0.496471>,
      < -0.829910, 1.809586, 0.704059>,
      < -0.847336, 1.812592, 0.495734>
    }
    triangle {
      < -0.829962, 1.838783, 0.704454>,
      < -0.812516, 1.835775, 0.912857>,
      < -0.812484, 1.806579, 0.912385>
    }
    triangle {
      < -0.829962, 1.838783, 0.704454>,
      < -0.812484, 1.806579, 0.912385>,
      < -0.829910, 1.809586, 0.704059>
    }
    triangle {
      < -0.812516, 1.835775, 0.912857>,
      < -0.795932, 1.831945, 1.111237>,
      < -0.795921, 1.802759, 1.110387>
    }
    triangle {
      < -0.812516, 1.835775, 0.912857>,
      < -0.795921, 1.802759, 1.110387>,
      < -0.812484, 1.806579, 0.912385>
    }
    triangle {
      < -0.795932, 1.831945, 1.111237>,
      < -0.779341, 1.824083, 1.310276>,
      < -0.779355, 1.794924, 1.308751>
    }
    triangle {
      < -0.795932, 1.831945, 1.111237>,
      < -0.779355, 1.794924, 1.308751>,
      < -0.795921, 1.802759, 1.110387>
    }
    triangle {
      < -0.779341, 1.824083, 1.310276>,
      < -0.765703, 1.813236, 1.473408>,
      < -0.765742, 1.784125, 1.471138>
    }
    triangle {
      < -0.779341, 1.824083, 1.310276>,
      < -0.765742, 1.784125, 1.471138>,
      < -0.779355, 1.794924, 1.308751>
    }
    triangle {
      < -0.765703, 1.813236, 1.473408>,
      < -0.755690, 1.793363, 1.688226>,
      < -0.755774, 1.764368, 1.684795>
    }
    triangle {
      < -0.765703, 1.813236, 1.473408>,
      < -0.755774, 1.764368, 1.684795>,
      < -0.765742, 1.784125, 1.471138>
    }
    triangle {
      < -0.755690, 1.793363, 1.688226>,
      < -0.769935, 1.781540, 1.773515>,
      < -0.770038, 1.752805, 1.768360>
    }
    triangle {
      < -0.755690, 1.793363, 1.688226>,
      < -0.770038, 1.752805, 1.768360>,
      < -0.755774, 1.764368, 1.684795>
    }
    triangle {
      < -0.769935, 1.781540, 1.773515>,
      < -0.805434, 1.769872, 1.827577>,
      < -0.805552, 1.741356, 1.821338>
    }
    triangle {
      < -0.769935, 1.781540, 1.773515>,
      < -0.805552, 1.741356, 1.821338>,
      < -0.770038, 1.752805, 1.768360>
    }
    triangle {
      < -0.805434, 1.769872, 1.827577>,
      < -0.860677, 1.762564, 1.859115>,
      < -0.860821, 1.734085, 1.852718>
    }
    triangle {
      < -0.805434, 1.769872, 1.827577>,
      < -0.860821, 1.734085, 1.852718>,
      < -0.805552, 1.741356, 1.821338>
    }
    triangle {
      < -0.860677, 1.762564, 1.859115>,
      < -1.050702, 1.762205, 1.866761>,
      < -1.050846, 1.733726, 1.860364>
    }
    triangle {
      < -0.860677, 1.762564, 1.859115>,
      < -1.050846, 1.733726, 1.860364>,
      < -0.860821, 1.734085, 1.852718>
    }
    triangle {
      < -1.211029, 1.762605, 1.714249>,
      < -0.755774, 1.764368, 1.684795>,
      < -0.770038, 1.752805, 1.768360>
    }
    triangle {
      < -1.211029, 1.762605, 1.714249>,
      < -0.770038, 1.752805, 1.768360>,
      < -1.178577, 1.752985, 1.773086>
    }
    triangle {
      < -0.805552, 1.741356, 1.821338>,
      < -1.116471, 1.741364, 1.826523>,
      < -1.178577, 1.752985, 1.773086>
    }
    triangle {
      < -0.805552, 1.741356, 1.821338>,
      < -1.178577, 1.752985, 1.773086>,
      < -0.770038, 1.752805, 1.768360>
    }
    triangle {
      < -1.301932, 1.762607, 1.715779>,
      < -1.328655, 1.783624, 1.486896>,
      < -1.211029, 1.762605, 1.714249>
    }
    triangle {
      < -1.347077, 1.794057, 1.329099>,
      < -0.779355, 1.794924, 1.308751>,
      < -0.765742, 1.784125, 1.471138>
    }
    triangle {
      < -1.347077, 1.794057, 1.329099>,
      < -0.765742, 1.784125, 1.471138>,
      < -1.328655, 1.783624, 1.486896>
    }
    triangle {
      < -0.755774, 1.764368, 1.684795>,
      < -1.211029, 1.762605, 1.714249>,
      < -1.328655, 1.783624, 1.486896>
    }
    triangle {
      < -0.755774, 1.764368, 1.684795>,
      < -1.328655, 1.783624, 1.486896>,
      < -0.765742, 1.784125, 1.471138>
    }
    triangle {
      < -1.375439, 1.805550, 0.941064>,
      < -0.812484, 1.806579, 0.912385>,
      < -0.795921, 1.802759, 1.110387>
    }
    triangle {
      < -1.375439, 1.805550, 0.941064>,
      < -0.795921, 1.802759, 1.110387>,
      < -1.361258, 1.801887, 1.134906>
    }
    triangle {
      < -0.812484, 1.806579, 0.912385>,
      < -1.375439, 1.805550, 0.941064>,
      < -1.381218, 1.808014, 0.747223>
    }
    triangle {
      < -0.812484, 1.806579, 0.912385>,
      < -1.381218, 1.808014, 0.747223>,
      < -0.829910, 1.809586, 0.704059>
    }
    triangle {
      < -1.310707, 1.813676, 0.467807>,
      < -1.113270, 1.814616, 0.442299>,
      < -0.971617, 1.815103, 0.428965>
    }
    triangle {
      < -1.310707, 1.813676, 0.467807>,
      < -0.971617, 1.815103, 0.428965>,
      < -0.918143, 1.815035, 0.430682>
    }
    triangle {
      < -1.310707, 1.813676, 0.467807>,
      < -0.918143, 1.815035, 0.430682>,
      < -0.882136, 1.814314, 0.449837>
    }
    triangle {
      < -1.310707, 1.813676, 0.467807>,
      < -0.882136, 1.814314, 0.449837>,
      < -1.363381, 1.812614, 0.496280>
    }
    triangle {
      < -0.847336, 1.812592, 0.495734>,
      < -1.386997, 1.810477, 0.553382>,
      < -1.363381, 1.812614, 0.496280>
    }
    triangle {
      < -0.847336, 1.812592, 0.495734>,
      < -1.363381, 1.812614, 0.496280>,
      < -0.882136, 1.814314, 0.449837>
    }
    triangle {
      < -1.381218, 1.808014, -0.747223>,
      < -0.829910, 1.809586, -0.704059>,
      < -0.847336, 1.812592, -0.495734>
    }
    triangle {
      < -1.381218, 1.808014, -0.747223>,
      < -0.847336, 1.812592, -0.495734>,
      < -1.386997, 1.810477, -0.553382>
    }
    triangle {
      < -0.882134, 1.843493, -0.450915>,
      < -1.363379, 1.841794, -0.497358>,
      < -1.310705, 1.842856, -0.468886>
    }
    triangle {
      < -0.882134, 1.843493, -0.450915>,
      < -1.310705, 1.842856, -0.468886>,
      < -1.113268, 1.843796, -0.443377>
    }
    triangle {
      < -0.882134, 1.843493, -0.450915>,
      < -1.113268, 1.843796, -0.443377>,
      < -0.971614, 1.844283, -0.430044>
    }
    triangle {
      < -0.882134, 1.843493, -0.450915>,
      < -0.971614, 1.844283, -0.430044>,
      < -0.918141, 1.844214, -0.431761>
    }
    triangle {
      < -1.328613, 1.812725, -1.489286>,
      < -0.765703, 1.813236, -1.473408>,
      < -0.755690, 1.793363, -1.688226>
    }
    triangle {
      < -1.328613, 1.812725, -1.489286>,
      < -0.755690, 1.793363, -1.688226>,
      < -1.210958, 1.791631, -1.717412>
    }
    triangle {
      < -0.805552, 1.741356, -1.821338>,
      < -1.116471, 1.741364, -1.826523>,
      < -1.050846, 1.733726, -1.860364>
    }
    triangle {
      < -0.805552, 1.741356, -1.821338>,
      < -1.050846, 1.733726, -1.860364>,
      < -0.860821, 1.734085, -1.852718>
    }
    triangle {
      < -0.795932, 1.831945, -1.111237>,
      < -1.361269, 1.831074, -1.135756>,
      < -1.375471, 1.834746, -0.941537>
    }
    triangle {
      < -0.795932, 1.831945, -1.111237>,
      < -1.375471, 1.834746, -0.941537>,
      < -0.812516, 1.835775, -0.912857>
    }
    triangle {
      < -1.347077, 1.794057, -1.329099>,
      < -0.779355, 1.794924, -1.308751>,
      < -0.795921, 1.802759, -1.110387>
    }
    triangle {
      < -1.347077, 1.794057, -1.329099>,
      < -0.795921, 1.802759, -1.110387>,
      < -1.361258, 1.801887, -1.134906>
    }
    triangle {
      < -0.765703, 1.813236, -1.473408>,
      < -1.328613, 1.812725, -1.489286>,
      < -1.347064, 1.823216, -1.330625>
    }
    triangle {
      < -0.765703, 1.813236, -1.473408>,
      < -1.347064, 1.823216, -1.330625>,
      < -0.779341, 1.824083, -1.310276>
    }
    triangle {
      < -1.387026, 1.839668, -0.554118>,
      < -0.847366, 1.841783, -0.496471>,
      < -0.829962, 1.838783, -0.704454>
    }
    triangle {
      < -1.387026, 1.839668, -0.554118>,
      < -0.829962, 1.838783, -0.704454>,
      < -1.381269, 1.837211, -0.747618>
    }
    triangle {
      < -1.381269, 1.837211, -0.747618>,
      < -0.829962, 1.838783, -0.704454>,
      < -0.812516, 1.835775, -0.912857>
    }
    triangle {
      < -1.381269, 1.837211, -0.747618>,
      < -0.812516, 1.835775, -0.912857>,
      < -1.375471, 1.834746, -0.941537>
    }
    triangle {
      < -1.361269, 1.831074, -1.135756>,
      < -0.795932, 1.831945, -1.111237>,
      < -0.779341, 1.824083, -1.310276>
    }
    triangle {
      < -1.361269, 1.831074, -1.135756>,
      < -0.779341, 1.824083, -1.310276>,
      < -1.347064, 1.823216, -1.330625>
    }
    triangle {
      < -1.116354, 1.769880, -1.832762>,
      < -0.805434, 1.769872, -1.827577>,
      < -0.860677, 1.762564, -1.859115>
    }
    triangle {
      < -1.116354, 1.769880, -1.832762>,
      < -0.860677, 1.762564, -1.859115>,
      < -1.050702, 1.762205, -1.866761>
    }
    triangle {
      < -0.769935, 1.781540, -1.773515>,
      < -1.178474, 1.781720, -1.778240>,
      < -1.210958, 1.791631, -1.717412>
    }
    triangle {
      < -0.769935, 1.781540, -1.773515>,
      < -1.210958, 1.791631, -1.717412>,
      < -0.755690, 1.793363, -1.688226>
    }
    triangle {
      < -1.178474, 1.781720, -1.778240>,
      < -0.769935, 1.781540, -1.773515>,
      < -0.805434, 1.769872, -1.827577>
    }
    triangle {
      < -1.178474, 1.781720, -1.778240>,
      < -0.805434, 1.769872, -1.827577>,
      < -1.116354, 1.769880, -1.832762>
    }
    triangle {
      < -1.363379, 1.841794, -0.497358>,
      < -0.882134, 1.843493, -0.450915>,
      < -0.847366, 1.841783, -0.496471>
    }
    triangle {
      < -1.363379, 1.841794, -0.497358>,
      < -0.847366, 1.841783, -0.496471>,
      < -1.387026, 1.839668, -0.554118>
    }
    triangle {
      < -1.328613, 1.812725, -1.489286>,
      < -1.210958, 1.791631, -1.717412>,
      < -1.301888, 1.791686, -1.718407>
    }
    triangle {
      < -1.050846, 1.733726, -1.860364>,
      < -1.116471, 1.741364, -1.826523>,
      < -1.116354, 1.769880, -1.832762>
    }
    triangle {
      < -1.050846, 1.733726, -1.860364>,
      < -1.116354, 1.769880, -1.832762>,
      < -1.050702, 1.762205, -1.866761>
    }
    triangle {
      < -1.116471, 1.741364, -1.826523>,
      < -1.178577, 1.752985, -1.773086>,
      < -1.178474, 1.781720, -1.778240>
    }
    triangle {
      < -1.116471, 1.741364, -1.826523>,
      < -1.178474, 1.781720, -1.778240>,
      < -1.116354, 1.769880, -1.832762>
    }
    triangle {
      < -1.178577, 1.752985, -1.773086>,
      < -1.211029, 1.762605, -1.714249>,
      < -1.210958, 1.791631, -1.717412>
    }
    triangle {
      < -1.178577, 1.752985, -1.773086>,
      < -1.210958, 1.791631, -1.717412>,
      < -1.178474, 1.781720, -1.778240>
    }
    triangle {
      < -1.211029, 1.762605, -1.714249>,
      < -1.301932, 1.762607, -1.715779>,
      < -1.301888, 1.791686, -1.718407>
    }
    triangle {
      < -1.211029, 1.762605, -1.714249>,
      < -1.301888, 1.791686, -1.718407>,
      < -1.210958, 1.791631, -1.717412>
    }
    triangle {
      < -1.301932, 1.762607, -1.715779>,
      < -1.328655, 1.783624, -1.486896>,
      < -1.328613, 1.812725, -1.489286>
    }
    triangle {
      < -1.301932, 1.762607, -1.715779>,
      < -1.328613, 1.812725, -1.489286>,
      < -1.301888, 1.791686, -1.718407>
    }
    triangle {
      < -1.328655, 1.783624, -1.486896>,
      < -1.347077, 1.794057, -1.329099>,
      < -1.347064, 1.823216, -1.330625>
    }
    triangle {
      < -1.328655, 1.783624, -1.486896>,
      < -1.347064, 1.823216, -1.330625>,
      < -1.328613, 1.812725, -1.489286>
    }
    triangle {
      < -1.347077, 1.794057, -1.329099>,
      < -1.361258, 1.801887, -1.134906>,
      < -1.361269, 1.831074, -1.135756>
    }
    triangle {
      < -1.347077, 1.794057, -1.329099>,
      < -1.361269, 1.831074, -1.135756>,
      < -1.347064, 1.823216, -1.330625>
    }
    triangle {
      < -1.361258, 1.801887, -1.134906>,
      < -1.375439, 1.805550, -0.941064>,
      < -1.375471, 1.834746, -0.941537>
    }
    triangle {
      < -1.361258, 1.801887, -1.134906>,
      < -1.375471, 1.834746, -0.941537>,
      < -1.361269, 1.831074, -1.135756>
    }
    triangle {
      < -1.375439, 1.805550, -0.941064>,
      < -1.381218, 1.808014, -0.747223>,
      < -1.381269, 1.837211, -0.747618>
    }
    triangle {
      < -1.375439, 1.805550, -0.941064>,
      < -1.381269, 1.837211, -0.747618>,
      < -1.375471, 1.834746, -0.941537>
    }
    triangle {
      < -1.381218, 1.808014, -0.747223>,
      < -1.386997, 1.810477, -0.553382>,
      < -1.387026, 1.839668, -0.554118>
    }
    triangle {
      < -1.381218, 1.808014, -0.747223>,
      < -1.387026, 1.839668, -0.554118>,
      < -1.381269, 1.837211, -0.747618>
    }
    triangle {
      < -1.386997, 1.810477, -0.553382>,
      < -1.363381, 1.812614, -0.496280>,
      < -1.363379, 1.841794, -0.497358>
    }
    triangle {
      < -1.386997, 1.810477, -0.553382>,
      < -1.363379, 1.841794, -0.497358>,
      < -1.387026, 1.839668, -0.554118>
    }
    triangle {
      < -1.363381, 1.812614, -0.496280>,
      < -1.310707, 1.813676, -0.467807>,
      < -1.310705, 1.842856, -0.468886>
    }
    triangle {
      < -1.363381, 1.812614, -0.496280>,
      < -1.310705, 1.842856, -0.468886>,
      < -1.363379, 1.841794, -0.497358>
    }
    triangle {
      < -1.310707, 1.813676, -0.467807>,
      < -1.113270, 1.814616, -0.442299>,
      < -1.113268, 1.843796, -0.443377>
    }
    triangle {
      < -1.310707, 1.813676, -0.467807>,
      < -1.113268, 1.843796, -0.443377>,
      < -1.310705, 1.842856, -0.468886>
    }
    triangle {
      < -1.113270, 1.814616, -0.442299>,
      < -0.971617, 1.815103, -0.428965>,
      < -0.971614, 1.844283, -0.430044>
    }
    triangle {
      < -1.113270, 1.814616, -0.442299>,
      < -0.971614, 1.844283, -0.430044>,
      < -1.113268, 1.843796, -0.443377>
    }
    triangle {
      < -0.971617, 1.815103, -0.428965>,
      < -0.918143, 1.815035, -0.430682>,
      < -0.918141, 1.844214, -0.431761>
    }
    triangle {
      < -0.971617, 1.815103, -0.428965>,
      < -0.918141, 1.844214, -0.431761>,
      < -0.971614, 1.844283, -0.430044>
    }
    triangle {
      < -0.918143, 1.815035, -0.430682>,
      < -0.882136, 1.814314, -0.449837>,
      < -0.882134, 1.843493, -0.450915>
    }
    triangle {
      < -0.918143, 1.815035, -0.430682>,
      < -0.882134, 1.843493, -0.450915>,
      < -0.918141, 1.844214, -0.431761>
    }
    triangle {
      < -0.882136, 1.814314, -0.449837>,
      < -0.847336, 1.812592, -0.495734>,
      < -0.847366, 1.841783, -0.496471>
    }
    triangle {
      < -0.882136, 1.814314, -0.449837>,
      < -0.847366, 1.841783, -0.496471>,
      < -0.882134, 1.843493, -0.450915>
    }
    triangle {
      < -0.847336, 1.812592, -0.495734>,
      < -0.829910, 1.809586, -0.704059>,
      < -0.829962, 1.838783, -0.704454>
    }
    triangle {
      < -0.847336, 1.812592, -0.495734>,
      < -0.829962, 1.838783, -0.704454>,
      < -0.847366, 1.841783, -0.496471>
    }
    triangle {
      < -0.829910, 1.809586, -0.704059>,
      < -0.812484, 1.806579, -0.912385>,
      < -0.812516, 1.835775, -0.912857>
    }
    triangle {
      < -0.829910, 1.809586, -0.704059>,
      < -0.812516, 1.835775, -0.912857>,
      < -0.829962, 1.838783, -0.704454>
    }
    triangle {
      < -0.812484, 1.806579, -0.912385>,
      < -0.795921, 1.802759, -1.110387>,
      < -0.795932, 1.831945, -1.111237>
    }
    triangle {
      < -0.812484, 1.806579, -0.912385>,
      < -0.795932, 1.831945, -1.111237>,
      < -0.812516, 1.835775, -0.912857>
    }
    triangle {
      < -0.795921, 1.802759, -1.110387>,
      < -0.779355, 1.794924, -1.308751>,
      < -0.779341, 1.824083, -1.310276>
    }
    triangle {
      < -0.795921, 1.802759, -1.110387>,
      < -0.779341, 1.824083, -1.310276>,
      < -0.795932, 1.831945, -1.111237>
    }
    triangle {
      < -0.779355, 1.794924, -1.308751>,
      < -0.765742, 1.784125, -1.471138>,
      < -0.765703, 1.813236, -1.473408>
    }
    triangle {
      < -0.779355, 1.794924, -1.308751>,
      < -0.765703, 1.813236, -1.473408>,
      < -0.779341, 1.824083, -1.310276>
    }
    triangle {
      < -0.765742, 1.784125, -1.471138>,
      < -0.755774, 1.764368, -1.684795>,
      < -0.755690, 1.793363, -1.688226>
    }
    triangle {
      < -0.765742, 1.784125, -1.471138>,
      < -0.755690, 1.793363, -1.688226>,
      < -0.765703, 1.813236, -1.473408>
    }
    triangle {
      < -0.755774, 1.764368, -1.684795>,
      < -0.770038, 1.752805, -1.768360>,
      < -0.769935, 1.781540, -1.773515>
    }
    triangle {
      < -0.755774, 1.764368, -1.684795>,
      < -0.769935, 1.781540, -1.773515>,
      < -0.755690, 1.793363, -1.688226>
    }
    triangle {
      < -0.770038, 1.752805, -1.768360>,
      < -0.805552, 1.741356, -1.821338>,
      < -0.805434, 1.769872, -1.827577>
    }
    triangle {
      < -0.770038, 1.752805, -1.768360>,
      < -0.805434, 1.769872, -1.827577>,
      < -0.769935, 1.781540, -1.773515>
    }
    triangle {
      < -0.805552, 1.741356, -1.821338>,
      < -0.860821, 1.734085, -1.852718>,
      < -0.860677, 1.762564, -1.859115>
    }
    triangle {
      < -0.805552, 1.741356, -1.821338>,
      < -0.860677, 1.762564, -1.859115>,
      < -0.805434, 1.769872, -1.827577>
    }
    triangle {
      < -0.860821, 1.734085, -1.852718>,
      < -1.050846, 1.733726, -1.860364>,
      < -1.050702, 1.762205, -1.866761>
    }
    triangle {
      < -0.860821, 1.734085, -1.852718>,
      < -1.050702, 1.762205, -1.866761>,
      < -0.860677, 1.762564, -1.859115>
    }
    triangle {
      < -1.178577, 1.752985, -1.773086>,
      < -0.770038, 1.752805, -1.768360>,
      < -0.755774, 1.764368, -1.684795>
    }
    triangle {
      < -1.178577, 1.752985, -1.773086>,
      < -0.755774, 1.764368, -1.684795>,
      < -1.211029, 1.762605, -1.714249>
    }
    triangle {
      < -0.770038, 1.752805, -1.768360>,
      < -1.178577, 1.752985, -1.773086>,
      < -1.116471, 1.741364, -1.826523>
    }
    triangle {
      < -0.770038, 1.752805, -1.768360>,
      < -1.116471, 1.741364, -1.826523>,
      < -0.805552, 1.741356, -1.821338>
    }
    triangle {
      < -1.211029, 1.762605, -1.714249>,
      < -1.328655, 1.783624, -1.486896>,
      < -1.301932, 1.762607, -1.715779>
    }
    triangle {
      < -1.328655, 1.783624, -1.486896>,
      < -0.765742, 1.784125, -1.471138>,
      < -0.779355, 1.794924, -1.308751>
    }
    triangle {
      < -1.328655, 1.783624, -1.486896>,
      < -0.779355, 1.794924, -1.308751>,
      < -1.347077, 1.794057, -1.329099>
    }
    triangle {
      < -0.765742, 1.784125, -1.471138>,
      < -1.328655, 1.783624, -1.486896>,
      < -1.211029, 1.762605, -1.714249>
    }
    triangle {
      < -0.765742, 1.784125, -1.471138>,
      < -1.211029, 1.762605, -1.714249>,
      < -0.755774, 1.764368, -1.684795>
    }
    triangle {
      < -1.361258, 1.801887, -1.134906>,
      < -0.795921, 1.802759, -1.110387>,
      < -0.812484, 1.806579, -0.912385>
    }
    triangle {
      < -1.361258, 1.801887, -1.134906>,
      < -0.812484, 1.806579, -0.912385>,
      < -1.375439, 1.805550, -0.941064>
    }
    triangle {
      < -0.829910, 1.809586, -0.704059>,
      < -1.381218, 1.808014, -0.747223>,
      < -1.375439, 1.805550, -0.941064>
    }
    triangle {
      < -0.829910, 1.809586, -0.704059>,
      < -1.375439, 1.805550, -0.941064>,
      < -0.812484, 1.806579, -0.912385>
    }
    triangle {
      < -1.363381, 1.812614, -0.496280>,
      < -0.882136, 1.814314, -0.449837>,
      < -0.918143, 1.815035, -0.430682>
    }
    triangle {
      < -1.363381, 1.812614, -0.496280>,
      < -0.918143, 1.815035, -0.430682>,
      < -0.971617, 1.815103, -0.428965>
    }
    triangle {
      < -1.363381, 1.812614, -0.496280>,
      < -0.971617, 1.815103, -0.428965>,
      < -1.113270, 1.814616, -0.442299>
    }
    triangle {
      < -1.363381, 1.812614, -0.496280>,
      < -1.113270, 1.814616, -0.442299>,
      < -1.310707, 1.813676, -0.467807>
    }
    triangle {
      < -0.882136, 1.814314, -0.449837>,
      < -1.363381, 1.812614, -0.496280>,
      < -1.386997, 1.810477, -0.553382>
    }
    triangle {
      < -0.882136, 1.814314, -0.449837>,
      < -1.386997, 1.810477, -0.553382>,
      < -0.847336, 1.812592, -0.495734>
    }
    texture {visors}
  }
  // hood
  union {
    triangle {
      < -6.505096, 0.255659, -1.341405>,
      < -6.459274, 0.272179, -1.376115>,
      < -6.336598, 0.220499, -1.865870>
    }
    triangle {
      < -6.505096, 0.255659, -1.341405>,
      < -6.336598, 0.220499, -1.865870>,
      < -6.460075, 0.150510, -1.868090>
    }
    texture {hood}
  }
  // black
  union {
    triangle {
      < -6.741947, -0.371911, -2.834569>,
      < -6.741866, -0.439490, -2.791026>,
      < -6.765466, -0.439490, -2.791026>
    }
    triangle {
      < -6.741947, -0.371911, -2.834569>,
      < -6.765466, -0.439490, -2.791026>,
      < -6.765547, -0.371911, -2.834569>
    }
    triangle {
      < -6.741506, -0.487581, -2.733489>,
      < -6.765106, -0.487581, -2.733489>,
      < -6.765466, -0.439490, -2.791026>
    }
    triangle {
      < -6.741506, -0.487581, -2.733489>,
      < -6.765466, -0.439490, -2.791026>,
      < -6.741866, -0.439490, -2.791026>
    }
    triangle {
      < -6.739315, -0.539283, -2.555220>,
      < -6.737481, -0.549481, -2.444748>,
      < -6.761081, -0.549481, -2.444748>
    }
    triangle {
      < -6.739315, -0.539283, -2.555220>,
      < -6.761081, -0.549481, -2.444748>,
      < -6.762914, -0.539283, -2.555220>
    }
    triangle {
      < -6.737584, -0.541778, -2.342008>,
      < -6.761184, -0.541778, -2.342008>,
      < -6.761081, -0.549481, -2.444748>
    }
    triangle {
      < -6.737584, -0.541778, -2.342008>,
      < -6.761081, -0.549481, -2.444748>,
      < -6.737481, -0.549481, -2.444748>
    }
    triangle {
      < -6.732151, -0.500433, -2.174088>,
      < -6.726615, -0.459473, -2.118052>,
      < -6.750215, -0.459473, -2.118052>
    }
    triangle {
      < -6.732151, -0.500433, -2.174088>,
      < -6.750215, -0.459473, -2.118052>,
      < -6.755751, -0.500433, -2.174088>
    }
    triangle {
      < -6.726521, -0.394538, -2.074579>,
      < -6.750121, -0.394538, -2.074579>,
      < -6.750215, -0.459473, -2.118052>
    }
    triangle {
      < -6.726521, -0.394538, -2.074579>,
      < -6.750215, -0.459473, -2.118052>,
      < -6.726615, -0.459473, -2.118052>
    }
    triangle {
      < -6.726426, -0.319472, -2.052864>,
      < -6.733982, -0.079470, -2.018336>,
      < -6.757581, -0.079470, -2.018336>
    }
    triangle {
      < -6.726426, -0.319472, -2.052864>,
      < -6.757581, -0.079470, -2.018336>,
      < -6.750026, -0.319472, -2.052864>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.826890, -0.384413, -2.091931>,
      < -6.796764, -0.335362, -2.186019>,
      < -6.826978, -0.444986, -2.133379>
    }
    triangle {
      < -6.834251, -0.079229, -2.038333>,
      < -6.796898, -0.130108, -2.116174>,
      < -6.796567, -0.238610, -2.133832>
    }
    triangle {
      < -6.834251, -0.079229, -2.038333>,
      < -6.796567, -0.238610, -2.133832>,
      < -6.826804, -0.313709, -2.072241>
    }
    triangle {
      < -6.826978, -0.444986, -2.133379>,
      < -6.796764, -0.335362, -2.186019>,
      < -6.832448, -0.483480, -2.184819>
    }
    triangle {
      < -6.841676, -0.425841, -2.775235>,
      < -6.805990, -0.331365, -2.711921>,
      < -6.841698, -0.362516, -2.816865>
    }
    triangle {
      < -6.837764, -0.521986, -2.345005>,
      < -6.801351, -0.463196, -2.447439>,
      < -6.837608, -0.529316, -2.444607>
    }
    triangle {
      < -6.837608, -0.529316, -2.444607>,
      < -6.801351, -0.463196, -2.447439>,
      < -6.839378, -0.519588, -2.551625>
    }
    triangle {
      < -6.841412, -0.471144, -2.722069>,
      < -6.805990, -0.331365, -2.711921>,
      < -6.841676, -0.425841, -2.775235>
    }
    texture {net}
  }
  // hood
  union {
    triangle {
      < -6.539279, 0.243124, -1.292395>,
      < -6.604657, 0.295554, -0.651380>,
      < -6.518058, 0.265439, -1.239676>
    }
    triangle {
      < -6.539279, 0.243124, -1.292395>,
      < -6.421206, 0.243124, -1.232237>,
      < -6.407199, 0.243124, -1.350899>
    }
    triangle {
      < -6.518058, 0.265439, -1.239676>,
      < -6.480494, 0.287964, -1.204414>,
      < -6.421206, 0.243124, -1.232237>
    }
    triangle {
      < -6.459274, 0.272179, -1.376115>,
      < -6.505096, 0.255659, -1.341405>,
      < -6.407199, 0.243124, -1.350899>
    }
    triangle {
      < -6.421206, 0.243124, -1.232237>,
      < -6.480494, 0.287964, -1.204414>,
      < -6.426589, 0.310700, -1.186610>
    }
    triangle {
      < -6.518058, 0.265439, -1.239676>,
      < -6.421206, 0.243124, -1.232237>,
      < -6.539279, 0.243124, -1.292395>
    }
    triangle {
      < -6.407199, 0.243124, -1.350899>,
      < -6.505096, 0.255659, -1.341405>,
      < -6.539279, 0.243124, -1.292395>
    }
    triangle {
      < -6.459274, 0.272179, -1.376115>,
      < -6.407199, 0.243124, -1.350899>,
      < -6.401817, 0.292686, -1.396527>
    }
    triangle {
      < -6.480494, 0.287964, -1.204414>,
      < -6.487709, 0.350544, -0.646443>,
      < -6.426589, 0.310700, -1.186610>
    }
    triangle {
      < -6.487709, 0.350544, -0.646443>,
      < -6.480494, 0.287964, -1.204414>,
      < -6.518058, 0.265439, -1.239676>
    }
    triangle {
      < -6.487709, 0.350544, -0.646443>,
      < -6.518058, 0.265439, -1.239676>,
      < -6.604657, 0.295554, -0.651380>
    }
    triangle {
      < -6.505096, 0.255659, -1.341405>,
      < -6.460075, 0.150510, -1.868090>,
      < -6.539279, 0.243124, -1.292395>
    }
    triangle {
      < -6.336598, 0.220499, -1.865870>,
      < -6.459274, 0.272179, -1.376115>,
      < -6.401817, 0.292686, -1.396527>
    }
    texture {hood}
  }
  // black
  union {
    triangle {
      < -6.750121, -0.394538, -2.074579>,
      < -6.726521, -0.394538, -2.074579>,
      < -6.726426, -0.319472, -2.052864>
    }
    triangle {
      < -6.750121, -0.394538, -2.074579>,
      < -6.726426, -0.319472, -2.052864>,
      < -6.750026, -0.319472, -2.052864>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.796764, -0.335362, -2.186019>,
      < -6.826890, -0.384413, -2.091931>,
      < -6.826804, -0.313709, -2.072241>
    }
    triangle {
      < -6.796764, -0.335362, -2.186019>,
      < -6.826804, -0.313709, -2.072241>,
      < -6.796567, -0.238610, -2.133832>
    }
    triangle {
      < -6.832448, -0.483480, -2.184819>,
      < -6.796764, -0.335362, -2.186019>,
      < -6.798798, -0.429527, -2.301943>
    }
    triangle {
      < -6.832448, -0.483480, -2.184819>,
      < -6.798798, -0.429527, -2.301943>,
      < -6.837920, -0.505056, -2.245336>
    }
    texture {net}
  }
  // black
  union {
    triangle {
      < -6.732151, -0.500433, -2.174088>,
      < -6.755751, -0.500433, -2.174088>,
      < -6.761287, -0.524475, -2.239201>
    }
    triangle {
      < -6.732151, -0.500433, -2.174088>,
      < -6.761287, -0.524475, -2.239201>,
      < -6.737687, -0.524475, -2.239201>
    }
    triangle {
      < -6.761184, -0.541778, -2.342008>,
      < -6.737584, -0.541778, -2.342008>,
      < -6.737687, -0.524475, -2.239201>
    }
    triangle {
      < -6.761184, -0.541778, -2.342008>,
      < -6.737687, -0.524475, -2.239201>,
      < -6.761287, -0.524475, -2.239201>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.801351, -0.463196, -2.447439>,
      < -6.837764, -0.521986, -2.345005>,
      < -6.837920, -0.505056, -2.245336>
    }
    triangle {
      < -6.801351, -0.463196, -2.447439>,
      < -6.837920, -0.505056, -2.245336>,
      < -6.798798, -0.429527, -2.301943>
    }
    triangle {
      < -6.839378, -0.519588, -2.551625>,
      < -6.801351, -0.463196, -2.447439>,
      < -6.803942, -0.428412, -2.595193>
    }
    triangle {
      < -6.839378, -0.519588, -2.551625>,
      < -6.803942, -0.428412, -2.595193>,
      < -6.841147, -0.500260, -2.658577>
    }
    texture {net}
  }
  // black
  union {
    triangle {
      < -6.739315, -0.539283, -2.555220>,
      < -6.762914, -0.539283, -2.555220>,
      < -6.764747, -0.519486, -2.665626>
    }
    triangle {
      < -6.739315, -0.539283, -2.555220>,
      < -6.764747, -0.519486, -2.665626>,
      < -6.741147, -0.519486, -2.665626>
    }
    triangle {
      < -6.765106, -0.487581, -2.733489>,
      < -6.741506, -0.487581, -2.733489>,
      < -6.741147, -0.519486, -2.665626>
    }
    triangle {
      < -6.765106, -0.487581, -2.733489>,
      < -6.741147, -0.519486, -2.665626>,
      < -6.764747, -0.519486, -2.665626>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.805990, -0.331365, -2.711921>,
      < -6.841412, -0.471144, -2.722069>,
      < -6.841147, -0.500260, -2.658577>
    }
    triangle {
      < -6.805990, -0.331365, -2.711921>,
      < -6.841147, -0.500260, -2.658577>,
      < -6.803942, -0.428412, -2.595193>
    }
    triangle {
      < -6.841698, -0.362516, -2.816865>,
      < -6.805990, -0.331365, -2.711921>,
      < -6.806168, -0.232484, -2.763064>
    }
    triangle {
      < -6.841698, -0.362516, -2.816865>,
      < -6.806168, -0.232484, -2.763064>,
      < -6.841718, -0.289349, -2.836606>
    }
    texture {net}
  }
  // black
  union {
    triangle {
      < -6.741947, -0.371911, -2.834569>,
      < -6.765547, -0.371911, -2.834569>,
      < -6.765629, -0.294491, -2.856221>
    }
    triangle {
      < -6.741947, -0.371911, -2.834569>,
      < -6.765629, -0.294491, -2.856221>,
      < -6.742029, -0.294491, -2.856221>
    }
    texture {black}
  }
  // hood
  union {
    triangle {
      < -6.460075, 0.150510, 1.868090>,
      < -6.336598, 0.220499, 1.865870>,
      < -6.459274, 0.272179, 1.376115>
    }
    triangle {
      < -6.460075, 0.150510, 1.868090>,
      < -6.459274, 0.272179, 1.376115>,
      < -6.505096, 0.255659, 1.341405>
    }
    texture {hood}
  }
  // black
  union {
    triangle {
      < -6.765547, -0.371911, 2.834569>,
      < -6.765466, -0.439490, 2.791026>,
      < -6.741866, -0.439490, 2.791026>
    }
    triangle {
      < -6.765547, -0.371911, 2.834569>,
      < -6.741866, -0.439490, 2.791026>,
      < -6.741947, -0.371911, 2.834569>
    }
    triangle {
      < -6.741866, -0.439490, 2.791026>,
      < -6.765466, -0.439490, 2.791026>,
      < -6.765106, -0.487581, 2.733489>
    }
    triangle {
      < -6.741866, -0.439490, 2.791026>,
      < -6.765106, -0.487581, 2.733489>,
      < -6.741506, -0.487581, 2.733489>
    }
    triangle {
      < -6.762914, -0.539283, 2.555220>,
      < -6.761081, -0.549481, 2.444748>,
      < -6.737481, -0.549481, 2.444748>
    }
    triangle {
      < -6.762914, -0.539283, 2.555220>,
      < -6.737481, -0.549481, 2.444748>,
      < -6.739315, -0.539283, 2.555220>
    }
    triangle {
      < -6.737481, -0.549481, 2.444748>,
      < -6.761081, -0.549481, 2.444748>,
      < -6.761184, -0.541778, 2.342008>
    }
    triangle {
      < -6.737481, -0.549481, 2.444748>,
      < -6.761184, -0.541778, 2.342008>,
      < -6.737584, -0.541778, 2.342008>
    }
    triangle {
      < -6.755751, -0.500433, 2.174088>,
      < -6.750215, -0.459473, 2.118052>,
      < -6.726615, -0.459473, 2.118052>
    }
    triangle {
      < -6.755751, -0.500433, 2.174088>,
      < -6.726615, -0.459473, 2.118052>,
      < -6.732151, -0.500433, 2.174088>
    }
    triangle {
      < -6.726615, -0.459473, 2.118052>,
      < -6.750215, -0.459473, 2.118052>,
      < -6.750121, -0.394538, 2.074579>
    }
    triangle {
      < -6.726615, -0.459473, 2.118052>,
      < -6.750121, -0.394538, 2.074579>,
      < -6.726521, -0.394538, 2.074579>
    }
    triangle {
      < -6.750026, -0.319472, 2.052864>,
      < -6.757581, -0.079470, 2.018336>,
      < -6.733982, -0.079470, 2.018336>
    }
    triangle {
      < -6.750026, -0.319472, 2.052864>,
      < -6.733982, -0.079470, 2.018336>,
      < -6.726426, -0.319472, 2.052864>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.826978, -0.444986, 2.133379>,
      < -6.796764, -0.335362, 2.186019>,
      < -6.826890, -0.384413, 2.091931>
    }
    triangle {
      < -6.826804, -0.313709, 2.072241>,
      < -6.796567, -0.238610, 2.133832>,
      < -6.796898, -0.130108, 2.116174>
    }
    triangle {
      < -6.826804, -0.313709, 2.072241>,
      < -6.796898, -0.130108, 2.116174>,
      < -6.834251, -0.079229, 2.038333>
    }
    triangle {
      < -6.832448, -0.483480, 2.184819>,
      < -6.796764, -0.335362, 2.186019>,
      < -6.826978, -0.444986, 2.133379>
    }
    triangle {
      < -6.841698, -0.362516, 2.816865>,
      < -6.805990, -0.331365, 2.711921>,
      < -6.841676, -0.425841, 2.775235>
    }
    triangle {
      < -6.837608, -0.529316, 2.444607>,
      < -6.801351, -0.463196, 2.447439>,
      < -6.837764, -0.521986, 2.345005>
    }
    triangle {
      < -6.839378, -0.519588, 2.551625>,
      < -6.801351, -0.463196, 2.447439>,
      < -6.837608, -0.529316, 2.444607>
    }
    triangle {
      < -6.841676, -0.425841, 2.775235>,
      < -6.805990, -0.331365, 2.711921>,
      < -6.841412, -0.471144, 2.722069>
    }
    texture {net}
  }
  // hood
  union {
    triangle {
      < -6.518058, 0.265439, 1.239676>,
      < -6.604657, 0.295554, 0.651380>,
      < -6.539279, 0.243124, 1.292395>
    }
    triangle {
      < -6.407199, 0.243124, 1.350899>,
      < -6.421206, 0.243124, 1.232237>,
      < -6.539279, 0.243124, 1.292395>
    }
    triangle {
      < -6.421206, 0.243124, 1.232237>,
      < -6.480494, 0.287964, 1.204414>,
      < -6.518058, 0.265439, 1.239676>
    }
    triangle {
      < -6.407199, 0.243124, 1.350899>,
      < -6.505096, 0.255659, 1.341405>,
      < -6.459274, 0.272179, 1.376115>
    }
    triangle {
      < -6.426589, 0.310700, 1.186610>,
      < -6.480494, 0.287964, 1.204414>,
      < -6.421206, 0.243124, 1.232237>
    }
    triangle {
      < -6.539279, 0.243124, 1.292395>,
      < -6.421206, 0.243124, 1.232237>,
      < -6.518058, 0.265439, 1.239676>
    }
    triangle {
      < -6.539279, 0.243124, 1.292395>,
      < -6.505096, 0.255659, 1.341405>,
      < -6.407199, 0.243124, 1.350899>
    }
    triangle {
      < -6.401817, 0.292686, 1.396527>,
      < -6.407199, 0.243124, 1.350899>,
      < -6.459274, 0.272179, 1.376115>
    }
    triangle {
      < -6.426589, 0.310700, 1.186610>,
      < -6.487709, 0.350544, 0.646443>,
      < -6.480494, 0.287964, 1.204414>
    }
    triangle {
      < -6.604657, 0.295554, 0.651380>,
      < -6.518058, 0.265439, 1.239676>,
      < -6.480494, 0.287964, 1.204414>
    }
    triangle {
      < -6.604657, 0.295554, 0.651380>,
      < -6.480494, 0.287964, 1.204414>,
      < -6.487709, 0.350544, 0.646443>
    }
    triangle {
      < -6.539279, 0.243124, 1.292395>,
      < -6.460075, 0.150510, 1.868090>,
      < -6.505096, 0.255659, 1.341405>
    }
    triangle {
      < -6.401817, 0.292686, 1.396527>,
      < -6.459274, 0.272179, 1.376115>,
      < -6.336598, 0.220499, 1.865870>
    }
    texture {hood}
  }
  // black
  union {
    triangle {
      < -6.750026, -0.319472, 2.052864>,
      < -6.726426, -0.319472, 2.052864>,
      < -6.726521, -0.394538, 2.074579>
    }
    triangle {
      < -6.750026, -0.319472, 2.052864>,
      < -6.726521, -0.394538, 2.074579>,
      < -6.750121, -0.394538, 2.074579>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.796567, -0.238610, 2.133832>,
      < -6.826804, -0.313709, 2.072241>,
      < -6.826890, -0.384413, 2.091931>
    }
    triangle {
      < -6.796567, -0.238610, 2.133832>,
      < -6.826890, -0.384413, 2.091931>,
      < -6.796764, -0.335362, 2.186019>
    }
    triangle {
      < -6.837920, -0.505056, 2.245336>,
      < -6.798798, -0.429527, 2.301943>,
      < -6.796764, -0.335362, 2.186019>
    }
    triangle {
      < -6.837920, -0.505056, 2.245336>,
      < -6.796764, -0.335362, 2.186019>,
      < -6.832448, -0.483480, 2.184819>
    }
    texture {net}
  }
  // black
  union {
    triangle {
      < -6.737687, -0.524475, 2.239201>,
      < -6.761287, -0.524475, 2.239201>,
      < -6.755751, -0.500433, 2.174088>
    }
    triangle {
      < -6.737687, -0.524475, 2.239201>,
      < -6.755751, -0.500433, 2.174088>,
      < -6.732151, -0.500433, 2.174088>
    }
    triangle {
      < -6.761287, -0.524475, 2.239201>,
      < -6.737687, -0.524475, 2.239201>,
      < -6.737584, -0.541778, 2.342008>
    }
    triangle {
      < -6.761287, -0.524475, 2.239201>,
      < -6.737584, -0.541778, 2.342008>,
      < -6.761184, -0.541778, 2.342008>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.798798, -0.429527, 2.301943>,
      < -6.837920, -0.505056, 2.245336>,
      < -6.837764, -0.521986, 2.345005>
    }
    triangle {
      < -6.798798, -0.429527, 2.301943>,
      < -6.837764, -0.521986, 2.345005>,
      < -6.801351, -0.463196, 2.447439>
    }
    triangle {
      < -6.841147, -0.500260, 2.658577>,
      < -6.803942, -0.428412, 2.595193>,
      < -6.801351, -0.463196, 2.447439>
    }
    triangle {
      < -6.841147, -0.500260, 2.658577>,
      < -6.801351, -0.463196, 2.447439>,
      < -6.839378, -0.519588, 2.551625>
    }
    texture {net}
  }
  // black
  union {
    triangle {
      < -6.741147, -0.519486, 2.665626>,
      < -6.764747, -0.519486, 2.665626>,
      < -6.762914, -0.539283, 2.555220>
    }
    triangle {
      < -6.741147, -0.519486, 2.665626>,
      < -6.762914, -0.539283, 2.555220>,
      < -6.739315, -0.539283, 2.555220>
    }
    triangle {
      < -6.764747, -0.519486, 2.665626>,
      < -6.741147, -0.519486, 2.665626>,
      < -6.741506, -0.487581, 2.733489>
    }
    triangle {
      < -6.764747, -0.519486, 2.665626>,
      < -6.741506, -0.487581, 2.733489>,
      < -6.765106, -0.487581, 2.733489>
    }
    texture {black}
  }
  // net
  union {
    triangle {
      < -6.803942, -0.428412, 2.595193>,
      < -6.841147, -0.500260, 2.658577>,
      < -6.841412, -0.471144, 2.722069>
    }
    triangle {
      < -6.803942, -0.428412, 2.595193>,
      < -6.841412, -0.471144, 2.722069>,
      < -6.805990, -0.331365, 2.711921>
    }
    triangle {
      < -6.841718, -0.289349, 2.836606>,
      < -6.806168, -0.232484, 2.763064>,
      < -6.805990, -0.331365, 2.711921>
    }
    triangle {
      < -6.841718, -0.289349, 2.836606>,
      < -6.805990, -0.331365, 2.711921>,
      < -6.841698, -0.362516, 2.816865>
    }
    texture {net}
  }
  // black
  union {
    triangle {
      < -6.742029, -0.294491, 2.856221>,
      < -6.765629, -0.294491, 2.856221>,
      < -6.765547, -0.371911, 2.834569>
    }
    triangle {
      < -6.742029, -0.294491, 2.856221>,
      < -6.765547, -0.371911, 2.834569>,
      < -6.741947, -0.371911, 2.834569>
    }
    texture {black}
  }
  // mirror
  union {
    triangle {
      < -1.550830, 1.688141, 0.016995>,
      < -1.535529, 1.677625, 0.016995>,
      < -1.498961, 1.728131, 0.016995>
    }
    triangle {
      < -1.550830, 1.688141, 0.016995>,
      < -1.498961, 1.728131, 0.016995>,
      < -1.520508, 1.733871, 0.016995>
    }
    triangle {
      < -1.499538, 1.798151, -0.016995>,
      < -1.406522, 1.798151, -0.016995>,
      < -1.406066, 1.784377, -0.016995>
    }
    triangle {
      < -1.499538, 1.798151, -0.016995>,
      < -1.406066, 1.784377, -0.016995>,
      < -1.493610, 1.780933, -0.016995>
    }
    triangle {
      < -1.499538, 1.798151, 0.016995>,
      < -1.406522, 1.798151, 0.016995>,
      < -1.405221, 1.798151, 0.000000>
    }
    triangle {
      < -1.499538, 1.798151, 0.016995>,
      < -1.405221, 1.798151, 0.000000>,
      < -1.501304, 1.798151, 0.000000>
    }
    triangle {
      < -1.406522, 1.798151, 0.016995>,
      < -1.406066, 1.784377, 0.016995>,
      < -1.404534, 1.781439, 0.000000>
    }
    triangle {
      < -1.406522, 1.798151, 0.016995>,
      < -1.404534, 1.781439, 0.000000>,
      < -1.405221, 1.798151, 0.000000>
    }
    triangle {
      < -1.406066, 1.784377, 0.016995>,
      < -1.457133, 1.760272, 0.016995>,
      < -1.456550, 1.755653, 0.000000>
    }
    triangle {
      < -1.406066, 1.784377, 0.016995>,
      < -1.456550, 1.755653, 0.000000>,
      < -1.404534, 1.781439, 0.000000>
    }
    triangle {
      < -1.457133, 1.760272, 0.016995>,
      < -1.498961, 1.728131, 0.016995>,
      < -1.497888, 1.724108, 0.000000>
    }
    triangle {
      < -1.457133, 1.760272, 0.016995>,
      < -1.497888, 1.724108, 0.000000>,
      < -1.456550, 1.755653, 0.000000>
    }
    triangle {
      < -1.498961, 1.728131, 0.016995>,
      < -1.535529, 1.677625, 0.016995>,
      < -1.531724, 1.674623, 0.000000>
    }
    triangle {
      < -1.498961, 1.728131, 0.016995>,
      < -1.531724, 1.674623, 0.000000>,
      < -1.497888, 1.724108, 0.000000>
    }
    triangle {
      < -1.535529, 1.677625, 0.016995>,
      < -1.578001, 1.603014, 0.016995>,
      < -1.573634, 1.600910, 0.000000>
    }
    triangle {
      < -1.535529, 1.677625, 0.016995>,
      < -1.573634, 1.600910, 0.000000>,
      < -1.531724, 1.674623, 0.000000>
    }
    triangle {
      < -1.578001, 1.603014, 0.016995>,
      < -1.612437, 1.516923, 0.016995>,
      < -1.607677, 1.516007, 0.000000>
    }
    triangle {
      < -1.578001, 1.603014, 0.016995>,
      < -1.607677, 1.516007, 0.000000>,
      < -1.573634, 1.600910, 0.000000>
    }
    triangle {
      < -1.586197, 1.557193, 0.364264>,
      < -1.587039, 1.543715, 0.371372>,
      < -1.584737, 1.432649, 0.351930>
    }
    triangle {
      < -1.586197, 1.557193, 0.364264>,
      < -1.584737, 1.432649, 0.351930>,
      < -1.582762, 1.420991, 0.335244>
    }
    triangle {
      < -1.612437, 1.474803, 0.000000>,
      < -1.612437, 1.479044, 0.016995>,
      < -1.639843, 1.491556, 0.003787>
    }
    triangle {
      < -1.612437, 1.474803, 0.000000>,
      < -1.639843, 1.491556, 0.003787>,
      < -1.639656, 1.490173, -0.001447>
    }
    triangle {
      < -1.629655, 1.513480, 0.016995>,
      < -1.633156, 1.516831, 0.000000>,
      < -1.640592, 1.506292, -0.001184>
    }
    triangle {
      < -1.629655, 1.513480, 0.016995>,
      < -1.640592, 1.506292, -0.001184>,
      < -1.640609, 1.504047, 0.005960>
    }
    triangle {
      < -1.629655, 1.513480, 0.016995>,
      < -1.594071, 1.608753, 0.016995>,
      < -1.598480, 1.610765, 0.000000>
    }
    triangle {
      < -1.629655, 1.513480, 0.016995>,
      < -1.598480, 1.610765, 0.000000>,
      < -1.633156, 1.516831, 0.000000>
    }
    triangle {
      < -1.594071, 1.608753, 0.016995>,
      < -1.550830, 1.688141, 0.016995>,
      < -1.554940, 1.690709, 0.000000>
    }
    triangle {
      < -1.594071, 1.608753, 0.016995>,
      < -1.554940, 1.690709, 0.000000>,
      < -1.598480, 1.610765, 0.000000>
    }
    triangle {
      < -1.550830, 1.688141, 0.016995>,
      < -1.520508, 1.733871, 0.016995>,
      < -1.524611, 1.736450, 0.000000>
    }
    triangle {
      < -1.550830, 1.688141, 0.016995>,
      < -1.524611, 1.736450, 0.000000>,
      < -1.554940, 1.690709, 0.000000>
    }
    triangle {
      < -1.520508, 1.733871, 0.016995>,
      < -1.492242, 1.767159, 0.016995>,
      < -1.494151, 1.767785, 0.000000>
    }
    triangle {
      < -1.520508, 1.733871, 0.016995>,
      < -1.494151, 1.767785, 0.000000>,
      < -1.524611, 1.736450, 0.000000>
    }
    triangle {
      < -1.492242, 1.767159, 0.016995>,
      < -1.493610, 1.780933, 0.016995>,
      < -1.495303, 1.778624, 0.000000>
    }
    triangle {
      < -1.492242, 1.767159, 0.016995>,
      < -1.495303, 1.778624, 0.000000>,
      < -1.494151, 1.767785, 0.000000>
    }
    triangle {
      < -1.493610, 1.780933, 0.016995>,
      < -1.499538, 1.798151, 0.016995>,
      < -1.501304, 1.798151, 0.000000>
    }
    triangle {
      < -1.493610, 1.780933, 0.016995>,
      < -1.501304, 1.798151, 0.000000>,
      < -1.495303, 1.778624, 0.000000>
    }
    triangle {
      < -1.457133, 1.760272, -0.016995>,
      < -1.406066, 1.784377, -0.016995>,
      < -1.404534, 1.781439, 0.000000>
    }
    triangle {
      < -1.457133, 1.760272, -0.016995>,
      < -1.404534, 1.781439, 0.000000>,
      < -1.456550, 1.755653, 0.000000>
    }
    triangle {
      < -1.406066, 1.784377, -0.016995>,
      < -1.406522, 1.798151, -0.016995>,
      < -1.405221, 1.798151, 0.000000>
    }
    triangle {
      < -1.406066, 1.784377, -0.016995>,
      < -1.405221, 1.798151, 0.000000>,
      < -1.404534, 1.781439, 0.000000>
    }
    triangle {
      < -1.406522, 1.798151, -0.016995>,
      < -1.499538, 1.798151, -0.016995>,
      < -1.501304, 1.798151, 0.000000>
    }
    triangle {
      < -1.406522, 1.798151, -0.016995>,
      < -1.501304, 1.798151, 0.000000>,
      < -1.405221, 1.798151, 0.000000>
    }
    triangle {
      < -1.499538, 1.798151, -0.016995>,
      < -1.493610, 1.780933, -0.016995>,
      < -1.495303, 1.778624, 0.000000>
    }
    triangle {
      < -1.499538, 1.798151, -0.016995>,
      < -1.495303, 1.778624, 0.000000>,
      < -1.501304, 1.798151, 0.000000>
    }
    triangle {
      < -1.493610, 1.780933, -0.016995>,
      < -1.492242, 1.767159, -0.016995>,
      < -1.494151, 1.767785, 0.000000>
    }
    triangle {
      < -1.493610, 1.780933, -0.016995>,
      < -1.494151, 1.767785, 0.000000>,
      < -1.495303, 1.778624, 0.000000>
    }
    triangle {
      < -1.492242, 1.767159, -0.016995>,
      < -1.520508, 1.733871, -0.016995>,
      < -1.524611, 1.736450, 0.000000>
    }
    triangle {
      < -1.492242, 1.767159, -0.016995>,
      < -1.524611, 1.736450, 0.000000>,
      < -1.494151, 1.767785, 0.000000>
    }
    triangle {
      < -1.520508, 1.733871, -0.016995>,
      < -1.550830, 1.688141, -0.016995>,
      < -1.554940, 1.690709, 0.000000>
    }
    triangle {
      < -1.520508, 1.733871, -0.016995>,
      < -1.554940, 1.690709, 0.000000>,
      < -1.524611, 1.736450, 0.000000>
    }
    triangle {
      < -1.550830, 1.688141, -0.016995>,
      < -1.594071, 1.608753, -0.016995>,
      < -1.598480, 1.610765, 0.000000>
    }
    triangle {
      < -1.550830, 1.688141, -0.016995>,
      < -1.598480, 1.610765, 0.000000>,
      < -1.554940, 1.690709, 0.000000>
    }
    triangle {
      < -1.594071, 1.608753, -0.016995>,
      < -1.629655, 1.513480, -0.016995>,
      < -1.633156, 1.516831, 0.000000>
    }
    triangle {
      < -1.594071, 1.608753, -0.016995>,
      < -1.633156, 1.516831, 0.000000>,
      < -1.598480, 1.610765, 0.000000>
    }
    triangle {
      < -1.633156, 1.516831, 0.000000>,
      < -1.629655, 1.513480, -0.016995>,
      < -1.640318, 1.504167, -0.008586>
    }
    triangle {
      < -1.633156, 1.516831, 0.000000>,
      < -1.640318, 1.504167, -0.008586>,
      < -1.640592, 1.506292, -0.001184>
    }
    triangle {
      < -1.612437, 1.479044, -0.016995>,
      < -1.612437, 1.474803, 0.000000>,
      < -1.639656, 1.490173, -0.001447>
    }
    triangle {
      < -1.612437, 1.479044, -0.016995>,
      < -1.639656, 1.490173, -0.001447>,
      < -1.639624, 1.491485, -0.006753>
    }
    triangle {
      < -1.612437, 1.516923, -0.016995>,
      < -1.578001, 1.603014, -0.016995>,
      < -1.573634, 1.600910, 0.000000>
    }
    triangle {
      < -1.612437, 1.516923, -0.016995>,
      < -1.573634, 1.600910, 0.000000>,
      < -1.607677, 1.516007, 0.000000>
    }
    triangle {
      < -1.578001, 1.603014, -0.016995>,
      < -1.535529, 1.677625, -0.016995>,
      < -1.531724, 1.674623, 0.000000>
    }
    triangle {
      < -1.578001, 1.603014, -0.016995>,
      < -1.531724, 1.674623, 0.000000>,
      < -1.573634, 1.600910, 0.000000>
    }
    triangle {
      < -1.535529, 1.677625, -0.016995>,
      < -1.498961, 1.728131, -0.016995>,
      < -1.497888, 1.724108, 0.000000>
    }
    triangle {
      < -1.535529, 1.677625, -0.016995>,
      < -1.497888, 1.724108, 0.000000>,
      < -1.531724, 1.674623, 0.000000>
    }
    triangle {
      < -1.498961, 1.728131, -0.016995>,
      < -1.457133, 1.760272, -0.016995>,
      < -1.456550, 1.755653, 0.000000>
    }
    triangle {
      < -1.498961, 1.728131, -0.016995>,
      < -1.456550, 1.755653, 0.000000>,
      < -1.497888, 1.724108, 0.000000>
    }
    triangle {
      < -1.492242, 1.767159, 0.016995>,
      < -1.457133, 1.760272, 0.016995>,
      < -1.406066, 1.784377, 0.016995>
    }
    triangle {
      < -1.492242, 1.767159, 0.016995>,
      < -1.406066, 1.784377, 0.016995>,
      < -1.493610, 1.780933, 0.016995>
    }
    triangle {
      < -1.520508, 1.733871, 0.016995>,
      < -1.498961, 1.728131, 0.016995>,
      < -1.457133, 1.760272, 0.016995>
    }
    triangle {
      < -1.520508, 1.733871, 0.016995>,
      < -1.457133, 1.760272, 0.016995>,
      < -1.492242, 1.767159, 0.016995>
    }
    triangle {
      < -1.629655, 1.513480, 0.016995>,
      < -1.612437, 1.516923, 0.016995>,
      < -1.578001, 1.603014, 0.016995>
    }
    triangle {
      < -1.629655, 1.513480, 0.016995>,
      < -1.578001, 1.603014, 0.016995>,
      < -1.594071, 1.608753, 0.016995>
    }
    triangle {
      < -1.640609, 1.504047, 0.005960>,
      < -1.640328, 1.498679, 0.007389>,
      < -1.612437, 1.502282, 0.029550>
    }
    triangle {
      < -1.640609, 1.504047, 0.005960>,
      < -1.612437, 1.502282, 0.029550>,
      < -1.629655, 1.513480, 0.016995>
    }
    triangle {
      < -1.594071, 1.608753, 0.016995>,
      < -1.578001, 1.603014, 0.016995>,
      < -1.535529, 1.677625, 0.016995>
    }
    triangle {
      < -1.594071, 1.608753, 0.016995>,
      < -1.535529, 1.677625, 0.016995>,
      < -1.550830, 1.688141, 0.016995>
    }
    triangle {
      < -1.612437, 1.502282, -0.029550>,
      < -1.612437, 1.490022, -0.029550>,
      < -1.639743, 1.494928, -0.010614>
    }
    triangle {
      < -1.612437, 1.502282, -0.029550>,
      < -1.639743, 1.494928, -0.010614>,
      < -1.639964, 1.498711, -0.010505>
    }
    triangle {
      < -1.550830, 1.688141, -0.016995>,
      < -1.535529, 1.677625, -0.016995>,
      < -1.578001, 1.603014, -0.016995>
    }
    triangle {
      < -1.550830, 1.688141, -0.016995>,
      < -1.578001, 1.603014, -0.016995>,
      < -1.594071, 1.608753, -0.016995>
    }
    triangle {
      < -1.520508, 1.733871, -0.016995>,
      < -1.498961, 1.728131, -0.016995>,
      < -1.535529, 1.677625, -0.016995>
    }
    triangle {
      < -1.520508, 1.733871, -0.016995>,
      < -1.535529, 1.677625, -0.016995>,
      < -1.550830, 1.688141, -0.016995>
    }
    triangle {
      < -1.594071, 1.608753, -0.016995>,
      < -1.578001, 1.603014, -0.016995>,
      < -1.612437, 1.516923, -0.016995>
    }
    triangle {
      < -1.594071, 1.608753, -0.016995>,
      < -1.612437, 1.516923, -0.016995>,
      < -1.629655, 1.513480, -0.016995>
    }
    triangle {
      < -1.498961, 1.728131, -0.016995>,
      < -1.520508, 1.733871, -0.016995>,
      < -1.492242, 1.767159, -0.016995>
    }
    triangle {
      < -1.498961, 1.728131, -0.016995>,
      < -1.492242, 1.767159, -0.016995>,
      < -1.457133, 1.760272, -0.016995>
    }
    triangle {
      < -1.406522, 1.798151, 0.016995>,
      < -1.499538, 1.798151, 0.016995>,
      < -1.493610, 1.780933, 0.016995>
    }
    triangle {
      < -1.406522, 1.798151, 0.016995>,
      < -1.493610, 1.780933, 0.016995>,
      < -1.406066, 1.784377, 0.016995>
    }
    triangle {
      < -1.457133, 1.760272, -0.016995>,
      < -1.492242, 1.767159, -0.016995>,
      < -1.493610, 1.780933, -0.016995>
    }
    triangle {
      < -1.457133, 1.760272, -0.016995>,
      < -1.493610, 1.780933, -0.016995>,
      < -1.406066, 1.784377, -0.016995>
    }
    triangle {
      < -1.612437, 1.479044, 0.016995>,
      < -1.612437, 1.490022, 0.029550>,
      < -1.640117, 1.494977, 0.007507>
    }
    triangle {
      < -1.612437, 1.479044, 0.016995>,
      < -1.640117, 1.494977, 0.007507>,
      < -1.639843, 1.491556, 0.003787>
    }
    triangle {
      < -1.612437, 1.490022, 0.029550>,
      < -1.612437, 1.502282, 0.029550>,
      < -1.640328, 1.498679, 0.007389>
    }
    triangle {
      < -1.612437, 1.490022, 0.029550>,
      < -1.640328, 1.498679, 0.007389>,
      < -1.640117, 1.494977, 0.007507>
    }
    triangle {
      < -1.629655, 1.513480, -0.016995>,
      < -1.612437, 1.502282, -0.029550>,
      < -1.639964, 1.498711, -0.010505>
    }
    triangle {
      < -1.629655, 1.513480, -0.016995>,
      < -1.639964, 1.498711, -0.010505>,
      < -1.640318, 1.504167, -0.008586>
    }
    triangle {
      < -1.612437, 1.490022, -0.029550>,
      < -1.612437, 1.479044, -0.016995>,
      < -1.639624, 1.491485, -0.006753>
    }
    triangle {
      < -1.612437, 1.490022, -0.029550>,
      < -1.639624, 1.491485, -0.006753>,
      < -1.639743, 1.494928, -0.010614>
    }
    triangle {
      < -1.607677, 1.516007, 0.000000>,
      < -1.612437, 1.516923, 0.016995>,
      < -1.612437, 1.516923, -0.016995>
    }
    triangle {
      < -1.612437, 1.498641, 0.010667>,
      < -1.612437, 1.504302, 0.006128>,
      < -1.612437, 1.516923, 0.016995>
    }
    triangle {
      < -1.612437, 1.498641, 0.010667>,
      < -1.612437, 1.516923, 0.016995>,
      < -1.612437, 1.502282, 0.029550>
    }
    triangle {
      < -1.612437, 1.504302, 0.006128>,
      < -1.612437, 1.504302, -0.006128>,
      < -1.612437, 1.516923, -0.016995>
    }
    triangle {
      < -1.612437, 1.504302, 0.006128>,
      < -1.612437, 1.516923, -0.016995>,
      < -1.612437, 1.516923, 0.016995>
    }
    triangle {
      < -1.612437, 1.504302, -0.006128>,
      < -1.612437, 1.498641, -0.010667>,
      < -1.612437, 1.502282, -0.029550>
    }
    triangle {
      < -1.612437, 1.504302, -0.006128>,
      < -1.612437, 1.502282, -0.029550>,
      < -1.612437, 1.516923, -0.016995>
    }
    triangle {
      < -1.612437, 1.498641, -0.010667>,
      < -1.612437, 1.494554, -0.010667>,
      < -1.612437, 1.490022, -0.029550>
    }
    triangle {
      < -1.612437, 1.498641, -0.010667>,
      < -1.612437, 1.490022, -0.029550>,
      < -1.612437, 1.502282, -0.029550>
    }
    triangle {
      < -1.612437, 1.494554, -0.010667>,
      < -1.612437, 1.490250, -0.005899>,
      < -1.612437, 1.479044, -0.016995>
    }
    triangle {
      < -1.612437, 1.494554, -0.010667>,
      < -1.612437, 1.479044, -0.016995>,
      < -1.612437, 1.490022, -0.029550>
    }
    triangle {
      < -1.612437, 1.490250, -0.005899>,
      < -1.612437, 1.474803, 0.000000>,
      < -1.612437, 1.479044, -0.016995>
    }
    triangle {
      < -1.612437, 1.490250, 0.005899>,
      < -1.612437, 1.479044, 0.016995>,
      < -1.612437, 1.474803, 0.000000>
    }
    triangle {
      < -1.612437, 1.490250, 0.005899>,
      < -1.612437, 1.494554, 0.010667>,
      < -1.612437, 1.490022, 0.029550>
    }
    triangle {
      < -1.612437, 1.490250, 0.005899>,
      < -1.612437, 1.490022, 0.029550>,
      < -1.612437, 1.479044, 0.016995>
    }
    triangle {
      < -1.612437, 1.494554, 0.010667>,
      < -1.612437, 1.498641, 0.010667>,
      < -1.612437, 1.502282, 0.029550>
    }
    triangle {
      < -1.612437, 1.494554, 0.010667>,
      < -1.612437, 1.502282, 0.029550>,
      < -1.612437, 1.490022, 0.029550>
    }
    triangle {
      < -1.612437, 1.490250, 0.005899>,
      < -1.612437, 1.474803, 0.000000>,
      < -1.612437, 1.490250, -0.005899>
    }
    triangle {
      < -1.571896, 1.490250, -0.006243>,
      < -1.573280, 1.490250, 0.005445>,
      < -1.612437, 1.490250, 0.005899>
    }
    triangle {
      < -1.571896, 1.490250, -0.006243>,
      < -1.612437, 1.490250, 0.005899>,
      < -1.612437, 1.490250, -0.005899>
    }
    triangle {
      < -1.573280, 1.490250, 0.005445>,
      < -1.573839, 1.494554, 0.010169>,
      < -1.612437, 1.494554, 0.010667>
    }
    triangle {
      < -1.573280, 1.490250, 0.005445>,
      < -1.612437, 1.494554, 0.010667>,
      < -1.612437, 1.490250, 0.005899>
    }
    triangle {
      < -1.573839, 1.494554, 0.010169>,
      < -1.573839, 1.498641, 0.010169>,
      < -1.612437, 1.498641, 0.010667>
    }
    triangle {
      < -1.573839, 1.494554, 0.010169>,
      < -1.612437, 1.498641, 0.010667>,
      < -1.612437, 1.494554, 0.010667>
    }
    triangle {
      < -1.573839, 1.498641, 0.010169>,
      < -1.573307, 1.504302, 0.005672>,
      < -1.612437, 1.504302, 0.006128>
    }
    triangle {
      < -1.573839, 1.498641, 0.010169>,
      < -1.612437, 1.504302, 0.006128>,
      < -1.612437, 1.498641, 0.010667>
    }
    triangle {
      < -1.573307, 1.504302, 0.005672>,
      < -1.571869, 1.504302, -0.006470>,
      < -1.612437, 1.504302, -0.006128>
    }
    triangle {
      < -1.573307, 1.504302, 0.005672>,
      < -1.612437, 1.504302, -0.006128>,
      < -1.612437, 1.504302, 0.006128>
    }
    triangle {
      < -1.571869, 1.504302, -0.006470>,
      < -1.571337, 1.498641, -0.010966>,
      < -1.612437, 1.498641, -0.010667>
    }
    triangle {
      < -1.571869, 1.504302, -0.006470>,
      < -1.612437, 1.498641, -0.010667>,
      < -1.612437, 1.504302, -0.006128>
    }
    triangle {
      < -1.571337, 1.498641, -0.010966>,
      < -1.571337, 1.494554, -0.010966>,
      < -1.612437, 1.494554, -0.010667>
    }
    triangle {
      < -1.571337, 1.498641, -0.010966>,
      < -1.612437, 1.494554, -0.010667>,
      < -1.612437, 1.498641, -0.010667>
    }
    triangle {
      < -1.571337, 1.494554, -0.010966>,
      < -1.571896, 1.490250, -0.006243>,
      < -1.612437, 1.490250, -0.005899>
    }
    triangle {
      < -1.571337, 1.494554, -0.010966>,
      < -1.612437, 1.490250, -0.005899>,
      < -1.612437, 1.494554, -0.010667>
    }
    triangle {
      < -1.510422, 1.543715, -0.364559>,
      < -1.571337, 1.498641, -0.010966>,
      < -1.511263, 1.557193, -0.357450>
    }
    triangle {
      < -1.510422, 1.543715, -0.364559>,
      < -1.512723, 1.432649, -0.345116>,
      < -1.571337, 1.494554, -0.010966>
    }
    triangle {
      < -1.510422, 1.543715, -0.364559>,
      < -1.571337, 1.494554, -0.010966>,
      < -1.571337, 1.498641, -0.010966>
    }
    triangle {
      < -1.514698, 1.420991, -0.328431>,
      < -1.516977, 1.414307, -0.309181>,
      < -1.571896, 1.490250, -0.006243>
    }
    triangle {
      < -1.514698, 1.420991, -0.328431>,
      < -1.571896, 1.490250, -0.006243>,
      < -1.571337, 1.494554, -0.010966>
    }
    triangle {
      < -1.519559, 1.412598, -0.287366>,
      < -1.588204, 1.412598, 0.292536>,
      < -1.573280, 1.490250, 0.005445>
    }
    triangle {
      < -1.519559, 1.412598, -0.287366>,
      < -1.573280, 1.490250, 0.005445>,
      < -1.571896, 1.490250, -0.006243>
    }
    triangle {
      < -1.588204, 1.412598, 0.292536>,
      < -1.590787, 1.414307, 0.314351>,
      < -1.573280, 1.490250, 0.005445>
    }
    triangle {
      < -1.595040, 1.432649, 0.350286>,
      < -1.597342, 1.543715, 0.369729>,
      < -1.573839, 1.498641, 0.010169>
    }
    triangle {
      < -1.595040, 1.432649, 0.350286>,
      < -1.573839, 1.498641, 0.010169>,
      < -1.573839, 1.494554, 0.010169>
    }
    triangle {
      < -1.596501, 1.557193, 0.362620>,
      < -1.594173, 1.565984, 0.342953>,
      < -1.573307, 1.504302, 0.005672>
    }
    triangle {
      < -1.596501, 1.557193, 0.362620>,
      < -1.573307, 1.504302, 0.005672>,
      < -1.573839, 1.498641, 0.010169>
    }
    triangle {
      < -1.590530, 1.570087, 0.312182>,
      < -1.517233, 1.570087, -0.307012>,
      < -1.571869, 1.504302, -0.006470>
    }
    triangle {
      < -1.590530, 1.570087, 0.312182>,
      < -1.571869, 1.504302, -0.006470>,
      < -1.573307, 1.504302, 0.005672>
    }
    triangle {
      < -1.612437, 1.516923, -0.016995>,
      < -1.612437, 1.502282, -0.029550>,
      < -1.629655, 1.513480, -0.016995>
    }
    triangle {
      < -1.612437, 1.516923, 0.016995>,
      < -1.629655, 1.513480, 0.016995>,
      < -1.612437, 1.502282, 0.029550>
    }
    triangle {
      < -1.587039, 1.543715, 0.371372>,
      < -1.586197, 1.557193, 0.364264>,
      < -1.596501, 1.557193, 0.362620>
    }
    triangle {
      < -1.587039, 1.543715, 0.371372>,
      < -1.596501, 1.557193, 0.362620>,
      < -1.597342, 1.543715, 0.369729>
    }
    triangle {
      < -1.586197, 1.557193, 0.364264>,
      < -1.583869, 1.565984, 0.344597>,
      < -1.594173, 1.565984, 0.342953>
    }
    triangle {
      < -1.586197, 1.557193, 0.364264>,
      < -1.594173, 1.565984, 0.342953>,
      < -1.596501, 1.557193, 0.362620>
    }
    triangle {
      < -1.583869, 1.565984, 0.344597>,
      < -1.580227, 1.570087, 0.313826>,
      < -1.590530, 1.570087, 0.312182>
    }
    triangle {
      < -1.583869, 1.565984, 0.344597>,
      < -1.590530, 1.570087, 0.312182>,
      < -1.594173, 1.565984, 0.342953>
    }
    triangle {
      < -1.580227, 1.570087, 0.313826>,
      < -1.506930, 1.570087, -0.305369>,
      < -1.517233, 1.570087, -0.307012>
    }
    triangle {
      < -1.580227, 1.570087, 0.313826>,
      < -1.517233, 1.570087, -0.307012>,
      < -1.590530, 1.570087, 0.312182>
    }
    triangle {
      < -1.506930, 1.570087, -0.305369>,
      < -1.503288, 1.565984, -0.336140>,
      < -1.513591, 1.565984, -0.337784>
    }
    triangle {
      < -1.506930, 1.570087, -0.305369>,
      < -1.513591, 1.565984, -0.337784>,
      < -1.517233, 1.570087, -0.307012>
    }
    triangle {
      < -1.503288, 1.565984, -0.336140>,
      < -1.500960, 1.557193, -0.355807>,
      < -1.511263, 1.557193, -0.357450>
    }
    triangle {
      < -1.503288, 1.565984, -0.336140>,
      < -1.511263, 1.557193, -0.357450>,
      < -1.513591, 1.565984, -0.337784>
    }
    triangle {
      < -1.500960, 1.557193, -0.355807>,
      < -1.500118, 1.543715, -0.362915>,
      < -1.510422, 1.543715, -0.364559>
    }
    triangle {
      < -1.500960, 1.557193, -0.355807>,
      < -1.510422, 1.543715, -0.364559>,
      < -1.511263, 1.557193, -0.357450>
    }
    triangle {
      < -1.500118, 1.543715, -0.362915>,
      < -1.502420, 1.432649, -0.343473>,
      < -1.512723, 1.432649, -0.345116>
    }
    triangle {
      < -1.500118, 1.543715, -0.362915>,
      < -1.512723, 1.432649, -0.345116>,
      < -1.510422, 1.543715, -0.364559>
    }
    triangle {
      < -1.502420, 1.432649, -0.343473>,
      < -1.504395, 1.420991, -0.326788>,
      < -1.514698, 1.420991, -0.328431>
    }
    triangle {
      < -1.502420, 1.432649, -0.343473>,
      < -1.514698, 1.420991, -0.328431>,
      < -1.512723, 1.432649, -0.345116>
    }
    triangle {
      < -1.504395, 1.420991, -0.326788>,
      < -1.506673, 1.414307, -0.307537>,
      < -1.516977, 1.414307, -0.309181>
    }
    triangle {
      < -1.504395, 1.420991, -0.326788>,
      < -1.516977, 1.414307, -0.309181>,
      < -1.514698, 1.420991, -0.328431>
    }
    triangle {
      < -1.506673, 1.414307, -0.307537>,
      < -1.509256, 1.412598, -0.285722>,
      < -1.519559, 1.412598, -0.287366>
    }
    triangle {
      < -1.506673, 1.414307, -0.307537>,
      < -1.519559, 1.412598, -0.287366>,
      < -1.516977, 1.414307, -0.309181>
    }
    triangle {
      < -1.509256, 1.412598, -0.285722>,
      < -1.577901, 1.412598, 0.294179>,
      < -1.588204, 1.412598, 0.292536>
    }
    triangle {
      < -1.509256, 1.412598, -0.285722>,
      < -1.588204, 1.412598, 0.292536>,
      < -1.519559, 1.412598, -0.287366>
    }
    triangle {
      < -1.577901, 1.412598, 0.294179>,
      < -1.580483, 1.414307, 0.315994>,
      < -1.590787, 1.414307, 0.314351>
    }
    triangle {
      < -1.577901, 1.412598, 0.294179>,
      < -1.590787, 1.414307, 0.314351>,
      < -1.588204, 1.412598, 0.292536>
    }
    triangle {
      < -1.580483, 1.414307, 0.315994>,
      < -1.582762, 1.420991, 0.335244>,
      < -1.593066, 1.420991, 0.333601>
    }
    triangle {
      < -1.580483, 1.414307, 0.315994>,
      < -1.593066, 1.420991, 0.333601>,
      < -1.590787, 1.414307, 0.314351>
    }
    triangle {
      < -1.582762, 1.420991, 0.335244>,
      < -1.584737, 1.432649, 0.351930>,
      < -1.595040, 1.432649, 0.350286>
    }
    triangle {
      < -1.582762, 1.420991, 0.335244>,
      < -1.595040, 1.432649, 0.350286>,
      < -1.593066, 1.420991, 0.333601>
    }
    triangle {
      < -1.584737, 1.432649, 0.351930>,
      < -1.587039, 1.543715, 0.371372>,
      < -1.597342, 1.543715, 0.369729>
    }
    triangle {
      < -1.584737, 1.432649, 0.351930>,
      < -1.597342, 1.543715, 0.369729>,
      < -1.595040, 1.432649, 0.350286>
    }
    triangle {
      < -1.517233, 1.570087, -0.307012>,
      < -1.513591, 1.565984, -0.337784>,
      < -1.571869, 1.504302, -0.006470>
    }
    triangle {
      < -1.512723, 1.432649, -0.345116>,
      < -1.514698, 1.420991, -0.328431>,
      < -1.571337, 1.494554, -0.010966>
    }
    triangle {
      < -1.595040, 1.432649, 0.350286>,
      < -1.573839, 1.494554, 0.010169>,
      < -1.593066, 1.420991, 0.333601>
    }
    triangle {
      < -1.597342, 1.543715, 0.369729>,
      < -1.596501, 1.557193, 0.362620>,
      < -1.573839, 1.498641, 0.010169>
    }
    triangle {
      < -1.571869, 1.504302, -0.006470>,
      < -1.513591, 1.565984, -0.337784>,
      < -1.511263, 1.557193, -0.357450>
    }
    triangle {
      < -1.571869, 1.504302, -0.006470>,
      < -1.511263, 1.557193, -0.357450>,
      < -1.571337, 1.498641, -0.010966>
    }
    triangle {
      < -1.590530, 1.570087, 0.312182>,
      < -1.573307, 1.504302, 0.005672>,
      < -1.594173, 1.565984, 0.342953>
    }
    triangle {
      < -1.573280, 1.490250, 0.005445>,
      < -1.590787, 1.414307, 0.314351>,
      < -1.593066, 1.420991, 0.333601>
    }
    triangle {
      < -1.573280, 1.490250, 0.005445>,
      < -1.593066, 1.420991, 0.333601>,
      < -1.573839, 1.494554, 0.010169>
    }
    triangle {
      < -1.519559, 1.412598, -0.287366>,
      < -1.571896, 1.490250, -0.006243>,
      < -1.516977, 1.414307, -0.309181>
    }
    triangle {
      < -1.577901, 1.412598, 0.294179>,
      < -1.580227, 1.570087, 0.313826>,
      < -1.583869, 1.565984, 0.344597>
    }
    triangle {
      < -1.577901, 1.412598, 0.294179>,
      < -1.583869, 1.565984, 0.344597>,
      < -1.580483, 1.414307, 0.315994>
    }
    triangle {
      < -1.586197, 1.557193, 0.364264>,
      < -1.582762, 1.420991, 0.335244>,
      < -1.580483, 1.414307, 0.315994>
    }
    triangle {
      < -1.586197, 1.557193, 0.364264>,
      < -1.580483, 1.414307, 0.315994>,
      < -1.583869, 1.565984, 0.344597>
    }
    triangle {
      < -1.506673, 1.414307, -0.307537>,
      < -1.503288, 1.565984, -0.336140>,
      < -1.506930, 1.570087, -0.305369>
    }
    triangle {
      < -1.506673, 1.414307, -0.307537>,
      < -1.506930, 1.570087, -0.305369>,
      < -1.509256, 1.412598, -0.285722>
    }
    triangle {
      < -1.580227, 1.570087, 0.313826>,
      < -1.577901, 1.412598, 0.294179>,
      < -1.509256, 1.412598, -0.285722>
    }
    triangle {
      < -1.580227, 1.570087, 0.313826>,
      < -1.509256, 1.412598, -0.285722>,
      < -1.506930, 1.570087, -0.305369>
    }
    triangle {
      < -1.502420, 1.432649, -0.343473>,
      < -1.500118, 1.543715, -0.362915>,
      < -1.500960, 1.557193, -0.355807>
    }
    triangle {
      < -1.502420, 1.432649, -0.343473>,
      < -1.500960, 1.557193, -0.355807>,
      < -1.504395, 1.420991, -0.326788>
    }
    triangle {
      < -1.503288, 1.565984, -0.336140>,
      < -1.506673, 1.414307, -0.307537>,
      < -1.504395, 1.420991, -0.326788>
    }
    triangle {
      < -1.503288, 1.565984, -0.336140>,
      < -1.504395, 1.420991, -0.326788>,
      < -1.500960, 1.557193, -0.355807>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.640318, 1.504167, -0.008586>,
      < -1.639964, 1.498711, -0.010505>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.640592, 1.506292, -0.001184>,
      < -1.640318, 1.504167, -0.008586>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.640609, 1.504047, 0.005960>,
      < -1.640592, 1.506292, -0.001184>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.640328, 1.498679, 0.007389>,
      < -1.640609, 1.504047, 0.005960>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.640117, 1.494977, 0.007507>,
      < -1.640328, 1.498679, 0.007389>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.639843, 1.491556, 0.003787>,
      < -1.640117, 1.494977, 0.007507>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.639656, 1.490173, -0.001447>,
      < -1.639843, 1.491556, 0.003787>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.639624, 1.491485, -0.006753>,
      < -1.639656, 1.490173, -0.001447>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.639743, 1.494928, -0.010614>,
      < -1.639624, 1.491485, -0.006753>
    }
    triangle {
      < -1.641291, 1.497501, -0.001445>,
      < -1.639964, 1.498711, -0.010505>,
      < -1.639743, 1.494928, -0.010614>
    }
    texture {mirror}
  }
  // logo
  union {
    triangle {
      < 8.453187, -0.082831, -0.136370>,
      < 8.454281, -0.089033, -0.135357>,
      < 8.445457, -0.093631, -0.144457>
    }
    triangle {
      < 8.453187, -0.082831, -0.136370>,
      < 8.445457, -0.093631, -0.144457>,
      < 8.443847, -0.084506, -0.145950>
    }
    triangle {
      < 8.456572, -0.103650, -0.291688>,
      < 8.445619, -0.095815, -0.270373>,
      < 8.445673, -0.095561, -0.223416>
    }
    triangle {
      < 8.456572, -0.103650, -0.291688>,
      < 8.445673, -0.095561, -0.223416>,
      < 8.456655, -0.103263, -0.223350>
    }
    triangle {
      < 8.454302, -0.088934, -0.096672>,
      < 8.453209, -0.082728, -0.095689>,
      < 8.443879, -0.084354, -0.086094>
    }
    triangle {
      < 8.454302, -0.088934, -0.096672>,
      < 8.443879, -0.084354, -0.086094>,
      < 8.445489, -0.093486, -0.087541>
    }
    triangle {
      < 8.453209, -0.082728, -0.095689>,
      < 8.452114, -0.076526, -0.096697>,
      < 8.442270, -0.075229, -0.087575>
    }
    triangle {
      < 8.453209, -0.082728, -0.095689>,
      < 8.442270, -0.075229, -0.087575>,
      < 8.443879, -0.084354, -0.086094>
    }
    triangle {
      < 8.452114, -0.076526, -0.096697>,
      < 8.451126, -0.070936, -0.099598>,
      < 8.440816, -0.067002, -0.091843>
    }
    triangle {
      < 8.452114, -0.076526, -0.096697>,
      < 8.440816, -0.067002, -0.091843>,
      < 8.442270, -0.075229, -0.087575>
    }
    triangle {
      < 8.451126, -0.070936, -0.099598>,
      < 8.450340, -0.066504, -0.104109>,
      < 8.439661, -0.060480, -0.098480>
    }
    triangle {
      < 8.451126, -0.070936, -0.099598>,
      < 8.439661, -0.060480, -0.098480>,
      < 8.440816, -0.067002, -0.091843>
    }
    triangle {
      < 8.450340, -0.066504, -0.104109>,
      < 8.449834, -0.063666, -0.109788>,
      < 8.438915, -0.056303, -0.106836>
    }
    triangle {
      < 8.450340, -0.066504, -0.104109>,
      < 8.438915, -0.056303, -0.106836>,
      < 8.439661, -0.060480, -0.098480>
    }
    triangle {
      < 8.449834, -0.063666, -0.109788>,
      < 8.449659, -0.062699, -0.116079>,
      < 8.438657, -0.054880, -0.116094>
    }
    triangle {
      < 8.449834, -0.063666, -0.109788>,
      < 8.438657, -0.054880, -0.116094>,
      < 8.438915, -0.056303, -0.106836>
    }
    triangle {
      < 8.449659, -0.062699, -0.116079>,
      < 8.449829, -0.063698, -0.122365>,
      < 8.438908, -0.056350, -0.125344>
    }
    triangle {
      < 8.449659, -0.062699, -0.116079>,
      < 8.438908, -0.056350, -0.125344>,
      < 8.438657, -0.054880, -0.116094>
    }
    triangle {
      < 8.449829, -0.063698, -0.122365>,
      < 8.450328, -0.066565, -0.128031>,
      < 8.439641, -0.060569, -0.133680>
    }
    triangle {
      < 8.449829, -0.063698, -0.122365>,
      < 8.439641, -0.060569, -0.133680>,
      < 8.438908, -0.056350, -0.125344>
    }
    triangle {
      < 8.450328, -0.066565, -0.128031>,
      < 8.451109, -0.071020, -0.132519>,
      < 8.440790, -0.067125, -0.140286>
    }
    triangle {
      < 8.450328, -0.066565, -0.128031>,
      < 8.440790, -0.067125, -0.140286>,
      < 8.439641, -0.060569, -0.133680>
    }
    triangle {
      < 8.451109, -0.071020, -0.132519>,
      < 8.452093, -0.076625, -0.135393>,
      < 8.442239, -0.075374, -0.144513>
    }
    triangle {
      < 8.451109, -0.071020, -0.132519>,
      < 8.442239, -0.075374, -0.144513>,
      < 8.440790, -0.067125, -0.140286>
    }
    triangle {
      < 8.452093, -0.076625, -0.135393>,
      < 8.453187, -0.082831, -0.136370>,
      < 8.443847, -0.084506, -0.145950>
    }
    triangle {
      < 8.452093, -0.076625, -0.135393>,
      < 8.443847, -0.084506, -0.145950>,
      < 8.442239, -0.075374, -0.144513>
    }
    triangle {
      < 8.442348, -0.075851, -0.122363>,
      < 8.442761, -0.078206, -0.124736>,
      < 8.451109, -0.071020, -0.132519>
    }
    triangle {
      < 8.442348, -0.075851, -0.122363>,
      < 8.451109, -0.071020, -0.132519>,
      < 8.450328, -0.066565, -0.128031>
    }
    triangle {
      < 8.442761, -0.078206, -0.124736>,
      < 8.443282, -0.081168, -0.126255>,
      < 8.452093, -0.076625, -0.135393>
    }
    triangle {
      < 8.442761, -0.078206, -0.124736>,
      < 8.452093, -0.076625, -0.135393>,
      < 8.451109, -0.071020, -0.132519>
    }
    triangle {
      < 8.443282, -0.081168, -0.126255>,
      < 8.443859, -0.084449, -0.126773>,
      < 8.453187, -0.082831, -0.136370>
    }
    triangle {
      < 8.443282, -0.081168, -0.126255>,
      < 8.453187, -0.082831, -0.136370>,
      < 8.452093, -0.076625, -0.135393>
    }
    triangle {
      < 8.443859, -0.084449, -0.126773>,
      < 8.444439, -0.087727, -0.126237>,
      < 8.454281, -0.089033, -0.135357>
    }
    triangle {
      < 8.443859, -0.084449, -0.126773>,
      < 8.454281, -0.089033, -0.135357>,
      < 8.453187, -0.082831, -0.136370>
    }
    triangle {
      < 8.444439, -0.087727, -0.126237>,
      < 8.444961, -0.090681, -0.124703>,
      < 8.455338, -0.095006, -0.132452>
    }
    triangle {
      < 8.444439, -0.087727, -0.126237>,
      < 8.455338, -0.095006, -0.132452>,
      < 8.454281, -0.089033, -0.135357>
    }
    triangle {
      < 8.444961, -0.090681, -0.124703>,
      < 8.445375, -0.093022, -0.122319>,
      < 8.456178, -0.099740, -0.127941>
    }
    triangle {
      < 8.444961, -0.090681, -0.124703>,
      < 8.456178, -0.099740, -0.127941>,
      < 8.455338, -0.095006, -0.132452>
    }
    triangle {
      < 8.445375, -0.093022, -0.122319>,
      < 8.445642, -0.094522, -0.119319>,
      < 8.456738, -0.102879, -0.122264>
    }
    triangle {
      < 8.445375, -0.093022, -0.122319>,
      < 8.456738, -0.102879, -0.122264>,
      < 8.456178, -0.099740, -0.127941>
    }
    triangle {
      < 8.445642, -0.094522, -0.119319>,
      < 8.445737, -0.095033, -0.115996>,
      < 8.456741, -0.102867, -0.115980>
    }
    triangle {
      < 8.445642, -0.094522, -0.119319>,
      < 8.456741, -0.102867, -0.115980>,
      < 8.456738, -0.102879, -0.122264>
    }
    triangle {
      < 8.445737, -0.095033, -0.115996>,
      < 8.445646, -0.094505, -0.112675>,
      < 8.456743, -0.102848, -0.109697>
    }
    triangle {
      < 8.445737, -0.095033, -0.115996>,
      < 8.456743, -0.102848, -0.109697>,
      < 8.456741, -0.102867, -0.115980>
    }
    triangle {
      < 8.445646, -0.094505, -0.112675>,
      < 8.445381, -0.092990, -0.109682>,
      < 8.456189, -0.099679, -0.104036>
    }
    triangle {
      < 8.445646, -0.094505, -0.112675>,
      < 8.456189, -0.099679, -0.104036>,
      < 8.456743, -0.102848, -0.109697>
    }
    triangle {
      < 8.445381, -0.092990, -0.109682>,
      < 8.444968, -0.090637, -0.107309>,
      < 8.455354, -0.094922, -0.099548>
    }
    triangle {
      < 8.445381, -0.092990, -0.109682>,
      < 8.455354, -0.094922, -0.099548>,
      < 8.456189, -0.099679, -0.104036>
    }
    triangle {
      < 8.444968, -0.090637, -0.107309>,
      < 8.444449, -0.087675, -0.105789>,
      < 8.454302, -0.088934, -0.096672>
    }
    triangle {
      < 8.444968, -0.090637, -0.107309>,
      < 8.454302, -0.088934, -0.096672>,
      < 8.455354, -0.094922, -0.099548>
    }
    triangle {
      < 8.444449, -0.087675, -0.105789>,
      < 8.443872, -0.084394, -0.105270>,
      < 8.453209, -0.082728, -0.095689>
    }
    triangle {
      < 8.444449, -0.087675, -0.105789>,
      < 8.453209, -0.082728, -0.095689>,
      < 8.454302, -0.088934, -0.096672>
    }
    triangle {
      < 8.443872, -0.084394, -0.105270>,
      < 8.443294, -0.081116, -0.105803>,
      < 8.452114, -0.076526, -0.096697>
    }
    triangle {
      < 8.443872, -0.084394, -0.105270>,
      < 8.452114, -0.076526, -0.096697>,
      < 8.453209, -0.082728, -0.095689>
    }
    triangle {
      < 8.443294, -0.081116, -0.105803>,
      < 8.442769, -0.078161, -0.107337>,
      < 8.451126, -0.070936, -0.099598>
    }
    triangle {
      < 8.443294, -0.081116, -0.105803>,
      < 8.451126, -0.070936, -0.099598>,
      < 8.452114, -0.076526, -0.096697>
    }
    triangle {
      < 8.442769, -0.078161, -0.107337>,
      < 8.442354, -0.075819, -0.109722>,
      < 8.450340, -0.066504, -0.104109>
    }
    triangle {
      < 8.442769, -0.078161, -0.107337>,
      < 8.450340, -0.066504, -0.104109>,
      < 8.451126, -0.070936, -0.099598>
    }
    triangle {
      < 8.442354, -0.075819, -0.109722>,
      < 8.442087, -0.074320, -0.112723>,
      < 8.449834, -0.063666, -0.109788>
    }
    triangle {
      < 8.442354, -0.075819, -0.109722>,
      < 8.449834, -0.063666, -0.109788>,
      < 8.450340, -0.066504, -0.104109>
    }
    triangle {
      < 8.442087, -0.074320, -0.112723>,
      < 8.441995, -0.073808, -0.116048>,
      < 8.449659, -0.062699, -0.116079>
    }
    triangle {
      < 8.442087, -0.074320, -0.112723>,
      < 8.449659, -0.062699, -0.116079>,
      < 8.449834, -0.063666, -0.109788>
    }
    triangle {
      < 8.441995, -0.073808, -0.116048>,
      < 8.442084, -0.074337, -0.119369>,
      < 8.449829, -0.063698, -0.122365>
    }
    triangle {
      < 8.441995, -0.073808, -0.116048>,
      < 8.449829, -0.063698, -0.122365>,
      < 8.449659, -0.062699, -0.116079>
    }
    triangle {
      < 8.442084, -0.074337, -0.119369>,
      < 8.442348, -0.075851, -0.122363>,
      < 8.450328, -0.066565, -0.128031>
    }
    triangle {
      < 8.442084, -0.074337, -0.119369>,
      < 8.450328, -0.066565, -0.128031>,
      < 8.449829, -0.063698, -0.122365>
    }
    triangle {
      < 8.453050, -0.083474, -0.277748>,
      < 8.452993, -0.083741, -0.318454>,
      < 8.443096, -0.082036, -0.308331>
    }
    triangle {
      < 8.453050, -0.083474, -0.277748>,
      < 8.443096, -0.082036, -0.308331>,
      < 8.443125, -0.081902, -0.287868>
    }
    triangle {
      < 8.456572, -0.103650, -0.291688>,
      < 8.456390, -0.104482, -0.400965>,
      < 8.445410, -0.096774, -0.401108>
    }
    triangle {
      < 8.456572, -0.103650, -0.291688>,
      < 8.445410, -0.096774, -0.401108>,
      < 8.445560, -0.095860, -0.298011>
    }
    triangle {
      < 8.455196, -0.095709, -0.281564>,
      < 8.454142, -0.089685, -0.278708>,
      < 8.445336, -0.094199, -0.269550>
    }
    triangle {
      < 8.455196, -0.095709, -0.281564>,
      < 8.445336, -0.094199, -0.269550>,
      < 8.445619, -0.095815, -0.270373>
    }
    triangle {
      < 8.454142, -0.089685, -0.278708>,
      < 8.453050, -0.083474, -0.277748>,
      < 8.443729, -0.085061, -0.268136>
    }
    triangle {
      < 8.454142, -0.089685, -0.278708>,
      < 8.443729, -0.085061, -0.268136>,
      < 8.445336, -0.094199, -0.269550>
    }
    triangle {
      < 8.453050, -0.083474, -0.277748>,
      < 8.451955, -0.077277, -0.278781>,
      < 8.442119, -0.075942, -0.269654>
    }
    triangle {
      < 8.453050, -0.083474, -0.277748>,
      < 8.442119, -0.075942, -0.269654>,
      < 8.443729, -0.085061, -0.268136>
    }
    triangle {
      < 8.451955, -0.077277, -0.278781>,
      < 8.450965, -0.071698, -0.281707>,
      < 8.440661, -0.067732, -0.273955>
    }
    triangle {
      < 8.451955, -0.077277, -0.278781>,
      < 8.440661, -0.067732, -0.273955>,
      < 8.442119, -0.075942, -0.269654>
    }
    triangle {
      < 8.450965, -0.071698, -0.281707>,
      < 8.450176, -0.067284, -0.286236>,
      < 8.439502, -0.061236, -0.280620>
    }
    triangle {
      < 8.450965, -0.071698, -0.281707>,
      < 8.439502, -0.061236, -0.280620>,
      < 8.440661, -0.067732, -0.273955>
    }
    triangle {
      < 8.450176, -0.067284, -0.286236>,
      < 8.449668, -0.064469, -0.291929>,
      < 8.438751, -0.057093, -0.288997>
    }
    triangle {
      < 8.450176, -0.067284, -0.286236>,
      < 8.438751, -0.057093, -0.288997>,
      < 8.439502, -0.061236, -0.280620>
    }
    triangle {
      < 8.449668, -0.064469, -0.291929>,
      < 8.449484, -0.063527, -0.298227>,
      < 8.438484, -0.055707, -0.298264>
    }
    triangle {
      < 8.449668, -0.064469, -0.291929>,
      < 8.438484, -0.055707, -0.298264>,
      < 8.438751, -0.057093, -0.288997>
    }
    triangle {
      < 8.449484, -0.063527, -0.298227>,
      < 8.449650, -0.064551, -0.304512>,
      < 8.438725, -0.057214, -0.307515>
    }
    triangle {
      < 8.449484, -0.063527, -0.298227>,
      < 8.438725, -0.057214, -0.307515>,
      < 8.438484, -0.055707, -0.298264>
    }
    triangle {
      < 8.449650, -0.064551, -0.304512>,
      < 8.450142, -0.067440, -0.310170>,
      < 8.439453, -0.061467, -0.315840>
    }
    triangle {
      < 8.449650, -0.064551, -0.304512>,
      < 8.439453, -0.061467, -0.315840>,
      < 8.438725, -0.057214, -0.307515>
    }
    triangle {
      < 8.450142, -0.067440, -0.310170>,
      < 8.450919, -0.071914, -0.314644>,
      < 8.440595, -0.068049, -0.322423>
    }
    triangle {
      < 8.450142, -0.067440, -0.310170>,
      < 8.440595, -0.068049, -0.322423>,
      < 8.439453, -0.061467, -0.315840>
    }
    triangle {
      < 8.450919, -0.071914, -0.314644>,
      < 8.451901, -0.077530, -0.317499>,
      < 8.442039, -0.076314, -0.326623>
    }
    triangle {
      < 8.450919, -0.071914, -0.314644>,
      < 8.442039, -0.076314, -0.326623>,
      < 8.440595, -0.068049, -0.322423>
    }
    triangle {
      < 8.451901, -0.077530, -0.317499>,
      < 8.452993, -0.083741, -0.318454>,
      < 8.443645, -0.085453, -0.328025>
    }
    triangle {
      < 8.451901, -0.077530, -0.317499>,
      < 8.443645, -0.085453, -0.328025>,
      < 8.442039, -0.076314, -0.326623>
    }
    triangle {
      < 8.442168, -0.076704, -0.304457>,
      < 8.442576, -0.079067, -0.306822>,
      < 8.450919, -0.071914, -0.314644>
    }
    triangle {
      < 8.442168, -0.076704, -0.304457>,
      < 8.450919, -0.071914, -0.314644>,
      < 8.450142, -0.067440, -0.310170>
    }
    triangle {
      < 8.442576, -0.079067, -0.306822>,
      < 8.443096, -0.082036, -0.308331>,
      < 8.451901, -0.077530, -0.317499>
    }
    triangle {
      < 8.442576, -0.079067, -0.306822>,
      < 8.451901, -0.077530, -0.317499>,
      < 8.450919, -0.071914, -0.314644>
    }
    triangle {
      < 8.443096, -0.082036, -0.308331>,
      < 8.452993, -0.083741, -0.318454>,
      < 8.451901, -0.077530, -0.317499>
    }
    triangle {
      < 8.445472, -0.095319, -0.294691>,
      < 8.456572, -0.103650, -0.291688>,
      < 8.445560, -0.095860, -0.298011>
    }
    triangle {
      < 8.445472, -0.095319, -0.294691>,
      < 8.445211, -0.093792, -0.291704>,
      < 8.456030, -0.100504, -0.286035>
    }
    triangle {
      < 8.445472, -0.095319, -0.294691>,
      < 8.456030, -0.100504, -0.286035>,
      < 8.456572, -0.103650, -0.291688>
    }
    triangle {
      < 8.445211, -0.093792, -0.291704>,
      < 8.444800, -0.091429, -0.289339>,
      < 8.455196, -0.095709, -0.281564>
    }
    triangle {
      < 8.445211, -0.093792, -0.291704>,
      < 8.455196, -0.095709, -0.281564>,
      < 8.456030, -0.100504, -0.286035>
    }
    triangle {
      < 8.444800, -0.091429, -0.289339>,
      < 8.444283, -0.088461, -0.287828>,
      < 8.454142, -0.089685, -0.278708>
    }
    triangle {
      < 8.444800, -0.091429, -0.289339>,
      < 8.454142, -0.089685, -0.278708>,
      < 8.455196, -0.095709, -0.281564>
    }
    triangle {
      < 8.444224, -0.088729, -0.327476>,
      < 8.452993, -0.083741, -0.318454>,
      < 8.453050, -0.083474, -0.277748>
    }
    triangle {
      < 8.444224, -0.088729, -0.327476>,
      < 8.453050, -0.083474, -0.277748>,
      < 8.444283, -0.088461, -0.287828>
    }
    triangle {
      < 8.443125, -0.081902, -0.287868>,
      < 8.451955, -0.077277, -0.278781>,
      < 8.453050, -0.083474, -0.277748>
    }
    triangle {
      < 8.443125, -0.081902, -0.287868>,
      < 8.442602, -0.078954, -0.289415>,
      < 8.450965, -0.071698, -0.281707>
    }
    triangle {
      < 8.443125, -0.081902, -0.287868>,
      < 8.450965, -0.071698, -0.281707>,
      < 8.451955, -0.077277, -0.278781>
    }
    triangle {
      < 8.442602, -0.078954, -0.289415>,
      < 8.442185, -0.076621, -0.291810>,
      < 8.450176, -0.067284, -0.286236>
    }
    triangle {
      < 8.442602, -0.078954, -0.289415>,
      < 8.450176, -0.067284, -0.286236>,
      < 8.450965, -0.071698, -0.281707>
    }
    triangle {
      < 8.442185, -0.076621, -0.291810>,
      < 8.441916, -0.075133, -0.294817>,
      < 8.449668, -0.064469, -0.291929>
    }
    triangle {
      < 8.442185, -0.076621, -0.291810>,
      < 8.449668, -0.064469, -0.291929>,
      < 8.450176, -0.067284, -0.286236>
    }
    triangle {
      < 8.441916, -0.075133, -0.294817>,
      < 8.441819, -0.074635, -0.298145>,
      < 8.449484, -0.063527, -0.298227>
    }
    triangle {
      < 8.441916, -0.075133, -0.294817>,
      < 8.449484, -0.063527, -0.298227>,
      < 8.449668, -0.064469, -0.291929>
    }
    triangle {
      < 8.441819, -0.074635, -0.298145>,
      < 8.441907, -0.075177, -0.301466>,
      < 8.449650, -0.064551, -0.304512>
    }
    triangle {
      < 8.441819, -0.074635, -0.298145>,
      < 8.449650, -0.064551, -0.304512>,
      < 8.449484, -0.063527, -0.298227>
    }
    triangle {
      < 8.441907, -0.075177, -0.301466>,
      < 8.442168, -0.076704, -0.304457>,
      < 8.450142, -0.067440, -0.310170>
    }
    triangle {
      < 8.441907, -0.075177, -0.301466>,
      < 8.450142, -0.067440, -0.310170>,
      < 8.449650, -0.064551, -0.304512>
    }
    triangle {
      < 8.451987, -0.077073, 0.242859>,
      < 8.453078, -0.083282, 0.243824>,
      < 8.443178, -0.081595, 0.233703>
    }
    triangle {
      < 8.445629, -0.095707, 0.251043>,
      < 8.445549, -0.096074, 0.310600>,
      < 8.456510, -0.103855, 0.321551>
    }
    triangle {
      < 8.445629, -0.095707, 0.251043>,
      < 8.456510, -0.103855, 0.321551>,
      < 8.456636, -0.103297, 0.229666>
    }
    triangle {
      < 8.454174, -0.089481, 0.242796>,
      < 8.453078, -0.083282, 0.243824>,
      < 8.443733, -0.084979, 0.253398>
    }
    triangle {
      < 8.454174, -0.089481, 0.242796>,
      < 8.443733, -0.084979, 0.253398>,
      < 8.445343, -0.094101, 0.251883>
    }
    triangle {
      < 8.453078, -0.083282, 0.243824>,
      < 8.451987, -0.077073, 0.242859>,
      < 8.442126, -0.075843, 0.251980>
    }
    triangle {
      < 8.453078, -0.083282, 0.243824>,
      < 8.442126, -0.075843, 0.251980>,
      < 8.443733, -0.084979, 0.253398>
    }
    triangle {
      < 8.451987, -0.077073, 0.242859>,
      < 8.451003, -0.071461, 0.239996>,
      < 8.440681, -0.067585, 0.247770>
    }
    triangle {
      < 8.451987, -0.077073, 0.242859>,
      < 8.440681, -0.067585, 0.247770>,
      < 8.442126, -0.075843, 0.251980>
    }
    triangle {
      < 8.451003, -0.071461, 0.239996>,
      < 8.450226, -0.066995, 0.235516>,
      < 8.439537, -0.061013, 0.241178>
    }
    triangle {
      < 8.451003, -0.071461, 0.239996>,
      < 8.439537, -0.061013, 0.241178>,
      < 8.440681, -0.067585, 0.247770>
    }
    triangle {
      < 8.450226, -0.066995, 0.235516>,
      < 8.449731, -0.064115, 0.229856>,
      < 8.438806, -0.056774, 0.232848>
    }
    triangle {
      < 8.450226, -0.066995, 0.235516>,
      < 8.438806, -0.056774, 0.232848>,
      < 8.439537, -0.061013, 0.241178>
    }
    triangle {
      < 8.449731, -0.064115, 0.229856>,
      < 8.449563, -0.063101, 0.223571>,
      < 8.438561, -0.055282, 0.223599>
    }
    triangle {
      < 8.449731, -0.064115, 0.229856>,
      < 8.438561, -0.055282, 0.223599>,
      < 8.438806, -0.056774, 0.232848>
    }
    triangle {
      < 8.449563, -0.063101, 0.223571>,
      < 8.449742, -0.064054, 0.217277>,
      < 8.438827, -0.056683, 0.214335>
    }
    triangle {
      < 8.449563, -0.063101, 0.223571>,
      < 8.438827, -0.056683, 0.214335>,
      < 8.438561, -0.055282, 0.223599>
    }
    triangle {
      < 8.449742, -0.064054, 0.217277>,
      < 8.450252, -0.066878, 0.211589>,
      < 8.439575, -0.060840, 0.205967>
    }
    triangle {
      < 8.449742, -0.064054, 0.217277>,
      < 8.439575, -0.060840, 0.205967>,
      < 8.438827, -0.056683, 0.214335>
    }
    triangle {
      < 8.450252, -0.066878, 0.211589>,
      < 8.451038, -0.071300, 0.207067>,
      < 8.440732, -0.067347, 0.199314>
    }
    triangle {
      < 8.450252, -0.066878, 0.211589>,
      < 8.440732, -0.067347, 0.199314>,
      < 8.439575, -0.060840, 0.205967>
    }
    triangle {
      < 8.451038, -0.071300, 0.207067>,
      < 8.452029, -0.076883, 0.204152>,
      < 8.442188, -0.075563, 0.195026>
    }
    triangle {
      < 8.451038, -0.071300, 0.207067>,
      < 8.442188, -0.075563, 0.195026>,
      < 8.440732, -0.067347, 0.199314>
    }
    triangle {
      < 8.452029, -0.076883, 0.204152>,
      < 8.453124, -0.083082, 0.203129>,
      < 8.443801, -0.084685, 0.193524>
    }
    triangle {
      < 8.452029, -0.076883, 0.204152>,
      < 8.443801, -0.084685, 0.193524>,
      < 8.442188, -0.075563, 0.195026>
    }
    triangle {
      < 8.442262, -0.076206, 0.217177>,
      < 8.442679, -0.078543, 0.214787>,
      < 8.451038, -0.071300, 0.207067>
    }
    triangle {
      < 8.442262, -0.076206, 0.217177>,
      < 8.451038, -0.071300, 0.207067>,
      < 8.450252, -0.066878, 0.211589>
    }
    triangle {
      < 8.442679, -0.078543, 0.214787>,
      < 8.443200, -0.081494, 0.213247>,
      < 8.452029, -0.076883, 0.204152>
    }
    triangle {
      < 8.442679, -0.078543, 0.214787>,
      < 8.452029, -0.076883, 0.204152>,
      < 8.451038, -0.071300, 0.207067>
    }
    triangle {
      < 8.445544, -0.094932, 0.226734>,
      < 8.456636, -0.103297, 0.229666>,
      < 8.445639, -0.095435, 0.223409>
    }
    triangle {
      < 8.445544, -0.094932, 0.226734>,
      < 8.445274, -0.093440, 0.229739>,
      < 8.456073, -0.100171, 0.235351>
    }
    triangle {
      < 8.445544, -0.094932, 0.226734>,
      < 8.456073, -0.100171, 0.235351>,
      < 8.456636, -0.103297, 0.229666>
    }
    triangle {
      < 8.445274, -0.093440, 0.229739>,
      < 8.444859, -0.091104, 0.232129>,
      < 8.455232, -0.095447, 0.239875>
    }
    triangle {
      < 8.445274, -0.093440, 0.229739>,
      < 8.455232, -0.095447, 0.239875>,
      < 8.456073, -0.100171, 0.235351>
    }
    triangle {
      < 8.444859, -0.091104, 0.232129>,
      < 8.444335, -0.088153, 0.233671>,
      < 8.454174, -0.089481, 0.242796>
    }
    triangle {
      < 8.444859, -0.091104, 0.232129>,
      < 8.454174, -0.089481, 0.242796>,
      < 8.455232, -0.095447, 0.239875>
    }
    triangle {
      < 8.444335, -0.088153, 0.233671>,
      < 8.453078, -0.083282, 0.243824>,
      < 8.454174, -0.089481, 0.242796>
    }
    triangle {
      < 8.443178, -0.081595, 0.233703>,
      < 8.442659, -0.078628, 0.232190>,
      < 8.451003, -0.071461, 0.239996>
    }
    triangle {
      < 8.443178, -0.081595, 0.233703>,
      < 8.451003, -0.071461, 0.239996>,
      < 8.451987, -0.077073, 0.242859>
    }
    triangle {
      < 8.442659, -0.078628, 0.232190>,
      < 8.442249, -0.076268, 0.229822>,
      < 8.450226, -0.066995, 0.235516>
    }
    triangle {
      < 8.442659, -0.078628, 0.232190>,
      < 8.450226, -0.066995, 0.235516>,
      < 8.451003, -0.071461, 0.239996>
    }
    triangle {
      < 8.442249, -0.076268, 0.229822>,
      < 8.441986, -0.074747, 0.226831>,
      < 8.449731, -0.064115, 0.229856>
    }
    triangle {
      < 8.442249, -0.076268, 0.229822>,
      < 8.449731, -0.064115, 0.229856>,
      < 8.450226, -0.066995, 0.235516>
    }
    triangle {
      < 8.441986, -0.074747, 0.226831>,
      < 8.441897, -0.074210, 0.223509>,
      < 8.449563, -0.063101, 0.223571>
    }
    triangle {
      < 8.441986, -0.074747, 0.226831>,
      < 8.449563, -0.063101, 0.223571>,
      < 8.449731, -0.064115, 0.229856>
    }
    triangle {
      < 8.441897, -0.074210, 0.223509>,
      < 8.441994, -0.074714, 0.220183>,
      < 8.449742, -0.064054, 0.217277>
    }
    triangle {
      < 8.441897, -0.074210, 0.223509>,
      < 8.449742, -0.064054, 0.217277>,
      < 8.449563, -0.063101, 0.223571>
    }
    triangle {
      < 8.441994, -0.074714, 0.220183>,
      < 8.442262, -0.076206, 0.217177>,
      < 8.450252, -0.066878, 0.211589>
    }
    triangle {
      < 8.441994, -0.074714, 0.220183>,
      < 8.450252, -0.066878, 0.211589>,
      < 8.449742, -0.064054, 0.217277>
    }
    triangle {
      < 8.456510, -0.103855, 0.321551>,
      < 8.448827, -0.114837, 0.319948>,
      < 8.448975, -0.114364, 0.223320>
    }
    triangle {
      < 8.456510, -0.103855, 0.321551>,
      < 8.448975, -0.114364, 0.223320>,
      < 8.449060, -0.113894, 0.111289>
    }
    triangle {
      < 8.456510, -0.103855, 0.321551>,
      < 8.449060, -0.113894, 0.111289>,
      < 8.456737, -0.102852, 0.111320>
    }
    triangle {
      < 8.456510, -0.103855, 0.321551>,
      < 8.456737, -0.102852, 0.111320>,
      < 8.456636, -0.103297, 0.229666>
    }
    triangle {
      < 8.446184, -0.045888, 0.360497>,
      < 8.435220, -0.038110, 0.351052>,
      < 8.435187, -0.038260, 0.370028>
    }
    triangle {
      < 8.446400, -0.044944, -0.210223>,
      < 8.435409, -0.037287, -0.219898>,
      < 8.435427, -0.037198, -0.200600>
    }
    triangle {
      < 8.446105, -0.046351, -0.415350>,
      < 8.435106, -0.038738, -0.425404>,
      < 8.435144, -0.038557, -0.405397>
    }
    triangle {
      < 8.435427, -0.037198, -0.200600>,
      < 8.445038, -0.091715, -0.200370>,
      < 8.454379, -0.090216, -0.210022>
    }
    triangle {
      < 8.435427, -0.037198, -0.200600>,
      < 8.454379, -0.090216, -0.210022>,
      < 8.446400, -0.044944, -0.210223>
    }
    triangle {
      < 8.449129, -0.063970, -0.436672>,
      < 8.438566, -0.058824, -0.446191>,
      < 8.438607, -0.058625, -0.425225>
    }
    triangle {
      < 8.449129, -0.063970, -0.436672>,
      < 8.438607, -0.058625, -0.425225>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.448372, -0.117011, -0.548500>,
      < 8.456085, -0.105908, -0.539162>,
      < 8.456335, -0.104735, -0.428715>
    }
    triangle {
      < 8.448372, -0.117011, -0.548500>,
      < 8.456335, -0.104735, -0.428715>,
      < 8.448648, -0.115727, -0.428598>
    }
    triangle {
      < 8.448704, -0.115474, -0.400856>,
      < 8.456390, -0.104482, -0.400965>,
      < 8.456572, -0.103650, -0.291688>
    }
    triangle {
      < 8.448704, -0.115474, -0.400856>,
      < 8.456572, -0.103650, -0.291688>,
      < 8.448903, -0.114748, -0.291612>
    }
    triangle {
      < 8.445772, -0.095099, -0.088370>,
      < 8.445788, -0.095024, -0.031088>,
      < 8.456768, -0.102725, -0.029282>
    }
    triangle {
      < 8.445772, -0.095099, -0.088370>,
      < 8.456768, -0.102725, -0.029282>,
      < 8.456743, -0.102848, -0.109697>
    }
    triangle {
      < 8.448742, -0.115212, 0.369428>,
      < 8.458092, -0.113492, 0.359982>,
      < 8.455035, -0.096134, 0.360114>
    }
    triangle {
      < 8.448742, -0.115212, 0.369428>,
      < 8.455035, -0.096134, 0.360114>,
      < 8.447562, -0.108511, 0.369481>
    }
    triangle {
      < 8.456187, -0.103524, 0.404583>,
      < 8.456407, -0.105443, 0.436896>,
      < 8.448721, -0.116434, 0.436586>
    }
    triangle {
      < 8.456187, -0.103524, 0.404583>,
      < 8.448721, -0.116434, 0.436586>,
      < 8.448497, -0.114466, 0.403440>
    }
    triangle {
      < 8.456407, -0.105443, 0.436896>,
      < 8.456277, -0.105423, 0.469162>,
      < 8.448588, -0.116414, 0.469468>
    }
    triangle {
      < 8.456407, -0.105443, 0.436896>,
      < 8.448588, -0.116414, 0.469468>,
      < 8.448721, -0.116434, 0.436586>
    }
    triangle {
      < 8.456277, -0.105423, 0.469162>,
      < 8.455817, -0.103477, 0.497214>,
      < 8.448119, -0.114436, 0.497981>
    }
    triangle {
      < 8.456277, -0.105423, 0.469162>,
      < 8.448119, -0.114436, 0.497981>,
      < 8.448588, -0.116414, 0.469468>
    }
    triangle {
      < 8.455817, -0.103477, 0.497214>,
      < 8.455218, -0.100776, 0.525030>,
      < 8.447511, -0.111693, 0.526229>
    }
    triangle {
      < 8.455817, -0.103477, 0.497214>,
      < 8.447511, -0.111693, 0.526229>,
      < 8.448119, -0.114436, 0.497981>
    }
    triangle {
      < 8.455218, -0.100776, 0.525030>,
      < 8.454638, -0.097937, 0.542640>,
      < 8.446898, -0.108699, 0.544796>
    }
    triangle {
      < 8.455218, -0.100776, 0.525030>,
      < 8.446898, -0.108699, 0.544796>,
      < 8.447511, -0.111693, 0.526229>
    }
    triangle {
      < 8.454638, -0.097937, 0.542640>,
      < 8.453787, -0.093484, 0.557114>,
      < 8.445957, -0.103783, 0.560770>
    }
    triangle {
      < 8.454638, -0.097937, 0.542640>,
      < 8.445957, -0.103783, 0.560770>,
      < 8.446898, -0.108699, 0.544796>
    }
    triangle {
      < 8.453787, -0.093484, 0.557114>,
      < 8.452820, -0.088266, 0.566974>,
      < 8.444753, -0.097277, 0.573065>
    }
    triangle {
      < 8.453787, -0.093484, 0.557114>,
      < 8.444753, -0.097277, 0.573065>,
      < 8.445957, -0.103783, 0.560770>
    }
    triangle {
      < 8.452820, -0.088266, 0.566974>,
      < 8.451746, -0.082292, 0.571984>,
      < 8.443081, -0.087986, 0.580859>
    }
    triangle {
      < 8.452820, -0.088266, 0.566974>,
      < 8.443081, -0.087986, 0.580859>,
      < 8.444753, -0.097277, 0.573065>
    }
    triangle {
      < 8.451746, -0.082292, 0.571984>,
      < 8.450431, -0.074844, 0.573304>,
      < 8.441090, -0.076713, 0.582859>
    }
    triangle {
      < 8.451746, -0.082292, 0.571984>,
      < 8.441090, -0.076713, 0.582859>,
      < 8.443081, -0.087986, 0.580859>
    }
    triangle {
      < 8.450431, -0.074844, 0.573304>,
      < 8.449036, -0.066887, 0.572277>,
      < 8.438979, -0.064675, 0.581308>
    }
    triangle {
      < 8.450431, -0.074844, 0.573304>,
      < 8.438979, -0.064675, 0.581308>,
      < 8.441090, -0.076713, 0.582859>
    }
    triangle {
      < 8.449036, -0.066887, 0.572277>,
      < 8.448028, -0.061021, 0.567362>,
      < 8.437393, -0.055438, 0.573570>
    }
    triangle {
      < 8.449036, -0.066887, 0.572277>,
      < 8.437393, -0.055438, 0.573570>,
      < 8.438979, -0.064675, 0.581308>
    }
    triangle {
      < 8.448028, -0.061021, 0.567362>,
      < 8.447072, -0.055315, 0.557470>,
      < 8.436219, -0.048431, 0.561424>
    }
    triangle {
      < 8.448028, -0.061021, 0.567362>,
      < 8.436219, -0.048431, 0.561424>,
      < 8.437393, -0.055438, 0.573570>
    }
    triangle {
      < 8.447072, -0.055315, 0.557470>,
      < 8.446272, -0.050386, 0.543120>,
      < 8.435334, -0.042978, 0.545550>
    }
    triangle {
      < 8.447072, -0.055315, 0.557470>,
      < 8.435334, -0.042978, 0.545550>,
      < 8.436219, -0.048431, 0.561424>
    }
    triangle {
      < 8.446272, -0.050386, 0.543120>,
      < 8.445771, -0.047099, 0.525846>,
      < 8.434799, -0.039454, 0.527031>
    }
    triangle {
      < 8.446272, -0.050386, 0.543120>,
      < 8.434799, -0.039454, 0.527031>,
      < 8.435334, -0.042978, 0.545550>
    }
    triangle {
      < 8.445771, -0.047099, 0.525846>,
      < 8.445628, -0.045815, 0.506947>,
      < 8.434648, -0.038102, 0.507131>
    }
    triangle {
      < 8.445771, -0.047099, 0.525846>,
      < 8.434648, -0.038102, 0.507131>,
      < 8.434799, -0.039454, 0.527031>
    }
    triangle {
      < 8.445628, -0.045815, 0.506947>,
      < 8.445904, -0.046539, 0.471547>,
      < 8.434927, -0.038840, 0.471053>
    }
    triangle {
      < 8.445628, -0.045815, 0.506947>,
      < 8.434927, -0.038840, 0.471053>,
      < 8.434648, -0.038102, 0.507131>
    }
    triangle {
      < 8.445904, -0.046539, 0.471547>,
      < 8.446474, -0.049027, 0.437422>,
      < 8.435505, -0.041361, 0.436497>
    }
    triangle {
      < 8.445904, -0.046539, 0.471547>,
      < 8.435505, -0.041361, 0.436497>,
      < 8.434927, -0.038840, 0.471053>
    }
    triangle {
      < 8.446474, -0.049027, 0.437422>,
      < 8.447039, -0.051737, 0.413087>,
      < 8.436259, -0.044979, 0.404032>
    }
    triangle {
      < 8.446474, -0.049027, 0.437422>,
      < 8.436259, -0.044979, 0.404032>,
      < 8.435505, -0.041361, 0.436497>
    }
    triangle {
      < 8.445212, -0.095865, 0.405602>,
      < 8.445428, -0.097737, 0.437138>,
      < 8.456407, -0.105443, 0.436896>
    }
    triangle {
      < 8.445212, -0.095865, 0.405602>,
      < 8.456407, -0.105443, 0.436896>,
      < 8.456187, -0.103524, 0.404583>
    }
    triangle {
      < 8.445428, -0.097737, 0.437138>,
      < 8.445300, -0.097718, 0.468783>,
      < 8.456277, -0.105423, 0.469162>
    }
    triangle {
      < 8.445428, -0.097737, 0.437138>,
      < 8.456277, -0.105423, 0.469162>,
      < 8.456407, -0.105443, 0.436896>
    }
    triangle {
      < 8.445300, -0.097718, 0.468783>,
      < 8.444848, -0.095803, 0.496370>,
      < 8.455817, -0.103477, 0.497214>
    }
    triangle {
      < 8.445300, -0.097718, 0.468783>,
      < 8.455817, -0.103477, 0.497214>,
      < 8.456277, -0.105423, 0.469162>
    }
    triangle {
      < 8.444848, -0.095803, 0.496370>,
      < 8.444260, -0.093145, 0.523752>,
      < 8.455218, -0.100776, 0.525030>
    }
    triangle {
      < 8.444848, -0.095803, 0.496370>,
      < 8.455218, -0.100776, 0.525030>,
      < 8.455817, -0.103477, 0.497214>
    }
    triangle {
      < 8.444260, -0.093145, 0.523752>,
      < 8.443710, -0.090460, 0.540398>,
      < 8.454638, -0.097937, 0.542640>
    }
    triangle {
      < 8.444260, -0.093145, 0.523752>,
      < 8.454638, -0.097937, 0.542640>,
      < 8.455218, -0.100776, 0.525030>
    }
    triangle {
      < 8.443710, -0.090460, 0.540398>,
      < 8.442947, -0.086467, 0.553370>,
      < 8.453787, -0.093484, 0.557114>
    }
    triangle {
      < 8.443710, -0.090460, 0.540398>,
      < 8.453787, -0.093484, 0.557114>,
      < 8.454638, -0.097937, 0.542640>
    }
    triangle {
      < 8.442947, -0.086467, 0.553370>,
      < 8.442221, -0.082538, 0.560794>,
      < 8.452820, -0.088266, 0.566974>
    }
    triangle {
      < 8.442947, -0.086467, 0.553370>,
      < 8.452820, -0.088266, 0.566974>,
      < 8.453787, -0.093484, 0.557114>
    }
    triangle {
      < 8.442221, -0.082538, 0.560794>,
      < 8.441743, -0.079884, 0.563019>,
      < 8.451746, -0.082292, 0.571984>
    }
    triangle {
      < 8.442221, -0.082538, 0.560794>,
      < 8.451746, -0.082292, 0.571984>,
      < 8.452820, -0.088266, 0.566974>
    }
    triangle {
      < 8.441743, -0.079884, 0.563019>,
      < 8.441103, -0.076258, 0.563660>,
      < 8.450431, -0.074844, 0.573304>
    }
    triangle {
      < 8.441743, -0.079884, 0.563019>,
      < 8.450431, -0.074844, 0.573304>,
      < 8.451746, -0.082292, 0.571984>
    }
    triangle {
      < 8.441103, -0.076258, 0.563660>,
      < 8.440425, -0.072385, 0.563160>,
      < 8.449036, -0.066887, 0.572277>
    }
    triangle {
      < 8.441103, -0.076258, 0.563660>,
      < 8.449036, -0.066887, 0.572277>,
      < 8.450431, -0.074844, 0.573304>
    }
    triangle {
      < 8.440425, -0.072385, 0.563160>,
      < 8.439996, -0.069887, 0.561068>,
      < 8.448028, -0.061021, 0.567362>
    }
    triangle {
      < 8.440425, -0.072385, 0.563160>,
      < 8.448028, -0.061021, 0.567362>,
      < 8.449036, -0.066887, 0.572277>
    }
    triangle {
      < 8.439996, -0.069887, 0.561068>,
      < 8.439257, -0.065482, 0.553430>,
      < 8.447072, -0.055315, 0.557470>
    }
    triangle {
      < 8.439996, -0.069887, 0.561068>,
      < 8.447072, -0.055315, 0.557470>,
      < 8.448028, -0.061021, 0.567362>
    }
    triangle {
      < 8.439257, -0.065482, 0.553430>,
      < 8.438541, -0.061078, 0.540606>,
      < 8.446272, -0.050386, 0.543120>
    }
    triangle {
      < 8.439257, -0.065482, 0.553430>,
      < 8.446272, -0.050386, 0.543120>,
      < 8.447072, -0.055315, 0.557470>
    }
    triangle {
      < 8.438541, -0.061078, 0.540606>,
      < 8.438078, -0.058028, 0.524579>,
      < 8.445771, -0.047099, 0.525846>
    }
    triangle {
      < 8.438541, -0.061078, 0.540606>,
      < 8.445771, -0.047099, 0.525846>,
      < 8.446272, -0.050386, 0.543120>
    }
    triangle {
      < 8.438078, -0.058028, 0.524579>,
      < 8.437942, -0.056811, 0.506686>,
      < 8.445628, -0.045815, 0.506947>
    }
    triangle {
      < 8.438078, -0.058028, 0.524579>,
      < 8.445628, -0.045815, 0.506947>,
      < 8.445771, -0.047099, 0.525846>
    }
    triangle {
      < 8.437942, -0.056811, 0.506686>,
      < 8.438212, -0.057523, 0.471966>,
      < 8.445904, -0.046539, 0.471547>
    }
    triangle {
      < 8.437942, -0.056811, 0.506686>,
      < 8.445904, -0.046539, 0.471547>,
      < 8.445628, -0.045815, 0.506947>
    }
    triangle {
      < 8.438212, -0.057523, 0.471966>,
      < 8.438776, -0.059980, 0.438277>,
      < 8.446474, -0.049027, 0.437422>
    }
    triangle {
      < 8.438212, -0.057523, 0.471966>,
      < 8.446474, -0.049027, 0.437422>,
      < 8.445904, -0.046539, 0.471547>
    }
    triangle {
      < 8.438776, -0.059980, 0.438277>,
      < 8.439591, -0.063888, 0.403225>,
      < 8.447039, -0.051737, 0.413087>
    }
    triangle {
      < 8.438776, -0.059980, 0.438277>,
      < 8.447039, -0.051737, 0.413087>,
      < 8.446474, -0.049027, 0.437422>
    }
    triangle {
      < 8.448696, -0.114150, 0.323576>,
      < 8.456510, -0.103855, 0.321551>,
      < 8.448335, -0.112146, 0.326663>
    }
    triangle {
      < 8.443666, -0.086051, 0.350698>,
      < 8.455035, -0.096134, 0.360114>,
      < 8.458092, -0.113492, 0.359982>
    }
    triangle {
      < 8.446184, -0.045888, 0.360497>,
      < 8.435187, -0.038260, 0.370028>,
      < 8.444308, -0.090044, 0.369625>
    }
    triangle {
      < 8.446184, -0.045888, 0.360497>,
      < 8.444308, -0.090044, 0.369625>,
      < 8.455035, -0.096134, 0.360114>
    }
    triangle {
      < 8.435220, -0.038110, 0.351052>,
      < 8.446184, -0.045888, 0.360497>,
      < 8.455035, -0.096134, 0.360114>
    }
    triangle {
      < 8.435220, -0.038110, 0.351052>,
      < 8.455035, -0.096134, 0.360114>,
      < 8.443666, -0.086051, 0.350698>
    }
    triangle {
      < 8.456187, -0.103524, 0.404583>,
      < 8.448497, -0.114466, 0.403440>,
      < 8.447562, -0.108511, 0.369481>
    }
    triangle {
      < 8.456187, -0.103524, 0.404583>,
      < 8.447562, -0.108511, 0.369481>,
      < 8.455035, -0.096134, 0.360114>
    }
    triangle {
      < 8.445212, -0.095865, 0.405602>,
      < 8.456187, -0.103524, 0.404583>,
      < 8.455035, -0.096134, 0.360114>
    }
    triangle {
      < 8.445212, -0.095865, 0.405602>,
      < 8.455035, -0.096134, 0.360114>,
      < 8.444308, -0.090044, 0.369625>
    }
    triangle {
      < 8.450296, -0.068588, 0.321793>,
      < 8.439551, -0.062354, 0.330257>,
      < 8.443666, -0.086051, 0.350698>
    }
    triangle {
      < 8.450296, -0.068588, 0.321793>,
      < 8.443666, -0.086051, 0.350698>,
      < 8.458092, -0.113492, 0.359982>
    }
    triangle {
      < 8.447039, -0.051737, 0.413087>,
      < 8.439591, -0.063888, 0.403225>,
      < 8.436259, -0.044979, 0.404032>
    }
    triangle {
      < 8.439129, -0.059894, 0.326581>,
      < 8.439551, -0.062354, 0.330257>,
      < 8.450296, -0.068588, 0.321793>
    }
    triangle {
      < 8.458092, -0.113492, 0.359982>,
      < 8.448775, -0.115062, 0.350483>,
      < 8.444492, -0.090390, 0.329589>
    }
    triangle {
      < 8.458092, -0.113492, 0.359982>,
      < 8.444492, -0.090390, 0.329589>,
      < 8.450296, -0.068588, 0.321793>
    }
    triangle {
      < 8.447797, -0.109128, 0.328737>,
      < 8.448335, -0.112146, 0.326663>,
      < 8.456510, -0.103855, 0.321551>
    }
    triangle {
      < 8.447165, -0.105556, 0.329483>,
      < 8.456510, -0.103855, 0.321551>,
      < 8.450296, -0.068588, 0.321793>
    }
    triangle {
      < 8.447165, -0.105556, 0.329483>,
      < 8.450296, -0.068588, 0.321793>,
      < 8.444492, -0.090390, 0.329589>
    }
    triangle {
      < 8.447165, -0.105556, 0.329483>,
      < 8.447797, -0.109128, 0.328737>,
      < 8.456510, -0.103855, 0.321551>
    }
    triangle {
      < 8.448827, -0.114837, 0.319948>,
      < 8.456510, -0.103855, 0.321551>,
      < 8.448696, -0.114150, 0.323576>
    }
    triangle {
      < 8.439577, -0.062241, 0.314156>,
      < 8.450296, -0.068588, 0.321793>,
      < 8.440223, -0.065865, 0.311664>
    }
    triangle {
      < 8.456510, -0.103855, 0.321551>,
      < 8.445549, -0.096074, 0.310600>,
      < 8.440981, -0.070155, 0.310770>
    }
    triangle {
      < 8.456510, -0.103855, 0.321551>,
      < 8.440981, -0.070155, 0.310770>,
      < 8.450296, -0.068588, 0.321793>
    }
    triangle {
      < 8.439143, -0.059833, 0.317866>,
      < 8.450296, -0.068588, 0.321793>,
      < 8.439577, -0.062241, 0.314156>
    }
    triangle {
      < 8.440981, -0.070155, 0.310770>,
      < 8.440223, -0.065865, 0.311664>,
      < 8.450296, -0.068588, 0.321793>
    }
    triangle {
      < 8.438985, -0.059009, 0.322229>,
      < 8.450296, -0.068588, 0.321793>,
      < 8.439143, -0.059833, 0.317866>
    }
    triangle {
      < 8.438985, -0.059009, 0.322229>,
      < 8.439129, -0.059894, 0.326581>,
      < 8.450296, -0.068588, 0.321793>
    }
    triangle {
      < 8.456558, -0.101532, 0.024383>,
      < 8.448832, -0.112283, 0.020354>,
      < 8.448113, -0.108205, 0.014128>
    }
    triangle {
      < 8.456558, -0.101532, 0.024383>,
      < 8.448113, -0.108205, 0.014128>,
      < 8.456200, -0.099492, 0.021269>
    }
    triangle {
      < 8.449083, -0.113718, 0.027697>,
      < 8.456767, -0.102725, 0.029466>,
      < 8.456737, -0.102852, 0.111320>
    }
    triangle {
      < 8.449083, -0.113718, 0.027697>,
      < 8.456737, -0.102852, 0.111320>,
      < 8.449060, -0.113894, 0.111289>
    }
    triangle {
      < 8.439909, -0.061834, 0.077701>,
      < 8.450675, -0.068366, 0.091805>,
      < 8.456737, -0.102852, 0.111320>
    }
    triangle {
      < 8.439909, -0.061834, 0.077701>,
      < 8.456737, -0.102852, 0.111320>,
      < 8.445764, -0.095115, 0.095823>
    }
    triangle {
      < 8.439885, -0.061942, 0.126172>,
      < 8.439873, -0.061999, 0.145123>,
      < 8.450653, -0.068462, 0.130996>
    }
    triangle {
      < 8.456737, -0.102852, 0.111320>,
      < 8.444238, -0.086535, 0.111353>,
      < 8.439885, -0.061942, 0.126172>
    }
    triangle {
      < 8.456737, -0.102852, 0.111320>,
      < 8.439885, -0.061942, 0.126172>,
      < 8.450653, -0.068462, 0.130996>
    }
    triangle {
      < 8.439901, -0.061870, 0.096650>,
      < 8.444238, -0.086535, 0.111353>,
      < 8.456737, -0.102852, 0.111320>
    }
    triangle {
      < 8.439901, -0.061870, 0.096650>,
      < 8.456737, -0.102852, 0.111320>,
      < 8.450675, -0.068366, 0.091805>
    }
    triangle {
      < 8.439909, -0.061834, 0.077701>,
      < 8.439901, -0.061870, 0.096650>,
      < 8.450675, -0.068366, 0.091805>
    }
    triangle {
      < 8.445746, -0.095191, 0.126844>,
      < 8.456737, -0.102852, 0.111320>,
      < 8.450653, -0.068462, 0.130996>
    }
    triangle {
      < 8.445746, -0.095191, 0.126844>,
      < 8.450653, -0.068462, 0.130996>,
      < 8.439873, -0.061999, 0.145123>
    }
    triangle {
      < 8.456680, -0.103140, -0.196581>,
      < 8.448996, -0.114134, -0.196527>,
      < 8.448903, -0.113662, -0.201561>
    }
    triangle {
      < 8.456680, -0.103140, -0.196581>,
      < 8.448903, -0.113662, -0.201561>,
      < 8.456532, -0.102345, -0.201805>
    }
    triangle {
      < 8.454142, -0.089685, -0.278708>,
      < 8.444283, -0.088461, -0.287828>,
      < 8.453050, -0.083474, -0.277748>
    }
    triangle {
      < 8.443645, -0.085453, -0.328025>,
      < 8.452993, -0.083741, -0.318454>,
      < 8.444224, -0.088729, -0.327476>
    }
    triangle {
      < 8.456030, -0.100504, -0.286035>,
      < 8.455196, -0.095709, -0.281564>,
      < 8.445619, -0.095815, -0.270373>
    }
    triangle {
      < 8.456572, -0.103650, -0.291688>,
      < 8.456030, -0.100504, -0.286035>,
      < 8.445619, -0.095815, -0.270373>
    }
    triangle {
      < 8.454174, -0.089481, 0.242796>,
      < 8.445343, -0.094101, 0.251883>,
      < 8.445629, -0.095707, 0.251043>
    }
    triangle {
      < 8.454174, -0.089481, 0.242796>,
      < 8.445629, -0.095707, 0.251043>,
      < 8.455232, -0.095447, 0.239875>
    }
    triangle {
      < 8.454302, -0.088934, -0.096672>,
      < 8.445489, -0.093486, -0.087541>,
      < 8.445772, -0.095099, -0.088370>
    }
    triangle {
      < 8.454302, -0.088934, -0.096672>,
      < 8.445772, -0.095099, -0.088370>,
      < 8.455354, -0.094922, -0.099548>
    }
    triangle {
      < 8.456178, -0.099740, -0.127941>,
      < 8.456738, -0.102879, -0.122264>,
      < 8.445741, -0.095240, -0.143620>
    }
    triangle {
      < 8.456636, -0.103297, 0.229666>,
      < 8.456073, -0.100171, 0.235351>,
      < 8.445629, -0.095707, 0.251043>
    }
    triangle {
      < 8.456073, -0.100171, 0.235351>,
      < 8.455232, -0.095447, 0.239875>,
      < 8.445629, -0.095707, 0.251043>
    }
    triangle {
      < 8.456743, -0.102848, -0.109697>,
      < 8.456189, -0.099679, -0.104036>,
      < 8.445772, -0.095099, -0.088370>
    }
    triangle {
      < 8.456189, -0.099679, -0.104036>,
      < 8.455354, -0.094922, -0.099548>,
      < 8.445772, -0.095099, -0.088370>
    }
    triangle {
      < 8.455338, -0.095006, -0.132452>,
      < 8.456178, -0.099740, -0.127941>,
      < 8.445741, -0.095240, -0.143620>
    }
    triangle {
      < 8.445457, -0.093631, -0.144457>,
      < 8.454281, -0.089033, -0.135357>,
      < 8.455338, -0.095006, -0.132452>
    }
    triangle {
      < 8.445457, -0.093631, -0.144457>,
      < 8.455338, -0.095006, -0.132452>,
      < 8.445741, -0.095240, -0.143620>
    }
    triangle {
      < 8.456741, -0.102867, -0.115980>,
      < 8.456743, -0.102848, -0.109697>,
      < 8.449073, -0.113962, -0.115949>
    }
    triangle {
      < 8.456741, -0.102867, -0.115980>,
      < 8.449073, -0.113962, -0.115949>,
      < 8.456738, -0.102879, -0.122264>
    }
    triangle {
      < 8.452029, -0.076883, 0.204152>,
      < 8.443200, -0.081494, 0.213247>,
      < 8.453124, -0.083082, 0.203129>
    }
    triangle {
      < 8.443801, -0.084685, 0.193524>,
      < 8.453124, -0.083082, 0.203129>,
      < 8.444376, -0.087967, 0.194037>
    }
    triangle {
      < 8.456636, -0.103297, 0.229666>,
      < 8.456737, -0.102852, 0.111320>,
      < 8.445746, -0.095191, 0.126844>
    }
    triangle {
      < 8.456636, -0.103297, 0.229666>,
      < 8.445746, -0.095191, 0.126844>,
      < 8.445639, -0.095435, 0.223409>
    }
    triangle {
      < 8.453124, -0.083082, 0.203129>,
      < 8.443200, -0.081494, 0.213247>,
      < 8.443178, -0.081595, 0.233703>
    }
    triangle {
      < 8.453124, -0.083082, 0.203129>,
      < 8.443178, -0.081595, 0.233703>,
      < 8.453078, -0.083282, 0.243824>
    }
    triangle {
      < 8.444376, -0.087967, 0.194037>,
      < 8.453124, -0.083082, 0.203129>,
      < 8.453078, -0.083282, 0.243824>
    }
    triangle {
      < 8.444376, -0.087967, 0.194037>,
      < 8.453078, -0.083282, 0.243824>,
      < 8.444335, -0.088153, 0.233671>
    }
    triangle {
      < 8.445529, -0.094498, -0.199393>,
      < 8.445701, -0.095437, -0.196565>,
      < 8.456680, -0.103140, -0.196581>
    }
    triangle {
      < 8.445529, -0.094498, -0.199393>,
      < 8.456680, -0.103140, -0.196581>,
      < 8.456532, -0.102345, -0.201805>
    }
    triangle {
      < 8.456738, -0.102879, -0.122264>,
      < 8.449073, -0.113962, -0.115949>,
      < 8.448996, -0.114134, -0.196527>
    }
    triangle {
      < 8.456738, -0.102879, -0.122264>,
      < 8.448996, -0.114134, -0.196527>,
      < 8.456680, -0.103140, -0.196581>
    }
    triangle {
      < 8.445701, -0.095437, -0.196565>,
      < 8.445741, -0.095240, -0.143620>,
      < 8.456738, -0.102879, -0.122264>
    }
    triangle {
      < 8.445701, -0.095437, -0.196565>,
      < 8.456738, -0.102879, -0.122264>,
      < 8.456680, -0.103140, -0.196581>
    }
    triangle {
      < 8.456016, -0.099460, -0.206143>,
      < 8.445529, -0.094498, -0.199393>,
      < 8.456532, -0.102345, -0.201805>
    }
    triangle {
      < 8.448278, -0.110186, -0.208693>,
      < 8.455262, -0.095214, -0.209003>,
      < 8.456016, -0.099460, -0.206143>
    }
    triangle {
      < 8.448278, -0.110186, -0.208693>,
      < 8.456016, -0.099460, -0.206143>,
      < 8.448652, -0.112275, -0.205834>
    }
    triangle {
      < 8.456532, -0.102345, -0.201805>,
      < 8.448903, -0.113662, -0.201561>,
      < 8.448652, -0.112275, -0.205834>
    }
    triangle {
      < 8.456532, -0.102345, -0.201805>,
      < 8.448652, -0.112275, -0.205834>,
      < 8.456016, -0.099460, -0.206143>
    }
    triangle {
      < 8.448276, -0.110197, -0.211159>,
      < 8.455259, -0.095223, -0.210996>,
      < 8.454379, -0.090216, -0.210022>
    }
    triangle {
      < 8.448276, -0.110197, -0.211159>,
      < 8.454379, -0.090216, -0.210022>,
      < 8.447840, -0.107712, -0.210168>
    }
    triangle {
      < 8.455262, -0.095214, -0.209003>,
      < 8.448278, -0.110186, -0.208693>,
      < 8.447840, -0.107712, -0.210168>
    }
    triangle {
      < 8.455262, -0.095214, -0.209003>,
      < 8.447840, -0.107712, -0.210168>,
      < 8.454379, -0.090216, -0.210022>
    }
    triangle {
      < 8.448886, -0.113739, -0.218258>,
      < 8.456516, -0.102421, -0.218131>,
      < 8.456007, -0.099495, -0.213818>
    }
    triangle {
      < 8.448886, -0.113739, -0.218258>,
      < 8.456007, -0.099495, -0.213818>,
      < 8.448645, -0.112313, -0.213999>
    }
    triangle {
      < 8.455259, -0.095223, -0.210996>,
      < 8.448276, -0.110197, -0.211159>,
      < 8.448645, -0.112313, -0.213999>
    }
    triangle {
      < 8.455259, -0.095223, -0.210996>,
      < 8.448645, -0.112313, -0.213999>,
      < 8.456007, -0.099495, -0.213818>
    }
    triangle {
      < 8.448903, -0.114748, -0.291612>,
      < 8.456572, -0.103650, -0.291688>,
      < 8.456655, -0.103263, -0.223350>
    }
    triangle {
      < 8.448903, -0.114748, -0.291612>,
      < 8.456655, -0.103263, -0.223350>,
      < 8.448968, -0.114257, -0.223288>
    }
    triangle {
      < 8.456516, -0.102421, -0.218131>,
      < 8.448886, -0.113739, -0.218258>,
      < 8.448968, -0.114257, -0.223288>
    }
    triangle {
      < 8.456516, -0.102421, -0.218131>,
      < 8.448968, -0.114257, -0.223288>,
      < 8.456655, -0.103263, -0.223350>
    }
    triangle {
      < 8.445507, -0.094596, -0.220597>,
      < 8.456007, -0.099495, -0.213818>,
      < 8.456516, -0.102421, -0.218131>
    }
    triangle {
      < 8.454379, -0.090216, -0.210022>,
      < 8.445038, -0.091715, -0.200370>,
      < 8.445529, -0.094498, -0.199393>
    }
    triangle {
      < 8.454379, -0.090216, -0.210022>,
      < 8.445529, -0.094498, -0.199393>,
      < 8.455262, -0.095214, -0.209003>
    }
    triangle {
      < 8.445507, -0.094596, -0.220597>,
      < 8.455259, -0.095223, -0.210996>,
      < 8.456007, -0.099495, -0.213818>
    }
    triangle {
      < 8.455262, -0.095214, -0.209003>,
      < 8.445529, -0.094498, -0.199393>,
      < 8.456016, -0.099460, -0.206143>
    }
    triangle {
      < 8.445507, -0.094596, -0.220597>,
      < 8.445019, -0.091804, -0.219646>,
      < 8.454379, -0.090216, -0.210022>
    }
    triangle {
      < 8.445507, -0.094596, -0.220597>,
      < 8.454379, -0.090216, -0.210022>,
      < 8.455259, -0.095223, -0.210996>
    }
    triangle {
      < 8.456655, -0.103263, -0.223350>,
      < 8.445673, -0.095561, -0.223416>,
      < 8.445507, -0.094596, -0.220597>
    }
    triangle {
      < 8.456655, -0.103263, -0.223350>,
      < 8.445507, -0.094596, -0.220597>,
      < 8.456516, -0.102421, -0.218131>
    }
    triangle {
      < 8.456085, -0.105908, -0.539162>,
      < 8.445083, -0.098315, -0.548716>,
      < 8.445357, -0.097029, -0.428673>
    }
    triangle {
      < 8.456085, -0.105908, -0.539162>,
      < 8.445357, -0.097029, -0.428673>,
      < 8.456335, -0.104735, -0.428715>
    }
    triangle {
      < 8.448704, -0.115474, -0.400856>,
      < 8.448607, -0.115020, -0.405896>,
      < 8.456297, -0.104060, -0.406590>
    }
    triangle {
      < 8.448704, -0.115474, -0.400856>,
      < 8.456297, -0.104060, -0.406590>,
      < 8.456390, -0.104482, -0.400965>
    }
    triangle {
      < 8.456297, -0.104060, -0.406590>,
      < 8.445238, -0.095852, -0.403943>,
      < 8.445410, -0.096774, -0.401108>
    }
    triangle {
      < 8.456297, -0.104060, -0.406590>,
      < 8.445410, -0.096774, -0.401108>,
      < 8.456390, -0.104482, -0.400965>
    }
    triangle {
      < 8.445195, -0.096051, -0.425856>,
      < 8.455727, -0.101077, -0.418681>,
      < 8.456264, -0.104210, -0.423098>
    }
    triangle {
      < 8.455742, -0.101008, -0.411061>,
      < 8.445238, -0.095852, -0.403943>,
      < 8.456297, -0.104060, -0.406590>
    }
    triangle {
      < 8.447970, -0.111547, -0.413049>,
      < 8.454972, -0.096684, -0.413921>,
      < 8.455742, -0.101008, -0.411061>
    }
    triangle {
      < 8.447970, -0.111547, -0.413049>,
      < 8.455742, -0.101008, -0.411061>,
      < 8.448348, -0.113641, -0.410177>
    }
    triangle {
      < 8.456297, -0.104060, -0.406590>,
      < 8.448607, -0.115020, -0.405896>,
      < 8.448348, -0.113641, -0.410177>
    }
    triangle {
      < 8.456297, -0.104060, -0.406590>,
      < 8.448348, -0.113641, -0.410177>,
      < 8.455742, -0.101008, -0.411061>
    }
    triangle {
      < 8.447965, -0.111569, -0.415518>,
      < 8.454968, -0.096702, -0.415897>,
      < 8.454077, -0.091623, -0.414954>
    }
    triangle {
      < 8.447965, -0.111569, -0.415518>,
      < 8.454077, -0.091623, -0.414954>,
      < 8.447527, -0.109055, -0.414074>
    }
    triangle {
      < 8.454972, -0.096684, -0.413921>,
      < 8.447970, -0.111547, -0.413049>,
      < 8.447527, -0.109055, -0.414074>
    }
    triangle {
      < 8.454972, -0.096684, -0.413921>,
      < 8.447527, -0.109055, -0.414074>,
      < 8.454077, -0.091623, -0.414954>
    }
    triangle {
      < 8.448574, -0.115172, -0.422609>,
      < 8.456264, -0.104210, -0.423098>,
      < 8.455727, -0.101077, -0.418681>
    }
    triangle {
      < 8.448574, -0.115172, -0.422609>,
      < 8.455727, -0.101077, -0.418681>,
      < 8.448332, -0.113716, -0.418352>
    }
    triangle {
      < 8.454968, -0.096702, -0.415897>,
      < 8.447965, -0.111569, -0.415518>,
      < 8.448332, -0.113716, -0.418352>
    }
    triangle {
      < 8.454968, -0.096702, -0.415897>,
      < 8.448332, -0.113716, -0.418352>,
      < 8.455727, -0.101077, -0.418681>
    }
    triangle {
      < 8.448648, -0.115727, -0.428598>,
      < 8.456335, -0.104735, -0.428715>,
      < 8.456264, -0.104210, -0.423098>
    }
    triangle {
      < 8.448648, -0.115727, -0.428598>,
      < 8.456264, -0.104210, -0.423098>,
      < 8.448574, -0.115172, -0.422609>
    }
    triangle {
      < 8.454077, -0.091623, -0.414954>,
      < 8.444745, -0.093074, -0.404932>,
      < 8.445238, -0.095852, -0.403943>
    }
    triangle {
      < 8.454077, -0.091623, -0.414954>,
      < 8.445238, -0.095852, -0.403943>,
      < 8.454972, -0.096684, -0.413921>
    }
    triangle {
      < 8.445195, -0.096051, -0.425856>,
      < 8.444707, -0.093255, -0.424915>,
      < 8.454077, -0.091623, -0.414954>
    }
    triangle {
      < 8.445195, -0.096051, -0.425856>,
      < 8.454077, -0.091623, -0.414954>,
      < 8.454968, -0.096702, -0.415897>
    }
    triangle {
      < 8.456335, -0.104735, -0.428715>,
      < 8.445357, -0.097029, -0.428673>,
      < 8.445195, -0.096051, -0.425856>
    }
    triangle {
      < 8.456335, -0.104735, -0.428715>,
      < 8.445195, -0.096051, -0.425856>,
      < 8.456264, -0.104210, -0.423098>
    }
    triangle {
      < 8.454972, -0.096684, -0.413921>,
      < 8.445238, -0.095852, -0.403943>,
      < 8.455742, -0.101008, -0.411061>
    }
    triangle {
      < 8.445195, -0.096051, -0.425856>,
      < 8.454968, -0.096702, -0.415897>,
      < 8.455727, -0.101077, -0.418681>
    }
    triangle {
      < 8.449213, -0.063579, -0.393726>,
      < 8.438684, -0.058262, -0.384268>,
      < 8.441108, -0.072022, -0.384156>
    }
    triangle {
      < 8.440989, -0.072585, -0.446061>,
      < 8.449129, -0.063970, -0.436672>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.440989, -0.072585, -0.446061>,
      < 8.449172, -0.063769, -0.415198>,
      < 8.441031, -0.072385, -0.425102>
    }
    triangle {
      < 8.441070, -0.072203, -0.405110>,
      < 8.444745, -0.093074, -0.404932>,
      < 8.454077, -0.091623, -0.414954>
    }
    triangle {
      < 8.441070, -0.072203, -0.405110>,
      < 8.454077, -0.091623, -0.414954>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.435144, -0.038557, -0.405397>,
      < 8.438646, -0.058443, -0.405228>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.435144, -0.038557, -0.405397>,
      < 8.449172, -0.063769, -0.415198>,
      < 8.446105, -0.046351, -0.415350>
    }
    triangle {
      < 8.449129, -0.063970, -0.436672>,
      < 8.440989, -0.072585, -0.446061>,
      < 8.438566, -0.058824, -0.446191>
    }
    triangle {
      < 8.456085, -0.105908, -0.539162>,
      < 8.448372, -0.117011, -0.548500>,
      < 8.445083, -0.098315, -0.548716>
    }
    triangle {
      < 8.445019, -0.091804, -0.219646>,
      < 8.435409, -0.037287, -0.219898>,
      < 8.446400, -0.044944, -0.210223>
    }
    triangle {
      < 8.445019, -0.091804, -0.219646>,
      < 8.446400, -0.044944, -0.210223>,
      < 8.454379, -0.090216, -0.210022>
    }
    triangle {
      < 8.456559, -0.101531, -0.024214>,
      < 8.445621, -0.094071, -0.028264>,
      < 8.456199, -0.099492, -0.021113>
    }
    triangle {
      < 8.442604, -0.076960, -0.027311>,
      < 8.452231, -0.076982, -0.017840>,
      < 8.454782, -0.091450, -0.017835>
    }
    triangle {
      < 8.442604, -0.076960, -0.027311>,
      < 8.454782, -0.091450, -0.017835>,
      < 8.445129, -0.091283, -0.027303>
    }
    triangle {
      < 8.450527, -0.067322, 0.017987>,
      < 8.454782, -0.091450, 0.017979>,
      < 8.445771, -0.094911, 0.008509>
    }
    triangle {
      < 8.450527, -0.067322, 0.017987>,
      < 8.445771, -0.094911, 0.008509>,
      < 8.442534, -0.076558, 0.008512>
    }
    triangle {
      < 8.441552, -0.070993, -0.026117>,
      < 8.451460, -0.072605, -0.016761>,
      < 8.452231, -0.076982, -0.017840>
    }
    triangle {
      < 8.441552, -0.070993, -0.026117>,
      < 8.452231, -0.076982, -0.017840>,
      < 8.442604, -0.076960, -0.027311>
    }
    triangle {
      < 8.439855, -0.061363, -0.011583>,
      < 8.439856, -0.061362, 0.008515>,
      < 8.450527, -0.067322, 0.017987>
    }
    triangle {
      < 8.439855, -0.061363, -0.011583>,
      < 8.450527, -0.067322, 0.017987>,
      < 8.450527, -0.067314, -0.008082>
    }
    triangle {
      < 8.450527, -0.067324, 0.022512>,
      < 8.442532, -0.076568, 0.031622>,
      < 8.442533, -0.076565, 0.027454>
    }
    triangle {
      < 8.450527, -0.067324, 0.022512>,
      < 8.442533, -0.076565, 0.027454>,
      < 8.450527, -0.067322, 0.017987>
    }
    triangle {
      < 8.447039, -0.102105, 0.009969>,
      < 8.455662, -0.096441, 0.019190>,
      < 8.456200, -0.099492, 0.021269>
    }
    triangle {
      < 8.447039, -0.102105, 0.009969>,
      < 8.456200, -0.099492, 0.021269>,
      < 8.448113, -0.108205, 0.014128>
    }
    triangle {
      < 8.455663, -0.096441, -0.019043>,
      < 8.456199, -0.099492, -0.021113>,
      < 8.445621, -0.094071, -0.028264>
    }
    triangle {
      < 8.440064, -0.062551, -0.017605>,
      < 8.439855, -0.061363, -0.011583>,
      < 8.450527, -0.067314, -0.008082>
    }
    triangle {
      < 8.440064, -0.062551, -0.017605>,
      < 8.450527, -0.067314, -0.008082>,
      < 8.450716, -0.068385, -0.012504>
    }
    triangle {
      < 8.449083, -0.113718, 0.027697>,
      < 8.448832, -0.112283, 0.020354>,
      < 8.456558, -0.101532, 0.024383>
    }
    triangle {
      < 8.449083, -0.113718, 0.027697>,
      < 8.456558, -0.101532, 0.024383>,
      < 8.456767, -0.102725, 0.029466>
    }
    triangle {
      < 8.445771, -0.094911, 0.008509>,
      < 8.454782, -0.091450, 0.017979>,
      < 8.455662, -0.096441, 0.019190>
    }
    triangle {
      < 8.445771, -0.094911, 0.008509>,
      < 8.455662, -0.096441, 0.019190>,
      < 8.447039, -0.102105, 0.009969>
    }
    triangle {
      < 8.445129, -0.091283, -0.027303>,
      < 8.454782, -0.091450, -0.017835>,
      < 8.455663, -0.096441, -0.019043>
    }
    triangle {
      < 8.445129, -0.091283, -0.027303>,
      < 8.455663, -0.096441, -0.019043>,
      < 8.445621, -0.094071, -0.028264>
    }
    triangle {
      < 8.445788, -0.095024, -0.031088>,
      < 8.445621, -0.094071, -0.028264>,
      < 8.456559, -0.101531, -0.024214>
    }
    triangle {
      < 8.445788, -0.095024, -0.031088>,
      < 8.456559, -0.101531, -0.024214>,
      < 8.456768, -0.102725, -0.029282>
    }
    triangle {
      < 8.440661, -0.065933, -0.022709>,
      < 8.440064, -0.062551, -0.017605>,
      < 8.450716, -0.068385, -0.012504>
    }
    triangle {
      < 8.440661, -0.065933, -0.022709>,
      < 8.450716, -0.068385, -0.012504>,
      < 8.451014, -0.070075, -0.015057>
    }
    triangle {
      < 8.440661, -0.065933, -0.022709>,
      < 8.451014, -0.070075, -0.015057>,
      < 8.451460, -0.072605, -0.016761>
    }
    triangle {
      < 8.440661, -0.065933, -0.022709>,
      < 8.451460, -0.072605, -0.016761>,
      < 8.441552, -0.070993, -0.026117>
    }
    triangle {
      < 8.445786, -0.095024, 0.031231>,
      < 8.445764, -0.095115, 0.095823>,
      < 8.456737, -0.102852, 0.111320>
    }
    triangle {
      < 8.445786, -0.095024, 0.031231>,
      < 8.456737, -0.102852, 0.111320>,
      < 8.456767, -0.102725, 0.029466>
    }
    triangle {
      < 8.445619, -0.094071, 0.028409>,
      < 8.445786, -0.095024, 0.031231>,
      < 8.456767, -0.102725, 0.029466>
    }
    triangle {
      < 8.445619, -0.094071, 0.028409>,
      < 8.456767, -0.102725, 0.029466>,
      < 8.456558, -0.101532, 0.024383>
    }
    triangle {
      < 8.445619, -0.094071, 0.028409>,
      < 8.456558, -0.101532, 0.024383>,
      < 8.456200, -0.099492, 0.021269>
    }
    triangle {
      < 8.445619, -0.094071, 0.028409>,
      < 8.456200, -0.099492, 0.021269>,
      < 8.455662, -0.096441, 0.019190>
    }
    triangle {
      < 8.445127, -0.091283, 0.027445>,
      < 8.445619, -0.094071, 0.028409>,
      < 8.455662, -0.096441, 0.019190>
    }
    triangle {
      < 8.445127, -0.091283, 0.027445>,
      < 8.455662, -0.096441, 0.019190>,
      < 8.454782, -0.091450, 0.017979>
    }
    triangle {
      < 8.442533, -0.076565, 0.027454>,
      < 8.445127, -0.091283, 0.027445>,
      < 8.454782, -0.091450, 0.017979>
    }
    triangle {
      < 8.442533, -0.076565, 0.027454>,
      < 8.454782, -0.091450, 0.017979>,
      < 8.450527, -0.067322, 0.017987>
    }
    triangle {
      < 8.449084, -0.113718, -0.027474>,
      < 8.449073, -0.113962, -0.115949>,
      < 8.456743, -0.102848, -0.109697>
    }
    triangle {
      < 8.449084, -0.113718, -0.027474>,
      < 8.456743, -0.102848, -0.109697>,
      < 8.456768, -0.102725, -0.029282>
    }
    triangle {
      < 8.448833, -0.112282, -0.020161>,
      < 8.449084, -0.113718, -0.027474>,
      < 8.456768, -0.102725, -0.029282>
    }
    triangle {
      < 8.448833, -0.112282, -0.020161>,
      < 8.456768, -0.102725, -0.029282>,
      < 8.456559, -0.101531, -0.024214>
    }
    triangle {
      < 8.448113, -0.108205, -0.013962>,
      < 8.448833, -0.112282, -0.020161>,
      < 8.456559, -0.101531, -0.024214>
    }
    triangle {
      < 8.448113, -0.108205, -0.013962>,
      < 8.456559, -0.101531, -0.024214>,
      < 8.456199, -0.099492, -0.021113>
    }
    triangle {
      < 8.447039, -0.102105, -0.009820>,
      < 8.448113, -0.108205, -0.013962>,
      < 8.456199, -0.099492, -0.021113>
    }
    triangle {
      < 8.447039, -0.102105, -0.009820>,
      < 8.456199, -0.099492, -0.021113>,
      < 8.455663, -0.096441, -0.019043>
    }
    triangle {
      < 8.445770, -0.094911, -0.008366>,
      < 8.447039, -0.102105, -0.009820>,
      < 8.455663, -0.096441, -0.019043>
    }
    triangle {
      < 8.445770, -0.094911, -0.008366>,
      < 8.455663, -0.096441, -0.019043>,
      < 8.454782, -0.091450, -0.017835>
    }
    triangle {
      < 8.443193, -0.080297, -0.008369>,
      < 8.445770, -0.094911, -0.008366>,
      < 8.454782, -0.091450, -0.017835>
    }
    triangle {
      < 8.443193, -0.080297, -0.008369>,
      < 8.454782, -0.091450, -0.017835>,
      < 8.452231, -0.076982, -0.017840>
    }
    triangle {
      < 8.442703, -0.077510, -0.007404>,
      < 8.443193, -0.080297, -0.008369>,
      < 8.452231, -0.076982, -0.017840>
    }
    triangle {
      < 8.442703, -0.077510, -0.007404>,
      < 8.452231, -0.076982, -0.017840>,
      < 8.451460, -0.072605, -0.016761>
    }
    triangle {
      < 8.442703, -0.077510, -0.007404>,
      < 8.451460, -0.072605, -0.016761>,
      < 8.451014, -0.070075, -0.015057>
    }
    triangle {
      < 8.442703, -0.077510, -0.007404>,
      < 8.451014, -0.070075, -0.015057>,
      < 8.450716, -0.068385, -0.012504>
    }
    triangle {
      < 8.442535, -0.076557, -0.004581>,
      < 8.442703, -0.077510, -0.007404>,
      < 8.450716, -0.068385, -0.012504>
    }
    triangle {
      < 8.442535, -0.076557, -0.004581>,
      < 8.450716, -0.068385, -0.012504>,
      < 8.450527, -0.067314, -0.008082>
    }
    triangle {
      < 8.450527, -0.067322, 0.017987>,
      < 8.442534, -0.076558, 0.008512>,
      < 8.442535, -0.076557, -0.004581>
    }
    triangle {
      < 8.450527, -0.067322, 0.017987>,
      < 8.442535, -0.076557, -0.004581>,
      < 8.450527, -0.067314, -0.008082>
    }
    triangle {
      < 8.439141, -0.057309, 0.008515>,
      < 8.439137, -0.057319, 0.031635>,
      < 8.449841, -0.063440, 0.022662>
    }
    triangle {
      < 8.439141, -0.057309, 0.008515>,
      < 8.449841, -0.063440, 0.022662>,
      < 8.449863, -0.063554, 0.017989>
    }
    triangle {
      < 8.442532, -0.076568, 0.031622>,
      < 8.450527, -0.067324, 0.022512>,
      < 8.449841, -0.063440, 0.022662>
    }
    triangle {
      < 8.442532, -0.076568, 0.031622>,
      < 8.449841, -0.063440, 0.022662>,
      < 8.439137, -0.057319, 0.031635>
    }
    triangle {
      < 8.439856, -0.061362, 0.008515>,
      < 8.439141, -0.057309, 0.008515>,
      < 8.449863, -0.063554, 0.017989>
    }
    triangle {
      < 8.439856, -0.061362, 0.008515>,
      < 8.449863, -0.063554, 0.017989>,
      < 8.450527, -0.067322, 0.017987>
    }
    triangle {
      < 8.449863, -0.063554, 0.017989>,
      < 8.449841, -0.063440, 0.022662>,
      < 8.450527, -0.067324, 0.022512>
    }
    triangle {
      < 8.449863, -0.063554, 0.017989>,
      < 8.450527, -0.067324, 0.022512>,
      < 8.450527, -0.067322, 0.017987>
    }
    triangle {
      < 8.449213, -0.063579, -0.393726>,
      < 8.441108, -0.072022, -0.384156>,
      < 8.441070, -0.072203, -0.405110>
    }
    triangle {
      < 8.449213, -0.063579, -0.393726>,
      < 8.441070, -0.072203, -0.405110>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.435106, -0.038738, -0.425404>,
      < 8.446105, -0.046351, -0.415350>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.435106, -0.038738, -0.425404>,
      < 8.449172, -0.063769, -0.415198>,
      < 8.438607, -0.058625, -0.425225>
    }
    triangle {
      < 8.454077, -0.091623, -0.414954>,
      < 8.444707, -0.093255, -0.424915>,
      < 8.441031, -0.072385, -0.425102>
    }
    triangle {
      < 8.454077, -0.091623, -0.414954>,
      < 8.441031, -0.072385, -0.425102>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.438684, -0.058262, -0.384268>,
      < 8.449213, -0.063579, -0.393726>,
      < 8.449172, -0.063769, -0.415198>
    }
    triangle {
      < 8.438684, -0.058262, -0.384268>,
      < 8.449172, -0.063769, -0.415198>,
      < 8.438646, -0.058443, -0.405228>
    }
    triangle {
      < -6.898146, -0.049281, 0.137734>,
      < -6.899295, -0.055475, 0.136732>,
      < -6.889958, -0.060137, 0.145328>
    }
    triangle {
      < -6.898146, -0.049281, 0.137734>,
      < -6.889958, -0.060137, 0.145328>,
      < -6.888260, -0.051024, 0.146795>
    }
    triangle {
      < -6.887735, -0.071829, 0.293681>,
      < -6.879328, -0.063673, 0.271236>,
      < -6.884169, -0.062819, 0.224361>
    }
    triangle {
      < -6.887735, -0.071829, 0.293681>,
      < -6.884169, -0.062819, 0.224361>,
      < -6.895113, -0.070528, 0.225216>
    }
    triangle {
      < -6.901185, -0.055142, 0.097786>,
      < -6.900131, -0.048931, 0.096784>,
      < -6.891170, -0.050511, 0.086780>
    }
    triangle {
      < -6.901185, -0.055142, 0.097786>,
      < -6.891170, -0.050511, 0.086780>,
      < -6.892726, -0.059649, 0.088249>
    }
    triangle {
      < -6.900131, -0.048931, 0.096784>,
      < -6.898995, -0.042735, 0.097786>,
      < -6.889508, -0.041392, 0.088249>
    }
    triangle {
      < -6.900131, -0.048931, 0.096784>,
      < -6.889508, -0.041392, 0.088249>,
      < -6.891170, -0.050511, 0.086780>
    }
    triangle {
      < -6.898995, -0.042735, 0.097786>,
      < -6.897890, -0.037159, 0.100695>,
      < -6.887896, -0.033185, 0.092514>
    }
    triangle {
      < -6.898995, -0.042735, 0.097786>,
      < -6.887896, -0.033185, 0.092514>,
      < -6.889508, -0.041392, 0.088249>
    }
    triangle {
      < -6.897890, -0.037159, 0.100695>,
      < -6.896914, -0.032751, 0.105226>,
      < -6.886478, -0.026695, 0.099155>
    }
    triangle {
      < -6.897890, -0.037159, 0.100695>,
      < -6.886478, -0.026695, 0.099155>,
      < -6.887896, -0.033185, 0.092514>
    }
    triangle {
      < -6.896914, -0.032751, 0.105226>,
      < -6.896155, -0.029945, 0.110935>,
      < -6.885379, -0.022564, 0.107523>
    }
    triangle {
      < -6.896914, -0.032751, 0.105226>,
      < -6.885379, -0.022564, 0.107523>,
      < -6.886478, -0.026695, 0.099155>
    }
    triangle {
      < -6.896155, -0.029945, 0.110935>,
      < -6.895685, -0.029014, 0.117263>,
      < -6.884694, -0.021194, 0.116797>
    }
    triangle {
      < -6.896155, -0.029945, 0.110935>,
      < -6.884694, -0.021194, 0.116797>,
      < -6.885379, -0.022564, 0.107523>
    }
    triangle {
      < -6.895685, -0.029014, 0.117263>,
      < -6.895543, -0.030053, 0.123590>,
      < -6.884480, -0.022722, 0.126069>
    }
    triangle {
      < -6.895685, -0.029014, 0.117263>,
      < -6.884480, -0.022722, 0.126069>,
      < -6.884694, -0.021194, 0.116797>
    }
    triangle {
      < -6.895543, -0.030053, 0.123590>,
      < -6.895747, -0.032956, 0.129297>,
      < -6.884768, -0.026997, 0.134432>
    }
    triangle {
      < -6.895543, -0.030053, 0.123590>,
      < -6.884768, -0.026997, 0.134432>,
      < -6.884480, -0.022722, 0.126069>
    }
    triangle {
      < -6.895747, -0.032956, 0.129297>,
      < -6.896285, -0.037442, 0.133826>,
      < -6.885541, -0.033600, 0.141069>
    }
    triangle {
      < -6.895747, -0.032956, 0.129297>,
      < -6.885541, -0.033600, 0.141069>,
      < -6.884768, -0.026997, 0.134432>
    }
    triangle {
      < -6.896285, -0.037442, 0.133826>,
      < -6.897109, -0.043068, 0.136732>,
      < -6.886740, -0.041880, 0.145328>
    }
    triangle {
      < -6.896285, -0.037442, 0.133826>,
      < -6.886740, -0.041880, 0.145328>,
      < -6.885541, -0.033600, 0.141069>
    }
    triangle {
      < -6.897109, -0.043068, 0.136732>,
      < -6.898146, -0.049281, 0.137734>,
      < -6.888260, -0.051024, 0.146795>
    }
    triangle {
      < -6.897109, -0.043068, 0.136732>,
      < -6.888260, -0.051024, 0.146795>,
      < -6.886740, -0.041880, 0.145328>
    }
    triangle {
      < -6.888072, -0.042204, 0.123134>,
      < -6.888363, -0.044574, 0.125518>,
      < -6.896285, -0.037442, 0.133826>
    }
    triangle {
      < -6.888072, -0.042204, 0.123134>,
      < -6.896285, -0.037442, 0.133826>,
      < -6.895747, -0.032956, 0.129297>
    }
    triangle {
      < -6.888363, -0.044574, 0.125518>,
      < -6.888804, -0.047546, 0.127048>,
      < -6.897109, -0.043068, 0.136732>
    }
    triangle {
      < -6.888363, -0.044574, 0.125518>,
      < -6.897109, -0.043068, 0.136732>,
      < -6.896285, -0.037442, 0.133826>
    }
    triangle {
      < -6.888804, -0.047546, 0.127048>,
      < -6.889356, -0.050831, 0.127576>,
      < -6.898146, -0.049281, 0.137734>
    }
    triangle {
      < -6.888804, -0.047546, 0.127048>,
      < -6.898146, -0.049281, 0.137734>,
      < -6.897109, -0.043068, 0.136732>
    }
    triangle {
      < -6.889356, -0.050831, 0.127576>,
      < -6.889962, -0.054105, 0.127048>,
      < -6.899295, -0.055475, 0.136732>
    }
    triangle {
      < -6.889356, -0.050831, 0.127576>,
      < -6.899295, -0.055475, 0.136732>,
      < -6.898146, -0.049281, 0.137734>
    }
    triangle {
      < -6.889962, -0.054105, 0.127048>,
      < -6.890563, -0.057049, 0.125518>,
      < -6.900514, -0.061428, 0.133826>
    }
    triangle {
      < -6.889962, -0.054105, 0.127048>,
      < -6.900514, -0.061428, 0.133826>,
      < -6.899295, -0.055475, 0.136732>
    }
    triangle {
      < -6.890563, -0.057049, 0.125518>,
      < -6.891100, -0.059375, 0.123134>,
      < -6.901597, -0.066131, 0.129297>
    }
    triangle {
      < -6.890563, -0.057049, 0.125518>,
      < -6.901597, -0.066131, 0.129297>,
      < -6.900514, -0.061428, 0.133826>
    }
    triangle {
      < -6.891100, -0.059375, 0.123134>,
      < -6.891518, -0.060856, 0.120129>,
      < -6.902451, -0.069234, 0.123590>
    }
    triangle {
      < -6.891100, -0.059375, 0.123134>,
      < -6.902451, -0.069234, 0.123590>,
      < -6.901597, -0.066131, 0.129297>
    }
    triangle {
      < -6.891518, -0.060856, 0.120129>,
      < -6.891774, -0.061347, 0.116797>,
      < -6.902767, -0.069183, 0.117263>
    }
    triangle {
      < -6.891518, -0.060856, 0.120129>,
      < -6.902767, -0.069183, 0.117263>,
      < -6.902451, -0.069234, 0.123590>
    }
    triangle {
      < -6.891774, -0.061347, 0.116797>,
      < -6.891840, -0.060799, 0.113466>,
      < -6.903065, -0.069126, 0.110935>
    }
    triangle {
      < -6.891774, -0.061347, 0.116797>,
      < -6.903065, -0.069126, 0.110935>,
      < -6.902767, -0.069183, 0.117263>
    }
    triangle {
      < -6.891840, -0.060799, 0.113466>,
      < -6.891715, -0.059267, 0.110461>,
      < -6.902762, -0.065926, 0.105226>
    }
    triangle {
      < -6.891840, -0.060799, 0.113466>,
      < -6.902762, -0.065926, 0.105226>,
      < -6.903065, -0.069126, 0.110935>
    }
    triangle {
      < -6.891715, -0.059267, 0.110461>,
      < -6.891408, -0.056900, 0.108075>,
      < -6.902119, -0.061145, 0.100695>
    }
    triangle {
      < -6.891715, -0.059267, 0.110461>,
      < -6.902119, -0.061145, 0.100695>,
      < -6.902762, -0.065926, 0.105226>
    }
    triangle {
      < -6.891408, -0.056900, 0.108075>,
      < -6.890955, -0.053930, 0.106543>,
      < -6.901185, -0.055142, 0.097786>
    }
    triangle {
      < -6.891408, -0.056900, 0.108075>,
      < -6.901185, -0.055142, 0.097786>,
      < -6.902119, -0.061145, 0.100695>
    }
    triangle {
      < -6.890955, -0.053930, 0.106543>,
      < -6.890401, -0.050646, 0.106016>,
      < -6.900131, -0.048931, 0.096784>
    }
    triangle {
      < -6.890955, -0.053930, 0.106543>,
      < -6.900131, -0.048931, 0.096784>,
      < -6.901185, -0.055142, 0.097786>
    }
    triangle {
      < -6.890401, -0.050646, 0.106016>,
      < -6.889800, -0.047371, 0.106543>,
      < -6.898995, -0.042735, 0.097786>
    }
    triangle {
      < -6.890401, -0.050646, 0.106016>,
      < -6.898995, -0.042735, 0.097786>,
      < -6.900131, -0.048931, 0.096784>
    }
    triangle {
      < -6.889800, -0.047371, 0.106543>,
      < -6.889208, -0.044425, 0.108075>,
      < -6.897890, -0.037159, 0.100695>
    }
    triangle {
      < -6.889800, -0.047371, 0.106543>,
      < -6.897890, -0.037159, 0.100695>,
      < -6.898995, -0.042735, 0.097786>
    }
    triangle {
      < -6.889208, -0.044425, 0.108075>,
      < -6.888687, -0.042096, 0.110461>,
      < -6.896914, -0.032751, 0.105226>
    }
    triangle {
      < -6.889208, -0.044425, 0.108075>,
      < -6.896914, -0.032751, 0.105226>,
      < -6.897890, -0.037159, 0.100695>
    }
    triangle {
      < -6.888687, -0.042096, 0.110461>,
      < -6.888281, -0.040614, 0.113466>,
      < -6.896155, -0.029945, 0.110935>
    }
    triangle {
      < -6.888687, -0.042096, 0.110461>,
      < -6.896155, -0.029945, 0.110935>,
      < -6.896914, -0.032751, 0.105226>
    }
    triangle {
      < -6.888281, -0.040614, 0.113466>,
      < -6.888031, -0.040122, 0.116797>,
      < -6.895685, -0.029014, 0.117263>
    }
    triangle {
      < -6.888281, -0.040614, 0.113466>,
      < -6.895685, -0.029014, 0.117263>,
      < -6.896155, -0.029945, 0.110935>
    }
    triangle {
      < -6.888031, -0.040122, 0.116797>,
      < -6.887959, -0.040671, 0.120129>,
      < -6.895543, -0.030053, 0.123590>
    }
    triangle {
      < -6.888031, -0.040122, 0.116797>,
      < -6.895543, -0.030053, 0.123590>,
      < -6.895685, -0.029014, 0.117263>
    }
    triangle {
      < -6.887959, -0.040671, 0.120129>,
      < -6.888072, -0.042204, 0.123134>,
      < -6.895747, -0.032956, 0.129297>
    }
    triangle {
      < -6.887959, -0.040671, 0.120129>,
      < -6.895747, -0.032956, 0.129297>,
      < -6.895543, -0.030053, 0.123590>
    }
    triangle {
      < -6.885869, -0.051445, 0.279618>,
      < -6.880793, -0.052341, 0.320293>,
      < -6.872285, -0.050459, 0.308956>
    }
    triangle {
      < -6.885869, -0.051445, 0.279618>,
      < -6.872285, -0.050459, 0.308956>,
      < -6.874828, -0.050011, 0.288589>
    }
    triangle {
      < -6.887735, -0.071829, 0.293681>,
      < -6.871912, -0.074619, 0.402584>,
      < -6.861048, -0.066892, 0.401078>
    }
    triangle {
      < -6.887735, -0.071829, 0.293681>,
      < -6.861048, -0.066892, 0.401078>,
      < -6.876029, -0.064123, 0.298775>
    }
    triangle {
      < -6.887568, -0.063736, 0.283506>,
      < -6.886847, -0.057670, 0.280614>,
      < -6.879138, -0.062045, 0.270407>
    }
    triangle {
      < -6.887568, -0.063736, 0.283506>,
      < -6.879138, -0.062045, 0.270407>,
      < -6.879328, -0.063673, 0.271236>
    }
    triangle {
      < -6.886847, -0.057670, 0.280614>,
      < -6.885869, -0.051445, 0.279618>,
      < -6.877693, -0.052887, 0.268946>
    }
    triangle {
      < -6.886847, -0.057670, 0.280614>,
      < -6.877693, -0.052887, 0.268946>,
      < -6.879138, -0.062045, 0.270407>
    }
    triangle {
      < -6.885869, -0.051445, 0.279618>,
      < -6.884660, -0.045262, 0.280614>,
      < -6.875918, -0.043788, 0.270407>
    }
    triangle {
      < -6.885869, -0.051445, 0.279618>,
      < -6.875918, -0.043788, 0.270407>,
      < -6.877693, -0.052887, 0.268946>
    }
    triangle {
      < -6.884660, -0.045262, 0.280614>,
      < -6.883334, -0.039726, 0.283506>,
      < -6.873983, -0.035638, 0.274646>
    }
    triangle {
      < -6.884660, -0.045262, 0.280614>,
      < -6.873983, -0.035638, 0.274646>,
      < -6.875918, -0.043788, 0.270407>
    }
    triangle {
      < -6.883334, -0.039726, 0.283506>,
      < -6.882015, -0.035378, 0.288009>,
      < -6.872066, -0.029237, 0.281247>
    }
    triangle {
      < -6.883334, -0.039726, 0.283506>,
      < -6.872066, -0.029237, 0.281247>,
      < -6.873983, -0.035638, 0.274646>
    }
    triangle {
      < -6.882015, -0.035378, 0.288009>,
      < -6.880826, -0.032647, 0.293681>,
      < -6.870337, -0.025216, 0.289562>
    }
    triangle {
      < -6.882015, -0.035378, 0.288009>,
      < -6.870337, -0.025216, 0.289562>,
      < -6.872066, -0.029237, 0.281247>
    }
    triangle {
      < -6.880826, -0.032647, 0.293681>,
      < -6.879877, -0.031802, 0.299967>,
      < -6.868949, -0.023970, 0.298775>
    }
    triangle {
      < -6.880826, -0.032647, 0.293681>,
      < -6.868949, -0.023970, 0.298775>,
      < -6.870337, -0.025216, 0.289562>
    }
    triangle {
      < -6.879877, -0.031802, 0.299967>,
      < -6.879258, -0.032924, 0.306250>,
      < -6.868035, -0.025622, 0.307983>
    }
    triangle {
      < -6.879877, -0.031802, 0.299967>,
      < -6.868035, -0.025622, 0.307983>,
      < -6.868949, -0.023970, 0.298775>
    }
    triangle {
      < -6.879258, -0.032924, 0.306250>,
      < -6.879031, -0.035904, 0.311917>,
      < -6.867692, -0.030008, 0.316286>
    }
    triangle {
      < -6.879258, -0.032924, 0.306250>,
      < -6.867692, -0.030008, 0.316286>,
      < -6.868035, -0.025622, 0.307983>
    }
    triangle {
      < -6.879031, -0.035904, 0.311917>,
      < -6.879227, -0.040450, 0.316412>,
      < -6.867965, -0.036699, 0.322873>
    }
    triangle {
      < -6.879031, -0.035904, 0.311917>,
      < -6.867965, -0.036699, 0.322873>,
      < -6.867692, -0.030008, 0.316286>
    }
    triangle {
      < -6.879227, -0.040450, 0.316412>,
      < -6.879830, -0.046114, 0.319299>,
      < -6.868843, -0.045036, 0.327100>
    }
    triangle {
      < -6.879227, -0.040450, 0.316412>,
      < -6.868843, -0.045036, 0.327100>,
      < -6.867965, -0.036699, 0.322873>
    }
    triangle {
      < -6.879830, -0.046114, 0.319299>,
      < -6.880793, -0.052341, 0.320293>,
      < -6.870253, -0.054199, 0.328557>
    }
    triangle {
      < -6.879830, -0.046114, 0.319299>,
      < -6.870253, -0.054199, 0.328557>,
      < -6.868843, -0.045036, 0.327100>
    }
    triangle {
      < -6.871850, -0.045065, 0.305067>,
      < -6.871961, -0.047466, 0.307435>,
      < -6.879227, -0.040450, 0.316412>
    }
    triangle {
      < -6.871850, -0.045065, 0.305067>,
      < -6.879227, -0.040450, 0.316412>,
      < -6.879031, -0.035904, 0.311917>
    }
    triangle {
      < -6.871961, -0.047466, 0.307435>,
      < -6.872285, -0.050459, 0.308956>,
      < -6.879830, -0.046114, 0.319299>
    }
    triangle {
      < -6.871961, -0.047466, 0.307435>,
      < -6.879830, -0.046114, 0.319299>,
      < -6.879227, -0.040450, 0.316412>
    }
    triangle {
      < -6.872285, -0.050459, 0.308956>,
      < -6.880793, -0.052341, 0.320293>,
      < -6.879830, -0.046114, 0.319299>
    }
    triangle {
      < -6.876348, -0.063531, 0.295465>,
      < -6.887735, -0.071829, 0.293681>,
      < -6.876029, -0.064123, 0.298775>
    }
    triangle {
      < -6.876348, -0.063531, 0.295465>,
      < -6.876450, -0.061959, 0.292481>,
      < -6.887873, -0.068598, 0.288009>
    }
    triangle {
      < -6.876348, -0.063531, 0.295465>,
      < -6.887873, -0.068598, 0.288009>,
      < -6.887735, -0.071829, 0.293681>
    }
    triangle {
      < -6.876450, -0.061959, 0.292481>,
      < -6.876323, -0.059560, 0.290111>,
      < -6.887568, -0.063736, 0.283506>
    }
    triangle {
      < -6.876450, -0.061959, 0.292481>,
      < -6.887568, -0.063736, 0.283506>,
      < -6.887873, -0.068598, 0.288009>
    }
    triangle {
      < -6.876323, -0.059560, 0.290111>,
      < -6.875986, -0.056569, 0.288589>,
      < -6.886847, -0.057670, 0.280614>
    }
    triangle {
      < -6.876323, -0.059560, 0.290111>,
      < -6.886847, -0.057670, 0.280614>,
      < -6.887568, -0.063736, 0.283506>
    }
    triangle {
      < -6.870903, -0.057466, 0.328034>,
      < -6.880793, -0.052341, 0.320293>,
      < -6.885869, -0.051445, 0.279618>
    }
    triangle {
      < -6.870903, -0.057466, 0.328034>,
      < -6.885869, -0.051445, 0.279618>,
      < -6.875986, -0.056569, 0.288589>
    }
    triangle {
      < -6.874828, -0.050011, 0.288589>,
      < -6.884660, -0.045262, 0.280614>,
      < -6.885869, -0.051445, 0.279618>
    }
    triangle {
      < -6.874828, -0.050011, 0.288589>,
      < -6.874124, -0.047085, 0.290111>,
      < -6.883334, -0.039726, 0.283506>
    }
    triangle {
      < -6.874828, -0.050011, 0.288589>,
      < -6.883334, -0.039726, 0.283506>,
      < -6.884660, -0.045262, 0.280614>
    }
    triangle {
      < -6.874124, -0.047085, 0.290111>,
      < -6.873422, -0.044788, 0.292481>,
      < -6.882015, -0.035378, 0.288009>
    }
    triangle {
      < -6.874124, -0.047085, 0.290111>,
      < -6.882015, -0.035378, 0.288009>,
      < -6.883334, -0.039726, 0.283506>
    }
    triangle {
      < -6.873422, -0.044788, 0.292481>,
      < -6.872788, -0.043346, 0.295465>,
      < -6.880826, -0.032647, 0.293681>
    }
    triangle {
      < -6.873422, -0.044788, 0.292481>,
      < -6.880826, -0.032647, 0.293681>,
      < -6.882015, -0.035378, 0.288009>
    }
    triangle {
      < -6.872788, -0.043346, 0.295465>,
      < -6.872286, -0.042898, 0.298775>,
      < -6.879877, -0.031802, 0.299967>
    }
    triangle {
      < -6.872788, -0.043346, 0.295465>,
      < -6.879877, -0.031802, 0.299967>,
      < -6.880826, -0.032647, 0.293681>
    }
    triangle {
      < -6.872286, -0.042898, 0.298775>,
      < -6.871964, -0.043491, 0.302083>,
      < -6.879258, -0.032924, 0.306250>
    }
    triangle {
      < -6.872286, -0.042898, 0.298775>,
      < -6.879258, -0.032924, 0.306250>,
      < -6.879877, -0.031802, 0.299967>
    }
    triangle {
      < -6.871964, -0.043491, 0.302083>,
      < -6.871850, -0.045065, 0.305067>,
      < -6.879031, -0.035904, 0.311917>
    }
    triangle {
      < -6.871964, -0.043491, 0.302083>,
      < -6.879031, -0.035904, 0.311917>,
      < -6.879258, -0.032924, 0.306250>
    }
    triangle {
      < -6.888669, -0.044556, -0.243924>,
      < -6.889661, -0.050777, -0.244923>,
      < -6.880804, -0.048957, -0.233847>
    }
    triangle {
      < -6.881521, -0.063286, -0.251231>,
      < -6.874565, -0.064513, -0.310585>,
      < -6.884016, -0.072485, -0.322797>
    }
    triangle {
      < -6.881521, -0.063286, -0.251231>,
      < -6.884016, -0.072485, -0.322797>,
      < -6.894595, -0.070620, -0.230827>
    }
    triangle {
      < -6.890857, -0.056963, -0.243924>,
      < -6.889661, -0.050777, -0.244923>,
      < -6.879385, -0.052589, -0.253523>
    }
    triangle {
      < -6.890857, -0.056963, -0.243924>,
      < -6.879385, -0.052589, -0.253523>,
      < -6.881148, -0.061691, -0.252060>
    }
    triangle {
      < -6.889661, -0.050777, -0.244923>,
      < -6.888669, -0.044556, -0.243924>,
      < -6.877930, -0.043433, -0.252060>
    }
    triangle {
      < -6.889661, -0.050777, -0.244923>,
      < -6.877930, -0.043433, -0.252060>,
      < -6.879385, -0.052589, -0.253523>
    }
    triangle {
      < -6.888669, -0.044556, -0.243924>,
      < -6.887973, -0.038908, -0.241027>,
      < -6.876920, -0.035120, -0.247817>
    }
    triangle {
      < -6.888669, -0.044556, -0.243924>,
      < -6.876920, -0.035120, -0.247817>,
      < -6.877930, -0.043433, -0.252060>
    }
    triangle {
      < -6.887973, -0.038908, -0.241027>,
      < -6.887637, -0.034386, -0.236515>,
      < -6.876441, -0.028465, -0.241206>
    }
    triangle {
      < -6.887973, -0.038908, -0.241027>,
      < -6.876441, -0.028465, -0.241206>,
      < -6.876920, -0.035120, -0.247817>
    }
    triangle {
      < -6.887637, -0.034386, -0.236515>,
      < -6.887686, -0.031438, -0.230827>,
      < -6.876523, -0.024125, -0.232871>
    }
    triangle {
      < -6.887637, -0.034386, -0.236515>,
      < -6.876523, -0.024125, -0.232871>,
      < -6.876441, -0.028465, -0.241206>
    }
    triangle {
      < -6.887686, -0.031438, -0.230827>,
      < -6.888106, -0.030350, -0.224522>,
      < -6.877147, -0.022525, -0.223630>
    }
    triangle {
      < -6.887686, -0.031438, -0.230827>,
      < -6.877147, -0.022525, -0.223630>,
      < -6.876523, -0.024125, -0.232871>
    }
    triangle {
      < -6.888106, -0.030350, -0.224522>,
      < -6.888858, -0.031231, -0.218214>,
      < -6.878243, -0.023822, -0.214384>
    }
    triangle {
      < -6.888106, -0.030350, -0.224522>,
      < -6.878243, -0.023822, -0.214384>,
      < -6.877147, -0.022525, -0.223630>
    }
    triangle {
      < -6.888858, -0.031231, -0.218214>,
      < -6.889870, -0.033993, -0.212522>,
      < -6.879713, -0.027889, -0.206042>
    }
    triangle {
      < -6.888858, -0.031231, -0.218214>,
      < -6.879713, -0.027889, -0.206042>,
      < -6.878243, -0.023822, -0.214384>
    }
    triangle {
      < -6.889870, -0.033993, -0.212522>,
      < -6.891047, -0.038366, -0.208005>,
      < -6.881423, -0.034326, -0.199419>
    }
    triangle {
      < -6.889870, -0.033993, -0.212522>,
      < -6.881423, -0.034326, -0.199419>,
      < -6.879713, -0.027889, -0.206042>
    }
    triangle {
      < -6.891047, -0.038366, -0.208005>,
      < -6.892282, -0.043919, -0.205103>,
      < -6.883224, -0.042500, -0.195166>
    }
    triangle {
      < -6.891047, -0.038366, -0.208005>,
      < -6.883224, -0.042500, -0.195166>,
      < -6.881423, -0.034326, -0.199419>
    }
    triangle {
      < -6.892282, -0.043919, -0.205103>,
      < -6.893459, -0.050107, -0.204103>,
      < -6.884952, -0.051607, -0.193701>
    }
    triangle {
      < -6.892282, -0.043919, -0.205103>,
      < -6.884952, -0.051607, -0.193701>,
      < -6.883224, -0.042500, -0.195166>
    }
    triangle {
      < -6.881421, -0.043377, -0.217313>,
      < -6.882049, -0.045687, -0.214935>,
      < -6.891047, -0.038366, -0.208005>
    }
    triangle {
      < -6.881421, -0.043377, -0.217313>,
      < -6.891047, -0.038366, -0.208005>,
      < -6.889870, -0.033993, -0.212522>
    }
    triangle {
      < -6.882049, -0.045687, -0.214935>,
      < -6.882706, -0.048622, -0.213409>,
      < -6.892282, -0.043919, -0.205103>
    }
    triangle {
      < -6.882049, -0.045687, -0.214935>,
      < -6.892282, -0.043919, -0.205103>,
      < -6.891047, -0.038366, -0.208005>
    }
    triangle {
      < -6.883822, -0.062213, -0.226950>,
      < -6.894595, -0.070620, -0.230827>,
      < -6.884225, -0.062677, -0.223630>
    }
    triangle {
      < -6.883822, -0.062213, -0.226950>,
      < -6.883273, -0.060756, -0.229945>,
      < -6.893486, -0.067561, -0.236515>
    }
    triangle {
      < -6.883822, -0.062213, -0.226950>,
      < -6.893486, -0.067561, -0.236515>,
      < -6.894595, -0.070620, -0.230827>
    }
    triangle {
      < -6.883273, -0.060756, -0.229945>,
      < -6.882629, -0.058448, -0.232322>,
      < -6.892202, -0.062894, -0.241027>
    }
    triangle {
      < -6.883273, -0.060756, -0.229945>,
      < -6.892202, -0.062894, -0.241027>,
      < -6.893486, -0.067561, -0.236515>
    }
    triangle {
      < -6.882629, -0.058448, -0.232322>,
      < -6.881959, -0.055516, -0.233847>,
      < -6.890857, -0.056963, -0.243924>
    }
    triangle {
      < -6.882629, -0.058448, -0.232322>,
      < -6.890857, -0.056963, -0.243924>,
      < -6.892202, -0.062894, -0.241027>
    }
    triangle {
      < -6.881959, -0.055516, -0.233847>,
      < -6.889661, -0.050777, -0.244923>,
      < -6.890857, -0.056963, -0.243924>
    }
    triangle {
      < -6.880804, -0.048957, -0.233847>,
      < -6.880430, -0.045973, -0.232322>,
      < -6.887973, -0.038908, -0.241027>
    }
    triangle {
      < -6.880804, -0.048957, -0.233847>,
      < -6.887973, -0.038908, -0.241027>,
      < -6.888669, -0.044556, -0.243924>
    }
    triangle {
      < -6.880430, -0.045973, -0.232322>,
      < -6.880245, -0.043585, -0.229945>,
      < -6.887637, -0.034386, -0.236515>
    }
    triangle {
      < -6.880430, -0.045973, -0.232322>,
      < -6.887637, -0.034386, -0.236515>,
      < -6.887973, -0.038908, -0.241027>
    }
    triangle {
      < -6.880245, -0.043585, -0.229945>,
      < -6.880263, -0.042028, -0.226950>,
      < -6.887686, -0.031438, -0.230827>
    }
    triangle {
      < -6.880245, -0.043585, -0.229945>,
      < -6.887686, -0.031438, -0.230827>,
      < -6.887637, -0.034386, -0.236515>
    }
    triangle {
      < -6.880263, -0.042028, -0.226950>,
      < -6.880484, -0.041453, -0.223630>,
      < -6.888106, -0.030350, -0.224522>
    }
    triangle {
      < -6.880263, -0.042028, -0.226950>,
      < -6.888106, -0.030350, -0.224522>,
      < -6.887686, -0.031438, -0.230827>
    }
    triangle {
      < -6.880484, -0.041453, -0.223630>,
      < -6.880881, -0.041919, -0.220309>,
      < -6.888858, -0.031231, -0.218214>
    }
    triangle {
      < -6.880484, -0.041453, -0.223630>,
      < -6.888858, -0.031231, -0.218214>,
      < -6.888106, -0.030350, -0.224522>
    }
    triangle {
      < -6.880881, -0.041919, -0.220309>,
      < -6.881421, -0.043377, -0.217313>,
      < -6.889870, -0.033993, -0.212522>
    }
    triangle {
      < -6.880881, -0.041919, -0.220309>,
      < -6.889870, -0.033993, -0.212522>,
      < -6.888858, -0.031231, -0.218214>
    }
    triangle {
      < -6.884016, -0.072485, -0.322797>,
      < -6.876619, -0.083428, -0.320008>,
      < -6.887564, -0.081606, -0.223630>
    }
    triangle {
      < -6.884016, -0.072485, -0.322797>,
      < -6.887564, -0.081606, -0.223630>,
      < -6.895363, -0.080172, -0.111395>
    }
    triangle {
      < -6.884016, -0.072485, -0.322797>,
      < -6.895363, -0.080172, -0.111395>,
      < -6.903028, -0.069132, -0.111839>
    }
    triangle {
      < -6.884016, -0.072485, -0.322797>,
      < -6.903028, -0.069132, -0.111839>,
      < -6.894595, -0.070620, -0.230827>
    }
    triangle {
      < -6.868268, -0.015195, -0.361188>,
      < -6.858795, -0.007227, -0.350353>,
      < -6.855959, -0.007727, -0.369149>
    }
    triangle {
      < -6.886057, -0.012058, 0.211781>,
      < -6.874248, -0.004502, 0.220574>,
      < -6.875939, -0.004204, 0.201302>
    }
    triangle {
      < -6.859277, -0.016780, 0.416350>,
      < -6.846696, -0.009360, 0.424559>,
      < -6.850142, -0.008753, 0.404826>
    }
    triangle {
      < -6.875939, -0.004204, 0.201302>,
      < -6.885551, -0.058721, 0.201302>,
      < -6.894041, -0.057330, 0.211781>
    }
    triangle {
      < -6.875939, -0.004204, 0.201302>,
      < -6.894041, -0.057330, 0.211781>,
      < -6.886057, -0.012058, 0.211781>
    }
    triangle {
      < -6.858541, -0.034870, 0.437608>,
      < -6.846417, -0.029914, 0.445212>,
      < -6.850203, -0.029246, 0.424559>
    }
    triangle {
      < -6.858541, -0.034870, 0.437608>,
      < -6.850203, -0.029246, 0.424559>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.835291, -0.090716, 0.546070>,
      < -6.844868, -0.079388, 0.538953>,
      < -6.867107, -0.075466, 0.430103>
    }
    triangle {
      < -6.835291, -0.090716, 0.546070>,
      < -6.867107, -0.075466, 0.430103>,
      < -6.859577, -0.086434, 0.428393>
    }
    triangle {
      < -6.864360, -0.085590, 0.400985>,
      < -6.871912, -0.074619, 0.402584>,
      < -6.887735, -0.071829, 0.293681>
    }
    triangle {
      < -6.864360, -0.085590, 0.400985>,
      < -6.887735, -0.071829, 0.293681>,
      < -6.880139, -0.082915, 0.292518>
    }
    triangle {
      < -6.892980, -0.061266, 0.089084>,
      < -6.894421, -0.061012, 0.031582>,
      < -6.905423, -0.068710, 0.029892>
    }
    triangle {
      < -6.892980, -0.061266, 0.089084>,
      < -6.905423, -0.068710, 0.029892>,
      < -6.903065, -0.069126, 0.110935>
    }
    triangle {
      < -6.869529, -0.084679, -0.369149>,
      < -6.880188, -0.082799, -0.361188>,
      < -6.877129, -0.065441, -0.361188>
    }
    triangle {
      < -6.869529, -0.084679, -0.369149>,
      < -6.877129, -0.065441, -0.361188>,
      < -6.868347, -0.077978, -0.369149>
    }
    triangle {
      < -6.871272, -0.073707, -0.405451>,
      < -6.865896, -0.076326, -0.437494>,
      < -6.858404, -0.087287, -0.435569>
    }
    triangle {
      < -6.871272, -0.073707, -0.405451>,
      < -6.858404, -0.087287, -0.435569>,
      < -6.863889, -0.084607, -0.402819>
    }
    triangle {
      < -6.865896, -0.076326, -0.437494>,
      < -6.859756, -0.077057, -0.469386>,
      < -6.852170, -0.088029, -0.467949>
    }
    triangle {
      < -6.865896, -0.076326, -0.437494>,
      < -6.852170, -0.088029, -0.467949>,
      < -6.858404, -0.087287, -0.435569>
    }
    triangle {
      < -6.859756, -0.077057, -0.469386>,
      < -6.853734, -0.075805, -0.497015>,
      < -6.846063, -0.086754, -0.495927>
    }
    triangle {
      < -6.859756, -0.077057, -0.469386>,
      < -6.846063, -0.086754, -0.495927>,
      < -6.852170, -0.088029, -0.467949>
    }
    triangle {
      < -6.853734, -0.075805, -0.497015>,
      < -6.847311, -0.073832, -0.524329>,
      < -6.839548, -0.084748, -0.523559>
    }
    triangle {
      < -6.853734, -0.075805, -0.497015>,
      < -6.839548, -0.084748, -0.523559>,
      < -6.846063, -0.086754, -0.495927>
    }
    triangle {
      < -6.847311, -0.073832, -0.524329>,
      < -6.842885, -0.071472, -0.541565>,
      < -6.834881, -0.082259, -0.541661>
    }
    triangle {
      < -6.847311, -0.073832, -0.524329>,
      < -6.834881, -0.082259, -0.541661>,
      < -6.839548, -0.084748, -0.523559>
    }
    triangle {
      < -6.842885, -0.071472, -0.541565>,
      < -6.838786, -0.067424, -0.555683>,
      < -6.830350, -0.077790, -0.557179>
    }
    triangle {
      < -6.842885, -0.071472, -0.541565>,
      < -6.830350, -0.077790, -0.557179>,
      < -6.834881, -0.082259, -0.541661>
    }
    triangle {
      < -6.838786, -0.067424, -0.555683>,
      < -6.835566, -0.062487, -0.565260>,
      < -6.826322, -0.071636, -0.569070>
    }
    triangle {
      < -6.838786, -0.067424, -0.555683>,
      < -6.826322, -0.071636, -0.569070>,
      < -6.830350, -0.077790, -0.557179>
    }
    triangle {
      < -6.835566, -0.062487, -0.565260>,
      < -6.833339, -0.056657, -0.570083>,
      < -6.822840, -0.062570, -0.576536>
    }
    triangle {
      < -6.835566, -0.062487, -0.565260>,
      < -6.822840, -0.062570, -0.576536>,
      < -6.826322, -0.071636, -0.569070>
    }
    triangle {
      < -6.833339, -0.056657, -0.570083>,
      < -6.831730, -0.049245, -0.571283>,
      < -6.820403, -0.051352, -0.578345>
    }
    triangle {
      < -6.833339, -0.056657, -0.570083>,
      < -6.820403, -0.051352, -0.578345>,
      < -6.822840, -0.062570, -0.576536>
    }
    triangle {
      < -6.831730, -0.049245, -0.571283>,
      < -6.830596, -0.041255, -0.570188>,
      < -6.818689, -0.039264, -0.576695>
    }
    triangle {
      < -6.831730, -0.049245, -0.571283>,
      < -6.818689, -0.039264, -0.576695>,
      < -6.820403, -0.051352, -0.578345>
    }
    triangle {
      < -6.830596, -0.041255, -0.570188>,
      < -6.830747, -0.035244, -0.565321>,
      < -6.818944, -0.029797, -0.569070>
    }
    triangle {
      < -6.830596, -0.041255, -0.570188>,
      < -6.818944, -0.029797, -0.569070>,
      < -6.818689, -0.039264, -0.576695>
    }
    triangle {
      < -6.830747, -0.035244, -0.565321>,
      < -6.832077, -0.029253, -0.555593>,
      < -6.820590, -0.022438, -0.557179>
    }
    triangle {
      < -6.830747, -0.035244, -0.565321>,
      < -6.820590, -0.022438, -0.557179>,
      < -6.818944, -0.029797, -0.569070>
    }
    triangle {
      < -6.832077, -0.029253, -0.555593>,
      < -6.834516, -0.023919, -0.541503>,
      < -6.823294, -0.016538, -0.541661>
    }
    triangle {
      < -6.832077, -0.029253, -0.555593>,
      < -6.823294, -0.016538, -0.541661>,
      < -6.820590, -0.022438, -0.557179>
    }
    triangle {
      < -6.834516, -0.023919, -0.541503>,
      < -6.837799, -0.020160, -0.524545>,
      < -6.826809, -0.012509, -0.523559>
    }
    triangle {
      < -6.834516, -0.023919, -0.541503>,
      < -6.826809, -0.012509, -0.523559>,
      < -6.823294, -0.016538, -0.541661>
    }
    triangle {
      < -6.837799, -0.020160, -0.524545>,
      < -6.841651, -0.018377, -0.505987>,
      < -6.830854, -0.010633, -0.504097>
    }
    triangle {
      < -6.837799, -0.020160, -0.524545>,
      < -6.830854, -0.010633, -0.504097>,
      < -6.826809, -0.012509, -0.523559>
    }
    triangle {
      < -6.841651, -0.018377, -0.505987>,
      < -6.849020, -0.018216, -0.471161>,
      < -6.838332, -0.010475, -0.468751>
    }
    triangle {
      < -6.841651, -0.018377, -0.505987>,
      < -6.838332, -0.010475, -0.468751>,
      < -6.830854, -0.010633, -0.504097>
    }
    triangle {
      < -6.849020, -0.018216, -0.471161>,
      < -6.855947, -0.019910, -0.437498>,
      < -6.845308, -0.012197, -0.434800>
    }
    triangle {
      < -6.849020, -0.018216, -0.471161>,
      < -6.845308, -0.012197, -0.434800>,
      < -6.838332, -0.010475, -0.468751>
    }
    triangle {
      < -6.855947, -0.019910, -0.437498>,
      < -6.860757, -0.022090, -0.413439>,
      < -6.851636, -0.015120, -0.402819>
    }
    triangle {
      < -6.855947, -0.019910, -0.437498>,
      < -6.851636, -0.015120, -0.402819>,
      < -6.845308, -0.012197, -0.434800>
    }
    triangle {
      < -6.860270, -0.066046, -0.404799>,
      < -6.855038, -0.068599, -0.435943>,
      < -6.865896, -0.076326, -0.437494>
    }
    triangle {
      < -6.860270, -0.066046, -0.404799>,
      < -6.865896, -0.076326, -0.437494>,
      < -6.871272, -0.073707, -0.405451>
    }
    triangle {
      < -6.855038, -0.068599, -0.435943>,
      < -6.849043, -0.069311, -0.467093>,
      < -6.859756, -0.077057, -0.469386>
    }
    triangle {
      < -6.855038, -0.068599, -0.435943>,
      < -6.859756, -0.077057, -0.469386>,
      < -6.865896, -0.076326, -0.437494>
    }
    triangle {
      < -6.849043, -0.069311, -0.467093>,
      < -6.843153, -0.068076, -0.494157>,
      < -6.853734, -0.075805, -0.497015>
    }
    triangle {
      < -6.849043, -0.069311, -0.467093>,
      < -6.853734, -0.075805, -0.497015>,
      < -6.859756, -0.077057, -0.469386>
    }
    triangle {
      < -6.843153, -0.068076, -0.494157>,
      < -6.836864, -0.066128, -0.520936>,
      < -6.847311, -0.073832, -0.524329>
    }
    triangle {
      < -6.843153, -0.068076, -0.494157>,
      < -6.847311, -0.073832, -0.524329>,
      < -6.853734, -0.075805, -0.497015>
    }
    triangle {
      < -6.836864, -0.066128, -0.520936>,
      < -6.832706, -0.063893, -0.537167>,
      < -6.842885, -0.071472, -0.541565>
    }
    triangle {
      < -6.836864, -0.066128, -0.520936>,
      < -6.842885, -0.071472, -0.541565>,
      < -6.847311, -0.073832, -0.524329>
    }
    triangle {
      < -6.832706, -0.063893, -0.537167>,
      < -6.829061, -0.060259, -0.549772>,
      < -6.838786, -0.067424, -0.555683>
    }
    triangle {
      < -6.832706, -0.063893, -0.537167>,
      < -6.838786, -0.067424, -0.555683>,
      < -6.842885, -0.071472, -0.541565>
    }
    triangle {
      < -6.829061, -0.060259, -0.549772>,
      < -6.826658, -0.056539, -0.556957>,
      < -6.835566, -0.062487, -0.565260>
    }
    triangle {
      < -6.829061, -0.060259, -0.549772>,
      < -6.835566, -0.062487, -0.565260>,
      < -6.838786, -0.067424, -0.555683>
    }
    triangle {
      < -6.826658, -0.056539, -0.556957>,
      < -6.825676, -0.053947, -0.559094>,
      < -6.833339, -0.056657, -0.570083>
    }
    triangle {
      < -6.826658, -0.056539, -0.556957>,
      < -6.833339, -0.056657, -0.570083>,
      < -6.835566, -0.062487, -0.565260>
    }
    triangle {
      < -6.825676, -0.053947, -0.559094>,
      < -6.824898, -0.050339, -0.559676>,
      < -6.831730, -0.049245, -0.571283>
    }
    triangle {
      < -6.825676, -0.053947, -0.559094>,
      < -6.831730, -0.049245, -0.571283>,
      < -6.833339, -0.056657, -0.570083>
    }
    triangle {
      < -6.824898, -0.050339, -0.559676>,
      < -6.824343, -0.046450, -0.559144>,
      < -6.830596, -0.041255, -0.570188>
    }
    triangle {
      < -6.824898, -0.050339, -0.559676>,
      < -6.830596, -0.041255, -0.570188>,
      < -6.831730, -0.049245, -0.571283>
    }
    triangle {
      < -6.824343, -0.046450, -0.559144>,
      < -6.824398, -0.043892, -0.557078>,
      < -6.830747, -0.035244, -0.565321>
    }
    triangle {
      < -6.824343, -0.046450, -0.559144>,
      < -6.830747, -0.035244, -0.565321>,
      < -6.830596, -0.041255, -0.570188>
    }
    triangle {
      < -6.824398, -0.043892, -0.557078>,
      < -6.825404, -0.039269, -0.549591>,
      < -6.832077, -0.029253, -0.555593>
    }
    triangle {
      < -6.824398, -0.043892, -0.557078>,
      < -6.832077, -0.029253, -0.555593>,
      < -6.830747, -0.035244, -0.565321>
    }
    triangle {
      < -6.825404, -0.039269, -0.549591>,
      < -6.827555, -0.034507, -0.537043>,
      < -6.834516, -0.023919, -0.541503>
    }
    triangle {
      < -6.825404, -0.039269, -0.549591>,
      < -6.834516, -0.023919, -0.541503>,
      < -6.832077, -0.029253, -0.555593>
    }
    triangle {
      < -6.827555, -0.034507, -0.537043>,
      < -6.830576, -0.031022, -0.521366>,
      < -6.837799, -0.020160, -0.524545>
    }
    triangle {
      < -6.827555, -0.034507, -0.537043>,
      < -6.837799, -0.020160, -0.524545>,
      < -6.834516, -0.023919, -0.541503>
    }
    triangle {
      < -6.830576, -0.031022, -0.521366>,
      < -6.834206, -0.029337, -0.503858>,
      < -6.841651, -0.018377, -0.505987>
    }
    triangle {
      < -6.830576, -0.031022, -0.521366>,
      < -6.841651, -0.018377, -0.505987>,
      < -6.837799, -0.020160, -0.524545>
    }
    triangle {
      < -6.834206, -0.029337, -0.503858>,
      < -6.841410, -0.029183, -0.469829>,
      < -6.849020, -0.018216, -0.471161>
    }
    triangle {
      < -6.834206, -0.029337, -0.503858>,
      < -6.849020, -0.018216, -0.471161>,
      < -6.841651, -0.018377, -0.505987>
    }
    triangle {
      < -6.841410, -0.029183, -0.469829>,
      < -6.848236, -0.030859, -0.436722>,
      < -6.855947, -0.019910, -0.437498>
    }
    triangle {
      < -6.841410, -0.029183, -0.469829>,
      < -6.855947, -0.019910, -0.437498>,
      < -6.849020, -0.018216, -0.471161>
    }
    triangle {
      < -6.848236, -0.030859, -0.436722>,
      < -6.855081, -0.034015, -0.402180>,
      < -6.860757, -0.022090, -0.413439>
    }
    triangle {
      < -6.848236, -0.030859, -0.436722>,
      < -6.860757, -0.022090, -0.413439>,
      < -6.855947, -0.019910, -0.437498>
    }
    triangle {
      < -6.876009, -0.082802, -0.323612>,
      < -6.884016, -0.072485, -0.322797>,
      < -6.875236, -0.080848, -0.326668>
    }
    triangle {
      < -6.867248, -0.055168, -0.350353>,
      < -6.877129, -0.065441, -0.361188>,
      < -6.880188, -0.082799, -0.361188>
    }
    triangle {
      < -6.868268, -0.015195, -0.361188>,
      < -6.855959, -0.007727, -0.369149>,
      < -6.865090, -0.059511, -0.369149>
    }
    triangle {
      < -6.868268, -0.015195, -0.361188>,
      < -6.865090, -0.059511, -0.369149>,
      < -6.877129, -0.065441, -0.361188>
    }
    triangle {
      < -6.858795, -0.007227, -0.350353>,
      < -6.868268, -0.015195, -0.361188>,
      < -6.877129, -0.065441, -0.361188>
    }
    triangle {
      < -6.858795, -0.007227, -0.350353>,
      < -6.877129, -0.065441, -0.361188>,
      < -6.867248, -0.055168, -0.350353>
    }
    triangle {
      < -6.871272, -0.073707, -0.405451>,
      < -6.863889, -0.084607, -0.402819>,
      < -6.868347, -0.077978, -0.369149>
    }
    triangle {
      < -6.871272, -0.073707, -0.405451>,
      < -6.868347, -0.077978, -0.369149>,
      < -6.877129, -0.065441, -0.361188>
    }
    triangle {
      < -6.860270, -0.066046, -0.404799>,
      < -6.871272, -0.073707, -0.405451>,
      < -6.877129, -0.065441, -0.361188>
    }
    triangle {
      < -6.860270, -0.066046, -0.404799>,
      < -6.877129, -0.065441, -0.361188>,
      < -6.865090, -0.059511, -0.369149>
    }
    triangle {
      < -6.877797, -0.037218, -0.322800>,
      < -6.866009, -0.031112, -0.329896>,
      < -6.867248, -0.055168, -0.350353>
    }
    triangle {
      < -6.877797, -0.037218, -0.322800>,
      < -6.867248, -0.055168, -0.350353>,
      < -6.880188, -0.082799, -0.361188>
    }
    triangle {
      < -6.860757, -0.022090, -0.413439>,
      < -6.855081, -0.034015, -0.402180>,
      < -6.851636, -0.015120, -0.402819>
    }
    triangle {
      < -6.866084, -0.028590, -0.326228>,
      < -6.866009, -0.031112, -0.329896>,
      < -6.877797, -0.037218, -0.322800>
    }
    triangle {
      < -6.880188, -0.082799, -0.361188>,
      < -6.872363, -0.084179, -0.350353>,
      < -6.871017, -0.059139, -0.329426>
    }
    triangle {
      < -6.880188, -0.082799, -0.361188>,
      < -6.871017, -0.059139, -0.329426>,
      < -6.877797, -0.037218, -0.322800>
    }
    triangle {
      < -6.874422, -0.077866, -0.328709>,
      < -6.875236, -0.080848, -0.326668>,
      < -6.884016, -0.072485, -0.322797>
    }
    triangle {
      < -6.873692, -0.074305, -0.329426>,
      < -6.884016, -0.072485, -0.322797>,
      < -6.877797, -0.037218, -0.322800>
    }
    triangle {
      < -6.873692, -0.074305, -0.329426>,
      < -6.877797, -0.037218, -0.322800>,
      < -6.871017, -0.059139, -0.329426>
    }
    triangle {
      < -6.873692, -0.074305, -0.329426>,
      < -6.874422, -0.077866, -0.328709>,
      < -6.884016, -0.072485, -0.322797>
    }
    triangle {
      < -6.876619, -0.083428, -0.320008>,
      < -6.884016, -0.072485, -0.322797>,
      < -6.876009, -0.082802, -0.323612>
    }
    triangle {
      < -6.868163, -0.030732, -0.313899>,
      < -6.877797, -0.037218, -0.322800>,
      < -6.869125, -0.034318, -0.311446>
    }
    triangle {
      < -6.884016, -0.072485, -0.322797>,
      < -6.874565, -0.064513, -0.310585>,
      < -6.869995, -0.038594, -0.310585>
    }
    triangle {
      < -6.884016, -0.072485, -0.322797>,
      < -6.869995, -0.038594, -0.310585>,
      < -6.877797, -0.037218, -0.322800>
    }
    triangle {
      < -6.867249, -0.028384, -0.317570>,
      < -6.877797, -0.037218, -0.322800>,
      < -6.868163, -0.030732, -0.313899>
    }
    triangle {
      < -6.869995, -0.038594, -0.310585>,
      < -6.869125, -0.034318, -0.311446>,
      < -6.877797, -0.037218, -0.322800>
    }
    triangle {
      < -6.866518, -0.027632, -0.321899>,
      < -6.877797, -0.037218, -0.322800>,
      < -6.867249, -0.028384, -0.317570>
    }
    triangle {
      < -6.866518, -0.027632, -0.321899>,
      < -6.866084, -0.028590, -0.326228>,
      < -6.877797, -0.037218, -0.322800>
    }
    triangle {
      < -6.905278, -0.067508, -0.024220>,
      < -6.897589, -0.078255, -0.020083>,
      < -6.896914, -0.074172, -0.013828>
    }
    triangle {
      < -6.905278, -0.067508, -0.024220>,
      < -6.896914, -0.074172, -0.013828>,
      < -6.904949, -0.065465, -0.021079>
    }
    triangle {
      < -6.897768, -0.079699, -0.027461>,
      < -6.905432, -0.068709, -0.029346>,
      < -6.903028, -0.069132, -0.111839>
    }
    triangle {
      < -6.897768, -0.079699, -0.027461>,
      < -6.903028, -0.069132, -0.111839>,
      < -6.895363, -0.080172, -0.111395>
    }
    triangle {
      < -6.887519, -0.027949, -0.077596>,
      < -6.897787, -0.034543, -0.092114>,
      < -6.903028, -0.069132, -0.111839>
    }
    triangle {
      < -6.887519, -0.027949, -0.077596>,
      < -6.903028, -0.069132, -0.111839>,
      < -6.892725, -0.061311, -0.095836>
    }
    triangle {
      < -6.885468, -0.028311, -0.126188>,
      < -6.884398, -0.028499, -0.145172>,
      < -6.895966, -0.034864, -0.131557>
    }
    triangle {
      < -6.903028, -0.069132, -0.111839>,
      < -6.890540, -0.052813, -0.111395>,
      < -6.885468, -0.028311, -0.126188>
    }
    triangle {
      < -6.903028, -0.069132, -0.111839>,
      < -6.885468, -0.028311, -0.126188>,
      < -6.895966, -0.034864, -0.131557>
    }
    triangle {
      < -6.886835, -0.028070, -0.096598>,
      < -6.890540, -0.052813, -0.111395>,
      < -6.903028, -0.069132, -0.111839>
    }
    triangle {
      < -6.886835, -0.028070, -0.096598>,
      < -6.903028, -0.069132, -0.111839>,
      < -6.897787, -0.034543, -0.092114>
    }
    triangle {
      < -6.887519, -0.027949, -0.077596>,
      < -6.886835, -0.028070, -0.096598>,
      < -6.897787, -0.034543, -0.092114>
    }
    triangle {
      < -6.891290, -0.061564, -0.126950>,
      < -6.903028, -0.069132, -0.111839>,
      < -6.895966, -0.034864, -0.131557>
    }
    triangle {
      < -6.891290, -0.061564, -0.126950>,
      < -6.895966, -0.034864, -0.131557>,
      < -6.884398, -0.028499, -0.145172>
    }
    triangle {
      < -6.897471, -0.070112, 0.198340>,
      < -6.889819, -0.081101, 0.197552>,
      < -6.889313, -0.080680, 0.202587>
    }
    triangle {
      < -6.897471, -0.070112, 0.198340>,
      < -6.889313, -0.080680, 0.202587>,
      < -6.896891, -0.069372, 0.203584>
    }
    triangle {
      < -6.886847, -0.057670, 0.280614>,
      < -6.875986, -0.056569, 0.288589>,
      < -6.885869, -0.051445, 0.279618>
    }
    triangle {
      < -6.870253, -0.054199, 0.328557>,
      < -6.880793, -0.052341, 0.320293>,
      < -6.870903, -0.057466, 0.328034>
    }
    triangle {
      < -6.887873, -0.068598, 0.288009>,
      < -6.887568, -0.063736, 0.283506>,
      < -6.879328, -0.063673, 0.271236>
    }
    triangle {
      < -6.887735, -0.071829, 0.293681>,
      < -6.887873, -0.068598, 0.288009>,
      < -6.879328, -0.063673, 0.271236>
    }
    triangle {
      < -6.890857, -0.056963, -0.243924>,
      < -6.881148, -0.061691, -0.252060>,
      < -6.881521, -0.063286, -0.251231>
    }
    triangle {
      < -6.890857, -0.056963, -0.243924>,
      < -6.881521, -0.063286, -0.251231>,
      < -6.892202, -0.062894, -0.241027>
    }
    triangle {
      < -6.901185, -0.055142, 0.097786>,
      < -6.892726, -0.059649, 0.088249>,
      < -6.892980, -0.061266, 0.089084>
    }
    triangle {
      < -6.901185, -0.055142, 0.097786>,
      < -6.892980, -0.061266, 0.089084>,
      < -6.902119, -0.061145, 0.100695>
    }
    triangle {
      < -6.901597, -0.066131, 0.129297>,
      < -6.902451, -0.069234, 0.123590>,
      < -6.890294, -0.061740, 0.144494>
    }
    triangle {
      < -6.894595, -0.070620, -0.230827>,
      < -6.893486, -0.067561, -0.236515>,
      < -6.881521, -0.063286, -0.251231>
    }
    triangle {
      < -6.893486, -0.067561, -0.236515>,
      < -6.892202, -0.062894, -0.241027>,
      < -6.881521, -0.063286, -0.251231>
    }
    triangle {
      < -6.903065, -0.069126, 0.110935>,
      < -6.902762, -0.065926, 0.105226>,
      < -6.892980, -0.061266, 0.089084>
    }
    triangle {
      < -6.902762, -0.065926, 0.105226>,
      < -6.902119, -0.061145, 0.100695>,
      < -6.892980, -0.061266, 0.089084>
    }
    triangle {
      < -6.900514, -0.061428, 0.133826>,
      < -6.901597, -0.066131, 0.129297>,
      < -6.890294, -0.061740, 0.144494>
    }
    triangle {
      < -6.889958, -0.060137, 0.145328>,
      < -6.899295, -0.055475, 0.136732>,
      < -6.900514, -0.061428, 0.133826>
    }
    triangle {
      < -6.889958, -0.060137, 0.145328>,
      < -6.900514, -0.061428, 0.133826>,
      < -6.890294, -0.061740, 0.144494>
    }
    triangle {
      < -6.902767, -0.069183, 0.117263>,
      < -6.903065, -0.069126, 0.110935>,
      < -6.895112, -0.080276, 0.116797>
    }
    triangle {
      < -6.902767, -0.069183, 0.117263>,
      < -6.895112, -0.080276, 0.116797>,
      < -6.902451, -0.069234, 0.123590>
    }
    triangle {
      < -6.892282, -0.043919, -0.205103>,
      < -6.882706, -0.048622, -0.213409>,
      < -6.893459, -0.050107, -0.204103>
    }
    triangle {
      < -6.884952, -0.051607, -0.193701>,
      < -6.893459, -0.050107, -0.204103>,
      < -6.885488, -0.054894, -0.194228>
    }
    triangle {
      < -6.894595, -0.070620, -0.230827>,
      < -6.903028, -0.069132, -0.111839>,
      < -6.891290, -0.061564, -0.126950>
    }
    triangle {
      < -6.894595, -0.070620, -0.230827>,
      < -6.891290, -0.061564, -0.126950>,
      < -6.884225, -0.062677, -0.223630>
    }
    triangle {
      < -6.893459, -0.050107, -0.204103>,
      < -6.882706, -0.048622, -0.213409>,
      < -6.880804, -0.048957, -0.233847>
    }
    triangle {
      < -6.893459, -0.050107, -0.204103>,
      < -6.880804, -0.048957, -0.233847>,
      < -6.889661, -0.050777, -0.244923>
    }
    triangle {
      < -6.885488, -0.054894, -0.194228>,
      < -6.893459, -0.050107, -0.204103>,
      < -6.889661, -0.050777, -0.244923>
    }
    triangle {
      < -6.885488, -0.054894, -0.194228>,
      < -6.889661, -0.050777, -0.244923>,
      < -6.881959, -0.055516, -0.233847>
    }
    triangle {
      < -6.886125, -0.061494, 0.200337>,
      < -6.886526, -0.062404, 0.197512>,
      < -6.897471, -0.070112, 0.198340>
    }
    triangle {
      < -6.886125, -0.061494, 0.200337>,
      < -6.897471, -0.070112, 0.198340>,
      < -6.896891, -0.069372, 0.203584>
    }
    triangle {
      < -6.902451, -0.069234, 0.123590>,
      < -6.895112, -0.080276, 0.116797>,
      < -6.889819, -0.081101, 0.197552>
    }
    triangle {
      < -6.902451, -0.069234, 0.123590>,
      < -6.889819, -0.081101, 0.197552>,
      < -6.897471, -0.070112, 0.198340>
    }
    triangle {
      < -6.886526, -0.062404, 0.197512>,
      < -6.890294, -0.061740, 0.144494>,
      < -6.902451, -0.069234, 0.123590>
    }
    triangle {
      < -6.886526, -0.062404, 0.197512>,
      < -6.902451, -0.069234, 0.123590>,
      < -6.897471, -0.070112, 0.198340>
    }
    triangle {
      < -6.896008, -0.066532, 0.207927>,
      < -6.886125, -0.061494, 0.200337>,
      < -6.896891, -0.069372, 0.203584>
    }
    triangle {
      < -6.888083, -0.077280, 0.209708>,
      < -6.895010, -0.062317, 0.210780>,
      < -6.896008, -0.066532, 0.207927>
    }
    triangle {
      < -6.888083, -0.077280, 0.209708>,
      < -6.896008, -0.066532, 0.207927>,
      < -6.888700, -0.079339, 0.206856>
    }
    triangle {
      < -6.896891, -0.069372, 0.203584>,
      < -6.889313, -0.080680, 0.202587>,
      < -6.888700, -0.079339, 0.206856>
    }
    triangle {
      < -6.896891, -0.069372, 0.203584>,
      < -6.888700, -0.079339, 0.206856>,
      < -6.896008, -0.066532, 0.207927>
    }
    triangle {
      < -6.887867, -0.077318, 0.212173>,
      < -6.894834, -0.062348, 0.212782>,
      < -6.894041, -0.057330, 0.211781>
    }
    triangle {
      < -6.887867, -0.077318, 0.212173>,
      < -6.894041, -0.057330, 0.211781>,
      < -6.887518, -0.074822, 0.211171>
    }
    triangle {
      < -6.895010, -0.062317, 0.210780>,
      < -6.888083, -0.077280, 0.209708>,
      < -6.887518, -0.074822, 0.211171>
    }
    triangle {
      < -6.895010, -0.062317, 0.210780>,
      < -6.887518, -0.074822, 0.211171>,
      < -6.894041, -0.057330, 0.211781>
    }
    triangle {
      < -6.887846, -0.080939, 0.219290>,
      < -6.895452, -0.069625, 0.219976>,
      < -6.895331, -0.066651, 0.215634>
    }
    triangle {
      < -6.887846, -0.080939, 0.219290>,
      < -6.895331, -0.066651, 0.215634>,
      < -6.887985, -0.079466, 0.215024>
    }
    triangle {
      < -6.894834, -0.062348, 0.212782>,
      < -6.887867, -0.077318, 0.212173>,
      < -6.887985, -0.079466, 0.215024>
    }
    triangle {
      < -6.894834, -0.062348, 0.212782>,
      < -6.887985, -0.079466, 0.215024>,
      < -6.895331, -0.066651, 0.215634>
    }
    triangle {
      < -6.880139, -0.082915, 0.292518>,
      < -6.887735, -0.071829, 0.293681>,
      < -6.895113, -0.070528, 0.225216>
    }
    triangle {
      < -6.880139, -0.082915, 0.292518>,
      < -6.895113, -0.070528, 0.225216>,
      < -6.887468, -0.081515, 0.224321>
    }
    triangle {
      < -6.895452, -0.069625, 0.219976>,
      < -6.887846, -0.080939, 0.219290>,
      < -6.887468, -0.081515, 0.224321>
    }
    triangle {
      < -6.895452, -0.069625, 0.219976>,
      < -6.887468, -0.081515, 0.224321>,
      < -6.895113, -0.070528, 0.225216>
    }
    triangle {
      < -6.884263, -0.061822, 0.221539>,
      < -6.895331, -0.066651, 0.215634>,
      < -6.895452, -0.069625, 0.219976>
    }
    triangle {
      < -6.894041, -0.057330, 0.211781>,
      < -6.885551, -0.058721, 0.201302>,
      < -6.886125, -0.061494, 0.200337>
    }
    triangle {
      < -6.894041, -0.057330, 0.211781>,
      < -6.886125, -0.061494, 0.200337>,
      < -6.895010, -0.062317, 0.210780>
    }
    triangle {
      < -6.884263, -0.061822, 0.221539>,
      < -6.894834, -0.062348, 0.212782>,
      < -6.895331, -0.066651, 0.215634>
    }
    triangle {
      < -6.895010, -0.062317, 0.210780>,
      < -6.886125, -0.061494, 0.200337>,
      < -6.896008, -0.066532, 0.207927>
    }
    triangle {
      < -6.884263, -0.061822, 0.221539>,
      < -6.883860, -0.059019, 0.220574>,
      < -6.894041, -0.057330, 0.211781>
    }
    triangle {
      < -6.884263, -0.061822, 0.221539>,
      < -6.894041, -0.057330, 0.211781>,
      < -6.894834, -0.062348, 0.212782>
    }
    triangle {
      < -6.895113, -0.070528, 0.225216>,
      < -6.884169, -0.062819, 0.224361>,
      < -6.884263, -0.061822, 0.221539>
    }
    triangle {
      < -6.895113, -0.070528, 0.225216>,
      < -6.884263, -0.061822, 0.221539>,
      < -6.895452, -0.069625, 0.219976>
    }
    triangle {
      < -6.844868, -0.079388, 0.538953>,
      < -6.831995, -0.072019, 0.546070>,
      < -6.856297, -0.067734, 0.428301>
    }
    triangle {
      < -6.844868, -0.079388, 0.538953>,
      < -6.856297, -0.067734, 0.428301>,
      < -6.867107, -0.075466, 0.430103>
    }
    triangle {
      < -6.864360, -0.085590, 0.400985>,
      < -6.863428, -0.085241, 0.405965>,
      < -6.870880, -0.074315, 0.408163>
    }
    triangle {
      < -6.864360, -0.085590, 0.400985>,
      < -6.870880, -0.074315, 0.408163>,
      < -6.871912, -0.074619, 0.402584>
    }
    triangle {
      < -6.870880, -0.074315, 0.408163>,
      < -6.860407, -0.066028, 0.403873>,
      < -6.861048, -0.066892, 0.401078>
    }
    triangle {
      < -6.870880, -0.074315, 0.408163>,
      < -6.861048, -0.066892, 0.401078>,
      < -6.871912, -0.074619, 0.402584>
    }
    triangle {
      < -6.856629, -0.066694, 0.425512>,
      < -6.868258, -0.071588, 0.420127>,
      < -6.868022, -0.074818, 0.424533>
    }
    triangle {
      < -6.869576, -0.071356, 0.412572>,
      < -6.860407, -0.066028, 0.403873>,
      < -6.870880, -0.074315, 0.408163>
    }
    triangle {
      < -6.861590, -0.081917, 0.413005>,
      < -6.868323, -0.067093, 0.415371>,
      < -6.869576, -0.071356, 0.412572>
    }
    triangle {
      < -6.861590, -0.081917, 0.413005>,
      < -6.869576, -0.071356, 0.412572>,
      < -6.862453, -0.083951, 0.410185>
    }
    triangle {
      < -6.870880, -0.074315, 0.408163>,
      < -6.863428, -0.085241, 0.405965>,
      < -6.862453, -0.083951, 0.410185>
    }
    triangle {
      < -6.870880, -0.074315, 0.408163>,
      < -6.862453, -0.083951, 0.410185>,
      < -6.869576, -0.071356, 0.412572>
    }
    triangle {
      < -6.861166, -0.081992, 0.415442>,
      < -6.867982, -0.067153, 0.417330>,
      < -6.867259, -0.062052, 0.416350>
    }
    triangle {
      < -6.861166, -0.081992, 0.415442>,
      < -6.867259, -0.062052, 0.416350>,
      < -6.860977, -0.079446, 0.413995>
    }
    triangle {
      < -6.868323, -0.067093, 0.415371>,
      < -6.861590, -0.081917, 0.413005>,
      < -6.860977, -0.079446, 0.413995>
    }
    triangle {
      < -6.868323, -0.067093, 0.415371>,
      < -6.860977, -0.079446, 0.413995>,
      < -6.867259, -0.062052, 0.416350>
    }
    triangle {
      < -6.860548, -0.085748, 0.422477>,
      < -6.868022, -0.074818, 0.424533>,
      < -6.868258, -0.071588, 0.420127>
    }
    triangle {
      < -6.860548, -0.085748, 0.422477>,
      < -6.868258, -0.071588, 0.420127>,
      < -6.861044, -0.084200, 0.418261>
    }
    triangle {
      < -6.867982, -0.067153, 0.417330>,
      < -6.861166, -0.081992, 0.415442>,
      < -6.861044, -0.084200, 0.418261>
    }
    triangle {
      < -6.867982, -0.067153, 0.417330>,
      < -6.861044, -0.084200, 0.418261>,
      < -6.868258, -0.071588, 0.420127>
    }
    triangle {
      < -6.859577, -0.086434, 0.428393>,
      < -6.867107, -0.075466, 0.430103>,
      < -6.868022, -0.074818, 0.424533>
    }
    triangle {
      < -6.859577, -0.086434, 0.428393>,
      < -6.868022, -0.074818, 0.424533>,
      < -6.860548, -0.085748, 0.422477>
    }
    triangle {
      < -6.867259, -0.062052, 0.416350>,
      < -6.859754, -0.063270, 0.404826>,
      < -6.860407, -0.066028, 0.403873>
    }
    triangle {
      < -6.867259, -0.062052, 0.416350>,
      < -6.860407, -0.066028, 0.403873>,
      < -6.868323, -0.067093, 0.415371>
    }
    triangle {
      < -6.856629, -0.066694, 0.425512>,
      < -6.856309, -0.063877, 0.424559>,
      < -6.867259, -0.062052, 0.416350>
    }
    triangle {
      < -6.856629, -0.066694, 0.425512>,
      < -6.867259, -0.062052, 0.416350>,
      < -6.867982, -0.067153, 0.417330>
    }
    triangle {
      < -6.867107, -0.075466, 0.430103>,
      < -6.856297, -0.067734, 0.428301>,
      < -6.856629, -0.066694, 0.425512>
    }
    triangle {
      < -6.867107, -0.075466, 0.430103>,
      < -6.856629, -0.066694, 0.425512>,
      < -6.868022, -0.074818, 0.424533>
    }
    triangle {
      < -6.868323, -0.067093, 0.415371>,
      < -6.860407, -0.066028, 0.403873>,
      < -6.869576, -0.071356, 0.412572>
    }
    triangle {
      < -6.856629, -0.066694, 0.425512>,
      < -6.867982, -0.067153, 0.417330>,
      < -6.868258, -0.071588, 0.420127>
    }
    triangle {
      < -6.865966, -0.033561, 0.395059>,
      < -6.857081, -0.028034, 0.384110>,
      < -6.859508, -0.041794, 0.384110>
    }
    triangle {
      < -6.848844, -0.043675, 0.445212>,
      < -6.858541, -0.034870, 0.437608>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.848844, -0.043675, 0.445212>,
      < -6.862348, -0.034199, 0.416350>,
      < -6.852630, -0.043007, 0.424559>
    }
    triangle {
      < -6.856073, -0.042400, 0.404826>,
      < -6.859754, -0.063270, 0.404826>,
      < -6.867259, -0.062052, 0.416350>
    }
    triangle {
      < -6.856073, -0.042400, 0.404826>,
      < -6.867259, -0.062052, 0.416350>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.850142, -0.008753, 0.404826>,
      < -6.853648, -0.028639, 0.404826>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.850142, -0.008753, 0.404826>,
      < -6.862348, -0.034199, 0.416350>,
      < -6.859277, -0.016780, 0.416350>
    }
    triangle {
      < -6.858541, -0.034870, 0.437608>,
      < -6.848844, -0.043675, 0.445212>,
      < -6.846417, -0.029914, 0.445212>
    }
    triangle {
      < -6.844868, -0.079388, 0.538953>,
      < -6.835291, -0.090716, 0.546070>,
      < -6.831995, -0.072019, 0.546070>
    }
    triangle {
      < -6.883860, -0.059019, 0.220574>,
      < -6.874248, -0.004502, 0.220574>,
      < -6.886057, -0.012058, 0.211781>
    }
    triangle {
      < -6.883860, -0.059019, 0.220574>,
      < -6.886057, -0.012058, 0.211781>,
      < -6.894041, -0.057330, 0.211781>
    }
    triangle {
      < -6.905272, -0.067509, 0.024781>,
      < -6.894289, -0.060054, 0.028746>,
      < -6.904942, -0.065466, 0.021653>
    }
    triangle {
      < -6.891283, -0.042942, 0.027779>,
      < -6.901000, -0.042953, 0.018345>,
      < -6.903552, -0.057421, 0.018345>
    }
    triangle {
      < -6.891283, -0.042942, 0.027779>,
      < -6.903552, -0.057421, 0.018345>,
      < -6.893808, -0.057265, 0.027779>
    }
    triangle {
      < -6.899302, -0.033292, -0.017758>,
      < -6.903556, -0.057420, -0.017759>,
      < -6.894597, -0.060874, -0.008181>
    }
    triangle {
      < -6.899302, -0.033292, -0.017758>,
      < -6.894597, -0.060874, -0.008181>,
      < -6.891361, -0.042521, -0.008181>
    }
    triangle {
      < -6.890244, -0.036974, 0.026577>,
      < -6.900237, -0.038575, 0.017256>,
      < -6.901000, -0.042953, 0.018345>
    }
    triangle {
      < -6.890244, -0.036974, 0.026577>,
      < -6.901000, -0.042953, 0.018345>,
      < -6.891283, -0.042942, 0.027779>
    }
    triangle {
      < -6.888664, -0.027329, 0.011988>,
      < -6.888680, -0.027326, -0.008181>,
      < -6.899302, -0.033292, -0.017758>
    }
    triangle {
      < -6.888664, -0.027329, 0.011988>,
      < -6.899302, -0.033292, -0.017758>,
      < -6.899351, -0.033278, 0.008509>
    }
    triangle {
      < -6.899264, -0.033299, -0.022317>,
      < -6.891170, -0.042555, -0.031378>,
      < -6.891221, -0.042546, -0.027195>
    }
    triangle {
      < -6.899264, -0.033299, -0.022317>,
      < -6.891221, -0.042546, -0.027195>,
      < -6.899302, -0.033292, -0.017758>
    }
    triangle {
      < -6.895859, -0.068069, -0.009648>,
      < -6.904428, -0.062412, -0.018982>,
      < -6.904949, -0.065465, -0.021079>
    }
    triangle {
      < -6.895859, -0.068069, -0.009648>,
      < -6.904949, -0.065465, -0.021079>,
      < -6.896914, -0.074172, -0.013828>
    }
    triangle {
      < -6.904423, -0.062413, 0.019565>,
      < -6.904942, -0.065466, 0.021653>,
      < -6.894289, -0.060054, 0.028746>
    }
    triangle {
      < -6.888835, -0.028522, 0.018031>,
      < -6.888664, -0.027329, 0.011988>,
      < -6.899351, -0.033278, 0.008509>
    }
    triangle {
      < -6.888835, -0.028522, 0.018031>,
      < -6.899351, -0.033278, 0.008509>,
      < -6.899519, -0.034351, 0.012965>
    }
    triangle {
      < -6.897768, -0.079699, -0.027461>,
      < -6.897589, -0.078255, -0.020083>,
      < -6.905278, -0.067508, -0.024220>
    }
    triangle {
      < -6.897768, -0.079699, -0.027461>,
      < -6.905278, -0.067508, -0.024220>,
      < -6.905432, -0.068709, -0.029346>
    }
    triangle {
      < -6.894597, -0.060874, -0.008181>,
      < -6.903556, -0.057420, -0.017759>,
      < -6.904428, -0.062412, -0.018982>
    }
    triangle {
      < -6.894597, -0.060874, -0.008181>,
      < -6.904428, -0.062412, -0.018982>,
      < -6.895859, -0.068069, -0.009648>
    }
    triangle {
      < -6.893808, -0.057265, 0.027779>,
      < -6.903552, -0.057421, 0.018345>,
      < -6.904423, -0.062413, 0.019565>
    }
    triangle {
      < -6.893808, -0.057265, 0.027779>,
      < -6.904423, -0.062413, 0.019565>,
      < -6.894289, -0.060054, 0.028746>
    }
    triangle {
      < -6.894421, -0.061012, 0.031582>,
      < -6.894289, -0.060054, 0.028746>,
      < -6.905272, -0.067509, 0.024781>
    }
    triangle {
      < -6.894421, -0.061012, 0.031582>,
      < -6.905272, -0.067509, 0.024781>,
      < -6.905423, -0.068710, 0.029892>
    }
    triangle {
      < -6.889388, -0.031910, 0.023154>,
      < -6.888835, -0.028522, 0.018031>,
      < -6.899519, -0.034351, 0.012965>
    }
    triangle {
      < -6.889388, -0.031910, 0.023154>,
      < -6.899519, -0.034351, 0.012965>,
      < -6.899803, -0.036044, 0.015537>
    }
    triangle {
      < -6.889388, -0.031910, 0.023154>,
      < -6.899803, -0.036044, 0.015537>,
      < -6.900237, -0.038575, 0.017256>
    }
    triangle {
      < -6.889388, -0.031910, 0.023154>,
      < -6.900237, -0.038575, 0.017256>,
      < -6.890244, -0.036974, 0.026577>
    }
    triangle {
      < -6.894429, -0.061010, -0.030998>,
      < -6.892725, -0.061311, -0.095836>,
      < -6.903028, -0.069132, -0.111839>
    }
    triangle {
      < -6.894429, -0.061010, -0.030998>,
      < -6.903028, -0.069132, -0.111839>,
      < -6.905432, -0.068709, -0.029346>
    }
    triangle {
      < -6.894296, -0.060053, -0.028164>,
      < -6.894429, -0.061010, -0.030998>,
      < -6.905432, -0.068709, -0.029346>
    }
    triangle {
      < -6.894296, -0.060053, -0.028164>,
      < -6.905432, -0.068709, -0.029346>,
      < -6.905278, -0.067508, -0.024220>
    }
    triangle {
      < -6.894296, -0.060053, -0.028164>,
      < -6.905278, -0.067508, -0.024220>,
      < -6.904949, -0.065465, -0.021079>
    }
    triangle {
      < -6.894296, -0.060053, -0.028164>,
      < -6.904949, -0.065465, -0.021079>,
      < -6.904428, -0.062412, -0.018982>
    }
    triangle {
      < -6.893816, -0.057264, -0.027195>,
      < -6.894296, -0.060053, -0.028164>,
      < -6.904428, -0.062412, -0.018982>
    }
    triangle {
      < -6.893816, -0.057264, -0.027195>,
      < -6.904428, -0.062412, -0.018982>,
      < -6.903556, -0.057420, -0.017759>
    }
    triangle {
      < -6.891221, -0.042546, -0.027195>,
      < -6.893816, -0.057264, -0.027195>,
      < -6.903556, -0.057420, -0.017759>
    }
    triangle {
      < -6.891221, -0.042546, -0.027195>,
      < -6.903556, -0.057420, -0.017759>,
      < -6.899302, -0.033292, -0.017758>
    }
    triangle {
      < -6.897761, -0.079700, 0.027964>,
      < -6.895112, -0.080276, 0.116797>,
      < -6.903065, -0.069126, 0.110935>
    }
    triangle {
      < -6.897761, -0.079700, 0.027964>,
      < -6.903065, -0.069126, 0.110935>,
      < -6.905423, -0.068710, 0.029892>
    }
    triangle {
      < -6.897583, -0.078256, 0.020617>,
      < -6.897761, -0.079700, 0.027964>,
      < -6.905423, -0.068710, 0.029892>
    }
    triangle {
      < -6.897583, -0.078256, 0.020617>,
      < -6.905423, -0.068710, 0.029892>,
      < -6.905272, -0.067509, 0.024781>
    }
    triangle {
      < -6.896910, -0.074172, 0.014388>,
      < -6.897583, -0.078256, 0.020617>,
      < -6.905272, -0.067509, 0.024781>
    }
    triangle {
      < -6.896910, -0.074172, 0.014388>,
      < -6.905272, -0.067509, 0.024781>,
      < -6.904942, -0.065466, 0.021653>
    }
    triangle {
      < -6.895855, -0.068070, 0.010226>,
      < -6.896910, -0.074172, 0.014388>,
      < -6.904942, -0.065466, 0.021653>
    }
    triangle {
      < -6.895855, -0.068070, 0.010226>,
      < -6.904942, -0.065466, 0.021653>,
      < -6.904423, -0.062413, 0.019565>
    }
    triangle {
      < -6.894593, -0.060875, 0.008765>,
      < -6.895855, -0.068070, 0.010226>,
      < -6.904423, -0.062413, 0.019565>
    }
    triangle {
      < -6.894593, -0.060875, 0.008765>,
      < -6.904423, -0.062413, 0.019565>,
      < -6.903552, -0.057421, 0.018345>
    }
    triangle {
      < -6.892015, -0.046261, 0.008765>,
      < -6.894593, -0.060875, 0.008765>,
      < -6.903552, -0.057421, 0.018345>
    }
    triangle {
      < -6.892015, -0.046261, 0.008765>,
      < -6.903552, -0.057421, 0.018345>,
      < -6.901000, -0.042953, 0.018345>
    }
    triangle {
      < -6.891529, -0.043474, 0.007797>,
      < -6.892015, -0.046261, 0.008765>,
      < -6.901000, -0.042953, 0.018345>
    }
    triangle {
      < -6.891529, -0.043474, 0.007797>,
      < -6.901000, -0.042953, 0.018345>,
      < -6.900237, -0.038575, 0.017256>
    }
    triangle {
      < -6.891529, -0.043474, 0.007797>,
      < -6.900237, -0.038575, 0.017256>,
      < -6.899803, -0.036044, 0.015537>
    }
    triangle {
      < -6.891529, -0.043474, 0.007797>,
      < -6.899803, -0.036044, 0.015537>,
      < -6.899519, -0.034351, 0.012965>
    }
    triangle {
      < -6.891367, -0.042520, 0.004962>,
      < -6.891529, -0.043474, 0.007797>,
      < -6.899519, -0.034351, 0.012965>
    }
    triangle {
      < -6.891367, -0.042520, 0.004962>,
      < -6.899519, -0.034351, 0.012965>,
      < -6.899351, -0.033278, 0.008509>
    }
    triangle {
      < -6.899302, -0.033292, -0.017758>,
      < -6.891361, -0.042521, -0.008181>,
      < -6.891367, -0.042520, 0.004962>
    }
    triangle {
      < -6.899302, -0.033292, -0.017758>,
      < -6.891367, -0.042520, 0.004962>,
      < -6.899351, -0.033278, 0.008509>
    }
    triangle {
      < -6.887967, -0.023272, -0.008181>,
      < -6.887775, -0.023306, -0.031378>,
      < -6.898579, -0.029415, -0.022466>
    }
    triangle {
      < -6.887967, -0.023272, -0.008181>,
      < -6.898579, -0.029415, -0.022466>,
      < -6.898638, -0.029524, -0.017758>
    }
    triangle {
      < -6.891170, -0.042555, -0.031378>,
      < -6.899264, -0.033299, -0.022317>,
      < -6.898579, -0.029415, -0.022466>
    }
    triangle {
      < -6.891170, -0.042555, -0.031378>,
      < -6.898579, -0.029415, -0.022466>,
      < -6.887775, -0.023306, -0.031378>
    }
    triangle {
      < -6.888680, -0.027326, -0.008181>,
      < -6.887967, -0.023272, -0.008181>,
      < -6.898638, -0.029524, -0.017758>
    }
    triangle {
      < -6.888680, -0.027326, -0.008181>,
      < -6.898638, -0.029524, -0.017758>,
      < -6.899302, -0.033292, -0.017758>
    }
    triangle {
      < -6.898638, -0.029524, -0.017758>,
      < -6.898579, -0.029415, -0.022466>,
      < -6.899264, -0.033299, -0.022317>
    }
    triangle {
      < -6.898638, -0.029524, -0.017758>,
      < -6.899264, -0.033299, -0.022317>,
      < -6.899302, -0.033292, -0.017758>
    }
    triangle {
      < -6.865966, -0.033561, 0.395059>,
      < -6.859508, -0.041794, 0.384110>,
      < -6.856073, -0.042400, 0.404826>
    }
    triangle {
      < -6.865966, -0.033561, 0.395059>,
      < -6.856073, -0.042400, 0.404826>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.846696, -0.009360, 0.424559>,
      < -6.859277, -0.016780, 0.416350>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.846696, -0.009360, 0.424559>,
      < -6.862348, -0.034199, 0.416350>,
      < -6.850203, -0.029246, 0.424559>
    }
    triangle {
      < -6.867259, -0.062052, 0.416350>,
      < -6.856309, -0.063877, 0.424559>,
      < -6.852630, -0.043007, 0.424559>
    }
    triangle {
      < -6.867259, -0.062052, 0.416350>,
      < -6.852630, -0.043007, 0.424559>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.857081, -0.028034, 0.384110>,
      < -6.865966, -0.033561, 0.395059>,
      < -6.862348, -0.034199, 0.416350>
    }
    triangle {
      < -6.857081, -0.028034, 0.384110>,
      < -6.862348, -0.034199, 0.416350>,
      < -6.853648, -0.028639, 0.404826>
    }
    texture {logo}
  }
  // steer1
  union {
    triangle {
      < -0.347751, -0.172583, 1.201452>,
      < -0.332003, -0.167082, 1.201452>,
      < -0.329347, -0.174696, 1.303913>
    }
    triangle {
      < -0.347751, -0.172583, 1.201452>,
      < -0.329347, -0.174696, 1.303913>,
      < -0.345094, -0.180197, 1.303912>
    }
    triangle {
      < -0.355660, -0.149931, 1.101514>,
      < -0.339913, -0.144430, 1.101514>,
      < -0.332003, -0.167082, 1.201452>
    }
    triangle {
      < -0.355660, -0.149931, 1.101514>,
      < -0.332003, -0.167082, 1.201452>,
      < -0.347751, -0.172583, 1.201452>
    }
    triangle {
      < -0.368629, -0.112800, 1.006559>,
      < -0.352881, -0.107298, 1.006560>,
      < -0.339913, -0.144430, 1.101514>
    }
    triangle {
      < -0.368629, -0.112800, 1.006559>,
      < -0.339913, -0.144430, 1.101514>,
      < -0.355660, -0.149931, 1.101514>
    }
    triangle {
      < -0.386336, -0.062102, 0.918927>,
      < -0.370589, -0.056601, 0.918927>,
      < -0.352881, -0.107298, 1.006560>
    }
    triangle {
      < -0.386336, -0.062102, 0.918927>,
      < -0.352881, -0.107298, 1.006560>,
      < -0.368629, -0.112800, 1.006559>
    }
    triangle {
      < -0.408347, 0.000913, 0.840774>,
      < -0.392600, 0.006414, 0.840774>,
      < -0.370589, -0.056601, 0.918927>
    }
    triangle {
      < -0.408347, 0.000913, 0.840774>,
      < -0.370589, -0.056601, 0.918927>,
      < -0.386336, -0.062102, 0.918927>
    }
    triangle {
      < -0.434120, 0.074694, 0.774025>,
      < -0.418372, 0.080196, 0.774026>,
      < -0.392600, 0.006414, 0.840774>
    }
    triangle {
      < -0.434120, 0.074694, 0.774025>,
      < -0.392600, 0.006414, 0.840774>,
      < -0.408347, 0.000913, 0.840774>
    }
    triangle {
      < -0.463019, 0.157425, 0.720324>,
      < -0.447271, 0.162926, 0.720325>,
      < -0.418372, 0.080196, 0.774026>
    }
    triangle {
      < -0.463019, 0.157425, 0.720324>,
      < -0.418372, 0.080196, 0.774026>,
      < -0.434120, 0.074694, 0.774025>
    }
    triangle {
      < -0.494333, 0.247067, 0.680993>,
      < -0.478585, 0.252568, 0.680993>,
      < -0.447271, 0.162926, 0.720325>
    }
    triangle {
      < -0.494333, 0.247067, 0.680993>,
      < -0.447271, 0.162926, 0.720325>,
      < -0.463019, 0.157425, 0.720324>
    }
    triangle {
      < -0.527291, 0.341414, 0.657000>,
      < -0.511543, 0.346915, 0.657000>,
      < -0.478585, 0.252568, 0.680993>
    }
    triangle {
      < -0.527291, 0.341414, 0.657000>,
      < -0.478585, 0.252568, 0.680993>,
      < -0.494333, 0.247067, 0.680993>
    }
    triangle {
      < -0.561082, 0.438142, 0.648936>,
      < -0.545334, 0.443644, 0.648936>,
      < -0.511543, 0.346915, 0.657000>
    }
    triangle {
      < -0.561082, 0.438142, 0.648936>,
      < -0.511543, 0.346915, 0.657000>,
      < -0.527291, 0.341414, 0.657000>
    }
    triangle {
      < -0.594873, 0.534871, 0.657000>,
      < -0.579125, 0.540372, 0.657000>,
      < -0.545334, 0.443644, 0.648936>
    }
    triangle {
      < -0.594873, 0.534871, 0.657000>,
      < -0.545334, 0.443644, 0.648936>,
      < -0.561082, 0.438142, 0.648936>
    }
    triangle {
      < -0.627833, 0.629217, 0.680993>,
      < -0.612085, 0.634719, 0.680993>,
      < -0.579125, 0.540372, 0.657000>
    }
    triangle {
      < -0.627833, 0.629217, 0.680993>,
      < -0.579125, 0.540372, 0.657000>,
      < -0.594873, 0.534871, 0.657000>
    }
    triangle {
      < -0.659149, 0.718859, 0.720324>,
      < -0.643402, 0.724360, 0.720325>,
      < -0.612085, 0.634719, 0.680993>
    }
    triangle {
      < -0.659149, 0.718859, 0.720324>,
      < -0.612085, 0.634719, 0.680993>,
      < -0.627833, 0.629217, 0.680993>
    }
    triangle {
      < -0.688051, 0.801588, 0.774025>,
      < -0.672304, 0.807089, 0.774026>,
      < -0.643402, 0.724360, 0.720325>
    }
    triangle {
      < -0.688051, 0.801588, 0.774025>,
      < -0.643402, 0.724360, 0.720325>,
      < -0.659149, 0.718859, 0.720324>
    }
    triangle {
      < -0.713828, 0.875368, 0.840774>,
      < -0.698080, 0.880869, 0.840774>,
      < -0.672304, 0.807089, 0.774026>
    }
    triangle {
      < -0.713828, 0.875368, 0.840774>,
      < -0.672304, 0.807089, 0.774026>,
      < -0.688051, 0.801588, 0.774025>
    }
    triangle {
      < -0.735843, 0.938381, 0.918927>,
      < -0.720096, 0.943882, 0.918927>,
      < -0.698080, 0.880869, 0.840774>
    }
    triangle {
      < -0.735843, 0.938381, 0.918927>,
      < -0.698080, 0.880869, 0.840774>,
      < -0.713828, 0.875368, 0.840774>
    }
    triangle {
      < -0.753556, 0.989077, 1.006559>,
      < -0.737809, 0.994578, 1.006560>,
      < -0.720096, 0.943882, 0.918927>
    }
    triangle {
      < -0.753556, 0.989077, 1.006559>,
      < -0.720096, 0.943882, 0.918927>,
      < -0.735843, 0.938381, 0.918927>
    }
    triangle {
      < -0.766531, 1.026207, 1.101514>,
      < -0.750783, 1.031708, 1.101514>,
      < -0.737809, 0.994578, 1.006560>
    }
    triangle {
      < -0.766531, 1.026207, 1.101514>,
      < -0.737809, 0.994578, 1.006560>,
      < -0.753556, 0.989077, 1.006559>
    }
    triangle {
      < -0.774446, 1.048856, 1.201452>,
      < -0.758699, 1.054358, 1.201452>,
      < -0.750783, 1.031708, 1.101514>
    }
    triangle {
      < -0.774446, 1.048856, 1.201452>,
      < -0.750783, 1.031708, 1.101514>,
      < -0.766531, 1.026207, 1.101514>
    }
    triangle {
      < -0.777109, 1.056468, 1.303912>,
      < -0.761361, 1.061969, 1.303913>,
      < -0.758699, 1.054358, 1.201452>
    }
    triangle {
      < -0.777109, 1.056468, 1.303912>,
      < -0.758699, 1.054358, 1.201452>,
      < -0.774446, 1.048856, 1.201452>
    }
    triangle {
      < -0.774453, 1.048854, 1.406373>,
      < -0.758705, 1.054355, 1.406374>,
      < -0.761361, 1.061969, 1.303913>
    }
    triangle {
      < -0.774453, 1.048854, 1.406373>,
      < -0.761361, 1.061969, 1.303913>,
      < -0.777109, 1.056468, 1.303912>
    }
    triangle {
      < -0.766543, 1.026202, 1.506311>,
      < -0.750795, 1.031704, 1.506312>,
      < -0.758705, 1.054355, 1.406374>
    }
    triangle {
      < -0.766543, 1.026202, 1.506311>,
      < -0.758705, 1.054355, 1.406374>,
      < -0.774453, 1.048854, 1.406373>
    }
    triangle {
      < -0.753574, 0.989071, 1.601266>,
      < -0.737827, 0.994572, 1.601266>,
      < -0.750795, 1.031704, 1.506312>
    }
    triangle {
      < -0.753574, 0.989071, 1.601266>,
      < -0.750795, 1.031704, 1.506312>,
      < -0.766543, 1.026202, 1.506311>
    }
    triangle {
      < -0.735867, 0.938373, 1.688898>,
      < -0.720119, 0.943874, 1.688898>,
      < -0.737827, 0.994572, 1.601266>
    }
    triangle {
      < -0.735867, 0.938373, 1.688898>,
      < -0.737827, 0.994572, 1.601266>,
      < -0.753574, 0.989071, 1.601266>
    }
    triangle {
      < -0.713856, 0.875358, 1.767051>,
      < -0.698108, 0.880859, 1.767051>,
      < -0.720119, 0.943874, 1.688898>
    }
    triangle {
      < -0.713856, 0.875358, 1.767051>,
      < -0.720119, 0.943874, 1.688898>,
      < -0.735867, 0.938373, 1.688898>
    }
    triangle {
      < -0.688084, 0.801576, 1.833800>,
      < -0.672336, 0.807078, 1.833800>,
      < -0.698108, 0.880859, 1.767051>
    }
    triangle {
      < -0.688084, 0.801576, 1.833800>,
      < -0.698108, 0.880859, 1.767051>,
      < -0.713856, 0.875358, 1.767051>
    }
    triangle {
      < -0.659185, 0.718846, 1.887501>,
      < -0.643437, 0.724348, 1.887501>,
      < -0.672336, 0.807078, 1.833800>
    }
    triangle {
      < -0.659185, 0.718846, 1.887501>,
      < -0.672336, 0.807078, 1.833800>,
      < -0.688084, 0.801576, 1.833800>
    }
    triangle {
      < -0.627870, 0.629204, 1.926832>,
      < -0.612123, 0.634705, 1.926832>,
      < -0.643437, 0.724348, 1.887501>
    }
    triangle {
      < -0.627870, 0.629204, 1.926832>,
      < -0.643437, 0.724348, 1.887501>,
      < -0.659185, 0.718846, 1.887501>
    }
    triangle {
      < -0.594912, 0.534857, 1.950825>,
      < -0.579165, 0.540358, 1.950825>,
      < -0.612123, 0.634705, 1.926832>
    }
    triangle {
      < -0.594912, 0.534857, 1.950825>,
      < -0.612123, 0.634705, 1.926832>,
      < -0.627870, 0.629204, 1.926832>
    }
    triangle {
      < -0.561122, 0.438129, 1.958889>,
      < -0.545374, 0.443630, 1.958889>,
      < -0.579165, 0.540358, 1.950825>
    }
    triangle {
      < -0.561122, 0.438129, 1.958889>,
      < -0.579165, 0.540358, 1.950825>,
      < -0.594912, 0.534857, 1.950825>
    }
    triangle {
      < -0.527330, 0.341400, 1.950825>,
      < -0.511583, 0.346901, 1.950825>,
      < -0.545374, 0.443630, 1.958889>
    }
    triangle {
      < -0.527330, 0.341400, 1.950825>,
      < -0.545374, 0.443630, 1.958889>,
      < -0.561122, 0.438129, 1.958889>
    }
    triangle {
      < -0.494371, 0.247054, 1.926832>,
      < -0.478623, 0.252555, 1.926832>,
      < -0.511583, 0.346901, 1.950825>
    }
    triangle {
      < -0.494371, 0.247054, 1.926832>,
      < -0.511583, 0.346901, 1.950825>,
      < -0.527330, 0.341400, 1.950825>
    }
    triangle {
      < -0.463054, 0.157412, 1.887501>,
      < -0.447307, 0.162913, 1.887501>,
      < -0.478623, 0.252555, 1.926832>
    }
    triangle {
      < -0.463054, 0.157412, 1.887501>,
      < -0.478623, 0.252555, 1.926832>,
      < -0.494371, 0.247054, 1.926832>
    }
    triangle {
      < -0.434152, 0.074683, 1.833800>,
      < -0.418404, 0.080184, 1.833800>,
      < -0.447307, 0.162913, 1.887501>
    }
    triangle {
      < -0.434152, 0.074683, 1.833800>,
      < -0.447307, 0.162913, 1.887501>,
      < -0.463054, 0.157412, 1.887501>
    }
    triangle {
      < -0.408376, 0.000903, 1.767051>,
      < -0.392628, 0.006405, 1.767051>,
      < -0.418404, 0.080184, 1.833800>
    }
    triangle {
      < -0.408376, 0.000903, 1.767051>,
      < -0.418404, 0.080184, 1.833800>,
      < -0.434152, 0.074683, 1.833800>
    }
    triangle {
      < -0.386360, -0.062110, 1.688898>,
      < -0.370612, -0.056609, 1.688898>,
      < -0.392628, 0.006405, 1.767051>
    }
    triangle {
      < -0.386360, -0.062110, 1.688898>,
      < -0.392628, 0.006405, 1.767051>,
      < -0.408376, 0.000903, 1.767051>
    }
    triangle {
      < -0.368647, -0.112806, 1.601266>,
      < -0.352899, -0.107305, 1.601266>,
      < -0.370612, -0.056609, 1.688898>
    }
    triangle {
      < -0.368647, -0.112806, 1.601266>,
      < -0.370612, -0.056609, 1.688898>,
      < -0.386360, -0.062110, 1.688898>
    }
    triangle {
      < -0.355673, -0.149936, 1.506311>,
      < -0.339925, -0.144435, 1.506312>,
      < -0.352899, -0.107305, 1.601266>
    }
    triangle {
      < -0.355673, -0.149936, 1.506311>,
      < -0.352899, -0.107305, 1.601266>,
      < -0.368647, -0.112806, 1.601266>
    }
    triangle {
      < -0.347757, -0.172585, 1.406373>,
      < -0.332009, -0.167084, 1.406374>,
      < -0.339925, -0.144435, 1.506312>
    }
    triangle {
      < -0.347757, -0.172585, 1.406373>,
      < -0.339925, -0.144435, 1.506312>,
      < -0.355673, -0.149936, 1.506311>
    }
    triangle {
      < -0.345094, -0.180197, 1.303912>,
      < -0.329347, -0.174696, 1.303913>,
      < -0.332009, -0.167084, 1.406374>
    }
    triangle {
      < -0.345094, -0.180197, 1.303912>,
      < -0.332009, -0.167084, 1.406374>,
      < -0.347757, -0.172585, 1.406373>
    }
    triangle {
      < -0.325190, -0.136020, 1.205741>,
      < -0.322645, -0.143315, 1.303913>,
      < -0.318105, -0.156312, 1.303913>
    }
    triangle {
      < -0.325190, -0.136020, 1.205741>,
      < -0.318105, -0.156312, 1.303913>,
      < -0.320706, -0.148856, 1.203587>
    }
    triangle {
      < -0.322645, -0.143315, 1.303913>,
      < -0.325196, -0.136022, 1.402085>,
      < -0.320712, -0.148859, 1.404239>
    }
    triangle {
      < -0.322645, -0.143315, 1.303913>,
      < -0.320712, -0.148859, 1.404239>,
      < -0.318105, -0.156312, 1.303913>
    }
    triangle {
      < -0.325196, -0.136022, 1.402085>,
      < -0.332781, -0.114321, 1.497841>,
      < -0.328463, -0.126681, 1.502095>
    }
    triangle {
      < -0.325196, -0.136022, 1.402085>,
      < -0.328463, -0.126681, 1.502095>,
      < -0.320712, -0.148859, 1.404239>
    }
    triangle {
      < -0.332781, -0.114321, 1.497841>,
      < -0.345212, -0.078745, 1.588820>,
      < -0.341167, -0.090325, 1.595070>
    }
    triangle {
      < -0.332781, -0.114321, 1.497841>,
      < -0.341167, -0.090325, 1.595070>,
      < -0.328463, -0.126681, 1.502095>
    }
    triangle {
      < -0.345212, -0.078745, 1.588820>,
      < -0.362183, -0.030171, 1.672785>,
      < -0.358510, -0.040685, 1.680877>
    }
    triangle {
      < -0.345212, -0.078745, 1.588820>,
      < -0.358510, -0.040685, 1.680877>,
      < -0.341167, -0.090325, 1.595070>
    }
    triangle {
      < -0.362183, -0.030171, 1.672785>,
      < -0.383277, 0.030205, 1.747667>,
      < -0.380067, 0.021015, 1.757401>
    }
    triangle {
      < -0.362183, -0.030171, 1.672785>,
      < -0.380067, 0.021015, 1.757401>,
      < -0.358510, -0.040685, 1.680877>
    }
    triangle {
      < -0.383277, 0.030205, 1.747667>,
      < -0.407975, 0.100897, 1.811622>,
      < -0.405307, 0.093257, 1.822759>
    }
    triangle {
      < -0.383277, 0.030205, 1.747667>,
      < -0.405307, 0.093257, 1.822759>,
      < -0.380067, 0.021015, 1.757401>
    }
    triangle {
      < -0.407975, 0.100897, 1.811622>,
      < -0.435667, 0.180163, 1.863075>,
      < -0.433607, 0.174263, 1.875341>
    }
    triangle {
      < -0.407975, 0.100897, 1.811622>,
      < -0.433607, 0.174263, 1.875341>,
      < -0.405307, 0.093257, 1.822759>
    }
    triangle {
      < -0.435667, 0.180163, 1.863075>,
      < -0.465673, 0.266052, 1.900760>,
      < -0.464271, 0.262036, 1.913853>
    }
    triangle {
      < -0.435667, 0.180163, 1.863075>,
      < -0.464271, 0.262036, 1.913853>,
      < -0.433607, 0.174263, 1.875341>
    }
    triangle {
      < -0.465673, 0.266052, 1.900760>,
      < -0.497253, 0.356450, 1.923749>,
      < -0.496544, 0.354417, 1.937346>
    }
    triangle {
      < -0.465673, 0.266052, 1.900760>,
      < -0.496544, 0.354417, 1.937346>,
      < -0.464271, 0.262036, 1.913853>
    }
    triangle {
      < -0.497253, 0.356450, 1.923749>,
      < -0.529630, 0.449130, 1.931475>,
      < -0.529631, 0.449129, 1.945242>
    }
    triangle {
      < -0.497253, 0.356450, 1.923749>,
      < -0.529631, 0.449129, 1.945242>,
      < -0.496544, 0.354417, 1.937346>
    }
    triangle {
      < -0.529630, 0.449130, 1.931475>,
      < -0.562007, 0.541810, 1.923749>,
      < -0.562717, 0.543842, 1.937346>
    }
    triangle {
      < -0.529630, 0.449130, 1.931475>,
      < -0.562717, 0.543842, 1.937346>,
      < -0.529631, 0.449129, 1.945242>
    }
    triangle {
      < -0.562007, 0.541810, 1.923749>,
      < -0.593585, 0.632208, 1.900760>,
      < -0.594989, 0.636224, 1.913853>
    }
    triangle {
      < -0.562007, 0.541810, 1.923749>,
      < -0.594989, 0.636224, 1.913853>,
      < -0.562717, 0.543842, 1.937346>
    }
    triangle {
      < -0.593585, 0.632208, 1.900760>,
      < -0.623589, 0.718098, 1.863075>,
      < -0.625650, 0.723998, 1.875341>
    }
    triangle {
      < -0.593585, 0.632208, 1.900760>,
      < -0.625650, 0.723998, 1.875341>,
      < -0.594989, 0.636224, 1.913853>
    }
    triangle {
      < -0.623589, 0.718098, 1.863075>,
      < -0.651278, 0.797365, 1.811622>,
      < -0.653947, 0.805004, 1.822759>
    }
    triangle {
      < -0.623589, 0.718098, 1.863075>,
      < -0.653947, 0.805004, 1.822759>,
      < -0.625650, 0.723998, 1.875341>
    }
    triangle {
      < -0.651278, 0.797365, 1.811622>,
      < -0.675972, 0.868058, 1.747667>,
      < -0.679182, 0.877248, 1.757401>
    }
    triangle {
      < -0.651278, 0.797365, 1.811622>,
      < -0.679182, 0.877248, 1.757401>,
      < -0.653947, 0.805004, 1.822759>
    }
    triangle {
      < -0.675972, 0.868058, 1.747667>,
      < -0.697061, 0.928436, 1.672785>,
      < -0.700735, 0.938950, 1.680877>
    }
    triangle {
      < -0.675972, 0.868058, 1.747667>,
      < -0.700735, 0.938950, 1.680877>,
      < -0.679182, 0.877248, 1.757401>
    }
    triangle {
      < -0.697061, 0.928436, 1.672785>,
      < -0.714028, 0.977012, 1.588820>,
      < -0.718073, 0.988591, 1.595070>
    }
    triangle {
      < -0.697061, 0.928436, 1.672785>,
      < -0.718073, 0.988591, 1.595070>,
      < -0.700735, 0.938950, 1.680877>
    }
    triangle {
      < -0.714028, 0.977012, 1.588820>,
      < -0.726453, 1.012589, 1.497841>,
      < -0.730771, 1.024949, 1.502095>
    }
    triangle {
      < -0.714028, 0.977012, 1.588820>,
      < -0.730771, 1.024949, 1.502095>,
      < -0.718073, 0.988591, 1.595070>
    }
    triangle {
      < -0.726453, 1.012589, 1.497841>,
      < -0.734032, 1.034293, 1.402085>,
      < -0.738516, 1.047129, 1.404239>
    }
    triangle {
      < -0.726453, 1.012589, 1.497841>,
      < -0.738516, 1.047129, 1.404239>,
      < -0.730771, 1.024949, 1.502095>
    }
    triangle {
      < -0.734032, 1.034293, 1.402085>,
      < -0.736577, 1.041588, 1.303913>,
      < -0.741117, 1.054584, 1.303913>
    }
    triangle {
      < -0.734032, 1.034293, 1.402085>,
      < -0.741117, 1.054584, 1.303913>,
      < -0.738516, 1.047129, 1.404239>
    }
    triangle {
      < -0.736577, 1.041588, 1.303913>,
      < -0.734026, 1.034295, 1.205741>,
      < -0.738510, 1.047131, 1.203587>
    }
    triangle {
      < -0.736577, 1.041588, 1.303913>,
      < -0.738510, 1.047131, 1.203587>,
      < -0.741117, 1.054584, 1.303913>
    }
    triangle {
      < -0.734026, 1.034295, 1.205741>,
      < -0.726442, 1.012593, 1.109986>,
      < -0.730759, 1.024954, 1.105732>
    }
    triangle {
      < -0.734026, 1.034295, 1.205741>,
      < -0.730759, 1.024954, 1.105732>,
      < -0.738510, 1.047131, 1.203587>
    }
    triangle {
      < -0.726442, 1.012593, 1.109986>,
      < -0.714011, 0.977018, 1.019006>,
      < -0.718056, 0.988597, 1.012756>
    }
    triangle {
      < -0.726442, 1.012593, 1.109986>,
      < -0.718056, 0.988597, 1.012756>,
      < -0.730759, 1.024954, 1.105732>
    }
    triangle {
      < -0.714011, 0.977018, 1.019006>,
      < -0.697039, 0.928444, 0.935042>,
      < -0.700712, 0.938958, 0.926950>
    }
    triangle {
      < -0.714011, 0.977018, 1.019006>,
      < -0.700712, 0.938958, 0.926950>,
      < -0.718056, 0.988597, 1.012756>
    }
    triangle {
      < -0.697039, 0.928444, 0.935042>,
      < -0.675945, 0.868068, 0.860160>,
      < -0.679155, 0.877257, 0.850426>
    }
    triangle {
      < -0.697039, 0.928444, 0.935042>,
      < -0.679155, 0.877257, 0.850426>,
      < -0.700712, 0.938958, 0.926950>
    }
    triangle {
      < -0.675945, 0.868068, 0.860160>,
      < -0.651247, 0.797376, 0.796205>,
      < -0.653916, 0.805015, 0.785068>
    }
    triangle {
      < -0.675945, 0.868068, 0.860160>,
      < -0.653916, 0.805015, 0.785068>,
      < -0.679155, 0.877257, 0.850426>
    }
    triangle {
      < -0.651247, 0.797376, 0.796205>,
      < -0.623555, 0.718110, 0.744751>,
      < -0.625616, 0.724010, 0.732486>
    }
    triangle {
      < -0.651247, 0.797376, 0.796205>,
      < -0.625616, 0.724010, 0.732486>,
      < -0.653916, 0.805015, 0.785068>
    }
    triangle {
      < -0.623555, 0.718110, 0.744751>,
      < -0.593549, 0.632220, 0.707066>,
      < -0.594952, 0.636236, 0.693974>
    }
    triangle {
      < -0.623555, 0.718110, 0.744751>,
      < -0.594952, 0.636236, 0.693974>,
      < -0.625616, 0.724010, 0.732486>
    }
    triangle {
      < -0.593549, 0.632220, 0.707066>,
      < -0.561969, 0.541823, 0.684078>,
      < -0.562679, 0.543856, 0.670481>
    }
    triangle {
      < -0.593549, 0.632220, 0.707066>,
      < -0.562679, 0.543856, 0.670481>,
      < -0.594952, 0.636236, 0.693974>
    }
    triangle {
      < -0.561969, 0.541823, 0.684078>,
      < -0.529592, 0.449143, 0.676351>,
      < -0.529592, 0.449143, 0.662585>
    }
    triangle {
      < -0.561969, 0.541823, 0.684078>,
      < -0.529592, 0.449143, 0.662585>,
      < -0.562679, 0.543856, 0.670481>
    }
    triangle {
      < -0.529592, 0.449143, 0.676351>,
      < -0.497216, 0.356463, 0.684078>,
      < -0.496505, 0.354430, 0.670481>
    }
    triangle {
      < -0.529592, 0.449143, 0.676351>,
      < -0.496505, 0.354430, 0.670481>,
      < -0.529592, 0.449143, 0.662585>
    }
    triangle {
      < -0.497216, 0.356463, 0.684078>,
      < -0.465637, 0.266065, 0.707066>,
      < -0.464234, 0.262049, 0.693974>
    }
    triangle {
      < -0.497216, 0.356463, 0.684078>,
      < -0.464234, 0.262049, 0.693974>,
      < -0.496505, 0.354430, 0.670481>
    }
    triangle {
      < -0.465637, 0.266065, 0.707066>,
      < -0.435634, 0.180175, 0.744751>,
      < -0.433572, 0.174275, 0.732486>
    }
    triangle {
      < -0.465637, 0.266065, 0.707066>,
      < -0.433572, 0.174275, 0.732486>,
      < -0.464234, 0.262049, 0.693974>
    }
    triangle {
      < -0.435634, 0.180175, 0.744751>,
      < -0.407944, 0.100907, 0.796205>,
      < -0.405275, 0.093268, 0.785068>
    }
    triangle {
      < -0.435634, 0.180175, 0.744751>,
      < -0.405275, 0.093268, 0.785068>,
      < -0.433572, 0.174275, 0.732486>
    }
    triangle {
      < -0.407944, 0.100907, 0.796205>,
      < -0.383251, 0.030214, 0.860160>,
      < -0.380040, 0.021025, 0.850426>
    }
    triangle {
      < -0.407944, 0.100907, 0.796205>,
      < -0.380040, 0.021025, 0.850426>,
      < -0.405275, 0.093268, 0.785068>
    }
    triangle {
      < -0.383251, 0.030214, 0.860160>,
      < -0.362161, -0.030163, 0.935042>,
      < -0.358488, -0.040677, 0.926950>
    }
    triangle {
      < -0.383251, 0.030214, 0.860160>,
      < -0.358488, -0.040677, 0.926950>,
      < -0.380040, 0.021025, 0.850426>
    }
    triangle {
      < -0.362161, -0.030163, 0.935042>,
      < -0.345194, -0.078739, 1.019006>,
      < -0.341149, -0.090319, 1.012756>
    }
    triangle {
      < -0.362161, -0.030163, 0.935042>,
      < -0.341149, -0.090319, 1.012756>,
      < -0.358488, -0.040677, 0.926950>
    }
    triangle {
      < -0.345194, -0.078739, 1.019006>,
      < -0.332769, -0.114317, 1.109986>,
      < -0.328451, -0.126677, 1.105732>
    }
    triangle {
      < -0.345194, -0.078739, 1.019006>,
      < -0.328451, -0.126677, 1.105732>,
      < -0.341149, -0.090319, 1.012756>
    }
    triangle {
      < -0.332769, -0.114317, 1.109986>,
      < -0.325190, -0.136020, 1.205741>,
      < -0.320706, -0.148856, 1.203587>
    }
    triangle {
      < -0.332769, -0.114317, 1.109986>,
      < -0.320706, -0.148856, 1.203587>,
      < -0.328451, -0.126677, 1.105732>
    }
    triangle {
      < -0.372430, -0.152523, 1.402084>,
      < -0.369878, -0.159816, 1.303912>,
      < -0.365338, -0.172812, 1.303912>
    }
    triangle {
      < -0.372430, -0.152523, 1.402084>,
      < -0.365338, -0.172812, 1.303912>,
      < -0.367945, -0.165359, 1.404238>
    }
    triangle {
      < -0.369878, -0.159816, 1.303912>,
      < -0.372424, -0.152521, 1.205740>,
      < -0.367939, -0.165357, 1.203586>
    }
    triangle {
      < -0.369878, -0.159816, 1.303912>,
      < -0.367939, -0.165357, 1.203586>,
      < -0.365338, -0.172812, 1.303912>
    }
    triangle {
      < -0.372424, -0.152521, 1.205740>,
      < -0.380002, -0.130817, 1.109985>,
      < -0.375684, -0.143177, 1.105731>
    }
    triangle {
      < -0.372424, -0.152521, 1.205740>,
      < -0.375684, -0.143177, 1.105731>,
      < -0.367939, -0.165357, 1.203586>
    }
    triangle {
      < -0.380002, -0.130817, 1.109985>,
      < -0.392428, -0.095239, 1.019005>,
      < -0.388382, -0.106819, 1.012755>
    }
    triangle {
      < -0.380002, -0.130817, 1.109985>,
      < -0.388382, -0.106819, 1.012755>,
      < -0.375684, -0.143177, 1.105731>
    }
    triangle {
      < -0.392428, -0.095239, 1.019005>,
      < -0.409394, -0.046664, 0.935040>,
      < -0.405721, -0.057178, 0.926949>
    }
    triangle {
      < -0.392428, -0.095239, 1.019005>,
      < -0.405721, -0.057178, 0.926949>,
      < -0.388382, -0.106819, 1.012755>
    }
    triangle {
      < -0.409394, -0.046664, 0.935040>,
      < -0.430484, 0.013714, 0.860159>,
      < -0.427273, 0.004524, 0.850424>
    }
    triangle {
      < -0.409394, -0.046664, 0.935040>,
      < -0.427273, 0.004524, 0.850424>,
      < -0.405721, -0.057178, 0.926949>
    }
    triangle {
      < -0.430484, 0.013714, 0.860159>,
      < -0.455178, 0.084407, 0.796204>,
      < -0.452509, 0.076768, 0.785067>
    }
    triangle {
      < -0.430484, 0.013714, 0.860159>,
      < -0.452509, 0.076768, 0.785067>,
      < -0.427273, 0.004524, 0.850424>
    }
    triangle {
      < -0.455178, 0.084407, 0.796204>,
      < -0.482867, 0.163674, 0.744750>,
      < -0.480805, 0.157774, 0.732484>
    }
    triangle {
      < -0.455178, 0.084407, 0.796204>,
      < -0.480805, 0.157774, 0.732484>,
      < -0.452509, 0.076768, 0.785067>
    }
    triangle {
      < -0.482867, 0.163674, 0.744750>,
      < -0.512870, 0.249565, 0.707065>,
      < -0.511467, 0.245549, 0.693973>
    }
    triangle {
      < -0.482867, 0.163674, 0.744750>,
      < -0.511467, 0.245549, 0.693973>,
      < -0.480805, 0.157774, 0.732484>
    }
    triangle {
      < -0.512870, 0.249565, 0.707065>,
      < -0.544449, 0.339963, 0.684077>,
      < -0.543738, 0.337930, 0.670480>
    }
    triangle {
      < -0.512870, 0.249565, 0.707065>,
      < -0.543738, 0.337930, 0.670480>,
      < -0.511467, 0.245549, 0.693973>
    }
    triangle {
      < -0.544449, 0.339963, 0.684077>,
      < -0.576825, 0.432643, 0.676350>,
      < -0.576825, 0.432643, 0.662584>
    }
    triangle {
      < -0.544449, 0.339963, 0.684077>,
      < -0.576825, 0.432643, 0.662584>,
      < -0.543738, 0.337930, 0.670480>
    }
    triangle {
      < -0.576825, 0.432643, 0.676350>,
      < -0.609202, 0.525322, 0.684077>,
      < -0.609912, 0.527355, 0.670480>
    }
    triangle {
      < -0.576825, 0.432643, 0.676350>,
      < -0.609912, 0.527355, 0.670480>,
      < -0.576825, 0.432643, 0.662584>
    }
    triangle {
      < -0.609202, 0.525322, 0.684077>,
      < -0.640782, 0.615720, 0.707065>,
      < -0.642185, 0.619736, 0.693973>
    }
    triangle {
      < -0.609202, 0.525322, 0.684077>,
      < -0.642185, 0.619736, 0.693973>,
      < -0.609912, 0.527355, 0.670480>
    }
    triangle {
      < -0.640782, 0.615720, 0.707065>,
      < -0.670788, 0.701609, 0.744750>,
      < -0.672849, 0.707510, 0.732484>
    }
    triangle {
      < -0.640782, 0.615720, 0.707065>,
      < -0.672849, 0.707510, 0.732484>,
      < -0.642185, 0.619736, 0.693973>
    }
    triangle {
      < -0.670788, 0.701609, 0.744750>,
      < -0.698481, 0.780876, 0.796204>,
      < -0.701149, 0.788515, 0.785067>
    }
    triangle {
      < -0.670788, 0.701609, 0.744750>,
      < -0.701149, 0.788515, 0.785067>,
      < -0.672849, 0.707510, 0.732484>
    }
    triangle {
      < -0.698481, 0.780876, 0.796204>,
      < -0.723178, 0.851567, 0.860159>,
      < -0.726388, 0.860757, 0.850424>
    }
    triangle {
      < -0.698481, 0.780876, 0.796204>,
      < -0.726388, 0.860757, 0.850424>,
      < -0.701149, 0.788515, 0.785067>
    }
    triangle {
      < -0.723178, 0.851567, 0.860159>,
      < -0.744272, 0.911943, 0.935040>,
      < -0.747945, 0.922458, 0.926949>
    }
    triangle {
      < -0.723178, 0.851567, 0.860159>,
      < -0.747945, 0.922458, 0.926949>,
      < -0.726388, 0.860757, 0.850424>
    }
    triangle {
      < -0.744272, 0.911943, 0.935040>,
      < -0.761244, 0.960517, 1.019005>,
      < -0.765289, 0.972097, 1.012755>
    }
    triangle {
      < -0.744272, 0.911943, 0.935040>,
      < -0.765289, 0.972097, 1.012755>,
      < -0.747945, 0.922458, 0.926949>
    }
    triangle {
      < -0.761244, 0.960517, 1.019005>,
      < -0.773675, 0.996093, 1.109985>,
      < -0.777993, 1.008453, 1.105731>
    }
    triangle {
      < -0.761244, 0.960517, 1.019005>,
      < -0.777993, 1.008453, 1.105731>,
      < -0.765289, 0.972097, 1.012755>
    }
    triangle {
      < -0.773675, 0.996093, 1.109985>,
      < -0.781260, 1.017794, 1.205740>,
      < -0.785744, 1.030631, 1.203586>
    }
    triangle {
      < -0.773675, 0.996093, 1.109985>,
      < -0.785744, 1.030631, 1.203586>,
      < -0.777993, 1.008453, 1.105731>
    }
    triangle {
      < -0.781260, 1.017794, 1.205740>,
      < -0.783811, 1.025088, 1.303912>,
      < -0.788351, 1.038084, 1.303912>
    }
    triangle {
      < -0.781260, 1.017794, 1.205740>,
      < -0.788351, 1.038084, 1.303912>,
      < -0.785744, 1.030631, 1.203586>
    }
    triangle {
      < -0.783811, 1.025088, 1.303912>,
      < -0.781265, 1.017792, 1.402084>,
      < -0.785750, 1.030629, 1.404238>
    }
    triangle {
      < -0.783811, 1.025088, 1.303912>,
      < -0.785750, 1.030629, 1.404238>,
      < -0.788351, 1.038084, 1.303912>
    }
    triangle {
      < -0.781265, 1.017792, 1.402084>,
      < -0.773687, 0.996089, 1.497839>,
      < -0.778005, 1.008449, 1.502093>
    }
    triangle {
      < -0.781265, 1.017792, 1.402084>,
      < -0.778005, 1.008449, 1.502093>,
      < -0.785750, 1.030629, 1.404238>
    }
    triangle {
      < -0.773687, 0.996089, 1.497839>,
      < -0.761261, 0.960511, 1.588819>,
      < -0.765307, 0.972091, 1.595069>
    }
    triangle {
      < -0.773687, 0.996089, 1.497839>,
      < -0.765307, 0.972091, 1.595069>,
      < -0.778005, 1.008449, 1.502093>
    }
    triangle {
      < -0.761261, 0.960511, 1.588819>,
      < -0.744295, 0.911936, 1.672784>,
      < -0.747968, 0.922450, 1.680876>
    }
    triangle {
      < -0.761261, 0.960511, 1.588819>,
      < -0.747968, 0.922450, 1.680876>,
      < -0.765307, 0.972091, 1.595069>
    }
    triangle {
      < -0.744295, 0.911936, 1.672784>,
      < -0.723205, 0.851558, 1.747665>,
      < -0.726416, 0.860747, 1.757400>
    }
    triangle {
      < -0.744295, 0.911936, 1.672784>,
      < -0.726416, 0.860747, 1.757400>,
      < -0.747968, 0.922450, 1.680876>
    }
    triangle {
      < -0.723205, 0.851558, 1.747665>,
      < -0.698512, 0.780865, 1.811620>,
      < -0.701181, 0.788504, 1.822758>
    }
    triangle {
      < -0.723205, 0.851558, 1.747665>,
      < -0.701181, 0.788504, 1.822758>,
      < -0.726416, 0.860747, 1.757400>
    }
    triangle {
      < -0.698512, 0.780865, 1.811620>,
      < -0.670822, 0.701597, 1.863074>,
      < -0.672884, 0.707497, 1.875340>
    }
    triangle {
      < -0.698512, 0.780865, 1.811620>,
      < -0.672884, 0.707497, 1.875340>,
      < -0.701181, 0.788504, 1.822758>
    }
    triangle {
      < -0.670822, 0.701597, 1.863074>,
      < -0.640819, 0.615707, 1.900759>,
      < -0.642222, 0.619723, 1.913852>
    }
    triangle {
      < -0.670822, 0.701597, 1.863074>,
      < -0.642222, 0.619723, 1.913852>,
      < -0.672884, 0.707497, 1.875340>
    }
    triangle {
      < -0.640819, 0.615707, 1.900759>,
      < -0.609240, 0.525309, 1.923748>,
      < -0.609951, 0.527342, 1.937345>
    }
    triangle {
      < -0.640819, 0.615707, 1.900759>,
      < -0.609951, 0.527342, 1.937345>,
      < -0.642222, 0.619723, 1.913852>
    }
    triangle {
      < -0.609240, 0.525309, 1.923748>,
      < -0.576864, 0.432629, 1.931474>,
      < -0.576864, 0.432629, 1.945240>
    }
    triangle {
      < -0.609240, 0.525309, 1.923748>,
      < -0.576864, 0.432629, 1.945240>,
      < -0.609951, 0.527342, 1.937345>
    }
    triangle {
      < -0.576864, 0.432629, 1.931474>,
      < -0.544487, 0.339949, 1.923748>,
      < -0.543777, 0.337916, 1.937345>
    }
    triangle {
      < -0.576864, 0.432629, 1.931474>,
      < -0.543777, 0.337916, 1.937345>,
      < -0.576864, 0.432629, 1.945240>
    }
    triangle {
      < -0.544487, 0.339949, 1.923748>,
      < -0.512907, 0.249552, 1.900759>,
      < -0.511504, 0.245536, 1.913852>
    }
    triangle {
      < -0.544487, 0.339949, 1.923748>,
      < -0.511504, 0.245536, 1.913852>,
      < -0.543777, 0.337916, 1.937345>
    }
    triangle {
      < -0.512907, 0.249552, 1.900759>,
      < -0.482901, 0.163662, 1.863074>,
      < -0.480840, 0.157762, 1.875340>
    }
    triangle {
      < -0.512907, 0.249552, 1.900759>,
      < -0.480840, 0.157762, 1.875340>,
      < -0.511504, 0.245536, 1.913852>
    }
    triangle {
      < -0.482901, 0.163662, 1.863074>,
      < -0.455208, 0.084396, 1.811620>,
      < -0.452540, 0.076757, 1.822758>
    }
    triangle {
      < -0.482901, 0.163662, 1.863074>,
      < -0.452540, 0.076757, 1.822758>,
      < -0.480840, 0.157762, 1.875340>
    }
    triangle {
      < -0.455208, 0.084396, 1.811620>,
      < -0.430511, 0.013705, 1.747665>,
      < -0.427301, 0.004515, 1.757400>
    }
    triangle {
      < -0.455208, 0.084396, 1.811620>,
      < -0.427301, 0.004515, 1.757400>,
      < -0.452540, 0.076757, 1.822758>
    }
    triangle {
      < -0.430511, 0.013705, 1.747665>,
      < -0.409417, -0.046672, 1.672784>,
      < -0.405744, -0.057186, 1.680876>
    }
    triangle {
      < -0.430511, 0.013705, 1.747665>,
      < -0.405744, -0.057186, 1.680876>,
      < -0.427301, 0.004515, 1.757400>
    }
    triangle {
      < -0.409417, -0.046672, 1.672784>,
      < -0.392445, -0.095245, 1.588819>,
      < -0.388400, -0.106825, 1.595069>
    }
    triangle {
      < -0.409417, -0.046672, 1.672784>,
      < -0.388400, -0.106825, 1.595069>,
      < -0.405744, -0.057186, 1.680876>
    }
    triangle {
      < -0.392445, -0.095245, 1.588819>,
      < -0.380014, -0.130821, 1.497839>,
      < -0.375696, -0.143181, 1.502093>
    }
    triangle {
      < -0.392445, -0.095245, 1.588819>,
      < -0.375696, -0.143181, 1.502093>,
      < -0.388400, -0.106825, 1.595069>
    }
    triangle {
      < -0.380014, -0.130821, 1.497839>,
      < -0.372430, -0.152523, 1.402084>,
      < -0.367945, -0.165359, 1.404238>
    }
    triangle {
      < -0.380014, -0.130821, 1.497839>,
      < -0.367945, -0.165359, 1.404238>,
      < -0.375696, -0.143181, 1.502093>
    }
    triangle {
      < -0.368540, -0.113064, 1.114203>,
      < -0.352793, -0.107562, 1.114203>,
      < -0.364948, -0.072758, 1.025202>
    }
    triangle {
      < -0.368540, -0.113064, 1.114203>,
      < -0.364948, -0.072758, 1.025202>,
      < -0.380696, -0.078260, 1.025201>
    }
    triangle {
      < -0.361126, -0.134295, 1.207875>,
      < -0.345379, -0.128794, 1.207875>,
      < -0.352793, -0.107562, 1.114203>
    }
    triangle {
      < -0.361126, -0.134295, 1.207875>,
      < -0.352793, -0.107562, 1.114203>,
      < -0.368540, -0.113064, 1.114203>
    }
    triangle {
      < -0.358637, -0.141432, 1.303912>,
      < -0.342889, -0.135930, 1.303913>,
      < -0.345379, -0.128794, 1.207875>
    }
    triangle {
      < -0.358637, -0.141432, 1.303912>,
      < -0.345379, -0.128794, 1.207875>,
      < -0.361126, -0.134295, 1.207875>
    }
    triangle {
      < -0.361132, -0.134297, 1.399950>,
      < -0.345385, -0.128796, 1.399950>,
      < -0.342889, -0.135930, 1.303913>
    }
    triangle {
      < -0.361132, -0.134297, 1.399950>,
      < -0.342889, -0.135930, 1.303913>,
      < -0.358637, -0.141432, 1.303912>
    }
    triangle {
      < -0.368552, -0.113068, 1.493622>,
      < -0.352804, -0.107566, 1.493623>,
      < -0.345385, -0.128796, 1.399950>
    }
    triangle {
      < -0.368552, -0.113068, 1.493622>,
      < -0.345385, -0.128796, 1.399950>,
      < -0.361132, -0.134297, 1.399950>
    }
    triangle {
      < -0.380712, -0.078266, 1.582623>,
      < -0.364965, -0.072764, 1.582624>,
      < -0.352804, -0.107566, 1.493623>
    }
    triangle {
      < -0.380712, -0.078266, 1.582623>,
      < -0.352804, -0.107566, 1.493623>,
      < -0.368552, -0.113068, 1.493622>
    }
    triangle {
      < -0.397315, -0.030748, 1.664762>,
      < -0.381567, -0.025247, 1.664762>,
      < -0.364965, -0.072764, 1.582624>
    }
    triangle {
      < -0.397315, -0.030748, 1.664762>,
      < -0.364965, -0.072764, 1.582624>,
      < -0.380712, -0.078266, 1.582623>
    }
    triangle {
      < -0.417950, 0.028315, 1.738015>,
      < -0.402203, 0.033816, 1.738015>,
      < -0.381567, -0.025247, 1.664762>
    }
    triangle {
      < -0.417950, 0.028315, 1.738015>,
      < -0.381567, -0.025247, 1.664762>,
      < -0.397315, -0.030748, 1.664762>
    }
    triangle {
      < -0.442111, 0.097469, 1.800579>,
      < -0.426363, 0.102970, 1.800580>,
      < -0.402203, 0.033816, 1.738015>
    }
    triangle {
      < -0.442111, 0.097469, 1.800579>,
      < -0.402203, 0.033816, 1.738015>,
      < -0.417950, 0.028315, 1.738015>
    }
    triangle {
      < -0.469201, 0.175012, 1.850914>,
      < -0.453453, 0.180513, 1.850914>,
      < -0.426363, 0.102970, 1.800580>
    }
    triangle {
      < -0.469201, 0.175012, 1.850914>,
      < -0.426363, 0.102970, 1.800580>,
      < -0.442111, 0.097469, 1.800579>
    }
    triangle {
      < -0.498554, 0.259033, 1.887779>,
      < -0.482807, 0.264534, 1.887779>,
      < -0.453453, 0.180513, 1.850914>
    }
    triangle {
      < -0.498554, 0.259033, 1.887779>,
      < -0.453453, 0.180513, 1.850914>,
      < -0.469201, 0.175012, 1.850914>
    }
    triangle {
      < -0.529448, 0.347465, 1.910268>,
      < -0.513700, 0.352966, 1.910268>,
      < -0.482807, 0.264534, 1.887779>
    }
    triangle {
      < -0.529448, 0.347465, 1.910268>,
      < -0.482807, 0.264534, 1.887779>,
      < -0.498554, 0.259033, 1.887779>
    }
    triangle {
      < -0.561120, 0.438129, 1.917826>,
      < -0.545373, 0.443630, 1.917827>,
      < -0.513700, 0.352966, 1.910268>
    }
    triangle {
      < -0.561120, 0.438129, 1.917826>,
      < -0.513700, 0.352966, 1.910268>,
      < -0.529448, 0.347465, 1.910268>
    }
    triangle {
      < -0.592793, 0.528793, 1.910268>,
      < -0.577045, 0.534295, 1.910268>,
      < -0.545373, 0.443630, 1.917827>
    }
    triangle {
      < -0.592793, 0.528793, 1.910268>,
      < -0.545373, 0.443630, 1.917827>,
      < -0.561120, 0.438129, 1.917826>
    }
    triangle {
      < -0.623685, 0.617225, 1.887779>,
      < -0.607937, 0.622727, 1.887779>,
      < -0.577045, 0.534295, 1.910268>
    }
    triangle {
      < -0.623685, 0.617225, 1.887779>,
      < -0.577045, 0.534295, 1.910268>,
      < -0.592793, 0.528793, 1.910268>
    }
    triangle {
      < -0.653035, 0.701248, 1.850914>,
      < -0.637288, 0.706749, 1.850914>,
      < -0.607937, 0.622727, 1.887779>
    }
    triangle {
      < -0.653035, 0.701248, 1.850914>,
      < -0.607937, 0.622727, 1.887779>,
      < -0.623685, 0.617225, 1.887779>
    }
    triangle {
      < -0.680123, 0.778791, 1.800579>,
      < -0.664375, 0.784292, 1.800580>,
      < -0.637288, 0.706749, 1.850914>
    }
    triangle {
      < -0.680123, 0.778791, 1.800579>,
      < -0.637288, 0.706749, 1.850914>,
      < -0.653035, 0.701248, 1.850914>
    }
    triangle {
      < -0.704279, 0.847947, 1.738015>,
      < -0.688532, 0.853448, 1.738015>,
      < -0.664375, 0.784292, 1.800580>
    }
    triangle {
      < -0.704279, 0.847947, 1.738015>,
      < -0.664375, 0.784292, 1.800580>,
      < -0.680123, 0.778791, 1.800579>
    }
    triangle {
      < -0.724910, 0.907011, 1.664762>,
      < -0.709163, 0.912513, 1.664762>,
      < -0.688532, 0.853448, 1.738015>
    }
    triangle {
      < -0.724910, 0.907011, 1.664762>,
      < -0.688532, 0.853448, 1.738015>,
      < -0.704279, 0.847947, 1.738015>
    }
    triangle {
      < -0.741508, 0.954531, 1.582623>,
      < -0.725760, 0.960032, 1.582624>,
      < -0.709163, 0.912513, 1.664762>
    }
    triangle {
      < -0.741508, 0.954531, 1.582623>,
      < -0.709163, 0.912513, 1.664762>,
      < -0.724910, 0.907011, 1.664762>
    }
    triangle {
      < -0.753663, 0.989335, 1.493622>,
      < -0.737915, 0.994836, 1.493623>,
      < -0.725760, 0.960032, 1.582624>
    }
    triangle {
      < -0.753663, 0.989335, 1.493622>,
      < -0.725760, 0.960032, 1.582624>,
      < -0.741508, 0.954531, 1.582623>
    }
    triangle {
      < -0.761077, 1.010566, 1.399950>,
      < -0.745329, 1.016068, 1.399950>,
      < -0.737915, 0.994836, 1.493623>
    }
    triangle {
      < -0.761077, 1.010566, 1.399950>,
      < -0.737915, 0.994836, 1.493623>,
      < -0.753663, 0.989335, 1.493622>
    }
    triangle {
      < -0.763567, 1.017703, 1.303912>,
      < -0.747819, 1.023204, 1.303913>,
      < -0.745329, 1.016068, 1.399950>
    }
    triangle {
      < -0.763567, 1.017703, 1.303912>,
      < -0.745329, 1.016068, 1.399950>,
      < -0.761077, 1.010566, 1.399950>
    }
    triangle {
      < -0.761071, 1.010568, 1.207875>,
      < -0.745323, 1.016070, 1.207875>,
      < -0.747819, 1.023204, 1.303913>
    }
    triangle {
      < -0.761071, 1.010568, 1.207875>,
      < -0.747819, 1.023204, 1.303913>,
      < -0.763567, 1.017703, 1.303912>
    }
    triangle {
      < -0.753652, 0.989339, 1.114203>,
      < -0.737904, 0.994840, 1.114203>,
      < -0.745323, 1.016070, 1.207875>
    }
    triangle {
      < -0.753652, 0.989339, 1.114203>,
      < -0.745323, 1.016070, 1.207875>,
      < -0.761071, 1.010568, 1.207875>
    }
    triangle {
      < -0.741491, 0.954536, 1.025201>,
      < -0.725743, 0.960038, 1.025202>,
      < -0.737904, 0.994840, 1.114203>
    }
    triangle {
      < -0.741491, 0.954536, 1.025201>,
      < -0.737904, 0.994840, 1.114203>,
      < -0.753652, 0.989339, 1.114203>
    }
    triangle {
      < -0.724888, 0.907019, 0.943063>,
      < -0.709141, 0.912520, 0.943063>,
      < -0.725743, 0.960038, 1.025202>
    }
    triangle {
      < -0.724888, 0.907019, 0.943063>,
      < -0.725743, 0.960038, 1.025202>,
      < -0.741491, 0.954536, 1.025201>
    }
    triangle {
      < -0.704253, 0.847956, 0.869810>,
      < -0.688505, 0.853457, 0.869810>,
      < -0.709141, 0.912520, 0.943063>
    }
    triangle {
      < -0.704253, 0.847956, 0.869810>,
      < -0.709141, 0.912520, 0.943063>,
      < -0.724888, 0.907019, 0.943063>
    }
    triangle {
      < -0.680093, 0.778802, 0.807246>,
      < -0.664345, 0.784303, 0.807246>,
      < -0.688505, 0.853457, 0.869810>
    }
    triangle {
      < -0.680093, 0.778802, 0.807246>,
      < -0.688505, 0.853457, 0.869810>,
      < -0.704253, 0.847956, 0.869810>
    }
    triangle {
      < -0.653002, 0.701259, 0.756911>,
      < -0.637255, 0.706761, 0.756912>,
      < -0.664345, 0.784303, 0.807246>
    }
    triangle {
      < -0.653002, 0.701259, 0.756911>,
      < -0.664345, 0.784303, 0.807246>,
      < -0.680093, 0.778802, 0.807246>
    }
    triangle {
      < -0.623649, 0.617238, 0.720046>,
      < -0.607901, 0.622739, 0.720046>,
      < -0.637255, 0.706761, 0.756912>
    }
    triangle {
      < -0.623649, 0.617238, 0.720046>,
      < -0.637255, 0.706761, 0.756912>,
      < -0.653002, 0.701259, 0.756911>
    }
    triangle {
      < -0.592756, 0.528806, 0.697557>,
      < -0.577008, 0.534307, 0.697557>,
      < -0.607901, 0.622739, 0.720046>
    }
    triangle {
      < -0.592756, 0.528806, 0.697557>,
      < -0.607901, 0.622739, 0.720046>,
      < -0.623649, 0.617238, 0.720046>
    }
    triangle {
      < -0.561083, 0.438142, 0.689999>,
      < -0.545335, 0.443643, 0.689999>,
      < -0.577008, 0.534307, 0.697557>
    }
    triangle {
      < -0.561083, 0.438142, 0.689999>,
      < -0.577008, 0.534307, 0.697557>,
      < -0.592756, 0.528806, 0.697557>
    }
    triangle {
      < -0.529411, 0.347478, 0.697557>,
      < -0.513663, 0.352979, 0.697557>,
      < -0.545335, 0.443643, 0.689999>
    }
    triangle {
      < -0.529411, 0.347478, 0.697557>,
      < -0.545335, 0.443643, 0.689999>,
      < -0.561083, 0.438142, 0.689999>
    }
    triangle {
      < -0.498519, 0.259046, 0.720046>,
      < -0.482771, 0.264547, 0.720046>,
      < -0.513663, 0.352979, 0.697557>
    }
    triangle {
      < -0.498519, 0.259046, 0.720046>,
      < -0.513663, 0.352979, 0.697557>,
      < -0.529411, 0.347478, 0.697557>
    }
    triangle {
      < -0.469168, 0.175023, 0.756911>,
      < -0.453420, 0.180524, 0.756912>,
      < -0.482771, 0.264547, 0.720046>
    }
    triangle {
      < -0.469168, 0.175023, 0.756911>,
      < -0.482771, 0.264547, 0.720046>,
      < -0.498519, 0.259046, 0.720046>
    }
    triangle {
      < -0.442081, 0.097480, 0.807246>,
      < -0.426333, 0.102981, 0.807246>,
      < -0.453420, 0.180524, 0.756912>
    }
    triangle {
      < -0.442081, 0.097480, 0.807246>,
      < -0.453420, 0.180524, 0.756912>,
      < -0.469168, 0.175023, 0.756911>
    }
    triangle {
      < -0.417924, 0.028324, 0.869810>,
      < -0.402176, 0.033825, 0.869810>,
      < -0.426333, 0.102981, 0.807246>
    }
    triangle {
      < -0.417924, 0.028324, 0.869810>,
      < -0.426333, 0.102981, 0.807246>,
      < -0.442081, 0.097480, 0.807246>
    }
    triangle {
      < -0.397293, -0.030740, 0.943063>,
      < -0.381545, -0.025239, 0.943063>,
      < -0.402176, 0.033825, 0.869810>
    }
    triangle {
      < -0.397293, -0.030740, 0.943063>,
      < -0.402176, 0.033825, 0.869810>,
      < -0.417924, 0.028324, 0.869810>
    }
    triangle {
      < -0.380696, -0.078260, 1.025201>,
      < -0.364948, -0.072758, 1.025202>,
      < -0.381545, -0.025239, 0.943063>
    }
    triangle {
      < -0.380696, -0.078260, 1.025201>,
      < -0.381545, -0.025239, 0.943063>,
      < -0.397293, -0.030740, 0.943063>
    }
    triangle {
      < -0.453420, 0.180524, 0.756912>,
      < -0.426333, 0.102981, 0.807246>,
      < -0.407944, 0.100907, 0.796205>
    }
    triangle {
      < -0.453420, 0.180524, 0.756912>,
      < -0.407944, 0.100907, 0.796205>,
      < -0.435634, 0.180175, 0.744751>
    }
    triangle {
      < -0.426333, 0.102981, 0.807246>,
      < -0.402176, 0.033825, 0.869810>,
      < -0.383251, 0.030214, 0.860160>
    }
    triangle {
      < -0.426333, 0.102981, 0.807246>,
      < -0.383251, 0.030214, 0.860160>,
      < -0.407944, 0.100907, 0.796205>
    }
    triangle {
      < -0.402176, 0.033825, 0.869810>,
      < -0.381545, -0.025239, 0.943063>,
      < -0.362161, -0.030163, 0.935042>
    }
    triangle {
      < -0.402176, 0.033825, 0.869810>,
      < -0.362161, -0.030163, 0.935042>,
      < -0.383251, 0.030214, 0.860160>
    }
    triangle {
      < -0.381545, -0.025239, 0.943063>,
      < -0.364948, -0.072758, 1.025202>,
      < -0.345194, -0.078739, 1.019006>
    }
    triangle {
      < -0.381545, -0.025239, 0.943063>,
      < -0.345194, -0.078739, 1.019006>,
      < -0.362161, -0.030163, 0.935042>
    }
    triangle {
      < -0.364948, -0.072758, 1.025202>,
      < -0.352793, -0.107562, 1.114203>,
      < -0.332769, -0.114317, 1.109986>
    }
    triangle {
      < -0.364948, -0.072758, 1.025202>,
      < -0.332769, -0.114317, 1.109986>,
      < -0.345194, -0.078739, 1.019006>
    }
    triangle {
      < -0.352793, -0.107562, 1.114203>,
      < -0.345379, -0.128794, 1.207875>,
      < -0.325190, -0.136020, 1.205741>
    }
    triangle {
      < -0.352793, -0.107562, 1.114203>,
      < -0.325190, -0.136020, 1.205741>,
      < -0.332769, -0.114317, 1.109986>
    }
    triangle {
      < -0.345379, -0.128794, 1.207875>,
      < -0.342889, -0.135930, 1.303913>,
      < -0.322645, -0.143315, 1.303913>
    }
    triangle {
      < -0.345379, -0.128794, 1.207875>,
      < -0.322645, -0.143315, 1.303913>,
      < -0.325190, -0.136020, 1.205741>
    }
    triangle {
      < -0.342889, -0.135930, 1.303913>,
      < -0.345385, -0.128796, 1.399950>,
      < -0.325196, -0.136022, 1.402085>
    }
    triangle {
      < -0.342889, -0.135930, 1.303913>,
      < -0.325196, -0.136022, 1.402085>,
      < -0.322645, -0.143315, 1.303913>
    }
    triangle {
      < -0.345385, -0.128796, 1.399950>,
      < -0.352804, -0.107566, 1.493623>,
      < -0.332781, -0.114321, 1.497841>
    }
    triangle {
      < -0.345385, -0.128796, 1.399950>,
      < -0.332781, -0.114321, 1.497841>,
      < -0.325196, -0.136022, 1.402085>
    }
    triangle {
      < -0.352804, -0.107566, 1.493623>,
      < -0.364965, -0.072764, 1.582624>,
      < -0.345212, -0.078745, 1.588820>
    }
    triangle {
      < -0.352804, -0.107566, 1.493623>,
      < -0.345212, -0.078745, 1.588820>,
      < -0.332781, -0.114321, 1.497841>
    }
    triangle {
      < -0.364965, -0.072764, 1.582624>,
      < -0.381567, -0.025247, 1.664762>,
      < -0.362183, -0.030171, 1.672785>
    }
    triangle {
      < -0.364965, -0.072764, 1.582624>,
      < -0.362183, -0.030171, 1.672785>,
      < -0.345212, -0.078745, 1.588820>
    }
    triangle {
      < -0.381567, -0.025247, 1.664762>,
      < -0.402203, 0.033816, 1.738015>,
      < -0.383277, 0.030205, 1.747667>
    }
    triangle {
      < -0.381567, -0.025247, 1.664762>,
      < -0.383277, 0.030205, 1.747667>,
      < -0.362183, -0.030171, 1.672785>
    }
    triangle {
      < -0.402203, 0.033816, 1.738015>,
      < -0.426363, 0.102970, 1.800580>,
      < -0.407975, 0.100897, 1.811622>
    }
    triangle {
      < -0.402203, 0.033816, 1.738015>,
      < -0.407975, 0.100897, 1.811622>,
      < -0.383277, 0.030205, 1.747667>
    }
    triangle {
      < -0.426363, 0.102970, 1.800580>,
      < -0.453453, 0.180513, 1.850914>,
      < -0.435667, 0.180163, 1.863075>
    }
    triangle {
      < -0.426363, 0.102970, 1.800580>,
      < -0.435667, 0.180163, 1.863075>,
      < -0.407975, 0.100897, 1.811622>
    }
    triangle {
      < -0.453453, 0.180513, 1.850914>,
      < -0.482807, 0.264534, 1.887779>,
      < -0.465673, 0.266052, 1.900760>
    }
    triangle {
      < -0.453453, 0.180513, 1.850914>,
      < -0.465673, 0.266052, 1.900760>,
      < -0.435667, 0.180163, 1.863075>
    }
    triangle {
      < -0.482807, 0.264534, 1.887779>,
      < -0.513700, 0.352966, 1.910268>,
      < -0.497253, 0.356450, 1.923749>
    }
    triangle {
      < -0.482807, 0.264534, 1.887779>,
      < -0.497253, 0.356450, 1.923749>,
      < -0.465673, 0.266052, 1.900760>
    }
    triangle {
      < -0.513700, 0.352966, 1.910268>,
      < -0.545373, 0.443630, 1.917827>,
      < -0.529630, 0.449130, 1.931475>
    }
    triangle {
      < -0.513700, 0.352966, 1.910268>,
      < -0.529630, 0.449130, 1.931475>,
      < -0.497253, 0.356450, 1.923749>
    }
    triangle {
      < -0.545373, 0.443630, 1.917827>,
      < -0.577045, 0.534295, 1.910268>,
      < -0.562007, 0.541810, 1.923749>
    }
    triangle {
      < -0.545373, 0.443630, 1.917827>,
      < -0.562007, 0.541810, 1.923749>,
      < -0.529630, 0.449130, 1.931475>
    }
    triangle {
      < -0.577045, 0.534295, 1.910268>,
      < -0.607937, 0.622727, 1.887779>,
      < -0.593585, 0.632208, 1.900760>
    }
    triangle {
      < -0.577045, 0.534295, 1.910268>,
      < -0.593585, 0.632208, 1.900760>,
      < -0.562007, 0.541810, 1.923749>
    }
    triangle {
      < -0.607937, 0.622727, 1.887779>,
      < -0.637288, 0.706749, 1.850914>,
      < -0.623589, 0.718098, 1.863075>
    }
    triangle {
      < -0.607937, 0.622727, 1.887779>,
      < -0.623589, 0.718098, 1.863075>,
      < -0.593585, 0.632208, 1.900760>
    }
    triangle {
      < -0.637288, 0.706749, 1.850914>,
      < -0.664375, 0.784292, 1.800580>,
      < -0.651278, 0.797365, 1.811622>
    }
    triangle {
      < -0.637288, 0.706749, 1.850914>,
      < -0.651278, 0.797365, 1.811622>,
      < -0.623589, 0.718098, 1.863075>
    }
    triangle {
      < -0.664375, 0.784292, 1.800580>,
      < -0.688532, 0.853448, 1.738015>,
      < -0.675972, 0.868058, 1.747667>
    }
    triangle {
      < -0.664375, 0.784292, 1.800580>,
      < -0.675972, 0.868058, 1.747667>,
      < -0.651278, 0.797365, 1.811622>
    }
    triangle {
      < -0.688532, 0.853448, 1.738015>,
      < -0.709163, 0.912513, 1.664762>,
      < -0.697061, 0.928436, 1.672785>
    }
    triangle {
      < -0.688532, 0.853448, 1.738015>,
      < -0.697061, 0.928436, 1.672785>,
      < -0.675972, 0.868058, 1.747667>
    }
    triangle {
      < -0.709163, 0.912513, 1.664762>,
      < -0.725760, 0.960032, 1.582624>,
      < -0.714028, 0.977012, 1.588820>
    }
    triangle {
      < -0.709163, 0.912513, 1.664762>,
      < -0.714028, 0.977012, 1.588820>,
      < -0.697061, 0.928436, 1.672785>
    }
    triangle {
      < -0.725760, 0.960032, 1.582624>,
      < -0.737915, 0.994836, 1.493623>,
      < -0.726453, 1.012589, 1.497841>
    }
    triangle {
      < -0.725760, 0.960032, 1.582624>,
      < -0.726453, 1.012589, 1.497841>,
      < -0.714028, 0.977012, 1.588820>
    }
    triangle {
      < -0.737915, 0.994836, 1.493623>,
      < -0.745329, 1.016068, 1.399950>,
      < -0.734032, 1.034293, 1.402085>
    }
    triangle {
      < -0.737915, 0.994836, 1.493623>,
      < -0.734032, 1.034293, 1.402085>,
      < -0.726453, 1.012589, 1.497841>
    }
    triangle {
      < -0.745329, 1.016068, 1.399950>,
      < -0.747819, 1.023204, 1.303913>,
      < -0.736577, 1.041588, 1.303913>
    }
    triangle {
      < -0.745329, 1.016068, 1.399950>,
      < -0.736577, 1.041588, 1.303913>,
      < -0.734032, 1.034293, 1.402085>
    }
    triangle {
      < -0.747819, 1.023204, 1.303913>,
      < -0.745323, 1.016070, 1.207875>,
      < -0.734026, 1.034295, 1.205741>
    }
    triangle {
      < -0.747819, 1.023204, 1.303913>,
      < -0.734026, 1.034295, 1.205741>,
      < -0.736577, 1.041588, 1.303913>
    }
    triangle {
      < -0.745323, 1.016070, 1.207875>,
      < -0.737904, 0.994840, 1.114203>,
      < -0.726442, 1.012593, 1.109986>
    }
    triangle {
      < -0.745323, 1.016070, 1.207875>,
      < -0.726442, 1.012593, 1.109986>,
      < -0.734026, 1.034295, 1.205741>
    }
    triangle {
      < -0.737904, 0.994840, 1.114203>,
      < -0.725743, 0.960038, 1.025202>,
      < -0.714011, 0.977018, 1.019006>
    }
    triangle {
      < -0.737904, 0.994840, 1.114203>,
      < -0.714011, 0.977018, 1.019006>,
      < -0.726442, 1.012593, 1.109986>
    }
    triangle {
      < -0.725743, 0.960038, 1.025202>,
      < -0.709141, 0.912520, 0.943063>,
      < -0.697039, 0.928444, 0.935042>
    }
    triangle {
      < -0.725743, 0.960038, 1.025202>,
      < -0.697039, 0.928444, 0.935042>,
      < -0.714011, 0.977018, 1.019006>
    }
    triangle {
      < -0.709141, 0.912520, 0.943063>,
      < -0.688505, 0.853457, 0.869810>,
      < -0.675945, 0.868068, 0.860160>
    }
    triangle {
      < -0.709141, 0.912520, 0.943063>,
      < -0.675945, 0.868068, 0.860160>,
      < -0.697039, 0.928444, 0.935042>
    }
    triangle {
      < -0.688505, 0.853457, 0.869810>,
      < -0.664345, 0.784303, 0.807246>,
      < -0.651247, 0.797376, 0.796205>
    }
    triangle {
      < -0.688505, 0.853457, 0.869810>,
      < -0.651247, 0.797376, 0.796205>,
      < -0.675945, 0.868068, 0.860160>
    }
    triangle {
      < -0.664345, 0.784303, 0.807246>,
      < -0.637255, 0.706761, 0.756912>,
      < -0.623555, 0.718110, 0.744751>
    }
    triangle {
      < -0.664345, 0.784303, 0.807246>,
      < -0.623555, 0.718110, 0.744751>,
      < -0.651247, 0.797376, 0.796205>
    }
    triangle {
      < -0.637255, 0.706761, 0.756912>,
      < -0.607901, 0.622739, 0.720046>,
      < -0.593549, 0.632220, 0.707066>
    }
    triangle {
      < -0.637255, 0.706761, 0.756912>,
      < -0.593549, 0.632220, 0.707066>,
      < -0.623555, 0.718110, 0.744751>
    }
    triangle {
      < -0.607901, 0.622739, 0.720046>,
      < -0.577008, 0.534307, 0.697557>,
      < -0.561969, 0.541823, 0.684078>
    }
    triangle {
      < -0.607901, 0.622739, 0.720046>,
      < -0.561969, 0.541823, 0.684078>,
      < -0.593549, 0.632220, 0.707066>
    }
    triangle {
      < -0.577008, 0.534307, 0.697557>,
      < -0.545335, 0.443643, 0.689999>,
      < -0.529592, 0.449143, 0.676351>
    }
    triangle {
      < -0.577008, 0.534307, 0.697557>,
      < -0.529592, 0.449143, 0.676351>,
      < -0.561969, 0.541823, 0.684078>
    }
    triangle {
      < -0.545335, 0.443643, 0.689999>,
      < -0.513663, 0.352979, 0.697557>,
      < -0.497216, 0.356463, 0.684078>
    }
    triangle {
      < -0.545335, 0.443643, 0.689999>,
      < -0.497216, 0.356463, 0.684078>,
      < -0.529592, 0.449143, 0.676351>
    }
    triangle {
      < -0.513663, 0.352979, 0.697557>,
      < -0.482771, 0.264547, 0.720046>,
      < -0.465637, 0.266065, 0.707066>
    }
    triangle {
      < -0.513663, 0.352979, 0.697557>,
      < -0.465637, 0.266065, 0.707066>,
      < -0.497216, 0.356463, 0.684078>
    }
    triangle {
      < -0.482771, 0.264547, 0.720046>,
      < -0.453420, 0.180524, 0.756912>,
      < -0.435634, 0.180175, 0.744751>
    }
    triangle {
      < -0.482771, 0.264547, 0.720046>,
      < -0.435634, 0.180175, 0.744751>,
      < -0.465637, 0.266065, 0.707066>
    }
    triangle {
      < -0.418372, 0.080196, 0.774026>,
      < -0.447271, 0.162926, 0.720325>,
      < -0.433572, 0.174275, 0.732486>
    }
    triangle {
      < -0.418372, 0.080196, 0.774026>,
      < -0.433572, 0.174275, 0.732486>,
      < -0.405275, 0.093268, 0.785068>
    }
    triangle {
      < -0.447271, 0.162926, 0.720325>,
      < -0.478585, 0.252568, 0.680993>,
      < -0.464234, 0.262049, 0.693974>
    }
    triangle {
      < -0.447271, 0.162926, 0.720325>,
      < -0.464234, 0.262049, 0.693974>,
      < -0.433572, 0.174275, 0.732486>
    }
    triangle {
      < -0.478585, 0.252568, 0.680993>,
      < -0.511543, 0.346915, 0.657000>,
      < -0.496505, 0.354430, 0.670481>
    }
    triangle {
      < -0.478585, 0.252568, 0.680993>,
      < -0.496505, 0.354430, 0.670481>,
      < -0.464234, 0.262049, 0.693974>
    }
    triangle {
      < -0.511543, 0.346915, 0.657000>,
      < -0.545334, 0.443644, 0.648936>,
      < -0.529592, 0.449143, 0.662585>
    }
    triangle {
      < -0.511543, 0.346915, 0.657000>,
      < -0.529592, 0.449143, 0.662585>,
      < -0.496505, 0.354430, 0.670481>
    }
    triangle {
      < -0.545334, 0.443644, 0.648936>,
      < -0.579125, 0.540372, 0.657000>,
      < -0.562679, 0.543856, 0.670481>
    }
    triangle {
      < -0.545334, 0.443644, 0.648936>,
      < -0.562679, 0.543856, 0.670481>,
      < -0.529592, 0.449143, 0.662585>
    }
    triangle {
      < -0.579125, 0.540372, 0.657000>,
      < -0.612085, 0.634719, 0.680993>,
      < -0.594952, 0.636236, 0.693974>
    }
    triangle {
      < -0.579125, 0.540372, 0.657000>,
      < -0.594952, 0.636236, 0.693974>,
      < -0.562679, 0.543856, 0.670481>
    }
    triangle {
      < -0.612085, 0.634719, 0.680993>,
      < -0.643402, 0.724360, 0.720325>,
      < -0.625616, 0.724010, 0.732486>
    }
    triangle {
      < -0.612085, 0.634719, 0.680993>,
      < -0.625616, 0.724010, 0.732486>,
      < -0.594952, 0.636236, 0.693974>
    }
    triangle {
      < -0.643402, 0.724360, 0.720325>,
      < -0.672304, 0.807089, 0.774026>,
      < -0.653916, 0.805015, 0.785068>
    }
    triangle {
      < -0.643402, 0.724360, 0.720325>,
      < -0.653916, 0.805015, 0.785068>,
      < -0.625616, 0.724010, 0.732486>
    }
    triangle {
      < -0.672304, 0.807089, 0.774026>,
      < -0.698080, 0.880869, 0.840774>,
      < -0.679155, 0.877257, 0.850426>
    }
    triangle {
      < -0.672304, 0.807089, 0.774026>,
      < -0.679155, 0.877257, 0.850426>,
      < -0.653916, 0.805015, 0.785068>
    }
    triangle {
      < -0.698080, 0.880869, 0.840774>,
      < -0.720096, 0.943882, 0.918927>,
      < -0.700712, 0.938958, 0.926950>
    }
    triangle {
      < -0.698080, 0.880869, 0.840774>,
      < -0.700712, 0.938958, 0.926950>,
      < -0.679155, 0.877257, 0.850426>
    }
    triangle {
      < -0.720096, 0.943882, 0.918927>,
      < -0.737809, 0.994578, 1.006560>,
      < -0.718056, 0.988597, 1.012756>
    }
    triangle {
      < -0.720096, 0.943882, 0.918927>,
      < -0.718056, 0.988597, 1.012756>,
      < -0.700712, 0.938958, 0.926950>
    }
    triangle {
      < -0.737809, 0.994578, 1.006560>,
      < -0.750783, 1.031708, 1.101514>,
      < -0.730759, 1.024954, 1.105732>
    }
    triangle {
      < -0.737809, 0.994578, 1.006560>,
      < -0.730759, 1.024954, 1.105732>,
      < -0.718056, 0.988597, 1.012756>
    }
    triangle {
      < -0.750783, 1.031708, 1.101514>,
      < -0.758699, 1.054358, 1.201452>,
      < -0.738510, 1.047131, 1.203587>
    }
    triangle {
      < -0.750783, 1.031708, 1.101514>,
      < -0.738510, 1.047131, 1.203587>,
      < -0.730759, 1.024954, 1.105732>
    }
    triangle {
      < -0.758699, 1.054358, 1.201452>,
      < -0.761361, 1.061969, 1.303913>,
      < -0.741117, 1.054584, 1.303913>
    }
    triangle {
      < -0.758699, 1.054358, 1.201452>,
      < -0.741117, 1.054584, 1.303913>,
      < -0.738510, 1.047131, 1.203587>
    }
    triangle {
      < -0.761361, 1.061969, 1.303913>,
      < -0.758705, 1.054355, 1.406374>,
      < -0.738516, 1.047129, 1.404239>
    }
    triangle {
      < -0.761361, 1.061969, 1.303913>,
      < -0.738516, 1.047129, 1.404239>,
      < -0.741117, 1.054584, 1.303913>
    }
    triangle {
      < -0.758705, 1.054355, 1.406374>,
      < -0.750795, 1.031704, 1.506312>,
      < -0.730771, 1.024949, 1.502095>
    }
    triangle {
      < -0.758705, 1.054355, 1.406374>,
      < -0.730771, 1.024949, 1.502095>,
      < -0.738516, 1.047129, 1.404239>
    }
    triangle {
      < -0.750795, 1.031704, 1.506312>,
      < -0.737827, 0.994572, 1.601266>,
      < -0.718073, 0.988591, 1.595070>
    }
    triangle {
      < -0.750795, 1.031704, 1.506312>,
      < -0.718073, 0.988591, 1.595070>,
      < -0.730771, 1.024949, 1.502095>
    }
    triangle {
      < -0.737827, 0.994572, 1.601266>,
      < -0.720119, 0.943874, 1.688898>,
      < -0.700735, 0.938950, 1.680877>
    }
    triangle {
      < -0.737827, 0.994572, 1.601266>,
      < -0.700735, 0.938950, 1.680877>,
      < -0.718073, 0.988591, 1.595070>
    }
    triangle {
      < -0.720119, 0.943874, 1.688898>,
      < -0.698108, 0.880859, 1.767051>,
      < -0.679182, 0.877248, 1.757401>
    }
    triangle {
      < -0.720119, 0.943874, 1.688898>,
      < -0.679182, 0.877248, 1.757401>,
      < -0.700735, 0.938950, 1.680877>
    }
    triangle {
      < -0.698108, 0.880859, 1.767051>,
      < -0.672336, 0.807078, 1.833800>,
      < -0.653947, 0.805004, 1.822759>
    }
    triangle {
      < -0.698108, 0.880859, 1.767051>,
      < -0.653947, 0.805004, 1.822759>,
      < -0.679182, 0.877248, 1.757401>
    }
    triangle {
      < -0.672336, 0.807078, 1.833800>,
      < -0.643437, 0.724348, 1.887501>,
      < -0.625650, 0.723998, 1.875341>
    }
    triangle {
      < -0.672336, 0.807078, 1.833800>,
      < -0.625650, 0.723998, 1.875341>,
      < -0.653947, 0.805004, 1.822759>
    }
    triangle {
      < -0.643437, 0.724348, 1.887501>,
      < -0.612123, 0.634705, 1.926832>,
      < -0.594989, 0.636224, 1.913853>
    }
    triangle {
      < -0.643437, 0.724348, 1.887501>,
      < -0.594989, 0.636224, 1.913853>,
      < -0.625650, 0.723998, 1.875341>
    }
    triangle {
      < -0.612123, 0.634705, 1.926832>,
      < -0.579165, 0.540358, 1.950825>,
      < -0.562717, 0.543842, 1.937346>
    }
    triangle {
      < -0.612123, 0.634705, 1.926832>,
      < -0.562717, 0.543842, 1.937346>,
      < -0.594989, 0.636224, 1.913853>
    }
    triangle {
      < -0.579165, 0.540358, 1.950825>,
      < -0.545374, 0.443630, 1.958889>,
      < -0.529631, 0.449129, 1.945242>
    }
    triangle {
      < -0.579165, 0.540358, 1.950825>,
      < -0.529631, 0.449129, 1.945242>,
      < -0.562717, 0.543842, 1.937346>
    }
    triangle {
      < -0.545374, 0.443630, 1.958889>,
      < -0.511583, 0.346901, 1.950825>,
      < -0.496544, 0.354417, 1.937346>
    }
    triangle {
      < -0.545374, 0.443630, 1.958889>,
      < -0.496544, 0.354417, 1.937346>,
      < -0.529631, 0.449129, 1.945242>
    }
    triangle {
      < -0.511583, 0.346901, 1.950825>,
      < -0.478623, 0.252555, 1.926832>,
      < -0.464271, 0.262036, 1.913853>
    }
    triangle {
      < -0.511583, 0.346901, 1.950825>,
      < -0.464271, 0.262036, 1.913853>,
      < -0.496544, 0.354417, 1.937346>
    }
    triangle {
      < -0.478623, 0.252555, 1.926832>,
      < -0.447307, 0.162913, 1.887501>,
      < -0.433607, 0.174263, 1.875341>
    }
    triangle {
      < -0.478623, 0.252555, 1.926832>,
      < -0.433607, 0.174263, 1.875341>,
      < -0.464271, 0.262036, 1.913853>
    }
    triangle {
      < -0.447307, 0.162913, 1.887501>,
      < -0.418404, 0.080184, 1.833800>,
      < -0.405307, 0.093257, 1.822759>
    }
    triangle {
      < -0.447307, 0.162913, 1.887501>,
      < -0.405307, 0.093257, 1.822759>,
      < -0.433607, 0.174263, 1.875341>
    }
    triangle {
      < -0.418404, 0.080184, 1.833800>,
      < -0.392628, 0.006405, 1.767051>,
      < -0.380067, 0.021015, 1.757401>
    }
    triangle {
      < -0.418404, 0.080184, 1.833800>,
      < -0.380067, 0.021015, 1.757401>,
      < -0.405307, 0.093257, 1.822759>
    }
    triangle {
      < -0.392628, 0.006405, 1.767051>,
      < -0.370612, -0.056609, 1.688898>,
      < -0.358510, -0.040685, 1.680877>
    }
    triangle {
      < -0.392628, 0.006405, 1.767051>,
      < -0.358510, -0.040685, 1.680877>,
      < -0.380067, 0.021015, 1.757401>
    }
    triangle {
      < -0.370612, -0.056609, 1.688898>,
      < -0.352899, -0.107305, 1.601266>,
      < -0.341167, -0.090325, 1.595070>
    }
    triangle {
      < -0.370612, -0.056609, 1.688898>,
      < -0.341167, -0.090325, 1.595070>,
      < -0.358510, -0.040685, 1.680877>
    }
    triangle {
      < -0.352899, -0.107305, 1.601266>,
      < -0.339925, -0.144435, 1.506312>,
      < -0.328463, -0.126681, 1.502095>
    }
    triangle {
      < -0.352899, -0.107305, 1.601266>,
      < -0.328463, -0.126681, 1.502095>,
      < -0.341167, -0.090325, 1.595070>
    }
    triangle {
      < -0.339925, -0.144435, 1.506312>,
      < -0.332009, -0.167084, 1.406374>,
      < -0.320712, -0.148859, 1.404239>
    }
    triangle {
      < -0.339925, -0.144435, 1.506312>,
      < -0.320712, -0.148859, 1.404239>,
      < -0.328463, -0.126681, 1.502095>
    }
    triangle {
      < -0.332009, -0.167084, 1.406374>,
      < -0.329347, -0.174696, 1.303913>,
      < -0.318105, -0.156312, 1.303913>
    }
    triangle {
      < -0.332009, -0.167084, 1.406374>,
      < -0.318105, -0.156312, 1.303913>,
      < -0.320712, -0.148859, 1.404239>
    }
    triangle {
      < -0.329347, -0.174696, 1.303913>,
      < -0.332003, -0.167082, 1.201452>,
      < -0.320706, -0.148856, 1.203587>
    }
    triangle {
      < -0.329347, -0.174696, 1.303913>,
      < -0.320706, -0.148856, 1.203587>,
      < -0.318105, -0.156312, 1.303913>
    }
    triangle {
      < -0.332003, -0.167082, 1.201452>,
      < -0.339913, -0.144430, 1.101514>,
      < -0.328451, -0.126677, 1.105732>
    }
    triangle {
      < -0.332003, -0.167082, 1.201452>,
      < -0.328451, -0.126677, 1.105732>,
      < -0.320706, -0.148856, 1.203587>
    }
    triangle {
      < -0.339913, -0.144430, 1.101514>,
      < -0.352881, -0.107298, 1.006560>,
      < -0.341149, -0.090319, 1.012756>
    }
    triangle {
      < -0.339913, -0.144430, 1.101514>,
      < -0.341149, -0.090319, 1.012756>,
      < -0.328451, -0.126677, 1.105732>
    }
    triangle {
      < -0.352881, -0.107298, 1.006560>,
      < -0.370589, -0.056601, 0.918927>,
      < -0.358488, -0.040677, 0.926950>
    }
    triangle {
      < -0.352881, -0.107298, 1.006560>,
      < -0.358488, -0.040677, 0.926950>,
      < -0.341149, -0.090319, 1.012756>
    }
    triangle {
      < -0.370589, -0.056601, 0.918927>,
      < -0.392600, 0.006414, 0.840774>,
      < -0.380040, 0.021025, 0.850426>
    }
    triangle {
      < -0.370589, -0.056601, 0.918927>,
      < -0.380040, 0.021025, 0.850426>,
      < -0.358488, -0.040677, 0.926950>
    }
    triangle {
      < -0.392600, 0.006414, 0.840774>,
      < -0.418372, 0.080196, 0.774026>,
      < -0.405275, 0.093268, 0.785068>
    }
    triangle {
      < -0.392600, 0.006414, 0.840774>,
      < -0.405275, 0.093268, 0.785068>,
      < -0.380040, 0.021025, 0.850426>
    }
    triangle {
      < -0.452509, 0.076768, 0.785067>,
      < -0.480805, 0.157774, 0.732484>,
      < -0.463019, 0.157425, 0.720324>
    }
    triangle {
      < -0.452509, 0.076768, 0.785067>,
      < -0.463019, 0.157425, 0.720324>,
      < -0.434120, 0.074694, 0.774025>
    }
    triangle {
      < -0.480805, 0.157774, 0.732484>,
      < -0.511467, 0.245549, 0.693973>,
      < -0.494333, 0.247067, 0.680993>
    }
    triangle {
      < -0.480805, 0.157774, 0.732484>,
      < -0.494333, 0.247067, 0.680993>,
      < -0.463019, 0.157425, 0.720324>
    }
    triangle {
      < -0.511467, 0.245549, 0.693973>,
      < -0.543738, 0.337930, 0.670480>,
      < -0.527291, 0.341414, 0.657000>
    }
    triangle {
      < -0.511467, 0.245549, 0.693973>,
      < -0.527291, 0.341414, 0.657000>,
      < -0.494333, 0.247067, 0.680993>
    }
    triangle {
      < -0.543738, 0.337930, 0.670480>,
      < -0.576825, 0.432643, 0.662584>,
      < -0.561082, 0.438142, 0.648936>
    }
    triangle {
      < -0.543738, 0.337930, 0.670480>,
      < -0.561082, 0.438142, 0.648936>,
      < -0.527291, 0.341414, 0.657000>
    }
    triangle {
      < -0.576825, 0.432643, 0.662584>,
      < -0.609912, 0.527355, 0.670480>,
      < -0.594873, 0.534871, 0.657000>
    }
    triangle {
      < -0.576825, 0.432643, 0.662584>,
      < -0.594873, 0.534871, 0.657000>,
      < -0.561082, 0.438142, 0.648936>
    }
    triangle {
      < -0.609912, 0.527355, 0.670480>,
      < -0.642185, 0.619736, 0.693973>,
      < -0.627833, 0.629217, 0.680993>
    }
    triangle {
      < -0.609912, 0.527355, 0.670480>,
      < -0.627833, 0.629217, 0.680993>,
      < -0.594873, 0.534871, 0.657000>
    }
    triangle {
      < -0.642185, 0.619736, 0.693973>,
      < -0.672849, 0.707510, 0.732484>,
      < -0.659149, 0.718859, 0.720324>
    }
    triangle {
      < -0.642185, 0.619736, 0.693973>,
      < -0.659149, 0.718859, 0.720324>,
      < -0.627833, 0.629217, 0.680993>
    }
    triangle {
      < -0.672849, 0.707510, 0.732484>,
      < -0.701149, 0.788515, 0.785067>,
      < -0.688051, 0.801588, 0.774025>
    }
    triangle {
      < -0.672849, 0.707510, 0.732484>,
      < -0.688051, 0.801588, 0.774025>,
      < -0.659149, 0.718859, 0.720324>
    }
    triangle {
      < -0.701149, 0.788515, 0.785067>,
      < -0.726388, 0.860757, 0.850424>,
      < -0.713828, 0.875368, 0.840774>
    }
    triangle {
      < -0.701149, 0.788515, 0.785067>,
      < -0.713828, 0.875368, 0.840774>,
      < -0.688051, 0.801588, 0.774025>
    }
    triangle {
      < -0.726388, 0.860757, 0.850424>,
      < -0.747945, 0.922458, 0.926949>,
      < -0.735843, 0.938381, 0.918927>
    }
    triangle {
      < -0.726388, 0.860757, 0.850424>,
      < -0.735843, 0.938381, 0.918927>,
      < -0.713828, 0.875368, 0.840774>
    }
    triangle {
      < -0.747945, 0.922458, 0.926949>,
      < -0.765289, 0.972097, 1.012755>,
      < -0.753556, 0.989077, 1.006559>
    }
    triangle {
      < -0.747945, 0.922458, 0.926949>,
      < -0.753556, 0.989077, 1.006559>,
      < -0.735843, 0.938381, 0.918927>
    }
    triangle {
      < -0.765289, 0.972097, 1.012755>,
      < -0.777993, 1.008453, 1.105731>,
      < -0.766531, 1.026207, 1.101514>
    }
    triangle {
      < -0.765289, 0.972097, 1.012755>,
      < -0.766531, 1.026207, 1.101514>,
      < -0.753556, 0.989077, 1.006559>
    }
    triangle {
      < -0.777993, 1.008453, 1.105731>,
      < -0.785744, 1.030631, 1.203586>,
      < -0.774446, 1.048856, 1.201452>
    }
    triangle {
      < -0.777993, 1.008453, 1.105731>,
      < -0.774446, 1.048856, 1.201452>,
      < -0.766531, 1.026207, 1.101514>
    }
    triangle {
      < -0.785744, 1.030631, 1.203586>,
      < -0.788351, 1.038084, 1.303912>,
      < -0.777109, 1.056468, 1.303912>
    }
    triangle {
      < -0.785744, 1.030631, 1.203586>,
      < -0.777109, 1.056468, 1.303912>,
      < -0.774446, 1.048856, 1.201452>
    }
    triangle {
      < -0.788351, 1.038084, 1.303912>,
      < -0.785750, 1.030629, 1.404238>,
      < -0.774453, 1.048854, 1.406373>
    }
    triangle {
      < -0.788351, 1.038084, 1.303912>,
      < -0.774453, 1.048854, 1.406373>,
      < -0.777109, 1.056468, 1.303912>
    }
    triangle {
      < -0.785750, 1.030629, 1.404238>,
      < -0.778005, 1.008449, 1.502093>,
      < -0.766543, 1.026202, 1.506311>
    }
    triangle {
      < -0.785750, 1.030629, 1.404238>,
      < -0.766543, 1.026202, 1.506311>,
      < -0.774453, 1.048854, 1.406373>
    }
    triangle {
      < -0.778005, 1.008449, 1.502093>,
      < -0.765307, 0.972091, 1.595069>,
      < -0.753574, 0.989071, 1.601266>
    }
    triangle {
      < -0.778005, 1.008449, 1.502093>,
      < -0.753574, 0.989071, 1.601266>,
      < -0.766543, 1.026202, 1.506311>
    }
    triangle {
      < -0.765307, 0.972091, 1.595069>,
      < -0.747968, 0.922450, 1.680876>,
      < -0.735867, 0.938373, 1.688898>
    }
    triangle {
      < -0.765307, 0.972091, 1.595069>,
      < -0.735867, 0.938373, 1.688898>,
      < -0.753574, 0.989071, 1.601266>
    }
    triangle {
      < -0.747968, 0.922450, 1.680876>,
      < -0.726416, 0.860747, 1.757400>,
      < -0.713856, 0.875358, 1.767051>
    }
    triangle {
      < -0.747968, 0.922450, 1.680876>,
      < -0.713856, 0.875358, 1.767051>,
      < -0.735867, 0.938373, 1.688898>
    }
    triangle {
      < -0.726416, 0.860747, 1.757400>,
      < -0.701181, 0.788504, 1.822758>,
      < -0.688084, 0.801576, 1.833800>
    }
    triangle {
      < -0.726416, 0.860747, 1.757400>,
      < -0.688084, 0.801576, 1.833800>,
      < -0.713856, 0.875358, 1.767051>
    }
    triangle {
      < -0.701181, 0.788504, 1.822758>,
      < -0.672884, 0.707497, 1.875340>,
      < -0.659185, 0.718846, 1.887501>
    }
    triangle {
      < -0.701181, 0.788504, 1.822758>,
      < -0.659185, 0.718846, 1.887501>,
      < -0.688084, 0.801576, 1.833800>
    }
    triangle {
      < -0.672884, 0.707497, 1.875340>,
      < -0.642222, 0.619723, 1.913852>,
      < -0.627870, 0.629204, 1.926832>
    }
    triangle {
      < -0.672884, 0.707497, 1.875340>,
      < -0.627870, 0.629204, 1.926832>,
      < -0.659185, 0.718846, 1.887501>
    }
    triangle {
      < -0.642222, 0.619723, 1.913852>,
      < -0.609951, 0.527342, 1.937345>,
      < -0.594912, 0.534857, 1.950825>
    }
    triangle {
      < -0.642222, 0.619723, 1.913852>,
      < -0.594912, 0.534857, 1.950825>,
      < -0.627870, 0.629204, 1.926832>
    }
    triangle {
      < -0.609951, 0.527342, 1.937345>,
      < -0.576864, 0.432629, 1.945240>,
      < -0.561122, 0.438129, 1.958889>
    }
    triangle {
      < -0.609951, 0.527342, 1.937345>,
      < -0.561122, 0.438129, 1.958889>,
      < -0.594912, 0.534857, 1.950825>
    }
    triangle {
      < -0.576864, 0.432629, 1.945240>,
      < -0.543777, 0.337916, 1.937345>,
      < -0.527330, 0.341400, 1.950825>
    }
    triangle {
      < -0.576864, 0.432629, 1.945240>,
      < -0.527330, 0.341400, 1.950825>,
      < -0.561122, 0.438129, 1.958889>
    }
    triangle {
      < -0.543777, 0.337916, 1.937345>,
      < -0.511504, 0.245536, 1.913852>,
      < -0.494371, 0.247054, 1.926832>
    }
    triangle {
      < -0.543777, 0.337916, 1.937345>,
      < -0.494371, 0.247054, 1.926832>,
      < -0.527330, 0.341400, 1.950825>
    }
    triangle {
      < -0.511504, 0.245536, 1.913852>,
      < -0.480840, 0.157762, 1.875340>,
      < -0.463054, 0.157412, 1.887501>
    }
    triangle {
      < -0.511504, 0.245536, 1.913852>,
      < -0.463054, 0.157412, 1.887501>,
      < -0.494371, 0.247054, 1.926832>
    }
    triangle {
      < -0.480840, 0.157762, 1.875340>,
      < -0.452540, 0.076757, 1.822758>,
      < -0.434152, 0.074683, 1.833800>
    }
    triangle {
      < -0.480840, 0.157762, 1.875340>,
      < -0.434152, 0.074683, 1.833800>,
      < -0.463054, 0.157412, 1.887501>
    }
    triangle {
      < -0.452540, 0.076757, 1.822758>,
      < -0.427301, 0.004515, 1.757400>,
      < -0.408376, 0.000903, 1.767051>
    }
    triangle {
      < -0.452540, 0.076757, 1.822758>,
      < -0.408376, 0.000903, 1.767051>,
      < -0.434152, 0.074683, 1.833800>
    }
    triangle {
      < -0.427301, 0.004515, 1.757400>,
      < -0.405744, -0.057186, 1.680876>,
      < -0.386360, -0.062110, 1.688898>
    }
    triangle {
      < -0.427301, 0.004515, 1.757400>,
      < -0.386360, -0.062110, 1.688898>,
      < -0.408376, 0.000903, 1.767051>
    }
    triangle {
      < -0.405744, -0.057186, 1.680876>,
      < -0.388400, -0.106825, 1.595069>,
      < -0.368647, -0.112806, 1.601266>
    }
    triangle {
      < -0.405744, -0.057186, 1.680876>,
      < -0.368647, -0.112806, 1.601266>,
      < -0.386360, -0.062110, 1.688898>
    }
    triangle {
      < -0.388400, -0.106825, 1.595069>,
      < -0.375696, -0.143181, 1.502093>,
      < -0.355673, -0.149936, 1.506311>
    }
    triangle {
      < -0.388400, -0.106825, 1.595069>,
      < -0.355673, -0.149936, 1.506311>,
      < -0.368647, -0.112806, 1.601266>
    }
    triangle {
      < -0.375696, -0.143181, 1.502093>,
      < -0.367945, -0.165359, 1.404238>,
      < -0.347757, -0.172585, 1.406373>
    }
    triangle {
      < -0.375696, -0.143181, 1.502093>,
      < -0.347757, -0.172585, 1.406373>,
      < -0.355673, -0.149936, 1.506311>
    }
    triangle {
      < -0.367945, -0.165359, 1.404238>,
      < -0.365338, -0.172812, 1.303912>,
      < -0.345094, -0.180197, 1.303912>
    }
    triangle {
      < -0.367945, -0.165359, 1.404238>,
      < -0.345094, -0.180197, 1.303912>,
      < -0.347757, -0.172585, 1.406373>
    }
    triangle {
      < -0.365338, -0.172812, 1.303912>,
      < -0.367939, -0.165357, 1.203586>,
      < -0.347751, -0.172583, 1.201452>
    }
    triangle {
      < -0.365338, -0.172812, 1.303912>,
      < -0.347751, -0.172583, 1.201452>,
      < -0.345094, -0.180197, 1.303912>
    }
    triangle {
      < -0.367939, -0.165357, 1.203586>,
      < -0.375684, -0.143177, 1.105731>,
      < -0.355660, -0.149931, 1.101514>
    }
    triangle {
      < -0.367939, -0.165357, 1.203586>,
      < -0.355660, -0.149931, 1.101514>,
      < -0.347751, -0.172583, 1.201452>
    }
    triangle {
      < -0.375684, -0.143177, 1.105731>,
      < -0.388382, -0.106819, 1.012755>,
      < -0.368629, -0.112800, 1.006559>
    }
    triangle {
      < -0.375684, -0.143177, 1.105731>,
      < -0.368629, -0.112800, 1.006559>,
      < -0.355660, -0.149931, 1.101514>
    }
    triangle {
      < -0.388382, -0.106819, 1.012755>,
      < -0.405721, -0.057178, 0.926949>,
      < -0.386336, -0.062102, 0.918927>
    }
    triangle {
      < -0.388382, -0.106819, 1.012755>,
      < -0.386336, -0.062102, 0.918927>,
      < -0.368629, -0.112800, 1.006559>
    }
    triangle {
      < -0.405721, -0.057178, 0.926949>,
      < -0.427273, 0.004524, 0.850424>,
      < -0.408347, 0.000913, 0.840774>
    }
    triangle {
      < -0.405721, -0.057178, 0.926949>,
      < -0.408347, 0.000913, 0.840774>,
      < -0.386336, -0.062102, 0.918927>
    }
    triangle {
      < -0.427273, 0.004524, 0.850424>,
      < -0.452509, 0.076768, 0.785067>,
      < -0.434120, 0.074694, 0.774025>
    }
    triangle {
      < -0.427273, 0.004524, 0.850424>,
      < -0.434120, 0.074694, 0.774025>,
      < -0.408347, 0.000913, 0.840774>
    }
    triangle {
      < -0.442081, 0.097480, 0.807246>,
      < -0.469168, 0.175023, 0.756911>,
      < -0.482867, 0.163674, 0.744750>
    }
    triangle {
      < -0.442081, 0.097480, 0.807246>,
      < -0.482867, 0.163674, 0.744750>,
      < -0.455178, 0.084407, 0.796204>
    }
    triangle {
      < -0.469168, 0.175023, 0.756911>,
      < -0.498519, 0.259046, 0.720046>,
      < -0.512870, 0.249565, 0.707065>
    }
    triangle {
      < -0.469168, 0.175023, 0.756911>,
      < -0.512870, 0.249565, 0.707065>,
      < -0.482867, 0.163674, 0.744750>
    }
    triangle {
      < -0.498519, 0.259046, 0.720046>,
      < -0.529411, 0.347478, 0.697557>,
      < -0.544449, 0.339963, 0.684077>
    }
    triangle {
      < -0.498519, 0.259046, 0.720046>,
      < -0.544449, 0.339963, 0.684077>,
      < -0.512870, 0.249565, 0.707065>
    }
    triangle {
      < -0.529411, 0.347478, 0.697557>,
      < -0.561083, 0.438142, 0.689999>,
      < -0.576825, 0.432643, 0.676350>
    }
    triangle {
      < -0.529411, 0.347478, 0.697557>,
      < -0.576825, 0.432643, 0.676350>,
      < -0.544449, 0.339963, 0.684077>
    }
    triangle {
      < -0.561083, 0.438142, 0.689999>,
      < -0.592756, 0.528806, 0.697557>,
      < -0.609202, 0.525322, 0.684077>
    }
    triangle {
      < -0.561083, 0.438142, 0.689999>,
      < -0.609202, 0.525322, 0.684077>,
      < -0.576825, 0.432643, 0.676350>
    }
    triangle {
      < -0.592756, 0.528806, 0.697557>,
      < -0.623649, 0.617238, 0.720046>,
      < -0.640782, 0.615720, 0.707065>
    }
    triangle {
      < -0.592756, 0.528806, 0.697557>,
      < -0.640782, 0.615720, 0.707065>,
      < -0.609202, 0.525322, 0.684077>
    }
    triangle {
      < -0.623649, 0.617238, 0.720046>,
      < -0.653002, 0.701259, 0.756911>,
      < -0.670788, 0.701609, 0.744750>
    }
    triangle {
      < -0.623649, 0.617238, 0.720046>,
      < -0.670788, 0.701609, 0.744750>,
      < -0.640782, 0.615720, 0.707065>
    }
    triangle {
      < -0.653002, 0.701259, 0.756911>,
      < -0.680093, 0.778802, 0.807246>,
      < -0.698481, 0.780876, 0.796204>
    }
    triangle {
      < -0.653002, 0.701259, 0.756911>,
      < -0.698481, 0.780876, 0.796204>,
      < -0.670788, 0.701609, 0.744750>
    }
    triangle {
      < -0.680093, 0.778802, 0.807246>,
      < -0.704253, 0.847956, 0.869810>,
      < -0.723178, 0.851567, 0.860159>
    }
    triangle {
      < -0.680093, 0.778802, 0.807246>,
      < -0.723178, 0.851567, 0.860159>,
      < -0.698481, 0.780876, 0.796204>
    }
    triangle {
      < -0.704253, 0.847956, 0.869810>,
      < -0.724888, 0.907019, 0.943063>,
      < -0.744272, 0.911943, 0.935040>
    }
    triangle {
      < -0.704253, 0.847956, 0.869810>,
      < -0.744272, 0.911943, 0.935040>,
      < -0.723178, 0.851567, 0.860159>
    }
    triangle {
      < -0.724888, 0.907019, 0.943063>,
      < -0.741491, 0.954536, 1.025201>,
      < -0.761244, 0.960517, 1.019005>
    }
    triangle {
      < -0.724888, 0.907019, 0.943063>,
      < -0.761244, 0.960517, 1.019005>,
      < -0.744272, 0.911943, 0.935040>
    }
    triangle {
      < -0.741491, 0.954536, 1.025201>,
      < -0.753652, 0.989339, 1.114203>,
      < -0.773675, 0.996093, 1.109985>
    }
    triangle {
      < -0.741491, 0.954536, 1.025201>,
      < -0.773675, 0.996093, 1.109985>,
      < -0.761244, 0.960517, 1.019005>
    }
    triangle {
      < -0.753652, 0.989339, 1.114203>,
      < -0.761071, 1.010568, 1.207875>,
      < -0.781260, 1.017794, 1.205740>
    }
    triangle {
      < -0.753652, 0.989339, 1.114203>,
      < -0.781260, 1.017794, 1.205740>,
      < -0.773675, 0.996093, 1.109985>
    }
    triangle {
      < -0.761071, 1.010568, 1.207875>,
      < -0.763567, 1.017703, 1.303912>,
      < -0.783811, 1.025088, 1.303912>
    }
    triangle {
      < -0.761071, 1.010568, 1.207875>,
      < -0.783811, 1.025088, 1.303912>,
      < -0.781260, 1.017794, 1.205740>
    }
    triangle {
      < -0.763567, 1.017703, 1.303912>,
      < -0.761077, 1.010566, 1.399950>,
      < -0.781265, 1.017792, 1.402084>
    }
    triangle {
      < -0.763567, 1.017703, 1.303912>,
      < -0.781265, 1.017792, 1.402084>,
      < -0.783811, 1.025088, 1.303912>
    }
    triangle {
      < -0.761077, 1.010566, 1.399950>,
      < -0.753663, 0.989335, 1.493622>,
      < -0.773687, 0.996089, 1.497839>
    }
    triangle {
      < -0.761077, 1.010566, 1.399950>,
      < -0.773687, 0.996089, 1.497839>,
      < -0.781265, 1.017792, 1.402084>
    }
    triangle {
      < -0.753663, 0.989335, 1.493622>,
      < -0.741508, 0.954531, 1.582623>,
      < -0.761261, 0.960511, 1.588819>
    }
    triangle {
      < -0.753663, 0.989335, 1.493622>,
      < -0.761261, 0.960511, 1.588819>,
      < -0.773687, 0.996089, 1.497839>
    }
    triangle {
      < -0.741508, 0.954531, 1.582623>,
      < -0.724910, 0.907011, 1.664762>,
      < -0.744295, 0.911936, 1.672784>
    }
    triangle {
      < -0.741508, 0.954531, 1.582623>,
      < -0.744295, 0.911936, 1.672784>,
      < -0.761261, 0.960511, 1.588819>
    }
    triangle {
      < -0.724910, 0.907011, 1.664762>,
      < -0.704279, 0.847947, 1.738015>,
      < -0.723205, 0.851558, 1.747665>
    }
    triangle {
      < -0.724910, 0.907011, 1.664762>,
      < -0.723205, 0.851558, 1.747665>,
      < -0.744295, 0.911936, 1.672784>
    }
    triangle {
      < -0.704279, 0.847947, 1.738015>,
      < -0.680123, 0.778791, 1.800579>,
      < -0.698512, 0.780865, 1.811620>
    }
    triangle {
      < -0.704279, 0.847947, 1.738015>,
      < -0.698512, 0.780865, 1.811620>,
      < -0.723205, 0.851558, 1.747665>
    }
    triangle {
      < -0.680123, 0.778791, 1.800579>,
      < -0.653035, 0.701248, 1.850914>,
      < -0.670822, 0.701597, 1.863074>
    }
    triangle {
      < -0.680123, 0.778791, 1.800579>,
      < -0.670822, 0.701597, 1.863074>,
      < -0.698512, 0.780865, 1.811620>
    }
    triangle {
      < -0.653035, 0.701248, 1.850914>,
      < -0.623685, 0.617225, 1.887779>,
      < -0.640819, 0.615707, 1.900759>
    }
    triangle {
      < -0.653035, 0.701248, 1.850914>,
      < -0.640819, 0.615707, 1.900759>,
      < -0.670822, 0.701597, 1.863074>
    }
    triangle {
      < -0.623685, 0.617225, 1.887779>,
      < -0.592793, 0.528793, 1.910268>,
      < -0.609240, 0.525309, 1.923748>
    }
    triangle {
      < -0.623685, 0.617225, 1.887779>,
      < -0.609240, 0.525309, 1.923748>,
      < -0.640819, 0.615707, 1.900759>
    }
    triangle {
      < -0.592793, 0.528793, 1.910268>,
      < -0.561120, 0.438129, 1.917826>,
      < -0.576864, 0.432629, 1.931474>
    }
    triangle {
      < -0.592793, 0.528793, 1.910268>,
      < -0.576864, 0.432629, 1.931474>,
      < -0.609240, 0.525309, 1.923748>
    }
    triangle {
      < -0.561120, 0.438129, 1.917826>,
      < -0.529448, 0.347465, 1.910268>,
      < -0.544487, 0.339949, 1.923748>
    }
    triangle {
      < -0.561120, 0.438129, 1.917826>,
      < -0.544487, 0.339949, 1.923748>,
      < -0.576864, 0.432629, 1.931474>
    }
    triangle {
      < -0.529448, 0.347465, 1.910268>,
      < -0.498554, 0.259033, 1.887779>,
      < -0.512907, 0.249552, 1.900759>
    }
    triangle {
      < -0.529448, 0.347465, 1.910268>,
      < -0.512907, 0.249552, 1.900759>,
      < -0.544487, 0.339949, 1.923748>
    }
    triangle {
      < -0.498554, 0.259033, 1.887779>,
      < -0.469201, 0.175012, 1.850914>,
      < -0.482901, 0.163662, 1.863074>
    }
    triangle {
      < -0.498554, 0.259033, 1.887779>,
      < -0.482901, 0.163662, 1.863074>,
      < -0.512907, 0.249552, 1.900759>
    }
    triangle {
      < -0.469201, 0.175012, 1.850914>,
      < -0.442111, 0.097469, 1.800579>,
      < -0.455208, 0.084396, 1.811620>
    }
    triangle {
      < -0.469201, 0.175012, 1.850914>,
      < -0.455208, 0.084396, 1.811620>,
      < -0.482901, 0.163662, 1.863074>
    }
    triangle {
      < -0.442111, 0.097469, 1.800579>,
      < -0.417950, 0.028315, 1.738015>,
      < -0.430511, 0.013705, 1.747665>
    }
    triangle {
      < -0.442111, 0.097469, 1.800579>,
      < -0.430511, 0.013705, 1.747665>,
      < -0.455208, 0.084396, 1.811620>
    }
    triangle {
      < -0.417950, 0.028315, 1.738015>,
      < -0.397315, -0.030748, 1.664762>,
      < -0.409417, -0.046672, 1.672784>
    }
    triangle {
      < -0.417950, 0.028315, 1.738015>,
      < -0.409417, -0.046672, 1.672784>,
      < -0.430511, 0.013705, 1.747665>
    }
    triangle {
      < -0.397315, -0.030748, 1.664762>,
      < -0.380712, -0.078266, 1.582623>,
      < -0.392445, -0.095245, 1.588819>
    }
    triangle {
      < -0.397315, -0.030748, 1.664762>,
      < -0.392445, -0.095245, 1.588819>,
      < -0.409417, -0.046672, 1.672784>
    }
    triangle {
      < -0.380712, -0.078266, 1.582623>,
      < -0.368552, -0.113068, 1.493622>,
      < -0.380014, -0.130821, 1.497839>
    }
    triangle {
      < -0.380712, -0.078266, 1.582623>,
      < -0.380014, -0.130821, 1.497839>,
      < -0.392445, -0.095245, 1.588819>
    }
    triangle {
      < -0.368552, -0.113068, 1.493622>,
      < -0.361132, -0.134297, 1.399950>,
      < -0.372430, -0.152523, 1.402084>
    }
    triangle {
      < -0.368552, -0.113068, 1.493622>,
      < -0.372430, -0.152523, 1.402084>,
      < -0.380014, -0.130821, 1.497839>
    }
    triangle {
      < -0.361132, -0.134297, 1.399950>,
      < -0.358637, -0.141432, 1.303912>,
      < -0.369878, -0.159816, 1.303912>
    }
    triangle {
      < -0.361132, -0.134297, 1.399950>,
      < -0.369878, -0.159816, 1.303912>,
      < -0.372430, -0.152523, 1.402084>
    }
    triangle {
      < -0.358637, -0.141432, 1.303912>,
      < -0.361126, -0.134295, 1.207875>,
      < -0.372424, -0.152521, 1.205740>
    }
    triangle {
      < -0.358637, -0.141432, 1.303912>,
      < -0.372424, -0.152521, 1.205740>,
      < -0.369878, -0.159816, 1.303912>
    }
    triangle {
      < -0.361126, -0.134295, 1.207875>,
      < -0.368540, -0.113064, 1.114203>,
      < -0.380002, -0.130817, 1.109985>
    }
    triangle {
      < -0.361126, -0.134295, 1.207875>,
      < -0.380002, -0.130817, 1.109985>,
      < -0.372424, -0.152521, 1.205740>
    }
    triangle {
      < -0.368540, -0.113064, 1.114203>,
      < -0.380696, -0.078260, 1.025201>,
      < -0.392428, -0.095239, 1.019005>
    }
    triangle {
      < -0.368540, -0.113064, 1.114203>,
      < -0.392428, -0.095239, 1.019005>,
      < -0.380002, -0.130817, 1.109985>
    }
    triangle {
      < -0.380696, -0.078260, 1.025201>,
      < -0.397293, -0.030740, 0.943063>,
      < -0.409394, -0.046664, 0.935040>
    }
    triangle {
      < -0.380696, -0.078260, 1.025201>,
      < -0.409394, -0.046664, 0.935040>,
      < -0.392428, -0.095239, 1.019005>
    }
    triangle {
      < -0.397293, -0.030740, 0.943063>,
      < -0.417924, 0.028324, 0.869810>,
      < -0.430484, 0.013714, 0.860159>
    }
    triangle {
      < -0.397293, -0.030740, 0.943063>,
      < -0.430484, 0.013714, 0.860159>,
      < -0.409394, -0.046664, 0.935040>
    }
    triangle {
      < -0.417924, 0.028324, 0.869810>,
      < -0.442081, 0.097480, 0.807246>,
      < -0.455178, 0.084407, 0.796204>
    }
    triangle {
      < -0.417924, 0.028324, 0.869810>,
      < -0.455178, 0.084407, 0.796204>,
      < -0.430484, 0.013714, 0.860159>
    }
    texture {steer1}
  }
  // steer2
  union {
    triangle {
      < -0.567550, 0.050430, 1.246275>,
      < -0.539210, 0.060330, 1.246276>,
      < -0.537716, 0.056047, 1.303910>
    }
    triangle {
      < -0.567550, 0.050430, 1.246275>,
      < -0.537716, 0.056047, 1.303910>,
      < -0.566056, 0.046147, 1.303910>
    }
    triangle {
      < -0.571999, 0.063171, 1.190060>,
      < -0.543659, 0.073071, 1.190061>,
      < -0.539210, 0.060330, 1.246276>
    }
    triangle {
      < -0.571999, 0.063171, 1.190060>,
      < -0.539210, 0.060330, 1.246276>,
      < -0.567550, 0.050430, 1.246275>
    }
    triangle {
      < -0.579294, 0.084058, 1.136648>,
      < -0.550954, 0.093958, 1.136649>,
      < -0.543659, 0.073071, 1.190061>
    }
    triangle {
      < -0.579294, 0.084058, 1.136648>,
      < -0.543659, 0.073071, 1.190061>,
      < -0.571999, 0.063171, 1.190060>
    }
    triangle {
      < -0.589254, 0.112575, 1.087355>,
      < -0.560914, 0.122476, 1.087356>,
      < -0.550954, 0.093958, 1.136649>
    }
    triangle {
      < -0.589254, 0.112575, 1.087355>,
      < -0.550954, 0.093958, 1.136649>,
      < -0.579294, 0.084058, 1.136648>
    }
    triangle {
      < -0.601635, 0.148021, 1.043394>,
      < -0.573295, 0.157922, 1.043395>,
      < -0.560914, 0.122476, 1.087356>
    }
    triangle {
      < -0.601635, 0.148021, 1.043394>,
      < -0.560914, 0.122476, 1.087356>,
      < -0.589254, 0.112575, 1.087355>
    }
    triangle {
      < -0.616132, 0.189523, 1.005848>,
      < -0.587792, 0.199423, 1.005849>,
      < -0.573295, 0.157922, 1.043395>
    }
    triangle {
      < -0.616132, 0.189523, 1.005848>,
      < -0.573295, 0.157922, 1.043395>,
      < -0.601635, 0.148021, 1.043394>
    }
    triangle {
      < -0.632388, 0.236059, 0.975641>,
      < -0.604048, 0.245959, 0.975642>,
      < -0.587792, 0.199423, 1.005849>
    }
    triangle {
      < -0.632388, 0.236059, 0.975641>,
      < -0.587792, 0.199423, 1.005849>,
      < -0.616132, 0.189523, 1.005848>
    }
    triangle {
      < -0.650002, 0.286483, 0.953517>,
      < -0.621662, 0.296383, 0.953518>,
      < -0.604048, 0.245959, 0.975642>
    }
    triangle {
      < -0.650002, 0.286483, 0.953517>,
      < -0.604048, 0.245959, 0.975642>,
      < -0.632388, 0.236059, 0.975641>
    }
    triangle {
      < -0.668541, 0.339553, 0.940021>,
      < -0.640201, 0.349453, 0.940022>,
      < -0.621662, 0.296383, 0.953518>
    }
    triangle {
      < -0.668541, 0.339553, 0.940021>,
      < -0.621662, 0.296383, 0.953518>,
      < -0.650002, 0.286483, 0.953517>
    }
    triangle {
      < -0.687548, 0.393963, 0.935485>,
      < -0.659208, 0.403863, 0.935486>,
      < -0.640201, 0.349453, 0.940022>
    }
    triangle {
      < -0.687548, 0.393963, 0.935485>,
      < -0.640201, 0.349453, 0.940022>,
      < -0.668541, 0.339553, 0.940021>
    }
    triangle {
      < -0.706556, 0.448372, 0.940021>,
      < -0.678216, 0.458273, 0.940022>,
      < -0.659208, 0.403863, 0.935486>
    }
    triangle {
      < -0.706556, 0.448372, 0.940021>,
      < -0.659208, 0.403863, 0.935486>,
      < -0.687548, 0.393963, 0.935485>
    }
    triangle {
      < -0.725096, 0.501442, 0.953517>,
      < -0.696756, 0.511343, 0.953518>,
      < -0.678216, 0.458273, 0.940022>
    }
    triangle {
      < -0.725096, 0.501442, 0.953517>,
      < -0.678216, 0.458273, 0.940022>,
      < -0.706556, 0.448372, 0.940021>
    }
    triangle {
      < -0.742711, 0.551866, 0.975641>,
      < -0.714371, 0.561766, 0.975642>,
      < -0.696756, 0.511343, 0.953518>
    }
    triangle {
      < -0.742711, 0.551866, 0.975641>,
      < -0.696756, 0.511343, 0.953518>,
      < -0.725096, 0.501442, 0.953517>
    }
    triangle {
      < -0.758969, 0.598401, 1.005848>,
      < -0.730629, 0.608301, 1.005849>,
      < -0.714371, 0.561766, 0.975642>
    }
    triangle {
      < -0.758969, 0.598401, 1.005848>,
      < -0.714371, 0.561766, 0.975642>,
      < -0.742711, 0.551866, 0.975641>
    }
    triangle {
      < -0.773468, 0.639902, 1.043394>,
      < -0.745128, 0.649802, 1.043395>,
      < -0.730629, 0.608301, 1.005849>
    }
    triangle {
      < -0.773468, 0.639902, 1.043394>,
      < -0.730629, 0.608301, 1.005849>,
      < -0.758969, 0.598401, 1.005848>
    }
    triangle {
      < -0.785852, 0.675347, 1.087355>,
      < -0.757512, 0.685247, 1.087356>,
      < -0.745128, 0.649802, 1.043395>
    }
    triangle {
      < -0.785852, 0.675347, 1.087355>,
      < -0.745128, 0.649802, 1.043395>,
      < -0.773468, 0.639902, 1.043394>
    }
    triangle {
      < -0.795815, 0.703863, 1.136648>,
      < -0.767475, 0.713764, 1.136649>,
      < -0.757512, 0.685247, 1.087356>
    }
    triangle {
      < -0.795815, 0.703863, 1.136648>,
      < -0.757512, 0.685247, 1.087356>,
      < -0.785852, 0.675347, 1.087355>
    }
    triangle {
      < -0.803113, 0.724749, 1.190060>,
      < -0.774773, 0.734649, 1.190061>,
      < -0.767475, 0.713764, 1.136649>
    }
    triangle {
      < -0.803113, 0.724749, 1.190060>,
      < -0.767475, 0.713764, 1.136649>,
      < -0.795815, 0.703863, 1.136648>
    }
    triangle {
      < -0.807566, 0.737489, 1.246275>,
      < -0.779226, 0.747390, 1.246276>,
      < -0.774773, 0.734649, 1.190061>
    }
    triangle {
      < -0.807566, 0.737489, 1.246275>,
      < -0.774773, 0.734649, 1.190061>,
      < -0.803113, 0.724749, 1.190060>
    }
    triangle {
      < -0.809064, 0.741771, 1.303910>,
      < -0.780724, 0.751671, 1.303910>,
      < -0.779226, 0.747390, 1.246276>
    }
    triangle {
      < -0.809064, 0.741771, 1.303910>,
      < -0.779226, 0.747390, 1.246276>,
      < -0.807566, 0.737489, 1.246275>
    }
    triangle {
      < -0.807570, 0.737488, 1.361544>,
      < -0.779230, 0.747388, 1.361544>,
      < -0.780724, 0.751671, 1.303910>
    }
    triangle {
      < -0.807570, 0.737488, 1.361544>,
      < -0.780724, 0.751671, 1.303910>,
      < -0.809064, 0.741771, 1.303910>
    }
    triangle {
      < -0.803120, 0.724746, 1.417759>,
      < -0.774780, 0.734647, 1.417760>,
      < -0.779230, 0.747388, 1.361544>
    }
    triangle {
      < -0.803120, 0.724746, 1.417759>,
      < -0.779230, 0.747388, 1.361544>,
      < -0.807570, 0.737488, 1.361544>
    }
    triangle {
      < -0.795826, 0.703860, 1.471171>,
      < -0.767486, 0.713760, 1.471171>,
      < -0.774780, 0.734647, 1.417760>
    }
    triangle {
      < -0.795826, 0.703860, 1.471171>,
      < -0.774780, 0.734647, 1.417760>,
      < -0.803120, 0.724746, 1.417759>
    }
    triangle {
      < -0.785865, 0.675342, 1.520464>,
      < -0.757525, 0.685243, 1.520465>,
      < -0.767486, 0.713760, 1.471171>
    }
    triangle {
      < -0.785865, 0.675342, 1.520464>,
      < -0.767486, 0.713760, 1.471171>,
      < -0.795826, 0.703860, 1.471171>
    }
    triangle {
      < -0.773484, 0.639896, 1.564425>,
      < -0.745144, 0.649797, 1.564426>,
      < -0.757525, 0.685243, 1.520465>
    }
    triangle {
      < -0.773484, 0.639896, 1.564425>,
      < -0.757525, 0.685243, 1.520465>,
      < -0.785865, 0.675342, 1.520464>
    }
    triangle {
      < -0.758987, 0.598394, 1.601971>,
      < -0.730647, 0.608295, 1.601972>,
      < -0.745144, 0.649797, 1.564426>
    }
    triangle {
      < -0.758987, 0.598394, 1.601971>,
      < -0.745144, 0.649797, 1.564426>,
      < -0.773484, 0.639896, 1.564425>
    }
    triangle {
      < -0.742731, 0.551859, 1.632178>,
      < -0.714391, 0.561759, 1.632179>,
      < -0.730647, 0.608295, 1.601972>
    }
    triangle {
      < -0.742731, 0.551859, 1.632178>,
      < -0.730647, 0.608295, 1.601972>,
      < -0.758987, 0.598394, 1.601971>
    }
    triangle {
      < -0.725117, 0.501435, 1.654302>,
      < -0.696777, 0.511335, 1.654302>,
      < -0.714391, 0.561759, 1.632179>
    }
    triangle {
      < -0.725117, 0.501435, 1.654302>,
      < -0.714391, 0.561759, 1.632179>,
      < -0.742731, 0.551859, 1.632178>
    }
    triangle {
      < -0.706578, 0.448365, 1.667798>,
      < -0.678238, 0.458265, 1.667799>,
      < -0.696777, 0.511335, 1.654302>
    }
    triangle {
      < -0.706578, 0.448365, 1.667798>,
      < -0.696777, 0.511335, 1.654302>,
      < -0.725117, 0.501435, 1.654302>
    }
    triangle {
      < -0.687571, 0.393955, 1.672334>,
      < -0.659231, 0.403855, 1.672334>,
      < -0.678238, 0.458265, 1.667799>
    }
    triangle {
      < -0.687571, 0.393955, 1.672334>,
      < -0.678238, 0.458265, 1.667799>,
      < -0.706578, 0.448365, 1.667798>
    }
    triangle {
      < -0.668563, 0.339545, 1.667798>,
      < -0.640223, 0.349445, 1.667799>,
      < -0.659231, 0.403855, 1.672334>
    }
    triangle {
      < -0.668563, 0.339545, 1.667798>,
      < -0.659231, 0.403855, 1.672334>,
      < -0.687571, 0.393955, 1.672334>
    }
    triangle {
      < -0.650023, 0.286475, 1.654302>,
      < -0.621683, 0.296376, 1.654302>,
      < -0.640223, 0.349445, 1.667799>
    }
    triangle {
      < -0.650023, 0.286475, 1.654302>,
      < -0.640223, 0.349445, 1.667799>,
      < -0.668563, 0.339545, 1.667798>
    }
    triangle {
      < -0.632408, 0.236052, 1.632178>,
      < -0.604068, 0.245952, 1.632179>,
      < -0.621683, 0.296376, 1.654302>
    }
    triangle {
      < -0.632408, 0.236052, 1.632178>,
      < -0.621683, 0.296376, 1.654302>,
      < -0.650023, 0.286475, 1.654302>
    }
    triangle {
      < -0.616150, 0.189517, 1.601971>,
      < -0.587810, 0.199417, 1.601972>,
      < -0.604068, 0.245952, 1.632179>
    }
    triangle {
      < -0.616150, 0.189517, 1.601971>,
      < -0.604068, 0.245952, 1.632179>,
      < -0.632408, 0.236052, 1.632178>
    }
    triangle {
      < -0.601651, 0.148016, 1.564425>,
      < -0.573311, 0.157916, 1.564426>,
      < -0.587810, 0.199417, 1.601972>
    }
    triangle {
      < -0.601651, 0.148016, 1.564425>,
      < -0.587810, 0.199417, 1.601972>,
      < -0.616150, 0.189517, 1.601971>
    }
    triangle {
      < -0.589267, 0.112571, 1.520464>,
      < -0.560927, 0.122471, 1.520465>,
      < -0.573311, 0.157916, 1.564426>
    }
    triangle {
      < -0.589267, 0.112571, 1.520464>,
      < -0.573311, 0.157916, 1.564426>,
      < -0.601651, 0.148016, 1.564425>
    }
    triangle {
      < -0.579304, 0.084054, 1.471171>,
      < -0.550964, 0.093955, 1.471171>,
      < -0.560927, 0.122471, 1.520465>
    }
    triangle {
      < -0.579304, 0.084054, 1.471171>,
      < -0.560927, 0.122471, 1.520465>,
      < -0.589267, 0.112571, 1.520464>
    }
    triangle {
      < -0.572006, 0.063169, 1.417759>,
      < -0.543666, 0.073069, 1.417760>,
      < -0.550964, 0.093955, 1.471171>
    }
    triangle {
      < -0.572006, 0.063169, 1.417759>,
      < -0.550964, 0.093955, 1.471171>,
      < -0.579304, 0.084054, 1.471171>
    }
    triangle {
      < -0.567553, 0.050428, 1.361544>,
      < -0.539213, 0.060329, 1.361544>,
      < -0.543666, 0.073069, 1.417760>
    }
    triangle {
      < -0.567553, 0.050428, 1.361544>,
      < -0.543666, 0.073069, 1.417760>,
      < -0.572006, 0.063169, 1.417759>
    }
    triangle {
      < -0.566056, 0.046147, 1.303910>,
      < -0.537716, 0.056047, 1.303910>,
      < -0.539213, 0.060329, 1.361544>
    }
    triangle {
      < -0.566056, 0.046147, 1.303910>,
      < -0.539213, 0.060329, 1.361544>,
      < -0.567553, 0.050428, 1.361544>
    }
    triangle {
      < -0.575211, 0.163404, 1.049202>,
      < -0.563105, 0.128748, 1.092183>,
      < -0.560914, 0.122476, 1.087356>
    }
    triangle {
      < -0.575211, 0.163404, 1.049202>,
      < -0.560914, 0.122476, 1.087356>,
      < -0.573295, 0.157922, 1.043395>
    }
    triangle {
      < -0.563105, 0.128748, 1.092183>,
      < -0.553367, 0.100866, 1.140378>,
      < -0.550954, 0.093958, 1.136649>
    }
    triangle {
      < -0.563105, 0.128748, 1.092183>,
      < -0.550954, 0.093958, 1.136649>,
      < -0.560914, 0.122476, 1.087356>
    }
    triangle {
      < -0.553367, 0.100866, 1.140378>,
      < -0.546235, 0.080445, 1.192599>,
      < -0.543659, 0.073071, 1.190061>
    }
    triangle {
      < -0.553367, 0.100866, 1.140378>,
      < -0.543659, 0.073071, 1.190061>,
      < -0.550954, 0.093958, 1.136649>
    }
    triangle {
      < -0.546235, 0.080445, 1.192599>,
      < -0.541885, 0.067987, 1.247561>,
      < -0.539210, 0.060330, 1.246276>
    }
    triangle {
      < -0.546235, 0.080445, 1.192599>,
      < -0.539210, 0.060330, 1.246276>,
      < -0.543659, 0.073071, 1.190061>
    }
    triangle {
      < -0.541885, 0.067987, 1.247561>,
      < -0.540424, 0.063800, 1.303910>,
      < -0.537716, 0.056047, 1.303910>
    }
    triangle {
      < -0.541885, 0.067987, 1.247561>,
      < -0.537716, 0.056047, 1.303910>,
      < -0.539210, 0.060330, 1.246276>
    }
    triangle {
      < -0.540424, 0.063800, 1.303910>,
      < -0.541888, 0.067986, 1.360260>,
      < -0.539213, 0.060329, 1.361544>
    }
    triangle {
      < -0.540424, 0.063800, 1.303910>,
      < -0.539213, 0.060329, 1.361544>,
      < -0.537716, 0.056047, 1.303910>
    }
    triangle {
      < -0.541888, 0.067986, 1.360260>,
      < -0.546242, 0.080443, 1.415222>,
      < -0.543666, 0.073069, 1.417760>
    }
    triangle {
      < -0.541888, 0.067986, 1.360260>,
      < -0.543666, 0.073069, 1.417760>,
      < -0.539213, 0.060329, 1.361544>
    }
    triangle {
      < -0.546242, 0.080443, 1.415222>,
      < -0.553377, 0.100863, 1.467443>,
      < -0.550964, 0.093955, 1.471171>
    }
    triangle {
      < -0.546242, 0.080443, 1.415222>,
      < -0.550964, 0.093955, 1.471171>,
      < -0.543666, 0.073069, 1.417760>
    }
    triangle {
      < -0.553377, 0.100863, 1.467443>,
      < -0.563118, 0.128743, 1.515637>,
      < -0.560927, 0.122471, 1.520465>
    }
    triangle {
      < -0.553377, 0.100863, 1.467443>,
      < -0.560927, 0.122471, 1.520465>,
      < -0.550964, 0.093955, 1.471171>
    }
    triangle {
      < -0.563118, 0.128743, 1.515637>,
      < -0.575226, 0.163398, 1.558618>,
      < -0.573311, 0.157916, 1.564426>
    }
    triangle {
      < -0.563118, 0.128743, 1.515637>,
      < -0.573311, 0.157916, 1.564426>,
      < -0.560927, 0.122471, 1.520465>
    }
    triangle {
      < -0.575226, 0.163398, 1.558618>,
      < -0.589402, 0.203974, 1.595328>,
      < -0.587810, 0.199417, 1.601972>
    }
    triangle {
      < -0.575226, 0.163398, 1.558618>,
      < -0.587810, 0.199417, 1.601972>,
      < -0.573311, 0.157916, 1.564426>
    }
    triangle {
      < -0.589402, 0.203974, 1.595328>,
      < -0.605297, 0.249472, 1.624861>,
      < -0.604068, 0.245952, 1.632179>
    }
    triangle {
      < -0.589402, 0.203974, 1.595328>,
      < -0.604068, 0.245952, 1.632179>,
      < -0.587810, 0.199417, 1.601972>
    }
    triangle {
      < -0.605297, 0.249472, 1.624861>,
      < -0.622520, 0.298772, 1.646492>,
      < -0.621683, 0.296376, 1.654302>
    }
    triangle {
      < -0.605297, 0.249472, 1.624861>,
      < -0.621683, 0.296376, 1.654302>,
      < -0.604068, 0.245952, 1.632179>
    }
    triangle {
      < -0.622520, 0.298772, 1.646492>,
      < -0.640647, 0.350658, 1.659687>,
      < -0.640223, 0.349445, 1.667799>
    }
    triangle {
      < -0.622520, 0.298772, 1.646492>,
      < -0.640223, 0.349445, 1.667799>,
      < -0.621683, 0.296376, 1.654302>
    }
    triangle {
      < -0.640647, 0.350658, 1.659687>,
      < -0.659231, 0.403855, 1.664122>,
      < -0.659231, 0.403855, 1.672334>
    }
    triangle {
      < -0.640647, 0.350658, 1.659687>,
      < -0.659231, 0.403855, 1.672334>,
      < -0.640223, 0.349445, 1.667799>
    }
    triangle {
      < -0.659231, 0.403855, 1.664122>,
      < -0.677814, 0.457052, 1.659687>,
      < -0.678238, 0.458265, 1.667799>
    }
    triangle {
      < -0.659231, 0.403855, 1.664122>,
      < -0.678238, 0.458265, 1.667799>,
      < -0.659231, 0.403855, 1.672334>
    }
    triangle {
      < -0.677814, 0.457052, 1.659687>,
      < -0.695940, 0.508939, 1.646492>,
      < -0.696777, 0.511335, 1.654302>
    }
    triangle {
      < -0.677814, 0.457052, 1.659687>,
      < -0.696777, 0.511335, 1.654302>,
      < -0.678238, 0.458265, 1.667799>
    }
    triangle {
      < -0.695940, 0.508939, 1.646492>,
      < -0.713161, 0.558239, 1.624861>,
      < -0.714391, 0.561759, 1.632179>
    }
    triangle {
      < -0.695940, 0.508939, 1.646492>,
      < -0.714391, 0.561759, 1.632179>,
      < -0.696777, 0.511335, 1.654302>
    }
    triangle {
      < -0.713161, 0.558239, 1.624861>,
      < -0.729055, 0.603738, 1.595328>,
      < -0.730647, 0.608295, 1.601972>
    }
    triangle {
      < -0.713161, 0.558239, 1.624861>,
      < -0.730647, 0.608295, 1.601972>,
      < -0.714391, 0.561759, 1.632179>
    }
    triangle {
      < -0.729055, 0.603738, 1.595328>,
      < -0.743228, 0.644314, 1.558618>,
      < -0.745144, 0.649797, 1.564426>
    }
    triangle {
      < -0.729055, 0.603738, 1.595328>,
      < -0.745144, 0.649797, 1.564426>,
      < -0.730647, 0.608295, 1.601972>
    }
    triangle {
      < -0.743228, 0.644314, 1.558618>,
      < -0.755334, 0.678970, 1.515637>,
      < -0.757525, 0.685243, 1.520465>
    }
    triangle {
      < -0.743228, 0.644314, 1.558618>,
      < -0.757525, 0.685243, 1.520465>,
      < -0.745144, 0.649797, 1.564426>
    }
    triangle {
      < -0.755334, 0.678970, 1.515637>,
      < -0.765072, 0.706852, 1.467443>,
      < -0.767486, 0.713760, 1.471171>
    }
    triangle {
      < -0.755334, 0.678970, 1.515637>,
      < -0.767486, 0.713760, 1.471171>,
      < -0.757525, 0.685243, 1.520465>
    }
    triangle {
      < -0.765072, 0.706852, 1.467443>,
      < -0.772204, 0.727273, 1.415222>,
      < -0.774780, 0.734647, 1.417760>
    }
    triangle {
      < -0.765072, 0.706852, 1.467443>,
      < -0.774780, 0.734647, 1.417760>,
      < -0.767486, 0.713760, 1.471171>
    }
    triangle {
      < -0.772204, 0.727273, 1.415222>,
      < -0.776554, 0.739731, 1.360260>,
      < -0.779230, 0.747388, 1.361544>
    }
    triangle {
      < -0.772204, 0.727273, 1.415222>,
      < -0.779230, 0.747388, 1.361544>,
      < -0.774780, 0.734647, 1.417760>
    }
    triangle {
      < -0.776554, 0.739731, 1.360260>,
      < -0.778015, 0.743918, 1.303910>,
      < -0.780724, 0.751671, 1.303910>
    }
    triangle {
      < -0.776554, 0.739731, 1.360260>,
      < -0.780724, 0.751671, 1.303910>,
      < -0.779230, 0.747388, 1.361544>
    }
    triangle {
      < -0.778015, 0.743918, 1.303910>,
      < -0.776551, 0.739732, 1.247561>,
      < -0.779226, 0.747390, 1.246276>
    }
    triangle {
      < -0.778015, 0.743918, 1.303910>,
      < -0.779226, 0.747390, 1.246276>,
      < -0.780724, 0.751671, 1.303910>
    }
    triangle {
      < -0.776551, 0.739732, 1.247561>,
      < -0.772198, 0.727275, 1.192599>,
      < -0.774773, 0.734649, 1.190061>
    }
    triangle {
      < -0.776551, 0.739732, 1.247561>,
      < -0.774773, 0.734649, 1.190061>,
      < -0.779226, 0.747390, 1.246276>
    }
    triangle {
      < -0.772198, 0.727275, 1.192599>,
      < -0.765062, 0.706856, 1.140378>,
      < -0.767475, 0.713764, 1.136649>
    }
    triangle {
      < -0.772198, 0.727275, 1.192599>,
      < -0.767475, 0.713764, 1.136649>,
      < -0.774773, 0.734649, 1.190061>
    }
    triangle {
      < -0.765062, 0.706856, 1.140378>,
      < -0.755321, 0.678975, 1.092183>,
      < -0.757512, 0.685247, 1.087356>
    }
    triangle {
      < -0.765062, 0.706856, 1.140378>,
      < -0.757512, 0.685247, 1.087356>,
      < -0.767475, 0.713764, 1.136649>
    }
    triangle {
      < -0.755321, 0.678975, 1.092183>,
      < -0.743213, 0.644320, 1.049202>,
      < -0.745128, 0.649802, 1.043395>
    }
    triangle {
      < -0.755321, 0.678975, 1.092183>,
      < -0.745128, 0.649802, 1.043395>,
      < -0.757512, 0.685247, 1.087356>
    }
    triangle {
      < -0.743213, 0.644320, 1.049202>,
      < -0.729037, 0.603744, 1.012493>,
      < -0.730629, 0.608301, 1.005849>
    }
    triangle {
      < -0.743213, 0.644320, 1.049202>,
      < -0.730629, 0.608301, 1.005849>,
      < -0.745128, 0.649802, 1.043395>
    }
    triangle {
      < -0.729037, 0.603744, 1.012493>,
      < -0.713142, 0.558246, 0.982959>,
      < -0.714371, 0.561766, 0.975642>
    }
    triangle {
      < -0.729037, 0.603744, 1.012493>,
      < -0.714371, 0.561766, 0.975642>,
      < -0.730629, 0.608301, 1.005849>
    }
    triangle {
      < -0.713142, 0.558246, 0.982959>,
      < -0.695919, 0.508947, 0.961329>,
      < -0.696756, 0.511343, 0.953518>
    }
    triangle {
      < -0.713142, 0.558246, 0.982959>,
      < -0.696756, 0.511343, 0.953518>,
      < -0.714371, 0.561766, 0.975642>
    }
    triangle {
      < -0.695919, 0.508947, 0.961329>,
      < -0.677792, 0.457060, 0.948133>,
      < -0.678216, 0.458273, 0.940022>
    }
    triangle {
      < -0.695919, 0.508947, 0.961329>,
      < -0.678216, 0.458273, 0.940022>,
      < -0.696756, 0.511343, 0.953518>
    }
    triangle {
      < -0.677792, 0.457060, 0.948133>,
      < -0.659209, 0.403863, 0.943699>,
      < -0.659208, 0.403863, 0.935486>
    }
    triangle {
      < -0.677792, 0.457060, 0.948133>,
      < -0.659208, 0.403863, 0.935486>,
      < -0.678216, 0.458273, 0.940022>
    }
    triangle {
      < -0.659209, 0.403863, 0.943699>,
      < -0.640625, 0.350666, 0.948133>,
      < -0.640201, 0.349453, 0.940022>
    }
    triangle {
      < -0.659209, 0.403863, 0.943699>,
      < -0.640201, 0.349453, 0.940022>,
      < -0.659208, 0.403863, 0.935486>
    }
    triangle {
      < -0.640625, 0.350666, 0.948133>,
      < -0.622499, 0.298779, 0.961329>,
      < -0.621662, 0.296383, 0.953518>
    }
    triangle {
      < -0.640625, 0.350666, 0.948133>,
      < -0.621662, 0.296383, 0.953518>,
      < -0.640201, 0.349453, 0.940022>
    }
    triangle {
      < -0.622499, 0.298779, 0.961329>,
      < -0.605278, 0.249479, 0.982959>,
      < -0.604048, 0.245959, 0.975642>
    }
    triangle {
      < -0.622499, 0.298779, 0.961329>,
      < -0.604048, 0.245959, 0.975642>,
      < -0.621662, 0.296383, 0.953518>
    }
    triangle {
      < -0.605278, 0.249479, 0.982959>,
      < -0.589384, 0.203981, 1.012493>,
      < -0.587792, 0.199423, 1.005849>
    }
    triangle {
      < -0.605278, 0.249479, 0.982959>,
      < -0.587792, 0.199423, 1.005849>,
      < -0.604048, 0.245959, 0.975642>
    }
    triangle {
      < -0.589384, 0.203981, 1.012493>,
      < -0.575211, 0.163404, 1.049202>,
      < -0.573295, 0.157922, 1.043395>
    }
    triangle {
      < -0.589384, 0.203981, 1.012493>,
      < -0.573295, 0.157922, 1.043395>,
      < -0.587792, 0.199423, 1.005849>
    }
    triangle {
      < -0.603566, 0.153498, 1.558618>,
      < -0.591458, 0.118843, 1.515637>,
      < -0.589267, 0.112571, 1.520464>
    }
    triangle {
      < -0.603566, 0.153498, 1.558618>,
      < -0.589267, 0.112571, 1.520464>,
      < -0.601651, 0.148016, 1.564425>
    }
    triangle {
      < -0.591458, 0.118843, 1.515637>,
      < -0.581717, 0.090962, 1.467442>,
      < -0.579304, 0.084054, 1.471171>
    }
    triangle {
      < -0.591458, 0.118843, 1.515637>,
      < -0.579304, 0.084054, 1.471171>,
      < -0.589267, 0.112571, 1.520464>
    }
    triangle {
      < -0.581717, 0.090962, 1.467442>,
      < -0.574582, 0.070542, 1.415221>,
      < -0.572006, 0.063169, 1.417759>
    }
    triangle {
      < -0.581717, 0.090962, 1.467442>,
      < -0.572006, 0.063169, 1.417759>,
      < -0.579304, 0.084054, 1.471171>
    }
    triangle {
      < -0.574582, 0.070542, 1.415221>,
      < -0.570228, 0.058086, 1.360259>,
      < -0.567553, 0.050428, 1.361544>
    }
    triangle {
      < -0.574582, 0.070542, 1.415221>,
      < -0.567553, 0.050428, 1.361544>,
      < -0.572006, 0.063169, 1.417759>
    }
    triangle {
      < -0.570228, 0.058086, 1.360259>,
      < -0.568764, 0.053900, 1.303910>,
      < -0.566056, 0.046147, 1.303910>
    }
    triangle {
      < -0.570228, 0.058086, 1.360259>,
      < -0.566056, 0.046147, 1.303910>,
      < -0.567553, 0.050428, 1.361544>
    }
    triangle {
      < -0.568764, 0.053900, 1.303910>,
      < -0.570225, 0.058087, 1.247560>,
      < -0.567550, 0.050430, 1.246275>
    }
    triangle {
      < -0.568764, 0.053900, 1.303910>,
      < -0.567550, 0.050430, 1.246275>,
      < -0.566056, 0.046147, 1.303910>
    }
    triangle {
      < -0.570225, 0.058087, 1.247560>,
      < -0.574575, 0.070545, 1.192598>,
      < -0.571999, 0.063171, 1.190060>
    }
    triangle {
      < -0.570225, 0.058087, 1.247560>,
      < -0.571999, 0.063171, 1.190060>,
      < -0.567550, 0.050430, 1.246275>
    }
    triangle {
      < -0.574575, 0.070545, 1.192598>,
      < -0.581707, 0.090966, 1.140377>,
      < -0.579294, 0.084058, 1.136648>
    }
    triangle {
      < -0.574575, 0.070545, 1.192598>,
      < -0.579294, 0.084058, 1.136648>,
      < -0.571999, 0.063171, 1.190060>
    }
    triangle {
      < -0.581707, 0.090966, 1.140377>,
      < -0.591446, 0.118848, 1.092182>,
      < -0.589254, 0.112575, 1.087355>
    }
    triangle {
      < -0.581707, 0.090966, 1.140377>,
      < -0.589254, 0.112575, 1.087355>,
      < -0.579294, 0.084058, 1.136648>
    }
    triangle {
      < -0.591446, 0.118848, 1.092182>,
      < -0.603551, 0.153504, 1.049201>,
      < -0.601635, 0.148021, 1.043394>
    }
    triangle {
      < -0.591446, 0.118848, 1.092182>,
      < -0.601635, 0.148021, 1.043394>,
      < -0.589254, 0.112575, 1.087355>
    }
    triangle {
      < -0.603551, 0.153504, 1.049201>,
      < -0.617724, 0.194080, 1.012492>,
      < -0.616132, 0.189523, 1.005848>
    }
    triangle {
      < -0.603551, 0.153504, 1.049201>,
      < -0.616132, 0.189523, 1.005848>,
      < -0.601635, 0.148021, 1.043394>
    }
    triangle {
      < -0.617724, 0.194080, 1.012492>,
      < -0.633618, 0.239579, 0.982959>,
      < -0.632388, 0.236059, 0.975641>
    }
    triangle {
      < -0.617724, 0.194080, 1.012492>,
      < -0.632388, 0.236059, 0.975641>,
      < -0.616132, 0.189523, 1.005848>
    }
    triangle {
      < -0.633618, 0.239579, 0.982959>,
      < -0.650839, 0.288879, 0.961328>,
      < -0.650002, 0.286483, 0.953517>
    }
    triangle {
      < -0.633618, 0.239579, 0.982959>,
      < -0.650002, 0.286483, 0.953517>,
      < -0.632388, 0.236059, 0.975641>
    }
    triangle {
      < -0.650839, 0.288879, 0.961328>,
      < -0.668965, 0.340766, 0.948133>,
      < -0.668541, 0.339553, 0.940021>
    }
    triangle {
      < -0.650839, 0.288879, 0.961328>,
      < -0.668541, 0.339553, 0.940021>,
      < -0.650002, 0.286483, 0.953517>
    }
    triangle {
      < -0.668965, 0.340766, 0.948133>,
      < -0.687549, 0.393963, 0.943698>,
      < -0.687548, 0.393963, 0.935485>
    }
    triangle {
      < -0.668965, 0.340766, 0.948133>,
      < -0.687548, 0.393963, 0.935485>,
      < -0.668541, 0.339553, 0.940021>
    }
    triangle {
      < -0.687549, 0.393963, 0.943698>,
      < -0.706133, 0.447160, 0.948133>,
      < -0.706556, 0.448372, 0.940021>
    }
    triangle {
      < -0.687549, 0.393963, 0.943698>,
      < -0.706556, 0.448372, 0.940021>,
      < -0.687548, 0.393963, 0.935485>
    }
    triangle {
      < -0.706133, 0.447160, 0.948133>,
      < -0.724259, 0.499046, 0.961328>,
      < -0.725096, 0.501442, 0.953517>
    }
    triangle {
      < -0.706133, 0.447160, 0.948133>,
      < -0.725096, 0.501442, 0.953517>,
      < -0.706556, 0.448372, 0.940021>
    }
    triangle {
      < -0.724259, 0.499046, 0.961328>,
      < -0.741482, 0.548346, 0.982959>,
      < -0.742711, 0.551866, 0.975641>
    }
    triangle {
      < -0.724259, 0.499046, 0.961328>,
      < -0.742711, 0.551866, 0.975641>,
      < -0.725096, 0.501442, 0.953517>
    }
    triangle {
      < -0.741482, 0.548346, 0.982959>,
      < -0.757377, 0.593844, 1.012492>,
      < -0.758969, 0.598401, 1.005848>
    }
    triangle {
      < -0.741482, 0.548346, 0.982959>,
      < -0.758969, 0.598401, 1.005848>,
      < -0.742711, 0.551866, 0.975641>
    }
    triangle {
      < -0.757377, 0.593844, 1.012492>,
      < -0.771553, 0.634420, 1.049201>,
      < -0.773468, 0.639902, 1.043394>
    }
    triangle {
      < -0.757377, 0.593844, 1.012492>,
      < -0.773468, 0.639902, 1.043394>,
      < -0.758969, 0.598401, 1.005848>
    }
    triangle {
      < -0.771553, 0.634420, 1.049201>,
      < -0.783661, 0.669075, 1.092182>,
      < -0.785852, 0.675347, 1.087355>
    }
    triangle {
      < -0.771553, 0.634420, 1.049201>,
      < -0.785852, 0.675347, 1.087355>,
      < -0.773468, 0.639902, 1.043394>
    }
    triangle {
      < -0.783661, 0.669075, 1.092182>,
      < -0.793402, 0.696955, 1.140377>,
      < -0.795815, 0.703863, 1.136648>
    }
    triangle {
      < -0.783661, 0.669075, 1.092182>,
      < -0.795815, 0.703863, 1.136648>,
      < -0.785852, 0.675347, 1.087355>
    }
    triangle {
      < -0.793402, 0.696955, 1.140377>,
      < -0.800538, 0.717375, 1.192598>,
      < -0.803113, 0.724749, 1.190060>
    }
    triangle {
      < -0.793402, 0.696955, 1.140377>,
      < -0.803113, 0.724749, 1.190060>,
      < -0.795815, 0.703863, 1.136648>
    }
    triangle {
      < -0.800538, 0.717375, 1.192598>,
      < -0.804891, 0.729832, 1.247560>,
      < -0.807566, 0.737489, 1.246275>
    }
    triangle {
      < -0.800538, 0.717375, 1.192598>,
      < -0.807566, 0.737489, 1.246275>,
      < -0.803113, 0.724749, 1.190060>
    }
    triangle {
      < -0.804891, 0.729832, 1.247560>,
      < -0.806355, 0.734018, 1.303910>,
      < -0.809064, 0.741771, 1.303910>
    }
    triangle {
      < -0.804891, 0.729832, 1.247560>,
      < -0.809064, 0.741771, 1.303910>,
      < -0.807566, 0.737489, 1.246275>
    }
    triangle {
      < -0.806355, 0.734018, 1.303910>,
      < -0.804894, 0.729831, 1.360259>,
      < -0.807570, 0.737488, 1.361544>
    }
    triangle {
      < -0.806355, 0.734018, 1.303910>,
      < -0.807570, 0.737488, 1.361544>,
      < -0.809064, 0.741771, 1.303910>
    }
    triangle {
      < -0.804894, 0.729831, 1.360259>,
      < -0.800544, 0.717373, 1.415221>,
      < -0.803120, 0.724746, 1.417759>
    }
    triangle {
      < -0.804894, 0.729831, 1.360259>,
      < -0.803120, 0.724746, 1.417759>,
      < -0.807570, 0.737488, 1.361544>
    }
    triangle {
      < -0.800544, 0.717373, 1.415221>,
      < -0.793412, 0.696952, 1.467442>,
      < -0.795826, 0.703860, 1.471171>
    }
    triangle {
      < -0.800544, 0.717373, 1.415221>,
      < -0.795826, 0.703860, 1.471171>,
      < -0.803120, 0.724746, 1.417759>
    }
    triangle {
      < -0.793412, 0.696952, 1.467442>,
      < -0.783674, 0.669070, 1.515637>,
      < -0.785865, 0.675342, 1.520464>
    }
    triangle {
      < -0.793412, 0.696952, 1.467442>,
      < -0.785865, 0.675342, 1.520464>,
      < -0.795826, 0.703860, 1.471171>
    }
    triangle {
      < -0.783674, 0.669070, 1.515637>,
      < -0.771569, 0.634414, 1.558618>,
      < -0.773484, 0.639896, 1.564425>
    }
    triangle {
      < -0.783674, 0.669070, 1.515637>,
      < -0.773484, 0.639896, 1.564425>,
      < -0.785865, 0.675342, 1.520464>
    }
    triangle {
      < -0.771569, 0.634414, 1.558618>,
      < -0.757395, 0.593837, 1.595327>,
      < -0.758987, 0.598394, 1.601971>
    }
    triangle {
      < -0.771569, 0.634414, 1.558618>,
      < -0.758987, 0.598394, 1.601971>,
      < -0.773484, 0.639896, 1.564425>
    }
    triangle {
      < -0.757395, 0.593837, 1.595327>,
      < -0.741501, 0.548339, 1.624861>,
      < -0.742731, 0.551859, 1.632178>
    }
    triangle {
      < -0.757395, 0.593837, 1.595327>,
      < -0.742731, 0.551859, 1.632178>,
      < -0.758987, 0.598394, 1.601971>
    }
    triangle {
      < -0.741501, 0.548339, 1.624861>,
      < -0.724280, 0.499039, 1.646491>,
      < -0.725117, 0.501435, 1.654302>
    }
    triangle {
      < -0.741501, 0.548339, 1.624861>,
      < -0.725117, 0.501435, 1.654302>,
      < -0.742731, 0.551859, 1.632178>
    }
    triangle {
      < -0.724280, 0.499039, 1.646491>,
      < -0.706154, 0.447152, 1.659686>,
      < -0.706578, 0.448365, 1.667798>
    }
    triangle {
      < -0.724280, 0.499039, 1.646491>,
      < -0.706578, 0.448365, 1.667798>,
      < -0.725117, 0.501435, 1.654302>
    }
    triangle {
      < -0.706154, 0.447152, 1.659686>,
      < -0.687571, 0.393955, 1.664121>,
      < -0.687571, 0.393955, 1.672334>
    }
    triangle {
      < -0.706154, 0.447152, 1.659686>,
      < -0.687571, 0.393955, 1.672334>,
      < -0.706578, 0.448365, 1.667798>
    }
    triangle {
      < -0.687571, 0.393955, 1.664121>,
      < -0.668987, 0.340758, 1.659686>,
      < -0.668563, 0.339545, 1.667798>
    }
    triangle {
      < -0.687571, 0.393955, 1.664121>,
      < -0.668563, 0.339545, 1.667798>,
      < -0.687571, 0.393955, 1.672334>
    }
    triangle {
      < -0.668987, 0.340758, 1.659686>,
      < -0.650860, 0.288871, 1.646491>,
      < -0.650023, 0.286475, 1.654302>
    }
    triangle {
      < -0.668987, 0.340758, 1.659686>,
      < -0.650023, 0.286475, 1.654302>,
      < -0.668563, 0.339545, 1.667798>
    }
    triangle {
      < -0.650860, 0.288871, 1.646491>,
      < -0.633637, 0.239572, 1.624861>,
      < -0.632408, 0.236052, 1.632178>
    }
    triangle {
      < -0.650860, 0.288871, 1.646491>,
      < -0.632408, 0.236052, 1.632178>,
      < -0.650023, 0.286475, 1.654302>
    }
    triangle {
      < -0.633637, 0.239572, 1.624861>,
      < -0.617742, 0.194074, 1.595327>,
      < -0.616150, 0.189517, 1.601971>
    }
    triangle {
      < -0.633637, 0.239572, 1.624861>,
      < -0.616150, 0.189517, 1.601971>,
      < -0.632408, 0.236052, 1.632178>
    }
    triangle {
      < -0.617742, 0.194074, 1.595327>,
      < -0.603566, 0.153498, 1.558618>,
      < -0.601651, 0.148016, 1.564425>
    }
    triangle {
      < -0.617742, 0.194074, 1.595327>,
      < -0.601651, 0.148016, 1.564425>,
      < -0.616150, 0.189517, 1.601971>
    }
    triangle {
      < -0.589402, 0.203974, 1.595328>,
      < -0.617742, 0.194074, 1.595327>,
      < -0.633637, 0.239572, 1.624861>
    }
    triangle {
      < -0.589402, 0.203974, 1.595328>,
      < -0.633637, 0.239572, 1.624861>,
      < -0.605297, 0.249472, 1.624861>
    }
    triangle {
      < -0.575226, 0.163398, 1.558618>,
      < -0.603566, 0.153498, 1.558618>,
      < -0.617742, 0.194074, 1.595327>
    }
    triangle {
      < -0.575226, 0.163398, 1.558618>,
      < -0.617742, 0.194074, 1.595327>,
      < -0.589402, 0.203974, 1.595328>
    }
    triangle {
      < -0.563118, 0.128743, 1.515637>,
      < -0.591458, 0.118843, 1.515637>,
      < -0.603566, 0.153498, 1.558618>
    }
    triangle {
      < -0.563118, 0.128743, 1.515637>,
      < -0.603566, 0.153498, 1.558618>,
      < -0.575226, 0.163398, 1.558618>
    }
    triangle {
      < -0.553377, 0.100863, 1.467443>,
      < -0.581717, 0.090962, 1.467442>,
      < -0.591458, 0.118843, 1.515637>
    }
    triangle {
      < -0.553377, 0.100863, 1.467443>,
      < -0.591458, 0.118843, 1.515637>,
      < -0.563118, 0.128743, 1.515637>
    }
    triangle {
      < -0.546242, 0.080443, 1.415222>,
      < -0.574582, 0.070542, 1.415221>,
      < -0.581717, 0.090962, 1.467442>
    }
    triangle {
      < -0.546242, 0.080443, 1.415222>,
      < -0.581717, 0.090962, 1.467442>,
      < -0.553377, 0.100863, 1.467443>
    }
    triangle {
      < -0.541888, 0.067986, 1.360260>,
      < -0.570228, 0.058086, 1.360259>,
      < -0.574582, 0.070542, 1.415221>
    }
    triangle {
      < -0.541888, 0.067986, 1.360260>,
      < -0.574582, 0.070542, 1.415221>,
      < -0.546242, 0.080443, 1.415222>
    }
    triangle {
      < -0.540424, 0.063800, 1.303910>,
      < -0.568764, 0.053900, 1.303910>,
      < -0.570228, 0.058086, 1.360259>
    }
    triangle {
      < -0.540424, 0.063800, 1.303910>,
      < -0.570228, 0.058086, 1.360259>,
      < -0.541888, 0.067986, 1.360260>
    }
    triangle {
      < -0.541885, 0.067987, 1.247561>,
      < -0.570225, 0.058087, 1.247560>,
      < -0.568764, 0.053900, 1.303910>
    }
    triangle {
      < -0.541885, 0.067987, 1.247561>,
      < -0.568764, 0.053900, 1.303910>,
      < -0.540424, 0.063800, 1.303910>
    }
    triangle {
      < -0.546235, 0.080445, 1.192599>,
      < -0.574575, 0.070545, 1.192598>,
      < -0.570225, 0.058087, 1.247560>
    }
    triangle {
      < -0.546235, 0.080445, 1.192599>,
      < -0.570225, 0.058087, 1.247560>,
      < -0.541885, 0.067987, 1.247561>
    }
    triangle {
      < -0.553367, 0.100866, 1.140378>,
      < -0.581707, 0.090966, 1.140377>,
      < -0.574575, 0.070545, 1.192598>
    }
    triangle {
      < -0.553367, 0.100866, 1.140378>,
      < -0.574575, 0.070545, 1.192598>,
      < -0.546235, 0.080445, 1.192599>
    }
    triangle {
      < -0.563105, 0.128748, 1.092183>,
      < -0.591446, 0.118848, 1.092182>,
      < -0.581707, 0.090966, 1.140377>
    }
    triangle {
      < -0.563105, 0.128748, 1.092183>,
      < -0.581707, 0.090966, 1.140377>,
      < -0.553367, 0.100866, 1.140378>
    }
    triangle {
      < -0.575211, 0.163404, 1.049202>,
      < -0.603551, 0.153504, 1.049201>,
      < -0.591446, 0.118848, 1.092182>
    }
    triangle {
      < -0.575211, 0.163404, 1.049202>,
      < -0.591446, 0.118848, 1.092182>,
      < -0.563105, 0.128748, 1.092183>
    }
    triangle {
      < -0.589384, 0.203981, 1.012493>,
      < -0.617724, 0.194080, 1.012492>,
      < -0.603551, 0.153504, 1.049201>
    }
    triangle {
      < -0.589384, 0.203981, 1.012493>,
      < -0.603551, 0.153504, 1.049201>,
      < -0.575211, 0.163404, 1.049202>
    }
    triangle {
      < -0.605278, 0.249479, 0.982959>,
      < -0.633618, 0.239579, 0.982959>,
      < -0.617724, 0.194080, 1.012492>
    }
    triangle {
      < -0.605278, 0.249479, 0.982959>,
      < -0.617724, 0.194080, 1.012492>,
      < -0.589384, 0.203981, 1.012493>
    }
    triangle {
      < -0.622499, 0.298779, 0.961329>,
      < -0.650839, 0.288879, 0.961328>,
      < -0.633618, 0.239579, 0.982959>
    }
    triangle {
      < -0.622499, 0.298779, 0.961329>,
      < -0.633618, 0.239579, 0.982959>,
      < -0.605278, 0.249479, 0.982959>
    }
    triangle {
      < -0.640625, 0.350666, 0.948133>,
      < -0.668965, 0.340766, 0.948133>,
      < -0.650839, 0.288879, 0.961328>
    }
    triangle {
      < -0.640625, 0.350666, 0.948133>,
      < -0.650839, 0.288879, 0.961328>,
      < -0.622499, 0.298779, 0.961329>
    }
    triangle {
      < -0.659209, 0.403863, 0.943699>,
      < -0.687549, 0.393963, 0.943698>,
      < -0.668965, 0.340766, 0.948133>
    }
    triangle {
      < -0.659209, 0.403863, 0.943699>,
      < -0.668965, 0.340766, 0.948133>,
      < -0.640625, 0.350666, 0.948133>
    }
    triangle {
      < -0.677792, 0.457060, 0.948133>,
      < -0.706133, 0.447160, 0.948133>,
      < -0.687549, 0.393963, 0.943698>
    }
    triangle {
      < -0.677792, 0.457060, 0.948133>,
      < -0.687549, 0.393963, 0.943698>,
      < -0.659209, 0.403863, 0.943699>
    }
    triangle {
      < -0.695919, 0.508947, 0.961329>,
      < -0.724259, 0.499046, 0.961328>,
      < -0.706133, 0.447160, 0.948133>
    }
    triangle {
      < -0.695919, 0.508947, 0.961329>,
      < -0.706133, 0.447160, 0.948133>,
      < -0.677792, 0.457060, 0.948133>
    }
    triangle {
      < -0.713142, 0.558246, 0.982959>,
      < -0.741482, 0.548346, 0.982959>,
      < -0.724259, 0.499046, 0.961328>
    }
    triangle {
      < -0.713142, 0.558246, 0.982959>,
      < -0.724259, 0.499046, 0.961328>,
      < -0.695919, 0.508947, 0.961329>
    }
    triangle {
      < -0.729037, 0.603744, 1.012493>,
      < -0.757377, 0.593844, 1.012492>,
      < -0.741482, 0.548346, 0.982959>
    }
    triangle {
      < -0.729037, 0.603744, 1.012493>,
      < -0.741482, 0.548346, 0.982959>,
      < -0.713142, 0.558246, 0.982959>
    }
    triangle {
      < -0.743213, 0.644320, 1.049202>,
      < -0.771553, 0.634420, 1.049201>,
      < -0.757377, 0.593844, 1.012492>
    }
    triangle {
      < -0.743213, 0.644320, 1.049202>,
      < -0.757377, 0.593844, 1.012492>,
      < -0.729037, 0.603744, 1.012493>
    }
    triangle {
      < -0.755321, 0.678975, 1.092183>,
      < -0.783661, 0.669075, 1.092182>,
      < -0.771553, 0.634420, 1.049201>
    }
    triangle {
      < -0.755321, 0.678975, 1.092183>,
      < -0.771553, 0.634420, 1.049201>,
      < -0.743213, 0.644320, 1.049202>
    }
    triangle {
      < -0.765062, 0.706856, 1.140378>,
      < -0.793402, 0.696955, 1.140377>,
      < -0.783661, 0.669075, 1.092182>
    }
    triangle {
      < -0.765062, 0.706856, 1.140378>,
      < -0.783661, 0.669075, 1.092182>,
      < -0.755321, 0.678975, 1.092183>
    }
    triangle {
      < -0.772198, 0.727275, 1.192599>,
      < -0.800538, 0.717375, 1.192598>,
      < -0.793402, 0.696955, 1.140377>
    }
    triangle {
      < -0.772198, 0.727275, 1.192599>,
      < -0.793402, 0.696955, 1.140377>,
      < -0.765062, 0.706856, 1.140378>
    }
    triangle {
      < -0.776551, 0.739732, 1.247561>,
      < -0.804891, 0.729832, 1.247560>,
      < -0.800538, 0.717375, 1.192598>
    }
    triangle {
      < -0.776551, 0.739732, 1.247561>,
      < -0.800538, 0.717375, 1.192598>,
      < -0.772198, 0.727275, 1.192599>
    }
    triangle {
      < -0.778015, 0.743918, 1.303910>,
      < -0.806355, 0.734018, 1.303910>,
      < -0.804891, 0.729832, 1.247560>
    }
    triangle {
      < -0.778015, 0.743918, 1.303910>,
      < -0.804891, 0.729832, 1.247560>,
      < -0.776551, 0.739732, 1.247561>
    }
    triangle {
      < -0.776554, 0.739731, 1.360260>,
      < -0.804894, 0.729831, 1.360259>,
      < -0.806355, 0.734018, 1.303910>
    }
    triangle {
      < -0.776554, 0.739731, 1.360260>,
      < -0.806355, 0.734018, 1.303910>,
      < -0.778015, 0.743918, 1.303910>
    }
    triangle {
      < -0.772204, 0.727273, 1.415222>,
      < -0.800544, 0.717373, 1.415221>,
      < -0.804894, 0.729831, 1.360259>
    }
    triangle {
      < -0.772204, 0.727273, 1.415222>,
      < -0.804894, 0.729831, 1.360259>,
      < -0.776554, 0.739731, 1.360260>
    }
    triangle {
      < -0.765072, 0.706852, 1.467443>,
      < -0.793412, 0.696952, 1.467442>,
      < -0.800544, 0.717373, 1.415221>
    }
    triangle {
      < -0.765072, 0.706852, 1.467443>,
      < -0.800544, 0.717373, 1.415221>,
      < -0.772204, 0.727273, 1.415222>
    }
    triangle {
      < -0.755334, 0.678970, 1.515637>,
      < -0.783674, 0.669070, 1.515637>,
      < -0.793412, 0.696952, 1.467442>
    }
    triangle {
      < -0.755334, 0.678970, 1.515637>,
      < -0.793412, 0.696952, 1.467442>,
      < -0.765072, 0.706852, 1.467443>
    }
    triangle {
      < -0.743228, 0.644314, 1.558618>,
      < -0.771569, 0.634414, 1.558618>,
      < -0.783674, 0.669070, 1.515637>
    }
    triangle {
      < -0.743228, 0.644314, 1.558618>,
      < -0.783674, 0.669070, 1.515637>,
      < -0.755334, 0.678970, 1.515637>
    }
    triangle {
      < -0.729055, 0.603738, 1.595328>,
      < -0.757395, 0.593837, 1.595327>,
      < -0.771569, 0.634414, 1.558618>
    }
    triangle {
      < -0.729055, 0.603738, 1.595328>,
      < -0.771569, 0.634414, 1.558618>,
      < -0.743228, 0.644314, 1.558618>
    }
    triangle {
      < -0.713161, 0.558239, 1.624861>,
      < -0.741501, 0.548339, 1.624861>,
      < -0.757395, 0.593837, 1.595327>
    }
    triangle {
      < -0.713161, 0.558239, 1.624861>,
      < -0.757395, 0.593837, 1.595327>,
      < -0.729055, 0.603738, 1.595328>
    }
    triangle {
      < -0.695940, 0.508939, 1.646492>,
      < -0.724280, 0.499039, 1.646491>,
      < -0.741501, 0.548339, 1.624861>
    }
    triangle {
      < -0.695940, 0.508939, 1.646492>,
      < -0.741501, 0.548339, 1.624861>,
      < -0.713161, 0.558239, 1.624861>
    }
    triangle {
      < -0.677814, 0.457052, 1.659687>,
      < -0.706154, 0.447152, 1.659686>,
      < -0.724280, 0.499039, 1.646491>
    }
    triangle {
      < -0.677814, 0.457052, 1.659687>,
      < -0.724280, 0.499039, 1.646491>,
      < -0.695940, 0.508939, 1.646492>
    }
    triangle {
      < -0.659231, 0.403855, 1.664122>,
      < -0.687571, 0.393955, 1.664121>,
      < -0.706154, 0.447152, 1.659686>
    }
    triangle {
      < -0.659231, 0.403855, 1.664122>,
      < -0.706154, 0.447152, 1.659686>,
      < -0.677814, 0.457052, 1.659687>
    }
    triangle {
      < -0.640647, 0.350658, 1.659687>,
      < -0.668987, 0.340758, 1.659686>,
      < -0.687571, 0.393955, 1.664121>
    }
    triangle {
      < -0.640647, 0.350658, 1.659687>,
      < -0.687571, 0.393955, 1.664121>,
      < -0.659231, 0.403855, 1.664122>
    }
    triangle {
      < -0.622520, 0.298772, 1.646492>,
      < -0.650860, 0.288871, 1.646491>,
      < -0.668987, 0.340758, 1.659686>
    }
    triangle {
      < -0.622520, 0.298772, 1.646492>,
      < -0.668987, 0.340758, 1.659686>,
      < -0.640647, 0.350658, 1.659687>
    }
    triangle {
      < -0.605297, 0.249472, 1.624861>,
      < -0.633637, 0.239572, 1.624861>,
      < -0.650860, 0.288871, 1.646491>
    }
    triangle {
      < -0.605297, 0.249472, 1.624861>,
      < -0.650860, 0.288871, 1.646491>,
      < -0.622520, 0.298772, 1.646492>
    }
    triangle {
      < -0.798948, 0.288031, 1.286955>,
      < -0.732821, 0.311132, 1.286956>,
      < -0.732086, 0.309025, 1.303908>
    }
    triangle {
      < -0.798948, 0.288031, 1.286955>,
      < -0.732086, 0.309025, 1.303908>,
      < -0.798212, 0.285924, 1.303907>
    }
    triangle {
      < -0.801105, 0.294209, 1.271158>,
      < -0.734979, 0.317309, 1.271159>,
      < -0.732821, 0.311132, 1.286956>
    }
    triangle {
      < -0.801105, 0.294209, 1.271158>,
      < -0.732821, 0.311132, 1.286956>,
      < -0.798948, 0.288031, 1.286955>
    }
    triangle {
      < -0.804538, 0.304035, 1.257593>,
      < -0.738411, 0.327136, 1.257594>,
      < -0.734979, 0.317309, 1.271159>
    }
    triangle {
      < -0.804538, 0.304035, 1.257593>,
      < -0.734979, 0.317309, 1.271159>,
      < -0.801105, 0.294209, 1.271158>
    }
    triangle {
      < -0.684972, 0.386586, 0.943698>,
      < -0.689445, 0.399392, 0.943698>,
      < -0.661105, 0.409292, 0.943699>
    }
    triangle {
      < -0.684972, 0.386586, 0.943698>,
      < -0.661105, 0.409292, 0.943699>,
      < -0.656632, 0.396486, 0.943699>
    }
    triangle {
      < -0.814221, 0.331755, 1.240641>,
      < -0.748094, 0.354855, 1.240642>,
      < -0.742884, 0.339942, 1.247185>
    }
    triangle {
      < -0.814221, 0.331755, 1.240641>,
      < -0.742884, 0.339942, 1.247185>,
      < -0.809011, 0.316842, 1.247184>
    }
    triangle {
      < -0.819811, 0.347758, 1.238409>,
      < -0.753684, 0.370859, 1.238410>,
      < -0.748094, 0.354855, 1.240642>
    }
    triangle {
      < -0.819811, 0.347758, 1.238409>,
      < -0.748094, 0.354855, 1.240642>,
      < -0.814221, 0.331755, 1.240641>
    }
    triangle {
      < -0.825402, 0.363762, 1.240641>,
      < -0.759275, 0.386863, 1.240642>,
      < -0.753684, 0.370859, 1.238410>
    }
    triangle {
      < -0.825402, 0.363762, 1.240641>,
      < -0.753684, 0.370859, 1.238410>,
      < -0.819811, 0.347758, 1.238409>
    }
    triangle {
      < -0.830612, 0.378675, 1.247184>,
      < -0.764485, 0.401775, 1.247185>,
      < -0.759275, 0.386863, 1.240642>
    }
    triangle {
      < -0.830612, 0.378675, 1.247184>,
      < -0.759275, 0.386863, 1.240642>,
      < -0.825402, 0.363762, 1.240641>
    }
    triangle {
      < -0.835086, 0.391481, 1.257593>,
      < -0.768959, 0.414581, 1.257594>,
      < -0.764485, 0.401775, 1.247185>
    }
    triangle {
      < -0.835086, 0.391481, 1.257593>,
      < -0.764485, 0.401775, 1.247185>,
      < -0.830612, 0.378675, 1.247184>
    }
    triangle {
      < -0.838519, 0.401307, 1.271158>,
      < -0.772392, 0.424408, 1.271159>,
      < -0.768959, 0.414581, 1.257594>
    }
    triangle {
      < -0.838519, 0.401307, 1.271158>,
      < -0.768959, 0.414581, 1.257594>,
      < -0.835086, 0.391481, 1.257593>
    }
    triangle {
      < -0.840677, 0.407484, 1.286955>,
      < -0.774551, 0.430585, 1.286956>,
      < -0.772392, 0.424408, 1.271159>
    }
    triangle {
      < -0.840677, 0.407484, 1.286955>,
      < -0.772392, 0.424408, 1.271159>,
      < -0.838519, 0.401307, 1.271158>
    }
    triangle {
      < -0.841414, 0.409591, 1.303907>,
      < -0.775287, 0.432691, 1.303908>,
      < -0.774551, 0.430585, 1.286956>
    }
    triangle {
      < -0.841414, 0.409591, 1.303907>,
      < -0.774551, 0.430585, 1.286956>,
      < -0.840677, 0.407484, 1.286955>
    }
    triangle {
      < -0.840678, 0.407484, 1.320859>,
      < -0.774552, 0.430584, 1.320860>,
      < -0.775287, 0.432691, 1.303908>
    }
    triangle {
      < -0.840678, 0.407484, 1.320859>,
      < -0.775287, 0.432691, 1.303908>,
      < -0.841414, 0.409591, 1.303907>
    }
    triangle {
      < -0.838521, 0.401306, 1.336655>,
      < -0.772394, 0.424407, 1.336657>,
      < -0.774552, 0.430584, 1.320860>
    }
    triangle {
      < -0.838521, 0.401306, 1.336655>,
      < -0.774552, 0.430584, 1.320860>,
      < -0.840678, 0.407484, 1.320859>
    }
    triangle {
      < -0.835089, 0.391480, 1.350220>,
      < -0.768962, 0.414580, 1.350222>,
      < -0.772394, 0.424407, 1.336657>
    }
    triangle {
      < -0.835089, 0.391480, 1.350220>,
      < -0.772394, 0.424407, 1.336657>,
      < -0.838521, 0.401306, 1.336655>
    }
    triangle {
      < -0.830615, 0.378674, 1.360629>,
      < -0.764488, 0.401774, 1.360631>,
      < -0.768962, 0.414580, 1.350222>
    }
    triangle {
      < -0.830615, 0.378674, 1.360629>,
      < -0.768962, 0.414580, 1.350222>,
      < -0.835089, 0.391480, 1.350220>
    }
    triangle {
      < -0.825406, 0.363761, 1.367172>,
      < -0.759279, 0.386861, 1.367174>,
      < -0.764488, 0.401774, 1.360631>
    }
    triangle {
      < -0.825406, 0.363761, 1.367172>,
      < -0.764488, 0.401774, 1.360631>,
      < -0.830615, 0.378674, 1.360629>
    }
    triangle {
      < -0.819815, 0.347757, 1.369404>,
      < -0.753688, 0.370858, 1.369406>,
      < -0.759279, 0.386861, 1.367174>
    }
    triangle {
      < -0.819815, 0.347757, 1.369404>,
      < -0.759279, 0.386861, 1.367174>,
      < -0.825406, 0.363761, 1.367172>
    }
    triangle {
      < -0.814224, 0.331753, 1.367172>,
      < -0.748098, 0.354854, 1.367174>,
      < -0.753688, 0.370858, 1.369406>
    }
    triangle {
      < -0.814224, 0.331753, 1.367172>,
      < -0.753688, 0.370858, 1.369406>,
      < -0.819815, 0.347757, 1.369404>
    }
    triangle {
      < -0.809014, 0.316840, 1.360629>,
      < -0.742888, 0.339941, 1.360631>,
      < -0.748098, 0.354854, 1.367174>
    }
    triangle {
      < -0.809014, 0.316840, 1.360629>,
      < -0.748098, 0.354854, 1.367174>,
      < -0.814224, 0.331753, 1.367172>
    }
    triangle {
      < -0.689467, 0.399384, 1.664121>,
      < -0.684994, 0.386578, 1.664121>,
      < -0.656653, 0.396478, 1.664122>
    }
    triangle {
      < -0.689467, 0.399384, 1.664121>,
      < -0.656653, 0.396478, 1.664122>,
      < -0.661127, 0.409284, 1.664122>
    }
    triangle {
      < -0.801107, 0.294208, 1.336655>,
      < -0.734981, 0.317309, 1.336657>,
      < -0.738414, 0.327135, 1.350222>
    }
    triangle {
      < -0.801107, 0.294208, 1.336655>,
      < -0.738414, 0.327135, 1.350222>,
      < -0.804541, 0.304034, 1.350220>
    }
    triangle {
      < -0.798949, 0.288031, 1.320859>,
      < -0.732822, 0.311132, 1.320860>,
      < -0.734981, 0.317309, 1.336657>
    }
    triangle {
      < -0.798949, 0.288031, 1.320859>,
      < -0.734981, 0.317309, 1.336657>,
      < -0.801107, 0.294208, 1.336655>
    }
    triangle {
      < -0.798212, 0.285924, 1.303907>,
      < -0.732086, 0.309025, 1.303908>,
      < -0.732822, 0.311132, 1.320860>
    }
    triangle {
      < -0.798212, 0.285924, 1.303907>,
      < -0.732822, 0.311132, 1.320860>,
      < -0.798949, 0.288031, 1.320859>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.734979, 0.317309, 1.271159>,
      < -0.738411, 0.327136, 1.257594>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.738411, 0.327136, 1.257594>,
      < -0.742884, 0.339942, 1.247185>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.742884, 0.339942, 1.247185>,
      < -0.748094, 0.354855, 1.240642>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.748094, 0.354855, 1.240642>,
      < -0.753684, 0.370859, 1.238410>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.753684, 0.370859, 1.238410>,
      < -0.759275, 0.386863, 1.240642>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.759275, 0.386863, 1.240642>,
      < -0.764485, 0.401775, 1.247185>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.764485, 0.401775, 1.247185>,
      < -0.768959, 0.414581, 1.257594>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.768959, 0.414581, 1.257594>,
      < -0.772392, 0.424408, 1.271159>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.772392, 0.424408, 1.271159>,
      < -0.774551, 0.430585, 1.286956>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.774551, 0.430585, 1.286956>,
      < -0.775287, 0.432691, 1.303908>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.775287, 0.432691, 1.303908>,
      < -0.774552, 0.430584, 1.320860>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.774552, 0.430584, 1.320860>,
      < -0.772394, 0.424407, 1.336657>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.772394, 0.424407, 1.336657>,
      < -0.768962, 0.414580, 1.350222>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.768962, 0.414580, 1.350222>,
      < -0.764488, 0.401774, 1.360631>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.764488, 0.401774, 1.360631>,
      < -0.759279, 0.386861, 1.367174>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.759279, 0.386861, 1.367174>,
      < -0.753688, 0.370858, 1.369406>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.753688, 0.370858, 1.369406>,
      < -0.748098, 0.354854, 1.367174>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.748098, 0.354854, 1.367174>,
      < -0.742888, 0.339941, 1.360631>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.742888, 0.339941, 1.360631>,
      < -0.738414, 0.327135, 1.350222>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.738414, 0.327135, 1.350222>,
      < -0.734981, 0.317309, 1.336657>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.734981, 0.317309, 1.336657>,
      < -0.732822, 0.311132, 1.320860>
    }
    triangle {
      < -0.732821, 0.311132, 1.286956>,
      < -0.732822, 0.311132, 1.320860>,
      < -0.732086, 0.309025, 1.303908>
    }
    texture {steer2}
  }
  // steer1
  union {
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.283256, -0.386193, 1.335882>,
      < -3.284646, -0.382211, 1.303851>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.284646, -0.382211, 1.303851>,
      < -3.283254, -0.386192, 1.271821>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.283254, -0.386192, 1.271821>,
      < -3.279176, -0.397863, 1.241973>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.279176, -0.397863, 1.241973>,
      < -3.272689, -0.416430, 1.216342>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.272689, -0.416430, 1.216342>,
      < -3.264235, -0.440627, 1.196674>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.264235, -0.440627, 1.196674>,
      < -3.254391, -0.468805, 1.184311>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.254391, -0.468805, 1.184311>,
      < -3.243828, -0.499044, 1.180094>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.243828, -0.499044, 1.180094>,
      < -3.233264, -0.529282, 1.184311>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.233264, -0.529282, 1.184311>,
      < -3.223421, -0.557460, 1.196674>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.223421, -0.557460, 1.196674>,
      < -3.214969, -0.581658, 1.216342>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.214969, -0.581658, 1.216342>,
      < -3.208483, -0.600225, 1.241973>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.208483, -0.600225, 1.241973>,
      < -3.204407, -0.611897, 1.271821>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.204407, -0.611897, 1.271821>,
      < -3.203017, -0.615878, 1.303851>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.203017, -0.615878, 1.303851>,
      < -3.204409, -0.611898, 1.335882>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.204409, -0.611898, 1.335882>,
      < -3.208487, -0.600226, 1.365730>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.208487, -0.600226, 1.365730>,
      < -3.214974, -0.581660, 1.391361>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.214974, -0.581660, 1.391361>,
      < -3.223428, -0.557463, 1.411028>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.223428, -0.557463, 1.411028>,
      < -3.233271, -0.529285, 1.423392>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.233271, -0.529285, 1.423392>,
      < -3.243835, -0.499046, 1.427609>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.243835, -0.499046, 1.427609>,
      < -3.254399, -0.468807, 1.423392>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.254399, -0.468807, 1.423392>,
      < -3.264242, -0.440629, 1.411028>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.264242, -0.440629, 1.411028>,
      < -3.272694, -0.416432, 1.391361>
    }
    texture {steer1}
  }
  // steer2
  union {
    triangle {
      < -0.803509, 0.311191, 1.402537>,
      < -0.807983, 0.323998, 1.411211>,
      < -0.809014, 0.316840, 1.360629>
    }
    triangle {
      < -0.803509, 0.311191, 1.402537>,
      < -0.809014, 0.316840, 1.360629>,
      < -0.804541, 0.304034, 1.350220>
    }
    triangle {
      < -0.807983, 0.323998, 1.411211>,
      < -0.689467, 0.399384, 1.664121>,
      < -0.661127, 0.409284, 1.664122>
    }
    triangle {
      < -0.807983, 0.323998, 1.411211>,
      < -0.661127, 0.409284, 1.664122>,
      < -0.742888, 0.339941, 1.360631>
    }
    triangle {
      < -0.807983, 0.323998, 1.411211>,
      < -0.742888, 0.339941, 1.360631>,
      < -0.809014, 0.316840, 1.360629>
    }
    triangle {
      < -0.661127, 0.409284, 1.664122>,
      < -0.656653, 0.396478, 1.664122>,
      < -0.738414, 0.327135, 1.350222>
    }
    triangle {
      < -0.661127, 0.409284, 1.664122>,
      < -0.738414, 0.327135, 1.350222>,
      < -0.742888, 0.339941, 1.360631>
    }
    triangle {
      < -0.656653, 0.396478, 1.664122>,
      < -0.684994, 0.386578, 1.664121>,
      < -0.803509, 0.311191, 1.402537>
    }
    triangle {
      < -0.656653, 0.396478, 1.664122>,
      < -0.803509, 0.311191, 1.402537>,
      < -0.804541, 0.304034, 1.350220>
    }
    triangle {
      < -0.656653, 0.396478, 1.664122>,
      < -0.804541, 0.304034, 1.350220>,
      < -0.738414, 0.327135, 1.350222>
    }
    triangle {
      < -0.689445, 0.399392, 0.943698>,
      < -0.684972, 0.386586, 0.943698>,
      < -0.803503, 0.311194, 1.205276>
    }
    triangle {
      < -0.689445, 0.399392, 0.943698>,
      < -0.803503, 0.311194, 1.205276>,
      < -0.807977, 0.324000, 1.196603>
    }
    triangle {
      < -0.803503, 0.311194, 1.205276>,
      < -0.684972, 0.386586, 0.943698>,
      < -0.656632, 0.396486, 0.943699>
    }
    triangle {
      < -0.803503, 0.311194, 1.205276>,
      < -0.656632, 0.396486, 0.943699>,
      < -0.738411, 0.327136, 1.257594>
    }
    triangle {
      < -0.803503, 0.311194, 1.205276>,
      < -0.738411, 0.327136, 1.257594>,
      < -0.804538, 0.304035, 1.257593>
    }
    triangle {
      < -0.656632, 0.396486, 0.943699>,
      < -0.661105, 0.409292, 0.943699>,
      < -0.742884, 0.339942, 1.247185>
    }
    triangle {
      < -0.656632, 0.396486, 0.943699>,
      < -0.742884, 0.339942, 1.247185>,
      < -0.738411, 0.327136, 1.257594>
    }
    triangle {
      < -0.661105, 0.409292, 0.943699>,
      < -0.689445, 0.399392, 0.943698>,
      < -0.807977, 0.324000, 1.196603>
    }
    triangle {
      < -0.661105, 0.409292, 0.943699>,
      < -0.807977, 0.324000, 1.196603>,
      < -0.809011, 0.316842, 1.247184>
    }
    triangle {
      < -0.661105, 0.409292, 0.943699>,
      < -0.809011, 0.316842, 1.247184>,
      < -0.742884, 0.339942, 1.247185>
    }
    triangle {
      < -0.804538, 0.304035, 1.257593>,
      < -0.809011, 0.316842, 1.247184>,
      < -0.807977, 0.324000, 1.196603>
    }
    triangle {
      < -0.804538, 0.304035, 1.257593>,
      < -0.807977, 0.324000, 1.196603>,
      < -0.803503, 0.311194, 1.205276>
    }
    triangle {
      < -0.684994, 0.386578, 1.664121>,
      < -0.689467, 0.399384, 1.664121>,
      < -0.807983, 0.323998, 1.411211>
    }
    triangle {
      < -0.684994, 0.386578, 1.664121>,
      < -0.807983, 0.323998, 1.411211>,
      < -0.803509, 0.311191, 1.402537>
    }
    texture {steer2}
  }
  // steer1
  union {
    triangle {
      < -0.815797, 0.250088, 1.328967>,
      < -0.814708, 0.246973, 1.303906>,
      < -0.798212, 0.285924, 1.303907>
    }
    triangle {
      < -0.815797, 0.250088, 1.328967>,
      < -0.798212, 0.285924, 1.303907>,
      < -0.798949, 0.288031, 1.320859>
    }
    triangle {
      < -0.814708, 0.246973, 1.303906>,
      < -0.815795, 0.250088, 1.278845>,
      < -0.798948, 0.288031, 1.286955>
    }
    triangle {
      < -0.814708, 0.246973, 1.303906>,
      < -0.798948, 0.288031, 1.286955>,
      < -0.798212, 0.285924, 1.303907>
    }
    triangle {
      < -0.815795, 0.250088, 1.278845>,
      < -0.818985, 0.259221, 1.255491>,
      < -0.801105, 0.294209, 1.271158>
    }
    triangle {
      < -0.815795, 0.250088, 1.278845>,
      < -0.801105, 0.294209, 1.271158>,
      < -0.798948, 0.288031, 1.286955>
    }
    triangle {
      < -0.818985, 0.259221, 1.255491>,
      < -0.824059, 0.273748, 1.235437>,
      < -0.804538, 0.304035, 1.257593>
    }
    triangle {
      < -0.818985, 0.259221, 1.255491>,
      < -0.804538, 0.304035, 1.257593>,
      < -0.801105, 0.294209, 1.271158>
    }
    triangle {
      < -0.824059, 0.273748, 1.235437>,
      < -0.830672, 0.292680, 1.220049>,
      < -0.809011, 0.316842, 1.247184>
    }
    triangle {
      < -0.824059, 0.273748, 1.235437>,
      < -0.809011, 0.316842, 1.247184>,
      < -0.804538, 0.304035, 1.257593>
    }
    triangle {
      < -0.830672, 0.292680, 1.220049>,
      < -0.838374, 0.314727, 1.210376>,
      < -0.814221, 0.331755, 1.240641>
    }
    triangle {
      < -0.830672, 0.292680, 1.220049>,
      < -0.814221, 0.331755, 1.240641>,
      < -0.809011, 0.316842, 1.247184>
    }
    triangle {
      < -0.838374, 0.314727, 1.210376>,
      < -0.846639, 0.338386, 1.207077>,
      < -0.819811, 0.347758, 1.238409>
    }
    triangle {
      < -0.838374, 0.314727, 1.210376>,
      < -0.819811, 0.347758, 1.238409>,
      < -0.814221, 0.331755, 1.240641>
    }
    triangle {
      < -0.846639, 0.338386, 1.207077>,
      < -0.854904, 0.362045, 1.210376>,
      < -0.825402, 0.363762, 1.240641>
    }
    triangle {
      < -0.846639, 0.338386, 1.207077>,
      < -0.825402, 0.363762, 1.240641>,
      < -0.819811, 0.347758, 1.238409>
    }
    triangle {
      < -0.854904, 0.362045, 1.210376>,
      < -0.862606, 0.384092, 1.220049>,
      < -0.830612, 0.378675, 1.247184>
    }
    triangle {
      < -0.854904, 0.362045, 1.210376>,
      < -0.830612, 0.378675, 1.247184>,
      < -0.825402, 0.363762, 1.240641>
    }
    triangle {
      < -0.862606, 0.384092, 1.220049>,
      < -0.869220, 0.403024, 1.235437>,
      < -0.835086, 0.391481, 1.257593>
    }
    triangle {
      < -0.862606, 0.384092, 1.220049>,
      < -0.835086, 0.391481, 1.257593>,
      < -0.830612, 0.378675, 1.247184>
    }
    triangle {
      < -0.869220, 0.403024, 1.235437>,
      < -0.874296, 0.417551, 1.255491>,
      < -0.838519, 0.401307, 1.271158>
    }
    triangle {
      < -0.869220, 0.403024, 1.235437>,
      < -0.838519, 0.401307, 1.271158>,
      < -0.835086, 0.391481, 1.257593>
    }
    triangle {
      < -0.874296, 0.417551, 1.255491>,
      < -0.877487, 0.426683, 1.278845>,
      < -0.840677, 0.407484, 1.286955>
    }
    triangle {
      < -0.874296, 0.417551, 1.255491>,
      < -0.840677, 0.407484, 1.286955>,
      < -0.838519, 0.401307, 1.271158>
    }
    triangle {
      < -0.877487, 0.426683, 1.278845>,
      < -0.878576, 0.429797, 1.303906>,
      < -0.841414, 0.409591, 1.303907>
    }
    triangle {
      < -0.877487, 0.426683, 1.278845>,
      < -0.841414, 0.409591, 1.303907>,
      < -0.840677, 0.407484, 1.286955>
    }
    triangle {
      < -0.878576, 0.429797, 1.303906>,
      < -0.877488, 0.426682, 1.328967>,
      < -0.840678, 0.407484, 1.320859>
    }
    triangle {
      < -0.878576, 0.429797, 1.303906>,
      < -0.840678, 0.407484, 1.320859>,
      < -0.841414, 0.409591, 1.303907>
    }
    triangle {
      < -0.877488, 0.426682, 1.328967>,
      < -0.874299, 0.417550, 1.352321>,
      < -0.838521, 0.401306, 1.336655>
    }
    triangle {
      < -0.877488, 0.426682, 1.328967>,
      < -0.838521, 0.401306, 1.336655>,
      < -0.840678, 0.407484, 1.320859>
    }
    triangle {
      < -0.874299, 0.417550, 1.352321>,
      < -0.869224, 0.403023, 1.372375>,
      < -0.835089, 0.391480, 1.350220>
    }
    triangle {
      < -0.874299, 0.417550, 1.352321>,
      < -0.835089, 0.391480, 1.350220>,
      < -0.838521, 0.401306, 1.336655>
    }
    triangle {
      < -0.869224, 0.403023, 1.372375>,
      < -0.862611, 0.384090, 1.387763>,
      < -0.830615, 0.378674, 1.360629>
    }
    triangle {
      < -0.869224, 0.403023, 1.372375>,
      < -0.830615, 0.378674, 1.360629>,
      < -0.835089, 0.391480, 1.350220>
    }
    triangle {
      < -0.862611, 0.384090, 1.387763>,
      < -0.854910, 0.362044, 1.397436>,
      < -0.825406, 0.363761, 1.367172>
    }
    triangle {
      < -0.862611, 0.384090, 1.387763>,
      < -0.825406, 0.363761, 1.367172>,
      < -0.830615, 0.378674, 1.360629>
    }
    triangle {
      < -0.854910, 0.362044, 1.397436>,
      < -0.846645, 0.338384, 1.400735>,
      < -0.819815, 0.347757, 1.369404>
    }
    triangle {
      < -0.854910, 0.362044, 1.397436>,
      < -0.819815, 0.347757, 1.369404>,
      < -0.825406, 0.363761, 1.367172>
    }
    triangle {
      < -0.846645, 0.338384, 1.400735>,
      < -0.838380, 0.314725, 1.397436>,
      < -0.814224, 0.331753, 1.367172>
    }
    triangle {
      < -0.846645, 0.338384, 1.400735>,
      < -0.814224, 0.331753, 1.367172>,
      < -0.819815, 0.347757, 1.369404>
    }
    triangle {
      < -0.838380, 0.314725, 1.397436>,
      < -0.830678, 0.292678, 1.387763>,
      < -0.809014, 0.316840, 1.360629>
    }
    triangle {
      < -0.838380, 0.314725, 1.397436>,
      < -0.809014, 0.316840, 1.360629>,
      < -0.814224, 0.331753, 1.367172>
    }
    triangle {
      < -0.830678, 0.292678, 1.387763>,
      < -0.824063, 0.273747, 1.372375>,
      < -0.804541, 0.304034, 1.350220>
    }
    triangle {
      < -0.830678, 0.292678, 1.387763>,
      < -0.804541, 0.304034, 1.350220>,
      < -0.809014, 0.316840, 1.360629>
    }
    triangle {
      < -0.824063, 0.273747, 1.372375>,
      < -0.818988, 0.259220, 1.352321>,
      < -0.801107, 0.294208, 1.336655>
    }
    triangle {
      < -0.824063, 0.273747, 1.372375>,
      < -0.801107, 0.294208, 1.336655>,
      < -0.804541, 0.304034, 1.350220>
    }
    triangle {
      < -0.818988, 0.259220, 1.352321>,
      < -0.815797, 0.250088, 1.328967>,
      < -0.798949, 0.288031, 1.320859>
    }
    triangle {
      < -0.818988, 0.259220, 1.352321>,
      < -0.798949, 0.288031, 1.320859>,
      < -0.801107, 0.294208, 1.336655>
    }
    triangle {
      < -0.549296, 0.452789, 1.917827>,
      < -0.584265, 0.438799, 1.938595>,
      < -0.575812, 0.414602, 1.938595>
    }
    triangle {
      < -0.549296, 0.452789, 1.917827>,
      < -0.575812, 0.414602, 1.938595>,
      < -0.542682, 0.433857, 1.917827>
    }
    triangle {
      < -0.924721, 0.218414, 1.391413>,
      < -0.918234, 0.199847, 1.365782>,
      < -0.818988, 0.259220, 1.352321>
    }
    triangle {
      < -0.924721, 0.218414, 1.391413>,
      < -0.818988, 0.259220, 1.352321>,
      < -0.824063, 0.273747, 1.372375>
    }
    triangle {
      < -0.918234, 0.199847, 1.365782>,
      < -0.914156, 0.188175, 1.335934>,
      < -0.815797, 0.250088, 1.328967>
    }
    triangle {
      < -0.918234, 0.199847, 1.365782>,
      < -0.815797, 0.250088, 1.328967>,
      < -0.818988, 0.259220, 1.352321>
    }
    triangle {
      < -0.914156, 0.188175, 1.335934>,
      < -0.912764, 0.184195, 1.303903>,
      < -0.814708, 0.246973, 1.303906>
    }
    triangle {
      < -0.914156, 0.188175, 1.335934>,
      < -0.814708, 0.246973, 1.303906>,
      < -0.815797, 0.250088, 1.328967>
    }
    triangle {
      < -0.912764, 0.184195, 1.303903>,
      < -0.914154, 0.188176, 1.271873>,
      < -0.815795, 0.250088, 1.278845>
    }
    triangle {
      < -0.912764, 0.184195, 1.303903>,
      < -0.815795, 0.250088, 1.278845>,
      < -0.814708, 0.246973, 1.303906>
    }
    triangle {
      < -0.914154, 0.188176, 1.271873>,
      < -0.918230, 0.199848, 1.242025>,
      < -0.818985, 0.259221, 1.255491>
    }
    triangle {
      < -0.914154, 0.188176, 1.271873>,
      < -0.818985, 0.259221, 1.255491>,
      < -0.815795, 0.250088, 1.278845>
    }
    triangle {
      < -0.918230, 0.199848, 1.242025>,
      < -0.924716, 0.218415, 1.216394>,
      < -0.824059, 0.273748, 1.235437>
    }
    triangle {
      < -0.918230, 0.199848, 1.242025>,
      < -0.824059, 0.273748, 1.235437>,
      < -0.818985, 0.259221, 1.255491>
    }
    triangle {
      < -0.542645, 0.433870, 0.689999>,
      < -0.575774, 0.414616, 0.669229>,
      < -0.584227, 0.438813, 0.669229>
    }
    triangle {
      < -0.542645, 0.433870, 0.689999>,
      < -0.584227, 0.438813, 0.669229>,
      < -0.549259, 0.452802, 0.689999>
    }
    triangle {
      < -0.933168, 0.242613, 1.196726>,
      < -0.943011, 0.270791, 1.184363>,
      < -0.838374, 0.314727, 1.210376>
    }
    triangle {
      < -0.933168, 0.242613, 1.196726>,
      < -0.838374, 0.314727, 1.210376>,
      < -0.830672, 0.292680, 1.220049>
    }
    triangle {
      < -0.943011, 0.270791, 1.184363>,
      < -0.953575, 0.301030, 1.180146>,
      < -0.846639, 0.338386, 1.207077>
    }
    triangle {
      < -0.943011, 0.270791, 1.184363>,
      < -0.846639, 0.338386, 1.207077>,
      < -0.838374, 0.314727, 1.210376>
    }
    triangle {
      < -0.953575, 0.301030, 1.180146>,
      < -0.964138, 0.331268, 1.184363>,
      < -0.854904, 0.362045, 1.210376>
    }
    triangle {
      < -0.953575, 0.301030, 1.180146>,
      < -0.854904, 0.362045, 1.210376>,
      < -0.846639, 0.338386, 1.207077>
    }
    triangle {
      < -0.964138, 0.331268, 1.184363>,
      < -0.973982, 0.359446, 1.196726>,
      < -0.862606, 0.384092, 1.220049>
    }
    triangle {
      < -0.964138, 0.331268, 1.184363>,
      < -0.862606, 0.384092, 1.220049>,
      < -0.854904, 0.362045, 1.210376>
    }
    triangle {
      < -0.973982, 0.359446, 1.196726>,
      < -0.982436, 0.383643, 1.216394>,
      < -0.869220, 0.403024, 1.235437>
    }
    triangle {
      < -0.973982, 0.359446, 1.196726>,
      < -0.869220, 0.403024, 1.235437>,
      < -0.862606, 0.384092, 1.220049>
    }
    triangle {
      < -0.982436, 0.383643, 1.216394>,
      < -0.988923, 0.402210, 1.242025>,
      < -0.874296, 0.417551, 1.255491>
    }
    triangle {
      < -0.982436, 0.383643, 1.216394>,
      < -0.874296, 0.417551, 1.255491>,
      < -0.869220, 0.403024, 1.235437>
    }
    triangle {
      < -0.988923, 0.402210, 1.242025>,
      < -0.993001, 0.413881, 1.271873>,
      < -0.877487, 0.426683, 1.278845>
    }
    triangle {
      < -0.988923, 0.402210, 1.242025>,
      < -0.877487, 0.426683, 1.278845>,
      < -0.874296, 0.417551, 1.255491>
    }
    triangle {
      < -0.993001, 0.413881, 1.271873>,
      < -0.994393, 0.417862, 1.303903>,
      < -0.878576, 0.429797, 1.303906>
    }
    triangle {
      < -0.993001, 0.413881, 1.271873>,
      < -0.878576, 0.429797, 1.303906>,
      < -0.877487, 0.426683, 1.278845>
    }
    triangle {
      < -0.994393, 0.417862, 1.303903>,
      < -0.993003, 0.413881, 1.335934>,
      < -0.877488, 0.426682, 1.328967>
    }
    triangle {
      < -0.994393, 0.417862, 1.303903>,
      < -0.877488, 0.426682, 1.328967>,
      < -0.878576, 0.429797, 1.303906>
    }
    triangle {
      < -0.993003, 0.413881, 1.335934>,
      < -0.988927, 0.402209, 1.365782>,
      < -0.874299, 0.417550, 1.352321>
    }
    triangle {
      < -0.993003, 0.413881, 1.335934>,
      < -0.874299, 0.417550, 1.352321>,
      < -0.877488, 0.426682, 1.328967>
    }
    triangle {
      < -0.988927, 0.402209, 1.365782>,
      < -0.982441, 0.383641, 1.391413>,
      < -0.869224, 0.403023, 1.372375>
    }
    triangle {
      < -0.988927, 0.402209, 1.365782>,
      < -0.869224, 0.403023, 1.372375>,
      < -0.874299, 0.417550, 1.352321>
    }
    triangle {
      < -0.982441, 0.383641, 1.391413>,
      < -0.973989, 0.359444, 1.411081>,
      < -0.862611, 0.384090, 1.387763>
    }
    triangle {
      < -0.982441, 0.383641, 1.391413>,
      < -0.862611, 0.384090, 1.387763>,
      < -0.869224, 0.403023, 1.372375>
    }
    triangle {
      < -0.973989, 0.359444, 1.411081>,
      < -0.964146, 0.331266, 1.423444>,
      < -0.854910, 0.362044, 1.397436>
    }
    triangle {
      < -0.973989, 0.359444, 1.411081>,
      < -0.854910, 0.362044, 1.397436>,
      < -0.862611, 0.384090, 1.387763>
    }
    triangle {
      < -0.964146, 0.331266, 1.423444>,
      < -0.953582, 0.301027, 1.427661>,
      < -0.846645, 0.338384, 1.400735>
    }
    triangle {
      < -0.964146, 0.331266, 1.423444>,
      < -0.846645, 0.338384, 1.400735>,
      < -0.854910, 0.362044, 1.397436>
    }
    triangle {
      < -0.953582, 0.301027, 1.427661>,
      < -0.943018, 0.270788, 1.423444>,
      < -0.838380, 0.314725, 1.397436>
    }
    triangle {
      < -0.953582, 0.301027, 1.427661>,
      < -0.838380, 0.314725, 1.397436>,
      < -0.846645, 0.338384, 1.400735>
    }
    triangle {
      < -0.943018, 0.270788, 1.423444>,
      < -0.933174, 0.242610, 1.411081>,
      < -0.830678, 0.292678, 1.387763>
    }
    triangle {
      < -0.943018, 0.270788, 1.423444>,
      < -0.830678, 0.292678, 1.387763>,
      < -0.838380, 0.314725, 1.397436>
    }
    triangle {
      < -3.254399, -0.468807, 1.423392>,
      < -3.243835, -0.499046, 1.427609>,
      < -0.953582, 0.301027, 1.427661>
    }
    triangle {
      < -3.254399, -0.468807, 1.423392>,
      < -0.953582, 0.301027, 1.427661>,
      < -0.964146, 0.331266, 1.423444>
    }
    triangle {
      < -3.243835, -0.499046, 1.427609>,
      < -3.233271, -0.529285, 1.423392>,
      < -0.943018, 0.270788, 1.423444>
    }
    triangle {
      < -3.243835, -0.499046, 1.427609>,
      < -0.943018, 0.270788, 1.423444>,
      < -0.953582, 0.301027, 1.427661>
    }
    triangle {
      < -3.233271, -0.529285, 1.423392>,
      < -3.223428, -0.557463, 1.411028>,
      < -0.933174, 0.242610, 1.411081>
    }
    triangle {
      < -3.233271, -0.529285, 1.423392>,
      < -0.933174, 0.242610, 1.411081>,
      < -0.943018, 0.270788, 1.423444>
    }
    triangle {
      < -3.223428, -0.557463, 1.411028>,
      < -3.214974, -0.581660, 1.391361>,
      < -0.924721, 0.218414, 1.391413>
    }
    triangle {
      < -3.223428, -0.557463, 1.411028>,
      < -0.924721, 0.218414, 1.391413>,
      < -0.933174, 0.242610, 1.411081>
    }
    triangle {
      < -3.214974, -0.581660, 1.391361>,
      < -3.208487, -0.600226, 1.365730>,
      < -0.918234, 0.199847, 1.365782>
    }
    triangle {
      < -3.214974, -0.581660, 1.391361>,
      < -0.918234, 0.199847, 1.365782>,
      < -0.924721, 0.218414, 1.391413>
    }
    triangle {
      < -3.208487, -0.600226, 1.365730>,
      < -3.204409, -0.611898, 1.335882>,
      < -0.914156, 0.188175, 1.335934>
    }
    triangle {
      < -3.208487, -0.600226, 1.365730>,
      < -0.914156, 0.188175, 1.335934>,
      < -0.918234, 0.199847, 1.365782>
    }
    triangle {
      < -3.204409, -0.611898, 1.335882>,
      < -3.203017, -0.615878, 1.303851>,
      < -0.912764, 0.184195, 1.303903>
    }
    triangle {
      < -3.204409, -0.611898, 1.335882>,
      < -0.912764, 0.184195, 1.303903>,
      < -0.914156, 0.188175, 1.335934>
    }
    triangle {
      < -3.203017, -0.615878, 1.303851>,
      < -3.204407, -0.611897, 1.271821>,
      < -0.914154, 0.188176, 1.271873>
    }
    triangle {
      < -3.203017, -0.615878, 1.303851>,
      < -0.914154, 0.188176, 1.271873>,
      < -0.912764, 0.184195, 1.303903>
    }
    triangle {
      < -3.204407, -0.611897, 1.271821>,
      < -3.208483, -0.600225, 1.241973>,
      < -0.918230, 0.199848, 1.242025>
    }
    triangle {
      < -3.204407, -0.611897, 1.271821>,
      < -0.918230, 0.199848, 1.242025>,
      < -0.914154, 0.188176, 1.271873>
    }
    triangle {
      < -3.208483, -0.600225, 1.241973>,
      < -3.214969, -0.581658, 1.216342>,
      < -0.924716, 0.218415, 1.216394>
    }
    triangle {
      < -3.208483, -0.600225, 1.241973>,
      < -0.924716, 0.218415, 1.216394>,
      < -0.918230, 0.199848, 1.242025>
    }
    triangle {
      < -3.214969, -0.581658, 1.216342>,
      < -3.223421, -0.557460, 1.196674>,
      < -0.933168, 0.242613, 1.196726>
    }
    triangle {
      < -3.214969, -0.581658, 1.216342>,
      < -0.933168, 0.242613, 1.196726>,
      < -0.924716, 0.218415, 1.216394>
    }
    triangle {
      < -3.223421, -0.557460, 1.196674>,
      < -3.233264, -0.529282, 1.184311>,
      < -0.943011, 0.270791, 1.184363>
    }
    triangle {
      < -3.223421, -0.557460, 1.196674>,
      < -0.943011, 0.270791, 1.184363>,
      < -0.933168, 0.242613, 1.196726>
    }
    triangle {
      < -3.233264, -0.529282, 1.184311>,
      < -3.243828, -0.499044, 1.180094>,
      < -0.953575, 0.301030, 1.180146>
    }
    triangle {
      < -3.233264, -0.529282, 1.184311>,
      < -0.953575, 0.301030, 1.180146>,
      < -0.943011, 0.270791, 1.184363>
    }
    triangle {
      < -3.243828, -0.499044, 1.180094>,
      < -3.254391, -0.468805, 1.184311>,
      < -0.964138, 0.331268, 1.184363>
    }
    triangle {
      < -3.243828, -0.499044, 1.180094>,
      < -0.964138, 0.331268, 1.184363>,
      < -0.953575, 0.301030, 1.180146>
    }
    triangle {
      < -3.254391, -0.468805, 1.184311>,
      < -3.264235, -0.440627, 1.196674>,
      < -0.973982, 0.359446, 1.196726>
    }
    triangle {
      < -3.254391, -0.468805, 1.184311>,
      < -0.973982, 0.359446, 1.196726>,
      < -0.964138, 0.331268, 1.184363>
    }
    triangle {
      < -3.264235, -0.440627, 1.196674>,
      < -3.272689, -0.416430, 1.216342>,
      < -0.982436, 0.383643, 1.216394>
    }
    triangle {
      < -3.264235, -0.440627, 1.196674>,
      < -0.982436, 0.383643, 1.216394>,
      < -0.973982, 0.359446, 1.196726>
    }
    triangle {
      < -3.272689, -0.416430, 1.216342>,
      < -3.279176, -0.397863, 1.241973>,
      < -0.988923, 0.402210, 1.242025>
    }
    triangle {
      < -3.272689, -0.416430, 1.216342>,
      < -0.988923, 0.402210, 1.242025>,
      < -0.982436, 0.383643, 1.216394>
    }
    triangle {
      < -3.279176, -0.397863, 1.241973>,
      < -3.283254, -0.386192, 1.271821>,
      < -0.993001, 0.413881, 1.271873>
    }
    triangle {
      < -3.279176, -0.397863, 1.241973>,
      < -0.993001, 0.413881, 1.271873>,
      < -0.988923, 0.402210, 1.242025>
    }
    triangle {
      < -3.283254, -0.386192, 1.271821>,
      < -3.284646, -0.382211, 1.303851>,
      < -0.994393, 0.417862, 1.303903>
    }
    triangle {
      < -3.283254, -0.386192, 1.271821>,
      < -0.994393, 0.417862, 1.303903>,
      < -0.993001, 0.413881, 1.271873>
    }
    triangle {
      < -3.284646, -0.382211, 1.303851>,
      < -3.283256, -0.386193, 1.335882>,
      < -0.993003, 0.413881, 1.335934>
    }
    triangle {
      < -3.284646, -0.382211, 1.303851>,
      < -0.993003, 0.413881, 1.335934>,
      < -0.994393, 0.417862, 1.303903>
    }
    triangle {
      < -3.283256, -0.386193, 1.335882>,
      < -3.279180, -0.397865, 1.365730>,
      < -0.988927, 0.402209, 1.365782>
    }
    triangle {
      < -3.283256, -0.386193, 1.335882>,
      < -0.988927, 0.402209, 1.365782>,
      < -0.993003, 0.413881, 1.335934>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -3.272694, -0.416432, 1.391361>,
      < -0.982441, 0.383641, 1.391413>
    }
    triangle {
      < -3.279180, -0.397865, 1.365730>,
      < -0.982441, 0.383641, 1.391413>,
      < -0.988927, 0.402209, 1.365782>
    }
    triangle {
      < -3.272694, -0.416432, 1.391361>,
      < -3.264242, -0.440629, 1.411028>,
      < -0.973989, 0.359444, 1.411081>
    }
    triangle {
      < -3.272694, -0.416432, 1.391361>,
      < -0.973989, 0.359444, 1.411081>,
      < -0.982441, 0.383641, 1.391413>
    }
    triangle {
      < -3.264242, -0.440629, 1.411028>,
      < -3.254399, -0.468807, 1.423392>,
      < -0.964146, 0.331266, 1.423444>
    }
    triangle {
      < -3.264242, -0.440629, 1.411028>,
      < -0.964146, 0.331266, 1.423444>,
      < -0.973989, 0.359444, 1.411081>
    }
    triangle {
      < -0.575774, 0.414616, 0.669229>,
      < -0.542645, 0.433870, 0.689999>,
      < -0.824059, 0.273748, 1.235437>
    }
    triangle {
      < -0.575774, 0.414616, 0.669229>,
      < -0.824059, 0.273748, 1.235437>,
      < -0.924716, 0.218415, 1.216394>
    }
    triangle {
      < -0.542645, 0.433870, 0.689999>,
      < -0.549259, 0.452802, 0.689999>,
      < -0.830672, 0.292680, 1.220049>
    }
    triangle {
      < -0.542645, 0.433870, 0.689999>,
      < -0.830672, 0.292680, 1.220049>,
      < -0.824059, 0.273748, 1.235437>
    }
    triangle {
      < -0.549259, 0.452802, 0.689999>,
      < -0.584227, 0.438813, 0.669229>,
      < -0.933168, 0.242613, 1.196726>
    }
    triangle {
      < -0.549259, 0.452802, 0.689999>,
      < -0.933168, 0.242613, 1.196726>,
      < -0.830672, 0.292680, 1.220049>
    }
    triangle {
      < -0.584227, 0.438813, 0.669229>,
      < -0.575774, 0.414616, 0.669229>,
      < -0.924716, 0.218415, 1.216394>
    }
    triangle {
      < -0.584227, 0.438813, 0.669229>,
      < -0.924716, 0.218415, 1.216394>,
      < -0.933168, 0.242613, 1.196726>
    }
    triangle {
      < -0.584265, 0.438799, 1.938595>,
      < -0.549296, 0.452789, 1.917827>,
      < -0.830678, 0.292678, 1.387763>
    }
    triangle {
      < -0.584265, 0.438799, 1.938595>,
      < -0.830678, 0.292678, 1.387763>,
      < -0.933174, 0.242610, 1.411081>
    }
    triangle {
      < -0.549296, 0.452789, 1.917827>,
      < -0.542682, 0.433857, 1.917827>,
      < -0.824063, 0.273747, 1.372375>
    }
    triangle {
      < -0.549296, 0.452789, 1.917827>,
      < -0.824063, 0.273747, 1.372375>,
      < -0.830678, 0.292678, 1.387763>
    }
    triangle {
      < -0.542682, 0.433857, 1.917827>,
      < -0.575812, 0.414602, 1.938595>,
      < -0.924721, 0.218414, 1.391413>
    }
    triangle {
      < -0.542682, 0.433857, 1.917827>,
      < -0.924721, 0.218414, 1.391413>,
      < -0.824063, 0.273747, 1.372375>
    }
    triangle {
      < -0.575812, 0.414602, 1.938595>,
      < -0.584265, 0.438799, 1.938595>,
      < -0.933174, 0.242610, 1.411081>
    }
    triangle {
      < -0.575812, 0.414602, 1.938595>,
      < -0.933174, 0.242610, 1.411081>,
      < -0.924721, 0.218414, 1.391413>
    }
    texture {steer1}
  }
  // interior
  union {
    triangle {
      < -2.122629, 0.525250, 1.951595>,
      < -2.047460, 0.529835, 1.851686>,
      < -2.047460, 0.540047, 1.636499>
    }
    triangle {
      < -2.122629, 0.525250, 1.951595>,
      < -2.047460, 0.540047, 1.636499>,
      < -2.258311, 0.539354, 1.650110>
    }
    triangle {
      < -2.122629, 0.525250, 1.951595>,
      < -2.258311, 0.539354, 1.650110>,
      < -2.129692, 0.526073, 1.940406>
    }
    triangle {
      < -2.047460, 0.540047, 1.636499>,
      < -2.047460, 0.579575, 1.090915>,
      < -2.366911, 0.579198, 1.099482>
    }
    triangle {
      < -2.047460, 0.540047, 1.636499>,
      < -2.366911, 0.579198, 1.099482>,
      < -2.258311, 0.539354, 1.650110>
    }
    triangle {
      < -1.687726, 0.711366, 0.704818>,
      < -1.565481, 0.591046, 0.705669>,
      < -1.766871, 0.669704, 0.705244>
    }
    triangle {
      < -1.487570, 0.503308, 1.938999>,
      < -1.488833, 0.434764, 1.943825>,
      < -1.534226, 0.489469, 0.713341>
    }
    triangle {
      < -1.487570, 0.503308, 1.938999>,
      < -1.534226, 0.489469, 0.713341>,
      < -1.534907, 0.561359, 0.709689>
    }
    triangle {
      < -1.534543, 0.510023, 0.000393>,
      < -1.534543, 0.590023, 0.000393>,
      < -1.534907, 0.561359, 0.709689>
    }
    triangle {
      < -1.534543, 0.510023, 0.000393>,
      < -1.534907, 0.561359, 0.709689>,
      < -1.534226, 0.489469, 0.713341>
    }
    triangle {
      < -1.645992, 0.783910, 0.812209>,
      < -1.679290, 0.780304, 0.805599>,
      < -1.639600, 0.780304, 1.851668>
    }
    triangle {
      < -1.645992, 0.783910, 0.812209>,
      < -1.639600, 0.780304, 1.851668>,
      < -1.608079, 0.784003, 1.845209>
    }
    triangle {
      < -1.534543, 0.590023, 0.000393>,
      < -1.565518, 0.611684, 0.000895>,
      < -1.565481, 0.591046, 0.705669>
    }
    triangle {
      < -1.534543, 0.590023, 0.000393>,
      < -1.565481, 0.591046, 0.705669>,
      < -1.534907, 0.561359, 0.709689>
    }
    triangle {
      < -1.846007, 0.338840, 0.000393>,
      < -1.534543, 0.510023, 0.000393>,
      < -1.534226, 0.489469, 0.713341>
    }
    triangle {
      < -1.846007, 0.338840, 0.000393>,
      < -1.534226, 0.489469, 0.713341>,
      < -1.845950, 0.338829, 0.705669>
    }
    triangle {
      < -1.488833, 0.434764, 1.943825>,
      < -1.857452, 0.338694, 1.616905>,
      < -1.534226, 0.489469, 0.713341>
    }
    triangle {
      < -1.845919, 0.338823, 1.086187>,
      < -1.683317, 0.079326, 1.086187>,
      < -1.845950, 0.338829, 0.705669>
    }
    triangle {
      < -1.692454, 0.078977, 1.616905>,
      < -1.683317, 0.079326, 1.086187>,
      < -1.845919, 0.338823, 1.086187>
    }
    triangle {
      < -1.692454, 0.078977, 1.616905>,
      < -1.845919, 0.338823, 1.086187>,
      < -1.857452, 0.338694, 1.616905>
    }
    triangle {
      < -1.645417, 0.110211, 1.888693>,
      < -1.692454, 0.078977, 1.616905>,
      < -1.857452, 0.338694, 1.616905>
    }
    triangle {
      < -1.645417, 0.110211, 1.888693>,
      < -1.857452, 0.338694, 1.616905>,
      < -1.798078, 0.350158, 1.888693>
    }
    triangle {
      < -1.724702, 0.369548, 2.050812>,
      < -1.587286, 0.163037, 2.050812>,
      < -1.769608, 0.357681, 1.951595>
    }
    triangle {
      < -1.461509, 0.435837, 2.050812>,
      < -1.724702, 0.369548, 2.050812>,
      < -1.769608, 0.357681, 1.951595>
    }
    triangle {
      < -1.461509, 0.435837, 2.050812>,
      < -1.769608, 0.357681, 1.951595>,
      < -1.488833, 0.434764, 1.943825>
    }
    triangle {
      < -1.461509, 0.496637, 2.050812>,
      < -1.461509, 0.435837, 2.050812>,
      < -1.488833, 0.434764, 1.943825>
    }
    triangle {
      < -1.461509, 0.496637, 2.050812>,
      < -1.488833, 0.434764, 1.943825>,
      < -1.487570, 0.503308, 1.938999>
    }
    triangle {
      < -1.492305, 0.516620, 2.051260>,
      < -1.461509, 0.496637, 2.050812>,
      < -1.487570, 0.503308, 1.938999>
    }
    triangle {
      < -1.492305, 0.516620, 2.051260>,
      < -1.487570, 0.503308, 1.938999>,
      < -1.518209, 0.524000, 1.951595>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -2.122629, 0.525250, 1.951595>,
      < -2.015709, 0.512791, 2.120956>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -2.015709, 0.512791, 2.120956>,
      < -1.492305, 0.516620, 2.051260>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -1.492305, 0.516620, 2.051260>,
      < -1.518209, 0.524000, 1.951595>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -1.518209, 0.524000, 1.951595>,
      < -1.635826, 0.524243, 1.951595>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -1.635826, 0.524243, 1.951595>,
      < -1.753444, 0.524486, 1.951595>
    }
    triangle {
      < -2.366911, 0.579198, 1.099482>,
      < -2.047460, 0.579575, 1.090915>,
      < -2.047460, 0.589177, 0.805620>
    }
    triangle {
      < -2.366911, 0.579198, 1.099482>,
      < -2.047460, 0.589177, 0.805620>,
      < -2.385837, 0.593591, 0.705669>
    }
    triangle {
      < -1.639600, 0.780304, 1.851668>,
      < -1.679290, 0.780304, 0.805599>,
      < -1.761213, 0.752595, 0.805606>
    }
    triangle {
      < -1.639600, 0.780304, 1.851668>,
      < -1.761213, 0.752595, 0.805606>,
      < -1.734753, 0.732814, 1.851674>
    }
    triangle {
      < -1.588868, 0.694643, 1.949859>,
      < -1.642132, 0.674005, 1.950438>,
      < -1.518209, 0.524000, 1.951595>
    }
    triangle {
      < -1.649381, 0.717028, 0.704393>,
      < -1.615904, 0.720597, 0.712120>,
      < -1.534907, 0.561359, 0.709689>
    }
    triangle {
      < -1.649381, 0.717028, 0.704393>,
      < -1.534907, 0.561359, 0.709689>,
      < -1.565481, 0.591046, 0.705669>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.632367, 0.753925, 0.736064>,
      < -1.642397, 0.775029, 0.769428>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.642397, 0.775029, 0.769428>,
      < -1.645992, 0.783910, 0.812209>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.645992, 0.783910, 0.812209>,
      < -1.608079, 0.784003, 1.845209>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.608079, 0.784003, 1.845209>,
      < -1.597889, 0.767074, 1.889124>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.597889, 0.767074, 1.889124>,
      < -1.582003, 0.739513, 1.921468>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.582003, 0.739513, 1.921468>,
      < -1.560417, 0.701323, 1.942241>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.560417, 0.701323, 1.942241>,
      < -1.487570, 0.503308, 1.938999>
    }
    triangle {
      < -1.615904, 0.720597, 0.712120>,
      < -1.487570, 0.503308, 1.938999>,
      < -1.534907, 0.561359, 0.709689>
    }
    triangle {
      < -1.560417, 0.701323, 1.942241>,
      < -1.588868, 0.694643, 1.949859>,
      < -1.518209, 0.524000, 1.951595>
    }
    triangle {
      < -1.560417, 0.701323, 1.942241>,
      < -1.518209, 0.524000, 1.951595>,
      < -1.487570, 0.503308, 1.938999>
    }
    triangle {
      < -1.626441, 0.764920, 1.896140>,
      < -1.639600, 0.780304, 1.851668>,
      < -1.734753, 0.732814, 1.851674>
    }
    triangle {
      < -1.626441, 0.764920, 1.896140>,
      < -1.734753, 0.732814, 1.851674>,
      < -1.715180, 0.721706, 1.898816>
    }
    triangle {
      < -1.608079, 0.784003, 1.845209>,
      < -1.639600, 0.780304, 1.851668>,
      < -1.626441, 0.764920, 1.896140>
    }
    triangle {
      < -1.608079, 0.784003, 1.845209>,
      < -1.626441, 0.764920, 1.896140>,
      < -1.597889, 0.767074, 1.889124>
    }
    triangle {
      < -1.665793, 0.750349, 0.728580>,
      < -1.632367, 0.753925, 0.736064>,
      < -1.615904, 0.720597, 0.712120>
    }
    triangle {
      < -1.665793, 0.750349, 0.728580>,
      < -1.615904, 0.720597, 0.712120>,
      < -1.649381, 0.717028, 0.704393>
    }
    triangle {
      < -1.886817, 0.592043, 0.705669>,
      < -1.966765, 0.591815, 0.719797>,
      < -1.825641, 0.680660, 0.722725>
    }
    triangle {
      < -1.886817, 0.592043, 0.705669>,
      < -1.825641, 0.680660, 0.722725>,
      < -1.766871, 0.669704, 0.705244>
    }
    triangle {
      < -2.015061, 0.527278, 1.904167>,
      < -2.047460, 0.529835, 1.851686>,
      < -2.122629, 0.525250, 1.951595>
    }
    triangle {
      < -1.966765, 0.591815, 0.719797>,
      < -1.886817, 0.592043, 0.705669>,
      < -2.385837, 0.593591, 0.705669>
    }
    triangle {
      < -1.588868, 0.694643, 1.949859>,
      < -1.560417, 0.701323, 1.942241>,
      < -1.582003, 0.739513, 1.921468>
    }
    triangle {
      < -1.588868, 0.694643, 1.949859>,
      < -1.582003, 0.739513, 1.921468>,
      < -1.609046, 0.737003, 1.928882>
    }
    triangle {
      < -1.588868, 0.694643, 1.949859>,
      < -1.609046, 0.737003, 1.928882>,
      < -1.683984, 0.702527, 1.931745>
    }
    triangle {
      < -1.588868, 0.694643, 1.949859>,
      < -1.683984, 0.702527, 1.931745>,
      < -1.642132, 0.674005, 1.950438>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -1.956261, 0.525576, 1.937471>,
      < -2.122629, 0.525250, 1.951595>
    }
    triangle {
      < -1.679290, 0.780304, 0.805599>,
      < -1.645992, 0.783910, 0.812209>,
      < -1.642397, 0.775029, 0.769428>
    }
    triangle {
      < -1.679290, 0.780304, 0.805599>,
      < -1.642397, 0.775029, 0.769428>,
      < -1.675763, 0.771442, 0.762316>
    }
    triangle {
      < -2.020313, 0.590860, 0.753114>,
      < -2.047460, 0.589177, 0.805620>,
      < -1.883937, 0.688886, 0.805613>
    }
    triangle {
      < -2.020313, 0.590860, 0.753114>,
      < -1.883937, 0.688886, 0.805613>,
      < -1.864662, 0.687054, 0.756181>
    }
    triangle {
      < -2.047460, 0.589177, 0.805620>,
      < -2.020313, 0.590860, 0.753114>,
      < -2.385837, 0.593591, 0.705669>
    }
    triangle {
      < -1.609046, 0.737003, 1.928882>,
      < -1.582003, 0.739513, 1.921468>,
      < -1.597889, 0.767074, 1.889124>
    }
    triangle {
      < -1.609046, 0.737003, 1.928882>,
      < -1.597889, 0.767074, 1.889124>,
      < -1.626441, 0.764920, 1.896140>
    }
    triangle {
      < -1.609046, 0.737003, 1.928882>,
      < -1.626441, 0.764920, 1.896140>,
      < -1.715180, 0.721706, 1.898816>
    }
    triangle {
      < -1.609046, 0.737003, 1.928882>,
      < -1.715180, 0.721706, 1.898816>,
      < -1.683984, 0.702527, 1.931745>
    }
    triangle {
      < -1.956261, 0.525576, 1.937471>,
      < -2.015061, 0.527278, 1.904167>,
      < -2.122629, 0.525250, 1.951595>
    }
    triangle {
      < -1.675763, 0.771442, 0.762316>,
      < -1.642397, 0.775029, 0.769428>,
      < -1.632367, 0.753925, 0.736064>
    }
    triangle {
      < -1.675763, 0.771442, 0.762316>,
      < -1.632367, 0.753925, 0.736064>,
      < -1.665793, 0.750349, 0.728580>
    }
    triangle {
      < -1.966765, 0.591815, 0.719797>,
      < -2.020313, 0.590860, 0.753114>,
      < -1.864662, 0.687054, 0.756181>
    }
    triangle {
      < -1.966765, 0.591815, 0.719797>,
      < -1.864662, 0.687054, 0.756181>,
      < -1.825641, 0.680660, 0.722725>
    }
    triangle {
      < -2.020313, 0.590860, 0.753114>,
      < -1.966765, 0.591815, 0.719797>,
      < -2.385837, 0.593591, 0.705669>
    }
    triangle {
      < -1.649381, 0.717028, 0.704393>,
      < -1.565481, 0.591046, 0.705669>,
      < -1.687726, 0.711366, 0.704818>
    }
    triangle {
      < -1.665793, 0.750349, 0.728580>,
      < -1.649381, 0.717028, 0.704393>,
      < -1.687726, 0.711366, 0.704818>
    }
    triangle {
      < -1.665793, 0.750349, 0.728580>,
      < -1.687726, 0.711366, 0.704818>,
      < -1.725316, 0.733505, 0.725653>
    }
    triangle {
      < -1.675763, 0.771442, 0.762316>,
      < -1.665793, 0.750349, 0.728580>,
      < -1.725316, 0.733505, 0.725653>
    }
    triangle {
      < -1.675763, 0.771442, 0.762316>,
      < -1.725316, 0.733505, 0.725653>,
      < -1.749812, 0.747248, 0.759249>
    }
    triangle {
      < -1.679290, 0.780304, 0.805599>,
      < -1.675763, 0.771442, 0.762316>,
      < -1.749812, 0.747248, 0.759249>
    }
    triangle {
      < -1.679290, 0.780304, 0.805599>,
      < -1.749812, 0.747248, 0.759249>,
      < -1.761213, 0.752595, 0.805606>
    }
    triangle {
      < -1.725316, 0.733505, 0.725653>,
      < -1.687726, 0.711366, 0.704818>,
      < -1.766871, 0.669704, 0.705244>
    }
    triangle {
      < -1.725316, 0.733505, 0.725653>,
      < -1.766871, 0.669704, 0.705244>,
      < -1.825641, 0.680660, 0.722725>
    }
    triangle {
      < -1.749812, 0.747248, 0.759249>,
      < -1.725316, 0.733505, 0.725653>,
      < -1.825641, 0.680660, 0.722725>
    }
    triangle {
      < -1.749812, 0.747248, 0.759249>,
      < -1.825641, 0.680660, 0.722725>,
      < -1.864662, 0.687054, 0.756181>
    }
    triangle {
      < -1.761213, 0.752595, 0.805606>,
      < -1.749812, 0.747248, 0.759249>,
      < -1.864662, 0.687054, 0.756181>
    }
    triangle {
      < -1.761213, 0.752595, 0.805606>,
      < -1.864662, 0.687054, 0.756181>,
      < -1.883937, 0.688886, 0.805613>
    }
    triangle {
      < -1.565518, 0.611684, 0.000895>,
      < -2.419305, 0.619042, 0.009285>,
      < -2.385837, 0.593591, 0.705669>
    }
    triangle {
      < -1.565518, 0.611684, 0.000895>,
      < -2.385837, 0.593591, 0.705669>,
      < -1.886817, 0.592043, 0.705669>
    }
    triangle {
      < -1.565518, 0.611684, 0.000895>,
      < -1.886817, 0.592043, 0.705669>,
      < -1.565481, 0.591046, 0.705669>
    }
    triangle {
      < -1.886817, 0.592043, 0.705669>,
      < -1.766871, 0.669704, 0.705244>,
      < -1.565481, 0.591046, 0.705669>
    }
    triangle {
      < -1.736196, 0.617367, 1.951016>,
      < -1.518209, 0.524000, 1.951595>,
      < -1.642132, 0.674005, 1.950438>
    }
    triangle {
      < -1.799723, 0.632051, 1.934608>,
      < -1.736196, 0.617367, 1.951016>,
      < -1.642132, 0.674005, 1.950438>
    }
    triangle {
      < -1.799723, 0.632051, 1.934608>,
      < -1.642132, 0.674005, 1.950438>,
      < -1.683984, 0.702527, 1.931745>
    }
    triangle {
      < -1.844721, 0.642492, 1.901492>,
      < -1.799723, 0.632051, 1.934608>,
      < -1.683984, 0.702527, 1.931745>
    }
    triangle {
      < -1.844721, 0.642492, 1.901492>,
      < -1.683984, 0.702527, 1.931745>,
      < -1.715180, 0.721706, 1.898816>
    }
    triangle {
      < -1.870707, 0.649325, 1.851680>,
      < -1.844721, 0.642492, 1.901492>,
      < -1.715180, 0.721706, 1.898816>
    }
    triangle {
      < -1.870707, 0.649325, 1.851680>,
      < -1.715180, 0.721706, 1.898816>,
      < -1.734753, 0.732814, 1.851674>
    }
    triangle {
      < -1.883937, 0.688886, 0.805613>,
      < -1.870707, 0.649325, 1.851680>,
      < -1.734753, 0.732814, 1.851674>
    }
    triangle {
      < -1.883937, 0.688886, 0.805613>,
      < -1.734753, 0.732814, 1.851674>,
      < -1.761213, 0.752595, 0.805606>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -1.753444, 0.524486, 1.951595>,
      < -1.635826, 0.524243, 1.951595>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -1.635826, 0.524243, 1.951595>,
      < -1.518209, 0.524000, 1.951595>
    }
    triangle {
      < -1.871061, 0.524729, 1.951595>,
      < -1.518209, 0.524000, 1.951595>,
      < -1.736196, 0.617367, 1.951016>
    }
    triangle {
      < -1.956261, 0.525576, 1.937471>,
      < -1.871061, 0.524729, 1.951595>,
      < -1.736196, 0.617367, 1.951016>
    }
    triangle {
      < -1.956261, 0.525576, 1.937471>,
      < -1.736196, 0.617367, 1.951016>,
      < -1.799723, 0.632051, 1.934608>
    }
    triangle {
      < -2.015061, 0.527278, 1.904167>,
      < -1.956261, 0.525576, 1.937471>,
      < -1.799723, 0.632051, 1.934608>
    }
    triangle {
      < -2.015061, 0.527278, 1.904167>,
      < -1.799723, 0.632051, 1.934608>,
      < -1.844721, 0.642492, 1.901492>
    }
    triangle {
      < -2.047460, 0.529835, 1.851686>,
      < -2.015061, 0.527278, 1.904167>,
      < -1.844721, 0.642492, 1.901492>
    }
    triangle {
      < -2.047460, 0.529835, 1.851686>,
      < -1.844721, 0.642492, 1.901492>,
      < -1.870707, 0.649325, 1.851680>
    }
    triangle {
      < -2.047460, 0.529835, 1.851686>,
      < -1.870707, 0.649325, 1.851680>,
      < -2.047460, 0.540047, 1.636499>
    }
    triangle {
      < -2.047460, 0.589177, 0.805620>,
      < -2.047460, 0.579575, 1.090915>,
      < -1.883937, 0.688886, 0.805613>
    }
    triangle {
      < -1.883937, 0.688886, 0.805613>,
      < -2.047460, 0.579575, 1.090915>,
      < -2.047460, 0.540047, 1.636499>
    }
    triangle {
      < -1.883937, 0.688886, 0.805613>,
      < -2.047460, 0.540047, 1.636499>,
      < -1.870707, 0.649325, 1.851680>
    }
    triangle {
      < -1.683317, 0.079326, 1.086187>,
      < -1.683387, 0.079374, 0.000393>,
      < -1.845950, 0.338829, 0.705669>
    }
    triangle {
      < -1.683387, 0.079374, 0.000393>,
      < -1.846007, 0.338840, 0.000393>,
      < -1.845950, 0.338829, 0.705669>
    }
    triangle {
      < -1.587286, 0.163037, 2.050812>,
      < -1.645417, 0.110211, 1.888693>,
      < -1.769608, 0.357681, 1.951595>
    }
    triangle {
      < -1.645417, 0.110211, 1.888693>,
      < -1.798078, 0.350158, 1.888693>,
      < -1.769608, 0.357681, 1.951595>
    }
    texture {interior}
  }
  // handles
  union {
    triangle {
      < 1.546206, 0.136139, -2.987218>,
      < 1.521534, 0.136451, -2.989452>,
      < 1.495635, 0.134343, -2.973276>
    }
    triangle {
      < 1.546206, 0.136139, -2.987218>,
      < 1.495635, 0.134343, -2.973276>,
      < 1.511216, 0.134043, -2.971511>
    }
    triangle {
      < 1.521534, 0.136451, -2.989452>,
      < 1.278458, 0.136412, -2.987453>,
      < 1.277134, 0.134312, -2.971308>
    }
    triangle {
      < 1.521534, 0.136451, -2.989452>,
      < 1.277134, 0.134312, -2.971308>,
      < 1.495635, 0.134343, -2.973276>
    }
    triangle {
      < 1.278458, 0.136412, -2.987453>,
      < 1.248751, 0.135527, -2.981526>,
      < 1.254544, 0.133502, -2.966010>
    }
    triangle {
      < 1.278458, 0.136412, -2.987453>,
      < 1.254544, 0.133502, -2.966010>,
      < 1.277134, 0.134312, -2.971308>
    }
    triangle {
      < 1.248751, 0.135527, -2.981526>,
      < 1.221411, 0.134071, -2.971846>,
      < 1.233700, 0.132165, -2.957398>
    }
    triangle {
      < 1.248751, 0.135527, -2.981526>,
      < 1.233700, 0.132165, -2.957398>,
      < 1.254544, 0.133502, -2.966010>
    }
    triangle {
      < 1.221411, 0.134071, -2.971846>,
      < 1.197822, 0.132122, -2.959055>,
      < 1.215957, 0.130405, -2.946145>
    }
    triangle {
      < 1.221411, 0.134071, -2.971846>,
      < 1.215957, 0.130405, -2.946145>,
      < 1.233700, 0.132165, -2.957398>
    }
    triangle {
      < 1.197822, 0.132122, -2.959055>,
      < 1.178982, 0.129799, -2.943987>,
      < 1.202151, 0.128364, -2.933146>
    }
    triangle {
      < 1.197822, 0.132122, -2.959055>,
      < 1.202151, 0.128364, -2.933146>,
      < 1.215957, 0.130405, -2.946145>
    }
    triangle {
      < 1.178982, 0.129799, -2.943987>,
      < 1.165605, 0.127269, -2.927727>,
      < 1.192818, 0.126239, -2.919652>
    }
    triangle {
      < 1.178982, 0.129799, -2.943987>,
      < 1.192818, 0.126239, -2.919652>,
      < 1.202151, 0.128364, -2.933146>
    }
    triangle {
      < 1.165605, 0.127269, -2.927727>,
      < 1.157893, 0.124717, -2.911452>,
      < 1.187860, 0.124245, -2.907025>
    }
    triangle {
      < 1.165605, 0.127269, -2.927727>,
      < 1.187860, 0.124245, -2.907025>,
      < 1.192818, 0.126239, -2.919652>
    }
    triangle {
      < 1.157893, 0.124717, -2.911452>,
      < 1.155444, 0.122247, -2.895804>,
      < 1.186416, 0.122454, -2.895702>
    }
    triangle {
      < 1.157893, 0.124717, -2.911452>,
      < 1.186416, 0.122454, -2.895702>,
      < 1.187860, 0.124245, -2.907025>
    }
    triangle {
      < 1.642766, 0.121669, -2.895805>,
      < 1.640649, 0.124352, -2.912733>,
      < 1.568035, 0.124095, -2.909162>
    }
    triangle {
      < 1.642766, 0.121669, -2.895805>,
      < 1.568035, 0.124095, -2.909162>,
      < 1.569181, 0.121968, -2.895740>
    }
    triangle {
      < 1.640649, 0.124352, -2.912733>,
      < 1.634262, 0.126999, -2.929410>,
      < 1.564493, 0.126231, -2.922618>
    }
    triangle {
      < 1.640649, 0.124352, -2.912733>,
      < 1.564493, 0.126231, -2.922618>,
      < 1.568035, 0.124095, -2.909162>
    }
    triangle {
      < 1.634262, 0.126999, -2.929410>,
      < 1.623615, 0.129525, -2.945315>,
      < 1.558383, 0.128325, -2.935789>
    }
    triangle {
      < 1.634262, 0.126999, -2.929410>,
      < 1.558383, 0.128325, -2.935789>,
      < 1.564493, 0.126231, -2.922618>
    }
    triangle {
      < 1.623615, 0.129525, -2.945315>,
      < 1.608913, 0.131819, -2.959741>,
      < 1.549681, 0.130271, -2.948004>
    }
    triangle {
      < 1.623615, 0.129525, -2.945315>,
      < 1.549681, 0.130271, -2.948004>,
      < 1.558383, 0.128325, -2.935789>
    }
    triangle {
      < 1.608913, 0.131819, -2.959741>,
      < 1.590627, 0.133755, -2.971938>,
      < 1.538607, 0.131944, -2.958474>
    }
    triangle {
      < 1.608913, 0.131819, -2.959741>,
      < 1.538607, 0.131944, -2.958474>,
      < 1.549681, 0.130271, -2.948004>
    }
    triangle {
      < 1.590627, 0.133755, -2.971938>,
      < 1.569444, 0.135226, -2.981258>,
      < 1.525593, 0.133229, -2.966486>
    }
    triangle {
      < 1.590627, 0.133755, -2.971938>,
      < 1.525593, 0.133229, -2.966486>,
      < 1.538607, 0.131944, -2.958474>
    }
    triangle {
      < 1.569444, 0.135226, -2.981258>,
      < 1.546206, 0.136139, -2.987218>,
      < 1.511216, 0.134043, -2.971511>
    }
    triangle {
      < 1.569444, 0.135226, -2.981258>,
      < 1.511216, 0.134043, -2.971511>,
      < 1.525593, 0.133229, -2.966486>
    }
    triangle {
      < 1.532780, 0.092368, -2.900428>,
      < 1.569181, 0.121968, -2.895740>,
      < 1.568035, 0.124095, -2.909162>
    }
    triangle {
      < 1.532780, 0.092368, -2.900428>,
      < 1.568035, 0.124095, -2.909162>,
      < 1.532200, 0.094495, -2.913850>
    }
    triangle {
      < 1.495597, 0.104743, -2.977964>,
      < 1.495635, 0.134343, -2.973276>,
      < 1.277134, 0.134312, -2.971308>
    }
    triangle {
      < 1.495597, 0.104743, -2.977964>,
      < 1.277134, 0.134312, -2.971308>,
      < 1.277096, 0.104712, -2.975997>
    }
    triangle {
      < 1.254506, 0.103902, -2.970698>,
      < 1.254544, 0.133502, -2.966010>,
      < 1.233700, 0.132165, -2.957398>
    }
    triangle {
      < 1.254506, 0.103902, -2.970698>,
      < 1.233700, 0.132165, -2.957398>,
      < 1.233662, 0.102565, -2.962086>
    }
    triangle {
      < 1.233662, 0.102565, -2.962086>,
      < 1.233700, 0.132165, -2.957398>,
      < 1.215957, 0.130405, -2.946145>
    }
    triangle {
      < 1.233662, 0.102565, -2.962086>,
      < 1.215957, 0.130405, -2.946145>,
      < 1.215919, 0.100805, -2.950832>
    }
    triangle {
      < 1.215919, 0.100805, -2.950832>,
      < 1.215957, 0.130405, -2.946145>,
      < 1.202151, 0.128364, -2.933146>
    }
    triangle {
      < 1.215919, 0.100805, -2.950832>,
      < 1.202151, 0.128364, -2.933146>,
      < 1.202113, 0.098764, -2.937833>
    }
    triangle {
      < 1.192780, 0.096639, -2.924340>,
      < 1.192818, 0.126239, -2.919652>,
      < 1.187860, 0.124245, -2.907025>
    }
    triangle {
      < 1.192780, 0.096639, -2.924340>,
      < 1.187860, 0.124245, -2.907025>,
      < 1.187822, 0.094645, -2.911713>
    }
    triangle {
      < 1.192818, 0.126239, -2.919652>,
      < 1.192780, 0.096639, -2.924340>,
      < 1.202113, 0.098764, -2.937833>
    }
    triangle {
      < 1.192818, 0.126239, -2.919652>,
      < 1.202113, 0.098764, -2.937833>,
      < 1.202151, 0.128364, -2.933146>
    }
    triangle {
      < 1.187822, 0.094645, -2.911713>,
      < 1.187860, 0.124245, -2.907025>,
      < 1.186416, 0.122454, -2.895702>
    }
    triangle {
      < 1.187822, 0.094645, -2.911713>,
      < 1.186416, 0.122454, -2.895702>,
      < 1.186378, 0.092854, -2.900390>
    }
    triangle {
      < 1.277096, 0.104712, -2.975997>,
      < 1.277134, 0.134312, -2.971308>,
      < 1.254544, 0.133502, -2.966010>
    }
    triangle {
      < 1.277096, 0.104712, -2.975997>,
      < 1.254544, 0.133502, -2.966010>,
      < 1.254506, 0.103902, -2.970698>
    }
    triangle {
      < 1.532200, 0.094495, -2.913850>,
      < 1.568035, 0.124095, -2.909162>,
      < 1.564493, 0.126231, -2.922618>
    }
    triangle {
      < 1.532200, 0.094495, -2.913850>,
      < 1.564493, 0.126231, -2.922618>,
      < 1.530409, 0.096631, -2.927305>
    }
    triangle {
      < 1.530409, 0.096631, -2.927305>,
      < 1.564493, 0.126231, -2.922618>,
      < 1.558383, 0.128325, -2.935789>
    }
    triangle {
      < 1.530409, 0.096631, -2.927305>,
      < 1.558383, 0.128325, -2.935789>,
      < 1.527320, 0.098725, -2.940478>
    }
    triangle {
      < 1.527320, 0.098725, -2.940478>,
      < 1.558383, 0.128325, -2.935789>,
      < 1.549681, 0.130271, -2.948004>
    }
    triangle {
      < 1.527320, 0.098725, -2.940478>,
      < 1.549681, 0.130271, -2.948004>,
      < 1.522920, 0.100671, -2.952693>
    }
    triangle {
      < 1.522920, 0.100671, -2.952693>,
      < 1.549681, 0.130271, -2.948004>,
      < 1.538607, 0.131944, -2.958474>
    }
    triangle {
      < 1.522920, 0.100671, -2.952693>,
      < 1.538607, 0.131944, -2.958474>,
      < 1.517322, 0.102343, -2.963162>
    }
    triangle {
      < 1.517322, 0.102343, -2.963162>,
      < 1.538607, 0.131944, -2.958474>,
      < 1.525593, 0.133229, -2.966486>
    }
    triangle {
      < 1.517322, 0.102343, -2.963162>,
      < 1.525593, 0.133229, -2.966486>,
      < 1.510743, 0.103629, -2.971175>
    }
    triangle {
      < 1.510743, 0.103629, -2.971175>,
      < 1.525593, 0.133229, -2.966486>,
      < 1.511216, 0.134043, -2.971511>
    }
    triangle {
      < 1.510743, 0.103629, -2.971175>,
      < 1.511216, 0.134043, -2.971511>,
      < 1.503474, 0.104443, -2.976199>
    }
    triangle {
      < 1.503474, 0.104443, -2.976199>,
      < 1.511216, 0.134043, -2.971511>,
      < 1.495635, 0.134343, -2.973276>
    }
    triangle {
      < 1.503474, 0.104443, -2.976199>,
      < 1.495635, 0.134343, -2.973276>,
      < 1.495597, 0.104743, -2.977964>
    }
    triangle {
      < 1.640649, 0.124352, -2.912733>,
      < 1.642766, 0.121669, -2.895805>,
      < 1.708858, 0.116653, -2.896593>
    }
    triangle {
      < 1.640649, 0.124352, -2.912733>,
      < 1.708858, 0.116653, -2.896593>,
      < 1.705940, 0.119880, -2.916955>
    }
    triangle {
      < 1.634262, 0.126999, -2.929410>,
      < 1.640649, 0.124352, -2.912733>,
      < 1.705940, 0.119880, -2.916955>
    }
    triangle {
      < 1.634262, 0.126999, -2.929410>,
      < 1.705940, 0.119880, -2.916955>,
      < 1.697234, 0.123024, -2.936750>
    }
    triangle {
      < 1.623615, 0.129525, -2.945315>,
      < 1.634262, 0.126999, -2.929410>,
      < 1.697234, 0.123024, -2.936750>
    }
    triangle {
      < 1.623615, 0.129525, -2.945315>,
      < 1.697234, 0.123024, -2.936750>,
      < 1.682957, 0.125970, -2.955271>
    }
    triangle {
      < 1.608913, 0.131819, -2.959741>,
      < 1.623615, 0.129525, -2.945315>,
      < 1.682957, 0.125970, -2.955271>
    }
    triangle {
      < 1.608913, 0.131819, -2.959741>,
      < 1.682957, 0.125970, -2.955271>,
      < 1.663552, 0.128596, -2.971766>
    }
    triangle {
      < 1.590627, 0.133755, -2.971938>,
      < 1.608913, 0.131819, -2.959741>,
      < 1.663552, 0.128596, -2.971766>
    }
    triangle {
      < 1.590627, 0.133755, -2.971938>,
      < 1.663552, 0.128596, -2.971766>,
      < 1.639715, 0.130786, -2.985514>
    }
    triangle {
      < 1.569444, 0.135226, -2.981258>,
      < 1.590627, 0.133755, -2.971938>,
      < 1.639715, 0.130786, -2.985514>
    }
    triangle {
      < 1.569444, 0.135226, -2.981258>,
      < 1.639715, 0.130786, -2.985514>,
      < 1.612344, 0.132434, -2.995907>
    }
    triangle {
      < 1.546206, 0.136139, -2.987218>,
      < 1.569444, 0.135226, -2.981258>,
      < 1.612344, 0.132434, -2.995907>
    }
    triangle {
      < 1.546206, 0.136139, -2.987218>,
      < 1.612344, 0.132434, -2.995907>,
      < 1.582491, 0.133456, -3.002498>
    }
    triangle {
      < 1.521534, 0.136451, -2.989452>,
      < 1.546206, 0.136139, -2.987218>,
      < 1.582491, 0.133456, -3.002498>
    }
    triangle {
      < 1.521534, 0.136451, -2.989452>,
      < 1.582491, 0.133456, -3.002498>,
      < 1.551179, 0.133806, -3.004922>
    }
    triangle {
      < 1.278458, 0.136412, -2.987453>,
      < 1.521534, 0.136451, -2.989452>,
      < 1.551179, 0.133806, -3.004922>
    }
    triangle {
      < 1.278458, 0.136412, -2.987453>,
      < 1.551179, 0.133806, -3.004922>,
      < 1.279926, 0.133783, -3.002790>
    }
    triangle {
      < 1.248751, 0.135527, -2.981526>,
      < 1.278458, 0.136412, -2.987453>,
      < 1.279926, 0.133783, -3.002790>
    }
    triangle {
      < 1.248751, 0.135527, -2.981526>,
      < 1.279926, 0.133783, -3.002790>,
      < 1.243323, 0.132820, -2.996321>
    }
    triangle {
      < 1.221411, 0.134071, -2.971846>,
      < 1.248751, 0.135527, -2.981526>,
      < 1.243323, 0.132820, -2.996321>
    }
    triangle {
      < 1.221411, 0.134071, -2.971846>,
      < 1.243323, 0.132820, -2.996321>,
      < 1.209636, 0.131234, -2.985763>
    }
    triangle {
      < 1.197822, 0.132122, -2.959055>,
      < 1.221411, 0.134071, -2.971846>,
      < 1.209636, 0.131234, -2.985763>
    }
    triangle {
      < 1.197822, 0.132122, -2.959055>,
      < 1.209636, 0.131234, -2.985763>,
      < 1.180308, 0.129088, -2.971683>
    }
    triangle {
      < 1.178982, 0.129799, -2.943987>,
      < 1.197822, 0.132122, -2.959055>,
      < 1.180308, 0.129088, -2.971683>
    }
    triangle {
      < 1.178982, 0.129799, -2.943987>,
      < 1.180308, 0.129088, -2.971683>,
      < 1.156505, 0.126485, -2.954804>
    }
    triangle {
      < 1.165605, 0.127269, -2.927727>,
      < 1.178982, 0.129799, -2.943987>,
      < 1.156505, 0.126485, -2.954804>
    }
    triangle {
      < 1.165605, 0.127269, -2.927727>,
      < 1.156505, 0.126485, -2.954804>,
      < 1.139132, 0.123562, -2.936034>
    }
    triangle {
      < 1.157893, 0.124717, -2.911452>,
      < 1.165605, 0.127269, -2.927727>,
      < 1.139132, 0.123562, -2.936034>
    }
    triangle {
      < 1.157893, 0.124717, -2.911452>,
      < 1.139132, 0.123562, -2.936034>,
      < 1.128697, 0.120476, -2.916363>
    }
    triangle {
      < 1.155444, 0.122247, -2.895804>,
      < 1.157893, 0.124717, -2.911452>,
      < 1.128697, 0.120476, -2.916363>
    }
    triangle {
      < 1.155444, 0.122247, -2.895804>,
      < 1.128697, 0.120476, -2.916363>,
      < 1.125250, 0.117353, -2.896582>
    }
    triangle {
      < 1.705940, 0.119880, -2.916955>,
      < 1.708858, 0.116653, -2.896593>,
      < 1.742028, 0.106949, -2.898102>
    }
    triangle {
      < 1.705940, 0.119880, -2.916955>,
      < 1.742028, 0.106949, -2.898102>,
      < 1.738786, 0.110711, -2.921825>
    }
    triangle {
      < 1.697234, 0.123024, -2.936750>,
      < 1.705940, 0.119880, -2.916955>,
      < 1.738786, 0.110711, -2.921825>
    }
    triangle {
      < 1.697234, 0.123024, -2.936750>,
      < 1.738786, 0.110711, -2.921825>,
      < 1.729177, 0.114335, -2.944634>
    }
    triangle {
      < 1.682957, 0.125970, -2.955271>,
      < 1.697234, 0.123024, -2.936750>,
      < 1.729177, 0.114335, -2.944634>
    }
    triangle {
      < 1.682957, 0.125970, -2.955271>,
      < 1.729177, 0.114335, -2.944634>,
      < 1.713573, 0.117685, -2.965655>
    }
    triangle {
      < 1.663552, 0.128596, -2.971766>,
      < 1.682957, 0.125970, -2.955271>,
      < 1.713573, 0.117685, -2.965655>
    }
    triangle {
      < 1.663552, 0.128596, -2.971766>,
      < 1.713573, 0.117685, -2.965655>,
      < 1.692573, 0.120630, -2.984080>
    }
    triangle {
      < 1.639715, 0.130786, -2.985514>,
      < 1.663552, 0.128596, -2.971766>,
      < 1.692573, 0.120630, -2.984080>
    }
    triangle {
      < 1.639715, 0.130786, -2.985514>,
      < 1.692573, 0.120630, -2.984080>,
      < 1.666983, 0.123057, -2.999199>
    }
    triangle {
      < 1.612344, 0.132434, -2.995907>,
      < 1.639715, 0.130786, -2.985514>,
      < 1.666983, 0.123057, -2.999199>
    }
    triangle {
      < 1.612344, 0.132434, -2.995907>,
      < 1.666983, 0.123057, -2.999199>,
      < 1.637787, 0.124874, -3.010434>
    }
    triangle {
      < 1.582491, 0.133456, -3.002498>,
      < 1.612344, 0.132434, -2.995907>,
      < 1.637787, 0.124874, -3.010434>
    }
    triangle {
      < 1.582491, 0.133456, -3.002498>,
      < 1.637787, 0.124874, -3.010434>,
      < 1.606107, 0.126010, -3.017351>
    }
    triangle {
      < 1.551179, 0.133806, -3.004922>,
      < 1.582491, 0.133456, -3.002498>,
      < 1.606107, 0.126010, -3.017351>
    }
    triangle {
      < 1.551179, 0.133806, -3.004922>,
      < 1.606107, 0.126010, -3.017351>,
      < 1.573162, 0.126422, -3.019683>
    }
    triangle {
      < 1.279926, 0.133783, -3.002790>,
      < 1.551179, 0.133806, -3.004922>,
      < 1.573162, 0.126422, -3.019683>
    }
    triangle {
      < 1.279926, 0.133783, -3.002790>,
      < 1.573162, 0.126422, -3.019683>,
      < 1.281538, 0.126422, -3.017319>
    }
    triangle {
      < 1.243323, 0.132820, -2.996321>,
      < 1.279926, 0.133783, -3.002790>,
      < 1.281538, 0.126422, -3.017319>
    }
    triangle {
      < 1.243323, 0.132820, -2.996321>,
      < 1.281538, 0.126422, -3.017319>,
      < 1.238261, 0.125381, -3.010394>
    }
    triangle {
      < 1.209636, 0.131234, -2.985763>,
      < 1.243323, 0.132820, -2.996321>,
      < 1.238261, 0.125381, -3.010394>
    }
    triangle {
      < 1.209636, 0.131234, -2.985763>,
      < 1.238261, 0.125381, -3.010394>,
      < 1.198375, 0.123652, -2.999152>
    }
    triangle {
      < 1.180308, 0.129088, -2.971683>,
      < 1.209636, 0.131234, -2.985763>,
      < 1.198375, 0.123652, -2.999152>
    }
    triangle {
      < 1.180308, 0.129088, -2.971683>,
      < 1.198375, 0.123652, -2.999152>,
      < 1.163414, 0.121301, -2.984027>
    }
    triangle {
      < 1.156505, 0.126485, -2.954804>,
      < 1.180308, 0.129088, -2.971683>,
      < 1.163414, 0.121301, -2.984027>
    }
    triangle {
      < 1.156505, 0.126485, -2.954804>,
      < 1.163414, 0.121301, -2.984027>,
      < 1.134722, 0.118419, -2.965597>
    }
    triangle {
      < 1.139132, 0.123562, -2.936034>,
      < 1.156505, 0.126485, -2.954804>,
      < 1.134722, 0.118419, -2.965597>
    }
    triangle {
      < 1.139132, 0.123562, -2.936034>,
      < 1.134722, 0.118419, -2.965597>,
      < 1.113402, 0.115116, -2.944572>
    }
    triangle {
      < 1.128697, 0.120476, -2.916363>,
      < 1.139132, 0.123562, -2.936034>,
      < 1.113402, 0.115116, -2.944572>
    }
    triangle {
      < 1.128697, 0.120476, -2.916363>,
      < 1.113402, 0.115116, -2.944572>,
      < 1.100272, 0.111520, -2.921761>
    }
    triangle {
      < 1.125250, 0.117353, -2.896582>,
      < 1.128697, 0.120476, -2.916363>,
      < 1.100272, 0.111520, -2.921761>
    }
    triangle {
      < 1.125250, 0.117353, -2.896582>,
      < 1.100272, 0.111520, -2.921761>,
      < 1.095836, 0.107769, -2.898037>
    }
    triangle {
      < 1.155404, 0.114301, -2.845629>,
      < 1.125211, 0.109406, -2.846407>,
      < 1.095797, 0.099822, -2.847863>
    }
    triangle {
      < 1.155404, 0.114301, -2.845629>,
      < 1.095797, 0.099822, -2.847863>,
      < 1.125186, 0.090184, -2.849452>
    }
    triangle {
      < 1.155404, 0.114301, -2.845629>,
      < 1.125186, 0.090184, -2.849452>,
      < 1.155367, 0.085213, -2.850236>
    }
    triangle {
      < 1.155404, 0.114301, -2.845629>,
      < 1.155367, 0.085213, -2.850236>,
      < 1.186339, 0.084908, -2.850215>
    }
    triangle {
      < 1.155404, 0.114301, -2.845629>,
      < 1.186339, 0.084908, -2.850215>,
      < 1.186377, 0.114507, -2.845527>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.524419, 0.064205, -2.853461>,
      < 1.529281, 0.047695, -2.856076>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.529281, 0.047695, -2.856076>,
      < 1.538991, 0.031173, -2.858692>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.538991, 0.031173, -2.858692>,
      < 1.558018, 0.012603, -2.861632>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.558018, 0.012603, -2.861632>,
      < 1.585755, -0.001239, -2.863822>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.585755, -0.001239, -2.863822>,
      < 1.619429, -0.006272, -2.864615>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.619429, -0.006272, -2.864615>,
      < 1.653114, -0.001330, -2.863828>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.653114, -0.001330, -2.863828>,
      < 1.681587, 0.012436, -2.861645>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.681587, 0.012436, -2.861645>,
      < 1.698679, 0.030962, -2.858709>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.698679, 0.030962, -2.858709>,
      < 1.703224, 0.047471, -2.856094>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.703224, 0.047471, -2.856094>,
      < 1.705729, 0.063993, -2.853477>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.705729, 0.063993, -2.853477>,
      < 1.708831, 0.089396, -2.849476>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.708831, 0.089396, -2.849476>,
      < 1.742025, 0.099008, -2.847926>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.742025, 0.099008, -2.847926>,
      < 1.708855, 0.108712, -2.846417>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.708855, 0.108712, -2.846417>,
      < 1.642763, 0.113728, -2.845629>
    }
    triangle {
      < 1.532777, 0.084427, -2.850253>,
      < 1.642763, 0.113728, -2.845629>,
      < 1.569178, 0.114027, -2.845564>
    }
    triangle {
      < 1.128672, 0.101264, -2.919406>,
      < 1.125226, 0.098131, -2.899626>,
      < 1.095836, 0.107769, -2.898037>
    }
    triangle {
      < 1.128672, 0.101264, -2.919406>,
      < 1.095836, 0.107769, -2.898037>,
      < 1.100272, 0.111520, -2.921761>
    }
    triangle {
      < 1.139108, 0.104381, -2.939072>,
      < 1.128672, 0.101264, -2.919406>,
      < 1.100272, 0.111520, -2.921761>
    }
    triangle {
      < 1.139108, 0.104381, -2.939072>,
      < 1.100272, 0.111520, -2.921761>,
      < 1.113402, 0.115116, -2.944572>
    }
    triangle {
      < 1.156481, 0.107358, -2.957833>,
      < 1.139108, 0.104381, -2.939072>,
      < 1.113402, 0.115116, -2.944572>
    }
    triangle {
      < 1.156481, 0.107358, -2.957833>,
      < 1.113402, 0.115116, -2.944572>,
      < 1.134722, 0.118419, -2.965597>
    }
    triangle {
      < 1.180284, 0.110038, -2.974700>,
      < 1.156481, 0.107358, -2.957833>,
      < 1.134722, 0.118419, -2.965597>
    }
    triangle {
      < 1.180284, 0.110038, -2.974700>,
      < 1.134722, 0.118419, -2.965597>,
      < 1.163414, 0.121301, -2.984027>
    }
    triangle {
      < 1.209612, 0.112275, -2.988766>,
      < 1.180284, 0.110038, -2.974700>,
      < 1.163414, 0.121301, -2.984027>
    }
    triangle {
      < 1.209612, 0.112275, -2.988766>,
      < 1.163414, 0.121301, -2.984027>,
      < 1.198375, 0.123652, -2.999152>
    }
    triangle {
      < 1.243299, 0.113944, -2.999311>,
      < 1.209612, 0.112275, -2.988766>,
      < 1.198375, 0.123652, -2.999152>
    }
    triangle {
      < 1.243299, 0.113944, -2.999311>,
      < 1.198375, 0.123652, -2.999152>,
      < 1.238261, 0.125381, -3.010394>
    }
    triangle {
      < 1.279902, 0.114936, -3.005774>,
      < 1.243299, 0.113944, -2.999311>,
      < 1.238261, 0.125381, -3.010394>
    }
    triangle {
      < 1.279902, 0.114936, -3.005774>,
      < 1.238261, 0.125381, -3.010394>,
      < 1.281538, 0.126422, -3.017319>
    }
    triangle {
      < 1.551154, 0.114893, -3.007917>,
      < 1.279902, 0.114936, -3.005774>,
      < 1.281538, 0.126422, -3.017319>
    }
    triangle {
      < 1.551154, 0.114893, -3.007917>,
      < 1.281538, 0.126422, -3.017319>,
      < 1.573162, 0.126422, -3.019683>
    }
    triangle {
      < 1.582466, 0.114398, -3.005516>,
      < 1.551154, 0.114893, -3.007917>,
      < 1.573162, 0.126422, -3.019683>
    }
    triangle {
      < 1.582466, 0.114398, -3.005516>,
      < 1.573162, 0.126422, -3.019683>,
      < 1.606107, 0.126010, -3.017351>
    }
    triangle {
      < 1.612318, 0.113259, -2.998944>,
      < 1.582466, 0.114398, -3.005516>,
      < 1.606107, 0.126010, -3.017351>
    }
    triangle {
      < 1.612318, 0.113259, -2.998944>,
      < 1.606107, 0.126010, -3.017351>,
      < 1.637787, 0.124874, -3.010434>
    }
    triangle {
      < 1.639689, 0.111546, -2.988561>,
      < 1.612318, 0.113259, -2.998944>,
      < 1.637787, 0.124874, -3.010434>
    }
    triangle {
      < 1.639689, 0.111546, -2.988561>,
      < 1.637787, 0.124874, -3.010434>,
      < 1.666983, 0.123057, -2.999199>
    }
    triangle {
      < 1.663527, 0.109321, -2.974819>,
      < 1.639689, 0.111546, -2.988561>,
      < 1.666983, 0.123057, -2.999199>
    }
    triangle {
      < 1.663527, 0.109321, -2.974819>,
      < 1.666983, 0.123057, -2.999199>,
      < 1.692573, 0.120630, -2.984080>
    }
    triangle {
      < 1.682931, 0.106673, -2.958327>,
      < 1.663527, 0.109321, -2.974819>,
      < 1.692573, 0.120630, -2.984080>
    }
    triangle {
      < 1.682931, 0.106673, -2.958327>,
      < 1.692573, 0.120630, -2.984080>,
      < 1.713573, 0.117685, -2.965655>
    }
    triangle {
      < 1.697208, 0.103716, -2.939808>,
      < 1.682931, 0.106673, -2.958327>,
      < 1.713573, 0.117685, -2.965655>
    }
    triangle {
      < 1.697208, 0.103716, -2.939808>,
      < 1.713573, 0.117685, -2.965655>,
      < 1.729177, 0.114335, -2.944634>
    }
    triangle {
      < 1.703923, 0.101287, -2.924543>,
      < 1.697208, 0.103716, -2.939808>,
      < 1.729177, 0.114335, -2.944634>
    }
    triangle {
      < 1.703923, 0.101287, -2.924543>,
      < 1.729177, 0.114335, -2.944634>,
      < 1.738786, 0.110711, -2.921825>
    }
    triangle {
      < 1.703923, 0.101287, -2.924543>,
      < 1.738786, 0.110711, -2.921825>,
      < 1.710687, 0.102039, -2.920277>
    }
    triangle {
      < 1.708834, 0.097337, -2.899652>,
      < 1.706616, 0.099792, -2.915124>,
      < 1.710687, 0.102039, -2.920277>
    }
    triangle {
      < 1.708834, 0.097337, -2.899652>,
      < 1.710687, 0.102039, -2.920277>,
      < 1.738786, 0.110711, -2.921825>
    }
    triangle {
      < 1.708834, 0.097337, -2.899652>,
      < 1.738786, 0.110711, -2.921825>,
      < 1.742028, 0.106949, -2.898102>
    }
    triangle {
      < 1.157856, 0.095640, -2.916057>,
      < 1.155406, 0.093160, -2.900410>,
      < 1.125226, 0.098131, -2.899626>
    }
    triangle {
      < 1.157856, 0.095640, -2.916057>,
      < 1.125226, 0.098131, -2.899626>,
      < 1.128672, 0.101264, -2.919406>
    }
    triangle {
      < 1.165568, 0.098223, -2.932328>,
      < 1.157856, 0.095640, -2.916057>,
      < 1.128672, 0.101264, -2.919406>
    }
    triangle {
      < 1.165568, 0.098223, -2.932328>,
      < 1.128672, 0.101264, -2.919406>,
      < 1.139108, 0.104381, -2.939072>
    }
    triangle {
      < 1.178945, 0.100807, -2.948578>,
      < 1.165568, 0.098223, -2.932328>,
      < 1.139108, 0.104381, -2.939072>
    }
    triangle {
      < 1.178945, 0.100807, -2.948578>,
      < 1.139108, 0.104381, -2.939072>,
      < 1.156481, 0.107358, -2.957833>
    }
    triangle {
      < 1.197785, 0.103207, -2.963634>,
      < 1.178945, 0.100807, -2.948578>,
      < 1.156481, 0.107358, -2.957833>
    }
    triangle {
      < 1.197785, 0.103207, -2.963634>,
      < 1.156481, 0.107358, -2.957833>,
      < 1.180284, 0.110038, -2.974700>
    }
    triangle {
      < 1.221374, 0.105247, -2.976411>,
      < 1.197785, 0.103207, -2.963634>,
      < 1.180284, 0.110038, -2.974700>
    }
    triangle {
      < 1.221374, 0.105247, -2.976411>,
      < 1.180284, 0.110038, -2.974700>,
      < 1.209612, 0.112275, -2.988766>
    }
    triangle {
      < 1.248714, 0.106785, -2.986079>,
      < 1.221374, 0.105247, -2.976411>,
      < 1.209612, 0.112275, -2.988766>
    }
    triangle {
      < 1.248714, 0.106785, -2.986079>,
      < 1.209612, 0.112275, -2.988766>,
      < 1.243299, 0.113944, -2.999311>
    }
    triangle {
      < 1.278421, 0.107700, -2.992000>,
      < 1.248714, 0.106785, -2.986079>,
      < 1.243299, 0.113944, -2.999311>
    }
    triangle {
      < 1.278421, 0.107700, -2.992000>,
      < 1.243299, 0.113944, -2.999311>,
      < 1.279902, 0.114936, -3.005774>
    }
    triangle {
      < 1.521497, 0.107672, -2.994010>,
      < 1.278421, 0.107700, -2.992000>,
      < 1.279902, 0.114936, -3.005774>
    }
    triangle {
      < 1.521497, 0.107672, -2.994010>,
      < 1.279902, 0.114936, -3.005774>,
      < 1.551154, 0.114893, -3.007917>
    }
    triangle {
      < 1.546168, 0.107216, -2.991798>,
      < 1.521497, 0.107672, -2.994010>,
      < 1.551154, 0.114893, -3.007917>
    }
    triangle {
      < 1.546168, 0.107216, -2.991798>,
      < 1.551154, 0.114893, -3.007917>,
      < 1.582466, 0.114398, -3.005516>
    }
    triangle {
      < 1.569407, 0.106185, -2.985857>,
      < 1.546168, 0.107216, -2.991798>,
      < 1.582466, 0.114398, -3.005516>
    }
    triangle {
      < 1.569407, 0.106185, -2.985857>,
      < 1.582466, 0.114398, -3.005516>,
      < 1.612318, 0.113259, -2.998944>
    }
    triangle {
      < 1.590590, 0.104650, -2.976548>,
      < 1.569407, 0.106185, -2.985857>,
      < 1.612318, 0.113259, -2.998944>
    }
    triangle {
      < 1.590590, 0.104650, -2.976548>,
      < 1.612318, 0.113259, -2.998944>,
      < 1.639689, 0.111546, -2.988561>
    }
    triangle {
      < 1.608876, 0.102677, -2.964356>,
      < 1.590590, 0.104650, -2.976548>,
      < 1.639689, 0.111546, -2.988561>
    }
    triangle {
      < 1.608876, 0.102677, -2.964356>,
      < 1.639689, 0.111546, -2.988561>,
      < 1.663527, 0.109321, -2.974819>
    }
    triangle {
      < 1.623577, 0.100364, -2.949934>,
      < 1.608876, 0.102677, -2.964356>,
      < 1.663527, 0.109321, -2.974819>
    }
    triangle {
      < 1.623577, 0.100364, -2.949934>,
      < 1.663527, 0.109321, -2.974819>,
      < 1.682931, 0.106673, -2.958327>
    }
    triangle {
      < 1.634225, 0.097826, -2.934031>,
      < 1.623577, 0.100364, -2.949934>,
      < 1.682931, 0.106673, -2.958327>
    }
    triangle {
      < 1.634225, 0.097826, -2.934031>,
      < 1.682931, 0.106673, -2.958327>,
      < 1.697208, 0.103716, -2.939808>
    }
    triangle {
      < 1.640612, 0.095173, -2.917354>,
      < 1.634225, 0.097826, -2.934031>,
      < 1.697208, 0.103716, -2.939808>
    }
    triangle {
      < 1.640612, 0.095173, -2.917354>,
      < 1.697208, 0.103716, -2.939808>,
      < 1.703923, 0.101287, -2.924543>
    }
    triangle {
      < 1.640612, 0.095173, -2.917354>,
      < 1.703923, 0.101287, -2.924543>,
      < 1.700921, 0.099682, -2.920027>
    }
    triangle {
      < 1.546168, 0.107216, -2.991798>,
      < 1.569407, 0.106185, -2.985857>,
      < 1.510743, 0.103629, -2.971175>
    }
    triangle {
      < 1.546168, 0.107216, -2.991798>,
      < 1.510743, 0.103629, -2.971175>,
      < 1.503474, 0.104443, -2.976199>
    }
    triangle {
      < 1.569407, 0.106185, -2.985857>,
      < 1.590590, 0.104650, -2.976548>,
      < 1.517322, 0.102343, -2.963162>
    }
    triangle {
      < 1.569407, 0.106185, -2.985857>,
      < 1.517322, 0.102343, -2.963162>,
      < 1.510743, 0.103629, -2.971175>
    }
    triangle {
      < 1.590590, 0.104650, -2.976548>,
      < 1.608876, 0.102677, -2.964356>,
      < 1.522920, 0.100671, -2.952693>
    }
    triangle {
      < 1.590590, 0.104650, -2.976548>,
      < 1.522920, 0.100671, -2.952693>,
      < 1.517322, 0.102343, -2.963162>
    }
    triangle {
      < 1.608876, 0.102677, -2.964356>,
      < 1.623577, 0.100364, -2.949934>,
      < 1.527320, 0.098725, -2.940478>
    }
    triangle {
      < 1.608876, 0.102677, -2.964356>,
      < 1.527320, 0.098725, -2.940478>,
      < 1.522920, 0.100671, -2.952693>
    }
    triangle {
      < 1.623577, 0.100364, -2.949934>,
      < 1.634225, 0.097826, -2.934031>,
      < 1.530409, 0.096631, -2.927305>
    }
    triangle {
      < 1.623577, 0.100364, -2.949934>,
      < 1.530409, 0.096631, -2.927305>,
      < 1.527320, 0.098725, -2.940478>
    }
    triangle {
      < 1.634225, 0.097826, -2.934031>,
      < 1.640612, 0.095173, -2.917354>,
      < 1.530409, 0.096631, -2.927305>
    }
    triangle {
      < 1.155406, 0.093160, -2.900410>,
      < 1.157856, 0.095640, -2.916057>,
      < 1.187822, 0.094645, -2.911713>
    }
    triangle {
      < 1.155406, 0.093160, -2.900410>,
      < 1.187822, 0.094645, -2.911713>,
      < 1.186378, 0.092854, -2.900390>
    }
    triangle {
      < 1.157856, 0.095640, -2.916057>,
      < 1.165568, 0.098223, -2.932328>,
      < 1.192780, 0.096639, -2.924340>
    }
    triangle {
      < 1.157856, 0.095640, -2.916057>,
      < 1.192780, 0.096639, -2.924340>,
      < 1.187822, 0.094645, -2.911713>
    }
    triangle {
      < 1.165568, 0.098223, -2.932328>,
      < 1.178945, 0.100807, -2.948578>,
      < 1.202113, 0.098764, -2.937833>
    }
    triangle {
      < 1.165568, 0.098223, -2.932328>,
      < 1.202113, 0.098764, -2.937833>,
      < 1.192780, 0.096639, -2.924340>
    }
    triangle {
      < 1.178945, 0.100807, -2.948578>,
      < 1.197785, 0.103207, -2.963634>,
      < 1.215919, 0.100805, -2.950832>
    }
    triangle {
      < 1.178945, 0.100807, -2.948578>,
      < 1.215919, 0.100805, -2.950832>,
      < 1.202113, 0.098764, -2.937833>
    }
    triangle {
      < 1.197785, 0.103207, -2.963634>,
      < 1.221374, 0.105247, -2.976411>,
      < 1.233662, 0.102565, -2.962086>
    }
    triangle {
      < 1.197785, 0.103207, -2.963634>,
      < 1.233662, 0.102565, -2.962086>,
      < 1.215919, 0.100805, -2.950832>
    }
    triangle {
      < 1.221374, 0.105247, -2.976411>,
      < 1.248714, 0.106785, -2.986079>,
      < 1.254506, 0.103902, -2.970698>
    }
    triangle {
      < 1.221374, 0.105247, -2.976411>,
      < 1.254506, 0.103902, -2.970698>,
      < 1.233662, 0.102565, -2.962086>
    }
    triangle {
      < 1.248714, 0.106785, -2.986079>,
      < 1.278421, 0.107700, -2.992000>,
      < 1.277096, 0.104712, -2.975997>
    }
    triangle {
      < 1.248714, 0.106785, -2.986079>,
      < 1.277096, 0.104712, -2.975997>,
      < 1.254506, 0.103902, -2.970698>
    }
    triangle {
      < 1.278421, 0.107700, -2.992000>,
      < 1.521497, 0.107672, -2.994010>,
      < 1.495597, 0.104743, -2.977964>
    }
    triangle {
      < 1.278421, 0.107700, -2.992000>,
      < 1.495597, 0.104743, -2.977964>,
      < 1.277096, 0.104712, -2.975997>
    }
    triangle {
      < 1.521497, 0.107672, -2.994010>,
      < 1.546168, 0.107216, -2.991798>,
      < 1.503474, 0.104443, -2.976199>
    }
    triangle {
      < 1.521497, 0.107672, -2.994010>,
      < 1.503474, 0.104443, -2.976199>,
      < 1.495597, 0.104743, -2.977964>
    }
    triangle {
      < 1.619913, 0.035428, -2.930400>,
      < 1.619922, 0.048339, -3.011919>,
      < 1.638026, 0.050092, -3.011639>
    }
    triangle {
      < 1.619913, 0.035428, -2.930400>,
      < 1.638026, 0.050092, -3.011639>,
      < 1.638018, 0.037181, -2.930121>
    }
    triangle {
      < 1.638018, 0.037181, -2.930121>,
      < 1.638026, 0.050092, -3.011639>,
      < 1.653378, 0.055129, -3.010840>
    }
    triangle {
      < 1.638018, 0.037181, -2.930121>,
      < 1.653378, 0.055129, -3.010840>,
      < 1.653370, 0.042218, -2.929321>
    }
    triangle {
      < 1.653370, 0.042218, -2.929321>,
      < 1.653378, 0.055129, -3.010840>,
      < 1.663642, 0.062684, -3.009642>
    }
    triangle {
      < 1.653370, 0.042218, -2.929321>,
      < 1.663642, 0.062684, -3.009642>,
      < 1.663633, 0.049773, -2.928124>
    }
    triangle {
      < 1.663633, 0.049773, -2.928124>,
      < 1.663642, 0.062684, -3.009642>,
      < 1.667255, 0.071607, -3.008229>
    }
    triangle {
      < 1.663633, 0.049773, -2.928124>,
      < 1.667255, 0.071607, -3.008229>,
      < 1.667247, 0.058696, -2.926711>
    }
    triangle {
      < 1.667247, 0.058696, -2.926711>,
      < 1.667255, 0.071607, -3.008229>,
      < 1.663664, 0.080539, -3.006815>
    }
    triangle {
      < 1.667247, 0.058696, -2.926711>,
      < 1.663664, 0.080539, -3.006815>,
      < 1.663657, 0.067628, -2.925296>
    }
    triangle {
      < 1.663657, 0.067628, -2.925296>,
      < 1.663664, 0.080539, -3.006815>,
      < 1.653421, 0.088120, -3.005615>
    }
    triangle {
      < 1.663657, 0.067628, -2.925296>,
      < 1.653421, 0.088120, -3.005615>,
      < 1.653412, 0.075209, -2.924097>
    }
    triangle {
      < 1.653412, 0.075209, -2.924097>,
      < 1.653421, 0.088120, -3.005615>,
      < 1.638081, 0.093196, -3.004812>
    }
    triangle {
      < 1.653412, 0.075209, -2.924097>,
      < 1.638081, 0.093196, -3.004812>,
      < 1.638074, 0.080285, -2.923294>
    }
    triangle {
      < 1.638074, 0.080285, -2.923294>,
      < 1.638081, 0.093196, -3.004812>,
      < 1.619981, 0.094995, -3.004530>
    }
    triangle {
      < 1.638074, 0.080285, -2.923294>,
      < 1.619981, 0.094995, -3.004530>,
      < 1.619973, 0.082084, -2.923011>
    }
    triangle {
      < 1.619973, 0.082084, -2.923011>,
      < 1.619981, 0.094995, -3.004530>,
      < 1.601878, 0.093242, -3.004809>
    }
    triangle {
      < 1.619973, 0.082084, -2.923011>,
      < 1.601878, 0.093242, -3.004809>,
      < 1.601870, 0.080331, -2.923290>
    }
    triangle {
      < 1.601870, 0.080331, -2.923290>,
      < 1.601878, 0.093242, -3.004809>,
      < 1.586526, 0.088205, -3.005609>
    }
    triangle {
      < 1.601870, 0.080331, -2.923290>,
      < 1.586526, 0.088205, -3.005609>,
      < 1.586518, 0.075294, -2.924090>
    }
    triangle {
      < 1.586518, 0.075294, -2.924090>,
      < 1.586526, 0.088205, -3.005609>,
      < 1.576262, 0.080650, -3.006806>
    }
    triangle {
      < 1.586518, 0.075294, -2.924090>,
      < 1.576262, 0.080650, -3.006806>,
      < 1.576254, 0.067739, -2.925287>
    }
    triangle {
      < 1.576254, 0.067739, -2.925287>,
      < 1.576262, 0.080650, -3.006806>,
      < 1.572650, 0.071727, -3.008220>
    }
    triangle {
      < 1.576254, 0.067739, -2.925287>,
      < 1.572650, 0.071727, -3.008220>,
      < 1.572642, 0.058816, -2.926701>
    }
    triangle {
      < 1.572642, 0.058816, -2.926701>,
      < 1.572650, 0.071727, -3.008220>,
      < 1.576239, 0.062795, -3.009634>
    }
    triangle {
      < 1.572642, 0.058816, -2.926701>,
      < 1.576239, 0.062795, -3.009634>,
      < 1.576231, 0.049884, -2.928116>
    }
    triangle {
      < 1.576231, 0.049884, -2.928116>,
      < 1.576239, 0.062795, -3.009634>,
      < 1.586483, 0.055214, -3.010834>
    }
    triangle {
      < 1.576231, 0.049884, -2.928116>,
      < 1.586483, 0.055214, -3.010834>,
      < 1.586475, 0.042303, -2.929315>
    }
    triangle {
      < 1.586475, 0.042303, -2.929315>,
      < 1.586483, 0.055214, -3.010834>,
      < 1.601822, 0.050138, -3.011636>
    }
    triangle {
      < 1.586475, 0.042303, -2.929315>,
      < 1.601822, 0.050138, -3.011636>,
      < 1.601814, 0.037227, -2.930118>
    }
    triangle {
      < 1.601814, 0.037227, -2.930118>,
      < 1.601822, 0.050138, -3.011636>,
      < 1.619922, 0.048339, -3.011919>
    }
    triangle {
      < 1.601814, 0.037227, -2.930118>,
      < 1.619922, 0.048339, -3.011919>,
      < 1.619913, 0.035428, -2.930400>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.601822, 0.050138, -3.011636>,
      < 1.586483, 0.055214, -3.010834>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.586483, 0.055214, -3.010834>,
      < 1.576239, 0.062795, -3.009634>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.576239, 0.062795, -3.009634>,
      < 1.572650, 0.071727, -3.008220>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.572650, 0.071727, -3.008220>,
      < 1.619951, 0.071667, -3.008224>
    }
    triangle {
      < 1.576254, 0.067739, -2.925287>,
      < 1.572642, 0.058816, -2.926701>,
      < 1.533916, 0.060832, -2.926386>
    }
    triangle {
      < 1.576254, 0.067739, -2.925287>,
      < 1.533916, 0.060832, -2.926386>,
      < 1.529626, 0.075296, -2.924094>
    }
    triangle {
      < 1.572642, 0.058816, -2.926701>,
      < 1.576231, 0.049884, -2.928116>,
      < 1.542985, 0.045402, -2.928829>
    }
    triangle {
      < 1.572642, 0.058816, -2.926701>,
      < 1.542985, 0.045402, -2.928829>,
      < 1.533916, 0.060832, -2.926386>
    }
    triangle {
      < 1.576231, 0.049884, -2.928116>,
      < 1.586475, 0.042303, -2.929315>,
      < 1.560979, 0.027840, -2.931609>
    }
    triangle {
      < 1.576231, 0.049884, -2.928116>,
      < 1.560979, 0.027840, -2.931609>,
      < 1.542985, 0.045402, -2.928829>
    }
    triangle {
      < 1.586475, 0.042303, -2.929315>,
      < 1.601814, 0.037227, -2.930118>,
      < 1.587300, 0.014705, -2.933686>
    }
    triangle {
      < 1.586475, 0.042303, -2.929315>,
      < 1.587300, 0.014705, -2.933686>,
      < 1.560979, 0.027840, -2.931609>
    }
    triangle {
      < 1.601814, 0.037227, -2.930118>,
      < 1.619913, 0.035428, -2.930400>,
      < 1.619512, 0.009845, -2.934453>
    }
    triangle {
      < 1.601814, 0.037227, -2.930118>,
      < 1.619512, 0.009845, -2.934453>,
      < 1.587300, 0.014705, -2.933686>
    }
    triangle {
      < 1.619913, 0.035428, -2.930400>,
      < 1.638018, 0.037181, -2.930121>,
      < 1.650724, 0.014184, -2.933762>
    }
    triangle {
      < 1.619913, 0.035428, -2.930400>,
      < 1.650724, 0.014184, -2.933762>,
      < 1.619512, 0.009845, -2.934453>
    }
    triangle {
      < 1.638018, 0.037181, -2.930121>,
      < 1.653370, 0.042218, -2.929321>,
      < 1.678538, 0.027637, -2.931628>
    }
    triangle {
      < 1.638018, 0.037181, -2.930121>,
      < 1.678538, 0.027637, -2.931628>,
      < 1.650724, 0.014184, -2.933762>
    }
    triangle {
      < 1.653370, 0.042218, -2.929321>,
      < 1.663633, 0.049773, -2.928124>,
      < 1.694175, 0.044587, -2.928943>
    }
    triangle {
      < 1.653370, 0.042218, -2.929321>,
      < 1.694175, 0.044587, -2.928943>,
      < 1.678538, 0.027637, -2.931628>
    }
    triangle {
      < 1.663633, 0.049773, -2.928124>,
      < 1.667247, 0.058696, -2.926711>,
      < 1.698328, 0.059668, -2.926553>
    }
    triangle {
      < 1.663633, 0.049773, -2.928124>,
      < 1.698328, 0.059668, -2.926553>,
      < 1.694175, 0.044587, -2.928943>
    }
    triangle {
      < 1.667247, 0.058696, -2.926711>,
      < 1.663657, 0.067628, -2.925296>,
      < 1.700536, 0.074240, -2.924246>
    }
    triangle {
      < 1.667247, 0.058696, -2.926711>,
      < 1.700536, 0.074240, -2.924246>,
      < 1.698328, 0.059668, -2.926553>
    }
    triangle {
      < 1.663657, 0.067628, -2.925296>,
      < 1.653412, 0.075209, -2.924097>,
      < 1.680764, 0.093743, -2.921158>
    }
    triangle {
      < 1.663657, 0.067628, -2.925296>,
      < 1.680764, 0.093743, -2.921158>,
      < 1.700760, 0.078871, -2.923512>
    }
    triangle {
      < 1.663657, 0.067628, -2.925296>,
      < 1.700760, 0.078871, -2.923512>,
      < 1.700536, 0.074240, -2.924246>
    }
    triangle {
      < 1.653412, 0.075209, -2.924097>,
      < 1.638074, 0.080285, -2.923294>,
      < 1.648183, 0.090016, -2.921748>
    }
    triangle {
      < 1.653412, 0.075209, -2.924097>,
      < 1.648183, 0.090016, -2.921748>,
      < 1.680764, 0.093743, -2.921158>
    }
    triangle {
      < 1.638074, 0.080285, -2.923294>,
      < 1.619973, 0.082084, -2.923011>,
      < 1.613693, 0.086068, -2.922376>
    }
    triangle {
      < 1.638074, 0.080285, -2.923294>,
      < 1.613693, 0.086068, -2.922376>,
      < 1.648183, 0.090016, -2.921748>
    }
    triangle {
      < 1.619973, 0.082084, -2.923011>,
      < 1.601870, 0.080331, -2.923290>,
      < 1.583470, 0.082608, -2.922928>
    }
    triangle {
      < 1.619973, 0.082084, -2.923011>,
      < 1.583470, 0.082608, -2.922928>,
      < 1.613693, 0.086068, -2.922376>
    }
    triangle {
      < 1.601870, 0.080331, -2.923290>,
      < 1.586518, 0.075294, -2.924090>,
      < 1.562716, 0.080230, -2.923307>
    }
    triangle {
      < 1.601870, 0.080331, -2.923290>,
      < 1.562716, 0.080230, -2.923307>,
      < 1.583470, 0.082608, -2.922928>
    }
    triangle {
      < 1.586518, 0.075294, -2.924090>,
      < 1.576254, 0.067739, -2.925287>,
      < 1.529626, 0.075296, -2.924094>
    }
    triangle {
      < 1.586518, 0.075294, -2.924090>,
      < 1.529626, 0.075296, -2.924094>,
      < 1.562716, 0.080230, -2.923307>
    }
    triangle {
      < 1.524423, 0.074602, -2.919142>,
      < 1.529285, 0.058092, -2.921758>,
      < 1.529284, 0.055636, -2.906252>
    }
    triangle {
      < 1.524423, 0.074602, -2.919142>,
      < 1.529284, 0.055636, -2.906252>,
      < 1.524422, 0.072146, -2.903637>
    }
    triangle {
      < 1.529285, 0.058092, -2.921758>,
      < 1.538995, 0.041570, -2.924374>,
      < 1.538994, 0.039114, -2.908868>
    }
    triangle {
      < 1.529285, 0.058092, -2.921758>,
      < 1.538994, 0.039114, -2.908868>,
      < 1.529284, 0.055636, -2.906252>
    }
    triangle {
      < 1.538995, 0.041570, -2.924374>,
      < 1.558023, 0.023000, -2.927313>,
      < 1.558021, 0.020544, -2.911808>
    }
    triangle {
      < 1.538995, 0.041570, -2.924374>,
      < 1.558021, 0.020544, -2.911808>,
      < 1.538994, 0.039114, -2.908868>
    }
    triangle {
      < 1.558023, 0.023000, -2.927313>,
      < 1.585760, 0.009158, -2.929503>,
      < 1.585758, 0.006702, -2.913997>
    }
    triangle {
      < 1.558023, 0.023000, -2.927313>,
      < 1.585758, 0.006702, -2.913997>,
      < 1.558021, 0.020544, -2.911808>
    }
    triangle {
      < 1.585760, 0.009158, -2.929503>,
      < 1.619434, 0.004125, -2.930296>,
      < 1.619432, 0.001670, -2.914790>
    }
    triangle {
      < 1.585760, 0.009158, -2.929503>,
      < 1.619432, 0.001670, -2.914790>,
      < 1.585758, 0.006702, -2.913997>
    }
    triangle {
      < 1.619434, 0.004125, -2.930296>,
      < 1.653118, 0.009067, -2.929510>,
      < 1.653117, 0.006611, -2.914004>
    }
    triangle {
      < 1.619434, 0.004125, -2.930296>,
      < 1.653117, 0.006611, -2.914004>,
      < 1.619432, 0.001670, -2.914790>
    }
    triangle {
      < 1.653118, 0.009067, -2.929510>,
      < 1.681591, 0.022833, -2.927326>,
      < 1.681590, 0.020377, -2.911820>
    }
    triangle {
      < 1.653118, 0.009067, -2.929510>,
      < 1.681590, 0.020377, -2.911820>,
      < 1.653117, 0.006611, -2.914004>
    }
    triangle {
      < 1.681591, 0.022833, -2.927326>,
      < 1.698683, 0.041359, -2.924391>,
      < 1.698681, 0.038903, -2.908885>
    }
    triangle {
      < 1.681591, 0.022833, -2.927326>,
      < 1.698681, 0.038903, -2.908885>,
      < 1.681590, 0.020377, -2.911820>
    }
    triangle {
      < 1.698683, 0.041359, -2.924391>,
      < 1.703229, 0.057868, -2.921776>,
      < 1.703227, 0.055412, -2.906270>
    }
    triangle {
      < 1.698683, 0.041359, -2.924391>,
      < 1.703227, 0.055412, -2.906270>,
      < 1.698681, 0.038903, -2.908885>
    }
    triangle {
      < 1.703229, 0.057868, -2.921776>,
      < 1.705733, 0.074390, -2.919159>,
      < 1.705732, 0.071934, -2.903653>
    }
    triangle {
      < 1.703229, 0.057868, -2.921776>,
      < 1.705732, 0.071934, -2.903653>,
      < 1.703227, 0.055412, -2.906270>
    }
    triangle {
      < 1.700760, 0.078871, -2.923512>,
      < 1.680764, 0.093743, -2.921158>,
      < 1.700921, 0.099682, -2.920027>
    }
    triangle {
      < 1.524422, 0.072146, -2.903637>,
      < 1.532780, 0.092368, -2.900428>,
      < 1.532200, 0.094495, -2.913850>
    }
    triangle {
      < 1.524422, 0.072146, -2.903637>,
      < 1.532200, 0.094495, -2.913850>,
      < 1.524423, 0.074602, -2.919142>
    }
    triangle {
      < 1.613693, 0.086068, -2.922376>,
      < 1.640612, 0.095173, -2.917354>,
      < 1.648183, 0.090016, -2.921748>
    }
    triangle {
      < 1.648183, 0.090016, -2.921748>,
      < 1.640612, 0.095173, -2.917354>,
      < 1.700921, 0.099682, -2.920027>
    }
    triangle {
      < 1.648183, 0.090016, -2.921748>,
      < 1.700921, 0.099682, -2.920027>,
      < 1.680764, 0.093743, -2.921158>
    }
    triangle {
      < 1.705733, 0.074390, -2.919159>,
      < 1.706616, 0.099792, -2.915124>,
      < 1.708834, 0.097337, -2.899652>
    }
    triangle {
      < 1.705733, 0.074390, -2.919159>,
      < 1.708834, 0.097337, -2.899652>,
      < 1.705732, 0.071934, -2.903653>
    }
    triangle {
      < 1.583470, 0.082608, -2.922928>,
      < 1.530409, 0.096631, -2.927305>,
      < 1.613693, 0.086068, -2.922376>
    }
    triangle {
      < 1.530409, 0.096631, -2.927305>,
      < 1.562716, 0.080230, -2.923307>,
      < 1.529626, 0.075296, -2.924094>
    }
    triangle {
      < 1.530409, 0.096631, -2.927305>,
      < 1.583470, 0.082608, -2.922928>,
      < 1.562716, 0.080230, -2.923307>
    }
    triangle {
      < 1.530409, 0.096631, -2.927305>,
      < 1.640612, 0.095173, -2.917354>,
      < 1.613693, 0.086068, -2.922376>
    }
    triangle {
      < 1.706616, 0.099792, -2.915124>,
      < 1.700921, 0.099682, -2.920027>,
      < 1.703923, 0.101287, -2.924543>
    }
    triangle {
      < 1.700760, 0.078871, -2.923512>,
      < 1.705733, 0.074390, -2.919159>,
      < 1.700536, 0.074240, -2.924246>
    }
    triangle {
      < 1.700760, 0.078871, -2.923512>,
      < 1.700921, 0.099682, -2.920027>,
      < 1.706616, 0.099792, -2.915124>
    }
    triangle {
      < 1.700760, 0.078871, -2.923512>,
      < 1.706616, 0.099792, -2.915124>,
      < 1.705733, 0.074390, -2.919159>
    }
    triangle {
      < 1.705733, 0.074390, -2.919159>,
      < 1.703229, 0.057868, -2.921776>,
      < 1.698328, 0.059668, -2.926553>
    }
    triangle {
      < 1.705733, 0.074390, -2.919159>,
      < 1.698328, 0.059668, -2.926553>,
      < 1.700536, 0.074240, -2.924246>
    }
    triangle {
      < 1.703229, 0.057868, -2.921776>,
      < 1.698683, 0.041359, -2.924391>,
      < 1.694175, 0.044587, -2.928943>
    }
    triangle {
      < 1.703229, 0.057868, -2.921776>,
      < 1.694175, 0.044587, -2.928943>,
      < 1.698328, 0.059668, -2.926553>
    }
    triangle {
      < 1.698683, 0.041359, -2.924391>,
      < 1.681591, 0.022833, -2.927326>,
      < 1.678538, 0.027637, -2.931628>
    }
    triangle {
      < 1.698683, 0.041359, -2.924391>,
      < 1.678538, 0.027637, -2.931628>,
      < 1.694175, 0.044587, -2.928943>
    }
    triangle {
      < 1.681591, 0.022833, -2.927326>,
      < 1.653118, 0.009067, -2.929510>,
      < 1.650724, 0.014184, -2.933762>
    }
    triangle {
      < 1.681591, 0.022833, -2.927326>,
      < 1.650724, 0.014184, -2.933762>,
      < 1.678538, 0.027637, -2.931628>
    }
    triangle {
      < 1.653118, 0.009067, -2.929510>,
      < 1.619434, 0.004125, -2.930296>,
      < 1.619512, 0.009845, -2.934453>
    }
    triangle {
      < 1.653118, 0.009067, -2.929510>,
      < 1.619512, 0.009845, -2.934453>,
      < 1.650724, 0.014184, -2.933762>
    }
    triangle {
      < 1.529285, 0.058092, -2.921758>,
      < 1.524423, 0.074602, -2.919142>,
      < 1.529626, 0.075296, -2.924094>
    }
    triangle {
      < 1.529285, 0.058092, -2.921758>,
      < 1.529626, 0.075296, -2.924094>,
      < 1.533916, 0.060832, -2.926386>
    }
    triangle {
      < 1.538995, 0.041570, -2.924374>,
      < 1.529285, 0.058092, -2.921758>,
      < 1.533916, 0.060832, -2.926386>
    }
    triangle {
      < 1.538995, 0.041570, -2.924374>,
      < 1.533916, 0.060832, -2.926386>,
      < 1.542985, 0.045402, -2.928829>
    }
    triangle {
      < 1.558023, 0.023000, -2.927313>,
      < 1.538995, 0.041570, -2.924374>,
      < 1.542985, 0.045402, -2.928829>
    }
    triangle {
      < 1.558023, 0.023000, -2.927313>,
      < 1.542985, 0.045402, -2.928829>,
      < 1.560979, 0.027840, -2.931609>
    }
    triangle {
      < 1.585760, 0.009158, -2.929503>,
      < 1.558023, 0.023000, -2.927313>,
      < 1.560979, 0.027840, -2.931609>
    }
    triangle {
      < 1.585760, 0.009158, -2.929503>,
      < 1.560979, 0.027840, -2.931609>,
      < 1.587300, 0.014705, -2.933686>
    }
    triangle {
      < 1.619434, 0.004125, -2.930296>,
      < 1.585760, 0.009158, -2.929503>,
      < 1.587300, 0.014705, -2.933686>
    }
    triangle {
      < 1.619434, 0.004125, -2.930296>,
      < 1.587300, 0.014705, -2.933686>,
      < 1.619512, 0.009845, -2.934453>
    }
    triangle {
      < 1.706616, 0.099792, -2.915124>,
      < 1.703923, 0.101287, -2.924543>,
      < 1.710687, 0.102039, -2.920277>
    }
    triangle {
      < 1.530409, 0.096631, -2.927305>,
      < 1.529626, 0.075296, -2.924094>,
      < 1.524423, 0.074602, -2.919142>
    }
    triangle {
      < 1.530409, 0.096631, -2.927305>,
      < 1.524423, 0.074602, -2.919142>,
      < 1.532200, 0.094495, -2.913850>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.619951, 0.071667, -3.008224>,
      < 1.667255, 0.071607, -3.008229>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.667255, 0.071607, -3.008229>,
      < 1.663642, 0.062684, -3.009642>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.663642, 0.062684, -3.009642>,
      < 1.653378, 0.055129, -3.010840>
    }
    triangle {
      < 1.619922, 0.048339, -3.011919>,
      < 1.653378, 0.055129, -3.010840>,
      < 1.638026, 0.050092, -3.011639>
    }
    triangle {
      < 1.619951, 0.071667, -3.008224>,
      < 1.572650, 0.071727, -3.008220>,
      < 1.576262, 0.080650, -3.006806>
    }
    triangle {
      < 1.619951, 0.071667, -3.008224>,
      < 1.576262, 0.080650, -3.006806>,
      < 1.586526, 0.088205, -3.005609>
    }
    triangle {
      < 1.619951, 0.071667, -3.008224>,
      < 1.586526, 0.088205, -3.005609>,
      < 1.601878, 0.093242, -3.004809>
    }
    triangle {
      < 1.619951, 0.071667, -3.008224>,
      < 1.601878, 0.093242, -3.004809>,
      < 1.619981, 0.094995, -3.004530>
    }
    triangle {
      < 1.667255, 0.071607, -3.008229>,
      < 1.619951, 0.071667, -3.008224>,
      < 1.619981, 0.094995, -3.004530>
    }
    triangle {
      < 1.667255, 0.071607, -3.008229>,
      < 1.619981, 0.094995, -3.004530>,
      < 1.638081, 0.093196, -3.004812>
    }
    triangle {
      < 1.667255, 0.071607, -3.008229>,
      < 1.638081, 0.093196, -3.004812>,
      < 1.653421, 0.088120, -3.005615>
    }
    triangle {
      < 1.667255, 0.071607, -3.008229>,
      < 1.653421, 0.088120, -3.005615>,
      < 1.663664, 0.080539, -3.006815>
    }
    triangle {
      < 1.569181, 0.121968, -2.895740>,
      < 1.532780, 0.092368, -2.900428>,
      < 1.532777, 0.084427, -2.850253>
    }
    triangle {
      < 1.569181, 0.121968, -2.895740>,
      < 1.532777, 0.084427, -2.850253>,
      < 1.569178, 0.114027, -2.845564>
    }
    triangle {
      < 1.532780, 0.092368, -2.900428>,
      < 1.524422, 0.072146, -2.903637>,
      < 1.524419, 0.064205, -2.853461>
    }
    triangle {
      < 1.532780, 0.092368, -2.900428>,
      < 1.524419, 0.064205, -2.853461>,
      < 1.532777, 0.084427, -2.850253>
    }
    triangle {
      < 1.524422, 0.072146, -2.903637>,
      < 1.529284, 0.055636, -2.906252>,
      < 1.529281, 0.047695, -2.856076>
    }
    triangle {
      < 1.524422, 0.072146, -2.903637>,
      < 1.529281, 0.047695, -2.856076>,
      < 1.524419, 0.064205, -2.853461>
    }
    triangle {
      < 1.529284, 0.055636, -2.906252>,
      < 1.538994, 0.039114, -2.908868>,
      < 1.538991, 0.031173, -2.858692>
    }
    triangle {
      < 1.529284, 0.055636, -2.906252>,
      < 1.538991, 0.031173, -2.858692>,
      < 1.529281, 0.047695, -2.856076>
    }
    triangle {
      < 1.538994, 0.039114, -2.908868>,
      < 1.558021, 0.020544, -2.911808>,
      < 1.558018, 0.012603, -2.861632>
    }
    triangle {
      < 1.538994, 0.039114, -2.908868>,
      < 1.558018, 0.012603, -2.861632>,
      < 1.538991, 0.031173, -2.858692>
    }
    triangle {
      < 1.558021, 0.020544, -2.911808>,
      < 1.585758, 0.006702, -2.913997>,
      < 1.585755, -0.001239, -2.863822>
    }
    triangle {
      < 1.558021, 0.020544, -2.911808>,
      < 1.585755, -0.001239, -2.863822>,
      < 1.558018, 0.012603, -2.861632>
    }
    triangle {
      < 1.585758, 0.006702, -2.913997>,
      < 1.619432, 0.001670, -2.914790>,
      < 1.619429, -0.006272, -2.864615>
    }
    triangle {
      < 1.585758, 0.006702, -2.913997>,
      < 1.619429, -0.006272, -2.864615>,
      < 1.585755, -0.001239, -2.863822>
    }
    triangle {
      < 1.619432, 0.001670, -2.914790>,
      < 1.653117, 0.006611, -2.914004>,
      < 1.653114, -0.001330, -2.863828>
    }
    triangle {
      < 1.619432, 0.001670, -2.914790>,
      < 1.653114, -0.001330, -2.863828>,
      < 1.619429, -0.006272, -2.864615>
    }
    triangle {
      < 1.653117, 0.006611, -2.914004>,
      < 1.681590, 0.020377, -2.911820>,
      < 1.681587, 0.012436, -2.861645>
    }
    triangle {
      < 1.653117, 0.006611, -2.914004>,
      < 1.681587, 0.012436, -2.861645>,
      < 1.653114, -0.001330, -2.863828>
    }
    triangle {
      < 1.681590, 0.020377, -2.911820>,
      < 1.698681, 0.038903, -2.908885>,
      < 1.698679, 0.030962, -2.858709>
    }
    triangle {
      < 1.681590, 0.020377, -2.911820>,
      < 1.698679, 0.030962, -2.858709>,
      < 1.681587, 0.012436, -2.861645>
    }
    triangle {
      < 1.698681, 0.038903, -2.908885>,
      < 1.703227, 0.055412, -2.906270>,
      < 1.703224, 0.047471, -2.856094>
    }
    triangle {
      < 1.698681, 0.038903, -2.908885>,
      < 1.703224, 0.047471, -2.856094>,
      < 1.698679, 0.030962, -2.858709>
    }
    triangle {
      < 1.703227, 0.055412, -2.906270>,
      < 1.705732, 0.071934, -2.903653>,
      < 1.705729, 0.063993, -2.853477>
    }
    triangle {
      < 1.703227, 0.055412, -2.906270>,
      < 1.705729, 0.063993, -2.853477>,
      < 1.703224, 0.047471, -2.856094>
    }
    triangle {
      < 1.705732, 0.071934, -2.903653>,
      < 1.708834, 0.097337, -2.899652>,
      < 1.708831, 0.089396, -2.849476>
    }
    triangle {
      < 1.705732, 0.071934, -2.903653>,
      < 1.708831, 0.089396, -2.849476>,
      < 1.705729, 0.063993, -2.853477>
    }
    triangle {
      < 1.708834, 0.097337, -2.899652>,
      < 1.742028, 0.106949, -2.898102>,
      < 1.742025, 0.099008, -2.847926>
    }
    triangle {
      < 1.708834, 0.097337, -2.899652>,
      < 1.742025, 0.099008, -2.847926>,
      < 1.708831, 0.089396, -2.849476>
    }
    triangle {
      < 1.742028, 0.106949, -2.898102>,
      < 1.708858, 0.116653, -2.896593>,
      < 1.708855, 0.108712, -2.846417>
    }
    triangle {
      < 1.742028, 0.106949, -2.898102>,
      < 1.708855, 0.108712, -2.846417>,
      < 1.742025, 0.099008, -2.847926>
    }
    triangle {
      < 1.708858, 0.116653, -2.896593>,
      < 1.642766, 0.121669, -2.895805>,
      < 1.642763, 0.113728, -2.845629>
    }
    triangle {
      < 1.708858, 0.116653, -2.896593>,
      < 1.642763, 0.113728, -2.845629>,
      < 1.708855, 0.108712, -2.846417>
    }
    triangle {
      < 1.642766, 0.121669, -2.895805>,
      < 1.569181, 0.121968, -2.895740>,
      < 1.569178, 0.114027, -2.845564>
    }
    triangle {
      < 1.642766, 0.121669, -2.895805>,
      < 1.569178, 0.114027, -2.845564>,
      < 1.642763, 0.113728, -2.845629>
    }
    triangle {
      < 1.186416, 0.122454, -2.895702>,
      < 1.155444, 0.122247, -2.895804>,
      < 1.155404, 0.114301, -2.845629>
    }
    triangle {
      < 1.186416, 0.122454, -2.895702>,
      < 1.155404, 0.114301, -2.845629>,
      < 1.186377, 0.114507, -2.845527>
    }
    triangle {
      < 1.155444, 0.122247, -2.895804>,
      < 1.125250, 0.117353, -2.896582>,
      < 1.125211, 0.109406, -2.846407>
    }
    triangle {
      < 1.155444, 0.122247, -2.895804>,
      < 1.125211, 0.109406, -2.846407>,
      < 1.155404, 0.114301, -2.845629>
    }
    triangle {
      < 1.125250, 0.117353, -2.896582>,
      < 1.095836, 0.107769, -2.898037>,
      < 1.095797, 0.099822, -2.847863>
    }
    triangle {
      < 1.125250, 0.117353, -2.896582>,
      < 1.095797, 0.099822, -2.847863>,
      < 1.125211, 0.109406, -2.846407>
    }
    triangle {
      < 1.095836, 0.107769, -2.898037>,
      < 1.125226, 0.098131, -2.899626>,
      < 1.125186, 0.090184, -2.849452>
    }
    triangle {
      < 1.095836, 0.107769, -2.898037>,
      < 1.125186, 0.090184, -2.849452>,
      < 1.095797, 0.099822, -2.847863>
    }
    triangle {
      < 1.125226, 0.098131, -2.899626>,
      < 1.155406, 0.093160, -2.900410>,
      < 1.155367, 0.085213, -2.850236>
    }
    triangle {
      < 1.125226, 0.098131, -2.899626>,
      < 1.155367, 0.085213, -2.850236>,
      < 1.125186, 0.090184, -2.849452>
    }
    triangle {
      < 1.155406, 0.093160, -2.900410>,
      < 1.186378, 0.092854, -2.900390>,
      < 1.186339, 0.084908, -2.850215>
    }
    triangle {
      < 1.155406, 0.093160, -2.900410>,
      < 1.186339, 0.084908, -2.850215>,
      < 1.155367, 0.085213, -2.850236>
    }
    triangle {
      < 1.186378, 0.092854, -2.900390>,
      < 1.186416, 0.122454, -2.895702>,
      < 1.186377, 0.114507, -2.845527>
    }
    triangle {
      < 1.186378, 0.092854, -2.900390>,
      < 1.186377, 0.114507, -2.845527>,
      < 1.186339, 0.084908, -2.850215>
    }
    triangle {
      < 1.511216, 0.134043, 2.971511>,
      < 1.495635, 0.134343, 2.973276>,
      < 1.521534, 0.136451, 2.989452>
    }
    triangle {
      < 1.511216, 0.134043, 2.971511>,
      < 1.521534, 0.136451, 2.989452>,
      < 1.546206, 0.136139, 2.987218>
    }
    triangle {
      < 1.495635, 0.134343, 2.973276>,
      < 1.277134, 0.134312, 2.971308>,
      < 1.278458, 0.136412, 2.987453>
    }
    triangle {
      < 1.495635, 0.134343, 2.973276>,
      < 1.278458, 0.136412, 2.987453>,
      < 1.521534, 0.136451, 2.989452>
    }
    triangle {
      < 1.277134, 0.134312, 2.971308>,
      < 1.254544, 0.133502, 2.966010>,
      < 1.248751, 0.135527, 2.981526>
    }
    triangle {
      < 1.277134, 0.134312, 2.971308>,
      < 1.248751, 0.135527, 2.981526>,
      < 1.278458, 0.136412, 2.987453>
    }
    triangle {
      < 1.254544, 0.133502, 2.966010>,
      < 1.233700, 0.132165, 2.957398>,
      < 1.221411, 0.134071, 2.971846>
    }
    triangle {
      < 1.254544, 0.133502, 2.966010>,
      < 1.221411, 0.134071, 2.971846>,
      < 1.248751, 0.135527, 2.981526>
    }
    triangle {
      < 1.233700, 0.132165, 2.957398>,
      < 1.215957, 0.130405, 2.946145>,
      < 1.197822, 0.132122, 2.959055>
    }
    triangle {
      < 1.233700, 0.132165, 2.957398>,
      < 1.197822, 0.132122, 2.959055>,
      < 1.221411, 0.134071, 2.971846>
    }
    triangle {
      < 1.215957, 0.130405, 2.946145>,
      < 1.202151, 0.128364, 2.933146>,
      < 1.178982, 0.129799, 2.943987>
    }
    triangle {
      < 1.215957, 0.130405, 2.946145>,
      < 1.178982, 0.129799, 2.943987>,
      < 1.197822, 0.132122, 2.959055>
    }
    triangle {
      < 1.202151, 0.128364, 2.933146>,
      < 1.192818, 0.126239, 2.919652>,
      < 1.165605, 0.127269, 2.927727>
    }
    triangle {
      < 1.202151, 0.128364, 2.933146>,
      < 1.165605, 0.127269, 2.927727>,
      < 1.178982, 0.129799, 2.943987>
    }
    triangle {
      < 1.192818, 0.126239, 2.919652>,
      < 1.187860, 0.124245, 2.907025>,
      < 1.157893, 0.124717, 2.911452>
    }
    triangle {
      < 1.192818, 0.126239, 2.919652>,
      < 1.157893, 0.124717, 2.911452>,
      < 1.165605, 0.127269, 2.927727>
    }
    triangle {
      < 1.187860, 0.124245, 2.907025>,
      < 1.186416, 0.122454, 2.895702>,
      < 1.155444, 0.122247, 2.895804>
    }
    triangle {
      < 1.187860, 0.124245, 2.907025>,
      < 1.155444, 0.122247, 2.895804>,
      < 1.157893, 0.124717, 2.911452>
    }
    triangle {
      < 1.569181, 0.121968, 2.895740>,
      < 1.568035, 0.124095, 2.909162>,
      < 1.640649, 0.124352, 2.912733>
    }
    triangle {
      < 1.569181, 0.121968, 2.895740>,
      < 1.640649, 0.124352, 2.912733>,
      < 1.642766, 0.121669, 2.895805>
    }
    triangle {
      < 1.568035, 0.124095, 2.909162>,
      < 1.564493, 0.126231, 2.922618>,
      < 1.634262, 0.126999, 2.929410>
    }
    triangle {
      < 1.568035, 0.124095, 2.909162>,
      < 1.634262, 0.126999, 2.929410>,
      < 1.640649, 0.124352, 2.912733>
    }
    triangle {
      < 1.564493, 0.126231, 2.922618>,
      < 1.558383, 0.128325, 2.935789>,
      < 1.623615, 0.129525, 2.945315>
    }
    triangle {
      < 1.564493, 0.126231, 2.922618>,
      < 1.623615, 0.129525, 2.945315>,
      < 1.634262, 0.126999, 2.929410>
    }
    triangle {
      < 1.558383, 0.128325, 2.935789>,
      < 1.549681, 0.130271, 2.948004>,
      < 1.608913, 0.131819, 2.959741>
    }
    triangle {
      < 1.558383, 0.128325, 2.935789>,
      < 1.608913, 0.131819, 2.959741>,
      < 1.623615, 0.129525, 2.945315>
    }
    triangle {
      < 1.549681, 0.130271, 2.948004>,
      < 1.538607, 0.131944, 2.958474>,
      < 1.590627, 0.133755, 2.971938>
    }
    triangle {
      < 1.549681, 0.130271, 2.948004>,
      < 1.590627, 0.133755, 2.971938>,
      < 1.608913, 0.131819, 2.959741>
    }
    triangle {
      < 1.538607, 0.131944, 2.958474>,
      < 1.525593, 0.133229, 2.966486>,
      < 1.569444, 0.135226, 2.981258>
    }
    triangle {
      < 1.538607, 0.131944, 2.958474>,
      < 1.569444, 0.135226, 2.981258>,
      < 1.590627, 0.133755, 2.971938>
    }
    triangle {
      < 1.525593, 0.133229, 2.966486>,
      < 1.511216, 0.134043, 2.971511>,
      < 1.546206, 0.136139, 2.987218>
    }
    triangle {
      < 1.525593, 0.133229, 2.966486>,
      < 1.546206, 0.136139, 2.987218>,
      < 1.569444, 0.135226, 2.981258>
    }
    triangle {
      < 1.532200, 0.094495, 2.913850>,
      < 1.568035, 0.124095, 2.909162>,
      < 1.569181, 0.121968, 2.895740>
    }
    triangle {
      < 1.532200, 0.094495, 2.913850>,
      < 1.569181, 0.121968, 2.895740>,
      < 1.532780, 0.092368, 2.900428>
    }
    triangle {
      < 1.277096, 0.104712, 2.975997>,
      < 1.277134, 0.134312, 2.971308>,
      < 1.495635, 0.134343, 2.973276>
    }
    triangle {
      < 1.277096, 0.104712, 2.975997>,
      < 1.495635, 0.134343, 2.973276>,
      < 1.495597, 0.104743, 2.977964>
    }
    triangle {
      < 1.233662, 0.102565, 2.962086>,
      < 1.233700, 0.132165, 2.957398>,
      < 1.254544, 0.133502, 2.966010>
    }
    triangle {
      < 1.233662, 0.102565, 2.962086>,
      < 1.254544, 0.133502, 2.966010>,
      < 1.254506, 0.103902, 2.970698>
    }
    triangle {
      < 1.215919, 0.100805, 2.950832>,
      < 1.215957, 0.130405, 2.946145>,
      < 1.233700, 0.132165, 2.957398>
    }
    triangle {
      < 1.215919, 0.100805, 2.950832>,
      < 1.233700, 0.132165, 2.957398>,
      < 1.233662, 0.102565, 2.962086>
    }
    triangle {
      < 1.202113, 0.098764, 2.937833>,
      < 1.202151, 0.128364, 2.933146>,
      < 1.215957, 0.130405, 2.946145>
    }
    triangle {
      < 1.202113, 0.098764, 2.937833>,
      < 1.215957, 0.130405, 2.946145>,
      < 1.215919, 0.100805, 2.950832>
    }
    triangle {
      < 1.187822, 0.094645, 2.911713>,
      < 1.187860, 0.124245, 2.907025>,
      < 1.192818, 0.126239, 2.919652>
    }
    triangle {
      < 1.187822, 0.094645, 2.911713>,
      < 1.192818, 0.126239, 2.919652>,
      < 1.192780, 0.096639, 2.924340>
    }
    triangle {
      < 1.202151, 0.128364, 2.933146>,
      < 1.202113, 0.098764, 2.937833>,
      < 1.192780, 0.096639, 2.924340>
    }
    triangle {
      < 1.202151, 0.128364, 2.933146>,
      < 1.192780, 0.096639, 2.924340>,
      < 1.192818, 0.126239, 2.919652>
    }
    triangle {
      < 1.186378, 0.092854, 2.900390>,
      < 1.186416, 0.122454, 2.895702>,
      < 1.187860, 0.124245, 2.907025>
    }
    triangle {
      < 1.186378, 0.092854, 2.900390>,
      < 1.187860, 0.124245, 2.907025>,
      < 1.187822, 0.094645, 2.911713>
    }
    triangle {
      < 1.254506, 0.103902, 2.970698>,
      < 1.254544, 0.133502, 2.966010>,
      < 1.277134, 0.134312, 2.971308>
    }
    triangle {
      < 1.254506, 0.103902, 2.970698>,
      < 1.277134, 0.134312, 2.971308>,
      < 1.277096, 0.104712, 2.975997>
    }
    triangle {
      < 1.530409, 0.096631, 2.927305>,
      < 1.564493, 0.126231, 2.922618>,
      < 1.568035, 0.124095, 2.909162>
    }
    triangle {
      < 1.530409, 0.096631, 2.927305>,
      < 1.568035, 0.124095, 2.909162>,
      < 1.532200, 0.094495, 2.913850>
    }
    triangle {
      < 1.527320, 0.098725, 2.940478>,
      < 1.558383, 0.128325, 2.935789>,
      < 1.564493, 0.126231, 2.922618>
    }
    triangle {
      < 1.527320, 0.098725, 2.940478>,
      < 1.564493, 0.126231, 2.922618>,
      < 1.530409, 0.096631, 2.927305>
    }
    triangle {
      < 1.522920, 0.100671, 2.952693>,
      < 1.549681, 0.130271, 2.948004>,
      < 1.558383, 0.128325, 2.935789>
    }
    triangle {
      < 1.522920, 0.100671, 2.952693>,
      < 1.558383, 0.128325, 2.935789>,
      < 1.527320, 0.098725, 2.940478>
    }
    triangle {
      < 1.517322, 0.102343, 2.963162>,
      < 1.538607, 0.131944, 2.958474>,
      < 1.549681, 0.130271, 2.948004>
    }
    triangle {
      < 1.517322, 0.102343, 2.963162>,
      < 1.549681, 0.130271, 2.948004>,
      < 1.522920, 0.100671, 2.952693>
    }
    triangle {
      < 1.510743, 0.103629, 2.971175>,
      < 1.525593, 0.133229, 2.966486>,
      < 1.538607, 0.131944, 2.958474>
    }
    triangle {
      < 1.510743, 0.103629, 2.971175>,
      < 1.538607, 0.131944, 2.958474>,
      < 1.517322, 0.102343, 2.963162>
    }
    triangle {
      < 1.503474, 0.104443, 2.976199>,
      < 1.511216, 0.134043, 2.971511>,
      < 1.525593, 0.133229, 2.966486>
    }
    triangle {
      < 1.503474, 0.104443, 2.976199>,
      < 1.525593, 0.133229, 2.966486>,
      < 1.510743, 0.103629, 2.971175>
    }
    triangle {
      < 1.495597, 0.104743, 2.977964>,
      < 1.495635, 0.134343, 2.973276>,
      < 1.511216, 0.134043, 2.971511>
    }
    triangle {
      < 1.495597, 0.104743, 2.977964>,
      < 1.511216, 0.134043, 2.971511>,
      < 1.503474, 0.104443, 2.976199>
    }
    triangle {
      < 1.705940, 0.119880, 2.916955>,
      < 1.708858, 0.116653, 2.896593>,
      < 1.642766, 0.121669, 2.895805>
    }
    triangle {
      < 1.705940, 0.119880, 2.916955>,
      < 1.642766, 0.121669, 2.895805>,
      < 1.640649, 0.124352, 2.912733>
    }
    triangle {
      < 1.697234, 0.123024, 2.936750>,
      < 1.705940, 0.119880, 2.916955>,
      < 1.640649, 0.124352, 2.912733>
    }
    triangle {
      < 1.697234, 0.123024, 2.936750>,
      < 1.640649, 0.124352, 2.912733>,
      < 1.634262, 0.126999, 2.929410>
    }
    triangle {
      < 1.682957, 0.125970, 2.955271>,
      < 1.697234, 0.123024, 2.936750>,
      < 1.634262, 0.126999, 2.929410>
    }
    triangle {
      < 1.682957, 0.125970, 2.955271>,
      < 1.634262, 0.126999, 2.929410>,
      < 1.623615, 0.129525, 2.945315>
    }
    triangle {
      < 1.663552, 0.128596, 2.971766>,
      < 1.682957, 0.125970, 2.955271>,
      < 1.623615, 0.129525, 2.945315>
    }
    triangle {
      < 1.663552, 0.128596, 2.971766>,
      < 1.623615, 0.129525, 2.945315>,
      < 1.608913, 0.131819, 2.959741>
    }
    triangle {
      < 1.639715, 0.130786, 2.985514>,
      < 1.663552, 0.128596, 2.971766>,
      < 1.608913, 0.131819, 2.959741>
    }
    triangle {
      < 1.639715, 0.130786, 2.985514>,
      < 1.608913, 0.131819, 2.959741>,
      < 1.590627, 0.133755, 2.971938>
    }
    triangle {
      < 1.612344, 0.132434, 2.995907>,
      < 1.639715, 0.130786, 2.985514>,
      < 1.590627, 0.133755, 2.971938>
    }
    triangle {
      < 1.612344, 0.132434, 2.995907>,
      < 1.590627, 0.133755, 2.971938>,
      < 1.569444, 0.135226, 2.981258>
    }
    triangle {
      < 1.582491, 0.133456, 3.002498>,
      < 1.612344, 0.132434, 2.995907>,
      < 1.569444, 0.135226, 2.981258>
    }
    triangle {
      < 1.582491, 0.133456, 3.002498>,
      < 1.569444, 0.135226, 2.981258>,
      < 1.546206, 0.136139, 2.987218>
    }
    triangle {
      < 1.551179, 0.133806, 3.004922>,
      < 1.582491, 0.133456, 3.002498>,
      < 1.546206, 0.136139, 2.987218>
    }
    triangle {
      < 1.551179, 0.133806, 3.004922>,
      < 1.546206, 0.136139, 2.987218>,
      < 1.521534, 0.136451, 2.989452>
    }
    triangle {
      < 1.279926, 0.133783, 3.002790>,
      < 1.551179, 0.133806, 3.004922>,
      < 1.521534, 0.136451, 2.989452>
    }
    triangle {
      < 1.279926, 0.133783, 3.002790>,
      < 1.521534, 0.136451, 2.989452>,
      < 1.278458, 0.136412, 2.987453>
    }
    triangle {
      < 1.243323, 0.132820, 2.996321>,
      < 1.279926, 0.133783, 3.002790>,
      < 1.278458, 0.136412, 2.987453>
    }
    triangle {
      < 1.243323, 0.132820, 2.996321>,
      < 1.278458, 0.136412, 2.987453>,
      < 1.248751, 0.135527, 2.981526>
    }
    triangle {
      < 1.209636, 0.131234, 2.985763>,
      < 1.243323, 0.132820, 2.996321>,
      < 1.248751, 0.135527, 2.981526>
    }
    triangle {
      < 1.209636, 0.131234, 2.985763>,
      < 1.248751, 0.135527, 2.981526>,
      < 1.221411, 0.134071, 2.971846>
    }
    triangle {
      < 1.180308, 0.129088, 2.971683>,
      < 1.209636, 0.131234, 2.985763>,
      < 1.221411, 0.134071, 2.971846>
    }
    triangle {
      < 1.180308, 0.129088, 2.971683>,
      < 1.221411, 0.134071, 2.971846>,
      < 1.197822, 0.132122, 2.959055>
    }
    triangle {
      < 1.156505, 0.126485, 2.954804>,
      < 1.180308, 0.129088, 2.971683>,
      < 1.197822, 0.132122, 2.959055>
    }
    triangle {
      < 1.156505, 0.126485, 2.954804>,
      < 1.197822, 0.132122, 2.959055>,
      < 1.178982, 0.129799, 2.943987>
    }
    triangle {
      < 1.139132, 0.123562, 2.936034>,
      < 1.156505, 0.126485, 2.954804>,
      < 1.178982, 0.129799, 2.943987>
    }
    triangle {
      < 1.139132, 0.123562, 2.936034>,
      < 1.178982, 0.129799, 2.943987>,
      < 1.165605, 0.127269, 2.927727>
    }
    triangle {
      < 1.128697, 0.120476, 2.916363>,
      < 1.139132, 0.123562, 2.936034>,
      < 1.165605, 0.127269, 2.927727>
    }
    triangle {
      < 1.128697, 0.120476, 2.916363>,
      < 1.165605, 0.127269, 2.927727>,
      < 1.157893, 0.124717, 2.911452>
    }
    triangle {
      < 1.125250, 0.117353, 2.896582>,
      < 1.128697, 0.120476, 2.916363>,
      < 1.157893, 0.124717, 2.911452>
    }
    triangle {
      < 1.125250, 0.117353, 2.896582>,
      < 1.157893, 0.124717, 2.911452>,
      < 1.155444, 0.122247, 2.895804>
    }
    triangle {
      < 1.738786, 0.110711, 2.921825>,
      < 1.742028, 0.106949, 2.898102>,
      < 1.708858, 0.116653, 2.896593>
    }
    triangle {
      < 1.738786, 0.110711, 2.921825>,
      < 1.708858, 0.116653, 2.896593>,
      < 1.705940, 0.119880, 2.916955>
    }
    triangle {
      < 1.729177, 0.114335, 2.944634>,
      < 1.738786, 0.110711, 2.921825>,
      < 1.705940, 0.119880, 2.916955>
    }
    triangle {
      < 1.729177, 0.114335, 2.944634>,
      < 1.705940, 0.119880, 2.916955>,
      < 1.697234, 0.123024, 2.936750>
    }
    triangle {
      < 1.713573, 0.117685, 2.965655>,
      < 1.729177, 0.114335, 2.944634>,
      < 1.697234, 0.123024, 2.936750>
    }
    triangle {
      < 1.713573, 0.117685, 2.965655>,
      < 1.697234, 0.123024, 2.936750>,
      < 1.682957, 0.125970, 2.955271>
    }
    triangle {
      < 1.692573, 0.120630, 2.984080>,
      < 1.713573, 0.117685, 2.965655>,
      < 1.682957, 0.125970, 2.955271>
    }
    triangle {
      < 1.692573, 0.120630, 2.984080>,
      < 1.682957, 0.125970, 2.955271>,
      < 1.663552, 0.128596, 2.971766>
    }
    triangle {
      < 1.666983, 0.123057, 2.999199>,
      < 1.692573, 0.120630, 2.984080>,
      < 1.663552, 0.128596, 2.971766>
    }
    triangle {
      < 1.666983, 0.123057, 2.999199>,
      < 1.663552, 0.128596, 2.971766>,
      < 1.639715, 0.130786, 2.985514>
    }
    triangle {
      < 1.637787, 0.124874, 3.010434>,
      < 1.666983, 0.123057, 2.999199>,
      < 1.639715, 0.130786, 2.985514>
    }
    triangle {
      < 1.637787, 0.124874, 3.010434>,
      < 1.639715, 0.130786, 2.985514>,
      < 1.612344, 0.132434, 2.995907>
    }
    triangle {
      < 1.606107, 0.126010, 3.017351>,
      < 1.637787, 0.124874, 3.010434>,
      < 1.612344, 0.132434, 2.995907>
    }
    triangle {
      < 1.606107, 0.126010, 3.017351>,
      < 1.612344, 0.132434, 2.995907>,
      < 1.582491, 0.133456, 3.002498>
    }
    triangle {
      < 1.573162, 0.126422, 3.019683>,
      < 1.606107, 0.126010, 3.017351>,
      < 1.582491, 0.133456, 3.002498>
    }
    triangle {
      < 1.573162, 0.126422, 3.019683>,
      < 1.582491, 0.133456, 3.002498>,
      < 1.551179, 0.133806, 3.004922>
    }
    triangle {
      < 1.281538, 0.126422, 3.017319>,
      < 1.573162, 0.126422, 3.019683>,
      < 1.551179, 0.133806, 3.004922>
    }
    triangle {
      < 1.281538, 0.126422, 3.017319>,
      < 1.551179, 0.133806, 3.004922>,
      < 1.279926, 0.133783, 3.002790>
    }
    triangle {
      < 1.238261, 0.125381, 3.010394>,
      < 1.281538, 0.126422, 3.017319>,
      < 1.279926, 0.133783, 3.002790>
    }
    triangle {
      < 1.238261, 0.125381, 3.010394>,
      < 1.279926, 0.133783, 3.002790>,
      < 1.243323, 0.132820, 2.996321>
    }
    triangle {
      < 1.198375, 0.123652, 2.999152>,
      < 1.238261, 0.125381, 3.010394>,
      < 1.243323, 0.132820, 2.996321>
    }
    triangle {
      < 1.198375, 0.123652, 2.999152>,
      < 1.243323, 0.132820, 2.996321>,
      < 1.209636, 0.131234, 2.985763>
    }
    triangle {
      < 1.163414, 0.121301, 2.984027>,
      < 1.198375, 0.123652, 2.999152>,
      < 1.209636, 0.131234, 2.985763>
    }
    triangle {
      < 1.163414, 0.121301, 2.984027>,
      < 1.209636, 0.131234, 2.985763>,
      < 1.180308, 0.129088, 2.971683>
    }
    triangle {
      < 1.134722, 0.118419, 2.965597>,
      < 1.163414, 0.121301, 2.984027>,
      < 1.180308, 0.129088, 2.971683>
    }
    triangle {
      < 1.134722, 0.118419, 2.965597>,
      < 1.180308, 0.129088, 2.971683>,
      < 1.156505, 0.126485, 2.954804>
    }
    triangle {
      < 1.113402, 0.115116, 2.944572>,
      < 1.134722, 0.118419, 2.965597>,
      < 1.156505, 0.126485, 2.954804>
    }
    triangle {
      < 1.113402, 0.115116, 2.944572>,
      < 1.156505, 0.126485, 2.954804>,
      < 1.139132, 0.123562, 2.936034>
    }
    triangle {
      < 1.100272, 0.111520, 2.921761>,
      < 1.113402, 0.115116, 2.944572>,
      < 1.139132, 0.123562, 2.936034>
    }
    triangle {
      < 1.100272, 0.111520, 2.921761>,
      < 1.139132, 0.123562, 2.936034>,
      < 1.128697, 0.120476, 2.916363>
    }
    triangle {
      < 1.095836, 0.107769, 2.898037>,
      < 1.100272, 0.111520, 2.921761>,
      < 1.128697, 0.120476, 2.916363>
    }
    triangle {
      < 1.095836, 0.107769, 2.898037>,
      < 1.128697, 0.120476, 2.916363>,
      < 1.125250, 0.117353, 2.896582>
    }
    triangle {
      < 1.186377, 0.114507, 2.845527>,
      < 1.186339, 0.084908, 2.850215>,
      < 1.155367, 0.085213, 2.850236>
    }
    triangle {
      < 1.186377, 0.114507, 2.845527>,
      < 1.155367, 0.085213, 2.850236>,
      < 1.125186, 0.090184, 2.849452>
    }
    triangle {
      < 1.186377, 0.114507, 2.845527>,
      < 1.125186, 0.090184, 2.849452>,
      < 1.095797, 0.099822, 2.847863>
    }
    triangle {
      < 1.186377, 0.114507, 2.845527>,
      < 1.095797, 0.099822, 2.847863>,
      < 1.125211, 0.109406, 2.846407>
    }
    triangle {
      < 1.186377, 0.114507, 2.845527>,
      < 1.125211, 0.109406, 2.846407>,
      < 1.155404, 0.114301, 2.845629>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.642763, 0.113728, 2.845629>,
      < 1.708855, 0.108712, 2.846417>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.708855, 0.108712, 2.846417>,
      < 1.742025, 0.099008, 2.847926>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.742025, 0.099008, 2.847926>,
      < 1.708831, 0.089396, 2.849476>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.708831, 0.089396, 2.849476>,
      < 1.705729, 0.063993, 2.853477>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.705729, 0.063993, 2.853477>,
      < 1.703224, 0.047471, 2.856094>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.703224, 0.047471, 2.856094>,
      < 1.698679, 0.030962, 2.858709>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.698679, 0.030962, 2.858709>,
      < 1.681587, 0.012436, 2.861645>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.681587, 0.012436, 2.861645>,
      < 1.653114, -0.001330, 2.863828>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.653114, -0.001330, 2.863828>,
      < 1.619429, -0.006272, 2.864615>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.619429, -0.006272, 2.864615>,
      < 1.585755, -0.001239, 2.863822>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.585755, -0.001239, 2.863822>,
      < 1.558018, 0.012603, 2.861632>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.558018, 0.012603, 2.861632>,
      < 1.538991, 0.031173, 2.858692>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.538991, 0.031173, 2.858692>,
      < 1.529281, 0.047695, 2.856076>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.529281, 0.047695, 2.856076>,
      < 1.524419, 0.064205, 2.853461>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.524419, 0.064205, 2.853461>,
      < 1.532777, 0.084427, 2.850253>
    }
    triangle {
      < 1.100272, 0.111520, 2.921761>,
      < 1.095836, 0.107769, 2.898037>,
      < 1.125226, 0.098131, 2.899626>
    }
    triangle {
      < 1.100272, 0.111520, 2.921761>,
      < 1.125226, 0.098131, 2.899626>,
      < 1.128672, 0.101264, 2.919406>
    }
    triangle {
      < 1.113402, 0.115116, 2.944572>,
      < 1.100272, 0.111520, 2.921761>,
      < 1.128672, 0.101264, 2.919406>
    }
    triangle {
      < 1.113402, 0.115116, 2.944572>,
      < 1.128672, 0.101264, 2.919406>,
      < 1.139108, 0.104381, 2.939072>
    }
    triangle {
      < 1.134722, 0.118419, 2.965597>,
      < 1.113402, 0.115116, 2.944572>,
      < 1.139108, 0.104381, 2.939072>
    }
    triangle {
      < 1.134722, 0.118419, 2.965597>,
      < 1.139108, 0.104381, 2.939072>,
      < 1.156481, 0.107358, 2.957833>
    }
    triangle {
      < 1.163414, 0.121301, 2.984027>,
      < 1.134722, 0.118419, 2.965597>,
      < 1.156481, 0.107358, 2.957833>
    }
    triangle {
      < 1.163414, 0.121301, 2.984027>,
      < 1.156481, 0.107358, 2.957833>,
      < 1.180284, 0.110038, 2.974700>
    }
    triangle {
      < 1.198375, 0.123652, 2.999152>,
      < 1.163414, 0.121301, 2.984027>,
      < 1.180284, 0.110038, 2.974700>
    }
    triangle {
      < 1.198375, 0.123652, 2.999152>,
      < 1.180284, 0.110038, 2.974700>,
      < 1.209612, 0.112275, 2.988766>
    }
    triangle {
      < 1.238261, 0.125381, 3.010394>,
      < 1.198375, 0.123652, 2.999152>,
      < 1.209612, 0.112275, 2.988766>
    }
    triangle {
      < 1.238261, 0.125381, 3.010394>,
      < 1.209612, 0.112275, 2.988766>,
      < 1.243299, 0.113944, 2.999311>
    }
    triangle {
      < 1.281538, 0.126422, 3.017319>,
      < 1.238261, 0.125381, 3.010394>,
      < 1.243299, 0.113944, 2.999311>
    }
    triangle {
      < 1.281538, 0.126422, 3.017319>,
      < 1.243299, 0.113944, 2.999311>,
      < 1.279902, 0.114936, 3.005774>
    }
    triangle {
      < 1.573162, 0.126422, 3.019683>,
      < 1.281538, 0.126422, 3.017319>,
      < 1.279902, 0.114936, 3.005774>
    }
    triangle {
      < 1.573162, 0.126422, 3.019683>,
      < 1.279902, 0.114936, 3.005774>,
      < 1.551154, 0.114893, 3.007917>
    }
    triangle {
      < 1.606107, 0.126010, 3.017351>,
      < 1.573162, 0.126422, 3.019683>,
      < 1.551154, 0.114893, 3.007917>
    }
    triangle {
      < 1.606107, 0.126010, 3.017351>,
      < 1.551154, 0.114893, 3.007917>,
      < 1.582466, 0.114398, 3.005516>
    }
    triangle {
      < 1.637787, 0.124874, 3.010434>,
      < 1.606107, 0.126010, 3.017351>,
      < 1.582466, 0.114398, 3.005516>
    }
    triangle {
      < 1.637787, 0.124874, 3.010434>,
      < 1.582466, 0.114398, 3.005516>,
      < 1.612318, 0.113259, 2.998944>
    }
    triangle {
      < 1.666983, 0.123057, 2.999199>,
      < 1.637787, 0.124874, 3.010434>,
      < 1.612318, 0.113259, 2.998944>
    }
    triangle {
      < 1.666983, 0.123057, 2.999199>,
      < 1.612318, 0.113259, 2.998944>,
      < 1.639689, 0.111546, 2.988561>
    }
    triangle {
      < 1.692573, 0.120630, 2.984080>,
      < 1.666983, 0.123057, 2.999199>,
      < 1.639689, 0.111546, 2.988561>
    }
    triangle {
      < 1.692573, 0.120630, 2.984080>,
      < 1.639689, 0.111546, 2.988561>,
      < 1.663527, 0.109321, 2.974819>
    }
    triangle {
      < 1.713573, 0.117685, 2.965655>,
      < 1.692573, 0.120630, 2.984080>,
      < 1.663527, 0.109321, 2.974819>
    }
    triangle {
      < 1.713573, 0.117685, 2.965655>,
      < 1.663527, 0.109321, 2.974819>,
      < 1.682931, 0.106673, 2.958327>
    }
    triangle {
      < 1.729177, 0.114335, 2.944634>,
      < 1.713573, 0.117685, 2.965655>,
      < 1.682931, 0.106673, 2.958327>
    }
    triangle {
      < 1.729177, 0.114335, 2.944634>,
      < 1.682931, 0.106673, 2.958327>,
      < 1.697208, 0.103716, 2.939808>
    }
    triangle {
      < 1.710687, 0.102039, 2.920277>,
      < 1.738786, 0.110711, 2.921825>,
      < 1.729177, 0.114335, 2.944634>
    }
    triangle {
      < 1.710687, 0.102039, 2.920277>,
      < 1.729177, 0.114335, 2.944634>,
      < 1.697208, 0.103716, 2.939808>
    }
    triangle {
      < 1.710687, 0.102039, 2.920277>,
      < 1.697208, 0.103716, 2.939808>,
      < 1.703923, 0.101287, 2.924543>
    }
    triangle {
      < 1.742028, 0.106949, 2.898102>,
      < 1.738786, 0.110711, 2.921825>,
      < 1.710687, 0.102039, 2.920277>
    }
    triangle {
      < 1.742028, 0.106949, 2.898102>,
      < 1.710687, 0.102039, 2.920277>,
      < 1.706616, 0.099792, 2.915124>
    }
    triangle {
      < 1.742028, 0.106949, 2.898102>,
      < 1.706616, 0.099792, 2.915124>,
      < 1.708834, 0.097337, 2.899652>
    }
    triangle {
      < 1.128672, 0.101264, 2.919406>,
      < 1.125226, 0.098131, 2.899626>,
      < 1.155406, 0.093160, 2.900410>
    }
    triangle {
      < 1.128672, 0.101264, 2.919406>,
      < 1.155406, 0.093160, 2.900410>,
      < 1.157856, 0.095640, 2.916057>
    }
    triangle {
      < 1.139108, 0.104381, 2.939072>,
      < 1.128672, 0.101264, 2.919406>,
      < 1.157856, 0.095640, 2.916057>
    }
    triangle {
      < 1.139108, 0.104381, 2.939072>,
      < 1.157856, 0.095640, 2.916057>,
      < 1.165568, 0.098223, 2.932328>
    }
    triangle {
      < 1.156481, 0.107358, 2.957833>,
      < 1.139108, 0.104381, 2.939072>,
      < 1.165568, 0.098223, 2.932328>
    }
    triangle {
      < 1.156481, 0.107358, 2.957833>,
      < 1.165568, 0.098223, 2.932328>,
      < 1.178945, 0.100807, 2.948578>
    }
    triangle {
      < 1.180284, 0.110038, 2.974700>,
      < 1.156481, 0.107358, 2.957833>,
      < 1.178945, 0.100807, 2.948578>
    }
    triangle {
      < 1.180284, 0.110038, 2.974700>,
      < 1.178945, 0.100807, 2.948578>,
      < 1.197785, 0.103207, 2.963634>
    }
    triangle {
      < 1.209612, 0.112275, 2.988766>,
      < 1.180284, 0.110038, 2.974700>,
      < 1.197785, 0.103207, 2.963634>
    }
    triangle {
      < 1.209612, 0.112275, 2.988766>,
      < 1.197785, 0.103207, 2.963634>,
      < 1.221374, 0.105247, 2.976411>
    }
    triangle {
      < 1.243299, 0.113944, 2.999311>,
      < 1.209612, 0.112275, 2.988766>,
      < 1.221374, 0.105247, 2.976411>
    }
    triangle {
      < 1.243299, 0.113944, 2.999311>,
      < 1.221374, 0.105247, 2.976411>,
      < 1.248714, 0.106785, 2.986079>
    }
    triangle {
      < 1.279902, 0.114936, 3.005774>,
      < 1.243299, 0.113944, 2.999311>,
      < 1.248714, 0.106785, 2.986079>
    }
    triangle {
      < 1.279902, 0.114936, 3.005774>,
      < 1.248714, 0.106785, 2.986079>,
      < 1.278421, 0.107700, 2.992000>
    }
    triangle {
      < 1.551154, 0.114893, 3.007917>,
      < 1.279902, 0.114936, 3.005774>,
      < 1.278421, 0.107700, 2.992000>
    }
    triangle {
      < 1.551154, 0.114893, 3.007917>,
      < 1.278421, 0.107700, 2.992000>,
      < 1.521497, 0.107672, 2.994010>
    }
    triangle {
      < 1.582466, 0.114398, 3.005516>,
      < 1.551154, 0.114893, 3.007917>,
      < 1.521497, 0.107672, 2.994010>
    }
    triangle {
      < 1.582466, 0.114398, 3.005516>,
      < 1.521497, 0.107672, 2.994010>,
      < 1.546168, 0.107216, 2.991798>
    }
    triangle {
      < 1.612318, 0.113259, 2.998944>,
      < 1.582466, 0.114398, 3.005516>,
      < 1.546168, 0.107216, 2.991798>
    }
    triangle {
      < 1.612318, 0.113259, 2.998944>,
      < 1.546168, 0.107216, 2.991798>,
      < 1.569407, 0.106185, 2.985857>
    }
    triangle {
      < 1.639689, 0.111546, 2.988561>,
      < 1.612318, 0.113259, 2.998944>,
      < 1.569407, 0.106185, 2.985857>
    }
    triangle {
      < 1.639689, 0.111546, 2.988561>,
      < 1.569407, 0.106185, 2.985857>,
      < 1.590590, 0.104650, 2.976548>
    }
    triangle {
      < 1.663527, 0.109321, 2.974819>,
      < 1.639689, 0.111546, 2.988561>,
      < 1.590590, 0.104650, 2.976548>
    }
    triangle {
      < 1.663527, 0.109321, 2.974819>,
      < 1.590590, 0.104650, 2.976548>,
      < 1.608876, 0.102677, 2.964356>
    }
    triangle {
      < 1.682931, 0.106673, 2.958327>,
      < 1.663527, 0.109321, 2.974819>,
      < 1.608876, 0.102677, 2.964356>
    }
    triangle {
      < 1.682931, 0.106673, 2.958327>,
      < 1.608876, 0.102677, 2.964356>,
      < 1.623577, 0.100364, 2.949934>
    }
    triangle {
      < 1.697208, 0.103716, 2.939808>,
      < 1.682931, 0.106673, 2.958327>,
      < 1.623577, 0.100364, 2.949934>
    }
    triangle {
      < 1.697208, 0.103716, 2.939808>,
      < 1.623577, 0.100364, 2.949934>,
      < 1.634225, 0.097826, 2.934031>
    }
    triangle {
      < 1.700921, 0.099682, 2.920027>,
      < 1.703923, 0.101287, 2.924543>,
      < 1.697208, 0.103716, 2.939808>
    }
    triangle {
      < 1.700921, 0.099682, 2.920027>,
      < 1.697208, 0.103716, 2.939808>,
      < 1.634225, 0.097826, 2.934031>
    }
    triangle {
      < 1.700921, 0.099682, 2.920027>,
      < 1.634225, 0.097826, 2.934031>,
      < 1.640612, 0.095173, 2.917354>
    }
    triangle {
      < 1.503474, 0.104443, 2.976199>,
      < 1.510743, 0.103629, 2.971175>,
      < 1.569407, 0.106185, 2.985857>
    }
    triangle {
      < 1.503474, 0.104443, 2.976199>,
      < 1.569407, 0.106185, 2.985857>,
      < 1.546168, 0.107216, 2.991798>
    }
    triangle {
      < 1.510743, 0.103629, 2.971175>,
      < 1.517322, 0.102343, 2.963162>,
      < 1.590590, 0.104650, 2.976548>
    }
    triangle {
      < 1.510743, 0.103629, 2.971175>,
      < 1.590590, 0.104650, 2.976548>,
      < 1.569407, 0.106185, 2.985857>
    }
    triangle {
      < 1.517322, 0.102343, 2.963162>,
      < 1.522920, 0.100671, 2.952693>,
      < 1.608876, 0.102677, 2.964356>
    }
    triangle {
      < 1.517322, 0.102343, 2.963162>,
      < 1.608876, 0.102677, 2.964356>,
      < 1.590590, 0.104650, 2.976548>
    }
    triangle {
      < 1.522920, 0.100671, 2.952693>,
      < 1.527320, 0.098725, 2.940478>,
      < 1.623577, 0.100364, 2.949934>
    }
    triangle {
      < 1.522920, 0.100671, 2.952693>,
      < 1.623577, 0.100364, 2.949934>,
      < 1.608876, 0.102677, 2.964356>
    }
    triangle {
      < 1.527320, 0.098725, 2.940478>,
      < 1.530409, 0.096631, 2.927305>,
      < 1.634225, 0.097826, 2.934031>
    }
    triangle {
      < 1.527320, 0.098725, 2.940478>,
      < 1.634225, 0.097826, 2.934031>,
      < 1.623577, 0.100364, 2.949934>
    }
    triangle {
      < 1.530409, 0.096631, 2.927305>,
      < 1.640612, 0.095173, 2.917354>,
      < 1.634225, 0.097826, 2.934031>
    }
    triangle {
      < 1.186378, 0.092854, 2.900390>,
      < 1.187822, 0.094645, 2.911713>,
      < 1.157856, 0.095640, 2.916057>
    }
    triangle {
      < 1.186378, 0.092854, 2.900390>,
      < 1.157856, 0.095640, 2.916057>,
      < 1.155406, 0.093160, 2.900410>
    }
    triangle {
      < 1.187822, 0.094645, 2.911713>,
      < 1.192780, 0.096639, 2.924340>,
      < 1.165568, 0.098223, 2.932328>
    }
    triangle {
      < 1.187822, 0.094645, 2.911713>,
      < 1.165568, 0.098223, 2.932328>,
      < 1.157856, 0.095640, 2.916057>
    }
    triangle {
      < 1.192780, 0.096639, 2.924340>,
      < 1.202113, 0.098764, 2.937833>,
      < 1.178945, 0.100807, 2.948578>
    }
    triangle {
      < 1.192780, 0.096639, 2.924340>,
      < 1.178945, 0.100807, 2.948578>,
      < 1.165568, 0.098223, 2.932328>
    }
    triangle {
      < 1.202113, 0.098764, 2.937833>,
      < 1.215919, 0.100805, 2.950832>,
      < 1.197785, 0.103207, 2.963634>
    }
    triangle {
      < 1.202113, 0.098764, 2.937833>,
      < 1.197785, 0.103207, 2.963634>,
      < 1.178945, 0.100807, 2.948578>
    }
    triangle {
      < 1.215919, 0.100805, 2.950832>,
      < 1.233662, 0.102565, 2.962086>,
      < 1.221374, 0.105247, 2.976411>
    }
    triangle {
      < 1.215919, 0.100805, 2.950832>,
      < 1.221374, 0.105247, 2.976411>,
      < 1.197785, 0.103207, 2.963634>
    }
    triangle {
      < 1.233662, 0.102565, 2.962086>,
      < 1.254506, 0.103902, 2.970698>,
      < 1.248714, 0.106785, 2.986079>
    }
    triangle {
      < 1.233662, 0.102565, 2.962086>,
      < 1.248714, 0.106785, 2.986079>,
      < 1.221374, 0.105247, 2.976411>
    }
    triangle {
      < 1.254506, 0.103902, 2.970698>,
      < 1.277096, 0.104712, 2.975997>,
      < 1.278421, 0.107700, 2.992000>
    }
    triangle {
      < 1.254506, 0.103902, 2.970698>,
      < 1.278421, 0.107700, 2.992000>,
      < 1.248714, 0.106785, 2.986079>
    }
    triangle {
      < 1.277096, 0.104712, 2.975997>,
      < 1.495597, 0.104743, 2.977964>,
      < 1.521497, 0.107672, 2.994010>
    }
    triangle {
      < 1.277096, 0.104712, 2.975997>,
      < 1.521497, 0.107672, 2.994010>,
      < 1.278421, 0.107700, 2.992000>
    }
    triangle {
      < 1.495597, 0.104743, 2.977964>,
      < 1.503474, 0.104443, 2.976199>,
      < 1.546168, 0.107216, 2.991798>
    }
    triangle {
      < 1.495597, 0.104743, 2.977964>,
      < 1.546168, 0.107216, 2.991798>,
      < 1.521497, 0.107672, 2.994010>
    }
    triangle {
      < 1.638018, 0.037181, 2.930121>,
      < 1.638026, 0.050092, 3.011639>,
      < 1.619922, 0.048339, 3.011919>
    }
    triangle {
      < 1.638018, 0.037181, 2.930121>,
      < 1.619922, 0.048339, 3.011919>,
      < 1.619913, 0.035428, 2.930400>
    }
    triangle {
      < 1.653370, 0.042218, 2.929321>,
      < 1.653378, 0.055129, 3.010840>,
      < 1.638026, 0.050092, 3.011639>
    }
    triangle {
      < 1.653370, 0.042218, 2.929321>,
      < 1.638026, 0.050092, 3.011639>,
      < 1.638018, 0.037181, 2.930121>
    }
    triangle {
      < 1.663633, 0.049773, 2.928124>,
      < 1.663642, 0.062684, 3.009642>,
      < 1.653378, 0.055129, 3.010840>
    }
    triangle {
      < 1.663633, 0.049773, 2.928124>,
      < 1.653378, 0.055129, 3.010840>,
      < 1.653370, 0.042218, 2.929321>
    }
    triangle {
      < 1.667247, 0.058696, 2.926711>,
      < 1.667255, 0.071607, 3.008229>,
      < 1.663642, 0.062684, 3.009642>
    }
    triangle {
      < 1.667247, 0.058696, 2.926711>,
      < 1.663642, 0.062684, 3.009642>,
      < 1.663633, 0.049773, 2.928124>
    }
    triangle {
      < 1.663657, 0.067628, 2.925296>,
      < 1.663664, 0.080539, 3.006815>,
      < 1.667255, 0.071607, 3.008229>
    }
    triangle {
      < 1.663657, 0.067628, 2.925296>,
      < 1.667255, 0.071607, 3.008229>,
      < 1.667247, 0.058696, 2.926711>
    }
    triangle {
      < 1.653412, 0.075209, 2.924097>,
      < 1.653421, 0.088120, 3.005615>,
      < 1.663664, 0.080539, 3.006815>
    }
    triangle {
      < 1.653412, 0.075209, 2.924097>,
      < 1.663664, 0.080539, 3.006815>,
      < 1.663657, 0.067628, 2.925296>
    }
    triangle {
      < 1.638074, 0.080285, 2.923294>,
      < 1.638081, 0.093196, 3.004812>,
      < 1.653421, 0.088120, 3.005615>
    }
    triangle {
      < 1.638074, 0.080285, 2.923294>,
      < 1.653421, 0.088120, 3.005615>,
      < 1.653412, 0.075209, 2.924097>
    }
    triangle {
      < 1.619973, 0.082084, 2.923011>,
      < 1.619981, 0.094995, 3.004530>,
      < 1.638081, 0.093196, 3.004812>
    }
    triangle {
      < 1.619973, 0.082084, 2.923011>,
      < 1.638081, 0.093196, 3.004812>,
      < 1.638074, 0.080285, 2.923294>
    }
    triangle {
      < 1.601870, 0.080331, 2.923290>,
      < 1.601878, 0.093242, 3.004809>,
      < 1.619981, 0.094995, 3.004530>
    }
    triangle {
      < 1.601870, 0.080331, 2.923290>,
      < 1.619981, 0.094995, 3.004530>,
      < 1.619973, 0.082084, 2.923011>
    }
    triangle {
      < 1.586518, 0.075294, 2.924090>,
      < 1.586526, 0.088205, 3.005609>,
      < 1.601878, 0.093242, 3.004809>
    }
    triangle {
      < 1.586518, 0.075294, 2.924090>,
      < 1.601878, 0.093242, 3.004809>,
      < 1.601870, 0.080331, 2.923290>
    }
    triangle {
      < 1.576254, 0.067739, 2.925287>,
      < 1.576262, 0.080650, 3.006806>,
      < 1.586526, 0.088205, 3.005609>
    }
    triangle {
      < 1.576254, 0.067739, 2.925287>,
      < 1.586526, 0.088205, 3.005609>,
      < 1.586518, 0.075294, 2.924090>
    }
    triangle {
      < 1.572642, 0.058816, 2.926701>,
      < 1.572650, 0.071727, 3.008220>,
      < 1.576262, 0.080650, 3.006806>
    }
    triangle {
      < 1.572642, 0.058816, 2.926701>,
      < 1.576262, 0.080650, 3.006806>,
      < 1.576254, 0.067739, 2.925287>
    }
    triangle {
      < 1.576231, 0.049884, 2.928116>,
      < 1.576239, 0.062795, 3.009634>,
      < 1.572650, 0.071727, 3.008220>
    }
    triangle {
      < 1.576231, 0.049884, 2.928116>,
      < 1.572650, 0.071727, 3.008220>,
      < 1.572642, 0.058816, 2.926701>
    }
    triangle {
      < 1.586475, 0.042303, 2.929315>,
      < 1.586483, 0.055214, 3.010834>,
      < 1.576239, 0.062795, 3.009634>
    }
    triangle {
      < 1.586475, 0.042303, 2.929315>,
      < 1.576239, 0.062795, 3.009634>,
      < 1.576231, 0.049884, 2.928116>
    }
    triangle {
      < 1.601814, 0.037227, 2.930118>,
      < 1.601822, 0.050138, 3.011636>,
      < 1.586483, 0.055214, 3.010834>
    }
    triangle {
      < 1.601814, 0.037227, 2.930118>,
      < 1.586483, 0.055214, 3.010834>,
      < 1.586475, 0.042303, 2.929315>
    }
    triangle {
      < 1.619913, 0.035428, 2.930400>,
      < 1.619922, 0.048339, 3.011919>,
      < 1.601822, 0.050138, 3.011636>
    }
    triangle {
      < 1.619913, 0.035428, 2.930400>,
      < 1.601822, 0.050138, 3.011636>,
      < 1.601814, 0.037227, 2.930118>
    }
    triangle {
      < 1.619951, 0.071667, 3.008224>,
      < 1.572650, 0.071727, 3.008220>,
      < 1.576239, 0.062795, 3.009634>
    }
    triangle {
      < 1.619951, 0.071667, 3.008224>,
      < 1.576239, 0.062795, 3.009634>,
      < 1.586483, 0.055214, 3.010834>
    }
    triangle {
      < 1.619951, 0.071667, 3.008224>,
      < 1.586483, 0.055214, 3.010834>,
      < 1.601822, 0.050138, 3.011636>
    }
    triangle {
      < 1.619951, 0.071667, 3.008224>,
      < 1.601822, 0.050138, 3.011636>,
      < 1.619922, 0.048339, 3.011919>
    }
    triangle {
      < 1.529626, 0.075296, 2.924094>,
      < 1.533916, 0.060832, 2.926386>,
      < 1.572642, 0.058816, 2.926701>
    }
    triangle {
      < 1.529626, 0.075296, 2.924094>,
      < 1.572642, 0.058816, 2.926701>,
      < 1.576254, 0.067739, 2.925287>
    }
    triangle {
      < 1.533916, 0.060832, 2.926386>,
      < 1.542985, 0.045402, 2.928829>,
      < 1.576231, 0.049884, 2.928116>
    }
    triangle {
      < 1.533916, 0.060832, 2.926386>,
      < 1.576231, 0.049884, 2.928116>,
      < 1.572642, 0.058816, 2.926701>
    }
    triangle {
      < 1.542985, 0.045402, 2.928829>,
      < 1.560979, 0.027840, 2.931609>,
      < 1.586475, 0.042303, 2.929315>
    }
    triangle {
      < 1.542985, 0.045402, 2.928829>,
      < 1.586475, 0.042303, 2.929315>,
      < 1.576231, 0.049884, 2.928116>
    }
    triangle {
      < 1.560979, 0.027840, 2.931609>,
      < 1.587300, 0.014705, 2.933686>,
      < 1.601814, 0.037227, 2.930118>
    }
    triangle {
      < 1.560979, 0.027840, 2.931609>,
      < 1.601814, 0.037227, 2.930118>,
      < 1.586475, 0.042303, 2.929315>
    }
    triangle {
      < 1.587300, 0.014705, 2.933686>,
      < 1.619512, 0.009845, 2.934453>,
      < 1.619913, 0.035428, 2.930400>
    }
    triangle {
      < 1.587300, 0.014705, 2.933686>,
      < 1.619913, 0.035428, 2.930400>,
      < 1.601814, 0.037227, 2.930118>
    }
    triangle {
      < 1.619512, 0.009845, 2.934453>,
      < 1.650724, 0.014184, 2.933762>,
      < 1.638018, 0.037181, 2.930121>
    }
    triangle {
      < 1.619512, 0.009845, 2.934453>,
      < 1.638018, 0.037181, 2.930121>,
      < 1.619913, 0.035428, 2.930400>
    }
    triangle {
      < 1.650724, 0.014184, 2.933762>,
      < 1.678538, 0.027637, 2.931628>,
      < 1.653370, 0.042218, 2.929321>
    }
    triangle {
      < 1.650724, 0.014184, 2.933762>,
      < 1.653370, 0.042218, 2.929321>,
      < 1.638018, 0.037181, 2.930121>
    }
    triangle {
      < 1.678538, 0.027637, 2.931628>,
      < 1.694175, 0.044587, 2.928943>,
      < 1.663633, 0.049773, 2.928124>
    }
    triangle {
      < 1.678538, 0.027637, 2.931628>,
      < 1.663633, 0.049773, 2.928124>,
      < 1.653370, 0.042218, 2.929321>
    }
    triangle {
      < 1.694175, 0.044587, 2.928943>,
      < 1.698328, 0.059668, 2.926553>,
      < 1.667247, 0.058696, 2.926711>
    }
    triangle {
      < 1.694175, 0.044587, 2.928943>,
      < 1.667247, 0.058696, 2.926711>,
      < 1.663633, 0.049773, 2.928124>
    }
    triangle {
      < 1.698328, 0.059668, 2.926553>,
      < 1.700536, 0.074240, 2.924246>,
      < 1.663657, 0.067628, 2.925296>
    }
    triangle {
      < 1.698328, 0.059668, 2.926553>,
      < 1.663657, 0.067628, 2.925296>,
      < 1.667247, 0.058696, 2.926711>
    }
    triangle {
      < 1.700536, 0.074240, 2.924246>,
      < 1.700760, 0.078871, 2.923512>,
      < 1.680764, 0.093743, 2.921158>
    }
    triangle {
      < 1.700536, 0.074240, 2.924246>,
      < 1.680764, 0.093743, 2.921158>,
      < 1.653412, 0.075209, 2.924097>
    }
    triangle {
      < 1.700536, 0.074240, 2.924246>,
      < 1.653412, 0.075209, 2.924097>,
      < 1.663657, 0.067628, 2.925296>
    }
    triangle {
      < 1.680764, 0.093743, 2.921158>,
      < 1.648183, 0.090016, 2.921748>,
      < 1.638074, 0.080285, 2.923294>
    }
    triangle {
      < 1.680764, 0.093743, 2.921158>,
      < 1.638074, 0.080285, 2.923294>,
      < 1.653412, 0.075209, 2.924097>
    }
    triangle {
      < 1.648183, 0.090016, 2.921748>,
      < 1.613693, 0.086068, 2.922376>,
      < 1.619973, 0.082084, 2.923011>
    }
    triangle {
      < 1.648183, 0.090016, 2.921748>,
      < 1.619973, 0.082084, 2.923011>,
      < 1.638074, 0.080285, 2.923294>
    }
    triangle {
      < 1.613693, 0.086068, 2.922376>,
      < 1.583470, 0.082608, 2.922928>,
      < 1.601870, 0.080331, 2.923290>
    }
    triangle {
      < 1.613693, 0.086068, 2.922376>,
      < 1.601870, 0.080331, 2.923290>,
      < 1.619973, 0.082084, 2.923011>
    }
    triangle {
      < 1.583470, 0.082608, 2.922928>,
      < 1.562716, 0.080230, 2.923307>,
      < 1.586518, 0.075294, 2.924090>
    }
    triangle {
      < 1.583470, 0.082608, 2.922928>,
      < 1.586518, 0.075294, 2.924090>,
      < 1.601870, 0.080331, 2.923290>
    }
    triangle {
      < 1.562716, 0.080230, 2.923307>,
      < 1.529626, 0.075296, 2.924094>,
      < 1.576254, 0.067739, 2.925287>
    }
    triangle {
      < 1.562716, 0.080230, 2.923307>,
      < 1.576254, 0.067739, 2.925287>,
      < 1.586518, 0.075294, 2.924090>
    }
    triangle {
      < 1.524422, 0.072146, 2.903637>,
      < 1.529284, 0.055636, 2.906252>,
      < 1.529285, 0.058092, 2.921758>
    }
    triangle {
      < 1.524422, 0.072146, 2.903637>,
      < 1.529285, 0.058092, 2.921758>,
      < 1.524423, 0.074602, 2.919142>
    }
    triangle {
      < 1.529284, 0.055636, 2.906252>,
      < 1.538994, 0.039114, 2.908868>,
      < 1.538995, 0.041570, 2.924374>
    }
    triangle {
      < 1.529284, 0.055636, 2.906252>,
      < 1.538995, 0.041570, 2.924374>,
      < 1.529285, 0.058092, 2.921758>
    }
    triangle {
      < 1.538994, 0.039114, 2.908868>,
      < 1.558021, 0.020544, 2.911808>,
      < 1.558023, 0.023000, 2.927313>
    }
    triangle {
      < 1.538994, 0.039114, 2.908868>,
      < 1.558023, 0.023000, 2.927313>,
      < 1.538995, 0.041570, 2.924374>
    }
    triangle {
      < 1.558021, 0.020544, 2.911808>,
      < 1.585758, 0.006702, 2.913997>,
      < 1.585760, 0.009158, 2.929503>
    }
    triangle {
      < 1.558021, 0.020544, 2.911808>,
      < 1.585760, 0.009158, 2.929503>,
      < 1.558023, 0.023000, 2.927313>
    }
    triangle {
      < 1.585758, 0.006702, 2.913997>,
      < 1.619432, 0.001670, 2.914790>,
      < 1.619434, 0.004125, 2.930296>
    }
    triangle {
      < 1.585758, 0.006702, 2.913997>,
      < 1.619434, 0.004125, 2.930296>,
      < 1.585760, 0.009158, 2.929503>
    }
    triangle {
      < 1.619432, 0.001670, 2.914790>,
      < 1.653117, 0.006611, 2.914004>,
      < 1.653118, 0.009067, 2.929510>
    }
    triangle {
      < 1.619432, 0.001670, 2.914790>,
      < 1.653118, 0.009067, 2.929510>,
      < 1.619434, 0.004125, 2.930296>
    }
    triangle {
      < 1.653117, 0.006611, 2.914004>,
      < 1.681590, 0.020377, 2.911820>,
      < 1.681591, 0.022833, 2.927326>
    }
    triangle {
      < 1.653117, 0.006611, 2.914004>,
      < 1.681591, 0.022833, 2.927326>,
      < 1.653118, 0.009067, 2.929510>
    }
    triangle {
      < 1.681590, 0.020377, 2.911820>,
      < 1.698681, 0.038903, 2.908885>,
      < 1.698683, 0.041359, 2.924391>
    }
    triangle {
      < 1.681590, 0.020377, 2.911820>,
      < 1.698683, 0.041359, 2.924391>,
      < 1.681591, 0.022833, 2.927326>
    }
    triangle {
      < 1.698681, 0.038903, 2.908885>,
      < 1.703227, 0.055412, 2.906270>,
      < 1.703229, 0.057868, 2.921776>
    }
    triangle {
      < 1.698681, 0.038903, 2.908885>,
      < 1.703229, 0.057868, 2.921776>,
      < 1.698683, 0.041359, 2.924391>
    }
    triangle {
      < 1.703227, 0.055412, 2.906270>,
      < 1.705732, 0.071934, 2.903653>,
      < 1.705733, 0.074390, 2.919159>
    }
    triangle {
      < 1.703227, 0.055412, 2.906270>,
      < 1.705733, 0.074390, 2.919159>,
      < 1.703229, 0.057868, 2.921776>
    }
    triangle {
      < 1.700921, 0.099682, 2.920027>,
      < 1.680764, 0.093743, 2.921158>,
      < 1.700760, 0.078871, 2.923512>
    }
    triangle {
      < 1.524423, 0.074602, 2.919142>,
      < 1.532200, 0.094495, 2.913850>,
      < 1.532780, 0.092368, 2.900428>
    }
    triangle {
      < 1.524423, 0.074602, 2.919142>,
      < 1.532780, 0.092368, 2.900428>,
      < 1.524422, 0.072146, 2.903637>
    }
    triangle {
      < 1.648183, 0.090016, 2.921748>,
      < 1.640612, 0.095173, 2.917354>,
      < 1.613693, 0.086068, 2.922376>
    }
    triangle {
      < 1.680764, 0.093743, 2.921158>,
      < 1.700921, 0.099682, 2.920027>,
      < 1.640612, 0.095173, 2.917354>
    }
    triangle {
      < 1.680764, 0.093743, 2.921158>,
      < 1.640612, 0.095173, 2.917354>,
      < 1.648183, 0.090016, 2.921748>
    }
    triangle {
      < 1.705732, 0.071934, 2.903653>,
      < 1.708834, 0.097337, 2.899652>,
      < 1.706616, 0.099792, 2.915124>
    }
    triangle {
      < 1.705732, 0.071934, 2.903653>,
      < 1.706616, 0.099792, 2.915124>,
      < 1.705733, 0.074390, 2.919159>
    }
    triangle {
      < 1.613693, 0.086068, 2.922376>,
      < 1.530409, 0.096631, 2.927305>,
      < 1.583470, 0.082608, 2.922928>
    }
    triangle {
      < 1.529626, 0.075296, 2.924094>,
      < 1.562716, 0.080230, 2.923307>,
      < 1.530409, 0.096631, 2.927305>
    }
    triangle {
      < 1.562716, 0.080230, 2.923307>,
      < 1.583470, 0.082608, 2.922928>,
      < 1.530409, 0.096631, 2.927305>
    }
    triangle {
      < 1.613693, 0.086068, 2.922376>,
      < 1.640612, 0.095173, 2.917354>,
      < 1.530409, 0.096631, 2.927305>
    }
    triangle {
      < 1.703923, 0.101287, 2.924543>,
      < 1.700921, 0.099682, 2.920027>,
      < 1.706616, 0.099792, 2.915124>
    }
    triangle {
      < 1.700536, 0.074240, 2.924246>,
      < 1.705733, 0.074390, 2.919159>,
      < 1.700760, 0.078871, 2.923512>
    }
    triangle {
      < 1.705733, 0.074390, 2.919159>,
      < 1.706616, 0.099792, 2.915124>,
      < 1.700921, 0.099682, 2.920027>
    }
    triangle {
      < 1.705733, 0.074390, 2.919159>,
      < 1.700921, 0.099682, 2.920027>,
      < 1.700760, 0.078871, 2.923512>
    }
    triangle {
      < 1.700536, 0.074240, 2.924246>,
      < 1.698328, 0.059668, 2.926553>,
      < 1.703229, 0.057868, 2.921776>
    }
    triangle {
      < 1.700536, 0.074240, 2.924246>,
      < 1.703229, 0.057868, 2.921776>,
      < 1.705733, 0.074390, 2.919159>
    }
    triangle {
      < 1.698328, 0.059668, 2.926553>,
      < 1.694175, 0.044587, 2.928943>,
      < 1.698683, 0.041359, 2.924391>
    }
    triangle {
      < 1.698328, 0.059668, 2.926553>,
      < 1.698683, 0.041359, 2.924391>,
      < 1.703229, 0.057868, 2.921776>
    }
    triangle {
      < 1.694175, 0.044587, 2.928943>,
      < 1.678538, 0.027637, 2.931628>,
      < 1.681591, 0.022833, 2.927326>
    }
    triangle {
      < 1.694175, 0.044587, 2.928943>,
      < 1.681591, 0.022833, 2.927326>,
      < 1.698683, 0.041359, 2.924391>
    }
    triangle {
      < 1.678538, 0.027637, 2.931628>,
      < 1.650724, 0.014184, 2.933762>,
      < 1.653118, 0.009067, 2.929510>
    }
    triangle {
      < 1.678538, 0.027637, 2.931628>,
      < 1.653118, 0.009067, 2.929510>,
      < 1.681591, 0.022833, 2.927326>
    }
    triangle {
      < 1.650724, 0.014184, 2.933762>,
      < 1.619512, 0.009845, 2.934453>,
      < 1.619434, 0.004125, 2.930296>
    }
    triangle {
      < 1.650724, 0.014184, 2.933762>,
      < 1.619434, 0.004125, 2.930296>,
      < 1.653118, 0.009067, 2.929510>
    }
    triangle {
      < 1.533916, 0.060832, 2.926386>,
      < 1.529626, 0.075296, 2.924094>,
      < 1.524423, 0.074602, 2.919142>
    }
    triangle {
      < 1.533916, 0.060832, 2.926386>,
      < 1.524423, 0.074602, 2.919142>,
      < 1.529285, 0.058092, 2.921758>
    }
    triangle {
      < 1.542985, 0.045402, 2.928829>,
      < 1.533916, 0.060832, 2.926386>,
      < 1.529285, 0.058092, 2.921758>
    }
    triangle {
      < 1.542985, 0.045402, 2.928829>,
      < 1.529285, 0.058092, 2.921758>,
      < 1.538995, 0.041570, 2.924374>
    }
    triangle {
      < 1.560979, 0.027840, 2.931609>,
      < 1.542985, 0.045402, 2.928829>,
      < 1.538995, 0.041570, 2.924374>
    }
    triangle {
      < 1.560979, 0.027840, 2.931609>,
      < 1.538995, 0.041570, 2.924374>,
      < 1.558023, 0.023000, 2.927313>
    }
    triangle {
      < 1.587300, 0.014705, 2.933686>,
      < 1.560979, 0.027840, 2.931609>,
      < 1.558023, 0.023000, 2.927313>
    }
    triangle {
      < 1.587300, 0.014705, 2.933686>,
      < 1.558023, 0.023000, 2.927313>,
      < 1.585760, 0.009158, 2.929503>
    }
    triangle {
      < 1.619512, 0.009845, 2.934453>,
      < 1.587300, 0.014705, 2.933686>,
      < 1.585760, 0.009158, 2.929503>
    }
    triangle {
      < 1.619512, 0.009845, 2.934453>,
      < 1.585760, 0.009158, 2.929503>,
      < 1.619434, 0.004125, 2.930296>
    }
    triangle {
      < 1.710687, 0.102039, 2.920277>,
      < 1.703923, 0.101287, 2.924543>,
      < 1.706616, 0.099792, 2.915124>
    }
    triangle {
      < 1.532200, 0.094495, 2.913850>,
      < 1.524423, 0.074602, 2.919142>,
      < 1.529626, 0.075296, 2.924094>
    }
    triangle {
      < 1.532200, 0.094495, 2.913850>,
      < 1.529626, 0.075296, 2.924094>,
      < 1.530409, 0.096631, 2.927305>
    }
    triangle {
      < 1.638026, 0.050092, 3.011639>,
      < 1.653378, 0.055129, 3.010840>,
      < 1.663642, 0.062684, 3.009642>
    }
    triangle {
      < 1.638026, 0.050092, 3.011639>,
      < 1.663642, 0.062684, 3.009642>,
      < 1.667255, 0.071607, 3.008229>
    }
    triangle {
      < 1.638026, 0.050092, 3.011639>,
      < 1.667255, 0.071607, 3.008229>,
      < 1.619951, 0.071667, 3.008224>
    }
    triangle {
      < 1.638026, 0.050092, 3.011639>,
      < 1.619951, 0.071667, 3.008224>,
      < 1.619922, 0.048339, 3.011919>
    }
    triangle {
      < 1.619981, 0.094995, 3.004530>,
      < 1.601878, 0.093242, 3.004809>,
      < 1.586526, 0.088205, 3.005609>
    }
    triangle {
      < 1.619981, 0.094995, 3.004530>,
      < 1.586526, 0.088205, 3.005609>,
      < 1.576262, 0.080650, 3.006806>
    }
    triangle {
      < 1.619981, 0.094995, 3.004530>,
      < 1.576262, 0.080650, 3.006806>,
      < 1.572650, 0.071727, 3.008220>
    }
    triangle {
      < 1.619981, 0.094995, 3.004530>,
      < 1.572650, 0.071727, 3.008220>,
      < 1.619951, 0.071667, 3.008224>
    }
    triangle {
      < 1.663664, 0.080539, 3.006815>,
      < 1.653421, 0.088120, 3.005615>,
      < 1.638081, 0.093196, 3.004812>
    }
    triangle {
      < 1.663664, 0.080539, 3.006815>,
      < 1.638081, 0.093196, 3.004812>,
      < 1.619981, 0.094995, 3.004530>
    }
    triangle {
      < 1.663664, 0.080539, 3.006815>,
      < 1.619981, 0.094995, 3.004530>,
      < 1.619951, 0.071667, 3.008224>
    }
    triangle {
      < 1.663664, 0.080539, 3.006815>,
      < 1.619951, 0.071667, 3.008224>,
      < 1.667255, 0.071607, 3.008229>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.532777, 0.084427, 2.850253>,
      < 1.532780, 0.092368, 2.900428>
    }
    triangle {
      < 1.569178, 0.114027, 2.845564>,
      < 1.532780, 0.092368, 2.900428>,
      < 1.569181, 0.121968, 2.895740>
    }
    triangle {
      < 1.532777, 0.084427, 2.850253>,
      < 1.524419, 0.064205, 2.853461>,
      < 1.524422, 0.072146, 2.903637>
    }
    triangle {
      < 1.532777, 0.084427, 2.850253>,
      < 1.524422, 0.072146, 2.903637>,
      < 1.532780, 0.092368, 2.900428>
    }
    triangle {
      < 1.524419, 0.064205, 2.853461>,
      < 1.529281, 0.047695, 2.856076>,
      < 1.529284, 0.055636, 2.906252>
    }
    triangle {
      < 1.524419, 0.064205, 2.853461>,
      < 1.529284, 0.055636, 2.906252>,
      < 1.524422, 0.072146, 2.903637>
    }
    triangle {
      < 1.529281, 0.047695, 2.856076>,
      < 1.538991, 0.031173, 2.858692>,
      < 1.538994, 0.039114, 2.908868>
    }
    triangle {
      < 1.529281, 0.047695, 2.856076>,
      < 1.538994, 0.039114, 2.908868>,
      < 1.529284, 0.055636, 2.906252>
    }
    triangle {
      < 1.538991, 0.031173, 2.858692>,
      < 1.558018, 0.012603, 2.861632>,
      < 1.558021, 0.020544, 2.911808>
    }
    triangle {
      < 1.538991, 0.031173, 2.858692>,
      < 1.558021, 0.020544, 2.911808>,
      < 1.538994, 0.039114, 2.908868>
    }
    triangle {
      < 1.558018, 0.012603, 2.861632>,
      < 1.585755, -0.001239, 2.863822>,
      < 1.585758, 0.006702, 2.913997>
    }
    triangle {
      < 1.558018, 0.012603, 2.861632>,
      < 1.585758, 0.006702, 2.913997>,
      < 1.558021, 0.020544, 2.911808>
    }
    triangle {
      < 1.585755, -0.001239, 2.863822>,
      < 1.619429, -0.006272, 2.864615>,
      < 1.619432, 0.001670, 2.914790>
    }
    triangle {
      < 1.585755, -0.001239, 2.863822>,
      < 1.619432, 0.001670, 2.914790>,
      < 1.585758, 0.006702, 2.913997>
    }
    triangle {
      < 1.619429, -0.006272, 2.864615>,
      < 1.653114, -0.001330, 2.863828>,
      < 1.653117, 0.006611, 2.914004>
    }
    triangle {
      < 1.619429, -0.006272, 2.864615>,
      < 1.653117, 0.006611, 2.914004>,
      < 1.619432, 0.001670, 2.914790>
    }
    triangle {
      < 1.653114, -0.001330, 2.863828>,
      < 1.681587, 0.012436, 2.861645>,
      < 1.681590, 0.020377, 2.911820>
    }
    triangle {
      < 1.653114, -0.001330, 2.863828>,
      < 1.681590, 0.020377, 2.911820>,
      < 1.653117, 0.006611, 2.914004>
    }
    triangle {
      < 1.681587, 0.012436, 2.861645>,
      < 1.698679, 0.030962, 2.858709>,
      < 1.698681, 0.038903, 2.908885>
    }
    triangle {
      < 1.681587, 0.012436, 2.861645>,
      < 1.698681, 0.038903, 2.908885>,
      < 1.681590, 0.020377, 2.911820>
    }
    triangle {
      < 1.698679, 0.030962, 2.858709>,
      < 1.703224, 0.047471, 2.856094>,
      < 1.703227, 0.055412, 2.906270>
    }
    triangle {
      < 1.698679, 0.030962, 2.858709>,
      < 1.703227, 0.055412, 2.906270>,
      < 1.698681, 0.038903, 2.908885>
    }
    triangle {
      < 1.703224, 0.047471, 2.856094>,
      < 1.705729, 0.063993, 2.853477>,
      < 1.705732, 0.071934, 2.903653>
    }
    triangle {
      < 1.703224, 0.047471, 2.856094>,
      < 1.705732, 0.071934, 2.903653>,
      < 1.703227, 0.055412, 2.906270>
    }
    triangle {
      < 1.705729, 0.063993, 2.853477>,
      < 1.708831, 0.089396, 2.849476>,
      < 1.708834, 0.097337, 2.899652>
    }
    triangle {
      < 1.705729, 0.063993, 2.853477>,
      < 1.708834, 0.097337, 2.899652>,
      < 1.705732, 0.071934, 2.903653>
    }
    triangle {
      < 1.708831, 0.089396, 2.849476>,
      < 1.742025, 0.099008, 2.847926>,
      < 1.742028, 0.106949, 2.898102>
    }
    triangle {
      < 1.708831, 0.089396, 2.849476>,
      < 1.742028, 0.106949, 2.898102>,
      < 1.708834, 0.097337, 2.899652>
    }
    triangle {
      < 1.742025, 0.099008, 2.847926>,
      < 1.708855, 0.108712, 2.846417>,
      < 1.708858, 0.116653, 2.896593>
    }
    triangle {
      < 1.742025, 0.099008, 2.847926>,
      < 1.708858, 0.116653, 2.896593>,
      < 1.742028, 0.106949, 2.898102>
    }
    triangle {
      < 1.708855, 0.108712, 2.846417>,
      < 1.642763, 0.113728, 2.845629>,
      < 1.642766, 0.121669, 2.895805>
    }
    triangle {
      < 1.708855, 0.108712, 2.846417>,
      < 1.642766, 0.121669, 2.895805>,
      < 1.708858, 0.116653, 2.896593>
    }
    triangle {
      < 1.642763, 0.113728, 2.845629>,
      < 1.569178, 0.114027, 2.845564>,
      < 1.569181, 0.121968, 2.895740>
    }
    triangle {
      < 1.642763, 0.113728, 2.845629>,
      < 1.569181, 0.121968, 2.895740>,
      < 1.642766, 0.121669, 2.895805>
    }
    triangle {
      < 1.186377, 0.114507, 2.845527>,
      < 1.155404, 0.114301, 2.845629>,
      < 1.155444, 0.122247, 2.895804>
    }
    triangle {
      < 1.186377, 0.114507, 2.845527>,
      < 1.155444, 0.122247, 2.895804>,
      < 1.186416, 0.122454, 2.895702>
    }
    triangle {
      < 1.155404, 0.114301, 2.845629>,
      < 1.125211, 0.109406, 2.846407>,
      < 1.125250, 0.117353, 2.896582>
    }
    triangle {
      < 1.155404, 0.114301, 2.845629>,
      < 1.125250, 0.117353, 2.896582>,
      < 1.155444, 0.122247, 2.895804>
    }
    triangle {
      < 1.125211, 0.109406, 2.846407>,
      < 1.095797, 0.099822, 2.847863>,
      < 1.095836, 0.107769, 2.898037>
    }
    triangle {
      < 1.125211, 0.109406, 2.846407>,
      < 1.095836, 0.107769, 2.898037>,
      < 1.125250, 0.117353, 2.896582>
    }
    triangle {
      < 1.095797, 0.099822, 2.847863>,
      < 1.125186, 0.090184, 2.849452>,
      < 1.125226, 0.098131, 2.899626>
    }
    triangle {
      < 1.095797, 0.099822, 2.847863>,
      < 1.125226, 0.098131, 2.899626>,
      < 1.095836, 0.107769, 2.898037>
    }
    triangle {
      < 1.125186, 0.090184, 2.849452>,
      < 1.155367, 0.085213, 2.850236>,
      < 1.155406, 0.093160, 2.900410>
    }
    triangle {
      < 1.125186, 0.090184, 2.849452>,
      < 1.155406, 0.093160, 2.900410>,
      < 1.125226, 0.098131, 2.899626>
    }
    triangle {
      < 1.155367, 0.085213, 2.850236>,
      < 1.186339, 0.084908, 2.850215>,
      < 1.186378, 0.092854, 2.900390>
    }
    triangle {
      < 1.155367, 0.085213, 2.850236>,
      < 1.186378, 0.092854, 2.900390>,
      < 1.155406, 0.093160, 2.900410>
    }
    triangle {
      < 1.186339, 0.084908, 2.850215>,
      < 1.186377, 0.114507, 2.845527>,
      < 1.186416, 0.122454, 2.895702>
    }
    triangle {
      < 1.186339, 0.084908, 2.850215>,
      < 1.186416, 0.122454, 2.895702>,
      < 1.186378, 0.092854, 2.900390>
    }
    texture {handles}
  }
  // hood
  union {
    triangle {
      < -2.933282, 0.535217, -1.302090>,
      < -3.059436, 0.525226, -1.386560>,
      < -3.070839, 0.530228, -1.348220>
    }
    triangle {
      < -3.069289, 0.550229, -1.300811>,
      < -3.072534, 0.545230, -1.254827>,
      < -2.933282, 0.535217, -1.302090>
    }
    triangle {
      < -6.102836, 0.405456, -1.150682>,
      < -6.103782, 0.405498, -1.131757>,
      < -6.034318, 0.438167, -1.163428>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.828452, -0.089431, -0.830134>,
      < -6.812109, -0.069434, -0.882889>,
      < -6.805052, -0.059433, -0.847532>
    }
    triangle {
      < -6.828452, -0.089431, -0.830134>,
      < -6.805052, -0.059433, -0.847532>,
      < -6.926939, -0.199401, 0.000000>
    }
    triangle {
      < -6.828452, -0.089431, -0.830134>,
      < -6.926939, -0.199401, 0.000000>,
      < -6.909551, -0.299402, 0.000000>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -6.716984, 0.205564, -0.654411>,
      < -6.632165, 0.140540, -1.306276>,
      < -6.697175, 0.035545, -1.306025>
    }
    triangle {
      < -6.716984, 0.205564, -0.654411>,
      < -6.697175, 0.035545, -1.306025>,
      < -6.772749, 0.100569, -0.650350>
    }
    triangle {
      < -5.960172, 0.518346, -1.291770>,
      < -5.960786, 0.490270, -1.196739>,
      < -5.567408, 0.500250, -1.184759>
    }
    triangle {
      < -5.960172, 0.518346, -1.291770>,
      < -5.567408, 0.500250, -1.184759>,
      < -5.555390, 0.530446, -1.279130>
    }
    triangle {
      < -6.716984, 0.205564, -0.654411>,
      < -6.766448, 0.240585, 0.000000>,
      < -6.674516, 0.315577, 0.000000>
    }
    triangle {
      < -6.716984, 0.205564, -0.654411>,
      < -6.674516, 0.315577, 0.000000>,
      < -6.604657, 0.295554, -0.651380>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.805052, -0.059433, -0.847532>,
      < -6.812109, -0.069434, -0.882889>,
      < -6.818110, -0.074432, -0.842097>
    }
    triangle {
      < -6.818110, -0.074432, -0.842097>,
      < -6.812109, -0.069434, -0.882889>,
      < -6.828452, -0.089431, -0.830134>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -6.773168, -0.484462, -1.856496>,
      < -6.852518, -0.439441, -1.283499>,
      < -6.809813, -0.364444, -1.282125>
    }
    triangle {
      < -6.773168, -0.484462, -1.856496>,
      < -6.809813, -0.364444, -1.282125>,
      < -6.723934, -0.419467, -1.857839>
    }
    triangle {
      < -5.960786, 0.490270, -1.196739>,
      < -5.958795, 0.463829, -1.152349>,
      < -5.586890, 0.475105, -1.113520>
    }
    triangle {
      < -5.960786, 0.490270, -1.196739>,
      < -5.586890, 0.475105, -1.113520>,
      < -5.567408, 0.500250, -1.184759>
    }
    texture {hood}
  }
  // trim
  union {
    triangle {
      < -6.547824, -0.292206, -2.932751>,
      < -6.550397, -0.323618, -2.914041>,
      < -6.743127, -0.292188, -2.902118>
    }
    texture {trim}
  }
  // hood
  union {
    triangle {
      < -3.483353, 0.560283, -0.610196>,
      < -3.504409, 0.565301, 0.000000>,
      < -2.945995, 0.575252, 0.000000>
    }
    triangle {
      < -3.483353, 0.560283, -0.610196>,
      < -2.945995, 0.575252, 0.000000>,
      < -2.931157, 0.575235, -0.607670>
    }
    triangle {
      < -6.164611, 0.415516, -0.643061>,
      < -6.248342, 0.420540, 0.000000>,
      < -5.715290, 0.475494, 0.000000>
    }
    triangle {
      < -6.164611, 0.415516, -0.643061>,
      < -5.715290, 0.475494, 0.000000>,
      < -5.628418, 0.470470, -0.632759>
    }
    triangle {
      < -6.809813, -0.364444, -1.282125>,
      < -6.732543, -0.074451, -1.298965>,
      < -6.668155, -0.139472, -1.861905>
    }
    triangle {
      < -6.809813, -0.364444, -1.282125>,
      < -6.668155, -0.139472, -1.861905>,
      < -6.723934, -0.419467, -1.857839>
    }
    triangle {
      < -6.632165, 0.140540, -1.306276>,
      < -6.539279, 0.243124, -1.292395>,
      < -6.460075, 0.150510, -1.868090>
    }
    triangle {
      < -6.632165, 0.140540, -1.306276>,
      < -6.460075, 0.150510, -1.868090>,
      < -6.533515, 0.065517, -1.860501>
    }
    triangle {
      < -6.697175, 0.035545, -1.306025>,
      < -6.623542, -0.034476, -1.865155>,
      < -6.668155, -0.139472, -1.861905>
    }
    triangle {
      < -6.697175, 0.035545, -1.306025>,
      < -6.668155, -0.139472, -1.861905>,
      < -6.732543, -0.074451, -1.298965>
    }
    triangle {
      < -5.960360, 0.490232, -1.387106>,
      < -5.960172, 0.518346, -1.291770>,
      < -5.555390, 0.530446, -1.279130>
    }
    triangle {
      < -5.960360, 0.490232, -1.387106>,
      < -5.555390, 0.530446, -1.279130>,
      < -5.557968, 0.500444, -1.379595>
    }
    triangle {
      < -4.639324, 0.415351, -1.867963>,
      < -4.687379, 0.460365, -1.490486>,
      < -3.439059, 0.510101, -1.410795>
    }
    triangle {
      < -4.639324, 0.415351, -1.867963>,
      < -3.439059, 0.510101, -1.410795>,
      < -3.357367, 0.464914, -1.876387>
    }
    texture {hood}
  }
  // bottom
  union {
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.073455, -1.859547, 0.000000>,
      < -7.096247, -1.824386, 0.000000>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -7.096247, -1.824386, 0.000000>,
      < -6.923715, -1.839447, -1.767040>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.923715, -1.839447, -1.767040>,
      < -6.862916, -1.839463, -2.163813>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.862916, -1.839463, -2.163813>,
      < -6.834743, -1.834470, -2.351647>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.834743, -1.834470, -2.351647>,
      < -6.752730, -1.839481, -2.511016>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.752730, -1.839481, -2.511016>,
      < -6.686976, -1.844489, -2.586358>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.686976, -1.844489, -2.586358>,
      < -6.602015, -1.839498, -2.650247>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.602015, -1.839498, -2.650247>,
      < -6.503947, -1.849508, -2.688095>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.503947, -1.849508, -2.688095>,
      < -6.370975, -1.859520, -2.723353>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -6.370975, -1.859520, -2.723353>,
      < -6.073455, -1.859547, -2.746403>
    }
    texture {bottom}
  }
  // black
  union {
    triangle {
      < -6.998756, 0.275547, -2.233527>,
      < -7.040396, 0.324326, -2.411743>,
      < -7.063996, 0.318964, -2.411743>
    }
    triangle {
      < -6.998756, 0.275547, -2.233527>,
      < -7.063996, 0.318964, -2.411743>,
      < -7.022356, 0.270845, -2.233527>
    }
    triangle {
      < -7.040396, 0.324326, -2.411743>,
      < -7.045109, 0.325588, -2.499018>,
      < -7.068709, 0.320061, -2.499018>
    }
    triangle {
      < -7.040396, 0.324326, -2.411743>,
      < -7.068709, 0.320061, -2.499018>,
      < -7.063996, 0.318964, -2.411743>
    }
    triangle {
      < -7.045109, 0.325588, -2.499018>,
      < -7.011448, 0.280537, -2.670665>,
      < -7.035048, 0.275753, -2.670665>
    }
    triangle {
      < -7.045109, 0.325588, -2.499018>,
      < -7.035048, 0.275753, -2.670665>,
      < -7.068709, 0.320061, -2.499018>
    }
    triangle {
      < -7.011448, 0.280537, -2.670665>,
      < -6.937014, 0.200527, -2.795497>,
      < -6.960614, 0.197063, -2.795497>
    }
    triangle {
      < -7.011448, 0.280537, -2.670665>,
      < -6.960614, 0.197063, -2.795497>,
      < -7.035048, 0.275753, -2.670665>
    }
    triangle {
      < -6.937014, 0.200527, -2.795497>,
      < -6.831750, 0.065516, -2.862890>,
      < -6.855350, 0.064279, -2.862890>
    }
    triangle {
      < -6.937014, 0.200527, -2.795497>,
      < -6.855350, 0.064279, -2.862890>,
      < -6.960614, 0.197063, -2.795497>
    }
    triangle {
      < -6.831750, 0.065516, -2.862890>,
      < -6.775799, -0.009489, -2.873777>,
      < -6.799399, -0.009489, -2.873777>
    }
    triangle {
      < -6.831750, 0.065516, -2.862890>,
      < -6.799399, -0.009489, -2.873777>,
      < -6.855350, 0.064279, -2.862890>
    }
    triangle {
      < -6.775799, -0.009489, -2.873777>,
      < -6.745515, -0.069491, -2.876542>,
      < -6.769115, -0.068501, -2.876542>
    }
    triangle {
      < -6.775799, -0.009489, -2.873777>,
      < -6.769115, -0.068501, -2.876542>,
      < -6.799399, -0.009489, -2.873777>
    }
    triangle {
      < -6.745515, -0.069491, -2.876542>,
      < -6.742029, -0.294491, -2.856221>,
      < -6.765629, -0.294491, -2.856221>
    }
    triangle {
      < -6.745515, -0.069491, -2.876542>,
      < -6.765629, -0.294491, -2.856221>,
      < -6.769115, -0.068501, -2.876542>
    }
    triangle {
      < -6.733982, -0.079470, -2.018336>,
      < -6.758536, -0.009468, -2.025174>,
      < -6.782136, -0.009468, -2.025174>
    }
    triangle {
      < -6.733982, -0.079470, -2.018336>,
      < -6.782136, -0.009468, -2.025174>,
      < -6.757581, -0.079470, -2.018336>
    }
    triangle {
      < -6.758536, -0.009468, -2.025174>,
      < -6.822981, 0.070537, -2.034971>,
      < -6.846581, 0.069217, -2.034971>
    }
    triangle {
      < -6.758536, -0.009468, -2.025174>,
      < -6.846581, 0.069217, -2.034971>,
      < -6.782136, -0.009468, -2.025174>
    }
    triangle {
      < -6.822981, 0.070537, -2.034971>,
      < -6.937092, 0.210545, -2.118648>,
      < -6.960692, 0.206915, -2.118648>
    }
    triangle {
      < -6.822981, 0.070537, -2.034971>,
      < -6.960692, 0.206915, -2.118648>,
      < -6.846581, 0.069217, -2.034971>
    }
    triangle {
      < -6.937092, 0.210545, -2.118648>,
      < -6.998756, 0.275547, -2.233527>,
      < -7.022356, 0.270845, -2.233527>
    }
    triangle {
      < -6.937092, 0.210545, -2.118648>,
      < -7.022356, 0.270845, -2.233527>,
      < -6.960692, 0.206915, -2.118648>
    }
    texture {black}
  }
  // hlight
  union {
    triangle {
      < -6.805049, 0.097988, -2.656756>,
      < -6.805604, -0.002191, -2.729949>,
      < -6.847389, -0.041836, -2.635788>
    }
    triangle {
      < -6.805049, 0.097988, -2.656756>,
      < -6.847389, -0.041836, -2.635788>,
      < -6.847019, 0.024951, -2.586992>
    }
    texture {hlight}
  }
  // net
  union {
    triangle {
      < -6.834251, -0.079229, -2.038333>,
      < -6.857495, -0.015160, -2.045397>,
      < -6.837502, -0.016683, -2.059246>
    }
    triangle {
      < -6.805801, -0.122246, -2.778569>,
      < -6.845248, -0.069362, -2.856545>,
      < -6.841718, -0.289349, -2.836606>
    }
    triangle {
      < -6.805801, -0.122246, -2.778569>,
      < -6.841718, -0.289349, -2.836606>,
      < -6.806168, -0.232484, -2.763064>
    }
    triangle {
      < -6.844799, 0.017019, -2.819852>,
      < -6.852876, 0.122928, -2.743728>,
      < -7.029285, 0.172025, -2.778870>
    }
    triangle {
      < -6.844799, 0.017019, -2.819852>,
      < -7.029285, 0.172025, -2.778870>,
      < -6.928379, 0.052304, -2.843365>
    }
    triangle {
      < -6.861089, 0.214310, -2.473609>,
      < -6.859937, 0.215047, -2.430470>,
      < -7.128163, 0.281420, -2.415889>
    }
    triangle {
      < -6.861089, 0.214310, -2.473609>,
      < -7.128163, 0.281420, -2.415889>,
      < -7.132436, 0.281541, -2.496710>
    }
    triangle {
      < -7.128163, 0.281420, -2.415889>,
      < -6.859937, 0.215047, -2.430470>,
      < -6.856724, 0.183102, -2.273175>
    }
    triangle {
      < -7.128163, 0.281420, -2.415889>,
      < -6.856724, 0.183102, -2.273175>,
      < -7.087681, 0.236878, -2.242903>
    }
    triangle {
      < -7.087681, 0.236878, -2.242903>,
      < -6.856724, 0.183102, -2.273175>,
      < -6.851715, 0.125842, -2.159429>
    }
    triangle {
      < -7.087681, 0.236878, -2.242903>,
      < -6.851715, 0.125842, -2.159429>,
      < -7.029095, 0.180308, -2.134510>
    }
    triangle {
      < -7.029095, 0.180308, -2.134510>,
      < -6.851715, 0.125842, -2.159429>,
      < -6.842713, 0.016693, -2.075266>
    }
    triangle {
      < -7.029095, 0.180308, -2.134510>,
      < -6.842713, 0.016693, -2.075266>,
      < -6.919741, 0.056316, -2.054514>
    }
    triangle {
      < -6.805801, -0.122246, -2.778569>,
      < -6.840583, -0.014346, -2.836553>,
      < -6.845248, -0.069362, -2.856545>
    }
    triangle {
      < -7.029285, 0.172025, -2.778870>,
      < -6.852876, 0.122928, -2.743728>,
      < -6.858394, 0.185584, -2.625300>
    }
    triangle {
      < -7.029285, 0.172025, -2.778870>,
      < -6.858394, 0.185584, -2.625300>,
      < -7.100271, 0.241778, -2.660793>
    }
    triangle {
      < -6.840583, -0.014346, -2.836553>,
      < -6.844799, 0.017019, -2.819852>,
      < -6.928379, 0.052304, -2.843365>
    }
    triangle {
      < -6.840583, -0.014346, -2.836553>,
      < -6.928379, 0.052304, -2.843365>,
      < -6.874547, -0.014609, -2.853755>
    }
    triangle {
      < -6.858394, 0.185584, -2.625300>,
      < -6.861089, 0.214310, -2.473609>,
      < -7.132436, 0.281541, -2.496710>
    }
    triangle {
      < -6.858394, 0.185584, -2.625300>,
      < -7.132436, 0.281541, -2.496710>,
      < -7.100271, 0.241778, -2.660793>
    }
    triangle {
      < -6.919741, 0.056316, -2.054514>,
      < -6.842713, 0.016693, -2.075266>,
      < -6.837502, -0.016683, -2.059246>
    }
    triangle {
      < -6.919741, 0.056316, -2.054514>,
      < -6.837502, -0.016683, -2.059246>,
      < -6.857495, -0.015160, -2.045397>
    }
    triangle {
      < -6.840583, -0.014346, -2.836553>,
      < -6.805801, -0.122246, -2.778569>,
      < -6.805894, 0.006324, -2.748495>
    }
    triangle {
      < -6.844799, 0.017019, -2.819852>,
      < -6.840583, -0.014346, -2.836553>,
      < -6.805894, 0.006324, -2.748495>
    }
    triangle {
      < -6.852876, 0.122928, -2.743728>,
      < -6.844799, 0.017019, -2.819852>,
      < -6.805894, 0.006324, -2.748495>
    }
    triangle {
      < -6.852876, 0.122928, -2.743728>,
      < -6.805894, 0.006324, -2.748495>,
      < -6.805265, 0.112938, -2.670601>
    }
    triangle {
      < -6.858394, 0.185584, -2.625300>,
      < -6.852876, 0.122928, -2.743728>,
      < -6.805265, 0.112938, -2.670601>
    }
    triangle {
      < -6.858394, 0.185584, -2.625300>,
      < -6.805265, 0.112938, -2.670601>,
      < -6.803450, 0.177033, -2.567100>
    }
    triangle {
      < -6.861089, 0.214310, -2.473609>,
      < -6.858394, 0.185584, -2.625300>,
      < -6.803450, 0.177033, -2.567100>
    }
    triangle {
      < -6.861089, 0.214310, -2.473609>,
      < -6.803450, 0.177033, -2.567100>,
      < -6.801351, 0.199405, -2.447439>
    }
    triangle {
      < -6.859937, 0.215047, -2.430470>,
      < -6.861089, 0.214310, -2.473609>,
      < -6.801351, 0.199405, -2.447439>
    }
    triangle {
      < -6.856724, 0.183102, -2.273175>,
      < -6.859937, 0.215047, -2.430470>,
      < -6.801351, 0.199405, -2.447439>
    }
    triangle {
      < -6.856724, 0.183102, -2.273175>,
      < -6.801351, 0.199405, -2.447439>,
      < -6.799222, 0.176365, -2.326069>
    }
    triangle {
      < -6.851715, 0.125842, -2.159429>,
      < -6.856724, 0.183102, -2.273175>,
      < -6.799222, 0.176365, -2.326069>
    }
    triangle {
      < -6.851715, 0.125842, -2.159429>,
      < -6.799222, 0.176365, -2.326069>,
      < -6.797389, 0.110451, -2.221580>
    }
    triangle {
      < -6.842713, 0.016693, -2.075266>,
      < -6.851715, 0.125842, -2.159429>,
      < -6.797389, 0.110451, -2.221580>
    }
    triangle {
      < -6.842713, 0.016693, -2.075266>,
      < -6.797389, 0.110451, -2.221580>,
      < -6.796768, 0.001062, -2.144023>
    }
    triangle {
      < -6.837502, -0.016683, -2.059246>,
      < -6.842713, 0.016693, -2.075266>,
      < -6.796768, 0.001062, -2.144023>
    }
    triangle {
      < -6.796898, -0.130108, -2.116174>,
      < -6.837502, -0.016683, -2.059246>,
      < -6.796768, 0.001062, -2.144023>
    }
    triangle {
      < -6.845248, -0.069362, -2.856545>,
      < -6.840583, -0.014346, -2.836553>,
      < -6.874547, -0.014609, -2.853755>
    }
    triangle {
      < -6.834251, -0.079229, -2.038333>,
      < -6.837502, -0.016683, -2.059246>,
      < -6.796898, -0.130108, -2.116174>
    }
    texture {net}
  }
  // hlight
  union {
    triangle {
      < -6.805604, -0.002191, -2.729949>,
      < -6.805484, -0.123162, -2.758246>,
      < -6.847309, -0.122483, -2.654652>
    }
    triangle {
      < -6.805604, -0.002191, -2.729949>,
      < -6.847309, -0.122483, -2.654652>,
      < -6.847389, -0.041836, -2.635788>
    }
    triangle {
      < -6.805484, -0.123162, -2.758246>,
      < -6.805866, -0.226324, -2.743735>,
      < -6.847563, -0.191258, -2.644979>
    }
    triangle {
      < -6.805484, -0.123162, -2.758246>,
      < -6.847563, -0.191258, -2.644979>,
      < -6.847309, -0.122483, -2.654652>
    }
    triangle {
      < -6.805866, -0.226324, -2.743735>,
      < -6.805741, -0.318576, -2.696020>,
      < -6.847480, -0.252759, -2.613168>
    }
    triangle {
      < -6.805866, -0.226324, -2.743735>,
      < -6.847480, -0.252759, -2.613168>,
      < -6.847563, -0.191258, -2.644979>
    }
    triangle {
      < -6.805741, -0.318576, -2.696020>,
      < -6.803799, -0.410023, -2.586029>,
      < -6.846185, -0.313724, -2.539841>
    }
    triangle {
      < -6.805741, -0.318576, -2.696020>,
      < -6.846185, -0.313724, -2.539841>,
      < -6.847480, -0.252759, -2.613168>
    }
    triangle {
      < -6.803799, -0.410023, -2.586029>,
      < -6.801350, -0.442659, -2.447400>,
      < -6.844553, -0.335481, -2.447422>
    }
    triangle {
      < -6.803799, -0.410023, -2.586029>,
      < -6.844553, -0.335481, -2.447422>,
      < -6.846185, -0.313724, -2.539841>
    }
    triangle {
      < -6.801350, -0.442659, -2.447400>,
      < -6.798938, -0.411085, -2.310958>,
      < -6.842945, -0.314432, -2.356460>
    }
    triangle {
      < -6.801350, -0.442659, -2.447400>,
      < -6.842945, -0.314432, -2.356460>,
      < -6.844553, -0.335481, -2.447422>
    }
    triangle {
      < -6.798938, -0.411085, -2.310958>,
      < -6.797009, -0.322354, -2.201725>,
      < -6.841659, -0.255278, -2.283638>
    }
    triangle {
      < -6.798938, -0.411085, -2.310958>,
      < -6.841659, -0.255278, -2.283638>,
      < -6.842945, -0.314432, -2.356460>
    }
    triangle {
      < -6.797009, -0.322354, -2.201725>,
      < -6.796867, -0.232077, -2.153030>,
      < -6.841564, -0.195093, -2.251175>
    }
    triangle {
      < -6.797009, -0.322354, -2.201725>,
      < -6.841564, -0.195093, -2.251175>,
      < -6.841659, -0.255278, -2.283638>
    }
    triangle {
      < -6.796867, -0.232077, -2.153030>,
      < -6.797215, -0.130596, -2.136513>,
      < -6.841796, -0.127439, -2.240164>
    }
    triangle {
      < -6.796867, -0.232077, -2.153030>,
      < -6.841796, -0.127439, -2.240164>,
      < -6.841564, -0.195093, -2.251175>
    }
    triangle {
      < -6.797215, -0.130596, -2.136513>,
      < -6.797060, -0.007134, -2.162727>,
      < -6.841693, -0.045131, -2.257639>
    }
    triangle {
      < -6.797215, -0.130596, -2.136513>,
      < -6.841693, -0.045131, -2.257639>,
      < -6.841796, -0.127439, -2.240164>
    }
    triangle {
      < -6.797060, -0.007134, -2.162727>,
      < -6.797607, 0.095650, -2.235601>,
      < -6.842058, 0.023391, -2.306222>
    }
    triangle {
      < -6.797060, -0.007134, -2.162727>,
      < -6.842058, 0.023391, -2.306222>,
      < -6.841693, -0.045131, -2.257639>
    }
    triangle {
      < -6.797607, 0.095650, -2.235601>,
      < -6.799339, 0.157424, -2.333527>,
      < -6.843212, 0.064574, -2.371506>
    }
    triangle {
      < -6.797607, 0.095650, -2.235601>,
      < -6.843212, 0.064574, -2.371506>,
      < -6.842058, 0.023391, -2.306222>
    }
    triangle {
      < -6.799339, 0.157424, -2.333527>,
      < -6.801351, 0.179053, -2.447468>,
      < -6.844553, 0.078994, -2.447467>
    }
    triangle {
      < -6.799339, 0.157424, -2.333527>,
      < -6.844553, 0.078994, -2.447467>,
      < -6.843212, 0.064574, -2.371506>
    }
    triangle {
      < -6.801351, 0.179053, -2.447468>,
      < -6.803336, 0.158060, -2.559751>,
      < -6.845876, 0.064999, -2.522322>
    }
    triangle {
      < -6.801351, 0.179053, -2.447468>,
      < -6.845876, 0.064999, -2.522322>,
      < -6.844553, 0.078994, -2.447467>
    }
    triangle {
      < -6.803336, 0.158060, -2.559751>,
      < -6.805049, 0.097988, -2.656756>,
      < -6.847019, 0.024951, -2.586992>
    }
    triangle {
      < -6.803336, 0.158060, -2.559751>,
      < -6.847019, 0.024951, -2.586992>,
      < -6.845876, 0.064999, -2.522322>
    }
    triangle {
      < -6.847563, -0.191258, -2.644979>,
      < -6.847480, -0.252759, -2.613168>,
      < -6.867616, -0.186942, -2.530316>
    }
    triangle {
      < -6.847563, -0.191258, -2.644979>,
      < -6.867616, -0.186942, -2.530316>,
      < -6.867658, -0.156192, -2.546221>
    }
    triangle {
      < -6.847309, -0.122483, -2.654652>,
      < -6.847563, -0.191258, -2.644979>,
      < -6.867658, -0.156192, -2.546221>
    }
    triangle {
      < -6.847309, -0.122483, -2.654652>,
      < -6.867658, -0.156192, -2.546221>,
      < -6.867530, -0.121804, -2.551058>
    }
    triangle {
      < -6.847389, -0.041836, -2.635788>,
      < -6.847309, -0.122483, -2.654652>,
      < -6.867530, -0.121804, -2.551058>
    }
    triangle {
      < -6.847389, -0.041836, -2.635788>,
      < -6.867530, -0.121804, -2.551058>,
      < -6.867570, -0.081481, -2.541626>
    }
    triangle {
      < -6.847019, 0.024951, -2.586992>,
      < -6.847389, -0.041836, -2.635788>,
      < -6.867570, -0.081481, -2.541626>
    }
    triangle {
      < -6.847019, 0.024951, -2.586992>,
      < -6.867570, -0.081481, -2.541626>,
      < -6.867385, -0.048088, -2.517228>
    }
    triangle {
      < -6.845876, 0.064999, -2.522322>,
      < -6.847019, 0.024951, -2.586992>,
      < -6.867385, -0.048088, -2.517228>
    }
    triangle {
      < -6.845876, 0.064999, -2.522322>,
      < -6.867385, -0.048088, -2.517228>,
      < -6.866814, -0.028064, -2.484894>
    }
    triangle {
      < -6.844553, 0.078994, -2.447467>,
      < -6.845876, 0.064999, -2.522322>,
      < -6.866814, -0.028064, -2.484894>
    }
    triangle {
      < -6.844553, 0.078994, -2.447467>,
      < -6.866814, -0.028064, -2.484894>,
      < -6.866152, -0.021066, -2.447466>
    }
    triangle {
      < -6.843212, 0.064574, -2.371506>,
      < -6.844553, 0.078994, -2.447467>,
      < -6.866152, -0.021066, -2.447466>
    }
    triangle {
      < -6.843212, 0.064574, -2.371506>,
      < -6.866152, -0.021066, -2.447466>,
      < -6.865482, -0.028276, -2.409486>
    }
    triangle {
      < -6.842058, 0.023391, -2.306222>,
      < -6.843212, 0.064574, -2.371506>,
      < -6.865482, -0.028276, -2.409486>
    }
    triangle {
      < -6.842058, 0.023391, -2.306222>,
      < -6.865482, -0.028276, -2.409486>,
      < -6.864904, -0.048867, -2.376843>
    }
    triangle {
      < -6.841693, -0.045131, -2.257639>,
      < -6.842058, 0.023391, -2.306222>,
      < -6.864904, -0.048867, -2.376843>
    }
    triangle {
      < -6.841693, -0.045131, -2.257639>,
      < -6.864904, -0.048867, -2.376843>,
      < -6.864722, -0.083128, -2.352552>
    }
    triangle {
      < -6.841796, -0.127439, -2.240164>,
      < -6.841693, -0.045131, -2.257639>,
      < -6.864722, -0.083128, -2.352552>
    }
    triangle {
      < -6.841796, -0.127439, -2.240164>,
      < -6.864722, -0.083128, -2.352552>,
      < -6.864774, -0.124282, -2.343814>
    }
    triangle {
      < -6.841564, -0.195093, -2.251175>,
      < -6.841796, -0.127439, -2.240164>,
      < -6.864774, -0.124282, -2.343814>
    }
    triangle {
      < -6.841564, -0.195093, -2.251175>,
      < -6.864774, -0.124282, -2.343814>,
      < -6.864658, -0.158109, -2.349320>
    }
    triangle {
      < -6.841659, -0.255278, -2.283638>,
      < -6.841564, -0.195093, -2.251175>,
      < -6.864658, -0.158109, -2.349320>
    }
    triangle {
      < -6.841659, -0.255278, -2.283638>,
      < -6.864658, -0.158109, -2.349320>,
      < -6.864705, -0.188201, -2.365551>
    }
    triangle {
      < -6.842945, -0.314432, -2.356460>,
      < -6.841659, -0.255278, -2.283638>,
      < -6.864705, -0.188201, -2.365551>
    }
    triangle {
      < -6.842945, -0.314432, -2.356460>,
      < -6.864705, -0.188201, -2.365551>,
      < -6.865348, -0.217778, -2.401963>
    }
    triangle {
      < -6.844553, -0.335481, -2.447422>,
      < -6.842945, -0.314432, -2.356460>,
      < -6.865348, -0.217778, -2.401963>
    }
    triangle {
      < -6.844553, -0.335481, -2.447422>,
      < -6.865348, -0.217778, -2.401963>,
      < -6.866151, -0.228303, -2.447443>
    }
    triangle {
      < -6.846185, -0.313724, -2.539841>,
      < -6.844553, -0.335481, -2.447422>,
      < -6.866151, -0.228303, -2.447443>
    }
    triangle {
      < -6.846185, -0.313724, -2.539841>,
      < -6.866151, -0.228303, -2.447443>,
      < -6.866968, -0.217424, -2.493653>
    }
    triangle {
      < -6.847480, -0.252759, -2.613168>,
      < -6.846185, -0.313724, -2.539841>,
      < -6.866968, -0.217424, -2.493653>
    }
    triangle {
      < -6.847480, -0.252759, -2.613168>,
      < -6.866968, -0.217424, -2.493653>,
      < -6.867616, -0.186942, -2.530316>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.866151, -0.228303, -2.447443>,
      < -6.865348, -0.217778, -2.401963>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.865348, -0.217778, -2.401963>,
      < -6.864705, -0.188201, -2.365551>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.864705, -0.188201, -2.365551>,
      < -6.864658, -0.158109, -2.349320>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.864658, -0.158109, -2.349320>,
      < -6.864774, -0.124282, -2.343814>
    }
    triangle {
      < -6.866152, -0.021066, -2.447466>,
      < -6.870951, -0.123043, -2.447436>,
      < -6.864774, -0.124282, -2.343814>
    }
    triangle {
      < -6.866152, -0.021066, -2.447466>,
      < -6.864774, -0.124282, -2.343814>,
      < -6.864722, -0.083128, -2.352552>
    }
    triangle {
      < -6.866152, -0.021066, -2.447466>,
      < -6.864722, -0.083128, -2.352552>,
      < -6.864904, -0.048867, -2.376843>
    }
    triangle {
      < -6.866152, -0.021066, -2.447466>,
      < -6.864904, -0.048867, -2.376843>,
      < -6.865482, -0.028276, -2.409486>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.866152, -0.021066, -2.447466>,
      < -6.866814, -0.028064, -2.484894>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.866814, -0.028064, -2.484894>,
      < -6.867385, -0.048088, -2.517228>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.867385, -0.048088, -2.517228>,
      < -6.867570, -0.081481, -2.541626>
    }
    triangle {
      < -6.870951, -0.123043, -2.447436>,
      < -6.867570, -0.081481, -2.541626>,
      < -6.867530, -0.121804, -2.551058>
    }
    triangle {
      < -6.866151, -0.228303, -2.447443>,
      < -6.870951, -0.123043, -2.447436>,
      < -6.867530, -0.121804, -2.551058>
    }
    triangle {
      < -6.866151, -0.228303, -2.447443>,
      < -6.867530, -0.121804, -2.551058>,
      < -6.867658, -0.156192, -2.546221>
    }
    triangle {
      < -6.866151, -0.228303, -2.447443>,
      < -6.867658, -0.156192, -2.546221>,
      < -6.867616, -0.186942, -2.530316>
    }
    triangle {
      < -6.866151, -0.228303, -2.447443>,
      < -6.867616, -0.186942, -2.530316>,
      < -6.866968, -0.217424, -2.493653>
    }
    texture {hlight}
  }
  // trim
  union {
    triangle {
      < -5.447221, -0.284804, -3.001511>,
      < -6.261021, -0.294883, -2.952750>,
      < -6.259114, -0.247901, -2.939256>
    }
    triangle {
      < -5.447221, -0.284804, -3.001511>,
      < -6.259114, -0.247901, -2.939256>,
      < -5.447547, -0.233197, -2.982637>
    }
    triangle {
      < -4.553186, -0.282382, -3.022923>,
      < -4.549205, -0.233019, -3.001480>,
      < -3.224575, -0.238647, -3.006465>
    }
    triangle {
      < -4.553186, -0.282382, -3.022923>,
      < -3.224575, -0.238647, -3.006465>,
      < -3.222914, -0.285354, -3.026460>
    }
    texture {trim}
  }
  // hood
  union {
    triangle {
      < -5.511751, 0.360427, -1.867509>,
      < -5.564794, 0.415442, -1.490401>,
      < -4.687379, 0.460365, -1.490486>
    }
    triangle {
      < -5.511751, 0.360427, -1.867509>,
      < -4.687379, 0.460365, -1.490486>,
      < -4.639324, 0.415351, -1.867963>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.494899, 0.001477, -2.905111>,
      < -6.439514, -0.028014, -2.909794>,
      < -6.449501, -0.171873, -2.917568>
    }
    triangle {
      < -6.494899, 0.001477, -2.905111>,
      < -6.449501, -0.171873, -2.917568>,
      < -6.509136, -0.203522, -2.916189>
    }
    triangle {
      < -6.112895, 0.007528, -2.911247>,
      < -6.056494, -0.022025, -2.916862>,
      < -6.061722, -0.166179, -2.929018>
    }
    triangle {
      < -6.112895, 0.007528, -2.911247>,
      < -6.061722, -0.166179, -2.929018>,
      < -6.120342, -0.197891, -2.928570>
    }
    triangle {
      < -6.316707, 0.000122, -2.906346>,
      < -6.260139, -0.029177, -2.911535>,
      < -6.269356, -0.172128, -2.921570>
    }
    triangle {
      < -6.316707, 0.000122, -2.906346>,
      < -6.269356, -0.172128, -2.921570>,
      < -6.327809, -0.203586, -2.920697>
    }
    triangle {
      < -6.060792, -0.167655, -2.911906>,
      < -6.119413, -0.199368, -2.911458>,
      < -6.120342, -0.197891, -2.928570>
    }
    triangle {
      < -6.060792, -0.167655, -2.911906>,
      < -6.120342, -0.197891, -2.928570>,
      < -6.061722, -0.166179, -2.929018>
    }
    triangle {
      < -6.119413, -0.199368, -2.911458>,
      < -6.111966, 0.006052, -2.894136>,
      < -6.112895, 0.007528, -2.911247>
    }
    triangle {
      < -6.119413, -0.199368, -2.911458>,
      < -6.112895, 0.007528, -2.911247>,
      < -6.120342, -0.197891, -2.928570>
    }
    triangle {
      < -6.111966, 0.006052, -2.894136>,
      < -6.055564, -0.023501, -2.899750>,
      < -6.056494, -0.022025, -2.916862>
    }
    triangle {
      < -6.111966, 0.006052, -2.894136>,
      < -6.056494, -0.022025, -2.916862>,
      < -6.112895, 0.007528, -2.911247>
    }
    triangle {
      < -6.055564, -0.023501, -2.899750>,
      < -6.060792, -0.167655, -2.911906>,
      < -6.061722, -0.166179, -2.929018>
    }
    triangle {
      < -6.055564, -0.023501, -2.899750>,
      < -6.061722, -0.166179, -2.929018>,
      < -6.056494, -0.022025, -2.916862>
    }
    triangle {
      < -6.268429, -0.173387, -2.904441>,
      < -6.326883, -0.204846, -2.903568>,
      < -6.327809, -0.203586, -2.920697>
    }
    triangle {
      < -6.268429, -0.173387, -2.904441>,
      < -6.327809, -0.203586, -2.920697>,
      < -6.269356, -0.172128, -2.921570>
    }
    triangle {
      < -6.326883, -0.204846, -2.903568>,
      < -6.315780, -0.001138, -2.889217>,
      < -6.316707, 0.000122, -2.906346>
    }
    triangle {
      < -6.326883, -0.204846, -2.903568>,
      < -6.316707, 0.000122, -2.906346>,
      < -6.327809, -0.203586, -2.920697>
    }
    triangle {
      < -6.315780, -0.001138, -2.889217>,
      < -6.259212, -0.030437, -2.894406>,
      < -6.260139, -0.029177, -2.911535>
    }
    triangle {
      < -6.315780, -0.001138, -2.889217>,
      < -6.260139, -0.029177, -2.911535>,
      < -6.316707, 0.000122, -2.906346>
    }
    triangle {
      < -6.259212, -0.030437, -2.894406>,
      < -6.268429, -0.173387, -2.904441>,
      < -6.269356, -0.172128, -2.921570>
    }
    triangle {
      < -6.259212, -0.030437, -2.894406>,
      < -6.269356, -0.172128, -2.921570>,
      < -6.260139, -0.029177, -2.911535>
    }
    triangle {
      < -6.448577, -0.172863, -2.900421>,
      < -6.508213, -0.204513, -2.899042>,
      < -6.509136, -0.203522, -2.916189>
    }
    triangle {
      < -6.448577, -0.172863, -2.900421>,
      < -6.509136, -0.203522, -2.916189>,
      < -6.449501, -0.171873, -2.917568>
    }
    triangle {
      < -6.508213, -0.204513, -2.899042>,
      < -6.493976, 0.000486, -2.887964>,
      < -6.494899, 0.001477, -2.905111>
    }
    triangle {
      < -6.508213, -0.204513, -2.899042>,
      < -6.494899, 0.001477, -2.905111>,
      < -6.509136, -0.203522, -2.916189>
    }
    triangle {
      < -6.493976, 0.000486, -2.887964>,
      < -6.438591, -0.029004, -2.892648>,
      < -6.439514, -0.028014, -2.909794>
    }
    triangle {
      < -6.493976, 0.000486, -2.887964>,
      < -6.439514, -0.028014, -2.909794>,
      < -6.494899, 0.001477, -2.905111>
    }
    triangle {
      < -6.438591, -0.029004, -2.892648>,
      < -6.448577, -0.172863, -2.900421>,
      < -6.449501, -0.171873, -2.917568>
    }
    triangle {
      < -6.438591, -0.029004, -2.892648>,
      < -6.449501, -0.171873, -2.917568>,
      < -6.439514, -0.028014, -2.909794>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -6.852518, -0.439441, -1.283499>,
      < -6.773168, -0.484462, -1.856496>,
      < -6.840075, -0.524456, -1.851624>
    }
    triangle {
      < -6.852518, -0.439441, -1.283499>,
      < -6.840075, -0.524456, -1.851624>,
      < -6.908277, -0.494436, -1.279438>
    }
    triangle {
      < -6.923189, -0.414418, -0.652841>,
      < -6.852518, -0.439441, -1.283499>,
      < -6.908277, -0.494436, -1.279438>
    }
    triangle {
      < -6.923189, -0.414418, -0.652841>,
      < -6.908277, -0.494436, -1.279438>,
      < -6.986286, -0.464412, -0.657214>
    }
    triangle {
      < -6.968031, -0.399397, 0.000000>,
      < -6.923189, -0.414418, -0.652841>,
      < -6.986286, -0.464412, -0.657214>
    }
    triangle {
      < -6.968031, -0.399397, 0.000000>,
      < -6.986286, -0.464412, -0.657214>,
      < -7.040373, -0.449391, 0.000000>
    }
    triangle {
      < -6.604657, 0.295554, -0.651380>,
      < -6.674516, 0.315577, 0.000000>,
      < -6.546418, 0.365566, 0.000000>
    }
    triangle {
      < -6.604657, 0.295554, -0.651380>,
      < -6.546418, 0.365566, 0.000000>,
      < -6.487709, 0.350544, -0.646443>
    }
    triangle {
      < -6.632165, 0.140540, -1.306276>,
      < -6.716984, 0.205564, -0.654411>,
      < -6.604657, 0.295554, -0.651380>
    }
    triangle {
      < -6.632165, 0.140540, -1.306276>,
      < -6.604657, 0.295554, -0.651380>,
      < -6.539279, 0.243124, -1.292395>
    }
    triangle {
      < -6.426589, 0.310700, -1.186610>,
      < -6.487709, 0.350544, -0.646443>,
      < -6.164611, 0.415516, -0.643061>
    }
    triangle {
      < -6.426589, 0.310700, -1.186610>,
      < -6.164611, 0.415516, -0.643061>,
      < -6.103782, 0.405498, -1.131757>
    }
    triangle {
      < -6.426589, 0.310700, -1.186610>,
      < -6.103782, 0.405498, -1.131757>,
      < -6.265186, 0.358099, -1.159183>
    }
    triangle {
      < -6.336598, 0.220499, -1.865870>,
      < -6.401817, 0.292686, -1.396527>,
      < -6.244581, 0.329087, -1.428405>
    }
    triangle {
      < -6.336598, 0.220499, -1.865870>,
      < -6.244581, 0.329087, -1.428405>,
      < -6.087345, 0.365488, -1.460283>
    }
    triangle {
      < -6.336598, 0.220499, -1.865870>,
      < -6.087345, 0.365488, -1.460283>,
      < -6.045046, 0.300474, -1.864676>
    }
    triangle {
      < -6.164611, 0.415516, -0.643061>,
      < -5.628418, 0.470470, -0.632759>,
      < -5.586890, 0.475105, -1.113520>
    }
    triangle {
      < -6.164611, 0.415516, -0.643061>,
      < -5.586890, 0.475105, -1.113520>,
      < -6.103782, 0.405498, -1.131757>
    }
    triangle {
      < -6.045046, 0.300474, -1.864676>,
      < -6.087345, 0.365488, -1.460283>,
      < -5.564794, 0.415442, -1.490401>
    }
    triangle {
      < -6.045046, 0.300474, -1.864676>,
      < -5.564794, 0.415442, -1.490401>,
      < -5.511751, 0.360427, -1.867509>
    }
    triangle {
      < -3.452590, 0.530266, -1.169640>,
      < -3.483353, 0.560283, -0.610196>,
      < -2.931157, 0.575235, -0.607670>
    }
    triangle {
      < -3.452590, 0.530266, -1.169640>,
      < -2.931157, 0.575235, -0.607670>,
      < -2.879675, 0.555217, -1.114004>
    }
    triangle {
      < -3.452590, 0.530266, -1.169640>,
      < -2.879675, 0.555217, -1.114004>,
      < -3.088729, 0.535233, -1.217913>
    }
    triangle {
      < -3.072534, 0.545230, -1.254827>,
      < -3.088729, 0.535233, -1.217913>,
      < -2.933282, 0.535217, -1.302090>
    }
    triangle {
      < -4.692935, 0.550371, -1.280324>,
      < -4.690363, 0.530373, -1.179857>,
      < -3.445069, 0.540264, -1.230001>
    }
    triangle {
      < -4.692935, 0.550371, -1.280324>,
      < -3.445069, 0.540264, -1.230001>,
      < -3.455293, 0.555263, -1.300857>
    }
    triangle {
      < -5.557968, 0.500444, -1.379595>,
      < -5.555390, 0.530446, -1.279130>,
      < -4.692935, 0.550371, -1.280324>
    }
    triangle {
      < -5.557968, 0.500444, -1.379595>,
      < -4.692935, 0.550371, -1.280324>,
      < -4.701466, 0.515369, -1.376299>
    }
    triangle {
      < -5.564794, 0.415442, -1.490401>,
      < -5.557968, 0.500444, -1.379595>,
      < -4.701466, 0.515369, -1.376299>
    }
    triangle {
      < -5.564794, 0.415442, -1.490401>,
      < -4.701466, 0.515369, -1.376299>,
      < -4.687379, 0.460365, -1.490486>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.818110, -0.074432, -0.842097>,
      < -6.828452, -0.089431, -0.830134>,
      < -6.909551, -0.299402, 0.000000>
    }
    triangle {
      < -6.818110, -0.074432, -0.842097>,
      < -6.909551, -0.299402, 0.000000>,
      < -6.981886, -0.254396, 0.000000>
    }
    triangle {
      < -6.805052, -0.059433, -0.847532>,
      < -6.818110, -0.074432, -0.842097>,
      < -6.981886, -0.254396, 0.000000>
    }
    triangle {
      < -6.805052, -0.059433, -0.847532>,
      < -6.981886, -0.254396, 0.000000>,
      < -6.926939, -0.199401, 0.000000>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -5.958795, 0.463829, -1.152349>,
      < -5.955692, 0.433614, -1.129197>,
      < -5.586890, 0.475105, -1.113520>
    }
    triangle {
      < -5.956346, 0.402280, -1.458986>,
      < -5.958843, 0.447611, -1.431477>,
      < -5.564794, 0.415442, -1.490401>
    }
    triangle {
      < -5.958843, 0.447611, -1.431477>,
      < -5.960360, 0.490232, -1.387106>,
      < -5.557968, 0.500444, -1.379595>
    }
    triangle {
      < -5.958843, 0.447611, -1.431477>,
      < -5.557968, 0.500444, -1.379595>,
      < -5.564794, 0.415442, -1.490401>
    }
    triangle {
      < -6.407199, 0.243124, -1.350899>,
      < -6.090918, 0.243125, -1.388875>,
      < -6.088412, 0.365459, -1.438961>
    }
    triangle {
      < -6.407199, 0.243124, -1.350899>,
      < -6.088412, 0.365459, -1.438961>,
      < -6.244581, 0.329087, -1.428405>
    }
    triangle {
      < -6.407199, 0.243124, -1.350899>,
      < -6.244581, 0.329087, -1.428405>,
      < -6.401817, 0.292686, -1.396527>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -6.421206, 0.243124, -1.232237>,
      < -6.426589, 0.310700, -1.186610>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -6.426589, 0.310700, -1.186610>,
      < -6.265186, 0.358099, -1.159183>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -6.265186, 0.358099, -1.159183>,
      < -6.102836, 0.405456, -1.150682>
    }
    triangle {
      < -6.421206, 0.243124, -1.232237>,
      < -6.100210, 0.243125, -1.203165>,
      < -6.090918, 0.243125, -1.388875>
    }
    triangle {
      < -6.421206, 0.243124, -1.232237>,
      < -6.090918, 0.243125, -1.388875>,
      < -6.407199, 0.243124, -1.350899>
    }
    triangle {
      < -5.956346, 0.402280, -1.458986>,
      < -6.023270, 0.409888, -1.437446>,
      < -5.987817, 0.451553, -1.412701>
    }
    triangle {
      < -5.956346, 0.402280, -1.458986>,
      < -5.987817, 0.451553, -1.412701>,
      < -5.958843, 0.447611, -1.431477>
    }
    triangle {
      < -5.958843, 0.447611, -1.431477>,
      < -5.987817, 0.451553, -1.412701>,
      < -5.980987, 0.490481, -1.377429>
    }
    triangle {
      < -5.958843, 0.447611, -1.431477>,
      < -5.980987, 0.490481, -1.377429>,
      < -5.960360, 0.490232, -1.387106>
    }
    triangle {
      < -5.960786, 0.490270, -1.196739>,
      < -5.980962, 0.490449, -1.215842>,
      < -5.993377, 0.466484, -1.184726>
    }
    triangle {
      < -5.960786, 0.490270, -1.196739>,
      < -5.993377, 0.466484, -1.184726>,
      < -5.958795, 0.463829, -1.152349>
    }
    triangle {
      < -5.958795, 0.463829, -1.152349>,
      < -5.993377, 0.466484, -1.184726>,
      < -6.034318, 0.438167, -1.163428>
    }
    triangle {
      < -5.958795, 0.463829, -1.152349>,
      < -6.034318, 0.438167, -1.163428>,
      < -5.955692, 0.433614, -1.129197>
    }
    triangle {
      < -5.960360, 0.490232, -1.387106>,
      < -5.980987, 0.490481, -1.377429>,
      < -5.981008, 0.517752, -1.291769>
    }
    triangle {
      < -5.960360, 0.490232, -1.387106>,
      < -5.981008, 0.517752, -1.291769>,
      < -5.960172, 0.518346, -1.291770>
    }
    triangle {
      < -5.960172, 0.518346, -1.291770>,
      < -5.981008, 0.517752, -1.291769>,
      < -5.980962, 0.490449, -1.215842>
    }
    triangle {
      < -5.960172, 0.518346, -1.291770>,
      < -5.980962, 0.490449, -1.215842>,
      < -5.960786, 0.490270, -1.196739>
    }
    triangle {
      < -5.956346, 0.402280, -1.458986>,
      < -6.087345, 0.365488, -1.460283>,
      < -6.023270, 0.409888, -1.437446>
    }
    triangle {
      < -6.102836, 0.405456, -1.150682>,
      < -6.265186, 0.358099, -1.159183>,
      < -6.103782, 0.405498, -1.131757>
    }
    triangle {
      < -6.244581, 0.329087, -1.428405>,
      < -6.088412, 0.365459, -1.438961>,
      < -6.087345, 0.365488, -1.460283>
    }
    triangle {
      < -6.102836, 0.405456, -1.150682>,
      < -6.034318, 0.438167, -1.163428>,
      < -6.100210, 0.243125, -1.203165>
    }
    triangle {
      < -6.088412, 0.365459, -1.438961>,
      < -6.023270, 0.409888, -1.437446>,
      < -6.087345, 0.365488, -1.460283>
    }
    triangle {
      < -6.090918, 0.243125, -1.388875>,
      < -6.023270, 0.409888, -1.437446>,
      < -6.088412, 0.365459, -1.438961>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -6.034318, 0.438167, -1.163428>,
      < -5.993377, 0.466484, -1.184726>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -5.993377, 0.466484, -1.184726>,
      < -5.980962, 0.490449, -1.215842>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -5.980962, 0.490449, -1.215842>,
      < -5.981008, 0.517752, -1.291769>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -5.981008, 0.517752, -1.291769>,
      < -5.980987, 0.490481, -1.377429>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -5.980987, 0.490481, -1.377429>,
      < -5.987817, 0.451553, -1.412701>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -5.987817, 0.451553, -1.412701>,
      < -6.023270, 0.409888, -1.437446>
    }
    triangle {
      < -6.100210, 0.243125, -1.203165>,
      < -6.023270, 0.409888, -1.437446>,
      < -6.090918, 0.243125, -1.388875>
    }
    triangle {
      < -6.103782, 0.405498, -1.131757>,
      < -5.955692, 0.433614, -1.129197>,
      < -6.034318, 0.438167, -1.163428>
    }
    triangle {
      < -5.564794, 0.415442, -1.490401>,
      < -6.087345, 0.365488, -1.460283>,
      < -5.956346, 0.402280, -1.458986>
    }
    triangle {
      < -5.955692, 0.433614, -1.129197>,
      < -6.103782, 0.405498, -1.131757>,
      < -5.586890, 0.475105, -1.113520>
    }
    texture {hood}
  }
  // bottom
  union {
    triangle {
      < -5.663052, -1.007231, -1.747609>,
      < -3.336812, -1.116545, -1.747609>,
      < -3.052612, -1.408860, -1.747609>
    }
    triangle {
      < -5.663052, -1.007231, -1.747609>,
      < -3.052612, -1.408860, -1.747609>,
      < -6.073455, -1.859547, -1.747609>
    }
    triangle {
      < -5.663052, -1.007231, -1.747609>,
      < -6.073455, -1.859547, -1.747609>,
      < -5.722831, -1.024584, -1.747609>
    }
    texture {bottom}
  }
  // trim
  union {
    triangle {
      < -2.016263, -0.282503, -3.023225>,
      < -3.222914, -0.285354, -3.026460>,
      < -3.224575, -0.238647, -3.006465>
    }
    triangle {
      < -2.016263, -0.282503, -3.023225>,
      < -3.224575, -0.238647, -3.006465>,
      < -2.007425, -0.232984, -2.999176>
    }
    triangle {
      < -4.549205, -0.233019, -3.001480>,
      < -4.553186, -0.282382, -3.022923>,
      < -5.447221, -0.284804, -3.001511>
    }
    triangle {
      < -4.549205, -0.233019, -3.001480>,
      < -5.447221, -0.284804, -3.001511>,
      < -5.447547, -0.233197, -2.982637>
    }
    triangle {
      < -6.543860, -0.259509, -2.891657>,
      < -6.257797, -0.244839, -2.907863>,
      < -6.259114, -0.247901, -2.939256>
    }
    triangle {
      < -6.543860, -0.259509, -2.891657>,
      < -6.259114, -0.247901, -2.939256>,
      < -6.545251, -0.260793, -2.922662>
    }
    triangle {
      < -6.257797, -0.244839, -2.907863>,
      < -5.446486, -0.229607, -2.950629>,
      < -5.447547, -0.233197, -2.982637>
    }
    triangle {
      < -6.257797, -0.244839, -2.907863>,
      < -5.447547, -0.233197, -2.982637>,
      < -6.259114, -0.247901, -2.939256>
    }
    triangle {
      < -5.446486, -0.229607, -2.950629>,
      < -4.547651, -0.229686, -2.969179>,
      < -4.549205, -0.233019, -3.001480>
    }
    triangle {
      < -5.446486, -0.229607, -2.950629>,
      < -4.549205, -0.233019, -3.001480>,
      < -5.447547, -0.233197, -2.982637>
    }
    triangle {
      < -4.547651, -0.229686, -2.969179>,
      < -3.223694, -0.234801, -2.974232>,
      < -3.224575, -0.238647, -3.006465>
    }
    triangle {
      < -4.547651, -0.229686, -2.969179>,
      < -3.224575, -0.238647, -3.006465>,
      < -4.549205, -0.233019, -3.001480>
    }
    triangle {
      < -3.223694, -0.234801, -2.974232>,
      < -2.005316, -0.229907, -2.966577>,
      < -2.007425, -0.232984, -2.999176>
    }
    triangle {
      < -3.223694, -0.234801, -2.974232>,
      < -2.007425, -0.232984, -2.999176>,
      < -3.224575, -0.238647, -3.006465>
    }
    triangle {
      < -2.025026, -0.339706, -2.988144>,
      < -3.219849, -0.342895, -2.987180>,
      < -3.221167, -0.334442, -3.017940>
    }
    triangle {
      < -2.025026, -0.339706, -2.988144>,
      < -3.221167, -0.334442, -3.017940>,
      < -2.025116, -0.332021, -3.018539>
    }
    triangle {
      < -3.219849, -0.342895, -2.987180>,
      < -4.556523, -0.339685, -2.984874>,
      < -4.557167, -0.331745, -3.015566>
    }
    triangle {
      < -3.219849, -0.342895, -2.987180>,
      < -4.557167, -0.331745, -3.015566>,
      < -3.221167, -0.334442, -3.017940>
    }
    triangle {
      < -4.556523, -0.339685, -2.984874>,
      < -5.445757, -0.344607, -2.960599>,
      < -5.446893, -0.336410, -2.991585>
    }
    triangle {
      < -4.556523, -0.339685, -2.984874>,
      < -5.446893, -0.336410, -2.991585>,
      < -4.557167, -0.331745, -3.015566>
    }
    triangle {
      < -5.445757, -0.344607, -2.960599>,
      < -6.262047, -0.349534, -2.905843>,
      < -6.262928, -0.341865, -2.937443>
    }
    triangle {
      < -5.445757, -0.344607, -2.960599>,
      < -6.262928, -0.341865, -2.937443>,
      < -5.446893, -0.336410, -2.991585>
    }
    triangle {
      < -6.262047, -0.349534, -2.905843>,
      < -6.549592, -0.329509, -2.882052>,
      < -6.550397, -0.323618, -2.914041>
    }
    triangle {
      < -6.262047, -0.349534, -2.905843>,
      < -6.550397, -0.323618, -2.914041>,
      < -6.262928, -0.341865, -2.937443>
    }
    triangle {
      < -6.549592, -0.329509, -2.882052>,
      < -6.742029, -0.294491, -2.856221>,
      < -6.743127, -0.292188, -2.902118>
    }
    triangle {
      < -6.549592, -0.329509, -2.882052>,
      < -6.743127, -0.292188, -2.902118>,
      < -6.550397, -0.323618, -2.914041>
    }
    triangle {
      < -6.742029, -0.294491, -2.856221>,
      < -6.543860, -0.259509, -2.891657>,
      < -6.545251, -0.260793, -2.922662>
    }
    triangle {
      < -6.742029, -0.294491, -2.856221>,
      < -6.545251, -0.260793, -2.922662>,
      < -6.743127, -0.292188, -2.902118>
    }
    triangle {
      < -6.550397, -0.323618, -2.914041>,
      < -6.547824, -0.292206, -2.932751>,
      < -6.261021, -0.294883, -2.952750>
    }
    triangle {
      < -6.550397, -0.323618, -2.914041>,
      < -6.261021, -0.294883, -2.952750>,
      < -6.262928, -0.341865, -2.937443>
    }
    triangle {
      < -3.222914, -0.285354, -3.026460>,
      < -2.016263, -0.282503, -3.023225>,
      < -2.025116, -0.332021, -3.018539>
    }
    triangle {
      < -3.222914, -0.285354, -3.026460>,
      < -2.025116, -0.332021, -3.018539>,
      < -3.221167, -0.334442, -3.017940>
    }
    triangle {
      < -4.553186, -0.282382, -3.022923>,
      < -3.222914, -0.285354, -3.026460>,
      < -3.221167, -0.334442, -3.017940>
    }
    triangle {
      < -4.553186, -0.282382, -3.022923>,
      < -3.221167, -0.334442, -3.017940>,
      < -4.557167, -0.331745, -3.015566>
    }
    triangle {
      < -5.447221, -0.284804, -3.001511>,
      < -4.553186, -0.282382, -3.022923>,
      < -4.557167, -0.331745, -3.015566>
    }
    triangle {
      < -5.447221, -0.284804, -3.001511>,
      < -4.557167, -0.331745, -3.015566>,
      < -5.446893, -0.336410, -2.991585>
    }
    triangle {
      < -6.261021, -0.294883, -2.952750>,
      < -5.447221, -0.284804, -3.001511>,
      < -5.446893, -0.336410, -2.991585>
    }
    triangle {
      < -6.261021, -0.294883, -2.952750>,
      < -5.446893, -0.336410, -2.991585>,
      < -6.262928, -0.341865, -2.937443>
    }
    triangle {
      < -6.547824, -0.292206, -2.932751>,
      < -6.743127, -0.292188, -2.902118>,
      < -6.545251, -0.260793, -2.922662>
    }
    triangle {
      < -6.261021, -0.294883, -2.952750>,
      < -6.547824, -0.292206, -2.932751>,
      < -6.545251, -0.260793, -2.922662>
    }
    triangle {
      < -6.261021, -0.294883, -2.952750>,
      < -6.545251, -0.260793, -2.922662>,
      < -6.259114, -0.247901, -2.939256>
    }
    texture {trim}
  }
  // hood
  union {
    triangle {
      < -4.687379, 0.460365, -1.490486>,
      < -4.701466, 0.515369, -1.376299>,
      < -3.439615, 0.535260, -1.353574>
    }
    triangle {
      < -4.687379, 0.460365, -1.490486>,
      < -3.439615, 0.535260, -1.353574>,
      < -3.439059, 0.510101, -1.410795>
    }
    triangle {
      < -3.439615, 0.535260, -1.353574>,
      < -3.455293, 0.555263, -1.300857>,
      < -3.069289, 0.550229, -1.300811>
    }
    triangle {
      < -3.439615, 0.535260, -1.353574>,
      < -3.069289, 0.550229, -1.300811>,
      < -2.933282, 0.535217, -1.302090>
    }
    triangle {
      < -3.439615, 0.535260, -1.353574>,
      < -2.933282, 0.535217, -1.302090>,
      < -3.070839, 0.530228, -1.348220>
    }
    triangle {
      < -4.690363, 0.530373, -1.179857>,
      < -4.692935, 0.550371, -1.280324>,
      < -5.555390, 0.530446, -1.279130>
    }
    triangle {
      < -4.690363, 0.530373, -1.179857>,
      < -5.555390, 0.530446, -1.279130>,
      < -5.567408, 0.500250, -1.184759>
    }
    triangle {
      < -3.452590, 0.530266, -1.169640>,
      < -3.445069, 0.540264, -1.230001>,
      < -4.690363, 0.530373, -1.179857>
    }
    triangle {
      < -3.452590, 0.530266, -1.169640>,
      < -4.690363, 0.530373, -1.179857>,
      < -4.700901, 0.500376, -1.105432>
    }
    triangle {
      < -4.700901, 0.500376, -1.105432>,
      < -4.690363, 0.530373, -1.179857>,
      < -5.567408, 0.500250, -1.184759>
    }
    triangle {
      < -4.700901, 0.500376, -1.105432>,
      < -5.567408, 0.500250, -1.184759>,
      < -5.586890, 0.475105, -1.113520>
    }
    triangle {
      < -3.088729, 0.535233, -1.217913>,
      < -3.072534, 0.545230, -1.254827>,
      < -3.445069, 0.540264, -1.230001>
    }
    triangle {
      < -3.088729, 0.535233, -1.217913>,
      < -3.445069, 0.540264, -1.230001>,
      < -3.452590, 0.530266, -1.169640>
    }
    triangle {
      < -4.756729, 0.520394, -0.623242>,
      < -4.700901, 0.500376, -1.105432>,
      < -5.586890, 0.475105, -1.113520>
    }
    triangle {
      < -4.756729, 0.520394, -0.623242>,
      < -5.586890, 0.475105, -1.113520>,
      < -5.628418, 0.470470, -0.632759>
    }
    triangle {
      < -2.933282, 0.535217, -1.302090>,
      < -2.879675, 0.555217, -1.114004>,
      < -2.807869, 0.525200, -1.530828>
    }
    triangle {
      < -2.879675, 0.555217, -1.114004>,
      < -2.933282, 0.535217, -1.302090>,
      < -3.088729, 0.535233, -1.217913>
    }
    triangle {
      < -3.483353, 0.560283, -0.610196>,
      < -3.452590, 0.530266, -1.169640>,
      < -4.700901, 0.500376, -1.105432>
    }
    triangle {
      < -3.483353, 0.560283, -0.610196>,
      < -4.700901, 0.500376, -1.105432>,
      < -4.756729, 0.520394, -0.623242>
    }
    triangle {
      < -2.703817, 0.490182, -1.880681>,
      < -3.059436, 0.525226, -1.386560>,
      < -2.933282, 0.535217, -1.302090>
    }
    triangle {
      < -2.703817, 0.490182, -1.880681>,
      < -2.933282, 0.535217, -1.302090>,
      < -2.807869, 0.525200, -1.530828>
    }
    triangle {
      < -6.623542, -0.034476, -1.865155>,
      < -6.697175, 0.035545, -1.306025>,
      < -6.632165, 0.140540, -1.306276>
    }
    triangle {
      < -6.623542, -0.034476, -1.865155>,
      < -6.632165, 0.140540, -1.306276>,
      < -6.533515, 0.065517, -1.860501>
    }
    triangle {
      < -4.822544, 0.530416, 0.000000>,
      < -4.756729, 0.520394, -0.623242>,
      < -5.628418, 0.470470, -0.632759>
    }
    triangle {
      < -4.822544, 0.530416, 0.000000>,
      < -5.628418, 0.470470, -0.632759>,
      < -5.715290, 0.475494, 0.000000>
    }
    triangle {
      < -3.504409, 0.565301, 0.000000>,
      < -3.483353, 0.560283, -0.610196>,
      < -4.756729, 0.520394, -0.623242>
    }
    triangle {
      < -3.504409, 0.565301, 0.000000>,
      < -4.756729, 0.520394, -0.623242>,
      < -4.822544, 0.530416, 0.000000>
    }
    triangle {
      < -6.909551, -0.299402, 0.000000>,
      < -6.871237, -0.324422, -0.647656>,
      < -6.923189, -0.414418, -0.652841>
    }
    triangle {
      < -6.909551, -0.299402, 0.000000>,
      < -6.923189, -0.414418, -0.652841>,
      < -6.968031, -0.399397, 0.000000>
    }
    triangle {
      < -6.831455, 0.140591, 0.000000>,
      < -6.772749, 0.100569, -0.650350>,
      < -6.806211, -0.004428, -0.647912>
    }
    triangle {
      < -6.831455, 0.140591, 0.000000>,
      < -6.806211, -0.004428, -0.647912>,
      < -6.867636, 0.025594, 0.000000>
    }
    triangle {
      < -6.867636, 0.025594, 0.000000>,
      < -6.806211, -0.004428, -0.647912>,
      < -6.871237, -0.324422, -0.647656>
    }
    triangle {
      < -6.867636, 0.025594, 0.000000>,
      < -6.871237, -0.324422, -0.647656>,
      < -6.909551, -0.299402, 0.000000>
    }
    triangle {
      < -6.806211, -0.004428, -0.647912>,
      < -6.732543, -0.074451, -1.298965>,
      < -6.809813, -0.364444, -1.282125>
    }
    triangle {
      < -6.806211, -0.004428, -0.647912>,
      < -6.809813, -0.364444, -1.282125>,
      < -6.871237, -0.324422, -0.647656>
    }
    triangle {
      < -6.871237, -0.324422, -0.647656>,
      < -6.809813, -0.364444, -1.282125>,
      < -6.852518, -0.439441, -1.283499>
    }
    triangle {
      < -6.871237, -0.324422, -0.647656>,
      < -6.852518, -0.439441, -1.283499>,
      < -6.923189, -0.414418, -0.652841>
    }
    triangle {
      < -6.772749, 0.100569, -0.650350>,
      < -6.697175, 0.035545, -1.306025>,
      < -6.732543, -0.074451, -1.298965>
    }
    triangle {
      < -6.772749, 0.100569, -0.650350>,
      < -6.732543, -0.074451, -1.298965>,
      < -6.806211, -0.004428, -0.647912>
    }
    triangle {
      < -6.766448, 0.240585, 0.000000>,
      < -6.716984, 0.205564, -0.654411>,
      < -6.772749, 0.100569, -0.650350>
    }
    triangle {
      < -6.766448, 0.240585, 0.000000>,
      < -6.772749, 0.100569, -0.650350>,
      < -6.831455, 0.140591, 0.000000>
    }
    triangle {
      < -6.248342, 0.420540, 0.000000>,
      < -6.164611, 0.415516, -0.643061>,
      < -6.487709, 0.350544, -0.646443>
    }
    triangle {
      < -6.248342, 0.420540, 0.000000>,
      < -6.487709, 0.350544, -0.646443>,
      < -6.546418, 0.365566, 0.000000>
    }
    triangle {
      < -4.701466, 0.515369, -1.376299>,
      < -4.692935, 0.550371, -1.280324>,
      < -3.455293, 0.555263, -1.300857>
    }
    triangle {
      < -4.701466, 0.515369, -1.376299>,
      < -3.455293, 0.555263, -1.300857>,
      < -3.439615, 0.535260, -1.353574>
    }
    triangle {
      < -3.455293, 0.555263, -1.300857>,
      < -3.445069, 0.540264, -1.230001>,
      < -3.072534, 0.545230, -1.254827>
    }
    triangle {
      < -3.455293, 0.555263, -1.300857>,
      < -3.072534, 0.545230, -1.254827>,
      < -3.069289, 0.550229, -1.300811>
    }
    triangle {
      < -3.439059, 0.510101, -1.410795>,
      < -3.439615, 0.535260, -1.353574>,
      < -3.070839, 0.530228, -1.348220>
    }
    triangle {
      < -3.439059, 0.510101, -1.410795>,
      < -3.070839, 0.530228, -1.348220>,
      < -3.059436, 0.525226, -1.386560>
    }
    triangle {
      < -3.357367, 0.464914, -1.876387>,
      < -3.439059, 0.510101, -1.410795>,
      < -3.059436, 0.525226, -1.386560>
    }
    triangle {
      < -3.357367, 0.464914, -1.876387>,
      < -3.059436, 0.525226, -1.386560>,
      < -2.703817, 0.490182, -1.880681>
    }
    texture {hood}
  }
  // bottom
  union {
    triangle {
      < -3.052612, -1.408860, -3.051297>,
      < -2.813603, -1.651789, -3.013454>,
      < -2.813603, -1.651789, -1.747609>
    }
    triangle {
      < -3.052612, -1.408860, -3.051297>,
      < -2.813603, -1.651789, -1.747609>,
      < -3.052612, -1.408860, -1.747609>
    }
    triangle {
      < -2.813603, -1.651789, -3.013454>,
      < -2.569514, -1.869857, -2.919900>,
      < -2.569514, -1.869857, -1.747609>
    }
    triangle {
      < -2.813603, -1.651789, -3.013454>,
      < -2.569514, -1.869857, -1.747609>,
      < -2.813603, -1.651789, -1.747609>
    }
    triangle {
      < -2.569514, -1.869857, -2.919900>,
      < -2.538924, -1.884860, -2.946151>,
      < -2.538924, -1.884860, -1.747609>
    }
    triangle {
      < -2.569514, -1.869857, -2.919900>,
      < -2.538924, -1.884860, -1.747609>,
      < -2.569514, -1.869857, -1.747609>
    }
    triangle {
      < -2.538924, -1.884860, -2.946151>,
      < -2.424010, -2.004869, -2.890315>,
      < -2.424010, -2.004869, -1.747609>
    }
    triangle {
      < -2.538924, -1.884860, -2.946151>,
      < -2.424010, -2.004869, -1.747609>,
      < -2.538924, -1.884860, -1.747609>
    }
    triangle {
      < -2.424010, -2.004869, -2.890315>,
      < -2.315905, -2.054878, -2.871945>,
      < -2.315905, -2.054878, -1.747609>
    }
    triangle {
      < -2.424010, -2.004869, -2.890315>,
      < -2.315905, -2.054878, -1.747609>,
      < -2.424010, -2.004869, -1.747609>
    }
    triangle {
      < -2.315905, -2.054878, -2.871945>,
      < -2.184192, -2.064889, -2.863208>,
      < -2.184192, -2.064889, -1.747609>
    }
    triangle {
      < -2.315905, -2.054878, -2.871945>,
      < -2.184192, -2.064889, -1.747609>,
      < -2.315905, -2.054878, -1.747609>
    }
    triangle {
      < -6.073455, -1.859547, -2.746403>,
      < -5.722831, -1.024584, -3.011215>,
      < -5.722831, -1.024584, -1.747609>
    }
    triangle {
      < -6.073455, -1.859547, -2.746403>,
      < -5.722831, -1.024584, -1.747609>,
      < -6.073455, -1.859547, -1.747609>
    }
    triangle {
      < -5.722831, -1.024584, -3.011215>,
      < -5.663052, -1.007231, -3.037668>,
      < -5.663052, -1.007231, -1.747609>
    }
    triangle {
      < -5.722831, -1.024584, -3.011215>,
      < -5.663052, -1.007231, -1.747609>,
      < -5.722831, -1.024584, -1.747609>
    }
    triangle {
      < -5.663052, -1.007231, -3.037668>,
      < -5.461406, -0.809276, -3.028569>,
      < -5.461406, -0.809276, -1.747609>
    }
    triangle {
      < -5.663052, -1.007231, -3.037668>,
      < -5.461406, -0.809276, -1.747609>,
      < -5.663052, -1.007231, -1.747609>
    }
    triangle {
      < -5.461406, -0.809276, -3.028569>,
      < -5.266409, -0.695346, -3.031584>,
      < -5.266409, -0.695346, -1.747609>
    }
    triangle {
      < -5.461406, -0.809276, -3.028569>,
      < -5.266409, -0.695346, -1.747609>,
      < -5.461406, -0.809276, -1.747609>
    }
    triangle {
      < -5.266409, -0.695346, -3.031584>,
      < -5.017154, -0.628374, -3.036136>,
      < -5.017154, -0.628374, -1.747609>
    }
    triangle {
      < -5.266409, -0.695346, -3.031584>,
      < -5.017154, -0.628374, -1.747609>,
      < -5.266409, -0.695346, -1.747609>
    }
    triangle {
      < -5.017154, -0.628374, -3.036136>,
      < -4.509265, -0.613634, -3.047463>,
      < -4.509265, -0.613634, -1.747609>
    }
    triangle {
      < -5.017154, -0.628374, -3.036136>,
      < -4.509265, -0.613634, -1.747609>,
      < -5.017154, -0.628374, -1.747609>
    }
    triangle {
      < -4.509265, -0.613634, -3.047463>,
      < -4.111175, -0.662607, -3.057256>,
      < -4.111175, -0.662607, -1.747609>
    }
    triangle {
      < -4.509265, -0.613634, -3.047463>,
      < -4.111175, -0.662607, -1.747609>,
      < -4.509265, -0.613634, -1.747609>
    }
    triangle {
      < -4.111175, -0.662607, -3.057256>,
      < -3.856030, -0.749120, -3.057916>,
      < -3.856030, -0.749120, -1.747609>
    }
    triangle {
      < -4.111175, -0.662607, -3.057256>,
      < -3.856030, -0.749120, -1.747609>,
      < -4.111175, -0.662607, -1.747609>
    }
    triangle {
      < -3.856030, -0.749120, -3.057916>,
      < -3.604055, -0.909909, -3.052055>,
      < -3.604055, -0.909909, -1.747609>
    }
    triangle {
      < -3.856030, -0.749120, -3.057916>,
      < -3.604055, -0.909909, -1.747609>,
      < -3.856030, -0.749120, -1.747609>
    }
    triangle {
      < -3.604055, -0.909909, -3.052055>,
      < -3.336812, -1.116545, -3.058673>,
      < -3.336812, -1.116545, -1.747609>
    }
    triangle {
      < -3.604055, -0.909909, -3.052055>,
      < -3.336812, -1.116545, -1.747609>,
      < -3.604055, -0.909909, -1.747609>
    }
    triangle {
      < -3.336812, -1.116545, -3.058673>,
      < -3.052612, -1.408860, -3.051297>,
      < -3.052612, -1.408860, -1.747609>
    }
    triangle {
      < -3.336812, -1.116545, -3.058673>,
      < -3.052612, -1.408860, -1.747609>,
      < -3.336812, -1.116545, -1.747609>
    }
    triangle {
      < -2.184192, -2.064889, -1.747609>,
      < -2.184192, -2.064889, 0.000000>,
      < -6.073455, -1.859547, 0.000000>
    }
    triangle {
      < -2.184192, -2.064889, -1.747609>,
      < -6.073455, -1.859547, 0.000000>,
      < -6.073455, -1.859547, -1.747609>
    }
    triangle {
      < -3.336812, -1.116545, -1.747609>,
      < -5.663052, -1.007231, -1.747609>,
      < -5.461406, -0.809276, -1.747609>
    }
    triangle {
      < -3.336812, -1.116545, -1.747609>,
      < -5.461406, -0.809276, -1.747609>,
      < -5.266409, -0.695346, -1.747609>
    }
    triangle {
      < -3.336812, -1.116545, -1.747609>,
      < -5.266409, -0.695346, -1.747609>,
      < -3.856030, -0.749120, -1.747609>
    }
    triangle {
      < -3.336812, -1.116545, -1.747609>,
      < -3.856030, -0.749120, -1.747609>,
      < -3.604055, -0.909909, -1.747609>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -3.052612, -1.408860, -1.747609>,
      < -2.813603, -1.651789, -1.747609>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -2.813603, -1.651789, -1.747609>,
      < -2.569514, -1.869857, -1.747609>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -2.569514, -1.869857, -1.747609>,
      < -2.424010, -2.004869, -1.747609>
    }
    triangle {
      < -2.424010, -2.004869, -1.747609>,
      < -2.569514, -1.869857, -1.747609>,
      < -2.538924, -1.884860, -1.747609>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -2.424010, -2.004869, -1.747609>,
      < -2.315905, -2.054878, -1.747609>
    }
    triangle {
      < -6.073455, -1.859547, -1.747609>,
      < -2.315905, -2.054878, -1.747609>,
      < -2.184192, -2.064889, -1.747609>
    }
    triangle {
      < -3.856030, -0.749120, -1.747609>,
      < -5.266409, -0.695346, -1.747609>,
      < -5.017154, -0.628374, -1.747609>
    }
    triangle {
      < -3.856030, -0.749120, -1.747609>,
      < -5.017154, -0.628374, -1.747609>,
      < -4.509265, -0.613634, -1.747609>
    }
    triangle {
      < -3.856030, -0.749120, -1.747609>,
      < -4.509265, -0.613634, -1.747609>,
      < -4.111175, -0.662607, -1.747609>
    }
    texture {bottom}
  }
  // fseat
  union {
    triangle {
      < -0.350672, -1.368000, -2.150854>,
      < -0.462992, -0.765600, -2.150854>,
      < -0.441985, -0.677600, -2.164841>
    }
    triangle {
      < -0.350672, -1.368000, -2.150854>,
      < -0.441985, -0.677600, -2.164841>,
      < -0.300640, -1.381333, -2.164841>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < -0.225137, -1.382295, -2.183490>,
      < -0.096081, -1.384488, -2.188152>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < -0.096081, -1.384488, -2.188152>,
      < 0.114115, -1.388035, -2.183490>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < 0.114115, -1.388035, -2.183490>,
      < 0.475977, -1.394139, -2.164841>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < 0.475977, -1.394139, -2.164841>,
      < 1.125798, -1.405102, -2.150854>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < 1.125798, -1.405102, -2.150854>,
      < 1.297600, -1.408000, -2.150854>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < 1.297600, -1.408000, -2.150854>,
      < 1.289825, -1.408841, -2.080531>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < 1.289825, -1.408841, -2.080531>,
      < -0.404046, -1.368000, -2.080531>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < -0.404046, -1.368000, -2.080531>,
      < -0.350672, -1.368000, -2.150854>
    }
    triangle {
      < 1.297600, -1.408000, -2.150854>,
      < 1.625600, 0.144000, -2.150854>,
      < 1.624716, 0.175770, -2.080531>
    }
    triangle {
      < 1.297600, -1.408000, -2.150854>,
      < 1.624716, 0.175770, -2.080531>,
      < 1.289825, -1.408841, -2.080531>
    }
    triangle {
      < 1.625600, 0.144000, -2.150854>,
      < 1.667625, 0.384000, -2.150854>,
      < 1.667625, 0.420813, -2.080531>
    }
    triangle {
      < 1.625600, 0.144000, -2.150854>,
      < 1.667625, 0.420813, -2.080531>,
      < 1.624716, 0.175770, -2.080531>
    }
    triangle {
      < 1.667625, 0.384000, -2.150854>,
      < 1.621617, 0.480000, -2.150854>,
      < 1.620650, 0.518830, -2.080531>
    }
    triangle {
      < 1.667625, 0.384000, -2.150854>,
      < 1.620650, 0.518830, -2.080531>,
      < 1.667625, 0.420813, -2.080531>
    }
    triangle {
      < 1.621617, 0.480000, -2.150854>,
      < 1.541617, 0.520000, -2.150854>,
      < 1.538969, 0.559671, -2.080531>
    }
    triangle {
      < 1.621617, 0.480000, -2.150854>,
      < 1.538969, 0.559671, -2.080531>,
      < 1.620650, 0.518830, -2.080531>
    }
    triangle {
      < 1.541617, 0.520000, -2.150854>,
      < 1.449600, 0.520000, -2.150854>,
      < 1.445019, 0.559671, -2.080531>
    }
    triangle {
      < 1.541617, 0.520000, -2.150854>,
      < 1.445019, 0.559671, -2.080531>,
      < 1.538969, 0.559671, -2.080531>
    }
    triangle {
      < 1.449600, 0.520000, -2.150854>,
      < 1.393600, 0.480000, -2.150854>,
      < 1.387842, 0.518830, -2.080531>
    }
    triangle {
      < 1.449600, 0.520000, -2.150854>,
      < 1.387842, 0.518830, -2.080531>,
      < 1.445019, 0.559671, -2.080531>
    }
    triangle {
      < 1.393600, 0.480000, -2.150854>,
      < 1.300000, 0.392000, -2.150854>,
      < 1.292275, 0.428981, -2.080531>
    }
    triangle {
      < 1.393600, 0.480000, -2.150854>,
      < 1.292275, 0.428981, -2.080531>,
      < 1.387842, 0.518830, -2.080531>
    }
    triangle {
      < 1.300000, 0.392000, -2.150854>,
      < 1.162333, 0.101888, -2.150854>,
      < 1.151716, 0.132773, -2.080531>
    }
    triangle {
      < 1.300000, 0.392000, -2.150854>,
      < 1.151716, 0.132773, -2.080531>,
      < 1.292275, 0.428981, -2.080531>
    }
    triangle {
      < 1.162333, 0.101888, -2.150854>,
      < 1.026333, -0.346112, -2.150854>,
      < 1.012858, -0.324640, -2.080531>
    }
    triangle {
      < 1.162333, 0.101888, -2.150854>,
      < 1.012858, -0.324640, -2.080531>,
      < 1.151716, 0.132773, -2.080531>
    }
    triangle {
      < 1.026333, -0.346112, -2.150854>,
      < 0.940857, -0.740617, -2.150854>,
      < 0.925586, -0.727435, -2.080531>
    }
    triangle {
      < 1.026333, -0.346112, -2.150854>,
      < 0.925586, -0.727435, -2.080531>,
      < 1.012858, -0.324640, -2.080531>
    }
    triangle {
      < 0.940857, -0.740617, -2.150854>,
      < 0.973411, -0.861091, -2.150854>,
      < 0.958824, -0.828386, -2.080531>
    }
    triangle {
      < 0.940857, -0.740617, -2.150854>,
      < 0.958824, -0.828386, -2.080531>,
      < 0.925586, -0.727435, -2.080531>
    }
    triangle {
      < 0.973411, -0.861091, -2.150854>,
      < 0.303423, -0.685600, -2.164841>,
      < 0.274758, -0.649208, -2.080531>
    }
    triangle {
      < 0.973411, -0.861091, -2.150854>,
      < 0.274758, -0.649208, -2.080531>,
      < 0.958824, -0.828386, -2.080531>
    }
    triangle {
      < 0.303423, -0.685600, -2.164841>,
      < -0.079495, -0.624800, -2.183490>,
      < -0.115968, -0.587130, -2.080531>
    }
    triangle {
      < 0.303423, -0.685600, -2.164841>,
      < -0.115968, -0.587130, -2.080531>,
      < 0.274758, -0.649208, -2.080531>
    }
    triangle {
      < -0.079495, -0.624800, -2.183490>,
      < -0.263595, -0.621600, -2.188152>,
      < -0.328597, -0.583863, -2.080531>
    }
    triangle {
      < -0.079495, -0.624800, -2.183490>,
      < -0.328597, -0.583863, -2.080531>,
      < -0.115968, -0.587130, -2.080531>
    }
    triangle {
      < -0.263595, -0.621600, -2.188152>,
      < -0.375915, -0.637600, -2.183490>,
      < -0.445200, -0.600199, -2.080531>
    }
    triangle {
      < -0.263595, -0.621600, -2.188152>,
      < -0.445200, -0.600199, -2.080531>,
      < -0.328597, -0.583863, -2.080531>
    }
    triangle {
      < -0.375915, -0.637600, -2.183490>,
      < -0.441985, -0.677600, -2.164841>,
      < -0.513791, -0.641040, -2.080531>
    }
    triangle {
      < -0.375915, -0.637600, -2.183490>,
      < -0.513791, -0.641040, -2.080531>,
      < -0.445200, -0.600199, -2.080531>
    }
    triangle {
      < -0.441985, -0.677600, -2.164841>,
      < -0.462992, -0.765600, -2.150854>,
      < -0.520650, -0.730889, -2.080531>
    }
    triangle {
      < -0.441985, -0.677600, -2.164841>,
      < -0.520650, -0.730889, -2.080531>,
      < -0.513791, -0.641040, -2.080531>
    }
    triangle {
      < -0.462992, -0.765600, -2.150854>,
      < -0.350672, -1.368000, -2.150854>,
      < -0.404046, -1.368000, -2.080531>
    }
    triangle {
      < -0.462992, -0.765600, -2.150854>,
      < -0.404046, -1.368000, -2.080531>,
      < -0.520650, -0.730889, -2.080531>
    }
    triangle {
      < -0.445200, -0.600199, -2.080531>,
      < -0.513791, -0.641040, -2.080531>,
      < -0.563893, -0.628845, -1.908415>
    }
    triangle {
      < -0.445200, -0.600199, -2.080531>,
      < -0.563893, -0.628845, -1.908415>,
      < -0.493276, -0.587320, -1.908415>
    }
    triangle {
      < -0.513791, -0.641040, -2.080531>,
      < -0.520650, -0.730889, -2.080531>,
      < -0.570954, -0.720201, -1.908415>
    }
    triangle {
      < -0.513791, -0.641040, -2.080531>,
      < -0.570954, -0.720201, -1.908415>,
      < -0.563893, -0.628845, -1.908415>
    }
    triangle {
      < -0.520650, -0.730889, -2.080531>,
      < -0.404046, -1.368000, -2.080531>,
      < -0.450907, -1.368000, -1.908415>
    }
    triangle {
      < -0.520650, -0.730889, -2.080531>,
      < -0.450907, -1.368000, -1.908415>,
      < -0.570954, -0.720201, -1.908415>
    }
    triangle {
      < -0.404046, -1.368000, -2.080531>,
      < 1.289825, -1.408841, -2.080531>,
      < 1.284590, -1.409526, -1.908415>
    }
    triangle {
      < -0.404046, -1.368000, -2.080531>,
      < 1.284590, -1.409526, -1.908415>,
      < -0.450907, -1.368000, -1.908415>
    }
    triangle {
      < 1.289825, -1.408841, -2.080531>,
      < 1.624716, 0.175770, -2.080531>,
      < 1.626518, 0.201666, -1.908415>
    }
    triangle {
      < 1.289825, -1.408841, -2.080531>,
      < 1.626518, 0.201666, -1.908415>,
      < 1.284590, -1.409526, -1.908415>
    }
    triangle {
      < 1.624716, 0.175770, -2.080531>,
      < 1.667625, 0.420813, -2.080531>,
      < 1.670328, 0.450819, -1.908415>
    }
    triangle {
      < 1.624716, 0.175770, -2.080531>,
      < 1.670328, 0.450819, -1.908415>,
      < 1.626518, 0.201666, -1.908415>
    }
    triangle {
      < 1.667625, 0.420813, -2.080531>,
      < 1.620650, 0.518830, -2.080531>,
      < 1.622366, 0.550481, -1.908415>
    }
    triangle {
      < 1.667625, 0.420813, -2.080531>,
      < 1.622366, 0.550481, -1.908415>,
      < 1.670328, 0.450819, -1.908415>
    }
    triangle {
      < 1.620650, 0.518830, -2.080531>,
      < 1.538969, 0.559671, -2.080531>,
      < 1.538969, 0.592006, -1.908415>
    }
    triangle {
      < 1.620650, 0.518830, -2.080531>,
      < 1.538969, 0.592006, -1.908415>,
      < 1.622366, 0.550481, -1.908415>
    }
    triangle {
      < 1.538969, 0.559671, -2.080531>,
      < 1.445019, 0.559671, -2.080531>,
      < 1.443045, 0.592006, -1.908415>
    }
    triangle {
      < 1.538969, 0.559671, -2.080531>,
      < 1.443045, 0.592006, -1.908415>,
      < 1.538969, 0.592006, -1.908415>
    }
    triangle {
      < 1.445019, 0.559671, -2.080531>,
      < 1.387842, 0.518830, -2.080531>,
      < 1.384666, 0.550481, -1.908415>
    }
    triangle {
      < 1.445019, 0.559671, -2.080531>,
      < 1.384666, 0.550481, -1.908415>,
      < 1.443045, 0.592006, -1.908415>
    }
    triangle {
      < 1.387842, 0.518830, -2.080531>,
      < 1.292275, 0.428981, -2.080531>,
      < 1.287091, 0.459125, -1.908415>
    }
    triangle {
      < 1.387842, 0.518830, -2.080531>,
      < 1.287091, 0.459125, -1.908415>,
      < 1.384666, 0.550481, -1.908415>
    }
    triangle {
      < 1.292275, 0.428981, -2.080531>,
      < 1.151716, 0.132773, -2.080531>,
      < 1.143579, 0.157948, -1.908415>
    }
    triangle {
      < 1.292275, 0.428981, -2.080531>,
      < 1.143579, 0.157948, -1.908415>,
      < 1.287091, 0.459125, -1.908415>
    }
    triangle {
      < 1.151716, 0.132773, -2.080531>,
      < 1.012858, -0.324640, -2.080531>,
      < 1.001803, -0.307138, -1.908415>
    }
    triangle {
      < 1.151716, 0.132773, -2.080531>,
      < 1.001803, -0.307138, -1.908415>,
      < 1.143579, 0.157948, -1.908415>
    }
    triangle {
      < 1.012858, -0.324640, -2.080531>,
      < 0.925586, -0.727435, -2.080531>,
      < 0.912697, -0.716689, -1.908415>
    }
    triangle {
      < 1.012858, -0.324640, -2.080531>,
      < 0.912697, -0.716689, -1.908415>,
      < 1.001803, -0.307138, -1.908415>
    }
    triangle {
      < 0.925586, -0.727435, -2.080531>,
      < 0.958824, -0.828386, -2.080531>,
      < 0.946633, -0.819334, -1.908415>
    }
    triangle {
      < 0.925586, -0.727435, -2.080531>,
      < 0.946633, -0.819334, -1.908415>,
      < 0.912697, -0.716689, -1.908415>
    }
    triangle {
      < 0.958824, -0.828386, -2.080531>,
      < 0.274758, -0.649208, -2.080531>,
      < 0.248194, -0.637150, -1.908415>
    }
    triangle {
      < 0.958824, -0.828386, -2.080531>,
      < 0.248194, -0.637150, -1.908415>,
      < 0.946633, -0.819334, -1.908415>
    }
    triangle {
      < 0.274758, -0.649208, -2.080531>,
      < -0.115968, -0.587130, -2.080531>,
      < -0.154318, -0.574031, -1.908415>
    }
    triangle {
      < 0.274758, -0.649208, -2.080531>,
      < -0.154318, -0.574031, -1.908415>,
      < 0.248194, -0.637150, -1.908415>
    }
    triangle {
      < -0.115968, -0.587130, -2.080531>,
      < -0.328597, -0.583863, -2.080531>,
      < -0.373229, -0.570709, -1.908415>
    }
    triangle {
      < -0.115968, -0.587130, -2.080531>,
      < -0.373229, -0.570709, -1.908415>,
      < -0.154318, -0.574031, -1.908415>
    }
    triangle {
      < -0.328597, -0.583863, -2.080531>,
      < -0.445200, -0.600199, -2.080531>,
      < -0.493276, -0.587320, -1.908415>
    }
    triangle {
      < -0.328597, -0.583863, -2.080531>,
      < -0.493276, -0.587320, -1.908415>,
      < -0.373229, -0.570709, -1.908415>
    }
    triangle {
      < 0.248194, -0.637150, -1.908415>,
      < -0.154318, -0.574031, -1.908415>,
      < -0.168462, -0.567400, -1.732031>
    }
    triangle {
      < 0.248194, -0.637150, -1.908415>,
      < -0.168462, -0.567400, -1.732031>,
      < 0.237413, -0.631046, -1.732031>
    }
    triangle {
      < -0.154318, -0.574031, -1.908415>,
      < -0.373229, -0.570709, -1.908415>,
      < -0.389200, -0.564050, -1.732031>
    }
    triangle {
      < -0.154318, -0.574031, -1.908415>,
      < -0.389200, -0.564050, -1.732031>,
      < -0.168462, -0.567400, -1.732031>
    }
    triangle {
      < -0.373229, -0.570709, -1.908415>,
      < -0.493276, -0.587320, -1.908415>,
      < -0.510251, -0.580799, -1.732031>
    }
    triangle {
      < -0.373229, -0.570709, -1.908415>,
      < -0.510251, -0.580799, -1.732031>,
      < -0.389200, -0.564050, -1.732031>
    }
    triangle {
      < -0.493276, -0.587320, -1.908415>,
      < -0.563893, -0.628845, -1.908415>,
      < -0.581457, -0.622671, -1.732031>
    }
    triangle {
      < -0.493276, -0.587320, -1.908415>,
      < -0.581457, -0.622671, -1.732031>,
      < -0.510251, -0.580799, -1.732031>
    }
    triangle {
      < -0.563893, -0.628845, -1.908415>,
      < -0.570954, -0.720201, -1.908415>,
      < -0.588577, -0.714790, -1.732031>
    }
    triangle {
      < -0.563893, -0.628845, -1.908415>,
      < -0.588577, -0.714790, -1.732031>,
      < -0.581457, -0.622671, -1.732031>
    }
    triangle {
      < -0.570954, -0.720201, -1.908415>,
      < -0.450907, -1.368000, -1.908415>,
      < -0.467527, -1.368000, -1.732031>
    }
    triangle {
      < -0.570954, -0.720201, -1.908415>,
      < -0.467527, -1.368000, -1.732031>,
      < -0.588577, -0.714790, -1.732031>
    }
    triangle {
      < -0.450907, -1.368000, -1.908415>,
      < 1.284590, -1.409526, -1.908415>,
      < 1.282465, -1.409872, -1.732031>
    }
    triangle {
      < -0.450907, -1.368000, -1.908415>,
      < 1.282465, -1.409872, -1.732031>,
      < -0.467527, -1.368000, -1.732031>
    }
    triangle {
      < 1.284590, -1.409526, -1.908415>,
      < 1.626518, 0.201666, -1.908415>,
      < 1.627249, 0.214777, -1.732031>
    }
    triangle {
      < 1.284590, -1.409526, -1.908415>,
      < 1.627249, 0.214777, -1.732031>,
      < 1.282465, -1.409872, -1.732031>
    }
    triangle {
      < 1.626518, 0.201666, -1.908415>,
      < 1.670328, 0.450819, -1.908415>,
      < 1.671425, 0.466011, -1.732031>
    }
    triangle {
      < 1.626518, 0.201666, -1.908415>,
      < 1.671425, 0.466011, -1.732031>,
      < 1.627249, 0.214777, -1.732031>
    }
    triangle {
      < 1.670328, 0.450819, -1.908415>,
      < 1.622366, 0.550481, -1.908415>,
      < 1.623063, 0.566505, -1.732031>
    }
    triangle {
      < 1.670328, 0.450819, -1.908415>,
      < 1.623063, 0.566505, -1.732031>,
      < 1.671425, 0.466011, -1.732031>
    }
    triangle {
      < 1.622366, 0.550481, -1.908415>,
      < 1.538969, 0.592006, -1.908415>,
      < 1.538969, 0.608377, -1.732031>
    }
    triangle {
      < 1.622366, 0.550481, -1.908415>,
      < 1.538969, 0.608377, -1.732031>,
      < 1.623063, 0.566505, -1.732031>
    }
    triangle {
      < 1.538969, 0.592006, -1.908415>,
      < 1.443045, 0.592006, -1.908415>,
      < 1.442243, 0.608377, -1.732031>
    }
    triangle {
      < 1.538969, 0.592006, -1.908415>,
      < 1.442243, 0.608377, -1.732031>,
      < 1.538969, 0.608377, -1.732031>
    }
    triangle {
      < 1.443045, 0.592006, -1.908415>,
      < 1.384666, 0.550481, -1.908415>,
      < 1.383377, 0.566505, -1.732031>
    }
    triangle {
      < 1.443045, 0.592006, -1.908415>,
      < 1.383377, 0.566505, -1.732031>,
      < 1.442243, 0.608377, -1.732031>
    }
    triangle {
      < 1.384666, 0.550481, -1.908415>,
      < 1.287091, 0.459125, -1.908415>,
      < 1.284988, 0.474386, -1.732031>
    }
    triangle {
      < 1.384666, 0.550481, -1.908415>,
      < 1.284988, 0.474386, -1.732031>,
      < 1.383377, 0.566505, -1.732031>
    }
    triangle {
      < 1.287091, 0.459125, -1.908415>,
      < 1.143579, 0.157948, -1.908415>,
      < 1.140276, 0.170694, -1.732031>
    }
    triangle {
      < 1.287091, 0.459125, -1.908415>,
      < 1.140276, 0.170694, -1.732031>,
      < 1.284988, 0.474386, -1.732031>
    }
    triangle {
      < 1.143579, 0.157948, -1.908415>,
      < 1.001803, -0.307138, -1.908415>,
      < 0.997317, -0.298277, -1.732031>
    }
    triangle {
      < 1.143579, 0.157948, -1.908415>,
      < 0.997317, -0.298277, -1.732031>,
      < 1.140276, 0.170694, -1.732031>
    }
    triangle {
      < 1.001803, -0.307138, -1.908415>,
      < 0.912697, -0.716689, -1.908415>,
      < 0.907466, -0.711249, -1.732031>
    }
    triangle {
      < 1.001803, -0.307138, -1.908415>,
      < 0.907466, -0.711249, -1.732031>,
      < 0.997317, -0.298277, -1.732031>
    }
    triangle {
      < 0.912697, -0.716689, -1.908415>,
      < 0.946633, -0.819334, -1.908415>,
      < 0.941686, -0.814751, -1.732031>
    }
    triangle {
      < 0.912697, -0.716689, -1.908415>,
      < 0.941686, -0.814751, -1.732031>,
      < 0.907466, -0.711249, -1.732031>
    }
    triangle {
      < 0.946633, -0.819334, -1.908415>,
      < 0.248194, -0.637150, -1.908415>,
      < 0.237413, -0.631046, -1.732031>
    }
    triangle {
      < 0.946633, -0.819334, -1.908415>,
      < 0.237413, -0.631046, -1.732031>,
      < 0.941686, -0.814751, -1.732031>
    }
    triangle {
      < 0.997317, -0.298277, -1.732031>,
      < 0.907466, -0.711249, -1.732031>,
      < 0.895462, -0.705414, -1.097573>
    }
    triangle {
      < 0.997317, -0.298277, -1.732031>,
      < 0.895462, -0.705414, -1.097573>,
      < 0.986820, -0.288993, -1.097573>
    }
    triangle {
      < 0.907466, -0.711249, -1.732031>,
      < 0.941686, -0.814751, -1.732031>,
      < 0.930256, -0.809781, -1.097573>
    }
    triangle {
      < 0.907466, -0.711249, -1.732031>,
      < 0.930256, -0.809781, -1.097573>,
      < 0.895462, -0.705414, -1.097573>
    }
    triangle {
      < 0.941686, -0.814751, -1.732031>,
      < 0.237413, -0.631046, -1.732031>,
      < 0.214169, -0.624541, -1.097573>
    }
    triangle {
      < 0.941686, -0.814751, -1.732031>,
      < 0.214169, -0.624541, -1.097573>,
      < 0.930256, -0.809781, -1.097573>
    }
    triangle {
      < 0.237413, -0.631046, -1.732031>,
      < -0.168462, -0.567400, -1.732031>,
      < -0.198514, -0.560363, -1.097573>
    }
    triangle {
      < 0.237413, -0.631046, -1.732031>,
      < -0.198514, -0.560363, -1.097573>,
      < 0.214169, -0.624541, -1.097573>
    }
    triangle {
      < -0.168462, -0.567400, -1.732031>,
      < -0.389200, -0.564050, -1.732031>,
      < -0.422955, -0.556985, -1.097573>
    }
    triangle {
      < -0.168462, -0.567400, -1.732031>,
      < -0.422955, -0.556985, -1.097573>,
      < -0.198514, -0.560363, -1.097573>
    }
    triangle {
      < -0.389200, -0.564050, -1.732031>,
      < -0.510251, -0.580799, -1.732031>,
      < -0.546036, -0.573874, -1.097573>
    }
    triangle {
      < -0.389200, -0.564050, -1.732031>,
      < -0.546036, -0.573874, -1.097573>,
      < -0.422955, -0.556985, -1.097573>
    }
    triangle {
      < -0.510251, -0.580799, -1.732031>,
      < -0.581457, -0.622671, -1.732031>,
      < -0.618437, -0.616096, -1.097573>
    }
    triangle {
      < -0.510251, -0.580799, -1.732031>,
      < -0.618437, -0.616096, -1.097573>,
      < -0.546036, -0.573874, -1.097573>
    }
    triangle {
      < -0.581457, -0.622671, -1.732031>,
      < -0.588577, -0.714790, -1.732031>,
      < -0.625677, -0.708985, -1.097573>
    }
    triangle {
      < -0.581457, -0.622671, -1.732031>,
      < -0.625677, -0.708985, -1.097573>,
      < -0.618437, -0.616096, -1.097573>
    }
    triangle {
      < -0.588577, -0.714790, -1.732031>,
      < -0.467527, -1.368000, -1.732031>,
      < -0.502596, -1.367650, -1.097573>
    }
    triangle {
      < -0.588577, -0.714790, -1.732031>,
      < -0.502596, -1.367650, -1.097573>,
      < -0.625677, -0.708985, -1.097573>
    }
    triangle {
      < -0.467527, -1.368000, -1.732031>,
      < 1.282465, -1.409872, -1.732031>,
      < 1.276751, -1.409872, -1.097573>
    }
    triangle {
      < -0.467527, -1.368000, -1.732031>,
      < 1.276751, -1.409872, -1.097573>,
      < 1.282465, -1.409872, -0.463114>
    }
    triangle {
      < -0.467527, -1.368000, -1.732031>,
      < 1.282465, -1.409872, -0.463114>,
      < -0.467527, -1.368000, -0.463114>
    }
    triangle {
      < -0.467527, -1.368000, -1.732031>,
      < -0.467527, -1.368000, -0.463114>,
      < -0.502596, -1.367650, -1.097573>
    }
    triangle {
      < 1.282465, -1.409872, -1.732031>,
      < 1.627249, 0.214777, -1.732031>,
      < 1.627319, 0.228347, -1.097573>
    }
    triangle {
      < 1.282465, -1.409872, -1.732031>,
      < 1.627319, 0.228347, -1.097573>,
      < 1.276751, -1.409872, -1.097573>
    }
    triangle {
      < 1.627249, 0.214777, -1.732031>,
      < 1.671425, 0.466011, -1.732031>,
      < 1.672236, 0.481679, -1.097573>
    }
    triangle {
      < 1.627249, 0.214777, -1.732031>,
      < 1.672236, 0.481679, -1.097573>,
      < 1.627319, 0.228347, -1.097573>
    }
    triangle {
      < 1.671425, 0.466011, -1.732031>,
      < 1.623063, 0.566505, -1.732031>,
      < 1.623063, 0.583013, -1.097573>
    }
    triangle {
      < 1.671425, 0.466011, -1.732031>,
      < 1.623063, 0.583013, -1.097573>,
      < 1.672236, 0.481679, -1.097573>
    }
    triangle {
      < 1.623063, 0.566505, -1.732031>,
      < 1.538969, 0.608377, -1.732031>,
      < 1.537558, 0.625235, -1.097573>
    }
    triangle {
      < 1.623063, 0.566505, -1.732031>,
      < 1.537558, 0.625235, -1.097573>,
      < 1.623063, 0.583013, -1.097573>
    }
    triangle {
      < 1.538969, 0.608377, -1.732031>,
      < 1.442243, 0.608377, -1.732031>,
      < 1.439210, 0.625235, -1.097573>
    }
    triangle {
      < 1.538969, 0.608377, -1.732031>,
      < 1.439210, 0.625235, -1.097573>,
      < 1.537558, 0.625235, -1.097573>
    }
    triangle {
      < 1.442243, 0.608377, -1.732031>,
      < 1.383377, 0.566505, -1.732031>,
      < 1.379357, 0.583013, -1.097573>
    }
    triangle {
      < 1.442243, 0.608377, -1.732031>,
      < 1.379357, 0.583013, -1.097573>,
      < 1.439210, 0.625235, -1.097573>
    }
    triangle {
      < 1.383377, 0.566505, -1.732031>,
      < 1.284988, 0.474386, -1.732031>,
      < 1.279316, 0.490124, -1.097573>
    }
    triangle {
      < 1.383377, 0.566505, -1.732031>,
      < 1.279316, 0.490124, -1.097573>,
      < 1.379357, 0.583013, -1.097573>
    }
    triangle {
      < 1.284988, 0.474386, -1.732031>,
      < 1.140276, 0.170694, -1.732031>,
      < 1.132178, 0.183895, -1.097573>
    }
    triangle {
      < 1.284988, 0.474386, -1.732031>,
      < 1.132178, 0.183895, -1.097573>,
      < 1.279316, 0.490124, -1.097573>
    }
    triangle {
      < 1.140276, 0.170694, -1.732031>,
      < 0.997317, -0.298277, -1.732031>,
      < 0.986820, -0.288993, -1.097573>
    }
    triangle {
      < 1.140276, 0.170694, -1.732031>,
      < 0.986820, -0.288993, -1.097573>,
      < 1.132178, 0.183895, -1.097573>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < -0.441985, -0.677600, -2.164841>,
      < -0.375915, -0.637600, -2.183490>
    }
    triangle {
      < -0.300640, -1.381333, -2.164841>,
      < -0.375915, -0.637600, -2.183490>,
      < -0.225137, -1.382295, -2.183490>
    }
    triangle {
      < -0.225137, -1.382295, -2.183490>,
      < -0.375915, -0.637600, -2.183490>,
      < -0.263595, -0.621600, -2.188152>
    }
    triangle {
      < -0.225137, -1.382295, -2.183490>,
      < -0.263595, -0.621600, -2.188152>,
      < -0.096081, -1.384488, -2.188152>
    }
    triangle {
      < -0.096081, -1.384488, -2.188152>,
      < -0.263595, -0.621600, -2.188152>,
      < -0.079495, -0.624800, -2.183490>
    }
    triangle {
      < -0.096081, -1.384488, -2.188152>,
      < -0.079495, -0.624800, -2.183490>,
      < 0.114115, -1.388035, -2.183490>
    }
    triangle {
      < 0.114115, -1.388035, -2.183490>,
      < -0.079495, -0.624800, -2.183490>,
      < 0.303423, -0.685600, -2.164841>
    }
    triangle {
      < 0.114115, -1.388035, -2.183490>,
      < 0.303423, -0.685600, -2.164841>,
      < 0.475977, -1.394139, -2.164841>
    }
    triangle {
      < 0.475977, -1.394139, -2.164841>,
      < 0.303423, -0.685600, -2.164841>,
      < 0.973411, -0.861091, -2.150854>
    }
    triangle {
      < 0.475977, -1.394139, -2.164841>,
      < 0.973411, -0.861091, -2.150854>,
      < 1.021619, -0.847826, -2.167172>
    }
    triangle {
      < 0.475977, -1.394139, -2.164841>,
      < 1.021619, -0.847826, -2.167172>,
      < 1.092757, -1.101782, -2.171834>
    }
    triangle {
      < 0.475977, -1.394139, -2.164841>,
      < 1.092757, -1.101782, -2.171834>,
      < 1.163895, -1.355737, -2.176496>
    }
    triangle {
      < 1.392799, 0.118647, -2.176496>,
      < 1.092757, -1.101782, -2.171834>,
      < 1.021619, -0.847826, -2.167172>
    }
    triangle {
      < 1.392799, 0.118647, -2.176496>,
      < 1.021619, -0.847826, -2.167172>,
      < 0.992299, -0.739317, -2.167172>
    }
    triangle {
      < 1.392799, 0.118647, -2.176496>,
      < 0.992299, -0.739317, -2.167172>,
      < 1.074769, -0.358689, -2.167172>
    }
    triangle {
      < 1.392799, 0.118647, -2.176496>,
      < 1.074769, -0.358689, -2.167172>,
      < 1.209098, 0.083809, -2.167172>
    }
    triangle {
      < 1.297600, -1.408000, -2.150854>,
      < 1.125798, -1.405102, -2.150854>,
      < 1.163895, -1.355737, -2.176496>
    }
    triangle {
      < 1.297600, -1.408000, -2.150854>,
      < 1.163895, -1.355737, -2.176496>,
      < 1.257208, -1.357312, -2.167172>
    }
    triangle {
      < 0.973411, -0.861091, -2.150854>,
      < 0.940857, -0.740617, -2.150854>,
      < 0.992299, -0.739317, -2.167172>
    }
    triangle {
      < 0.973411, -0.861091, -2.150854>,
      < 0.992299, -0.739317, -2.167172>,
      < 1.021619, -0.847826, -2.167172>
    }
    triangle {
      < 0.940857, -0.740617, -2.150854>,
      < 1.026333, -0.346112, -2.150854>,
      < 1.074769, -0.358689, -2.167172>
    }
    triangle {
      < 0.940857, -0.740617, -2.150854>,
      < 1.074769, -0.358689, -2.167172>,
      < 0.992299, -0.739317, -2.167172>
    }
    triangle {
      < 1.026333, -0.346112, -2.150854>,
      < 1.162333, 0.101888, -2.150854>,
      < 1.209098, 0.083809, -2.167172>
    }
    triangle {
      < 1.026333, -0.346112, -2.150854>,
      < 1.209098, 0.083809, -2.167172>,
      < 1.074769, -0.358689, -2.167172>
    }
    triangle {
      < 1.162333, 0.101888, -2.150854>,
      < 1.300000, 0.392000, -2.150854>,
      < 1.341126, 0.362037, -2.167172>
    }
    triangle {
      < 1.162333, 0.101888, -2.150854>,
      < 1.341126, 0.362037, -2.167172>,
      < 1.209098, 0.083809, -2.167172>
    }
    triangle {
      < 1.300000, 0.392000, -2.150854>,
      < 1.393600, 0.480000, -2.150854>,
      < 1.425399, 0.441268, -2.167172>
    }
    triangle {
      < 1.300000, 0.392000, -2.150854>,
      < 1.425399, 0.441268, -2.167172>,
      < 1.341126, 0.362037, -2.167172>
    }
    triangle {
      < 1.393600, 0.480000, -2.150854>,
      < 1.449600, 0.520000, -2.150854>,
      < 1.465623, 0.470000, -2.167172>
    }
    triangle {
      < 1.393600, 0.480000, -2.150854>,
      < 1.465623, 0.470000, -2.167172>,
      < 1.425399, 0.441268, -2.167172>
    }
    triangle {
      < 1.449600, 0.520000, -2.150854>,
      < 1.541617, 0.520000, -2.150854>,
      < 1.529814, 0.470000, -2.176496>
    }
    triangle {
      < 1.449600, 0.520000, -2.150854>,
      < 1.529814, 0.470000, -2.176496>,
      < 1.465623, 0.470000, -2.167172>
    }
    triangle {
      < 1.541617, 0.520000, -2.150854>,
      < 1.621617, 0.480000, -2.150854>,
      < 1.583932, 0.442941, -2.167172>
    }
    triangle {
      < 1.541617, 0.520000, -2.150854>,
      < 1.583932, 0.442941, -2.167172>,
      < 1.529814, 0.470000, -2.176496>
    }
    triangle {
      < 1.621617, 0.480000, -2.150854>,
      < 1.667625, 0.384000, -2.150854>,
      < 1.615610, 0.376841, -2.167172>
    }
    triangle {
      < 1.621617, 0.480000, -2.150854>,
      < 1.615610, 0.376841, -2.167172>,
      < 1.583932, 0.442941, -2.167172>
    }
    triangle {
      < 1.667625, 0.384000, -2.150854>,
      < 1.625600, 0.144000, -2.150854>,
      < 1.576500, 0.153484, -2.167172>
    }
    triangle {
      < 1.667625, 0.384000, -2.150854>,
      < 1.576500, 0.153484, -2.167172>,
      < 1.615610, 0.376841, -2.167172>
    }
    triangle {
      < 1.625600, 0.144000, -2.150854>,
      < 1.297600, -1.408000, -2.150854>,
      < 1.257208, -1.357312, -2.167172>
    }
    triangle {
      < 1.625600, 0.144000, -2.150854>,
      < 1.257208, -1.357312, -2.167172>,
      < 1.576500, 0.153484, -2.167172>
    }
    triangle {
      < 1.504665, 0.442104, -2.176496>,
      < 1.478368, 0.369439, -2.176496>,
      < 1.341126, 0.362037, -2.167172>
    }
    triangle {
      < 1.504665, 0.442104, -2.176496>,
      < 1.341126, 0.362037, -2.167172>,
      < 1.425399, 0.441268, -2.167172>
    }
    triangle {
      < 1.478368, 0.369439, -2.176496>,
      < 1.392799, 0.118647, -2.176496>,
      < 1.209098, 0.083809, -2.167172>
    }
    triangle {
      < 1.478368, 0.369439, -2.176496>,
      < 1.209098, 0.083809, -2.167172>,
      < 1.341126, 0.362037, -2.167172>
    }
    triangle {
      < 1.529814, 0.470000, -2.176496>,
      < 1.504665, 0.442104, -2.176496>,
      < 1.425399, 0.441268, -2.167172>
    }
    triangle {
      < 1.529814, 0.470000, -2.176496>,
      < 1.425399, 0.441268, -2.167172>,
      < 1.465623, 0.470000, -2.167172>
    }
    triangle {
      < 1.504665, 0.442104, -2.176496>,
      < 1.529814, 0.470000, -2.176496>,
      < 1.583932, 0.442941, -2.167172>
    }
    triangle {
      < 1.478368, 0.369439, -2.176496>,
      < 1.504665, 0.442104, -2.176496>,
      < 1.583932, 0.442941, -2.167172>
    }
    triangle {
      < 1.478368, 0.369439, -2.176496>,
      < 1.583932, 0.442941, -2.167172>,
      < 1.615610, 0.376841, -2.167172>
    }
    triangle {
      < 1.392799, 0.118647, -2.176496>,
      < 1.478368, 0.369439, -2.176496>,
      < 1.615610, 0.376841, -2.167172>
    }
    triangle {
      < 1.392799, 0.118647, -2.176496>,
      < 1.615610, 0.376841, -2.167172>,
      < 1.576500, 0.153484, -2.167172>
    }
    triangle {
      < 0.475977, -1.394139, -2.164841>,
      < 1.163895, -1.355737, -2.176496>,
      < 1.125798, -1.405102, -2.150854>
    }
    triangle {
      < 1.092757, -1.101782, -2.171834>,
      < 1.392799, 0.118647, -2.176496>,
      < 1.576500, 0.153484, -2.167172>
    }
    triangle {
      < 1.092757, -1.101782, -2.171834>,
      < 1.576500, 0.153484, -2.167172>,
      < 1.257208, -1.357312, -2.167172>
    }
    triangle {
      < 1.092757, -1.101782, -2.171834>,
      < 1.257208, -1.357312, -2.167172>,
      < 1.163895, -1.355737, -2.176496>
    }
    triangle {
      < 1.392799, 0.118647, -0.018649>,
      < 1.092757, -1.101782, -0.023311>,
      < 1.163895, -1.355737, -0.018649>
    }
    triangle {
      < 1.392799, 0.118647, -0.018649>,
      < 1.163895, -1.355737, -0.018649>,
      < 1.257208, -1.357312, -0.027974>
    }
    triangle {
      < 1.392799, 0.118647, -0.018649>,
      < 1.257208, -1.357312, -0.027974>,
      < 1.576500, 0.153484, -0.027974>
    }
    triangle {
      < 1.163895, -1.355737, -0.018649>,
      < 0.475977, -1.394139, -0.030305>,
      < 1.125798, -1.405102, -0.044292>
    }
    triangle {
      < 1.478368, 0.369439, -0.018649>,
      < 1.392799, 0.118647, -0.018649>,
      < 1.576500, 0.153484, -0.027974>
    }
    triangle {
      < 1.478368, 0.369439, -0.018649>,
      < 1.576500, 0.153484, -0.027974>,
      < 1.615610, 0.376841, -0.027974>
    }
    triangle {
      < 1.504665, 0.442104, -0.018649>,
      < 1.478368, 0.369439, -0.018649>,
      < 1.615610, 0.376841, -0.027974>
    }
    triangle {
      < 1.504665, 0.442104, -0.018649>,
      < 1.615610, 0.376841, -0.027974>,
      < 1.583932, 0.442941, -0.027974>
    }
    triangle {
      < 1.529814, 0.470000, -0.018649>,
      < 1.504665, 0.442104, -0.018649>,
      < 1.583932, 0.442941, -0.027974>
    }
    triangle {
      < 1.504665, 0.442104, -0.018649>,
      < 1.529814, 0.470000, -0.018649>,
      < 1.465623, 0.470000, -0.027974>
    }
    triangle {
      < 1.504665, 0.442104, -0.018649>,
      < 1.465623, 0.470000, -0.027974>,
      < 1.425399, 0.441268, -0.027974>
    }
    triangle {
      < 1.392799, 0.118647, -0.018649>,
      < 1.478368, 0.369439, -0.018649>,
      < 1.341126, 0.362037, -0.027974>
    }
    triangle {
      < 1.392799, 0.118647, -0.018649>,
      < 1.341126, 0.362037, -0.027974>,
      < 1.209098, 0.083809, -0.027974>
    }
    triangle {
      < 1.478368, 0.369439, -0.018649>,
      < 1.504665, 0.442104, -0.018649>,
      < 1.425399, 0.441268, -0.027974>
    }
    triangle {
      < 1.478368, 0.369439, -0.018649>,
      < 1.425399, 0.441268, -0.027974>,
      < 1.341126, 0.362037, -0.027974>
    }
    triangle {
      < 1.297600, -1.408000, -0.044292>,
      < 1.625600, 0.144000, -0.044292>,
      < 1.576500, 0.153484, -0.027974>
    }
    triangle {
      < 1.297600, -1.408000, -0.044292>,
      < 1.576500, 0.153484, -0.027974>,
      < 1.257208, -1.357312, -0.027974>
    }
    triangle {
      < 1.625600, 0.144000, -0.044292>,
      < 1.667625, 0.384000, -0.044292>,
      < 1.615610, 0.376841, -0.027974>
    }
    triangle {
      < 1.625600, 0.144000, -0.044292>,
      < 1.615610, 0.376841, -0.027974>,
      < 1.576500, 0.153484, -0.027974>
    }
    triangle {
      < 1.667625, 0.384000, -0.044292>,
      < 1.621617, 0.480000, -0.044292>,
      < 1.583932, 0.442941, -0.027974>
    }
    triangle {
      < 1.667625, 0.384000, -0.044292>,
      < 1.583932, 0.442941, -0.027974>,
      < 1.615610, 0.376841, -0.027974>
    }
    triangle {
      < 1.621617, 0.480000, -0.044292>,
      < 1.541617, 0.520000, -0.044292>,
      < 1.529814, 0.470000, -0.018649>
    }
    triangle {
      < 1.621617, 0.480000, -0.044292>,
      < 1.529814, 0.470000, -0.018649>,
      < 1.583932, 0.442941, -0.027974>
    }
    triangle {
      < 1.541617, 0.520000, -0.044292>,
      < 1.449600, 0.520000, -0.044292>,
      < 1.465623, 0.470000, -0.027974>
    }
    triangle {
      < 1.541617, 0.520000, -0.044292>,
      < 1.465623, 0.470000, -0.027974>,
      < 1.529814, 0.470000, -0.018649>
    }
    triangle {
      < 1.449600, 0.520000, -0.044292>,
      < 1.393600, 0.480000, -0.044292>,
      < 1.425399, 0.441268, -0.027974>
    }
    triangle {
      < 1.449600, 0.520000, -0.044292>,
      < 1.425399, 0.441268, -0.027974>,
      < 1.465623, 0.470000, -0.027974>
    }
    triangle {
      < 1.393600, 0.480000, -0.044292>,
      < 1.300000, 0.392000, -0.044292>,
      < 1.341126, 0.362037, -0.027974>
    }
    triangle {
      < 1.393600, 0.480000, -0.044292>,
      < 1.341126, 0.362037, -0.027974>,
      < 1.425399, 0.441268, -0.027974>
    }
    triangle {
      < 1.300000, 0.392000, -0.044292>,
      < 1.162333, 0.101888, -0.044292>,
      < 1.209098, 0.083809, -0.027974>
    }
    triangle {
      < 1.300000, 0.392000, -0.044292>,
      < 1.209098, 0.083809, -0.027974>,
      < 1.341126, 0.362037, -0.027974>
    }
    triangle {
      < 1.162333, 0.101888, -0.044292>,
      < 1.026333, -0.346112, -0.044292>,
      < 1.074769, -0.358689, -0.027974>
    }
    triangle {
      < 1.162333, 0.101888, -0.044292>,
      < 1.074769, -0.358689, -0.027974>,
      < 1.209098, 0.083809, -0.027974>
    }
    triangle {
      < 1.026333, -0.346112, -0.044292>,
      < 0.940857, -0.740617, -0.044292>,
      < 0.992299, -0.739317, -0.027974>
    }
    triangle {
      < 1.026333, -0.346112, -0.044292>,
      < 0.992299, -0.739317, -0.027974>,
      < 1.074769, -0.358689, -0.027974>
    }
    triangle {
      < 0.940857, -0.740617, -0.044292>,
      < 0.973411, -0.861091, -0.044292>,
      < 1.021619, -0.847826, -0.027974>
    }
    triangle {
      < 0.940857, -0.740617, -0.044292>,
      < 1.021619, -0.847826, -0.027974>,
      < 0.992299, -0.739317, -0.027974>
    }
    triangle {
      < 1.125798, -1.405102, -0.044292>,
      < 1.297600, -1.408000, -0.044292>,
      < 1.257208, -1.357312, -0.027974>
    }
    triangle {
      < 1.125798, -1.405102, -0.044292>,
      < 1.257208, -1.357312, -0.027974>,
      < 1.163895, -1.355737, -0.018649>
    }
    triangle {
      < 1.092757, -1.101782, -0.023311>,
      < 1.392799, 0.118647, -0.018649>,
      < 1.209098, 0.083809, -0.027974>
    }
    triangle {
      < 1.092757, -1.101782, -0.023311>,
      < 1.209098, 0.083809, -0.027974>,
      < 1.074769, -0.358689, -0.027974>
    }
    triangle {
      < 1.092757, -1.101782, -0.023311>,
      < 1.074769, -0.358689, -0.027974>,
      < 0.992299, -0.739317, -0.027974>
    }
    triangle {
      < 1.092757, -1.101782, -0.023311>,
      < 0.992299, -0.739317, -0.027974>,
      < 1.021619, -0.847826, -0.027974>
    }
    triangle {
      < 0.303423, -0.685600, -0.030305>,
      < 0.475977, -1.394139, -0.030305>,
      < 1.163895, -1.355737, -0.018649>
    }
    triangle {
      < 0.303423, -0.685600, -0.030305>,
      < 1.163895, -1.355737, -0.018649>,
      < 1.092757, -1.101782, -0.023311>
    }
    triangle {
      < 0.303423, -0.685600, -0.030305>,
      < 1.092757, -1.101782, -0.023311>,
      < 1.021619, -0.847826, -0.027974>
    }
    triangle {
      < 0.303423, -0.685600, -0.030305>,
      < 1.021619, -0.847826, -0.027974>,
      < 0.973411, -0.861091, -0.044292>
    }
    triangle {
      < -0.079495, -0.624800, -0.011655>,
      < 0.114115, -1.388035, -0.011655>,
      < 0.475977, -1.394139, -0.030305>
    }
    triangle {
      < -0.079495, -0.624800, -0.011655>,
      < 0.475977, -1.394139, -0.030305>,
      < 0.303423, -0.685600, -0.030305>
    }
    triangle {
      < -0.263595, -0.621600, -0.006993>,
      < -0.096081, -1.384488, -0.006993>,
      < 0.114115, -1.388035, -0.011655>
    }
    triangle {
      < -0.263595, -0.621600, -0.006993>,
      < 0.114115, -1.388035, -0.011655>,
      < -0.079495, -0.624800, -0.011655>
    }
    triangle {
      < -0.375915, -0.637600, -0.011655>,
      < -0.225137, -1.382295, -0.011655>,
      < -0.096081, -1.384488, -0.006993>
    }
    triangle {
      < -0.375915, -0.637600, -0.011655>,
      < -0.096081, -1.384488, -0.006993>,
      < -0.263595, -0.621600, -0.006993>
    }
    triangle {
      < -0.441985, -0.677600, -0.030305>,
      < -0.300640, -1.381333, -0.030305>,
      < -0.225137, -1.382295, -0.011655>
    }
    triangle {
      < -0.441985, -0.677600, -0.030305>,
      < -0.225137, -1.382295, -0.011655>,
      < -0.375915, -0.637600, -0.011655>
    }
    triangle {
      < 0.997317, -0.298277, -0.463114>,
      < 1.140276, 0.170694, -0.463114>,
      < 1.132178, 0.183895, -1.097573>
    }
    triangle {
      < 0.997317, -0.298277, -0.463114>,
      < 1.132178, 0.183895, -1.097573>,
      < 0.986820, -0.288993, -1.097573>
    }
    triangle {
      < 1.140276, 0.170694, -0.463114>,
      < 1.284988, 0.474386, -0.463114>,
      < 1.279316, 0.490124, -1.097573>
    }
    triangle {
      < 1.140276, 0.170694, -0.463114>,
      < 1.279316, 0.490124, -1.097573>,
      < 1.132178, 0.183895, -1.097573>
    }
    triangle {
      < 1.284988, 0.474386, -0.463114>,
      < 1.383377, 0.566505, -0.463114>,
      < 1.379357, 0.583013, -1.097573>
    }
    triangle {
      < 1.284988, 0.474386, -0.463114>,
      < 1.379357, 0.583013, -1.097573>,
      < 1.279316, 0.490124, -1.097573>
    }
    triangle {
      < 1.383377, 0.566505, -0.463114>,
      < 1.442243, 0.608377, -0.463114>,
      < 1.439210, 0.625235, -1.097573>
    }
    triangle {
      < 1.383377, 0.566505, -0.463114>,
      < 1.439210, 0.625235, -1.097573>,
      < 1.379357, 0.583013, -1.097573>
    }
    triangle {
      < 1.442243, 0.608377, -0.463114>,
      < 1.538969, 0.608377, -0.463114>,
      < 1.537558, 0.625235, -1.097573>
    }
    triangle {
      < 1.442243, 0.608377, -0.463114>,
      < 1.537558, 0.625235, -1.097573>,
      < 1.439210, 0.625235, -1.097573>
    }
    triangle {
      < 1.538969, 0.608377, -0.463114>,
      < 1.623063, 0.566505, -0.463114>,
      < 1.623063, 0.583013, -1.097573>
    }
    triangle {
      < 1.538969, 0.608377, -0.463114>,
      < 1.623063, 0.583013, -1.097573>,
      < 1.537558, 0.625235, -1.097573>
    }
    triangle {
      < 1.623063, 0.566505, -0.463114>,
      < 1.671425, 0.466011, -0.463114>,
      < 1.672236, 0.481679, -1.097573>
    }
    triangle {
      < 1.623063, 0.566505, -0.463114>,
      < 1.672236, 0.481679, -1.097573>,
      < 1.623063, 0.583013, -1.097573>
    }
    triangle {
      < 1.671425, 0.466011, -0.463114>,
      < 1.627249, 0.214777, -0.463114>,
      < 1.627319, 0.228347, -1.097573>
    }
    triangle {
      < 1.671425, 0.466011, -0.463114>,
      < 1.627319, 0.228347, -1.097573>,
      < 1.672236, 0.481679, -1.097573>
    }
    triangle {
      < 1.627249, 0.214777, -0.463114>,
      < 1.282465, -1.409872, -0.463114>,
      < 1.276751, -1.409872, -1.097573>
    }
    triangle {
      < 1.627249, 0.214777, -0.463114>,
      < 1.276751, -1.409872, -1.097573>,
      < 1.627319, 0.228347, -1.097573>
    }
    triangle {
      < -0.467527, -1.368000, -0.463114>,
      < -0.588577, -0.714790, -0.463114>,
      < -0.625677, -0.708985, -1.097573>
    }
    triangle {
      < -0.467527, -1.368000, -0.463114>,
      < -0.625677, -0.708985, -1.097573>,
      < -0.502596, -1.367650, -1.097573>
    }
    triangle {
      < -0.588577, -0.714790, -0.463114>,
      < -0.581457, -0.622671, -0.463114>,
      < -0.618437, -0.616096, -1.097573>
    }
    triangle {
      < -0.588577, -0.714790, -0.463114>,
      < -0.618437, -0.616096, -1.097573>,
      < -0.625677, -0.708985, -1.097573>
    }
    triangle {
      < -0.581457, -0.622671, -0.463114>,
      < -0.510251, -0.580799, -0.463114>,
      < -0.546036, -0.573874, -1.097573>
    }
    triangle {
      < -0.581457, -0.622671, -0.463114>,
      < -0.546036, -0.573874, -1.097573>,
      < -0.618437, -0.616096, -1.097573>
    }
    triangle {
      < -0.510251, -0.580799, -0.463114>,
      < -0.389200, -0.564050, -0.463114>,
      < -0.422955, -0.556985, -1.097573>
    }
    triangle {
      < -0.510251, -0.580799, -0.463114>,
      < -0.422955, -0.556985, -1.097573>,
      < -0.546036, -0.573874, -1.097573>
    }
    triangle {
      < -0.389200, -0.564050, -0.463114>,
      < -0.168462, -0.567400, -0.463114>,
      < -0.198514, -0.560363, -1.097573>
    }
    triangle {
      < -0.389200, -0.564050, -0.463114>,
      < -0.198514, -0.560363, -1.097573>,
      < -0.422955, -0.556985, -1.097573>
    }
    triangle {
      < -0.168462, -0.567400, -0.463114>,
      < 0.237413, -0.631046, -0.463114>,
      < 0.214169, -0.624541, -1.097573>
    }
    triangle {
      < -0.168462, -0.567400, -0.463114>,
      < 0.214169, -0.624541, -1.097573>,
      < -0.198514, -0.560363, -1.097573>
    }
    triangle {
      < 0.237413, -0.631046, -0.463114>,
      < 0.941686, -0.814751, -0.463114>,
      < 0.930256, -0.809781, -1.097573>
    }
    triangle {
      < 0.237413, -0.631046, -0.463114>,
      < 0.930256, -0.809781, -1.097573>,
      < 0.214169, -0.624541, -1.097573>
    }
    triangle {
      < 0.941686, -0.814751, -0.463114>,
      < 0.907466, -0.711249, -0.463114>,
      < 0.895462, -0.705414, -1.097573>
    }
    triangle {
      < 0.941686, -0.814751, -0.463114>,
      < 0.895462, -0.705414, -1.097573>,
      < 0.930256, -0.809781, -1.097573>
    }
    triangle {
      < 0.907466, -0.711249, -0.463114>,
      < 0.997317, -0.298277, -0.463114>,
      < 0.986820, -0.288993, -1.097573>
    }
    triangle {
      < 0.907466, -0.711249, -0.463114>,
      < 0.986820, -0.288993, -1.097573>,
      < 0.895462, -0.705414, -1.097573>
    }
    triangle {
      < 0.248194, -0.637150, -0.286730>,
      < 0.946633, -0.819334, -0.286730>,
      < 0.941686, -0.814751, -0.463114>
    }
    triangle {
      < 0.248194, -0.637150, -0.286730>,
      < 0.941686, -0.814751, -0.463114>,
      < 0.237413, -0.631046, -0.463114>
    }
    triangle {
      < 0.946633, -0.819334, -0.286730>,
      < 0.912697, -0.716689, -0.286730>,
      < 0.907466, -0.711249, -0.463114>
    }
    triangle {
      < 0.946633, -0.819334, -0.286730>,
      < 0.907466, -0.711249, -0.463114>,
      < 0.941686, -0.814751, -0.463114>
    }
    triangle {
      < 0.912697, -0.716689, -0.286730>,
      < 1.001803, -0.307138, -0.286730>,
      < 0.997317, -0.298277, -0.463114>
    }
    triangle {
      < 0.912697, -0.716689, -0.286730>,
      < 0.997317, -0.298277, -0.463114>,
      < 0.907466, -0.711249, -0.463114>
    }
    triangle {
      < 1.001803, -0.307138, -0.286730>,
      < 1.143579, 0.157948, -0.286730>,
      < 1.140276, 0.170694, -0.463114>
    }
    triangle {
      < 1.001803, -0.307138, -0.286730>,
      < 1.140276, 0.170694, -0.463114>,
      < 0.997317, -0.298277, -0.463114>
    }
    triangle {
      < 1.143579, 0.157948, -0.286730>,
      < 1.287091, 0.459125, -0.286730>,
      < 1.284988, 0.474386, -0.463114>
    }
    triangle {
      < 1.143579, 0.157948, -0.286730>,
      < 1.284988, 0.474386, -0.463114>,
      < 1.140276, 0.170694, -0.463114>
    }
    triangle {
      < 1.287091, 0.459125, -0.286730>,
      < 1.384666, 0.550481, -0.286730>,
      < 1.383377, 0.566505, -0.463114>
    }
    triangle {
      < 1.287091, 0.459125, -0.286730>,
      < 1.383377, 0.566505, -0.463114>,
      < 1.284988, 0.474386, -0.463114>
    }
    triangle {
      < 1.384666, 0.550481, -0.286730>,
      < 1.443045, 0.592006, -0.286730>,
      < 1.442243, 0.608377, -0.463114>
    }
    triangle {
      < 1.384666, 0.550481, -0.286730>,
      < 1.442243, 0.608377, -0.463114>,
      < 1.383377, 0.566505, -0.463114>
    }
    triangle {
      < 1.443045, 0.592006, -0.286730>,
      < 1.538969, 0.592006, -0.286730>,
      < 1.538969, 0.608377, -0.463114>
    }
    triangle {
      < 1.443045, 0.592006, -0.286730>,
      < 1.538969, 0.608377, -0.463114>,
      < 1.442243, 0.608377, -0.463114>
    }
    triangle {
      < 1.538969, 0.592006, -0.286730>,
      < 1.622366, 0.550481, -0.286730>,
      < 1.623063, 0.566505, -0.463114>
    }
    triangle {
      < 1.538969, 0.592006, -0.286730>,
      < 1.623063, 0.566505, -0.463114>,
      < 1.538969, 0.608377, -0.463114>
    }
    triangle {
      < 1.622366, 0.550481, -0.286730>,
      < 1.670328, 0.450819, -0.286730>,
      < 1.671425, 0.466011, -0.463114>
    }
    triangle {
      < 1.622366, 0.550481, -0.286730>,
      < 1.671425, 0.466011, -0.463114>,
      < 1.623063, 0.566505, -0.463114>
    }
    triangle {
      < 1.670328, 0.450819, -0.286730>,
      < 1.626518, 0.201666, -0.286730>,
      < 1.627249, 0.214777, -0.463114>
    }
    triangle {
      < 1.670328, 0.450819, -0.286730>,
      < 1.627249, 0.214777, -0.463114>,
      < 1.671425, 0.466011, -0.463114>
    }
    triangle {
      < 1.626518, 0.201666, -0.286730>,
      < 1.284590, -1.409526, -0.286730>,
      < 1.282465, -1.409872, -0.463114>
    }
    triangle {
      < 1.626518, 0.201666, -0.286730>,
      < 1.282465, -1.409872, -0.463114>,
      < 1.627249, 0.214777, -0.463114>
    }
    triangle {
      < 1.284590, -1.409526, -0.286730>,
      < -0.450907, -1.368000, -0.286730>,
      < -0.467527, -1.368000, -0.463114>
    }
    triangle {
      < 1.284590, -1.409526, -0.286730>,
      < -0.467527, -1.368000, -0.463114>,
      < 1.282465, -1.409872, -0.463114>
    }
    triangle {
      < -0.450907, -1.368000, -0.286730>,
      < -0.570954, -0.720201, -0.286730>,
      < -0.588577, -0.714790, -0.463114>
    }
    triangle {
      < -0.450907, -1.368000, -0.286730>,
      < -0.588577, -0.714790, -0.463114>,
      < -0.467527, -1.368000, -0.463114>
    }
    triangle {
      < -0.570954, -0.720201, -0.286730>,
      < -0.563893, -0.628845, -0.286730>,
      < -0.581457, -0.622671, -0.463114>
    }
    triangle {
      < -0.570954, -0.720201, -0.286730>,
      < -0.581457, -0.622671, -0.463114>,
      < -0.588577, -0.714790, -0.463114>
    }
    triangle {
      < -0.563893, -0.628845, -0.286730>,
      < -0.493276, -0.587320, -0.286730>,
      < -0.510251, -0.580799, -0.463114>
    }
    triangle {
      < -0.563893, -0.628845, -0.286730>,
      < -0.510251, -0.580799, -0.463114>,
      < -0.581457, -0.622671, -0.463114>
    }
    triangle {
      < -0.493276, -0.587320, -0.286730>,
      < -0.373229, -0.570709, -0.286730>,
      < -0.389200, -0.564050, -0.463114>
    }
    triangle {
      < -0.493276, -0.587320, -0.286730>,
      < -0.389200, -0.564050, -0.463114>,
      < -0.510251, -0.580799, -0.463114>
    }
    triangle {
      < -0.373229, -0.570709, -0.286730>,
      < -0.154318, -0.574031, -0.286730>,
      < -0.168462, -0.567400, -0.463114>
    }
    triangle {
      < -0.373229, -0.570709, -0.286730>,
      < -0.168462, -0.567400, -0.463114>,
      < -0.389200, -0.564050, -0.463114>
    }
    triangle {
      < -0.154318, -0.574031, -0.286730>,
      < 0.248194, -0.637150, -0.286730>,
      < 0.237413, -0.631046, -0.463114>
    }
    triangle {
      < -0.154318, -0.574031, -0.286730>,
      < 0.237413, -0.631046, -0.463114>,
      < -0.168462, -0.567400, -0.463114>
    }
    triangle {
      < -0.445200, -0.600199, -0.114615>,
      < -0.328597, -0.583863, -0.114615>,
      < -0.373229, -0.570709, -0.286730>
    }
    triangle {
      < -0.445200, -0.600199, -0.114615>,
      < -0.373229, -0.570709, -0.286730>,
      < -0.493276, -0.587320, -0.286730>
    }
    triangle {
      < -0.328597, -0.583863, -0.114615>,
      < -0.115968, -0.587130, -0.114615>,
      < -0.154318, -0.574031, -0.286730>
    }
    triangle {
      < -0.328597, -0.583863, -0.114615>,
      < -0.154318, -0.574031, -0.286730>,
      < -0.373229, -0.570709, -0.286730>
    }
    triangle {
      < -0.115968, -0.587130, -0.114615>,
      < 0.274758, -0.649208, -0.114615>,
      < 0.248194, -0.637150, -0.286730>
    }
    triangle {
      < -0.115968, -0.587130, -0.114615>,
      < 0.248194, -0.637150, -0.286730>,
      < -0.154318, -0.574031, -0.286730>
    }
    triangle {
      < 0.274758, -0.649208, -0.114615>,
      < 0.958824, -0.828386, -0.114615>,
      < 0.946633, -0.819334, -0.286730>
    }
    triangle {
      < 0.274758, -0.649208, -0.114615>,
      < 0.946633, -0.819334, -0.286730>,
      < 0.248194, -0.637150, -0.286730>
    }
    triangle {
      < 0.958824, -0.828386, -0.114615>,
      < 0.925586, -0.727435, -0.114615>,
      < 0.912697, -0.716689, -0.286730>
    }
    triangle {
      < 0.958824, -0.828386, -0.114615>,
      < 0.912697, -0.716689, -0.286730>,
      < 0.946633, -0.819334, -0.286730>
    }
    triangle {
      < 0.925586, -0.727435, -0.114615>,
      < 1.012858, -0.324640, -0.114615>,
      < 1.001803, -0.307138, -0.286730>
    }
    triangle {
      < 0.925586, -0.727435, -0.114615>,
      < 1.001803, -0.307138, -0.286730>,
      < 0.912697, -0.716689, -0.286730>
    }
    triangle {
      < 1.012858, -0.324640, -0.114615>,
      < 1.151716, 0.132773, -0.114615>,
      < 1.143579, 0.157948, -0.286730>
    }
    triangle {
      < 1.012858, -0.324640, -0.114615>,
      < 1.143579, 0.157948, -0.286730>,
      < 1.001803, -0.307138, -0.286730>
    }
    triangle {
      < 1.151716, 0.132773, -0.114615>,
      < 1.292275, 0.428981, -0.114615>,
      < 1.287091, 0.459125, -0.286730>
    }
    triangle {
      < 1.151716, 0.132773, -0.114615>,
      < 1.287091, 0.459125, -0.286730>,
      < 1.143579, 0.157948, -0.286730>
    }
    triangle {
      < 1.292275, 0.428981, -0.114615>,
      < 1.387842, 0.518830, -0.114615>,
      < 1.384666, 0.550481, -0.286730>
    }
    triangle {
      < 1.292275, 0.428981, -0.114615>,
      < 1.384666, 0.550481, -0.286730>,
      < 1.287091, 0.459125, -0.286730>
    }
    triangle {
      < 1.387842, 0.518830, -0.114615>,
      < 1.445019, 0.559671, -0.114615>,
      < 1.443045, 0.592006, -0.286730>
    }
    triangle {
      < 1.387842, 0.518830, -0.114615>,
      < 1.443045, 0.592006, -0.286730>,
      < 1.384666, 0.550481, -0.286730>
    }
    triangle {
      < 1.445019, 0.559671, -0.114615>,
      < 1.538969, 0.559671, -0.114615>,
      < 1.538969, 0.592006, -0.286730>
    }
    triangle {
      < 1.445019, 0.559671, -0.114615>,
      < 1.538969, 0.592006, -0.286730>,
      < 1.443045, 0.592006, -0.286730>
    }
    triangle {
      < 1.538969, 0.559671, -0.114615>,
      < 1.620650, 0.518830, -0.114615>,
      < 1.622366, 0.550481, -0.286730>
    }
    triangle {
      < 1.538969, 0.559671, -0.114615>,
      < 1.622366, 0.550481, -0.286730>,
      < 1.538969, 0.592006, -0.286730>
    }
    triangle {
      < 1.620650, 0.518830, -0.114615>,
      < 1.667625, 0.420813, -0.114615>,
      < 1.670328, 0.450819, -0.286730>
    }
    triangle {
      < 1.620650, 0.518830, -0.114615>,
      < 1.670328, 0.450819, -0.286730>,
      < 1.622366, 0.550481, -0.286730>
    }
    triangle {
      < 1.667625, 0.420813, -0.114615>,
      < 1.624716, 0.175770, -0.114615>,
      < 1.626518, 0.201666, -0.286730>
    }
    triangle {
      < 1.667625, 0.420813, -0.114615>,
      < 1.626518, 0.201666, -0.286730>,
      < 1.670328, 0.450819, -0.286730>
    }
    triangle {
      < 1.624716, 0.175770, -0.114615>,
      < 1.289825, -1.408841, -0.114615>,
      < 1.284590, -1.409526, -0.286730>
    }
    triangle {
      < 1.624716, 0.175770, -0.114615>,
      < 1.284590, -1.409526, -0.286730>,
      < 1.626518, 0.201666, -0.286730>
    }
    triangle {
      < 1.289825, -1.408841, -0.114615>,
      < -0.404046, -1.368000, -0.114615>,
      < -0.450907, -1.368000, -0.286730>
    }
    triangle {
      < 1.289825, -1.408841, -0.114615>,
      < -0.450907, -1.368000, -0.286730>,
      < 1.284590, -1.409526, -0.286730>
    }
    triangle {
      < -0.404046, -1.368000, -0.114615>,
      < -0.520650, -0.730889, -0.114615>,
      < -0.570954, -0.720201, -0.286730>
    }
    triangle {
      < -0.404046, -1.368000, -0.114615>,
      < -0.570954, -0.720201, -0.286730>,
      < -0.450907, -1.368000, -0.286730>
    }
    triangle {
      < -0.520650, -0.730889, -0.114615>,
      < -0.513791, -0.641040, -0.114615>,
      < -0.563893, -0.628845, -0.286730>
    }
    triangle {
      < -0.520650, -0.730889, -0.114615>,
      < -0.563893, -0.628845, -0.286730>,
      < -0.570954, -0.720201, -0.286730>
    }
    triangle {
      < -0.513791, -0.641040, -0.114615>,
      < -0.445200, -0.600199, -0.114615>,
      < -0.493276, -0.587320, -0.286730>
    }
    triangle {
      < -0.513791, -0.641040, -0.114615>,
      < -0.493276, -0.587320, -0.286730>,
      < -0.563893, -0.628845, -0.286730>
    }
    triangle {
      < -0.350672, -1.368000, -0.044292>,
      < -0.462992, -0.765600, -0.044292>,
      < -0.520650, -0.730889, -0.114615>
    }
    triangle {
      < -0.350672, -1.368000, -0.044292>,
      < -0.520650, -0.730889, -0.114615>,
      < -0.404046, -1.368000, -0.114615>
    }
    triangle {
      < -0.462992, -0.765600, -0.044292>,
      < -0.441985, -0.677600, -0.030305>,
      < -0.513791, -0.641040, -0.114615>
    }
    triangle {
      < -0.462992, -0.765600, -0.044292>,
      < -0.513791, -0.641040, -0.114615>,
      < -0.520650, -0.730889, -0.114615>
    }
    triangle {
      < -0.441985, -0.677600, -0.030305>,
      < -0.375915, -0.637600, -0.011655>,
      < -0.445200, -0.600199, -0.114615>
    }
    triangle {
      < -0.441985, -0.677600, -0.030305>,
      < -0.445200, -0.600199, -0.114615>,
      < -0.513791, -0.641040, -0.114615>
    }
    triangle {
      < -0.375915, -0.637600, -0.011655>,
      < -0.263595, -0.621600, -0.006993>,
      < -0.328597, -0.583863, -0.114615>
    }
    triangle {
      < -0.375915, -0.637600, -0.011655>,
      < -0.328597, -0.583863, -0.114615>,
      < -0.445200, -0.600199, -0.114615>
    }
    triangle {
      < -0.263595, -0.621600, -0.006993>,
      < -0.079495, -0.624800, -0.011655>,
      < -0.115968, -0.587130, -0.114615>
    }
    triangle {
      < -0.263595, -0.621600, -0.006993>,
      < -0.115968, -0.587130, -0.114615>,
      < -0.328597, -0.583863, -0.114615>
    }
    triangle {
      < -0.079495, -0.624800, -0.011655>,
      < 0.303423, -0.685600, -0.030305>,
      < 0.274758, -0.649208, -0.114615>
    }
    triangle {
      < -0.079495, -0.624800, -0.011655>,
      < 0.274758, -0.649208, -0.114615>,
      < -0.115968, -0.587130, -0.114615>
    }
    triangle {
      < 0.303423, -0.685600, -0.030305>,
      < 0.973411, -0.861091, -0.044292>,
      < 0.958824, -0.828386, -0.114615>
    }
    triangle {
      < 0.303423, -0.685600, -0.030305>,
      < 0.958824, -0.828386, -0.114615>,
      < 0.274758, -0.649208, -0.114615>
    }
    triangle {
      < 0.973411, -0.861091, -0.044292>,
      < 0.940857, -0.740617, -0.044292>,
      < 0.925586, -0.727435, -0.114615>
    }
    triangle {
      < 0.973411, -0.861091, -0.044292>,
      < 0.925586, -0.727435, -0.114615>,
      < 0.958824, -0.828386, -0.114615>
    }
    triangle {
      < 0.940857, -0.740617, -0.044292>,
      < 1.026333, -0.346112, -0.044292>,
      < 1.012858, -0.324640, -0.114615>
    }
    triangle {
      < 0.940857, -0.740617, -0.044292>,
      < 1.012858, -0.324640, -0.114615>,
      < 0.925586, -0.727435, -0.114615>
    }
    triangle {
      < 1.026333, -0.346112, -0.044292>,
      < 1.162333, 0.101888, -0.044292>,
      < 1.151716, 0.132773, -0.114615>
    }
    triangle {
      < 1.026333, -0.346112, -0.044292>,
      < 1.151716, 0.132773, -0.114615>,
      < 1.012858, -0.324640, -0.114615>
    }
    triangle {
      < 1.162333, 0.101888, -0.044292>,
      < 1.300000, 0.392000, -0.044292>,
      < 1.292275, 0.428981, -0.114615>
    }
    triangle {
      < 1.162333, 0.101888, -0.044292>,
      < 1.292275, 0.428981, -0.114615>,
      < 1.151716, 0.132773, -0.114615>
    }
    triangle {
      < 1.300000, 0.392000, -0.044292>,
      < 1.393600, 0.480000, -0.044292>,
      < 1.387842, 0.518830, -0.114615>
    }
    triangle {
      < 1.300000, 0.392000, -0.044292>,
      < 1.387842, 0.518830, -0.114615>,
      < 1.292275, 0.428981, -0.114615>
    }
    triangle {
      < 1.393600, 0.480000, -0.044292>,
      < 1.449600, 0.520000, -0.044292>,
      < 1.445019, 0.559671, -0.114615>
    }
    triangle {
      < 1.393600, 0.480000, -0.044292>,
      < 1.445019, 0.559671, -0.114615>,
      < 1.387842, 0.518830, -0.114615>
    }
    triangle {
      < 1.449600, 0.520000, -0.044292>,
      < 1.541617, 0.520000, -0.044292>,
      < 1.538969, 0.559671, -0.114615>
    }
    triangle {
      < 1.449600, 0.520000, -0.044292>,
      < 1.538969, 0.559671, -0.114615>,
      < 1.445019, 0.559671, -0.114615>
    }
    triangle {
      < 1.541617, 0.520000, -0.044292>,
      < 1.621617, 0.480000, -0.044292>,
      < 1.620650, 0.518830, -0.114615>
    }
    triangle {
      < 1.541617, 0.520000, -0.044292>,
      < 1.620650, 0.518830, -0.114615>,
      < 1.538969, 0.559671, -0.114615>
    }
    triangle {
      < 1.621617, 0.480000, -0.044292>,
      < 1.667625, 0.384000, -0.044292>,
      < 1.667625, 0.420813, -0.114615>
    }
    triangle {
      < 1.621617, 0.480000, -0.044292>,
      < 1.667625, 0.420813, -0.114615>,
      < 1.620650, 0.518830, -0.114615>
    }
    triangle {
      < 1.667625, 0.384000, -0.044292>,
      < 1.625600, 0.144000, -0.044292>,
      < 1.624716, 0.175770, -0.114615>
    }
    triangle {
      < 1.667625, 0.384000, -0.044292>,
      < 1.624716, 0.175770, -0.114615>,
      < 1.667625, 0.420813, -0.114615>
    }
    triangle {
      < 1.625600, 0.144000, -0.044292>,
      < 1.297600, -1.408000, -0.044292>,
      < 1.289825, -1.408841, -0.114615>
    }
    triangle {
      < 1.625600, 0.144000, -0.044292>,
      < 1.289825, -1.408841, -0.114615>,
      < 1.624716, 0.175770, -0.114615>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < -0.300640, -1.381333, -0.030305>,
      < -0.350672, -1.368000, -0.044292>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < -0.350672, -1.368000, -0.044292>,
      < -0.404046, -1.368000, -0.114615>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < -0.404046, -1.368000, -0.114615>,
      < 1.289825, -1.408841, -0.114615>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < 1.289825, -1.408841, -0.114615>,
      < 1.297600, -1.408000, -0.044292>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < 1.297600, -1.408000, -0.044292>,
      < 1.125798, -1.405102, -0.044292>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < 1.125798, -1.405102, -0.044292>,
      < 0.475977, -1.394139, -0.030305>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < 0.475977, -1.394139, -0.030305>,
      < 0.114115, -1.388035, -0.011655>
    }
    triangle {
      < -0.225137, -1.382295, -0.011655>,
      < 0.114115, -1.388035, -0.011655>,
      < -0.096081, -1.384488, -0.006993>
    }
    triangle {
      < -0.462992, -0.765600, -0.044292>,
      < -0.350672, -1.368000, -0.044292>,
      < -0.300640, -1.381333, -0.030305>
    }
    triangle {
      < -0.462992, -0.765600, -0.044292>,
      < -0.300640, -1.381333, -0.030305>,
      < -0.441985, -0.677600, -0.030305>
    }
    texture {fseat}
  }
  // bseat
  union {
    triangle {
      < 4.011121, 0.548839, -2.318152>,
      < 4.056026, 0.490409, -2.351752>,
      < 3.883232, 0.491614, -2.318152>
    }
    triangle {
      < 2.310423, -1.846814, -2.149752>,
      < 2.402448, -1.845804, -2.149752>,
      < 2.522855, -1.844482, -2.149752>
    }
    triangle {
      < 2.310423, -1.846814, -2.149752>,
      < 2.522855, -1.844482, -2.149752>,
      < 3.624801, -1.832000, -2.149752>
    }
    triangle {
      < 2.310423, -1.846814, -2.149752>,
      < 3.624801, -1.832000, -2.149752>,
      < 3.611769, -1.841750, -2.077352>
    }
    triangle {
      < 2.310423, -1.846814, -2.149752>,
      < 3.611769, -1.841750, -2.077352>,
      < 2.166532, -1.858086, -2.077352>
    }
    triangle {
      < 2.310423, -1.846814, -2.149752>,
      < 2.166532, -1.858086, -2.077352>,
      < 2.251997, -1.847456, -2.149752>
    }
    triangle {
      < 4.257186, -0.499095, -2.149752>,
      < 4.389499, -0.207939, -2.197752>,
      < 4.389287, -0.180291, -2.058646>
    }
    triangle {
      < 4.257186, -0.499095, -2.149752>,
      < 4.389287, -0.180291, -2.058646>,
      < 3.611769, -1.841750, -2.077352>
    }
    triangle {
      < 4.257186, -0.499095, -2.149752>,
      < 3.611769, -1.841750, -2.077352>,
      < 3.624801, -1.832000, -2.149752>
    }
    triangle {
      < 4.399747, 0.377859, -2.318152>,
      < 4.401617, 0.488000, -2.318152>,
      < 4.401617, 0.526998, -2.245752>
    }
    triangle {
      < 4.399747, 0.377859, -2.318152>,
      < 4.401617, 0.526998, -2.245752>,
      < 4.389499, -0.207939, -2.197752>
    }
    triangle {
      < 4.399747, 0.377859, -2.318152>,
      < 4.389499, -0.207939, -2.197752>,
      < 4.389600, -0.220000, -2.318152>
    }
    triangle {
      < 4.401617, 0.488000, -2.318152>,
      < 4.325600, 0.536000, -2.318152>,
      < 4.324324, 0.576007, -2.245752>
    }
    triangle {
      < 4.401617, 0.488000, -2.318152>,
      < 4.324324, 0.576007, -2.245752>,
      < 4.401617, 0.526998, -2.245752>
    }
    triangle {
      < 4.325600, 0.536000, -2.318152>,
      < 4.259746, 0.553561, -2.318152>,
      < 4.257366, 0.593937, -2.245752>
    }
    triangle {
      < 4.325600, 0.536000, -2.318152>,
      < 4.257366, 0.593937, -2.245752>,
      < 4.324324, 0.576007, -2.245752>
    }
    triangle {
      < 4.259746, 0.553561, -2.318152>,
      < 4.011121, 0.548839, -2.318152>,
      < 4.004570, 0.589115, -2.245752>
    }
    triangle {
      < 4.259746, 0.553561, -2.318152>,
      < 4.004570, 0.589115, -2.245752>,
      < 4.257366, 0.593937, -2.245752>
    }
    triangle {
      < 4.011121, 0.548839, -2.318152>,
      < 3.883232, 0.491614, -2.318152>,
      < 3.874535, 0.530688, -2.245752>
    }
    triangle {
      < 4.011121, 0.548839, -2.318152>,
      < 3.874535, 0.530688, -2.245752>,
      < 4.004570, 0.589115, -2.245752>
    }
    triangle {
      < 3.883232, 0.491614, -2.318152>,
      < 3.791552, 0.382871, -2.318152>,
      < 3.781318, 0.419660, -2.245752>
    }
    triangle {
      < 3.883232, 0.491614, -2.318152>,
      < 3.781318, 0.419660, -2.245752>,
      < 3.874535, 0.530688, -2.245752>
    }
    triangle {
      < 3.791552, 0.382871, -2.318152>,
      < 3.627673, -0.052210, -2.318152>,
      < 3.614690, -0.024563, -2.245752>
    }
    triangle {
      < 3.791552, 0.382871, -2.318152>,
      < 3.614690, -0.024563, -2.245752>,
      < 3.781318, 0.419660, -2.245752>
    }
    triangle {
      < 3.627673, -0.052210, -2.318152>,
      < 3.538874, -0.492210, -2.318152>,
      < 3.524401, -0.473808, -2.245752>
    }
    triangle {
      < 3.627673, -0.052210, -2.318152>,
      < 3.524401, -0.473808, -2.245752>,
      < 3.614690, -0.024563, -2.245752>
    }
    triangle {
      < 3.538874, -0.492210, -2.149752>,
      < 3.472934, -0.926993, -2.149752>,
      < 3.457355, -0.917727, -2.077352>
    }
    triangle {
      < 3.538874, -0.492210, -2.149752>,
      < 3.457355, -0.917727, -2.077352>,
      < 3.517043, -0.462198, -2.072952>
    }
    triangle {
      < 3.472934, -0.926993, -2.149752>,
      < 3.504321, -1.043538, -2.149752>,
      < 3.489269, -0.999964, -2.077352>
    }
    triangle {
      < 3.472934, -0.926993, -2.149752>,
      < 3.489269, -0.999964, -2.077352>,
      < 3.457355, -0.917727, -2.077352>
    }
    triangle {
      < 3.504321, -1.043538, -2.149752>,
      < 3.232000, -0.984000, -2.149752>,
      < 3.212380, -0.939175, -2.077352>
    }
    triangle {
      < 3.504321, -1.043538, -2.149752>,
      < 3.212380, -0.939175, -2.077352>,
      < 3.489269, -0.999964, -2.077352>
    }
    triangle {
      < 3.232000, -0.984000, -2.149752>,
      < 2.664000, -0.900000, -2.149752>,
      < 2.634852, -0.853410, -2.077352>
    }
    triangle {
      < 3.232000, -0.984000, -2.149752>,
      < 2.634852, -0.853410, -2.077352>,
      < 3.212380, -0.939175, -2.077352>
    }
    triangle {
      < 2.664000, -0.900000, -2.149752>,
      < 2.387997, -0.875456, -2.149752>,
      < 2.304813, -0.828906, -2.077352>
    }
    triangle {
      < 2.664000, -0.900000, -2.149752>,
      < 2.304813, -0.828906, -2.077352>,
      < 2.634852, -0.853410, -2.077352>
    }
    triangle {
      < 2.387997, -0.875456, -2.149752>,
      < 2.275997, -0.891456, -2.149752>,
      < 2.190935, -0.845242, -2.077352>
    }
    triangle {
      < 2.387997, -0.875456, -2.149752>,
      < 2.190935, -0.845242, -2.077352>,
      < 2.304813, -0.828906, -2.077352>
    }
    triangle {
      < 2.275997, -0.891456, -2.149752>,
      < 2.195997, -0.939456, -2.149752>,
      < 2.109592, -0.894251, -2.077352>
    }
    triangle {
      < 2.275997, -0.891456, -2.149752>,
      < 2.109592, -0.894251, -2.077352>,
      < 2.190935, -0.845242, -2.077352>
    }
    triangle {
      < 2.195997, -0.939456, -2.149752>,
      < 2.155997, -1.027456, -2.149752>,
      < 2.068922, -0.984100, -2.077352>
    }
    triangle {
      < 2.195997, -0.939456, -2.149752>,
      < 2.068922, -0.984100, -2.077352>,
      < 2.109592, -0.894251, -2.077352>
    }
    triangle {
      < 2.155997, -1.027456, -2.149752>,
      < 2.251997, -1.847456, -2.149752>,
      < 2.166532, -1.858086, -2.077352>
    }
    triangle {
      < 2.155997, -1.027456, -2.149752>,
      < 2.166532, -1.858086, -2.077352>,
      < 2.068922, -0.984100, -2.077352>
    }
    triangle {
      < 2.190935, -0.845242, -2.077352>,
      < 2.109592, -0.894251, -2.077352>,
      < 2.034539, -0.878083, -1.900152>
    }
    triangle {
      < 2.190935, -0.845242, -2.077352>,
      < 2.034539, -0.878083, -1.900152>,
      < 2.117246, -0.828252, -1.900152>
    }
    triangle {
      < 2.109592, -0.894251, -2.077352>,
      < 2.068922, -0.984100, -2.077352>,
      < 1.993187, -0.969439, -1.900152>
    }
    triangle {
      < 2.109592, -0.894251, -2.077352>,
      < 1.993187, -0.969439, -1.900152>,
      < 2.034539, -0.878083, -1.900152>
    }
    triangle {
      < 2.068922, -0.984100, -2.077352>,
      < 2.166532, -1.858086, -2.077352>,
      < 2.092434, -1.858086, -1.900152>
    }
    triangle {
      < 2.068922, -0.984100, -2.077352>,
      < 2.092434, -1.858086, -1.900152>,
      < 1.993187, -0.969439, -1.900152>
    }
    triangle {
      < 2.166532, -1.858086, -2.077352>,
      < 3.611769, -1.841750, -2.077352>,
      < 3.598520, -1.841476, -1.900152>
    }
    triangle {
      < 2.166532, -1.858086, -2.077352>,
      < 3.598520, -1.841476, -1.900152>,
      < 2.092434, -1.858086, -1.900152>
    }
    triangle {
      < 3.611769, -1.841750, -2.077352>,
      < 4.389287, -0.180291, -2.058646>,
      < 4.389192, -0.162058, -1.900152>
    }
    triangle {
      < 3.611769, -1.841750, -2.077352>,
      < 4.389192, -0.162058, -1.900152>,
      < 3.598520, -1.841476, -1.900152>
    }
    triangle {
      < 4.389499, -0.207939, -2.197752>,
      < 4.401617, 0.526998, -2.245752>,
      < 4.401617, 0.567007, -2.068552>
    }
    triangle {
      < 4.389499, -0.207939, -2.197752>,
      < 4.401617, 0.567007, -2.068552>,
      < 4.389287, -0.180291, -2.058646>
    }
    triangle {
      < 4.401617, 0.526998, -2.245752>,
      < 4.324324, 0.576007, -2.245752>,
      < 4.323027, 0.616838, -2.068552>
    }
    triangle {
      < 4.401617, 0.526998, -2.245752>,
      < 4.323027, 0.616838, -2.068552>,
      < 4.401617, 0.567007, -2.068552>
    }
    triangle {
      < 4.324324, 0.576007, -2.245752>,
      < 4.257366, 0.593937, -2.245752>,
      < 4.254946, 0.635069, -2.068552>
    }
    triangle {
      < 4.324324, 0.576007, -2.245752>,
      < 4.254946, 0.635069, -2.068552>,
      < 4.323027, 0.616838, -2.068552>
    }
    triangle {
      < 4.257366, 0.593937, -2.245752>,
      < 4.004570, 0.589115, -2.245752>,
      < 3.997909, 0.630166, -2.068552>
    }
    triangle {
      < 4.257366, 0.593937, -2.245752>,
      < 3.997909, 0.630166, -2.068552>,
      < 4.254946, 0.635069, -2.068552>
    }
    triangle {
      < 4.004570, 0.589115, -2.245752>,
      < 3.874535, 0.530688, -2.245752>,
      < 3.865693, 0.570759, -2.068552>
    }
    triangle {
      < 4.004570, 0.589115, -2.245752>,
      < 3.865693, 0.570759, -2.068552>,
      < 3.997909, 0.630166, -2.068552>
    }
    triangle {
      < 3.874535, 0.530688, -2.245752>,
      < 3.781318, 0.419660, -2.245752>,
      < 3.770912, 0.457868, -2.068552>
    }
    triangle {
      < 3.874535, 0.530688, -2.245752>,
      < 3.770912, 0.457868, -2.068552>,
      < 3.865693, 0.570759, -2.068552>
    }
    triangle {
      < 3.781318, 0.419660, -2.245752>,
      < 3.614690, -0.024563, -2.245752>,
      < 3.601489, 0.006194, -2.068552>
    }
    triangle {
      < 3.781318, 0.419660, -2.245752>,
      < 3.601489, 0.006194, -2.068552>,
      < 3.770912, 0.457868, -2.068552>
    }
    triangle {
      < 3.614690, -0.024563, -2.245752>,
      < 3.524401, -0.473808, -2.245752>,
      < 3.517043, -0.462198, -2.072952>
    }
    triangle {
      < 3.614690, -0.024563, -2.245752>,
      < 3.517043, -0.462198, -2.072952>,
      < 3.601489, 0.006194, -2.068552>
    }
    triangle {
      < 3.517043, -0.462198, -2.072952>,
      < 3.457355, -0.917727, -2.077352>,
      < 3.441515, -0.901953, -1.900152>
    }
    triangle {
      < 3.517043, -0.462198, -2.072952>,
      < 3.441515, -0.901953, -1.900152>,
      < 3.509686, -0.450587, -1.900152>
    }
    triangle {
      < 3.457355, -0.917727, -2.077352>,
      < 3.489269, -0.999964, -2.077352>,
      < 3.473964, -0.985569, -1.900152>
    }
    triangle {
      < 3.457355, -0.917727, -2.077352>,
      < 3.473964, -0.985569, -1.900152>,
      < 3.441515, -0.901953, -1.900152>
    }
    triangle {
      < 3.489269, -0.999964, -2.077352>,
      < 3.212380, -0.939175, -2.077352>,
      < 3.192430, -0.923761, -1.900152>
    }
    triangle {
      < 3.489269, -0.999964, -2.077352>,
      < 3.192430, -0.923761, -1.900152>,
      < 3.473964, -0.985569, -1.900152>
    }
    triangle {
      < 3.212380, -0.939175, -2.077352>,
      < 2.634852, -0.853410, -2.077352>,
      < 2.605214, -0.836557, -1.900152>
    }
    triangle {
      < 3.212380, -0.939175, -2.077352>,
      < 2.605214, -0.836557, -1.900152>,
      < 3.192430, -0.923761, -1.900152>
    }
    triangle {
      < 2.634852, -0.853410, -2.077352>,
      < 2.304813, -0.828906, -2.077352>,
      < 2.233035, -0.811642, -1.900152>
    }
    triangle {
      < 2.634852, -0.853410, -2.077352>,
      < 2.233035, -0.811642, -1.900152>,
      < 2.605214, -0.836557, -1.900152>
    }
    triangle {
      < 2.304813, -0.828906, -2.077352>,
      < 2.190935, -0.845242, -2.077352>,
      < 2.117246, -0.828252, -1.900152>
    }
    triangle {
      < 2.304813, -0.828906, -2.077352>,
      < 2.117246, -0.828252, -1.900152>,
      < 2.233035, -0.811642, -1.900152>
    }
    triangle {
      < 3.192430, -0.923761, -1.900152>,
      < 2.605214, -0.836557, -1.900152>,
      < 2.590867, -0.823732, -1.718557>
    }
    triangle {
      < 3.192430, -0.923761, -1.900152>,
      < 2.590867, -0.823732, -1.718557>,
      < 3.182987, -0.912031, -1.718557>
    }
    triangle {
      < 2.605214, -0.836557, -1.900152>,
      < 2.233035, -0.811642, -1.900152>,
      < 2.215579, -0.798504, -1.718557>
    }
    triangle {
      < 2.605214, -0.836557, -1.900152>,
      < 2.215579, -0.798504, -1.718557>,
      < 2.590867, -0.823732, -1.718557>
    }
    triangle {
      < 2.233035, -0.811642, -1.900152>,
      < 2.117246, -0.828252, -1.900152>,
      < 2.098823, -0.815323, -1.718557>
    }
    triangle {
      < 2.233035, -0.811642, -1.900152>,
      < 2.098823, -0.815323, -1.718557>,
      < 2.215579, -0.798504, -1.718557>
    }
    triangle {
      < 2.117246, -0.828252, -1.900152>,
      < 2.034539, -0.878083, -1.900152>,
      < 2.015425, -0.865779, -1.718557>
    }
    triangle {
      < 2.117246, -0.828252, -1.900152>,
      < 2.015425, -0.865779, -1.718557>,
      < 2.098823, -0.815323, -1.718557>
    }
    triangle {
      < 2.034539, -0.878083, -1.900152>,
      < 1.993187, -0.969439, -1.900152>,
      < 1.973727, -0.958282, -1.718557>
    }
    triangle {
      < 2.034539, -0.878083, -1.900152>,
      < 1.973727, -0.958282, -1.718557>,
      < 2.015425, -0.865779, -1.718557>
    }
    triangle {
      < 1.993187, -0.969439, -1.900152>,
      < 2.092434, -1.858086, -1.900152>,
      < 2.073804, -1.858086, -1.718557>
    }
    triangle {
      < 1.993187, -0.969439, -1.900152>,
      < 2.073804, -1.858086, -1.718557>,
      < 1.973727, -0.958282, -1.718557>
    }
    triangle {
      < 2.092434, -1.858086, -1.900152>,
      < 3.598520, -1.841476, -1.900152>,
      < 3.592469, -1.841267, -1.718557>
    }
    triangle {
      < 2.092434, -1.858086, -1.900152>,
      < 3.592469, -1.841267, -1.718557>,
      < 2.073804, -1.858086, -1.718557>
    }
    triangle {
      < 3.598520, -1.841476, -1.900152>,
      < 4.389192, -0.162058, -1.900152>,
      < 4.389745, -0.145584, -1.718557>
    }
    triangle {
      < 3.598520, -1.841476, -1.900152>,
      < 4.389745, -0.145584, -1.718557>,
      < 3.592469, -1.841267, -1.718557>
    }
    triangle {
      < 4.389192, -0.162058, -1.900152>,
      < 4.401617, 0.592719, -1.900152>,
      < 4.402273, 0.610390, -1.718557>
    }
    triangle {
      < 4.389192, -0.162058, -1.900152>,
      < 4.402273, 0.610390, -1.718557>,
      < 4.389745, -0.145584, -1.718557>
    }
    triangle {
      < 4.401617, 0.592719, -1.900152>,
      < 4.323027, 0.643809, -1.900152>,
      < 4.323027, 0.661479, -1.718557>
    }
    triangle {
      < 4.401617, 0.592719, -1.900152>,
      < 4.323027, 0.661479, -1.718557>,
      < 4.402273, 0.610390, -1.718557>
    }
    triangle {
      < 4.323027, 0.643809, -1.900152>,
      < 4.254946, 0.662500, -1.900152>,
      < 4.254377, 0.680171, -1.718557>
    }
    triangle {
      < 4.323027, 0.643809, -1.900152>,
      < 4.254377, 0.680171, -1.718557>,
      < 4.323027, 0.661479, -1.718557>
    }
    triangle {
      < 4.254946, 0.662500, -1.900152>,
      < 3.997909, 0.657474, -1.900152>,
      < 3.995193, 0.675144, -1.718557>
    }
    triangle {
      < 4.254946, 0.662500, -1.900152>,
      < 3.995193, 0.675144, -1.718557>,
      < 4.254377, 0.680171, -1.718557>
    }
    triangle {
      < 3.997909, 0.657474, -1.900152>,
      < 3.865693, 0.596565, -1.900152>,
      < 3.861873, 0.614236, -1.718557>
    }
    triangle {
      < 3.997909, 0.657474, -1.900152>,
      < 3.861873, 0.614236, -1.718557>,
      < 3.995193, 0.675144, -1.718557>
    }
    triangle {
      < 3.865693, 0.596565, -1.900152>,
      < 3.770912, 0.480823, -1.900152>,
      < 3.766301, 0.498493, -1.718557>
    }
    triangle {
      < 3.865693, 0.596565, -1.900152>,
      < 3.766301, 0.498493, -1.718557>,
      < 3.861873, 0.614236, -1.718557>
    }
    triangle {
      < 3.770912, 0.480823, -1.900152>,
      < 3.601489, 0.017736, -1.900152>,
      < 3.595463, 0.035406, -1.718557>
    }
    triangle {
      < 3.770912, 0.480823, -1.900152>,
      < 3.595463, 0.035406, -1.718557>,
      < 3.766301, 0.498493, -1.718557>
    }
    triangle {
      < 3.601489, 0.017736, -1.900152>,
      < 3.509686, -0.450587, -1.900152>,
      < 3.502892, -0.432917, -1.718557>
    }
    triangle {
      < 3.601489, 0.017736, -1.900152>,
      < 3.502892, -0.432917, -1.718557>,
      < 3.595463, 0.035406, -1.718557>
    }
    triangle {
      < 3.509686, -0.450587, -1.900152>,
      < 3.441515, -0.901953, -1.900152>,
      < 3.434152, -0.889949, -1.718557>
    }
    triangle {
      < 3.509686, -0.450587, -1.900152>,
      < 3.434152, -0.889949, -1.718557>,
      < 3.502892, -0.432917, -1.718557>
    }
    triangle {
      < 3.441515, -0.901953, -1.900152>,
      < 3.473964, -0.985569, -1.900152>,
      < 3.466872, -0.974615, -1.718557>
    }
    triangle {
      < 3.441515, -0.901953, -1.900152>,
      < 3.466872, -0.974615, -1.718557>,
      < 3.434152, -0.889949, -1.718557>
    }
    triangle {
      < 3.473964, -0.985569, -1.900152>,
      < 3.192430, -0.923761, -1.900152>,
      < 3.182987, -0.912031, -1.718557>
    }
    triangle {
      < 3.473964, -0.985569, -1.900152>,
      < 3.182987, -0.912031, -1.718557>,
      < 3.466872, -0.974615, -1.718557>
    }
    triangle {
      < 3.502892, -0.432917, -1.718557>,
      < 3.434152, -0.889949, -1.718557>,
      < 3.420393, -0.869959, -1.175757>
    }
    triangle {
      < 3.502892, -0.432917, -1.718557>,
      < 3.420393, -0.869959, -1.175757>,
      < 3.490286, -0.403324, -1.175757>
    }
    triangle {
      < 3.434152, -0.889949, -1.718557>,
      < 3.466872, -0.974615, -1.718557>,
      < 3.453663, -0.956405, -1.175757>
    }
    triangle {
      < 3.434152, -0.889949, -1.718557>,
      < 3.453663, -0.956405, -1.175757>,
      < 3.420393, -0.869959, -1.175757>
    }
    triangle {
      < 3.466872, -0.974615, -1.718557>,
      < 3.182987, -0.912031, -1.718557>,
      < 3.165015, -0.892505, -1.175757>
    }
    triangle {
      < 3.466872, -0.974615, -1.718557>,
      < 3.165015, -0.892505, -1.175757>,
      < 3.453663, -0.956405, -1.175757>
    }
    triangle {
      < 3.182987, -0.912031, -1.718557>,
      < 2.590867, -0.823732, -1.718557>,
      < 2.562962, -0.802351, -1.175757>
    }
    triangle {
      < 3.182987, -0.912031, -1.718557>,
      < 2.562962, -0.802351, -1.175757>,
      < 3.165015, -0.892505, -1.175757>
    }
    triangle {
      < 2.590867, -0.823732, -1.718557>,
      < 2.215579, -0.798504, -1.718557>,
      < 2.181378, -0.776593, -1.175757>
    }
    triangle {
      < 2.590867, -0.823732, -1.718557>,
      < 2.181378, -0.776593, -1.175757>,
      < 2.562962, -0.802351, -1.175757>
    }
    triangle {
      < 2.215579, -0.798504, -1.718557>,
      < 2.098823, -0.815323, -1.718557>,
      < 2.062664, -0.793765, -1.175757>
    }
    triangle {
      < 2.215579, -0.798504, -1.718557>,
      < 2.062664, -0.793765, -1.175757>,
      < 2.181378, -0.776593, -1.175757>
    }
    triangle {
      < 2.098823, -0.815323, -1.718557>,
      < 2.015425, -0.865779, -1.718557>,
      < 1.977867, -0.845282, -1.175757>
    }
    triangle {
      < 2.098823, -0.815323, -1.718557>,
      < 1.977867, -0.845282, -1.175757>,
      < 2.062664, -0.793765, -1.175757>
    }
    triangle {
      < 2.015425, -0.865779, -1.718557>,
      < 1.973727, -0.958282, -1.718557>,
      < 1.935470, -0.939729, -1.175757>
    }
    triangle {
      < 2.015425, -0.865779, -1.718557>,
      < 1.935470, -0.939729, -1.175757>,
      < 1.977867, -0.845282, -1.175757>
    }
    triangle {
      < 1.973727, -0.958282, -1.718557>,
      < 2.073804, -1.858086, -1.718557>,
      < 2.037225, -1.858439, -1.175757>
    }
    triangle {
      < 1.973727, -0.958282, -1.718557>,
      < 2.037225, -1.858439, -1.175757>,
      < 1.935470, -0.939729, -1.175757>
    }
    triangle {
      < 2.073804, -1.858086, -1.718557>,
      < 3.592469, -1.841267, -1.718557>,
      < 3.581366, -1.841267, -1.175757>
    }
    triangle {
      < 2.073804, -1.858086, -1.718557>,
      < 3.581366, -1.841267, -1.175757>,
      < 2.037225, -1.858439, -1.175757>
    }
    triangle {
      < 3.592469, -1.841267, -1.718557>,
      < 4.389745, -0.145584, -1.718557>,
      < 4.392016, -0.111172, -1.175757>
    }
    triangle {
      < 3.592469, -1.841267, -1.718557>,
      < 4.392016, -0.111172, -1.175757>,
      < 3.581366, -1.841267, -1.175757>
    }
    triangle {
      < 4.389745, -0.145584, -1.718557>,
      < 4.402273, 0.610390, -1.718557>,
      < 4.404754, 0.648696, -1.175757>
    }
    triangle {
      < 4.389745, -0.145584, -1.718557>,
      < 4.404754, 0.648696, -1.175757>,
      < 4.392016, -0.111172, -1.175757>
    }
    triangle {
      < 4.402273, 0.610390, -1.718557>,
      < 4.323027, 0.661479, -1.718557>,
      < 4.324178, 0.700213, -1.175757>
    }
    triangle {
      < 4.402273, 0.610390, -1.718557>,
      < 4.324178, 0.700213, -1.175757>,
      < 4.404754, 0.648696, -1.175757>
    }
    triangle {
      < 4.323027, 0.661479, -1.718557>,
      < 4.254377, 0.680171, -1.718557>,
      < 4.254377, 0.719060, -1.175757>
    }
    triangle {
      < 4.323027, 0.661479, -1.718557>,
      < 4.254377, 0.719060, -1.175757>,
      < 4.324178, 0.700213, -1.175757>
    }
    triangle {
      < 4.254377, 0.680171, -1.718557>,
      < 3.995193, 0.675144, -1.718557>,
      < 3.990846, 0.713992, -1.175757>
    }
    triangle {
      < 4.254377, 0.680171, -1.718557>,
      < 3.990846, 0.713992, -1.175757>,
      < 4.254377, 0.719060, -1.175757>
    }
    triangle {
      < 3.995193, 0.675144, -1.718557>,
      < 3.861873, 0.614236, -1.718557>,
      < 3.855289, 0.652575, -1.175757>
    }
    triangle {
      < 3.995193, 0.675144, -1.718557>,
      < 3.855289, 0.652575, -1.175757>,
      < 3.990846, 0.713992, -1.175757>
    }
    triangle {
      < 3.861873, 0.614236, -1.718557>,
      < 3.766301, 0.498493, -1.718557>,
      < 3.758114, 0.535865, -1.175757>
    }
    triangle {
      < 3.861873, 0.614236, -1.718557>,
      < 3.758114, 0.535865, -1.175757>,
      < 3.855289, 0.652575, -1.175757>
    }
    triangle {
      < 3.766301, 0.498493, -1.718557>,
      < 3.595463, 0.035406, -1.718557>,
      < 3.584409, 0.068910, -1.175757>
    }
    triangle {
      < 3.766301, 0.498493, -1.718557>,
      < 3.584409, 0.068910, -1.175757>,
      < 3.758114, 0.535865, -1.175757>
    }
    triangle {
      < 3.595463, 0.035406, -1.718557>,
      < 3.502892, -0.432917, -1.718557>,
      < 3.490286, -0.403324, -1.175757>
    }
    triangle {
      < 3.595463, 0.035406, -1.718557>,
      < 3.490286, -0.403324, -1.175757>,
      < 3.584409, 0.068910, -1.175757>
    }
    triangle {
      < 3.855289, 0.652575, -1.175757>,
      < 3.758114, 0.535865, -1.175757>,
      < 3.752712, 0.565926, -0.343357>
    }
    triangle {
      < 3.855289, 0.652575, -1.175757>,
      < 3.752712, 0.565926, -0.343357>,
      < 3.850700, 0.684100, -0.343357>
    }
    triangle {
      < 3.758114, 0.535865, -1.175757>,
      < 3.584409, 0.068910, -1.175757>,
      < 3.577557, 0.093108, -0.343357>
    }
    triangle {
      < 3.758114, 0.535865, -1.175757>,
      < 3.577557, 0.093108, -0.343357>,
      < 3.752712, 0.565926, -0.343357>
    }
    triangle {
      < 3.584409, 0.068910, -1.175757>,
      < 3.490286, -0.403324, -1.175757>,
      < 3.482648, -0.385055, -0.343357>
    }
    triangle {
      < 3.584409, 0.068910, -1.175757>,
      < 3.482648, -0.385055, -0.343357>,
      < 3.577557, 0.093108, -0.343357>
    }
    triangle {
      < 3.490286, -0.403324, -1.175757>,
      < 3.420393, -0.869959, -1.175757>,
      < 3.412172, -0.857549, -0.343357>
    }
    triangle {
      < 3.490286, -0.403324, -1.175757>,
      < 3.412172, -0.857549, -0.343357>,
      < 3.482648, -0.385055, -0.343357>
    }
    triangle {
      < 3.420393, -0.869959, -1.175757>,
      < 3.453663, -0.956405, -1.175757>,
      < 3.445719, -0.945080, -0.343357>
    }
    triangle {
      < 3.420393, -0.869959, -1.175757>,
      < 3.445719, -0.945080, -0.343357>,
      < 3.412172, -0.857549, -0.343357>
    }
    triangle {
      < 3.453663, -0.956405, -1.175757>,
      < 3.165015, -0.892505, -1.175757>,
      < 3.154660, -0.880378, -0.343357>
    }
    triangle {
      < 3.453663, -0.956405, -1.175757>,
      < 3.154660, -0.880378, -0.343357>,
      < 3.445719, -0.945080, -0.343357>
    }
    triangle {
      < 3.165015, -0.892505, -1.175757>,
      < 2.562962, -0.802351, -1.175757>,
      < 2.547578, -0.789092, -0.343357>
    }
    triangle {
      < 3.165015, -0.892505, -1.175757>,
      < 2.547578, -0.789092, -0.343357>,
      < 3.154660, -0.880378, -0.343357>
    }
    triangle {
      < 2.562962, -0.802351, -1.175757>,
      < 2.181378, -0.776593, -1.175757>,
      < 2.162808, -0.763011, -0.343357>
    }
    triangle {
      < 2.562962, -0.802351, -1.175757>,
      < 2.162808, -0.763011, -0.343357>,
      < 2.547578, -0.789092, -0.343357>
    }
    triangle {
      < 2.181378, -0.776593, -1.175757>,
      < 2.062664, -0.793765, -1.175757>,
      < 2.043102, -0.780399, -0.343357>
    }
    triangle {
      < 2.181378, -0.776593, -1.175757>,
      < 2.043102, -0.780399, -0.343357>,
      < 2.162808, -0.763011, -0.343357>
    }
    triangle {
      < 2.062664, -0.793765, -1.175757>,
      < 1.977867, -0.845282, -1.175757>,
      < 1.957596, -0.832562, -0.343357>
    }
    triangle {
      < 2.062664, -0.793765, -1.175757>,
      < 1.957596, -0.832562, -0.343357>,
      < 2.043102, -0.780399, -0.343357>
    }
    triangle {
      < 1.977867, -0.845282, -1.175757>,
      < 1.935470, -0.939729, -1.175757>,
      < 1.914845, -0.928194, -0.343357>
    }
    triangle {
      < 1.977867, -0.845282, -1.175757>,
      < 1.914845, -0.928194, -0.343357>,
      < 1.957596, -0.832562, -0.343357>
    }
    triangle {
      < 1.935470, -0.939729, -1.175757>,
      < 2.037225, -1.858439, -1.175757>,
      < 2.017450, -1.858439, -0.343357>
    }
    triangle {
      < 1.935470, -0.939729, -1.175757>,
      < 2.017450, -1.858439, -0.343357>,
      < 1.914845, -0.928194, -0.343357>
    }
    triangle {
      < 2.037225, -1.858439, -1.175757>,
      < 3.581366, -1.841267, -1.175757>,
      < 3.574488, -1.841052, -0.343357>
    }
    triangle {
      < 2.037225, -1.858439, -1.175757>,
      < 3.574488, -1.841052, -0.343357>,
      < 2.017450, -1.858439, -0.343357>
    }
    triangle {
      < 3.581366, -1.841267, -1.175757>,
      < 4.392016, -0.111172, -1.175757>,
      < 4.391910, -0.089235, -0.343357>
    }
    triangle {
      < 3.581366, -1.841267, -1.175757>,
      < 4.391910, -0.089235, -0.343357>,
      < 3.574488, -1.841052, -0.343357>
    }
    triangle {
      < 4.392016, -0.111172, -1.175757>,
      < 4.404754, 0.648696, -1.175757>,
      < 4.404754, 0.680173, -0.343357>
    }
    triangle {
      < 4.392016, -0.111172, -1.175757>,
      < 4.404754, 0.680173, -0.343357>,
      < 4.391910, -0.089235, -0.343357>
    }
    triangle {
      < 4.404754, 0.648696, -1.175757>,
      < 4.324178, 0.700213, -1.175757>,
      < 4.323505, 0.732336, -0.343357>
    }
    triangle {
      < 4.404754, 0.648696, -1.175757>,
      < 4.323505, 0.732336, -0.343357>,
      < 4.404754, 0.680173, -0.343357>
    }
    triangle {
      < 4.324178, 0.700213, -1.175757>,
      < 4.254377, 0.719060, -1.175757>,
      < 4.253121, 0.751420, -0.343357>
    }
    triangle {
      < 4.324178, 0.700213, -1.175757>,
      < 4.253121, 0.751420, -0.343357>,
      < 4.323505, 0.732336, -0.343357>
    }
    triangle {
      < 4.254377, 0.719060, -1.175757>,
      < 3.990846, 0.713992, -1.175757>,
      < 3.987389, 0.746288, -0.343357>
    }
    triangle {
      < 4.254377, 0.719060, -1.175757>,
      < 3.987389, 0.746288, -0.343357>,
      < 4.253121, 0.751420, -0.343357>
    }
    triangle {
      < 3.990846, 0.713992, -1.175757>,
      < 3.855289, 0.652575, -1.175757>,
      < 3.850700, 0.684100, -0.343357>
    }
    triangle {
      < 3.990846, 0.713992, -1.175757>,
      < 3.850700, 0.684100, -0.343357>,
      < 3.987389, 0.746288, -0.343357>
    }
    triangle {
      < 4.323505, 0.732336, -0.343357>,
      < 4.253121, 0.751420, -0.343357>,
      < 4.253121, 0.751420, 0.000000>
    }
    triangle {
      < 4.323505, 0.732336, -0.343357>,
      < 4.253121, 0.751420, 0.000000>,
      < 4.323505, 0.732336, 0.000000>
    }
    triangle {
      < 4.253121, 0.751420, -0.343357>,
      < 3.987389, 0.746288, -0.343357>,
      < 3.987389, 0.746288, 0.000000>
    }
    triangle {
      < 4.253121, 0.751420, -0.343357>,
      < 3.987389, 0.746288, 0.000000>,
      < 4.253121, 0.751420, 0.000000>
    }
    triangle {
      < 3.987389, 0.746288, -0.343357>,
      < 3.850700, 0.684100, -0.343357>,
      < 3.850700, 0.684100, 0.000000>
    }
    triangle {
      < 3.987389, 0.746288, -0.343357>,
      < 3.850700, 0.684100, 0.000000>,
      < 3.987389, 0.746288, 0.000000>
    }
    triangle {
      < 3.850700, 0.684100, -0.343357>,
      < 3.752712, 0.565926, -0.343357>,
      < 3.752712, 0.565926, 0.000000>
    }
    triangle {
      < 3.850700, 0.684100, -0.343357>,
      < 3.752712, 0.565926, 0.000000>,
      < 3.850700, 0.684100, 0.000000>
    }
    triangle {
      < 3.752712, 0.565926, -0.343357>,
      < 3.577557, 0.093108, -0.343357>,
      < 3.577557, 0.093108, 0.000000>
    }
    triangle {
      < 3.752712, 0.565926, -0.343357>,
      < 3.577557, 0.093108, 0.000000>,
      < 3.752712, 0.565926, 0.000000>
    }
    triangle {
      < 3.577557, 0.093108, -0.343357>,
      < 3.482648, -0.385055, -0.343357>,
      < 3.482648, -0.385055, 0.000000>
    }
    triangle {
      < 3.577557, 0.093108, -0.343357>,
      < 3.482648, -0.385055, 0.000000>,
      < 3.577557, 0.093108, 0.000000>
    }
    triangle {
      < 3.482648, -0.385055, -0.343357>,
      < 3.412172, -0.857549, -0.343357>,
      < 3.412172, -0.857549, 0.000000>
    }
    triangle {
      < 3.482648, -0.385055, -0.343357>,
      < 3.412172, -0.857549, 0.000000>,
      < 3.482648, -0.385055, 0.000000>
    }
    triangle {
      < 3.412172, -0.857549, -0.343357>,
      < 3.445719, -0.945080, -0.343357>,
      < 3.445719, -0.945080, 0.000000>
    }
    triangle {
      < 3.412172, -0.857549, -0.343357>,
      < 3.445719, -0.945080, 0.000000>,
      < 3.412172, -0.857549, 0.000000>
    }
    triangle {
      < 3.445719, -0.945080, -0.343357>,
      < 3.154660, -0.880378, -0.343357>,
      < 3.154660, -0.880378, 0.000000>
    }
    triangle {
      < 3.445719, -0.945080, -0.343357>,
      < 3.154660, -0.880378, 0.000000>,
      < 3.445719, -0.945080, 0.000000>
    }
    triangle {
      < 3.154660, -0.880378, -0.343357>,
      < 2.547578, -0.789092, -0.343357>,
      < 2.547578, -0.789092, 0.000000>
    }
    triangle {
      < 3.154660, -0.880378, -0.343357>,
      < 2.547578, -0.789092, 0.000000>,
      < 3.154660, -0.880378, 0.000000>
    }
    triangle {
      < 2.547578, -0.789092, -0.343357>,
      < 2.162808, -0.763011, -0.343357>,
      < 2.162808, -0.763011, 0.000000>
    }
    triangle {
      < 2.547578, -0.789092, -0.343357>,
      < 2.162808, -0.763011, 0.000000>,
      < 2.547578, -0.789092, 0.000000>
    }
    triangle {
      < 2.162808, -0.763011, -0.343357>,
      < 2.043102, -0.780399, -0.343357>,
      < 2.043102, -0.780399, 0.000000>
    }
    triangle {
      < 2.162808, -0.763011, -0.343357>,
      < 2.043102, -0.780399, 0.000000>,
      < 2.162808, -0.763011, 0.000000>
    }
    triangle {
      < 2.043102, -0.780399, -0.343357>,
      < 1.957596, -0.832562, -0.343357>,
      < 1.957596, -0.832562, 0.004243>
    }
    triangle {
      < 2.043102, -0.780399, -0.343357>,
      < 1.957596, -0.832562, 0.004243>,
      < 2.043102, -0.780399, 0.000000>
    }
    triangle {
      < 1.957596, -0.832562, -0.343357>,
      < 1.914845, -0.928194, -0.343357>,
      < 1.914845, -0.928194, 0.004243>
    }
    triangle {
      < 1.957596, -0.832562, -0.343357>,
      < 1.914845, -0.928194, 0.004243>,
      < 1.957596, -0.832562, 0.004243>
    }
    triangle {
      < 1.914845, -0.928194, -0.343357>,
      < 2.017450, -1.858439, -0.343357>,
      < 2.017450, -1.858439, 0.004243>
    }
    triangle {
      < 1.914845, -0.928194, -0.343357>,
      < 2.017450, -1.858439, 0.004243>,
      < 1.914845, -0.928194, 0.004243>
    }
    triangle {
      < 2.017450, -1.858439, -0.343357>,
      < 3.574488, -1.841052, -0.343357>,
      < 3.574488, -1.841052, 0.000000>
    }
    triangle {
      < 2.017450, -1.858439, -0.343357>,
      < 3.574488, -1.841052, 0.000000>,
      < 2.017450, -1.858439, 0.004243>
    }
    triangle {
      < 3.574488, -1.841052, -0.343357>,
      < 4.391910, -0.089235, -0.343357>,
      < 4.391910, -0.089235, 0.000000>
    }
    triangle {
      < 3.574488, -1.841052, -0.343357>,
      < 4.391910, -0.089235, 0.000000>,
      < 3.574488, -1.841052, 0.000000>
    }
    triangle {
      < 4.391910, -0.089235, -0.343357>,
      < 4.404754, 0.680173, -0.343357>,
      < 4.404754, 0.680173, 0.000000>
    }
    triangle {
      < 4.391910, -0.089235, -0.343357>,
      < 4.404754, 0.680173, 0.000000>,
      < 4.391910, -0.089235, 0.000000>
    }
    triangle {
      < 4.404754, 0.680173, -0.343357>,
      < 4.323505, 0.732336, -0.343357>,
      < 4.323505, 0.732336, 0.000000>
    }
    triangle {
      < 4.404754, 0.680173, -0.343357>,
      < 4.323505, 0.732336, 0.000000>,
      < 4.404754, 0.680173, 0.000000>
    }
    triangle {
      < 2.195997, -0.939456, -2.149752>,
      < 2.310423, -1.846814, -2.149752>,
      < 2.251997, -1.847456, -2.149752>
    }
    triangle {
      < 2.195997, -0.939456, -2.149752>,
      < 2.251997, -1.847456, -2.149752>,
      < 2.155997, -1.027456, -2.149752>
    }
    triangle {
      < 4.056026, 0.490409, -2.351752>,
      < 3.994283, 0.381200, -2.351752>,
      < 3.791552, 0.382871, -2.318152>
    }
    triangle {
      < 4.056026, 0.490409, -2.351752>,
      < 3.791552, 0.382871, -2.318152>,
      < 3.883232, 0.491614, -2.318152>
    }
    triangle {
      < 3.994283, 0.381200, -2.351752>,
      < 3.881649, -0.108140, -2.351752>,
      < 3.627673, -0.052210, -2.318152>
    }
    triangle {
      < 3.994283, 0.381200, -2.351752>,
      < 3.627673, -0.052210, -2.318152>,
      < 3.791552, 0.382871, -2.318152>
    }
    triangle {
      < 3.768705, -0.501479, -2.183352>,
      < 3.544481, -1.282359, -2.183352>,
      < 3.504321, -1.043538, -2.149752>
    }
    triangle {
      < 3.768705, -0.501479, -2.183352>,
      < 3.504321, -1.043538, -2.149752>,
      < 3.472934, -0.926993, -2.149752>
    }
    triangle {
      < 3.768705, -0.501479, -2.183352>,
      < 3.472934, -0.926993, -2.149752>,
      < 3.538874, -0.492210, -2.149752>
    }
    triangle {
      < 4.056026, 0.490409, -2.351752>,
      < 4.011121, 0.548839, -2.318152>,
      < 4.259746, 0.553561, -2.318152>
    }
    triangle {
      < 4.056026, 0.490409, -2.351752>,
      < 4.259746, 0.553561, -2.318152>,
      < 4.228822, 0.489205, -2.351752>
    }
    triangle {
      < 3.994283, 0.381200, -2.351752>,
      < 4.056026, 0.490409, -2.351752>,
      < 4.228822, 0.489205, -2.351752>
    }
    triangle {
      < 3.994283, 0.381200, -2.351752>,
      < 4.228822, 0.489205, -2.351752>,
      < 4.197015, 0.379530, -2.351752>
    }
    triangle {
      < 3.881649, -0.108140, -2.351752>,
      < 3.994283, 0.381200, -2.351752>,
      < 4.197015, 0.379530, -2.351752>
    }
    triangle {
      < 3.881649, -0.108140, -2.351752>,
      < 4.197015, 0.379530, -2.351752>,
      < 4.135624, -0.164070, -2.351752>
    }
    triangle {
      < 3.544481, -1.282359, -2.183352>,
      < 3.768705, -0.501479, -2.183352>,
      < 4.004011, -0.496844, -2.183352>
    }
    triangle {
      < 3.544481, -1.282359, -2.183352>,
      < 4.004011, -0.496844, -2.183352>,
      < 3.584641, -1.557180, -2.183352>
    }
    triangle {
      < 4.228822, 0.489205, -2.351752>,
      < 4.259746, 0.553561, -2.318152>,
      < 4.325600, 0.536000, -2.318152>
    }
    triangle {
      < 4.228822, 0.489205, -2.351752>,
      < 4.325600, 0.536000, -2.318152>,
      < 4.401617, 0.488000, -2.318152>
    }
    triangle {
      < 4.197015, 0.379530, -2.351752>,
      < 4.228822, 0.489205, -2.351752>,
      < 4.401617, 0.488000, -2.318152>
    }
    triangle {
      < 4.197015, 0.379530, -2.351752>,
      < 4.401617, 0.488000, -2.318152>,
      < 4.399747, 0.377859, -2.318152>
    }
    triangle {
      < 4.135624, -0.164070, -2.351752>,
      < 4.197015, 0.379530, -2.351752>,
      < 4.399747, 0.377859, -2.318152>
    }
    triangle {
      < 4.135624, -0.164070, -2.351752>,
      < 4.399747, 0.377859, -2.318152>,
      < 4.389600, -0.220000, -2.318152>
    }
    triangle {
      < 3.584641, -1.557180, -2.183352>,
      < 4.004011, -0.496844, -2.183352>,
      < 4.257186, -0.499095, -2.149752>
    }
    triangle {
      < 3.584641, -1.557180, -2.183352>,
      < 4.257186, -0.499095, -2.149752>,
      < 3.624801, -1.832000, -2.149752>
    }
    triangle {
      < 3.768705, -0.501479, -2.351752>,
      < 3.538874, -0.492210, -2.318152>,
      < 3.627673, -0.052210, -2.318152>
    }
    triangle {
      < 3.768705, -0.501479, -2.351752>,
      < 3.627673, -0.052210, -2.318152>,
      < 3.881649, -0.108140, -2.351752>
    }
    triangle {
      < 4.004011, -0.496844, -2.351752>,
      < 3.768705, -0.501479, -2.351752>,
      < 3.881649, -0.108140, -2.351752>
    }
    triangle {
      < 4.004011, -0.496844, -2.351752>,
      < 3.881649, -0.108140, -2.351752>,
      < 4.135624, -0.164070, -2.351752>
    }
    triangle {
      < 4.257186, -0.499095, -2.318152>,
      < 4.004011, -0.496844, -2.351752>,
      < 4.135624, -0.164070, -2.351752>
    }
    triangle {
      < 4.257186, -0.499095, -2.318152>,
      < 4.135624, -0.164070, -2.351752>,
      < 4.389600, -0.220000, -2.318152>
    }
    triangle {
      < 4.389499, -0.207939, -2.197752>,
      < 4.257186, -0.499095, -2.149752>,
      < 4.257186, -0.499095, -2.318152>
    }
    triangle {
      < 4.389499, -0.207939, -2.197752>,
      < 4.257186, -0.499095, -2.318152>,
      < 4.389600, -0.220000, -2.318152>
    }
    triangle {
      < 4.257186, -0.499095, -2.149752>,
      < 4.004011, -0.496844, -2.183352>,
      < 4.004011, -0.496844, -2.351752>
    }
    triangle {
      < 4.257186, -0.499095, -2.149752>,
      < 4.004011, -0.496844, -2.351752>,
      < 4.257186, -0.499095, -2.318152>
    }
    triangle {
      < 4.004011, -0.496844, -2.183352>,
      < 3.768705, -0.501479, -2.183352>,
      < 3.768705, -0.501479, -2.351752>
    }
    triangle {
      < 4.004011, -0.496844, -2.183352>,
      < 3.768705, -0.501479, -2.351752>,
      < 4.004011, -0.496844, -2.351752>
    }
    triangle {
      < 3.768705, -0.501479, -2.183352>,
      < 3.538874, -0.492210, -2.149752>,
      < 3.538874, -0.492210, -2.318152>
    }
    triangle {
      < 3.768705, -0.501479, -2.183352>,
      < 3.538874, -0.492210, -2.318152>,
      < 3.768705, -0.501479, -2.351752>
    }
    triangle {
      < 3.538874, -0.492210, -2.149752>,
      < 3.517043, -0.462198, -2.072952>,
      < 3.524401, -0.473808, -2.245752>
    }
    triangle {
      < 3.538874, -0.492210, -2.149752>,
      < 3.524401, -0.473808, -2.245752>,
      < 3.538874, -0.492210, -2.318152>
    }
    triangle {
      < 3.509686, -0.450587, -1.900152>,
      < 3.601489, 0.017736, -1.900152>,
      < 3.601489, 0.006194, -2.068552>
    }
    triangle {
      < 3.509686, -0.450587, -1.900152>,
      < 3.601489, 0.006194, -2.068552>,
      < 3.517043, -0.462198, -2.072952>
    }
    triangle {
      < 3.601489, 0.017736, -1.900152>,
      < 3.770912, 0.480823, -1.900152>,
      < 3.770912, 0.457868, -2.068552>
    }
    triangle {
      < 3.601489, 0.017736, -1.900152>,
      < 3.770912, 0.457868, -2.068552>,
      < 3.601489, 0.006194, -2.068552>
    }
    triangle {
      < 3.770912, 0.480823, -1.900152>,
      < 3.865693, 0.596565, -1.900152>,
      < 3.865693, 0.570759, -2.068552>
    }
    triangle {
      < 3.770912, 0.480823, -1.900152>,
      < 3.865693, 0.570759, -2.068552>,
      < 3.770912, 0.457868, -2.068552>
    }
    triangle {
      < 3.865693, 0.596565, -1.900152>,
      < 3.997909, 0.657474, -1.900152>,
      < 3.997909, 0.630166, -2.068552>
    }
    triangle {
      < 3.865693, 0.596565, -1.900152>,
      < 3.997909, 0.630166, -2.068552>,
      < 3.865693, 0.570759, -2.068552>
    }
    triangle {
      < 3.997909, 0.657474, -1.900152>,
      < 4.254946, 0.662500, -1.900152>,
      < 4.254946, 0.635069, -2.068552>
    }
    triangle {
      < 3.997909, 0.657474, -1.900152>,
      < 4.254946, 0.635069, -2.068552>,
      < 3.997909, 0.630166, -2.068552>
    }
    triangle {
      < 4.254946, 0.662500, -1.900152>,
      < 4.323027, 0.643809, -1.900152>,
      < 4.323027, 0.616838, -2.068552>
    }
    triangle {
      < 4.254946, 0.662500, -1.900152>,
      < 4.323027, 0.616838, -2.068552>,
      < 4.254946, 0.635069, -2.068552>
    }
    triangle {
      < 4.323027, 0.643809, -1.900152>,
      < 4.401617, 0.592719, -1.900152>,
      < 4.401617, 0.567007, -2.068552>
    }
    triangle {
      < 4.323027, 0.643809, -1.900152>,
      < 4.401617, 0.567007, -2.068552>,
      < 4.323027, 0.616838, -2.068552>
    }
    triangle {
      < 4.401617, 0.592719, -1.900152>,
      < 4.389192, -0.162058, -1.900152>,
      < 4.389287, -0.180291, -2.058646>
    }
    triangle {
      < 4.401617, 0.592719, -1.900152>,
      < 4.389287, -0.180291, -2.058646>,
      < 4.401617, 0.567007, -2.068552>
    }
    triangle {
      < 2.310423, -1.846814, -2.149752>,
      < 2.195997, -0.939456, -2.149752>,
      < 2.275997, -0.891456, -2.149752>
    }
    triangle {
      < 2.310423, -1.846814, -2.149752>,
      < 2.275997, -0.891456, -2.149752>,
      < 2.402448, -1.845804, -2.149752>
    }
    triangle {
      < 2.402448, -1.845804, -2.149752>,
      < 2.275997, -0.891456, -2.149752>,
      < 2.387997, -0.875456, -2.149752>
    }
    triangle {
      < 2.402448, -1.845804, -2.149752>,
      < 2.387997, -0.875456, -2.149752>,
      < 2.522855, -1.844482, -2.149752>
    }
    triangle {
      < 2.522855, -1.844482, -2.149752>,
      < 2.387997, -0.875456, -2.149752>,
      < 2.664000, -0.900000, -2.149752>
    }
    triangle {
      < 2.522855, -1.844482, -2.149752>,
      < 2.664000, -0.900000, -2.149752>,
      < 3.232000, -0.984000, -2.149752>
    }
    triangle {
      < 2.522855, -1.844482, -2.149752>,
      < 3.232000, -0.984000, -2.149752>,
      < 3.504321, -1.043538, -2.149752>
    }
    triangle {
      < 2.522855, -1.844482, -2.149752>,
      < 3.504321, -1.043538, -2.149752>,
      < 3.544481, -1.282359, -2.183352>
    }
    triangle {
      < 2.522855, -1.844482, -2.149752>,
      < 3.544481, -1.282359, -2.183352>,
      < 3.584641, -1.557180, -2.183352>
    }
    triangle {
      < 2.522855, -1.844482, -2.149752>,
      < 3.584641, -1.557180, -2.183352>,
      < 3.624801, -1.832000, -2.149752>
    }
    texture {bseat}
  }
  // interior
  union {
    triangle {
      < 3.626896, -1.850225, -2.040359>,
      < 3.625001, -1.850225, -2.149406>,
      < 3.005907, -1.850225, -2.149338>
    }
    triangle {
      < 3.626896, -1.850225, -2.040359>,
      < 3.005907, -1.850225, -2.149338>,
      < 2.744587, -1.850225, -2.149555>
    }
    triangle {
      < 3.626896, -1.850225, -2.040359>,
      < 2.744587, -1.850225, -2.149555>,
      < 2.540798, -1.850225, -2.149752>
    }
    triangle {
      < 3.626896, -1.850225, -2.040359>,
      < 2.540798, -1.850225, -2.149752>,
      < 2.379416, -1.850225, -2.149975>
    }
    triangle {
      < 3.626896, -1.850225, -2.040359>,
      < 2.379416, -1.850225, -2.149975>,
      < 2.378150, -1.850225, -1.119635>
    }
    triangle {
      < 3.626896, -1.850225, -2.040359>,
      < 2.378150, -1.850225, -1.119635>,
      < 3.626908, -1.850225, -1.126325>
    }
    triangle {
      < 3.626896, -1.850225, -2.040359>,
      < 3.626908, -1.850225, -1.126325>,
      < 3.626900, -1.850225, -1.747711>
    }
    triangle {
      < 5.401163, 0.604866, 0.000000>,
      < 5.355932, 0.593194, -1.141120>,
      < 4.266672, 0.595661, -1.126325>
    }
    triangle {
      < 5.401163, 0.604866, 0.000000>,
      < 4.266672, 0.595661, -1.126325>,
      < 4.270950, 0.598853, 0.000000>
    }
    triangle {
      < 5.355932, 0.593194, -1.141120>,
      < 5.258856, 0.556459, -1.780305>,
      < 4.263855, 0.560059, -1.747711>
    }
    triangle {
      < 5.355932, 0.593194, -1.141120>,
      < 4.263855, 0.560059, -1.747711>,
      < 4.266672, 0.595661, -1.126325>
    }
    triangle {
      < 5.258856, 0.556459, -1.780305>,
      < 5.132811, 0.520019, -2.098088>,
      < 4.262456, 0.525243, -2.040359>
    }
    triangle {
      < 5.258856, 0.556459, -1.780305>,
      < 4.262456, 0.525243, -2.040359>,
      < 4.263855, 0.560059, -1.747711>
    }
    triangle {
      < 5.132811, 0.520019, -2.098088>,
      < 4.971003, 0.493964, -2.309541>,
      < 4.261516, 0.500683, -2.227976>
    }
    triangle {
      < 5.132811, 0.520019, -2.098088>,
      < 4.261516, 0.500683, -2.227976>,
      < 4.262456, 0.525243, -2.040359>
    }
    triangle {
      < 4.971003, 0.493964, -2.309541>,
      < 4.309868, 0.446250, -2.365411>,
      < 4.260612, 0.461617, -2.323344>
    }
    triangle {
      < 4.971003, 0.493964, -2.309541>,
      < 4.260612, 0.461617, -2.323344>,
      < 4.261516, 0.500683, -2.227976>
    }
    triangle {
      < 4.271063, 0.434863, -2.541304>,
      < 3.625835, 0.430011, -2.554180>,
      < 3.625227, 0.435713, -2.429362>
    }
    triangle {
      < 4.271063, 0.434863, -2.541304>,
      < 3.625227, 0.435713, -2.429362>,
      < 4.263341, 0.440395, -2.419557>
    }
    triangle {
      < 3.625835, 0.430011, -2.554180>,
      < 3.009002, 0.415065, -2.549848>,
      < 3.006765, 0.420722, -2.429284>
    }
    triangle {
      < 3.625835, 0.430011, -2.554180>,
      < 3.006765, 0.420722, -2.429284>,
      < 3.625227, 0.435713, -2.429362>
    }
    triangle {
      < 3.009002, 0.415065, -2.549848>,
      < 2.752269, 0.385087, -2.563607>,
      < 2.746567, 0.390882, -2.436677>
    }
    triangle {
      < 3.009002, 0.415065, -2.549848>,
      < 2.746567, 0.390882, -2.436677>,
      < 3.006765, 0.420722, -2.429284>
    }
    triangle {
      < 2.752269, 0.385087, -2.563607>,
      < 2.552528, 0.340104, -2.576065>,
      < 2.543640, 0.346010, -2.448837>
    }
    triangle {
      < 2.752269, 0.385087, -2.563607>,
      < 2.543640, 0.346010, -2.448837>,
      < 2.746567, 0.390882, -2.436677>
    }
    triangle {
      < 2.552528, 0.340104, -2.576065>,
      < 2.385818, 0.275118, -2.594347>,
      < 2.380844, 0.281394, -2.451524>
    }
    triangle {
      < 2.552528, 0.340104, -2.576065>,
      < 2.380844, 0.281394, -2.451524>,
      < 2.543640, 0.346010, -2.448837>
    }
    triangle {
      < 2.385818, 0.275118, -2.594347>,
      < 1.773786, 0.360172, -2.588591>,
      < 1.776334, 0.366205, -2.451505>
    }
    triangle {
      < 2.385818, 0.275118, -2.594347>,
      < 1.776334, 0.366205, -2.451505>,
      < 2.380844, 0.281394, -2.451524>
    }
    triangle {
      < 1.773786, 0.360172, -2.588591>,
      < 0.819398, 0.425256, -2.554250>,
      < 0.822813, 0.430957, -2.429350>
    }
    triangle {
      < 1.773786, 0.360172, -2.588591>,
      < 0.822813, 0.430957, -2.429350>,
      < 1.776334, 0.366205, -2.451505>
    }
    triangle {
      < 0.819398, 0.425256, -2.554250>,
      < -0.379683, 0.470362, -2.504004>,
      < -0.376578, 0.475573, -2.414016>
    }
    triangle {
      < 0.819398, 0.425256, -2.554250>,
      < -0.376578, 0.475573, -2.414016>,
      < 0.822813, 0.430957, -2.429350>
    }
    triangle {
      < -0.379683, 0.470362, -2.504004>,
      < -1.077008, 0.499510, -2.477921>,
      < -1.067868, 0.504709, -2.405055>
    }
    triangle {
      < -0.379683, 0.470362, -2.504004>,
      < -1.067868, 0.504709, -2.405055>,
      < -0.376578, 0.475573, -2.414016>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -1.593830, 0.501724, -2.368387>,
      < -1.310475, 0.506873, -2.286254>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -1.310475, 0.506873, -2.286254>,
      < -1.067868, 0.504709, -2.405055>
    }
    triangle {
      < -1.593830, 0.501724, -2.368387>,
      < -1.765427, 0.503937, -2.299581>,
      < -1.387740, 0.509184, -2.216830>
    }
    triangle {
      < -1.593830, 0.501724, -2.368387>,
      < -1.387740, 0.509184, -2.216830>,
      < -1.310475, 0.506873, -2.286254>
    }
    triangle {
      < -1.765427, 0.503937, -2.299581>,
      < -1.939025, 0.508364, -2.193487>,
      < -1.462541, 0.513094, -2.114367>
    }
    triangle {
      < -1.765427, 0.503937, -2.299581>,
      < -1.462541, 0.513094, -2.114367>,
      < -1.387740, 0.509184, -2.216830>
    }
    triangle {
      < -1.939025, 0.508364, -2.193487>,
      < -2.015709, 0.512791, -2.120956>,
      < -1.492305, 0.516620, -2.051260>
    }
    triangle {
      < -1.939025, 0.508364, -2.193487>,
      < -1.492305, 0.516620, -2.051260>,
      < -1.462541, 0.513094, -2.114367>
    }
    triangle {
      < -2.015709, 0.512791, -2.120956>,
      < -2.129692, 0.526073, -1.940406>,
      < -1.537558, 0.529512, -1.877151>
    }
    triangle {
      < -2.015709, 0.512791, -2.120956>,
      < -1.537558, 0.529512, -1.877151>,
      < -1.492305, 0.516620, -2.051260>
    }
    triangle {
      < -2.129692, 0.526073, -1.940406>,
      < -2.258311, 0.539354, -1.650110>,
      < -1.572105, 0.541608, -1.605813>
    }
    triangle {
      < -2.129692, 0.526073, -1.940406>,
      < -1.572105, 0.541608, -1.605813>,
      < -1.537558, 0.529512, -1.877151>
    }
    triangle {
      < -2.258311, 0.539354, -1.650110>,
      < -2.366911, 0.579198, -1.099482>,
      < -1.565462, 0.580143, -1.077989>
    }
    triangle {
      < -2.258311, 0.539354, -1.650110>,
      < -1.565462, 0.580143, -1.077989>,
      < -1.572105, 0.541608, -1.605813>
    }
    triangle {
      < -2.366911, 0.579198, -1.099482>,
      < -2.419305, 0.619042, 0.009285>,
      < -1.565518, 0.611684, 0.000895>
    }
    triangle {
      < -2.366911, 0.579198, -1.099482>,
      < -1.565518, 0.611684, 0.000895>,
      < -1.565462, 0.580143, -1.077989>
    }
    triangle {
      < 4.309868, 0.446250, -2.365411>,
      < 4.971003, 0.493964, -2.309541>,
      < 4.778682, 0.457080, -2.450184>
    }
    triangle {
      < 4.309868, 0.446250, -2.365411>,
      < 4.778682, 0.457080, -2.450184>,
      < 4.618841, 0.431370, -2.478587>
    }
    triangle {
      < 4.309868, 0.446250, -2.365411>,
      < 4.618841, 0.431370, -2.478587>,
      < 4.271063, 0.434863, -2.541304>
    }
    triangle {
      < 4.309868, 0.446250, -2.365411>,
      < 4.271063, 0.434863, -2.541304>,
      < 4.263341, 0.440395, -2.419557>
    }
    triangle {
      < -1.505687, 0.508610, -1.888693>,
      < -1.541433, 0.520577, -1.616905>,
      < -1.541433, 0.440577, -1.616905>
    }
    triangle {
      < -1.505687, 0.508610, -1.888693>,
      < -1.541433, 0.440577, -1.616905>,
      < -1.505687, 0.433410, -1.888693>
    }
    triangle {
      < -1.541433, 0.520577, -1.616905>,
      < -1.534490, 0.559004, -1.086187>,
      < -1.534490, 0.479004, -1.086187>
    }
    triangle {
      < -1.541433, 0.520577, -1.616905>,
      < -1.534490, 0.479004, -1.086187>,
      < -1.541433, 0.440577, -1.616905>
    }
    triangle {
      < -1.534490, 0.559004, -1.086187>,
      < -1.534543, 0.590023, 0.000393>,
      < -1.534543, 0.510023, 0.000393>
    }
    triangle {
      < -1.534490, 0.559004, -1.086187>,
      < -1.534543, 0.510023, 0.000393>,
      < -1.534490, 0.479004, -1.086187>
    }
    triangle {
      < 4.270950, 0.598853, 0.000000>,
      < 4.266672, 0.595661, -1.126325>,
      < 4.266672, 0.320061, -1.126325>
    }
    triangle {
      < 4.270950, 0.598853, 0.000000>,
      < 4.266672, 0.320061, -1.126325>,
      < 4.270950, 0.323253, 0.000000>
    }
    triangle {
      < 4.266672, 0.595661, -1.126325>,
      < 4.263855, 0.560059, -1.747711>,
      < 4.263855, 0.284459, -1.747711>
    }
    triangle {
      < 4.266672, 0.595661, -1.126325>,
      < 4.263855, 0.284459, -1.747711>,
      < 4.266672, 0.320061, -1.126325>
    }
    triangle {
      < 4.263855, 0.560059, -1.747711>,
      < 4.262456, 0.525243, -2.040359>,
      < 4.262456, 0.249643, -2.040359>
    }
    triangle {
      < 4.263855, 0.560059, -1.747711>,
      < 4.262456, 0.249643, -2.040359>,
      < 4.263855, 0.284459, -1.747711>
    }
    triangle {
      < 4.262456, 0.525243, -2.040359>,
      < 4.261516, 0.500683, -2.227976>,
      < 4.261516, 0.225084, -2.227976>
    }
    triangle {
      < 4.262456, 0.525243, -2.040359>,
      < 4.261516, 0.225084, -2.227976>,
      < 4.262456, 0.249643, -2.040359>
    }
    triangle {
      < 4.261516, 0.500683, -2.227976>,
      < 4.260612, 0.461617, -2.323344>,
      < 4.260174, 0.378263, -2.369611>
    }
    triangle {
      < 4.261516, 0.500683, -2.227976>,
      < 4.260174, 0.378263, -2.369611>,
      < 4.260174, 0.167064, -2.369611>
    }
    triangle {
      < 4.261516, 0.500683, -2.227976>,
      < 4.260174, 0.167064, -2.369611>,
      < 4.261516, 0.225084, -2.227976>
    }
    triangle {
      < 4.260174, 0.378263, -2.369611>,
      < 3.625001, 0.373432, -2.369808>,
      < 3.625001, 0.162232, -2.369808>
    }
    triangle {
      < 4.260174, 0.378263, -2.369611>,
      < 3.625001, 0.162232, -2.369808>,
      < 4.260174, 0.167064, -2.369611>
    }
    triangle {
      < 3.625001, 0.373432, -2.369808>,
      < 3.005907, 0.358493, -2.369739>,
      < 3.005907, 0.147293, -2.369739>
    }
    triangle {
      < 3.625001, 0.373432, -2.369808>,
      < 3.005907, 0.147293, -2.369739>,
      < 3.625001, 0.162232, -2.369808>
    }
    triangle {
      < 3.005907, 0.358493, -2.369739>,
      < 2.744587, 0.328496, -2.369957>,
      < 2.744587, 0.117295, -2.369957>
    }
    triangle {
      < 3.005907, 0.358493, -2.369739>,
      < 2.744587, 0.117295, -2.369957>,
      < 3.005907, 0.147293, -2.369739>
    }
    triangle {
      < 2.744587, 0.328496, -2.369957>,
      < 2.555591, 0.285560, -2.370136>,
      < 2.540798, 0.072298, -2.370153>
    }
    triangle {
      < 2.744587, 0.328496, -2.369957>,
      < 2.540798, 0.072298, -2.370153>,
      < 2.744587, 0.117295, -2.369957>
    }
    triangle {
      < 2.555591, 0.285560, -2.370136>,
      < 2.379416, 0.218796, -2.370376>,
      < 2.379416, 0.007596, -2.370376>
    }
    triangle {
      < 2.555591, 0.285560, -2.370136>,
      < 2.379416, 0.007596, -2.370376>,
      < 2.540798, 0.072298, -2.370153>
    }
    triangle {
      < 2.379416, 0.218796, -2.370376>,
      < 1.777091, 0.303596, -2.370343>,
      < 1.777091, 0.092396, -2.370343>
    }
    triangle {
      < 2.379416, 0.218796, -2.370376>,
      < 1.777091, 0.092396, -2.370343>,
      < 2.379416, 0.007596, -2.370376>
    }
    triangle {
      < 1.777091, 0.303596, -2.370343>,
      < 0.824081, 0.368673, -2.369811>,
      < 0.824081, 0.157473, -2.369811>
    }
    triangle {
      < 1.777091, 0.303596, -2.370343>,
      < 0.824081, 0.157473, -2.369811>,
      < 1.777091, 0.092396, -2.370343>
    }
    triangle {
      < 0.824081, 0.368673, -2.369811>,
      < -0.375026, 0.413778, -2.369029>,
      < -0.375026, 0.202578, -2.369029>
    }
    triangle {
      < 0.824081, 0.368673, -2.369811>,
      < -0.375026, 0.202578, -2.369029>,
      < 0.824081, 0.157473, -2.369811>
    }
    triangle {
      < -0.375026, 0.413778, -2.369029>,
      < -1.063298, 0.442908, -2.368628>,
      < -1.063298, 0.362908, -2.368628>
    }
    triangle {
      < -0.375026, 0.413778, -2.369029>,
      < -1.063298, 0.362908, -2.368628>,
      < -1.063298, 0.231708, -2.368628>
    }
    triangle {
      < -0.375026, 0.413778, -2.369029>,
      < -1.063298, 0.231708, -2.368628>,
      < -0.375026, 0.202578, -2.369029>
    }
    triangle {
      < -2.288326, -0.243897, -2.367348>,
      < -1.063298, 0.231708, -2.368628>,
      < -1.063298, 0.362908, -2.368628>
    }
    triangle {
      < -1.292308, 0.488052, -2.263012>,
      < -1.363152, 0.489778, -2.201167>,
      < -1.363152, 0.433778, -2.201167>
    }
    triangle {
      < -1.292308, 0.488052, -2.263012>,
      < -1.363152, 0.433778, -2.201167>,
      < -1.292308, 0.436852, -2.263012>
    }
    triangle {
      < -1.363152, 0.489778, -2.201167>,
      < -1.434754, 0.493443, -2.105901>,
      < -1.434754, 0.435043, -2.105901>
    }
    triangle {
      < -1.363152, 0.489778, -2.201167>,
      < -1.434754, 0.435043, -2.105901>,
      < -1.363152, 0.433778, -2.201167>
    }
    triangle {
      < -1.434754, 0.493443, -2.105901>,
      < -1.461509, 0.496637, -2.050812>,
      < -1.461509, 0.435837, -2.050812>
    }
    triangle {
      < -1.434754, 0.493443, -2.105901>,
      < -1.461509, 0.435837, -2.050812>,
      < -1.434754, 0.435043, -2.105901>
    }
    triangle {
      < -1.461509, 0.496637, -2.050812>,
      < -1.505687, 0.508610, -1.888693>,
      < -1.505687, 0.433410, -1.888693>
    }
    triangle {
      < -1.461509, 0.496637, -2.050812>,
      < -1.505687, 0.433410, -1.888693>,
      < -1.461509, 0.435837, -2.050812>
    }
    triangle {
      < 4.263341, 0.440395, -2.419557>,
      < 4.260174, 0.378263, -2.369611>,
      < 4.260612, 0.461617, -2.323344>
    }
    triangle {
      < 4.263341, 0.440395, -2.419557>,
      < 4.260612, 0.461617, -2.323344>,
      < 4.309868, 0.446250, -2.365411>
    }
    triangle {
      < 4.263341, 0.440395, -2.419557>,
      < 3.625227, 0.435713, -2.429362>,
      < 3.625001, 0.373432, -2.369808>
    }
    triangle {
      < 4.263341, 0.440395, -2.419557>,
      < 3.625001, 0.373432, -2.369808>,
      < 4.260174, 0.378263, -2.369611>
    }
    triangle {
      < 3.625227, 0.435713, -2.429362>,
      < 3.006765, 0.420722, -2.429284>,
      < 3.005907, 0.358493, -2.369739>
    }
    triangle {
      < 3.625227, 0.435713, -2.429362>,
      < 3.005907, 0.358493, -2.369739>,
      < 3.625001, 0.373432, -2.369808>
    }
    triangle {
      < 3.006765, 0.420722, -2.429284>,
      < 2.746567, 0.390882, -2.436677>,
      < 2.744587, 0.328496, -2.369957>
    }
    triangle {
      < 3.006765, 0.420722, -2.429284>,
      < 2.744587, 0.328496, -2.369957>,
      < 3.005907, 0.358493, -2.369739>
    }
    triangle {
      < 2.746567, 0.390882, -2.436677>,
      < 2.543640, 0.346010, -2.448837>,
      < 2.555591, 0.285560, -2.370136>
    }
    triangle {
      < 2.746567, 0.390882, -2.436677>,
      < 2.555591, 0.285560, -2.370136>,
      < 2.744587, 0.328496, -2.369957>
    }
    triangle {
      < 2.543640, 0.346010, -2.448837>,
      < 2.380844, 0.281394, -2.451524>,
      < 2.379416, 0.218796, -2.370376>
    }
    triangle {
      < 2.543640, 0.346010, -2.448837>,
      < 2.379416, 0.218796, -2.370376>,
      < 2.555591, 0.285560, -2.370136>
    }
    triangle {
      < 2.380844, 0.281394, -2.451524>,
      < 1.776334, 0.366205, -2.451505>,
      < 1.777091, 0.303596, -2.370343>
    }
    triangle {
      < 2.380844, 0.281394, -2.451524>,
      < 1.777091, 0.303596, -2.370343>,
      < 2.379416, 0.218796, -2.370376>
    }
    triangle {
      < 1.776334, 0.366205, -2.451505>,
      < 0.822813, 0.430957, -2.429350>,
      < 0.824081, 0.368673, -2.369811>
    }
    triangle {
      < 1.776334, 0.366205, -2.451505>,
      < 0.824081, 0.368673, -2.369811>,
      < 1.777091, 0.303596, -2.370343>
    }
    triangle {
      < 0.822813, 0.430957, -2.429350>,
      < -0.376578, 0.475573, -2.414016>,
      < -0.375026, 0.413778, -2.369029>
    }
    triangle {
      < 0.822813, 0.430957, -2.429350>,
      < -0.375026, 0.413778, -2.369029>,
      < 0.824081, 0.368673, -2.369811>
    }
    triangle {
      < -0.376578, 0.475573, -2.414016>,
      < -1.067868, 0.504709, -2.405055>,
      < -1.063298, 0.442908, -2.368628>
    }
    triangle {
      < -0.376578, 0.475573, -2.414016>,
      < -1.063298, 0.442908, -2.368628>,
      < -0.375026, 0.413778, -2.369029>
    }
    triangle {
      < -1.065583, 0.471804, -2.368705>,
      < -1.292308, 0.488052, -2.263012>,
      < -1.292308, 0.436852, -2.263012>
    }
    triangle {
      < -1.065583, 0.471804, -2.368705>,
      < -1.292308, 0.436852, -2.263012>,
      < -1.063298, 0.442908, -2.368628>
    }
    triangle {
      < -1.310475, 0.506873, -2.286254>,
      < -1.387740, 0.509184, -2.216830>,
      < -1.363152, 0.489778, -2.201167>
    }
    triangle {
      < -1.310475, 0.506873, -2.286254>,
      < -1.363152, 0.489778, -2.201167>,
      < -1.292308, 0.488052, -2.263012>
    }
    triangle {
      < -1.387740, 0.509184, -2.216830>,
      < -1.462541, 0.513094, -2.114367>,
      < -1.434754, 0.493443, -2.105901>
    }
    triangle {
      < -1.387740, 0.509184, -2.216830>,
      < -1.434754, 0.493443, -2.105901>,
      < -1.363152, 0.489778, -2.201167>
    }
    triangle {
      < -1.462541, 0.513094, -2.114367>,
      < -1.492305, 0.516620, -2.051260>,
      < -1.461509, 0.496637, -2.050812>
    }
    triangle {
      < -1.462541, 0.513094, -2.114367>,
      < -1.461509, 0.496637, -2.050812>,
      < -1.434754, 0.493443, -2.105901>
    }
    triangle {
      < -1.492305, 0.516620, -2.051260>,
      < -1.537558, 0.529512, -1.877151>,
      < -1.505687, 0.508610, -1.888693>
    }
    triangle {
      < -1.492305, 0.516620, -2.051260>,
      < -1.505687, 0.508610, -1.888693>,
      < -1.461509, 0.496637, -2.050812>
    }
    triangle {
      < -1.537558, 0.529512, -1.877151>,
      < -1.572105, 0.541608, -1.605813>,
      < -1.541433, 0.520577, -1.616905>
    }
    triangle {
      < -1.537558, 0.529512, -1.877151>,
      < -1.541433, 0.520577, -1.616905>,
      < -1.505687, 0.508610, -1.888693>
    }
    triangle {
      < -1.572105, 0.541608, -1.605813>,
      < -1.565462, 0.580143, -1.077989>,
      < -1.534490, 0.559004, -1.086187>
    }
    triangle {
      < -1.572105, 0.541608, -1.605813>,
      < -1.534490, 0.559004, -1.086187>,
      < -1.541433, 0.520577, -1.616905>
    }
    triangle {
      < -1.565462, 0.580143, -1.077989>,
      < -1.565518, 0.611684, 0.000895>,
      < -1.534543, 0.590023, 0.000393>
    }
    triangle {
      < -1.565462, 0.580143, -1.077989>,
      < -1.534543, 0.590023, 0.000393>,
      < -1.534490, 0.559004, -1.086187>
    }
    triangle {
      < -1.457862, 0.244978, -2.201167>,
      < -1.552080, 0.188643, -2.105901>,
      < -1.552080, 0.108643, -2.105901>
    }
    triangle {
      < -1.457862, 0.244978, -2.201167>,
      < -1.552080, 0.108643, -2.105901>,
      < -1.457862, 0.164978, -2.201167>
    }
    triangle {
      < -1.552080, 0.188643, -2.105901>,
      < -1.587286, 0.163037, -2.050812>,
      < -1.587286, 0.083037, -2.050812>
    }
    triangle {
      < -1.552080, 0.188643, -2.105901>,
      < -1.587286, 0.083037, -2.050812>,
      < -1.552080, 0.108643, -2.105901>
    }
    triangle {
      < -1.587286, 0.163037, -2.050812>,
      < -1.645417, 0.110211, -1.888693>,
      < -1.645417, 0.030211, -1.888693>
    }
    triangle {
      < -1.587286, 0.163037, -2.050812>,
      < -1.645417, 0.030211, -1.888693>,
      < -1.587286, 0.083037, -2.050812>
    }
    triangle {
      < -1.645417, 0.110211, -1.888693>,
      < -1.692454, 0.078977, -1.616905>,
      < -1.692454, -0.001023, -1.616905>
    }
    triangle {
      < -1.645417, 0.110211, -1.888693>,
      < -1.692454, -0.001023, -1.616905>,
      < -1.645417, 0.030211, -1.888693>
    }
    triangle {
      < -1.692454, 0.078977, -1.616905>,
      < -1.683317, 0.079326, -1.086187>,
      < -1.683317, -0.000674, -1.086187>
    }
    triangle {
      < -1.692454, 0.078977, -1.616905>,
      < -1.683317, -0.000674, -1.086187>,
      < -1.692454, -0.001023, -1.616905>
    }
    triangle {
      < -1.683317, 0.079326, -1.086187>,
      < -1.683387, 0.079374, 0.000393>,
      < -1.683387, -0.000626, 0.000000>
    }
    triangle {
      < -1.683317, 0.079326, -1.086187>,
      < -1.683387, -0.000626, 0.000000>,
      < -1.683317, -0.000674, -1.086187>
    }
    triangle {
      < 4.270950, 0.323253, 0.000000>,
      < 4.266672, 0.320061, -1.126325>,
      < 4.266672, -0.147539, -1.126325>
    }
    triangle {
      < 4.270950, 0.323253, 0.000000>,
      < 4.266672, -0.147539, -1.126325>,
      < 4.268098, -0.146475, -0.751046>
    }
    triangle {
      < 4.270950, 0.323253, 0.000000>,
      < 4.268098, -0.146475, -0.751046>,
      < 4.269524, -0.145411, -0.375766>
    }
    triangle {
      < 4.270950, 0.323253, 0.000000>,
      < 4.269524, -0.145411, -0.375766>,
      < 4.270950, -0.144347, 0.000000>
    }
    triangle {
      < 4.266672, 0.320061, -1.126325>,
      < 4.263855, 0.284459, -1.747711>,
      < 4.263855, -0.183141, -1.747711>
    }
    triangle {
      < 4.266672, 0.320061, -1.126325>,
      < 4.263855, -0.183141, -1.747711>,
      < 4.266672, -0.147539, -1.126325>
    }
    triangle {
      < 4.263855, 0.284459, -1.747711>,
      < 4.262456, 0.249643, -2.040359>,
      < 4.262456, -0.217957, -2.040359>
    }
    triangle {
      < 4.263855, 0.284459, -1.747711>,
      < 4.262456, -0.217957, -2.040359>,
      < 4.263855, -0.183141, -1.747711>
    }
    triangle {
      < 4.262456, 0.249643, -2.040359>,
      < 4.261516, 0.225084, -2.227976>,
      < 4.261516, -0.242516, -2.227976>
    }
    triangle {
      < 4.262456, 0.249643, -2.040359>,
      < 4.261516, -0.242516, -2.227976>,
      < 4.262456, -0.217957, -2.040359>
    }
    triangle {
      < 4.261516, 0.225084, -2.227976>,
      < 4.260174, 0.167064, -2.369611>,
      < 4.260174, -0.300536, -2.369611>
    }
    triangle {
      < 4.261516, 0.225084, -2.227976>,
      < 4.260174, -0.300536, -2.369611>,
      < 4.261516, -0.242516, -2.227976>
    }
    triangle {
      < 4.260174, 0.167064, -2.369611>,
      < 3.625001, 0.162232, -2.369808>,
      < 3.625001, -0.305368, -2.369808>
    }
    triangle {
      < 4.260174, 0.167064, -2.369611>,
      < 3.625001, -0.305368, -2.369808>,
      < 4.260174, -0.300536, -2.369611>
    }
    triangle {
      < 3.625001, 0.162232, -2.369808>,
      < 3.005907, 0.147293, -2.369739>,
      < 3.005907, -0.320307, -2.369739>
    }
    triangle {
      < 3.625001, 0.162232, -2.369808>,
      < 3.005907, -0.320307, -2.369739>,
      < 3.625001, -0.305368, -2.369808>
    }
    triangle {
      < 3.005907, 0.147293, -2.369739>,
      < 2.744587, 0.117295, -2.369957>,
      < 2.744587, -0.350305, -2.369957>
    }
    triangle {
      < 3.005907, 0.147293, -2.369739>,
      < 2.744587, -0.350305, -2.369957>,
      < 3.005907, -0.320307, -2.369739>
    }
    triangle {
      < 2.744587, 0.117295, -2.369957>,
      < 2.540798, 0.072298, -2.370153>,
      < 2.540798, -0.395302, -2.370153>
    }
    triangle {
      < 2.744587, 0.117295, -2.369957>,
      < 2.540798, -0.395302, -2.370153>,
      < 2.744587, -0.350305, -2.369957>
    }
    triangle {
      < 2.540798, 0.072298, -2.370153>,
      < 2.379416, 0.007596, -2.370376>,
      < 2.379416, -0.460004, -2.370376>
    }
    triangle {
      < 2.540798, 0.072298, -2.370153>,
      < 2.379416, -0.460004, -2.370376>,
      < 2.540798, -0.395302, -2.370153>
    }
    triangle {
      < 2.379416, 0.007596, -2.370376>,
      < 1.777091, 0.092396, -2.370343>,
      < 1.777091, -0.375204, -2.370343>
    }
    triangle {
      < 2.379416, 0.007596, -2.370376>,
      < 1.777091, -0.375204, -2.370343>,
      < 2.379416, -0.460004, -2.370376>
    }
    triangle {
      < 1.777091, 0.092396, -2.370343>,
      < 0.824081, 0.157473, -2.369811>,
      < 0.824081, -0.310127, -2.369811>
    }
    triangle {
      < 1.777091, 0.092396, -2.370343>,
      < 0.824081, -0.310127, -2.369811>,
      < 1.777091, -0.375204, -2.370343>
    }
    triangle {
      < 0.824081, 0.157473, -2.369811>,
      < -0.375026, 0.202578, -2.369029>,
      < -0.375026, -0.265022, -2.369029>
    }
    triangle {
      < 0.824081, 0.157473, -2.369811>,
      < -0.375026, -0.265022, -2.369029>,
      < 0.824081, -0.310127, -2.369811>
    }
    triangle {
      < -0.375026, 0.202578, -2.369029>,
      < -1.063298, 0.231708, -2.368628>,
      < -1.063298, -0.235892, -2.368628>
    }
    triangle {
      < -0.375026, 0.202578, -2.369029>,
      < -1.063298, -0.235892, -2.368628>,
      < -0.375026, -0.265022, -2.369029>
    }
    triangle {
      < -1.364641, 0.298452, -2.263012>,
      < -1.457862, 0.244978, -2.201167>,
      < -1.457862, 0.164978, -2.201167>
    }
    triangle {
      < -1.364641, 0.298452, -2.263012>,
      < -1.457862, 0.164978, -2.201167>,
      < -1.364641, 0.218452, -2.263012>
    }
    triangle {
      < -0.375026, -0.265022, -2.369029>,
      < -1.063298, -0.235892, -2.368628>,
      < -1.063298, -1.850225, -2.368628>
    }
    triangle {
      < -0.375026, -0.265022, -2.369029>,
      < -1.063298, -1.850225, -2.368628>,
      < -0.375026, -1.850225, -2.369029>
    }
    triangle {
      < -3.123050, -1.037834, -2.367348>,
      < -2.396326, -1.850225, -2.367348>,
      < -2.008258, -1.850225, -2.367348>
    }
    triangle {
      < -3.123050, -1.037834, -2.367348>,
      < -2.008258, -1.850225, -2.367348>,
      < -1.063298, -1.850225, -2.368628>
    }
    triangle {
      < -3.123050, -1.037834, -2.367348>,
      < -1.063298, -1.850225, -2.368628>,
      < -1.063298, -0.235892, -2.368628>
    }
    triangle {
      < -3.123050, -1.037834, -2.367348>,
      < -3.123018, -1.032010, -1.086187>,
      < -2.378328, -1.850225, -1.086187>
    }
    triangle {
      < -3.123050, -1.037834, -2.367348>,
      < -2.378328, -1.850225, -1.086187>,
      < -2.396326, -1.850225, -2.367348>
    }
    triangle {
      < -2.220033, -1.351600, -0.262988>,
      < -3.123018, -0.448646, -0.262621>,
      < -3.123018, -0.424615, 0.000000>
    }
    triangle {
      < -2.220033, -1.351600, -0.262988>,
      < -3.123018, -0.424615, 0.000000>,
      < -2.220067, -1.315539, 0.000000>
    }
    triangle {
      < 4.269524, -0.145411, -0.375766>,
      < 3.780999, -1.476034, -0.206646>,
      < 3.792218, -1.448971, 0.000000>
    }
    triangle {
      < 4.269524, -0.145411, -0.375766>,
      < 3.792218, -1.448971, 0.000000>,
      < 4.270950, -0.144347, 0.000000>
    }
    triangle {
      < 4.266672, -0.147539, -1.126325>,
      < 4.263855, -0.183141, -1.747711>,
      < 3.626900, -1.850225, -1.747711>
    }
    triangle {
      < 4.266672, -0.147539, -1.126325>,
      < 3.626900, -1.850225, -1.747711>,
      < 3.626908, -1.850225, -1.126325>
    }
    triangle {
      < 4.263855, -0.183141, -1.747711>,
      < 4.262456, -0.217957, -2.040359>,
      < 3.626896, -1.850225, -2.040359>
    }
    triangle {
      < 4.263855, -0.183141, -1.747711>,
      < 3.626896, -1.850225, -2.040359>,
      < 3.626900, -1.850225, -1.747711>
    }
    triangle {
      < 4.262456, -0.217957, -2.040359>,
      < 4.261516, -0.242516, -2.227976>,
      < 4.260174, -0.300536, -2.369611>
    }
    triangle {
      < 4.262456, -0.217957, -2.040359>,
      < 4.260174, -0.300536, -2.369611>,
      < 4.260174, -0.300536, -2.149209>
    }
    triangle {
      < 3.625001, -0.305368, -2.149406>,
      < 3.005907, -0.320307, -2.149338>,
      < 3.005907, -1.850225, -2.149338>
    }
    triangle {
      < 3.625001, -0.305368, -2.149406>,
      < 3.005907, -1.850225, -2.149338>,
      < 3.625001, -1.850225, -2.149406>
    }
    triangle {
      < 3.005907, -0.320307, -2.149338>,
      < 2.744587, -0.350305, -2.149555>,
      < 2.744587, -1.850225, -2.149555>
    }
    triangle {
      < 3.005907, -0.320307, -2.149338>,
      < 2.744587, -1.850225, -2.149555>,
      < 3.005907, -1.850225, -2.149338>
    }
    triangle {
      < 2.744587, -0.350305, -2.149555>,
      < 2.540798, -0.395302, -2.149752>,
      < 2.540798, -1.850225, -2.149752>
    }
    triangle {
      < 2.744587, -0.350305, -2.149555>,
      < 2.540798, -1.850225, -2.149752>,
      < 2.744587, -1.850225, -2.149555>
    }
    triangle {
      < 2.540798, -0.395302, -2.149752>,
      < 2.379416, -0.460004, -2.149975>,
      < 2.379416, -1.850225, -2.149975>
    }
    triangle {
      < 2.540798, -0.395302, -2.149752>,
      < 2.379416, -1.850225, -2.149975>,
      < 2.540798, -1.850225, -2.149752>
    }
    triangle {
      < 2.379416, -0.460004, -2.149975>,
      < 1.961091, -0.389282, -2.149947>,
      < 1.961091, -1.850225, -2.149947>
    }
    triangle {
      < 2.379416, -0.460004, -2.149975>,
      < 1.961091, -1.850225, -2.149947>,
      < 2.379416, -1.850225, -2.149975>
    }
    triangle {
      < 1.777091, -0.375204, -2.370343>,
      < 0.824081, -0.310127, -2.369811>,
      < 0.824081, -1.850225, -2.369811>
    }
    triangle {
      < 1.777091, -0.375204, -2.370343>,
      < 0.824081, -1.850225, -2.369811>,
      < 1.777091, -1.850225, -2.370343>
    }
    triangle {
      < 0.824081, -0.310127, -2.369811>,
      < -0.375026, -0.265022, -2.369029>,
      < -0.375026, -1.850225, -2.369029>
    }
    triangle {
      < 0.824081, -0.310127, -2.369811>,
      < -0.375026, -1.850225, -2.369029>,
      < 0.824081, -1.850225, -2.369811>
    }
    triangle {
      < 3.625001, -1.850225, -2.149406>,
      < 4.260174, -0.300536, -2.149209>,
      < 3.625001, -0.305368, -2.149406>
    }
    triangle {
      < -1.310475, 0.506873, -2.286254>,
      < -1.066725, 0.488256, -2.383916>,
      < -1.067868, 0.504709, -2.405055>
    }
    triangle {
      < -1.063298, 0.442908, -2.368628>,
      < -1.067868, 0.504709, -2.405055>,
      < -1.066725, 0.488256, -2.383916>
    }
    triangle {
      < -1.063298, 0.442908, -2.368628>,
      < -1.066725, 0.488256, -2.383916>,
      < -1.065583, 0.471804, -2.368705>
    }
    triangle {
      < -1.066725, 0.488256, -2.383916>,
      < -1.310475, 0.506873, -2.286254>,
      < -1.292308, 0.488052, -2.263012>
    }
    triangle {
      < -1.066725, 0.488256, -2.383916>,
      < -1.292308, 0.488052, -2.263012>,
      < -1.065583, 0.471804, -2.368705>
    }
    triangle {
      < -1.534490, 0.479004, -1.086187>,
      < -1.534543, 0.510023, 0.000393>,
      < -1.846007, 0.338840, 0.000393>
    }
    triangle {
      < -1.534490, 0.479004, -1.086187>,
      < -1.846007, 0.338840, 0.000393>,
      < -1.845919, 0.338823, -1.086187>
    }
    triangle {
      < -1.541433, 0.440577, -1.616905>,
      < -1.534490, 0.479004, -1.086187>,
      < -1.845919, 0.338823, -1.086187>
    }
    triangle {
      < -1.541433, 0.440577, -1.616905>,
      < -1.845919, 0.338823, -1.086187>,
      < -1.857452, 0.338694, -1.616905>
    }
    triangle {
      < -1.505687, 0.433410, -1.888693>,
      < -1.541433, 0.440577, -1.616905>,
      < -1.857452, 0.338694, -1.616905>
    }
    triangle {
      < -1.505687, 0.433410, -1.888693>,
      < -1.857452, 0.338694, -1.616905>,
      < -1.798078, 0.350158, -1.888693>
    }
    triangle {
      < -1.461509, 0.435837, -2.050812>,
      < -1.505687, 0.433410, -1.888693>,
      < -1.798078, 0.350158, -1.888693>
    }
    triangle {
      < -1.461509, 0.435837, -2.050812>,
      < -1.798078, 0.350158, -1.888693>,
      < -1.724702, 0.369548, -2.050812>
    }
    triangle {
      < -1.434754, 0.435043, -2.105901>,
      < -1.461509, 0.435837, -2.050812>,
      < -1.724702, 0.369548, -2.050812>
    }
    triangle {
      < -1.434754, 0.435043, -2.105901>,
      < -1.724702, 0.369548, -2.050812>,
      < -1.680265, 0.378946, -2.105901>
    }
    triangle {
      < -1.363152, 0.433778, -2.201167>,
      < -1.434754, 0.435043, -2.105901>,
      < -1.680265, 0.378946, -2.105901>
    }
    triangle {
      < -1.363152, 0.433778, -2.201167>,
      < -1.680265, 0.378946, -2.105901>,
      < -1.561337, 0.399623, -2.201167>
    }
    triangle {
      < -1.292308, 0.436852, -2.263012>,
      < -1.363152, 0.433778, -2.201167>,
      < -1.561337, 0.399623, -2.201167>
    }
    triangle {
      < -1.292308, 0.436852, -2.263012>,
      < -1.561337, 0.399623, -2.201167>,
      < -1.443669, 0.419250, -2.263012>
    }
    triangle {
      < -1.063298, 0.442908, -2.368628>,
      < -1.292308, 0.436852, -2.263012>,
      < -1.443669, 0.419250, -2.263012>
    }
    triangle {
      < -1.845919, 0.338823, -1.086187>,
      < -1.846007, 0.338840, 0.000393>,
      < -1.683387, 0.079374, 0.000393>
    }
    triangle {
      < -1.845919, 0.338823, -1.086187>,
      < -1.683387, 0.079374, 0.000393>,
      < -1.683317, 0.079326, -1.086187>
    }
    triangle {
      < -1.857452, 0.338694, -1.616905>,
      < -1.845919, 0.338823, -1.086187>,
      < -1.683317, 0.079326, -1.086187>
    }
    triangle {
      < -1.857452, 0.338694, -1.616905>,
      < -1.683317, 0.079326, -1.086187>,
      < -1.692454, 0.078977, -1.616905>
    }
    triangle {
      < -1.798078, 0.350158, -1.888693>,
      < -1.857452, 0.338694, -1.616905>,
      < -1.692454, 0.078977, -1.616905>
    }
    triangle {
      < -1.798078, 0.350158, -1.888693>,
      < -1.692454, 0.078977, -1.616905>,
      < -1.645417, 0.110211, -1.888693>
    }
    triangle {
      < -1.724702, 0.369548, -2.050812>,
      < -1.798078, 0.350158, -1.888693>,
      < -1.645417, 0.110211, -1.888693>
    }
    triangle {
      < -1.724702, 0.369548, -2.050812>,
      < -1.645417, 0.110211, -1.888693>,
      < -1.587286, 0.163037, -2.050812>
    }
    triangle {
      < -1.680265, 0.378946, -2.105901>,
      < -1.724702, 0.369548, -2.050812>,
      < -1.587286, 0.163037, -2.050812>
    }
    triangle {
      < -1.680265, 0.378946, -2.105901>,
      < -1.587286, 0.163037, -2.050812>,
      < -1.552080, 0.188643, -2.105901>
    }
    triangle {
      < -1.561337, 0.399623, -2.201167>,
      < -1.680265, 0.378946, -2.105901>,
      < -1.552080, 0.188643, -2.105901>
    }
    triangle {
      < -1.561337, 0.399623, -2.201167>,
      < -1.552080, 0.188643, -2.105901>,
      < -1.457862, 0.244978, -2.201167>
    }
    triangle {
      < -1.443669, 0.419250, -2.263012>,
      < -1.561337, 0.399623, -2.201167>,
      < -1.457862, 0.244978, -2.201167>
    }
    triangle {
      < -1.443669, 0.419250, -2.263012>,
      < -1.457862, 0.244978, -2.201167>,
      < -1.364641, 0.298452, -2.263012>
    }
    triangle {
      < -1.063298, 0.442908, -2.368628>,
      < -1.443669, 0.419250, -2.263012>,
      < -1.364641, 0.298452, -2.263012>
    }
    triangle {
      < -2.270328, -0.243791, -1.086187>,
      < -3.124035, -0.289859, -0.724256>,
      < -3.124035, -0.292996, -1.086187>
    }
    triangle {
      < -2.288326, -0.243897, -2.367348>,
      < -2.270328, -0.243791, -1.086187>,
      < -3.124035, -0.292996, -1.086187>
    }
    triangle {
      < -2.288326, -0.243897, -2.367348>,
      < -3.124035, -0.292996, -1.086187>,
      < -3.124098, -0.304644, -2.367348>
    }
    triangle {
      < -1.364641, 0.218452, -2.263012>,
      < -1.063298, 0.362908, -2.368628>,
      < -1.063298, 0.442908, -2.368628>
    }
    triangle {
      < -1.364641, 0.218452, -2.263012>,
      < -1.063298, 0.442908, -2.368628>,
      < -1.364641, 0.298452, -2.263012>
    }
    triangle {
      < -1.063298, 0.362908, -2.368628>,
      < -1.364641, 0.218452, -2.263012>,
      < -1.457862, 0.164978, -2.201167>
    }
    triangle {
      < -1.063298, 0.362908, -2.368628>,
      < -1.457862, 0.164978, -2.201167>,
      < -1.552080, 0.108643, -2.105901>
    }
    triangle {
      < -1.063298, 0.362908, -2.368628>,
      < -1.552080, 0.108643, -2.105901>,
      < -1.587286, 0.083037, -2.050812>
    }
    triangle {
      < -1.063298, 0.362908, -2.368628>,
      < -1.587286, 0.083037, -2.050812>,
      < -1.645417, 0.030211, -1.888693>
    }
    triangle {
      < -1.063298, 0.362908, -2.368628>,
      < -1.645417, 0.030211, -1.888693>,
      < -1.692454, -0.001023, -1.616905>
    }
    triangle {
      < -1.063298, 0.362908, -2.368628>,
      < -1.692454, -0.001023, -1.616905>,
      < -2.288326, -0.243897, -2.367348>
    }
    triangle {
      < -1.692454, -0.001023, -1.616905>,
      < -1.683317, -0.000674, -1.086187>,
      < -2.270328, -0.243791, -1.086187>
    }
    triangle {
      < -1.692454, -0.001023, -1.616905>,
      < -2.270328, -0.243791, -1.086187>,
      < -2.288326, -0.243897, -2.367348>
    }
    triangle {
      < -1.683317, -0.000674, -1.086187>,
      < -1.683387, -0.000626, 0.000000>,
      < -2.270467, -0.243776, 0.000000>
    }
    triangle {
      < -1.683317, -0.000674, -1.086187>,
      < -2.270467, -0.243776, 0.000000>,
      < -2.270328, -0.243791, -1.086187>
    }
    triangle {
      < -1.849829, -1.351621, -0.262988>,
      < -2.220033, -1.351600, -0.262988>,
      < -2.220067, -1.315539, 0.000000>
    }
    triangle {
      < -1.849829, -1.351621, -0.262988>,
      < -2.220067, -1.315539, 0.000000>,
      < -1.849830, -1.315557, 0.000000>
    }
    triangle {
      < -2.008229, -1.850225, -1.086187>,
      < -2.008258, -1.850225, -2.367348>,
      < -2.396326, -1.850225, -2.367348>
    }
    triangle {
      < -2.008229, -1.850225, -1.086187>,
      < -2.396326, -1.850225, -2.367348>,
      < -2.378328, -1.850225, -1.086187>
    }
    triangle {
      < -3.123050, -1.037834, -2.367348>,
      < -1.063298, -0.235892, -2.368628>,
      < -3.124098, -0.304644, -2.367348>
    }
    triangle {
      < -3.123018, -1.032010, -1.086187>,
      < -3.123050, -1.037834, -2.367348>,
      < -3.124098, -0.304644, -2.367348>
    }
    triangle {
      < -3.123018, -1.032010, -1.086187>,
      < -3.124098, -0.304644, -2.367348>,
      < -3.124035, -0.292996, -1.086187>
    }
    triangle {
      < -3.123018, -0.448646, -0.262621>,
      < -3.124036, -0.285856, -0.262324>,
      < -3.124036, -0.283587, 0.000000>
    }
    triangle {
      < -3.123018, -0.448646, -0.262621>,
      < -3.124036, -0.283587, 0.000000>,
      < -3.123018, -0.424615, 0.000000>
    }
    triangle {
      < -1.063298, 0.231708, -2.368628>,
      < -2.288326, -0.243897, -2.367348>,
      < -1.063298, -0.235892, -2.368628>
    }
    triangle {
      < 2.378281, -1.476034, -0.204981>,
      < 2.378290, -1.448971, 0.000000>,
      < 3.792218, -1.448971, 0.000000>
    }
    triangle {
      < 2.378281, -1.476034, -0.204981>,
      < 3.792218, -1.448971, 0.000000>,
      < 3.780999, -1.476034, -0.206646>
    }
    triangle {
      < 3.626912, -1.850225, -0.561449>,
      < 4.268098, -0.146475, -0.751046>,
      < 4.266672, -0.147539, -1.126325>
    }
    triangle {
      < 3.626912, -1.850225, -0.561449>,
      < 4.266672, -0.147539, -1.126325>,
      < 3.626908, -1.850225, -1.126325>
    }
    triangle {
      < 2.378150, -1.850225, -1.119635>,
      < 2.378170, -1.850121, -0.558112>,
      < 3.626912, -1.850225, -0.561449>
    }
    triangle {
      < 2.378150, -1.850225, -1.119635>,
      < 3.626912, -1.850225, -0.561449>,
      < 3.626908, -1.850225, -1.126325>
    }
    triangle {
      < -2.378375, -1.849855, -0.724256>,
      < -2.008230, -1.850061, -0.724256>,
      < -2.008229, -1.850225, -1.086187>
    }
    triangle {
      < -2.378375, -1.849855, -0.724256>,
      < -2.008229, -1.850225, -1.086187>,
      < -2.378328, -1.850225, -1.086187>
    }
    triangle {
      < -3.123018, -1.028232, -0.724256>,
      < -2.378375, -1.849855, -0.724256>,
      < -2.378328, -1.850225, -1.086187>
    }
    triangle {
      < -3.123018, -1.028232, -0.724256>,
      < -2.378328, -1.850225, -1.086187>,
      < -3.123018, -1.032010, -1.086187>
    }
    triangle {
      < -3.124035, -0.289859, -0.724256>,
      < -3.123018, -1.028232, -0.724256>,
      < -3.123018, -1.032010, -1.086187>
    }
    triangle {
      < -3.124035, -0.289859, -0.724256>,
      < -3.123018, -1.032010, -1.086187>,
      < -3.124035, -0.292996, -1.086187>
    }
    triangle {
      < 3.751823, -1.549721, -0.336739>,
      < 4.269524, -0.145411, -0.375766>,
      < 4.268098, -0.146475, -0.751046>
    }
    triangle {
      < 3.751823, -1.549721, -0.336739>,
      < 4.268098, -0.146475, -0.751046>,
      < 3.626912, -1.850225, -0.561449>
    }
    triangle {
      < 2.378170, -1.850121, -0.558112>,
      < 2.378256, -1.549722, -0.334937>,
      < 3.751823, -1.549721, -0.336739>
    }
    triangle {
      < 2.378170, -1.850121, -0.558112>,
      < 3.751823, -1.549721, -0.336739>,
      < 3.626912, -1.850225, -0.561449>
    }
    triangle {
      < -2.252662, -1.449829, -0.424804>,
      < -1.873709, -1.449869, -0.420646>,
      < -2.008230, -1.850061, -0.724256>
    }
    triangle {
      < -2.252662, -1.449829, -0.424804>,
      < -2.008230, -1.850061, -0.724256>,
      < -2.378375, -1.849855, -0.724256>
    }
    triangle {
      < -3.123018, -0.529557, -0.441929>,
      < -2.252662, -1.449829, -0.424804>,
      < -2.378375, -1.849855, -0.724256>
    }
    triangle {
      < -3.123018, -0.529557, -0.441929>,
      < -2.378375, -1.849855, -0.724256>,
      < -3.123018, -1.028232, -0.724256>
    }
    triangle {
      < -3.124036, -0.287589, -0.462324>,
      < -3.123018, -0.529557, -0.441929>,
      < -3.123018, -1.028232, -0.724256>
    }
    triangle {
      < -3.124036, -0.287589, -0.462324>,
      < -3.123018, -1.028232, -0.724256>,
      < -3.124035, -0.289859, -0.724256>
    }
    triangle {
      < -1.060381, -1.850225, -1.099566>,
      < -1.063298, -1.850225, -2.368628>,
      < -2.008258, -1.850225, -2.367348>
    }
    triangle {
      < -1.060381, -1.850225, -1.099566>,
      < -2.008258, -1.850225, -2.367348>,
      < -2.008229, -1.850225, -1.086187>
    }
    triangle {
      < -1.060381, -1.850061, -0.733186>,
      < -1.060381, -1.850225, -1.099566>,
      < -2.008229, -1.850225, -1.086187>
    }
    triangle {
      < -1.060381, -1.850061, -0.733186>,
      < -2.008229, -1.850225, -1.086187>,
      < -2.008230, -1.850061, -0.724256>
    }
    triangle {
      < -1.060257, -1.449853, -0.440745>,
      < -1.060381, -1.850061, -0.733186>,
      < -2.008230, -1.850061, -0.724256>
    }
    triangle {
      < -1.060257, -1.449853, -0.440745>,
      < -2.008230, -1.850061, -0.724256>,
      < -1.873709, -1.449869, -0.420646>
    }
    triangle {
      < -1.060209, -1.315570, 0.000000>,
      < -1.060221, -1.351637, -0.267437>,
      < -1.849829, -1.351621, -0.262988>
    }
    triangle {
      < -1.060209, -1.315570, 0.000000>,
      < -1.849829, -1.351621, -0.262988>,
      < -1.849830, -1.315557, 0.000000>
    }
    triangle {
      < -0.366958, -1.850225, -1.112945>,
      < -0.375026, -1.850225, -2.369029>,
      < -1.063298, -1.850225, -2.368628>
    }
    triangle {
      < -0.366958, -1.850225, -1.112945>,
      < -1.063298, -1.850225, -2.368628>,
      < -1.060381, -1.850225, -1.099566>
    }
    triangle {
      < -0.366958, -1.850087, -0.742116>,
      < -0.366958, -1.850225, -1.112945>,
      < -1.060381, -1.850225, -1.099566>
    }
    triangle {
      < -0.366958, -1.850087, -0.742116>,
      < -1.060381, -1.850225, -1.099566>,
      < -1.060381, -1.850061, -0.733186>
    }
    triangle {
      < -0.366654, -1.449842, -0.445578>,
      < -0.366958, -1.850087, -0.742116>,
      < -1.060381, -1.850061, -0.733186>
    }
    triangle {
      < -0.366654, -1.449842, -0.445578>,
      < -1.060381, -1.850061, -0.733186>,
      < -1.060257, -1.449853, -0.440745>
    }
    triangle {
      < -0.366539, -1.315604, -0.000455>,
      < -0.366567, -1.351662, -0.271888>,
      < -1.060221, -1.351637, -0.267437>
    }
    triangle {
      < -0.366539, -1.315604, -0.000455>,
      < -1.060221, -1.351637, -0.267437>,
      < -1.060209, -1.315570, 0.000000>
    }
    triangle {
      < 2.378256, -1.549722, -0.334937>,
      < 2.378281, -1.476034, -0.204981>,
      < 3.780999, -1.476034, -0.206646>
    }
    triangle {
      < 2.378256, -1.549722, -0.334937>,
      < 3.780999, -1.476034, -0.206646>,
      < 3.751823, -1.549721, -0.336739>
    }
    triangle {
      < -1.060221, -1.351637, -0.267437>,
      < -0.366567, -1.351662, -0.271888>,
      < -0.366654, -1.449842, -0.445578>
    }
    triangle {
      < -1.060221, -1.351637, -0.267437>,
      < -0.366654, -1.449842, -0.445578>,
      < -1.060257, -1.449853, -0.440745>
    }
    triangle {
      < -1.849829, -1.351621, -0.262988>,
      < -1.060221, -1.351637, -0.267437>,
      < -1.060257, -1.449853, -0.440745>
    }
    triangle {
      < -1.849829, -1.351621, -0.262988>,
      < -1.060257, -1.449853, -0.440745>,
      < -1.873709, -1.449869, -0.420646>
    }
    triangle {
      < -2.220033, -1.351600, -0.262988>,
      < -1.849829, -1.351621, -0.262988>,
      < -1.873709, -1.449869, -0.420646>
    }
    triangle {
      < -2.220033, -1.351600, -0.262988>,
      < -1.873709, -1.449869, -0.420646>,
      < -2.252662, -1.449829, -0.424804>
    }
    triangle {
      < -3.123018, -0.448646, -0.262621>,
      < -2.220033, -1.351600, -0.262988>,
      < -2.252662, -1.449829, -0.424804>
    }
    triangle {
      < -3.123018, -0.448646, -0.262621>,
      < -2.252662, -1.449829, -0.424804>,
      < -3.123018, -0.529557, -0.441929>
    }
    triangle {
      < -3.124036, -0.285856, -0.262324>,
      < -3.123018, -0.448646, -0.262621>,
      < -3.123018, -0.529557, -0.441929>
    }
    triangle {
      < -3.124036, -0.285856, -0.262324>,
      < -3.123018, -0.529557, -0.441929>,
      < -3.124036, -0.287589, -0.462324>
    }
    triangle {
      < 4.269524, -0.145411, -0.375766>,
      < 3.751823, -1.549721, -0.336739>,
      < 3.780999, -1.476034, -0.206646>
    }
    triangle {
      < 2.378150, -1.850225, -1.119635>,
      < 2.379416, -1.850225, -2.149975>,
      < 1.961091, -1.850225, -2.149947>
    }
    triangle {
      < 2.378150, -1.850225, -1.119635>,
      < 1.961091, -1.850225, -2.149947>,
      < 1.776923, -1.850225, -1.116290>
    }
    triangle {
      < 2.378170, -1.850121, -0.558112>,
      < 2.378150, -1.850225, -1.119635>,
      < 1.776923, -1.850225, -1.116290>
    }
    triangle {
      < 2.378170, -1.850121, -0.558112>,
      < 1.776923, -1.850225, -1.116290>,
      < 1.776923, -1.850121, -0.556443>
    }
    triangle {
      < 2.378256, -1.549722, -0.334937>,
      < 2.378170, -1.850121, -0.558112>,
      < 1.776923, -1.850121, -0.556443>
    }
    triangle {
      < 2.378256, -1.549722, -0.334937>,
      < 1.776923, -1.850121, -0.556443>,
      < 1.776923, -1.549722, -0.334036>
    }
    triangle {
      < 2.378281, -1.476034, -0.204981>,
      < 2.378256, -1.549722, -0.334937>,
      < 1.776923, -1.549722, -0.334036>
    }
    triangle {
      < 2.378281, -1.476034, -0.204981>,
      < 1.776923, -1.549722, -0.334036>,
      < 1.776923, -1.476034, -0.204148>
    }
    triangle {
      < 2.378290, -1.448971, 0.000000>,
      < 2.378281, -1.476034, -0.204981>,
      < 1.776923, -1.476034, -0.204148>
    }
    triangle {
      < 2.378290, -1.448971, 0.000000>,
      < 1.776923, -1.476034, -0.204148>,
      < 1.776923, -1.448971, -0.000445>
    }
    triangle {
      < 4.260174, -0.300536, -2.369611>,
      < 3.625001, -0.305368, -2.369808>,
      < 3.625001, -0.305368, -2.149406>
    }
    triangle {
      < 4.260174, -0.300536, -2.369611>,
      < 3.625001, -0.305368, -2.149406>,
      < 4.260174, -0.300536, -2.149209>
    }
    triangle {
      < 3.625001, -0.305368, -2.369808>,
      < 3.005907, -0.320307, -2.369739>,
      < 3.005907, -0.320307, -2.149338>
    }
    triangle {
      < 3.625001, -0.305368, -2.369808>,
      < 3.005907, -0.320307, -2.149338>,
      < 3.625001, -0.305368, -2.149406>
    }
    triangle {
      < 3.005907, -0.320307, -2.369739>,
      < 2.744587, -0.350305, -2.369957>,
      < 2.744587, -0.350305, -2.149555>
    }
    triangle {
      < 3.005907, -0.320307, -2.369739>,
      < 2.744587, -0.350305, -2.149555>,
      < 3.005907, -0.320307, -2.149338>
    }
    triangle {
      < 2.744587, -0.350305, -2.369957>,
      < 2.540798, -0.395302, -2.370153>,
      < 2.540798, -0.395302, -2.149752>
    }
    triangle {
      < 2.744587, -0.350305, -2.369957>,
      < 2.540798, -0.395302, -2.149752>,
      < 2.744587, -0.350305, -2.149555>
    }
    triangle {
      < 2.540798, -0.395302, -2.370153>,
      < 2.379416, -0.460004, -2.370376>,
      < 2.379416, -0.460004, -2.149975>
    }
    triangle {
      < 2.540798, -0.395302, -2.370153>,
      < 2.379416, -0.460004, -2.149975>,
      < 2.540798, -0.395302, -2.149752>
    }
    triangle {
      < 2.379416, -0.460004, -2.370376>,
      < 1.777091, -0.375204, -2.370343>,
      < 1.789091, -0.375204, -2.295402>
    }
    triangle {
      < 2.379416, -0.460004, -2.370376>,
      < 1.789091, -0.375204, -2.295402>,
      < 1.856495, -0.382243, -2.200684>
    }
    triangle {
      < 2.379416, -0.460004, -2.370376>,
      < 1.856495, -0.382243, -2.200684>,
      < 1.961091, -0.389282, -2.149947>
    }
    triangle {
      < 2.379416, -0.460004, -2.370376>,
      < 1.961091, -0.389282, -2.149947>,
      < 2.379416, -0.460004, -2.149975>
    }
    triangle {
      < 1.777091, -0.375204, -2.370343>,
      < 1.777091, -1.850225, -2.370343>,
      < 1.789091, -1.850225, -2.295402>
    }
    triangle {
      < 1.777091, -0.375204, -2.370343>,
      < 1.789091, -1.850225, -2.295402>,
      < 1.789091, -0.375204, -2.295402>
    }
    triangle {
      < 4.262456, -0.217957, -2.040359>,
      < 4.260174, -0.300536, -2.149209>,
      < 3.625001, -1.850225, -2.149406>
    }
    triangle {
      < 4.262456, -0.217957, -2.040359>,
      < 3.625001, -1.850225, -2.149406>,
      < 3.626896, -1.850225, -2.040359>
    }
    triangle {
      < 1.856495, -0.382243, -2.200684>,
      < 1.856495, -1.850225, -2.200684>,
      < 1.961091, -1.850225, -2.149947>
    }
    triangle {
      < 1.856495, -0.382243, -2.200684>,
      < 1.961091, -1.850225, -2.149947>,
      < 1.961091, -0.389282, -2.149947>
    }
    triangle {
      < 1.856495, -1.850225, -2.200684>,
      < 1.856495, -0.382243, -2.200684>,
      < 1.789091, -0.375204, -2.295402>
    }
    triangle {
      < 1.856495, -1.850225, -2.200684>,
      < 1.789091, -0.375204, -2.295402>,
      < 1.789091, -1.850225, -2.295402>
    }
    triangle {
      < 1.776923, -1.850225, -1.116290>,
      < 1.777091, -1.850225, -2.370343>,
      < 0.824081, -1.850225, -2.369811>
    }
    triangle {
      < 1.776923, -1.850225, -1.116290>,
      < 0.824081, -1.850225, -2.369811>,
      < 0.823881, -1.850225, -1.114618>
    }
    triangle {
      < 1.776923, -1.850121, -0.556443>,
      < 1.776923, -1.850225, -1.116290>,
      < 0.823881, -1.850225, -1.114618>
    }
    triangle {
      < 1.776923, -1.850121, -0.556443>,
      < 0.823881, -1.850225, -1.114618>,
      < 0.823881, -1.850087, -0.743232>
    }
    triangle {
      < 1.776923, -1.549722, -0.334036>,
      < 1.776923, -1.850121, -0.556443>,
      < 0.823881, -1.850087, -0.743232>
    }
    triangle {
      < 1.776923, -1.549722, -0.334036>,
      < 0.823881, -1.850087, -0.743232>,
      < 0.823881, -1.449842, -0.446181>
    }
    triangle {
      < 1.776923, -1.476034, -0.204148>,
      < 1.776923, -1.549722, -0.334036>,
      < 0.823881, -1.449842, -0.446181>
    }
    triangle {
      < 1.776923, -1.476034, -0.204148>,
      < 0.823881, -1.449842, -0.446181>,
      < 0.823881, -1.351662, -0.272445>
    }
    triangle {
      < 1.776923, -1.448971, -0.000445>,
      < 1.776923, -1.476034, -0.204148>,
      < 0.823881, -1.351662, -0.272445>
    }
    triangle {
      < 1.776923, -1.448971, -0.000445>,
      < 0.823881, -1.351662, -0.272445>,
      < 0.823881, -1.315604, -0.000459>
    }
    triangle {
      < 1.776923, -1.850225, -1.116290>,
      < 1.961091, -1.850225, -2.149947>,
      < 1.856495, -1.850225, -2.200684>
    }
    triangle {
      < 1.776923, -1.850225, -1.116290>,
      < 1.789091, -1.850225, -2.295402>,
      < 1.777091, -1.850225, -2.370343>
    }
    triangle {
      < 1.776923, -1.850225, -1.116290>,
      < 1.856495, -1.850225, -2.200684>,
      < 1.789091, -1.850225, -2.295402>
    }
    triangle {
      < 0.823881, -1.850225, -1.114618>,
      < 0.824081, -1.850225, -2.369811>,
      < -0.375026, -1.850225, -2.369029>
    }
    triangle {
      < 0.823881, -1.850225, -1.114618>,
      < -0.375026, -1.850225, -2.369029>,
      < -0.366958, -1.850225, -1.112945>
    }
    triangle {
      < 0.823881, -1.850087, -0.743232>,
      < 0.823881, -1.850225, -1.114618>,
      < -0.366958, -1.850225, -1.112945>
    }
    triangle {
      < 0.823881, -1.850087, -0.743232>,
      < -0.366958, -1.850225, -1.112945>,
      < -0.366958, -1.850087, -0.742116>
    }
    triangle {
      < 0.823881, -1.449842, -0.446181>,
      < 0.823881, -1.850087, -0.743232>,
      < -0.366958, -1.850087, -0.742116>
    }
    triangle {
      < 0.823881, -1.449842, -0.446181>,
      < -0.366958, -1.850087, -0.742116>,
      < -0.366654, -1.449842, -0.445578>
    }
    triangle {
      < 0.823881, -1.351662, -0.272445>,
      < 0.823881, -1.449842, -0.446181>,
      < -0.366654, -1.449842, -0.445578>
    }
    triangle {
      < 0.823881, -1.351662, -0.272445>,
      < -0.366654, -1.449842, -0.445578>,
      < -0.366567, -1.351662, -0.271888>
    }
    triangle {
      < 0.823881, -1.315604, -0.000459>,
      < 0.823881, -1.351662, -0.272445>,
      < -0.366567, -1.351662, -0.271888>
    }
    triangle {
      < 0.823881, -1.315604, -0.000459>,
      < -0.366567, -1.351662, -0.271888>,
      < -0.366539, -1.315604, -0.000455>
    }
    texture {interior}
  }
  // rlight
  union {
    triangle {
      < 8.941601, -1.056968, -2.840635>,
      < 8.941601, -1.073912, -2.797338>,
      < 8.941601, -1.091616, -2.842811>
    }
    triangle {
      < 8.941601, -1.056706, -2.568872>,
      < 8.941601, -0.888966, -2.506449>,
      < 8.941601, -0.938202, -2.480663>
    }
    triangle {
      < 8.941601, -1.056706, -2.721055>,
      < 8.941601, -0.849236, -2.752583>,
      < 8.941601, -0.820418, -2.718179>
    }
    triangle {
      < 8.941601, -1.056706, -2.721055>,
      < 8.941601, -0.820418, -2.718179>,
      < 8.941601, -1.052008, -2.644964>
    }
    triangle {
      < 8.941601, -0.849236, -2.537343>,
      < 8.941601, -1.056706, -2.568872>,
      < 8.941601, -1.052008, -2.644964>
    }
    triangle {
      < 8.941601, -0.849236, -2.537343>,
      < 8.941601, -1.052008, -2.644964>,
      < 8.941601, -0.820418, -2.571748>
    }
    triangle {
      < 8.941601, -1.056706, -2.721055>,
      < 8.941601, -0.938202, -2.809265>,
      < 8.941601, -0.888966, -2.783479>
    }
    triangle {
      < 8.941601, -1.073912, -2.492589>,
      < 8.941601, -1.056968, -2.449295>,
      < 8.941601, -1.091616, -2.447118>
    }
    triangle {
      < 8.941601, -1.073912, -2.492589>,
      < 8.941601, -0.994980, -2.461295>,
      < 8.941601, -1.056968, -2.449295>
    }
    triangle {
      < 8.941601, -0.938202, -2.809265>,
      < 8.941601, -1.056706, -2.721055>,
      < 8.941601, -1.073912, -2.797338>
    }
    triangle {
      < 8.941601, -0.938202, -2.809265>,
      < 8.941601, -1.073912, -2.797338>,
      < 8.941601, -0.994980, -2.828633>
    }
    triangle {
      < 8.941601, -1.052008, -2.644964>,
      < 8.941601, -0.803172, -2.681896>,
      < 8.941601, -0.797472, -2.644964>
    }
    triangle {
      < 8.941601, -0.803172, -2.608031>,
      < 8.941601, -1.052008, -2.644964>,
      < 8.941601, -0.797472, -2.644964>
    }
    triangle {
      < 8.941601, -0.994980, -2.461295>,
      < 8.941601, -1.073912, -2.492589>,
      < 8.941601, -1.056706, -2.568872>
    }
    triangle {
      < 8.941601, -0.994980, -2.461295>,
      < 8.941601, -1.056706, -2.568872>,
      < 8.941601, -0.938202, -2.480663>
    }
    triangle {
      < 8.941601, -0.994980, -2.828633>,
      < 8.941601, -1.073912, -2.797338>,
      < 8.941601, -1.056968, -2.840635>
    }
    triangle {
      < 8.941601, -1.052008, -2.644964>,
      < 8.941601, -0.820418, -2.718179>,
      < 8.941601, -0.803172, -2.681896>
    }
    triangle {
      < 8.941601, -1.052008, -2.644964>,
      < 8.941601, -0.803172, -2.608031>,
      < 8.941601, -0.820418, -2.571748>
    }
    triangle {
      < 8.941601, -1.056706, -2.568872>,
      < 8.941601, -0.849236, -2.537343>,
      < 8.941601, -0.888966, -2.506449>
    }
    triangle {
      < 8.941601, -0.849236, -2.752583>,
      < 8.941601, -1.056706, -2.721055>,
      < 8.941601, -0.888966, -2.783479>
    }
    texture {rlight}
  }
  // wlight
  union {
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.452059, -2.695912>,
      < 9.270059, -1.437610, -2.742372>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.437610, -2.742372>,
      < 9.270059, -1.415792, -2.780160>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.415792, -2.780160>,
      < 9.270059, -1.389757, -2.806606>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.389757, -2.806606>,
      < 9.270059, -1.363081, -2.821137>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.363081, -2.821137>,
      < 9.270059, -1.341180, -2.824098>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.341180, -2.824098>,
      < 9.270059, -1.341180, -2.465543>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.363081, -2.468503>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.363081, -2.468503>,
      < 9.270059, -1.389757, -2.483034>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.389757, -2.483034>,
      < 9.270059, -1.415792, -2.509480>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.415792, -2.509480>,
      < 9.270059, -1.437610, -2.547268>
    }
    triangle {
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.437610, -2.547268>,
      < 9.270059, -1.452059, -2.593728>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.341180, -2.824098>,
      < 9.270059, -1.319076, -2.817147>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.319076, -2.817147>,
      < 9.270059, -1.294850, -2.798639>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.294850, -2.798639>,
      < 9.270059, -1.273519, -2.770604>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.273519, -2.770604>,
      < 9.270059, -1.256751, -2.734026>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.256751, -2.734026>,
      < 9.270059, -1.246052, -2.691093>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.246052, -2.691093>,
      < 9.270059, -1.242382, -2.644820>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.242382, -2.644820>,
      < 9.270059, -1.246052, -2.598547>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.246052, -2.598547>,
      < 9.270059, -1.256751, -2.555614>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.256751, -2.555614>,
      < 9.270059, -1.273519, -2.519037>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.273519, -2.519037>,
      < 9.270059, -1.294850, -2.491002>
    }
    triangle {
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.294850, -2.491002>,
      < 9.270059, -1.319076, -2.472493>
    }
    texture {wlight}
  }
  // orn
  union {
    triangle {
      < 8.405490, -0.095794, -0.815684>,
      < 8.475469, -0.408127, 0.000000>,
      < 8.471934, -0.293105, 0.000000>
    }
    triangle {
      < 8.405490, -0.095794, -0.815684>,
      < 8.471934, -0.293105, 0.000000>,
      < 8.413591, -0.060930, -0.791835>
    }
    triangle {
      < 8.405490, -0.095794, -0.815684>,
      < 8.413591, -0.060930, -0.791835>,
      < 8.394976, -0.070614, -0.845775>
    }
    texture {orn}
  }
  // bottom
  union {
    triangle {
      < 5.645978, -1.296764, -1.747609>,
      < 6.224681, -1.470219, -1.747609>,
      < 4.036805, -1.444195, -1.747609>
    }
    triangle {
      < 5.645978, -1.296764, -1.747609>,
      < 4.036805, -1.444195, -1.747609>,
      < 4.203426, -1.317132, -1.747609>
    }
    triangle {
      < 5.645978, -1.296764, -1.747609>,
      < 4.203426, -1.317132, -1.747609>,
      < 4.418622, -1.236594, -1.747609>
    }
    texture {bottom}
  }
  // sidep
  union {
    triangle {
      < 8.552464, -0.915826, -2.875156>,
      < 7.266874, -0.750716, -2.954813>,
      < 7.443739, -0.255730, -2.890142>
    }
    triangle {
      < 8.552464, -0.915826, -2.875156>,
      < 7.443739, -0.255730, -2.890142>,
      < 8.879555, -0.281976, -2.769261>
    }
    triangle {
      < 8.552464, -0.915826, -2.875156>,
      < 8.879555, -0.281976, -2.769261>,
      < 8.735338, -0.613710, -2.826938>
    }
    texture {sidep}
  }
  // trunk
  union {
    triangle {
      < 8.457153, -0.449640, -1.764580>,
      < 8.449835, -0.425835, -1.079941>,
      < 8.560331, -1.222266, -1.029780>
    }
    triangle {
      < 8.457153, -0.449640, -1.764580>,
      < 8.560331, -1.222266, -1.029780>,
      < 8.522250, -1.225294, -1.772281>
    }
    triangle {
      < 8.440199, -0.463641, -2.193263>,
      < 8.457153, -0.449640, -1.764580>,
      < 8.522250, -1.225294, -1.772281>
    }
    triangle {
      < 8.440199, -0.463641, -2.193263>,
      < 8.522250, -1.225294, -1.772281>,
      < 8.512800, -1.225042, -1.923583>
    }
    triangle {
      < 8.440199, -0.463641, -2.193263>,
      < 8.512800, -1.225042, -1.923583>,
      < 8.509673, -1.194734, -2.067450>
    }
    triangle {
      < 8.440199, -0.463641, -2.193263>,
      < 8.509673, -1.194734, -2.067450>,
      < 8.486027, -1.114300, -2.149738>
    }
    triangle {
      < 8.440199, -0.463641, -2.193263>,
      < 8.486027, -1.114300, -2.149738>,
      < 8.489470, -0.969292, -2.170007>
    }
    texture {trunk}
  }
  // orn
  union {
    triangle {
      < 8.414921, -0.085937, -0.796610>,
      < 8.413591, -0.060930, -0.791835>,
      < 8.471934, -0.293105, 0.000000>
    }
    triangle {
      < 8.414921, -0.085937, -0.796610>,
      < 8.471934, -0.293105, 0.000000>,
      < 8.531489, -0.343789, 0.000000>
    }
    triangle {
      < 8.405490, -0.095794, -0.815684>,
      < 8.414921, -0.085937, -0.796610>,
      < 8.531489, -0.343789, 0.000000>
    }
    triangle {
      < 8.405490, -0.095794, -0.815684>,
      < 8.531489, -0.343789, 0.000000>,
      < 8.475469, -0.408127, 0.000000>
    }
    texture {orn}
  }
  // trunk
  union {
    triangle {
      < 8.475469, -0.408127, 0.000000>,
      < 8.449835, -0.425835, -1.079941>,
      < 8.395494, -0.065184, -1.078200>
    }
    triangle {
      < 8.475469, -0.408127, 0.000000>,
      < 8.395494, -0.065184, -1.078200>,
      < 8.400454, -0.047262, 0.000000>
    }
    texture {trunk}
  }
  // trim
  union {
    triangle {
      < 7.444382, -0.248379, -2.921873>,
      < 7.456694, -0.149653, -2.924987>,
      < 8.931488, -0.183258, -2.805120>
    }
    triangle {
      < 7.444382, -0.248379, -2.921873>,
      < 8.931488, -0.183258, -2.805120>,
      < 8.882301, -0.275022, -2.801047>
    }
    triangle {
      < 2.774747, -0.371004, -3.065446>,
      < 2.939125, -0.269663, -3.032358>,
      < 2.983860, -0.373048, -3.077279>
    }
    triangle {
      < 7.234224, -0.860815, -2.999818>,
      < 7.263474, -0.758225, -2.986269>,
      < 8.547125, -0.924360, -2.908364>
    }
    triangle {
      < 7.234224, -0.860815, -2.999818>,
      < 8.547125, -0.924360, -2.908364>,
      < 8.500901, -1.043360, -2.937258>
    }
    triangle {
      < 4.562160, -0.491394, -3.060796>,
      < 5.821069, -0.601820, -3.044645>,
      < 5.799877, -0.686073, -3.050399>
    }
    triangle {
      < 4.562160, -0.491394, -3.060796>,
      < 5.799877, -0.686073, -3.050399>,
      < 4.552039, -0.563719, -3.071908>
    }
    triangle {
      < 7.263474, -0.758225, -2.986269>,
      < 7.234224, -0.860815, -2.999818>,
      < 5.799877, -0.686073, -3.050399>
    }
    triangle {
      < 7.263474, -0.758225, -2.986269>,
      < 5.799877, -0.686073, -3.050399>,
      < 5.821069, -0.601820, -3.044645>
    }
    texture {trim}
  }
  // sidep
  union {
    triangle {
      < 3.192947, -0.280363, -3.029328>,
      < 3.549376, -0.410394, -3.043454>,
      < 2.998860, -0.375346, -3.050740>
    }
    texture {sidep}
  }
  // trim
  union {
    triangle {
      < 5.920316, -0.123030, -2.979121>,
      < 5.895473, -0.213704, -2.984118>,
      < 4.151097, -0.194196, -3.026751>
    }
    triangle {
      < 5.920316, -0.123030, -2.979121>,
      < 4.151097, -0.194196, -3.026751>,
      < 4.127273, -0.109232, -3.028296>
    }
    texture {trim}
  }
  // trunk
  union {
    triangle {
      < 8.230323, 0.163051, -1.774980>,
      < 8.182999, 0.129380, -2.192896>,
      < 8.073201, 0.205660, -2.193727>
    }
    triangle {
      < 8.230323, 0.163051, -1.774980>,
      < 8.073201, 0.205660, -2.193727>,
      < 8.100101, 0.249571, -1.777554>
    }
    triangle {
      < 8.243834, 0.211613, -1.088533>,
      < 8.230323, 0.163051, -1.774980>,
      < 8.100101, 0.249571, -1.777554>
    }
    triangle {
      < 8.243834, 0.211613, -1.088533>,
      < 8.100101, 0.249571, -1.777554>,
      < 8.124635, 0.293009, -1.092600>
    }
    triangle {
      < 8.317673, 0.062025, -1.771227>,
      < 8.301852, 0.017987, -2.188884>,
      < 8.182999, 0.129380, -2.192896>
    }
    triangle {
      < 8.317673, 0.062025, -1.771227>,
      < 8.182999, 0.129380, -2.192896>,
      < 8.230323, 0.163051, -1.774980>
    }
    triangle {
      < 8.327960, 0.100635, -1.091151>,
      < 8.317673, 0.062025, -1.771227>,
      < 8.230323, 0.163051, -1.774980>
    }
    triangle {
      < 8.327960, 0.100635, -1.091151>,
      < 8.230323, 0.163051, -1.774980>,
      < 8.243834, 0.211613, -1.088533>
    }
    triangle {
      < 8.347019, 0.123354, 0.000000>,
      < 8.327960, 0.100635, -1.091151>,
      < 8.243834, 0.211613, -1.088533>
    }
    triangle {
      < 8.347019, 0.123354, 0.000000>,
      < 8.243834, 0.211613, -1.088533>,
      < 8.245603, 0.234554, 0.000000>
    }
    triangle {
      < 8.124635, 0.293009, -1.092600>,
      < 7.976715, 0.344752, -1.106459>,
      < 8.009962, 0.367298, 0.000000>
    }
    triangle {
      < 8.124635, 0.293009, -1.092600>,
      < 8.009962, 0.367298, 0.000000>,
      < 8.135803, 0.310833, 0.000000>
    }
    triangle {
      < 7.145475, 0.415678, -1.793569>,
      < 7.113728, 0.361826, -2.211385>,
      < 6.328420, 0.420911, -2.200800>
    }
    triangle {
      < 7.145475, 0.415678, -1.793569>,
      < 6.328420, 0.420911, -2.200800>,
      < 6.219293, 0.427158, -2.190680>
    }
    triangle {
      < 7.145475, 0.415678, -1.793569>,
      < 6.219293, 0.427158, -2.190680>,
      < 6.144370, 0.447848, -2.094849>
    }
    triangle {
      < 7.145475, 0.415678, -1.793569>,
      < 6.144370, 0.447848, -2.094849>,
      < 6.110524, 0.468056, -1.995495>
    }
    triangle {
      < 7.145475, 0.415678, -1.793569>,
      < 6.110524, 0.468056, -1.995495>,
      < 6.121673, 0.477584, -1.811959>
    }
    triangle {
      < 7.185932, 0.468931, -1.108458>,
      < 7.145475, 0.415678, -1.793569>,
      < 6.121673, 0.477584, -1.811959>
    }
    triangle {
      < 7.185932, 0.468931, -1.108458>,
      < 6.121673, 0.477584, -1.811959>,
      < 6.193891, 0.530497, -1.142380>
    }
    triangle {
      < 7.220746, 0.486467, 0.000000>,
      < 7.185932, 0.468931, -1.108458>,
      < 6.193891, 0.530497, -1.142380>
    }
    triangle {
      < 7.220746, 0.486467, 0.000000>,
      < 6.193891, 0.530497, -1.142380>,
      < 6.233547, 0.557975, 0.000000>
    }
    texture {trunk}
  }
  // glass
  union {
    triangle {
      < -2.421983, 0.687416, -1.109558>,
      < -2.471125, 0.711497, 0.000000>,
      < -1.531823, 1.796562, 0.000000>
    }
    triangle {
      < -2.421983, 0.687416, -1.109558>,
      < -1.531823, 1.796562, 0.000000>,
      < -1.501422, 1.776069, -1.058051>
    }
    triangle {
      < -2.306105, 0.664578, -1.673231>,
      < -2.421983, 0.687416, -1.109558>,
      < -1.501422, 1.776069, -1.058051>
    }
    triangle {
      < -2.306105, 0.664578, -1.673231>,
      < -1.501422, 1.776069, -1.058051>,
      < -1.448195, 1.740140, -1.666425>
    }
    triangle {
      < -2.055634, 0.627002, -2.125403>,
      < -2.173151, 0.642992, -1.948107>,
      < -1.393737, 1.694287, -1.944256>
    }
    triangle {
      < -2.055634, 0.627002, -2.125403>,
      < -1.393737, 1.694287, -1.944256>,
      < -1.340144, 1.643680, -2.095907>
    }
    triangle {
      < -1.792238, 0.600730, -2.337865>,
      < -1.972645, 0.624423, -2.205898>,
      < -1.317752, 1.596914, -2.165866>
    }
    triangle {
      < -1.792238, 0.600730, -2.337865>,
      < -1.317752, 1.596914, -2.165866>,
      < -1.285982, 1.434658, -2.282372>
    }
    triangle {
      < -2.173151, 0.642992, -1.948107>,
      < -2.306105, 0.664578, -1.673231>,
      < -1.448195, 1.740140, -1.666425>
    }
    triangle {
      < -2.173151, 0.642992, -1.948107>,
      < -1.448195, 1.740140, -1.666425>,
      < -1.393737, 1.694287, -1.944256>
    }
    triangle {
      < -1.972645, 0.624423, -2.205898>,
      < -2.055634, 0.627002, -2.125403>,
      < -1.340144, 1.643680, -2.095907>
    }
    triangle {
      < -1.972645, 0.624423, -2.205898>,
      < -1.340144, 1.643680, -2.095907>,
      < -1.317752, 1.596914, -2.165866>
    }
    triangle {
      < -1.614355, 0.602091, -2.428892>,
      < -1.792238, 0.600730, -2.337865>,
      < -1.285982, 1.434658, -2.282372>
    }
    triangle {
      < -1.614355, 0.602091, -2.428892>,
      < -1.285982, 1.434658, -2.282372>,
      < -1.260878, 1.233804, -2.353841>
    }
    triangle {
      < -1.502984, 0.598885, -2.446143>,
      < -1.614355, 0.602091, -2.428892>,
      < -1.260878, 1.233804, -2.353841>
    }
    triangle {
      < -1.502984, 0.598885, -2.446143>,
      < -1.260878, 1.233804, -2.353841>,
      < -1.268391, 0.835856, -2.433827>
    }
    triangle {
      < -1.502984, 0.598885, -2.446143>,
      < -1.268391, 0.835856, -2.433827>,
      < -1.285062, 0.735826, -2.451662>
    }
    triangle {
      < -1.502984, 0.598885, -2.446143>,
      < -1.285062, 0.735826, -2.451662>,
      < -1.322724, 0.656193, -2.462118>
    }
    triangle {
      < -1.502984, 0.598885, -2.446143>,
      < -1.322724, 0.656193, -2.462118>,
      < -1.402362, 0.617344, -2.457819>
    }
    triangle {
      < -1.467670, 1.767479, -1.054614>,
      < -1.494550, 1.785838, 0.000000>,
      < -2.419312, 0.712380, 0.000000>
    }
    triangle {
      < -1.467670, 1.767479, -1.054614>,
      < -2.419312, 0.712380, 0.000000>,
      < -2.366984, 0.665475, -1.099416>
    }
    triangle {
      < -1.416259, 1.732549, -1.655801>,
      < -1.467670, 1.767479, -1.054614>,
      < -2.366984, 0.665475, -1.099416>
    }
    triangle {
      < -1.416259, 1.732549, -1.655801>,
      < -2.366984, 0.665475, -1.099416>,
      < -2.258348, 0.618570, -1.650021>
    }
    triangle {
      < -1.362498, 1.685040, -1.934339>,
      < -1.416259, 1.732549, -1.655801>,
      < -2.258348, 0.618570, -1.650021>
    }
    triangle {
      < -1.362498, 1.685040, -1.934339>,
      < -2.258348, 0.618570, -1.650021>,
      < -2.129741, 0.602935, -1.940372>
    }
    triangle {
      < -1.326746, 1.641951, -2.066452>,
      < -1.362498, 1.685040, -1.934339>,
      < -2.129741, 0.602935, -1.940372>
    }
    triangle {
      < -1.326746, 1.641951, -2.066452>,
      < -2.129741, 0.602935, -1.940372>,
      < -2.015777, 0.587300, -2.120876>
    }
    triangle {
      < -1.308735, 1.605871, -2.125383>,
      < -1.326746, 1.641951, -2.066452>,
      < -2.015777, 0.587300, -2.120876>
    }
    triangle {
      < -1.308735, 1.605871, -2.125383>,
      < -2.015777, 0.587300, -2.120876>,
      < -1.939041, 0.582088, -2.193431>
    }
    triangle {
      < -1.294507, 1.551115, -2.172036>,
      < -1.308735, 1.605871, -2.125383>,
      < -1.939041, 0.582088, -2.193431>
    }
    triangle {
      < -1.294507, 1.551115, -2.172036>,
      < -1.939041, 0.582088, -2.193431>,
      < -1.765442, 0.576877, -2.299501>
    }
    triangle {
      < -1.286024, 1.491526, -2.253235>,
      < -1.294507, 1.551115, -2.172036>,
      < -1.765442, 0.576877, -2.299501>
    }
    triangle {
      < -1.286024, 1.491526, -2.253235>,
      < -1.765442, 0.576877, -2.299501>,
      < -1.593866, 0.574271, -2.356469>
    }
    triangle {
      < -1.396127, 0.602132, -2.389802>,
      < -1.305959, 0.682560, -2.392979>,
      < -1.264699, 0.815249, -2.377412>
    }
    triangle {
      < -1.396127, 0.602132, -2.389802>,
      < -1.264699, 0.815249, -2.377412>,
      < -1.260465, 1.206042, -2.308860>
    }
    triangle {
      < -1.396127, 0.602132, -2.389802>,
      < -1.260465, 1.206042, -2.308860>,
      < -1.286024, 1.491526, -2.253235>
    }
    triangle {
      < -1.396127, 0.602132, -2.389802>,
      < -1.286024, 1.491526, -2.253235>,
      < -1.593866, 0.574271, -2.356469>
    }
    triangle {
      < -1.396127, 0.602132, -2.389802>,
      < -1.593866, 0.574271, -2.356469>,
      < -1.535205, 0.573965, -2.367879>
    }
    texture {glass}
  }
  // trim
  union {
    triangle {
      < 5.895473, -0.213704, -2.984118>,
      < 5.920316, -0.123030, -2.979121>,
      < 7.456694, -0.149653, -2.924987>
    }
    triangle {
      < 5.895473, -0.213704, -2.984118>,
      < 7.456694, -0.149653, -2.924987>,
      < 7.444382, -0.248379, -2.921873>
    }
    triangle {
      < 3.514180, -0.133783, -3.023055>,
      < 3.557825, -0.209364, -3.039376>,
      < 3.361498, -0.229362, -3.053108>
    }
    triangle {
      < 3.514180, -0.133783, -3.023055>,
      < 3.361498, -0.229362, -3.053108>,
      < 3.303162, -0.154032, -3.023582>
    }
    triangle {
      < 3.303162, -0.154032, -3.023582>,
      < 3.361498, -0.229362, -3.053108>,
      < 3.189895, -0.274036, -3.058901>
    }
    triangle {
      < 3.303162, -0.154032, -3.023582>,
      < 3.189895, -0.274036, -3.058901>,
      < 3.137519, -0.193255, -3.024220>
    }
    triangle {
      < 2.748360, -0.429951, -3.073404>,
      < 1.895532, -0.386009, -3.064815>,
      < 1.906129, -0.329685, -3.054738>
    }
    triangle {
      < 2.748360, -0.429951, -3.073404>,
      < 1.906129, -0.329685, -3.054738>,
      < 2.774747, -0.371004, -3.065446>
    }
    triangle {
      < 2.983860, -0.373048, -3.077279>,
      < 2.939125, -0.269663, -3.032358>,
      < 3.137519, -0.193255, -3.024220>
    }
    triangle {
      < 2.983860, -0.373048, -3.077279>,
      < 3.137519, -0.193255, -3.024220>,
      < 3.189895, -0.274036, -3.058901>
    }
    triangle {
      < 4.127273, -0.109232, -3.028296>,
      < 4.151097, -0.194196, -3.026751>,
      < 3.557825, -0.209364, -3.039376>
    }
    triangle {
      < 4.127273, -0.109232, -3.028296>,
      < 3.557825, -0.209364, -3.039376>,
      < 3.514180, -0.133783, -3.023055>
    }
    triangle {
      < 4.562160, -0.491394, -3.060796>,
      < 4.552039, -0.563719, -3.071908>,
      < 3.533338, -0.474769, -3.081829>
    }
    triangle {
      < 4.562160, -0.491394, -3.060796>,
      < 3.533338, -0.474769, -3.081829>,
      < 3.547677, -0.414829, -3.074230>
    }
    triangle {
      < 2.984796, -0.441652, -3.083088>,
      < 2.748360, -0.429951, -3.073404>,
      < 2.774747, -0.371004, -3.065446>
    }
    triangle {
      < 2.984796, -0.441652, -3.083088>,
      < 2.774747, -0.371004, -3.065446>,
      < 2.983860, -0.373048, -3.077279>
    }
    triangle {
      < 3.533338, -0.474769, -3.081829>,
      < 2.984796, -0.441652, -3.083088>,
      < 2.983860, -0.373048, -3.077279>
    }
    triangle {
      < 3.533338, -0.474769, -3.081829>,
      < 2.983860, -0.373048, -3.077279>,
      < 3.547677, -0.414829, -3.074230>
    }
    triangle {
      < 1.907401, -0.325250, -3.023679>,
      < 2.764446, -0.365325, -3.033453>,
      < 2.774747, -0.371004, -3.065446>
    }
    triangle {
      < 1.907401, -0.325250, -3.023679>,
      < 2.774747, -0.371004, -3.065446>,
      < 1.906129, -0.329685, -3.054738>
    }
    triangle {
      < 2.764446, -0.365325, -3.033453>,
      < 2.937687, -0.265340, -2.998240>,
      < 2.939125, -0.269663, -3.032358>
    }
    triangle {
      < 2.764446, -0.365325, -3.033453>,
      < 2.939125, -0.269663, -3.032358>,
      < 2.774747, -0.371004, -3.065446>
    }
    triangle {
      < 2.937687, -0.265340, -2.998240>,
      < 3.134589, -0.190357, -2.990687>,
      < 3.137519, -0.193255, -3.024220>
    }
    triangle {
      < 2.937687, -0.265340, -2.998240>,
      < 3.137519, -0.193255, -3.024220>,
      < 2.939125, -0.269663, -3.032358>
    }
    triangle {
      < 3.134589, -0.190357, -2.990687>,
      < 3.299893, -0.151445, -2.990343>,
      < 3.303162, -0.154032, -3.023582>
    }
    triangle {
      < 3.134589, -0.190357, -2.990687>,
      < 3.303162, -0.154032, -3.023582>,
      < 3.137519, -0.193255, -3.024220>
    }
    triangle {
      < 3.299893, -0.151445, -2.990343>,
      < 3.511749, -0.131182, -2.990570>,
      < 3.514180, -0.133783, -3.023055>
    }
    triangle {
      < 3.299893, -0.151445, -2.990343>,
      < 3.514180, -0.133783, -3.023055>,
      < 3.303162, -0.154032, -3.023582>
    }
    triangle {
      < 3.511749, -0.131182, -2.990570>,
      < 4.125974, -0.106096, -2.996831>,
      < 4.127273, -0.109232, -3.028296>
    }
    triangle {
      < 3.511749, -0.131182, -2.990570>,
      < 4.127273, -0.109232, -3.028296>,
      < 3.514180, -0.133783, -3.023055>
    }
    triangle {
      < 4.125974, -0.106096, -2.996831>,
      < 5.921797, -0.119568, -2.947283>,
      < 5.920316, -0.123030, -2.979121>
    }
    triangle {
      < 4.125974, -0.106096, -2.996831>,
      < 5.920316, -0.123030, -2.979121>,
      < 4.127273, -0.109232, -3.028296>
    }
    triangle {
      < 5.921797, -0.119568, -2.947283>,
      < 7.457458, -0.145731, -2.893612>,
      < 7.456694, -0.149653, -2.924987>
    }
    triangle {
      < 5.921797, -0.119568, -2.947283>,
      < 7.456694, -0.149653, -2.924987>,
      < 5.920316, -0.123030, -2.979121>
    }
    triangle {
      < 7.457458, -0.145731, -2.893612>,
      < 8.934355, -0.179734, -2.773799>,
      < 8.931488, -0.183258, -2.805120>
    }
    triangle {
      < 7.457458, -0.145731, -2.893612>,
      < 8.931488, -0.183258, -2.805120>,
      < 7.456694, -0.149653, -2.924987>
    }
    triangle {
      < 8.934355, -0.179734, -2.773799>,
      < 8.879555, -0.281976, -2.769261>,
      < 8.882301, -0.275022, -2.801047>
    }
    triangle {
      < 8.934355, -0.179734, -2.773799>,
      < 8.882301, -0.275022, -2.801047>,
      < 8.931488, -0.183258, -2.805120>
    }
    triangle {
      < 8.879555, -0.281976, -2.769261>,
      < 7.443739, -0.255730, -2.890142>,
      < 7.444382, -0.248379, -2.921873>
    }
    triangle {
      < 8.879555, -0.281976, -2.769261>,
      < 7.444382, -0.248379, -2.921873>,
      < 8.882301, -0.275022, -2.801047>
    }
    triangle {
      < 7.443739, -0.255730, -2.890142>,
      < 5.894114, -0.220596, -2.952850>,
      < 5.895473, -0.213704, -2.984118>
    }
    triangle {
      < 7.443739, -0.255730, -2.890142>,
      < 5.895473, -0.213704, -2.984118>,
      < 7.444382, -0.248379, -2.921873>
    }
    triangle {
      < 5.894114, -0.220596, -2.952850>,
      < 4.152519, -0.200762, -2.995109>,
      < 4.151097, -0.194196, -3.026751>
    }
    triangle {
      < 5.894114, -0.220596, -2.952850>,
      < 4.151097, -0.194196, -3.026751>,
      < 5.895473, -0.213704, -2.984118>
    }
    triangle {
      < 4.152519, -0.200762, -2.995109>,
      < 3.560378, -0.215394, -3.008755>,
      < 3.557825, -0.209364, -3.039376>
    }
    triangle {
      < 4.152519, -0.200762, -2.995109>,
      < 3.557825, -0.209364, -3.039376>,
      < 4.151097, -0.194196, -3.026751>
    }
    triangle {
      < 3.560378, -0.215394, -3.008755>,
      < 3.364890, -0.235378, -3.023240>,
      < 3.361498, -0.229362, -3.053108>
    }
    triangle {
      < 3.560378, -0.215394, -3.008755>,
      < 3.361498, -0.229362, -3.053108>,
      < 3.557825, -0.209364, -3.039376>
    }
    triangle {
      < 3.364890, -0.235378, -3.023240>,
      < 3.192947, -0.280363, -3.029328>,
      < 3.189895, -0.274036, -3.058901>
    }
    triangle {
      < 3.364890, -0.235378, -3.023240>,
      < 3.189895, -0.274036, -3.058901>,
      < 3.361498, -0.229362, -3.053108>
    }
    triangle {
      < 3.192947, -0.280363, -3.029328>,
      < 2.998860, -0.375346, -3.050740>,
      < 2.983860, -0.373048, -3.077279>
    }
    triangle {
      < 3.192947, -0.280363, -3.029328>,
      < 2.983860, -0.373048, -3.077279>,
      < 3.189895, -0.274036, -3.058901>
    }
    triangle {
      < 2.998860, -0.375346, -3.050740>,
      < 3.549376, -0.410394, -3.043454>,
      < 3.547677, -0.414829, -3.074230>
    }
    triangle {
      < 2.998860, -0.375346, -3.050740>,
      < 3.547677, -0.414829, -3.074230>,
      < 2.983860, -0.373048, -3.077279>
    }
    triangle {
      < 3.549376, -0.410394, -3.043454>,
      < 4.563378, -0.485959, -3.029619>,
      < 4.562160, -0.491394, -3.060796>
    }
    triangle {
      < 3.549376, -0.410394, -3.043454>,
      < 4.562160, -0.491394, -3.060796>,
      < 3.547677, -0.414829, -3.074230>
    }
    triangle {
      < 4.563378, -0.485959, -3.029619>,
      < 5.823551, -0.595592, -3.014080>,
      < 5.821069, -0.601820, -3.044645>
    }
    triangle {
      < 4.563378, -0.485959, -3.029619>,
      < 5.821069, -0.601820, -3.044645>,
      < 4.562160, -0.491394, -3.060796>
    }
    triangle {
      < 5.823551, -0.595592, -3.014080>,
      < 7.266874, -0.750716, -2.954813>,
      < 7.263474, -0.758225, -2.986269>
    }
    triangle {
      < 5.823551, -0.595592, -3.014080>,
      < 7.263474, -0.758225, -2.986269>,
      < 5.821069, -0.601820, -3.044645>
    }
    triangle {
      < 7.266874, -0.750716, -2.954813>,
      < 8.552464, -0.915826, -2.875156>,
      < 8.547125, -0.924360, -2.908364>
    }
    triangle {
      < 7.266874, -0.750716, -2.954813>,
      < 8.547125, -0.924360, -2.908364>,
      < 7.263474, -0.758225, -2.986269>
    }
    triangle {
      < 8.552464, -0.915826, -2.875156>,
      < 8.449459, -1.115818, -2.907453>,
      < 8.454678, -1.103855, -2.937351>
    }
    triangle {
      < 8.552464, -0.915826, -2.875156>,
      < 8.454678, -1.103855, -2.937351>,
      < 8.500901, -1.043360, -2.937258>
    }
    triangle {
      < 8.552464, -0.915826, -2.875156>,
      < 8.500901, -1.043360, -2.937258>,
      < 8.547125, -0.924360, -2.908364>
    }
    triangle {
      < 8.449459, -1.115818, -2.907453>,
      < 7.201694, -0.930711, -2.952916>,
      < 7.204973, -0.919772, -2.984567>
    }
    triangle {
      < 8.449459, -1.115818, -2.907453>,
      < 7.204973, -0.919772, -2.984567>,
      < 8.454678, -1.103855, -2.937351>
    }
    triangle {
      < 7.201694, -0.930711, -2.952916>,
      < 5.776326, -0.750587, -2.994811>,
      < 5.778685, -0.740930, -3.027352>
    }
    triangle {
      < 7.201694, -0.930711, -2.952916>,
      < 5.778685, -0.740930, -3.027352>,
      < 7.204973, -0.919772, -2.984567>
    }
    triangle {
      < 5.776326, -0.750587, -2.994811>,
      < 4.540823, -0.625480, -3.022290>,
      < 4.541917, -0.616616, -3.054219>
    }
    triangle {
      < 5.776326, -0.750587, -2.994811>,
      < 4.541917, -0.616616, -3.054219>,
      < 5.778685, -0.740930, -3.027352>
    }
    triangle {
      < 4.540823, -0.625480, -3.022290>,
      < 3.517423, -0.530391, -3.028297>,
      < 3.518999, -0.522527, -3.060627>
    }
    triangle {
      < 4.540823, -0.625480, -3.022290>,
      < 3.518999, -0.522527, -3.060627>,
      < 4.541917, -0.616616, -3.054219>
    }
    triangle {
      < 3.517423, -0.530391, -3.028297>,
      < 2.970855, -0.501905, -3.023529>,
      < 2.972229, -0.493705, -3.056476>
    }
    triangle {
      < 3.517423, -0.530391, -3.028297>,
      < 2.972229, -0.493705, -3.056476>,
      < 3.518999, -0.522527, -3.060627>
    }
    triangle {
      < 2.970855, -0.501905, -3.023529>,
      < 2.732397, -0.489476, -3.021448>,
      < 2.733978, -0.481400, -3.053616>
    }
    triangle {
      < 2.970855, -0.501905, -3.023529>,
      < 2.733978, -0.481400, -3.053616>,
      < 2.972229, -0.493705, -3.056476>
    }
    triangle {
      < 2.732397, -0.489476, -3.021448>,
      < 1.883786, -0.445248, -3.014044>,
      < 1.884935, -0.437384, -3.046091>
    }
    triangle {
      < 2.732397, -0.489476, -3.021448>,
      < 1.884935, -0.437384, -3.046091>,
      < 2.733978, -0.481400, -3.053616>
    }
    triangle {
      < 7.234224, -0.860815, -2.999818>,
      < 8.500901, -1.043360, -2.937258>,
      < 8.454678, -1.103855, -2.937351>
    }
    triangle {
      < 7.234224, -0.860815, -2.999818>,
      < 8.454678, -1.103855, -2.937351>,
      < 7.204973, -0.919772, -2.984567>
    }
    triangle {
      < 5.799877, -0.686073, -3.050399>,
      < 7.234224, -0.860815, -2.999818>,
      < 7.204973, -0.919772, -2.984567>
    }
    triangle {
      < 5.799877, -0.686073, -3.050399>,
      < 7.204973, -0.919772, -2.984567>,
      < 5.778685, -0.740930, -3.027352>
    }
    triangle {
      < 4.552039, -0.563719, -3.071908>,
      < 5.799877, -0.686073, -3.050399>,
      < 5.778685, -0.740930, -3.027352>
    }
    triangle {
      < 4.552039, -0.563719, -3.071908>,
      < 5.778685, -0.740930, -3.027352>,
      < 4.541917, -0.616616, -3.054219>
    }
    triangle {
      < 3.533338, -0.474769, -3.081829>,
      < 4.552039, -0.563719, -3.071908>,
      < 4.541917, -0.616616, -3.054219>
    }
    triangle {
      < 3.533338, -0.474769, -3.081829>,
      < 4.541917, -0.616616, -3.054219>,
      < 3.518999, -0.522527, -3.060627>
    }
    triangle {
      < 2.984796, -0.441652, -3.083088>,
      < 3.533338, -0.474769, -3.081829>,
      < 3.518999, -0.522527, -3.060627>
    }
    triangle {
      < 2.984796, -0.441652, -3.083088>,
      < 3.518999, -0.522527, -3.060627>,
      < 2.972229, -0.493705, -3.056476>
    }
    triangle {
      < 2.748360, -0.429951, -3.073404>,
      < 2.984796, -0.441652, -3.083088>,
      < 2.972229, -0.493705, -3.056476>
    }
    triangle {
      < 2.748360, -0.429951, -3.073404>,
      < 2.972229, -0.493705, -3.056476>,
      < 2.733978, -0.481400, -3.053616>
    }
    triangle {
      < 1.895532, -0.386009, -3.064815>,
      < 2.748360, -0.429951, -3.073404>,
      < 2.733978, -0.481400, -3.053616>
    }
    triangle {
      < 1.895532, -0.386009, -3.064815>,
      < 2.733978, -0.481400, -3.053616>,
      < 1.884935, -0.437384, -3.046091>
    }
    texture {trim}
  }
  // sidep
  union {
    triangle {
      < 5.823551, -0.595592, -3.014080>,
      < 5.894114, -0.220596, -2.952850>,
      < 7.443739, -0.255730, -2.890142>
    }
    triangle {
      < 5.823551, -0.595592, -3.014080>,
      < 7.443739, -0.255730, -2.890142>,
      < 7.266874, -0.750716, -2.954813>
    }
    triangle {
      < 3.549376, -0.410394, -3.043454>,
      < 3.364890, -0.235378, -3.023240>,
      < 3.560378, -0.215394, -3.008755>
    }
    triangle {
      < 3.549376, -0.410394, -3.043454>,
      < 3.560378, -0.215394, -3.008755>,
      < 4.152519, -0.200762, -2.995109>
    }
    triangle {
      < 3.549376, -0.410394, -3.043454>,
      < 4.152519, -0.200762, -2.995109>,
      < 4.563378, -0.485959, -3.029619>
    }
    triangle {
      < 3.549376, -0.410394, -3.043454>,
      < 3.192947, -0.280363, -3.029328>,
      < 3.364890, -0.235378, -3.023240>
    }
    triangle {
      < 4.563378, -0.485959, -3.029619>,
      < 4.152519, -0.200762, -2.995109>,
      < 5.894114, -0.220596, -2.952850>
    }
    triangle {
      < 4.563378, -0.485959, -3.029619>,
      < 5.894114, -0.220596, -2.952850>,
      < 5.823551, -0.595592, -3.014080>
    }
    texture {sidep}
  }
  // trim
  union {
    triangle {
      < 8.449459, -1.115818, -2.907453>,
      < 8.552464, -0.915826, -2.875156>,
      < 8.449459, -1.115818, -2.862253>
    }
    texture {trim}
  }
  // bottom
  union {
    triangle {
      < 8.513547, -1.508811, -2.261814>,
      < 7.979931, -1.865773, -2.699738>,
      < 8.539258, -1.508811, -2.321690>
    }
    triangle {
      < 7.979931, -1.865773, -2.699738>,
      < 8.640915, -1.508811, -2.394224>,
      < 8.539258, -1.508811, -2.321690>
    }
    triangle {
      < 7.979931, -1.865773, -2.699738>,
      < 8.512800, -1.508811, -1.923583>,
      < 8.522250, -1.508811, -1.772281>
    }
    triangle {
      < 7.979931, -1.865773, -2.699738>,
      < 8.522250, -1.508811, -1.772281>,
      < 8.560331, -1.508811, -1.029780>
    }
    triangle {
      < 7.979931, -1.865773, -2.699738>,
      < 8.560331, -1.508811, -1.029780>,
      < 8.597543, -1.508811, 0.000000>
    }
    triangle {
      < 7.979931, -1.865773, -2.699738>,
      < 8.597543, -1.508811, 0.000000>,
      < 7.979931, -1.865773, 0.000000>
    }
    triangle {
      < 7.979931, -1.865773, -2.699738>,
      < 8.509673, -1.508811, -2.067450>,
      < 8.512800, -1.508811, -1.923583>
    }
    triangle {
      < 7.979931, -1.865773, -2.699738>,
      < 8.513547, -1.508811, -2.261814>,
      < 8.509673, -1.508811, -2.067450>
    }
    texture {bottom}
  }
  // trunk
  union {
    triangle {
      < 8.124635, 0.293009, -1.092600>,
      < 8.135803, 0.310833, 0.000000>,
      < 8.245603, 0.234554, 0.000000>
    }
    triangle {
      < 8.124635, 0.293009, -1.092600>,
      < 8.245603, 0.234554, 0.000000>,
      < 8.243834, 0.211613, -1.088533>
    }
    triangle {
      < 8.124635, 0.293009, -1.092600>,
      < 8.100101, 0.249571, -1.777554>,
      < 7.958450, 0.306219, -1.778701>
    }
    triangle {
      < 8.124635, 0.293009, -1.092600>,
      < 7.958450, 0.306219, -1.778701>,
      < 7.976715, 0.344752, -1.106459>
    }
    triangle {
      < 7.697620, 0.412992, -1.107215>,
      < 7.678421, 0.360949, -1.786135>,
      < 7.145475, 0.415678, -1.793569>
    }
    triangle {
      < 7.697620, 0.412992, -1.107215>,
      < 7.145475, 0.415678, -1.793569>,
      < 7.185932, 0.468931, -1.108458>
    }
    triangle {
      < 7.678421, 0.360949, -1.786135>,
      < 7.642765, 0.310666, -2.198912>,
      < 7.113728, 0.361826, -2.211385>
    }
    triangle {
      < 7.678421, 0.360949, -1.786135>,
      < 7.113728, 0.361826, -2.211385>,
      < 7.145475, 0.415678, -1.793569>
    }
    triangle {
      < 8.449835, -0.425835, -1.079941>,
      < 8.475469, -0.408127, 0.000000>,
      < 8.597543, -1.223972, 0.000000>
    }
    triangle {
      < 8.449835, -0.425835, -1.079941>,
      < 8.597543, -1.223972, 0.000000>,
      < 8.560331, -1.222266, -1.029780>
    }
    triangle {
      < 8.400454, -0.047262, 0.000000>,
      < 8.395494, -0.065184, -1.078200>,
      < 8.327960, 0.100635, -1.091151>
    }
    triangle {
      < 8.400454, -0.047262, 0.000000>,
      < 8.327960, 0.100635, -1.091151>,
      < 8.347019, 0.123354, 0.000000>
    }
    triangle {
      < 8.391681, -0.093862, -1.761364>,
      < 8.366402, -0.137784, -2.182268>,
      < 8.301852, 0.017987, -2.188884>
    }
    triangle {
      < 8.391681, -0.093862, -1.761364>,
      < 8.301852, 0.017987, -2.188884>,
      < 8.317673, 0.062025, -1.771227>
    }
    triangle {
      < 8.449835, -0.425835, -1.079941>,
      < 8.457153, -0.449640, -1.764580>,
      < 8.391681, -0.093862, -1.761364>
    }
    triangle {
      < 8.449835, -0.425835, -1.079941>,
      < 8.391681, -0.093862, -1.761364>,
      < 8.395494, -0.065184, -1.078200>
    }
    triangle {
      < 8.395494, -0.065184, -1.078200>,
      < 8.391681, -0.093862, -1.761364>,
      < 8.317673, 0.062025, -1.771227>
    }
    triangle {
      < 8.395494, -0.065184, -1.078200>,
      < 8.317673, 0.062025, -1.771227>,
      < 8.327960, 0.100635, -1.091151>
    }
    triangle {
      < 8.100101, 0.249571, -1.777554>,
      < 8.073201, 0.205660, -2.193727>,
      < 7.932977, 0.257270, -2.183802>
    }
    triangle {
      < 8.100101, 0.249571, -1.777554>,
      < 7.932977, 0.257270, -2.183802>,
      < 7.958450, 0.306219, -1.778701>
    }
    triangle {
      < 7.726421, 0.429283, 0.000000>,
      < 7.697620, 0.412992, -1.107215>,
      < 7.185932, 0.468931, -1.108458>
    }
    triangle {
      < 7.726421, 0.429283, 0.000000>,
      < 7.185932, 0.468931, -1.108458>,
      < 7.220746, 0.486467, 0.000000>
    }
    triangle {
      < 8.457153, -0.449640, -1.764580>,
      < 8.440199, -0.463641, -2.193263>,
      < 8.366402, -0.137784, -2.182268>
    }
    triangle {
      < 8.457153, -0.449640, -1.764580>,
      < 8.366402, -0.137784, -2.182268>,
      < 8.391681, -0.093862, -1.761364>
    }
    triangle {
      < 7.697620, 0.412992, -1.107215>,
      < 7.726421, 0.429283, 0.000000>,
      < 8.009962, 0.367298, 0.000000>
    }
    triangle {
      < 7.697620, 0.412992, -1.107215>,
      < 8.009962, 0.367298, 0.000000>,
      < 7.976715, 0.344752, -1.106459>
    }
    triangle {
      < 7.678421, 0.360949, -1.786135>,
      < 7.697620, 0.412992, -1.107215>,
      < 7.976715, 0.344752, -1.106459>
    }
    triangle {
      < 7.678421, 0.360949, -1.786135>,
      < 7.976715, 0.344752, -1.106459>,
      < 7.958450, 0.306219, -1.778701>
    }
    triangle {
      < 7.642765, 0.310666, -2.198912>,
      < 7.678421, 0.360949, -1.786135>,
      < 7.958450, 0.306219, -1.778701>
    }
    triangle {
      < 7.642765, 0.310666, -2.198912>,
      < 7.958450, 0.306219, -1.778701>,
      < 7.932977, 0.257270, -2.183802>
    }
    texture {trunk}
  }
  // bottom
  union {
    triangle {
      < 6.912721, -1.695685, -2.927237>,
      < 7.210523, -1.845708, -2.831152>,
      < 7.210523, -1.845708, -1.747609>
    }
    triangle {
      < 6.912721, -1.695685, -2.927237>,
      < 7.210523, -1.845708, -1.747609>,
      < 6.912721, -1.695685, -1.747609>
    }
    triangle {
      < 3.715029, -2.025404, -2.847356>,
      < 3.789022, -1.973501, -2.874413>,
      < 3.789022, -1.973501, -1.747609>
    }
    triangle {
      < 3.715029, -2.025404, -2.847356>,
      < 3.789022, -1.973501, -1.747609>,
      < 3.715029, -2.025404, -1.747609>
    }
    triangle {
      < 3.789022, -1.973501, -2.874413>,
      < 3.827017, -1.921838, -2.901567>,
      < 3.827017, -1.921838, -1.747609>
    }
    triangle {
      < 3.789022, -1.973501, -2.874413>,
      < 3.827017, -1.921838, -1.747609>,
      < 3.789022, -1.973501, -1.747609>
    }
    triangle {
      < 3.827017, -1.921838, -2.901567>,
      < 3.829013, -1.870416, -2.928818>,
      < 3.829013, -1.870416, -1.747609>
    }
    triangle {
      < 3.827017, -1.921838, -2.901567>,
      < 3.829013, -1.870416, -1.747609>,
      < 3.827017, -1.921838, -1.747609>
    }
    triangle {
      < 3.829013, -1.870416, -2.928818>,
      < 3.931926, -1.576616, -3.023407>,
      < 3.931926, -1.576616, -1.747609>
    }
    triangle {
      < 3.829013, -1.870416, -2.928818>,
      < 3.931926, -1.576616, -1.747609>,
      < 3.829013, -1.870416, -1.747609>
    }
    triangle {
      < 3.931926, -1.576616, -3.023407>,
      < 4.036805, -1.444195, -3.053520>,
      < 4.036805, -1.444195, -1.747609>
    }
    triangle {
      < 3.931926, -1.576616, -3.023407>,
      < 4.036805, -1.444195, -1.747609>,
      < 3.931926, -1.576616, -1.747609>
    }
    triangle {
      < 4.036805, -1.444195, -3.053520>,
      < 4.203426, -1.317132, -3.072573>,
      < 4.203426, -1.317132, -1.747609>
    }
    triangle {
      < 4.036805, -1.444195, -3.053520>,
      < 4.203426, -1.317132, -1.747609>,
      < 4.036805, -1.444195, -1.747609>
    }
    triangle {
      < 4.203426, -1.317132, -3.072573>,
      < 4.418622, -1.236594, -3.089916>,
      < 4.418622, -1.236594, -1.747609>
    }
    triangle {
      < 4.203426, -1.317132, -3.072573>,
      < 4.418622, -1.236594, -1.747609>,
      < 4.203426, -1.317132, -1.747609>
    }
    triangle {
      < 4.418622, -1.236594, -3.089916>,
      < 4.704625, -1.197789, -3.087335>,
      < 4.704625, -1.197789, -1.747609>
    }
    triangle {
      < 4.418622, -1.236594, -3.089916>,
      < 4.704625, -1.197789, -1.747609>,
      < 4.418622, -1.236594, -1.747609>
    }
    triangle {
      < 4.704625, -1.197789, -3.087335>,
      < 5.075943, -1.202748, -3.086273>,
      < 5.075943, -1.202748, -1.747609>
    }
    triangle {
      < 4.704625, -1.197789, -3.087335>,
      < 5.075943, -1.202748, -1.747609>,
      < 4.704625, -1.197789, -1.747609>
    }
    triangle {
      < 5.075943, -1.202748, -3.086273>,
      < 5.645978, -1.296764, -3.066880>,
      < 5.645978, -1.296764, -1.747609>
    }
    triangle {
      < 5.075943, -1.202748, -3.086273>,
      < 5.645978, -1.296764, -1.747609>,
      < 5.075943, -1.202748, -1.747609>
    }
    triangle {
      < 5.645978, -1.296764, -3.066880>,
      < 6.224681, -1.470219, -3.043646>,
      < 6.224681, -1.470219, -1.747609>
    }
    triangle {
      < 5.645978, -1.296764, -3.066880>,
      < 6.224681, -1.470219, -1.747609>,
      < 5.645978, -1.296764, -1.747609>
    }
    triangle {
      < 6.224681, -1.470219, -3.043646>,
      < 6.912721, -1.695685, -2.927237>,
      < 6.912721, -1.695685, -1.747609>
    }
    triangle {
      < 6.224681, -1.470219, -3.043646>,
      < 6.912721, -1.695685, -1.747609>,
      < 6.224681, -1.470219, -1.747609>
    }
    triangle {
      < 3.715029, -2.025404, 0.000000>,
      < 3.715029, -2.025404, -1.747609>,
      < 7.210523, -1.845708, -1.747609>
    }
    triangle {
      < 3.715029, -2.025404, 0.000000>,
      < 7.210523, -1.845708, -1.747609>,
      < 7.408657, -1.865725, 0.000000>
    }
    triangle {
      < 3.715029, -2.025404, 0.000000>,
      < 7.408657, -1.865725, 0.000000>,
      < 7.210523, -1.845708, 0.000000>
    }
    triangle {
      < 7.408657, -1.865725, 0.000000>,
      < 7.210523, -1.845708, -1.747609>,
      < 7.210523, -1.845708, -2.831152>
    }
    triangle {
      < 7.408657, -1.865725, 0.000000>,
      < 7.210523, -1.845708, -2.831152>,
      < 7.408657, -1.865725, -2.811972>
    }
    triangle {
      < 7.408657, -1.865725, 0.000000>,
      < 7.408657, -1.865725, -2.811972>,
      < 7.979931, -1.865773, -2.744938>
    }
    triangle {
      < 7.408657, -1.865725, 0.000000>,
      < 7.979931, -1.865773, -2.744938>,
      < 7.979931, -1.865773, -2.699738>
    }
    triangle {
      < 7.408657, -1.865725, 0.000000>,
      < 7.979931, -1.865773, -2.699738>,
      < 7.979931, -1.865773, 0.000000>
    }
    triangle {
      < 3.789022, -1.973501, -1.747609>,
      < 7.210523, -1.845708, -1.747609>,
      < 3.715029, -2.025404, -1.747609>
    }
    triangle {
      < 7.210523, -1.845708, -1.747609>,
      < 3.789022, -1.973501, -1.747609>,
      < 3.827017, -1.921838, -1.747609>
    }
    triangle {
      < 7.210523, -1.845708, -1.747609>,
      < 3.827017, -1.921838, -1.747609>,
      < 3.829013, -1.870416, -1.747609>
    }
    triangle {
      < 7.210523, -1.845708, -1.747609>,
      < 3.829013, -1.870416, -1.747609>,
      < 3.931926, -1.576616, -1.747609>
    }
    triangle {
      < 7.210523, -1.845708, -1.747609>,
      < 3.931926, -1.576616, -1.747609>,
      < 4.036805, -1.444195, -1.747609>
    }
    triangle {
      < 7.210523, -1.845708, -1.747609>,
      < 4.036805, -1.444195, -1.747609>,
      < 6.224681, -1.470219, -1.747609>
    }
    triangle {
      < 7.210523, -1.845708, -1.747609>,
      < 6.224681, -1.470219, -1.747609>,
      < 6.912721, -1.695685, -1.747609>
    }
    triangle {
      < 5.645978, -1.296764, -1.747609>,
      < 4.418622, -1.236594, -1.747609>,
      < 4.704625, -1.197789, -1.747609>
    }
    triangle {
      < 5.645978, -1.296764, -1.747609>,
      < 4.704625, -1.197789, -1.747609>,
      < 5.075943, -1.202748, -1.747609>
    }
    texture {bottom}
  }
  // orn
  union {
    triangle {
      < 8.405490, -0.095794, -0.815684>,
      < 8.394976, -0.070614, -0.845775>,
      < 8.414921, -0.085937, -0.796610>
    }
    triangle {
      < 8.414921, -0.085937, -0.796610>,
      < 8.394976, -0.070614, -0.845775>,
      < 8.413591, -0.060930, -0.791835>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -3.070839, 0.530228, 1.348220>,
      < -3.059436, 0.525226, 1.386560>,
      < -2.933282, 0.535217, 1.302090>
    }
    triangle {
      < -2.933282, 0.535217, 1.302090>,
      < -3.072534, 0.545230, 1.254827>,
      < -3.069289, 0.550229, 1.300811>
    }
    triangle {
      < -6.034318, 0.438167, 1.163428>,
      < -6.103782, 0.405498, 1.131757>,
      < -6.102836, 0.405456, 1.150682>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.909551, -0.299402, 0.000000>,
      < -6.926939, -0.199401, 0.000000>,
      < -6.805052, -0.059433, 0.847532>
    }
    triangle {
      < -6.909551, -0.299402, 0.000000>,
      < -6.805052, -0.059433, 0.847532>,
      < -6.812109, -0.069434, 0.882889>
    }
    triangle {
      < -6.909551, -0.299402, 0.000000>,
      < -6.812109, -0.069434, 0.882889>,
      < -6.828452, -0.089431, 0.830134>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -6.772749, 0.100569, 0.650350>,
      < -6.697175, 0.035545, 1.306025>,
      < -6.632165, 0.140540, 1.306276>
    }
    triangle {
      < -6.772749, 0.100569, 0.650350>,
      < -6.632165, 0.140540, 1.306276>,
      < -6.716984, 0.205564, 0.654411>
    }
    triangle {
      < -5.555390, 0.530446, 1.279130>,
      < -5.567408, 0.500250, 1.184759>,
      < -5.960786, 0.490270, 1.196739>
    }
    triangle {
      < -5.555390, 0.530446, 1.279130>,
      < -5.960786, 0.490270, 1.196739>,
      < -5.960172, 0.518346, 1.291770>
    }
    triangle {
      < -6.604657, 0.295554, 0.651380>,
      < -6.674516, 0.315577, 0.000000>,
      < -6.766448, 0.240585, 0.000000>
    }
    triangle {
      < -6.604657, 0.295554, 0.651380>,
      < -6.766448, 0.240585, 0.000000>,
      < -6.716984, 0.205564, 0.654411>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.818110, -0.074432, 0.842097>,
      < -6.812109, -0.069434, 0.882889>,
      < -6.805052, -0.059433, 0.847532>
    }
    triangle {
      < -6.828452, -0.089431, 0.830134>,
      < -6.812109, -0.069434, 0.882889>,
      < -6.818110, -0.074432, 0.842097>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -6.723934, -0.419467, 1.857839>,
      < -6.809813, -0.364444, 1.282125>,
      < -6.852518, -0.439441, 1.283499>
    }
    triangle {
      < -6.723934, -0.419467, 1.857839>,
      < -6.852518, -0.439441, 1.283499>,
      < -6.773168, -0.484462, 1.856496>
    }
    triangle {
      < -5.567408, 0.500250, 1.184759>,
      < -5.586890, 0.475105, 1.113520>,
      < -5.958795, 0.463829, 1.152349>
    }
    triangle {
      < -5.567408, 0.500250, 1.184759>,
      < -5.958795, 0.463829, 1.152349>,
      < -5.960786, 0.490270, 1.196739>
    }
    texture {hood}
  }
  // trim
  union {
    triangle {
      < -6.743127, -0.292188, 2.902118>,
      < -6.550397, -0.323618, 2.914041>,
      < -6.547824, -0.292206, 2.932751>
    }
    texture {trim}
  }
  // hood
  union {
    triangle {
      < -2.931157, 0.575235, 0.607670>,
      < -2.945995, 0.575252, 0.000000>,
      < -3.504409, 0.565301, 0.000000>
    }
    triangle {
      < -2.931157, 0.575235, 0.607670>,
      < -3.504409, 0.565301, 0.000000>,
      < -3.483353, 0.560283, 0.610196>
    }
    triangle {
      < -5.628418, 0.470470, 0.632759>,
      < -5.715290, 0.475494, 0.000000>,
      < -6.248342, 0.420540, 0.000000>
    }
    triangle {
      < -5.628418, 0.470470, 0.632759>,
      < -6.248342, 0.420540, 0.000000>,
      < -6.164611, 0.415516, 0.643061>
    }
    triangle {
      < -6.723934, -0.419467, 1.857839>,
      < -6.668155, -0.139472, 1.861905>,
      < -6.732543, -0.074451, 1.298965>
    }
    triangle {
      < -6.723934, -0.419467, 1.857839>,
      < -6.732543, -0.074451, 1.298965>,
      < -6.809813, -0.364444, 1.282125>
    }
    triangle {
      < -6.533515, 0.065517, 1.860501>,
      < -6.460075, 0.150510, 1.868090>,
      < -6.539279, 0.243124, 1.292395>
    }
    triangle {
      < -6.533515, 0.065517, 1.860501>,
      < -6.539279, 0.243124, 1.292395>,
      < -6.632165, 0.140540, 1.306276>
    }
    triangle {
      < -6.732543, -0.074451, 1.298965>,
      < -6.668155, -0.139472, 1.861905>,
      < -6.623542, -0.034476, 1.865155>
    }
    triangle {
      < -6.732543, -0.074451, 1.298965>,
      < -6.623542, -0.034476, 1.865155>,
      < -6.697175, 0.035545, 1.306025>
    }
    triangle {
      < -5.557968, 0.500444, 1.379595>,
      < -5.555390, 0.530446, 1.279130>,
      < -5.960172, 0.518346, 1.291770>
    }
    triangle {
      < -5.557968, 0.500444, 1.379595>,
      < -5.960172, 0.518346, 1.291770>,
      < -5.960360, 0.490232, 1.387106>
    }
    triangle {
      < -3.357367, 0.464914, 1.876387>,
      < -3.439059, 0.510101, 1.410795>,
      < -4.687379, 0.460365, 1.490486>
    }
    triangle {
      < -3.357367, 0.464914, 1.876387>,
      < -4.687379, 0.460365, 1.490486>,
      < -4.639324, 0.415351, 1.867963>
    }
    texture {hood}
  }
  // bottom
  union {
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.370975, -1.859520, 2.723353>,
      < -6.503947, -1.849508, 2.688095>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.503947, -1.849508, 2.688095>,
      < -6.602015, -1.839498, 2.650247>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.602015, -1.839498, 2.650247>,
      < -6.686976, -1.844489, 2.586358>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.686976, -1.844489, 2.586358>,
      < -6.752730, -1.839481, 2.511016>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.752730, -1.839481, 2.511016>,
      < -6.834743, -1.834470, 2.351647>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.834743, -1.834470, 2.351647>,
      < -6.862916, -1.839463, 2.163813>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.862916, -1.839463, 2.163813>,
      < -6.923715, -1.839447, 1.767040>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.923715, -1.839447, 1.767040>,
      < -7.096247, -1.824386, 0.000000>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -7.096247, -1.824386, 0.000000>,
      < -6.073455, -1.859547, 0.000000>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.073455, -1.859547, 0.000000>,
      < -6.073455, -1.859547, 1.747609>
    }
    texture {bottom}
  }
  // black
  union {
    triangle {
      < -7.022356, 0.270845, 2.233527>,
      < -7.063996, 0.318964, 2.411743>,
      < -7.040396, 0.324326, 2.411743>
    }
    triangle {
      < -7.022356, 0.270845, 2.233527>,
      < -7.040396, 0.324326, 2.411743>,
      < -6.998756, 0.275547, 2.233527>
    }
    triangle {
      < -7.063996, 0.318964, 2.411743>,
      < -7.068709, 0.320061, 2.499018>,
      < -7.045109, 0.325588, 2.499018>
    }
    triangle {
      < -7.063996, 0.318964, 2.411743>,
      < -7.045109, 0.325588, 2.499018>,
      < -7.040396, 0.324326, 2.411743>
    }
    triangle {
      < -7.068709, 0.320061, 2.499018>,
      < -7.035048, 0.275753, 2.670665>,
      < -7.011448, 0.280537, 2.670665>
    }
    triangle {
      < -7.068709, 0.320061, 2.499018>,
      < -7.011448, 0.280537, 2.670665>,
      < -7.045109, 0.325588, 2.499018>
    }
    triangle {
      < -7.035048, 0.275753, 2.670665>,
      < -6.960614, 0.197063, 2.795497>,
      < -6.937014, 0.200527, 2.795497>
    }
    triangle {
      < -7.035048, 0.275753, 2.670665>,
      < -6.937014, 0.200527, 2.795497>,
      < -7.011448, 0.280537, 2.670665>
    }
    triangle {
      < -6.960614, 0.197063, 2.795497>,
      < -6.855350, 0.064279, 2.862890>,
      < -6.831750, 0.065516, 2.862890>
    }
    triangle {
      < -6.960614, 0.197063, 2.795497>,
      < -6.831750, 0.065516, 2.862890>,
      < -6.937014, 0.200527, 2.795497>
    }
    triangle {
      < -6.855350, 0.064279, 2.862890>,
      < -6.799399, -0.009489, 2.873777>,
      < -6.775799, -0.009489, 2.873777>
    }
    triangle {
      < -6.855350, 0.064279, 2.862890>,
      < -6.775799, -0.009489, 2.873777>,
      < -6.831750, 0.065516, 2.862890>
    }
    triangle {
      < -6.799399, -0.009489, 2.873777>,
      < -6.769115, -0.068501, 2.876542>,
      < -6.745515, -0.069491, 2.876542>
    }
    triangle {
      < -6.799399, -0.009489, 2.873777>,
      < -6.745515, -0.069491, 2.876542>,
      < -6.775799, -0.009489, 2.873777>
    }
    triangle {
      < -6.769115, -0.068501, 2.876542>,
      < -6.765629, -0.294491, 2.856221>,
      < -6.742029, -0.294491, 2.856221>
    }
    triangle {
      < -6.769115, -0.068501, 2.876542>,
      < -6.742029, -0.294491, 2.856221>,
      < -6.745515, -0.069491, 2.876542>
    }
    triangle {
      < -6.757581, -0.079470, 2.018336>,
      < -6.782136, -0.009468, 2.025174>,
      < -6.758536, -0.009468, 2.025174>
    }
    triangle {
      < -6.757581, -0.079470, 2.018336>,
      < -6.758536, -0.009468, 2.025174>,
      < -6.733982, -0.079470, 2.018336>
    }
    triangle {
      < -6.782136, -0.009468, 2.025174>,
      < -6.846581, 0.069217, 2.034971>,
      < -6.822981, 0.070537, 2.034971>
    }
    triangle {
      < -6.782136, -0.009468, 2.025174>,
      < -6.822981, 0.070537, 2.034971>,
      < -6.758536, -0.009468, 2.025174>
    }
    triangle {
      < -6.846581, 0.069217, 2.034971>,
      < -6.960692, 0.206915, 2.118648>,
      < -6.937092, 0.210545, 2.118648>
    }
    triangle {
      < -6.846581, 0.069217, 2.034971>,
      < -6.937092, 0.210545, 2.118648>,
      < -6.822981, 0.070537, 2.034971>
    }
    triangle {
      < -6.960692, 0.206915, 2.118648>,
      < -7.022356, 0.270845, 2.233527>,
      < -6.998756, 0.275547, 2.233527>
    }
    triangle {
      < -6.960692, 0.206915, 2.118648>,
      < -6.998756, 0.275547, 2.233527>,
      < -6.937092, 0.210545, 2.118648>
    }
    texture {black}
  }
  // hlight
  union {
    triangle {
      < -6.847019, 0.024951, 2.586992>,
      < -6.847389, -0.041836, 2.635788>,
      < -6.805604, -0.002191, 2.729949>
    }
    triangle {
      < -6.847019, 0.024951, 2.586992>,
      < -6.805604, -0.002191, 2.729949>,
      < -6.805049, 0.097988, 2.656756>
    }
    texture {hlight}
  }
  // net
  union {
    triangle {
      < -6.837502, -0.016683, 2.059246>,
      < -6.857495, -0.015160, 2.045397>,
      < -6.834251, -0.079229, 2.038333>
    }
    triangle {
      < -6.806168, -0.232484, 2.763064>,
      < -6.841718, -0.289349, 2.836606>,
      < -6.845248, -0.069362, 2.856545>
    }
    triangle {
      < -6.806168, -0.232484, 2.763064>,
      < -6.845248, -0.069362, 2.856545>,
      < -6.805801, -0.122246, 2.778569>
    }
    triangle {
      < -6.928379, 0.052304, 2.843365>,
      < -7.029285, 0.172025, 2.778870>,
      < -6.852876, 0.122928, 2.743728>
    }
    triangle {
      < -6.928379, 0.052304, 2.843365>,
      < -6.852876, 0.122928, 2.743728>,
      < -6.844799, 0.017019, 2.819852>
    }
    triangle {
      < -7.132436, 0.281541, 2.496710>,
      < -7.128163, 0.281420, 2.415889>,
      < -6.859937, 0.215047, 2.430470>
    }
    triangle {
      < -7.132436, 0.281541, 2.496710>,
      < -6.859937, 0.215047, 2.430470>,
      < -6.861089, 0.214310, 2.473609>
    }
    triangle {
      < -7.087681, 0.236878, 2.242903>,
      < -6.856724, 0.183102, 2.273175>,
      < -6.859937, 0.215047, 2.430470>
    }
    triangle {
      < -7.087681, 0.236878, 2.242903>,
      < -6.859937, 0.215047, 2.430470>,
      < -7.128163, 0.281420, 2.415889>
    }
    triangle {
      < -7.029095, 0.180308, 2.134510>,
      < -6.851715, 0.125842, 2.159429>,
      < -6.856724, 0.183102, 2.273175>
    }
    triangle {
      < -7.029095, 0.180308, 2.134510>,
      < -6.856724, 0.183102, 2.273175>,
      < -7.087681, 0.236878, 2.242903>
    }
    triangle {
      < -6.919741, 0.056316, 2.054514>,
      < -6.842713, 0.016693, 2.075266>,
      < -6.851715, 0.125842, 2.159429>
    }
    triangle {
      < -6.919741, 0.056316, 2.054514>,
      < -6.851715, 0.125842, 2.159429>,
      < -7.029095, 0.180308, 2.134510>
    }
    triangle {
      < -6.845248, -0.069362, 2.856545>,
      < -6.840583, -0.014346, 2.836553>,
      < -6.805801, -0.122246, 2.778569>
    }
    triangle {
      < -7.100271, 0.241778, 2.660793>,
      < -6.858394, 0.185584, 2.625300>,
      < -6.852876, 0.122928, 2.743728>
    }
    triangle {
      < -7.100271, 0.241778, 2.660793>,
      < -6.852876, 0.122928, 2.743728>,
      < -7.029285, 0.172025, 2.778870>
    }
    triangle {
      < -6.874547, -0.014609, 2.853755>,
      < -6.928379, 0.052304, 2.843365>,
      < -6.844799, 0.017019, 2.819852>
    }
    triangle {
      < -6.874547, -0.014609, 2.853755>,
      < -6.844799, 0.017019, 2.819852>,
      < -6.840583, -0.014346, 2.836553>
    }
    triangle {
      < -7.100271, 0.241778, 2.660793>,
      < -7.132436, 0.281541, 2.496710>,
      < -6.861089, 0.214310, 2.473609>
    }
    triangle {
      < -7.100271, 0.241778, 2.660793>,
      < -6.861089, 0.214310, 2.473609>,
      < -6.858394, 0.185584, 2.625300>
    }
    triangle {
      < -6.857495, -0.015160, 2.045397>,
      < -6.837502, -0.016683, 2.059246>,
      < -6.842713, 0.016693, 2.075266>
    }
    triangle {
      < -6.857495, -0.015160, 2.045397>,
      < -6.842713, 0.016693, 2.075266>,
      < -6.919741, 0.056316, 2.054514>
    }
    triangle {
      < -6.805894, 0.006324, 2.748495>,
      < -6.805801, -0.122246, 2.778569>,
      < -6.840583, -0.014346, 2.836553>
    }
    triangle {
      < -6.805894, 0.006324, 2.748495>,
      < -6.840583, -0.014346, 2.836553>,
      < -6.844799, 0.017019, 2.819852>
    }
    triangle {
      < -6.805265, 0.112938, 2.670601>,
      < -6.805894, 0.006324, 2.748495>,
      < -6.844799, 0.017019, 2.819852>
    }
    triangle {
      < -6.805265, 0.112938, 2.670601>,
      < -6.844799, 0.017019, 2.819852>,
      < -6.852876, 0.122928, 2.743728>
    }
    triangle {
      < -6.803450, 0.177033, 2.567100>,
      < -6.805265, 0.112938, 2.670601>,
      < -6.852876, 0.122928, 2.743728>
    }
    triangle {
      < -6.803450, 0.177033, 2.567100>,
      < -6.852876, 0.122928, 2.743728>,
      < -6.858394, 0.185584, 2.625300>
    }
    triangle {
      < -6.801351, 0.199405, 2.447439>,
      < -6.803450, 0.177033, 2.567100>,
      < -6.858394, 0.185584, 2.625300>
    }
    triangle {
      < -6.801351, 0.199405, 2.447439>,
      < -6.858394, 0.185584, 2.625300>,
      < -6.861089, 0.214310, 2.473609>
    }
    triangle {
      < -6.801351, 0.199405, 2.447439>,
      < -6.861089, 0.214310, 2.473609>,
      < -6.859937, 0.215047, 2.430470>
    }
    triangle {
      < -6.799222, 0.176365, 2.326069>,
      < -6.801351, 0.199405, 2.447439>,
      < -6.859937, 0.215047, 2.430470>
    }
    triangle {
      < -6.799222, 0.176365, 2.326069>,
      < -6.859937, 0.215047, 2.430470>,
      < -6.856724, 0.183102, 2.273175>
    }
    triangle {
      < -6.797389, 0.110451, 2.221580>,
      < -6.799222, 0.176365, 2.326069>,
      < -6.856724, 0.183102, 2.273175>
    }
    triangle {
      < -6.797389, 0.110451, 2.221580>,
      < -6.856724, 0.183102, 2.273175>,
      < -6.851715, 0.125842, 2.159429>
    }
    triangle {
      < -6.796768, 0.001062, 2.144023>,
      < -6.797389, 0.110451, 2.221580>,
      < -6.851715, 0.125842, 2.159429>
    }
    triangle {
      < -6.796768, 0.001062, 2.144023>,
      < -6.851715, 0.125842, 2.159429>,
      < -6.842713, 0.016693, 2.075266>
    }
    triangle {
      < -6.796768, 0.001062, 2.144023>,
      < -6.842713, 0.016693, 2.075266>,
      < -6.837502, -0.016683, 2.059246>
    }
    triangle {
      < -6.796768, 0.001062, 2.144023>,
      < -6.837502, -0.016683, 2.059246>,
      < -6.796898, -0.130108, 2.116174>
    }
    triangle {
      < -6.874547, -0.014609, 2.853755>,
      < -6.840583, -0.014346, 2.836553>,
      < -6.845248, -0.069362, 2.856545>
    }
    triangle {
      < -6.796898, -0.130108, 2.116174>,
      < -6.837502, -0.016683, 2.059246>,
      < -6.834251, -0.079229, 2.038333>
    }
    texture {net}
  }
  // hlight
  union {
    triangle {
      < -6.847389, -0.041836, 2.635788>,
      < -6.847309, -0.122483, 2.654652>,
      < -6.805484, -0.123162, 2.758246>
    }
    triangle {
      < -6.847389, -0.041836, 2.635788>,
      < -6.805484, -0.123162, 2.758246>,
      < -6.805604, -0.002191, 2.729949>
    }
    triangle {
      < -6.847309, -0.122483, 2.654652>,
      < -6.847563, -0.191258, 2.644979>,
      < -6.805866, -0.226324, 2.743735>
    }
    triangle {
      < -6.847309, -0.122483, 2.654652>,
      < -6.805866, -0.226324, 2.743735>,
      < -6.805484, -0.123162, 2.758246>
    }
    triangle {
      < -6.847563, -0.191258, 2.644979>,
      < -6.847480, -0.252759, 2.613168>,
      < -6.805741, -0.318576, 2.696020>
    }
    triangle {
      < -6.847563, -0.191258, 2.644979>,
      < -6.805741, -0.318576, 2.696020>,
      < -6.805866, -0.226324, 2.743735>
    }
    triangle {
      < -6.847480, -0.252759, 2.613168>,
      < -6.846185, -0.313724, 2.539841>,
      < -6.803799, -0.410023, 2.586029>
    }
    triangle {
      < -6.847480, -0.252759, 2.613168>,
      < -6.803799, -0.410023, 2.586029>,
      < -6.805741, -0.318576, 2.696020>
    }
    triangle {
      < -6.846185, -0.313724, 2.539841>,
      < -6.844553, -0.335481, 2.447422>,
      < -6.801350, -0.442659, 2.447400>
    }
    triangle {
      < -6.846185, -0.313724, 2.539841>,
      < -6.801350, -0.442659, 2.447400>,
      < -6.803799, -0.410023, 2.586029>
    }
    triangle {
      < -6.844553, -0.335481, 2.447422>,
      < -6.842945, -0.314432, 2.356460>,
      < -6.798938, -0.411085, 2.310958>
    }
    triangle {
      < -6.844553, -0.335481, 2.447422>,
      < -6.798938, -0.411085, 2.310958>,
      < -6.801350, -0.442659, 2.447400>
    }
    triangle {
      < -6.842945, -0.314432, 2.356460>,
      < -6.841659, -0.255278, 2.283638>,
      < -6.797009, -0.322354, 2.201725>
    }
    triangle {
      < -6.842945, -0.314432, 2.356460>,
      < -6.797009, -0.322354, 2.201725>,
      < -6.798938, -0.411085, 2.310958>
    }
    triangle {
      < -6.841659, -0.255278, 2.283638>,
      < -6.841564, -0.195093, 2.251175>,
      < -6.796867, -0.232077, 2.153030>
    }
    triangle {
      < -6.841659, -0.255278, 2.283638>,
      < -6.796867, -0.232077, 2.153030>,
      < -6.797009, -0.322354, 2.201725>
    }
    triangle {
      < -6.841564, -0.195093, 2.251175>,
      < -6.841796, -0.127439, 2.240164>,
      < -6.797215, -0.130596, 2.136513>
    }
    triangle {
      < -6.841564, -0.195093, 2.251175>,
      < -6.797215, -0.130596, 2.136513>,
      < -6.796867, -0.232077, 2.153030>
    }
    triangle {
      < -6.841796, -0.127439, 2.240164>,
      < -6.841693, -0.045131, 2.257639>,
      < -6.797060, -0.007134, 2.162727>
    }
    triangle {
      < -6.841796, -0.127439, 2.240164>,
      < -6.797060, -0.007134, 2.162727>,
      < -6.797215, -0.130596, 2.136513>
    }
    triangle {
      < -6.841693, -0.045131, 2.257639>,
      < -6.842058, 0.023391, 2.306222>,
      < -6.797607, 0.095650, 2.235601>
    }
    triangle {
      < -6.841693, -0.045131, 2.257639>,
      < -6.797607, 0.095650, 2.235601>,
      < -6.797060, -0.007134, 2.162727>
    }
    triangle {
      < -6.842058, 0.023391, 2.306222>,
      < -6.843212, 0.064574, 2.371506>,
      < -6.799339, 0.157424, 2.333527>
    }
    triangle {
      < -6.842058, 0.023391, 2.306222>,
      < -6.799339, 0.157424, 2.333527>,
      < -6.797607, 0.095650, 2.235601>
    }
    triangle {
      < -6.843212, 0.064574, 2.371506>,
      < -6.844553, 0.078994, 2.447467>,
      < -6.801351, 0.179053, 2.447468>
    }
    triangle {
      < -6.843212, 0.064574, 2.371506>,
      < -6.801351, 0.179053, 2.447468>,
      < -6.799339, 0.157424, 2.333527>
    }
    triangle {
      < -6.844553, 0.078994, 2.447467>,
      < -6.845876, 0.064999, 2.522322>,
      < -6.803336, 0.158060, 2.559751>
    }
    triangle {
      < -6.844553, 0.078994, 2.447467>,
      < -6.803336, 0.158060, 2.559751>,
      < -6.801351, 0.179053, 2.447468>
    }
    triangle {
      < -6.845876, 0.064999, 2.522322>,
      < -6.847019, 0.024951, 2.586992>,
      < -6.805049, 0.097988, 2.656756>
    }
    triangle {
      < -6.845876, 0.064999, 2.522322>,
      < -6.805049, 0.097988, 2.656756>,
      < -6.803336, 0.158060, 2.559751>
    }
    triangle {
      < -6.867658, -0.156192, 2.546221>,
      < -6.867616, -0.186942, 2.530316>,
      < -6.847480, -0.252759, 2.613168>
    }
    triangle {
      < -6.867658, -0.156192, 2.546221>,
      < -6.847480, -0.252759, 2.613168>,
      < -6.847563, -0.191258, 2.644979>
    }
    triangle {
      < -6.867530, -0.121804, 2.551058>,
      < -6.867658, -0.156192, 2.546221>,
      < -6.847563, -0.191258, 2.644979>
    }
    triangle {
      < -6.867530, -0.121804, 2.551058>,
      < -6.847563, -0.191258, 2.644979>,
      < -6.847309, -0.122483, 2.654652>
    }
    triangle {
      < -6.867570, -0.081481, 2.541626>,
      < -6.867530, -0.121804, 2.551058>,
      < -6.847309, -0.122483, 2.654652>
    }
    triangle {
      < -6.867570, -0.081481, 2.541626>,
      < -6.847309, -0.122483, 2.654652>,
      < -6.847389, -0.041836, 2.635788>
    }
    triangle {
      < -6.867385, -0.048088, 2.517228>,
      < -6.867570, -0.081481, 2.541626>,
      < -6.847389, -0.041836, 2.635788>
    }
    triangle {
      < -6.867385, -0.048088, 2.517228>,
      < -6.847389, -0.041836, 2.635788>,
      < -6.847019, 0.024951, 2.586992>
    }
    triangle {
      < -6.866814, -0.028064, 2.484894>,
      < -6.867385, -0.048088, 2.517228>,
      < -6.847019, 0.024951, 2.586992>
    }
    triangle {
      < -6.866814, -0.028064, 2.484894>,
      < -6.847019, 0.024951, 2.586992>,
      < -6.845876, 0.064999, 2.522322>
    }
    triangle {
      < -6.866152, -0.021066, 2.447466>,
      < -6.866814, -0.028064, 2.484894>,
      < -6.845876, 0.064999, 2.522322>
    }
    triangle {
      < -6.866152, -0.021066, 2.447466>,
      < -6.845876, 0.064999, 2.522322>,
      < -6.844553, 0.078994, 2.447467>
    }
    triangle {
      < -6.865482, -0.028276, 2.409486>,
      < -6.866152, -0.021066, 2.447466>,
      < -6.844553, 0.078994, 2.447467>
    }
    triangle {
      < -6.865482, -0.028276, 2.409486>,
      < -6.844553, 0.078994, 2.447467>,
      < -6.843212, 0.064574, 2.371506>
    }
    triangle {
      < -6.864904, -0.048867, 2.376843>,
      < -6.865482, -0.028276, 2.409486>,
      < -6.843212, 0.064574, 2.371506>
    }
    triangle {
      < -6.864904, -0.048867, 2.376843>,
      < -6.843212, 0.064574, 2.371506>,
      < -6.842058, 0.023391, 2.306222>
    }
    triangle {
      < -6.864722, -0.083128, 2.352552>,
      < -6.864904, -0.048867, 2.376843>,
      < -6.842058, 0.023391, 2.306222>
    }
    triangle {
      < -6.864722, -0.083128, 2.352552>,
      < -6.842058, 0.023391, 2.306222>,
      < -6.841693, -0.045131, 2.257639>
    }
    triangle {
      < -6.864774, -0.124282, 2.343814>,
      < -6.864722, -0.083128, 2.352552>,
      < -6.841693, -0.045131, 2.257639>
    }
    triangle {
      < -6.864774, -0.124282, 2.343814>,
      < -6.841693, -0.045131, 2.257639>,
      < -6.841796, -0.127439, 2.240164>
    }
    triangle {
      < -6.864658, -0.158109, 2.349320>,
      < -6.864774, -0.124282, 2.343814>,
      < -6.841796, -0.127439, 2.240164>
    }
    triangle {
      < -6.864658, -0.158109, 2.349320>,
      < -6.841796, -0.127439, 2.240164>,
      < -6.841564, -0.195093, 2.251175>
    }
    triangle {
      < -6.864705, -0.188201, 2.365551>,
      < -6.864658, -0.158109, 2.349320>,
      < -6.841564, -0.195093, 2.251175>
    }
    triangle {
      < -6.864705, -0.188201, 2.365551>,
      < -6.841564, -0.195093, 2.251175>,
      < -6.841659, -0.255278, 2.283638>
    }
    triangle {
      < -6.865348, -0.217778, 2.401963>,
      < -6.864705, -0.188201, 2.365551>,
      < -6.841659, -0.255278, 2.283638>
    }
    triangle {
      < -6.865348, -0.217778, 2.401963>,
      < -6.841659, -0.255278, 2.283638>,
      < -6.842945, -0.314432, 2.356460>
    }
    triangle {
      < -6.866151, -0.228303, 2.447443>,
      < -6.865348, -0.217778, 2.401963>,
      < -6.842945, -0.314432, 2.356460>
    }
    triangle {
      < -6.866151, -0.228303, 2.447443>,
      < -6.842945, -0.314432, 2.356460>,
      < -6.844553, -0.335481, 2.447422>
    }
    triangle {
      < -6.866968, -0.217424, 2.493653>,
      < -6.866151, -0.228303, 2.447443>,
      < -6.844553, -0.335481, 2.447422>
    }
    triangle {
      < -6.866968, -0.217424, 2.493653>,
      < -6.844553, -0.335481, 2.447422>,
      < -6.846185, -0.313724, 2.539841>
    }
    triangle {
      < -6.867616, -0.186942, 2.530316>,
      < -6.866968, -0.217424, 2.493653>,
      < -6.846185, -0.313724, 2.539841>
    }
    triangle {
      < -6.867616, -0.186942, 2.530316>,
      < -6.846185, -0.313724, 2.539841>,
      < -6.847480, -0.252759, 2.613168>
    }
    triangle {
      < -6.864774, -0.124282, 2.343814>,
      < -6.864658, -0.158109, 2.349320>,
      < -6.864705, -0.188201, 2.365551>
    }
    triangle {
      < -6.864774, -0.124282, 2.343814>,
      < -6.864705, -0.188201, 2.365551>,
      < -6.865348, -0.217778, 2.401963>
    }
    triangle {
      < -6.864774, -0.124282, 2.343814>,
      < -6.865348, -0.217778, 2.401963>,
      < -6.866151, -0.228303, 2.447443>
    }
    triangle {
      < -6.864774, -0.124282, 2.343814>,
      < -6.866151, -0.228303, 2.447443>,
      < -6.870951, -0.123043, 2.447436>
    }
    triangle {
      < -6.865482, -0.028276, 2.409486>,
      < -6.864904, -0.048867, 2.376843>,
      < -6.864722, -0.083128, 2.352552>
    }
    triangle {
      < -6.865482, -0.028276, 2.409486>,
      < -6.864722, -0.083128, 2.352552>,
      < -6.864774, -0.124282, 2.343814>
    }
    triangle {
      < -6.865482, -0.028276, 2.409486>,
      < -6.864774, -0.124282, 2.343814>,
      < -6.870951, -0.123043, 2.447436>
    }
    triangle {
      < -6.865482, -0.028276, 2.409486>,
      < -6.870951, -0.123043, 2.447436>,
      < -6.866152, -0.021066, 2.447466>
    }
    triangle {
      < -6.867530, -0.121804, 2.551058>,
      < -6.867570, -0.081481, 2.541626>,
      < -6.867385, -0.048088, 2.517228>
    }
    triangle {
      < -6.867530, -0.121804, 2.551058>,
      < -6.867385, -0.048088, 2.517228>,
      < -6.866814, -0.028064, 2.484894>
    }
    triangle {
      < -6.867530, -0.121804, 2.551058>,
      < -6.866814, -0.028064, 2.484894>,
      < -6.866152, -0.021066, 2.447466>
    }
    triangle {
      < -6.867530, -0.121804, 2.551058>,
      < -6.866152, -0.021066, 2.447466>,
      < -6.870951, -0.123043, 2.447436>
    }
    triangle {
      < -6.866968, -0.217424, 2.493653>,
      < -6.867616, -0.186942, 2.530316>,
      < -6.867658, -0.156192, 2.546221>
    }
    triangle {
      < -6.866968, -0.217424, 2.493653>,
      < -6.867658, -0.156192, 2.546221>,
      < -6.867530, -0.121804, 2.551058>
    }
    triangle {
      < -6.866968, -0.217424, 2.493653>,
      < -6.867530, -0.121804, 2.551058>,
      < -6.870951, -0.123043, 2.447436>
    }
    triangle {
      < -6.866968, -0.217424, 2.493653>,
      < -6.870951, -0.123043, 2.447436>,
      < -6.866151, -0.228303, 2.447443>
    }
    texture {hlight}
  }
  // trim
  union {
    triangle {
      < -5.447547, -0.233197, 2.982637>,
      < -6.259114, -0.247901, 2.939256>,
      < -6.261021, -0.294883, 2.952750>
    }
    triangle {
      < -5.447547, -0.233197, 2.982637>,
      < -6.261021, -0.294883, 2.952750>,
      < -5.447221, -0.284804, 3.001511>
    }
    triangle {
      < -3.222914, -0.285354, 3.026460>,
      < -3.224575, -0.238647, 3.006465>,
      < -4.549205, -0.233019, 3.001480>
    }
    triangle {
      < -3.222914, -0.285354, 3.026460>,
      < -4.549205, -0.233019, 3.001480>,
      < -4.553186, -0.282382, 3.022923>
    }
    texture {trim}
  }
  // hood
  union {
    triangle {
      < -4.639324, 0.415351, 1.867963>,
      < -4.687379, 0.460365, 1.490486>,
      < -5.564794, 0.415442, 1.490401>
    }
    triangle {
      < -4.639324, 0.415351, 1.867963>,
      < -5.564794, 0.415442, 1.490401>,
      < -5.511751, 0.360427, 1.867509>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.509136, -0.203522, 2.916189>,
      < -6.449501, -0.171873, 2.917568>,
      < -6.439514, -0.028014, 2.909794>
    }
    triangle {
      < -6.509136, -0.203522, 2.916189>,
      < -6.439514, -0.028014, 2.909794>,
      < -6.494899, 0.001477, 2.905111>
    }
    triangle {
      < -6.120342, -0.197891, 2.928570>,
      < -6.061722, -0.166179, 2.929018>,
      < -6.056494, -0.022025, 2.916862>
    }
    triangle {
      < -6.120342, -0.197891, 2.928570>,
      < -6.056494, -0.022025, 2.916862>,
      < -6.112895, 0.007528, 2.911247>
    }
    triangle {
      < -6.327809, -0.203586, 2.920697>,
      < -6.269356, -0.172128, 2.921570>,
      < -6.260139, -0.029177, 2.911535>
    }
    triangle {
      < -6.327809, -0.203586, 2.920697>,
      < -6.260139, -0.029177, 2.911535>,
      < -6.316707, 0.000122, 2.906346>
    }
    triangle {
      < -6.061722, -0.166179, 2.929018>,
      < -6.120342, -0.197891, 2.928570>,
      < -6.119413, -0.199368, 2.911458>
    }
    triangle {
      < -6.061722, -0.166179, 2.929018>,
      < -6.119413, -0.199368, 2.911458>,
      < -6.060792, -0.167655, 2.911906>
    }
    triangle {
      < -6.120342, -0.197891, 2.928570>,
      < -6.112895, 0.007528, 2.911247>,
      < -6.111966, 0.006052, 2.894136>
    }
    triangle {
      < -6.120342, -0.197891, 2.928570>,
      < -6.111966, 0.006052, 2.894136>,
      < -6.119413, -0.199368, 2.911458>
    }
    triangle {
      < -6.112895, 0.007528, 2.911247>,
      < -6.056494, -0.022025, 2.916862>,
      < -6.055564, -0.023501, 2.899750>
    }
    triangle {
      < -6.112895, 0.007528, 2.911247>,
      < -6.055564, -0.023501, 2.899750>,
      < -6.111966, 0.006052, 2.894136>
    }
    triangle {
      < -6.056494, -0.022025, 2.916862>,
      < -6.061722, -0.166179, 2.929018>,
      < -6.060792, -0.167655, 2.911906>
    }
    triangle {
      < -6.056494, -0.022025, 2.916862>,
      < -6.060792, -0.167655, 2.911906>,
      < -6.055564, -0.023501, 2.899750>
    }
    triangle {
      < -6.269356, -0.172128, 2.921570>,
      < -6.327809, -0.203586, 2.920697>,
      < -6.326883, -0.204846, 2.903568>
    }
    triangle {
      < -6.269356, -0.172128, 2.921570>,
      < -6.326883, -0.204846, 2.903568>,
      < -6.268429, -0.173387, 2.904441>
    }
    triangle {
      < -6.327809, -0.203586, 2.920697>,
      < -6.316707, 0.000122, 2.906346>,
      < -6.315780, -0.001138, 2.889217>
    }
    triangle {
      < -6.327809, -0.203586, 2.920697>,
      < -6.315780, -0.001138, 2.889217>,
      < -6.326883, -0.204846, 2.903568>
    }
    triangle {
      < -6.316707, 0.000122, 2.906346>,
      < -6.260139, -0.029177, 2.911535>,
      < -6.259212, -0.030437, 2.894406>
    }
    triangle {
      < -6.316707, 0.000122, 2.906346>,
      < -6.259212, -0.030437, 2.894406>,
      < -6.315780, -0.001138, 2.889217>
    }
    triangle {
      < -6.260139, -0.029177, 2.911535>,
      < -6.269356, -0.172128, 2.921570>,
      < -6.268429, -0.173387, 2.904441>
    }
    triangle {
      < -6.260139, -0.029177, 2.911535>,
      < -6.268429, -0.173387, 2.904441>,
      < -6.259212, -0.030437, 2.894406>
    }
    triangle {
      < -6.449501, -0.171873, 2.917568>,
      < -6.509136, -0.203522, 2.916189>,
      < -6.508213, -0.204513, 2.899042>
    }
    triangle {
      < -6.449501, -0.171873, 2.917568>,
      < -6.508213, -0.204513, 2.899042>,
      < -6.448577, -0.172863, 2.900421>
    }
    triangle {
      < -6.509136, -0.203522, 2.916189>,
      < -6.494899, 0.001477, 2.905111>,
      < -6.493976, 0.000486, 2.887964>
    }
    triangle {
      < -6.509136, -0.203522, 2.916189>,
      < -6.493976, 0.000486, 2.887964>,
      < -6.508213, -0.204513, 2.899042>
    }
    triangle {
      < -6.494899, 0.001477, 2.905111>,
      < -6.439514, -0.028014, 2.909794>,
      < -6.438591, -0.029004, 2.892648>
    }
    triangle {
      < -6.494899, 0.001477, 2.905111>,
      < -6.438591, -0.029004, 2.892648>,
      < -6.493976, 0.000486, 2.887964>
    }
    triangle {
      < -6.439514, -0.028014, 2.909794>,
      < -6.449501, -0.171873, 2.917568>,
      < -6.448577, -0.172863, 2.900421>
    }
    triangle {
      < -6.439514, -0.028014, 2.909794>,
      < -6.448577, -0.172863, 2.900421>,
      < -6.438591, -0.029004, 2.892648>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -6.908277, -0.494436, 1.279438>,
      < -6.840075, -0.524456, 1.851624>,
      < -6.773168, -0.484462, 1.856496>
    }
    triangle {
      < -6.908277, -0.494436, 1.279438>,
      < -6.773168, -0.484462, 1.856496>,
      < -6.852518, -0.439441, 1.283499>
    }
    triangle {
      < -6.986286, -0.464412, 0.657214>,
      < -6.908277, -0.494436, 1.279438>,
      < -6.852518, -0.439441, 1.283499>
    }
    triangle {
      < -6.986286, -0.464412, 0.657214>,
      < -6.852518, -0.439441, 1.283499>,
      < -6.923189, -0.414418, 0.652841>
    }
    triangle {
      < -7.040373, -0.449391, 0.000000>,
      < -6.986286, -0.464412, 0.657214>,
      < -6.923189, -0.414418, 0.652841>
    }
    triangle {
      < -7.040373, -0.449391, 0.000000>,
      < -6.923189, -0.414418, 0.652841>,
      < -6.968031, -0.399397, 0.000000>
    }
    triangle {
      < -6.487709, 0.350544, 0.646443>,
      < -6.546418, 0.365566, 0.000000>,
      < -6.674516, 0.315577, 0.000000>
    }
    triangle {
      < -6.487709, 0.350544, 0.646443>,
      < -6.674516, 0.315577, 0.000000>,
      < -6.604657, 0.295554, 0.651380>
    }
    triangle {
      < -6.539279, 0.243124, 1.292395>,
      < -6.604657, 0.295554, 0.651380>,
      < -6.716984, 0.205564, 0.654411>
    }
    triangle {
      < -6.539279, 0.243124, 1.292395>,
      < -6.716984, 0.205564, 0.654411>,
      < -6.632165, 0.140540, 1.306276>
    }
    triangle {
      < -6.265186, 0.358099, 1.159183>,
      < -6.103782, 0.405498, 1.131757>,
      < -6.164611, 0.415516, 0.643061>
    }
    triangle {
      < -6.265186, 0.358099, 1.159183>,
      < -6.164611, 0.415516, 0.643061>,
      < -6.487709, 0.350544, 0.646443>
    }
    triangle {
      < -6.265186, 0.358099, 1.159183>,
      < -6.487709, 0.350544, 0.646443>,
      < -6.426589, 0.310700, 1.186610>
    }
    triangle {
      < -6.045046, 0.300474, 1.864676>,
      < -6.087345, 0.365488, 1.460283>,
      < -6.244581, 0.329087, 1.428405>
    }
    triangle {
      < -6.045046, 0.300474, 1.864676>,
      < -6.244581, 0.329087, 1.428405>,
      < -6.401817, 0.292686, 1.396527>
    }
    triangle {
      < -6.045046, 0.300474, 1.864676>,
      < -6.401817, 0.292686, 1.396527>,
      < -6.336598, 0.220499, 1.865870>
    }
    triangle {
      < -6.103782, 0.405498, 1.131757>,
      < -5.586890, 0.475105, 1.113520>,
      < -5.628418, 0.470470, 0.632759>
    }
    triangle {
      < -6.103782, 0.405498, 1.131757>,
      < -5.628418, 0.470470, 0.632759>,
      < -6.164611, 0.415516, 0.643061>
    }
    triangle {
      < -5.511751, 0.360427, 1.867509>,
      < -5.564794, 0.415442, 1.490401>,
      < -6.087345, 0.365488, 1.460283>
    }
    triangle {
      < -5.511751, 0.360427, 1.867509>,
      < -6.087345, 0.365488, 1.460283>,
      < -6.045046, 0.300474, 1.864676>
    }
    triangle {
      < -3.088729, 0.535233, 1.217913>,
      < -2.879675, 0.555217, 1.114004>,
      < -2.931157, 0.575235, 0.607670>
    }
    triangle {
      < -3.088729, 0.535233, 1.217913>,
      < -2.931157, 0.575235, 0.607670>,
      < -3.483353, 0.560283, 0.610196>
    }
    triangle {
      < -3.088729, 0.535233, 1.217913>,
      < -3.483353, 0.560283, 0.610196>,
      < -3.452590, 0.530266, 1.169640>
    }
    triangle {
      < -2.933282, 0.535217, 1.302090>,
      < -3.088729, 0.535233, 1.217913>,
      < -3.072534, 0.545230, 1.254827>
    }
    triangle {
      < -3.455293, 0.555263, 1.300857>,
      < -3.445069, 0.540264, 1.230001>,
      < -4.690363, 0.530373, 1.179857>
    }
    triangle {
      < -3.455293, 0.555263, 1.300857>,
      < -4.690363, 0.530373, 1.179857>,
      < -4.692935, 0.550371, 1.280324>
    }
    triangle {
      < -4.701466, 0.515369, 1.376299>,
      < -4.692935, 0.550371, 1.280324>,
      < -5.555390, 0.530446, 1.279130>
    }
    triangle {
      < -4.701466, 0.515369, 1.376299>,
      < -5.555390, 0.530446, 1.279130>,
      < -5.557968, 0.500444, 1.379595>
    }
    triangle {
      < -4.687379, 0.460365, 1.490486>,
      < -4.701466, 0.515369, 1.376299>,
      < -5.557968, 0.500444, 1.379595>
    }
    triangle {
      < -4.687379, 0.460365, 1.490486>,
      < -5.557968, 0.500444, 1.379595>,
      < -5.564794, 0.415442, 1.490401>
    }
    texture {hood}
  }
  // orn
  union {
    triangle {
      < -6.981886, -0.254396, 0.000000>,
      < -6.909551, -0.299402, 0.000000>,
      < -6.828452, -0.089431, 0.830134>
    }
    triangle {
      < -6.981886, -0.254396, 0.000000>,
      < -6.828452, -0.089431, 0.830134>,
      < -6.818110, -0.074432, 0.842097>
    }
    triangle {
      < -6.926939, -0.199401, 0.000000>,
      < -6.981886, -0.254396, 0.000000>,
      < -6.818110, -0.074432, 0.842097>
    }
    triangle {
      < -6.926939, -0.199401, 0.000000>,
      < -6.818110, -0.074432, 0.842097>,
      < -6.805052, -0.059433, 0.847532>
    }
    texture {orn}
  }
  // hood
  union {
    triangle {
      < -5.586890, 0.475105, 1.113520>,
      < -5.955692, 0.433614, 1.129197>,
      < -5.958795, 0.463829, 1.152349>
    }
    triangle {
      < -5.564794, 0.415442, 1.490401>,
      < -5.958843, 0.447611, 1.431477>,
      < -5.956346, 0.402280, 1.458986>
    }
    triangle {
      < -5.564794, 0.415442, 1.490401>,
      < -5.557968, 0.500444, 1.379595>,
      < -5.960360, 0.490232, 1.387106>
    }
    triangle {
      < -5.564794, 0.415442, 1.490401>,
      < -5.960360, 0.490232, 1.387106>,
      < -5.958843, 0.447611, 1.431477>
    }
    triangle {
      < -6.401817, 0.292686, 1.396527>,
      < -6.244581, 0.329087, 1.428405>,
      < -6.088412, 0.365459, 1.438961>
    }
    triangle {
      < -6.401817, 0.292686, 1.396527>,
      < -6.088412, 0.365459, 1.438961>,
      < -6.090918, 0.243125, 1.388875>
    }
    triangle {
      < -6.401817, 0.292686, 1.396527>,
      < -6.090918, 0.243125, 1.388875>,
      < -6.407199, 0.243124, 1.350899>
    }
    triangle {
      < -6.102836, 0.405456, 1.150682>,
      < -6.265186, 0.358099, 1.159183>,
      < -6.426589, 0.310700, 1.186610>
    }
    triangle {
      < -6.102836, 0.405456, 1.150682>,
      < -6.426589, 0.310700, 1.186610>,
      < -6.421206, 0.243124, 1.232237>
    }
    triangle {
      < -6.102836, 0.405456, 1.150682>,
      < -6.421206, 0.243124, 1.232237>,
      < -6.100210, 0.243125, 1.203165>
    }
    triangle {
      < -6.407199, 0.243124, 1.350899>,
      < -6.090918, 0.243125, 1.388875>,
      < -6.100210, 0.243125, 1.203165>
    }
    triangle {
      < -6.407199, 0.243124, 1.350899>,
      < -6.100210, 0.243125, 1.203165>,
      < -6.421206, 0.243124, 1.232237>
    }
    triangle {
      < -5.958843, 0.447611, 1.431477>,
      < -5.987817, 0.451553, 1.412701>,
      < -6.023270, 0.409888, 1.437446>
    }
    triangle {
      < -5.958843, 0.447611, 1.431477>,
      < -6.023270, 0.409888, 1.437446>,
      < -5.956346, 0.402280, 1.458986>
    }
    triangle {
      < -5.960360, 0.490232, 1.387106>,
      < -5.980987, 0.490481, 1.377429>,
      < -5.987817, 0.451553, 1.412701>
    }
    triangle {
      < -5.960360, 0.490232, 1.387106>,
      < -5.987817, 0.451553, 1.412701>,
      < -5.958843, 0.447611, 1.431477>
    }
    triangle {
      < -5.958795, 0.463829, 1.152349>,
      < -5.993377, 0.466484, 1.184726>,
      < -5.980962, 0.490449, 1.215842>
    }
    triangle {
      < -5.958795, 0.463829, 1.152349>,
      < -5.980962, 0.490449, 1.215842>,
      < -5.960786, 0.490270, 1.196739>
    }
    triangle {
      < -5.955692, 0.433614, 1.129197>,
      < -6.034318, 0.438167, 1.163428>,
      < -5.993377, 0.466484, 1.184726>
    }
    triangle {
      < -5.955692, 0.433614, 1.129197>,
      < -5.993377, 0.466484, 1.184726>,
      < -5.958795, 0.463829, 1.152349>
    }
    triangle {
      < -5.960172, 0.518346, 1.291770>,
      < -5.981008, 0.517752, 1.291769>,
      < -5.980987, 0.490481, 1.377429>
    }
    triangle {
      < -5.960172, 0.518346, 1.291770>,
      < -5.980987, 0.490481, 1.377429>,
      < -5.960360, 0.490232, 1.387106>
    }
    triangle {
      < -5.960786, 0.490270, 1.196739>,
      < -5.980962, 0.490449, 1.215842>,
      < -5.981008, 0.517752, 1.291769>
    }
    triangle {
      < -5.960786, 0.490270, 1.196739>,
      < -5.981008, 0.517752, 1.291769>,
      < -5.960172, 0.518346, 1.291770>
    }
    triangle {
      < -6.023270, 0.409888, 1.437446>,
      < -6.087345, 0.365488, 1.460283>,
      < -5.956346, 0.402280, 1.458986>
    }
    triangle {
      < -6.103782, 0.405498, 1.131757>,
      < -6.265186, 0.358099, 1.159183>,
      < -6.102836, 0.405456, 1.150682>
    }
    triangle {
      < -6.087345, 0.365488, 1.460283>,
      < -6.088412, 0.365459, 1.438961>,
      < -6.244581, 0.329087, 1.428405>
    }
    triangle {
      < -6.100210, 0.243125, 1.203165>,
      < -6.034318, 0.438167, 1.163428>,
      < -6.102836, 0.405456, 1.150682>
    }
    triangle {
      < -6.087345, 0.365488, 1.460283>,
      < -6.023270, 0.409888, 1.437446>,
      < -6.088412, 0.365459, 1.438961>
    }
    triangle {
      < -6.088412, 0.365459, 1.438961>,
      < -6.023270, 0.409888, 1.437446>,
      < -6.090918, 0.243125, 1.388875>
    }
    triangle {
      < -6.090918, 0.243125, 1.388875>,
      < -6.023270, 0.409888, 1.437446>,
      < -5.987817, 0.451553, 1.412701>
    }
    triangle {
      < -6.090918, 0.243125, 1.388875>,
      < -5.987817, 0.451553, 1.412701>,
      < -5.980987, 0.490481, 1.377429>
    }
    triangle {
      < -6.090918, 0.243125, 1.388875>,
      < -5.980987, 0.490481, 1.377429>,
      < -5.981008, 0.517752, 1.291769>
    }
    triangle {
      < -6.090918, 0.243125, 1.388875>,
      < -5.981008, 0.517752, 1.291769>,
      < -5.980962, 0.490449, 1.215842>
    }
    triangle {
      < -6.090918, 0.243125, 1.388875>,
      < -5.980962, 0.490449, 1.215842>,
      < -5.993377, 0.466484, 1.184726>
    }
    triangle {
      < -6.090918, 0.243125, 1.388875>,
      < -5.993377, 0.466484, 1.184726>,
      < -6.034318, 0.438167, 1.163428>
    }
    triangle {
      < -6.090918, 0.243125, 1.388875>,
      < -6.034318, 0.438167, 1.163428>,
      < -6.100210, 0.243125, 1.203165>
    }
    triangle {
      < -6.034318, 0.438167, 1.163428>,
      < -5.955692, 0.433614, 1.129197>,
      < -6.103782, 0.405498, 1.131757>
    }
    triangle {
      < -5.956346, 0.402280, 1.458986>,
      < -6.087345, 0.365488, 1.460283>,
      < -5.564794, 0.415442, 1.490401>
    }
    triangle {
      < -5.586890, 0.475105, 1.113520>,
      < -6.103782, 0.405498, 1.131757>,
      < -5.955692, 0.433614, 1.129197>
    }
    texture {hood}
  }
  // bottom
  union {
    triangle {
      < -5.722831, -1.024584, 1.747609>,
      < -6.073455, -1.859547, 1.747609>,
      < -3.052612, -1.408860, 1.747609>
    }
    triangle {
      < -5.722831, -1.024584, 1.747609>,
      < -3.052612, -1.408860, 1.747609>,
      < -3.336812, -1.116545, 1.747609>
    }
    triangle {
      < -5.722831, -1.024584, 1.747609>,
      < -3.336812, -1.116545, 1.747609>,
      < -5.663052, -1.007231, 1.747609>
    }
    texture {bottom}
  }
  // trim
  union {
    triangle {
      < -2.007425, -0.232984, 2.999176>,
      < -3.224575, -0.238647, 3.006465>,
      < -3.222914, -0.285354, 3.026460>
    }
    triangle {
      < -2.007425, -0.232984, 2.999176>,
      < -3.222914, -0.285354, 3.026460>,
      < -2.016263, -0.282503, 3.023225>
    }
    triangle {
      < -5.447547, -0.233197, 2.982637>,
      < -5.447221, -0.284804, 3.001511>,
      < -4.553186, -0.282382, 3.022923>
    }
    triangle {
      < -5.447547, -0.233197, 2.982637>,
      < -4.553186, -0.282382, 3.022923>,
      < -4.549205, -0.233019, 3.001480>
    }
    triangle {
      < -6.545251, -0.260793, 2.922662>,
      < -6.259114, -0.247901, 2.939256>,
      < -6.257797, -0.244839, 2.907863>
    }
    triangle {
      < -6.545251, -0.260793, 2.922662>,
      < -6.257797, -0.244839, 2.907863>,
      < -6.543860, -0.259509, 2.891657>
    }
    triangle {
      < -6.259114, -0.247901, 2.939256>,
      < -5.447547, -0.233197, 2.982637>,
      < -5.446486, -0.229607, 2.950629>
    }
    triangle {
      < -6.259114, -0.247901, 2.939256>,
      < -5.446486, -0.229607, 2.950629>,
      < -6.257797, -0.244839, 2.907863>
    }
    triangle {
      < -5.447547, -0.233197, 2.982637>,
      < -4.549205, -0.233019, 3.001480>,
      < -4.547651, -0.229686, 2.969179>
    }
    triangle {
      < -5.447547, -0.233197, 2.982637>,
      < -4.547651, -0.229686, 2.969179>,
      < -5.446486, -0.229607, 2.950629>
    }
    triangle {
      < -4.549205, -0.233019, 3.001480>,
      < -3.224575, -0.238647, 3.006465>,
      < -3.223694, -0.234801, 2.974232>
    }
    triangle {
      < -4.549205, -0.233019, 3.001480>,
      < -3.223694, -0.234801, 2.974232>,
      < -4.547651, -0.229686, 2.969179>
    }
    triangle {
      < -3.224575, -0.238647, 3.006465>,
      < -2.007425, -0.232984, 2.999176>,
      < -2.005316, -0.229907, 2.966577>
    }
    triangle {
      < -3.224575, -0.238647, 3.006465>,
      < -2.005316, -0.229907, 2.966577>,
      < -3.223694, -0.234801, 2.974232>
    }
    triangle {
      < -2.025116, -0.332021, 3.018539>,
      < -3.221167, -0.334442, 3.017940>,
      < -3.219849, -0.342895, 2.987180>
    }
    triangle {
      < -2.025116, -0.332021, 3.018539>,
      < -3.219849, -0.342895, 2.987180>,
      < -2.025026, -0.339706, 2.988144>
    }
    triangle {
      < -3.221167, -0.334442, 3.017940>,
      < -4.557167, -0.331745, 3.015566>,
      < -4.556523, -0.339685, 2.984874>
    }
    triangle {
      < -3.221167, -0.334442, 3.017940>,
      < -4.556523, -0.339685, 2.984874>,
      < -3.219849, -0.342895, 2.987180>
    }
    triangle {
      < -4.557167, -0.331745, 3.015566>,
      < -5.446893, -0.336410, 2.991585>,
      < -5.445757, -0.344607, 2.960599>
    }
    triangle {
      < -4.557167, -0.331745, 3.015566>,
      < -5.445757, -0.344607, 2.960599>,
      < -4.556523, -0.339685, 2.984874>
    }
    triangle {
      < -5.446893, -0.336410, 2.991585>,
      < -6.262928, -0.341865, 2.937443>,
      < -6.262047, -0.349534, 2.905843>
    }
    triangle {
      < -5.446893, -0.336410, 2.991585>,
      < -6.262047, -0.349534, 2.905843>,
      < -5.445757, -0.344607, 2.960599>
    }
    triangle {
      < -6.262928, -0.341865, 2.937443>,
      < -6.550397, -0.323618, 2.914041>,
      < -6.549592, -0.329509, 2.882052>
    }
    triangle {
      < -6.262928, -0.341865, 2.937443>,
      < -6.549592, -0.329509, 2.882052>,
      < -6.262047, -0.349534, 2.905843>
    }
    triangle {
      < -6.550397, -0.323618, 2.914041>,
      < -6.743127, -0.292188, 2.902118>,
      < -6.742029, -0.294491, 2.856221>
    }
    triangle {
      < -6.550397, -0.323618, 2.914041>,
      < -6.742029, -0.294491, 2.856221>,
      < -6.549592, -0.329509, 2.882052>
    }
    triangle {
      < -6.743127, -0.292188, 2.902118>,
      < -6.545251, -0.260793, 2.922662>,
      < -6.543860, -0.259509, 2.891657>
    }
    triangle {
      < -6.743127, -0.292188, 2.902118>,
      < -6.543860, -0.259509, 2.891657>,
      < -6.742029, -0.294491, 2.856221>
    }
    triangle {
      < -6.262928, -0.341865, 2.937443>,
      < -6.261021, -0.294883, 2.952750>,
      < -6.547824, -0.292206, 2.932751>
    }
    triangle {
      < -6.262928, -0.341865, 2.937443>,
      < -6.547824, -0.292206, 2.932751>,
      < -6.550397, -0.323618, 2.914041>
    }
    triangle {
      < -3.221167, -0.334442, 3.017940>,
      < -2.025116, -0.332021, 3.018539>,
      < -2.016263, -0.282503, 3.023225>
    }
    triangle {
      < -3.221167, -0.334442, 3.017940>,
      < -2.016263, -0.282503, 3.023225>,
      < -3.222914, -0.285354, 3.026460>
    }
    triangle {
      < -4.557167, -0.331745, 3.015566>,
      < -3.221167, -0.334442, 3.017940>,
      < -3.222914, -0.285354, 3.026460>
    }
    triangle {
      < -4.557167, -0.331745, 3.015566>,
      < -3.222914, -0.285354, 3.026460>,
      < -4.553186, -0.282382, 3.022923>
    }
    triangle {
      < -5.446893, -0.336410, 2.991585>,
      < -4.557167, -0.331745, 3.015566>,
      < -4.553186, -0.282382, 3.022923>
    }
    triangle {
      < -5.446893, -0.336410, 2.991585>,
      < -4.553186, -0.282382, 3.022923>,
      < -5.447221, -0.284804, 3.001511>
    }
    triangle {
      < -6.262928, -0.341865, 2.937443>,
      < -5.446893, -0.336410, 2.991585>,
      < -5.447221, -0.284804, 3.001511>
    }
    triangle {
      < -6.262928, -0.341865, 2.937443>,
      < -5.447221, -0.284804, 3.001511>,
      < -6.261021, -0.294883, 2.952750>
    }
    triangle {
      < -6.545251, -0.260793, 2.922662>,
      < -6.743127, -0.292188, 2.902118>,
      < -6.547824, -0.292206, 2.932751>
    }
    triangle {
      < -6.259114, -0.247901, 2.939256>,
      < -6.545251, -0.260793, 2.922662>,
      < -6.547824, -0.292206, 2.932751>
    }
    triangle {
      < -6.259114, -0.247901, 2.939256>,
      < -6.547824, -0.292206, 2.932751>,
      < -6.261021, -0.294883, 2.952750>
    }
    texture {trim}
  }
  // hood
  union {
    triangle {
      < -3.439059, 0.510101, 1.410795>,
      < -3.439615, 0.535260, 1.353574>,
      < -4.701466, 0.515369, 1.376299>
    }
    triangle {
      < -3.439059, 0.510101, 1.410795>,
      < -4.701466, 0.515369, 1.376299>,
      < -4.687379, 0.460365, 1.490486>
    }
    triangle {
      < -3.070839, 0.530228, 1.348220>,
      < -2.933282, 0.535217, 1.302090>,
      < -3.069289, 0.550229, 1.300811>
    }
    triangle {
      < -3.070839, 0.530228, 1.348220>,
      < -3.069289, 0.550229, 1.300811>,
      < -3.455293, 0.555263, 1.300857>
    }
    triangle {
      < -3.070839, 0.530228, 1.348220>,
      < -3.455293, 0.555263, 1.300857>,
      < -3.439615, 0.535260, 1.353574>
    }
    triangle {
      < -5.567408, 0.500250, 1.184759>,
      < -5.555390, 0.530446, 1.279130>,
      < -4.692935, 0.550371, 1.280324>
    }
    triangle {
      < -5.567408, 0.500250, 1.184759>,
      < -4.692935, 0.550371, 1.280324>,
      < -4.690363, 0.530373, 1.179857>
    }
    triangle {
      < -4.700901, 0.500376, 1.105432>,
      < -4.690363, 0.530373, 1.179857>,
      < -3.445069, 0.540264, 1.230001>
    }
    triangle {
      < -4.700901, 0.500376, 1.105432>,
      < -3.445069, 0.540264, 1.230001>,
      < -3.452590, 0.530266, 1.169640>
    }
    triangle {
      < -5.586890, 0.475105, 1.113520>,
      < -5.567408, 0.500250, 1.184759>,
      < -4.690363, 0.530373, 1.179857>
    }
    triangle {
      < -5.586890, 0.475105, 1.113520>,
      < -4.690363, 0.530373, 1.179857>,
      < -4.700901, 0.500376, 1.105432>
    }
    triangle {
      < -3.452590, 0.530266, 1.169640>,
      < -3.445069, 0.540264, 1.230001>,
      < -3.072534, 0.545230, 1.254827>
    }
    triangle {
      < -3.452590, 0.530266, 1.169640>,
      < -3.072534, 0.545230, 1.254827>,
      < -3.088729, 0.535233, 1.217913>
    }
    triangle {
      < -5.628418, 0.470470, 0.632759>,
      < -5.586890, 0.475105, 1.113520>,
      < -4.700901, 0.500376, 1.105432>
    }
    triangle {
      < -5.628418, 0.470470, 0.632759>,
      < -4.700901, 0.500376, 1.105432>,
      < -4.756729, 0.520394, 0.623242>
    }
    triangle {
      < -2.807869, 0.525200, 1.530828>,
      < -2.879675, 0.555217, 1.114004>,
      < -2.933282, 0.535217, 1.302090>
    }
    triangle {
      < -3.088729, 0.535233, 1.217913>,
      < -2.933282, 0.535217, 1.302090>,
      < -2.879675, 0.555217, 1.114004>
    }
    triangle {
      < -4.756729, 0.520394, 0.623242>,
      < -4.700901, 0.500376, 1.105432>,
      < -3.452590, 0.530266, 1.169640>
    }
    triangle {
      < -4.756729, 0.520394, 0.623242>,
      < -3.452590, 0.530266, 1.169640>,
      < -3.483353, 0.560283, 0.610196>
    }
    triangle {
      < -2.807869, 0.525200, 1.530828>,
      < -2.933282, 0.535217, 1.302090>,
      < -3.059436, 0.525226, 1.386560>
    }
    triangle {
      < -2.807869, 0.525200, 1.530828>,
      < -3.059436, 0.525226, 1.386560>,
      < -2.703817, 0.490182, 1.880681>
    }
    triangle {
      < -6.533515, 0.065517, 1.860501>,
      < -6.632165, 0.140540, 1.306276>,
      < -6.697175, 0.035545, 1.306025>
    }
    triangle {
      < -6.533515, 0.065517, 1.860501>,
      < -6.697175, 0.035545, 1.306025>,
      < -6.623542, -0.034476, 1.865155>
    }
    triangle {
      < -5.715290, 0.475494, 0.000000>,
      < -5.628418, 0.470470, 0.632759>,
      < -4.756729, 0.520394, 0.623242>
    }
    triangle {
      < -5.715290, 0.475494, 0.000000>,
      < -4.756729, 0.520394, 0.623242>,
      < -4.822544, 0.530416, 0.000000>
    }
    triangle {
      < -4.822544, 0.530416, 0.000000>,
      < -4.756729, 0.520394, 0.623242>,
      < -3.483353, 0.560283, 0.610196>
    }
    triangle {
      < -4.822544, 0.530416, 0.000000>,
      < -3.483353, 0.560283, 0.610196>,
      < -3.504409, 0.565301, 0.000000>
    }
    triangle {
      < -6.968031, -0.399397, 0.000000>,
      < -6.923189, -0.414418, 0.652841>,
      < -6.871237, -0.324422, 0.647656>
    }
    triangle {
      < -6.968031, -0.399397, 0.000000>,
      < -6.871237, -0.324422, 0.647656>,
      < -6.909551, -0.299402, 0.000000>
    }
    triangle {
      < -6.867636, 0.025594, 0.000000>,
      < -6.806211, -0.004428, 0.647912>,
      < -6.772749, 0.100569, 0.650350>
    }
    triangle {
      < -6.867636, 0.025594, 0.000000>,
      < -6.772749, 0.100569, 0.650350>,
      < -6.831455, 0.140591, 0.000000>
    }
    triangle {
      < -6.909551, -0.299402, 0.000000>,
      < -6.871237, -0.324422, 0.647656>,
      < -6.806211, -0.004428, 0.647912>
    }
    triangle {
      < -6.909551, -0.299402, 0.000000>,
      < -6.806211, -0.004428, 0.647912>,
      < -6.867636, 0.025594, 0.000000>
    }
    triangle {
      < -6.871237, -0.324422, 0.647656>,
      < -6.809813, -0.364444, 1.282125>,
      < -6.732543, -0.074451, 1.298965>
    }
    triangle {
      < -6.871237, -0.324422, 0.647656>,
      < -6.732543, -0.074451, 1.298965>,
      < -6.806211, -0.004428, 0.647912>
    }
    triangle {
      < -6.923189, -0.414418, 0.652841>,
      < -6.852518, -0.439441, 1.283499>,
      < -6.809813, -0.364444, 1.282125>
    }
    triangle {
      < -6.923189, -0.414418, 0.652841>,
      < -6.809813, -0.364444, 1.282125>,
      < -6.871237, -0.324422, 0.647656>
    }
    triangle {
      < -6.806211, -0.004428, 0.647912>,
      < -6.732543, -0.074451, 1.298965>,
      < -6.697175, 0.035545, 1.306025>
    }
    triangle {
      < -6.806211, -0.004428, 0.647912>,
      < -6.697175, 0.035545, 1.306025>,
      < -6.772749, 0.100569, 0.650350>
    }
    triangle {
      < -6.831455, 0.140591, 0.000000>,
      < -6.772749, 0.100569, 0.650350>,
      < -6.716984, 0.205564, 0.654411>
    }
    triangle {
      < -6.831455, 0.140591, 0.000000>,
      < -6.716984, 0.205564, 0.654411>,
      < -6.766448, 0.240585, 0.000000>
    }
    triangle {
      < -6.546418, 0.365566, 0.000000>,
      < -6.487709, 0.350544, 0.646443>,
      < -6.164611, 0.415516, 0.643061>
    }
    triangle {
      < -6.546418, 0.365566, 0.000000>,
      < -6.164611, 0.415516, 0.643061>,
      < -6.248342, 0.420540, 0.000000>
    }
    triangle {
      < -3.439615, 0.535260, 1.353574>,
      < -3.455293, 0.555263, 1.300857>,
      < -4.692935, 0.550371, 1.280324>
    }
    triangle {
      < -3.439615, 0.535260, 1.353574>,
      < -4.692935, 0.550371, 1.280324>,
      < -4.701466, 0.515369, 1.376299>
    }
    triangle {
      < -3.069289, 0.550229, 1.300811>,
      < -3.072534, 0.545230, 1.254827>,
      < -3.445069, 0.540264, 1.230001>
    }
    triangle {
      < -3.069289, 0.550229, 1.300811>,
      < -3.445069, 0.540264, 1.230001>,
      < -3.455293, 0.555263, 1.300857>
    }
    triangle {
      < -3.059436, 0.525226, 1.386560>,
      < -3.070839, 0.530228, 1.348220>,
      < -3.439615, 0.535260, 1.353574>
    }
    triangle {
      < -3.059436, 0.525226, 1.386560>,
      < -3.439615, 0.535260, 1.353574>,
      < -3.439059, 0.510101, 1.410795>
    }
    triangle {
      < -2.703817, 0.490182, 1.880681>,
      < -3.059436, 0.525226, 1.386560>,
      < -3.439059, 0.510101, 1.410795>
    }
    triangle {
      < -2.703817, 0.490182, 1.880681>,
      < -3.439059, 0.510101, 1.410795>,
      < -3.357367, 0.464914, 1.876387>
    }
    texture {hood}
  }
  // bottom
  union {
    triangle {
      < -3.052612, -1.408860, 1.747609>,
      < -2.813603, -1.651789, 1.747609>,
      < -2.813603, -1.651789, 3.013454>
    }
    triangle {
      < -3.052612, -1.408860, 1.747609>,
      < -2.813603, -1.651789, 3.013454>,
      < -3.052612, -1.408860, 3.051297>
    }
    triangle {
      < -2.813603, -1.651789, 1.747609>,
      < -2.569514, -1.869857, 1.747609>,
      < -2.569514, -1.869857, 2.919900>
    }
    triangle {
      < -2.813603, -1.651789, 1.747609>,
      < -2.569514, -1.869857, 2.919900>,
      < -2.813603, -1.651789, 3.013454>
    }
    triangle {
      < -2.569514, -1.869857, 1.747609>,
      < -2.538924, -1.884860, 1.747609>,
      < -2.538924, -1.884860, 2.946151>
    }
    triangle {
      < -2.569514, -1.869857, 1.747609>,
      < -2.538924, -1.884860, 2.946151>,
      < -2.569514, -1.869857, 2.919900>
    }
    triangle {
      < -2.538924, -1.884860, 1.747609>,
      < -2.424010, -2.004869, 1.747609>,
      < -2.424010, -2.004869, 2.890315>
    }
    triangle {
      < -2.538924, -1.884860, 1.747609>,
      < -2.424010, -2.004869, 2.890315>,
      < -2.538924, -1.884860, 2.946151>
    }
    triangle {
      < -2.424010, -2.004869, 1.747609>,
      < -2.315905, -2.054878, 1.747609>,
      < -2.315905, -2.054878, 2.871945>
    }
    triangle {
      < -2.424010, -2.004869, 1.747609>,
      < -2.315905, -2.054878, 2.871945>,
      < -2.424010, -2.004869, 2.890315>
    }
    triangle {
      < -2.315905, -2.054878, 1.747609>,
      < -2.184192, -2.064889, 1.747609>,
      < -2.184192, -2.064889, 2.863208>
    }
    triangle {
      < -2.315905, -2.054878, 1.747609>,
      < -2.184192, -2.064889, 2.863208>,
      < -2.315905, -2.054878, 2.871945>
    }
    triangle {
      < -6.073455, -1.859547, 1.747609>,
      < -5.722831, -1.024584, 1.747609>,
      < -5.722831, -1.024584, 3.011215>
    }
    triangle {
      < -6.073455, -1.859547, 1.747609>,
      < -5.722831, -1.024584, 3.011215>,
      < -6.073455, -1.859547, 2.746403>
    }
    triangle {
      < -5.722831, -1.024584, 1.747609>,
      < -5.663052, -1.007231, 1.747609>,
      < -5.663052, -1.007231, 3.037668>
    }
    triangle {
      < -5.722831, -1.024584, 1.747609>,
      < -5.663052, -1.007231, 3.037668>,
      < -5.722831, -1.024584, 3.011215>
    }
    triangle {
      < -5.663052, -1.007231, 1.747609>,
      < -5.461406, -0.809276, 1.747609>,
      < -5.461406, -0.809276, 3.028569>
    }
    triangle {
      < -5.663052, -1.007231, 1.747609>,
      < -5.461406, -0.809276, 3.028569>,
      < -5.663052, -1.007231, 3.037668>
    }
    triangle {
      < -5.461406, -0.809276, 1.747609>,
      < -5.266409, -0.695346, 1.747609>,
      < -5.266409, -0.695346, 3.031584>
    }
    triangle {
      < -5.461406, -0.809276, 1.747609>,
      < -5.266409, -0.695346, 3.031584>,
      < -5.461406, -0.809276, 3.028569>
    }
    triangle {
      < -5.266409, -0.695346, 1.747609>,
      < -5.017154, -0.628374, 1.747609>,
      < -5.017154, -0.628374, 3.036136>
    }
    triangle {
      < -5.266409, -0.695346, 1.747609>,
      < -5.017154, -0.628374, 3.036136>,
      < -5.266409, -0.695346, 3.031584>
    }
    triangle {
      < -5.017154, -0.628374, 1.747609>,
      < -4.509265, -0.613634, 1.747609>,
      < -4.509265, -0.613634, 3.047463>
    }
    triangle {
      < -5.017154, -0.628374, 1.747609>,
      < -4.509265, -0.613634, 3.047463>,
      < -5.017154, -0.628374, 3.036136>
    }
    triangle {
      < -4.509265, -0.613634, 1.747609>,
      < -4.111175, -0.662607, 1.747609>,
      < -4.111175, -0.662607, 3.057256>
    }
    triangle {
      < -4.509265, -0.613634, 1.747609>,
      < -4.111175, -0.662607, 3.057256>,
      < -4.509265, -0.613634, 3.047463>
    }
    triangle {
      < -4.111175, -0.662607, 1.747609>,
      < -3.856030, -0.749120, 1.747609>,
      < -3.856030, -0.749120, 3.057916>
    }
    triangle {
      < -4.111175, -0.662607, 1.747609>,
      < -3.856030, -0.749120, 3.057916>,
      < -4.111175, -0.662607, 3.057256>
    }
    triangle {
      < -3.856030, -0.749120, 1.747609>,
      < -3.604055, -0.909909, 1.747609>,
      < -3.604055, -0.909909, 3.052055>
    }
    triangle {
      < -3.856030, -0.749120, 1.747609>,
      < -3.604055, -0.909909, 3.052055>,
      < -3.856030, -0.749120, 3.057916>
    }
    triangle {
      < -3.604055, -0.909909, 1.747609>,
      < -3.336812, -1.116545, 1.747609>,
      < -3.336812, -1.116545, 3.058673>
    }
    triangle {
      < -3.604055, -0.909909, 1.747609>,
      < -3.336812, -1.116545, 3.058673>,
      < -3.604055, -0.909909, 3.052055>
    }
    triangle {
      < -3.336812, -1.116545, 1.747609>,
      < -3.052612, -1.408860, 1.747609>,
      < -3.052612, -1.408860, 3.051297>
    }
    triangle {
      < -3.336812, -1.116545, 1.747609>,
      < -3.052612, -1.408860, 3.051297>,
      < -3.336812, -1.116545, 3.058673>
    }
    triangle {
      < -6.073455, -1.859547, 1.747609>,
      < -6.073455, -1.859547, 0.000000>,
      < -2.184192, -2.064889, 0.000000>
    }
    triangle {
      < -6.073455, -1.859547, 1.747609>,
      < -2.184192, -2.064889, 0.000000>,
      < -2.184192, -2.064889, 1.747609>
    }
    triangle {
      < -3.604055, -0.909909, 1.747609>,
      < -3.856030, -0.749120, 1.747609>,
      < -5.266409, -0.695346, 1.747609>
    }
    triangle {
      < -3.604055, -0.909909, 1.747609>,
      < -5.266409, -0.695346, 1.747609>,
      < -5.461406, -0.809276, 1.747609>
    }
    triangle {
      < -3.604055, -0.909909, 1.747609>,
      < -5.461406, -0.809276, 1.747609>,
      < -5.663052, -1.007231, 1.747609>
    }
    triangle {
      < -3.604055, -0.909909, 1.747609>,
      < -5.663052, -1.007231, 1.747609>,
      < -3.336812, -1.116545, 1.747609>
    }
    triangle {
      < -2.813603, -1.651789, 1.747609>,
      < -3.052612, -1.408860, 1.747609>,
      < -6.073455, -1.859547, 1.747609>
    }
    triangle {
      < -2.424010, -2.004869, 1.747609>,
      < -2.569514, -1.869857, 1.747609>,
      < -2.813603, -1.651789, 1.747609>
    }
    triangle {
      < -2.424010, -2.004869, 1.747609>,
      < -2.813603, -1.651789, 1.747609>,
      < -6.073455, -1.859547, 1.747609>
    }
    triangle {
      < -2.538924, -1.884860, 1.747609>,
      < -2.569514, -1.869857, 1.747609>,
      < -2.424010, -2.004869, 1.747609>
    }
    triangle {
      < -2.315905, -2.054878, 1.747609>,
      < -2.424010, -2.004869, 1.747609>,
      < -6.073455, -1.859547, 1.747609>
    }
    triangle {
      < -2.184192, -2.064889, 1.747609>,
      < -2.315905, -2.054878, 1.747609>,
      < -6.073455, -1.859547, 1.747609>
    }
    triangle {
      < -4.111175, -0.662607, 1.747609>,
      < -4.509265, -0.613634, 1.747609>,
      < -5.017154, -0.628374, 1.747609>
    }
    triangle {
      < -4.111175, -0.662607, 1.747609>,
      < -5.017154, -0.628374, 1.747609>,
      < -5.266409, -0.695346, 1.747609>
    }
    triangle {
      < -4.111175, -0.662607, 1.747609>,
      < -5.266409, -0.695346, 1.747609>,
      < -3.856030, -0.749120, 1.747609>
    }
    texture {bottom}
  }
  // fseat
  union {
    triangle {
      < -0.300640, -1.381333, 2.164841>,
      < -0.441985, -0.677600, 2.164841>,
      < -0.462992, -0.765600, 2.150854>
    }
    triangle {
      < -0.300640, -1.381333, 2.164841>,
      < -0.462992, -0.765600, 2.150854>,
      < -0.350672, -1.368000, 2.150854>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < -0.404046, -1.368000, 2.080531>,
      < 1.289825, -1.408841, 2.080531>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < 1.289825, -1.408841, 2.080531>,
      < 1.297600, -1.408000, 2.150854>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < 1.297600, -1.408000, 2.150854>,
      < 1.125798, -1.405102, 2.150854>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < 1.125798, -1.405102, 2.150854>,
      < 0.475977, -1.394139, 2.164841>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < 0.475977, -1.394139, 2.164841>,
      < 0.114115, -1.388035, 2.183490>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < 0.114115, -1.388035, 2.183490>,
      < -0.096081, -1.384488, 2.188152>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < -0.096081, -1.384488, 2.188152>,
      < -0.225137, -1.382295, 2.183490>
    }
    triangle {
      < -0.350672, -1.368000, 2.150854>,
      < -0.225137, -1.382295, 2.183490>,
      < -0.300640, -1.381333, 2.164841>
    }
    triangle {
      < 1.289825, -1.408841, 2.080531>,
      < 1.624716, 0.175770, 2.080531>,
      < 1.625600, 0.144000, 2.150854>
    }
    triangle {
      < 1.289825, -1.408841, 2.080531>,
      < 1.625600, 0.144000, 2.150854>,
      < 1.297600, -1.408000, 2.150854>
    }
    triangle {
      < 1.624716, 0.175770, 2.080531>,
      < 1.667625, 0.420813, 2.080531>,
      < 1.667625, 0.384000, 2.150854>
    }
    triangle {
      < 1.624716, 0.175770, 2.080531>,
      < 1.667625, 0.384000, 2.150854>,
      < 1.625600, 0.144000, 2.150854>
    }
    triangle {
      < 1.667625, 0.420813, 2.080531>,
      < 1.620650, 0.518830, 2.080531>,
      < 1.621617, 0.480000, 2.150854>
    }
    triangle {
      < 1.667625, 0.420813, 2.080531>,
      < 1.621617, 0.480000, 2.150854>,
      < 1.667625, 0.384000, 2.150854>
    }
    triangle {
      < 1.620650, 0.518830, 2.080531>,
      < 1.538969, 0.559671, 2.080531>,
      < 1.541617, 0.520000, 2.150854>
    }
    triangle {
      < 1.620650, 0.518830, 2.080531>,
      < 1.541617, 0.520000, 2.150854>,
      < 1.621617, 0.480000, 2.150854>
    }
    triangle {
      < 1.538969, 0.559671, 2.080531>,
      < 1.445019, 0.559671, 2.080531>,
      < 1.449600, 0.520000, 2.150854>
    }
    triangle {
      < 1.538969, 0.559671, 2.080531>,
      < 1.449600, 0.520000, 2.150854>,
      < 1.541617, 0.520000, 2.150854>
    }
    triangle {
      < 1.445019, 0.559671, 2.080531>,
      < 1.387842, 0.518830, 2.080531>,
      < 1.393600, 0.480000, 2.150854>
    }
    triangle {
      < 1.445019, 0.559671, 2.080531>,
      < 1.393600, 0.480000, 2.150854>,
      < 1.449600, 0.520000, 2.150854>
    }
    triangle {
      < 1.387842, 0.518830, 2.080531>,
      < 1.292275, 0.428981, 2.080531>,
      < 1.300000, 0.392000, 2.150854>
    }
    triangle {
      < 1.387842, 0.518830, 2.080531>,
      < 1.300000, 0.392000, 2.150854>,
      < 1.393600, 0.480000, 2.150854>
    }
    triangle {
      < 1.292275, 0.428981, 2.080531>,
      < 1.151716, 0.132773, 2.080531>,
      < 1.162333, 0.101888, 2.150854>
    }
    triangle {
      < 1.292275, 0.428981, 2.080531>,
      < 1.162333, 0.101888, 2.150854>,
      < 1.300000, 0.392000, 2.150854>
    }
    triangle {
      < 1.151716, 0.132773, 2.080531>,
      < 1.012858, -0.324640, 2.080531>,
      < 1.026333, -0.346112, 2.150854>
    }
    triangle {
      < 1.151716, 0.132773, 2.080531>,
      < 1.026333, -0.346112, 2.150854>,
      < 1.162333, 0.101888, 2.150854>
    }
    triangle {
      < 1.012858, -0.324640, 2.080531>,
      < 0.925586, -0.727435, 2.080531>,
      < 0.940857, -0.740617, 2.150854>
    }
    triangle {
      < 1.012858, -0.324640, 2.080531>,
      < 0.940857, -0.740617, 2.150854>,
      < 1.026333, -0.346112, 2.150854>
    }
    triangle {
      < 0.925586, -0.727435, 2.080531>,
      < 0.958824, -0.828386, 2.080531>,
      < 0.973411, -0.861091, 2.150854>
    }
    triangle {
      < 0.925586, -0.727435, 2.080531>,
      < 0.973411, -0.861091, 2.150854>,
      < 0.940857, -0.740617, 2.150854>
    }
    triangle {
      < 0.958824, -0.828386, 2.080531>,
      < 0.274758, -0.649208, 2.080531>,
      < 0.303423, -0.685600, 2.164841>
    }
    triangle {
      < 0.958824, -0.828386, 2.080531>,
      < 0.303423, -0.685600, 2.164841>,
      < 0.973411, -0.861091, 2.150854>
    }
    triangle {
      < 0.274758, -0.649208, 2.080531>,
      < -0.115968, -0.587130, 2.080531>,
      < -0.079495, -0.624800, 2.183490>
    }
    triangle {
      < 0.274758, -0.649208, 2.080531>,
      < -0.079495, -0.624800, 2.183490>,
      < 0.303423, -0.685600, 2.164841>
    }
    triangle {
      < -0.115968, -0.587130, 2.080531>,
      < -0.328597, -0.583863, 2.080531>,
      < -0.263595, -0.621600, 2.188152>
    }
    triangle {
      < -0.115968, -0.587130, 2.080531>,
      < -0.263595, -0.621600, 2.188152>,
      < -0.079495, -0.624800, 2.183490>
    }
    triangle {
      < -0.328597, -0.583863, 2.080531>,
      < -0.445200, -0.600199, 2.080531>,
      < -0.375915, -0.637600, 2.183490>
    }
    triangle {
      < -0.328597, -0.583863, 2.080531>,
      < -0.375915, -0.637600, 2.183490>,
      < -0.263595, -0.621600, 2.188152>
    }
    triangle {
      < -0.445200, -0.600199, 2.080531>,
      < -0.513791, -0.641040, 2.080531>,
      < -0.441985, -0.677600, 2.164841>
    }
    triangle {
      < -0.445200, -0.600199, 2.080531>,
      < -0.441985, -0.677600, 2.164841>,
      < -0.375915, -0.637600, 2.183490>
    }
    triangle {
      < -0.513791, -0.641040, 2.080531>,
      < -0.520650, -0.730889, 2.080531>,
      < -0.462992, -0.765600, 2.150854>
    }
    triangle {
      < -0.513791, -0.641040, 2.080531>,
      < -0.462992, -0.765600, 2.150854>,
      < -0.441985, -0.677600, 2.164841>
    }
    triangle {
      < -0.520650, -0.730889, 2.080531>,
      < -0.404046, -1.368000, 2.080531>,
      < -0.350672, -1.368000, 2.150854>
    }
    triangle {
      < -0.520650, -0.730889, 2.080531>,
      < -0.350672, -1.368000, 2.150854>,
      < -0.462992, -0.765600, 2.150854>
    }
    triangle {
      < -0.493276, -0.587320, 1.908415>,
      < -0.563893, -0.628845, 1.908415>,
      < -0.513791, -0.641040, 2.080531>
    }
    triangle {
      < -0.493276, -0.587320, 1.908415>,
      < -0.513791, -0.641040, 2.080531>,
      < -0.445200, -0.600199, 2.080531>
    }
    triangle {
      < -0.563893, -0.628845, 1.908415>,
      < -0.570954, -0.720201, 1.908415>,
      < -0.520650, -0.730889, 2.080531>
    }
    triangle {
      < -0.563893, -0.628845, 1.908415>,
      < -0.520650, -0.730889, 2.080531>,
      < -0.513791, -0.641040, 2.080531>
    }
    triangle {
      < -0.570954, -0.720201, 1.908415>,
      < -0.450907, -1.368000, 1.908415>,
      < -0.404046, -1.368000, 2.080531>
    }
    triangle {
      < -0.570954, -0.720201, 1.908415>,
      < -0.404046, -1.368000, 2.080531>,
      < -0.520650, -0.730889, 2.080531>
    }
    triangle {
      < -0.450907, -1.368000, 1.908415>,
      < 1.284590, -1.409526, 1.908415>,
      < 1.289825, -1.408841, 2.080531>
    }
    triangle {
      < -0.450907, -1.368000, 1.908415>,
      < 1.289825, -1.408841, 2.080531>,
      < -0.404046, -1.368000, 2.080531>
    }
    triangle {
      < 1.284590, -1.409526, 1.908415>,
      < 1.626518, 0.201666, 1.908415>,
      < 1.624716, 0.175770, 2.080531>
    }
    triangle {
      < 1.284590, -1.409526, 1.908415>,
      < 1.624716, 0.175770, 2.080531>,
      < 1.289825, -1.408841, 2.080531>
    }
    triangle {
      < 1.626518, 0.201666, 1.908415>,
      < 1.670328, 0.450819, 1.908415>,
      < 1.667625, 0.420813, 2.080531>
    }
    triangle {
      < 1.626518, 0.201666, 1.908415>,
      < 1.667625, 0.420813, 2.080531>,
      < 1.624716, 0.175770, 2.080531>
    }
    triangle {
      < 1.670328, 0.450819, 1.908415>,
      < 1.622366, 0.550481, 1.908415>,
      < 1.620650, 0.518830, 2.080531>
    }
    triangle {
      < 1.670328, 0.450819, 1.908415>,
      < 1.620650, 0.518830, 2.080531>,
      < 1.667625, 0.420813, 2.080531>
    }
    triangle {
      < 1.622366, 0.550481, 1.908415>,
      < 1.538969, 0.592006, 1.908415>,
      < 1.538969, 0.559671, 2.080531>
    }
    triangle {
      < 1.622366, 0.550481, 1.908415>,
      < 1.538969, 0.559671, 2.080531>,
      < 1.620650, 0.518830, 2.080531>
    }
    triangle {
      < 1.538969, 0.592006, 1.908415>,
      < 1.443045, 0.592006, 1.908415>,
      < 1.445019, 0.559671, 2.080531>
    }
    triangle {
      < 1.538969, 0.592006, 1.908415>,
      < 1.445019, 0.559671, 2.080531>,
      < 1.538969, 0.559671, 2.080531>
    }
    triangle {
      < 1.443045, 0.592006, 1.908415>,
      < 1.384666, 0.550481, 1.908415>,
      < 1.387842, 0.518830, 2.080531>
    }
    triangle {
      < 1.443045, 0.592006, 1.908415>,
      < 1.387842, 0.518830, 2.080531>,
      < 1.445019, 0.559671, 2.080531>
    }
    triangle {
      < 1.384666, 0.550481, 1.908415>,
      < 1.287091, 0.459125, 1.908415>,
      < 1.292275, 0.428981, 2.080531>
    }
    triangle {
      < 1.384666, 0.550481, 1.908415>,
      < 1.292275, 0.428981, 2.080531>,
      < 1.387842, 0.518830, 2.080531>
    }
    triangle {
      < 1.287091, 0.459125, 1.908415>,
      < 1.143579, 0.157948, 1.908415>,
      < 1.151716, 0.132773, 2.080531>
    }
    triangle {
      < 1.287091, 0.459125, 1.908415>,
      < 1.151716, 0.132773, 2.080531>,
      < 1.292275, 0.428981, 2.080531>
    }
    triangle {
      < 1.143579, 0.157948, 1.908415>,
      < 1.001803, -0.307138, 1.908415>,
      < 1.012858, -0.324640, 2.080531>
    }
    triangle {
      < 1.143579, 0.157948, 1.908415>,
      < 1.012858, -0.324640, 2.080531>,
      < 1.151716, 0.132773, 2.080531>
    }
    triangle {
      < 1.001803, -0.307138, 1.908415>,
      < 0.912697, -0.716689, 1.908415>,
      < 0.925586, -0.727435, 2.080531>
    }
    triangle {
      < 1.001803, -0.307138, 1.908415>,
      < 0.925586, -0.727435, 2.080531>,
      < 1.012858, -0.324640, 2.080531>
    }
    triangle {
      < 0.912697, -0.716689, 1.908415>,
      < 0.946633, -0.819334, 1.908415>,
      < 0.958824, -0.828386, 2.080531>
    }
    triangle {
      < 0.912697, -0.716689, 1.908415>,
      < 0.958824, -0.828386, 2.080531>,
      < 0.925586, -0.727435, 2.080531>
    }
    triangle {
      < 0.946633, -0.819334, 1.908415>,
      < 0.248194, -0.637150, 1.908415>,
      < 0.274758, -0.649208, 2.080531>
    }
    triangle {
      < 0.946633, -0.819334, 1.908415>,
      < 0.274758, -0.649208, 2.080531>,
      < 0.958824, -0.828386, 2.080531>
    }
    triangle {
      < 0.248194, -0.637150, 1.908415>,
      < -0.154318, -0.574031, 1.908415>,
      < -0.115968, -0.587130, 2.080531>
    }
    triangle {
      < 0.248194, -0.637150, 1.908415>,
      < -0.115968, -0.587130, 2.080531>,
      < 0.274758, -0.649208, 2.080531>
    }
    triangle {
      < -0.154318, -0.574031, 1.908415>,
      < -0.373229, -0.570709, 1.908415>,
      < -0.328597, -0.583863, 2.080531>
    }
    triangle {
      < -0.154318, -0.574031, 1.908415>,
      < -0.328597, -0.583863, 2.080531>,
      < -0.115968, -0.587130, 2.080531>
    }
    triangle {
      < -0.373229, -0.570709, 1.908415>,
      < -0.493276, -0.587320, 1.908415>,
      < -0.445200, -0.600199, 2.080531>
    }
    triangle {
      < -0.373229, -0.570709, 1.908415>,
      < -0.445200, -0.600199, 2.080531>,
      < -0.328597, -0.583863, 2.080531>
    }
    triangle {
      < 0.237413, -0.631046, 1.732031>,
      < -0.168462, -0.567400, 1.732031>,
      < -0.154318, -0.574031, 1.908415>
    }
    triangle {
      < 0.237413, -0.631046, 1.732031>,
      < -0.154318, -0.574031, 1.908415>,
      < 0.248194, -0.637150, 1.908415>
    }
    triangle {
      < -0.168462, -0.567400, 1.732031>,
      < -0.389200, -0.564050, 1.732031>,
      < -0.373229, -0.570709, 1.908415>
    }
    triangle {
      < -0.168462, -0.567400, 1.732031>,
      < -0.373229, -0.570709, 1.908415>,
      < -0.154318, -0.574031, 1.908415>
    }
    triangle {
      < -0.389200, -0.564050, 1.732031>,
      < -0.510251, -0.580799, 1.732031>,
      < -0.493276, -0.587320, 1.908415>
    }
    triangle {
      < -0.389200, -0.564050, 1.732031>,
      < -0.493276, -0.587320, 1.908415>,
      < -0.373229, -0.570709, 1.908415>
    }
    triangle {
      < -0.510251, -0.580799, 1.732031>,
      < -0.581457, -0.622671, 1.732031>,
      < -0.563893, -0.628845, 1.908415>
    }
    triangle {
      < -0.510251, -0.580799, 1.732031>,
      < -0.563893, -0.628845, 1.908415>,
      < -0.493276, -0.587320, 1.908415>
    }
    triangle {
      < -0.581457, -0.622671, 1.732031>,
      < -0.588577, -0.714790, 1.732031>,
      < -0.570954, -0.720201, 1.908415>
    }
    triangle {
      < -0.581457, -0.622671, 1.732031>,
      < -0.570954, -0.720201, 1.908415>,
      < -0.563893, -0.628845, 1.908415>
    }
    triangle {
      < -0.588577, -0.714790, 1.732031>,
      < -0.467527, -1.368000, 1.732031>,
      < -0.450907, -1.368000, 1.908415>
    }
    triangle {
      < -0.588577, -0.714790, 1.732031>,
      < -0.450907, -1.368000, 1.908415>,
      < -0.570954, -0.720201, 1.908415>
    }
    triangle {
      < -0.467527, -1.368000, 1.732031>,
      < 1.282465, -1.409872, 1.732031>,
      < 1.284590, -1.409526, 1.908415>
    }
    triangle {
      < -0.467527, -1.368000, 1.732031>,
      < 1.284590, -1.409526, 1.908415>,
      < -0.450907, -1.368000, 1.908415>
    }
    triangle {
      < 1.282465, -1.409872, 1.732031>,
      < 1.627249, 0.214777, 1.732031>,
      < 1.626518, 0.201666, 1.908415>
    }
    triangle {
      < 1.282465, -1.409872, 1.732031>,
      < 1.626518, 0.201666, 1.908415>,
      < 1.284590, -1.409526, 1.908415>
    }
    triangle {
      < 1.627249, 0.214777, 1.732031>,
      < 1.671425, 0.466011, 1.732031>,
      < 1.670328, 0.450819, 1.908415>
    }
    triangle {
      < 1.627249, 0.214777, 1.732031>,
      < 1.670328, 0.450819, 1.908415>,
      < 1.626518, 0.201666, 1.908415>
    }
    triangle {
      < 1.671425, 0.466011, 1.732031>,
      < 1.623063, 0.566505, 1.732031>,
      < 1.622366, 0.550481, 1.908415>
    }
    triangle {
      < 1.671425, 0.466011, 1.732031>,
      < 1.622366, 0.550481, 1.908415>,
      < 1.670328, 0.450819, 1.908415>
    }
    triangle {
      < 1.623063, 0.566505, 1.732031>,
      < 1.538969, 0.608377, 1.732031>,
      < 1.538969, 0.592006, 1.908415>
    }
    triangle {
      < 1.623063, 0.566505, 1.732031>,
      < 1.538969, 0.592006, 1.908415>,
      < 1.622366, 0.550481, 1.908415>
    }
    triangle {
      < 1.538969, 0.608377, 1.732031>,
      < 1.442243, 0.608377, 1.732031>,
      < 1.443045, 0.592006, 1.908415>
    }
    triangle {
      < 1.538969, 0.608377, 1.732031>,
      < 1.443045, 0.592006, 1.908415>,
      < 1.538969, 0.592006, 1.908415>
    }
    triangle {
      < 1.442243, 0.608377, 1.732031>,
      < 1.383377, 0.566505, 1.732031>,
      < 1.384666, 0.550481, 1.908415>
    }
    triangle {
      < 1.442243, 0.608377, 1.732031>,
      < 1.384666, 0.550481, 1.908415>,
      < 1.443045, 0.592006, 1.908415>
    }
    triangle {
      < 1.383377, 0.566505, 1.732031>,
      < 1.284988, 0.474386, 1.732031>,
      < 1.287091, 0.459125, 1.908415>
    }
    triangle {
      < 1.383377, 0.566505, 1.732031>,
      < 1.287091, 0.459125, 1.908415>,
      < 1.384666, 0.550481, 1.908415>
    }
    triangle {
      < 1.284988, 0.474386, 1.732031>,
      < 1.140276, 0.170694, 1.732031>,
      < 1.143579, 0.157948, 1.908415>
    }
    triangle {
      < 1.284988, 0.474386, 1.732031>,
      < 1.143579, 0.157948, 1.908415>,
      < 1.287091, 0.459125, 1.908415>
    }
    triangle {
      < 1.140276, 0.170694, 1.732031>,
      < 0.997317, -0.298277, 1.732031>,
      < 1.001803, -0.307138, 1.908415>
    }
    triangle {
      < 1.140276, 0.170694, 1.732031>,
      < 1.001803, -0.307138, 1.908415>,
      < 1.143579, 0.157948, 1.908415>
    }
    triangle {
      < 0.997317, -0.298277, 1.732031>,
      < 0.907466, -0.711249, 1.732031>,
      < 0.912697, -0.716689, 1.908415>
    }
    triangle {
      < 0.997317, -0.298277, 1.732031>,
      < 0.912697, -0.716689, 1.908415>,
      < 1.001803, -0.307138, 1.908415>
    }
    triangle {
      < 0.907466, -0.711249, 1.732031>,
      < 0.941686, -0.814751, 1.732031>,
      < 0.946633, -0.819334, 1.908415>
    }
    triangle {
      < 0.907466, -0.711249, 1.732031>,
      < 0.946633, -0.819334, 1.908415>,
      < 0.912697, -0.716689, 1.908415>
    }
    triangle {
      < 0.941686, -0.814751, 1.732031>,
      < 0.237413, -0.631046, 1.732031>,
      < 0.248194, -0.637150, 1.908415>
    }
    triangle {
      < 0.941686, -0.814751, 1.732031>,
      < 0.248194, -0.637150, 1.908415>,
      < 0.946633, -0.819334, 1.908415>
    }
    triangle {
      < 0.986820, -0.288993, 1.097573>,
      < 0.895462, -0.705414, 1.097573>,
      < 0.907466, -0.711249, 1.732031>
    }
    triangle {
      < 0.986820, -0.288993, 1.097573>,
      < 0.907466, -0.711249, 1.732031>,
      < 0.997317, -0.298277, 1.732031>
    }
    triangle {
      < 0.895462, -0.705414, 1.097573>,
      < 0.930256, -0.809781, 1.097573>,
      < 0.941686, -0.814751, 1.732031>
    }
    triangle {
      < 0.895462, -0.705414, 1.097573>,
      < 0.941686, -0.814751, 1.732031>,
      < 0.907466, -0.711249, 1.732031>
    }
    triangle {
      < 0.930256, -0.809781, 1.097573>,
      < 0.214169, -0.624541, 1.097573>,
      < 0.237413, -0.631046, 1.732031>
    }
    triangle {
      < 0.930256, -0.809781, 1.097573>,
      < 0.237413, -0.631046, 1.732031>,
      < 0.941686, -0.814751, 1.732031>
    }
    triangle {
      < 0.214169, -0.624541, 1.097573>,
      < -0.198514, -0.560363, 1.097573>,
      < -0.168462, -0.567400, 1.732031>
    }
    triangle {
      < 0.214169, -0.624541, 1.097573>,
      < -0.168462, -0.567400, 1.732031>,
      < 0.237413, -0.631046, 1.732031>
    }
    triangle {
      < -0.198514, -0.560363, 1.097573>,
      < -0.422955, -0.556985, 1.097573>,
      < -0.389200, -0.564050, 1.732031>
    }
    triangle {
      < -0.198514, -0.560363, 1.097573>,
      < -0.389200, -0.564050, 1.732031>,
      < -0.168462, -0.567400, 1.732031>
    }
    triangle {
      < -0.422955, -0.556985, 1.097573>,
      < -0.546036, -0.573874, 1.097573>,
      < -0.510251, -0.580799, 1.732031>
    }
    triangle {
      < -0.422955, -0.556985, 1.097573>,
      < -0.510251, -0.580799, 1.732031>,
      < -0.389200, -0.564050, 1.732031>
    }
    triangle {
      < -0.546036, -0.573874, 1.097573>,
      < -0.618437, -0.616096, 1.097573>,
      < -0.581457, -0.622671, 1.732031>
    }
    triangle {
      < -0.546036, -0.573874, 1.097573>,
      < -0.581457, -0.622671, 1.732031>,
      < -0.510251, -0.580799, 1.732031>
    }
    triangle {
      < -0.618437, -0.616096, 1.097573>,
      < -0.625677, -0.708985, 1.097573>,
      < -0.588577, -0.714790, 1.732031>
    }
    triangle {
      < -0.618437, -0.616096, 1.097573>,
      < -0.588577, -0.714790, 1.732031>,
      < -0.581457, -0.622671, 1.732031>
    }
    triangle {
      < -0.625677, -0.708985, 1.097573>,
      < -0.502596, -1.367650, 1.097573>,
      < -0.467527, -1.368000, 1.732031>
    }
    triangle {
      < -0.625677, -0.708985, 1.097573>,
      < -0.467527, -1.368000, 1.732031>,
      < -0.588577, -0.714790, 1.732031>
    }
    triangle {
      < -0.502596, -1.367650, 1.097573>,
      < -0.467527, -1.368000, 0.463114>,
      < 1.282465, -1.409872, 0.463114>
    }
    triangle {
      < -0.502596, -1.367650, 1.097573>,
      < 1.282465, -1.409872, 0.463114>,
      < 1.276751, -1.409872, 1.097573>
    }
    triangle {
      < -0.502596, -1.367650, 1.097573>,
      < 1.276751, -1.409872, 1.097573>,
      < 1.282465, -1.409872, 1.732031>
    }
    triangle {
      < -0.502596, -1.367650, 1.097573>,
      < 1.282465, -1.409872, 1.732031>,
      < -0.467527, -1.368000, 1.732031>
    }
    triangle {
      < 1.276751, -1.409872, 1.097573>,
      < 1.627319, 0.228347, 1.097573>,
      < 1.627249, 0.214777, 1.732031>
    }
    triangle {
      < 1.276751, -1.409872, 1.097573>,
      < 1.627249, 0.214777, 1.732031>,
      < 1.282465, -1.409872, 1.732031>
    }
    triangle {
      < 1.627319, 0.228347, 1.097573>,
      < 1.672236, 0.481679, 1.097573>,
      < 1.671425, 0.466011, 1.732031>
    }
    triangle {
      < 1.627319, 0.228347, 1.097573>,
      < 1.671425, 0.466011, 1.732031>,
      < 1.627249, 0.214777, 1.732031>
    }
    triangle {
      < 1.672236, 0.481679, 1.097573>,
      < 1.623063, 0.583013, 1.097573>,
      < 1.623063, 0.566505, 1.732031>
    }
    triangle {
      < 1.672236, 0.481679, 1.097573>,
      < 1.623063, 0.566505, 1.732031>,
      < 1.671425, 0.466011, 1.732031>
    }
    triangle {
      < 1.623063, 0.583013, 1.097573>,
      < 1.537558, 0.625235, 1.097573>,
      < 1.538969, 0.608377, 1.732031>
    }
    triangle {
      < 1.623063, 0.583013, 1.097573>,
      < 1.538969, 0.608377, 1.732031>,
      < 1.623063, 0.566505, 1.732031>
    }
    triangle {
      < 1.537558, 0.625235, 1.097573>,
      < 1.439210, 0.625235, 1.097573>,
      < 1.442243, 0.608377, 1.732031>
    }
    triangle {
      < 1.537558, 0.625235, 1.097573>,
      < 1.442243, 0.608377, 1.732031>,
      < 1.538969, 0.608377, 1.732031>
    }
    triangle {
      < 1.439210, 0.625235, 1.097573>,
      < 1.379357, 0.583013, 1.097573>,
      < 1.383377, 0.566505, 1.732031>
    }
    triangle {
      < 1.439210, 0.625235, 1.097573>,
      < 1.383377, 0.566505, 1.732031>,
      < 1.442243, 0.608377, 1.732031>
    }
    triangle {
      < 1.379357, 0.583013, 1.097573>,
      < 1.279316, 0.490124, 1.097573>,
      < 1.284988, 0.474386, 1.732031>
    }
    triangle {
      < 1.379357, 0.583013, 1.097573>,
      < 1.284988, 0.474386, 1.732031>,
      < 1.383377, 0.566505, 1.732031>
    }
    triangle {
      < 1.279316, 0.490124, 1.097573>,
      < 1.132178, 0.183895, 1.097573>,
      < 1.140276, 0.170694, 1.732031>
    }
    triangle {
      < 1.279316, 0.490124, 1.097573>,
      < 1.140276, 0.170694, 1.732031>,
      < 1.284988, 0.474386, 1.732031>
    }
    triangle {
      < 1.132178, 0.183895, 1.097573>,
      < 0.986820, -0.288993, 1.097573>,
      < 0.997317, -0.298277, 1.732031>
    }
    triangle {
      < 1.132178, 0.183895, 1.097573>,
      < 0.997317, -0.298277, 1.732031>,
      < 1.140276, 0.170694, 1.732031>
    }
    triangle {
      < -0.225137, -1.382295, 2.183490>,
      < -0.375915, -0.637600, 2.183490>,
      < -0.441985, -0.677600, 2.164841>
    }
    triangle {
      < -0.225137, -1.382295, 2.183490>,
      < -0.441985, -0.677600, 2.164841>,
      < -0.300640, -1.381333, 2.164841>
    }
    triangle {
      < -0.096081, -1.384488, 2.188152>,
      < -0.263595, -0.621600, 2.188152>,
      < -0.375915, -0.637600, 2.183490>
    }
    triangle {
      < -0.096081, -1.384488, 2.188152>,
      < -0.375915, -0.637600, 2.183490>,
      < -0.225137, -1.382295, 2.183490>
    }
    triangle {
      < 0.114115, -1.388035, 2.183490>,
      < -0.079495, -0.624800, 2.183490>,
      < -0.263595, -0.621600, 2.188152>
    }
    triangle {
      < 0.114115, -1.388035, 2.183490>,
      < -0.263595, -0.621600, 2.188152>,
      < -0.096081, -1.384488, 2.188152>
    }
    triangle {
      < 0.475977, -1.394139, 2.164841>,
      < 0.303423, -0.685600, 2.164841>,
      < -0.079495, -0.624800, 2.183490>
    }
    triangle {
      < 0.475977, -1.394139, 2.164841>,
      < -0.079495, -0.624800, 2.183490>,
      < 0.114115, -1.388035, 2.183490>
    }
    triangle {
      < 1.163895, -1.355737, 2.176496>,
      < 1.092757, -1.101782, 2.171834>,
      < 1.021619, -0.847826, 2.167172>
    }
    triangle {
      < 1.163895, -1.355737, 2.176496>,
      < 1.021619, -0.847826, 2.167172>,
      < 0.973411, -0.861091, 2.150854>
    }
    triangle {
      < 1.163895, -1.355737, 2.176496>,
      < 0.973411, -0.861091, 2.150854>,
      < 0.303423, -0.685600, 2.164841>
    }
    triangle {
      < 1.163895, -1.355737, 2.176496>,
      < 0.303423, -0.685600, 2.164841>,
      < 0.475977, -1.394139, 2.164841>
    }
    triangle {
      < 1.209098, 0.083809, 2.167172>,
      < 1.074769, -0.358689, 2.167172>,
      < 0.992299, -0.739317, 2.167172>
    }
    triangle {
      < 1.209098, 0.083809, 2.167172>,
      < 0.992299, -0.739317, 2.167172>,
      < 1.021619, -0.847826, 2.167172>
    }
    triangle {
      < 1.209098, 0.083809, 2.167172>,
      < 1.021619, -0.847826, 2.167172>,
      < 1.092757, -1.101782, 2.171834>
    }
    triangle {
      < 1.209098, 0.083809, 2.167172>,
      < 1.092757, -1.101782, 2.171834>,
      < 1.392799, 0.118647, 2.176496>
    }
    triangle {
      < 1.257208, -1.357312, 2.167172>,
      < 1.163895, -1.355737, 2.176496>,
      < 1.125798, -1.405102, 2.150854>
    }
    triangle {
      < 1.257208, -1.357312, 2.167172>,
      < 1.125798, -1.405102, 2.150854>,
      < 1.297600, -1.408000, 2.150854>
    }
    triangle {
      < 1.021619, -0.847826, 2.167172>,
      < 0.992299, -0.739317, 2.167172>,
      < 0.940857, -0.740617, 2.150854>
    }
    triangle {
      < 1.021619, -0.847826, 2.167172>,
      < 0.940857, -0.740617, 2.150854>,
      < 0.973411, -0.861091, 2.150854>
    }
    triangle {
      < 0.992299, -0.739317, 2.167172>,
      < 1.074769, -0.358689, 2.167172>,
      < 1.026333, -0.346112, 2.150854>
    }
    triangle {
      < 0.992299, -0.739317, 2.167172>,
      < 1.026333, -0.346112, 2.150854>,
      < 0.940857, -0.740617, 2.150854>
    }
    triangle {
      < 1.074769, -0.358689, 2.167172>,
      < 1.209098, 0.083809, 2.167172>,
      < 1.162333, 0.101888, 2.150854>
    }
    triangle {
      < 1.074769, -0.358689, 2.167172>,
      < 1.162333, 0.101888, 2.150854>,
      < 1.026333, -0.346112, 2.150854>
    }
    triangle {
      < 1.209098, 0.083809, 2.167172>,
      < 1.341126, 0.362037, 2.167172>,
      < 1.300000, 0.392000, 2.150854>
    }
    triangle {
      < 1.209098, 0.083809, 2.167172>,
      < 1.300000, 0.392000, 2.150854>,
      < 1.162333, 0.101888, 2.150854>
    }
    triangle {
      < 1.341126, 0.362037, 2.167172>,
      < 1.425399, 0.441268, 2.167172>,
      < 1.393600, 0.480000, 2.150854>
    }
    triangle {
      < 1.341126, 0.362037, 2.167172>,
      < 1.393600, 0.480000, 2.150854>,
      < 1.300000, 0.392000, 2.150854>
    }
    triangle {
      < 1.425399, 0.441268, 2.167172>,
      < 1.465623, 0.470000, 2.167172>,
      < 1.449600, 0.520000, 2.150854>
    }
    triangle {
      < 1.425399, 0.441268, 2.167172>,
      < 1.449600, 0.520000, 2.150854>,
      < 1.393600, 0.480000, 2.150854>
    }
    triangle {
      < 1.465623, 0.470000, 2.167172>,
      < 1.529814, 0.470000, 2.176496>,
      < 1.541617, 0.520000, 2.150854>
    }
    triangle {
      < 1.465623, 0.470000, 2.167172>,
      < 1.541617, 0.520000, 2.150854>,
      < 1.449600, 0.520000, 2.150854>
    }
    triangle {
      < 1.529814, 0.470000, 2.176496>,
      < 1.583932, 0.442941, 2.167172>,
      < 1.621617, 0.480000, 2.150854>
    }
    triangle {
      < 1.529814, 0.470000, 2.176496>,
      < 1.621617, 0.480000, 2.150854>,
      < 1.541617, 0.520000, 2.150854>
    }
    triangle {
      < 1.583932, 0.442941, 2.167172>,
      < 1.615610, 0.376841, 2.167172>,
      < 1.667625, 0.384000, 2.150854>
    }
    triangle {
      < 1.583932, 0.442941, 2.167172>,
      < 1.667625, 0.384000, 2.150854>,
      < 1.621617, 0.480000, 2.150854>
    }
    triangle {
      < 1.615610, 0.376841, 2.167172>,
      < 1.576500, 0.153484, 2.167172>,
      < 1.625600, 0.144000, 2.150854>
    }
    triangle {
      < 1.615610, 0.376841, 2.167172>,
      < 1.625600, 0.144000, 2.150854>,
      < 1.667625, 0.384000, 2.150854>
    }
    triangle {
      < 1.576500, 0.153484, 2.167172>,
      < 1.257208, -1.357312, 2.167172>,
      < 1.297600, -1.408000, 2.150854>
    }
    triangle {
      < 1.576500, 0.153484, 2.167172>,
      < 1.297600, -1.408000, 2.150854>,
      < 1.625600, 0.144000, 2.150854>
    }
    triangle {
      < 1.425399, 0.441268, 2.167172>,
      < 1.341126, 0.362037, 2.167172>,
      < 1.478368, 0.369439, 2.176496>
    }
    triangle {
      < 1.425399, 0.441268, 2.167172>,
      < 1.478368, 0.369439, 2.176496>,
      < 1.504665, 0.442104, 2.176496>
    }
    triangle {
      < 1.341126, 0.362037, 2.167172>,
      < 1.209098, 0.083809, 2.167172>,
      < 1.392799, 0.118647, 2.176496>
    }
    triangle {
      < 1.341126, 0.362037, 2.167172>,
      < 1.392799, 0.118647, 2.176496>,
      < 1.478368, 0.369439, 2.176496>
    }
    triangle {
      < 1.465623, 0.470000, 2.167172>,
      < 1.425399, 0.441268, 2.167172>,
      < 1.504665, 0.442104, 2.176496>
    }
    triangle {
      < 1.465623, 0.470000, 2.167172>,
      < 1.504665, 0.442104, 2.176496>,
      < 1.529814, 0.470000, 2.176496>
    }
    triangle {
      < 1.583932, 0.442941, 2.167172>,
      < 1.529814, 0.470000, 2.176496>,
      < 1.504665, 0.442104, 2.176496>
    }
    triangle {
      < 1.615610, 0.376841, 2.167172>,
      < 1.583932, 0.442941, 2.167172>,
      < 1.504665, 0.442104, 2.176496>
    }
    triangle {
      < 1.615610, 0.376841, 2.167172>,
      < 1.504665, 0.442104, 2.176496>,
      < 1.478368, 0.369439, 2.176496>
    }
    triangle {
      < 1.576500, 0.153484, 2.167172>,
      < 1.615610, 0.376841, 2.167172>,
      < 1.478368, 0.369439, 2.176496>
    }
    triangle {
      < 1.576500, 0.153484, 2.167172>,
      < 1.478368, 0.369439, 2.176496>,
      < 1.392799, 0.118647, 2.176496>
    }
    triangle {
      < 1.125798, -1.405102, 2.150854>,
      < 1.163895, -1.355737, 2.176496>,
      < 0.475977, -1.394139, 2.164841>
    }
    triangle {
      < 1.163895, -1.355737, 2.176496>,
      < 1.257208, -1.357312, 2.167172>,
      < 1.576500, 0.153484, 2.167172>
    }
    triangle {
      < 1.163895, -1.355737, 2.176496>,
      < 1.576500, 0.153484, 2.167172>,
      < 1.392799, 0.118647, 2.176496>
    }
    triangle {
      < 1.163895, -1.355737, 2.176496>,
      < 1.392799, 0.118647, 2.176496>,
      < 1.092757, -1.101782, 2.171834>
    }
    triangle {
      < 1.576500, 0.153484, 0.027974>,
      < 1.257208, -1.357312, 0.027974>,
      < 1.163895, -1.355737, 0.018649>
    }
    triangle {
      < 1.576500, 0.153484, 0.027974>,
      < 1.163895, -1.355737, 0.018649>,
      < 1.092757, -1.101782, 0.023311>
    }
    triangle {
      < 1.576500, 0.153484, 0.027974>,
      < 1.092757, -1.101782, 0.023311>,
      < 1.392799, 0.118647, 0.018649>
    }
    triangle {
      < 1.125798, -1.405102, 0.044292>,
      < 0.475977, -1.394139, 0.030305>,
      < 1.163895, -1.355737, 0.018649>
    }
    triangle {
      < 1.615610, 0.376841, 0.027974>,
      < 1.576500, 0.153484, 0.027974>,
      < 1.392799, 0.118647, 0.018649>
    }
    triangle {
      < 1.615610, 0.376841, 0.027974>,
      < 1.392799, 0.118647, 0.018649>,
      < 1.478368, 0.369439, 0.018649>
    }
    triangle {
      < 1.583932, 0.442941, 0.027974>,
      < 1.615610, 0.376841, 0.027974>,
      < 1.478368, 0.369439, 0.018649>
    }
    triangle {
      < 1.583932, 0.442941, 0.027974>,
      < 1.478368, 0.369439, 0.018649>,
      < 1.504665, 0.442104, 0.018649>
    }
    triangle {
      < 1.583932, 0.442941, 0.027974>,
      < 1.504665, 0.442104, 0.018649>,
      < 1.529814, 0.470000, 0.018649>
    }
    triangle {
      < 1.425399, 0.441268, 0.027974>,
      < 1.465623, 0.470000, 0.027974>,
      < 1.529814, 0.470000, 0.018649>
    }
    triangle {
      < 1.425399, 0.441268, 0.027974>,
      < 1.529814, 0.470000, 0.018649>,
      < 1.504665, 0.442104, 0.018649>
    }
    triangle {
      < 1.209098, 0.083809, 0.027974>,
      < 1.341126, 0.362037, 0.027974>,
      < 1.478368, 0.369439, 0.018649>
    }
    triangle {
      < 1.209098, 0.083809, 0.027974>,
      < 1.478368, 0.369439, 0.018649>,
      < 1.392799, 0.118647, 0.018649>
    }
    triangle {
      < 1.341126, 0.362037, 0.027974>,
      < 1.425399, 0.441268, 0.027974>,
      < 1.504665, 0.442104, 0.018649>
    }
    triangle {
      < 1.341126, 0.362037, 0.027974>,
      < 1.504665, 0.442104, 0.018649>,
      < 1.478368, 0.369439, 0.018649>
    }
    triangle {
      < 1.257208, -1.357312, 0.027974>,
      < 1.576500, 0.153484, 0.027974>,
      < 1.625600, 0.144000, 0.044292>
    }
    triangle {
      < 1.257208, -1.357312, 0.027974>,
      < 1.625600, 0.144000, 0.044292>,
      < 1.297600, -1.408000, 0.044292>
    }
    triangle {
      < 1.576500, 0.153484, 0.027974>,
      < 1.615610, 0.376841, 0.027974>,
      < 1.667625, 0.384000, 0.044292>
    }
    triangle {
      < 1.576500, 0.153484, 0.027974>,
      < 1.667625, 0.384000, 0.044292>,
      < 1.625600, 0.144000, 0.044292>
    }
    triangle {
      < 1.615610, 0.376841, 0.027974>,
      < 1.583932, 0.442941, 0.027974>,
      < 1.621617, 0.480000, 0.044292>
    }
    triangle {
      < 1.615610, 0.376841, 0.027974>,
      < 1.621617, 0.480000, 0.044292>,
      < 1.667625, 0.384000, 0.044292>
    }
    triangle {
      < 1.583932, 0.442941, 0.027974>,
      < 1.529814, 0.470000, 0.018649>,
      < 1.541617, 0.520000, 0.044292>
    }
    triangle {
      < 1.583932, 0.442941, 0.027974>,
      < 1.541617, 0.520000, 0.044292>,
      < 1.621617, 0.480000, 0.044292>
    }
    triangle {
      < 1.529814, 0.470000, 0.018649>,
      < 1.465623, 0.470000, 0.027974>,
      < 1.449600, 0.520000, 0.044292>
    }
    triangle {
      < 1.529814, 0.470000, 0.018649>,
      < 1.449600, 0.520000, 0.044292>,
      < 1.541617, 0.520000, 0.044292>
    }
    triangle {
      < 1.465623, 0.470000, 0.027974>,
      < 1.425399, 0.441268, 0.027974>,
      < 1.393600, 0.480000, 0.044292>
    }
    triangle {
      < 1.465623, 0.470000, 0.027974>,
      < 1.393600, 0.480000, 0.044292>,
      < 1.449600, 0.520000, 0.044292>
    }
    triangle {
      < 1.425399, 0.441268, 0.027974>,
      < 1.341126, 0.362037, 0.027974>,
      < 1.300000, 0.392000, 0.044292>
    }
    triangle {
      < 1.425399, 0.441268, 0.027974>,
      < 1.300000, 0.392000, 0.044292>,
      < 1.393600, 0.480000, 0.044292>
    }
    triangle {
      < 1.341126, 0.362037, 0.027974>,
      < 1.209098, 0.083809, 0.027974>,
      < 1.162333, 0.101888, 0.044292>
    }
    triangle {
      < 1.341126, 0.362037, 0.027974>,
      < 1.162333, 0.101888, 0.044292>,
      < 1.300000, 0.392000, 0.044292>
    }
    triangle {
      < 1.209098, 0.083809, 0.027974>,
      < 1.074769, -0.358689, 0.027974>,
      < 1.026333, -0.346112, 0.044292>
    }
    triangle {
      < 1.209098, 0.083809, 0.027974>,
      < 1.026333, -0.346112, 0.044292>,
      < 1.162333, 0.101888, 0.044292>
    }
    triangle {
      < 1.074769, -0.358689, 0.027974>,
      < 0.992299, -0.739317, 0.027974>,
      < 0.940857, -0.740617, 0.044292>
    }
    triangle {
      < 1.074769, -0.358689, 0.027974>,
      < 0.940857, -0.740617, 0.044292>,
      < 1.026333, -0.346112, 0.044292>
    }
    triangle {
      < 0.992299, -0.739317, 0.027974>,
      < 1.021619, -0.847826, 0.027974>,
      < 0.973411, -0.861091, 0.044292>
    }
    triangle {
      < 0.992299, -0.739317, 0.027974>,
      < 0.973411, -0.861091, 0.044292>,
      < 0.940857, -0.740617, 0.044292>
    }
    triangle {
      < 1.163895, -1.355737, 0.018649>,
      < 1.257208, -1.357312, 0.027974>,
      < 1.297600, -1.408000, 0.044292>
    }
    triangle {
      < 1.163895, -1.355737, 0.018649>,
      < 1.297600, -1.408000, 0.044292>,
      < 1.125798, -1.405102, 0.044292>
    }
    triangle {
      < 1.021619, -0.847826, 0.027974>,
      < 0.992299, -0.739317, 0.027974>,
      < 1.074769, -0.358689, 0.027974>
    }
    triangle {
      < 1.021619, -0.847826, 0.027974>,
      < 1.074769, -0.358689, 0.027974>,
      < 1.209098, 0.083809, 0.027974>
    }
    triangle {
      < 1.021619, -0.847826, 0.027974>,
      < 1.209098, 0.083809, 0.027974>,
      < 1.392799, 0.118647, 0.018649>
    }
    triangle {
      < 1.021619, -0.847826, 0.027974>,
      < 1.392799, 0.118647, 0.018649>,
      < 1.092757, -1.101782, 0.023311>
    }
    triangle {
      < 0.973411, -0.861091, 0.044292>,
      < 1.021619, -0.847826, 0.027974>,
      < 1.092757, -1.101782, 0.023311>
    }
    triangle {
      < 0.973411, -0.861091, 0.044292>,
      < 1.092757, -1.101782, 0.023311>,
      < 1.163895, -1.355737, 0.018649>
    }
    triangle {
      < 0.973411, -0.861091, 0.044292>,
      < 1.163895, -1.355737, 0.018649>,
      < 0.475977, -1.394139, 0.030305>
    }
    triangle {
      < 0.973411, -0.861091, 0.044292>,
      < 0.475977, -1.394139, 0.030305>,
      < 0.303423, -0.685600, 0.030305>
    }
    triangle {
      < 0.303423, -0.685600, 0.030305>,
      < 0.475977, -1.394139, 0.030305>,
      < 0.114115, -1.388035, 0.011655>
    }
    triangle {
      < 0.303423, -0.685600, 0.030305>,
      < 0.114115, -1.388035, 0.011655>,
      < -0.079495, -0.624800, 0.011655>
    }
    triangle {
      < -0.079495, -0.624800, 0.011655>,
      < 0.114115, -1.388035, 0.011655>,
      < -0.096081, -1.384488, 0.006993>
    }
    triangle {
      < -0.079495, -0.624800, 0.011655>,
      < -0.096081, -1.384488, 0.006993>,
      < -0.263595, -0.621600, 0.006993>
    }
    triangle {
      < -0.263595, -0.621600, 0.006993>,
      < -0.096081, -1.384488, 0.006993>,
      < -0.225137, -1.382295, 0.011655>
    }
    triangle {
      < -0.263595, -0.621600, 0.006993>,
      < -0.225137, -1.382295, 0.011655>,
      < -0.375915, -0.637600, 0.011655>
    }
    triangle {
      < -0.375915, -0.637600, 0.011655>,
      < -0.225137, -1.382295, 0.011655>,
      < -0.300640, -1.381333, 0.030305>
    }
    triangle {
      < -0.375915, -0.637600, 0.011655>,
      < -0.300640, -1.381333, 0.030305>,
      < -0.441985, -0.677600, 0.030305>
    }
    triangle {
      < 0.986820, -0.288993, 1.097573>,
      < 1.132178, 0.183895, 1.097573>,
      < 1.140276, 0.170694, 0.463114>
    }
    triangle {
      < 0.986820, -0.288993, 1.097573>,
      < 1.140276, 0.170694, 0.463114>,
      < 0.997317, -0.298277, 0.463114>
    }
    triangle {
      < 1.132178, 0.183895, 1.097573>,
      < 1.279316, 0.490124, 1.097573>,
      < 1.284988, 0.474386, 0.463114>
    }
    triangle {
      < 1.132178, 0.183895, 1.097573>,
      < 1.284988, 0.474386, 0.463114>,
      < 1.140276, 0.170694, 0.463114>
    }
    triangle {
      < 1.279316, 0.490124, 1.097573>,
      < 1.379357, 0.583013, 1.097573>,
      < 1.383377, 0.566505, 0.463114>
    }
    triangle {
      < 1.279316, 0.490124, 1.097573>,
      < 1.383377, 0.566505, 0.463114>,
      < 1.284988, 0.474386, 0.463114>
    }
    triangle {
      < 1.379357, 0.583013, 1.097573>,
      < 1.439210, 0.625235, 1.097573>,
      < 1.442243, 0.608377, 0.463114>
    }
    triangle {
      < 1.379357, 0.583013, 1.097573>,
      < 1.442243, 0.608377, 0.463114>,
      < 1.383377, 0.566505, 0.463114>
    }
    triangle {
      < 1.439210, 0.625235, 1.097573>,
      < 1.537558, 0.625235, 1.097573>,
      < 1.538969, 0.608377, 0.463114>
    }
    triangle {
      < 1.439210, 0.625235, 1.097573>,
      < 1.538969, 0.608377, 0.463114>,
      < 1.442243, 0.608377, 0.463114>
    }
    triangle {
      < 1.537558, 0.625235, 1.097573>,
      < 1.623063, 0.583013, 1.097573>,
      < 1.623063, 0.566505, 0.463114>
    }
    triangle {
      < 1.537558, 0.625235, 1.097573>,
      < 1.623063, 0.566505, 0.463114>,
      < 1.538969, 0.608377, 0.463114>
    }
    triangle {
      < 1.623063, 0.583013, 1.097573>,
      < 1.672236, 0.481679, 1.097573>,
      < 1.671425, 0.466011, 0.463114>
    }
    triangle {
      < 1.623063, 0.583013, 1.097573>,
      < 1.671425, 0.466011, 0.463114>,
      < 1.623063, 0.566505, 0.463114>
    }
    triangle {
      < 1.672236, 0.481679, 1.097573>,
      < 1.627319, 0.228347, 1.097573>,
      < 1.627249, 0.214777, 0.463114>
    }
    triangle {
      < 1.672236, 0.481679, 1.097573>,
      < 1.627249, 0.214777, 0.463114>,
      < 1.671425, 0.466011, 0.463114>
    }
    triangle {
      < 1.627319, 0.228347, 1.097573>,
      < 1.276751, -1.409872, 1.097573>,
      < 1.282465, -1.409872, 0.463114>
    }
    triangle {
      < 1.627319, 0.228347, 1.097573>,
      < 1.282465, -1.409872, 0.463114>,
      < 1.627249, 0.214777, 0.463114>
    }
    triangle {
      < -0.502596, -1.367650, 1.097573>,
      < -0.625677, -0.708985, 1.097573>,
      < -0.588577, -0.714790, 0.463114>
    }
    triangle {
      < -0.502596, -1.367650, 1.097573>,
      < -0.588577, -0.714790, 0.463114>,
      < -0.467527, -1.368000, 0.463114>
    }
    triangle {
      < -0.625677, -0.708985, 1.097573>,
      < -0.618437, -0.616096, 1.097573>,
      < -0.581457, -0.622671, 0.463114>
    }
    triangle {
      < -0.625677, -0.708985, 1.097573>,
      < -0.581457, -0.622671, 0.463114>,
      < -0.588577, -0.714790, 0.463114>
    }
    triangle {
      < -0.618437, -0.616096, 1.097573>,
      < -0.546036, -0.573874, 1.097573>,
      < -0.510251, -0.580799, 0.463114>
    }
    triangle {
      < -0.618437, -0.616096, 1.097573>,
      < -0.510251, -0.580799, 0.463114>,
      < -0.581457, -0.622671, 0.463114>
    }
    triangle {
      < -0.546036, -0.573874, 1.097573>,
      < -0.422955, -0.556985, 1.097573>,
      < -0.389200, -0.564050, 0.463114>
    }
    triangle {
      < -0.546036, -0.573874, 1.097573>,
      < -0.389200, -0.564050, 0.463114>,
      < -0.510251, -0.580799, 0.463114>
    }
    triangle {
      < -0.422955, -0.556985, 1.097573>,
      < -0.198514, -0.560363, 1.097573>,
      < -0.168462, -0.567400, 0.463114>
    }
    triangle {
      < -0.422955, -0.556985, 1.097573>,
      < -0.168462, -0.567400, 0.463114>,
      < -0.389200, -0.564050, 0.463114>
    }
    triangle {
      < -0.198514, -0.560363, 1.097573>,
      < 0.214169, -0.624541, 1.097573>,
      < 0.237413, -0.631046, 0.463114>
    }
    triangle {
      < -0.198514, -0.560363, 1.097573>,
      < 0.237413, -0.631046, 0.463114>,
      < -0.168462, -0.567400, 0.463114>
    }
    triangle {
      < 0.214169, -0.624541, 1.097573>,
      < 0.930256, -0.809781, 1.097573>,
      < 0.941686, -0.814751, 0.463114>
    }
    triangle {
      < 0.214169, -0.624541, 1.097573>,
      < 0.941686, -0.814751, 0.463114>,
      < 0.237413, -0.631046, 0.463114>
    }
    triangle {
      < 0.930256, -0.809781, 1.097573>,
      < 0.895462, -0.705414, 1.097573>,
      < 0.907466, -0.711249, 0.463114>
    }
    triangle {
      < 0.930256, -0.809781, 1.097573>,
      < 0.907466, -0.711249, 0.463114>,
      < 0.941686, -0.814751, 0.463114>
    }
    triangle {
      < 0.895462, -0.705414, 1.097573>,
      < 0.986820, -0.288993, 1.097573>,
      < 0.997317, -0.298277, 0.463114>
    }
    triangle {
      < 0.895462, -0.705414, 1.097573>,
      < 0.997317, -0.298277, 0.463114>,
      < 0.907466, -0.711249, 0.463114>
    }
    triangle {
      < 0.237413, -0.631046, 0.463114>,
      < 0.941686, -0.814751, 0.463114>,
      < 0.946633, -0.819334, 0.286730>
    }
    triangle {
      < 0.237413, -0.631046, 0.463114>,
      < 0.946633, -0.819334, 0.286730>,
      < 0.248194, -0.637150, 0.286730>
    }
    triangle {
      < 0.941686, -0.814751, 0.463114>,
      < 0.907466, -0.711249, 0.463114>,
      < 0.912697, -0.716689, 0.286730>
    }
    triangle {
      < 0.941686, -0.814751, 0.463114>,
      < 0.912697, -0.716689, 0.286730>,
      < 0.946633, -0.819334, 0.286730>
    }
    triangle {
      < 0.907466, -0.711249, 0.463114>,
      < 0.997317, -0.298277, 0.463114>,
      < 1.001803, -0.307138, 0.286730>
    }
    triangle {
      < 0.907466, -0.711249, 0.463114>,
      < 1.001803, -0.307138, 0.286730>,
      < 0.912697, -0.716689, 0.286730>
    }
    triangle {
      < 0.997317, -0.298277, 0.463114>,
      < 1.140276, 0.170694, 0.463114>,
      < 1.143579, 0.157948, 0.286730>
    }
    triangle {
      < 0.997317, -0.298277, 0.463114>,
      < 1.143579, 0.157948, 0.286730>,
      < 1.001803, -0.307138, 0.286730>
    }
    triangle {
      < 1.140276, 0.170694, 0.463114>,
      < 1.284988, 0.474386, 0.463114>,
      < 1.287091, 0.459125, 0.286730>
    }
    triangle {
      < 1.140276, 0.170694, 0.463114>,
      < 1.287091, 0.459125, 0.286730>,
      < 1.143579, 0.157948, 0.286730>
    }
    triangle {
      < 1.284988, 0.474386, 0.463114>,
      < 1.383377, 0.566505, 0.463114>,
      < 1.384666, 0.550481, 0.286730>
    }
    triangle {
      < 1.284988, 0.474386, 0.463114>,
      < 1.384666, 0.550481, 0.286730>,
      < 1.287091, 0.459125, 0.286730>
    }
    triangle {
      < 1.383377, 0.566505, 0.463114>,
      < 1.442243, 0.608377, 0.463114>,
      < 1.443045, 0.592006, 0.286730>
    }
    triangle {
      < 1.383377, 0.566505, 0.463114>,
      < 1.443045, 0.592006, 0.286730>,
      < 1.384666, 0.550481, 0.286730>
    }
    triangle {
      < 1.442243, 0.608377, 0.463114>,
      < 1.538969, 0.608377, 0.463114>,
      < 1.538969, 0.592006, 0.286730>
    }
    triangle {
      < 1.442243, 0.608377, 0.463114>,
      < 1.538969, 0.592006, 0.286730>,
      < 1.443045, 0.592006, 0.286730>
    }
    triangle {
      < 1.538969, 0.608377, 0.463114>,
      < 1.623063, 0.566505, 0.463114>,
      < 1.622366, 0.550481, 0.286730>
    }
    triangle {
      < 1.538969, 0.608377, 0.463114>,
      < 1.622366, 0.550481, 0.286730>,
      < 1.538969, 0.592006, 0.286730>
    }
    triangle {
      < 1.623063, 0.566505, 0.463114>,
      < 1.671425, 0.466011, 0.463114>,
      < 1.670328, 0.450819, 0.286730>
    }
    triangle {
      < 1.623063, 0.566505, 0.463114>,
      < 1.670328, 0.450819, 0.286730>,
      < 1.622366, 0.550481, 0.286730>
    }
    triangle {
      < 1.671425, 0.466011, 0.463114>,
      < 1.627249, 0.214777, 0.463114>,
      < 1.626518, 0.201666, 0.286730>
    }
    triangle {
      < 1.671425, 0.466011, 0.463114>,
      < 1.626518, 0.201666, 0.286730>,
      < 1.670328, 0.450819, 0.286730>
    }
    triangle {
      < 1.627249, 0.214777, 0.463114>,
      < 1.282465, -1.409872, 0.463114>,
      < 1.284590, -1.409526, 0.286730>
    }
    triangle {
      < 1.627249, 0.214777, 0.463114>,
      < 1.284590, -1.409526, 0.286730>,
      < 1.626518, 0.201666, 0.286730>
    }
    triangle {
      < 1.282465, -1.409872, 0.463114>,
      < -0.467527, -1.368000, 0.463114>,
      < -0.450907, -1.368000, 0.286730>
    }
    triangle {
      < 1.282465, -1.409872, 0.463114>,
      < -0.450907, -1.368000, 0.286730>,
      < 1.284590, -1.409526, 0.286730>
    }
    triangle {
      < -0.467527, -1.368000, 0.463114>,
      < -0.588577, -0.714790, 0.463114>,
      < -0.570954, -0.720201, 0.286730>
    }
    triangle {
      < -0.467527, -1.368000, 0.463114>,
      < -0.570954, -0.720201, 0.286730>,
      < -0.450907, -1.368000, 0.286730>
    }
    triangle {
      < -0.588577, -0.714790, 0.463114>,
      < -0.581457, -0.622671, 0.463114>,
      < -0.563893, -0.628845, 0.286730>
    }
    triangle {
      < -0.588577, -0.714790, 0.463114>,
      < -0.563893, -0.628845, 0.286730>,
      < -0.570954, -0.720201, 0.286730>
    }
    triangle {
      < -0.581457, -0.622671, 0.463114>,
      < -0.510251, -0.580799, 0.463114>,
      < -0.493276, -0.587320, 0.286730>
    }
    triangle {
      < -0.581457, -0.622671, 0.463114>,
      < -0.493276, -0.587320, 0.286730>,
      < -0.563893, -0.628845, 0.286730>
    }
    triangle {
      < -0.510251, -0.580799, 0.463114>,
      < -0.389200, -0.564050, 0.463114>,
      < -0.373229, -0.570709, 0.286730>
    }
    triangle {
      < -0.510251, -0.580799, 0.463114>,
      < -0.373229, -0.570709, 0.286730>,
      < -0.493276, -0.587320, 0.286730>
    }
    triangle {
      < -0.389200, -0.564050, 0.463114>,
      < -0.168462, -0.567400, 0.463114>,
      < -0.154318, -0.574031, 0.286730>
    }
    triangle {
      < -0.389200, -0.564050, 0.463114>,
      < -0.154318, -0.574031, 0.286730>,
      < -0.373229, -0.570709, 0.286730>
    }
    triangle {
      < -0.168462, -0.567400, 0.463114>,
      < 0.237413, -0.631046, 0.463114>,
      < 0.248194, -0.637150, 0.286730>
    }
    triangle {
      < -0.168462, -0.567400, 0.463114>,
      < 0.248194, -0.637150, 0.286730>,
      < -0.154318, -0.574031, 0.286730>
    }
    triangle {
      < -0.493276, -0.587320, 0.286730>,
      < -0.373229, -0.570709, 0.286730>,
      < -0.328597, -0.583863, 0.114615>
    }
    triangle {
      < -0.493276, -0.587320, 0.286730>,
      < -0.328597, -0.583863, 0.114615>,
      < -0.445200, -0.600199, 0.114615>
    }
    triangle {
      < -0.373229, -0.570709, 0.286730>,
      < -0.154318, -0.574031, 0.286730>,
      < -0.115968, -0.587130, 0.114615>
    }
    triangle {
      < -0.373229, -0.570709, 0.286730>,
      < -0.115968, -0.587130, 0.114615>,
      < -0.328597, -0.583863, 0.114615>
    }
    triangle {
      < -0.154318, -0.574031, 0.286730>,
      < 0.248194, -0.637150, 0.286730>,
      < 0.274758, -0.649208, 0.114615>
    }
    triangle {
      < -0.154318, -0.574031, 0.286730>,
      < 0.274758, -0.649208, 0.114615>,
      < -0.115968, -0.587130, 0.114615>
    }
    triangle {
      < 0.248194, -0.637150, 0.286730>,
      < 0.946633, -0.819334, 0.286730>,
      < 0.958824, -0.828386, 0.114615>
    }
    triangle {
      < 0.248194, -0.637150, 0.286730>,
      < 0.958824, -0.828386, 0.114615>,
      < 0.274758, -0.649208, 0.114615>
    }
    triangle {
      < 0.946633, -0.819334, 0.286730>,
      < 0.912697, -0.716689, 0.286730>,
      < 0.925586, -0.727435, 0.114615>
    }
    triangle {
      < 0.946633, -0.819334, 0.286730>,
      < 0.925586, -0.727435, 0.114615>,
      < 0.958824, -0.828386, 0.114615>
    }
    triangle {
      < 0.912697, -0.716689, 0.286730>,
      < 1.001803, -0.307138, 0.286730>,
      < 1.012858, -0.324640, 0.114615>
    }
    triangle {
      < 0.912697, -0.716689, 0.286730>,
      < 1.012858, -0.324640, 0.114615>,
      < 0.925586, -0.727435, 0.114615>
    }
    triangle {
      < 1.001803, -0.307138, 0.286730>,
      < 1.143579, 0.157948, 0.286730>,
      < 1.151716, 0.132773, 0.114615>
    }
    triangle {
      < 1.001803, -0.307138, 0.286730>,
      < 1.151716, 0.132773, 0.114615>,
      < 1.012858, -0.324640, 0.114615>
    }
    triangle {
      < 1.143579, 0.157948, 0.286730>,
      < 1.287091, 0.459125, 0.286730>,
      < 1.292275, 0.428981, 0.114615>
    }
    triangle {
      < 1.143579, 0.157948, 0.286730>,
      < 1.292275, 0.428981, 0.114615>,
      < 1.151716, 0.132773, 0.114615>
    }
    triangle {
      < 1.287091, 0.459125, 0.286730>,
      < 1.384666, 0.550481, 0.286730>,
      < 1.387842, 0.518830, 0.114615>
    }
    triangle {
      < 1.287091, 0.459125, 0.286730>,
      < 1.387842, 0.518830, 0.114615>,
      < 1.292275, 0.428981, 0.114615>
    }
    triangle {
      < 1.384666, 0.550481, 0.286730>,
      < 1.443045, 0.592006, 0.286730>,
      < 1.445019, 0.559671, 0.114615>
    }
    triangle {
      < 1.384666, 0.550481, 0.286730>,
      < 1.445019, 0.559671, 0.114615>,
      < 1.387842, 0.518830, 0.114615>
    }
    triangle {
      < 1.443045, 0.592006, 0.286730>,
      < 1.538969, 0.592006, 0.286730>,
      < 1.538969, 0.559671, 0.114615>
    }
    triangle {
      < 1.443045, 0.592006, 0.286730>,
      < 1.538969, 0.559671, 0.114615>,
      < 1.445019, 0.559671, 0.114615>
    }
    triangle {
      < 1.538969, 0.592006, 0.286730>,
      < 1.622366, 0.550481, 0.286730>,
      < 1.620650, 0.518830, 0.114615>
    }
    triangle {
      < 1.538969, 0.592006, 0.286730>,
      < 1.620650, 0.518830, 0.114615>,
      < 1.538969, 0.559671, 0.114615>
    }
    triangle {
      < 1.622366, 0.550481, 0.286730>,
      < 1.670328, 0.450819, 0.286730>,
      < 1.667625, 0.420813, 0.114615>
    }
    triangle {
      < 1.622366, 0.550481, 0.286730>,
      < 1.667625, 0.420813, 0.114615>,
      < 1.620650, 0.518830, 0.114615>
    }
    triangle {
      < 1.670328, 0.450819, 0.286730>,
      < 1.626518, 0.201666, 0.286730>,
      < 1.624716, 0.175770, 0.114615>
    }
    triangle {
      < 1.670328, 0.450819, 0.286730>,
      < 1.624716, 0.175770, 0.114615>,
      < 1.667625, 0.420813, 0.114615>
    }
    triangle {
      < 1.626518, 0.201666, 0.286730>,
      < 1.284590, -1.409526, 0.286730>,
      < 1.289825, -1.408841, 0.114615>
    }
    triangle {
      < 1.626518, 0.201666, 0.286730>,
      < 1.289825, -1.408841, 0.114615>,
      < 1.624716, 0.175770, 0.114615>
    }
    triangle {
      < 1.284590, -1.409526, 0.286730>,
      < -0.450907, -1.368000, 0.286730>,
      < -0.404046, -1.368000, 0.114615>
    }
    triangle {
      < 1.284590, -1.409526, 0.286730>,
      < -0.404046, -1.368000, 0.114615>,
      < 1.289825, -1.408841, 0.114615>
    }
    triangle {
      < -0.450907, -1.368000, 0.286730>,
      < -0.570954, -0.720201, 0.286730>,
      < -0.520650, -0.730889, 0.114615>
    }
    triangle {
      < -0.450907, -1.368000, 0.286730>,
      < -0.520650, -0.730889, 0.114615>,
      < -0.404046, -1.368000, 0.114615>
    }
    triangle {
      < -0.570954, -0.720201, 0.286730>,
      < -0.563893, -0.628845, 0.286730>,
      < -0.513791, -0.641040, 0.114615>
    }
    triangle {
      < -0.570954, -0.720201, 0.286730>,
      < -0.513791, -0.641040, 0.114615>,
      < -0.520650, -0.730889, 0.114615>
    }
    triangle {
      < -0.563893, -0.628845, 0.286730>,
      < -0.493276, -0.587320, 0.286730>,
      < -0.445200, -0.600199, 0.114615>
    }
    triangle {
      < -0.563893, -0.628845, 0.286730>,
      < -0.445200, -0.600199, 0.114615>,
      < -0.513791, -0.641040, 0.114615>
    }
    triangle {
      < -0.404046, -1.368000, 0.114615>,
      < -0.520650, -0.730889, 0.114615>,
      < -0.462992, -0.765600, 0.044292>
    }
    triangle {
      < -0.404046, -1.368000, 0.114615>,
      < -0.462992, -0.765600, 0.044292>,
      < -0.350672, -1.368000, 0.044292>
    }
    triangle {
      < -0.520650, -0.730889, 0.114615>,
      < -0.513791, -0.641040, 0.114615>,
      < -0.441985, -0.677600, 0.030305>
    }
    triangle {
      < -0.520650, -0.730889, 0.114615>,
      < -0.441985, -0.677600, 0.030305>,
      < -0.462992, -0.765600, 0.044292>
    }
    triangle {
      < -0.513791, -0.641040, 0.114615>,
      < -0.445200, -0.600199, 0.114615>,
      < -0.375915, -0.637600, 0.011655>
    }
    triangle {
      < -0.513791, -0.641040, 0.114615>,
      < -0.375915, -0.637600, 0.011655>,
      < -0.441985, -0.677600, 0.030305>
    }
    triangle {
      < -0.445200, -0.600199, 0.114615>,
      < -0.328597, -0.583863, 0.114615>,
      < -0.263595, -0.621600, 0.006993>
    }
    triangle {
      < -0.445200, -0.600199, 0.114615>,
      < -0.263595, -0.621600, 0.006993>,
      < -0.375915, -0.637600, 0.011655>
    }
    triangle {
      < -0.328597, -0.583863, 0.114615>,
      < -0.115968, -0.587130, 0.114615>,
      < -0.079495, -0.624800, 0.011655>
    }
    triangle {
      < -0.328597, -0.583863, 0.114615>,
      < -0.079495, -0.624800, 0.011655>,
      < -0.263595, -0.621600, 0.006993>
    }
    triangle {
      < -0.115968, -0.587130, 0.114615>,
      < 0.274758, -0.649208, 0.114615>,
      < 0.303423, -0.685600, 0.030305>
    }
    triangle {
      < -0.115968, -0.587130, 0.114615>,
      < 0.303423, -0.685600, 0.030305>,
      < -0.079495, -0.624800, 0.011655>
    }
    triangle {
      < 0.274758, -0.649208, 0.114615>,
      < 0.958824, -0.828386, 0.114615>,
      < 0.973411, -0.861091, 0.044292>
    }
    triangle {
      < 0.274758, -0.649208, 0.114615>,
      < 0.973411, -0.861091, 0.044292>,
      < 0.303423, -0.685600, 0.030305>
    }
    triangle {
      < 0.958824, -0.828386, 0.114615>,
      < 0.925586, -0.727435, 0.114615>,
      < 0.940857, -0.740617, 0.044292>
    }
    triangle {
      < 0.958824, -0.828386, 0.114615>,
      < 0.940857, -0.740617, 0.044292>,
      < 0.973411, -0.861091, 0.044292>
    }
    triangle {
      < 0.925586, -0.727435, 0.114615>,
      < 1.012858, -0.324640, 0.114615>,
      < 1.026333, -0.346112, 0.044292>
    }
    triangle {
      < 0.925586, -0.727435, 0.114615>,
      < 1.026333, -0.346112, 0.044292>,
      < 0.940857, -0.740617, 0.044292>
    }
    triangle {
      < 1.012858, -0.324640, 0.114615>,
      < 1.151716, 0.132773, 0.114615>,
      < 1.162333, 0.101888, 0.044292>
    }
    triangle {
      < 1.012858, -0.324640, 0.114615>,
      < 1.162333, 0.101888, 0.044292>,
      < 1.026333, -0.346112, 0.044292>
    }
    triangle {
      < 1.151716, 0.132773, 0.114615>,
      < 1.292275, 0.428981, 0.114615>,
      < 1.300000, 0.392000, 0.044292>
    }
    triangle {
      < 1.151716, 0.132773, 0.114615>,
      < 1.300000, 0.392000, 0.044292>,
      < 1.162333, 0.101888, 0.044292>
    }
    triangle {
      < 1.292275, 0.428981, 0.114615>,
      < 1.387842, 0.518830, 0.114615>,
      < 1.393600, 0.480000, 0.044292>
    }
    triangle {
      < 1.292275, 0.428981, 0.114615>,
      < 1.393600, 0.480000, 0.044292>,
      < 1.300000, 0.392000, 0.044292>
    }
    triangle {
      < 1.387842, 0.518830, 0.114615>,
      < 1.445019, 0.559671, 0.114615>,
      < 1.449600, 0.520000, 0.044292>
    }
    triangle {
      < 1.387842, 0.518830, 0.114615>,
      < 1.449600, 0.520000, 0.044292>,
      < 1.393600, 0.480000, 0.044292>
    }
    triangle {
      < 1.445019, 0.559671, 0.114615>,
      < 1.538969, 0.559671, 0.114615>,
      < 1.541617, 0.520000, 0.044292>
    }
    triangle {
      < 1.445019, 0.559671, 0.114615>,
      < 1.541617, 0.520000, 0.044292>,
      < 1.449600, 0.520000, 0.044292>
    }
    triangle {
      < 1.538969, 0.559671, 0.114615>,
      < 1.620650, 0.518830, 0.114615>,
      < 1.621617, 0.480000, 0.044292>
    }
    triangle {
      < 1.538969, 0.559671, 0.114615>,
      < 1.621617, 0.480000, 0.044292>,
      < 1.541617, 0.520000, 0.044292>
    }
    triangle {
      < 1.620650, 0.518830, 0.114615>,
      < 1.667625, 0.420813, 0.114615>,
      < 1.667625, 0.384000, 0.044292>
    }
    triangle {
      < 1.620650, 0.518830, 0.114615>,
      < 1.667625, 0.384000, 0.044292>,
      < 1.621617, 0.480000, 0.044292>
    }
    triangle {
      < 1.667625, 0.420813, 0.114615>,
      < 1.624716, 0.175770, 0.114615>,
      < 1.625600, 0.144000, 0.044292>
    }
    triangle {
      < 1.667625, 0.420813, 0.114615>,
      < 1.625600, 0.144000, 0.044292>,
      < 1.667625, 0.384000, 0.044292>
    }
    triangle {
      < 1.624716, 0.175770, 0.114615>,
      < 1.289825, -1.408841, 0.114615>,
      < 1.297600, -1.408000, 0.044292>
    }
    triangle {
      < 1.624716, 0.175770, 0.114615>,
      < 1.297600, -1.408000, 0.044292>,
      < 1.625600, 0.144000, 0.044292>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < 0.114115, -1.388035, 0.011655>,
      < 0.475977, -1.394139, 0.030305>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < 0.475977, -1.394139, 0.030305>,
      < 1.125798, -1.405102, 0.044292>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < 1.125798, -1.405102, 0.044292>,
      < 1.297600, -1.408000, 0.044292>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < 1.297600, -1.408000, 0.044292>,
      < 1.289825, -1.408841, 0.114615>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < 1.289825, -1.408841, 0.114615>,
      < -0.404046, -1.368000, 0.114615>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < -0.404046, -1.368000, 0.114615>,
      < -0.350672, -1.368000, 0.044292>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < -0.350672, -1.368000, 0.044292>,
      < -0.300640, -1.381333, 0.030305>
    }
    triangle {
      < -0.096081, -1.384488, 0.006993>,
      < -0.300640, -1.381333, 0.030305>,
      < -0.225137, -1.382295, 0.011655>
    }
    triangle {
      < -0.441985, -0.677600, 0.030305>,
      < -0.300640, -1.381333, 0.030305>,
      < -0.350672, -1.368000, 0.044292>
    }
    triangle {
      < -0.441985, -0.677600, 0.030305>,
      < -0.350672, -1.368000, 0.044292>,
      < -0.462992, -0.765600, 0.044292>
    }
    texture {fseat}
  }
  // bseat
  union {
    triangle {
      < 3.883232, 0.491614, 2.318152>,
      < 4.056026, 0.490409, 2.351752>,
      < 4.011121, 0.548839, 2.318152>
    }
    triangle {
      < 2.251997, -1.847456, 2.149752>,
      < 2.166532, -1.858086, 2.077352>,
      < 3.611769, -1.841750, 2.077352>
    }
    triangle {
      < 2.251997, -1.847456, 2.149752>,
      < 3.611769, -1.841750, 2.077352>,
      < 3.624801, -1.832000, 2.149752>
    }
    triangle {
      < 2.251997, -1.847456, 2.149752>,
      < 3.624801, -1.832000, 2.149752>,
      < 2.522855, -1.844482, 2.149752>
    }
    triangle {
      < 2.251997, -1.847456, 2.149752>,
      < 2.522855, -1.844482, 2.149752>,
      < 2.402448, -1.845804, 2.149752>
    }
    triangle {
      < 2.251997, -1.847456, 2.149752>,
      < 2.402448, -1.845804, 2.149752>,
      < 2.310423, -1.846814, 2.149752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 3.611769, -1.841750, 2.077352>,
      < 4.389287, -0.180291, 2.058646>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 4.389287, -0.180291, 2.058646>,
      < 4.389499, -0.207939, 2.197752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 4.389499, -0.207939, 2.197752>,
      < 4.257186, -0.499095, 2.149752>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.389499, -0.207939, 2.197752>,
      < 4.401617, 0.526998, 2.245752>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.401617, 0.526998, 2.245752>,
      < 4.401617, 0.488000, 2.318152>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.401617, 0.488000, 2.318152>,
      < 4.399747, 0.377859, 2.318152>
    }
    triangle {
      < 4.401617, 0.526998, 2.245752>,
      < 4.324324, 0.576007, 2.245752>,
      < 4.325600, 0.536000, 2.318152>
    }
    triangle {
      < 4.401617, 0.526998, 2.245752>,
      < 4.325600, 0.536000, 2.318152>,
      < 4.401617, 0.488000, 2.318152>
    }
    triangle {
      < 4.324324, 0.576007, 2.245752>,
      < 4.257366, 0.593937, 2.245752>,
      < 4.259746, 0.553561, 2.318152>
    }
    triangle {
      < 4.324324, 0.576007, 2.245752>,
      < 4.259746, 0.553561, 2.318152>,
      < 4.325600, 0.536000, 2.318152>
    }
    triangle {
      < 4.257366, 0.593937, 2.245752>,
      < 4.004570, 0.589115, 2.245752>,
      < 4.011121, 0.548839, 2.318152>
    }
    triangle {
      < 4.257366, 0.593937, 2.245752>,
      < 4.011121, 0.548839, 2.318152>,
      < 4.259746, 0.553561, 2.318152>
    }
    triangle {
      < 4.004570, 0.589115, 2.245752>,
      < 3.874535, 0.530688, 2.245752>,
      < 3.883232, 0.491614, 2.318152>
    }
    triangle {
      < 4.004570, 0.589115, 2.245752>,
      < 3.883232, 0.491614, 2.318152>,
      < 4.011121, 0.548839, 2.318152>
    }
    triangle {
      < 3.874535, 0.530688, 2.245752>,
      < 3.781318, 0.419660, 2.245752>,
      < 3.791552, 0.382871, 2.318152>
    }
    triangle {
      < 3.874535, 0.530688, 2.245752>,
      < 3.791552, 0.382871, 2.318152>,
      < 3.883232, 0.491614, 2.318152>
    }
    triangle {
      < 3.781318, 0.419660, 2.245752>,
      < 3.614690, -0.024563, 2.245752>,
      < 3.627673, -0.052210, 2.318152>
    }
    triangle {
      < 3.781318, 0.419660, 2.245752>,
      < 3.627673, -0.052210, 2.318152>,
      < 3.791552, 0.382871, 2.318152>
    }
    triangle {
      < 3.614690, -0.024563, 2.245752>,
      < 3.524401, -0.473808, 2.245752>,
      < 3.538874, -0.492210, 2.318152>
    }
    triangle {
      < 3.614690, -0.024563, 2.245752>,
      < 3.538874, -0.492210, 2.318152>,
      < 3.627673, -0.052210, 2.318152>
    }
    triangle {
      < 3.517043, -0.462198, 2.072952>,
      < 3.457355, -0.917727, 2.077352>,
      < 3.472934, -0.926993, 2.149752>
    }
    triangle {
      < 3.517043, -0.462198, 2.072952>,
      < 3.472934, -0.926993, 2.149752>,
      < 3.538874, -0.492210, 2.149752>
    }
    triangle {
      < 3.457355, -0.917727, 2.077352>,
      < 3.489269, -0.999964, 2.077352>,
      < 3.504321, -1.043538, 2.149752>
    }
    triangle {
      < 3.457355, -0.917727, 2.077352>,
      < 3.504321, -1.043538, 2.149752>,
      < 3.472934, -0.926993, 2.149752>
    }
    triangle {
      < 3.489269, -0.999964, 2.077352>,
      < 3.212380, -0.939175, 2.077352>,
      < 3.232000, -0.984000, 2.149752>
    }
    triangle {
      < 3.489269, -0.999964, 2.077352>,
      < 3.232000, -0.984000, 2.149752>,
      < 3.504321, -1.043538, 2.149752>
    }
    triangle {
      < 3.212380, -0.939175, 2.077352>,
      < 2.634852, -0.853410, 2.077352>,
      < 2.664000, -0.900000, 2.149752>
    }
    triangle {
      < 3.212380, -0.939175, 2.077352>,
      < 2.664000, -0.900000, 2.149752>,
      < 3.232000, -0.984000, 2.149752>
    }
    triangle {
      < 2.634852, -0.853410, 2.077352>,
      < 2.304813, -0.828906, 2.077352>,
      < 2.387997, -0.875456, 2.149752>
    }
    triangle {
      < 2.634852, -0.853410, 2.077352>,
      < 2.387997, -0.875456, 2.149752>,
      < 2.664000, -0.900000, 2.149752>
    }
    triangle {
      < 2.304813, -0.828906, 2.077352>,
      < 2.190935, -0.845242, 2.077352>,
      < 2.275997, -0.891456, 2.149752>
    }
    triangle {
      < 2.304813, -0.828906, 2.077352>,
      < 2.275997, -0.891456, 2.149752>,
      < 2.387997, -0.875456, 2.149752>
    }
    triangle {
      < 2.190935, -0.845242, 2.077352>,
      < 2.109592, -0.894251, 2.077352>,
      < 2.195997, -0.939456, 2.149752>
    }
    triangle {
      < 2.190935, -0.845242, 2.077352>,
      < 2.195997, -0.939456, 2.149752>,
      < 2.275997, -0.891456, 2.149752>
    }
    triangle {
      < 2.109592, -0.894251, 2.077352>,
      < 2.068922, -0.984100, 2.077352>,
      < 2.155997, -1.027456, 2.149752>
    }
    triangle {
      < 2.109592, -0.894251, 2.077352>,
      < 2.155997, -1.027456, 2.149752>,
      < 2.195997, -0.939456, 2.149752>
    }
    triangle {
      < 2.068922, -0.984100, 2.077352>,
      < 2.166532, -1.858086, 2.077352>,
      < 2.251997, -1.847456, 2.149752>
    }
    triangle {
      < 2.068922, -0.984100, 2.077352>,
      < 2.251997, -1.847456, 2.149752>,
      < 2.155997, -1.027456, 2.149752>
    }
    triangle {
      < 2.117246, -0.828252, 1.900152>,
      < 2.034539, -0.878083, 1.900152>,
      < 2.109592, -0.894251, 2.077352>
    }
    triangle {
      < 2.117246, -0.828252, 1.900152>,
      < 2.109592, -0.894251, 2.077352>,
      < 2.190935, -0.845242, 2.077352>
    }
    triangle {
      < 2.034539, -0.878083, 1.900152>,
      < 1.993187, -0.969439, 1.900152>,
      < 2.068922, -0.984100, 2.077352>
    }
    triangle {
      < 2.034539, -0.878083, 1.900152>,
      < 2.068922, -0.984100, 2.077352>,
      < 2.109592, -0.894251, 2.077352>
    }
    triangle {
      < 1.993187, -0.969439, 1.900152>,
      < 2.092434, -1.858086, 1.900152>,
      < 2.166532, -1.858086, 2.077352>
    }
    triangle {
      < 1.993187, -0.969439, 1.900152>,
      < 2.166532, -1.858086, 2.077352>,
      < 2.068922, -0.984100, 2.077352>
    }
    triangle {
      < 2.092434, -1.858086, 1.900152>,
      < 3.598520, -1.841476, 1.900152>,
      < 3.611769, -1.841750, 2.077352>
    }
    triangle {
      < 2.092434, -1.858086, 1.900152>,
      < 3.611769, -1.841750, 2.077352>,
      < 2.166532, -1.858086, 2.077352>
    }
    triangle {
      < 3.598520, -1.841476, 1.900152>,
      < 4.389192, -0.162058, 1.900152>,
      < 4.389287, -0.180291, 2.058646>
    }
    triangle {
      < 3.598520, -1.841476, 1.900152>,
      < 4.389287, -0.180291, 2.058646>,
      < 3.611769, -1.841750, 2.077352>
    }
    triangle {
      < 4.389287, -0.180291, 2.058646>,
      < 4.401617, 0.567007, 2.068552>,
      < 4.401617, 0.526998, 2.245752>
    }
    triangle {
      < 4.389287, -0.180291, 2.058646>,
      < 4.401617, 0.526998, 2.245752>,
      < 4.389499, -0.207939, 2.197752>
    }
    triangle {
      < 4.401617, 0.567007, 2.068552>,
      < 4.323027, 0.616838, 2.068552>,
      < 4.324324, 0.576007, 2.245752>
    }
    triangle {
      < 4.401617, 0.567007, 2.068552>,
      < 4.324324, 0.576007, 2.245752>,
      < 4.401617, 0.526998, 2.245752>
    }
    triangle {
      < 4.323027, 0.616838, 2.068552>,
      < 4.254946, 0.635069, 2.068552>,
      < 4.257366, 0.593937, 2.245752>
    }
    triangle {
      < 4.323027, 0.616838, 2.068552>,
      < 4.257366, 0.593937, 2.245752>,
      < 4.324324, 0.576007, 2.245752>
    }
    triangle {
      < 4.254946, 0.635069, 2.068552>,
      < 3.997909, 0.630166, 2.068552>,
      < 4.004570, 0.589115, 2.245752>
    }
    triangle {
      < 4.254946, 0.635069, 2.068552>,
      < 4.004570, 0.589115, 2.245752>,
      < 4.257366, 0.593937, 2.245752>
    }
    triangle {
      < 3.997909, 0.630166, 2.068552>,
      < 3.865693, 0.570759, 2.068552>,
      < 3.874535, 0.530688, 2.245752>
    }
    triangle {
      < 3.997909, 0.630166, 2.068552>,
      < 3.874535, 0.530688, 2.245752>,
      < 4.004570, 0.589115, 2.245752>
    }
    triangle {
      < 3.865693, 0.570759, 2.068552>,
      < 3.770912, 0.457868, 2.068552>,
      < 3.781318, 0.419660, 2.245752>
    }
    triangle {
      < 3.865693, 0.570759, 2.068552>,
      < 3.781318, 0.419660, 2.245752>,
      < 3.874535, 0.530688, 2.245752>
    }
    triangle {
      < 3.770912, 0.457868, 2.068552>,
      < 3.601489, 0.006194, 2.068552>,
      < 3.614690, -0.024563, 2.245752>
    }
    triangle {
      < 3.770912, 0.457868, 2.068552>,
      < 3.614690, -0.024563, 2.245752>,
      < 3.781318, 0.419660, 2.245752>
    }
    triangle {
      < 3.601489, 0.006194, 2.068552>,
      < 3.517043, -0.462198, 2.072952>,
      < 3.524401, -0.473808, 2.245752>
    }
    triangle {
      < 3.601489, 0.006194, 2.068552>,
      < 3.524401, -0.473808, 2.245752>,
      < 3.614690, -0.024563, 2.245752>
    }
    triangle {
      < 3.509686, -0.450587, 1.900152>,
      < 3.441515, -0.901953, 1.900152>,
      < 3.457355, -0.917727, 2.077352>
    }
    triangle {
      < 3.509686, -0.450587, 1.900152>,
      < 3.457355, -0.917727, 2.077352>,
      < 3.517043, -0.462198, 2.072952>
    }
    triangle {
      < 3.441515, -0.901953, 1.900152>,
      < 3.473964, -0.985569, 1.900152>,
      < 3.489269, -0.999964, 2.077352>
    }
    triangle {
      < 3.441515, -0.901953, 1.900152>,
      < 3.489269, -0.999964, 2.077352>,
      < 3.457355, -0.917727, 2.077352>
    }
    triangle {
      < 3.473964, -0.985569, 1.900152>,
      < 3.192430, -0.923761, 1.900152>,
      < 3.212380, -0.939175, 2.077352>
    }
    triangle {
      < 3.473964, -0.985569, 1.900152>,
      < 3.212380, -0.939175, 2.077352>,
      < 3.489269, -0.999964, 2.077352>
    }
    triangle {
      < 3.192430, -0.923761, 1.900152>,
      < 2.605214, -0.836557, 1.900152>,
      < 2.634852, -0.853410, 2.077352>
    }
    triangle {
      < 3.192430, -0.923761, 1.900152>,
      < 2.634852, -0.853410, 2.077352>,
      < 3.212380, -0.939175, 2.077352>
    }
    triangle {
      < 2.605214, -0.836557, 1.900152>,
      < 2.233035, -0.811642, 1.900152>,
      < 2.304813, -0.828906, 2.077352>
    }
    triangle {
      < 2.605214, -0.836557, 1.900152>,
      < 2.304813, -0.828906, 2.077352>,
      < 2.634852, -0.853410, 2.077352>
    }
    triangle {
      < 2.233035, -0.811642, 1.900152>,
      < 2.117246, -0.828252, 1.900152>,
      < 2.190935, -0.845242, 2.077352>
    }
    triangle {
      < 2.233035, -0.811642, 1.900152>,
      < 2.190935, -0.845242, 2.077352>,
      < 2.304813, -0.828906, 2.077352>
    }
    triangle {
      < 3.182987, -0.912031, 1.718557>,
      < 2.590867, -0.823732, 1.718557>,
      < 2.605214, -0.836557, 1.900152>
    }
    triangle {
      < 3.182987, -0.912031, 1.718557>,
      < 2.605214, -0.836557, 1.900152>,
      < 3.192430, -0.923761, 1.900152>
    }
    triangle {
      < 2.590867, -0.823732, 1.718557>,
      < 2.215579, -0.798504, 1.718557>,
      < 2.233035, -0.811642, 1.900152>
    }
    triangle {
      < 2.590867, -0.823732, 1.718557>,
      < 2.233035, -0.811642, 1.900152>,
      < 2.605214, -0.836557, 1.900152>
    }
    triangle {
      < 2.215579, -0.798504, 1.718557>,
      < 2.098823, -0.815323, 1.718557>,
      < 2.117246, -0.828252, 1.900152>
    }
    triangle {
      < 2.215579, -0.798504, 1.718557>,
      < 2.117246, -0.828252, 1.900152>,
      < 2.233035, -0.811642, 1.900152>
    }
    triangle {
      < 2.098823, -0.815323, 1.718557>,
      < 2.015425, -0.865779, 1.718557>,
      < 2.034539, -0.878083, 1.900152>
    }
    triangle {
      < 2.098823, -0.815323, 1.718557>,
      < 2.034539, -0.878083, 1.900152>,
      < 2.117246, -0.828252, 1.900152>
    }
    triangle {
      < 2.015425, -0.865779, 1.718557>,
      < 1.973727, -0.958282, 1.718557>,
      < 1.993187, -0.969439, 1.900152>
    }
    triangle {
      < 2.015425, -0.865779, 1.718557>,
      < 1.993187, -0.969439, 1.900152>,
      < 2.034539, -0.878083, 1.900152>
    }
    triangle {
      < 1.973727, -0.958282, 1.718557>,
      < 2.073804, -1.858086, 1.718557>,
      < 2.092434, -1.858086, 1.900152>
    }
    triangle {
      < 1.973727, -0.958282, 1.718557>,
      < 2.092434, -1.858086, 1.900152>,
      < 1.993187, -0.969439, 1.900152>
    }
    triangle {
      < 2.073804, -1.858086, 1.718557>,
      < 3.592469, -1.841267, 1.718557>,
      < 3.598520, -1.841476, 1.900152>
    }
    triangle {
      < 2.073804, -1.858086, 1.718557>,
      < 3.598520, -1.841476, 1.900152>,
      < 2.092434, -1.858086, 1.900152>
    }
    triangle {
      < 3.592469, -1.841267, 1.718557>,
      < 4.389745, -0.145584, 1.718557>,
      < 4.389192, -0.162058, 1.900152>
    }
    triangle {
      < 3.592469, -1.841267, 1.718557>,
      < 4.389192, -0.162058, 1.900152>,
      < 3.598520, -1.841476, 1.900152>
    }
    triangle {
      < 4.389745, -0.145584, 1.718557>,
      < 4.402273, 0.610390, 1.718557>,
      < 4.401617, 0.592719, 1.900152>
    }
    triangle {
      < 4.389745, -0.145584, 1.718557>,
      < 4.401617, 0.592719, 1.900152>,
      < 4.389192, -0.162058, 1.900152>
    }
    triangle {
      < 4.402273, 0.610390, 1.718557>,
      < 4.323027, 0.661479, 1.718557>,
      < 4.323027, 0.643809, 1.900152>
    }
    triangle {
      < 4.402273, 0.610390, 1.718557>,
      < 4.323027, 0.643809, 1.900152>,
      < 4.401617, 0.592719, 1.900152>
    }
    triangle {
      < 4.323027, 0.661479, 1.718557>,
      < 4.254377, 0.680171, 1.718557>,
      < 4.254946, 0.662500, 1.900152>
    }
    triangle {
      < 4.323027, 0.661479, 1.718557>,
      < 4.254946, 0.662500, 1.900152>,
      < 4.323027, 0.643809, 1.900152>
    }
    triangle {
      < 4.254377, 0.680171, 1.718557>,
      < 3.995193, 0.675144, 1.718557>,
      < 3.997909, 0.657474, 1.900152>
    }
    triangle {
      < 4.254377, 0.680171, 1.718557>,
      < 3.997909, 0.657474, 1.900152>,
      < 4.254946, 0.662500, 1.900152>
    }
    triangle {
      < 3.995193, 0.675144, 1.718557>,
      < 3.861873, 0.614236, 1.718557>,
      < 3.865693, 0.596565, 1.900152>
    }
    triangle {
      < 3.995193, 0.675144, 1.718557>,
      < 3.865693, 0.596565, 1.900152>,
      < 3.997909, 0.657474, 1.900152>
    }
    triangle {
      < 3.861873, 0.614236, 1.718557>,
      < 3.766301, 0.498493, 1.718557>,
      < 3.770912, 0.480823, 1.900152>
    }
    triangle {
      < 3.861873, 0.614236, 1.718557>,
      < 3.770912, 0.480823, 1.900152>,
      < 3.865693, 0.596565, 1.900152>
    }
    triangle {
      < 3.766301, 0.498493, 1.718557>,
      < 3.595463, 0.035406, 1.718557>,
      < 3.601489, 0.017736, 1.900152>
    }
    triangle {
      < 3.766301, 0.498493, 1.718557>,
      < 3.601489, 0.017736, 1.900152>,
      < 3.770912, 0.480823, 1.900152>
    }
    triangle {
      < 3.595463, 0.035406, 1.718557>,
      < 3.502892, -0.432917, 1.718557>,
      < 3.509686, -0.450587, 1.900152>
    }
    triangle {
      < 3.595463, 0.035406, 1.718557>,
      < 3.509686, -0.450587, 1.900152>,
      < 3.601489, 0.017736, 1.900152>
    }
    triangle {
      < 3.502892, -0.432917, 1.718557>,
      < 3.434152, -0.889949, 1.718557>,
      < 3.441515, -0.901953, 1.900152>
    }
    triangle {
      < 3.502892, -0.432917, 1.718557>,
      < 3.441515, -0.901953, 1.900152>,
      < 3.509686, -0.450587, 1.900152>
    }
    triangle {
      < 3.434152, -0.889949, 1.718557>,
      < 3.466872, -0.974615, 1.718557>,
      < 3.473964, -0.985569, 1.900152>
    }
    triangle {
      < 3.434152, -0.889949, 1.718557>,
      < 3.473964, -0.985569, 1.900152>,
      < 3.441515, -0.901953, 1.900152>
    }
    triangle {
      < 3.466872, -0.974615, 1.718557>,
      < 3.182987, -0.912031, 1.718557>,
      < 3.192430, -0.923761, 1.900152>
    }
    triangle {
      < 3.466872, -0.974615, 1.718557>,
      < 3.192430, -0.923761, 1.900152>,
      < 3.473964, -0.985569, 1.900152>
    }
    triangle {
      < 3.490286, -0.403324, 1.175757>,
      < 3.420393, -0.869959, 1.175757>,
      < 3.434152, -0.889949, 1.718557>
    }
    triangle {
      < 3.490286, -0.403324, 1.175757>,
      < 3.434152, -0.889949, 1.718557>,
      < 3.502892, -0.432917, 1.718557>
    }
    triangle {
      < 3.420393, -0.869959, 1.175757>,
      < 3.453663, -0.956405, 1.175757>,
      < 3.466872, -0.974615, 1.718557>
    }
    triangle {
      < 3.420393, -0.869959, 1.175757>,
      < 3.466872, -0.974615, 1.718557>,
      < 3.434152, -0.889949, 1.718557>
    }
    triangle {
      < 3.453663, -0.956405, 1.175757>,
      < 3.165015, -0.892505, 1.175757>,
      < 3.182987, -0.912031, 1.718557>
    }
    triangle {
      < 3.453663, -0.956405, 1.175757>,
      < 3.182987, -0.912031, 1.718557>,
      < 3.466872, -0.974615, 1.718557>
    }
    triangle {
      < 3.165015, -0.892505, 1.175757>,
      < 2.562962, -0.802351, 1.175757>,
      < 2.590867, -0.823732, 1.718557>
    }
    triangle {
      < 3.165015, -0.892505, 1.175757>,
      < 2.590867, -0.823732, 1.718557>,
      < 3.182987, -0.912031, 1.718557>
    }
    triangle {
      < 2.562962, -0.802351, 1.175757>,
      < 2.181378, -0.776593, 1.175757>,
      < 2.215579, -0.798504, 1.718557>
    }
    triangle {
      < 2.562962, -0.802351, 1.175757>,
      < 2.215579, -0.798504, 1.718557>,
      < 2.590867, -0.823732, 1.718557>
    }
    triangle {
      < 2.181378, -0.776593, 1.175757>,
      < 2.062664, -0.793765, 1.175757>,
      < 2.098823, -0.815323, 1.718557>
    }
    triangle {
      < 2.181378, -0.776593, 1.175757>,
      < 2.098823, -0.815323, 1.718557>,
      < 2.215579, -0.798504, 1.718557>
    }
    triangle {
      < 2.062664, -0.793765, 1.175757>,
      < 1.977867, -0.845282, 1.175757>,
      < 2.015425, -0.865779, 1.718557>
    }
    triangle {
      < 2.062664, -0.793765, 1.175757>,
      < 2.015425, -0.865779, 1.718557>,
      < 2.098823, -0.815323, 1.718557>
    }
    triangle {
      < 1.977867, -0.845282, 1.175757>,
      < 1.935470, -0.939729, 1.175757>,
      < 1.973727, -0.958282, 1.718557>
    }
    triangle {
      < 1.977867, -0.845282, 1.175757>,
      < 1.973727, -0.958282, 1.718557>,
      < 2.015425, -0.865779, 1.718557>
    }
    triangle {
      < 1.935470, -0.939729, 1.175757>,
      < 2.037225, -1.858439, 1.175757>,
      < 2.073804, -1.858086, 1.718557>
    }
    triangle {
      < 1.935470, -0.939729, 1.175757>,
      < 2.073804, -1.858086, 1.718557>,
      < 1.973727, -0.958282, 1.718557>
    }
    triangle {
      < 2.037225, -1.858439, 1.175757>,
      < 3.581366, -1.841267, 1.175757>,
      < 3.592469, -1.841267, 1.718557>
    }
    triangle {
      < 2.037225, -1.858439, 1.175757>,
      < 3.592469, -1.841267, 1.718557>,
      < 2.073804, -1.858086, 1.718557>
    }
    triangle {
      < 3.581366, -1.841267, 1.175757>,
      < 4.392016, -0.111172, 1.175757>,
      < 4.389745, -0.145584, 1.718557>
    }
    triangle {
      < 3.581366, -1.841267, 1.175757>,
      < 4.389745, -0.145584, 1.718557>,
      < 3.592469, -1.841267, 1.718557>
    }
    triangle {
      < 4.392016, -0.111172, 1.175757>,
      < 4.404754, 0.648696, 1.175757>,
      < 4.402273, 0.610390, 1.718557>
    }
    triangle {
      < 4.392016, -0.111172, 1.175757>,
      < 4.402273, 0.610390, 1.718557>,
      < 4.389745, -0.145584, 1.718557>
    }
    triangle {
      < 4.404754, 0.648696, 1.175757>,
      < 4.324178, 0.700213, 1.175757>,
      < 4.323027, 0.661479, 1.718557>
    }
    triangle {
      < 4.404754, 0.648696, 1.175757>,
      < 4.323027, 0.661479, 1.718557>,
      < 4.402273, 0.610390, 1.718557>
    }
    triangle {
      < 4.324178, 0.700213, 1.175757>,
      < 4.254377, 0.719060, 1.175757>,
      < 4.254377, 0.680171, 1.718557>
    }
    triangle {
      < 4.324178, 0.700213, 1.175757>,
      < 4.254377, 0.680171, 1.718557>,
      < 4.323027, 0.661479, 1.718557>
    }
    triangle {
      < 4.254377, 0.719060, 1.175757>,
      < 3.990846, 0.713992, 1.175757>,
      < 3.995193, 0.675144, 1.718557>
    }
    triangle {
      < 4.254377, 0.719060, 1.175757>,
      < 3.995193, 0.675144, 1.718557>,
      < 4.254377, 0.680171, 1.718557>
    }
    triangle {
      < 3.990846, 0.713992, 1.175757>,
      < 3.855289, 0.652575, 1.175757>,
      < 3.861873, 0.614236, 1.718557>
    }
    triangle {
      < 3.990846, 0.713992, 1.175757>,
      < 3.861873, 0.614236, 1.718557>,
      < 3.995193, 0.675144, 1.718557>
    }
    triangle {
      < 3.855289, 0.652575, 1.175757>,
      < 3.758114, 0.535865, 1.175757>,
      < 3.766301, 0.498493, 1.718557>
    }
    triangle {
      < 3.855289, 0.652575, 1.175757>,
      < 3.766301, 0.498493, 1.718557>,
      < 3.861873, 0.614236, 1.718557>
    }
    triangle {
      < 3.758114, 0.535865, 1.175757>,
      < 3.584409, 0.068910, 1.175757>,
      < 3.595463, 0.035406, 1.718557>
    }
    triangle {
      < 3.758114, 0.535865, 1.175757>,
      < 3.595463, 0.035406, 1.718557>,
      < 3.766301, 0.498493, 1.718557>
    }
    triangle {
      < 3.584409, 0.068910, 1.175757>,
      < 3.490286, -0.403324, 1.175757>,
      < 3.502892, -0.432917, 1.718557>
    }
    triangle {
      < 3.584409, 0.068910, 1.175757>,
      < 3.502892, -0.432917, 1.718557>,
      < 3.595463, 0.035406, 1.718557>
    }
    triangle {
      < 3.850700, 0.684100, 0.343357>,
      < 3.752712, 0.565926, 0.343357>,
      < 3.758114, 0.535865, 1.175757>
    }
    triangle {
      < 3.850700, 0.684100, 0.343357>,
      < 3.758114, 0.535865, 1.175757>,
      < 3.855289, 0.652575, 1.175757>
    }
    triangle {
      < 3.752712, 0.565926, 0.343357>,
      < 3.577557, 0.093108, 0.343357>,
      < 3.584409, 0.068910, 1.175757>
    }
    triangle {
      < 3.752712, 0.565926, 0.343357>,
      < 3.584409, 0.068910, 1.175757>,
      < 3.758114, 0.535865, 1.175757>
    }
    triangle {
      < 3.577557, 0.093108, 0.343357>,
      < 3.482648, -0.385055, 0.343357>,
      < 3.490286, -0.403324, 1.175757>
    }
    triangle {
      < 3.577557, 0.093108, 0.343357>,
      < 3.490286, -0.403324, 1.175757>,
      < 3.584409, 0.068910, 1.175757>
    }
    triangle {
      < 3.482648, -0.385055, 0.343357>,
      < 3.412172, -0.857549, 0.343357>,
      < 3.420393, -0.869959, 1.175757>
    }
    triangle {
      < 3.482648, -0.385055, 0.343357>,
      < 3.420393, -0.869959, 1.175757>,
      < 3.490286, -0.403324, 1.175757>
    }
    triangle {
      < 3.412172, -0.857549, 0.343357>,
      < 3.445719, -0.945080, 0.343357>,
      < 3.453663, -0.956405, 1.175757>
    }
    triangle {
      < 3.412172, -0.857549, 0.343357>,
      < 3.453663, -0.956405, 1.175757>,
      < 3.420393, -0.869959, 1.175757>
    }
    triangle {
      < 3.445719, -0.945080, 0.343357>,
      < 3.154660, -0.880378, 0.343357>,
      < 3.165015, -0.892505, 1.175757>
    }
    triangle {
      < 3.445719, -0.945080, 0.343357>,
      < 3.165015, -0.892505, 1.175757>,
      < 3.453663, -0.956405, 1.175757>
    }
    triangle {
      < 3.154660, -0.880378, 0.343357>,
      < 2.547578, -0.789092, 0.343357>,
      < 2.562962, -0.802351, 1.175757>
    }
    triangle {
      < 3.154660, -0.880378, 0.343357>,
      < 2.562962, -0.802351, 1.175757>,
      < 3.165015, -0.892505, 1.175757>
    }
    triangle {
      < 2.547578, -0.789092, 0.343357>,
      < 2.162808, -0.763011, 0.343357>,
      < 2.181378, -0.776593, 1.175757>
    }
    triangle {
      < 2.547578, -0.789092, 0.343357>,
      < 2.181378, -0.776593, 1.175757>,
      < 2.562962, -0.802351, 1.175757>
    }
    triangle {
      < 2.162808, -0.763011, 0.343357>,
      < 2.043102, -0.780399, 0.343357>,
      < 2.062664, -0.793765, 1.175757>
    }
    triangle {
      < 2.162808, -0.763011, 0.343357>,
      < 2.062664, -0.793765, 1.175757>,
      < 2.181378, -0.776593, 1.175757>
    }
    triangle {
      < 2.043102, -0.780399, 0.343357>,
      < 1.957596, -0.832562, 0.343357>,
      < 1.977867, -0.845282, 1.175757>
    }
    triangle {
      < 2.043102, -0.780399, 0.343357>,
      < 1.977867, -0.845282, 1.175757>,
      < 2.062664, -0.793765, 1.175757>
    }
    triangle {
      < 1.957596, -0.832562, 0.343357>,
      < 1.914845, -0.928194, 0.343357>,
      < 1.935470, -0.939729, 1.175757>
    }
    triangle {
      < 1.957596, -0.832562, 0.343357>,
      < 1.935470, -0.939729, 1.175757>,
      < 1.977867, -0.845282, 1.175757>
    }
    triangle {
      < 1.914845, -0.928194, 0.343357>,
      < 2.017450, -1.858439, 0.343357>,
      < 2.037225, -1.858439, 1.175757>
    }
    triangle {
      < 1.914845, -0.928194, 0.343357>,
      < 2.037225, -1.858439, 1.175757>,
      < 1.935470, -0.939729, 1.175757>
    }
    triangle {
      < 2.017450, -1.858439, 0.343357>,
      < 3.574488, -1.841052, 0.343357>,
      < 3.581366, -1.841267, 1.175757>
    }
    triangle {
      < 2.017450, -1.858439, 0.343357>,
      < 3.581366, -1.841267, 1.175757>,
      < 2.037225, -1.858439, 1.175757>
    }
    triangle {
      < 3.574488, -1.841052, 0.343357>,
      < 4.391910, -0.089235, 0.343357>,
      < 4.392016, -0.111172, 1.175757>
    }
    triangle {
      < 3.574488, -1.841052, 0.343357>,
      < 4.392016, -0.111172, 1.175757>,
      < 3.581366, -1.841267, 1.175757>
    }
    triangle {
      < 4.391910, -0.089235, 0.343357>,
      < 4.404754, 0.680173, 0.343357>,
      < 4.404754, 0.648696, 1.175757>
    }
    triangle {
      < 4.391910, -0.089235, 0.343357>,
      < 4.404754, 0.648696, 1.175757>,
      < 4.392016, -0.111172, 1.175757>
    }
    triangle {
      < 4.404754, 0.680173, 0.343357>,
      < 4.323505, 0.732336, 0.343357>,
      < 4.324178, 0.700213, 1.175757>
    }
    triangle {
      < 4.404754, 0.680173, 0.343357>,
      < 4.324178, 0.700213, 1.175757>,
      < 4.404754, 0.648696, 1.175757>
    }
    triangle {
      < 4.323505, 0.732336, 0.343357>,
      < 4.253121, 0.751420, 0.343357>,
      < 4.254377, 0.719060, 1.175757>
    }
    triangle {
      < 4.323505, 0.732336, 0.343357>,
      < 4.254377, 0.719060, 1.175757>,
      < 4.324178, 0.700213, 1.175757>
    }
    triangle {
      < 4.253121, 0.751420, 0.343357>,
      < 3.987389, 0.746288, 0.343357>,
      < 3.990846, 0.713992, 1.175757>
    }
    triangle {
      < 4.253121, 0.751420, 0.343357>,
      < 3.990846, 0.713992, 1.175757>,
      < 4.254377, 0.719060, 1.175757>
    }
    triangle {
      < 3.987389, 0.746288, 0.343357>,
      < 3.850700, 0.684100, 0.343357>,
      < 3.855289, 0.652575, 1.175757>
    }
    triangle {
      < 3.987389, 0.746288, 0.343357>,
      < 3.855289, 0.652575, 1.175757>,
      < 3.990846, 0.713992, 1.175757>
    }
    triangle {
      < 4.323505, 0.732336, 0.000000>,
      < 4.253121, 0.751420, 0.000000>,
      < 4.253121, 0.751420, 0.343357>
    }
    triangle {
      < 4.323505, 0.732336, 0.000000>,
      < 4.253121, 0.751420, 0.343357>,
      < 4.323505, 0.732336, 0.343357>
    }
    triangle {
      < 4.253121, 0.751420, 0.000000>,
      < 3.987389, 0.746288, 0.000000>,
      < 3.987389, 0.746288, 0.343357>
    }
    triangle {
      < 4.253121, 0.751420, 0.000000>,
      < 3.987389, 0.746288, 0.343357>,
      < 4.253121, 0.751420, 0.343357>
    }
    triangle {
      < 3.987389, 0.746288, 0.000000>,
      < 3.850700, 0.684100, 0.000000>,
      < 3.850700, 0.684100, 0.343357>
    }
    triangle {
      < 3.987389, 0.746288, 0.000000>,
      < 3.850700, 0.684100, 0.343357>,
      < 3.987389, 0.746288, 0.343357>
    }
    triangle {
      < 3.850700, 0.684100, 0.000000>,
      < 3.752712, 0.565926, 0.000000>,
      < 3.752712, 0.565926, 0.343357>
    }
    triangle {
      < 3.850700, 0.684100, 0.000000>,
      < 3.752712, 0.565926, 0.343357>,
      < 3.850700, 0.684100, 0.343357>
    }
    triangle {
      < 3.752712, 0.565926, 0.000000>,
      < 3.577557, 0.093108, 0.000000>,
      < 3.577557, 0.093108, 0.343357>
    }
    triangle {
      < 3.752712, 0.565926, 0.000000>,
      < 3.577557, 0.093108, 0.343357>,
      < 3.752712, 0.565926, 0.343357>
    }
    triangle {
      < 3.577557, 0.093108, 0.000000>,
      < 3.482648, -0.385055, 0.000000>,
      < 3.482648, -0.385055, 0.343357>
    }
    triangle {
      < 3.577557, 0.093108, 0.000000>,
      < 3.482648, -0.385055, 0.343357>,
      < 3.577557, 0.093108, 0.343357>
    }
    triangle {
      < 3.482648, -0.385055, 0.000000>,
      < 3.412172, -0.857549, 0.000000>,
      < 3.412172, -0.857549, 0.343357>
    }
    triangle {
      < 3.482648, -0.385055, 0.000000>,
      < 3.412172, -0.857549, 0.343357>,
      < 3.482648, -0.385055, 0.343357>
    }
    triangle {
      < 3.412172, -0.857549, 0.000000>,
      < 3.445719, -0.945080, 0.000000>,
      < 3.445719, -0.945080, 0.343357>
    }
    triangle {
      < 3.412172, -0.857549, 0.000000>,
      < 3.445719, -0.945080, 0.343357>,
      < 3.412172, -0.857549, 0.343357>
    }
    triangle {
      < 3.445719, -0.945080, 0.000000>,
      < 3.154660, -0.880378, 0.000000>,
      < 3.154660, -0.880378, 0.343357>
    }
    triangle {
      < 3.445719, -0.945080, 0.000000>,
      < 3.154660, -0.880378, 0.343357>,
      < 3.445719, -0.945080, 0.343357>
    }
    triangle {
      < 3.154660, -0.880378, 0.000000>,
      < 2.547578, -0.789092, 0.000000>,
      < 2.547578, -0.789092, 0.343357>
    }
    triangle {
      < 3.154660, -0.880378, 0.000000>,
      < 2.547578, -0.789092, 0.343357>,
      < 3.154660, -0.880378, 0.343357>
    }
    triangle {
      < 2.547578, -0.789092, 0.000000>,
      < 2.162808, -0.763011, 0.000000>,
      < 2.162808, -0.763011, 0.343357>
    }
    triangle {
      < 2.547578, -0.789092, 0.000000>,
      < 2.162808, -0.763011, 0.343357>,
      < 2.547578, -0.789092, 0.343357>
    }
    triangle {
      < 2.162808, -0.763011, 0.000000>,
      < 2.043102, -0.780399, 0.000000>,
      < 2.043102, -0.780399, 0.343357>
    }
    triangle {
      < 2.162808, -0.763011, 0.000000>,
      < 2.043102, -0.780399, 0.343357>,
      < 2.162808, -0.763011, 0.343357>
    }
    triangle {
      < 2.043102, -0.780399, 0.000000>,
      < 1.957596, -0.832562, -0.004243>,
      < 1.957596, -0.832562, 0.343357>
    }
    triangle {
      < 2.043102, -0.780399, 0.000000>,
      < 1.957596, -0.832562, 0.343357>,
      < 2.043102, -0.780399, 0.343357>
    }
    triangle {
      < 1.957596, -0.832562, -0.004243>,
      < 1.914845, -0.928194, -0.004243>,
      < 1.914845, -0.928194, 0.343357>
    }
    triangle {
      < 1.957596, -0.832562, -0.004243>,
      < 1.914845, -0.928194, 0.343357>,
      < 1.957596, -0.832562, 0.343357>
    }
    triangle {
      < 1.914845, -0.928194, -0.004243>,
      < 2.017450, -1.858439, -0.004243>,
      < 2.017450, -1.858439, 0.343357>
    }
    triangle {
      < 1.914845, -0.928194, -0.004243>,
      < 2.017450, -1.858439, 0.343357>,
      < 1.914845, -0.928194, 0.343357>
    }
    triangle {
      < 2.017450, -1.858439, -0.004243>,
      < 3.574488, -1.841052, 0.000000>,
      < 3.574488, -1.841052, 0.343357>
    }
    triangle {
      < 2.017450, -1.858439, -0.004243>,
      < 3.574488, -1.841052, 0.343357>,
      < 2.017450, -1.858439, 0.343357>
    }
    triangle {
      < 3.574488, -1.841052, 0.000000>,
      < 4.391910, -0.089235, 0.000000>,
      < 4.391910, -0.089235, 0.343357>
    }
    triangle {
      < 3.574488, -1.841052, 0.000000>,
      < 4.391910, -0.089235, 0.343357>,
      < 3.574488, -1.841052, 0.343357>
    }
    triangle {
      < 4.391910, -0.089235, 0.000000>,
      < 4.404754, 0.680173, 0.000000>,
      < 4.404754, 0.680173, 0.343357>
    }
    triangle {
      < 4.391910, -0.089235, 0.000000>,
      < 4.404754, 0.680173, 0.343357>,
      < 4.391910, -0.089235, 0.343357>
    }
    triangle {
      < 4.404754, 0.680173, 0.000000>,
      < 4.323505, 0.732336, 0.000000>,
      < 4.323505, 0.732336, 0.343357>
    }
    triangle {
      < 4.404754, 0.680173, 0.000000>,
      < 4.323505, 0.732336, 0.343357>,
      < 4.404754, 0.680173, 0.343357>
    }
    triangle {
      < 2.155997, -1.027456, 2.149752>,
      < 2.251997, -1.847456, 2.149752>,
      < 2.310423, -1.846814, 2.149752>
    }
    triangle {
      < 2.155997, -1.027456, 2.149752>,
      < 2.310423, -1.846814, 2.149752>,
      < 2.195997, -0.939456, 2.149752>
    }
    triangle {
      < 3.883232, 0.491614, 2.318152>,
      < 3.791552, 0.382871, 2.318152>,
      < 3.994283, 0.381200, 2.351752>
    }
    triangle {
      < 3.883232, 0.491614, 2.318152>,
      < 3.994283, 0.381200, 2.351752>,
      < 4.056026, 0.490409, 2.351752>
    }
    triangle {
      < 3.791552, 0.382871, 2.318152>,
      < 3.627673, -0.052210, 2.318152>,
      < 3.881649, -0.108140, 2.351752>
    }
    triangle {
      < 3.791552, 0.382871, 2.318152>,
      < 3.881649, -0.108140, 2.351752>,
      < 3.994283, 0.381200, 2.351752>
    }
    triangle {
      < 3.538874, -0.492210, 2.149752>,
      < 3.472934, -0.926993, 2.149752>,
      < 3.504321, -1.043538, 2.149752>
    }
    triangle {
      < 3.538874, -0.492210, 2.149752>,
      < 3.504321, -1.043538, 2.149752>,
      < 3.544481, -1.282359, 2.183352>
    }
    triangle {
      < 3.538874, -0.492210, 2.149752>,
      < 3.544481, -1.282359, 2.183352>,
      < 3.768705, -0.501479, 2.183352>
    }
    triangle {
      < 4.228822, 0.489205, 2.351752>,
      < 4.259746, 0.553561, 2.318152>,
      < 4.011121, 0.548839, 2.318152>
    }
    triangle {
      < 4.228822, 0.489205, 2.351752>,
      < 4.011121, 0.548839, 2.318152>,
      < 4.056026, 0.490409, 2.351752>
    }
    triangle {
      < 4.197015, 0.379530, 2.351752>,
      < 4.228822, 0.489205, 2.351752>,
      < 4.056026, 0.490409, 2.351752>
    }
    triangle {
      < 4.197015, 0.379530, 2.351752>,
      < 4.056026, 0.490409, 2.351752>,
      < 3.994283, 0.381200, 2.351752>
    }
    triangle {
      < 4.135624, -0.164070, 2.351752>,
      < 4.197015, 0.379530, 2.351752>,
      < 3.994283, 0.381200, 2.351752>
    }
    triangle {
      < 4.135624, -0.164070, 2.351752>,
      < 3.994283, 0.381200, 2.351752>,
      < 3.881649, -0.108140, 2.351752>
    }
    triangle {
      < 3.584641, -1.557180, 2.183352>,
      < 4.004011, -0.496844, 2.183352>,
      < 3.768705, -0.501479, 2.183352>
    }
    triangle {
      < 3.584641, -1.557180, 2.183352>,
      < 3.768705, -0.501479, 2.183352>,
      < 3.544481, -1.282359, 2.183352>
    }
    triangle {
      < 4.401617, 0.488000, 2.318152>,
      < 4.325600, 0.536000, 2.318152>,
      < 4.259746, 0.553561, 2.318152>
    }
    triangle {
      < 4.401617, 0.488000, 2.318152>,
      < 4.259746, 0.553561, 2.318152>,
      < 4.228822, 0.489205, 2.351752>
    }
    triangle {
      < 4.399747, 0.377859, 2.318152>,
      < 4.401617, 0.488000, 2.318152>,
      < 4.228822, 0.489205, 2.351752>
    }
    triangle {
      < 4.399747, 0.377859, 2.318152>,
      < 4.228822, 0.489205, 2.351752>,
      < 4.197015, 0.379530, 2.351752>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.399747, 0.377859, 2.318152>,
      < 4.197015, 0.379530, 2.351752>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.197015, 0.379530, 2.351752>,
      < 4.135624, -0.164070, 2.351752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 4.257186, -0.499095, 2.149752>,
      < 4.004011, -0.496844, 2.183352>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 4.004011, -0.496844, 2.183352>,
      < 3.584641, -1.557180, 2.183352>
    }
    triangle {
      < 3.881649, -0.108140, 2.351752>,
      < 3.627673, -0.052210, 2.318152>,
      < 3.538874, -0.492210, 2.318152>
    }
    triangle {
      < 3.881649, -0.108140, 2.351752>,
      < 3.538874, -0.492210, 2.318152>,
      < 3.768705, -0.501479, 2.351752>
    }
    triangle {
      < 4.135624, -0.164070, 2.351752>,
      < 3.881649, -0.108140, 2.351752>,
      < 3.768705, -0.501479, 2.351752>
    }
    triangle {
      < 4.135624, -0.164070, 2.351752>,
      < 3.768705, -0.501479, 2.351752>,
      < 4.004011, -0.496844, 2.351752>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.135624, -0.164070, 2.351752>,
      < 4.004011, -0.496844, 2.351752>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.004011, -0.496844, 2.351752>,
      < 4.257186, -0.499095, 2.318152>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.257186, -0.499095, 2.318152>,
      < 4.257186, -0.499095, 2.149752>
    }
    triangle {
      < 4.389600, -0.220000, 2.318152>,
      < 4.257186, -0.499095, 2.149752>,
      < 4.389499, -0.207939, 2.197752>
    }
    triangle {
      < 4.257186, -0.499095, 2.318152>,
      < 4.004011, -0.496844, 2.351752>,
      < 4.004011, -0.496844, 2.183352>
    }
    triangle {
      < 4.257186, -0.499095, 2.318152>,
      < 4.004011, -0.496844, 2.183352>,
      < 4.257186, -0.499095, 2.149752>
    }
    triangle {
      < 4.004011, -0.496844, 2.351752>,
      < 3.768705, -0.501479, 2.351752>,
      < 3.768705, -0.501479, 2.183352>
    }
    triangle {
      < 4.004011, -0.496844, 2.351752>,
      < 3.768705, -0.501479, 2.183352>,
      < 4.004011, -0.496844, 2.183352>
    }
    triangle {
      < 3.768705, -0.501479, 2.351752>,
      < 3.538874, -0.492210, 2.318152>,
      < 3.538874, -0.492210, 2.149752>
    }
    triangle {
      < 3.768705, -0.501479, 2.351752>,
      < 3.538874, -0.492210, 2.149752>,
      < 3.768705, -0.501479, 2.183352>
    }
    triangle {
      < 3.538874, -0.492210, 2.318152>,
      < 3.524401, -0.473808, 2.245752>,
      < 3.517043, -0.462198, 2.072952>
    }
    triangle {
      < 3.538874, -0.492210, 2.318152>,
      < 3.517043, -0.462198, 2.072952>,
      < 3.538874, -0.492210, 2.149752>
    }
    triangle {
      < 3.517043, -0.462198, 2.072952>,
      < 3.601489, 0.006194, 2.068552>,
      < 3.601489, 0.017736, 1.900152>
    }
    triangle {
      < 3.517043, -0.462198, 2.072952>,
      < 3.601489, 0.017736, 1.900152>,
      < 3.509686, -0.450587, 1.900152>
    }
    triangle {
      < 3.601489, 0.006194, 2.068552>,
      < 3.770912, 0.457868, 2.068552>,
      < 3.770912, 0.480823, 1.900152>
    }
    triangle {
      < 3.601489, 0.006194, 2.068552>,
      < 3.770912, 0.480823, 1.900152>,
      < 3.601489, 0.017736, 1.900152>
    }
    triangle {
      < 3.770912, 0.457868, 2.068552>,
      < 3.865693, 0.570759, 2.068552>,
      < 3.865693, 0.596565, 1.900152>
    }
    triangle {
      < 3.770912, 0.457868, 2.068552>,
      < 3.865693, 0.596565, 1.900152>,
      < 3.770912, 0.480823, 1.900152>
    }
    triangle {
      < 3.865693, 0.570759, 2.068552>,
      < 3.997909, 0.630166, 2.068552>,
      < 3.997909, 0.657474, 1.900152>
    }
    triangle {
      < 3.865693, 0.570759, 2.068552>,
      < 3.997909, 0.657474, 1.900152>,
      < 3.865693, 0.596565, 1.900152>
    }
    triangle {
      < 3.997909, 0.630166, 2.068552>,
      < 4.254946, 0.635069, 2.068552>,
      < 4.254946, 0.662500, 1.900152>
    }
    triangle {
      < 3.997909, 0.630166, 2.068552>,
      < 4.254946, 0.662500, 1.900152>,
      < 3.997909, 0.657474, 1.900152>
    }
    triangle {
      < 4.254946, 0.635069, 2.068552>,
      < 4.323027, 0.616838, 2.068552>,
      < 4.323027, 0.643809, 1.900152>
    }
    triangle {
      < 4.254946, 0.635069, 2.068552>,
      < 4.323027, 0.643809, 1.900152>,
      < 4.254946, 0.662500, 1.900152>
    }
    triangle {
      < 4.323027, 0.616838, 2.068552>,
      < 4.401617, 0.567007, 2.068552>,
      < 4.401617, 0.592719, 1.900152>
    }
    triangle {
      < 4.323027, 0.616838, 2.068552>,
      < 4.401617, 0.592719, 1.900152>,
      < 4.323027, 0.643809, 1.900152>
    }
    triangle {
      < 4.401617, 0.567007, 2.068552>,
      < 4.389287, -0.180291, 2.058646>,
      < 4.389192, -0.162058, 1.900152>
    }
    triangle {
      < 4.401617, 0.567007, 2.068552>,
      < 4.389192, -0.162058, 1.900152>,
      < 4.401617, 0.592719, 1.900152>
    }
    triangle {
      < 2.402448, -1.845804, 2.149752>,
      < 2.275997, -0.891456, 2.149752>,
      < 2.195997, -0.939456, 2.149752>
    }
    triangle {
      < 2.402448, -1.845804, 2.149752>,
      < 2.195997, -0.939456, 2.149752>,
      < 2.310423, -1.846814, 2.149752>
    }
    triangle {
      < 2.522855, -1.844482, 2.149752>,
      < 2.387997, -0.875456, 2.149752>,
      < 2.275997, -0.891456, 2.149752>
    }
    triangle {
      < 2.522855, -1.844482, 2.149752>,
      < 2.275997, -0.891456, 2.149752>,
      < 2.402448, -1.845804, 2.149752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 3.584641, -1.557180, 2.183352>,
      < 3.544481, -1.282359, 2.183352>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 3.544481, -1.282359, 2.183352>,
      < 3.504321, -1.043538, 2.149752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 3.504321, -1.043538, 2.149752>,
      < 3.232000, -0.984000, 2.149752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 3.232000, -0.984000, 2.149752>,
      < 2.664000, -0.900000, 2.149752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 2.664000, -0.900000, 2.149752>,
      < 2.387997, -0.875456, 2.149752>
    }
    triangle {
      < 3.624801, -1.832000, 2.149752>,
      < 2.387997, -0.875456, 2.149752>,
      < 2.522855, -1.844482, 2.149752>
    }
    texture {bseat}
  }
  // interior
  union {
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 3.626908, -1.850225, 1.126325>,
      < 2.378150, -1.850225, 1.119635>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 2.378150, -1.850225, 1.119635>,
      < 2.379416, -1.850225, 2.149975>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 2.379416, -1.850225, 2.149975>,
      < 2.540798, -1.850225, 2.149752>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 2.540798, -1.850225, 2.149752>,
      < 2.744587, -1.850225, 2.149555>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 2.744587, -1.850225, 2.149555>,
      < 3.005907, -1.850225, 2.149338>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 3.005907, -1.850225, 2.149338>,
      < 3.625001, -1.850225, 2.149406>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 3.625001, -1.850225, 2.149406>,
      < 3.626896, -1.850225, 2.040359>
    }
    triangle {
      < 4.270950, 0.598853, 0.000000>,
      < 4.266672, 0.595661, 1.126325>,
      < 5.355932, 0.593194, 1.141120>
    }
    triangle {
      < 4.270950, 0.598853, 0.000000>,
      < 5.355932, 0.593194, 1.141120>,
      < 5.401163, 0.604866, 0.000000>
    }
    triangle {
      < 4.266672, 0.595661, 1.126325>,
      < 4.263855, 0.560059, 1.747711>,
      < 5.258856, 0.556459, 1.780305>
    }
    triangle {
      < 4.266672, 0.595661, 1.126325>,
      < 5.258856, 0.556459, 1.780305>,
      < 5.355932, 0.593194, 1.141120>
    }
    triangle {
      < 4.263855, 0.560059, 1.747711>,
      < 4.262456, 0.525243, 2.040359>,
      < 5.132811, 0.520019, 2.098088>
    }
    triangle {
      < 4.263855, 0.560059, 1.747711>,
      < 5.132811, 0.520019, 2.098088>,
      < 5.258856, 0.556459, 1.780305>
    }
    triangle {
      < 4.262456, 0.525243, 2.040359>,
      < 4.261516, 0.500683, 2.227976>,
      < 4.971003, 0.493964, 2.309541>
    }
    triangle {
      < 4.262456, 0.525243, 2.040359>,
      < 4.971003, 0.493964, 2.309541>,
      < 5.132811, 0.520019, 2.098088>
    }
    triangle {
      < 4.261516, 0.500683, 2.227976>,
      < 4.260612, 0.461617, 2.323344>,
      < 4.309868, 0.446250, 2.365411>
    }
    triangle {
      < 4.261516, 0.500683, 2.227976>,
      < 4.309868, 0.446250, 2.365411>,
      < 4.971003, 0.493964, 2.309541>
    }
    triangle {
      < 4.263341, 0.440395, 2.419557>,
      < 3.625227, 0.435713, 2.429362>,
      < 3.625835, 0.430011, 2.554180>
    }
    triangle {
      < 4.263341, 0.440395, 2.419557>,
      < 3.625835, 0.430011, 2.554180>,
      < 4.271063, 0.434863, 2.541304>
    }
    triangle {
      < 3.625227, 0.435713, 2.429362>,
      < 3.006765, 0.420722, 2.429284>,
      < 3.009002, 0.415065, 2.549848>
    }
    triangle {
      < 3.625227, 0.435713, 2.429362>,
      < 3.009002, 0.415065, 2.549848>,
      < 3.625835, 0.430011, 2.554180>
    }
    triangle {
      < 3.006765, 0.420722, 2.429284>,
      < 2.746567, 0.390882, 2.436677>,
      < 2.752269, 0.385087, 2.563607>
    }
    triangle {
      < 3.006765, 0.420722, 2.429284>,
      < 2.752269, 0.385087, 2.563607>,
      < 3.009002, 0.415065, 2.549848>
    }
    triangle {
      < 2.746567, 0.390882, 2.436677>,
      < 2.543640, 0.346010, 2.448837>,
      < 2.552528, 0.340104, 2.576065>
    }
    triangle {
      < 2.746567, 0.390882, 2.436677>,
      < 2.552528, 0.340104, 2.576065>,
      < 2.752269, 0.385087, 2.563607>
    }
    triangle {
      < 2.543640, 0.346010, 2.448837>,
      < 2.380844, 0.281394, 2.451524>,
      < 2.385818, 0.275118, 2.594347>
    }
    triangle {
      < 2.543640, 0.346010, 2.448837>,
      < 2.385818, 0.275118, 2.594347>,
      < 2.552528, 0.340104, 2.576065>
    }
    triangle {
      < 2.380844, 0.281394, 2.451524>,
      < 1.776334, 0.366205, 2.451505>,
      < 1.773786, 0.360172, 2.588591>
    }
    triangle {
      < 2.380844, 0.281394, 2.451524>,
      < 1.773786, 0.360172, 2.588591>,
      < 2.385818, 0.275118, 2.594347>
    }
    triangle {
      < 1.776334, 0.366205, 2.451505>,
      < 0.822813, 0.430957, 2.429350>,
      < 0.819398, 0.425256, 2.554250>
    }
    triangle {
      < 1.776334, 0.366205, 2.451505>,
      < 0.819398, 0.425256, 2.554250>,
      < 1.773786, 0.360172, 2.588591>
    }
    triangle {
      < 0.822813, 0.430957, 2.429350>,
      < -0.376578, 0.475573, 2.414016>,
      < -0.379683, 0.470362, 2.504004>
    }
    triangle {
      < 0.822813, 0.430957, 2.429350>,
      < -0.379683, 0.470362, 2.504004>,
      < 0.819398, 0.425256, 2.554250>
    }
    triangle {
      < -0.376578, 0.475573, 2.414016>,
      < -1.067868, 0.504709, 2.405055>,
      < -1.077008, 0.499510, 2.477921>
    }
    triangle {
      < -0.376578, 0.475573, 2.414016>,
      < -1.077008, 0.499510, 2.477921>,
      < -0.379683, 0.470362, 2.504004>
    }
    triangle {
      < -1.067868, 0.504709, 2.405055>,
      < -1.310475, 0.506873, 2.286254>,
      < -1.593830, 0.501724, 2.368387>
    }
    triangle {
      < -1.067868, 0.504709, 2.405055>,
      < -1.593830, 0.501724, 2.368387>,
      < -1.077008, 0.499510, 2.477921>
    }
    triangle {
      < -1.310475, 0.506873, 2.286254>,
      < -1.387740, 0.509184, 2.216830>,
      < -1.765427, 0.503937, 2.299581>
    }
    triangle {
      < -1.310475, 0.506873, 2.286254>,
      < -1.765427, 0.503937, 2.299581>,
      < -1.593830, 0.501724, 2.368387>
    }
    triangle {
      < -1.387740, 0.509184, 2.216830>,
      < -1.462541, 0.513094, 2.114367>,
      < -1.939025, 0.508364, 2.193487>
    }
    triangle {
      < -1.387740, 0.509184, 2.216830>,
      < -1.939025, 0.508364, 2.193487>,
      < -1.765427, 0.503937, 2.299581>
    }
    triangle {
      < -1.462541, 0.513094, 2.114367>,
      < -1.492305, 0.516620, 2.051260>,
      < -2.015709, 0.512791, 2.120956>
    }
    triangle {
      < -1.462541, 0.513094, 2.114367>,
      < -2.015709, 0.512791, 2.120956>,
      < -1.939025, 0.508364, 2.193487>
    }
    triangle {
      < 4.263341, 0.440395, 2.419557>,
      < 4.271063, 0.434863, 2.541304>,
      < 4.618841, 0.431370, 2.478587>
    }
    triangle {
      < 4.263341, 0.440395, 2.419557>,
      < 4.618841, 0.431370, 2.478587>,
      < 4.778682, 0.457080, 2.450184>
    }
    triangle {
      < 4.263341, 0.440395, 2.419557>,
      < 4.778682, 0.457080, 2.450184>,
      < 4.971003, 0.493964, 2.309541>
    }
    triangle {
      < 4.263341, 0.440395, 2.419557>,
      < 4.971003, 0.493964, 2.309541>,
      < 4.309868, 0.446250, 2.365411>
    }
    triangle {
      < 4.270950, 0.323253, 0.000000>,
      < 4.266672, 0.320061, 1.126325>,
      < 4.266672, 0.595661, 1.126325>
    }
    triangle {
      < 4.270950, 0.323253, 0.000000>,
      < 4.266672, 0.595661, 1.126325>,
      < 4.270950, 0.598853, 0.000000>
    }
    triangle {
      < 4.266672, 0.320061, 1.126325>,
      < 4.263855, 0.284459, 1.747711>,
      < 4.263855, 0.560059, 1.747711>
    }
    triangle {
      < 4.266672, 0.320061, 1.126325>,
      < 4.263855, 0.560059, 1.747711>,
      < 4.266672, 0.595661, 1.126325>
    }
    triangle {
      < 4.263855, 0.284459, 1.747711>,
      < 4.262456, 0.249643, 2.040359>,
      < 4.262456, 0.525243, 2.040359>
    }
    triangle {
      < 4.263855, 0.284459, 1.747711>,
      < 4.262456, 0.525243, 2.040359>,
      < 4.263855, 0.560059, 1.747711>
    }
    triangle {
      < 4.262456, 0.249643, 2.040359>,
      < 4.261516, 0.225084, 2.227976>,
      < 4.261516, 0.500683, 2.227976>
    }
    triangle {
      < 4.262456, 0.249643, 2.040359>,
      < 4.261516, 0.500683, 2.227976>,
      < 4.262456, 0.525243, 2.040359>
    }
    triangle {
      < 4.261516, 0.225084, 2.227976>,
      < 4.260174, 0.167064, 2.369611>,
      < 4.260174, 0.378263, 2.369611>
    }
    triangle {
      < 4.261516, 0.225084, 2.227976>,
      < 4.260174, 0.378263, 2.369611>,
      < 4.260612, 0.461617, 2.323344>
    }
    triangle {
      < 4.261516, 0.225084, 2.227976>,
      < 4.260612, 0.461617, 2.323344>,
      < 4.261516, 0.500683, 2.227976>
    }
    triangle {
      < 4.260174, 0.167064, 2.369611>,
      < 3.625001, 0.162232, 2.369808>,
      < 3.625001, 0.373432, 2.369808>
    }
    triangle {
      < 4.260174, 0.167064, 2.369611>,
      < 3.625001, 0.373432, 2.369808>,
      < 4.260174, 0.378263, 2.369611>
    }
    triangle {
      < 3.625001, 0.162232, 2.369808>,
      < 3.005907, 0.147293, 2.369739>,
      < 3.005907, 0.358493, 2.369739>
    }
    triangle {
      < 3.625001, 0.162232, 2.369808>,
      < 3.005907, 0.358493, 2.369739>,
      < 3.625001, 0.373432, 2.369808>
    }
    triangle {
      < 3.005907, 0.147293, 2.369739>,
      < 2.744587, 0.117295, 2.369957>,
      < 2.744587, 0.328496, 2.369957>
    }
    triangle {
      < 3.005907, 0.147293, 2.369739>,
      < 2.744587, 0.328496, 2.369957>,
      < 3.005907, 0.358493, 2.369739>
    }
    triangle {
      < 2.744587, 0.117295, 2.369957>,
      < 2.540798, 0.072298, 2.370153>,
      < 2.555591, 0.285560, 2.370136>
    }
    triangle {
      < 2.744587, 0.117295, 2.369957>,
      < 2.555591, 0.285560, 2.370136>,
      < 2.744587, 0.328496, 2.369957>
    }
    triangle {
      < 2.540798, 0.072298, 2.370153>,
      < 2.379416, 0.007596, 2.370376>,
      < 2.379416, 0.218796, 2.370376>
    }
    triangle {
      < 2.540798, 0.072298, 2.370153>,
      < 2.379416, 0.218796, 2.370376>,
      < 2.555591, 0.285560, 2.370136>
    }
    triangle {
      < 2.379416, 0.007596, 2.370376>,
      < 1.777091, 0.092396, 2.370343>,
      < 1.777091, 0.303596, 2.370343>
    }
    triangle {
      < 2.379416, 0.007596, 2.370376>,
      < 1.777091, 0.303596, 2.370343>,
      < 2.379416, 0.218796, 2.370376>
    }
    triangle {
      < 1.777091, 0.092396, 2.370343>,
      < 0.824081, 0.157473, 2.369811>,
      < 0.824081, 0.368673, 2.369811>
    }
    triangle {
      < 1.777091, 0.092396, 2.370343>,
      < 0.824081, 0.368673, 2.369811>,
      < 1.777091, 0.303596, 2.370343>
    }
    triangle {
      < 0.824081, 0.157473, 2.369811>,
      < -0.375026, 0.202578, 2.369029>,
      < -0.375026, 0.413778, 2.369029>
    }
    triangle {
      < 0.824081, 0.157473, 2.369811>,
      < -0.375026, 0.413778, 2.369029>,
      < 0.824081, 0.368673, 2.369811>
    }
    triangle {
      < -0.375026, 0.202578, 2.369029>,
      < -1.063298, 0.231708, 2.368628>,
      < -1.063298, 0.362908, 2.368628>
    }
    triangle {
      < -0.375026, 0.202578, 2.369029>,
      < -1.063298, 0.362908, 2.368628>,
      < -1.063298, 0.442908, 2.368628>
    }
    triangle {
      < -0.375026, 0.202578, 2.369029>,
      < -1.063298, 0.442908, 2.368628>,
      < -0.375026, 0.413778, 2.369029>
    }
    triangle {
      < -1.063298, 0.362908, 2.368628>,
      < -1.063298, 0.231708, 2.368628>,
      < -2.288326, -0.243897, 2.367348>
    }
    triangle {
      < -1.292308, 0.436852, 2.263012>,
      < -1.363152, 0.433778, 2.201167>,
      < -1.363152, 0.489778, 2.201167>
    }
    triangle {
      < -1.292308, 0.436852, 2.263012>,
      < -1.363152, 0.489778, 2.201167>,
      < -1.292308, 0.488052, 2.263012>
    }
    triangle {
      < -1.363152, 0.433778, 2.201167>,
      < -1.434754, 0.435043, 2.105901>,
      < -1.434754, 0.493443, 2.105901>
    }
    triangle {
      < -1.363152, 0.433778, 2.201167>,
      < -1.434754, 0.493443, 2.105901>,
      < -1.363152, 0.489778, 2.201167>
    }
    triangle {
      < -1.434754, 0.435043, 2.105901>,
      < -1.461509, 0.435837, 2.050812>,
      < -1.461509, 0.496637, 2.050812>
    }
    triangle {
      < -1.434754, 0.435043, 2.105901>,
      < -1.461509, 0.496637, 2.050812>,
      < -1.434754, 0.493443, 2.105901>
    }
    triangle {
      < 4.309868, 0.446250, 2.365411>,
      < 4.260612, 0.461617, 2.323344>,
      < 4.260174, 0.378263, 2.369611>
    }
    triangle {
      < 4.309868, 0.446250, 2.365411>,
      < 4.260174, 0.378263, 2.369611>,
      < 4.263341, 0.440395, 2.419557>
    }
    triangle {
      < 4.260174, 0.378263, 2.369611>,
      < 3.625001, 0.373432, 2.369808>,
      < 3.625227, 0.435713, 2.429362>
    }
    triangle {
      < 4.260174, 0.378263, 2.369611>,
      < 3.625227, 0.435713, 2.429362>,
      < 4.263341, 0.440395, 2.419557>
    }
    triangle {
      < 3.625001, 0.373432, 2.369808>,
      < 3.005907, 0.358493, 2.369739>,
      < 3.006765, 0.420722, 2.429284>
    }
    triangle {
      < 3.625001, 0.373432, 2.369808>,
      < 3.006765, 0.420722, 2.429284>,
      < 3.625227, 0.435713, 2.429362>
    }
    triangle {
      < 3.005907, 0.358493, 2.369739>,
      < 2.744587, 0.328496, 2.369957>,
      < 2.746567, 0.390882, 2.436677>
    }
    triangle {
      < 3.005907, 0.358493, 2.369739>,
      < 2.746567, 0.390882, 2.436677>,
      < 3.006765, 0.420722, 2.429284>
    }
    triangle {
      < 2.744587, 0.328496, 2.369957>,
      < 2.555591, 0.285560, 2.370136>,
      < 2.543640, 0.346010, 2.448837>
    }
    triangle {
      < 2.744587, 0.328496, 2.369957>,
      < 2.543640, 0.346010, 2.448837>,
      < 2.746567, 0.390882, 2.436677>
    }
    triangle {
      < 2.555591, 0.285560, 2.370136>,
      < 2.379416, 0.218796, 2.370376>,
      < 2.380844, 0.281394, 2.451524>
    }
    triangle {
      < 2.555591, 0.285560, 2.370136>,
      < 2.380844, 0.281394, 2.451524>,
      < 2.543640, 0.346010, 2.448837>
    }
    triangle {
      < 2.379416, 0.218796, 2.370376>,
      < 1.777091, 0.303596, 2.370343>,
      < 1.776334, 0.366205, 2.451505>
    }
    triangle {
      < 2.379416, 0.218796, 2.370376>,
      < 1.776334, 0.366205, 2.451505>,
      < 2.380844, 0.281394, 2.451524>
    }
    triangle {
      < 1.777091, 0.303596, 2.370343>,
      < 0.824081, 0.368673, 2.369811>,
      < 0.822813, 0.430957, 2.429350>
    }
    triangle {
      < 1.777091, 0.303596, 2.370343>,
      < 0.822813, 0.430957, 2.429350>,
      < 1.776334, 0.366205, 2.451505>
    }
    triangle {
      < 0.824081, 0.368673, 2.369811>,
      < -0.375026, 0.413778, 2.369029>,
      < -0.376578, 0.475573, 2.414016>
    }
    triangle {
      < 0.824081, 0.368673, 2.369811>,
      < -0.376578, 0.475573, 2.414016>,
      < 0.822813, 0.430957, 2.429350>
    }
    triangle {
      < -0.375026, 0.413778, 2.369029>,
      < -1.063298, 0.442908, 2.368628>,
      < -1.067868, 0.504709, 2.405055>
    }
    triangle {
      < -0.375026, 0.413778, 2.369029>,
      < -1.067868, 0.504709, 2.405055>,
      < -0.376578, 0.475573, 2.414016>
    }
    triangle {
      < -1.063298, 0.442908, 2.368628>,
      < -1.292308, 0.436852, 2.263012>,
      < -1.292308, 0.488052, 2.263012>
    }
    triangle {
      < -1.063298, 0.442908, 2.368628>,
      < -1.292308, 0.488052, 2.263012>,
      < -1.065583, 0.471804, 2.368705>
    }
    triangle {
      < -1.292308, 0.488052, 2.263012>,
      < -1.363152, 0.489778, 2.201167>,
      < -1.387740, 0.509184, 2.216830>
    }
    triangle {
      < -1.292308, 0.488052, 2.263012>,
      < -1.387740, 0.509184, 2.216830>,
      < -1.310475, 0.506873, 2.286254>
    }
    triangle {
      < -1.363152, 0.489778, 2.201167>,
      < -1.434754, 0.493443, 2.105901>,
      < -1.462541, 0.513094, 2.114367>
    }
    triangle {
      < -1.363152, 0.489778, 2.201167>,
      < -1.462541, 0.513094, 2.114367>,
      < -1.387740, 0.509184, 2.216830>
    }
    triangle {
      < -1.434754, 0.493443, 2.105901>,
      < -1.461509, 0.496637, 2.050812>,
      < -1.492305, 0.516620, 2.051260>
    }
    triangle {
      < -1.434754, 0.493443, 2.105901>,
      < -1.492305, 0.516620, 2.051260>,
      < -1.462541, 0.513094, 2.114367>
    }
    triangle {
      < -1.457862, 0.164978, 2.201167>,
      < -1.552080, 0.108643, 2.105901>,
      < -1.552080, 0.188643, 2.105901>
    }
    triangle {
      < -1.457862, 0.164978, 2.201167>,
      < -1.552080, 0.188643, 2.105901>,
      < -1.457862, 0.244978, 2.201167>
    }
    triangle {
      < -1.552080, 0.108643, 2.105901>,
      < -1.587286, 0.083037, 2.050812>,
      < -1.587286, 0.163037, 2.050812>
    }
    triangle {
      < -1.552080, 0.108643, 2.105901>,
      < -1.587286, 0.163037, 2.050812>,
      < -1.552080, 0.188643, 2.105901>
    }
    triangle {
      < -1.587286, 0.083037, 2.050812>,
      < -1.645417, 0.030211, 1.888693>,
      < -1.645417, 0.110211, 1.888693>
    }
    triangle {
      < -1.587286, 0.083037, 2.050812>,
      < -1.645417, 0.110211, 1.888693>,
      < -1.587286, 0.163037, 2.050812>
    }
    triangle {
      < -1.645417, 0.030211, 1.888693>,
      < -1.692454, -0.001023, 1.616905>,
      < -1.692454, 0.078977, 1.616905>
    }
    triangle {
      < -1.645417, 0.030211, 1.888693>,
      < -1.692454, 0.078977, 1.616905>,
      < -1.645417, 0.110211, 1.888693>
    }
    triangle {
      < -1.692454, -0.001023, 1.616905>,
      < -1.683317, -0.000674, 1.086187>,
      < -1.683317, 0.079326, 1.086187>
    }
    triangle {
      < -1.692454, -0.001023, 1.616905>,
      < -1.683317, 0.079326, 1.086187>,
      < -1.692454, 0.078977, 1.616905>
    }
    triangle {
      < -1.683317, -0.000674, 1.086187>,
      < -1.683387, -0.000626, 0.000000>,
      < -1.683387, 0.079374, 0.000393>
    }
    triangle {
      < -1.683317, -0.000674, 1.086187>,
      < -1.683387, 0.079374, 0.000393>,
      < -1.683317, 0.079326, 1.086187>
    }
    triangle {
      < 4.270950, -0.144347, 0.000000>,
      < 4.269524, -0.145411, 0.375766>,
      < 4.268098, -0.146475, 0.751046>
    }
    triangle {
      < 4.270950, -0.144347, 0.000000>,
      < 4.268098, -0.146475, 0.751046>,
      < 4.266672, -0.147539, 1.126325>
    }
    triangle {
      < 4.270950, -0.144347, 0.000000>,
      < 4.266672, -0.147539, 1.126325>,
      < 4.266672, 0.320061, 1.126325>
    }
    triangle {
      < 4.270950, -0.144347, 0.000000>,
      < 4.266672, 0.320061, 1.126325>,
      < 4.270950, 0.323253, 0.000000>
    }
    triangle {
      < 4.266672, -0.147539, 1.126325>,
      < 4.263855, -0.183141, 1.747711>,
      < 4.263855, 0.284459, 1.747711>
    }
    triangle {
      < 4.266672, -0.147539, 1.126325>,
      < 4.263855, 0.284459, 1.747711>,
      < 4.266672, 0.320061, 1.126325>
    }
    triangle {
      < 4.263855, -0.183141, 1.747711>,
      < 4.262456, -0.217957, 2.040359>,
      < 4.262456, 0.249643, 2.040359>
    }
    triangle {
      < 4.263855, -0.183141, 1.747711>,
      < 4.262456, 0.249643, 2.040359>,
      < 4.263855, 0.284459, 1.747711>
    }
    triangle {
      < 4.262456, -0.217957, 2.040359>,
      < 4.261516, -0.242516, 2.227976>,
      < 4.261516, 0.225084, 2.227976>
    }
    triangle {
      < 4.262456, -0.217957, 2.040359>,
      < 4.261516, 0.225084, 2.227976>,
      < 4.262456, 0.249643, 2.040359>
    }
    triangle {
      < 4.261516, -0.242516, 2.227976>,
      < 4.260174, -0.300536, 2.369611>,
      < 4.260174, 0.167064, 2.369611>
    }
    triangle {
      < 4.261516, -0.242516, 2.227976>,
      < 4.260174, 0.167064, 2.369611>,
      < 4.261516, 0.225084, 2.227976>
    }
    triangle {
      < 4.260174, -0.300536, 2.369611>,
      < 3.625001, -0.305368, 2.369808>,
      < 3.625001, 0.162232, 2.369808>
    }
    triangle {
      < 4.260174, -0.300536, 2.369611>,
      < 3.625001, 0.162232, 2.369808>,
      < 4.260174, 0.167064, 2.369611>
    }
    triangle {
      < 3.625001, -0.305368, 2.369808>,
      < 3.005907, -0.320307, 2.369739>,
      < 3.005907, 0.147293, 2.369739>
    }
    triangle {
      < 3.625001, -0.305368, 2.369808>,
      < 3.005907, 0.147293, 2.369739>,
      < 3.625001, 0.162232, 2.369808>
    }
    triangle {
      < 3.005907, -0.320307, 2.369739>,
      < 2.744587, -0.350305, 2.369957>,
      < 2.744587, 0.117295, 2.369957>
    }
    triangle {
      < 3.005907, -0.320307, 2.369739>,
      < 2.744587, 0.117295, 2.369957>,
      < 3.005907, 0.147293, 2.369739>
    }
    triangle {
      < 2.744587, -0.350305, 2.369957>,
      < 2.540798, -0.395302, 2.370153>,
      < 2.540798, 0.072298, 2.370153>
    }
    triangle {
      < 2.744587, -0.350305, 2.369957>,
      < 2.540798, 0.072298, 2.370153>,
      < 2.744587, 0.117295, 2.369957>
    }
    triangle {
      < 2.540798, -0.395302, 2.370153>,
      < 2.379416, -0.460004, 2.370376>,
      < 2.379416, 0.007596, 2.370376>
    }
    triangle {
      < 2.540798, -0.395302, 2.370153>,
      < 2.379416, 0.007596, 2.370376>,
      < 2.540798, 0.072298, 2.370153>
    }
    triangle {
      < 2.379416, -0.460004, 2.370376>,
      < 1.777091, -0.375204, 2.370343>,
      < 1.777091, 0.092396, 2.370343>
    }
    triangle {
      < 2.379416, -0.460004, 2.370376>,
      < 1.777091, 0.092396, 2.370343>,
      < 2.379416, 0.007596, 2.370376>
    }
    triangle {
      < 1.777091, -0.375204, 2.370343>,
      < 0.824081, -0.310127, 2.369811>,
      < 0.824081, 0.157473, 2.369811>
    }
    triangle {
      < 1.777091, -0.375204, 2.370343>,
      < 0.824081, 0.157473, 2.369811>,
      < 1.777091, 0.092396, 2.370343>
    }
    triangle {
      < 0.824081, -0.310127, 2.369811>,
      < -0.375026, -0.265022, 2.369029>,
      < -0.375026, 0.202578, 2.369029>
    }
    triangle {
      < 0.824081, -0.310127, 2.369811>,
      < -0.375026, 0.202578, 2.369029>,
      < 0.824081, 0.157473, 2.369811>
    }
    triangle {
      < -0.375026, -0.265022, 2.369029>,
      < -1.063298, -0.235892, 2.368628>,
      < -1.063298, 0.231708, 2.368628>
    }
    triangle {
      < -0.375026, -0.265022, 2.369029>,
      < -1.063298, 0.231708, 2.368628>,
      < -0.375026, 0.202578, 2.369029>
    }
    triangle {
      < -1.364641, 0.218452, 2.263012>,
      < -1.457862, 0.164978, 2.201167>,
      < -1.457862, 0.244978, 2.201167>
    }
    triangle {
      < -1.364641, 0.218452, 2.263012>,
      < -1.457862, 0.244978, 2.201167>,
      < -1.364641, 0.298452, 2.263012>
    }
    triangle {
      < -0.375026, -1.850225, 2.369029>,
      < -1.063298, -1.850225, 2.368628>,
      < -1.063298, -0.235892, 2.368628>
    }
    triangle {
      < -0.375026, -1.850225, 2.369029>,
      < -1.063298, -0.235892, 2.368628>,
      < -0.375026, -0.265022, 2.369029>
    }
    triangle {
      < -1.063298, -0.235892, 2.368628>,
      < -1.063298, -1.850225, 2.368628>,
      < -2.008258, -1.850225, 2.367348>
    }
    triangle {
      < -1.063298, -0.235892, 2.368628>,
      < -2.008258, -1.850225, 2.367348>,
      < -2.396326, -1.850225, 2.367348>
    }
    triangle {
      < -1.063298, -0.235892, 2.368628>,
      < -2.396326, -1.850225, 2.367348>,
      < -3.123050, -1.037834, 2.367348>
    }
    triangle {
      < -2.396326, -1.850225, 2.367348>,
      < -2.378328, -1.850225, 1.086187>,
      < -3.123018, -1.032010, 1.086187>
    }
    triangle {
      < -2.396326, -1.850225, 2.367348>,
      < -3.123018, -1.032010, 1.086187>,
      < -3.123050, -1.037834, 2.367348>
    }
    triangle {
      < -2.220067, -1.315539, 0.000000>,
      < -3.123018, -0.424615, 0.000000>,
      < -3.123018, -0.448646, 0.262621>
    }
    triangle {
      < -2.220067, -1.315539, 0.000000>,
      < -3.123018, -0.448646, 0.262621>,
      < -2.220033, -1.351600, 0.262988>
    }
    triangle {
      < 4.270950, -0.144347, 0.000000>,
      < 3.792218, -1.448971, 0.000000>,
      < 3.780999, -1.476034, 0.206646>
    }
    triangle {
      < 4.270950, -0.144347, 0.000000>,
      < 3.780999, -1.476034, 0.206646>,
      < 4.269524, -0.145411, 0.375766>
    }
    triangle {
      < 3.626908, -1.850225, 1.126325>,
      < 3.626900, -1.850225, 1.747711>,
      < 4.263855, -0.183141, 1.747711>
    }
    triangle {
      < 3.626908, -1.850225, 1.126325>,
      < 4.263855, -0.183141, 1.747711>,
      < 4.266672, -0.147539, 1.126325>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 3.626896, -1.850225, 2.040359>,
      < 4.262456, -0.217957, 2.040359>
    }
    triangle {
      < 3.626900, -1.850225, 1.747711>,
      < 4.262456, -0.217957, 2.040359>,
      < 4.263855, -0.183141, 1.747711>
    }
    triangle {
      < 4.260174, -0.300536, 2.149209>,
      < 4.260174, -0.300536, 2.369611>,
      < 4.261516, -0.242516, 2.227976>
    }
    triangle {
      < 4.260174, -0.300536, 2.149209>,
      < 4.261516, -0.242516, 2.227976>,
      < 4.262456, -0.217957, 2.040359>
    }
    triangle {
      < 3.625001, -1.850225, 2.149406>,
      < 3.005907, -1.850225, 2.149338>,
      < 3.005907, -0.320307, 2.149338>
    }
    triangle {
      < 3.625001, -1.850225, 2.149406>,
      < 3.005907, -0.320307, 2.149338>,
      < 3.625001, -0.305368, 2.149406>
    }
    triangle {
      < 3.005907, -1.850225, 2.149338>,
      < 2.744587, -1.850225, 2.149555>,
      < 2.744587, -0.350305, 2.149555>
    }
    triangle {
      < 3.005907, -1.850225, 2.149338>,
      < 2.744587, -0.350305, 2.149555>,
      < 3.005907, -0.320307, 2.149338>
    }
    triangle {
      < 2.744587, -1.850225, 2.149555>,
      < 2.540798, -1.850225, 2.149752>,
      < 2.540798, -0.395302, 2.149752>
    }
    triangle {
      < 2.744587, -1.850225, 2.149555>,
      < 2.540798, -0.395302, 2.149752>,
      < 2.744587, -0.350305, 2.149555>
    }
    triangle {
      < 2.540798, -1.850225, 2.149752>,
      < 2.379416, -1.850225, 2.149975>,
      < 2.379416, -0.460004, 2.149975>
    }
    triangle {
      < 2.540798, -1.850225, 2.149752>,
      < 2.379416, -0.460004, 2.149975>,
      < 2.540798, -0.395302, 2.149752>
    }
    triangle {
      < 2.379416, -1.850225, 2.149975>,
      < 1.961091, -1.850225, 2.149947>,
      < 1.961091, -0.389282, 2.149947>
    }
    triangle {
      < 2.379416, -1.850225, 2.149975>,
      < 1.961091, -0.389282, 2.149947>,
      < 2.379416, -0.460004, 2.149975>
    }
    triangle {
      < 1.777091, -1.850225, 2.370343>,
      < 0.824081, -1.850225, 2.369811>,
      < 0.824081, -0.310127, 2.369811>
    }
    triangle {
      < 1.777091, -1.850225, 2.370343>,
      < 0.824081, -0.310127, 2.369811>,
      < 1.777091, -0.375204, 2.370343>
    }
    triangle {
      < 0.824081, -1.850225, 2.369811>,
      < -0.375026, -1.850225, 2.369029>,
      < -0.375026, -0.265022, 2.369029>
    }
    triangle {
      < 0.824081, -1.850225, 2.369811>,
      < -0.375026, -0.265022, 2.369029>,
      < 0.824081, -0.310127, 2.369811>
    }
    triangle {
      < 3.625001, -0.305368, 2.149406>,
      < 4.260174, -0.300536, 2.149209>,
      < 3.625001, -1.850225, 2.149406>
    }
    triangle {
      < -1.067868, 0.504709, 2.405055>,
      < -1.066725, 0.488256, 2.383916>,
      < -1.310475, 0.506873, 2.286254>
    }
    triangle {
      < -1.065583, 0.471804, 2.368705>,
      < -1.066725, 0.488256, 2.383916>,
      < -1.067868, 0.504709, 2.405055>
    }
    triangle {
      < -1.065583, 0.471804, 2.368705>,
      < -1.067868, 0.504709, 2.405055>,
      < -1.063298, 0.442908, 2.368628>
    }
    triangle {
      < -1.065583, 0.471804, 2.368705>,
      < -1.292308, 0.488052, 2.263012>,
      < -1.310475, 0.506873, 2.286254>
    }
    triangle {
      < -1.065583, 0.471804, 2.368705>,
      < -1.310475, 0.506873, 2.286254>,
      < -1.066725, 0.488256, 2.383916>
    }
    triangle {
      < -1.680265, 0.378946, 2.105901>,
      < -1.724702, 0.369548, 2.050812>,
      < -1.461509, 0.435837, 2.050812>
    }
    triangle {
      < -1.680265, 0.378946, 2.105901>,
      < -1.461509, 0.435837, 2.050812>,
      < -1.434754, 0.435043, 2.105901>
    }
    triangle {
      < -1.561337, 0.399623, 2.201167>,
      < -1.680265, 0.378946, 2.105901>,
      < -1.434754, 0.435043, 2.105901>
    }
    triangle {
      < -1.561337, 0.399623, 2.201167>,
      < -1.434754, 0.435043, 2.105901>,
      < -1.363152, 0.433778, 2.201167>
    }
    triangle {
      < -1.443669, 0.419250, 2.263012>,
      < -1.561337, 0.399623, 2.201167>,
      < -1.363152, 0.433778, 2.201167>
    }
    triangle {
      < -1.443669, 0.419250, 2.263012>,
      < -1.363152, 0.433778, 2.201167>,
      < -1.292308, 0.436852, 2.263012>
    }
    triangle {
      < -1.443669, 0.419250, 2.263012>,
      < -1.292308, 0.436852, 2.263012>,
      < -1.063298, 0.442908, 2.368628>
    }
    triangle {
      < -1.552080, 0.188643, 2.105901>,
      < -1.587286, 0.163037, 2.050812>,
      < -1.724702, 0.369548, 2.050812>
    }
    triangle {
      < -1.552080, 0.188643, 2.105901>,
      < -1.724702, 0.369548, 2.050812>,
      < -1.680265, 0.378946, 2.105901>
    }
    triangle {
      < -1.457862, 0.244978, 2.201167>,
      < -1.552080, 0.188643, 2.105901>,
      < -1.680265, 0.378946, 2.105901>
    }
    triangle {
      < -1.457862, 0.244978, 2.201167>,
      < -1.680265, 0.378946, 2.105901>,
      < -1.561337, 0.399623, 2.201167>
    }
    triangle {
      < -1.364641, 0.298452, 2.263012>,
      < -1.457862, 0.244978, 2.201167>,
      < -1.561337, 0.399623, 2.201167>
    }
    triangle {
      < -1.364641, 0.298452, 2.263012>,
      < -1.561337, 0.399623, 2.201167>,
      < -1.443669, 0.419250, 2.263012>
    }
    triangle {
      < -1.364641, 0.298452, 2.263012>,
      < -1.443669, 0.419250, 2.263012>,
      < -1.063298, 0.442908, 2.368628>
    }
    triangle {
      < -3.124035, -0.292996, 1.086187>,
      < -3.124035, -0.289859, 0.724256>,
      < -2.270328, -0.243791, 1.086187>
    }
    triangle {
      < -3.124098, -0.304644, 2.367348>,
      < -3.124035, -0.292996, 1.086187>,
      < -2.270328, -0.243791, 1.086187>
    }
    triangle {
      < -3.124098, -0.304644, 2.367348>,
      < -2.270328, -0.243791, 1.086187>,
      < -2.288326, -0.243897, 2.367348>
    }
    triangle {
      < -1.364641, 0.298452, 2.263012>,
      < -1.063298, 0.442908, 2.368628>,
      < -1.063298, 0.362908, 2.368628>
    }
    triangle {
      < -1.364641, 0.298452, 2.263012>,
      < -1.063298, 0.362908, 2.368628>,
      < -1.364641, 0.218452, 2.263012>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -1.692454, -0.001023, 1.616905>,
      < -1.645417, 0.030211, 1.888693>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -1.645417, 0.030211, 1.888693>,
      < -1.587286, 0.083037, 2.050812>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -1.587286, 0.083037, 2.050812>,
      < -1.552080, 0.108643, 2.105901>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -1.552080, 0.108643, 2.105901>,
      < -1.457862, 0.164978, 2.201167>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -1.457862, 0.164978, 2.201167>,
      < -1.364641, 0.218452, 2.263012>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -1.364641, 0.218452, 2.263012>,
      < -1.063298, 0.362908, 2.368628>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -2.270328, -0.243791, 1.086187>,
      < -1.683317, -0.000674, 1.086187>
    }
    triangle {
      < -2.288326, -0.243897, 2.367348>,
      < -1.683317, -0.000674, 1.086187>,
      < -1.692454, -0.001023, 1.616905>
    }
    triangle {
      < -2.270328, -0.243791, 1.086187>,
      < -2.270467, -0.243776, 0.000000>,
      < -1.683387, -0.000626, 0.000000>
    }
    triangle {
      < -2.270328, -0.243791, 1.086187>,
      < -1.683387, -0.000626, 0.000000>,
      < -1.683317, -0.000674, 1.086187>
    }
    triangle {
      < -1.849830, -1.315557, 0.000000>,
      < -2.220067, -1.315539, 0.000000>,
      < -2.220033, -1.351600, 0.262988>
    }
    triangle {
      < -1.849830, -1.315557, 0.000000>,
      < -2.220033, -1.351600, 0.262988>,
      < -1.849829, -1.351621, 0.262988>
    }
    triangle {
      < -2.378328, -1.850225, 1.086187>,
      < -2.396326, -1.850225, 2.367348>,
      < -2.008258, -1.850225, 2.367348>
    }
    triangle {
      < -2.378328, -1.850225, 1.086187>,
      < -2.008258, -1.850225, 2.367348>,
      < -2.008229, -1.850225, 1.086187>
    }
    triangle {
      < -3.124098, -0.304644, 2.367348>,
      < -1.063298, -0.235892, 2.368628>,
      < -3.123050, -1.037834, 2.367348>
    }
    triangle {
      < -3.124035, -0.292996, 1.086187>,
      < -3.124098, -0.304644, 2.367348>,
      < -3.123050, -1.037834, 2.367348>
    }
    triangle {
      < -3.124035, -0.292996, 1.086187>,
      < -3.123050, -1.037834, 2.367348>,
      < -3.123018, -1.032010, 1.086187>
    }
    triangle {
      < -3.123018, -0.424615, 0.000000>,
      < -3.124036, -0.283587, 0.000000>,
      < -3.124036, -0.285856, 0.262324>
    }
    triangle {
      < -3.123018, -0.424615, 0.000000>,
      < -3.124036, -0.285856, 0.262324>,
      < -3.123018, -0.448646, 0.262621>
    }
    triangle {
      < -1.063298, -0.235892, 2.368628>,
      < -2.288326, -0.243897, 2.367348>,
      < -1.063298, 0.231708, 2.368628>
    }
    triangle {
      < 3.780999, -1.476034, 0.206646>,
      < 3.792218, -1.448971, 0.000000>,
      < 2.378290, -1.448971, 0.000000>
    }
    triangle {
      < 3.780999, -1.476034, 0.206646>,
      < 2.378290, -1.448971, 0.000000>,
      < 2.378281, -1.476034, 0.204981>
    }
    triangle {
      < 3.626908, -1.850225, 1.126325>,
      < 4.266672, -0.147539, 1.126325>,
      < 4.268098, -0.146475, 0.751046>
    }
    triangle {
      < 3.626908, -1.850225, 1.126325>,
      < 4.268098, -0.146475, 0.751046>,
      < 3.626912, -1.850225, 0.561449>
    }
    triangle {
      < 3.626908, -1.850225, 1.126325>,
      < 3.626912, -1.850225, 0.561449>,
      < 2.378170, -1.850121, 0.558112>
    }
    triangle {
      < 3.626908, -1.850225, 1.126325>,
      < 2.378170, -1.850121, 0.558112>,
      < 2.378150, -1.850225, 1.119635>
    }
    triangle {
      < -2.378328, -1.850225, 1.086187>,
      < -2.008229, -1.850225, 1.086187>,
      < -2.008230, -1.850061, 0.724256>
    }
    triangle {
      < -2.378328, -1.850225, 1.086187>,
      < -2.008230, -1.850061, 0.724256>,
      < -2.378375, -1.849855, 0.724256>
    }
    triangle {
      < -3.123018, -1.032010, 1.086187>,
      < -2.378328, -1.850225, 1.086187>,
      < -2.378375, -1.849855, 0.724256>
    }
    triangle {
      < -3.123018, -1.032010, 1.086187>,
      < -2.378375, -1.849855, 0.724256>,
      < -3.123018, -1.028232, 0.724256>
    }
    triangle {
      < -3.124035, -0.292996, 1.086187>,
      < -3.123018, -1.032010, 1.086187>,
      < -3.123018, -1.028232, 0.724256>
    }
    triangle {
      < -3.124035, -0.292996, 1.086187>,
      < -3.123018, -1.028232, 0.724256>,
      < -3.124035, -0.289859, 0.724256>
    }
    triangle {
      < 3.626912, -1.850225, 0.561449>,
      < 4.268098, -0.146475, 0.751046>,
      < 4.269524, -0.145411, 0.375766>
    }
    triangle {
      < 3.626912, -1.850225, 0.561449>,
      < 4.269524, -0.145411, 0.375766>,
      < 3.751823, -1.549721, 0.336739>
    }
    triangle {
      < 3.626912, -1.850225, 0.561449>,
      < 3.751823, -1.549721, 0.336739>,
      < 2.378256, -1.549722, 0.334937>
    }
    triangle {
      < 3.626912, -1.850225, 0.561449>,
      < 2.378256, -1.549722, 0.334937>,
      < 2.378170, -1.850121, 0.558112>
    }
    triangle {
      < -2.378375, -1.849855, 0.724256>,
      < -2.008230, -1.850061, 0.724256>,
      < -1.873709, -1.449869, 0.420646>
    }
    triangle {
      < -2.378375, -1.849855, 0.724256>,
      < -1.873709, -1.449869, 0.420646>,
      < -2.252662, -1.449829, 0.424804>
    }
    triangle {
      < -3.123018, -1.028232, 0.724256>,
      < -2.378375, -1.849855, 0.724256>,
      < -2.252662, -1.449829, 0.424804>
    }
    triangle {
      < -3.123018, -1.028232, 0.724256>,
      < -2.252662, -1.449829, 0.424804>,
      < -3.123018, -0.529557, 0.441929>
    }
    triangle {
      < -3.124035, -0.289859, 0.724256>,
      < -3.123018, -1.028232, 0.724256>,
      < -3.123018, -0.529557, 0.441929>
    }
    triangle {
      < -3.124035, -0.289859, 0.724256>,
      < -3.123018, -0.529557, 0.441929>,
      < -3.124036, -0.287589, 0.462324>
    }
    triangle {
      < -2.008229, -1.850225, 1.086187>,
      < -2.008258, -1.850225, 2.367348>,
      < -1.063298, -1.850225, 2.368628>
    }
    triangle {
      < -2.008229, -1.850225, 1.086187>,
      < -1.063298, -1.850225, 2.368628>,
      < -1.060381, -1.850225, 1.099566>
    }
    triangle {
      < -2.008230, -1.850061, 0.724256>,
      < -2.008229, -1.850225, 1.086187>,
      < -1.060381, -1.850225, 1.099566>
    }
    triangle {
      < -2.008230, -1.850061, 0.724256>,
      < -1.060381, -1.850225, 1.099566>,
      < -1.060381, -1.850061, 0.733186>
    }
    triangle {
      < -1.873709, -1.449869, 0.420646>,
      < -2.008230, -1.850061, 0.724256>,
      < -1.060381, -1.850061, 0.733186>
    }
    triangle {
      < -1.873709, -1.449869, 0.420646>,
      < -1.060381, -1.850061, 0.733186>,
      < -1.060257, -1.449853, 0.440745>
    }
    triangle {
      < -1.849830, -1.315557, 0.000000>,
      < -1.849829, -1.351621, 0.262988>,
      < -1.060221, -1.351637, 0.267437>
    }
    triangle {
      < -1.849830, -1.315557, 0.000000>,
      < -1.060221, -1.351637, 0.267437>,
      < -1.060209, -1.315570, 0.000000>
    }
    triangle {
      < -1.060381, -1.850225, 1.099566>,
      < -1.063298, -1.850225, 2.368628>,
      < -0.375026, -1.850225, 2.369029>
    }
    triangle {
      < -1.060381, -1.850225, 1.099566>,
      < -0.375026, -1.850225, 2.369029>,
      < -0.366958, -1.850225, 1.112945>
    }
    triangle {
      < -1.060381, -1.850061, 0.733186>,
      < -1.060381, -1.850225, 1.099566>,
      < -0.366958, -1.850225, 1.112945>
    }
    triangle {
      < -1.060381, -1.850061, 0.733186>,
      < -0.366958, -1.850225, 1.112945>,
      < -0.366958, -1.850087, 0.742116>
    }
    triangle {
      < -1.060257, -1.449853, 0.440745>,
      < -1.060381, -1.850061, 0.733186>,
      < -0.366958, -1.850087, 0.742116>
    }
    triangle {
      < -1.060257, -1.449853, 0.440745>,
      < -0.366958, -1.850087, 0.742116>,
      < -0.366654, -1.449842, 0.445578>
    }
    triangle {
      < -1.060209, -1.315570, 0.000000>,
      < -1.060221, -1.351637, 0.267437>,
      < -0.366567, -1.351662, 0.271888>
    }
    triangle {
      < -1.060209, -1.315570, 0.000000>,
      < -0.366567, -1.351662, 0.271888>,
      < -0.366539, -1.315604, -0.000455>
    }
    triangle {
      < 3.751823, -1.549721, 0.336739>,
      < 3.780999, -1.476034, 0.206646>,
      < 2.378281, -1.476034, 0.204981>
    }
    triangle {
      < 3.751823, -1.549721, 0.336739>,
      < 2.378281, -1.476034, 0.204981>,
      < 2.378256, -1.549722, 0.334937>
    }
    triangle {
      < -1.060257, -1.449853, 0.440745>,
      < -0.366654, -1.449842, 0.445578>,
      < -0.366567, -1.351662, 0.271888>
    }
    triangle {
      < -1.060257, -1.449853, 0.440745>,
      < -0.366567, -1.351662, 0.271888>,
      < -1.060221, -1.351637, 0.267437>
    }
    triangle {
      < -1.873709, -1.449869, 0.420646>,
      < -1.060257, -1.449853, 0.440745>,
      < -1.060221, -1.351637, 0.267437>
    }
    triangle {
      < -1.873709, -1.449869, 0.420646>,
      < -1.060221, -1.351637, 0.267437>,
      < -1.849829, -1.351621, 0.262988>
    }
    triangle {
      < -2.252662, -1.449829, 0.424804>,
      < -1.873709, -1.449869, 0.420646>,
      < -1.849829, -1.351621, 0.262988>
    }
    triangle {
      < -2.252662, -1.449829, 0.424804>,
      < -1.849829, -1.351621, 0.262988>,
      < -2.220033, -1.351600, 0.262988>
    }
    triangle {
      < -3.123018, -0.529557, 0.441929>,
      < -2.252662, -1.449829, 0.424804>,
      < -2.220033, -1.351600, 0.262988>
    }
    triangle {
      < -3.123018, -0.529557, 0.441929>,
      < -2.220033, -1.351600, 0.262988>,
      < -3.123018, -0.448646, 0.262621>
    }
    triangle {
      < -3.124036, -0.287589, 0.462324>,
      < -3.123018, -0.529557, 0.441929>,
      < -3.123018, -0.448646, 0.262621>
    }
    triangle {
      < -3.124036, -0.287589, 0.462324>,
      < -3.123018, -0.448646, 0.262621>,
      < -3.124036, -0.285856, 0.262324>
    }
    triangle {
      < 3.780999, -1.476034, 0.206646>,
      < 3.751823, -1.549721, 0.336739>,
      < 4.269524, -0.145411, 0.375766>
    }
    triangle {
      < 1.776923, -1.850225, 1.116290>,
      < 1.961091, -1.850225, 2.149947>,
      < 2.379416, -1.850225, 2.149975>
    }
    triangle {
      < 1.776923, -1.850225, 1.116290>,
      < 2.379416, -1.850225, 2.149975>,
      < 2.378150, -1.850225, 1.119635>
    }
    triangle {
      < 1.776923, -1.850121, 0.556443>,
      < 1.776923, -1.850225, 1.116290>,
      < 2.378150, -1.850225, 1.119635>
    }
    triangle {
      < 1.776923, -1.850121, 0.556443>,
      < 2.378150, -1.850225, 1.119635>,
      < 2.378170, -1.850121, 0.558112>
    }
    triangle {
      < 1.776923, -1.549722, 0.334036>,
      < 1.776923, -1.850121, 0.556443>,
      < 2.378170, -1.850121, 0.558112>
    }
    triangle {
      < 1.776923, -1.549722, 0.334036>,
      < 2.378170, -1.850121, 0.558112>,
      < 2.378256, -1.549722, 0.334937>
    }
    triangle {
      < 1.776923, -1.476034, 0.204148>,
      < 1.776923, -1.549722, 0.334036>,
      < 2.378256, -1.549722, 0.334937>
    }
    triangle {
      < 1.776923, -1.476034, 0.204148>,
      < 2.378256, -1.549722, 0.334937>,
      < 2.378281, -1.476034, 0.204981>
    }
    triangle {
      < 1.776923, -1.448971, -0.000445>,
      < 1.776923, -1.476034, 0.204148>,
      < 2.378281, -1.476034, 0.204981>
    }
    triangle {
      < 1.776923, -1.448971, -0.000445>,
      < 2.378281, -1.476034, 0.204981>,
      < 2.378290, -1.448971, 0.000000>
    }
    triangle {
      < 4.260174, -0.300536, 2.149209>,
      < 3.625001, -0.305368, 2.149406>,
      < 3.625001, -0.305368, 2.369808>
    }
    triangle {
      < 4.260174, -0.300536, 2.149209>,
      < 3.625001, -0.305368, 2.369808>,
      < 4.260174, -0.300536, 2.369611>
    }
    triangle {
      < 3.625001, -0.305368, 2.149406>,
      < 3.005907, -0.320307, 2.149338>,
      < 3.005907, -0.320307, 2.369739>
    }
    triangle {
      < 3.625001, -0.305368, 2.149406>,
      < 3.005907, -0.320307, 2.369739>,
      < 3.625001, -0.305368, 2.369808>
    }
    triangle {
      < 3.005907, -0.320307, 2.149338>,
      < 2.744587, -0.350305, 2.149555>,
      < 2.744587, -0.350305, 2.369957>
    }
    triangle {
      < 3.005907, -0.320307, 2.149338>,
      < 2.744587, -0.350305, 2.369957>,
      < 3.005907, -0.320307, 2.369739>
    }
    triangle {
      < 2.744587, -0.350305, 2.149555>,
      < 2.540798, -0.395302, 2.149752>,
      < 2.540798, -0.395302, 2.370153>
    }
    triangle {
      < 2.744587, -0.350305, 2.149555>,
      < 2.540798, -0.395302, 2.370153>,
      < 2.744587, -0.350305, 2.369957>
    }
    triangle {
      < 2.540798, -0.395302, 2.149752>,
      < 2.379416, -0.460004, 2.149975>,
      < 2.379416, -0.460004, 2.370376>
    }
    triangle {
      < 2.540798, -0.395302, 2.149752>,
      < 2.379416, -0.460004, 2.370376>,
      < 2.540798, -0.395302, 2.370153>
    }
    triangle {
      < 2.379416, -0.460004, 2.149975>,
      < 1.961091, -0.389282, 2.149947>,
      < 1.856495, -0.382243, 2.200684>
    }
    triangle {
      < 2.379416, -0.460004, 2.149975>,
      < 1.856495, -0.382243, 2.200684>,
      < 1.789091, -0.375204, 2.295402>
    }
    triangle {
      < 2.379416, -0.460004, 2.149975>,
      < 1.789091, -0.375204, 2.295402>,
      < 1.777091, -0.375204, 2.370343>
    }
    triangle {
      < 2.379416, -0.460004, 2.149975>,
      < 1.777091, -0.375204, 2.370343>,
      < 2.379416, -0.460004, 2.370376>
    }
    triangle {
      < 1.789091, -0.375204, 2.295402>,
      < 1.789091, -1.850225, 2.295402>,
      < 1.777091, -1.850225, 2.370343>
    }
    triangle {
      < 1.789091, -0.375204, 2.295402>,
      < 1.777091, -1.850225, 2.370343>,
      < 1.777091, -0.375204, 2.370343>
    }
    triangle {
      < 3.626896, -1.850225, 2.040359>,
      < 3.625001, -1.850225, 2.149406>,
      < 4.260174, -0.300536, 2.149209>
    }
    triangle {
      < 3.626896, -1.850225, 2.040359>,
      < 4.260174, -0.300536, 2.149209>,
      < 4.262456, -0.217957, 2.040359>
    }
    triangle {
      < 1.961091, -0.389282, 2.149947>,
      < 1.961091, -1.850225, 2.149947>,
      < 1.856495, -1.850225, 2.200684>
    }
    triangle {
      < 1.961091, -0.389282, 2.149947>,
      < 1.856495, -1.850225, 2.200684>,
      < 1.856495, -0.382243, 2.200684>
    }
    triangle {
      < 1.789091, -1.850225, 2.295402>,
      < 1.789091, -0.375204, 2.295402>,
      < 1.856495, -0.382243, 2.200684>
    }
    triangle {
      < 1.789091, -1.850225, 2.295402>,
      < 1.856495, -0.382243, 2.200684>,
      < 1.856495, -1.850225, 2.200684>
    }
    triangle {
      < 0.823881, -1.850225, 1.114618>,
      < 0.824081, -1.850225, 2.369811>,
      < 1.777091, -1.850225, 2.370343>
    }
    triangle {
      < 0.823881, -1.850225, 1.114618>,
      < 1.777091, -1.850225, 2.370343>,
      < 1.776923, -1.850225, 1.116290>
    }
    triangle {
      < 0.823881, -1.850087, 0.743232>,
      < 0.823881, -1.850225, 1.114618>,
      < 1.776923, -1.850225, 1.116290>
    }
    triangle {
      < 0.823881, -1.850087, 0.743232>,
      < 1.776923, -1.850225, 1.116290>,
      < 1.776923, -1.850121, 0.556443>
    }
    triangle {
      < 0.823881, -1.449842, 0.446181>,
      < 0.823881, -1.850087, 0.743232>,
      < 1.776923, -1.850121, 0.556443>
    }
    triangle {
      < 0.823881, -1.449842, 0.446181>,
      < 1.776923, -1.850121, 0.556443>,
      < 1.776923, -1.549722, 0.334036>
    }
    triangle {
      < 0.823881, -1.351662, 0.272445>,
      < 0.823881, -1.449842, 0.446181>,
      < 1.776923, -1.549722, 0.334036>
    }
    triangle {
      < 0.823881, -1.351662, 0.272445>,
      < 1.776923, -1.549722, 0.334036>,
      < 1.776923, -1.476034, 0.204148>
    }
    triangle {
      < 0.823881, -1.315604, -0.000459>,
      < 0.823881, -1.351662, 0.272445>,
      < 1.776923, -1.476034, 0.204148>
    }
    triangle {
      < 0.823881, -1.315604, -0.000459>,
      < 1.776923, -1.476034, 0.204148>,
      < 1.776923, -1.448971, -0.000445>
    }
    triangle {
      < 1.856495, -1.850225, 2.200684>,
      < 1.961091, -1.850225, 2.149947>,
      < 1.776923, -1.850225, 1.116290>
    }
    triangle {
      < 1.777091, -1.850225, 2.370343>,
      < 1.789091, -1.850225, 2.295402>,
      < 1.776923, -1.850225, 1.116290>
    }
    triangle {
      < 1.789091, -1.850225, 2.295402>,
      < 1.856495, -1.850225, 2.200684>,
      < 1.776923, -1.850225, 1.116290>
    }
    triangle {
      < -0.366958, -1.850225, 1.112945>,
      < -0.375026, -1.850225, 2.369029>,
      < 0.824081, -1.850225, 2.369811>
    }
    triangle {
      < -0.366958, -1.850225, 1.112945>,
      < 0.824081, -1.850225, 2.369811>,
      < 0.823881, -1.850225, 1.114618>
    }
    triangle {
      < -0.366958, -1.850087, 0.742116>,
      < -0.366958, -1.850225, 1.112945>,
      < 0.823881, -1.850225, 1.114618>
    }
    triangle {
      < -0.366958, -1.850087, 0.742116>,
      < 0.823881, -1.850225, 1.114618>,
      < 0.823881, -1.850087, 0.743232>
    }
    triangle {
      < -0.366654, -1.449842, 0.445578>,
      < -0.366958, -1.850087, 0.742116>,
      < 0.823881, -1.850087, 0.743232>
    }
    triangle {
      < -0.366654, -1.449842, 0.445578>,
      < 0.823881, -1.850087, 0.743232>,
      < 0.823881, -1.449842, 0.446181>
    }
    triangle {
      < -0.366567, -1.351662, 0.271888>,
      < -0.366654, -1.449842, 0.445578>,
      < 0.823881, -1.449842, 0.446181>
    }
    triangle {
      < -0.366567, -1.351662, 0.271888>,
      < 0.823881, -1.449842, 0.446181>,
      < 0.823881, -1.351662, 0.272445>
    }
    triangle {
      < -0.366539, -1.315604, -0.000455>,
      < -0.366567, -1.351662, 0.271888>,
      < 0.823881, -1.351662, 0.272445>
    }
    triangle {
      < -0.366539, -1.315604, -0.000455>,
      < 0.823881, -1.351662, 0.272445>,
      < 0.823881, -1.315604, -0.000459>
    }
    texture {interior}
  }
  // rlight
  union {
    triangle {
      < 8.941601, -1.091616, 2.842811>,
      < 8.941601, -1.073912, 2.797338>,
      < 8.941601, -1.056968, 2.840635>
    }
    triangle {
      < 8.941601, -0.938202, 2.480663>,
      < 8.941601, -0.888966, 2.506449>,
      < 8.941601, -1.056706, 2.568872>
    }
    triangle {
      < 8.941601, -1.052008, 2.644964>,
      < 8.941601, -0.820418, 2.718179>,
      < 8.941601, -0.849236, 2.752583>
    }
    triangle {
      < 8.941601, -1.052008, 2.644964>,
      < 8.941601, -0.849236, 2.752583>,
      < 8.941601, -1.056706, 2.721055>
    }
    triangle {
      < 8.941601, -0.820418, 2.571748>,
      < 8.941601, -1.052008, 2.644964>,
      < 8.941601, -1.056706, 2.568872>
    }
    triangle {
      < 8.941601, -0.820418, 2.571748>,
      < 8.941601, -1.056706, 2.568872>,
      < 8.941601, -0.849236, 2.537343>
    }
    triangle {
      < 8.941601, -0.888966, 2.783479>,
      < 8.941601, -0.938202, 2.809265>,
      < 8.941601, -1.056706, 2.721055>
    }
    triangle {
      < 8.941601, -1.091616, 2.447118>,
      < 8.941601, -1.056968, 2.449295>,
      < 8.941601, -1.073912, 2.492589>
    }
    triangle {
      < 8.941601, -1.056968, 2.449295>,
      < 8.941601, -0.994980, 2.461295>,
      < 8.941601, -1.073912, 2.492589>
    }
    triangle {
      < 8.941601, -0.994980, 2.828633>,
      < 8.941601, -1.073912, 2.797338>,
      < 8.941601, -1.056706, 2.721055>
    }
    triangle {
      < 8.941601, -0.994980, 2.828633>,
      < 8.941601, -1.056706, 2.721055>,
      < 8.941601, -0.938202, 2.809265>
    }
    triangle {
      < 8.941601, -0.797472, 2.644964>,
      < 8.941601, -0.803172, 2.681896>,
      < 8.941601, -1.052008, 2.644964>
    }
    triangle {
      < 8.941601, -0.797472, 2.644964>,
      < 8.941601, -1.052008, 2.644964>,
      < 8.941601, -0.803172, 2.608031>
    }
    triangle {
      < 8.941601, -0.938202, 2.480663>,
      < 8.941601, -1.056706, 2.568872>,
      < 8.941601, -1.073912, 2.492589>
    }
    triangle {
      < 8.941601, -0.938202, 2.480663>,
      < 8.941601, -1.073912, 2.492589>,
      < 8.941601, -0.994980, 2.461295>
    }
    triangle {
      < 8.941601, -1.056968, 2.840635>,
      < 8.941601, -1.073912, 2.797338>,
      < 8.941601, -0.994980, 2.828633>
    }
    triangle {
      < 8.941601, -0.803172, 2.681896>,
      < 8.941601, -0.820418, 2.718179>,
      < 8.941601, -1.052008, 2.644964>
    }
    triangle {
      < 8.941601, -0.820418, 2.571748>,
      < 8.941601, -0.803172, 2.608031>,
      < 8.941601, -1.052008, 2.644964>
    }
    triangle {
      < 8.941601, -0.888966, 2.506449>,
      < 8.941601, -0.849236, 2.537343>,
      < 8.941601, -1.056706, 2.568872>
    }
    triangle {
      < 8.941601, -0.888966, 2.783479>,
      < 8.941601, -1.056706, 2.721055>,
      < 8.941601, -0.849236, 2.752583>
    }
    texture {rlight}
  }
  // wlight
  union {
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.437610, 2.547268>,
      < 9.270059, -1.415792, 2.509480>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.415792, 2.509480>,
      < 9.270059, -1.389757, 2.483034>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.389757, 2.483034>,
      < 9.270059, -1.363081, 2.468503>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.363081, 2.468503>,
      < 9.270059, -1.341180, 2.465543>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.341180, 2.465543>,
      < 9.270059, -1.341180, 2.824098>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.341180, 2.824098>,
      < 9.270059, -1.363081, 2.821137>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.363081, 2.821137>,
      < 9.270059, -1.389757, 2.806606>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.389757, 2.806606>,
      < 9.270059, -1.415792, 2.780160>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.415792, 2.780160>,
      < 9.270059, -1.437610, 2.742372>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.437610, 2.742372>,
      < 9.270059, -1.452059, 2.695912>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.452059, 2.695912>,
      < 9.270059, -1.457104, 2.644820>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.294850, 2.491002>,
      < 9.270059, -1.273519, 2.519037>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.273519, 2.519037>,
      < 9.270059, -1.256751, 2.555614>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.256751, 2.555614>,
      < 9.270059, -1.246052, 2.598547>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.246052, 2.598547>,
      < 9.270059, -1.242382, 2.644820>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.242382, 2.644820>,
      < 9.270059, -1.246052, 2.691093>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.246052, 2.691093>,
      < 9.270059, -1.256751, 2.734026>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.256751, 2.734026>,
      < 9.270059, -1.273519, 2.770604>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.273519, 2.770604>,
      < 9.270059, -1.294850, 2.798639>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.294850, 2.798639>,
      < 9.270059, -1.319076, 2.817147>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.319076, 2.817147>,
      < 9.270059, -1.341180, 2.824098>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.341180, 2.824098>,
      < 9.270059, -1.341180, 2.465543>
    }
    texture {wlight}
  }
  // orn
  union {
    triangle {
      < 8.394976, -0.070614, 0.845775>,
      < 8.413591, -0.060930, 0.791835>,
      < 8.471934, -0.293105, 0.000000>
    }
    triangle {
      < 8.394976, -0.070614, 0.845775>,
      < 8.471934, -0.293105, 0.000000>,
      < 8.475469, -0.408127, 0.000000>
    }
    triangle {
      < 8.394976, -0.070614, 0.845775>,
      < 8.475469, -0.408127, 0.000000>,
      < 8.405490, -0.095794, 0.815684>
    }
    texture {orn}
  }
  // bottom
  union {
    triangle {
      < 4.418622, -1.236594, 1.747609>,
      < 4.203426, -1.317132, 1.747609>,
      < 4.036805, -1.444195, 1.747609>
    }
    triangle {
      < 4.418622, -1.236594, 1.747609>,
      < 4.036805, -1.444195, 1.747609>,
      < 6.224681, -1.470219, 1.747609>
    }
    triangle {
      < 4.418622, -1.236594, 1.747609>,
      < 6.224681, -1.470219, 1.747609>,
      < 5.645978, -1.296764, 1.747609>
    }
    texture {bottom}
  }
  // sidep
  union {
    triangle {
      < 8.735338, -0.613710, 2.826938>,
      < 8.879555, -0.281976, 2.769261>,
      < 7.443739, -0.255730, 2.890142>
    }
    triangle {
      < 8.735338, -0.613710, 2.826938>,
      < 7.443739, -0.255730, 2.890142>,
      < 7.266874, -0.750716, 2.954813>
    }
    triangle {
      < 8.735338, -0.613710, 2.826938>,
      < 7.266874, -0.750716, 2.954813>,
      < 8.552464, -0.915826, 2.875156>
    }
    texture {sidep}
  }
  // trunk
  union {
    triangle {
      < 8.522250, -1.225294, 1.772281>,
      < 8.560331, -1.222266, 1.029780>,
      < 8.449835, -0.425835, 1.079941>
    }
    triangle {
      < 8.522250, -1.225294, 1.772281>,
      < 8.449835, -0.425835, 1.079941>,
      < 8.457153, -0.449640, 1.764580>
    }
    triangle {
      < 8.489470, -0.969292, 2.170007>,
      < 8.486027, -1.114300, 2.149738>,
      < 8.509673, -1.194734, 2.067450>
    }
    triangle {
      < 8.489470, -0.969292, 2.170007>,
      < 8.509673, -1.194734, 2.067450>,
      < 8.512800, -1.225042, 1.923583>
    }
    triangle {
      < 8.489470, -0.969292, 2.170007>,
      < 8.512800, -1.225042, 1.923583>,
      < 8.522250, -1.225294, 1.772281>
    }
    triangle {
      < 8.489470, -0.969292, 2.170007>,
      < 8.522250, -1.225294, 1.772281>,
      < 8.457153, -0.449640, 1.764580>
    }
    triangle {
      < 8.489470, -0.969292, 2.170007>,
      < 8.457153, -0.449640, 1.764580>,
      < 8.440199, -0.463641, 2.193263>
    }
    texture {trunk}
  }
  // orn
  union {
    triangle {
      < 8.531489, -0.343789, 0.000000>,
      < 8.471934, -0.293105, 0.000000>,
      < 8.413591, -0.060930, 0.791835>
    }
    triangle {
      < 8.531489, -0.343789, 0.000000>,
      < 8.413591, -0.060930, 0.791835>,
      < 8.414921, -0.085937, 0.796610>
    }
    triangle {
      < 8.475469, -0.408127, 0.000000>,
      < 8.531489, -0.343789, 0.000000>,
      < 8.414921, -0.085937, 0.796610>
    }
    triangle {
      < 8.475469, -0.408127, 0.000000>,
      < 8.414921, -0.085937, 0.796610>,
      < 8.405490, -0.095794, 0.815684>
    }
    texture {orn}
  }
  // trunk
  union {
    triangle {
      < 8.400454, -0.047262, 0.000000>,
      < 8.395494, -0.065184, 1.078200>,
      < 8.449835, -0.425835, 1.079941>
    }
    triangle {
      < 8.400454, -0.047262, 0.000000>,
      < 8.449835, -0.425835, 1.079941>,
      < 8.475469, -0.408127, 0.000000>
    }
    texture {trunk}
  }
  // trim
  union {
    triangle {
      < 8.882301, -0.275022, 2.801047>,
      < 8.931488, -0.183258, 2.805120>,
      < 7.456694, -0.149653, 2.924987>
    }
    triangle {
      < 8.882301, -0.275022, 2.801047>,
      < 7.456694, -0.149653, 2.924987>,
      < 7.444382, -0.248379, 2.921873>
    }
    triangle {
      < 2.983860, -0.373048, 3.077279>,
      < 2.939125, -0.269663, 3.032358>,
      < 2.774747, -0.371004, 3.065446>
    }
    triangle {
      < 8.500901, -1.043360, 2.937258>,
      < 8.547125, -0.924360, 2.908364>,
      < 7.263474, -0.758225, 2.986269>
    }
    triangle {
      < 8.500901, -1.043360, 2.937258>,
      < 7.263474, -0.758225, 2.986269>,
      < 7.234224, -0.860815, 2.999818>
    }
    triangle {
      < 4.552039, -0.563719, 3.071908>,
      < 5.799877, -0.686073, 3.050399>,
      < 5.821069, -0.601820, 3.044645>
    }
    triangle {
      < 4.552039, -0.563719, 3.071908>,
      < 5.821069, -0.601820, 3.044645>,
      < 4.562160, -0.491394, 3.060796>
    }
    triangle {
      < 5.821069, -0.601820, 3.044645>,
      < 5.799877, -0.686073, 3.050399>,
      < 7.234224, -0.860815, 2.999818>
    }
    triangle {
      < 5.821069, -0.601820, 3.044645>,
      < 7.234224, -0.860815, 2.999818>,
      < 7.263474, -0.758225, 2.986269>
    }
    texture {trim}
  }
  // sidep
  union {
    triangle {
      < 2.998860, -0.375346, 3.050740>,
      < 3.549376, -0.410394, 3.043454>,
      < 3.192947, -0.280363, 3.029328>
    }
    texture {sidep}
  }
  // trim
  union {
    triangle {
      < 4.127273, -0.109232, 3.028296>,
      < 4.151097, -0.194196, 3.026751>,
      < 5.895473, -0.213704, 2.984118>
    }
    triangle {
      < 4.127273, -0.109232, 3.028296>,
      < 5.895473, -0.213704, 2.984118>,
      < 5.920316, -0.123030, 2.979121>
    }
    texture {trim}
  }
  // trunk
  union {
    triangle {
      < 8.100101, 0.249571, 1.777554>,
      < 8.073201, 0.205660, 2.193727>,
      < 8.182999, 0.129380, 2.192896>
    }
    triangle {
      < 8.100101, 0.249571, 1.777554>,
      < 8.182999, 0.129380, 2.192896>,
      < 8.230323, 0.163051, 1.774980>
    }
    triangle {
      < 8.124635, 0.293009, 1.092600>,
      < 8.100101, 0.249571, 1.777554>,
      < 8.230323, 0.163051, 1.774980>
    }
    triangle {
      < 8.124635, 0.293009, 1.092600>,
      < 8.230323, 0.163051, 1.774980>,
      < 8.243834, 0.211613, 1.088533>
    }
    triangle {
      < 8.230323, 0.163051, 1.774980>,
      < 8.182999, 0.129380, 2.192896>,
      < 8.301852, 0.017987, 2.188884>
    }
    triangle {
      < 8.230323, 0.163051, 1.774980>,
      < 8.301852, 0.017987, 2.188884>,
      < 8.317673, 0.062025, 1.771227>
    }
    triangle {
      < 8.243834, 0.211613, 1.088533>,
      < 8.230323, 0.163051, 1.774980>,
      < 8.317673, 0.062025, 1.771227>
    }
    triangle {
      < 8.243834, 0.211613, 1.088533>,
      < 8.317673, 0.062025, 1.771227>,
      < 8.327960, 0.100635, 1.091151>
    }
    triangle {
      < 8.245603, 0.234554, 0.000000>,
      < 8.243834, 0.211613, 1.088533>,
      < 8.327960, 0.100635, 1.091151>
    }
    triangle {
      < 8.245603, 0.234554, 0.000000>,
      < 8.327960, 0.100635, 1.091151>,
      < 8.347019, 0.123354, 0.000000>
    }
    triangle {
      < 8.135803, 0.310833, 0.000000>,
      < 8.009962, 0.367298, 0.000000>,
      < 7.976715, 0.344752, 1.106459>
    }
    triangle {
      < 8.135803, 0.310833, 0.000000>,
      < 7.976715, 0.344752, 1.106459>,
      < 8.124635, 0.293009, 1.092600>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 6.110524, 0.468056, 1.995495>,
      < 6.144370, 0.447848, 2.094849>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 6.144370, 0.447848, 2.094849>,
      < 6.219293, 0.427158, 2.190680>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 6.219293, 0.427158, 2.190680>,
      < 6.328420, 0.420911, 2.200800>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 6.328420, 0.420911, 2.200800>,
      < 7.113728, 0.361826, 2.211385>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 7.113728, 0.361826, 2.211385>,
      < 7.145475, 0.415678, 1.793569>
    }
    triangle {
      < 6.193891, 0.530497, 1.142380>,
      < 6.121673, 0.477584, 1.811959>,
      < 7.145475, 0.415678, 1.793569>
    }
    triangle {
      < 6.193891, 0.530497, 1.142380>,
      < 7.145475, 0.415678, 1.793569>,
      < 7.185932, 0.468931, 1.108458>
    }
    triangle {
      < 6.233547, 0.557975, 0.000000>,
      < 6.193891, 0.530497, 1.142380>,
      < 7.185932, 0.468931, 1.108458>
    }
    triangle {
      < 6.233547, 0.557975, 0.000000>,
      < 7.185932, 0.468931, 1.108458>,
      < 7.220746, 0.486467, 0.000000>
    }
    texture {trunk}
  }
  // glass
  union {
    triangle {
      < -1.501422, 1.776069, 1.058051>,
      < -1.531823, 1.796562, 0.000000>,
      < -2.471125, 0.711497, 0.000000>
    }
    triangle {
      < -1.501422, 1.776069, 1.058051>,
      < -2.471125, 0.711497, 0.000000>,
      < -2.421983, 0.687416, 1.109558>
    }
    triangle {
      < -1.448195, 1.740140, 1.666425>,
      < -1.501422, 1.776069, 1.058051>,
      < -2.421983, 0.687416, 1.109558>
    }
    triangle {
      < -1.448195, 1.740140, 1.666425>,
      < -2.421983, 0.687416, 1.109558>,
      < -2.306105, 0.664578, 1.673231>
    }
    triangle {
      < -1.340144, 1.643680, 2.095907>,
      < -1.393737, 1.694287, 1.944256>,
      < -2.173151, 0.642992, 1.948107>
    }
    triangle {
      < -1.340144, 1.643680, 2.095907>,
      < -2.173151, 0.642992, 1.948107>,
      < -2.055634, 0.627002, 2.125403>
    }
    triangle {
      < -1.285982, 1.434658, 2.282372>,
      < -1.317752, 1.596914, 2.165866>,
      < -1.972645, 0.624423, 2.205898>
    }
    triangle {
      < -1.285982, 1.434658, 2.282372>,
      < -1.972645, 0.624423, 2.205898>,
      < -1.792238, 0.600730, 2.337865>
    }
    triangle {
      < -1.393737, 1.694287, 1.944256>,
      < -1.448195, 1.740140, 1.666425>,
      < -2.306105, 0.664578, 1.673231>
    }
    triangle {
      < -1.393737, 1.694287, 1.944256>,
      < -2.306105, 0.664578, 1.673231>,
      < -2.173151, 0.642992, 1.948107>
    }
    triangle {
      < -1.317752, 1.596914, 2.165866>,
      < -1.340144, 1.643680, 2.095907>,
      < -2.055634, 0.627002, 2.125403>
    }
    triangle {
      < -1.317752, 1.596914, 2.165866>,
      < -2.055634, 0.627002, 2.125403>,
      < -1.972645, 0.624423, 2.205898>
    }
    triangle {
      < -1.260878, 1.233804, 2.353841>,
      < -1.285982, 1.434658, 2.282372>,
      < -1.792238, 0.600730, 2.337865>
    }
    triangle {
      < -1.260878, 1.233804, 2.353841>,
      < -1.792238, 0.600730, 2.337865>,
      < -1.614355, 0.602091, 2.428892>
    }
    triangle {
      < -1.402362, 0.617344, 2.457819>,
      < -1.322724, 0.656193, 2.462118>,
      < -1.285062, 0.735826, 2.451662>
    }
    triangle {
      < -1.402362, 0.617344, 2.457819>,
      < -1.285062, 0.735826, 2.451662>,
      < -1.268391, 0.835856, 2.433827>
    }
    triangle {
      < -1.402362, 0.617344, 2.457819>,
      < -1.268391, 0.835856, 2.433827>,
      < -1.260878, 1.233804, 2.353841>
    }
    triangle {
      < -1.402362, 0.617344, 2.457819>,
      < -1.260878, 1.233804, 2.353841>,
      < -1.614355, 0.602091, 2.428892>
    }
    triangle {
      < -1.402362, 0.617344, 2.457819>,
      < -1.614355, 0.602091, 2.428892>,
      < -1.502984, 0.598885, 2.446143>
    }
    triangle {
      < -2.366984, 0.665475, 1.099416>,
      < -2.419312, 0.712380, 0.000000>,
      < -1.494550, 1.785838, 0.000000>
    }
    triangle {
      < -2.366984, 0.665475, 1.099416>,
      < -1.494550, 1.785838, 0.000000>,
      < -1.467670, 1.767479, 1.054614>
    }
    triangle {
      < -2.258348, 0.618570, 1.650021>,
      < -2.366984, 0.665475, 1.099416>,
      < -1.467670, 1.767479, 1.054614>
    }
    triangle {
      < -2.258348, 0.618570, 1.650021>,
      < -1.467670, 1.767479, 1.054614>,
      < -1.416259, 1.732549, 1.655801>
    }
    triangle {
      < -2.129741, 0.602935, 1.940372>,
      < -2.258348, 0.618570, 1.650021>,
      < -1.416259, 1.732549, 1.655801>
    }
    triangle {
      < -2.129741, 0.602935, 1.940372>,
      < -1.416259, 1.732549, 1.655801>,
      < -1.362498, 1.685040, 1.934339>
    }
    triangle {
      < -2.015777, 0.587300, 2.120876>,
      < -2.129741, 0.602935, 1.940372>,
      < -1.362498, 1.685040, 1.934339>
    }
    triangle {
      < -2.015777, 0.587300, 2.120876>,
      < -1.362498, 1.685040, 1.934339>,
      < -1.326746, 1.641951, 2.066452>
    }
    triangle {
      < -1.939041, 0.582088, 2.193431>,
      < -2.015777, 0.587300, 2.120876>,
      < -1.326746, 1.641951, 2.066452>
    }
    triangle {
      < -1.939041, 0.582088, 2.193431>,
      < -1.326746, 1.641951, 2.066452>,
      < -1.308735, 1.605871, 2.125383>
    }
    triangle {
      < -1.765442, 0.576877, 2.299501>,
      < -1.939041, 0.582088, 2.193431>,
      < -1.308735, 1.605871, 2.125383>
    }
    triangle {
      < -1.765442, 0.576877, 2.299501>,
      < -1.308735, 1.605871, 2.125383>,
      < -1.294507, 1.551115, 2.172036>
    }
    triangle {
      < -1.593866, 0.574271, 2.356469>,
      < -1.765442, 0.576877, 2.299501>,
      < -1.294507, 1.551115, 2.172036>
    }
    triangle {
      < -1.593866, 0.574271, 2.356469>,
      < -1.294507, 1.551115, 2.172036>,
      < -1.286024, 1.491526, 2.253235>
    }
    triangle {
      < -1.535205, 0.573965, 2.367879>,
      < -1.593866, 0.574271, 2.356469>,
      < -1.286024, 1.491526, 2.253235>
    }
    triangle {
      < -1.535205, 0.573965, 2.367879>,
      < -1.286024, 1.491526, 2.253235>,
      < -1.260465, 1.206042, 2.308860>
    }
    triangle {
      < -1.535205, 0.573965, 2.367879>,
      < -1.260465, 1.206042, 2.308860>,
      < -1.264699, 0.815249, 2.377412>
    }
    triangle {
      < -1.535205, 0.573965, 2.367879>,
      < -1.264699, 0.815249, 2.377412>,
      < -1.305959, 0.682560, 2.392979>
    }
    triangle {
      < -1.535205, 0.573965, 2.367879>,
      < -1.305959, 0.682560, 2.392979>,
      < -1.396127, 0.602132, 2.389802>
    }
    texture {glass}
  }
  // trim
  union {
    triangle {
      < 7.444382, -0.248379, 2.921873>,
      < 7.456694, -0.149653, 2.924987>,
      < 5.920316, -0.123030, 2.979121>
    }
    triangle {
      < 7.444382, -0.248379, 2.921873>,
      < 5.920316, -0.123030, 2.979121>,
      < 5.895473, -0.213704, 2.984118>
    }
    triangle {
      < 3.303162, -0.154032, 3.023582>,
      < 3.361498, -0.229362, 3.053108>,
      < 3.557825, -0.209364, 3.039376>
    }
    triangle {
      < 3.303162, -0.154032, 3.023582>,
      < 3.557825, -0.209364, 3.039376>,
      < 3.514180, -0.133783, 3.023055>
    }
    triangle {
      < 3.137519, -0.193255, 3.024220>,
      < 3.189895, -0.274036, 3.058901>,
      < 3.361498, -0.229362, 3.053108>
    }
    triangle {
      < 3.137519, -0.193255, 3.024220>,
      < 3.361498, -0.229362, 3.053108>,
      < 3.303162, -0.154032, 3.023582>
    }
    triangle {
      < 2.774747, -0.371004, 3.065446>,
      < 1.906129, -0.329685, 3.054738>,
      < 1.895532, -0.386009, 3.064815>
    }
    triangle {
      < 2.774747, -0.371004, 3.065446>,
      < 1.895532, -0.386009, 3.064815>,
      < 2.748360, -0.429951, 3.073404>
    }
    triangle {
      < 3.189895, -0.274036, 3.058901>,
      < 3.137519, -0.193255, 3.024220>,
      < 2.939125, -0.269663, 3.032358>
    }
    triangle {
      < 3.189895, -0.274036, 3.058901>,
      < 2.939125, -0.269663, 3.032358>,
      < 2.983860, -0.373048, 3.077279>
    }
    triangle {
      < 3.514180, -0.133783, 3.023055>,
      < 3.557825, -0.209364, 3.039376>,
      < 4.151097, -0.194196, 3.026751>
    }
    triangle {
      < 3.514180, -0.133783, 3.023055>,
      < 4.151097, -0.194196, 3.026751>,
      < 4.127273, -0.109232, 3.028296>
    }
    triangle {
      < 3.547677, -0.414829, 3.074230>,
      < 3.533338, -0.474769, 3.081829>,
      < 4.552039, -0.563719, 3.071908>
    }
    triangle {
      < 3.547677, -0.414829, 3.074230>,
      < 4.552039, -0.563719, 3.071908>,
      < 4.562160, -0.491394, 3.060796>
    }
    triangle {
      < 2.983860, -0.373048, 3.077279>,
      < 2.774747, -0.371004, 3.065446>,
      < 2.748360, -0.429951, 3.073404>
    }
    triangle {
      < 2.983860, -0.373048, 3.077279>,
      < 2.748360, -0.429951, 3.073404>,
      < 2.984796, -0.441652, 3.083088>
    }
    triangle {
      < 3.547677, -0.414829, 3.074230>,
      < 2.983860, -0.373048, 3.077279>,
      < 2.984796, -0.441652, 3.083088>
    }
    triangle {
      < 3.547677, -0.414829, 3.074230>,
      < 2.984796, -0.441652, 3.083088>,
      < 3.533338, -0.474769, 3.081829>
    }
    triangle {
      < 1.906129, -0.329685, 3.054738>,
      < 2.774747, -0.371004, 3.065446>,
      < 2.764446, -0.365325, 3.033453>
    }
    triangle {
      < 1.906129, -0.329685, 3.054738>,
      < 2.764446, -0.365325, 3.033453>,
      < 1.907401, -0.325250, 3.023679>
    }
    triangle {
      < 2.774747, -0.371004, 3.065446>,
      < 2.939125, -0.269663, 3.032358>,
      < 2.937687, -0.265340, 2.998240>
    }
    triangle {
      < 2.774747, -0.371004, 3.065446>,
      < 2.937687, -0.265340, 2.998240>,
      < 2.764446, -0.365325, 3.033453>
    }
    triangle {
      < 2.939125, -0.269663, 3.032358>,
      < 3.137519, -0.193255, 3.024220>,
      < 3.134589, -0.190357, 2.990687>
    }
    triangle {
      < 2.939125, -0.269663, 3.032358>,
      < 3.134589, -0.190357, 2.990687>,
      < 2.937687, -0.265340, 2.998240>
    }
    triangle {
      < 3.137519, -0.193255, 3.024220>,
      < 3.303162, -0.154032, 3.023582>,
      < 3.299893, -0.151445, 2.990343>
    }
    triangle {
      < 3.137519, -0.193255, 3.024220>,
      < 3.299893, -0.151445, 2.990343>,
      < 3.134589, -0.190357, 2.990687>
    }
    triangle {
      < 3.303162, -0.154032, 3.023582>,
      < 3.514180, -0.133783, 3.023055>,
      < 3.511749, -0.131182, 2.990570>
    }
    triangle {
      < 3.303162, -0.154032, 3.023582>,
      < 3.511749, -0.131182, 2.990570>,
      < 3.299893, -0.151445, 2.990343>
    }
    triangle {
      < 3.514180, -0.133783, 3.023055>,
      < 4.127273, -0.109232, 3.028296>,
      < 4.125974, -0.106096, 2.996831>
    }
    triangle {
      < 3.514180, -0.133783, 3.023055>,
      < 4.125974, -0.106096, 2.996831>,
      < 3.511749, -0.131182, 2.990570>
    }
    triangle {
      < 4.127273, -0.109232, 3.028296>,
      < 5.920316, -0.123030, 2.979121>,
      < 5.921797, -0.119568, 2.947283>
    }
    triangle {
      < 4.127273, -0.109232, 3.028296>,
      < 5.921797, -0.119568, 2.947283>,
      < 4.125974, -0.106096, 2.996831>
    }
    triangle {
      < 5.920316, -0.123030, 2.979121>,
      < 7.456694, -0.149653, 2.924987>,
      < 7.457458, -0.145731, 2.893612>
    }
    triangle {
      < 5.920316, -0.123030, 2.979121>,
      < 7.457458, -0.145731, 2.893612>,
      < 5.921797, -0.119568, 2.947283>
    }
    triangle {
      < 7.456694, -0.149653, 2.924987>,
      < 8.931488, -0.183258, 2.805120>,
      < 8.934355, -0.179734, 2.773799>
    }
    triangle {
      < 7.456694, -0.149653, 2.924987>,
      < 8.934355, -0.179734, 2.773799>,
      < 7.457458, -0.145731, 2.893612>
    }
    triangle {
      < 8.931488, -0.183258, 2.805120>,
      < 8.882301, -0.275022, 2.801047>,
      < 8.879555, -0.281976, 2.769261>
    }
    triangle {
      < 8.931488, -0.183258, 2.805120>,
      < 8.879555, -0.281976, 2.769261>,
      < 8.934355, -0.179734, 2.773799>
    }
    triangle {
      < 8.882301, -0.275022, 2.801047>,
      < 7.444382, -0.248379, 2.921873>,
      < 7.443739, -0.255730, 2.890142>
    }
    triangle {
      < 8.882301, -0.275022, 2.801047>,
      < 7.443739, -0.255730, 2.890142>,
      < 8.879555, -0.281976, 2.769261>
    }
    triangle {
      < 7.444382, -0.248379, 2.921873>,
      < 5.895473, -0.213704, 2.984118>,
      < 5.894114, -0.220596, 2.952850>
    }
    triangle {
      < 7.444382, -0.248379, 2.921873>,
      < 5.894114, -0.220596, 2.952850>,
      < 7.443739, -0.255730, 2.890142>
    }
    triangle {
      < 5.895473, -0.213704, 2.984118>,
      < 4.151097, -0.194196, 3.026751>,
      < 4.152519, -0.200762, 2.995109>
    }
    triangle {
      < 5.895473, -0.213704, 2.984118>,
      < 4.152519, -0.200762, 2.995109>,
      < 5.894114, -0.220596, 2.952850>
    }
    triangle {
      < 4.151097, -0.194196, 3.026751>,
      < 3.557825, -0.209364, 3.039376>,
      < 3.560378, -0.215394, 3.008755>
    }
    triangle {
      < 4.151097, -0.194196, 3.026751>,
      < 3.560378, -0.215394, 3.008755>,
      < 4.152519, -0.200762, 2.995109>
    }
    triangle {
      < 3.557825, -0.209364, 3.039376>,
      < 3.361498, -0.229362, 3.053108>,
      < 3.364890, -0.235378, 3.023240>
    }
    triangle {
      < 3.557825, -0.209364, 3.039376>,
      < 3.364890, -0.235378, 3.023240>,
      < 3.560378, -0.215394, 3.008755>
    }
    triangle {
      < 3.361498, -0.229362, 3.053108>,
      < 3.189895, -0.274036, 3.058901>,
      < 3.192947, -0.280363, 3.029328>
    }
    triangle {
      < 3.361498, -0.229362, 3.053108>,
      < 3.192947, -0.280363, 3.029328>,
      < 3.364890, -0.235378, 3.023240>
    }
    triangle {
      < 3.189895, -0.274036, 3.058901>,
      < 2.983860, -0.373048, 3.077279>,
      < 2.998860, -0.375346, 3.050740>
    }
    triangle {
      < 3.189895, -0.274036, 3.058901>,
      < 2.998860, -0.375346, 3.050740>,
      < 3.192947, -0.280363, 3.029328>
    }
    triangle {
      < 2.983860, -0.373048, 3.077279>,
      < 3.547677, -0.414829, 3.074230>,
      < 3.549376, -0.410394, 3.043454>
    }
    triangle {
      < 2.983860, -0.373048, 3.077279>,
      < 3.549376, -0.410394, 3.043454>,
      < 2.998860, -0.375346, 3.050740>
    }
    triangle {
      < 3.547677, -0.414829, 3.074230>,
      < 4.562160, -0.491394, 3.060796>,
      < 4.563378, -0.485959, 3.029619>
    }
    triangle {
      < 3.547677, -0.414829, 3.074230>,
      < 4.563378, -0.485959, 3.029619>,
      < 3.549376, -0.410394, 3.043454>
    }
    triangle {
      < 4.562160, -0.491394, 3.060796>,
      < 5.821069, -0.601820, 3.044645>,
      < 5.823551, -0.595592, 3.014080>
    }
    triangle {
      < 4.562160, -0.491394, 3.060796>,
      < 5.823551, -0.595592, 3.014080>,
      < 4.563378, -0.485959, 3.029619>
    }
    triangle {
      < 5.821069, -0.601820, 3.044645>,
      < 7.263474, -0.758225, 2.986269>,
      < 7.266874, -0.750716, 2.954813>
    }
    triangle {
      < 5.821069, -0.601820, 3.044645>,
      < 7.266874, -0.750716, 2.954813>,
      < 5.823551, -0.595592, 3.014080>
    }
    triangle {
      < 7.263474, -0.758225, 2.986269>,
      < 8.547125, -0.924360, 2.908364>,
      < 8.552464, -0.915826, 2.875156>
    }
    triangle {
      < 7.263474, -0.758225, 2.986269>,
      < 8.552464, -0.915826, 2.875156>,
      < 7.266874, -0.750716, 2.954813>
    }
    triangle {
      < 8.547125, -0.924360, 2.908364>,
      < 8.500901, -1.043360, 2.937258>,
      < 8.454678, -1.103855, 2.937351>
    }
    triangle {
      < 8.547125, -0.924360, 2.908364>,
      < 8.454678, -1.103855, 2.937351>,
      < 8.449459, -1.115818, 2.907453>
    }
    triangle {
      < 8.547125, -0.924360, 2.908364>,
      < 8.449459, -1.115818, 2.907453>,
      < 8.552464, -0.915826, 2.875156>
    }
    triangle {
      < 8.454678, -1.103855, 2.937351>,
      < 7.204973, -0.919772, 2.984567>,
      < 7.201694, -0.930711, 2.952916>
    }
    triangle {
      < 8.454678, -1.103855, 2.937351>,
      < 7.201694, -0.930711, 2.952916>,
      < 8.449459, -1.115818, 2.907453>
    }
    triangle {
      < 7.204973, -0.919772, 2.984567>,
      < 5.778685, -0.740930, 3.027352>,
      < 5.776326, -0.750587, 2.994811>
    }
    triangle {
      < 7.204973, -0.919772, 2.984567>,
      < 5.776326, -0.750587, 2.994811>,
      < 7.201694, -0.930711, 2.952916>
    }
    triangle {
      < 5.778685, -0.740930, 3.027352>,
      < 4.541917, -0.616616, 3.054219>,
      < 4.540823, -0.625480, 3.022290>
    }
    triangle {
      < 5.778685, -0.740930, 3.027352>,
      < 4.540823, -0.625480, 3.022290>,
      < 5.776326, -0.750587, 2.994811>
    }
    triangle {
      < 4.541917, -0.616616, 3.054219>,
      < 3.518999, -0.522527, 3.060627>,
      < 3.517423, -0.530391, 3.028297>
    }
    triangle {
      < 4.541917, -0.616616, 3.054219>,
      < 3.517423, -0.530391, 3.028297>,
      < 4.540823, -0.625480, 3.022290>
    }
    triangle {
      < 3.518999, -0.522527, 3.060627>,
      < 2.972229, -0.493705, 3.056476>,
      < 2.970855, -0.501905, 3.023529>
    }
    triangle {
      < 3.518999, -0.522527, 3.060627>,
      < 2.970855, -0.501905, 3.023529>,
      < 3.517423, -0.530391, 3.028297>
    }
    triangle {
      < 2.972229, -0.493705, 3.056476>,
      < 2.733978, -0.481400, 3.053616>,
      < 2.732397, -0.489476, 3.021448>
    }
    triangle {
      < 2.972229, -0.493705, 3.056476>,
      < 2.732397, -0.489476, 3.021448>,
      < 2.970855, -0.501905, 3.023529>
    }
    triangle {
      < 2.733978, -0.481400, 3.053616>,
      < 1.884935, -0.437384, 3.046091>,
      < 1.883786, -0.445248, 3.014044>
    }
    triangle {
      < 2.733978, -0.481400, 3.053616>,
      < 1.883786, -0.445248, 3.014044>,
      < 2.732397, -0.489476, 3.021448>
    }
    triangle {
      < 7.204973, -0.919772, 2.984567>,
      < 8.454678, -1.103855, 2.937351>,
      < 8.500901, -1.043360, 2.937258>
    }
    triangle {
      < 7.204973, -0.919772, 2.984567>,
      < 8.500901, -1.043360, 2.937258>,
      < 7.234224, -0.860815, 2.999818>
    }
    triangle {
      < 5.778685, -0.740930, 3.027352>,
      < 7.204973, -0.919772, 2.984567>,
      < 7.234224, -0.860815, 2.999818>
    }
    triangle {
      < 5.778685, -0.740930, 3.027352>,
      < 7.234224, -0.860815, 2.999818>,
      < 5.799877, -0.686073, 3.050399>
    }
    triangle {
      < 4.541917, -0.616616, 3.054219>,
      < 5.778685, -0.740930, 3.027352>,
      < 5.799877, -0.686073, 3.050399>
    }
    triangle {
      < 4.541917, -0.616616, 3.054219>,
      < 5.799877, -0.686073, 3.050399>,
      < 4.552039, -0.563719, 3.071908>
    }
    triangle {
      < 3.518999, -0.522527, 3.060627>,
      < 4.541917, -0.616616, 3.054219>,
      < 4.552039, -0.563719, 3.071908>
    }
    triangle {
      < 3.518999, -0.522527, 3.060627>,
      < 4.552039, -0.563719, 3.071908>,
      < 3.533338, -0.474769, 3.081829>
    }
    triangle {
      < 2.972229, -0.493705, 3.056476>,
      < 3.518999, -0.522527, 3.060627>,
      < 3.533338, -0.474769, 3.081829>
    }
    triangle {
      < 2.972229, -0.493705, 3.056476>,
      < 3.533338, -0.474769, 3.081829>,
      < 2.984796, -0.441652, 3.083088>
    }
    triangle {
      < 2.733978, -0.481400, 3.053616>,
      < 2.972229, -0.493705, 3.056476>,
      < 2.984796, -0.441652, 3.083088>
    }
    triangle {
      < 2.733978, -0.481400, 3.053616>,
      < 2.984796, -0.441652, 3.083088>,
      < 2.748360, -0.429951, 3.073404>
    }
    triangle {
      < 1.884935, -0.437384, 3.046091>,
      < 2.733978, -0.481400, 3.053616>,
      < 2.748360, -0.429951, 3.073404>
    }
    triangle {
      < 1.884935, -0.437384, 3.046091>,
      < 2.748360, -0.429951, 3.073404>,
      < 1.895532, -0.386009, 3.064815>
    }
    texture {trim}
  }
  // sidep
  union {
    triangle {
      < 7.266874, -0.750716, 2.954813>,
      < 7.443739, -0.255730, 2.890142>,
      < 5.894114, -0.220596, 2.952850>
    }
    triangle {
      < 7.266874, -0.750716, 2.954813>,
      < 5.894114, -0.220596, 2.952850>,
      < 5.823551, -0.595592, 3.014080>
    }
    triangle {
      < 3.560378, -0.215394, 3.008755>,
      < 3.364890, -0.235378, 3.023240>,
      < 3.549376, -0.410394, 3.043454>
    }
    triangle {
      < 4.563378, -0.485959, 3.029619>,
      < 4.152519, -0.200762, 2.995109>,
      < 3.560378, -0.215394, 3.008755>
    }
    triangle {
      < 4.563378, -0.485959, 3.029619>,
      < 3.560378, -0.215394, 3.008755>,
      < 3.549376, -0.410394, 3.043454>
    }
    triangle {
      < 3.364890, -0.235378, 3.023240>,
      < 3.192947, -0.280363, 3.029328>,
      < 3.549376, -0.410394, 3.043454>
    }
    triangle {
      < 5.823551, -0.595592, 3.014080>,
      < 5.894114, -0.220596, 2.952850>,
      < 4.152519, -0.200762, 2.995109>
    }
    triangle {
      < 5.823551, -0.595592, 3.014080>,
      < 4.152519, -0.200762, 2.995109>,
      < 4.563378, -0.485959, 3.029619>
    }
    texture {sidep}
  }
  // trim
  union {
    triangle {
      < 8.449459, -1.115818, 2.862253>,
      < 8.552464, -0.915826, 2.875156>,
      < 8.449459, -1.115818, 2.907453>
    }
    texture {trim}
  }
  // bottom
  union {
    triangle {
      < 8.539258, -1.508811, 2.321690>,
      < 7.979931, -1.865773, 2.699738>,
      < 8.513547, -1.508811, 2.261814>
    }
    triangle {
      < 8.539258, -1.508811, 2.321690>,
      < 8.640915, -1.508811, 2.394224>,
      < 7.979931, -1.865773, 2.699738>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 8.597543, -1.508811, 0.000000>,
      < 8.560331, -1.508811, 1.029780>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 8.560331, -1.508811, 1.029780>,
      < 8.522250, -1.508811, 1.772281>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 8.522250, -1.508811, 1.772281>,
      < 8.512800, -1.508811, 1.923583>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 8.512800, -1.508811, 1.923583>,
      < 7.979931, -1.865773, 2.699738>
    }
    triangle {
      < 8.512800, -1.508811, 1.923583>,
      < 8.509673, -1.508811, 2.067450>,
      < 7.979931, -1.865773, 2.699738>
    }
    triangle {
      < 8.509673, -1.508811, 2.067450>,
      < 8.513547, -1.508811, 2.261814>,
      < 7.979931, -1.865773, 2.699738>
    }
    texture {bottom}
  }
  // trunk
  union {
    triangle {
      < 8.243834, 0.211613, 1.088533>,
      < 8.245603, 0.234554, 0.000000>,
      < 8.135803, 0.310833, 0.000000>
    }
    triangle {
      < 8.243834, 0.211613, 1.088533>,
      < 8.135803, 0.310833, 0.000000>,
      < 8.124635, 0.293009, 1.092600>
    }
    triangle {
      < 7.976715, 0.344752, 1.106459>,
      < 7.958450, 0.306219, 1.778701>,
      < 8.100101, 0.249571, 1.777554>
    }
    triangle {
      < 7.976715, 0.344752, 1.106459>,
      < 8.100101, 0.249571, 1.777554>,
      < 8.124635, 0.293009, 1.092600>
    }
    triangle {
      < 7.185932, 0.468931, 1.108458>,
      < 7.145475, 0.415678, 1.793569>,
      < 7.678421, 0.360949, 1.786135>
    }
    triangle {
      < 7.185932, 0.468931, 1.108458>,
      < 7.678421, 0.360949, 1.786135>,
      < 7.697620, 0.412992, 1.107215>
    }
    triangle {
      < 7.145475, 0.415678, 1.793569>,
      < 7.113728, 0.361826, 2.211385>,
      < 7.642765, 0.310666, 2.198912>
    }
    triangle {
      < 7.145475, 0.415678, 1.793569>,
      < 7.642765, 0.310666, 2.198912>,
      < 7.678421, 0.360949, 1.786135>
    }
    triangle {
      < 8.560331, -1.222266, 1.029780>,
      < 8.597543, -1.223972, 0.000000>,
      < 8.475469, -0.408127, 0.000000>
    }
    triangle {
      < 8.560331, -1.222266, 1.029780>,
      < 8.475469, -0.408127, 0.000000>,
      < 8.449835, -0.425835, 1.079941>
    }
    triangle {
      < 8.347019, 0.123354, 0.000000>,
      < 8.327960, 0.100635, 1.091151>,
      < 8.395494, -0.065184, 1.078200>
    }
    triangle {
      < 8.347019, 0.123354, 0.000000>,
      < 8.395494, -0.065184, 1.078200>,
      < 8.400454, -0.047262, 0.000000>
    }
    triangle {
      < 8.317673, 0.062025, 1.771227>,
      < 8.301852, 0.017987, 2.188884>,
      < 8.366402, -0.137784, 2.182268>
    }
    triangle {
      < 8.317673, 0.062025, 1.771227>,
      < 8.366402, -0.137784, 2.182268>,
      < 8.391681, -0.093862, 1.761364>
    }
    triangle {
      < 8.395494, -0.065184, 1.078200>,
      < 8.391681, -0.093862, 1.761364>,
      < 8.457153, -0.449640, 1.764580>
    }
    triangle {
      < 8.395494, -0.065184, 1.078200>,
      < 8.457153, -0.449640, 1.764580>,
      < 8.449835, -0.425835, 1.079941>
    }
    triangle {
      < 8.327960, 0.100635, 1.091151>,
      < 8.317673, 0.062025, 1.771227>,
      < 8.391681, -0.093862, 1.761364>
    }
    triangle {
      < 8.327960, 0.100635, 1.091151>,
      < 8.391681, -0.093862, 1.761364>,
      < 8.395494, -0.065184, 1.078200>
    }
    triangle {
      < 7.958450, 0.306219, 1.778701>,
      < 7.932977, 0.257270, 2.183802>,
      < 8.073201, 0.205660, 2.193727>
    }
    triangle {
      < 7.958450, 0.306219, 1.778701>,
      < 8.073201, 0.205660, 2.193727>,
      < 8.100101, 0.249571, 1.777554>
    }
    triangle {
      < 7.220746, 0.486467, 0.000000>,
      < 7.185932, 0.468931, 1.108458>,
      < 7.697620, 0.412992, 1.107215>
    }
    triangle {
      < 7.220746, 0.486467, 0.000000>,
      < 7.697620, 0.412992, 1.107215>,
      < 7.726421, 0.429283, 0.000000>
    }
    triangle {
      < 8.391681, -0.093862, 1.761364>,
      < 8.366402, -0.137784, 2.182268>,
      < 8.440199, -0.463641, 2.193263>
    }
    triangle {
      < 8.391681, -0.093862, 1.761364>,
      < 8.440199, -0.463641, 2.193263>,
      < 8.457153, -0.449640, 1.764580>
    }
    triangle {
      < 7.976715, 0.344752, 1.106459>,
      < 8.009962, 0.367298, 0.000000>,
      < 7.726421, 0.429283, 0.000000>
    }
    triangle {
      < 7.976715, 0.344752, 1.106459>,
      < 7.726421, 0.429283, 0.000000>,
      < 7.697620, 0.412992, 1.107215>
    }
    triangle {
      < 7.958450, 0.306219, 1.778701>,
      < 7.976715, 0.344752, 1.106459>,
      < 7.697620, 0.412992, 1.107215>
    }
    triangle {
      < 7.958450, 0.306219, 1.778701>,
      < 7.697620, 0.412992, 1.107215>,
      < 7.678421, 0.360949, 1.786135>
    }
    triangle {
      < 7.932977, 0.257270, 2.183802>,
      < 7.958450, 0.306219, 1.778701>,
      < 7.678421, 0.360949, 1.786135>
    }
    triangle {
      < 7.932977, 0.257270, 2.183802>,
      < 7.678421, 0.360949, 1.786135>,
      < 7.642765, 0.310666, 2.198912>
    }
    texture {trunk}
  }
  // bottom
  union {
    triangle {
      < 6.912721, -1.695685, 1.747609>,
      < 7.210523, -1.845708, 1.747609>,
      < 7.210523, -1.845708, 2.831152>
    }
    triangle {
      < 6.912721, -1.695685, 1.747609>,
      < 7.210523, -1.845708, 2.831152>,
      < 6.912721, -1.695685, 2.927237>
    }
    triangle {
      < 3.715029, -2.025404, 1.747609>,
      < 3.789022, -1.973501, 1.747609>,
      < 3.789022, -1.973501, 2.874413>
    }
    triangle {
      < 3.715029, -2.025404, 1.747609>,
      < 3.789022, -1.973501, 2.874413>,
      < 3.715029, -2.025404, 2.847356>
    }
    triangle {
      < 3.789022, -1.973501, 1.747609>,
      < 3.827017, -1.921838, 1.747609>,
      < 3.827017, -1.921838, 2.901567>
    }
    triangle {
      < 3.789022, -1.973501, 1.747609>,
      < 3.827017, -1.921838, 2.901567>,
      < 3.789022, -1.973501, 2.874413>
    }
    triangle {
      < 3.827017, -1.921838, 1.747609>,
      < 3.829013, -1.870416, 1.747609>,
      < 3.829013, -1.870416, 2.928818>
    }
    triangle {
      < 3.827017, -1.921838, 1.747609>,
      < 3.829013, -1.870416, 2.928818>,
      < 3.827017, -1.921838, 2.901567>
    }
    triangle {
      < 3.829013, -1.870416, 1.747609>,
      < 3.931926, -1.576616, 1.747609>,
      < 3.931926, -1.576616, 3.023407>
    }
    triangle {
      < 3.829013, -1.870416, 1.747609>,
      < 3.931926, -1.576616, 3.023407>,
      < 3.829013, -1.870416, 2.928818>
    }
    triangle {
      < 3.931926, -1.576616, 1.747609>,
      < 4.036805, -1.444195, 1.747609>,
      < 4.036805, -1.444195, 3.053520>
    }
    triangle {
      < 3.931926, -1.576616, 1.747609>,
      < 4.036805, -1.444195, 3.053520>,
      < 3.931926, -1.576616, 3.023407>
    }
    triangle {
      < 4.036805, -1.444195, 1.747609>,
      < 4.203426, -1.317132, 1.747609>,
      < 4.203426, -1.317132, 3.072573>
    }
    triangle {
      < 4.036805, -1.444195, 1.747609>,
      < 4.203426, -1.317132, 3.072573>,
      < 4.036805, -1.444195, 3.053520>
    }
    triangle {
      < 4.203426, -1.317132, 1.747609>,
      < 4.418622, -1.236594, 1.747609>,
      < 4.418622, -1.236594, 3.089916>
    }
    triangle {
      < 4.203426, -1.317132, 1.747609>,
      < 4.418622, -1.236594, 3.089916>,
      < 4.203426, -1.317132, 3.072573>
    }
    triangle {
      < 4.418622, -1.236594, 1.747609>,
      < 4.704625, -1.197789, 1.747609>,
      < 4.704625, -1.197789, 3.087335>
    }
    triangle {
      < 4.418622, -1.236594, 1.747609>,
      < 4.704625, -1.197789, 3.087335>,
      < 4.418622, -1.236594, 3.089916>
    }
    triangle {
      < 4.704625, -1.197789, 1.747609>,
      < 5.075943, -1.202748, 1.747609>,
      < 5.075943, -1.202748, 3.086273>
    }
    triangle {
      < 4.704625, -1.197789, 1.747609>,
      < 5.075943, -1.202748, 3.086273>,
      < 4.704625, -1.197789, 3.087335>
    }
    triangle {
      < 5.075943, -1.202748, 1.747609>,
      < 5.645978, -1.296764, 1.747609>,
      < 5.645978, -1.296764, 3.066880>
    }
    triangle {
      < 5.075943, -1.202748, 1.747609>,
      < 5.645978, -1.296764, 3.066880>,
      < 5.075943, -1.202748, 3.086273>
    }
    triangle {
      < 5.645978, -1.296764, 1.747609>,
      < 6.224681, -1.470219, 1.747609>,
      < 6.224681, -1.470219, 3.043646>
    }
    triangle {
      < 5.645978, -1.296764, 1.747609>,
      < 6.224681, -1.470219, 3.043646>,
      < 5.645978, -1.296764, 3.066880>
    }
    triangle {
      < 6.224681, -1.470219, 1.747609>,
      < 6.912721, -1.695685, 1.747609>,
      < 6.912721, -1.695685, 2.927237>
    }
    triangle {
      < 6.224681, -1.470219, 1.747609>,
      < 6.912721, -1.695685, 2.927237>,
      < 6.224681, -1.470219, 3.043646>
    }
    triangle {
      < 7.210523, -1.845708, 0.000000>,
      < 7.408657, -1.865725, 0.000000>,
      < 7.210523, -1.845708, 1.747609>
    }
    triangle {
      < 7.210523, -1.845708, 0.000000>,
      < 7.210523, -1.845708, 1.747609>,
      < 3.715029, -2.025404, 1.747609>
    }
    triangle {
      < 7.210523, -1.845708, 0.000000>,
      < 3.715029, -2.025404, 1.747609>,
      < 3.715029, -2.025404, 0.000000>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 7.979931, -1.865773, 2.699738>,
      < 7.979931, -1.865773, 2.744938>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 7.979931, -1.865773, 2.744938>,
      < 7.408657, -1.865725, 2.811972>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 7.408657, -1.865725, 2.811972>,
      < 7.210523, -1.845708, 2.831152>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 7.210523, -1.845708, 2.831152>,
      < 7.210523, -1.845708, 1.747609>
    }
    triangle {
      < 7.979931, -1.865773, 0.000000>,
      < 7.210523, -1.845708, 1.747609>,
      < 7.408657, -1.865725, 0.000000>
    }
    triangle {
      < 3.715029, -2.025404, 1.747609>,
      < 7.210523, -1.845708, 1.747609>,
      < 3.789022, -1.973501, 1.747609>
    }
    triangle {
      < 3.827017, -1.921838, 1.747609>,
      < 3.789022, -1.973501, 1.747609>,
      < 7.210523, -1.845708, 1.747609>
    }
    triangle {
      < 6.912721, -1.695685, 1.747609>,
      < 6.224681, -1.470219, 1.747609>,
      < 4.036805, -1.444195, 1.747609>
    }
    triangle {
      < 6.912721, -1.695685, 1.747609>,
      < 4.036805, -1.444195, 1.747609>,
      < 3.931926, -1.576616, 1.747609>
    }
    triangle {
      < 6.912721, -1.695685, 1.747609>,
      < 3.931926, -1.576616, 1.747609>,
      < 3.829013, -1.870416, 1.747609>
    }
    triangle {
      < 6.912721, -1.695685, 1.747609>,
      < 3.829013, -1.870416, 1.747609>,
      < 3.827017, -1.921838, 1.747609>
    }
    triangle {
      < 6.912721, -1.695685, 1.747609>,
      < 3.827017, -1.921838, 1.747609>,
      < 7.210523, -1.845708, 1.747609>
    }
    triangle {
      < 5.075943, -1.202748, 1.747609>,
      < 4.704625, -1.197789, 1.747609>,
      < 4.418622, -1.236594, 1.747609>
    }
    triangle {
      < 5.075943, -1.202748, 1.747609>,
      < 4.418622, -1.236594, 1.747609>,
      < 5.645978, -1.296764, 1.747609>
    }
    texture {bottom}
  }
  // orn
  union {
    triangle {
      < 8.414921, -0.085937, 0.796610>,
      < 8.394976, -0.070614, 0.845775>,
      < 8.405490, -0.095794, 0.815684>
    }
    triangle {
      < 8.413591, -0.060930, 0.791835>,
      < 8.394976, -0.070614, 0.845775>,
      < 8.414921, -0.085937, 0.796610>
    }
    texture {orn}
  }
  // rftire
  union {
    triangle {
      < -4.904545, -2.145534, -2.704390>,
      < -4.817424, -2.217035, -2.704390>,
      < -4.838571, -2.248682, -2.704448>
    }
    triangle {
      < -4.904545, -2.145534, -2.704390>,
      < -4.838571, -2.248682, -2.704448>,
      < -4.931459, -2.172448, -2.704448>
    }
    triangle {
      < -4.931459, -2.172448, -2.704448>,
      < -4.838571, -2.248682, -2.704448>,
      < -4.895739, -2.334237, -2.758817>
    }
    triangle {
      < -4.931459, -2.172448, -2.704448>,
      < -4.895739, -2.334237, -2.758817>,
      < -5.004219, -2.245206, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.004219, -2.245206, -2.758817>,
      < -4.895739, -2.334237, -2.758817>,
      < -4.957872, -2.427223, -2.787150>
    }
    triangle {
      < -5.004219, -2.245206, -2.758817>,
      < -4.957872, -2.427223, -2.787150>,
      < -5.083300, -2.324284, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.083300, -2.324284, -2.787150>,
      < -4.957872, -2.427223, -2.787150>,
      < -5.017624, -2.516644, -2.764967>
    }
    triangle {
      < -5.083300, -2.324284, -2.787150>,
      < -5.017624, -2.516644, -2.764967>,
      < -5.159349, -2.400331, -2.764967>
    }
    triangle {
      < -5.159349, -2.400331, -2.764967>,
      < -5.017624, -2.516644, -2.764967>,
      < -5.080666, -2.610991, -2.700042>
    }
    triangle {
      < -5.159349, -2.400331, -2.764967>,
      < -5.080666, -2.610991, -2.700042>,
      < -5.239585, -2.480566, -2.700042>
    }
    triangle {
      < -5.239585, -2.480566, -2.700042>,
      < -5.080666, -2.610991, -2.700042>,
      < -5.093641, -2.630407, -2.486032>
    }
    triangle {
      < -5.239585, -2.480566, -2.700042>,
      < -5.093641, -2.630407, -2.486032>,
      < -5.256098, -2.497078, -2.486032>
    }
    triangle {
      < -5.256098, -2.497078, -2.486032>,
      < -5.093641, -2.630407, -2.486032>,
      < -5.080666, -2.610991, -2.272216>
    }
    triangle {
      < -5.256098, -2.497078, -2.486032>,
      < -5.080666, -2.610991, -2.272216>,
      < -5.239585, -2.480566, -2.272216>
    }
    triangle {
      < -5.239585, -2.480566, -2.272216>,
      < -5.080666, -2.610991, -2.272216>,
      < -5.017624, -2.516644, -2.207291>
    }
    triangle {
      < -5.239585, -2.480566, -2.272216>,
      < -5.017624, -2.516644, -2.207291>,
      < -5.159349, -2.400331, -2.207291>
    }
    triangle {
      < -5.159349, -2.400331, -2.207291>,
      < -5.017624, -2.516644, -2.207291>,
      < -4.957872, -2.427223, -2.185108>
    }
    triangle {
      < -5.159349, -2.400331, -2.207291>,
      < -4.957872, -2.427223, -2.185108>,
      < -5.083300, -2.324284, -2.185108>
    }
    triangle {
      < -5.083300, -2.324284, -2.185108>,
      < -4.957872, -2.427223, -2.185108>,
      < -4.895739, -2.334237, -2.213441>
    }
    triangle {
      < -5.083300, -2.324284, -2.185108>,
      < -4.895739, -2.334237, -2.213441>,
      < -5.004219, -2.245206, -2.213441>
    }
    triangle {
      < -5.004219, -2.245206, -2.213441>,
      < -4.895739, -2.334237, -2.213441>,
      < -4.838571, -2.248682, -2.267810>
    }
    triangle {
      < -5.004219, -2.245206, -2.213441>,
      < -4.838571, -2.248682, -2.267810>,
      < -4.931459, -2.172448, -2.267810>
    }
    triangle {
      < -4.931459, -2.172448, -2.267810>,
      < -4.838571, -2.248682, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.817424, -2.217035, -2.704390>,
      < -4.718028, -2.270165, -2.704390>,
      < -4.732594, -2.305330, -2.704448>
    }
    triangle {
      < -4.817424, -2.217035, -2.704390>,
      < -4.732594, -2.305330, -2.704448>,
      < -4.838571, -2.248682, -2.704448>
    }
    triangle {
      < -4.838571, -2.248682, -2.704448>,
      < -4.732594, -2.305330, -2.704448>,
      < -4.771974, -2.400394, -2.758817>
    }
    triangle {
      < -4.838571, -2.248682, -2.704448>,
      < -4.771974, -2.400394, -2.758817>,
      < -4.895739, -2.334237, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.895739, -2.334237, -2.758817>,
      < -4.771974, -2.400394, -2.758817>,
      < -4.814773, -2.503715, -2.787150>
    }
    triangle {
      < -4.895739, -2.334237, -2.758817>,
      < -4.814773, -2.503715, -2.787150>,
      < -4.957872, -2.427223, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.957872, -2.427223, -2.787150>,
      < -4.814773, -2.503715, -2.787150>,
      < -4.855932, -2.603076, -2.764967>
    }
    triangle {
      < -4.957872, -2.427223, -2.787150>,
      < -4.855932, -2.603076, -2.764967>,
      < -5.017624, -2.516644, -2.764967>
    }
    triangle {
      < -5.017624, -2.516644, -2.764967>,
      < -4.855932, -2.603076, -2.764967>,
      < -4.899357, -2.707907, -2.700042>
    }
    triangle {
      < -5.017624, -2.516644, -2.764967>,
      < -4.899357, -2.707907, -2.700042>,
      < -5.080666, -2.610991, -2.700042>
    }
    triangle {
      < -5.080666, -2.610991, -2.700042>,
      < -4.899357, -2.707907, -2.700042>,
      < -4.908293, -2.729481, -2.486032>
    }
    triangle {
      < -5.080666, -2.610991, -2.700042>,
      < -4.908293, -2.729481, -2.486032>,
      < -5.093641, -2.630407, -2.486032>
    }
    triangle {
      < -5.093641, -2.630407, -2.486032>,
      < -4.908293, -2.729481, -2.486032>,
      < -4.899357, -2.707907, -2.272216>
    }
    triangle {
      < -5.093641, -2.630407, -2.486032>,
      < -4.899357, -2.707907, -2.272216>,
      < -5.080666, -2.610991, -2.272216>
    }
    triangle {
      < -5.080666, -2.610991, -2.272216>,
      < -4.899357, -2.707907, -2.272216>,
      < -4.855932, -2.603076, -2.207291>
    }
    triangle {
      < -5.080666, -2.610991, -2.272216>,
      < -4.855932, -2.603076, -2.207291>,
      < -5.017624, -2.516644, -2.207291>
    }
    triangle {
      < -5.017624, -2.516644, -2.207291>,
      < -4.855932, -2.603076, -2.207291>,
      < -4.814773, -2.503715, -2.185108>
    }
    triangle {
      < -5.017624, -2.516644, -2.207291>,
      < -4.814773, -2.503715, -2.185108>,
      < -4.957872, -2.427223, -2.185108>
    }
    triangle {
      < -4.957872, -2.427223, -2.185108>,
      < -4.814773, -2.503715, -2.185108>,
      < -4.771974, -2.400394, -2.213441>
    }
    triangle {
      < -4.957872, -2.427223, -2.185108>,
      < -4.771974, -2.400394, -2.213441>,
      < -4.895739, -2.334237, -2.213441>
    }
    triangle {
      < -4.895739, -2.334237, -2.213441>,
      < -4.771974, -2.400394, -2.213441>,
      < -4.732594, -2.305330, -2.267810>
    }
    triangle {
      < -4.895739, -2.334237, -2.213441>,
      < -4.732594, -2.305330, -2.267810>,
      < -4.838571, -2.248682, -2.267810>
    }
    triangle {
      < -4.838571, -2.248682, -2.267810>,
      < -4.732594, -2.305330, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.718028, -2.270165, -2.704390>,
      < -4.610177, -2.302884, -2.704390>,
      < -4.617604, -2.340215, -2.704448>
    }
    triangle {
      < -4.718028, -2.270165, -2.704390>,
      < -4.617604, -2.340215, -2.704448>,
      < -4.732594, -2.305330, -2.704448>
    }
    triangle {
      < -4.732594, -2.305330, -2.704448>,
      < -4.617604, -2.340215, -2.704448>,
      < -4.637680, -2.441134, -2.758817>
    }
    triangle {
      < -4.732594, -2.305330, -2.704448>,
      < -4.637680, -2.441134, -2.758817>,
      < -4.771974, -2.400394, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.771974, -2.400394, -2.758817>,
      < -4.637680, -2.441134, -2.758817>,
      < -4.659500, -2.550819, -2.787150>
    }
    triangle {
      < -4.771974, -2.400394, -2.758817>,
      < -4.659500, -2.550819, -2.787150>,
      < -4.814773, -2.503715, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.814773, -2.503715, -2.787150>,
      < -4.659500, -2.550819, -2.787150>,
      < -4.680484, -2.656301, -2.764967>
    }
    triangle {
      < -4.814773, -2.503715, -2.787150>,
      < -4.680484, -2.656301, -2.764967>,
      < -4.855932, -2.603076, -2.764967>
    }
    triangle {
      < -4.855932, -2.603076, -2.764967>,
      < -4.680484, -2.656301, -2.764967>,
      < -4.702624, -2.767589, -2.700042>
    }
    triangle {
      < -4.855932, -2.603076, -2.764967>,
      < -4.702624, -2.767589, -2.700042>,
      < -4.899357, -2.707907, -2.700042>
    }
    triangle {
      < -4.899357, -2.707907, -2.700042>,
      < -4.702624, -2.767589, -2.700042>,
      < -4.707180, -2.790493, -2.486032>
    }
    triangle {
      < -4.899357, -2.707907, -2.700042>,
      < -4.707180, -2.790493, -2.486032>,
      < -4.908293, -2.729481, -2.486032>
    }
    triangle {
      < -4.908293, -2.729481, -2.486032>,
      < -4.707180, -2.790493, -2.486032>,
      < -4.702624, -2.767589, -2.272216>
    }
    triangle {
      < -4.908293, -2.729481, -2.486032>,
      < -4.702624, -2.767589, -2.272216>,
      < -4.899357, -2.707907, -2.272216>
    }
    triangle {
      < -4.899357, -2.707907, -2.272216>,
      < -4.702624, -2.767589, -2.272216>,
      < -4.680484, -2.656301, -2.207291>
    }
    triangle {
      < -4.899357, -2.707907, -2.272216>,
      < -4.680484, -2.656301, -2.207291>,
      < -4.855932, -2.603076, -2.207291>
    }
    triangle {
      < -4.855932, -2.603076, -2.207291>,
      < -4.680484, -2.656301, -2.207291>,
      < -4.659500, -2.550819, -2.185108>
    }
    triangle {
      < -4.855932, -2.603076, -2.207291>,
      < -4.659500, -2.550819, -2.185108>,
      < -4.814773, -2.503715, -2.185108>
    }
    triangle {
      < -4.814773, -2.503715, -2.185108>,
      < -4.659500, -2.550819, -2.185108>,
      < -4.637680, -2.441134, -2.213441>
    }
    triangle {
      < -4.814773, -2.503715, -2.185108>,
      < -4.637680, -2.441134, -2.213441>,
      < -4.771974, -2.400394, -2.213441>
    }
    triangle {
      < -4.771974, -2.400394, -2.213441>,
      < -4.637680, -2.441134, -2.213441>,
      < -4.617604, -2.340215, -2.267810>
    }
    triangle {
      < -4.771974, -2.400394, -2.213441>,
      < -4.617604, -2.340215, -2.267810>,
      < -4.732594, -2.305330, -2.267810>
    }
    triangle {
      < -4.732594, -2.305330, -2.267810>,
      < -4.617604, -2.340215, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.610177, -2.302884, -2.704390>,
      < -4.498015, -2.313934, -2.704390>,
      < -4.498016, -2.351996, -2.704448>
    }
    triangle {
      < -4.610177, -2.302884, -2.704390>,
      < -4.498016, -2.351996, -2.704448>,
      < -4.617604, -2.340215, -2.704448>
    }
    triangle {
      < -4.617604, -2.340215, -2.704448>,
      < -4.498016, -2.351996, -2.704448>,
      < -4.498019, -2.454893, -2.758817>
    }
    triangle {
      < -4.617604, -2.340215, -2.704448>,
      < -4.498019, -2.454893, -2.758817>,
      < -4.637680, -2.441134, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.637680, -2.441134, -2.758817>,
      < -4.498019, -2.454893, -2.758817>,
      < -4.498022, -2.566728, -2.787150>
    }
    triangle {
      < -4.637680, -2.441134, -2.758817>,
      < -4.498022, -2.566728, -2.787150>,
      < -4.659500, -2.550819, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.659500, -2.550819, -2.787150>,
      < -4.498022, -2.566728, -2.787150>,
      < -4.498025, -2.674276, -2.764967>
    }
    triangle {
      < -4.659500, -2.550819, -2.787150>,
      < -4.498025, -2.674276, -2.764967>,
      < -4.680484, -2.656301, -2.764967>
    }
    triangle {
      < -4.680484, -2.656301, -2.764967>,
      < -4.498025, -2.674276, -2.764967>,
      < -4.498027, -2.787746, -2.700042>
    }
    triangle {
      < -4.680484, -2.656301, -2.764967>,
      < -4.498027, -2.787746, -2.700042>,
      < -4.702624, -2.767589, -2.700042>
    }
    triangle {
      < -4.702624, -2.767589, -2.700042>,
      < -4.498027, -2.787746, -2.700042>,
      < -4.498028, -2.811098, -2.486032>
    }
    triangle {
      < -4.702624, -2.767589, -2.700042>,
      < -4.498028, -2.811098, -2.486032>,
      < -4.707180, -2.790493, -2.486032>
    }
    triangle {
      < -4.707180, -2.790493, -2.486032>,
      < -4.498028, -2.811098, -2.486032>,
      < -4.498027, -2.787746, -2.272216>
    }
    triangle {
      < -4.707180, -2.790493, -2.486032>,
      < -4.498027, -2.787746, -2.272216>,
      < -4.702624, -2.767589, -2.272216>
    }
    triangle {
      < -4.702624, -2.767589, -2.272216>,
      < -4.498027, -2.787746, -2.272216>,
      < -4.498025, -2.674276, -2.207291>
    }
    triangle {
      < -4.702624, -2.767589, -2.272216>,
      < -4.498025, -2.674276, -2.207291>,
      < -4.680484, -2.656301, -2.207291>
    }
    triangle {
      < -4.680484, -2.656301, -2.207291>,
      < -4.498025, -2.674276, -2.207291>,
      < -4.498022, -2.566728, -2.185108>
    }
    triangle {
      < -4.680484, -2.656301, -2.207291>,
      < -4.498022, -2.566728, -2.185108>,
      < -4.659500, -2.550819, -2.185108>
    }
    triangle {
      < -4.659500, -2.550819, -2.185108>,
      < -4.498022, -2.566728, -2.185108>,
      < -4.498019, -2.454893, -2.213441>
    }
    triangle {
      < -4.659500, -2.550819, -2.185108>,
      < -4.498019, -2.454893, -2.213441>,
      < -4.637680, -2.441134, -2.213441>
    }
    triangle {
      < -4.637680, -2.441134, -2.213441>,
      < -4.498019, -2.454893, -2.213441>,
      < -4.498016, -2.351996, -2.267810>
    }
    triangle {
      < -4.637680, -2.441134, -2.213441>,
      < -4.498016, -2.351996, -2.267810>,
      < -4.617604, -2.340215, -2.267810>
    }
    triangle {
      < -4.617604, -2.340215, -2.267810>,
      < -4.498016, -2.351996, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.498015, -2.313934, -2.704390>,
      < -4.385853, -2.302890, -2.704390>,
      < -4.378428, -2.340221, -2.704448>
    }
    triangle {
      < -4.498015, -2.313934, -2.704390>,
      < -4.378428, -2.340221, -2.704448>,
      < -4.498016, -2.351996, -2.704448>
    }
    triangle {
      < -4.498016, -2.351996, -2.704448>,
      < -4.378428, -2.340221, -2.704448>,
      < -4.358357, -2.441142, -2.758817>
    }
    triangle {
      < -4.498016, -2.351996, -2.704448>,
      < -4.358357, -2.441142, -2.758817>,
      < -4.498019, -2.454893, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.498019, -2.454893, -2.758817>,
      < -4.358357, -2.441142, -2.758817>,
      < -4.336542, -2.550828, -2.787150>
    }
    triangle {
      < -4.498019, -2.454893, -2.758817>,
      < -4.336542, -2.550828, -2.787150>,
      < -4.498022, -2.566728, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.498022, -2.566728, -2.787150>,
      < -4.336542, -2.550828, -2.787150>,
      < -4.315564, -2.656310, -2.764967>
    }
    triangle {
      < -4.498022, -2.566728, -2.787150>,
      < -4.315564, -2.656310, -2.764967>,
      < -4.498025, -2.674276, -2.764967>
    }
    triangle {
      < -4.498025, -2.674276, -2.764967>,
      < -4.315564, -2.656310, -2.764967>,
      < -4.293430, -2.767600, -2.700042>
    }
    triangle {
      < -4.498025, -2.674276, -2.764967>,
      < -4.293430, -2.767600, -2.700042>,
      < -4.498027, -2.787746, -2.700042>
    }
    triangle {
      < -4.498027, -2.787746, -2.700042>,
      < -4.293430, -2.767600, -2.700042>,
      < -4.288875, -2.790504, -2.486032>
    }
    triangle {
      < -4.498027, -2.787746, -2.700042>,
      < -4.288875, -2.790504, -2.486032>,
      < -4.498028, -2.811098, -2.486032>
    }
    triangle {
      < -4.498028, -2.811098, -2.486032>,
      < -4.288875, -2.790504, -2.486032>,
      < -4.293430, -2.767600, -2.272216>
    }
    triangle {
      < -4.498028, -2.811098, -2.486032>,
      < -4.293430, -2.767600, -2.272216>,
      < -4.498027, -2.787746, -2.272216>
    }
    triangle {
      < -4.498027, -2.787746, -2.272216>,
      < -4.293430, -2.767600, -2.272216>,
      < -4.315564, -2.656310, -2.207291>
    }
    triangle {
      < -4.498027, -2.787746, -2.272216>,
      < -4.315564, -2.656310, -2.207291>,
      < -4.498025, -2.674276, -2.207291>
    }
    triangle {
      < -4.498025, -2.674276, -2.207291>,
      < -4.315564, -2.656310, -2.207291>,
      < -4.336542, -2.550828, -2.185108>
    }
    triangle {
      < -4.498025, -2.674276, -2.207291>,
      < -4.336542, -2.550828, -2.185108>,
      < -4.498022, -2.566728, -2.185108>
    }
    triangle {
      < -4.498022, -2.566728, -2.185108>,
      < -4.336542, -2.550828, -2.185108>,
      < -4.358357, -2.441142, -2.213441>
    }
    triangle {
      < -4.498022, -2.566728, -2.185108>,
      < -4.358357, -2.441142, -2.213441>,
      < -4.498019, -2.454893, -2.213441>
    }
    triangle {
      < -4.498019, -2.454893, -2.213441>,
      < -4.358357, -2.441142, -2.213441>,
      < -4.378428, -2.340221, -2.267810>
    }
    triangle {
      < -4.498019, -2.454893, -2.213441>,
      < -4.378428, -2.340221, -2.267810>,
      < -4.498016, -2.351996, -2.267810>
    }
    triangle {
      < -4.498016, -2.351996, -2.267810>,
      < -4.378428, -2.340221, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.385853, -2.302890, -2.704390>,
      < -4.278000, -2.270177, -2.704390>,
      < -4.263435, -2.305343, -2.704448>
    }
    triangle {
      < -4.385853, -2.302890, -2.704390>,
      < -4.263435, -2.305343, -2.704448>,
      < -4.378428, -2.340221, -2.704448>
    }
    triangle {
      < -4.378428, -2.340221, -2.704448>,
      < -4.263435, -2.305343, -2.704448>,
      < -4.224061, -2.400407, -2.758817>
    }
    triangle {
      < -4.378428, -2.340221, -2.704448>,
      < -4.224061, -2.400407, -2.758817>,
      < -4.358357, -2.441142, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.358357, -2.441142, -2.758817>,
      < -4.224061, -2.400407, -2.758817>,
      < -4.181267, -2.503732, -2.787150>
    }
    triangle {
      < -4.358357, -2.441142, -2.758817>,
      < -4.181267, -2.503732, -2.787150>,
      < -4.336542, -2.550828, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.336542, -2.550828, -2.787150>,
      < -4.181267, -2.503732, -2.787150>,
      < -4.140114, -2.603094, -2.764967>
    }
    triangle {
      < -4.336542, -2.550828, -2.787150>,
      < -4.140114, -2.603094, -2.764967>,
      < -4.315564, -2.656310, -2.764967>
    }
    triangle {
      < -4.315564, -2.656310, -2.764967>,
      < -4.140114, -2.603094, -2.764967>,
      < -4.096694, -2.707928, -2.700042>
    }
    triangle {
      < -4.315564, -2.656310, -2.764967>,
      < -4.096694, -2.707928, -2.700042>,
      < -4.293430, -2.767600, -2.700042>
    }
    triangle {
      < -4.293430, -2.767600, -2.700042>,
      < -4.096694, -2.707928, -2.700042>,
      < -4.087759, -2.729503, -2.486032>
    }
    triangle {
      < -4.293430, -2.767600, -2.700042>,
      < -4.087759, -2.729503, -2.486032>,
      < -4.288875, -2.790504, -2.486032>
    }
    triangle {
      < -4.288875, -2.790504, -2.486032>,
      < -4.087759, -2.729503, -2.486032>,
      < -4.096694, -2.707928, -2.272216>
    }
    triangle {
      < -4.288875, -2.790504, -2.486032>,
      < -4.096694, -2.707928, -2.272216>,
      < -4.293430, -2.767600, -2.272216>
    }
    triangle {
      < -4.293430, -2.767600, -2.272216>,
      < -4.096694, -2.707928, -2.272216>,
      < -4.140114, -2.603094, -2.207291>
    }
    triangle {
      < -4.293430, -2.767600, -2.272216>,
      < -4.140114, -2.603094, -2.207291>,
      < -4.315564, -2.656310, -2.207291>
    }
    triangle {
      < -4.315564, -2.656310, -2.207291>,
      < -4.140114, -2.603094, -2.207291>,
      < -4.181267, -2.503732, -2.185108>
    }
    triangle {
      < -4.315564, -2.656310, -2.207291>,
      < -4.181267, -2.503732, -2.185108>,
      < -4.336542, -2.550828, -2.185108>
    }
    triangle {
      < -4.336542, -2.550828, -2.185108>,
      < -4.181267, -2.503732, -2.185108>,
      < -4.224061, -2.400407, -2.213441>
    }
    triangle {
      < -4.336542, -2.550828, -2.185108>,
      < -4.224061, -2.400407, -2.213441>,
      < -4.358357, -2.441142, -2.213441>
    }
    triangle {
      < -4.358357, -2.441142, -2.213441>,
      < -4.224061, -2.400407, -2.213441>,
      < -4.263435, -2.305343, -2.267810>
    }
    triangle {
      < -4.358357, -2.441142, -2.213441>,
      < -4.263435, -2.305343, -2.267810>,
      < -4.378428, -2.340221, -2.267810>
    }
    triangle {
      < -4.378428, -2.340221, -2.267810>,
      < -4.263435, -2.305343, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.278000, -2.270177, -2.704390>,
      < -4.178601, -2.217052, -2.704390>,
      < -4.157456, -2.248700, -2.704448>
    }
    triangle {
      < -4.278000, -2.270177, -2.704390>,
      < -4.157456, -2.248700, -2.704448>,
      < -4.263435, -2.305343, -2.704448>
    }
    triangle {
      < -4.263435, -2.305343, -2.704448>,
      < -4.157456, -2.248700, -2.704448>,
      < -4.100293, -2.334258, -2.758817>
    }
    triangle {
      < -4.263435, -2.305343, -2.704448>,
      < -4.100293, -2.334258, -2.758817>,
      < -4.224061, -2.400407, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.224061, -2.400407, -2.758817>,
      < -4.100293, -2.334258, -2.758817>,
      < -4.038163, -2.427247, -2.787150>
    }
    triangle {
      < -4.224061, -2.400407, -2.758817>,
      < -4.038163, -2.427247, -2.787150>,
      < -4.181267, -2.503732, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.181267, -2.503732, -2.787150>,
      < -4.038163, -2.427247, -2.787150>,
      < -3.978416, -2.516672, -2.764967>
    }
    triangle {
      < -4.181267, -2.503732, -2.787150>,
      < -3.978416, -2.516672, -2.764967>,
      < -4.140114, -2.603094, -2.764967>
    }
    triangle {
      < -4.140114, -2.603094, -2.764967>,
      < -3.978416, -2.516672, -2.764967>,
      < -3.915380, -2.611022, -2.700042>
    }
    triangle {
      < -4.140114, -2.603094, -2.764967>,
      < -3.915380, -2.611022, -2.700042>,
      < -4.096694, -2.707928, -2.700042>
    }
    triangle {
      < -4.096694, -2.707928, -2.700042>,
      < -3.915380, -2.611022, -2.700042>,
      < -3.902406, -2.630438, -2.486032>
    }
    triangle {
      < -4.096694, -2.707928, -2.700042>,
      < -3.902406, -2.630438, -2.486032>,
      < -4.087759, -2.729503, -2.486032>
    }
    triangle {
      < -4.087759, -2.729503, -2.486032>,
      < -3.902406, -2.630438, -2.486032>,
      < -3.915380, -2.611022, -2.272216>
    }
    triangle {
      < -4.087759, -2.729503, -2.486032>,
      < -3.915380, -2.611022, -2.272216>,
      < -4.096694, -2.707928, -2.272216>
    }
    triangle {
      < -4.096694, -2.707928, -2.272216>,
      < -3.915380, -2.611022, -2.272216>,
      < -3.978416, -2.516672, -2.207291>
    }
    triangle {
      < -4.096694, -2.707928, -2.272216>,
      < -3.978416, -2.516672, -2.207291>,
      < -4.140114, -2.603094, -2.207291>
    }
    triangle {
      < -4.140114, -2.603094, -2.207291>,
      < -3.978416, -2.516672, -2.207291>,
      < -4.038163, -2.427247, -2.185108>
    }
    triangle {
      < -4.140114, -2.603094, -2.207291>,
      < -4.038163, -2.427247, -2.185108>,
      < -4.181267, -2.503732, -2.185108>
    }
    triangle {
      < -4.181267, -2.503732, -2.185108>,
      < -4.038163, -2.427247, -2.185108>,
      < -4.100293, -2.334258, -2.213441>
    }
    triangle {
      < -4.181267, -2.503732, -2.185108>,
      < -4.100293, -2.334258, -2.213441>,
      < -4.224061, -2.400407, -2.213441>
    }
    triangle {
      < -4.224061, -2.400407, -2.213441>,
      < -4.100293, -2.334258, -2.213441>,
      < -4.157456, -2.248700, -2.267810>
    }
    triangle {
      < -4.224061, -2.400407, -2.213441>,
      < -4.157456, -2.248700, -2.267810>,
      < -4.263435, -2.305343, -2.267810>
    }
    triangle {
      < -4.263435, -2.305343, -2.267810>,
      < -4.157456, -2.248700, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.178601, -2.217052, -2.704390>,
      < -4.091476, -2.145556, -2.704390>,
      < -4.064563, -2.172471, -2.704448>
    }
    triangle {
      < -4.178601, -2.217052, -2.704390>,
      < -4.064563, -2.172471, -2.704448>,
      < -4.157456, -2.248700, -2.704448>
    }
    triangle {
      < -4.157456, -2.248700, -2.704448>,
      < -4.064563, -2.172471, -2.704448>,
      < -3.991807, -2.245233, -2.758817>
    }
    triangle {
      < -4.157456, -2.248700, -2.704448>,
      < -3.991807, -2.245233, -2.758817>,
      < -4.100293, -2.334258, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.100293, -2.334258, -2.758817>,
      < -3.991807, -2.245233, -2.758817>,
      < -3.912731, -2.324315, -2.787150>
    }
    triangle {
      < -4.100293, -2.334258, -2.758817>,
      < -3.912731, -2.324315, -2.787150>,
      < -4.038163, -2.427247, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.038163, -2.427247, -2.787150>,
      < -3.912731, -2.324315, -2.787150>,
      < -3.836686, -2.400366, -2.764967>
    }
    triangle {
      < -4.038163, -2.427247, -2.787150>,
      < -3.836686, -2.400366, -2.764967>,
      < -3.978416, -2.516672, -2.764967>
    }
    triangle {
      < -3.978416, -2.516672, -2.764967>,
      < -3.836686, -2.400366, -2.764967>,
      < -3.756454, -2.480605, -2.700042>
    }
    triangle {
      < -3.978416, -2.516672, -2.764967>,
      < -3.756454, -2.480605, -2.700042>,
      < -3.915380, -2.611022, -2.700042>
    }
    triangle {
      < -3.915380, -2.611022, -2.700042>,
      < -3.756454, -2.480605, -2.700042>,
      < -3.739942, -2.497117, -2.486032>
    }
    triangle {
      < -3.915380, -2.611022, -2.700042>,
      < -3.739942, -2.497117, -2.486032>,
      < -3.902406, -2.630438, -2.486032>
    }
    triangle {
      < -3.902406, -2.630438, -2.486032>,
      < -3.739942, -2.497117, -2.486032>,
      < -3.756454, -2.480605, -2.272216>
    }
    triangle {
      < -3.902406, -2.630438, -2.486032>,
      < -3.756454, -2.480605, -2.272216>,
      < -3.915380, -2.611022, -2.272216>
    }
    triangle {
      < -3.915380, -2.611022, -2.272216>,
      < -3.756454, -2.480605, -2.272216>,
      < -3.836686, -2.400366, -2.207291>
    }
    triangle {
      < -3.915380, -2.611022, -2.272216>,
      < -3.836686, -2.400366, -2.207291>,
      < -3.978416, -2.516672, -2.207291>
    }
    triangle {
      < -3.978416, -2.516672, -2.207291>,
      < -3.836686, -2.400366, -2.207291>,
      < -3.912731, -2.324315, -2.185108>
    }
    triangle {
      < -3.978416, -2.516672, -2.207291>,
      < -3.912731, -2.324315, -2.185108>,
      < -4.038163, -2.427247, -2.185108>
    }
    triangle {
      < -4.038163, -2.427247, -2.185108>,
      < -3.912731, -2.324315, -2.185108>,
      < -3.991807, -2.245233, -2.213441>
    }
    triangle {
      < -4.038163, -2.427247, -2.185108>,
      < -3.991807, -2.245233, -2.213441>,
      < -4.100293, -2.334258, -2.213441>
    }
    triangle {
      < -4.100293, -2.334258, -2.213441>,
      < -3.991807, -2.245233, -2.213441>,
      < -4.064563, -2.172471, -2.267810>
    }
    triangle {
      < -4.100293, -2.334258, -2.213441>,
      < -4.064563, -2.172471, -2.267810>,
      < -4.157456, -2.248700, -2.267810>
    }
    triangle {
      < -4.157456, -2.248700, -2.267810>,
      < -4.064563, -2.172471, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.091476, -2.145556, -2.704390>,
      < -4.019974, -2.058437, -2.704390>,
      < -3.988327, -2.079584, -2.704448>
    }
    triangle {
      < -4.091476, -2.145556, -2.704390>,
      < -3.988327, -2.079584, -2.704448>,
      < -4.064563, -2.172471, -2.704448>
    }
    triangle {
      < -4.064563, -2.172471, -2.704448>,
      < -3.988327, -2.079584, -2.704448>,
      < -3.902774, -2.136754, -2.758817>
    }
    triangle {
      < -4.064563, -2.172471, -2.704448>,
      < -3.902774, -2.136754, -2.758817>,
      < -3.991807, -2.245233, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.991807, -2.245233, -2.758817>,
      < -3.902774, -2.136754, -2.758817>,
      < -3.809789, -2.198890, -2.787150>
    }
    triangle {
      < -3.991807, -2.245233, -2.758817>,
      < -3.809789, -2.198890, -2.787150>,
      < -3.912731, -2.324315, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.912731, -2.324315, -2.787150>,
      < -3.809789, -2.198890, -2.787150>,
      < -3.720369, -2.258645, -2.764967>
    }
    triangle {
      < -3.912731, -2.324315, -2.787150>,
      < -3.720369, -2.258645, -2.764967>,
      < -3.836686, -2.400366, -2.764967>
    }
    triangle {
      < -3.836686, -2.400366, -2.764967>,
      < -3.720369, -2.258645, -2.764967>,
      < -3.626024, -2.321689, -2.700042>
    }
    triangle {
      < -3.836686, -2.400366, -2.764967>,
      < -3.626024, -2.321689, -2.700042>,
      < -3.756454, -2.480605, -2.700042>
    }
    triangle {
      < -3.756454, -2.480605, -2.700042>,
      < -3.626024, -2.321689, -2.700042>,
      < -3.606608, -2.334664, -2.486032>
    }
    triangle {
      < -3.756454, -2.480605, -2.700042>,
      < -3.606608, -2.334664, -2.486032>,
      < -3.739942, -2.497117, -2.486032>
    }
    triangle {
      < -3.739942, -2.497117, -2.486032>,
      < -3.606608, -2.334664, -2.486032>,
      < -3.626024, -2.321689, -2.272216>
    }
    triangle {
      < -3.739942, -2.497117, -2.486032>,
      < -3.626024, -2.321689, -2.272216>,
      < -3.756454, -2.480605, -2.272216>
    }
    triangle {
      < -3.756454, -2.480605, -2.272216>,
      < -3.626024, -2.321689, -2.272216>,
      < -3.720369, -2.258645, -2.207291>
    }
    triangle {
      < -3.756454, -2.480605, -2.272216>,
      < -3.720369, -2.258645, -2.207291>,
      < -3.836686, -2.400366, -2.207291>
    }
    triangle {
      < -3.836686, -2.400366, -2.207291>,
      < -3.720369, -2.258645, -2.207291>,
      < -3.809789, -2.198890, -2.185108>
    }
    triangle {
      < -3.836686, -2.400366, -2.207291>,
      < -3.809789, -2.198890, -2.185108>,
      < -3.912731, -2.324315, -2.185108>
    }
    triangle {
      < -3.912731, -2.324315, -2.185108>,
      < -3.809789, -2.198890, -2.185108>,
      < -3.902774, -2.136754, -2.213441>
    }
    triangle {
      < -3.912731, -2.324315, -2.185108>,
      < -3.902774, -2.136754, -2.213441>,
      < -3.991807, -2.245233, -2.213441>
    }
    triangle {
      < -3.991807, -2.245233, -2.213441>,
      < -3.902774, -2.136754, -2.213441>,
      < -3.988327, -2.079584, -2.267810>
    }
    triangle {
      < -3.991807, -2.245233, -2.213441>,
      < -3.988327, -2.079584, -2.267810>,
      < -4.064563, -2.172471, -2.267810>
    }
    triangle {
      < -4.064563, -2.172471, -2.267810>,
      < -3.988327, -2.079584, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.019974, -2.058437, -2.704390>,
      < -3.966841, -1.959042, -2.704390>,
      < -3.931676, -1.973609, -2.704448>
    }
    triangle {
      < -4.019974, -2.058437, -2.704390>,
      < -3.931676, -1.973609, -2.704448>,
      < -3.988327, -2.079584, -2.704448>
    }
    triangle {
      < -3.988327, -2.079584, -2.704448>,
      < -3.931676, -1.973609, -2.704448>,
      < -3.836613, -2.012991, -2.758817>
    }
    triangle {
      < -3.988327, -2.079584, -2.704448>,
      < -3.836613, -2.012991, -2.758817>,
      < -3.902774, -2.136754, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.902774, -2.136754, -2.758817>,
      < -3.836613, -2.012991, -2.758817>,
      < -3.733294, -2.055792, -2.787150>
    }
    triangle {
      < -3.902774, -2.136754, -2.758817>,
      < -3.733294, -2.055792, -2.787150>,
      < -3.809789, -2.198890, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.809789, -2.198890, -2.787150>,
      < -3.733294, -2.055792, -2.787150>,
      < -3.633934, -2.096955, -2.764967>
    }
    triangle {
      < -3.809789, -2.198890, -2.787150>,
      < -3.633934, -2.096955, -2.764967>,
      < -3.720369, -2.258645, -2.764967>
    }
    triangle {
      < -3.720369, -2.258645, -2.764967>,
      < -3.633934, -2.096955, -2.764967>,
      < -3.529103, -2.140382, -2.700042>
    }
    triangle {
      < -3.720369, -2.258645, -2.764967>,
      < -3.529103, -2.140382, -2.700042>,
      < -3.626024, -2.321689, -2.700042>
    }
    triangle {
      < -3.626024, -2.321689, -2.700042>,
      < -3.529103, -2.140382, -2.700042>,
      < -3.507529, -2.149320, -2.486032>
    }
    triangle {
      < -3.626024, -2.321689, -2.700042>,
      < -3.507529, -2.149320, -2.486032>,
      < -3.606608, -2.334664, -2.486032>
    }
    triangle {
      < -3.606608, -2.334664, -2.486032>,
      < -3.507529, -2.149320, -2.486032>,
      < -3.529103, -2.140382, -2.272216>
    }
    triangle {
      < -3.606608, -2.334664, -2.486032>,
      < -3.529103, -2.140382, -2.272216>,
      < -3.626024, -2.321689, -2.272216>
    }
    triangle {
      < -3.626024, -2.321689, -2.272216>,
      < -3.529103, -2.140382, -2.272216>,
      < -3.633934, -2.096955, -2.207291>
    }
    triangle {
      < -3.626024, -2.321689, -2.272216>,
      < -3.633934, -2.096955, -2.207291>,
      < -3.720369, -2.258645, -2.207291>
    }
    triangle {
      < -3.720369, -2.258645, -2.207291>,
      < -3.633934, -2.096955, -2.207291>,
      < -3.733294, -2.055792, -2.185108>
    }
    triangle {
      < -3.720369, -2.258645, -2.207291>,
      < -3.733294, -2.055792, -2.185108>,
      < -3.809789, -2.198890, -2.185108>
    }
    triangle {
      < -3.809789, -2.198890, -2.185108>,
      < -3.733294, -2.055792, -2.185108>,
      < -3.836613, -2.012991, -2.213441>
    }
    triangle {
      < -3.809789, -2.198890, -2.185108>,
      < -3.836613, -2.012991, -2.213441>,
      < -3.902774, -2.136754, -2.213441>
    }
    triangle {
      < -3.902774, -2.136754, -2.213441>,
      < -3.836613, -2.012991, -2.213441>,
      < -3.931676, -1.973609, -2.267810>
    }
    triangle {
      < -3.902774, -2.136754, -2.213441>,
      < -3.931676, -1.973609, -2.267810>,
      < -3.988327, -2.079584, -2.267810>
    }
    triangle {
      < -3.988327, -2.079584, -2.267810>,
      < -3.931676, -1.973609, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -3.966841, -1.959042, -2.704390>,
      < -3.934118, -1.851192, -2.704390>,
      < -3.896788, -1.858619, -2.704448>
    }
    triangle {
      < -3.966841, -1.959042, -2.704390>,
      < -3.896788, -1.858619, -2.704448>,
      < -3.931676, -1.973609, -2.704448>
    }
    triangle {
      < -3.931676, -1.973609, -2.704448>,
      < -3.896788, -1.858619, -2.704448>,
      < -3.795870, -1.878699, -2.758817>
    }
    triangle {
      < -3.931676, -1.973609, -2.704448>,
      < -3.795870, -1.878699, -2.758817>,
      < -3.836613, -2.012991, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.836613, -2.012991, -2.758817>,
      < -3.795870, -1.878699, -2.758817>,
      < -3.686185, -1.900522, -2.787150>
    }
    triangle {
      < -3.836613, -2.012991, -2.758817>,
      < -3.686185, -1.900522, -2.787150>,
      < -3.733294, -2.055792, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.733294, -2.055792, -2.787150>,
      < -3.686185, -1.900522, -2.787150>,
      < -3.580705, -1.921509, -2.764967>
    }
    triangle {
      < -3.733294, -2.055792, -2.787150>,
      < -3.580705, -1.921509, -2.764967>,
      < -3.633934, -2.096955, -2.764967>
    }
    triangle {
      < -3.633934, -2.096955, -2.764967>,
      < -3.580705, -1.921509, -2.764967>,
      < -3.469416, -1.943652, -2.700042>
    }
    triangle {
      < -3.633934, -2.096955, -2.764967>,
      < -3.469416, -1.943652, -2.700042>,
      < -3.529103, -2.140382, -2.700042>
    }
    triangle {
      < -3.529103, -2.140382, -2.700042>,
      < -3.469416, -1.943652, -2.700042>,
      < -3.446512, -1.948209, -2.486032>
    }
    triangle {
      < -3.529103, -2.140382, -2.700042>,
      < -3.446512, -1.948209, -2.486032>,
      < -3.507529, -2.149320, -2.486032>
    }
    triangle {
      < -3.507529, -2.149320, -2.486032>,
      < -3.446512, -1.948209, -2.486032>,
      < -3.469416, -1.943652, -2.272216>
    }
    triangle {
      < -3.507529, -2.149320, -2.486032>,
      < -3.469416, -1.943652, -2.272216>,
      < -3.529103, -2.140382, -2.272216>
    }
    triangle {
      < -3.529103, -2.140382, -2.272216>,
      < -3.469416, -1.943652, -2.272216>,
      < -3.580705, -1.921509, -2.207291>
    }
    triangle {
      < -3.529103, -2.140382, -2.272216>,
      < -3.580705, -1.921509, -2.207291>,
      < -3.633934, -2.096955, -2.207291>
    }
    triangle {
      < -3.633934, -2.096955, -2.207291>,
      < -3.580705, -1.921509, -2.207291>,
      < -3.686185, -1.900522, -2.185108>
    }
    triangle {
      < -3.633934, -2.096955, -2.207291>,
      < -3.686185, -1.900522, -2.185108>,
      < -3.733294, -2.055792, -2.185108>
    }
    triangle {
      < -3.733294, -2.055792, -2.185108>,
      < -3.686185, -1.900522, -2.185108>,
      < -3.795870, -1.878699, -2.213441>
    }
    triangle {
      < -3.733294, -2.055792, -2.185108>,
      < -3.795870, -1.878699, -2.213441>,
      < -3.836613, -2.012991, -2.213441>
    }
    triangle {
      < -3.836613, -2.012991, -2.213441>,
      < -3.795870, -1.878699, -2.213441>,
      < -3.896788, -1.858619, -2.267810>
    }
    triangle {
      < -3.836613, -2.012991, -2.213441>,
      < -3.896788, -1.858619, -2.267810>,
      < -3.931676, -1.973609, -2.267810>
    }
    triangle {
      < -3.931676, -1.973609, -2.267810>,
      < -3.896788, -1.858619, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -3.934118, -1.851192, -2.704390>,
      < -3.923066, -1.739030, -2.704390>,
      < -3.885004, -1.739033, -2.704448>
    }
    triangle {
      < -3.934118, -1.851192, -2.704390>,
      < -3.885004, -1.739033, -2.704448>,
      < -3.896788, -1.858619, -2.704448>
    }
    triangle {
      < -3.896788, -1.858619, -2.704448>,
      < -3.885004, -1.739033, -2.704448>,
      < -3.782107, -1.739038, -2.758817>
    }
    triangle {
      < -3.896788, -1.858619, -2.704448>,
      < -3.782107, -1.739038, -2.758817>,
      < -3.795870, -1.878699, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.795870, -1.878699, -2.758817>,
      < -3.782107, -1.739038, -2.758817>,
      < -3.670272, -1.739043, -2.787150>
    }
    triangle {
      < -3.795870, -1.878699, -2.758817>,
      < -3.670272, -1.739043, -2.787150>,
      < -3.686185, -1.900522, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.686185, -1.900522, -2.787150>,
      < -3.670272, -1.739043, -2.787150>,
      < -3.562724, -1.739049, -2.764967>
    }
    triangle {
      < -3.686185, -1.900522, -2.787150>,
      < -3.562724, -1.739049, -2.764967>,
      < -3.580705, -1.921509, -2.764967>
    }
    triangle {
      < -3.580705, -1.921509, -2.764967>,
      < -3.562724, -1.739049, -2.764967>,
      < -3.449254, -1.739055, -2.700042>
    }
    triangle {
      < -3.580705, -1.921509, -2.764967>,
      < -3.449254, -1.739055, -2.700042>,
      < -3.469416, -1.943652, -2.700042>
    }
    triangle {
      < -3.469416, -1.943652, -2.700042>,
      < -3.449254, -1.739055, -2.700042>,
      < -3.425902, -1.739057, -2.486032>
    }
    triangle {
      < -3.469416, -1.943652, -2.700042>,
      < -3.425902, -1.739057, -2.486032>,
      < -3.446512, -1.948209, -2.486032>
    }
    triangle {
      < -3.446512, -1.948209, -2.486032>,
      < -3.425902, -1.739057, -2.486032>,
      < -3.449254, -1.739055, -2.272216>
    }
    triangle {
      < -3.446512, -1.948209, -2.486032>,
      < -3.449254, -1.739055, -2.272216>,
      < -3.469416, -1.943652, -2.272216>
    }
    triangle {
      < -3.469416, -1.943652, -2.272216>,
      < -3.449254, -1.739055, -2.272216>,
      < -3.562724, -1.739049, -2.207291>
    }
    triangle {
      < -3.469416, -1.943652, -2.272216>,
      < -3.562724, -1.739049, -2.207291>,
      < -3.580705, -1.921509, -2.207291>
    }
    triangle {
      < -3.580705, -1.921509, -2.207291>,
      < -3.562724, -1.739049, -2.207291>,
      < -3.670272, -1.739043, -2.185108>
    }
    triangle {
      < -3.580705, -1.921509, -2.207291>,
      < -3.670272, -1.739043, -2.185108>,
      < -3.686185, -1.900522, -2.185108>
    }
    triangle {
      < -3.686185, -1.900522, -2.185108>,
      < -3.670272, -1.739043, -2.185108>,
      < -3.782107, -1.739038, -2.213441>
    }
    triangle {
      < -3.686185, -1.900522, -2.185108>,
      < -3.782107, -1.739038, -2.213441>,
      < -3.795870, -1.878699, -2.213441>
    }
    triangle {
      < -3.795870, -1.878699, -2.213441>,
      < -3.782107, -1.739038, -2.213441>,
      < -3.885004, -1.739033, -2.267810>
    }
    triangle {
      < -3.795870, -1.878699, -2.213441>,
      < -3.885004, -1.739033, -2.267810>,
      < -3.896788, -1.858619, -2.267810>
    }
    triangle {
      < -3.896788, -1.858619, -2.267810>,
      < -3.885004, -1.739033, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -3.923066, -1.739030, -2.704390>,
      < -3.934107, -1.626868, -2.704390>,
      < -3.896776, -1.619444, -2.704448>
    }
    triangle {
      < -3.923066, -1.739030, -2.704390>,
      < -3.896776, -1.619444, -2.704448>,
      < -3.885004, -1.739033, -2.704448>
    }
    triangle {
      < -3.885004, -1.739033, -2.704448>,
      < -3.896776, -1.619444, -2.704448>,
      < -3.795855, -1.599375, -2.758817>
    }
    triangle {
      < -3.885004, -1.739033, -2.704448>,
      < -3.795855, -1.599375, -2.758817>,
      < -3.782107, -1.739038, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.782107, -1.739038, -2.758817>,
      < -3.795855, -1.599375, -2.758817>,
      < -3.686168, -1.577563, -2.787150>
    }
    triangle {
      < -3.782107, -1.739038, -2.758817>,
      < -3.686168, -1.577563, -2.787150>,
      < -3.670272, -1.739043, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.670272, -1.739043, -2.787150>,
      < -3.686168, -1.577563, -2.787150>,
      < -3.580685, -1.556588, -2.764967>
    }
    triangle {
      < -3.670272, -1.739043, -2.787150>,
      < -3.580685, -1.556588, -2.764967>,
      < -3.562724, -1.739049, -2.764967>
    }
    triangle {
      < -3.562724, -1.739049, -2.764967>,
      < -3.580685, -1.556588, -2.764967>,
      < -3.469395, -1.534457, -2.700042>
    }
    triangle {
      < -3.562724, -1.739049, -2.764967>,
      < -3.469395, -1.534457, -2.700042>,
      < -3.449254, -1.739055, -2.700042>
    }
    triangle {
      < -3.449254, -1.739055, -2.700042>,
      < -3.469395, -1.534457, -2.700042>,
      < -3.446491, -1.529903, -2.486032>
    }
    triangle {
      < -3.449254, -1.739055, -2.700042>,
      < -3.446491, -1.529903, -2.486032>,
      < -3.425902, -1.739057, -2.486032>
    }
    triangle {
      < -3.425902, -1.739057, -2.486032>,
      < -3.446491, -1.529903, -2.486032>,
      < -3.469395, -1.534457, -2.272216>
    }
    triangle {
      < -3.425902, -1.739057, -2.486032>,
      < -3.469395, -1.534457, -2.272216>,
      < -3.449254, -1.739055, -2.272216>
    }
    triangle {
      < -3.449254, -1.739055, -2.272216>,
      < -3.469395, -1.534457, -2.272216>,
      < -3.580685, -1.556588, -2.207291>
    }
    triangle {
      < -3.449254, -1.739055, -2.272216>,
      < -3.580685, -1.556588, -2.207291>,
      < -3.562724, -1.739049, -2.207291>
    }
    triangle {
      < -3.562724, -1.739049, -2.207291>,
      < -3.580685, -1.556588, -2.207291>,
      < -3.686168, -1.577563, -2.185108>
    }
    triangle {
      < -3.562724, -1.739049, -2.207291>,
      < -3.686168, -1.577563, -2.185108>,
      < -3.670272, -1.739043, -2.185108>
    }
    triangle {
      < -3.670272, -1.739043, -2.185108>,
      < -3.686168, -1.577563, -2.185108>,
      < -3.795855, -1.599375, -2.213441>
    }
    triangle {
      < -3.670272, -1.739043, -2.185108>,
      < -3.795855, -1.599375, -2.213441>,
      < -3.782107, -1.739038, -2.213441>
    }
    triangle {
      < -3.782107, -1.739038, -2.213441>,
      < -3.795855, -1.599375, -2.213441>,
      < -3.896776, -1.619444, -2.267810>
    }
    triangle {
      < -3.782107, -1.739038, -2.213441>,
      < -3.896776, -1.619444, -2.267810>,
      < -3.885004, -1.739033, -2.267810>
    }
    triangle {
      < -3.885004, -1.739033, -2.267810>,
      < -3.896776, -1.619444, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -3.934107, -1.626868, -2.704390>,
      < -3.966817, -1.519013, -2.704390>,
      < -3.931651, -1.504450, -2.704448>
    }
    triangle {
      < -3.934107, -1.626868, -2.704390>,
      < -3.931651, -1.504450, -2.704448>,
      < -3.896776, -1.619444, -2.704448>
    }
    triangle {
      < -3.896776, -1.619444, -2.704448>,
      < -3.931651, -1.504450, -2.704448>,
      < -3.836585, -1.465079, -2.758817>
    }
    triangle {
      < -3.896776, -1.619444, -2.704448>,
      < -3.836585, -1.465079, -2.758817>,
      < -3.795855, -1.599375, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.795855, -1.599375, -2.758817>,
      < -3.836585, -1.465079, -2.758817>,
      < -3.733261, -1.422288, -2.787150>
    }
    triangle {
      < -3.795855, -1.599375, -2.758817>,
      < -3.733261, -1.422288, -2.787150>,
      < -3.686168, -1.577563, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.686168, -1.577563, -2.787150>,
      < -3.733261, -1.422288, -2.787150>,
      < -3.633897, -1.381136, -2.764967>
    }
    triangle {
      < -3.686168, -1.577563, -2.787150>,
      < -3.633897, -1.381136, -2.764967>,
      < -3.580685, -1.556588, -2.764967>
    }
    triangle {
      < -3.580685, -1.556588, -2.764967>,
      < -3.633897, -1.381136, -2.764967>,
      < -3.529061, -1.337719, -2.700042>
    }
    triangle {
      < -3.580685, -1.556588, -2.764967>,
      < -3.529061, -1.337719, -2.700042>,
      < -3.469395, -1.534457, -2.700042>
    }
    triangle {
      < -3.469395, -1.534457, -2.700042>,
      < -3.529061, -1.337719, -2.700042>,
      < -3.507486, -1.328784, -2.486032>
    }
    triangle {
      < -3.469395, -1.534457, -2.700042>,
      < -3.507486, -1.328784, -2.486032>,
      < -3.446491, -1.529903, -2.486032>
    }
    triangle {
      < -3.446491, -1.529903, -2.486032>,
      < -3.507486, -1.328784, -2.486032>,
      < -3.529061, -1.337719, -2.272216>
    }
    triangle {
      < -3.446491, -1.529903, -2.486032>,
      < -3.529061, -1.337719, -2.272216>,
      < -3.469395, -1.534457, -2.272216>
    }
    triangle {
      < -3.469395, -1.534457, -2.272216>,
      < -3.529061, -1.337719, -2.272216>,
      < -3.633897, -1.381136, -2.207291>
    }
    triangle {
      < -3.469395, -1.534457, -2.272216>,
      < -3.633897, -1.381136, -2.207291>,
      < -3.580685, -1.556588, -2.207291>
    }
    triangle {
      < -3.580685, -1.556588, -2.207291>,
      < -3.633897, -1.381136, -2.207291>,
      < -3.733261, -1.422288, -2.185108>
    }
    triangle {
      < -3.580685, -1.556588, -2.207291>,
      < -3.733261, -1.422288, -2.185108>,
      < -3.686168, -1.577563, -2.185108>
    }
    triangle {
      < -3.686168, -1.577563, -2.185108>,
      < -3.733261, -1.422288, -2.185108>,
      < -3.836585, -1.465079, -2.213441>
    }
    triangle {
      < -3.686168, -1.577563, -2.185108>,
      < -3.836585, -1.465079, -2.213441>,
      < -3.795855, -1.599375, -2.213441>
    }
    triangle {
      < -3.795855, -1.599375, -2.213441>,
      < -3.836585, -1.465079, -2.213441>,
      < -3.931651, -1.504450, -2.267810>
    }
    triangle {
      < -3.795855, -1.599375, -2.213441>,
      < -3.931651, -1.504450, -2.267810>,
      < -3.896776, -1.619444, -2.267810>
    }
    triangle {
      < -3.896776, -1.619444, -2.267810>,
      < -3.931651, -1.504450, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -3.966817, -1.519013, -2.704390>,
      < -4.019940, -1.419614, -2.704390>,
      < -3.988291, -1.398469, -2.704448>
    }
    triangle {
      < -3.966817, -1.519013, -2.704390>,
      < -3.988291, -1.398469, -2.704448>,
      < -3.931651, -1.504450, -2.704448>
    }
    triangle {
      < -3.931651, -1.504450, -2.704448>,
      < -3.988291, -1.398469, -2.704448>,
      < -3.902732, -1.341308, -2.758817>
    }
    triangle {
      < -3.931651, -1.504450, -2.704448>,
      < -3.902732, -1.341308, -2.758817>,
      < -3.836585, -1.465079, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.836585, -1.465079, -2.758817>,
      < -3.902732, -1.341308, -2.758817>,
      < -3.809741, -1.279182, -2.787150>
    }
    triangle {
      < -3.836585, -1.465079, -2.758817>,
      < -3.809741, -1.279182, -2.787150>,
      < -3.733261, -1.422288, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.733261, -1.422288, -2.787150>,
      < -3.809741, -1.279182, -2.787150>,
      < -3.720314, -1.219437, -2.764967>
    }
    triangle {
      < -3.733261, -1.422288, -2.787150>,
      < -3.720314, -1.219437, -2.764967>,
      < -3.633897, -1.381136, -2.764967>
    }
    triangle {
      < -3.633897, -1.381136, -2.764967>,
      < -3.720314, -1.219437, -2.764967>,
      < -3.625963, -1.156403, -2.700042>
    }
    triangle {
      < -3.633897, -1.381136, -2.764967>,
      < -3.625963, -1.156403, -2.700042>,
      < -3.529061, -1.337719, -2.700042>
    }
    triangle {
      < -3.529061, -1.337719, -2.700042>,
      < -3.625963, -1.156403, -2.700042>,
      < -3.606545, -1.143430, -2.486032>
    }
    triangle {
      < -3.529061, -1.337719, -2.700042>,
      < -3.606545, -1.143430, -2.486032>,
      < -3.507486, -1.328784, -2.486032>
    }
    triangle {
      < -3.507486, -1.328784, -2.486032>,
      < -3.606545, -1.143430, -2.486032>,
      < -3.625963, -1.156403, -2.272216>
    }
    triangle {
      < -3.507486, -1.328784, -2.486032>,
      < -3.625963, -1.156403, -2.272216>,
      < -3.529061, -1.337719, -2.272216>
    }
    triangle {
      < -3.529061, -1.337719, -2.272216>,
      < -3.625963, -1.156403, -2.272216>,
      < -3.720314, -1.219437, -2.207291>
    }
    triangle {
      < -3.529061, -1.337719, -2.272216>,
      < -3.720314, -1.219437, -2.207291>,
      < -3.633897, -1.381136, -2.207291>
    }
    triangle {
      < -3.633897, -1.381136, -2.207291>,
      < -3.720314, -1.219437, -2.207291>,
      < -3.809741, -1.279182, -2.185108>
    }
    triangle {
      < -3.633897, -1.381136, -2.207291>,
      < -3.809741, -1.279182, -2.185108>,
      < -3.733261, -1.422288, -2.185108>
    }
    triangle {
      < -3.733261, -1.422288, -2.185108>,
      < -3.809741, -1.279182, -2.185108>,
      < -3.902732, -1.341308, -2.213441>
    }
    triangle {
      < -3.733261, -1.422288, -2.185108>,
      < -3.902732, -1.341308, -2.213441>,
      < -3.836585, -1.465079, -2.213441>
    }
    triangle {
      < -3.836585, -1.465079, -2.213441>,
      < -3.902732, -1.341308, -2.213441>,
      < -3.988291, -1.398469, -2.267810>
    }
    triangle {
      < -3.836585, -1.465079, -2.213441>,
      < -3.988291, -1.398469, -2.267810>,
      < -3.931651, -1.504450, -2.267810>
    }
    triangle {
      < -3.931651, -1.504450, -2.267810>,
      < -3.988291, -1.398469, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.019940, -1.419614, -2.704390>,
      < -4.091434, -1.332487, -2.704390>,
      < -4.064518, -1.305575, -2.704448>
    }
    triangle {
      < -4.019940, -1.419614, -2.704390>,
      < -4.064518, -1.305575, -2.704448>,
      < -3.988291, -1.398469, -2.704448>
    }
    triangle {
      < -3.988291, -1.398469, -2.704448>,
      < -4.064518, -1.305575, -2.704448>,
      < -3.991754, -1.232821, -2.758817>
    }
    triangle {
      < -3.988291, -1.398469, -2.704448>,
      < -3.991754, -1.232821, -2.758817>,
      < -3.902732, -1.341308, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.902732, -1.341308, -2.758817>,
      < -3.991754, -1.232821, -2.758817>,
      < -3.912669, -1.153747, -2.787150>
    }
    triangle {
      < -3.902732, -1.341308, -2.758817>,
      < -3.912669, -1.153747, -2.787150>,
      < -3.809741, -1.279182, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.809741, -1.279182, -2.787150>,
      < -3.912669, -1.153747, -2.787150>,
      < -3.836617, -1.077703, -2.764967>
    }
    triangle {
      < -3.809741, -1.279182, -2.787150>,
      < -3.836617, -1.077703, -2.764967>,
      < -3.720314, -1.219437, -2.764967>
    }
    triangle {
      < -3.720314, -1.219437, -2.764967>,
      < -3.836617, -1.077703, -2.764967>,
      < -3.756376, -0.997473, -2.700042>
    }
    triangle {
      < -3.720314, -1.219437, -2.764967>,
      < -3.756376, -0.997473, -2.700042>,
      < -3.625963, -1.156403, -2.700042>
    }
    triangle {
      < -3.625963, -1.156403, -2.700042>,
      < -3.756376, -0.997473, -2.700042>,
      < -3.739863, -0.980962, -2.486032>
    }
    triangle {
      < -3.625963, -1.156403, -2.700042>,
      < -3.739863, -0.980962, -2.486032>,
      < -3.606545, -1.143430, -2.486032>
    }
    triangle {
      < -3.606545, -1.143430, -2.486032>,
      < -3.739863, -0.980962, -2.486032>,
      < -3.756376, -0.997473, -2.272216>
    }
    triangle {
      < -3.606545, -1.143430, -2.486032>,
      < -3.756376, -0.997473, -2.272216>,
      < -3.625963, -1.156403, -2.272216>
    }
    triangle {
      < -3.625963, -1.156403, -2.272216>,
      < -3.756376, -0.997473, -2.272216>,
      < -3.836617, -1.077703, -2.207291>
    }
    triangle {
      < -3.625963, -1.156403, -2.272216>,
      < -3.836617, -1.077703, -2.207291>,
      < -3.720314, -1.219437, -2.207291>
    }
    triangle {
      < -3.720314, -1.219437, -2.207291>,
      < -3.836617, -1.077703, -2.207291>,
      < -3.912669, -1.153747, -2.185108>
    }
    triangle {
      < -3.720314, -1.219437, -2.207291>,
      < -3.912669, -1.153747, -2.185108>,
      < -3.809741, -1.279182, -2.185108>
    }
    triangle {
      < -3.809741, -1.279182, -2.185108>,
      < -3.912669, -1.153747, -2.185108>,
      < -3.991754, -1.232821, -2.213441>
    }
    triangle {
      < -3.809741, -1.279182, -2.185108>,
      < -3.991754, -1.232821, -2.213441>,
      < -3.902732, -1.341308, -2.213441>
    }
    triangle {
      < -3.902732, -1.341308, -2.213441>,
      < -3.991754, -1.232821, -2.213441>,
      < -4.064518, -1.305575, -2.267810>
    }
    triangle {
      < -3.902732, -1.341308, -2.213441>,
      < -4.064518, -1.305575, -2.267810>,
      < -3.988291, -1.398469, -2.267810>
    }
    triangle {
      < -3.988291, -1.398469, -2.267810>,
      < -4.064518, -1.305575, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.091434, -1.332487, -2.704390>,
      < -4.178551, -1.260982, -2.704390>,
      < -4.157403, -1.229336, -2.704448>
    }
    triangle {
      < -4.091434, -1.332487, -2.704390>,
      < -4.157403, -1.229336, -2.704448>,
      < -4.064518, -1.305575, -2.704448>
    }
    triangle {
      < -4.064518, -1.305575, -2.704448>,
      < -4.157403, -1.229336, -2.704448>,
      < -4.100230, -1.143784, -2.758817>
    }
    triangle {
      < -4.064518, -1.305575, -2.704448>,
      < -4.100230, -1.143784, -2.758817>,
      < -3.991754, -1.232821, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -3.991754, -1.232821, -2.758817>,
      < -4.100230, -1.143784, -2.758817>,
      < -4.038092, -1.050802, -2.787150>
    }
    triangle {
      < -3.991754, -1.232821, -2.758817>,
      < -4.038092, -1.050802, -2.787150>,
      < -3.912669, -1.153747, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -3.912669, -1.153747, -2.787150>,
      < -4.038092, -1.050802, -2.787150>,
      < -3.978335, -0.961382, -2.764967>
    }
    triangle {
      < -3.912669, -1.153747, -2.787150>,
      < -3.978335, -0.961382, -2.764967>,
      < -3.836617, -1.077703, -2.764967>
    }
    triangle {
      < -3.836617, -1.077703, -2.764967>,
      < -3.978335, -0.961382, -2.764967>,
      < -3.915288, -0.867040, -2.700042>
    }
    triangle {
      < -3.836617, -1.077703, -2.764967>,
      < -3.915288, -0.867040, -2.700042>,
      < -3.756376, -0.997473, -2.700042>
    }
    triangle {
      < -3.756376, -0.997473, -2.700042>,
      < -3.915288, -0.867040, -2.700042>,
      < -3.902312, -0.847624, -2.486032>
    }
    triangle {
      < -3.756376, -0.997473, -2.700042>,
      < -3.902312, -0.847624, -2.486032>,
      < -3.739863, -0.980962, -2.486032>
    }
    triangle {
      < -3.739863, -0.980962, -2.486032>,
      < -3.902312, -0.847624, -2.486032>,
      < -3.915288, -0.867040, -2.272216>
    }
    triangle {
      < -3.739863, -0.980962, -2.486032>,
      < -3.915288, -0.867040, -2.272216>,
      < -3.756376, -0.997473, -2.272216>
    }
    triangle {
      < -3.756376, -0.997473, -2.272216>,
      < -3.915288, -0.867040, -2.272216>,
      < -3.978335, -0.961382, -2.207291>
    }
    triangle {
      < -3.756376, -0.997473, -2.272216>,
      < -3.978335, -0.961382, -2.207291>,
      < -3.836617, -1.077703, -2.207291>
    }
    triangle {
      < -3.836617, -1.077703, -2.207291>,
      < -3.978335, -0.961382, -2.207291>,
      < -4.038092, -1.050802, -2.185108>
    }
    triangle {
      < -3.836617, -1.077703, -2.207291>,
      < -4.038092, -1.050802, -2.185108>,
      < -3.912669, -1.153747, -2.185108>
    }
    triangle {
      < -3.912669, -1.153747, -2.185108>,
      < -4.038092, -1.050802, -2.185108>,
      < -4.100230, -1.143784, -2.213441>
    }
    triangle {
      < -3.912669, -1.153747, -2.185108>,
      < -4.100230, -1.143784, -2.213441>,
      < -3.991754, -1.232821, -2.213441>
    }
    triangle {
      < -3.991754, -1.232821, -2.213441>,
      < -4.100230, -1.143784, -2.213441>,
      < -4.157403, -1.229336, -2.267810>
    }
    triangle {
      < -3.991754, -1.232821, -2.213441>,
      < -4.157403, -1.229336, -2.267810>,
      < -4.064518, -1.305575, -2.267810>
    }
    triangle {
      < -4.064518, -1.305575, -2.267810>,
      < -4.157403, -1.229336, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.178551, -1.260982, -2.704390>,
      < -4.277944, -1.207846, -2.704390>,
      < -4.263376, -1.172683, -2.704448>
    }
    triangle {
      < -4.178551, -1.260982, -2.704390>,
      < -4.263376, -1.172683, -2.704448>,
      < -4.157403, -1.229336, -2.704448>
    }
    triangle {
      < -4.157403, -1.229336, -2.704448>,
      < -4.263376, -1.172683, -2.704448>,
      < -4.223992, -1.077621, -2.758817>
    }
    triangle {
      < -4.157403, -1.229336, -2.704448>,
      < -4.223992, -1.077621, -2.758817>,
      < -4.100230, -1.143784, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.100230, -1.143784, -2.758817>,
      < -4.223992, -1.077621, -2.758817>,
      < -4.181187, -0.974301, -2.787150>
    }
    triangle {
      < -4.100230, -1.143784, -2.758817>,
      < -4.181187, -0.974301, -2.787150>,
      < -4.038092, -1.050802, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.038092, -1.050802, -2.787150>,
      < -4.181187, -0.974301, -2.787150>,
      < -4.140024, -0.874944, -2.764967>
    }
    triangle {
      < -4.038092, -1.050802, -2.787150>,
      < -4.140024, -0.874944, -2.764967>,
      < -3.978335, -0.961382, -2.764967>
    }
    triangle {
      < -3.978335, -0.961382, -2.764967>,
      < -4.140024, -0.874944, -2.764967>,
      < -4.096592, -0.770114, -2.700042>
    }
    triangle {
      < -3.978335, -0.961382, -2.764967>,
      < -4.096592, -0.770114, -2.700042>,
      < -3.915288, -0.867040, -2.700042>
    }
    triangle {
      < -3.915288, -0.867040, -2.700042>,
      < -4.096592, -0.770114, -2.700042>,
      < -4.087654, -0.748540, -2.486032>
    }
    triangle {
      < -3.915288, -0.867040, -2.700042>,
      < -4.087654, -0.748540, -2.486032>,
      < -3.902312, -0.847624, -2.486032>
    }
    triangle {
      < -3.902312, -0.847624, -2.486032>,
      < -4.087654, -0.748540, -2.486032>,
      < -4.096592, -0.770114, -2.272216>
    }
    triangle {
      < -3.902312, -0.847624, -2.486032>,
      < -4.096592, -0.770114, -2.272216>,
      < -3.915288, -0.867040, -2.272216>
    }
    triangle {
      < -3.915288, -0.867040, -2.272216>,
      < -4.096592, -0.770114, -2.272216>,
      < -4.140024, -0.874944, -2.207291>
    }
    triangle {
      < -3.915288, -0.867040, -2.272216>,
      < -4.140024, -0.874944, -2.207291>,
      < -3.978335, -0.961382, -2.207291>
    }
    triangle {
      < -3.978335, -0.961382, -2.207291>,
      < -4.140024, -0.874944, -2.207291>,
      < -4.181187, -0.974301, -2.185108>
    }
    triangle {
      < -3.978335, -0.961382, -2.207291>,
      < -4.181187, -0.974301, -2.185108>,
      < -4.038092, -1.050802, -2.185108>
    }
    triangle {
      < -4.038092, -1.050802, -2.185108>,
      < -4.181187, -0.974301, -2.185108>,
      < -4.223992, -1.077621, -2.213441>
    }
    triangle {
      < -4.038092, -1.050802, -2.185108>,
      < -4.223992, -1.077621, -2.213441>,
      < -4.100230, -1.143784, -2.213441>
    }
    triangle {
      < -4.100230, -1.143784, -2.213441>,
      < -4.223992, -1.077621, -2.213441>,
      < -4.263376, -1.172683, -2.267810>
    }
    triangle {
      < -4.100230, -1.143784, -2.213441>,
      < -4.263376, -1.172683, -2.267810>,
      < -4.157403, -1.229336, -2.267810>
    }
    triangle {
      < -4.157403, -1.229336, -2.267810>,
      < -4.263376, -1.172683, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.277944, -1.207846, -2.704390>,
      < -4.385793, -1.175122, -2.704390>,
      < -4.378364, -1.137792, -2.704448>
    }
    triangle {
      < -4.277944, -1.207846, -2.704390>,
      < -4.378364, -1.137792, -2.704448>,
      < -4.263376, -1.172683, -2.704448>
    }
    triangle {
      < -4.263376, -1.172683, -2.704448>,
      < -4.378364, -1.137792, -2.704448>,
      < -4.358283, -1.036873, -2.758817>
    }
    triangle {
      < -4.263376, -1.172683, -2.704448>,
      < -4.358283, -1.036873, -2.758817>,
      < -4.223992, -1.077621, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.223992, -1.077621, -2.758817>,
      < -4.358283, -1.036873, -2.758817>,
      < -4.336457, -0.927189, -2.787150>
    }
    triangle {
      < -4.223992, -1.077621, -2.758817>,
      < -4.336457, -0.927189, -2.787150>,
      < -4.181187, -0.974301, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.181187, -0.974301, -2.787150>,
      < -4.336457, -0.927189, -2.787150>,
      < -4.315467, -0.821709, -2.764967>
    }
    triangle {
      < -4.181187, -0.974301, -2.787150>,
      < -4.315467, -0.821709, -2.764967>,
      < -4.140024, -0.874944, -2.764967>
    }
    triangle {
      < -4.140024, -0.874944, -2.764967>,
      < -4.315467, -0.821709, -2.764967>,
      < -4.293321, -0.710421, -2.700042>
    }
    triangle {
      < -4.140024, -0.874944, -2.764967>,
      < -4.293321, -0.710421, -2.700042>,
      < -4.096592, -0.770114, -2.700042>
    }
    triangle {
      < -4.096592, -0.770114, -2.700042>,
      < -4.293321, -0.710421, -2.700042>,
      < -4.288765, -0.687518, -2.486032>
    }
    triangle {
      < -4.096592, -0.770114, -2.700042>,
      < -4.288765, -0.687518, -2.486032>,
      < -4.087654, -0.748540, -2.486032>
    }
    triangle {
      < -4.087654, -0.748540, -2.486032>,
      < -4.288765, -0.687518, -2.486032>,
      < -4.293321, -0.710421, -2.272216>
    }
    triangle {
      < -4.087654, -0.748540, -2.486032>,
      < -4.293321, -0.710421, -2.272216>,
      < -4.096592, -0.770114, -2.272216>
    }
    triangle {
      < -4.096592, -0.770114, -2.272216>,
      < -4.293321, -0.710421, -2.272216>,
      < -4.315467, -0.821709, -2.207291>
    }
    triangle {
      < -4.096592, -0.770114, -2.272216>,
      < -4.315467, -0.821709, -2.207291>,
      < -4.140024, -0.874944, -2.207291>
    }
    triangle {
      < -4.140024, -0.874944, -2.207291>,
      < -4.315467, -0.821709, -2.207291>,
      < -4.336457, -0.927189, -2.185108>
    }
    triangle {
      < -4.140024, -0.874944, -2.207291>,
      < -4.336457, -0.927189, -2.185108>,
      < -4.181187, -0.974301, -2.185108>
    }
    triangle {
      < -4.181187, -0.974301, -2.185108>,
      < -4.336457, -0.927189, -2.185108>,
      < -4.358283, -1.036873, -2.213441>
    }
    triangle {
      < -4.181187, -0.974301, -2.185108>,
      < -4.358283, -1.036873, -2.213441>,
      < -4.223992, -1.077621, -2.213441>
    }
    triangle {
      < -4.223992, -1.077621, -2.213441>,
      < -4.358283, -1.036873, -2.213441>,
      < -4.378364, -1.137792, -2.267810>
    }
    triangle {
      < -4.223992, -1.077621, -2.213441>,
      < -4.378364, -1.137792, -2.267810>,
      < -4.263376, -1.172683, -2.267810>
    }
    triangle {
      < -4.263376, -1.172683, -2.267810>,
      < -4.378364, -1.137792, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.385793, -1.175122, -2.704390>,
      < -4.497954, -1.164066, -2.704390>,
      < -4.497952, -1.126004, -2.704448>
    }
    triangle {
      < -4.385793, -1.175122, -2.704390>,
      < -4.497952, -1.126004, -2.704448>,
      < -4.378364, -1.137792, -2.704448>
    }
    triangle {
      < -4.378364, -1.137792, -2.704448>,
      < -4.497952, -1.126004, -2.704448>,
      < -4.497943, -1.023107, -2.758817>
    }
    triangle {
      < -4.378364, -1.137792, -2.704448>,
      < -4.497943, -1.023107, -2.758817>,
      < -4.358283, -1.036873, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.358283, -1.036873, -2.758817>,
      < -4.497943, -1.023107, -2.758817>,
      < -4.497935, -0.911271, -2.787150>
    }
    triangle {
      < -4.358283, -1.036873, -2.758817>,
      < -4.497935, -0.911271, -2.787150>,
      < -4.336457, -0.927189, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.336457, -0.927189, -2.787150>,
      < -4.497935, -0.911271, -2.787150>,
      < -4.497925, -0.803724, -2.764967>
    }
    triangle {
      < -4.336457, -0.927189, -2.787150>,
      < -4.497925, -0.803724, -2.764967>,
      < -4.315467, -0.821709, -2.764967>
    }
    triangle {
      < -4.315467, -0.821709, -2.764967>,
      < -4.497925, -0.803724, -2.764967>,
      < -4.497918, -0.690254, -2.700042>
    }
    triangle {
      < -4.315467, -0.821709, -2.764967>,
      < -4.497918, -0.690254, -2.700042>,
      < -4.293321, -0.710421, -2.700042>
    }
    triangle {
      < -4.293321, -0.710421, -2.700042>,
      < -4.497918, -0.690254, -2.700042>,
      < -4.497915, -0.666902, -2.486032>
    }
    triangle {
      < -4.293321, -0.710421, -2.700042>,
      < -4.497915, -0.666902, -2.486032>,
      < -4.288765, -0.687518, -2.486032>
    }
    triangle {
      < -4.288765, -0.687518, -2.486032>,
      < -4.497915, -0.666902, -2.486032>,
      < -4.497918, -0.690254, -2.272216>
    }
    triangle {
      < -4.288765, -0.687518, -2.486032>,
      < -4.497918, -0.690254, -2.272216>,
      < -4.293321, -0.710421, -2.272216>
    }
    triangle {
      < -4.293321, -0.710421, -2.272216>,
      < -4.497918, -0.690254, -2.272216>,
      < -4.497925, -0.803724, -2.207291>
    }
    triangle {
      < -4.293321, -0.710421, -2.272216>,
      < -4.497925, -0.803724, -2.207291>,
      < -4.315467, -0.821709, -2.207291>
    }
    triangle {
      < -4.315467, -0.821709, -2.207291>,
      < -4.497925, -0.803724, -2.207291>,
      < -4.497935, -0.911271, -2.185108>
    }
    triangle {
      < -4.315467, -0.821709, -2.207291>,
      < -4.497935, -0.911271, -2.185108>,
      < -4.336457, -0.927189, -2.185108>
    }
    triangle {
      < -4.336457, -0.927189, -2.185108>,
      < -4.497935, -0.911271, -2.185108>,
      < -4.497943, -1.023107, -2.213441>
    }
    triangle {
      < -4.336457, -0.927189, -2.185108>,
      < -4.497943, -1.023107, -2.213441>,
      < -4.358283, -1.036873, -2.213441>
    }
    triangle {
      < -4.358283, -1.036873, -2.213441>,
      < -4.497943, -1.023107, -2.213441>,
      < -4.497952, -1.126004, -2.267810>
    }
    triangle {
      < -4.358283, -1.036873, -2.213441>,
      < -4.497952, -1.126004, -2.267810>,
      < -4.378364, -1.137792, -2.267810>
    }
    triangle {
      < -4.378364, -1.137792, -2.267810>,
      < -4.497952, -1.126004, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.497954, -1.164066, -2.704390>,
      < -4.610118, -1.175104, -2.704390>,
      < -4.617540, -1.137773, -2.704448>
    }
    triangle {
      < -4.497954, -1.164066, -2.704390>,
      < -4.617540, -1.137773, -2.704448>,
      < -4.497952, -1.126004, -2.704448>
    }
    triangle {
      < -4.497952, -1.126004, -2.704448>,
      < -4.617540, -1.137773, -2.704448>,
      < -4.637606, -1.036851, -2.758817>
    }
    triangle {
      < -4.497952, -1.126004, -2.704448>,
      < -4.637606, -1.036851, -2.758817>,
      < -4.497943, -1.023107, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.497943, -1.023107, -2.758817>,
      < -4.637606, -1.036851, -2.758817>,
      < -4.659415, -0.927164, -2.787150>
    }
    triangle {
      < -4.497943, -1.023107, -2.758817>,
      < -4.659415, -0.927164, -2.787150>,
      < -4.497935, -0.911271, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.497935, -0.911271, -2.787150>,
      < -4.659415, -0.927164, -2.787150>,
      < -4.680388, -0.821680, -2.764967>
    }
    triangle {
      < -4.497935, -0.911271, -2.787150>,
      < -4.680388, -0.821680, -2.764967>,
      < -4.497925, -0.803724, -2.764967>
    }
    triangle {
      < -4.497925, -0.803724, -2.764967>,
      < -4.680388, -0.821680, -2.764967>,
      < -4.702516, -0.710389, -2.700042>
    }
    triangle {
      < -4.497925, -0.803724, -2.764967>,
      < -4.702516, -0.710389, -2.700042>,
      < -4.497918, -0.690254, -2.700042>
    }
    triangle {
      < -4.497918, -0.690254, -2.700042>,
      < -4.702516, -0.710389, -2.700042>,
      < -4.707070, -0.687485, -2.486032>
    }
    triangle {
      < -4.497918, -0.690254, -2.700042>,
      < -4.707070, -0.687485, -2.486032>,
      < -4.497915, -0.666902, -2.486032>
    }
    triangle {
      < -4.497915, -0.666902, -2.486032>,
      < -4.707070, -0.687485, -2.486032>,
      < -4.702516, -0.710389, -2.272216>
    }
    triangle {
      < -4.497915, -0.666902, -2.486032>,
      < -4.702516, -0.710389, -2.272216>,
      < -4.497918, -0.690254, -2.272216>
    }
    triangle {
      < -4.497918, -0.690254, -2.272216>,
      < -4.702516, -0.710389, -2.272216>,
      < -4.680388, -0.821680, -2.207291>
    }
    triangle {
      < -4.497918, -0.690254, -2.272216>,
      < -4.680388, -0.821680, -2.207291>,
      < -4.497925, -0.803724, -2.207291>
    }
    triangle {
      < -4.497925, -0.803724, -2.207291>,
      < -4.680388, -0.821680, -2.207291>,
      < -4.659415, -0.927164, -2.185108>
    }
    triangle {
      < -4.497925, -0.803724, -2.207291>,
      < -4.659415, -0.927164, -2.185108>,
      < -4.497935, -0.911271, -2.185108>
    }
    triangle {
      < -4.497935, -0.911271, -2.185108>,
      < -4.659415, -0.927164, -2.185108>,
      < -4.637606, -1.036851, -2.213441>
    }
    triangle {
      < -4.497935, -0.911271, -2.185108>,
      < -4.637606, -1.036851, -2.213441>,
      < -4.497943, -1.023107, -2.213441>
    }
    triangle {
      < -4.497943, -1.023107, -2.213441>,
      < -4.637606, -1.036851, -2.213441>,
      < -4.617540, -1.137773, -2.267810>
    }
    triangle {
      < -4.497943, -1.023107, -2.213441>,
      < -4.617540, -1.137773, -2.267810>,
      < -4.497952, -1.126004, -2.267810>
    }
    triangle {
      < -4.497952, -1.126004, -2.267810>,
      < -4.617540, -1.137773, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.610118, -1.175104, -2.704390>,
      < -4.717972, -1.207811, -2.704390>,
      < -4.732534, -1.172645, -2.704448>
    }
    triangle {
      < -4.610118, -1.175104, -2.704390>,
      < -4.732534, -1.172645, -2.704448>,
      < -4.617540, -1.137773, -2.704448>
    }
    triangle {
      < -4.617540, -1.137773, -2.704448>,
      < -4.732534, -1.172645, -2.704448>,
      < -4.771904, -1.077578, -2.758817>
    }
    triangle {
      < -4.617540, -1.137773, -2.704448>,
      < -4.771904, -1.077578, -2.758817>,
      < -4.637606, -1.036851, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.637606, -1.036851, -2.758817>,
      < -4.771904, -1.077578, -2.758817>,
      < -4.814693, -0.974252, -2.787150>
    }
    triangle {
      < -4.637606, -1.036851, -2.758817>,
      < -4.814693, -0.974252, -2.787150>,
      < -4.659415, -0.927164, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.659415, -0.927164, -2.787150>,
      < -4.814693, -0.974252, -2.787150>,
      < -4.855841, -0.874888, -2.764967>
    }
    triangle {
      < -4.659415, -0.927164, -2.787150>,
      < -4.855841, -0.874888, -2.764967>,
      < -4.680388, -0.821680, -2.764967>
    }
    triangle {
      < -4.680388, -0.821680, -2.764967>,
      < -4.855841, -0.874888, -2.764967>,
      < -4.899255, -0.770051, -2.700042>
    }
    triangle {
      < -4.680388, -0.821680, -2.764967>,
      < -4.899255, -0.770051, -2.700042>,
      < -4.702516, -0.710389, -2.700042>
    }
    triangle {
      < -4.702516, -0.710389, -2.700042>,
      < -4.899255, -0.770051, -2.700042>,
      < -4.908190, -0.748475, -2.486032>
    }
    triangle {
      < -4.702516, -0.710389, -2.700042>,
      < -4.908190, -0.748475, -2.486032>,
      < -4.707070, -0.687485, -2.486032>
    }
    triangle {
      < -4.707070, -0.687485, -2.486032>,
      < -4.908190, -0.748475, -2.486032>,
      < -4.899255, -0.770051, -2.272216>
    }
    triangle {
      < -4.707070, -0.687485, -2.486032>,
      < -4.899255, -0.770051, -2.272216>,
      < -4.702516, -0.710389, -2.272216>
    }
    triangle {
      < -4.702516, -0.710389, -2.272216>,
      < -4.899255, -0.770051, -2.272216>,
      < -4.855841, -0.874888, -2.207291>
    }
    triangle {
      < -4.702516, -0.710389, -2.272216>,
      < -4.855841, -0.874888, -2.207291>,
      < -4.680388, -0.821680, -2.207291>
    }
    triangle {
      < -4.680388, -0.821680, -2.207291>,
      < -4.855841, -0.874888, -2.207291>,
      < -4.814693, -0.974252, -2.185108>
    }
    triangle {
      < -4.680388, -0.821680, -2.207291>,
      < -4.814693, -0.974252, -2.185108>,
      < -4.659415, -0.927164, -2.185108>
    }
    triangle {
      < -4.659415, -0.927164, -2.185108>,
      < -4.814693, -0.974252, -2.185108>,
      < -4.771904, -1.077578, -2.213441>
    }
    triangle {
      < -4.659415, -0.927164, -2.185108>,
      < -4.771904, -1.077578, -2.213441>,
      < -4.637606, -1.036851, -2.213441>
    }
    triangle {
      < -4.637606, -1.036851, -2.213441>,
      < -4.771904, -1.077578, -2.213441>,
      < -4.732534, -1.172645, -2.267810>
    }
    triangle {
      < -4.637606, -1.036851, -2.213441>,
      < -4.732534, -1.172645, -2.267810>,
      < -4.617540, -1.137773, -2.267810>
    }
    triangle {
      < -4.617540, -1.137773, -2.267810>,
      < -4.732534, -1.172645, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.717972, -1.207811, -2.704390>,
      < -4.817373, -1.260931, -2.704390>,
      < -4.838517, -1.229283, -2.704448>
    }
    triangle {
      < -4.717972, -1.207811, -2.704390>,
      < -4.838517, -1.229283, -2.704448>,
      < -4.732534, -1.172645, -2.704448>
    }
    triangle {
      < -4.732534, -1.172645, -2.704448>,
      < -4.838517, -1.229283, -2.704448>,
      < -4.895676, -1.143721, -2.758817>
    }
    triangle {
      < -4.732534, -1.172645, -2.704448>,
      < -4.895676, -1.143721, -2.758817>,
      < -4.771904, -1.077578, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.771904, -1.077578, -2.758817>,
      < -4.895676, -1.143721, -2.758817>,
      < -4.957800, -1.050729, -2.787150>
    }
    triangle {
      < -4.771904, -1.077578, -2.758817>,
      < -4.957800, -1.050729, -2.787150>,
      < -4.814693, -0.974252, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.814693, -0.974252, -2.787150>,
      < -4.957800, -1.050729, -2.787150>,
      < -5.017542, -0.961300, -2.764967>
    }
    triangle {
      < -4.814693, -0.974252, -2.787150>,
      < -5.017542, -0.961300, -2.764967>,
      < -4.855841, -0.874888, -2.764967>
    }
    triangle {
      < -4.855841, -0.874888, -2.764967>,
      < -5.017542, -0.961300, -2.764967>,
      < -5.080574, -0.866948, -2.700042>
    }
    triangle {
      < -4.855841, -0.874888, -2.764967>,
      < -5.080574, -0.866948, -2.700042>,
      < -4.899255, -0.770051, -2.700042>
    }
    triangle {
      < -4.899255, -0.770051, -2.700042>,
      < -5.080574, -0.866948, -2.700042>,
      < -5.093546, -0.847530, -2.486032>
    }
    triangle {
      < -4.899255, -0.770051, -2.700042>,
      < -5.093546, -0.847530, -2.486032>,
      < -4.908190, -0.748475, -2.486032>
    }
    triangle {
      < -4.908190, -0.748475, -2.486032>,
      < -5.093546, -0.847530, -2.486032>,
      < -5.080574, -0.866948, -2.272216>
    }
    triangle {
      < -4.908190, -0.748475, -2.486032>,
      < -5.080574, -0.866948, -2.272216>,
      < -4.899255, -0.770051, -2.272216>
    }
    triangle {
      < -4.899255, -0.770051, -2.272216>,
      < -5.080574, -0.866948, -2.272216>,
      < -5.017542, -0.961300, -2.207291>
    }
    triangle {
      < -4.899255, -0.770051, -2.272216>,
      < -5.017542, -0.961300, -2.207291>,
      < -4.855841, -0.874888, -2.207291>
    }
    triangle {
      < -4.855841, -0.874888, -2.207291>,
      < -5.017542, -0.961300, -2.207291>,
      < -4.957800, -1.050729, -2.185108>
    }
    triangle {
      < -4.855841, -0.874888, -2.207291>,
      < -4.957800, -1.050729, -2.185108>,
      < -4.814693, -0.974252, -2.185108>
    }
    triangle {
      < -4.814693, -0.974252, -2.185108>,
      < -4.957800, -1.050729, -2.185108>,
      < -4.895676, -1.143721, -2.213441>
    }
    triangle {
      < -4.814693, -0.974252, -2.185108>,
      < -4.895676, -1.143721, -2.213441>,
      < -4.771904, -1.077578, -2.213441>
    }
    triangle {
      < -4.771904, -1.077578, -2.213441>,
      < -4.895676, -1.143721, -2.213441>,
      < -4.838517, -1.229283, -2.267810>
    }
    triangle {
      < -4.771904, -1.077578, -2.213441>,
      < -4.838517, -1.229283, -2.267810>,
      < -4.732534, -1.172645, -2.267810>
    }
    triangle {
      < -4.732534, -1.172645, -2.267810>,
      < -4.838517, -1.229283, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.817373, -1.260931, -2.704390>,
      < -4.904502, -1.332422, -2.704390>,
      < -4.931413, -1.305506, -2.704448>
    }
    triangle {
      < -4.817373, -1.260931, -2.704390>,
      < -4.931413, -1.305506, -2.704448>,
      < -4.838517, -1.229283, -2.704448>
    }
    triangle {
      < -4.838517, -1.229283, -2.704448>,
      < -4.931413, -1.305506, -2.704448>,
      < -5.004166, -1.232740, -2.758817>
    }
    triangle {
      < -4.838517, -1.229283, -2.704448>,
      < -5.004166, -1.232740, -2.758817>,
      < -4.895676, -1.143721, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -4.895676, -1.143721, -2.758817>,
      < -5.004166, -1.232740, -2.758817>,
      < -5.083238, -1.153654, -2.787150>
    }
    triangle {
      < -4.895676, -1.143721, -2.758817>,
      < -5.083238, -1.153654, -2.787150>,
      < -4.957800, -1.050729, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -4.957800, -1.050729, -2.787150>,
      < -5.083238, -1.153654, -2.787150>,
      < -5.159279, -1.077599, -2.764967>
    }
    triangle {
      < -4.957800, -1.050729, -2.787150>,
      < -5.159279, -1.077599, -2.764967>,
      < -5.017542, -0.961300, -2.764967>
    }
    triangle {
      < -5.017542, -0.961300, -2.764967>,
      < -5.159279, -1.077599, -2.764967>,
      < -5.239507, -0.997356, -2.700042>
    }
    triangle {
      < -5.017542, -0.961300, -2.764967>,
      < -5.239507, -0.997356, -2.700042>,
      < -5.080574, -0.866948, -2.700042>
    }
    triangle {
      < -5.080574, -0.866948, -2.700042>,
      < -5.239507, -0.997356, -2.700042>,
      < -5.256018, -0.980842, -2.486032>
    }
    triangle {
      < -5.080574, -0.866948, -2.700042>,
      < -5.256018, -0.980842, -2.486032>,
      < -5.093546, -0.847530, -2.486032>
    }
    triangle {
      < -5.093546, -0.847530, -2.486032>,
      < -5.256018, -0.980842, -2.486032>,
      < -5.239507, -0.997356, -2.272216>
    }
    triangle {
      < -5.093546, -0.847530, -2.486032>,
      < -5.239507, -0.997356, -2.272216>,
      < -5.080574, -0.866948, -2.272216>
    }
    triangle {
      < -5.080574, -0.866948, -2.272216>,
      < -5.239507, -0.997356, -2.272216>,
      < -5.159279, -1.077599, -2.207291>
    }
    triangle {
      < -5.080574, -0.866948, -2.272216>,
      < -5.159279, -1.077599, -2.207291>,
      < -5.017542, -0.961300, -2.207291>
    }
    triangle {
      < -5.017542, -0.961300, -2.207291>,
      < -5.159279, -1.077599, -2.207291>,
      < -5.083238, -1.153654, -2.185108>
    }
    triangle {
      < -5.017542, -0.961300, -2.207291>,
      < -5.083238, -1.153654, -2.185108>,
      < -4.957800, -1.050729, -2.185108>
    }
    triangle {
      < -4.957800, -1.050729, -2.185108>,
      < -5.083238, -1.153654, -2.185108>,
      < -5.004166, -1.232740, -2.213441>
    }
    triangle {
      < -4.957800, -1.050729, -2.185108>,
      < -5.004166, -1.232740, -2.213441>,
      < -4.895676, -1.143721, -2.213441>
    }
    triangle {
      < -4.895676, -1.143721, -2.213441>,
      < -5.004166, -1.232740, -2.213441>,
      < -4.931413, -1.305506, -2.267810>
    }
    triangle {
      < -4.895676, -1.143721, -2.213441>,
      < -4.931413, -1.305506, -2.267810>,
      < -4.838517, -1.229283, -2.267810>
    }
    triangle {
      < -4.838517, -1.229283, -2.267810>,
      < -4.931413, -1.305506, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.904502, -1.332422, -2.704390>,
      < -4.976010, -1.419538, -2.704390>,
      < -5.007655, -1.398389, -2.704448>
    }
    triangle {
      < -4.904502, -1.332422, -2.704390>,
      < -5.007655, -1.398389, -2.704448>,
      < -4.931413, -1.305506, -2.704448>
    }
    triangle {
      < -4.931413, -1.305506, -2.704448>,
      < -5.007655, -1.398389, -2.704448>,
      < -5.093205, -1.341214, -2.758817>
    }
    triangle {
      < -4.931413, -1.305506, -2.704448>,
      < -5.093205, -1.341214, -2.758817>,
      < -5.004166, -1.232740, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.004166, -1.232740, -2.758817>,
      < -5.093205, -1.341214, -2.758817>,
      < -5.186187, -1.279073, -2.787150>
    }
    triangle {
      < -5.004166, -1.232740, -2.758817>,
      < -5.186187, -1.279073, -2.787150>,
      < -5.083238, -1.153654, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.083238, -1.153654, -2.787150>,
      < -5.186187, -1.279073, -2.787150>,
      < -5.275604, -1.219314, -2.764967>
    }
    triangle {
      < -5.083238, -1.153654, -2.787150>,
      < -5.275604, -1.219314, -2.764967>,
      < -5.159279, -1.077599, -2.764967>
    }
    triangle {
      < -5.159279, -1.077599, -2.764967>,
      < -5.275604, -1.219314, -2.764967>,
      < -5.369944, -1.156265, -2.700042>
    }
    triangle {
      < -5.159279, -1.077599, -2.764967>,
      < -5.369944, -1.156265, -2.700042>,
      < -5.239507, -0.997356, -2.700042>
    }
    triangle {
      < -5.239507, -0.997356, -2.700042>,
      < -5.369944, -1.156265, -2.700042>,
      < -5.389360, -1.143289, -2.486032>
    }
    triangle {
      < -5.239507, -0.997356, -2.700042>,
      < -5.389360, -1.143289, -2.486032>,
      < -5.256018, -0.980842, -2.486032>
    }
    triangle {
      < -5.256018, -0.980842, -2.486032>,
      < -5.389360, -1.143289, -2.486032>,
      < -5.369944, -1.156265, -2.272216>
    }
    triangle {
      < -5.256018, -0.980842, -2.486032>,
      < -5.369944, -1.156265, -2.272216>,
      < -5.239507, -0.997356, -2.272216>
    }
    triangle {
      < -5.239507, -0.997356, -2.272216>,
      < -5.369944, -1.156265, -2.272216>,
      < -5.275604, -1.219314, -2.207291>
    }
    triangle {
      < -5.239507, -0.997356, -2.272216>,
      < -5.275604, -1.219314, -2.207291>,
      < -5.159279, -1.077599, -2.207291>
    }
    triangle {
      < -5.159279, -1.077599, -2.207291>,
      < -5.275604, -1.219314, -2.207291>,
      < -5.186187, -1.279073, -2.185108>
    }
    triangle {
      < -5.159279, -1.077599, -2.207291>,
      < -5.186187, -1.279073, -2.185108>,
      < -5.083238, -1.153654, -2.185108>
    }
    triangle {
      < -5.083238, -1.153654, -2.185108>,
      < -5.186187, -1.279073, -2.185108>,
      < -5.093205, -1.341214, -2.213441>
    }
    triangle {
      < -5.083238, -1.153654, -2.185108>,
      < -5.093205, -1.341214, -2.213441>,
      < -5.004166, -1.232740, -2.213441>
    }
    triangle {
      < -5.004166, -1.232740, -2.213441>,
      < -5.093205, -1.341214, -2.213441>,
      < -5.007655, -1.398389, -2.267810>
    }
    triangle {
      < -5.004166, -1.232740, -2.213441>,
      < -5.007655, -1.398389, -2.267810>,
      < -4.931413, -1.305506, -2.267810>
    }
    triangle {
      < -4.931413, -1.305506, -2.267810>,
      < -5.007655, -1.398389, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.976010, -1.419538, -2.704390>,
      < -5.029148, -1.518929, -2.704390>,
      < -5.064312, -1.504360, -2.704448>
    }
    triangle {
      < -4.976010, -1.419538, -2.704390>,
      < -5.064312, -1.504360, -2.704448>,
      < -5.007655, -1.398389, -2.704448>
    }
    triangle {
      < -5.007655, -1.398389, -2.704448>,
      < -5.064312, -1.504360, -2.704448>,
      < -5.159372, -1.464975, -2.758817>
    }
    triangle {
      < -5.007655, -1.398389, -2.704448>,
      < -5.159372, -1.464975, -2.758817>,
      < -5.093205, -1.341214, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.093205, -1.341214, -2.758817>,
      < -5.159372, -1.464975, -2.758817>,
      < -5.262689, -1.422167, -2.787150>
    }
    triangle {
      < -5.093205, -1.341214, -2.758817>,
      < -5.262689, -1.422167, -2.787150>,
      < -5.186187, -1.279073, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.186187, -1.279073, -2.787150>,
      < -5.262689, -1.422167, -2.787150>,
      < -5.362047, -1.381000, -2.764967>
    }
    triangle {
      < -5.186187, -1.279073, -2.787150>,
      < -5.362047, -1.381000, -2.764967>,
      < -5.275604, -1.219314, -2.764967>
    }
    triangle {
      < -5.275604, -1.219314, -2.764967>,
      < -5.362047, -1.381000, -2.764967>,
      < -5.466875, -1.337567, -2.700042>
    }
    triangle {
      < -5.275604, -1.219314, -2.764967>,
      < -5.466875, -1.337567, -2.700042>,
      < -5.369944, -1.156265, -2.700042>
    }
    triangle {
      < -5.369944, -1.156265, -2.700042>,
      < -5.466875, -1.337567, -2.700042>,
      < -5.488449, -1.328627, -2.486032>
    }
    triangle {
      < -5.369944, -1.156265, -2.700042>,
      < -5.488449, -1.328627, -2.486032>,
      < -5.389360, -1.143289, -2.486032>
    }
    triangle {
      < -5.389360, -1.143289, -2.486032>,
      < -5.488449, -1.328627, -2.486032>,
      < -5.466875, -1.337567, -2.272216>
    }
    triangle {
      < -5.389360, -1.143289, -2.486032>,
      < -5.466875, -1.337567, -2.272216>,
      < -5.369944, -1.156265, -2.272216>
    }
    triangle {
      < -5.369944, -1.156265, -2.272216>,
      < -5.466875, -1.337567, -2.272216>,
      < -5.362047, -1.381000, -2.207291>
    }
    triangle {
      < -5.369944, -1.156265, -2.272216>,
      < -5.362047, -1.381000, -2.207291>,
      < -5.275604, -1.219314, -2.207291>
    }
    triangle {
      < -5.275604, -1.219314, -2.207291>,
      < -5.362047, -1.381000, -2.207291>,
      < -5.262689, -1.422167, -2.185108>
    }
    triangle {
      < -5.275604, -1.219314, -2.207291>,
      < -5.262689, -1.422167, -2.185108>,
      < -5.186187, -1.279073, -2.185108>
    }
    triangle {
      < -5.186187, -1.279073, -2.185108>,
      < -5.262689, -1.422167, -2.185108>,
      < -5.159372, -1.464975, -2.213441>
    }
    triangle {
      < -5.186187, -1.279073, -2.185108>,
      < -5.159372, -1.464975, -2.213441>,
      < -5.093205, -1.341214, -2.213441>
    }
    triangle {
      < -5.093205, -1.341214, -2.213441>,
      < -5.159372, -1.464975, -2.213441>,
      < -5.064312, -1.504360, -2.267810>
    }
    triangle {
      < -5.093205, -1.341214, -2.213441>,
      < -5.064312, -1.504360, -2.267810>,
      < -5.007655, -1.398389, -2.267810>
    }
    triangle {
      < -5.007655, -1.398389, -2.267810>,
      < -5.064312, -1.504360, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -5.029148, -1.518929, -2.704390>,
      < -5.061876, -1.626778, -2.704390>,
      < -5.099205, -1.619349, -2.704448>
    }
    triangle {
      < -5.029148, -1.518929, -2.704390>,
      < -5.099205, -1.619349, -2.704448>,
      < -5.064312, -1.504360, -2.704448>
    }
    triangle {
      < -5.064312, -1.504360, -2.704448>,
      < -5.099205, -1.619349, -2.704448>,
      < -5.200123, -1.599264, -2.758817>
    }
    triangle {
      < -5.064312, -1.504360, -2.704448>,
      < -5.200123, -1.599264, -2.758817>,
      < -5.159372, -1.464975, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.159372, -1.464975, -2.758817>,
      < -5.200123, -1.599264, -2.758817>,
      < -5.309807, -1.577435, -2.787150>
    }
    triangle {
      < -5.159372, -1.464975, -2.758817>,
      < -5.309807, -1.577435, -2.787150>,
      < -5.262689, -1.422167, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.262689, -1.422167, -2.787150>,
      < -5.309807, -1.577435, -2.787150>,
      < -5.415286, -1.556443, -2.764967>
    }
    triangle {
      < -5.262689, -1.422167, -2.787150>,
      < -5.415286, -1.556443, -2.764967>,
      < -5.362047, -1.381000, -2.764967>
    }
    triangle {
      < -5.362047, -1.381000, -2.764967>,
      < -5.415286, -1.556443, -2.764967>,
      < -5.526573, -1.534295, -2.700042>
    }
    triangle {
      < -5.362047, -1.381000, -2.764967>,
      < -5.526573, -1.534295, -2.700042>,
      < -5.466875, -1.337567, -2.700042>
    }
    triangle {
      < -5.466875, -1.337567, -2.700042>,
      < -5.526573, -1.534295, -2.700042>,
      < -5.549476, -1.529736, -2.486032>
    }
    triangle {
      < -5.466875, -1.337567, -2.700042>,
      < -5.549476, -1.529736, -2.486032>,
      < -5.488449, -1.328627, -2.486032>
    }
    triangle {
      < -5.488449, -1.328627, -2.486032>,
      < -5.549476, -1.529736, -2.486032>,
      < -5.526573, -1.534295, -2.272216>
    }
    triangle {
      < -5.488449, -1.328627, -2.486032>,
      < -5.526573, -1.534295, -2.272216>,
      < -5.466875, -1.337567, -2.272216>
    }
    triangle {
      < -5.466875, -1.337567, -2.272216>,
      < -5.526573, -1.534295, -2.272216>,
      < -5.415286, -1.556443, -2.207291>
    }
    triangle {
      < -5.466875, -1.337567, -2.272216>,
      < -5.415286, -1.556443, -2.207291>,
      < -5.362047, -1.381000, -2.207291>
    }
    triangle {
      < -5.362047, -1.381000, -2.207291>,
      < -5.415286, -1.556443, -2.207291>,
      < -5.309807, -1.577435, -2.185108>
    }
    triangle {
      < -5.362047, -1.381000, -2.207291>,
      < -5.309807, -1.577435, -2.185108>,
      < -5.262689, -1.422167, -2.185108>
    }
    triangle {
      < -5.262689, -1.422167, -2.185108>,
      < -5.309807, -1.577435, -2.185108>,
      < -5.200123, -1.599264, -2.213441>
    }
    triangle {
      < -5.262689, -1.422167, -2.185108>,
      < -5.200123, -1.599264, -2.213441>,
      < -5.159372, -1.464975, -2.213441>
    }
    triangle {
      < -5.159372, -1.464975, -2.213441>,
      < -5.200123, -1.599264, -2.213441>,
      < -5.099205, -1.619349, -2.267810>
    }
    triangle {
      < -5.159372, -1.464975, -2.213441>,
      < -5.099205, -1.619349, -2.267810>,
      < -5.064312, -1.504360, -2.267810>
    }
    triangle {
      < -5.064312, -1.504360, -2.267810>,
      < -5.099205, -1.619349, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -5.061876, -1.626778, -2.704390>,
      < -5.072934, -1.738939, -2.704390>,
      < -5.110997, -1.738935, -2.704448>
    }
    triangle {
      < -5.061876, -1.626778, -2.704390>,
      < -5.110997, -1.738935, -2.704448>,
      < -5.099205, -1.619349, -2.704448>
    }
    triangle {
      < -5.099205, -1.619349, -2.704448>,
      < -5.110997, -1.738935, -2.704448>,
      < -5.213893, -1.738925, -2.758817>
    }
    triangle {
      < -5.099205, -1.619349, -2.704448>,
      < -5.213893, -1.738925, -2.758817>,
      < -5.200123, -1.599264, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.200123, -1.599264, -2.758817>,
      < -5.213893, -1.738925, -2.758817>,
      < -5.325728, -1.738913, -2.787150>
    }
    triangle {
      < -5.200123, -1.599264, -2.758817>,
      < -5.325728, -1.738913, -2.787150>,
      < -5.309807, -1.577435, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.309807, -1.577435, -2.787150>,
      < -5.325728, -1.738913, -2.787150>,
      < -5.433276, -1.738901, -2.764967>
    }
    triangle {
      < -5.309807, -1.577435, -2.787150>,
      < -5.433276, -1.738901, -2.764967>,
      < -5.415286, -1.556443, -2.764967>
    }
    triangle {
      < -5.415286, -1.556443, -2.764967>,
      < -5.433276, -1.738901, -2.764967>,
      < -5.546746, -1.738889, -2.700042>
    }
    triangle {
      < -5.415286, -1.556443, -2.764967>,
      < -5.546746, -1.738889, -2.700042>,
      < -5.526573, -1.534295, -2.700042>
    }
    triangle {
      < -5.526573, -1.534295, -2.700042>,
      < -5.546746, -1.738889, -2.700042>,
      < -5.570098, -1.738887, -2.486032>
    }
    triangle {
      < -5.526573, -1.534295, -2.700042>,
      < -5.570098, -1.738887, -2.486032>,
      < -5.549476, -1.529736, -2.486032>
    }
    triangle {
      < -5.549476, -1.529736, -2.486032>,
      < -5.570098, -1.738887, -2.486032>,
      < -5.546746, -1.738889, -2.272216>
    }
    triangle {
      < -5.549476, -1.529736, -2.486032>,
      < -5.546746, -1.738889, -2.272216>,
      < -5.526573, -1.534295, -2.272216>
    }
    triangle {
      < -5.526573, -1.534295, -2.272216>,
      < -5.546746, -1.738889, -2.272216>,
      < -5.433276, -1.738901, -2.207291>
    }
    triangle {
      < -5.526573, -1.534295, -2.272216>,
      < -5.433276, -1.738901, -2.207291>,
      < -5.415286, -1.556443, -2.207291>
    }
    triangle {
      < -5.415286, -1.556443, -2.207291>,
      < -5.433276, -1.738901, -2.207291>,
      < -5.325728, -1.738913, -2.185108>
    }
    triangle {
      < -5.415286, -1.556443, -2.207291>,
      < -5.325728, -1.738913, -2.185108>,
      < -5.309807, -1.577435, -2.185108>
    }
    triangle {
      < -5.309807, -1.577435, -2.185108>,
      < -5.325728, -1.738913, -2.185108>,
      < -5.213893, -1.738925, -2.213441>
    }
    triangle {
      < -5.309807, -1.577435, -2.185108>,
      < -5.213893, -1.738925, -2.213441>,
      < -5.200123, -1.599264, -2.213441>
    }
    triangle {
      < -5.200123, -1.599264, -2.213441>,
      < -5.213893, -1.738925, -2.213441>,
      < -5.110997, -1.738935, -2.267810>
    }
    triangle {
      < -5.200123, -1.599264, -2.213441>,
      < -5.110997, -1.738935, -2.267810>,
      < -5.099205, -1.619349, -2.267810>
    }
    triangle {
      < -5.099205, -1.619349, -2.267810>,
      < -5.110997, -1.738935, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -5.072934, -1.738939, -2.704390>,
      < -5.061899, -1.851103, -2.704390>,
      < -5.099230, -1.858524, -2.704448>
    }
    triangle {
      < -5.072934, -1.738939, -2.704390>,
      < -5.099230, -1.858524, -2.704448>,
      < -5.110997, -1.738935, -2.704448>
    }
    triangle {
      < -5.110997, -1.738935, -2.704448>,
      < -5.099230, -1.858524, -2.704448>,
      < -5.200152, -1.878587, -2.758817>
    }
    triangle {
      < -5.110997, -1.738935, -2.704448>,
      < -5.200152, -1.878587, -2.758817>,
      < -5.213893, -1.738925, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.213893, -1.738925, -2.758817>,
      < -5.200152, -1.878587, -2.758817>,
      < -5.309841, -1.900394, -2.787150>
    }
    triangle {
      < -5.213893, -1.738925, -2.758817>,
      < -5.309841, -1.900394, -2.787150>,
      < -5.325728, -1.738913, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.325728, -1.738913, -2.787150>,
      < -5.309841, -1.900394, -2.787150>,
      < -5.415325, -1.921364, -2.764967>
    }
    triangle {
      < -5.325728, -1.738913, -2.787150>,
      < -5.415325, -1.921364, -2.764967>,
      < -5.433276, -1.738901, -2.764967>
    }
    triangle {
      < -5.433276, -1.738901, -2.764967>,
      < -5.415325, -1.921364, -2.764967>,
      < -5.526617, -1.943489, -2.700042>
    }
    triangle {
      < -5.433276, -1.738901, -2.764967>,
      < -5.526617, -1.943489, -2.700042>,
      < -5.546746, -1.738889, -2.700042>
    }
    triangle {
      < -5.546746, -1.738889, -2.700042>,
      < -5.526617, -1.943489, -2.700042>,
      < -5.549521, -1.948042, -2.486032>
    }
    triangle {
      < -5.546746, -1.738889, -2.700042>,
      < -5.549521, -1.948042, -2.486032>,
      < -5.570098, -1.738887, -2.486032>
    }
    triangle {
      < -5.570098, -1.738887, -2.486032>,
      < -5.549521, -1.948042, -2.486032>,
      < -5.526617, -1.943489, -2.272216>
    }
    triangle {
      < -5.570098, -1.738887, -2.486032>,
      < -5.526617, -1.943489, -2.272216>,
      < -5.546746, -1.738889, -2.272216>
    }
    triangle {
      < -5.546746, -1.738889, -2.272216>,
      < -5.526617, -1.943489, -2.272216>,
      < -5.415325, -1.921364, -2.207291>
    }
    triangle {
      < -5.546746, -1.738889, -2.272216>,
      < -5.415325, -1.921364, -2.207291>,
      < -5.433276, -1.738901, -2.207291>
    }
    triangle {
      < -5.433276, -1.738901, -2.207291>,
      < -5.415325, -1.921364, -2.207291>,
      < -5.309841, -1.900394, -2.185108>
    }
    triangle {
      < -5.433276, -1.738901, -2.207291>,
      < -5.309841, -1.900394, -2.185108>,
      < -5.325728, -1.738913, -2.185108>
    }
    triangle {
      < -5.325728, -1.738913, -2.185108>,
      < -5.309841, -1.900394, -2.185108>,
      < -5.200152, -1.878587, -2.213441>
    }
    triangle {
      < -5.325728, -1.738913, -2.185108>,
      < -5.200152, -1.878587, -2.213441>,
      < -5.213893, -1.738925, -2.213441>
    }
    triangle {
      < -5.213893, -1.738925, -2.213441>,
      < -5.200152, -1.878587, -2.213441>,
      < -5.099230, -1.858524, -2.267810>
    }
    triangle {
      < -5.213893, -1.738925, -2.213441>,
      < -5.099230, -1.858524, -2.267810>,
      < -5.110997, -1.738935, -2.267810>
    }
    triangle {
      < -5.110997, -1.738935, -2.267810>,
      < -5.099230, -1.858524, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -5.061899, -1.851103, -2.704390>,
      < -5.029194, -1.958958, -2.704390>,
      < -5.064360, -1.973520, -2.704448>
    }
    triangle {
      < -5.061899, -1.851103, -2.704390>,
      < -5.064360, -1.973520, -2.704448>,
      < -5.099230, -1.858524, -2.704448>
    }
    triangle {
      < -5.099230, -1.858524, -2.704448>,
      < -5.064360, -1.973520, -2.704448>,
      < -5.159430, -2.012886, -2.758817>
    }
    triangle {
      < -5.099230, -1.858524, -2.704448>,
      < -5.159430, -2.012886, -2.758817>,
      < -5.200152, -1.878587, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.200152, -1.878587, -2.758817>,
      < -5.159430, -2.012886, -2.758817>,
      < -5.262756, -2.055673, -2.787150>
    }
    triangle {
      < -5.200152, -1.878587, -2.758817>,
      < -5.262756, -2.055673, -2.787150>,
      < -5.309841, -1.900394, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.309841, -1.900394, -2.787150>,
      < -5.262756, -2.055673, -2.787150>,
      < -5.362122, -2.096818, -2.764967>
    }
    triangle {
      < -5.309841, -1.900394, -2.787150>,
      < -5.362122, -2.096818, -2.764967>,
      < -5.415325, -1.921364, -2.764967>
    }
    triangle {
      < -5.415325, -1.921364, -2.764967>,
      < -5.362122, -2.096818, -2.764967>,
      < -5.466959, -2.140229, -2.700042>
    }
    triangle {
      < -5.415325, -1.921364, -2.764967>,
      < -5.466959, -2.140229, -2.700042>,
      < -5.526617, -1.943489, -2.700042>
    }
    triangle {
      < -5.526617, -1.943489, -2.700042>,
      < -5.466959, -2.140229, -2.700042>,
      < -5.488535, -2.149163, -2.486032>
    }
    triangle {
      < -5.526617, -1.943489, -2.700042>,
      < -5.488535, -2.149163, -2.486032>,
      < -5.549521, -1.948042, -2.486032>
    }
    triangle {
      < -5.549521, -1.948042, -2.486032>,
      < -5.488535, -2.149163, -2.486032>,
      < -5.466959, -2.140229, -2.272216>
    }
    triangle {
      < -5.549521, -1.948042, -2.486032>,
      < -5.466959, -2.140229, -2.272216>,
      < -5.526617, -1.943489, -2.272216>
    }
    triangle {
      < -5.526617, -1.943489, -2.272216>,
      < -5.466959, -2.140229, -2.272216>,
      < -5.362122, -2.096818, -2.207291>
    }
    triangle {
      < -5.526617, -1.943489, -2.272216>,
      < -5.362122, -2.096818, -2.207291>,
      < -5.415325, -1.921364, -2.207291>
    }
    triangle {
      < -5.415325, -1.921364, -2.207291>,
      < -5.362122, -2.096818, -2.207291>,
      < -5.262756, -2.055673, -2.185108>
    }
    triangle {
      < -5.415325, -1.921364, -2.207291>,
      < -5.262756, -2.055673, -2.185108>,
      < -5.309841, -1.900394, -2.185108>
    }
    triangle {
      < -5.309841, -1.900394, -2.185108>,
      < -5.262756, -2.055673, -2.185108>,
      < -5.159430, -2.012886, -2.213441>
    }
    triangle {
      < -5.309841, -1.900394, -2.185108>,
      < -5.159430, -2.012886, -2.213441>,
      < -5.200152, -1.878587, -2.213441>
    }
    triangle {
      < -5.200152, -1.878587, -2.213441>,
      < -5.159430, -2.012886, -2.213441>,
      < -5.064360, -1.973520, -2.267810>
    }
    triangle {
      < -5.200152, -1.878587, -2.213441>,
      < -5.064360, -1.973520, -2.267810>,
      < -5.099230, -1.858524, -2.267810>
    }
    triangle {
      < -5.099230, -1.858524, -2.267810>,
      < -5.064360, -1.973520, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -5.029194, -1.958958, -2.704390>,
      < -4.976077, -2.058361, -2.704390>,
      < -5.007727, -2.079503, -2.704448>
    }
    triangle {
      < -5.029194, -1.958958, -2.704390>,
      < -5.007727, -2.079503, -2.704448>,
      < -5.064360, -1.973520, -2.704448>
    }
    triangle {
      < -5.064360, -1.973520, -2.704448>,
      < -5.007727, -2.079503, -2.704448>,
      < -5.093289, -2.136661, -2.758817>
    }
    triangle {
      < -5.064360, -1.973520, -2.704448>,
      < -5.093289, -2.136661, -2.758817>,
      < -5.159430, -2.012886, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.159430, -2.012886, -2.758817>,
      < -5.093289, -2.136661, -2.758817>,
      < -5.186283, -2.198782, -2.787150>
    }
    triangle {
      < -5.159430, -2.012886, -2.758817>,
      < -5.186283, -2.198782, -2.787150>,
      < -5.262756, -2.055673, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.262756, -2.055673, -2.787150>,
      < -5.186283, -2.198782, -2.787150>,
      < -5.275713, -2.258522, -2.764967>
    }
    triangle {
      < -5.262756, -2.055673, -2.787150>,
      < -5.275713, -2.258522, -2.764967>,
      < -5.362122, -2.096818, -2.764967>
    }
    triangle {
      < -5.362122, -2.096818, -2.764967>,
      < -5.275713, -2.258522, -2.764967>,
      < -5.370068, -2.321552, -2.700042>
    }
    triangle {
      < -5.362122, -2.096818, -2.764967>,
      < -5.370068, -2.321552, -2.700042>,
      < -5.466959, -2.140229, -2.700042>
    }
    triangle {
      < -5.466959, -2.140229, -2.700042>,
      < -5.370068, -2.321552, -2.700042>,
      < -5.389486, -2.334523, -2.486032>
    }
    triangle {
      < -5.466959, -2.140229, -2.700042>,
      < -5.389486, -2.334523, -2.486032>,
      < -5.488535, -2.149163, -2.486032>
    }
    triangle {
      < -5.488535, -2.149163, -2.486032>,
      < -5.389486, -2.334523, -2.486032>,
      < -5.370068, -2.321552, -2.272216>
    }
    triangle {
      < -5.488535, -2.149163, -2.486032>,
      < -5.370068, -2.321552, -2.272216>,
      < -5.466959, -2.140229, -2.272216>
    }
    triangle {
      < -5.466959, -2.140229, -2.272216>,
      < -5.370068, -2.321552, -2.272216>,
      < -5.275713, -2.258522, -2.207291>
    }
    triangle {
      < -5.466959, -2.140229, -2.272216>,
      < -5.275713, -2.258522, -2.207291>,
      < -5.362122, -2.096818, -2.207291>
    }
    triangle {
      < -5.362122, -2.096818, -2.207291>,
      < -5.275713, -2.258522, -2.207291>,
      < -5.186283, -2.198782, -2.185108>
    }
    triangle {
      < -5.362122, -2.096818, -2.207291>,
      < -5.186283, -2.198782, -2.185108>,
      < -5.262756, -2.055673, -2.185108>
    }
    triangle {
      < -5.262756, -2.055673, -2.185108>,
      < -5.186283, -2.198782, -2.185108>,
      < -5.093289, -2.136661, -2.213441>
    }
    triangle {
      < -5.262756, -2.055673, -2.185108>,
      < -5.093289, -2.136661, -2.213441>,
      < -5.159430, -2.012886, -2.213441>
    }
    triangle {
      < -5.159430, -2.012886, -2.213441>,
      < -5.093289, -2.136661, -2.213441>,
      < -5.007727, -2.079503, -2.267810>
    }
    triangle {
      < -5.159430, -2.012886, -2.213441>,
      < -5.007727, -2.079503, -2.267810>,
      < -5.064360, -1.973520, -2.267810>
    }
    triangle {
      < -5.064360, -1.973520, -2.267810>,
      < -5.007727, -2.079503, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    triangle {
      < -4.976077, -2.058361, -2.704390>,
      < -4.904545, -2.145534, -2.704390>,
      < -4.931459, -2.172448, -2.704448>
    }
    triangle {
      < -4.976077, -2.058361, -2.704390>,
      < -4.931459, -2.172448, -2.704448>,
      < -5.007727, -2.079503, -2.704448>
    }
    triangle {
      < -5.007727, -2.079503, -2.704448>,
      < -4.931459, -2.172448, -2.704448>,
      < -5.004219, -2.245206, -2.758817>
    }
    triangle {
      < -5.007727, -2.079503, -2.704448>,
      < -5.004219, -2.245206, -2.758817>,
      < -5.093289, -2.136661, -2.758817>
    }
    texture {rftire}
  }
  // rfwhitew
  union {
    triangle {
      < -5.093289, -2.136661, -2.758817>,
      < -5.004219, -2.245206, -2.758817>,
      < -5.083300, -2.324284, -2.787150>
    }
    triangle {
      < -5.093289, -2.136661, -2.758817>,
      < -5.083300, -2.324284, -2.787150>,
      < -5.186283, -2.198782, -2.787150>
    }
    texture {rfwhitew}
  }
  // rftire
  union {
    triangle {
      < -5.186283, -2.198782, -2.787150>,
      < -5.083300, -2.324284, -2.787150>,
      < -5.159349, -2.400331, -2.764967>
    }
    triangle {
      < -5.186283, -2.198782, -2.787150>,
      < -5.159349, -2.400331, -2.764967>,
      < -5.275713, -2.258522, -2.764967>
    }
    triangle {
      < -5.275713, -2.258522, -2.764967>,
      < -5.159349, -2.400331, -2.764967>,
      < -5.239585, -2.480566, -2.700042>
    }
    triangle {
      < -5.275713, -2.258522, -2.764967>,
      < -5.239585, -2.480566, -2.700042>,
      < -5.370068, -2.321552, -2.700042>
    }
    triangle {
      < -5.370068, -2.321552, -2.700042>,
      < -5.239585, -2.480566, -2.700042>,
      < -5.256098, -2.497078, -2.486032>
    }
    triangle {
      < -5.370068, -2.321552, -2.700042>,
      < -5.256098, -2.497078, -2.486032>,
      < -5.389486, -2.334523, -2.486032>
    }
    triangle {
      < -5.389486, -2.334523, -2.486032>,
      < -5.256098, -2.497078, -2.486032>,
      < -5.239585, -2.480566, -2.272216>
    }
    triangle {
      < -5.389486, -2.334523, -2.486032>,
      < -5.239585, -2.480566, -2.272216>,
      < -5.370068, -2.321552, -2.272216>
    }
    triangle {
      < -5.370068, -2.321552, -2.272216>,
      < -5.239585, -2.480566, -2.272216>,
      < -5.159349, -2.400331, -2.207291>
    }
    triangle {
      < -5.370068, -2.321552, -2.272216>,
      < -5.159349, -2.400331, -2.207291>,
      < -5.275713, -2.258522, -2.207291>
    }
    triangle {
      < -5.275713, -2.258522, -2.207291>,
      < -5.159349, -2.400331, -2.207291>,
      < -5.083300, -2.324284, -2.185108>
    }
    triangle {
      < -5.275713, -2.258522, -2.207291>,
      < -5.083300, -2.324284, -2.185108>,
      < -5.186283, -2.198782, -2.185108>
    }
    triangle {
      < -5.186283, -2.198782, -2.185108>,
      < -5.083300, -2.324284, -2.185108>,
      < -5.004219, -2.245206, -2.213441>
    }
    triangle {
      < -5.186283, -2.198782, -2.185108>,
      < -5.004219, -2.245206, -2.213441>,
      < -5.093289, -2.136661, -2.213441>
    }
    triangle {
      < -5.093289, -2.136661, -2.213441>,
      < -5.004219, -2.245206, -2.213441>,
      < -4.931459, -2.172448, -2.267810>
    }
    triangle {
      < -5.093289, -2.136661, -2.213441>,
      < -4.931459, -2.172448, -2.267810>,
      < -5.007727, -2.079503, -2.267810>
    }
    triangle {
      < -5.007727, -2.079503, -2.267810>,
      < -4.931459, -2.172448, -2.267810>,
      < -4.498117, -1.739117, -2.267490>
    }
    texture {rftire}
  }
  // btires
  union {
    triangle {
      < 4.642129, -2.145534, -2.704390>,
      < 4.729250, -2.217035, -2.704390>,
      < 4.708104, -2.248682, -2.704448>
    }
    triangle {
      < 4.642129, -2.145534, -2.704390>,
      < 4.708104, -2.248682, -2.704448>,
      < 4.615216, -2.172448, -2.704448>
    }
    triangle {
      < 4.615216, -2.172448, -2.704448>,
      < 4.708104, -2.248682, -2.704448>,
      < 4.650936, -2.334237, -2.758817>
    }
    triangle {
      < 4.615216, -2.172448, -2.704448>,
      < 4.650936, -2.334237, -2.758817>,
      < 4.542456, -2.245206, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.542456, -2.245206, -2.758817>,
      < 4.650936, -2.334237, -2.758817>,
      < 4.588802, -2.427223, -2.787150>
    }
    triangle {
      < 4.542456, -2.245206, -2.758817>,
      < 4.588802, -2.427223, -2.787150>,
      < 4.463375, -2.324284, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.463375, -2.324284, -2.787150>,
      < 4.588802, -2.427223, -2.787150>,
      < 4.529051, -2.516644, -2.764967>
    }
    triangle {
      < 4.463375, -2.324284, -2.787150>,
      < 4.529051, -2.516644, -2.764967>,
      < 4.387326, -2.400331, -2.764967>
    }
    triangle {
      < 4.387326, -2.400331, -2.764967>,
      < 4.529051, -2.516644, -2.764967>,
      < 4.466009, -2.610991, -2.700042>
    }
    triangle {
      < 4.387326, -2.400331, -2.764967>,
      < 4.466009, -2.610991, -2.700042>,
      < 4.307090, -2.480566, -2.700042>
    }
    triangle {
      < 4.307090, -2.480566, -2.700042>,
      < 4.466009, -2.610991, -2.700042>,
      < 4.453033, -2.630407, -2.486032>
    }
    triangle {
      < 4.307090, -2.480566, -2.700042>,
      < 4.453033, -2.630407, -2.486032>,
      < 4.290576, -2.497078, -2.486032>
    }
    triangle {
      < 4.290576, -2.497078, -2.486032>,
      < 4.453033, -2.630407, -2.486032>,
      < 4.466009, -2.610991, -2.272216>
    }
    triangle {
      < 4.290576, -2.497078, -2.486032>,
      < 4.466009, -2.610991, -2.272216>,
      < 4.307090, -2.480566, -2.272216>
    }
    triangle {
      < 4.307090, -2.480566, -2.272216>,
      < 4.466009, -2.610991, -2.272216>,
      < 4.529051, -2.516644, -2.207291>
    }
    triangle {
      < 4.307090, -2.480566, -2.272216>,
      < 4.529051, -2.516644, -2.207291>,
      < 4.387326, -2.400331, -2.207291>
    }
    triangle {
      < 4.387326, -2.400331, -2.207291>,
      < 4.529051, -2.516644, -2.207291>,
      < 4.588802, -2.427223, -2.185108>
    }
    triangle {
      < 4.387326, -2.400331, -2.207291>,
      < 4.588802, -2.427223, -2.185108>,
      < 4.463375, -2.324284, -2.185108>
    }
    triangle {
      < 4.463375, -2.324284, -2.185108>,
      < 4.588802, -2.427223, -2.185108>,
      < 4.650936, -2.334237, -2.213441>
    }
    triangle {
      < 4.463375, -2.324284, -2.185108>,
      < 4.650936, -2.334237, -2.213441>,
      < 4.542456, -2.245206, -2.213441>
    }
    triangle {
      < 4.542456, -2.245206, -2.213441>,
      < 4.650936, -2.334237, -2.213441>,
      < 4.708104, -2.248682, -2.267810>
    }
    triangle {
      < 4.542456, -2.245206, -2.213441>,
      < 4.708104, -2.248682, -2.267810>,
      < 4.615216, -2.172448, -2.267810>
    }
    triangle {
      < 4.615216, -2.172448, -2.267810>,
      < 4.708104, -2.248682, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.729250, -2.217035, -2.704390>,
      < 4.828647, -2.270165, -2.704390>,
      < 4.814081, -2.305330, -2.704448>
    }
    triangle {
      < 4.729250, -2.217035, -2.704390>,
      < 4.814081, -2.305330, -2.704448>,
      < 4.708104, -2.248682, -2.704448>
    }
    triangle {
      < 4.708104, -2.248682, -2.704448>,
      < 4.814081, -2.305330, -2.704448>,
      < 4.774701, -2.400394, -2.758817>
    }
    triangle {
      < 4.708104, -2.248682, -2.704448>,
      < 4.774701, -2.400394, -2.758817>,
      < 4.650936, -2.334237, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.650936, -2.334237, -2.758817>,
      < 4.774701, -2.400394, -2.758817>,
      < 4.731902, -2.503715, -2.787150>
    }
    triangle {
      < 4.650936, -2.334237, -2.758817>,
      < 4.731902, -2.503715, -2.787150>,
      < 4.588802, -2.427223, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.588802, -2.427223, -2.787150>,
      < 4.731902, -2.503715, -2.787150>,
      < 4.690742, -2.603076, -2.764967>
    }
    triangle {
      < 4.588802, -2.427223, -2.787150>,
      < 4.690742, -2.603076, -2.764967>,
      < 4.529051, -2.516644, -2.764967>
    }
    triangle {
      < 4.529051, -2.516644, -2.764967>,
      < 4.690742, -2.603076, -2.764967>,
      < 4.647317, -2.707907, -2.700042>
    }
    triangle {
      < 4.529051, -2.516644, -2.764967>,
      < 4.647317, -2.707907, -2.700042>,
      < 4.466009, -2.610991, -2.700042>
    }
    triangle {
      < 4.466009, -2.610991, -2.700042>,
      < 4.647317, -2.707907, -2.700042>,
      < 4.638381, -2.729481, -2.486032>
    }
    triangle {
      < 4.466009, -2.610991, -2.700042>,
      < 4.638381, -2.729481, -2.486032>,
      < 4.453033, -2.630407, -2.486032>
    }
    triangle {
      < 4.453033, -2.630407, -2.486032>,
      < 4.638381, -2.729481, -2.486032>,
      < 4.647317, -2.707907, -2.272216>
    }
    triangle {
      < 4.453033, -2.630407, -2.486032>,
      < 4.647317, -2.707907, -2.272216>,
      < 4.466009, -2.610991, -2.272216>
    }
    triangle {
      < 4.466009, -2.610991, -2.272216>,
      < 4.647317, -2.707907, -2.272216>,
      < 4.690742, -2.603076, -2.207291>
    }
    triangle {
      < 4.466009, -2.610991, -2.272216>,
      < 4.690742, -2.603076, -2.207291>,
      < 4.529051, -2.516644, -2.207291>
    }
    triangle {
      < 4.529051, -2.516644, -2.207291>,
      < 4.690742, -2.603076, -2.207291>,
      < 4.731902, -2.503715, -2.185108>
    }
    triangle {
      < 4.529051, -2.516644, -2.207291>,
      < 4.731902, -2.503715, -2.185108>,
      < 4.588802, -2.427223, -2.185108>
    }
    triangle {
      < 4.588802, -2.427223, -2.185108>,
      < 4.731902, -2.503715, -2.185108>,
      < 4.774701, -2.400394, -2.213441>
    }
    triangle {
      < 4.588802, -2.427223, -2.185108>,
      < 4.774701, -2.400394, -2.213441>,
      < 4.650936, -2.334237, -2.213441>
    }
    triangle {
      < 4.650936, -2.334237, -2.213441>,
      < 4.774701, -2.400394, -2.213441>,
      < 4.814081, -2.305330, -2.267810>
    }
    triangle {
      < 4.650936, -2.334237, -2.213441>,
      < 4.814081, -2.305330, -2.267810>,
      < 4.708104, -2.248682, -2.267810>
    }
    triangle {
      < 4.708104, -2.248682, -2.267810>,
      < 4.814081, -2.305330, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.828647, -2.270165, -2.704390>,
      < 4.936498, -2.302884, -2.704390>,
      < 4.929070, -2.340215, -2.704448>
    }
    triangle {
      < 4.828647, -2.270165, -2.704390>,
      < 4.929070, -2.340215, -2.704448>,
      < 4.814081, -2.305330, -2.704448>
    }
    triangle {
      < 4.814081, -2.305330, -2.704448>,
      < 4.929070, -2.340215, -2.704448>,
      < 4.908995, -2.441134, -2.758817>
    }
    triangle {
      < 4.814081, -2.305330, -2.704448>,
      < 4.908995, -2.441134, -2.758817>,
      < 4.774701, -2.400394, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.774701, -2.400394, -2.758817>,
      < 4.908995, -2.441134, -2.758817>,
      < 4.887175, -2.550819, -2.787150>
    }
    triangle {
      < 4.774701, -2.400394, -2.758817>,
      < 4.887175, -2.550819, -2.787150>,
      < 4.731902, -2.503715, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.731902, -2.503715, -2.787150>,
      < 4.887175, -2.550819, -2.787150>,
      < 4.866190, -2.656301, -2.764967>
    }
    triangle {
      < 4.731902, -2.503715, -2.787150>,
      < 4.866190, -2.656301, -2.764967>,
      < 4.690742, -2.603076, -2.764967>
    }
    triangle {
      < 4.690742, -2.603076, -2.764967>,
      < 4.866190, -2.656301, -2.764967>,
      < 4.844050, -2.767589, -2.700042>
    }
    triangle {
      < 4.690742, -2.603076, -2.764967>,
      < 4.844050, -2.767589, -2.700042>,
      < 4.647317, -2.707907, -2.700042>
    }
    triangle {
      < 4.647317, -2.707907, -2.700042>,
      < 4.844050, -2.767589, -2.700042>,
      < 4.839495, -2.790493, -2.486032>
    }
    triangle {
      < 4.647317, -2.707907, -2.700042>,
      < 4.839495, -2.790493, -2.486032>,
      < 4.638381, -2.729481, -2.486032>
    }
    triangle {
      < 4.638381, -2.729481, -2.486032>,
      < 4.839495, -2.790493, -2.486032>,
      < 4.844050, -2.767589, -2.272216>
    }
    triangle {
      < 4.638381, -2.729481, -2.486032>,
      < 4.844050, -2.767589, -2.272216>,
      < 4.647317, -2.707907, -2.272216>
    }
    triangle {
      < 4.647317, -2.707907, -2.272216>,
      < 4.844050, -2.767589, -2.272216>,
      < 4.866190, -2.656301, -2.207291>
    }
    triangle {
      < 4.647317, -2.707907, -2.272216>,
      < 4.866190, -2.656301, -2.207291>,
      < 4.690742, -2.603076, -2.207291>
    }
    triangle {
      < 4.690742, -2.603076, -2.207291>,
      < 4.866190, -2.656301, -2.207291>,
      < 4.887175, -2.550819, -2.185108>
    }
    triangle {
      < 4.690742, -2.603076, -2.207291>,
      < 4.887175, -2.550819, -2.185108>,
      < 4.731902, -2.503715, -2.185108>
    }
    triangle {
      < 4.731902, -2.503715, -2.185108>,
      < 4.887175, -2.550819, -2.185108>,
      < 4.908995, -2.441134, -2.213441>
    }
    triangle {
      < 4.731902, -2.503715, -2.185108>,
      < 4.908995, -2.441134, -2.213441>,
      < 4.774701, -2.400394, -2.213441>
    }
    triangle {
      < 4.774701, -2.400394, -2.213441>,
      < 4.908995, -2.441134, -2.213441>,
      < 4.929070, -2.340215, -2.267810>
    }
    triangle {
      < 4.774701, -2.400394, -2.213441>,
      < 4.929070, -2.340215, -2.267810>,
      < 4.814081, -2.305330, -2.267810>
    }
    triangle {
      < 4.814081, -2.305330, -2.267810>,
      < 4.929070, -2.340215, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.936498, -2.302884, -2.704390>,
      < 5.048660, -2.313934, -2.704390>,
      < 5.048658, -2.351996, -2.704448>
    }
    triangle {
      < 4.936498, -2.302884, -2.704390>,
      < 5.048658, -2.351996, -2.704448>,
      < 4.929070, -2.340215, -2.704448>
    }
    triangle {
      < 4.929070, -2.340215, -2.704448>,
      < 5.048658, -2.351996, -2.704448>,
      < 5.048656, -2.454893, -2.758817>
    }
    triangle {
      < 4.929070, -2.340215, -2.704448>,
      < 5.048656, -2.454893, -2.758817>,
      < 4.908995, -2.441134, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.908995, -2.441134, -2.758817>,
      < 5.048656, -2.454893, -2.758817>,
      < 5.048653, -2.566728, -2.787150>
    }
    triangle {
      < 4.908995, -2.441134, -2.758817>,
      < 5.048653, -2.566728, -2.787150>,
      < 4.887175, -2.550819, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.887175, -2.550819, -2.787150>,
      < 5.048653, -2.566728, -2.787150>,
      < 5.048650, -2.674276, -2.764967>
    }
    triangle {
      < 4.887175, -2.550819, -2.787150>,
      < 5.048650, -2.674276, -2.764967>,
      < 4.866190, -2.656301, -2.764967>
    }
    triangle {
      < 4.866190, -2.656301, -2.764967>,
      < 5.048650, -2.674276, -2.764967>,
      < 5.048647, -2.787746, -2.700042>
    }
    triangle {
      < 4.866190, -2.656301, -2.764967>,
      < 5.048647, -2.787746, -2.700042>,
      < 4.844050, -2.767589, -2.700042>
    }
    triangle {
      < 4.844050, -2.767589, -2.700042>,
      < 5.048647, -2.787746, -2.700042>,
      < 5.048646, -2.811098, -2.486032>
    }
    triangle {
      < 4.844050, -2.767589, -2.700042>,
      < 5.048646, -2.811098, -2.486032>,
      < 4.839495, -2.790493, -2.486032>
    }
    triangle {
      < 4.839495, -2.790493, -2.486032>,
      < 5.048646, -2.811098, -2.486032>,
      < 5.048647, -2.787746, -2.272216>
    }
    triangle {
      < 4.839495, -2.790493, -2.486032>,
      < 5.048647, -2.787746, -2.272216>,
      < 4.844050, -2.767589, -2.272216>
    }
    triangle {
      < 4.844050, -2.767589, -2.272216>,
      < 5.048647, -2.787746, -2.272216>,
      < 5.048650, -2.674276, -2.207291>
    }
    triangle {
      < 4.844050, -2.767589, -2.272216>,
      < 5.048650, -2.674276, -2.207291>,
      < 4.866190, -2.656301, -2.207291>
    }
    triangle {
      < 4.866190, -2.656301, -2.207291>,
      < 5.048650, -2.674276, -2.207291>,
      < 5.048653, -2.566728, -2.185108>
    }
    triangle {
      < 4.866190, -2.656301, -2.207291>,
      < 5.048653, -2.566728, -2.185108>,
      < 4.887175, -2.550819, -2.185108>
    }
    triangle {
      < 4.887175, -2.550819, -2.185108>,
      < 5.048653, -2.566728, -2.185108>,
      < 5.048656, -2.454893, -2.213441>
    }
    triangle {
      < 4.887175, -2.550819, -2.185108>,
      < 5.048656, -2.454893, -2.213441>,
      < 4.908995, -2.441134, -2.213441>
    }
    triangle {
      < 4.908995, -2.441134, -2.213441>,
      < 5.048656, -2.454893, -2.213441>,
      < 5.048658, -2.351996, -2.267810>
    }
    triangle {
      < 4.908995, -2.441134, -2.213441>,
      < 5.048658, -2.351996, -2.267810>,
      < 4.929070, -2.340215, -2.267810>
    }
    triangle {
      < 4.929070, -2.340215, -2.267810>,
      < 5.048658, -2.351996, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.048660, -2.313934, -2.704390>,
      < 5.160821, -2.302890, -2.704390>,
      < 5.168247, -2.340221, -2.704448>
    }
    triangle {
      < 5.048660, -2.313934, -2.704390>,
      < 5.168247, -2.340221, -2.704448>,
      < 5.048658, -2.351996, -2.704448>
    }
    triangle {
      < 5.048658, -2.351996, -2.704448>,
      < 5.168247, -2.340221, -2.704448>,
      < 5.188318, -2.441142, -2.758817>
    }
    triangle {
      < 5.048658, -2.351996, -2.704448>,
      < 5.188318, -2.441142, -2.758817>,
      < 5.048656, -2.454893, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.048656, -2.454893, -2.758817>,
      < 5.188318, -2.441142, -2.758817>,
      < 5.210133, -2.550828, -2.787150>
    }
    triangle {
      < 5.048656, -2.454893, -2.758817>,
      < 5.210133, -2.550828, -2.787150>,
      < 5.048653, -2.566728, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.048653, -2.566728, -2.787150>,
      < 5.210133, -2.550828, -2.787150>,
      < 5.231111, -2.656310, -2.764967>
    }
    triangle {
      < 5.048653, -2.566728, -2.787150>,
      < 5.231111, -2.656310, -2.764967>,
      < 5.048650, -2.674276, -2.764967>
    }
    triangle {
      < 5.048650, -2.674276, -2.764967>,
      < 5.231111, -2.656310, -2.764967>,
      < 5.253244, -2.767600, -2.700042>
    }
    triangle {
      < 5.048650, -2.674276, -2.764967>,
      < 5.253244, -2.767600, -2.700042>,
      < 5.048647, -2.787746, -2.700042>
    }
    triangle {
      < 5.048647, -2.787746, -2.700042>,
      < 5.253244, -2.767600, -2.700042>,
      < 5.257800, -2.790504, -2.486032>
    }
    triangle {
      < 5.048647, -2.787746, -2.700042>,
      < 5.257800, -2.790504, -2.486032>,
      < 5.048646, -2.811098, -2.486032>
    }
    triangle {
      < 5.048646, -2.811098, -2.486032>,
      < 5.257800, -2.790504, -2.486032>,
      < 5.253244, -2.767600, -2.272216>
    }
    triangle {
      < 5.048646, -2.811098, -2.486032>,
      < 5.253244, -2.767600, -2.272216>,
      < 5.048647, -2.787746, -2.272216>
    }
    triangle {
      < 5.048647, -2.787746, -2.272216>,
      < 5.253244, -2.767600, -2.272216>,
      < 5.231111, -2.656310, -2.207291>
    }
    triangle {
      < 5.048647, -2.787746, -2.272216>,
      < 5.231111, -2.656310, -2.207291>,
      < 5.048650, -2.674276, -2.207291>
    }
    triangle {
      < 5.048650, -2.674276, -2.207291>,
      < 5.231111, -2.656310, -2.207291>,
      < 5.210133, -2.550828, -2.185108>
    }
    triangle {
      < 5.048650, -2.674276, -2.207291>,
      < 5.210133, -2.550828, -2.185108>,
      < 5.048653, -2.566728, -2.185108>
    }
    triangle {
      < 5.048653, -2.566728, -2.185108>,
      < 5.210133, -2.550828, -2.185108>,
      < 5.188318, -2.441142, -2.213441>
    }
    triangle {
      < 5.048653, -2.566728, -2.185108>,
      < 5.188318, -2.441142, -2.213441>,
      < 5.048656, -2.454893, -2.213441>
    }
    triangle {
      < 5.048656, -2.454893, -2.213441>,
      < 5.188318, -2.441142, -2.213441>,
      < 5.168247, -2.340221, -2.267810>
    }
    triangle {
      < 5.048656, -2.454893, -2.213441>,
      < 5.168247, -2.340221, -2.267810>,
      < 5.048658, -2.351996, -2.267810>
    }
    triangle {
      < 5.048658, -2.351996, -2.267810>,
      < 5.168247, -2.340221, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.160821, -2.302890, -2.704390>,
      < 5.268674, -2.270177, -2.704390>,
      < 5.283239, -2.305343, -2.704448>
    }
    triangle {
      < 5.160821, -2.302890, -2.704390>,
      < 5.283239, -2.305343, -2.704448>,
      < 5.168247, -2.340221, -2.704448>
    }
    triangle {
      < 5.168247, -2.340221, -2.704448>,
      < 5.283239, -2.305343, -2.704448>,
      < 5.322614, -2.400407, -2.758817>
    }
    triangle {
      < 5.168247, -2.340221, -2.704448>,
      < 5.322614, -2.400407, -2.758817>,
      < 5.188318, -2.441142, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.188318, -2.441142, -2.758817>,
      < 5.322614, -2.400407, -2.758817>,
      < 5.365407, -2.503732, -2.787150>
    }
    triangle {
      < 5.188318, -2.441142, -2.758817>,
      < 5.365407, -2.503732, -2.787150>,
      < 5.210133, -2.550828, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.210133, -2.550828, -2.787150>,
      < 5.365407, -2.503732, -2.787150>,
      < 5.406560, -2.603094, -2.764967>
    }
    triangle {
      < 5.210133, -2.550828, -2.787150>,
      < 5.406560, -2.603094, -2.764967>,
      < 5.231111, -2.656310, -2.764967>
    }
    triangle {
      < 5.231111, -2.656310, -2.764967>,
      < 5.406560, -2.603094, -2.764967>,
      < 5.449981, -2.707928, -2.700042>
    }
    triangle {
      < 5.231111, -2.656310, -2.764967>,
      < 5.449981, -2.707928, -2.700042>,
      < 5.253244, -2.767600, -2.700042>
    }
    triangle {
      < 5.253244, -2.767600, -2.700042>,
      < 5.449981, -2.707928, -2.700042>,
      < 5.458916, -2.729503, -2.486032>
    }
    triangle {
      < 5.253244, -2.767600, -2.700042>,
      < 5.458916, -2.729503, -2.486032>,
      < 5.257800, -2.790504, -2.486032>
    }
    triangle {
      < 5.257800, -2.790504, -2.486032>,
      < 5.458916, -2.729503, -2.486032>,
      < 5.449981, -2.707928, -2.272216>
    }
    triangle {
      < 5.257800, -2.790504, -2.486032>,
      < 5.449981, -2.707928, -2.272216>,
      < 5.253244, -2.767600, -2.272216>
    }
    triangle {
      < 5.253244, -2.767600, -2.272216>,
      < 5.449981, -2.707928, -2.272216>,
      < 5.406560, -2.603094, -2.207291>
    }
    triangle {
      < 5.253244, -2.767600, -2.272216>,
      < 5.406560, -2.603094, -2.207291>,
      < 5.231111, -2.656310, -2.207291>
    }
    triangle {
      < 5.231111, -2.656310, -2.207291>,
      < 5.406560, -2.603094, -2.207291>,
      < 5.365407, -2.503732, -2.185108>
    }
    triangle {
      < 5.231111, -2.656310, -2.207291>,
      < 5.365407, -2.503732, -2.185108>,
      < 5.210133, -2.550828, -2.185108>
    }
    triangle {
      < 5.210133, -2.550828, -2.185108>,
      < 5.365407, -2.503732, -2.185108>,
      < 5.322614, -2.400407, -2.213441>
    }
    triangle {
      < 5.210133, -2.550828, -2.185108>,
      < 5.322614, -2.400407, -2.213441>,
      < 5.188318, -2.441142, -2.213441>
    }
    triangle {
      < 5.188318, -2.441142, -2.213441>,
      < 5.322614, -2.400407, -2.213441>,
      < 5.283239, -2.305343, -2.267810>
    }
    triangle {
      < 5.188318, -2.441142, -2.213441>,
      < 5.283239, -2.305343, -2.267810>,
      < 5.168247, -2.340221, -2.267810>
    }
    triangle {
      < 5.168247, -2.340221, -2.267810>,
      < 5.283239, -2.305343, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.268674, -2.270177, -2.704390>,
      < 5.368073, -2.217052, -2.704390>,
      < 5.389218, -2.248700, -2.704448>
    }
    triangle {
      < 5.268674, -2.270177, -2.704390>,
      < 5.389218, -2.248700, -2.704448>,
      < 5.283239, -2.305343, -2.704448>
    }
    triangle {
      < 5.283239, -2.305343, -2.704448>,
      < 5.389218, -2.248700, -2.704448>,
      < 5.446382, -2.334258, -2.758817>
    }
    triangle {
      < 5.283239, -2.305343, -2.704448>,
      < 5.446382, -2.334258, -2.758817>,
      < 5.322614, -2.400407, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.322614, -2.400407, -2.758817>,
      < 5.446382, -2.334258, -2.758817>,
      < 5.508512, -2.427247, -2.787150>
    }
    triangle {
      < 5.322614, -2.400407, -2.758817>,
      < 5.508512, -2.427247, -2.787150>,
      < 5.365407, -2.503732, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.365407, -2.503732, -2.787150>,
      < 5.508512, -2.427247, -2.787150>,
      < 5.568258, -2.516672, -2.764967>
    }
    triangle {
      < 5.365407, -2.503732, -2.787150>,
      < 5.568258, -2.516672, -2.764967>,
      < 5.406560, -2.603094, -2.764967>
    }
    triangle {
      < 5.406560, -2.603094, -2.764967>,
      < 5.568258, -2.516672, -2.764967>,
      < 5.631295, -2.611022, -2.700042>
    }
    triangle {
      < 5.406560, -2.603094, -2.764967>,
      < 5.631295, -2.611022, -2.700042>,
      < 5.449981, -2.707928, -2.700042>
    }
    triangle {
      < 5.449981, -2.707928, -2.700042>,
      < 5.631295, -2.611022, -2.700042>,
      < 5.644269, -2.630438, -2.486032>
    }
    triangle {
      < 5.449981, -2.707928, -2.700042>,
      < 5.644269, -2.630438, -2.486032>,
      < 5.458916, -2.729503, -2.486032>
    }
    triangle {
      < 5.458916, -2.729503, -2.486032>,
      < 5.644269, -2.630438, -2.486032>,
      < 5.631295, -2.611022, -2.272216>
    }
    triangle {
      < 5.458916, -2.729503, -2.486032>,
      < 5.631295, -2.611022, -2.272216>,
      < 5.449981, -2.707928, -2.272216>
    }
    triangle {
      < 5.449981, -2.707928, -2.272216>,
      < 5.631295, -2.611022, -2.272216>,
      < 5.568258, -2.516672, -2.207291>
    }
    triangle {
      < 5.449981, -2.707928, -2.272216>,
      < 5.568258, -2.516672, -2.207291>,
      < 5.406560, -2.603094, -2.207291>
    }
    triangle {
      < 5.406560, -2.603094, -2.207291>,
      < 5.568258, -2.516672, -2.207291>,
      < 5.508512, -2.427247, -2.185108>
    }
    triangle {
      < 5.406560, -2.603094, -2.207291>,
      < 5.508512, -2.427247, -2.185108>,
      < 5.365407, -2.503732, -2.185108>
    }
    triangle {
      < 5.365407, -2.503732, -2.185108>,
      < 5.508512, -2.427247, -2.185108>,
      < 5.446382, -2.334258, -2.213441>
    }
    triangle {
      < 5.365407, -2.503732, -2.185108>,
      < 5.446382, -2.334258, -2.213441>,
      < 5.322614, -2.400407, -2.213441>
    }
    triangle {
      < 5.322614, -2.400407, -2.213441>,
      < 5.446382, -2.334258, -2.213441>,
      < 5.389218, -2.248700, -2.267810>
    }
    triangle {
      < 5.322614, -2.400407, -2.213441>,
      < 5.389218, -2.248700, -2.267810>,
      < 5.283239, -2.305343, -2.267810>
    }
    triangle {
      < 5.283239, -2.305343, -2.267810>,
      < 5.389218, -2.248700, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.368073, -2.217052, -2.704390>,
      < 5.455199, -2.145556, -2.704390>,
      < 5.482111, -2.172471, -2.704448>
    }
    triangle {
      < 5.368073, -2.217052, -2.704390>,
      < 5.482111, -2.172471, -2.704448>,
      < 5.389218, -2.248700, -2.704448>
    }
    triangle {
      < 5.389218, -2.248700, -2.704448>,
      < 5.482111, -2.172471, -2.704448>,
      < 5.554868, -2.245233, -2.758817>
    }
    triangle {
      < 5.389218, -2.248700, -2.704448>,
      < 5.554868, -2.245233, -2.758817>,
      < 5.446382, -2.334258, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.446382, -2.334258, -2.758817>,
      < 5.554868, -2.245233, -2.758817>,
      < 5.633944, -2.324315, -2.787150>
    }
    triangle {
      < 5.446382, -2.334258, -2.758817>,
      < 5.633944, -2.324315, -2.787150>,
      < 5.508512, -2.427247, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.508512, -2.427247, -2.787150>,
      < 5.633944, -2.324315, -2.787150>,
      < 5.709989, -2.400366, -2.764967>
    }
    triangle {
      < 5.508512, -2.427247, -2.787150>,
      < 5.709989, -2.400366, -2.764967>,
      < 5.568258, -2.516672, -2.764967>
    }
    triangle {
      < 5.568258, -2.516672, -2.764967>,
      < 5.709989, -2.400366, -2.764967>,
      < 5.790220, -2.480605, -2.700042>
    }
    triangle {
      < 5.568258, -2.516672, -2.764967>,
      < 5.790220, -2.480605, -2.700042>,
      < 5.631295, -2.611022, -2.700042>
    }
    triangle {
      < 5.631295, -2.611022, -2.700042>,
      < 5.790220, -2.480605, -2.700042>,
      < 5.806733, -2.497117, -2.486032>
    }
    triangle {
      < 5.631295, -2.611022, -2.700042>,
      < 5.806733, -2.497117, -2.486032>,
      < 5.644269, -2.630438, -2.486032>
    }
    triangle {
      < 5.644269, -2.630438, -2.486032>,
      < 5.806733, -2.497117, -2.486032>,
      < 5.790220, -2.480605, -2.272216>
    }
    triangle {
      < 5.644269, -2.630438, -2.486032>,
      < 5.790220, -2.480605, -2.272216>,
      < 5.631295, -2.611022, -2.272216>
    }
    triangle {
      < 5.631295, -2.611022, -2.272216>,
      < 5.790220, -2.480605, -2.272216>,
      < 5.709989, -2.400366, -2.207291>
    }
    triangle {
      < 5.631295, -2.611022, -2.272216>,
      < 5.709989, -2.400366, -2.207291>,
      < 5.568258, -2.516672, -2.207291>
    }
    triangle {
      < 5.568258, -2.516672, -2.207291>,
      < 5.709989, -2.400366, -2.207291>,
      < 5.633944, -2.324315, -2.185108>
    }
    triangle {
      < 5.568258, -2.516672, -2.207291>,
      < 5.633944, -2.324315, -2.185108>,
      < 5.508512, -2.427247, -2.185108>
    }
    triangle {
      < 5.508512, -2.427247, -2.185108>,
      < 5.633944, -2.324315, -2.185108>,
      < 5.554868, -2.245233, -2.213441>
    }
    triangle {
      < 5.508512, -2.427247, -2.185108>,
      < 5.554868, -2.245233, -2.213441>,
      < 5.446382, -2.334258, -2.213441>
    }
    triangle {
      < 5.446382, -2.334258, -2.213441>,
      < 5.554868, -2.245233, -2.213441>,
      < 5.482111, -2.172471, -2.267810>
    }
    triangle {
      < 5.446382, -2.334258, -2.213441>,
      < 5.482111, -2.172471, -2.267810>,
      < 5.389218, -2.248700, -2.267810>
    }
    triangle {
      < 5.389218, -2.248700, -2.267810>,
      < 5.482111, -2.172471, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.455199, -2.145556, -2.704390>,
      < 5.526700, -2.058437, -2.704390>,
      < 5.558348, -2.079584, -2.704448>
    }
    triangle {
      < 5.455199, -2.145556, -2.704390>,
      < 5.558348, -2.079584, -2.704448>,
      < 5.482111, -2.172471, -2.704448>
    }
    triangle {
      < 5.482111, -2.172471, -2.704448>,
      < 5.558348, -2.079584, -2.704448>,
      < 5.643901, -2.136754, -2.758817>
    }
    triangle {
      < 5.482111, -2.172471, -2.704448>,
      < 5.643901, -2.136754, -2.758817>,
      < 5.554868, -2.245233, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.554868, -2.245233, -2.758817>,
      < 5.643901, -2.136754, -2.758817>,
      < 5.736886, -2.198890, -2.787150>
    }
    triangle {
      < 5.554868, -2.245233, -2.758817>,
      < 5.736886, -2.198890, -2.787150>,
      < 5.633944, -2.324315, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.633944, -2.324315, -2.787150>,
      < 5.736886, -2.198890, -2.787150>,
      < 5.826305, -2.258645, -2.764967>
    }
    triangle {
      < 5.633944, -2.324315, -2.787150>,
      < 5.826305, -2.258645, -2.764967>,
      < 5.709989, -2.400366, -2.764967>
    }
    triangle {
      < 5.709989, -2.400366, -2.764967>,
      < 5.826305, -2.258645, -2.764967>,
      < 5.920650, -2.321689, -2.700042>
    }
    triangle {
      < 5.709989, -2.400366, -2.764967>,
      < 5.920650, -2.321689, -2.700042>,
      < 5.790220, -2.480605, -2.700042>
    }
    triangle {
      < 5.790220, -2.480605, -2.700042>,
      < 5.920650, -2.321689, -2.700042>,
      < 5.940066, -2.334664, -2.486032>
    }
    triangle {
      < 5.790220, -2.480605, -2.700042>,
      < 5.940066, -2.334664, -2.486032>,
      < 5.806733, -2.497117, -2.486032>
    }
    triangle {
      < 5.806733, -2.497117, -2.486032>,
      < 5.940066, -2.334664, -2.486032>,
      < 5.920650, -2.321689, -2.272216>
    }
    triangle {
      < 5.806733, -2.497117, -2.486032>,
      < 5.920650, -2.321689, -2.272216>,
      < 5.790220, -2.480605, -2.272216>
    }
    triangle {
      < 5.790220, -2.480605, -2.272216>,
      < 5.920650, -2.321689, -2.272216>,
      < 5.826305, -2.258645, -2.207291>
    }
    triangle {
      < 5.790220, -2.480605, -2.272216>,
      < 5.826305, -2.258645, -2.207291>,
      < 5.709989, -2.400366, -2.207291>
    }
    triangle {
      < 5.709989, -2.400366, -2.207291>,
      < 5.826305, -2.258645, -2.207291>,
      < 5.736886, -2.198890, -2.185108>
    }
    triangle {
      < 5.709989, -2.400366, -2.207291>,
      < 5.736886, -2.198890, -2.185108>,
      < 5.633944, -2.324315, -2.185108>
    }
    triangle {
      < 5.633944, -2.324315, -2.185108>,
      < 5.736886, -2.198890, -2.185108>,
      < 5.643901, -2.136754, -2.213441>
    }
    triangle {
      < 5.633944, -2.324315, -2.185108>,
      < 5.643901, -2.136754, -2.213441>,
      < 5.554868, -2.245233, -2.213441>
    }
    triangle {
      < 5.554868, -2.245233, -2.213441>,
      < 5.643901, -2.136754, -2.213441>,
      < 5.558348, -2.079584, -2.267810>
    }
    triangle {
      < 5.554868, -2.245233, -2.213441>,
      < 5.558348, -2.079584, -2.267810>,
      < 5.482111, -2.172471, -2.267810>
    }
    triangle {
      < 5.482111, -2.172471, -2.267810>,
      < 5.558348, -2.079584, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.526700, -2.058437, -2.704390>,
      < 5.579834, -1.959042, -2.704390>,
      < 5.614999, -1.973609, -2.704448>
    }
    triangle {
      < 5.526700, -2.058437, -2.704390>,
      < 5.614999, -1.973609, -2.704448>,
      < 5.558348, -2.079584, -2.704448>
    }
    triangle {
      < 5.558348, -2.079584, -2.704448>,
      < 5.614999, -1.973609, -2.704448>,
      < 5.710062, -2.012991, -2.758817>
    }
    triangle {
      < 5.558348, -2.079584, -2.704448>,
      < 5.710062, -2.012991, -2.758817>,
      < 5.643901, -2.136754, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.643901, -2.136754, -2.758817>,
      < 5.710062, -2.012991, -2.758817>,
      < 5.813381, -2.055792, -2.787150>
    }
    triangle {
      < 5.643901, -2.136754, -2.758817>,
      < 5.813381, -2.055792, -2.787150>,
      < 5.736886, -2.198890, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.736886, -2.198890, -2.787150>,
      < 5.813381, -2.055792, -2.787150>,
      < 5.912741, -2.096955, -2.764967>
    }
    triangle {
      < 5.736886, -2.198890, -2.787150>,
      < 5.912741, -2.096955, -2.764967>,
      < 5.826305, -2.258645, -2.764967>
    }
    triangle {
      < 5.826305, -2.258645, -2.764967>,
      < 5.912741, -2.096955, -2.764967>,
      < 6.017571, -2.140382, -2.700042>
    }
    triangle {
      < 5.826305, -2.258645, -2.764967>,
      < 6.017571, -2.140382, -2.700042>,
      < 5.920650, -2.321689, -2.700042>
    }
    triangle {
      < 5.920650, -2.321689, -2.700042>,
      < 6.017571, -2.140382, -2.700042>,
      < 6.039145, -2.149320, -2.486032>
    }
    triangle {
      < 5.920650, -2.321689, -2.700042>,
      < 6.039145, -2.149320, -2.486032>,
      < 5.940066, -2.334664, -2.486032>
    }
    triangle {
      < 5.940066, -2.334664, -2.486032>,
      < 6.039145, -2.149320, -2.486032>,
      < 6.017571, -2.140382, -2.272216>
    }
    triangle {
      < 5.940066, -2.334664, -2.486032>,
      < 6.017571, -2.140382, -2.272216>,
      < 5.920650, -2.321689, -2.272216>
    }
    triangle {
      < 5.920650, -2.321689, -2.272216>,
      < 6.017571, -2.140382, -2.272216>,
      < 5.912741, -2.096955, -2.207291>
    }
    triangle {
      < 5.920650, -2.321689, -2.272216>,
      < 5.912741, -2.096955, -2.207291>,
      < 5.826305, -2.258645, -2.207291>
    }
    triangle {
      < 5.826305, -2.258645, -2.207291>,
      < 5.912741, -2.096955, -2.207291>,
      < 5.813381, -2.055792, -2.185108>
    }
    triangle {
      < 5.826305, -2.258645, -2.207291>,
      < 5.813381, -2.055792, -2.185108>,
      < 5.736886, -2.198890, -2.185108>
    }
    triangle {
      < 5.736886, -2.198890, -2.185108>,
      < 5.813381, -2.055792, -2.185108>,
      < 5.710062, -2.012991, -2.213441>
    }
    triangle {
      < 5.736886, -2.198890, -2.185108>,
      < 5.710062, -2.012991, -2.213441>,
      < 5.643901, -2.136754, -2.213441>
    }
    triangle {
      < 5.643901, -2.136754, -2.213441>,
      < 5.710062, -2.012991, -2.213441>,
      < 5.614999, -1.973609, -2.267810>
    }
    triangle {
      < 5.643901, -2.136754, -2.213441>,
      < 5.614999, -1.973609, -2.267810>,
      < 5.558348, -2.079584, -2.267810>
    }
    triangle {
      < 5.558348, -2.079584, -2.267810>,
      < 5.614999, -1.973609, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.579834, -1.959042, -2.704390>,
      < 5.612556, -1.851192, -2.704390>,
      < 5.649887, -1.858619, -2.704448>
    }
    triangle {
      < 5.579834, -1.959042, -2.704390>,
      < 5.649887, -1.858619, -2.704448>,
      < 5.614999, -1.973609, -2.704448>
    }
    triangle {
      < 5.614999, -1.973609, -2.704448>,
      < 5.649887, -1.858619, -2.704448>,
      < 5.750805, -1.878699, -2.758817>
    }
    triangle {
      < 5.614999, -1.973609, -2.704448>,
      < 5.750805, -1.878699, -2.758817>,
      < 5.710062, -2.012991, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.710062, -2.012991, -2.758817>,
      < 5.750805, -1.878699, -2.758817>,
      < 5.860490, -1.900522, -2.787150>
    }
    triangle {
      < 5.710062, -2.012991, -2.758817>,
      < 5.860490, -1.900522, -2.787150>,
      < 5.813381, -2.055792, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.813381, -2.055792, -2.787150>,
      < 5.860490, -1.900522, -2.787150>,
      < 5.965970, -1.921509, -2.764967>
    }
    triangle {
      < 5.813381, -2.055792, -2.787150>,
      < 5.965970, -1.921509, -2.764967>,
      < 5.912741, -2.096955, -2.764967>
    }
    triangle {
      < 5.912741, -2.096955, -2.764967>,
      < 5.965970, -1.921509, -2.764967>,
      < 6.077259, -1.943652, -2.700042>
    }
    triangle {
      < 5.912741, -2.096955, -2.764967>,
      < 6.077259, -1.943652, -2.700042>,
      < 6.017571, -2.140382, -2.700042>
    }
    triangle {
      < 6.017571, -2.140382, -2.700042>,
      < 6.077259, -1.943652, -2.700042>,
      < 6.100163, -1.948209, -2.486032>
    }
    triangle {
      < 6.017571, -2.140382, -2.700042>,
      < 6.100163, -1.948209, -2.486032>,
      < 6.039145, -2.149320, -2.486032>
    }
    triangle {
      < 6.039145, -2.149320, -2.486032>,
      < 6.100163, -1.948209, -2.486032>,
      < 6.077259, -1.943652, -2.272216>
    }
    triangle {
      < 6.039145, -2.149320, -2.486032>,
      < 6.077259, -1.943652, -2.272216>,
      < 6.017571, -2.140382, -2.272216>
    }
    triangle {
      < 6.017571, -2.140382, -2.272216>,
      < 6.077259, -1.943652, -2.272216>,
      < 5.965970, -1.921509, -2.207291>
    }
    triangle {
      < 6.017571, -2.140382, -2.272216>,
      < 5.965970, -1.921509, -2.207291>,
      < 5.912741, -2.096955, -2.207291>
    }
    triangle {
      < 5.912741, -2.096955, -2.207291>,
      < 5.965970, -1.921509, -2.207291>,
      < 5.860490, -1.900522, -2.185108>
    }
    triangle {
      < 5.912741, -2.096955, -2.207291>,
      < 5.860490, -1.900522, -2.185108>,
      < 5.813381, -2.055792, -2.185108>
    }
    triangle {
      < 5.813381, -2.055792, -2.185108>,
      < 5.860490, -1.900522, -2.185108>,
      < 5.750805, -1.878699, -2.213441>
    }
    triangle {
      < 5.813381, -2.055792, -2.185108>,
      < 5.750805, -1.878699, -2.213441>,
      < 5.710062, -2.012991, -2.213441>
    }
    triangle {
      < 5.710062, -2.012991, -2.213441>,
      < 5.750805, -1.878699, -2.213441>,
      < 5.649887, -1.858619, -2.267810>
    }
    triangle {
      < 5.710062, -2.012991, -2.213441>,
      < 5.649887, -1.858619, -2.267810>,
      < 5.614999, -1.973609, -2.267810>
    }
    triangle {
      < 5.614999, -1.973609, -2.267810>,
      < 5.649887, -1.858619, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.612556, -1.851192, -2.704390>,
      < 5.623609, -1.739030, -2.704390>,
      < 5.661671, -1.739033, -2.704448>
    }
    triangle {
      < 5.612556, -1.851192, -2.704390>,
      < 5.661671, -1.739033, -2.704448>,
      < 5.649887, -1.858619, -2.704448>
    }
    triangle {
      < 5.649887, -1.858619, -2.704448>,
      < 5.661671, -1.739033, -2.704448>,
      < 5.764567, -1.739038, -2.758817>
    }
    triangle {
      < 5.649887, -1.858619, -2.704448>,
      < 5.764567, -1.739038, -2.758817>,
      < 5.750805, -1.878699, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.750805, -1.878699, -2.758817>,
      < 5.764567, -1.739038, -2.758817>,
      < 5.876403, -1.739043, -2.787150>
    }
    triangle {
      < 5.750805, -1.878699, -2.758817>,
      < 5.876403, -1.739043, -2.787150>,
      < 5.860490, -1.900522, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.860490, -1.900522, -2.787150>,
      < 5.876403, -1.739043, -2.787150>,
      < 5.983951, -1.739049, -2.764967>
    }
    triangle {
      < 5.860490, -1.900522, -2.787150>,
      < 5.983951, -1.739049, -2.764967>,
      < 5.965970, -1.921509, -2.764967>
    }
    triangle {
      < 5.965970, -1.921509, -2.764967>,
      < 5.983951, -1.739049, -2.764967>,
      < 6.097421, -1.739055, -2.700042>
    }
    triangle {
      < 5.965970, -1.921509, -2.764967>,
      < 6.097421, -1.739055, -2.700042>,
      < 6.077259, -1.943652, -2.700042>
    }
    triangle {
      < 6.077259, -1.943652, -2.700042>,
      < 6.097421, -1.739055, -2.700042>,
      < 6.120772, -1.739057, -2.486032>
    }
    triangle {
      < 6.077259, -1.943652, -2.700042>,
      < 6.120772, -1.739057, -2.486032>,
      < 6.100163, -1.948209, -2.486032>
    }
    triangle {
      < 6.100163, -1.948209, -2.486032>,
      < 6.120772, -1.739057, -2.486032>,
      < 6.097421, -1.739055, -2.272216>
    }
    triangle {
      < 6.100163, -1.948209, -2.486032>,
      < 6.097421, -1.739055, -2.272216>,
      < 6.077259, -1.943652, -2.272216>
    }
    triangle {
      < 6.077259, -1.943652, -2.272216>,
      < 6.097421, -1.739055, -2.272216>,
      < 5.983951, -1.739049, -2.207291>
    }
    triangle {
      < 6.077259, -1.943652, -2.272216>,
      < 5.983951, -1.739049, -2.207291>,
      < 5.965970, -1.921509, -2.207291>
    }
    triangle {
      < 5.965970, -1.921509, -2.207291>,
      < 5.983951, -1.739049, -2.207291>,
      < 5.876403, -1.739043, -2.185108>
    }
    triangle {
      < 5.965970, -1.921509, -2.207291>,
      < 5.876403, -1.739043, -2.185108>,
      < 5.860490, -1.900522, -2.185108>
    }
    triangle {
      < 5.860490, -1.900522, -2.185108>,
      < 5.876403, -1.739043, -2.185108>,
      < 5.764567, -1.739038, -2.213441>
    }
    triangle {
      < 5.860490, -1.900522, -2.185108>,
      < 5.764567, -1.739038, -2.213441>,
      < 5.750805, -1.878699, -2.213441>
    }
    triangle {
      < 5.750805, -1.878699, -2.213441>,
      < 5.764567, -1.739038, -2.213441>,
      < 5.661671, -1.739033, -2.267810>
    }
    triangle {
      < 5.750805, -1.878699, -2.213441>,
      < 5.661671, -1.739033, -2.267810>,
      < 5.649887, -1.858619, -2.267810>
    }
    triangle {
      < 5.649887, -1.858619, -2.267810>,
      < 5.661671, -1.739033, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.623609, -1.739030, -2.704390>,
      < 5.612568, -1.626868, -2.704390>,
      < 5.649899, -1.619444, -2.704448>
    }
    triangle {
      < 5.623609, -1.739030, -2.704390>,
      < 5.649899, -1.619444, -2.704448>,
      < 5.661671, -1.739033, -2.704448>
    }
    triangle {
      < 5.661671, -1.739033, -2.704448>,
      < 5.649899, -1.619444, -2.704448>,
      < 5.750820, -1.599375, -2.758817>
    }
    triangle {
      < 5.661671, -1.739033, -2.704448>,
      < 5.750820, -1.599375, -2.758817>,
      < 5.764567, -1.739038, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.764567, -1.739038, -2.758817>,
      < 5.750820, -1.599375, -2.758817>,
      < 5.860507, -1.577563, -2.787150>
    }
    triangle {
      < 5.764567, -1.739038, -2.758817>,
      < 5.860507, -1.577563, -2.787150>,
      < 5.876403, -1.739043, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.876403, -1.739043, -2.787150>,
      < 5.860507, -1.577563, -2.787150>,
      < 5.965990, -1.556588, -2.764967>
    }
    triangle {
      < 5.876403, -1.739043, -2.787150>,
      < 5.965990, -1.556588, -2.764967>,
      < 5.983951, -1.739049, -2.764967>
    }
    triangle {
      < 5.983951, -1.739049, -2.764967>,
      < 5.965990, -1.556588, -2.764967>,
      < 6.077280, -1.534457, -2.700042>
    }
    triangle {
      < 5.983951, -1.739049, -2.764967>,
      < 6.077280, -1.534457, -2.700042>,
      < 6.097421, -1.739055, -2.700042>
    }
    triangle {
      < 6.097421, -1.739055, -2.700042>,
      < 6.077280, -1.534457, -2.700042>,
      < 6.100183, -1.529903, -2.486032>
    }
    triangle {
      < 6.097421, -1.739055, -2.700042>,
      < 6.100183, -1.529903, -2.486032>,
      < 6.120772, -1.739057, -2.486032>
    }
    triangle {
      < 6.120772, -1.739057, -2.486032>,
      < 6.100183, -1.529903, -2.486032>,
      < 6.077280, -1.534457, -2.272216>
    }
    triangle {
      < 6.120772, -1.739057, -2.486032>,
      < 6.077280, -1.534457, -2.272216>,
      < 6.097421, -1.739055, -2.272216>
    }
    triangle {
      < 6.097421, -1.739055, -2.272216>,
      < 6.077280, -1.534457, -2.272216>,
      < 5.965990, -1.556588, -2.207291>
    }
    triangle {
      < 6.097421, -1.739055, -2.272216>,
      < 5.965990, -1.556588, -2.207291>,
      < 5.983951, -1.739049, -2.207291>
    }
    triangle {
      < 5.983951, -1.739049, -2.207291>,
      < 5.965990, -1.556588, -2.207291>,
      < 5.860507, -1.577563, -2.185108>
    }
    triangle {
      < 5.983951, -1.739049, -2.207291>,
      < 5.860507, -1.577563, -2.185108>,
      < 5.876403, -1.739043, -2.185108>
    }
    triangle {
      < 5.876403, -1.739043, -2.185108>,
      < 5.860507, -1.577563, -2.185108>,
      < 5.750820, -1.599375, -2.213441>
    }
    triangle {
      < 5.876403, -1.739043, -2.185108>,
      < 5.750820, -1.599375, -2.213441>,
      < 5.764567, -1.739038, -2.213441>
    }
    triangle {
      < 5.764567, -1.739038, -2.213441>,
      < 5.750820, -1.599375, -2.213441>,
      < 5.649899, -1.619444, -2.267810>
    }
    triangle {
      < 5.764567, -1.739038, -2.213441>,
      < 5.649899, -1.619444, -2.267810>,
      < 5.661671, -1.739033, -2.267810>
    }
    triangle {
      < 5.661671, -1.739033, -2.267810>,
      < 5.649899, -1.619444, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.612568, -1.626868, -2.704390>,
      < 5.579858, -1.519013, -2.704390>,
      < 5.615024, -1.504450, -2.704448>
    }
    triangle {
      < 5.612568, -1.626868, -2.704390>,
      < 5.615024, -1.504450, -2.704448>,
      < 5.649899, -1.619444, -2.704448>
    }
    triangle {
      < 5.649899, -1.619444, -2.704448>,
      < 5.615024, -1.504450, -2.704448>,
      < 5.710090, -1.465079, -2.758817>
    }
    triangle {
      < 5.649899, -1.619444, -2.704448>,
      < 5.710090, -1.465079, -2.758817>,
      < 5.750820, -1.599375, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.750820, -1.599375, -2.758817>,
      < 5.710090, -1.465079, -2.758817>,
      < 5.813414, -1.422288, -2.787150>
    }
    triangle {
      < 5.750820, -1.599375, -2.758817>,
      < 5.813414, -1.422288, -2.787150>,
      < 5.860507, -1.577563, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.860507, -1.577563, -2.787150>,
      < 5.813414, -1.422288, -2.787150>,
      < 5.912778, -1.381136, -2.764967>
    }
    triangle {
      < 5.860507, -1.577563, -2.787150>,
      < 5.912778, -1.381136, -2.764967>,
      < 5.965990, -1.556588, -2.764967>
    }
    triangle {
      < 5.965990, -1.556588, -2.764967>,
      < 5.912778, -1.381136, -2.764967>,
      < 6.017613, -1.337719, -2.700042>
    }
    triangle {
      < 5.965990, -1.556588, -2.764967>,
      < 6.017613, -1.337719, -2.700042>,
      < 6.077280, -1.534457, -2.700042>
    }
    triangle {
      < 6.077280, -1.534457, -2.700042>,
      < 6.017613, -1.337719, -2.700042>,
      < 6.039188, -1.328784, -2.486032>
    }
    triangle {
      < 6.077280, -1.534457, -2.700042>,
      < 6.039188, -1.328784, -2.486032>,
      < 6.100183, -1.529903, -2.486032>
    }
    triangle {
      < 6.100183, -1.529903, -2.486032>,
      < 6.039188, -1.328784, -2.486032>,
      < 6.017613, -1.337719, -2.272216>
    }
    triangle {
      < 6.100183, -1.529903, -2.486032>,
      < 6.017613, -1.337719, -2.272216>,
      < 6.077280, -1.534457, -2.272216>
    }
    triangle {
      < 6.077280, -1.534457, -2.272216>,
      < 6.017613, -1.337719, -2.272216>,
      < 5.912778, -1.381136, -2.207291>
    }
    triangle {
      < 6.077280, -1.534457, -2.272216>,
      < 5.912778, -1.381136, -2.207291>,
      < 5.965990, -1.556588, -2.207291>
    }
    triangle {
      < 5.965990, -1.556588, -2.207291>,
      < 5.912778, -1.381136, -2.207291>,
      < 5.813414, -1.422288, -2.185108>
    }
    triangle {
      < 5.965990, -1.556588, -2.207291>,
      < 5.813414, -1.422288, -2.185108>,
      < 5.860507, -1.577563, -2.185108>
    }
    triangle {
      < 5.860507, -1.577563, -2.185108>,
      < 5.813414, -1.422288, -2.185108>,
      < 5.710090, -1.465079, -2.213441>
    }
    triangle {
      < 5.860507, -1.577563, -2.185108>,
      < 5.710090, -1.465079, -2.213441>,
      < 5.750820, -1.599375, -2.213441>
    }
    triangle {
      < 5.750820, -1.599375, -2.213441>,
      < 5.710090, -1.465079, -2.213441>,
      < 5.615024, -1.504450, -2.267810>
    }
    triangle {
      < 5.750820, -1.599375, -2.213441>,
      < 5.615024, -1.504450, -2.267810>,
      < 5.649899, -1.619444, -2.267810>
    }
    triangle {
      < 5.649899, -1.619444, -2.267810>,
      < 5.615024, -1.504450, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.579858, -1.519013, -2.704390>,
      < 5.526734, -1.419614, -2.704390>,
      < 5.558383, -1.398469, -2.704448>
    }
    triangle {
      < 5.579858, -1.519013, -2.704390>,
      < 5.558383, -1.398469, -2.704448>,
      < 5.615024, -1.504450, -2.704448>
    }
    triangle {
      < 5.615024, -1.504450, -2.704448>,
      < 5.558383, -1.398469, -2.704448>,
      < 5.643943, -1.341308, -2.758817>
    }
    triangle {
      < 5.615024, -1.504450, -2.704448>,
      < 5.643943, -1.341308, -2.758817>,
      < 5.710090, -1.465079, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.710090, -1.465079, -2.758817>,
      < 5.643943, -1.341308, -2.758817>,
      < 5.736934, -1.279182, -2.787150>
    }
    triangle {
      < 5.710090, -1.465079, -2.758817>,
      < 5.736934, -1.279182, -2.787150>,
      < 5.813414, -1.422288, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.813414, -1.422288, -2.787150>,
      < 5.736934, -1.279182, -2.787150>,
      < 5.826361, -1.219437, -2.764967>
    }
    triangle {
      < 5.813414, -1.422288, -2.787150>,
      < 5.826361, -1.219437, -2.764967>,
      < 5.912778, -1.381136, -2.764967>
    }
    triangle {
      < 5.912778, -1.381136, -2.764967>,
      < 5.826361, -1.219437, -2.764967>,
      < 5.920712, -1.156403, -2.700042>
    }
    triangle {
      < 5.912778, -1.381136, -2.764967>,
      < 5.920712, -1.156403, -2.700042>,
      < 6.017613, -1.337719, -2.700042>
    }
    triangle {
      < 6.017613, -1.337719, -2.700042>,
      < 5.920712, -1.156403, -2.700042>,
      < 5.940129, -1.143430, -2.486032>
    }
    triangle {
      < 6.017613, -1.337719, -2.700042>,
      < 5.940129, -1.143430, -2.486032>,
      < 6.039188, -1.328784, -2.486032>
    }
    triangle {
      < 6.039188, -1.328784, -2.486032>,
      < 5.940129, -1.143430, -2.486032>,
      < 5.920712, -1.156403, -2.272216>
    }
    triangle {
      < 6.039188, -1.328784, -2.486032>,
      < 5.920712, -1.156403, -2.272216>,
      < 6.017613, -1.337719, -2.272216>
    }
    triangle {
      < 6.017613, -1.337719, -2.272216>,
      < 5.920712, -1.156403, -2.272216>,
      < 5.826361, -1.219437, -2.207291>
    }
    triangle {
      < 6.017613, -1.337719, -2.272216>,
      < 5.826361, -1.219437, -2.207291>,
      < 5.912778, -1.381136, -2.207291>
    }
    triangle {
      < 5.912778, -1.381136, -2.207291>,
      < 5.826361, -1.219437, -2.207291>,
      < 5.736934, -1.279182, -2.185108>
    }
    triangle {
      < 5.912778, -1.381136, -2.207291>,
      < 5.736934, -1.279182, -2.185108>,
      < 5.813414, -1.422288, -2.185108>
    }
    triangle {
      < 5.813414, -1.422288, -2.185108>,
      < 5.736934, -1.279182, -2.185108>,
      < 5.643943, -1.341308, -2.213441>
    }
    triangle {
      < 5.813414, -1.422288, -2.185108>,
      < 5.643943, -1.341308, -2.213441>,
      < 5.710090, -1.465079, -2.213441>
    }
    triangle {
      < 5.710090, -1.465079, -2.213441>,
      < 5.643943, -1.341308, -2.213441>,
      < 5.558383, -1.398469, -2.267810>
    }
    triangle {
      < 5.710090, -1.465079, -2.213441>,
      < 5.558383, -1.398469, -2.267810>,
      < 5.615024, -1.504450, -2.267810>
    }
    triangle {
      < 5.615024, -1.504450, -2.267810>,
      < 5.558383, -1.398469, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.526734, -1.419614, -2.704390>,
      < 5.455241, -1.332487, -2.704390>,
      < 5.482157, -1.305575, -2.704448>
    }
    triangle {
      < 5.526734, -1.419614, -2.704390>,
      < 5.482157, -1.305575, -2.704448>,
      < 5.558383, -1.398469, -2.704448>
    }
    triangle {
      < 5.558383, -1.398469, -2.704448>,
      < 5.482157, -1.305575, -2.704448>,
      < 5.554921, -1.232821, -2.758817>
    }
    triangle {
      < 5.558383, -1.398469, -2.704448>,
      < 5.554921, -1.232821, -2.758817>,
      < 5.643943, -1.341308, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.643943, -1.341308, -2.758817>,
      < 5.554921, -1.232821, -2.758817>,
      < 5.634006, -1.153747, -2.787150>
    }
    triangle {
      < 5.643943, -1.341308, -2.758817>,
      < 5.634006, -1.153747, -2.787150>,
      < 5.736934, -1.279182, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.736934, -1.279182, -2.787150>,
      < 5.634006, -1.153747, -2.787150>,
      < 5.710057, -1.077703, -2.764967>
    }
    triangle {
      < 5.736934, -1.279182, -2.787150>,
      < 5.710057, -1.077703, -2.764967>,
      < 5.826361, -1.219437, -2.764967>
    }
    triangle {
      < 5.826361, -1.219437, -2.764967>,
      < 5.710057, -1.077703, -2.764967>,
      < 5.790298, -0.997473, -2.700042>
    }
    triangle {
      < 5.826361, -1.219437, -2.764967>,
      < 5.790298, -0.997473, -2.700042>,
      < 5.920712, -1.156403, -2.700042>
    }
    triangle {
      < 5.920712, -1.156403, -2.700042>,
      < 5.790298, -0.997473, -2.700042>,
      < 5.806811, -0.980962, -2.486032>
    }
    triangle {
      < 5.920712, -1.156403, -2.700042>,
      < 5.806811, -0.980962, -2.486032>,
      < 5.940129, -1.143430, -2.486032>
    }
    triangle {
      < 5.940129, -1.143430, -2.486032>,
      < 5.806811, -0.980962, -2.486032>,
      < 5.790298, -0.997473, -2.272216>
    }
    triangle {
      < 5.940129, -1.143430, -2.486032>,
      < 5.790298, -0.997473, -2.272216>,
      < 5.920712, -1.156403, -2.272216>
    }
    triangle {
      < 5.920712, -1.156403, -2.272216>,
      < 5.790298, -0.997473, -2.272216>,
      < 5.710057, -1.077703, -2.207291>
    }
    triangle {
      < 5.920712, -1.156403, -2.272216>,
      < 5.710057, -1.077703, -2.207291>,
      < 5.826361, -1.219437, -2.207291>
    }
    triangle {
      < 5.826361, -1.219437, -2.207291>,
      < 5.710057, -1.077703, -2.207291>,
      < 5.634006, -1.153747, -2.185108>
    }
    triangle {
      < 5.826361, -1.219437, -2.207291>,
      < 5.634006, -1.153747, -2.185108>,
      < 5.736934, -1.279182, -2.185108>
    }
    triangle {
      < 5.736934, -1.279182, -2.185108>,
      < 5.634006, -1.153747, -2.185108>,
      < 5.554921, -1.232821, -2.213441>
    }
    triangle {
      < 5.736934, -1.279182, -2.185108>,
      < 5.554921, -1.232821, -2.213441>,
      < 5.643943, -1.341308, -2.213441>
    }
    triangle {
      < 5.643943, -1.341308, -2.213441>,
      < 5.554921, -1.232821, -2.213441>,
      < 5.482157, -1.305575, -2.267810>
    }
    triangle {
      < 5.643943, -1.341308, -2.213441>,
      < 5.482157, -1.305575, -2.267810>,
      < 5.558383, -1.398469, -2.267810>
    }
    triangle {
      < 5.558383, -1.398469, -2.267810>,
      < 5.482157, -1.305575, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.455241, -1.332487, -2.704390>,
      < 5.368124, -1.260982, -2.704390>,
      < 5.389272, -1.229336, -2.704448>
    }
    triangle {
      < 5.455241, -1.332487, -2.704390>,
      < 5.389272, -1.229336, -2.704448>,
      < 5.482157, -1.305575, -2.704448>
    }
    triangle {
      < 5.482157, -1.305575, -2.704448>,
      < 5.389272, -1.229336, -2.704448>,
      < 5.446445, -1.143784, -2.758817>
    }
    triangle {
      < 5.482157, -1.305575, -2.704448>,
      < 5.446445, -1.143784, -2.758817>,
      < 5.554921, -1.232821, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.554921, -1.232821, -2.758817>,
      < 5.446445, -1.143784, -2.758817>,
      < 5.508583, -1.050802, -2.787150>
    }
    triangle {
      < 5.554921, -1.232821, -2.758817>,
      < 5.508583, -1.050802, -2.787150>,
      < 5.634006, -1.153747, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.634006, -1.153747, -2.787150>,
      < 5.508583, -1.050802, -2.787150>,
      < 5.568339, -0.961382, -2.764967>
    }
    triangle {
      < 5.634006, -1.153747, -2.787150>,
      < 5.568339, -0.961382, -2.764967>,
      < 5.710057, -1.077703, -2.764967>
    }
    triangle {
      < 5.710057, -1.077703, -2.764967>,
      < 5.568339, -0.961382, -2.764967>,
      < 5.631387, -0.867040, -2.700042>
    }
    triangle {
      < 5.710057, -1.077703, -2.764967>,
      < 5.631387, -0.867040, -2.700042>,
      < 5.790298, -0.997473, -2.700042>
    }
    triangle {
      < 5.790298, -0.997473, -2.700042>,
      < 5.631387, -0.867040, -2.700042>,
      < 5.644362, -0.847624, -2.486032>
    }
    triangle {
      < 5.790298, -0.997473, -2.700042>,
      < 5.644362, -0.847624, -2.486032>,
      < 5.806811, -0.980962, -2.486032>
    }
    triangle {
      < 5.806811, -0.980962, -2.486032>,
      < 5.644362, -0.847624, -2.486032>,
      < 5.631387, -0.867040, -2.272216>
    }
    triangle {
      < 5.806811, -0.980962, -2.486032>,
      < 5.631387, -0.867040, -2.272216>,
      < 5.790298, -0.997473, -2.272216>
    }
    triangle {
      < 5.790298, -0.997473, -2.272216>,
      < 5.631387, -0.867040, -2.272216>,
      < 5.568339, -0.961382, -2.207291>
    }
    triangle {
      < 5.790298, -0.997473, -2.272216>,
      < 5.568339, -0.961382, -2.207291>,
      < 5.710057, -1.077703, -2.207291>
    }
    triangle {
      < 5.710057, -1.077703, -2.207291>,
      < 5.568339, -0.961382, -2.207291>,
      < 5.508583, -1.050802, -2.185108>
    }
    triangle {
      < 5.710057, -1.077703, -2.207291>,
      < 5.508583, -1.050802, -2.185108>,
      < 5.634006, -1.153747, -2.185108>
    }
    triangle {
      < 5.634006, -1.153747, -2.185108>,
      < 5.508583, -1.050802, -2.185108>,
      < 5.446445, -1.143784, -2.213441>
    }
    triangle {
      < 5.634006, -1.153747, -2.185108>,
      < 5.446445, -1.143784, -2.213441>,
      < 5.554921, -1.232821, -2.213441>
    }
    triangle {
      < 5.554921, -1.232821, -2.213441>,
      < 5.446445, -1.143784, -2.213441>,
      < 5.389272, -1.229336, -2.267810>
    }
    triangle {
      < 5.554921, -1.232821, -2.213441>,
      < 5.389272, -1.229336, -2.267810>,
      < 5.482157, -1.305575, -2.267810>
    }
    triangle {
      < 5.482157, -1.305575, -2.267810>,
      < 5.389272, -1.229336, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.368124, -1.260982, -2.704390>,
      < 5.268731, -1.207846, -2.704390>,
      < 5.283298, -1.172683, -2.704448>
    }
    triangle {
      < 5.368124, -1.260982, -2.704390>,
      < 5.283298, -1.172683, -2.704448>,
      < 5.389272, -1.229336, -2.704448>
    }
    triangle {
      < 5.389272, -1.229336, -2.704448>,
      < 5.283298, -1.172683, -2.704448>,
      < 5.322682, -1.077621, -2.758817>
    }
    triangle {
      < 5.389272, -1.229336, -2.704448>,
      < 5.322682, -1.077621, -2.758817>,
      < 5.446445, -1.143784, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.446445, -1.143784, -2.758817>,
      < 5.322682, -1.077621, -2.758817>,
      < 5.365488, -0.974301, -2.787150>
    }
    triangle {
      < 5.446445, -1.143784, -2.758817>,
      < 5.365488, -0.974301, -2.787150>,
      < 5.508583, -1.050802, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.508583, -1.050802, -2.787150>,
      < 5.365488, -0.974301, -2.787150>,
      < 5.406651, -0.874944, -2.764967>
    }
    triangle {
      < 5.508583, -1.050802, -2.787150>,
      < 5.406651, -0.874944, -2.764967>,
      < 5.568339, -0.961382, -2.764967>
    }
    triangle {
      < 5.568339, -0.961382, -2.764967>,
      < 5.406651, -0.874944, -2.764967>,
      < 5.450083, -0.770114, -2.700042>
    }
    triangle {
      < 5.568339, -0.961382, -2.764967>,
      < 5.450083, -0.770114, -2.700042>,
      < 5.631387, -0.867040, -2.700042>
    }
    triangle {
      < 5.631387, -0.867040, -2.700042>,
      < 5.450083, -0.770114, -2.700042>,
      < 5.459021, -0.748540, -2.486032>
    }
    triangle {
      < 5.631387, -0.867040, -2.700042>,
      < 5.459021, -0.748540, -2.486032>,
      < 5.644362, -0.847624, -2.486032>
    }
    triangle {
      < 5.644362, -0.847624, -2.486032>,
      < 5.459021, -0.748540, -2.486032>,
      < 5.450083, -0.770114, -2.272216>
    }
    triangle {
      < 5.644362, -0.847624, -2.486032>,
      < 5.450083, -0.770114, -2.272216>,
      < 5.631387, -0.867040, -2.272216>
    }
    triangle {
      < 5.631387, -0.867040, -2.272216>,
      < 5.450083, -0.770114, -2.272216>,
      < 5.406651, -0.874944, -2.207291>
    }
    triangle {
      < 5.631387, -0.867040, -2.272216>,
      < 5.406651, -0.874944, -2.207291>,
      < 5.568339, -0.961382, -2.207291>
    }
    triangle {
      < 5.568339, -0.961382, -2.207291>,
      < 5.406651, -0.874944, -2.207291>,
      < 5.365488, -0.974301, -2.185108>
    }
    triangle {
      < 5.568339, -0.961382, -2.207291>,
      < 5.365488, -0.974301, -2.185108>,
      < 5.508583, -1.050802, -2.185108>
    }
    triangle {
      < 5.508583, -1.050802, -2.185108>,
      < 5.365488, -0.974301, -2.185108>,
      < 5.322682, -1.077621, -2.213441>
    }
    triangle {
      < 5.508583, -1.050802, -2.185108>,
      < 5.322682, -1.077621, -2.213441>,
      < 5.446445, -1.143784, -2.213441>
    }
    triangle {
      < 5.446445, -1.143784, -2.213441>,
      < 5.322682, -1.077621, -2.213441>,
      < 5.283298, -1.172683, -2.267810>
    }
    triangle {
      < 5.446445, -1.143784, -2.213441>,
      < 5.283298, -1.172683, -2.267810>,
      < 5.389272, -1.229336, -2.267810>
    }
    triangle {
      < 5.389272, -1.229336, -2.267810>,
      < 5.283298, -1.172683, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.268731, -1.207846, -2.704390>,
      < 5.160882, -1.175122, -2.704390>,
      < 5.168311, -1.137792, -2.704448>
    }
    triangle {
      < 5.268731, -1.207846, -2.704390>,
      < 5.168311, -1.137792, -2.704448>,
      < 5.283298, -1.172683, -2.704448>
    }
    triangle {
      < 5.283298, -1.172683, -2.704448>,
      < 5.168311, -1.137792, -2.704448>,
      < 5.188392, -1.036873, -2.758817>
    }
    triangle {
      < 5.283298, -1.172683, -2.704448>,
      < 5.188392, -1.036873, -2.758817>,
      < 5.322682, -1.077621, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.322682, -1.077621, -2.758817>,
      < 5.188392, -1.036873, -2.758817>,
      < 5.210217, -0.927189, -2.787150>
    }
    triangle {
      < 5.322682, -1.077621, -2.758817>,
      < 5.210217, -0.927189, -2.787150>,
      < 5.365488, -0.974301, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.365488, -0.974301, -2.787150>,
      < 5.210217, -0.927189, -2.787150>,
      < 5.231207, -0.821709, -2.764967>
    }
    triangle {
      < 5.365488, -0.974301, -2.787150>,
      < 5.231207, -0.821709, -2.764967>,
      < 5.406651, -0.874944, -2.764967>
    }
    triangle {
      < 5.406651, -0.874944, -2.764967>,
      < 5.231207, -0.821709, -2.764967>,
      < 5.253354, -0.710421, -2.700042>
    }
    triangle {
      < 5.406651, -0.874944, -2.764967>,
      < 5.253354, -0.710421, -2.700042>,
      < 5.450083, -0.770114, -2.700042>
    }
    triangle {
      < 5.450083, -0.770114, -2.700042>,
      < 5.253354, -0.710421, -2.700042>,
      < 5.257910, -0.687518, -2.486032>
    }
    triangle {
      < 5.450083, -0.770114, -2.700042>,
      < 5.257910, -0.687518, -2.486032>,
      < 5.459021, -0.748540, -2.486032>
    }
    triangle {
      < 5.459021, -0.748540, -2.486032>,
      < 5.257910, -0.687518, -2.486032>,
      < 5.253354, -0.710421, -2.272216>
    }
    triangle {
      < 5.459021, -0.748540, -2.486032>,
      < 5.253354, -0.710421, -2.272216>,
      < 5.450083, -0.770114, -2.272216>
    }
    triangle {
      < 5.450083, -0.770114, -2.272216>,
      < 5.253354, -0.710421, -2.272216>,
      < 5.231207, -0.821709, -2.207291>
    }
    triangle {
      < 5.450083, -0.770114, -2.272216>,
      < 5.231207, -0.821709, -2.207291>,
      < 5.406651, -0.874944, -2.207291>
    }
    triangle {
      < 5.406651, -0.874944, -2.207291>,
      < 5.231207, -0.821709, -2.207291>,
      < 5.210217, -0.927189, -2.185108>
    }
    triangle {
      < 5.406651, -0.874944, -2.207291>,
      < 5.210217, -0.927189, -2.185108>,
      < 5.365488, -0.974301, -2.185108>
    }
    triangle {
      < 5.365488, -0.974301, -2.185108>,
      < 5.210217, -0.927189, -2.185108>,
      < 5.188392, -1.036873, -2.213441>
    }
    triangle {
      < 5.365488, -0.974301, -2.185108>,
      < 5.188392, -1.036873, -2.213441>,
      < 5.322682, -1.077621, -2.213441>
    }
    triangle {
      < 5.322682, -1.077621, -2.213441>,
      < 5.188392, -1.036873, -2.213441>,
      < 5.168311, -1.137792, -2.267810>
    }
    triangle {
      < 5.322682, -1.077621, -2.213441>,
      < 5.168311, -1.137792, -2.267810>,
      < 5.283298, -1.172683, -2.267810>
    }
    triangle {
      < 5.283298, -1.172683, -2.267810>,
      < 5.168311, -1.137792, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.160882, -1.175122, -2.704390>,
      < 5.048720, -1.164066, -2.704390>,
      < 5.048723, -1.126004, -2.704448>
    }
    triangle {
      < 5.160882, -1.175122, -2.704390>,
      < 5.048723, -1.126004, -2.704448>,
      < 5.168311, -1.137792, -2.704448>
    }
    triangle {
      < 5.168311, -1.137792, -2.704448>,
      < 5.048723, -1.126004, -2.704448>,
      < 5.048732, -1.023107, -2.758817>
    }
    triangle {
      < 5.168311, -1.137792, -2.704448>,
      < 5.048732, -1.023107, -2.758817>,
      < 5.188392, -1.036873, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.188392, -1.036873, -2.758817>,
      < 5.048732, -1.023107, -2.758817>,
      < 5.048739, -0.911271, -2.787150>
    }
    triangle {
      < 5.188392, -1.036873, -2.758817>,
      < 5.048739, -0.911271, -2.787150>,
      < 5.210217, -0.927189, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.210217, -0.927189, -2.787150>,
      < 5.048739, -0.911271, -2.787150>,
      < 5.048749, -0.803724, -2.764967>
    }
    triangle {
      < 5.210217, -0.927189, -2.787150>,
      < 5.048749, -0.803724, -2.764967>,
      < 5.231207, -0.821709, -2.764967>
    }
    triangle {
      < 5.231207, -0.821709, -2.764967>,
      < 5.048749, -0.803724, -2.764967>,
      < 5.048757, -0.690254, -2.700042>
    }
    triangle {
      < 5.231207, -0.821709, -2.764967>,
      < 5.048757, -0.690254, -2.700042>,
      < 5.253354, -0.710421, -2.700042>
    }
    triangle {
      < 5.253354, -0.710421, -2.700042>,
      < 5.048757, -0.690254, -2.700042>,
      < 5.048759, -0.666902, -2.486032>
    }
    triangle {
      < 5.253354, -0.710421, -2.700042>,
      < 5.048759, -0.666902, -2.486032>,
      < 5.257910, -0.687518, -2.486032>
    }
    triangle {
      < 5.257910, -0.687518, -2.486032>,
      < 5.048759, -0.666902, -2.486032>,
      < 5.048757, -0.690254, -2.272216>
    }
    triangle {
      < 5.257910, -0.687518, -2.486032>,
      < 5.048757, -0.690254, -2.272216>,
      < 5.253354, -0.710421, -2.272216>
    }
    triangle {
      < 5.253354, -0.710421, -2.272216>,
      < 5.048757, -0.690254, -2.272216>,
      < 5.048749, -0.803724, -2.207291>
    }
    triangle {
      < 5.253354, -0.710421, -2.272216>,
      < 5.048749, -0.803724, -2.207291>,
      < 5.231207, -0.821709, -2.207291>
    }
    triangle {
      < 5.231207, -0.821709, -2.207291>,
      < 5.048749, -0.803724, -2.207291>,
      < 5.048739, -0.911271, -2.185108>
    }
    triangle {
      < 5.231207, -0.821709, -2.207291>,
      < 5.048739, -0.911271, -2.185108>,
      < 5.210217, -0.927189, -2.185108>
    }
    triangle {
      < 5.210217, -0.927189, -2.185108>,
      < 5.048739, -0.911271, -2.185108>,
      < 5.048732, -1.023107, -2.213441>
    }
    triangle {
      < 5.210217, -0.927189, -2.185108>,
      < 5.048732, -1.023107, -2.213441>,
      < 5.188392, -1.036873, -2.213441>
    }
    triangle {
      < 5.188392, -1.036873, -2.213441>,
      < 5.048732, -1.023107, -2.213441>,
      < 5.048723, -1.126004, -2.267810>
    }
    triangle {
      < 5.188392, -1.036873, -2.213441>,
      < 5.048723, -1.126004, -2.267810>,
      < 5.168311, -1.137792, -2.267810>
    }
    triangle {
      < 5.168311, -1.137792, -2.267810>,
      < 5.048723, -1.126004, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 5.048720, -1.164066, -2.704390>,
      < 4.936557, -1.175104, -2.704390>,
      < 4.929134, -1.137773, -2.704448>
    }
    triangle {
      < 5.048720, -1.164066, -2.704390>,
      < 4.929134, -1.137773, -2.704448>,
      < 5.048723, -1.126004, -2.704448>
    }
    triangle {
      < 5.048723, -1.126004, -2.704448>,
      < 4.929134, -1.137773, -2.704448>,
      < 4.909069, -1.036851, -2.758817>
    }
    triangle {
      < 5.048723, -1.126004, -2.704448>,
      < 4.909069, -1.036851, -2.758817>,
      < 5.048732, -1.023107, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.048732, -1.023107, -2.758817>,
      < 4.909069, -1.036851, -2.758817>,
      < 4.887259, -0.927164, -2.787150>
    }
    triangle {
      < 5.048732, -1.023107, -2.758817>,
      < 4.887259, -0.927164, -2.787150>,
      < 5.048739, -0.911271, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.048739, -0.911271, -2.787150>,
      < 4.887259, -0.927164, -2.787150>,
      < 4.866287, -0.821680, -2.764967>
    }
    triangle {
      < 5.048739, -0.911271, -2.787150>,
      < 4.866287, -0.821680, -2.764967>,
      < 5.048749, -0.803724, -2.764967>
    }
    triangle {
      < 5.048749, -0.803724, -2.764967>,
      < 4.866287, -0.821680, -2.764967>,
      < 4.844159, -0.710389, -2.700042>
    }
    triangle {
      < 5.048749, -0.803724, -2.764967>,
      < 4.844159, -0.710389, -2.700042>,
      < 5.048757, -0.690254, -2.700042>
    }
    triangle {
      < 5.048757, -0.690254, -2.700042>,
      < 4.844159, -0.710389, -2.700042>,
      < 4.839604, -0.687485, -2.486032>
    }
    triangle {
      < 5.048757, -0.690254, -2.700042>,
      < 4.839604, -0.687485, -2.486032>,
      < 5.048759, -0.666902, -2.486032>
    }
    triangle {
      < 5.048759, -0.666902, -2.486032>,
      < 4.839604, -0.687485, -2.486032>,
      < 4.844159, -0.710389, -2.272216>
    }
    triangle {
      < 5.048759, -0.666902, -2.486032>,
      < 4.844159, -0.710389, -2.272216>,
      < 5.048757, -0.690254, -2.272216>
    }
    triangle {
      < 5.048757, -0.690254, -2.272216>,
      < 4.844159, -0.710389, -2.272216>,
      < 4.866287, -0.821680, -2.207291>
    }
    triangle {
      < 5.048757, -0.690254, -2.272216>,
      < 4.866287, -0.821680, -2.207291>,
      < 5.048749, -0.803724, -2.207291>
    }
    triangle {
      < 5.048749, -0.803724, -2.207291>,
      < 4.866287, -0.821680, -2.207291>,
      < 4.887259, -0.927164, -2.185108>
    }
    triangle {
      < 5.048749, -0.803724, -2.207291>,
      < 4.887259, -0.927164, -2.185108>,
      < 5.048739, -0.911271, -2.185108>
    }
    triangle {
      < 5.048739, -0.911271, -2.185108>,
      < 4.887259, -0.927164, -2.185108>,
      < 4.909069, -1.036851, -2.213441>
    }
    triangle {
      < 5.048739, -0.911271, -2.185108>,
      < 4.909069, -1.036851, -2.213441>,
      < 5.048732, -1.023107, -2.213441>
    }
    triangle {
      < 5.048732, -1.023107, -2.213441>,
      < 4.909069, -1.036851, -2.213441>,
      < 4.929134, -1.137773, -2.267810>
    }
    triangle {
      < 5.048732, -1.023107, -2.213441>,
      < 4.929134, -1.137773, -2.267810>,
      < 5.048723, -1.126004, -2.267810>
    }
    triangle {
      < 5.048723, -1.126004, -2.267810>,
      < 4.929134, -1.137773, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.936557, -1.175104, -2.704390>,
      < 4.828702, -1.207811, -2.704390>,
      < 4.814141, -1.172645, -2.704448>
    }
    triangle {
      < 4.936557, -1.175104, -2.704390>,
      < 4.814141, -1.172645, -2.704448>,
      < 4.929134, -1.137773, -2.704448>
    }
    triangle {
      < 4.929134, -1.137773, -2.704448>,
      < 4.814141, -1.172645, -2.704448>,
      < 4.774771, -1.077578, -2.758817>
    }
    triangle {
      < 4.929134, -1.137773, -2.704448>,
      < 4.774771, -1.077578, -2.758817>,
      < 4.909069, -1.036851, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.909069, -1.036851, -2.758817>,
      < 4.774771, -1.077578, -2.758817>,
      < 4.731982, -0.974252, -2.787150>
    }
    triangle {
      < 4.909069, -1.036851, -2.758817>,
      < 4.731982, -0.974252, -2.787150>,
      < 4.887259, -0.927164, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.887259, -0.927164, -2.787150>,
      < 4.731982, -0.974252, -2.787150>,
      < 4.690834, -0.874888, -2.764967>
    }
    triangle {
      < 4.887259, -0.927164, -2.787150>,
      < 4.690834, -0.874888, -2.764967>,
      < 4.866287, -0.821680, -2.764967>
    }
    triangle {
      < 4.866287, -0.821680, -2.764967>,
      < 4.690834, -0.874888, -2.764967>,
      < 4.647419, -0.770051, -2.700042>
    }
    triangle {
      < 4.866287, -0.821680, -2.764967>,
      < 4.647419, -0.770051, -2.700042>,
      < 4.844159, -0.710389, -2.700042>
    }
    triangle {
      < 4.844159, -0.710389, -2.700042>,
      < 4.647419, -0.770051, -2.700042>,
      < 4.638484, -0.748475, -2.486032>
    }
    triangle {
      < 4.844159, -0.710389, -2.700042>,
      < 4.638484, -0.748475, -2.486032>,
      < 4.839604, -0.687485, -2.486032>
    }
    triangle {
      < 4.839604, -0.687485, -2.486032>,
      < 4.638484, -0.748475, -2.486032>,
      < 4.647419, -0.770051, -2.272216>
    }
    triangle {
      < 4.839604, -0.687485, -2.486032>,
      < 4.647419, -0.770051, -2.272216>,
      < 4.844159, -0.710389, -2.272216>
    }
    triangle {
      < 4.844159, -0.710389, -2.272216>,
      < 4.647419, -0.770051, -2.272216>,
      < 4.690834, -0.874888, -2.207291>
    }
    triangle {
      < 4.844159, -0.710389, -2.272216>,
      < 4.690834, -0.874888, -2.207291>,
      < 4.866287, -0.821680, -2.207291>
    }
    triangle {
      < 4.866287, -0.821680, -2.207291>,
      < 4.690834, -0.874888, -2.207291>,
      < 4.731982, -0.974252, -2.185108>
    }
    triangle {
      < 4.866287, -0.821680, -2.207291>,
      < 4.731982, -0.974252, -2.185108>,
      < 4.887259, -0.927164, -2.185108>
    }
    triangle {
      < 4.887259, -0.927164, -2.185108>,
      < 4.731982, -0.974252, -2.185108>,
      < 4.774771, -1.077578, -2.213441>
    }
    triangle {
      < 4.887259, -0.927164, -2.185108>,
      < 4.774771, -1.077578, -2.213441>,
      < 4.909069, -1.036851, -2.213441>
    }
    triangle {
      < 4.909069, -1.036851, -2.213441>,
      < 4.774771, -1.077578, -2.213441>,
      < 4.814141, -1.172645, -2.267810>
    }
    triangle {
      < 4.909069, -1.036851, -2.213441>,
      < 4.814141, -1.172645, -2.267810>,
      < 4.929134, -1.137773, -2.267810>
    }
    triangle {
      < 4.929134, -1.137773, -2.267810>,
      < 4.814141, -1.172645, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.828702, -1.207811, -2.704390>,
      < 4.729301, -1.260931, -2.704390>,
      < 4.708158, -1.229283, -2.704448>
    }
    triangle {
      < 4.828702, -1.207811, -2.704390>,
      < 4.708158, -1.229283, -2.704448>,
      < 4.814141, -1.172645, -2.704448>
    }
    triangle {
      < 4.814141, -1.172645, -2.704448>,
      < 4.708158, -1.229283, -2.704448>,
      < 4.650999, -1.143721, -2.758817>
    }
    triangle {
      < 4.814141, -1.172645, -2.704448>,
      < 4.650999, -1.143721, -2.758817>,
      < 4.774771, -1.077578, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.774771, -1.077578, -2.758817>,
      < 4.650999, -1.143721, -2.758817>,
      < 4.588875, -1.050729, -2.787150>
    }
    triangle {
      < 4.774771, -1.077578, -2.758817>,
      < 4.588875, -1.050729, -2.787150>,
      < 4.731982, -0.974252, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.731982, -0.974252, -2.787150>,
      < 4.588875, -1.050729, -2.787150>,
      < 4.529133, -0.961300, -2.764967>
    }
    triangle {
      < 4.731982, -0.974252, -2.787150>,
      < 4.529133, -0.961300, -2.764967>,
      < 4.690834, -0.874888, -2.764967>
    }
    triangle {
      < 4.690834, -0.874888, -2.764967>,
      < 4.529133, -0.961300, -2.764967>,
      < 4.466101, -0.866948, -2.700042>
    }
    triangle {
      < 4.690834, -0.874888, -2.764967>,
      < 4.466101, -0.866948, -2.700042>,
      < 4.647419, -0.770051, -2.700042>
    }
    triangle {
      < 4.647419, -0.770051, -2.700042>,
      < 4.466101, -0.866948, -2.700042>,
      < 4.453129, -0.847530, -2.486032>
    }
    triangle {
      < 4.647419, -0.770051, -2.700042>,
      < 4.453129, -0.847530, -2.486032>,
      < 4.638484, -0.748475, -2.486032>
    }
    triangle {
      < 4.638484, -0.748475, -2.486032>,
      < 4.453129, -0.847530, -2.486032>,
      < 4.466101, -0.866948, -2.272216>
    }
    triangle {
      < 4.638484, -0.748475, -2.486032>,
      < 4.466101, -0.866948, -2.272216>,
      < 4.647419, -0.770051, -2.272216>
    }
    triangle {
      < 4.647419, -0.770051, -2.272216>,
      < 4.466101, -0.866948, -2.272216>,
      < 4.529133, -0.961300, -2.207291>
    }
    triangle {
      < 4.647419, -0.770051, -2.272216>,
      < 4.529133, -0.961300, -2.207291>,
      < 4.690834, -0.874888, -2.207291>
    }
    triangle {
      < 4.690834, -0.874888, -2.207291>,
      < 4.529133, -0.961300, -2.207291>,
      < 4.588875, -1.050729, -2.185108>
    }
    triangle {
      < 4.690834, -0.874888, -2.207291>,
      < 4.588875, -1.050729, -2.185108>,
      < 4.731982, -0.974252, -2.185108>
    }
    triangle {
      < 4.731982, -0.974252, -2.185108>,
      < 4.588875, -1.050729, -2.185108>,
      < 4.650999, -1.143721, -2.213441>
    }
    triangle {
      < 4.731982, -0.974252, -2.185108>,
      < 4.650999, -1.143721, -2.213441>,
      < 4.774771, -1.077578, -2.213441>
    }
    triangle {
      < 4.774771, -1.077578, -2.213441>,
      < 4.650999, -1.143721, -2.213441>,
      < 4.708158, -1.229283, -2.267810>
    }
    triangle {
      < 4.774771, -1.077578, -2.213441>,
      < 4.708158, -1.229283, -2.267810>,
      < 4.814141, -1.172645, -2.267810>
    }
    triangle {
      < 4.814141, -1.172645, -2.267810>,
      < 4.708158, -1.229283, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.729301, -1.260931, -2.704390>,
      < 4.642173, -1.332422, -2.704390>,
      < 4.615262, -1.305506, -2.704448>
    }
    triangle {
      < 4.729301, -1.260931, -2.704390>,
      < 4.615262, -1.305506, -2.704448>,
      < 4.708158, -1.229283, -2.704448>
    }
    triangle {
      < 4.708158, -1.229283, -2.704448>,
      < 4.615262, -1.305506, -2.704448>,
      < 4.542509, -1.232740, -2.758817>
    }
    triangle {
      < 4.708158, -1.229283, -2.704448>,
      < 4.542509, -1.232740, -2.758817>,
      < 4.650999, -1.143721, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.650999, -1.143721, -2.758817>,
      < 4.542509, -1.232740, -2.758817>,
      < 4.463437, -1.153654, -2.787150>
    }
    triangle {
      < 4.650999, -1.143721, -2.758817>,
      < 4.463437, -1.153654, -2.787150>,
      < 4.588875, -1.050729, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.588875, -1.050729, -2.787150>,
      < 4.463437, -1.153654, -2.787150>,
      < 4.387395, -1.077599, -2.764967>
    }
    triangle {
      < 4.588875, -1.050729, -2.787150>,
      < 4.387395, -1.077599, -2.764967>,
      < 4.529133, -0.961300, -2.764967>
    }
    triangle {
      < 4.529133, -0.961300, -2.764967>,
      < 4.387395, -1.077599, -2.764967>,
      < 4.307168, -0.997356, -2.700042>
    }
    triangle {
      < 4.529133, -0.961300, -2.764967>,
      < 4.307168, -0.997356, -2.700042>,
      < 4.466101, -0.866948, -2.700042>
    }
    triangle {
      < 4.466101, -0.866948, -2.700042>,
      < 4.307168, -0.997356, -2.700042>,
      < 4.290657, -0.980842, -2.486032>
    }
    triangle {
      < 4.466101, -0.866948, -2.700042>,
      < 4.290657, -0.980842, -2.486032>,
      < 4.453129, -0.847530, -2.486032>
    }
    triangle {
      < 4.453129, -0.847530, -2.486032>,
      < 4.290657, -0.980842, -2.486032>,
      < 4.307168, -0.997356, -2.272216>
    }
    triangle {
      < 4.453129, -0.847530, -2.486032>,
      < 4.307168, -0.997356, -2.272216>,
      < 4.466101, -0.866948, -2.272216>
    }
    triangle {
      < 4.466101, -0.866948, -2.272216>,
      < 4.307168, -0.997356, -2.272216>,
      < 4.387395, -1.077599, -2.207291>
    }
    triangle {
      < 4.466101, -0.866948, -2.272216>,
      < 4.387395, -1.077599, -2.207291>,
      < 4.529133, -0.961300, -2.207291>
    }
    triangle {
      < 4.529133, -0.961300, -2.207291>,
      < 4.387395, -1.077599, -2.207291>,
      < 4.463437, -1.153654, -2.185108>
    }
    triangle {
      < 4.529133, -0.961300, -2.207291>,
      < 4.463437, -1.153654, -2.185108>,
      < 4.588875, -1.050729, -2.185108>
    }
    triangle {
      < 4.588875, -1.050729, -2.185108>,
      < 4.463437, -1.153654, -2.185108>,
      < 4.542509, -1.232740, -2.213441>
    }
    triangle {
      < 4.588875, -1.050729, -2.185108>,
      < 4.542509, -1.232740, -2.213441>,
      < 4.650999, -1.143721, -2.213441>
    }
    triangle {
      < 4.650999, -1.143721, -2.213441>,
      < 4.542509, -1.232740, -2.213441>,
      < 4.615262, -1.305506, -2.267810>
    }
    triangle {
      < 4.650999, -1.143721, -2.213441>,
      < 4.615262, -1.305506, -2.267810>,
      < 4.708158, -1.229283, -2.267810>
    }
    triangle {
      < 4.708158, -1.229283, -2.267810>,
      < 4.615262, -1.305506, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.642173, -1.332422, -2.704390>,
      < 4.570664, -1.419538, -2.704390>,
      < 4.539020, -1.398389, -2.704448>
    }
    triangle {
      < 4.642173, -1.332422, -2.704390>,
      < 4.539020, -1.398389, -2.704448>,
      < 4.615262, -1.305506, -2.704448>
    }
    triangle {
      < 4.615262, -1.305506, -2.704448>,
      < 4.539020, -1.398389, -2.704448>,
      < 4.453470, -1.341214, -2.758817>
    }
    triangle {
      < 4.615262, -1.305506, -2.704448>,
      < 4.453470, -1.341214, -2.758817>,
      < 4.542509, -1.232740, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.542509, -1.232740, -2.758817>,
      < 4.453470, -1.341214, -2.758817>,
      < 4.360487, -1.279073, -2.787150>
    }
    triangle {
      < 4.542509, -1.232740, -2.758817>,
      < 4.360487, -1.279073, -2.787150>,
      < 4.463437, -1.153654, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.463437, -1.153654, -2.787150>,
      < 4.360487, -1.279073, -2.787150>,
      < 4.271070, -1.219314, -2.764967>
    }
    triangle {
      < 4.463437, -1.153654, -2.787150>,
      < 4.271070, -1.219314, -2.764967>,
      < 4.387395, -1.077599, -2.764967>
    }
    triangle {
      < 4.387395, -1.077599, -2.764967>,
      < 4.271070, -1.219314, -2.764967>,
      < 4.176731, -1.156265, -2.700042>
    }
    triangle {
      < 4.387395, -1.077599, -2.764967>,
      < 4.176731, -1.156265, -2.700042>,
      < 4.307168, -0.997356, -2.700042>
    }
    triangle {
      < 4.307168, -0.997356, -2.700042>,
      < 4.176731, -1.156265, -2.700042>,
      < 4.157315, -1.143289, -2.486032>
    }
    triangle {
      < 4.307168, -0.997356, -2.700042>,
      < 4.157315, -1.143289, -2.486032>,
      < 4.290657, -0.980842, -2.486032>
    }
    triangle {
      < 4.290657, -0.980842, -2.486032>,
      < 4.157315, -1.143289, -2.486032>,
      < 4.176731, -1.156265, -2.272216>
    }
    triangle {
      < 4.290657, -0.980842, -2.486032>,
      < 4.176731, -1.156265, -2.272216>,
      < 4.307168, -0.997356, -2.272216>
    }
    triangle {
      < 4.307168, -0.997356, -2.272216>,
      < 4.176731, -1.156265, -2.272216>,
      < 4.271070, -1.219314, -2.207291>
    }
    triangle {
      < 4.307168, -0.997356, -2.272216>,
      < 4.271070, -1.219314, -2.207291>,
      < 4.387395, -1.077599, -2.207291>
    }
    triangle {
      < 4.387395, -1.077599, -2.207291>,
      < 4.271070, -1.219314, -2.207291>,
      < 4.360487, -1.279073, -2.185108>
    }
    triangle {
      < 4.387395, -1.077599, -2.207291>,
      < 4.360487, -1.279073, -2.185108>,
      < 4.463437, -1.153654, -2.185108>
    }
    triangle {
      < 4.463437, -1.153654, -2.185108>,
      < 4.360487, -1.279073, -2.185108>,
      < 4.453470, -1.341214, -2.213441>
    }
    triangle {
      < 4.463437, -1.153654, -2.185108>,
      < 4.453470, -1.341214, -2.213441>,
      < 4.542509, -1.232740, -2.213441>
    }
    triangle {
      < 4.542509, -1.232740, -2.213441>,
      < 4.453470, -1.341214, -2.213441>,
      < 4.539020, -1.398389, -2.267810>
    }
    triangle {
      < 4.542509, -1.232740, -2.213441>,
      < 4.539020, -1.398389, -2.267810>,
      < 4.615262, -1.305506, -2.267810>
    }
    triangle {
      < 4.615262, -1.305506, -2.267810>,
      < 4.539020, -1.398389, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.570664, -1.419538, -2.704390>,
      < 4.517527, -1.518929, -2.704390>,
      < 4.482363, -1.504360, -2.704448>
    }
    triangle {
      < 4.570664, -1.419538, -2.704390>,
      < 4.482363, -1.504360, -2.704448>,
      < 4.539020, -1.398389, -2.704448>
    }
    triangle {
      < 4.539020, -1.398389, -2.704448>,
      < 4.482363, -1.504360, -2.704448>,
      < 4.387302, -1.464975, -2.758817>
    }
    triangle {
      < 4.539020, -1.398389, -2.704448>,
      < 4.387302, -1.464975, -2.758817>,
      < 4.453470, -1.341214, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.453470, -1.341214, -2.758817>,
      < 4.387302, -1.464975, -2.758817>,
      < 4.283986, -1.422167, -2.787150>
    }
    triangle {
      < 4.453470, -1.341214, -2.758817>,
      < 4.283986, -1.422167, -2.787150>,
      < 4.360487, -1.279073, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.360487, -1.279073, -2.787150>,
      < 4.283986, -1.422167, -2.787150>,
      < 4.184628, -1.381000, -2.764967>
    }
    triangle {
      < 4.360487, -1.279073, -2.787150>,
      < 4.184628, -1.381000, -2.764967>,
      < 4.271070, -1.219314, -2.764967>
    }
    triangle {
      < 4.271070, -1.219314, -2.764967>,
      < 4.184628, -1.381000, -2.764967>,
      < 4.079800, -1.337567, -2.700042>
    }
    triangle {
      < 4.271070, -1.219314, -2.764967>,
      < 4.079800, -1.337567, -2.700042>,
      < 4.176731, -1.156265, -2.700042>
    }
    triangle {
      < 4.176731, -1.156265, -2.700042>,
      < 4.079800, -1.337567, -2.700042>,
      < 4.058226, -1.328627, -2.486032>
    }
    triangle {
      < 4.176731, -1.156265, -2.700042>,
      < 4.058226, -1.328627, -2.486032>,
      < 4.157315, -1.143289, -2.486032>
    }
    triangle {
      < 4.157315, -1.143289, -2.486032>,
      < 4.058226, -1.328627, -2.486032>,
      < 4.079800, -1.337567, -2.272216>
    }
    triangle {
      < 4.157315, -1.143289, -2.486032>,
      < 4.079800, -1.337567, -2.272216>,
      < 4.176731, -1.156265, -2.272216>
    }
    triangle {
      < 4.176731, -1.156265, -2.272216>,
      < 4.079800, -1.337567, -2.272216>,
      < 4.184628, -1.381000, -2.207291>
    }
    triangle {
      < 4.176731, -1.156265, -2.272216>,
      < 4.184628, -1.381000, -2.207291>,
      < 4.271070, -1.219314, -2.207291>
    }
    triangle {
      < 4.271070, -1.219314, -2.207291>,
      < 4.184628, -1.381000, -2.207291>,
      < 4.283986, -1.422167, -2.185108>
    }
    triangle {
      < 4.271070, -1.219314, -2.207291>,
      < 4.283986, -1.422167, -2.185108>,
      < 4.360487, -1.279073, -2.185108>
    }
    triangle {
      < 4.360487, -1.279073, -2.185108>,
      < 4.283986, -1.422167, -2.185108>,
      < 4.387302, -1.464975, -2.213441>
    }
    triangle {
      < 4.360487, -1.279073, -2.185108>,
      < 4.387302, -1.464975, -2.213441>,
      < 4.453470, -1.341214, -2.213441>
    }
    triangle {
      < 4.453470, -1.341214, -2.213441>,
      < 4.387302, -1.464975, -2.213441>,
      < 4.482363, -1.504360, -2.267810>
    }
    triangle {
      < 4.453470, -1.341214, -2.213441>,
      < 4.482363, -1.504360, -2.267810>,
      < 4.539020, -1.398389, -2.267810>
    }
    triangle {
      < 4.539020, -1.398389, -2.267810>,
      < 4.482363, -1.504360, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.517527, -1.518929, -2.704390>,
      < 4.484798, -1.626778, -2.704390>,
      < 4.447470, -1.619349, -2.704448>
    }
    triangle {
      < 4.517527, -1.518929, -2.704390>,
      < 4.447470, -1.619349, -2.704448>,
      < 4.482363, -1.504360, -2.704448>
    }
    triangle {
      < 4.482363, -1.504360, -2.704448>,
      < 4.447470, -1.619349, -2.704448>,
      < 4.346551, -1.599264, -2.758817>
    }
    triangle {
      < 4.482363, -1.504360, -2.704448>,
      < 4.346551, -1.599264, -2.758817>,
      < 4.387302, -1.464975, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.387302, -1.464975, -2.758817>,
      < 4.346551, -1.599264, -2.758817>,
      < 4.236867, -1.577435, -2.787150>
    }
    triangle {
      < 4.387302, -1.464975, -2.758817>,
      < 4.236867, -1.577435, -2.787150>,
      < 4.283986, -1.422167, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.283986, -1.422167, -2.787150>,
      < 4.236867, -1.577435, -2.787150>,
      < 4.131389, -1.556443, -2.764967>
    }
    triangle {
      < 4.283986, -1.422167, -2.787150>,
      < 4.131389, -1.556443, -2.764967>,
      < 4.184628, -1.381000, -2.764967>
    }
    triangle {
      < 4.184628, -1.381000, -2.764967>,
      < 4.131389, -1.556443, -2.764967>,
      < 4.020102, -1.534295, -2.700042>
    }
    triangle {
      < 4.184628, -1.381000, -2.764967>,
      < 4.020102, -1.534295, -2.700042>,
      < 4.079800, -1.337567, -2.700042>
    }
    triangle {
      < 4.079800, -1.337567, -2.700042>,
      < 4.020102, -1.534295, -2.700042>,
      < 3.997199, -1.529736, -2.486032>
    }
    triangle {
      < 4.079800, -1.337567, -2.700042>,
      < 3.997199, -1.529736, -2.486032>,
      < 4.058226, -1.328627, -2.486032>
    }
    triangle {
      < 4.058226, -1.328627, -2.486032>,
      < 3.997199, -1.529736, -2.486032>,
      < 4.020102, -1.534295, -2.272216>
    }
    triangle {
      < 4.058226, -1.328627, -2.486032>,
      < 4.020102, -1.534295, -2.272216>,
      < 4.079800, -1.337567, -2.272216>
    }
    triangle {
      < 4.079800, -1.337567, -2.272216>,
      < 4.020102, -1.534295, -2.272216>,
      < 4.131389, -1.556443, -2.207291>
    }
    triangle {
      < 4.079800, -1.337567, -2.272216>,
      < 4.131389, -1.556443, -2.207291>,
      < 4.184628, -1.381000, -2.207291>
    }
    triangle {
      < 4.184628, -1.381000, -2.207291>,
      < 4.131389, -1.556443, -2.207291>,
      < 4.236867, -1.577435, -2.185108>
    }
    triangle {
      < 4.184628, -1.381000, -2.207291>,
      < 4.236867, -1.577435, -2.185108>,
      < 4.283986, -1.422167, -2.185108>
    }
    triangle {
      < 4.283986, -1.422167, -2.185108>,
      < 4.236867, -1.577435, -2.185108>,
      < 4.346551, -1.599264, -2.213441>
    }
    triangle {
      < 4.283986, -1.422167, -2.185108>,
      < 4.346551, -1.599264, -2.213441>,
      < 4.387302, -1.464975, -2.213441>
    }
    triangle {
      < 4.387302, -1.464975, -2.213441>,
      < 4.346551, -1.599264, -2.213441>,
      < 4.447470, -1.619349, -2.267810>
    }
    triangle {
      < 4.387302, -1.464975, -2.213441>,
      < 4.447470, -1.619349, -2.267810>,
      < 4.482363, -1.504360, -2.267810>
    }
    triangle {
      < 4.482363, -1.504360, -2.267810>,
      < 4.447470, -1.619349, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.484798, -1.626778, -2.704390>,
      < 4.473741, -1.738939, -2.704390>,
      < 4.435678, -1.738935, -2.704448>
    }
    triangle {
      < 4.484798, -1.626778, -2.704390>,
      < 4.435678, -1.738935, -2.704448>,
      < 4.447470, -1.619349, -2.704448>
    }
    triangle {
      < 4.447470, -1.619349, -2.704448>,
      < 4.435678, -1.738935, -2.704448>,
      < 4.332782, -1.738925, -2.758817>
    }
    triangle {
      < 4.447470, -1.619349, -2.704448>,
      < 4.332782, -1.738925, -2.758817>,
      < 4.346551, -1.599264, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.346551, -1.599264, -2.758817>,
      < 4.332782, -1.738925, -2.758817>,
      < 4.220947, -1.738913, -2.787150>
    }
    triangle {
      < 4.346551, -1.599264, -2.758817>,
      < 4.220947, -1.738913, -2.787150>,
      < 4.236867, -1.577435, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.236867, -1.577435, -2.787150>,
      < 4.220947, -1.738913, -2.787150>,
      < 4.113399, -1.738901, -2.764967>
    }
    triangle {
      < 4.236867, -1.577435, -2.787150>,
      < 4.113399, -1.738901, -2.764967>,
      < 4.131389, -1.556443, -2.764967>
    }
    triangle {
      < 4.131389, -1.556443, -2.764967>,
      < 4.113399, -1.738901, -2.764967>,
      < 3.999928, -1.738889, -2.700042>
    }
    triangle {
      < 4.131389, -1.556443, -2.764967>,
      < 3.999928, -1.738889, -2.700042>,
      < 4.020102, -1.534295, -2.700042>
    }
    triangle {
      < 4.020102, -1.534295, -2.700042>,
      < 3.999928, -1.738889, -2.700042>,
      < 3.976577, -1.738887, -2.486032>
    }
    triangle {
      < 4.020102, -1.534295, -2.700042>,
      < 3.976577, -1.738887, -2.486032>,
      < 3.997199, -1.529736, -2.486032>
    }
    triangle {
      < 3.997199, -1.529736, -2.486032>,
      < 3.976577, -1.738887, -2.486032>,
      < 3.999928, -1.738889, -2.272216>
    }
    triangle {
      < 3.997199, -1.529736, -2.486032>,
      < 3.999928, -1.738889, -2.272216>,
      < 4.020102, -1.534295, -2.272216>
    }
    triangle {
      < 4.020102, -1.534295, -2.272216>,
      < 3.999928, -1.738889, -2.272216>,
      < 4.113399, -1.738901, -2.207291>
    }
    triangle {
      < 4.020102, -1.534295, -2.272216>,
      < 4.113399, -1.738901, -2.207291>,
      < 4.131389, -1.556443, -2.207291>
    }
    triangle {
      < 4.131389, -1.556443, -2.207291>,
      < 4.113399, -1.738901, -2.207291>,
      < 4.220947, -1.738913, -2.185108>
    }
    triangle {
      < 4.131389, -1.556443, -2.207291>,
      < 4.220947, -1.738913, -2.185108>,
      < 4.236867, -1.577435, -2.185108>
    }
    triangle {
      < 4.236867, -1.577435, -2.185108>,
      < 4.220947, -1.738913, -2.185108>,
      < 4.332782, -1.738925, -2.213441>
    }
    triangle {
      < 4.236867, -1.577435, -2.185108>,
      < 4.332782, -1.738925, -2.213441>,
      < 4.346551, -1.599264, -2.213441>
    }
    triangle {
      < 4.346551, -1.599264, -2.213441>,
      < 4.332782, -1.738925, -2.213441>,
      < 4.435678, -1.738935, -2.267810>
    }
    triangle {
      < 4.346551, -1.599264, -2.213441>,
      < 4.435678, -1.738935, -2.267810>,
      < 4.447470, -1.619349, -2.267810>
    }
    triangle {
      < 4.447470, -1.619349, -2.267810>,
      < 4.435678, -1.738935, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.473741, -1.738939, -2.704390>,
      < 4.484776, -1.851103, -2.704390>,
      < 4.447444, -1.858524, -2.704448>
    }
    triangle {
      < 4.473741, -1.738939, -2.704390>,
      < 4.447444, -1.858524, -2.704448>,
      < 4.435678, -1.738935, -2.704448>
    }
    triangle {
      < 4.435678, -1.738935, -2.704448>,
      < 4.447444, -1.858524, -2.704448>,
      < 4.346522, -1.878587, -2.758817>
    }
    triangle {
      < 4.435678, -1.738935, -2.704448>,
      < 4.346522, -1.878587, -2.758817>,
      < 4.332782, -1.738925, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.332782, -1.738925, -2.758817>,
      < 4.346522, -1.878587, -2.758817>,
      < 4.236834, -1.900394, -2.787150>
    }
    triangle {
      < 4.332782, -1.738925, -2.758817>,
      < 4.236834, -1.900394, -2.787150>,
      < 4.220947, -1.738913, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.220947, -1.738913, -2.787150>,
      < 4.236834, -1.900394, -2.787150>,
      < 4.131350, -1.921364, -2.764967>
    }
    triangle {
      < 4.220947, -1.738913, -2.787150>,
      < 4.131350, -1.921364, -2.764967>,
      < 4.113399, -1.738901, -2.764967>
    }
    triangle {
      < 4.113399, -1.738901, -2.764967>,
      < 4.131350, -1.921364, -2.764967>,
      < 4.020058, -1.943489, -2.700042>
    }
    triangle {
      < 4.113399, -1.738901, -2.764967>,
      < 4.020058, -1.943489, -2.700042>,
      < 3.999928, -1.738889, -2.700042>
    }
    triangle {
      < 3.999928, -1.738889, -2.700042>,
      < 4.020058, -1.943489, -2.700042>,
      < 3.997154, -1.948042, -2.486032>
    }
    triangle {
      < 3.999928, -1.738889, -2.700042>,
      < 3.997154, -1.948042, -2.486032>,
      < 3.976577, -1.738887, -2.486032>
    }
    triangle {
      < 3.976577, -1.738887, -2.486032>,
      < 3.997154, -1.948042, -2.486032>,
      < 4.020058, -1.943489, -2.272216>
    }
    triangle {
      < 3.976577, -1.738887, -2.486032>,
      < 4.020058, -1.943489, -2.272216>,
      < 3.999928, -1.738889, -2.272216>
    }
    triangle {
      < 3.999928, -1.738889, -2.272216>,
      < 4.020058, -1.943489, -2.272216>,
      < 4.131350, -1.921364, -2.207291>
    }
    triangle {
      < 3.999928, -1.738889, -2.272216>,
      < 4.131350, -1.921364, -2.207291>,
      < 4.113399, -1.738901, -2.207291>
    }
    triangle {
      < 4.113399, -1.738901, -2.207291>,
      < 4.131350, -1.921364, -2.207291>,
      < 4.236834, -1.900394, -2.185108>
    }
    triangle {
      < 4.113399, -1.738901, -2.207291>,
      < 4.236834, -1.900394, -2.185108>,
      < 4.220947, -1.738913, -2.185108>
    }
    triangle {
      < 4.220947, -1.738913, -2.185108>,
      < 4.236834, -1.900394, -2.185108>,
      < 4.346522, -1.878587, -2.213441>
    }
    triangle {
      < 4.220947, -1.738913, -2.185108>,
      < 4.346522, -1.878587, -2.213441>,
      < 4.332782, -1.738925, -2.213441>
    }
    triangle {
      < 4.332782, -1.738925, -2.213441>,
      < 4.346522, -1.878587, -2.213441>,
      < 4.447444, -1.858524, -2.267810>
    }
    triangle {
      < 4.332782, -1.738925, -2.213441>,
      < 4.447444, -1.858524, -2.267810>,
      < 4.435678, -1.738935, -2.267810>
    }
    triangle {
      < 4.435678, -1.738935, -2.267810>,
      < 4.447444, -1.858524, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.484776, -1.851103, -2.704390>,
      < 4.517481, -1.958958, -2.704390>,
      < 4.482315, -1.973520, -2.704448>
    }
    triangle {
      < 4.484776, -1.851103, -2.704390>,
      < 4.482315, -1.973520, -2.704448>,
      < 4.447444, -1.858524, -2.704448>
    }
    triangle {
      < 4.447444, -1.858524, -2.704448>,
      < 4.482315, -1.973520, -2.704448>,
      < 4.387245, -2.012886, -2.758817>
    }
    triangle {
      < 4.447444, -1.858524, -2.704448>,
      < 4.387245, -2.012886, -2.758817>,
      < 4.346522, -1.878587, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.346522, -1.878587, -2.758817>,
      < 4.387245, -2.012886, -2.758817>,
      < 4.283918, -2.055673, -2.787150>
    }
    triangle {
      < 4.346522, -1.878587, -2.758817>,
      < 4.283918, -2.055673, -2.787150>,
      < 4.236834, -1.900394, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.236834, -1.900394, -2.787150>,
      < 4.283918, -2.055673, -2.787150>,
      < 4.184553, -2.096818, -2.764967>
    }
    triangle {
      < 4.236834, -1.900394, -2.787150>,
      < 4.184553, -2.096818, -2.764967>,
      < 4.131350, -1.921364, -2.764967>
    }
    triangle {
      < 4.131350, -1.921364, -2.764967>,
      < 4.184553, -2.096818, -2.764967>,
      < 4.079716, -2.140229, -2.700042>
    }
    triangle {
      < 4.131350, -1.921364, -2.764967>,
      < 4.079716, -2.140229, -2.700042>,
      < 4.020058, -1.943489, -2.700042>
    }
    triangle {
      < 4.020058, -1.943489, -2.700042>,
      < 4.079716, -2.140229, -2.700042>,
      < 4.058140, -2.149163, -2.486032>
    }
    triangle {
      < 4.020058, -1.943489, -2.700042>,
      < 4.058140, -2.149163, -2.486032>,
      < 3.997154, -1.948042, -2.486032>
    }
    triangle {
      < 3.997154, -1.948042, -2.486032>,
      < 4.058140, -2.149163, -2.486032>,
      < 4.079716, -2.140229, -2.272216>
    }
    triangle {
      < 3.997154, -1.948042, -2.486032>,
      < 4.079716, -2.140229, -2.272216>,
      < 4.020058, -1.943489, -2.272216>
    }
    triangle {
      < 4.020058, -1.943489, -2.272216>,
      < 4.079716, -2.140229, -2.272216>,
      < 4.184553, -2.096818, -2.207291>
    }
    triangle {
      < 4.020058, -1.943489, -2.272216>,
      < 4.184553, -2.096818, -2.207291>,
      < 4.131350, -1.921364, -2.207291>
    }
    triangle {
      < 4.131350, -1.921364, -2.207291>,
      < 4.184553, -2.096818, -2.207291>,
      < 4.283918, -2.055673, -2.185108>
    }
    triangle {
      < 4.131350, -1.921364, -2.207291>,
      < 4.283918, -2.055673, -2.185108>,
      < 4.236834, -1.900394, -2.185108>
    }
    triangle {
      < 4.236834, -1.900394, -2.185108>,
      < 4.283918, -2.055673, -2.185108>,
      < 4.387245, -2.012886, -2.213441>
    }
    triangle {
      < 4.236834, -1.900394, -2.185108>,
      < 4.387245, -2.012886, -2.213441>,
      < 4.346522, -1.878587, -2.213441>
    }
    triangle {
      < 4.346522, -1.878587, -2.213441>,
      < 4.387245, -2.012886, -2.213441>,
      < 4.482315, -1.973520, -2.267810>
    }
    triangle {
      < 4.346522, -1.878587, -2.213441>,
      < 4.482315, -1.973520, -2.267810>,
      < 4.447444, -1.858524, -2.267810>
    }
    triangle {
      < 4.447444, -1.858524, -2.267810>,
      < 4.482315, -1.973520, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.517481, -1.958958, -2.704390>,
      < 4.570598, -2.058361, -2.704390>,
      < 4.538948, -2.079503, -2.704448>
    }
    triangle {
      < 4.517481, -1.958958, -2.704390>,
      < 4.538948, -2.079503, -2.704448>,
      < 4.482315, -1.973520, -2.704448>
    }
    triangle {
      < 4.482315, -1.973520, -2.704448>,
      < 4.538948, -2.079503, -2.704448>,
      < 4.453385, -2.136661, -2.758817>
    }
    triangle {
      < 4.482315, -1.973520, -2.704448>,
      < 4.453385, -2.136661, -2.758817>,
      < 4.387245, -2.012886, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.387245, -2.012886, -2.758817>,
      < 4.453385, -2.136661, -2.758817>,
      < 4.360392, -2.198782, -2.787150>
    }
    triangle {
      < 4.387245, -2.012886, -2.758817>,
      < 4.360392, -2.198782, -2.787150>,
      < 4.283918, -2.055673, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.283918, -2.055673, -2.787150>,
      < 4.360392, -2.198782, -2.787150>,
      < 4.270962, -2.258522, -2.764967>
    }
    triangle {
      < 4.283918, -2.055673, -2.787150>,
      < 4.270962, -2.258522, -2.764967>,
      < 4.184553, -2.096818, -2.764967>
    }
    triangle {
      < 4.184553, -2.096818, -2.764967>,
      < 4.270962, -2.258522, -2.764967>,
      < 4.176607, -2.321552, -2.700042>
    }
    triangle {
      < 4.184553, -2.096818, -2.764967>,
      < 4.176607, -2.321552, -2.700042>,
      < 4.079716, -2.140229, -2.700042>
    }
    triangle {
      < 4.079716, -2.140229, -2.700042>,
      < 4.176607, -2.321552, -2.700042>,
      < 4.157188, -2.334523, -2.486032>
    }
    triangle {
      < 4.079716, -2.140229, -2.700042>,
      < 4.157188, -2.334523, -2.486032>,
      < 4.058140, -2.149163, -2.486032>
    }
    triangle {
      < 4.058140, -2.149163, -2.486032>,
      < 4.157188, -2.334523, -2.486032>,
      < 4.176607, -2.321552, -2.272216>
    }
    triangle {
      < 4.058140, -2.149163, -2.486032>,
      < 4.176607, -2.321552, -2.272216>,
      < 4.079716, -2.140229, -2.272216>
    }
    triangle {
      < 4.079716, -2.140229, -2.272216>,
      < 4.176607, -2.321552, -2.272216>,
      < 4.270962, -2.258522, -2.207291>
    }
    triangle {
      < 4.079716, -2.140229, -2.272216>,
      < 4.270962, -2.258522, -2.207291>,
      < 4.184553, -2.096818, -2.207291>
    }
    triangle {
      < 4.184553, -2.096818, -2.207291>,
      < 4.270962, -2.258522, -2.207291>,
      < 4.360392, -2.198782, -2.185108>
    }
    triangle {
      < 4.184553, -2.096818, -2.207291>,
      < 4.360392, -2.198782, -2.185108>,
      < 4.283918, -2.055673, -2.185108>
    }
    triangle {
      < 4.283918, -2.055673, -2.185108>,
      < 4.360392, -2.198782, -2.185108>,
      < 4.453385, -2.136661, -2.213441>
    }
    triangle {
      < 4.283918, -2.055673, -2.185108>,
      < 4.453385, -2.136661, -2.213441>,
      < 4.387245, -2.012886, -2.213441>
    }
    triangle {
      < 4.387245, -2.012886, -2.213441>,
      < 4.453385, -2.136661, -2.213441>,
      < 4.538948, -2.079503, -2.267810>
    }
    triangle {
      < 4.387245, -2.012886, -2.213441>,
      < 4.538948, -2.079503, -2.267810>,
      < 4.482315, -1.973520, -2.267810>
    }
    triangle {
      < 4.482315, -1.973520, -2.267810>,
      < 4.538948, -2.079503, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    triangle {
      < 4.570598, -2.058361, -2.704390>,
      < 4.642129, -2.145534, -2.704390>,
      < 4.615216, -2.172448, -2.704448>
    }
    triangle {
      < 4.570598, -2.058361, -2.704390>,
      < 4.615216, -2.172448, -2.704448>,
      < 4.538948, -2.079503, -2.704448>
    }
    triangle {
      < 4.538948, -2.079503, -2.704448>,
      < 4.615216, -2.172448, -2.704448>,
      < 4.542456, -2.245206, -2.758817>
    }
    triangle {
      < 4.538948, -2.079503, -2.704448>,
      < 4.542456, -2.245206, -2.758817>,
      < 4.453385, -2.136661, -2.758817>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.453385, -2.136661, -2.758817>,
      < 4.542456, -2.245206, -2.758817>,
      < 4.463375, -2.324284, -2.787150>
    }
    triangle {
      < 4.453385, -2.136661, -2.758817>,
      < 4.463375, -2.324284, -2.787150>,
      < 4.360392, -2.198782, -2.787150>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.360392, -2.198782, -2.787150>,
      < 4.463375, -2.324284, -2.787150>,
      < 4.387326, -2.400331, -2.764967>
    }
    triangle {
      < 4.360392, -2.198782, -2.787150>,
      < 4.387326, -2.400331, -2.764967>,
      < 4.270962, -2.258522, -2.764967>
    }
    triangle {
      < 4.270962, -2.258522, -2.764967>,
      < 4.387326, -2.400331, -2.764967>,
      < 4.307090, -2.480566, -2.700042>
    }
    triangle {
      < 4.270962, -2.258522, -2.764967>,
      < 4.307090, -2.480566, -2.700042>,
      < 4.176607, -2.321552, -2.700042>
    }
    triangle {
      < 4.176607, -2.321552, -2.700042>,
      < 4.307090, -2.480566, -2.700042>,
      < 4.290576, -2.497078, -2.486032>
    }
    triangle {
      < 4.176607, -2.321552, -2.700042>,
      < 4.290576, -2.497078, -2.486032>,
      < 4.157188, -2.334523, -2.486032>
    }
    triangle {
      < 4.157188, -2.334523, -2.486032>,
      < 4.290576, -2.497078, -2.486032>,
      < 4.307090, -2.480566, -2.272216>
    }
    triangle {
      < 4.157188, -2.334523, -2.486032>,
      < 4.307090, -2.480566, -2.272216>,
      < 4.176607, -2.321552, -2.272216>
    }
    triangle {
      < 4.176607, -2.321552, -2.272216>,
      < 4.307090, -2.480566, -2.272216>,
      < 4.387326, -2.400331, -2.207291>
    }
    triangle {
      < 4.176607, -2.321552, -2.272216>,
      < 4.387326, -2.400331, -2.207291>,
      < 4.270962, -2.258522, -2.207291>
    }
    triangle {
      < 4.270962, -2.258522, -2.207291>,
      < 4.387326, -2.400331, -2.207291>,
      < 4.463375, -2.324284, -2.185108>
    }
    triangle {
      < 4.270962, -2.258522, -2.207291>,
      < 4.463375, -2.324284, -2.185108>,
      < 4.360392, -2.198782, -2.185108>
    }
    triangle {
      < 4.360392, -2.198782, -2.185108>,
      < 4.463375, -2.324284, -2.185108>,
      < 4.542456, -2.245206, -2.213441>
    }
    triangle {
      < 4.360392, -2.198782, -2.185108>,
      < 4.542456, -2.245206, -2.213441>,
      < 4.453385, -2.136661, -2.213441>
    }
    triangle {
      < 4.453385, -2.136661, -2.213441>,
      < 4.542456, -2.245206, -2.213441>,
      < 4.615216, -2.172448, -2.267810>
    }
    triangle {
      < 4.453385, -2.136661, -2.213441>,
      < 4.615216, -2.172448, -2.267810>,
      < 4.538948, -2.079503, -2.267810>
    }
    triangle {
      < 4.538948, -2.079503, -2.267810>,
      < 4.615216, -2.172448, -2.267810>,
      < 5.048558, -1.739117, -2.267490>
    }
    texture {btires}
  }
  // lftire
  union {
    triangle {
      < -4.931459, -2.172448, 2.704448>,
      < -4.838571, -2.248682, 2.704448>,
      < -4.817424, -2.217035, 2.704390>
    }
    triangle {
      < -4.931459, -2.172448, 2.704448>,
      < -4.817424, -2.217035, 2.704390>,
      < -4.904545, -2.145534, 2.704390>
    }
    triangle {
      < -5.004219, -2.245206, 2.758817>,
      < -4.895739, -2.334237, 2.758817>,
      < -4.838571, -2.248682, 2.704448>
    }
    triangle {
      < -5.004219, -2.245206, 2.758817>,
      < -4.838571, -2.248682, 2.704448>,
      < -4.931459, -2.172448, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.083300, -2.324284, 2.787150>,
      < -4.957872, -2.427223, 2.787150>,
      < -4.895739, -2.334237, 2.758817>
    }
    triangle {
      < -5.083300, -2.324284, 2.787150>,
      < -4.895739, -2.334237, 2.758817>,
      < -5.004219, -2.245206, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.159349, -2.400331, 2.764967>,
      < -5.017624, -2.516644, 2.764967>,
      < -4.957872, -2.427223, 2.787150>
    }
    triangle {
      < -5.159349, -2.400331, 2.764967>,
      < -4.957872, -2.427223, 2.787150>,
      < -5.083300, -2.324284, 2.787150>
    }
    triangle {
      < -5.239585, -2.480566, 2.700042>,
      < -5.080666, -2.610991, 2.700042>,
      < -5.017624, -2.516644, 2.764967>
    }
    triangle {
      < -5.239585, -2.480566, 2.700042>,
      < -5.017624, -2.516644, 2.764967>,
      < -5.159349, -2.400331, 2.764967>
    }
    triangle {
      < -5.256098, -2.497078, 2.486032>,
      < -5.093641, -2.630407, 2.486032>,
      < -5.080666, -2.610991, 2.700042>
    }
    triangle {
      < -5.256098, -2.497078, 2.486032>,
      < -5.080666, -2.610991, 2.700042>,
      < -5.239585, -2.480566, 2.700042>
    }
    triangle {
      < -5.239585, -2.480566, 2.272216>,
      < -5.080666, -2.610991, 2.272216>,
      < -5.093641, -2.630407, 2.486032>
    }
    triangle {
      < -5.239585, -2.480566, 2.272216>,
      < -5.093641, -2.630407, 2.486032>,
      < -5.256098, -2.497078, 2.486032>
    }
    triangle {
      < -5.159349, -2.400331, 2.207291>,
      < -5.017624, -2.516644, 2.207291>,
      < -5.080666, -2.610991, 2.272216>
    }
    triangle {
      < -5.159349, -2.400331, 2.207291>,
      < -5.080666, -2.610991, 2.272216>,
      < -5.239585, -2.480566, 2.272216>
    }
    triangle {
      < -5.083300, -2.324284, 2.185108>,
      < -4.957872, -2.427223, 2.185108>,
      < -5.017624, -2.516644, 2.207291>
    }
    triangle {
      < -5.083300, -2.324284, 2.185108>,
      < -5.017624, -2.516644, 2.207291>,
      < -5.159349, -2.400331, 2.207291>
    }
    triangle {
      < -5.004219, -2.245206, 2.213441>,
      < -4.895739, -2.334237, 2.213441>,
      < -4.957872, -2.427223, 2.185108>
    }
    triangle {
      < -5.004219, -2.245206, 2.213441>,
      < -4.957872, -2.427223, 2.185108>,
      < -5.083300, -2.324284, 2.185108>
    }
    triangle {
      < -4.931459, -2.172448, 2.267810>,
      < -4.838571, -2.248682, 2.267810>,
      < -4.895739, -2.334237, 2.213441>
    }
    triangle {
      < -4.931459, -2.172448, 2.267810>,
      < -4.895739, -2.334237, 2.213441>,
      < -5.004219, -2.245206, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.838571, -2.248682, 2.267810>,
      < -4.931459, -2.172448, 2.267810>
    }
    triangle {
      < -4.838571, -2.248682, 2.704448>,
      < -4.732594, -2.305330, 2.704448>,
      < -4.718028, -2.270165, 2.704390>
    }
    triangle {
      < -4.838571, -2.248682, 2.704448>,
      < -4.718028, -2.270165, 2.704390>,
      < -4.817424, -2.217035, 2.704390>
    }
    triangle {
      < -4.895739, -2.334237, 2.758817>,
      < -4.771974, -2.400394, 2.758817>,
      < -4.732594, -2.305330, 2.704448>
    }
    triangle {
      < -4.895739, -2.334237, 2.758817>,
      < -4.732594, -2.305330, 2.704448>,
      < -4.838571, -2.248682, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.957872, -2.427223, 2.787150>,
      < -4.814773, -2.503715, 2.787150>,
      < -4.771974, -2.400394, 2.758817>
    }
    triangle {
      < -4.957872, -2.427223, 2.787150>,
      < -4.771974, -2.400394, 2.758817>,
      < -4.895739, -2.334237, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.017624, -2.516644, 2.764967>,
      < -4.855932, -2.603076, 2.764967>,
      < -4.814773, -2.503715, 2.787150>
    }
    triangle {
      < -5.017624, -2.516644, 2.764967>,
      < -4.814773, -2.503715, 2.787150>,
      < -4.957872, -2.427223, 2.787150>
    }
    triangle {
      < -5.080666, -2.610991, 2.700042>,
      < -4.899357, -2.707907, 2.700042>,
      < -4.855932, -2.603076, 2.764967>
    }
    triangle {
      < -5.080666, -2.610991, 2.700042>,
      < -4.855932, -2.603076, 2.764967>,
      < -5.017624, -2.516644, 2.764967>
    }
    triangle {
      < -5.093641, -2.630407, 2.486032>,
      < -4.908293, -2.729481, 2.486032>,
      < -4.899357, -2.707907, 2.700042>
    }
    triangle {
      < -5.093641, -2.630407, 2.486032>,
      < -4.899357, -2.707907, 2.700042>,
      < -5.080666, -2.610991, 2.700042>
    }
    triangle {
      < -5.080666, -2.610991, 2.272216>,
      < -4.899357, -2.707907, 2.272216>,
      < -4.908293, -2.729481, 2.486032>
    }
    triangle {
      < -5.080666, -2.610991, 2.272216>,
      < -4.908293, -2.729481, 2.486032>,
      < -5.093641, -2.630407, 2.486032>
    }
    triangle {
      < -5.017624, -2.516644, 2.207291>,
      < -4.855932, -2.603076, 2.207291>,
      < -4.899357, -2.707907, 2.272216>
    }
    triangle {
      < -5.017624, -2.516644, 2.207291>,
      < -4.899357, -2.707907, 2.272216>,
      < -5.080666, -2.610991, 2.272216>
    }
    triangle {
      < -4.957872, -2.427223, 2.185108>,
      < -4.814773, -2.503715, 2.185108>,
      < -4.855932, -2.603076, 2.207291>
    }
    triangle {
      < -4.957872, -2.427223, 2.185108>,
      < -4.855932, -2.603076, 2.207291>,
      < -5.017624, -2.516644, 2.207291>
    }
    triangle {
      < -4.895739, -2.334237, 2.213441>,
      < -4.771974, -2.400394, 2.213441>,
      < -4.814773, -2.503715, 2.185108>
    }
    triangle {
      < -4.895739, -2.334237, 2.213441>,
      < -4.814773, -2.503715, 2.185108>,
      < -4.957872, -2.427223, 2.185108>
    }
    triangle {
      < -4.838571, -2.248682, 2.267810>,
      < -4.732594, -2.305330, 2.267810>,
      < -4.771974, -2.400394, 2.213441>
    }
    triangle {
      < -4.838571, -2.248682, 2.267810>,
      < -4.771974, -2.400394, 2.213441>,
      < -4.895739, -2.334237, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.732594, -2.305330, 2.267810>,
      < -4.838571, -2.248682, 2.267810>
    }
    triangle {
      < -4.732594, -2.305330, 2.704448>,
      < -4.617604, -2.340215, 2.704448>,
      < -4.610177, -2.302884, 2.704390>
    }
    triangle {
      < -4.732594, -2.305330, 2.704448>,
      < -4.610177, -2.302884, 2.704390>,
      < -4.718028, -2.270165, 2.704390>
    }
    triangle {
      < -4.771974, -2.400394, 2.758817>,
      < -4.637680, -2.441134, 2.758817>,
      < -4.617604, -2.340215, 2.704448>
    }
    triangle {
      < -4.771974, -2.400394, 2.758817>,
      < -4.617604, -2.340215, 2.704448>,
      < -4.732594, -2.305330, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.814773, -2.503715, 2.787150>,
      < -4.659500, -2.550819, 2.787150>,
      < -4.637680, -2.441134, 2.758817>
    }
    triangle {
      < -4.814773, -2.503715, 2.787150>,
      < -4.637680, -2.441134, 2.758817>,
      < -4.771974, -2.400394, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.855932, -2.603076, 2.764967>,
      < -4.680484, -2.656301, 2.764967>,
      < -4.659500, -2.550819, 2.787150>
    }
    triangle {
      < -4.855932, -2.603076, 2.764967>,
      < -4.659500, -2.550819, 2.787150>,
      < -4.814773, -2.503715, 2.787150>
    }
    triangle {
      < -4.899357, -2.707907, 2.700042>,
      < -4.702624, -2.767589, 2.700042>,
      < -4.680484, -2.656301, 2.764967>
    }
    triangle {
      < -4.899357, -2.707907, 2.700042>,
      < -4.680484, -2.656301, 2.764967>,
      < -4.855932, -2.603076, 2.764967>
    }
    triangle {
      < -4.908293, -2.729481, 2.486032>,
      < -4.707180, -2.790493, 2.486032>,
      < -4.702624, -2.767589, 2.700042>
    }
    triangle {
      < -4.908293, -2.729481, 2.486032>,
      < -4.702624, -2.767589, 2.700042>,
      < -4.899357, -2.707907, 2.700042>
    }
    triangle {
      < -4.899357, -2.707907, 2.272216>,
      < -4.702624, -2.767589, 2.272216>,
      < -4.707180, -2.790493, 2.486032>
    }
    triangle {
      < -4.899357, -2.707907, 2.272216>,
      < -4.707180, -2.790493, 2.486032>,
      < -4.908293, -2.729481, 2.486032>
    }
    triangle {
      < -4.855932, -2.603076, 2.207291>,
      < -4.680484, -2.656301, 2.207291>,
      < -4.702624, -2.767589, 2.272216>
    }
    triangle {
      < -4.855932, -2.603076, 2.207291>,
      < -4.702624, -2.767589, 2.272216>,
      < -4.899357, -2.707907, 2.272216>
    }
    triangle {
      < -4.814773, -2.503715, 2.185108>,
      < -4.659500, -2.550819, 2.185108>,
      < -4.680484, -2.656301, 2.207291>
    }
    triangle {
      < -4.814773, -2.503715, 2.185108>,
      < -4.680484, -2.656301, 2.207291>,
      < -4.855932, -2.603076, 2.207291>
    }
    triangle {
      < -4.771974, -2.400394, 2.213441>,
      < -4.637680, -2.441134, 2.213441>,
      < -4.659500, -2.550819, 2.185108>
    }
    triangle {
      < -4.771974, -2.400394, 2.213441>,
      < -4.659500, -2.550819, 2.185108>,
      < -4.814773, -2.503715, 2.185108>
    }
    triangle {
      < -4.732594, -2.305330, 2.267810>,
      < -4.617604, -2.340215, 2.267810>,
      < -4.637680, -2.441134, 2.213441>
    }
    triangle {
      < -4.732594, -2.305330, 2.267810>,
      < -4.637680, -2.441134, 2.213441>,
      < -4.771974, -2.400394, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.617604, -2.340215, 2.267810>,
      < -4.732594, -2.305330, 2.267810>
    }
    triangle {
      < -4.617604, -2.340215, 2.704448>,
      < -4.498016, -2.351996, 2.704448>,
      < -4.498015, -2.313934, 2.704390>
    }
    triangle {
      < -4.617604, -2.340215, 2.704448>,
      < -4.498015, -2.313934, 2.704390>,
      < -4.610177, -2.302884, 2.704390>
    }
    triangle {
      < -4.637680, -2.441134, 2.758817>,
      < -4.498019, -2.454893, 2.758817>,
      < -4.498016, -2.351996, 2.704448>
    }
    triangle {
      < -4.637680, -2.441134, 2.758817>,
      < -4.498016, -2.351996, 2.704448>,
      < -4.617604, -2.340215, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.659500, -2.550819, 2.787150>,
      < -4.498022, -2.566728, 2.787150>,
      < -4.498019, -2.454893, 2.758817>
    }
    triangle {
      < -4.659500, -2.550819, 2.787150>,
      < -4.498019, -2.454893, 2.758817>,
      < -4.637680, -2.441134, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.680484, -2.656301, 2.764967>,
      < -4.498025, -2.674276, 2.764967>,
      < -4.498022, -2.566728, 2.787150>
    }
    triangle {
      < -4.680484, -2.656301, 2.764967>,
      < -4.498022, -2.566728, 2.787150>,
      < -4.659500, -2.550819, 2.787150>
    }
    triangle {
      < -4.702624, -2.767589, 2.700042>,
      < -4.498027, -2.787746, 2.700042>,
      < -4.498025, -2.674276, 2.764967>
    }
    triangle {
      < -4.702624, -2.767589, 2.700042>,
      < -4.498025, -2.674276, 2.764967>,
      < -4.680484, -2.656301, 2.764967>
    }
    triangle {
      < -4.707180, -2.790493, 2.486032>,
      < -4.498028, -2.811098, 2.486032>,
      < -4.498027, -2.787746, 2.700042>
    }
    triangle {
      < -4.707180, -2.790493, 2.486032>,
      < -4.498027, -2.787746, 2.700042>,
      < -4.702624, -2.767589, 2.700042>
    }
    triangle {
      < -4.702624, -2.767589, 2.272216>,
      < -4.498027, -2.787746, 2.272216>,
      < -4.498028, -2.811098, 2.486032>
    }
    triangle {
      < -4.702624, -2.767589, 2.272216>,
      < -4.498028, -2.811098, 2.486032>,
      < -4.707180, -2.790493, 2.486032>
    }
    triangle {
      < -4.680484, -2.656301, 2.207291>,
      < -4.498025, -2.674276, 2.207291>,
      < -4.498027, -2.787746, 2.272216>
    }
    triangle {
      < -4.680484, -2.656301, 2.207291>,
      < -4.498027, -2.787746, 2.272216>,
      < -4.702624, -2.767589, 2.272216>
    }
    triangle {
      < -4.659500, -2.550819, 2.185108>,
      < -4.498022, -2.566728, 2.185108>,
      < -4.498025, -2.674276, 2.207291>
    }
    triangle {
      < -4.659500, -2.550819, 2.185108>,
      < -4.498025, -2.674276, 2.207291>,
      < -4.680484, -2.656301, 2.207291>
    }
    triangle {
      < -4.637680, -2.441134, 2.213441>,
      < -4.498019, -2.454893, 2.213441>,
      < -4.498022, -2.566728, 2.185108>
    }
    triangle {
      < -4.637680, -2.441134, 2.213441>,
      < -4.498022, -2.566728, 2.185108>,
      < -4.659500, -2.550819, 2.185108>
    }
    triangle {
      < -4.617604, -2.340215, 2.267810>,
      < -4.498016, -2.351996, 2.267810>,
      < -4.498019, -2.454893, 2.213441>
    }
    triangle {
      < -4.617604, -2.340215, 2.267810>,
      < -4.498019, -2.454893, 2.213441>,
      < -4.637680, -2.441134, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.498016, -2.351996, 2.267810>,
      < -4.617604, -2.340215, 2.267810>
    }
    triangle {
      < -4.498016, -2.351996, 2.704448>,
      < -4.378428, -2.340221, 2.704448>,
      < -4.385853, -2.302890, 2.704390>
    }
    triangle {
      < -4.498016, -2.351996, 2.704448>,
      < -4.385853, -2.302890, 2.704390>,
      < -4.498015, -2.313934, 2.704390>
    }
    triangle {
      < -4.498019, -2.454893, 2.758817>,
      < -4.358357, -2.441142, 2.758817>,
      < -4.378428, -2.340221, 2.704448>
    }
    triangle {
      < -4.498019, -2.454893, 2.758817>,
      < -4.378428, -2.340221, 2.704448>,
      < -4.498016, -2.351996, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.498022, -2.566728, 2.787150>,
      < -4.336542, -2.550828, 2.787150>,
      < -4.358357, -2.441142, 2.758817>
    }
    triangle {
      < -4.498022, -2.566728, 2.787150>,
      < -4.358357, -2.441142, 2.758817>,
      < -4.498019, -2.454893, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.498025, -2.674276, 2.764967>,
      < -4.315564, -2.656310, 2.764967>,
      < -4.336542, -2.550828, 2.787150>
    }
    triangle {
      < -4.498025, -2.674276, 2.764967>,
      < -4.336542, -2.550828, 2.787150>,
      < -4.498022, -2.566728, 2.787150>
    }
    triangle {
      < -4.498027, -2.787746, 2.700042>,
      < -4.293430, -2.767600, 2.700042>,
      < -4.315564, -2.656310, 2.764967>
    }
    triangle {
      < -4.498027, -2.787746, 2.700042>,
      < -4.315564, -2.656310, 2.764967>,
      < -4.498025, -2.674276, 2.764967>
    }
    triangle {
      < -4.498028, -2.811098, 2.486032>,
      < -4.288875, -2.790504, 2.486032>,
      < -4.293430, -2.767600, 2.700042>
    }
    triangle {
      < -4.498028, -2.811098, 2.486032>,
      < -4.293430, -2.767600, 2.700042>,
      < -4.498027, -2.787746, 2.700042>
    }
    triangle {
      < -4.498027, -2.787746, 2.272216>,
      < -4.293430, -2.767600, 2.272216>,
      < -4.288875, -2.790504, 2.486032>
    }
    triangle {
      < -4.498027, -2.787746, 2.272216>,
      < -4.288875, -2.790504, 2.486032>,
      < -4.498028, -2.811098, 2.486032>
    }
    triangle {
      < -4.498025, -2.674276, 2.207291>,
      < -4.315564, -2.656310, 2.207291>,
      < -4.293430, -2.767600, 2.272216>
    }
    triangle {
      < -4.498025, -2.674276, 2.207291>,
      < -4.293430, -2.767600, 2.272216>,
      < -4.498027, -2.787746, 2.272216>
    }
    triangle {
      < -4.498022, -2.566728, 2.185108>,
      < -4.336542, -2.550828, 2.185108>,
      < -4.315564, -2.656310, 2.207291>
    }
    triangle {
      < -4.498022, -2.566728, 2.185108>,
      < -4.315564, -2.656310, 2.207291>,
      < -4.498025, -2.674276, 2.207291>
    }
    triangle {
      < -4.498019, -2.454893, 2.213441>,
      < -4.358357, -2.441142, 2.213441>,
      < -4.336542, -2.550828, 2.185108>
    }
    triangle {
      < -4.498019, -2.454893, 2.213441>,
      < -4.336542, -2.550828, 2.185108>,
      < -4.498022, -2.566728, 2.185108>
    }
    triangle {
      < -4.498016, -2.351996, 2.267810>,
      < -4.378428, -2.340221, 2.267810>,
      < -4.358357, -2.441142, 2.213441>
    }
    triangle {
      < -4.498016, -2.351996, 2.267810>,
      < -4.358357, -2.441142, 2.213441>,
      < -4.498019, -2.454893, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.378428, -2.340221, 2.267810>,
      < -4.498016, -2.351996, 2.267810>
    }
    triangle {
      < -4.378428, -2.340221, 2.704448>,
      < -4.263435, -2.305343, 2.704448>,
      < -4.278000, -2.270177, 2.704390>
    }
    triangle {
      < -4.378428, -2.340221, 2.704448>,
      < -4.278000, -2.270177, 2.704390>,
      < -4.385853, -2.302890, 2.704390>
    }
    triangle {
      < -4.358357, -2.441142, 2.758817>,
      < -4.224061, -2.400407, 2.758817>,
      < -4.263435, -2.305343, 2.704448>
    }
    triangle {
      < -4.358357, -2.441142, 2.758817>,
      < -4.263435, -2.305343, 2.704448>,
      < -4.378428, -2.340221, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.336542, -2.550828, 2.787150>,
      < -4.181267, -2.503732, 2.787150>,
      < -4.224061, -2.400407, 2.758817>
    }
    triangle {
      < -4.336542, -2.550828, 2.787150>,
      < -4.224061, -2.400407, 2.758817>,
      < -4.358357, -2.441142, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.315564, -2.656310, 2.764967>,
      < -4.140114, -2.603094, 2.764967>,
      < -4.181267, -2.503732, 2.787150>
    }
    triangle {
      < -4.315564, -2.656310, 2.764967>,
      < -4.181267, -2.503732, 2.787150>,
      < -4.336542, -2.550828, 2.787150>
    }
    triangle {
      < -4.293430, -2.767600, 2.700042>,
      < -4.096694, -2.707928, 2.700042>,
      < -4.140114, -2.603094, 2.764967>
    }
    triangle {
      < -4.293430, -2.767600, 2.700042>,
      < -4.140114, -2.603094, 2.764967>,
      < -4.315564, -2.656310, 2.764967>
    }
    triangle {
      < -4.288875, -2.790504, 2.486032>,
      < -4.087759, -2.729503, 2.486032>,
      < -4.096694, -2.707928, 2.700042>
    }
    triangle {
      < -4.288875, -2.790504, 2.486032>,
      < -4.096694, -2.707928, 2.700042>,
      < -4.293430, -2.767600, 2.700042>
    }
    triangle {
      < -4.293430, -2.767600, 2.272216>,
      < -4.096694, -2.707928, 2.272216>,
      < -4.087759, -2.729503, 2.486032>
    }
    triangle {
      < -4.293430, -2.767600, 2.272216>,
      < -4.087759, -2.729503, 2.486032>,
      < -4.288875, -2.790504, 2.486032>
    }
    triangle {
      < -4.315564, -2.656310, 2.207291>,
      < -4.140114, -2.603094, 2.207291>,
      < -4.096694, -2.707928, 2.272216>
    }
    triangle {
      < -4.315564, -2.656310, 2.207291>,
      < -4.096694, -2.707928, 2.272216>,
      < -4.293430, -2.767600, 2.272216>
    }
    triangle {
      < -4.336542, -2.550828, 2.185108>,
      < -4.181267, -2.503732, 2.185108>,
      < -4.140114, -2.603094, 2.207291>
    }
    triangle {
      < -4.336542, -2.550828, 2.185108>,
      < -4.140114, -2.603094, 2.207291>,
      < -4.315564, -2.656310, 2.207291>
    }
    triangle {
      < -4.358357, -2.441142, 2.213441>,
      < -4.224061, -2.400407, 2.213441>,
      < -4.181267, -2.503732, 2.185108>
    }
    triangle {
      < -4.358357, -2.441142, 2.213441>,
      < -4.181267, -2.503732, 2.185108>,
      < -4.336542, -2.550828, 2.185108>
    }
    triangle {
      < -4.378428, -2.340221, 2.267810>,
      < -4.263435, -2.305343, 2.267810>,
      < -4.224061, -2.400407, 2.213441>
    }
    triangle {
      < -4.378428, -2.340221, 2.267810>,
      < -4.224061, -2.400407, 2.213441>,
      < -4.358357, -2.441142, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.263435, -2.305343, 2.267810>,
      < -4.378428, -2.340221, 2.267810>
    }
    triangle {
      < -4.263435, -2.305343, 2.704448>,
      < -4.157456, -2.248700, 2.704448>,
      < -4.178601, -2.217052, 2.704390>
    }
    triangle {
      < -4.263435, -2.305343, 2.704448>,
      < -4.178601, -2.217052, 2.704390>,
      < -4.278000, -2.270177, 2.704390>
    }
    triangle {
      < -4.224061, -2.400407, 2.758817>,
      < -4.100293, -2.334258, 2.758817>,
      < -4.157456, -2.248700, 2.704448>
    }
    triangle {
      < -4.224061, -2.400407, 2.758817>,
      < -4.157456, -2.248700, 2.704448>,
      < -4.263435, -2.305343, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.181267, -2.503732, 2.787150>,
      < -4.038163, -2.427247, 2.787150>,
      < -4.100293, -2.334258, 2.758817>
    }
    triangle {
      < -4.181267, -2.503732, 2.787150>,
      < -4.100293, -2.334258, 2.758817>,
      < -4.224061, -2.400407, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.140114, -2.603094, 2.764967>,
      < -3.978416, -2.516672, 2.764967>,
      < -4.038163, -2.427247, 2.787150>
    }
    triangle {
      < -4.140114, -2.603094, 2.764967>,
      < -4.038163, -2.427247, 2.787150>,
      < -4.181267, -2.503732, 2.787150>
    }
    triangle {
      < -4.096694, -2.707928, 2.700042>,
      < -3.915380, -2.611022, 2.700042>,
      < -3.978416, -2.516672, 2.764967>
    }
    triangle {
      < -4.096694, -2.707928, 2.700042>,
      < -3.978416, -2.516672, 2.764967>,
      < -4.140114, -2.603094, 2.764967>
    }
    triangle {
      < -4.087759, -2.729503, 2.486032>,
      < -3.902406, -2.630438, 2.486032>,
      < -3.915380, -2.611022, 2.700042>
    }
    triangle {
      < -4.087759, -2.729503, 2.486032>,
      < -3.915380, -2.611022, 2.700042>,
      < -4.096694, -2.707928, 2.700042>
    }
    triangle {
      < -4.096694, -2.707928, 2.272216>,
      < -3.915380, -2.611022, 2.272216>,
      < -3.902406, -2.630438, 2.486032>
    }
    triangle {
      < -4.096694, -2.707928, 2.272216>,
      < -3.902406, -2.630438, 2.486032>,
      < -4.087759, -2.729503, 2.486032>
    }
    triangle {
      < -4.140114, -2.603094, 2.207291>,
      < -3.978416, -2.516672, 2.207291>,
      < -3.915380, -2.611022, 2.272216>
    }
    triangle {
      < -4.140114, -2.603094, 2.207291>,
      < -3.915380, -2.611022, 2.272216>,
      < -4.096694, -2.707928, 2.272216>
    }
    triangle {
      < -4.181267, -2.503732, 2.185108>,
      < -4.038163, -2.427247, 2.185108>,
      < -3.978416, -2.516672, 2.207291>
    }
    triangle {
      < -4.181267, -2.503732, 2.185108>,
      < -3.978416, -2.516672, 2.207291>,
      < -4.140114, -2.603094, 2.207291>
    }
    triangle {
      < -4.224061, -2.400407, 2.213441>,
      < -4.100293, -2.334258, 2.213441>,
      < -4.038163, -2.427247, 2.185108>
    }
    triangle {
      < -4.224061, -2.400407, 2.213441>,
      < -4.038163, -2.427247, 2.185108>,
      < -4.181267, -2.503732, 2.185108>
    }
    triangle {
      < -4.263435, -2.305343, 2.267810>,
      < -4.157456, -2.248700, 2.267810>,
      < -4.100293, -2.334258, 2.213441>
    }
    triangle {
      < -4.263435, -2.305343, 2.267810>,
      < -4.100293, -2.334258, 2.213441>,
      < -4.224061, -2.400407, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.157456, -2.248700, 2.267810>,
      < -4.263435, -2.305343, 2.267810>
    }
    triangle {
      < -4.157456, -2.248700, 2.704448>,
      < -4.064563, -2.172471, 2.704448>,
      < -4.091476, -2.145556, 2.704390>
    }
    triangle {
      < -4.157456, -2.248700, 2.704448>,
      < -4.091476, -2.145556, 2.704390>,
      < -4.178601, -2.217052, 2.704390>
    }
    triangle {
      < -4.100293, -2.334258, 2.758817>,
      < -3.991807, -2.245233, 2.758817>,
      < -4.064563, -2.172471, 2.704448>
    }
    triangle {
      < -4.100293, -2.334258, 2.758817>,
      < -4.064563, -2.172471, 2.704448>,
      < -4.157456, -2.248700, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.038163, -2.427247, 2.787150>,
      < -3.912731, -2.324315, 2.787150>,
      < -3.991807, -2.245233, 2.758817>
    }
    triangle {
      < -4.038163, -2.427247, 2.787150>,
      < -3.991807, -2.245233, 2.758817>,
      < -4.100293, -2.334258, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.978416, -2.516672, 2.764967>,
      < -3.836686, -2.400366, 2.764967>,
      < -3.912731, -2.324315, 2.787150>
    }
    triangle {
      < -3.978416, -2.516672, 2.764967>,
      < -3.912731, -2.324315, 2.787150>,
      < -4.038163, -2.427247, 2.787150>
    }
    triangle {
      < -3.915380, -2.611022, 2.700042>,
      < -3.756454, -2.480605, 2.700042>,
      < -3.836686, -2.400366, 2.764967>
    }
    triangle {
      < -3.915380, -2.611022, 2.700042>,
      < -3.836686, -2.400366, 2.764967>,
      < -3.978416, -2.516672, 2.764967>
    }
    triangle {
      < -3.902406, -2.630438, 2.486032>,
      < -3.739942, -2.497117, 2.486032>,
      < -3.756454, -2.480605, 2.700042>
    }
    triangle {
      < -3.902406, -2.630438, 2.486032>,
      < -3.756454, -2.480605, 2.700042>,
      < -3.915380, -2.611022, 2.700042>
    }
    triangle {
      < -3.915380, -2.611022, 2.272216>,
      < -3.756454, -2.480605, 2.272216>,
      < -3.739942, -2.497117, 2.486032>
    }
    triangle {
      < -3.915380, -2.611022, 2.272216>,
      < -3.739942, -2.497117, 2.486032>,
      < -3.902406, -2.630438, 2.486032>
    }
    triangle {
      < -3.978416, -2.516672, 2.207291>,
      < -3.836686, -2.400366, 2.207291>,
      < -3.756454, -2.480605, 2.272216>
    }
    triangle {
      < -3.978416, -2.516672, 2.207291>,
      < -3.756454, -2.480605, 2.272216>,
      < -3.915380, -2.611022, 2.272216>
    }
    triangle {
      < -4.038163, -2.427247, 2.185108>,
      < -3.912731, -2.324315, 2.185108>,
      < -3.836686, -2.400366, 2.207291>
    }
    triangle {
      < -4.038163, -2.427247, 2.185108>,
      < -3.836686, -2.400366, 2.207291>,
      < -3.978416, -2.516672, 2.207291>
    }
    triangle {
      < -4.100293, -2.334258, 2.213441>,
      < -3.991807, -2.245233, 2.213441>,
      < -3.912731, -2.324315, 2.185108>
    }
    triangle {
      < -4.100293, -2.334258, 2.213441>,
      < -3.912731, -2.324315, 2.185108>,
      < -4.038163, -2.427247, 2.185108>
    }
    triangle {
      < -4.157456, -2.248700, 2.267810>,
      < -4.064563, -2.172471, 2.267810>,
      < -3.991807, -2.245233, 2.213441>
    }
    triangle {
      < -4.157456, -2.248700, 2.267810>,
      < -3.991807, -2.245233, 2.213441>,
      < -4.100293, -2.334258, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.064563, -2.172471, 2.267810>,
      < -4.157456, -2.248700, 2.267810>
    }
    triangle {
      < -4.064563, -2.172471, 2.704448>,
      < -3.988327, -2.079584, 2.704448>,
      < -4.019974, -2.058437, 2.704390>
    }
    triangle {
      < -4.064563, -2.172471, 2.704448>,
      < -4.019974, -2.058437, 2.704390>,
      < -4.091476, -2.145556, 2.704390>
    }
    triangle {
      < -3.991807, -2.245233, 2.758817>,
      < -3.902774, -2.136754, 2.758817>,
      < -3.988327, -2.079584, 2.704448>
    }
    triangle {
      < -3.991807, -2.245233, 2.758817>,
      < -3.988327, -2.079584, 2.704448>,
      < -4.064563, -2.172471, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.912731, -2.324315, 2.787150>,
      < -3.809789, -2.198890, 2.787150>,
      < -3.902774, -2.136754, 2.758817>
    }
    triangle {
      < -3.912731, -2.324315, 2.787150>,
      < -3.902774, -2.136754, 2.758817>,
      < -3.991807, -2.245233, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.836686, -2.400366, 2.764967>,
      < -3.720369, -2.258645, 2.764967>,
      < -3.809789, -2.198890, 2.787150>
    }
    triangle {
      < -3.836686, -2.400366, 2.764967>,
      < -3.809789, -2.198890, 2.787150>,
      < -3.912731, -2.324315, 2.787150>
    }
    triangle {
      < -3.756454, -2.480605, 2.700042>,
      < -3.626024, -2.321689, 2.700042>,
      < -3.720369, -2.258645, 2.764967>
    }
    triangle {
      < -3.756454, -2.480605, 2.700042>,
      < -3.720369, -2.258645, 2.764967>,
      < -3.836686, -2.400366, 2.764967>
    }
    triangle {
      < -3.739942, -2.497117, 2.486032>,
      < -3.606608, -2.334664, 2.486032>,
      < -3.626024, -2.321689, 2.700042>
    }
    triangle {
      < -3.739942, -2.497117, 2.486032>,
      < -3.626024, -2.321689, 2.700042>,
      < -3.756454, -2.480605, 2.700042>
    }
    triangle {
      < -3.756454, -2.480605, 2.272216>,
      < -3.626024, -2.321689, 2.272216>,
      < -3.606608, -2.334664, 2.486032>
    }
    triangle {
      < -3.756454, -2.480605, 2.272216>,
      < -3.606608, -2.334664, 2.486032>,
      < -3.739942, -2.497117, 2.486032>
    }
    triangle {
      < -3.836686, -2.400366, 2.207291>,
      < -3.720369, -2.258645, 2.207291>,
      < -3.626024, -2.321689, 2.272216>
    }
    triangle {
      < -3.836686, -2.400366, 2.207291>,
      < -3.626024, -2.321689, 2.272216>,
      < -3.756454, -2.480605, 2.272216>
    }
    triangle {
      < -3.912731, -2.324315, 2.185108>,
      < -3.809789, -2.198890, 2.185108>,
      < -3.720369, -2.258645, 2.207291>
    }
    triangle {
      < -3.912731, -2.324315, 2.185108>,
      < -3.720369, -2.258645, 2.207291>,
      < -3.836686, -2.400366, 2.207291>
    }
    triangle {
      < -3.991807, -2.245233, 2.213441>,
      < -3.902774, -2.136754, 2.213441>,
      < -3.809789, -2.198890, 2.185108>
    }
    triangle {
      < -3.991807, -2.245233, 2.213441>,
      < -3.809789, -2.198890, 2.185108>,
      < -3.912731, -2.324315, 2.185108>
    }
    triangle {
      < -4.064563, -2.172471, 2.267810>,
      < -3.988327, -2.079584, 2.267810>,
      < -3.902774, -2.136754, 2.213441>
    }
    triangle {
      < -4.064563, -2.172471, 2.267810>,
      < -3.902774, -2.136754, 2.213441>,
      < -3.991807, -2.245233, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -3.988327, -2.079584, 2.267810>,
      < -4.064563, -2.172471, 2.267810>
    }
    triangle {
      < -3.988327, -2.079584, 2.704448>,
      < -3.931676, -1.973609, 2.704448>,
      < -3.966841, -1.959042, 2.704390>
    }
    triangle {
      < -3.988327, -2.079584, 2.704448>,
      < -3.966841, -1.959042, 2.704390>,
      < -4.019974, -2.058437, 2.704390>
    }
    triangle {
      < -3.902774, -2.136754, 2.758817>,
      < -3.836613, -2.012991, 2.758817>,
      < -3.931676, -1.973609, 2.704448>
    }
    triangle {
      < -3.902774, -2.136754, 2.758817>,
      < -3.931676, -1.973609, 2.704448>,
      < -3.988327, -2.079584, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.809789, -2.198890, 2.787150>,
      < -3.733294, -2.055792, 2.787150>,
      < -3.836613, -2.012991, 2.758817>
    }
    triangle {
      < -3.809789, -2.198890, 2.787150>,
      < -3.836613, -2.012991, 2.758817>,
      < -3.902774, -2.136754, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.720369, -2.258645, 2.764967>,
      < -3.633934, -2.096955, 2.764967>,
      < -3.733294, -2.055792, 2.787150>
    }
    triangle {
      < -3.720369, -2.258645, 2.764967>,
      < -3.733294, -2.055792, 2.787150>,
      < -3.809789, -2.198890, 2.787150>
    }
    triangle {
      < -3.626024, -2.321689, 2.700042>,
      < -3.529103, -2.140382, 2.700042>,
      < -3.633934, -2.096955, 2.764967>
    }
    triangle {
      < -3.626024, -2.321689, 2.700042>,
      < -3.633934, -2.096955, 2.764967>,
      < -3.720369, -2.258645, 2.764967>
    }
    triangle {
      < -3.606608, -2.334664, 2.486032>,
      < -3.507529, -2.149320, 2.486032>,
      < -3.529103, -2.140382, 2.700042>
    }
    triangle {
      < -3.606608, -2.334664, 2.486032>,
      < -3.529103, -2.140382, 2.700042>,
      < -3.626024, -2.321689, 2.700042>
    }
    triangle {
      < -3.626024, -2.321689, 2.272216>,
      < -3.529103, -2.140382, 2.272216>,
      < -3.507529, -2.149320, 2.486032>
    }
    triangle {
      < -3.626024, -2.321689, 2.272216>,
      < -3.507529, -2.149320, 2.486032>,
      < -3.606608, -2.334664, 2.486032>
    }
    triangle {
      < -3.720369, -2.258645, 2.207291>,
      < -3.633934, -2.096955, 2.207291>,
      < -3.529103, -2.140382, 2.272216>
    }
    triangle {
      < -3.720369, -2.258645, 2.207291>,
      < -3.529103, -2.140382, 2.272216>,
      < -3.626024, -2.321689, 2.272216>
    }
    triangle {
      < -3.809789, -2.198890, 2.185108>,
      < -3.733294, -2.055792, 2.185108>,
      < -3.633934, -2.096955, 2.207291>
    }
    triangle {
      < -3.809789, -2.198890, 2.185108>,
      < -3.633934, -2.096955, 2.207291>,
      < -3.720369, -2.258645, 2.207291>
    }
    triangle {
      < -3.902774, -2.136754, 2.213441>,
      < -3.836613, -2.012991, 2.213441>,
      < -3.733294, -2.055792, 2.185108>
    }
    triangle {
      < -3.902774, -2.136754, 2.213441>,
      < -3.733294, -2.055792, 2.185108>,
      < -3.809789, -2.198890, 2.185108>
    }
    triangle {
      < -3.988327, -2.079584, 2.267810>,
      < -3.931676, -1.973609, 2.267810>,
      < -3.836613, -2.012991, 2.213441>
    }
    triangle {
      < -3.988327, -2.079584, 2.267810>,
      < -3.836613, -2.012991, 2.213441>,
      < -3.902774, -2.136754, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -3.931676, -1.973609, 2.267810>,
      < -3.988327, -2.079584, 2.267810>
    }
    triangle {
      < -3.931676, -1.973609, 2.704448>,
      < -3.896788, -1.858619, 2.704448>,
      < -3.934118, -1.851192, 2.704390>
    }
    triangle {
      < -3.931676, -1.973609, 2.704448>,
      < -3.934118, -1.851192, 2.704390>,
      < -3.966841, -1.959042, 2.704390>
    }
    triangle {
      < -3.836613, -2.012991, 2.758817>,
      < -3.795870, -1.878699, 2.758817>,
      < -3.896788, -1.858619, 2.704448>
    }
    triangle {
      < -3.836613, -2.012991, 2.758817>,
      < -3.896788, -1.858619, 2.704448>,
      < -3.931676, -1.973609, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.733294, -2.055792, 2.787150>,
      < -3.686185, -1.900522, 2.787150>,
      < -3.795870, -1.878699, 2.758817>
    }
    triangle {
      < -3.733294, -2.055792, 2.787150>,
      < -3.795870, -1.878699, 2.758817>,
      < -3.836613, -2.012991, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.633934, -2.096955, 2.764967>,
      < -3.580705, -1.921509, 2.764967>,
      < -3.686185, -1.900522, 2.787150>
    }
    triangle {
      < -3.633934, -2.096955, 2.764967>,
      < -3.686185, -1.900522, 2.787150>,
      < -3.733294, -2.055792, 2.787150>
    }
    triangle {
      < -3.529103, -2.140382, 2.700042>,
      < -3.469416, -1.943652, 2.700042>,
      < -3.580705, -1.921509, 2.764967>
    }
    triangle {
      < -3.529103, -2.140382, 2.700042>,
      < -3.580705, -1.921509, 2.764967>,
      < -3.633934, -2.096955, 2.764967>
    }
    triangle {
      < -3.507529, -2.149320, 2.486032>,
      < -3.446512, -1.948209, 2.486032>,
      < -3.469416, -1.943652, 2.700042>
    }
    triangle {
      < -3.507529, -2.149320, 2.486032>,
      < -3.469416, -1.943652, 2.700042>,
      < -3.529103, -2.140382, 2.700042>
    }
    triangle {
      < -3.529103, -2.140382, 2.272216>,
      < -3.469416, -1.943652, 2.272216>,
      < -3.446512, -1.948209, 2.486032>
    }
    triangle {
      < -3.529103, -2.140382, 2.272216>,
      < -3.446512, -1.948209, 2.486032>,
      < -3.507529, -2.149320, 2.486032>
    }
    triangle {
      < -3.633934, -2.096955, 2.207291>,
      < -3.580705, -1.921509, 2.207291>,
      < -3.469416, -1.943652, 2.272216>
    }
    triangle {
      < -3.633934, -2.096955, 2.207291>,
      < -3.469416, -1.943652, 2.272216>,
      < -3.529103, -2.140382, 2.272216>
    }
    triangle {
      < -3.733294, -2.055792, 2.185108>,
      < -3.686185, -1.900522, 2.185108>,
      < -3.580705, -1.921509, 2.207291>
    }
    triangle {
      < -3.733294, -2.055792, 2.185108>,
      < -3.580705, -1.921509, 2.207291>,
      < -3.633934, -2.096955, 2.207291>
    }
    triangle {
      < -3.836613, -2.012991, 2.213441>,
      < -3.795870, -1.878699, 2.213441>,
      < -3.686185, -1.900522, 2.185108>
    }
    triangle {
      < -3.836613, -2.012991, 2.213441>,
      < -3.686185, -1.900522, 2.185108>,
      < -3.733294, -2.055792, 2.185108>
    }
    triangle {
      < -3.931676, -1.973609, 2.267810>,
      < -3.896788, -1.858619, 2.267810>,
      < -3.795870, -1.878699, 2.213441>
    }
    triangle {
      < -3.931676, -1.973609, 2.267810>,
      < -3.795870, -1.878699, 2.213441>,
      < -3.836613, -2.012991, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -3.896788, -1.858619, 2.267810>,
      < -3.931676, -1.973609, 2.267810>
    }
    triangle {
      < -3.896788, -1.858619, 2.704448>,
      < -3.885004, -1.739033, 2.704448>,
      < -3.923066, -1.739030, 2.704390>
    }
    triangle {
      < -3.896788, -1.858619, 2.704448>,
      < -3.923066, -1.739030, 2.704390>,
      < -3.934118, -1.851192, 2.704390>
    }
    triangle {
      < -3.795870, -1.878699, 2.758817>,
      < -3.782107, -1.739038, 2.758817>,
      < -3.885004, -1.739033, 2.704448>
    }
    triangle {
      < -3.795870, -1.878699, 2.758817>,
      < -3.885004, -1.739033, 2.704448>,
      < -3.896788, -1.858619, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.686185, -1.900522, 2.787150>,
      < -3.670272, -1.739043, 2.787150>,
      < -3.782107, -1.739038, 2.758817>
    }
    triangle {
      < -3.686185, -1.900522, 2.787150>,
      < -3.782107, -1.739038, 2.758817>,
      < -3.795870, -1.878699, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.580705, -1.921509, 2.764967>,
      < -3.562724, -1.739049, 2.764967>,
      < -3.670272, -1.739043, 2.787150>
    }
    triangle {
      < -3.580705, -1.921509, 2.764967>,
      < -3.670272, -1.739043, 2.787150>,
      < -3.686185, -1.900522, 2.787150>
    }
    triangle {
      < -3.469416, -1.943652, 2.700042>,
      < -3.449254, -1.739055, 2.700042>,
      < -3.562724, -1.739049, 2.764967>
    }
    triangle {
      < -3.469416, -1.943652, 2.700042>,
      < -3.562724, -1.739049, 2.764967>,
      < -3.580705, -1.921509, 2.764967>
    }
    triangle {
      < -3.446512, -1.948209, 2.486032>,
      < -3.425902, -1.739057, 2.486032>,
      < -3.449254, -1.739055, 2.700042>
    }
    triangle {
      < -3.446512, -1.948209, 2.486032>,
      < -3.449254, -1.739055, 2.700042>,
      < -3.469416, -1.943652, 2.700042>
    }
    triangle {
      < -3.469416, -1.943652, 2.272216>,
      < -3.449254, -1.739055, 2.272216>,
      < -3.425902, -1.739057, 2.486032>
    }
    triangle {
      < -3.469416, -1.943652, 2.272216>,
      < -3.425902, -1.739057, 2.486032>,
      < -3.446512, -1.948209, 2.486032>
    }
    triangle {
      < -3.580705, -1.921509, 2.207291>,
      < -3.562724, -1.739049, 2.207291>,
      < -3.449254, -1.739055, 2.272216>
    }
    triangle {
      < -3.580705, -1.921509, 2.207291>,
      < -3.449254, -1.739055, 2.272216>,
      < -3.469416, -1.943652, 2.272216>
    }
    triangle {
      < -3.686185, -1.900522, 2.185108>,
      < -3.670272, -1.739043, 2.185108>,
      < -3.562724, -1.739049, 2.207291>
    }
    triangle {
      < -3.686185, -1.900522, 2.185108>,
      < -3.562724, -1.739049, 2.207291>,
      < -3.580705, -1.921509, 2.207291>
    }
    triangle {
      < -3.795870, -1.878699, 2.213441>,
      < -3.782107, -1.739038, 2.213441>,
      < -3.670272, -1.739043, 2.185108>
    }
    triangle {
      < -3.795870, -1.878699, 2.213441>,
      < -3.670272, -1.739043, 2.185108>,
      < -3.686185, -1.900522, 2.185108>
    }
    triangle {
      < -3.896788, -1.858619, 2.267810>,
      < -3.885004, -1.739033, 2.267810>,
      < -3.782107, -1.739038, 2.213441>
    }
    triangle {
      < -3.896788, -1.858619, 2.267810>,
      < -3.782107, -1.739038, 2.213441>,
      < -3.795870, -1.878699, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -3.885004, -1.739033, 2.267810>,
      < -3.896788, -1.858619, 2.267810>
    }
    triangle {
      < -3.885004, -1.739033, 2.704448>,
      < -3.896776, -1.619444, 2.704448>,
      < -3.934107, -1.626868, 2.704390>
    }
    triangle {
      < -3.885004, -1.739033, 2.704448>,
      < -3.934107, -1.626868, 2.704390>,
      < -3.923066, -1.739030, 2.704390>
    }
    triangle {
      < -3.782107, -1.739038, 2.758817>,
      < -3.795855, -1.599375, 2.758817>,
      < -3.896776, -1.619444, 2.704448>
    }
    triangle {
      < -3.782107, -1.739038, 2.758817>,
      < -3.896776, -1.619444, 2.704448>,
      < -3.885004, -1.739033, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.670272, -1.739043, 2.787150>,
      < -3.686168, -1.577563, 2.787150>,
      < -3.795855, -1.599375, 2.758817>
    }
    triangle {
      < -3.670272, -1.739043, 2.787150>,
      < -3.795855, -1.599375, 2.758817>,
      < -3.782107, -1.739038, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.562724, -1.739049, 2.764967>,
      < -3.580685, -1.556588, 2.764967>,
      < -3.686168, -1.577563, 2.787150>
    }
    triangle {
      < -3.562724, -1.739049, 2.764967>,
      < -3.686168, -1.577563, 2.787150>,
      < -3.670272, -1.739043, 2.787150>
    }
    triangle {
      < -3.449254, -1.739055, 2.700042>,
      < -3.469395, -1.534457, 2.700042>,
      < -3.580685, -1.556588, 2.764967>
    }
    triangle {
      < -3.449254, -1.739055, 2.700042>,
      < -3.580685, -1.556588, 2.764967>,
      < -3.562724, -1.739049, 2.764967>
    }
    triangle {
      < -3.425902, -1.739057, 2.486032>,
      < -3.446491, -1.529903, 2.486032>,
      < -3.469395, -1.534457, 2.700042>
    }
    triangle {
      < -3.425902, -1.739057, 2.486032>,
      < -3.469395, -1.534457, 2.700042>,
      < -3.449254, -1.739055, 2.700042>
    }
    triangle {
      < -3.449254, -1.739055, 2.272216>,
      < -3.469395, -1.534457, 2.272216>,
      < -3.446491, -1.529903, 2.486032>
    }
    triangle {
      < -3.449254, -1.739055, 2.272216>,
      < -3.446491, -1.529903, 2.486032>,
      < -3.425902, -1.739057, 2.486032>
    }
    triangle {
      < -3.562724, -1.739049, 2.207291>,
      < -3.580685, -1.556588, 2.207291>,
      < -3.469395, -1.534457, 2.272216>
    }
    triangle {
      < -3.562724, -1.739049, 2.207291>,
      < -3.469395, -1.534457, 2.272216>,
      < -3.449254, -1.739055, 2.272216>
    }
    triangle {
      < -3.670272, -1.739043, 2.185108>,
      < -3.686168, -1.577563, 2.185108>,
      < -3.580685, -1.556588, 2.207291>
    }
    triangle {
      < -3.670272, -1.739043, 2.185108>,
      < -3.580685, -1.556588, 2.207291>,
      < -3.562724, -1.739049, 2.207291>
    }
    triangle {
      < -3.782107, -1.739038, 2.213441>,
      < -3.795855, -1.599375, 2.213441>,
      < -3.686168, -1.577563, 2.185108>
    }
    triangle {
      < -3.782107, -1.739038, 2.213441>,
      < -3.686168, -1.577563, 2.185108>,
      < -3.670272, -1.739043, 2.185108>
    }
    triangle {
      < -3.885004, -1.739033, 2.267810>,
      < -3.896776, -1.619444, 2.267810>,
      < -3.795855, -1.599375, 2.213441>
    }
    triangle {
      < -3.885004, -1.739033, 2.267810>,
      < -3.795855, -1.599375, 2.213441>,
      < -3.782107, -1.739038, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -3.896776, -1.619444, 2.267810>,
      < -3.885004, -1.739033, 2.267810>
    }
    triangle {
      < -3.896776, -1.619444, 2.704448>,
      < -3.931651, -1.504450, 2.704448>,
      < -3.966817, -1.519013, 2.704390>
    }
    triangle {
      < -3.896776, -1.619444, 2.704448>,
      < -3.966817, -1.519013, 2.704390>,
      < -3.934107, -1.626868, 2.704390>
    }
    triangle {
      < -3.795855, -1.599375, 2.758817>,
      < -3.836585, -1.465079, 2.758817>,
      < -3.931651, -1.504450, 2.704448>
    }
    triangle {
      < -3.795855, -1.599375, 2.758817>,
      < -3.931651, -1.504450, 2.704448>,
      < -3.896776, -1.619444, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.686168, -1.577563, 2.787150>,
      < -3.733261, -1.422288, 2.787150>,
      < -3.836585, -1.465079, 2.758817>
    }
    triangle {
      < -3.686168, -1.577563, 2.787150>,
      < -3.836585, -1.465079, 2.758817>,
      < -3.795855, -1.599375, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.580685, -1.556588, 2.764967>,
      < -3.633897, -1.381136, 2.764967>,
      < -3.733261, -1.422288, 2.787150>
    }
    triangle {
      < -3.580685, -1.556588, 2.764967>,
      < -3.733261, -1.422288, 2.787150>,
      < -3.686168, -1.577563, 2.787150>
    }
    triangle {
      < -3.469395, -1.534457, 2.700042>,
      < -3.529061, -1.337719, 2.700042>,
      < -3.633897, -1.381136, 2.764967>
    }
    triangle {
      < -3.469395, -1.534457, 2.700042>,
      < -3.633897, -1.381136, 2.764967>,
      < -3.580685, -1.556588, 2.764967>
    }
    triangle {
      < -3.446491, -1.529903, 2.486032>,
      < -3.507486, -1.328784, 2.486032>,
      < -3.529061, -1.337719, 2.700042>
    }
    triangle {
      < -3.446491, -1.529903, 2.486032>,
      < -3.529061, -1.337719, 2.700042>,
      < -3.469395, -1.534457, 2.700042>
    }
    triangle {
      < -3.469395, -1.534457, 2.272216>,
      < -3.529061, -1.337719, 2.272216>,
      < -3.507486, -1.328784, 2.486032>
    }
    triangle {
      < -3.469395, -1.534457, 2.272216>,
      < -3.507486, -1.328784, 2.486032>,
      < -3.446491, -1.529903, 2.486032>
    }
    triangle {
      < -3.580685, -1.556588, 2.207291>,
      < -3.633897, -1.381136, 2.207291>,
      < -3.529061, -1.337719, 2.272216>
    }
    triangle {
      < -3.580685, -1.556588, 2.207291>,
      < -3.529061, -1.337719, 2.272216>,
      < -3.469395, -1.534457, 2.272216>
    }
    triangle {
      < -3.686168, -1.577563, 2.185108>,
      < -3.733261, -1.422288, 2.185108>,
      < -3.633897, -1.381136, 2.207291>
    }
    triangle {
      < -3.686168, -1.577563, 2.185108>,
      < -3.633897, -1.381136, 2.207291>,
      < -3.580685, -1.556588, 2.207291>
    }
    triangle {
      < -3.795855, -1.599375, 2.213441>,
      < -3.836585, -1.465079, 2.213441>,
      < -3.733261, -1.422288, 2.185108>
    }
    triangle {
      < -3.795855, -1.599375, 2.213441>,
      < -3.733261, -1.422288, 2.185108>,
      < -3.686168, -1.577563, 2.185108>
    }
    triangle {
      < -3.896776, -1.619444, 2.267810>,
      < -3.931651, -1.504450, 2.267810>,
      < -3.836585, -1.465079, 2.213441>
    }
    triangle {
      < -3.896776, -1.619444, 2.267810>,
      < -3.836585, -1.465079, 2.213441>,
      < -3.795855, -1.599375, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -3.931651, -1.504450, 2.267810>,
      < -3.896776, -1.619444, 2.267810>
    }
    triangle {
      < -3.931651, -1.504450, 2.704448>,
      < -3.988291, -1.398469, 2.704448>,
      < -4.019940, -1.419614, 2.704390>
    }
    triangle {
      < -3.931651, -1.504450, 2.704448>,
      < -4.019940, -1.419614, 2.704390>,
      < -3.966817, -1.519013, 2.704390>
    }
    triangle {
      < -3.836585, -1.465079, 2.758817>,
      < -3.902732, -1.341308, 2.758817>,
      < -3.988291, -1.398469, 2.704448>
    }
    triangle {
      < -3.836585, -1.465079, 2.758817>,
      < -3.988291, -1.398469, 2.704448>,
      < -3.931651, -1.504450, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.733261, -1.422288, 2.787150>,
      < -3.809741, -1.279182, 2.787150>,
      < -3.902732, -1.341308, 2.758817>
    }
    triangle {
      < -3.733261, -1.422288, 2.787150>,
      < -3.902732, -1.341308, 2.758817>,
      < -3.836585, -1.465079, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.633897, -1.381136, 2.764967>,
      < -3.720314, -1.219437, 2.764967>,
      < -3.809741, -1.279182, 2.787150>
    }
    triangle {
      < -3.633897, -1.381136, 2.764967>,
      < -3.809741, -1.279182, 2.787150>,
      < -3.733261, -1.422288, 2.787150>
    }
    triangle {
      < -3.529061, -1.337719, 2.700042>,
      < -3.625963, -1.156403, 2.700042>,
      < -3.720314, -1.219437, 2.764967>
    }
    triangle {
      < -3.529061, -1.337719, 2.700042>,
      < -3.720314, -1.219437, 2.764967>,
      < -3.633897, -1.381136, 2.764967>
    }
    triangle {
      < -3.507486, -1.328784, 2.486032>,
      < -3.606545, -1.143430, 2.486032>,
      < -3.625963, -1.156403, 2.700042>
    }
    triangle {
      < -3.507486, -1.328784, 2.486032>,
      < -3.625963, -1.156403, 2.700042>,
      < -3.529061, -1.337719, 2.700042>
    }
    triangle {
      < -3.529061, -1.337719, 2.272216>,
      < -3.625963, -1.156403, 2.272216>,
      < -3.606545, -1.143430, 2.486032>
    }
    triangle {
      < -3.529061, -1.337719, 2.272216>,
      < -3.606545, -1.143430, 2.486032>,
      < -3.507486, -1.328784, 2.486032>
    }
    triangle {
      < -3.633897, -1.381136, 2.207291>,
      < -3.720314, -1.219437, 2.207291>,
      < -3.625963, -1.156403, 2.272216>
    }
    triangle {
      < -3.633897, -1.381136, 2.207291>,
      < -3.625963, -1.156403, 2.272216>,
      < -3.529061, -1.337719, 2.272216>
    }
    triangle {
      < -3.733261, -1.422288, 2.185108>,
      < -3.809741, -1.279182, 2.185108>,
      < -3.720314, -1.219437, 2.207291>
    }
    triangle {
      < -3.733261, -1.422288, 2.185108>,
      < -3.720314, -1.219437, 2.207291>,
      < -3.633897, -1.381136, 2.207291>
    }
    triangle {
      < -3.836585, -1.465079, 2.213441>,
      < -3.902732, -1.341308, 2.213441>,
      < -3.809741, -1.279182, 2.185108>
    }
    triangle {
      < -3.836585, -1.465079, 2.213441>,
      < -3.809741, -1.279182, 2.185108>,
      < -3.733261, -1.422288, 2.185108>
    }
    triangle {
      < -3.931651, -1.504450, 2.267810>,
      < -3.988291, -1.398469, 2.267810>,
      < -3.902732, -1.341308, 2.213441>
    }
    triangle {
      < -3.931651, -1.504450, 2.267810>,
      < -3.902732, -1.341308, 2.213441>,
      < -3.836585, -1.465079, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -3.988291, -1.398469, 2.267810>,
      < -3.931651, -1.504450, 2.267810>
    }
    triangle {
      < -3.988291, -1.398469, 2.704448>,
      < -4.064518, -1.305575, 2.704448>,
      < -4.091434, -1.332487, 2.704390>
    }
    triangle {
      < -3.988291, -1.398469, 2.704448>,
      < -4.091434, -1.332487, 2.704390>,
      < -4.019940, -1.419614, 2.704390>
    }
    triangle {
      < -3.902732, -1.341308, 2.758817>,
      < -3.991754, -1.232821, 2.758817>,
      < -4.064518, -1.305575, 2.704448>
    }
    triangle {
      < -3.902732, -1.341308, 2.758817>,
      < -4.064518, -1.305575, 2.704448>,
      < -3.988291, -1.398469, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.809741, -1.279182, 2.787150>,
      < -3.912669, -1.153747, 2.787150>,
      < -3.991754, -1.232821, 2.758817>
    }
    triangle {
      < -3.809741, -1.279182, 2.787150>,
      < -3.991754, -1.232821, 2.758817>,
      < -3.902732, -1.341308, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.720314, -1.219437, 2.764967>,
      < -3.836617, -1.077703, 2.764967>,
      < -3.912669, -1.153747, 2.787150>
    }
    triangle {
      < -3.720314, -1.219437, 2.764967>,
      < -3.912669, -1.153747, 2.787150>,
      < -3.809741, -1.279182, 2.787150>
    }
    triangle {
      < -3.625963, -1.156403, 2.700042>,
      < -3.756376, -0.997473, 2.700042>,
      < -3.836617, -1.077703, 2.764967>
    }
    triangle {
      < -3.625963, -1.156403, 2.700042>,
      < -3.836617, -1.077703, 2.764967>,
      < -3.720314, -1.219437, 2.764967>
    }
    triangle {
      < -3.606545, -1.143430, 2.486032>,
      < -3.739863, -0.980962, 2.486032>,
      < -3.756376, -0.997473, 2.700042>
    }
    triangle {
      < -3.606545, -1.143430, 2.486032>,
      < -3.756376, -0.997473, 2.700042>,
      < -3.625963, -1.156403, 2.700042>
    }
    triangle {
      < -3.625963, -1.156403, 2.272216>,
      < -3.756376, -0.997473, 2.272216>,
      < -3.739863, -0.980962, 2.486032>
    }
    triangle {
      < -3.625963, -1.156403, 2.272216>,
      < -3.739863, -0.980962, 2.486032>,
      < -3.606545, -1.143430, 2.486032>
    }
    triangle {
      < -3.720314, -1.219437, 2.207291>,
      < -3.836617, -1.077703, 2.207291>,
      < -3.756376, -0.997473, 2.272216>
    }
    triangle {
      < -3.720314, -1.219437, 2.207291>,
      < -3.756376, -0.997473, 2.272216>,
      < -3.625963, -1.156403, 2.272216>
    }
    triangle {
      < -3.809741, -1.279182, 2.185108>,
      < -3.912669, -1.153747, 2.185108>,
      < -3.836617, -1.077703, 2.207291>
    }
    triangle {
      < -3.809741, -1.279182, 2.185108>,
      < -3.836617, -1.077703, 2.207291>,
      < -3.720314, -1.219437, 2.207291>
    }
    triangle {
      < -3.902732, -1.341308, 2.213441>,
      < -3.991754, -1.232821, 2.213441>,
      < -3.912669, -1.153747, 2.185108>
    }
    triangle {
      < -3.902732, -1.341308, 2.213441>,
      < -3.912669, -1.153747, 2.185108>,
      < -3.809741, -1.279182, 2.185108>
    }
    triangle {
      < -3.988291, -1.398469, 2.267810>,
      < -4.064518, -1.305575, 2.267810>,
      < -3.991754, -1.232821, 2.213441>
    }
    triangle {
      < -3.988291, -1.398469, 2.267810>,
      < -3.991754, -1.232821, 2.213441>,
      < -3.902732, -1.341308, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.064518, -1.305575, 2.267810>,
      < -3.988291, -1.398469, 2.267810>
    }
    triangle {
      < -4.064518, -1.305575, 2.704448>,
      < -4.157403, -1.229336, 2.704448>,
      < -4.178551, -1.260982, 2.704390>
    }
    triangle {
      < -4.064518, -1.305575, 2.704448>,
      < -4.178551, -1.260982, 2.704390>,
      < -4.091434, -1.332487, 2.704390>
    }
    triangle {
      < -3.991754, -1.232821, 2.758817>,
      < -4.100230, -1.143784, 2.758817>,
      < -4.157403, -1.229336, 2.704448>
    }
    triangle {
      < -3.991754, -1.232821, 2.758817>,
      < -4.157403, -1.229336, 2.704448>,
      < -4.064518, -1.305575, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -3.912669, -1.153747, 2.787150>,
      < -4.038092, -1.050802, 2.787150>,
      < -4.100230, -1.143784, 2.758817>
    }
    triangle {
      < -3.912669, -1.153747, 2.787150>,
      < -4.100230, -1.143784, 2.758817>,
      < -3.991754, -1.232821, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.836617, -1.077703, 2.764967>,
      < -3.978335, -0.961382, 2.764967>,
      < -4.038092, -1.050802, 2.787150>
    }
    triangle {
      < -3.836617, -1.077703, 2.764967>,
      < -4.038092, -1.050802, 2.787150>,
      < -3.912669, -1.153747, 2.787150>
    }
    triangle {
      < -3.756376, -0.997473, 2.700042>,
      < -3.915288, -0.867040, 2.700042>,
      < -3.978335, -0.961382, 2.764967>
    }
    triangle {
      < -3.756376, -0.997473, 2.700042>,
      < -3.978335, -0.961382, 2.764967>,
      < -3.836617, -1.077703, 2.764967>
    }
    triangle {
      < -3.739863, -0.980962, 2.486032>,
      < -3.902312, -0.847624, 2.486032>,
      < -3.915288, -0.867040, 2.700042>
    }
    triangle {
      < -3.739863, -0.980962, 2.486032>,
      < -3.915288, -0.867040, 2.700042>,
      < -3.756376, -0.997473, 2.700042>
    }
    triangle {
      < -3.756376, -0.997473, 2.272216>,
      < -3.915288, -0.867040, 2.272216>,
      < -3.902312, -0.847624, 2.486032>
    }
    triangle {
      < -3.756376, -0.997473, 2.272216>,
      < -3.902312, -0.847624, 2.486032>,
      < -3.739863, -0.980962, 2.486032>
    }
    triangle {
      < -3.836617, -1.077703, 2.207291>,
      < -3.978335, -0.961382, 2.207291>,
      < -3.915288, -0.867040, 2.272216>
    }
    triangle {
      < -3.836617, -1.077703, 2.207291>,
      < -3.915288, -0.867040, 2.272216>,
      < -3.756376, -0.997473, 2.272216>
    }
    triangle {
      < -3.912669, -1.153747, 2.185108>,
      < -4.038092, -1.050802, 2.185108>,
      < -3.978335, -0.961382, 2.207291>
    }
    triangle {
      < -3.912669, -1.153747, 2.185108>,
      < -3.978335, -0.961382, 2.207291>,
      < -3.836617, -1.077703, 2.207291>
    }
    triangle {
      < -3.991754, -1.232821, 2.213441>,
      < -4.100230, -1.143784, 2.213441>,
      < -4.038092, -1.050802, 2.185108>
    }
    triangle {
      < -3.991754, -1.232821, 2.213441>,
      < -4.038092, -1.050802, 2.185108>,
      < -3.912669, -1.153747, 2.185108>
    }
    triangle {
      < -4.064518, -1.305575, 2.267810>,
      < -4.157403, -1.229336, 2.267810>,
      < -4.100230, -1.143784, 2.213441>
    }
    triangle {
      < -4.064518, -1.305575, 2.267810>,
      < -4.100230, -1.143784, 2.213441>,
      < -3.991754, -1.232821, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.157403, -1.229336, 2.267810>,
      < -4.064518, -1.305575, 2.267810>
    }
    triangle {
      < -4.157403, -1.229336, 2.704448>,
      < -4.263376, -1.172683, 2.704448>,
      < -4.277944, -1.207846, 2.704390>
    }
    triangle {
      < -4.157403, -1.229336, 2.704448>,
      < -4.277944, -1.207846, 2.704390>,
      < -4.178551, -1.260982, 2.704390>
    }
    triangle {
      < -4.100230, -1.143784, 2.758817>,
      < -4.223992, -1.077621, 2.758817>,
      < -4.263376, -1.172683, 2.704448>
    }
    triangle {
      < -4.100230, -1.143784, 2.758817>,
      < -4.263376, -1.172683, 2.704448>,
      < -4.157403, -1.229336, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.038092, -1.050802, 2.787150>,
      < -4.181187, -0.974301, 2.787150>,
      < -4.223992, -1.077621, 2.758817>
    }
    triangle {
      < -4.038092, -1.050802, 2.787150>,
      < -4.223992, -1.077621, 2.758817>,
      < -4.100230, -1.143784, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -3.978335, -0.961382, 2.764967>,
      < -4.140024, -0.874944, 2.764967>,
      < -4.181187, -0.974301, 2.787150>
    }
    triangle {
      < -3.978335, -0.961382, 2.764967>,
      < -4.181187, -0.974301, 2.787150>,
      < -4.038092, -1.050802, 2.787150>
    }
    triangle {
      < -3.915288, -0.867040, 2.700042>,
      < -4.096592, -0.770114, 2.700042>,
      < -4.140024, -0.874944, 2.764967>
    }
    triangle {
      < -3.915288, -0.867040, 2.700042>,
      < -4.140024, -0.874944, 2.764967>,
      < -3.978335, -0.961382, 2.764967>
    }
    triangle {
      < -3.902312, -0.847624, 2.486032>,
      < -4.087654, -0.748540, 2.486032>,
      < -4.096592, -0.770114, 2.700042>
    }
    triangle {
      < -3.902312, -0.847624, 2.486032>,
      < -4.096592, -0.770114, 2.700042>,
      < -3.915288, -0.867040, 2.700042>
    }
    triangle {
      < -3.915288, -0.867040, 2.272216>,
      < -4.096592, -0.770114, 2.272216>,
      < -4.087654, -0.748540, 2.486032>
    }
    triangle {
      < -3.915288, -0.867040, 2.272216>,
      < -4.087654, -0.748540, 2.486032>,
      < -3.902312, -0.847624, 2.486032>
    }
    triangle {
      < -3.978335, -0.961382, 2.207291>,
      < -4.140024, -0.874944, 2.207291>,
      < -4.096592, -0.770114, 2.272216>
    }
    triangle {
      < -3.978335, -0.961382, 2.207291>,
      < -4.096592, -0.770114, 2.272216>,
      < -3.915288, -0.867040, 2.272216>
    }
    triangle {
      < -4.038092, -1.050802, 2.185108>,
      < -4.181187, -0.974301, 2.185108>,
      < -4.140024, -0.874944, 2.207291>
    }
    triangle {
      < -4.038092, -1.050802, 2.185108>,
      < -4.140024, -0.874944, 2.207291>,
      < -3.978335, -0.961382, 2.207291>
    }
    triangle {
      < -4.100230, -1.143784, 2.213441>,
      < -4.223992, -1.077621, 2.213441>,
      < -4.181187, -0.974301, 2.185108>
    }
    triangle {
      < -4.100230, -1.143784, 2.213441>,
      < -4.181187, -0.974301, 2.185108>,
      < -4.038092, -1.050802, 2.185108>
    }
    triangle {
      < -4.157403, -1.229336, 2.267810>,
      < -4.263376, -1.172683, 2.267810>,
      < -4.223992, -1.077621, 2.213441>
    }
    triangle {
      < -4.157403, -1.229336, 2.267810>,
      < -4.223992, -1.077621, 2.213441>,
      < -4.100230, -1.143784, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.263376, -1.172683, 2.267810>,
      < -4.157403, -1.229336, 2.267810>
    }
    triangle {
      < -4.263376, -1.172683, 2.704448>,
      < -4.378364, -1.137792, 2.704448>,
      < -4.385793, -1.175122, 2.704390>
    }
    triangle {
      < -4.263376, -1.172683, 2.704448>,
      < -4.385793, -1.175122, 2.704390>,
      < -4.277944, -1.207846, 2.704390>
    }
    triangle {
      < -4.223992, -1.077621, 2.758817>,
      < -4.358283, -1.036873, 2.758817>,
      < -4.378364, -1.137792, 2.704448>
    }
    triangle {
      < -4.223992, -1.077621, 2.758817>,
      < -4.378364, -1.137792, 2.704448>,
      < -4.263376, -1.172683, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.181187, -0.974301, 2.787150>,
      < -4.336457, -0.927189, 2.787150>,
      < -4.358283, -1.036873, 2.758817>
    }
    triangle {
      < -4.181187, -0.974301, 2.787150>,
      < -4.358283, -1.036873, 2.758817>,
      < -4.223992, -1.077621, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.140024, -0.874944, 2.764967>,
      < -4.315467, -0.821709, 2.764967>,
      < -4.336457, -0.927189, 2.787150>
    }
    triangle {
      < -4.140024, -0.874944, 2.764967>,
      < -4.336457, -0.927189, 2.787150>,
      < -4.181187, -0.974301, 2.787150>
    }
    triangle {
      < -4.096592, -0.770114, 2.700042>,
      < -4.293321, -0.710421, 2.700042>,
      < -4.315467, -0.821709, 2.764967>
    }
    triangle {
      < -4.096592, -0.770114, 2.700042>,
      < -4.315467, -0.821709, 2.764967>,
      < -4.140024, -0.874944, 2.764967>
    }
    triangle {
      < -4.087654, -0.748540, 2.486032>,
      < -4.288765, -0.687518, 2.486032>,
      < -4.293321, -0.710421, 2.700042>
    }
    triangle {
      < -4.087654, -0.748540, 2.486032>,
      < -4.293321, -0.710421, 2.700042>,
      < -4.096592, -0.770114, 2.700042>
    }
    triangle {
      < -4.096592, -0.770114, 2.272216>,
      < -4.293321, -0.710421, 2.272216>,
      < -4.288765, -0.687518, 2.486032>
    }
    triangle {
      < -4.096592, -0.770114, 2.272216>,
      < -4.288765, -0.687518, 2.486032>,
      < -4.087654, -0.748540, 2.486032>
    }
    triangle {
      < -4.140024, -0.874944, 2.207291>,
      < -4.315467, -0.821709, 2.207291>,
      < -4.293321, -0.710421, 2.272216>
    }
    triangle {
      < -4.140024, -0.874944, 2.207291>,
      < -4.293321, -0.710421, 2.272216>,
      < -4.096592, -0.770114, 2.272216>
    }
    triangle {
      < -4.181187, -0.974301, 2.185108>,
      < -4.336457, -0.927189, 2.185108>,
      < -4.315467, -0.821709, 2.207291>
    }
    triangle {
      < -4.181187, -0.974301, 2.185108>,
      < -4.315467, -0.821709, 2.207291>,
      < -4.140024, -0.874944, 2.207291>
    }
    triangle {
      < -4.223992, -1.077621, 2.213441>,
      < -4.358283, -1.036873, 2.213441>,
      < -4.336457, -0.927189, 2.185108>
    }
    triangle {
      < -4.223992, -1.077621, 2.213441>,
      < -4.336457, -0.927189, 2.185108>,
      < -4.181187, -0.974301, 2.185108>
    }
    triangle {
      < -4.263376, -1.172683, 2.267810>,
      < -4.378364, -1.137792, 2.267810>,
      < -4.358283, -1.036873, 2.213441>
    }
    triangle {
      < -4.263376, -1.172683, 2.267810>,
      < -4.358283, -1.036873, 2.213441>,
      < -4.223992, -1.077621, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.378364, -1.137792, 2.267810>,
      < -4.263376, -1.172683, 2.267810>
    }
    triangle {
      < -4.378364, -1.137792, 2.704448>,
      < -4.497952, -1.126004, 2.704448>,
      < -4.497954, -1.164066, 2.704390>
    }
    triangle {
      < -4.378364, -1.137792, 2.704448>,
      < -4.497954, -1.164066, 2.704390>,
      < -4.385793, -1.175122, 2.704390>
    }
    triangle {
      < -4.358283, -1.036873, 2.758817>,
      < -4.497943, -1.023107, 2.758817>,
      < -4.497952, -1.126004, 2.704448>
    }
    triangle {
      < -4.358283, -1.036873, 2.758817>,
      < -4.497952, -1.126004, 2.704448>,
      < -4.378364, -1.137792, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.336457, -0.927189, 2.787150>,
      < -4.497935, -0.911271, 2.787150>,
      < -4.497943, -1.023107, 2.758817>
    }
    triangle {
      < -4.336457, -0.927189, 2.787150>,
      < -4.497943, -1.023107, 2.758817>,
      < -4.358283, -1.036873, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.315467, -0.821709, 2.764967>,
      < -4.497925, -0.803724, 2.764967>,
      < -4.497935, -0.911271, 2.787150>
    }
    triangle {
      < -4.315467, -0.821709, 2.764967>,
      < -4.497935, -0.911271, 2.787150>,
      < -4.336457, -0.927189, 2.787150>
    }
    triangle {
      < -4.293321, -0.710421, 2.700042>,
      < -4.497918, -0.690254, 2.700042>,
      < -4.497925, -0.803724, 2.764967>
    }
    triangle {
      < -4.293321, -0.710421, 2.700042>,
      < -4.497925, -0.803724, 2.764967>,
      < -4.315467, -0.821709, 2.764967>
    }
    triangle {
      < -4.288765, -0.687518, 2.486032>,
      < -4.497915, -0.666902, 2.486032>,
      < -4.497918, -0.690254, 2.700042>
    }
    triangle {
      < -4.288765, -0.687518, 2.486032>,
      < -4.497918, -0.690254, 2.700042>,
      < -4.293321, -0.710421, 2.700042>
    }
    triangle {
      < -4.293321, -0.710421, 2.272216>,
      < -4.497918, -0.690254, 2.272216>,
      < -4.497915, -0.666902, 2.486032>
    }
    triangle {
      < -4.293321, -0.710421, 2.272216>,
      < -4.497915, -0.666902, 2.486032>,
      < -4.288765, -0.687518, 2.486032>
    }
    triangle {
      < -4.315467, -0.821709, 2.207291>,
      < -4.497925, -0.803724, 2.207291>,
      < -4.497918, -0.690254, 2.272216>
    }
    triangle {
      < -4.315467, -0.821709, 2.207291>,
      < -4.497918, -0.690254, 2.272216>,
      < -4.293321, -0.710421, 2.272216>
    }
    triangle {
      < -4.336457, -0.927189, 2.185108>,
      < -4.497935, -0.911271, 2.185108>,
      < -4.497925, -0.803724, 2.207291>
    }
    triangle {
      < -4.336457, -0.927189, 2.185108>,
      < -4.497925, -0.803724, 2.207291>,
      < -4.315467, -0.821709, 2.207291>
    }
    triangle {
      < -4.358283, -1.036873, 2.213441>,
      < -4.497943, -1.023107, 2.213441>,
      < -4.497935, -0.911271, 2.185108>
    }
    triangle {
      < -4.358283, -1.036873, 2.213441>,
      < -4.497935, -0.911271, 2.185108>,
      < -4.336457, -0.927189, 2.185108>
    }
    triangle {
      < -4.378364, -1.137792, 2.267810>,
      < -4.497952, -1.126004, 2.267810>,
      < -4.497943, -1.023107, 2.213441>
    }
    triangle {
      < -4.378364, -1.137792, 2.267810>,
      < -4.497943, -1.023107, 2.213441>,
      < -4.358283, -1.036873, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.497952, -1.126004, 2.267810>,
      < -4.378364, -1.137792, 2.267810>
    }
    triangle {
      < -4.497952, -1.126004, 2.704448>,
      < -4.617540, -1.137773, 2.704448>,
      < -4.610118, -1.175104, 2.704390>
    }
    triangle {
      < -4.497952, -1.126004, 2.704448>,
      < -4.610118, -1.175104, 2.704390>,
      < -4.497954, -1.164066, 2.704390>
    }
    triangle {
      < -4.497943, -1.023107, 2.758817>,
      < -4.637606, -1.036851, 2.758817>,
      < -4.617540, -1.137773, 2.704448>
    }
    triangle {
      < -4.497943, -1.023107, 2.758817>,
      < -4.617540, -1.137773, 2.704448>,
      < -4.497952, -1.126004, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.497935, -0.911271, 2.787150>,
      < -4.659415, -0.927164, 2.787150>,
      < -4.637606, -1.036851, 2.758817>
    }
    triangle {
      < -4.497935, -0.911271, 2.787150>,
      < -4.637606, -1.036851, 2.758817>,
      < -4.497943, -1.023107, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.497925, -0.803724, 2.764967>,
      < -4.680388, -0.821680, 2.764967>,
      < -4.659415, -0.927164, 2.787150>
    }
    triangle {
      < -4.497925, -0.803724, 2.764967>,
      < -4.659415, -0.927164, 2.787150>,
      < -4.497935, -0.911271, 2.787150>
    }
    triangle {
      < -4.497918, -0.690254, 2.700042>,
      < -4.702516, -0.710389, 2.700042>,
      < -4.680388, -0.821680, 2.764967>
    }
    triangle {
      < -4.497918, -0.690254, 2.700042>,
      < -4.680388, -0.821680, 2.764967>,
      < -4.497925, -0.803724, 2.764967>
    }
    triangle {
      < -4.497915, -0.666902, 2.486032>,
      < -4.707070, -0.687485, 2.486032>,
      < -4.702516, -0.710389, 2.700042>
    }
    triangle {
      < -4.497915, -0.666902, 2.486032>,
      < -4.702516, -0.710389, 2.700042>,
      < -4.497918, -0.690254, 2.700042>
    }
    triangle {
      < -4.497918, -0.690254, 2.272216>,
      < -4.702516, -0.710389, 2.272216>,
      < -4.707070, -0.687485, 2.486032>
    }
    triangle {
      < -4.497918, -0.690254, 2.272216>,
      < -4.707070, -0.687485, 2.486032>,
      < -4.497915, -0.666902, 2.486032>
    }
    triangle {
      < -4.497925, -0.803724, 2.207291>,
      < -4.680388, -0.821680, 2.207291>,
      < -4.702516, -0.710389, 2.272216>
    }
    triangle {
      < -4.497925, -0.803724, 2.207291>,
      < -4.702516, -0.710389, 2.272216>,
      < -4.497918, -0.690254, 2.272216>
    }
    triangle {
      < -4.497935, -0.911271, 2.185108>,
      < -4.659415, -0.927164, 2.185108>,
      < -4.680388, -0.821680, 2.207291>
    }
    triangle {
      < -4.497935, -0.911271, 2.185108>,
      < -4.680388, -0.821680, 2.207291>,
      < -4.497925, -0.803724, 2.207291>
    }
    triangle {
      < -4.497943, -1.023107, 2.213441>,
      < -4.637606, -1.036851, 2.213441>,
      < -4.659415, -0.927164, 2.185108>
    }
    triangle {
      < -4.497943, -1.023107, 2.213441>,
      < -4.659415, -0.927164, 2.185108>,
      < -4.497935, -0.911271, 2.185108>
    }
    triangle {
      < -4.497952, -1.126004, 2.267810>,
      < -4.617540, -1.137773, 2.267810>,
      < -4.637606, -1.036851, 2.213441>
    }
    triangle {
      < -4.497952, -1.126004, 2.267810>,
      < -4.637606, -1.036851, 2.213441>,
      < -4.497943, -1.023107, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.617540, -1.137773, 2.267810>,
      < -4.497952, -1.126004, 2.267810>
    }
    triangle {
      < -4.617540, -1.137773, 2.704448>,
      < -4.732534, -1.172645, 2.704448>,
      < -4.717972, -1.207811, 2.704390>
    }
    triangle {
      < -4.617540, -1.137773, 2.704448>,
      < -4.717972, -1.207811, 2.704390>,
      < -4.610118, -1.175104, 2.704390>
    }
    triangle {
      < -4.637606, -1.036851, 2.758817>,
      < -4.771904, -1.077578, 2.758817>,
      < -4.732534, -1.172645, 2.704448>
    }
    triangle {
      < -4.637606, -1.036851, 2.758817>,
      < -4.732534, -1.172645, 2.704448>,
      < -4.617540, -1.137773, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.659415, -0.927164, 2.787150>,
      < -4.814693, -0.974252, 2.787150>,
      < -4.771904, -1.077578, 2.758817>
    }
    triangle {
      < -4.659415, -0.927164, 2.787150>,
      < -4.771904, -1.077578, 2.758817>,
      < -4.637606, -1.036851, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.680388, -0.821680, 2.764967>,
      < -4.855841, -0.874888, 2.764967>,
      < -4.814693, -0.974252, 2.787150>
    }
    triangle {
      < -4.680388, -0.821680, 2.764967>,
      < -4.814693, -0.974252, 2.787150>,
      < -4.659415, -0.927164, 2.787150>
    }
    triangle {
      < -4.702516, -0.710389, 2.700042>,
      < -4.899255, -0.770051, 2.700042>,
      < -4.855841, -0.874888, 2.764967>
    }
    triangle {
      < -4.702516, -0.710389, 2.700042>,
      < -4.855841, -0.874888, 2.764967>,
      < -4.680388, -0.821680, 2.764967>
    }
    triangle {
      < -4.707070, -0.687485, 2.486032>,
      < -4.908190, -0.748475, 2.486032>,
      < -4.899255, -0.770051, 2.700042>
    }
    triangle {
      < -4.707070, -0.687485, 2.486032>,
      < -4.899255, -0.770051, 2.700042>,
      < -4.702516, -0.710389, 2.700042>
    }
    triangle {
      < -4.702516, -0.710389, 2.272216>,
      < -4.899255, -0.770051, 2.272216>,
      < -4.908190, -0.748475, 2.486032>
    }
    triangle {
      < -4.702516, -0.710389, 2.272216>,
      < -4.908190, -0.748475, 2.486032>,
      < -4.707070, -0.687485, 2.486032>
    }
    triangle {
      < -4.680388, -0.821680, 2.207291>,
      < -4.855841, -0.874888, 2.207291>,
      < -4.899255, -0.770051, 2.272216>
    }
    triangle {
      < -4.680388, -0.821680, 2.207291>,
      < -4.899255, -0.770051, 2.272216>,
      < -4.702516, -0.710389, 2.272216>
    }
    triangle {
      < -4.659415, -0.927164, 2.185108>,
      < -4.814693, -0.974252, 2.185108>,
      < -4.855841, -0.874888, 2.207291>
    }
    triangle {
      < -4.659415, -0.927164, 2.185108>,
      < -4.855841, -0.874888, 2.207291>,
      < -4.680388, -0.821680, 2.207291>
    }
    triangle {
      < -4.637606, -1.036851, 2.213441>,
      < -4.771904, -1.077578, 2.213441>,
      < -4.814693, -0.974252, 2.185108>
    }
    triangle {
      < -4.637606, -1.036851, 2.213441>,
      < -4.814693, -0.974252, 2.185108>,
      < -4.659415, -0.927164, 2.185108>
    }
    triangle {
      < -4.617540, -1.137773, 2.267810>,
      < -4.732534, -1.172645, 2.267810>,
      < -4.771904, -1.077578, 2.213441>
    }
    triangle {
      < -4.617540, -1.137773, 2.267810>,
      < -4.771904, -1.077578, 2.213441>,
      < -4.637606, -1.036851, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.732534, -1.172645, 2.267810>,
      < -4.617540, -1.137773, 2.267810>
    }
    triangle {
      < -4.732534, -1.172645, 2.704448>,
      < -4.838517, -1.229283, 2.704448>,
      < -4.817373, -1.260931, 2.704390>
    }
    triangle {
      < -4.732534, -1.172645, 2.704448>,
      < -4.817373, -1.260931, 2.704390>,
      < -4.717972, -1.207811, 2.704390>
    }
    triangle {
      < -4.771904, -1.077578, 2.758817>,
      < -4.895676, -1.143721, 2.758817>,
      < -4.838517, -1.229283, 2.704448>
    }
    triangle {
      < -4.771904, -1.077578, 2.758817>,
      < -4.838517, -1.229283, 2.704448>,
      < -4.732534, -1.172645, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.814693, -0.974252, 2.787150>,
      < -4.957800, -1.050729, 2.787150>,
      < -4.895676, -1.143721, 2.758817>
    }
    triangle {
      < -4.814693, -0.974252, 2.787150>,
      < -4.895676, -1.143721, 2.758817>,
      < -4.771904, -1.077578, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -4.855841, -0.874888, 2.764967>,
      < -5.017542, -0.961300, 2.764967>,
      < -4.957800, -1.050729, 2.787150>
    }
    triangle {
      < -4.855841, -0.874888, 2.764967>,
      < -4.957800, -1.050729, 2.787150>,
      < -4.814693, -0.974252, 2.787150>
    }
    triangle {
      < -4.899255, -0.770051, 2.700042>,
      < -5.080574, -0.866948, 2.700042>,
      < -5.017542, -0.961300, 2.764967>
    }
    triangle {
      < -4.899255, -0.770051, 2.700042>,
      < -5.017542, -0.961300, 2.764967>,
      < -4.855841, -0.874888, 2.764967>
    }
    triangle {
      < -4.908190, -0.748475, 2.486032>,
      < -5.093546, -0.847530, 2.486032>,
      < -5.080574, -0.866948, 2.700042>
    }
    triangle {
      < -4.908190, -0.748475, 2.486032>,
      < -5.080574, -0.866948, 2.700042>,
      < -4.899255, -0.770051, 2.700042>
    }
    triangle {
      < -4.899255, -0.770051, 2.272216>,
      < -5.080574, -0.866948, 2.272216>,
      < -5.093546, -0.847530, 2.486032>
    }
    triangle {
      < -4.899255, -0.770051, 2.272216>,
      < -5.093546, -0.847530, 2.486032>,
      < -4.908190, -0.748475, 2.486032>
    }
    triangle {
      < -4.855841, -0.874888, 2.207291>,
      < -5.017542, -0.961300, 2.207291>,
      < -5.080574, -0.866948, 2.272216>
    }
    triangle {
      < -4.855841, -0.874888, 2.207291>,
      < -5.080574, -0.866948, 2.272216>,
      < -4.899255, -0.770051, 2.272216>
    }
    triangle {
      < -4.814693, -0.974252, 2.185108>,
      < -4.957800, -1.050729, 2.185108>,
      < -5.017542, -0.961300, 2.207291>
    }
    triangle {
      < -4.814693, -0.974252, 2.185108>,
      < -5.017542, -0.961300, 2.207291>,
      < -4.855841, -0.874888, 2.207291>
    }
    triangle {
      < -4.771904, -1.077578, 2.213441>,
      < -4.895676, -1.143721, 2.213441>,
      < -4.957800, -1.050729, 2.185108>
    }
    triangle {
      < -4.771904, -1.077578, 2.213441>,
      < -4.957800, -1.050729, 2.185108>,
      < -4.814693, -0.974252, 2.185108>
    }
    triangle {
      < -4.732534, -1.172645, 2.267810>,
      < -4.838517, -1.229283, 2.267810>,
      < -4.895676, -1.143721, 2.213441>
    }
    triangle {
      < -4.732534, -1.172645, 2.267810>,
      < -4.895676, -1.143721, 2.213441>,
      < -4.771904, -1.077578, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.838517, -1.229283, 2.267810>,
      < -4.732534, -1.172645, 2.267810>
    }
    triangle {
      < -4.838517, -1.229283, 2.704448>,
      < -4.931413, -1.305506, 2.704448>,
      < -4.904502, -1.332422, 2.704390>
    }
    triangle {
      < -4.838517, -1.229283, 2.704448>,
      < -4.904502, -1.332422, 2.704390>,
      < -4.817373, -1.260931, 2.704390>
    }
    triangle {
      < -4.895676, -1.143721, 2.758817>,
      < -5.004166, -1.232740, 2.758817>,
      < -4.931413, -1.305506, 2.704448>
    }
    triangle {
      < -4.895676, -1.143721, 2.758817>,
      < -4.931413, -1.305506, 2.704448>,
      < -4.838517, -1.229283, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -4.957800, -1.050729, 2.787150>,
      < -5.083238, -1.153654, 2.787150>,
      < -5.004166, -1.232740, 2.758817>
    }
    triangle {
      < -4.957800, -1.050729, 2.787150>,
      < -5.004166, -1.232740, 2.758817>,
      < -4.895676, -1.143721, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.017542, -0.961300, 2.764967>,
      < -5.159279, -1.077599, 2.764967>,
      < -5.083238, -1.153654, 2.787150>
    }
    triangle {
      < -5.017542, -0.961300, 2.764967>,
      < -5.083238, -1.153654, 2.787150>,
      < -4.957800, -1.050729, 2.787150>
    }
    triangle {
      < -5.080574, -0.866948, 2.700042>,
      < -5.239507, -0.997356, 2.700042>,
      < -5.159279, -1.077599, 2.764967>
    }
    triangle {
      < -5.080574, -0.866948, 2.700042>,
      < -5.159279, -1.077599, 2.764967>,
      < -5.017542, -0.961300, 2.764967>
    }
    triangle {
      < -5.093546, -0.847530, 2.486032>,
      < -5.256018, -0.980842, 2.486032>,
      < -5.239507, -0.997356, 2.700042>
    }
    triangle {
      < -5.093546, -0.847530, 2.486032>,
      < -5.239507, -0.997356, 2.700042>,
      < -5.080574, -0.866948, 2.700042>
    }
    triangle {
      < -5.080574, -0.866948, 2.272216>,
      < -5.239507, -0.997356, 2.272216>,
      < -5.256018, -0.980842, 2.486032>
    }
    triangle {
      < -5.080574, -0.866948, 2.272216>,
      < -5.256018, -0.980842, 2.486032>,
      < -5.093546, -0.847530, 2.486032>
    }
    triangle {
      < -5.017542, -0.961300, 2.207291>,
      < -5.159279, -1.077599, 2.207291>,
      < -5.239507, -0.997356, 2.272216>
    }
    triangle {
      < -5.017542, -0.961300, 2.207291>,
      < -5.239507, -0.997356, 2.272216>,
      < -5.080574, -0.866948, 2.272216>
    }
    triangle {
      < -4.957800, -1.050729, 2.185108>,
      < -5.083238, -1.153654, 2.185108>,
      < -5.159279, -1.077599, 2.207291>
    }
    triangle {
      < -4.957800, -1.050729, 2.185108>,
      < -5.159279, -1.077599, 2.207291>,
      < -5.017542, -0.961300, 2.207291>
    }
    triangle {
      < -4.895676, -1.143721, 2.213441>,
      < -5.004166, -1.232740, 2.213441>,
      < -5.083238, -1.153654, 2.185108>
    }
    triangle {
      < -4.895676, -1.143721, 2.213441>,
      < -5.083238, -1.153654, 2.185108>,
      < -4.957800, -1.050729, 2.185108>
    }
    triangle {
      < -4.838517, -1.229283, 2.267810>,
      < -4.931413, -1.305506, 2.267810>,
      < -5.004166, -1.232740, 2.213441>
    }
    triangle {
      < -4.838517, -1.229283, 2.267810>,
      < -5.004166, -1.232740, 2.213441>,
      < -4.895676, -1.143721, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.931413, -1.305506, 2.267810>,
      < -4.838517, -1.229283, 2.267810>
    }
    triangle {
      < -4.931413, -1.305506, 2.704448>,
      < -5.007655, -1.398389, 2.704448>,
      < -4.976010, -1.419538, 2.704390>
    }
    triangle {
      < -4.931413, -1.305506, 2.704448>,
      < -4.976010, -1.419538, 2.704390>,
      < -4.904502, -1.332422, 2.704390>
    }
    triangle {
      < -5.004166, -1.232740, 2.758817>,
      < -5.093205, -1.341214, 2.758817>,
      < -5.007655, -1.398389, 2.704448>
    }
    triangle {
      < -5.004166, -1.232740, 2.758817>,
      < -5.007655, -1.398389, 2.704448>,
      < -4.931413, -1.305506, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.083238, -1.153654, 2.787150>,
      < -5.186187, -1.279073, 2.787150>,
      < -5.093205, -1.341214, 2.758817>
    }
    triangle {
      < -5.083238, -1.153654, 2.787150>,
      < -5.093205, -1.341214, 2.758817>,
      < -5.004166, -1.232740, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.159279, -1.077599, 2.764967>,
      < -5.275604, -1.219314, 2.764967>,
      < -5.186187, -1.279073, 2.787150>
    }
    triangle {
      < -5.159279, -1.077599, 2.764967>,
      < -5.186187, -1.279073, 2.787150>,
      < -5.083238, -1.153654, 2.787150>
    }
    triangle {
      < -5.239507, -0.997356, 2.700042>,
      < -5.369944, -1.156265, 2.700042>,
      < -5.275604, -1.219314, 2.764967>
    }
    triangle {
      < -5.239507, -0.997356, 2.700042>,
      < -5.275604, -1.219314, 2.764967>,
      < -5.159279, -1.077599, 2.764967>
    }
    triangle {
      < -5.256018, -0.980842, 2.486032>,
      < -5.389360, -1.143289, 2.486032>,
      < -5.369944, -1.156265, 2.700042>
    }
    triangle {
      < -5.256018, -0.980842, 2.486032>,
      < -5.369944, -1.156265, 2.700042>,
      < -5.239507, -0.997356, 2.700042>
    }
    triangle {
      < -5.239507, -0.997356, 2.272216>,
      < -5.369944, -1.156265, 2.272216>,
      < -5.389360, -1.143289, 2.486032>
    }
    triangle {
      < -5.239507, -0.997356, 2.272216>,
      < -5.389360, -1.143289, 2.486032>,
      < -5.256018, -0.980842, 2.486032>
    }
    triangle {
      < -5.159279, -1.077599, 2.207291>,
      < -5.275604, -1.219314, 2.207291>,
      < -5.369944, -1.156265, 2.272216>
    }
    triangle {
      < -5.159279, -1.077599, 2.207291>,
      < -5.369944, -1.156265, 2.272216>,
      < -5.239507, -0.997356, 2.272216>
    }
    triangle {
      < -5.083238, -1.153654, 2.185108>,
      < -5.186187, -1.279073, 2.185108>,
      < -5.275604, -1.219314, 2.207291>
    }
    triangle {
      < -5.083238, -1.153654, 2.185108>,
      < -5.275604, -1.219314, 2.207291>,
      < -5.159279, -1.077599, 2.207291>
    }
    triangle {
      < -5.004166, -1.232740, 2.213441>,
      < -5.093205, -1.341214, 2.213441>,
      < -5.186187, -1.279073, 2.185108>
    }
    triangle {
      < -5.004166, -1.232740, 2.213441>,
      < -5.186187, -1.279073, 2.185108>,
      < -5.083238, -1.153654, 2.185108>
    }
    triangle {
      < -4.931413, -1.305506, 2.267810>,
      < -5.007655, -1.398389, 2.267810>,
      < -5.093205, -1.341214, 2.213441>
    }
    triangle {
      < -4.931413, -1.305506, 2.267810>,
      < -5.093205, -1.341214, 2.213441>,
      < -5.004166, -1.232740, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -5.007655, -1.398389, 2.267810>,
      < -4.931413, -1.305506, 2.267810>
    }
    triangle {
      < -5.007655, -1.398389, 2.704448>,
      < -5.064312, -1.504360, 2.704448>,
      < -5.029148, -1.518929, 2.704390>
    }
    triangle {
      < -5.007655, -1.398389, 2.704448>,
      < -5.029148, -1.518929, 2.704390>,
      < -4.976010, -1.419538, 2.704390>
    }
    triangle {
      < -5.093205, -1.341214, 2.758817>,
      < -5.159372, -1.464975, 2.758817>,
      < -5.064312, -1.504360, 2.704448>
    }
    triangle {
      < -5.093205, -1.341214, 2.758817>,
      < -5.064312, -1.504360, 2.704448>,
      < -5.007655, -1.398389, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.186187, -1.279073, 2.787150>,
      < -5.262689, -1.422167, 2.787150>,
      < -5.159372, -1.464975, 2.758817>
    }
    triangle {
      < -5.186187, -1.279073, 2.787150>,
      < -5.159372, -1.464975, 2.758817>,
      < -5.093205, -1.341214, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.275604, -1.219314, 2.764967>,
      < -5.362047, -1.381000, 2.764967>,
      < -5.262689, -1.422167, 2.787150>
    }
    triangle {
      < -5.275604, -1.219314, 2.764967>,
      < -5.262689, -1.422167, 2.787150>,
      < -5.186187, -1.279073, 2.787150>
    }
    triangle {
      < -5.369944, -1.156265, 2.700042>,
      < -5.466875, -1.337567, 2.700042>,
      < -5.362047, -1.381000, 2.764967>
    }
    triangle {
      < -5.369944, -1.156265, 2.700042>,
      < -5.362047, -1.381000, 2.764967>,
      < -5.275604, -1.219314, 2.764967>
    }
    triangle {
      < -5.389360, -1.143289, 2.486032>,
      < -5.488449, -1.328627, 2.486032>,
      < -5.466875, -1.337567, 2.700042>
    }
    triangle {
      < -5.389360, -1.143289, 2.486032>,
      < -5.466875, -1.337567, 2.700042>,
      < -5.369944, -1.156265, 2.700042>
    }
    triangle {
      < -5.369944, -1.156265, 2.272216>,
      < -5.466875, -1.337567, 2.272216>,
      < -5.488449, -1.328627, 2.486032>
    }
    triangle {
      < -5.369944, -1.156265, 2.272216>,
      < -5.488449, -1.328627, 2.486032>,
      < -5.389360, -1.143289, 2.486032>
    }
    triangle {
      < -5.275604, -1.219314, 2.207291>,
      < -5.362047, -1.381000, 2.207291>,
      < -5.466875, -1.337567, 2.272216>
    }
    triangle {
      < -5.275604, -1.219314, 2.207291>,
      < -5.466875, -1.337567, 2.272216>,
      < -5.369944, -1.156265, 2.272216>
    }
    triangle {
      < -5.186187, -1.279073, 2.185108>,
      < -5.262689, -1.422167, 2.185108>,
      < -5.362047, -1.381000, 2.207291>
    }
    triangle {
      < -5.186187, -1.279073, 2.185108>,
      < -5.362047, -1.381000, 2.207291>,
      < -5.275604, -1.219314, 2.207291>
    }
    triangle {
      < -5.093205, -1.341214, 2.213441>,
      < -5.159372, -1.464975, 2.213441>,
      < -5.262689, -1.422167, 2.185108>
    }
    triangle {
      < -5.093205, -1.341214, 2.213441>,
      < -5.262689, -1.422167, 2.185108>,
      < -5.186187, -1.279073, 2.185108>
    }
    triangle {
      < -5.007655, -1.398389, 2.267810>,
      < -5.064312, -1.504360, 2.267810>,
      < -5.159372, -1.464975, 2.213441>
    }
    triangle {
      < -5.007655, -1.398389, 2.267810>,
      < -5.159372, -1.464975, 2.213441>,
      < -5.093205, -1.341214, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -5.064312, -1.504360, 2.267810>,
      < -5.007655, -1.398389, 2.267810>
    }
    triangle {
      < -5.064312, -1.504360, 2.704448>,
      < -5.099205, -1.619349, 2.704448>,
      < -5.061876, -1.626778, 2.704390>
    }
    triangle {
      < -5.064312, -1.504360, 2.704448>,
      < -5.061876, -1.626778, 2.704390>,
      < -5.029148, -1.518929, 2.704390>
    }
    triangle {
      < -5.159372, -1.464975, 2.758817>,
      < -5.200123, -1.599264, 2.758817>,
      < -5.099205, -1.619349, 2.704448>
    }
    triangle {
      < -5.159372, -1.464975, 2.758817>,
      < -5.099205, -1.619349, 2.704448>,
      < -5.064312, -1.504360, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.262689, -1.422167, 2.787150>,
      < -5.309807, -1.577435, 2.787150>,
      < -5.200123, -1.599264, 2.758817>
    }
    triangle {
      < -5.262689, -1.422167, 2.787150>,
      < -5.200123, -1.599264, 2.758817>,
      < -5.159372, -1.464975, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.362047, -1.381000, 2.764967>,
      < -5.415286, -1.556443, 2.764967>,
      < -5.309807, -1.577435, 2.787150>
    }
    triangle {
      < -5.362047, -1.381000, 2.764967>,
      < -5.309807, -1.577435, 2.787150>,
      < -5.262689, -1.422167, 2.787150>
    }
    triangle {
      < -5.466875, -1.337567, 2.700042>,
      < -5.526573, -1.534295, 2.700042>,
      < -5.415286, -1.556443, 2.764967>
    }
    triangle {
      < -5.466875, -1.337567, 2.700042>,
      < -5.415286, -1.556443, 2.764967>,
      < -5.362047, -1.381000, 2.764967>
    }
    triangle {
      < -5.488449, -1.328627, 2.486032>,
      < -5.549476, -1.529736, 2.486032>,
      < -5.526573, -1.534295, 2.700042>
    }
    triangle {
      < -5.488449, -1.328627, 2.486032>,
      < -5.526573, -1.534295, 2.700042>,
      < -5.466875, -1.337567, 2.700042>
    }
    triangle {
      < -5.466875, -1.337567, 2.272216>,
      < -5.526573, -1.534295, 2.272216>,
      < -5.549476, -1.529736, 2.486032>
    }
    triangle {
      < -5.466875, -1.337567, 2.272216>,
      < -5.549476, -1.529736, 2.486032>,
      < -5.488449, -1.328627, 2.486032>
    }
    triangle {
      < -5.362047, -1.381000, 2.207291>,
      < -5.415286, -1.556443, 2.207291>,
      < -5.526573, -1.534295, 2.272216>
    }
    triangle {
      < -5.362047, -1.381000, 2.207291>,
      < -5.526573, -1.534295, 2.272216>,
      < -5.466875, -1.337567, 2.272216>
    }
    triangle {
      < -5.262689, -1.422167, 2.185108>,
      < -5.309807, -1.577435, 2.185108>,
      < -5.415286, -1.556443, 2.207291>
    }
    triangle {
      < -5.262689, -1.422167, 2.185108>,
      < -5.415286, -1.556443, 2.207291>,
      < -5.362047, -1.381000, 2.207291>
    }
    triangle {
      < -5.159372, -1.464975, 2.213441>,
      < -5.200123, -1.599264, 2.213441>,
      < -5.309807, -1.577435, 2.185108>
    }
    triangle {
      < -5.159372, -1.464975, 2.213441>,
      < -5.309807, -1.577435, 2.185108>,
      < -5.262689, -1.422167, 2.185108>
    }
    triangle {
      < -5.064312, -1.504360, 2.267810>,
      < -5.099205, -1.619349, 2.267810>,
      < -5.200123, -1.599264, 2.213441>
    }
    triangle {
      < -5.064312, -1.504360, 2.267810>,
      < -5.200123, -1.599264, 2.213441>,
      < -5.159372, -1.464975, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -5.099205, -1.619349, 2.267810>,
      < -5.064312, -1.504360, 2.267810>
    }
    triangle {
      < -5.099205, -1.619349, 2.704448>,
      < -5.110997, -1.738935, 2.704448>,
      < -5.072934, -1.738939, 2.704390>
    }
    triangle {
      < -5.099205, -1.619349, 2.704448>,
      < -5.072934, -1.738939, 2.704390>,
      < -5.061876, -1.626778, 2.704390>
    }
    triangle {
      < -5.200123, -1.599264, 2.758817>,
      < -5.213893, -1.738925, 2.758817>,
      < -5.110997, -1.738935, 2.704448>
    }
    triangle {
      < -5.200123, -1.599264, 2.758817>,
      < -5.110997, -1.738935, 2.704448>,
      < -5.099205, -1.619349, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.309807, -1.577435, 2.787150>,
      < -5.325728, -1.738913, 2.787150>,
      < -5.213893, -1.738925, 2.758817>
    }
    triangle {
      < -5.309807, -1.577435, 2.787150>,
      < -5.213893, -1.738925, 2.758817>,
      < -5.200123, -1.599264, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.415286, -1.556443, 2.764967>,
      < -5.433276, -1.738901, 2.764967>,
      < -5.325728, -1.738913, 2.787150>
    }
    triangle {
      < -5.415286, -1.556443, 2.764967>,
      < -5.325728, -1.738913, 2.787150>,
      < -5.309807, -1.577435, 2.787150>
    }
    triangle {
      < -5.526573, -1.534295, 2.700042>,
      < -5.546746, -1.738889, 2.700042>,
      < -5.433276, -1.738901, 2.764967>
    }
    triangle {
      < -5.526573, -1.534295, 2.700042>,
      < -5.433276, -1.738901, 2.764967>,
      < -5.415286, -1.556443, 2.764967>
    }
    triangle {
      < -5.549476, -1.529736, 2.486032>,
      < -5.570098, -1.738887, 2.486032>,
      < -5.546746, -1.738889, 2.700042>
    }
    triangle {
      < -5.549476, -1.529736, 2.486032>,
      < -5.546746, -1.738889, 2.700042>,
      < -5.526573, -1.534295, 2.700042>
    }
    triangle {
      < -5.526573, -1.534295, 2.272216>,
      < -5.546746, -1.738889, 2.272216>,
      < -5.570098, -1.738887, 2.486032>
    }
    triangle {
      < -5.526573, -1.534295, 2.272216>,
      < -5.570098, -1.738887, 2.486032>,
      < -5.549476, -1.529736, 2.486032>
    }
    triangle {
      < -5.415286, -1.556443, 2.207291>,
      < -5.433276, -1.738901, 2.207291>,
      < -5.546746, -1.738889, 2.272216>
    }
    triangle {
      < -5.415286, -1.556443, 2.207291>,
      < -5.546746, -1.738889, 2.272216>,
      < -5.526573, -1.534295, 2.272216>
    }
    triangle {
      < -5.309807, -1.577435, 2.185108>,
      < -5.325728, -1.738913, 2.185108>,
      < -5.433276, -1.738901, 2.207291>
    }
    triangle {
      < -5.309807, -1.577435, 2.185108>,
      < -5.433276, -1.738901, 2.207291>,
      < -5.415286, -1.556443, 2.207291>
    }
    triangle {
      < -5.200123, -1.599264, 2.213441>,
      < -5.213893, -1.738925, 2.213441>,
      < -5.325728, -1.738913, 2.185108>
    }
    triangle {
      < -5.200123, -1.599264, 2.213441>,
      < -5.325728, -1.738913, 2.185108>,
      < -5.309807, -1.577435, 2.185108>
    }
    triangle {
      < -5.099205, -1.619349, 2.267810>,
      < -5.110997, -1.738935, 2.267810>,
      < -5.213893, -1.738925, 2.213441>
    }
    triangle {
      < -5.099205, -1.619349, 2.267810>,
      < -5.213893, -1.738925, 2.213441>,
      < -5.200123, -1.599264, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -5.110997, -1.738935, 2.267810>,
      < -5.099205, -1.619349, 2.267810>
    }
    triangle {
      < -5.110997, -1.738935, 2.704448>,
      < -5.099230, -1.858524, 2.704448>,
      < -5.061899, -1.851103, 2.704390>
    }
    triangle {
      < -5.110997, -1.738935, 2.704448>,
      < -5.061899, -1.851103, 2.704390>,
      < -5.072934, -1.738939, 2.704390>
    }
    triangle {
      < -5.213893, -1.738925, 2.758817>,
      < -5.200152, -1.878587, 2.758817>,
      < -5.099230, -1.858524, 2.704448>
    }
    triangle {
      < -5.213893, -1.738925, 2.758817>,
      < -5.099230, -1.858524, 2.704448>,
      < -5.110997, -1.738935, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.325728, -1.738913, 2.787150>,
      < -5.309841, -1.900394, 2.787150>,
      < -5.200152, -1.878587, 2.758817>
    }
    triangle {
      < -5.325728, -1.738913, 2.787150>,
      < -5.200152, -1.878587, 2.758817>,
      < -5.213893, -1.738925, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.433276, -1.738901, 2.764967>,
      < -5.415325, -1.921364, 2.764967>,
      < -5.309841, -1.900394, 2.787150>
    }
    triangle {
      < -5.433276, -1.738901, 2.764967>,
      < -5.309841, -1.900394, 2.787150>,
      < -5.325728, -1.738913, 2.787150>
    }
    triangle {
      < -5.546746, -1.738889, 2.700042>,
      < -5.526617, -1.943489, 2.700042>,
      < -5.415325, -1.921364, 2.764967>
    }
    triangle {
      < -5.546746, -1.738889, 2.700042>,
      < -5.415325, -1.921364, 2.764967>,
      < -5.433276, -1.738901, 2.764967>
    }
    triangle {
      < -5.570098, -1.738887, 2.486032>,
      < -5.549521, -1.948042, 2.486032>,
      < -5.526617, -1.943489, 2.700042>
    }
    triangle {
      < -5.570098, -1.738887, 2.486032>,
      < -5.526617, -1.943489, 2.700042>,
      < -5.546746, -1.738889, 2.700042>
    }
    triangle {
      < -5.546746, -1.738889, 2.272216>,
      < -5.526617, -1.943489, 2.272216>,
      < -5.549521, -1.948042, 2.486032>
    }
    triangle {
      < -5.546746, -1.738889, 2.272216>,
      < -5.549521, -1.948042, 2.486032>,
      < -5.570098, -1.738887, 2.486032>
    }
    triangle {
      < -5.433276, -1.738901, 2.207291>,
      < -5.415325, -1.921364, 2.207291>,
      < -5.526617, -1.943489, 2.272216>
    }
    triangle {
      < -5.433276, -1.738901, 2.207291>,
      < -5.526617, -1.943489, 2.272216>,
      < -5.546746, -1.738889, 2.272216>
    }
    triangle {
      < -5.325728, -1.738913, 2.185108>,
      < -5.309841, -1.900394, 2.185108>,
      < -5.415325, -1.921364, 2.207291>
    }
    triangle {
      < -5.325728, -1.738913, 2.185108>,
      < -5.415325, -1.921364, 2.207291>,
      < -5.433276, -1.738901, 2.207291>
    }
    triangle {
      < -5.213893, -1.738925, 2.213441>,
      < -5.200152, -1.878587, 2.213441>,
      < -5.309841, -1.900394, 2.185108>
    }
    triangle {
      < -5.213893, -1.738925, 2.213441>,
      < -5.309841, -1.900394, 2.185108>,
      < -5.325728, -1.738913, 2.185108>
    }
    triangle {
      < -5.110997, -1.738935, 2.267810>,
      < -5.099230, -1.858524, 2.267810>,
      < -5.200152, -1.878587, 2.213441>
    }
    triangle {
      < -5.110997, -1.738935, 2.267810>,
      < -5.200152, -1.878587, 2.213441>,
      < -5.213893, -1.738925, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -5.099230, -1.858524, 2.267810>,
      < -5.110997, -1.738935, 2.267810>
    }
    triangle {
      < -5.099230, -1.858524, 2.704448>,
      < -5.064360, -1.973520, 2.704448>,
      < -5.029194, -1.958958, 2.704390>
    }
    triangle {
      < -5.099230, -1.858524, 2.704448>,
      < -5.029194, -1.958958, 2.704390>,
      < -5.061899, -1.851103, 2.704390>
    }
    triangle {
      < -5.200152, -1.878587, 2.758817>,
      < -5.159430, -2.012886, 2.758817>,
      < -5.064360, -1.973520, 2.704448>
    }
    triangle {
      < -5.200152, -1.878587, 2.758817>,
      < -5.064360, -1.973520, 2.704448>,
      < -5.099230, -1.858524, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.309841, -1.900394, 2.787150>,
      < -5.262756, -2.055673, 2.787150>,
      < -5.159430, -2.012886, 2.758817>
    }
    triangle {
      < -5.309841, -1.900394, 2.787150>,
      < -5.159430, -2.012886, 2.758817>,
      < -5.200152, -1.878587, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.415325, -1.921364, 2.764967>,
      < -5.362122, -2.096818, 2.764967>,
      < -5.262756, -2.055673, 2.787150>
    }
    triangle {
      < -5.415325, -1.921364, 2.764967>,
      < -5.262756, -2.055673, 2.787150>,
      < -5.309841, -1.900394, 2.787150>
    }
    triangle {
      < -5.526617, -1.943489, 2.700042>,
      < -5.466959, -2.140229, 2.700042>,
      < -5.362122, -2.096818, 2.764967>
    }
    triangle {
      < -5.526617, -1.943489, 2.700042>,
      < -5.362122, -2.096818, 2.764967>,
      < -5.415325, -1.921364, 2.764967>
    }
    triangle {
      < -5.549521, -1.948042, 2.486032>,
      < -5.488535, -2.149163, 2.486032>,
      < -5.466959, -2.140229, 2.700042>
    }
    triangle {
      < -5.549521, -1.948042, 2.486032>,
      < -5.466959, -2.140229, 2.700042>,
      < -5.526617, -1.943489, 2.700042>
    }
    triangle {
      < -5.526617, -1.943489, 2.272216>,
      < -5.466959, -2.140229, 2.272216>,
      < -5.488535, -2.149163, 2.486032>
    }
    triangle {
      < -5.526617, -1.943489, 2.272216>,
      < -5.488535, -2.149163, 2.486032>,
      < -5.549521, -1.948042, 2.486032>
    }
    triangle {
      < -5.415325, -1.921364, 2.207291>,
      < -5.362122, -2.096818, 2.207291>,
      < -5.466959, -2.140229, 2.272216>
    }
    triangle {
      < -5.415325, -1.921364, 2.207291>,
      < -5.466959, -2.140229, 2.272216>,
      < -5.526617, -1.943489, 2.272216>
    }
    triangle {
      < -5.309841, -1.900394, 2.185108>,
      < -5.262756, -2.055673, 2.185108>,
      < -5.362122, -2.096818, 2.207291>
    }
    triangle {
      < -5.309841, -1.900394, 2.185108>,
      < -5.362122, -2.096818, 2.207291>,
      < -5.415325, -1.921364, 2.207291>
    }
    triangle {
      < -5.200152, -1.878587, 2.213441>,
      < -5.159430, -2.012886, 2.213441>,
      < -5.262756, -2.055673, 2.185108>
    }
    triangle {
      < -5.200152, -1.878587, 2.213441>,
      < -5.262756, -2.055673, 2.185108>,
      < -5.309841, -1.900394, 2.185108>
    }
    triangle {
      < -5.099230, -1.858524, 2.267810>,
      < -5.064360, -1.973520, 2.267810>,
      < -5.159430, -2.012886, 2.213441>
    }
    triangle {
      < -5.099230, -1.858524, 2.267810>,
      < -5.159430, -2.012886, 2.213441>,
      < -5.200152, -1.878587, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -5.064360, -1.973520, 2.267810>,
      < -5.099230, -1.858524, 2.267810>
    }
    triangle {
      < -5.064360, -1.973520, 2.704448>,
      < -5.007727, -2.079503, 2.704448>,
      < -4.976077, -2.058361, 2.704390>
    }
    triangle {
      < -5.064360, -1.973520, 2.704448>,
      < -4.976077, -2.058361, 2.704390>,
      < -5.029194, -1.958958, 2.704390>
    }
    triangle {
      < -5.159430, -2.012886, 2.758817>,
      < -5.093289, -2.136661, 2.758817>,
      < -5.007727, -2.079503, 2.704448>
    }
    triangle {
      < -5.159430, -2.012886, 2.758817>,
      < -5.007727, -2.079503, 2.704448>,
      < -5.064360, -1.973520, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.262756, -2.055673, 2.787150>,
      < -5.186283, -2.198782, 2.787150>,
      < -5.093289, -2.136661, 2.758817>
    }
    triangle {
      < -5.262756, -2.055673, 2.787150>,
      < -5.093289, -2.136661, 2.758817>,
      < -5.159430, -2.012886, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.362122, -2.096818, 2.764967>,
      < -5.275713, -2.258522, 2.764967>,
      < -5.186283, -2.198782, 2.787150>
    }
    triangle {
      < -5.362122, -2.096818, 2.764967>,
      < -5.186283, -2.198782, 2.787150>,
      < -5.262756, -2.055673, 2.787150>
    }
    triangle {
      < -5.466959, -2.140229, 2.700042>,
      < -5.370068, -2.321552, 2.700042>,
      < -5.275713, -2.258522, 2.764967>
    }
    triangle {
      < -5.466959, -2.140229, 2.700042>,
      < -5.275713, -2.258522, 2.764967>,
      < -5.362122, -2.096818, 2.764967>
    }
    triangle {
      < -5.488535, -2.149163, 2.486032>,
      < -5.389486, -2.334523, 2.486032>,
      < -5.370068, -2.321552, 2.700042>
    }
    triangle {
      < -5.488535, -2.149163, 2.486032>,
      < -5.370068, -2.321552, 2.700042>,
      < -5.466959, -2.140229, 2.700042>
    }
    triangle {
      < -5.466959, -2.140229, 2.272216>,
      < -5.370068, -2.321552, 2.272216>,
      < -5.389486, -2.334523, 2.486032>
    }
    triangle {
      < -5.466959, -2.140229, 2.272216>,
      < -5.389486, -2.334523, 2.486032>,
      < -5.488535, -2.149163, 2.486032>
    }
    triangle {
      < -5.362122, -2.096818, 2.207291>,
      < -5.275713, -2.258522, 2.207291>,
      < -5.370068, -2.321552, 2.272216>
    }
    triangle {
      < -5.362122, -2.096818, 2.207291>,
      < -5.370068, -2.321552, 2.272216>,
      < -5.466959, -2.140229, 2.272216>
    }
    triangle {
      < -5.262756, -2.055673, 2.185108>,
      < -5.186283, -2.198782, 2.185108>,
      < -5.275713, -2.258522, 2.207291>
    }
    triangle {
      < -5.262756, -2.055673, 2.185108>,
      < -5.275713, -2.258522, 2.207291>,
      < -5.362122, -2.096818, 2.207291>
    }
    triangle {
      < -5.159430, -2.012886, 2.213441>,
      < -5.093289, -2.136661, 2.213441>,
      < -5.186283, -2.198782, 2.185108>
    }
    triangle {
      < -5.159430, -2.012886, 2.213441>,
      < -5.186283, -2.198782, 2.185108>,
      < -5.262756, -2.055673, 2.185108>
    }
    triangle {
      < -5.064360, -1.973520, 2.267810>,
      < -5.007727, -2.079503, 2.267810>,
      < -5.093289, -2.136661, 2.213441>
    }
    triangle {
      < -5.064360, -1.973520, 2.267810>,
      < -5.093289, -2.136661, 2.213441>,
      < -5.159430, -2.012886, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -5.007727, -2.079503, 2.267810>,
      < -5.064360, -1.973520, 2.267810>
    }
    triangle {
      < -5.007727, -2.079503, 2.704448>,
      < -4.931459, -2.172448, 2.704448>,
      < -4.904545, -2.145534, 2.704390>
    }
    triangle {
      < -5.007727, -2.079503, 2.704448>,
      < -4.904545, -2.145534, 2.704390>,
      < -4.976077, -2.058361, 2.704390>
    }
    triangle {
      < -5.093289, -2.136661, 2.758817>,
      < -5.004219, -2.245206, 2.758817>,
      < -4.931459, -2.172448, 2.704448>
    }
    triangle {
      < -5.093289, -2.136661, 2.758817>,
      < -4.931459, -2.172448, 2.704448>,
      < -5.007727, -2.079503, 2.704448>
    }
    texture {lftire}
  }
  // lfwhitew
  union {
    triangle {
      < -5.186283, -2.198782, 2.787150>,
      < -5.083300, -2.324284, 2.787150>,
      < -5.004219, -2.245206, 2.758817>
    }
    triangle {
      < -5.186283, -2.198782, 2.787150>,
      < -5.004219, -2.245206, 2.758817>,
      < -5.093289, -2.136661, 2.758817>
    }
    texture {lfwhitew}
  }
  // lftire
  union {
    triangle {
      < -5.275713, -2.258522, 2.764967>,
      < -5.159349, -2.400331, 2.764967>,
      < -5.083300, -2.324284, 2.787150>
    }
    triangle {
      < -5.275713, -2.258522, 2.764967>,
      < -5.083300, -2.324284, 2.787150>,
      < -5.186283, -2.198782, 2.787150>
    }
    triangle {
      < -5.370068, -2.321552, 2.700042>,
      < -5.239585, -2.480566, 2.700042>,
      < -5.159349, -2.400331, 2.764967>
    }
    triangle {
      < -5.370068, -2.321552, 2.700042>,
      < -5.159349, -2.400331, 2.764967>,
      < -5.275713, -2.258522, 2.764967>
    }
    triangle {
      < -5.389486, -2.334523, 2.486032>,
      < -5.256098, -2.497078, 2.486032>,
      < -5.239585, -2.480566, 2.700042>
    }
    triangle {
      < -5.389486, -2.334523, 2.486032>,
      < -5.239585, -2.480566, 2.700042>,
      < -5.370068, -2.321552, 2.700042>
    }
    triangle {
      < -5.370068, -2.321552, 2.272216>,
      < -5.239585, -2.480566, 2.272216>,
      < -5.256098, -2.497078, 2.486032>
    }
    triangle {
      < -5.370068, -2.321552, 2.272216>,
      < -5.256098, -2.497078, 2.486032>,
      < -5.389486, -2.334523, 2.486032>
    }
    triangle {
      < -5.275713, -2.258522, 2.207291>,
      < -5.159349, -2.400331, 2.207291>,
      < -5.239585, -2.480566, 2.272216>
    }
    triangle {
      < -5.275713, -2.258522, 2.207291>,
      < -5.239585, -2.480566, 2.272216>,
      < -5.370068, -2.321552, 2.272216>
    }
    triangle {
      < -5.186283, -2.198782, 2.185108>,
      < -5.083300, -2.324284, 2.185108>,
      < -5.159349, -2.400331, 2.207291>
    }
    triangle {
      < -5.186283, -2.198782, 2.185108>,
      < -5.159349, -2.400331, 2.207291>,
      < -5.275713, -2.258522, 2.207291>
    }
    triangle {
      < -5.093289, -2.136661, 2.213441>,
      < -5.004219, -2.245206, 2.213441>,
      < -5.083300, -2.324284, 2.185108>
    }
    triangle {
      < -5.093289, -2.136661, 2.213441>,
      < -5.083300, -2.324284, 2.185108>,
      < -5.186283, -2.198782, 2.185108>
    }
    triangle {
      < -5.007727, -2.079503, 2.267810>,
      < -4.931459, -2.172448, 2.267810>,
      < -5.004219, -2.245206, 2.213441>
    }
    triangle {
      < -5.007727, -2.079503, 2.267810>,
      < -5.004219, -2.245206, 2.213441>,
      < -5.093289, -2.136661, 2.213441>
    }
    triangle {
      < -4.498117, -1.739117, 2.267490>,
      < -4.931459, -2.172448, 2.267810>,
      < -5.007727, -2.079503, 2.267810>
    }
    texture {lftire}
  }
  // btires
  union {
    triangle {
      < 4.615216, -2.172448, 2.704448>,
      < 4.708104, -2.248682, 2.704448>,
      < 4.729250, -2.217035, 2.704390>
    }
    triangle {
      < 4.615216, -2.172448, 2.704448>,
      < 4.729250, -2.217035, 2.704390>,
      < 4.642129, -2.145534, 2.704390>
    }
    triangle {
      < 4.542456, -2.245206, 2.758817>,
      < 4.650936, -2.334237, 2.758817>,
      < 4.708104, -2.248682, 2.704448>
    }
    triangle {
      < 4.542456, -2.245206, 2.758817>,
      < 4.708104, -2.248682, 2.704448>,
      < 4.615216, -2.172448, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.463375, -2.324284, 2.787150>,
      < 4.588802, -2.427223, 2.787150>,
      < 4.650936, -2.334237, 2.758817>
    }
    triangle {
      < 4.463375, -2.324284, 2.787150>,
      < 4.650936, -2.334237, 2.758817>,
      < 4.542456, -2.245206, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.387326, -2.400331, 2.764967>,
      < 4.529051, -2.516644, 2.764967>,
      < 4.588802, -2.427223, 2.787150>
    }
    triangle {
      < 4.387326, -2.400331, 2.764967>,
      < 4.588802, -2.427223, 2.787150>,
      < 4.463375, -2.324284, 2.787150>
    }
    triangle {
      < 4.307090, -2.480566, 2.700042>,
      < 4.466009, -2.610991, 2.700042>,
      < 4.529051, -2.516644, 2.764967>
    }
    triangle {
      < 4.307090, -2.480566, 2.700042>,
      < 4.529051, -2.516644, 2.764967>,
      < 4.387326, -2.400331, 2.764967>
    }
    triangle {
      < 4.290576, -2.497078, 2.486032>,
      < 4.453033, -2.630407, 2.486032>,
      < 4.466009, -2.610991, 2.700042>
    }
    triangle {
      < 4.290576, -2.497078, 2.486032>,
      < 4.466009, -2.610991, 2.700042>,
      < 4.307090, -2.480566, 2.700042>
    }
    triangle {
      < 4.307090, -2.480566, 2.272216>,
      < 4.466009, -2.610991, 2.272216>,
      < 4.453033, -2.630407, 2.486032>
    }
    triangle {
      < 4.307090, -2.480566, 2.272216>,
      < 4.453033, -2.630407, 2.486032>,
      < 4.290576, -2.497078, 2.486032>
    }
    triangle {
      < 4.387326, -2.400331, 2.207291>,
      < 4.529051, -2.516644, 2.207291>,
      < 4.466009, -2.610991, 2.272216>
    }
    triangle {
      < 4.387326, -2.400331, 2.207291>,
      < 4.466009, -2.610991, 2.272216>,
      < 4.307090, -2.480566, 2.272216>
    }
    triangle {
      < 4.463375, -2.324284, 2.185108>,
      < 4.588802, -2.427223, 2.185108>,
      < 4.529051, -2.516644, 2.207291>
    }
    triangle {
      < 4.463375, -2.324284, 2.185108>,
      < 4.529051, -2.516644, 2.207291>,
      < 4.387326, -2.400331, 2.207291>
    }
    triangle {
      < 4.542456, -2.245206, 2.213441>,
      < 4.650936, -2.334237, 2.213441>,
      < 4.588802, -2.427223, 2.185108>
    }
    triangle {
      < 4.542456, -2.245206, 2.213441>,
      < 4.588802, -2.427223, 2.185108>,
      < 4.463375, -2.324284, 2.185108>
    }
    triangle {
      < 4.615216, -2.172448, 2.267810>,
      < 4.708104, -2.248682, 2.267810>,
      < 4.650936, -2.334237, 2.213441>
    }
    triangle {
      < 4.615216, -2.172448, 2.267810>,
      < 4.650936, -2.334237, 2.213441>,
      < 4.542456, -2.245206, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.708104, -2.248682, 2.267810>,
      < 4.615216, -2.172448, 2.267810>
    }
    triangle {
      < 4.708104, -2.248682, 2.704448>,
      < 4.814081, -2.305330, 2.704448>,
      < 4.828647, -2.270165, 2.704390>
    }
    triangle {
      < 4.708104, -2.248682, 2.704448>,
      < 4.828647, -2.270165, 2.704390>,
      < 4.729250, -2.217035, 2.704390>
    }
    triangle {
      < 4.650936, -2.334237, 2.758817>,
      < 4.774701, -2.400394, 2.758817>,
      < 4.814081, -2.305330, 2.704448>
    }
    triangle {
      < 4.650936, -2.334237, 2.758817>,
      < 4.814081, -2.305330, 2.704448>,
      < 4.708104, -2.248682, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.588802, -2.427223, 2.787150>,
      < 4.731902, -2.503715, 2.787150>,
      < 4.774701, -2.400394, 2.758817>
    }
    triangle {
      < 4.588802, -2.427223, 2.787150>,
      < 4.774701, -2.400394, 2.758817>,
      < 4.650936, -2.334237, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.529051, -2.516644, 2.764967>,
      < 4.690742, -2.603076, 2.764967>,
      < 4.731902, -2.503715, 2.787150>
    }
    triangle {
      < 4.529051, -2.516644, 2.764967>,
      < 4.731902, -2.503715, 2.787150>,
      < 4.588802, -2.427223, 2.787150>
    }
    triangle {
      < 4.466009, -2.610991, 2.700042>,
      < 4.647317, -2.707907, 2.700042>,
      < 4.690742, -2.603076, 2.764967>
    }
    triangle {
      < 4.466009, -2.610991, 2.700042>,
      < 4.690742, -2.603076, 2.764967>,
      < 4.529051, -2.516644, 2.764967>
    }
    triangle {
      < 4.453033, -2.630407, 2.486032>,
      < 4.638381, -2.729481, 2.486032>,
      < 4.647317, -2.707907, 2.700042>
    }
    triangle {
      < 4.453033, -2.630407, 2.486032>,
      < 4.647317, -2.707907, 2.700042>,
      < 4.466009, -2.610991, 2.700042>
    }
    triangle {
      < 4.466009, -2.610991, 2.272216>,
      < 4.647317, -2.707907, 2.272216>,
      < 4.638381, -2.729481, 2.486032>
    }
    triangle {
      < 4.466009, -2.610991, 2.272216>,
      < 4.638381, -2.729481, 2.486032>,
      < 4.453033, -2.630407, 2.486032>
    }
    triangle {
      < 4.529051, -2.516644, 2.207291>,
      < 4.690742, -2.603076, 2.207291>,
      < 4.647317, -2.707907, 2.272216>
    }
    triangle {
      < 4.529051, -2.516644, 2.207291>,
      < 4.647317, -2.707907, 2.272216>,
      < 4.466009, -2.610991, 2.272216>
    }
    triangle {
      < 4.588802, -2.427223, 2.185108>,
      < 4.731902, -2.503715, 2.185108>,
      < 4.690742, -2.603076, 2.207291>
    }
    triangle {
      < 4.588802, -2.427223, 2.185108>,
      < 4.690742, -2.603076, 2.207291>,
      < 4.529051, -2.516644, 2.207291>
    }
    triangle {
      < 4.650936, -2.334237, 2.213441>,
      < 4.774701, -2.400394, 2.213441>,
      < 4.731902, -2.503715, 2.185108>
    }
    triangle {
      < 4.650936, -2.334237, 2.213441>,
      < 4.731902, -2.503715, 2.185108>,
      < 4.588802, -2.427223, 2.185108>
    }
    triangle {
      < 4.708104, -2.248682, 2.267810>,
      < 4.814081, -2.305330, 2.267810>,
      < 4.774701, -2.400394, 2.213441>
    }
    triangle {
      < 4.708104, -2.248682, 2.267810>,
      < 4.774701, -2.400394, 2.213441>,
      < 4.650936, -2.334237, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.814081, -2.305330, 2.267810>,
      < 4.708104, -2.248682, 2.267810>
    }
    triangle {
      < 4.814081, -2.305330, 2.704448>,
      < 4.929070, -2.340215, 2.704448>,
      < 4.936498, -2.302884, 2.704390>
    }
    triangle {
      < 4.814081, -2.305330, 2.704448>,
      < 4.936498, -2.302884, 2.704390>,
      < 4.828647, -2.270165, 2.704390>
    }
    triangle {
      < 4.774701, -2.400394, 2.758817>,
      < 4.908995, -2.441134, 2.758817>,
      < 4.929070, -2.340215, 2.704448>
    }
    triangle {
      < 4.774701, -2.400394, 2.758817>,
      < 4.929070, -2.340215, 2.704448>,
      < 4.814081, -2.305330, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.731902, -2.503715, 2.787150>,
      < 4.887175, -2.550819, 2.787150>,
      < 4.908995, -2.441134, 2.758817>
    }
    triangle {
      < 4.731902, -2.503715, 2.787150>,
      < 4.908995, -2.441134, 2.758817>,
      < 4.774701, -2.400394, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.690742, -2.603076, 2.764967>,
      < 4.866190, -2.656301, 2.764967>,
      < 4.887175, -2.550819, 2.787150>
    }
    triangle {
      < 4.690742, -2.603076, 2.764967>,
      < 4.887175, -2.550819, 2.787150>,
      < 4.731902, -2.503715, 2.787150>
    }
    triangle {
      < 4.647317, -2.707907, 2.700042>,
      < 4.844050, -2.767589, 2.700042>,
      < 4.866190, -2.656301, 2.764967>
    }
    triangle {
      < 4.647317, -2.707907, 2.700042>,
      < 4.866190, -2.656301, 2.764967>,
      < 4.690742, -2.603076, 2.764967>
    }
    triangle {
      < 4.638381, -2.729481, 2.486032>,
      < 4.839495, -2.790493, 2.486032>,
      < 4.844050, -2.767589, 2.700042>
    }
    triangle {
      < 4.638381, -2.729481, 2.486032>,
      < 4.844050, -2.767589, 2.700042>,
      < 4.647317, -2.707907, 2.700042>
    }
    triangle {
      < 4.647317, -2.707907, 2.272216>,
      < 4.844050, -2.767589, 2.272216>,
      < 4.839495, -2.790493, 2.486032>
    }
    triangle {
      < 4.647317, -2.707907, 2.272216>,
      < 4.839495, -2.790493, 2.486032>,
      < 4.638381, -2.729481, 2.486032>
    }
    triangle {
      < 4.690742, -2.603076, 2.207291>,
      < 4.866190, -2.656301, 2.207291>,
      < 4.844050, -2.767589, 2.272216>
    }
    triangle {
      < 4.690742, -2.603076, 2.207291>,
      < 4.844050, -2.767589, 2.272216>,
      < 4.647317, -2.707907, 2.272216>
    }
    triangle {
      < 4.731902, -2.503715, 2.185108>,
      < 4.887175, -2.550819, 2.185108>,
      < 4.866190, -2.656301, 2.207291>
    }
    triangle {
      < 4.731902, -2.503715, 2.185108>,
      < 4.866190, -2.656301, 2.207291>,
      < 4.690742, -2.603076, 2.207291>
    }
    triangle {
      < 4.774701, -2.400394, 2.213441>,
      < 4.908995, -2.441134, 2.213441>,
      < 4.887175, -2.550819, 2.185108>
    }
    triangle {
      < 4.774701, -2.400394, 2.213441>,
      < 4.887175, -2.550819, 2.185108>,
      < 4.731902, -2.503715, 2.185108>
    }
    triangle {
      < 4.814081, -2.305330, 2.267810>,
      < 4.929070, -2.340215, 2.267810>,
      < 4.908995, -2.441134, 2.213441>
    }
    triangle {
      < 4.814081, -2.305330, 2.267810>,
      < 4.908995, -2.441134, 2.213441>,
      < 4.774701, -2.400394, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.929070, -2.340215, 2.267810>,
      < 4.814081, -2.305330, 2.267810>
    }
    triangle {
      < 4.929070, -2.340215, 2.704448>,
      < 5.048658, -2.351996, 2.704448>,
      < 5.048660, -2.313934, 2.704390>
    }
    triangle {
      < 4.929070, -2.340215, 2.704448>,
      < 5.048660, -2.313934, 2.704390>,
      < 4.936498, -2.302884, 2.704390>
    }
    triangle {
      < 4.908995, -2.441134, 2.758817>,
      < 5.048656, -2.454893, 2.758817>,
      < 5.048658, -2.351996, 2.704448>
    }
    triangle {
      < 4.908995, -2.441134, 2.758817>,
      < 5.048658, -2.351996, 2.704448>,
      < 4.929070, -2.340215, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.887175, -2.550819, 2.787150>,
      < 5.048653, -2.566728, 2.787150>,
      < 5.048656, -2.454893, 2.758817>
    }
    triangle {
      < 4.887175, -2.550819, 2.787150>,
      < 5.048656, -2.454893, 2.758817>,
      < 4.908995, -2.441134, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.866190, -2.656301, 2.764967>,
      < 5.048650, -2.674276, 2.764967>,
      < 5.048653, -2.566728, 2.787150>
    }
    triangle {
      < 4.866190, -2.656301, 2.764967>,
      < 5.048653, -2.566728, 2.787150>,
      < 4.887175, -2.550819, 2.787150>
    }
    triangle {
      < 4.844050, -2.767589, 2.700042>,
      < 5.048647, -2.787746, 2.700042>,
      < 5.048650, -2.674276, 2.764967>
    }
    triangle {
      < 4.844050, -2.767589, 2.700042>,
      < 5.048650, -2.674276, 2.764967>,
      < 4.866190, -2.656301, 2.764967>
    }
    triangle {
      < 4.839495, -2.790493, 2.486032>,
      < 5.048646, -2.811098, 2.486032>,
      < 5.048647, -2.787746, 2.700042>
    }
    triangle {
      < 4.839495, -2.790493, 2.486032>,
      < 5.048647, -2.787746, 2.700042>,
      < 4.844050, -2.767589, 2.700042>
    }
    triangle {
      < 4.844050, -2.767589, 2.272216>,
      < 5.048647, -2.787746, 2.272216>,
      < 5.048646, -2.811098, 2.486032>
    }
    triangle {
      < 4.844050, -2.767589, 2.272216>,
      < 5.048646, -2.811098, 2.486032>,
      < 4.839495, -2.790493, 2.486032>
    }
    triangle {
      < 4.866190, -2.656301, 2.207291>,
      < 5.048650, -2.674276, 2.207291>,
      < 5.048647, -2.787746, 2.272216>
    }
    triangle {
      < 4.866190, -2.656301, 2.207291>,
      < 5.048647, -2.787746, 2.272216>,
      < 4.844050, -2.767589, 2.272216>
    }
    triangle {
      < 4.887175, -2.550819, 2.185108>,
      < 5.048653, -2.566728, 2.185108>,
      < 5.048650, -2.674276, 2.207291>
    }
    triangle {
      < 4.887175, -2.550819, 2.185108>,
      < 5.048650, -2.674276, 2.207291>,
      < 4.866190, -2.656301, 2.207291>
    }
    triangle {
      < 4.908995, -2.441134, 2.213441>,
      < 5.048656, -2.454893, 2.213441>,
      < 5.048653, -2.566728, 2.185108>
    }
    triangle {
      < 4.908995, -2.441134, 2.213441>,
      < 5.048653, -2.566728, 2.185108>,
      < 4.887175, -2.550819, 2.185108>
    }
    triangle {
      < 4.929070, -2.340215, 2.267810>,
      < 5.048658, -2.351996, 2.267810>,
      < 5.048656, -2.454893, 2.213441>
    }
    triangle {
      < 4.929070, -2.340215, 2.267810>,
      < 5.048656, -2.454893, 2.213441>,
      < 4.908995, -2.441134, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.048658, -2.351996, 2.267810>,
      < 4.929070, -2.340215, 2.267810>
    }
    triangle {
      < 5.048658, -2.351996, 2.704448>,
      < 5.168247, -2.340221, 2.704448>,
      < 5.160821, -2.302890, 2.704390>
    }
    triangle {
      < 5.048658, -2.351996, 2.704448>,
      < 5.160821, -2.302890, 2.704390>,
      < 5.048660, -2.313934, 2.704390>
    }
    triangle {
      < 5.048656, -2.454893, 2.758817>,
      < 5.188318, -2.441142, 2.758817>,
      < 5.168247, -2.340221, 2.704448>
    }
    triangle {
      < 5.048656, -2.454893, 2.758817>,
      < 5.168247, -2.340221, 2.704448>,
      < 5.048658, -2.351996, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.048653, -2.566728, 2.787150>,
      < 5.210133, -2.550828, 2.787150>,
      < 5.188318, -2.441142, 2.758817>
    }
    triangle {
      < 5.048653, -2.566728, 2.787150>,
      < 5.188318, -2.441142, 2.758817>,
      < 5.048656, -2.454893, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.048650, -2.674276, 2.764967>,
      < 5.231111, -2.656310, 2.764967>,
      < 5.210133, -2.550828, 2.787150>
    }
    triangle {
      < 5.048650, -2.674276, 2.764967>,
      < 5.210133, -2.550828, 2.787150>,
      < 5.048653, -2.566728, 2.787150>
    }
    triangle {
      < 5.048647, -2.787746, 2.700042>,
      < 5.253244, -2.767600, 2.700042>,
      < 5.231111, -2.656310, 2.764967>
    }
    triangle {
      < 5.048647, -2.787746, 2.700042>,
      < 5.231111, -2.656310, 2.764967>,
      < 5.048650, -2.674276, 2.764967>
    }
    triangle {
      < 5.048646, -2.811098, 2.486032>,
      < 5.257800, -2.790504, 2.486032>,
      < 5.253244, -2.767600, 2.700042>
    }
    triangle {
      < 5.048646, -2.811098, 2.486032>,
      < 5.253244, -2.767600, 2.700042>,
      < 5.048647, -2.787746, 2.700042>
    }
    triangle {
      < 5.048647, -2.787746, 2.272216>,
      < 5.253244, -2.767600, 2.272216>,
      < 5.257800, -2.790504, 2.486032>
    }
    triangle {
      < 5.048647, -2.787746, 2.272216>,
      < 5.257800, -2.790504, 2.486032>,
      < 5.048646, -2.811098, 2.486032>
    }
    triangle {
      < 5.048650, -2.674276, 2.207291>,
      < 5.231111, -2.656310, 2.207291>,
      < 5.253244, -2.767600, 2.272216>
    }
    triangle {
      < 5.048650, -2.674276, 2.207291>,
      < 5.253244, -2.767600, 2.272216>,
      < 5.048647, -2.787746, 2.272216>
    }
    triangle {
      < 5.048653, -2.566728, 2.185108>,
      < 5.210133, -2.550828, 2.185108>,
      < 5.231111, -2.656310, 2.207291>
    }
    triangle {
      < 5.048653, -2.566728, 2.185108>,
      < 5.231111, -2.656310, 2.207291>,
      < 5.048650, -2.674276, 2.207291>
    }
    triangle {
      < 5.048656, -2.454893, 2.213441>,
      < 5.188318, -2.441142, 2.213441>,
      < 5.210133, -2.550828, 2.185108>
    }
    triangle {
      < 5.048656, -2.454893, 2.213441>,
      < 5.210133, -2.550828, 2.185108>,
      < 5.048653, -2.566728, 2.185108>
    }
    triangle {
      < 5.048658, -2.351996, 2.267810>,
      < 5.168247, -2.340221, 2.267810>,
      < 5.188318, -2.441142, 2.213441>
    }
    triangle {
      < 5.048658, -2.351996, 2.267810>,
      < 5.188318, -2.441142, 2.213441>,
      < 5.048656, -2.454893, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.168247, -2.340221, 2.267810>,
      < 5.048658, -2.351996, 2.267810>
    }
    triangle {
      < 5.168247, -2.340221, 2.704448>,
      < 5.283239, -2.305343, 2.704448>,
      < 5.268674, -2.270177, 2.704390>
    }
    triangle {
      < 5.168247, -2.340221, 2.704448>,
      < 5.268674, -2.270177, 2.704390>,
      < 5.160821, -2.302890, 2.704390>
    }
    triangle {
      < 5.188318, -2.441142, 2.758817>,
      < 5.322614, -2.400407, 2.758817>,
      < 5.283239, -2.305343, 2.704448>
    }
    triangle {
      < 5.188318, -2.441142, 2.758817>,
      < 5.283239, -2.305343, 2.704448>,
      < 5.168247, -2.340221, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.210133, -2.550828, 2.787150>,
      < 5.365407, -2.503732, 2.787150>,
      < 5.322614, -2.400407, 2.758817>
    }
    triangle {
      < 5.210133, -2.550828, 2.787150>,
      < 5.322614, -2.400407, 2.758817>,
      < 5.188318, -2.441142, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.231111, -2.656310, 2.764967>,
      < 5.406560, -2.603094, 2.764967>,
      < 5.365407, -2.503732, 2.787150>
    }
    triangle {
      < 5.231111, -2.656310, 2.764967>,
      < 5.365407, -2.503732, 2.787150>,
      < 5.210133, -2.550828, 2.787150>
    }
    triangle {
      < 5.253244, -2.767600, 2.700042>,
      < 5.449981, -2.707928, 2.700042>,
      < 5.406560, -2.603094, 2.764967>
    }
    triangle {
      < 5.253244, -2.767600, 2.700042>,
      < 5.406560, -2.603094, 2.764967>,
      < 5.231111, -2.656310, 2.764967>
    }
    triangle {
      < 5.257800, -2.790504, 2.486032>,
      < 5.458916, -2.729503, 2.486032>,
      < 5.449981, -2.707928, 2.700042>
    }
    triangle {
      < 5.257800, -2.790504, 2.486032>,
      < 5.449981, -2.707928, 2.700042>,
      < 5.253244, -2.767600, 2.700042>
    }
    triangle {
      < 5.253244, -2.767600, 2.272216>,
      < 5.449981, -2.707928, 2.272216>,
      < 5.458916, -2.729503, 2.486032>
    }
    triangle {
      < 5.253244, -2.767600, 2.272216>,
      < 5.458916, -2.729503, 2.486032>,
      < 5.257800, -2.790504, 2.486032>
    }
    triangle {
      < 5.231111, -2.656310, 2.207291>,
      < 5.406560, -2.603094, 2.207291>,
      < 5.449981, -2.707928, 2.272216>
    }
    triangle {
      < 5.231111, -2.656310, 2.207291>,
      < 5.449981, -2.707928, 2.272216>,
      < 5.253244, -2.767600, 2.272216>
    }
    triangle {
      < 5.210133, -2.550828, 2.185108>,
      < 5.365407, -2.503732, 2.185108>,
      < 5.406560, -2.603094, 2.207291>
    }
    triangle {
      < 5.210133, -2.550828, 2.185108>,
      < 5.406560, -2.603094, 2.207291>,
      < 5.231111, -2.656310, 2.207291>
    }
    triangle {
      < 5.188318, -2.441142, 2.213441>,
      < 5.322614, -2.400407, 2.213441>,
      < 5.365407, -2.503732, 2.185108>
    }
    triangle {
      < 5.188318, -2.441142, 2.213441>,
      < 5.365407, -2.503732, 2.185108>,
      < 5.210133, -2.550828, 2.185108>
    }
    triangle {
      < 5.168247, -2.340221, 2.267810>,
      < 5.283239, -2.305343, 2.267810>,
      < 5.322614, -2.400407, 2.213441>
    }
    triangle {
      < 5.168247, -2.340221, 2.267810>,
      < 5.322614, -2.400407, 2.213441>,
      < 5.188318, -2.441142, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.283239, -2.305343, 2.267810>,
      < 5.168247, -2.340221, 2.267810>
    }
    triangle {
      < 5.283239, -2.305343, 2.704448>,
      < 5.389218, -2.248700, 2.704448>,
      < 5.368073, -2.217052, 2.704390>
    }
    triangle {
      < 5.283239, -2.305343, 2.704448>,
      < 5.368073, -2.217052, 2.704390>,
      < 5.268674, -2.270177, 2.704390>
    }
    triangle {
      < 5.322614, -2.400407, 2.758817>,
      < 5.446382, -2.334258, 2.758817>,
      < 5.389218, -2.248700, 2.704448>
    }
    triangle {
      < 5.322614, -2.400407, 2.758817>,
      < 5.389218, -2.248700, 2.704448>,
      < 5.283239, -2.305343, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.365407, -2.503732, 2.787150>,
      < 5.508512, -2.427247, 2.787150>,
      < 5.446382, -2.334258, 2.758817>
    }
    triangle {
      < 5.365407, -2.503732, 2.787150>,
      < 5.446382, -2.334258, 2.758817>,
      < 5.322614, -2.400407, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.406560, -2.603094, 2.764967>,
      < 5.568258, -2.516672, 2.764967>,
      < 5.508512, -2.427247, 2.787150>
    }
    triangle {
      < 5.406560, -2.603094, 2.764967>,
      < 5.508512, -2.427247, 2.787150>,
      < 5.365407, -2.503732, 2.787150>
    }
    triangle {
      < 5.449981, -2.707928, 2.700042>,
      < 5.631295, -2.611022, 2.700042>,
      < 5.568258, -2.516672, 2.764967>
    }
    triangle {
      < 5.449981, -2.707928, 2.700042>,
      < 5.568258, -2.516672, 2.764967>,
      < 5.406560, -2.603094, 2.764967>
    }
    triangle {
      < 5.458916, -2.729503, 2.486032>,
      < 5.644269, -2.630438, 2.486032>,
      < 5.631295, -2.611022, 2.700042>
    }
    triangle {
      < 5.458916, -2.729503, 2.486032>,
      < 5.631295, -2.611022, 2.700042>,
      < 5.449981, -2.707928, 2.700042>
    }
    triangle {
      < 5.449981, -2.707928, 2.272216>,
      < 5.631295, -2.611022, 2.272216>,
      < 5.644269, -2.630438, 2.486032>
    }
    triangle {
      < 5.449981, -2.707928, 2.272216>,
      < 5.644269, -2.630438, 2.486032>,
      < 5.458916, -2.729503, 2.486032>
    }
    triangle {
      < 5.406560, -2.603094, 2.207291>,
      < 5.568258, -2.516672, 2.207291>,
      < 5.631295, -2.611022, 2.272216>
    }
    triangle {
      < 5.406560, -2.603094, 2.207291>,
      < 5.631295, -2.611022, 2.272216>,
      < 5.449981, -2.707928, 2.272216>
    }
    triangle {
      < 5.365407, -2.503732, 2.185108>,
      < 5.508512, -2.427247, 2.185108>,
      < 5.568258, -2.516672, 2.207291>
    }
    triangle {
      < 5.365407, -2.503732, 2.185108>,
      < 5.568258, -2.516672, 2.207291>,
      < 5.406560, -2.603094, 2.207291>
    }
    triangle {
      < 5.322614, -2.400407, 2.213441>,
      < 5.446382, -2.334258, 2.213441>,
      < 5.508512, -2.427247, 2.185108>
    }
    triangle {
      < 5.322614, -2.400407, 2.213441>,
      < 5.508512, -2.427247, 2.185108>,
      < 5.365407, -2.503732, 2.185108>
    }
    triangle {
      < 5.283239, -2.305343, 2.267810>,
      < 5.389218, -2.248700, 2.267810>,
      < 5.446382, -2.334258, 2.213441>
    }
    triangle {
      < 5.283239, -2.305343, 2.267810>,
      < 5.446382, -2.334258, 2.213441>,
      < 5.322614, -2.400407, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.389218, -2.248700, 2.267810>,
      < 5.283239, -2.305343, 2.267810>
    }
    triangle {
      < 5.389218, -2.248700, 2.704448>,
      < 5.482111, -2.172471, 2.704448>,
      < 5.455199, -2.145556, 2.704390>
    }
    triangle {
      < 5.389218, -2.248700, 2.704448>,
      < 5.455199, -2.145556, 2.704390>,
      < 5.368073, -2.217052, 2.704390>
    }
    triangle {
      < 5.446382, -2.334258, 2.758817>,
      < 5.554868, -2.245233, 2.758817>,
      < 5.482111, -2.172471, 2.704448>
    }
    triangle {
      < 5.446382, -2.334258, 2.758817>,
      < 5.482111, -2.172471, 2.704448>,
      < 5.389218, -2.248700, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.508512, -2.427247, 2.787150>,
      < 5.633944, -2.324315, 2.787150>,
      < 5.554868, -2.245233, 2.758817>
    }
    triangle {
      < 5.508512, -2.427247, 2.787150>,
      < 5.554868, -2.245233, 2.758817>,
      < 5.446382, -2.334258, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.568258, -2.516672, 2.764967>,
      < 5.709989, -2.400366, 2.764967>,
      < 5.633944, -2.324315, 2.787150>
    }
    triangle {
      < 5.568258, -2.516672, 2.764967>,
      < 5.633944, -2.324315, 2.787150>,
      < 5.508512, -2.427247, 2.787150>
    }
    triangle {
      < 5.631295, -2.611022, 2.700042>,
      < 5.790220, -2.480605, 2.700042>,
      < 5.709989, -2.400366, 2.764967>
    }
    triangle {
      < 5.631295, -2.611022, 2.700042>,
      < 5.709989, -2.400366, 2.764967>,
      < 5.568258, -2.516672, 2.764967>
    }
    triangle {
      < 5.644269, -2.630438, 2.486032>,
      < 5.806733, -2.497117, 2.486032>,
      < 5.790220, -2.480605, 2.700042>
    }
    triangle {
      < 5.644269, -2.630438, 2.486032>,
      < 5.790220, -2.480605, 2.700042>,
      < 5.631295, -2.611022, 2.700042>
    }
    triangle {
      < 5.631295, -2.611022, 2.272216>,
      < 5.790220, -2.480605, 2.272216>,
      < 5.806733, -2.497117, 2.486032>
    }
    triangle {
      < 5.631295, -2.611022, 2.272216>,
      < 5.806733, -2.497117, 2.486032>,
      < 5.644269, -2.630438, 2.486032>
    }
    triangle {
      < 5.568258, -2.516672, 2.207291>,
      < 5.709989, -2.400366, 2.207291>,
      < 5.790220, -2.480605, 2.272216>
    }
    triangle {
      < 5.568258, -2.516672, 2.207291>,
      < 5.790220, -2.480605, 2.272216>,
      < 5.631295, -2.611022, 2.272216>
    }
    triangle {
      < 5.508512, -2.427247, 2.185108>,
      < 5.633944, -2.324315, 2.185108>,
      < 5.709989, -2.400366, 2.207291>
    }
    triangle {
      < 5.508512, -2.427247, 2.185108>,
      < 5.709989, -2.400366, 2.207291>,
      < 5.568258, -2.516672, 2.207291>
    }
    triangle {
      < 5.446382, -2.334258, 2.213441>,
      < 5.554868, -2.245233, 2.213441>,
      < 5.633944, -2.324315, 2.185108>
    }
    triangle {
      < 5.446382, -2.334258, 2.213441>,
      < 5.633944, -2.324315, 2.185108>,
      < 5.508512, -2.427247, 2.185108>
    }
    triangle {
      < 5.389218, -2.248700, 2.267810>,
      < 5.482111, -2.172471, 2.267810>,
      < 5.554868, -2.245233, 2.213441>
    }
    triangle {
      < 5.389218, -2.248700, 2.267810>,
      < 5.554868, -2.245233, 2.213441>,
      < 5.446382, -2.334258, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.482111, -2.172471, 2.267810>,
      < 5.389218, -2.248700, 2.267810>
    }
    triangle {
      < 5.482111, -2.172471, 2.704448>,
      < 5.558348, -2.079584, 2.704448>,
      < 5.526700, -2.058437, 2.704390>
    }
    triangle {
      < 5.482111, -2.172471, 2.704448>,
      < 5.526700, -2.058437, 2.704390>,
      < 5.455199, -2.145556, 2.704390>
    }
    triangle {
      < 5.554868, -2.245233, 2.758817>,
      < 5.643901, -2.136754, 2.758817>,
      < 5.558348, -2.079584, 2.704448>
    }
    triangle {
      < 5.554868, -2.245233, 2.758817>,
      < 5.558348, -2.079584, 2.704448>,
      < 5.482111, -2.172471, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.633944, -2.324315, 2.787150>,
      < 5.736886, -2.198890, 2.787150>,
      < 5.643901, -2.136754, 2.758817>
    }
    triangle {
      < 5.633944, -2.324315, 2.787150>,
      < 5.643901, -2.136754, 2.758817>,
      < 5.554868, -2.245233, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.709989, -2.400366, 2.764967>,
      < 5.826305, -2.258645, 2.764967>,
      < 5.736886, -2.198890, 2.787150>
    }
    triangle {
      < 5.709989, -2.400366, 2.764967>,
      < 5.736886, -2.198890, 2.787150>,
      < 5.633944, -2.324315, 2.787150>
    }
    triangle {
      < 5.790220, -2.480605, 2.700042>,
      < 5.920650, -2.321689, 2.700042>,
      < 5.826305, -2.258645, 2.764967>
    }
    triangle {
      < 5.790220, -2.480605, 2.700042>,
      < 5.826305, -2.258645, 2.764967>,
      < 5.709989, -2.400366, 2.764967>
    }
    triangle {
      < 5.806733, -2.497117, 2.486032>,
      < 5.940066, -2.334664, 2.486032>,
      < 5.920650, -2.321689, 2.700042>
    }
    triangle {
      < 5.806733, -2.497117, 2.486032>,
      < 5.920650, -2.321689, 2.700042>,
      < 5.790220, -2.480605, 2.700042>
    }
    triangle {
      < 5.790220, -2.480605, 2.272216>,
      < 5.920650, -2.321689, 2.272216>,
      < 5.940066, -2.334664, 2.486032>
    }
    triangle {
      < 5.790220, -2.480605, 2.272216>,
      < 5.940066, -2.334664, 2.486032>,
      < 5.806733, -2.497117, 2.486032>
    }
    triangle {
      < 5.709989, -2.400366, 2.207291>,
      < 5.826305, -2.258645, 2.207291>,
      < 5.920650, -2.321689, 2.272216>
    }
    triangle {
      < 5.709989, -2.400366, 2.207291>,
      < 5.920650, -2.321689, 2.272216>,
      < 5.790220, -2.480605, 2.272216>
    }
    triangle {
      < 5.633944, -2.324315, 2.185108>,
      < 5.736886, -2.198890, 2.185108>,
      < 5.826305, -2.258645, 2.207291>
    }
    triangle {
      < 5.633944, -2.324315, 2.185108>,
      < 5.826305, -2.258645, 2.207291>,
      < 5.709989, -2.400366, 2.207291>
    }
    triangle {
      < 5.554868, -2.245233, 2.213441>,
      < 5.643901, -2.136754, 2.213441>,
      < 5.736886, -2.198890, 2.185108>
    }
    triangle {
      < 5.554868, -2.245233, 2.213441>,
      < 5.736886, -2.198890, 2.185108>,
      < 5.633944, -2.324315, 2.185108>
    }
    triangle {
      < 5.482111, -2.172471, 2.267810>,
      < 5.558348, -2.079584, 2.267810>,
      < 5.643901, -2.136754, 2.213441>
    }
    triangle {
      < 5.482111, -2.172471, 2.267810>,
      < 5.643901, -2.136754, 2.213441>,
      < 5.554868, -2.245233, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.558348, -2.079584, 2.267810>,
      < 5.482111, -2.172471, 2.267810>
    }
    triangle {
      < 5.558348, -2.079584, 2.704448>,
      < 5.614999, -1.973609, 2.704448>,
      < 5.579834, -1.959042, 2.704390>
    }
    triangle {
      < 5.558348, -2.079584, 2.704448>,
      < 5.579834, -1.959042, 2.704390>,
      < 5.526700, -2.058437, 2.704390>
    }
    triangle {
      < 5.643901, -2.136754, 2.758817>,
      < 5.710062, -2.012991, 2.758817>,
      < 5.614999, -1.973609, 2.704448>
    }
    triangle {
      < 5.643901, -2.136754, 2.758817>,
      < 5.614999, -1.973609, 2.704448>,
      < 5.558348, -2.079584, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.736886, -2.198890, 2.787150>,
      < 5.813381, -2.055792, 2.787150>,
      < 5.710062, -2.012991, 2.758817>
    }
    triangle {
      < 5.736886, -2.198890, 2.787150>,
      < 5.710062, -2.012991, 2.758817>,
      < 5.643901, -2.136754, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.826305, -2.258645, 2.764967>,
      < 5.912741, -2.096955, 2.764967>,
      < 5.813381, -2.055792, 2.787150>
    }
    triangle {
      < 5.826305, -2.258645, 2.764967>,
      < 5.813381, -2.055792, 2.787150>,
      < 5.736886, -2.198890, 2.787150>
    }
    triangle {
      < 5.920650, -2.321689, 2.700042>,
      < 6.017571, -2.140382, 2.700042>,
      < 5.912741, -2.096955, 2.764967>
    }
    triangle {
      < 5.920650, -2.321689, 2.700042>,
      < 5.912741, -2.096955, 2.764967>,
      < 5.826305, -2.258645, 2.764967>
    }
    triangle {
      < 5.940066, -2.334664, 2.486032>,
      < 6.039145, -2.149320, 2.486032>,
      < 6.017571, -2.140382, 2.700042>
    }
    triangle {
      < 5.940066, -2.334664, 2.486032>,
      < 6.017571, -2.140382, 2.700042>,
      < 5.920650, -2.321689, 2.700042>
    }
    triangle {
      < 5.920650, -2.321689, 2.272216>,
      < 6.017571, -2.140382, 2.272216>,
      < 6.039145, -2.149320, 2.486032>
    }
    triangle {
      < 5.920650, -2.321689, 2.272216>,
      < 6.039145, -2.149320, 2.486032>,
      < 5.940066, -2.334664, 2.486032>
    }
    triangle {
      < 5.826305, -2.258645, 2.207291>,
      < 5.912741, -2.096955, 2.207291>,
      < 6.017571, -2.140382, 2.272216>
    }
    triangle {
      < 5.826305, -2.258645, 2.207291>,
      < 6.017571, -2.140382, 2.272216>,
      < 5.920650, -2.321689, 2.272216>
    }
    triangle {
      < 5.736886, -2.198890, 2.185108>,
      < 5.813381, -2.055792, 2.185108>,
      < 5.912741, -2.096955, 2.207291>
    }
    triangle {
      < 5.736886, -2.198890, 2.185108>,
      < 5.912741, -2.096955, 2.207291>,
      < 5.826305, -2.258645, 2.207291>
    }
    triangle {
      < 5.643901, -2.136754, 2.213441>,
      < 5.710062, -2.012991, 2.213441>,
      < 5.813381, -2.055792, 2.185108>
    }
    triangle {
      < 5.643901, -2.136754, 2.213441>,
      < 5.813381, -2.055792, 2.185108>,
      < 5.736886, -2.198890, 2.185108>
    }
    triangle {
      < 5.558348, -2.079584, 2.267810>,
      < 5.614999, -1.973609, 2.267810>,
      < 5.710062, -2.012991, 2.213441>
    }
    triangle {
      < 5.558348, -2.079584, 2.267810>,
      < 5.710062, -2.012991, 2.213441>,
      < 5.643901, -2.136754, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.614999, -1.973609, 2.267810>,
      < 5.558348, -2.079584, 2.267810>
    }
    triangle {
      < 5.614999, -1.973609, 2.704448>,
      < 5.649887, -1.858619, 2.704448>,
      < 5.612556, -1.851192, 2.704390>
    }
    triangle {
      < 5.614999, -1.973609, 2.704448>,
      < 5.612556, -1.851192, 2.704390>,
      < 5.579834, -1.959042, 2.704390>
    }
    triangle {
      < 5.710062, -2.012991, 2.758817>,
      < 5.750805, -1.878699, 2.758817>,
      < 5.649887, -1.858619, 2.704448>
    }
    triangle {
      < 5.710062, -2.012991, 2.758817>,
      < 5.649887, -1.858619, 2.704448>,
      < 5.614999, -1.973609, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.813381, -2.055792, 2.787150>,
      < 5.860490, -1.900522, 2.787150>,
      < 5.750805, -1.878699, 2.758817>
    }
    triangle {
      < 5.813381, -2.055792, 2.787150>,
      < 5.750805, -1.878699, 2.758817>,
      < 5.710062, -2.012991, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.912741, -2.096955, 2.764967>,
      < 5.965970, -1.921509, 2.764967>,
      < 5.860490, -1.900522, 2.787150>
    }
    triangle {
      < 5.912741, -2.096955, 2.764967>,
      < 5.860490, -1.900522, 2.787150>,
      < 5.813381, -2.055792, 2.787150>
    }
    triangle {
      < 6.017571, -2.140382, 2.700042>,
      < 6.077259, -1.943652, 2.700042>,
      < 5.965970, -1.921509, 2.764967>
    }
    triangle {
      < 6.017571, -2.140382, 2.700042>,
      < 5.965970, -1.921509, 2.764967>,
      < 5.912741, -2.096955, 2.764967>
    }
    triangle {
      < 6.039145, -2.149320, 2.486032>,
      < 6.100163, -1.948209, 2.486032>,
      < 6.077259, -1.943652, 2.700042>
    }
    triangle {
      < 6.039145, -2.149320, 2.486032>,
      < 6.077259, -1.943652, 2.700042>,
      < 6.017571, -2.140382, 2.700042>
    }
    triangle {
      < 6.017571, -2.140382, 2.272216>,
      < 6.077259, -1.943652, 2.272216>,
      < 6.100163, -1.948209, 2.486032>
    }
    triangle {
      < 6.017571, -2.140382, 2.272216>,
      < 6.100163, -1.948209, 2.486032>,
      < 6.039145, -2.149320, 2.486032>
    }
    triangle {
      < 5.912741, -2.096955, 2.207291>,
      < 5.965970, -1.921509, 2.207291>,
      < 6.077259, -1.943652, 2.272216>
    }
    triangle {
      < 5.912741, -2.096955, 2.207291>,
      < 6.077259, -1.943652, 2.272216>,
      < 6.017571, -2.140382, 2.272216>
    }
    triangle {
      < 5.813381, -2.055792, 2.185108>,
      < 5.860490, -1.900522, 2.185108>,
      < 5.965970, -1.921509, 2.207291>
    }
    triangle {
      < 5.813381, -2.055792, 2.185108>,
      < 5.965970, -1.921509, 2.207291>,
      < 5.912741, -2.096955, 2.207291>
    }
    triangle {
      < 5.710062, -2.012991, 2.213441>,
      < 5.750805, -1.878699, 2.213441>,
      < 5.860490, -1.900522, 2.185108>
    }
    triangle {
      < 5.710062, -2.012991, 2.213441>,
      < 5.860490, -1.900522, 2.185108>,
      < 5.813381, -2.055792, 2.185108>
    }
    triangle {
      < 5.614999, -1.973609, 2.267810>,
      < 5.649887, -1.858619, 2.267810>,
      < 5.750805, -1.878699, 2.213441>
    }
    triangle {
      < 5.614999, -1.973609, 2.267810>,
      < 5.750805, -1.878699, 2.213441>,
      < 5.710062, -2.012991, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.649887, -1.858619, 2.267810>,
      < 5.614999, -1.973609, 2.267810>
    }
    triangle {
      < 5.649887, -1.858619, 2.704448>,
      < 5.661671, -1.739033, 2.704448>,
      < 5.623609, -1.739030, 2.704390>
    }
    triangle {
      < 5.649887, -1.858619, 2.704448>,
      < 5.623609, -1.739030, 2.704390>,
      < 5.612556, -1.851192, 2.704390>
    }
    triangle {
      < 5.750805, -1.878699, 2.758817>,
      < 5.764567, -1.739038, 2.758817>,
      < 5.661671, -1.739033, 2.704448>
    }
    triangle {
      < 5.750805, -1.878699, 2.758817>,
      < 5.661671, -1.739033, 2.704448>,
      < 5.649887, -1.858619, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.860490, -1.900522, 2.787150>,
      < 5.876403, -1.739043, 2.787150>,
      < 5.764567, -1.739038, 2.758817>
    }
    triangle {
      < 5.860490, -1.900522, 2.787150>,
      < 5.764567, -1.739038, 2.758817>,
      < 5.750805, -1.878699, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.965970, -1.921509, 2.764967>,
      < 5.983951, -1.739049, 2.764967>,
      < 5.876403, -1.739043, 2.787150>
    }
    triangle {
      < 5.965970, -1.921509, 2.764967>,
      < 5.876403, -1.739043, 2.787150>,
      < 5.860490, -1.900522, 2.787150>
    }
    triangle {
      < 6.077259, -1.943652, 2.700042>,
      < 6.097421, -1.739055, 2.700042>,
      < 5.983951, -1.739049, 2.764967>
    }
    triangle {
      < 6.077259, -1.943652, 2.700042>,
      < 5.983951, -1.739049, 2.764967>,
      < 5.965970, -1.921509, 2.764967>
    }
    triangle {
      < 6.100163, -1.948209, 2.486032>,
      < 6.120772, -1.739057, 2.486032>,
      < 6.097421, -1.739055, 2.700042>
    }
    triangle {
      < 6.100163, -1.948209, 2.486032>,
      < 6.097421, -1.739055, 2.700042>,
      < 6.077259, -1.943652, 2.700042>
    }
    triangle {
      < 6.077259, -1.943652, 2.272216>,
      < 6.097421, -1.739055, 2.272216>,
      < 6.120772, -1.739057, 2.486032>
    }
    triangle {
      < 6.077259, -1.943652, 2.272216>,
      < 6.120772, -1.739057, 2.486032>,
      < 6.100163, -1.948209, 2.486032>
    }
    triangle {
      < 5.965970, -1.921509, 2.207291>,
      < 5.983951, -1.739049, 2.207291>,
      < 6.097421, -1.739055, 2.272216>
    }
    triangle {
      < 5.965970, -1.921509, 2.207291>,
      < 6.097421, -1.739055, 2.272216>,
      < 6.077259, -1.943652, 2.272216>
    }
    triangle {
      < 5.860490, -1.900522, 2.185108>,
      < 5.876403, -1.739043, 2.185108>,
      < 5.983951, -1.739049, 2.207291>
    }
    triangle {
      < 5.860490, -1.900522, 2.185108>,
      < 5.983951, -1.739049, 2.207291>,
      < 5.965970, -1.921509, 2.207291>
    }
    triangle {
      < 5.750805, -1.878699, 2.213441>,
      < 5.764567, -1.739038, 2.213441>,
      < 5.876403, -1.739043, 2.185108>
    }
    triangle {
      < 5.750805, -1.878699, 2.213441>,
      < 5.876403, -1.739043, 2.185108>,
      < 5.860490, -1.900522, 2.185108>
    }
    triangle {
      < 5.649887, -1.858619, 2.267810>,
      < 5.661671, -1.739033, 2.267810>,
      < 5.764567, -1.739038, 2.213441>
    }
    triangle {
      < 5.649887, -1.858619, 2.267810>,
      < 5.764567, -1.739038, 2.213441>,
      < 5.750805, -1.878699, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.661671, -1.739033, 2.267810>,
      < 5.649887, -1.858619, 2.267810>
    }
    triangle {
      < 5.661671, -1.739033, 2.704448>,
      < 5.649899, -1.619444, 2.704448>,
      < 5.612568, -1.626868, 2.704390>
    }
    triangle {
      < 5.661671, -1.739033, 2.704448>,
      < 5.612568, -1.626868, 2.704390>,
      < 5.623609, -1.739030, 2.704390>
    }
    triangle {
      < 5.764567, -1.739038, 2.758817>,
      < 5.750820, -1.599375, 2.758817>,
      < 5.649899, -1.619444, 2.704448>
    }
    triangle {
      < 5.764567, -1.739038, 2.758817>,
      < 5.649899, -1.619444, 2.704448>,
      < 5.661671, -1.739033, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.876403, -1.739043, 2.787150>,
      < 5.860507, -1.577563, 2.787150>,
      < 5.750820, -1.599375, 2.758817>
    }
    triangle {
      < 5.876403, -1.739043, 2.787150>,
      < 5.750820, -1.599375, 2.758817>,
      < 5.764567, -1.739038, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.983951, -1.739049, 2.764967>,
      < 5.965990, -1.556588, 2.764967>,
      < 5.860507, -1.577563, 2.787150>
    }
    triangle {
      < 5.983951, -1.739049, 2.764967>,
      < 5.860507, -1.577563, 2.787150>,
      < 5.876403, -1.739043, 2.787150>
    }
    triangle {
      < 6.097421, -1.739055, 2.700042>,
      < 6.077280, -1.534457, 2.700042>,
      < 5.965990, -1.556588, 2.764967>
    }
    triangle {
      < 6.097421, -1.739055, 2.700042>,
      < 5.965990, -1.556588, 2.764967>,
      < 5.983951, -1.739049, 2.764967>
    }
    triangle {
      < 6.120772, -1.739057, 2.486032>,
      < 6.100183, -1.529903, 2.486032>,
      < 6.077280, -1.534457, 2.700042>
    }
    triangle {
      < 6.120772, -1.739057, 2.486032>,
      < 6.077280, -1.534457, 2.700042>,
      < 6.097421, -1.739055, 2.700042>
    }
    triangle {
      < 6.097421, -1.739055, 2.272216>,
      < 6.077280, -1.534457, 2.272216>,
      < 6.100183, -1.529903, 2.486032>
    }
    triangle {
      < 6.097421, -1.739055, 2.272216>,
      < 6.100183, -1.529903, 2.486032>,
      < 6.120772, -1.739057, 2.486032>
    }
    triangle {
      < 5.983951, -1.739049, 2.207291>,
      < 5.965990, -1.556588, 2.207291>,
      < 6.077280, -1.534457, 2.272216>
    }
    triangle {
      < 5.983951, -1.739049, 2.207291>,
      < 6.077280, -1.534457, 2.272216>,
      < 6.097421, -1.739055, 2.272216>
    }
    triangle {
      < 5.876403, -1.739043, 2.185108>,
      < 5.860507, -1.577563, 2.185108>,
      < 5.965990, -1.556588, 2.207291>
    }
    triangle {
      < 5.876403, -1.739043, 2.185108>,
      < 5.965990, -1.556588, 2.207291>,
      < 5.983951, -1.739049, 2.207291>
    }
    triangle {
      < 5.764567, -1.739038, 2.213441>,
      < 5.750820, -1.599375, 2.213441>,
      < 5.860507, -1.577563, 2.185108>
    }
    triangle {
      < 5.764567, -1.739038, 2.213441>,
      < 5.860507, -1.577563, 2.185108>,
      < 5.876403, -1.739043, 2.185108>
    }
    triangle {
      < 5.661671, -1.739033, 2.267810>,
      < 5.649899, -1.619444, 2.267810>,
      < 5.750820, -1.599375, 2.213441>
    }
    triangle {
      < 5.661671, -1.739033, 2.267810>,
      < 5.750820, -1.599375, 2.213441>,
      < 5.764567, -1.739038, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.649899, -1.619444, 2.267810>,
      < 5.661671, -1.739033, 2.267810>
    }
    triangle {
      < 5.649899, -1.619444, 2.704448>,
      < 5.615024, -1.504450, 2.704448>,
      < 5.579858, -1.519013, 2.704390>
    }
    triangle {
      < 5.649899, -1.619444, 2.704448>,
      < 5.579858, -1.519013, 2.704390>,
      < 5.612568, -1.626868, 2.704390>
    }
    triangle {
      < 5.750820, -1.599375, 2.758817>,
      < 5.710090, -1.465079, 2.758817>,
      < 5.615024, -1.504450, 2.704448>
    }
    triangle {
      < 5.750820, -1.599375, 2.758817>,
      < 5.615024, -1.504450, 2.704448>,
      < 5.649899, -1.619444, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.860507, -1.577563, 2.787150>,
      < 5.813414, -1.422288, 2.787150>,
      < 5.710090, -1.465079, 2.758817>
    }
    triangle {
      < 5.860507, -1.577563, 2.787150>,
      < 5.710090, -1.465079, 2.758817>,
      < 5.750820, -1.599375, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.965990, -1.556588, 2.764967>,
      < 5.912778, -1.381136, 2.764967>,
      < 5.813414, -1.422288, 2.787150>
    }
    triangle {
      < 5.965990, -1.556588, 2.764967>,
      < 5.813414, -1.422288, 2.787150>,
      < 5.860507, -1.577563, 2.787150>
    }
    triangle {
      < 6.077280, -1.534457, 2.700042>,
      < 6.017613, -1.337719, 2.700042>,
      < 5.912778, -1.381136, 2.764967>
    }
    triangle {
      < 6.077280, -1.534457, 2.700042>,
      < 5.912778, -1.381136, 2.764967>,
      < 5.965990, -1.556588, 2.764967>
    }
    triangle {
      < 6.100183, -1.529903, 2.486032>,
      < 6.039188, -1.328784, 2.486032>,
      < 6.017613, -1.337719, 2.700042>
    }
    triangle {
      < 6.100183, -1.529903, 2.486032>,
      < 6.017613, -1.337719, 2.700042>,
      < 6.077280, -1.534457, 2.700042>
    }
    triangle {
      < 6.077280, -1.534457, 2.272216>,
      < 6.017613, -1.337719, 2.272216>,
      < 6.039188, -1.328784, 2.486032>
    }
    triangle {
      < 6.077280, -1.534457, 2.272216>,
      < 6.039188, -1.328784, 2.486032>,
      < 6.100183, -1.529903, 2.486032>
    }
    triangle {
      < 5.965990, -1.556588, 2.207291>,
      < 5.912778, -1.381136, 2.207291>,
      < 6.017613, -1.337719, 2.272216>
    }
    triangle {
      < 5.965990, -1.556588, 2.207291>,
      < 6.017613, -1.337719, 2.272216>,
      < 6.077280, -1.534457, 2.272216>
    }
    triangle {
      < 5.860507, -1.577563, 2.185108>,
      < 5.813414, -1.422288, 2.185108>,
      < 5.912778, -1.381136, 2.207291>
    }
    triangle {
      < 5.860507, -1.577563, 2.185108>,
      < 5.912778, -1.381136, 2.207291>,
      < 5.965990, -1.556588, 2.207291>
    }
    triangle {
      < 5.750820, -1.599375, 2.213441>,
      < 5.710090, -1.465079, 2.213441>,
      < 5.813414, -1.422288, 2.185108>
    }
    triangle {
      < 5.750820, -1.599375, 2.213441>,
      < 5.813414, -1.422288, 2.185108>,
      < 5.860507, -1.577563, 2.185108>
    }
    triangle {
      < 5.649899, -1.619444, 2.267810>,
      < 5.615024, -1.504450, 2.267810>,
      < 5.710090, -1.465079, 2.213441>
    }
    triangle {
      < 5.649899, -1.619444, 2.267810>,
      < 5.710090, -1.465079, 2.213441>,
      < 5.750820, -1.599375, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.615024, -1.504450, 2.267810>,
      < 5.649899, -1.619444, 2.267810>
    }
    triangle {
      < 5.615024, -1.504450, 2.704448>,
      < 5.558383, -1.398469, 2.704448>,
      < 5.526734, -1.419614, 2.704390>
    }
    triangle {
      < 5.615024, -1.504450, 2.704448>,
      < 5.526734, -1.419614, 2.704390>,
      < 5.579858, -1.519013, 2.704390>
    }
    triangle {
      < 5.710090, -1.465079, 2.758817>,
      < 5.643943, -1.341308, 2.758817>,
      < 5.558383, -1.398469, 2.704448>
    }
    triangle {
      < 5.710090, -1.465079, 2.758817>,
      < 5.558383, -1.398469, 2.704448>,
      < 5.615024, -1.504450, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.813414, -1.422288, 2.787150>,
      < 5.736934, -1.279182, 2.787150>,
      < 5.643943, -1.341308, 2.758817>
    }
    triangle {
      < 5.813414, -1.422288, 2.787150>,
      < 5.643943, -1.341308, 2.758817>,
      < 5.710090, -1.465079, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.912778, -1.381136, 2.764967>,
      < 5.826361, -1.219437, 2.764967>,
      < 5.736934, -1.279182, 2.787150>
    }
    triangle {
      < 5.912778, -1.381136, 2.764967>,
      < 5.736934, -1.279182, 2.787150>,
      < 5.813414, -1.422288, 2.787150>
    }
    triangle {
      < 6.017613, -1.337719, 2.700042>,
      < 5.920712, -1.156403, 2.700042>,
      < 5.826361, -1.219437, 2.764967>
    }
    triangle {
      < 6.017613, -1.337719, 2.700042>,
      < 5.826361, -1.219437, 2.764967>,
      < 5.912778, -1.381136, 2.764967>
    }
    triangle {
      < 6.039188, -1.328784, 2.486032>,
      < 5.940129, -1.143430, 2.486032>,
      < 5.920712, -1.156403, 2.700042>
    }
    triangle {
      < 6.039188, -1.328784, 2.486032>,
      < 5.920712, -1.156403, 2.700042>,
      < 6.017613, -1.337719, 2.700042>
    }
    triangle {
      < 6.017613, -1.337719, 2.272216>,
      < 5.920712, -1.156403, 2.272216>,
      < 5.940129, -1.143430, 2.486032>
    }
    triangle {
      < 6.017613, -1.337719, 2.272216>,
      < 5.940129, -1.143430, 2.486032>,
      < 6.039188, -1.328784, 2.486032>
    }
    triangle {
      < 5.912778, -1.381136, 2.207291>,
      < 5.826361, -1.219437, 2.207291>,
      < 5.920712, -1.156403, 2.272216>
    }
    triangle {
      < 5.912778, -1.381136, 2.207291>,
      < 5.920712, -1.156403, 2.272216>,
      < 6.017613, -1.337719, 2.272216>
    }
    triangle {
      < 5.813414, -1.422288, 2.185108>,
      < 5.736934, -1.279182, 2.185108>,
      < 5.826361, -1.219437, 2.207291>
    }
    triangle {
      < 5.813414, -1.422288, 2.185108>,
      < 5.826361, -1.219437, 2.207291>,
      < 5.912778, -1.381136, 2.207291>
    }
    triangle {
      < 5.710090, -1.465079, 2.213441>,
      < 5.643943, -1.341308, 2.213441>,
      < 5.736934, -1.279182, 2.185108>
    }
    triangle {
      < 5.710090, -1.465079, 2.213441>,
      < 5.736934, -1.279182, 2.185108>,
      < 5.813414, -1.422288, 2.185108>
    }
    triangle {
      < 5.615024, -1.504450, 2.267810>,
      < 5.558383, -1.398469, 2.267810>,
      < 5.643943, -1.341308, 2.213441>
    }
    triangle {
      < 5.615024, -1.504450, 2.267810>,
      < 5.643943, -1.341308, 2.213441>,
      < 5.710090, -1.465079, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.558383, -1.398469, 2.267810>,
      < 5.615024, -1.504450, 2.267810>
    }
    triangle {
      < 5.558383, -1.398469, 2.704448>,
      < 5.482157, -1.305575, 2.704448>,
      < 5.455241, -1.332487, 2.704390>
    }
    triangle {
      < 5.558383, -1.398469, 2.704448>,
      < 5.455241, -1.332487, 2.704390>,
      < 5.526734, -1.419614, 2.704390>
    }
    triangle {
      < 5.643943, -1.341308, 2.758817>,
      < 5.554921, -1.232821, 2.758817>,
      < 5.482157, -1.305575, 2.704448>
    }
    triangle {
      < 5.643943, -1.341308, 2.758817>,
      < 5.482157, -1.305575, 2.704448>,
      < 5.558383, -1.398469, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.736934, -1.279182, 2.787150>,
      < 5.634006, -1.153747, 2.787150>,
      < 5.554921, -1.232821, 2.758817>
    }
    triangle {
      < 5.736934, -1.279182, 2.787150>,
      < 5.554921, -1.232821, 2.758817>,
      < 5.643943, -1.341308, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.826361, -1.219437, 2.764967>,
      < 5.710057, -1.077703, 2.764967>,
      < 5.634006, -1.153747, 2.787150>
    }
    triangle {
      < 5.826361, -1.219437, 2.764967>,
      < 5.634006, -1.153747, 2.787150>,
      < 5.736934, -1.279182, 2.787150>
    }
    triangle {
      < 5.920712, -1.156403, 2.700042>,
      < 5.790298, -0.997473, 2.700042>,
      < 5.710057, -1.077703, 2.764967>
    }
    triangle {
      < 5.920712, -1.156403, 2.700042>,
      < 5.710057, -1.077703, 2.764967>,
      < 5.826361, -1.219437, 2.764967>
    }
    triangle {
      < 5.940129, -1.143430, 2.486032>,
      < 5.806811, -0.980962, 2.486032>,
      < 5.790298, -0.997473, 2.700042>
    }
    triangle {
      < 5.940129, -1.143430, 2.486032>,
      < 5.790298, -0.997473, 2.700042>,
      < 5.920712, -1.156403, 2.700042>
    }
    triangle {
      < 5.920712, -1.156403, 2.272216>,
      < 5.790298, -0.997473, 2.272216>,
      < 5.806811, -0.980962, 2.486032>
    }
    triangle {
      < 5.920712, -1.156403, 2.272216>,
      < 5.806811, -0.980962, 2.486032>,
      < 5.940129, -1.143430, 2.486032>
    }
    triangle {
      < 5.826361, -1.219437, 2.207291>,
      < 5.710057, -1.077703, 2.207291>,
      < 5.790298, -0.997473, 2.272216>
    }
    triangle {
      < 5.826361, -1.219437, 2.207291>,
      < 5.790298, -0.997473, 2.272216>,
      < 5.920712, -1.156403, 2.272216>
    }
    triangle {
      < 5.736934, -1.279182, 2.185108>,
      < 5.634006, -1.153747, 2.185108>,
      < 5.710057, -1.077703, 2.207291>
    }
    triangle {
      < 5.736934, -1.279182, 2.185108>,
      < 5.710057, -1.077703, 2.207291>,
      < 5.826361, -1.219437, 2.207291>
    }
    triangle {
      < 5.643943, -1.341308, 2.213441>,
      < 5.554921, -1.232821, 2.213441>,
      < 5.634006, -1.153747, 2.185108>
    }
    triangle {
      < 5.643943, -1.341308, 2.213441>,
      < 5.634006, -1.153747, 2.185108>,
      < 5.736934, -1.279182, 2.185108>
    }
    triangle {
      < 5.558383, -1.398469, 2.267810>,
      < 5.482157, -1.305575, 2.267810>,
      < 5.554921, -1.232821, 2.213441>
    }
    triangle {
      < 5.558383, -1.398469, 2.267810>,
      < 5.554921, -1.232821, 2.213441>,
      < 5.643943, -1.341308, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.482157, -1.305575, 2.267810>,
      < 5.558383, -1.398469, 2.267810>
    }
    triangle {
      < 5.482157, -1.305575, 2.704448>,
      < 5.389272, -1.229336, 2.704448>,
      < 5.368124, -1.260982, 2.704390>
    }
    triangle {
      < 5.482157, -1.305575, 2.704448>,
      < 5.368124, -1.260982, 2.704390>,
      < 5.455241, -1.332487, 2.704390>
    }
    triangle {
      < 5.554921, -1.232821, 2.758817>,
      < 5.446445, -1.143784, 2.758817>,
      < 5.389272, -1.229336, 2.704448>
    }
    triangle {
      < 5.554921, -1.232821, 2.758817>,
      < 5.389272, -1.229336, 2.704448>,
      < 5.482157, -1.305575, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.634006, -1.153747, 2.787150>,
      < 5.508583, -1.050802, 2.787150>,
      < 5.446445, -1.143784, 2.758817>
    }
    triangle {
      < 5.634006, -1.153747, 2.787150>,
      < 5.446445, -1.143784, 2.758817>,
      < 5.554921, -1.232821, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.710057, -1.077703, 2.764967>,
      < 5.568339, -0.961382, 2.764967>,
      < 5.508583, -1.050802, 2.787150>
    }
    triangle {
      < 5.710057, -1.077703, 2.764967>,
      < 5.508583, -1.050802, 2.787150>,
      < 5.634006, -1.153747, 2.787150>
    }
    triangle {
      < 5.790298, -0.997473, 2.700042>,
      < 5.631387, -0.867040, 2.700042>,
      < 5.568339, -0.961382, 2.764967>
    }
    triangle {
      < 5.790298, -0.997473, 2.700042>,
      < 5.568339, -0.961382, 2.764967>,
      < 5.710057, -1.077703, 2.764967>
    }
    triangle {
      < 5.806811, -0.980962, 2.486032>,
      < 5.644362, -0.847624, 2.486032>,
      < 5.631387, -0.867040, 2.700042>
    }
    triangle {
      < 5.806811, -0.980962, 2.486032>,
      < 5.631387, -0.867040, 2.700042>,
      < 5.790298, -0.997473, 2.700042>
    }
    triangle {
      < 5.790298, -0.997473, 2.272216>,
      < 5.631387, -0.867040, 2.272216>,
      < 5.644362, -0.847624, 2.486032>
    }
    triangle {
      < 5.790298, -0.997473, 2.272216>,
      < 5.644362, -0.847624, 2.486032>,
      < 5.806811, -0.980962, 2.486032>
    }
    triangle {
      < 5.710057, -1.077703, 2.207291>,
      < 5.568339, -0.961382, 2.207291>,
      < 5.631387, -0.867040, 2.272216>
    }
    triangle {
      < 5.710057, -1.077703, 2.207291>,
      < 5.631387, -0.867040, 2.272216>,
      < 5.790298, -0.997473, 2.272216>
    }
    triangle {
      < 5.634006, -1.153747, 2.185108>,
      < 5.508583, -1.050802, 2.185108>,
      < 5.568339, -0.961382, 2.207291>
    }
    triangle {
      < 5.634006, -1.153747, 2.185108>,
      < 5.568339, -0.961382, 2.207291>,
      < 5.710057, -1.077703, 2.207291>
    }
    triangle {
      < 5.554921, -1.232821, 2.213441>,
      < 5.446445, -1.143784, 2.213441>,
      < 5.508583, -1.050802, 2.185108>
    }
    triangle {
      < 5.554921, -1.232821, 2.213441>,
      < 5.508583, -1.050802, 2.185108>,
      < 5.634006, -1.153747, 2.185108>
    }
    triangle {
      < 5.482157, -1.305575, 2.267810>,
      < 5.389272, -1.229336, 2.267810>,
      < 5.446445, -1.143784, 2.213441>
    }
    triangle {
      < 5.482157, -1.305575, 2.267810>,
      < 5.446445, -1.143784, 2.213441>,
      < 5.554921, -1.232821, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.389272, -1.229336, 2.267810>,
      < 5.482157, -1.305575, 2.267810>
    }
    triangle {
      < 5.389272, -1.229336, 2.704448>,
      < 5.283298, -1.172683, 2.704448>,
      < 5.268731, -1.207846, 2.704390>
    }
    triangle {
      < 5.389272, -1.229336, 2.704448>,
      < 5.268731, -1.207846, 2.704390>,
      < 5.368124, -1.260982, 2.704390>
    }
    triangle {
      < 5.446445, -1.143784, 2.758817>,
      < 5.322682, -1.077621, 2.758817>,
      < 5.283298, -1.172683, 2.704448>
    }
    triangle {
      < 5.446445, -1.143784, 2.758817>,
      < 5.283298, -1.172683, 2.704448>,
      < 5.389272, -1.229336, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.508583, -1.050802, 2.787150>,
      < 5.365488, -0.974301, 2.787150>,
      < 5.322682, -1.077621, 2.758817>
    }
    triangle {
      < 5.508583, -1.050802, 2.787150>,
      < 5.322682, -1.077621, 2.758817>,
      < 5.446445, -1.143784, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.568339, -0.961382, 2.764967>,
      < 5.406651, -0.874944, 2.764967>,
      < 5.365488, -0.974301, 2.787150>
    }
    triangle {
      < 5.568339, -0.961382, 2.764967>,
      < 5.365488, -0.974301, 2.787150>,
      < 5.508583, -1.050802, 2.787150>
    }
    triangle {
      < 5.631387, -0.867040, 2.700042>,
      < 5.450083, -0.770114, 2.700042>,
      < 5.406651, -0.874944, 2.764967>
    }
    triangle {
      < 5.631387, -0.867040, 2.700042>,
      < 5.406651, -0.874944, 2.764967>,
      < 5.568339, -0.961382, 2.764967>
    }
    triangle {
      < 5.644362, -0.847624, 2.486032>,
      < 5.459021, -0.748540, 2.486032>,
      < 5.450083, -0.770114, 2.700042>
    }
    triangle {
      < 5.644362, -0.847624, 2.486032>,
      < 5.450083, -0.770114, 2.700042>,
      < 5.631387, -0.867040, 2.700042>
    }
    triangle {
      < 5.631387, -0.867040, 2.272216>,
      < 5.450083, -0.770114, 2.272216>,
      < 5.459021, -0.748540, 2.486032>
    }
    triangle {
      < 5.631387, -0.867040, 2.272216>,
      < 5.459021, -0.748540, 2.486032>,
      < 5.644362, -0.847624, 2.486032>
    }
    triangle {
      < 5.568339, -0.961382, 2.207291>,
      < 5.406651, -0.874944, 2.207291>,
      < 5.450083, -0.770114, 2.272216>
    }
    triangle {
      < 5.568339, -0.961382, 2.207291>,
      < 5.450083, -0.770114, 2.272216>,
      < 5.631387, -0.867040, 2.272216>
    }
    triangle {
      < 5.508583, -1.050802, 2.185108>,
      < 5.365488, -0.974301, 2.185108>,
      < 5.406651, -0.874944, 2.207291>
    }
    triangle {
      < 5.508583, -1.050802, 2.185108>,
      < 5.406651, -0.874944, 2.207291>,
      < 5.568339, -0.961382, 2.207291>
    }
    triangle {
      < 5.446445, -1.143784, 2.213441>,
      < 5.322682, -1.077621, 2.213441>,
      < 5.365488, -0.974301, 2.185108>
    }
    triangle {
      < 5.446445, -1.143784, 2.213441>,
      < 5.365488, -0.974301, 2.185108>,
      < 5.508583, -1.050802, 2.185108>
    }
    triangle {
      < 5.389272, -1.229336, 2.267810>,
      < 5.283298, -1.172683, 2.267810>,
      < 5.322682, -1.077621, 2.213441>
    }
    triangle {
      < 5.389272, -1.229336, 2.267810>,
      < 5.322682, -1.077621, 2.213441>,
      < 5.446445, -1.143784, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.283298, -1.172683, 2.267810>,
      < 5.389272, -1.229336, 2.267810>
    }
    triangle {
      < 5.283298, -1.172683, 2.704448>,
      < 5.168311, -1.137792, 2.704448>,
      < 5.160882, -1.175122, 2.704390>
    }
    triangle {
      < 5.283298, -1.172683, 2.704448>,
      < 5.160882, -1.175122, 2.704390>,
      < 5.268731, -1.207846, 2.704390>
    }
    triangle {
      < 5.322682, -1.077621, 2.758817>,
      < 5.188392, -1.036873, 2.758817>,
      < 5.168311, -1.137792, 2.704448>
    }
    triangle {
      < 5.322682, -1.077621, 2.758817>,
      < 5.168311, -1.137792, 2.704448>,
      < 5.283298, -1.172683, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.365488, -0.974301, 2.787150>,
      < 5.210217, -0.927189, 2.787150>,
      < 5.188392, -1.036873, 2.758817>
    }
    triangle {
      < 5.365488, -0.974301, 2.787150>,
      < 5.188392, -1.036873, 2.758817>,
      < 5.322682, -1.077621, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.406651, -0.874944, 2.764967>,
      < 5.231207, -0.821709, 2.764967>,
      < 5.210217, -0.927189, 2.787150>
    }
    triangle {
      < 5.406651, -0.874944, 2.764967>,
      < 5.210217, -0.927189, 2.787150>,
      < 5.365488, -0.974301, 2.787150>
    }
    triangle {
      < 5.450083, -0.770114, 2.700042>,
      < 5.253354, -0.710421, 2.700042>,
      < 5.231207, -0.821709, 2.764967>
    }
    triangle {
      < 5.450083, -0.770114, 2.700042>,
      < 5.231207, -0.821709, 2.764967>,
      < 5.406651, -0.874944, 2.764967>
    }
    triangle {
      < 5.459021, -0.748540, 2.486032>,
      < 5.257910, -0.687518, 2.486032>,
      < 5.253354, -0.710421, 2.700042>
    }
    triangle {
      < 5.459021, -0.748540, 2.486032>,
      < 5.253354, -0.710421, 2.700042>,
      < 5.450083, -0.770114, 2.700042>
    }
    triangle {
      < 5.450083, -0.770114, 2.272216>,
      < 5.253354, -0.710421, 2.272216>,
      < 5.257910, -0.687518, 2.486032>
    }
    triangle {
      < 5.450083, -0.770114, 2.272216>,
      < 5.257910, -0.687518, 2.486032>,
      < 5.459021, -0.748540, 2.486032>
    }
    triangle {
      < 5.406651, -0.874944, 2.207291>,
      < 5.231207, -0.821709, 2.207291>,
      < 5.253354, -0.710421, 2.272216>
    }
    triangle {
      < 5.406651, -0.874944, 2.207291>,
      < 5.253354, -0.710421, 2.272216>,
      < 5.450083, -0.770114, 2.272216>
    }
    triangle {
      < 5.365488, -0.974301, 2.185108>,
      < 5.210217, -0.927189, 2.185108>,
      < 5.231207, -0.821709, 2.207291>
    }
    triangle {
      < 5.365488, -0.974301, 2.185108>,
      < 5.231207, -0.821709, 2.207291>,
      < 5.406651, -0.874944, 2.207291>
    }
    triangle {
      < 5.322682, -1.077621, 2.213441>,
      < 5.188392, -1.036873, 2.213441>,
      < 5.210217, -0.927189, 2.185108>
    }
    triangle {
      < 5.322682, -1.077621, 2.213441>,
      < 5.210217, -0.927189, 2.185108>,
      < 5.365488, -0.974301, 2.185108>
    }
    triangle {
      < 5.283298, -1.172683, 2.267810>,
      < 5.168311, -1.137792, 2.267810>,
      < 5.188392, -1.036873, 2.213441>
    }
    triangle {
      < 5.283298, -1.172683, 2.267810>,
      < 5.188392, -1.036873, 2.213441>,
      < 5.322682, -1.077621, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.168311, -1.137792, 2.267810>,
      < 5.283298, -1.172683, 2.267810>
    }
    triangle {
      < 5.168311, -1.137792, 2.704448>,
      < 5.048723, -1.126004, 2.704448>,
      < 5.048720, -1.164066, 2.704390>
    }
    triangle {
      < 5.168311, -1.137792, 2.704448>,
      < 5.048720, -1.164066, 2.704390>,
      < 5.160882, -1.175122, 2.704390>
    }
    triangle {
      < 5.188392, -1.036873, 2.758817>,
      < 5.048732, -1.023107, 2.758817>,
      < 5.048723, -1.126004, 2.704448>
    }
    triangle {
      < 5.188392, -1.036873, 2.758817>,
      < 5.048723, -1.126004, 2.704448>,
      < 5.168311, -1.137792, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.210217, -0.927189, 2.787150>,
      < 5.048739, -0.911271, 2.787150>,
      < 5.048732, -1.023107, 2.758817>
    }
    triangle {
      < 5.210217, -0.927189, 2.787150>,
      < 5.048732, -1.023107, 2.758817>,
      < 5.188392, -1.036873, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.231207, -0.821709, 2.764967>,
      < 5.048749, -0.803724, 2.764967>,
      < 5.048739, -0.911271, 2.787150>
    }
    triangle {
      < 5.231207, -0.821709, 2.764967>,
      < 5.048739, -0.911271, 2.787150>,
      < 5.210217, -0.927189, 2.787150>
    }
    triangle {
      < 5.253354, -0.710421, 2.700042>,
      < 5.048757, -0.690254, 2.700042>,
      < 5.048749, -0.803724, 2.764967>
    }
    triangle {
      < 5.253354, -0.710421, 2.700042>,
      < 5.048749, -0.803724, 2.764967>,
      < 5.231207, -0.821709, 2.764967>
    }
    triangle {
      < 5.257910, -0.687518, 2.486032>,
      < 5.048759, -0.666902, 2.486032>,
      < 5.048757, -0.690254, 2.700042>
    }
    triangle {
      < 5.257910, -0.687518, 2.486032>,
      < 5.048757, -0.690254, 2.700042>,
      < 5.253354, -0.710421, 2.700042>
    }
    triangle {
      < 5.253354, -0.710421, 2.272216>,
      < 5.048757, -0.690254, 2.272216>,
      < 5.048759, -0.666902, 2.486032>
    }
    triangle {
      < 5.253354, -0.710421, 2.272216>,
      < 5.048759, -0.666902, 2.486032>,
      < 5.257910, -0.687518, 2.486032>
    }
    triangle {
      < 5.231207, -0.821709, 2.207291>,
      < 5.048749, -0.803724, 2.207291>,
      < 5.048757, -0.690254, 2.272216>
    }
    triangle {
      < 5.231207, -0.821709, 2.207291>,
      < 5.048757, -0.690254, 2.272216>,
      < 5.253354, -0.710421, 2.272216>
    }
    triangle {
      < 5.210217, -0.927189, 2.185108>,
      < 5.048739, -0.911271, 2.185108>,
      < 5.048749, -0.803724, 2.207291>
    }
    triangle {
      < 5.210217, -0.927189, 2.185108>,
      < 5.048749, -0.803724, 2.207291>,
      < 5.231207, -0.821709, 2.207291>
    }
    triangle {
      < 5.188392, -1.036873, 2.213441>,
      < 5.048732, -1.023107, 2.213441>,
      < 5.048739, -0.911271, 2.185108>
    }
    triangle {
      < 5.188392, -1.036873, 2.213441>,
      < 5.048739, -0.911271, 2.185108>,
      < 5.210217, -0.927189, 2.185108>
    }
    triangle {
      < 5.168311, -1.137792, 2.267810>,
      < 5.048723, -1.126004, 2.267810>,
      < 5.048732, -1.023107, 2.213441>
    }
    triangle {
      < 5.168311, -1.137792, 2.267810>,
      < 5.048732, -1.023107, 2.213441>,
      < 5.188392, -1.036873, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 5.048723, -1.126004, 2.267810>,
      < 5.168311, -1.137792, 2.267810>
    }
    triangle {
      < 5.048723, -1.126004, 2.704448>,
      < 4.929134, -1.137773, 2.704448>,
      < 4.936557, -1.175104, 2.704390>
    }
    triangle {
      < 5.048723, -1.126004, 2.704448>,
      < 4.936557, -1.175104, 2.704390>,
      < 5.048720, -1.164066, 2.704390>
    }
    triangle {
      < 5.048732, -1.023107, 2.758817>,
      < 4.909069, -1.036851, 2.758817>,
      < 4.929134, -1.137773, 2.704448>
    }
    triangle {
      < 5.048732, -1.023107, 2.758817>,
      < 4.929134, -1.137773, 2.704448>,
      < 5.048723, -1.126004, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 5.048739, -0.911271, 2.787150>,
      < 4.887259, -0.927164, 2.787150>,
      < 4.909069, -1.036851, 2.758817>
    }
    triangle {
      < 5.048739, -0.911271, 2.787150>,
      < 4.909069, -1.036851, 2.758817>,
      < 5.048732, -1.023107, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 5.048749, -0.803724, 2.764967>,
      < 4.866287, -0.821680, 2.764967>,
      < 4.887259, -0.927164, 2.787150>
    }
    triangle {
      < 5.048749, -0.803724, 2.764967>,
      < 4.887259, -0.927164, 2.787150>,
      < 5.048739, -0.911271, 2.787150>
    }
    triangle {
      < 5.048757, -0.690254, 2.700042>,
      < 4.844159, -0.710389, 2.700042>,
      < 4.866287, -0.821680, 2.764967>
    }
    triangle {
      < 5.048757, -0.690254, 2.700042>,
      < 4.866287, -0.821680, 2.764967>,
      < 5.048749, -0.803724, 2.764967>
    }
    triangle {
      < 5.048759, -0.666902, 2.486032>,
      < 4.839604, -0.687485, 2.486032>,
      < 4.844159, -0.710389, 2.700042>
    }
    triangle {
      < 5.048759, -0.666902, 2.486032>,
      < 4.844159, -0.710389, 2.700042>,
      < 5.048757, -0.690254, 2.700042>
    }
    triangle {
      < 5.048757, -0.690254, 2.272216>,
      < 4.844159, -0.710389, 2.272216>,
      < 4.839604, -0.687485, 2.486032>
    }
    triangle {
      < 5.048757, -0.690254, 2.272216>,
      < 4.839604, -0.687485, 2.486032>,
      < 5.048759, -0.666902, 2.486032>
    }
    triangle {
      < 5.048749, -0.803724, 2.207291>,
      < 4.866287, -0.821680, 2.207291>,
      < 4.844159, -0.710389, 2.272216>
    }
    triangle {
      < 5.048749, -0.803724, 2.207291>,
      < 4.844159, -0.710389, 2.272216>,
      < 5.048757, -0.690254, 2.272216>
    }
    triangle {
      < 5.048739, -0.911271, 2.185108>,
      < 4.887259, -0.927164, 2.185108>,
      < 4.866287, -0.821680, 2.207291>
    }
    triangle {
      < 5.048739, -0.911271, 2.185108>,
      < 4.866287, -0.821680, 2.207291>,
      < 5.048749, -0.803724, 2.207291>
    }
    triangle {
      < 5.048732, -1.023107, 2.213441>,
      < 4.909069, -1.036851, 2.213441>,
      < 4.887259, -0.927164, 2.185108>
    }
    triangle {
      < 5.048732, -1.023107, 2.213441>,
      < 4.887259, -0.927164, 2.185108>,
      < 5.048739, -0.911271, 2.185108>
    }
    triangle {
      < 5.048723, -1.126004, 2.267810>,
      < 4.929134, -1.137773, 2.267810>,
      < 4.909069, -1.036851, 2.213441>
    }
    triangle {
      < 5.048723, -1.126004, 2.267810>,
      < 4.909069, -1.036851, 2.213441>,
      < 5.048732, -1.023107, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.929134, -1.137773, 2.267810>,
      < 5.048723, -1.126004, 2.267810>
    }
    triangle {
      < 4.929134, -1.137773, 2.704448>,
      < 4.814141, -1.172645, 2.704448>,
      < 4.828702, -1.207811, 2.704390>
    }
    triangle {
      < 4.929134, -1.137773, 2.704448>,
      < 4.828702, -1.207811, 2.704390>,
      < 4.936557, -1.175104, 2.704390>
    }
    triangle {
      < 4.909069, -1.036851, 2.758817>,
      < 4.774771, -1.077578, 2.758817>,
      < 4.814141, -1.172645, 2.704448>
    }
    triangle {
      < 4.909069, -1.036851, 2.758817>,
      < 4.814141, -1.172645, 2.704448>,
      < 4.929134, -1.137773, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.887259, -0.927164, 2.787150>,
      < 4.731982, -0.974252, 2.787150>,
      < 4.774771, -1.077578, 2.758817>
    }
    triangle {
      < 4.887259, -0.927164, 2.787150>,
      < 4.774771, -1.077578, 2.758817>,
      < 4.909069, -1.036851, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.866287, -0.821680, 2.764967>,
      < 4.690834, -0.874888, 2.764967>,
      < 4.731982, -0.974252, 2.787150>
    }
    triangle {
      < 4.866287, -0.821680, 2.764967>,
      < 4.731982, -0.974252, 2.787150>,
      < 4.887259, -0.927164, 2.787150>
    }
    triangle {
      < 4.844159, -0.710389, 2.700042>,
      < 4.647419, -0.770051, 2.700042>,
      < 4.690834, -0.874888, 2.764967>
    }
    triangle {
      < 4.844159, -0.710389, 2.700042>,
      < 4.690834, -0.874888, 2.764967>,
      < 4.866287, -0.821680, 2.764967>
    }
    triangle {
      < 4.839604, -0.687485, 2.486032>,
      < 4.638484, -0.748475, 2.486032>,
      < 4.647419, -0.770051, 2.700042>
    }
    triangle {
      < 4.839604, -0.687485, 2.486032>,
      < 4.647419, -0.770051, 2.700042>,
      < 4.844159, -0.710389, 2.700042>
    }
    triangle {
      < 4.844159, -0.710389, 2.272216>,
      < 4.647419, -0.770051, 2.272216>,
      < 4.638484, -0.748475, 2.486032>
    }
    triangle {
      < 4.844159, -0.710389, 2.272216>,
      < 4.638484, -0.748475, 2.486032>,
      < 4.839604, -0.687485, 2.486032>
    }
    triangle {
      < 4.866287, -0.821680, 2.207291>,
      < 4.690834, -0.874888, 2.207291>,
      < 4.647419, -0.770051, 2.272216>
    }
    triangle {
      < 4.866287, -0.821680, 2.207291>,
      < 4.647419, -0.770051, 2.272216>,
      < 4.844159, -0.710389, 2.272216>
    }
    triangle {
      < 4.887259, -0.927164, 2.185108>,
      < 4.731982, -0.974252, 2.185108>,
      < 4.690834, -0.874888, 2.207291>
    }
    triangle {
      < 4.887259, -0.927164, 2.185108>,
      < 4.690834, -0.874888, 2.207291>,
      < 4.866287, -0.821680, 2.207291>
    }
    triangle {
      < 4.909069, -1.036851, 2.213441>,
      < 4.774771, -1.077578, 2.213441>,
      < 4.731982, -0.974252, 2.185108>
    }
    triangle {
      < 4.909069, -1.036851, 2.213441>,
      < 4.731982, -0.974252, 2.185108>,
      < 4.887259, -0.927164, 2.185108>
    }
    triangle {
      < 4.929134, -1.137773, 2.267810>,
      < 4.814141, -1.172645, 2.267810>,
      < 4.774771, -1.077578, 2.213441>
    }
    triangle {
      < 4.929134, -1.137773, 2.267810>,
      < 4.774771, -1.077578, 2.213441>,
      < 4.909069, -1.036851, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.814141, -1.172645, 2.267810>,
      < 4.929134, -1.137773, 2.267810>
    }
    triangle {
      < 4.814141, -1.172645, 2.704448>,
      < 4.708158, -1.229283, 2.704448>,
      < 4.729301, -1.260931, 2.704390>
    }
    triangle {
      < 4.814141, -1.172645, 2.704448>,
      < 4.729301, -1.260931, 2.704390>,
      < 4.828702, -1.207811, 2.704390>
    }
    triangle {
      < 4.774771, -1.077578, 2.758817>,
      < 4.650999, -1.143721, 2.758817>,
      < 4.708158, -1.229283, 2.704448>
    }
    triangle {
      < 4.774771, -1.077578, 2.758817>,
      < 4.708158, -1.229283, 2.704448>,
      < 4.814141, -1.172645, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.731982, -0.974252, 2.787150>,
      < 4.588875, -1.050729, 2.787150>,
      < 4.650999, -1.143721, 2.758817>
    }
    triangle {
      < 4.731982, -0.974252, 2.787150>,
      < 4.650999, -1.143721, 2.758817>,
      < 4.774771, -1.077578, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.690834, -0.874888, 2.764967>,
      < 4.529133, -0.961300, 2.764967>,
      < 4.588875, -1.050729, 2.787150>
    }
    triangle {
      < 4.690834, -0.874888, 2.764967>,
      < 4.588875, -1.050729, 2.787150>,
      < 4.731982, -0.974252, 2.787150>
    }
    triangle {
      < 4.647419, -0.770051, 2.700042>,
      < 4.466101, -0.866948, 2.700042>,
      < 4.529133, -0.961300, 2.764967>
    }
    triangle {
      < 4.647419, -0.770051, 2.700042>,
      < 4.529133, -0.961300, 2.764967>,
      < 4.690834, -0.874888, 2.764967>
    }
    triangle {
      < 4.638484, -0.748475, 2.486032>,
      < 4.453129, -0.847530, 2.486032>,
      < 4.466101, -0.866948, 2.700042>
    }
    triangle {
      < 4.638484, -0.748475, 2.486032>,
      < 4.466101, -0.866948, 2.700042>,
      < 4.647419, -0.770051, 2.700042>
    }
    triangle {
      < 4.647419, -0.770051, 2.272216>,
      < 4.466101, -0.866948, 2.272216>,
      < 4.453129, -0.847530, 2.486032>
    }
    triangle {
      < 4.647419, -0.770051, 2.272216>,
      < 4.453129, -0.847530, 2.486032>,
      < 4.638484, -0.748475, 2.486032>
    }
    triangle {
      < 4.690834, -0.874888, 2.207291>,
      < 4.529133, -0.961300, 2.207291>,
      < 4.466101, -0.866948, 2.272216>
    }
    triangle {
      < 4.690834, -0.874888, 2.207291>,
      < 4.466101, -0.866948, 2.272216>,
      < 4.647419, -0.770051, 2.272216>
    }
    triangle {
      < 4.731982, -0.974252, 2.185108>,
      < 4.588875, -1.050729, 2.185108>,
      < 4.529133, -0.961300, 2.207291>
    }
    triangle {
      < 4.731982, -0.974252, 2.185108>,
      < 4.529133, -0.961300, 2.207291>,
      < 4.690834, -0.874888, 2.207291>
    }
    triangle {
      < 4.774771, -1.077578, 2.213441>,
      < 4.650999, -1.143721, 2.213441>,
      < 4.588875, -1.050729, 2.185108>
    }
    triangle {
      < 4.774771, -1.077578, 2.213441>,
      < 4.588875, -1.050729, 2.185108>,
      < 4.731982, -0.974252, 2.185108>
    }
    triangle {
      < 4.814141, -1.172645, 2.267810>,
      < 4.708158, -1.229283, 2.267810>,
      < 4.650999, -1.143721, 2.213441>
    }
    triangle {
      < 4.814141, -1.172645, 2.267810>,
      < 4.650999, -1.143721, 2.213441>,
      < 4.774771, -1.077578, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.708158, -1.229283, 2.267810>,
      < 4.814141, -1.172645, 2.267810>
    }
    triangle {
      < 4.708158, -1.229283, 2.704448>,
      < 4.615262, -1.305506, 2.704448>,
      < 4.642173, -1.332422, 2.704390>
    }
    triangle {
      < 4.708158, -1.229283, 2.704448>,
      < 4.642173, -1.332422, 2.704390>,
      < 4.729301, -1.260931, 2.704390>
    }
    triangle {
      < 4.650999, -1.143721, 2.758817>,
      < 4.542509, -1.232740, 2.758817>,
      < 4.615262, -1.305506, 2.704448>
    }
    triangle {
      < 4.650999, -1.143721, 2.758817>,
      < 4.615262, -1.305506, 2.704448>,
      < 4.708158, -1.229283, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.588875, -1.050729, 2.787150>,
      < 4.463437, -1.153654, 2.787150>,
      < 4.542509, -1.232740, 2.758817>
    }
    triangle {
      < 4.588875, -1.050729, 2.787150>,
      < 4.542509, -1.232740, 2.758817>,
      < 4.650999, -1.143721, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.529133, -0.961300, 2.764967>,
      < 4.387395, -1.077599, 2.764967>,
      < 4.463437, -1.153654, 2.787150>
    }
    triangle {
      < 4.529133, -0.961300, 2.764967>,
      < 4.463437, -1.153654, 2.787150>,
      < 4.588875, -1.050729, 2.787150>
    }
    triangle {
      < 4.466101, -0.866948, 2.700042>,
      < 4.307168, -0.997356, 2.700042>,
      < 4.387395, -1.077599, 2.764967>
    }
    triangle {
      < 4.466101, -0.866948, 2.700042>,
      < 4.387395, -1.077599, 2.764967>,
      < 4.529133, -0.961300, 2.764967>
    }
    triangle {
      < 4.453129, -0.847530, 2.486032>,
      < 4.290657, -0.980842, 2.486032>,
      < 4.307168, -0.997356, 2.700042>
    }
    triangle {
      < 4.453129, -0.847530, 2.486032>,
      < 4.307168, -0.997356, 2.700042>,
      < 4.466101, -0.866948, 2.700042>
    }
    triangle {
      < 4.466101, -0.866948, 2.272216>,
      < 4.307168, -0.997356, 2.272216>,
      < 4.290657, -0.980842, 2.486032>
    }
    triangle {
      < 4.466101, -0.866948, 2.272216>,
      < 4.290657, -0.980842, 2.486032>,
      < 4.453129, -0.847530, 2.486032>
    }
    triangle {
      < 4.529133, -0.961300, 2.207291>,
      < 4.387395, -1.077599, 2.207291>,
      < 4.307168, -0.997356, 2.272216>
    }
    triangle {
      < 4.529133, -0.961300, 2.207291>,
      < 4.307168, -0.997356, 2.272216>,
      < 4.466101, -0.866948, 2.272216>
    }
    triangle {
      < 4.588875, -1.050729, 2.185108>,
      < 4.463437, -1.153654, 2.185108>,
      < 4.387395, -1.077599, 2.207291>
    }
    triangle {
      < 4.588875, -1.050729, 2.185108>,
      < 4.387395, -1.077599, 2.207291>,
      < 4.529133, -0.961300, 2.207291>
    }
    triangle {
      < 4.650999, -1.143721, 2.213441>,
      < 4.542509, -1.232740, 2.213441>,
      < 4.463437, -1.153654, 2.185108>
    }
    triangle {
      < 4.650999, -1.143721, 2.213441>,
      < 4.463437, -1.153654, 2.185108>,
      < 4.588875, -1.050729, 2.185108>
    }
    triangle {
      < 4.708158, -1.229283, 2.267810>,
      < 4.615262, -1.305506, 2.267810>,
      < 4.542509, -1.232740, 2.213441>
    }
    triangle {
      < 4.708158, -1.229283, 2.267810>,
      < 4.542509, -1.232740, 2.213441>,
      < 4.650999, -1.143721, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.615262, -1.305506, 2.267810>,
      < 4.708158, -1.229283, 2.267810>
    }
    triangle {
      < 4.615262, -1.305506, 2.704448>,
      < 4.539020, -1.398389, 2.704448>,
      < 4.570664, -1.419538, 2.704390>
    }
    triangle {
      < 4.615262, -1.305506, 2.704448>,
      < 4.570664, -1.419538, 2.704390>,
      < 4.642173, -1.332422, 2.704390>
    }
    triangle {
      < 4.542509, -1.232740, 2.758817>,
      < 4.453470, -1.341214, 2.758817>,
      < 4.539020, -1.398389, 2.704448>
    }
    triangle {
      < 4.542509, -1.232740, 2.758817>,
      < 4.539020, -1.398389, 2.704448>,
      < 4.615262, -1.305506, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.463437, -1.153654, 2.787150>,
      < 4.360487, -1.279073, 2.787150>,
      < 4.453470, -1.341214, 2.758817>
    }
    triangle {
      < 4.463437, -1.153654, 2.787150>,
      < 4.453470, -1.341214, 2.758817>,
      < 4.542509, -1.232740, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.387395, -1.077599, 2.764967>,
      < 4.271070, -1.219314, 2.764967>,
      < 4.360487, -1.279073, 2.787150>
    }
    triangle {
      < 4.387395, -1.077599, 2.764967>,
      < 4.360487, -1.279073, 2.787150>,
      < 4.463437, -1.153654, 2.787150>
    }
    triangle {
      < 4.307168, -0.997356, 2.700042>,
      < 4.176731, -1.156265, 2.700042>,
      < 4.271070, -1.219314, 2.764967>
    }
    triangle {
      < 4.307168, -0.997356, 2.700042>,
      < 4.271070, -1.219314, 2.764967>,
      < 4.387395, -1.077599, 2.764967>
    }
    triangle {
      < 4.290657, -0.980842, 2.486032>,
      < 4.157315, -1.143289, 2.486032>,
      < 4.176731, -1.156265, 2.700042>
    }
    triangle {
      < 4.290657, -0.980842, 2.486032>,
      < 4.176731, -1.156265, 2.700042>,
      < 4.307168, -0.997356, 2.700042>
    }
    triangle {
      < 4.307168, -0.997356, 2.272216>,
      < 4.176731, -1.156265, 2.272216>,
      < 4.157315, -1.143289, 2.486032>
    }
    triangle {
      < 4.307168, -0.997356, 2.272216>,
      < 4.157315, -1.143289, 2.486032>,
      < 4.290657, -0.980842, 2.486032>
    }
    triangle {
      < 4.387395, -1.077599, 2.207291>,
      < 4.271070, -1.219314, 2.207291>,
      < 4.176731, -1.156265, 2.272216>
    }
    triangle {
      < 4.387395, -1.077599, 2.207291>,
      < 4.176731, -1.156265, 2.272216>,
      < 4.307168, -0.997356, 2.272216>
    }
    triangle {
      < 4.463437, -1.153654, 2.185108>,
      < 4.360487, -1.279073, 2.185108>,
      < 4.271070, -1.219314, 2.207291>
    }
    triangle {
      < 4.463437, -1.153654, 2.185108>,
      < 4.271070, -1.219314, 2.207291>,
      < 4.387395, -1.077599, 2.207291>
    }
    triangle {
      < 4.542509, -1.232740, 2.213441>,
      < 4.453470, -1.341214, 2.213441>,
      < 4.360487, -1.279073, 2.185108>
    }
    triangle {
      < 4.542509, -1.232740, 2.213441>,
      < 4.360487, -1.279073, 2.185108>,
      < 4.463437, -1.153654, 2.185108>
    }
    triangle {
      < 4.615262, -1.305506, 2.267810>,
      < 4.539020, -1.398389, 2.267810>,
      < 4.453470, -1.341214, 2.213441>
    }
    triangle {
      < 4.615262, -1.305506, 2.267810>,
      < 4.453470, -1.341214, 2.213441>,
      < 4.542509, -1.232740, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.539020, -1.398389, 2.267810>,
      < 4.615262, -1.305506, 2.267810>
    }
    triangle {
      < 4.539020, -1.398389, 2.704448>,
      < 4.482363, -1.504360, 2.704448>,
      < 4.517527, -1.518929, 2.704390>
    }
    triangle {
      < 4.539020, -1.398389, 2.704448>,
      < 4.517527, -1.518929, 2.704390>,
      < 4.570664, -1.419538, 2.704390>
    }
    triangle {
      < 4.453470, -1.341214, 2.758817>,
      < 4.387302, -1.464975, 2.758817>,
      < 4.482363, -1.504360, 2.704448>
    }
    triangle {
      < 4.453470, -1.341214, 2.758817>,
      < 4.482363, -1.504360, 2.704448>,
      < 4.539020, -1.398389, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.360487, -1.279073, 2.787150>,
      < 4.283986, -1.422167, 2.787150>,
      < 4.387302, -1.464975, 2.758817>
    }
    triangle {
      < 4.360487, -1.279073, 2.787150>,
      < 4.387302, -1.464975, 2.758817>,
      < 4.453470, -1.341214, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.271070, -1.219314, 2.764967>,
      < 4.184628, -1.381000, 2.764967>,
      < 4.283986, -1.422167, 2.787150>
    }
    triangle {
      < 4.271070, -1.219314, 2.764967>,
      < 4.283986, -1.422167, 2.787150>,
      < 4.360487, -1.279073, 2.787150>
    }
    triangle {
      < 4.176731, -1.156265, 2.700042>,
      < 4.079800, -1.337567, 2.700042>,
      < 4.184628, -1.381000, 2.764967>
    }
    triangle {
      < 4.176731, -1.156265, 2.700042>,
      < 4.184628, -1.381000, 2.764967>,
      < 4.271070, -1.219314, 2.764967>
    }
    triangle {
      < 4.157315, -1.143289, 2.486032>,
      < 4.058226, -1.328627, 2.486032>,
      < 4.079800, -1.337567, 2.700042>
    }
    triangle {
      < 4.157315, -1.143289, 2.486032>,
      < 4.079800, -1.337567, 2.700042>,
      < 4.176731, -1.156265, 2.700042>
    }
    triangle {
      < 4.176731, -1.156265, 2.272216>,
      < 4.079800, -1.337567, 2.272216>,
      < 4.058226, -1.328627, 2.486032>
    }
    triangle {
      < 4.176731, -1.156265, 2.272216>,
      < 4.058226, -1.328627, 2.486032>,
      < 4.157315, -1.143289, 2.486032>
    }
    triangle {
      < 4.271070, -1.219314, 2.207291>,
      < 4.184628, -1.381000, 2.207291>,
      < 4.079800, -1.337567, 2.272216>
    }
    triangle {
      < 4.271070, -1.219314, 2.207291>,
      < 4.079800, -1.337567, 2.272216>,
      < 4.176731, -1.156265, 2.272216>
    }
    triangle {
      < 4.360487, -1.279073, 2.185108>,
      < 4.283986, -1.422167, 2.185108>,
      < 4.184628, -1.381000, 2.207291>
    }
    triangle {
      < 4.360487, -1.279073, 2.185108>,
      < 4.184628, -1.381000, 2.207291>,
      < 4.271070, -1.219314, 2.207291>
    }
    triangle {
      < 4.453470, -1.341214, 2.213441>,
      < 4.387302, -1.464975, 2.213441>,
      < 4.283986, -1.422167, 2.185108>
    }
    triangle {
      < 4.453470, -1.341214, 2.213441>,
      < 4.283986, -1.422167, 2.185108>,
      < 4.360487, -1.279073, 2.185108>
    }
    triangle {
      < 4.539020, -1.398389, 2.267810>,
      < 4.482363, -1.504360, 2.267810>,
      < 4.387302, -1.464975, 2.213441>
    }
    triangle {
      < 4.539020, -1.398389, 2.267810>,
      < 4.387302, -1.464975, 2.213441>,
      < 4.453470, -1.341214, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.482363, -1.504360, 2.267810>,
      < 4.539020, -1.398389, 2.267810>
    }
    triangle {
      < 4.482363, -1.504360, 2.704448>,
      < 4.447470, -1.619349, 2.704448>,
      < 4.484798, -1.626778, 2.704390>
    }
    triangle {
      < 4.482363, -1.504360, 2.704448>,
      < 4.484798, -1.626778, 2.704390>,
      < 4.517527, -1.518929, 2.704390>
    }
    triangle {
      < 4.387302, -1.464975, 2.758817>,
      < 4.346551, -1.599264, 2.758817>,
      < 4.447470, -1.619349, 2.704448>
    }
    triangle {
      < 4.387302, -1.464975, 2.758817>,
      < 4.447470, -1.619349, 2.704448>,
      < 4.482363, -1.504360, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.283986, -1.422167, 2.787150>,
      < 4.236867, -1.577435, 2.787150>,
      < 4.346551, -1.599264, 2.758817>
    }
    triangle {
      < 4.283986, -1.422167, 2.787150>,
      < 4.346551, -1.599264, 2.758817>,
      < 4.387302, -1.464975, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.184628, -1.381000, 2.764967>,
      < 4.131389, -1.556443, 2.764967>,
      < 4.236867, -1.577435, 2.787150>
    }
    triangle {
      < 4.184628, -1.381000, 2.764967>,
      < 4.236867, -1.577435, 2.787150>,
      < 4.283986, -1.422167, 2.787150>
    }
    triangle {
      < 4.079800, -1.337567, 2.700042>,
      < 4.020102, -1.534295, 2.700042>,
      < 4.131389, -1.556443, 2.764967>
    }
    triangle {
      < 4.079800, -1.337567, 2.700042>,
      < 4.131389, -1.556443, 2.764967>,
      < 4.184628, -1.381000, 2.764967>
    }
    triangle {
      < 4.058226, -1.328627, 2.486032>,
      < 3.997199, -1.529736, 2.486032>,
      < 4.020102, -1.534295, 2.700042>
    }
    triangle {
      < 4.058226, -1.328627, 2.486032>,
      < 4.020102, -1.534295, 2.700042>,
      < 4.079800, -1.337567, 2.700042>
    }
    triangle {
      < 4.079800, -1.337567, 2.272216>,
      < 4.020102, -1.534295, 2.272216>,
      < 3.997199, -1.529736, 2.486032>
    }
    triangle {
      < 4.079800, -1.337567, 2.272216>,
      < 3.997199, -1.529736, 2.486032>,
      < 4.058226, -1.328627, 2.486032>
    }
    triangle {
      < 4.184628, -1.381000, 2.207291>,
      < 4.131389, -1.556443, 2.207291>,
      < 4.020102, -1.534295, 2.272216>
    }
    triangle {
      < 4.184628, -1.381000, 2.207291>,
      < 4.020102, -1.534295, 2.272216>,
      < 4.079800, -1.337567, 2.272216>
    }
    triangle {
      < 4.283986, -1.422167, 2.185108>,
      < 4.236867, -1.577435, 2.185108>,
      < 4.131389, -1.556443, 2.207291>
    }
    triangle {
      < 4.283986, -1.422167, 2.185108>,
      < 4.131389, -1.556443, 2.207291>,
      < 4.184628, -1.381000, 2.207291>
    }
    triangle {
      < 4.387302, -1.464975, 2.213441>,
      < 4.346551, -1.599264, 2.213441>,
      < 4.236867, -1.577435, 2.185108>
    }
    triangle {
      < 4.387302, -1.464975, 2.213441>,
      < 4.236867, -1.577435, 2.185108>,
      < 4.283986, -1.422167, 2.185108>
    }
    triangle {
      < 4.482363, -1.504360, 2.267810>,
      < 4.447470, -1.619349, 2.267810>,
      < 4.346551, -1.599264, 2.213441>
    }
    triangle {
      < 4.482363, -1.504360, 2.267810>,
      < 4.346551, -1.599264, 2.213441>,
      < 4.387302, -1.464975, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.447470, -1.619349, 2.267810>,
      < 4.482363, -1.504360, 2.267810>
    }
    triangle {
      < 4.447470, -1.619349, 2.704448>,
      < 4.435678, -1.738935, 2.704448>,
      < 4.473741, -1.738939, 2.704390>
    }
    triangle {
      < 4.447470, -1.619349, 2.704448>,
      < 4.473741, -1.738939, 2.704390>,
      < 4.484798, -1.626778, 2.704390>
    }
    triangle {
      < 4.346551, -1.599264, 2.758817>,
      < 4.332782, -1.738925, 2.758817>,
      < 4.435678, -1.738935, 2.704448>
    }
    triangle {
      < 4.346551, -1.599264, 2.758817>,
      < 4.435678, -1.738935, 2.704448>,
      < 4.447470, -1.619349, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.236867, -1.577435, 2.787150>,
      < 4.220947, -1.738913, 2.787150>,
      < 4.332782, -1.738925, 2.758817>
    }
    triangle {
      < 4.236867, -1.577435, 2.787150>,
      < 4.332782, -1.738925, 2.758817>,
      < 4.346551, -1.599264, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.131389, -1.556443, 2.764967>,
      < 4.113399, -1.738901, 2.764967>,
      < 4.220947, -1.738913, 2.787150>
    }
    triangle {
      < 4.131389, -1.556443, 2.764967>,
      < 4.220947, -1.738913, 2.787150>,
      < 4.236867, -1.577435, 2.787150>
    }
    triangle {
      < 4.020102, -1.534295, 2.700042>,
      < 3.999928, -1.738889, 2.700042>,
      < 4.113399, -1.738901, 2.764967>
    }
    triangle {
      < 4.020102, -1.534295, 2.700042>,
      < 4.113399, -1.738901, 2.764967>,
      < 4.131389, -1.556443, 2.764967>
    }
    triangle {
      < 3.997199, -1.529736, 2.486032>,
      < 3.976577, -1.738887, 2.486032>,
      < 3.999928, -1.738889, 2.700042>
    }
    triangle {
      < 3.997199, -1.529736, 2.486032>,
      < 3.999928, -1.738889, 2.700042>,
      < 4.020102, -1.534295, 2.700042>
    }
    triangle {
      < 4.020102, -1.534295, 2.272216>,
      < 3.999928, -1.738889, 2.272216>,
      < 3.976577, -1.738887, 2.486032>
    }
    triangle {
      < 4.020102, -1.534295, 2.272216>,
      < 3.976577, -1.738887, 2.486032>,
      < 3.997199, -1.529736, 2.486032>
    }
    triangle {
      < 4.131389, -1.556443, 2.207291>,
      < 4.113399, -1.738901, 2.207291>,
      < 3.999928, -1.738889, 2.272216>
    }
    triangle {
      < 4.131389, -1.556443, 2.207291>,
      < 3.999928, -1.738889, 2.272216>,
      < 4.020102, -1.534295, 2.272216>
    }
    triangle {
      < 4.236867, -1.577435, 2.185108>,
      < 4.220947, -1.738913, 2.185108>,
      < 4.113399, -1.738901, 2.207291>
    }
    triangle {
      < 4.236867, -1.577435, 2.185108>,
      < 4.113399, -1.738901, 2.207291>,
      < 4.131389, -1.556443, 2.207291>
    }
    triangle {
      < 4.346551, -1.599264, 2.213441>,
      < 4.332782, -1.738925, 2.213441>,
      < 4.220947, -1.738913, 2.185108>
    }
    triangle {
      < 4.346551, -1.599264, 2.213441>,
      < 4.220947, -1.738913, 2.185108>,
      < 4.236867, -1.577435, 2.185108>
    }
    triangle {
      < 4.447470, -1.619349, 2.267810>,
      < 4.435678, -1.738935, 2.267810>,
      < 4.332782, -1.738925, 2.213441>
    }
    triangle {
      < 4.447470, -1.619349, 2.267810>,
      < 4.332782, -1.738925, 2.213441>,
      < 4.346551, -1.599264, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.435678, -1.738935, 2.267810>,
      < 4.447470, -1.619349, 2.267810>
    }
    triangle {
      < 4.435678, -1.738935, 2.704448>,
      < 4.447444, -1.858524, 2.704448>,
      < 4.484776, -1.851103, 2.704390>
    }
    triangle {
      < 4.435678, -1.738935, 2.704448>,
      < 4.484776, -1.851103, 2.704390>,
      < 4.473741, -1.738939, 2.704390>
    }
    triangle {
      < 4.332782, -1.738925, 2.758817>,
      < 4.346522, -1.878587, 2.758817>,
      < 4.447444, -1.858524, 2.704448>
    }
    triangle {
      < 4.332782, -1.738925, 2.758817>,
      < 4.447444, -1.858524, 2.704448>,
      < 4.435678, -1.738935, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.220947, -1.738913, 2.787150>,
      < 4.236834, -1.900394, 2.787150>,
      < 4.346522, -1.878587, 2.758817>
    }
    triangle {
      < 4.220947, -1.738913, 2.787150>,
      < 4.346522, -1.878587, 2.758817>,
      < 4.332782, -1.738925, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.113399, -1.738901, 2.764967>,
      < 4.131350, -1.921364, 2.764967>,
      < 4.236834, -1.900394, 2.787150>
    }
    triangle {
      < 4.113399, -1.738901, 2.764967>,
      < 4.236834, -1.900394, 2.787150>,
      < 4.220947, -1.738913, 2.787150>
    }
    triangle {
      < 3.999928, -1.738889, 2.700042>,
      < 4.020058, -1.943489, 2.700042>,
      < 4.131350, -1.921364, 2.764967>
    }
    triangle {
      < 3.999928, -1.738889, 2.700042>,
      < 4.131350, -1.921364, 2.764967>,
      < 4.113399, -1.738901, 2.764967>
    }
    triangle {
      < 3.976577, -1.738887, 2.486032>,
      < 3.997154, -1.948042, 2.486032>,
      < 4.020058, -1.943489, 2.700042>
    }
    triangle {
      < 3.976577, -1.738887, 2.486032>,
      < 4.020058, -1.943489, 2.700042>,
      < 3.999928, -1.738889, 2.700042>
    }
    triangle {
      < 3.999928, -1.738889, 2.272216>,
      < 4.020058, -1.943489, 2.272216>,
      < 3.997154, -1.948042, 2.486032>
    }
    triangle {
      < 3.999928, -1.738889, 2.272216>,
      < 3.997154, -1.948042, 2.486032>,
      < 3.976577, -1.738887, 2.486032>
    }
    triangle {
      < 4.113399, -1.738901, 2.207291>,
      < 4.131350, -1.921364, 2.207291>,
      < 4.020058, -1.943489, 2.272216>
    }
    triangle {
      < 4.113399, -1.738901, 2.207291>,
      < 4.020058, -1.943489, 2.272216>,
      < 3.999928, -1.738889, 2.272216>
    }
    triangle {
      < 4.220947, -1.738913, 2.185108>,
      < 4.236834, -1.900394, 2.185108>,
      < 4.131350, -1.921364, 2.207291>
    }
    triangle {
      < 4.220947, -1.738913, 2.185108>,
      < 4.131350, -1.921364, 2.207291>,
      < 4.113399, -1.738901, 2.207291>
    }
    triangle {
      < 4.332782, -1.738925, 2.213441>,
      < 4.346522, -1.878587, 2.213441>,
      < 4.236834, -1.900394, 2.185108>
    }
    triangle {
      < 4.332782, -1.738925, 2.213441>,
      < 4.236834, -1.900394, 2.185108>,
      < 4.220947, -1.738913, 2.185108>
    }
    triangle {
      < 4.435678, -1.738935, 2.267810>,
      < 4.447444, -1.858524, 2.267810>,
      < 4.346522, -1.878587, 2.213441>
    }
    triangle {
      < 4.435678, -1.738935, 2.267810>,
      < 4.346522, -1.878587, 2.213441>,
      < 4.332782, -1.738925, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.447444, -1.858524, 2.267810>,
      < 4.435678, -1.738935, 2.267810>
    }
    triangle {
      < 4.447444, -1.858524, 2.704448>,
      < 4.482315, -1.973520, 2.704448>,
      < 4.517481, -1.958958, 2.704390>
    }
    triangle {
      < 4.447444, -1.858524, 2.704448>,
      < 4.517481, -1.958958, 2.704390>,
      < 4.484776, -1.851103, 2.704390>
    }
    triangle {
      < 4.346522, -1.878587, 2.758817>,
      < 4.387245, -2.012886, 2.758817>,
      < 4.482315, -1.973520, 2.704448>
    }
    triangle {
      < 4.346522, -1.878587, 2.758817>,
      < 4.482315, -1.973520, 2.704448>,
      < 4.447444, -1.858524, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.236834, -1.900394, 2.787150>,
      < 4.283918, -2.055673, 2.787150>,
      < 4.387245, -2.012886, 2.758817>
    }
    triangle {
      < 4.236834, -1.900394, 2.787150>,
      < 4.387245, -2.012886, 2.758817>,
      < 4.346522, -1.878587, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.131350, -1.921364, 2.764967>,
      < 4.184553, -2.096818, 2.764967>,
      < 4.283918, -2.055673, 2.787150>
    }
    triangle {
      < 4.131350, -1.921364, 2.764967>,
      < 4.283918, -2.055673, 2.787150>,
      < 4.236834, -1.900394, 2.787150>
    }
    triangle {
      < 4.020058, -1.943489, 2.700042>,
      < 4.079716, -2.140229, 2.700042>,
      < 4.184553, -2.096818, 2.764967>
    }
    triangle {
      < 4.020058, -1.943489, 2.700042>,
      < 4.184553, -2.096818, 2.764967>,
      < 4.131350, -1.921364, 2.764967>
    }
    triangle {
      < 3.997154, -1.948042, 2.486032>,
      < 4.058140, -2.149163, 2.486032>,
      < 4.079716, -2.140229, 2.700042>
    }
    triangle {
      < 3.997154, -1.948042, 2.486032>,
      < 4.079716, -2.140229, 2.700042>,
      < 4.020058, -1.943489, 2.700042>
    }
    triangle {
      < 4.020058, -1.943489, 2.272216>,
      < 4.079716, -2.140229, 2.272216>,
      < 4.058140, -2.149163, 2.486032>
    }
    triangle {
      < 4.020058, -1.943489, 2.272216>,
      < 4.058140, -2.149163, 2.486032>,
      < 3.997154, -1.948042, 2.486032>
    }
    triangle {
      < 4.131350, -1.921364, 2.207291>,
      < 4.184553, -2.096818, 2.207291>,
      < 4.079716, -2.140229, 2.272216>
    }
    triangle {
      < 4.131350, -1.921364, 2.207291>,
      < 4.079716, -2.140229, 2.272216>,
      < 4.020058, -1.943489, 2.272216>
    }
    triangle {
      < 4.236834, -1.900394, 2.185108>,
      < 4.283918, -2.055673, 2.185108>,
      < 4.184553, -2.096818, 2.207291>
    }
    triangle {
      < 4.236834, -1.900394, 2.185108>,
      < 4.184553, -2.096818, 2.207291>,
      < 4.131350, -1.921364, 2.207291>
    }
    triangle {
      < 4.346522, -1.878587, 2.213441>,
      < 4.387245, -2.012886, 2.213441>,
      < 4.283918, -2.055673, 2.185108>
    }
    triangle {
      < 4.346522, -1.878587, 2.213441>,
      < 4.283918, -2.055673, 2.185108>,
      < 4.236834, -1.900394, 2.185108>
    }
    triangle {
      < 4.447444, -1.858524, 2.267810>,
      < 4.482315, -1.973520, 2.267810>,
      < 4.387245, -2.012886, 2.213441>
    }
    triangle {
      < 4.447444, -1.858524, 2.267810>,
      < 4.387245, -2.012886, 2.213441>,
      < 4.346522, -1.878587, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.482315, -1.973520, 2.267810>,
      < 4.447444, -1.858524, 2.267810>
    }
    triangle {
      < 4.482315, -1.973520, 2.704448>,
      < 4.538948, -2.079503, 2.704448>,
      < 4.570598, -2.058361, 2.704390>
    }
    triangle {
      < 4.482315, -1.973520, 2.704448>,
      < 4.570598, -2.058361, 2.704390>,
      < 4.517481, -1.958958, 2.704390>
    }
    triangle {
      < 4.387245, -2.012886, 2.758817>,
      < 4.453385, -2.136661, 2.758817>,
      < 4.538948, -2.079503, 2.704448>
    }
    triangle {
      < 4.387245, -2.012886, 2.758817>,
      < 4.538948, -2.079503, 2.704448>,
      < 4.482315, -1.973520, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.283918, -2.055673, 2.787150>,
      < 4.360392, -2.198782, 2.787150>,
      < 4.453385, -2.136661, 2.758817>
    }
    triangle {
      < 4.283918, -2.055673, 2.787150>,
      < 4.453385, -2.136661, 2.758817>,
      < 4.387245, -2.012886, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.184553, -2.096818, 2.764967>,
      < 4.270962, -2.258522, 2.764967>,
      < 4.360392, -2.198782, 2.787150>
    }
    triangle {
      < 4.184553, -2.096818, 2.764967>,
      < 4.360392, -2.198782, 2.787150>,
      < 4.283918, -2.055673, 2.787150>
    }
    triangle {
      < 4.079716, -2.140229, 2.700042>,
      < 4.176607, -2.321552, 2.700042>,
      < 4.270962, -2.258522, 2.764967>
    }
    triangle {
      < 4.079716, -2.140229, 2.700042>,
      < 4.270962, -2.258522, 2.764967>,
      < 4.184553, -2.096818, 2.764967>
    }
    triangle {
      < 4.058140, -2.149163, 2.486032>,
      < 4.157188, -2.334523, 2.486032>,
      < 4.176607, -2.321552, 2.700042>
    }
    triangle {
      < 4.058140, -2.149163, 2.486032>,
      < 4.176607, -2.321552, 2.700042>,
      < 4.079716, -2.140229, 2.700042>
    }
    triangle {
      < 4.079716, -2.140229, 2.272216>,
      < 4.176607, -2.321552, 2.272216>,
      < 4.157188, -2.334523, 2.486032>
    }
    triangle {
      < 4.079716, -2.140229, 2.272216>,
      < 4.157188, -2.334523, 2.486032>,
      < 4.058140, -2.149163, 2.486032>
    }
    triangle {
      < 4.184553, -2.096818, 2.207291>,
      < 4.270962, -2.258522, 2.207291>,
      < 4.176607, -2.321552, 2.272216>
    }
    triangle {
      < 4.184553, -2.096818, 2.207291>,
      < 4.176607, -2.321552, 2.272216>,
      < 4.079716, -2.140229, 2.272216>
    }
    triangle {
      < 4.283918, -2.055673, 2.185108>,
      < 4.360392, -2.198782, 2.185108>,
      < 4.270962, -2.258522, 2.207291>
    }
    triangle {
      < 4.283918, -2.055673, 2.185108>,
      < 4.270962, -2.258522, 2.207291>,
      < 4.184553, -2.096818, 2.207291>
    }
    triangle {
      < 4.387245, -2.012886, 2.213441>,
      < 4.453385, -2.136661, 2.213441>,
      < 4.360392, -2.198782, 2.185108>
    }
    triangle {
      < 4.387245, -2.012886, 2.213441>,
      < 4.360392, -2.198782, 2.185108>,
      < 4.283918, -2.055673, 2.185108>
    }
    triangle {
      < 4.482315, -1.973520, 2.267810>,
      < 4.538948, -2.079503, 2.267810>,
      < 4.453385, -2.136661, 2.213441>
    }
    triangle {
      < 4.482315, -1.973520, 2.267810>,
      < 4.453385, -2.136661, 2.213441>,
      < 4.387245, -2.012886, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.538948, -2.079503, 2.267810>,
      < 4.482315, -1.973520, 2.267810>
    }
    triangle {
      < 4.538948, -2.079503, 2.704448>,
      < 4.615216, -2.172448, 2.704448>,
      < 4.642129, -2.145534, 2.704390>
    }
    triangle {
      < 4.538948, -2.079503, 2.704448>,
      < 4.642129, -2.145534, 2.704390>,
      < 4.570598, -2.058361, 2.704390>
    }
    triangle {
      < 4.453385, -2.136661, 2.758817>,
      < 4.542456, -2.245206, 2.758817>,
      < 4.615216, -2.172448, 2.704448>
    }
    triangle {
      < 4.453385, -2.136661, 2.758817>,
      < 4.615216, -2.172448, 2.704448>,
      < 4.538948, -2.079503, 2.704448>
    }
    texture {btires}
  }
  // bwhitew
  union {
    triangle {
      < 4.360392, -2.198782, 2.787150>,
      < 4.463375, -2.324284, 2.787150>,
      < 4.542456, -2.245206, 2.758817>
    }
    triangle {
      < 4.360392, -2.198782, 2.787150>,
      < 4.542456, -2.245206, 2.758817>,
      < 4.453385, -2.136661, 2.758817>
    }
    texture {bwhitew}
  }
  // btires
  union {
    triangle {
      < 4.270962, -2.258522, 2.764967>,
      < 4.387326, -2.400331, 2.764967>,
      < 4.463375, -2.324284, 2.787150>
    }
    triangle {
      < 4.270962, -2.258522, 2.764967>,
      < 4.463375, -2.324284, 2.787150>,
      < 4.360392, -2.198782, 2.787150>
    }
    triangle {
      < 4.176607, -2.321552, 2.700042>,
      < 4.307090, -2.480566, 2.700042>,
      < 4.387326, -2.400331, 2.764967>
    }
    triangle {
      < 4.176607, -2.321552, 2.700042>,
      < 4.387326, -2.400331, 2.764967>,
      < 4.270962, -2.258522, 2.764967>
    }
    triangle {
      < 4.157188, -2.334523, 2.486032>,
      < 4.290576, -2.497078, 2.486032>,
      < 4.307090, -2.480566, 2.700042>
    }
    triangle {
      < 4.157188, -2.334523, 2.486032>,
      < 4.307090, -2.480566, 2.700042>,
      < 4.176607, -2.321552, 2.700042>
    }
    triangle {
      < 4.176607, -2.321552, 2.272216>,
      < 4.307090, -2.480566, 2.272216>,
      < 4.290576, -2.497078, 2.486032>
    }
    triangle {
      < 4.176607, -2.321552, 2.272216>,
      < 4.290576, -2.497078, 2.486032>,
      < 4.157188, -2.334523, 2.486032>
    }
    triangle {
      < 4.270962, -2.258522, 2.207291>,
      < 4.387326, -2.400331, 2.207291>,
      < 4.307090, -2.480566, 2.272216>
    }
    triangle {
      < 4.270962, -2.258522, 2.207291>,
      < 4.307090, -2.480566, 2.272216>,
      < 4.176607, -2.321552, 2.272216>
    }
    triangle {
      < 4.360392, -2.198782, 2.185108>,
      < 4.463375, -2.324284, 2.185108>,
      < 4.387326, -2.400331, 2.207291>
    }
    triangle {
      < 4.360392, -2.198782, 2.185108>,
      < 4.387326, -2.400331, 2.207291>,
      < 4.270962, -2.258522, 2.207291>
    }
    triangle {
      < 4.453385, -2.136661, 2.213441>,
      < 4.542456, -2.245206, 2.213441>,
      < 4.463375, -2.324284, 2.185108>
    }
    triangle {
      < 4.453385, -2.136661, 2.213441>,
      < 4.463375, -2.324284, 2.185108>,
      < 4.360392, -2.198782, 2.185108>
    }
    triangle {
      < 4.538948, -2.079503, 2.267810>,
      < 4.615216, -2.172448, 2.267810>,
      < 4.542456, -2.245206, 2.213441>
    }
    triangle {
      < 4.538948, -2.079503, 2.267810>,
      < 4.542456, -2.245206, 2.213441>,
      < 4.453385, -2.136661, 2.213441>
    }
    triangle {
      < 5.048558, -1.739117, 2.267490>,
      < 4.615216, -2.172448, 2.267810>,
      < 4.538948, -2.079503, 2.267810>
    }
    texture {btires}
  }
  // doors
  union {
    triangle {
      < -0.706121, 0.261649, -2.839315>,
      < -0.715091, 0.109981, -2.909752>,
      < -2.006068, 0.150094, -2.893790>
    }
    triangle {
      < -0.706121, 0.261649, -2.839315>,
      < -2.006068, 0.150094, -2.893790>,
      < -1.980028, 0.300094, -2.823455>
    }
    triangle {
      < -0.722611, -0.367954, -3.004505>,
      < -0.723364, -0.981687, -3.024465>,
      < -2.026972, -0.999906, -2.997255>
    }
    triangle {
      < -0.722611, -0.367954, -3.004505>,
      < -2.026972, -0.999906, -2.997255>,
      < -2.025026, -0.339706, -2.988144>
    }
    triangle {
      < -0.731341, -1.570020, -3.003212>,
      < -0.721598, -1.853257, -2.939839>,
      < -2.009248, -1.854906, -2.925065>
    }
    triangle {
      < -0.731341, -1.570020, -3.003212>,
      < -2.009248, -1.854906, -2.925065>,
      < -2.024261, -1.569907, -2.993072>
    }
    texture {doors}
  }
  // bottom
  union {
    triangle {
      < -0.717937, -2.055075, -2.859268>,
      < -0.716523, -2.055063, 0.000000>,
      < -2.184192, -2.064889, 0.000000>
    }
    triangle {
      < -0.717937, -2.055075, -2.859268>,
      < -2.184192, -2.064889, 0.000000>,
      < -2.184192, -2.064889, -2.863208>
    }
    texture {bottom}
  }
  // trim
  union {
    triangle {
      < -2.024078, -0.332610, -3.018595>,
      < -2.015225, -0.283092, -3.023281>,
      < -0.712161, -0.310465, -3.044853>
    }
    triangle {
      < -2.024078, -0.332610, -3.018595>,
      < -0.712161, -0.310465, -3.044853>,
      < -0.721595, -0.360602, -3.035488>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < -1.827191, 0.470087, -2.600646>,
      < -1.743652, 0.475082, -2.513202>,
      < -1.534455, 0.475062, -2.550094>
    }
    triangle {
      < -1.156857, 0.455026, -2.662095>,
      < -0.950543, 0.463118, -2.608058>,
      < -0.370346, 0.444959, -2.605526>
    }
    triangle {
      < -1.156857, 0.455026, -2.662095>,
      < -0.370346, 0.444959, -2.605526>,
      < -0.572180, 0.426277, -2.682826>
    }
    triangle {
      < -1.033102, 0.465816, -2.607353>,
      < -1.156857, 0.455026, -2.662095>,
      < -1.148572, 0.470027, -2.602251>
    }
    triangle {
      < -1.156857, 0.455026, -2.662095>,
      < -1.033102, 0.465816, -2.607353>,
      < -0.950543, 0.463118, -2.608058>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < -0.721595, -0.360602, -3.035488>,
      < -0.722611, -0.367954, -3.004505>,
      < -2.025026, -0.339706, -2.988144>
    }
    triangle {
      < -0.721595, -0.360602, -3.035488>,
      < -2.025026, -0.339706, -2.988144>,
      < -2.024078, -0.332610, -3.018595>
    }
    triangle {
      < -0.701599, -0.254755, -2.993339>,
      < -0.702736, -0.258677, -3.025462>,
      < -2.006387, -0.233573, -2.999232>
    }
    triangle {
      < -0.701599, -0.254755, -2.993339>,
      < -2.006387, -0.233573, -2.999232>,
      < -2.005316, -0.229907, -2.966577>
    }
    triangle {
      < -0.702736, -0.258677, -3.025462>,
      < -0.712161, -0.310465, -3.044853>,
      < -2.015225, -0.283092, -3.023281>
    }
    triangle {
      < -0.702736, -0.258677, -3.025462>,
      < -2.015225, -0.283092, -3.023281>,
      < -2.006387, -0.233573, -2.999232>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < -1.827191, 0.470087, -2.600646>,
      < -1.534455, 0.475062, -2.550094>,
      < -1.148572, 0.470027, -2.602251>
    }
    triangle {
      < -1.827191, 0.470087, -2.600646>,
      < -1.148572, 0.470027, -2.602251>,
      < -1.156857, 0.455026, -2.662095>
    }
    triangle {
      < -0.739559, -1.280019, -3.027744>,
      < -0.731341, -1.570020, -3.003212>,
      < -2.024261, -1.569907, -2.993072>
    }
    triangle {
      < -0.739559, -1.280019, -3.027744>,
      < -2.024261, -1.569907, -2.993072>,
      < -2.042209, -1.294905, -3.011163>
    }
    triangle {
      < -0.715091, 0.109981, -2.909752>,
      < -0.701599, -0.254755, -2.993339>,
      < -2.005316, -0.229907, -2.966577>
    }
    triangle {
      < -0.715091, 0.109981, -2.909752>,
      < -2.005316, -0.229907, -2.966577>,
      < -2.006068, 0.150094, -2.893790>
    }
    triangle {
      < -0.723364, -0.981687, -3.024465>,
      < -0.739559, -1.280019, -3.027744>,
      < -2.042209, -1.294905, -3.011163>
    }
    triangle {
      < -0.723364, -0.981687, -3.024465>,
      < -2.042209, -1.294905, -3.011163>,
      < -2.026972, -0.999906, -2.997255>
    }
    triangle {
      < -0.673143, 0.383316, -2.731264>,
      < -0.706121, 0.261649, -2.839315>,
      < -1.980028, 0.300094, -2.823455>
    }
    triangle {
      < -0.673143, 0.383316, -2.731264>,
      < -1.980028, 0.300094, -2.823455>,
      < -1.908399, 0.420091, -2.713477>
    }
    triangle {
      < -0.572180, 0.426277, -2.682826>,
      < -0.673143, 0.383316, -2.731264>,
      < -1.908399, 0.420091, -2.713477>
    }
    triangle {
      < -0.572180, 0.426277, -2.682826>,
      < -1.908399, 0.420091, -2.713477>,
      < -1.827191, 0.470087, -2.600646>
    }
    triangle {
      < -0.572180, 0.426277, -2.682826>,
      < -1.827191, 0.470087, -2.600646>,
      < -1.156857, 0.455026, -2.662095>
    }
    triangle {
      < 0.771994, 0.379304, -2.721166>,
      < 0.816296, 0.404855, -2.649039>,
      < 1.780270, 0.339770, -2.680530>
    }
    triangle {
      < 0.771994, 0.379304, -2.721166>,
      < 1.780270, 0.339770, -2.680530>,
      < 1.797373, 0.309767, -2.738039>
    }
    triangle {
      < 0.739638, 0.341257, -2.739249>,
      < 0.771994, 0.379304, -2.721166>,
      < 1.797373, 0.309767, -2.738039>
    }
    triangle {
      < 0.654150, 0.220598, -2.845349>,
      < 0.739638, 0.341257, -2.739249>,
      < 1.797373, 0.309767, -2.738039>
    }
    triangle {
      < 0.654150, 0.220598, -2.845349>,
      < 1.797373, 0.309767, -2.738039>,
      < 1.841696, 0.184760, -2.842235>
    }
    triangle {
      < 0.621467, 0.068452, -2.915999>,
      < 0.654150, 0.220598, -2.845349>,
      < 1.841696, 0.184760, -2.842235>
    }
    triangle {
      < 0.621467, 0.068452, -2.915999>,
      < 1.841696, 0.184760, -2.842235>,
      < 1.866866, 0.029756, -2.912876>
    }
    triangle {
      < 0.602643, -0.286536, -3.012373>,
      < 0.621467, 0.068452, -2.915999>,
      < 1.866866, 0.029756, -2.912876>
    }
    triangle {
      < 0.602643, -0.286536, -3.012373>,
      < 1.866866, 0.029756, -2.912876>,
      < 1.907401, -0.325250, -3.023679>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < 0.601438, -0.290715, -3.043964>,
      < 0.602643, -0.286536, -3.012373>,
      < 1.907401, -0.325250, -3.023679>
    }
    triangle {
      < 0.601438, -0.290715, -3.043964>,
      < 1.907401, -0.325250, -3.023679>,
      < 1.906129, -0.329685, -3.054738>
    }
    triangle {
      < 0.591428, -0.344771, -3.058698>,
      < 0.601438, -0.290715, -3.043964>,
      < 1.906129, -0.329685, -3.054738>
    }
    triangle {
      < 0.591428, -0.344771, -3.058698>,
      < 1.906129, -0.329685, -3.054738>,
      < 1.895532, -0.386009, -3.064815>
    }
    triangle {
      < 0.581412, -0.395527, -3.044654>,
      < 0.591428, -0.344771, -3.058698>,
      < 1.895532, -0.386009, -3.064815>
    }
    triangle {
      < 0.581412, -0.395527, -3.044654>,
      < 1.895532, -0.386009, -3.064815>,
      < 1.884935, -0.437384, -3.046091>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < 0.563094, -1.265133, -3.034725>,
      < 0.580248, -0.963468, -3.042075>,
      < 1.883856, -0.945249, -3.050085>
    }
    triangle {
      < 0.563094, -1.265133, -3.034725>,
      < 1.883856, -0.945249, -3.050085>,
      < 1.865744, -1.250247, -3.032106>
    }
    triangle {
      < 0.561584, -1.570132, -3.003752>,
      < 0.563094, -1.265133, -3.034725>,
      < 1.865744, -1.250247, -3.032106>
    }
    triangle {
      < 0.561584, -1.570132, -3.003752>,
      < 1.865744, -1.250247, -3.032106>,
      < 1.854504, -1.570245, -2.994691>
    }
    triangle {
      < 0.537256, -1.851644, -2.944117>,
      < 0.561584, -1.570132, -3.003752>,
      < 1.854504, -1.570245, -2.994691>
    }
    triangle {
      < 0.537256, -1.851644, -2.944117>,
      < 1.854504, -1.570245, -2.994691>,
      < 1.829418, -1.745242, -2.960097>
    }
    triangle {
      < 0.537256, -1.851644, -2.944117>,
      < 1.829418, -1.745242, -2.960097>,
      < 1.762765, -1.820235, -2.933957>
    }
    triangle {
      < 0.537256, -1.851644, -2.944117>,
      < 1.762765, -1.820235, -2.933957>,
      < 1.644907, -1.850225, -2.939876>
    }
    triangle {
      < -0.572180, 0.426277, -2.682826>,
      < -0.370346, 0.444959, -2.605526>,
      < 0.816296, 0.404855, -2.649039>
    }
    triangle {
      < -0.572180, 0.426277, -2.682826>,
      < 0.816296, 0.404855, -2.649039>,
      < 0.771994, 0.379304, -2.721166>
    }
    triangle {
      < -0.673143, 0.383316, -2.731264>,
      < -0.572180, 0.426277, -2.682826>,
      < 0.771994, 0.379304, -2.721166>
    }
    triangle {
      < -0.673143, 0.383316, -2.731264>,
      < 0.771994, 0.379304, -2.721166>,
      < 0.739638, 0.341257, -2.739249>
    }
    triangle {
      < -0.706121, 0.261649, -2.839315>,
      < -0.673143, 0.383316, -2.731264>,
      < 0.739638, 0.341257, -2.739249>
    }
    triangle {
      < -0.706121, 0.261649, -2.839315>,
      < 0.739638, 0.341257, -2.739249>,
      < 0.654150, 0.220598, -2.845349>
    }
    triangle {
      < -0.715091, 0.109981, -2.909752>,
      < -0.706121, 0.261649, -2.839315>,
      < 0.654150, 0.220598, -2.845349>
    }
    triangle {
      < -0.715091, 0.109981, -2.909752>,
      < 0.654150, 0.220598, -2.845349>,
      < 0.621467, 0.068452, -2.915999>
    }
    triangle {
      < -0.701599, -0.254755, -2.993339>,
      < -0.715091, 0.109981, -2.909752>,
      < 0.621467, 0.068452, -2.915999>
    }
    triangle {
      < -0.701599, -0.254755, -2.993339>,
      < 0.621467, 0.068452, -2.915999>,
      < 0.602643, -0.286536, -3.012373>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < -0.702736, -0.258677, -3.025462>,
      < -0.701599, -0.254755, -2.993339>,
      < 0.602643, -0.286536, -3.012373>
    }
    triangle {
      < -0.702736, -0.258677, -3.025462>,
      < 0.602643, -0.286536, -3.012373>,
      < 0.601438, -0.290715, -3.043964>
    }
    triangle {
      < -0.712161, -0.310465, -3.044853>,
      < -0.702736, -0.258677, -3.025462>,
      < 0.601438, -0.290715, -3.043964>
    }
    triangle {
      < -0.712161, -0.310465, -3.044853>,
      < 0.601438, -0.290715, -3.043964>,
      < 0.591428, -0.344771, -3.058698>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < -0.739559, -1.280019, -3.027744>,
      < -0.723364, -0.981687, -3.024465>,
      < 0.580248, -0.963468, -3.042075>
    }
    triangle {
      < -0.739559, -1.280019, -3.027744>,
      < 0.580248, -0.963468, -3.042075>,
      < 0.563094, -1.265133, -3.034725>
    }
    triangle {
      < -0.731341, -1.570020, -3.003212>,
      < -0.739559, -1.280019, -3.027744>,
      < 0.563094, -1.265133, -3.034725>
    }
    triangle {
      < -0.731341, -1.570020, -3.003212>,
      < 0.563094, -1.265133, -3.034725>,
      < 0.561584, -1.570132, -3.003752>
    }
    triangle {
      < -0.721598, -1.853257, -2.939839>,
      < -0.731341, -1.570020, -3.003212>,
      < 0.561584, -1.570132, -3.003752>
    }
    triangle {
      < -0.721598, -1.853257, -2.939839>,
      < 0.561584, -1.570132, -3.003752>,
      < 0.537256, -1.851644, -2.944117>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < -0.722611, -0.367954, -3.004505>,
      < -0.721595, -0.360602, -3.035488>,
      < 0.581412, -0.395527, -3.044654>
    }
    triangle {
      < -0.722611, -0.367954, -3.004505>,
      < 0.581412, -0.395527, -3.044654>,
      < 0.580330, -0.403134, -3.013139>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < -0.723364, -0.981687, -3.024465>,
      < -0.722611, -0.367954, -3.004505>,
      < 0.580330, -0.403134, -3.013139>
    }
    triangle {
      < -0.723364, -0.981687, -3.024465>,
      < 0.580330, -0.403134, -3.013139>,
      < 0.580248, -0.963468, -3.042075>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < 0.580330, -0.403134, -3.013139>,
      < 0.581412, -0.395527, -3.044654>,
      < 1.884935, -0.437384, -3.046091>
    }
    triangle {
      < 0.580330, -0.403134, -3.013139>,
      < 1.884935, -0.437384, -3.046091>,
      < 1.883786, -0.445248, -3.014044>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < 0.580248, -0.963468, -3.042075>,
      < 0.580330, -0.403134, -3.013139>,
      < 1.883786, -0.445248, -3.014044>
    }
    triangle {
      < 0.580248, -0.963468, -3.042075>,
      < 1.883786, -0.445248, -3.014044>,
      < 1.883856, -0.945249, -3.050085>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < -0.721595, -0.360602, -3.035488>,
      < -0.712161, -0.310465, -3.044853>,
      < 0.591428, -0.344771, -3.058698>
    }
    triangle {
      < -0.721595, -0.360602, -3.035488>,
      < 0.591428, -0.344771, -3.058698>,
      < 0.581412, -0.395527, -3.044654>
    }
    texture {trim}
  }
  // bottom
  union {
    triangle {
      < -0.716523, -2.055063, 0.000000>,
      < -0.717937, -2.055075, -2.859268>,
      < 0.527923, -2.046736, -2.855920>
    }
    triangle {
      < -0.716523, -2.055063, 0.000000>,
      < 0.527923, -2.046736, -2.855920>,
      < 0.528078, -2.046735, 0.000065>
    }
    triangle {
      < 0.528078, -2.046735, 0.000065>,
      < 0.527923, -2.046736, -2.855920>,
      < 1.647939, -2.039240, -2.852911>
    }
    triangle {
      < 0.528078, -2.046735, 0.000065>,
      < 1.647939, -2.039240, -2.852911>,
      < 1.651284, -2.039219, 0.000022>
    }
    triangle {
      < 1.651284, -2.039219, 0.000022>,
      < 1.647939, -2.039240, -2.852911>,
      < 3.715029, -2.025404, -2.847356>
    }
    triangle {
      < 1.651284, -2.039219, 0.000022>,
      < 3.715029, -2.025404, -2.847356>,
      < 3.715029, -2.025404, -1.747609>
    }
    triangle {
      < 1.651284, -2.039219, 0.000022>,
      < 3.715029, -2.025404, -1.747609>,
      < 3.715029, -2.025404, 0.000000>
    }
    texture {bottom}
  }
  // doors
  union {
    triangle {
      < -1.980028, 0.300094, 2.823455>,
      < -2.006068, 0.150094, 2.893790>,
      < -0.715091, 0.109981, 2.909752>
    }
    triangle {
      < -1.980028, 0.300094, 2.823455>,
      < -0.715091, 0.109981, 2.909752>,
      < -0.706121, 0.261649, 2.839315>
    }
    triangle {
      < -2.025026, -0.339706, 2.988144>,
      < -2.026972, -0.999906, 2.997255>,
      < -0.723364, -0.981687, 3.024465>
    }
    triangle {
      < -2.025026, -0.339706, 2.988144>,
      < -0.723364, -0.981687, 3.024465>,
      < -0.722611, -0.367954, 3.004505>
    }
    triangle {
      < -2.024261, -1.569907, 2.993072>,
      < -2.009248, -1.854906, 2.925065>,
      < -0.721598, -1.853257, 2.939839>
    }
    triangle {
      < -2.024261, -1.569907, 2.993072>,
      < -0.721598, -1.853257, 2.939839>,
      < -0.731341, -1.570020, 3.003212>
    }
    texture {doors}
  }
  // bottom
  union {
    triangle {
      < -2.184192, -2.064889, 2.863208>,
      < -2.184192, -2.064889, 0.000000>,
      < -0.716523, -2.055063, 0.000000>
    }
    triangle {
      < -2.184192, -2.064889, 2.863208>,
      < -0.716523, -2.055063, 0.000000>,
      < -0.717937, -2.055075, 2.859268>
    }
    texture {bottom}
  }
  // trim
  union {
    triangle {
      < -0.721595, -0.360602, 3.035488>,
      < -0.712161, -0.310465, 3.044853>,
      < -2.015225, -0.283092, 3.023281>
    }
    triangle {
      < -0.721595, -0.360602, 3.035488>,
      < -2.015225, -0.283092, 3.023281>,
      < -2.024078, -0.332610, 3.018595>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < -1.534455, 0.475062, 2.550094>,
      < -1.743652, 0.475082, 2.513202>,
      < -1.827191, 0.470087, 2.600646>
    }
    triangle {
      < -0.572180, 0.426277, 2.682826>,
      < -0.370346, 0.444959, 2.605526>,
      < -0.950543, 0.463118, 2.608058>
    }
    triangle {
      < -0.572180, 0.426277, 2.682826>,
      < -0.950543, 0.463118, 2.608058>,
      < -1.156857, 0.455026, 2.662095>
    }
    triangle {
      < -1.148572, 0.470027, 2.602251>,
      < -1.156857, 0.455026, 2.662095>,
      < -1.033102, 0.465816, 2.607353>
    }
    triangle {
      < -0.950543, 0.463118, 2.608058>,
      < -1.033102, 0.465816, 2.607353>,
      < -1.156857, 0.455026, 2.662095>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < -2.024078, -0.332610, 3.018595>,
      < -2.025026, -0.339706, 2.988144>,
      < -0.722611, -0.367954, 3.004505>
    }
    triangle {
      < -2.024078, -0.332610, 3.018595>,
      < -0.722611, -0.367954, 3.004505>,
      < -0.721595, -0.360602, 3.035488>
    }
    triangle {
      < -2.005316, -0.229907, 2.966577>,
      < -2.006387, -0.233573, 2.999232>,
      < -0.702736, -0.258677, 3.025462>
    }
    triangle {
      < -2.005316, -0.229907, 2.966577>,
      < -0.702736, -0.258677, 3.025462>,
      < -0.701599, -0.254755, 2.993339>
    }
    triangle {
      < -2.006387, -0.233573, 2.999232>,
      < -2.015225, -0.283092, 3.023281>,
      < -0.712161, -0.310465, 3.044853>
    }
    triangle {
      < -2.006387, -0.233573, 2.999232>,
      < -0.712161, -0.310465, 3.044853>,
      < -0.702736, -0.258677, 3.025462>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < -1.156857, 0.455026, 2.662095>,
      < -1.148572, 0.470027, 2.602251>,
      < -1.534455, 0.475062, 2.550094>
    }
    triangle {
      < -1.156857, 0.455026, 2.662095>,
      < -1.534455, 0.475062, 2.550094>,
      < -1.827191, 0.470087, 2.600646>
    }
    triangle {
      < -2.042209, -1.294905, 3.011163>,
      < -2.024261, -1.569907, 2.993072>,
      < -0.731341, -1.570020, 3.003212>
    }
    triangle {
      < -2.042209, -1.294905, 3.011163>,
      < -0.731341, -1.570020, 3.003212>,
      < -0.739559, -1.280019, 3.027744>
    }
    triangle {
      < -2.006068, 0.150094, 2.893790>,
      < -2.005316, -0.229907, 2.966577>,
      < -0.701599, -0.254755, 2.993339>
    }
    triangle {
      < -2.006068, 0.150094, 2.893790>,
      < -0.701599, -0.254755, 2.993339>,
      < -0.715091, 0.109981, 2.909752>
    }
    triangle {
      < -2.026972, -0.999906, 2.997255>,
      < -2.042209, -1.294905, 3.011163>,
      < -0.739559, -1.280019, 3.027744>
    }
    triangle {
      < -2.026972, -0.999906, 2.997255>,
      < -0.739559, -1.280019, 3.027744>,
      < -0.723364, -0.981687, 3.024465>
    }
    triangle {
      < -1.908399, 0.420091, 2.713477>,
      < -1.980028, 0.300094, 2.823455>,
      < -0.706121, 0.261649, 2.839315>
    }
    triangle {
      < -1.908399, 0.420091, 2.713477>,
      < -0.706121, 0.261649, 2.839315>,
      < -0.673143, 0.383316, 2.731264>
    }
    triangle {
      < -1.156857, 0.455026, 2.662095>,
      < -1.827191, 0.470087, 2.600646>,
      < -1.908399, 0.420091, 2.713477>
    }
    triangle {
      < -1.156857, 0.455026, 2.662095>,
      < -1.908399, 0.420091, 2.713477>,
      < -0.673143, 0.383316, 2.731264>
    }
    triangle {
      < -1.156857, 0.455026, 2.662095>,
      < -0.673143, 0.383316, 2.731264>,
      < -0.572180, 0.426277, 2.682826>
    }
    triangle {
      < 1.797373, 0.309767, 2.738039>,
      < 1.780270, 0.339770, 2.680530>,
      < 0.816296, 0.404855, 2.649039>
    }
    triangle {
      < 1.797373, 0.309767, 2.738039>,
      < 0.816296, 0.404855, 2.649039>,
      < 0.771994, 0.379304, 2.721166>
    }
    triangle {
      < 1.797373, 0.309767, 2.738039>,
      < 0.771994, 0.379304, 2.721166>,
      < 0.739638, 0.341257, 2.739249>
    }
    triangle {
      < 1.841696, 0.184760, 2.842235>,
      < 1.797373, 0.309767, 2.738039>,
      < 0.739638, 0.341257, 2.739249>
    }
    triangle {
      < 1.841696, 0.184760, 2.842235>,
      < 0.739638, 0.341257, 2.739249>,
      < 0.654150, 0.220598, 2.845349>
    }
    triangle {
      < 1.866866, 0.029756, 2.912876>,
      < 1.841696, 0.184760, 2.842235>,
      < 0.654150, 0.220598, 2.845349>
    }
    triangle {
      < 1.866866, 0.029756, 2.912876>,
      < 0.654150, 0.220598, 2.845349>,
      < 0.621467, 0.068452, 2.915999>
    }
    triangle {
      < 1.907401, -0.325250, 3.023679>,
      < 1.866866, 0.029756, 2.912876>,
      < 0.621467, 0.068452, 2.915999>
    }
    triangle {
      < 1.907401, -0.325250, 3.023679>,
      < 0.621467, 0.068452, 2.915999>,
      < 0.602643, -0.286536, 3.012373>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < 1.906129, -0.329685, 3.054738>,
      < 1.907401, -0.325250, 3.023679>,
      < 0.602643, -0.286536, 3.012373>
    }
    triangle {
      < 1.906129, -0.329685, 3.054738>,
      < 0.602643, -0.286536, 3.012373>,
      < 0.601438, -0.290715, 3.043964>
    }
    triangle {
      < 1.895532, -0.386009, 3.064815>,
      < 1.906129, -0.329685, 3.054738>,
      < 0.601438, -0.290715, 3.043964>
    }
    triangle {
      < 1.895532, -0.386009, 3.064815>,
      < 0.601438, -0.290715, 3.043964>,
      < 0.591428, -0.344771, 3.058698>
    }
    triangle {
      < 1.884935, -0.437384, 3.046091>,
      < 1.895532, -0.386009, 3.064815>,
      < 0.591428, -0.344771, 3.058698>
    }
    triangle {
      < 1.884935, -0.437384, 3.046091>,
      < 0.591428, -0.344771, 3.058698>,
      < 0.581412, -0.395527, 3.044654>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < 1.865744, -1.250247, 3.032106>,
      < 1.883856, -0.945249, 3.050085>,
      < 0.580248, -0.963468, 3.042075>
    }
    triangle {
      < 1.865744, -1.250247, 3.032106>,
      < 0.580248, -0.963468, 3.042075>,
      < 0.563094, -1.265133, 3.034725>
    }
    triangle {
      < 1.854504, -1.570245, 2.994691>,
      < 1.865744, -1.250247, 3.032106>,
      < 0.563094, -1.265133, 3.034725>
    }
    triangle {
      < 1.854504, -1.570245, 2.994691>,
      < 0.563094, -1.265133, 3.034725>,
      < 0.561584, -1.570132, 3.003752>
    }
    triangle {
      < 1.644907, -1.850225, 2.939876>,
      < 1.762765, -1.820235, 2.933957>,
      < 1.829418, -1.745242, 2.960097>
    }
    triangle {
      < 1.644907, -1.850225, 2.939876>,
      < 1.829418, -1.745242, 2.960097>,
      < 1.854504, -1.570245, 2.994691>
    }
    triangle {
      < 1.644907, -1.850225, 2.939876>,
      < 1.854504, -1.570245, 2.994691>,
      < 0.561584, -1.570132, 3.003752>
    }
    triangle {
      < 1.644907, -1.850225, 2.939876>,
      < 0.561584, -1.570132, 3.003752>,
      < 0.537256, -1.851644, 2.944117>
    }
    triangle {
      < 0.771994, 0.379304, 2.721166>,
      < 0.816296, 0.404855, 2.649039>,
      < -0.370346, 0.444959, 2.605526>
    }
    triangle {
      < 0.771994, 0.379304, 2.721166>,
      < -0.370346, 0.444959, 2.605526>,
      < -0.572180, 0.426277, 2.682826>
    }
    triangle {
      < 0.739638, 0.341257, 2.739249>,
      < 0.771994, 0.379304, 2.721166>,
      < -0.572180, 0.426277, 2.682826>
    }
    triangle {
      < 0.739638, 0.341257, 2.739249>,
      < -0.572180, 0.426277, 2.682826>,
      < -0.673143, 0.383316, 2.731264>
    }
    triangle {
      < 0.654150, 0.220598, 2.845349>,
      < 0.739638, 0.341257, 2.739249>,
      < -0.673143, 0.383316, 2.731264>
    }
    triangle {
      < 0.654150, 0.220598, 2.845349>,
      < -0.673143, 0.383316, 2.731264>,
      < -0.706121, 0.261649, 2.839315>
    }
    triangle {
      < 0.621467, 0.068452, 2.915999>,
      < 0.654150, 0.220598, 2.845349>,
      < -0.706121, 0.261649, 2.839315>
    }
    triangle {
      < 0.621467, 0.068452, 2.915999>,
      < -0.706121, 0.261649, 2.839315>,
      < -0.715091, 0.109981, 2.909752>
    }
    triangle {
      < 0.602643, -0.286536, 3.012373>,
      < 0.621467, 0.068452, 2.915999>,
      < -0.715091, 0.109981, 2.909752>
    }
    triangle {
      < 0.602643, -0.286536, 3.012373>,
      < -0.715091, 0.109981, 2.909752>,
      < -0.701599, -0.254755, 2.993339>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < 0.601438, -0.290715, 3.043964>,
      < 0.602643, -0.286536, 3.012373>,
      < -0.701599, -0.254755, 2.993339>
    }
    triangle {
      < 0.601438, -0.290715, 3.043964>,
      < -0.701599, -0.254755, 2.993339>,
      < -0.702736, -0.258677, 3.025462>
    }
    triangle {
      < 0.591428, -0.344771, 3.058698>,
      < 0.601438, -0.290715, 3.043964>,
      < -0.702736, -0.258677, 3.025462>
    }
    triangle {
      < 0.591428, -0.344771, 3.058698>,
      < -0.702736, -0.258677, 3.025462>,
      < -0.712161, -0.310465, 3.044853>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < 0.563094, -1.265133, 3.034725>,
      < 0.580248, -0.963468, 3.042075>,
      < -0.723364, -0.981687, 3.024465>
    }
    triangle {
      < 0.563094, -1.265133, 3.034725>,
      < -0.723364, -0.981687, 3.024465>,
      < -0.739559, -1.280019, 3.027744>
    }
    triangle {
      < 0.561584, -1.570132, 3.003752>,
      < 0.563094, -1.265133, 3.034725>,
      < -0.739559, -1.280019, 3.027744>
    }
    triangle {
      < 0.561584, -1.570132, 3.003752>,
      < -0.739559, -1.280019, 3.027744>,
      < -0.731341, -1.570020, 3.003212>
    }
    triangle {
      < 0.537256, -1.851644, 2.944117>,
      < 0.561584, -1.570132, 3.003752>,
      < -0.731341, -1.570020, 3.003212>
    }
    triangle {
      < 0.537256, -1.851644, 2.944117>,
      < -0.731341, -1.570020, 3.003212>,
      < -0.721598, -1.853257, 2.939839>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < 0.580330, -0.403134, 3.013139>,
      < 0.581412, -0.395527, 3.044654>,
      < -0.721595, -0.360602, 3.035488>
    }
    triangle {
      < 0.580330, -0.403134, 3.013139>,
      < -0.721595, -0.360602, 3.035488>,
      < -0.722611, -0.367954, 3.004505>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < 0.580248, -0.963468, 3.042075>,
      < 0.580330, -0.403134, 3.013139>,
      < -0.722611, -0.367954, 3.004505>
    }
    triangle {
      < 0.580248, -0.963468, 3.042075>,
      < -0.722611, -0.367954, 3.004505>,
      < -0.723364, -0.981687, 3.024465>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < 1.883786, -0.445248, 3.014044>,
      < 1.884935, -0.437384, 3.046091>,
      < 0.581412, -0.395527, 3.044654>
    }
    triangle {
      < 1.883786, -0.445248, 3.014044>,
      < 0.581412, -0.395527, 3.044654>,
      < 0.580330, -0.403134, 3.013139>
    }
    texture {trim}
  }
  // doors
  union {
    triangle {
      < 1.883856, -0.945249, 3.050085>,
      < 1.883786, -0.445248, 3.014044>,
      < 0.580330, -0.403134, 3.013139>
    }
    triangle {
      < 1.883856, -0.945249, 3.050085>,
      < 0.580330, -0.403134, 3.013139>,
      < 0.580248, -0.963468, 3.042075>
    }
    texture {doors}
  }
  // trim
  union {
    triangle {
      < 0.581412, -0.395527, 3.044654>,
      < 0.591428, -0.344771, 3.058698>,
      < -0.712161, -0.310465, 3.044853>
    }
    triangle {
      < 0.581412, -0.395527, 3.044654>,
      < -0.712161, -0.310465, 3.044853>,
      < -0.721595, -0.360602, 3.035488>
    }
    texture {trim}
  }
  // bottom
  union {
    triangle {
      < 0.528078, -2.046735, 0.000065>,
      < 0.527923, -2.046736, 2.855920>,
      < -0.717937, -2.055075, 2.859268>
    }
    triangle {
      < 0.528078, -2.046735, 0.000065>,
      < -0.717937, -2.055075, 2.859268>,
      < -0.716523, -2.055063, 0.000000>
    }
    triangle {
      < 1.651284, -2.039219, 0.000022>,
      < 1.647939, -2.039240, 2.852911>,
      < 0.527923, -2.046736, 2.855920>
    }
    triangle {
      < 1.651284, -2.039219, 0.000022>,
      < 0.527923, -2.046736, 2.855920>,
      < 0.528078, -2.046735, 0.000065>
    }
    triangle {
      < 3.715029, -2.025404, 0.000000>,
      < 3.715029, -2.025404, 1.747609>,
      < 3.715029, -2.025404, 2.847356>
    }
    triangle {
      < 3.715029, -2.025404, 0.000000>,
      < 3.715029, -2.025404, 2.847356>,
      < 1.647939, -2.039240, 2.852911>
    }
    triangle {
      < 3.715029, -2.025404, 0.000000>,
      < 1.647939, -2.039240, 2.852911>,
      < 1.651284, -2.039219, 0.000022>
    }
    texture {bottom}
  }
  // alight
  union {
    triangle {
      < -6.934822, -1.110614, -1.645681>,
      < -6.934822, -1.097154, -1.634633>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.904465, -1.102408, -1.572563>,
      < -6.904465, -1.075025, -1.564260>,
      < -6.934822, -1.065272, -1.621422>
    }
    triangle {
      < -6.904465, -1.102408, -1.572563>,
      < -6.934822, -1.065272, -1.621422>,
      < -6.934822, -1.081827, -1.626442>
    }
    triangle {
      < -6.904465, -1.075025, -1.564260>,
      < -6.904465, -1.046170, -1.562022>,
      < -6.934822, -1.047827, -1.620068>
    }
    triangle {
      < -6.904465, -1.075025, -1.564260>,
      < -6.934822, -1.047827, -1.620068>,
      < -6.934822, -1.065272, -1.621422>
    }
    triangle {
      < -6.904465, -1.046170, -1.562022>,
      < -6.904465, -1.015177, -1.564416>,
      < -6.934822, -1.029089, -1.621517>
    }
    triangle {
      < -6.904465, -1.046170, -1.562022>,
      < -6.934822, -1.029089, -1.621517>,
      < -6.934822, -1.047827, -1.620068>
    }
    triangle {
      < -6.904465, -1.015177, -1.564416>,
      < -6.904465, -0.992253, -1.572645>,
      < -6.934822, -1.015230, -1.626492>
    }
    triangle {
      < -6.904465, -1.015177, -1.564416>,
      < -6.934822, -1.015230, -1.626492>,
      < -6.934822, -1.029089, -1.621517>
    }
    triangle {
      < -6.904465, -0.992253, -1.572645>,
      < -6.904465, -0.970829, -1.586191>,
      < -6.934822, -1.002278, -1.634681>
    }
    triangle {
      < -6.904465, -0.992253, -1.572645>,
      < -6.934822, -1.002278, -1.634681>,
      < -6.934822, -1.015230, -1.626492>
    }
    triangle {
      < -6.904465, -0.970829, -1.586191>,
      < -6.904465, -0.952010, -1.604460>,
      < -6.934822, -0.990900, -1.645727>
    }
    triangle {
      < -6.904465, -0.970829, -1.586191>,
      < -6.934822, -0.990900, -1.645727>,
      < -6.934822, -1.002278, -1.634681>
    }
    triangle {
      < -6.904465, -0.952010, -1.604460>,
      < -6.904465, -0.936532, -1.626768>,
      < -6.934822, -0.981542, -1.659213>
    }
    triangle {
      < -6.904465, -0.952010, -1.604460>,
      < -6.934822, -0.981542, -1.659213>,
      < -6.934822, -0.990900, -1.645727>
    }
    triangle {
      < -6.904465, -0.936532, -1.626768>,
      < -6.904465, -0.925003, -1.652266>,
      < -6.934822, -0.974571, -1.674629>
    }
    triangle {
      < -6.904465, -0.936532, -1.626768>,
      < -6.934822, -0.974571, -1.674629>,
      < -6.934822, -0.981542, -1.659213>
    }
    triangle {
      < -6.904465, -0.925003, -1.652266>,
      < -6.904465, -0.917890, -1.679976>,
      < -6.934822, -0.970271, -1.691382>
    }
    triangle {
      < -6.904465, -0.925003, -1.652266>,
      < -6.934822, -0.970271, -1.691382>,
      < -6.934822, -0.974571, -1.674629>
    }
    triangle {
      < -6.904465, -0.917890, -1.679976>,
      < -6.904465, -0.915478, -1.708816>,
      < -6.934822, -0.968813, -1.708817>
    }
    triangle {
      < -6.904465, -0.917890, -1.679976>,
      < -6.934822, -0.968813, -1.708817>,
      < -6.934822, -0.970271, -1.691382>
    }
    triangle {
      < -6.904465, -0.915478, -1.708816>,
      < -6.904465, -0.917866, -1.737659>,
      < -6.934822, -0.970257, -1.726254>
    }
    triangle {
      < -6.904465, -0.915478, -1.708816>,
      < -6.934822, -0.970257, -1.726254>,
      < -6.934822, -0.968813, -1.708817>
    }
    triangle {
      < -6.904465, -0.917866, -1.737659>,
      < -6.904465, -0.924957, -1.765378>,
      < -6.934822, -0.974544, -1.743014>
    }
    triangle {
      < -6.904465, -0.917866, -1.737659>,
      < -6.934822, -0.974544, -1.743014>,
      < -6.934822, -0.970257, -1.726254>
    }
    triangle {
      < -6.904465, -0.924957, -1.765378>,
      < -6.904465, -0.936466, -1.790894>,
      < -6.934822, -0.981502, -1.758440>
    }
    triangle {
      < -6.904465, -0.924957, -1.765378>,
      < -6.934822, -0.981502, -1.758440>,
      < -6.934822, -0.974544, -1.743014>
    }
    triangle {
      < -6.904465, -0.936466, -1.790894>,
      < -6.904465, -0.951925, -1.813223>,
      < -6.934822, -0.990848, -1.771939>
    }
    triangle {
      < -6.904465, -0.936466, -1.790894>,
      < -6.934822, -0.990848, -1.771939>,
      < -6.934822, -0.981502, -1.758440>
    }
    triangle {
      < -6.904465, -0.951925, -1.813223>,
      < -6.904465, -0.970730, -1.831518>,
      < -6.934822, -1.002217, -1.783000>
    }
    triangle {
      < -6.904465, -0.951925, -1.813223>,
      < -6.934822, -1.002217, -1.783000>,
      < -6.934822, -0.990848, -1.771939>
    }
    triangle {
      < -6.904465, -0.970730, -1.831518>,
      < -6.904465, -0.992145, -1.845094>,
      < -6.934822, -1.015164, -1.791207>
    }
    triangle {
      < -6.904465, -0.970730, -1.831518>,
      < -6.934822, -1.015164, -1.791207>,
      < -6.934822, -1.002217, -1.783000>
    }
    triangle {
      < -6.904465, -0.992145, -1.845094>,
      < -6.904465, -1.014989, -1.853330>,
      < -6.934822, -1.028975, -1.796187>
    }
    triangle {
      < -6.904465, -0.992145, -1.845094>,
      < -6.934822, -1.028975, -1.796187>,
      < -6.934822, -1.015164, -1.791207>
    }
    triangle {
      < -6.904465, -1.014989, -1.853330>,
      < -6.904465, -1.046108, -1.855581>,
      < -6.934822, -1.047789, -1.797548>
    }
    triangle {
      < -6.904465, -1.014989, -1.853330>,
      < -6.934822, -1.047789, -1.797548>,
      < -6.934822, -1.028975, -1.796187>
    }
    triangle {
      < -6.904465, -1.046108, -1.855581>,
      < -6.904465, -1.075025, -1.853340>,
      < -6.934822, -1.065271, -1.796193>
    }
    triangle {
      < -6.904465, -1.046108, -1.855581>,
      < -6.934822, -1.065271, -1.796193>,
      < -6.934822, -1.047789, -1.797548>
    }
    triangle {
      < -6.904465, -1.075025, -1.853340>,
      < -6.904465, -1.102407, -1.845036>,
      < -6.934822, -1.081826, -1.791174>
    }
    triangle {
      < -6.904465, -1.075025, -1.853340>,
      < -6.934822, -1.081826, -1.791174>,
      < -6.934822, -1.065271, -1.796193>
    }
    triangle {
      < -6.904465, -1.102407, -1.845036>,
      < -6.904465, -1.127759, -1.831487>,
      < -6.934822, -1.097153, -1.782981>
    }
    triangle {
      < -6.904465, -1.102407, -1.845036>,
      < -6.934822, -1.097153, -1.782981>,
      < -6.934822, -1.081826, -1.791174>
    }
    triangle {
      < -6.904465, -1.127759, -1.831487>,
      < -6.904465, -1.150022, -1.813214>,
      < -6.934822, -1.110613, -1.771934>
    }
    triangle {
      < -6.904465, -1.127759, -1.831487>,
      < -6.934822, -1.110613, -1.771934>,
      < -6.934822, -1.097153, -1.782981>
    }
    triangle {
      < -6.904465, -1.150022, -1.813214>,
      < -6.904465, -1.168333, -1.790896>,
      < -6.934822, -1.121684, -1.758441>
    }
    triangle {
      < -6.904465, -1.150022, -1.813214>,
      < -6.934822, -1.121684, -1.758441>,
      < -6.934822, -1.110613, -1.771934>
    }
    triangle {
      < -6.904465, -1.168333, -1.790896>,
      < -6.904465, -1.181965, -1.765383>,
      < -6.934822, -1.129925, -1.743016>
    }
    triangle {
      < -6.904465, -1.168333, -1.790896>,
      < -6.934822, -1.129925, -1.743016>,
      < -6.934822, -1.121684, -1.758441>
    }
    triangle {
      < -6.904465, -1.181965, -1.765383>,
      < -6.904465, -1.190369, -1.737657>,
      < -6.934822, -1.135006, -1.726254>
    }
    triangle {
      < -6.904465, -1.181965, -1.765383>,
      < -6.934822, -1.135006, -1.726254>,
      < -6.934822, -1.129925, -1.743016>
    }
    triangle {
      < -6.904465, -1.190369, -1.737657>,
      < -6.904465, -1.193210, -1.708800>,
      < -6.934822, -1.136724, -1.708807>
    }
    triangle {
      < -6.904465, -1.190369, -1.737657>,
      < -6.934822, -1.136724, -1.708807>,
      < -6.934822, -1.135006, -1.726254>
    }
    triangle {
      < -6.904465, -1.193210, -1.708800>,
      < -6.904465, -1.190369, -1.679942>,
      < -6.934822, -1.135006, -1.691361>
    }
    triangle {
      < -6.904465, -1.193210, -1.708800>,
      < -6.934822, -1.135006, -1.691361>,
      < -6.934822, -1.136724, -1.708807>
    }
    triangle {
      < -6.904465, -1.190369, -1.679942>,
      < -6.904465, -1.181965, -1.652216>,
      < -6.934822, -1.129926, -1.674599>
    }
    triangle {
      < -6.904465, -1.190369, -1.679942>,
      < -6.934822, -1.129926, -1.674599>,
      < -6.934822, -1.135006, -1.691361>
    }
    triangle {
      < -6.904465, -1.181965, -1.652216>,
      < -6.904465, -1.168334, -1.626702>,
      < -6.934822, -1.121684, -1.659175>
    }
    triangle {
      < -6.904465, -1.181965, -1.652216>,
      < -6.934822, -1.121684, -1.659175>,
      < -6.934822, -1.129926, -1.674599>
    }
    triangle {
      < -6.904465, -1.168334, -1.626702>,
      < -6.904465, -1.150023, -1.604386>,
      < -6.934822, -1.110614, -1.645681>
    }
    triangle {
      < -6.904465, -1.168334, -1.626702>,
      < -6.934822, -1.110614, -1.645681>,
      < -6.934822, -1.121684, -1.659175>
    }
    triangle {
      < -6.904465, -1.150023, -1.604386>,
      < -6.904465, -1.127759, -1.586112>,
      < -6.934822, -1.097154, -1.634633>
    }
    triangle {
      < -6.904465, -1.150023, -1.604386>,
      < -6.934822, -1.097154, -1.634633>,
      < -6.934822, -1.110614, -1.645681>
    }
    triangle {
      < -6.904465, -1.127759, -1.586112>,
      < -6.904465, -1.102408, -1.572563>,
      < -6.934822, -1.081827, -1.626442>
    }
    triangle {
      < -6.904465, -1.127759, -1.586112>,
      < -6.934822, -1.081827, -1.626442>,
      < -6.934822, -1.097154, -1.634633>
    }
    triangle {
      < -6.934822, -1.097154, -1.634633>,
      < -6.934822, -1.081827, -1.626442>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.081827, -1.626442>,
      < -6.934822, -1.065272, -1.621422>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.065272, -1.621422>,
      < -6.934822, -1.047827, -1.620068>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.047827, -1.620068>,
      < -6.934822, -1.029089, -1.621517>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.029089, -1.621517>,
      < -6.934822, -1.015230, -1.626492>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.015230, -1.626492>,
      < -6.934822, -1.002278, -1.634681>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.002278, -1.634681>,
      < -6.934822, -0.990900, -1.645727>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.990900, -1.645727>,
      < -6.934822, -0.981542, -1.659213>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.981542, -1.659213>,
      < -6.934822, -0.974571, -1.674629>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.974571, -1.674629>,
      < -6.934822, -0.970271, -1.691382>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.970271, -1.691382>,
      < -6.934822, -0.968813, -1.708817>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.968813, -1.708817>,
      < -6.934822, -0.970257, -1.726254>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.970257, -1.726254>,
      < -6.934822, -0.974544, -1.743014>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.974544, -1.743014>,
      < -6.934822, -0.981502, -1.758440>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.981502, -1.758440>,
      < -6.934822, -0.990848, -1.771939>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -0.990848, -1.771939>,
      < -6.934822, -1.002217, -1.783000>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.002217, -1.783000>,
      < -6.934822, -1.015164, -1.791207>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.015164, -1.791207>,
      < -6.934822, -1.028975, -1.796187>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.028975, -1.796187>,
      < -6.934822, -1.047789, -1.797548>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.047789, -1.797548>,
      < -6.934822, -1.065271, -1.796193>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.065271, -1.796193>,
      < -6.934822, -1.081826, -1.791174>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.081826, -1.791174>,
      < -6.934822, -1.097153, -1.782981>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.097153, -1.782981>,
      < -6.934822, -1.110613, -1.771934>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.110613, -1.771934>,
      < -6.934822, -1.121684, -1.758441>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.121684, -1.758441>,
      < -6.934822, -1.129925, -1.743016>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.129925, -1.743016>,
      < -6.934822, -1.135006, -1.726254>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.135006, -1.726254>,
      < -6.934822, -1.136724, -1.708807>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.136724, -1.708807>,
      < -6.934822, -1.135006, -1.691361>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.135006, -1.691361>,
      < -6.934822, -1.129926, -1.674599>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.129926, -1.674599>,
      < -6.934822, -1.121684, -1.659175>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.934822, -1.121684, -1.659175>,
      < -6.934822, -1.110614, -1.645681>,
      < -6.949224, -1.050359, -1.708820>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.097154, 1.634633>,
      < -6.934822, -1.110614, 1.645681>
    }
    triangle {
      < -6.934822, -1.081827, 1.626442>,
      < -6.934822, -1.065272, 1.621422>,
      < -6.904465, -1.075025, 1.564260>
    }
    triangle {
      < -6.934822, -1.081827, 1.626442>,
      < -6.904465, -1.075025, 1.564260>,
      < -6.904465, -1.102408, 1.572563>
    }
    triangle {
      < -6.934822, -1.065272, 1.621422>,
      < -6.934822, -1.047827, 1.620068>,
      < -6.904465, -1.046170, 1.562022>
    }
    triangle {
      < -6.934822, -1.065272, 1.621422>,
      < -6.904465, -1.046170, 1.562022>,
      < -6.904465, -1.075025, 1.564260>
    }
    triangle {
      < -6.934822, -1.047827, 1.620068>,
      < -6.934822, -1.029089, 1.621517>,
      < -6.904465, -1.015177, 1.564416>
    }
    triangle {
      < -6.934822, -1.047827, 1.620068>,
      < -6.904465, -1.015177, 1.564416>,
      < -6.904465, -1.046170, 1.562022>
    }
    triangle {
      < -6.934822, -1.029089, 1.621517>,
      < -6.934822, -1.015230, 1.626492>,
      < -6.904465, -0.992253, 1.572645>
    }
    triangle {
      < -6.934822, -1.029089, 1.621517>,
      < -6.904465, -0.992253, 1.572645>,
      < -6.904465, -1.015177, 1.564416>
    }
    triangle {
      < -6.934822, -1.015230, 1.626492>,
      < -6.934822, -1.002278, 1.634681>,
      < -6.904465, -0.970829, 1.586191>
    }
    triangle {
      < -6.934822, -1.015230, 1.626492>,
      < -6.904465, -0.970829, 1.586191>,
      < -6.904465, -0.992253, 1.572645>
    }
    triangle {
      < -6.934822, -1.002278, 1.634681>,
      < -6.934822, -0.990900, 1.645727>,
      < -6.904465, -0.952010, 1.604460>
    }
    triangle {
      < -6.934822, -1.002278, 1.634681>,
      < -6.904465, -0.952010, 1.604460>,
      < -6.904465, -0.970829, 1.586191>
    }
    triangle {
      < -6.934822, -0.990900, 1.645727>,
      < -6.934822, -0.981542, 1.659213>,
      < -6.904465, -0.936532, 1.626768>
    }
    triangle {
      < -6.934822, -0.990900, 1.645727>,
      < -6.904465, -0.936532, 1.626768>,
      < -6.904465, -0.952010, 1.604460>
    }
    triangle {
      < -6.934822, -0.981542, 1.659213>,
      < -6.934822, -0.974571, 1.674629>,
      < -6.904465, -0.925003, 1.652266>
    }
    triangle {
      < -6.934822, -0.981542, 1.659213>,
      < -6.904465, -0.925003, 1.652266>,
      < -6.904465, -0.936532, 1.626768>
    }
    triangle {
      < -6.934822, -0.974571, 1.674629>,
      < -6.934822, -0.970271, 1.691382>,
      < -6.904465, -0.917890, 1.679976>
    }
    triangle {
      < -6.934822, -0.974571, 1.674629>,
      < -6.904465, -0.917890, 1.679976>,
      < -6.904465, -0.925003, 1.652266>
    }
    triangle {
      < -6.934822, -0.970271, 1.691382>,
      < -6.934822, -0.968813, 1.708817>,
      < -6.904465, -0.915478, 1.708816>
    }
    triangle {
      < -6.934822, -0.970271, 1.691382>,
      < -6.904465, -0.915478, 1.708816>,
      < -6.904465, -0.917890, 1.679976>
    }
    triangle {
      < -6.934822, -0.968813, 1.708817>,
      < -6.934822, -0.970257, 1.726254>,
      < -6.904465, -0.917866, 1.737659>
    }
    triangle {
      < -6.934822, -0.968813, 1.708817>,
      < -6.904465, -0.917866, 1.737659>,
      < -6.904465, -0.915478, 1.708816>
    }
    triangle {
      < -6.934822, -0.970257, 1.726254>,
      < -6.934822, -0.974544, 1.743014>,
      < -6.904465, -0.924957, 1.765378>
    }
    triangle {
      < -6.934822, -0.970257, 1.726254>,
      < -6.904465, -0.924957, 1.765378>,
      < -6.904465, -0.917866, 1.737659>
    }
    triangle {
      < -6.934822, -0.974544, 1.743014>,
      < -6.934822, -0.981502, 1.758440>,
      < -6.904465, -0.936466, 1.790894>
    }
    triangle {
      < -6.934822, -0.974544, 1.743014>,
      < -6.904465, -0.936466, 1.790894>,
      < -6.904465, -0.924957, 1.765378>
    }
    triangle {
      < -6.934822, -0.981502, 1.758440>,
      < -6.934822, -0.990848, 1.771939>,
      < -6.904465, -0.951925, 1.813223>
    }
    triangle {
      < -6.934822, -0.981502, 1.758440>,
      < -6.904465, -0.951925, 1.813223>,
      < -6.904465, -0.936466, 1.790894>
    }
    triangle {
      < -6.934822, -0.990848, 1.771939>,
      < -6.934822, -1.002217, 1.783000>,
      < -6.904465, -0.970730, 1.831518>
    }
    triangle {
      < -6.934822, -0.990848, 1.771939>,
      < -6.904465, -0.970730, 1.831518>,
      < -6.904465, -0.951925, 1.813223>
    }
    triangle {
      < -6.934822, -1.002217, 1.783000>,
      < -6.934822, -1.015164, 1.791207>,
      < -6.904465, -0.992145, 1.845094>
    }
    triangle {
      < -6.934822, -1.002217, 1.783000>,
      < -6.904465, -0.992145, 1.845094>,
      < -6.904465, -0.970730, 1.831518>
    }
    triangle {
      < -6.934822, -1.015164, 1.791207>,
      < -6.934822, -1.028975, 1.796187>,
      < -6.904465, -1.014989, 1.853330>
    }
    triangle {
      < -6.934822, -1.015164, 1.791207>,
      < -6.904465, -1.014989, 1.853330>,
      < -6.904465, -0.992145, 1.845094>
    }
    triangle {
      < -6.934822, -1.028975, 1.796187>,
      < -6.934822, -1.047789, 1.797548>,
      < -6.904465, -1.046108, 1.855581>
    }
    triangle {
      < -6.934822, -1.028975, 1.796187>,
      < -6.904465, -1.046108, 1.855581>,
      < -6.904465, -1.014989, 1.853330>
    }
    triangle {
      < -6.934822, -1.047789, 1.797548>,
      < -6.934822, -1.065271, 1.796193>,
      < -6.904465, -1.075025, 1.853340>
    }
    triangle {
      < -6.934822, -1.047789, 1.797548>,
      < -6.904465, -1.075025, 1.853340>,
      < -6.904465, -1.046108, 1.855581>
    }
    triangle {
      < -6.934822, -1.065271, 1.796193>,
      < -6.934822, -1.081826, 1.791174>,
      < -6.904465, -1.102407, 1.845036>
    }
    triangle {
      < -6.934822, -1.065271, 1.796193>,
      < -6.904465, -1.102407, 1.845036>,
      < -6.904465, -1.075025, 1.853340>
    }
    triangle {
      < -6.934822, -1.081826, 1.791174>,
      < -6.934822, -1.097153, 1.782981>,
      < -6.904465, -1.127759, 1.831487>
    }
    triangle {
      < -6.934822, -1.081826, 1.791174>,
      < -6.904465, -1.127759, 1.831487>,
      < -6.904465, -1.102407, 1.845036>
    }
    triangle {
      < -6.934822, -1.097153, 1.782981>,
      < -6.934822, -1.110613, 1.771934>,
      < -6.904465, -1.150022, 1.813214>
    }
    triangle {
      < -6.934822, -1.097153, 1.782981>,
      < -6.904465, -1.150022, 1.813214>,
      < -6.904465, -1.127759, 1.831487>
    }
    triangle {
      < -6.934822, -1.110613, 1.771934>,
      < -6.934822, -1.121684, 1.758441>,
      < -6.904465, -1.168333, 1.790896>
    }
    triangle {
      < -6.934822, -1.110613, 1.771934>,
      < -6.904465, -1.168333, 1.790896>,
      < -6.904465, -1.150022, 1.813214>
    }
    triangle {
      < -6.934822, -1.121684, 1.758441>,
      < -6.934822, -1.129925, 1.743016>,
      < -6.904465, -1.181965, 1.765383>
    }
    triangle {
      < -6.934822, -1.121684, 1.758441>,
      < -6.904465, -1.181965, 1.765383>,
      < -6.904465, -1.168333, 1.790896>
    }
    triangle {
      < -6.934822, -1.129925, 1.743016>,
      < -6.934822, -1.135006, 1.726254>,
      < -6.904465, -1.190369, 1.737657>
    }
    triangle {
      < -6.934822, -1.129925, 1.743016>,
      < -6.904465, -1.190369, 1.737657>,
      < -6.904465, -1.181965, 1.765383>
    }
    triangle {
      < -6.934822, -1.135006, 1.726254>,
      < -6.934822, -1.136724, 1.708807>,
      < -6.904465, -1.193210, 1.708800>
    }
    triangle {
      < -6.934822, -1.135006, 1.726254>,
      < -6.904465, -1.193210, 1.708800>,
      < -6.904465, -1.190369, 1.737657>
    }
    triangle {
      < -6.934822, -1.136724, 1.708807>,
      < -6.934822, -1.135006, 1.691361>,
      < -6.904465, -1.190369, 1.679942>
    }
    triangle {
      < -6.934822, -1.136724, 1.708807>,
      < -6.904465, -1.190369, 1.679942>,
      < -6.904465, -1.193210, 1.708800>
    }
    triangle {
      < -6.934822, -1.135006, 1.691361>,
      < -6.934822, -1.129926, 1.674599>,
      < -6.904465, -1.181965, 1.652216>
    }
    triangle {
      < -6.934822, -1.135006, 1.691361>,
      < -6.904465, -1.181965, 1.652216>,
      < -6.904465, -1.190369, 1.679942>
    }
    triangle {
      < -6.934822, -1.129926, 1.674599>,
      < -6.934822, -1.121684, 1.659175>,
      < -6.904465, -1.168334, 1.626702>
    }
    triangle {
      < -6.934822, -1.129926, 1.674599>,
      < -6.904465, -1.168334, 1.626702>,
      < -6.904465, -1.181965, 1.652216>
    }
    triangle {
      < -6.934822, -1.121684, 1.659175>,
      < -6.934822, -1.110614, 1.645681>,
      < -6.904465, -1.150023, 1.604386>
    }
    triangle {
      < -6.934822, -1.121684, 1.659175>,
      < -6.904465, -1.150023, 1.604386>,
      < -6.904465, -1.168334, 1.626702>
    }
    triangle {
      < -6.934822, -1.110614, 1.645681>,
      < -6.934822, -1.097154, 1.634633>,
      < -6.904465, -1.127759, 1.586112>
    }
    triangle {
      < -6.934822, -1.110614, 1.645681>,
      < -6.904465, -1.127759, 1.586112>,
      < -6.904465, -1.150023, 1.604386>
    }
    triangle {
      < -6.934822, -1.097154, 1.634633>,
      < -6.934822, -1.081827, 1.626442>,
      < -6.904465, -1.102408, 1.572563>
    }
    triangle {
      < -6.934822, -1.097154, 1.634633>,
      < -6.904465, -1.102408, 1.572563>,
      < -6.904465, -1.127759, 1.586112>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.081827, 1.626442>,
      < -6.934822, -1.097154, 1.634633>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.065272, 1.621422>,
      < -6.934822, -1.081827, 1.626442>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.047827, 1.620068>,
      < -6.934822, -1.065272, 1.621422>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.029089, 1.621517>,
      < -6.934822, -1.047827, 1.620068>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.015230, 1.626492>,
      < -6.934822, -1.029089, 1.621517>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.002278, 1.634681>,
      < -6.934822, -1.015230, 1.626492>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.990900, 1.645727>,
      < -6.934822, -1.002278, 1.634681>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.981542, 1.659213>,
      < -6.934822, -0.990900, 1.645727>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.974571, 1.674629>,
      < -6.934822, -0.981542, 1.659213>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.970271, 1.691382>,
      < -6.934822, -0.974571, 1.674629>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.968813, 1.708817>,
      < -6.934822, -0.970271, 1.691382>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.970257, 1.726254>,
      < -6.934822, -0.968813, 1.708817>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.974544, 1.743014>,
      < -6.934822, -0.970257, 1.726254>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.981502, 1.758440>,
      < -6.934822, -0.974544, 1.743014>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -0.990848, 1.771939>,
      < -6.934822, -0.981502, 1.758440>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.002217, 1.783000>,
      < -6.934822, -0.990848, 1.771939>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.015164, 1.791207>,
      < -6.934822, -1.002217, 1.783000>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.028975, 1.796187>,
      < -6.934822, -1.015164, 1.791207>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.047789, 1.797548>,
      < -6.934822, -1.028975, 1.796187>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.065271, 1.796193>,
      < -6.934822, -1.047789, 1.797548>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.081826, 1.791174>,
      < -6.934822, -1.065271, 1.796193>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.097153, 1.782981>,
      < -6.934822, -1.081826, 1.791174>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.110613, 1.771934>,
      < -6.934822, -1.097153, 1.782981>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.121684, 1.758441>,
      < -6.934822, -1.110613, 1.771934>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.129925, 1.743016>,
      < -6.934822, -1.121684, 1.758441>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.135006, 1.726254>,
      < -6.934822, -1.129925, 1.743016>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.136724, 1.708807>,
      < -6.934822, -1.135006, 1.726254>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.135006, 1.691361>,
      < -6.934822, -1.136724, 1.708807>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.129926, 1.674599>,
      < -6.934822, -1.135006, 1.691361>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.121684, 1.659175>,
      < -6.934822, -1.129926, 1.674599>
    }
    triangle {
      < -6.949224, -1.050359, 1.708820>,
      < -6.934822, -1.110614, 1.645681>,
      < -6.934822, -1.121684, 1.659175>
    }
    texture {alight}
  }
  // interior
  union {
    triangle {
      < -1.845919, 0.338823, 1.086187>,
      < -1.845950, 0.338829, 0.705669>,
      < -1.534226, 0.489469, 0.713341>
    }
    triangle {
      < -1.857452, 0.338694, 1.616905>,
      < -1.845919, 0.338823, 1.086187>,
      < -1.534226, 0.489469, 0.713341>
    }
    triangle {
      < -1.488833, 0.434764, 1.943825>,
      < -1.769608, 0.357681, 1.951595>,
      < -1.798078, 0.350158, 1.888693>
    }
    triangle {
      < -1.488833, 0.434764, 1.943825>,
      < -1.798078, 0.350158, 1.888693>,
      < -1.857452, 0.338694, 1.616905>
    }
    texture {interior}
  }
  // glass
  union {
    triangle {
      < -0.649581, 1.526013, -2.336698>,
      < -0.627246, 0.591351, -2.514760>,
      < -0.928116, 0.602701, -2.503510>
    }
    triangle {
      < -0.649581, 1.526013, -2.336698>,
      < -0.928116, 0.602701, -2.503510>,
      < -0.950451, 1.525363, -2.342247>
    }
    triangle {
      < -0.626836, 0.590539, -2.470842>,
      < -0.649177, 1.525230, -2.292849>,
      < -0.947583, 1.527573, -2.301732>
    }
    triangle {
      < -0.626836, 0.590539, -2.470842>,
      < -0.947583, 1.527573, -2.301732>,
      < -0.924028, 0.604633, -2.464607>
    }
    triangle {
      < -0.950451, 1.525363, 2.342247>,
      < -0.928116, 0.602701, 2.503510>,
      < -0.627246, 0.591351, 2.514760>
    }
    triangle {
      < -0.950451, 1.525363, 2.342247>,
      < -0.627246, 0.591351, 2.514760>,
      < -0.649581, 1.526013, 2.336698>
    }
    triangle {
      < -0.924028, 0.604633, 2.464607>,
      < -0.947583, 1.527573, 2.301732>,
      < -0.649177, 1.525230, 2.292849>
    }
    triangle {
      < -0.924028, 0.604633, 2.464607>,
      < -0.649177, 1.525230, 2.292849>,
      < -0.626836, 0.590539, 2.470842>
    }
    texture {glass}
  }
  // interior
  union {
    triangle {
      < -2.288326, -0.243897, -2.367348>,
      < -3.124098, -0.304644, -2.367348>,
      < -1.063298, -0.235892, -2.368628>
    }
    triangle {
      < -1.063298, -0.235892, 2.368628>,
      < -3.124098, -0.304644, 2.367348>,
      < -2.288326, -0.243897, 2.367348>
    }
    triangle {
      < -3.124035, -0.289859, 0.724256>,
      < -3.124036, -0.287589, 0.462324>,
      < -2.270467, -0.243776, 0.000000>
    }
    triangle {
      < -3.124035, -0.289859, 0.724256>,
      < -2.270467, -0.243776, 0.000000>,
      < -2.270328, -0.243791, 1.086187>
    }
    triangle {
      < -3.124036, -0.287589, 0.462324>,
      < -3.124036, -0.285856, 0.262324>,
      < -2.270467, -0.243776, 0.000000>
    }
    triangle {
      < -3.124036, -0.285856, 0.262324>,
      < -3.124036, -0.283587, 0.000000>,
      < -2.270467, -0.243776, 0.000000>
    }
    triangle {
      < -2.270328, -0.243791, -1.086187>,
      < -2.270467, -0.243776, 0.000000>,
      < -3.124036, -0.287589, -0.462324>
    }
    triangle {
      < -2.270328, -0.243791, -1.086187>,
      < -3.124036, -0.287589, -0.462324>,
      < -3.124035, -0.289859, -0.724256>
    }
    triangle {
      < -2.270467, -0.243776, 0.000000>,
      < -3.124036, -0.283587, 0.000000>,
      < -3.124036, -0.285856, -0.262324>
    }
    triangle {
      < -2.270467, -0.243776, 0.000000>,
      < -3.124036, -0.285856, -0.262324>,
      < -3.124036, -0.287589, -0.462324>
    }
    texture {interior}
  }
  // embwhite
  union {
    triangle {
      < -7.062660, -1.011067, -0.432676>,
      < -7.064786, -1.029065, -0.445514>,
      < -7.069734, -1.050319, -0.428379>
    }
    triangle {
      < -7.062660, -1.011067, -0.432676>,
      < -7.069734, -1.050319, -0.428379>,
      < -7.094644, -1.067653, -0.137597>
    }
    triangle {
      < -7.062660, -1.011067, -0.432676>,
      < -7.094644, -1.067653, -0.137597>,
      < -7.084982, -1.011654, -0.138004>
    }
    texture {embwhite}
  }
  // embred
  union {
    triangle {
      < -7.058405, -0.975069, -0.407000>,
      < -7.076698, -0.963606, -0.138298>,
      < -7.072464, -0.958079, -0.159185>
    }
    triangle {
      < -7.058405, -0.975069, -0.407000>,
      < -7.072464, -0.958079, -0.159185>,
      < -7.056583, -0.964400, -0.421163>
    }
    texture {embred}
  }
  // embblue
  union {
    triangle {
      < -7.099803, -1.054985, -0.040283>,
      < -7.100391, -1.054884, -0.032269>,
      < -7.092621, -1.009893, -0.032700>
    }
    triangle {
      < -7.099803, -1.054985, -0.040283>,
      < -7.092621, -1.009893, -0.032700>,
      < -7.097019, -1.038842, -0.040390>
    }
    texture {embblue}
  }
  // embwhite
  union {
    triangle {
      < -7.056583, -0.964400, 0.421163>,
      < -7.072464, -0.958079, 0.159185>,
      < -7.076698, -0.963606, 0.138298>
    }
    triangle {
      < -7.056583, -0.964400, 0.421163>,
      < -7.076698, -0.963606, 0.138298>,
      < -7.058404, -0.975070, 0.407000>
    }
    texture {embwhite}
  }
  // embred
  union {
    triangle {
      < -7.058405, -0.975069, -0.407000>,
      < -7.062660, -1.011067, -0.432676>,
      < -7.084982, -1.011654, -0.138004>
    }
    triangle {
      < -7.058405, -0.975069, -0.407000>,
      < -7.084982, -1.011654, -0.138004>,
      < -7.076698, -0.963606, -0.138298>
    }
    texture {embred}
  }
  // embwhite
  union {
    triangle {
      < -7.062659, -1.011067, 0.432676>,
      < -7.058404, -0.975070, 0.407000>,
      < -7.076698, -0.963606, 0.138298>
    }
    triangle {
      < -7.062659, -1.011067, 0.432676>,
      < -7.076698, -0.963606, 0.138298>,
      < -7.084981, -1.011654, 0.138004>
    }
    texture {embwhite}
  }
  // embred
  union {
    triangle {
      < -7.069733, -1.050319, 0.428379>,
      < -7.064786, -1.029065, 0.445514>,
      < -7.062659, -1.011067, 0.432676>
    }
    triangle {
      < -7.069733, -1.050319, 0.428379>,
      < -7.062659, -1.011067, 0.432676>,
      < -7.084981, -1.011654, 0.138004>
    }
    triangle {
      < -7.069733, -1.050319, 0.428379>,
      < -7.084981, -1.011654, 0.138004>,
      < -7.094642, -1.067653, 0.137597>
    }
    triangle {
      < -7.097019, -1.038843, 0.040391>,
      < -7.099802, -1.054985, 0.040283>,
      < -7.094642, -1.067653, 0.137597>
    }
    triangle {
      < -7.097019, -1.038843, 0.040391>,
      < -7.094642, -1.067653, 0.137597>,
      < -7.092330, -1.037818, 0.100228>
    }
    texture {embred}
  }
  // embwhite
  union {
    triangle {
      < -7.099803, -1.054985, -0.040283>,
      < -7.094644, -1.067653, -0.137597>,
      < -7.103739, -1.073982, -0.031413>
    }
    triangle {
      < -7.099803, -1.054985, -0.040283>,
      < -7.103739, -1.073982, -0.031413>,
      < -7.100391, -1.054884, -0.032269>
    }
    triangle {
      < -7.091205, -1.037567, -0.114580>,
      < -7.087291, -1.010155, -0.103976>,
      < -7.084982, -1.011654, -0.138004>
    }
    triangle {
      < -7.091205, -1.037567, -0.114580>,
      < -7.084982, -1.011654, -0.138004>,
      < -7.094644, -1.067653, -0.137597>
    }
    texture {embwhite}
  }
  // embred
  union {
    triangle {
      < -7.087749, -0.985100, -0.040758>,
      < -7.088336, -0.985000, -0.032747>,
      < -7.084741, -0.963822, -0.032127>
    }
    triangle {
      < -7.087749, -0.985100, -0.040758>,
      < -7.084741, -0.963822, -0.032127>,
      < -7.076698, -0.963606, -0.138298>
    }
    texture {embred}
  }
  // embwhite
  union {
    triangle {
      < -7.088336, -0.985000, 0.032749>,
      < -7.084741, -0.963822, 0.032129>,
      < -7.087167, -0.963891, -0.000123>
    }
    triangle {
      < -7.088336, -0.985000, 0.032749>,
      < -7.087167, -0.963891, -0.000123>,
      < -7.090786, -0.984579, 0.000694>
    }
    texture {embwhite}
  }
  // embblue
  union {
    triangle {
      < -7.100389, -1.054884, 0.032272>,
      < -7.092618, -1.009881, 0.032708>,
      < -7.095104, -1.009762, 0.000524>
    }
    triangle {
      < -7.100389, -1.054884, 0.032272>,
      < -7.095104, -1.009762, 0.000524>,
      < -7.102770, -1.054474, 0.000222>
    }
    texture {embblue}
  }
  // embwhite
  union {
    triangle {
      < -7.103738, -1.073982, 0.031415>,
      < -7.100389, -1.054884, 0.032272>,
      < -7.102770, -1.054474, 0.000222>
    }
    triangle {
      < -7.103738, -1.073982, 0.031415>,
      < -7.102770, -1.054474, 0.000222>,
      < -7.106380, -1.075926, -0.000833>
    }
    texture {embwhite}
  }
  // embblue
  union {
    triangle {
      < -7.090786, -0.984579, 0.000694>,
      < -7.095104, -1.009762, 0.000524>,
      < -7.092618, -1.009881, 0.032708>
    }
    triangle {
      < -7.090786, -0.984579, 0.000694>,
      < -7.092618, -1.009881, 0.032708>,
      < -7.088336, -0.985000, 0.032749>
    }
    triangle {
      < -7.090644, -1.001881, -0.040642>,
      < -7.085999, -1.001105, -0.100475>,
      < -7.087291, -1.010155, -0.103976>
    }
    triangle {
      < -7.090644, -1.001881, -0.040642>,
      < -7.087291, -1.010155, -0.103976>,
      < -7.092621, -1.009893, -0.032700>
    }
    texture {embblue}
  }
  // embwhite
  union {
    triangle {
      < -7.076698, -0.963606, 0.138298>,
      < -7.084884, -1.000924, 0.114829>,
      < -7.086744, -1.010140, 0.111182>
    }
    triangle {
      < -7.076698, -0.963606, 0.138298>,
      < -7.086744, -1.010140, 0.111182>,
      < -7.084981, -1.011654, 0.138004>
    }
    texture {embwhite}
  }
  // embred
  union {
    triangle {
      < -7.090644, -1.001881, -0.040642>,
      < -7.087749, -0.985100, -0.040758>,
      < -7.076698, -0.963606, -0.138298>
    }
    triangle {
      < -7.090644, -1.001881, -0.040642>,
      < -7.076698, -0.963606, -0.138298>,
      < -7.085999, -1.001105, -0.100475>
    }
    texture {embred}
  }
  // embwhite
  union {
    triangle {
      < -7.087749, -0.985101, 0.040758>,
      < -7.076698, -0.963606, 0.138298>,
      < -7.084741, -0.963822, 0.032129>
    }
    triangle {
      < -7.087749, -0.985101, 0.040758>,
      < -7.084741, -0.963822, 0.032129>,
      < -7.088336, -0.985000, 0.032749>
    }
    texture {embwhite}
  }
  // embblue
  union {
    triangle {
      < -7.090643, -1.001882, 0.040642>,
      < -7.087749, -0.985101, 0.040758>,
      < -7.088336, -0.985000, 0.032749>
    }
    triangle {
      < -7.090643, -1.001882, 0.040642>,
      < -7.088336, -0.985000, 0.032749>,
      < -7.092618, -1.009881, 0.032708>
    }
    triangle {
      < -7.092330, -1.037818, 0.100228>,
      < -7.086744, -1.010140, 0.111182>,
      < -7.092618, -1.009881, 0.032708>
    }
    triangle {
      < -7.092330, -1.037818, 0.100228>,
      < -7.092618, -1.009881, 0.032708>,
      < -7.097019, -1.038843, 0.040391>
    }
    texture {embblue}
  }
  // embred
  union {
    triangle {
      < -7.094642, -1.067653, 0.137597>,
      < -7.099802, -1.054985, 0.040283>,
      < -7.100389, -1.054884, 0.032272>
    }
    triangle {
      < -7.094642, -1.067653, 0.137597>,
      < -7.100389, -1.054884, 0.032272>,
      < -7.103738, -1.073982, 0.031415>
    }
    texture {embred}
  }
  // embwhite
  union {
    triangle {
      < -7.106380, -1.075926, -0.000833>,
      < -7.102770, -1.054474, 0.000222>,
      < -7.100391, -1.054884, -0.032269>
    }
    triangle {
      < -7.106380, -1.075926, -0.000833>,
      < -7.100391, -1.054884, -0.032269>,
      < -7.103739, -1.073982, -0.031413>
    }
    texture {embwhite}
  }
  // embblue
  union {
    triangle {
      < -7.102770, -1.054474, 0.000222>,
      < -7.095104, -1.009762, 0.000524>,
      < -7.092621, -1.009893, -0.032700>
    }
    triangle {
      < -7.102770, -1.054474, 0.000222>,
      < -7.092621, -1.009893, -0.032700>,
      < -7.100391, -1.054884, -0.032269>
    }
    triangle {
      < -7.095104, -1.009762, 0.000524>,
      < -7.090786, -0.984579, 0.000694>,
      < -7.088336, -0.985000, -0.032747>
    }
    triangle {
      < -7.095104, -1.009762, 0.000524>,
      < -7.088336, -0.985000, -0.032747>,
      < -7.092621, -1.009893, -0.032700>
    }
    texture {embblue}
  }
  // embwhite
  union {
    triangle {
      < -7.090786, -0.984579, 0.000694>,
      < -7.087167, -0.963891, -0.000123>,
      < -7.084741, -0.963822, -0.032127>
    }
    triangle {
      < -7.090786, -0.984579, 0.000694>,
      < -7.084741, -0.963822, -0.032127>,
      < -7.088336, -0.985000, -0.032747>
    }
    texture {embwhite}
  }
  // embblue
  union {
    triangle {
      < -7.100389, -1.054884, 0.032272>,
      < -7.099802, -1.054985, 0.040283>,
      < -7.097019, -1.038843, 0.040391>
    }
    triangle {
      < -7.100389, -1.054884, 0.032272>,
      < -7.097019, -1.038843, 0.040391>,
      < -7.092618, -1.009881, 0.032708>
    }
    triangle {
      < -7.086744, -1.010140, 0.111182>,
      < -7.084884, -1.000924, 0.114829>,
      < -7.090643, -1.001882, 0.040642>
    }
    triangle {
      < -7.086744, -1.010140, 0.111182>,
      < -7.090643, -1.001882, 0.040642>,
      < -7.092618, -1.009881, 0.032708>
    }
    texture {embblue}
  }
  // embred
  union {
    triangle {
      < -7.084982, -1.011654, -0.138004>,
      < -7.087291, -1.010155, -0.103976>,
      < -7.085999, -1.001105, -0.100475>
    }
    triangle {
      < -7.084982, -1.011654, -0.138004>,
      < -7.085999, -1.001105, -0.100475>,
      < -7.076698, -0.963606, -0.138298>
    }
    texture {embred}
  }
  // embwhite
  union {
    triangle {
      < -7.087749, -0.985101, 0.040758>,
      < -7.090643, -1.001882, 0.040642>,
      < -7.084884, -1.000924, 0.114829>
    }
    triangle {
      < -7.087749, -0.985101, 0.040758>,
      < -7.084884, -1.000924, 0.114829>,
      < -7.076698, -0.963606, 0.138298>
    }
    texture {embwhite}
  }
  // embblue
  union {
    triangle {
      < -7.088336, -0.985000, -0.032747>,
      < -7.087749, -0.985100, -0.040758>,
      < -7.090644, -1.001881, -0.040642>
    }
    triangle {
      < -7.088336, -0.985000, -0.032747>,
      < -7.090644, -1.001881, -0.040642>,
      < -7.092621, -1.009893, -0.032700>
    }
    texture {embblue}
  }
  // embwhite
  union {
    triangle {
      < -7.099803, -1.054985, -0.040283>,
      < -7.097019, -1.038842, -0.040390>,
      < -7.091205, -1.037567, -0.114580>
    }
    triangle {
      < -7.099803, -1.054985, -0.040283>,
      < -7.091205, -1.037567, -0.114580>,
      < -7.094644, -1.067653, -0.137597>
    }
    texture {embwhite}
  }
  // embred
  union {
    triangle {
      < -7.084981, -1.011654, 0.138004>,
      < -7.086744, -1.010140, 0.111182>,
      < -7.092330, -1.037818, 0.100228>
    }
    triangle {
      < -7.084981, -1.011654, 0.138004>,
      < -7.092330, -1.037818, 0.100228>,
      < -7.094642, -1.067653, 0.137597>
    }
    texture {embred}
  }
  // embblue
  union {
    triangle {
      < -7.087291, -1.010155, -0.103976>,
      < -7.091205, -1.037567, -0.114580>,
      < -7.097019, -1.038842, -0.040390>
    }
    triangle {
      < -7.087291, -1.010155, -0.103976>,
      < -7.097019, -1.038842, -0.040390>,
      < -7.092621, -1.009893, -0.032700>
    }
    texture {embblue}
  }
  // rubber
  union {
    triangle {
      < -7.313999, -1.046512, 2.578587>,
      < -7.313999, -1.094400, 2.586172>,
      < -7.237774, -1.094400, 2.632995>
    }
    triangle {
      < -7.313999, -1.046512, 2.578587>,
      < -7.237774, -1.094400, 2.632995>,
      < -7.237774, -1.032043, 2.623118>
    }
    triangle {
      < -7.313999, -1.094400, 2.586172>,
      < -7.313999, -1.142289, 2.578587>,
      < -7.237774, -1.156758, 2.623118>
    }
    triangle {
      < -7.313999, -1.094400, 2.586172>,
      < -7.237774, -1.156758, 2.623118>,
      < -7.237774, -1.094400, 2.632995>
    }
    triangle {
      < -7.313999, -1.142289, 2.578587>,
      < -7.313999, -1.185490, 2.556575>,
      < -7.237774, -1.213012, 2.594456>
    }
    triangle {
      < -7.313999, -1.142289, 2.578587>,
      < -7.237774, -1.213012, 2.594456>,
      < -7.237774, -1.156758, 2.623118>
    }
    triangle {
      < -7.313999, -1.185490, 2.556575>,
      < -7.313999, -1.219774, 2.522290>,
      < -7.237774, -1.257655, 2.549812>
    }
    triangle {
      < -7.313999, -1.185490, 2.556575>,
      < -7.237774, -1.257655, 2.549812>,
      < -7.237774, -1.213012, 2.594456>
    }
    triangle {
      < -7.313999, -1.219774, 2.522290>,
      < -7.313999, -1.241787, 2.479089>,
      < -7.237774, -1.286318, 2.493558>
    }
    triangle {
      < -7.313999, -1.219774, 2.522290>,
      < -7.237774, -1.286318, 2.493558>,
      < -7.237774, -1.257655, 2.549812>
    }
    triangle {
      < -7.313999, -1.241787, 2.479089>,
      < -7.313999, -1.249372, 2.431200>,
      < -7.237774, -1.296195, 2.431200>
    }
    triangle {
      < -7.313999, -1.241787, 2.479089>,
      < -7.237774, -1.296195, 2.431200>,
      < -7.237774, -1.286318, 2.493558>
    }
    triangle {
      < -7.313999, -1.249372, 2.431200>,
      < -7.313999, -1.241787, 2.383312>,
      < -7.237774, -1.286318, 2.368843>
    }
    triangle {
      < -7.313999, -1.249372, 2.431200>,
      < -7.237774, -1.286318, 2.368843>,
      < -7.237774, -1.296195, 2.431200>
    }
    triangle {
      < -7.313999, -1.241787, 2.383312>,
      < -7.313999, -1.219774, 2.340111>,
      < -7.237774, -1.257655, 2.312589>
    }
    triangle {
      < -7.313999, -1.241787, 2.383312>,
      < -7.237774, -1.257655, 2.312589>,
      < -7.237774, -1.286318, 2.368843>
    }
    triangle {
      < -7.313999, -1.219774, 2.340111>,
      < -7.313999, -1.185490, 2.305826>,
      < -7.237774, -1.213012, 2.267945>
    }
    triangle {
      < -7.313999, -1.219774, 2.340111>,
      < -7.237774, -1.213012, 2.267945>,
      < -7.237774, -1.257655, 2.312589>
    }
    triangle {
      < -7.313999, -1.185490, 2.305826>,
      < -7.313999, -1.142289, 2.283813>,
      < -7.237774, -1.156758, 2.239282>
    }
    triangle {
      < -7.313999, -1.185490, 2.305826>,
      < -7.237774, -1.156758, 2.239282>,
      < -7.237774, -1.213012, 2.267945>
    }
    triangle {
      < -7.313999, -1.142289, 2.283813>,
      < -7.313999, -1.094400, 2.276229>,
      < -7.237774, -1.094400, 2.229406>
    }
    triangle {
      < -7.313999, -1.142289, 2.283813>,
      < -7.237774, -1.094400, 2.229406>,
      < -7.237774, -1.156758, 2.239282>
    }
    triangle {
      < -7.313999, -1.094400, 2.276229>,
      < -7.313999, -1.046512, 2.283813>,
      < -7.237774, -1.032043, 2.239282>
    }
    triangle {
      < -7.313999, -1.094400, 2.276229>,
      < -7.237774, -1.032043, 2.239282>,
      < -7.237774, -1.094400, 2.229406>
    }
    triangle {
      < -7.313999, -1.046512, 2.283813>,
      < -7.313999, -1.003310, 2.305826>,
      < -7.237774, -0.975788, 2.267945>
    }
    triangle {
      < -7.313999, -1.046512, 2.283813>,
      < -7.237774, -0.975788, 2.267945>,
      < -7.237774, -1.032043, 2.239282>
    }
    triangle {
      < -7.313999, -1.003310, 2.305826>,
      < -7.313999, -0.969026, 2.340111>,
      < -7.237774, -0.931145, 2.312589>
    }
    triangle {
      < -7.313999, -1.003310, 2.305826>,
      < -7.237774, -0.931145, 2.312589>,
      < -7.237774, -0.975788, 2.267945>
    }
    triangle {
      < -7.313999, -0.969026, 2.340111>,
      < -7.313999, -0.947014, 2.383312>,
      < -7.237774, -0.902483, 2.368843>
    }
    triangle {
      < -7.313999, -0.969026, 2.340111>,
      < -7.237774, -0.902483, 2.368843>,
      < -7.237774, -0.931145, 2.312589>
    }
    triangle {
      < -7.313999, -0.947014, 2.383312>,
      < -7.313999, -0.939429, 2.431200>,
      < -7.237774, -0.892606, 2.431200>
    }
    triangle {
      < -7.313999, -0.947014, 2.383312>,
      < -7.237774, -0.892606, 2.431200>,
      < -7.237774, -0.902483, 2.368843>
    }
    triangle {
      < -7.313999, -0.939429, 2.431200>,
      < -7.313999, -0.947014, 2.479089>,
      < -7.237774, -0.902483, 2.493558>
    }
    triangle {
      < -7.313999, -0.939429, 2.431200>,
      < -7.237774, -0.902483, 2.493558>,
      < -7.237774, -0.892606, 2.431200>
    }
    triangle {
      < -7.313999, -0.947014, 2.479089>,
      < -7.313999, -0.969026, 2.522290>,
      < -7.237774, -0.931145, 2.549812>
    }
    triangle {
      < -7.313999, -0.947014, 2.479089>,
      < -7.237774, -0.931145, 2.549812>,
      < -7.237774, -0.902483, 2.493558>
    }
    triangle {
      < -7.313999, -0.969026, 2.522290>,
      < -7.313999, -1.003310, 2.556575>,
      < -7.237774, -0.975788, 2.594456>
    }
    triangle {
      < -7.313999, -0.969026, 2.522290>,
      < -7.237774, -0.975788, 2.594456>,
      < -7.237774, -0.931145, 2.549812>
    }
    triangle {
      < -7.313999, -1.003310, 2.556575>,
      < -7.313999, -1.046512, 2.578587>,
      < -7.237774, -1.032043, 2.623118>
    }
    triangle {
      < -7.313999, -1.003310, 2.556575>,
      < -7.237774, -1.032043, 2.623118>,
      < -7.237774, -0.975788, 2.594456>
    }
    triangle {
      < -7.313999, -1.094400, -2.586172>,
      < -7.313999, -1.046512, -2.578587>,
      < -7.237774, -1.032043, -2.623118>
    }
    triangle {
      < -7.313999, -1.094400, -2.586172>,
      < -7.237774, -1.032043, -2.623118>,
      < -7.237774, -1.094400, -2.632995>
    }
    triangle {
      < -7.313999, -1.046512, -2.578587>,
      < -7.313999, -1.003310, -2.556575>,
      < -7.237774, -0.975788, -2.594456>
    }
    triangle {
      < -7.313999, -1.046512, -2.578587>,
      < -7.237774, -0.975788, -2.594456>,
      < -7.237774, -1.032043, -2.623118>
    }
    triangle {
      < -7.313999, -1.003310, -2.556575>,
      < -7.313999, -0.969026, -2.522290>,
      < -7.237774, -0.931145, -2.549812>
    }
    triangle {
      < -7.313999, -1.003310, -2.556575>,
      < -7.237774, -0.931145, -2.549812>,
      < -7.237774, -0.975788, -2.594456>
    }
    triangle {
      < -7.313999, -0.969026, -2.522290>,
      < -7.313999, -0.947014, -2.479089>,
      < -7.237774, -0.902483, -2.493558>
    }
    triangle {
      < -7.313999, -0.969026, -2.522290>,
      < -7.237774, -0.902483, -2.493558>,
      < -7.237774, -0.931145, -2.549812>
    }
    triangle {
      < -7.313999, -0.947014, -2.479089>,
      < -7.313999, -0.939429, -2.431200>,
      < -7.237774, -0.892606, -2.431200>
    }
    triangle {
      < -7.313999, -0.947014, -2.479089>,
      < -7.237774, -0.892606, -2.431200>,
      < -7.237774, -0.902483, -2.493558>
    }
    triangle {
      < -7.313999, -0.939429, -2.431200>,
      < -7.313999, -0.947014, -2.383312>,
      < -7.237774, -0.902483, -2.368843>
    }
    triangle {
      < -7.313999, -0.939429, -2.431200>,
      < -7.237774, -0.902483, -2.368843>,
      < -7.237774, -0.892606, -2.431200>
    }
    triangle {
      < -7.313999, -0.947014, -2.383312>,
      < -7.313999, -0.969026, -2.340111>,
      < -7.237774, -0.931145, -2.312589>
    }
    triangle {
      < -7.313999, -0.947014, -2.383312>,
      < -7.237774, -0.931145, -2.312589>,
      < -7.237774, -0.902483, -2.368843>
    }
    triangle {
      < -7.313999, -0.969026, -2.340111>,
      < -7.313999, -1.003310, -2.305826>,
      < -7.237774, -0.975788, -2.267945>
    }
    triangle {
      < -7.313999, -0.969026, -2.340111>,
      < -7.237774, -0.975788, -2.267945>,
      < -7.237774, -0.931145, -2.312589>
    }
    triangle {
      < -7.313999, -1.003310, -2.305826>,
      < -7.313999, -1.046512, -2.283813>,
      < -7.237774, -1.032043, -2.239282>
    }
    triangle {
      < -7.313999, -1.003310, -2.305826>,
      < -7.237774, -1.032043, -2.239282>,
      < -7.237774, -0.975788, -2.267945>
    }
    triangle {
      < -7.313999, -1.046512, -2.283813>,
      < -7.313999, -1.094400, -2.276229>,
      < -7.237774, -1.094400, -2.229406>
    }
    triangle {
      < -7.313999, -1.046512, -2.283813>,
      < -7.237774, -1.094400, -2.229406>,
      < -7.237774, -1.032043, -2.239282>
    }
    triangle {
      < -7.313999, -1.094400, -2.276229>,
      < -7.313999, -1.142289, -2.283813>,
      < -7.237774, -1.156758, -2.239282>
    }
    triangle {
      < -7.313999, -1.094400, -2.276229>,
      < -7.237774, -1.156758, -2.239282>,
      < -7.237774, -1.094400, -2.229406>
    }
    triangle {
      < -7.313999, -1.142289, -2.283813>,
      < -7.313999, -1.185490, -2.305826>,
      < -7.237774, -1.213012, -2.267945>
    }
    triangle {
      < -7.313999, -1.142289, -2.283813>,
      < -7.237774, -1.213012, -2.267945>,
      < -7.237774, -1.156758, -2.239282>
    }
    triangle {
      < -7.313999, -1.185490, -2.305826>,
      < -7.313999, -1.219774, -2.340111>,
      < -7.237774, -1.257655, -2.312589>
    }
    triangle {
      < -7.313999, -1.185490, -2.305826>,
      < -7.237774, -1.257655, -2.312589>,
      < -7.237774, -1.213012, -2.267945>
    }
    triangle {
      < -7.313999, -1.219774, -2.340111>,
      < -7.313999, -1.241787, -2.383312>,
      < -7.237774, -1.286318, -2.368843>
    }
    triangle {
      < -7.313999, -1.219774, -2.340111>,
      < -7.237774, -1.286318, -2.368843>,
      < -7.237774, -1.257655, -2.312589>
    }
    triangle {
      < -7.313999, -1.241787, -2.383312>,
      < -7.313999, -1.249372, -2.431200>,
      < -7.237774, -1.296195, -2.431200>
    }
    triangle {
      < -7.313999, -1.241787, -2.383312>,
      < -7.237774, -1.296195, -2.431200>,
      < -7.237774, -1.286318, -2.368843>
    }
    triangle {
      < -7.313999, -1.249372, -2.431200>,
      < -7.313999, -1.241787, -2.479089>,
      < -7.237774, -1.286318, -2.493558>
    }
    triangle {
      < -7.313999, -1.249372, -2.431200>,
      < -7.237774, -1.286318, -2.493558>,
      < -7.237774, -1.296195, -2.431200>
    }
    triangle {
      < -7.313999, -1.241787, -2.479089>,
      < -7.313999, -1.219774, -2.522290>,
      < -7.237774, -1.257655, -2.549812>
    }
    triangle {
      < -7.313999, -1.241787, -2.479089>,
      < -7.237774, -1.257655, -2.549812>,
      < -7.237774, -1.286318, -2.493558>
    }
    triangle {
      < -7.313999, -1.219774, -2.522290>,
      < -7.313999, -1.185490, -2.556575>,
      < -7.237774, -1.213012, -2.594456>
    }
    triangle {
      < -7.313999, -1.219774, -2.522290>,
      < -7.237774, -1.213012, -2.594456>,
      < -7.237774, -1.257655, -2.549812>
    }
    triangle {
      < -7.313999, -1.185490, -2.556575>,
      < -7.313999, -1.142289, -2.578587>,
      < -7.237774, -1.156758, -2.623118>
    }
    triangle {
      < -7.313999, -1.185490, -2.556575>,
      < -7.237774, -1.156758, -2.623118>,
      < -7.237774, -1.213012, -2.594456>
    }
    triangle {
      < -7.313999, -1.142289, -2.578587>,
      < -7.313999, -1.094400, -2.586172>,
      < -7.237774, -1.094400, -2.632995>
    }
    triangle {
      < -7.313999, -1.142289, -2.578587>,
      < -7.237774, -1.094400, -2.632995>,
      < -7.237774, -1.156758, -2.623118>
    }
    triangle {
      < -7.313999, -1.009261, 2.314017>,
      < -7.313999, -0.977217, 2.346062>,
      < -7.313999, -0.969026, 2.340111>
    }
    triangle {
      < -7.313999, -1.009261, 2.314017>,
      < -7.313999, -0.969026, 2.340111>,
      < -7.313999, -1.003310, 2.305826>
    }
    triangle {
      < -7.313999, -0.977217, 2.346062>,
      < -7.313999, -0.956643, 2.386441>,
      < -7.313999, -0.947014, 2.383312>
    }
    triangle {
      < -7.313999, -0.977217, 2.346062>,
      < -7.313999, -0.947014, 2.383312>,
      < -7.313999, -0.969026, 2.340111>
    }
    triangle {
      < -7.313999, -0.956643, 2.386441>,
      < -7.313999, -0.949554, 2.431200>,
      < -7.313999, -0.939429, 2.431200>
    }
    triangle {
      < -7.313999, -0.956643, 2.386441>,
      < -7.313999, -0.939429, 2.431200>,
      < -7.313999, -0.947014, 2.383312>
    }
    triangle {
      < -7.313999, -0.949554, 2.431200>,
      < -7.313999, -0.956643, 2.475960>,
      < -7.313999, -0.947014, 2.479089>
    }
    triangle {
      < -7.313999, -0.949554, 2.431200>,
      < -7.313999, -0.947014, 2.479089>,
      < -7.313999, -0.939429, 2.431200>
    }
    triangle {
      < -7.313999, -0.956643, 2.475960>,
      < -7.313999, -0.977217, 2.516338>,
      < -7.313999, -0.969026, 2.522290>
    }
    triangle {
      < -7.313999, -0.956643, 2.475960>,
      < -7.313999, -0.969026, 2.522290>,
      < -7.313999, -0.947014, 2.479089>
    }
    triangle {
      < -7.313999, -0.977217, 2.516338>,
      < -7.313999, -1.009261, 2.548384>,
      < -7.313999, -1.003310, 2.556575>
    }
    triangle {
      < -7.313999, -0.977217, 2.516338>,
      < -7.313999, -1.003310, 2.556575>,
      < -7.313999, -0.969026, 2.522290>
    }
    triangle {
      < -7.313999, -1.009261, 2.548384>,
      < -7.313999, -1.049640, 2.568958>,
      < -7.313999, -1.046512, 2.578587>
    }
    triangle {
      < -7.313999, -1.009261, 2.548384>,
      < -7.313999, -1.046512, 2.578587>,
      < -7.313999, -1.003310, 2.556575>
    }
    triangle {
      < -7.313999, -1.049640, 2.568958>,
      < -7.313999, -1.094400, 2.576047>,
      < -7.313999, -1.094400, 2.586172>
    }
    triangle {
      < -7.313999, -1.049640, 2.568958>,
      < -7.313999, -1.094400, 2.586172>,
      < -7.313999, -1.046512, 2.578587>
    }
    triangle {
      < -7.313999, -1.094400, 2.576047>,
      < -7.313999, -1.139161, 2.568958>,
      < -7.313999, -1.142289, 2.578587>
    }
    triangle {
      < -7.313999, -1.094400, 2.576047>,
      < -7.313999, -1.142289, 2.578587>,
      < -7.313999, -1.094400, 2.586172>
    }
    triangle {
      < -7.313999, -1.139161, 2.568958>,
      < -7.313999, -1.179539, 2.548384>,
      < -7.313999, -1.185490, 2.556575>
    }
    triangle {
      < -7.313999, -1.139161, 2.568958>,
      < -7.313999, -1.185490, 2.556575>,
      < -7.313999, -1.142289, 2.578587>
    }
    triangle {
      < -7.313999, -1.179539, 2.548384>,
      < -7.313999, -1.211583, 2.516338>,
      < -7.313999, -1.219774, 2.522290>
    }
    triangle {
      < -7.313999, -1.179539, 2.548384>,
      < -7.313999, -1.219774, 2.522290>,
      < -7.313999, -1.185490, 2.556575>
    }
    triangle {
      < -7.313999, -1.211583, 2.516338>,
      < -7.313999, -1.232158, 2.475960>,
      < -7.313999, -1.241787, 2.479089>
    }
    triangle {
      < -7.313999, -1.211583, 2.516338>,
      < -7.313999, -1.241787, 2.479089>,
      < -7.313999, -1.219774, 2.522290>
    }
    triangle {
      < -7.313999, -1.232158, 2.475960>,
      < -7.313999, -1.239247, 2.431200>,
      < -7.313999, -1.249372, 2.431200>
    }
    triangle {
      < -7.313999, -1.232158, 2.475960>,
      < -7.313999, -1.249372, 2.431200>,
      < -7.313999, -1.241787, 2.479089>
    }
    triangle {
      < -7.313999, -1.239247, 2.431200>,
      < -7.313999, -1.232158, 2.386441>,
      < -7.313999, -1.241787, 2.383312>
    }
    triangle {
      < -7.313999, -1.239247, 2.431200>,
      < -7.313999, -1.241787, 2.383312>,
      < -7.313999, -1.249372, 2.431200>
    }
    triangle {
      < -7.313999, -1.232158, 2.386441>,
      < -7.313999, -1.211583, 2.346062>,
      < -7.313999, -1.219774, 2.340111>
    }
    triangle {
      < -7.313999, -1.232158, 2.386441>,
      < -7.313999, -1.219774, 2.340111>,
      < -7.313999, -1.241787, 2.383312>
    }
    triangle {
      < -7.313999, -1.211583, 2.346062>,
      < -7.313999, -1.179539, 2.314017>,
      < -7.313999, -1.185490, 2.305826>
    }
    triangle {
      < -7.313999, -1.211583, 2.346062>,
      < -7.313999, -1.185490, 2.305826>,
      < -7.313999, -1.219774, 2.340111>
    }
    triangle {
      < -7.313999, -1.179539, 2.314017>,
      < -7.313999, -1.139161, 2.293442>,
      < -7.313999, -1.142289, 2.283813>
    }
    triangle {
      < -7.313999, -1.179539, 2.314017>,
      < -7.313999, -1.142289, 2.283813>,
      < -7.313999, -1.185490, 2.305826>
    }
    triangle {
      < -7.313999, -1.139161, 2.293442>,
      < -7.313999, -1.094400, 2.286354>,
      < -7.313999, -1.094400, 2.276229>
    }
    triangle {
      < -7.313999, -1.139161, 2.293442>,
      < -7.313999, -1.094400, 2.276229>,
      < -7.313999, -1.142289, 2.283813>
    }
    triangle {
      < -7.313999, -1.094400, 2.286354>,
      < -7.313999, -1.049641, 2.293442>,
      < -7.313999, -1.046512, 2.283813>
    }
    triangle {
      < -7.313999, -1.094400, 2.286354>,
      < -7.313999, -1.046512, 2.283813>,
      < -7.313999, -1.094400, 2.276229>
    }
    triangle {
      < -7.313999, -1.049641, 2.293442>,
      < -7.313999, -1.009261, 2.314017>,
      < -7.313999, -1.003310, 2.305826>
    }
    triangle {
      < -7.313999, -1.049641, 2.293442>,
      < -7.313999, -1.003310, 2.305826>,
      < -7.313999, -1.046512, 2.283813>
    }
    triangle {
      < -7.313999, -1.211583, -2.346062>,
      < -7.313999, -1.232158, -2.386441>,
      < -7.313999, -1.241787, -2.383312>
    }
    triangle {
      < -7.313999, -1.211583, -2.346062>,
      < -7.313999, -1.241787, -2.383312>,
      < -7.313999, -1.219774, -2.340111>
    }
    triangle {
      < -7.313999, -1.232158, -2.386441>,
      < -7.313999, -1.239247, -2.431200>,
      < -7.313999, -1.249372, -2.431200>
    }
    triangle {
      < -7.313999, -1.232158, -2.386441>,
      < -7.313999, -1.249372, -2.431200>,
      < -7.313999, -1.241787, -2.383312>
    }
    triangle {
      < -7.313999, -1.239247, -2.431200>,
      < -7.313999, -1.232158, -2.475960>,
      < -7.313999, -1.241787, -2.479089>
    }
    triangle {
      < -7.313999, -1.239247, -2.431200>,
      < -7.313999, -1.241787, -2.479089>,
      < -7.313999, -1.249372, -2.431200>
    }
    triangle {
      < -7.313999, -1.232158, -2.475960>,
      < -7.313999, -1.211583, -2.516338>,
      < -7.313999, -1.219774, -2.522290>
    }
    triangle {
      < -7.313999, -1.232158, -2.475960>,
      < -7.313999, -1.219774, -2.522290>,
      < -7.313999, -1.241787, -2.479089>
    }
    triangle {
      < -7.313999, -1.211583, -2.516338>,
      < -7.313999, -1.179539, -2.548384>,
      < -7.313999, -1.185490, -2.556575>
    }
    triangle {
      < -7.313999, -1.211583, -2.516338>,
      < -7.313999, -1.185490, -2.556575>,
      < -7.313999, -1.219774, -2.522290>
    }
    triangle {
      < -7.313999, -1.179539, -2.548384>,
      < -7.313999, -1.139161, -2.568958>,
      < -7.313999, -1.142289, -2.578587>
    }
    triangle {
      < -7.313999, -1.179539, -2.548384>,
      < -7.313999, -1.142289, -2.578587>,
      < -7.313999, -1.185490, -2.556575>
    }
    triangle {
      < -7.313999, -1.139161, -2.568958>,
      < -7.313999, -1.094400, -2.576047>,
      < -7.313999, -1.094400, -2.586172>
    }
    triangle {
      < -7.313999, -1.139161, -2.568958>,
      < -7.313999, -1.094400, -2.586172>,
      < -7.313999, -1.142289, -2.578587>
    }
    triangle {
      < -7.313999, -1.094400, -2.576047>,
      < -7.313999, -1.049641, -2.568958>,
      < -7.313999, -1.046512, -2.578587>
    }
    triangle {
      < -7.313999, -1.094400, -2.576047>,
      < -7.313999, -1.046512, -2.578587>,
      < -7.313999, -1.094400, -2.586172>
    }
    triangle {
      < -7.313999, -1.049641, -2.568958>,
      < -7.313999, -1.009261, -2.548384>,
      < -7.313999, -1.003310, -2.556575>
    }
    triangle {
      < -7.313999, -1.049641, -2.568958>,
      < -7.313999, -1.003310, -2.556575>,
      < -7.313999, -1.046512, -2.578587>
    }
    triangle {
      < -7.313999, -1.009261, -2.548384>,
      < -7.313999, -0.977217, -2.516338>,
      < -7.313999, -0.969026, -2.522290>
    }
    triangle {
      < -7.313999, -1.009261, -2.548384>,
      < -7.313999, -0.969026, -2.522290>,
      < -7.313999, -1.003310, -2.556575>
    }
    triangle {
      < -7.313999, -0.977217, -2.516338>,
      < -7.313999, -0.956643, -2.475960>,
      < -7.313999, -0.947014, -2.479089>
    }
    triangle {
      < -7.313999, -0.977217, -2.516338>,
      < -7.313999, -0.947014, -2.479089>,
      < -7.313999, -0.969026, -2.522290>
    }
    triangle {
      < -7.313999, -0.956643, -2.475960>,
      < -7.313999, -0.949554, -2.431200>,
      < -7.313999, -0.939429, -2.431200>
    }
    triangle {
      < -7.313999, -0.956643, -2.475960>,
      < -7.313999, -0.939429, -2.431200>,
      < -7.313999, -0.947014, -2.479089>
    }
    triangle {
      < -7.313999, -0.949554, -2.431200>,
      < -7.313999, -0.956643, -2.386441>,
      < -7.313999, -0.947014, -2.383312>
    }
    triangle {
      < -7.313999, -0.949554, -2.431200>,
      < -7.313999, -0.947014, -2.383312>,
      < -7.313999, -0.939429, -2.431200>
    }
    triangle {
      < -7.313999, -0.956643, -2.386441>,
      < -7.313999, -0.977217, -2.346062>,
      < -7.313999, -0.969026, -2.340111>
    }
    triangle {
      < -7.313999, -0.956643, -2.386441>,
      < -7.313999, -0.969026, -2.340111>,
      < -7.313999, -0.947014, -2.383312>
    }
    triangle {
      < -7.313999, -0.977217, -2.346062>,
      < -7.313999, -1.009261, -2.314017>,
      < -7.313999, -1.003310, -2.305826>
    }
    triangle {
      < -7.313999, -0.977217, -2.346062>,
      < -7.313999, -1.003310, -2.305826>,
      < -7.313999, -0.969026, -2.340111>
    }
    triangle {
      < -7.313999, -1.009261, -2.314017>,
      < -7.313999, -1.049641, -2.293442>,
      < -7.313999, -1.046512, -2.283813>
    }
    triangle {
      < -7.313999, -1.009261, -2.314017>,
      < -7.313999, -1.046512, -2.283813>,
      < -7.313999, -1.003310, -2.305826>
    }
    triangle {
      < -7.313999, -1.049641, -2.293442>,
      < -7.313999, -1.094400, -2.286354>,
      < -7.313999, -1.094400, -2.276229>
    }
    triangle {
      < -7.313999, -1.049641, -2.293442>,
      < -7.313999, -1.094400, -2.276229>,
      < -7.313999, -1.046512, -2.283813>
    }
    triangle {
      < -7.313999, -1.094400, -2.286354>,
      < -7.313999, -1.139161, -2.293442>,
      < -7.313999, -1.142289, -2.283813>
    }
    triangle {
      < -7.313999, -1.094400, -2.286354>,
      < -7.313999, -1.142289, -2.283813>,
      < -7.313999, -1.094400, -2.276229>
    }
    triangle {
      < -7.313999, -1.139161, -2.293442>,
      < -7.313999, -1.179539, -2.314017>,
      < -7.313999, -1.185490, -2.305826>
    }
    triangle {
      < -7.313999, -1.139161, -2.293442>,
      < -7.313999, -1.185490, -2.305826>,
      < -7.313999, -1.142289, -2.283813>
    }
    triangle {
      < -7.313999, -1.179539, -2.314017>,
      < -7.313999, -1.211583, -2.346062>,
      < -7.313999, -1.219774, -2.340111>
    }
    triangle {
      < -7.313999, -1.179539, -2.314017>,
      < -7.313999, -1.219774, -2.340111>,
      < -7.313999, -1.185490, -2.305826>
    }
    triangle {
      < -7.371199, -1.150105, -2.507872>,
      < -7.371199, -1.123686, -2.521333>,
      < -7.313999, -1.139161, -2.568958>
    }
    triangle {
      < -7.371199, -1.150105, -2.507872>,
      < -7.313999, -1.139161, -2.568958>,
      < -7.313999, -1.179539, -2.548384>
    }
    triangle {
      < -7.371199, -1.123686, -2.521333>,
      < -7.371199, -1.094400, -2.525972>,
      < -7.313999, -1.094400, -2.576047>
    }
    triangle {
      < -7.371199, -1.123686, -2.521333>,
      < -7.313999, -1.094400, -2.576047>,
      < -7.313999, -1.139161, -2.568958>
    }
    triangle {
      < -7.371199, -1.094400, -2.525972>,
      < -7.371199, -1.065114, -2.521333>,
      < -7.313999, -1.049641, -2.568958>
    }
    triangle {
      < -7.371199, -1.094400, -2.525972>,
      < -7.313999, -1.049641, -2.568958>,
      < -7.313999, -1.094400, -2.576047>
    }
    triangle {
      < -7.371199, -1.065114, -2.521333>,
      < -7.371199, -1.038695, -2.507872>,
      < -7.313999, -1.009261, -2.548384>
    }
    triangle {
      < -7.371199, -1.065114, -2.521333>,
      < -7.313999, -1.009261, -2.548384>,
      < -7.313999, -1.049641, -2.568958>
    }
    triangle {
      < -7.371199, -1.038695, -2.507872>,
      < -7.371199, -1.017728, -2.486905>,
      < -7.313999, -0.977217, -2.516338>
    }
    triangle {
      < -7.371199, -1.038695, -2.507872>,
      < -7.313999, -0.977217, -2.516338>,
      < -7.313999, -1.009261, -2.548384>
    }
    triangle {
      < -7.371199, -1.017728, -2.486905>,
      < -7.371199, -1.004267, -2.460486>,
      < -7.313999, -0.956643, -2.475960>
    }
    triangle {
      < -7.371199, -1.017728, -2.486905>,
      < -7.313999, -0.956643, -2.475960>,
      < -7.313999, -0.977217, -2.516338>
    }
    triangle {
      < -7.371199, -1.004267, -2.460486>,
      < -7.371199, -0.999629, -2.431200>,
      < -7.313999, -0.949554, -2.431200>
    }
    triangle {
      < -7.371199, -1.004267, -2.460486>,
      < -7.313999, -0.949554, -2.431200>,
      < -7.313999, -0.956643, -2.475960>
    }
    triangle {
      < -7.371199, -0.999629, -2.431200>,
      < -7.371199, -1.004267, -2.401914>,
      < -7.313999, -0.956643, -2.386441>
    }
    triangle {
      < -7.371199, -0.999629, -2.431200>,
      < -7.313999, -0.956643, -2.386441>,
      < -7.313999, -0.949554, -2.431200>
    }
    triangle {
      < -7.371199, -1.004267, -2.401914>,
      < -7.371199, -1.017728, -2.375496>,
      < -7.313999, -0.977217, -2.346062>
    }
    triangle {
      < -7.371199, -1.004267, -2.401914>,
      < -7.313999, -0.977217, -2.346062>,
      < -7.313999, -0.956643, -2.386441>
    }
    triangle {
      < -7.371199, -1.017728, -2.375496>,
      < -7.371199, -1.038695, -2.354528>,
      < -7.313999, -1.009261, -2.314017>
    }
    triangle {
      < -7.371199, -1.017728, -2.375496>,
      < -7.313999, -1.009261, -2.314017>,
      < -7.313999, -0.977217, -2.346062>
    }
    triangle {
      < -7.371199, -1.038695, -2.354528>,
      < -7.371199, -1.065114, -2.341067>,
      < -7.313999, -1.049641, -2.293442>
    }
    triangle {
      < -7.371199, -1.038695, -2.354528>,
      < -7.313999, -1.049641, -2.293442>,
      < -7.313999, -1.009261, -2.314017>
    }
    triangle {
      < -7.371199, -1.065114, -2.341067>,
      < -7.371199, -1.094400, -2.336429>,
      < -7.313999, -1.094400, -2.286354>
    }
    triangle {
      < -7.371199, -1.065114, -2.341067>,
      < -7.313999, -1.094400, -2.286354>,
      < -7.313999, -1.049641, -2.293442>
    }
    triangle {
      < -7.371199, -1.094400, -2.336429>,
      < -7.371199, -1.123686, -2.341067>,
      < -7.313999, -1.139161, -2.293442>
    }
    triangle {
      < -7.371199, -1.094400, -2.336429>,
      < -7.313999, -1.139161, -2.293442>,
      < -7.313999, -1.094400, -2.286354>
    }
    triangle {
      < -7.371199, -1.123686, -2.341067>,
      < -7.371199, -1.150105, -2.354528>,
      < -7.313999, -1.179539, -2.314017>
    }
    triangle {
      < -7.371199, -1.123686, -2.341067>,
      < -7.313999, -1.179539, -2.314017>,
      < -7.313999, -1.139161, -2.293442>
    }
    triangle {
      < -7.371199, -1.150105, -2.354528>,
      < -7.371199, -1.171072, -2.375496>,
      < -7.313999, -1.211583, -2.346062>
    }
    triangle {
      < -7.371199, -1.150105, -2.354528>,
      < -7.313999, -1.211583, -2.346062>,
      < -7.313999, -1.179539, -2.314017>
    }
    triangle {
      < -7.371199, -1.171072, -2.375496>,
      < -7.371199, -1.184533, -2.401914>,
      < -7.313999, -1.232158, -2.386441>
    }
    triangle {
      < -7.371199, -1.171072, -2.375496>,
      < -7.313999, -1.232158, -2.386441>,
      < -7.313999, -1.211583, -2.346062>
    }
    triangle {
      < -7.371199, -1.184533, -2.401914>,
      < -7.371199, -1.189172, -2.431200>,
      < -7.313999, -1.239247, -2.431200>
    }
    triangle {
      < -7.371199, -1.184533, -2.401914>,
      < -7.313999, -1.239247, -2.431200>,
      < -7.313999, -1.232158, -2.386441>
    }
    triangle {
      < -7.371199, -1.189172, -2.431200>,
      < -7.371199, -1.184533, -2.460486>,
      < -7.313999, -1.232158, -2.475960>
    }
    triangle {
      < -7.371199, -1.189172, -2.431200>,
      < -7.313999, -1.232158, -2.475960>,
      < -7.313999, -1.239247, -2.431200>
    }
    triangle {
      < -7.371199, -1.184533, -2.460486>,
      < -7.371199, -1.171072, -2.486905>,
      < -7.313999, -1.211583, -2.516338>
    }
    triangle {
      < -7.371199, -1.184533, -2.460486>,
      < -7.313999, -1.211583, -2.516338>,
      < -7.313999, -1.232158, -2.475960>
    }
    triangle {
      < -7.371199, -1.171072, -2.486905>,
      < -7.371199, -1.150105, -2.507872>,
      < -7.313999, -1.179539, -2.548384>
    }
    triangle {
      < -7.371199, -1.171072, -2.486905>,
      < -7.313999, -1.179539, -2.548384>,
      < -7.313999, -1.211583, -2.516338>
    }
    triangle {
      < -7.371199, -1.017729, 2.486905>,
      < -7.371199, -1.038695, 2.507872>,
      < -7.313999, -1.009261, 2.548384>
    }
    triangle {
      < -7.371199, -1.017729, 2.486905>,
      < -7.313999, -1.009261, 2.548384>,
      < -7.313999, -0.977217, 2.516338>
    }
    triangle {
      < -7.371199, -1.038695, 2.507872>,
      < -7.371199, -1.065114, 2.521333>,
      < -7.313999, -1.049640, 2.568958>
    }
    triangle {
      < -7.371199, -1.038695, 2.507872>,
      < -7.313999, -1.049640, 2.568958>,
      < -7.313999, -1.009261, 2.548384>
    }
    triangle {
      < -7.371199, -1.065114, 2.521333>,
      < -7.371199, -1.094400, 2.525972>,
      < -7.313999, -1.094400, 2.576047>
    }
    triangle {
      < -7.371199, -1.065114, 2.521333>,
      < -7.313999, -1.094400, 2.576047>,
      < -7.313999, -1.049640, 2.568958>
    }
    triangle {
      < -7.371199, -1.094400, 2.525972>,
      < -7.371199, -1.123686, 2.521333>,
      < -7.313999, -1.139161, 2.568958>
    }
    triangle {
      < -7.371199, -1.094400, 2.525972>,
      < -7.313999, -1.139161, 2.568958>,
      < -7.313999, -1.094400, 2.576047>
    }
    triangle {
      < -7.371199, -1.123686, 2.521333>,
      < -7.371199, -1.150105, 2.507872>,
      < -7.313999, -1.179539, 2.548384>
    }
    triangle {
      < -7.371199, -1.123686, 2.521333>,
      < -7.313999, -1.179539, 2.548384>,
      < -7.313999, -1.139161, 2.568958>
    }
    triangle {
      < -7.371199, -1.150105, 2.507872>,
      < -7.371199, -1.171072, 2.486905>,
      < -7.313999, -1.211583, 2.516338>
    }
    triangle {
      < -7.371199, -1.150105, 2.507872>,
      < -7.313999, -1.211583, 2.516338>,
      < -7.313999, -1.179539, 2.548384>
    }
    triangle {
      < -7.371199, -1.171072, 2.486905>,
      < -7.371199, -1.184533, 2.460486>,
      < -7.313999, -1.232158, 2.475960>
    }
    triangle {
      < -7.371199, -1.171072, 2.486905>,
      < -7.313999, -1.232158, 2.475960>,
      < -7.313999, -1.211583, 2.516338>
    }
    triangle {
      < -7.371199, -1.184533, 2.460486>,
      < -7.371199, -1.189172, 2.431200>,
      < -7.313999, -1.239247, 2.431200>
    }
    triangle {
      < -7.371199, -1.184533, 2.460486>,
      < -7.313999, -1.239247, 2.431200>,
      < -7.313999, -1.232158, 2.475960>
    }
    triangle {
      < -7.371199, -1.189172, 2.431200>,
      < -7.371199, -1.184533, 2.401914>,
      < -7.313999, -1.232158, 2.386441>
    }
    triangle {
      < -7.371199, -1.189172, 2.431200>,
      < -7.313999, -1.232158, 2.386441>,
      < -7.313999, -1.239247, 2.431200>
    }
    triangle {
      < -7.371199, -1.184533, 2.401914>,
      < -7.371199, -1.171072, 2.375496>,
      < -7.313999, -1.211583, 2.346062>
    }
    triangle {
      < -7.371199, -1.184533, 2.401914>,
      < -7.313999, -1.211583, 2.346062>,
      < -7.313999, -1.232158, 2.386441>
    }
    triangle {
      < -7.371199, -1.171072, 2.375496>,
      < -7.371199, -1.150105, 2.354528>,
      < -7.313999, -1.179539, 2.314017>
    }
    triangle {
      < -7.371199, -1.171072, 2.375496>,
      < -7.313999, -1.179539, 2.314017>,
      < -7.313999, -1.211583, 2.346062>
    }
    triangle {
      < -7.371199, -1.150105, 2.354528>,
      < -7.371199, -1.123686, 2.341067>,
      < -7.313999, -1.139161, 2.293442>
    }
    triangle {
      < -7.371199, -1.150105, 2.354528>,
      < -7.313999, -1.139161, 2.293442>,
      < -7.313999, -1.179539, 2.314017>
    }
    triangle {
      < -7.371199, -1.123686, 2.341067>,
      < -7.371199, -1.094400, 2.336428>,
      < -7.313999, -1.094400, 2.286354>
    }
    triangle {
      < -7.371199, -1.123686, 2.341067>,
      < -7.313999, -1.094400, 2.286354>,
      < -7.313999, -1.139161, 2.293442>
    }
    triangle {
      < -7.371199, -1.094400, 2.336428>,
      < -7.371199, -1.065114, 2.341067>,
      < -7.313999, -1.049641, 2.293442>
    }
    triangle {
      < -7.371199, -1.094400, 2.336428>,
      < -7.313999, -1.049641, 2.293442>,
      < -7.313999, -1.094400, 2.286354>
    }
    triangle {
      < -7.371199, -1.065114, 2.341067>,
      < -7.371199, -1.038695, 2.354528>,
      < -7.313999, -1.009261, 2.314017>
    }
    triangle {
      < -7.371199, -1.065114, 2.341067>,
      < -7.313999, -1.009261, 2.314017>,
      < -7.313999, -1.049641, 2.293442>
    }
    triangle {
      < -7.371199, -1.038695, 2.354528>,
      < -7.371199, -1.017729, 2.375496>,
      < -7.313999, -0.977217, 2.346062>
    }
    triangle {
      < -7.371199, -1.038695, 2.354528>,
      < -7.313999, -0.977217, 2.346062>,
      < -7.313999, -1.009261, 2.314017>
    }
    triangle {
      < -7.371199, -1.017729, 2.375496>,
      < -7.371199, -1.004267, 2.401914>,
      < -7.313999, -0.956643, 2.386441>
    }
    triangle {
      < -7.371199, -1.017729, 2.375496>,
      < -7.313999, -0.956643, 2.386441>,
      < -7.313999, -0.977217, 2.346062>
    }
    triangle {
      < -7.371199, -1.004267, 2.401914>,
      < -7.371199, -0.999629, 2.431200>,
      < -7.313999, -0.949554, 2.431200>
    }
    triangle {
      < -7.371199, -1.004267, 2.401914>,
      < -7.313999, -0.949554, 2.431200>,
      < -7.313999, -0.956643, 2.386441>
    }
    triangle {
      < -7.371199, -0.999629, 2.431200>,
      < -7.371199, -1.004267, 2.460486>,
      < -7.313999, -0.956643, 2.475960>
    }
    triangle {
      < -7.371199, -0.999629, 2.431200>,
      < -7.313999, -0.956643, 2.475960>,
      < -7.313999, -0.949554, 2.431200>
    }
    triangle {
      < -7.371199, -1.004267, 2.460486>,
      < -7.371199, -1.017729, 2.486905>,
      < -7.313999, -0.977217, 2.516338>
    }
    triangle {
      < -7.371199, -1.004267, 2.460486>,
      < -7.313999, -0.977217, 2.516338>,
      < -7.313999, -0.956643, 2.475960>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.184533, -2.460486>,
      < -7.371199, -1.189172, -2.431200>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.171072, -2.486905>,
      < -7.371199, -1.184533, -2.460486>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.150105, -2.507872>,
      < -7.371199, -1.171072, -2.486905>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.123686, -2.521333>,
      < -7.371199, -1.150105, -2.507872>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.094400, -2.525972>,
      < -7.371199, -1.123686, -2.521333>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.065114, -2.521333>,
      < -7.371199, -1.094400, -2.525972>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.038695, -2.507872>,
      < -7.371199, -1.065114, -2.521333>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.017728, -2.486905>,
      < -7.371199, -1.038695, -2.507872>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.004267, -2.460486>,
      < -7.371199, -1.017728, -2.486905>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -0.999629, -2.431200>,
      < -7.371199, -1.004267, -2.460486>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.004267, -2.401914>,
      < -7.371199, -0.999629, -2.431200>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.017728, -2.375496>,
      < -7.371199, -1.004267, -2.401914>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.038695, -2.354528>,
      < -7.371199, -1.017728, -2.375496>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.065114, -2.341067>,
      < -7.371199, -1.038695, -2.354528>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.094400, -2.336429>,
      < -7.371199, -1.065114, -2.341067>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.123686, -2.341067>,
      < -7.371199, -1.094400, -2.336429>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.150105, -2.354528>,
      < -7.371199, -1.123686, -2.341067>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.171072, -2.375496>,
      < -7.371199, -1.150105, -2.354528>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.184533, -2.401914>,
      < -7.371199, -1.171072, -2.375496>
    }
    triangle {
      < -7.435600, -1.094400, -2.431200>,
      < -7.371199, -1.189172, -2.431200>,
      < -7.371199, -1.184533, -2.401914>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -0.999629, 2.431200>,
      < -7.371199, -1.004267, 2.401914>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.004267, 2.460486>,
      < -7.371199, -0.999629, 2.431200>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.017729, 2.486905>,
      < -7.371199, -1.004267, 2.460486>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.038695, 2.507872>,
      < -7.371199, -1.017729, 2.486905>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.065114, 2.521333>,
      < -7.371199, -1.038695, 2.507872>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.094400, 2.525972>,
      < -7.371199, -1.065114, 2.521333>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.123686, 2.521333>,
      < -7.371199, -1.094400, 2.525972>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.150105, 2.507872>,
      < -7.371199, -1.123686, 2.521333>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.171072, 2.486905>,
      < -7.371199, -1.150105, 2.507872>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.184533, 2.460486>,
      < -7.371199, -1.171072, 2.486905>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.189172, 2.431200>,
      < -7.371199, -1.184533, 2.460486>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.184533, 2.401914>,
      < -7.371199, -1.189172, 2.431200>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.171072, 2.375496>,
      < -7.371199, -1.184533, 2.401914>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.150105, 2.354528>,
      < -7.371199, -1.171072, 2.375496>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.123686, 2.341067>,
      < -7.371199, -1.150105, 2.354528>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.094400, 2.336428>,
      < -7.371199, -1.123686, 2.341067>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.065114, 2.341067>,
      < -7.371199, -1.094400, 2.336428>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.038695, 2.354528>,
      < -7.371199, -1.065114, 2.341067>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.017729, 2.375496>,
      < -7.371199, -1.038695, 2.354528>
    }
    triangle {
      < -7.435600, -1.094400, 2.431200>,
      < -7.371199, -1.004267, 2.401914>,
      < -7.371199, -1.017729, 2.375496>
    }
    texture {rubber}
  }
  // blacko
  union {
    triangle {
      < -6.851050, -1.551863, 0.174104>,
      < -6.851050, -1.603042, 0.174104>,
      < -6.834615, -1.603042, 0.324351>
    }
    triangle {
      < -6.851050, -1.551863, 0.174104>,
      < -6.834615, -1.603042, 0.324351>,
      < -6.834615, -1.551863, 0.324351>
    }
    triangle {
      < -6.580181, -1.551863, -2.650473>,
      < -6.580181, -1.603042, -2.650473>,
      < -6.596616, -1.603042, -2.500227>
    }
    triangle {
      < -6.580181, -1.551863, -2.650473>,
      < -6.596616, -1.603042, -2.500227>,
      < -6.596616, -1.551863, -2.500227>
    }
    triangle {
      < -6.616529, -1.603042, -2.318170>,
      < -6.632964, -1.603042, -2.167923>,
      < -6.632964, -1.551863, -2.167923>
    }
    triangle {
      < -6.616529, -1.603042, -2.318170>,
      < -6.632964, -1.551863, -2.167923>,
      < -6.616529, -1.551863, -2.318170>
    }
    triangle {
      < -6.598355, -1.603042, -2.484322>,
      < -6.614789, -1.603042, -2.334075>,
      < -6.614789, -1.551863, -2.334075>
    }
    triangle {
      < -6.598355, -1.603042, -2.484322>,
      < -6.614789, -1.551863, -2.334075>,
      < -6.598355, -1.551863, -2.484322>
    }
    triangle {
      < -6.652877, -1.603042, -1.985867>,
      < -6.669312, -1.603042, -1.835620>,
      < -6.669312, -1.551863, -1.835620>
    }
    triangle {
      < -6.652877, -1.603042, -1.985867>,
      < -6.669312, -1.551863, -1.835620>,
      < -6.652877, -1.551863, -1.985867>
    }
    triangle {
      < -6.634703, -1.603042, -2.152018>,
      < -6.651138, -1.603042, -2.001772>,
      < -6.651138, -1.551863, -2.001772>
    }
    triangle {
      < -6.634703, -1.603042, -2.152018>,
      < -6.651138, -1.551863, -2.001772>,
      < -6.634703, -1.551863, -2.152018>
    }
    triangle {
      < -6.689225, -1.603042, -1.653563>,
      < -6.705659, -1.603042, -1.503317>,
      < -6.705659, -1.551863, -1.503317>
    }
    triangle {
      < -6.689225, -1.603042, -1.653563>,
      < -6.705659, -1.551863, -1.503317>,
      < -6.689225, -1.551863, -1.653563>
    }
    triangle {
      < -6.671051, -1.603042, -1.819715>,
      < -6.687486, -1.603042, -1.669468>,
      < -6.687486, -1.551863, -1.669469>
    }
    triangle {
      < -6.671051, -1.603042, -1.819715>,
      < -6.687486, -1.551863, -1.669469>,
      < -6.671051, -1.551863, -1.819715>
    }
    triangle {
      < -6.725573, -1.603042, -1.321260>,
      < -6.742008, -1.603042, -1.171014>,
      < -6.742008, -1.551863, -1.171014>
    }
    triangle {
      < -6.725573, -1.603042, -1.321260>,
      < -6.742008, -1.551863, -1.171014>,
      < -6.725573, -1.551863, -1.321260>
    }
    triangle {
      < -6.707399, -1.603042, -1.487412>,
      < -6.723834, -1.603042, -1.337165>,
      < -6.723834, -1.551863, -1.337165>
    }
    triangle {
      < -6.707399, -1.603042, -1.487412>,
      < -6.723834, -1.551863, -1.337165>,
      < -6.707399, -1.551863, -1.487412>
    }
    triangle {
      < -6.761921, -1.603042, -0.988957>,
      < -6.778356, -1.603042, -0.838710>,
      < -6.778356, -1.551863, -0.838710>
    }
    triangle {
      < -6.761921, -1.603042, -0.988957>,
      < -6.778356, -1.551863, -0.838710>,
      < -6.761921, -1.551863, -0.988957>
    }
    triangle {
      < -6.743747, -1.603042, -1.155109>,
      < -6.760181, -1.603042, -1.004862>,
      < -6.760181, -1.551863, -1.004862>
    }
    triangle {
      < -6.743747, -1.603042, -1.155109>,
      < -6.760181, -1.551863, -1.004862>,
      < -6.743747, -1.551863, -1.155109>
    }
    triangle {
      < -6.798269, -1.603042, -0.656654>,
      < -6.814703, -1.603042, -0.506407>,
      < -6.814703, -1.551863, -0.506407>
    }
    triangle {
      < -6.798269, -1.603042, -0.656654>,
      < -6.814703, -1.551863, -0.506407>,
      < -6.798269, -1.551863, -0.656654>
    }
    triangle {
      < -6.780095, -1.603042, -0.822805>,
      < -6.796529, -1.603042, -0.672559>,
      < -6.796529, -1.551863, -0.672559>
    }
    triangle {
      < -6.780095, -1.603042, -0.822805>,
      < -6.796529, -1.551863, -0.672559>,
      < -6.780095, -1.551863, -0.822805>
    }
    triangle {
      < -6.834616, -1.603042, -0.324351>,
      < -6.851051, -1.603042, -0.174104>,
      < -6.851051, -1.551863, -0.174104>
    }
    triangle {
      < -6.834616, -1.603042, -0.324351>,
      < -6.851051, -1.551863, -0.174104>,
      < -6.834616, -1.551863, -0.324351>
    }
    triangle {
      < -6.816443, -1.603042, -0.490502>,
      < -6.832877, -1.603042, -0.340256>,
      < -6.832877, -1.551863, -0.340256>
    }
    triangle {
      < -6.816443, -1.603042, -0.490502>,
      < -6.832877, -1.551863, -0.340256>,
      < -6.816443, -1.551863, -0.490502>
    }
    triangle {
      < -6.869224, -1.603042, -0.007953>,
      < -6.869224, -1.551863, -0.007953>,
      < -6.852790, -1.551863, -0.158199>
    }
    triangle {
      < -6.869224, -1.603042, -0.007953>,
      < -6.852790, -1.551863, -0.158199>,
      < -6.852790, -1.603042, -0.158199>
    }
    triangle {
      < -6.869224, -1.603042, 0.007953>,
      < -6.852789, -1.603042, 0.158199>,
      < -6.852789, -1.551863, 0.158199>
    }
    triangle {
      < -6.869224, -1.603042, 0.007953>,
      < -6.852789, -1.551863, 0.158199>,
      < -6.869224, -1.551863, 0.007953>
    }
    triangle {
      < -6.814702, -1.603042, 0.506408>,
      < -6.798267, -1.603042, 0.656654>,
      < -6.798267, -1.551863, 0.656654>
    }
    triangle {
      < -6.814702, -1.603042, 0.506408>,
      < -6.798267, -1.551863, 0.656654>,
      < -6.814702, -1.551863, 0.506408>
    }
    triangle {
      < -6.832876, -1.603042, 0.340256>,
      < -6.816442, -1.603042, 0.490503>,
      < -6.816442, -1.551863, 0.490503>
    }
    triangle {
      < -6.832876, -1.603042, 0.340256>,
      < -6.816442, -1.551863, 0.490503>,
      < -6.832876, -1.551863, 0.340256>
    }
    triangle {
      < -6.778354, -1.603042, 0.838711>,
      < -6.761919, -1.603042, 0.988958>,
      < -6.761919, -1.551863, 0.988957>
    }
    triangle {
      < -6.778354, -1.603042, 0.838711>,
      < -6.761919, -1.551863, 0.988957>,
      < -6.778354, -1.551863, 0.838711>
    }
    triangle {
      < -6.796528, -1.603042, 0.672559>,
      < -6.780094, -1.603042, 0.822806>,
      < -6.780094, -1.551863, 0.822806>
    }
    triangle {
      < -6.796528, -1.603042, 0.672559>,
      < -6.780094, -1.551863, 0.822806>,
      < -6.796528, -1.551863, 0.672559>
    }
    triangle {
      < -6.742006, -1.603042, 1.171014>,
      < -6.725572, -1.603042, 1.321261>,
      < -6.725572, -1.551863, 1.321261>
    }
    triangle {
      < -6.742006, -1.603042, 1.171014>,
      < -6.725572, -1.551863, 1.321261>,
      < -6.742006, -1.551863, 1.171014>
    }
    triangle {
      < -6.760180, -1.603042, 1.004863>,
      < -6.743745, -1.603042, 1.155109>,
      < -6.743745, -1.551863, 1.155109>
    }
    triangle {
      < -6.760180, -1.603042, 1.004863>,
      < -6.743745, -1.551863, 1.155109>,
      < -6.760180, -1.551863, 1.004863>
    }
    triangle {
      < -6.705658, -1.603042, 1.503318>,
      < -6.689224, -1.603042, 1.653564>,
      < -6.689224, -1.551863, 1.653564>
    }
    triangle {
      < -6.705658, -1.603042, 1.503318>,
      < -6.689224, -1.551863, 1.653564>,
      < -6.705658, -1.551863, 1.503317>
    }
    triangle {
      < -6.723832, -1.603042, 1.337166>,
      < -6.707397, -1.603042, 1.487412>,
      < -6.707397, -1.551863, 1.487412>
    }
    triangle {
      < -6.723832, -1.603042, 1.337166>,
      < -6.707397, -1.551863, 1.487412>,
      < -6.723832, -1.551863, 1.337166>
    }
    triangle {
      < -6.669310, -1.603042, 1.835621>,
      < -6.652875, -1.603042, 1.985867>,
      < -6.652875, -1.551863, 1.985867>
    }
    triangle {
      < -6.669310, -1.603042, 1.835621>,
      < -6.652875, -1.551863, 1.985867>,
      < -6.669310, -1.551863, 1.835621>
    }
    triangle {
      < -6.687484, -1.603042, 1.669469>,
      < -6.671050, -1.603042, 1.819715>,
      < -6.671050, -1.551863, 1.819715>
    }
    triangle {
      < -6.687484, -1.603042, 1.669469>,
      < -6.671050, -1.551863, 1.819715>,
      < -6.687484, -1.551863, 1.669469>
    }
    triangle {
      < -6.632963, -1.603042, 2.167924>,
      < -6.616529, -1.603042, 2.318171>,
      < -6.616529, -1.551863, 2.318171>
    }
    triangle {
      < -6.632963, -1.603042, 2.167924>,
      < -6.616529, -1.551863, 2.318171>,
      < -6.632963, -1.551863, 2.167924>
    }
    triangle {
      < -6.651136, -1.603042, 2.001772>,
      < -6.634702, -1.603042, 2.152019>,
      < -6.634702, -1.551863, 2.152019>
    }
    triangle {
      < -6.651136, -1.603042, 2.001772>,
      < -6.634702, -1.551863, 2.152019>,
      < -6.651136, -1.551863, 2.001772>
    }
    triangle {
      < -6.596615, -1.603042, 2.500227>,
      < -6.580181, -1.603042, 2.650474>,
      < -6.580181, -1.551863, 2.650474>
    }
    triangle {
      < -6.596615, -1.603042, 2.500227>,
      < -6.580181, -1.551863, 2.650474>,
      < -6.596615, -1.551863, 2.500227>
    }
    triangle {
      < -6.614789, -1.603042, 2.334076>,
      < -6.598354, -1.603042, 2.484322>,
      < -6.598354, -1.551863, 2.484322>
    }
    triangle {
      < -6.614789, -1.603042, 2.334076>,
      < -6.598354, -1.551863, 2.484322>,
      < -6.614789, -1.551863, 2.334076>
    }
    triangle {
      < -6.580181, -0.611356, 2.650474>,
      < -6.596616, -0.611356, 2.500227>,
      < -6.596616, -0.662535, 2.500227>
    }
    triangle {
      < -6.580181, -0.611356, 2.650474>,
      < -6.596616, -0.662535, 2.500227>,
      < -6.580181, -0.662535, 2.650474>
    }
    triangle {
      < -6.598355, -0.611356, 2.484322>,
      < -6.614789, -0.611356, 2.334075>,
      < -6.614789, -0.662535, 2.334075>
    }
    triangle {
      < -6.598355, -0.611356, 2.484322>,
      < -6.614789, -0.662535, 2.334075>,
      < -6.598355, -0.662535, 2.484322>
    }
    triangle {
      < -6.616529, -0.611356, 2.318170>,
      < -6.632964, -0.611356, 2.167924>,
      < -6.632964, -0.662535, 2.167924>
    }
    triangle {
      < -6.616529, -0.611356, 2.318170>,
      < -6.632964, -0.662535, 2.167924>,
      < -6.616529, -0.662535, 2.318170>
    }
    triangle {
      < -6.634703, -0.611356, 2.152019>,
      < -6.651138, -0.611356, 2.001772>,
      < -6.651138, -0.662535, 2.001772>
    }
    triangle {
      < -6.634703, -0.611356, 2.152019>,
      < -6.651138, -0.662535, 2.001772>,
      < -6.634703, -0.662535, 2.152019>
    }
    triangle {
      < -6.652877, -0.611356, 1.985867>,
      < -6.669312, -0.611356, 1.835620>,
      < -6.669312, -0.662535, 1.835620>
    }
    triangle {
      < -6.652877, -0.611356, 1.985867>,
      < -6.669312, -0.662535, 1.835620>,
      < -6.652877, -0.662535, 1.985867>
    }
    triangle {
      < -6.671051, -0.611356, 1.819715>,
      < -6.687486, -0.611356, 1.669469>,
      < -6.687486, -0.662535, 1.669469>
    }
    triangle {
      < -6.671051, -0.611356, 1.819715>,
      < -6.687486, -0.662535, 1.669469>,
      < -6.671051, -0.662535, 1.819715>
    }
    triangle {
      < -6.689225, -0.611356, 1.653563>,
      < -6.705659, -0.611356, 1.503317>,
      < -6.705659, -0.662535, 1.503317>
    }
    triangle {
      < -6.689225, -0.611356, 1.653563>,
      < -6.705659, -0.662535, 1.503317>,
      < -6.689225, -0.662535, 1.653563>
    }
    triangle {
      < -6.707399, -0.611356, 1.487412>,
      < -6.723834, -0.611356, 1.337165>,
      < -6.723834, -0.662535, 1.337165>
    }
    triangle {
      < -6.707399, -0.611356, 1.487412>,
      < -6.723834, -0.662535, 1.337165>,
      < -6.707399, -0.662535, 1.487412>
    }
    triangle {
      < -6.725573, -0.611356, 1.321260>,
      < -6.742008, -0.611356, 1.171014>,
      < -6.742008, -0.662535, 1.171014>
    }
    triangle {
      < -6.725573, -0.611356, 1.321260>,
      < -6.742008, -0.662535, 1.171014>,
      < -6.725573, -0.662535, 1.321260>
    }
    triangle {
      < -6.743747, -0.611356, 1.155109>,
      < -6.760181, -0.611356, 1.004862>,
      < -6.760181, -0.662535, 1.004862>
    }
    triangle {
      < -6.743747, -0.611356, 1.155109>,
      < -6.760181, -0.662535, 1.004862>,
      < -6.743747, -0.662535, 1.155109>
    }
    triangle {
      < -6.761921, -0.611356, 0.988957>,
      < -6.778356, -0.611356, 0.838711>,
      < -6.778356, -0.662535, 0.838711>
    }
    triangle {
      < -6.761921, -0.611356, 0.988957>,
      < -6.778356, -0.662535, 0.838711>,
      < -6.761921, -0.662535, 0.988957>
    }
    triangle {
      < -6.780095, -0.611356, 0.822805>,
      < -6.796529, -0.611356, 0.672559>,
      < -6.796529, -0.662535, 0.672559>
    }
    triangle {
      < -6.780095, -0.611356, 0.822805>,
      < -6.796529, -0.662535, 0.672559>,
      < -6.780095, -0.662535, 0.822805>
    }
    triangle {
      < -6.798269, -0.611356, 0.656654>,
      < -6.814703, -0.611356, 0.506407>,
      < -6.814703, -0.662535, 0.506407>
    }
    triangle {
      < -6.798269, -0.611356, 0.656654>,
      < -6.814703, -0.662535, 0.506407>,
      < -6.798269, -0.662535, 0.656654>
    }
    triangle {
      < -6.816443, -0.611356, 0.490502>,
      < -6.832877, -0.611356, 0.340256>,
      < -6.832877, -0.662535, 0.340256>
    }
    triangle {
      < -6.816443, -0.611356, 0.490502>,
      < -6.832877, -0.662535, 0.340256>,
      < -6.816443, -0.662535, 0.490502>
    }
    triangle {
      < -6.834616, -0.611356, 0.324351>,
      < -6.851051, -0.611356, 0.174104>,
      < -6.851051, -0.662535, 0.174104>
    }
    triangle {
      < -6.834616, -0.611356, 0.324351>,
      < -6.851051, -0.662535, 0.174104>,
      < -6.834616, -0.662535, 0.324351>
    }
    triangle {
      < -6.852790, -0.611356, 0.158199>,
      < -6.869224, -0.611356, 0.007953>,
      < -6.869224, -0.662535, 0.007953>
    }
    triangle {
      < -6.852790, -0.611356, 0.158199>,
      < -6.869224, -0.662535, 0.007953>,
      < -6.852790, -0.662535, 0.158199>
    }
    triangle {
      < -6.851050, -0.611356, -0.174104>,
      < -6.834615, -0.611356, -0.324351>,
      < -6.834615, -0.662535, -0.324351>
    }
    triangle {
      < -6.851050, -0.611356, -0.174104>,
      < -6.834615, -0.662535, -0.324351>,
      < -6.851050, -0.662535, -0.174104>
    }
    triangle {
      < -6.869224, -0.611356, -0.007953>,
      < -6.852789, -0.611356, -0.158199>,
      < -6.852789, -0.662535, -0.158199>
    }
    triangle {
      < -6.869224, -0.611356, -0.007953>,
      < -6.852789, -0.662535, -0.158199>,
      < -6.869224, -0.662535, -0.007953>
    }
    triangle {
      < -6.832876, -0.611356, -0.340256>,
      < -6.816442, -0.611356, -0.490503>,
      < -6.816442, -0.662535, -0.490503>
    }
    triangle {
      < -6.832876, -0.611356, -0.340256>,
      < -6.816442, -0.662535, -0.490503>,
      < -6.832876, -0.662535, -0.340256>
    }
    triangle {
      < -6.814702, -0.611356, -0.506408>,
      < -6.798267, -0.611356, -0.656654>,
      < -6.798267, -0.662535, -0.656654>
    }
    triangle {
      < -6.814702, -0.611356, -0.506408>,
      < -6.798267, -0.662535, -0.656654>,
      < -6.814702, -0.662535, -0.506408>
    }
    triangle {
      < -6.796528, -0.611356, -0.672559>,
      < -6.780094, -0.611356, -0.822806>,
      < -6.780094, -0.662535, -0.822806>
    }
    triangle {
      < -6.796528, -0.611356, -0.672559>,
      < -6.780094, -0.662535, -0.822806>,
      < -6.796528, -0.662535, -0.672559>
    }
    triangle {
      < -6.778354, -0.611356, -0.838711>,
      < -6.761919, -0.611356, -0.988958>,
      < -6.761919, -0.662535, -0.988958>
    }
    triangle {
      < -6.778354, -0.611356, -0.838711>,
      < -6.761919, -0.662535, -0.988958>,
      < -6.778354, -0.662535, -0.838711>
    }
    triangle {
      < -6.760180, -0.611356, -1.004863>,
      < -6.743745, -0.611356, -1.155109>,
      < -6.743745, -0.662535, -1.155109>
    }
    triangle {
      < -6.760180, -0.611356, -1.004863>,
      < -6.743745, -0.662535, -1.155109>,
      < -6.760180, -0.662535, -1.004863>
    }
    triangle {
      < -6.742006, -0.611356, -1.171014>,
      < -6.725572, -0.611356, -1.321261>,
      < -6.725572, -0.662535, -1.321261>
    }
    triangle {
      < -6.742006, -0.611356, -1.171014>,
      < -6.725572, -0.662535, -1.321261>,
      < -6.742006, -0.662535, -1.171014>
    }
    triangle {
      < -6.723832, -0.611356, -1.337166>,
      < -6.707397, -0.611356, -1.487412>,
      < -6.707397, -0.662535, -1.487412>
    }
    triangle {
      < -6.723832, -0.611356, -1.337166>,
      < -6.707397, -0.662535, -1.487412>,
      < -6.723832, -0.662535, -1.337166>
    }
    triangle {
      < -6.705658, -0.611356, -1.503318>,
      < -6.689224, -0.611356, -1.653564>,
      < -6.689224, -0.662535, -1.653564>
    }
    triangle {
      < -6.705658, -0.611356, -1.503318>,
      < -6.689224, -0.662535, -1.653564>,
      < -6.705658, -0.662535, -1.503318>
    }
    triangle {
      < -6.687484, -0.611356, -1.669469>,
      < -6.671050, -0.611356, -1.819715>,
      < -6.671050, -0.662535, -1.819715>
    }
    triangle {
      < -6.687484, -0.611356, -1.669469>,
      < -6.671050, -0.662535, -1.819715>,
      < -6.687484, -0.662535, -1.669469>
    }
    triangle {
      < -6.669310, -0.611356, -1.835621>,
      < -6.652875, -0.611356, -1.985867>,
      < -6.652875, -0.662535, -1.985867>
    }
    triangle {
      < -6.669310, -0.611356, -1.835621>,
      < -6.652875, -0.662535, -1.985867>,
      < -6.669310, -0.662535, -1.835621>
    }
    triangle {
      < -6.651136, -0.611356, -2.001772>,
      < -6.634702, -0.611356, -2.152019>,
      < -6.634702, -0.662535, -2.152019>
    }
    triangle {
      < -6.651136, -0.611356, -2.001772>,
      < -6.634702, -0.662535, -2.152019>,
      < -6.651136, -0.662535, -2.001772>
    }
    triangle {
      < -6.632962, -0.611356, -2.167924>,
      < -6.616529, -0.611356, -2.318170>,
      < -6.616529, -0.662535, -2.318170>
    }
    triangle {
      < -6.632962, -0.611356, -2.167924>,
      < -6.616529, -0.662535, -2.318170>,
      < -6.632962, -0.662535, -2.167924>
    }
    triangle {
      < -6.614789, -0.611356, -2.334075>,
      < -6.598354, -0.611356, -2.484322>,
      < -6.598354, -0.662535, -2.484322>
    }
    triangle {
      < -6.614789, -0.611356, -2.334075>,
      < -6.598354, -0.662535, -2.484322>,
      < -6.614789, -0.662535, -2.334075>
    }
    triangle {
      < -6.596615, -0.611356, -2.500227>,
      < -6.580181, -0.611356, -2.650473>,
      < -6.580181, -0.662535, -2.650473>
    }
    triangle {
      < -6.596615, -0.611356, -2.500227>,
      < -6.580181, -0.662535, -2.650473>,
      < -6.596615, -0.662535, -2.500227>
    }
    triangle {
      < -6.632962, -0.678535, -2.167924>,
      < -6.616529, -0.678535, -2.318170>,
      < -6.616529, -0.729714, -2.318170>
    }
    triangle {
      < -6.632962, -0.678535, -2.167924>,
      < -6.616529, -0.729714, -2.318170>,
      < -6.632962, -0.729714, -2.167924>
    }
    triangle {
      < -6.614789, -0.678535, -2.334075>,
      < -6.598354, -0.678535, -2.484322>,
      < -6.598354, -0.729714, -2.484322>
    }
    triangle {
      < -6.614789, -0.678535, -2.334075>,
      < -6.598354, -0.729714, -2.484322>,
      < -6.614789, -0.729714, -2.334075>
    }
    triangle {
      < -6.669310, -0.678535, -1.835621>,
      < -6.652875, -0.678535, -1.985867>,
      < -6.652875, -0.729714, -1.985867>
    }
    triangle {
      < -6.669310, -0.678535, -1.835621>,
      < -6.652875, -0.729714, -1.985867>,
      < -6.669310, -0.729714, -1.835621>
    }
    triangle {
      < -6.651136, -0.678535, -2.001772>,
      < -6.634702, -0.678535, -2.152019>,
      < -6.634702, -0.729714, -2.152019>
    }
    triangle {
      < -6.651136, -0.678535, -2.001772>,
      < -6.634702, -0.729714, -2.152019>,
      < -6.651136, -0.729714, -2.001772>
    }
    triangle {
      < -6.705658, -0.678535, -1.503318>,
      < -6.689224, -0.678535, -1.653564>,
      < -6.689224, -0.729714, -1.653564>
    }
    triangle {
      < -6.705658, -0.678535, -1.503318>,
      < -6.689224, -0.729714, -1.653564>,
      < -6.705658, -0.729714, -1.503317>
    }
    triangle {
      < -6.687484, -0.678535, -1.669469>,
      < -6.671050, -0.678535, -1.819715>,
      < -6.671050, -0.729714, -1.819715>
    }
    triangle {
      < -6.687484, -0.678535, -1.669469>,
      < -6.671050, -0.729714, -1.819715>,
      < -6.687484, -0.729714, -1.669469>
    }
    triangle {
      < -6.742006, -0.678535, -1.171014>,
      < -6.725572, -0.678535, -1.321261>,
      < -6.725572, -0.729714, -1.321261>
    }
    triangle {
      < -6.742006, -0.678535, -1.171014>,
      < -6.725572, -0.729714, -1.321261>,
      < -6.742006, -0.729714, -1.171014>
    }
    triangle {
      < -6.723832, -0.678535, -1.337166>,
      < -6.707397, -0.678535, -1.487412>,
      < -6.707397, -0.729714, -1.487412>
    }
    triangle {
      < -6.723832, -0.678535, -1.337166>,
      < -6.707397, -0.729714, -1.487412>,
      < -6.723832, -0.729714, -1.337166>
    }
    triangle {
      < -6.778354, -0.678535, -0.838711>,
      < -6.761919, -0.678535, -0.988958>,
      < -6.761919, -0.729714, -0.988958>
    }
    triangle {
      < -6.778354, -0.678535, -0.838711>,
      < -6.761919, -0.729714, -0.988958>,
      < -6.778354, -0.729714, -0.838711>
    }
    triangle {
      < -6.760180, -0.678535, -1.004863>,
      < -6.743745, -0.678535, -1.155109>,
      < -6.743745, -0.729714, -1.155109>
    }
    triangle {
      < -6.760180, -0.678535, -1.004863>,
      < -6.743745, -0.729714, -1.155109>,
      < -6.760180, -0.729714, -1.004863>
    }
    triangle {
      < -6.814702, -0.678535, -0.506407>,
      < -6.798267, -0.678535, -0.656654>,
      < -6.798267, -0.729714, -0.656654>
    }
    triangle {
      < -6.814702, -0.678535, -0.506407>,
      < -6.798267, -0.729714, -0.656654>,
      < -6.814702, -0.729714, -0.506407>
    }
    triangle {
      < -6.796528, -0.678535, -0.672559>,
      < -6.780094, -0.678535, -0.822806>,
      < -6.780094, -0.729714, -0.822806>
    }
    triangle {
      < -6.796528, -0.678535, -0.672559>,
      < -6.780094, -0.729714, -0.822806>,
      < -6.796528, -0.729714, -0.672559>
    }
    triangle {
      < -6.851050, -0.678535, -0.174104>,
      < -6.834615, -0.678535, -0.324351>,
      < -6.834615, -0.729714, -0.324351>
    }
    triangle {
      < -6.851050, -0.678535, -0.174104>,
      < -6.834615, -0.729714, -0.324351>,
      < -6.851050, -0.729714, -0.174104>
    }
    triangle {
      < -6.832876, -0.678535, -0.340256>,
      < -6.816442, -0.678535, -0.490502>,
      < -6.816442, -0.729714, -0.490502>
    }
    triangle {
      < -6.832876, -0.678535, -0.340256>,
      < -6.816442, -0.729714, -0.490502>,
      < -6.832876, -0.729714, -0.340256>
    }
    triangle {
      < -6.834616, -0.678535, 0.324351>,
      < -6.851051, -0.678535, 0.174104>,
      < -6.851051, -0.729714, 0.174104>
    }
    triangle {
      < -6.834616, -0.678535, 0.324351>,
      < -6.851051, -0.729714, 0.174104>,
      < -6.834616, -0.729714, 0.324351>
    }
    triangle {
      < -6.852790, -0.678535, 0.158199>,
      < -6.869224, -0.678535, 0.007953>,
      < -6.869224, -0.729714, 0.007953>
    }
    triangle {
      < -6.852790, -0.678535, 0.158199>,
      < -6.869224, -0.729714, 0.007953>,
      < -6.852790, -0.729714, 0.158199>
    }
    triangle {
      < -6.798269, -0.678535, 0.656654>,
      < -6.814703, -0.678535, 0.506407>,
      < -6.814703, -0.729714, 0.506407>
    }
    triangle {
      < -6.798269, -0.678535, 0.656654>,
      < -6.814703, -0.729714, 0.506407>,
      < -6.798269, -0.729714, 0.656654>
    }
    triangle {
      < -6.816443, -0.678535, 0.490502>,
      < -6.832877, -0.678535, 0.340256>,
      < -6.832877, -0.729714, 0.340256>
    }
    triangle {
      < -6.816443, -0.678535, 0.490502>,
      < -6.832877, -0.729714, 0.340256>,
      < -6.816443, -0.729714, 0.490502>
    }
    triangle {
      < -6.761921, -0.678535, 0.988957>,
      < -6.778356, -0.678535, 0.838711>,
      < -6.778356, -0.729714, 0.838711>
    }
    triangle {
      < -6.761921, -0.678535, 0.988957>,
      < -6.778356, -0.729714, 0.838711>,
      < -6.761921, -0.729714, 0.988957>
    }
    triangle {
      < -6.780095, -0.678535, 0.822805>,
      < -6.796529, -0.678535, 0.672559>,
      < -6.796529, -0.729714, 0.672559>
    }
    triangle {
      < -6.780095, -0.678535, 0.822805>,
      < -6.796529, -0.729714, 0.672559>,
      < -6.780095, -0.729714, 0.822805>
    }
    triangle {
      < -6.725573, -0.678535, 1.321260>,
      < -6.742008, -0.678535, 1.171014>,
      < -6.742008, -0.729714, 1.171014>
    }
    triangle {
      < -6.725573, -0.678535, 1.321260>,
      < -6.742008, -0.729714, 1.171014>,
      < -6.725573, -0.729714, 1.321260>
    }
    triangle {
      < -6.743747, -0.678535, 1.155109>,
      < -6.760181, -0.678535, 1.004862>,
      < -6.760181, -0.729714, 1.004862>
    }
    triangle {
      < -6.743747, -0.678535, 1.155109>,
      < -6.760181, -0.729714, 1.004862>,
      < -6.743747, -0.729714, 1.155109>
    }
    triangle {
      < -6.689225, -0.678535, 1.653563>,
      < -6.705659, -0.678535, 1.503317>,
      < -6.705659, -0.729714, 1.503317>
    }
    triangle {
      < -6.689225, -0.678535, 1.653563>,
      < -6.705659, -0.729714, 1.503317>,
      < -6.689225, -0.729714, 1.653563>
    }
    triangle {
      < -6.707399, -0.678535, 1.487412>,
      < -6.723834, -0.678535, 1.337165>,
      < -6.723834, -0.729714, 1.337165>
    }
    triangle {
      < -6.707399, -0.678535, 1.487412>,
      < -6.723834, -0.729714, 1.337165>,
      < -6.707399, -0.729714, 1.487412>
    }
    triangle {
      < -6.652877, -0.678535, 1.985867>,
      < -6.669312, -0.678535, 1.835620>,
      < -6.669312, -0.729714, 1.835620>
    }
    triangle {
      < -6.652877, -0.678535, 1.985867>,
      < -6.669312, -0.729714, 1.835620>,
      < -6.652877, -0.729714, 1.985867>
    }
    triangle {
      < -6.671051, -0.678535, 1.819715>,
      < -6.687486, -0.678535, 1.669469>,
      < -6.687486, -0.729714, 1.669469>
    }
    triangle {
      < -6.671051, -0.678535, 1.819715>,
      < -6.687486, -0.729714, 1.669469>,
      < -6.671051, -0.729714, 1.819715>
    }
    triangle {
      < -6.616529, -0.678535, 2.318170>,
      < -6.632964, -0.678535, 2.167924>,
      < -6.632964, -0.729714, 2.167924>
    }
    triangle {
      < -6.616529, -0.678535, 2.318170>,
      < -6.632964, -0.729714, 2.167924>,
      < -6.616529, -0.729714, 2.318170>
    }
    triangle {
      < -6.634703, -0.678535, 2.152019>,
      < -6.651138, -0.678535, 2.001772>,
      < -6.651138, -0.729714, 2.001772>
    }
    triangle {
      < -6.634703, -0.678535, 2.152019>,
      < -6.651138, -0.729714, 2.001772>,
      < -6.634703, -0.729714, 2.152019>
    }
    triangle {
      < -6.580181, -0.678535, 2.650474>,
      < -6.596616, -0.678535, 2.500227>,
      < -6.596616, -0.729714, 2.500227>
    }
    triangle {
      < -6.580181, -0.678535, 2.650474>,
      < -6.596616, -0.729714, 2.500227>,
      < -6.580181, -0.729714, 2.650474>
    }
    triangle {
      < -6.598355, -0.678535, 2.484322>,
      < -6.614789, -0.678535, 2.334075>,
      < -6.614789, -0.729714, 2.334075>
    }
    triangle {
      < -6.598355, -0.678535, 2.484322>,
      < -6.614789, -0.729714, 2.334075>,
      < -6.598355, -0.729714, 2.484322>
    }
    triangle {
      < -6.869224, -0.678535, -0.007953>,
      < -6.852789, -0.678535, -0.158199>,
      < -6.852789, -0.729714, -0.158199>
    }
    triangle {
      < -6.869224, -0.678535, -0.007953>,
      < -6.852789, -0.729714, -0.158199>,
      < -6.869224, -0.729714, -0.007953>
    }
    triangle {
      < -6.596615, -0.678535, -2.500227>,
      < -6.580181, -0.678535, -2.650473>,
      < -6.580181, -0.729714, -2.650473>
    }
    triangle {
      < -6.596615, -0.678535, -2.500227>,
      < -6.580181, -0.729714, -2.650473>,
      < -6.596615, -0.729714, -2.500227>
    }
    triangle {
      < -6.580181, -0.745714, 2.650474>,
      < -6.596616, -0.745714, 2.500227>,
      < -6.596616, -0.796893, 2.500227>
    }
    triangle {
      < -6.580181, -0.745714, 2.650474>,
      < -6.596616, -0.796893, 2.500227>,
      < -6.580181, -0.796893, 2.650474>
    }
    triangle {
      < -6.598355, -0.745714, 2.484322>,
      < -6.614789, -0.745714, 2.334075>,
      < -6.614789, -0.796893, 2.334075>
    }
    triangle {
      < -6.598355, -0.745714, 2.484322>,
      < -6.614789, -0.796893, 2.334075>,
      < -6.598355, -0.796893, 2.484322>
    }
    triangle {
      < -6.616529, -0.745714, 2.318170>,
      < -6.632964, -0.745714, 2.167924>,
      < -6.632964, -0.796893, 2.167924>
    }
    triangle {
      < -6.616529, -0.745714, 2.318170>,
      < -6.632964, -0.796893, 2.167924>,
      < -6.616529, -0.796893, 2.318170>
    }
    triangle {
      < -6.634703, -0.745714, 2.152019>,
      < -6.651138, -0.745714, 2.001772>,
      < -6.651138, -0.796893, 2.001772>
    }
    triangle {
      < -6.634703, -0.745714, 2.152019>,
      < -6.651138, -0.796893, 2.001772>,
      < -6.634703, -0.796893, 2.152019>
    }
    triangle {
      < -6.652877, -0.745714, 1.985867>,
      < -6.669312, -0.745714, 1.835620>,
      < -6.669312, -0.796893, 1.835620>
    }
    triangle {
      < -6.652877, -0.745714, 1.985867>,
      < -6.669312, -0.796893, 1.835620>,
      < -6.652877, -0.796893, 1.985867>
    }
    triangle {
      < -6.671051, -0.745714, 1.819715>,
      < -6.687486, -0.745714, 1.669469>,
      < -6.687486, -0.796893, 1.669469>
    }
    triangle {
      < -6.671051, -0.745714, 1.819715>,
      < -6.687486, -0.796893, 1.669469>,
      < -6.671051, -0.796893, 1.819715>
    }
    triangle {
      < -6.689225, -0.745714, 1.653563>,
      < -6.705659, -0.745714, 1.503317>,
      < -6.705659, -0.796893, 1.503317>
    }
    triangle {
      < -6.689225, -0.745714, 1.653563>,
      < -6.705659, -0.796893, 1.503317>,
      < -6.689225, -0.796893, 1.653563>
    }
    triangle {
      < -6.707399, -0.745714, 1.487412>,
      < -6.723834, -0.745714, 1.337165>,
      < -6.723834, -0.796893, 1.337165>
    }
    triangle {
      < -6.707399, -0.745714, 1.487412>,
      < -6.723834, -0.796893, 1.337165>,
      < -6.707399, -0.796893, 1.487412>
    }
    triangle {
      < -6.725573, -0.745714, 1.321260>,
      < -6.742008, -0.745714, 1.171014>,
      < -6.742008, -0.796893, 1.171014>
    }
    triangle {
      < -6.725573, -0.745714, 1.321260>,
      < -6.742008, -0.796893, 1.171014>,
      < -6.725573, -0.796893, 1.321260>
    }
    triangle {
      < -6.743747, -0.745714, 1.155109>,
      < -6.760181, -0.745714, 1.004862>,
      < -6.760181, -0.796893, 1.004862>
    }
    triangle {
      < -6.743747, -0.745714, 1.155109>,
      < -6.760181, -0.796893, 1.004862>,
      < -6.743747, -0.796893, 1.155109>
    }
    triangle {
      < -6.761921, -0.745714, 0.988957>,
      < -6.778356, -0.745714, 0.838711>,
      < -6.778356, -0.796893, 0.838711>
    }
    triangle {
      < -6.761921, -0.745714, 0.988957>,
      < -6.778356, -0.796893, 0.838711>,
      < -6.761921, -0.796893, 0.988957>
    }
    triangle {
      < -6.780095, -0.745714, 0.822805>,
      < -6.796529, -0.745714, 0.672559>,
      < -6.796529, -0.796893, 0.672559>
    }
    triangle {
      < -6.780095, -0.745714, 0.822805>,
      < -6.796529, -0.796893, 0.672559>,
      < -6.780095, -0.796893, 0.822805>
    }
    triangle {
      < -6.798269, -0.745714, 0.656654>,
      < -6.814703, -0.745714, 0.506407>,
      < -6.814703, -0.796893, 0.506407>
    }
    triangle {
      < -6.798269, -0.745714, 0.656654>,
      < -6.814703, -0.796893, 0.506407>,
      < -6.798269, -0.796893, 0.656654>
    }
    triangle {
      < -6.816443, -0.745714, 0.490502>,
      < -6.832877, -0.745714, 0.340256>,
      < -6.832877, -0.796893, 0.340256>
    }
    triangle {
      < -6.816443, -0.745714, 0.490502>,
      < -6.832877, -0.796893, 0.340256>,
      < -6.816443, -0.796893, 0.490502>
    }
    triangle {
      < -6.834616, -0.745714, 0.324351>,
      < -6.851051, -0.745714, 0.174104>,
      < -6.851051, -0.796893, 0.174104>
    }
    triangle {
      < -6.834616, -0.745714, 0.324351>,
      < -6.851051, -0.796893, 0.174104>,
      < -6.834616, -0.796893, 0.324351>
    }
    triangle {
      < -6.852790, -0.745714, 0.158199>,
      < -6.869224, -0.745714, 0.007953>,
      < -6.869224, -0.796893, 0.007953>
    }
    triangle {
      < -6.852790, -0.745714, 0.158199>,
      < -6.869224, -0.796893, 0.007953>,
      < -6.852790, -0.796893, 0.158199>
    }
    triangle {
      < -6.851050, -0.745714, -0.174104>,
      < -6.834615, -0.745714, -0.324351>,
      < -6.834615, -0.796893, -0.324351>
    }
    triangle {
      < -6.851050, -0.745714, -0.174104>,
      < -6.834615, -0.796893, -0.324351>,
      < -6.851050, -0.796893, -0.174104>
    }
    triangle {
      < -6.832876, -0.745714, -0.340256>,
      < -6.816442, -0.745714, -0.490502>,
      < -6.816442, -0.796893, -0.490502>
    }
    triangle {
      < -6.832876, -0.745714, -0.340256>,
      < -6.816442, -0.796893, -0.490502>,
      < -6.832876, -0.796893, -0.340256>
    }
    triangle {
      < -6.814702, -0.745714, -0.506407>,
      < -6.798267, -0.745714, -0.656654>,
      < -6.798267, -0.796893, -0.656654>
    }
    triangle {
      < -6.814702, -0.745714, -0.506407>,
      < -6.798267, -0.796893, -0.656654>,
      < -6.814702, -0.796893, -0.506407>
    }
    triangle {
      < -6.796528, -0.745714, -0.672559>,
      < -6.780094, -0.745714, -0.822806>,
      < -6.780094, -0.796893, -0.822806>
    }
    triangle {
      < -6.796528, -0.745714, -0.672559>,
      < -6.780094, -0.796893, -0.822806>,
      < -6.796528, -0.796893, -0.672559>
    }
    triangle {
      < -6.778354, -0.745714, -0.838711>,
      < -6.761919, -0.745714, -0.988958>,
      < -6.761919, -0.796893, -0.988958>
    }
    triangle {
      < -6.778354, -0.745714, -0.838711>,
      < -6.761919, -0.796893, -0.988958>,
      < -6.778354, -0.796893, -0.838711>
    }
    triangle {
      < -6.760180, -0.745714, -1.004863>,
      < -6.743745, -0.745714, -1.155109>,
      < -6.743745, -0.796893, -1.155109>
    }
    triangle {
      < -6.760180, -0.745714, -1.004863>,
      < -6.743745, -0.796893, -1.155109>,
      < -6.760180, -0.796893, -1.004863>
    }
    triangle {
      < -6.742006, -0.745714, -1.171014>,
      < -6.725572, -0.745714, -1.321261>,
      < -6.725572, -0.796893, -1.321261>
    }
    triangle {
      < -6.742006, -0.745714, -1.171014>,
      < -6.725572, -0.796893, -1.321261>,
      < -6.742006, -0.796893, -1.171014>
    }
    triangle {
      < -6.723832, -0.745714, -1.337166>,
      < -6.707397, -0.745714, -1.487412>,
      < -6.707397, -0.796893, -1.487412>
    }
    triangle {
      < -6.723832, -0.745714, -1.337166>,
      < -6.707397, -0.796893, -1.487412>,
      < -6.723832, -0.796893, -1.337166>
    }
    triangle {
      < -6.705658, -0.745714, -1.503317>,
      < -6.689224, -0.745714, -1.653564>,
      < -6.689224, -0.796893, -1.653564>
    }
    triangle {
      < -6.705658, -0.745714, -1.503317>,
      < -6.689224, -0.796893, -1.653564>,
      < -6.705658, -0.796893, -1.503317>
    }
    triangle {
      < -6.687484, -0.745714, -1.669469>,
      < -6.671050, -0.745714, -1.819715>,
      < -6.671050, -0.796893, -1.819715>
    }
    triangle {
      < -6.687484, -0.745714, -1.669469>,
      < -6.671050, -0.796893, -1.819715>,
      < -6.687484, -0.796893, -1.669469>
    }
    triangle {
      < -6.669310, -0.745714, -1.835621>,
      < -6.652875, -0.745714, -1.985867>,
      < -6.652875, -0.796893, -1.985867>
    }
    triangle {
      < -6.669310, -0.745714, -1.835621>,
      < -6.652875, -0.796893, -1.985867>,
      < -6.669310, -0.796893, -1.835621>
    }
    triangle {
      < -6.651136, -0.745714, -2.001772>,
      < -6.634702, -0.745714, -2.152019>,
      < -6.634702, -0.796893, -2.152019>
    }
    triangle {
      < -6.651136, -0.745714, -2.001772>,
      < -6.634702, -0.796893, -2.152019>,
      < -6.651136, -0.796893, -2.001772>
    }
    triangle {
      < -6.632962, -0.745714, -2.167924>,
      < -6.616529, -0.745714, -2.318170>,
      < -6.616529, -0.796893, -2.318170>
    }
    triangle {
      < -6.632962, -0.745714, -2.167924>,
      < -6.616529, -0.796893, -2.318170>,
      < -6.632962, -0.796893, -2.167924>
    }
    triangle {
      < -6.614789, -0.745714, -2.334075>,
      < -6.598354, -0.745714, -2.484322>,
      < -6.598354, -0.796893, -2.484322>
    }
    triangle {
      < -6.614789, -0.745714, -2.334075>,
      < -6.598354, -0.796893, -2.484322>,
      < -6.614789, -0.796893, -2.334075>
    }
    triangle {
      < -6.869224, -0.745714, -0.007953>,
      < -6.852789, -0.745714, -0.158199>,
      < -6.852789, -0.796893, -0.158199>
    }
    triangle {
      < -6.869224, -0.745714, -0.007953>,
      < -6.852789, -0.796893, -0.158199>,
      < -6.869224, -0.796893, -0.007953>
    }
    triangle {
      < -6.596615, -0.745714, -2.500227>,
      < -6.580181, -0.745714, -2.650473>,
      < -6.580181, -0.796893, -2.650473>
    }
    triangle {
      < -6.596615, -0.745714, -2.500227>,
      < -6.580181, -0.796893, -2.650473>,
      < -6.596615, -0.796893, -2.500227>
    }
    triangle {
      < -6.632962, -0.812893, -2.167924>,
      < -6.616529, -0.812893, -2.318170>,
      < -6.616529, -0.864072, -2.318170>
    }
    triangle {
      < -6.632962, -0.812893, -2.167924>,
      < -6.616529, -0.864072, -2.318170>,
      < -6.632962, -0.864072, -2.167924>
    }
    triangle {
      < -6.614789, -0.812893, -2.334075>,
      < -6.598354, -0.812893, -2.484322>,
      < -6.598354, -0.864072, -2.484322>
    }
    triangle {
      < -6.614789, -0.812893, -2.334075>,
      < -6.598354, -0.864072, -2.484322>,
      < -6.614789, -0.864072, -2.334075>
    }
    triangle {
      < -6.669310, -0.812893, -1.835621>,
      < -6.652875, -0.812893, -1.985867>,
      < -6.652875, -0.864072, -1.985867>
    }
    triangle {
      < -6.669310, -0.812893, -1.835621>,
      < -6.652875, -0.864072, -1.985867>,
      < -6.669310, -0.864072, -1.835621>
    }
    triangle {
      < -6.651136, -0.812893, -2.001772>,
      < -6.634702, -0.812893, -2.152019>,
      < -6.634702, -0.864072, -2.152019>
    }
    triangle {
      < -6.651136, -0.812893, -2.001772>,
      < -6.634702, -0.864072, -2.152019>,
      < -6.651136, -0.864072, -2.001772>
    }
    triangle {
      < -6.705658, -0.812893, -1.503317>,
      < -6.689224, -0.812893, -1.653564>,
      < -6.689224, -0.864072, -1.653564>
    }
    triangle {
      < -6.705658, -0.812893, -1.503317>,
      < -6.689224, -0.864072, -1.653564>,
      < -6.705658, -0.864072, -1.503317>
    }
    triangle {
      < -6.687484, -0.812893, -1.669469>,
      < -6.671050, -0.812893, -1.819715>,
      < -6.671050, -0.864072, -1.819715>
    }
    triangle {
      < -6.687484, -0.812893, -1.669469>,
      < -6.671050, -0.864072, -1.819715>,
      < -6.687484, -0.864072, -1.669469>
    }
    triangle {
      < -6.742006, -0.812893, -1.171014>,
      < -6.725572, -0.812893, -1.321261>,
      < -6.725572, -0.864072, -1.321261>
    }
    triangle {
      < -6.742006, -0.812893, -1.171014>,
      < -6.725572, -0.864072, -1.321261>,
      < -6.742006, -0.864072, -1.171014>
    }
    triangle {
      < -6.723832, -0.812893, -1.337166>,
      < -6.707397, -0.812893, -1.487412>,
      < -6.707397, -0.864072, -1.487412>
    }
    triangle {
      < -6.723832, -0.812893, -1.337166>,
      < -6.707397, -0.864072, -1.487412>,
      < -6.723832, -0.864072, -1.337166>
    }
    triangle {
      < -6.778354, -0.812893, -0.838711>,
      < -6.761919, -0.812893, -0.988958>,
      < -6.761919, -0.864072, -0.988957>
    }
    triangle {
      < -6.778354, -0.812893, -0.838711>,
      < -6.761919, -0.864072, -0.988957>,
      < -6.778354, -0.864072, -0.838711>
    }
    triangle {
      < -6.760180, -0.812893, -1.004863>,
      < -6.743745, -0.812893, -1.155109>,
      < -6.743745, -0.864072, -1.155109>
    }
    triangle {
      < -6.760180, -0.812893, -1.004863>,
      < -6.743745, -0.864072, -1.155109>,
      < -6.760180, -0.864072, -1.004863>
    }
    triangle {
      < -6.814702, -0.812893, -0.506407>,
      < -6.798267, -0.812893, -0.656654>,
      < -6.798267, -0.864072, -0.656654>
    }
    triangle {
      < -6.814702, -0.812893, -0.506407>,
      < -6.798267, -0.864072, -0.656654>,
      < -6.814702, -0.864072, -0.506407>
    }
    triangle {
      < -6.796528, -0.812893, -0.672559>,
      < -6.780094, -0.812893, -0.822806>,
      < -6.780094, -0.864072, -0.822806>
    }
    triangle {
      < -6.796528, -0.812893, -0.672559>,
      < -6.780094, -0.864072, -0.822806>,
      < -6.796528, -0.864072, -0.672559>
    }
    triangle {
      < -6.851050, -0.812893, -0.174104>,
      < -6.834615, -0.812893, -0.324351>,
      < -6.834615, -0.864072, -0.324351>
    }
    triangle {
      < -6.851050, -0.812893, -0.174104>,
      < -6.834615, -0.864072, -0.324351>,
      < -6.851050, -0.864072, -0.174104>
    }
    triangle {
      < -6.832876, -0.812893, -0.340256>,
      < -6.816442, -0.812893, -0.490502>,
      < -6.816442, -0.864072, -0.490502>
    }
    triangle {
      < -6.832876, -0.812893, -0.340256>,
      < -6.816442, -0.864072, -0.490502>,
      < -6.832876, -0.864072, -0.340256>
    }
    triangle {
      < -6.834616, -0.812893, 0.324351>,
      < -6.851051, -0.812893, 0.174104>,
      < -6.851051, -0.864072, 0.174104>
    }
    triangle {
      < -6.834616, -0.812893, 0.324351>,
      < -6.851051, -0.864072, 0.174104>,
      < -6.834616, -0.864072, 0.324351>
    }
    triangle {
      < -6.852790, -0.812893, 0.158199>,
      < -6.869224, -0.812893, 0.007953>,
      < -6.869224, -0.864072, 0.007953>
    }
    triangle {
      < -6.852790, -0.812893, 0.158199>,
      < -6.869224, -0.864072, 0.007953>,
      < -6.852790, -0.864072, 0.158199>
    }
    triangle {
      < -6.798269, -0.812893, 0.656654>,
      < -6.814703, -0.812893, 0.506407>,
      < -6.814703, -0.864072, 0.506407>
    }
    triangle {
      < -6.798269, -0.812893, 0.656654>,
      < -6.814703, -0.864072, 0.506407>,
      < -6.798269, -0.864072, 0.656654>
    }
    triangle {
      < -6.816443, -0.812893, 0.490502>,
      < -6.832877, -0.812893, 0.340256>,
      < -6.832877, -0.864072, 0.340256>
    }
    triangle {
      < -6.816443, -0.812893, 0.490502>,
      < -6.832877, -0.864072, 0.340256>,
      < -6.816443, -0.864072, 0.490502>
    }
    triangle {
      < -6.761921, -0.812893, 0.988957>,
      < -6.778356, -0.812893, 0.838711>,
      < -6.778356, -0.864072, 0.838711>
    }
    triangle {
      < -6.761921, -0.812893, 0.988957>,
      < -6.778356, -0.864072, 0.838711>,
      < -6.761921, -0.864072, 0.988957>
    }
    triangle {
      < -6.780095, -0.812893, 0.822805>,
      < -6.796529, -0.812893, 0.672559>,
      < -6.796529, -0.864072, 0.672559>
    }
    triangle {
      < -6.780095, -0.812893, 0.822805>,
      < -6.796529, -0.864072, 0.672559>,
      < -6.780095, -0.864072, 0.822805>
    }
    triangle {
      < -6.725573, -0.812893, 1.321260>,
      < -6.742008, -0.812893, 1.171014>,
      < -6.742008, -0.864072, 1.171014>
    }
    triangle {
      < -6.725573, -0.812893, 1.321260>,
      < -6.742008, -0.864072, 1.171014>,
      < -6.725573, -0.864072, 1.321260>
    }
    triangle {
      < -6.743747, -0.812893, 1.155109>,
      < -6.760181, -0.812893, 1.004862>,
      < -6.760181, -0.864072, 1.004862>
    }
    triangle {
      < -6.743747, -0.812893, 1.155109>,
      < -6.760181, -0.864072, 1.004862>,
      < -6.743747, -0.864072, 1.155109>
    }
    triangle {
      < -6.689225, -0.812893, 1.653563>,
      < -6.705659, -0.812893, 1.503317>,
      < -6.705659, -0.864072, 1.503317>
    }
    triangle {
      < -6.689225, -0.812893, 1.653563>,
      < -6.705659, -0.864072, 1.503317>,
      < -6.689225, -0.864072, 1.653563>
    }
    triangle {
      < -6.707399, -0.812893, 1.487412>,
      < -6.723834, -0.812893, 1.337165>,
      < -6.723834, -0.864072, 1.337165>
    }
    triangle {
      < -6.707399, -0.812893, 1.487412>,
      < -6.723834, -0.864072, 1.337165>,
      < -6.707399, -0.864072, 1.487412>
    }
    triangle {
      < -6.652877, -0.812893, 1.985867>,
      < -6.669312, -0.812893, 1.835620>,
      < -6.669312, -0.864072, 1.835620>
    }
    triangle {
      < -6.652877, -0.812893, 1.985867>,
      < -6.669312, -0.864072, 1.835620>,
      < -6.652877, -0.864072, 1.985867>
    }
    triangle {
      < -6.671051, -0.812893, 1.819715>,
      < -6.687486, -0.812893, 1.669469>,
      < -6.687486, -0.864072, 1.669469>
    }
    triangle {
      < -6.671051, -0.812893, 1.819715>,
      < -6.687486, -0.864072, 1.669469>,
      < -6.671051, -0.864072, 1.819715>
    }
    triangle {
      < -6.616529, -0.812893, 2.318170>,
      < -6.632964, -0.812893, 2.167924>,
      < -6.632964, -0.864072, 2.167924>
    }
    triangle {
      < -6.616529, -0.812893, 2.318170>,
      < -6.632964, -0.864072, 2.167924>,
      < -6.616529, -0.864072, 2.318170>
    }
    triangle {
      < -6.634703, -0.812893, 2.152019>,
      < -6.651138, -0.812893, 2.001772>,
      < -6.651138, -0.864072, 2.001772>
    }
    triangle {
      < -6.634703, -0.812893, 2.152019>,
      < -6.651138, -0.864072, 2.001772>,
      < -6.634703, -0.864072, 2.152019>
    }
    triangle {
      < -6.580181, -0.812893, 2.650474>,
      < -6.596616, -0.812893, 2.500227>,
      < -6.596616, -0.864072, 2.500227>
    }
    triangle {
      < -6.580181, -0.812893, 2.650474>,
      < -6.596616, -0.864072, 2.500227>,
      < -6.580181, -0.864072, 2.650474>
    }
    triangle {
      < -6.598355, -0.812893, 2.484322>,
      < -6.614789, -0.812893, 2.334075>,
      < -6.614789, -0.864072, 2.334075>
    }
    triangle {
      < -6.598355, -0.812893, 2.484322>,
      < -6.614789, -0.864072, 2.334075>,
      < -6.598355, -0.864072, 2.484322>
    }
    triangle {
      < -6.869224, -0.812893, -0.007953>,
      < -6.852789, -0.812893, -0.158199>,
      < -6.852789, -0.864072, -0.158199>
    }
    triangle {
      < -6.869224, -0.812893, -0.007953>,
      < -6.852789, -0.864072, -0.158199>,
      < -6.869224, -0.864072, -0.007953>
    }
    triangle {
      < -6.596615, -0.812893, -2.500227>,
      < -6.580181, -0.812893, -2.650473>,
      < -6.580181, -0.864072, -2.650473>
    }
    triangle {
      < -6.596615, -0.812893, -2.500227>,
      < -6.580181, -0.864072, -2.650473>,
      < -6.596615, -0.864072, -2.500227>
    }
    triangle {
      < -6.580181, -0.880072, 2.650474>,
      < -6.596616, -0.880072, 2.500227>,
      < -6.596616, -0.931251, 2.500227>
    }
    triangle {
      < -6.580181, -0.880072, 2.650474>,
      < -6.596616, -0.931251, 2.500227>,
      < -6.580181, -0.931251, 2.650474>
    }
    triangle {
      < -6.598355, -0.880072, 2.484322>,
      < -6.614789, -0.880072, 2.334075>,
      < -6.614789, -0.931251, 2.334075>
    }
    triangle {
      < -6.598355, -0.880072, 2.484322>,
      < -6.614789, -0.931251, 2.334075>,
      < -6.598355, -0.931251, 2.484322>
    }
    triangle {
      < -6.616529, -0.880072, 2.318170>,
      < -6.632964, -0.880072, 2.167924>,
      < -6.632964, -0.931251, 2.167924>
    }
    triangle {
      < -6.616529, -0.880072, 2.318170>,
      < -6.632964, -0.931251, 2.167924>,
      < -6.616529, -0.931251, 2.318170>
    }
    triangle {
      < -6.634703, -0.880072, 2.152019>,
      < -6.651138, -0.880072, 2.001772>,
      < -6.651138, -0.931251, 2.001772>
    }
    triangle {
      < -6.634703, -0.880072, 2.152019>,
      < -6.651138, -0.931251, 2.001772>,
      < -6.634703, -0.931251, 2.152019>
    }
    triangle {
      < -6.652877, -0.880072, 1.985867>,
      < -6.669312, -0.880072, 1.835620>,
      < -6.669312, -0.931251, 1.835620>
    }
    triangle {
      < -6.652877, -0.880072, 1.985867>,
      < -6.669312, -0.931251, 1.835620>,
      < -6.652877, -0.931251, 1.985867>
    }
    triangle {
      < -6.671051, -0.880072, 1.819715>,
      < -6.687486, -0.880072, 1.669469>,
      < -6.687486, -0.931251, 1.669469>
    }
    triangle {
      < -6.671051, -0.880072, 1.819715>,
      < -6.687486, -0.931251, 1.669469>,
      < -6.671051, -0.931251, 1.819715>
    }
    triangle {
      < -6.689225, -0.880072, 1.653563>,
      < -6.705659, -0.880072, 1.503317>,
      < -6.705659, -0.931251, 1.503317>
    }
    triangle {
      < -6.689225, -0.880072, 1.653563>,
      < -6.705659, -0.931251, 1.503317>,
      < -6.689225, -0.931251, 1.653563>
    }
    triangle {
      < -6.707399, -0.880072, 1.487412>,
      < -6.723834, -0.880072, 1.337165>,
      < -6.723834, -0.931251, 1.337166>
    }
    triangle {
      < -6.707399, -0.880072, 1.487412>,
      < -6.723834, -0.931251, 1.337166>,
      < -6.707399, -0.931251, 1.487412>
    }
    triangle {
      < -6.725573, -0.880072, 1.321260>,
      < -6.742008, -0.880072, 1.171014>,
      < -6.742008, -0.931251, 1.171014>
    }
    triangle {
      < -6.725573, -0.880072, 1.321260>,
      < -6.742008, -0.931251, 1.171014>,
      < -6.725573, -0.931251, 1.321260>
    }
    triangle {
      < -6.743747, -0.880072, 1.155109>,
      < -6.760181, -0.880072, 1.004862>,
      < -6.760181, -0.931251, 1.004862>
    }
    triangle {
      < -6.743747, -0.880072, 1.155109>,
      < -6.760181, -0.931251, 1.004862>,
      < -6.743747, -0.931251, 1.155109>
    }
    triangle {
      < -6.761921, -0.880072, 0.988957>,
      < -6.778356, -0.880072, 0.838711>,
      < -6.778356, -0.931251, 0.838711>
    }
    triangle {
      < -6.761921, -0.880072, 0.988957>,
      < -6.778356, -0.931251, 0.838711>,
      < -6.761921, -0.931251, 0.988957>
    }
    triangle {
      < -6.780095, -0.880072, 0.822805>,
      < -6.796529, -0.880072, 0.672559>,
      < -6.796529, -0.931251, 0.672559>
    }
    triangle {
      < -6.780095, -0.880072, 0.822805>,
      < -6.796529, -0.931251, 0.672559>,
      < -6.780095, -0.931251, 0.822805>
    }
    triangle {
      < -6.798269, -0.880072, 0.656654>,
      < -6.814703, -0.880072, 0.506407>,
      < -6.814703, -0.931251, 0.506407>
    }
    triangle {
      < -6.798269, -0.880072, 0.656654>,
      < -6.814703, -0.931251, 0.506407>,
      < -6.798269, -0.931251, 0.656654>
    }
    triangle {
      < -6.816443, -0.880072, 0.490502>,
      < -6.832877, -0.880072, 0.340256>,
      < -6.832877, -0.931251, 0.340256>
    }
    triangle {
      < -6.816443, -0.880072, 0.490502>,
      < -6.832877, -0.931251, 0.340256>,
      < -6.816443, -0.931251, 0.490502>
    }
    triangle {
      < -6.834616, -0.880072, 0.324351>,
      < -6.851051, -0.880072, 0.174104>,
      < -6.851051, -0.931251, 0.174104>
    }
    triangle {
      < -6.834616, -0.880072, 0.324351>,
      < -6.851051, -0.931251, 0.174104>,
      < -6.834616, -0.931251, 0.324351>
    }
    triangle {
      < -6.852790, -0.880072, 0.158199>,
      < -6.869224, -0.880072, 0.007953>,
      < -6.869224, -0.931251, 0.007953>
    }
    triangle {
      < -6.852790, -0.880072, 0.158199>,
      < -6.869224, -0.931251, 0.007953>,
      < -6.852790, -0.931251, 0.158199>
    }
    triangle {
      < -6.851050, -0.880072, -0.174104>,
      < -6.834615, -0.880072, -0.324351>,
      < -6.834615, -0.931251, -0.324351>
    }
    triangle {
      < -6.851050, -0.880072, -0.174104>,
      < -6.834615, -0.931251, -0.324351>,
      < -6.851050, -0.931251, -0.174104>
    }
    triangle {
      < -6.832876, -0.880072, -0.340256>,
      < -6.816442, -0.880072, -0.490502>,
      < -6.816442, -0.931251, -0.490502>
    }
    triangle {
      < -6.832876, -0.880072, -0.340256>,
      < -6.816442, -0.931251, -0.490502>,
      < -6.832876, -0.931251, -0.340256>
    }
    triangle {
      < -6.814702, -0.880072, -0.506407>,
      < -6.798267, -0.880072, -0.656654>,
      < -6.798267, -0.931251, -0.656654>
    }
    triangle {
      < -6.814702, -0.880072, -0.506407>,
      < -6.798267, -0.931251, -0.656654>,
      < -6.814702, -0.931251, -0.506407>
    }
    triangle {
      < -6.796528, -0.880072, -0.672559>,
      < -6.780094, -0.880072, -0.822806>,
      < -6.780094, -0.931251, -0.822806>
    }
    triangle {
      < -6.796528, -0.880072, -0.672559>,
      < -6.780094, -0.931251, -0.822806>,
      < -6.796528, -0.931251, -0.672559>
    }
    triangle {
      < -6.778354, -0.880072, -0.838711>,
      < -6.761919, -0.880072, -0.988957>,
      < -6.761919, -0.931251, -0.988957>
    }
    triangle {
      < -6.778354, -0.880072, -0.838711>,
      < -6.761919, -0.931251, -0.988957>,
      < -6.778354, -0.931251, -0.838711>
    }
    triangle {
      < -6.760180, -0.880072, -1.004863>,
      < -6.743745, -0.880072, -1.155109>,
      < -6.743745, -0.931251, -1.155109>
    }
    triangle {
      < -6.760180, -0.880072, -1.004863>,
      < -6.743745, -0.931251, -1.155109>,
      < -6.760180, -0.931251, -1.004863>
    }
    triangle {
      < -6.742006, -0.880072, -1.171014>,
      < -6.725572, -0.880072, -1.321261>,
      < -6.725572, -0.931251, -1.321261>
    }
    triangle {
      < -6.742006, -0.880072, -1.171014>,
      < -6.725572, -0.931251, -1.321261>,
      < -6.742006, -0.931251, -1.171014>
    }
    triangle {
      < -6.723832, -0.880072, -1.337166>,
      < -6.707397, -0.880072, -1.487412>,
      < -6.707397, -0.931251, -1.487412>
    }
    triangle {
      < -6.723832, -0.880072, -1.337166>,
      < -6.707397, -0.931251, -1.487412>,
      < -6.723832, -0.931251, -1.337166>
    }
    triangle {
      < -6.705658, -0.880072, -1.503317>,
      < -6.689224, -0.880072, -1.653564>,
      < -6.689224, -0.931251, -1.653564>
    }
    triangle {
      < -6.705658, -0.880072, -1.503317>,
      < -6.689224, -0.931251, -1.653564>,
      < -6.705658, -0.931251, -1.503317>
    }
    triangle {
      < -6.687484, -0.880072, -1.669469>,
      < -6.671050, -0.880072, -1.819715>,
      < -6.671050, -0.931251, -1.819715>
    }
    triangle {
      < -6.687484, -0.880072, -1.669469>,
      < -6.671050, -0.931251, -1.819715>,
      < -6.687484, -0.931251, -1.669469>
    }
    triangle {
      < -6.669310, -0.880072, -1.835621>,
      < -6.652875, -0.880072, -1.985867>,
      < -6.652875, -0.931251, -1.985867>
    }
    triangle {
      < -6.669310, -0.880072, -1.835621>,
      < -6.652875, -0.931251, -1.985867>,
      < -6.669310, -0.931251, -1.835621>
    }
    triangle {
      < -6.651136, -0.880072, -2.001772>,
      < -6.634702, -0.880072, -2.152019>,
      < -6.634702, -0.931251, -2.152019>
    }
    triangle {
      < -6.651136, -0.880072, -2.001772>,
      < -6.634702, -0.931251, -2.152019>,
      < -6.651136, -0.931251, -2.001772>
    }
    triangle {
      < -6.632962, -0.880072, -2.167924>,
      < -6.616529, -0.880072, -2.318170>,
      < -6.616529, -0.931251, -2.318170>
    }
    triangle {
      < -6.632962, -0.880072, -2.167924>,
      < -6.616529, -0.931251, -2.318170>,
      < -6.632962, -0.931251, -2.167924>
    }
    triangle {
      < -6.614789, -0.880072, -2.334075>,
      < -6.598354, -0.880072, -2.484322>,
      < -6.598354, -0.931251, -2.484322>
    }
    triangle {
      < -6.614789, -0.880072, -2.334075>,
      < -6.598354, -0.931251, -2.484322>,
      < -6.614789, -0.931251, -2.334075>
    }
    triangle {
      < -6.869224, -0.880072, -0.007953>,
      < -6.852789, -0.880072, -0.158199>,
      < -6.852789, -0.931251, -0.158199>
    }
    triangle {
      < -6.869224, -0.880072, -0.007953>,
      < -6.852789, -0.931251, -0.158199>,
      < -6.869224, -0.931251, -0.007953>
    }
    triangle {
      < -6.596615, -0.880072, -2.500227>,
      < -6.580181, -0.880072, -2.650473>,
      < -6.580181, -0.931251, -2.650473>
    }
    triangle {
      < -6.596615, -0.880072, -2.500227>,
      < -6.580181, -0.931251, -2.650473>,
      < -6.596615, -0.931251, -2.500227>
    }
    triangle {
      < -6.632962, -0.947251, -2.167924>,
      < -6.616529, -0.947251, -2.318170>,
      < -6.616529, -0.998430, -2.318170>
    }
    triangle {
      < -6.632962, -0.947251, -2.167924>,
      < -6.616529, -0.998430, -2.318170>,
      < -6.632962, -0.998430, -2.167924>
    }
    triangle {
      < -6.614789, -0.947251, -2.334075>,
      < -6.598354, -0.947251, -2.484322>,
      < -6.598354, -0.998430, -2.484322>
    }
    triangle {
      < -6.614789, -0.947251, -2.334075>,
      < -6.598354, -0.998430, -2.484322>,
      < -6.614789, -0.998430, -2.334075>
    }
    triangle {
      < -6.669310, -0.947251, -1.835621>,
      < -6.652875, -0.947251, -1.985867>,
      < -6.652875, -0.998430, -1.985867>
    }
    triangle {
      < -6.669310, -0.947251, -1.835621>,
      < -6.652875, -0.998430, -1.985867>,
      < -6.669310, -0.998430, -1.835621>
    }
    triangle {
      < -6.651136, -0.947251, -2.001772>,
      < -6.634702, -0.947251, -2.152019>,
      < -6.634702, -0.998430, -2.152019>
    }
    triangle {
      < -6.651136, -0.947251, -2.001772>,
      < -6.634702, -0.998430, -2.152019>,
      < -6.651136, -0.998430, -2.001772>
    }
    triangle {
      < -6.705658, -0.947251, -1.503317>,
      < -6.689224, -0.947251, -1.653564>,
      < -6.689224, -0.998430, -1.653564>
    }
    triangle {
      < -6.705658, -0.947251, -1.503317>,
      < -6.689224, -0.998430, -1.653564>,
      < -6.705658, -0.998430, -1.503317>
    }
    triangle {
      < -6.687484, -0.947251, -1.669469>,
      < -6.671050, -0.947251, -1.819715>,
      < -6.671050, -0.998430, -1.819715>
    }
    triangle {
      < -6.687484, -0.947251, -1.669469>,
      < -6.671050, -0.998430, -1.819715>,
      < -6.687484, -0.998430, -1.669469>
    }
    triangle {
      < -6.742006, -0.947251, -1.171014>,
      < -6.725572, -0.947251, -1.321261>,
      < -6.725572, -0.998430, -1.321261>
    }
    triangle {
      < -6.742006, -0.947251, -1.171014>,
      < -6.725572, -0.998430, -1.321261>,
      < -6.742006, -0.998430, -1.171014>
    }
    triangle {
      < -6.723832, -0.947251, -1.337166>,
      < -6.707397, -0.947251, -1.487412>,
      < -6.707397, -0.998430, -1.487412>
    }
    triangle {
      < -6.723832, -0.947251, -1.337166>,
      < -6.707397, -0.998430, -1.487412>,
      < -6.723832, -0.998430, -1.337166>
    }
    triangle {
      < -6.778354, -0.947251, -0.838711>,
      < -6.761919, -0.947251, -0.988957>,
      < -6.761919, -0.998430, -0.988957>
    }
    triangle {
      < -6.778354, -0.947251, -0.838711>,
      < -6.761919, -0.998430, -0.988957>,
      < -6.778354, -0.998430, -0.838711>
    }
    triangle {
      < -6.760180, -0.947251, -1.004863>,
      < -6.743745, -0.947251, -1.155109>,
      < -6.743745, -0.998430, -1.155109>
    }
    triangle {
      < -6.760180, -0.947251, -1.004863>,
      < -6.743745, -0.998430, -1.155109>,
      < -6.760180, -0.998430, -1.004863>
    }
    triangle {
      < -6.814702, -0.947251, -0.506407>,
      < -6.798267, -0.947251, -0.656654>,
      < -6.798267, -0.998430, -0.656654>
    }
    triangle {
      < -6.814702, -0.947251, -0.506407>,
      < -6.798267, -0.998430, -0.656654>,
      < -6.814702, -0.998430, -0.506407>
    }
    triangle {
      < -6.796528, -0.947251, -0.672559>,
      < -6.780094, -0.947251, -0.822806>,
      < -6.780094, -0.998430, -0.822806>
    }
    triangle {
      < -6.796528, -0.947251, -0.672559>,
      < -6.780094, -0.998430, -0.822806>,
      < -6.796528, -0.998430, -0.672559>
    }
    triangle {
      < -6.851050, -0.947251, -0.174104>,
      < -6.834615, -0.947251, -0.324351>,
      < -6.834615, -0.998430, -0.324351>
    }
    triangle {
      < -6.851050, -0.947251, -0.174104>,
      < -6.834615, -0.998430, -0.324351>,
      < -6.851050, -0.998430, -0.174104>
    }
    triangle {
      < -6.832876, -0.947251, -0.340256>,
      < -6.816442, -0.947251, -0.490502>,
      < -6.816442, -0.998430, -0.490502>
    }
    triangle {
      < -6.832876, -0.947251, -0.340256>,
      < -6.816442, -0.998430, -0.490502>,
      < -6.832876, -0.998430, -0.340256>
    }
    triangle {
      < -6.834616, -0.947251, 0.324351>,
      < -6.851051, -0.947251, 0.174104>,
      < -6.851051, -0.998430, 0.174104>
    }
    triangle {
      < -6.834616, -0.947251, 0.324351>,
      < -6.851051, -0.998430, 0.174104>,
      < -6.834616, -0.998430, 0.324351>
    }
    triangle {
      < -6.852790, -0.947251, 0.158199>,
      < -6.869224, -0.947251, 0.007953>,
      < -6.869224, -0.998430, 0.007953>
    }
    triangle {
      < -6.852790, -0.947251, 0.158199>,
      < -6.869224, -0.998430, 0.007953>,
      < -6.852790, -0.998430, 0.158199>
    }
    triangle {
      < -6.798269, -0.947251, 0.656654>,
      < -6.814703, -0.947251, 0.506407>,
      < -6.814703, -0.998430, 0.506407>
    }
    triangle {
      < -6.798269, -0.947251, 0.656654>,
      < -6.814703, -0.998430, 0.506407>,
      < -6.798269, -0.998430, 0.656654>
    }
    triangle {
      < -6.816443, -0.947251, 0.490502>,
      < -6.832877, -0.947251, 0.340256>,
      < -6.832877, -0.998430, 0.340256>
    }
    triangle {
      < -6.816443, -0.947251, 0.490502>,
      < -6.832877, -0.998430, 0.340256>,
      < -6.816443, -0.998430, 0.490502>
    }
    triangle {
      < -6.761921, -0.947251, 0.988957>,
      < -6.778356, -0.947251, 0.838711>,
      < -6.778356, -0.998430, 0.838711>
    }
    triangle {
      < -6.761921, -0.947251, 0.988957>,
      < -6.778356, -0.998430, 0.838711>,
      < -6.761921, -0.998430, 0.988957>
    }
    triangle {
      < -6.780095, -0.947251, 0.822805>,
      < -6.796529, -0.947251, 0.672559>,
      < -6.796529, -0.998430, 0.672559>
    }
    triangle {
      < -6.780095, -0.947251, 0.822805>,
      < -6.796529, -0.998430, 0.672559>,
      < -6.780095, -0.998430, 0.822805>
    }
    triangle {
      < -6.725573, -0.947251, 1.321260>,
      < -6.742008, -0.947251, 1.171014>,
      < -6.742008, -0.998430, 1.171014>
    }
    triangle {
      < -6.725573, -0.947251, 1.321260>,
      < -6.742008, -0.998430, 1.171014>,
      < -6.725573, -0.998430, 1.321260>
    }
    triangle {
      < -6.743747, -0.947251, 1.155109>,
      < -6.760181, -0.947251, 1.004862>,
      < -6.760181, -0.998430, 1.004862>
    }
    triangle {
      < -6.743747, -0.947251, 1.155109>,
      < -6.760181, -0.998430, 1.004862>,
      < -6.743747, -0.998430, 1.155109>
    }
    triangle {
      < -6.689225, -0.947251, 1.653563>,
      < -6.705659, -0.947251, 1.503317>,
      < -6.705659, -0.998430, 1.503317>
    }
    triangle {
      < -6.689225, -0.947251, 1.653563>,
      < -6.705659, -0.998430, 1.503317>,
      < -6.689225, -0.998430, 1.653563>
    }
    triangle {
      < -6.707399, -0.947251, 1.487412>,
      < -6.723834, -0.947251, 1.337166>,
      < -6.723834, -0.998430, 1.337166>
    }
    triangle {
      < -6.707399, -0.947251, 1.487412>,
      < -6.723834, -0.998430, 1.337166>,
      < -6.707399, -0.998430, 1.487412>
    }
    triangle {
      < -6.652877, -0.947251, 1.985867>,
      < -6.669312, -0.947251, 1.835620>,
      < -6.669312, -0.998430, 1.835620>
    }
    triangle {
      < -6.652877, -0.947251, 1.985867>,
      < -6.669312, -0.998430, 1.835620>,
      < -6.652877, -0.998430, 1.985867>
    }
    triangle {
      < -6.671051, -0.947251, 1.819715>,
      < -6.687486, -0.947251, 1.669469>,
      < -6.687486, -0.998430, 1.669469>
    }
    triangle {
      < -6.671051, -0.947251, 1.819715>,
      < -6.687486, -0.998430, 1.669469>,
      < -6.671051, -0.998430, 1.819715>
    }
    triangle {
      < -6.616529, -0.947251, 2.318170>,
      < -6.632964, -0.947251, 2.167924>,
      < -6.632964, -0.998430, 2.167924>
    }
    triangle {
      < -6.616529, -0.947251, 2.318170>,
      < -6.632964, -0.998430, 2.167924>,
      < -6.616529, -0.998430, 2.318170>
    }
    triangle {
      < -6.634703, -0.947251, 2.152019>,
      < -6.651138, -0.947251, 2.001772>,
      < -6.651138, -0.998430, 2.001772>
    }
    triangle {
      < -6.634703, -0.947251, 2.152019>,
      < -6.651138, -0.998430, 2.001772>,
      < -6.634703, -0.998430, 2.152019>
    }
    triangle {
      < -6.580181, -0.947251, 2.650474>,
      < -6.596616, -0.947251, 2.500227>,
      < -6.596616, -0.998430, 2.500227>
    }
    triangle {
      < -6.580181, -0.947251, 2.650474>,
      < -6.596616, -0.998430, 2.500227>,
      < -6.580181, -0.998430, 2.650474>
    }
    triangle {
      < -6.598355, -0.947251, 2.484322>,
      < -6.614789, -0.947251, 2.334075>,
      < -6.614789, -0.998430, 2.334075>
    }
    triangle {
      < -6.598355, -0.947251, 2.484322>,
      < -6.614789, -0.998430, 2.334075>,
      < -6.598355, -0.998430, 2.484322>
    }
    triangle {
      < -6.869224, -0.947251, -0.007953>,
      < -6.852789, -0.947251, -0.158199>,
      < -6.852789, -0.998430, -0.158199>
    }
    triangle {
      < -6.869224, -0.947251, -0.007953>,
      < -6.852789, -0.998430, -0.158199>,
      < -6.869224, -0.998430, -0.007953>
    }
    triangle {
      < -6.596615, -0.947251, -2.500227>,
      < -6.580181, -0.947251, -2.650473>,
      < -6.580181, -0.998430, -2.650473>
    }
    triangle {
      < -6.596615, -0.947251, -2.500227>,
      < -6.580181, -0.998430, -2.650473>,
      < -6.596615, -0.998430, -2.500227>
    }
    triangle {
      < -6.580181, -1.014430, 2.650474>,
      < -6.596616, -1.014430, 2.500227>,
      < -6.596616, -1.065609, 2.500227>
    }
    triangle {
      < -6.580181, -1.014430, 2.650474>,
      < -6.596616, -1.065609, 2.500227>,
      < -6.580181, -1.065609, 2.650474>
    }
    triangle {
      < -6.598355, -1.014430, 2.484322>,
      < -6.614789, -1.014430, 2.334075>,
      < -6.614789, -1.065609, 2.334075>
    }
    triangle {
      < -6.598355, -1.014430, 2.484322>,
      < -6.614789, -1.065609, 2.334075>,
      < -6.598355, -1.065609, 2.484322>
    }
    triangle {
      < -6.616529, -1.014430, 2.318170>,
      < -6.632964, -1.014430, 2.167924>,
      < -6.632964, -1.065609, 2.167924>
    }
    triangle {
      < -6.616529, -1.014430, 2.318170>,
      < -6.632964, -1.065609, 2.167924>,
      < -6.616529, -1.065609, 2.318170>
    }
    triangle {
      < -6.634703, -1.014430, 2.152019>,
      < -6.651138, -1.014430, 2.001772>,
      < -6.651138, -1.065609, 2.001772>
    }
    triangle {
      < -6.634703, -1.014430, 2.152019>,
      < -6.651138, -1.065609, 2.001772>,
      < -6.634703, -1.065609, 2.152019>
    }
    triangle {
      < -6.652877, -1.014430, 1.985867>,
      < -6.669312, -1.014430, 1.835620>,
      < -6.669312, -1.065609, 1.835620>
    }
    triangle {
      < -6.652877, -1.014430, 1.985867>,
      < -6.669312, -1.065609, 1.835620>,
      < -6.652877, -1.065609, 1.985867>
    }
    triangle {
      < -6.671051, -1.014430, 1.819715>,
      < -6.687486, -1.014430, 1.669469>,
      < -6.687486, -1.065609, 1.669469>
    }
    triangle {
      < -6.671051, -1.014430, 1.819715>,
      < -6.687486, -1.065609, 1.669469>,
      < -6.671051, -1.065609, 1.819715>
    }
    triangle {
      < -6.689225, -1.014430, 1.653563>,
      < -6.705659, -1.014430, 1.503317>,
      < -6.705659, -1.065609, 1.503317>
    }
    triangle {
      < -6.689225, -1.014430, 1.653563>,
      < -6.705659, -1.065609, 1.503317>,
      < -6.689225, -1.065609, 1.653563>
    }
    triangle {
      < -6.707399, -1.014430, 1.487412>,
      < -6.723834, -1.014430, 1.337166>,
      < -6.723834, -1.065609, 1.337166>
    }
    triangle {
      < -6.707399, -1.014430, 1.487412>,
      < -6.723834, -1.065609, 1.337166>,
      < -6.707399, -1.065609, 1.487412>
    }
    triangle {
      < -6.725573, -1.014430, 1.321260>,
      < -6.742008, -1.014430, 1.171014>,
      < -6.742008, -1.065609, 1.171014>
    }
    triangle {
      < -6.725573, -1.014430, 1.321260>,
      < -6.742008, -1.065609, 1.171014>,
      < -6.725573, -1.065609, 1.321260>
    }
    triangle {
      < -6.743747, -1.014430, 1.155109>,
      < -6.760181, -1.014430, 1.004862>,
      < -6.760181, -1.065609, 1.004862>
    }
    triangle {
      < -6.743747, -1.014430, 1.155109>,
      < -6.760181, -1.065609, 1.004862>,
      < -6.743747, -1.065609, 1.155109>
    }
    triangle {
      < -6.761921, -1.014430, 0.988957>,
      < -6.778356, -1.014430, 0.838711>,
      < -6.778356, -1.065609, 0.838711>
    }
    triangle {
      < -6.761921, -1.014430, 0.988957>,
      < -6.778356, -1.065609, 0.838711>,
      < -6.761921, -1.065609, 0.988957>
    }
    triangle {
      < -6.780095, -1.014430, 0.822805>,
      < -6.796529, -1.014430, 0.672559>,
      < -6.796529, -1.065609, 0.672559>
    }
    triangle {
      < -6.780095, -1.014430, 0.822805>,
      < -6.796529, -1.065609, 0.672559>,
      < -6.780095, -1.065609, 0.822806>
    }
    triangle {
      < -6.798269, -1.014430, 0.656654>,
      < -6.814703, -1.014430, 0.506407>,
      < -6.814703, -1.065609, 0.506407>
    }
    triangle {
      < -6.798269, -1.014430, 0.656654>,
      < -6.814703, -1.065609, 0.506407>,
      < -6.798269, -1.065609, 0.656654>
    }
    triangle {
      < -6.816443, -1.014430, 0.490502>,
      < -6.832877, -1.014430, 0.340256>,
      < -6.832877, -1.065609, 0.340256>
    }
    triangle {
      < -6.816443, -1.014430, 0.490502>,
      < -6.832877, -1.065609, 0.340256>,
      < -6.816443, -1.065609, 0.490502>
    }
    triangle {
      < -6.834616, -1.014430, 0.324351>,
      < -6.851051, -1.014430, 0.174104>,
      < -6.851051, -1.065609, 0.174104>
    }
    triangle {
      < -6.834616, -1.014430, 0.324351>,
      < -6.851051, -1.065609, 0.174104>,
      < -6.834616, -1.065609, 0.324351>
    }
    triangle {
      < -6.852790, -1.014430, 0.158199>,
      < -6.869224, -1.014430, 0.007953>,
      < -6.869224, -1.065609, 0.007953>
    }
    triangle {
      < -6.852790, -1.014430, 0.158199>,
      < -6.869224, -1.065609, 0.007953>,
      < -6.852790, -1.065609, 0.158199>
    }
    triangle {
      < -6.851050, -1.014430, -0.174104>,
      < -6.834615, -1.014430, -0.324351>,
      < -6.834615, -1.065609, -0.324351>
    }
    triangle {
      < -6.851050, -1.014430, -0.174104>,
      < -6.834615, -1.065609, -0.324351>,
      < -6.851050, -1.065609, -0.174104>
    }
    triangle {
      < -6.832876, -1.014430, -0.340256>,
      < -6.816442, -1.014430, -0.490502>,
      < -6.816442, -1.065609, -0.490502>
    }
    triangle {
      < -6.832876, -1.014430, -0.340256>,
      < -6.816442, -1.065609, -0.490502>,
      < -6.832876, -1.065609, -0.340256>
    }
    triangle {
      < -6.814702, -1.014430, -0.506407>,
      < -6.798267, -1.014430, -0.656654>,
      < -6.798267, -1.065609, -0.656654>
    }
    triangle {
      < -6.814702, -1.014430, -0.506407>,
      < -6.798267, -1.065609, -0.656654>,
      < -6.814702, -1.065609, -0.506407>
    }
    triangle {
      < -6.796528, -1.014430, -0.672559>,
      < -6.780094, -1.014430, -0.822806>,
      < -6.780094, -1.065609, -0.822806>
    }
    triangle {
      < -6.796528, -1.014430, -0.672559>,
      < -6.780094, -1.065609, -0.822806>,
      < -6.796528, -1.065609, -0.672559>
    }
    triangle {
      < -6.778354, -1.014430, -0.838711>,
      < -6.761919, -1.014430, -0.988957>,
      < -6.761919, -1.065609, -0.988957>
    }
    triangle {
      < -6.778354, -1.014430, -0.838711>,
      < -6.761919, -1.065609, -0.988957>,
      < -6.778354, -1.065609, -0.838711>
    }
    triangle {
      < -6.760180, -1.014430, -1.004863>,
      < -6.743745, -1.014430, -1.155109>,
      < -6.743745, -1.065609, -1.155109>
    }
    triangle {
      < -6.760180, -1.014430, -1.004863>,
      < -6.743745, -1.065609, -1.155109>,
      < -6.760180, -1.065609, -1.004863>
    }
    triangle {
      < -6.742006, -1.014430, -1.171014>,
      < -6.725572, -1.014430, -1.321261>,
      < -6.725572, -1.065609, -1.321261>
    }
    triangle {
      < -6.742006, -1.014430, -1.171014>,
      < -6.725572, -1.065609, -1.321261>,
      < -6.742006, -1.065609, -1.171014>
    }
    triangle {
      < -6.723832, -1.014430, -1.337166>,
      < -6.707397, -1.014430, -1.487412>,
      < -6.707397, -1.065609, -1.487412>
    }
    triangle {
      < -6.723832, -1.014430, -1.337166>,
      < -6.707397, -1.065609, -1.487412>,
      < -6.723832, -1.065609, -1.337166>
    }
    triangle {
      < -6.705658, -1.014430, -1.503317>,
      < -6.689224, -1.014430, -1.653564>,
      < -6.689224, -1.065609, -1.653564>
    }
    triangle {
      < -6.705658, -1.014430, -1.503317>,
      < -6.689224, -1.065609, -1.653564>,
      < -6.705658, -1.065609, -1.503317>
    }
    triangle {
      < -6.687484, -1.014430, -1.669469>,
      < -6.671050, -1.014430, -1.819715>,
      < -6.671050, -1.065609, -1.819715>
    }
    triangle {
      < -6.687484, -1.014430, -1.669469>,
      < -6.671050, -1.065609, -1.819715>,
      < -6.687484, -1.065609, -1.669469>
    }
    triangle {
      < -6.669310, -1.014430, -1.835621>,
      < -6.652875, -1.014430, -1.985867>,
      < -6.652875, -1.065609, -1.985867>
    }
    triangle {
      < -6.669310, -1.014430, -1.835621>,
      < -6.652875, -1.065609, -1.985867>,
      < -6.669310, -1.065609, -1.835621>
    }
    triangle {
      < -6.651136, -1.014430, -2.001772>,
      < -6.634702, -1.014430, -2.152019>,
      < -6.634702, -1.065609, -2.152019>
    }
    triangle {
      < -6.651136, -1.014430, -2.001772>,
      < -6.634702, -1.065609, -2.152019>,
      < -6.651136, -1.065609, -2.001772>
    }
    triangle {
      < -6.632962, -1.014430, -2.167924>,
      < -6.616529, -1.014430, -2.318170>,
      < -6.616529, -1.065609, -2.318170>
    }
    triangle {
      < -6.632962, -1.014430, -2.167924>,
      < -6.616529, -1.065609, -2.318170>,
      < -6.632962, -1.065609, -2.167924>
    }
    triangle {
      < -6.614789, -1.014430, -2.334075>,
      < -6.598354, -1.014430, -2.484322>,
      < -6.598354, -1.065609, -2.484322>
    }
    triangle {
      < -6.614789, -1.014430, -2.334075>,
      < -6.598354, -1.065609, -2.484322>,
      < -6.614789, -1.065609, -2.334075>
    }
    triangle {
      < -6.869224, -1.014430, -0.007953>,
      < -6.852789, -1.014430, -0.158199>,
      < -6.852789, -1.065609, -0.158199>
    }
    triangle {
      < -6.869224, -1.014430, -0.007953>,
      < -6.852789, -1.065609, -0.158199>,
      < -6.869224, -1.065609, -0.007953>
    }
    triangle {
      < -6.596615, -1.014430, -2.500227>,
      < -6.580181, -1.014430, -2.650473>,
      < -6.580181, -1.065609, -2.650473>
    }
    triangle {
      < -6.596615, -1.014430, -2.500227>,
      < -6.580181, -1.065609, -2.650473>,
      < -6.596615, -1.065609, -2.500227>
    }
    triangle {
      < -6.632962, -1.081609, -2.167924>,
      < -6.616529, -1.081609, -2.318170>,
      < -6.616529, -1.132789, -2.318170>
    }
    triangle {
      < -6.632962, -1.081609, -2.167924>,
      < -6.616529, -1.132789, -2.318170>,
      < -6.632962, -1.132789, -2.167924>
    }
    triangle {
      < -6.614789, -1.081609, -2.334075>,
      < -6.598354, -1.081609, -2.484322>,
      < -6.598354, -1.132789, -2.484322>
    }
    triangle {
      < -6.614789, -1.081609, -2.334075>,
      < -6.598354, -1.132789, -2.484322>,
      < -6.614789, -1.132789, -2.334075>
    }
    triangle {
      < -6.669310, -1.081609, -1.835621>,
      < -6.652875, -1.081609, -1.985867>,
      < -6.652875, -1.132789, -1.985867>
    }
    triangle {
      < -6.669310, -1.081609, -1.835621>,
      < -6.652875, -1.132789, -1.985867>,
      < -6.669310, -1.132789, -1.835621>
    }
    triangle {
      < -6.651136, -1.081609, -2.001772>,
      < -6.634702, -1.081609, -2.152019>,
      < -6.634702, -1.132789, -2.152019>
    }
    triangle {
      < -6.651136, -1.081609, -2.001772>,
      < -6.634702, -1.132789, -2.152019>,
      < -6.651136, -1.132789, -2.001772>
    }
    triangle {
      < -6.705658, -1.081609, -1.503317>,
      < -6.689224, -1.081609, -1.653564>,
      < -6.689224, -1.132789, -1.653564>
    }
    triangle {
      < -6.705658, -1.081609, -1.503317>,
      < -6.689224, -1.132789, -1.653564>,
      < -6.705658, -1.132789, -1.503317>
    }
    triangle {
      < -6.687484, -1.081609, -1.669469>,
      < -6.671050, -1.081609, -1.819715>,
      < -6.671050, -1.132789, -1.819715>
    }
    triangle {
      < -6.687484, -1.081609, -1.669469>,
      < -6.671050, -1.132789, -1.819715>,
      < -6.687484, -1.132789, -1.669469>
    }
    triangle {
      < -6.742006, -1.081609, -1.171014>,
      < -6.725572, -1.081609, -1.321261>,
      < -6.725572, -1.132789, -1.321260>
    }
    triangle {
      < -6.742006, -1.081609, -1.171014>,
      < -6.725572, -1.132789, -1.321260>,
      < -6.742006, -1.132789, -1.171014>
    }
    triangle {
      < -6.723832, -1.081609, -1.337166>,
      < -6.707397, -1.081609, -1.487412>,
      < -6.707397, -1.132789, -1.487412>
    }
    triangle {
      < -6.723832, -1.081609, -1.337166>,
      < -6.707397, -1.132789, -1.487412>,
      < -6.723832, -1.132789, -1.337166>
    }
    triangle {
      < -6.778354, -1.081609, -0.838711>,
      < -6.761919, -1.081609, -0.988957>,
      < -6.761919, -1.132789, -0.988957>
    }
    triangle {
      < -6.778354, -1.081609, -0.838711>,
      < -6.761919, -1.132789, -0.988957>,
      < -6.778354, -1.132789, -0.838711>
    }
    triangle {
      < -6.760180, -1.081609, -1.004863>,
      < -6.743745, -1.081609, -1.155109>,
      < -6.743745, -1.132789, -1.155109>
    }
    triangle {
      < -6.760180, -1.081609, -1.004863>,
      < -6.743745, -1.132789, -1.155109>,
      < -6.760180, -1.132789, -1.004862>
    }
    triangle {
      < -6.814702, -1.081609, -0.506407>,
      < -6.798267, -1.081609, -0.656654>,
      < -6.798267, -1.132789, -0.656654>
    }
    triangle {
      < -6.814702, -1.081609, -0.506407>,
      < -6.798267, -1.132789, -0.656654>,
      < -6.814702, -1.132789, -0.506407>
    }
    triangle {
      < -6.796528, -1.081609, -0.672559>,
      < -6.780094, -1.081609, -0.822806>,
      < -6.780094, -1.132789, -0.822806>
    }
    triangle {
      < -6.796528, -1.081609, -0.672559>,
      < -6.780094, -1.132789, -0.822806>,
      < -6.796528, -1.132789, -0.672559>
    }
    triangle {
      < -6.851050, -1.081609, -0.174104>,
      < -6.834615, -1.081609, -0.324351>,
      < -6.834615, -1.132789, -0.324351>
    }
    triangle {
      < -6.851050, -1.081609, -0.174104>,
      < -6.834615, -1.132789, -0.324351>,
      < -6.851050, -1.132789, -0.174104>
    }
    triangle {
      < -6.832876, -1.081609, -0.340256>,
      < -6.816442, -1.081609, -0.490502>,
      < -6.816442, -1.132789, -0.490502>
    }
    triangle {
      < -6.832876, -1.081609, -0.340256>,
      < -6.816442, -1.132789, -0.490502>,
      < -6.832876, -1.132789, -0.340256>
    }
    triangle {
      < -6.834616, -1.081609, 0.324351>,
      < -6.851051, -1.081609, 0.174104>,
      < -6.851051, -1.132789, 0.174104>
    }
    triangle {
      < -6.834616, -1.081609, 0.324351>,
      < -6.851051, -1.132789, 0.174104>,
      < -6.834616, -1.132789, 0.324351>
    }
    triangle {
      < -6.852790, -1.081609, 0.158199>,
      < -6.869224, -1.081609, 0.007953>,
      < -6.869224, -1.132789, 0.007953>
    }
    triangle {
      < -6.852790, -1.081609, 0.158199>,
      < -6.869224, -1.132789, 0.007953>,
      < -6.852790, -1.132789, 0.158199>
    }
    triangle {
      < -6.798269, -1.081609, 0.656654>,
      < -6.814703, -1.081609, 0.506407>,
      < -6.814703, -1.132789, 0.506407>
    }
    triangle {
      < -6.798269, -1.081609, 0.656654>,
      < -6.814703, -1.132789, 0.506407>,
      < -6.798269, -1.132789, 0.656654>
    }
    triangle {
      < -6.816443, -1.081609, 0.490502>,
      < -6.832877, -1.081609, 0.340256>,
      < -6.832877, -1.132789, 0.340256>
    }
    triangle {
      < -6.816443, -1.081609, 0.490502>,
      < -6.832877, -1.132789, 0.340256>,
      < -6.816443, -1.132789, 0.490502>
    }
    triangle {
      < -6.761921, -1.081609, 0.988957>,
      < -6.778356, -1.081609, 0.838711>,
      < -6.778356, -1.132789, 0.838711>
    }
    triangle {
      < -6.761921, -1.081609, 0.988957>,
      < -6.778356, -1.132789, 0.838711>,
      < -6.761921, -1.132789, 0.988957>
    }
    triangle {
      < -6.780095, -1.081609, 0.822806>,
      < -6.796529, -1.081609, 0.672559>,
      < -6.796529, -1.132789, 0.672559>
    }
    triangle {
      < -6.780095, -1.081609, 0.822806>,
      < -6.796529, -1.132789, 0.672559>,
      < -6.780095, -1.132789, 0.822806>
    }
    triangle {
      < -6.725573, -1.081609, 1.321260>,
      < -6.742008, -1.081609, 1.171014>,
      < -6.742008, -1.132789, 1.171014>
    }
    triangle {
      < -6.725573, -1.081609, 1.321260>,
      < -6.742008, -1.132789, 1.171014>,
      < -6.725573, -1.132789, 1.321261>
    }
    triangle {
      < -6.743747, -1.081609, 1.155109>,
      < -6.760181, -1.081609, 1.004862>,
      < -6.760181, -1.132789, 1.004862>
    }
    triangle {
      < -6.743747, -1.081609, 1.155109>,
      < -6.760181, -1.132789, 1.004862>,
      < -6.743747, -1.132789, 1.155109>
    }
    triangle {
      < -6.689225, -1.081609, 1.653563>,
      < -6.705659, -1.081609, 1.503317>,
      < -6.705659, -1.132789, 1.503317>
    }
    triangle {
      < -6.689225, -1.081609, 1.653563>,
      < -6.705659, -1.132789, 1.503317>,
      < -6.689225, -1.132789, 1.653563>
    }
    triangle {
      < -6.707399, -1.081609, 1.487412>,
      < -6.723834, -1.081609, 1.337166>,
      < -6.723834, -1.132789, 1.337166>
    }
    triangle {
      < -6.707399, -1.081609, 1.487412>,
      < -6.723834, -1.132789, 1.337166>,
      < -6.707399, -1.132789, 1.487412>
    }
    triangle {
      < -6.652877, -1.081609, 1.985867>,
      < -6.669312, -1.081609, 1.835620>,
      < -6.669312, -1.132789, 1.835620>
    }
    triangle {
      < -6.652877, -1.081609, 1.985867>,
      < -6.669312, -1.132789, 1.835620>,
      < -6.652877, -1.132789, 1.985867>
    }
    triangle {
      < -6.671051, -1.081609, 1.819715>,
      < -6.687486, -1.081609, 1.669469>,
      < -6.687486, -1.132789, 1.669469>
    }
    triangle {
      < -6.671051, -1.081609, 1.819715>,
      < -6.687486, -1.132789, 1.669469>,
      < -6.671051, -1.132789, 1.819715>
    }
    triangle {
      < -6.616529, -1.081609, 2.318170>,
      < -6.632964, -1.081609, 2.167924>,
      < -6.632964, -1.132789, 2.167924>
    }
    triangle {
      < -6.616529, -1.081609, 2.318170>,
      < -6.632964, -1.132789, 2.167924>,
      < -6.616529, -1.132789, 2.318170>
    }
    triangle {
      < -6.634703, -1.081609, 2.152019>,
      < -6.651138, -1.081609, 2.001772>,
      < -6.651138, -1.132789, 2.001772>
    }
    triangle {
      < -6.634703, -1.081609, 2.152019>,
      < -6.651138, -1.132789, 2.001772>,
      < -6.634703, -1.132789, 2.152019>
    }
    triangle {
      < -6.580181, -1.081609, 2.650474>,
      < -6.596616, -1.081609, 2.500227>,
      < -6.596616, -1.132789, 2.500227>
    }
    triangle {
      < -6.580181, -1.081609, 2.650474>,
      < -6.596616, -1.132789, 2.500227>,
      < -6.580181, -1.132789, 2.650474>
    }
    triangle {
      < -6.598355, -1.081609, 2.484322>,
      < -6.614789, -1.081609, 2.334075>,
      < -6.614789, -1.132789, 2.334075>
    }
    triangle {
      < -6.598355, -1.081609, 2.484322>,
      < -6.614789, -1.132789, 2.334075>,
      < -6.598355, -1.132789, 2.484322>
    }
    triangle {
      < -6.869224, -1.081609, -0.007953>,
      < -6.852789, -1.081609, -0.158199>,
      < -6.852789, -1.132789, -0.158199>
    }
    triangle {
      < -6.869224, -1.081609, -0.007953>,
      < -6.852789, -1.132789, -0.158199>,
      < -6.869224, -1.132789, -0.007953>
    }
    triangle {
      < -6.596615, -1.081609, -2.500227>,
      < -6.580181, -1.081609, -2.650473>,
      < -6.580181, -1.132789, -2.650473>
    }
    triangle {
      < -6.596615, -1.081609, -2.500227>,
      < -6.580181, -1.132789, -2.650473>,
      < -6.596615, -1.132789, -2.500227>
    }
    triangle {
      < -6.580181, -1.148789, 2.650474>,
      < -6.596616, -1.148789, 2.500227>,
      < -6.596616, -1.199968, 2.500227>
    }
    triangle {
      < -6.580181, -1.148789, 2.650474>,
      < -6.596616, -1.199968, 2.500227>,
      < -6.580181, -1.199968, 2.650474>
    }
    triangle {
      < -6.598355, -1.148789, 2.484322>,
      < -6.614789, -1.148789, 2.334075>,
      < -6.614789, -1.199968, 2.334075>
    }
    triangle {
      < -6.598355, -1.148789, 2.484322>,
      < -6.614789, -1.199968, 2.334075>,
      < -6.598355, -1.199968, 2.484322>
    }
    triangle {
      < -6.616529, -1.148789, 2.318170>,
      < -6.632964, -1.148789, 2.167924>,
      < -6.632964, -1.199968, 2.167924>
    }
    triangle {
      < -6.616529, -1.148789, 2.318170>,
      < -6.632964, -1.199968, 2.167924>,
      < -6.616529, -1.199968, 2.318170>
    }
    triangle {
      < -6.634703, -1.148789, 2.152019>,
      < -6.651138, -1.148789, 2.001772>,
      < -6.651138, -1.199968, 2.001772>
    }
    triangle {
      < -6.634703, -1.148789, 2.152019>,
      < -6.651138, -1.199968, 2.001772>,
      < -6.634703, -1.199968, 2.152019>
    }
    triangle {
      < -6.652877, -1.148789, 1.985867>,
      < -6.669312, -1.148789, 1.835620>,
      < -6.669312, -1.199968, 1.835620>
    }
    triangle {
      < -6.652877, -1.148789, 1.985867>,
      < -6.669312, -1.199968, 1.835620>,
      < -6.652877, -1.199968, 1.985867>
    }
    triangle {
      < -6.671051, -1.148789, 1.819715>,
      < -6.687486, -1.148789, 1.669469>,
      < -6.687486, -1.199968, 1.669469>
    }
    triangle {
      < -6.671051, -1.148789, 1.819715>,
      < -6.687486, -1.199968, 1.669469>,
      < -6.671051, -1.199968, 1.819715>
    }
    triangle {
      < -6.689225, -1.148789, 1.653563>,
      < -6.705659, -1.148789, 1.503317>,
      < -6.705659, -1.199968, 1.503317>
    }
    triangle {
      < -6.689225, -1.148789, 1.653563>,
      < -6.705659, -1.199968, 1.503317>,
      < -6.689225, -1.199968, 1.653563>
    }
    triangle {
      < -6.707399, -1.148789, 1.487412>,
      < -6.723834, -1.148789, 1.337166>,
      < -6.723834, -1.199968, 1.337166>
    }
    triangle {
      < -6.707399, -1.148789, 1.487412>,
      < -6.723834, -1.199968, 1.337166>,
      < -6.707399, -1.199968, 1.487412>
    }
    triangle {
      < -6.725573, -1.148789, 1.321261>,
      < -6.742008, -1.148789, 1.171014>,
      < -6.742008, -1.199968, 1.171014>
    }
    triangle {
      < -6.725573, -1.148789, 1.321261>,
      < -6.742008, -1.199968, 1.171014>,
      < -6.725573, -1.199968, 1.321261>
    }
    triangle {
      < -6.743747, -1.148789, 1.155109>,
      < -6.760181, -1.148789, 1.004862>,
      < -6.760181, -1.199968, 1.004862>
    }
    triangle {
      < -6.743747, -1.148789, 1.155109>,
      < -6.760181, -1.199968, 1.004862>,
      < -6.743747, -1.199968, 1.155109>
    }
    triangle {
      < -6.761921, -1.148789, 0.988957>,
      < -6.778356, -1.148789, 0.838711>,
      < -6.778356, -1.199968, 0.838711>
    }
    triangle {
      < -6.761921, -1.148789, 0.988957>,
      < -6.778356, -1.199968, 0.838711>,
      < -6.761921, -1.199968, 0.988957>
    }
    triangle {
      < -6.780095, -1.148789, 0.822806>,
      < -6.796529, -1.148789, 0.672559>,
      < -6.796529, -1.199968, 0.672559>
    }
    triangle {
      < -6.780095, -1.148789, 0.822806>,
      < -6.796529, -1.199968, 0.672559>,
      < -6.780095, -1.199968, 0.822806>
    }
    triangle {
      < -6.798269, -1.148789, 0.656654>,
      < -6.814703, -1.148789, 0.506407>,
      < -6.814703, -1.199968, 0.506407>
    }
    triangle {
      < -6.798269, -1.148789, 0.656654>,
      < -6.814703, -1.199968, 0.506407>,
      < -6.798269, -1.199968, 0.656654>
    }
    triangle {
      < -6.816443, -1.148789, 0.490502>,
      < -6.832877, -1.148789, 0.340256>,
      < -6.832877, -1.199968, 0.340256>
    }
    triangle {
      < -6.816443, -1.148789, 0.490502>,
      < -6.832877, -1.199968, 0.340256>,
      < -6.816443, -1.199968, 0.490502>
    }
    triangle {
      < -6.834616, -1.148789, 0.324351>,
      < -6.851051, -1.148789, 0.174104>,
      < -6.851051, -1.199968, 0.174104>
    }
    triangle {
      < -6.834616, -1.148789, 0.324351>,
      < -6.851051, -1.199968, 0.174104>,
      < -6.834616, -1.199968, 0.324351>
    }
    triangle {
      < -6.852790, -1.148789, 0.158199>,
      < -6.869224, -1.148789, 0.007953>,
      < -6.869224, -1.199968, 0.007953>
    }
    triangle {
      < -6.852790, -1.148789, 0.158199>,
      < -6.869224, -1.199968, 0.007953>,
      < -6.852790, -1.199968, 0.158199>
    }
    triangle {
      < -6.851050, -1.148789, -0.174104>,
      < -6.834615, -1.148789, -0.324351>,
      < -6.834615, -1.199968, -0.324351>
    }
    triangle {
      < -6.851050, -1.148789, -0.174104>,
      < -6.834615, -1.199968, -0.324351>,
      < -6.851050, -1.199968, -0.174104>
    }
    triangle {
      < -6.832876, -1.148789, -0.340256>,
      < -6.816442, -1.148789, -0.490502>,
      < -6.816442, -1.199968, -0.490502>
    }
    triangle {
      < -6.832876, -1.148789, -0.340256>,
      < -6.816442, -1.199968, -0.490502>,
      < -6.832876, -1.199968, -0.340256>
    }
    triangle {
      < -6.814702, -1.148789, -0.506407>,
      < -6.798267, -1.148789, -0.656654>,
      < -6.798267, -1.199968, -0.656654>
    }
    triangle {
      < -6.814702, -1.148789, -0.506407>,
      < -6.798267, -1.199968, -0.656654>,
      < -6.814702, -1.199968, -0.506407>
    }
    triangle {
      < -6.796528, -1.148789, -0.672559>,
      < -6.780094, -1.148789, -0.822806>,
      < -6.780094, -1.199968, -0.822806>
    }
    triangle {
      < -6.796528, -1.148789, -0.672559>,
      < -6.780094, -1.199968, -0.822806>,
      < -6.796528, -1.199968, -0.672559>
    }
    triangle {
      < -6.778354, -1.148789, -0.838711>,
      < -6.761919, -1.148789, -0.988957>,
      < -6.761919, -1.199968, -0.988957>
    }
    triangle {
      < -6.778354, -1.148789, -0.838711>,
      < -6.761919, -1.199968, -0.988957>,
      < -6.778354, -1.199968, -0.838711>
    }
    triangle {
      < -6.760180, -1.148789, -1.004862>,
      < -6.743745, -1.148789, -1.155109>,
      < -6.743745, -1.199968, -1.155109>
    }
    triangle {
      < -6.760180, -1.148789, -1.004862>,
      < -6.743745, -1.199968, -1.155109>,
      < -6.760180, -1.199968, -1.004862>
    }
    triangle {
      < -6.742006, -1.148789, -1.171014>,
      < -6.725572, -1.148789, -1.321260>,
      < -6.725572, -1.199968, -1.321260>
    }
    triangle {
      < -6.742006, -1.148789, -1.171014>,
      < -6.725572, -1.199968, -1.321260>,
      < -6.742006, -1.199968, -1.171014>
    }
    triangle {
      < -6.723832, -1.148789, -1.337166>,
      < -6.707397, -1.148789, -1.487412>,
      < -6.707397, -1.199968, -1.487412>
    }
    triangle {
      < -6.723832, -1.148789, -1.337166>,
      < -6.707397, -1.199968, -1.487412>,
      < -6.723832, -1.199968, -1.337166>
    }
    triangle {
      < -6.705658, -1.148789, -1.503317>,
      < -6.689224, -1.148789, -1.653564>,
      < -6.689224, -1.199968, -1.653564>
    }
    triangle {
      < -6.705658, -1.148789, -1.503317>,
      < -6.689224, -1.199968, -1.653564>,
      < -6.705658, -1.199968, -1.503317>
    }
    triangle {
      < -6.687484, -1.148789, -1.669469>,
      < -6.671050, -1.148789, -1.819715>,
      < -6.671050, -1.199968, -1.819715>
    }
    triangle {
      < -6.687484, -1.148789, -1.669469>,
      < -6.671050, -1.199968, -1.819715>,
      < -6.687484, -1.199968, -1.669469>
    }
    triangle {
      < -6.669310, -1.148789, -1.835621>,
      < -6.652875, -1.148789, -1.985867>,
      < -6.652875, -1.199968, -1.985867>
    }
    triangle {
      < -6.669310, -1.148789, -1.835621>,
      < -6.652875, -1.199968, -1.985867>,
      < -6.669310, -1.199968, -1.835621>
    }
    triangle {
      < -6.651136, -1.148789, -2.001772>,
      < -6.634702, -1.148789, -2.152019>,
      < -6.634702, -1.199968, -2.152019>
    }
    triangle {
      < -6.651136, -1.148789, -2.001772>,
      < -6.634702, -1.199968, -2.152019>,
      < -6.651136, -1.199968, -2.001772>
    }
    triangle {
      < -6.632962, -1.148789, -2.167924>,
      < -6.616529, -1.148789, -2.318170>,
      < -6.616529, -1.199968, -2.318170>
    }
    triangle {
      < -6.632962, -1.148789, -2.167924>,
      < -6.616529, -1.199968, -2.318170>,
      < -6.632962, -1.199968, -2.167924>
    }
    triangle {
      < -6.614789, -1.148789, -2.334075>,
      < -6.598354, -1.148789, -2.484322>,
      < -6.598354, -1.199968, -2.484322>
    }
    triangle {
      < -6.614789, -1.148789, -2.334075>,
      < -6.598354, -1.199968, -2.484322>,
      < -6.614789, -1.199968, -2.334075>
    }
    triangle {
      < -6.869224, -1.148789, -0.007953>,
      < -6.852789, -1.148789, -0.158199>,
      < -6.852789, -1.199968, -0.158199>
    }
    triangle {
      < -6.869224, -1.148789, -0.007953>,
      < -6.852789, -1.199968, -0.158199>,
      < -6.869224, -1.199968, -0.007953>
    }
    triangle {
      < -6.596615, -1.148789, -2.500227>,
      < -6.580181, -1.148789, -2.650473>,
      < -6.580181, -1.199968, -2.650473>
    }
    triangle {
      < -6.596615, -1.148789, -2.500227>,
      < -6.580181, -1.199968, -2.650473>,
      < -6.596615, -1.199968, -2.500227>
    }
    triangle {
      < -6.632962, -1.215968, -2.167924>,
      < -6.616529, -1.215968, -2.318170>,
      < -6.616529, -1.267147, -2.318170>
    }
    triangle {
      < -6.632962, -1.215968, -2.167924>,
      < -6.616529, -1.267147, -2.318170>,
      < -6.632962, -1.267147, -2.167924>
    }
    triangle {
      < -6.614789, -1.215968, -2.334075>,
      < -6.598354, -1.215968, -2.484322>,
      < -6.598354, -1.267147, -2.484322>
    }
    triangle {
      < -6.614789, -1.215968, -2.334075>,
      < -6.598354, -1.267147, -2.484322>,
      < -6.614789, -1.267147, -2.334075>
    }
    triangle {
      < -6.669310, -1.215968, -1.835621>,
      < -6.652875, -1.215968, -1.985867>,
      < -6.652875, -1.267147, -1.985867>
    }
    triangle {
      < -6.669310, -1.215968, -1.835621>,
      < -6.652875, -1.267147, -1.985867>,
      < -6.669310, -1.267147, -1.835621>
    }
    triangle {
      < -6.651136, -1.215968, -2.001772>,
      < -6.634702, -1.215968, -2.152019>,
      < -6.634702, -1.267147, -2.152019>
    }
    triangle {
      < -6.651136, -1.215968, -2.001772>,
      < -6.634702, -1.267147, -2.152019>,
      < -6.651136, -1.267147, -2.001772>
    }
    triangle {
      < -6.705658, -1.215968, -1.503317>,
      < -6.689224, -1.215968, -1.653564>,
      < -6.689224, -1.267147, -1.653564>
    }
    triangle {
      < -6.705658, -1.215968, -1.503317>,
      < -6.689224, -1.267147, -1.653564>,
      < -6.705658, -1.267147, -1.503317>
    }
    triangle {
      < -6.687484, -1.215968, -1.669469>,
      < -6.671050, -1.215968, -1.819715>,
      < -6.671050, -1.267147, -1.819715>
    }
    triangle {
      < -6.687484, -1.215968, -1.669469>,
      < -6.671050, -1.267147, -1.819715>,
      < -6.687484, -1.267147, -1.669469>
    }
    triangle {
      < -6.742006, -1.215968, -1.171014>,
      < -6.725572, -1.215968, -1.321260>,
      < -6.725572, -1.267147, -1.321260>
    }
    triangle {
      < -6.742006, -1.215968, -1.171014>,
      < -6.725572, -1.267147, -1.321260>,
      < -6.742006, -1.267147, -1.171014>
    }
    triangle {
      < -6.723832, -1.215968, -1.337166>,
      < -6.707397, -1.215968, -1.487412>,
      < -6.707397, -1.267147, -1.487412>
    }
    triangle {
      < -6.723832, -1.215968, -1.337166>,
      < -6.707397, -1.267147, -1.487412>,
      < -6.723832, -1.267147, -1.337166>
    }
    triangle {
      < -6.778354, -1.215968, -0.838711>,
      < -6.761919, -1.215968, -0.988957>,
      < -6.761919, -1.267147, -0.988957>
    }
    triangle {
      < -6.778354, -1.215968, -0.838711>,
      < -6.761919, -1.267147, -0.988957>,
      < -6.778354, -1.267147, -0.838711>
    }
    triangle {
      < -6.760180, -1.215968, -1.004862>,
      < -6.743745, -1.215968, -1.155109>,
      < -6.743745, -1.267147, -1.155109>
    }
    triangle {
      < -6.760180, -1.215968, -1.004862>,
      < -6.743745, -1.267147, -1.155109>,
      < -6.760180, -1.267147, -1.004862>
    }
    triangle {
      < -6.814702, -1.215968, -0.506407>,
      < -6.798267, -1.215968, -0.656654>,
      < -6.798267, -1.267147, -0.656654>
    }
    triangle {
      < -6.814702, -1.215968, -0.506407>,
      < -6.798267, -1.267147, -0.656654>,
      < -6.814702, -1.267147, -0.506407>
    }
    triangle {
      < -6.796528, -1.215968, -0.672559>,
      < -6.780094, -1.215968, -0.822806>,
      < -6.780094, -1.267147, -0.822806>
    }
    triangle {
      < -6.796528, -1.215968, -0.672559>,
      < -6.780094, -1.267147, -0.822806>,
      < -6.796528, -1.267147, -0.672559>
    }
    triangle {
      < -6.851050, -1.215968, -0.174104>,
      < -6.834615, -1.215968, -0.324351>,
      < -6.834615, -1.267147, -0.324351>
    }
    triangle {
      < -6.851050, -1.215968, -0.174104>,
      < -6.834615, -1.267147, -0.324351>,
      < -6.851050, -1.267147, -0.174104>
    }
    triangle {
      < -6.832876, -1.215968, -0.340256>,
      < -6.816442, -1.215968, -0.490502>,
      < -6.816442, -1.267147, -0.490502>
    }
    triangle {
      < -6.832876, -1.215968, -0.340256>,
      < -6.816442, -1.267147, -0.490502>,
      < -6.832876, -1.267147, -0.340256>
    }
    triangle {
      < -6.834616, -1.215968, 0.324351>,
      < -6.851051, -1.215968, 0.174104>,
      < -6.851051, -1.267147, 0.174104>
    }
    triangle {
      < -6.834616, -1.215968, 0.324351>,
      < -6.851051, -1.267147, 0.174104>,
      < -6.834616, -1.267147, 0.324351>
    }
    triangle {
      < -6.852790, -1.215968, 0.158199>,
      < -6.869224, -1.215968, 0.007953>,
      < -6.869224, -1.267147, 0.007953>
    }
    triangle {
      < -6.852790, -1.215968, 0.158199>,
      < -6.869224, -1.267147, 0.007953>,
      < -6.852790, -1.267147, 0.158199>
    }
    triangle {
      < -6.798269, -1.215968, 0.656654>,
      < -6.814703, -1.215968, 0.506407>,
      < -6.814703, -1.267147, 0.506407>
    }
    triangle {
      < -6.798269, -1.215968, 0.656654>,
      < -6.814703, -1.267147, 0.506407>,
      < -6.798269, -1.267147, 0.656654>
    }
    triangle {
      < -6.816443, -1.215968, 0.490502>,
      < -6.832877, -1.215968, 0.340256>,
      < -6.832877, -1.267147, 0.340256>
    }
    triangle {
      < -6.816443, -1.215968, 0.490502>,
      < -6.832877, -1.267147, 0.340256>,
      < -6.816443, -1.267147, 0.490502>
    }
    triangle {
      < -6.761921, -1.215968, 0.988957>,
      < -6.778356, -1.215968, 0.838711>,
      < -6.778356, -1.267147, 0.838711>
    }
    triangle {
      < -6.761921, -1.215968, 0.988957>,
      < -6.778356, -1.267147, 0.838711>,
      < -6.761921, -1.267147, 0.988957>
    }
    triangle {
      < -6.780095, -1.215968, 0.822806>,
      < -6.796529, -1.215968, 0.672559>,
      < -6.796529, -1.267147, 0.672559>
    }
    triangle {
      < -6.780095, -1.215968, 0.822806>,
      < -6.796529, -1.267147, 0.672559>,
      < -6.780095, -1.267147, 0.822806>
    }
    triangle {
      < -6.725573, -1.215968, 1.321261>,
      < -6.742008, -1.215968, 1.171014>,
      < -6.742008, -1.267147, 1.171014>
    }
    triangle {
      < -6.725573, -1.215968, 1.321261>,
      < -6.742008, -1.267147, 1.171014>,
      < -6.725573, -1.267147, 1.321261>
    }
    triangle {
      < -6.743747, -1.215968, 1.155109>,
      < -6.760181, -1.215968, 1.004862>,
      < -6.760181, -1.267147, 1.004862>
    }
    triangle {
      < -6.743747, -1.215968, 1.155109>,
      < -6.760181, -1.267147, 1.004862>,
      < -6.743747, -1.267147, 1.155109>
    }
    triangle {
      < -6.689225, -1.215968, 1.653563>,
      < -6.705659, -1.215968, 1.503317>,
      < -6.705659, -1.267147, 1.503317>
    }
    triangle {
      < -6.689225, -1.215968, 1.653563>,
      < -6.705659, -1.267147, 1.503317>,
      < -6.689225, -1.267147, 1.653563>
    }
    triangle {
      < -6.707399, -1.215968, 1.487412>,
      < -6.723834, -1.215968, 1.337166>,
      < -6.723834, -1.267147, 1.337166>
    }
    triangle {
      < -6.707399, -1.215968, 1.487412>,
      < -6.723834, -1.267147, 1.337166>,
      < -6.707399, -1.267147, 1.487412>
    }
    triangle {
      < -6.652877, -1.215968, 1.985867>,
      < -6.669312, -1.215968, 1.835620>,
      < -6.669312, -1.267147, 1.835620>
    }
    triangle {
      < -6.652877, -1.215968, 1.985867>,
      < -6.669312, -1.267147, 1.835620>,
      < -6.652877, -1.267147, 1.985867>
    }
    triangle {
      < -6.671051, -1.215968, 1.819715>,
      < -6.687486, -1.215968, 1.669469>,
      < -6.687486, -1.267147, 1.669469>
    }
    triangle {
      < -6.671051, -1.215968, 1.819715>,
      < -6.687486, -1.267147, 1.669469>,
      < -6.671051, -1.267147, 1.819715>
    }
    triangle {
      < -6.616529, -1.215968, 2.318170>,
      < -6.632964, -1.215968, 2.167924>,
      < -6.632964, -1.267147, 2.167924>
    }
    triangle {
      < -6.616529, -1.215968, 2.318170>,
      < -6.632964, -1.267147, 2.167924>,
      < -6.616529, -1.267147, 2.318170>
    }
    triangle {
      < -6.634703, -1.215968, 2.152019>,
      < -6.651138, -1.215968, 2.001772>,
      < -6.651138, -1.267147, 2.001772>
    }
    triangle {
      < -6.634703, -1.215968, 2.152019>,
      < -6.651138, -1.267147, 2.001772>,
      < -6.634703, -1.267147, 2.152019>
    }
    triangle {
      < -6.580181, -1.215968, 2.650474>,
      < -6.596616, -1.215968, 2.500227>,
      < -6.596616, -1.267147, 2.500227>
    }
    triangle {
      < -6.580181, -1.215968, 2.650474>,
      < -6.596616, -1.267147, 2.500227>,
      < -6.580181, -1.267147, 2.650474>
    }
    triangle {
      < -6.598355, -1.215968, 2.484322>,
      < -6.614789, -1.215968, 2.334075>,
      < -6.614789, -1.267147, 2.334075>
    }
    triangle {
      < -6.598355, -1.215968, 2.484322>,
      < -6.614789, -1.267147, 2.334075>,
      < -6.598355, -1.267147, 2.484322>
    }
    triangle {
      < -6.869224, -1.215968, -0.007953>,
      < -6.852789, -1.215968, -0.158199>,
      < -6.852789, -1.267147, -0.158199>
    }
    triangle {
      < -6.869224, -1.215968, -0.007953>,
      < -6.852789, -1.267147, -0.158199>,
      < -6.869224, -1.267147, -0.007953>
    }
    triangle {
      < -6.596615, -1.215968, -2.500227>,
      < -6.580181, -1.215968, -2.650473>,
      < -6.580181, -1.267147, -2.650473>
    }
    triangle {
      < -6.596615, -1.215968, -2.500227>,
      < -6.580181, -1.267147, -2.650473>,
      < -6.596615, -1.267147, -2.500227>
    }
    triangle {
      < -6.580181, -1.350326, 2.650474>,
      < -6.596616, -1.350326, 2.500227>,
      < -6.596616, -1.401505, 2.500227>
    }
    triangle {
      < -6.580181, -1.350326, 2.650474>,
      < -6.596616, -1.401505, 2.500227>,
      < -6.580181, -1.401505, 2.650474>
    }
    triangle {
      < -6.598355, -1.350326, 2.484322>,
      < -6.614789, -1.350326, 2.334075>,
      < -6.614789, -1.401505, 2.334075>
    }
    triangle {
      < -6.598355, -1.350326, 2.484322>,
      < -6.614789, -1.401505, 2.334075>,
      < -6.598355, -1.401505, 2.484322>
    }
    triangle {
      < -6.616529, -1.350326, 2.318170>,
      < -6.632964, -1.350326, 2.167924>,
      < -6.632964, -1.401505, 2.167924>
    }
    triangle {
      < -6.616529, -1.350326, 2.318170>,
      < -6.632964, -1.401505, 2.167924>,
      < -6.616529, -1.401505, 2.318170>
    }
    triangle {
      < -6.634703, -1.350326, 2.152019>,
      < -6.651138, -1.350326, 2.001772>,
      < -6.651137, -1.401505, 2.001772>
    }
    triangle {
      < -6.634703, -1.350326, 2.152019>,
      < -6.651137, -1.401505, 2.001772>,
      < -6.634703, -1.401505, 2.152019>
    }
    triangle {
      < -6.652877, -1.350326, 1.985867>,
      < -6.669312, -1.350326, 1.835620>,
      < -6.669311, -1.401505, 1.835620>
    }
    triangle {
      < -6.652877, -1.350326, 1.985867>,
      < -6.669311, -1.401505, 1.835620>,
      < -6.652876, -1.401505, 1.985867>
    }
    triangle {
      < -6.671051, -1.350326, 1.819715>,
      < -6.687486, -1.350326, 1.669469>,
      < -6.687485, -1.401505, 1.669469>
    }
    triangle {
      < -6.671051, -1.350326, 1.819715>,
      < -6.687485, -1.401505, 1.669469>,
      < -6.671051, -1.401505, 1.819715>
    }
    triangle {
      < -6.689225, -1.350326, 1.653563>,
      < -6.705659, -1.350326, 1.503317>,
      < -6.705659, -1.401505, 1.503317>
    }
    triangle {
      < -6.689225, -1.350326, 1.653563>,
      < -6.705659, -1.401505, 1.503317>,
      < -6.689224, -1.401505, 1.653564>
    }
    triangle {
      < -6.707399, -1.350326, 1.487412>,
      < -6.723834, -1.350326, 1.337166>,
      < -6.723833, -1.401505, 1.337166>
    }
    triangle {
      < -6.707399, -1.350326, 1.487412>,
      < -6.723833, -1.401505, 1.337166>,
      < -6.707398, -1.401505, 1.487412>
    }
    triangle {
      < -6.725573, -1.350326, 1.321261>,
      < -6.742008, -1.350326, 1.171014>,
      < -6.742007, -1.401505, 1.171014>
    }
    triangle {
      < -6.725573, -1.350326, 1.321261>,
      < -6.742007, -1.401505, 1.171014>,
      < -6.725572, -1.401505, 1.321261>
    }
    triangle {
      < -6.743747, -1.350326, 1.155109>,
      < -6.760181, -1.350326, 1.004862>,
      < -6.760181, -1.401505, 1.004863>
    }
    triangle {
      < -6.743747, -1.350326, 1.155109>,
      < -6.760181, -1.401505, 1.004863>,
      < -6.743746, -1.401505, 1.155109>
    }
    triangle {
      < -6.761921, -1.350326, 0.988957>,
      < -6.778356, -1.350326, 0.838711>,
      < -6.778355, -1.401505, 0.838711>
    }
    triangle {
      < -6.761921, -1.350326, 0.988957>,
      < -6.778355, -1.401505, 0.838711>,
      < -6.761920, -1.401505, 0.988957>
    }
    triangle {
      < -6.780095, -1.350326, 0.822806>,
      < -6.796529, -1.350326, 0.672559>,
      < -6.796529, -1.401505, 0.672559>
    }
    triangle {
      < -6.780095, -1.350326, 0.822806>,
      < -6.796529, -1.401505, 0.672559>,
      < -6.780094, -1.401505, 0.822806>
    }
    triangle {
      < -6.798269, -1.350326, 0.656654>,
      < -6.814703, -1.350326, 0.506407>,
      < -6.814703, -1.401505, 0.506407>
    }
    triangle {
      < -6.798269, -1.350326, 0.656654>,
      < -6.814703, -1.401505, 0.506407>,
      < -6.798268, -1.401505, 0.656654>
    }
    triangle {
      < -6.816443, -1.350326, 0.490502>,
      < -6.832877, -1.350326, 0.340256>,
      < -6.832877, -1.401505, 0.340256>
    }
    triangle {
      < -6.816443, -1.350326, 0.490502>,
      < -6.832877, -1.401505, 0.340256>,
      < -6.816442, -1.401505, 0.490502>
    }
    triangle {
      < -6.834616, -1.350326, 0.324351>,
      < -6.851051, -1.350326, 0.174104>,
      < -6.851051, -1.401505, 0.174104>
    }
    triangle {
      < -6.834616, -1.350326, 0.324351>,
      < -6.851051, -1.401505, 0.174104>,
      < -6.834616, -1.401505, 0.324351>
    }
    triangle {
      < -6.852790, -1.350326, 0.158199>,
      < -6.869224, -1.350326, 0.007953>,
      < -6.869224, -1.401505, 0.007953>
    }
    triangle {
      < -6.852790, -1.350326, 0.158199>,
      < -6.869224, -1.401505, 0.007953>,
      < -6.852790, -1.401505, 0.158199>
    }
    triangle {
      < -6.851050, -1.350326, -0.174104>,
      < -6.834615, -1.350326, -0.324351>,
      < -6.834615, -1.401505, -0.324351>
    }
    triangle {
      < -6.851050, -1.350326, -0.174104>,
      < -6.834615, -1.401505, -0.324351>,
      < -6.851050, -1.401505, -0.174104>
    }
    triangle {
      < -6.832876, -1.350326, -0.340256>,
      < -6.816442, -1.350326, -0.490502>,
      < -6.816442, -1.401505, -0.490502>
    }
    triangle {
      < -6.832876, -1.350326, -0.340256>,
      < -6.816442, -1.401505, -0.490502>,
      < -6.832876, -1.401505, -0.340256>
    }
    triangle {
      < -6.814702, -1.350326, -0.506407>,
      < -6.798267, -1.350326, -0.656654>,
      < -6.798268, -1.401505, -0.656654>
    }
    triangle {
      < -6.814702, -1.350326, -0.506407>,
      < -6.798268, -1.401505, -0.656654>,
      < -6.814703, -1.401505, -0.506407>
    }
    triangle {
      < -6.796528, -1.350326, -0.672559>,
      < -6.780094, -1.350326, -0.822806>,
      < -6.780094, -1.401505, -0.822805>
    }
    triangle {
      < -6.796528, -1.350326, -0.672559>,
      < -6.780094, -1.401505, -0.822805>,
      < -6.796529, -1.401505, -0.672559>
    }
    triangle {
      < -6.778354, -1.350326, -0.838711>,
      < -6.761919, -1.350326, -0.988957>,
      < -6.761920, -1.401505, -0.988957>
    }
    triangle {
      < -6.778354, -1.350326, -0.838711>,
      < -6.761920, -1.401505, -0.988957>,
      < -6.778355, -1.401505, -0.838711>
    }
    triangle {
      < -6.760180, -1.350326, -1.004862>,
      < -6.743745, -1.350326, -1.155109>,
      < -6.743746, -1.401505, -1.155109>
    }
    triangle {
      < -6.760180, -1.350326, -1.004862>,
      < -6.743746, -1.401505, -1.155109>,
      < -6.760181, -1.401505, -1.004862>
    }
    triangle {
      < -6.742006, -1.350326, -1.171014>,
      < -6.725572, -1.350326, -1.321260>,
      < -6.725572, -1.401505, -1.321260>
    }
    triangle {
      < -6.742006, -1.350326, -1.171014>,
      < -6.725572, -1.401505, -1.321260>,
      < -6.742007, -1.401505, -1.171014>
    }
    triangle {
      < -6.723832, -1.350326, -1.337166>,
      < -6.707397, -1.350326, -1.487412>,
      < -6.707398, -1.401505, -1.487412>
    }
    triangle {
      < -6.723832, -1.350326, -1.337166>,
      < -6.707398, -1.401505, -1.487412>,
      < -6.723833, -1.401505, -1.337166>
    }
    triangle {
      < -6.705658, -1.350326, -1.503317>,
      < -6.689224, -1.350326, -1.653564>,
      < -6.689224, -1.401505, -1.653564>
    }
    triangle {
      < -6.705658, -1.350326, -1.503317>,
      < -6.689224, -1.401505, -1.653564>,
      < -6.705659, -1.401505, -1.503317>
    }
    triangle {
      < -6.687484, -1.350326, -1.669469>,
      < -6.671050, -1.350326, -1.819715>,
      < -6.671051, -1.401505, -1.819715>
    }
    triangle {
      < -6.687484, -1.350326, -1.669469>,
      < -6.671051, -1.401505, -1.819715>,
      < -6.687485, -1.401505, -1.669469>
    }
    triangle {
      < -6.669310, -1.350326, -1.835621>,
      < -6.652875, -1.350326, -1.985867>,
      < -6.652876, -1.401505, -1.985867>
    }
    triangle {
      < -6.669310, -1.350326, -1.835621>,
      < -6.652876, -1.401505, -1.985867>,
      < -6.669311, -1.401505, -1.835621>
    }
    triangle {
      < -6.651136, -1.350326, -2.001772>,
      < -6.634702, -1.350326, -2.152019>,
      < -6.634702, -1.401505, -2.152019>
    }
    triangle {
      < -6.651136, -1.350326, -2.001772>,
      < -6.634702, -1.401505, -2.152019>,
      < -6.651137, -1.401505, -2.001772>
    }
    triangle {
      < -6.632962, -1.350326, -2.167924>,
      < -6.616529, -1.350326, -2.318170>,
      < -6.616529, -1.401505, -2.318170>
    }
    triangle {
      < -6.632962, -1.350326, -2.167924>,
      < -6.616529, -1.401505, -2.318170>,
      < -6.632963, -1.401505, -2.167924>
    }
    triangle {
      < -6.614789, -1.350326, -2.334075>,
      < -6.598354, -1.350326, -2.484322>,
      < -6.598354, -1.401505, -2.484322>
    }
    triangle {
      < -6.614789, -1.350326, -2.334075>,
      < -6.598354, -1.401505, -2.484322>,
      < -6.614789, -1.401505, -2.334075>
    }
    triangle {
      < -6.869224, -1.350326, -0.007953>,
      < -6.852789, -1.350326, -0.158199>,
      < -6.852789, -1.401505, -0.158199>
    }
    triangle {
      < -6.869224, -1.350326, -0.007953>,
      < -6.852789, -1.401505, -0.158199>,
      < -6.869224, -1.401505, -0.007953>
    }
    triangle {
      < -6.596615, -1.350326, -2.500227>,
      < -6.580181, -1.350326, -2.650473>,
      < -6.580181, -1.401505, -2.650473>
    }
    triangle {
      < -6.596615, -1.350326, -2.500227>,
      < -6.580181, -1.401505, -2.650473>,
      < -6.596615, -1.401505, -2.500227>
    }
    triangle {
      < -6.632964, -1.484684, -2.167923>,
      < -6.616529, -1.484684, -2.318170>,
      < -6.616529, -1.535863, -2.318170>
    }
    triangle {
      < -6.632964, -1.484684, -2.167923>,
      < -6.616529, -1.535863, -2.318170>,
      < -6.632964, -1.535863, -2.167923>
    }
    triangle {
      < -6.614789, -1.484684, -2.334075>,
      < -6.598355, -1.484684, -2.484322>,
      < -6.598355, -1.535863, -2.484322>
    }
    triangle {
      < -6.614789, -1.484684, -2.334075>,
      < -6.598355, -1.535863, -2.484322>,
      < -6.614789, -1.535863, -2.334075>
    }
    triangle {
      < -6.669312, -1.484684, -1.835620>,
      < -6.652876, -1.484684, -1.985867>,
      < -6.652877, -1.535863, -1.985867>
    }
    triangle {
      < -6.669312, -1.484684, -1.835620>,
      < -6.652877, -1.535863, -1.985867>,
      < -6.669312, -1.535863, -1.835620>
    }
    triangle {
      < -6.651137, -1.484684, -2.001772>,
      < -6.634703, -1.484684, -2.152018>,
      < -6.634703, -1.535863, -2.152018>
    }
    triangle {
      < -6.651137, -1.484684, -2.001772>,
      < -6.634703, -1.535863, -2.152018>,
      < -6.651138, -1.535863, -2.001772>
    }
    triangle {
      < -6.705659, -1.484684, -1.503317>,
      < -6.689224, -1.484684, -1.653564>,
      < -6.689225, -1.535863, -1.653563>
    }
    triangle {
      < -6.705659, -1.484684, -1.503317>,
      < -6.689225, -1.535863, -1.653563>,
      < -6.705659, -1.535863, -1.503317>
    }
    triangle {
      < -6.687485, -1.484684, -1.669469>,
      < -6.671051, -1.484684, -1.819715>,
      < -6.671051, -1.535863, -1.819715>
    }
    triangle {
      < -6.687485, -1.484684, -1.669469>,
      < -6.671051, -1.535863, -1.819715>,
      < -6.687486, -1.535863, -1.669469>
    }
    triangle {
      < -6.742008, -1.484684, -1.171014>,
      < -6.725572, -1.484684, -1.321260>,
      < -6.725573, -1.535863, -1.321260>
    }
    triangle {
      < -6.742008, -1.484684, -1.171014>,
      < -6.725573, -1.535863, -1.321260>,
      < -6.742008, -1.535863, -1.171014>
    }
    triangle {
      < -6.723833, -1.484684, -1.337165>,
      < -6.707399, -1.484684, -1.487412>,
      < -6.707399, -1.535863, -1.487412>
    }
    triangle {
      < -6.723833, -1.484684, -1.337165>,
      < -6.707399, -1.535863, -1.487412>,
      < -6.723834, -1.535863, -1.337165>
    }
    triangle {
      < -6.778356, -1.484684, -0.838710>,
      < -6.761920, -1.484684, -0.988957>,
      < -6.761921, -1.535863, -0.988957>
    }
    triangle {
      < -6.778356, -1.484684, -0.838710>,
      < -6.761921, -1.535863, -0.988957>,
      < -6.778356, -1.535863, -0.838710>
    }
    triangle {
      < -6.760181, -1.484684, -1.004862>,
      < -6.743747, -1.484684, -1.155109>,
      < -6.743747, -1.535863, -1.155109>
    }
    triangle {
      < -6.760181, -1.484684, -1.004862>,
      < -6.743747, -1.535863, -1.155109>,
      < -6.760181, -1.535863, -1.004862>
    }
    triangle {
      < -6.814703, -1.484684, -0.506407>,
      < -6.798268, -1.484684, -0.656654>,
      < -6.798269, -1.535863, -0.656654>
    }
    triangle {
      < -6.814703, -1.484684, -0.506407>,
      < -6.798269, -1.535863, -0.656654>,
      < -6.814703, -1.535863, -0.506407>
    }
    triangle {
      < -6.796529, -1.484684, -0.672559>,
      < -6.780095, -1.484684, -0.822805>,
      < -6.780095, -1.535863, -0.822805>
    }
    triangle {
      < -6.796529, -1.484684, -0.672559>,
      < -6.780095, -1.535863, -0.822805>,
      < -6.796529, -1.535863, -0.672559>
    }
    triangle {
      < -6.851050, -1.484684, -0.174104>,
      < -6.834616, -1.484684, -0.324351>,
      < -6.834616, -1.535863, -0.324351>
    }
    triangle {
      < -6.851050, -1.484684, -0.174104>,
      < -6.834616, -1.535863, -0.324351>,
      < -6.851051, -1.535863, -0.174104>
    }
    triangle {
      < -6.832877, -1.484684, -0.340256>,
      < -6.816443, -1.484684, -0.490502>,
      < -6.816443, -1.535863, -0.490502>
    }
    triangle {
      < -6.832877, -1.484684, -0.340256>,
      < -6.816443, -1.535863, -0.490502>,
      < -6.832877, -1.535863, -0.340256>
    }
    triangle {
      < -6.834616, -1.484684, 0.324351>,
      < -6.851050, -1.484684, 0.174104>,
      < -6.851050, -1.535863, 0.174104>
    }
    triangle {
      < -6.834616, -1.484684, 0.324351>,
      < -6.851050, -1.535863, 0.174104>,
      < -6.834615, -1.535863, 0.324351>
    }
    triangle {
      < -6.852789, -1.484684, 0.158199>,
      < -6.869224, -1.484684, 0.007953>,
      < -6.869224, -1.535863, 0.007953>
    }
    triangle {
      < -6.852789, -1.484684, 0.158199>,
      < -6.869224, -1.535863, 0.007953>,
      < -6.852789, -1.535863, 0.158199>
    }
    triangle {
      < -6.798268, -1.484684, 0.656654>,
      < -6.814702, -1.484684, 0.506407>,
      < -6.814702, -1.535863, 0.506407>
    }
    triangle {
      < -6.798268, -1.484684, 0.656654>,
      < -6.814702, -1.535863, 0.506407>,
      < -6.798267, -1.535863, 0.656654>
    }
    triangle {
      < -6.816442, -1.484684, 0.490502>,
      < -6.832877, -1.484684, 0.340256>,
      < -6.832876, -1.535863, 0.340256>
    }
    triangle {
      < -6.816442, -1.484684, 0.490502>,
      < -6.832876, -1.535863, 0.340256>,
      < -6.816442, -1.535863, 0.490503>
    }
    triangle {
      < -6.761920, -1.484684, 0.988957>,
      < -6.778354, -1.484684, 0.838711>,
      < -6.778354, -1.535863, 0.838711>
    }
    triangle {
      < -6.761920, -1.484684, 0.988957>,
      < -6.778354, -1.535863, 0.838711>,
      < -6.761919, -1.535863, 0.988957>
    }
    triangle {
      < -6.780094, -1.484684, 0.822806>,
      < -6.796529, -1.484684, 0.672559>,
      < -6.796528, -1.535863, 0.672559>
    }
    triangle {
      < -6.780094, -1.484684, 0.822806>,
      < -6.796528, -1.535863, 0.672559>,
      < -6.780094, -1.535863, 0.822806>
    }
    triangle {
      < -6.725572, -1.484684, 1.321261>,
      < -6.742006, -1.484684, 1.171014>,
      < -6.742006, -1.535863, 1.171014>
    }
    triangle {
      < -6.725572, -1.484684, 1.321261>,
      < -6.742006, -1.535863, 1.171014>,
      < -6.725572, -1.535863, 1.321261>
    }
    triangle {
      < -6.743745, -1.484684, 1.155109>,
      < -6.760181, -1.484684, 1.004863>,
      < -6.760180, -1.535863, 1.004863>
    }
    triangle {
      < -6.743745, -1.484684, 1.155109>,
      < -6.760180, -1.535863, 1.004863>,
      < -6.743745, -1.535863, 1.155109>
    }
    triangle {
      < -6.689224, -1.484684, 1.653564>,
      < -6.705658, -1.484684, 1.503317>,
      < -6.705658, -1.535863, 1.503317>
    }
    triangle {
      < -6.689224, -1.484684, 1.653564>,
      < -6.705658, -1.535863, 1.503317>,
      < -6.689224, -1.535863, 1.653564>
    }
    triangle {
      < -6.707397, -1.484684, 1.487412>,
      < -6.723833, -1.484684, 1.337166>,
      < -6.723832, -1.535863, 1.337166>
    }
    triangle {
      < -6.707397, -1.484684, 1.487412>,
      < -6.723832, -1.535863, 1.337166>,
      < -6.707397, -1.535863, 1.487412>
    }
    triangle {
      < -6.652876, -1.484684, 1.985867>,
      < -6.669310, -1.484684, 1.835621>,
      < -6.669310, -1.535863, 1.835621>
    }
    triangle {
      < -6.652876, -1.484684, 1.985867>,
      < -6.669310, -1.535863, 1.835621>,
      < -6.652875, -1.535863, 1.985867>
    }
    triangle {
      < -6.671050, -1.484684, 1.819715>,
      < -6.687485, -1.484684, 1.669469>,
      < -6.687484, -1.535863, 1.669469>
    }
    triangle {
      < -6.671050, -1.484684, 1.819715>,
      < -6.687484, -1.535863, 1.669469>,
      < -6.671050, -1.535863, 1.819715>
    }
    triangle {
      < -6.616529, -1.484684, 2.318171>,
      < -6.632964, -1.484684, 2.167924>,
      < -6.632963, -1.535863, 2.167924>
    }
    triangle {
      < -6.616529, -1.484684, 2.318171>,
      < -6.632963, -1.535863, 2.167924>,
      < -6.616529, -1.535863, 2.318171>
    }
    triangle {
      < -6.634703, -1.484684, 2.152019>,
      < -6.651137, -1.484684, 2.001772>,
      < -6.651136, -1.535863, 2.001772>
    }
    triangle {
      < -6.634703, -1.484684, 2.152019>,
      < -6.651136, -1.535863, 2.001772>,
      < -6.634702, -1.535863, 2.152019>
    }
    triangle {
      < -6.580181, -1.484684, 2.650474>,
      < -6.596616, -1.484684, 2.500227>,
      < -6.596615, -1.535863, 2.500227>
    }
    triangle {
      < -6.580181, -1.484684, 2.650474>,
      < -6.596615, -1.535863, 2.500227>,
      < -6.580181, -1.535863, 2.650474>
    }
    triangle {
      < -6.598355, -1.484684, 2.484322>,
      < -6.614789, -1.484684, 2.334076>,
      < -6.614789, -1.535863, 2.334076>
    }
    triangle {
      < -6.598355, -1.484684, 2.484322>,
      < -6.614789, -1.535863, 2.334076>,
      < -6.598354, -1.535863, 2.484322>
    }
    triangle {
      < -6.869224, -1.484684, -0.007953>,
      < -6.852789, -1.484684, -0.158199>,
      < -6.852790, -1.535863, -0.158199>
    }
    triangle {
      < -6.869224, -1.484684, -0.007953>,
      < -6.852790, -1.535863, -0.158199>,
      < -6.869224, -1.535863, -0.007953>
    }
    triangle {
      < -6.596616, -1.484684, -2.500227>,
      < -6.580181, -1.484684, -2.650473>,
      < -6.580181, -1.535863, -2.650473>
    }
    triangle {
      < -6.596616, -1.484684, -2.500227>,
      < -6.580181, -1.535863, -2.650473>,
      < -6.596616, -1.535863, -2.500227>
    }
    triangle {
      < -6.869224, -1.283147, -0.007953>,
      < -6.852789, -1.283147, -0.158199>,
      < -6.852789, -1.334326, -0.158199>
    }
    triangle {
      < -6.869224, -1.283147, -0.007953>,
      < -6.852789, -1.334326, -0.158199>,
      < -6.869224, -1.334326, -0.007953>
    }
    triangle {
      < -6.852790, -1.283147, 0.158199>,
      < -6.869224, -1.283147, 0.007953>,
      < -6.869224, -1.334326, 0.007953>
    }
    triangle {
      < -6.852790, -1.283147, 0.158199>,
      < -6.869224, -1.334326, 0.007953>,
      < -6.852790, -1.334326, 0.158199>
    }
    triangle {
      < -6.596615, -1.283147, -2.500227>,
      < -6.580181, -1.283147, -2.650473>,
      < -6.580181, -1.334326, -2.650473>
    }
    triangle {
      < -6.596615, -1.283147, -2.500227>,
      < -6.580181, -1.334326, -2.650473>,
      < -6.596615, -1.334326, -2.500227>
    }
    triangle {
      < -6.614789, -1.283147, -2.334075>,
      < -6.598354, -1.283147, -2.484322>,
      < -6.598354, -1.334326, -2.484322>
    }
    triangle {
      < -6.614789, -1.283147, -2.334075>,
      < -6.598354, -1.334326, -2.484322>,
      < -6.614789, -1.334326, -2.334075>
    }
    triangle {
      < -6.632962, -1.283147, -2.167924>,
      < -6.616529, -1.283147, -2.318170>,
      < -6.616529, -1.334326, -2.318170>
    }
    triangle {
      < -6.632962, -1.283147, -2.167924>,
      < -6.616529, -1.334326, -2.318170>,
      < -6.632962, -1.334326, -2.167924>
    }
    triangle {
      < -6.651136, -1.283147, -2.001772>,
      < -6.634702, -1.283147, -2.152019>,
      < -6.634702, -1.334326, -2.152019>
    }
    triangle {
      < -6.651136, -1.283147, -2.001772>,
      < -6.634702, -1.334326, -2.152019>,
      < -6.651136, -1.334326, -2.001772>
    }
    triangle {
      < -6.669310, -1.283147, -1.835621>,
      < -6.652875, -1.283147, -1.985867>,
      < -6.652875, -1.334326, -1.985867>
    }
    triangle {
      < -6.669310, -1.283147, -1.835621>,
      < -6.652875, -1.334326, -1.985867>,
      < -6.669310, -1.334326, -1.835621>
    }
    triangle {
      < -6.687484, -1.283147, -1.669469>,
      < -6.671050, -1.283147, -1.819715>,
      < -6.671050, -1.334326, -1.819715>
    }
    triangle {
      < -6.687484, -1.283147, -1.669469>,
      < -6.671050, -1.334326, -1.819715>,
      < -6.687484, -1.334326, -1.669469>
    }
    triangle {
      < -6.705658, -1.283147, -1.503317>,
      < -6.689224, -1.283147, -1.653564>,
      < -6.689224, -1.334326, -1.653564>
    }
    triangle {
      < -6.705658, -1.283147, -1.503317>,
      < -6.689224, -1.334326, -1.653564>,
      < -6.705658, -1.334326, -1.503317>
    }
    triangle {
      < -6.723832, -1.283147, -1.337166>,
      < -6.707397, -1.283147, -1.487412>,
      < -6.707397, -1.334326, -1.487412>
    }
    triangle {
      < -6.723832, -1.283147, -1.337166>,
      < -6.707397, -1.334326, -1.487412>,
      < -6.723832, -1.334326, -1.337166>
    }
    triangle {
      < -6.742006, -1.283147, -1.171014>,
      < -6.725572, -1.283147, -1.321260>,
      < -6.725572, -1.334326, -1.321260>
    }
    triangle {
      < -6.742006, -1.283147, -1.171014>,
      < -6.725572, -1.334326, -1.321260>,
      < -6.742006, -1.334326, -1.171014>
    }
    triangle {
      < -6.760180, -1.283147, -1.004862>,
      < -6.743745, -1.283147, -1.155109>,
      < -6.743745, -1.334326, -1.155109>
    }
    triangle {
      < -6.760180, -1.283147, -1.004862>,
      < -6.743745, -1.334326, -1.155109>,
      < -6.760180, -1.334326, -1.004862>
    }
    triangle {
      < -6.778354, -1.283147, -0.838711>,
      < -6.761919, -1.283147, -0.988957>,
      < -6.761919, -1.334326, -0.988957>
    }
    triangle {
      < -6.778354, -1.283147, -0.838711>,
      < -6.761919, -1.334326, -0.988957>,
      < -6.778354, -1.334326, -0.838711>
    }
    triangle {
      < -6.796528, -1.283147, -0.672559>,
      < -6.780094, -1.283147, -0.822806>,
      < -6.780094, -1.334326, -0.822806>
    }
    triangle {
      < -6.796528, -1.283147, -0.672559>,
      < -6.780094, -1.334326, -0.822806>,
      < -6.796528, -1.334326, -0.672559>
    }
    triangle {
      < -6.814702, -1.283147, -0.506407>,
      < -6.798267, -1.283147, -0.656654>,
      < -6.798267, -1.334326, -0.656654>
    }
    triangle {
      < -6.814702, -1.283147, -0.506407>,
      < -6.798267, -1.334326, -0.656654>,
      < -6.814702, -1.334326, -0.506407>
    }
    triangle {
      < -6.832876, -1.283147, -0.340256>,
      < -6.816442, -1.283147, -0.490502>,
      < -6.816442, -1.334326, -0.490502>
    }
    triangle {
      < -6.832876, -1.283147, -0.340256>,
      < -6.816442, -1.334326, -0.490502>,
      < -6.832876, -1.334326, -0.340256>
    }
    triangle {
      < -6.851050, -1.283147, -0.174104>,
      < -6.834615, -1.283147, -0.324351>,
      < -6.834615, -1.334326, -0.324351>
    }
    triangle {
      < -6.851050, -1.283147, -0.174104>,
      < -6.834615, -1.334326, -0.324351>,
      < -6.851050, -1.334326, -0.174104>
    }
    triangle {
      < -6.834616, -1.283147, 0.324351>,
      < -6.851051, -1.283147, 0.174104>,
      < -6.851051, -1.334326, 0.174104>
    }
    triangle {
      < -6.834616, -1.283147, 0.324351>,
      < -6.851051, -1.334326, 0.174104>,
      < -6.834616, -1.334326, 0.324351>
    }
    triangle {
      < -6.816443, -1.283147, 0.490502>,
      < -6.832877, -1.283147, 0.340256>,
      < -6.832877, -1.334326, 0.340256>
    }
    triangle {
      < -6.816443, -1.283147, 0.490502>,
      < -6.832877, -1.334326, 0.340256>,
      < -6.816443, -1.334326, 0.490502>
    }
    triangle {
      < -6.798269, -1.283147, 0.656654>,
      < -6.814703, -1.283147, 0.506407>,
      < -6.814703, -1.334326, 0.506407>
    }
    triangle {
      < -6.798269, -1.283147, 0.656654>,
      < -6.814703, -1.334326, 0.506407>,
      < -6.798269, -1.334326, 0.656654>
    }
    triangle {
      < -6.780095, -1.283147, 0.822806>,
      < -6.796529, -1.283147, 0.672559>,
      < -6.796529, -1.334326, 0.672559>
    }
    triangle {
      < -6.780095, -1.283147, 0.822806>,
      < -6.796529, -1.334326, 0.672559>,
      < -6.780095, -1.334326, 0.822806>
    }
    triangle {
      < -6.761921, -1.283147, 0.988957>,
      < -6.778356, -1.283147, 0.838711>,
      < -6.778356, -1.334326, 0.838711>
    }
    triangle {
      < -6.761921, -1.283147, 0.988957>,
      < -6.778356, -1.334326, 0.838711>,
      < -6.761921, -1.334326, 0.988957>
    }
    triangle {
      < -6.743747, -1.283147, 1.155109>,
      < -6.760181, -1.283147, 1.004862>,
      < -6.760181, -1.334326, 1.004862>
    }
    triangle {
      < -6.743747, -1.283147, 1.155109>,
      < -6.760181, -1.334326, 1.004862>,
      < -6.743747, -1.334326, 1.155109>
    }
    triangle {
      < -6.725573, -1.283147, 1.321261>,
      < -6.742008, -1.283147, 1.171014>,
      < -6.742008, -1.334326, 1.171014>
    }
    triangle {
      < -6.725573, -1.283147, 1.321261>,
      < -6.742008, -1.334326, 1.171014>,
      < -6.725573, -1.334326, 1.321261>
    }
    triangle {
      < -6.707399, -1.283147, 1.487412>,
      < -6.723834, -1.283147, 1.337166>,
      < -6.723834, -1.334326, 1.337166>
    }
    triangle {
      < -6.707399, -1.283147, 1.487412>,
      < -6.723834, -1.334326, 1.337166>,
      < -6.707399, -1.334326, 1.487412>
    }
    triangle {
      < -6.689225, -1.283147, 1.653563>,
      < -6.705659, -1.283147, 1.503317>,
      < -6.705659, -1.334326, 1.503317>
    }
    triangle {
      < -6.689225, -1.283147, 1.653563>,
      < -6.705659, -1.334326, 1.503317>,
      < -6.689225, -1.334326, 1.653563>
    }
    triangle {
      < -6.671051, -1.283147, 1.819715>,
      < -6.687486, -1.283147, 1.669469>,
      < -6.687486, -1.334326, 1.669469>
    }
    triangle {
      < -6.671051, -1.283147, 1.819715>,
      < -6.687486, -1.334326, 1.669469>,
      < -6.671051, -1.334326, 1.819715>
    }
    triangle {
      < -6.652877, -1.283147, 1.985867>,
      < -6.669312, -1.283147, 1.835620>,
      < -6.669312, -1.334326, 1.835620>
    }
    triangle {
      < -6.652877, -1.283147, 1.985867>,
      < -6.669312, -1.334326, 1.835620>,
      < -6.652877, -1.334326, 1.985867>
    }
    triangle {
      < -6.634703, -1.283147, 2.152019>,
      < -6.651138, -1.283147, 2.001772>,
      < -6.651138, -1.334326, 2.001772>
    }
    triangle {
      < -6.634703, -1.283147, 2.152019>,
      < -6.651138, -1.334326, 2.001772>,
      < -6.634703, -1.334326, 2.152019>
    }
    triangle {
      < -6.616529, -1.283147, 2.318170>,
      < -6.632964, -1.283147, 2.167924>,
      < -6.632964, -1.334326, 2.167924>
    }
    triangle {
      < -6.616529, -1.283147, 2.318170>,
      < -6.632964, -1.334326, 2.167924>,
      < -6.616529, -1.334326, 2.318170>
    }
    triangle {
      < -6.598355, -1.283147, 2.484322>,
      < -6.614789, -1.283147, 2.334075>,
      < -6.614789, -1.334326, 2.334075>
    }
    triangle {
      < -6.598355, -1.283147, 2.484322>,
      < -6.614789, -1.334326, 2.334075>,
      < -6.598355, -1.334326, 2.484322>
    }
    triangle {
      < -6.580181, -1.283147, 2.650474>,
      < -6.596616, -1.283147, 2.500227>,
      < -6.596616, -1.334326, 2.500227>
    }
    triangle {
      < -6.580181, -1.283147, 2.650474>,
      < -6.596616, -1.334326, 2.500227>,
      < -6.580181, -1.334326, 2.650474>
    }
    triangle {
      < -6.869224, -1.417505, -0.007953>,
      < -6.852789, -1.417505, -0.158199>,
      < -6.852789, -1.468684, -0.158199>
    }
    triangle {
      < -6.869224, -1.417505, -0.007953>,
      < -6.852789, -1.468684, -0.158199>,
      < -6.869224, -1.468684, -0.007953>
    }
    triangle {
      < -6.852790, -1.417505, 0.158199>,
      < -6.869224, -1.417505, 0.007953>,
      < -6.869224, -1.468684, 0.007953>
    }
    triangle {
      < -6.852790, -1.417505, 0.158199>,
      < -6.869224, -1.468684, 0.007953>,
      < -6.852789, -1.468684, 0.158199>
    }
    triangle {
      < -6.596615, -1.417505, -2.500227>,
      < -6.580181, -1.417505, -2.650473>,
      < -6.580181, -1.468684, -2.650473>
    }
    triangle {
      < -6.596615, -1.417505, -2.500227>,
      < -6.580181, -1.468684, -2.650473>,
      < -6.596616, -1.468684, -2.500227>
    }
    triangle {
      < -6.614789, -1.417505, -2.334075>,
      < -6.598354, -1.417505, -2.484322>,
      < -6.598355, -1.468684, -2.484322>
    }
    triangle {
      < -6.614789, -1.417505, -2.334075>,
      < -6.598355, -1.468684, -2.484322>,
      < -6.614789, -1.468684, -2.334075>
    }
    triangle {
      < -6.632963, -1.417505, -2.167924>,
      < -6.616529, -1.417505, -2.318170>,
      < -6.616529, -1.468684, -2.318170>
    }
    triangle {
      < -6.632963, -1.417505, -2.167924>,
      < -6.616529, -1.468684, -2.318170>,
      < -6.632964, -1.468684, -2.167923>
    }
    triangle {
      < -6.651137, -1.417505, -2.001772>,
      < -6.634702, -1.417505, -2.152018>,
      < -6.634703, -1.468684, -2.152018>
    }
    triangle {
      < -6.651137, -1.417505, -2.001772>,
      < -6.634703, -1.468684, -2.152018>,
      < -6.651137, -1.468684, -2.001772>
    }
    triangle {
      < -6.669311, -1.417505, -1.835620>,
      < -6.652876, -1.417505, -1.985867>,
      < -6.652876, -1.468684, -1.985867>
    }
    triangle {
      < -6.669311, -1.417505, -1.835620>,
      < -6.652876, -1.468684, -1.985867>,
      < -6.669312, -1.468684, -1.835620>
    }
    triangle {
      < -6.687485, -1.417505, -1.669469>,
      < -6.671051, -1.417505, -1.819715>,
      < -6.671051, -1.468684, -1.819715>
    }
    triangle {
      < -6.687485, -1.417505, -1.669469>,
      < -6.671051, -1.468684, -1.819715>,
      < -6.687485, -1.468684, -1.669469>
    }
    triangle {
      < -6.705659, -1.417505, -1.503317>,
      < -6.689224, -1.417505, -1.653564>,
      < -6.689224, -1.468684, -1.653564>
    }
    triangle {
      < -6.705659, -1.417505, -1.503317>,
      < -6.689224, -1.468684, -1.653564>,
      < -6.705659, -1.468684, -1.503317>
    }
    triangle {
      < -6.723833, -1.417505, -1.337166>,
      < -6.707398, -1.417505, -1.487412>,
      < -6.707399, -1.468684, -1.487412>
    }
    triangle {
      < -6.723833, -1.417505, -1.337166>,
      < -6.707399, -1.468684, -1.487412>,
      < -6.723833, -1.468684, -1.337165>
    }
    triangle {
      < -6.742007, -1.417505, -1.171014>,
      < -6.725572, -1.417505, -1.321260>,
      < -6.725572, -1.468684, -1.321260>
    }
    triangle {
      < -6.742007, -1.417505, -1.171014>,
      < -6.725572, -1.468684, -1.321260>,
      < -6.742008, -1.468684, -1.171014>
    }
    triangle {
      < -6.760181, -1.417505, -1.004862>,
      < -6.743746, -1.417505, -1.155109>,
      < -6.743747, -1.468684, -1.155109>
    }
    triangle {
      < -6.760181, -1.417505, -1.004862>,
      < -6.743747, -1.468684, -1.155109>,
      < -6.760181, -1.468684, -1.004862>
    }
    triangle {
      < -6.778355, -1.417505, -0.838711>,
      < -6.761920, -1.417505, -0.988957>,
      < -6.761920, -1.468684, -0.988957>
    }
    triangle {
      < -6.778355, -1.417505, -0.838711>,
      < -6.761920, -1.468684, -0.988957>,
      < -6.778356, -1.468684, -0.838710>
    }
    triangle {
      < -6.796529, -1.417505, -0.672559>,
      < -6.780094, -1.417505, -0.822805>,
      < -6.780095, -1.468684, -0.822805>
    }
    triangle {
      < -6.796529, -1.417505, -0.672559>,
      < -6.780095, -1.468684, -0.822805>,
      < -6.796529, -1.468684, -0.672559>
    }
    triangle {
      < -6.814703, -1.417505, -0.506407>,
      < -6.798268, -1.417505, -0.656654>,
      < -6.798268, -1.468684, -0.656654>
    }
    triangle {
      < -6.814703, -1.417505, -0.506407>,
      < -6.798268, -1.468684, -0.656654>,
      < -6.814703, -1.468684, -0.506407>
    }
    triangle {
      < -6.832876, -1.417505, -0.340256>,
      < -6.816442, -1.417505, -0.490502>,
      < -6.816443, -1.468684, -0.490502>
    }
    triangle {
      < -6.832876, -1.417505, -0.340256>,
      < -6.816443, -1.468684, -0.490502>,
      < -6.832877, -1.468684, -0.340256>
    }
    triangle {
      < -6.851050, -1.417505, -0.174104>,
      < -6.834615, -1.417505, -0.324351>,
      < -6.834616, -1.468684, -0.324351>
    }
    triangle {
      < -6.851050, -1.417505, -0.174104>,
      < -6.834616, -1.468684, -0.324351>,
      < -6.851050, -1.468684, -0.174104>
    }
    triangle {
      < -6.834616, -1.417505, 0.324351>,
      < -6.851051, -1.417505, 0.174104>,
      < -6.851050, -1.468684, 0.174104>
    }
    triangle {
      < -6.834616, -1.417505, 0.324351>,
      < -6.851050, -1.468684, 0.174104>,
      < -6.834616, -1.468684, 0.324351>
    }
    triangle {
      < -6.816442, -1.417505, 0.490502>,
      < -6.832877, -1.417505, 0.340256>,
      < -6.832877, -1.468684, 0.340256>
    }
    triangle {
      < -6.816442, -1.417505, 0.490502>,
      < -6.832877, -1.468684, 0.340256>,
      < -6.816442, -1.468684, 0.490502>
    }
    triangle {
      < -6.798268, -1.417505, 0.656654>,
      < -6.814703, -1.417505, 0.506407>,
      < -6.814702, -1.468684, 0.506407>
    }
    triangle {
      < -6.798268, -1.417505, 0.656654>,
      < -6.814702, -1.468684, 0.506407>,
      < -6.798268, -1.468684, 0.656654>
    }
    triangle {
      < -6.780094, -1.417505, 0.822806>,
      < -6.796529, -1.417505, 0.672559>,
      < -6.796529, -1.468684, 0.672559>
    }
    triangle {
      < -6.780094, -1.417505, 0.822806>,
      < -6.796529, -1.468684, 0.672559>,
      < -6.780094, -1.468684, 0.822806>
    }
    triangle {
      < -6.761920, -1.417505, 0.988957>,
      < -6.778355, -1.417505, 0.838711>,
      < -6.778354, -1.468684, 0.838711>
    }
    triangle {
      < -6.761920, -1.417505, 0.988957>,
      < -6.778354, -1.468684, 0.838711>,
      < -6.761920, -1.468684, 0.988957>
    }
    triangle {
      < -6.743746, -1.417505, 1.155109>,
      < -6.760181, -1.417505, 1.004863>,
      < -6.760181, -1.468684, 1.004863>
    }
    triangle {
      < -6.743746, -1.417505, 1.155109>,
      < -6.760181, -1.468684, 1.004863>,
      < -6.743745, -1.468684, 1.155109>
    }
    triangle {
      < -6.725572, -1.417505, 1.321261>,
      < -6.742007, -1.417505, 1.171014>,
      < -6.742006, -1.468684, 1.171014>
    }
    triangle {
      < -6.725572, -1.417505, 1.321261>,
      < -6.742006, -1.468684, 1.171014>,
      < -6.725572, -1.468684, 1.321261>
    }
    triangle {
      < -6.707398, -1.417505, 1.487412>,
      < -6.723833, -1.417505, 1.337166>,
      < -6.723833, -1.468684, 1.337166>
    }
    triangle {
      < -6.707398, -1.417505, 1.487412>,
      < -6.723833, -1.468684, 1.337166>,
      < -6.707397, -1.468684, 1.487412>
    }
    triangle {
      < -6.689224, -1.417505, 1.653564>,
      < -6.705659, -1.417505, 1.503317>,
      < -6.705658, -1.468684, 1.503317>
    }
    triangle {
      < -6.689224, -1.417505, 1.653564>,
      < -6.705658, -1.468684, 1.503317>,
      < -6.689224, -1.468684, 1.653564>
    }
    triangle {
      < -6.671051, -1.417505, 1.819715>,
      < -6.687485, -1.417505, 1.669469>,
      < -6.687485, -1.468684, 1.669469>
    }
    triangle {
      < -6.671051, -1.417505, 1.819715>,
      < -6.687485, -1.468684, 1.669469>,
      < -6.671050, -1.468684, 1.819715>
    }
    triangle {
      < -6.652876, -1.417505, 1.985867>,
      < -6.669311, -1.417505, 1.835621>,
      < -6.669310, -1.468684, 1.835621>
    }
    triangle {
      < -6.652876, -1.417505, 1.985867>,
      < -6.669310, -1.468684, 1.835621>,
      < -6.652876, -1.468684, 1.985867>
    }
    triangle {
      < -6.634703, -1.417505, 2.152019>,
      < -6.651137, -1.417505, 2.001772>,
      < -6.651137, -1.468684, 2.001772>
    }
    triangle {
      < -6.634703, -1.417505, 2.152019>,
      < -6.651137, -1.468684, 2.001772>,
      < -6.634703, -1.468684, 2.152019>
    }
    triangle {
      < -6.616529, -1.417505, 2.318170>,
      < -6.632964, -1.417505, 2.167924>,
      < -6.632964, -1.468684, 2.167924>
    }
    triangle {
      < -6.616529, -1.417505, 2.318170>,
      < -6.632964, -1.468684, 2.167924>,
      < -6.616529, -1.468684, 2.318171>
    }
    triangle {
      < -6.598355, -1.417505, 2.484322>,
      < -6.614789, -1.417505, 2.334076>,
      < -6.614789, -1.468684, 2.334076>
    }
    triangle {
      < -6.598355, -1.417505, 2.484322>,
      < -6.614789, -1.468684, 2.334076>,
      < -6.598355, -1.468684, 2.484322>
    }
    triangle {
      < -6.580181, -1.417505, 2.650474>,
      < -6.596616, -1.417505, 2.500227>,
      < -6.596616, -1.468684, 2.500227>
    }
    triangle {
      < -6.580181, -1.417505, 2.650474>,
      < -6.596616, -1.468684, 2.500227>,
      < -6.580181, -1.468684, 2.650474>
    }
    texture {blacko}
  }
  // grill
  union {
    triangle {
      < -6.598354, -1.535863, 2.484322>,
      < -6.598354, -1.551863, 2.484322>,
      < -6.596615, -1.551863, 2.500227>
    }
    triangle {
      < -6.598354, -1.535863, 2.484322>,
      < -6.596615, -1.551863, 2.500227>,
      < -6.596615, -1.535863, 2.500227>
    }
    triangle {
      < -6.596616, -1.484684, 2.500227>,
      < -6.596616, -1.468684, 2.500227>,
      < -6.598355, -1.468684, 2.484322>
    }
    triangle {
      < -6.596616, -1.484684, 2.500227>,
      < -6.598355, -1.468684, 2.484322>,
      < -6.598355, -1.484684, 2.484322>
    }
    triangle {
      < -6.580181, -1.484684, 2.650474>,
      < -6.571311, -1.476684, 2.658426>,
      < -6.580181, -1.468684, 2.650474>
    }
    triangle {
      < -6.596616, -1.417505, 2.500227>,
      < -6.596616, -1.401505, 2.500227>,
      < -6.598355, -1.401505, 2.484322>
    }
    triangle {
      < -6.596616, -1.417505, 2.500227>,
      < -6.598355, -1.401505, 2.484322>,
      < -6.598355, -1.417505, 2.484322>
    }
    triangle {
      < -6.614789, -1.468684, 2.334076>,
      < -6.616529, -1.468684, 2.318171>,
      < -6.616529, -1.484684, 2.318171>
    }
    triangle {
      < -6.614789, -1.468684, 2.334076>,
      < -6.616529, -1.484684, 2.318171>,
      < -6.614789, -1.484684, 2.334076>
    }
    triangle {
      < -6.634702, -1.535863, 2.152019>,
      < -6.634702, -1.551863, 2.152019>,
      < -6.632963, -1.551863, 2.167924>
    }
    triangle {
      < -6.634702, -1.535863, 2.152019>,
      < -6.632963, -1.551863, 2.167924>,
      < -6.632963, -1.535863, 2.167924>
    }
    triangle {
      < -6.632964, -1.484684, 2.167924>,
      < -6.632964, -1.468684, 2.167924>,
      < -6.634703, -1.468684, 2.152019>
    }
    triangle {
      < -6.632964, -1.484684, 2.167924>,
      < -6.634703, -1.468684, 2.152019>,
      < -6.634703, -1.484684, 2.152019>
    }
    triangle {
      < -6.632964, -1.417505, 2.167924>,
      < -6.632964, -1.401505, 2.167924>,
      < -6.634703, -1.401505, 2.152019>
    }
    triangle {
      < -6.632964, -1.417505, 2.167924>,
      < -6.634703, -1.401505, 2.152019>,
      < -6.634703, -1.417505, 2.152019>
    }
    triangle {
      < -6.651137, -1.468684, 2.001772>,
      < -6.652876, -1.468684, 1.985867>,
      < -6.652876, -1.484684, 1.985867>
    }
    triangle {
      < -6.651137, -1.468684, 2.001772>,
      < -6.652876, -1.484684, 1.985867>,
      < -6.651137, -1.484684, 2.001772>
    }
    triangle {
      < -6.671050, -1.535863, 1.819715>,
      < -6.671050, -1.551863, 1.819715>,
      < -6.669310, -1.551863, 1.835621>
    }
    triangle {
      < -6.671050, -1.535863, 1.819715>,
      < -6.669310, -1.551863, 1.835621>,
      < -6.669310, -1.535863, 1.835621>
    }
    triangle {
      < -6.669310, -1.484684, 1.835621>,
      < -6.669310, -1.468684, 1.835621>,
      < -6.671050, -1.468684, 1.819715>
    }
    triangle {
      < -6.669310, -1.484684, 1.835621>,
      < -6.671050, -1.468684, 1.819715>,
      < -6.671050, -1.484684, 1.819715>
    }
    triangle {
      < -6.669311, -1.417505, 1.835621>,
      < -6.669311, -1.401505, 1.835620>,
      < -6.671051, -1.401505, 1.819715>
    }
    triangle {
      < -6.669311, -1.417505, 1.835621>,
      < -6.671051, -1.401505, 1.819715>,
      < -6.671051, -1.417505, 1.819715>
    }
    triangle {
      < -6.687485, -1.468684, 1.669469>,
      < -6.689224, -1.468684, 1.653564>,
      < -6.689224, -1.484684, 1.653564>
    }
    triangle {
      < -6.687485, -1.468684, 1.669469>,
      < -6.689224, -1.484684, 1.653564>,
      < -6.687485, -1.484684, 1.669469>
    }
    triangle {
      < -6.707397, -1.535863, 1.487412>,
      < -6.707397, -1.551863, 1.487412>,
      < -6.705658, -1.551863, 1.503317>
    }
    triangle {
      < -6.707397, -1.535863, 1.487412>,
      < -6.705658, -1.551863, 1.503317>,
      < -6.705658, -1.535863, 1.503317>
    }
    triangle {
      < -6.705658, -1.484684, 1.503317>,
      < -6.705658, -1.468684, 1.503317>,
      < -6.707397, -1.468684, 1.487412>
    }
    triangle {
      < -6.705658, -1.484684, 1.503317>,
      < -6.707397, -1.468684, 1.487412>,
      < -6.707397, -1.484684, 1.487412>
    }
    triangle {
      < -6.705659, -1.417505, 1.503317>,
      < -6.705659, -1.401505, 1.503317>,
      < -6.707398, -1.401505, 1.487412>
    }
    triangle {
      < -6.705659, -1.417505, 1.503317>,
      < -6.707398, -1.401505, 1.487412>,
      < -6.707398, -1.417505, 1.487412>
    }
    triangle {
      < -6.723833, -1.468684, 1.337166>,
      < -6.725572, -1.468684, 1.321261>,
      < -6.725572, -1.484684, 1.321261>
    }
    triangle {
      < -6.723833, -1.468684, 1.337166>,
      < -6.725572, -1.484684, 1.321261>,
      < -6.723833, -1.484684, 1.337166>
    }
    triangle {
      < -6.743745, -1.535863, 1.155109>,
      < -6.743745, -1.551863, 1.155109>,
      < -6.742006, -1.551863, 1.171014>
    }
    triangle {
      < -6.743745, -1.535863, 1.155109>,
      < -6.742006, -1.551863, 1.171014>,
      < -6.742006, -1.535863, 1.171014>
    }
    triangle {
      < -6.742006, -1.484684, 1.171014>,
      < -6.742006, -1.468684, 1.171014>,
      < -6.743745, -1.468684, 1.155109>
    }
    triangle {
      < -6.742006, -1.484684, 1.171014>,
      < -6.743745, -1.468684, 1.155109>,
      < -6.743745, -1.484684, 1.155109>
    }
    triangle {
      < -6.742007, -1.417505, 1.171014>,
      < -6.742007, -1.401505, 1.171014>,
      < -6.743746, -1.401505, 1.155109>
    }
    triangle {
      < -6.742007, -1.417505, 1.171014>,
      < -6.743746, -1.401505, 1.155109>,
      < -6.743746, -1.417505, 1.155109>
    }
    triangle {
      < -6.760181, -1.468684, 1.004863>,
      < -6.761920, -1.468684, 0.988957>,
      < -6.761920, -1.484684, 0.988957>
    }
    triangle {
      < -6.760181, -1.468684, 1.004863>,
      < -6.761920, -1.484684, 0.988957>,
      < -6.760181, -1.484684, 1.004863>
    }
    triangle {
      < -6.780094, -1.535863, 0.822806>,
      < -6.780094, -1.551863, 0.822806>,
      < -6.778354, -1.551863, 0.838711>
    }
    triangle {
      < -6.780094, -1.535863, 0.822806>,
      < -6.778354, -1.551863, 0.838711>,
      < -6.778354, -1.535863, 0.838711>
    }
    triangle {
      < -6.778354, -1.484684, 0.838711>,
      < -6.778354, -1.468684, 0.838711>,
      < -6.780094, -1.468684, 0.822806>
    }
    triangle {
      < -6.778354, -1.484684, 0.838711>,
      < -6.780094, -1.468684, 0.822806>,
      < -6.780094, -1.484684, 0.822806>
    }
    triangle {
      < -6.778355, -1.417505, 0.838711>,
      < -6.778355, -1.401505, 0.838711>,
      < -6.780094, -1.401505, 0.822806>
    }
    triangle {
      < -6.778355, -1.417505, 0.838711>,
      < -6.780094, -1.401505, 0.822806>,
      < -6.780094, -1.417505, 0.822806>
    }
    triangle {
      < -6.796529, -1.468684, 0.672559>,
      < -6.798268, -1.468684, 0.656654>,
      < -6.798268, -1.484684, 0.656654>
    }
    triangle {
      < -6.796529, -1.468684, 0.672559>,
      < -6.798268, -1.484684, 0.656654>,
      < -6.796529, -1.484684, 0.672559>
    }
    triangle {
      < -6.816442, -1.535863, 0.490503>,
      < -6.816442, -1.551863, 0.490503>,
      < -6.814702, -1.551863, 0.506408>
    }
    triangle {
      < -6.816442, -1.535863, 0.490503>,
      < -6.814702, -1.551863, 0.506408>,
      < -6.814702, -1.535863, 0.506407>
    }
    triangle {
      < -6.814702, -1.484684, 0.506407>,
      < -6.814702, -1.468684, 0.506407>,
      < -6.816442, -1.468684, 0.490502>
    }
    triangle {
      < -6.814702, -1.484684, 0.506407>,
      < -6.816442, -1.468684, 0.490502>,
      < -6.816442, -1.484684, 0.490502>
    }
    triangle {
      < -6.814703, -1.417505, 0.506407>,
      < -6.814703, -1.401505, 0.506407>,
      < -6.816442, -1.401505, 0.490502>
    }
    triangle {
      < -6.814703, -1.417505, 0.506407>,
      < -6.816442, -1.401505, 0.490502>,
      < -6.816442, -1.417505, 0.490502>
    }
    triangle {
      < -6.832877, -1.468684, 0.340256>,
      < -6.834616, -1.468684, 0.324351>,
      < -6.834616, -1.484684, 0.324351>
    }
    triangle {
      < -6.832877, -1.468684, 0.340256>,
      < -6.834616, -1.484684, 0.324351>,
      < -6.832877, -1.484684, 0.340256>
    }
    triangle {
      < -6.852789, -1.535863, 0.158199>,
      < -6.852789, -1.551863, 0.158199>,
      < -6.851050, -1.551863, 0.174104>
    }
    triangle {
      < -6.852789, -1.535863, 0.158199>,
      < -6.851050, -1.551863, 0.174104>,
      < -6.851050, -1.535863, 0.174104>
    }
    triangle {
      < -6.851050, -1.484684, 0.174104>,
      < -6.851050, -1.468684, 0.174104>,
      < -6.852789, -1.468684, 0.158199>
    }
    triangle {
      < -6.851050, -1.484684, 0.174104>,
      < -6.852789, -1.468684, 0.158199>,
      < -6.852789, -1.484684, 0.158199>
    }
    triangle {
      < -6.851051, -1.417505, 0.174104>,
      < -6.851051, -1.401505, 0.174104>,
      < -6.852790, -1.401505, 0.158199>
    }
    triangle {
      < -6.851051, -1.417505, 0.174104>,
      < -6.852790, -1.401505, 0.158199>,
      < -6.852790, -1.417505, 0.158199>
    }
    triangle {
      < -6.869224, -1.468684, 0.007953>,
      < -6.869224, -1.468684, -0.007953>,
      < -6.869224, -1.484684, -0.007953>
    }
    triangle {
      < -6.869224, -1.468684, 0.007953>,
      < -6.869224, -1.484684, -0.007953>,
      < -6.869224, -1.484684, 0.007953>
    }
    triangle {
      < -6.832877, -1.535863, -0.340256>,
      < -6.832877, -1.551863, -0.340256>,
      < -6.834616, -1.551863, -0.324351>
    }
    triangle {
      < -6.832877, -1.535863, -0.340256>,
      < -6.834616, -1.551863, -0.324351>,
      < -6.834616, -1.535863, -0.324351>
    }
    triangle {
      < -6.834616, -1.484684, -0.324351>,
      < -6.834616, -1.468684, -0.324351>,
      < -6.832877, -1.468684, -0.340256>
    }
    triangle {
      < -6.834616, -1.484684, -0.324351>,
      < -6.832877, -1.468684, -0.340256>,
      < -6.832877, -1.484684, -0.340256>
    }
    triangle {
      < -6.851050, -1.484684, -0.174104>,
      < -6.852789, -1.484684, -0.158199>,
      < -6.852789, -1.468684, -0.158199>
    }
    triangle {
      < -6.851050, -1.484684, -0.174104>,
      < -6.852789, -1.468684, -0.158199>,
      < -6.851050, -1.468684, -0.174104>
    }
    triangle {
      < -6.834615, -1.417505, -0.324351>,
      < -6.834615, -1.401505, -0.324351>,
      < -6.832876, -1.401505, -0.340256>
    }
    triangle {
      < -6.834615, -1.417505, -0.324351>,
      < -6.832876, -1.401505, -0.340256>,
      < -6.832876, -1.417505, -0.340256>
    }
    triangle {
      < -6.816443, -1.468684, -0.490502>,
      < -6.814703, -1.468684, -0.506407>,
      < -6.814703, -1.484684, -0.506407>
    }
    triangle {
      < -6.816443, -1.468684, -0.490502>,
      < -6.814703, -1.484684, -0.506407>,
      < -6.816443, -1.484684, -0.490502>
    }
    triangle {
      < -6.796529, -1.535863, -0.672559>,
      < -6.796529, -1.551863, -0.672559>,
      < -6.798269, -1.551863, -0.656654>
    }
    triangle {
      < -6.796529, -1.535863, -0.672559>,
      < -6.798269, -1.551863, -0.656654>,
      < -6.798269, -1.535863, -0.656654>
    }
    triangle {
      < -6.798268, -1.484684, -0.656654>,
      < -6.798268, -1.468684, -0.656654>,
      < -6.796529, -1.468684, -0.672559>
    }
    triangle {
      < -6.798268, -1.484684, -0.656654>,
      < -6.796529, -1.468684, -0.672559>,
      < -6.796529, -1.484684, -0.672559>
    }
    triangle {
      < -6.798268, -1.417505, -0.656654>,
      < -6.798268, -1.401505, -0.656654>,
      < -6.796529, -1.401505, -0.672559>
    }
    triangle {
      < -6.798268, -1.417505, -0.656654>,
      < -6.796529, -1.401505, -0.672559>,
      < -6.796529, -1.417505, -0.672559>
    }
    triangle {
      < -6.780095, -1.468684, -0.822805>,
      < -6.778356, -1.468684, -0.838710>,
      < -6.778356, -1.484684, -0.838710>
    }
    triangle {
      < -6.780095, -1.468684, -0.822805>,
      < -6.778356, -1.484684, -0.838710>,
      < -6.780095, -1.484684, -0.822805>
    }
    triangle {
      < -6.760181, -1.535863, -1.004862>,
      < -6.760181, -1.551863, -1.004862>,
      < -6.761921, -1.551863, -0.988957>
    }
    triangle {
      < -6.760181, -1.535863, -1.004862>,
      < -6.761921, -1.551863, -0.988957>,
      < -6.761921, -1.535863, -0.988957>
    }
    triangle {
      < -6.761920, -1.484684, -0.988957>,
      < -6.761920, -1.468684, -0.988957>,
      < -6.760181, -1.468684, -1.004862>
    }
    triangle {
      < -6.761920, -1.484684, -0.988957>,
      < -6.760181, -1.468684, -1.004862>,
      < -6.760181, -1.484684, -1.004862>
    }
    triangle {
      < -6.761920, -1.417505, -0.988957>,
      < -6.761920, -1.401505, -0.988957>,
      < -6.760181, -1.401505, -1.004862>
    }
    triangle {
      < -6.761920, -1.417505, -0.988957>,
      < -6.760181, -1.401505, -1.004862>,
      < -6.760181, -1.417505, -1.004862>
    }
    triangle {
      < -6.743747, -1.468684, -1.155109>,
      < -6.742008, -1.468684, -1.171014>,
      < -6.742008, -1.484684, -1.171014>
    }
    triangle {
      < -6.743747, -1.468684, -1.155109>,
      < -6.742008, -1.484684, -1.171014>,
      < -6.743747, -1.484684, -1.155109>
    }
    triangle {
      < -6.723834, -1.535863, -1.337165>,
      < -6.723834, -1.551863, -1.337165>,
      < -6.725573, -1.551863, -1.321260>
    }
    triangle {
      < -6.723834, -1.535863, -1.337165>,
      < -6.725573, -1.551863, -1.321260>,
      < -6.725573, -1.535863, -1.321260>
    }
    triangle {
      < -6.725572, -1.484684, -1.321260>,
      < -6.725572, -1.468684, -1.321260>,
      < -6.723833, -1.468684, -1.337165>
    }
    triangle {
      < -6.725572, -1.484684, -1.321260>,
      < -6.723833, -1.468684, -1.337165>,
      < -6.723833, -1.484684, -1.337165>
    }
    triangle {
      < -6.725572, -1.417505, -1.321260>,
      < -6.725572, -1.401505, -1.321260>,
      < -6.723833, -1.401505, -1.337166>
    }
    triangle {
      < -6.725572, -1.417505, -1.321260>,
      < -6.723833, -1.401505, -1.337166>,
      < -6.723833, -1.417505, -1.337166>
    }
    triangle {
      < -6.707399, -1.468684, -1.487412>,
      < -6.705659, -1.468684, -1.503317>,
      < -6.705659, -1.484684, -1.503317>
    }
    triangle {
      < -6.707399, -1.468684, -1.487412>,
      < -6.705659, -1.484684, -1.503317>,
      < -6.707399, -1.484684, -1.487412>
    }
    triangle {
      < -6.687486, -1.535863, -1.669469>,
      < -6.687486, -1.551863, -1.669469>,
      < -6.689225, -1.551863, -1.653563>
    }
    triangle {
      < -6.687486, -1.535863, -1.669469>,
      < -6.689225, -1.551863, -1.653563>,
      < -6.689225, -1.535863, -1.653563>
    }
    triangle {
      < -6.689224, -1.484684, -1.653564>,
      < -6.689224, -1.468684, -1.653564>,
      < -6.687485, -1.468684, -1.669469>
    }
    triangle {
      < -6.689224, -1.484684, -1.653564>,
      < -6.687485, -1.468684, -1.669469>,
      < -6.687485, -1.484684, -1.669469>
    }
    triangle {
      < -6.689224, -1.417505, -1.653564>,
      < -6.689224, -1.401505, -1.653564>,
      < -6.687485, -1.401505, -1.669469>
    }
    triangle {
      < -6.689224, -1.417505, -1.653564>,
      < -6.687485, -1.401505, -1.669469>,
      < -6.687485, -1.417505, -1.669469>
    }
    triangle {
      < -6.671051, -1.468684, -1.819715>,
      < -6.669312, -1.468684, -1.835620>,
      < -6.669312, -1.484684, -1.835620>
    }
    triangle {
      < -6.671051, -1.468684, -1.819715>,
      < -6.669312, -1.484684, -1.835620>,
      < -6.671051, -1.484684, -1.819715>
    }
    triangle {
      < -6.651138, -1.535863, -2.001772>,
      < -6.651138, -1.551863, -2.001772>,
      < -6.652877, -1.551863, -1.985867>
    }
    triangle {
      < -6.651138, -1.535863, -2.001772>,
      < -6.652877, -1.551863, -1.985867>,
      < -6.652877, -1.535863, -1.985867>
    }
    triangle {
      < -6.652876, -1.484684, -1.985867>,
      < -6.652876, -1.468684, -1.985867>,
      < -6.651137, -1.468684, -2.001772>
    }
    triangle {
      < -6.652876, -1.484684, -1.985867>,
      < -6.651137, -1.468684, -2.001772>,
      < -6.651137, -1.484684, -2.001772>
    }
    triangle {
      < -6.652876, -1.417505, -1.985867>,
      < -6.652876, -1.401505, -1.985867>,
      < -6.651137, -1.401505, -2.001772>
    }
    triangle {
      < -6.652876, -1.417505, -1.985867>,
      < -6.651137, -1.401505, -2.001772>,
      < -6.651137, -1.417505, -2.001772>
    }
    triangle {
      < -6.634703, -1.468684, -2.152018>,
      < -6.632964, -1.468684, -2.167923>,
      < -6.632964, -1.484684, -2.167923>
    }
    triangle {
      < -6.634703, -1.468684, -2.152018>,
      < -6.632964, -1.484684, -2.167923>,
      < -6.634703, -1.484684, -2.152018>
    }
    triangle {
      < -6.614789, -1.535863, -2.334075>,
      < -6.614789, -1.551863, -2.334075>,
      < -6.616529, -1.551863, -2.318170>
    }
    triangle {
      < -6.614789, -1.535863, -2.334075>,
      < -6.616529, -1.551863, -2.318170>,
      < -6.616529, -1.535863, -2.318170>
    }
    triangle {
      < -6.616529, -1.484684, -2.318170>,
      < -6.616529, -1.468684, -2.318170>,
      < -6.614789, -1.468684, -2.334075>
    }
    triangle {
      < -6.616529, -1.484684, -2.318170>,
      < -6.614789, -1.468684, -2.334075>,
      < -6.614789, -1.484684, -2.334075>
    }
    triangle {
      < -6.616529, -1.417505, -2.318170>,
      < -6.616529, -1.401505, -2.318170>,
      < -6.614789, -1.401505, -2.334075>
    }
    triangle {
      < -6.616529, -1.417505, -2.318170>,
      < -6.614789, -1.401505, -2.334075>,
      < -6.614789, -1.417505, -2.334075>
    }
    triangle {
      < -6.598355, -1.468684, -2.484322>,
      < -6.596616, -1.468684, -2.500227>,
      < -6.596616, -1.484684, -2.500227>
    }
    triangle {
      < -6.598355, -1.468684, -2.484322>,
      < -6.596616, -1.484684, -2.500227>,
      < -6.598355, -1.484684, -2.484322>
    }
    triangle {
      < -6.614789, -1.417505, 2.334076>,
      < -6.614789, -1.401505, 2.334075>,
      < -6.616529, -1.401505, 2.318170>
    }
    triangle {
      < -6.614789, -1.417505, 2.334076>,
      < -6.616529, -1.401505, 2.318170>,
      < -6.616529, -1.417505, 2.318170>
    }
    triangle {
      < -6.616529, -1.535863, 2.318171>,
      < -6.616529, -1.551863, 2.318171>,
      < -6.614789, -1.551863, 2.334076>
    }
    triangle {
      < -6.616529, -1.535863, 2.318171>,
      < -6.614789, -1.551863, 2.334076>,
      < -6.614789, -1.535863, 2.334076>
    }
    triangle {
      < -6.651137, -1.417505, 2.001772>,
      < -6.651137, -1.401505, 2.001772>,
      < -6.652876, -1.401505, 1.985867>
    }
    triangle {
      < -6.651137, -1.417505, 2.001772>,
      < -6.652876, -1.401505, 1.985867>,
      < -6.652876, -1.417505, 1.985867>
    }
    triangle {
      < -6.652875, -1.535863, 1.985867>,
      < -6.652875, -1.551863, 1.985867>,
      < -6.651136, -1.551863, 2.001772>
    }
    triangle {
      < -6.652875, -1.535863, 1.985867>,
      < -6.651136, -1.551863, 2.001772>,
      < -6.651136, -1.535863, 2.001772>
    }
    triangle {
      < -6.687485, -1.417505, 1.669469>,
      < -6.687485, -1.401505, 1.669469>,
      < -6.689224, -1.401505, 1.653564>
    }
    triangle {
      < -6.687485, -1.417505, 1.669469>,
      < -6.689224, -1.401505, 1.653564>,
      < -6.689224, -1.417505, 1.653564>
    }
    triangle {
      < -6.689224, -1.535863, 1.653564>,
      < -6.689224, -1.551863, 1.653564>,
      < -6.687484, -1.551863, 1.669469>
    }
    triangle {
      < -6.689224, -1.535863, 1.653564>,
      < -6.687484, -1.551863, 1.669469>,
      < -6.687484, -1.535863, 1.669469>
    }
    triangle {
      < -6.723833, -1.417505, 1.337166>,
      < -6.723833, -1.401505, 1.337166>,
      < -6.725572, -1.401505, 1.321261>
    }
    triangle {
      < -6.723833, -1.417505, 1.337166>,
      < -6.725572, -1.401505, 1.321261>,
      < -6.725572, -1.417505, 1.321261>
    }
    triangle {
      < -6.725572, -1.535863, 1.321261>,
      < -6.725572, -1.551863, 1.321261>,
      < -6.723832, -1.551863, 1.337166>
    }
    triangle {
      < -6.725572, -1.535863, 1.321261>,
      < -6.723832, -1.551863, 1.337166>,
      < -6.723832, -1.535863, 1.337166>
    }
    triangle {
      < -6.760181, -1.417505, 1.004863>,
      < -6.760181, -1.401505, 1.004863>,
      < -6.761920, -1.401505, 0.988957>
    }
    triangle {
      < -6.760181, -1.417505, 1.004863>,
      < -6.761920, -1.401505, 0.988957>,
      < -6.761920, -1.417505, 0.988957>
    }
    triangle {
      < -6.761919, -1.535863, 0.988957>,
      < -6.761919, -1.551863, 0.988957>,
      < -6.760180, -1.551863, 1.004863>
    }
    triangle {
      < -6.761919, -1.535863, 0.988957>,
      < -6.760180, -1.551863, 1.004863>,
      < -6.760180, -1.535863, 1.004863>
    }
    triangle {
      < -6.796529, -1.417505, 0.672559>,
      < -6.796529, -1.401505, 0.672559>,
      < -6.798268, -1.401505, 0.656654>
    }
    triangle {
      < -6.796529, -1.417505, 0.672559>,
      < -6.798268, -1.401505, 0.656654>,
      < -6.798268, -1.417505, 0.656654>
    }
    triangle {
      < -6.798267, -1.535863, 0.656654>,
      < -6.798267, -1.551863, 0.656654>,
      < -6.796528, -1.551863, 0.672559>
    }
    triangle {
      < -6.798267, -1.535863, 0.656654>,
      < -6.796528, -1.551863, 0.672559>,
      < -6.796528, -1.535863, 0.672559>
    }
    triangle {
      < -6.832877, -1.417505, 0.340256>,
      < -6.832877, -1.401505, 0.340256>,
      < -6.834616, -1.401505, 0.324351>
    }
    triangle {
      < -6.832877, -1.417505, 0.340256>,
      < -6.834616, -1.401505, 0.324351>,
      < -6.834616, -1.417505, 0.324351>
    }
    triangle {
      < -6.834615, -1.535863, 0.324351>,
      < -6.834615, -1.551863, 0.324351>,
      < -6.832876, -1.551863, 0.340256>
    }
    triangle {
      < -6.834615, -1.535863, 0.324351>,
      < -6.832876, -1.551863, 0.340256>,
      < -6.832876, -1.535863, 0.340256>
    }
    triangle {
      < -6.852789, -1.417505, -0.158199>,
      < -6.852789, -1.401505, -0.158199>,
      < -6.851050, -1.401505, -0.174104>
    }
    triangle {
      < -6.852789, -1.417505, -0.158199>,
      < -6.851050, -1.401505, -0.174104>,
      < -6.851050, -1.417505, -0.174104>
    }
    triangle {
      < -6.851051, -1.535863, -0.174104>,
      < -6.851051, -1.551863, -0.174104>,
      < -6.852790, -1.551863, -0.158199>
    }
    triangle {
      < -6.851051, -1.535863, -0.174104>,
      < -6.852790, -1.551863, -0.158199>,
      < -6.852790, -1.535863, -0.158199>
    }
    triangle {
      < -6.816442, -1.417505, -0.490502>,
      < -6.816442, -1.401505, -0.490502>,
      < -6.814703, -1.401505, -0.506407>
    }
    triangle {
      < -6.816442, -1.417505, -0.490502>,
      < -6.814703, -1.401505, -0.506407>,
      < -6.814703, -1.417505, -0.506407>
    }
    triangle {
      < -6.814703, -1.535863, -0.506407>,
      < -6.814703, -1.551863, -0.506407>,
      < -6.816443, -1.551863, -0.490502>
    }
    triangle {
      < -6.814703, -1.535863, -0.506407>,
      < -6.816443, -1.551863, -0.490502>,
      < -6.816443, -1.535863, -0.490502>
    }
    triangle {
      < -6.780094, -1.417505, -0.822805>,
      < -6.780094, -1.401505, -0.822805>,
      < -6.778355, -1.401505, -0.838711>
    }
    triangle {
      < -6.780094, -1.417505, -0.822805>,
      < -6.778355, -1.401505, -0.838711>,
      < -6.778355, -1.417505, -0.838711>
    }
    triangle {
      < -6.778356, -1.535863, -0.838710>,
      < -6.778356, -1.551863, -0.838710>,
      < -6.780095, -1.551863, -0.822805>
    }
    triangle {
      < -6.778356, -1.535863, -0.838710>,
      < -6.780095, -1.551863, -0.822805>,
      < -6.780095, -1.535863, -0.822805>
    }
    triangle {
      < -6.743746, -1.417505, -1.155109>,
      < -6.743746, -1.401505, -1.155109>,
      < -6.742007, -1.401505, -1.171014>
    }
    triangle {
      < -6.743746, -1.417505, -1.155109>,
      < -6.742007, -1.401505, -1.171014>,
      < -6.742007, -1.417505, -1.171014>
    }
    triangle {
      < -6.742008, -1.535863, -1.171014>,
      < -6.742008, -1.551863, -1.171014>,
      < -6.743747, -1.551863, -1.155109>
    }
    triangle {
      < -6.742008, -1.535863, -1.171014>,
      < -6.743747, -1.551863, -1.155109>,
      < -6.743747, -1.535863, -1.155109>
    }
    triangle {
      < -6.707398, -1.417505, -1.487412>,
      < -6.707398, -1.401505, -1.487412>,
      < -6.705659, -1.401505, -1.503317>
    }
    triangle {
      < -6.707398, -1.417505, -1.487412>,
      < -6.705659, -1.401505, -1.503317>,
      < -6.705659, -1.417505, -1.503317>
    }
    triangle {
      < -6.705659, -1.535863, -1.503317>,
      < -6.705659, -1.551863, -1.503317>,
      < -6.707399, -1.551863, -1.487412>
    }
    triangle {
      < -6.705659, -1.535863, -1.503317>,
      < -6.707399, -1.551863, -1.487412>,
      < -6.707399, -1.535863, -1.487412>
    }
    triangle {
      < -6.671051, -1.417505, -1.819715>,
      < -6.671051, -1.401505, -1.819715>,
      < -6.669311, -1.401505, -1.835621>
    }
    triangle {
      < -6.671051, -1.417505, -1.819715>,
      < -6.669311, -1.401505, -1.835621>,
      < -6.669311, -1.417505, -1.835620>
    }
    triangle {
      < -6.669312, -1.535863, -1.835620>,
      < -6.669312, -1.551863, -1.835620>,
      < -6.671051, -1.551863, -1.819715>
    }
    triangle {
      < -6.669312, -1.535863, -1.835620>,
      < -6.671051, -1.551863, -1.819715>,
      < -6.671051, -1.535863, -1.819715>
    }
    triangle {
      < -6.634702, -1.417505, -2.152018>,
      < -6.634702, -1.401505, -2.152019>,
      < -6.632963, -1.401505, -2.167924>
    }
    triangle {
      < -6.634702, -1.417505, -2.152018>,
      < -6.632963, -1.401505, -2.167924>,
      < -6.632963, -1.417505, -2.167924>
    }
    triangle {
      < -6.632964, -1.535863, -2.167923>,
      < -6.632964, -1.551863, -2.167923>,
      < -6.634703, -1.551863, -2.152018>
    }
    triangle {
      < -6.632964, -1.535863, -2.167923>,
      < -6.634703, -1.551863, -2.152018>,
      < -6.634703, -1.535863, -2.152018>
    }
    triangle {
      < -6.598354, -1.417505, -2.484322>,
      < -6.598354, -1.401505, -2.484322>,
      < -6.596615, -1.401505, -2.500227>
    }
    triangle {
      < -6.598354, -1.417505, -2.484322>,
      < -6.596615, -1.401505, -2.500227>,
      < -6.596615, -1.417505, -2.500227>
    }
    triangle {
      < -6.580181, -1.468684, -2.650473>,
      < -6.571311, -1.476684, -2.658426>,
      < -6.580181, -1.484684, -2.650473>
    }
    triangle {
      < -6.596616, -1.535863, -2.500227>,
      < -6.596616, -1.551863, -2.500227>,
      < -6.598355, -1.551863, -2.484322>
    }
    triangle {
      < -6.596616, -1.535863, -2.500227>,
      < -6.598355, -1.551863, -2.484322>,
      < -6.598355, -1.535863, -2.484322>
    }
    triangle {
      < -6.580181, -1.401505, -2.650473>,
      < -6.571311, -1.409505, -2.658426>,
      < -6.580181, -1.417505, -2.650473>
    }
    triangle {
      < -6.571311, -1.543863, -2.658426>,
      < -6.580181, -1.551863, -2.650473>,
      < -6.580181, -1.535863, -2.650473>
    }
    triangle {
      < -6.869224, -1.417505, 0.007953>,
      < -6.869224, -1.401505, 0.007953>,
      < -6.869224, -1.401505, -0.007953>
    }
    triangle {
      < -6.869224, -1.417505, 0.007953>,
      < -6.869224, -1.401505, -0.007953>,
      < -6.869224, -1.417505, -0.007953>
    }
    triangle {
      < -6.869224, -1.535863, -0.007953>,
      < -6.869224, -1.551863, -0.007953>,
      < -6.869224, -1.551863, 0.007953>
    }
    triangle {
      < -6.869224, -1.535863, -0.007953>,
      < -6.869224, -1.551863, 0.007953>,
      < -6.869224, -1.535863, 0.007953>
    }
    triangle {
      < -6.616529, -1.350326, -2.318170>,
      < -6.616529, -1.334326, -2.318170>,
      < -6.614789, -1.334326, -2.334075>
    }
    triangle {
      < -6.616529, -1.350326, -2.318170>,
      < -6.614789, -1.334326, -2.334075>,
      < -6.614789, -1.350326, -2.334075>
    }
    triangle {
      < -6.632962, -1.350326, -2.167924>,
      < -6.634702, -1.350326, -2.152019>,
      < -6.634702, -1.334326, -2.152019>
    }
    triangle {
      < -6.632962, -1.350326, -2.167924>,
      < -6.634702, -1.334326, -2.152019>,
      < -6.632962, -1.334326, -2.167924>
    }
    triangle {
      < -6.616529, -1.283147, -2.318170>,
      < -6.616529, -1.267147, -2.318170>,
      < -6.614789, -1.267147, -2.334075>
    }
    triangle {
      < -6.616529, -1.283147, -2.318170>,
      < -6.614789, -1.267147, -2.334075>,
      < -6.614789, -1.283147, -2.334075>
    }
    triangle {
      < -6.598354, -1.334326, -2.484322>,
      < -6.596615, -1.334326, -2.500227>,
      < -6.596615, -1.350326, -2.500227>
    }
    triangle {
      < -6.598354, -1.334326, -2.484322>,
      < -6.596615, -1.350326, -2.500227>,
      < -6.598354, -1.350326, -2.484322>
    }
    triangle {
      < -6.652875, -1.350326, -1.985867>,
      < -6.652875, -1.334326, -1.985867>,
      < -6.651136, -1.334326, -2.001772>
    }
    triangle {
      < -6.652875, -1.350326, -1.985867>,
      < -6.651136, -1.334326, -2.001772>,
      < -6.651136, -1.350326, -2.001772>
    }
    triangle {
      < -6.669310, -1.350326, -1.835621>,
      < -6.671050, -1.350326, -1.819715>,
      < -6.671050, -1.334326, -1.819715>
    }
    triangle {
      < -6.669310, -1.350326, -1.835621>,
      < -6.671050, -1.334326, -1.819715>,
      < -6.669310, -1.334326, -1.835621>
    }
    triangle {
      < -6.652875, -1.283147, -1.985867>,
      < -6.652875, -1.267147, -1.985867>,
      < -6.651136, -1.267147, -2.001772>
    }
    triangle {
      < -6.652875, -1.283147, -1.985867>,
      < -6.651136, -1.267147, -2.001772>,
      < -6.651136, -1.283147, -2.001772>
    }
    triangle {
      < -6.689224, -1.350326, -1.653564>,
      < -6.689224, -1.334326, -1.653564>,
      < -6.687484, -1.334326, -1.669469>
    }
    triangle {
      < -6.689224, -1.350326, -1.653564>,
      < -6.687484, -1.334326, -1.669469>,
      < -6.687484, -1.350326, -1.669469>
    }
    triangle {
      < -6.705658, -1.350326, -1.503317>,
      < -6.707397, -1.350326, -1.487412>,
      < -6.707397, -1.334326, -1.487412>
    }
    triangle {
      < -6.705658, -1.350326, -1.503317>,
      < -6.707397, -1.334326, -1.487412>,
      < -6.705658, -1.334326, -1.503317>
    }
    triangle {
      < -6.689224, -1.283147, -1.653564>,
      < -6.689224, -1.267147, -1.653564>,
      < -6.687484, -1.267147, -1.669469>
    }
    triangle {
      < -6.689224, -1.283147, -1.653564>,
      < -6.687484, -1.267147, -1.669469>,
      < -6.687484, -1.283147, -1.669469>
    }
    triangle {
      < -6.725572, -1.350326, -1.321260>,
      < -6.725572, -1.334326, -1.321260>,
      < -6.723832, -1.334326, -1.337166>
    }
    triangle {
      < -6.725572, -1.350326, -1.321260>,
      < -6.723832, -1.334326, -1.337166>,
      < -6.723832, -1.350326, -1.337166>
    }
    triangle {
      < -6.742006, -1.350326, -1.171014>,
      < -6.743745, -1.350326, -1.155109>,
      < -6.743745, -1.334326, -1.155109>
    }
    triangle {
      < -6.742006, -1.350326, -1.171014>,
      < -6.743745, -1.334326, -1.155109>,
      < -6.742006, -1.334326, -1.171014>
    }
    triangle {
      < -6.725572, -1.283147, -1.321260>,
      < -6.725572, -1.267147, -1.321260>,
      < -6.723832, -1.267147, -1.337166>
    }
    triangle {
      < -6.725572, -1.283147, -1.321260>,
      < -6.723832, -1.267147, -1.337166>,
      < -6.723832, -1.283147, -1.337166>
    }
    triangle {
      < -6.761919, -1.350326, -0.988957>,
      < -6.761919, -1.334326, -0.988957>,
      < -6.760180, -1.334326, -1.004862>
    }
    triangle {
      < -6.761919, -1.350326, -0.988957>,
      < -6.760180, -1.334326, -1.004862>,
      < -6.760180, -1.350326, -1.004862>
    }
    triangle {
      < -6.778354, -1.350326, -0.838711>,
      < -6.780094, -1.350326, -0.822806>,
      < -6.780094, -1.334326, -0.822806>
    }
    triangle {
      < -6.778354, -1.350326, -0.838711>,
      < -6.780094, -1.334326, -0.822806>,
      < -6.778354, -1.334326, -0.838711>
    }
    triangle {
      < -6.761919, -1.283147, -0.988957>,
      < -6.761919, -1.267147, -0.988957>,
      < -6.760180, -1.267147, -1.004862>
    }
    triangle {
      < -6.761919, -1.283147, -0.988957>,
      < -6.760180, -1.267147, -1.004862>,
      < -6.760180, -1.283147, -1.004862>
    }
    triangle {
      < -6.798267, -1.350326, -0.656654>,
      < -6.798267, -1.334326, -0.656654>,
      < -6.796528, -1.334326, -0.672559>
    }
    triangle {
      < -6.798267, -1.350326, -0.656654>,
      < -6.796528, -1.334326, -0.672559>,
      < -6.796528, -1.350326, -0.672559>
    }
    triangle {
      < -6.814702, -1.350326, -0.506407>,
      < -6.816442, -1.350326, -0.490502>,
      < -6.816442, -1.334326, -0.490502>
    }
    triangle {
      < -6.814702, -1.350326, -0.506407>,
      < -6.816442, -1.334326, -0.490502>,
      < -6.814702, -1.334326, -0.506407>
    }
    triangle {
      < -6.798267, -1.283147, -0.656654>,
      < -6.798267, -1.267147, -0.656654>,
      < -6.796528, -1.267147, -0.672559>
    }
    triangle {
      < -6.798267, -1.283147, -0.656654>,
      < -6.796528, -1.267147, -0.672559>,
      < -6.796528, -1.283147, -0.672559>
    }
    triangle {
      < -6.834615, -1.350326, -0.324351>,
      < -6.834615, -1.334326, -0.324351>,
      < -6.832876, -1.334326, -0.340256>
    }
    triangle {
      < -6.834615, -1.350326, -0.324351>,
      < -6.832876, -1.334326, -0.340256>,
      < -6.832876, -1.350326, -0.340256>
    }
    triangle {
      < -6.851050, -1.350326, -0.174104>,
      < -6.852789, -1.350326, -0.158199>,
      < -6.852789, -1.334326, -0.158199>
    }
    triangle {
      < -6.851050, -1.350326, -0.174104>,
      < -6.852789, -1.334326, -0.158199>,
      < -6.851050, -1.334326, -0.174104>
    }
    triangle {
      < -6.834615, -1.283147, -0.324351>,
      < -6.834615, -1.267147, -0.324351>,
      < -6.832876, -1.267147, -0.340256>
    }
    triangle {
      < -6.834615, -1.283147, -0.324351>,
      < -6.832876, -1.267147, -0.340256>,
      < -6.832876, -1.283147, -0.340256>
    }
    triangle {
      < -6.851051, -1.350326, 0.174104>,
      < -6.851051, -1.334326, 0.174104>,
      < -6.852790, -1.334326, 0.158199>
    }
    triangle {
      < -6.851051, -1.350326, 0.174104>,
      < -6.852790, -1.334326, 0.158199>,
      < -6.852790, -1.350326, 0.158199>
    }
    triangle {
      < -6.834616, -1.350326, 0.324351>,
      < -6.832877, -1.350326, 0.340256>,
      < -6.832877, -1.334326, 0.340256>
    }
    triangle {
      < -6.834616, -1.350326, 0.324351>,
      < -6.832877, -1.334326, 0.340256>,
      < -6.834616, -1.334326, 0.324351>
    }
    triangle {
      < -6.851051, -1.283147, 0.174104>,
      < -6.851051, -1.267147, 0.174104>,
      < -6.852790, -1.267147, 0.158199>
    }
    triangle {
      < -6.851051, -1.283147, 0.174104>,
      < -6.852790, -1.267147, 0.158199>,
      < -6.852790, -1.283147, 0.158199>
    }
    triangle {
      < -6.869224, -1.334326, 0.007953>,
      < -6.869224, -1.334326, -0.007953>,
      < -6.869224, -1.350326, -0.007953>
    }
    triangle {
      < -6.869224, -1.334326, 0.007953>,
      < -6.869224, -1.350326, -0.007953>,
      < -6.869224, -1.350326, 0.007953>
    }
    triangle {
      < -6.814703, -1.350326, 0.506407>,
      < -6.814703, -1.334326, 0.506407>,
      < -6.816443, -1.334326, 0.490502>
    }
    triangle {
      < -6.814703, -1.350326, 0.506407>,
      < -6.816443, -1.334326, 0.490502>,
      < -6.816443, -1.350326, 0.490502>
    }
    triangle {
      < -6.798269, -1.350326, 0.656654>,
      < -6.796529, -1.350326, 0.672559>,
      < -6.796529, -1.334326, 0.672559>
    }
    triangle {
      < -6.798269, -1.350326, 0.656654>,
      < -6.796529, -1.334326, 0.672559>,
      < -6.798269, -1.334326, 0.656654>
    }
    triangle {
      < -6.814703, -1.283147, 0.506407>,
      < -6.814703, -1.267147, 0.506407>,
      < -6.816443, -1.267147, 0.490502>
    }
    triangle {
      < -6.814703, -1.283147, 0.506407>,
      < -6.816443, -1.267147, 0.490502>,
      < -6.816443, -1.283147, 0.490502>
    }
    triangle {
      < -6.778356, -1.350326, 0.838711>,
      < -6.778356, -1.334326, 0.838711>,
      < -6.780095, -1.334326, 0.822806>
    }
    triangle {
      < -6.778356, -1.350326, 0.838711>,
      < -6.780095, -1.334326, 0.822806>,
      < -6.780095, -1.350326, 0.822806>
    }
    triangle {
      < -6.761921, -1.350326, 0.988957>,
      < -6.760181, -1.350326, 1.004862>,
      < -6.760181, -1.334326, 1.004862>
    }
    triangle {
      < -6.761921, -1.350326, 0.988957>,
      < -6.760181, -1.334326, 1.004862>,
      < -6.761921, -1.334326, 0.988957>
    }
    triangle {
      < -6.778356, -1.283147, 0.838711>,
      < -6.778356, -1.267147, 0.838711>,
      < -6.780095, -1.267147, 0.822806>
    }
    triangle {
      < -6.778356, -1.283147, 0.838711>,
      < -6.780095, -1.267147, 0.822806>,
      < -6.780095, -1.283147, 0.822806>
    }
    triangle {
      < -6.742008, -1.350326, 1.171014>,
      < -6.742008, -1.334326, 1.171014>,
      < -6.743747, -1.334326, 1.155109>
    }
    triangle {
      < -6.742008, -1.350326, 1.171014>,
      < -6.743747, -1.334326, 1.155109>,
      < -6.743747, -1.350326, 1.155109>
    }
    triangle {
      < -6.725573, -1.350326, 1.321261>,
      < -6.723834, -1.350326, 1.337166>,
      < -6.723834, -1.334326, 1.337166>
    }
    triangle {
      < -6.725573, -1.350326, 1.321261>,
      < -6.723834, -1.334326, 1.337166>,
      < -6.725573, -1.334326, 1.321261>
    }
    triangle {
      < -6.742008, -1.283147, 1.171014>,
      < -6.742008, -1.267147, 1.171014>,
      < -6.743747, -1.267147, 1.155109>
    }
    triangle {
      < -6.742008, -1.283147, 1.171014>,
      < -6.743747, -1.267147, 1.155109>,
      < -6.743747, -1.283147, 1.155109>
    }
    triangle {
      < -6.705659, -1.350326, 1.503317>,
      < -6.705659, -1.334326, 1.503317>,
      < -6.707399, -1.334326, 1.487412>
    }
    triangle {
      < -6.705659, -1.350326, 1.503317>,
      < -6.707399, -1.334326, 1.487412>,
      < -6.707399, -1.350326, 1.487412>
    }
    triangle {
      < -6.689225, -1.350326, 1.653563>,
      < -6.687486, -1.350326, 1.669469>,
      < -6.687486, -1.334326, 1.669469>
    }
    triangle {
      < -6.689225, -1.350326, 1.653563>,
      < -6.687486, -1.334326, 1.669469>,
      < -6.689225, -1.334326, 1.653563>
    }
    triangle {
      < -6.705659, -1.283147, 1.503317>,
      < -6.705659, -1.267147, 1.503317>,
      < -6.707399, -1.267147, 1.487412>
    }
    triangle {
      < -6.705659, -1.283147, 1.503317>,
      < -6.707399, -1.267147, 1.487412>,
      < -6.707399, -1.283147, 1.487412>
    }
    triangle {
      < -6.669312, -1.350326, 1.835620>,
      < -6.669312, -1.334326, 1.835620>,
      < -6.671051, -1.334326, 1.819715>
    }
    triangle {
      < -6.669312, -1.350326, 1.835620>,
      < -6.671051, -1.334326, 1.819715>,
      < -6.671051, -1.350326, 1.819715>
    }
    triangle {
      < -6.652877, -1.350326, 1.985867>,
      < -6.651138, -1.350326, 2.001772>,
      < -6.651138, -1.334326, 2.001772>
    }
    triangle {
      < -6.652877, -1.350326, 1.985867>,
      < -6.651138, -1.334326, 2.001772>,
      < -6.652877, -1.334326, 1.985867>
    }
    triangle {
      < -6.669312, -1.283147, 1.835620>,
      < -6.669312, -1.267147, 1.835620>,
      < -6.671051, -1.267147, 1.819715>
    }
    triangle {
      < -6.669312, -1.283147, 1.835620>,
      < -6.671051, -1.267147, 1.819715>,
      < -6.671051, -1.283147, 1.819715>
    }
    triangle {
      < -6.632964, -1.350326, 2.167924>,
      < -6.632964, -1.334326, 2.167924>,
      < -6.634703, -1.334326, 2.152019>
    }
    triangle {
      < -6.632964, -1.350326, 2.167924>,
      < -6.634703, -1.334326, 2.152019>,
      < -6.634703, -1.350326, 2.152019>
    }
    triangle {
      < -6.616529, -1.350326, 2.318170>,
      < -6.614789, -1.350326, 2.334075>,
      < -6.614789, -1.334326, 2.334075>
    }
    triangle {
      < -6.616529, -1.350326, 2.318170>,
      < -6.614789, -1.334326, 2.334075>,
      < -6.616529, -1.334326, 2.318170>
    }
    triangle {
      < -6.632964, -1.283147, 2.167924>,
      < -6.632964, -1.267147, 2.167924>,
      < -6.634703, -1.267147, 2.152019>
    }
    triangle {
      < -6.632964, -1.283147, 2.167924>,
      < -6.634703, -1.267147, 2.152019>,
      < -6.634703, -1.283147, 2.152019>
    }
    triangle {
      < -6.596616, -1.350326, 2.500227>,
      < -6.596616, -1.334326, 2.500227>,
      < -6.598355, -1.334326, 2.484322>
    }
    triangle {
      < -6.596616, -1.350326, 2.500227>,
      < -6.598355, -1.334326, 2.484322>,
      < -6.598355, -1.350326, 2.484322>
    }
    triangle {
      < -6.580181, -1.350326, 2.650474>,
      < -6.571311, -1.342326, 2.658426>,
      < -6.580181, -1.334326, 2.650474>
    }
    triangle {
      < -6.596616, -1.283147, 2.500227>,
      < -6.596616, -1.267147, 2.500227>,
      < -6.598355, -1.267147, 2.484322>
    }
    triangle {
      < -6.596616, -1.283147, 2.500227>,
      < -6.598355, -1.267147, 2.484322>,
      < -6.598355, -1.283147, 2.484322>
    }
    triangle {
      < -6.614789, -1.283147, 2.334075>,
      < -6.614789, -1.267147, 2.334075>,
      < -6.616529, -1.267147, 2.318170>
    }
    triangle {
      < -6.614789, -1.283147, 2.334075>,
      < -6.616529, -1.267147, 2.318170>,
      < -6.616529, -1.283147, 2.318170>
    }
    triangle {
      < -6.651138, -1.283147, 2.001772>,
      < -6.651138, -1.267147, 2.001772>,
      < -6.652877, -1.267147, 1.985867>
    }
    triangle {
      < -6.651138, -1.283147, 2.001772>,
      < -6.652877, -1.267147, 1.985867>,
      < -6.652877, -1.283147, 1.985867>
    }
    triangle {
      < -6.687486, -1.283147, 1.669469>,
      < -6.687486, -1.267147, 1.669469>,
      < -6.689225, -1.267147, 1.653563>
    }
    triangle {
      < -6.687486, -1.283147, 1.669469>,
      < -6.689225, -1.267147, 1.653563>,
      < -6.689225, -1.283147, 1.653563>
    }
    triangle {
      < -6.723834, -1.283147, 1.337166>,
      < -6.723834, -1.267147, 1.337166>,
      < -6.725573, -1.267147, 1.321261>
    }
    triangle {
      < -6.723834, -1.283147, 1.337166>,
      < -6.725573, -1.267147, 1.321261>,
      < -6.725573, -1.283147, 1.321261>
    }
    triangle {
      < -6.760181, -1.283147, 1.004862>,
      < -6.760181, -1.267147, 1.004862>,
      < -6.761921, -1.267147, 0.988957>
    }
    triangle {
      < -6.760181, -1.283147, 1.004862>,
      < -6.761921, -1.267147, 0.988957>,
      < -6.761921, -1.283147, 0.988957>
    }
    triangle {
      < -6.796529, -1.283147, 0.672559>,
      < -6.796529, -1.267147, 0.672559>,
      < -6.798269, -1.267147, 0.656654>
    }
    triangle {
      < -6.796529, -1.283147, 0.672559>,
      < -6.798269, -1.267147, 0.656654>,
      < -6.798269, -1.283147, 0.656654>
    }
    triangle {
      < -6.832877, -1.283147, 0.340256>,
      < -6.832877, -1.267147, 0.340256>,
      < -6.834616, -1.267147, 0.324351>
    }
    triangle {
      < -6.832877, -1.283147, 0.340256>,
      < -6.834616, -1.267147, 0.324351>,
      < -6.834616, -1.283147, 0.324351>
    }
    triangle {
      < -6.852789, -1.283147, -0.158199>,
      < -6.852789, -1.267147, -0.158199>,
      < -6.851050, -1.267147, -0.174104>
    }
    triangle {
      < -6.852789, -1.283147, -0.158199>,
      < -6.851050, -1.267147, -0.174104>,
      < -6.851050, -1.283147, -0.174104>
    }
    triangle {
      < -6.816442, -1.283147, -0.490502>,
      < -6.816442, -1.267147, -0.490502>,
      < -6.814702, -1.267147, -0.506407>
    }
    triangle {
      < -6.816442, -1.283147, -0.490502>,
      < -6.814702, -1.267147, -0.506407>,
      < -6.814702, -1.283147, -0.506407>
    }
    triangle {
      < -6.780094, -1.283147, -0.822806>,
      < -6.780094, -1.267147, -0.822806>,
      < -6.778354, -1.267147, -0.838711>
    }
    triangle {
      < -6.780094, -1.283147, -0.822806>,
      < -6.778354, -1.267147, -0.838711>,
      < -6.778354, -1.283147, -0.838711>
    }
    triangle {
      < -6.743745, -1.283147, -1.155109>,
      < -6.743745, -1.267147, -1.155109>,
      < -6.742006, -1.267147, -1.171014>
    }
    triangle {
      < -6.743745, -1.283147, -1.155109>,
      < -6.742006, -1.267147, -1.171014>,
      < -6.742006, -1.283147, -1.171014>
    }
    triangle {
      < -6.707397, -1.283147, -1.487412>,
      < -6.707397, -1.267147, -1.487412>,
      < -6.705658, -1.267147, -1.503317>
    }
    triangle {
      < -6.707397, -1.283147, -1.487412>,
      < -6.705658, -1.267147, -1.503317>,
      < -6.705658, -1.283147, -1.503317>
    }
    triangle {
      < -6.671050, -1.283147, -1.819715>,
      < -6.671050, -1.267147, -1.819715>,
      < -6.669310, -1.267147, -1.835621>
    }
    triangle {
      < -6.671050, -1.283147, -1.819715>,
      < -6.669310, -1.267147, -1.835621>,
      < -6.669310, -1.283147, -1.835621>
    }
    triangle {
      < -6.634702, -1.283147, -2.152019>,
      < -6.634702, -1.267147, -2.152019>,
      < -6.632962, -1.267147, -2.167924>
    }
    triangle {
      < -6.634702, -1.283147, -2.152019>,
      < -6.632962, -1.267147, -2.167924>,
      < -6.632962, -1.283147, -2.167924>
    }
    triangle {
      < -6.598354, -1.283147, -2.484322>,
      < -6.598354, -1.267147, -2.484322>,
      < -6.596615, -1.267147, -2.500227>
    }
    triangle {
      < -6.598354, -1.283147, -2.484322>,
      < -6.596615, -1.267147, -2.500227>,
      < -6.596615, -1.283147, -2.500227>
    }
    triangle {
      < -6.580181, -1.334326, -2.650473>,
      < -6.571311, -1.342326, -2.658426>,
      < -6.580181, -1.350326, -2.650473>
    }
    triangle {
      < -6.580181, -1.267147, -2.650473>,
      < -6.571311, -1.275147, -2.658426>,
      < -6.580181, -1.283147, -2.650473>
    }
    triangle {
      < -6.869224, -1.283147, 0.007953>,
      < -6.869224, -1.267147, 0.007953>,
      < -6.869224, -1.267147, -0.007953>
    }
    triangle {
      < -6.869224, -1.283147, 0.007953>,
      < -6.869224, -1.267147, -0.007953>,
      < -6.869224, -1.283147, -0.007953>
    }
    triangle {
      < -6.869224, -1.603042, -0.007953>,
      < -6.862093, -1.611042, 0.000000>,
      < -6.869224, -1.603042, 0.007953>
    }
    triangle {
      < -6.596616, -1.603042, -2.500227>,
      < -6.589485, -1.611042, -2.492274>,
      < -6.598355, -1.603042, -2.484322>
    }
    triangle {
      < -6.632964, -1.603042, -2.167923>,
      < -6.625833, -1.611042, -2.159971>,
      < -6.634703, -1.603042, -2.152018>
    }
    triangle {
      < -6.669312, -1.603042, -1.835620>,
      < -6.662181, -1.611042, -1.827667>,
      < -6.671051, -1.603042, -1.819715>
    }
    triangle {
      < -6.705659, -1.603042, -1.503317>,
      < -6.698529, -1.611042, -1.495364>,
      < -6.707399, -1.603042, -1.487412>
    }
    triangle {
      < -6.742008, -1.603042, -1.171014>,
      < -6.734877, -1.611042, -1.163061>,
      < -6.743747, -1.603042, -1.155109>
    }
    triangle {
      < -6.778356, -1.603042, -0.838710>,
      < -6.771225, -1.611042, -0.830758>,
      < -6.780095, -1.603042, -0.822805>
    }
    triangle {
      < -6.814703, -1.603042, -0.506407>,
      < -6.807573, -1.611042, -0.498455>,
      < -6.816443, -1.603042, -0.490502>
    }
    triangle {
      < -6.851051, -1.603042, -0.174104>,
      < -6.843920, -1.611042, -0.166151>,
      < -6.852790, -1.603042, -0.158199>
    }
    triangle {
      < -6.834615, -1.603042, 0.324351>,
      < -6.825746, -1.611042, 0.332303>,
      < -6.832876, -1.603042, 0.340256>
    }
    triangle {
      < -6.798267, -1.603042, 0.656654>,
      < -6.789398, -1.611042, 0.664607>,
      < -6.796528, -1.603042, 0.672559>
    }
    triangle {
      < -6.761919, -1.603042, 0.988958>,
      < -6.753049, -1.611042, 0.996910>,
      < -6.760180, -1.603042, 1.004863>
    }
    triangle {
      < -6.725572, -1.603042, 1.321261>,
      < -6.716702, -1.611042, 1.329213>,
      < -6.723832, -1.603042, 1.337166>
    }
    triangle {
      < -6.689224, -1.603042, 1.653564>,
      < -6.680354, -1.611042, 1.661516>,
      < -6.687484, -1.603042, 1.669469>
    }
    triangle {
      < -6.652875, -1.603042, 1.985867>,
      < -6.644006, -1.611042, 1.993820>,
      < -6.651136, -1.603042, 2.001772>
    }
    triangle {
      < -6.616529, -1.603042, 2.318171>,
      < -6.607658, -1.611042, 2.326123>,
      < -6.614789, -1.603042, 2.334076>
    }
    triangle {
      < -6.598354, -1.603042, 2.484322>,
      < -6.589485, -1.611042, 2.492275>,
      < -6.596615, -1.603042, 2.500227>
    }
    triangle {
      < -6.580181, -1.551863, 2.650474>,
      < -6.571311, -1.543863, 2.658426>,
      < -6.580181, -1.535863, 2.650474>
    }
    triangle {
      < -6.634702, -1.603042, 2.152019>,
      < -6.625833, -1.611042, 2.159971>,
      < -6.632963, -1.603042, 2.167924>
    }
    triangle {
      < -6.671050, -1.603042, 1.819715>,
      < -6.662179, -1.611042, 1.827668>,
      < -6.669310, -1.603042, 1.835621>
    }
    triangle {
      < -6.707397, -1.603042, 1.487412>,
      < -6.698528, -1.611042, 1.495365>,
      < -6.705658, -1.603042, 1.503318>
    }
    triangle {
      < -6.743745, -1.603042, 1.155109>,
      < -6.734876, -1.611042, 1.163062>,
      < -6.742006, -1.603042, 1.171014>
    }
    triangle {
      < -6.780094, -1.603042, 0.822806>,
      < -6.771224, -1.611042, 0.830759>,
      < -6.778354, -1.603042, 0.838711>
    }
    triangle {
      < -6.816442, -1.603042, 0.490503>,
      < -6.807571, -1.611042, 0.498455>,
      < -6.814702, -1.603042, 0.506408>
    }
    triangle {
      < -6.852789, -1.603042, 0.158199>,
      < -6.843919, -1.611042, 0.166152>,
      < -6.851050, -1.603042, 0.174104>
    }
    triangle {
      < -6.832877, -1.603042, -0.340256>,
      < -6.825746, -1.611042, -0.332303>,
      < -6.834616, -1.603042, -0.324351>
    }
    triangle {
      < -6.796529, -1.603042, -0.672559>,
      < -6.789399, -1.611042, -0.664606>,
      < -6.798269, -1.603042, -0.656654>
    }
    triangle {
      < -6.760181, -1.603042, -1.004862>,
      < -6.753051, -1.611042, -0.996910>,
      < -6.761921, -1.603042, -0.988957>
    }
    triangle {
      < -6.723834, -1.603042, -1.337165>,
      < -6.716703, -1.611042, -1.329213>,
      < -6.725573, -1.603042, -1.321260>
    }
    triangle {
      < -6.687486, -1.603042, -1.669468>,
      < -6.680355, -1.611042, -1.661516>,
      < -6.689225, -1.603042, -1.653563>
    }
    triangle {
      < -6.651138, -1.603042, -2.001772>,
      < -6.644007, -1.611042, -1.993819>,
      < -6.652877, -1.603042, -1.985867>
    }
    triangle {
      < -6.614789, -1.603042, -2.334075>,
      < -6.607659, -1.611042, -2.326122>,
      < -6.616529, -1.603042, -2.318170>
    }
    triangle {
      < -6.580181, -1.417505, 2.650474>,
      < -6.571311, -1.409505, 2.658426>,
      < -6.580181, -1.401505, 2.650474>
    }
    triangle {
      < -6.869224, -1.215968, 0.007953>,
      < -6.869224, -1.199968, 0.007953>,
      < -6.869224, -1.199968, -0.007953>
    }
    triangle {
      < -6.869224, -1.215968, 0.007953>,
      < -6.869224, -1.199968, -0.007953>,
      < -6.869224, -1.215968, -0.007953>
    }
    triangle {
      < -6.580181, -1.199968, -2.650473>,
      < -6.571311, -1.207968, -2.658426>,
      < -6.580181, -1.215968, -2.650473>
    }
    triangle {
      < -6.598354, -1.215968, -2.484322>,
      < -6.598354, -1.199968, -2.484322>,
      < -6.596615, -1.199968, -2.500227>
    }
    triangle {
      < -6.598354, -1.215968, -2.484322>,
      < -6.596615, -1.199968, -2.500227>,
      < -6.596615, -1.215968, -2.500227>
    }
    triangle {
      < -6.634702, -1.215968, -2.152019>,
      < -6.634702, -1.199968, -2.152019>,
      < -6.632962, -1.199968, -2.167924>
    }
    triangle {
      < -6.634702, -1.215968, -2.152019>,
      < -6.632962, -1.199968, -2.167924>,
      < -6.632962, -1.215968, -2.167924>
    }
    triangle {
      < -6.671050, -1.215968, -1.819715>,
      < -6.671050, -1.199968, -1.819715>,
      < -6.669310, -1.199968, -1.835621>
    }
    triangle {
      < -6.671050, -1.215968, -1.819715>,
      < -6.669310, -1.199968, -1.835621>,
      < -6.669310, -1.215968, -1.835621>
    }
    triangle {
      < -6.707397, -1.215968, -1.487412>,
      < -6.707397, -1.199968, -1.487412>,
      < -6.705658, -1.199968, -1.503317>
    }
    triangle {
      < -6.707397, -1.215968, -1.487412>,
      < -6.705658, -1.199968, -1.503317>,
      < -6.705658, -1.215968, -1.503317>
    }
    triangle {
      < -6.743745, -1.215968, -1.155109>,
      < -6.743745, -1.199968, -1.155109>,
      < -6.742006, -1.199968, -1.171014>
    }
    triangle {
      < -6.743745, -1.215968, -1.155109>,
      < -6.742006, -1.199968, -1.171014>,
      < -6.742006, -1.215968, -1.171014>
    }
    triangle {
      < -6.780094, -1.215968, -0.822806>,
      < -6.780094, -1.199968, -0.822806>,
      < -6.778354, -1.199968, -0.838711>
    }
    triangle {
      < -6.780094, -1.215968, -0.822806>,
      < -6.778354, -1.199968, -0.838711>,
      < -6.778354, -1.215968, -0.838711>
    }
    triangle {
      < -6.816442, -1.215968, -0.490502>,
      < -6.816442, -1.199968, -0.490502>,
      < -6.814702, -1.199968, -0.506407>
    }
    triangle {
      < -6.816442, -1.215968, -0.490502>,
      < -6.814702, -1.199968, -0.506407>,
      < -6.814702, -1.215968, -0.506407>
    }
    triangle {
      < -6.852789, -1.215968, -0.158199>,
      < -6.852789, -1.199968, -0.158199>,
      < -6.851050, -1.199968, -0.174104>
    }
    triangle {
      < -6.852789, -1.215968, -0.158199>,
      < -6.851050, -1.199968, -0.174104>,
      < -6.851050, -1.215968, -0.174104>
    }
    triangle {
      < -6.832877, -1.215968, 0.340256>,
      < -6.832877, -1.199968, 0.340256>,
      < -6.834616, -1.199968, 0.324351>
    }
    triangle {
      < -6.832877, -1.215968, 0.340256>,
      < -6.834616, -1.199968, 0.324351>,
      < -6.834616, -1.215968, 0.324351>
    }
    triangle {
      < -6.796529, -1.215968, 0.672559>,
      < -6.796529, -1.199968, 0.672559>,
      < -6.798269, -1.199968, 0.656654>
    }
    triangle {
      < -6.796529, -1.215968, 0.672559>,
      < -6.798269, -1.199968, 0.656654>,
      < -6.798269, -1.215968, 0.656654>
    }
    triangle {
      < -6.760181, -1.215968, 1.004862>,
      < -6.760181, -1.199968, 1.004862>,
      < -6.761921, -1.199968, 0.988957>
    }
    triangle {
      < -6.760181, -1.215968, 1.004862>,
      < -6.761921, -1.199968, 0.988957>,
      < -6.761921, -1.215968, 0.988957>
    }
    triangle {
      < -6.723834, -1.215968, 1.337166>,
      < -6.723834, -1.199968, 1.337166>,
      < -6.725573, -1.199968, 1.321261>
    }
    triangle {
      < -6.723834, -1.215968, 1.337166>,
      < -6.725573, -1.199968, 1.321261>,
      < -6.725573, -1.215968, 1.321261>
    }
    triangle {
      < -6.687486, -1.215968, 1.669469>,
      < -6.687486, -1.199968, 1.669469>,
      < -6.689225, -1.199968, 1.653563>
    }
    triangle {
      < -6.687486, -1.215968, 1.669469>,
      < -6.689225, -1.199968, 1.653563>,
      < -6.689225, -1.215968, 1.653563>
    }
    triangle {
      < -6.651138, -1.215968, 2.001772>,
      < -6.651138, -1.199968, 2.001772>,
      < -6.652877, -1.199968, 1.985867>
    }
    triangle {
      < -6.651138, -1.215968, 2.001772>,
      < -6.652877, -1.199968, 1.985867>,
      < -6.652877, -1.215968, 1.985867>
    }
    triangle {
      < -6.614789, -1.215968, 2.334075>,
      < -6.614789, -1.199968, 2.334075>,
      < -6.616529, -1.199968, 2.318170>
    }
    triangle {
      < -6.614789, -1.215968, 2.334075>,
      < -6.616529, -1.199968, 2.318170>,
      < -6.616529, -1.215968, 2.318170>
    }
    triangle {
      < -6.580181, -1.283147, 2.650474>,
      < -6.571311, -1.275147, 2.658426>,
      < -6.580181, -1.267147, 2.650474>
    }
    triangle {
      < -6.596616, -1.215968, 2.500227>,
      < -6.596616, -1.199968, 2.500227>,
      < -6.598355, -1.199968, 2.484322>
    }
    triangle {
      < -6.596616, -1.215968, 2.500227>,
      < -6.598355, -1.199968, 2.484322>,
      < -6.598355, -1.215968, 2.484322>
    }
    triangle {
      < -6.632964, -1.215968, 2.167924>,
      < -6.632964, -1.199968, 2.167924>,
      < -6.634703, -1.199968, 2.152019>
    }
    triangle {
      < -6.632964, -1.215968, 2.167924>,
      < -6.634703, -1.199968, 2.152019>,
      < -6.634703, -1.215968, 2.152019>
    }
    triangle {
      < -6.669312, -1.215968, 1.835620>,
      < -6.669312, -1.199968, 1.835620>,
      < -6.671051, -1.199968, 1.819715>
    }
    triangle {
      < -6.669312, -1.215968, 1.835620>,
      < -6.671051, -1.199968, 1.819715>,
      < -6.671051, -1.215968, 1.819715>
    }
    triangle {
      < -6.705659, -1.215968, 1.503317>,
      < -6.705659, -1.199968, 1.503317>,
      < -6.707399, -1.199968, 1.487412>
    }
    triangle {
      < -6.705659, -1.215968, 1.503317>,
      < -6.707399, -1.199968, 1.487412>,
      < -6.707399, -1.215968, 1.487412>
    }
    triangle {
      < -6.742008, -1.215968, 1.171014>,
      < -6.742008, -1.199968, 1.171014>,
      < -6.743747, -1.199968, 1.155109>
    }
    triangle {
      < -6.742008, -1.215968, 1.171014>,
      < -6.743747, -1.199968, 1.155109>,
      < -6.743747, -1.215968, 1.155109>
    }
    triangle {
      < -6.778356, -1.215968, 0.838711>,
      < -6.778356, -1.199968, 0.838711>,
      < -6.780095, -1.199968, 0.822806>
    }
    triangle {
      < -6.778356, -1.215968, 0.838711>,
      < -6.780095, -1.199968, 0.822806>,
      < -6.780095, -1.215968, 0.822806>
    }
    triangle {
      < -6.814703, -1.215968, 0.506407>,
      < -6.814703, -1.199968, 0.506407>,
      < -6.816443, -1.199968, 0.490502>
    }
    triangle {
      < -6.814703, -1.215968, 0.506407>,
      < -6.816443, -1.199968, 0.490502>,
      < -6.816443, -1.215968, 0.490502>
    }
    triangle {
      < -6.851051, -1.215968, 0.174104>,
      < -6.851051, -1.199968, 0.174104>,
      < -6.852790, -1.199968, 0.158199>
    }
    triangle {
      < -6.851051, -1.215968, 0.174104>,
      < -6.852790, -1.199968, 0.158199>,
      < -6.852790, -1.215968, 0.158199>
    }
    triangle {
      < -6.834615, -1.215968, -0.324351>,
      < -6.834615, -1.199968, -0.324351>,
      < -6.832876, -1.199968, -0.340256>
    }
    triangle {
      < -6.834615, -1.215968, -0.324351>,
      < -6.832876, -1.199968, -0.340256>,
      < -6.832876, -1.215968, -0.340256>
    }
    triangle {
      < -6.798267, -1.215968, -0.656654>,
      < -6.798267, -1.199968, -0.656654>,
      < -6.796528, -1.199968, -0.672559>
    }
    triangle {
      < -6.798267, -1.215968, -0.656654>,
      < -6.796528, -1.199968, -0.672559>,
      < -6.796528, -1.215968, -0.672559>
    }
    triangle {
      < -6.761919, -1.215968, -0.988957>,
      < -6.761919, -1.199968, -0.988957>,
      < -6.760180, -1.199968, -1.004862>
    }
    triangle {
      < -6.761919, -1.215968, -0.988957>,
      < -6.760180, -1.199968, -1.004862>,
      < -6.760180, -1.215968, -1.004862>
    }
    triangle {
      < -6.725572, -1.215968, -1.321260>,
      < -6.725572, -1.199968, -1.321260>,
      < -6.723832, -1.199968, -1.337166>
    }
    triangle {
      < -6.725572, -1.215968, -1.321260>,
      < -6.723832, -1.199968, -1.337166>,
      < -6.723832, -1.215968, -1.337166>
    }
    triangle {
      < -6.689224, -1.215968, -1.653564>,
      < -6.689224, -1.199968, -1.653564>,
      < -6.687484, -1.199968, -1.669469>
    }
    triangle {
      < -6.689224, -1.215968, -1.653564>,
      < -6.687484, -1.199968, -1.669469>,
      < -6.687484, -1.215968, -1.669469>
    }
    triangle {
      < -6.652875, -1.215968, -1.985867>,
      < -6.652875, -1.199968, -1.985867>,
      < -6.651136, -1.199968, -2.001772>
    }
    triangle {
      < -6.652875, -1.215968, -1.985867>,
      < -6.651136, -1.199968, -2.001772>,
      < -6.651136, -1.215968, -2.001772>
    }
    triangle {
      < -6.616529, -1.215968, -2.318170>,
      < -6.616529, -1.199968, -2.318170>,
      < -6.614789, -1.199968, -2.334075>
    }
    triangle {
      < -6.616529, -1.215968, -2.318170>,
      < -6.614789, -1.199968, -2.334075>,
      < -6.614789, -1.215968, -2.334075>
    }
    triangle {
      < -6.869224, -1.148789, 0.007953>,
      < -6.869224, -1.132789, 0.007953>,
      < -6.869224, -1.132789, -0.007953>
    }
    triangle {
      < -6.869224, -1.148789, 0.007953>,
      < -6.869224, -1.132789, -0.007953>,
      < -6.869224, -1.148789, -0.007953>
    }
    triangle {
      < -6.580181, -1.132789, -2.650473>,
      < -6.571311, -1.140788, -2.658426>,
      < -6.580181, -1.148789, -2.650473>
    }
    triangle {
      < -6.598354, -1.148789, -2.484322>,
      < -6.598354, -1.132789, -2.484322>,
      < -6.596615, -1.132789, -2.500227>
    }
    triangle {
      < -6.598354, -1.148789, -2.484322>,
      < -6.596615, -1.132789, -2.500227>,
      < -6.596615, -1.148789, -2.500227>
    }
    triangle {
      < -6.634702, -1.148789, -2.152019>,
      < -6.634702, -1.132789, -2.152019>,
      < -6.632962, -1.132789, -2.167924>
    }
    triangle {
      < -6.634702, -1.148789, -2.152019>,
      < -6.632962, -1.132789, -2.167924>,
      < -6.632962, -1.148789, -2.167924>
    }
    triangle {
      < -6.671050, -1.148789, -1.819715>,
      < -6.671050, -1.132789, -1.819715>,
      < -6.669310, -1.132789, -1.835621>
    }
    triangle {
      < -6.671050, -1.148789, -1.819715>,
      < -6.669310, -1.132789, -1.835621>,
      < -6.669310, -1.148789, -1.835621>
    }
    triangle {
      < -6.707397, -1.148789, -1.487412>,
      < -6.707397, -1.132789, -1.487412>,
      < -6.705658, -1.132789, -1.503317>
    }
    triangle {
      < -6.707397, -1.148789, -1.487412>,
      < -6.705658, -1.132789, -1.503317>,
      < -6.705658, -1.148789, -1.503317>
    }
    triangle {
      < -6.743745, -1.148789, -1.155109>,
      < -6.743745, -1.132789, -1.155109>,
      < -6.742006, -1.132789, -1.171014>
    }
    triangle {
      < -6.743745, -1.148789, -1.155109>,
      < -6.742006, -1.132789, -1.171014>,
      < -6.742006, -1.148789, -1.171014>
    }
    triangle {
      < -6.780094, -1.148789, -0.822806>,
      < -6.780094, -1.132789, -0.822806>,
      < -6.778354, -1.132789, -0.838711>
    }
    triangle {
      < -6.780094, -1.148789, -0.822806>,
      < -6.778354, -1.132789, -0.838711>,
      < -6.778354, -1.148789, -0.838711>
    }
    triangle {
      < -6.816442, -1.148789, -0.490502>,
      < -6.816442, -1.132789, -0.490502>,
      < -6.814702, -1.132789, -0.506407>
    }
    triangle {
      < -6.816442, -1.148789, -0.490502>,
      < -6.814702, -1.132789, -0.506407>,
      < -6.814702, -1.148789, -0.506407>
    }
    triangle {
      < -6.852789, -1.148789, -0.158199>,
      < -6.852789, -1.132789, -0.158199>,
      < -6.851050, -1.132789, -0.174104>
    }
    triangle {
      < -6.852789, -1.148789, -0.158199>,
      < -6.851050, -1.132789, -0.174104>,
      < -6.851050, -1.148789, -0.174104>
    }
    triangle {
      < -6.832877, -1.148789, 0.340256>,
      < -6.832877, -1.132789, 0.340256>,
      < -6.834616, -1.132789, 0.324351>
    }
    triangle {
      < -6.832877, -1.148789, 0.340256>,
      < -6.834616, -1.132789, 0.324351>,
      < -6.834616, -1.148789, 0.324351>
    }
    triangle {
      < -6.796529, -1.148789, 0.672559>,
      < -6.796529, -1.132789, 0.672559>,
      < -6.798269, -1.132789, 0.656654>
    }
    triangle {
      < -6.796529, -1.148789, 0.672559>,
      < -6.798269, -1.132789, 0.656654>,
      < -6.798269, -1.148789, 0.656654>
    }
    triangle {
      < -6.760181, -1.148789, 1.004862>,
      < -6.760181, -1.132789, 1.004862>,
      < -6.761921, -1.132789, 0.988957>
    }
    triangle {
      < -6.760181, -1.148789, 1.004862>,
      < -6.761921, -1.132789, 0.988957>,
      < -6.761921, -1.148789, 0.988957>
    }
    triangle {
      < -6.723834, -1.148789, 1.337166>,
      < -6.723834, -1.132789, 1.337166>,
      < -6.725573, -1.132789, 1.321261>
    }
    triangle {
      < -6.723834, -1.148789, 1.337166>,
      < -6.725573, -1.132789, 1.321261>,
      < -6.725573, -1.148789, 1.321261>
    }
    triangle {
      < -6.687486, -1.148789, 1.669469>,
      < -6.687486, -1.132789, 1.669469>,
      < -6.689225, -1.132789, 1.653563>
    }
    triangle {
      < -6.687486, -1.148789, 1.669469>,
      < -6.689225, -1.132789, 1.653563>,
      < -6.689225, -1.148789, 1.653563>
    }
    triangle {
      < -6.651138, -1.148789, 2.001772>,
      < -6.651138, -1.132789, 2.001772>,
      < -6.652877, -1.132789, 1.985867>
    }
    triangle {
      < -6.651138, -1.148789, 2.001772>,
      < -6.652877, -1.132789, 1.985867>,
      < -6.652877, -1.148789, 1.985867>
    }
    triangle {
      < -6.614789, -1.148789, 2.334075>,
      < -6.614789, -1.132789, 2.334075>,
      < -6.616529, -1.132789, 2.318170>
    }
    triangle {
      < -6.614789, -1.148789, 2.334075>,
      < -6.616529, -1.132789, 2.318170>,
      < -6.616529, -1.148789, 2.318170>
    }
    triangle {
      < -6.616529, -1.148789, -2.318170>,
      < -6.616529, -1.132789, -2.318170>,
      < -6.614789, -1.132789, -2.334075>
    }
    triangle {
      < -6.616529, -1.148789, -2.318170>,
      < -6.614789, -1.132789, -2.334075>,
      < -6.614789, -1.148789, -2.334075>
    }
    triangle {
      < -6.652875, -1.148789, -1.985867>,
      < -6.652875, -1.132789, -1.985867>,
      < -6.651136, -1.132789, -2.001772>
    }
    triangle {
      < -6.652875, -1.148789, -1.985867>,
      < -6.651136, -1.132789, -2.001772>,
      < -6.651136, -1.148789, -2.001772>
    }
    triangle {
      < -6.689224, -1.148789, -1.653564>,
      < -6.689224, -1.132789, -1.653564>,
      < -6.687484, -1.132789, -1.669469>
    }
    triangle {
      < -6.689224, -1.148789, -1.653564>,
      < -6.687484, -1.132789, -1.669469>,
      < -6.687484, -1.148789, -1.669469>
    }
    triangle {
      < -6.725572, -1.148789, -1.321260>,
      < -6.725572, -1.132789, -1.321260>,
      < -6.723832, -1.132789, -1.337166>
    }
    triangle {
      < -6.725572, -1.148789, -1.321260>,
      < -6.723832, -1.132789, -1.337166>,
      < -6.723832, -1.148789, -1.337166>
    }
    triangle {
      < -6.761919, -1.148789, -0.988957>,
      < -6.761919, -1.132789, -0.988957>,
      < -6.760180, -1.132789, -1.004862>
    }
    triangle {
      < -6.761919, -1.148789, -0.988957>,
      < -6.760180, -1.132789, -1.004862>,
      < -6.760180, -1.148789, -1.004862>
    }
    triangle {
      < -6.798267, -1.148789, -0.656654>,
      < -6.798267, -1.132789, -0.656654>,
      < -6.796528, -1.132789, -0.672559>
    }
    triangle {
      < -6.798267, -1.148789, -0.656654>,
      < -6.796528, -1.132789, -0.672559>,
      < -6.796528, -1.148789, -0.672559>
    }
    triangle {
      < -6.834615, -1.148789, -0.324351>,
      < -6.834615, -1.132789, -0.324351>,
      < -6.832876, -1.132789, -0.340256>
    }
    triangle {
      < -6.834615, -1.148789, -0.324351>,
      < -6.832876, -1.132789, -0.340256>,
      < -6.832876, -1.148789, -0.340256>
    }
    triangle {
      < -6.851051, -1.148789, 0.174104>,
      < -6.851051, -1.132789, 0.174104>,
      < -6.852790, -1.132789, 0.158199>
    }
    triangle {
      < -6.851051, -1.148789, 0.174104>,
      < -6.852790, -1.132789, 0.158199>,
      < -6.852790, -1.148789, 0.158199>
    }
    triangle {
      < -6.814703, -1.148789, 0.506407>,
      < -6.814703, -1.132789, 0.506407>,
      < -6.816443, -1.132789, 0.490502>
    }
    triangle {
      < -6.814703, -1.148789, 0.506407>,
      < -6.816443, -1.132789, 0.490502>,
      < -6.816443, -1.148789, 0.490502>
    }
    triangle {
      < -6.778356, -1.148789, 0.838711>,
      < -6.778356, -1.132789, 0.838711>,
      < -6.780095, -1.132789, 0.822806>
    }
    triangle {
      < -6.778356, -1.148789, 0.838711>,
      < -6.780095, -1.132789, 0.822806>,
      < -6.780095, -1.148789, 0.822806>
    }
    triangle {
      < -6.742008, -1.148789, 1.171014>,
      < -6.742008, -1.132789, 1.171014>,
      < -6.743747, -1.132789, 1.155109>
    }
    triangle {
      < -6.742008, -1.148789, 1.171014>,
      < -6.743747, -1.132789, 1.155109>,
      < -6.743747, -1.148789, 1.155109>
    }
    triangle {
      < -6.705659, -1.148789, 1.503317>,
      < -6.705659, -1.132789, 1.503317>,
      < -6.707399, -1.132789, 1.487412>
    }
    triangle {
      < -6.705659, -1.148789, 1.503317>,
      < -6.707399, -1.132789, 1.487412>,
      < -6.707399, -1.148789, 1.487412>
    }
    triangle {
      < -6.669312, -1.148789, 1.835620>,
      < -6.669312, -1.132789, 1.835620>,
      < -6.671051, -1.132789, 1.819715>
    }
    triangle {
      < -6.669312, -1.148789, 1.835620>,
      < -6.671051, -1.132789, 1.819715>,
      < -6.671051, -1.148789, 1.819715>
    }
    triangle {
      < -6.632964, -1.148789, 2.167924>,
      < -6.632964, -1.132789, 2.167924>,
      < -6.634703, -1.132789, 2.152019>
    }
    triangle {
      < -6.632964, -1.148789, 2.167924>,
      < -6.634703, -1.132789, 2.152019>,
      < -6.634703, -1.148789, 2.152019>
    }
    triangle {
      < -6.580181, -1.215968, 2.650474>,
      < -6.571311, -1.207968, 2.658426>,
      < -6.580181, -1.199968, 2.650474>
    }
    triangle {
      < -6.596616, -1.148789, 2.500227>,
      < -6.596616, -1.132789, 2.500227>,
      < -6.598355, -1.132789, 2.484322>
    }
    triangle {
      < -6.596616, -1.148789, 2.500227>,
      < -6.598355, -1.132789, 2.484322>,
      < -6.598355, -1.148789, 2.484322>
    }
    triangle {
      < -6.869224, -1.081609, 0.007953>,
      < -6.869224, -1.065609, 0.007953>,
      < -6.869224, -1.065609, -0.007953>
    }
    triangle {
      < -6.869224, -1.081609, 0.007953>,
      < -6.869224, -1.065609, -0.007953>,
      < -6.869224, -1.081609, -0.007953>
    }
    triangle {
      < -6.580181, -1.065609, -2.650473>,
      < -6.571311, -1.073609, -2.658426>,
      < -6.580181, -1.081609, -2.650473>
    }
    triangle {
      < -6.598354, -1.081609, -2.484322>,
      < -6.598354, -1.065609, -2.484322>,
      < -6.596615, -1.065609, -2.500227>
    }
    triangle {
      < -6.598354, -1.081609, -2.484322>,
      < -6.596615, -1.065609, -2.500227>,
      < -6.596615, -1.081609, -2.500227>
    }
    triangle {
      < -6.634702, -1.081609, -2.152019>,
      < -6.634702, -1.065609, -2.152019>,
      < -6.632962, -1.065609, -2.167924>
    }
    triangle {
      < -6.634702, -1.081609, -2.152019>,
      < -6.632962, -1.065609, -2.167924>,
      < -6.632962, -1.081609, -2.167924>
    }
    triangle {
      < -6.671050, -1.081609, -1.819715>,
      < -6.671050, -1.065609, -1.819715>,
      < -6.669310, -1.065609, -1.835621>
    }
    triangle {
      < -6.671050, -1.081609, -1.819715>,
      < -6.669310, -1.065609, -1.835621>,
      < -6.669310, -1.081609, -1.835621>
    }
    triangle {
      < -6.707397, -1.081609, -1.487412>,
      < -6.707397, -1.065609, -1.487412>,
      < -6.705658, -1.065609, -1.503317>
    }
    triangle {
      < -6.707397, -1.081609, -1.487412>,
      < -6.705658, -1.065609, -1.503317>,
      < -6.705658, -1.081609, -1.503317>
    }
    triangle {
      < -6.743745, -1.081609, -1.155109>,
      < -6.743745, -1.065609, -1.155109>,
      < -6.742006, -1.065609, -1.171014>
    }
    triangle {
      < -6.743745, -1.081609, -1.155109>,
      < -6.742006, -1.065609, -1.171014>,
      < -6.742006, -1.081609, -1.171014>
    }
    triangle {
      < -6.780094, -1.081609, -0.822806>,
      < -6.780094, -1.065609, -0.822806>,
      < -6.778354, -1.065609, -0.838711>
    }
    triangle {
      < -6.780094, -1.081609, -0.822806>,
      < -6.778354, -1.065609, -0.838711>,
      < -6.778354, -1.081609, -0.838711>
    }
    triangle {
      < -6.816442, -1.081609, -0.490502>,
      < -6.816442, -1.065609, -0.490502>,
      < -6.814702, -1.065609, -0.506407>
    }
    triangle {
      < -6.816442, -1.081609, -0.490502>,
      < -6.814702, -1.065609, -0.506407>,
      < -6.814702, -1.081609, -0.506407>
    }
    triangle {
      < -6.852789, -1.081609, -0.158199>,
      < -6.852789, -1.065609, -0.158199>,
      < -6.851050, -1.065609, -0.174104>
    }
    triangle {
      < -6.852789, -1.081609, -0.158199>,
      < -6.851050, -1.065609, -0.174104>,
      < -6.851050, -1.081609, -0.174104>
    }
    triangle {
      < -6.832877, -1.081609, 0.340256>,
      < -6.832877, -1.065609, 0.340256>,
      < -6.834616, -1.065609, 0.324351>
    }
    triangle {
      < -6.832877, -1.081609, 0.340256>,
      < -6.834616, -1.065609, 0.324351>,
      < -6.834616, -1.081609, 0.324351>
    }
    triangle {
      < -6.796529, -1.081609, 0.672559>,
      < -6.796529, -1.065609, 0.672559>,
      < -6.798269, -1.065609, 0.656654>
    }
    triangle {
      < -6.796529, -1.081609, 0.672559>,
      < -6.798269, -1.065609, 0.656654>,
      < -6.798269, -1.081609, 0.656654>
    }
    triangle {
      < -6.760181, -1.081609, 1.004862>,
      < -6.760181, -1.065609, 1.004862>,
      < -6.761921, -1.065609, 0.988957>
    }
    triangle {
      < -6.760181, -1.081609, 1.004862>,
      < -6.761921, -1.065609, 0.988957>,
      < -6.761921, -1.081609, 0.988957>
    }
    triangle {
      < -6.723834, -1.081609, 1.337166>,
      < -6.723834, -1.065609, 1.337166>,
      < -6.725573, -1.065609, 1.321260>
    }
    triangle {
      < -6.723834, -1.081609, 1.337166>,
      < -6.725573, -1.065609, 1.321260>,
      < -6.725573, -1.081609, 1.321260>
    }
    triangle {
      < -6.687486, -1.081609, 1.669469>,
      < -6.687486, -1.065609, 1.669469>,
      < -6.689225, -1.065609, 1.653563>
    }
    triangle {
      < -6.687486, -1.081609, 1.669469>,
      < -6.689225, -1.065609, 1.653563>,
      < -6.689225, -1.081609, 1.653563>
    }
    triangle {
      < -6.651138, -1.081609, 2.001772>,
      < -6.651138, -1.065609, 2.001772>,
      < -6.652877, -1.065609, 1.985867>
    }
    triangle {
      < -6.651138, -1.081609, 2.001772>,
      < -6.652877, -1.065609, 1.985867>,
      < -6.652877, -1.081609, 1.985867>
    }
    triangle {
      < -6.614789, -1.081609, 2.334075>,
      < -6.614789, -1.065609, 2.334075>,
      < -6.616529, -1.065609, 2.318170>
    }
    triangle {
      < -6.614789, -1.081609, 2.334075>,
      < -6.616529, -1.065609, 2.318170>,
      < -6.616529, -1.081609, 2.318170>
    }
    triangle {
      < -6.580181, -1.148789, 2.650474>,
      < -6.571311, -1.140788, 2.658426>,
      < -6.580181, -1.132789, 2.650474>
    }
    triangle {
      < -6.596616, -1.081609, 2.500227>,
      < -6.596616, -1.065609, 2.500227>,
      < -6.598355, -1.065609, 2.484322>
    }
    triangle {
      < -6.596616, -1.081609, 2.500227>,
      < -6.598355, -1.065609, 2.484322>,
      < -6.598355, -1.081609, 2.484322>
    }
    triangle {
      < -6.632964, -1.081609, 2.167924>,
      < -6.632964, -1.065609, 2.167924>,
      < -6.634703, -1.065609, 2.152019>
    }
    triangle {
      < -6.632964, -1.081609, 2.167924>,
      < -6.634703, -1.065609, 2.152019>,
      < -6.634703, -1.081609, 2.152019>
    }
    triangle {
      < -6.669312, -1.081609, 1.835620>,
      < -6.669312, -1.065609, 1.835620>,
      < -6.671051, -1.065609, 1.819715>
    }
    triangle {
      < -6.669312, -1.081609, 1.835620>,
      < -6.671051, -1.065609, 1.819715>,
      < -6.671051, -1.081609, 1.819715>
    }
    triangle {
      < -6.705659, -1.081609, 1.503317>,
      < -6.705659, -1.065609, 1.503317>,
      < -6.707399, -1.065609, 1.487412>
    }
    triangle {
      < -6.705659, -1.081609, 1.503317>,
      < -6.707399, -1.065609, 1.487412>,
      < -6.707399, -1.081609, 1.487412>
    }
    triangle {
      < -6.742008, -1.081609, 1.171014>,
      < -6.742008, -1.065609, 1.171014>,
      < -6.743747, -1.065609, 1.155109>
    }
    triangle {
      < -6.742008, -1.081609, 1.171014>,
      < -6.743747, -1.065609, 1.155109>,
      < -6.743747, -1.081609, 1.155109>
    }
    triangle {
      < -6.778356, -1.081609, 0.838711>,
      < -6.778356, -1.065609, 0.838711>,
      < -6.780095, -1.065609, 0.822806>
    }
    triangle {
      < -6.778356, -1.081609, 0.838711>,
      < -6.780095, -1.065609, 0.822806>,
      < -6.780095, -1.081609, 0.822806>
    }
    triangle {
      < -6.814703, -1.081609, 0.506407>,
      < -6.814703, -1.065609, 0.506407>,
      < -6.816443, -1.065609, 0.490502>
    }
    triangle {
      < -6.814703, -1.081609, 0.506407>,
      < -6.816443, -1.065609, 0.490502>,
      < -6.816443, -1.081609, 0.490502>
    }
    triangle {
      < -6.851051, -1.081609, 0.174104>,
      < -6.851051, -1.065609, 0.174104>,
      < -6.852790, -1.065609, 0.158199>
    }
    triangle {
      < -6.851051, -1.081609, 0.174104>,
      < -6.852790, -1.065609, 0.158199>,
      < -6.852790, -1.081609, 0.158199>
    }
    triangle {
      < -6.834615, -1.081609, -0.324351>,
      < -6.834615, -1.065609, -0.324351>,
      < -6.832876, -1.065609, -0.340256>
    }
    triangle {
      < -6.834615, -1.081609, -0.324351>,
      < -6.832876, -1.065609, -0.340256>,
      < -6.832876, -1.081609, -0.340256>
    }
    triangle {
      < -6.798267, -1.081609, -0.656654>,
      < -6.798267, -1.065609, -0.656654>,
      < -6.796528, -1.065609, -0.672559>
    }
    triangle {
      < -6.798267, -1.081609, -0.656654>,
      < -6.796528, -1.065609, -0.672559>,
      < -6.796528, -1.081609, -0.672559>
    }
    triangle {
      < -6.761919, -1.081609, -0.988957>,
      < -6.761919, -1.065609, -0.988957>,
      < -6.760180, -1.065609, -1.004863>
    }
    triangle {
      < -6.761919, -1.081609, -0.988957>,
      < -6.760180, -1.065609, -1.004863>,
      < -6.760180, -1.081609, -1.004863>
    }
    triangle {
      < -6.725572, -1.081609, -1.321261>,
      < -6.725572, -1.065609, -1.321261>,
      < -6.723832, -1.065609, -1.337166>
    }
    triangle {
      < -6.725572, -1.081609, -1.321261>,
      < -6.723832, -1.065609, -1.337166>,
      < -6.723832, -1.081609, -1.337166>
    }
    triangle {
      < -6.689224, -1.081609, -1.653564>,
      < -6.689224, -1.065609, -1.653564>,
      < -6.687484, -1.065609, -1.669469>
    }
    triangle {
      < -6.689224, -1.081609, -1.653564>,
      < -6.687484, -1.065609, -1.669469>,
      < -6.687484, -1.081609, -1.669469>
    }
    triangle {
      < -6.652875, -1.081609, -1.985867>,
      < -6.652875, -1.065609, -1.985867>,
      < -6.651136, -1.065609, -2.001772>
    }
    triangle {
      < -6.652875, -1.081609, -1.985867>,
      < -6.651136, -1.065609, -2.001772>,
      < -6.651136, -1.081609, -2.001772>
    }
    triangle {
      < -6.616529, -1.081609, -2.318170>,
      < -6.616529, -1.065609, -2.318170>,
      < -6.614789, -1.065609, -2.334075>
    }
    triangle {
      < -6.616529, -1.081609, -2.318170>,
      < -6.614789, -1.065609, -2.334075>,
      < -6.614789, -1.081609, -2.334075>
    }
    triangle {
      < -6.869224, -1.014430, 0.007953>,
      < -6.869224, -0.998430, 0.007953>,
      < -6.869224, -0.998430, -0.007953>
    }
    triangle {
      < -6.869224, -1.014430, 0.007953>,
      < -6.869224, -0.998430, -0.007953>,
      < -6.869224, -1.014430, -0.007953>
    }
    triangle {
      < -6.580181, -0.998430, -2.650473>,
      < -6.571311, -1.006430, -2.658426>,
      < -6.580181, -1.014430, -2.650473>
    }
    triangle {
      < -6.598354, -1.014430, -2.484322>,
      < -6.598354, -0.998430, -2.484322>,
      < -6.596615, -0.998430, -2.500227>
    }
    triangle {
      < -6.598354, -1.014430, -2.484322>,
      < -6.596615, -0.998430, -2.500227>,
      < -6.596615, -1.014430, -2.500227>
    }
    triangle {
      < -6.634702, -1.014430, -2.152019>,
      < -6.634702, -0.998430, -2.152019>,
      < -6.632962, -0.998430, -2.167924>
    }
    triangle {
      < -6.634702, -1.014430, -2.152019>,
      < -6.632962, -0.998430, -2.167924>,
      < -6.632962, -1.014430, -2.167924>
    }
    triangle {
      < -6.671050, -1.014430, -1.819715>,
      < -6.671050, -0.998430, -1.819715>,
      < -6.669310, -0.998430, -1.835621>
    }
    triangle {
      < -6.671050, -1.014430, -1.819715>,
      < -6.669310, -0.998430, -1.835621>,
      < -6.669310, -1.014430, -1.835621>
    }
    triangle {
      < -6.707397, -1.014430, -1.487412>,
      < -6.707397, -0.998430, -1.487412>,
      < -6.705658, -0.998430, -1.503317>
    }
    triangle {
      < -6.707397, -1.014430, -1.487412>,
      < -6.705658, -0.998430, -1.503317>,
      < -6.705658, -1.014430, -1.503317>
    }
    triangle {
      < -6.743745, -1.014430, -1.155109>,
      < -6.743745, -0.998430, -1.155109>,
      < -6.742006, -0.998430, -1.171014>
    }
    triangle {
      < -6.743745, -1.014430, -1.155109>,
      < -6.742006, -0.998430, -1.171014>,
      < -6.742006, -1.014430, -1.171014>
    }
    triangle {
      < -6.780094, -1.014430, -0.822806>,
      < -6.780094, -0.998430, -0.822806>,
      < -6.778354, -0.998430, -0.838711>
    }
    triangle {
      < -6.780094, -1.014430, -0.822806>,
      < -6.778354, -0.998430, -0.838711>,
      < -6.778354, -1.014430, -0.838711>
    }
    triangle {
      < -6.816442, -1.014430, -0.490502>,
      < -6.816442, -0.998430, -0.490502>,
      < -6.814702, -0.998430, -0.506407>
    }
    triangle {
      < -6.816442, -1.014430, -0.490502>,
      < -6.814702, -0.998430, -0.506407>,
      < -6.814702, -1.014430, -0.506407>
    }
    triangle {
      < -6.852789, -1.014430, -0.158199>,
      < -6.852789, -0.998430, -0.158199>,
      < -6.851050, -0.998430, -0.174104>
    }
    triangle {
      < -6.852789, -1.014430, -0.158199>,
      < -6.851050, -0.998430, -0.174104>,
      < -6.851050, -1.014430, -0.174104>
    }
    triangle {
      < -6.832877, -1.014430, 0.340256>,
      < -6.832877, -0.998430, 0.340256>,
      < -6.834616, -0.998430, 0.324351>
    }
    triangle {
      < -6.832877, -1.014430, 0.340256>,
      < -6.834616, -0.998430, 0.324351>,
      < -6.834616, -1.014430, 0.324351>
    }
    triangle {
      < -6.796529, -1.014430, 0.672559>,
      < -6.796529, -0.998430, 0.672559>,
      < -6.798269, -0.998430, 0.656654>
    }
    triangle {
      < -6.796529, -1.014430, 0.672559>,
      < -6.798269, -0.998430, 0.656654>,
      < -6.798269, -1.014430, 0.656654>
    }
    triangle {
      < -6.760181, -1.014430, 1.004862>,
      < -6.760181, -0.998430, 1.004862>,
      < -6.761921, -0.998430, 0.988957>
    }
    triangle {
      < -6.760181, -1.014430, 1.004862>,
      < -6.761921, -0.998430, 0.988957>,
      < -6.761921, -1.014430, 0.988957>
    }
    triangle {
      < -6.723834, -1.014430, 1.337166>,
      < -6.723834, -0.998430, 1.337166>,
      < -6.725573, -0.998430, 1.321260>
    }
    triangle {
      < -6.723834, -1.014430, 1.337166>,
      < -6.725573, -0.998430, 1.321260>,
      < -6.725573, -1.014430, 1.321260>
    }
    triangle {
      < -6.687486, -1.014430, 1.669469>,
      < -6.687486, -0.998430, 1.669469>,
      < -6.689225, -0.998430, 1.653563>
    }
    triangle {
      < -6.687486, -1.014430, 1.669469>,
      < -6.689225, -0.998430, 1.653563>,
      < -6.689225, -1.014430, 1.653563>
    }
    triangle {
      < -6.651138, -1.014430, 2.001772>,
      < -6.651138, -0.998430, 2.001772>,
      < -6.652877, -0.998430, 1.985867>
    }
    triangle {
      < -6.651138, -1.014430, 2.001772>,
      < -6.652877, -0.998430, 1.985867>,
      < -6.652877, -1.014430, 1.985867>
    }
    triangle {
      < -6.614789, -1.014430, 2.334075>,
      < -6.614789, -0.998430, 2.334075>,
      < -6.616529, -0.998430, 2.318170>
    }
    triangle {
      < -6.614789, -1.014430, 2.334075>,
      < -6.616529, -0.998430, 2.318170>,
      < -6.616529, -1.014430, 2.318170>
    }
    triangle {
      < -6.616529, -1.014430, -2.318170>,
      < -6.616529, -0.998430, -2.318170>,
      < -6.614789, -0.998430, -2.334075>
    }
    triangle {
      < -6.616529, -1.014430, -2.318170>,
      < -6.614789, -0.998430, -2.334075>,
      < -6.614789, -1.014430, -2.334075>
    }
    triangle {
      < -6.652875, -1.014430, -1.985867>,
      < -6.652875, -0.998430, -1.985867>,
      < -6.651136, -0.998430, -2.001772>
    }
    triangle {
      < -6.652875, -1.014430, -1.985867>,
      < -6.651136, -0.998430, -2.001772>,
      < -6.651136, -1.014430, -2.001772>
    }
    triangle {
      < -6.689224, -1.014430, -1.653564>,
      < -6.689224, -0.998430, -1.653564>,
      < -6.687484, -0.998430, -1.669469>
    }
    triangle {
      < -6.689224, -1.014430, -1.653564>,
      < -6.687484, -0.998430, -1.669469>,
      < -6.687484, -1.014430, -1.669469>
    }
    triangle {
      < -6.725572, -1.014430, -1.321261>,
      < -6.725572, -0.998430, -1.321261>,
      < -6.723832, -0.998430, -1.337166>
    }
    triangle {
      < -6.725572, -1.014430, -1.321261>,
      < -6.723832, -0.998430, -1.337166>,
      < -6.723832, -1.014430, -1.337166>
    }
    triangle {
      < -6.761919, -1.014430, -0.988957>,
      < -6.761919, -0.998430, -0.988957>,
      < -6.760180, -0.998430, -1.004863>
    }
    triangle {
      < -6.761919, -1.014430, -0.988957>,
      < -6.760180, -0.998430, -1.004863>,
      < -6.760180, -1.014430, -1.004863>
    }
    triangle {
      < -6.798267, -1.014430, -0.656654>,
      < -6.798267, -0.998430, -0.656654>,
      < -6.796528, -0.998430, -0.672559>
    }
    triangle {
      < -6.798267, -1.014430, -0.656654>,
      < -6.796528, -0.998430, -0.672559>,
      < -6.796528, -1.014430, -0.672559>
    }
    triangle {
      < -6.834615, -1.014430, -0.324351>,
      < -6.834615, -0.998430, -0.324351>,
      < -6.832876, -0.998430, -0.340256>
    }
    triangle {
      < -6.834615, -1.014430, -0.324351>,
      < -6.832876, -0.998430, -0.340256>,
      < -6.832876, -1.014430, -0.340256>
    }
    triangle {
      < -6.851051, -1.014430, 0.174104>,
      < -6.851051, -0.998430, 0.174104>,
      < -6.852790, -0.998430, 0.158199>
    }
    triangle {
      < -6.851051, -1.014430, 0.174104>,
      < -6.852790, -0.998430, 0.158199>,
      < -6.852790, -1.014430, 0.158199>
    }
    triangle {
      < -6.814703, -1.014430, 0.506407>,
      < -6.814703, -0.998430, 0.506407>,
      < -6.816443, -0.998430, 0.490502>
    }
    triangle {
      < -6.814703, -1.014430, 0.506407>,
      < -6.816443, -0.998430, 0.490502>,
      < -6.816443, -1.014430, 0.490502>
    }
    triangle {
      < -6.778356, -1.014430, 0.838711>,
      < -6.778356, -0.998430, 0.838711>,
      < -6.780095, -0.998430, 0.822805>
    }
    triangle {
      < -6.778356, -1.014430, 0.838711>,
      < -6.780095, -0.998430, 0.822805>,
      < -6.780095, -1.014430, 0.822805>
    }
    triangle {
      < -6.742008, -1.014430, 1.171014>,
      < -6.742008, -0.998430, 1.171014>,
      < -6.743747, -0.998430, 1.155109>
    }
    triangle {
      < -6.742008, -1.014430, 1.171014>,
      < -6.743747, -0.998430, 1.155109>,
      < -6.743747, -1.014430, 1.155109>
    }
    triangle {
      < -6.705659, -1.014430, 1.503317>,
      < -6.705659, -0.998430, 1.503317>,
      < -6.707399, -0.998430, 1.487412>
    }
    triangle {
      < -6.705659, -1.014430, 1.503317>,
      < -6.707399, -0.998430, 1.487412>,
      < -6.707399, -1.014430, 1.487412>
    }
    triangle {
      < -6.669312, -1.014430, 1.835620>,
      < -6.669312, -0.998430, 1.835620>,
      < -6.671051, -0.998430, 1.819715>
    }
    triangle {
      < -6.669312, -1.014430, 1.835620>,
      < -6.671051, -0.998430, 1.819715>,
      < -6.671051, -1.014430, 1.819715>
    }
    triangle {
      < -6.632964, -1.014430, 2.167924>,
      < -6.632964, -0.998430, 2.167924>,
      < -6.634703, -0.998430, 2.152019>
    }
    triangle {
      < -6.632964, -1.014430, 2.167924>,
      < -6.634703, -0.998430, 2.152019>,
      < -6.634703, -1.014430, 2.152019>
    }
    triangle {
      < -6.580181, -1.081609, 2.650474>,
      < -6.571311, -1.073609, 2.658426>,
      < -6.580181, -1.065609, 2.650474>
    }
    triangle {
      < -6.596616, -1.014430, 2.500227>,
      < -6.596616, -0.998430, 2.500227>,
      < -6.598355, -0.998430, 2.484322>
    }
    triangle {
      < -6.596616, -1.014430, 2.500227>,
      < -6.598355, -0.998430, 2.484322>,
      < -6.598355, -1.014430, 2.484322>
    }
    triangle {
      < -6.869224, -0.947251, 0.007953>,
      < -6.869224, -0.931251, 0.007953>,
      < -6.869224, -0.931251, -0.007953>
    }
    triangle {
      < -6.869224, -0.947251, 0.007953>,
      < -6.869224, -0.931251, -0.007953>,
      < -6.869224, -0.947251, -0.007953>
    }
    triangle {
      < -6.580181, -0.931251, -2.650473>,
      < -6.571311, -0.939251, -2.658426>,
      < -6.580181, -0.947251, -2.650473>
    }
    triangle {
      < -6.598354, -0.947251, -2.484322>,
      < -6.598354, -0.931251, -2.484322>,
      < -6.596615, -0.931251, -2.500227>
    }
    triangle {
      < -6.598354, -0.947251, -2.484322>,
      < -6.596615, -0.931251, -2.500227>,
      < -6.596615, -0.947251, -2.500227>
    }
    triangle {
      < -6.634702, -0.947251, -2.152019>,
      < -6.634702, -0.931251, -2.152019>,
      < -6.632962, -0.931251, -2.167924>
    }
    triangle {
      < -6.634702, -0.947251, -2.152019>,
      < -6.632962, -0.931251, -2.167924>,
      < -6.632962, -0.947251, -2.167924>
    }
    triangle {
      < -6.671050, -0.947251, -1.819715>,
      < -6.671050, -0.931251, -1.819715>,
      < -6.669310, -0.931251, -1.835621>
    }
    triangle {
      < -6.671050, -0.947251, -1.819715>,
      < -6.669310, -0.931251, -1.835621>,
      < -6.669310, -0.947251, -1.835621>
    }
    triangle {
      < -6.707397, -0.947251, -1.487412>,
      < -6.707397, -0.931251, -1.487412>,
      < -6.705658, -0.931251, -1.503317>
    }
    triangle {
      < -6.707397, -0.947251, -1.487412>,
      < -6.705658, -0.931251, -1.503317>,
      < -6.705658, -0.947251, -1.503317>
    }
    triangle {
      < -6.743745, -0.947251, -1.155109>,
      < -6.743745, -0.931251, -1.155109>,
      < -6.742006, -0.931251, -1.171014>
    }
    triangle {
      < -6.743745, -0.947251, -1.155109>,
      < -6.742006, -0.931251, -1.171014>,
      < -6.742006, -0.947251, -1.171014>
    }
    triangle {
      < -6.780094, -0.947251, -0.822806>,
      < -6.780094, -0.931251, -0.822806>,
      < -6.778354, -0.931251, -0.838711>
    }
    triangle {
      < -6.780094, -0.947251, -0.822806>,
      < -6.778354, -0.931251, -0.838711>,
      < -6.778354, -0.947251, -0.838711>
    }
    triangle {
      < -6.816442, -0.947251, -0.490502>,
      < -6.816442, -0.931251, -0.490502>,
      < -6.814702, -0.931251, -0.506407>
    }
    triangle {
      < -6.816442, -0.947251, -0.490502>,
      < -6.814702, -0.931251, -0.506407>,
      < -6.814702, -0.947251, -0.506407>
    }
    triangle {
      < -6.852789, -0.947251, -0.158199>,
      < -6.852789, -0.931251, -0.158199>,
      < -6.851050, -0.931251, -0.174104>
    }
    triangle {
      < -6.852789, -0.947251, -0.158199>,
      < -6.851050, -0.931251, -0.174104>,
      < -6.851050, -0.947251, -0.174104>
    }
    triangle {
      < -6.832877, -0.947251, 0.340256>,
      < -6.832877, -0.931251, 0.340256>,
      < -6.834616, -0.931251, 0.324351>
    }
    triangle {
      < -6.832877, -0.947251, 0.340256>,
      < -6.834616, -0.931251, 0.324351>,
      < -6.834616, -0.947251, 0.324351>
    }
    triangle {
      < -6.796529, -0.947251, 0.672559>,
      < -6.796529, -0.931251, 0.672559>,
      < -6.798269, -0.931251, 0.656654>
    }
    triangle {
      < -6.796529, -0.947251, 0.672559>,
      < -6.798269, -0.931251, 0.656654>,
      < -6.798269, -0.947251, 0.656654>
    }
    triangle {
      < -6.760181, -0.947251, 1.004862>,
      < -6.760181, -0.931251, 1.004862>,
      < -6.761921, -0.931251, 0.988957>
    }
    triangle {
      < -6.760181, -0.947251, 1.004862>,
      < -6.761921, -0.931251, 0.988957>,
      < -6.761921, -0.947251, 0.988957>
    }
    triangle {
      < -6.723834, -0.947251, 1.337166>,
      < -6.723834, -0.931251, 1.337166>,
      < -6.725573, -0.931251, 1.321260>
    }
    triangle {
      < -6.723834, -0.947251, 1.337166>,
      < -6.725573, -0.931251, 1.321260>,
      < -6.725573, -0.947251, 1.321260>
    }
    triangle {
      < -6.687486, -0.947251, 1.669469>,
      < -6.687486, -0.931251, 1.669469>,
      < -6.689225, -0.931251, 1.653563>
    }
    triangle {
      < -6.687486, -0.947251, 1.669469>,
      < -6.689225, -0.931251, 1.653563>,
      < -6.689225, -0.947251, 1.653563>
    }
    triangle {
      < -6.651138, -0.947251, 2.001772>,
      < -6.651138, -0.931251, 2.001772>,
      < -6.652877, -0.931251, 1.985867>
    }
    triangle {
      < -6.651138, -0.947251, 2.001772>,
      < -6.652877, -0.931251, 1.985867>,
      < -6.652877, -0.947251, 1.985867>
    }
    triangle {
      < -6.614789, -0.947251, 2.334075>,
      < -6.614789, -0.931251, 2.334075>,
      < -6.616529, -0.931251, 2.318170>
    }
    triangle {
      < -6.614789, -0.947251, 2.334075>,
      < -6.616529, -0.931251, 2.318170>,
      < -6.616529, -0.947251, 2.318170>
    }
    triangle {
      < -6.580181, -1.014430, 2.650474>,
      < -6.571311, -1.006430, 2.658426>,
      < -6.580181, -0.998430, 2.650474>
    }
    triangle {
      < -6.596616, -0.947251, 2.500227>,
      < -6.596616, -0.931251, 2.500227>,
      < -6.598355, -0.931251, 2.484322>
    }
    triangle {
      < -6.596616, -0.947251, 2.500227>,
      < -6.598355, -0.931251, 2.484322>,
      < -6.598355, -0.947251, 2.484322>
    }
    triangle {
      < -6.632964, -0.947251, 2.167924>,
      < -6.632964, -0.931251, 2.167924>,
      < -6.634703, -0.931251, 2.152019>
    }
    triangle {
      < -6.632964, -0.947251, 2.167924>,
      < -6.634703, -0.931251, 2.152019>,
      < -6.634703, -0.947251, 2.152019>
    }
    triangle {
      < -6.669312, -0.947251, 1.835620>,
      < -6.669312, -0.931251, 1.835620>,
      < -6.671051, -0.931251, 1.819715>
    }
    triangle {
      < -6.669312, -0.947251, 1.835620>,
      < -6.671051, -0.931251, 1.819715>,
      < -6.671051, -0.947251, 1.819715>
    }
    triangle {
      < -6.705659, -0.947251, 1.503317>,
      < -6.705659, -0.931251, 1.503317>,
      < -6.707399, -0.931251, 1.487412>
    }
    triangle {
      < -6.705659, -0.947251, 1.503317>,
      < -6.707399, -0.931251, 1.487412>,
      < -6.707399, -0.947251, 1.487412>
    }
    triangle {
      < -6.742008, -0.947251, 1.171014>,
      < -6.742008, -0.931251, 1.171014>,
      < -6.743747, -0.931251, 1.155109>
    }
    triangle {
      < -6.742008, -0.947251, 1.171014>,
      < -6.743747, -0.931251, 1.155109>,
      < -6.743747, -0.947251, 1.155109>
    }
    triangle {
      < -6.778356, -0.947251, 0.838711>,
      < -6.778356, -0.931251, 0.838711>,
      < -6.780095, -0.931251, 0.822805>
    }
    triangle {
      < -6.778356, -0.947251, 0.838711>,
      < -6.780095, -0.931251, 0.822805>,
      < -6.780095, -0.947251, 0.822805>
    }
    triangle {
      < -6.814703, -0.947251, 0.506407>,
      < -6.814703, -0.931251, 0.506407>,
      < -6.816443, -0.931251, 0.490502>
    }
    triangle {
      < -6.814703, -0.947251, 0.506407>,
      < -6.816443, -0.931251, 0.490502>,
      < -6.816443, -0.947251, 0.490502>
    }
    triangle {
      < -6.851051, -0.947251, 0.174104>,
      < -6.851051, -0.931251, 0.174104>,
      < -6.852790, -0.931251, 0.158199>
    }
    triangle {
      < -6.851051, -0.947251, 0.174104>,
      < -6.852790, -0.931251, 0.158199>,
      < -6.852790, -0.947251, 0.158199>
    }
    triangle {
      < -6.834615, -0.947251, -0.324351>,
      < -6.834615, -0.931251, -0.324351>,
      < -6.832876, -0.931251, -0.340256>
    }
    triangle {
      < -6.834615, -0.947251, -0.324351>,
      < -6.832876, -0.931251, -0.340256>,
      < -6.832876, -0.947251, -0.340256>
    }
    triangle {
      < -6.798267, -0.947251, -0.656654>,
      < -6.798267, -0.931251, -0.656654>,
      < -6.796528, -0.931251, -0.672559>
    }
    triangle {
      < -6.798267, -0.947251, -0.656654>,
      < -6.796528, -0.931251, -0.672559>,
      < -6.796528, -0.947251, -0.672559>
    }
    triangle {
      < -6.761919, -0.947251, -0.988957>,
      < -6.761919, -0.931251, -0.988957>,
      < -6.760180, -0.931251, -1.004863>
    }
    triangle {
      < -6.761919, -0.947251, -0.988957>,
      < -6.760180, -0.931251, -1.004863>,
      < -6.760180, -0.947251, -1.004863>
    }
    triangle {
      < -6.725572, -0.947251, -1.321261>,
      < -6.725572, -0.931251, -1.321261>,
      < -6.723832, -0.931251, -1.337166>
    }
    triangle {
      < -6.725572, -0.947251, -1.321261>,
      < -6.723832, -0.931251, -1.337166>,
      < -6.723832, -0.947251, -1.337166>
    }
    triangle {
      < -6.689224, -0.947251, -1.653564>,
      < -6.689224, -0.931251, -1.653564>,
      < -6.687484, -0.931251, -1.669469>
    }
    triangle {
      < -6.689224, -0.947251, -1.653564>,
      < -6.687484, -0.931251, -1.669469>,
      < -6.687484, -0.947251, -1.669469>
    }
    triangle {
      < -6.652875, -0.947251, -1.985867>,
      < -6.652875, -0.931251, -1.985867>,
      < -6.651136, -0.931251, -2.001772>
    }
    triangle {
      < -6.652875, -0.947251, -1.985867>,
      < -6.651136, -0.931251, -2.001772>,
      < -6.651136, -0.947251, -2.001772>
    }
    triangle {
      < -6.616529, -0.947251, -2.318170>,
      < -6.616529, -0.931251, -2.318170>,
      < -6.614789, -0.931251, -2.334075>
    }
    triangle {
      < -6.616529, -0.947251, -2.318170>,
      < -6.614789, -0.931251, -2.334075>,
      < -6.614789, -0.947251, -2.334075>
    }
    triangle {
      < -6.869224, -0.880072, 0.007953>,
      < -6.869224, -0.864072, 0.007953>,
      < -6.869224, -0.864072, -0.007953>
    }
    triangle {
      < -6.869224, -0.880072, 0.007953>,
      < -6.869224, -0.864072, -0.007953>,
      < -6.869224, -0.880072, -0.007953>
    }
    triangle {
      < -6.580181, -0.864072, -2.650473>,
      < -6.571311, -0.872072, -2.658426>,
      < -6.580181, -0.880072, -2.650473>
    }
    triangle {
      < -6.598354, -0.880072, -2.484322>,
      < -6.598354, -0.864072, -2.484322>,
      < -6.596615, -0.864072, -2.500227>
    }
    triangle {
      < -6.598354, -0.880072, -2.484322>,
      < -6.596615, -0.864072, -2.500227>,
      < -6.596615, -0.880072, -2.500227>
    }
    triangle {
      < -6.634702, -0.880072, -2.152019>,
      < -6.634702, -0.864072, -2.152019>,
      < -6.632962, -0.864072, -2.167924>
    }
    triangle {
      < -6.634702, -0.880072, -2.152019>,
      < -6.632962, -0.864072, -2.167924>,
      < -6.632962, -0.880072, -2.167924>
    }
    triangle {
      < -6.671050, -0.880072, -1.819715>,
      < -6.671050, -0.864072, -1.819715>,
      < -6.669310, -0.864072, -1.835621>
    }
    triangle {
      < -6.671050, -0.880072, -1.819715>,
      < -6.669310, -0.864072, -1.835621>,
      < -6.669310, -0.880072, -1.835621>
    }
    triangle {
      < -6.707397, -0.880072, -1.487412>,
      < -6.707397, -0.864072, -1.487412>,
      < -6.705658, -0.864072, -1.503317>
    }
    triangle {
      < -6.707397, -0.880072, -1.487412>,
      < -6.705658, -0.864072, -1.503317>,
      < -6.705658, -0.880072, -1.503317>
    }
    triangle {
      < -6.743745, -0.880072, -1.155109>,
      < -6.743745, -0.864072, -1.155109>,
      < -6.742006, -0.864072, -1.171014>
    }
    triangle {
      < -6.743745, -0.880072, -1.155109>,
      < -6.742006, -0.864072, -1.171014>,
      < -6.742006, -0.880072, -1.171014>
    }
    triangle {
      < -6.780094, -0.880072, -0.822806>,
      < -6.780094, -0.864072, -0.822806>,
      < -6.778354, -0.864072, -0.838711>
    }
    triangle {
      < -6.780094, -0.880072, -0.822806>,
      < -6.778354, -0.864072, -0.838711>,
      < -6.778354, -0.880072, -0.838711>
    }
    triangle {
      < -6.816442, -0.880072, -0.490502>,
      < -6.816442, -0.864072, -0.490502>,
      < -6.814702, -0.864072, -0.506407>
    }
    triangle {
      < -6.816442, -0.880072, -0.490502>,
      < -6.814702, -0.864072, -0.506407>,
      < -6.814702, -0.880072, -0.506407>
    }
    triangle {
      < -6.852789, -0.880072, -0.158199>,
      < -6.852789, -0.864072, -0.158199>,
      < -6.851050, -0.864072, -0.174104>
    }
    triangle {
      < -6.852789, -0.880072, -0.158199>,
      < -6.851050, -0.864072, -0.174104>,
      < -6.851050, -0.880072, -0.174104>
    }
    triangle {
      < -6.832877, -0.880072, 0.340256>,
      < -6.832877, -0.864072, 0.340256>,
      < -6.834616, -0.864072, 0.324351>
    }
    triangle {
      < -6.832877, -0.880072, 0.340256>,
      < -6.834616, -0.864072, 0.324351>,
      < -6.834616, -0.880072, 0.324351>
    }
    triangle {
      < -6.796529, -0.880072, 0.672559>,
      < -6.796529, -0.864072, 0.672559>,
      < -6.798269, -0.864072, 0.656654>
    }
    triangle {
      < -6.796529, -0.880072, 0.672559>,
      < -6.798269, -0.864072, 0.656654>,
      < -6.798269, -0.880072, 0.656654>
    }
    triangle {
      < -6.760181, -0.880072, 1.004862>,
      < -6.760181, -0.864072, 1.004862>,
      < -6.761921, -0.864072, 0.988957>
    }
    triangle {
      < -6.760181, -0.880072, 1.004862>,
      < -6.761921, -0.864072, 0.988957>,
      < -6.761921, -0.880072, 0.988957>
    }
    triangle {
      < -6.723834, -0.880072, 1.337165>,
      < -6.723834, -0.864072, 1.337165>,
      < -6.725573, -0.864072, 1.321260>
    }
    triangle {
      < -6.723834, -0.880072, 1.337165>,
      < -6.725573, -0.864072, 1.321260>,
      < -6.725573, -0.880072, 1.321260>
    }
    triangle {
      < -6.687486, -0.880072, 1.669469>,
      < -6.687486, -0.864072, 1.669469>,
      < -6.689225, -0.864072, 1.653563>
    }
    triangle {
      < -6.687486, -0.880072, 1.669469>,
      < -6.689225, -0.864072, 1.653563>,
      < -6.689225, -0.880072, 1.653563>
    }
    triangle {
      < -6.651138, -0.880072, 2.001772>,
      < -6.651138, -0.864072, 2.001772>,
      < -6.652877, -0.864072, 1.985867>
    }
    triangle {
      < -6.651138, -0.880072, 2.001772>,
      < -6.652877, -0.864072, 1.985867>,
      < -6.652877, -0.880072, 1.985867>
    }
    triangle {
      < -6.614789, -0.880072, 2.334075>,
      < -6.614789, -0.864072, 2.334075>,
      < -6.616529, -0.864072, 2.318170>
    }
    triangle {
      < -6.614789, -0.880072, 2.334075>,
      < -6.616529, -0.864072, 2.318170>,
      < -6.616529, -0.880072, 2.318170>
    }
    triangle {
      < -6.616529, -0.880072, -2.318170>,
      < -6.616529, -0.864072, -2.318170>,
      < -6.614789, -0.864072, -2.334075>
    }
    triangle {
      < -6.616529, -0.880072, -2.318170>,
      < -6.614789, -0.864072, -2.334075>,
      < -6.614789, -0.880072, -2.334075>
    }
    triangle {
      < -6.652875, -0.880072, -1.985867>,
      < -6.652875, -0.864072, -1.985867>,
      < -6.651136, -0.864072, -2.001772>
    }
    triangle {
      < -6.652875, -0.880072, -1.985867>,
      < -6.651136, -0.864072, -2.001772>,
      < -6.651136, -0.880072, -2.001772>
    }
    triangle {
      < -6.689224, -0.880072, -1.653564>,
      < -6.689224, -0.864072, -1.653564>,
      < -6.687484, -0.864072, -1.669469>
    }
    triangle {
      < -6.689224, -0.880072, -1.653564>,
      < -6.687484, -0.864072, -1.669469>,
      < -6.687484, -0.880072, -1.669469>
    }
    triangle {
      < -6.725572, -0.880072, -1.321261>,
      < -6.725572, -0.864072, -1.321261>,
      < -6.723832, -0.864072, -1.337166>
    }
    triangle {
      < -6.725572, -0.880072, -1.321261>,
      < -6.723832, -0.864072, -1.337166>,
      < -6.723832, -0.880072, -1.337166>
    }
    triangle {
      < -6.761919, -0.880072, -0.988957>,
      < -6.761919, -0.864072, -0.988957>,
      < -6.760180, -0.864072, -1.004863>
    }
    triangle {
      < -6.761919, -0.880072, -0.988957>,
      < -6.760180, -0.864072, -1.004863>,
      < -6.760180, -0.880072, -1.004863>
    }
    triangle {
      < -6.798267, -0.880072, -0.656654>,
      < -6.798267, -0.864072, -0.656654>,
      < -6.796528, -0.864072, -0.672559>
    }
    triangle {
      < -6.798267, -0.880072, -0.656654>,
      < -6.796528, -0.864072, -0.672559>,
      < -6.796528, -0.880072, -0.672559>
    }
    triangle {
      < -6.834615, -0.880072, -0.324351>,
      < -6.834615, -0.864072, -0.324351>,
      < -6.832876, -0.864072, -0.340256>
    }
    triangle {
      < -6.834615, -0.880072, -0.324351>,
      < -6.832876, -0.864072, -0.340256>,
      < -6.832876, -0.880072, -0.340256>
    }
    triangle {
      < -6.851051, -0.880072, 0.174104>,
      < -6.851051, -0.864072, 0.174104>,
      < -6.852790, -0.864072, 0.158199>
    }
    triangle {
      < -6.851051, -0.880072, 0.174104>,
      < -6.852790, -0.864072, 0.158199>,
      < -6.852790, -0.880072, 0.158199>
    }
    triangle {
      < -6.814703, -0.880072, 0.506407>,
      < -6.814703, -0.864072, 0.506407>,
      < -6.816443, -0.864072, 0.490502>
    }
    triangle {
      < -6.814703, -0.880072, 0.506407>,
      < -6.816443, -0.864072, 0.490502>,
      < -6.816443, -0.880072, 0.490502>
    }
    triangle {
      < -6.778356, -0.880072, 0.838711>,
      < -6.778356, -0.864072, 0.838711>,
      < -6.780095, -0.864072, 0.822805>
    }
    triangle {
      < -6.778356, -0.880072, 0.838711>,
      < -6.780095, -0.864072, 0.822805>,
      < -6.780095, -0.880072, 0.822805>
    }
    triangle {
      < -6.742008, -0.880072, 1.171014>,
      < -6.742008, -0.864072, 1.171014>,
      < -6.743747, -0.864072, 1.155109>
    }
    triangle {
      < -6.742008, -0.880072, 1.171014>,
      < -6.743747, -0.864072, 1.155109>,
      < -6.743747, -0.880072, 1.155109>
    }
    triangle {
      < -6.705659, -0.880072, 1.503317>,
      < -6.705659, -0.864072, 1.503317>,
      < -6.707399, -0.864072, 1.487412>
    }
    triangle {
      < -6.705659, -0.880072, 1.503317>,
      < -6.707399, -0.864072, 1.487412>,
      < -6.707399, -0.880072, 1.487412>
    }
    triangle {
      < -6.669312, -0.880072, 1.835620>,
      < -6.669312, -0.864072, 1.835620>,
      < -6.671051, -0.864072, 1.819715>
    }
    triangle {
      < -6.669312, -0.880072, 1.835620>,
      < -6.671051, -0.864072, 1.819715>,
      < -6.671051, -0.880072, 1.819715>
    }
    triangle {
      < -6.632964, -0.880072, 2.167924>,
      < -6.632964, -0.864072, 2.167924>,
      < -6.634703, -0.864072, 2.152019>
    }
    triangle {
      < -6.632964, -0.880072, 2.167924>,
      < -6.634703, -0.864072, 2.152019>,
      < -6.634703, -0.880072, 2.152019>
    }
    triangle {
      < -6.580181, -0.947251, 2.650474>,
      < -6.571311, -0.939251, 2.658426>,
      < -6.580181, -0.931251, 2.650474>
    }
    triangle {
      < -6.596616, -0.880072, 2.500227>,
      < -6.596616, -0.864072, 2.500227>,
      < -6.598355, -0.864072, 2.484322>
    }
    triangle {
      < -6.596616, -0.880072, 2.500227>,
      < -6.598355, -0.864072, 2.484322>,
      < -6.598355, -0.880072, 2.484322>
    }
    triangle {
      < -6.869224, -0.812893, 0.007953>,
      < -6.869224, -0.796893, 0.007953>,
      < -6.869224, -0.796893, -0.007953>
    }
    triangle {
      < -6.869224, -0.812893, 0.007953>,
      < -6.869224, -0.796893, -0.007953>,
      < -6.869224, -0.812893, -0.007953>
    }
    triangle {
      < -6.580181, -0.796893, -2.650473>,
      < -6.571311, -0.804893, -2.658426>,
      < -6.580181, -0.812893, -2.650473>
    }
    triangle {
      < -6.598354, -0.812893, -2.484322>,
      < -6.598354, -0.796893, -2.484322>,
      < -6.596615, -0.796893, -2.500227>
    }
    triangle {
      < -6.598354, -0.812893, -2.484322>,
      < -6.596615, -0.796893, -2.500227>,
      < -6.596615, -0.812893, -2.500227>
    }
    triangle {
      < -6.634702, -0.812893, -2.152019>,
      < -6.634702, -0.796893, -2.152019>,
      < -6.632962, -0.796893, -2.167924>
    }
    triangle {
      < -6.634702, -0.812893, -2.152019>,
      < -6.632962, -0.796893, -2.167924>,
      < -6.632962, -0.812893, -2.167924>
    }
    triangle {
      < -6.671050, -0.812893, -1.819715>,
      < -6.671050, -0.796893, -1.819715>,
      < -6.669310, -0.796893, -1.835621>
    }
    triangle {
      < -6.671050, -0.812893, -1.819715>,
      < -6.669310, -0.796893, -1.835621>,
      < -6.669310, -0.812893, -1.835621>
    }
    triangle {
      < -6.707397, -0.812893, -1.487412>,
      < -6.707397, -0.796893, -1.487412>,
      < -6.705658, -0.796893, -1.503317>
    }
    triangle {
      < -6.707397, -0.812893, -1.487412>,
      < -6.705658, -0.796893, -1.503317>,
      < -6.705658, -0.812893, -1.503317>
    }
    triangle {
      < -6.743745, -0.812893, -1.155109>,
      < -6.743745, -0.796893, -1.155109>,
      < -6.742006, -0.796893, -1.171014>
    }
    triangle {
      < -6.743745, -0.812893, -1.155109>,
      < -6.742006, -0.796893, -1.171014>,
      < -6.742006, -0.812893, -1.171014>
    }
    triangle {
      < -6.780094, -0.812893, -0.822806>,
      < -6.780094, -0.796893, -0.822806>,
      < -6.778354, -0.796893, -0.838711>
    }
    triangle {
      < -6.780094, -0.812893, -0.822806>,
      < -6.778354, -0.796893, -0.838711>,
      < -6.778354, -0.812893, -0.838711>
    }
    triangle {
      < -6.816442, -0.812893, -0.490502>,
      < -6.816442, -0.796893, -0.490502>,
      < -6.814702, -0.796893, -0.506407>
    }
    triangle {
      < -6.816442, -0.812893, -0.490502>,
      < -6.814702, -0.796893, -0.506407>,
      < -6.814702, -0.812893, -0.506407>
    }
    triangle {
      < -6.852789, -0.812893, -0.158199>,
      < -6.852789, -0.796893, -0.158199>,
      < -6.851050, -0.796893, -0.174104>
    }
    triangle {
      < -6.852789, -0.812893, -0.158199>,
      < -6.851050, -0.796893, -0.174104>,
      < -6.851050, -0.812893, -0.174104>
    }
    triangle {
      < -6.832877, -0.812893, 0.340256>,
      < -6.832877, -0.796893, 0.340256>,
      < -6.834616, -0.796893, 0.324351>
    }
    triangle {
      < -6.832877, -0.812893, 0.340256>,
      < -6.834616, -0.796893, 0.324351>,
      < -6.834616, -0.812893, 0.324351>
    }
    triangle {
      < -6.796529, -0.812893, 0.672559>,
      < -6.796529, -0.796893, 0.672559>,
      < -6.798269, -0.796893, 0.656654>
    }
    triangle {
      < -6.796529, -0.812893, 0.672559>,
      < -6.798269, -0.796893, 0.656654>,
      < -6.798269, -0.812893, 0.656654>
    }
    triangle {
      < -6.760181, -0.812893, 1.004862>,
      < -6.760181, -0.796893, 1.004862>,
      < -6.761921, -0.796893, 0.988957>
    }
    triangle {
      < -6.760181, -0.812893, 1.004862>,
      < -6.761921, -0.796893, 0.988957>,
      < -6.761921, -0.812893, 0.988957>
    }
    triangle {
      < -6.723834, -0.812893, 1.337165>,
      < -6.723834, -0.796893, 1.337165>,
      < -6.725573, -0.796893, 1.321260>
    }
    triangle {
      < -6.723834, -0.812893, 1.337165>,
      < -6.725573, -0.796893, 1.321260>,
      < -6.725573, -0.812893, 1.321260>
    }
    triangle {
      < -6.687486, -0.812893, 1.669469>,
      < -6.687486, -0.796893, 1.669469>,
      < -6.689225, -0.796893, 1.653563>
    }
    triangle {
      < -6.687486, -0.812893, 1.669469>,
      < -6.689225, -0.796893, 1.653563>,
      < -6.689225, -0.812893, 1.653563>
    }
    triangle {
      < -6.651138, -0.812893, 2.001772>,
      < -6.651138, -0.796893, 2.001772>,
      < -6.652877, -0.796893, 1.985867>
    }
    triangle {
      < -6.651138, -0.812893, 2.001772>,
      < -6.652877, -0.796893, 1.985867>,
      < -6.652877, -0.812893, 1.985867>
    }
    triangle {
      < -6.614789, -0.812893, 2.334075>,
      < -6.614789, -0.796893, 2.334075>,
      < -6.616529, -0.796893, 2.318170>
    }
    triangle {
      < -6.614789, -0.812893, 2.334075>,
      < -6.616529, -0.796893, 2.318170>,
      < -6.616529, -0.812893, 2.318170>
    }
    triangle {
      < -6.580181, -0.880072, 2.650474>,
      < -6.571311, -0.872072, 2.658426>,
      < -6.580181, -0.864072, 2.650474>
    }
    triangle {
      < -6.596616, -0.812893, 2.500227>,
      < -6.596616, -0.796893, 2.500227>,
      < -6.598355, -0.796893, 2.484322>
    }
    triangle {
      < -6.596616, -0.812893, 2.500227>,
      < -6.598355, -0.796893, 2.484322>,
      < -6.598355, -0.812893, 2.484322>
    }
    triangle {
      < -6.632964, -0.812893, 2.167924>,
      < -6.632964, -0.796893, 2.167924>,
      < -6.634703, -0.796893, 2.152019>
    }
    triangle {
      < -6.632964, -0.812893, 2.167924>,
      < -6.634703, -0.796893, 2.152019>,
      < -6.634703, -0.812893, 2.152019>
    }
    triangle {
      < -6.669312, -0.812893, 1.835620>,
      < -6.669312, -0.796893, 1.835620>,
      < -6.671051, -0.796893, 1.819715>
    }
    triangle {
      < -6.669312, -0.812893, 1.835620>,
      < -6.671051, -0.796893, 1.819715>,
      < -6.671051, -0.812893, 1.819715>
    }
    triangle {
      < -6.705659, -0.812893, 1.503317>,
      < -6.705659, -0.796893, 1.503317>,
      < -6.707399, -0.796893, 1.487412>
    }
    triangle {
      < -6.705659, -0.812893, 1.503317>,
      < -6.707399, -0.796893, 1.487412>,
      < -6.707399, -0.812893, 1.487412>
    }
    triangle {
      < -6.742008, -0.812893, 1.171014>,
      < -6.742008, -0.796893, 1.171014>,
      < -6.743747, -0.796893, 1.155109>
    }
    triangle {
      < -6.742008, -0.812893, 1.171014>,
      < -6.743747, -0.796893, 1.155109>,
      < -6.743747, -0.812893, 1.155109>
    }
    triangle {
      < -6.778356, -0.812893, 0.838711>,
      < -6.778356, -0.796893, 0.838711>,
      < -6.780095, -0.796893, 0.822805>
    }
    triangle {
      < -6.778356, -0.812893, 0.838711>,
      < -6.780095, -0.796893, 0.822805>,
      < -6.780095, -0.812893, 0.822805>
    }
    triangle {
      < -6.814703, -0.812893, 0.506407>,
      < -6.814703, -0.796893, 0.506407>,
      < -6.816443, -0.796893, 0.490502>
    }
    triangle {
      < -6.814703, -0.812893, 0.506407>,
      < -6.816443, -0.796893, 0.490502>,
      < -6.816443, -0.812893, 0.490502>
    }
    triangle {
      < -6.851051, -0.812893, 0.174104>,
      < -6.851051, -0.796893, 0.174104>,
      < -6.852790, -0.796893, 0.158199>
    }
    triangle {
      < -6.851051, -0.812893, 0.174104>,
      < -6.852790, -0.796893, 0.158199>,
      < -6.852790, -0.812893, 0.158199>
    }
    triangle {
      < -6.834615, -0.812893, -0.324351>,
      < -6.834615, -0.796893, -0.324351>,
      < -6.832876, -0.796893, -0.340256>
    }
    triangle {
      < -6.834615, -0.812893, -0.324351>,
      < -6.832876, -0.796893, -0.340256>,
      < -6.832876, -0.812893, -0.340256>
    }
    triangle {
      < -6.798267, -0.812893, -0.656654>,
      < -6.798267, -0.796893, -0.656654>,
      < -6.796528, -0.796893, -0.672559>
    }
    triangle {
      < -6.798267, -0.812893, -0.656654>,
      < -6.796528, -0.796893, -0.672559>,
      < -6.796528, -0.812893, -0.672559>
    }
    triangle {
      < -6.761919, -0.812893, -0.988958>,
      < -6.761919, -0.796893, -0.988958>,
      < -6.760180, -0.796893, -1.004863>
    }
    triangle {
      < -6.761919, -0.812893, -0.988958>,
      < -6.760180, -0.796893, -1.004863>,
      < -6.760180, -0.812893, -1.004863>
    }
    triangle {
      < -6.725572, -0.812893, -1.321261>,
      < -6.725572, -0.796893, -1.321261>,
      < -6.723832, -0.796893, -1.337166>
    }
    triangle {
      < -6.725572, -0.812893, -1.321261>,
      < -6.723832, -0.796893, -1.337166>,
      < -6.723832, -0.812893, -1.337166>
    }
    triangle {
      < -6.689224, -0.812893, -1.653564>,
      < -6.689224, -0.796893, -1.653564>,
      < -6.687484, -0.796893, -1.669469>
    }
    triangle {
      < -6.689224, -0.812893, -1.653564>,
      < -6.687484, -0.796893, -1.669469>,
      < -6.687484, -0.812893, -1.669469>
    }
    triangle {
      < -6.652875, -0.812893, -1.985867>,
      < -6.652875, -0.796893, -1.985867>,
      < -6.651136, -0.796893, -2.001772>
    }
    triangle {
      < -6.652875, -0.812893, -1.985867>,
      < -6.651136, -0.796893, -2.001772>,
      < -6.651136, -0.812893, -2.001772>
    }
    triangle {
      < -6.616529, -0.812893, -2.318170>,
      < -6.616529, -0.796893, -2.318170>,
      < -6.614789, -0.796893, -2.334075>
    }
    triangle {
      < -6.616529, -0.812893, -2.318170>,
      < -6.614789, -0.796893, -2.334075>,
      < -6.614789, -0.812893, -2.334075>
    }
    triangle {
      < -6.869224, -0.745714, 0.007953>,
      < -6.869224, -0.729714, 0.007953>,
      < -6.869224, -0.729714, -0.007953>
    }
    triangle {
      < -6.869224, -0.745714, 0.007953>,
      < -6.869224, -0.729714, -0.007953>,
      < -6.869224, -0.745714, -0.007953>
    }
    triangle {
      < -6.580181, -0.729714, -2.650473>,
      < -6.571311, -0.737714, -2.658426>,
      < -6.580181, -0.745714, -2.650473>
    }
    triangle {
      < -6.598354, -0.745714, -2.484322>,
      < -6.598354, -0.729714, -2.484322>,
      < -6.596615, -0.729714, -2.500227>
    }
    triangle {
      < -6.598354, -0.745714, -2.484322>,
      < -6.596615, -0.729714, -2.500227>,
      < -6.596615, -0.745714, -2.500227>
    }
    triangle {
      < -6.634702, -0.745714, -2.152019>,
      < -6.634702, -0.729714, -2.152019>,
      < -6.632962, -0.729714, -2.167924>
    }
    triangle {
      < -6.634702, -0.745714, -2.152019>,
      < -6.632962, -0.729714, -2.167924>,
      < -6.632962, -0.745714, -2.167924>
    }
    triangle {
      < -6.671050, -0.745714, -1.819715>,
      < -6.671050, -0.729714, -1.819715>,
      < -6.669310, -0.729714, -1.835621>
    }
    triangle {
      < -6.671050, -0.745714, -1.819715>,
      < -6.669310, -0.729714, -1.835621>,
      < -6.669310, -0.745714, -1.835621>
    }
    triangle {
      < -6.707397, -0.745714, -1.487412>,
      < -6.707397, -0.729714, -1.487412>,
      < -6.705658, -0.729714, -1.503317>
    }
    triangle {
      < -6.707397, -0.745714, -1.487412>,
      < -6.705658, -0.729714, -1.503317>,
      < -6.705658, -0.745714, -1.503317>
    }
    triangle {
      < -6.743745, -0.745714, -1.155109>,
      < -6.743745, -0.729714, -1.155109>,
      < -6.742006, -0.729714, -1.171014>
    }
    triangle {
      < -6.743745, -0.745714, -1.155109>,
      < -6.742006, -0.729714, -1.171014>,
      < -6.742006, -0.745714, -1.171014>
    }
    triangle {
      < -6.780094, -0.745714, -0.822806>,
      < -6.780094, -0.729714, -0.822806>,
      < -6.778354, -0.729714, -0.838711>
    }
    triangle {
      < -6.780094, -0.745714, -0.822806>,
      < -6.778354, -0.729714, -0.838711>,
      < -6.778354, -0.745714, -0.838711>
    }
    triangle {
      < -6.816442, -0.745714, -0.490502>,
      < -6.816442, -0.729714, -0.490502>,
      < -6.814702, -0.729714, -0.506407>
    }
    triangle {
      < -6.816442, -0.745714, -0.490502>,
      < -6.814702, -0.729714, -0.506407>,
      < -6.814702, -0.745714, -0.506407>
    }
    triangle {
      < -6.852789, -0.745714, -0.158199>,
      < -6.852789, -0.729714, -0.158199>,
      < -6.851050, -0.729714, -0.174104>
    }
    triangle {
      < -6.852789, -0.745714, -0.158199>,
      < -6.851050, -0.729714, -0.174104>,
      < -6.851050, -0.745714, -0.174104>
    }
    triangle {
      < -6.832877, -0.745714, 0.340256>,
      < -6.832877, -0.729714, 0.340256>,
      < -6.834616, -0.729714, 0.324351>
    }
    triangle {
      < -6.832877, -0.745714, 0.340256>,
      < -6.834616, -0.729714, 0.324351>,
      < -6.834616, -0.745714, 0.324351>
    }
    triangle {
      < -6.796529, -0.745714, 0.672559>,
      < -6.796529, -0.729714, 0.672559>,
      < -6.798269, -0.729714, 0.656654>
    }
    triangle {
      < -6.796529, -0.745714, 0.672559>,
      < -6.798269, -0.729714, 0.656654>,
      < -6.798269, -0.745714, 0.656654>
    }
    triangle {
      < -6.760181, -0.745714, 1.004862>,
      < -6.760181, -0.729714, 1.004862>,
      < -6.761921, -0.729714, 0.988957>
    }
    triangle {
      < -6.760181, -0.745714, 1.004862>,
      < -6.761921, -0.729714, 0.988957>,
      < -6.761921, -0.745714, 0.988957>
    }
    triangle {
      < -6.723834, -0.745714, 1.337165>,
      < -6.723834, -0.729714, 1.337165>,
      < -6.725573, -0.729714, 1.321260>
    }
    triangle {
      < -6.723834, -0.745714, 1.337165>,
      < -6.725573, -0.729714, 1.321260>,
      < -6.725573, -0.745714, 1.321260>
    }
    triangle {
      < -6.687486, -0.745714, 1.669469>,
      < -6.687486, -0.729714, 1.669469>,
      < -6.689225, -0.729714, 1.653563>
    }
    triangle {
      < -6.687486, -0.745714, 1.669469>,
      < -6.689225, -0.729714, 1.653563>,
      < -6.689225, -0.745714, 1.653563>
    }
    triangle {
      < -6.651138, -0.745714, 2.001772>,
      < -6.651138, -0.729714, 2.001772>,
      < -6.652877, -0.729714, 1.985867>
    }
    triangle {
      < -6.651138, -0.745714, 2.001772>,
      < -6.652877, -0.729714, 1.985867>,
      < -6.652877, -0.745714, 1.985867>
    }
    triangle {
      < -6.614789, -0.745714, 2.334075>,
      < -6.614789, -0.729714, 2.334075>,
      < -6.616529, -0.729714, 2.318170>
    }
    triangle {
      < -6.614789, -0.745714, 2.334075>,
      < -6.616529, -0.729714, 2.318170>,
      < -6.616529, -0.745714, 2.318170>
    }
    triangle {
      < -6.616529, -0.745714, -2.318170>,
      < -6.616529, -0.729714, -2.318170>,
      < -6.614789, -0.729714, -2.334075>
    }
    triangle {
      < -6.616529, -0.745714, -2.318170>,
      < -6.614789, -0.729714, -2.334075>,
      < -6.614789, -0.745714, -2.334075>
    }
    triangle {
      < -6.652875, -0.745714, -1.985867>,
      < -6.652875, -0.729714, -1.985867>,
      < -6.651136, -0.729714, -2.001772>
    }
    triangle {
      < -6.652875, -0.745714, -1.985867>,
      < -6.651136, -0.729714, -2.001772>,
      < -6.651136, -0.745714, -2.001772>
    }
    triangle {
      < -6.689224, -0.745714, -1.653564>,
      < -6.689224, -0.729714, -1.653564>,
      < -6.687484, -0.729714, -1.669469>
    }
    triangle {
      < -6.689224, -0.745714, -1.653564>,
      < -6.687484, -0.729714, -1.669469>,
      < -6.687484, -0.745714, -1.669469>
    }
    triangle {
      < -6.725572, -0.745714, -1.321261>,
      < -6.725572, -0.729714, -1.321261>,
      < -6.723832, -0.729714, -1.337166>
    }
    triangle {
      < -6.725572, -0.745714, -1.321261>,
      < -6.723832, -0.729714, -1.337166>,
      < -6.723832, -0.745714, -1.337166>
    }
    triangle {
      < -6.761919, -0.745714, -0.988958>,
      < -6.761919, -0.729714, -0.988958>,
      < -6.760180, -0.729714, -1.004863>
    }
    triangle {
      < -6.761919, -0.745714, -0.988958>,
      < -6.760180, -0.729714, -1.004863>,
      < -6.760180, -0.745714, -1.004863>
    }
    triangle {
      < -6.798267, -0.745714, -0.656654>,
      < -6.798267, -0.729714, -0.656654>,
      < -6.796528, -0.729714, -0.672559>
    }
    triangle {
      < -6.798267, -0.745714, -0.656654>,
      < -6.796528, -0.729714, -0.672559>,
      < -6.796528, -0.745714, -0.672559>
    }
    triangle {
      < -6.834615, -0.745714, -0.324351>,
      < -6.834615, -0.729714, -0.324351>,
      < -6.832876, -0.729714, -0.340256>
    }
    triangle {
      < -6.834615, -0.745714, -0.324351>,
      < -6.832876, -0.729714, -0.340256>,
      < -6.832876, -0.745714, -0.340256>
    }
    triangle {
      < -6.851051, -0.745714, 0.174104>,
      < -6.851051, -0.729714, 0.174104>,
      < -6.852790, -0.729714, 0.158199>
    }
    triangle {
      < -6.851051, -0.745714, 0.174104>,
      < -6.852790, -0.729714, 0.158199>,
      < -6.852790, -0.745714, 0.158199>
    }
    triangle {
      < -6.814703, -0.745714, 0.506407>,
      < -6.814703, -0.729714, 0.506407>,
      < -6.816443, -0.729714, 0.490502>
    }
    triangle {
      < -6.814703, -0.745714, 0.506407>,
      < -6.816443, -0.729714, 0.490502>,
      < -6.816443, -0.745714, 0.490502>
    }
    triangle {
      < -6.778356, -0.745714, 0.838711>,
      < -6.778356, -0.729714, 0.838711>,
      < -6.780095, -0.729714, 0.822805>
    }
    triangle {
      < -6.778356, -0.745714, 0.838711>,
      < -6.780095, -0.729714, 0.822805>,
      < -6.780095, -0.745714, 0.822805>
    }
    triangle {
      < -6.742008, -0.745714, 1.171014>,
      < -6.742008, -0.729714, 1.171014>,
      < -6.743747, -0.729714, 1.155109>
    }
    triangle {
      < -6.742008, -0.745714, 1.171014>,
      < -6.743747, -0.729714, 1.155109>,
      < -6.743747, -0.745714, 1.155109>
    }
    triangle {
      < -6.705659, -0.745714, 1.503317>,
      < -6.705659, -0.729714, 1.503317>,
      < -6.707399, -0.729714, 1.487412>
    }
    triangle {
      < -6.705659, -0.745714, 1.503317>,
      < -6.707399, -0.729714, 1.487412>,
      < -6.707399, -0.745714, 1.487412>
    }
    triangle {
      < -6.669312, -0.745714, 1.835620>,
      < -6.669312, -0.729714, 1.835620>,
      < -6.671051, -0.729714, 1.819715>
    }
    triangle {
      < -6.669312, -0.745714, 1.835620>,
      < -6.671051, -0.729714, 1.819715>,
      < -6.671051, -0.745714, 1.819715>
    }
    triangle {
      < -6.632964, -0.745714, 2.167924>,
      < -6.632964, -0.729714, 2.167924>,
      < -6.634703, -0.729714, 2.152019>
    }
    triangle {
      < -6.632964, -0.745714, 2.167924>,
      < -6.634703, -0.729714, 2.152019>,
      < -6.634703, -0.745714, 2.152019>
    }
    triangle {
      < -6.580181, -0.812893, 2.650474>,
      < -6.571311, -0.804893, 2.658426>,
      < -6.580181, -0.796893, 2.650474>
    }
    triangle {
      < -6.596616, -0.745714, 2.500227>,
      < -6.596616, -0.729714, 2.500227>,
      < -6.598355, -0.729714, 2.484322>
    }
    triangle {
      < -6.596616, -0.745714, 2.500227>,
      < -6.598355, -0.729714, 2.484322>,
      < -6.598355, -0.745714, 2.484322>
    }
    triangle {
      < -6.869224, -0.678535, 0.007953>,
      < -6.869224, -0.662535, 0.007953>,
      < -6.869224, -0.662535, -0.007953>
    }
    triangle {
      < -6.869224, -0.678535, 0.007953>,
      < -6.869224, -0.662535, -0.007953>,
      < -6.869224, -0.678535, -0.007953>
    }
    triangle {
      < -6.580181, -0.662535, -2.650473>,
      < -6.571311, -0.670535, -2.658426>,
      < -6.580181, -0.678535, -2.650473>
    }
    triangle {
      < -6.598354, -0.678535, -2.484322>,
      < -6.598354, -0.662535, -2.484322>,
      < -6.596615, -0.662535, -2.500227>
    }
    triangle {
      < -6.598354, -0.678535, -2.484322>,
      < -6.596615, -0.662535, -2.500227>,
      < -6.596615, -0.678535, -2.500227>
    }
    triangle {
      < -6.634702, -0.678535, -2.152019>,
      < -6.634702, -0.662535, -2.152019>,
      < -6.632962, -0.662535, -2.167924>
    }
    triangle {
      < -6.634702, -0.678535, -2.152019>,
      < -6.632962, -0.662535, -2.167924>,
      < -6.632962, -0.678535, -2.167924>
    }
    triangle {
      < -6.671050, -0.678535, -1.819715>,
      < -6.671050, -0.662535, -1.819715>,
      < -6.669310, -0.662535, -1.835621>
    }
    triangle {
      < -6.671050, -0.678535, -1.819715>,
      < -6.669310, -0.662535, -1.835621>,
      < -6.669310, -0.678535, -1.835621>
    }
    triangle {
      < -6.707397, -0.678535, -1.487412>,
      < -6.707397, -0.662535, -1.487412>,
      < -6.705658, -0.662535, -1.503318>
    }
    triangle {
      < -6.707397, -0.678535, -1.487412>,
      < -6.705658, -0.662535, -1.503318>,
      < -6.705658, -0.678535, -1.503318>
    }
    triangle {
      < -6.743745, -0.678535, -1.155109>,
      < -6.743745, -0.662535, -1.155109>,
      < -6.742006, -0.662535, -1.171014>
    }
    triangle {
      < -6.743745, -0.678535, -1.155109>,
      < -6.742006, -0.662535, -1.171014>,
      < -6.742006, -0.678535, -1.171014>
    }
    triangle {
      < -6.780094, -0.678535, -0.822806>,
      < -6.780094, -0.662535, -0.822806>,
      < -6.778354, -0.662535, -0.838711>
    }
    triangle {
      < -6.780094, -0.678535, -0.822806>,
      < -6.778354, -0.662535, -0.838711>,
      < -6.778354, -0.678535, -0.838711>
    }
    triangle {
      < -6.816442, -0.678535, -0.490502>,
      < -6.816442, -0.662535, -0.490503>,
      < -6.814702, -0.662535, -0.506408>
    }
    triangle {
      < -6.816442, -0.678535, -0.490502>,
      < -6.814702, -0.662535, -0.506408>,
      < -6.814702, -0.678535, -0.506407>
    }
    triangle {
      < -6.852789, -0.678535, -0.158199>,
      < -6.852789, -0.662535, -0.158199>,
      < -6.851050, -0.662535, -0.174104>
    }
    triangle {
      < -6.852789, -0.678535, -0.158199>,
      < -6.851050, -0.662535, -0.174104>,
      < -6.851050, -0.678535, -0.174104>
    }
    triangle {
      < -6.832877, -0.678535, 0.340256>,
      < -6.832877, -0.662535, 0.340256>,
      < -6.834616, -0.662535, 0.324351>
    }
    triangle {
      < -6.832877, -0.678535, 0.340256>,
      < -6.834616, -0.662535, 0.324351>,
      < -6.834616, -0.678535, 0.324351>
    }
    triangle {
      < -6.796529, -0.678535, 0.672559>,
      < -6.796529, -0.662535, 0.672559>,
      < -6.798269, -0.662535, 0.656654>
    }
    triangle {
      < -6.796529, -0.678535, 0.672559>,
      < -6.798269, -0.662535, 0.656654>,
      < -6.798269, -0.678535, 0.656654>
    }
    triangle {
      < -6.760181, -0.678535, 1.004862>,
      < -6.760181, -0.662535, 1.004862>,
      < -6.761921, -0.662535, 0.988957>
    }
    triangle {
      < -6.760181, -0.678535, 1.004862>,
      < -6.761921, -0.662535, 0.988957>,
      < -6.761921, -0.678535, 0.988957>
    }
    triangle {
      < -6.723834, -0.678535, 1.337165>,
      < -6.723834, -0.662535, 1.337165>,
      < -6.725573, -0.662535, 1.321260>
    }
    triangle {
      < -6.723834, -0.678535, 1.337165>,
      < -6.725573, -0.662535, 1.321260>,
      < -6.725573, -0.678535, 1.321260>
    }
    triangle {
      < -6.687486, -0.678535, 1.669469>,
      < -6.687486, -0.662535, 1.669469>,
      < -6.689225, -0.662535, 1.653563>
    }
    triangle {
      < -6.687486, -0.678535, 1.669469>,
      < -6.689225, -0.662535, 1.653563>,
      < -6.689225, -0.678535, 1.653563>
    }
    triangle {
      < -6.651138, -0.678535, 2.001772>,
      < -6.651138, -0.662535, 2.001772>,
      < -6.652877, -0.662535, 1.985867>
    }
    triangle {
      < -6.651138, -0.678535, 2.001772>,
      < -6.652877, -0.662535, 1.985867>,
      < -6.652877, -0.678535, 1.985867>
    }
    triangle {
      < -6.614789, -0.678535, 2.334075>,
      < -6.614789, -0.662535, 2.334075>,
      < -6.616529, -0.662535, 2.318170>
    }
    triangle {
      < -6.614789, -0.678535, 2.334075>,
      < -6.616529, -0.662535, 2.318170>,
      < -6.616529, -0.678535, 2.318170>
    }
    triangle {
      < -6.580181, -0.745714, 2.650474>,
      < -6.571311, -0.737714, 2.658426>,
      < -6.580181, -0.729714, 2.650474>
    }
    triangle {
      < -6.596616, -0.678535, 2.500227>,
      < -6.596616, -0.662535, 2.500227>,
      < -6.598355, -0.662535, 2.484322>
    }
    triangle {
      < -6.596616, -0.678535, 2.500227>,
      < -6.598355, -0.662535, 2.484322>,
      < -6.598355, -0.678535, 2.484322>
    }
    triangle {
      < -6.632964, -0.678535, 2.167924>,
      < -6.632964, -0.662535, 2.167924>,
      < -6.634703, -0.662535, 2.152019>
    }
    triangle {
      < -6.632964, -0.678535, 2.167924>,
      < -6.634703, -0.662535, 2.152019>,
      < -6.634703, -0.678535, 2.152019>
    }
    triangle {
      < -6.669312, -0.678535, 1.835620>,
      < -6.669312, -0.662535, 1.835620>,
      < -6.671051, -0.662535, 1.819715>
    }
    triangle {
      < -6.669312, -0.678535, 1.835620>,
      < -6.671051, -0.662535, 1.819715>,
      < -6.671051, -0.678535, 1.819715>
    }
    triangle {
      < -6.705659, -0.678535, 1.503317>,
      < -6.705659, -0.662535, 1.503317>,
      < -6.707399, -0.662535, 1.487412>
    }
    triangle {
      < -6.705659, -0.678535, 1.503317>,
      < -6.707399, -0.662535, 1.487412>,
      < -6.707399, -0.678535, 1.487412>
    }
    triangle {
      < -6.742008, -0.678535, 1.171014>,
      < -6.742008, -0.662535, 1.171014>,
      < -6.743747, -0.662535, 1.155109>
    }
    triangle {
      < -6.742008, -0.678535, 1.171014>,
      < -6.743747, -0.662535, 1.155109>,
      < -6.743747, -0.678535, 1.155109>
    }
    triangle {
      < -6.778356, -0.678535, 0.838711>,
      < -6.778356, -0.662535, 0.838711>,
      < -6.780095, -0.662535, 0.822805>
    }
    triangle {
      < -6.778356, -0.678535, 0.838711>,
      < -6.780095, -0.662535, 0.822805>,
      < -6.780095, -0.678535, 0.822805>
    }
    triangle {
      < -6.814703, -0.678535, 0.506407>,
      < -6.814703, -0.662535, 0.506407>,
      < -6.816443, -0.662535, 0.490502>
    }
    triangle {
      < -6.814703, -0.678535, 0.506407>,
      < -6.816443, -0.662535, 0.490502>,
      < -6.816443, -0.678535, 0.490502>
    }
    triangle {
      < -6.851051, -0.678535, 0.174104>,
      < -6.851051, -0.662535, 0.174104>,
      < -6.852790, -0.662535, 0.158199>
    }
    triangle {
      < -6.851051, -0.678535, 0.174104>,
      < -6.852790, -0.662535, 0.158199>,
      < -6.852790, -0.678535, 0.158199>
    }
    triangle {
      < -6.834615, -0.678535, -0.324351>,
      < -6.834615, -0.662535, -0.324351>,
      < -6.832876, -0.662535, -0.340256>
    }
    triangle {
      < -6.834615, -0.678535, -0.324351>,
      < -6.832876, -0.662535, -0.340256>,
      < -6.832876, -0.678535, -0.340256>
    }
    triangle {
      < -6.798267, -0.678535, -0.656654>,
      < -6.798267, -0.662535, -0.656654>,
      < -6.796528, -0.662535, -0.672559>
    }
    triangle {
      < -6.798267, -0.678535, -0.656654>,
      < -6.796528, -0.662535, -0.672559>,
      < -6.796528, -0.678535, -0.672559>
    }
    triangle {
      < -6.761919, -0.678535, -0.988958>,
      < -6.761919, -0.662535, -0.988958>,
      < -6.760180, -0.662535, -1.004863>
    }
    triangle {
      < -6.761919, -0.678535, -0.988958>,
      < -6.760180, -0.662535, -1.004863>,
      < -6.760180, -0.678535, -1.004863>
    }
    triangle {
      < -6.725572, -0.678535, -1.321261>,
      < -6.725572, -0.662535, -1.321261>,
      < -6.723832, -0.662535, -1.337166>
    }
    triangle {
      < -6.725572, -0.678535, -1.321261>,
      < -6.723832, -0.662535, -1.337166>,
      < -6.723832, -0.678535, -1.337166>
    }
    triangle {
      < -6.689224, -0.678535, -1.653564>,
      < -6.689224, -0.662535, -1.653564>,
      < -6.687484, -0.662535, -1.669469>
    }
    triangle {
      < -6.689224, -0.678535, -1.653564>,
      < -6.687484, -0.662535, -1.669469>,
      < -6.687484, -0.678535, -1.669469>
    }
    triangle {
      < -6.652875, -0.678535, -1.985867>,
      < -6.652875, -0.662535, -1.985867>,
      < -6.651136, -0.662535, -2.001772>
    }
    triangle {
      < -6.652875, -0.678535, -1.985867>,
      < -6.651136, -0.662535, -2.001772>,
      < -6.651136, -0.678535, -2.001772>
    }
    triangle {
      < -6.616529, -0.678535, -2.318170>,
      < -6.616529, -0.662535, -2.318170>,
      < -6.614789, -0.662535, -2.334075>
    }
    triangle {
      < -6.616529, -0.678535, -2.318170>,
      < -6.614789, -0.662535, -2.334075>,
      < -6.614789, -0.678535, -2.334075>
    }
    triangle {
      < -6.869224, -0.611356, 0.007953>,
      < -6.862093, -0.603356, 0.000000>,
      < -6.869224, -0.611356, -0.007953>
    }
    triangle {
      < -6.598354, -0.611356, -2.484322>,
      < -6.589485, -0.603356, -2.492275>,
      < -6.596615, -0.611356, -2.500227>
    }
    triangle {
      < -6.616529, -0.611356, -2.318170>,
      < -6.607658, -0.603356, -2.326123>,
      < -6.614789, -0.611356, -2.334075>
    }
    triangle {
      < -6.634702, -0.611356, -2.152019>,
      < -6.625832, -0.603356, -2.159971>,
      < -6.632962, -0.611356, -2.167924>
    }
    triangle {
      < -6.652875, -0.611356, -1.985867>,
      < -6.644006, -0.603356, -1.993820>,
      < -6.651136, -0.611356, -2.001772>
    }
    triangle {
      < -6.671050, -0.611356, -1.819715>,
      < -6.662179, -0.603356, -1.827668>,
      < -6.669310, -0.611356, -1.835621>
    }
    triangle {
      < -6.689224, -0.611356, -1.653564>,
      < -6.680354, -0.603356, -1.661516>,
      < -6.687484, -0.611356, -1.669469>
    }
    triangle {
      < -6.707397, -0.611356, -1.487412>,
      < -6.698528, -0.603356, -1.495365>,
      < -6.705658, -0.611356, -1.503318>
    }
    triangle {
      < -6.725572, -0.611356, -1.321261>,
      < -6.716702, -0.603356, -1.329213>,
      < -6.723832, -0.611356, -1.337166>
    }
    triangle {
      < -6.743745, -0.611356, -1.155109>,
      < -6.734876, -0.603356, -1.163062>,
      < -6.742006, -0.611356, -1.171014>
    }
    triangle {
      < -6.761919, -0.611356, -0.988958>,
      < -6.753049, -0.603356, -0.996910>,
      < -6.760180, -0.611356, -1.004863>
    }
    triangle {
      < -6.780094, -0.611356, -0.822806>,
      < -6.771224, -0.603356, -0.830759>,
      < -6.778354, -0.611356, -0.838711>
    }
    triangle {
      < -6.798267, -0.611356, -0.656654>,
      < -6.789398, -0.603356, -0.664607>,
      < -6.796528, -0.611356, -0.672559>
    }
    triangle {
      < -6.816442, -0.611356, -0.490503>,
      < -6.807571, -0.603356, -0.498455>,
      < -6.814702, -0.611356, -0.506408>
    }
    triangle {
      < -6.834615, -0.611356, -0.324351>,
      < -6.825746, -0.603356, -0.332304>,
      < -6.832876, -0.611356, -0.340256>
    }
    triangle {
      < -6.852789, -0.611356, -0.158199>,
      < -6.843919, -0.603356, -0.166152>,
      < -6.851050, -0.611356, -0.174104>
    }
    triangle {
      < -6.851051, -0.611356, 0.174104>,
      < -6.843920, -0.603356, 0.166151>,
      < -6.852790, -0.611356, 0.158199>
    }
    triangle {
      < -6.832877, -0.611356, 0.340256>,
      < -6.825746, -0.603356, 0.332303>,
      < -6.834616, -0.611356, 0.324351>
    }
    triangle {
      < -6.814703, -0.611356, 0.506407>,
      < -6.807573, -0.603356, 0.498455>,
      < -6.816443, -0.611356, 0.490502>
    }
    triangle {
      < -6.796529, -0.611356, 0.672559>,
      < -6.789399, -0.603356, 0.664606>,
      < -6.798269, -0.611356, 0.656654>
    }
    triangle {
      < -6.778356, -0.611356, 0.838711>,
      < -6.771225, -0.603356, 0.830758>,
      < -6.780095, -0.611356, 0.822805>
    }
    triangle {
      < -6.760181, -0.611356, 1.004862>,
      < -6.753051, -0.603356, 0.996910>,
      < -6.761921, -0.611356, 0.988957>
    }
    triangle {
      < -6.742008, -0.611356, 1.171014>,
      < -6.734877, -0.603356, 1.163061>,
      < -6.743747, -0.611356, 1.155109>
    }
    triangle {
      < -6.723834, -0.611356, 1.337165>,
      < -6.716703, -0.603356, 1.329213>,
      < -6.725573, -0.611356, 1.321260>
    }
    triangle {
      < -6.705659, -0.611356, 1.503317>,
      < -6.698529, -0.603356, 1.495364>,
      < -6.707399, -0.611356, 1.487412>
    }
    triangle {
      < -6.687486, -0.611356, 1.669469>,
      < -6.680355, -0.603356, 1.661516>,
      < -6.689225, -0.611356, 1.653563>
    }
    triangle {
      < -6.669312, -0.611356, 1.835620>,
      < -6.662181, -0.603356, 1.827668>,
      < -6.671051, -0.611356, 1.819715>
    }
    triangle {
      < -6.651138, -0.611356, 2.001772>,
      < -6.644007, -0.603356, 1.993819>,
      < -6.652877, -0.611356, 1.985867>
    }
    triangle {
      < -6.632964, -0.611356, 2.167924>,
      < -6.625833, -0.603356, 2.159971>,
      < -6.634703, -0.611356, 2.152019>
    }
    triangle {
      < -6.614789, -0.611356, 2.334075>,
      < -6.607659, -0.603356, 2.326123>,
      < -6.616529, -0.611356, 2.318170>
    }
    triangle {
      < -6.580181, -0.678535, 2.650474>,
      < -6.571311, -0.670535, 2.658426>,
      < -6.580181, -0.662535, 2.650474>
    }
    triangle {
      < -6.596616, -0.611356, 2.500227>,
      < -6.589485, -0.603356, 2.492275>,
      < -6.598355, -0.611356, 2.484322>
    }
    triangle {
      < -6.598355, -1.484684, 2.484322>,
      < -6.598354, -1.535863, 2.484322>,
      < -6.596615, -1.535863, 2.500227>
    }
    triangle {
      < -6.598355, -1.484684, 2.484322>,
      < -6.596615, -1.535863, 2.500227>,
      < -6.596616, -1.484684, 2.500227>
    }
    triangle {
      < -6.580181, -1.468684, 2.650474>,
      < -6.596616, -1.468684, 2.500227>,
      < -6.596616, -1.484684, 2.500227>
    }
    triangle {
      < -6.580181, -1.468684, 2.650474>,
      < -6.596616, -1.484684, 2.500227>,
      < -6.580181, -1.484684, 2.650474>
    }
    triangle {
      < -6.598355, -1.417505, 2.484322>,
      < -6.598355, -1.468684, 2.484322>,
      < -6.596616, -1.468684, 2.500227>
    }
    triangle {
      < -6.598355, -1.417505, 2.484322>,
      < -6.596616, -1.468684, 2.500227>,
      < -6.596616, -1.417505, 2.500227>
    }
    triangle {
      < -6.598355, -1.468684, 2.484322>,
      < -6.614789, -1.468684, 2.334076>,
      < -6.614789, -1.484684, 2.334076>
    }
    triangle {
      < -6.598355, -1.468684, 2.484322>,
      < -6.614789, -1.484684, 2.334076>,
      < -6.598355, -1.484684, 2.484322>
    }
    triangle {
      < -6.634703, -1.484684, 2.152019>,
      < -6.634702, -1.535863, 2.152019>,
      < -6.632963, -1.535863, 2.167924>
    }
    triangle {
      < -6.634703, -1.484684, 2.152019>,
      < -6.632963, -1.535863, 2.167924>,
      < -6.632964, -1.484684, 2.167924>
    }
    triangle {
      < -6.616529, -1.468684, 2.318171>,
      < -6.632964, -1.468684, 2.167924>,
      < -6.632964, -1.484684, 2.167924>
    }
    triangle {
      < -6.616529, -1.468684, 2.318171>,
      < -6.632964, -1.484684, 2.167924>,
      < -6.616529, -1.484684, 2.318171>
    }
    triangle {
      < -6.634703, -1.417505, 2.152019>,
      < -6.634703, -1.468684, 2.152019>,
      < -6.632964, -1.468684, 2.167924>
    }
    triangle {
      < -6.634703, -1.417505, 2.152019>,
      < -6.632964, -1.468684, 2.167924>,
      < -6.632964, -1.417505, 2.167924>
    }
    triangle {
      < -6.634703, -1.468684, 2.152019>,
      < -6.651137, -1.468684, 2.001772>,
      < -6.651137, -1.484684, 2.001772>
    }
    triangle {
      < -6.634703, -1.468684, 2.152019>,
      < -6.651137, -1.484684, 2.001772>,
      < -6.634703, -1.484684, 2.152019>
    }
    triangle {
      < -6.671050, -1.484684, 1.819715>,
      < -6.671050, -1.535863, 1.819715>,
      < -6.669310, -1.535863, 1.835621>
    }
    triangle {
      < -6.671050, -1.484684, 1.819715>,
      < -6.669310, -1.535863, 1.835621>,
      < -6.669310, -1.484684, 1.835621>
    }
    triangle {
      < -6.652876, -1.468684, 1.985867>,
      < -6.669310, -1.468684, 1.835621>,
      < -6.669310, -1.484684, 1.835621>
    }
    triangle {
      < -6.652876, -1.468684, 1.985867>,
      < -6.669310, -1.484684, 1.835621>,
      < -6.652876, -1.484684, 1.985867>
    }
    triangle {
      < -6.671051, -1.417505, 1.819715>,
      < -6.671050, -1.468684, 1.819715>,
      < -6.669310, -1.468684, 1.835621>
    }
    triangle {
      < -6.671051, -1.417505, 1.819715>,
      < -6.669310, -1.468684, 1.835621>,
      < -6.669311, -1.417505, 1.835621>
    }
    triangle {
      < -6.671050, -1.468684, 1.819715>,
      < -6.687485, -1.468684, 1.669469>,
      < -6.687485, -1.484684, 1.669469>
    }
    triangle {
      < -6.671050, -1.468684, 1.819715>,
      < -6.687485, -1.484684, 1.669469>,
      < -6.671050, -1.484684, 1.819715>
    }
    triangle {
      < -6.707397, -1.484684, 1.487412>,
      < -6.707397, -1.535863, 1.487412>,
      < -6.705658, -1.535863, 1.503317>
    }
    triangle {
      < -6.707397, -1.484684, 1.487412>,
      < -6.705658, -1.535863, 1.503317>,
      < -6.705658, -1.484684, 1.503317>
    }
    triangle {
      < -6.689224, -1.468684, 1.653564>,
      < -6.705658, -1.468684, 1.503317>,
      < -6.705658, -1.484684, 1.503317>
    }
    triangle {
      < -6.689224, -1.468684, 1.653564>,
      < -6.705658, -1.484684, 1.503317>,
      < -6.689224, -1.484684, 1.653564>
    }
    triangle {
      < -6.707398, -1.417505, 1.487412>,
      < -6.707397, -1.468684, 1.487412>,
      < -6.705658, -1.468684, 1.503317>
    }
    triangle {
      < -6.707398, -1.417505, 1.487412>,
      < -6.705658, -1.468684, 1.503317>,
      < -6.705659, -1.417505, 1.503317>
    }
    triangle {
      < -6.707397, -1.468684, 1.487412>,
      < -6.723833, -1.468684, 1.337166>,
      < -6.723833, -1.484684, 1.337166>
    }
    triangle {
      < -6.707397, -1.468684, 1.487412>,
      < -6.723833, -1.484684, 1.337166>,
      < -6.707397, -1.484684, 1.487412>
    }
    triangle {
      < -6.743745, -1.484684, 1.155109>,
      < -6.743745, -1.535863, 1.155109>,
      < -6.742006, -1.535863, 1.171014>
    }
    triangle {
      < -6.743745, -1.484684, 1.155109>,
      < -6.742006, -1.535863, 1.171014>,
      < -6.742006, -1.484684, 1.171014>
    }
    triangle {
      < -6.725572, -1.468684, 1.321261>,
      < -6.742006, -1.468684, 1.171014>,
      < -6.742006, -1.484684, 1.171014>
    }
    triangle {
      < -6.725572, -1.468684, 1.321261>,
      < -6.742006, -1.484684, 1.171014>,
      < -6.725572, -1.484684, 1.321261>
    }
    triangle {
      < -6.743746, -1.417505, 1.155109>,
      < -6.743745, -1.468684, 1.155109>,
      < -6.742006, -1.468684, 1.171014>
    }
    triangle {
      < -6.743746, -1.417505, 1.155109>,
      < -6.742006, -1.468684, 1.171014>,
      < -6.742007, -1.417505, 1.171014>
    }
    triangle {
      < -6.743745, -1.468684, 1.155109>,
      < -6.760181, -1.468684, 1.004863>,
      < -6.760181, -1.484684, 1.004863>
    }
    triangle {
      < -6.743745, -1.468684, 1.155109>,
      < -6.760181, -1.484684, 1.004863>,
      < -6.743745, -1.484684, 1.155109>
    }
    triangle {
      < -6.780094, -1.484684, 0.822806>,
      < -6.780094, -1.535863, 0.822806>,
      < -6.778354, -1.535863, 0.838711>
    }
    triangle {
      < -6.780094, -1.484684, 0.822806>,
      < -6.778354, -1.535863, 0.838711>,
      < -6.778354, -1.484684, 0.838711>
    }
    triangle {
      < -6.761920, -1.468684, 0.988957>,
      < -6.778354, -1.468684, 0.838711>,
      < -6.778354, -1.484684, 0.838711>
    }
    triangle {
      < -6.761920, -1.468684, 0.988957>,
      < -6.778354, -1.484684, 0.838711>,
      < -6.761920, -1.484684, 0.988957>
    }
    triangle {
      < -6.780094, -1.417505, 0.822806>,
      < -6.780094, -1.468684, 0.822806>,
      < -6.778354, -1.468684, 0.838711>
    }
    triangle {
      < -6.780094, -1.417505, 0.822806>,
      < -6.778354, -1.468684, 0.838711>,
      < -6.778355, -1.417505, 0.838711>
    }
    triangle {
      < -6.780094, -1.468684, 0.822806>,
      < -6.796529, -1.468684, 0.672559>,
      < -6.796529, -1.484684, 0.672559>
    }
    triangle {
      < -6.780094, -1.468684, 0.822806>,
      < -6.796529, -1.484684, 0.672559>,
      < -6.780094, -1.484684, 0.822806>
    }
    triangle {
      < -6.816442, -1.484684, 0.490502>,
      < -6.816442, -1.535863, 0.490503>,
      < -6.814702, -1.535863, 0.506407>
    }
    triangle {
      < -6.816442, -1.484684, 0.490502>,
      < -6.814702, -1.535863, 0.506407>,
      < -6.814702, -1.484684, 0.506407>
    }
    triangle {
      < -6.798268, -1.468684, 0.656654>,
      < -6.814702, -1.468684, 0.506407>,
      < -6.814702, -1.484684, 0.506407>
    }
    triangle {
      < -6.798268, -1.468684, 0.656654>,
      < -6.814702, -1.484684, 0.506407>,
      < -6.798268, -1.484684, 0.656654>
    }
    triangle {
      < -6.816442, -1.417505, 0.490502>,
      < -6.816442, -1.468684, 0.490502>,
      < -6.814702, -1.468684, 0.506407>
    }
    triangle {
      < -6.816442, -1.417505, 0.490502>,
      < -6.814702, -1.468684, 0.506407>,
      < -6.814703, -1.417505, 0.506407>
    }
    triangle {
      < -6.816442, -1.468684, 0.490502>,
      < -6.832877, -1.468684, 0.340256>,
      < -6.832877, -1.484684, 0.340256>
    }
    triangle {
      < -6.816442, -1.468684, 0.490502>,
      < -6.832877, -1.484684, 0.340256>,
      < -6.816442, -1.484684, 0.490502>
    }
    triangle {
      < -6.852789, -1.484684, 0.158199>,
      < -6.852789, -1.535863, 0.158199>,
      < -6.851050, -1.535863, 0.174104>
    }
    triangle {
      < -6.852789, -1.484684, 0.158199>,
      < -6.851050, -1.535863, 0.174104>,
      < -6.851050, -1.484684, 0.174104>
    }
    triangle {
      < -6.834616, -1.468684, 0.324351>,
      < -6.851050, -1.468684, 0.174104>,
      < -6.851050, -1.484684, 0.174104>
    }
    triangle {
      < -6.834616, -1.468684, 0.324351>,
      < -6.851050, -1.484684, 0.174104>,
      < -6.834616, -1.484684, 0.324351>
    }
    triangle {
      < -6.852790, -1.417505, 0.158199>,
      < -6.852789, -1.468684, 0.158199>,
      < -6.851050, -1.468684, 0.174104>
    }
    triangle {
      < -6.852790, -1.417505, 0.158199>,
      < -6.851050, -1.468684, 0.174104>,
      < -6.851051, -1.417505, 0.174104>
    }
    triangle {
      < -6.852789, -1.468684, 0.158199>,
      < -6.869224, -1.468684, 0.007953>,
      < -6.869224, -1.484684, 0.007953>
    }
    triangle {
      < -6.852789, -1.468684, 0.158199>,
      < -6.869224, -1.484684, 0.007953>,
      < -6.852789, -1.484684, 0.158199>
    }
    triangle {
      < -6.832877, -1.484684, -0.340256>,
      < -6.832877, -1.535863, -0.340256>,
      < -6.834616, -1.535863, -0.324351>
    }
    triangle {
      < -6.832877, -1.484684, -0.340256>,
      < -6.834616, -1.535863, -0.324351>,
      < -6.834616, -1.484684, -0.324351>
    }
    triangle {
      < -6.851050, -1.468684, -0.174104>,
      < -6.834616, -1.468684, -0.324351>,
      < -6.834616, -1.484684, -0.324351>
    }
    triangle {
      < -6.851050, -1.468684, -0.174104>,
      < -6.834616, -1.484684, -0.324351>,
      < -6.851050, -1.484684, -0.174104>
    }
    triangle {
      < -6.832876, -1.417505, -0.340256>,
      < -6.832877, -1.468684, -0.340256>,
      < -6.834616, -1.468684, -0.324351>
    }
    triangle {
      < -6.832876, -1.417505, -0.340256>,
      < -6.834616, -1.468684, -0.324351>,
      < -6.834615, -1.417505, -0.324351>
    }
    triangle {
      < -6.832877, -1.468684, -0.340256>,
      < -6.816443, -1.468684, -0.490502>,
      < -6.816443, -1.484684, -0.490502>
    }
    triangle {
      < -6.832877, -1.468684, -0.340256>,
      < -6.816443, -1.484684, -0.490502>,
      < -6.832877, -1.484684, -0.340256>
    }
    triangle {
      < -6.796529, -1.484684, -0.672559>,
      < -6.796529, -1.535863, -0.672559>,
      < -6.798269, -1.535863, -0.656654>
    }
    triangle {
      < -6.796529, -1.484684, -0.672559>,
      < -6.798269, -1.535863, -0.656654>,
      < -6.798268, -1.484684, -0.656654>
    }
    triangle {
      < -6.814703, -1.468684, -0.506407>,
      < -6.798268, -1.468684, -0.656654>,
      < -6.798268, -1.484684, -0.656654>
    }
    triangle {
      < -6.814703, -1.468684, -0.506407>,
      < -6.798268, -1.484684, -0.656654>,
      < -6.814703, -1.484684, -0.506407>
    }
    triangle {
      < -6.796529, -1.417505, -0.672559>,
      < -6.796529, -1.468684, -0.672559>,
      < -6.798268, -1.468684, -0.656654>
    }
    triangle {
      < -6.796529, -1.417505, -0.672559>,
      < -6.798268, -1.468684, -0.656654>,
      < -6.798268, -1.417505, -0.656654>
    }
    triangle {
      < -6.796529, -1.468684, -0.672559>,
      < -6.780095, -1.468684, -0.822805>,
      < -6.780095, -1.484684, -0.822805>
    }
    triangle {
      < -6.796529, -1.468684, -0.672559>,
      < -6.780095, -1.484684, -0.822805>,
      < -6.796529, -1.484684, -0.672559>
    }
    triangle {
      < -6.760181, -1.484684, -1.004862>,
      < -6.760181, -1.535863, -1.004862>,
      < -6.761921, -1.535863, -0.988957>
    }
    triangle {
      < -6.760181, -1.484684, -1.004862>,
      < -6.761921, -1.535863, -0.988957>,
      < -6.761920, -1.484684, -0.988957>
    }
    triangle {
      < -6.778356, -1.468684, -0.838710>,
      < -6.761920, -1.468684, -0.988957>,
      < -6.761920, -1.484684, -0.988957>
    }
    triangle {
      < -6.778356, -1.468684, -0.838710>,
      < -6.761920, -1.484684, -0.988957>,
      < -6.778356, -1.484684, -0.838710>
    }
    triangle {
      < -6.760181, -1.417505, -1.004862>,
      < -6.760181, -1.468684, -1.004862>,
      < -6.761920, -1.468684, -0.988957>
    }
    triangle {
      < -6.760181, -1.417505, -1.004862>,
      < -6.761920, -1.468684, -0.988957>,
      < -6.761920, -1.417505, -0.988957>
    }
    triangle {
      < -6.760181, -1.468684, -1.004862>,
      < -6.743747, -1.468684, -1.155109>,
      < -6.743747, -1.484684, -1.155109>
    }
    triangle {
      < -6.760181, -1.468684, -1.004862>,
      < -6.743747, -1.484684, -1.155109>,
      < -6.760181, -1.484684, -1.004862>
    }
    triangle {
      < -6.723833, -1.484684, -1.337165>,
      < -6.723834, -1.535863, -1.337165>,
      < -6.725573, -1.535863, -1.321260>
    }
    triangle {
      < -6.723833, -1.484684, -1.337165>,
      < -6.725573, -1.535863, -1.321260>,
      < -6.725572, -1.484684, -1.321260>
    }
    triangle {
      < -6.742008, -1.468684, -1.171014>,
      < -6.725572, -1.468684, -1.321260>,
      < -6.725572, -1.484684, -1.321260>
    }
    triangle {
      < -6.742008, -1.468684, -1.171014>,
      < -6.725572, -1.484684, -1.321260>,
      < -6.742008, -1.484684, -1.171014>
    }
    triangle {
      < -6.723833, -1.417505, -1.337166>,
      < -6.723833, -1.468684, -1.337165>,
      < -6.725572, -1.468684, -1.321260>
    }
    triangle {
      < -6.723833, -1.417505, -1.337166>,
      < -6.725572, -1.468684, -1.321260>,
      < -6.725572, -1.417505, -1.321260>
    }
    triangle {
      < -6.723833, -1.468684, -1.337165>,
      < -6.707399, -1.468684, -1.487412>,
      < -6.707399, -1.484684, -1.487412>
    }
    triangle {
      < -6.723833, -1.468684, -1.337165>,
      < -6.707399, -1.484684, -1.487412>,
      < -6.723833, -1.484684, -1.337165>
    }
    triangle {
      < -6.687485, -1.484684, -1.669469>,
      < -6.687486, -1.535863, -1.669469>,
      < -6.689225, -1.535863, -1.653563>
    }
    triangle {
      < -6.687485, -1.484684, -1.669469>,
      < -6.689225, -1.535863, -1.653563>,
      < -6.689224, -1.484684, -1.653564>
    }
    triangle {
      < -6.705659, -1.468684, -1.503317>,
      < -6.689224, -1.468684, -1.653564>,
      < -6.689224, -1.484684, -1.653564>
    }
    triangle {
      < -6.705659, -1.468684, -1.503317>,
      < -6.689224, -1.484684, -1.653564>,
      < -6.705659, -1.484684, -1.503317>
    }
    triangle {
      < -6.687485, -1.417505, -1.669469>,
      < -6.687485, -1.468684, -1.669469>,
      < -6.689224, -1.468684, -1.653564>
    }
    triangle {
      < -6.687485, -1.417505, -1.669469>,
      < -6.689224, -1.468684, -1.653564>,
      < -6.689224, -1.417505, -1.653564>
    }
    triangle {
      < -6.687485, -1.468684, -1.669469>,
      < -6.671051, -1.468684, -1.819715>,
      < -6.671051, -1.484684, -1.819715>
    }
    triangle {
      < -6.687485, -1.468684, -1.669469>,
      < -6.671051, -1.484684, -1.819715>,
      < -6.687485, -1.484684, -1.669469>
    }
    triangle {
      < -6.651137, -1.484684, -2.001772>,
      < -6.651138, -1.535863, -2.001772>,
      < -6.652877, -1.535863, -1.985867>
    }
    triangle {
      < -6.651137, -1.484684, -2.001772>,
      < -6.652877, -1.535863, -1.985867>,
      < -6.652876, -1.484684, -1.985867>
    }
    triangle {
      < -6.669312, -1.468684, -1.835620>,
      < -6.652876, -1.468684, -1.985867>,
      < -6.652876, -1.484684, -1.985867>
    }
    triangle {
      < -6.669312, -1.468684, -1.835620>,
      < -6.652876, -1.484684, -1.985867>,
      < -6.669312, -1.484684, -1.835620>
    }
    triangle {
      < -6.651137, -1.417505, -2.001772>,
      < -6.651137, -1.468684, -2.001772>,
      < -6.652876, -1.468684, -1.985867>
    }
    triangle {
      < -6.651137, -1.417505, -2.001772>,
      < -6.652876, -1.468684, -1.985867>,
      < -6.652876, -1.417505, -1.985867>
    }
    triangle {
      < -6.651137, -1.468684, -2.001772>,
      < -6.634703, -1.468684, -2.152018>,
      < -6.634703, -1.484684, -2.152018>
    }
    triangle {
      < -6.651137, -1.468684, -2.001772>,
      < -6.634703, -1.484684, -2.152018>,
      < -6.651137, -1.484684, -2.001772>
    }
    triangle {
      < -6.614789, -1.484684, -2.334075>,
      < -6.614789, -1.535863, -2.334075>,
      < -6.616529, -1.535863, -2.318170>
    }
    triangle {
      < -6.614789, -1.484684, -2.334075>,
      < -6.616529, -1.535863, -2.318170>,
      < -6.616529, -1.484684, -2.318170>
    }
    triangle {
      < -6.632964, -1.468684, -2.167923>,
      < -6.616529, -1.468684, -2.318170>,
      < -6.616529, -1.484684, -2.318170>
    }
    triangle {
      < -6.632964, -1.468684, -2.167923>,
      < -6.616529, -1.484684, -2.318170>,
      < -6.632964, -1.484684, -2.167923>
    }
    triangle {
      < -6.614789, -1.417505, -2.334075>,
      < -6.614789, -1.468684, -2.334075>,
      < -6.616529, -1.468684, -2.318170>
    }
    triangle {
      < -6.614789, -1.417505, -2.334075>,
      < -6.616529, -1.468684, -2.318170>,
      < -6.616529, -1.417505, -2.318170>
    }
    triangle {
      < -6.614789, -1.468684, -2.334075>,
      < -6.598355, -1.468684, -2.484322>,
      < -6.598355, -1.484684, -2.484322>
    }
    triangle {
      < -6.614789, -1.468684, -2.334075>,
      < -6.598355, -1.484684, -2.484322>,
      < -6.614789, -1.484684, -2.334075>
    }
    triangle {
      < -6.614789, -1.468684, 2.334076>,
      < -6.614789, -1.417505, 2.334076>,
      < -6.616529, -1.417505, 2.318170>
    }
    triangle {
      < -6.614789, -1.468684, 2.334076>,
      < -6.616529, -1.417505, 2.318170>,
      < -6.616529, -1.468684, 2.318171>
    }
    triangle {
      < -6.614789, -1.535863, 2.334076>,
      < -6.614789, -1.484684, 2.334076>,
      < -6.616529, -1.484684, 2.318171>
    }
    triangle {
      < -6.614789, -1.535863, 2.334076>,
      < -6.616529, -1.484684, 2.318171>,
      < -6.616529, -1.535863, 2.318171>
    }
    triangle {
      < -6.651137, -1.468684, 2.001772>,
      < -6.651137, -1.417505, 2.001772>,
      < -6.652876, -1.417505, 1.985867>
    }
    triangle {
      < -6.651137, -1.468684, 2.001772>,
      < -6.652876, -1.417505, 1.985867>,
      < -6.652876, -1.468684, 1.985867>
    }
    triangle {
      < -6.651136, -1.535863, 2.001772>,
      < -6.651137, -1.484684, 2.001772>,
      < -6.652876, -1.484684, 1.985867>
    }
    triangle {
      < -6.651136, -1.535863, 2.001772>,
      < -6.652876, -1.484684, 1.985867>,
      < -6.652875, -1.535863, 1.985867>
    }
    triangle {
      < -6.687485, -1.468684, 1.669469>,
      < -6.687485, -1.417505, 1.669469>,
      < -6.689224, -1.417505, 1.653564>
    }
    triangle {
      < -6.687485, -1.468684, 1.669469>,
      < -6.689224, -1.417505, 1.653564>,
      < -6.689224, -1.468684, 1.653564>
    }
    triangle {
      < -6.687484, -1.535863, 1.669469>,
      < -6.687485, -1.484684, 1.669469>,
      < -6.689224, -1.484684, 1.653564>
    }
    triangle {
      < -6.687484, -1.535863, 1.669469>,
      < -6.689224, -1.484684, 1.653564>,
      < -6.689224, -1.535863, 1.653564>
    }
    triangle {
      < -6.723833, -1.468684, 1.337166>,
      < -6.723833, -1.417505, 1.337166>,
      < -6.725572, -1.417505, 1.321261>
    }
    triangle {
      < -6.723833, -1.468684, 1.337166>,
      < -6.725572, -1.417505, 1.321261>,
      < -6.725572, -1.468684, 1.321261>
    }
    triangle {
      < -6.723832, -1.535863, 1.337166>,
      < -6.723833, -1.484684, 1.337166>,
      < -6.725572, -1.484684, 1.321261>
    }
    triangle {
      < -6.723832, -1.535863, 1.337166>,
      < -6.725572, -1.484684, 1.321261>,
      < -6.725572, -1.535863, 1.321261>
    }
    triangle {
      < -6.760181, -1.468684, 1.004863>,
      < -6.760181, -1.417505, 1.004863>,
      < -6.761920, -1.417505, 0.988957>
    }
    triangle {
      < -6.760181, -1.468684, 1.004863>,
      < -6.761920, -1.417505, 0.988957>,
      < -6.761920, -1.468684, 0.988957>
    }
    triangle {
      < -6.760180, -1.535863, 1.004863>,
      < -6.760181, -1.484684, 1.004863>,
      < -6.761920, -1.484684, 0.988957>
    }
    triangle {
      < -6.760180, -1.535863, 1.004863>,
      < -6.761920, -1.484684, 0.988957>,
      < -6.761919, -1.535863, 0.988957>
    }
    triangle {
      < -6.796529, -1.468684, 0.672559>,
      < -6.796529, -1.417505, 0.672559>,
      < -6.798268, -1.417505, 0.656654>
    }
    triangle {
      < -6.796529, -1.468684, 0.672559>,
      < -6.798268, -1.417505, 0.656654>,
      < -6.798268, -1.468684, 0.656654>
    }
    triangle {
      < -6.796528, -1.535863, 0.672559>,
      < -6.796529, -1.484684, 0.672559>,
      < -6.798268, -1.484684, 0.656654>
    }
    triangle {
      < -6.796528, -1.535863, 0.672559>,
      < -6.798268, -1.484684, 0.656654>,
      < -6.798267, -1.535863, 0.656654>
    }
    triangle {
      < -6.832877, -1.468684, 0.340256>,
      < -6.832877, -1.417505, 0.340256>,
      < -6.834616, -1.417505, 0.324351>
    }
    triangle {
      < -6.832877, -1.468684, 0.340256>,
      < -6.834616, -1.417505, 0.324351>,
      < -6.834616, -1.468684, 0.324351>
    }
    triangle {
      < -6.832876, -1.535863, 0.340256>,
      < -6.832877, -1.484684, 0.340256>,
      < -6.834616, -1.484684, 0.324351>
    }
    triangle {
      < -6.832876, -1.535863, 0.340256>,
      < -6.834616, -1.484684, 0.324351>,
      < -6.834615, -1.535863, 0.324351>
    }
    triangle {
      < -6.852789, -1.468684, -0.158199>,
      < -6.852789, -1.417505, -0.158199>,
      < -6.851050, -1.417505, -0.174104>
    }
    triangle {
      < -6.852789, -1.468684, -0.158199>,
      < -6.851050, -1.417505, -0.174104>,
      < -6.851050, -1.468684, -0.174104>
    }
    triangle {
      < -6.852790, -1.535863, -0.158199>,
      < -6.852789, -1.484684, -0.158199>,
      < -6.851050, -1.484684, -0.174104>
    }
    triangle {
      < -6.852790, -1.535863, -0.158199>,
      < -6.851050, -1.484684, -0.174104>,
      < -6.851051, -1.535863, -0.174104>
    }
    triangle {
      < -6.869224, -1.468684, -0.007953>,
      < -6.852789, -1.468684, -0.158199>,
      < -6.852789, -1.484684, -0.158199>
    }
    triangle {
      < -6.869224, -1.468684, -0.007953>,
      < -6.852789, -1.484684, -0.158199>,
      < -6.869224, -1.484684, -0.007953>
    }
    triangle {
      < -6.816443, -1.468684, -0.490502>,
      < -6.816442, -1.417505, -0.490502>,
      < -6.814703, -1.417505, -0.506407>
    }
    triangle {
      < -6.816443, -1.468684, -0.490502>,
      < -6.814703, -1.417505, -0.506407>,
      < -6.814703, -1.468684, -0.506407>
    }
    triangle {
      < -6.816443, -1.535863, -0.490502>,
      < -6.816443, -1.484684, -0.490502>,
      < -6.814703, -1.484684, -0.506407>
    }
    triangle {
      < -6.816443, -1.535863, -0.490502>,
      < -6.814703, -1.484684, -0.506407>,
      < -6.814703, -1.535863, -0.506407>
    }
    triangle {
      < -6.780095, -1.468684, -0.822805>,
      < -6.780094, -1.417505, -0.822805>,
      < -6.778355, -1.417505, -0.838711>
    }
    triangle {
      < -6.780095, -1.468684, -0.822805>,
      < -6.778355, -1.417505, -0.838711>,
      < -6.778356, -1.468684, -0.838710>
    }
    triangle {
      < -6.780095, -1.535863, -0.822805>,
      < -6.780095, -1.484684, -0.822805>,
      < -6.778356, -1.484684, -0.838710>
    }
    triangle {
      < -6.780095, -1.535863, -0.822805>,
      < -6.778356, -1.484684, -0.838710>,
      < -6.778356, -1.535863, -0.838710>
    }
    triangle {
      < -6.743747, -1.468684, -1.155109>,
      < -6.743746, -1.417505, -1.155109>,
      < -6.742007, -1.417505, -1.171014>
    }
    triangle {
      < -6.743747, -1.468684, -1.155109>,
      < -6.742007, -1.417505, -1.171014>,
      < -6.742008, -1.468684, -1.171014>
    }
    triangle {
      < -6.743747, -1.535863, -1.155109>,
      < -6.743747, -1.484684, -1.155109>,
      < -6.742008, -1.484684, -1.171014>
    }
    triangle {
      < -6.743747, -1.535863, -1.155109>,
      < -6.742008, -1.484684, -1.171014>,
      < -6.742008, -1.535863, -1.171014>
    }
    triangle {
      < -6.707399, -1.468684, -1.487412>,
      < -6.707398, -1.417505, -1.487412>,
      < -6.705659, -1.417505, -1.503317>
    }
    triangle {
      < -6.707399, -1.468684, -1.487412>,
      < -6.705659, -1.417505, -1.503317>,
      < -6.705659, -1.468684, -1.503317>
    }
    triangle {
      < -6.707399, -1.535863, -1.487412>,
      < -6.707399, -1.484684, -1.487412>,
      < -6.705659, -1.484684, -1.503317>
    }
    triangle {
      < -6.707399, -1.535863, -1.487412>,
      < -6.705659, -1.484684, -1.503317>,
      < -6.705659, -1.535863, -1.503317>
    }
    triangle {
      < -6.671051, -1.468684, -1.819715>,
      < -6.671051, -1.417505, -1.819715>,
      < -6.669311, -1.417505, -1.835620>
    }
    triangle {
      < -6.671051, -1.468684, -1.819715>,
      < -6.669311, -1.417505, -1.835620>,
      < -6.669312, -1.468684, -1.835620>
    }
    triangle {
      < -6.671051, -1.535863, -1.819715>,
      < -6.671051, -1.484684, -1.819715>,
      < -6.669312, -1.484684, -1.835620>
    }
    triangle {
      < -6.671051, -1.535863, -1.819715>,
      < -6.669312, -1.484684, -1.835620>,
      < -6.669312, -1.535863, -1.835620>
    }
    triangle {
      < -6.634703, -1.468684, -2.152018>,
      < -6.634702, -1.417505, -2.152018>,
      < -6.632963, -1.417505, -2.167924>
    }
    triangle {
      < -6.634703, -1.468684, -2.152018>,
      < -6.632963, -1.417505, -2.167924>,
      < -6.632964, -1.468684, -2.167923>
    }
    triangle {
      < -6.634703, -1.535863, -2.152018>,
      < -6.634703, -1.484684, -2.152018>,
      < -6.632964, -1.484684, -2.167923>
    }
    triangle {
      < -6.634703, -1.535863, -2.152018>,
      < -6.632964, -1.484684, -2.167923>,
      < -6.632964, -1.535863, -2.167923>
    }
    triangle {
      < -6.598355, -1.468684, -2.484322>,
      < -6.598354, -1.417505, -2.484322>,
      < -6.596615, -1.417505, -2.500227>
    }
    triangle {
      < -6.598355, -1.468684, -2.484322>,
      < -6.596615, -1.417505, -2.500227>,
      < -6.596616, -1.468684, -2.500227>
    }
    triangle {
      < -6.596616, -1.468684, -2.500227>,
      < -6.580181, -1.468684, -2.650473>,
      < -6.580181, -1.484684, -2.650473>
    }
    triangle {
      < -6.596616, -1.468684, -2.500227>,
      < -6.580181, -1.484684, -2.650473>,
      < -6.596616, -1.484684, -2.500227>
    }
    triangle {
      < -6.598355, -1.535863, -2.484322>,
      < -6.598355, -1.484684, -2.484322>,
      < -6.596616, -1.484684, -2.500227>
    }
    triangle {
      < -6.598355, -1.535863, -2.484322>,
      < -6.596616, -1.484684, -2.500227>,
      < -6.596616, -1.535863, -2.500227>
    }
    triangle {
      < -6.580181, -1.468684, -2.650473>,
      < -6.580181, -1.417505, -2.650473>,
      < -6.571311, -1.409505, -2.658426>
    }
    triangle {
      < -6.580181, -1.468684, -2.650473>,
      < -6.571311, -1.409505, -2.658426>,
      < -6.571311, -1.476684, -2.658426>
    }
    triangle {
      < -6.580181, -1.535863, -2.650473>,
      < -6.580181, -1.484684, -2.650473>,
      < -6.571311, -1.476684, -2.658426>
    }
    triangle {
      < -6.580181, -1.535863, -2.650473>,
      < -6.571311, -1.476684, -2.658426>,
      < -6.571311, -1.543863, -2.658426>
    }
    triangle {
      < -6.869224, -1.468684, 0.007953>,
      < -6.869224, -1.417505, 0.007953>,
      < -6.869224, -1.417505, -0.007953>
    }
    triangle {
      < -6.869224, -1.468684, 0.007953>,
      < -6.869224, -1.417505, -0.007953>,
      < -6.869224, -1.468684, -0.007953>
    }
    triangle {
      < -6.869224, -1.535863, 0.007953>,
      < -6.869224, -1.484684, 0.007953>,
      < -6.869224, -1.484684, -0.007953>
    }
    triangle {
      < -6.869224, -1.535863, 0.007953>,
      < -6.869224, -1.484684, -0.007953>,
      < -6.869224, -1.535863, -0.007953>
    }
    triangle {
      < -6.614789, -1.350326, -2.334075>,
      < -6.614789, -1.401505, -2.334075>,
      < -6.616529, -1.401505, -2.318170>
    }
    triangle {
      < -6.614789, -1.350326, -2.334075>,
      < -6.616529, -1.401505, -2.318170>,
      < -6.616529, -1.350326, -2.318170>
    }
    triangle {
      < -6.632962, -1.334326, -2.167924>,
      < -6.616529, -1.334326, -2.318170>,
      < -6.616529, -1.350326, -2.318170>
    }
    triangle {
      < -6.632962, -1.334326, -2.167924>,
      < -6.616529, -1.350326, -2.318170>,
      < -6.632962, -1.350326, -2.167924>
    }
    triangle {
      < -6.614789, -1.283147, -2.334075>,
      < -6.614789, -1.334326, -2.334075>,
      < -6.616529, -1.334326, -2.318170>
    }
    triangle {
      < -6.614789, -1.283147, -2.334075>,
      < -6.616529, -1.334326, -2.318170>,
      < -6.616529, -1.283147, -2.318170>
    }
    triangle {
      < -6.614789, -1.334326, -2.334075>,
      < -6.598354, -1.334326, -2.484322>,
      < -6.598354, -1.350326, -2.484322>
    }
    triangle {
      < -6.614789, -1.334326, -2.334075>,
      < -6.598354, -1.350326, -2.484322>,
      < -6.614789, -1.350326, -2.334075>
    }
    triangle {
      < -6.651136, -1.350326, -2.001772>,
      < -6.651137, -1.401505, -2.001772>,
      < -6.652876, -1.401505, -1.985867>
    }
    triangle {
      < -6.651136, -1.350326, -2.001772>,
      < -6.652876, -1.401505, -1.985867>,
      < -6.652875, -1.350326, -1.985867>
    }
    triangle {
      < -6.669310, -1.334326, -1.835621>,
      < -6.652875, -1.334326, -1.985867>,
      < -6.652875, -1.350326, -1.985867>
    }
    triangle {
      < -6.669310, -1.334326, -1.835621>,
      < -6.652875, -1.350326, -1.985867>,
      < -6.669310, -1.350326, -1.835621>
    }
    triangle {
      < -6.651136, -1.283147, -2.001772>,
      < -6.651136, -1.334326, -2.001772>,
      < -6.652875, -1.334326, -1.985867>
    }
    triangle {
      < -6.651136, -1.283147, -2.001772>,
      < -6.652875, -1.334326, -1.985867>,
      < -6.652875, -1.283147, -1.985867>
    }
    triangle {
      < -6.651136, -1.334326, -2.001772>,
      < -6.634702, -1.334326, -2.152019>,
      < -6.634702, -1.350326, -2.152019>
    }
    triangle {
      < -6.651136, -1.334326, -2.001772>,
      < -6.634702, -1.350326, -2.152019>,
      < -6.651136, -1.350326, -2.001772>
    }
    triangle {
      < -6.687484, -1.350326, -1.669469>,
      < -6.687485, -1.401505, -1.669469>,
      < -6.689224, -1.401505, -1.653564>
    }
    triangle {
      < -6.687484, -1.350326, -1.669469>,
      < -6.689224, -1.401505, -1.653564>,
      < -6.689224, -1.350326, -1.653564>
    }
    triangle {
      < -6.705658, -1.334326, -1.503317>,
      < -6.689224, -1.334326, -1.653564>,
      < -6.689224, -1.350326, -1.653564>
    }
    triangle {
      < -6.705658, -1.334326, -1.503317>,
      < -6.689224, -1.350326, -1.653564>,
      < -6.705658, -1.350326, -1.503317>
    }
    triangle {
      < -6.687484, -1.283147, -1.669469>,
      < -6.687484, -1.334326, -1.669469>,
      < -6.689224, -1.334326, -1.653564>
    }
    triangle {
      < -6.687484, -1.283147, -1.669469>,
      < -6.689224, -1.334326, -1.653564>,
      < -6.689224, -1.283147, -1.653564>
    }
    triangle {
      < -6.687484, -1.334326, -1.669469>,
      < -6.671050, -1.334326, -1.819715>,
      < -6.671050, -1.350326, -1.819715>
    }
    triangle {
      < -6.687484, -1.334326, -1.669469>,
      < -6.671050, -1.350326, -1.819715>,
      < -6.687484, -1.350326, -1.669469>
    }
    triangle {
      < -6.723832, -1.350326, -1.337166>,
      < -6.723833, -1.401505, -1.337166>,
      < -6.725572, -1.401505, -1.321260>
    }
    triangle {
      < -6.723832, -1.350326, -1.337166>,
      < -6.725572, -1.401505, -1.321260>,
      < -6.725572, -1.350326, -1.321260>
    }
    triangle {
      < -6.742006, -1.334326, -1.171014>,
      < -6.725572, -1.334326, -1.321260>,
      < -6.725572, -1.350326, -1.321260>
    }
    triangle {
      < -6.742006, -1.334326, -1.171014>,
      < -6.725572, -1.350326, -1.321260>,
      < -6.742006, -1.350326, -1.171014>
    }
    triangle {
      < -6.723832, -1.283147, -1.337166>,
      < -6.723832, -1.334326, -1.337166>,
      < -6.725572, -1.334326, -1.321260>
    }
    triangle {
      < -6.723832, -1.283147, -1.337166>,
      < -6.725572, -1.334326, -1.321260>,
      < -6.725572, -1.283147, -1.321260>
    }
    triangle {
      < -6.723832, -1.334326, -1.337166>,
      < -6.707397, -1.334326, -1.487412>,
      < -6.707397, -1.350326, -1.487412>
    }
    triangle {
      < -6.723832, -1.334326, -1.337166>,
      < -6.707397, -1.350326, -1.487412>,
      < -6.723832, -1.350326, -1.337166>
    }
    triangle {
      < -6.760180, -1.350326, -1.004862>,
      < -6.760181, -1.401505, -1.004862>,
      < -6.761920, -1.401505, -0.988957>
    }
    triangle {
      < -6.760180, -1.350326, -1.004862>,
      < -6.761920, -1.401505, -0.988957>,
      < -6.761919, -1.350326, -0.988957>
    }
    triangle {
      < -6.778354, -1.334326, -0.838711>,
      < -6.761919, -1.334326, -0.988957>,
      < -6.761919, -1.350326, -0.988957>
    }
    triangle {
      < -6.778354, -1.334326, -0.838711>,
      < -6.761919, -1.350326, -0.988957>,
      < -6.778354, -1.350326, -0.838711>
    }
    triangle {
      < -6.760180, -1.283147, -1.004862>,
      < -6.760180, -1.334326, -1.004862>,
      < -6.761919, -1.334326, -0.988957>
    }
    triangle {
      < -6.760180, -1.283147, -1.004862>,
      < -6.761919, -1.334326, -0.988957>,
      < -6.761919, -1.283147, -0.988957>
    }
    triangle {
      < -6.760180, -1.334326, -1.004862>,
      < -6.743745, -1.334326, -1.155109>,
      < -6.743745, -1.350326, -1.155109>
    }
    triangle {
      < -6.760180, -1.334326, -1.004862>,
      < -6.743745, -1.350326, -1.155109>,
      < -6.760180, -1.350326, -1.004862>
    }
    triangle {
      < -6.796528, -1.350326, -0.672559>,
      < -6.796529, -1.401505, -0.672559>,
      < -6.798268, -1.401505, -0.656654>
    }
    triangle {
      < -6.796528, -1.350326, -0.672559>,
      < -6.798268, -1.401505, -0.656654>,
      < -6.798267, -1.350326, -0.656654>
    }
    triangle {
      < -6.814702, -1.334326, -0.506407>,
      < -6.798267, -1.334326, -0.656654>,
      < -6.798267, -1.350326, -0.656654>
    }
    triangle {
      < -6.814702, -1.334326, -0.506407>,
      < -6.798267, -1.350326, -0.656654>,
      < -6.814702, -1.350326, -0.506407>
    }
    triangle {
      < -6.796528, -1.283147, -0.672559>,
      < -6.796528, -1.334326, -0.672559>,
      < -6.798267, -1.334326, -0.656654>
    }
    triangle {
      < -6.796528, -1.283147, -0.672559>,
      < -6.798267, -1.334326, -0.656654>,
      < -6.798267, -1.283147, -0.656654>
    }
    triangle {
      < -6.796528, -1.334326, -0.672559>,
      < -6.780094, -1.334326, -0.822806>,
      < -6.780094, -1.350326, -0.822806>
    }
    triangle {
      < -6.796528, -1.334326, -0.672559>,
      < -6.780094, -1.350326, -0.822806>,
      < -6.796528, -1.350326, -0.672559>
    }
    triangle {
      < -6.832876, -1.350326, -0.340256>,
      < -6.832876, -1.401505, -0.340256>,
      < -6.834615, -1.401505, -0.324351>
    }
    triangle {
      < -6.832876, -1.350326, -0.340256>,
      < -6.834615, -1.401505, -0.324351>,
      < -6.834615, -1.350326, -0.324351>
    }
    triangle {
      < -6.851050, -1.334326, -0.174104>,
      < -6.834615, -1.334326, -0.324351>,
      < -6.834615, -1.350326, -0.324351>
    }
    triangle {
      < -6.851050, -1.334326, -0.174104>,
      < -6.834615, -1.350326, -0.324351>,
      < -6.851050, -1.350326, -0.174104>
    }
    triangle {
      < -6.832876, -1.283147, -0.340256>,
      < -6.832876, -1.334326, -0.340256>,
      < -6.834615, -1.334326, -0.324351>
    }
    triangle {
      < -6.832876, -1.283147, -0.340256>,
      < -6.834615, -1.334326, -0.324351>,
      < -6.834615, -1.283147, -0.324351>
    }
    triangle {
      < -6.832876, -1.334326, -0.340256>,
      < -6.816442, -1.334326, -0.490502>,
      < -6.816442, -1.350326, -0.490502>
    }
    triangle {
      < -6.832876, -1.334326, -0.340256>,
      < -6.816442, -1.350326, -0.490502>,
      < -6.832876, -1.350326, -0.340256>
    }
    triangle {
      < -6.852790, -1.350326, 0.158199>,
      < -6.852790, -1.401505, 0.158199>,
      < -6.851051, -1.401505, 0.174104>
    }
    triangle {
      < -6.852790, -1.350326, 0.158199>,
      < -6.851051, -1.401505, 0.174104>,
      < -6.851051, -1.350326, 0.174104>
    }
    triangle {
      < -6.834616, -1.334326, 0.324351>,
      < -6.851051, -1.334326, 0.174104>,
      < -6.851051, -1.350326, 0.174104>
    }
    triangle {
      < -6.834616, -1.334326, 0.324351>,
      < -6.851051, -1.350326, 0.174104>,
      < -6.834616, -1.350326, 0.324351>
    }
    triangle {
      < -6.852790, -1.283147, 0.158199>,
      < -6.852790, -1.334326, 0.158199>,
      < -6.851051, -1.334326, 0.174104>
    }
    triangle {
      < -6.852790, -1.283147, 0.158199>,
      < -6.851051, -1.334326, 0.174104>,
      < -6.851051, -1.283147, 0.174104>
    }
    triangle {
      < -6.852790, -1.334326, 0.158199>,
      < -6.869224, -1.334326, 0.007953>,
      < -6.869224, -1.350326, 0.007953>
    }
    triangle {
      < -6.852790, -1.334326, 0.158199>,
      < -6.869224, -1.350326, 0.007953>,
      < -6.852790, -1.350326, 0.158199>
    }
    triangle {
      < -6.816443, -1.350326, 0.490502>,
      < -6.816442, -1.401505, 0.490502>,
      < -6.814703, -1.401505, 0.506407>
    }
    triangle {
      < -6.816443, -1.350326, 0.490502>,
      < -6.814703, -1.401505, 0.506407>,
      < -6.814703, -1.350326, 0.506407>
    }
    triangle {
      < -6.798269, -1.334326, 0.656654>,
      < -6.814703, -1.334326, 0.506407>,
      < -6.814703, -1.350326, 0.506407>
    }
    triangle {
      < -6.798269, -1.334326, 0.656654>,
      < -6.814703, -1.350326, 0.506407>,
      < -6.798269, -1.350326, 0.656654>
    }
    triangle {
      < -6.816443, -1.283147, 0.490502>,
      < -6.816443, -1.334326, 0.490502>,
      < -6.814703, -1.334326, 0.506407>
    }
    triangle {
      < -6.816443, -1.283147, 0.490502>,
      < -6.814703, -1.334326, 0.506407>,
      < -6.814703, -1.283147, 0.506407>
    }
    triangle {
      < -6.816443, -1.334326, 0.490502>,
      < -6.832877, -1.334326, 0.340256>,
      < -6.832877, -1.350326, 0.340256>
    }
    triangle {
      < -6.816443, -1.334326, 0.490502>,
      < -6.832877, -1.350326, 0.340256>,
      < -6.816443, -1.350326, 0.490502>
    }
    triangle {
      < -6.780095, -1.350326, 0.822806>,
      < -6.780094, -1.401505, 0.822806>,
      < -6.778355, -1.401505, 0.838711>
    }
    triangle {
      < -6.780095, -1.350326, 0.822806>,
      < -6.778355, -1.401505, 0.838711>,
      < -6.778356, -1.350326, 0.838711>
    }
    triangle {
      < -6.761921, -1.334326, 0.988957>,
      < -6.778356, -1.334326, 0.838711>,
      < -6.778356, -1.350326, 0.838711>
    }
    triangle {
      < -6.761921, -1.334326, 0.988957>,
      < -6.778356, -1.350326, 0.838711>,
      < -6.761921, -1.350326, 0.988957>
    }
    triangle {
      < -6.780095, -1.283147, 0.822806>,
      < -6.780095, -1.334326, 0.822806>,
      < -6.778356, -1.334326, 0.838711>
    }
    triangle {
      < -6.780095, -1.283147, 0.822806>,
      < -6.778356, -1.334326, 0.838711>,
      < -6.778356, -1.283147, 0.838711>
    }
    triangle {
      < -6.780095, -1.334326, 0.822806>,
      < -6.796529, -1.334326, 0.672559>,
      < -6.796529, -1.350326, 0.672559>
    }
    triangle {
      < -6.780095, -1.334326, 0.822806>,
      < -6.796529, -1.350326, 0.672559>,
      < -6.780095, -1.350326, 0.822806>
    }
    triangle {
      < -6.743747, -1.350326, 1.155109>,
      < -6.743746, -1.401505, 1.155109>,
      < -6.742007, -1.401505, 1.171014>
    }
    triangle {
      < -6.743747, -1.350326, 1.155109>,
      < -6.742007, -1.401505, 1.171014>,
      < -6.742008, -1.350326, 1.171014>
    }
    triangle {
      < -6.725573, -1.334326, 1.321261>,
      < -6.742008, -1.334326, 1.171014>,
      < -6.742008, -1.350326, 1.171014>
    }
    triangle {
      < -6.725573, -1.334326, 1.321261>,
      < -6.742008, -1.350326, 1.171014>,
      < -6.725573, -1.350326, 1.321261>
    }
    triangle {
      < -6.743747, -1.283147, 1.155109>,
      < -6.743747, -1.334326, 1.155109>,
      < -6.742008, -1.334326, 1.171014>
    }
    triangle {
      < -6.743747, -1.283147, 1.155109>,
      < -6.742008, -1.334326, 1.171014>,
      < -6.742008, -1.283147, 1.171014>
    }
    triangle {
      < -6.743747, -1.334326, 1.155109>,
      < -6.760181, -1.334326, 1.004862>,
      < -6.760181, -1.350326, 1.004862>
    }
    triangle {
      < -6.743747, -1.334326, 1.155109>,
      < -6.760181, -1.350326, 1.004862>,
      < -6.743747, -1.350326, 1.155109>
    }
    triangle {
      < -6.707399, -1.350326, 1.487412>,
      < -6.707398, -1.401505, 1.487412>,
      < -6.705659, -1.401505, 1.503317>
    }
    triangle {
      < -6.707399, -1.350326, 1.487412>,
      < -6.705659, -1.401505, 1.503317>,
      < -6.705659, -1.350326, 1.503317>
    }
    triangle {
      < -6.689225, -1.334326, 1.653563>,
      < -6.705659, -1.334326, 1.503317>,
      < -6.705659, -1.350326, 1.503317>
    }
    triangle {
      < -6.689225, -1.334326, 1.653563>,
      < -6.705659, -1.350326, 1.503317>,
      < -6.689225, -1.350326, 1.653563>
    }
    triangle {
      < -6.707399, -1.283147, 1.487412>,
      < -6.707399, -1.334326, 1.487412>,
      < -6.705659, -1.334326, 1.503317>
    }
    triangle {
      < -6.707399, -1.283147, 1.487412>,
      < -6.705659, -1.334326, 1.503317>,
      < -6.705659, -1.283147, 1.503317>
    }
    triangle {
      < -6.707399, -1.334326, 1.487412>,
      < -6.723834, -1.334326, 1.337166>,
      < -6.723834, -1.350326, 1.337166>
    }
    triangle {
      < -6.707399, -1.334326, 1.487412>,
      < -6.723834, -1.350326, 1.337166>,
      < -6.707399, -1.350326, 1.487412>
    }
    triangle {
      < -6.671051, -1.350326, 1.819715>,
      < -6.671051, -1.401505, 1.819715>,
      < -6.669311, -1.401505, 1.835620>
    }
    triangle {
      < -6.671051, -1.350326, 1.819715>,
      < -6.669311, -1.401505, 1.835620>,
      < -6.669312, -1.350326, 1.835620>
    }
    triangle {
      < -6.652877, -1.334326, 1.985867>,
      < -6.669312, -1.334326, 1.835620>,
      < -6.669312, -1.350326, 1.835620>
    }
    triangle {
      < -6.652877, -1.334326, 1.985867>,
      < -6.669312, -1.350326, 1.835620>,
      < -6.652877, -1.350326, 1.985867>
    }
    triangle {
      < -6.671051, -1.283147, 1.819715>,
      < -6.671051, -1.334326, 1.819715>,
      < -6.669312, -1.334326, 1.835620>
    }
    triangle {
      < -6.671051, -1.283147, 1.819715>,
      < -6.669312, -1.334326, 1.835620>,
      < -6.669312, -1.283147, 1.835620>
    }
    triangle {
      < -6.671051, -1.334326, 1.819715>,
      < -6.687486, -1.334326, 1.669469>,
      < -6.687486, -1.350326, 1.669469>
    }
    triangle {
      < -6.671051, -1.334326, 1.819715>,
      < -6.687486, -1.350326, 1.669469>,
      < -6.671051, -1.350326, 1.819715>
    }
    triangle {
      < -6.634703, -1.350326, 2.152019>,
      < -6.634703, -1.401505, 2.152019>,
      < -6.632964, -1.401505, 2.167924>
    }
    triangle {
      < -6.634703, -1.350326, 2.152019>,
      < -6.632964, -1.401505, 2.167924>,
      < -6.632964, -1.350326, 2.167924>
    }
    triangle {
      < -6.616529, -1.334326, 2.318170>,
      < -6.632964, -1.334326, 2.167924>,
      < -6.632964, -1.350326, 2.167924>
    }
    triangle {
      < -6.616529, -1.334326, 2.318170>,
      < -6.632964, -1.350326, 2.167924>,
      < -6.616529, -1.350326, 2.318170>
    }
    triangle {
      < -6.634703, -1.283147, 2.152019>,
      < -6.634703, -1.334326, 2.152019>,
      < -6.632964, -1.334326, 2.167924>
    }
    triangle {
      < -6.634703, -1.283147, 2.152019>,
      < -6.632964, -1.334326, 2.167924>,
      < -6.632964, -1.283147, 2.167924>
    }
    triangle {
      < -6.634703, -1.334326, 2.152019>,
      < -6.651138, -1.334326, 2.001772>,
      < -6.651138, -1.350326, 2.001772>
    }
    triangle {
      < -6.634703, -1.334326, 2.152019>,
      < -6.651138, -1.350326, 2.001772>,
      < -6.634703, -1.350326, 2.152019>
    }
    triangle {
      < -6.598355, -1.350326, 2.484322>,
      < -6.598355, -1.401505, 2.484322>,
      < -6.596616, -1.401505, 2.500227>
    }
    triangle {
      < -6.598355, -1.350326, 2.484322>,
      < -6.596616, -1.401505, 2.500227>,
      < -6.596616, -1.350326, 2.500227>
    }
    triangle {
      < -6.580181, -1.334326, 2.650474>,
      < -6.596616, -1.334326, 2.500227>,
      < -6.596616, -1.350326, 2.500227>
    }
    triangle {
      < -6.580181, -1.334326, 2.650474>,
      < -6.596616, -1.350326, 2.500227>,
      < -6.580181, -1.350326, 2.650474>
    }
    triangle {
      < -6.598355, -1.283147, 2.484322>,
      < -6.598355, -1.334326, 2.484322>,
      < -6.596616, -1.334326, 2.500227>
    }
    triangle {
      < -6.598355, -1.283147, 2.484322>,
      < -6.596616, -1.334326, 2.500227>,
      < -6.596616, -1.283147, 2.500227>
    }
    triangle {
      < -6.598355, -1.334326, 2.484322>,
      < -6.614789, -1.334326, 2.334075>,
      < -6.614789, -1.350326, 2.334075>
    }
    triangle {
      < -6.598355, -1.334326, 2.484322>,
      < -6.614789, -1.350326, 2.334075>,
      < -6.598355, -1.350326, 2.484322>
    }
    triangle {
      < -6.614789, -1.334326, 2.334075>,
      < -6.614789, -1.283147, 2.334075>,
      < -6.616529, -1.283147, 2.318170>
    }
    triangle {
      < -6.614789, -1.334326, 2.334075>,
      < -6.616529, -1.283147, 2.318170>,
      < -6.616529, -1.334326, 2.318170>
    }
    triangle {
      < -6.614789, -1.401505, 2.334075>,
      < -6.614789, -1.350326, 2.334075>,
      < -6.616529, -1.350326, 2.318170>
    }
    triangle {
      < -6.614789, -1.401505, 2.334075>,
      < -6.616529, -1.350326, 2.318170>,
      < -6.616529, -1.401505, 2.318170>
    }
    triangle {
      < -6.651138, -1.334326, 2.001772>,
      < -6.651138, -1.283147, 2.001772>,
      < -6.652877, -1.283147, 1.985867>
    }
    triangle {
      < -6.651138, -1.334326, 2.001772>,
      < -6.652877, -1.283147, 1.985867>,
      < -6.652877, -1.334326, 1.985867>
    }
    triangle {
      < -6.651137, -1.401505, 2.001772>,
      < -6.651138, -1.350326, 2.001772>,
      < -6.652877, -1.350326, 1.985867>
    }
    triangle {
      < -6.651137, -1.401505, 2.001772>,
      < -6.652877, -1.350326, 1.985867>,
      < -6.652876, -1.401505, 1.985867>
    }
    triangle {
      < -6.687486, -1.334326, 1.669469>,
      < -6.687486, -1.283147, 1.669469>,
      < -6.689225, -1.283147, 1.653563>
    }
    triangle {
      < -6.687486, -1.334326, 1.669469>,
      < -6.689225, -1.283147, 1.653563>,
      < -6.689225, -1.334326, 1.653563>
    }
    triangle {
      < -6.687485, -1.401505, 1.669469>,
      < -6.687486, -1.350326, 1.669469>,
      < -6.689225, -1.350326, 1.653563>
    }
    triangle {
      < -6.687485, -1.401505, 1.669469>,
      < -6.689225, -1.350326, 1.653563>,
      < -6.689224, -1.401505, 1.653564>
    }
    triangle {
      < -6.723834, -1.334326, 1.337166>,
      < -6.723834, -1.283147, 1.337166>,
      < -6.725573, -1.283147, 1.321261>
    }
    triangle {
      < -6.723834, -1.334326, 1.337166>,
      < -6.725573, -1.283147, 1.321261>,
      < -6.725573, -1.334326, 1.321261>
    }
    triangle {
      < -6.723833, -1.401505, 1.337166>,
      < -6.723834, -1.350326, 1.337166>,
      < -6.725573, -1.350326, 1.321261>
    }
    triangle {
      < -6.723833, -1.401505, 1.337166>,
      < -6.725573, -1.350326, 1.321261>,
      < -6.725572, -1.401505, 1.321261>
    }
    triangle {
      < -6.760181, -1.334326, 1.004862>,
      < -6.760181, -1.283147, 1.004862>,
      < -6.761921, -1.283147, 0.988957>
    }
    triangle {
      < -6.760181, -1.334326, 1.004862>,
      < -6.761921, -1.283147, 0.988957>,
      < -6.761921, -1.334326, 0.988957>
    }
    triangle {
      < -6.760181, -1.401505, 1.004863>,
      < -6.760181, -1.350326, 1.004862>,
      < -6.761921, -1.350326, 0.988957>
    }
    triangle {
      < -6.760181, -1.401505, 1.004863>,
      < -6.761921, -1.350326, 0.988957>,
      < -6.761920, -1.401505, 0.988957>
    }
    triangle {
      < -6.796529, -1.334326, 0.672559>,
      < -6.796529, -1.283147, 0.672559>,
      < -6.798269, -1.283147, 0.656654>
    }
    triangle {
      < -6.796529, -1.334326, 0.672559>,
      < -6.798269, -1.283147, 0.656654>,
      < -6.798269, -1.334326, 0.656654>
    }
    triangle {
      < -6.796529, -1.401505, 0.672559>,
      < -6.796529, -1.350326, 0.672559>,
      < -6.798269, -1.350326, 0.656654>
    }
    triangle {
      < -6.796529, -1.401505, 0.672559>,
      < -6.798269, -1.350326, 0.656654>,
      < -6.798268, -1.401505, 0.656654>
    }
    triangle {
      < -6.832877, -1.334326, 0.340256>,
      < -6.832877, -1.283147, 0.340256>,
      < -6.834616, -1.283147, 0.324351>
    }
    triangle {
      < -6.832877, -1.334326, 0.340256>,
      < -6.834616, -1.283147, 0.324351>,
      < -6.834616, -1.334326, 0.324351>
    }
    triangle {
      < -6.832877, -1.401505, 0.340256>,
      < -6.832877, -1.350326, 0.340256>,
      < -6.834616, -1.350326, 0.324351>
    }
    triangle {
      < -6.832877, -1.401505, 0.340256>,
      < -6.834616, -1.350326, 0.324351>,
      < -6.834616, -1.401505, 0.324351>
    }
    triangle {
      < -6.852789, -1.334326, -0.158199>,
      < -6.852789, -1.283147, -0.158199>,
      < -6.851050, -1.283147, -0.174104>
    }
    triangle {
      < -6.852789, -1.334326, -0.158199>,
      < -6.851050, -1.283147, -0.174104>,
      < -6.851050, -1.334326, -0.174104>
    }
    triangle {
      < -6.852789, -1.401505, -0.158199>,
      < -6.852789, -1.350326, -0.158199>,
      < -6.851050, -1.350326, -0.174104>
    }
    triangle {
      < -6.852789, -1.401505, -0.158199>,
      < -6.851050, -1.350326, -0.174104>,
      < -6.851050, -1.401505, -0.174104>
    }
    triangle {
      < -6.869224, -1.334326, -0.007953>,
      < -6.852789, -1.334326, -0.158199>,
      < -6.852789, -1.350326, -0.158199>
    }
    triangle {
      < -6.869224, -1.334326, -0.007953>,
      < -6.852789, -1.350326, -0.158199>,
      < -6.869224, -1.350326, -0.007953>
    }
    triangle {
      < -6.816442, -1.334326, -0.490502>,
      < -6.816442, -1.283147, -0.490502>,
      < -6.814702, -1.283147, -0.506407>
    }
    triangle {
      < -6.816442, -1.334326, -0.490502>,
      < -6.814702, -1.283147, -0.506407>,
      < -6.814702, -1.334326, -0.506407>
    }
    triangle {
      < -6.816442, -1.401505, -0.490502>,
      < -6.816442, -1.350326, -0.490502>,
      < -6.814702, -1.350326, -0.506407>
    }
    triangle {
      < -6.816442, -1.401505, -0.490502>,
      < -6.814702, -1.350326, -0.506407>,
      < -6.814703, -1.401505, -0.506407>
    }
    triangle {
      < -6.780094, -1.334326, -0.822806>,
      < -6.780094, -1.283147, -0.822806>,
      < -6.778354, -1.283147, -0.838711>
    }
    triangle {
      < -6.780094, -1.334326, -0.822806>,
      < -6.778354, -1.283147, -0.838711>,
      < -6.778354, -1.334326, -0.838711>
    }
    triangle {
      < -6.780094, -1.401505, -0.822805>,
      < -6.780094, -1.350326, -0.822806>,
      < -6.778354, -1.350326, -0.838711>
    }
    triangle {
      < -6.780094, -1.401505, -0.822805>,
      < -6.778354, -1.350326, -0.838711>,
      < -6.778355, -1.401505, -0.838711>
    }
    triangle {
      < -6.743745, -1.334326, -1.155109>,
      < -6.743745, -1.283147, -1.155109>,
      < -6.742006, -1.283147, -1.171014>
    }
    triangle {
      < -6.743745, -1.334326, -1.155109>,
      < -6.742006, -1.283147, -1.171014>,
      < -6.742006, -1.334326, -1.171014>
    }
    triangle {
      < -6.743746, -1.401505, -1.155109>,
      < -6.743745, -1.350326, -1.155109>,
      < -6.742006, -1.350326, -1.171014>
    }
    triangle {
      < -6.743746, -1.401505, -1.155109>,
      < -6.742006, -1.350326, -1.171014>,
      < -6.742007, -1.401505, -1.171014>
    }
    triangle {
      < -6.707397, -1.334326, -1.487412>,
      < -6.707397, -1.283147, -1.487412>,
      < -6.705658, -1.283147, -1.503317>
    }
    triangle {
      < -6.707397, -1.334326, -1.487412>,
      < -6.705658, -1.283147, -1.503317>,
      < -6.705658, -1.334326, -1.503317>
    }
    triangle {
      < -6.707398, -1.401505, -1.487412>,
      < -6.707397, -1.350326, -1.487412>,
      < -6.705658, -1.350326, -1.503317>
    }
    triangle {
      < -6.707398, -1.401505, -1.487412>,
      < -6.705658, -1.350326, -1.503317>,
      < -6.705659, -1.401505, -1.503317>
    }
    triangle {
      < -6.671050, -1.334326, -1.819715>,
      < -6.671050, -1.283147, -1.819715>,
      < -6.669310, -1.283147, -1.835621>
    }
    triangle {
      < -6.671050, -1.334326, -1.819715>,
      < -6.669310, -1.283147, -1.835621>,
      < -6.669310, -1.334326, -1.835621>
    }
    triangle {
      < -6.671051, -1.401505, -1.819715>,
      < -6.671050, -1.350326, -1.819715>,
      < -6.669310, -1.350326, -1.835621>
    }
    triangle {
      < -6.671051, -1.401505, -1.819715>,
      < -6.669310, -1.350326, -1.835621>,
      < -6.669311, -1.401505, -1.835621>
    }
    triangle {
      < -6.634702, -1.334326, -2.152019>,
      < -6.634702, -1.283147, -2.152019>,
      < -6.632962, -1.283147, -2.167924>
    }
    triangle {
      < -6.634702, -1.334326, -2.152019>,
      < -6.632962, -1.283147, -2.167924>,
      < -6.632962, -1.334326, -2.167924>
    }
    triangle {
      < -6.634702, -1.401505, -2.152019>,
      < -6.634702, -1.350326, -2.152019>,
      < -6.632962, -1.350326, -2.167924>
    }
    triangle {
      < -6.634702, -1.401505, -2.152019>,
      < -6.632962, -1.350326, -2.167924>,
      < -6.632963, -1.401505, -2.167924>
    }
    triangle {
      < -6.598354, -1.334326, -2.484322>,
      < -6.598354, -1.283147, -2.484322>,
      < -6.596615, -1.283147, -2.500227>
    }
    triangle {
      < -6.598354, -1.334326, -2.484322>,
      < -6.596615, -1.283147, -2.500227>,
      < -6.596615, -1.334326, -2.500227>
    }
    triangle {
      < -6.596615, -1.334326, -2.500227>,
      < -6.580181, -1.334326, -2.650473>,
      < -6.580181, -1.350326, -2.650473>
    }
    triangle {
      < -6.596615, -1.334326, -2.500227>,
      < -6.580181, -1.350326, -2.650473>,
      < -6.596615, -1.350326, -2.500227>
    }
    triangle {
      < -6.598354, -1.401505, -2.484322>,
      < -6.598354, -1.350326, -2.484322>,
      < -6.596615, -1.350326, -2.500227>
    }
    triangle {
      < -6.598354, -1.401505, -2.484322>,
      < -6.596615, -1.350326, -2.500227>,
      < -6.596615, -1.401505, -2.500227>
    }
    triangle {
      < -6.580181, -1.334326, -2.650473>,
      < -6.580181, -1.283147, -2.650473>,
      < -6.571311, -1.275147, -2.658426>
    }
    triangle {
      < -6.580181, -1.334326, -2.650473>,
      < -6.571311, -1.275147, -2.658426>,
      < -6.571311, -1.342326, -2.658426>
    }
    triangle {
      < -6.580181, -1.401505, -2.650473>,
      < -6.580181, -1.350326, -2.650473>,
      < -6.571311, -1.342326, -2.658426>
    }
    triangle {
      < -6.580181, -1.401505, -2.650473>,
      < -6.571311, -1.342326, -2.658426>,
      < -6.571311, -1.409505, -2.658426>
    }
    triangle {
      < -6.869224, -1.334326, 0.007953>,
      < -6.869224, -1.283147, 0.007953>,
      < -6.869224, -1.283147, -0.007953>
    }
    triangle {
      < -6.869224, -1.334326, 0.007953>,
      < -6.869224, -1.283147, -0.007953>,
      < -6.869224, -1.334326, -0.007953>
    }
    triangle {
      < -6.869224, -1.401505, 0.007953>,
      < -6.869224, -1.350326, 0.007953>,
      < -6.869224, -1.350326, -0.007953>
    }
    triangle {
      < -6.869224, -1.401505, 0.007953>,
      < -6.869224, -1.350326, -0.007953>,
      < -6.869224, -1.401505, -0.007953>
    }
    triangle {
      < -6.869224, -1.535863, -0.007953>,
      < -6.852790, -1.535863, -0.158199>,
      < -6.852790, -1.551863, -0.158199>
    }
    triangle {
      < -6.869224, -1.535863, -0.007953>,
      < -6.852790, -1.551863, -0.158199>,
      < -6.869224, -1.551863, -0.007953>
    }
    triangle {
      < -6.869224, -1.603042, 0.007953>,
      < -6.869224, -1.551863, 0.007953>,
      < -6.869224, -1.551863, -0.007953>
    }
    triangle {
      < -6.869224, -1.603042, 0.007953>,
      < -6.869224, -1.551863, -0.007953>,
      < -6.869224, -1.603042, -0.007953>
    }
    triangle {
      < -6.852789, -1.535863, 0.158199>,
      < -6.869224, -1.535863, 0.007953>,
      < -6.869224, -1.551863, 0.007953>
    }
    triangle {
      < -6.852789, -1.535863, 0.158199>,
      < -6.869224, -1.551863, 0.007953>,
      < -6.852789, -1.551863, 0.158199>
    }
    triangle {
      < -6.580181, -1.603042, -2.650473>,
      < -6.580181, -1.551863, -2.650473>,
      < -6.571311, -1.543863, -2.658426>
    }
    triangle {
      < -6.580181, -1.603042, -2.650473>,
      < -6.571311, -1.543863, -2.658426>,
      < -6.571311, -1.611042, -2.658426>
    }
    triangle {
      < -6.596616, -1.535863, -2.500227>,
      < -6.580181, -1.535863, -2.650473>,
      < -6.580181, -1.551863, -2.650473>
    }
    triangle {
      < -6.596616, -1.535863, -2.500227>,
      < -6.580181, -1.551863, -2.650473>,
      < -6.596616, -1.551863, -2.500227>
    }
    triangle {
      < -6.598355, -1.603042, -2.484322>,
      < -6.598355, -1.551863, -2.484322>,
      < -6.596616, -1.551863, -2.500227>
    }
    triangle {
      < -6.598355, -1.603042, -2.484322>,
      < -6.596616, -1.551863, -2.500227>,
      < -6.596616, -1.603042, -2.500227>
    }
    triangle {
      < -6.614789, -1.535863, -2.334075>,
      < -6.598355, -1.535863, -2.484322>,
      < -6.598355, -1.551863, -2.484322>
    }
    triangle {
      < -6.614789, -1.535863, -2.334075>,
      < -6.598355, -1.551863, -2.484322>,
      < -6.614789, -1.551863, -2.334075>
    }
    triangle {
      < -6.632964, -1.535863, -2.167923>,
      < -6.616529, -1.535863, -2.318170>,
      < -6.616529, -1.551863, -2.318170>
    }
    triangle {
      < -6.632964, -1.535863, -2.167923>,
      < -6.616529, -1.551863, -2.318170>,
      < -6.632964, -1.551863, -2.167923>
    }
    triangle {
      < -6.634703, -1.603042, -2.152018>,
      < -6.634703, -1.551863, -2.152018>,
      < -6.632964, -1.551863, -2.167923>
    }
    triangle {
      < -6.634703, -1.603042, -2.152018>,
      < -6.632964, -1.551863, -2.167923>,
      < -6.632964, -1.603042, -2.167923>
    }
    triangle {
      < -6.651138, -1.535863, -2.001772>,
      < -6.634703, -1.535863, -2.152018>,
      < -6.634703, -1.551863, -2.152018>
    }
    triangle {
      < -6.651138, -1.535863, -2.001772>,
      < -6.634703, -1.551863, -2.152018>,
      < -6.651138, -1.551863, -2.001772>
    }
    triangle {
      < -6.669312, -1.535863, -1.835620>,
      < -6.652877, -1.535863, -1.985867>,
      < -6.652877, -1.551863, -1.985867>
    }
    triangle {
      < -6.669312, -1.535863, -1.835620>,
      < -6.652877, -1.551863, -1.985867>,
      < -6.669312, -1.551863, -1.835620>
    }
    triangle {
      < -6.671051, -1.603042, -1.819715>,
      < -6.671051, -1.551863, -1.819715>,
      < -6.669312, -1.551863, -1.835620>
    }
    triangle {
      < -6.671051, -1.603042, -1.819715>,
      < -6.669312, -1.551863, -1.835620>,
      < -6.669312, -1.603042, -1.835620>
    }
    triangle {
      < -6.687486, -1.535863, -1.669469>,
      < -6.671051, -1.535863, -1.819715>,
      < -6.671051, -1.551863, -1.819715>
    }
    triangle {
      < -6.687486, -1.535863, -1.669469>,
      < -6.671051, -1.551863, -1.819715>,
      < -6.687486, -1.551863, -1.669469>
    }
    triangle {
      < -6.705659, -1.535863, -1.503317>,
      < -6.689225, -1.535863, -1.653563>,
      < -6.689225, -1.551863, -1.653563>
    }
    triangle {
      < -6.705659, -1.535863, -1.503317>,
      < -6.689225, -1.551863, -1.653563>,
      < -6.705659, -1.551863, -1.503317>
    }
    triangle {
      < -6.707399, -1.603042, -1.487412>,
      < -6.707399, -1.551863, -1.487412>,
      < -6.705659, -1.551863, -1.503317>
    }
    triangle {
      < -6.707399, -1.603042, -1.487412>,
      < -6.705659, -1.551863, -1.503317>,
      < -6.705659, -1.603042, -1.503317>
    }
    triangle {
      < -6.723834, -1.535863, -1.337165>,
      < -6.707399, -1.535863, -1.487412>,
      < -6.707399, -1.551863, -1.487412>
    }
    triangle {
      < -6.723834, -1.535863, -1.337165>,
      < -6.707399, -1.551863, -1.487412>,
      < -6.723834, -1.551863, -1.337165>
    }
    triangle {
      < -6.742008, -1.535863, -1.171014>,
      < -6.725573, -1.535863, -1.321260>,
      < -6.725573, -1.551863, -1.321260>
    }
    triangle {
      < -6.742008, -1.535863, -1.171014>,
      < -6.725573, -1.551863, -1.321260>,
      < -6.742008, -1.551863, -1.171014>
    }
    triangle {
      < -6.743747, -1.603042, -1.155109>,
      < -6.743747, -1.551863, -1.155109>,
      < -6.742008, -1.551863, -1.171014>
    }
    triangle {
      < -6.743747, -1.603042, -1.155109>,
      < -6.742008, -1.551863, -1.171014>,
      < -6.742008, -1.603042, -1.171014>
    }
    triangle {
      < -6.760181, -1.535863, -1.004862>,
      < -6.743747, -1.535863, -1.155109>,
      < -6.743747, -1.551863, -1.155109>
    }
    triangle {
      < -6.760181, -1.535863, -1.004862>,
      < -6.743747, -1.551863, -1.155109>,
      < -6.760181, -1.551863, -1.004862>
    }
    triangle {
      < -6.778356, -1.535863, -0.838710>,
      < -6.761921, -1.535863, -0.988957>,
      < -6.761921, -1.551863, -0.988957>
    }
    triangle {
      < -6.778356, -1.535863, -0.838710>,
      < -6.761921, -1.551863, -0.988957>,
      < -6.778356, -1.551863, -0.838710>
    }
    triangle {
      < -6.780095, -1.603042, -0.822805>,
      < -6.780095, -1.551863, -0.822805>,
      < -6.778356, -1.551863, -0.838710>
    }
    triangle {
      < -6.780095, -1.603042, -0.822805>,
      < -6.778356, -1.551863, -0.838710>,
      < -6.778356, -1.603042, -0.838710>
    }
    triangle {
      < -6.796529, -1.535863, -0.672559>,
      < -6.780095, -1.535863, -0.822805>,
      < -6.780095, -1.551863, -0.822805>
    }
    triangle {
      < -6.796529, -1.535863, -0.672559>,
      < -6.780095, -1.551863, -0.822805>,
      < -6.796529, -1.551863, -0.672559>
    }
    triangle {
      < -6.814703, -1.535863, -0.506407>,
      < -6.798269, -1.535863, -0.656654>,
      < -6.798269, -1.551863, -0.656654>
    }
    triangle {
      < -6.814703, -1.535863, -0.506407>,
      < -6.798269, -1.551863, -0.656654>,
      < -6.814703, -1.551863, -0.506407>
    }
    triangle {
      < -6.816443, -1.603042, -0.490502>,
      < -6.816443, -1.551863, -0.490502>,
      < -6.814703, -1.551863, -0.506407>
    }
    triangle {
      < -6.816443, -1.603042, -0.490502>,
      < -6.814703, -1.551863, -0.506407>,
      < -6.814703, -1.603042, -0.506407>
    }
    triangle {
      < -6.832877, -1.535863, -0.340256>,
      < -6.816443, -1.535863, -0.490502>,
      < -6.816443, -1.551863, -0.490502>
    }
    triangle {
      < -6.832877, -1.535863, -0.340256>,
      < -6.816443, -1.551863, -0.490502>,
      < -6.832877, -1.551863, -0.340256>
    }
    triangle {
      < -6.851051, -1.535863, -0.174104>,
      < -6.834616, -1.535863, -0.324351>,
      < -6.834616, -1.551863, -0.324351>
    }
    triangle {
      < -6.851051, -1.535863, -0.174104>,
      < -6.834616, -1.551863, -0.324351>,
      < -6.851051, -1.551863, -0.174104>
    }
    triangle {
      < -6.852790, -1.603042, -0.158199>,
      < -6.852790, -1.551863, -0.158199>,
      < -6.851051, -1.551863, -0.174104>
    }
    triangle {
      < -6.852790, -1.603042, -0.158199>,
      < -6.851051, -1.551863, -0.174104>,
      < -6.851051, -1.603042, -0.174104>
    }
    triangle {
      < -6.834615, -1.535863, 0.324351>,
      < -6.851050, -1.535863, 0.174104>,
      < -6.851050, -1.551863, 0.174104>
    }
    triangle {
      < -6.834615, -1.535863, 0.324351>,
      < -6.851050, -1.551863, 0.174104>,
      < -6.834615, -1.551863, 0.324351>
    }
    triangle {
      < -6.832876, -1.603042, 0.340256>,
      < -6.832876, -1.551863, 0.340256>,
      < -6.834615, -1.551863, 0.324351>
    }
    triangle {
      < -6.832876, -1.603042, 0.340256>,
      < -6.834615, -1.551863, 0.324351>,
      < -6.834615, -1.603042, 0.324351>
    }
    triangle {
      < -6.816442, -1.535863, 0.490503>,
      < -6.832876, -1.535863, 0.340256>,
      < -6.832876, -1.551863, 0.340256>
    }
    triangle {
      < -6.816442, -1.535863, 0.490503>,
      < -6.832876, -1.551863, 0.340256>,
      < -6.816442, -1.551863, 0.490503>
    }
    triangle {
      < -6.798267, -1.535863, 0.656654>,
      < -6.814702, -1.535863, 0.506407>,
      < -6.814702, -1.551863, 0.506408>
    }
    triangle {
      < -6.798267, -1.535863, 0.656654>,
      < -6.814702, -1.551863, 0.506408>,
      < -6.798267, -1.551863, 0.656654>
    }
    triangle {
      < -6.796528, -1.603042, 0.672559>,
      < -6.796528, -1.551863, 0.672559>,
      < -6.798267, -1.551863, 0.656654>
    }
    triangle {
      < -6.796528, -1.603042, 0.672559>,
      < -6.798267, -1.551863, 0.656654>,
      < -6.798267, -1.603042, 0.656654>
    }
    triangle {
      < -6.780094, -1.535863, 0.822806>,
      < -6.796528, -1.535863, 0.672559>,
      < -6.796528, -1.551863, 0.672559>
    }
    triangle {
      < -6.780094, -1.535863, 0.822806>,
      < -6.796528, -1.551863, 0.672559>,
      < -6.780094, -1.551863, 0.822806>
    }
    triangle {
      < -6.761919, -1.535863, 0.988957>,
      < -6.778354, -1.535863, 0.838711>,
      < -6.778354, -1.551863, 0.838711>
    }
    triangle {
      < -6.761919, -1.535863, 0.988957>,
      < -6.778354, -1.551863, 0.838711>,
      < -6.761919, -1.551863, 0.988957>
    }
    triangle {
      < -6.760180, -1.603042, 1.004863>,
      < -6.760180, -1.551863, 1.004863>,
      < -6.761919, -1.551863, 0.988957>
    }
    triangle {
      < -6.760180, -1.603042, 1.004863>,
      < -6.761919, -1.551863, 0.988957>,
      < -6.761919, -1.603042, 0.988958>
    }
    triangle {
      < -6.743745, -1.535863, 1.155109>,
      < -6.760180, -1.535863, 1.004863>,
      < -6.760180, -1.551863, 1.004863>
    }
    triangle {
      < -6.743745, -1.535863, 1.155109>,
      < -6.760180, -1.551863, 1.004863>,
      < -6.743745, -1.551863, 1.155109>
    }
    triangle {
      < -6.725572, -1.535863, 1.321261>,
      < -6.742006, -1.535863, 1.171014>,
      < -6.742006, -1.551863, 1.171014>
    }
    triangle {
      < -6.725572, -1.535863, 1.321261>,
      < -6.742006, -1.551863, 1.171014>,
      < -6.725572, -1.551863, 1.321261>
    }
    triangle {
      < -6.723832, -1.603042, 1.337166>,
      < -6.723832, -1.551863, 1.337166>,
      < -6.725572, -1.551863, 1.321261>
    }
    triangle {
      < -6.723832, -1.603042, 1.337166>,
      < -6.725572, -1.551863, 1.321261>,
      < -6.725572, -1.603042, 1.321261>
    }
    triangle {
      < -6.707397, -1.535863, 1.487412>,
      < -6.723832, -1.535863, 1.337166>,
      < -6.723832, -1.551863, 1.337166>
    }
    triangle {
      < -6.707397, -1.535863, 1.487412>,
      < -6.723832, -1.551863, 1.337166>,
      < -6.707397, -1.551863, 1.487412>
    }
    triangle {
      < -6.689224, -1.535863, 1.653564>,
      < -6.705658, -1.535863, 1.503317>,
      < -6.705658, -1.551863, 1.503317>
    }
    triangle {
      < -6.689224, -1.535863, 1.653564>,
      < -6.705658, -1.551863, 1.503317>,
      < -6.689224, -1.551863, 1.653564>
    }
    triangle {
      < -6.687484, -1.603042, 1.669469>,
      < -6.687484, -1.551863, 1.669469>,
      < -6.689224, -1.551863, 1.653564>
    }
    triangle {
      < -6.687484, -1.603042, 1.669469>,
      < -6.689224, -1.551863, 1.653564>,
      < -6.689224, -1.603042, 1.653564>
    }
    triangle {
      < -6.671050, -1.535863, 1.819715>,
      < -6.687484, -1.535863, 1.669469>,
      < -6.687484, -1.551863, 1.669469>
    }
    triangle {
      < -6.671050, -1.535863, 1.819715>,
      < -6.687484, -1.551863, 1.669469>,
      < -6.671050, -1.551863, 1.819715>
    }
    triangle {
      < -6.652875, -1.535863, 1.985867>,
      < -6.669310, -1.535863, 1.835621>,
      < -6.669310, -1.551863, 1.835621>
    }
    triangle {
      < -6.652875, -1.535863, 1.985867>,
      < -6.669310, -1.551863, 1.835621>,
      < -6.652875, -1.551863, 1.985867>
    }
    triangle {
      < -6.651136, -1.603042, 2.001772>,
      < -6.651136, -1.551863, 2.001772>,
      < -6.652875, -1.551863, 1.985867>
    }
    triangle {
      < -6.651136, -1.603042, 2.001772>,
      < -6.652875, -1.551863, 1.985867>,
      < -6.652875, -1.603042, 1.985867>
    }
    triangle {
      < -6.634702, -1.535863, 2.152019>,
      < -6.651136, -1.535863, 2.001772>,
      < -6.651136, -1.551863, 2.001772>
    }
    triangle {
      < -6.634702, -1.535863, 2.152019>,
      < -6.651136, -1.551863, 2.001772>,
      < -6.634702, -1.551863, 2.152019>
    }
    triangle {
      < -6.616529, -1.535863, 2.318171>,
      < -6.632963, -1.535863, 2.167924>,
      < -6.632963, -1.551863, 2.167924>
    }
    triangle {
      < -6.616529, -1.535863, 2.318171>,
      < -6.632963, -1.551863, 2.167924>,
      < -6.616529, -1.551863, 2.318171>
    }
    triangle {
      < -6.614789, -1.603042, 2.334076>,
      < -6.614789, -1.551863, 2.334076>,
      < -6.616529, -1.551863, 2.318171>
    }
    triangle {
      < -6.614789, -1.603042, 2.334076>,
      < -6.616529, -1.551863, 2.318171>,
      < -6.616529, -1.603042, 2.318171>
    }
    triangle {
      < -6.598354, -1.535863, 2.484322>,
      < -6.614789, -1.535863, 2.334076>,
      < -6.614789, -1.551863, 2.334076>
    }
    triangle {
      < -6.598354, -1.535863, 2.484322>,
      < -6.614789, -1.551863, 2.334076>,
      < -6.598354, -1.551863, 2.484322>
    }
    triangle {
      < -6.598354, -1.551863, 2.484322>,
      < -6.598354, -1.603042, 2.484322>,
      < -6.596615, -1.603042, 2.500227>
    }
    triangle {
      < -6.598354, -1.551863, 2.484322>,
      < -6.596615, -1.603042, 2.500227>,
      < -6.596615, -1.551863, 2.500227>
    }
    triangle {
      < -6.580181, -1.535863, 2.650474>,
      < -6.596615, -1.535863, 2.500227>,
      < -6.596615, -1.551863, 2.500227>
    }
    triangle {
      < -6.580181, -1.535863, 2.650474>,
      < -6.596615, -1.551863, 2.500227>,
      < -6.580181, -1.551863, 2.650474>
    }
    triangle {
      < -6.634702, -1.551863, 2.152019>,
      < -6.634702, -1.603042, 2.152019>,
      < -6.632963, -1.603042, 2.167924>
    }
    triangle {
      < -6.634702, -1.551863, 2.152019>,
      < -6.632963, -1.603042, 2.167924>,
      < -6.632963, -1.551863, 2.167924>
    }
    triangle {
      < -6.671050, -1.551863, 1.819715>,
      < -6.671050, -1.603042, 1.819715>,
      < -6.669310, -1.603042, 1.835621>
    }
    triangle {
      < -6.671050, -1.551863, 1.819715>,
      < -6.669310, -1.603042, 1.835621>,
      < -6.669310, -1.551863, 1.835621>
    }
    triangle {
      < -6.707397, -1.551863, 1.487412>,
      < -6.707397, -1.603042, 1.487412>,
      < -6.705658, -1.603042, 1.503318>
    }
    triangle {
      < -6.707397, -1.551863, 1.487412>,
      < -6.705658, -1.603042, 1.503318>,
      < -6.705658, -1.551863, 1.503317>
    }
    triangle {
      < -6.743745, -1.551863, 1.155109>,
      < -6.743745, -1.603042, 1.155109>,
      < -6.742006, -1.603042, 1.171014>
    }
    triangle {
      < -6.743745, -1.551863, 1.155109>,
      < -6.742006, -1.603042, 1.171014>,
      < -6.742006, -1.551863, 1.171014>
    }
    triangle {
      < -6.780094, -1.551863, 0.822806>,
      < -6.780094, -1.603042, 0.822806>,
      < -6.778354, -1.603042, 0.838711>
    }
    triangle {
      < -6.780094, -1.551863, 0.822806>,
      < -6.778354, -1.603042, 0.838711>,
      < -6.778354, -1.551863, 0.838711>
    }
    triangle {
      < -6.816442, -1.551863, 0.490503>,
      < -6.816442, -1.603042, 0.490503>,
      < -6.814702, -1.603042, 0.506408>
    }
    triangle {
      < -6.816442, -1.551863, 0.490503>,
      < -6.814702, -1.603042, 0.506408>,
      < -6.814702, -1.551863, 0.506408>
    }
    triangle {
      < -6.852789, -1.551863, 0.158199>,
      < -6.852789, -1.603042, 0.158199>,
      < -6.851050, -1.603042, 0.174104>
    }
    triangle {
      < -6.852789, -1.551863, 0.158199>,
      < -6.851050, -1.603042, 0.174104>,
      < -6.851050, -1.551863, 0.174104>
    }
    triangle {
      < -6.832877, -1.551863, -0.340256>,
      < -6.832877, -1.603042, -0.340256>,
      < -6.834616, -1.603042, -0.324351>
    }
    triangle {
      < -6.832877, -1.551863, -0.340256>,
      < -6.834616, -1.603042, -0.324351>,
      < -6.834616, -1.551863, -0.324351>
    }
    triangle {
      < -6.796529, -1.551863, -0.672559>,
      < -6.796529, -1.603042, -0.672559>,
      < -6.798269, -1.603042, -0.656654>
    }
    triangle {
      < -6.796529, -1.551863, -0.672559>,
      < -6.798269, -1.603042, -0.656654>,
      < -6.798269, -1.551863, -0.656654>
    }
    triangle {
      < -6.760181, -1.551863, -1.004862>,
      < -6.760181, -1.603042, -1.004862>,
      < -6.761921, -1.603042, -0.988957>
    }
    triangle {
      < -6.760181, -1.551863, -1.004862>,
      < -6.761921, -1.603042, -0.988957>,
      < -6.761921, -1.551863, -0.988957>
    }
    triangle {
      < -6.723834, -1.551863, -1.337165>,
      < -6.723834, -1.603042, -1.337165>,
      < -6.725573, -1.603042, -1.321260>
    }
    triangle {
      < -6.723834, -1.551863, -1.337165>,
      < -6.725573, -1.603042, -1.321260>,
      < -6.725573, -1.551863, -1.321260>
    }
    triangle {
      < -6.687486, -1.551863, -1.669469>,
      < -6.687486, -1.603042, -1.669468>,
      < -6.689225, -1.603042, -1.653563>
    }
    triangle {
      < -6.687486, -1.551863, -1.669469>,
      < -6.689225, -1.603042, -1.653563>,
      < -6.689225, -1.551863, -1.653563>
    }
    triangle {
      < -6.651138, -1.551863, -2.001772>,
      < -6.651138, -1.603042, -2.001772>,
      < -6.652877, -1.603042, -1.985867>
    }
    triangle {
      < -6.651138, -1.551863, -2.001772>,
      < -6.652877, -1.603042, -1.985867>,
      < -6.652877, -1.551863, -1.985867>
    }
    triangle {
      < -6.614789, -1.551863, -2.334075>,
      < -6.614789, -1.603042, -2.334075>,
      < -6.616529, -1.603042, -2.318170>
    }
    triangle {
      < -6.614789, -1.551863, -2.334075>,
      < -6.616529, -1.603042, -2.318170>,
      < -6.616529, -1.551863, -2.318170>
    }
    triangle {
      < -6.869224, -1.401505, -0.007953>,
      < -6.852789, -1.401505, -0.158199>,
      < -6.852789, -1.417505, -0.158199>
    }
    triangle {
      < -6.869224, -1.401505, -0.007953>,
      < -6.852789, -1.417505, -0.158199>,
      < -6.869224, -1.417505, -0.007953>
    }
    triangle {
      < -6.852790, -1.401505, 0.158199>,
      < -6.869224, -1.401505, 0.007953>,
      < -6.869224, -1.417505, 0.007953>
    }
    triangle {
      < -6.852790, -1.401505, 0.158199>,
      < -6.869224, -1.417505, 0.007953>,
      < -6.852790, -1.417505, 0.158199>
    }
    triangle {
      < -6.596615, -1.401505, -2.500227>,
      < -6.580181, -1.401505, -2.650473>,
      < -6.580181, -1.417505, -2.650473>
    }
    triangle {
      < -6.596615, -1.401505, -2.500227>,
      < -6.580181, -1.417505, -2.650473>,
      < -6.596615, -1.417505, -2.500227>
    }
    triangle {
      < -6.614789, -1.401505, -2.334075>,
      < -6.598354, -1.401505, -2.484322>,
      < -6.598354, -1.417505, -2.484322>
    }
    triangle {
      < -6.614789, -1.401505, -2.334075>,
      < -6.598354, -1.417505, -2.484322>,
      < -6.614789, -1.417505, -2.334075>
    }
    triangle {
      < -6.632963, -1.401505, -2.167924>,
      < -6.616529, -1.401505, -2.318170>,
      < -6.616529, -1.417505, -2.318170>
    }
    triangle {
      < -6.632963, -1.401505, -2.167924>,
      < -6.616529, -1.417505, -2.318170>,
      < -6.632963, -1.417505, -2.167924>
    }
    triangle {
      < -6.651137, -1.401505, -2.001772>,
      < -6.634702, -1.401505, -2.152019>,
      < -6.634702, -1.417505, -2.152018>
    }
    triangle {
      < -6.651137, -1.401505, -2.001772>,
      < -6.634702, -1.417505, -2.152018>,
      < -6.651137, -1.417505, -2.001772>
    }
    triangle {
      < -6.669311, -1.401505, -1.835621>,
      < -6.652876, -1.401505, -1.985867>,
      < -6.652876, -1.417505, -1.985867>
    }
    triangle {
      < -6.669311, -1.401505, -1.835621>,
      < -6.652876, -1.417505, -1.985867>,
      < -6.669311, -1.417505, -1.835620>
    }
    triangle {
      < -6.687485, -1.401505, -1.669469>,
      < -6.671051, -1.401505, -1.819715>,
      < -6.671051, -1.417505, -1.819715>
    }
    triangle {
      < -6.687485, -1.401505, -1.669469>,
      < -6.671051, -1.417505, -1.819715>,
      < -6.687485, -1.417505, -1.669469>
    }
    triangle {
      < -6.705659, -1.401505, -1.503317>,
      < -6.689224, -1.401505, -1.653564>,
      < -6.689224, -1.417505, -1.653564>
    }
    triangle {
      < -6.705659, -1.401505, -1.503317>,
      < -6.689224, -1.417505, -1.653564>,
      < -6.705659, -1.417505, -1.503317>
    }
    triangle {
      < -6.723833, -1.401505, -1.337166>,
      < -6.707398, -1.401505, -1.487412>,
      < -6.707398, -1.417505, -1.487412>
    }
    triangle {
      < -6.723833, -1.401505, -1.337166>,
      < -6.707398, -1.417505, -1.487412>,
      < -6.723833, -1.417505, -1.337166>
    }
    triangle {
      < -6.742007, -1.401505, -1.171014>,
      < -6.725572, -1.401505, -1.321260>,
      < -6.725572, -1.417505, -1.321260>
    }
    triangle {
      < -6.742007, -1.401505, -1.171014>,
      < -6.725572, -1.417505, -1.321260>,
      < -6.742007, -1.417505, -1.171014>
    }
    triangle {
      < -6.760181, -1.401505, -1.004862>,
      < -6.743746, -1.401505, -1.155109>,
      < -6.743746, -1.417505, -1.155109>
    }
    triangle {
      < -6.760181, -1.401505, -1.004862>,
      < -6.743746, -1.417505, -1.155109>,
      < -6.760181, -1.417505, -1.004862>
    }
    triangle {
      < -6.778355, -1.401505, -0.838711>,
      < -6.761920, -1.401505, -0.988957>,
      < -6.761920, -1.417505, -0.988957>
    }
    triangle {
      < -6.778355, -1.401505, -0.838711>,
      < -6.761920, -1.417505, -0.988957>,
      < -6.778355, -1.417505, -0.838711>
    }
    triangle {
      < -6.796529, -1.401505, -0.672559>,
      < -6.780094, -1.401505, -0.822805>,
      < -6.780094, -1.417505, -0.822805>
    }
    triangle {
      < -6.796529, -1.401505, -0.672559>,
      < -6.780094, -1.417505, -0.822805>,
      < -6.796529, -1.417505, -0.672559>
    }
    triangle {
      < -6.814703, -1.401505, -0.506407>,
      < -6.798268, -1.401505, -0.656654>,
      < -6.798268, -1.417505, -0.656654>
    }
    triangle {
      < -6.814703, -1.401505, -0.506407>,
      < -6.798268, -1.417505, -0.656654>,
      < -6.814703, -1.417505, -0.506407>
    }
    triangle {
      < -6.832876, -1.401505, -0.340256>,
      < -6.816442, -1.401505, -0.490502>,
      < -6.816442, -1.417505, -0.490502>
    }
    triangle {
      < -6.832876, -1.401505, -0.340256>,
      < -6.816442, -1.417505, -0.490502>,
      < -6.832876, -1.417505, -0.340256>
    }
    triangle {
      < -6.851050, -1.401505, -0.174104>,
      < -6.834615, -1.401505, -0.324351>,
      < -6.834615, -1.417505, -0.324351>
    }
    triangle {
      < -6.851050, -1.401505, -0.174104>,
      < -6.834615, -1.417505, -0.324351>,
      < -6.851050, -1.417505, -0.174104>
    }
    triangle {
      < -6.834616, -1.401505, 0.324351>,
      < -6.851051, -1.401505, 0.174104>,
      < -6.851051, -1.417505, 0.174104>
    }
    triangle {
      < -6.834616, -1.401505, 0.324351>,
      < -6.851051, -1.417505, 0.174104>,
      < -6.834616, -1.417505, 0.324351>
    }
    triangle {
      < -6.816442, -1.401505, 0.490502>,
      < -6.832877, -1.401505, 0.340256>,
      < -6.832877, -1.417505, 0.340256>
    }
    triangle {
      < -6.816442, -1.401505, 0.490502>,
      < -6.832877, -1.417505, 0.340256>,
      < -6.816442, -1.417505, 0.490502>
    }
    triangle {
      < -6.798268, -1.401505, 0.656654>,
      < -6.814703, -1.401505, 0.506407>,
      < -6.814703, -1.417505, 0.506407>
    }
    triangle {
      < -6.798268, -1.401505, 0.656654>,
      < -6.814703, -1.417505, 0.506407>,
      < -6.798268, -1.417505, 0.656654>
    }
    triangle {
      < -6.780094, -1.401505, 0.822806>,
      < -6.796529, -1.401505, 0.672559>,
      < -6.796529, -1.417505, 0.672559>
    }
    triangle {
      < -6.780094, -1.401505, 0.822806>,
      < -6.796529, -1.417505, 0.672559>,
      < -6.780094, -1.417505, 0.822806>
    }
    triangle {
      < -6.761920, -1.401505, 0.988957>,
      < -6.778355, -1.401505, 0.838711>,
      < -6.778355, -1.417505, 0.838711>
    }
    triangle {
      < -6.761920, -1.401505, 0.988957>,
      < -6.778355, -1.417505, 0.838711>,
      < -6.761920, -1.417505, 0.988957>
    }
    triangle {
      < -6.743746, -1.401505, 1.155109>,
      < -6.760181, -1.401505, 1.004863>,
      < -6.760181, -1.417505, 1.004863>
    }
    triangle {
      < -6.743746, -1.401505, 1.155109>,
      < -6.760181, -1.417505, 1.004863>,
      < -6.743746, -1.417505, 1.155109>
    }
    triangle {
      < -6.725572, -1.401505, 1.321261>,
      < -6.742007, -1.401505, 1.171014>,
      < -6.742007, -1.417505, 1.171014>
    }
    triangle {
      < -6.725572, -1.401505, 1.321261>,
      < -6.742007, -1.417505, 1.171014>,
      < -6.725572, -1.417505, 1.321261>
    }
    triangle {
      < -6.707398, -1.401505, 1.487412>,
      < -6.723833, -1.401505, 1.337166>,
      < -6.723833, -1.417505, 1.337166>
    }
    triangle {
      < -6.707398, -1.401505, 1.487412>,
      < -6.723833, -1.417505, 1.337166>,
      < -6.707398, -1.417505, 1.487412>
    }
    triangle {
      < -6.689224, -1.401505, 1.653564>,
      < -6.705659, -1.401505, 1.503317>,
      < -6.705659, -1.417505, 1.503317>
    }
    triangle {
      < -6.689224, -1.401505, 1.653564>,
      < -6.705659, -1.417505, 1.503317>,
      < -6.689224, -1.417505, 1.653564>
    }
    triangle {
      < -6.671051, -1.401505, 1.819715>,
      < -6.687485, -1.401505, 1.669469>,
      < -6.687485, -1.417505, 1.669469>
    }
    triangle {
      < -6.671051, -1.401505, 1.819715>,
      < -6.687485, -1.417505, 1.669469>,
      < -6.671051, -1.417505, 1.819715>
    }
    triangle {
      < -6.652876, -1.401505, 1.985867>,
      < -6.669311, -1.401505, 1.835620>,
      < -6.669311, -1.417505, 1.835621>
    }
    triangle {
      < -6.652876, -1.401505, 1.985867>,
      < -6.669311, -1.417505, 1.835621>,
      < -6.652876, -1.417505, 1.985867>
    }
    triangle {
      < -6.634703, -1.401505, 2.152019>,
      < -6.651137, -1.401505, 2.001772>,
      < -6.651137, -1.417505, 2.001772>
    }
    triangle {
      < -6.634703, -1.401505, 2.152019>,
      < -6.651137, -1.417505, 2.001772>,
      < -6.634703, -1.417505, 2.152019>
    }
    triangle {
      < -6.616529, -1.401505, 2.318170>,
      < -6.632964, -1.401505, 2.167924>,
      < -6.632964, -1.417505, 2.167924>
    }
    triangle {
      < -6.616529, -1.401505, 2.318170>,
      < -6.632964, -1.417505, 2.167924>,
      < -6.616529, -1.417505, 2.318170>
    }
    triangle {
      < -6.598355, -1.401505, 2.484322>,
      < -6.614789, -1.401505, 2.334075>,
      < -6.614789, -1.417505, 2.334076>
    }
    triangle {
      < -6.598355, -1.401505, 2.484322>,
      < -6.614789, -1.417505, 2.334076>,
      < -6.598355, -1.417505, 2.484322>
    }
    triangle {
      < -6.580181, -1.401505, 2.650474>,
      < -6.596616, -1.401505, 2.500227>,
      < -6.596616, -1.417505, 2.500227>
    }
    triangle {
      < -6.580181, -1.401505, 2.650474>,
      < -6.596616, -1.417505, 2.500227>,
      < -6.580181, -1.417505, 2.650474>
    }
    triangle {
      < -6.869224, -1.267147, 0.007953>,
      < -6.869224, -1.215968, 0.007953>,
      < -6.869224, -1.215968, -0.007953>
    }
    triangle {
      < -6.869224, -1.267147, 0.007953>,
      < -6.869224, -1.215968, -0.007953>,
      < -6.869224, -1.267147, -0.007953>
    }
    triangle {
      < -6.869224, -1.267147, -0.007953>,
      < -6.852789, -1.267147, -0.158199>,
      < -6.852789, -1.283147, -0.158199>
    }
    triangle {
      < -6.869224, -1.267147, -0.007953>,
      < -6.852789, -1.283147, -0.158199>,
      < -6.869224, -1.283147, -0.007953>
    }
    triangle {
      < -6.852790, -1.267147, 0.158199>,
      < -6.869224, -1.267147, 0.007953>,
      < -6.869224, -1.283147, 0.007953>
    }
    triangle {
      < -6.852790, -1.267147, 0.158199>,
      < -6.869224, -1.283147, 0.007953>,
      < -6.852790, -1.283147, 0.158199>
    }
    triangle {
      < -6.580181, -1.267147, -2.650473>,
      < -6.580181, -1.215968, -2.650473>,
      < -6.571311, -1.207968, -2.658426>
    }
    triangle {
      < -6.580181, -1.267147, -2.650473>,
      < -6.571311, -1.207968, -2.658426>,
      < -6.571311, -1.275147, -2.658426>
    }
    triangle {
      < -6.596615, -1.267147, -2.500227>,
      < -6.580181, -1.267147, -2.650473>,
      < -6.580181, -1.283147, -2.650473>
    }
    triangle {
      < -6.596615, -1.267147, -2.500227>,
      < -6.580181, -1.283147, -2.650473>,
      < -6.596615, -1.283147, -2.500227>
    }
    triangle {
      < -6.598354, -1.267147, -2.484322>,
      < -6.598354, -1.215968, -2.484322>,
      < -6.596615, -1.215968, -2.500227>
    }
    triangle {
      < -6.598354, -1.267147, -2.484322>,
      < -6.596615, -1.215968, -2.500227>,
      < -6.596615, -1.267147, -2.500227>
    }
    triangle {
      < -6.614789, -1.267147, -2.334075>,
      < -6.598354, -1.267147, -2.484322>,
      < -6.598354, -1.283147, -2.484322>
    }
    triangle {
      < -6.614789, -1.267147, -2.334075>,
      < -6.598354, -1.283147, -2.484322>,
      < -6.614789, -1.283147, -2.334075>
    }
    triangle {
      < -6.634702, -1.267147, -2.152019>,
      < -6.634702, -1.215968, -2.152019>,
      < -6.632962, -1.215968, -2.167924>
    }
    triangle {
      < -6.634702, -1.267147, -2.152019>,
      < -6.632962, -1.215968, -2.167924>,
      < -6.632962, -1.267147, -2.167924>
    }
    triangle {
      < -6.632962, -1.267147, -2.167924>,
      < -6.616529, -1.267147, -2.318170>,
      < -6.616529, -1.283147, -2.318170>
    }
    triangle {
      < -6.632962, -1.267147, -2.167924>,
      < -6.616529, -1.283147, -2.318170>,
      < -6.632962, -1.283147, -2.167924>
    }
    triangle {
      < -6.651136, -1.267147, -2.001772>,
      < -6.634702, -1.267147, -2.152019>,
      < -6.634702, -1.283147, -2.152019>
    }
    triangle {
      < -6.651136, -1.267147, -2.001772>,
      < -6.634702, -1.283147, -2.152019>,
      < -6.651136, -1.283147, -2.001772>
    }
    triangle {
      < -6.671050, -1.267147, -1.819715>,
      < -6.671050, -1.215968, -1.819715>,
      < -6.669310, -1.215968, -1.835621>
    }
    triangle {
      < -6.671050, -1.267147, -1.819715>,
      < -6.669310, -1.215968, -1.835621>,
      < -6.669310, -1.267147, -1.835621>
    }
    triangle {
      < -6.669310, -1.267147, -1.835621>,
      < -6.652875, -1.267147, -1.985867>,
      < -6.652875, -1.283147, -1.985867>
    }
    triangle {
      < -6.669310, -1.267147, -1.835621>,
      < -6.652875, -1.283147, -1.985867>,
      < -6.669310, -1.283147, -1.835621>
    }
    triangle {
      < -6.687484, -1.267147, -1.669469>,
      < -6.671050, -1.267147, -1.819715>,
      < -6.671050, -1.283147, -1.819715>
    }
    triangle {
      < -6.687484, -1.267147, -1.669469>,
      < -6.671050, -1.283147, -1.819715>,
      < -6.687484, -1.283147, -1.669469>
    }
    triangle {
      < -6.707397, -1.267147, -1.487412>,
      < -6.707397, -1.215968, -1.487412>,
      < -6.705658, -1.215968, -1.503317>
    }
    triangle {
      < -6.707397, -1.267147, -1.487412>,
      < -6.705658, -1.215968, -1.503317>,
      < -6.705658, -1.267147, -1.503317>
    }
    triangle {
      < -6.705658, -1.267147, -1.503317>,
      < -6.689224, -1.267147, -1.653564>,
      < -6.689224, -1.283147, -1.653564>
    }
    triangle {
      < -6.705658, -1.267147, -1.503317>,
      < -6.689224, -1.283147, -1.653564>,
      < -6.705658, -1.283147, -1.503317>
    }
    triangle {
      < -6.723832, -1.267147, -1.337166>,
      < -6.707397, -1.267147, -1.487412>,
      < -6.707397, -1.283147, -1.487412>
    }
    triangle {
      < -6.723832, -1.267147, -1.337166>,
      < -6.707397, -1.283147, -1.487412>,
      < -6.723832, -1.283147, -1.337166>
    }
    triangle {
      < -6.743745, -1.267147, -1.155109>,
      < -6.743745, -1.215968, -1.155109>,
      < -6.742006, -1.215968, -1.171014>
    }
    triangle {
      < -6.743745, -1.267147, -1.155109>,
      < -6.742006, -1.215968, -1.171014>,
      < -6.742006, -1.267147, -1.171014>
    }
    triangle {
      < -6.742006, -1.267147, -1.171014>,
      < -6.725572, -1.267147, -1.321260>,
      < -6.725572, -1.283147, -1.321260>
    }
    triangle {
      < -6.742006, -1.267147, -1.171014>,
      < -6.725572, -1.283147, -1.321260>,
      < -6.742006, -1.283147, -1.171014>
    }
    triangle {
      < -6.760180, -1.267147, -1.004862>,
      < -6.743745, -1.267147, -1.155109>,
      < -6.743745, -1.283147, -1.155109>
    }
    triangle {
      < -6.760180, -1.267147, -1.004862>,
      < -6.743745, -1.283147, -1.155109>,
      < -6.760180, -1.283147, -1.004862>
    }
    triangle {
      < -6.780094, -1.267147, -0.822806>,
      < -6.780094, -1.215968, -0.822806>,
      < -6.778354, -1.215968, -0.838711>
    }
    triangle {
      < -6.780094, -1.267147, -0.822806>,
      < -6.778354, -1.215968, -0.838711>,
      < -6.778354, -1.267147, -0.838711>
    }
    triangle {
      < -6.778354, -1.267147, -0.838711>,
      < -6.761919, -1.267147, -0.988957>,
      < -6.761919, -1.283147, -0.988957>
    }
    triangle {
      < -6.778354, -1.267147, -0.838711>,
      < -6.761919, -1.283147, -0.988957>,
      < -6.778354, -1.283147, -0.838711>
    }
    triangle {
      < -6.796528, -1.267147, -0.672559>,
      < -6.780094, -1.267147, -0.822806>,
      < -6.780094, -1.283147, -0.822806>
    }
    triangle {
      < -6.796528, -1.267147, -0.672559>,
      < -6.780094, -1.283147, -0.822806>,
      < -6.796528, -1.283147, -0.672559>
    }
    triangle {
      < -6.816442, -1.267147, -0.490502>,
      < -6.816442, -1.215968, -0.490502>,
      < -6.814702, -1.215968, -0.506407>
    }
    triangle {
      < -6.816442, -1.267147, -0.490502>,
      < -6.814702, -1.215968, -0.506407>,
      < -6.814702, -1.267147, -0.506407>
    }
    triangle {
      < -6.814702, -1.267147, -0.506407>,
      < -6.798267, -1.267147, -0.656654>,
      < -6.798267, -1.283147, -0.656654>
    }
    triangle {
      < -6.814702, -1.267147, -0.506407>,
      < -6.798267, -1.283147, -0.656654>,
      < -6.814702, -1.283147, -0.506407>
    }
    triangle {
      < -6.832876, -1.267147, -0.340256>,
      < -6.816442, -1.267147, -0.490502>,
      < -6.816442, -1.283147, -0.490502>
    }
    triangle {
      < -6.832876, -1.267147, -0.340256>,
      < -6.816442, -1.283147, -0.490502>,
      < -6.832876, -1.283147, -0.340256>
    }
    triangle {
      < -6.852789, -1.267147, -0.158199>,
      < -6.852789, -1.215968, -0.158199>,
      < -6.851050, -1.215968, -0.174104>
    }
    triangle {
      < -6.852789, -1.267147, -0.158199>,
      < -6.851050, -1.215968, -0.174104>,
      < -6.851050, -1.267147, -0.174104>
    }
    triangle {
      < -6.851050, -1.267147, -0.174104>,
      < -6.834615, -1.267147, -0.324351>,
      < -6.834615, -1.283147, -0.324351>
    }
    triangle {
      < -6.851050, -1.267147, -0.174104>,
      < -6.834615, -1.283147, -0.324351>,
      < -6.851050, -1.283147, -0.174104>
    }
    triangle {
      < -6.832877, -1.267147, 0.340256>,
      < -6.832877, -1.215968, 0.340256>,
      < -6.834616, -1.215968, 0.324351>
    }
    triangle {
      < -6.832877, -1.267147, 0.340256>,
      < -6.834616, -1.215968, 0.324351>,
      < -6.834616, -1.267147, 0.324351>
    }
    triangle {
      < -6.834616, -1.267147, 0.324351>,
      < -6.851051, -1.267147, 0.174104>,
      < -6.851051, -1.283147, 0.174104>
    }
    triangle {
      < -6.834616, -1.267147, 0.324351>,
      < -6.851051, -1.283147, 0.174104>,
      < -6.834616, -1.283147, 0.324351>
    }
    triangle {
      < -6.816443, -1.267147, 0.490502>,
      < -6.832877, -1.267147, 0.340256>,
      < -6.832877, -1.283147, 0.340256>
    }
    triangle {
      < -6.816443, -1.267147, 0.490502>,
      < -6.832877, -1.283147, 0.340256>,
      < -6.816443, -1.283147, 0.490502>
    }
    triangle {
      < -6.796529, -1.267147, 0.672559>,
      < -6.796529, -1.215968, 0.672559>,
      < -6.798269, -1.215968, 0.656654>
    }
    triangle {
      < -6.796529, -1.267147, 0.672559>,
      < -6.798269, -1.215968, 0.656654>,
      < -6.798269, -1.267147, 0.656654>
    }
    triangle {
      < -6.798269, -1.267147, 0.656654>,
      < -6.814703, -1.267147, 0.506407>,
      < -6.814703, -1.283147, 0.506407>
    }
    triangle {
      < -6.798269, -1.267147, 0.656654>,
      < -6.814703, -1.283147, 0.506407>,
      < -6.798269, -1.283147, 0.656654>
    }
    triangle {
      < -6.780095, -1.267147, 0.822806>,
      < -6.796529, -1.267147, 0.672559>,
      < -6.796529, -1.283147, 0.672559>
    }
    triangle {
      < -6.780095, -1.267147, 0.822806>,
      < -6.796529, -1.283147, 0.672559>,
      < -6.780095, -1.283147, 0.822806>
    }
    triangle {
      < -6.760181, -1.267147, 1.004862>,
      < -6.760181, -1.215968, 1.004862>,
      < -6.761921, -1.215968, 0.988957>
    }
    triangle {
      < -6.760181, -1.267147, 1.004862>,
      < -6.761921, -1.215968, 0.988957>,
      < -6.761921, -1.267147, 0.988957>
    }
    triangle {
      < -6.761921, -1.267147, 0.988957>,
      < -6.778356, -1.267147, 0.838711>,
      < -6.778356, -1.283147, 0.838711>
    }
    triangle {
      < -6.761921, -1.267147, 0.988957>,
      < -6.778356, -1.283147, 0.838711>,
      < -6.761921, -1.283147, 0.988957>
    }
    triangle {
      < -6.743747, -1.267147, 1.155109>,
      < -6.760181, -1.267147, 1.004862>,
      < -6.760181, -1.283147, 1.004862>
    }
    triangle {
      < -6.743747, -1.267147, 1.155109>,
      < -6.760181, -1.283147, 1.004862>,
      < -6.743747, -1.283147, 1.155109>
    }
    triangle {
      < -6.723834, -1.267147, 1.337166>,
      < -6.723834, -1.215968, 1.337166>,
      < -6.725573, -1.215968, 1.321261>
    }
    triangle {
      < -6.723834, -1.267147, 1.337166>,
      < -6.725573, -1.215968, 1.321261>,
      < -6.725573, -1.267147, 1.321261>
    }
    triangle {
      < -6.725573, -1.267147, 1.321261>,
      < -6.742008, -1.267147, 1.171014>,
      < -6.742008, -1.283147, 1.171014>
    }
    triangle {
      < -6.725573, -1.267147, 1.321261>,
      < -6.742008, -1.283147, 1.171014>,
      < -6.725573, -1.283147, 1.321261>
    }
    triangle {
      < -6.707399, -1.267147, 1.487412>,
      < -6.723834, -1.267147, 1.337166>,
      < -6.723834, -1.283147, 1.337166>
    }
    triangle {
      < -6.707399, -1.267147, 1.487412>,
      < -6.723834, -1.283147, 1.337166>,
      < -6.707399, -1.283147, 1.487412>
    }
    triangle {
      < -6.687486, -1.267147, 1.669469>,
      < -6.687486, -1.215968, 1.669469>,
      < -6.689225, -1.215968, 1.653563>
    }
    triangle {
      < -6.687486, -1.267147, 1.669469>,
      < -6.689225, -1.215968, 1.653563>,
      < -6.689225, -1.267147, 1.653563>
    }
    triangle {
      < -6.689225, -1.267147, 1.653563>,
      < -6.705659, -1.267147, 1.503317>,
      < -6.705659, -1.283147, 1.503317>
    }
    triangle {
      < -6.689225, -1.267147, 1.653563>,
      < -6.705659, -1.283147, 1.503317>,
      < -6.689225, -1.283147, 1.653563>
    }
    triangle {
      < -6.671051, -1.267147, 1.819715>,
      < -6.687486, -1.267147, 1.669469>,
      < -6.687486, -1.283147, 1.669469>
    }
    triangle {
      < -6.671051, -1.267147, 1.819715>,
      < -6.687486, -1.283147, 1.669469>,
      < -6.671051, -1.283147, 1.819715>
    }
    triangle {
      < -6.651138, -1.267147, 2.001772>,
      < -6.651138, -1.215968, 2.001772>,
      < -6.652877, -1.215968, 1.985867>
    }
    triangle {
      < -6.651138, -1.267147, 2.001772>,
      < -6.652877, -1.215968, 1.985867>,
      < -6.652877, -1.267147, 1.985867>
    }
    triangle {
      < -6.652877, -1.267147, 1.985867>,
      < -6.669312, -1.267147, 1.835620>,
      < -6.669312, -1.283147, 1.835620>
    }
    triangle {
      < -6.652877, -1.267147, 1.985867>,
      < -6.669312, -1.283147, 1.835620>,
      < -6.652877, -1.283147, 1.985867>
    }
    triangle {
      < -6.634703, -1.267147, 2.152019>,
      < -6.651138, -1.267147, 2.001772>,
      < -6.651138, -1.283147, 2.001772>
    }
    triangle {
      < -6.634703, -1.267147, 2.152019>,
      < -6.651138, -1.283147, 2.001772>,
      < -6.634703, -1.283147, 2.152019>
    }
    triangle {
      < -6.614789, -1.267147, 2.334075>,
      < -6.614789, -1.215968, 2.334075>,
      < -6.616529, -1.215968, 2.318170>
    }
    triangle {
      < -6.614789, -1.267147, 2.334075>,
      < -6.616529, -1.215968, 2.318170>,
      < -6.616529, -1.267147, 2.318170>
    }
    triangle {
      < -6.616529, -1.267147, 2.318170>,
      < -6.632964, -1.267147, 2.167924>,
      < -6.632964, -1.283147, 2.167924>
    }
    triangle {
      < -6.616529, -1.267147, 2.318170>,
      < -6.632964, -1.283147, 2.167924>,
      < -6.616529, -1.283147, 2.318170>
    }
    triangle {
      < -6.598355, -1.267147, 2.484322>,
      < -6.614789, -1.267147, 2.334075>,
      < -6.614789, -1.283147, 2.334075>
    }
    triangle {
      < -6.598355, -1.267147, 2.484322>,
      < -6.614789, -1.283147, 2.334075>,
      < -6.598355, -1.283147, 2.484322>
    }
    triangle {
      < -6.580181, -1.267147, 2.650474>,
      < -6.596616, -1.267147, 2.500227>,
      < -6.596616, -1.283147, 2.500227>
    }
    triangle {
      < -6.580181, -1.267147, 2.650474>,
      < -6.596616, -1.283147, 2.500227>,
      < -6.580181, -1.283147, 2.650474>
    }
    triangle {
      < -6.598355, -1.215968, 2.484322>,
      < -6.598355, -1.267147, 2.484322>,
      < -6.596616, -1.267147, 2.500227>
    }
    triangle {
      < -6.598355, -1.215968, 2.484322>,
      < -6.596616, -1.267147, 2.500227>,
      < -6.596616, -1.215968, 2.500227>
    }
    triangle {
      < -6.634703, -1.215968, 2.152019>,
      < -6.634703, -1.267147, 2.152019>,
      < -6.632964, -1.267147, 2.167924>
    }
    triangle {
      < -6.634703, -1.215968, 2.152019>,
      < -6.632964, -1.267147, 2.167924>,
      < -6.632964, -1.215968, 2.167924>
    }
    triangle {
      < -6.671051, -1.215968, 1.819715>,
      < -6.671051, -1.267147, 1.819715>,
      < -6.669312, -1.267147, 1.835620>
    }
    triangle {
      < -6.671051, -1.215968, 1.819715>,
      < -6.669312, -1.267147, 1.835620>,
      < -6.669312, -1.215968, 1.835620>
    }
    triangle {
      < -6.707399, -1.215968, 1.487412>,
      < -6.707399, -1.267147, 1.487412>,
      < -6.705659, -1.267147, 1.503317>
    }
    triangle {
      < -6.707399, -1.215968, 1.487412>,
      < -6.705659, -1.267147, 1.503317>,
      < -6.705659, -1.215968, 1.503317>
    }
    triangle {
      < -6.743747, -1.215968, 1.155109>,
      < -6.743747, -1.267147, 1.155109>,
      < -6.742008, -1.267147, 1.171014>
    }
    triangle {
      < -6.743747, -1.215968, 1.155109>,
      < -6.742008, -1.267147, 1.171014>,
      < -6.742008, -1.215968, 1.171014>
    }
    triangle {
      < -6.780095, -1.215968, 0.822806>,
      < -6.780095, -1.267147, 0.822806>,
      < -6.778356, -1.267147, 0.838711>
    }
    triangle {
      < -6.780095, -1.215968, 0.822806>,
      < -6.778356, -1.267147, 0.838711>,
      < -6.778356, -1.215968, 0.838711>
    }
    triangle {
      < -6.816443, -1.215968, 0.490502>,
      < -6.816443, -1.267147, 0.490502>,
      < -6.814703, -1.267147, 0.506407>
    }
    triangle {
      < -6.816443, -1.215968, 0.490502>,
      < -6.814703, -1.267147, 0.506407>,
      < -6.814703, -1.215968, 0.506407>
    }
    triangle {
      < -6.852790, -1.215968, 0.158199>,
      < -6.852790, -1.267147, 0.158199>,
      < -6.851051, -1.267147, 0.174104>
    }
    triangle {
      < -6.852790, -1.215968, 0.158199>,
      < -6.851051, -1.267147, 0.174104>,
      < -6.851051, -1.215968, 0.174104>
    }
    triangle {
      < -6.832876, -1.215968, -0.340256>,
      < -6.832876, -1.267147, -0.340256>,
      < -6.834615, -1.267147, -0.324351>
    }
    triangle {
      < -6.832876, -1.215968, -0.340256>,
      < -6.834615, -1.267147, -0.324351>,
      < -6.834615, -1.215968, -0.324351>
    }
    triangle {
      < -6.796528, -1.215968, -0.672559>,
      < -6.796528, -1.267147, -0.672559>,
      < -6.798267, -1.267147, -0.656654>
    }
    triangle {
      < -6.796528, -1.215968, -0.672559>,
      < -6.798267, -1.267147, -0.656654>,
      < -6.798267, -1.215968, -0.656654>
    }
    triangle {
      < -6.760180, -1.215968, -1.004862>,
      < -6.760180, -1.267147, -1.004862>,
      < -6.761919, -1.267147, -0.988957>
    }
    triangle {
      < -6.760180, -1.215968, -1.004862>,
      < -6.761919, -1.267147, -0.988957>,
      < -6.761919, -1.215968, -0.988957>
    }
    triangle {
      < -6.723832, -1.215968, -1.337166>,
      < -6.723832, -1.267147, -1.337166>,
      < -6.725572, -1.267147, -1.321260>
    }
    triangle {
      < -6.723832, -1.215968, -1.337166>,
      < -6.725572, -1.267147, -1.321260>,
      < -6.725572, -1.215968, -1.321260>
    }
    triangle {
      < -6.687484, -1.215968, -1.669469>,
      < -6.687484, -1.267147, -1.669469>,
      < -6.689224, -1.267147, -1.653564>
    }
    triangle {
      < -6.687484, -1.215968, -1.669469>,
      < -6.689224, -1.267147, -1.653564>,
      < -6.689224, -1.215968, -1.653564>
    }
    triangle {
      < -6.651136, -1.215968, -2.001772>,
      < -6.651136, -1.267147, -2.001772>,
      < -6.652875, -1.267147, -1.985867>
    }
    triangle {
      < -6.651136, -1.215968, -2.001772>,
      < -6.652875, -1.267147, -1.985867>,
      < -6.652875, -1.215968, -1.985867>
    }
    triangle {
      < -6.614789, -1.215968, -2.334075>,
      < -6.614789, -1.267147, -2.334075>,
      < -6.616529, -1.267147, -2.318170>
    }
    triangle {
      < -6.614789, -1.215968, -2.334075>,
      < -6.616529, -1.267147, -2.318170>,
      < -6.616529, -1.215968, -2.318170>
    }
    triangle {
      < -6.869224, -1.199968, 0.007953>,
      < -6.869224, -1.148789, 0.007953>,
      < -6.869224, -1.148789, -0.007953>
    }
    triangle {
      < -6.869224, -1.199968, 0.007953>,
      < -6.869224, -1.148789, -0.007953>,
      < -6.869224, -1.199968, -0.007953>
    }
    triangle {
      < -6.869224, -1.199968, -0.007953>,
      < -6.852789, -1.199968, -0.158199>,
      < -6.852789, -1.215968, -0.158199>
    }
    triangle {
      < -6.869224, -1.199968, -0.007953>,
      < -6.852789, -1.215968, -0.158199>,
      < -6.869224, -1.215968, -0.007953>
    }
    triangle {
      < -6.852790, -1.199968, 0.158199>,
      < -6.869224, -1.199968, 0.007953>,
      < -6.869224, -1.215968, 0.007953>
    }
    triangle {
      < -6.852790, -1.199968, 0.158199>,
      < -6.869224, -1.215968, 0.007953>,
      < -6.852790, -1.215968, 0.158199>
    }
    triangle {
      < -6.580181, -1.199968, -2.650473>,
      < -6.580181, -1.148789, -2.650473>,
      < -6.571311, -1.140788, -2.658426>
    }
    triangle {
      < -6.580181, -1.199968, -2.650473>,
      < -6.571311, -1.140788, -2.658426>,
      < -6.571311, -1.207968, -2.658426>
    }
    triangle {
      < -6.596615, -1.199968, -2.500227>,
      < -6.580181, -1.199968, -2.650473>,
      < -6.580181, -1.215968, -2.650473>
    }
    triangle {
      < -6.596615, -1.199968, -2.500227>,
      < -6.580181, -1.215968, -2.650473>,
      < -6.596615, -1.215968, -2.500227>
    }
    triangle {
      < -6.598354, -1.199968, -2.484322>,
      < -6.598354, -1.148789, -2.484322>,
      < -6.596615, -1.148789, -2.500227>
    }
    triangle {
      < -6.598354, -1.199968, -2.484322>,
      < -6.596615, -1.148789, -2.500227>,
      < -6.596615, -1.199968, -2.500227>
    }
    triangle {
      < -6.614789, -1.199968, -2.334075>,
      < -6.598354, -1.199968, -2.484322>,
      < -6.598354, -1.215968, -2.484322>
    }
    triangle {
      < -6.614789, -1.199968, -2.334075>,
      < -6.598354, -1.215968, -2.484322>,
      < -6.614789, -1.215968, -2.334075>
    }
    triangle {
      < -6.634702, -1.199968, -2.152019>,
      < -6.634702, -1.148789, -2.152019>,
      < -6.632962, -1.148789, -2.167924>
    }
    triangle {
      < -6.634702, -1.199968, -2.152019>,
      < -6.632962, -1.148789, -2.167924>,
      < -6.632962, -1.199968, -2.167924>
    }
    triangle {
      < -6.632962, -1.199968, -2.167924>,
      < -6.616529, -1.199968, -2.318170>,
      < -6.616529, -1.215968, -2.318170>
    }
    triangle {
      < -6.632962, -1.199968, -2.167924>,
      < -6.616529, -1.215968, -2.318170>,
      < -6.632962, -1.215968, -2.167924>
    }
    triangle {
      < -6.651136, -1.199968, -2.001772>,
      < -6.634702, -1.199968, -2.152019>,
      < -6.634702, -1.215968, -2.152019>
    }
    triangle {
      < -6.651136, -1.199968, -2.001772>,
      < -6.634702, -1.215968, -2.152019>,
      < -6.651136, -1.215968, -2.001772>
    }
    triangle {
      < -6.671050, -1.199968, -1.819715>,
      < -6.671050, -1.148789, -1.819715>,
      < -6.669310, -1.148789, -1.835621>
    }
    triangle {
      < -6.671050, -1.199968, -1.819715>,
      < -6.669310, -1.148789, -1.835621>,
      < -6.669310, -1.199968, -1.835621>
    }
    triangle {
      < -6.669310, -1.199968, -1.835621>,
      < -6.652875, -1.199968, -1.985867>,
      < -6.652875, -1.215968, -1.985867>
    }
    triangle {
      < -6.669310, -1.199968, -1.835621>,
      < -6.652875, -1.215968, -1.985867>,
      < -6.669310, -1.215968, -1.835621>
    }
    triangle {
      < -6.687484, -1.199968, -1.669469>,
      < -6.671050, -1.199968, -1.819715>,
      < -6.671050, -1.215968, -1.819715>
    }
    triangle {
      < -6.687484, -1.199968, -1.669469>,
      < -6.671050, -1.215968, -1.819715>,
      < -6.687484, -1.215968, -1.669469>
    }
    triangle {
      < -6.707397, -1.199968, -1.487412>,
      < -6.707397, -1.148789, -1.487412>,
      < -6.705658, -1.148789, -1.503317>
    }
    triangle {
      < -6.707397, -1.199968, -1.487412>,
      < -6.705658, -1.148789, -1.503317>,
      < -6.705658, -1.199968, -1.503317>
    }
    triangle {
      < -6.705658, -1.199968, -1.503317>,
      < -6.689224, -1.199968, -1.653564>,
      < -6.689224, -1.215968, -1.653564>
    }
    triangle {
      < -6.705658, -1.199968, -1.503317>,
      < -6.689224, -1.215968, -1.653564>,
      < -6.705658, -1.215968, -1.503317>
    }
    triangle {
      < -6.723832, -1.199968, -1.337166>,
      < -6.707397, -1.199968, -1.487412>,
      < -6.707397, -1.215968, -1.487412>
    }
    triangle {
      < -6.723832, -1.199968, -1.337166>,
      < -6.707397, -1.215968, -1.487412>,
      < -6.723832, -1.215968, -1.337166>
    }
    triangle {
      < -6.743745, -1.199968, -1.155109>,
      < -6.743745, -1.148789, -1.155109>,
      < -6.742006, -1.148789, -1.171014>
    }
    triangle {
      < -6.743745, -1.199968, -1.155109>,
      < -6.742006, -1.148789, -1.171014>,
      < -6.742006, -1.199968, -1.171014>
    }
    triangle {
      < -6.742006, -1.199968, -1.171014>,
      < -6.725572, -1.199968, -1.321260>,
      < -6.725572, -1.215968, -1.321260>
    }
    triangle {
      < -6.742006, -1.199968, -1.171014>,
      < -6.725572, -1.215968, -1.321260>,
      < -6.742006, -1.215968, -1.171014>
    }
    triangle {
      < -6.760180, -1.199968, -1.004862>,
      < -6.743745, -1.199968, -1.155109>,
      < -6.743745, -1.215968, -1.155109>
    }
    triangle {
      < -6.760180, -1.199968, -1.004862>,
      < -6.743745, -1.215968, -1.155109>,
      < -6.760180, -1.215968, -1.004862>
    }
    triangle {
      < -6.780094, -1.199968, -0.822806>,
      < -6.780094, -1.148789, -0.822806>,
      < -6.778354, -1.148789, -0.838711>
    }
    triangle {
      < -6.780094, -1.199968, -0.822806>,
      < -6.778354, -1.148789, -0.838711>,
      < -6.778354, -1.199968, -0.838711>
    }
    triangle {
      < -6.778354, -1.199968, -0.838711>,
      < -6.761919, -1.199968, -0.988957>,
      < -6.761919, -1.215968, -0.988957>
    }
    triangle {
      < -6.778354, -1.199968, -0.838711>,
      < -6.761919, -1.215968, -0.988957>,
      < -6.778354, -1.215968, -0.838711>
    }
    triangle {
      < -6.796528, -1.199968, -0.672559>,
      < -6.780094, -1.199968, -0.822806>,
      < -6.780094, -1.215968, -0.822806>
    }
    triangle {
      < -6.796528, -1.199968, -0.672559>,
      < -6.780094, -1.215968, -0.822806>,
      < -6.796528, -1.215968, -0.672559>
    }
    triangle {
      < -6.816442, -1.199968, -0.490502>,
      < -6.816442, -1.148789, -0.490502>,
      < -6.814702, -1.148789, -0.506407>
    }
    triangle {
      < -6.816442, -1.199968, -0.490502>,
      < -6.814702, -1.148789, -0.506407>,
      < -6.814702, -1.199968, -0.506407>
    }
    triangle {
      < -6.814702, -1.199968, -0.506407>,
      < -6.798267, -1.199968, -0.656654>,
      < -6.798267, -1.215968, -0.656654>
    }
    triangle {
      < -6.814702, -1.199968, -0.506407>,
      < -6.798267, -1.215968, -0.656654>,
      < -6.814702, -1.215968, -0.506407>
    }
    triangle {
      < -6.832876, -1.199968, -0.340256>,
      < -6.816442, -1.199968, -0.490502>,
      < -6.816442, -1.215968, -0.490502>
    }
    triangle {
      < -6.832876, -1.199968, -0.340256>,
      < -6.816442, -1.215968, -0.490502>,
      < -6.832876, -1.215968, -0.340256>
    }
    triangle {
      < -6.852789, -1.199968, -0.158199>,
      < -6.852789, -1.148789, -0.158199>,
      < -6.851050, -1.148789, -0.174104>
    }
    triangle {
      < -6.852789, -1.199968, -0.158199>,
      < -6.851050, -1.148789, -0.174104>,
      < -6.851050, -1.199968, -0.174104>
    }
    triangle {
      < -6.851050, -1.199968, -0.174104>,
      < -6.834615, -1.199968, -0.324351>,
      < -6.834615, -1.215968, -0.324351>
    }
    triangle {
      < -6.851050, -1.199968, -0.174104>,
      < -6.834615, -1.215968, -0.324351>,
      < -6.851050, -1.215968, -0.174104>
    }
    triangle {
      < -6.832877, -1.199968, 0.340256>,
      < -6.832877, -1.148789, 0.340256>,
      < -6.834616, -1.148789, 0.324351>
    }
    triangle {
      < -6.832877, -1.199968, 0.340256>,
      < -6.834616, -1.148789, 0.324351>,
      < -6.834616, -1.199968, 0.324351>
    }
    triangle {
      < -6.834616, -1.199968, 0.324351>,
      < -6.851051, -1.199968, 0.174104>,
      < -6.851051, -1.215968, 0.174104>
    }
    triangle {
      < -6.834616, -1.199968, 0.324351>,
      < -6.851051, -1.215968, 0.174104>,
      < -6.834616, -1.215968, 0.324351>
    }
    triangle {
      < -6.816443, -1.199968, 0.490502>,
      < -6.832877, -1.199968, 0.340256>,
      < -6.832877, -1.215968, 0.340256>
    }
    triangle {
      < -6.816443, -1.199968, 0.490502>,
      < -6.832877, -1.215968, 0.340256>,
      < -6.816443, -1.215968, 0.490502>
    }
    triangle {
      < -6.796529, -1.199968, 0.672559>,
      < -6.796529, -1.148789, 0.672559>,
      < -6.798269, -1.148789, 0.656654>
    }
    triangle {
      < -6.796529, -1.199968, 0.672559>,
      < -6.798269, -1.148789, 0.656654>,
      < -6.798269, -1.199968, 0.656654>
    }
    triangle {
      < -6.798269, -1.199968, 0.656654>,
      < -6.814703, -1.199968, 0.506407>,
      < -6.814703, -1.215968, 0.506407>
    }
    triangle {
      < -6.798269, -1.199968, 0.656654>,
      < -6.814703, -1.215968, 0.506407>,
      < -6.798269, -1.215968, 0.656654>
    }
    triangle {
      < -6.780095, -1.199968, 0.822806>,
      < -6.796529, -1.199968, 0.672559>,
      < -6.796529, -1.215968, 0.672559>
    }
    triangle {
      < -6.780095, -1.199968, 0.822806>,
      < -6.796529, -1.215968, 0.672559>,
      < -6.780095, -1.215968, 0.822806>
    }
    triangle {
      < -6.760181, -1.199968, 1.004862>,
      < -6.760181, -1.148789, 1.004862>,
      < -6.761921, -1.148789, 0.988957>
    }
    triangle {
      < -6.760181, -1.199968, 1.004862>,
      < -6.761921, -1.148789, 0.988957>,
      < -6.761921, -1.199968, 0.988957>
    }
    triangle {
      < -6.761921, -1.199968, 0.988957>,
      < -6.778356, -1.199968, 0.838711>,
      < -6.778356, -1.215968, 0.838711>
    }
    triangle {
      < -6.761921, -1.199968, 0.988957>,
      < -6.778356, -1.215968, 0.838711>,
      < -6.761921, -1.215968, 0.988957>
    }
    triangle {
      < -6.743747, -1.199968, 1.155109>,
      < -6.760181, -1.199968, 1.004862>,
      < -6.760181, -1.215968, 1.004862>
    }
    triangle {
      < -6.743747, -1.199968, 1.155109>,
      < -6.760181, -1.215968, 1.004862>,
      < -6.743747, -1.215968, 1.155109>
    }
    triangle {
      < -6.723834, -1.199968, 1.337166>,
      < -6.723834, -1.148789, 1.337166>,
      < -6.725573, -1.148789, 1.321261>
    }
    triangle {
      < -6.723834, -1.199968, 1.337166>,
      < -6.725573, -1.148789, 1.321261>,
      < -6.725573, -1.199968, 1.321261>
    }
    triangle {
      < -6.725573, -1.199968, 1.321261>,
      < -6.742008, -1.199968, 1.171014>,
      < -6.742008, -1.215968, 1.171014>
    }
    triangle {
      < -6.725573, -1.199968, 1.321261>,
      < -6.742008, -1.215968, 1.171014>,
      < -6.725573, -1.215968, 1.321261>
    }
    triangle {
      < -6.707399, -1.199968, 1.487412>,
      < -6.723834, -1.199968, 1.337166>,
      < -6.723834, -1.215968, 1.337166>
    }
    triangle {
      < -6.707399, -1.199968, 1.487412>,
      < -6.723834, -1.215968, 1.337166>,
      < -6.707399, -1.215968, 1.487412>
    }
    triangle {
      < -6.687486, -1.199968, 1.669469>,
      < -6.687486, -1.148789, 1.669469>,
      < -6.689225, -1.148789, 1.653563>
    }
    triangle {
      < -6.687486, -1.199968, 1.669469>,
      < -6.689225, -1.148789, 1.653563>,
      < -6.689225, -1.199968, 1.653563>
    }
    triangle {
      < -6.689225, -1.199968, 1.653563>,
      < -6.705659, -1.199968, 1.503317>,
      < -6.705659, -1.215968, 1.503317>
    }
    triangle {
      < -6.689225, -1.199968, 1.653563>,
      < -6.705659, -1.215968, 1.503317>,
      < -6.689225, -1.215968, 1.653563>
    }
    triangle {
      < -6.671051, -1.199968, 1.819715>,
      < -6.687486, -1.199968, 1.669469>,
      < -6.687486, -1.215968, 1.669469>
    }
    triangle {
      < -6.671051, -1.199968, 1.819715>,
      < -6.687486, -1.215968, 1.669469>,
      < -6.671051, -1.215968, 1.819715>
    }
    triangle {
      < -6.651138, -1.199968, 2.001772>,
      < -6.651138, -1.148789, 2.001772>,
      < -6.652877, -1.148789, 1.985867>
    }
    triangle {
      < -6.651138, -1.199968, 2.001772>,
      < -6.652877, -1.148789, 1.985867>,
      < -6.652877, -1.199968, 1.985867>
    }
    triangle {
      < -6.652877, -1.199968, 1.985867>,
      < -6.669312, -1.199968, 1.835620>,
      < -6.669312, -1.215968, 1.835620>
    }
    triangle {
      < -6.652877, -1.199968, 1.985867>,
      < -6.669312, -1.215968, 1.835620>,
      < -6.652877, -1.215968, 1.985867>
    }
    triangle {
      < -6.634703, -1.199968, 2.152019>,
      < -6.651138, -1.199968, 2.001772>,
      < -6.651138, -1.215968, 2.001772>
    }
    triangle {
      < -6.634703, -1.199968, 2.152019>,
      < -6.651138, -1.215968, 2.001772>,
      < -6.634703, -1.215968, 2.152019>
    }
    triangle {
      < -6.614789, -1.199968, 2.334075>,
      < -6.614789, -1.148789, 2.334075>,
      < -6.616529, -1.148789, 2.318170>
    }
    triangle {
      < -6.614789, -1.199968, 2.334075>,
      < -6.616529, -1.148789, 2.318170>,
      < -6.616529, -1.199968, 2.318170>
    }
    triangle {
      < -6.616529, -1.199968, 2.318170>,
      < -6.632964, -1.199968, 2.167924>,
      < -6.632964, -1.215968, 2.167924>
    }
    triangle {
      < -6.616529, -1.199968, 2.318170>,
      < -6.632964, -1.215968, 2.167924>,
      < -6.616529, -1.215968, 2.318170>
    }
    triangle {
      < -6.598355, -1.199968, 2.484322>,
      < -6.614789, -1.199968, 2.334075>,
      < -6.614789, -1.215968, 2.334075>
    }
    triangle {
      < -6.598355, -1.199968, 2.484322>,
      < -6.614789, -1.215968, 2.334075>,
      < -6.598355, -1.215968, 2.484322>
    }
    triangle {
      < -6.614789, -1.148789, -2.334075>,
      < -6.614789, -1.199968, -2.334075>,
      < -6.616529, -1.199968, -2.318170>
    }
    triangle {
      < -6.614789, -1.148789, -2.334075>,
      < -6.616529, -1.199968, -2.318170>,
      < -6.616529, -1.148789, -2.318170>
    }
    triangle {
      < -6.651136, -1.148789, -2.001772>,
      < -6.651136, -1.199968, -2.001772>,
      < -6.652875, -1.199968, -1.985867>
    }
    triangle {
      < -6.651136, -1.148789, -2.001772>,
      < -6.652875, -1.199968, -1.985867>,
      < -6.652875, -1.148789, -1.985867>
    }
    triangle {
      < -6.687484, -1.148789, -1.669469>,
      < -6.687484, -1.199968, -1.669469>,
      < -6.689224, -1.199968, -1.653564>
    }
    triangle {
      < -6.687484, -1.148789, -1.669469>,
      < -6.689224, -1.199968, -1.653564>,
      < -6.689224, -1.148789, -1.653564>
    }
    triangle {
      < -6.723832, -1.148789, -1.337166>,
      < -6.723832, -1.199968, -1.337166>,
      < -6.725572, -1.199968, -1.321260>
    }
    triangle {
      < -6.723832, -1.148789, -1.337166>,
      < -6.725572, -1.199968, -1.321260>,
      < -6.725572, -1.148789, -1.321260>
    }
    triangle {
      < -6.760180, -1.148789, -1.004862>,
      < -6.760180, -1.199968, -1.004862>,
      < -6.761919, -1.199968, -0.988957>
    }
    triangle {
      < -6.760180, -1.148789, -1.004862>,
      < -6.761919, -1.199968, -0.988957>,
      < -6.761919, -1.148789, -0.988957>
    }
    triangle {
      < -6.796528, -1.148789, -0.672559>,
      < -6.796528, -1.199968, -0.672559>,
      < -6.798267, -1.199968, -0.656654>
    }
    triangle {
      < -6.796528, -1.148789, -0.672559>,
      < -6.798267, -1.199968, -0.656654>,
      < -6.798267, -1.148789, -0.656654>
    }
    triangle {
      < -6.832876, -1.148789, -0.340256>,
      < -6.832876, -1.199968, -0.340256>,
      < -6.834615, -1.199968, -0.324351>
    }
    triangle {
      < -6.832876, -1.148789, -0.340256>,
      < -6.834615, -1.199968, -0.324351>,
      < -6.834615, -1.148789, -0.324351>
    }
    triangle {
      < -6.852790, -1.148789, 0.158199>,
      < -6.852790, -1.199968, 0.158199>,
      < -6.851051, -1.199968, 0.174104>
    }
    triangle {
      < -6.852790, -1.148789, 0.158199>,
      < -6.851051, -1.199968, 0.174104>,
      < -6.851051, -1.148789, 0.174104>
    }
    triangle {
      < -6.816443, -1.148789, 0.490502>,
      < -6.816443, -1.199968, 0.490502>,
      < -6.814703, -1.199968, 0.506407>
    }
    triangle {
      < -6.816443, -1.148789, 0.490502>,
      < -6.814703, -1.199968, 0.506407>,
      < -6.814703, -1.148789, 0.506407>
    }
    triangle {
      < -6.780095, -1.148789, 0.822806>,
      < -6.780095, -1.199968, 0.822806>,
      < -6.778356, -1.199968, 0.838711>
    }
    triangle {
      < -6.780095, -1.148789, 0.822806>,
      < -6.778356, -1.199968, 0.838711>,
      < -6.778356, -1.148789, 0.838711>
    }
    triangle {
      < -6.743747, -1.148789, 1.155109>,
      < -6.743747, -1.199968, 1.155109>,
      < -6.742008, -1.199968, 1.171014>
    }
    triangle {
      < -6.743747, -1.148789, 1.155109>,
      < -6.742008, -1.199968, 1.171014>,
      < -6.742008, -1.148789, 1.171014>
    }
    triangle {
      < -6.707399, -1.148789, 1.487412>,
      < -6.707399, -1.199968, 1.487412>,
      < -6.705659, -1.199968, 1.503317>
    }
    triangle {
      < -6.707399, -1.148789, 1.487412>,
      < -6.705659, -1.199968, 1.503317>,
      < -6.705659, -1.148789, 1.503317>
    }
    triangle {
      < -6.671051, -1.148789, 1.819715>,
      < -6.671051, -1.199968, 1.819715>,
      < -6.669312, -1.199968, 1.835620>
    }
    triangle {
      < -6.671051, -1.148789, 1.819715>,
      < -6.669312, -1.199968, 1.835620>,
      < -6.669312, -1.148789, 1.835620>
    }
    triangle {
      < -6.634703, -1.148789, 2.152019>,
      < -6.634703, -1.199968, 2.152019>,
      < -6.632964, -1.199968, 2.167924>
    }
    triangle {
      < -6.634703, -1.148789, 2.152019>,
      < -6.632964, -1.199968, 2.167924>,
      < -6.632964, -1.148789, 2.167924>
    }
    triangle {
      < -6.580181, -1.199968, 2.650474>,
      < -6.596616, -1.199968, 2.500227>,
      < -6.596616, -1.215968, 2.500227>
    }
    triangle {
      < -6.580181, -1.199968, 2.650474>,
      < -6.596616, -1.215968, 2.500227>,
      < -6.580181, -1.215968, 2.650474>
    }
    triangle {
      < -6.598355, -1.148789, 2.484322>,
      < -6.598355, -1.199968, 2.484322>,
      < -6.596616, -1.199968, 2.500227>
    }
    triangle {
      < -6.598355, -1.148789, 2.484322>,
      < -6.596616, -1.199968, 2.500227>,
      < -6.596616, -1.148789, 2.500227>
    }
    triangle {
      < -6.869224, -1.132789, 0.007953>,
      < -6.869224, -1.081609, 0.007953>,
      < -6.869224, -1.081609, -0.007953>
    }
    triangle {
      < -6.869224, -1.132789, 0.007953>,
      < -6.869224, -1.081609, -0.007953>,
      < -6.869224, -1.132789, -0.007953>
    }
    triangle {
      < -6.869224, -1.132789, -0.007953>,
      < -6.852789, -1.132789, -0.158199>,
      < -6.852789, -1.148789, -0.158199>
    }
    triangle {
      < -6.869224, -1.132789, -0.007953>,
      < -6.852789, -1.148789, -0.158199>,
      < -6.869224, -1.148789, -0.007953>
    }
    triangle {
      < -6.852790, -1.132789, 0.158199>,
      < -6.869224, -1.132789, 0.007953>,
      < -6.869224, -1.148789, 0.007953>
    }
    triangle {
      < -6.852790, -1.132789, 0.158199>,
      < -6.869224, -1.148789, 0.007953>,
      < -6.852790, -1.148789, 0.158199>
    }
    triangle {
      < -6.580181, -1.132789, -2.650473>,
      < -6.580181, -1.081609, -2.650473>,
      < -6.571311, -1.073609, -2.658426>
    }
    triangle {
      < -6.580181, -1.132789, -2.650473>,
      < -6.571311, -1.073609, -2.658426>,
      < -6.571311, -1.140788, -2.658426>
    }
    triangle {
      < -6.596615, -1.132789, -2.500227>,
      < -6.580181, -1.132789, -2.650473>,
      < -6.580181, -1.148789, -2.650473>
    }
    triangle {
      < -6.596615, -1.132789, -2.500227>,
      < -6.580181, -1.148789, -2.650473>,
      < -6.596615, -1.148789, -2.500227>
    }
    triangle {
      < -6.598354, -1.132789, -2.484322>,
      < -6.598354, -1.081609, -2.484322>,
      < -6.596615, -1.081609, -2.500227>
    }
    triangle {
      < -6.598354, -1.132789, -2.484322>,
      < -6.596615, -1.081609, -2.500227>,
      < -6.596615, -1.132789, -2.500227>
    }
    triangle {
      < -6.614789, -1.132789, -2.334075>,
      < -6.598354, -1.132789, -2.484322>,
      < -6.598354, -1.148789, -2.484322>
    }
    triangle {
      < -6.614789, -1.132789, -2.334075>,
      < -6.598354, -1.148789, -2.484322>,
      < -6.614789, -1.148789, -2.334075>
    }
    triangle {
      < -6.634702, -1.132789, -2.152019>,
      < -6.634702, -1.081609, -2.152019>,
      < -6.632962, -1.081609, -2.167924>
    }
    triangle {
      < -6.634702, -1.132789, -2.152019>,
      < -6.632962, -1.081609, -2.167924>,
      < -6.632962, -1.132789, -2.167924>
    }
    triangle {
      < -6.632962, -1.132789, -2.167924>,
      < -6.616529, -1.132789, -2.318170>,
      < -6.616529, -1.148789, -2.318170>
    }
    triangle {
      < -6.632962, -1.132789, -2.167924>,
      < -6.616529, -1.148789, -2.318170>,
      < -6.632962, -1.148789, -2.167924>
    }
    triangle {
      < -6.651136, -1.132789, -2.001772>,
      < -6.634702, -1.132789, -2.152019>,
      < -6.634702, -1.148789, -2.152019>
    }
    triangle {
      < -6.651136, -1.132789, -2.001772>,
      < -6.634702, -1.148789, -2.152019>,
      < -6.651136, -1.148789, -2.001772>
    }
    triangle {
      < -6.671050, -1.132789, -1.819715>,
      < -6.671050, -1.081609, -1.819715>,
      < -6.669310, -1.081609, -1.835621>
    }
    triangle {
      < -6.671050, -1.132789, -1.819715>,
      < -6.669310, -1.081609, -1.835621>,
      < -6.669310, -1.132789, -1.835621>
    }
    triangle {
      < -6.669310, -1.132789, -1.835621>,
      < -6.652875, -1.132789, -1.985867>,
      < -6.652875, -1.148789, -1.985867>
    }
    triangle {
      < -6.669310, -1.132789, -1.835621>,
      < -6.652875, -1.148789, -1.985867>,
      < -6.669310, -1.148789, -1.835621>
    }
    triangle {
      < -6.687484, -1.132789, -1.669469>,
      < -6.671050, -1.132789, -1.819715>,
      < -6.671050, -1.148789, -1.819715>
    }
    triangle {
      < -6.687484, -1.132789, -1.669469>,
      < -6.671050, -1.148789, -1.819715>,
      < -6.687484, -1.148789, -1.669469>
    }
    triangle {
      < -6.707397, -1.132789, -1.487412>,
      < -6.707397, -1.081609, -1.487412>,
      < -6.705658, -1.081609, -1.503317>
    }
    triangle {
      < -6.707397, -1.132789, -1.487412>,
      < -6.705658, -1.081609, -1.503317>,
      < -6.705658, -1.132789, -1.503317>
    }
    triangle {
      < -6.705658, -1.132789, -1.503317>,
      < -6.689224, -1.132789, -1.653564>,
      < -6.689224, -1.148789, -1.653564>
    }
    triangle {
      < -6.705658, -1.132789, -1.503317>,
      < -6.689224, -1.148789, -1.653564>,
      < -6.705658, -1.148789, -1.503317>
    }
    triangle {
      < -6.723832, -1.132789, -1.337166>,
      < -6.707397, -1.132789, -1.487412>,
      < -6.707397, -1.148789, -1.487412>
    }
    triangle {
      < -6.723832, -1.132789, -1.337166>,
      < -6.707397, -1.148789, -1.487412>,
      < -6.723832, -1.148789, -1.337166>
    }
    triangle {
      < -6.743745, -1.132789, -1.155109>,
      < -6.743745, -1.081609, -1.155109>,
      < -6.742006, -1.081609, -1.171014>
    }
    triangle {
      < -6.743745, -1.132789, -1.155109>,
      < -6.742006, -1.081609, -1.171014>,
      < -6.742006, -1.132789, -1.171014>
    }
    triangle {
      < -6.742006, -1.132789, -1.171014>,
      < -6.725572, -1.132789, -1.321260>,
      < -6.725572, -1.148789, -1.321260>
    }
    triangle {
      < -6.742006, -1.132789, -1.171014>,
      < -6.725572, -1.148789, -1.321260>,
      < -6.742006, -1.148789, -1.171014>
    }
    triangle {
      < -6.760180, -1.132789, -1.004862>,
      < -6.743745, -1.132789, -1.155109>,
      < -6.743745, -1.148789, -1.155109>
    }
    triangle {
      < -6.760180, -1.132789, -1.004862>,
      < -6.743745, -1.148789, -1.155109>,
      < -6.760180, -1.148789, -1.004862>
    }
    triangle {
      < -6.780094, -1.132789, -0.822806>,
      < -6.780094, -1.081609, -0.822806>,
      < -6.778354, -1.081609, -0.838711>
    }
    triangle {
      < -6.780094, -1.132789, -0.822806>,
      < -6.778354, -1.081609, -0.838711>,
      < -6.778354, -1.132789, -0.838711>
    }
    triangle {
      < -6.778354, -1.132789, -0.838711>,
      < -6.761919, -1.132789, -0.988957>,
      < -6.761919, -1.148789, -0.988957>
    }
    triangle {
      < -6.778354, -1.132789, -0.838711>,
      < -6.761919, -1.148789, -0.988957>,
      < -6.778354, -1.148789, -0.838711>
    }
    triangle {
      < -6.796528, -1.132789, -0.672559>,
      < -6.780094, -1.132789, -0.822806>,
      < -6.780094, -1.148789, -0.822806>
    }
    triangle {
      < -6.796528, -1.132789, -0.672559>,
      < -6.780094, -1.148789, -0.822806>,
      < -6.796528, -1.148789, -0.672559>
    }
    triangle {
      < -6.816442, -1.132789, -0.490502>,
      < -6.816442, -1.081609, -0.490502>,
      < -6.814702, -1.081609, -0.506407>
    }
    triangle {
      < -6.816442, -1.132789, -0.490502>,
      < -6.814702, -1.081609, -0.506407>,
      < -6.814702, -1.132789, -0.506407>
    }
    triangle {
      < -6.814702, -1.132789, -0.506407>,
      < -6.798267, -1.132789, -0.656654>,
      < -6.798267, -1.148789, -0.656654>
    }
    triangle {
      < -6.814702, -1.132789, -0.506407>,
      < -6.798267, -1.148789, -0.656654>,
      < -6.814702, -1.148789, -0.506407>
    }
    triangle {
      < -6.832876, -1.132789, -0.340256>,
      < -6.816442, -1.132789, -0.490502>,
      < -6.816442, -1.148789, -0.490502>
    }
    triangle {
      < -6.832876, -1.132789, -0.340256>,
      < -6.816442, -1.148789, -0.490502>,
      < -6.832876, -1.148789, -0.340256>
    }
    triangle {
      < -6.852789, -1.132789, -0.158199>,
      < -6.852789, -1.081609, -0.158199>,
      < -6.851050, -1.081609, -0.174104>
    }
    triangle {
      < -6.852789, -1.132789, -0.158199>,
      < -6.851050, -1.081609, -0.174104>,
      < -6.851050, -1.132789, -0.174104>
    }
    triangle {
      < -6.851050, -1.132789, -0.174104>,
      < -6.834615, -1.132789, -0.324351>,
      < -6.834615, -1.148789, -0.324351>
    }
    triangle {
      < -6.851050, -1.132789, -0.174104>,
      < -6.834615, -1.148789, -0.324351>,
      < -6.851050, -1.148789, -0.174104>
    }
    triangle {
      < -6.832877, -1.132789, 0.340256>,
      < -6.832877, -1.081609, 0.340256>,
      < -6.834616, -1.081609, 0.324351>
    }
    triangle {
      < -6.832877, -1.132789, 0.340256>,
      < -6.834616, -1.081609, 0.324351>,
      < -6.834616, -1.132789, 0.324351>
    }
    triangle {
      < -6.834616, -1.132789, 0.324351>,
      < -6.851051, -1.132789, 0.174104>,
      < -6.851051, -1.148789, 0.174104>
    }
    triangle {
      < -6.834616, -1.132789, 0.324351>,
      < -6.851051, -1.148789, 0.174104>,
      < -6.834616, -1.148789, 0.324351>
    }
    triangle {
      < -6.816443, -1.132789, 0.490502>,
      < -6.832877, -1.132789, 0.340256>,
      < -6.832877, -1.148789, 0.340256>
    }
    triangle {
      < -6.816443, -1.132789, 0.490502>,
      < -6.832877, -1.148789, 0.340256>,
      < -6.816443, -1.148789, 0.490502>
    }
    triangle {
      < -6.796529, -1.132789, 0.672559>,
      < -6.796529, -1.081609, 0.672559>,
      < -6.798269, -1.081609, 0.656654>
    }
    triangle {
      < -6.796529, -1.132789, 0.672559>,
      < -6.798269, -1.081609, 0.656654>,
      < -6.798269, -1.132789, 0.656654>
    }
    triangle {
      < -6.798269, -1.132789, 0.656654>,
      < -6.814703, -1.132789, 0.506407>,
      < -6.814703, -1.148789, 0.506407>
    }
    triangle {
      < -6.798269, -1.132789, 0.656654>,
      < -6.814703, -1.148789, 0.506407>,
      < -6.798269, -1.148789, 0.656654>
    }
    triangle {
      < -6.780095, -1.132789, 0.822806>,
      < -6.796529, -1.132789, 0.672559>,
      < -6.796529, -1.148789, 0.672559>
    }
    triangle {
      < -6.780095, -1.132789, 0.822806>,
      < -6.796529, -1.148789, 0.672559>,
      < -6.780095, -1.148789, 0.822806>
    }
    triangle {
      < -6.760181, -1.132789, 1.004862>,
      < -6.760181, -1.081609, 1.004862>,
      < -6.761921, -1.081609, 0.988957>
    }
    triangle {
      < -6.760181, -1.132789, 1.004862>,
      < -6.761921, -1.081609, 0.988957>,
      < -6.761921, -1.132789, 0.988957>
    }
    triangle {
      < -6.761921, -1.132789, 0.988957>,
      < -6.778356, -1.132789, 0.838711>,
      < -6.778356, -1.148789, 0.838711>
    }
    triangle {
      < -6.761921, -1.132789, 0.988957>,
      < -6.778356, -1.148789, 0.838711>,
      < -6.761921, -1.148789, 0.988957>
    }
    triangle {
      < -6.743747, -1.132789, 1.155109>,
      < -6.760181, -1.132789, 1.004862>,
      < -6.760181, -1.148789, 1.004862>
    }
    triangle {
      < -6.743747, -1.132789, 1.155109>,
      < -6.760181, -1.148789, 1.004862>,
      < -6.743747, -1.148789, 1.155109>
    }
    triangle {
      < -6.723834, -1.132789, 1.337166>,
      < -6.723834, -1.081609, 1.337166>,
      < -6.725573, -1.081609, 1.321260>
    }
    triangle {
      < -6.723834, -1.132789, 1.337166>,
      < -6.725573, -1.081609, 1.321260>,
      < -6.725573, -1.132789, 1.321261>
    }
    triangle {
      < -6.725573, -1.132789, 1.321261>,
      < -6.742008, -1.132789, 1.171014>,
      < -6.742008, -1.148789, 1.171014>
    }
    triangle {
      < -6.725573, -1.132789, 1.321261>,
      < -6.742008, -1.148789, 1.171014>,
      < -6.725573, -1.148789, 1.321261>
    }
    triangle {
      < -6.707399, -1.132789, 1.487412>,
      < -6.723834, -1.132789, 1.337166>,
      < -6.723834, -1.148789, 1.337166>
    }
    triangle {
      < -6.707399, -1.132789, 1.487412>,
      < -6.723834, -1.148789, 1.337166>,
      < -6.707399, -1.148789, 1.487412>
    }
    triangle {
      < -6.687486, -1.132789, 1.669469>,
      < -6.687486, -1.081609, 1.669469>,
      < -6.689225, -1.081609, 1.653563>
    }
    triangle {
      < -6.687486, -1.132789, 1.669469>,
      < -6.689225, -1.081609, 1.653563>,
      < -6.689225, -1.132789, 1.653563>
    }
    triangle {
      < -6.689225, -1.132789, 1.653563>,
      < -6.705659, -1.132789, 1.503317>,
      < -6.705659, -1.148789, 1.503317>
    }
    triangle {
      < -6.689225, -1.132789, 1.653563>,
      < -6.705659, -1.148789, 1.503317>,
      < -6.689225, -1.148789, 1.653563>
    }
    triangle {
      < -6.671051, -1.132789, 1.819715>,
      < -6.687486, -1.132789, 1.669469>,
      < -6.687486, -1.148789, 1.669469>
    }
    triangle {
      < -6.671051, -1.132789, 1.819715>,
      < -6.687486, -1.148789, 1.669469>,
      < -6.671051, -1.148789, 1.819715>
    }
    triangle {
      < -6.651138, -1.132789, 2.001772>,
      < -6.651138, -1.081609, 2.001772>,
      < -6.652877, -1.081609, 1.985867>
    }
    triangle {
      < -6.651138, -1.132789, 2.001772>,
      < -6.652877, -1.081609, 1.985867>,
      < -6.652877, -1.132789, 1.985867>
    }
    triangle {
      < -6.652877, -1.132789, 1.985867>,
      < -6.669312, -1.132789, 1.835620>,
      < -6.669312, -1.148789, 1.835620>
    }
    triangle {
      < -6.652877, -1.132789, 1.985867>,
      < -6.669312, -1.148789, 1.835620>,
      < -6.652877, -1.148789, 1.985867>
    }
    triangle {
      < -6.634703, -1.132789, 2.152019>,
      < -6.651138, -1.132789, 2.001772>,
      < -6.651138, -1.148789, 2.001772>
    }
    triangle {
      < -6.634703, -1.132789, 2.152019>,
      < -6.651138, -1.148789, 2.001772>,
      < -6.634703, -1.148789, 2.152019>
    }
    triangle {
      < -6.614789, -1.132789, 2.334075>,
      < -6.614789, -1.081609, 2.334075>,
      < -6.616529, -1.081609, 2.318170>
    }
    triangle {
      < -6.614789, -1.132789, 2.334075>,
      < -6.616529, -1.081609, 2.318170>,
      < -6.616529, -1.132789, 2.318170>
    }
    triangle {
      < -6.616529, -1.132789, 2.318170>,
      < -6.632964, -1.132789, 2.167924>,
      < -6.632964, -1.148789, 2.167924>
    }
    triangle {
      < -6.616529, -1.132789, 2.318170>,
      < -6.632964, -1.148789, 2.167924>,
      < -6.616529, -1.148789, 2.318170>
    }
    triangle {
      < -6.598355, -1.132789, 2.484322>,
      < -6.614789, -1.132789, 2.334075>,
      < -6.614789, -1.148789, 2.334075>
    }
    triangle {
      < -6.598355, -1.132789, 2.484322>,
      < -6.614789, -1.148789, 2.334075>,
      < -6.598355, -1.148789, 2.484322>
    }
    triangle {
      < -6.580181, -1.132789, 2.650474>,
      < -6.596616, -1.132789, 2.500227>,
      < -6.596616, -1.148789, 2.500227>
    }
    triangle {
      < -6.580181, -1.132789, 2.650474>,
      < -6.596616, -1.148789, 2.500227>,
      < -6.580181, -1.148789, 2.650474>
    }
    triangle {
      < -6.598355, -1.081609, 2.484322>,
      < -6.598355, -1.132789, 2.484322>,
      < -6.596616, -1.132789, 2.500227>
    }
    triangle {
      < -6.598355, -1.081609, 2.484322>,
      < -6.596616, -1.132789, 2.500227>,
      < -6.596616, -1.081609, 2.500227>
    }
    triangle {
      < -6.634703, -1.081609, 2.152019>,
      < -6.634703, -1.132789, 2.152019>,
      < -6.632964, -1.132789, 2.167924>
    }
    triangle {
      < -6.634703, -1.081609, 2.152019>,
      < -6.632964, -1.132789, 2.167924>,
      < -6.632964, -1.081609, 2.167924>
    }
    triangle {
      < -6.671051, -1.081609, 1.819715>,
      < -6.671051, -1.132789, 1.819715>,
      < -6.669312, -1.132789, 1.835620>
    }
    triangle {
      < -6.671051, -1.081609, 1.819715>,
      < -6.669312, -1.132789, 1.835620>,
      < -6.669312, -1.081609, 1.835620>
    }
    triangle {
      < -6.707399, -1.081609, 1.487412>,
      < -6.707399, -1.132789, 1.487412>,
      < -6.705659, -1.132789, 1.503317>
    }
    triangle {
      < -6.707399, -1.081609, 1.487412>,
      < -6.705659, -1.132789, 1.503317>,
      < -6.705659, -1.081609, 1.503317>
    }
    triangle {
      < -6.743747, -1.081609, 1.155109>,
      < -6.743747, -1.132789, 1.155109>,
      < -6.742008, -1.132789, 1.171014>
    }
    triangle {
      < -6.743747, -1.081609, 1.155109>,
      < -6.742008, -1.132789, 1.171014>,
      < -6.742008, -1.081609, 1.171014>
    }
    triangle {
      < -6.780095, -1.081609, 0.822806>,
      < -6.780095, -1.132789, 0.822806>,
      < -6.778356, -1.132789, 0.838711>
    }
    triangle {
      < -6.780095, -1.081609, 0.822806>,
      < -6.778356, -1.132789, 0.838711>,
      < -6.778356, -1.081609, 0.838711>
    }
    triangle {
      < -6.816443, -1.081609, 0.490502>,
      < -6.816443, -1.132789, 0.490502>,
      < -6.814703, -1.132789, 0.506407>
    }
    triangle {
      < -6.816443, -1.081609, 0.490502>,
      < -6.814703, -1.132789, 0.506407>,
      < -6.814703, -1.081609, 0.506407>
    }
    triangle {
      < -6.852790, -1.081609, 0.158199>,
      < -6.852790, -1.132789, 0.158199>,
      < -6.851051, -1.132789, 0.174104>
    }
    triangle {
      < -6.852790, -1.081609, 0.158199>,
      < -6.851051, -1.132789, 0.174104>,
      < -6.851051, -1.081609, 0.174104>
    }
    triangle {
      < -6.832876, -1.081609, -0.340256>,
      < -6.832876, -1.132789, -0.340256>,
      < -6.834615, -1.132789, -0.324351>
    }
    triangle {
      < -6.832876, -1.081609, -0.340256>,
      < -6.834615, -1.132789, -0.324351>,
      < -6.834615, -1.081609, -0.324351>
    }
    triangle {
      < -6.796528, -1.081609, -0.672559>,
      < -6.796528, -1.132789, -0.672559>,
      < -6.798267, -1.132789, -0.656654>
    }
    triangle {
      < -6.796528, -1.081609, -0.672559>,
      < -6.798267, -1.132789, -0.656654>,
      < -6.798267, -1.081609, -0.656654>
    }
    triangle {
      < -6.760180, -1.081609, -1.004863>,
      < -6.760180, -1.132789, -1.004862>,
      < -6.761919, -1.132789, -0.988957>
    }
    triangle {
      < -6.760180, -1.081609, -1.004863>,
      < -6.761919, -1.132789, -0.988957>,
      < -6.761919, -1.081609, -0.988957>
    }
    triangle {
      < -6.723832, -1.081609, -1.337166>,
      < -6.723832, -1.132789, -1.337166>,
      < -6.725572, -1.132789, -1.321260>
    }
    triangle {
      < -6.723832, -1.081609, -1.337166>,
      < -6.725572, -1.132789, -1.321260>,
      < -6.725572, -1.081609, -1.321261>
    }
    triangle {
      < -6.687484, -1.081609, -1.669469>,
      < -6.687484, -1.132789, -1.669469>,
      < -6.689224, -1.132789, -1.653564>
    }
    triangle {
      < -6.687484, -1.081609, -1.669469>,
      < -6.689224, -1.132789, -1.653564>,
      < -6.689224, -1.081609, -1.653564>
    }
    triangle {
      < -6.651136, -1.081609, -2.001772>,
      < -6.651136, -1.132789, -2.001772>,
      < -6.652875, -1.132789, -1.985867>
    }
    triangle {
      < -6.651136, -1.081609, -2.001772>,
      < -6.652875, -1.132789, -1.985867>,
      < -6.652875, -1.081609, -1.985867>
    }
    triangle {
      < -6.614789, -1.081609, -2.334075>,
      < -6.614789, -1.132789, -2.334075>,
      < -6.616529, -1.132789, -2.318170>
    }
    triangle {
      < -6.614789, -1.081609, -2.334075>,
      < -6.616529, -1.132789, -2.318170>,
      < -6.616529, -1.081609, -2.318170>
    }
    triangle {
      < -6.869224, -1.065609, 0.007953>,
      < -6.869224, -1.014430, 0.007953>,
      < -6.869224, -1.014430, -0.007953>
    }
    triangle {
      < -6.869224, -1.065609, 0.007953>,
      < -6.869224, -1.014430, -0.007953>,
      < -6.869224, -1.065609, -0.007953>
    }
    triangle {
      < -6.869224, -1.065609, -0.007953>,
      < -6.852789, -1.065609, -0.158199>,
      < -6.852789, -1.081609, -0.158199>
    }
    triangle {
      < -6.869224, -1.065609, -0.007953>,
      < -6.852789, -1.081609, -0.158199>,
      < -6.869224, -1.081609, -0.007953>
    }
    triangle {
      < -6.852790, -1.065609, 0.158199>,
      < -6.869224, -1.065609, 0.007953>,
      < -6.869224, -1.081609, 0.007953>
    }
    triangle {
      < -6.852790, -1.065609, 0.158199>,
      < -6.869224, -1.081609, 0.007953>,
      < -6.852790, -1.081609, 0.158199>
    }
    triangle {
      < -6.580181, -1.065609, -2.650473>,
      < -6.580181, -1.014430, -2.650473>,
      < -6.571311, -1.006430, -2.658426>
    }
    triangle {
      < -6.580181, -1.065609, -2.650473>,
      < -6.571311, -1.006430, -2.658426>,
      < -6.571311, -1.073609, -2.658426>
    }
    triangle {
      < -6.596615, -1.065609, -2.500227>,
      < -6.580181, -1.065609, -2.650473>,
      < -6.580181, -1.081609, -2.650473>
    }
    triangle {
      < -6.596615, -1.065609, -2.500227>,
      < -6.580181, -1.081609, -2.650473>,
      < -6.596615, -1.081609, -2.500227>
    }
    triangle {
      < -6.598354, -1.065609, -2.484322>,
      < -6.598354, -1.014430, -2.484322>,
      < -6.596615, -1.014430, -2.500227>
    }
    triangle {
      < -6.598354, -1.065609, -2.484322>,
      < -6.596615, -1.014430, -2.500227>,
      < -6.596615, -1.065609, -2.500227>
    }
    triangle {
      < -6.614789, -1.065609, -2.334075>,
      < -6.598354, -1.065609, -2.484322>,
      < -6.598354, -1.081609, -2.484322>
    }
    triangle {
      < -6.614789, -1.065609, -2.334075>,
      < -6.598354, -1.081609, -2.484322>,
      < -6.614789, -1.081609, -2.334075>
    }
    triangle {
      < -6.634702, -1.065609, -2.152019>,
      < -6.634702, -1.014430, -2.152019>,
      < -6.632962, -1.014430, -2.167924>
    }
    triangle {
      < -6.634702, -1.065609, -2.152019>,
      < -6.632962, -1.014430, -2.167924>,
      < -6.632962, -1.065609, -2.167924>
    }
    triangle {
      < -6.632962, -1.065609, -2.167924>,
      < -6.616529, -1.065609, -2.318170>,
      < -6.616529, -1.081609, -2.318170>
    }
    triangle {
      < -6.632962, -1.065609, -2.167924>,
      < -6.616529, -1.081609, -2.318170>,
      < -6.632962, -1.081609, -2.167924>
    }
    triangle {
      < -6.651136, -1.065609, -2.001772>,
      < -6.634702, -1.065609, -2.152019>,
      < -6.634702, -1.081609, -2.152019>
    }
    triangle {
      < -6.651136, -1.065609, -2.001772>,
      < -6.634702, -1.081609, -2.152019>,
      < -6.651136, -1.081609, -2.001772>
    }
    triangle {
      < -6.671050, -1.065609, -1.819715>,
      < -6.671050, -1.014430, -1.819715>,
      < -6.669310, -1.014430, -1.835621>
    }
    triangle {
      < -6.671050, -1.065609, -1.819715>,
      < -6.669310, -1.014430, -1.835621>,
      < -6.669310, -1.065609, -1.835621>
    }
    triangle {
      < -6.669310, -1.065609, -1.835621>,
      < -6.652875, -1.065609, -1.985867>,
      < -6.652875, -1.081609, -1.985867>
    }
    triangle {
      < -6.669310, -1.065609, -1.835621>,
      < -6.652875, -1.081609, -1.985867>,
      < -6.669310, -1.081609, -1.835621>
    }
    triangle {
      < -6.687484, -1.065609, -1.669469>,
      < -6.671050, -1.065609, -1.819715>,
      < -6.671050, -1.081609, -1.819715>
    }
    triangle {
      < -6.687484, -1.065609, -1.669469>,
      < -6.671050, -1.081609, -1.819715>,
      < -6.687484, -1.081609, -1.669469>
    }
    triangle {
      < -6.707397, -1.065609, -1.487412>,
      < -6.707397, -1.014430, -1.487412>,
      < -6.705658, -1.014430, -1.503317>
    }
    triangle {
      < -6.707397, -1.065609, -1.487412>,
      < -6.705658, -1.014430, -1.503317>,
      < -6.705658, -1.065609, -1.503317>
    }
    triangle {
      < -6.705658, -1.065609, -1.503317>,
      < -6.689224, -1.065609, -1.653564>,
      < -6.689224, -1.081609, -1.653564>
    }
    triangle {
      < -6.705658, -1.065609, -1.503317>,
      < -6.689224, -1.081609, -1.653564>,
      < -6.705658, -1.081609, -1.503317>
    }
    triangle {
      < -6.723832, -1.065609, -1.337166>,
      < -6.707397, -1.065609, -1.487412>,
      < -6.707397, -1.081609, -1.487412>
    }
    triangle {
      < -6.723832, -1.065609, -1.337166>,
      < -6.707397, -1.081609, -1.487412>,
      < -6.723832, -1.081609, -1.337166>
    }
    triangle {
      < -6.743745, -1.065609, -1.155109>,
      < -6.743745, -1.014430, -1.155109>,
      < -6.742006, -1.014430, -1.171014>
    }
    triangle {
      < -6.743745, -1.065609, -1.155109>,
      < -6.742006, -1.014430, -1.171014>,
      < -6.742006, -1.065609, -1.171014>
    }
    triangle {
      < -6.742006, -1.065609, -1.171014>,
      < -6.725572, -1.065609, -1.321261>,
      < -6.725572, -1.081609, -1.321261>
    }
    triangle {
      < -6.742006, -1.065609, -1.171014>,
      < -6.725572, -1.081609, -1.321261>,
      < -6.742006, -1.081609, -1.171014>
    }
    triangle {
      < -6.760180, -1.065609, -1.004863>,
      < -6.743745, -1.065609, -1.155109>,
      < -6.743745, -1.081609, -1.155109>
    }
    triangle {
      < -6.760180, -1.065609, -1.004863>,
      < -6.743745, -1.081609, -1.155109>,
      < -6.760180, -1.081609, -1.004863>
    }
    triangle {
      < -6.780094, -1.065609, -0.822806>,
      < -6.780094, -1.014430, -0.822806>,
      < -6.778354, -1.014430, -0.838711>
    }
    triangle {
      < -6.780094, -1.065609, -0.822806>,
      < -6.778354, -1.014430, -0.838711>,
      < -6.778354, -1.065609, -0.838711>
    }
    triangle {
      < -6.778354, -1.065609, -0.838711>,
      < -6.761919, -1.065609, -0.988957>,
      < -6.761919, -1.081609, -0.988957>
    }
    triangle {
      < -6.778354, -1.065609, -0.838711>,
      < -6.761919, -1.081609, -0.988957>,
      < -6.778354, -1.081609, -0.838711>
    }
    triangle {
      < -6.796528, -1.065609, -0.672559>,
      < -6.780094, -1.065609, -0.822806>,
      < -6.780094, -1.081609, -0.822806>
    }
    triangle {
      < -6.796528, -1.065609, -0.672559>,
      < -6.780094, -1.081609, -0.822806>,
      < -6.796528, -1.081609, -0.672559>
    }
    triangle {
      < -6.816442, -1.065609, -0.490502>,
      < -6.816442, -1.014430, -0.490502>,
      < -6.814702, -1.014430, -0.506407>
    }
    triangle {
      < -6.816442, -1.065609, -0.490502>,
      < -6.814702, -1.014430, -0.506407>,
      < -6.814702, -1.065609, -0.506407>
    }
    triangle {
      < -6.814702, -1.065609, -0.506407>,
      < -6.798267, -1.065609, -0.656654>,
      < -6.798267, -1.081609, -0.656654>
    }
    triangle {
      < -6.814702, -1.065609, -0.506407>,
      < -6.798267, -1.081609, -0.656654>,
      < -6.814702, -1.081609, -0.506407>
    }
    triangle {
      < -6.832876, -1.065609, -0.340256>,
      < -6.816442, -1.065609, -0.490502>,
      < -6.816442, -1.081609, -0.490502>
    }
    triangle {
      < -6.832876, -1.065609, -0.340256>,
      < -6.816442, -1.081609, -0.490502>,
      < -6.832876, -1.081609, -0.340256>
    }
    triangle {
      < -6.852789, -1.065609, -0.158199>,
      < -6.852789, -1.014430, -0.158199>,
      < -6.851050, -1.014430, -0.174104>
    }
    triangle {
      < -6.852789, -1.065609, -0.158199>,
      < -6.851050, -1.014430, -0.174104>,
      < -6.851050, -1.065609, -0.174104>
    }
    triangle {
      < -6.851050, -1.065609, -0.174104>,
      < -6.834615, -1.065609, -0.324351>,
      < -6.834615, -1.081609, -0.324351>
    }
    triangle {
      < -6.851050, -1.065609, -0.174104>,
      < -6.834615, -1.081609, -0.324351>,
      < -6.851050, -1.081609, -0.174104>
    }
    triangle {
      < -6.832877, -1.065609, 0.340256>,
      < -6.832877, -1.014430, 0.340256>,
      < -6.834616, -1.014430, 0.324351>
    }
    triangle {
      < -6.832877, -1.065609, 0.340256>,
      < -6.834616, -1.014430, 0.324351>,
      < -6.834616, -1.065609, 0.324351>
    }
    triangle {
      < -6.834616, -1.065609, 0.324351>,
      < -6.851051, -1.065609, 0.174104>,
      < -6.851051, -1.081609, 0.174104>
    }
    triangle {
      < -6.834616, -1.065609, 0.324351>,
      < -6.851051, -1.081609, 0.174104>,
      < -6.834616, -1.081609, 0.324351>
    }
    triangle {
      < -6.816443, -1.065609, 0.490502>,
      < -6.832877, -1.065609, 0.340256>,
      < -6.832877, -1.081609, 0.340256>
    }
    triangle {
      < -6.816443, -1.065609, 0.490502>,
      < -6.832877, -1.081609, 0.340256>,
      < -6.816443, -1.081609, 0.490502>
    }
    triangle {
      < -6.796529, -1.065609, 0.672559>,
      < -6.796529, -1.014430, 0.672559>,
      < -6.798269, -1.014430, 0.656654>
    }
    triangle {
      < -6.796529, -1.065609, 0.672559>,
      < -6.798269, -1.014430, 0.656654>,
      < -6.798269, -1.065609, 0.656654>
    }
    triangle {
      < -6.798269, -1.065609, 0.656654>,
      < -6.814703, -1.065609, 0.506407>,
      < -6.814703, -1.081609, 0.506407>
    }
    triangle {
      < -6.798269, -1.065609, 0.656654>,
      < -6.814703, -1.081609, 0.506407>,
      < -6.798269, -1.081609, 0.656654>
    }
    triangle {
      < -6.780095, -1.065609, 0.822806>,
      < -6.796529, -1.065609, 0.672559>,
      < -6.796529, -1.081609, 0.672559>
    }
    triangle {
      < -6.780095, -1.065609, 0.822806>,
      < -6.796529, -1.081609, 0.672559>,
      < -6.780095, -1.081609, 0.822806>
    }
    triangle {
      < -6.760181, -1.065609, 1.004862>,
      < -6.760181, -1.014430, 1.004862>,
      < -6.761921, -1.014430, 0.988957>
    }
    triangle {
      < -6.760181, -1.065609, 1.004862>,
      < -6.761921, -1.014430, 0.988957>,
      < -6.761921, -1.065609, 0.988957>
    }
    triangle {
      < -6.761921, -1.065609, 0.988957>,
      < -6.778356, -1.065609, 0.838711>,
      < -6.778356, -1.081609, 0.838711>
    }
    triangle {
      < -6.761921, -1.065609, 0.988957>,
      < -6.778356, -1.081609, 0.838711>,
      < -6.761921, -1.081609, 0.988957>
    }
    triangle {
      < -6.743747, -1.065609, 1.155109>,
      < -6.760181, -1.065609, 1.004862>,
      < -6.760181, -1.081609, 1.004862>
    }
    triangle {
      < -6.743747, -1.065609, 1.155109>,
      < -6.760181, -1.081609, 1.004862>,
      < -6.743747, -1.081609, 1.155109>
    }
    triangle {
      < -6.723834, -1.065609, 1.337166>,
      < -6.723834, -1.014430, 1.337166>,
      < -6.725573, -1.014430, 1.321260>
    }
    triangle {
      < -6.723834, -1.065609, 1.337166>,
      < -6.725573, -1.014430, 1.321260>,
      < -6.725573, -1.065609, 1.321260>
    }
    triangle {
      < -6.725573, -1.065609, 1.321260>,
      < -6.742008, -1.065609, 1.171014>,
      < -6.742008, -1.081609, 1.171014>
    }
    triangle {
      < -6.725573, -1.065609, 1.321260>,
      < -6.742008, -1.081609, 1.171014>,
      < -6.725573, -1.081609, 1.321260>
    }
    triangle {
      < -6.707399, -1.065609, 1.487412>,
      < -6.723834, -1.065609, 1.337166>,
      < -6.723834, -1.081609, 1.337166>
    }
    triangle {
      < -6.707399, -1.065609, 1.487412>,
      < -6.723834, -1.081609, 1.337166>,
      < -6.707399, -1.081609, 1.487412>
    }
    triangle {
      < -6.687486, -1.065609, 1.669469>,
      < -6.687486, -1.014430, 1.669469>,
      < -6.689225, -1.014430, 1.653563>
    }
    triangle {
      < -6.687486, -1.065609, 1.669469>,
      < -6.689225, -1.014430, 1.653563>,
      < -6.689225, -1.065609, 1.653563>
    }
    triangle {
      < -6.689225, -1.065609, 1.653563>,
      < -6.705659, -1.065609, 1.503317>,
      < -6.705659, -1.081609, 1.503317>
    }
    triangle {
      < -6.689225, -1.065609, 1.653563>,
      < -6.705659, -1.081609, 1.503317>,
      < -6.689225, -1.081609, 1.653563>
    }
    triangle {
      < -6.671051, -1.065609, 1.819715>,
      < -6.687486, -1.065609, 1.669469>,
      < -6.687486, -1.081609, 1.669469>
    }
    triangle {
      < -6.671051, -1.065609, 1.819715>,
      < -6.687486, -1.081609, 1.669469>,
      < -6.671051, -1.081609, 1.819715>
    }
    triangle {
      < -6.651138, -1.065609, 2.001772>,
      < -6.651138, -1.014430, 2.001772>,
      < -6.652877, -1.014430, 1.985867>
    }
    triangle {
      < -6.651138, -1.065609, 2.001772>,
      < -6.652877, -1.014430, 1.985867>,
      < -6.652877, -1.065609, 1.985867>
    }
    triangle {
      < -6.652877, -1.065609, 1.985867>,
      < -6.669312, -1.065609, 1.835620>,
      < -6.669312, -1.081609, 1.835620>
    }
    triangle {
      < -6.652877, -1.065609, 1.985867>,
      < -6.669312, -1.081609, 1.835620>,
      < -6.652877, -1.081609, 1.985867>
    }
    triangle {
      < -6.634703, -1.065609, 2.152019>,
      < -6.651138, -1.065609, 2.001772>,
      < -6.651138, -1.081609, 2.001772>
    }
    triangle {
      < -6.634703, -1.065609, 2.152019>,
      < -6.651138, -1.081609, 2.001772>,
      < -6.634703, -1.081609, 2.152019>
    }
    triangle {
      < -6.614789, -1.065609, 2.334075>,
      < -6.614789, -1.014430, 2.334075>,
      < -6.616529, -1.014430, 2.318170>
    }
    triangle {
      < -6.614789, -1.065609, 2.334075>,
      < -6.616529, -1.014430, 2.318170>,
      < -6.616529, -1.065609, 2.318170>
    }
    triangle {
      < -6.616529, -1.065609, 2.318170>,
      < -6.632964, -1.065609, 2.167924>,
      < -6.632964, -1.081609, 2.167924>
    }
    triangle {
      < -6.616529, -1.065609, 2.318170>,
      < -6.632964, -1.081609, 2.167924>,
      < -6.616529, -1.081609, 2.318170>
    }
    triangle {
      < -6.598355, -1.065609, 2.484322>,
      < -6.614789, -1.065609, 2.334075>,
      < -6.614789, -1.081609, 2.334075>
    }
    triangle {
      < -6.598355, -1.065609, 2.484322>,
      < -6.614789, -1.081609, 2.334075>,
      < -6.598355, -1.081609, 2.484322>
    }
    triangle {
      < -6.614789, -1.014430, -2.334075>,
      < -6.614789, -1.065609, -2.334075>,
      < -6.616529, -1.065609, -2.318170>
    }
    triangle {
      < -6.614789, -1.014430, -2.334075>,
      < -6.616529, -1.065609, -2.318170>,
      < -6.616529, -1.014430, -2.318170>
    }
    triangle {
      < -6.651136, -1.014430, -2.001772>,
      < -6.651136, -1.065609, -2.001772>,
      < -6.652875, -1.065609, -1.985867>
    }
    triangle {
      < -6.651136, -1.014430, -2.001772>,
      < -6.652875, -1.065609, -1.985867>,
      < -6.652875, -1.014430, -1.985867>
    }
    triangle {
      < -6.687484, -1.014430, -1.669469>,
      < -6.687484, -1.065609, -1.669469>,
      < -6.689224, -1.065609, -1.653564>
    }
    triangle {
      < -6.687484, -1.014430, -1.669469>,
      < -6.689224, -1.065609, -1.653564>,
      < -6.689224, -1.014430, -1.653564>
    }
    triangle {
      < -6.723832, -1.014430, -1.337166>,
      < -6.723832, -1.065609, -1.337166>,
      < -6.725572, -1.065609, -1.321261>
    }
    triangle {
      < -6.723832, -1.014430, -1.337166>,
      < -6.725572, -1.065609, -1.321261>,
      < -6.725572, -1.014430, -1.321261>
    }
    triangle {
      < -6.760180, -1.014430, -1.004863>,
      < -6.760180, -1.065609, -1.004863>,
      < -6.761919, -1.065609, -0.988957>
    }
    triangle {
      < -6.760180, -1.014430, -1.004863>,
      < -6.761919, -1.065609, -0.988957>,
      < -6.761919, -1.014430, -0.988957>
    }
    triangle {
      < -6.796528, -1.014430, -0.672559>,
      < -6.796528, -1.065609, -0.672559>,
      < -6.798267, -1.065609, -0.656654>
    }
    triangle {
      < -6.796528, -1.014430, -0.672559>,
      < -6.798267, -1.065609, -0.656654>,
      < -6.798267, -1.014430, -0.656654>
    }
    triangle {
      < -6.832876, -1.014430, -0.340256>,
      < -6.832876, -1.065609, -0.340256>,
      < -6.834615, -1.065609, -0.324351>
    }
    triangle {
      < -6.832876, -1.014430, -0.340256>,
      < -6.834615, -1.065609, -0.324351>,
      < -6.834615, -1.014430, -0.324351>
    }
    triangle {
      < -6.852790, -1.014430, 0.158199>,
      < -6.852790, -1.065609, 0.158199>,
      < -6.851051, -1.065609, 0.174104>
    }
    triangle {
      < -6.852790, -1.014430, 0.158199>,
      < -6.851051, -1.065609, 0.174104>,
      < -6.851051, -1.014430, 0.174104>
    }
    triangle {
      < -6.816443, -1.014430, 0.490502>,
      < -6.816443, -1.065609, 0.490502>,
      < -6.814703, -1.065609, 0.506407>
    }
    triangle {
      < -6.816443, -1.014430, 0.490502>,
      < -6.814703, -1.065609, 0.506407>,
      < -6.814703, -1.014430, 0.506407>
    }
    triangle {
      < -6.780095, -1.014430, 0.822805>,
      < -6.780095, -1.065609, 0.822806>,
      < -6.778356, -1.065609, 0.838711>
    }
    triangle {
      < -6.780095, -1.014430, 0.822805>,
      < -6.778356, -1.065609, 0.838711>,
      < -6.778356, -1.014430, 0.838711>
    }
    triangle {
      < -6.743747, -1.014430, 1.155109>,
      < -6.743747, -1.065609, 1.155109>,
      < -6.742008, -1.065609, 1.171014>
    }
    triangle {
      < -6.743747, -1.014430, 1.155109>,
      < -6.742008, -1.065609, 1.171014>,
      < -6.742008, -1.014430, 1.171014>
    }
    triangle {
      < -6.707399, -1.014430, 1.487412>,
      < -6.707399, -1.065609, 1.487412>,
      < -6.705659, -1.065609, 1.503317>
    }
    triangle {
      < -6.707399, -1.014430, 1.487412>,
      < -6.705659, -1.065609, 1.503317>,
      < -6.705659, -1.014430, 1.503317>
    }
    triangle {
      < -6.671051, -1.014430, 1.819715>,
      < -6.671051, -1.065609, 1.819715>,
      < -6.669312, -1.065609, 1.835620>
    }
    triangle {
      < -6.671051, -1.014430, 1.819715>,
      < -6.669312, -1.065609, 1.835620>,
      < -6.669312, -1.014430, 1.835620>
    }
    triangle {
      < -6.634703, -1.014430, 2.152019>,
      < -6.634703, -1.065609, 2.152019>,
      < -6.632964, -1.065609, 2.167924>
    }
    triangle {
      < -6.634703, -1.014430, 2.152019>,
      < -6.632964, -1.065609, 2.167924>,
      < -6.632964, -1.014430, 2.167924>
    }
    triangle {
      < -6.580181, -1.065609, 2.650474>,
      < -6.596616, -1.065609, 2.500227>,
      < -6.596616, -1.081609, 2.500227>
    }
    triangle {
      < -6.580181, -1.065609, 2.650474>,
      < -6.596616, -1.081609, 2.500227>,
      < -6.580181, -1.081609, 2.650474>
    }
    triangle {
      < -6.598355, -1.014430, 2.484322>,
      < -6.598355, -1.065609, 2.484322>,
      < -6.596616, -1.065609, 2.500227>
    }
    triangle {
      < -6.598355, -1.014430, 2.484322>,
      < -6.596616, -1.065609, 2.500227>,
      < -6.596616, -1.014430, 2.500227>
    }
    triangle {
      < -6.869224, -0.998430, 0.007953>,
      < -6.869224, -0.947251, 0.007953>,
      < -6.869224, -0.947251, -0.007953>
    }
    triangle {
      < -6.869224, -0.998430, 0.007953>,
      < -6.869224, -0.947251, -0.007953>,
      < -6.869224, -0.998430, -0.007953>
    }
    triangle {
      < -6.869224, -0.998430, -0.007953>,
      < -6.852789, -0.998430, -0.158199>,
      < -6.852789, -1.014430, -0.158199>
    }
    triangle {
      < -6.869224, -0.998430, -0.007953>,
      < -6.852789, -1.014430, -0.158199>,
      < -6.869224, -1.014430, -0.007953>
    }
    triangle {
      < -6.852790, -0.998430, 0.158199>,
      < -6.869224, -0.998430, 0.007953>,
      < -6.869224, -1.014430, 0.007953>
    }
    triangle {
      < -6.852790, -0.998430, 0.158199>,
      < -6.869224, -1.014430, 0.007953>,
      < -6.852790, -1.014430, 0.158199>
    }
    triangle {
      < -6.580181, -0.998430, -2.650473>,
      < -6.580181, -0.947251, -2.650473>,
      < -6.571311, -0.939251, -2.658426>
    }
    triangle {
      < -6.580181, -0.998430, -2.650473>,
      < -6.571311, -0.939251, -2.658426>,
      < -6.571311, -1.006430, -2.658426>
    }
    triangle {
      < -6.596615, -0.998430, -2.500227>,
      < -6.580181, -0.998430, -2.650473>,
      < -6.580181, -1.014430, -2.650473>
    }
    triangle {
      < -6.596615, -0.998430, -2.500227>,
      < -6.580181, -1.014430, -2.650473>,
      < -6.596615, -1.014430, -2.500227>
    }
    triangle {
      < -6.598354, -0.998430, -2.484322>,
      < -6.598354, -0.947251, -2.484322>,
      < -6.596615, -0.947251, -2.500227>
    }
    triangle {
      < -6.598354, -0.998430, -2.484322>,
      < -6.596615, -0.947251, -2.500227>,
      < -6.596615, -0.998430, -2.500227>
    }
    triangle {
      < -6.614789, -0.998430, -2.334075>,
      < -6.598354, -0.998430, -2.484322>,
      < -6.598354, -1.014430, -2.484322>
    }
    triangle {
      < -6.614789, -0.998430, -2.334075>,
      < -6.598354, -1.014430, -2.484322>,
      < -6.614789, -1.014430, -2.334075>
    }
    triangle {
      < -6.634702, -0.998430, -2.152019>,
      < -6.634702, -0.947251, -2.152019>,
      < -6.632962, -0.947251, -2.167924>
    }
    triangle {
      < -6.634702, -0.998430, -2.152019>,
      < -6.632962, -0.947251, -2.167924>,
      < -6.632962, -0.998430, -2.167924>
    }
    triangle {
      < -6.632962, -0.998430, -2.167924>,
      < -6.616529, -0.998430, -2.318170>,
      < -6.616529, -1.014430, -2.318170>
    }
    triangle {
      < -6.632962, -0.998430, -2.167924>,
      < -6.616529, -1.014430, -2.318170>,
      < -6.632962, -1.014430, -2.167924>
    }
    triangle {
      < -6.651136, -0.998430, -2.001772>,
      < -6.634702, -0.998430, -2.152019>,
      < -6.634702, -1.014430, -2.152019>
    }
    triangle {
      < -6.651136, -0.998430, -2.001772>,
      < -6.634702, -1.014430, -2.152019>,
      < -6.651136, -1.014430, -2.001772>
    }
    triangle {
      < -6.671050, -0.998430, -1.819715>,
      < -6.671050, -0.947251, -1.819715>,
      < -6.669310, -0.947251, -1.835621>
    }
    triangle {
      < -6.671050, -0.998430, -1.819715>,
      < -6.669310, -0.947251, -1.835621>,
      < -6.669310, -0.998430, -1.835621>
    }
    triangle {
      < -6.669310, -0.998430, -1.835621>,
      < -6.652875, -0.998430, -1.985867>,
      < -6.652875, -1.014430, -1.985867>
    }
    triangle {
      < -6.669310, -0.998430, -1.835621>,
      < -6.652875, -1.014430, -1.985867>,
      < -6.669310, -1.014430, -1.835621>
    }
    triangle {
      < -6.687484, -0.998430, -1.669469>,
      < -6.671050, -0.998430, -1.819715>,
      < -6.671050, -1.014430, -1.819715>
    }
    triangle {
      < -6.687484, -0.998430, -1.669469>,
      < -6.671050, -1.014430, -1.819715>,
      < -6.687484, -1.014430, -1.669469>
    }
    triangle {
      < -6.707397, -0.998430, -1.487412>,
      < -6.707397, -0.947251, -1.487412>,
      < -6.705658, -0.947251, -1.503317>
    }
    triangle {
      < -6.707397, -0.998430, -1.487412>,
      < -6.705658, -0.947251, -1.503317>,
      < -6.705658, -0.998430, -1.503317>
    }
    triangle {
      < -6.705658, -0.998430, -1.503317>,
      < -6.689224, -0.998430, -1.653564>,
      < -6.689224, -1.014430, -1.653564>
    }
    triangle {
      < -6.705658, -0.998430, -1.503317>,
      < -6.689224, -1.014430, -1.653564>,
      < -6.705658, -1.014430, -1.503317>
    }
    triangle {
      < -6.723832, -0.998430, -1.337166>,
      < -6.707397, -0.998430, -1.487412>,
      < -6.707397, -1.014430, -1.487412>
    }
    triangle {
      < -6.723832, -0.998430, -1.337166>,
      < -6.707397, -1.014430, -1.487412>,
      < -6.723832, -1.014430, -1.337166>
    }
    triangle {
      < -6.743745, -0.998430, -1.155109>,
      < -6.743745, -0.947251, -1.155109>,
      < -6.742006, -0.947251, -1.171014>
    }
    triangle {
      < -6.743745, -0.998430, -1.155109>,
      < -6.742006, -0.947251, -1.171014>,
      < -6.742006, -0.998430, -1.171014>
    }
    triangle {
      < -6.742006, -0.998430, -1.171014>,
      < -6.725572, -0.998430, -1.321261>,
      < -6.725572, -1.014430, -1.321261>
    }
    triangle {
      < -6.742006, -0.998430, -1.171014>,
      < -6.725572, -1.014430, -1.321261>,
      < -6.742006, -1.014430, -1.171014>
    }
    triangle {
      < -6.760180, -0.998430, -1.004863>,
      < -6.743745, -0.998430, -1.155109>,
      < -6.743745, -1.014430, -1.155109>
    }
    triangle {
      < -6.760180, -0.998430, -1.004863>,
      < -6.743745, -1.014430, -1.155109>,
      < -6.760180, -1.014430, -1.004863>
    }
    triangle {
      < -6.780094, -0.998430, -0.822806>,
      < -6.780094, -0.947251, -0.822806>,
      < -6.778354, -0.947251, -0.838711>
    }
    triangle {
      < -6.780094, -0.998430, -0.822806>,
      < -6.778354, -0.947251, -0.838711>,
      < -6.778354, -0.998430, -0.838711>
    }
    triangle {
      < -6.778354, -0.998430, -0.838711>,
      < -6.761919, -0.998430, -0.988957>,
      < -6.761919, -1.014430, -0.988957>
    }
    triangle {
      < -6.778354, -0.998430, -0.838711>,
      < -6.761919, -1.014430, -0.988957>,
      < -6.778354, -1.014430, -0.838711>
    }
    triangle {
      < -6.796528, -0.998430, -0.672559>,
      < -6.780094, -0.998430, -0.822806>,
      < -6.780094, -1.014430, -0.822806>
    }
    triangle {
      < -6.796528, -0.998430, -0.672559>,
      < -6.780094, -1.014430, -0.822806>,
      < -6.796528, -1.014430, -0.672559>
    }
    triangle {
      < -6.816442, -0.998430, -0.490502>,
      < -6.816442, -0.947251, -0.490502>,
      < -6.814702, -0.947251, -0.506407>
    }
    triangle {
      < -6.816442, -0.998430, -0.490502>,
      < -6.814702, -0.947251, -0.506407>,
      < -6.814702, -0.998430, -0.506407>
    }
    triangle {
      < -6.814702, -0.998430, -0.506407>,
      < -6.798267, -0.998430, -0.656654>,
      < -6.798267, -1.014430, -0.656654>
    }
    triangle {
      < -6.814702, -0.998430, -0.506407>,
      < -6.798267, -1.014430, -0.656654>,
      < -6.814702, -1.014430, -0.506407>
    }
    triangle {
      < -6.832876, -0.998430, -0.340256>,
      < -6.816442, -0.998430, -0.490502>,
      < -6.816442, -1.014430, -0.490502>
    }
    triangle {
      < -6.832876, -0.998430, -0.340256>,
      < -6.816442, -1.014430, -0.490502>,
      < -6.832876, -1.014430, -0.340256>
    }
    triangle {
      < -6.852789, -0.998430, -0.158199>,
      < -6.852789, -0.947251, -0.158199>,
      < -6.851050, -0.947251, -0.174104>
    }
    triangle {
      < -6.852789, -0.998430, -0.158199>,
      < -6.851050, -0.947251, -0.174104>,
      < -6.851050, -0.998430, -0.174104>
    }
    triangle {
      < -6.851050, -0.998430, -0.174104>,
      < -6.834615, -0.998430, -0.324351>,
      < -6.834615, -1.014430, -0.324351>
    }
    triangle {
      < -6.851050, -0.998430, -0.174104>,
      < -6.834615, -1.014430, -0.324351>,
      < -6.851050, -1.014430, -0.174104>
    }
    triangle {
      < -6.832877, -0.998430, 0.340256>,
      < -6.832877, -0.947251, 0.340256>,
      < -6.834616, -0.947251, 0.324351>
    }
    triangle {
      < -6.832877, -0.998430, 0.340256>,
      < -6.834616, -0.947251, 0.324351>,
      < -6.834616, -0.998430, 0.324351>
    }
    triangle {
      < -6.834616, -0.998430, 0.324351>,
      < -6.851051, -0.998430, 0.174104>,
      < -6.851051, -1.014430, 0.174104>
    }
    triangle {
      < -6.834616, -0.998430, 0.324351>,
      < -6.851051, -1.014430, 0.174104>,
      < -6.834616, -1.014430, 0.324351>
    }
    triangle {
      < -6.816443, -0.998430, 0.490502>,
      < -6.832877, -0.998430, 0.340256>,
      < -6.832877, -1.014430, 0.340256>
    }
    triangle {
      < -6.816443, -0.998430, 0.490502>,
      < -6.832877, -1.014430, 0.340256>,
      < -6.816443, -1.014430, 0.490502>
    }
    triangle {
      < -6.796529, -0.998430, 0.672559>,
      < -6.796529, -0.947251, 0.672559>,
      < -6.798269, -0.947251, 0.656654>
    }
    triangle {
      < -6.796529, -0.998430, 0.672559>,
      < -6.798269, -0.947251, 0.656654>,
      < -6.798269, -0.998430, 0.656654>
    }
    triangle {
      < -6.798269, -0.998430, 0.656654>,
      < -6.814703, -0.998430, 0.506407>,
      < -6.814703, -1.014430, 0.506407>
    }
    triangle {
      < -6.798269, -0.998430, 0.656654>,
      < -6.814703, -1.014430, 0.506407>,
      < -6.798269, -1.014430, 0.656654>
    }
    triangle {
      < -6.780095, -0.998430, 0.822805>,
      < -6.796529, -0.998430, 0.672559>,
      < -6.796529, -1.014430, 0.672559>
    }
    triangle {
      < -6.780095, -0.998430, 0.822805>,
      < -6.796529, -1.014430, 0.672559>,
      < -6.780095, -1.014430, 0.822805>
    }
    triangle {
      < -6.760181, -0.998430, 1.004862>,
      < -6.760181, -0.947251, 1.004862>,
      < -6.761921, -0.947251, 0.988957>
    }
    triangle {
      < -6.760181, -0.998430, 1.004862>,
      < -6.761921, -0.947251, 0.988957>,
      < -6.761921, -0.998430, 0.988957>
    }
    triangle {
      < -6.761921, -0.998430, 0.988957>,
      < -6.778356, -0.998430, 0.838711>,
      < -6.778356, -1.014430, 0.838711>
    }
    triangle {
      < -6.761921, -0.998430, 0.988957>,
      < -6.778356, -1.014430, 0.838711>,
      < -6.761921, -1.014430, 0.988957>
    }
    triangle {
      < -6.743747, -0.998430, 1.155109>,
      < -6.760181, -0.998430, 1.004862>,
      < -6.760181, -1.014430, 1.004862>
    }
    triangle {
      < -6.743747, -0.998430, 1.155109>,
      < -6.760181, -1.014430, 1.004862>,
      < -6.743747, -1.014430, 1.155109>
    }
    triangle {
      < -6.723834, -0.998430, 1.337166>,
      < -6.723834, -0.947251, 1.337166>,
      < -6.725573, -0.947251, 1.321260>
    }
    triangle {
      < -6.723834, -0.998430, 1.337166>,
      < -6.725573, -0.947251, 1.321260>,
      < -6.725573, -0.998430, 1.321260>
    }
    triangle {
      < -6.725573, -0.998430, 1.321260>,
      < -6.742008, -0.998430, 1.171014>,
      < -6.742008, -1.014430, 1.171014>
    }
    triangle {
      < -6.725573, -0.998430, 1.321260>,
      < -6.742008, -1.014430, 1.171014>,
      < -6.725573, -1.014430, 1.321260>
    }
    triangle {
      < -6.707399, -0.998430, 1.487412>,
      < -6.723834, -0.998430, 1.337166>,
      < -6.723834, -1.014430, 1.337166>
    }
    triangle {
      < -6.707399, -0.998430, 1.487412>,
      < -6.723834, -1.014430, 1.337166>,
      < -6.707399, -1.014430, 1.487412>
    }
    triangle {
      < -6.687486, -0.998430, 1.669469>,
      < -6.687486, -0.947251, 1.669469>,
      < -6.689225, -0.947251, 1.653563>
    }
    triangle {
      < -6.687486, -0.998430, 1.669469>,
      < -6.689225, -0.947251, 1.653563>,
      < -6.689225, -0.998430, 1.653563>
    }
    triangle {
      < -6.689225, -0.998430, 1.653563>,
      < -6.705659, -0.998430, 1.503317>,
      < -6.705659, -1.014430, 1.503317>
    }
    triangle {
      < -6.689225, -0.998430, 1.653563>,
      < -6.705659, -1.014430, 1.503317>,
      < -6.689225, -1.014430, 1.653563>
    }
    triangle {
      < -6.671051, -0.998430, 1.819715>,
      < -6.687486, -0.998430, 1.669469>,
      < -6.687486, -1.014430, 1.669469>
    }
    triangle {
      < -6.671051, -0.998430, 1.819715>,
      < -6.687486, -1.014430, 1.669469>,
      < -6.671051, -1.014430, 1.819715>
    }
    triangle {
      < -6.651138, -0.998430, 2.001772>,
      < -6.651138, -0.947251, 2.001772>,
      < -6.652877, -0.947251, 1.985867>
    }
    triangle {
      < -6.651138, -0.998430, 2.001772>,
      < -6.652877, -0.947251, 1.985867>,
      < -6.652877, -0.998430, 1.985867>
    }
    triangle {
      < -6.652877, -0.998430, 1.985867>,
      < -6.669312, -0.998430, 1.835620>,
      < -6.669312, -1.014430, 1.835620>
    }
    triangle {
      < -6.652877, -0.998430, 1.985867>,
      < -6.669312, -1.014430, 1.835620>,
      < -6.652877, -1.014430, 1.985867>
    }
    triangle {
      < -6.634703, -0.998430, 2.152019>,
      < -6.651138, -0.998430, 2.001772>,
      < -6.651138, -1.014430, 2.001772>
    }
    triangle {
      < -6.634703, -0.998430, 2.152019>,
      < -6.651138, -1.014430, 2.001772>,
      < -6.634703, -1.014430, 2.152019>
    }
    triangle {
      < -6.614789, -0.998430, 2.334075>,
      < -6.614789, -0.947251, 2.334075>,
      < -6.616529, -0.947251, 2.318170>
    }
    triangle {
      < -6.614789, -0.998430, 2.334075>,
      < -6.616529, -0.947251, 2.318170>,
      < -6.616529, -0.998430, 2.318170>
    }
    triangle {
      < -6.616529, -0.998430, 2.318170>,
      < -6.632964, -0.998430, 2.167924>,
      < -6.632964, -1.014430, 2.167924>
    }
    triangle {
      < -6.616529, -0.998430, 2.318170>,
      < -6.632964, -1.014430, 2.167924>,
      < -6.616529, -1.014430, 2.318170>
    }
    triangle {
      < -6.598355, -0.998430, 2.484322>,
      < -6.614789, -0.998430, 2.334075>,
      < -6.614789, -1.014430, 2.334075>
    }
    triangle {
      < -6.598355, -0.998430, 2.484322>,
      < -6.614789, -1.014430, 2.334075>,
      < -6.598355, -1.014430, 2.484322>
    }
    triangle {
      < -6.580181, -0.998430, 2.650474>,
      < -6.596616, -0.998430, 2.500227>,
      < -6.596616, -1.014430, 2.500227>
    }
    triangle {
      < -6.580181, -0.998430, 2.650474>,
      < -6.596616, -1.014430, 2.500227>,
      < -6.580181, -1.014430, 2.650474>
    }
    triangle {
      < -6.598355, -0.947251, 2.484322>,
      < -6.598355, -0.998430, 2.484322>,
      < -6.596616, -0.998430, 2.500227>
    }
    triangle {
      < -6.598355, -0.947251, 2.484322>,
      < -6.596616, -0.998430, 2.500227>,
      < -6.596616, -0.947251, 2.500227>
    }
    triangle {
      < -6.634703, -0.947251, 2.152019>,
      < -6.634703, -0.998430, 2.152019>,
      < -6.632964, -0.998430, 2.167924>
    }
    triangle {
      < -6.634703, -0.947251, 2.152019>,
      < -6.632964, -0.998430, 2.167924>,
      < -6.632964, -0.947251, 2.167924>
    }
    triangle {
      < -6.671051, -0.947251, 1.819715>,
      < -6.671051, -0.998430, 1.819715>,
      < -6.669312, -0.998430, 1.835620>
    }
    triangle {
      < -6.671051, -0.947251, 1.819715>,
      < -6.669312, -0.998430, 1.835620>,
      < -6.669312, -0.947251, 1.835620>
    }
    triangle {
      < -6.707399, -0.947251, 1.487412>,
      < -6.707399, -0.998430, 1.487412>,
      < -6.705659, -0.998430, 1.503317>
    }
    triangle {
      < -6.707399, -0.947251, 1.487412>,
      < -6.705659, -0.998430, 1.503317>,
      < -6.705659, -0.947251, 1.503317>
    }
    triangle {
      < -6.743747, -0.947251, 1.155109>,
      < -6.743747, -0.998430, 1.155109>,
      < -6.742008, -0.998430, 1.171014>
    }
    triangle {
      < -6.743747, -0.947251, 1.155109>,
      < -6.742008, -0.998430, 1.171014>,
      < -6.742008, -0.947251, 1.171014>
    }
    triangle {
      < -6.780095, -0.947251, 0.822805>,
      < -6.780095, -0.998430, 0.822805>,
      < -6.778356, -0.998430, 0.838711>
    }
    triangle {
      < -6.780095, -0.947251, 0.822805>,
      < -6.778356, -0.998430, 0.838711>,
      < -6.778356, -0.947251, 0.838711>
    }
    triangle {
      < -6.816443, -0.947251, 0.490502>,
      < -6.816443, -0.998430, 0.490502>,
      < -6.814703, -0.998430, 0.506407>
    }
    triangle {
      < -6.816443, -0.947251, 0.490502>,
      < -6.814703, -0.998430, 0.506407>,
      < -6.814703, -0.947251, 0.506407>
    }
    triangle {
      < -6.852790, -0.947251, 0.158199>,
      < -6.852790, -0.998430, 0.158199>,
      < -6.851051, -0.998430, 0.174104>
    }
    triangle {
      < -6.852790, -0.947251, 0.158199>,
      < -6.851051, -0.998430, 0.174104>,
      < -6.851051, -0.947251, 0.174104>
    }
    triangle {
      < -6.832876, -0.947251, -0.340256>,
      < -6.832876, -0.998430, -0.340256>,
      < -6.834615, -0.998430, -0.324351>
    }
    triangle {
      < -6.832876, -0.947251, -0.340256>,
      < -6.834615, -0.998430, -0.324351>,
      < -6.834615, -0.947251, -0.324351>
    }
    triangle {
      < -6.796528, -0.947251, -0.672559>,
      < -6.796528, -0.998430, -0.672559>,
      < -6.798267, -0.998430, -0.656654>
    }
    triangle {
      < -6.796528, -0.947251, -0.672559>,
      < -6.798267, -0.998430, -0.656654>,
      < -6.798267, -0.947251, -0.656654>
    }
    triangle {
      < -6.760180, -0.947251, -1.004863>,
      < -6.760180, -0.998430, -1.004863>,
      < -6.761919, -0.998430, -0.988957>
    }
    triangle {
      < -6.760180, -0.947251, -1.004863>,
      < -6.761919, -0.998430, -0.988957>,
      < -6.761919, -0.947251, -0.988957>
    }
    triangle {
      < -6.723832, -0.947251, -1.337166>,
      < -6.723832, -0.998430, -1.337166>,
      < -6.725572, -0.998430, -1.321261>
    }
    triangle {
      < -6.723832, -0.947251, -1.337166>,
      < -6.725572, -0.998430, -1.321261>,
      < -6.725572, -0.947251, -1.321261>
    }
    triangle {
      < -6.687484, -0.947251, -1.669469>,
      < -6.687484, -0.998430, -1.669469>,
      < -6.689224, -0.998430, -1.653564>
    }
    triangle {
      < -6.687484, -0.947251, -1.669469>,
      < -6.689224, -0.998430, -1.653564>,
      < -6.689224, -0.947251, -1.653564>
    }
    triangle {
      < -6.651136, -0.947251, -2.001772>,
      < -6.651136, -0.998430, -2.001772>,
      < -6.652875, -0.998430, -1.985867>
    }
    triangle {
      < -6.651136, -0.947251, -2.001772>,
      < -6.652875, -0.998430, -1.985867>,
      < -6.652875, -0.947251, -1.985867>
    }
    triangle {
      < -6.614789, -0.947251, -2.334075>,
      < -6.614789, -0.998430, -2.334075>,
      < -6.616529, -0.998430, -2.318170>
    }
    triangle {
      < -6.614789, -0.947251, -2.334075>,
      < -6.616529, -0.998430, -2.318170>,
      < -6.616529, -0.947251, -2.318170>
    }
    triangle {
      < -6.869224, -0.931251, 0.007953>,
      < -6.869224, -0.880072, 0.007953>,
      < -6.869224, -0.880072, -0.007953>
    }
    triangle {
      < -6.869224, -0.931251, 0.007953>,
      < -6.869224, -0.880072, -0.007953>,
      < -6.869224, -0.931251, -0.007953>
    }
    triangle {
      < -6.869224, -0.931251, -0.007953>,
      < -6.852789, -0.931251, -0.158199>,
      < -6.852789, -0.947251, -0.158199>
    }
    triangle {
      < -6.869224, -0.931251, -0.007953>,
      < -6.852789, -0.947251, -0.158199>,
      < -6.869224, -0.947251, -0.007953>
    }
    triangle {
      < -6.852790, -0.931251, 0.158199>,
      < -6.869224, -0.931251, 0.007953>,
      < -6.869224, -0.947251, 0.007953>
    }
    triangle {
      < -6.852790, -0.931251, 0.158199>,
      < -6.869224, -0.947251, 0.007953>,
      < -6.852790, -0.947251, 0.158199>
    }
    triangle {
      < -6.580181, -0.931251, -2.650473>,
      < -6.580181, -0.880072, -2.650473>,
      < -6.571311, -0.872072, -2.658426>
    }
    triangle {
      < -6.580181, -0.931251, -2.650473>,
      < -6.571311, -0.872072, -2.658426>,
      < -6.571311, -0.939251, -2.658426>
    }
    triangle {
      < -6.596615, -0.931251, -2.500227>,
      < -6.580181, -0.931251, -2.650473>,
      < -6.580181, -0.947251, -2.650473>
    }
    triangle {
      < -6.596615, -0.931251, -2.500227>,
      < -6.580181, -0.947251, -2.650473>,
      < -6.596615, -0.947251, -2.500227>
    }
    triangle {
      < -6.598354, -0.931251, -2.484322>,
      < -6.598354, -0.880072, -2.484322>,
      < -6.596615, -0.880072, -2.500227>
    }
    triangle {
      < -6.598354, -0.931251, -2.484322>,
      < -6.596615, -0.880072, -2.500227>,
      < -6.596615, -0.931251, -2.500227>
    }
    triangle {
      < -6.614789, -0.931251, -2.334075>,
      < -6.598354, -0.931251, -2.484322>,
      < -6.598354, -0.947251, -2.484322>
    }
    triangle {
      < -6.614789, -0.931251, -2.334075>,
      < -6.598354, -0.947251, -2.484322>,
      < -6.614789, -0.947251, -2.334075>
    }
    triangle {
      < -6.634702, -0.931251, -2.152019>,
      < -6.634702, -0.880072, -2.152019>,
      < -6.632962, -0.880072, -2.167924>
    }
    triangle {
      < -6.634702, -0.931251, -2.152019>,
      < -6.632962, -0.880072, -2.167924>,
      < -6.632962, -0.931251, -2.167924>
    }
    triangle {
      < -6.632962, -0.931251, -2.167924>,
      < -6.616529, -0.931251, -2.318170>,
      < -6.616529, -0.947251, -2.318170>
    }
    triangle {
      < -6.632962, -0.931251, -2.167924>,
      < -6.616529, -0.947251, -2.318170>,
      < -6.632962, -0.947251, -2.167924>
    }
    triangle {
      < -6.651136, -0.931251, -2.001772>,
      < -6.634702, -0.931251, -2.152019>,
      < -6.634702, -0.947251, -2.152019>
    }
    triangle {
      < -6.651136, -0.931251, -2.001772>,
      < -6.634702, -0.947251, -2.152019>,
      < -6.651136, -0.947251, -2.001772>
    }
    triangle {
      < -6.671050, -0.931251, -1.819715>,
      < -6.671050, -0.880072, -1.819715>,
      < -6.669310, -0.880072, -1.835621>
    }
    triangle {
      < -6.671050, -0.931251, -1.819715>,
      < -6.669310, -0.880072, -1.835621>,
      < -6.669310, -0.931251, -1.835621>
    }
    triangle {
      < -6.669310, -0.931251, -1.835621>,
      < -6.652875, -0.931251, -1.985867>,
      < -6.652875, -0.947251, -1.985867>
    }
    triangle {
      < -6.669310, -0.931251, -1.835621>,
      < -6.652875, -0.947251, -1.985867>,
      < -6.669310, -0.947251, -1.835621>
    }
    triangle {
      < -6.687484, -0.931251, -1.669469>,
      < -6.671050, -0.931251, -1.819715>,
      < -6.671050, -0.947251, -1.819715>
    }
    triangle {
      < -6.687484, -0.931251, -1.669469>,
      < -6.671050, -0.947251, -1.819715>,
      < -6.687484, -0.947251, -1.669469>
    }
    triangle {
      < -6.707397, -0.931251, -1.487412>,
      < -6.707397, -0.880072, -1.487412>,
      < -6.705658, -0.880072, -1.503317>
    }
    triangle {
      < -6.707397, -0.931251, -1.487412>,
      < -6.705658, -0.880072, -1.503317>,
      < -6.705658, -0.931251, -1.503317>
    }
    triangle {
      < -6.705658, -0.931251, -1.503317>,
      < -6.689224, -0.931251, -1.653564>,
      < -6.689224, -0.947251, -1.653564>
    }
    triangle {
      < -6.705658, -0.931251, -1.503317>,
      < -6.689224, -0.947251, -1.653564>,
      < -6.705658, -0.947251, -1.503317>
    }
    triangle {
      < -6.723832, -0.931251, -1.337166>,
      < -6.707397, -0.931251, -1.487412>,
      < -6.707397, -0.947251, -1.487412>
    }
    triangle {
      < -6.723832, -0.931251, -1.337166>,
      < -6.707397, -0.947251, -1.487412>,
      < -6.723832, -0.947251, -1.337166>
    }
    triangle {
      < -6.743745, -0.931251, -1.155109>,
      < -6.743745, -0.880072, -1.155109>,
      < -6.742006, -0.880072, -1.171014>
    }
    triangle {
      < -6.743745, -0.931251, -1.155109>,
      < -6.742006, -0.880072, -1.171014>,
      < -6.742006, -0.931251, -1.171014>
    }
    triangle {
      < -6.742006, -0.931251, -1.171014>,
      < -6.725572, -0.931251, -1.321261>,
      < -6.725572, -0.947251, -1.321261>
    }
    triangle {
      < -6.742006, -0.931251, -1.171014>,
      < -6.725572, -0.947251, -1.321261>,
      < -6.742006, -0.947251, -1.171014>
    }
    triangle {
      < -6.760180, -0.931251, -1.004863>,
      < -6.743745, -0.931251, -1.155109>,
      < -6.743745, -0.947251, -1.155109>
    }
    triangle {
      < -6.760180, -0.931251, -1.004863>,
      < -6.743745, -0.947251, -1.155109>,
      < -6.760180, -0.947251, -1.004863>
    }
    triangle {
      < -6.780094, -0.931251, -0.822806>,
      < -6.780094, -0.880072, -0.822806>,
      < -6.778354, -0.880072, -0.838711>
    }
    triangle {
      < -6.780094, -0.931251, -0.822806>,
      < -6.778354, -0.880072, -0.838711>,
      < -6.778354, -0.931251, -0.838711>
    }
    triangle {
      < -6.778354, -0.931251, -0.838711>,
      < -6.761919, -0.931251, -0.988957>,
      < -6.761919, -0.947251, -0.988957>
    }
    triangle {
      < -6.778354, -0.931251, -0.838711>,
      < -6.761919, -0.947251, -0.988957>,
      < -6.778354, -0.947251, -0.838711>
    }
    triangle {
      < -6.796528, -0.931251, -0.672559>,
      < -6.780094, -0.931251, -0.822806>,
      < -6.780094, -0.947251, -0.822806>
    }
    triangle {
      < -6.796528, -0.931251, -0.672559>,
      < -6.780094, -0.947251, -0.822806>,
      < -6.796528, -0.947251, -0.672559>
    }
    triangle {
      < -6.816442, -0.931251, -0.490502>,
      < -6.816442, -0.880072, -0.490502>,
      < -6.814702, -0.880072, -0.506407>
    }
    triangle {
      < -6.816442, -0.931251, -0.490502>,
      < -6.814702, -0.880072, -0.506407>,
      < -6.814702, -0.931251, -0.506407>
    }
    triangle {
      < -6.814702, -0.931251, -0.506407>,
      < -6.798267, -0.931251, -0.656654>,
      < -6.798267, -0.947251, -0.656654>
    }
    triangle {
      < -6.814702, -0.931251, -0.506407>,
      < -6.798267, -0.947251, -0.656654>,
      < -6.814702, -0.947251, -0.506407>
    }
    triangle {
      < -6.832876, -0.931251, -0.340256>,
      < -6.816442, -0.931251, -0.490502>,
      < -6.816442, -0.947251, -0.490502>
    }
    triangle {
      < -6.832876, -0.931251, -0.340256>,
      < -6.816442, -0.947251, -0.490502>,
      < -6.832876, -0.947251, -0.340256>
    }
    triangle {
      < -6.852789, -0.931251, -0.158199>,
      < -6.852789, -0.880072, -0.158199>,
      < -6.851050, -0.880072, -0.174104>
    }
    triangle {
      < -6.852789, -0.931251, -0.158199>,
      < -6.851050, -0.880072, -0.174104>,
      < -6.851050, -0.931251, -0.174104>
    }
    triangle {
      < -6.851050, -0.931251, -0.174104>,
      < -6.834615, -0.931251, -0.324351>,
      < -6.834615, -0.947251, -0.324351>
    }
    triangle {
      < -6.851050, -0.931251, -0.174104>,
      < -6.834615, -0.947251, -0.324351>,
      < -6.851050, -0.947251, -0.174104>
    }
    triangle {
      < -6.832877, -0.931251, 0.340256>,
      < -6.832877, -0.880072, 0.340256>,
      < -6.834616, -0.880072, 0.324351>
    }
    triangle {
      < -6.832877, -0.931251, 0.340256>,
      < -6.834616, -0.880072, 0.324351>,
      < -6.834616, -0.931251, 0.324351>
    }
    triangle {
      < -6.834616, -0.931251, 0.324351>,
      < -6.851051, -0.931251, 0.174104>,
      < -6.851051, -0.947251, 0.174104>
    }
    triangle {
      < -6.834616, -0.931251, 0.324351>,
      < -6.851051, -0.947251, 0.174104>,
      < -6.834616, -0.947251, 0.324351>
    }
    triangle {
      < -6.816443, -0.931251, 0.490502>,
      < -6.832877, -0.931251, 0.340256>,
      < -6.832877, -0.947251, 0.340256>
    }
    triangle {
      < -6.816443, -0.931251, 0.490502>,
      < -6.832877, -0.947251, 0.340256>,
      < -6.816443, -0.947251, 0.490502>
    }
    triangle {
      < -6.796529, -0.931251, 0.672559>,
      < -6.796529, -0.880072, 0.672559>,
      < -6.798269, -0.880072, 0.656654>
    }
    triangle {
      < -6.796529, -0.931251, 0.672559>,
      < -6.798269, -0.880072, 0.656654>,
      < -6.798269, -0.931251, 0.656654>
    }
    triangle {
      < -6.798269, -0.931251, 0.656654>,
      < -6.814703, -0.931251, 0.506407>,
      < -6.814703, -0.947251, 0.506407>
    }
    triangle {
      < -6.798269, -0.931251, 0.656654>,
      < -6.814703, -0.947251, 0.506407>,
      < -6.798269, -0.947251, 0.656654>
    }
    triangle {
      < -6.780095, -0.931251, 0.822805>,
      < -6.796529, -0.931251, 0.672559>,
      < -6.796529, -0.947251, 0.672559>
    }
    triangle {
      < -6.780095, -0.931251, 0.822805>,
      < -6.796529, -0.947251, 0.672559>,
      < -6.780095, -0.947251, 0.822805>
    }
    triangle {
      < -6.760181, -0.931251, 1.004862>,
      < -6.760181, -0.880072, 1.004862>,
      < -6.761921, -0.880072, 0.988957>
    }
    triangle {
      < -6.760181, -0.931251, 1.004862>,
      < -6.761921, -0.880072, 0.988957>,
      < -6.761921, -0.931251, 0.988957>
    }
    triangle {
      < -6.761921, -0.931251, 0.988957>,
      < -6.778356, -0.931251, 0.838711>,
      < -6.778356, -0.947251, 0.838711>
    }
    triangle {
      < -6.761921, -0.931251, 0.988957>,
      < -6.778356, -0.947251, 0.838711>,
      < -6.761921, -0.947251, 0.988957>
    }
    triangle {
      < -6.743747, -0.931251, 1.155109>,
      < -6.760181, -0.931251, 1.004862>,
      < -6.760181, -0.947251, 1.004862>
    }
    triangle {
      < -6.743747, -0.931251, 1.155109>,
      < -6.760181, -0.947251, 1.004862>,
      < -6.743747, -0.947251, 1.155109>
    }
    triangle {
      < -6.723834, -0.931251, 1.337166>,
      < -6.723834, -0.880072, 1.337165>,
      < -6.725573, -0.880072, 1.321260>
    }
    triangle {
      < -6.723834, -0.931251, 1.337166>,
      < -6.725573, -0.880072, 1.321260>,
      < -6.725573, -0.931251, 1.321260>
    }
    triangle {
      < -6.725573, -0.931251, 1.321260>,
      < -6.742008, -0.931251, 1.171014>,
      < -6.742008, -0.947251, 1.171014>
    }
    triangle {
      < -6.725573, -0.931251, 1.321260>,
      < -6.742008, -0.947251, 1.171014>,
      < -6.725573, -0.947251, 1.321260>
    }
    triangle {
      < -6.707399, -0.931251, 1.487412>,
      < -6.723834, -0.931251, 1.337166>,
      < -6.723834, -0.947251, 1.337166>
    }
    triangle {
      < -6.707399, -0.931251, 1.487412>,
      < -6.723834, -0.947251, 1.337166>,
      < -6.707399, -0.947251, 1.487412>
    }
    triangle {
      < -6.687486, -0.931251, 1.669469>,
      < -6.687486, -0.880072, 1.669469>,
      < -6.689225, -0.880072, 1.653563>
    }
    triangle {
      < -6.687486, -0.931251, 1.669469>,
      < -6.689225, -0.880072, 1.653563>,
      < -6.689225, -0.931251, 1.653563>
    }
    triangle {
      < -6.689225, -0.931251, 1.653563>,
      < -6.705659, -0.931251, 1.503317>,
      < -6.705659, -0.947251, 1.503317>
    }
    triangle {
      < -6.689225, -0.931251, 1.653563>,
      < -6.705659, -0.947251, 1.503317>,
      < -6.689225, -0.947251, 1.653563>
    }
    triangle {
      < -6.671051, -0.931251, 1.819715>,
      < -6.687486, -0.931251, 1.669469>,
      < -6.687486, -0.947251, 1.669469>
    }
    triangle {
      < -6.671051, -0.931251, 1.819715>,
      < -6.687486, -0.947251, 1.669469>,
      < -6.671051, -0.947251, 1.819715>
    }
    triangle {
      < -6.651138, -0.931251, 2.001772>,
      < -6.651138, -0.880072, 2.001772>,
      < -6.652877, -0.880072, 1.985867>
    }
    triangle {
      < -6.651138, -0.931251, 2.001772>,
      < -6.652877, -0.880072, 1.985867>,
      < -6.652877, -0.931251, 1.985867>
    }
    triangle {
      < -6.652877, -0.931251, 1.985867>,
      < -6.669312, -0.931251, 1.835620>,
      < -6.669312, -0.947251, 1.835620>
    }
    triangle {
      < -6.652877, -0.931251, 1.985867>,
      < -6.669312, -0.947251, 1.835620>,
      < -6.652877, -0.947251, 1.985867>
    }
    triangle {
      < -6.634703, -0.931251, 2.152019>,
      < -6.651138, -0.931251, 2.001772>,
      < -6.651138, -0.947251, 2.001772>
    }
    triangle {
      < -6.634703, -0.931251, 2.152019>,
      < -6.651138, -0.947251, 2.001772>,
      < -6.634703, -0.947251, 2.152019>
    }
    triangle {
      < -6.614789, -0.931251, 2.334075>,
      < -6.614789, -0.880072, 2.334075>,
      < -6.616529, -0.880072, 2.318170>
    }
    triangle {
      < -6.614789, -0.931251, 2.334075>,
      < -6.616529, -0.880072, 2.318170>,
      < -6.616529, -0.931251, 2.318170>
    }
    triangle {
      < -6.616529, -0.931251, 2.318170>,
      < -6.632964, -0.931251, 2.167924>,
      < -6.632964, -0.947251, 2.167924>
    }
    triangle {
      < -6.616529, -0.931251, 2.318170>,
      < -6.632964, -0.947251, 2.167924>,
      < -6.616529, -0.947251, 2.318170>
    }
    triangle {
      < -6.598355, -0.931251, 2.484322>,
      < -6.614789, -0.931251, 2.334075>,
      < -6.614789, -0.947251, 2.334075>
    }
    triangle {
      < -6.598355, -0.931251, 2.484322>,
      < -6.614789, -0.947251, 2.334075>,
      < -6.598355, -0.947251, 2.484322>
    }
    triangle {
      < -6.614789, -0.880072, -2.334075>,
      < -6.614789, -0.931251, -2.334075>,
      < -6.616529, -0.931251, -2.318170>
    }
    triangle {
      < -6.614789, -0.880072, -2.334075>,
      < -6.616529, -0.931251, -2.318170>,
      < -6.616529, -0.880072, -2.318170>
    }
    triangle {
      < -6.651136, -0.880072, -2.001772>,
      < -6.651136, -0.931251, -2.001772>,
      < -6.652875, -0.931251, -1.985867>
    }
    triangle {
      < -6.651136, -0.880072, -2.001772>,
      < -6.652875, -0.931251, -1.985867>,
      < -6.652875, -0.880072, -1.985867>
    }
    triangle {
      < -6.687484, -0.880072, -1.669469>,
      < -6.687484, -0.931251, -1.669469>,
      < -6.689224, -0.931251, -1.653564>
    }
    triangle {
      < -6.687484, -0.880072, -1.669469>,
      < -6.689224, -0.931251, -1.653564>,
      < -6.689224, -0.880072, -1.653564>
    }
    triangle {
      < -6.723832, -0.880072, -1.337166>,
      < -6.723832, -0.931251, -1.337166>,
      < -6.725572, -0.931251, -1.321261>
    }
    triangle {
      < -6.723832, -0.880072, -1.337166>,
      < -6.725572, -0.931251, -1.321261>,
      < -6.725572, -0.880072, -1.321261>
    }
    triangle {
      < -6.760180, -0.880072, -1.004863>,
      < -6.760180, -0.931251, -1.004863>,
      < -6.761919, -0.931251, -0.988957>
    }
    triangle {
      < -6.760180, -0.880072, -1.004863>,
      < -6.761919, -0.931251, -0.988957>,
      < -6.761919, -0.880072, -0.988957>
    }
    triangle {
      < -6.796528, -0.880072, -0.672559>,
      < -6.796528, -0.931251, -0.672559>,
      < -6.798267, -0.931251, -0.656654>
    }
    triangle {
      < -6.796528, -0.880072, -0.672559>,
      < -6.798267, -0.931251, -0.656654>,
      < -6.798267, -0.880072, -0.656654>
    }
    triangle {
      < -6.832876, -0.880072, -0.340256>,
      < -6.832876, -0.931251, -0.340256>,
      < -6.834615, -0.931251, -0.324351>
    }
    triangle {
      < -6.832876, -0.880072, -0.340256>,
      < -6.834615, -0.931251, -0.324351>,
      < -6.834615, -0.880072, -0.324351>
    }
    triangle {
      < -6.852790, -0.880072, 0.158199>,
      < -6.852790, -0.931251, 0.158199>,
      < -6.851051, -0.931251, 0.174104>
    }
    triangle {
      < -6.852790, -0.880072, 0.158199>,
      < -6.851051, -0.931251, 0.174104>,
      < -6.851051, -0.880072, 0.174104>
    }
    triangle {
      < -6.816443, -0.880072, 0.490502>,
      < -6.816443, -0.931251, 0.490502>,
      < -6.814703, -0.931251, 0.506407>
    }
    triangle {
      < -6.816443, -0.880072, 0.490502>,
      < -6.814703, -0.931251, 0.506407>,
      < -6.814703, -0.880072, 0.506407>
    }
    triangle {
      < -6.780095, -0.880072, 0.822805>,
      < -6.780095, -0.931251, 0.822805>,
      < -6.778356, -0.931251, 0.838711>
    }
    triangle {
      < -6.780095, -0.880072, 0.822805>,
      < -6.778356, -0.931251, 0.838711>,
      < -6.778356, -0.880072, 0.838711>
    }
    triangle {
      < -6.743747, -0.880072, 1.155109>,
      < -6.743747, -0.931251, 1.155109>,
      < -6.742008, -0.931251, 1.171014>
    }
    triangle {
      < -6.743747, -0.880072, 1.155109>,
      < -6.742008, -0.931251, 1.171014>,
      < -6.742008, -0.880072, 1.171014>
    }
    triangle {
      < -6.707399, -0.880072, 1.487412>,
      < -6.707399, -0.931251, 1.487412>,
      < -6.705659, -0.931251, 1.503317>
    }
    triangle {
      < -6.707399, -0.880072, 1.487412>,
      < -6.705659, -0.931251, 1.503317>,
      < -6.705659, -0.880072, 1.503317>
    }
    triangle {
      < -6.671051, -0.880072, 1.819715>,
      < -6.671051, -0.931251, 1.819715>,
      < -6.669312, -0.931251, 1.835620>
    }
    triangle {
      < -6.671051, -0.880072, 1.819715>,
      < -6.669312, -0.931251, 1.835620>,
      < -6.669312, -0.880072, 1.835620>
    }
    triangle {
      < -6.634703, -0.880072, 2.152019>,
      < -6.634703, -0.931251, 2.152019>,
      < -6.632964, -0.931251, 2.167924>
    }
    triangle {
      < -6.634703, -0.880072, 2.152019>,
      < -6.632964, -0.931251, 2.167924>,
      < -6.632964, -0.880072, 2.167924>
    }
    triangle {
      < -6.580181, -0.931251, 2.650474>,
      < -6.596616, -0.931251, 2.500227>,
      < -6.596616, -0.947251, 2.500227>
    }
    triangle {
      < -6.580181, -0.931251, 2.650474>,
      < -6.596616, -0.947251, 2.500227>,
      < -6.580181, -0.947251, 2.650474>
    }
    triangle {
      < -6.598355, -0.880072, 2.484322>,
      < -6.598355, -0.931251, 2.484322>,
      < -6.596616, -0.931251, 2.500227>
    }
    triangle {
      < -6.598355, -0.880072, 2.484322>,
      < -6.596616, -0.931251, 2.500227>,
      < -6.596616, -0.880072, 2.500227>
    }
    triangle {
      < -6.869224, -0.864072, 0.007953>,
      < -6.869224, -0.812893, 0.007953>,
      < -6.869224, -0.812893, -0.007953>
    }
    triangle {
      < -6.869224, -0.864072, 0.007953>,
      < -6.869224, -0.812893, -0.007953>,
      < -6.869224, -0.864072, -0.007953>
    }
    triangle {
      < -6.869224, -0.864072, -0.007953>,
      < -6.852789, -0.864072, -0.158199>,
      < -6.852789, -0.880072, -0.158199>
    }
    triangle {
      < -6.869224, -0.864072, -0.007953>,
      < -6.852789, -0.880072, -0.158199>,
      < -6.869224, -0.880072, -0.007953>
    }
    triangle {
      < -6.852790, -0.864072, 0.158199>,
      < -6.869224, -0.864072, 0.007953>,
      < -6.869224, -0.880072, 0.007953>
    }
    triangle {
      < -6.852790, -0.864072, 0.158199>,
      < -6.869224, -0.880072, 0.007953>,
      < -6.852790, -0.880072, 0.158199>
    }
    triangle {
      < -6.580181, -0.864072, -2.650473>,
      < -6.580181, -0.812893, -2.650473>,
      < -6.571311, -0.804893, -2.658426>
    }
    triangle {
      < -6.580181, -0.864072, -2.650473>,
      < -6.571311, -0.804893, -2.658426>,
      < -6.571311, -0.872072, -2.658426>
    }
    triangle {
      < -6.596615, -0.864072, -2.500227>,
      < -6.580181, -0.864072, -2.650473>,
      < -6.580181, -0.880072, -2.650473>
    }
    triangle {
      < -6.596615, -0.864072, -2.500227>,
      < -6.580181, -0.880072, -2.650473>,
      < -6.596615, -0.880072, -2.500227>
    }
    triangle {
      < -6.598354, -0.864072, -2.484322>,
      < -6.598354, -0.812893, -2.484322>,
      < -6.596615, -0.812893, -2.500227>
    }
    triangle {
      < -6.598354, -0.864072, -2.484322>,
      < -6.596615, -0.812893, -2.500227>,
      < -6.596615, -0.864072, -2.500227>
    }
    triangle {
      < -6.614789, -0.864072, -2.334075>,
      < -6.598354, -0.864072, -2.484322>,
      < -6.598354, -0.880072, -2.484322>
    }
    triangle {
      < -6.614789, -0.864072, -2.334075>,
      < -6.598354, -0.880072, -2.484322>,
      < -6.614789, -0.880072, -2.334075>
    }
    triangle {
      < -6.634702, -0.864072, -2.152019>,
      < -6.634702, -0.812893, -2.152019>,
      < -6.632962, -0.812893, -2.167924>
    }
    triangle {
      < -6.634702, -0.864072, -2.152019>,
      < -6.632962, -0.812893, -2.167924>,
      < -6.632962, -0.864072, -2.167924>
    }
    triangle {
      < -6.632962, -0.864072, -2.167924>,
      < -6.616529, -0.864072, -2.318170>,
      < -6.616529, -0.880072, -2.318170>
    }
    triangle {
      < -6.632962, -0.864072, -2.167924>,
      < -6.616529, -0.880072, -2.318170>,
      < -6.632962, -0.880072, -2.167924>
    }
    triangle {
      < -6.651136, -0.864072, -2.001772>,
      < -6.634702, -0.864072, -2.152019>,
      < -6.634702, -0.880072, -2.152019>
    }
    triangle {
      < -6.651136, -0.864072, -2.001772>,
      < -6.634702, -0.880072, -2.152019>,
      < -6.651136, -0.880072, -2.001772>
    }
    triangle {
      < -6.671050, -0.864072, -1.819715>,
      < -6.671050, -0.812893, -1.819715>,
      < -6.669310, -0.812893, -1.835621>
    }
    triangle {
      < -6.671050, -0.864072, -1.819715>,
      < -6.669310, -0.812893, -1.835621>,
      < -6.669310, -0.864072, -1.835621>
    }
    triangle {
      < -6.669310, -0.864072, -1.835621>,
      < -6.652875, -0.864072, -1.985867>,
      < -6.652875, -0.880072, -1.985867>
    }
    triangle {
      < -6.669310, -0.864072, -1.835621>,
      < -6.652875, -0.880072, -1.985867>,
      < -6.669310, -0.880072, -1.835621>
    }
    triangle {
      < -6.687484, -0.864072, -1.669469>,
      < -6.671050, -0.864072, -1.819715>,
      < -6.671050, -0.880072, -1.819715>
    }
    triangle {
      < -6.687484, -0.864072, -1.669469>,
      < -6.671050, -0.880072, -1.819715>,
      < -6.687484, -0.880072, -1.669469>
    }
    triangle {
      < -6.707397, -0.864072, -1.487412>,
      < -6.707397, -0.812893, -1.487412>,
      < -6.705658, -0.812893, -1.503317>
    }
    triangle {
      < -6.707397, -0.864072, -1.487412>,
      < -6.705658, -0.812893, -1.503317>,
      < -6.705658, -0.864072, -1.503317>
    }
    triangle {
      < -6.705658, -0.864072, -1.503317>,
      < -6.689224, -0.864072, -1.653564>,
      < -6.689224, -0.880072, -1.653564>
    }
    triangle {
      < -6.705658, -0.864072, -1.503317>,
      < -6.689224, -0.880072, -1.653564>,
      < -6.705658, -0.880072, -1.503317>
    }
    triangle {
      < -6.723832, -0.864072, -1.337166>,
      < -6.707397, -0.864072, -1.487412>,
      < -6.707397, -0.880072, -1.487412>
    }
    triangle {
      < -6.723832, -0.864072, -1.337166>,
      < -6.707397, -0.880072, -1.487412>,
      < -6.723832, -0.880072, -1.337166>
    }
    triangle {
      < -6.743745, -0.864072, -1.155109>,
      < -6.743745, -0.812893, -1.155109>,
      < -6.742006, -0.812893, -1.171014>
    }
    triangle {
      < -6.743745, -0.864072, -1.155109>,
      < -6.742006, -0.812893, -1.171014>,
      < -6.742006, -0.864072, -1.171014>
    }
    triangle {
      < -6.742006, -0.864072, -1.171014>,
      < -6.725572, -0.864072, -1.321261>,
      < -6.725572, -0.880072, -1.321261>
    }
    triangle {
      < -6.742006, -0.864072, -1.171014>,
      < -6.725572, -0.880072, -1.321261>,
      < -6.742006, -0.880072, -1.171014>
    }
    triangle {
      < -6.760180, -0.864072, -1.004863>,
      < -6.743745, -0.864072, -1.155109>,
      < -6.743745, -0.880072, -1.155109>
    }
    triangle {
      < -6.760180, -0.864072, -1.004863>,
      < -6.743745, -0.880072, -1.155109>,
      < -6.760180, -0.880072, -1.004863>
    }
    triangle {
      < -6.780094, -0.864072, -0.822806>,
      < -6.780094, -0.812893, -0.822806>,
      < -6.778354, -0.812893, -0.838711>
    }
    triangle {
      < -6.780094, -0.864072, -0.822806>,
      < -6.778354, -0.812893, -0.838711>,
      < -6.778354, -0.864072, -0.838711>
    }
    triangle {
      < -6.778354, -0.864072, -0.838711>,
      < -6.761919, -0.864072, -0.988957>,
      < -6.761919, -0.880072, -0.988957>
    }
    triangle {
      < -6.778354, -0.864072, -0.838711>,
      < -6.761919, -0.880072, -0.988957>,
      < -6.778354, -0.880072, -0.838711>
    }
    triangle {
      < -6.796528, -0.864072, -0.672559>,
      < -6.780094, -0.864072, -0.822806>,
      < -6.780094, -0.880072, -0.822806>
    }
    triangle {
      < -6.796528, -0.864072, -0.672559>,
      < -6.780094, -0.880072, -0.822806>,
      < -6.796528, -0.880072, -0.672559>
    }
    triangle {
      < -6.816442, -0.864072, -0.490502>,
      < -6.816442, -0.812893, -0.490502>,
      < -6.814702, -0.812893, -0.506407>
    }
    triangle {
      < -6.816442, -0.864072, -0.490502>,
      < -6.814702, -0.812893, -0.506407>,
      < -6.814702, -0.864072, -0.506407>
    }
    triangle {
      < -6.814702, -0.864072, -0.506407>,
      < -6.798267, -0.864072, -0.656654>,
      < -6.798267, -0.880072, -0.656654>
    }
    triangle {
      < -6.814702, -0.864072, -0.506407>,
      < -6.798267, -0.880072, -0.656654>,
      < -6.814702, -0.880072, -0.506407>
    }
    triangle {
      < -6.832876, -0.864072, -0.340256>,
      < -6.816442, -0.864072, -0.490502>,
      < -6.816442, -0.880072, -0.490502>
    }
    triangle {
      < -6.832876, -0.864072, -0.340256>,
      < -6.816442, -0.880072, -0.490502>,
      < -6.832876, -0.880072, -0.340256>
    }
    triangle {
      < -6.852789, -0.864072, -0.158199>,
      < -6.852789, -0.812893, -0.158199>,
      < -6.851050, -0.812893, -0.174104>
    }
    triangle {
      < -6.852789, -0.864072, -0.158199>,
      < -6.851050, -0.812893, -0.174104>,
      < -6.851050, -0.864072, -0.174104>
    }
    triangle {
      < -6.851050, -0.864072, -0.174104>,
      < -6.834615, -0.864072, -0.324351>,
      < -6.834615, -0.880072, -0.324351>
    }
    triangle {
      < -6.851050, -0.864072, -0.174104>,
      < -6.834615, -0.880072, -0.324351>,
      < -6.851050, -0.880072, -0.174104>
    }
    triangle {
      < -6.832877, -0.864072, 0.340256>,
      < -6.832877, -0.812893, 0.340256>,
      < -6.834616, -0.812893, 0.324351>
    }
    triangle {
      < -6.832877, -0.864072, 0.340256>,
      < -6.834616, -0.812893, 0.324351>,
      < -6.834616, -0.864072, 0.324351>
    }
    triangle {
      < -6.834616, -0.864072, 0.324351>,
      < -6.851051, -0.864072, 0.174104>,
      < -6.851051, -0.880072, 0.174104>
    }
    triangle {
      < -6.834616, -0.864072, 0.324351>,
      < -6.851051, -0.880072, 0.174104>,
      < -6.834616, -0.880072, 0.324351>
    }
    triangle {
      < -6.816443, -0.864072, 0.490502>,
      < -6.832877, -0.864072, 0.340256>,
      < -6.832877, -0.880072, 0.340256>
    }
    triangle {
      < -6.816443, -0.864072, 0.490502>,
      < -6.832877, -0.880072, 0.340256>,
      < -6.816443, -0.880072, 0.490502>
    }
    triangle {
      < -6.796529, -0.864072, 0.672559>,
      < -6.796529, -0.812893, 0.672559>,
      < -6.798269, -0.812893, 0.656654>
    }
    triangle {
      < -6.796529, -0.864072, 0.672559>,
      < -6.798269, -0.812893, 0.656654>,
      < -6.798269, -0.864072, 0.656654>
    }
    triangle {
      < -6.798269, -0.864072, 0.656654>,
      < -6.814703, -0.864072, 0.506407>,
      < -6.814703, -0.880072, 0.506407>
    }
    triangle {
      < -6.798269, -0.864072, 0.656654>,
      < -6.814703, -0.880072, 0.506407>,
      < -6.798269, -0.880072, 0.656654>
    }
    triangle {
      < -6.780095, -0.864072, 0.822805>,
      < -6.796529, -0.864072, 0.672559>,
      < -6.796529, -0.880072, 0.672559>
    }
    triangle {
      < -6.780095, -0.864072, 0.822805>,
      < -6.796529, -0.880072, 0.672559>,
      < -6.780095, -0.880072, 0.822805>
    }
    triangle {
      < -6.760181, -0.864072, 1.004862>,
      < -6.760181, -0.812893, 1.004862>,
      < -6.761921, -0.812893, 0.988957>
    }
    triangle {
      < -6.760181, -0.864072, 1.004862>,
      < -6.761921, -0.812893, 0.988957>,
      < -6.761921, -0.864072, 0.988957>
    }
    triangle {
      < -6.761921, -0.864072, 0.988957>,
      < -6.778356, -0.864072, 0.838711>,
      < -6.778356, -0.880072, 0.838711>
    }
    triangle {
      < -6.761921, -0.864072, 0.988957>,
      < -6.778356, -0.880072, 0.838711>,
      < -6.761921, -0.880072, 0.988957>
    }
    triangle {
      < -6.743747, -0.864072, 1.155109>,
      < -6.760181, -0.864072, 1.004862>,
      < -6.760181, -0.880072, 1.004862>
    }
    triangle {
      < -6.743747, -0.864072, 1.155109>,
      < -6.760181, -0.880072, 1.004862>,
      < -6.743747, -0.880072, 1.155109>
    }
    triangle {
      < -6.723834, -0.864072, 1.337165>,
      < -6.723834, -0.812893, 1.337165>,
      < -6.725573, -0.812893, 1.321260>
    }
    triangle {
      < -6.723834, -0.864072, 1.337165>,
      < -6.725573, -0.812893, 1.321260>,
      < -6.725573, -0.864072, 1.321260>
    }
    triangle {
      < -6.725573, -0.864072, 1.321260>,
      < -6.742008, -0.864072, 1.171014>,
      < -6.742008, -0.880072, 1.171014>
    }
    triangle {
      < -6.725573, -0.864072, 1.321260>,
      < -6.742008, -0.880072, 1.171014>,
      < -6.725573, -0.880072, 1.321260>
    }
    triangle {
      < -6.707399, -0.864072, 1.487412>,
      < -6.723834, -0.864072, 1.337165>,
      < -6.723834, -0.880072, 1.337165>
    }
    triangle {
      < -6.707399, -0.864072, 1.487412>,
      < -6.723834, -0.880072, 1.337165>,
      < -6.707399, -0.880072, 1.487412>
    }
    triangle {
      < -6.687486, -0.864072, 1.669469>,
      < -6.687486, -0.812893, 1.669469>,
      < -6.689225, -0.812893, 1.653563>
    }
    triangle {
      < -6.687486, -0.864072, 1.669469>,
      < -6.689225, -0.812893, 1.653563>,
      < -6.689225, -0.864072, 1.653563>
    }
    triangle {
      < -6.689225, -0.864072, 1.653563>,
      < -6.705659, -0.864072, 1.503317>,
      < -6.705659, -0.880072, 1.503317>
    }
    triangle {
      < -6.689225, -0.864072, 1.653563>,
      < -6.705659, -0.880072, 1.503317>,
      < -6.689225, -0.880072, 1.653563>
    }
    triangle {
      < -6.671051, -0.864072, 1.819715>,
      < -6.687486, -0.864072, 1.669469>,
      < -6.687486, -0.880072, 1.669469>
    }
    triangle {
      < -6.671051, -0.864072, 1.819715>,
      < -6.687486, -0.880072, 1.669469>,
      < -6.671051, -0.880072, 1.819715>
    }
    triangle {
      < -6.651138, -0.864072, 2.001772>,
      < -6.651138, -0.812893, 2.001772>,
      < -6.652877, -0.812893, 1.985867>
    }
    triangle {
      < -6.651138, -0.864072, 2.001772>,
      < -6.652877, -0.812893, 1.985867>,
      < -6.652877, -0.864072, 1.985867>
    }
    triangle {
      < -6.652877, -0.864072, 1.985867>,
      < -6.669312, -0.864072, 1.835620>,
      < -6.669312, -0.880072, 1.835620>
    }
    triangle {
      < -6.652877, -0.864072, 1.985867>,
      < -6.669312, -0.880072, 1.835620>,
      < -6.652877, -0.880072, 1.985867>
    }
    triangle {
      < -6.634703, -0.864072, 2.152019>,
      < -6.651138, -0.864072, 2.001772>,
      < -6.651138, -0.880072, 2.001772>
    }
    triangle {
      < -6.634703, -0.864072, 2.152019>,
      < -6.651138, -0.880072, 2.001772>,
      < -6.634703, -0.880072, 2.152019>
    }
    triangle {
      < -6.614789, -0.864072, 2.334075>,
      < -6.614789, -0.812893, 2.334075>,
      < -6.616529, -0.812893, 2.318170>
    }
    triangle {
      < -6.614789, -0.864072, 2.334075>,
      < -6.616529, -0.812893, 2.318170>,
      < -6.616529, -0.864072, 2.318170>
    }
    triangle {
      < -6.616529, -0.864072, 2.318170>,
      < -6.632964, -0.864072, 2.167924>,
      < -6.632964, -0.880072, 2.167924>
    }
    triangle {
      < -6.616529, -0.864072, 2.318170>,
      < -6.632964, -0.880072, 2.167924>,
      < -6.616529, -0.880072, 2.318170>
    }
    triangle {
      < -6.598355, -0.864072, 2.484322>,
      < -6.614789, -0.864072, 2.334075>,
      < -6.614789, -0.880072, 2.334075>
    }
    triangle {
      < -6.598355, -0.864072, 2.484322>,
      < -6.614789, -0.880072, 2.334075>,
      < -6.598355, -0.880072, 2.484322>
    }
    triangle {
      < -6.580181, -0.864072, 2.650474>,
      < -6.596616, -0.864072, 2.500227>,
      < -6.596616, -0.880072, 2.500227>
    }
    triangle {
      < -6.580181, -0.864072, 2.650474>,
      < -6.596616, -0.880072, 2.500227>,
      < -6.580181, -0.880072, 2.650474>
    }
    triangle {
      < -6.598355, -0.812893, 2.484322>,
      < -6.598355, -0.864072, 2.484322>,
      < -6.596616, -0.864072, 2.500227>
    }
    triangle {
      < -6.598355, -0.812893, 2.484322>,
      < -6.596616, -0.864072, 2.500227>,
      < -6.596616, -0.812893, 2.500227>
    }
    triangle {
      < -6.634703, -0.812893, 2.152019>,
      < -6.634703, -0.864072, 2.152019>,
      < -6.632964, -0.864072, 2.167924>
    }
    triangle {
      < -6.634703, -0.812893, 2.152019>,
      < -6.632964, -0.864072, 2.167924>,
      < -6.632964, -0.812893, 2.167924>
    }
    triangle {
      < -6.671051, -0.812893, 1.819715>,
      < -6.671051, -0.864072, 1.819715>,
      < -6.669312, -0.864072, 1.835620>
    }
    triangle {
      < -6.671051, -0.812893, 1.819715>,
      < -6.669312, -0.864072, 1.835620>,
      < -6.669312, -0.812893, 1.835620>
    }
    triangle {
      < -6.707399, -0.812893, 1.487412>,
      < -6.707399, -0.864072, 1.487412>,
      < -6.705659, -0.864072, 1.503317>
    }
    triangle {
      < -6.707399, -0.812893, 1.487412>,
      < -6.705659, -0.864072, 1.503317>,
      < -6.705659, -0.812893, 1.503317>
    }
    triangle {
      < -6.743747, -0.812893, 1.155109>,
      < -6.743747, -0.864072, 1.155109>,
      < -6.742008, -0.864072, 1.171014>
    }
    triangle {
      < -6.743747, -0.812893, 1.155109>,
      < -6.742008, -0.864072, 1.171014>,
      < -6.742008, -0.812893, 1.171014>
    }
    triangle {
      < -6.780095, -0.812893, 0.822805>,
      < -6.780095, -0.864072, 0.822805>,
      < -6.778356, -0.864072, 0.838711>
    }
    triangle {
      < -6.780095, -0.812893, 0.822805>,
      < -6.778356, -0.864072, 0.838711>,
      < -6.778356, -0.812893, 0.838711>
    }
    triangle {
      < -6.816443, -0.812893, 0.490502>,
      < -6.816443, -0.864072, 0.490502>,
      < -6.814703, -0.864072, 0.506407>
    }
    triangle {
      < -6.816443, -0.812893, 0.490502>,
      < -6.814703, -0.864072, 0.506407>,
      < -6.814703, -0.812893, 0.506407>
    }
    triangle {
      < -6.852790, -0.812893, 0.158199>,
      < -6.852790, -0.864072, 0.158199>,
      < -6.851051, -0.864072, 0.174104>
    }
    triangle {
      < -6.852790, -0.812893, 0.158199>,
      < -6.851051, -0.864072, 0.174104>,
      < -6.851051, -0.812893, 0.174104>
    }
    triangle {
      < -6.832876, -0.812893, -0.340256>,
      < -6.832876, -0.864072, -0.340256>,
      < -6.834615, -0.864072, -0.324351>
    }
    triangle {
      < -6.832876, -0.812893, -0.340256>,
      < -6.834615, -0.864072, -0.324351>,
      < -6.834615, -0.812893, -0.324351>
    }
    triangle {
      < -6.796528, -0.812893, -0.672559>,
      < -6.796528, -0.864072, -0.672559>,
      < -6.798267, -0.864072, -0.656654>
    }
    triangle {
      < -6.796528, -0.812893, -0.672559>,
      < -6.798267, -0.864072, -0.656654>,
      < -6.798267, -0.812893, -0.656654>
    }
    triangle {
      < -6.760180, -0.812893, -1.004863>,
      < -6.760180, -0.864072, -1.004863>,
      < -6.761919, -0.864072, -0.988957>
    }
    triangle {
      < -6.760180, -0.812893, -1.004863>,
      < -6.761919, -0.864072, -0.988957>,
      < -6.761919, -0.812893, -0.988958>
    }
    triangle {
      < -6.723832, -0.812893, -1.337166>,
      < -6.723832, -0.864072, -1.337166>,
      < -6.725572, -0.864072, -1.321261>
    }
    triangle {
      < -6.723832, -0.812893, -1.337166>,
      < -6.725572, -0.864072, -1.321261>,
      < -6.725572, -0.812893, -1.321261>
    }
    triangle {
      < -6.687484, -0.812893, -1.669469>,
      < -6.687484, -0.864072, -1.669469>,
      < -6.689224, -0.864072, -1.653564>
    }
    triangle {
      < -6.687484, -0.812893, -1.669469>,
      < -6.689224, -0.864072, -1.653564>,
      < -6.689224, -0.812893, -1.653564>
    }
    triangle {
      < -6.651136, -0.812893, -2.001772>,
      < -6.651136, -0.864072, -2.001772>,
      < -6.652875, -0.864072, -1.985867>
    }
    triangle {
      < -6.651136, -0.812893, -2.001772>,
      < -6.652875, -0.864072, -1.985867>,
      < -6.652875, -0.812893, -1.985867>
    }
    triangle {
      < -6.614789, -0.812893, -2.334075>,
      < -6.614789, -0.864072, -2.334075>,
      < -6.616529, -0.864072, -2.318170>
    }
    triangle {
      < -6.614789, -0.812893, -2.334075>,
      < -6.616529, -0.864072, -2.318170>,
      < -6.616529, -0.812893, -2.318170>
    }
    triangle {
      < -6.869224, -0.796893, 0.007953>,
      < -6.869224, -0.745714, 0.007953>,
      < -6.869224, -0.745714, -0.007953>
    }
    triangle {
      < -6.869224, -0.796893, 0.007953>,
      < -6.869224, -0.745714, -0.007953>,
      < -6.869224, -0.796893, -0.007953>
    }
    triangle {
      < -6.869224, -0.796893, -0.007953>,
      < -6.852789, -0.796893, -0.158199>,
      < -6.852789, -0.812893, -0.158199>
    }
    triangle {
      < -6.869224, -0.796893, -0.007953>,
      < -6.852789, -0.812893, -0.158199>,
      < -6.869224, -0.812893, -0.007953>
    }
    triangle {
      < -6.852790, -0.796893, 0.158199>,
      < -6.869224, -0.796893, 0.007953>,
      < -6.869224, -0.812893, 0.007953>
    }
    triangle {
      < -6.852790, -0.796893, 0.158199>,
      < -6.869224, -0.812893, 0.007953>,
      < -6.852790, -0.812893, 0.158199>
    }
    triangle {
      < -6.580181, -0.796893, -2.650473>,
      < -6.580181, -0.745714, -2.650473>,
      < -6.571311, -0.737714, -2.658426>
    }
    triangle {
      < -6.580181, -0.796893, -2.650473>,
      < -6.571311, -0.737714, -2.658426>,
      < -6.571311, -0.804893, -2.658426>
    }
    triangle {
      < -6.596615, -0.796893, -2.500227>,
      < -6.580181, -0.796893, -2.650473>,
      < -6.580181, -0.812893, -2.650473>
    }
    triangle {
      < -6.596615, -0.796893, -2.500227>,
      < -6.580181, -0.812893, -2.650473>,
      < -6.596615, -0.812893, -2.500227>
    }
    triangle {
      < -6.598354, -0.796893, -2.484322>,
      < -6.598354, -0.745714, -2.484322>,
      < -6.596615, -0.745714, -2.500227>
    }
    triangle {
      < -6.598354, -0.796893, -2.484322>,
      < -6.596615, -0.745714, -2.500227>,
      < -6.596615, -0.796893, -2.500227>
    }
    triangle {
      < -6.614789, -0.796893, -2.334075>,
      < -6.598354, -0.796893, -2.484322>,
      < -6.598354, -0.812893, -2.484322>
    }
    triangle {
      < -6.614789, -0.796893, -2.334075>,
      < -6.598354, -0.812893, -2.484322>,
      < -6.614789, -0.812893, -2.334075>
    }
    triangle {
      < -6.634702, -0.796893, -2.152019>,
      < -6.634702, -0.745714, -2.152019>,
      < -6.632962, -0.745714, -2.167924>
    }
    triangle {
      < -6.634702, -0.796893, -2.152019>,
      < -6.632962, -0.745714, -2.167924>,
      < -6.632962, -0.796893, -2.167924>
    }
    triangle {
      < -6.632962, -0.796893, -2.167924>,
      < -6.616529, -0.796893, -2.318170>,
      < -6.616529, -0.812893, -2.318170>
    }
    triangle {
      < -6.632962, -0.796893, -2.167924>,
      < -6.616529, -0.812893, -2.318170>,
      < -6.632962, -0.812893, -2.167924>
    }
    triangle {
      < -6.651136, -0.796893, -2.001772>,
      < -6.634702, -0.796893, -2.152019>,
      < -6.634702, -0.812893, -2.152019>
    }
    triangle {
      < -6.651136, -0.796893, -2.001772>,
      < -6.634702, -0.812893, -2.152019>,
      < -6.651136, -0.812893, -2.001772>
    }
    triangle {
      < -6.671050, -0.796893, -1.819715>,
      < -6.671050, -0.745714, -1.819715>,
      < -6.669310, -0.745714, -1.835621>
    }
    triangle {
      < -6.671050, -0.796893, -1.819715>,
      < -6.669310, -0.745714, -1.835621>,
      < -6.669310, -0.796893, -1.835621>
    }
    triangle {
      < -6.669310, -0.796893, -1.835621>,
      < -6.652875, -0.796893, -1.985867>,
      < -6.652875, -0.812893, -1.985867>
    }
    triangle {
      < -6.669310, -0.796893, -1.835621>,
      < -6.652875, -0.812893, -1.985867>,
      < -6.669310, -0.812893, -1.835621>
    }
    triangle {
      < -6.687484, -0.796893, -1.669469>,
      < -6.671050, -0.796893, -1.819715>,
      < -6.671050, -0.812893, -1.819715>
    }
    triangle {
      < -6.687484, -0.796893, -1.669469>,
      < -6.671050, -0.812893, -1.819715>,
      < -6.687484, -0.812893, -1.669469>
    }
    triangle {
      < -6.707397, -0.796893, -1.487412>,
      < -6.707397, -0.745714, -1.487412>,
      < -6.705658, -0.745714, -1.503317>
    }
    triangle {
      < -6.707397, -0.796893, -1.487412>,
      < -6.705658, -0.745714, -1.503317>,
      < -6.705658, -0.796893, -1.503317>
    }
    triangle {
      < -6.705658, -0.796893, -1.503317>,
      < -6.689224, -0.796893, -1.653564>,
      < -6.689224, -0.812893, -1.653564>
    }
    triangle {
      < -6.705658, -0.796893, -1.503317>,
      < -6.689224, -0.812893, -1.653564>,
      < -6.705658, -0.812893, -1.503317>
    }
    triangle {
      < -6.723832, -0.796893, -1.337166>,
      < -6.707397, -0.796893, -1.487412>,
      < -6.707397, -0.812893, -1.487412>
    }
    triangle {
      < -6.723832, -0.796893, -1.337166>,
      < -6.707397, -0.812893, -1.487412>,
      < -6.723832, -0.812893, -1.337166>
    }
    triangle {
      < -6.743745, -0.796893, -1.155109>,
      < -6.743745, -0.745714, -1.155109>,
      < -6.742006, -0.745714, -1.171014>
    }
    triangle {
      < -6.743745, -0.796893, -1.155109>,
      < -6.742006, -0.745714, -1.171014>,
      < -6.742006, -0.796893, -1.171014>
    }
    triangle {
      < -6.742006, -0.796893, -1.171014>,
      < -6.725572, -0.796893, -1.321261>,
      < -6.725572, -0.812893, -1.321261>
    }
    triangle {
      < -6.742006, -0.796893, -1.171014>,
      < -6.725572, -0.812893, -1.321261>,
      < -6.742006, -0.812893, -1.171014>
    }
    triangle {
      < -6.760180, -0.796893, -1.004863>,
      < -6.743745, -0.796893, -1.155109>,
      < -6.743745, -0.812893, -1.155109>
    }
    triangle {
      < -6.760180, -0.796893, -1.004863>,
      < -6.743745, -0.812893, -1.155109>,
      < -6.760180, -0.812893, -1.004863>
    }
    triangle {
      < -6.780094, -0.796893, -0.822806>,
      < -6.780094, -0.745714, -0.822806>,
      < -6.778354, -0.745714, -0.838711>
    }
    triangle {
      < -6.780094, -0.796893, -0.822806>,
      < -6.778354, -0.745714, -0.838711>,
      < -6.778354, -0.796893, -0.838711>
    }
    triangle {
      < -6.778354, -0.796893, -0.838711>,
      < -6.761919, -0.796893, -0.988958>,
      < -6.761919, -0.812893, -0.988958>
    }
    triangle {
      < -6.778354, -0.796893, -0.838711>,
      < -6.761919, -0.812893, -0.988958>,
      < -6.778354, -0.812893, -0.838711>
    }
    triangle {
      < -6.796528, -0.796893, -0.672559>,
      < -6.780094, -0.796893, -0.822806>,
      < -6.780094, -0.812893, -0.822806>
    }
    triangle {
      < -6.796528, -0.796893, -0.672559>,
      < -6.780094, -0.812893, -0.822806>,
      < -6.796528, -0.812893, -0.672559>
    }
    triangle {
      < -6.816442, -0.796893, -0.490502>,
      < -6.816442, -0.745714, -0.490502>,
      < -6.814702, -0.745714, -0.506407>
    }
    triangle {
      < -6.816442, -0.796893, -0.490502>,
      < -6.814702, -0.745714, -0.506407>,
      < -6.814702, -0.796893, -0.506407>
    }
    triangle {
      < -6.814702, -0.796893, -0.506407>,
      < -6.798267, -0.796893, -0.656654>,
      < -6.798267, -0.812893, -0.656654>
    }
    triangle {
      < -6.814702, -0.796893, -0.506407>,
      < -6.798267, -0.812893, -0.656654>,
      < -6.814702, -0.812893, -0.506407>
    }
    triangle {
      < -6.832876, -0.796893, -0.340256>,
      < -6.816442, -0.796893, -0.490502>,
      < -6.816442, -0.812893, -0.490502>
    }
    triangle {
      < -6.832876, -0.796893, -0.340256>,
      < -6.816442, -0.812893, -0.490502>,
      < -6.832876, -0.812893, -0.340256>
    }
    triangle {
      < -6.852789, -0.796893, -0.158199>,
      < -6.852789, -0.745714, -0.158199>,
      < -6.851050, -0.745714, -0.174104>
    }
    triangle {
      < -6.852789, -0.796893, -0.158199>,
      < -6.851050, -0.745714, -0.174104>,
      < -6.851050, -0.796893, -0.174104>
    }
    triangle {
      < -6.851050, -0.796893, -0.174104>,
      < -6.834615, -0.796893, -0.324351>,
      < -6.834615, -0.812893, -0.324351>
    }
    triangle {
      < -6.851050, -0.796893, -0.174104>,
      < -6.834615, -0.812893, -0.324351>,
      < -6.851050, -0.812893, -0.174104>
    }
    triangle {
      < -6.832877, -0.796893, 0.340256>,
      < -6.832877, -0.745714, 0.340256>,
      < -6.834616, -0.745714, 0.324351>
    }
    triangle {
      < -6.832877, -0.796893, 0.340256>,
      < -6.834616, -0.745714, 0.324351>,
      < -6.834616, -0.796893, 0.324351>
    }
    triangle {
      < -6.834616, -0.796893, 0.324351>,
      < -6.851051, -0.796893, 0.174104>,
      < -6.851051, -0.812893, 0.174104>
    }
    triangle {
      < -6.834616, -0.796893, 0.324351>,
      < -6.851051, -0.812893, 0.174104>,
      < -6.834616, -0.812893, 0.324351>
    }
    triangle {
      < -6.816443, -0.796893, 0.490502>,
      < -6.832877, -0.796893, 0.340256>,
      < -6.832877, -0.812893, 0.340256>
    }
    triangle {
      < -6.816443, -0.796893, 0.490502>,
      < -6.832877, -0.812893, 0.340256>,
      < -6.816443, -0.812893, 0.490502>
    }
    triangle {
      < -6.796529, -0.796893, 0.672559>,
      < -6.796529, -0.745714, 0.672559>,
      < -6.798269, -0.745714, 0.656654>
    }
    triangle {
      < -6.796529, -0.796893, 0.672559>,
      < -6.798269, -0.745714, 0.656654>,
      < -6.798269, -0.796893, 0.656654>
    }
    triangle {
      < -6.798269, -0.796893, 0.656654>,
      < -6.814703, -0.796893, 0.506407>,
      < -6.814703, -0.812893, 0.506407>
    }
    triangle {
      < -6.798269, -0.796893, 0.656654>,
      < -6.814703, -0.812893, 0.506407>,
      < -6.798269, -0.812893, 0.656654>
    }
    triangle {
      < -6.780095, -0.796893, 0.822805>,
      < -6.796529, -0.796893, 0.672559>,
      < -6.796529, -0.812893, 0.672559>
    }
    triangle {
      < -6.780095, -0.796893, 0.822805>,
      < -6.796529, -0.812893, 0.672559>,
      < -6.780095, -0.812893, 0.822805>
    }
    triangle {
      < -6.760181, -0.796893, 1.004862>,
      < -6.760181, -0.745714, 1.004862>,
      < -6.761921, -0.745714, 0.988957>
    }
    triangle {
      < -6.760181, -0.796893, 1.004862>,
      < -6.761921, -0.745714, 0.988957>,
      < -6.761921, -0.796893, 0.988957>
    }
    triangle {
      < -6.761921, -0.796893, 0.988957>,
      < -6.778356, -0.796893, 0.838711>,
      < -6.778356, -0.812893, 0.838711>
    }
    triangle {
      < -6.761921, -0.796893, 0.988957>,
      < -6.778356, -0.812893, 0.838711>,
      < -6.761921, -0.812893, 0.988957>
    }
    triangle {
      < -6.743747, -0.796893, 1.155109>,
      < -6.760181, -0.796893, 1.004862>,
      < -6.760181, -0.812893, 1.004862>
    }
    triangle {
      < -6.743747, -0.796893, 1.155109>,
      < -6.760181, -0.812893, 1.004862>,
      < -6.743747, -0.812893, 1.155109>
    }
    triangle {
      < -6.723834, -0.796893, 1.337165>,
      < -6.723834, -0.745714, 1.337165>,
      < -6.725573, -0.745714, 1.321260>
    }
    triangle {
      < -6.723834, -0.796893, 1.337165>,
      < -6.725573, -0.745714, 1.321260>,
      < -6.725573, -0.796893, 1.321260>
    }
    triangle {
      < -6.725573, -0.796893, 1.321260>,
      < -6.742008, -0.796893, 1.171014>,
      < -6.742008, -0.812893, 1.171014>
    }
    triangle {
      < -6.725573, -0.796893, 1.321260>,
      < -6.742008, -0.812893, 1.171014>,
      < -6.725573, -0.812893, 1.321260>
    }
    triangle {
      < -6.707399, -0.796893, 1.487412>,
      < -6.723834, -0.796893, 1.337165>,
      < -6.723834, -0.812893, 1.337165>
    }
    triangle {
      < -6.707399, -0.796893, 1.487412>,
      < -6.723834, -0.812893, 1.337165>,
      < -6.707399, -0.812893, 1.487412>
    }
    triangle {
      < -6.687486, -0.796893, 1.669469>,
      < -6.687486, -0.745714, 1.669469>,
      < -6.689225, -0.745714, 1.653563>
    }
    triangle {
      < -6.687486, -0.796893, 1.669469>,
      < -6.689225, -0.745714, 1.653563>,
      < -6.689225, -0.796893, 1.653563>
    }
    triangle {
      < -6.689225, -0.796893, 1.653563>,
      < -6.705659, -0.796893, 1.503317>,
      < -6.705659, -0.812893, 1.503317>
    }
    triangle {
      < -6.689225, -0.796893, 1.653563>,
      < -6.705659, -0.812893, 1.503317>,
      < -6.689225, -0.812893, 1.653563>
    }
    triangle {
      < -6.671051, -0.796893, 1.819715>,
      < -6.687486, -0.796893, 1.669469>,
      < -6.687486, -0.812893, 1.669469>
    }
    triangle {
      < -6.671051, -0.796893, 1.819715>,
      < -6.687486, -0.812893, 1.669469>,
      < -6.671051, -0.812893, 1.819715>
    }
    triangle {
      < -6.651138, -0.796893, 2.001772>,
      < -6.651138, -0.745714, 2.001772>,
      < -6.652877, -0.745714, 1.985867>
    }
    triangle {
      < -6.651138, -0.796893, 2.001772>,
      < -6.652877, -0.745714, 1.985867>,
      < -6.652877, -0.796893, 1.985867>
    }
    triangle {
      < -6.652877, -0.796893, 1.985867>,
      < -6.669312, -0.796893, 1.835620>,
      < -6.669312, -0.812893, 1.835620>
    }
    triangle {
      < -6.652877, -0.796893, 1.985867>,
      < -6.669312, -0.812893, 1.835620>,
      < -6.652877, -0.812893, 1.985867>
    }
    triangle {
      < -6.634703, -0.796893, 2.152019>,
      < -6.651138, -0.796893, 2.001772>,
      < -6.651138, -0.812893, 2.001772>
    }
    triangle {
      < -6.634703, -0.796893, 2.152019>,
      < -6.651138, -0.812893, 2.001772>,
      < -6.634703, -0.812893, 2.152019>
    }
    triangle {
      < -6.614789, -0.796893, 2.334075>,
      < -6.614789, -0.745714, 2.334075>,
      < -6.616529, -0.745714, 2.318170>
    }
    triangle {
      < -6.614789, -0.796893, 2.334075>,
      < -6.616529, -0.745714, 2.318170>,
      < -6.616529, -0.796893, 2.318170>
    }
    triangle {
      < -6.616529, -0.796893, 2.318170>,
      < -6.632964, -0.796893, 2.167924>,
      < -6.632964, -0.812893, 2.167924>
    }
    triangle {
      < -6.616529, -0.796893, 2.318170>,
      < -6.632964, -0.812893, 2.167924>,
      < -6.616529, -0.812893, 2.318170>
    }
    triangle {
      < -6.598355, -0.796893, 2.484322>,
      < -6.614789, -0.796893, 2.334075>,
      < -6.614789, -0.812893, 2.334075>
    }
    triangle {
      < -6.598355, -0.796893, 2.484322>,
      < -6.614789, -0.812893, 2.334075>,
      < -6.598355, -0.812893, 2.484322>
    }
    triangle {
      < -6.614789, -0.745714, -2.334075>,
      < -6.614789, -0.796893, -2.334075>,
      < -6.616529, -0.796893, -2.318170>
    }
    triangle {
      < -6.614789, -0.745714, -2.334075>,
      < -6.616529, -0.796893, -2.318170>,
      < -6.616529, -0.745714, -2.318170>
    }
    triangle {
      < -6.651136, -0.745714, -2.001772>,
      < -6.651136, -0.796893, -2.001772>,
      < -6.652875, -0.796893, -1.985867>
    }
    triangle {
      < -6.651136, -0.745714, -2.001772>,
      < -6.652875, -0.796893, -1.985867>,
      < -6.652875, -0.745714, -1.985867>
    }
    triangle {
      < -6.687484, -0.745714, -1.669469>,
      < -6.687484, -0.796893, -1.669469>,
      < -6.689224, -0.796893, -1.653564>
    }
    triangle {
      < -6.687484, -0.745714, -1.669469>,
      < -6.689224, -0.796893, -1.653564>,
      < -6.689224, -0.745714, -1.653564>
    }
    triangle {
      < -6.723832, -0.745714, -1.337166>,
      < -6.723832, -0.796893, -1.337166>,
      < -6.725572, -0.796893, -1.321261>
    }
    triangle {
      < -6.723832, -0.745714, -1.337166>,
      < -6.725572, -0.796893, -1.321261>,
      < -6.725572, -0.745714, -1.321261>
    }
    triangle {
      < -6.760180, -0.745714, -1.004863>,
      < -6.760180, -0.796893, -1.004863>,
      < -6.761919, -0.796893, -0.988958>
    }
    triangle {
      < -6.760180, -0.745714, -1.004863>,
      < -6.761919, -0.796893, -0.988958>,
      < -6.761919, -0.745714, -0.988958>
    }
    triangle {
      < -6.796528, -0.745714, -0.672559>,
      < -6.796528, -0.796893, -0.672559>,
      < -6.798267, -0.796893, -0.656654>
    }
    triangle {
      < -6.796528, -0.745714, -0.672559>,
      < -6.798267, -0.796893, -0.656654>,
      < -6.798267, -0.745714, -0.656654>
    }
    triangle {
      < -6.832876, -0.745714, -0.340256>,
      < -6.832876, -0.796893, -0.340256>,
      < -6.834615, -0.796893, -0.324351>
    }
    triangle {
      < -6.832876, -0.745714, -0.340256>,
      < -6.834615, -0.796893, -0.324351>,
      < -6.834615, -0.745714, -0.324351>
    }
    triangle {
      < -6.852790, -0.745714, 0.158199>,
      < -6.852790, -0.796893, 0.158199>,
      < -6.851051, -0.796893, 0.174104>
    }
    triangle {
      < -6.852790, -0.745714, 0.158199>,
      < -6.851051, -0.796893, 0.174104>,
      < -6.851051, -0.745714, 0.174104>
    }
    triangle {
      < -6.816443, -0.745714, 0.490502>,
      < -6.816443, -0.796893, 0.490502>,
      < -6.814703, -0.796893, 0.506407>
    }
    triangle {
      < -6.816443, -0.745714, 0.490502>,
      < -6.814703, -0.796893, 0.506407>,
      < -6.814703, -0.745714, 0.506407>
    }
    triangle {
      < -6.780095, -0.745714, 0.822805>,
      < -6.780095, -0.796893, 0.822805>,
      < -6.778356, -0.796893, 0.838711>
    }
    triangle {
      < -6.780095, -0.745714, 0.822805>,
      < -6.778356, -0.796893, 0.838711>,
      < -6.778356, -0.745714, 0.838711>
    }
    triangle {
      < -6.743747, -0.745714, 1.155109>,
      < -6.743747, -0.796893, 1.155109>,
      < -6.742008, -0.796893, 1.171014>
    }
    triangle {
      < -6.743747, -0.745714, 1.155109>,
      < -6.742008, -0.796893, 1.171014>,
      < -6.742008, -0.745714, 1.171014>
    }
    triangle {
      < -6.707399, -0.745714, 1.487412>,
      < -6.707399, -0.796893, 1.487412>,
      < -6.705659, -0.796893, 1.503317>
    }
    triangle {
      < -6.707399, -0.745714, 1.487412>,
      < -6.705659, -0.796893, 1.503317>,
      < -6.705659, -0.745714, 1.503317>
    }
    triangle {
      < -6.671051, -0.745714, 1.819715>,
      < -6.671051, -0.796893, 1.819715>,
      < -6.669312, -0.796893, 1.835620>
    }
    triangle {
      < -6.671051, -0.745714, 1.819715>,
      < -6.669312, -0.796893, 1.835620>,
      < -6.669312, -0.745714, 1.835620>
    }
    triangle {
      < -6.634703, -0.745714, 2.152019>,
      < -6.634703, -0.796893, 2.152019>,
      < -6.632964, -0.796893, 2.167924>
    }
    triangle {
      < -6.634703, -0.745714, 2.152019>,
      < -6.632964, -0.796893, 2.167924>,
      < -6.632964, -0.745714, 2.167924>
    }
    triangle {
      < -6.580181, -0.796893, 2.650474>,
      < -6.596616, -0.796893, 2.500227>,
      < -6.596616, -0.812893, 2.500227>
    }
    triangle {
      < -6.580181, -0.796893, 2.650474>,
      < -6.596616, -0.812893, 2.500227>,
      < -6.580181, -0.812893, 2.650474>
    }
    triangle {
      < -6.598355, -0.745714, 2.484322>,
      < -6.598355, -0.796893, 2.484322>,
      < -6.596616, -0.796893, 2.500227>
    }
    triangle {
      < -6.598355, -0.745714, 2.484322>,
      < -6.596616, -0.796893, 2.500227>,
      < -6.596616, -0.745714, 2.500227>
    }
    triangle {
      < -6.869224, -0.729714, 0.007953>,
      < -6.869224, -0.678535, 0.007953>,
      < -6.869224, -0.678535, -0.007953>
    }
    triangle {
      < -6.869224, -0.729714, 0.007953>,
      < -6.869224, -0.678535, -0.007953>,
      < -6.869224, -0.729714, -0.007953>
    }
    triangle {
      < -6.869224, -0.729714, -0.007953>,
      < -6.852789, -0.729714, -0.158199>,
      < -6.852789, -0.745714, -0.158199>
    }
    triangle {
      < -6.869224, -0.729714, -0.007953>,
      < -6.852789, -0.745714, -0.158199>,
      < -6.869224, -0.745714, -0.007953>
    }
    triangle {
      < -6.852790, -0.729714, 0.158199>,
      < -6.869224, -0.729714, 0.007953>,
      < -6.869224, -0.745714, 0.007953>
    }
    triangle {
      < -6.852790, -0.729714, 0.158199>,
      < -6.869224, -0.745714, 0.007953>,
      < -6.852790, -0.745714, 0.158199>
    }
    triangle {
      < -6.580181, -0.729714, -2.650473>,
      < -6.580181, -0.678535, -2.650473>,
      < -6.571311, -0.670535, -2.658426>
    }
    triangle {
      < -6.580181, -0.729714, -2.650473>,
      < -6.571311, -0.670535, -2.658426>,
      < -6.571311, -0.737714, -2.658426>
    }
    triangle {
      < -6.596615, -0.729714, -2.500227>,
      < -6.580181, -0.729714, -2.650473>,
      < -6.580181, -0.745714, -2.650473>
    }
    triangle {
      < -6.596615, -0.729714, -2.500227>,
      < -6.580181, -0.745714, -2.650473>,
      < -6.596615, -0.745714, -2.500227>
    }
    triangle {
      < -6.598354, -0.729714, -2.484322>,
      < -6.598354, -0.678535, -2.484322>,
      < -6.596615, -0.678535, -2.500227>
    }
    triangle {
      < -6.598354, -0.729714, -2.484322>,
      < -6.596615, -0.678535, -2.500227>,
      < -6.596615, -0.729714, -2.500227>
    }
    triangle {
      < -6.614789, -0.729714, -2.334075>,
      < -6.598354, -0.729714, -2.484322>,
      < -6.598354, -0.745714, -2.484322>
    }
    triangle {
      < -6.614789, -0.729714, -2.334075>,
      < -6.598354, -0.745714, -2.484322>,
      < -6.614789, -0.745714, -2.334075>
    }
    triangle {
      < -6.634702, -0.729714, -2.152019>,
      < -6.634702, -0.678535, -2.152019>,
      < -6.632962, -0.678535, -2.167924>
    }
    triangle {
      < -6.634702, -0.729714, -2.152019>,
      < -6.632962, -0.678535, -2.167924>,
      < -6.632962, -0.729714, -2.167924>
    }
    triangle {
      < -6.632962, -0.729714, -2.167924>,
      < -6.616529, -0.729714, -2.318170>,
      < -6.616529, -0.745714, -2.318170>
    }
    triangle {
      < -6.632962, -0.729714, -2.167924>,
      < -6.616529, -0.745714, -2.318170>,
      < -6.632962, -0.745714, -2.167924>
    }
    triangle {
      < -6.651136, -0.729714, -2.001772>,
      < -6.634702, -0.729714, -2.152019>,
      < -6.634702, -0.745714, -2.152019>
    }
    triangle {
      < -6.651136, -0.729714, -2.001772>,
      < -6.634702, -0.745714, -2.152019>,
      < -6.651136, -0.745714, -2.001772>
    }
    triangle {
      < -6.671050, -0.729714, -1.819715>,
      < -6.671050, -0.678535, -1.819715>,
      < -6.669310, -0.678535, -1.835621>
    }
    triangle {
      < -6.671050, -0.729714, -1.819715>,
      < -6.669310, -0.678535, -1.835621>,
      < -6.669310, -0.729714, -1.835621>
    }
    triangle {
      < -6.669310, -0.729714, -1.835621>,
      < -6.652875, -0.729714, -1.985867>,
      < -6.652875, -0.745714, -1.985867>
    }
    triangle {
      < -6.669310, -0.729714, -1.835621>,
      < -6.652875, -0.745714, -1.985867>,
      < -6.669310, -0.745714, -1.835621>
    }
    triangle {
      < -6.687484, -0.729714, -1.669469>,
      < -6.671050, -0.729714, -1.819715>,
      < -6.671050, -0.745714, -1.819715>
    }
    triangle {
      < -6.687484, -0.729714, -1.669469>,
      < -6.671050, -0.745714, -1.819715>,
      < -6.687484, -0.745714, -1.669469>
    }
    triangle {
      < -6.707397, -0.729714, -1.487412>,
      < -6.707397, -0.678535, -1.487412>,
      < -6.705658, -0.678535, -1.503318>
    }
    triangle {
      < -6.707397, -0.729714, -1.487412>,
      < -6.705658, -0.678535, -1.503318>,
      < -6.705658, -0.729714, -1.503317>
    }
    triangle {
      < -6.705658, -0.729714, -1.503317>,
      < -6.689224, -0.729714, -1.653564>,
      < -6.689224, -0.745714, -1.653564>
    }
    triangle {
      < -6.705658, -0.729714, -1.503317>,
      < -6.689224, -0.745714, -1.653564>,
      < -6.705658, -0.745714, -1.503317>
    }
    triangle {
      < -6.723832, -0.729714, -1.337166>,
      < -6.707397, -0.729714, -1.487412>,
      < -6.707397, -0.745714, -1.487412>
    }
    triangle {
      < -6.723832, -0.729714, -1.337166>,
      < -6.707397, -0.745714, -1.487412>,
      < -6.723832, -0.745714, -1.337166>
    }
    triangle {
      < -6.743745, -0.729714, -1.155109>,
      < -6.743745, -0.678535, -1.155109>,
      < -6.742006, -0.678535, -1.171014>
    }
    triangle {
      < -6.743745, -0.729714, -1.155109>,
      < -6.742006, -0.678535, -1.171014>,
      < -6.742006, -0.729714, -1.171014>
    }
    triangle {
      < -6.742006, -0.729714, -1.171014>,
      < -6.725572, -0.729714, -1.321261>,
      < -6.725572, -0.745714, -1.321261>
    }
    triangle {
      < -6.742006, -0.729714, -1.171014>,
      < -6.725572, -0.745714, -1.321261>,
      < -6.742006, -0.745714, -1.171014>
    }
    triangle {
      < -6.760180, -0.729714, -1.004863>,
      < -6.743745, -0.729714, -1.155109>,
      < -6.743745, -0.745714, -1.155109>
    }
    triangle {
      < -6.760180, -0.729714, -1.004863>,
      < -6.743745, -0.745714, -1.155109>,
      < -6.760180, -0.745714, -1.004863>
    }
    triangle {
      < -6.780094, -0.729714, -0.822806>,
      < -6.780094, -0.678535, -0.822806>,
      < -6.778354, -0.678535, -0.838711>
    }
    triangle {
      < -6.780094, -0.729714, -0.822806>,
      < -6.778354, -0.678535, -0.838711>,
      < -6.778354, -0.729714, -0.838711>
    }
    triangle {
      < -6.778354, -0.729714, -0.838711>,
      < -6.761919, -0.729714, -0.988958>,
      < -6.761919, -0.745714, -0.988958>
    }
    triangle {
      < -6.778354, -0.729714, -0.838711>,
      < -6.761919, -0.745714, -0.988958>,
      < -6.778354, -0.745714, -0.838711>
    }
    triangle {
      < -6.796528, -0.729714, -0.672559>,
      < -6.780094, -0.729714, -0.822806>,
      < -6.780094, -0.745714, -0.822806>
    }
    triangle {
      < -6.796528, -0.729714, -0.672559>,
      < -6.780094, -0.745714, -0.822806>,
      < -6.796528, -0.745714, -0.672559>
    }
    triangle {
      < -6.816442, -0.729714, -0.490502>,
      < -6.816442, -0.678535, -0.490502>,
      < -6.814702, -0.678535, -0.506407>
    }
    triangle {
      < -6.816442, -0.729714, -0.490502>,
      < -6.814702, -0.678535, -0.506407>,
      < -6.814702, -0.729714, -0.506407>
    }
    triangle {
      < -6.814702, -0.729714, -0.506407>,
      < -6.798267, -0.729714, -0.656654>,
      < -6.798267, -0.745714, -0.656654>
    }
    triangle {
      < -6.814702, -0.729714, -0.506407>,
      < -6.798267, -0.745714, -0.656654>,
      < -6.814702, -0.745714, -0.506407>
    }
    triangle {
      < -6.832876, -0.729714, -0.340256>,
      < -6.816442, -0.729714, -0.490502>,
      < -6.816442, -0.745714, -0.490502>
    }
    triangle {
      < -6.832876, -0.729714, -0.340256>,
      < -6.816442, -0.745714, -0.490502>,
      < -6.832876, -0.745714, -0.340256>
    }
    triangle {
      < -6.852789, -0.729714, -0.158199>,
      < -6.852789, -0.678535, -0.158199>,
      < -6.851050, -0.678535, -0.174104>
    }
    triangle {
      < -6.852789, -0.729714, -0.158199>,
      < -6.851050, -0.678535, -0.174104>,
      < -6.851050, -0.729714, -0.174104>
    }
    triangle {
      < -6.851050, -0.729714, -0.174104>,
      < -6.834615, -0.729714, -0.324351>,
      < -6.834615, -0.745714, -0.324351>
    }
    triangle {
      < -6.851050, -0.729714, -0.174104>,
      < -6.834615, -0.745714, -0.324351>,
      < -6.851050, -0.745714, -0.174104>
    }
    triangle {
      < -6.832877, -0.729714, 0.340256>,
      < -6.832877, -0.678535, 0.340256>,
      < -6.834616, -0.678535, 0.324351>
    }
    triangle {
      < -6.832877, -0.729714, 0.340256>,
      < -6.834616, -0.678535, 0.324351>,
      < -6.834616, -0.729714, 0.324351>
    }
    triangle {
      < -6.834616, -0.729714, 0.324351>,
      < -6.851051, -0.729714, 0.174104>,
      < -6.851051, -0.745714, 0.174104>
    }
    triangle {
      < -6.834616, -0.729714, 0.324351>,
      < -6.851051, -0.745714, 0.174104>,
      < -6.834616, -0.745714, 0.324351>
    }
    triangle {
      < -6.816443, -0.729714, 0.490502>,
      < -6.832877, -0.729714, 0.340256>,
      < -6.832877, -0.745714, 0.340256>
    }
    triangle {
      < -6.816443, -0.729714, 0.490502>,
      < -6.832877, -0.745714, 0.340256>,
      < -6.816443, -0.745714, 0.490502>
    }
    triangle {
      < -6.796529, -0.729714, 0.672559>,
      < -6.796529, -0.678535, 0.672559>,
      < -6.798269, -0.678535, 0.656654>
    }
    triangle {
      < -6.796529, -0.729714, 0.672559>,
      < -6.798269, -0.678535, 0.656654>,
      < -6.798269, -0.729714, 0.656654>
    }
    triangle {
      < -6.798269, -0.729714, 0.656654>,
      < -6.814703, -0.729714, 0.506407>,
      < -6.814703, -0.745714, 0.506407>
    }
    triangle {
      < -6.798269, -0.729714, 0.656654>,
      < -6.814703, -0.745714, 0.506407>,
      < -6.798269, -0.745714, 0.656654>
    }
    triangle {
      < -6.780095, -0.729714, 0.822805>,
      < -6.796529, -0.729714, 0.672559>,
      < -6.796529, -0.745714, 0.672559>
    }
    triangle {
      < -6.780095, -0.729714, 0.822805>,
      < -6.796529, -0.745714, 0.672559>,
      < -6.780095, -0.745714, 0.822805>
    }
    triangle {
      < -6.760181, -0.729714, 1.004862>,
      < -6.760181, -0.678535, 1.004862>,
      < -6.761921, -0.678535, 0.988957>
    }
    triangle {
      < -6.760181, -0.729714, 1.004862>,
      < -6.761921, -0.678535, 0.988957>,
      < -6.761921, -0.729714, 0.988957>
    }
    triangle {
      < -6.761921, -0.729714, 0.988957>,
      < -6.778356, -0.729714, 0.838711>,
      < -6.778356, -0.745714, 0.838711>
    }
    triangle {
      < -6.761921, -0.729714, 0.988957>,
      < -6.778356, -0.745714, 0.838711>,
      < -6.761921, -0.745714, 0.988957>
    }
    triangle {
      < -6.743747, -0.729714, 1.155109>,
      < -6.760181, -0.729714, 1.004862>,
      < -6.760181, -0.745714, 1.004862>
    }
    triangle {
      < -6.743747, -0.729714, 1.155109>,
      < -6.760181, -0.745714, 1.004862>,
      < -6.743747, -0.745714, 1.155109>
    }
    triangle {
      < -6.723834, -0.729714, 1.337165>,
      < -6.723834, -0.678535, 1.337165>,
      < -6.725573, -0.678535, 1.321260>
    }
    triangle {
      < -6.723834, -0.729714, 1.337165>,
      < -6.725573, -0.678535, 1.321260>,
      < -6.725573, -0.729714, 1.321260>
    }
    triangle {
      < -6.725573, -0.729714, 1.321260>,
      < -6.742008, -0.729714, 1.171014>,
      < -6.742008, -0.745714, 1.171014>
    }
    triangle {
      < -6.725573, -0.729714, 1.321260>,
      < -6.742008, -0.745714, 1.171014>,
      < -6.725573, -0.745714, 1.321260>
    }
    triangle {
      < -6.707399, -0.729714, 1.487412>,
      < -6.723834, -0.729714, 1.337165>,
      < -6.723834, -0.745714, 1.337165>
    }
    triangle {
      < -6.707399, -0.729714, 1.487412>,
      < -6.723834, -0.745714, 1.337165>,
      < -6.707399, -0.745714, 1.487412>
    }
    triangle {
      < -6.687486, -0.729714, 1.669469>,
      < -6.687486, -0.678535, 1.669469>,
      < -6.689225, -0.678535, 1.653563>
    }
    triangle {
      < -6.687486, -0.729714, 1.669469>,
      < -6.689225, -0.678535, 1.653563>,
      < -6.689225, -0.729714, 1.653563>
    }
    triangle {
      < -6.689225, -0.729714, 1.653563>,
      < -6.705659, -0.729714, 1.503317>,
      < -6.705659, -0.745714, 1.503317>
    }
    triangle {
      < -6.689225, -0.729714, 1.653563>,
      < -6.705659, -0.745714, 1.503317>,
      < -6.689225, -0.745714, 1.653563>
    }
    triangle {
      < -6.671051, -0.729714, 1.819715>,
      < -6.687486, -0.729714, 1.669469>,
      < -6.687486, -0.745714, 1.669469>
    }
    triangle {
      < -6.671051, -0.729714, 1.819715>,
      < -6.687486, -0.745714, 1.669469>,
      < -6.671051, -0.745714, 1.819715>
    }
    triangle {
      < -6.651138, -0.729714, 2.001772>,
      < -6.651138, -0.678535, 2.001772>,
      < -6.652877, -0.678535, 1.985867>
    }
    triangle {
      < -6.651138, -0.729714, 2.001772>,
      < -6.652877, -0.678535, 1.985867>,
      < -6.652877, -0.729714, 1.985867>
    }
    triangle {
      < -6.652877, -0.729714, 1.985867>,
      < -6.669312, -0.729714, 1.835620>,
      < -6.669312, -0.745714, 1.835620>
    }
    triangle {
      < -6.652877, -0.729714, 1.985867>,
      < -6.669312, -0.745714, 1.835620>,
      < -6.652877, -0.745714, 1.985867>
    }
    triangle {
      < -6.634703, -0.729714, 2.152019>,
      < -6.651138, -0.729714, 2.001772>,
      < -6.651138, -0.745714, 2.001772>
    }
    triangle {
      < -6.634703, -0.729714, 2.152019>,
      < -6.651138, -0.745714, 2.001772>,
      < -6.634703, -0.745714, 2.152019>
    }
    triangle {
      < -6.614789, -0.729714, 2.334075>,
      < -6.614789, -0.678535, 2.334075>,
      < -6.616529, -0.678535, 2.318170>
    }
    triangle {
      < -6.614789, -0.729714, 2.334075>,
      < -6.616529, -0.678535, 2.318170>,
      < -6.616529, -0.729714, 2.318170>
    }
    triangle {
      < -6.616529, -0.729714, 2.318170>,
      < -6.632964, -0.729714, 2.167924>,
      < -6.632964, -0.745714, 2.167924>
    }
    triangle {
      < -6.616529, -0.729714, 2.318170>,
      < -6.632964, -0.745714, 2.167924>,
      < -6.616529, -0.745714, 2.318170>
    }
    triangle {
      < -6.598355, -0.729714, 2.484322>,
      < -6.614789, -0.729714, 2.334075>,
      < -6.614789, -0.745714, 2.334075>
    }
    triangle {
      < -6.598355, -0.729714, 2.484322>,
      < -6.614789, -0.745714, 2.334075>,
      < -6.598355, -0.745714, 2.484322>
    }
    triangle {
      < -6.580181, -0.729714, 2.650474>,
      < -6.596616, -0.729714, 2.500227>,
      < -6.596616, -0.745714, 2.500227>
    }
    triangle {
      < -6.580181, -0.729714, 2.650474>,
      < -6.596616, -0.745714, 2.500227>,
      < -6.580181, -0.745714, 2.650474>
    }
    triangle {
      < -6.598355, -0.678535, 2.484322>,
      < -6.598355, -0.729714, 2.484322>,
      < -6.596616, -0.729714, 2.500227>
    }
    triangle {
      < -6.598355, -0.678535, 2.484322>,
      < -6.596616, -0.729714, 2.500227>,
      < -6.596616, -0.678535, 2.500227>
    }
    triangle {
      < -6.634703, -0.678535, 2.152019>,
      < -6.634703, -0.729714, 2.152019>,
      < -6.632964, -0.729714, 2.167924>
    }
    triangle {
      < -6.634703, -0.678535, 2.152019>,
      < -6.632964, -0.729714, 2.167924>,
      < -6.632964, -0.678535, 2.167924>
    }
    triangle {
      < -6.671051, -0.678535, 1.819715>,
      < -6.671051, -0.729714, 1.819715>,
      < -6.669312, -0.729714, 1.835620>
    }
    triangle {
      < -6.671051, -0.678535, 1.819715>,
      < -6.669312, -0.729714, 1.835620>,
      < -6.669312, -0.678535, 1.835620>
    }
    triangle {
      < -6.707399, -0.678535, 1.487412>,
      < -6.707399, -0.729714, 1.487412>,
      < -6.705659, -0.729714, 1.503317>
    }
    triangle {
      < -6.707399, -0.678535, 1.487412>,
      < -6.705659, -0.729714, 1.503317>,
      < -6.705659, -0.678535, 1.503317>
    }
    triangle {
      < -6.743747, -0.678535, 1.155109>,
      < -6.743747, -0.729714, 1.155109>,
      < -6.742008, -0.729714, 1.171014>
    }
    triangle {
      < -6.743747, -0.678535, 1.155109>,
      < -6.742008, -0.729714, 1.171014>,
      < -6.742008, -0.678535, 1.171014>
    }
    triangle {
      < -6.780095, -0.678535, 0.822805>,
      < -6.780095, -0.729714, 0.822805>,
      < -6.778356, -0.729714, 0.838711>
    }
    triangle {
      < -6.780095, -0.678535, 0.822805>,
      < -6.778356, -0.729714, 0.838711>,
      < -6.778356, -0.678535, 0.838711>
    }
    triangle {
      < -6.816443, -0.678535, 0.490502>,
      < -6.816443, -0.729714, 0.490502>,
      < -6.814703, -0.729714, 0.506407>
    }
    triangle {
      < -6.816443, -0.678535, 0.490502>,
      < -6.814703, -0.729714, 0.506407>,
      < -6.814703, -0.678535, 0.506407>
    }
    triangle {
      < -6.852790, -0.678535, 0.158199>,
      < -6.852790, -0.729714, 0.158199>,
      < -6.851051, -0.729714, 0.174104>
    }
    triangle {
      < -6.852790, -0.678535, 0.158199>,
      < -6.851051, -0.729714, 0.174104>,
      < -6.851051, -0.678535, 0.174104>
    }
    triangle {
      < -6.832876, -0.678535, -0.340256>,
      < -6.832876, -0.729714, -0.340256>,
      < -6.834615, -0.729714, -0.324351>
    }
    triangle {
      < -6.832876, -0.678535, -0.340256>,
      < -6.834615, -0.729714, -0.324351>,
      < -6.834615, -0.678535, -0.324351>
    }
    triangle {
      < -6.796528, -0.678535, -0.672559>,
      < -6.796528, -0.729714, -0.672559>,
      < -6.798267, -0.729714, -0.656654>
    }
    triangle {
      < -6.796528, -0.678535, -0.672559>,
      < -6.798267, -0.729714, -0.656654>,
      < -6.798267, -0.678535, -0.656654>
    }
    triangle {
      < -6.760180, -0.678535, -1.004863>,
      < -6.760180, -0.729714, -1.004863>,
      < -6.761919, -0.729714, -0.988958>
    }
    triangle {
      < -6.760180, -0.678535, -1.004863>,
      < -6.761919, -0.729714, -0.988958>,
      < -6.761919, -0.678535, -0.988958>
    }
    triangle {
      < -6.723832, -0.678535, -1.337166>,
      < -6.723832, -0.729714, -1.337166>,
      < -6.725572, -0.729714, -1.321261>
    }
    triangle {
      < -6.723832, -0.678535, -1.337166>,
      < -6.725572, -0.729714, -1.321261>,
      < -6.725572, -0.678535, -1.321261>
    }
    triangle {
      < -6.687484, -0.678535, -1.669469>,
      < -6.687484, -0.729714, -1.669469>,
      < -6.689224, -0.729714, -1.653564>
    }
    triangle {
      < -6.687484, -0.678535, -1.669469>,
      < -6.689224, -0.729714, -1.653564>,
      < -6.689224, -0.678535, -1.653564>
    }
    triangle {
      < -6.651136, -0.678535, -2.001772>,
      < -6.651136, -0.729714, -2.001772>,
      < -6.652875, -0.729714, -1.985867>
    }
    triangle {
      < -6.651136, -0.678535, -2.001772>,
      < -6.652875, -0.729714, -1.985867>,
      < -6.652875, -0.678535, -1.985867>
    }
    triangle {
      < -6.614789, -0.678535, -2.334075>,
      < -6.614789, -0.729714, -2.334075>,
      < -6.616529, -0.729714, -2.318170>
    }
    triangle {
      < -6.614789, -0.678535, -2.334075>,
      < -6.616529, -0.729714, -2.318170>,
      < -6.616529, -0.678535, -2.318170>
    }
    triangle {
      < -6.869224, -0.662535, 0.007953>,
      < -6.869224, -0.611356, 0.007953>,
      < -6.869224, -0.611356, -0.007953>
    }
    triangle {
      < -6.869224, -0.662535, 0.007953>,
      < -6.869224, -0.611356, -0.007953>,
      < -6.869224, -0.662535, -0.007953>
    }
    triangle {
      < -6.869224, -0.662535, -0.007953>,
      < -6.852789, -0.662535, -0.158199>,
      < -6.852789, -0.678535, -0.158199>
    }
    triangle {
      < -6.869224, -0.662535, -0.007953>,
      < -6.852789, -0.678535, -0.158199>,
      < -6.869224, -0.678535, -0.007953>
    }
    triangle {
      < -6.852790, -0.662535, 0.158199>,
      < -6.869224, -0.662535, 0.007953>,
      < -6.869224, -0.678535, 0.007953>
    }
    triangle {
      < -6.852790, -0.662535, 0.158199>,
      < -6.869224, -0.678535, 0.007953>,
      < -6.852790, -0.678535, 0.158199>
    }
    triangle {
      < -6.580181, -0.662535, -2.650473>,
      < -6.580181, -0.611356, -2.650473>,
      < -6.571311, -0.603356, -2.658426>
    }
    triangle {
      < -6.580181, -0.662535, -2.650473>,
      < -6.571311, -0.603356, -2.658426>,
      < -6.571311, -0.670535, -2.658426>
    }
    triangle {
      < -6.596615, -0.662535, -2.500227>,
      < -6.580181, -0.662535, -2.650473>,
      < -6.580181, -0.678535, -2.650473>
    }
    triangle {
      < -6.596615, -0.662535, -2.500227>,
      < -6.580181, -0.678535, -2.650473>,
      < -6.596615, -0.678535, -2.500227>
    }
    triangle {
      < -6.598354, -0.662535, -2.484322>,
      < -6.598354, -0.611356, -2.484322>,
      < -6.596615, -0.611356, -2.500227>
    }
    triangle {
      < -6.598354, -0.662535, -2.484322>,
      < -6.596615, -0.611356, -2.500227>,
      < -6.596615, -0.662535, -2.500227>
    }
    triangle {
      < -6.614789, -0.662535, -2.334075>,
      < -6.598354, -0.662535, -2.484322>,
      < -6.598354, -0.678535, -2.484322>
    }
    triangle {
      < -6.614789, -0.662535, -2.334075>,
      < -6.598354, -0.678535, -2.484322>,
      < -6.614789, -0.678535, -2.334075>
    }
    triangle {
      < -6.632962, -0.662535, -2.167924>,
      < -6.616529, -0.662535, -2.318170>,
      < -6.616529, -0.678535, -2.318170>
    }
    triangle {
      < -6.632962, -0.662535, -2.167924>,
      < -6.616529, -0.678535, -2.318170>,
      < -6.632962, -0.678535, -2.167924>
    }
    triangle {
      < -6.614789, -0.611356, -2.334075>,
      < -6.614789, -0.662535, -2.334075>,
      < -6.616529, -0.662535, -2.318170>
    }
    triangle {
      < -6.614789, -0.611356, -2.334075>,
      < -6.616529, -0.662535, -2.318170>,
      < -6.616529, -0.611356, -2.318170>
    }
    triangle {
      < -6.634702, -0.662535, -2.152019>,
      < -6.634702, -0.611356, -2.152019>,
      < -6.632962, -0.611356, -2.167924>
    }
    triangle {
      < -6.634702, -0.662535, -2.152019>,
      < -6.632962, -0.611356, -2.167924>,
      < -6.632962, -0.662535, -2.167924>
    }
    triangle {
      < -6.651136, -0.662535, -2.001772>,
      < -6.634702, -0.662535, -2.152019>,
      < -6.634702, -0.678535, -2.152019>
    }
    triangle {
      < -6.651136, -0.662535, -2.001772>,
      < -6.634702, -0.678535, -2.152019>,
      < -6.651136, -0.678535, -2.001772>
    }
    triangle {
      < -6.669310, -0.662535, -1.835621>,
      < -6.652875, -0.662535, -1.985867>,
      < -6.652875, -0.678535, -1.985867>
    }
    triangle {
      < -6.669310, -0.662535, -1.835621>,
      < -6.652875, -0.678535, -1.985867>,
      < -6.669310, -0.678535, -1.835621>
    }
    triangle {
      < -6.651136, -0.611356, -2.001772>,
      < -6.651136, -0.662535, -2.001772>,
      < -6.652875, -0.662535, -1.985867>
    }
    triangle {
      < -6.651136, -0.611356, -2.001772>,
      < -6.652875, -0.662535, -1.985867>,
      < -6.652875, -0.611356, -1.985867>
    }
    triangle {
      < -6.671050, -0.662535, -1.819715>,
      < -6.671050, -0.611356, -1.819715>,
      < -6.669310, -0.611356, -1.835621>
    }
    triangle {
      < -6.671050, -0.662535, -1.819715>,
      < -6.669310, -0.611356, -1.835621>,
      < -6.669310, -0.662535, -1.835621>
    }
    triangle {
      < -6.687484, -0.662535, -1.669469>,
      < -6.671050, -0.662535, -1.819715>,
      < -6.671050, -0.678535, -1.819715>
    }
    triangle {
      < -6.687484, -0.662535, -1.669469>,
      < -6.671050, -0.678535, -1.819715>,
      < -6.687484, -0.678535, -1.669469>
    }
    triangle {
      < -6.705658, -0.662535, -1.503318>,
      < -6.689224, -0.662535, -1.653564>,
      < -6.689224, -0.678535, -1.653564>
    }
    triangle {
      < -6.705658, -0.662535, -1.503318>,
      < -6.689224, -0.678535, -1.653564>,
      < -6.705658, -0.678535, -1.503318>
    }
    triangle {
      < -6.687484, -0.611356, -1.669469>,
      < -6.687484, -0.662535, -1.669469>,
      < -6.689224, -0.662535, -1.653564>
    }
    triangle {
      < -6.687484, -0.611356, -1.669469>,
      < -6.689224, -0.662535, -1.653564>,
      < -6.689224, -0.611356, -1.653564>
    }
    triangle {
      < -6.707397, -0.662535, -1.487412>,
      < -6.707397, -0.611356, -1.487412>,
      < -6.705658, -0.611356, -1.503318>
    }
    triangle {
      < -6.707397, -0.662535, -1.487412>,
      < -6.705658, -0.611356, -1.503318>,
      < -6.705658, -0.662535, -1.503318>
    }
    triangle {
      < -6.723832, -0.662535, -1.337166>,
      < -6.707397, -0.662535, -1.487412>,
      < -6.707397, -0.678535, -1.487412>
    }
    triangle {
      < -6.723832, -0.662535, -1.337166>,
      < -6.707397, -0.678535, -1.487412>,
      < -6.723832, -0.678535, -1.337166>
    }
    triangle {
      < -6.742006, -0.662535, -1.171014>,
      < -6.725572, -0.662535, -1.321261>,
      < -6.725572, -0.678535, -1.321261>
    }
    triangle {
      < -6.742006, -0.662535, -1.171014>,
      < -6.725572, -0.678535, -1.321261>,
      < -6.742006, -0.678535, -1.171014>
    }
    triangle {
      < -6.723832, -0.611356, -1.337166>,
      < -6.723832, -0.662535, -1.337166>,
      < -6.725572, -0.662535, -1.321261>
    }
    triangle {
      < -6.723832, -0.611356, -1.337166>,
      < -6.725572, -0.662535, -1.321261>,
      < -6.725572, -0.611356, -1.321261>
    }
    triangle {
      < -6.743745, -0.662535, -1.155109>,
      < -6.743745, -0.611356, -1.155109>,
      < -6.742006, -0.611356, -1.171014>
    }
    triangle {
      < -6.743745, -0.662535, -1.155109>,
      < -6.742006, -0.611356, -1.171014>,
      < -6.742006, -0.662535, -1.171014>
    }
    triangle {
      < -6.760180, -0.662535, -1.004863>,
      < -6.743745, -0.662535, -1.155109>,
      < -6.743745, -0.678535, -1.155109>
    }
    triangle {
      < -6.760180, -0.662535, -1.004863>,
      < -6.743745, -0.678535, -1.155109>,
      < -6.760180, -0.678535, -1.004863>
    }
    triangle {
      < -6.778354, -0.662535, -0.838711>,
      < -6.761919, -0.662535, -0.988958>,
      < -6.761919, -0.678535, -0.988958>
    }
    triangle {
      < -6.778354, -0.662535, -0.838711>,
      < -6.761919, -0.678535, -0.988958>,
      < -6.778354, -0.678535, -0.838711>
    }
    triangle {
      < -6.760180, -0.611356, -1.004863>,
      < -6.760180, -0.662535, -1.004863>,
      < -6.761919, -0.662535, -0.988958>
    }
    triangle {
      < -6.760180, -0.611356, -1.004863>,
      < -6.761919, -0.662535, -0.988958>,
      < -6.761919, -0.611356, -0.988958>
    }
    triangle {
      < -6.780094, -0.662535, -0.822806>,
      < -6.780094, -0.611356, -0.822806>,
      < -6.778354, -0.611356, -0.838711>
    }
    triangle {
      < -6.780094, -0.662535, -0.822806>,
      < -6.778354, -0.611356, -0.838711>,
      < -6.778354, -0.662535, -0.838711>
    }
    triangle {
      < -6.796528, -0.662535, -0.672559>,
      < -6.780094, -0.662535, -0.822806>,
      < -6.780094, -0.678535, -0.822806>
    }
    triangle {
      < -6.796528, -0.662535, -0.672559>,
      < -6.780094, -0.678535, -0.822806>,
      < -6.796528, -0.678535, -0.672559>
    }
    triangle {
      < -6.814702, -0.662535, -0.506408>,
      < -6.798267, -0.662535, -0.656654>,
      < -6.798267, -0.678535, -0.656654>
    }
    triangle {
      < -6.814702, -0.662535, -0.506408>,
      < -6.798267, -0.678535, -0.656654>,
      < -6.814702, -0.678535, -0.506407>
    }
    triangle {
      < -6.796528, -0.611356, -0.672559>,
      < -6.796528, -0.662535, -0.672559>,
      < -6.798267, -0.662535, -0.656654>
    }
    triangle {
      < -6.796528, -0.611356, -0.672559>,
      < -6.798267, -0.662535, -0.656654>,
      < -6.798267, -0.611356, -0.656654>
    }
    triangle {
      < -6.816442, -0.662535, -0.490503>,
      < -6.816442, -0.611356, -0.490503>,
      < -6.814702, -0.611356, -0.506408>
    }
    triangle {
      < -6.816442, -0.662535, -0.490503>,
      < -6.814702, -0.611356, -0.506408>,
      < -6.814702, -0.662535, -0.506408>
    }
    triangle {
      < -6.832876, -0.662535, -0.340256>,
      < -6.816442, -0.662535, -0.490503>,
      < -6.816442, -0.678535, -0.490502>
    }
    triangle {
      < -6.832876, -0.662535, -0.340256>,
      < -6.816442, -0.678535, -0.490502>,
      < -6.832876, -0.678535, -0.340256>
    }
    triangle {
      < -6.851050, -0.662535, -0.174104>,
      < -6.834615, -0.662535, -0.324351>,
      < -6.834615, -0.678535, -0.324351>
    }
    triangle {
      < -6.851050, -0.662535, -0.174104>,
      < -6.834615, -0.678535, -0.324351>,
      < -6.851050, -0.678535, -0.174104>
    }
    triangle {
      < -6.832876, -0.611356, -0.340256>,
      < -6.832876, -0.662535, -0.340256>,
      < -6.834615, -0.662535, -0.324351>
    }
    triangle {
      < -6.832876, -0.611356, -0.340256>,
      < -6.834615, -0.662535, -0.324351>,
      < -6.834615, -0.611356, -0.324351>
    }
    triangle {
      < -6.852789, -0.662535, -0.158199>,
      < -6.852789, -0.611356, -0.158199>,
      < -6.851050, -0.611356, -0.174104>
    }
    triangle {
      < -6.852789, -0.662535, -0.158199>,
      < -6.851050, -0.611356, -0.174104>,
      < -6.851050, -0.662535, -0.174104>
    }
    triangle {
      < -6.834616, -0.662535, 0.324351>,
      < -6.851051, -0.662535, 0.174104>,
      < -6.851051, -0.678535, 0.174104>
    }
    triangle {
      < -6.834616, -0.662535, 0.324351>,
      < -6.851051, -0.678535, 0.174104>,
      < -6.834616, -0.678535, 0.324351>
    }
    triangle {
      < -6.852790, -0.611356, 0.158199>,
      < -6.852790, -0.662535, 0.158199>,
      < -6.851051, -0.662535, 0.174104>
    }
    triangle {
      < -6.852790, -0.611356, 0.158199>,
      < -6.851051, -0.662535, 0.174104>,
      < -6.851051, -0.611356, 0.174104>
    }
    triangle {
      < -6.832877, -0.662535, 0.340256>,
      < -6.832877, -0.611356, 0.340256>,
      < -6.834616, -0.611356, 0.324351>
    }
    triangle {
      < -6.832877, -0.662535, 0.340256>,
      < -6.834616, -0.611356, 0.324351>,
      < -6.834616, -0.662535, 0.324351>
    }
    triangle {
      < -6.816443, -0.662535, 0.490502>,
      < -6.832877, -0.662535, 0.340256>,
      < -6.832877, -0.678535, 0.340256>
    }
    triangle {
      < -6.816443, -0.662535, 0.490502>,
      < -6.832877, -0.678535, 0.340256>,
      < -6.816443, -0.678535, 0.490502>
    }
    triangle {
      < -6.798269, -0.662535, 0.656654>,
      < -6.814703, -0.662535, 0.506407>,
      < -6.814703, -0.678535, 0.506407>
    }
    triangle {
      < -6.798269, -0.662535, 0.656654>,
      < -6.814703, -0.678535, 0.506407>,
      < -6.798269, -0.678535, 0.656654>
    }
    triangle {
      < -6.816443, -0.611356, 0.490502>,
      < -6.816443, -0.662535, 0.490502>,
      < -6.814703, -0.662535, 0.506407>
    }
    triangle {
      < -6.816443, -0.611356, 0.490502>,
      < -6.814703, -0.662535, 0.506407>,
      < -6.814703, -0.611356, 0.506407>
    }
    triangle {
      < -6.796529, -0.662535, 0.672559>,
      < -6.796529, -0.611356, 0.672559>,
      < -6.798269, -0.611356, 0.656654>
    }
    triangle {
      < -6.796529, -0.662535, 0.672559>,
      < -6.798269, -0.611356, 0.656654>,
      < -6.798269, -0.662535, 0.656654>
    }
    triangle {
      < -6.780095, -0.662535, 0.822805>,
      < -6.796529, -0.662535, 0.672559>,
      < -6.796529, -0.678535, 0.672559>
    }
    triangle {
      < -6.780095, -0.662535, 0.822805>,
      < -6.796529, -0.678535, 0.672559>,
      < -6.780095, -0.678535, 0.822805>
    }
    triangle {
      < -6.761921, -0.662535, 0.988957>,
      < -6.778356, -0.662535, 0.838711>,
      < -6.778356, -0.678535, 0.838711>
    }
    triangle {
      < -6.761921, -0.662535, 0.988957>,
      < -6.778356, -0.678535, 0.838711>,
      < -6.761921, -0.678535, 0.988957>
    }
    triangle {
      < -6.780095, -0.611356, 0.822805>,
      < -6.780095, -0.662535, 0.822805>,
      < -6.778356, -0.662535, 0.838711>
    }
    triangle {
      < -6.780095, -0.611356, 0.822805>,
      < -6.778356, -0.662535, 0.838711>,
      < -6.778356, -0.611356, 0.838711>
    }
    triangle {
      < -6.760181, -0.662535, 1.004862>,
      < -6.760181, -0.611356, 1.004862>,
      < -6.761921, -0.611356, 0.988957>
    }
    triangle {
      < -6.760181, -0.662535, 1.004862>,
      < -6.761921, -0.611356, 0.988957>,
      < -6.761921, -0.662535, 0.988957>
    }
    triangle {
      < -6.743747, -0.662535, 1.155109>,
      < -6.760181, -0.662535, 1.004862>,
      < -6.760181, -0.678535, 1.004862>
    }
    triangle {
      < -6.743747, -0.662535, 1.155109>,
      < -6.760181, -0.678535, 1.004862>,
      < -6.743747, -0.678535, 1.155109>
    }
    triangle {
      < -6.725573, -0.662535, 1.321260>,
      < -6.742008, -0.662535, 1.171014>,
      < -6.742008, -0.678535, 1.171014>
    }
    triangle {
      < -6.725573, -0.662535, 1.321260>,
      < -6.742008, -0.678535, 1.171014>,
      < -6.725573, -0.678535, 1.321260>
    }
    triangle {
      < -6.743747, -0.611356, 1.155109>,
      < -6.743747, -0.662535, 1.155109>,
      < -6.742008, -0.662535, 1.171014>
    }
    triangle {
      < -6.743747, -0.611356, 1.155109>,
      < -6.742008, -0.662535, 1.171014>,
      < -6.742008, -0.611356, 1.171014>
    }
    triangle {
      < -6.723834, -0.662535, 1.337165>,
      < -6.723834, -0.611356, 1.337165>,
      < -6.725573, -0.611356, 1.321260>
    }
    triangle {
      < -6.723834, -0.662535, 1.337165>,
      < -6.725573, -0.611356, 1.321260>,
      < -6.725573, -0.662535, 1.321260>
    }
    triangle {
      < -6.707399, -0.662535, 1.487412>,
      < -6.723834, -0.662535, 1.337165>,
      < -6.723834, -0.678535, 1.337165>
    }
    triangle {
      < -6.707399, -0.662535, 1.487412>,
      < -6.723834, -0.678535, 1.337165>,
      < -6.707399, -0.678535, 1.487412>
    }
    triangle {
      < -6.689225, -0.662535, 1.653563>,
      < -6.705659, -0.662535, 1.503317>,
      < -6.705659, -0.678535, 1.503317>
    }
    triangle {
      < -6.689225, -0.662535, 1.653563>,
      < -6.705659, -0.678535, 1.503317>,
      < -6.689225, -0.678535, 1.653563>
    }
    triangle {
      < -6.707399, -0.611356, 1.487412>,
      < -6.707399, -0.662535, 1.487412>,
      < -6.705659, -0.662535, 1.503317>
    }
    triangle {
      < -6.707399, -0.611356, 1.487412>,
      < -6.705659, -0.662535, 1.503317>,
      < -6.705659, -0.611356, 1.503317>
    }
    triangle {
      < -6.687486, -0.662535, 1.669469>,
      < -6.687486, -0.611356, 1.669469>,
      < -6.689225, -0.611356, 1.653563>
    }
    triangle {
      < -6.687486, -0.662535, 1.669469>,
      < -6.689225, -0.611356, 1.653563>,
      < -6.689225, -0.662535, 1.653563>
    }
    triangle {
      < -6.671051, -0.662535, 1.819715>,
      < -6.687486, -0.662535, 1.669469>,
      < -6.687486, -0.678535, 1.669469>
    }
    triangle {
      < -6.671051, -0.662535, 1.819715>,
      < -6.687486, -0.678535, 1.669469>,
      < -6.671051, -0.678535, 1.819715>
    }
    triangle {
      < -6.652877, -0.662535, 1.985867>,
      < -6.669312, -0.662535, 1.835620>,
      < -6.669312, -0.678535, 1.835620>
    }
    triangle {
      < -6.652877, -0.662535, 1.985867>,
      < -6.669312, -0.678535, 1.835620>,
      < -6.652877, -0.678535, 1.985867>
    }
    triangle {
      < -6.671051, -0.611356, 1.819715>,
      < -6.671051, -0.662535, 1.819715>,
      < -6.669312, -0.662535, 1.835620>
    }
    triangle {
      < -6.671051, -0.611356, 1.819715>,
      < -6.669312, -0.662535, 1.835620>,
      < -6.669312, -0.611356, 1.835620>
    }
    triangle {
      < -6.651138, -0.662535, 2.001772>,
      < -6.651138, -0.611356, 2.001772>,
      < -6.652877, -0.611356, 1.985867>
    }
    triangle {
      < -6.651138, -0.662535, 2.001772>,
      < -6.652877, -0.611356, 1.985867>,
      < -6.652877, -0.662535, 1.985867>
    }
    triangle {
      < -6.634703, -0.662535, 2.152019>,
      < -6.651138, -0.662535, 2.001772>,
      < -6.651138, -0.678535, 2.001772>
    }
    triangle {
      < -6.634703, -0.662535, 2.152019>,
      < -6.651138, -0.678535, 2.001772>,
      < -6.634703, -0.678535, 2.152019>
    }
    triangle {
      < -6.616529, -0.662535, 2.318170>,
      < -6.632964, -0.662535, 2.167924>,
      < -6.632964, -0.678535, 2.167924>
    }
    triangle {
      < -6.616529, -0.662535, 2.318170>,
      < -6.632964, -0.678535, 2.167924>,
      < -6.616529, -0.678535, 2.318170>
    }
    triangle {
      < -6.634703, -0.611356, 2.152019>,
      < -6.634703, -0.662535, 2.152019>,
      < -6.632964, -0.662535, 2.167924>
    }
    triangle {
      < -6.634703, -0.611356, 2.152019>,
      < -6.632964, -0.662535, 2.167924>,
      < -6.632964, -0.611356, 2.167924>
    }
    triangle {
      < -6.614789, -0.662535, 2.334075>,
      < -6.614789, -0.611356, 2.334075>,
      < -6.616529, -0.611356, 2.318170>
    }
    triangle {
      < -6.614789, -0.662535, 2.334075>,
      < -6.616529, -0.611356, 2.318170>,
      < -6.616529, -0.662535, 2.318170>
    }
    triangle {
      < -6.598355, -0.662535, 2.484322>,
      < -6.614789, -0.662535, 2.334075>,
      < -6.614789, -0.678535, 2.334075>
    }
    triangle {
      < -6.598355, -0.662535, 2.484322>,
      < -6.614789, -0.678535, 2.334075>,
      < -6.598355, -0.678535, 2.484322>
    }
    triangle {
      < -6.580181, -0.662535, 2.650474>,
      < -6.596616, -0.662535, 2.500227>,
      < -6.596616, -0.678535, 2.500227>
    }
    triangle {
      < -6.580181, -0.662535, 2.650474>,
      < -6.596616, -0.678535, 2.500227>,
      < -6.580181, -0.678535, 2.650474>
    }
    triangle {
      < -6.598355, -0.611356, 2.484322>,
      < -6.598355, -0.662535, 2.484322>,
      < -6.596616, -0.662535, 2.500227>
    }
    triangle {
      < -6.598355, -0.611356, 2.484322>,
      < -6.596616, -0.662535, 2.500227>,
      < -6.596616, -0.611356, 2.500227>
    }
    triangle {
      < -6.580181, -0.678535, 2.650474>,
      < -6.580181, -0.729714, 2.650474>,
      < -6.571311, -0.737714, 2.658426>
    }
    triangle {
      < -6.580181, -0.678535, 2.650474>,
      < -6.571311, -0.737714, 2.658426>,
      < -6.571311, -0.670535, 2.658426>
    }
    triangle {
      < -6.580181, -0.611356, 2.650474>,
      < -6.580181, -0.662535, 2.650474>,
      < -6.571311, -0.670535, 2.658426>
    }
    triangle {
      < -6.580181, -0.611356, 2.650474>,
      < -6.571311, -0.670535, 2.658426>,
      < -6.571311, -0.603356, 2.658426>
    }
    triangle {
      < -6.580181, -0.745714, 2.650474>,
      < -6.580181, -0.796893, 2.650474>,
      < -6.571311, -0.804893, 2.658426>
    }
    triangle {
      < -6.580181, -0.745714, 2.650474>,
      < -6.571311, -0.804893, 2.658426>,
      < -6.571311, -0.737714, 2.658426>
    }
    triangle {
      < -6.580181, -0.812893, 2.650474>,
      < -6.580181, -0.864072, 2.650474>,
      < -6.571311, -0.872072, 2.658426>
    }
    triangle {
      < -6.580181, -0.812893, 2.650474>,
      < -6.571311, -0.872072, 2.658426>,
      < -6.571311, -0.804893, 2.658426>
    }
    triangle {
      < -6.580181, -0.880072, 2.650474>,
      < -6.580181, -0.931251, 2.650474>,
      < -6.571311, -0.939251, 2.658426>
    }
    triangle {
      < -6.580181, -0.880072, 2.650474>,
      < -6.571311, -0.939251, 2.658426>,
      < -6.571311, -0.872072, 2.658426>
    }
    triangle {
      < -6.580181, -0.947251, 2.650474>,
      < -6.580181, -0.998430, 2.650474>,
      < -6.571311, -1.006430, 2.658426>
    }
    triangle {
      < -6.580181, -0.947251, 2.650474>,
      < -6.571311, -1.006430, 2.658426>,
      < -6.571311, -0.939251, 2.658426>
    }
    triangle {
      < -6.580181, -1.014430, 2.650474>,
      < -6.580181, -1.065609, 2.650474>,
      < -6.571311, -1.073609, 2.658426>
    }
    triangle {
      < -6.580181, -1.014430, 2.650474>,
      < -6.571311, -1.073609, 2.658426>,
      < -6.571311, -1.006430, 2.658426>
    }
    triangle {
      < -6.580181, -1.081609, 2.650474>,
      < -6.580181, -1.132789, 2.650474>,
      < -6.571311, -1.140788, 2.658426>
    }
    triangle {
      < -6.580181, -1.081609, 2.650474>,
      < -6.571311, -1.140788, 2.658426>,
      < -6.571311, -1.073609, 2.658426>
    }
    triangle {
      < -6.580181, -1.148789, 2.650474>,
      < -6.580181, -1.199968, 2.650474>,
      < -6.571311, -1.207968, 2.658426>
    }
    triangle {
      < -6.580181, -1.148789, 2.650474>,
      < -6.571311, -1.207968, 2.658426>,
      < -6.571311, -1.140788, 2.658426>
    }
    triangle {
      < -6.580181, -1.215968, 2.650474>,
      < -6.580181, -1.267147, 2.650474>,
      < -6.571311, -1.275147, 2.658426>
    }
    triangle {
      < -6.580181, -1.215968, 2.650474>,
      < -6.571311, -1.275147, 2.658426>,
      < -6.571311, -1.207968, 2.658426>
    }
    triangle {
      < -6.580181, -1.283147, 2.650474>,
      < -6.580181, -1.334326, 2.650474>,
      < -6.571311, -1.342326, 2.658426>
    }
    triangle {
      < -6.580181, -1.283147, 2.650474>,
      < -6.571311, -1.342326, 2.658426>,
      < -6.571311, -1.275147, 2.658426>
    }
    triangle {
      < -6.580181, -1.350326, 2.650474>,
      < -6.580181, -1.401505, 2.650474>,
      < -6.571311, -1.409505, 2.658426>
    }
    triangle {
      < -6.580181, -1.350326, 2.650474>,
      < -6.571311, -1.409505, 2.658426>,
      < -6.571311, -1.342326, 2.658426>
    }
    triangle {
      < -6.580181, -1.417505, 2.650474>,
      < -6.580181, -1.468684, 2.650474>,
      < -6.571311, -1.476684, 2.658426>
    }
    triangle {
      < -6.580181, -1.417505, 2.650474>,
      < -6.571311, -1.476684, 2.658426>,
      < -6.571311, -1.409505, 2.658426>
    }
    triangle {
      < -6.580181, -1.484684, 2.650474>,
      < -6.580181, -1.535863, 2.650474>,
      < -6.571311, -1.543863, 2.658426>
    }
    triangle {
      < -6.580181, -1.484684, 2.650474>,
      < -6.571311, -1.543863, 2.658426>,
      < -6.571311, -1.476684, 2.658426>
    }
    triangle {
      < -6.580181, -1.551863, 2.650474>,
      < -6.580181, -1.603042, 2.650474>,
      < -6.571311, -1.611042, 2.658426>
    }
    triangle {
      < -6.580181, -1.551863, 2.650474>,
      < -6.571311, -1.611042, 2.658426>,
      < -6.571311, -1.543863, 2.658426>
    }
    triangle {
      < -6.598354, -0.611356, -2.484322>,
      < -6.614789, -0.611356, -2.334075>,
      < -6.607658, -0.603356, -2.326123>
    }
    triangle {
      < -6.598354, -0.611356, -2.484322>,
      < -6.607658, -0.603356, -2.326123>,
      < -6.589485, -0.603356, -2.492275>
    }
    triangle {
      < -6.580181, -0.611356, -2.650473>,
      < -6.596615, -0.611356, -2.500227>,
      < -6.589485, -0.603356, -2.492275>
    }
    triangle {
      < -6.580181, -0.611356, -2.650473>,
      < -6.589485, -0.603356, -2.492275>,
      < -6.571311, -0.603356, -2.658426>
    }
    triangle {
      < -6.616529, -0.611356, -2.318170>,
      < -6.632962, -0.611356, -2.167924>,
      < -6.625832, -0.603356, -2.159971>
    }
    triangle {
      < -6.616529, -0.611356, -2.318170>,
      < -6.625832, -0.603356, -2.159971>,
      < -6.607658, -0.603356, -2.326123>
    }
    triangle {
      < -6.634702, -0.611356, -2.152019>,
      < -6.651136, -0.611356, -2.001772>,
      < -6.644006, -0.603356, -1.993820>
    }
    triangle {
      < -6.634702, -0.611356, -2.152019>,
      < -6.644006, -0.603356, -1.993820>,
      < -6.625832, -0.603356, -2.159971>
    }
    triangle {
      < -6.652875, -0.611356, -1.985867>,
      < -6.669310, -0.611356, -1.835621>,
      < -6.662179, -0.603356, -1.827668>
    }
    triangle {
      < -6.652875, -0.611356, -1.985867>,
      < -6.662179, -0.603356, -1.827668>,
      < -6.644006, -0.603356, -1.993820>
    }
    triangle {
      < -6.671050, -0.611356, -1.819715>,
      < -6.687484, -0.611356, -1.669469>,
      < -6.680354, -0.603356, -1.661516>
    }
    triangle {
      < -6.671050, -0.611356, -1.819715>,
      < -6.680354, -0.603356, -1.661516>,
      < -6.662179, -0.603356, -1.827668>
    }
    triangle {
      < -6.689224, -0.611356, -1.653564>,
      < -6.705658, -0.611356, -1.503318>,
      < -6.698528, -0.603356, -1.495365>
    }
    triangle {
      < -6.689224, -0.611356, -1.653564>,
      < -6.698528, -0.603356, -1.495365>,
      < -6.680354, -0.603356, -1.661516>
    }
    triangle {
      < -6.707397, -0.611356, -1.487412>,
      < -6.723832, -0.611356, -1.337166>,
      < -6.716702, -0.603356, -1.329213>
    }
    triangle {
      < -6.707397, -0.611356, -1.487412>,
      < -6.716702, -0.603356, -1.329213>,
      < -6.698528, -0.603356, -1.495365>
    }
    triangle {
      < -6.725572, -0.611356, -1.321261>,
      < -6.742006, -0.611356, -1.171014>,
      < -6.734876, -0.603356, -1.163062>
    }
    triangle {
      < -6.725572, -0.611356, -1.321261>,
      < -6.734876, -0.603356, -1.163062>,
      < -6.716702, -0.603356, -1.329213>
    }
    triangle {
      < -6.743745, -0.611356, -1.155109>,
      < -6.760180, -0.611356, -1.004863>,
      < -6.753049, -0.603356, -0.996910>
    }
    triangle {
      < -6.743745, -0.611356, -1.155109>,
      < -6.753049, -0.603356, -0.996910>,
      < -6.734876, -0.603356, -1.163062>
    }
    triangle {
      < -6.761919, -0.611356, -0.988958>,
      < -6.778354, -0.611356, -0.838711>,
      < -6.771224, -0.603356, -0.830759>
    }
    triangle {
      < -6.761919, -0.611356, -0.988958>,
      < -6.771224, -0.603356, -0.830759>,
      < -6.753049, -0.603356, -0.996910>
    }
    triangle {
      < -6.780094, -0.611356, -0.822806>,
      < -6.796528, -0.611356, -0.672559>,
      < -6.789398, -0.603356, -0.664607>
    }
    triangle {
      < -6.780094, -0.611356, -0.822806>,
      < -6.789398, -0.603356, -0.664607>,
      < -6.771224, -0.603356, -0.830759>
    }
    triangle {
      < -6.798267, -0.611356, -0.656654>,
      < -6.814702, -0.611356, -0.506408>,
      < -6.807571, -0.603356, -0.498455>
    }
    triangle {
      < -6.798267, -0.611356, -0.656654>,
      < -6.807571, -0.603356, -0.498455>,
      < -6.789398, -0.603356, -0.664607>
    }
    triangle {
      < -6.816442, -0.611356, -0.490503>,
      < -6.832876, -0.611356, -0.340256>,
      < -6.825746, -0.603356, -0.332304>
    }
    triangle {
      < -6.816442, -0.611356, -0.490503>,
      < -6.825746, -0.603356, -0.332304>,
      < -6.807571, -0.603356, -0.498455>
    }
    triangle {
      < -6.834615, -0.611356, -0.324351>,
      < -6.851050, -0.611356, -0.174104>,
      < -6.843919, -0.603356, -0.166152>
    }
    triangle {
      < -6.834615, -0.611356, -0.324351>,
      < -6.843919, -0.603356, -0.166152>,
      < -6.825746, -0.603356, -0.332304>
    }
    triangle {
      < -6.852789, -0.611356, -0.158199>,
      < -6.869224, -0.611356, -0.007953>,
      < -6.862093, -0.603356, 0.000000>
    }
    triangle {
      < -6.852789, -0.611356, -0.158199>,
      < -6.862093, -0.603356, 0.000000>,
      < -6.843919, -0.603356, -0.166152>
    }
    triangle {
      < -6.851051, -1.603042, -0.174104>,
      < -6.834616, -1.603042, -0.324351>,
      < -6.825746, -1.611042, -0.332303>
    }
    triangle {
      < -6.851051, -1.603042, -0.174104>,
      < -6.825746, -1.611042, -0.332303>,
      < -6.843920, -1.611042, -0.166151>
    }
    triangle {
      < -6.869224, -1.603042, -0.007953>,
      < -6.852790, -1.603042, -0.158199>,
      < -6.843920, -1.611042, -0.166151>
    }
    triangle {
      < -6.869224, -1.603042, -0.007953>,
      < -6.843920, -1.611042, -0.166151>,
      < -6.862093, -1.611042, 0.000000>
    }
    triangle {
      < -6.832877, -1.603042, -0.340256>,
      < -6.816443, -1.603042, -0.490502>,
      < -6.807573, -1.611042, -0.498455>
    }
    triangle {
      < -6.832877, -1.603042, -0.340256>,
      < -6.807573, -1.611042, -0.498455>,
      < -6.825746, -1.611042, -0.332303>
    }
    triangle {
      < -6.814703, -1.603042, -0.506407>,
      < -6.798269, -1.603042, -0.656654>,
      < -6.789399, -1.611042, -0.664606>
    }
    triangle {
      < -6.814703, -1.603042, -0.506407>,
      < -6.789399, -1.611042, -0.664606>,
      < -6.807573, -1.611042, -0.498455>
    }
    triangle {
      < -6.796529, -1.603042, -0.672559>,
      < -6.780095, -1.603042, -0.822805>,
      < -6.771225, -1.611042, -0.830758>
    }
    triangle {
      < -6.796529, -1.603042, -0.672559>,
      < -6.771225, -1.611042, -0.830758>,
      < -6.789399, -1.611042, -0.664606>
    }
    triangle {
      < -6.778356, -1.603042, -0.838710>,
      < -6.761921, -1.603042, -0.988957>,
      < -6.753051, -1.611042, -0.996910>
    }
    triangle {
      < -6.778356, -1.603042, -0.838710>,
      < -6.753051, -1.611042, -0.996910>,
      < -6.771225, -1.611042, -0.830758>
    }
    triangle {
      < -6.760181, -1.603042, -1.004862>,
      < -6.743747, -1.603042, -1.155109>,
      < -6.734877, -1.611042, -1.163061>
    }
    triangle {
      < -6.760181, -1.603042, -1.004862>,
      < -6.734877, -1.611042, -1.163061>,
      < -6.753051, -1.611042, -0.996910>
    }
    triangle {
      < -6.742008, -1.603042, -1.171014>,
      < -6.725573, -1.603042, -1.321260>,
      < -6.716703, -1.611042, -1.329213>
    }
    triangle {
      < -6.742008, -1.603042, -1.171014>,
      < -6.716703, -1.611042, -1.329213>,
      < -6.734877, -1.611042, -1.163061>
    }
    triangle {
      < -6.723834, -1.603042, -1.337165>,
      < -6.707399, -1.603042, -1.487412>,
      < -6.698529, -1.611042, -1.495364>
    }
    triangle {
      < -6.723834, -1.603042, -1.337165>,
      < -6.698529, -1.611042, -1.495364>,
      < -6.716703, -1.611042, -1.329213>
    }
    triangle {
      < -6.705659, -1.603042, -1.503317>,
      < -6.689225, -1.603042, -1.653563>,
      < -6.680355, -1.611042, -1.661516>
    }
    triangle {
      < -6.705659, -1.603042, -1.503317>,
      < -6.680355, -1.611042, -1.661516>,
      < -6.698529, -1.611042, -1.495364>
    }
    triangle {
      < -6.687486, -1.603042, -1.669468>,
      < -6.671051, -1.603042, -1.819715>,
      < -6.662181, -1.611042, -1.827667>
    }
    triangle {
      < -6.687486, -1.603042, -1.669468>,
      < -6.662181, -1.611042, -1.827667>,
      < -6.680355, -1.611042, -1.661516>
    }
    triangle {
      < -6.669312, -1.603042, -1.835620>,
      < -6.652877, -1.603042, -1.985867>,
      < -6.644007, -1.611042, -1.993819>
    }
    triangle {
      < -6.669312, -1.603042, -1.835620>,
      < -6.644007, -1.611042, -1.993819>,
      < -6.662181, -1.611042, -1.827667>
    }
    triangle {
      < -6.651138, -1.603042, -2.001772>,
      < -6.634703, -1.603042, -2.152018>,
      < -6.625833, -1.611042, -2.159971>
    }
    triangle {
      < -6.651138, -1.603042, -2.001772>,
      < -6.625833, -1.611042, -2.159971>,
      < -6.644007, -1.611042, -1.993819>
    }
    triangle {
      < -6.632964, -1.603042, -2.167923>,
      < -6.616529, -1.603042, -2.318170>,
      < -6.607659, -1.611042, -2.326122>
    }
    triangle {
      < -6.632964, -1.603042, -2.167923>,
      < -6.607659, -1.611042, -2.326122>,
      < -6.625833, -1.611042, -2.159971>
    }
    triangle {
      < -6.614789, -1.603042, -2.334075>,
      < -6.598355, -1.603042, -2.484322>,
      < -6.589485, -1.611042, -2.492274>
    }
    triangle {
      < -6.614789, -1.603042, -2.334075>,
      < -6.589485, -1.611042, -2.492274>,
      < -6.607659, -1.611042, -2.326122>
    }
    triangle {
      < -6.596616, -1.603042, -2.500227>,
      < -6.580181, -1.603042, -2.650473>,
      < -6.571311, -1.611042, -2.658426>
    }
    triangle {
      < -6.596616, -1.603042, -2.500227>,
      < -6.571311, -1.611042, -2.658426>,
      < -6.589485, -1.611042, -2.492274>
    }
    triangle {
      < -6.598354, -1.603042, 2.484322>,
      < -6.614789, -1.603042, 2.334076>,
      < -6.607658, -1.611042, 2.326123>
    }
    triangle {
      < -6.598354, -1.603042, 2.484322>,
      < -6.607658, -1.611042, 2.326123>,
      < -6.589485, -1.611042, 2.492275>
    }
    triangle {
      < -6.580181, -1.603042, 2.650474>,
      < -6.596615, -1.603042, 2.500227>,
      < -6.589485, -1.611042, 2.492275>
    }
    triangle {
      < -6.580181, -1.603042, 2.650474>,
      < -6.589485, -1.611042, 2.492275>,
      < -6.571311, -1.611042, 2.658426>
    }
    triangle {
      < -6.616529, -1.603042, 2.318171>,
      < -6.632963, -1.603042, 2.167924>,
      < -6.625833, -1.611042, 2.159971>
    }
    triangle {
      < -6.616529, -1.603042, 2.318171>,
      < -6.625833, -1.611042, 2.159971>,
      < -6.607658, -1.611042, 2.326123>
    }
    triangle {
      < -6.634702, -1.603042, 2.152019>,
      < -6.651136, -1.603042, 2.001772>,
      < -6.644006, -1.611042, 1.993820>
    }
    triangle {
      < -6.634702, -1.603042, 2.152019>,
      < -6.644006, -1.611042, 1.993820>,
      < -6.625833, -1.611042, 2.159971>
    }
    triangle {
      < -6.652875, -1.603042, 1.985867>,
      < -6.669310, -1.603042, 1.835621>,
      < -6.662179, -1.611042, 1.827668>
    }
    triangle {
      < -6.652875, -1.603042, 1.985867>,
      < -6.662179, -1.611042, 1.827668>,
      < -6.644006, -1.611042, 1.993820>
    }
    triangle {
      < -6.671050, -1.603042, 1.819715>,
      < -6.687484, -1.603042, 1.669469>,
      < -6.680354, -1.611042, 1.661516>
    }
    triangle {
      < -6.671050, -1.603042, 1.819715>,
      < -6.680354, -1.611042, 1.661516>,
      < -6.662179, -1.611042, 1.827668>
    }
    triangle {
      < -6.689224, -1.603042, 1.653564>,
      < -6.705658, -1.603042, 1.503318>,
      < -6.698528, -1.611042, 1.495365>
    }
    triangle {
      < -6.689224, -1.603042, 1.653564>,
      < -6.698528, -1.611042, 1.495365>,
      < -6.680354, -1.611042, 1.661516>
    }
    triangle {
      < -6.707397, -1.603042, 1.487412>,
      < -6.723832, -1.603042, 1.337166>,
      < -6.716702, -1.611042, 1.329213>
    }
    triangle {
      < -6.707397, -1.603042, 1.487412>,
      < -6.716702, -1.611042, 1.329213>,
      < -6.698528, -1.611042, 1.495365>
    }
    triangle {
      < -6.725572, -1.603042, 1.321261>,
      < -6.742006, -1.603042, 1.171014>,
      < -6.734876, -1.611042, 1.163062>
    }
    triangle {
      < -6.725572, -1.603042, 1.321261>,
      < -6.734876, -1.611042, 1.163062>,
      < -6.716702, -1.611042, 1.329213>
    }
    triangle {
      < -6.743745, -1.603042, 1.155109>,
      < -6.760180, -1.603042, 1.004863>,
      < -6.753049, -1.611042, 0.996910>
    }
    triangle {
      < -6.743745, -1.603042, 1.155109>,
      < -6.753049, -1.611042, 0.996910>,
      < -6.734876, -1.611042, 1.163062>
    }
    triangle {
      < -6.761919, -1.603042, 0.988958>,
      < -6.778354, -1.603042, 0.838711>,
      < -6.771224, -1.611042, 0.830759>
    }
    triangle {
      < -6.761919, -1.603042, 0.988958>,
      < -6.771224, -1.611042, 0.830759>,
      < -6.753049, -1.611042, 0.996910>
    }
    triangle {
      < -6.780094, -1.603042, 0.822806>,
      < -6.796528, -1.603042, 0.672559>,
      < -6.789398, -1.611042, 0.664607>
    }
    triangle {
      < -6.780094, -1.603042, 0.822806>,
      < -6.789398, -1.611042, 0.664607>,
      < -6.771224, -1.611042, 0.830759>
    }
    triangle {
      < -6.798267, -1.603042, 0.656654>,
      < -6.814702, -1.603042, 0.506408>,
      < -6.807571, -1.611042, 0.498455>
    }
    triangle {
      < -6.798267, -1.603042, 0.656654>,
      < -6.807571, -1.611042, 0.498455>,
      < -6.789398, -1.611042, 0.664607>
    }
    triangle {
      < -6.816442, -1.603042, 0.490503>,
      < -6.832876, -1.603042, 0.340256>,
      < -6.825746, -1.611042, 0.332303>
    }
    triangle {
      < -6.816442, -1.603042, 0.490503>,
      < -6.825746, -1.611042, 0.332303>,
      < -6.807571, -1.611042, 0.498455>
    }
    triangle {
      < -6.834615, -1.603042, 0.324351>,
      < -6.851050, -1.603042, 0.174104>,
      < -6.843919, -1.611042, 0.166152>
    }
    triangle {
      < -6.834615, -1.603042, 0.324351>,
      < -6.843919, -1.611042, 0.166152>,
      < -6.825746, -1.611042, 0.332303>
    }
    triangle {
      < -6.852789, -1.603042, 0.158199>,
      < -6.869224, -1.603042, 0.007953>,
      < -6.862093, -1.611042, 0.000000>
    }
    triangle {
      < -6.852789, -1.603042, 0.158199>,
      < -6.862093, -1.611042, 0.000000>,
      < -6.843919, -1.611042, 0.166152>
    }
    triangle {
      < -6.851051, -0.611356, 0.174104>,
      < -6.834616, -0.611356, 0.324351>,
      < -6.825746, -0.603356, 0.332303>
    }
    triangle {
      < -6.851051, -0.611356, 0.174104>,
      < -6.825746, -0.603356, 0.332303>,
      < -6.843920, -0.603356, 0.166151>
    }
    triangle {
      < -6.869224, -0.611356, 0.007953>,
      < -6.852790, -0.611356, 0.158199>,
      < -6.843920, -0.603356, 0.166151>
    }
    triangle {
      < -6.869224, -0.611356, 0.007953>,
      < -6.843920, -0.603356, 0.166151>,
      < -6.862093, -0.603356, 0.000000>
    }
    triangle {
      < -6.832877, -0.611356, 0.340256>,
      < -6.816443, -0.611356, 0.490502>,
      < -6.807573, -0.603356, 0.498455>
    }
    triangle {
      < -6.832877, -0.611356, 0.340256>,
      < -6.807573, -0.603356, 0.498455>,
      < -6.825746, -0.603356, 0.332303>
    }
    triangle {
      < -6.814703, -0.611356, 0.506407>,
      < -6.798269, -0.611356, 0.656654>,
      < -6.789399, -0.603356, 0.664606>
    }
    triangle {
      < -6.814703, -0.611356, 0.506407>,
      < -6.789399, -0.603356, 0.664606>,
      < -6.807573, -0.603356, 0.498455>
    }
    triangle {
      < -6.796529, -0.611356, 0.672559>,
      < -6.780095, -0.611356, 0.822805>,
      < -6.771225, -0.603356, 0.830758>
    }
    triangle {
      < -6.796529, -0.611356, 0.672559>,
      < -6.771225, -0.603356, 0.830758>,
      < -6.789399, -0.603356, 0.664606>
    }
    triangle {
      < -6.778356, -0.611356, 0.838711>,
      < -6.761921, -0.611356, 0.988957>,
      < -6.753051, -0.603356, 0.996910>
    }
    triangle {
      < -6.778356, -0.611356, 0.838711>,
      < -6.753051, -0.603356, 0.996910>,
      < -6.771225, -0.603356, 0.830758>
    }
    triangle {
      < -6.760181, -0.611356, 1.004862>,
      < -6.743747, -0.611356, 1.155109>,
      < -6.734877, -0.603356, 1.163061>
    }
    triangle {
      < -6.760181, -0.611356, 1.004862>,
      < -6.734877, -0.603356, 1.163061>,
      < -6.753051, -0.603356, 0.996910>
    }
    triangle {
      < -6.742008, -0.611356, 1.171014>,
      < -6.725573, -0.611356, 1.321260>,
      < -6.716703, -0.603356, 1.329213>
    }
    triangle {
      < -6.742008, -0.611356, 1.171014>,
      < -6.716703, -0.603356, 1.329213>,
      < -6.734877, -0.603356, 1.163061>
    }
    triangle {
      < -6.723834, -0.611356, 1.337165>,
      < -6.707399, -0.611356, 1.487412>,
      < -6.698529, -0.603356, 1.495364>
    }
    triangle {
      < -6.723834, -0.611356, 1.337165>,
      < -6.698529, -0.603356, 1.495364>,
      < -6.716703, -0.603356, 1.329213>
    }
    triangle {
      < -6.705659, -0.611356, 1.503317>,
      < -6.689225, -0.611356, 1.653563>,
      < -6.680355, -0.603356, 1.661516>
    }
    triangle {
      < -6.705659, -0.611356, 1.503317>,
      < -6.680355, -0.603356, 1.661516>,
      < -6.698529, -0.603356, 1.495364>
    }
    triangle {
      < -6.687486, -0.611356, 1.669469>,
      < -6.671051, -0.611356, 1.819715>,
      < -6.662181, -0.603356, 1.827668>
    }
    triangle {
      < -6.687486, -0.611356, 1.669469>,
      < -6.662181, -0.603356, 1.827668>,
      < -6.680355, -0.603356, 1.661516>
    }
    triangle {
      < -6.669312, -0.611356, 1.835620>,
      < -6.652877, -0.611356, 1.985867>,
      < -6.644007, -0.603356, 1.993819>
    }
    triangle {
      < -6.669312, -0.611356, 1.835620>,
      < -6.644007, -0.603356, 1.993819>,
      < -6.662181, -0.603356, 1.827668>
    }
    triangle {
      < -6.651138, -0.611356, 2.001772>,
      < -6.634703, -0.611356, 2.152019>,
      < -6.625833, -0.603356, 2.159971>
    }
    triangle {
      < -6.651138, -0.611356, 2.001772>,
      < -6.625833, -0.603356, 2.159971>,
      < -6.644007, -0.603356, 1.993819>
    }
    triangle {
      < -6.632964, -0.611356, 2.167924>,
      < -6.616529, -0.611356, 2.318170>,
      < -6.607659, -0.603356, 2.326123>
    }
    triangle {
      < -6.632964, -0.611356, 2.167924>,
      < -6.607659, -0.603356, 2.326123>,
      < -6.625833, -0.603356, 2.159971>
    }
    triangle {
      < -6.614789, -0.611356, 2.334075>,
      < -6.598355, -0.611356, 2.484322>,
      < -6.589485, -0.603356, 2.492275>
    }
    triangle {
      < -6.614789, -0.611356, 2.334075>,
      < -6.589485, -0.603356, 2.492275>,
      < -6.607659, -0.603356, 2.326123>
    }
    triangle {
      < -6.596616, -0.611356, 2.500227>,
      < -6.580181, -0.611356, 2.650474>,
      < -6.571311, -0.603356, 2.658426>
    }
    triangle {
      < -6.596616, -0.611356, 2.500227>,
      < -6.571311, -0.603356, 2.658426>,
      < -6.589485, -0.603356, 2.492275>
    }
    texture {grill}
  }
  // body
  union {
    triangle {
      < -6.731758, -0.579482, -2.454350>,
      < -6.771651, -0.604478, -2.457309>,
      < -6.802513, -0.564470, -2.244009>
    }
    triangle {
      < -6.731758, -0.579482, -2.454350>,
      < -6.802513, -0.564470, -2.244009>,
      < -6.757634, -0.549474, -2.240680>
    }
    triangle {
      < -6.660256, -0.699497, -2.810031>,
      < -6.705142, -0.629490, -2.677993>,
      < -6.710492, -0.559489, -2.673378>
    }
    triangle {
      < -6.660256, -0.699497, -2.810031>,
      < -6.710492, -0.559489, -2.673378>,
      < -6.636048, -0.519499, -2.798213>
    }
    triangle {
      < -6.667507, -0.139475, -1.968278>,
      < -6.726426, -0.319472, -2.052864>,
      < -6.709450, -0.434472, -2.011491>
    }
    triangle {
      < -6.710492, -0.559489, -2.673378>,
      < -6.741506, -0.487581, -2.733489>,
      < -6.741866, -0.439490, -2.791026>
    }
    triangle {
      < -6.710492, -0.559489, -2.673378>,
      < -6.741866, -0.439490, -2.791026>,
      < -6.636048, -0.519499, -2.798213>
    }
    triangle {
      < -6.739315, -0.539283, -2.555220>,
      < -6.710492, -0.559489, -2.673378>,
      < -6.731758, -0.579482, -2.454350>
    }
    triangle {
      < -6.739315, -0.539283, -2.555220>,
      < -6.731758, -0.579482, -2.454350>,
      < -6.737481, -0.549481, -2.444748>
    }
    triangle {
      < -6.524671, -0.444511, -2.880200>,
      < -6.741866, -0.439490, -2.791026>,
      < -6.741947, -0.371911, -2.834569>
    }
    triangle {
      < -6.757634, -0.549474, -2.240680>,
      < -6.737584, -0.541778, -2.342008>,
      < -6.737481, -0.549481, -2.444748>
    }
    triangle {
      < -6.757634, -0.549474, -2.240680>,
      < -6.737481, -0.549481, -2.444748>,
      < -6.731758, -0.579482, -2.454350>
    }
    triangle {
      < -6.802513, -0.564470, -2.244009>,
      < -6.743057, -0.509471, -2.099216>,
      < -6.757634, -0.549474, -2.240680>
    }
    triangle {
      < -6.757634, -0.549474, -2.240680>,
      < -6.743057, -0.509471, -2.099216>,
      < -6.726615, -0.459473, -2.118052>
    }
    triangle {
      < -6.757634, -0.549474, -2.240680>,
      < -6.726615, -0.459473, -2.118052>,
      < -6.732151, -0.500433, -2.174088>
    }
    triangle {
      < -6.741866, -0.439490, -2.791026>,
      < -6.524671, -0.444511, -2.880200>,
      < -6.636048, -0.519499, -2.798213>
    }
    triangle {
      < -6.660256, -0.699497, -2.810031>,
      < -6.636048, -0.519499, -2.798213>,
      < -6.524671, -0.444511, -2.880200>
    }
    triangle {
      < -6.660256, -0.699497, -2.810031>,
      < -6.524671, -0.444511, -2.880200>,
      < -6.458776, -0.844517, -2.890340>
    }
    triangle {
      < -6.705142, -0.629490, -2.677993>,
      < -6.771651, -0.604478, -2.457309>,
      < -6.731758, -0.579482, -2.454350>
    }
    triangle {
      < -6.705142, -0.629490, -2.677993>,
      < -6.731758, -0.579482, -2.454350>,
      < -6.710492, -0.559489, -2.673378>
    }
    triangle {
      < -6.726426, -0.319472, -2.052864>,
      < -6.667507, -0.139475, -1.968278>,
      < -6.642935, -0.014477, -1.961445>
    }
    triangle {
      < -6.726426, -0.319472, -2.052864>,
      < -6.642935, -0.014477, -1.961445>,
      < -6.733982, -0.079470, -2.018336>
    }
    triangle {
      < -6.709450, -0.434472, -2.011491>,
      < -6.726521, -0.394538, -2.074579>,
      < -6.726615, -0.459473, -2.118052>
    }
    triangle {
      < -6.709450, -0.434472, -2.011491>,
      < -6.726615, -0.459473, -2.118052>,
      < -6.743057, -0.509471, -2.099216>
    }
    triangle {
      < -6.726521, -0.394538, -2.074579>,
      < -6.709450, -0.434472, -2.011491>,
      < -6.726426, -0.319472, -2.052864>
    }
    triangle {
      < -6.757634, -0.549474, -2.240680>,
      < -6.732151, -0.500433, -2.174088>,
      < -6.737687, -0.524475, -2.239201>
    }
    triangle {
      < -6.737584, -0.541778, -2.342008>,
      < -6.757634, -0.549474, -2.240680>,
      < -6.737687, -0.524475, -2.239201>
    }
    triangle {
      < -6.710492, -0.559489, -2.673378>,
      < -6.739315, -0.539283, -2.555220>,
      < -6.741147, -0.519486, -2.665626>
    }
    triangle {
      < -6.741506, -0.487581, -2.733489>,
      < -6.710492, -0.559489, -2.673378>,
      < -6.741147, -0.519486, -2.665626>
    }
    triangle {
      < -6.524671, -0.444511, -2.880200>,
      < -6.741947, -0.371911, -2.834569>,
      < -6.742029, -0.294491, -2.856221>
    }
    triangle {
      < -6.524671, -0.444511, -2.880200>,
      < -6.742029, -0.294491, -2.856221>,
      < -6.549592, -0.329509, -2.882052>
    }
    triangle {
      < -6.757634, -0.549474, 2.240680>,
      < -6.802513, -0.564470, 2.244009>,
      < -6.771651, -0.604478, 2.457309>
    }
    triangle {
      < -6.757634, -0.549474, 2.240680>,
      < -6.771651, -0.604478, 2.457309>,
      < -6.731758, -0.579482, 2.454350>
    }
    triangle {
      < -6.636048, -0.519499, 2.798213>,
      < -6.710492, -0.559489, 2.673378>,
      < -6.705142, -0.629490, 2.677993>
    }
    triangle {
      < -6.636048, -0.519499, 2.798213>,
      < -6.705142, -0.629490, 2.677993>,
      < -6.660256, -0.699497, 2.810031>
    }
    triangle {
      < -6.709450, -0.434472, 2.011491>,
      < -6.726426, -0.319472, 2.052864>,
      < -6.667507, -0.139475, 1.968278>
    }
    triangle {
      < -6.636048, -0.519499, 2.798213>,
      < -6.741866, -0.439490, 2.791026>,
      < -6.741506, -0.487581, 2.733489>
    }
    triangle {
      < -6.636048, -0.519499, 2.798213>,
      < -6.741506, -0.487581, 2.733489>,
      < -6.710492, -0.559489, 2.673378>
    }
    triangle {
      < -6.737481, -0.549481, 2.444748>,
      < -6.731758, -0.579482, 2.454350>,
      < -6.710492, -0.559489, 2.673378>
    }
    triangle {
      < -6.737481, -0.549481, 2.444748>,
      < -6.710492, -0.559489, 2.673378>,
      < -6.739315, -0.539283, 2.555220>
    }
    triangle {
      < -6.741947, -0.371911, 2.834569>,
      < -6.741866, -0.439490, 2.791026>,
      < -6.524671, -0.444511, 2.880200>
    }
    triangle {
      < -6.731758, -0.579482, 2.454350>,
      < -6.737481, -0.549481, 2.444748>,
      < -6.737584, -0.541778, 2.342008>
    }
    triangle {
      < -6.731758, -0.579482, 2.454350>,
      < -6.737584, -0.541778, 2.342008>,
      < -6.757634, -0.549474, 2.240680>
    }
    triangle {
      < -6.757634, -0.549474, 2.240680>,
      < -6.743057, -0.509471, 2.099216>,
      < -6.802513, -0.564470, 2.244009>
    }
    triangle {
      < -6.732151, -0.500433, 2.174088>,
      < -6.726615, -0.459473, 2.118052>,
      < -6.743057, -0.509471, 2.099216>
    }
    triangle {
      < -6.732151, -0.500433, 2.174088>,
      < -6.743057, -0.509471, 2.099216>,
      < -6.757634, -0.549474, 2.240680>
    }
    triangle {
      < -6.636048, -0.519499, 2.798213>,
      < -6.524671, -0.444511, 2.880200>,
      < -6.741866, -0.439490, 2.791026>
    }
    triangle {
      < -6.458776, -0.844517, 2.890340>,
      < -6.524671, -0.444511, 2.880200>,
      < -6.636048, -0.519499, 2.798213>
    }
    triangle {
      < -6.458776, -0.844517, 2.890340>,
      < -6.636048, -0.519499, 2.798213>,
      < -6.660256, -0.699497, 2.810031>
    }
    triangle {
      < -6.710492, -0.559489, 2.673378>,
      < -6.731758, -0.579482, 2.454350>,
      < -6.771651, -0.604478, 2.457309>
    }
    triangle {
      < -6.710492, -0.559489, 2.673378>,
      < -6.771651, -0.604478, 2.457309>,
      < -6.705142, -0.629490, 2.677993>
    }
    triangle {
      < -6.733982, -0.079470, 2.018336>,
      < -6.642935, -0.014477, 1.961445>,
      < -6.667507, -0.139475, 1.968278>
    }
    triangle {
      < -6.733982, -0.079470, 2.018336>,
      < -6.667507, -0.139475, 1.968278>,
      < -6.726426, -0.319472, 2.052864>
    }
    triangle {
      < -6.743057, -0.509471, 2.099216>,
      < -6.726615, -0.459473, 2.118052>,
      < -6.726521, -0.394538, 2.074579>
    }
    triangle {
      < -6.743057, -0.509471, 2.099216>,
      < -6.726521, -0.394538, 2.074579>,
      < -6.709450, -0.434472, 2.011491>
    }
    triangle {
      < -6.726426, -0.319472, 2.052864>,
      < -6.709450, -0.434472, 2.011491>,
      < -6.726521, -0.394538, 2.074579>
    }
    triangle {
      < -6.737687, -0.524475, 2.239201>,
      < -6.732151, -0.500433, 2.174088>,
      < -6.757634, -0.549474, 2.240680>
    }
    triangle {
      < -6.737687, -0.524475, 2.239201>,
      < -6.757634, -0.549474, 2.240680>,
      < -6.737584, -0.541778, 2.342008>
    }
    triangle {
      < -6.741147, -0.519486, 2.665626>,
      < -6.739315, -0.539283, 2.555220>,
      < -6.710492, -0.559489, 2.673378>
    }
    triangle {
      < -6.741147, -0.519486, 2.665626>,
      < -6.710492, -0.559489, 2.673378>,
      < -6.741506, -0.487581, 2.733489>
    }
    triangle {
      < -6.549592, -0.329509, 2.882052>,
      < -6.742029, -0.294491, 2.856221>,
      < -6.741947, -0.371911, 2.834569>
    }
    triangle {
      < -6.549592, -0.329509, 2.882052>,
      < -6.741947, -0.371911, 2.834569>,
      < -6.524671, -0.444511, 2.880200>
    }
    triangle {
      < -6.792259, 0.385825, -2.457998>,
      < -6.793167, 0.370522, -2.504061>,
      < -7.045109, 0.325588, -2.499018>
    }
    triangle {
      < -6.792259, 0.385825, -2.457998>,
      < -7.045109, 0.325588, -2.499018>,
      < -7.042752, 0.341757, -2.455381>
    }
    triangle {
      < -6.793167, 0.370522, -2.504061>,
      < -6.792259, 0.385825, -2.457998>,
      < -6.371355, 0.434591, -2.459998>
    }
    triangle {
      < -6.793167, 0.370522, -2.504061>,
      < -6.371355, 0.434591, -2.459998>,
      < -6.372285, 0.415666, -2.503308>
    }
    triangle {
      < -2.199284, 0.494422, -2.489617>,
      < -3.314507, 0.507020, -2.480529>,
      < -3.323596, 0.495221, -2.437180>
    }
    triangle {
      < -2.199284, 0.494422, -2.489617>,
      < -3.323596, 0.495221, -2.437180>,
      < -2.201815, 0.475123, -2.446030>
    }
    triangle {
      < -6.372285, 0.415666, -2.503308>,
      < -6.371355, 0.434591, -2.459998>,
      < -5.516523, 0.470962, -2.461994>
    }
    triangle {
      < -6.372285, 0.415666, -2.503308>,
      < -5.516523, 0.470962, -2.461994>,
      < -5.511763, 0.447911, -2.509270>
    }
    triangle {
      < -5.516523, 0.470962, -2.461994>,
      < -4.644973, 0.497136, -2.467526>,
      < -4.646445, 0.480335, -2.515266>
    }
    triangle {
      < -5.516523, 0.470962, -2.461994>,
      < -4.646445, 0.480335, -2.515266>,
      < -5.511763, 0.447911, -2.509270>
    }
    triangle {
      < -4.644973, 0.497136, -2.467526>,
      < -3.314507, 0.507020, -2.480529>,
      < -3.305417, 0.485218, -2.523878>
    }
    triangle {
      < -4.644973, 0.497136, -2.467526>,
      < -3.305417, 0.485218, -2.523878>,
      < -4.646445, 0.480335, -2.515266>
    }
    triangle {
      < -6.792259, 0.385825, -2.457998>,
      < -7.042752, 0.341757, -2.455381>,
      < -7.040396, 0.324326, -2.411743>
    }
    triangle {
      < -6.792259, 0.385825, -2.457998>,
      < -7.040396, 0.324326, -2.411743>,
      < -6.791352, 0.367527, -2.411935>
    }
    triangle {
      < -6.371355, 0.434591, -2.459998>,
      < -6.792259, 0.385825, -2.457998>,
      < -6.791352, 0.367527, -2.411935>
    }
    triangle {
      < -6.371355, 0.434591, -2.459998>,
      < -6.791352, 0.367527, -2.411935>,
      < -6.370425, 0.419915, -2.416687>
    }
    triangle {
      < -5.516523, 0.470962, -2.461994>,
      < -6.371355, 0.434591, -2.459998>,
      < -6.370425, 0.419915, -2.416687>
    }
    triangle {
      < -5.516523, 0.470962, -2.461994>,
      < -6.370425, 0.419915, -2.416687>,
      < -5.521283, 0.460414, -2.414717>
    }
    triangle {
      < -4.644973, 0.497136, -2.467526>,
      < -5.516523, 0.470962, -2.461994>,
      < -5.521283, 0.460414, -2.414717>
    }
    triangle {
      < -4.644973, 0.497136, -2.467526>,
      < -5.521283, 0.460414, -2.414717>,
      < -4.643502, 0.480337, -2.419787>
    }
    triangle {
      < -3.314507, 0.507020, -2.480529>,
      < -4.644973, 0.497136, -2.467526>,
      < -4.643502, 0.480337, -2.419787>
    }
    triangle {
      < -3.314507, 0.507020, -2.480529>,
      < -4.643502, 0.480337, -2.419787>,
      < -3.323596, 0.495221, -2.437180>
    }
    triangle {
      < -2.040543, 0.480108, -2.497175>,
      < -2.199284, 0.494422, -2.489617>,
      < -2.201815, 0.475123, -2.446030>
    }
    triangle {
      < -7.045109, 0.325588, -2.499018>,
      < -7.040396, 0.324326, -2.411743>,
      < -7.042752, 0.341757, -2.455381>
    }
    triangle {
      < -2.199284, 0.494422, -2.489617>,
      < -2.040543, 0.480108, -2.497175>,
      < -2.196753, 0.480121, -2.533204>
    }
    triangle {
      < -3.314507, 0.507020, -2.480529>,
      < -2.199284, 0.494422, -2.489617>,
      < -2.196753, 0.480121, -2.533204>
    }
    triangle {
      < -3.314507, 0.507020, -2.480529>,
      < -2.196753, 0.480121, -2.533204>,
      < -3.305417, 0.485218, -2.523878>
    }
    triangle {
      < -6.774367, 0.325528, -2.216882>,
      < -6.791352, 0.367527, -2.411935>,
      < -7.040396, 0.324326, -2.411743>
    }
    triangle {
      < -6.774367, 0.325528, -2.216882>,
      < -7.040396, 0.324326, -2.411743>,
      < -6.998756, 0.275547, -2.233527>
    }
    triangle {
      < -6.315780, -0.001138, -2.889217>,
      < -6.493976, 0.000486, -2.887964>,
      < -6.685298, 0.070503, -2.877093>
    }
    triangle {
      < -6.315780, -0.001138, -2.889217>,
      < -6.685298, 0.070503, -2.877093>,
      < -6.313721, 0.085471, -2.884622>
    }
    triangle {
      < -6.744944, 0.220510, -2.816344>,
      < -6.937014, 0.200527, -2.795497>,
      < -7.011448, 0.280537, -2.670665>
    }
    triangle {
      < -6.744944, 0.220510, -2.816344>,
      < -7.011448, 0.280537, -2.670665>,
      < -6.774128, 0.320516, -2.693169>
    }
    triangle {
      < -6.601350, 0.230518, -2.048617>,
      < -6.752964, 0.255529, -2.099975>,
      < -6.709031, 0.120528, -2.016492>
    }
    triangle {
      < -2.775850, -1.619841, -3.005151>,
      < -2.749540, -1.604843, -2.992587>,
      < -2.569514, -1.869857, -2.919900>
    }
    triangle {
      < -5.929483, -0.974566, -2.996465>,
      < -5.914151, -0.939567, -3.000344>,
      < -5.706758, -0.979586, -3.025065>
    }
    triangle {
      < -5.929483, -0.974566, -2.996465>,
      < -5.706758, -0.979586, -3.025065>,
      < -5.722831, -1.024584, -3.011215>
    }
    triangle {
      < -6.493976, 0.000486, -2.887964>,
      < -6.508213, -0.204513, -2.899042>,
      < -6.543860, -0.259509, -2.891657>
    }
    triangle {
      < -6.493976, 0.000486, -2.887964>,
      < -6.543860, -0.259509, -2.891657>,
      < -6.742029, -0.294491, -2.856221>
    }
    triangle {
      < -6.493976, 0.000486, -2.887964>,
      < -6.742029, -0.294491, -2.856221>,
      < -6.745515, -0.069491, -2.876542>
    }
    triangle {
      < -6.744944, 0.220510, -2.816344>,
      < -6.685298, 0.070503, -2.877093>,
      < -6.831750, 0.065516, -2.862890>
    }
    triangle {
      < -6.744944, 0.220510, -2.816344>,
      < -6.831750, 0.065516, -2.862890>,
      < -6.937014, 0.200527, -2.795497>
    }
    triangle {
      < -6.793167, 0.370522, -2.504061>,
      < -6.774128, 0.320516, -2.693169>,
      < -7.011448, 0.280537, -2.670665>
    }
    triangle {
      < -6.793167, 0.370522, -2.504061>,
      < -7.011448, 0.280537, -2.670665>,
      < -7.045109, 0.325588, -2.499018>
    }
    triangle {
      < -5.491589, -0.769605, -3.019136>,
      < -5.706758, -0.979586, -3.025065>,
      < -5.914151, -0.939567, -3.000344>
    }
    triangle {
      < -5.491589, -0.769605, -3.019136>,
      < -5.914151, -0.939567, -3.000344>,
      < -5.926707, -0.864565, -2.966181>
    }
    triangle {
      < -5.491589, -0.769605, -3.019136>,
      < -5.926707, -0.864565, -2.966181>,
      < -5.538681, -0.719600, -2.992549>
    }
    triangle {
      < -5.318162, -0.594619, -2.991234>,
      < -5.047047, -0.519643, -2.996191>,
      < -5.024517, -0.579646, -3.029613>
    }
    triangle {
      < -5.318162, -0.594619, -2.991234>,
      < -5.024517, -0.579646, -3.029613>,
      < -5.285660, -0.649623, -3.023917>
    }
    triangle {
      < -6.774367, 0.325528, -2.216882>,
      < -6.998756, 0.275547, -2.233527>,
      < -6.937092, 0.210545, -2.118648>
    }
    triangle {
      < -6.774367, 0.325528, -2.216882>,
      < -6.937092, 0.210545, -2.118648>,
      < -6.752964, 0.255529, -2.099975>
    }
    triangle {
      < -6.328014, 0.315493, -2.083492>,
      < -6.325075, 0.255495, -1.988010>,
      < -6.020165, 0.320469, -1.975418>
    }
    triangle {
      < -6.262047, -0.349534, -2.905843>,
      < -6.250638, -0.849536, -2.925035>,
      < -6.458776, -0.844517, -2.890340>
    }
    triangle {
      < -6.262047, -0.349534, -2.905843>,
      < -6.458776, -0.844517, -2.890340>,
      < -6.524671, -0.444511, -2.880200>
    }
    triangle {
      < -4.627038, 0.415328, -2.709360>,
      < -3.300608, 0.415212, -2.715453>,
      < -3.296589, 0.300209, -2.834231>
    }
    triangle {
      < -4.627038, 0.415328, -2.709360>,
      < -3.296589, 0.300209, -2.834231>,
      < -4.613553, 0.305324, -2.823673>
    }
    triangle {
      < -4.613553, 0.305324, -2.823673>,
      < -3.296589, 0.300209, -2.834231>,
      < -3.271854, 0.145205, -2.899896>
    }
    triangle {
      < -4.613553, 0.305324, -2.823673>,
      < -3.271854, 0.145205, -2.899896>,
      < -4.588072, 0.150320, -2.896983>
    }
    triangle {
      < -6.705142, -0.629490, -2.677993>,
      < -6.729341, -0.694488, -2.689813>,
      < -6.742830, -0.644484, -2.575500>
    }
    triangle {
      < -6.667507, -0.139475, -1.968278>,
      < -6.668155, -0.139472, -1.861905>,
      < -6.623542, -0.034476, -1.865155>
    }
    triangle {
      < -6.667507, -0.139475, -1.968278>,
      < -6.623542, -0.034476, -1.865155>,
      < -6.642935, -0.014477, -1.961445>
    }
    triangle {
      < -4.614746, 0.425346, -1.996497>,
      < -4.639324, 0.415351, -1.867963>,
      < -3.357367, 0.464914, -1.876387>
    }
    triangle {
      < -4.614746, 0.425346, -1.996497>,
      < -3.357367, 0.464914, -1.876387>,
      < -3.328631, 0.470232, -2.031439>
    }
    triangle {
      < -4.639324, 0.415351, -1.867963>,
      < -4.614746, 0.425346, -1.996497>,
      < -5.498256, 0.375423, -1.981823>
    }
    triangle {
      < -4.639324, 0.415351, -1.867963>,
      < -5.498256, 0.375423, -1.981823>,
      < -5.511751, 0.360427, -1.867509>
    }
    triangle {
      < -6.020165, 0.320469, -1.975418>,
      < -6.045046, 0.300474, -1.864676>,
      < -5.511751, 0.360427, -1.867509>
    }
    triangle {
      < -6.020165, 0.320469, -1.975418>,
      < -5.511751, 0.360427, -1.867509>,
      < -5.498256, 0.375423, -1.981823>
    }
    triangle {
      < -6.325075, 0.255495, -1.988010>,
      < -6.336598, 0.220499, -1.865870>,
      < -6.045046, 0.300474, -1.864676>
    }
    triangle {
      < -6.325075, 0.255495, -1.988010>,
      < -6.045046, 0.300474, -1.864676>,
      < -6.020165, 0.320469, -1.975418>
    }
    triangle {
      < -6.481136, 0.185509, -1.979531>,
      < -6.460075, 0.150510, -1.868090>,
      < -6.336598, 0.220499, -1.865870>
    }
    triangle {
      < -6.481136, 0.185509, -1.979531>,
      < -6.336598, 0.220499, -1.865870>,
      < -6.325075, 0.255495, -1.988010>
    }
    triangle {
      < -6.773168, -0.484462, -1.856496>,
      < -6.743057, -0.509471, -2.099216>,
      < -6.802513, -0.564470, -2.244009>
    }
    triangle {
      < -6.773168, -0.484462, -1.856496>,
      < -6.802513, -0.564470, -2.244009>,
      < -6.840075, -0.524456, -1.851624>
    }
    triangle {
      < -6.709450, -0.434472, -2.011491>,
      < -6.723934, -0.419467, -1.857839>,
      < -6.668155, -0.139472, -1.861905>
    }
    triangle {
      < -6.709450, -0.434472, -2.011491>,
      < -6.668155, -0.139472, -1.861905>,
      < -6.667507, -0.139475, -1.968278>
    }
    triangle {
      < -6.743057, -0.509471, -2.099216>,
      < -6.773168, -0.484462, -1.856496>,
      < -6.723934, -0.419467, -1.857839>
    }
    triangle {
      < -6.743057, -0.509471, -2.099216>,
      < -6.723934, -0.419467, -1.857839>,
      < -6.709450, -0.434472, -2.011491>
    }
    triangle {
      < -6.707729, -0.774492, -2.778454>,
      < -6.660256, -0.699497, -2.810031>,
      < -6.458776, -0.844517, -2.890340>
    }
    triangle {
      < -6.707729, -0.774492, -2.778454>,
      < -6.458776, -0.844517, -2.890340>,
      < -6.680397, -0.914497, -2.876697>
    }
    triangle {
      < -6.729341, -0.694488, -2.689813>,
      < -6.705142, -0.629490, -2.677993>,
      < -6.660256, -0.699497, -2.810031>
    }
    triangle {
      < -6.729341, -0.694488, -2.689813>,
      < -6.660256, -0.699497, -2.810031>,
      < -6.707729, -0.774492, -2.778454>
    }
    triangle {
      < -6.771651, -0.604478, -2.457309>,
      < -6.705142, -0.629490, -2.677993>,
      < -6.742830, -0.644484, -2.575500>
    }
    triangle {
      < -6.370425, 0.419915, -2.416687>,
      < -6.348679, 0.375491, -2.210369>,
      < -5.503400, 0.430418, -2.182756>
    }
    triangle {
      < -6.370425, 0.419915, -2.416687>,
      < -5.503400, 0.430418, -2.182756>,
      < -5.521283, 0.460414, -2.414717>
    }
    triangle {
      < -6.774128, 0.320516, -2.693169>,
      < -6.793167, 0.370522, -2.504061>,
      < -6.372285, 0.415666, -2.503308>
    }
    triangle {
      < -6.774128, 0.320516, -2.693169>,
      < -6.372285, 0.415666, -2.503308>,
      < -6.347330, 0.360478, -2.701616>
    }
    triangle {
      < -6.744944, 0.220510, -2.816344>,
      < -6.774128, 0.320516, -2.693169>,
      < -6.347330, 0.360478, -2.701616>
    }
    triangle {
      < -6.744944, 0.220510, -2.816344>,
      < -6.347330, 0.360478, -2.701616>,
      < -6.333105, 0.245474, -2.825900>
    }
    triangle {
      < -6.685298, 0.070503, -2.877093>,
      < -6.744944, 0.220510, -2.816344>,
      < -6.333105, 0.245474, -2.825900>
    }
    triangle {
      < -6.685298, 0.070503, -2.877093>,
      < -6.333105, 0.245474, -2.825900>,
      < -6.313721, 0.085471, -2.884622>
    }
    triangle {
      < -6.348679, 0.375491, -2.210369>,
      < -6.370425, 0.419915, -2.416687>,
      < -6.791352, 0.367527, -2.411935>
    }
    triangle {
      < -6.348679, 0.375491, -2.210369>,
      < -6.791352, 0.367527, -2.411935>,
      < -6.774367, 0.325528, -2.216882>
    }
    triangle {
      < -6.328014, 0.315493, -2.083492>,
      < -6.348679, 0.375491, -2.210369>,
      < -6.774367, 0.325528, -2.216882>
    }
    triangle {
      < -6.328014, 0.315493, -2.083492>,
      < -6.774367, 0.325528, -2.216882>,
      < -6.752964, 0.255529, -2.099975>
    }
    triangle {
      < -6.481136, 0.185509, -1.979531>,
      < -6.601350, 0.230518, -2.048617>,
      < -6.709031, 0.120528, -2.016492>
    }
    triangle {
      < -6.481136, 0.185509, -1.979531>,
      < -6.709031, 0.120528, -2.016492>,
      < -6.587705, 0.095519, -1.962366>
    }
    triangle {
      < -6.709031, 0.120528, -2.016492>,
      < -6.642935, -0.014477, -1.961445>,
      < -6.587705, 0.095519, -1.962366>
    }
    triangle {
      < -6.601350, 0.230518, -2.048617>,
      < -6.481136, 0.185509, -1.979531>,
      < -6.325075, 0.255495, -1.988010>
    }
    triangle {
      < -6.601350, 0.230518, -2.048617>,
      < -6.325075, 0.255495, -1.988010>,
      < -6.328014, 0.315493, -2.083492>
    }
    triangle {
      < -6.752964, 0.255529, -2.099975>,
      < -6.601350, 0.230518, -2.048617>,
      < -6.328014, 0.315493, -2.083492>
    }
    triangle {
      < -6.709031, 0.120528, -2.016492>,
      < -6.752964, 0.255529, -2.099975>,
      < -6.937092, 0.210545, -2.118648>
    }
    triangle {
      < -6.709031, 0.120528, -2.016492>,
      < -6.937092, 0.210545, -2.118648>,
      < -6.822981, 0.070537, -2.034971>
    }
    triangle {
      < -6.642935, -0.014477, -1.961445>,
      < -6.709031, 0.120528, -2.016492>,
      < -6.822981, 0.070537, -2.034971>
    }
    triangle {
      < -6.642935, -0.014477, -1.961445>,
      < -6.822981, 0.070537, -2.034971>,
      < -6.758536, -0.009468, -2.025174>
    }
    triangle {
      < -6.642935, -0.014477, -1.961445>,
      < -6.758536, -0.009468, -2.025174>,
      < -6.733982, -0.079470, -2.018336>
    }
    triangle {
      < -6.533515, 0.065517, -1.860501>,
      < -6.460075, 0.150510, -1.868090>,
      < -6.481136, 0.185509, -1.979531>
    }
    triangle {
      < -6.533515, 0.065517, -1.860501>,
      < -6.481136, 0.185509, -1.979531>,
      < -6.587705, 0.095519, -1.962366>
    }
    triangle {
      < -6.020165, 0.320469, -1.975418>,
      < -5.498256, 0.375423, -1.981823>,
      < -5.503400, 0.430418, -2.182756>
    }
    triangle {
      < -6.020165, 0.320469, -1.975418>,
      < -5.503400, 0.430418, -2.182756>,
      < -6.348679, 0.375491, -2.210369>
    }
    triangle {
      < -6.020165, 0.320469, -1.975418>,
      < -6.348679, 0.375491, -2.210369>,
      < -6.328014, 0.315493, -2.083492>
    }
    triangle {
      < -6.111966, 0.006052, -2.894136>,
      < -6.315780, -0.001138, -2.889217>,
      < -6.313721, 0.085471, -2.884622>
    }
    triangle {
      < -6.111966, 0.006052, -2.894136>,
      < -6.313721, 0.085471, -2.884622>,
      < -5.486871, 0.121344, -2.892958>
    }
    triangle {
      < -4.627038, 0.415328, -2.709360>,
      < -4.646445, 0.480335, -2.515266>,
      < -3.305417, 0.485218, -2.523878>
    }
    triangle {
      < -4.627038, 0.415328, -2.709360>,
      < -3.305417, 0.485218, -2.523878>,
      < -3.300608, 0.415212, -2.715453>
    }
    triangle {
      < -5.505184, 0.280401, -2.834671>,
      < -5.513570, 0.391834, -2.705370>,
      < -4.627038, 0.415328, -2.709360>
    }
    triangle {
      < -5.505184, 0.280401, -2.834671>,
      < -4.627038, 0.415328, -2.709360>,
      < -4.613553, 0.305324, -2.823673>
    }
    triangle {
      < -5.486871, 0.121344, -2.892958>,
      < -5.505184, 0.280401, -2.834671>,
      < -4.613553, 0.305324, -2.823673>
    }
    triangle {
      < -5.486871, 0.121344, -2.892958>,
      < -4.613553, 0.305324, -2.823673>,
      < -4.588072, 0.150320, -2.896983>
    }
    triangle {
      < -4.547651, -0.229686, -2.969179>,
      < -4.588072, 0.150320, -2.896983>,
      < -3.271854, 0.145205, -2.899896>
    }
    triangle {
      < -4.547651, -0.229686, -2.969179>,
      < -3.271854, 0.145205, -2.899896>,
      < -3.223694, -0.234801, -2.974232>
    }
    triangle {
      < -4.640947, 0.455343, -2.183951>,
      < -4.614746, 0.425346, -1.996497>,
      < -3.328631, 0.470232, -2.031439>
    }
    triangle {
      < -4.640947, 0.455343, -2.183951>,
      < -3.328631, 0.470232, -2.031439>,
      < -3.331383, 0.470228, -2.197097>
    }
    triangle {
      < -3.323596, 0.495221, -2.437180>,
      < -3.331383, 0.470228, -2.197097>,
      < -2.450803, 0.470151, -2.222745>
    }
    triangle {
      < -3.323596, 0.495221, -2.437180>,
      < -2.450803, 0.470151, -2.222745>,
      < -2.271515, 0.470132, -2.351997>
    }
    triangle {
      < -3.323596, 0.495221, -2.437180>,
      < -2.271515, 0.470132, -2.351997>,
      < -2.201815, 0.475123, -2.446030>
    }
    triangle {
      < -6.119413, -0.199368, -2.911458>,
      < -5.446486, -0.229607, -2.950629>,
      < -6.257797, -0.244839, -2.907863>
    }
    triangle {
      < -6.119413, -0.199368, -2.911458>,
      < -6.257797, -0.244839, -2.907863>,
      < -6.326883, -0.204846, -2.903568>
    }
    triangle {
      < -6.508213, -0.204513, -2.899042>,
      < -6.326883, -0.204846, -2.903568>,
      < -6.257797, -0.244839, -2.907863>
    }
    triangle {
      < -6.508213, -0.204513, -2.899042>,
      < -6.257797, -0.244839, -2.907863>,
      < -6.543860, -0.259509, -2.891657>
    }
    triangle {
      < -6.326883, -0.204846, -2.903568>,
      < -6.508213, -0.204513, -2.899042>,
      < -6.448577, -0.172863, -2.900421>
    }
    triangle {
      < -6.119413, -0.199368, -2.911458>,
      < -6.326883, -0.204846, -2.903568>,
      < -6.268429, -0.173387, -2.904441>
    }
    triangle {
      < -5.446486, -0.229607, -2.950629>,
      < -6.119413, -0.199368, -2.911458>,
      < -6.060792, -0.167655, -2.911906>
    }
    triangle {
      < -6.347330, 0.360478, -2.701616>,
      < -6.372285, 0.415666, -2.503308>,
      < -5.511763, 0.447911, -2.509270>
    }
    triangle {
      < -6.347330, 0.360478, -2.701616>,
      < -5.511763, 0.447911, -2.509270>,
      < -5.513570, 0.391834, -2.705370>
    }
    triangle {
      < -6.333105, 0.245474, -2.825900>,
      < -6.347330, 0.360478, -2.701616>,
      < -5.513570, 0.391834, -2.705370>
    }
    triangle {
      < -6.333105, 0.245474, -2.825900>,
      < -5.513570, 0.391834, -2.705370>,
      < -5.505184, 0.280401, -2.834671>
    }
    triangle {
      < -6.313721, 0.085471, -2.884622>,
      < -6.333105, 0.245474, -2.825900>,
      < -5.505184, 0.280401, -2.834671>
    }
    triangle {
      < -6.313721, 0.085471, -2.884622>,
      < -5.505184, 0.280401, -2.834671>,
      < -5.486871, 0.121344, -2.892958>
    }
    triangle {
      < -6.250638, -0.849536, -2.925035>,
      < -6.262047, -0.349534, -2.905843>,
      < -5.445757, -0.344607, -2.960599>
    }
    triangle {
      < -6.250638, -0.849536, -2.925035>,
      < -5.445757, -0.344607, -2.960599>,
      < -5.318162, -0.594619, -2.991234>
    }
    triangle {
      < -6.250638, -0.849536, -2.925035>,
      < -5.318162, -0.594619, -2.991234>,
      < -5.538681, -0.719600, -2.992549>
    }
    triangle {
      < -6.250638, -0.849536, -2.925035>,
      < -5.538681, -0.719600, -2.992549>,
      < -5.926707, -0.864565, -2.966181>
    }
    triangle {
      < -5.722831, -1.024584, -3.011215>,
      < -5.706758, -0.979586, -3.025065>,
      < -5.663052, -1.007231, -3.037668>
    }
    triangle {
      < -5.706758, -0.979586, -3.025065>,
      < -5.491589, -0.769605, -3.019136>,
      < -5.461406, -0.809276, -3.028569>
    }
    triangle {
      < -5.706758, -0.979586, -3.025065>,
      < -5.461406, -0.809276, -3.028569>,
      < -5.663052, -1.007231, -3.037668>
    }
    triangle {
      < -5.491589, -0.769605, -3.019136>,
      < -5.285660, -0.649623, -3.023917>,
      < -5.266409, -0.695346, -3.031584>
    }
    triangle {
      < -5.491589, -0.769605, -3.019136>,
      < -5.266409, -0.695346, -3.031584>,
      < -5.461406, -0.809276, -3.028569>
    }
    triangle {
      < -5.285660, -0.649623, -3.023917>,
      < -5.024517, -0.579646, -3.029613>,
      < -5.017154, -0.628374, -3.036136>
    }
    triangle {
      < -5.285660, -0.649623, -3.023917>,
      < -5.017154, -0.628374, -3.036136>,
      < -5.266409, -0.695346, -3.031584>
    }
    triangle {
      < -5.024517, -0.579646, -3.029613>,
      < -4.507228, -0.564691, -3.041375>,
      < -4.509265, -0.613634, -3.047463>
    }
    triangle {
      < -5.024517, -0.579646, -3.029613>,
      < -4.509265, -0.613634, -3.047463>,
      < -5.017154, -0.628374, -3.036136>
    }
    triangle {
      < -4.507228, -0.564691, -3.041375>,
      < -4.100383, -0.614727, -3.051299>,
      < -4.111175, -0.662607, -3.057256>
    }
    triangle {
      < -4.507228, -0.564691, -3.041375>,
      < -4.111175, -0.662607, -3.057256>,
      < -4.509265, -0.613634, -3.047463>
    }
    triangle {
      < -4.100383, -0.614727, -3.051299>,
      < -3.834638, -0.704750, -3.051635>,
      < -3.856030, -0.749120, -3.057916>
    }
    triangle {
      < -4.100383, -0.614727, -3.051299>,
      < -3.856030, -0.749120, -3.057916>,
      < -4.111175, -0.662607, -3.057256>
    }
    triangle {
      < -3.834638, -0.704750, -3.051635>,
      < -3.575817, -0.869772, -3.045138>,
      < -3.604055, -0.909909, -3.052055>
    }
    triangle {
      < -3.834638, -0.704750, -3.051635>,
      < -3.604055, -0.909909, -3.052055>,
      < -3.856030, -0.749120, -3.057916>
    }
    triangle {
      < -3.575817, -0.869772, -3.045138>,
      < -3.304013, -1.079796, -3.051208>,
      < -3.336812, -1.116545, -3.058673>
    }
    triangle {
      < -3.575817, -0.869772, -3.045138>,
      < -3.336812, -1.116545, -3.058673>,
      < -3.604055, -0.909909, -3.052055>
    }
    triangle {
      < -3.304013, -1.079796, -3.051208>,
      < -3.017002, -1.374821, -3.043360>,
      < -3.052612, -1.408860, -3.051297>
    }
    triangle {
      < -3.304013, -1.079796, -3.051208>,
      < -3.052612, -1.408860, -3.051297>,
      < -3.336812, -1.116545, -3.058673>
    }
    triangle {
      < -3.017002, -1.374821, -3.043360>,
      < -2.775850, -1.619841, -3.005151>,
      < -2.813603, -1.651789, -3.013454>
    }
    triangle {
      < -3.017002, -1.374821, -3.043360>,
      < -2.813603, -1.651789, -3.013454>,
      < -3.052612, -1.408860, -3.051297>
    }
    triangle {
      < -2.775850, -1.619841, -3.005151>,
      < -2.569514, -1.869857, -2.919900>,
      < -2.813603, -1.651789, -3.013454>
    }
    triangle {
      < -3.263842, -1.049799, -3.035828>,
      < -2.026972, -0.999906, -2.997255>,
      < -2.042209, -1.294905, -3.011163>
    }
    triangle {
      < -3.263842, -1.049799, -3.035828>,
      < -2.042209, -1.294905, -3.011163>,
      < -2.961565, -1.334826, -3.032093>
    }
    triangle {
      < -3.219849, -0.342895, -2.987180>,
      < -3.535646, -0.834776, -3.029758>,
      < -3.796964, -0.659753, -3.018759>
    }
    triangle {
      < -4.556523, -0.339685, -2.984874>,
      < -4.515166, -0.489689, -3.001856>,
      < -5.047047, -0.519643, -2.996191>
    }
    triangle {
      < -4.556523, -0.339685, -2.984874>,
      < -5.047047, -0.519643, -2.996191>,
      < -5.445757, -0.344607, -2.960599>
    }
    triangle {
      < -5.445757, -0.344607, -2.960599>,
      < -5.047047, -0.519643, -2.996191>,
      < -5.318162, -0.594619, -2.991234>
    }
    triangle {
      < -4.556523, -0.339685, -2.984874>,
      < -4.073049, -0.554728, -3.014176>,
      < -4.515166, -0.489689, -3.001856>
    }
    triangle {
      < -3.219849, -0.342895, -2.987180>,
      < -4.073049, -0.554728, -3.014176>,
      < -4.556523, -0.339685, -2.984874>
    }
    triangle {
      < -5.446486, -0.229607, -2.950629>,
      < -6.060792, -0.167655, -2.911906>,
      < -6.055564, -0.023501, -2.899750>
    }
    triangle {
      < -5.446486, -0.229607, -2.950629>,
      < -6.055564, -0.023501, -2.899750>,
      < -5.486871, 0.121344, -2.892958>
    }
    triangle {
      < -5.486871, 0.121344, -2.892958>,
      < -6.055564, -0.023501, -2.899750>,
      < -6.111966, 0.006052, -2.894136>
    }
    triangle {
      < -6.119413, -0.199368, -2.911458>,
      < -6.268429, -0.173387, -2.904441>,
      < -6.259212, -0.030437, -2.894406>
    }
    triangle {
      < -6.119413, -0.199368, -2.911458>,
      < -6.259212, -0.030437, -2.894406>,
      < -6.111966, 0.006052, -2.894136>
    }
    triangle {
      < -6.111966, 0.006052, -2.894136>,
      < -6.259212, -0.030437, -2.894406>,
      < -6.315780, -0.001138, -2.889217>
    }
    triangle {
      < -6.326883, -0.204846, -2.903568>,
      < -6.448577, -0.172863, -2.900421>,
      < -6.438591, -0.029004, -2.892648>
    }
    triangle {
      < -6.326883, -0.204846, -2.903568>,
      < -6.438591, -0.029004, -2.892648>,
      < -6.315780, -0.001138, -2.889217>
    }
    triangle {
      < -6.315780, -0.001138, -2.889217>,
      < -6.438591, -0.029004, -2.892648>,
      < -6.493976, 0.000486, -2.887964>
    }
    triangle {
      < -4.640947, 0.455343, -2.183951>,
      < -4.643502, 0.480337, -2.419787>,
      < -5.521283, 0.460414, -2.414717>
    }
    triangle {
      < -4.640947, 0.455343, -2.183951>,
      < -5.521283, 0.460414, -2.414717>,
      < -5.503400, 0.430418, -2.182756>
    }
    triangle {
      < -2.196753, 0.480121, -2.533204>,
      < -1.827191, 0.470087, -2.600646>,
      < -3.305417, 0.485218, -2.523878>
    }
    triangle {
      < -1.827191, 0.470087, -2.600646>,
      < -2.196753, 0.480121, -2.533204>,
      < -2.040543, 0.480108, -2.497175>
    }
    triangle {
      < -1.827191, 0.470087, -2.600646>,
      < -2.040543, 0.480108, -2.497175>,
      < -2.009329, 0.475106, -2.461809>
    }
    triangle {
      < -1.827191, 0.470087, -2.600646>,
      < -2.009329, 0.475106, -2.461809>,
      < -1.743652, 0.475082, -2.513202>
    }
    triangle {
      < -2.201815, 0.475123, -2.446030>,
      < -2.271515, 0.470132, -2.351997>,
      < -2.009329, 0.475106, -2.461809>
    }
    triangle {
      < -2.201815, 0.475123, -2.446030>,
      < -2.009329, 0.475106, -2.461809>,
      < -2.040543, 0.480108, -2.497175>
    }
    triangle {
      < -4.614746, 0.425346, -1.996497>,
      < -4.640947, 0.455343, -2.183951>,
      < -5.503400, 0.430418, -2.182756>
    }
    triangle {
      < -4.614746, 0.425346, -1.996497>,
      < -5.503400, 0.430418, -2.182756>,
      < -5.498256, 0.375423, -1.981823>
    }
    triangle {
      < -3.331383, 0.470228, -2.197097>,
      < -3.328631, 0.470232, -2.031439>,
      < -2.612738, 0.475170, -2.046601>
    }
    triangle {
      < -3.331383, 0.470228, -2.197097>,
      < -2.612738, 0.475170, -2.046601>,
      < -2.450803, 0.470151, -2.222745>
    }
    triangle {
      < -4.588072, 0.150320, -2.896983>,
      < -4.547651, -0.229686, -2.969179>,
      < -5.446486, -0.229607, -2.950629>
    }
    triangle {
      < -4.588072, 0.150320, -2.896983>,
      < -5.446486, -0.229607, -2.950629>,
      < -5.486871, 0.121344, -2.892958>
    }
    triangle {
      < -3.223694, -0.234801, -2.974232>,
      < -3.271854, 0.145205, -2.899896>,
      < -2.006068, 0.150094, -2.893790>
    }
    triangle {
      < -3.223694, -0.234801, -2.974232>,
      < -2.006068, 0.150094, -2.893790>,
      < -2.005316, -0.229907, -2.966577>
    }
    triangle {
      < -4.646445, 0.480335, -2.515266>,
      < -4.627038, 0.415328, -2.709360>,
      < -5.513570, 0.391834, -2.705370>
    }
    triangle {
      < -4.646445, 0.480335, -2.515266>,
      < -5.513570, 0.391834, -2.705370>,
      < -5.511763, 0.447911, -2.509270>
    }
    triangle {
      < -3.271854, 0.145205, -2.899896>,
      < -3.296589, 0.300209, -2.834231>,
      < -1.980028, 0.300094, -2.823455>
    }
    triangle {
      < -3.271854, 0.145205, -2.899896>,
      < -1.980028, 0.300094, -2.823455>,
      < -2.006068, 0.150094, -2.893790>
    }
    triangle {
      < -3.296589, 0.300209, -2.834231>,
      < -3.300608, 0.415212, -2.715453>,
      < -1.908399, 0.420091, -2.713477>
    }
    triangle {
      < -3.296589, 0.300209, -2.834231>,
      < -1.908399, 0.420091, -2.713477>,
      < -1.980028, 0.300094, -2.823455>
    }
    triangle {
      < -6.262047, -0.349534, -2.905843>,
      < -6.524671, -0.444511, -2.880200>,
      < -6.549592, -0.329509, -2.882052>
    }
    triangle {
      < -5.318162, -0.594619, -2.991234>,
      < -5.285660, -0.649623, -3.023917>,
      < -5.491589, -0.769605, -3.019136>
    }
    triangle {
      < -5.318162, -0.594619, -2.991234>,
      < -5.491589, -0.769605, -3.019136>,
      < -5.538681, -0.719600, -2.992549>
    }
    triangle {
      < -6.250638, -0.849536, -2.925035>,
      < -6.680397, -0.914497, -2.876697>,
      < -6.458776, -0.844517, -2.890340>
    }
    triangle {
      < -6.685298, 0.070503, -2.877093>,
      < -6.775799, -0.009489, -2.873777>,
      < -6.831750, 0.065516, -2.862890>
    }
    triangle {
      < -6.493976, 0.000486, -2.887964>,
      < -6.745515, -0.069491, -2.876542>,
      < -6.775799, -0.009489, -2.873777>
    }
    triangle {
      < -6.493976, 0.000486, -2.887964>,
      < -6.775799, -0.009489, -2.873777>,
      < -6.685298, 0.070503, -2.877093>
    }
    triangle {
      < -5.914151, -0.939567, -3.000344>,
      < -5.929483, -0.974566, -2.996465>,
      < -6.694992, -0.954496, -2.882792>
    }
    triangle {
      < -5.914151, -0.939567, -3.000344>,
      < -6.694992, -0.954496, -2.882792>,
      < -6.680397, -0.914497, -2.876697>
    }
    triangle {
      < -2.961565, -1.334826, -3.032093>,
      < -3.017002, -1.374821, -3.043360>,
      < -3.304013, -1.079796, -3.051208>
    }
    triangle {
      < -2.961565, -1.334826, -3.032093>,
      < -3.304013, -1.079796, -3.051208>,
      < -3.263842, -1.049799, -3.035828>
    }
    triangle {
      < -3.535646, -0.834776, -3.029758>,
      < -3.575817, -0.869772, -3.045138>,
      < -3.834638, -0.704750, -3.051635>
    }
    triangle {
      < -3.535646, -0.834776, -3.029758>,
      < -3.834638, -0.704750, -3.051635>,
      < -3.796964, -0.659753, -3.018759>
    }
    triangle {
      < -4.515166, -0.489689, -3.001856>,
      < -4.507228, -0.564691, -3.041375>,
      < -5.024517, -0.579646, -3.029613>
    }
    triangle {
      < -4.515166, -0.489689, -3.001856>,
      < -5.024517, -0.579646, -3.029613>,
      < -5.047047, -0.519643, -2.996191>
    }
    triangle {
      < -4.073049, -0.554728, -3.014176>,
      < -4.100383, -0.614727, -3.051299>,
      < -4.507228, -0.564691, -3.041375>
    }
    triangle {
      < -4.073049, -0.554728, -3.014176>,
      < -4.507228, -0.564691, -3.041375>,
      < -4.515166, -0.489689, -3.001856>
    }
    triangle {
      < -3.796964, -0.659753, -3.018759>,
      < -3.834638, -0.704750, -3.051635>,
      < -4.100383, -0.614727, -3.051299>
    }
    triangle {
      < -3.796964, -0.659753, -3.018759>,
      < -4.100383, -0.614727, -3.051299>,
      < -4.073049, -0.554728, -3.014176>
    }
    triangle {
      < -3.263842, -1.049799, -3.035828>,
      < -3.304013, -1.079796, -3.051208>,
      < -3.575817, -0.869772, -3.045138>
    }
    triangle {
      < -3.263842, -1.049799, -3.035828>,
      < -3.575817, -0.869772, -3.045138>,
      < -3.535646, -0.834776, -3.029758>
    }
    triangle {
      < -6.533515, 0.065517, -1.860501>,
      < -6.587705, 0.095519, -1.962366>,
      < -6.642935, -0.014477, -1.961445>
    }
    triangle {
      < -6.533515, 0.065517, -1.860501>,
      < -6.642935, -0.014477, -1.961445>,
      < -6.623542, -0.034476, -1.865155>
    }
    triangle {
      < -3.331383, 0.470228, -2.197097>,
      < -3.323596, 0.495221, -2.437180>,
      < -4.643502, 0.480337, -2.419787>
    }
    triangle {
      < -3.331383, 0.470228, -2.197097>,
      < -4.643502, 0.480337, -2.419787>,
      < -4.640947, 0.455343, -2.183951>
    }
    triangle {
      < -2.961565, -1.334826, -3.032093>,
      < -2.042209, -1.294905, -3.011163>,
      < -2.024261, -1.569907, -2.993072>
    }
    triangle {
      < -2.961565, -1.334826, -3.032093>,
      < -2.024261, -1.569907, -2.993072>,
      < -2.749540, -1.604843, -2.992587>
    }
    triangle {
      < -2.749540, -1.604843, -2.992587>,
      < -2.024261, -1.569907, -2.993072>,
      < -2.009248, -1.854906, -2.925065>
    }
    triangle {
      < -2.749540, -1.604843, -2.992587>,
      < -2.009248, -1.854906, -2.925065>,
      < -2.538924, -1.884860, -2.946151>
    }
    triangle {
      < -2.749540, -1.604843, -2.992587>,
      < -2.538924, -1.884860, -2.946151>,
      < -2.569514, -1.869857, -2.919900>
    }
    triangle {
      < -3.017002, -1.374821, -3.043360>,
      < -2.961565, -1.334826, -3.032093>,
      < -2.749540, -1.604843, -2.992587>
    }
    triangle {
      < -3.017002, -1.374821, -3.043360>,
      < -2.749540, -1.604843, -2.992587>,
      < -2.775850, -1.619841, -3.005151>
    }
    triangle {
      < -2.026972, -0.999906, -2.997255>,
      < -3.263842, -1.049799, -3.035828>,
      < -3.535646, -0.834776, -3.029758>
    }
    triangle {
      < -2.026972, -0.999906, -2.997255>,
      < -3.535646, -0.834776, -3.029758>,
      < -3.219849, -0.342895, -2.987180>
    }
    triangle {
      < -2.026972, -0.999906, -2.997255>,
      < -3.219849, -0.342895, -2.987180>,
      < -2.025026, -0.339706, -2.988144>
    }
    triangle {
      < -6.680397, -0.914497, -2.876697>,
      < -6.250638, -0.849536, -2.925035>,
      < -5.926707, -0.864565, -2.966181>
    }
    triangle {
      < -6.680397, -0.914497, -2.876697>,
      < -5.926707, -0.864565, -2.966181>,
      < -5.914151, -0.939567, -3.000344>
    }
    triangle {
      < -3.328631, 0.470232, -2.031439>,
      < -3.357367, 0.464914, -1.876387>,
      < -2.703817, 0.490182, -1.880681>
    }
    triangle {
      < -3.328631, 0.470232, -2.031439>,
      < -2.703817, 0.490182, -1.880681>,
      < -2.612738, 0.475170, -2.046601>
    }
    triangle {
      < -3.300608, 0.415212, -2.715453>,
      < -3.305417, 0.485218, -2.523878>,
      < -1.827191, 0.470087, -2.600646>
    }
    triangle {
      < -3.300608, 0.415212, -2.715453>,
      < -1.827191, 0.470087, -2.600646>,
      < -1.908399, 0.420091, -2.713477>
    }
    triangle {
      < 7.109572, 0.347370, -2.477088>,
      < 7.656147, 0.345041, -2.573846>,
      < 6.014196, 0.389435, -2.592635>
    }
    triangle {
      < 6.047067, 0.434167, -2.196927>,
      < 5.236760, 0.493609, -2.221350>,
      < 5.412265, 0.520830, -1.822873>
    }
    triangle {
      < 6.047067, 0.434167, -2.196927>,
      < 5.412265, 0.520830, -1.822873>,
      < 6.121673, 0.477584, -1.811959>
    }
    triangle {
      < 4.818051, 0.424675, -2.645805>,
      < 4.278938, 0.429553, -2.620985>,
      < 4.633741, 0.426260, -2.557898>
    }
    triangle {
      < 8.934355, -0.179734, -2.773799>,
      < 7.457458, -0.145731, -2.893612>,
      < 7.530486, 0.079263, -2.850085>
    }
    triangle {
      < 8.934355, -0.179734, -2.773799>,
      < 7.530486, 0.079263, -2.850085>,
      < 9.045938, 0.054134, -2.755627>
    }
    triangle {
      < 8.399913, -0.142759, -2.403348>,
      < 8.479552, -0.128594, -2.450057>,
      < 8.390141, 0.062475, -2.459994>
    }
    triangle {
      < 8.399913, -0.142759, -2.403348>,
      < 8.390141, 0.062475, -2.459994>,
      < 8.318105, 0.028205, -2.405346>
    }
    triangle {
      < -2.596643, 0.595192, -1.118505>,
      < -2.879675, 0.555217, -1.114004>,
      < -2.931157, 0.575235, -0.607670>
    }
    triangle {
      < -2.596643, 0.595192, -1.118505>,
      < -2.931157, 0.575235, -0.607670>,
      < -2.945995, 0.575252, 0.000000>
    }
    triangle {
      < -2.596643, 0.595192, -1.118505>,
      < -2.945995, 0.575252, 0.000000>,
      < -2.647161, 0.620226, 0.000000>
    }
    triangle {
      < 6.241868, -1.425629, -3.042024>,
      < 6.261692, -1.360630, -3.006923>,
      < 6.714520, -1.540669, -2.975575>
    }
    triangle {
      < 6.241868, -1.425629, -3.042024>,
      < 6.714520, -1.540669, -2.975575>,
      < 6.959054, -1.695689, -2.917074>
    }
    triangle {
      < 6.241868, -1.425629, -3.042024>,
      < 6.959054, -1.695689, -2.917074>,
      < 6.912721, -1.695685, -2.927237>
    }
    triangle {
      < 8.449459, -1.115818, -2.907453>,
      < 8.416007, -1.160815, -2.909933>,
      < 8.322593, -1.180807, -2.889953>
    }
    triangle {
      < 8.449459, -1.115818, -2.907453>,
      < 8.322593, -1.180807, -2.889953>,
      < 7.201694, -0.930711, -2.952916>
    }
    triangle {
      < 2.732397, -0.489476, -3.021448>,
      < 1.883856, -0.945249, -3.050085>,
      < 1.883786, -0.445248, -3.014044>
    }
    triangle {
      < 2.401958, 0.144711, -2.847399>,
      < 2.482622, -0.005298, -2.924798>,
      < 1.866866, 0.029756, -2.912876>
    }
    triangle {
      < 2.401958, 0.144711, -2.847399>,
      < 1.866866, 0.029756, -2.912876>,
      < 1.841696, 0.184760, -2.842235>
    }
    triangle {
      < 7.605241, 0.254258, -2.799703>,
      < 7.629016, 0.319500, -2.761035>,
      < 9.095436, 0.283447, -2.717090>
    }
    triangle {
      < 7.605241, 0.254258, -2.799703>,
      < 9.095436, 0.283447, -2.717090>,
      < 9.140353, 0.244126, -2.728450>
    }
    triangle {
      < 5.027698, 0.491304, -2.367082>,
      < 5.018622, 0.476534, -2.433598>,
      < 4.812309, 0.452697, -2.525539>
    }
    triangle {
      < 8.365832, -0.142549, -2.304032>,
      < 8.399913, -0.142759, -2.403348>,
      < 8.318105, 0.028205, -2.405346>
    }
    triangle {
      < 8.365832, -0.142549, -2.304032>,
      < 8.318105, 0.028205, -2.405346>,
      < 8.291826, 0.013337, -2.313897>
    }
    triangle {
      < 7.908731, 0.294364, -2.556156>,
      < 9.089541, 0.294427, -2.558130>,
      < 7.656147, 0.345041, -2.573846>
    }
    triangle {
      < 2.546063, 0.324703, -2.677072>,
      < 2.745803, 0.369686, -2.664615>,
      < 2.758114, 0.354683, -2.723550>
    }
    triangle {
      < 2.546063, 0.324703, -2.677072>,
      < 2.758114, 0.354683, -2.723550>,
      < 2.563165, 0.299700, -2.734582>
    }
    triangle {
      < 2.393729, 0.259716, -2.691078>,
      < 2.390236, 0.234715, -2.749496>,
      < 1.797373, 0.309767, -2.738039>
    }
    triangle {
      < 2.393729, 0.259716, -2.691078>,
      < 1.797373, 0.309767, -2.738039>,
      < 1.780270, 0.339770, -2.680530>
    }
    triangle {
      < 6.714520, -1.540669, -2.975575>,
      < 6.261692, -1.360630, -3.006923>,
      < 7.201694, -0.930711, -2.952916>
    }
    triangle {
      < 6.714520, -1.540669, -2.975575>,
      < 7.201694, -0.930711, -2.952916>,
      < 6.971869, -1.560690, -2.938550>
    }
    triangle {
      < 6.971869, -1.560690, -2.938550>,
      < 6.959054, -1.695689, -2.917074>,
      < 6.714520, -1.540669, -2.975575>
    }
    triangle {
      < 2.390236, 0.234715, -2.749496>,
      < 2.401958, 0.144711, -2.847399>,
      < 1.841696, 0.184760, -2.842235>
    }
    triangle {
      < 2.390236, 0.234715, -2.749496>,
      < 1.841696, 0.184760, -2.842235>,
      < 1.797373, 0.309767, -2.738039>
    }
    triangle {
      < 6.110524, 0.468056, -1.995495>,
      < 6.047067, 0.434167, -2.196927>,
      < 6.121673, 0.477584, -1.811959>
    }
    triangle {
      < 7.530486, 0.079263, -2.850085>,
      < 7.605241, 0.254258, -2.799703>,
      < 9.140353, 0.244126, -2.728450>
    }
    triangle {
      < 7.530486, 0.079263, -2.850085>,
      < 9.140353, 0.244126, -2.728450>,
      < 9.045938, 0.054134, -2.755627>
    }
    triangle {
      < 3.579291, 0.304609, -2.835365>,
      < 3.533880, 0.110079, -2.930280>,
      < 3.185711, 0.114641, -2.922582>
    }
    triangle {
      < 3.579291, 0.304609, -2.835365>,
      < 3.185711, 0.114641, -2.922582>,
      < 3.075869, 0.309653, -2.825860>
    }
    triangle {
      < 9.095436, 0.283447, -2.717090>,
      < 7.629016, 0.319500, -2.761035>,
      < 7.653469, 0.344960, -2.729584>
    }
    triangle {
      < 8.489470, -0.969292, -2.170007>,
      < 8.487261, -0.964077, -2.271214>,
      < 8.436363, -0.458416, -2.289739>
    }
    triangle {
      < 8.489470, -0.969292, -2.170007>,
      < 8.436363, -0.458416, -2.289739>,
      < 8.440199, -0.463641, -2.193263>
    }
    triangle {
      < 2.482622, -0.005298, -2.924798>,
      < 2.764446, -0.365325, -3.033453>,
      < 1.907401, -0.325250, -3.023679>
    }
    triangle {
      < 2.482622, -0.005298, -2.924798>,
      < 1.907401, -0.325250, -3.023679>,
      < 1.866866, 0.029756, -2.912876>
    }
    triangle {
      < 7.605241, 0.254258, -2.799703>,
      < 7.530486, 0.079263, -2.850085>,
      < 5.949462, 0.094400, -2.905534>
    }
    triangle {
      < 7.605241, 0.254258, -2.799703>,
      < 5.949462, 0.094400, -2.905534>,
      < 5.976968, 0.269400, -2.827793>
    }
    triangle {
      < 2.587595, 0.269697, -2.784412>,
      < 2.615479, 0.214693, -2.832859>,
      < 2.401958, 0.144711, -2.847399>
    }
    triangle {
      < 6.000408, 0.344399, -2.783345>,
      < 6.016861, 0.389399, -2.722277>,
      < 7.653469, 0.344960, -2.729584>
    }
    triangle {
      < 6.000408, 0.344399, -2.783345>,
      < 7.653469, 0.344960, -2.729584>,
      < 7.629016, 0.319500, -2.761035>
    }
    triangle {
      < 5.976968, 0.269400, -2.827793>,
      < 6.000408, 0.344399, -2.783345>,
      < 7.629016, 0.319500, -2.761035>
    }
    triangle {
      < 5.976968, 0.269400, -2.827793>,
      < 7.629016, 0.319500, -2.761035>,
      < 7.605241, 0.254258, -2.799703>
    }
    triangle {
      < 7.925941, 0.262861, -2.455819>,
      < 7.908731, 0.294364, -2.556156>,
      < 7.656147, 0.345041, -2.573846>
    }
    triangle {
      < 7.925941, 0.262861, -2.455819>,
      < 7.656147, 0.345041, -2.573846>,
      < 7.643649, 0.311180, -2.478775>
    }
    triangle {
      < 7.650219, 0.285880, -2.360173>,
      < 7.643649, 0.311180, -2.478775>,
      < 7.109572, 0.347370, -2.477088>
    }
    triangle {
      < 7.650219, 0.285880, -2.360173>,
      < 7.109572, 0.347370, -2.477088>,
      < 7.119617, 0.342049, -2.367906>
    }
    triangle {
      < 7.642765, 0.310666, -2.198912>,
      < 7.650219, 0.285880, -2.360173>,
      < 7.119617, 0.342049, -2.367906>
    }
    triangle {
      < 7.642765, 0.310666, -2.198912>,
      < 7.119617, 0.342049, -2.367906>,
      < 7.113728, 0.361826, -2.211385>
    }
    triangle {
      < 8.318105, 0.028205, -2.405346>,
      < 8.390141, 0.062475, -2.459994>,
      < 8.259270, 0.209057, -2.489348>
    }
    triangle {
      < 8.318105, 0.028205, -2.405346>,
      < 8.259270, 0.209057, -2.489348>,
      < 8.223092, 0.144336, -2.417044>
    }
    triangle {
      < 8.291826, 0.013337, -2.313897>,
      < 8.318105, 0.028205, -2.405346>,
      < 8.223092, 0.144336, -2.417044>
    }
    triangle {
      < 8.291826, 0.013337, -2.313897>,
      < 8.223092, 0.144336, -2.417044>,
      < 8.193651, 0.124517, -2.331956>
    }
    triangle {
      < 8.301852, 0.017987, -2.188884>,
      < 8.291826, 0.013337, -2.313897>,
      < 8.193651, 0.124517, -2.331956>
    }
    triangle {
      < 8.301852, 0.017987, -2.188884>,
      < 8.193651, 0.124517, -2.331956>,
      < 8.182999, 0.129380, -2.192896>
    }
    triangle {
      < 8.735338, -0.613710, -2.826938>,
      < 8.749555, -0.613710, -2.466970>,
      < 8.656049, -0.866875, -2.422487>
    }
    triangle {
      < 8.735338, -0.613710, -2.826938>,
      < 8.656049, -0.866875, -2.422487>,
      < 8.640915, -1.140712, -2.394224>
    }
    triangle {
      < 8.735338, -0.613710, -2.826938>,
      < 8.640915, -1.140712, -2.394224>,
      < 8.449459, -1.115818, -2.862253>
    }
    triangle {
      < 8.735338, -0.613710, -2.826938>,
      < 8.449459, -1.115818, -2.862253>,
      < 8.552464, -0.915826, -2.875156>
    }
    triangle {
      < 6.019087, 0.405001, -2.470772>,
      < 6.014196, 0.389435, -2.592635>,
      < 5.194364, 0.402142, -2.616375>
    }
    triangle {
      < 6.014196, 0.389435, -2.592635>,
      < 6.019087, 0.405001, -2.470772>,
      < 7.119617, 0.342049, -2.367906>
    }
    triangle {
      < 6.014196, 0.389435, -2.592635>,
      < 7.119617, 0.342049, -2.367906>,
      < 7.109572, 0.347370, -2.477088>
    }
    triangle {
      < 7.656147, 0.345041, -2.573846>,
      < 7.109572, 0.347370, -2.477088>,
      < 7.643649, 0.311180, -2.478775>
    }
    triangle {
      < 4.939573, 0.418233, -2.648936>,
      < 4.937755, 0.418982, -2.677343>,
      < 4.818051, 0.424675, -2.645805>
    }
    triangle {
      < 4.278938, 0.429553, -2.620985>,
      < 4.281296, 0.409301, -2.691644>,
      < 3.624037, 0.399608, -2.705963>
    }
    triangle {
      < 4.278938, 0.429553, -2.620985>,
      < 3.624037, 0.399608, -2.705963>,
      < 3.618461, 0.419610, -2.634592>
    }
    triangle {
      < 3.013422, 0.384661, -2.704998>,
      < 3.052154, 0.359656, -2.780174>,
      < 2.799764, 0.324678, -2.780970>
    }
    triangle {
      < 3.013422, 0.384661, -2.704998>,
      < 2.799764, 0.324678, -2.780970>,
      < 2.758114, 0.354683, -2.723550>
    }
    triangle {
      < 4.281296, 0.409301, -2.691644>,
      < 4.268528, 0.401606, -2.710315>,
      < 3.624037, 0.399608, -2.705963>
    }
    triangle {
      < 3.829013, -1.870416, -2.928818>,
      < 3.808440, -1.839552, -2.919236>,
      < 3.886168, -1.555423, -3.014625>
    }
    triangle {
      < 3.829013, -1.870416, -2.928818>,
      < 3.886168, -1.555423, -3.014625>,
      < 3.931926, -1.576616, -3.023407>
    }
    triangle {
      < 3.886168, -1.555423, -3.014625>,
      < 4.001390, -1.410434, -3.048934>,
      < 4.036805, -1.444195, -3.053520>
    }
    triangle {
      < 3.886168, -1.555423, -3.014625>,
      < 4.036805, -1.444195, -3.053520>,
      < 3.931926, -1.576616, -3.023407>
    }
    triangle {
      < 4.001390, -1.410434, -3.048934>,
      < 4.178975, -1.275450, -3.070565>,
      < 4.203426, -1.317132, -3.072573>
    }
    triangle {
      < 4.001390, -1.410434, -3.048934>,
      < 4.203426, -1.317132, -3.072573>,
      < 4.036805, -1.444195, -3.053520>
    }
    triangle {
      < 4.178975, -1.275450, -3.070565>,
      < 4.406470, -1.190470, -3.089263>,
      < 4.418622, -1.236594, -3.089916>
    }
    triangle {
      < 4.178975, -1.275450, -3.070565>,
      < 4.418622, -1.236594, -3.089916>,
      < 4.203426, -1.317132, -3.072573>
    }
    triangle {
      < 4.406470, -1.190470, -3.089263>,
      < 4.701845, -1.150496, -3.086946>,
      < 4.704625, -1.197789, -3.087335>
    }
    triangle {
      < 4.406470, -1.190470, -3.089263>,
      < 4.704625, -1.197789, -3.087335>,
      < 4.418622, -1.236594, -3.089916>
    }
    triangle {
      < 4.701845, -1.150496, -3.086946>,
      < 5.080426, -1.155529, -3.085750>,
      < 5.075943, -1.202748, -3.086273>
    }
    triangle {
      < 4.701845, -1.150496, -3.086946>,
      < 5.075943, -1.202748, -3.086273>,
      < 4.704625, -1.197789, -3.087335>
    }
    triangle {
      < 5.080426, -1.155529, -3.085750>,
      < 5.657246, -1.250579, -3.065898>,
      < 5.645978, -1.296764, -3.066880>
    }
    triangle {
      < 5.080426, -1.155529, -3.085750>,
      < 5.645978, -1.296764, -3.066880>,
      < 5.075943, -1.202748, -3.086273>
    }
    triangle {
      < 5.657246, -1.250579, -3.065898>,
      < 6.241868, -1.425629, -3.042024>,
      < 6.224681, -1.470219, -3.043646>
    }
    triangle {
      < 5.657246, -1.250579, -3.065898>,
      < 6.224681, -1.470219, -3.043646>,
      < 5.645978, -1.296764, -3.066880>
    }
    triangle {
      < 6.241868, -1.425629, -3.042024>,
      < 6.912721, -1.695685, -2.927237>,
      < 6.224681, -1.470219, -3.043646>
    }
    triangle {
      < 7.210523, -1.845708, -2.831152>,
      < 6.912721, -1.695685, -2.927237>,
      < 6.959054, -1.695689, -2.917074>
    }
    triangle {
      < 3.808440, -1.839552, -2.919236>,
      < 1.644907, -1.850225, -2.939876>,
      < 1.762765, -1.820235, -2.933957>
    }
    triangle {
      < 5.921797, -0.119568, -2.947283>,
      < 5.949462, 0.094400, -2.905534>,
      < 7.530486, 0.079263, -2.850085>
    }
    triangle {
      < 5.921797, -0.119568, -2.947283>,
      < 7.530486, 0.079263, -2.850085>,
      < 7.457458, -0.145731, -2.893612>
    }
    triangle {
      < 2.390236, 0.234715, -2.749496>,
      < 2.393729, 0.259716, -2.691078>,
      < 2.546063, 0.324703, -2.677072>
    }
    triangle {
      < 2.390236, 0.234715, -2.749496>,
      < 2.546063, 0.324703, -2.677072>,
      < 2.563165, 0.299700, -2.734582>
    }
    triangle {
      < 2.401958, 0.144711, -2.847399>,
      < 2.390236, 0.234715, -2.749496>,
      < 2.563165, 0.299700, -2.734582>
    }
    triangle {
      < 2.401958, 0.144711, -2.847399>,
      < 2.563165, 0.299700, -2.734582>,
      < 2.587595, 0.269697, -2.784412>
    }
    triangle {
      < 2.482622, -0.005298, -2.924798>,
      < 2.401958, 0.144711, -2.847399>,
      < 2.615479, 0.214693, -2.832859>
    }
    triangle {
      < 2.482622, -0.005298, -2.924798>,
      < 2.615479, 0.214693, -2.832859>,
      < 2.733606, 0.059680, -2.917074>
    }
    triangle {
      < 2.764446, -0.365325, -3.033453>,
      < 2.482622, -0.005298, -2.924798>,
      < 2.733606, 0.059680, -2.917074>
    }
    triangle {
      < 2.764446, -0.365325, -3.033453>,
      < 2.733606, 0.059680, -2.917074>,
      < 2.937687, -0.265340, -2.998240>
    }
    triangle {
      < 2.587595, 0.269697, -2.784412>,
      < 2.563165, 0.299700, -2.734582>,
      < 2.758114, 0.354683, -2.723550>
    }
    triangle {
      < 2.587595, 0.269697, -2.784412>,
      < 2.758114, 0.354683, -2.723550>,
      < 2.799764, 0.324678, -2.780970>
    }
    triangle {
      < 2.615479, 0.214693, -2.832859>,
      < 2.587595, 0.269697, -2.784412>,
      < 2.799764, 0.324678, -2.780970>
    }
    triangle {
      < 2.615479, 0.214693, -2.832859>,
      < 2.799764, 0.324678, -2.780970>,
      < 2.835985, 0.279673, -2.834938>
    }
    triangle {
      < 2.733606, 0.059680, -2.917074>,
      < 2.615479, 0.214693, -2.832859>,
      < 2.835985, 0.279673, -2.834938>
    }
    triangle {
      < 2.733606, 0.059680, -2.917074>,
      < 2.835985, 0.279673, -2.834938>,
      < 2.947180, 0.089662, -2.920561>
    }
    triangle {
      < 2.937687, -0.265340, -2.998240>,
      < 2.733606, 0.059680, -2.917074>,
      < 2.947180, 0.089662, -2.920561>
    }
    triangle {
      < 2.937687, -0.265340, -2.998240>,
      < 2.947180, 0.089662, -2.920561>,
      < 3.134589, -0.190357, -2.990687>
    }
    triangle {
      < 2.758114, 0.354683, -2.723550>,
      < 2.745803, 0.369686, -2.664615>,
      < 3.013547, 0.399663, -2.652796>
    }
    triangle {
      < 2.758114, 0.354683, -2.723550>,
      < 3.013547, 0.399663, -2.652796>,
      < 3.013422, 0.384661, -2.704998>
    }
    triangle {
      < 2.835985, 0.279673, -2.834938>,
      < 2.799764, 0.324678, -2.780970>,
      < 3.052154, 0.359656, -2.780174>
    }
    triangle {
      < 2.835985, 0.279673, -2.834938>,
      < 3.052154, 0.359656, -2.780174>,
      < 3.075869, 0.309653, -2.825860>
    }
    triangle {
      < 2.947180, 0.089662, -2.920561>,
      < 2.835985, 0.279673, -2.834938>,
      < 3.075869, 0.309653, -2.825860>
    }
    triangle {
      < 2.947180, 0.089662, -2.920561>,
      < 3.075869, 0.309653, -2.825860>,
      < 3.185711, 0.114641, -2.922582>
    }
    triangle {
      < 3.134589, -0.190357, -2.990687>,
      < 2.947180, 0.089662, -2.920561>,
      < 3.185711, 0.114641, -2.922582>
    }
    triangle {
      < 3.134589, -0.190357, -2.990687>,
      < 3.185711, 0.114641, -2.922582>,
      < 3.299893, -0.151445, -2.990343>
    }
    triangle {
      < 3.013422, 0.384661, -2.704998>,
      < 3.013547, 0.399663, -2.652796>,
      < 3.618461, 0.419610, -2.634592>
    }
    triangle {
      < 3.013422, 0.384661, -2.704998>,
      < 3.618461, 0.419610, -2.634592>,
      < 3.624037, 0.399608, -2.705963>
    }
    triangle {
      < 3.052154, 0.359656, -2.780174>,
      < 3.013422, 0.384661, -2.704998>,
      < 3.624037, 0.399608, -2.705963>
    }
    triangle {
      < 3.052154, 0.359656, -2.780174>,
      < 3.624037, 0.399608, -2.705963>,
      < 3.598562, 0.369608, -2.788156>
    }
    triangle {
      < 3.075869, 0.309653, -2.825860>,
      < 3.052154, 0.359656, -2.780174>,
      < 3.598562, 0.369608, -2.788156>
    }
    triangle {
      < 3.075869, 0.309653, -2.825860>,
      < 3.598562, 0.369608, -2.788156>,
      < 3.579291, 0.304609, -2.835365>
    }
    triangle {
      < 3.299893, -0.151445, -2.990343>,
      < 3.185711, 0.114641, -2.922582>,
      < 3.533880, 0.110079, -2.930280>
    }
    triangle {
      < 3.299893, -0.151445, -2.990343>,
      < 3.533880, 0.110079, -2.930280>,
      < 3.511749, -0.131182, -2.990570>
    }
    triangle {
      < 3.598562, 0.369608, -2.788156>,
      < 3.624037, 0.399608, -2.705963>,
      < 4.268528, 0.401606, -2.710315>
    }
    triangle {
      < 3.598562, 0.369608, -2.788156>,
      < 4.268528, 0.401606, -2.710315>,
      < 4.233611, 0.362943, -2.786884>
    }
    triangle {
      < 3.579291, 0.304609, -2.835365>,
      < 3.598562, 0.369608, -2.788156>,
      < 4.233611, 0.362943, -2.786884>
    }
    triangle {
      < 3.579291, 0.304609, -2.835365>,
      < 4.233611, 0.362943, -2.786884>,
      < 4.205739, 0.295410, -2.833387>
    }
    triangle {
      < 3.533880, 0.110079, -2.930280>,
      < 3.579291, 0.304609, -2.835365>,
      < 4.205739, 0.295410, -2.833387>
    }
    triangle {
      < 3.533880, 0.110079, -2.930280>,
      < 4.205739, 0.295410, -2.833387>,
      < 4.155538, 0.105864, -2.924790>
    }
    triangle {
      < 3.511749, -0.131182, -2.990570>,
      < 3.533880, 0.110079, -2.930280>,
      < 4.155538, 0.105864, -2.924790>
    }
    triangle {
      < 3.511749, -0.131182, -2.990570>,
      < 4.155538, 0.105864, -2.924790>,
      < 4.125974, -0.106096, -2.996831>
    }
    triangle {
      < 4.281296, 0.409301, -2.691644>,
      < 4.278938, 0.429553, -2.620985>,
      < 4.818051, 0.424675, -2.645805>
    }
    triangle {
      < 4.281296, 0.409301, -2.691644>,
      < 4.818051, 0.424675, -2.645805>,
      < 4.937755, 0.418982, -2.677343>
    }
    triangle {
      < 4.268528, 0.401606, -2.710315>,
      < 4.281296, 0.409301, -2.691644>,
      < 4.937755, 0.418982, -2.677343>
    }
    triangle {
      < 4.268528, 0.401606, -2.710315>,
      < 4.937755, 0.418982, -2.677343>,
      < 4.966898, 0.413589, -2.698662>
    }
    triangle {
      < 4.233611, 0.362943, -2.786884>,
      < 4.268528, 0.401606, -2.710315>,
      < 5.193110, 0.404471, -2.716558>
    }
    triangle {
      < 4.233611, 0.362943, -2.786884>,
      < 5.193110, 0.404471, -2.716558>,
      < 6.016861, 0.389399, -2.722277>
    }
    triangle {
      < 4.233611, 0.362943, -2.786884>,
      < 6.016861, 0.389399, -2.722277>,
      < 6.000408, 0.344399, -2.783345>
    }
    triangle {
      < 4.205739, 0.295410, -2.833387>,
      < 4.233611, 0.362943, -2.786884>,
      < 6.000408, 0.344399, -2.783345>
    }
    triangle {
      < 4.205739, 0.295410, -2.833387>,
      < 6.000408, 0.344399, -2.783345>,
      < 5.976968, 0.269400, -2.827793>
    }
    triangle {
      < 4.155538, 0.105864, -2.924790>,
      < 4.205739, 0.295410, -2.833387>,
      < 5.976968, 0.269400, -2.827793>
    }
    triangle {
      < 4.155538, 0.105864, -2.924790>,
      < 5.976968, 0.269400, -2.827793>,
      < 5.949462, 0.094400, -2.905534>
    }
    triangle {
      < 4.125974, -0.106096, -2.996831>,
      < 4.155538, 0.105864, -2.924790>,
      < 5.949462, 0.094400, -2.905534>
    }
    triangle {
      < 4.125974, -0.106096, -2.996831>,
      < 5.949462, 0.094400, -2.905534>,
      < 5.921797, -0.119568, -2.947283>
    }
    triangle {
      < 8.640915, -1.140712, -2.394224>,
      < 8.539258, -1.154597, -2.321690>,
      < 8.539258, -1.508811, -2.321690>
    }
    triangle {
      < 8.640915, -1.140712, -2.394224>,
      < 8.539258, -1.508811, -2.321690>,
      < 8.640915, -1.508811, -2.394224>
    }
    triangle {
      < 8.539258, -1.154597, -2.321690>,
      < 8.513547, -1.144411, -2.261814>,
      < 8.513547, -1.508811, -2.261814>
    }
    triangle {
      < 8.539258, -1.154597, -2.321690>,
      < 8.513547, -1.508811, -2.261814>,
      < 8.539258, -1.508811, -2.321690>
    }
    triangle {
      < 8.513547, -1.144411, -2.261814>,
      < 8.509673, -1.194734, -2.067450>,
      < 8.509673, -1.508811, -2.067450>
    }
    triangle {
      < 8.513547, -1.144411, -2.261814>,
      < 8.509673, -1.508811, -2.067450>,
      < 8.513547, -1.508811, -2.261814>
    }
    triangle {
      < 8.509673, -1.194734, -2.067450>,
      < 8.512800, -1.225042, -1.923583>,
      < 8.512800, -1.508811, -1.923583>
    }
    triangle {
      < 8.509673, -1.194734, -2.067450>,
      < 8.512800, -1.508811, -1.923583>,
      < 8.509673, -1.508811, -2.067450>
    }
    triangle {
      < 8.512800, -1.225042, -1.923583>,
      < 8.522250, -1.225294, -1.772281>,
      < 8.522250, -1.508811, -1.772281>
    }
    triangle {
      < 8.512800, -1.225042, -1.923583>,
      < 8.522250, -1.508811, -1.772281>,
      < 8.512800, -1.508811, -1.923583>
    }
    triangle {
      < 8.522250, -1.225294, -1.772281>,
      < 8.560331, -1.222266, -1.029780>,
      < 8.560331, -1.508811, -1.029780>
    }
    triangle {
      < 8.522250, -1.225294, -1.772281>,
      < 8.560331, -1.508811, -1.029780>,
      < 8.522250, -1.508811, -1.772281>
    }
    triangle {
      < 8.560331, -1.222266, -1.029780>,
      < 8.597543, -1.223972, 0.000000>,
      < 8.597543, -1.508811, 0.000000>
    }
    triangle {
      < 8.560331, -1.222266, -1.029780>,
      < 8.597543, -1.508811, 0.000000>,
      < 8.560331, -1.508811, -1.029780>
    }
    triangle {
      < 7.979931, -1.865773, -2.744938>,
      < 8.001176, -1.730777, -2.819602>,
      < 8.001176, -1.730777, -2.774402>
    }
    triangle {
      < 7.979931, -1.865773, -2.744938>,
      < 8.001176, -1.730777, -2.774402>,
      < 7.979931, -1.865773, -2.699738>
    }
    triangle {
      < 8.001176, -1.730777, -2.819602>,
      < 8.051655, -1.600783, -2.865190>,
      < 8.051655, -1.600783, -2.819990>
    }
    triangle {
      < 8.001176, -1.730777, -2.819602>,
      < 8.051655, -1.600783, -2.819990>,
      < 8.001176, -1.730777, -2.774402>
    }
    triangle {
      < 8.051655, -1.600783, -2.865190>,
      < 8.253127, -1.245801, -2.890619>,
      < 8.253127, -1.245801, -2.845419>
    }
    triangle {
      < 8.051655, -1.600783, -2.865190>,
      < 8.253127, -1.245801, -2.845419>,
      < 8.051655, -1.600783, -2.819990>
    }
    triangle {
      < 8.253127, -1.245801, -2.890619>,
      < 8.322593, -1.180807, -2.889953>,
      < 8.322593, -1.180807, -2.844753>
    }
    triangle {
      < 8.253127, -1.245801, -2.890619>,
      < 8.322593, -1.180807, -2.844753>,
      < 8.253127, -1.245801, -2.845419>
    }
    triangle {
      < 8.322593, -1.180807, -2.889953>,
      < 8.416007, -1.160815, -2.909933>,
      < 8.416007, -1.160815, -2.864733>
    }
    triangle {
      < 8.322593, -1.180807, -2.889953>,
      < 8.416007, -1.160815, -2.864733>,
      < 8.322593, -1.180807, -2.844753>
    }
    triangle {
      < 8.416007, -1.160815, -2.909933>,
      < 8.449459, -1.115818, -2.907453>,
      < 8.449459, -1.115818, -2.862253>
    }
    triangle {
      < 8.416007, -1.160815, -2.909933>,
      < 8.449459, -1.115818, -2.862253>,
      < 8.416007, -1.160815, -2.864733>
    }
    triangle {
      < 8.449459, -1.115818, -2.862253>,
      < 8.640915, -1.140712, -2.394224>,
      < 8.640915, -1.508811, -2.394224>
    }
    triangle {
      < 8.449459, -1.115818, -2.862253>,
      < 8.640915, -1.508811, -2.394224>,
      < 7.979931, -1.865773, -2.699738>
    }
    triangle {
      < 8.449459, -1.115818, -2.862253>,
      < 7.979931, -1.865773, -2.699738>,
      < 8.001176, -1.730777, -2.774402>
    }
    triangle {
      < 8.449459, -1.115818, -2.862253>,
      < 8.001176, -1.730777, -2.774402>,
      < 8.051655, -1.600783, -2.819990>
    }
    triangle {
      < 8.449459, -1.115818, -2.862253>,
      < 8.051655, -1.600783, -2.819990>,
      < 8.253127, -1.245801, -2.845419>
    }
    triangle {
      < 8.449459, -1.115818, -2.862253>,
      < 8.253127, -1.245801, -2.845419>,
      < 8.322593, -1.180807, -2.844753>
    }
    triangle {
      < 8.449459, -1.115818, -2.862253>,
      < 8.322593, -1.180807, -2.844753>,
      < 8.416007, -1.160815, -2.864733>
    }
    triangle {
      < 4.268528, 0.401606, -2.710315>,
      < 4.966898, 0.413589, -2.698662>,
      < 5.193110, 0.404471, -2.716558>
    }
    triangle {
      < 4.388336, -1.110468, -3.053267>,
      < 3.467531, -0.935387, -3.049246>,
      < 4.701740, -1.055495, -3.050892>
    }
    triangle {
      < 3.467531, -0.935387, -3.049246>,
      < 4.130360, -1.230445, -3.044371>,
      < 1.865744, -1.250247, -3.032106>
    }
    triangle {
      < 3.467531, -0.935387, -3.049246>,
      < 1.865744, -1.250247, -3.032106>,
      < 1.883856, -0.945249, -3.050085>
    }
    triangle {
      < 1.854504, -1.570245, -2.994691>,
      < 3.844535, -1.550419, -3.005050>,
      < 3.808440, -1.839552, -2.919236>
    }
    triangle {
      < 1.854504, -1.570245, -2.994691>,
      < 3.808440, -1.839552, -2.919236>,
      < 1.829418, -1.745242, -2.960097>
    }
    triangle {
      < 3.467531, -0.935387, -3.049246>,
      < 4.388336, -1.110468, -3.053267>,
      < 4.130360, -1.230445, -3.044371>
    }
    triangle {
      < 3.808440, -1.839552, -2.919236>,
      < 1.762765, -1.820235, -2.933957>,
      < 1.829418, -1.745242, -2.960097>
    }
    triangle {
      < 7.940545, 0.242483, -2.345044>,
      < 7.932977, 0.257270, -2.183802>,
      < 8.073201, 0.205660, -2.193727>
    }
    triangle {
      < 7.940545, 0.242483, -2.345044>,
      < 8.073201, 0.205660, -2.193727>,
      < 8.072657, 0.190923, -2.331323>
    }
    triangle {
      < 8.072657, 0.190923, -2.331323>,
      < 8.073201, 0.205660, -2.193727>,
      < 8.182999, 0.129380, -2.192896>
    }
    triangle {
      < 8.072657, 0.190923, -2.331323>,
      < 8.182999, 0.129380, -2.192896>,
      < 8.193651, 0.124517, -2.331956>
    }
    triangle {
      < 7.643649, 0.311180, -2.478775>,
      < 7.650219, 0.285880, -2.360173>,
      < 7.940545, 0.242483, -2.345044>
    }
    triangle {
      < 7.643649, 0.311180, -2.478775>,
      < 7.940545, 0.242483, -2.345044>,
      < 7.925941, 0.262861, -2.455819>
    }
    triangle {
      < 8.069251, 0.221174, -2.443563>,
      < 8.072657, 0.190923, -2.331323>,
      < 8.193651, 0.124517, -2.331956>
    }
    triangle {
      < 8.069251, 0.221174, -2.443563>,
      < 8.193651, 0.124517, -2.331956>,
      < 8.223092, 0.144336, -2.417044>
    }
    triangle {
      < 7.908731, 0.294364, -2.556156>,
      < 7.925941, 0.262861, -2.455819>,
      < 8.069251, 0.221174, -2.443563>
    }
    triangle {
      < 7.908731, 0.294364, -2.556156>,
      < 8.069251, 0.221174, -2.443563>,
      < 8.107162, 0.252623, -2.518976>
    }
    triangle {
      < 8.107162, 0.252623, -2.518976>,
      < 8.069251, 0.221174, -2.443563>,
      < 8.223092, 0.144336, -2.417044>
    }
    triangle {
      < 8.107162, 0.252623, -2.518976>,
      < 8.223092, 0.144336, -2.417044>,
      < 8.259270, 0.209057, -2.489348>
    }
    triangle {
      < 8.440199, -0.463641, -2.193263>,
      < 8.436363, -0.458416, -2.289739>,
      < 8.365832, -0.142549, -2.304032>
    }
    triangle {
      < 8.440199, -0.463641, -2.193263>,
      < 8.365832, -0.142549, -2.304032>,
      < 8.366402, -0.137784, -2.182268>
    }
    triangle {
      < 8.366402, -0.137784, -2.182268>,
      < 8.365832, -0.142549, -2.304032>,
      < 8.291826, 0.013337, -2.313897>
    }
    triangle {
      < 8.366402, -0.137784, -2.182268>,
      < 8.291826, 0.013337, -2.313897>,
      < 8.301852, 0.017987, -2.188884>
    }
    triangle {
      < 8.487261, -0.964077, -2.271214>,
      < 8.489470, -0.969292, -2.170007>,
      < 8.486027, -1.114300, -2.149738>
    }
    triangle {
      < 8.487261, -0.964077, -2.271214>,
      < 8.486027, -1.114300, -2.149738>,
      < 8.513547, -1.144411, -2.261814>
    }
    triangle {
      < 8.513547, -1.144411, -2.261814>,
      < 8.486027, -1.114300, -2.149738>,
      < 8.509673, -1.194734, -2.067450>
    }
    triangle {
      < 6.019087, 0.405001, -2.470772>,
      < 6.328420, 0.420911, -2.200800>,
      < 7.113728, 0.361826, -2.211385>
    }
    triangle {
      < 6.019087, 0.405001, -2.470772>,
      < 7.113728, 0.361826, -2.211385>,
      < 7.119617, 0.342049, -2.367906>
    }
    triangle {
      < 6.047067, 0.434167, -2.196927>,
      < 6.144370, 0.447848, -2.094849>,
      < 6.219293, 0.427158, -2.190680>
    }
    triangle {
      < 6.047067, 0.434167, -2.196927>,
      < 6.219293, 0.427158, -2.190680>,
      < 6.019087, 0.405001, -2.470772>
    }
    triangle {
      < 6.019087, 0.405001, -2.470772>,
      < 6.219293, 0.427158, -2.190680>,
      < 6.328420, 0.420911, -2.200800>
    }
    triangle {
      < 6.047067, 0.434167, -2.196927>,
      < 6.110524, 0.468056, -1.995495>,
      < 6.144370, 0.447848, -2.094849>
    }
    triangle {
      < 6.971869, -1.560690, -2.938550>,
      < 8.051655, -1.600783, -2.865190>,
      < 8.001176, -1.730777, -2.819602>
    }
    triangle {
      < 6.971869, -1.560690, -2.938550>,
      < 8.001176, -1.730777, -2.819602>,
      < 6.959054, -1.695689, -2.917074>
    }
    triangle {
      < 7.201694, -0.930711, -2.952916>,
      < 6.261692, -1.360630, -3.006923>,
      < 5.679337, -1.160580, -3.032548>
    }
    triangle {
      < 7.201694, -0.930711, -2.952916>,
      < 5.679337, -1.160580, -3.032548>,
      < 5.776326, -0.750587, -2.994811>
    }
    triangle {
      < 5.776326, -0.750587, -2.994811>,
      < 5.679337, -1.160580, -3.032548>,
      < 5.092771, -1.050529, -3.039951>
    }
    triangle {
      < 5.776326, -0.750587, -2.994811>,
      < 5.092771, -1.050529, -3.039951>,
      < 4.540823, -0.625480, -3.022290>
    }
    triangle {
      < 4.540823, -0.625480, -3.022290>,
      < 5.092771, -1.050529, -3.039951>,
      < 4.701740, -1.055495, -3.050892>
    }
    triangle {
      < 9.089541, 0.294427, -2.558130>,
      < 7.908731, 0.294364, -2.556156>,
      < 8.107162, 0.252623, -2.518976>
    }
    triangle {
      < 8.656049, -0.866875, -2.422487>,
      < 8.578271, -0.844893, -2.393535>,
      < 8.640915, -1.140712, -2.394224>
    }
    triangle {
      < 8.259270, 0.209057, -2.489348>,
      < 9.089541, 0.294427, -2.558130>,
      < 8.107162, 0.252623, -2.518976>
    }
    triangle {
      < 9.142529, 0.248598, -2.550370>,
      < 8.479552, -0.128594, -2.450057>,
      < 8.561139, -0.434614, -2.421418>
    }
    triangle {
      < 9.142529, 0.248598, -2.550370>,
      < 8.561139, -0.434614, -2.421418>,
      < 8.749555, -0.613710, -2.466970>
    }
    triangle {
      < 9.089541, 0.294427, -2.558130>,
      < 8.390141, 0.062475, -2.459994>,
      < 8.479552, -0.128594, -2.450057>
    }
    triangle {
      < 9.089541, 0.294427, -2.558130>,
      < 8.479552, -0.128594, -2.450057>,
      < 9.142529, 0.248598, -2.550370>
    }
    triangle {
      < 9.089541, 0.294427, -2.558130>,
      < 8.259270, 0.209057, -2.489348>,
      < 8.390141, 0.062475, -2.459994>
    }
    triangle {
      < 8.578271, -0.844893, -2.393535>,
      < 8.656049, -0.866875, -2.422487>,
      < 8.749555, -0.613710, -2.466970>
    }
    triangle {
      < 8.578271, -0.844893, -2.393535>,
      < 8.749555, -0.613710, -2.466970>,
      < 8.561139, -0.434614, -2.421418>
    }
    triangle {
      < 8.515425, -0.914250, -2.351519>,
      < 8.487261, -0.964077, -2.271214>,
      < 8.513547, -1.144411, -2.261814>
    }
    triangle {
      < 8.515425, -0.914250, -2.351519>,
      < 8.513547, -1.144411, -2.261814>,
      < 8.539258, -1.154597, -2.321690>
    }
    triangle {
      < 8.399913, -0.142759, -2.403348>,
      < 8.365832, -0.142549, -2.304032>,
      < 8.436363, -0.458416, -2.289739>
    }
    triangle {
      < 8.399913, -0.142759, -2.403348>,
      < 8.436363, -0.458416, -2.289739>,
      < 8.492520, -0.453904, -2.376204>
    }
    triangle {
      < 5.522338, 0.563309, -1.156139>,
      < 5.435663, 0.594303, -1.148942>,
      < 5.484661, 0.611664, 0.000000>
    }
    triangle {
      < 5.522338, 0.563309, -1.156139>,
      < 5.484661, 0.611664, 0.000000>,
      < 5.569658, 0.575682, -0.000026>
    }
    triangle {
      < 5.412265, 0.520830, -1.822873>,
      < 5.336588, 0.556670, -1.801338>,
      < 5.435663, 0.594303, -1.148942>
    }
    triangle {
      < 5.412265, 0.520830, -1.822873>,
      < 5.435663, 0.594303, -1.148942>,
      < 5.522338, 0.563309, -1.156139>
    }
    triangle {
      < 5.018622, 0.476534, -2.433598>,
      < 5.027698, 0.491304, -2.367082>,
      < 5.203112, 0.518845, -2.137795>
    }
    triangle {
      < 5.018622, 0.476534, -2.433598>,
      < 5.203112, 0.518845, -2.137795>,
      < 5.236760, 0.493609, -2.221350>
    }
    triangle {
      < 5.236760, 0.493609, -2.221350>,
      < 5.203112, 0.518845, -2.137795>,
      < 5.336588, 0.556670, -1.801338>
    }
    triangle {
      < 5.236760, 0.493609, -2.221350>,
      < 5.336588, 0.556670, -1.801338>,
      < 5.412265, 0.520830, -1.822873>
    }
    triangle {
      < 3.467531, -0.935387, -3.049246>,
      < 2.970855, -0.501905, -3.023529>,
      < 3.517423, -0.530391, -3.028297>
    }
    triangle {
      < 3.467531, -0.935387, -3.049246>,
      < 3.517423, -0.530391, -3.028297>,
      < 4.540823, -0.625480, -3.022290>
    }
    triangle {
      < 3.467531, -0.935387, -3.049246>,
      < 4.540823, -0.625480, -3.022290>,
      < 4.701740, -1.055495, -3.050892>
    }
    triangle {
      < 7.201694, -0.930711, -2.952916>,
      < 8.322593, -1.180807, -2.889953>,
      < 8.253127, -1.245801, -2.890619>
    }
    triangle {
      < 6.261692, -1.360630, -3.006923>,
      < 6.241868, -1.425629, -3.042024>,
      < 5.657246, -1.250579, -3.065898>
    }
    triangle {
      < 6.261692, -1.360630, -3.006923>,
      < 5.657246, -1.250579, -3.065898>,
      < 5.679337, -1.160580, -3.032548>
    }
    triangle {
      < 5.679337, -1.160580, -3.032548>,
      < 5.657246, -1.250579, -3.065898>,
      < 5.080426, -1.155529, -3.085750>
    }
    triangle {
      < 5.679337, -1.160580, -3.032548>,
      < 5.080426, -1.155529, -3.085750>,
      < 5.092771, -1.050529, -3.039951>
    }
    triangle {
      < 5.092771, -1.050529, -3.039951>,
      < 5.080426, -1.155529, -3.085750>,
      < 4.701845, -1.150496, -3.086946>
    }
    triangle {
      < 5.092771, -1.050529, -3.039951>,
      < 4.701845, -1.150496, -3.086946>,
      < 4.701740, -1.055495, -3.050892>
    }
    triangle {
      < 4.701740, -1.055495, -3.050892>,
      < 4.701845, -1.150496, -3.086946>,
      < 4.406470, -1.190470, -3.089263>
    }
    triangle {
      < 4.701740, -1.055495, -3.050892>,
      < 4.406470, -1.190470, -3.089263>,
      < 4.388336, -1.110468, -3.053267>
    }
    triangle {
      < 4.388336, -1.110468, -3.053267>,
      < 4.406470, -1.190470, -3.089263>,
      < 4.178975, -1.275450, -3.070565>
    }
    triangle {
      < 4.388336, -1.110468, -3.053267>,
      < 4.178975, -1.275450, -3.070565>,
      < 4.130360, -1.230445, -3.044371>
    }
    triangle {
      < 3.955592, -1.365430, -3.036598>,
      < 4.001390, -1.410434, -3.048934>,
      < 3.886168, -1.555423, -3.014625>
    }
    triangle {
      < 3.955592, -1.365430, -3.036598>,
      < 3.886168, -1.555423, -3.014625>,
      < 3.844535, -1.550419, -3.005050>
    }
    triangle {
      < 3.844535, -1.550419, -3.005050>,
      < 3.886168, -1.555423, -3.014625>,
      < 3.808440, -1.839552, -2.919236>
    }
    triangle {
      < 4.130360, -1.230445, -3.044371>,
      < 4.178975, -1.275450, -3.070565>,
      < 4.001390, -1.410434, -3.048934>
    }
    triangle {
      < 4.130360, -1.230445, -3.044371>,
      < 4.001390, -1.410434, -3.048934>,
      < 3.955592, -1.365430, -3.036598>
    }
    triangle {
      < -2.703817, 0.490182, -1.880681>,
      < -2.477282, 0.570167, -1.677680>,
      < -2.338066, 0.541556, -1.972795>
    }
    triangle {
      < -2.703817, 0.490182, -1.880681>,
      < -2.338066, 0.541556, -1.972795>,
      < -2.612738, 0.475170, -2.046601>
    }
    triangle {
      < -2.612738, 0.475170, -2.046601>,
      < -2.338066, 0.541556, -1.972795>,
      < -2.216968, 0.523991, -2.156171>
    }
    triangle {
      < -2.612738, 0.475170, -2.046601>,
      < -2.216968, 0.523991, -2.156171>,
      < -2.450803, 0.470151, -2.222745>
    }
    triangle {
      < -2.271515, 0.470132, -2.351997>,
      < -2.124247, 0.515122, -2.250817>,
      < -1.937317, 0.490102, -2.388227>
    }
    triangle {
      < -2.271515, 0.470132, -2.351997>,
      < -1.937317, 0.490102, -2.388227>,
      < -2.009329, 0.475106, -2.461809>
    }
    triangle {
      < -2.009329, 0.475106, -2.461809>,
      < -1.937317, 0.490102, -2.388227>,
      < -1.738342, 0.485082, -2.495975>
    }
    triangle {
      < -2.009329, 0.475106, -2.461809>,
      < -1.738342, 0.485082, -2.495975>,
      < -1.743652, 0.475082, -2.513202>
    }
    triangle {
      < -1.743652, 0.475082, -2.513202>,
      < -1.738342, 0.485082, -2.495975>,
      < -1.534455, 0.475062, -2.550094>
    }
    triangle {
      < -2.450803, 0.470151, -2.222745>,
      < -2.216968, 0.523991, -2.156171>,
      < -2.124247, 0.515122, -2.250817>
    }
    triangle {
      < -2.450803, 0.470151, -2.222745>,
      < -2.124247, 0.515122, -2.250817>,
      < -2.271515, 0.470132, -2.351997>
    }
    triangle {
      < -2.703817, 0.490182, -1.880681>,
      < -2.807869, 0.525200, -1.530828>,
      < -2.551558, 0.580177, -1.443880>
    }
    triangle {
      < -2.703817, 0.490182, -1.880681>,
      < -2.551558, 0.580177, -1.443880>,
      < -2.477282, 0.570167, -1.677680>
    }
    triangle {
      < -2.879675, 0.555217, -1.114004>,
      < -2.596643, 0.595192, -1.118505>,
      < -2.551558, 0.580177, -1.443880>
    }
    triangle {
      < -2.879675, 0.555217, -1.114004>,
      < -2.551558, 0.580177, -1.443880>,
      < -2.807869, 0.525200, -1.530828>
    }
    triangle {
      < 8.578271, -0.844893, -2.393535>,
      < 8.515425, -0.914250, -2.351519>,
      < 8.539258, -1.154597, -2.321690>
    }
    triangle {
      < 8.578271, -0.844893, -2.393535>,
      < 8.539258, -1.154597, -2.321690>,
      < 8.640915, -1.140712, -2.394224>
    }
    triangle {
      < 8.492520, -0.453904, -2.376204>,
      < 8.561139, -0.434614, -2.421418>,
      < 8.479552, -0.128594, -2.450057>
    }
    triangle {
      < 8.492520, -0.453904, -2.376204>,
      < 8.479552, -0.128594, -2.450057>,
      < 8.399913, -0.142759, -2.403348>
    }
    triangle {
      < 8.561139, -0.434614, -2.421418>,
      < 8.492520, -0.453904, -2.376204>,
      < 8.515425, -0.914250, -2.351519>
    }
    triangle {
      < 8.561139, -0.434614, -2.421418>,
      < 8.515425, -0.914250, -2.351519>,
      < 8.578271, -0.844893, -2.393535>
    }
    triangle {
      < 4.812309, 0.452697, -2.525539>,
      < 4.818051, 0.424675, -2.645805>,
      < 4.633741, 0.426260, -2.557898>
    }
    triangle {
      < 4.818051, 0.424675, -2.645805>,
      < 4.812309, 0.452697, -2.525539>,
      < 5.018622, 0.476534, -2.433598>
    }
    triangle {
      < 4.818051, 0.424675, -2.645805>,
      < 5.018622, 0.476534, -2.433598>,
      < 4.968434, 0.412051, -2.634367>
    }
    triangle {
      < 4.818051, 0.424675, -2.645805>,
      < 4.968434, 0.412051, -2.634367>,
      < 4.939573, 0.418233, -2.648936>
    }
    triangle {
      < 4.968434, 0.412051, -2.634367>,
      < 5.018622, 0.476534, -2.433598>,
      < 5.236760, 0.493609, -2.221350>
    }
    triangle {
      < 4.968434, 0.412051, -2.634367>,
      < 5.236760, 0.493609, -2.221350>,
      < 6.047067, 0.434167, -2.196927>
    }
    triangle {
      < 4.968434, 0.412051, -2.634367>,
      < 6.047067, 0.434167, -2.196927>,
      < 6.019087, 0.405001, -2.470772>
    }
    triangle {
      < 4.968434, 0.412051, -2.634367>,
      < 6.019087, 0.405001, -2.470772>,
      < 5.194364, 0.402142, -2.616375>
    }
    triangle {
      < 6.193891, 0.530497, -1.142380>,
      < 5.522338, 0.563309, -1.156139>,
      < 5.569658, 0.575682, -0.000026>
    }
    triangle {
      < 6.193891, 0.530497, -1.142380>,
      < 5.569658, 0.575682, -0.000026>,
      < 6.233547, 0.557975, 0.000000>
    }
    triangle {
      < 8.072657, 0.190923, -2.331323>,
      < 8.069251, 0.221174, -2.443563>,
      < 7.925941, 0.262861, -2.455819>
    }
    triangle {
      < 8.072657, 0.190923, -2.331323>,
      < 7.925941, 0.262861, -2.455819>,
      < 7.940545, 0.242483, -2.345044>
    }
    triangle {
      < 7.932977, 0.257270, -2.183802>,
      < 7.940545, 0.242483, -2.345044>,
      < 7.650219, 0.285880, -2.360173>
    }
    triangle {
      < 7.932977, 0.257270, -2.183802>,
      < 7.650219, 0.285880, -2.360173>,
      < 7.642765, 0.310666, -2.198912>
    }
    triangle {
      < 8.487261, -0.964077, -2.271214>,
      < 8.515425, -0.914250, -2.351519>,
      < 8.492520, -0.453904, -2.376204>
    }
    triangle {
      < 8.487261, -0.964077, -2.271214>,
      < 8.492520, -0.453904, -2.376204>,
      < 8.436363, -0.458416, -2.289739>
    }
    triangle {
      < 6.121673, 0.477584, -1.811959>,
      < 5.412265, 0.520830, -1.822873>,
      < 5.522338, 0.563309, -1.156139>
    }
    triangle {
      < 6.121673, 0.477584, -1.811959>,
      < 5.522338, 0.563309, -1.156139>,
      < 6.193891, 0.530497, -1.142380>
    }
    triangle {
      < 3.844535, -1.550419, -3.005050>,
      < 1.854504, -1.570245, -2.994691>,
      < 1.865744, -1.250247, -3.032106>
    }
    triangle {
      < 3.844535, -1.550419, -3.005050>,
      < 1.865744, -1.250247, -3.032106>,
      < 3.955592, -1.365430, -3.036598>
    }
    triangle {
      < 6.971869, -1.560690, -2.938550>,
      < 7.201694, -0.930711, -2.952916>,
      < 8.253127, -1.245801, -2.890619>
    }
    triangle {
      < 6.971869, -1.560690, -2.938550>,
      < 8.253127, -1.245801, -2.890619>,
      < 8.051655, -1.600783, -2.865190>
    }
    triangle {
      < 6.959054, -1.695689, -2.917074>,
      < 8.001176, -1.730777, -2.819602>,
      < 7.979931, -1.865773, -2.744938>
    }
    triangle {
      < 6.959054, -1.695689, -2.917074>,
      < 7.979931, -1.865773, -2.744938>,
      < 7.408657, -1.865725, -2.811972>
    }
    triangle {
      < 6.959054, -1.695689, -2.917074>,
      < 7.408657, -1.865725, -2.811972>,
      < 7.210523, -1.845708, -2.831152>
    }
    triangle {
      < 1.865744, -1.250247, -3.032106>,
      < 4.130360, -1.230445, -3.044371>,
      < 3.955592, -1.365430, -3.036598>
    }
    triangle {
      < 1.883856, -0.945249, -3.050085>,
      < 2.732397, -0.489476, -3.021448>,
      < 2.970855, -0.501905, -3.023529>
    }
    triangle {
      < 1.883856, -0.945249, -3.050085>,
      < 2.970855, -0.501905, -3.023529>,
      < 3.467531, -0.935387, -3.049246>
    }
    triangle {
      < -7.042752, 0.341757, 2.455381>,
      < -7.045109, 0.325588, 2.499018>,
      < -6.793167, 0.370522, 2.504061>
    }
    triangle {
      < -7.042752, 0.341757, 2.455381>,
      < -6.793167, 0.370522, 2.504061>,
      < -6.792259, 0.385825, 2.457998>
    }
    triangle {
      < -6.372285, 0.415666, 2.503308>,
      < -6.371355, 0.434591, 2.459998>,
      < -6.792259, 0.385825, 2.457998>
    }
    triangle {
      < -6.372285, 0.415666, 2.503308>,
      < -6.792259, 0.385825, 2.457998>,
      < -6.793167, 0.370522, 2.504061>
    }
    triangle {
      < -2.201815, 0.475123, 2.446030>,
      < -3.323596, 0.495221, 2.437180>,
      < -3.314507, 0.507020, 2.480529>
    }
    triangle {
      < -2.201815, 0.475123, 2.446030>,
      < -3.314507, 0.507020, 2.480529>,
      < -2.199284, 0.494422, 2.489617>
    }
    triangle {
      < -5.511763, 0.447911, 2.509270>,
      < -5.516523, 0.470962, 2.461994>,
      < -6.371355, 0.434591, 2.459998>
    }
    triangle {
      < -5.511763, 0.447911, 2.509270>,
      < -6.371355, 0.434591, 2.459998>,
      < -6.372285, 0.415666, 2.503308>
    }
    triangle {
      < -5.511763, 0.447911, 2.509270>,
      < -4.646445, 0.480335, 2.515266>,
      < -4.644973, 0.497136, 2.467526>
    }
    triangle {
      < -5.511763, 0.447911, 2.509270>,
      < -4.644973, 0.497136, 2.467526>,
      < -5.516523, 0.470962, 2.461994>
    }
    triangle {
      < -4.646445, 0.480335, 2.515266>,
      < -3.305417, 0.485218, 2.523878>,
      < -3.314507, 0.507020, 2.480529>
    }
    triangle {
      < -4.646445, 0.480335, 2.515266>,
      < -3.314507, 0.507020, 2.480529>,
      < -4.644973, 0.497136, 2.467526>
    }
    triangle {
      < -6.791352, 0.367527, 2.411935>,
      < -7.040396, 0.324326, 2.411743>,
      < -7.042752, 0.341757, 2.455381>
    }
    triangle {
      < -6.791352, 0.367527, 2.411935>,
      < -7.042752, 0.341757, 2.455381>,
      < -6.792259, 0.385825, 2.457998>
    }
    triangle {
      < -6.370425, 0.419915, 2.416687>,
      < -6.791352, 0.367527, 2.411935>,
      < -6.792259, 0.385825, 2.457998>
    }
    triangle {
      < -6.370425, 0.419915, 2.416687>,
      < -6.792259, 0.385825, 2.457998>,
      < -6.371355, 0.434591, 2.459998>
    }
    triangle {
      < -5.521283, 0.460414, 2.414717>,
      < -6.370425, 0.419915, 2.416687>,
      < -6.371355, 0.434591, 2.459998>
    }
    triangle {
      < -5.521283, 0.460414, 2.414717>,
      < -6.371355, 0.434591, 2.459998>,
      < -5.516523, 0.470962, 2.461994>
    }
    triangle {
      < -4.643502, 0.480337, 2.419787>,
      < -5.521283, 0.460414, 2.414717>,
      < -5.516523, 0.470962, 2.461994>
    }
    triangle {
      < -4.643502, 0.480337, 2.419787>,
      < -5.516523, 0.470962, 2.461994>,
      < -4.644973, 0.497136, 2.467526>
    }
    triangle {
      < -3.323596, 0.495221, 2.437180>,
      < -4.643502, 0.480337, 2.419787>,
      < -4.644973, 0.497136, 2.467526>
    }
    triangle {
      < -3.323596, 0.495221, 2.437180>,
      < -4.644973, 0.497136, 2.467526>,
      < -3.314507, 0.507020, 2.480529>
    }
    triangle {
      < -2.201815, 0.475123, 2.446030>,
      < -2.199284, 0.494422, 2.489617>,
      < -2.040543, 0.480108, 2.497175>
    }
    triangle {
      < -7.042752, 0.341757, 2.455381>,
      < -7.040396, 0.324326, 2.411743>,
      < -7.045109, 0.325588, 2.499018>
    }
    triangle {
      < -2.196753, 0.480121, 2.533204>,
      < -2.040543, 0.480108, 2.497175>,
      < -2.199284, 0.494422, 2.489617>
    }
    triangle {
      < -3.305417, 0.485218, 2.523878>,
      < -2.196753, 0.480121, 2.533204>,
      < -2.199284, 0.494422, 2.489617>
    }
    triangle {
      < -3.305417, 0.485218, 2.523878>,
      < -2.199284, 0.494422, 2.489617>,
      < -3.314507, 0.507020, 2.480529>
    }
    triangle {
      < -6.998756, 0.275547, 2.233527>,
      < -7.040396, 0.324326, 2.411743>,
      < -6.791352, 0.367527, 2.411935>
    }
    triangle {
      < -6.998756, 0.275547, 2.233527>,
      < -6.791352, 0.367527, 2.411935>,
      < -6.774367, 0.325528, 2.216882>
    }
    triangle {
      < -6.313721, 0.085471, 2.884622>,
      < -6.685298, 0.070503, 2.877093>,
      < -6.493976, 0.000486, 2.887964>
    }
    triangle {
      < -6.313721, 0.085471, 2.884622>,
      < -6.493976, 0.000486, 2.887964>,
      < -6.315780, -0.001138, 2.889217>
    }
    triangle {
      < -6.774128, 0.320516, 2.693169>,
      < -7.011448, 0.280537, 2.670665>,
      < -6.937014, 0.200527, 2.795497>
    }
    triangle {
      < -6.774128, 0.320516, 2.693169>,
      < -6.937014, 0.200527, 2.795497>,
      < -6.744944, 0.220510, 2.816344>
    }
    triangle {
      < -6.709031, 0.120528, 2.016492>,
      < -6.752964, 0.255529, 2.099975>,
      < -6.601350, 0.230518, 2.048617>
    }
    triangle {
      < -2.569514, -1.869857, 2.919900>,
      < -2.749540, -1.604843, 2.992587>,
      < -2.775850, -1.619841, 3.005151>
    }
    triangle {
      < -5.722831, -1.024584, 3.011215>,
      < -5.706758, -0.979586, 3.025065>,
      < -5.914151, -0.939567, 3.000344>
    }
    triangle {
      < -5.722831, -1.024584, 3.011215>,
      < -5.914151, -0.939567, 3.000344>,
      < -5.929483, -0.974566, 2.996465>
    }
    triangle {
      < -6.745515, -0.069491, 2.876542>,
      < -6.742029, -0.294491, 2.856221>,
      < -6.543860, -0.259509, 2.891657>
    }
    triangle {
      < -6.745515, -0.069491, 2.876542>,
      < -6.543860, -0.259509, 2.891657>,
      < -6.508213, -0.204513, 2.899042>
    }
    triangle {
      < -6.745515, -0.069491, 2.876542>,
      < -6.508213, -0.204513, 2.899042>,
      < -6.493976, 0.000486, 2.887964>
    }
    triangle {
      < -6.937014, 0.200527, 2.795497>,
      < -6.831750, 0.065516, 2.862890>,
      < -6.685298, 0.070503, 2.877093>
    }
    triangle {
      < -6.937014, 0.200527, 2.795497>,
      < -6.685298, 0.070503, 2.877093>,
      < -6.744944, 0.220510, 2.816344>
    }
    triangle {
      < -7.045109, 0.325588, 2.499018>,
      < -7.011448, 0.280537, 2.670665>,
      < -6.774128, 0.320516, 2.693169>
    }
    triangle {
      < -7.045109, 0.325588, 2.499018>,
      < -6.774128, 0.320516, 2.693169>,
      < -6.793167, 0.370522, 2.504061>
    }
    triangle {
      < -5.538681, -0.719600, 2.992549>,
      < -5.926707, -0.864565, 2.966181>,
      < -5.914151, -0.939567, 3.000344>
    }
    triangle {
      < -5.538681, -0.719600, 2.992549>,
      < -5.914151, -0.939567, 3.000344>,
      < -5.706758, -0.979586, 3.025065>
    }
    triangle {
      < -5.538681, -0.719600, 2.992549>,
      < -5.706758, -0.979586, 3.025065>,
      < -5.491589, -0.769605, 3.019136>
    }
    triangle {
      < -5.285660, -0.649623, 3.023917>,
      < -5.024517, -0.579646, 3.029613>,
      < -5.047047, -0.519643, 2.996191>
    }
    triangle {
      < -5.285660, -0.649623, 3.023917>,
      < -5.047047, -0.519643, 2.996191>,
      < -5.318162, -0.594619, 2.991234>
    }
    triangle {
      < -6.752964, 0.255529, 2.099975>,
      < -6.937092, 0.210545, 2.118648>,
      < -6.998756, 0.275547, 2.233527>
    }
    triangle {
      < -6.752964, 0.255529, 2.099975>,
      < -6.998756, 0.275547, 2.233527>,
      < -6.774367, 0.325528, 2.216882>
    }
    triangle {
      < -6.020165, 0.320469, 1.975418>,
      < -6.325075, 0.255495, 1.988010>,
      < -6.328014, 0.315493, 2.083492>
    }
    triangle {
      < -6.524671, -0.444511, 2.880200>,
      < -6.458776, -0.844517, 2.890340>,
      < -6.250638, -0.849536, 2.925035>
    }
    triangle {
      < -6.524671, -0.444511, 2.880200>,
      < -6.250638, -0.849536, 2.925035>,
      < -6.262047, -0.349534, 2.905843>
    }
    triangle {
      < -4.613553, 0.305324, 2.823673>,
      < -3.296589, 0.300209, 2.834231>,
      < -3.300608, 0.415212, 2.715453>
    }
    triangle {
      < -4.613553, 0.305324, 2.823673>,
      < -3.300608, 0.415212, 2.715453>,
      < -4.627038, 0.415328, 2.709360>
    }
    triangle {
      < -4.588072, 0.150320, 2.896983>,
      < -3.271854, 0.145205, 2.899896>,
      < -3.296589, 0.300209, 2.834231>
    }
    triangle {
      < -4.588072, 0.150320, 2.896983>,
      < -3.296589, 0.300209, 2.834231>,
      < -4.613553, 0.305324, 2.823673>
    }
    triangle {
      < -6.742830, -0.644484, 2.575500>,
      < -6.729341, -0.694488, 2.689813>,
      < -6.705142, -0.629490, 2.677993>
    }
    triangle {
      < -6.642935, -0.014477, 1.961445>,
      < -6.623542, -0.034476, 1.865155>,
      < -6.668155, -0.139472, 1.861905>
    }
    triangle {
      < -6.642935, -0.014477, 1.961445>,
      < -6.668155, -0.139472, 1.861905>,
      < -6.667507, -0.139475, 1.968278>
    }
    triangle {
      < -3.328631, 0.470232, 2.031439>,
      < -3.357367, 0.464914, 1.876387>,
      < -4.639324, 0.415351, 1.867963>
    }
    triangle {
      < -3.328631, 0.470232, 2.031439>,
      < -4.639324, 0.415351, 1.867963>,
      < -4.614746, 0.425346, 1.996497>
    }
    triangle {
      < -5.511751, 0.360427, 1.867509>,
      < -5.498256, 0.375423, 1.981823>,
      < -4.614746, 0.425346, 1.996497>
    }
    triangle {
      < -5.511751, 0.360427, 1.867509>,
      < -4.614746, 0.425346, 1.996497>,
      < -4.639324, 0.415351, 1.867963>
    }
    triangle {
      < -5.498256, 0.375423, 1.981823>,
      < -5.511751, 0.360427, 1.867509>,
      < -6.045046, 0.300474, 1.864676>
    }
    triangle {
      < -5.498256, 0.375423, 1.981823>,
      < -6.045046, 0.300474, 1.864676>,
      < -6.020165, 0.320469, 1.975418>
    }
    triangle {
      < -6.020165, 0.320469, 1.975418>,
      < -6.045046, 0.300474, 1.864676>,
      < -6.336598, 0.220499, 1.865870>
    }
    triangle {
      < -6.020165, 0.320469, 1.975418>,
      < -6.336598, 0.220499, 1.865870>,
      < -6.325075, 0.255495, 1.988010>
    }
    triangle {
      < -6.325075, 0.255495, 1.988010>,
      < -6.336598, 0.220499, 1.865870>,
      < -6.460075, 0.150510, 1.868090>
    }
    triangle {
      < -6.325075, 0.255495, 1.988010>,
      < -6.460075, 0.150510, 1.868090>,
      < -6.481136, 0.185509, 1.979531>
    }
    triangle {
      < -6.840075, -0.524456, 1.851624>,
      < -6.802513, -0.564470, 2.244009>,
      < -6.743057, -0.509471, 2.099216>
    }
    triangle {
      < -6.840075, -0.524456, 1.851624>,
      < -6.743057, -0.509471, 2.099216>,
      < -6.773168, -0.484462, 1.856496>
    }
    triangle {
      < -6.667507, -0.139475, 1.968278>,
      < -6.668155, -0.139472, 1.861905>,
      < -6.723934, -0.419467, 1.857839>
    }
    triangle {
      < -6.667507, -0.139475, 1.968278>,
      < -6.723934, -0.419467, 1.857839>,
      < -6.709450, -0.434472, 2.011491>
    }
    triangle {
      < -6.709450, -0.434472, 2.011491>,
      < -6.723934, -0.419467, 1.857839>,
      < -6.773168, -0.484462, 1.856496>
    }
    triangle {
      < -6.709450, -0.434472, 2.011491>,
      < -6.773168, -0.484462, 1.856496>,
      < -6.743057, -0.509471, 2.099216>
    }
    triangle {
      < -6.680397, -0.914497, 2.876697>,
      < -6.458776, -0.844517, 2.890340>,
      < -6.660256, -0.699497, 2.810031>
    }
    triangle {
      < -6.680397, -0.914497, 2.876697>,
      < -6.660256, -0.699497, 2.810031>,
      < -6.707729, -0.774492, 2.778454>
    }
    triangle {
      < -6.707729, -0.774492, 2.778454>,
      < -6.660256, -0.699497, 2.810031>,
      < -6.705142, -0.629490, 2.677993>
    }
    triangle {
      < -6.707729, -0.774492, 2.778454>,
      < -6.705142, -0.629490, 2.677993>,
      < -6.729341, -0.694488, 2.689813>
    }
    triangle {
      < -6.742830, -0.644484, 2.575500>,
      < -6.705142, -0.629490, 2.677993>,
      < -6.771651, -0.604478, 2.457309>
    }
    triangle {
      < -5.521283, 0.460414, 2.414717>,
      < -5.503400, 0.430418, 2.182756>,
      < -6.348679, 0.375491, 2.210369>
    }
    triangle {
      < -5.521283, 0.460414, 2.414717>,
      < -6.348679, 0.375491, 2.210369>,
      < -6.370425, 0.419915, 2.416687>
    }
    triangle {
      < -6.347330, 0.360478, 2.701616>,
      < -6.372285, 0.415666, 2.503308>,
      < -6.793167, 0.370522, 2.504061>
    }
    triangle {
      < -6.347330, 0.360478, 2.701616>,
      < -6.793167, 0.370522, 2.504061>,
      < -6.774128, 0.320516, 2.693169>
    }
    triangle {
      < -6.333105, 0.245474, 2.825900>,
      < -6.347330, 0.360478, 2.701616>,
      < -6.774128, 0.320516, 2.693169>
    }
    triangle {
      < -6.333105, 0.245474, 2.825900>,
      < -6.774128, 0.320516, 2.693169>,
      < -6.744944, 0.220510, 2.816344>
    }
    triangle {
      < -6.313721, 0.085471, 2.884622>,
      < -6.333105, 0.245474, 2.825900>,
      < -6.744944, 0.220510, 2.816344>
    }
    triangle {
      < -6.313721, 0.085471, 2.884622>,
      < -6.744944, 0.220510, 2.816344>,
      < -6.685298, 0.070503, 2.877093>
    }
    triangle {
      < -6.774367, 0.325528, 2.216882>,
      < -6.791352, 0.367527, 2.411935>,
      < -6.370425, 0.419915, 2.416687>
    }
    triangle {
      < -6.774367, 0.325528, 2.216882>,
      < -6.370425, 0.419915, 2.416687>,
      < -6.348679, 0.375491, 2.210369>
    }
    triangle {
      < -6.752964, 0.255529, 2.099975>,
      < -6.774367, 0.325528, 2.216882>,
      < -6.348679, 0.375491, 2.210369>
    }
    triangle {
      < -6.752964, 0.255529, 2.099975>,
      < -6.348679, 0.375491, 2.210369>,
      < -6.328014, 0.315493, 2.083492>
    }
    triangle {
      < -6.587705, 0.095519, 1.962366>,
      < -6.709031, 0.120528, 2.016492>,
      < -6.601350, 0.230518, 2.048617>
    }
    triangle {
      < -6.587705, 0.095519, 1.962366>,
      < -6.601350, 0.230518, 2.048617>,
      < -6.481136, 0.185509, 1.979531>
    }
    triangle {
      < -6.587705, 0.095519, 1.962366>,
      < -6.642935, -0.014477, 1.961445>,
      < -6.709031, 0.120528, 2.016492>
    }
    triangle {
      < -6.328014, 0.315493, 2.083492>,
      < -6.325075, 0.255495, 1.988010>,
      < -6.481136, 0.185509, 1.979531>
    }
    triangle {
      < -6.328014, 0.315493, 2.083492>,
      < -6.481136, 0.185509, 1.979531>,
      < -6.601350, 0.230518, 2.048617>
    }
    triangle {
      < -6.328014, 0.315493, 2.083492>,
      < -6.601350, 0.230518, 2.048617>,
      < -6.752964, 0.255529, 2.099975>
    }
    triangle {
      < -6.822981, 0.070537, 2.034971>,
      < -6.937092, 0.210545, 2.118648>,
      < -6.752964, 0.255529, 2.099975>
    }
    triangle {
      < -6.822981, 0.070537, 2.034971>,
      < -6.752964, 0.255529, 2.099975>,
      < -6.709031, 0.120528, 2.016492>
    }
    triangle {
      < -6.758536, -0.009468, 2.025174>,
      < -6.822981, 0.070537, 2.034971>,
      < -6.709031, 0.120528, 2.016492>
    }
    triangle {
      < -6.758536, -0.009468, 2.025174>,
      < -6.709031, 0.120528, 2.016492>,
      < -6.642935, -0.014477, 1.961445>
    }
    triangle {
      < -6.733982, -0.079470, 2.018336>,
      < -6.758536, -0.009468, 2.025174>,
      < -6.642935, -0.014477, 1.961445>
    }
    triangle {
      < -6.587705, 0.095519, 1.962366>,
      < -6.481136, 0.185509, 1.979531>,
      < -6.460075, 0.150510, 1.868090>
    }
    triangle {
      < -6.587705, 0.095519, 1.962366>,
      < -6.460075, 0.150510, 1.868090>,
      < -6.533515, 0.065517, 1.860501>
    }
    triangle {
      < -6.328014, 0.315493, 2.083492>,
      < -6.348679, 0.375491, 2.210369>,
      < -5.503400, 0.430418, 2.182756>
    }
    triangle {
      < -6.328014, 0.315493, 2.083492>,
      < -5.503400, 0.430418, 2.182756>,
      < -5.498256, 0.375423, 1.981823>
    }
    triangle {
      < -6.328014, 0.315493, 2.083492>,
      < -5.498256, 0.375423, 1.981823>,
      < -6.020165, 0.320469, 1.975418>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -6.313721, 0.085471, 2.884622>,
      < -6.315780, -0.001138, 2.889217>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -6.315780, -0.001138, 2.889217>,
      < -6.111966, 0.006052, 2.894136>
    }
    triangle {
      < -3.300608, 0.415212, 2.715453>,
      < -3.305417, 0.485218, 2.523878>,
      < -4.646445, 0.480335, 2.515266>
    }
    triangle {
      < -3.300608, 0.415212, 2.715453>,
      < -4.646445, 0.480335, 2.515266>,
      < -4.627038, 0.415328, 2.709360>
    }
    triangle {
      < -4.613553, 0.305324, 2.823673>,
      < -4.627038, 0.415328, 2.709360>,
      < -5.513570, 0.391834, 2.705370>
    }
    triangle {
      < -4.613553, 0.305324, 2.823673>,
      < -5.513570, 0.391834, 2.705370>,
      < -5.505184, 0.280401, 2.834671>
    }
    triangle {
      < -4.588072, 0.150320, 2.896983>,
      < -4.613553, 0.305324, 2.823673>,
      < -5.505184, 0.280401, 2.834671>
    }
    triangle {
      < -4.588072, 0.150320, 2.896983>,
      < -5.505184, 0.280401, 2.834671>,
      < -5.486871, 0.121344, 2.892958>
    }
    triangle {
      < -3.223694, -0.234801, 2.974232>,
      < -3.271854, 0.145205, 2.899896>,
      < -4.588072, 0.150320, 2.896983>
    }
    triangle {
      < -3.223694, -0.234801, 2.974232>,
      < -4.588072, 0.150320, 2.896983>,
      < -4.547651, -0.229686, 2.969179>
    }
    triangle {
      < -3.331383, 0.470228, 2.197097>,
      < -3.328631, 0.470232, 2.031439>,
      < -4.614746, 0.425346, 1.996497>
    }
    triangle {
      < -3.331383, 0.470228, 2.197097>,
      < -4.614746, 0.425346, 1.996497>,
      < -4.640947, 0.455343, 2.183951>
    }
    triangle {
      < -2.201815, 0.475123, 2.446030>,
      < -2.271515, 0.470132, 2.351997>,
      < -2.450803, 0.470151, 2.222745>
    }
    triangle {
      < -2.201815, 0.475123, 2.446030>,
      < -2.450803, 0.470151, 2.222745>,
      < -3.331383, 0.470228, 2.197097>
    }
    triangle {
      < -2.201815, 0.475123, 2.446030>,
      < -3.331383, 0.470228, 2.197097>,
      < -3.323596, 0.495221, 2.437180>
    }
    triangle {
      < -6.326883, -0.204846, 2.903568>,
      < -6.257797, -0.244839, 2.907863>,
      < -5.446486, -0.229607, 2.950629>
    }
    triangle {
      < -6.326883, -0.204846, 2.903568>,
      < -5.446486, -0.229607, 2.950629>,
      < -6.119413, -0.199368, 2.911458>
    }
    triangle {
      < -6.543860, -0.259509, 2.891657>,
      < -6.257797, -0.244839, 2.907863>,
      < -6.326883, -0.204846, 2.903568>
    }
    triangle {
      < -6.543860, -0.259509, 2.891657>,
      < -6.326883, -0.204846, 2.903568>,
      < -6.508213, -0.204513, 2.899042>
    }
    triangle {
      < -6.448577, -0.172863, 2.900421>,
      < -6.508213, -0.204513, 2.899042>,
      < -6.326883, -0.204846, 2.903568>
    }
    triangle {
      < -6.268429, -0.173387, 2.904441>,
      < -6.326883, -0.204846, 2.903568>,
      < -6.119413, -0.199368, 2.911458>
    }
    triangle {
      < -6.060792, -0.167655, 2.911906>,
      < -6.119413, -0.199368, 2.911458>,
      < -5.446486, -0.229607, 2.950629>
    }
    triangle {
      < -5.513570, 0.391834, 2.705370>,
      < -5.511763, 0.447911, 2.509270>,
      < -6.372285, 0.415666, 2.503308>
    }
    triangle {
      < -5.513570, 0.391834, 2.705370>,
      < -6.372285, 0.415666, 2.503308>,
      < -6.347330, 0.360478, 2.701616>
    }
    triangle {
      < -5.505184, 0.280401, 2.834671>,
      < -5.513570, 0.391834, 2.705370>,
      < -6.347330, 0.360478, 2.701616>
    }
    triangle {
      < -5.505184, 0.280401, 2.834671>,
      < -6.347330, 0.360478, 2.701616>,
      < -6.333105, 0.245474, 2.825900>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -5.505184, 0.280401, 2.834671>,
      < -6.333105, 0.245474, 2.825900>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -6.333105, 0.245474, 2.825900>,
      < -6.313721, 0.085471, 2.884622>
    }
    triangle {
      < -5.926707, -0.864565, 2.966181>,
      < -5.538681, -0.719600, 2.992549>,
      < -5.318162, -0.594619, 2.991234>
    }
    triangle {
      < -5.926707, -0.864565, 2.966181>,
      < -5.318162, -0.594619, 2.991234>,
      < -5.445757, -0.344607, 2.960599>
    }
    triangle {
      < -5.926707, -0.864565, 2.966181>,
      < -5.445757, -0.344607, 2.960599>,
      < -6.262047, -0.349534, 2.905843>
    }
    triangle {
      < -5.926707, -0.864565, 2.966181>,
      < -6.262047, -0.349534, 2.905843>,
      < -6.250638, -0.849536, 2.925035>
    }
    triangle {
      < -5.663052, -1.007231, 3.037668>,
      < -5.706758, -0.979586, 3.025065>,
      < -5.722831, -1.024584, 3.011215>
    }
    triangle {
      < -5.663052, -1.007231, 3.037668>,
      < -5.461406, -0.809276, 3.028569>,
      < -5.491589, -0.769605, 3.019136>
    }
    triangle {
      < -5.663052, -1.007231, 3.037668>,
      < -5.491589, -0.769605, 3.019136>,
      < -5.706758, -0.979586, 3.025065>
    }
    triangle {
      < -5.461406, -0.809276, 3.028569>,
      < -5.266409, -0.695346, 3.031584>,
      < -5.285660, -0.649623, 3.023917>
    }
    triangle {
      < -5.461406, -0.809276, 3.028569>,
      < -5.285660, -0.649623, 3.023917>,
      < -5.491589, -0.769605, 3.019136>
    }
    triangle {
      < -5.266409, -0.695346, 3.031584>,
      < -5.017154, -0.628374, 3.036136>,
      < -5.024517, -0.579646, 3.029613>
    }
    triangle {
      < -5.266409, -0.695346, 3.031584>,
      < -5.024517, -0.579646, 3.029613>,
      < -5.285660, -0.649623, 3.023917>
    }
    triangle {
      < -5.017154, -0.628374, 3.036136>,
      < -4.509265, -0.613634, 3.047463>,
      < -4.507228, -0.564691, 3.041375>
    }
    triangle {
      < -5.017154, -0.628374, 3.036136>,
      < -4.507228, -0.564691, 3.041375>,
      < -5.024517, -0.579646, 3.029613>
    }
    triangle {
      < -4.509265, -0.613634, 3.047463>,
      < -4.111175, -0.662607, 3.057256>,
      < -4.100383, -0.614727, 3.051299>
    }
    triangle {
      < -4.509265, -0.613634, 3.047463>,
      < -4.100383, -0.614727, 3.051299>,
      < -4.507228, -0.564691, 3.041375>
    }
    triangle {
      < -4.111175, -0.662607, 3.057256>,
      < -3.856030, -0.749120, 3.057916>,
      < -3.834638, -0.704750, 3.051635>
    }
    triangle {
      < -4.111175, -0.662607, 3.057256>,
      < -3.834638, -0.704750, 3.051635>,
      < -4.100383, -0.614727, 3.051299>
    }
    triangle {
      < -3.856030, -0.749120, 3.057916>,
      < -3.604055, -0.909909, 3.052055>,
      < -3.575817, -0.869772, 3.045138>
    }
    triangle {
      < -3.856030, -0.749120, 3.057916>,
      < -3.575817, -0.869772, 3.045138>,
      < -3.834638, -0.704750, 3.051635>
    }
    triangle {
      < -3.604055, -0.909909, 3.052055>,
      < -3.336812, -1.116545, 3.058673>,
      < -3.304013, -1.079796, 3.051208>
    }
    triangle {
      < -3.604055, -0.909909, 3.052055>,
      < -3.304013, -1.079796, 3.051208>,
      < -3.575817, -0.869772, 3.045138>
    }
    triangle {
      < -3.336812, -1.116545, 3.058673>,
      < -3.052612, -1.408860, 3.051297>,
      < -3.017002, -1.374821, 3.043360>
    }
    triangle {
      < -3.336812, -1.116545, 3.058673>,
      < -3.017002, -1.374821, 3.043360>,
      < -3.304013, -1.079796, 3.051208>
    }
    triangle {
      < -3.052612, -1.408860, 3.051297>,
      < -2.813603, -1.651789, 3.013454>,
      < -2.775850, -1.619841, 3.005151>
    }
    triangle {
      < -3.052612, -1.408860, 3.051297>,
      < -2.775850, -1.619841, 3.005151>,
      < -3.017002, -1.374821, 3.043360>
    }
    triangle {
      < -2.813603, -1.651789, 3.013454>,
      < -2.569514, -1.869857, 2.919900>,
      < -2.775850, -1.619841, 3.005151>
    }
    triangle {
      < -2.961565, -1.334826, 3.032093>,
      < -2.042209, -1.294905, 3.011163>,
      < -2.026972, -0.999906, 2.997255>
    }
    triangle {
      < -2.961565, -1.334826, 3.032093>,
      < -2.026972, -0.999906, 2.997255>,
      < -3.263842, -1.049799, 3.035828>
    }
    triangle {
      < -3.796964, -0.659753, 3.018759>,
      < -3.535646, -0.834776, 3.029758>,
      < -3.219849, -0.342895, 2.987180>
    }
    triangle {
      < -5.445757, -0.344607, 2.960599>,
      < -5.047047, -0.519643, 2.996191>,
      < -4.515166, -0.489689, 3.001856>
    }
    triangle {
      < -5.445757, -0.344607, 2.960599>,
      < -4.515166, -0.489689, 3.001856>,
      < -4.556523, -0.339685, 2.984874>
    }
    triangle {
      < -5.318162, -0.594619, 2.991234>,
      < -5.047047, -0.519643, 2.996191>,
      < -5.445757, -0.344607, 2.960599>
    }
    triangle {
      < -4.515166, -0.489689, 3.001856>,
      < -4.073049, -0.554728, 3.014176>,
      < -4.556523, -0.339685, 2.984874>
    }
    triangle {
      < -4.556523, -0.339685, 2.984874>,
      < -4.073049, -0.554728, 3.014176>,
      < -3.219849, -0.342895, 2.987180>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -6.055564, -0.023501, 2.899750>,
      < -6.060792, -0.167655, 2.911906>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -6.060792, -0.167655, 2.911906>,
      < -5.446486, -0.229607, 2.950629>
    }
    triangle {
      < -6.111966, 0.006052, 2.894136>,
      < -6.055564, -0.023501, 2.899750>,
      < -5.486871, 0.121344, 2.892958>
    }
    triangle {
      < -6.111966, 0.006052, 2.894136>,
      < -6.259212, -0.030437, 2.894406>,
      < -6.268429, -0.173387, 2.904441>
    }
    triangle {
      < -6.111966, 0.006052, 2.894136>,
      < -6.268429, -0.173387, 2.904441>,
      < -6.119413, -0.199368, 2.911458>
    }
    triangle {
      < -6.315780, -0.001138, 2.889217>,
      < -6.259212, -0.030437, 2.894406>,
      < -6.111966, 0.006052, 2.894136>
    }
    triangle {
      < -6.315780, -0.001138, 2.889217>,
      < -6.438591, -0.029004, 2.892648>,
      < -6.448577, -0.172863, 2.900421>
    }
    triangle {
      < -6.315780, -0.001138, 2.889217>,
      < -6.448577, -0.172863, 2.900421>,
      < -6.326883, -0.204846, 2.903568>
    }
    triangle {
      < -6.493976, 0.000486, 2.887964>,
      < -6.438591, -0.029004, 2.892648>,
      < -6.315780, -0.001138, 2.889217>
    }
    triangle {
      < -5.503400, 0.430418, 2.182756>,
      < -5.521283, 0.460414, 2.414717>,
      < -4.643502, 0.480337, 2.419787>
    }
    triangle {
      < -5.503400, 0.430418, 2.182756>,
      < -4.643502, 0.480337, 2.419787>,
      < -4.640947, 0.455343, 2.183951>
    }
    triangle {
      < -3.305417, 0.485218, 2.523878>,
      < -1.827191, 0.470087, 2.600646>,
      < -2.196753, 0.480121, 2.533204>
    }
    triangle {
      < -2.040543, 0.480108, 2.497175>,
      < -2.196753, 0.480121, 2.533204>,
      < -1.827191, 0.470087, 2.600646>
    }
    triangle {
      < -1.743652, 0.475082, 2.513202>,
      < -2.009329, 0.475106, 2.461809>,
      < -2.040543, 0.480108, 2.497175>
    }
    triangle {
      < -1.743652, 0.475082, 2.513202>,
      < -2.040543, 0.480108, 2.497175>,
      < -1.827191, 0.470087, 2.600646>
    }
    triangle {
      < -2.040543, 0.480108, 2.497175>,
      < -2.009329, 0.475106, 2.461809>,
      < -2.271515, 0.470132, 2.351997>
    }
    triangle {
      < -2.040543, 0.480108, 2.497175>,
      < -2.271515, 0.470132, 2.351997>,
      < -2.201815, 0.475123, 2.446030>
    }
    triangle {
      < -5.498256, 0.375423, 1.981823>,
      < -5.503400, 0.430418, 2.182756>,
      < -4.640947, 0.455343, 2.183951>
    }
    triangle {
      < -5.498256, 0.375423, 1.981823>,
      < -4.640947, 0.455343, 2.183951>,
      < -4.614746, 0.425346, 1.996497>
    }
    triangle {
      < -2.450803, 0.470151, 2.222745>,
      < -2.612738, 0.475170, 2.046601>,
      < -3.328631, 0.470232, 2.031439>
    }
    triangle {
      < -2.450803, 0.470151, 2.222745>,
      < -3.328631, 0.470232, 2.031439>,
      < -3.331383, 0.470228, 2.197097>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -5.446486, -0.229607, 2.950629>,
      < -4.547651, -0.229686, 2.969179>
    }
    triangle {
      < -5.486871, 0.121344, 2.892958>,
      < -4.547651, -0.229686, 2.969179>,
      < -4.588072, 0.150320, 2.896983>
    }
    triangle {
      < -2.005316, -0.229907, 2.966577>,
      < -2.006068, 0.150094, 2.893790>,
      < -3.271854, 0.145205, 2.899896>
    }
    triangle {
      < -2.005316, -0.229907, 2.966577>,
      < -3.271854, 0.145205, 2.899896>,
      < -3.223694, -0.234801, 2.974232>
    }
    triangle {
      < -5.511763, 0.447911, 2.509270>,
      < -5.513570, 0.391834, 2.705370>,
      < -4.627038, 0.415328, 2.709360>
    }
    triangle {
      < -5.511763, 0.447911, 2.509270>,
      < -4.627038, 0.415328, 2.709360>,
      < -4.646445, 0.480335, 2.515266>
    }
    triangle {
      < -2.006068, 0.150094, 2.893790>,
      < -1.980028, 0.300094, 2.823455>,
      < -3.296589, 0.300209, 2.834231>
    }
    triangle {
      < -2.006068, 0.150094, 2.893790>,
      < -3.296589, 0.300209, 2.834231>,
      < -3.271854, 0.145205, 2.899896>
    }
    triangle {
      < -1.980028, 0.300094, 2.823455>,
      < -1.908399, 0.420091, 2.713477>,
      < -3.300608, 0.415212, 2.715453>
    }
    triangle {
      < -1.980028, 0.300094, 2.823455>,
      < -3.300608, 0.415212, 2.715453>,
      < -3.296589, 0.300209, 2.834231>
    }
    triangle {
      < -6.549592, -0.329509, 2.882052>,
      < -6.524671, -0.444511, 2.880200>,
      < -6.262047, -0.349534, 2.905843>
    }
    triangle {
      < -5.538681, -0.719600, 2.992549>,
      < -5.491589, -0.769605, 3.019136>,
      < -5.285660, -0.649623, 3.023917>
    }
    triangle {
      < -5.538681, -0.719600, 2.992549>,
      < -5.285660, -0.649623, 3.023917>,
      < -5.318162, -0.594619, 2.991234>
    }
    triangle {
      < -6.458776, -0.844517, 2.890340>,
      < -6.680397, -0.914497, 2.876697>,
      < -6.250638, -0.849536, 2.925035>
    }
    triangle {
      < -6.831750, 0.065516, 2.862890>,
      < -6.775799, -0.009489, 2.873777>,
      < -6.685298, 0.070503, 2.877093>
    }
    triangle {
      < -6.685298, 0.070503, 2.877093>,
      < -6.775799, -0.009489, 2.873777>,
      < -6.745515, -0.069491, 2.876542>
    }
    triangle {
      < -6.685298, 0.070503, 2.877093>,
      < -6.745515, -0.069491, 2.876542>,
      < -6.493976, 0.000486, 2.887964>
    }
    triangle {
      < -6.680397, -0.914497, 2.876697>,
      < -6.694992, -0.954496, 2.882792>,
      < -5.929483, -0.974566, 2.996465>
    }
    triangle {
      < -6.680397, -0.914497, 2.876697>,
      < -5.929483, -0.974566, 2.996465>,
      < -5.914151, -0.939567, 3.000344>
    }
    triangle {
      < -3.263842, -1.049799, 3.035828>,
      < -3.304013, -1.079796, 3.051208>,
      < -3.017002, -1.374821, 3.043360>
    }
    triangle {
      < -3.263842, -1.049799, 3.035828>,
      < -3.017002, -1.374821, 3.043360>,
      < -2.961565, -1.334826, 3.032093>
    }
    triangle {
      < -3.796964, -0.659753, 3.018759>,
      < -3.834638, -0.704750, 3.051635>,
      < -3.575817, -0.869772, 3.045138>
    }
    triangle {
      < -3.796964, -0.659753, 3.018759>,
      < -3.575817, -0.869772, 3.045138>,
      < -3.535646, -0.834776, 3.029758>
    }
    triangle {
      < -5.047047, -0.519643, 2.996191>,
      < -5.024517, -0.579646, 3.029613>,
      < -4.507228, -0.564691, 3.041375>
    }
    triangle {
      < -5.047047, -0.519643, 2.996191>,
      < -4.507228, -0.564691, 3.041375>,
      < -4.515166, -0.489689, 3.001856>
    }
    triangle {
      < -4.515166, -0.489689, 3.001856>,
      < -4.507228, -0.564691, 3.041375>,
      < -4.100383, -0.614727, 3.051299>
    }
    triangle {
      < -4.515166, -0.489689, 3.001856>,
      < -4.100383, -0.614727, 3.051299>,
      < -4.073049, -0.554728, 3.014176>
    }
    triangle {
      < -4.073049, -0.554728, 3.014176>,
      < -4.100383, -0.614727, 3.051299>,
      < -3.834638, -0.704750, 3.051635>
    }
    triangle {
      < -4.073049, -0.554728, 3.014176>,
      < -3.834638, -0.704750, 3.051635>,
      < -3.796964, -0.659753, 3.018759>
    }
    triangle {
      < -3.535646, -0.834776, 3.029758>,
      < -3.575817, -0.869772, 3.045138>,
      < -3.304013, -1.079796, 3.051208>
    }
    triangle {
      < -3.535646, -0.834776, 3.029758>,
      < -3.304013, -1.079796, 3.051208>,
      < -3.263842, -1.049799, 3.035828>
    }
    triangle {
      < -6.623542, -0.034476, 1.865155>,
      < -6.642935, -0.014477, 1.961445>,
      < -6.587705, 0.095519, 1.962366>
    }
    triangle {
      < -6.623542, -0.034476, 1.865155>,
      < -6.587705, 0.095519, 1.962366>,
      < -6.533515, 0.065517, 1.860501>
    }
    triangle {
      < -4.640947, 0.455343, 2.183951>,
      < -4.643502, 0.480337, 2.419787>,
      < -3.323596, 0.495221, 2.437180>
    }
    triangle {
      < -4.640947, 0.455343, 2.183951>,
      < -3.323596, 0.495221, 2.437180>,
      < -3.331383, 0.470228, 2.197097>
    }
    triangle {
      < -2.749540, -1.604843, 2.992587>,
      < -2.024261, -1.569907, 2.993072>,
      < -2.042209, -1.294905, 3.011163>
    }
    triangle {
      < -2.749540, -1.604843, 2.992587>,
      < -2.042209, -1.294905, 3.011163>,
      < -2.961565, -1.334826, 3.032093>
    }
    triangle {
      < -2.569514, -1.869857, 2.919900>,
      < -2.538924, -1.884860, 2.946151>,
      < -2.009248, -1.854906, 2.925065>
    }
    triangle {
      < -2.569514, -1.869857, 2.919900>,
      < -2.009248, -1.854906, 2.925065>,
      < -2.024261, -1.569907, 2.993072>
    }
    triangle {
      < -2.569514, -1.869857, 2.919900>,
      < -2.024261, -1.569907, 2.993072>,
      < -2.749540, -1.604843, 2.992587>
    }
    triangle {
      < -2.775850, -1.619841, 3.005151>,
      < -2.749540, -1.604843, 2.992587>,
      < -2.961565, -1.334826, 3.032093>
    }
    triangle {
      < -2.775850, -1.619841, 3.005151>,
      < -2.961565, -1.334826, 3.032093>,
      < -3.017002, -1.374821, 3.043360>
    }
    triangle {
      < -2.025026, -0.339706, 2.988144>,
      < -3.219849, -0.342895, 2.987180>,
      < -3.535646, -0.834776, 3.029758>
    }
    triangle {
      < -2.025026, -0.339706, 2.988144>,
      < -3.535646, -0.834776, 3.029758>,
      < -3.263842, -1.049799, 3.035828>
    }
    triangle {
      < -2.025026, -0.339706, 2.988144>,
      < -3.263842, -1.049799, 3.035828>,
      < -2.026972, -0.999906, 2.997255>
    }
    triangle {
      < -5.914151, -0.939567, 3.000344>,
      < -5.926707, -0.864565, 2.966181>,
      < -6.250638, -0.849536, 2.925035>
    }
    triangle {
      < -5.914151, -0.939567, 3.000344>,
      < -6.250638, -0.849536, 2.925035>,
      < -6.680397, -0.914497, 2.876697>
    }
    triangle {
      < -2.612738, 0.475170, 2.046601>,
      < -2.703817, 0.490182, 1.880681>,
      < -3.357367, 0.464914, 1.876387>
    }
    triangle {
      < -2.612738, 0.475170, 2.046601>,
      < -3.357367, 0.464914, 1.876387>,
      < -3.328631, 0.470232, 2.031439>
    }
    triangle {
      < -1.908399, 0.420091, 2.713477>,
      < -1.827191, 0.470087, 2.600646>,
      < -3.305417, 0.485218, 2.523878>
    }
    triangle {
      < -1.908399, 0.420091, 2.713477>,
      < -3.305417, 0.485218, 2.523878>,
      < -3.300608, 0.415212, 2.715453>
    }
    triangle {
      < 6.014196, 0.389435, 2.592635>,
      < 7.656147, 0.345041, 2.573846>,
      < 7.109572, 0.347370, 2.477088>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 5.412265, 0.520830, 1.822873>,
      < 5.236760, 0.493609, 2.221350>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 5.236760, 0.493609, 2.221350>,
      < 6.047067, 0.434167, 2.196927>
    }
    triangle {
      < 4.633741, 0.426260, 2.557898>,
      < 4.278938, 0.429553, 2.620985>,
      < 4.818051, 0.424675, 2.645805>
    }
    triangle {
      < 9.045938, 0.054134, 2.755627>,
      < 7.530486, 0.079263, 2.850085>,
      < 7.457458, -0.145731, 2.893612>
    }
    triangle {
      < 9.045938, 0.054134, 2.755627>,
      < 7.457458, -0.145731, 2.893612>,
      < 8.934355, -0.179734, 2.773799>
    }
    triangle {
      < 8.318105, 0.028205, 2.405346>,
      < 8.390141, 0.062475, 2.459994>,
      < 8.479552, -0.128594, 2.450057>
    }
    triangle {
      < 8.318105, 0.028205, 2.405346>,
      < 8.479552, -0.128594, 2.450057>,
      < 8.399913, -0.142759, 2.403348>
    }
    triangle {
      < -2.647161, 0.620226, 0.000000>,
      < -2.945995, 0.575252, 0.000000>,
      < -2.931157, 0.575235, 0.607670>
    }
    triangle {
      < -2.647161, 0.620226, 0.000000>,
      < -2.931157, 0.575235, 0.607670>,
      < -2.879675, 0.555217, 1.114004>
    }
    triangle {
      < -2.647161, 0.620226, 0.000000>,
      < -2.879675, 0.555217, 1.114004>,
      < -2.596643, 0.595192, 1.118505>
    }
    triangle {
      < 6.912721, -1.695685, 2.927237>,
      < 6.959054, -1.695689, 2.917074>,
      < 6.714520, -1.540669, 2.975575>
    }
    triangle {
      < 6.912721, -1.695685, 2.927237>,
      < 6.714520, -1.540669, 2.975575>,
      < 6.261692, -1.360630, 3.006923>
    }
    triangle {
      < 6.912721, -1.695685, 2.927237>,
      < 6.261692, -1.360630, 3.006923>,
      < 6.241868, -1.425629, 3.042024>
    }
    triangle {
      < 7.201694, -0.930711, 2.952916>,
      < 8.322593, -1.180807, 2.889953>,
      < 8.416007, -1.160815, 2.909933>
    }
    triangle {
      < 7.201694, -0.930711, 2.952916>,
      < 8.416007, -1.160815, 2.909933>,
      < 8.449459, -1.115818, 2.907453>
    }
    triangle {
      < 1.883786, -0.445248, 3.014044>,
      < 1.883856, -0.945249, 3.050085>,
      < 2.732397, -0.489476, 3.021448>
    }
    triangle {
      < 1.841696, 0.184760, 2.842235>,
      < 1.866866, 0.029756, 2.912876>,
      < 2.482622, -0.005298, 2.924798>
    }
    triangle {
      < 1.841696, 0.184760, 2.842235>,
      < 2.482622, -0.005298, 2.924798>,
      < 2.401958, 0.144711, 2.847399>
    }
    triangle {
      < 9.140353, 0.244126, 2.728450>,
      < 9.095436, 0.283447, 2.717090>,
      < 7.629016, 0.319500, 2.761035>
    }
    triangle {
      < 9.140353, 0.244126, 2.728450>,
      < 7.629016, 0.319500, 2.761035>,
      < 7.605241, 0.254258, 2.799703>
    }
    triangle {
      < 4.812309, 0.452697, 2.525539>,
      < 5.018622, 0.476534, 2.433598>,
      < 5.027698, 0.491304, 2.367082>
    }
    triangle {
      < 8.291826, 0.013337, 2.313897>,
      < 8.318105, 0.028205, 2.405346>,
      < 8.399913, -0.142759, 2.403348>
    }
    triangle {
      < 8.291826, 0.013337, 2.313897>,
      < 8.399913, -0.142759, 2.403348>,
      < 8.365832, -0.142549, 2.304032>
    }
    triangle {
      < 7.656147, 0.345041, 2.573846>,
      < 9.089541, 0.294427, 2.558130>,
      < 7.908731, 0.294364, 2.556156>
    }
    triangle {
      < 2.563165, 0.299700, 2.734582>,
      < 2.758114, 0.354683, 2.723550>,
      < 2.745803, 0.369686, 2.664615>
    }
    triangle {
      < 2.563165, 0.299700, 2.734582>,
      < 2.745803, 0.369686, 2.664615>,
      < 2.546063, 0.324703, 2.677072>
    }
    triangle {
      < 1.780270, 0.339770, 2.680530>,
      < 1.797373, 0.309767, 2.738039>,
      < 2.390236, 0.234715, 2.749496>
    }
    triangle {
      < 1.780270, 0.339770, 2.680530>,
      < 2.390236, 0.234715, 2.749496>,
      < 2.393729, 0.259716, 2.691078>
    }
    triangle {
      < 6.971869, -1.560690, 2.938550>,
      < 7.201694, -0.930711, 2.952916>,
      < 6.261692, -1.360630, 3.006923>
    }
    triangle {
      < 6.971869, -1.560690, 2.938550>,
      < 6.261692, -1.360630, 3.006923>,
      < 6.714520, -1.540669, 2.975575>
    }
    triangle {
      < 6.714520, -1.540669, 2.975575>,
      < 6.959054, -1.695689, 2.917074>,
      < 6.971869, -1.560690, 2.938550>
    }
    triangle {
      < 1.797373, 0.309767, 2.738039>,
      < 1.841696, 0.184760, 2.842235>,
      < 2.401958, 0.144711, 2.847399>
    }
    triangle {
      < 1.797373, 0.309767, 2.738039>,
      < 2.401958, 0.144711, 2.847399>,
      < 2.390236, 0.234715, 2.749496>
    }
    triangle {
      < 6.121673, 0.477584, 1.811959>,
      < 6.047067, 0.434167, 2.196927>,
      < 6.110524, 0.468056, 1.995495>
    }
    triangle {
      < 9.045938, 0.054134, 2.755627>,
      < 9.140353, 0.244126, 2.728450>,
      < 7.605241, 0.254258, 2.799703>
    }
    triangle {
      < 9.045938, 0.054134, 2.755627>,
      < 7.605241, 0.254258, 2.799703>,
      < 7.530486, 0.079263, 2.850085>
    }
    triangle {
      < 3.075869, 0.309653, 2.825860>,
      < 3.185711, 0.114641, 2.922582>,
      < 3.533880, 0.110079, 2.930280>
    }
    triangle {
      < 3.075869, 0.309653, 2.825860>,
      < 3.533880, 0.110079, 2.930280>,
      < 3.579291, 0.304609, 2.835365>
    }
    triangle {
      < 7.653469, 0.344960, 2.729584>,
      < 7.629016, 0.319500, 2.761035>,
      < 9.095436, 0.283447, 2.717090>
    }
    triangle {
      < 8.440199, -0.463641, 2.193263>,
      < 8.436363, -0.458416, 2.289739>,
      < 8.487261, -0.964077, 2.271214>
    }
    triangle {
      < 8.440199, -0.463641, 2.193263>,
      < 8.487261, -0.964077, 2.271214>,
      < 8.489470, -0.969292, 2.170007>
    }
    triangle {
      < 1.866866, 0.029756, 2.912876>,
      < 1.907401, -0.325250, 3.023679>,
      < 2.764446, -0.365325, 3.033453>
    }
    triangle {
      < 1.866866, 0.029756, 2.912876>,
      < 2.764446, -0.365325, 3.033453>,
      < 2.482622, -0.005298, 2.924798>
    }
    triangle {
      < 5.976968, 0.269400, 2.827793>,
      < 5.949462, 0.094400, 2.905534>,
      < 7.530486, 0.079263, 2.850085>
    }
    triangle {
      < 5.976968, 0.269400, 2.827793>,
      < 7.530486, 0.079263, 2.850085>,
      < 7.605241, 0.254258, 2.799703>
    }
    triangle {
      < 2.401958, 0.144711, 2.847399>,
      < 2.615479, 0.214693, 2.832859>,
      < 2.587595, 0.269697, 2.784412>
    }
    triangle {
      < 7.629016, 0.319500, 2.761035>,
      < 7.653469, 0.344960, 2.729584>,
      < 6.016861, 0.389399, 2.722277>
    }
    triangle {
      < 7.629016, 0.319500, 2.761035>,
      < 6.016861, 0.389399, 2.722277>,
      < 6.000408, 0.344399, 2.783345>
    }
    triangle {
      < 7.605241, 0.254258, 2.799703>,
      < 7.629016, 0.319500, 2.761035>,
      < 6.000408, 0.344399, 2.783345>
    }
    triangle {
      < 7.605241, 0.254258, 2.799703>,
      < 6.000408, 0.344399, 2.783345>,
      < 5.976968, 0.269400, 2.827793>
    }
    triangle {
      < 7.643649, 0.311180, 2.478775>,
      < 7.656147, 0.345041, 2.573846>,
      < 7.908731, 0.294364, 2.556156>
    }
    triangle {
      < 7.643649, 0.311180, 2.478775>,
      < 7.908731, 0.294364, 2.556156>,
      < 7.925941, 0.262861, 2.455819>
    }
    triangle {
      < 7.119617, 0.342049, 2.367906>,
      < 7.109572, 0.347370, 2.477088>,
      < 7.643649, 0.311180, 2.478775>
    }
    triangle {
      < 7.119617, 0.342049, 2.367906>,
      < 7.643649, 0.311180, 2.478775>,
      < 7.650219, 0.285880, 2.360173>
    }
    triangle {
      < 7.113728, 0.361826, 2.211385>,
      < 7.119617, 0.342049, 2.367906>,
      < 7.650219, 0.285880, 2.360173>
    }
    triangle {
      < 7.113728, 0.361826, 2.211385>,
      < 7.650219, 0.285880, 2.360173>,
      < 7.642765, 0.310666, 2.198912>
    }
    triangle {
      < 8.223092, 0.144336, 2.417044>,
      < 8.259270, 0.209057, 2.489348>,
      < 8.390141, 0.062475, 2.459994>
    }
    triangle {
      < 8.223092, 0.144336, 2.417044>,
      < 8.390141, 0.062475, 2.459994>,
      < 8.318105, 0.028205, 2.405346>
    }
    triangle {
      < 8.193651, 0.124517, 2.331956>,
      < 8.223092, 0.144336, 2.417044>,
      < 8.318105, 0.028205, 2.405346>
    }
    triangle {
      < 8.193651, 0.124517, 2.331956>,
      < 8.318105, 0.028205, 2.405346>,
      < 8.291826, 0.013337, 2.313897>
    }
    triangle {
      < 8.182999, 0.129380, 2.192896>,
      < 8.193651, 0.124517, 2.331956>,
      < 8.291826, 0.013337, 2.313897>
    }
    triangle {
      < 8.182999, 0.129380, 2.192896>,
      < 8.291826, 0.013337, 2.313897>,
      < 8.301852, 0.017987, 2.188884>
    }
    triangle {
      < 8.552464, -0.915826, 2.875156>,
      < 8.449459, -1.115818, 2.862253>,
      < 8.640915, -1.140712, 2.394224>
    }
    triangle {
      < 8.552464, -0.915826, 2.875156>,
      < 8.640915, -1.140712, 2.394224>,
      < 8.656049, -0.866875, 2.422487>
    }
    triangle {
      < 8.552464, -0.915826, 2.875156>,
      < 8.656049, -0.866875, 2.422487>,
      < 8.749555, -0.613710, 2.466970>
    }
    triangle {
      < 8.552464, -0.915826, 2.875156>,
      < 8.749555, -0.613710, 2.466970>,
      < 8.735338, -0.613710, 2.826938>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 6.014196, 0.389435, 2.592635>,
      < 6.019087, 0.405001, 2.470772>
    }
    triangle {
      < 7.109572, 0.347370, 2.477088>,
      < 7.119617, 0.342049, 2.367906>,
      < 6.019087, 0.405001, 2.470772>
    }
    triangle {
      < 7.109572, 0.347370, 2.477088>,
      < 6.019087, 0.405001, 2.470772>,
      < 6.014196, 0.389435, 2.592635>
    }
    triangle {
      < 7.643649, 0.311180, 2.478775>,
      < 7.109572, 0.347370, 2.477088>,
      < 7.656147, 0.345041, 2.573846>
    }
    triangle {
      < 4.818051, 0.424675, 2.645805>,
      < 4.937755, 0.418982, 2.677343>,
      < 4.939573, 0.418233, 2.648936>
    }
    triangle {
      < 3.618461, 0.419610, 2.634592>,
      < 3.624037, 0.399608, 2.705963>,
      < 4.281296, 0.409301, 2.691644>
    }
    triangle {
      < 3.618461, 0.419610, 2.634592>,
      < 4.281296, 0.409301, 2.691644>,
      < 4.278938, 0.429553, 2.620985>
    }
    triangle {
      < 2.758114, 0.354683, 2.723550>,
      < 2.799764, 0.324678, 2.780970>,
      < 3.052154, 0.359656, 2.780174>
    }
    triangle {
      < 2.758114, 0.354683, 2.723550>,
      < 3.052154, 0.359656, 2.780174>,
      < 3.013422, 0.384661, 2.704998>
    }
    triangle {
      < 3.624037, 0.399608, 2.705963>,
      < 4.268528, 0.401606, 2.710315>,
      < 4.281296, 0.409301, 2.691644>
    }
    triangle {
      < 3.931926, -1.576616, 3.023407>,
      < 3.886168, -1.555423, 3.014625>,
      < 3.808440, -1.839552, 2.919236>
    }
    triangle {
      < 3.931926, -1.576616, 3.023407>,
      < 3.808440, -1.839552, 2.919236>,
      < 3.829013, -1.870416, 2.928818>
    }
    triangle {
      < 3.931926, -1.576616, 3.023407>,
      < 4.036805, -1.444195, 3.053520>,
      < 4.001390, -1.410434, 3.048934>
    }
    triangle {
      < 3.931926, -1.576616, 3.023407>,
      < 4.001390, -1.410434, 3.048934>,
      < 3.886168, -1.555423, 3.014625>
    }
    triangle {
      < 4.036805, -1.444195, 3.053520>,
      < 4.203426, -1.317132, 3.072573>,
      < 4.178975, -1.275450, 3.070565>
    }
    triangle {
      < 4.036805, -1.444195, 3.053520>,
      < 4.178975, -1.275450, 3.070565>,
      < 4.001390, -1.410434, 3.048934>
    }
    triangle {
      < 4.203426, -1.317132, 3.072573>,
      < 4.418622, -1.236594, 3.089916>,
      < 4.406470, -1.190470, 3.089263>
    }
    triangle {
      < 4.203426, -1.317132, 3.072573>,
      < 4.406470, -1.190470, 3.089263>,
      < 4.178975, -1.275450, 3.070565>
    }
    triangle {
      < 4.418622, -1.236594, 3.089916>,
      < 4.704625, -1.197789, 3.087335>,
      < 4.701845, -1.150496, 3.086946>
    }
    triangle {
      < 4.418622, -1.236594, 3.089916>,
      < 4.701845, -1.150496, 3.086946>,
      < 4.406470, -1.190470, 3.089263>
    }
    triangle {
      < 4.704625, -1.197789, 3.087335>,
      < 5.075943, -1.202748, 3.086273>,
      < 5.080426, -1.155529, 3.085750>
    }
    triangle {
      < 4.704625, -1.197789, 3.087335>,
      < 5.080426, -1.155529, 3.085750>,
      < 4.701845, -1.150496, 3.086946>
    }
    triangle {
      < 5.075943, -1.202748, 3.086273>,
      < 5.645978, -1.296764, 3.066880>,
      < 5.657246, -1.250579, 3.065898>
    }
    triangle {
      < 5.075943, -1.202748, 3.086273>,
      < 5.657246, -1.250579, 3.065898>,
      < 5.080426, -1.155529, 3.085750>
    }
    triangle {
      < 5.645978, -1.296764, 3.066880>,
      < 6.224681, -1.470219, 3.043646>,
      < 6.241868, -1.425629, 3.042024>
    }
    triangle {
      < 5.645978, -1.296764, 3.066880>,
      < 6.241868, -1.425629, 3.042024>,
      < 5.657246, -1.250579, 3.065898>
    }
    triangle {
      < 6.224681, -1.470219, 3.043646>,
      < 6.912721, -1.695685, 2.927237>,
      < 6.241868, -1.425629, 3.042024>
    }
    triangle {
      < 6.959054, -1.695689, 2.917074>,
      < 6.912721, -1.695685, 2.927237>,
      < 7.210523, -1.845708, 2.831152>
    }
    triangle {
      < 1.762765, -1.820235, 2.933957>,
      < 1.644907, -1.850225, 2.939876>,
      < 3.808440, -1.839552, 2.919236>
    }
    triangle {
      < 7.457458, -0.145731, 2.893612>,
      < 7.530486, 0.079263, 2.850085>,
      < 5.949462, 0.094400, 2.905534>
    }
    triangle {
      < 7.457458, -0.145731, 2.893612>,
      < 5.949462, 0.094400, 2.905534>,
      < 5.921797, -0.119568, 2.947283>
    }
    triangle {
      < 2.563165, 0.299700, 2.734582>,
      < 2.546063, 0.324703, 2.677072>,
      < 2.393729, 0.259716, 2.691078>
    }
    triangle {
      < 2.563165, 0.299700, 2.734582>,
      < 2.393729, 0.259716, 2.691078>,
      < 2.390236, 0.234715, 2.749496>
    }
    triangle {
      < 2.587595, 0.269697, 2.784412>,
      < 2.563165, 0.299700, 2.734582>,
      < 2.390236, 0.234715, 2.749496>
    }
    triangle {
      < 2.587595, 0.269697, 2.784412>,
      < 2.390236, 0.234715, 2.749496>,
      < 2.401958, 0.144711, 2.847399>
    }
    triangle {
      < 2.733606, 0.059680, 2.917074>,
      < 2.615479, 0.214693, 2.832859>,
      < 2.401958, 0.144711, 2.847399>
    }
    triangle {
      < 2.733606, 0.059680, 2.917074>,
      < 2.401958, 0.144711, 2.847399>,
      < 2.482622, -0.005298, 2.924798>
    }
    triangle {
      < 2.937687, -0.265340, 2.998240>,
      < 2.733606, 0.059680, 2.917074>,
      < 2.482622, -0.005298, 2.924798>
    }
    triangle {
      < 2.937687, -0.265340, 2.998240>,
      < 2.482622, -0.005298, 2.924798>,
      < 2.764446, -0.365325, 3.033453>
    }
    triangle {
      < 2.799764, 0.324678, 2.780970>,
      < 2.758114, 0.354683, 2.723550>,
      < 2.563165, 0.299700, 2.734582>
    }
    triangle {
      < 2.799764, 0.324678, 2.780970>,
      < 2.563165, 0.299700, 2.734582>,
      < 2.587595, 0.269697, 2.784412>
    }
    triangle {
      < 2.835985, 0.279673, 2.834938>,
      < 2.799764, 0.324678, 2.780970>,
      < 2.587595, 0.269697, 2.784412>
    }
    triangle {
      < 2.835985, 0.279673, 2.834938>,
      < 2.587595, 0.269697, 2.784412>,
      < 2.615479, 0.214693, 2.832859>
    }
    triangle {
      < 2.947180, 0.089662, 2.920561>,
      < 2.835985, 0.279673, 2.834938>,
      < 2.615479, 0.214693, 2.832859>
    }
    triangle {
      < 2.947180, 0.089662, 2.920561>,
      < 2.615479, 0.214693, 2.832859>,
      < 2.733606, 0.059680, 2.917074>
    }
    triangle {
      < 3.134589, -0.190357, 2.990687>,
      < 2.947180, 0.089662, 2.920561>,
      < 2.733606, 0.059680, 2.917074>
    }
    triangle {
      < 3.134589, -0.190357, 2.990687>,
      < 2.733606, 0.059680, 2.917074>,
      < 2.937687, -0.265340, 2.998240>
    }
    triangle {
      < 3.013422, 0.384661, 2.704998>,
      < 3.013547, 0.399663, 2.652796>,
      < 2.745803, 0.369686, 2.664615>
    }
    triangle {
      < 3.013422, 0.384661, 2.704998>,
      < 2.745803, 0.369686, 2.664615>,
      < 2.758114, 0.354683, 2.723550>
    }
    triangle {
      < 3.075869, 0.309653, 2.825860>,
      < 3.052154, 0.359656, 2.780174>,
      < 2.799764, 0.324678, 2.780970>
    }
    triangle {
      < 3.075869, 0.309653, 2.825860>,
      < 2.799764, 0.324678, 2.780970>,
      < 2.835985, 0.279673, 2.834938>
    }
    triangle {
      < 3.185711, 0.114641, 2.922582>,
      < 3.075869, 0.309653, 2.825860>,
      < 2.835985, 0.279673, 2.834938>
    }
    triangle {
      < 3.185711, 0.114641, 2.922582>,
      < 2.835985, 0.279673, 2.834938>,
      < 2.947180, 0.089662, 2.920561>
    }
    triangle {
      < 3.299893, -0.151445, 2.990343>,
      < 3.185711, 0.114641, 2.922582>,
      < 2.947180, 0.089662, 2.920561>
    }
    triangle {
      < 3.299893, -0.151445, 2.990343>,
      < 2.947180, 0.089662, 2.920561>,
      < 3.134589, -0.190357, 2.990687>
    }
    triangle {
      < 3.624037, 0.399608, 2.705963>,
      < 3.618461, 0.419610, 2.634592>,
      < 3.013547, 0.399663, 2.652796>
    }
    triangle {
      < 3.624037, 0.399608, 2.705963>,
      < 3.013547, 0.399663, 2.652796>,
      < 3.013422, 0.384661, 2.704998>
    }
    triangle {
      < 3.598562, 0.369608, 2.788156>,
      < 3.624037, 0.399608, 2.705963>,
      < 3.013422, 0.384661, 2.704998>
    }
    triangle {
      < 3.598562, 0.369608, 2.788156>,
      < 3.013422, 0.384661, 2.704998>,
      < 3.052154, 0.359656, 2.780174>
    }
    triangle {
      < 3.579291, 0.304609, 2.835365>,
      < 3.598562, 0.369608, 2.788156>,
      < 3.052154, 0.359656, 2.780174>
    }
    triangle {
      < 3.579291, 0.304609, 2.835365>,
      < 3.052154, 0.359656, 2.780174>,
      < 3.075869, 0.309653, 2.825860>
    }
    triangle {
      < 3.511749, -0.131182, 2.990570>,
      < 3.533880, 0.110079, 2.930280>,
      < 3.185711, 0.114641, 2.922582>
    }
    triangle {
      < 3.511749, -0.131182, 2.990570>,
      < 3.185711, 0.114641, 2.922582>,
      < 3.299893, -0.151445, 2.990343>
    }
    triangle {
      < 4.233611, 0.362943, 2.786884>,
      < 4.268528, 0.401606, 2.710315>,
      < 3.624037, 0.399608, 2.705963>
    }
    triangle {
      < 4.233611, 0.362943, 2.786884>,
      < 3.624037, 0.399608, 2.705963>,
      < 3.598562, 0.369608, 2.788156>
    }
    triangle {
      < 4.205739, 0.295410, 2.833387>,
      < 4.233611, 0.362943, 2.786884>,
      < 3.598562, 0.369608, 2.788156>
    }
    triangle {
      < 4.205739, 0.295410, 2.833387>,
      < 3.598562, 0.369608, 2.788156>,
      < 3.579291, 0.304609, 2.835365>
    }
    triangle {
      < 4.155538, 0.105864, 2.924790>,
      < 4.205739, 0.295410, 2.833387>,
      < 3.579291, 0.304609, 2.835365>
    }
    triangle {
      < 4.155538, 0.105864, 2.924790>,
      < 3.579291, 0.304609, 2.835365>,
      < 3.533880, 0.110079, 2.930280>
    }
    triangle {
      < 4.125974, -0.106096, 2.996831>,
      < 4.155538, 0.105864, 2.924790>,
      < 3.533880, 0.110079, 2.930280>
    }
    triangle {
      < 4.125974, -0.106096, 2.996831>,
      < 3.533880, 0.110079, 2.930280>,
      < 3.511749, -0.131182, 2.990570>
    }
    triangle {
      < 4.937755, 0.418982, 2.677343>,
      < 4.818051, 0.424675, 2.645805>,
      < 4.278938, 0.429553, 2.620985>
    }
    triangle {
      < 4.937755, 0.418982, 2.677343>,
      < 4.278938, 0.429553, 2.620985>,
      < 4.281296, 0.409301, 2.691644>
    }
    triangle {
      < 4.966898, 0.413589, 2.698662>,
      < 4.937755, 0.418982, 2.677343>,
      < 4.281296, 0.409301, 2.691644>
    }
    triangle {
      < 4.966898, 0.413589, 2.698662>,
      < 4.281296, 0.409301, 2.691644>,
      < 4.268528, 0.401606, 2.710315>
    }
    triangle {
      < 6.000408, 0.344399, 2.783345>,
      < 6.016861, 0.389399, 2.722277>,
      < 5.193110, 0.404471, 2.716558>
    }
    triangle {
      < 6.000408, 0.344399, 2.783345>,
      < 5.193110, 0.404471, 2.716558>,
      < 4.268528, 0.401606, 2.710315>
    }
    triangle {
      < 6.000408, 0.344399, 2.783345>,
      < 4.268528, 0.401606, 2.710315>,
      < 4.233611, 0.362943, 2.786884>
    }
    triangle {
      < 5.976968, 0.269400, 2.827793>,
      < 6.000408, 0.344399, 2.783345>,
      < 4.233611, 0.362943, 2.786884>
    }
    triangle {
      < 5.976968, 0.269400, 2.827793>,
      < 4.233611, 0.362943, 2.786884>,
      < 4.205739, 0.295410, 2.833387>
    }
    triangle {
      < 5.949462, 0.094400, 2.905534>,
      < 5.976968, 0.269400, 2.827793>,
      < 4.205739, 0.295410, 2.833387>
    }
    triangle {
      < 5.949462, 0.094400, 2.905534>,
      < 4.205739, 0.295410, 2.833387>,
      < 4.155538, 0.105864, 2.924790>
    }
    triangle {
      < 5.921797, -0.119568, 2.947283>,
      < 5.949462, 0.094400, 2.905534>,
      < 4.155538, 0.105864, 2.924790>
    }
    triangle {
      < 5.921797, -0.119568, 2.947283>,
      < 4.155538, 0.105864, 2.924790>,
      < 4.125974, -0.106096, 2.996831>
    }
    triangle {
      < 8.640915, -1.508811, 2.394224>,
      < 8.539258, -1.508811, 2.321690>,
      < 8.539258, -1.154597, 2.321690>
    }
    triangle {
      < 8.640915, -1.508811, 2.394224>,
      < 8.539258, -1.154597, 2.321690>,
      < 8.640915, -1.140712, 2.394224>
    }
    triangle {
      < 8.539258, -1.508811, 2.321690>,
      < 8.513547, -1.508811, 2.261814>,
      < 8.513547, -1.144411, 2.261814>
    }
    triangle {
      < 8.539258, -1.508811, 2.321690>,
      < 8.513547, -1.144411, 2.261814>,
      < 8.539258, -1.154597, 2.321690>
    }
    triangle {
      < 8.513547, -1.508811, 2.261814>,
      < 8.509673, -1.508811, 2.067450>,
      < 8.509673, -1.194734, 2.067450>
    }
    triangle {
      < 8.513547, -1.508811, 2.261814>,
      < 8.509673, -1.194734, 2.067450>,
      < 8.513547, -1.144411, 2.261814>
    }
    triangle {
      < 8.509673, -1.508811, 2.067450>,
      < 8.512800, -1.508811, 1.923583>,
      < 8.512800, -1.225042, 1.923583>
    }
    triangle {
      < 8.509673, -1.508811, 2.067450>,
      < 8.512800, -1.225042, 1.923583>,
      < 8.509673, -1.194734, 2.067450>
    }
    triangle {
      < 8.512800, -1.508811, 1.923583>,
      < 8.522250, -1.508811, 1.772281>,
      < 8.522250, -1.225294, 1.772281>
    }
    triangle {
      < 8.512800, -1.508811, 1.923583>,
      < 8.522250, -1.225294, 1.772281>,
      < 8.512800, -1.225042, 1.923583>
    }
    triangle {
      < 8.522250, -1.508811, 1.772281>,
      < 8.560331, -1.508811, 1.029780>,
      < 8.560331, -1.222266, 1.029780>
    }
    triangle {
      < 8.522250, -1.508811, 1.772281>,
      < 8.560331, -1.222266, 1.029780>,
      < 8.522250, -1.225294, 1.772281>
    }
    triangle {
      < 8.560331, -1.508811, 1.029780>,
      < 8.597543, -1.508811, 0.000000>,
      < 8.597543, -1.223972, 0.000000>
    }
    triangle {
      < 8.560331, -1.508811, 1.029780>,
      < 8.597543, -1.223972, 0.000000>,
      < 8.560331, -1.222266, 1.029780>
    }
    triangle {
      < 7.979931, -1.865773, 2.699738>,
      < 8.001176, -1.730777, 2.774402>,
      < 8.001176, -1.730777, 2.819602>
    }
    triangle {
      < 7.979931, -1.865773, 2.699738>,
      < 8.001176, -1.730777, 2.819602>,
      < 7.979931, -1.865773, 2.744938>
    }
    triangle {
      < 8.001176, -1.730777, 2.774402>,
      < 8.051655, -1.600783, 2.819990>,
      < 8.051655, -1.600783, 2.865190>
    }
    triangle {
      < 8.001176, -1.730777, 2.774402>,
      < 8.051655, -1.600783, 2.865190>,
      < 8.001176, -1.730777, 2.819602>
    }
    triangle {
      < 8.051655, -1.600783, 2.819990>,
      < 8.253127, -1.245801, 2.845419>,
      < 8.253127, -1.245801, 2.890619>
    }
    triangle {
      < 8.051655, -1.600783, 2.819990>,
      < 8.253127, -1.245801, 2.890619>,
      < 8.051655, -1.600783, 2.865190>
    }
    triangle {
      < 8.253127, -1.245801, 2.845419>,
      < 8.322593, -1.180807, 2.844753>,
      < 8.322593, -1.180807, 2.889953>
    }
    triangle {
      < 8.253127, -1.245801, 2.845419>,
      < 8.322593, -1.180807, 2.889953>,
      < 8.253127, -1.245801, 2.890619>
    }
    triangle {
      < 8.322593, -1.180807, 2.844753>,
      < 8.416007, -1.160815, 2.864733>,
      < 8.416007, -1.160815, 2.909933>
    }
    triangle {
      < 8.322593, -1.180807, 2.844753>,
      < 8.416007, -1.160815, 2.909933>,
      < 8.322593, -1.180807, 2.889953>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.449459, -1.115818, 2.862253>,
      < 8.449459, -1.115818, 2.907453>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.449459, -1.115818, 2.907453>,
      < 8.416007, -1.160815, 2.909933>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.322593, -1.180807, 2.844753>,
      < 8.253127, -1.245801, 2.845419>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.253127, -1.245801, 2.845419>,
      < 8.051655, -1.600783, 2.819990>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.051655, -1.600783, 2.819990>,
      < 8.001176, -1.730777, 2.774402>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.001176, -1.730777, 2.774402>,
      < 7.979931, -1.865773, 2.699738>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 7.979931, -1.865773, 2.699738>,
      < 8.640915, -1.508811, 2.394224>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.640915, -1.508811, 2.394224>,
      < 8.640915, -1.140712, 2.394224>
    }
    triangle {
      < 8.416007, -1.160815, 2.864733>,
      < 8.640915, -1.140712, 2.394224>,
      < 8.449459, -1.115818, 2.862253>
    }
    triangle {
      < 5.193110, 0.404471, 2.716558>,
      < 4.966898, 0.413589, 2.698662>,
      < 4.268528, 0.401606, 2.710315>
    }
    triangle {
      < 4.701740, -1.055495, 3.050892>,
      < 3.467531, -0.935387, 3.049246>,
      < 4.388336, -1.110468, 3.053267>
    }
    triangle {
      < 1.883856, -0.945249, 3.050085>,
      < 1.865744, -1.250247, 3.032106>,
      < 4.130360, -1.230445, 3.044371>
    }
    triangle {
      < 1.883856, -0.945249, 3.050085>,
      < 4.130360, -1.230445, 3.044371>,
      < 3.467531, -0.935387, 3.049246>
    }
    triangle {
      < 1.829418, -1.745242, 2.960097>,
      < 3.808440, -1.839552, 2.919236>,
      < 3.844535, -1.550419, 3.005050>
    }
    triangle {
      < 1.829418, -1.745242, 2.960097>,
      < 3.844535, -1.550419, 3.005050>,
      < 1.854504, -1.570245, 2.994691>
    }
    triangle {
      < 4.130360, -1.230445, 3.044371>,
      < 4.388336, -1.110468, 3.053267>,
      < 3.467531, -0.935387, 3.049246>
    }
    triangle {
      < 1.829418, -1.745242, 2.960097>,
      < 1.762765, -1.820235, 2.933957>,
      < 3.808440, -1.839552, 2.919236>
    }
    triangle {
      < 8.072657, 0.190923, 2.331323>,
      < 8.073201, 0.205660, 2.193727>,
      < 7.932977, 0.257270, 2.183802>
    }
    triangle {
      < 8.072657, 0.190923, 2.331323>,
      < 7.932977, 0.257270, 2.183802>,
      < 7.940545, 0.242483, 2.345044>
    }
    triangle {
      < 8.193651, 0.124517, 2.331956>,
      < 8.182999, 0.129380, 2.192896>,
      < 8.073201, 0.205660, 2.193727>
    }
    triangle {
      < 8.193651, 0.124517, 2.331956>,
      < 8.073201, 0.205660, 2.193727>,
      < 8.072657, 0.190923, 2.331323>
    }
    triangle {
      < 7.925941, 0.262861, 2.455819>,
      < 7.940545, 0.242483, 2.345044>,
      < 7.650219, 0.285880, 2.360173>
    }
    triangle {
      < 7.925941, 0.262861, 2.455819>,
      < 7.650219, 0.285880, 2.360173>,
      < 7.643649, 0.311180, 2.478775>
    }
    triangle {
      < 8.223092, 0.144336, 2.417044>,
      < 8.193651, 0.124517, 2.331956>,
      < 8.072657, 0.190923, 2.331323>
    }
    triangle {
      < 8.223092, 0.144336, 2.417044>,
      < 8.072657, 0.190923, 2.331323>,
      < 8.069251, 0.221174, 2.443563>
    }
    triangle {
      < 8.107162, 0.252623, 2.518976>,
      < 8.069251, 0.221174, 2.443563>,
      < 7.925941, 0.262861, 2.455819>
    }
    triangle {
      < 8.107162, 0.252623, 2.518976>,
      < 7.925941, 0.262861, 2.455819>,
      < 7.908731, 0.294364, 2.556156>
    }
    triangle {
      < 8.259270, 0.209057, 2.489348>,
      < 8.223092, 0.144336, 2.417044>,
      < 8.069251, 0.221174, 2.443563>
    }
    triangle {
      < 8.259270, 0.209057, 2.489348>,
      < 8.069251, 0.221174, 2.443563>,
      < 8.107162, 0.252623, 2.518976>
    }
    triangle {
      < 8.366402, -0.137784, 2.182268>,
      < 8.365832, -0.142549, 2.304032>,
      < 8.436363, -0.458416, 2.289739>
    }
    triangle {
      < 8.366402, -0.137784, 2.182268>,
      < 8.436363, -0.458416, 2.289739>,
      < 8.440199, -0.463641, 2.193263>
    }
    triangle {
      < 8.301852, 0.017987, 2.188884>,
      < 8.291826, 0.013337, 2.313897>,
      < 8.365832, -0.142549, 2.304032>
    }
    triangle {
      < 8.301852, 0.017987, 2.188884>,
      < 8.365832, -0.142549, 2.304032>,
      < 8.366402, -0.137784, 2.182268>
    }
    triangle {
      < 8.513547, -1.144411, 2.261814>,
      < 8.486027, -1.114300, 2.149738>,
      < 8.489470, -0.969292, 2.170007>
    }
    triangle {
      < 8.513547, -1.144411, 2.261814>,
      < 8.489470, -0.969292, 2.170007>,
      < 8.487261, -0.964077, 2.271214>
    }
    triangle {
      < 8.509673, -1.194734, 2.067450>,
      < 8.486027, -1.114300, 2.149738>,
      < 8.513547, -1.144411, 2.261814>
    }
    triangle {
      < 7.119617, 0.342049, 2.367906>,
      < 7.113728, 0.361826, 2.211385>,
      < 6.328420, 0.420911, 2.200800>
    }
    triangle {
      < 7.119617, 0.342049, 2.367906>,
      < 6.328420, 0.420911, 2.200800>,
      < 6.019087, 0.405001, 2.470772>
    }
    triangle {
      < 6.019087, 0.405001, 2.470772>,
      < 6.219293, 0.427158, 2.190680>,
      < 6.144370, 0.447848, 2.094849>
    }
    triangle {
      < 6.019087, 0.405001, 2.470772>,
      < 6.144370, 0.447848, 2.094849>,
      < 6.047067, 0.434167, 2.196927>
    }
    triangle {
      < 6.328420, 0.420911, 2.200800>,
      < 6.219293, 0.427158, 2.190680>,
      < 6.019087, 0.405001, 2.470772>
    }
    triangle {
      < 6.144370, 0.447848, 2.094849>,
      < 6.110524, 0.468056, 1.995495>,
      < 6.047067, 0.434167, 2.196927>
    }
    triangle {
      < 6.959054, -1.695689, 2.917074>,
      < 8.001176, -1.730777, 2.819602>,
      < 8.051655, -1.600783, 2.865190>
    }
    triangle {
      < 6.959054, -1.695689, 2.917074>,
      < 8.051655, -1.600783, 2.865190>,
      < 6.971869, -1.560690, 2.938550>
    }
    triangle {
      < 5.776326, -0.750587, 2.994811>,
      < 5.679337, -1.160580, 3.032548>,
      < 6.261692, -1.360630, 3.006923>
    }
    triangle {
      < 5.776326, -0.750587, 2.994811>,
      < 6.261692, -1.360630, 3.006923>,
      < 7.201694, -0.930711, 2.952916>
    }
    triangle {
      < 4.540823, -0.625480, 3.022290>,
      < 5.092771, -1.050529, 3.039951>,
      < 5.679337, -1.160580, 3.032548>
    }
    triangle {
      < 4.540823, -0.625480, 3.022290>,
      < 5.679337, -1.160580, 3.032548>,
      < 5.776326, -0.750587, 2.994811>
    }
    triangle {
      < 4.701740, -1.055495, 3.050892>,
      < 5.092771, -1.050529, 3.039951>,
      < 4.540823, -0.625480, 3.022290>
    }
    triangle {
      < 8.107162, 0.252623, 2.518976>,
      < 7.908731, 0.294364, 2.556156>,
      < 9.089541, 0.294427, 2.558130>
    }
    triangle {
      < 8.640915, -1.140712, 2.394224>,
      < 8.578271, -0.844893, 2.393535>,
      < 8.656049, -0.866875, 2.422487>
    }
    triangle {
      < 8.107162, 0.252623, 2.518976>,
      < 9.089541, 0.294427, 2.558130>,
      < 8.259270, 0.209057, 2.489348>
    }
    triangle {
      < 8.749555, -0.613710, 2.466970>,
      < 8.561139, -0.434614, 2.421418>,
      < 8.479552, -0.128594, 2.450057>
    }
    triangle {
      < 8.749555, -0.613710, 2.466970>,
      < 8.479552, -0.128594, 2.450057>,
      < 9.142529, 0.248598, 2.550370>
    }
    triangle {
      < 9.142529, 0.248598, 2.550370>,
      < 8.479552, -0.128594, 2.450057>,
      < 8.390141, 0.062475, 2.459994>
    }
    triangle {
      < 9.142529, 0.248598, 2.550370>,
      < 8.390141, 0.062475, 2.459994>,
      < 9.089541, 0.294427, 2.558130>
    }
    triangle {
      < 8.390141, 0.062475, 2.459994>,
      < 8.259270, 0.209057, 2.489348>,
      < 9.089541, 0.294427, 2.558130>
    }
    triangle {
      < 8.561139, -0.434614, 2.421418>,
      < 8.749555, -0.613710, 2.466970>,
      < 8.656049, -0.866875, 2.422487>
    }
    triangle {
      < 8.561139, -0.434614, 2.421418>,
      < 8.656049, -0.866875, 2.422487>,
      < 8.578271, -0.844893, 2.393535>
    }
    triangle {
      < 8.539258, -1.154597, 2.321690>,
      < 8.513547, -1.144411, 2.261814>,
      < 8.487261, -0.964077, 2.271214>
    }
    triangle {
      < 8.539258, -1.154597, 2.321690>,
      < 8.487261, -0.964077, 2.271214>,
      < 8.515425, -0.914250, 2.351519>
    }
    triangle {
      < 8.492520, -0.453904, 2.376204>,
      < 8.436363, -0.458416, 2.289739>,
      < 8.365832, -0.142549, 2.304032>
    }
    triangle {
      < 8.492520, -0.453904, 2.376204>,
      < 8.365832, -0.142549, 2.304032>,
      < 8.399913, -0.142759, 2.403348>
    }
    triangle {
      < 5.569658, 0.575682, -0.000026>,
      < 5.484661, 0.611664, 0.000000>,
      < 5.435663, 0.594303, 1.148942>
    }
    triangle {
      < 5.569658, 0.575682, -0.000026>,
      < 5.435663, 0.594303, 1.148942>,
      < 5.522338, 0.563309, 1.156139>
    }
    triangle {
      < 5.522338, 0.563309, 1.156139>,
      < 5.435663, 0.594303, 1.148942>,
      < 5.336588, 0.556670, 1.801338>
    }
    triangle {
      < 5.522338, 0.563309, 1.156139>,
      < 5.336588, 0.556670, 1.801338>,
      < 5.412265, 0.520830, 1.822873>
    }
    triangle {
      < 5.236760, 0.493609, 2.221350>,
      < 5.203112, 0.518845, 2.137795>,
      < 5.027698, 0.491304, 2.367082>
    }
    triangle {
      < 5.236760, 0.493609, 2.221350>,
      < 5.027698, 0.491304, 2.367082>,
      < 5.018622, 0.476534, 2.433598>
    }
    triangle {
      < 5.412265, 0.520830, 1.822873>,
      < 5.336588, 0.556670, 1.801338>,
      < 5.203112, 0.518845, 2.137795>
    }
    triangle {
      < 5.412265, 0.520830, 1.822873>,
      < 5.203112, 0.518845, 2.137795>,
      < 5.236760, 0.493609, 2.221350>
    }
    triangle {
      < 4.701740, -1.055495, 3.050892>,
      < 4.540823, -0.625480, 3.022290>,
      < 3.517423, -0.530391, 3.028297>
    }
    triangle {
      < 4.701740, -1.055495, 3.050892>,
      < 3.517423, -0.530391, 3.028297>,
      < 2.970855, -0.501905, 3.023529>
    }
    triangle {
      < 4.701740, -1.055495, 3.050892>,
      < 2.970855, -0.501905, 3.023529>,
      < 3.467531, -0.935387, 3.049246>
    }
    triangle {
      < 8.253127, -1.245801, 2.890619>,
      < 8.322593, -1.180807, 2.889953>,
      < 7.201694, -0.930711, 2.952916>
    }
    triangle {
      < 5.679337, -1.160580, 3.032548>,
      < 5.657246, -1.250579, 3.065898>,
      < 6.241868, -1.425629, 3.042024>
    }
    triangle {
      < 5.679337, -1.160580, 3.032548>,
      < 6.241868, -1.425629, 3.042024>,
      < 6.261692, -1.360630, 3.006923>
    }
    triangle {
      < 5.092771, -1.050529, 3.039951>,
      < 5.080426, -1.155529, 3.085750>,
      < 5.657246, -1.250579, 3.065898>
    }
    triangle {
      < 5.092771, -1.050529, 3.039951>,
      < 5.657246, -1.250579, 3.065898>,
      < 5.679337, -1.160580, 3.032548>
    }
    triangle {
      < 4.701740, -1.055495, 3.050892>,
      < 4.701845, -1.150496, 3.086946>,
      < 5.080426, -1.155529, 3.085750>
    }
    triangle {
      < 4.701740, -1.055495, 3.050892>,
      < 5.080426, -1.155529, 3.085750>,
      < 5.092771, -1.050529, 3.039951>
    }
    triangle {
      < 4.388336, -1.110468, 3.053267>,
      < 4.406470, -1.190470, 3.089263>,
      < 4.701845, -1.150496, 3.086946>
    }
    triangle {
      < 4.388336, -1.110468, 3.053267>,
      < 4.701845, -1.150496, 3.086946>,
      < 4.701740, -1.055495, 3.050892>
    }
    triangle {
      < 4.130360, -1.230445, 3.044371>,
      < 4.178975, -1.275450, 3.070565>,
      < 4.406470, -1.190470, 3.089263>
    }
    triangle {
      < 4.130360, -1.230445, 3.044371>,
      < 4.406470, -1.190470, 3.089263>,
      < 4.388336, -1.110468, 3.053267>
    }
    triangle {
      < 3.844535, -1.550419, 3.005050>,
      < 3.886168, -1.555423, 3.014625>,
      < 4.001390, -1.410434, 3.048934>
    }
    triangle {
      < 3.844535, -1.550419, 3.005050>,
      < 4.001390, -1.410434, 3.048934>,
      < 3.955592, -1.365430, 3.036598>
    }
    triangle {
      < 3.808440, -1.839552, 2.919236>,
      < 3.886168, -1.555423, 3.014625>,
      < 3.844535, -1.550419, 3.005050>
    }
    triangle {
      < 3.955592, -1.365430, 3.036598>,
      < 4.001390, -1.410434, 3.048934>,
      < 4.178975, -1.275450, 3.070565>
    }
    triangle {
      < 3.955592, -1.365430, 3.036598>,
      < 4.178975, -1.275450, 3.070565>,
      < 4.130360, -1.230445, 3.044371>
    }
    triangle {
      < -2.612738, 0.475170, 2.046601>,
      < -2.338066, 0.541556, 1.972795>,
      < -2.477282, 0.570167, 1.677680>
    }
    triangle {
      < -2.612738, 0.475170, 2.046601>,
      < -2.477282, 0.570167, 1.677680>,
      < -2.703817, 0.490182, 1.880681>
    }
    triangle {
      < -2.450803, 0.470151, 2.222745>,
      < -2.216968, 0.523991, 2.156171>,
      < -2.338066, 0.541556, 1.972795>
    }
    triangle {
      < -2.450803, 0.470151, 2.222745>,
      < -2.338066, 0.541556, 1.972795>,
      < -2.612738, 0.475170, 2.046601>
    }
    triangle {
      < -2.009329, 0.475106, 2.461809>,
      < -1.937317, 0.490102, 2.388227>,
      < -2.124247, 0.515122, 2.250817>
    }
    triangle {
      < -2.009329, 0.475106, 2.461809>,
      < -2.124247, 0.515122, 2.250817>,
      < -2.271515, 0.470132, 2.351997>
    }
    triangle {
      < -1.743652, 0.475082, 2.513202>,
      < -1.738342, 0.485082, 2.495975>,
      < -1.937317, 0.490102, 2.388227>
    }
    triangle {
      < -1.743652, 0.475082, 2.513202>,
      < -1.937317, 0.490102, 2.388227>,
      < -2.009329, 0.475106, 2.461809>
    }
    triangle {
      < -1.534455, 0.475062, 2.550094>,
      < -1.738342, 0.485082, 2.495975>,
      < -1.743652, 0.475082, 2.513202>
    }
    triangle {
      < -2.271515, 0.470132, 2.351997>,
      < -2.124247, 0.515122, 2.250817>,
      < -2.216968, 0.523991, 2.156171>
    }
    triangle {
      < -2.271515, 0.470132, 2.351997>,
      < -2.216968, 0.523991, 2.156171>,
      < -2.450803, 0.470151, 2.222745>
    }
    triangle {
      < -2.477282, 0.570167, 1.677680>,
      < -2.551558, 0.580177, 1.443880>,
      < -2.807869, 0.525200, 1.530828>
    }
    triangle {
      < -2.477282, 0.570167, 1.677680>,
      < -2.807869, 0.525200, 1.530828>,
      < -2.703817, 0.490182, 1.880681>
    }
    triangle {
      < -2.807869, 0.525200, 1.530828>,
      < -2.551558, 0.580177, 1.443880>,
      < -2.596643, 0.595192, 1.118505>
    }
    triangle {
      < -2.807869, 0.525200, 1.530828>,
      < -2.596643, 0.595192, 1.118505>,
      < -2.879675, 0.555217, 1.114004>
    }
    triangle {
      < 8.640915, -1.140712, 2.394224>,
      < 8.539258, -1.154597, 2.321690>,
      < 8.515425, -0.914250, 2.351519>
    }
    triangle {
      < 8.640915, -1.140712, 2.394224>,
      < 8.515425, -0.914250, 2.351519>,
      < 8.578271, -0.844893, 2.393535>
    }
    triangle {
      < 8.399913, -0.142759, 2.403348>,
      < 8.479552, -0.128594, 2.450057>,
      < 8.561139, -0.434614, 2.421418>
    }
    triangle {
      < 8.399913, -0.142759, 2.403348>,
      < 8.561139, -0.434614, 2.421418>,
      < 8.492520, -0.453904, 2.376204>
    }
    triangle {
      < 8.578271, -0.844893, 2.393535>,
      < 8.515425, -0.914250, 2.351519>,
      < 8.492520, -0.453904, 2.376204>
    }
    triangle {
      < 8.578271, -0.844893, 2.393535>,
      < 8.492520, -0.453904, 2.376204>,
      < 8.561139, -0.434614, 2.421418>
    }
    triangle {
      < 4.633741, 0.426260, 2.557898>,
      < 4.818051, 0.424675, 2.645805>,
      < 4.812309, 0.452697, 2.525539>
    }
    triangle {
      < 4.939573, 0.418233, 2.648936>,
      < 4.968434, 0.412051, 2.634367>,
      < 5.018622, 0.476534, 2.433598>
    }
    triangle {
      < 4.939573, 0.418233, 2.648936>,
      < 5.018622, 0.476534, 2.433598>,
      < 4.812309, 0.452697, 2.525539>
    }
    triangle {
      < 4.939573, 0.418233, 2.648936>,
      < 4.812309, 0.452697, 2.525539>,
      < 4.818051, 0.424675, 2.645805>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 6.019087, 0.405001, 2.470772>,
      < 6.047067, 0.434167, 2.196927>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 6.047067, 0.434167, 2.196927>,
      < 5.236760, 0.493609, 2.221350>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 5.236760, 0.493609, 2.221350>,
      < 5.018622, 0.476534, 2.433598>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 5.018622, 0.476534, 2.433598>,
      < 4.968434, 0.412051, 2.634367>
    }
    triangle {
      < 6.233547, 0.557975, 0.000000>,
      < 5.569658, 0.575682, -0.000026>,
      < 5.522338, 0.563309, 1.156139>
    }
    triangle {
      < 6.233547, 0.557975, 0.000000>,
      < 5.522338, 0.563309, 1.156139>,
      < 6.193891, 0.530497, 1.142380>
    }
    triangle {
      < 7.940545, 0.242483, 2.345044>,
      < 7.925941, 0.262861, 2.455819>,
      < 8.069251, 0.221174, 2.443563>
    }
    triangle {
      < 7.940545, 0.242483, 2.345044>,
      < 8.069251, 0.221174, 2.443563>,
      < 8.072657, 0.190923, 2.331323>
    }
    triangle {
      < 7.642765, 0.310666, 2.198912>,
      < 7.650219, 0.285880, 2.360173>,
      < 7.940545, 0.242483, 2.345044>
    }
    triangle {
      < 7.642765, 0.310666, 2.198912>,
      < 7.940545, 0.242483, 2.345044>,
      < 7.932977, 0.257270, 2.183802>
    }
    triangle {
      < 8.436363, -0.458416, 2.289739>,
      < 8.492520, -0.453904, 2.376204>,
      < 8.515425, -0.914250, 2.351519>
    }
    triangle {
      < 8.436363, -0.458416, 2.289739>,
      < 8.515425, -0.914250, 2.351519>,
      < 8.487261, -0.964077, 2.271214>
    }
    triangle {
      < 6.193891, 0.530497, 1.142380>,
      < 5.522338, 0.563309, 1.156139>,
      < 5.412265, 0.520830, 1.822873>
    }
    triangle {
      < 6.193891, 0.530497, 1.142380>,
      < 5.412265, 0.520830, 1.822873>,
      < 6.121673, 0.477584, 1.811959>
    }
    triangle {
      < 3.955592, -1.365430, 3.036598>,
      < 1.865744, -1.250247, 3.032106>,
      < 1.854504, -1.570245, 2.994691>
    }
    triangle {
      < 3.955592, -1.365430, 3.036598>,
      < 1.854504, -1.570245, 2.994691>,
      < 3.844535, -1.550419, 3.005050>
    }
    triangle {
      < 8.051655, -1.600783, 2.865190>,
      < 8.253127, -1.245801, 2.890619>,
      < 7.201694, -0.930711, 2.952916>
    }
    triangle {
      < 8.051655, -1.600783, 2.865190>,
      < 7.201694, -0.930711, 2.952916>,
      < 6.971869, -1.560690, 2.938550>
    }
    triangle {
      < 7.210523, -1.845708, 2.831152>,
      < 7.408657, -1.865725, 2.811972>,
      < 7.979931, -1.865773, 2.744938>
    }
    triangle {
      < 7.210523, -1.845708, 2.831152>,
      < 7.979931, -1.865773, 2.744938>,
      < 8.001176, -1.730777, 2.819602>
    }
    triangle {
      < 7.210523, -1.845708, 2.831152>,
      < 8.001176, -1.730777, 2.819602>,
      < 6.959054, -1.695689, 2.917074>
    }
    triangle {
      < 3.955592, -1.365430, 3.036598>,
      < 4.130360, -1.230445, 3.044371>,
      < 1.865744, -1.250247, 3.032106>
    }
    triangle {
      < 3.467531, -0.935387, 3.049246>,
      < 2.970855, -0.501905, 3.023529>,
      < 2.732397, -0.489476, 3.021448>
    }
    triangle {
      < 3.467531, -0.935387, 3.049246>,
      < 2.732397, -0.489476, 3.021448>,
      < 1.883856, -0.945249, 3.050085>
    }
    triangle {
      < -0.721598, -1.853257, -2.939839>,
      < -0.713210, -1.880719, -2.941182>,
      < -2.538924, -1.884860, -2.946151>
    }
    triangle {
      < -0.721598, -1.853257, -2.939839>,
      < -2.538924, -1.884860, -2.946151>,
      < -2.009248, -1.854906, -2.925065>
    }
    triangle {
      < 3.829013, -1.870416, -2.928818>,
      < 1.644907, -1.850225, -2.939876>,
      < 3.808440, -1.839552, -2.919236>
    }
    triangle {
      < 0.535682, -1.877886, -2.937782>,
      < 0.537256, -1.851644, -2.944117>,
      < 1.644907, -1.850225, -2.939876>
    }
    triangle {
      < 0.535682, -1.877886, -2.937782>,
      < 1.644907, -1.850225, -2.939876>,
      < 1.650581, -1.875357, -2.934747>
    }
    triangle {
      < -0.713210, -1.880719, -2.941182>,
      < -0.721598, -1.853257, -2.939839>,
      < 0.537256, -1.851644, -2.944117>
    }
    triangle {
      < -0.713210, -1.880719, -2.941182>,
      < 0.537256, -1.851644, -2.944117>,
      < 0.535682, -1.877886, -2.937782>
    }
    triangle {
      < 1.650581, -1.875357, -2.934747>,
      < 1.644907, -1.850225, -2.939876>,
      < 3.829013, -1.870416, -2.928818>
    }
    triangle {
      < -2.009248, -1.854906, 2.925065>,
      < -2.538924, -1.884860, 2.946151>,
      < -0.713210, -1.880719, 2.941182>
    }
    triangle {
      < -2.009248, -1.854906, 2.925065>,
      < -0.713210, -1.880719, 2.941182>,
      < -0.721598, -1.853257, 2.939839>
    }
    triangle {
      < 3.808440, -1.839552, 2.919236>,
      < 1.644907, -1.850225, 2.939876>,
      < 3.829013, -1.870416, 2.928818>
    }
    triangle {
      < 1.650581, -1.875357, 2.934747>,
      < 1.644907, -1.850225, 2.939876>,
      < 0.537256, -1.851644, 2.944117>
    }
    triangle {
      < 1.650581, -1.875357, 2.934747>,
      < 0.537256, -1.851644, 2.944117>,
      < 0.535682, -1.877886, 2.937782>
    }
    triangle {
      < 0.535682, -1.877886, 2.937782>,
      < 0.537256, -1.851644, 2.944117>,
      < -0.721598, -1.853257, 2.939839>
    }
    triangle {
      < 0.535682, -1.877886, 2.937782>,
      < -0.721598, -1.853257, 2.939839>,
      < -0.713210, -1.880719, 2.941182>
    }
    triangle {
      < 3.829013, -1.870416, 2.928818>,
      < 1.644907, -1.850225, 2.939876>,
      < 1.650581, -1.875357, 2.934747>
    }
    triangle {
      < -4.073049, -0.554728, 3.014176>,
      < -3.796964, -0.659753, 3.018759>,
      < -3.219849, -0.342895, 2.987180>
    }
    triangle {
      < -3.219849, -0.342895, -2.987180>,
      < -3.796964, -0.659753, -3.018759>,
      < -4.073049, -0.554728, -3.014176>
    }
    texture {body}
  }
  // chrome
  union {
    triangle {
      < -6.765547, -0.371911, -2.834569>,
      < -6.765466, -0.439490, -2.791026>,
      < -6.841866, -0.439490, -2.791026>
    }
    triangle {
      < -6.765547, -0.371911, -2.834569>,
      < -6.841866, -0.439490, -2.791026>,
      < -6.841948, -0.371911, -2.834569>
    }
    triangle {
      < -6.765106, -0.487581, -2.733489>,
      < -6.841507, -0.487581, -2.733489>,
      < -6.841866, -0.439490, -2.791026>
    }
    triangle {
      < -6.765106, -0.487581, -2.733489>,
      < -6.841866, -0.439490, -2.791026>,
      < -6.765466, -0.439490, -2.791026>
    }
    triangle {
      < -6.762914, -0.539283, -2.555220>,
      < -6.761081, -0.549481, -2.444748>,
      < -6.837482, -0.549481, -2.444748>
    }
    triangle {
      < -6.762914, -0.539283, -2.555220>,
      < -6.837482, -0.549481, -2.444748>,
      < -6.839314, -0.539283, -2.555220>
    }
    triangle {
      < -6.761184, -0.541778, -2.342008>,
      < -6.837585, -0.541778, -2.342008>,
      < -6.837482, -0.549481, -2.444748>
    }
    triangle {
      < -6.761184, -0.541778, -2.342008>,
      < -6.837482, -0.549481, -2.444748>,
      < -6.761081, -0.549481, -2.444748>
    }
    triangle {
      < -6.755751, -0.500433, -2.174088>,
      < -6.750215, -0.459473, -2.118052>,
      < -6.826616, -0.459473, -2.118052>
    }
    triangle {
      < -6.755751, -0.500433, -2.174088>,
      < -6.826616, -0.459473, -2.118052>,
      < -6.832152, -0.500433, -2.174088>
    }
    triangle {
      < -6.750121, -0.394538, -2.074579>,
      < -6.826521, -0.394538, -2.074579>,
      < -6.826616, -0.459473, -2.118052>
    }
    triangle {
      < -6.750121, -0.394538, -2.074579>,
      < -6.826616, -0.459473, -2.118052>,
      < -6.750215, -0.459473, -2.118052>
    }
    triangle {
      < -6.750026, -0.319472, -2.052864>,
      < -6.757581, -0.079470, -2.018336>,
      < -6.833982, -0.079470, -2.018336>
    }
    triangle {
      < -6.750026, -0.319472, -2.052864>,
      < -6.833982, -0.079470, -2.018336>,
      < -6.826427, -0.319472, -2.052864>
    }
    triangle {
      < -6.826427, -0.319472, -2.052864>,
      < -6.833982, -0.079470, -2.018336>,
      < -6.834251, -0.079229, -2.038333>
    }
    triangle {
      < -6.826427, -0.319472, -2.052864>,
      < -6.834251, -0.079229, -2.038333>,
      < -6.826804, -0.313709, -2.072241>
    }
    triangle {
      < -6.841948, -0.371911, -2.834569>,
      < -6.841866, -0.439490, -2.791026>,
      < -6.841676, -0.425841, -2.775235>
    }
    triangle {
      < -6.841948, -0.371911, -2.834569>,
      < -6.841676, -0.425841, -2.775235>,
      < -6.841698, -0.362516, -2.816865>
    }
    triangle {
      < -6.841507, -0.487581, -2.733489>,
      < -6.841412, -0.471144, -2.722069>,
      < -6.841676, -0.425841, -2.775235>
    }
    triangle {
      < -6.841507, -0.487581, -2.733489>,
      < -6.841676, -0.425841, -2.775235>,
      < -6.841866, -0.439490, -2.791026>
    }
    triangle {
      < -6.839314, -0.539283, -2.555220>,
      < -6.837482, -0.549481, -2.444748>,
      < -6.837608, -0.529316, -2.444607>
    }
    triangle {
      < -6.839314, -0.539283, -2.555220>,
      < -6.837608, -0.529316, -2.444607>,
      < -6.839378, -0.519588, -2.551625>
    }
    triangle {
      < -6.837585, -0.541778, -2.342008>,
      < -6.837764, -0.521986, -2.345005>,
      < -6.837608, -0.529316, -2.444607>
    }
    triangle {
      < -6.837585, -0.541778, -2.342008>,
      < -6.837608, -0.529316, -2.444607>,
      < -6.837482, -0.549481, -2.444748>
    }
    triangle {
      < -6.832152, -0.500433, -2.174088>,
      < -6.826616, -0.459473, -2.118052>,
      < -6.826978, -0.444986, -2.133379>
    }
    triangle {
      < -6.832152, -0.500433, -2.174088>,
      < -6.826978, -0.444986, -2.133379>,
      < -6.832448, -0.483480, -2.184819>
    }
    triangle {
      < -6.826521, -0.394538, -2.074579>,
      < -6.826890, -0.384413, -2.091931>,
      < -6.826978, -0.444986, -2.133379>
    }
    triangle {
      < -6.826521, -0.394538, -2.074579>,
      < -6.826978, -0.444986, -2.133379>,
      < -6.826616, -0.459473, -2.118052>
    }
    triangle {
      < -6.826521, -0.394538, -2.074579>,
      < -6.750121, -0.394538, -2.074579>,
      < -6.750026, -0.319472, -2.052864>
    }
    triangle {
      < -6.826521, -0.394538, -2.074579>,
      < -6.750026, -0.319472, -2.052864>,
      < -6.826427, -0.319472, -2.052864>
    }
    triangle {
      < -6.826890, -0.384413, -2.091931>,
      < -6.826521, -0.394538, -2.074579>,
      < -6.826427, -0.319472, -2.052864>
    }
    triangle {
      < -6.826890, -0.384413, -2.091931>,
      < -6.826427, -0.319472, -2.052864>,
      < -6.826804, -0.313709, -2.072241>
    }
    triangle {
      < -6.832152, -0.500433, -2.174088>,
      < -6.832448, -0.483480, -2.184819>,
      < -6.837920, -0.505056, -2.245336>
    }
    triangle {
      < -6.832152, -0.500433, -2.174088>,
      < -6.837920, -0.505056, -2.245336>,
      < -6.837688, -0.524475, -2.239201>
    }
    triangle {
      < -6.755751, -0.500433, -2.174088>,
      < -6.832152, -0.500433, -2.174088>,
      < -6.837688, -0.524475, -2.239201>
    }
    triangle {
      < -6.755751, -0.500433, -2.174088>,
      < -6.837688, -0.524475, -2.239201>,
      < -6.761287, -0.524475, -2.239201>
    }
    triangle {
      < -6.837585, -0.541778, -2.342008>,
      < -6.761184, -0.541778, -2.342008>,
      < -6.761287, -0.524475, -2.239201>
    }
    triangle {
      < -6.837585, -0.541778, -2.342008>,
      < -6.761287, -0.524475, -2.239201>,
      < -6.837688, -0.524475, -2.239201>
    }
    triangle {
      < -6.837764, -0.521986, -2.345005>,
      < -6.837585, -0.541778, -2.342008>,
      < -6.837688, -0.524475, -2.239201>
    }
    triangle {
      < -6.837764, -0.521986, -2.345005>,
      < -6.837688, -0.524475, -2.239201>,
      < -6.837920, -0.505056, -2.245336>
    }
    triangle {
      < -6.839314, -0.539283, -2.555220>,
      < -6.839378, -0.519588, -2.551625>,
      < -6.841147, -0.500260, -2.658577>
    }
    triangle {
      < -6.839314, -0.539283, -2.555220>,
      < -6.841147, -0.500260, -2.658577>,
      < -6.841148, -0.519486, -2.665626>
    }
    triangle {
      < -6.762914, -0.539283, -2.555220>,
      < -6.839314, -0.539283, -2.555220>,
      < -6.841148, -0.519486, -2.665626>
    }
    triangle {
      < -6.762914, -0.539283, -2.555220>,
      < -6.841148, -0.519486, -2.665626>,
      < -6.764747, -0.519486, -2.665626>
    }
    triangle {
      < -6.841507, -0.487581, -2.733489>,
      < -6.765106, -0.487581, -2.733489>,
      < -6.764747, -0.519486, -2.665626>
    }
    triangle {
      < -6.841507, -0.487581, -2.733489>,
      < -6.764747, -0.519486, -2.665626>,
      < -6.841148, -0.519486, -2.665626>
    }
    triangle {
      < -6.841412, -0.471144, -2.722069>,
      < -6.841507, -0.487581, -2.733489>,
      < -6.841148, -0.519486, -2.665626>
    }
    triangle {
      < -6.841412, -0.471144, -2.722069>,
      < -6.841148, -0.519486, -2.665626>,
      < -6.841147, -0.500260, -2.658577>
    }
    triangle {
      < -6.841948, -0.371911, -2.834569>,
      < -6.841698, -0.362516, -2.816865>,
      < -6.841718, -0.289349, -2.836606>
    }
    triangle {
      < -6.841948, -0.371911, -2.834569>,
      < -6.841718, -0.289349, -2.836606>,
      < -6.842030, -0.294491, -2.856221>
    }
    triangle {
      < -6.765547, -0.371911, -2.834569>,
      < -6.841948, -0.371911, -2.834569>,
      < -6.842030, -0.294491, -2.856221>
    }
    triangle {
      < -6.765547, -0.371911, -2.834569>,
      < -6.842030, -0.294491, -2.856221>,
      < -6.765629, -0.294491, -2.856221>
    }
    triangle {
      < -6.841948, -0.371911, 2.834569>,
      < -6.841866, -0.439490, 2.791026>,
      < -6.765466, -0.439490, 2.791026>
    }
    triangle {
      < -6.841948, -0.371911, 2.834569>,
      < -6.765466, -0.439490, 2.791026>,
      < -6.765547, -0.371911, 2.834569>
    }
    triangle {
      < -6.765466, -0.439490, 2.791026>,
      < -6.841866, -0.439490, 2.791026>,
      < -6.841507, -0.487581, 2.733489>
    }
    triangle {
      < -6.765466, -0.439490, 2.791026>,
      < -6.841507, -0.487581, 2.733489>,
      < -6.765106, -0.487581, 2.733489>
    }
    triangle {
      < -6.839314, -0.539283, 2.555220>,
      < -6.837482, -0.549481, 2.444748>,
      < -6.761081, -0.549481, 2.444748>
    }
    triangle {
      < -6.839314, -0.539283, 2.555220>,
      < -6.761081, -0.549481, 2.444748>,
      < -6.762914, -0.539283, 2.555220>
    }
    triangle {
      < -6.761081, -0.549481, 2.444748>,
      < -6.837482, -0.549481, 2.444748>,
      < -6.837585, -0.541778, 2.342008>
    }
    triangle {
      < -6.761081, -0.549481, 2.444748>,
      < -6.837585, -0.541778, 2.342008>,
      < -6.761184, -0.541778, 2.342008>
    }
    triangle {
      < -6.832152, -0.500433, 2.174088>,
      < -6.826616, -0.459473, 2.118052>,
      < -6.750215, -0.459473, 2.118052>
    }
    triangle {
      < -6.832152, -0.500433, 2.174088>,
      < -6.750215, -0.459473, 2.118052>,
      < -6.755751, -0.500433, 2.174088>
    }
    triangle {
      < -6.750215, -0.459473, 2.118052>,
      < -6.826616, -0.459473, 2.118052>,
      < -6.826521, -0.394538, 2.074579>
    }
    triangle {
      < -6.750215, -0.459473, 2.118052>,
      < -6.826521, -0.394538, 2.074579>,
      < -6.750121, -0.394538, 2.074579>
    }
    triangle {
      < -6.826427, -0.319472, 2.052864>,
      < -6.833982, -0.079470, 2.018336>,
      < -6.757581, -0.079470, 2.018336>
    }
    triangle {
      < -6.826427, -0.319472, 2.052864>,
      < -6.757581, -0.079470, 2.018336>,
      < -6.750026, -0.319472, 2.052864>
    }
    triangle {
      < -6.826804, -0.313709, 2.072241>,
      < -6.834251, -0.079229, 2.038333>,
      < -6.833982, -0.079470, 2.018336>
    }
    triangle {
      < -6.826804, -0.313709, 2.072241>,
      < -6.833982, -0.079470, 2.018336>,
      < -6.826427, -0.319472, 2.052864>
    }
    triangle {
      < -6.841698, -0.362516, 2.816865>,
      < -6.841676, -0.425841, 2.775235>,
      < -6.841866, -0.439490, 2.791026>
    }
    triangle {
      < -6.841698, -0.362516, 2.816865>,
      < -6.841866, -0.439490, 2.791026>,
      < -6.841948, -0.371911, 2.834569>
    }
    triangle {
      < -6.841866, -0.439490, 2.791026>,
      < -6.841676, -0.425841, 2.775235>,
      < -6.841412, -0.471144, 2.722069>
    }
    triangle {
      < -6.841866, -0.439490, 2.791026>,
      < -6.841412, -0.471144, 2.722069>,
      < -6.841507, -0.487581, 2.733489>
    }
    triangle {
      < -6.839378, -0.519588, 2.551625>,
      < -6.837608, -0.529316, 2.444607>,
      < -6.837482, -0.549481, 2.444748>
    }
    triangle {
      < -6.839378, -0.519588, 2.551625>,
      < -6.837482, -0.549481, 2.444748>,
      < -6.839314, -0.539283, 2.555220>
    }
    triangle {
      < -6.837482, -0.549481, 2.444748>,
      < -6.837608, -0.529316, 2.444607>,
      < -6.837764, -0.521986, 2.345005>
    }
    triangle {
      < -6.837482, -0.549481, 2.444748>,
      < -6.837764, -0.521986, 2.345005>,
      < -6.837585, -0.541778, 2.342008>
    }
    triangle {
      < -6.832448, -0.483480, 2.184819>,
      < -6.826978, -0.444986, 2.133379>,
      < -6.826616, -0.459473, 2.118052>
    }
    triangle {
      < -6.832448, -0.483480, 2.184819>,
      < -6.826616, -0.459473, 2.118052>,
      < -6.832152, -0.500433, 2.174088>
    }
    triangle {
      < -6.826616, -0.459473, 2.118052>,
      < -6.826978, -0.444986, 2.133379>,
      < -6.826890, -0.384413, 2.091931>
    }
    triangle {
      < -6.826616, -0.459473, 2.118052>,
      < -6.826890, -0.384413, 2.091931>,
      < -6.826521, -0.394538, 2.074579>
    }
    triangle {
      < -6.826427, -0.319472, 2.052864>,
      < -6.750026, -0.319472, 2.052864>,
      < -6.750121, -0.394538, 2.074579>
    }
    triangle {
      < -6.826427, -0.319472, 2.052864>,
      < -6.750121, -0.394538, 2.074579>,
      < -6.826521, -0.394538, 2.074579>
    }
    triangle {
      < -6.826804, -0.313709, 2.072241>,
      < -6.826427, -0.319472, 2.052864>,
      < -6.826521, -0.394538, 2.074579>
    }
    triangle {
      < -6.826804, -0.313709, 2.072241>,
      < -6.826521, -0.394538, 2.074579>,
      < -6.826890, -0.384413, 2.091931>
    }
    triangle {
      < -6.837688, -0.524475, 2.239201>,
      < -6.837920, -0.505056, 2.245336>,
      < -6.832448, -0.483480, 2.184819>
    }
    triangle {
      < -6.837688, -0.524475, 2.239201>,
      < -6.832448, -0.483480, 2.184819>,
      < -6.832152, -0.500433, 2.174088>
    }
    triangle {
      < -6.761287, -0.524475, 2.239201>,
      < -6.837688, -0.524475, 2.239201>,
      < -6.832152, -0.500433, 2.174088>
    }
    triangle {
      < -6.761287, -0.524475, 2.239201>,
      < -6.832152, -0.500433, 2.174088>,
      < -6.755751, -0.500433, 2.174088>
    }
    triangle {
      < -6.837688, -0.524475, 2.239201>,
      < -6.761287, -0.524475, 2.239201>,
      < -6.761184, -0.541778, 2.342008>
    }
    triangle {
      < -6.837688, -0.524475, 2.239201>,
      < -6.761184, -0.541778, 2.342008>,
      < -6.837585, -0.541778, 2.342008>
    }
    triangle {
      < -6.837920, -0.505056, 2.245336>,
      < -6.837688, -0.524475, 2.239201>,
      < -6.837585, -0.541778, 2.342008>
    }
    triangle {
      < -6.837920, -0.505056, 2.245336>,
      < -6.837585, -0.541778, 2.342008>,
      < -6.837764, -0.521986, 2.345005>
    }
    triangle {
      < -6.841148, -0.519486, 2.665626>,
      < -6.841147, -0.500260, 2.658577>,
      < -6.839378, -0.519588, 2.551625>
    }
    triangle {
      < -6.841148, -0.519486, 2.665626>,
      < -6.839378, -0.519588, 2.551625>,
      < -6.839314, -0.539283, 2.555220>
    }
    triangle {
      < -6.764747, -0.519486, 2.665626>,
      < -6.841148, -0.519486, 2.665626>,
      < -6.839314, -0.539283, 2.555220>
    }
    triangle {
      < -6.764747, -0.519486, 2.665626>,
      < -6.839314, -0.539283, 2.555220>,
      < -6.762914, -0.539283, 2.555220>
    }
    triangle {
      < -6.841148, -0.519486, 2.665626>,
      < -6.764747, -0.519486, 2.665626>,
      < -6.765106, -0.487581, 2.733489>
    }
    triangle {
      < -6.841148, -0.519486, 2.665626>,
      < -6.765106, -0.487581, 2.733489>,
      < -6.841507, -0.487581, 2.733489>
    }
    triangle {
      < -6.841147, -0.500260, 2.658577>,
      < -6.841148, -0.519486, 2.665626>,
      < -6.841507, -0.487581, 2.733489>
    }
    triangle {
      < -6.841147, -0.500260, 2.658577>,
      < -6.841507, -0.487581, 2.733489>,
      < -6.841412, -0.471144, 2.722069>
    }
    triangle {
      < -6.842030, -0.294491, 2.856221>,
      < -6.841718, -0.289349, 2.836606>,
      < -6.841698, -0.362516, 2.816865>
    }
    triangle {
      < -6.842030, -0.294491, 2.856221>,
      < -6.841698, -0.362516, 2.816865>,
      < -6.841948, -0.371911, 2.834569>
    }
    triangle {
      < -6.765629, -0.294491, 2.856221>,
      < -6.842030, -0.294491, 2.856221>,
      < -6.841948, -0.371911, 2.834569>
    }
    triangle {
      < -6.765629, -0.294491, 2.856221>,
      < -6.841948, -0.371911, 2.834569>,
      < -6.765547, -0.371911, 2.834569>
    }
    triangle {
      < -6.834251, -0.079229, -2.038333>,
      < -6.833982, -0.079470, -2.018336>,
      < -6.858537, -0.013427, -2.025174>
    }
    triangle {
      < -6.834251, -0.079229, -2.038333>,
      < -6.858537, -0.013427, -2.025174>,
      < -6.857495, -0.015160, -2.045397>
    }
    triangle {
      < -6.782136, -0.009468, -2.025174>,
      < -6.846581, 0.069217, -2.034971>,
      < -6.922982, 0.060807, -2.034971>
    }
    triangle {
      < -6.782136, -0.009468, -2.025174>,
      < -6.922982, 0.060807, -2.034971>,
      < -6.858537, -0.013427, -2.025174>
    }
    triangle {
      < -6.846581, 0.069217, -2.034971>,
      < -6.960692, 0.206915, -2.118648>,
      < -7.037093, 0.190717, -2.118648>
    }
    triangle {
      < -6.846581, 0.069217, -2.034971>,
      < -7.037093, 0.190717, -2.118648>,
      < -6.922982, 0.060807, -2.034971>
    }
    triangle {
      < -6.960692, 0.206915, -2.118648>,
      < -7.022356, 0.270845, -2.233527>,
      < -7.098756, 0.251030, -2.233527>
    }
    triangle {
      < -6.960692, 0.206915, -2.118648>,
      < -7.098756, 0.251030, -2.233527>,
      < -7.037093, 0.190717, -2.118648>
    }
    triangle {
      < -7.022356, 0.270845, -2.233527>,
      < -7.063996, 0.318964, -2.411743>,
      < -7.140397, 0.296924, -2.411743>
    }
    triangle {
      < -7.022356, 0.270845, -2.233527>,
      < -7.140397, 0.296924, -2.411743>,
      < -7.098756, 0.251030, -2.233527>
    }
    triangle {
      < -7.063996, 0.318964, -2.411743>,
      < -7.068709, 0.320061, -2.499018>,
      < -7.145110, 0.297465, -2.499018>
    }
    triangle {
      < -7.063996, 0.318964, -2.411743>,
      < -7.145110, 0.297465, -2.499018>,
      < -7.140397, 0.296924, -2.411743>
    }
    triangle {
      < -7.068709, 0.320061, -2.499018>,
      < -7.035048, 0.275753, -2.670665>,
      < -7.111449, 0.255661, -2.670665>
    }
    triangle {
      < -7.068709, 0.320061, -2.499018>,
      < -7.111449, 0.255661, -2.670665>,
      < -7.145110, 0.297465, -2.499018>
    }
    triangle {
      < -7.035048, 0.275753, -2.670665>,
      < -6.960614, 0.197063, -2.795497>,
      < -7.037015, 0.181421, -2.795497>
    }
    triangle {
      < -7.035048, 0.275753, -2.670665>,
      < -7.037015, 0.181421, -2.795497>,
      < -7.111449, 0.255661, -2.670665>
    }
    triangle {
      < -6.960614, 0.197063, -2.795497>,
      < -6.855350, 0.064279, -2.862890>,
      < -6.931751, 0.056148, -2.862890>
    }
    triangle {
      < -6.960614, 0.197063, -2.795497>,
      < -6.931751, 0.056148, -2.862890>,
      < -7.037015, 0.181421, -2.795497>
    }
    triangle {
      < -6.855350, 0.064279, -2.862890>,
      < -6.799399, -0.009489, -2.873777>,
      < -6.875800, -0.013447, -2.873777>
    }
    triangle {
      < -6.855350, 0.064279, -2.862890>,
      < -6.875800, -0.013447, -2.873777>,
      < -6.931751, 0.056148, -2.862890>
    }
    triangle {
      < -6.799399, -0.009489, -2.873777>,
      < -6.769115, -0.068501, -2.876542>,
      < -6.845516, -0.069121, -2.876542>
    }
    triangle {
      < -6.799399, -0.009489, -2.873777>,
      < -6.845516, -0.069121, -2.876542>,
      < -6.875800, -0.013447, -2.873777>
    }
    triangle {
      < -6.769115, -0.068501, -2.876542>,
      < -6.765629, -0.294491, -2.856221>,
      < -6.842030, -0.294491, -2.856221>
    }
    triangle {
      < -6.769115, -0.068501, -2.876542>,
      < -6.842030, -0.294491, -2.856221>,
      < -6.845516, -0.069121, -2.876542>
    }
    triangle {
      < -6.757581, -0.079470, -2.018336>,
      < -6.782136, -0.009468, -2.025174>,
      < -6.858537, -0.013427, -2.025174>
    }
    triangle {
      < -6.757581, -0.079470, -2.018336>,
      < -6.858537, -0.013427, -2.025174>,
      < -6.833982, -0.079470, -2.018336>
    }
    triangle {
      < -6.931751, 0.056148, -2.862890>,
      < -6.875800, -0.013447, -2.873777>,
      < -6.874547, -0.014609, -2.853755>
    }
    triangle {
      < -6.931751, 0.056148, -2.862890>,
      < -6.874547, -0.014609, -2.853755>,
      < -6.928379, 0.052304, -2.843365>
    }
    triangle {
      < -6.858537, -0.013427, -2.025174>,
      < -6.922982, 0.060807, -2.034971>,
      < -6.919741, 0.056316, -2.054514>
    }
    triangle {
      < -6.858537, -0.013427, -2.025174>,
      < -6.919741, 0.056316, -2.054514>,
      < -6.857495, -0.015160, -2.045397>
    }
    triangle {
      < -6.922982, 0.060807, -2.034971>,
      < -7.037093, 0.190717, -2.118648>,
      < -7.029095, 0.180308, -2.134510>
    }
    triangle {
      < -6.922982, 0.060807, -2.034971>,
      < -7.029095, 0.180308, -2.134510>,
      < -6.919741, 0.056316, -2.054514>
    }
    triangle {
      < -7.037093, 0.190717, -2.118648>,
      < -7.098756, 0.251030, -2.233527>,
      < -7.087681, 0.236878, -2.242903>
    }
    triangle {
      < -7.037093, 0.190717, -2.118648>,
      < -7.087681, 0.236878, -2.242903>,
      < -7.029095, 0.180308, -2.134510>
    }
    triangle {
      < -7.098756, 0.251030, -2.233527>,
      < -7.140397, 0.296924, -2.411743>,
      < -7.128163, 0.281420, -2.415889>
    }
    triangle {
      < -7.098756, 0.251030, -2.233527>,
      < -7.128163, 0.281420, -2.415889>,
      < -7.087681, 0.236878, -2.242903>
    }
    triangle {
      < -7.140397, 0.296924, -2.411743>,
      < -7.145110, 0.297465, -2.499018>,
      < -7.132436, 0.281541, -2.496710>
    }
    triangle {
      < -7.140397, 0.296924, -2.411743>,
      < -7.132436, 0.281541, -2.496710>,
      < -7.128163, 0.281420, -2.415889>
    }
    triangle {
      < -7.145110, 0.297465, -2.499018>,
      < -7.111449, 0.255661, -2.670665>,
      < -7.100271, 0.241778, -2.660793>
    }
    triangle {
      < -7.145110, 0.297465, -2.499018>,
      < -7.100271, 0.241778, -2.660793>,
      < -7.132436, 0.281541, -2.496710>
    }
    triangle {
      < -7.111449, 0.255661, -2.670665>,
      < -7.037015, 0.181421, -2.795497>,
      < -7.029285, 0.172025, -2.778870>
    }
    triangle {
      < -7.111449, 0.255661, -2.670665>,
      < -7.029285, 0.172025, -2.778870>,
      < -7.100271, 0.241778, -2.660793>
    }
    triangle {
      < -7.037015, 0.181421, -2.795497>,
      < -6.931751, 0.056148, -2.862890>,
      < -6.928379, 0.052304, -2.843365>
    }
    triangle {
      < -7.037015, 0.181421, -2.795497>,
      < -6.928379, 0.052304, -2.843365>,
      < -7.029285, 0.172025, -2.778870>
    }
    triangle {
      < -6.845516, -0.069121, -2.876542>,
      < -6.842030, -0.294491, -2.856221>,
      < -6.841718, -0.289349, -2.836606>
    }
    triangle {
      < -6.845516, -0.069121, -2.876542>,
      < -6.841718, -0.289349, -2.836606>,
      < -6.845248, -0.069362, -2.856545>
    }
    triangle {
      < -6.845248, -0.069362, -2.856545>,
      < -6.874547, -0.014609, -2.853755>,
      < -6.875800, -0.013447, -2.873777>
    }
    triangle {
      < -6.845248, -0.069362, -2.856545>,
      < -6.875800, -0.013447, -2.873777>,
      < -6.845516, -0.069121, -2.876542>
    }
    triangle {
      < -6.805801, -0.122246, -2.778569>,
      < -6.806168, -0.232484, -2.763064>,
      < -6.805866, -0.226324, -2.743735>
    }
    triangle {
      < -6.805801, -0.122246, -2.778569>,
      < -6.805866, -0.226324, -2.743735>,
      < -6.805484, -0.123162, -2.758246>
    }
    triangle {
      < -6.806168, -0.232484, -2.763064>,
      < -6.805990, -0.331365, -2.711921>,
      < -6.805741, -0.318576, -2.696020>
    }
    triangle {
      < -6.806168, -0.232484, -2.763064>,
      < -6.805741, -0.318576, -2.696020>,
      < -6.805866, -0.226324, -2.743735>
    }
    triangle {
      < -6.805990, -0.331365, -2.711921>,
      < -6.803942, -0.428412, -2.595193>,
      < -6.803799, -0.410023, -2.586029>
    }
    triangle {
      < -6.805990, -0.331365, -2.711921>,
      < -6.803799, -0.410023, -2.586029>,
      < -6.805741, -0.318576, -2.696020>
    }
    triangle {
      < -6.803942, -0.428412, -2.595193>,
      < -6.801351, -0.463196, -2.447439>,
      < -6.801350, -0.442659, -2.447400>
    }
    triangle {
      < -6.803942, -0.428412, -2.595193>,
      < -6.801350, -0.442659, -2.447400>,
      < -6.803799, -0.410023, -2.586029>
    }
    triangle {
      < -6.801351, -0.463196, -2.447439>,
      < -6.798798, -0.429527, -2.301943>,
      < -6.798938, -0.411085, -2.310958>
    }
    triangle {
      < -6.801351, -0.463196, -2.447439>,
      < -6.798938, -0.411085, -2.310958>,
      < -6.801350, -0.442659, -2.447400>
    }
    triangle {
      < -6.798798, -0.429527, -2.301943>,
      < -6.796764, -0.335362, -2.186019>,
      < -6.797009, -0.322354, -2.201725>
    }
    triangle {
      < -6.798798, -0.429527, -2.301943>,
      < -6.797009, -0.322354, -2.201725>,
      < -6.798938, -0.411085, -2.310958>
    }
    triangle {
      < -6.796764, -0.335362, -2.186019>,
      < -6.796567, -0.238610, -2.133832>,
      < -6.796867, -0.232077, -2.153030>
    }
    triangle {
      < -6.796764, -0.335362, -2.186019>,
      < -6.796867, -0.232077, -2.153030>,
      < -6.797009, -0.322354, -2.201725>
    }
    triangle {
      < -6.796567, -0.238610, -2.133832>,
      < -6.796898, -0.130108, -2.116174>,
      < -6.797215, -0.130596, -2.136513>
    }
    triangle {
      < -6.796567, -0.238610, -2.133832>,
      < -6.797215, -0.130596, -2.136513>,
      < -6.796867, -0.232077, -2.153030>
    }
    triangle {
      < -6.796898, -0.130108, -2.116174>,
      < -6.796768, 0.001062, -2.144023>,
      < -6.797060, -0.007134, -2.162727>
    }
    triangle {
      < -6.796898, -0.130108, -2.116174>,
      < -6.797060, -0.007134, -2.162727>,
      < -6.797215, -0.130596, -2.136513>
    }
    triangle {
      < -6.796768, 0.001062, -2.144023>,
      < -6.797389, 0.110451, -2.221580>,
      < -6.797607, 0.095650, -2.235601>
    }
    triangle {
      < -6.796768, 0.001062, -2.144023>,
      < -6.797607, 0.095650, -2.235601>,
      < -6.797060, -0.007134, -2.162727>
    }
    triangle {
      < -6.797389, 0.110451, -2.221580>,
      < -6.799222, 0.176365, -2.326069>,
      < -6.799339, 0.157424, -2.333527>
    }
    triangle {
      < -6.797389, 0.110451, -2.221580>,
      < -6.799339, 0.157424, -2.333527>,
      < -6.797607, 0.095650, -2.235601>
    }
    triangle {
      < -6.799222, 0.176365, -2.326069>,
      < -6.801351, 0.199405, -2.447439>,
      < -6.801351, 0.179053, -2.447468>
    }
    triangle {
      < -6.799222, 0.176365, -2.326069>,
      < -6.801351, 0.179053, -2.447468>,
      < -6.799339, 0.157424, -2.333527>
    }
    triangle {
      < -6.801351, 0.199405, -2.447439>,
      < -6.803450, 0.177033, -2.567100>,
      < -6.803336, 0.158060, -2.559751>
    }
    triangle {
      < -6.801351, 0.199405, -2.447439>,
      < -6.803336, 0.158060, -2.559751>,
      < -6.801351, 0.179053, -2.447468>
    }
    triangle {
      < -6.803450, 0.177033, -2.567100>,
      < -6.805265, 0.112938, -2.670601>,
      < -6.805049, 0.097988, -2.656756>
    }
    triangle {
      < -6.803450, 0.177033, -2.567100>,
      < -6.805049, 0.097988, -2.656756>,
      < -6.803336, 0.158060, -2.559751>
    }
    triangle {
      < -6.805265, 0.112938, -2.670601>,
      < -6.805894, 0.006324, -2.748495>,
      < -6.805604, -0.002191, -2.729949>
    }
    triangle {
      < -6.805265, 0.112938, -2.670601>,
      < -6.805604, -0.002191, -2.729949>,
      < -6.805049, 0.097988, -2.656756>
    }
    triangle {
      < -6.805894, 0.006324, -2.748495>,
      < -6.805801, -0.122246, -2.778569>,
      < -6.805484, -0.123162, -2.758246>
    }
    triangle {
      < -6.805894, 0.006324, -2.748495>,
      < -6.805484, -0.123162, -2.758246>,
      < -6.805604, -0.002191, -2.729949>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.840815, -1.275948, -2.644820>,
      < 8.905038, -1.369328, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.905038, -1.369328, -2.644820>,
      < 8.866709, -1.430716, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.866709, -1.430716, -2.644820>,
      < 8.816582, -1.480141, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.816582, -1.480141, -2.644820>,
      < 8.754660, -1.517604, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.754660, -1.517604, -2.644820>,
      < 8.773904, -1.572958, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.773904, -1.572958, -2.644820>,
      < 8.773904, -1.757912, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.773904, -1.757912, -2.644820>,
      < 8.727462, -1.812349, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.727462, -1.812349, -2.644820>,
      < 8.652828, -1.812349, -2.644820>
    }
    triangle {
      < 8.756744, -1.206643, -2.644820>,
      < 8.652828, -1.812349, -2.644820>,
      < 8.652828, -1.161411, -2.644820>
    }
    triangle {
      < 8.924818, -1.275948, -1.032750>,
      < 8.948820, -1.275948, 0.000000>,
      < 9.013043, -1.369328, 0.000000>
    }
    triangle {
      < 8.924818, -1.275948, -1.032750>,
      < 9.013043, -1.369328, 0.000000>,
      < 8.989041, -1.369328, -1.032750>
    }
    triangle {
      < 8.760834, -1.812349, 0.000000>,
      < 8.736832, -1.812349, -1.032750>,
      < 8.811465, -1.812349, -1.032750>
    }
    triangle {
      < 8.760834, -1.812349, 0.000000>,
      < 8.811465, -1.812349, -1.032750>,
      < 8.835467, -1.812349, 0.000000>
    }
    triangle {
      < 8.857907, -1.757912, -1.032750>,
      < 8.881909, -1.757912, 0.000000>,
      < 8.835467, -1.812349, 0.000000>
    }
    triangle {
      < 8.857907, -1.757912, -1.032750>,
      < 8.835467, -1.812349, 0.000000>,
      < 8.811465, -1.812349, -1.032750>
    }
    triangle {
      < 8.760834, -1.812349, 0.000000>,
      < 8.760834, -1.161411, 0.000000>,
      < 8.736832, -1.161411, -1.032750>
    }
    triangle {
      < 8.760834, -1.812349, 0.000000>,
      < 8.736832, -1.161411, -1.032750>,
      < 8.736832, -1.812349, -1.032750>
    }
    triangle {
      < 8.974714, -1.430716, 0.000000>,
      < 8.950712, -1.430716, -1.032750>,
      < 8.989041, -1.369328, -1.032750>
    }
    triangle {
      < 8.974714, -1.430716, 0.000000>,
      < 8.989041, -1.369328, -1.032750>,
      < 9.013043, -1.369328, 0.000000>
    }
    triangle {
      < 8.881909, -1.757912, 0.000000>,
      < 8.857907, -1.757912, -1.032750>,
      < 8.857907, -1.572958, -1.032750>
    }
    triangle {
      < 8.881909, -1.757912, 0.000000>,
      < 8.857907, -1.572958, -1.032750>,
      < 8.881909, -1.572958, 0.000000>
    }
    triangle {
      < 8.864750, -1.206643, 0.000000>,
      < 8.840748, -1.206643, -1.032750>,
      < 8.736832, -1.161411, -1.032750>
    }
    triangle {
      < 8.864750, -1.206643, 0.000000>,
      < 8.736832, -1.161411, -1.032750>,
      < 8.760834, -1.161411, 0.000000>
    }
    triangle {
      < 8.948820, -1.275948, 0.000000>,
      < 8.924818, -1.275948, -1.032750>,
      < 8.840748, -1.206643, -1.032750>
    }
    triangle {
      < 8.948820, -1.275948, 0.000000>,
      < 8.840748, -1.206643, -1.032750>,
      < 8.864750, -1.206643, 0.000000>
    }
    triangle {
      < 8.950712, -1.430716, -1.032750>,
      < 8.974714, -1.430716, 0.000000>,
      < 8.924587, -1.480141, 0.000000>
    }
    triangle {
      < 8.950712, -1.430716, -1.032750>,
      < 8.924587, -1.480141, 0.000000>,
      < 8.900585, -1.480141, -1.032750>
    }
    triangle {
      < 8.900585, -1.480141, -1.032750>,
      < 8.924587, -1.480141, 0.000000>,
      < 8.862665, -1.517604, 0.000000>
    }
    triangle {
      < 8.900585, -1.480141, -1.032750>,
      < 8.862665, -1.517604, 0.000000>,
      < 8.838663, -1.517604, -1.032750>
    }
    triangle {
      < 8.881909, -1.572958, 0.000000>,
      < 8.857907, -1.572958, -1.032750>,
      < 8.838663, -1.517604, -1.032750>
    }
    triangle {
      < 8.881909, -1.572958, 0.000000>,
      < 8.838663, -1.517604, -1.032750>,
      < 8.862665, -1.517604, 0.000000>
    }
    triangle {
      < 8.811465, -1.812349, -1.032750>,
      < 8.736832, -1.812349, -1.032750>,
      < 8.708031, -1.812349, -1.749258>
    }
    triangle {
      < 8.811465, -1.812349, -1.032750>,
      < 8.708031, -1.812349, -1.749258>,
      < 8.782664, -1.812349, -1.749258>
    }
    triangle {
      < 8.736832, -1.812349, -1.032750>,
      < 8.736832, -1.161411, -1.032750>,
      < 8.708031, -1.161411, -1.749258>
    }
    triangle {
      < 8.736832, -1.812349, -1.032750>,
      < 8.708031, -1.161411, -1.749258>,
      < 8.708031, -1.812349, -1.749258>
    }
    triangle {
      < 8.736832, -1.161411, -1.032750>,
      < 8.840748, -1.206643, -1.032750>,
      < 8.811947, -1.206643, -1.749258>
    }
    triangle {
      < 8.736832, -1.161411, -1.032750>,
      < 8.811947, -1.206643, -1.749258>,
      < 8.708031, -1.161411, -1.749258>
    }
    triangle {
      < 8.840748, -1.206643, -1.032750>,
      < 8.924818, -1.275948, -1.032750>,
      < 8.896017, -1.275948, -1.749258>
    }
    triangle {
      < 8.840748, -1.206643, -1.032750>,
      < 8.896017, -1.275948, -1.749258>,
      < 8.811947, -1.206643, -1.749258>
    }
    triangle {
      < 8.924818, -1.275948, -1.032750>,
      < 8.989041, -1.369328, -1.032750>,
      < 8.960240, -1.369328, -1.749258>
    }
    triangle {
      < 8.924818, -1.275948, -1.032750>,
      < 8.960240, -1.369328, -1.749258>,
      < 8.896017, -1.275948, -1.749258>
    }
    triangle {
      < 8.989041, -1.369328, -1.032750>,
      < 8.950712, -1.430716, -1.032750>,
      < 8.921911, -1.430716, -1.749258>
    }
    triangle {
      < 8.989041, -1.369328, -1.032750>,
      < 8.921911, -1.430716, -1.749258>,
      < 8.960240, -1.369328, -1.749258>
    }
    triangle {
      < 8.950712, -1.430716, -1.032750>,
      < 8.900585, -1.480141, -1.032750>,
      < 8.871784, -1.480141, -1.749258>
    }
    triangle {
      < 8.950712, -1.430716, -1.032750>,
      < 8.871784, -1.480141, -1.749258>,
      < 8.921911, -1.430716, -1.749258>
    }
    triangle {
      < 8.900585, -1.480141, -1.032750>,
      < 8.838663, -1.517604, -1.032750>,
      < 8.809862, -1.517604, -1.749258>
    }
    triangle {
      < 8.900585, -1.480141, -1.032750>,
      < 8.809862, -1.517604, -1.749258>,
      < 8.871784, -1.480141, -1.749258>
    }
    triangle {
      < 8.838663, -1.517604, -1.032750>,
      < 8.857907, -1.572958, -1.032750>,
      < 8.829106, -1.572958, -1.749258>
    }
    triangle {
      < 8.838663, -1.517604, -1.032750>,
      < 8.829106, -1.572958, -1.749258>,
      < 8.809862, -1.517604, -1.749258>
    }
    triangle {
      < 8.857907, -1.572958, -1.032750>,
      < 8.857907, -1.757912, -1.032750>,
      < 8.829106, -1.757912, -1.749258>
    }
    triangle {
      < 8.857907, -1.572958, -1.032750>,
      < 8.829106, -1.757912, -1.749258>,
      < 8.829106, -1.572958, -1.749258>
    }
    triangle {
      < 8.857907, -1.757912, -1.032750>,
      < 8.811465, -1.812349, -1.032750>,
      < 8.782664, -1.812349, -1.749258>
    }
    triangle {
      < 8.857907, -1.757912, -1.032750>,
      < 8.782664, -1.812349, -1.749258>,
      < 8.829106, -1.757912, -1.749258>
    }
    triangle {
      < 8.809862, -1.517604, -1.749258>,
      < 8.829106, -1.572958, -1.749258>,
      < 8.802705, -1.572958, -2.283984>
    }
    triangle {
      < 8.809862, -1.517604, -1.749258>,
      < 8.802705, -1.572958, -2.283984>,
      < 8.783461, -1.517604, -2.283984>
    }
    triangle {
      < 8.829106, -1.572958, -1.749258>,
      < 8.829106, -1.757912, -1.749258>,
      < 8.802705, -1.757912, -2.283984>
    }
    triangle {
      < 8.829106, -1.572958, -1.749258>,
      < 8.802705, -1.757912, -2.283984>,
      < 8.802705, -1.572958, -2.283984>
    }
    triangle {
      < 8.829106, -1.757912, -1.749258>,
      < 8.782664, -1.812349, -1.749258>,
      < 8.756263, -1.812349, -2.283984>
    }
    triangle {
      < 8.829106, -1.757912, -1.749258>,
      < 8.756263, -1.812349, -2.283984>,
      < 8.802705, -1.757912, -2.283984>
    }
    triangle {
      < 8.782664, -1.812349, -1.749258>,
      < 8.708031, -1.812349, -1.749258>,
      < 8.681629, -1.812349, -2.283984>
    }
    triangle {
      < 8.782664, -1.812349, -1.749258>,
      < 8.681629, -1.812349, -2.283984>,
      < 8.756263, -1.812349, -2.283984>
    }
    triangle {
      < 8.708031, -1.812349, -1.749258>,
      < 8.708031, -1.161411, -1.749258>,
      < 8.681629, -1.161411, -2.283984>
    }
    triangle {
      < 8.708031, -1.812349, -1.749258>,
      < 8.681629, -1.161411, -2.283984>,
      < 8.681629, -1.812349, -2.283984>
    }
    triangle {
      < 8.708031, -1.161411, -1.749258>,
      < 8.811947, -1.206643, -1.749258>,
      < 8.785545, -1.206643, -2.283984>
    }
    triangle {
      < 8.708031, -1.161411, -1.749258>,
      < 8.785545, -1.206643, -2.283984>,
      < 8.681629, -1.161411, -2.283984>
    }
    triangle {
      < 8.811947, -1.206643, -1.749258>,
      < 8.896017, -1.275948, -1.749258>,
      < 8.869616, -1.275948, -2.283984>
    }
    triangle {
      < 8.811947, -1.206643, -1.749258>,
      < 8.869616, -1.275948, -2.283984>,
      < 8.785545, -1.206643, -2.283984>
    }
    triangle {
      < 8.896017, -1.275948, -1.749258>,
      < 8.960240, -1.369328, -1.749258>,
      < 8.933839, -1.369328, -2.283984>
    }
    triangle {
      < 8.896017, -1.275948, -1.749258>,
      < 8.933839, -1.369328, -2.283984>,
      < 8.869616, -1.275948, -2.283984>
    }
    triangle {
      < 8.960240, -1.369328, -1.749258>,
      < 8.921911, -1.430716, -1.749258>,
      < 8.895510, -1.430716, -2.283984>
    }
    triangle {
      < 8.960240, -1.369328, -1.749258>,
      < 8.895510, -1.430716, -2.283984>,
      < 8.933839, -1.369328, -2.283984>
    }
    triangle {
      < 8.921911, -1.430716, -1.749258>,
      < 8.871784, -1.480141, -1.749258>,
      < 8.845383, -1.480141, -2.283984>
    }
    triangle {
      < 8.921911, -1.430716, -1.749258>,
      < 8.845383, -1.480141, -2.283984>,
      < 8.895510, -1.430716, -2.283984>
    }
    triangle {
      < 8.871784, -1.480141, -1.749258>,
      < 8.809862, -1.517604, -1.749258>,
      < 8.783461, -1.517604, -2.283984>
    }
    triangle {
      < 8.871784, -1.480141, -1.749258>,
      < 8.783461, -1.517604, -2.283984>,
      < 8.845383, -1.480141, -2.283984>
    }
    triangle {
      < 8.933839, -1.369328, -2.283984>,
      < 8.895510, -1.430716, -2.283984>,
      < 8.866709, -1.430716, -2.644820>
    }
    triangle {
      < 8.933839, -1.369328, -2.283984>,
      < 8.866709, -1.430716, -2.644820>,
      < 8.905038, -1.369328, -2.644820>
    }
    triangle {
      < 8.895510, -1.430716, -2.283984>,
      < 8.845383, -1.480141, -2.283984>,
      < 8.816582, -1.480141, -2.644820>
    }
    triangle {
      < 8.895510, -1.430716, -2.283984>,
      < 8.816582, -1.480141, -2.644820>,
      < 8.866709, -1.430716, -2.644820>
    }
    triangle {
      < 8.845383, -1.480141, -2.283984>,
      < 8.783461, -1.517604, -2.283984>,
      < 8.754660, -1.517604, -2.644820>
    }
    triangle {
      < 8.845383, -1.480141, -2.283984>,
      < 8.754660, -1.517604, -2.644820>,
      < 8.816582, -1.480141, -2.644820>
    }
    triangle {
      < 8.783461, -1.517604, -2.283984>,
      < 8.802705, -1.572958, -2.283984>,
      < 8.773904, -1.572958, -2.644820>
    }
    triangle {
      < 8.783461, -1.517604, -2.283984>,
      < 8.773904, -1.572958, -2.644820>,
      < 8.754660, -1.517604, -2.644820>
    }
    triangle {
      < 8.802705, -1.572958, -2.283984>,
      < 8.802705, -1.757912, -2.283984>,
      < 8.773904, -1.757912, -2.644820>
    }
    triangle {
      < 8.802705, -1.572958, -2.283984>,
      < 8.773904, -1.757912, -2.644820>,
      < 8.773904, -1.572958, -2.644820>
    }
    triangle {
      < 8.802705, -1.757912, -2.283984>,
      < 8.756263, -1.812349, -2.283984>,
      < 8.727462, -1.812349, -2.644820>
    }
    triangle {
      < 8.802705, -1.757912, -2.283984>,
      < 8.727462, -1.812349, -2.644820>,
      < 8.773904, -1.757912, -2.644820>
    }
    triangle {
      < 8.756263, -1.812349, -2.283984>,
      < 8.681629, -1.812349, -2.283984>,
      < 8.652828, -1.812349, -2.644820>
    }
    triangle {
      < 8.756263, -1.812349, -2.283984>,
      < 8.652828, -1.812349, -2.644820>,
      < 8.727462, -1.812349, -2.644820>
    }
    triangle {
      < 8.681629, -1.812349, -2.283984>,
      < 8.681629, -1.161411, -2.283984>,
      < 8.652828, -1.161411, -2.644820>
    }
    triangle {
      < 8.681629, -1.812349, -2.283984>,
      < 8.652828, -1.161411, -2.644820>,
      < 8.652828, -1.812349, -2.644820>
    }
    triangle {
      < 8.681629, -1.161411, -2.283984>,
      < 8.785545, -1.206643, -2.283984>,
      < 8.756744, -1.206643, -2.644820>
    }
    triangle {
      < 8.681629, -1.161411, -2.283984>,
      < 8.756744, -1.206643, -2.644820>,
      < 8.652828, -1.161411, -2.644820>
    }
    triangle {
      < 8.785545, -1.206643, -2.283984>,
      < 8.869616, -1.275948, -2.283984>,
      < 8.840815, -1.275948, -2.644820>
    }
    triangle {
      < 8.785545, -1.206643, -2.283984>,
      < 8.840815, -1.275948, -2.644820>,
      < 8.756744, -1.206643, -2.644820>
    }
    triangle {
      < 8.869616, -1.275948, -2.283984>,
      < 8.933839, -1.369328, -2.283984>,
      < 8.905038, -1.369328, -2.644820>
    }
    triangle {
      < 8.869616, -1.275948, -2.283984>,
      < 8.905038, -1.369328, -2.644820>,
      < 8.840815, -1.275948, -2.644820>
    }
    triangle {
      < 8.960031, -0.871843, -2.805406>,
      < 8.960067, -0.925377, -2.833609>,
      < 8.710608, -0.924472, -2.864788>
    }
    triangle {
      < 8.960031, -0.871843, -2.805406>,
      < 8.710608, -0.924472, -2.864788>,
      < 8.810135, -0.869616, -2.822642>
    }
    triangle {
      < 8.959985, -0.827876, -2.771059>,
      < 8.960031, -0.871843, -2.805406>,
      < 8.810135, -0.869616, -2.822642>
    }
    triangle {
      < 8.959985, -0.827876, -2.771059>,
      < 8.810135, -0.869616, -2.822642>,
      < 8.870067, -0.824596, -2.779849>
    }
    triangle {
      < 8.959958, -0.794904, -2.732029>,
      < 8.959985, -0.827876, -2.771059>,
      < 8.870067, -0.824596, -2.779849>
    }
    triangle {
      < 8.959958, -0.794904, -2.732029>,
      < 8.870067, -0.824596, -2.779849>,
      < 8.911533, -0.791144, -2.735415>
    }
    triangle {
      < 8.961579, -0.774074, -2.689483>,
      < 8.959958, -0.794904, -2.732029>,
      < 8.911533, -0.791144, -2.735415>
    }
    triangle {
      < 8.961579, -0.774074, -2.689483>,
      < 8.911533, -0.791144, -2.735415>,
      < 8.938994, -0.770544, -2.690178>
    }
    triangle {
      < 8.962034, -0.766628, -2.644964>,
      < 8.961579, -0.774074, -2.689483>,
      < 8.938994, -0.770544, -2.690178>
    }
    triangle {
      < 8.962034, -0.766628, -2.644964>,
      < 8.938994, -0.770544, -2.690178>,
      < 8.947385, -0.763588, -2.644964>
    }
    triangle {
      < 8.961579, -0.774073, -2.600444>,
      < 8.962034, -0.766628, -2.644964>,
      < 8.947385, -0.763588, -2.644964>
    }
    triangle {
      < 8.961579, -0.774073, -2.600444>,
      < 8.947385, -0.763588, -2.644964>,
      < 8.938996, -0.770543, -2.599750>
    }
    triangle {
      < 8.959958, -0.794904, -2.557899>,
      < 8.961579, -0.774073, -2.600444>,
      < 8.938996, -0.770543, -2.599750>
    }
    triangle {
      < 8.959958, -0.794904, -2.557899>,
      < 8.938996, -0.770543, -2.599750>,
      < 8.911533, -0.791144, -2.554512>
    }
    triangle {
      < 8.959985, -0.827876, -2.518867>,
      < 8.959958, -0.794904, -2.557899>,
      < 8.911533, -0.791144, -2.554512>
    }
    triangle {
      < 8.959985, -0.827876, -2.518867>,
      < 8.911533, -0.791144, -2.554512>,
      < 8.870067, -0.824596, -2.510077>
    }
    triangle {
      < 8.960031, -0.871843, -2.484521>,
      < 8.959985, -0.827876, -2.518867>,
      < 8.870067, -0.824596, -2.510077>
    }
    triangle {
      < 8.960031, -0.871843, -2.484521>,
      < 8.870067, -0.824596, -2.510077>,
      < 8.810135, -0.869616, -2.467286>
    }
    triangle {
      < 8.960067, -0.925376, -2.456316>,
      < 8.960031, -0.871843, -2.484521>,
      < 8.810135, -0.869616, -2.467286>
    }
    triangle {
      < 8.960067, -0.925376, -2.456316>,
      < 8.810135, -0.869616, -2.467286>,
      < 8.710608, -0.924472, -2.425141>
    }
    triangle {
      < 8.870067, -0.824596, -2.779849>,
      < 8.810135, -0.869616, -2.822642>,
      < 8.758994, -0.839533, -2.819914>
    }
    triangle {
      < 8.870067, -0.824596, -2.779849>,
      < 8.758994, -0.839533, -2.819914>,
      < 8.820998, -0.798488, -2.777042>
    }
    triangle {
      < 8.911533, -0.791144, -2.735415>,
      < 8.870067, -0.824596, -2.779849>,
      < 8.820998, -0.798488, -2.777042>
    }
    triangle {
      < 8.911533, -0.791144, -2.735415>,
      < 8.820998, -0.798488, -2.777042>,
      < 8.863870, -0.768167, -2.732650>
    }
    triangle {
      < 8.938994, -0.770544, -2.690178>,
      < 8.911533, -0.791144, -2.735415>,
      < 8.863870, -0.768167, -2.732650>
    }
    triangle {
      < 8.938994, -0.770544, -2.690178>,
      < 8.863870, -0.768167, -2.732650>,
      < 8.891808, -0.749990, -2.688238>
    }
    triangle {
      < 8.947385, -0.763588, -2.644964>,
      < 8.938994, -0.770544, -2.690178>,
      < 8.891808, -0.749990, -2.688238>
    }
    triangle {
      < 8.947385, -0.763588, -2.644964>,
      < 8.891808, -0.749990, -2.688238>,
      < 8.900198, -0.744032, -2.644964>
    }
    triangle {
      < 8.710608, -0.924472, -2.425141>,
      < 8.810135, -0.869616, -2.467286>,
      < 8.758994, -0.839533, -2.470015>
    }
    triangle {
      < 8.710608, -0.924472, -2.425141>,
      < 8.758994, -0.839533, -2.470015>,
      < 8.651061, -0.887410, -2.425891>
    }
    triangle {
      < 8.938996, -0.770543, -2.599750>,
      < 8.947385, -0.763588, -2.644964>,
      < 8.900198, -0.744032, -2.644964>
    }
    triangle {
      < 8.938996, -0.770543, -2.599750>,
      < 8.900198, -0.744032, -2.644964>,
      < 8.891810, -0.749989, -2.601691>
    }
    triangle {
      < 8.911533, -0.791144, -2.554512>,
      < 8.938996, -0.770543, -2.599750>,
      < 8.891810, -0.749989, -2.601691>
    }
    triangle {
      < 8.911533, -0.791144, -2.554512>,
      < 8.891810, -0.749989, -2.601691>,
      < 8.863870, -0.768167, -2.557280>
    }
    triangle {
      < 8.870067, -0.824596, -2.510077>,
      < 8.911533, -0.791144, -2.554512>,
      < 8.863870, -0.768167, -2.557280>
    }
    triangle {
      < 8.870067, -0.824596, -2.510077>,
      < 8.863870, -0.768167, -2.557280>,
      < 8.820999, -0.798489, -2.512886>
    }
    triangle {
      < 8.810135, -0.869616, -2.467286>,
      < 8.870067, -0.824596, -2.510077>,
      < 8.820999, -0.798489, -2.512886>
    }
    triangle {
      < 8.810135, -0.869616, -2.467286>,
      < 8.820999, -0.798489, -2.512886>,
      < 8.758994, -0.839533, -2.470015>
    }
    triangle {
      < 8.646952, -0.889233, -2.865721>,
      < 8.758994, -0.839533, -2.819914>,
      < 8.810135, -0.869616, -2.822642>
    }
    triangle {
      < 8.646952, -0.889233, -2.865721>,
      < 8.810135, -0.869616, -2.822642>,
      < 8.710608, -0.924472, -2.864788>
    }
    triangle {
      < 8.717892, -0.792896, -2.455984>,
      < 8.782832, -0.750068, -2.501101>,
      < 8.824248, -0.614106, -2.525269>
    }
    triangle {
      < 8.717892, -0.792896, -2.455984>,
      < 8.824248, -0.614106, -2.525269>,
      < 8.797588, -0.614102, -2.484731>
    }
    triangle {
      < 8.782832, -0.750068, -2.501101>,
      < 8.829806, -0.718244, -2.548278>,
      < 8.839004, -0.614109, -2.564248>
    }
    triangle {
      < 8.782832, -0.750068, -2.501101>,
      < 8.839004, -0.614109, -2.564248>,
      < 8.824248, -0.614106, -2.525269>
    }
    triangle {
      < 8.829806, -0.718244, -2.548278>,
      < 8.858260, -0.698646, -2.596554>,
      < 8.845336, -0.614110, -2.603681>
    }
    triangle {
      < 8.829806, -0.718244, -2.548278>,
      < 8.845336, -0.614110, -2.603681>,
      < 8.839004, -0.614109, -2.564248>
    }
    triangle {
      < 8.860164, -0.614110, -2.623175>,
      < 8.877425, -0.695338, -2.620759>,
      < 8.882192, -0.692030, -2.644964>
    }
    triangle {
      < 8.860164, -0.614110, -2.623175>,
      < 8.882192, -0.692030, -2.644964>,
      < 8.860591, -0.614110, -2.642669>
    }
    triangle {
      < 8.882192, -0.692030, -2.644964>,
      < 8.877424, -0.695338, -2.669169>,
      < 8.857497, -0.614110, -2.661916>
    }
    triangle {
      < 8.882192, -0.692030, -2.644964>,
      < 8.857497, -0.614110, -2.661916>,
      < 8.860591, -0.614110, -2.642669>
    }
    triangle {
      < 8.858257, -0.698647, -2.693374>,
      < 8.829806, -0.718244, -2.741650>,
      < 8.828353, -0.614108, -2.718993>
    }
    triangle {
      < 8.858257, -0.698647, -2.693374>,
      < 8.828353, -0.614108, -2.718993>,
      < 8.840004, -0.614110, -2.681164>
    }
    triangle {
      < 8.829806, -0.718244, -2.741650>,
      < 8.782831, -0.750068, -2.788826>,
      < 8.808414, -0.614105, -2.755522>
    }
    triangle {
      < 8.829806, -0.718244, -2.741650>,
      < 8.808414, -0.614105, -2.755522>,
      < 8.828353, -0.614108, -2.718993>
    }
    triangle {
      < 8.782831, -0.750068, -2.788826>,
      < 8.717892, -0.792896, -2.833944>,
      < 8.774693, -0.614101, -2.793777>
    }
    triangle {
      < 8.782831, -0.750068, -2.788826>,
      < 8.774693, -0.614101, -2.793777>,
      < 8.808414, -0.614105, -2.755522>
    }
    triangle {
      < 8.820998, -0.798488, -2.777042>,
      < 8.758994, -0.839533, -2.819914>,
      < 8.717892, -0.792896, -2.833944>
    }
    triangle {
      < 8.820998, -0.798488, -2.777042>,
      < 8.717892, -0.792896, -2.833944>,
      < 8.782831, -0.750068, -2.788826>
    }
    triangle {
      < 8.863870, -0.768167, -2.732650>,
      < 8.820998, -0.798488, -2.777042>,
      < 8.782831, -0.750068, -2.788826>
    }
    triangle {
      < 8.863870, -0.768167, -2.732650>,
      < 8.782831, -0.750068, -2.788826>,
      < 8.829806, -0.718244, -2.741650>
    }
    triangle {
      < 8.891808, -0.749990, -2.688238>,
      < 8.863870, -0.768167, -2.732650>,
      < 8.829806, -0.718244, -2.741650>
    }
    triangle {
      < 8.891808, -0.749990, -2.688238>,
      < 8.829806, -0.718244, -2.741650>,
      < 8.858257, -0.698647, -2.693374>
    }
    triangle {
      < 8.900198, -0.744032, -2.644964>,
      < 8.877424, -0.695338, -2.669169>,
      < 8.882192, -0.692030, -2.644964>
    }
    triangle {
      < 8.877425, -0.695338, -2.620759>,
      < 8.900198, -0.744032, -2.644964>,
      < 8.882192, -0.692030, -2.644964>
    }
    triangle {
      < 8.863870, -0.768167, -2.557280>,
      < 8.891810, -0.749989, -2.601691>,
      < 8.858260, -0.698646, -2.596554>
    }
    triangle {
      < 8.863870, -0.768167, -2.557280>,
      < 8.858260, -0.698646, -2.596554>,
      < 8.829806, -0.718244, -2.548278>
    }
    triangle {
      < 8.820999, -0.798489, -2.512886>,
      < 8.863870, -0.768167, -2.557280>,
      < 8.829806, -0.718244, -2.548278>
    }
    triangle {
      < 8.820999, -0.798489, -2.512886>,
      < 8.829806, -0.718244, -2.548278>,
      < 8.782832, -0.750068, -2.501101>
    }
    triangle {
      < 8.758994, -0.839533, -2.470015>,
      < 8.820999, -0.798489, -2.512886>,
      < 8.782832, -0.750068, -2.501101>
    }
    triangle {
      < 8.758994, -0.839533, -2.470015>,
      < 8.782832, -0.750068, -2.501101>,
      < 8.717892, -0.792896, -2.455984>
    }
    triangle {
      < 8.877425, -0.695338, -2.620759>,
      < 8.860164, -0.614110, -2.623175>,
      < 8.845336, -0.614110, -2.603681>
    }
    triangle {
      < 8.877425, -0.695338, -2.620759>,
      < 8.845336, -0.614110, -2.603681>,
      < 8.858260, -0.698646, -2.596554>
    }
    triangle {
      < 8.900198, -0.744032, -2.644964>,
      < 8.877425, -0.695338, -2.620759>,
      < 8.858260, -0.698646, -2.596554>
    }
    triangle {
      < 8.900198, -0.744032, -2.644964>,
      < 8.858260, -0.698646, -2.596554>,
      < 8.891810, -0.749989, -2.601691>
    }
    triangle {
      < 8.877424, -0.695338, -2.669169>,
      < 8.900198, -0.744032, -2.644964>,
      < 8.891808, -0.749990, -2.688238>
    }
    triangle {
      < 8.877424, -0.695338, -2.669169>,
      < 8.891808, -0.749990, -2.688238>,
      < 8.858257, -0.698647, -2.693374>
    }
    triangle {
      < 8.857497, -0.614110, -2.661916>,
      < 8.877424, -0.695338, -2.669169>,
      < 8.858257, -0.698647, -2.693374>
    }
    triangle {
      < 8.857497, -0.614110, -2.661916>,
      < 8.858257, -0.698647, -2.693374>,
      < 8.840004, -0.614110, -2.681164>
    }
    triangle {
      < 8.651061, -0.887410, -2.425891>,
      < 8.649097, -0.944318, -2.417719>,
      < 8.710608, -0.924472, -2.425141>
    }
    triangle {
      < 8.518878, -0.977744, -2.897499>,
      < 8.555034, -0.908087, -2.884316>,
      < 8.646952, -0.889233, -2.865721>
    }
    triangle {
      < 8.518878, -0.977744, -2.897499>,
      < 8.646952, -0.889233, -2.865721>,
      < 8.710608, -0.924472, -2.864788>
    }
    triangle {
      < 8.555034, -0.908087, -2.884316>,
      < 8.580131, -0.859736, -2.875572>,
      < 8.646952, -0.889233, -2.865721>
    }
    triangle {
      < 8.580131, -0.859736, -2.875572>,
      < 8.595420, -0.830281, -2.867272>,
      < 8.717892, -0.792896, -2.833944>
    }
    triangle {
      < 8.580131, -0.859736, -2.875572>,
      < 8.717892, -0.792896, -2.833944>,
      < 8.758994, -0.839533, -2.819914>
    }
    triangle {
      < 8.580131, -0.859736, -2.875572>,
      < 8.758994, -0.839533, -2.819914>,
      < 8.646952, -0.889233, -2.865721>
    }
    triangle {
      < 8.717892, -0.792896, -2.455984>,
      < 8.651061, -0.887410, -2.425891>,
      < 8.758994, -0.839533, -2.470015>
    }
    triangle {
      < 8.595420, -0.830281, -2.867272>,
      < 8.707627, -0.614107, -2.823626>,
      < 8.774693, -0.614101, -2.793777>
    }
    triangle {
      < 8.595420, -0.830281, -2.867272>,
      < 8.774693, -0.614101, -2.793777>,
      < 8.717892, -0.792896, -2.833944>
    }
    triangle {
      < 8.840004, -0.614110, -2.681164>,
      < 8.845336, -0.614110, -2.603681>,
      < 8.860164, -0.614110, -2.623175>
    }
    triangle {
      < 8.840004, -0.614110, -2.681164>,
      < 8.860164, -0.614110, -2.623175>,
      < 8.860591, -0.614110, -2.642669>
    }
    triangle {
      < 8.840004, -0.614110, -2.681164>,
      < 8.860591, -0.614110, -2.642669>,
      < 8.857497, -0.614110, -2.661916>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.717892, -0.792896, -2.455984>,
      < 8.797588, -0.614102, -2.484731>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.797588, -0.614102, -2.484731>,
      < 8.751030, -0.614104, -2.469737>
    }
    triangle {
      < 8.960083, -0.986465, -2.435430>,
      < 8.960067, -0.925376, -2.456316>,
      < 8.710608, -0.924472, -2.425141>
    }
    triangle {
      < 8.960083, -0.986465, -2.435430>,
      < 8.710608, -0.924472, -2.425141>,
      < 8.649097, -0.944318, -2.417719>
    }
    triangle {
      < 8.960083, -0.986465, -2.435430>,
      < 8.649097, -0.944318, -2.417719>,
      < 8.646121, -0.987057, -2.401382>
    }
    triangle {
      < 8.960067, -0.925377, -2.833609>,
      < 8.960083, -0.986467, -2.854493>,
      < 8.512607, -0.987057, -2.904079>
    }
    triangle {
      < 8.960067, -0.925377, -2.833609>,
      < 8.512607, -0.987057, -2.904079>,
      < 8.518878, -0.977744, -2.897499>
    }
    triangle {
      < 8.960067, -0.925377, -2.833609>,
      < 8.518878, -0.977744, -2.897499>,
      < 8.710608, -0.924472, -2.864788>
    }
    triangle {
      < 8.959940, -1.076448, -2.718238>,
      < 8.959966, -1.072025, -2.644964>,
      < 8.469930, -1.072046, -2.644964>
    }
    triangle {
      < 8.959940, -1.076448, -2.718238>,
      < 8.469930, -1.072046, -2.644964>,
      < 8.467582, -1.076569, -2.737815>
    }
    triangle {
      < 8.959966, -1.072025, -2.644964>,
      < 8.959940, -1.076448, -2.571689>,
      < 8.467582, -1.076569, -2.552113>
    }
    triangle {
      < 8.959966, -1.072025, -2.644964>,
      < 8.467582, -1.076569, -2.552113>,
      < 8.469930, -1.072046, -2.644964>
    }
    triangle {
      < 8.959700, -1.122828, -2.870239>,
      < 8.959952, -1.092693, -2.791599>,
      < 8.459005, -1.093092, -2.830714>
    }
    triangle {
      < 8.959700, -1.122828, -2.870239>,
      < 8.459005, -1.093092, -2.830714>,
      < 8.444201, -1.121615, -2.926036>
    }
    triangle {
      < 8.959952, -1.092693, -2.791599>,
      < 8.959940, -1.076448, -2.718238>,
      < 8.467582, -1.076569, -2.737815>
    }
    triangle {
      < 8.959952, -1.092693, -2.791599>,
      < 8.467582, -1.076569, -2.737815>,
      < 8.459005, -1.093092, -2.830714>
    }
    triangle {
      < 8.959940, -1.076448, -2.571689>,
      < 8.959952, -1.092699, -2.498330>,
      < 8.459005, -1.093092, -2.459214>
    }
    triangle {
      < 8.959940, -1.076448, -2.571689>,
      < 8.459005, -1.093092, -2.459214>,
      < 8.467582, -1.076569, -2.552113>
    }
    triangle {
      < 8.959952, -1.092699, -2.498330>,
      < 8.959701, -1.122852, -2.419671>,
      < 8.644594, -1.121615, -2.386132>
    }
    triangle {
      < 8.959952, -1.092699, -2.498330>,
      < 8.644594, -1.121615, -2.386132>,
      < 8.459005, -1.093092, -2.459214>
    }
    triangle {
      < 8.960089, -1.052727, -2.867323>,
      < 8.959700, -1.122828, -2.870239>,
      < 8.444201, -1.121615, -2.926036>
    }
    triangle {
      < 8.960089, -1.052727, -2.867323>,
      < 8.444201, -1.121615, -2.926036>,
      < 8.479073, -1.053018, -2.920353>
    }
    triangle {
      < 8.960083, -0.986467, -2.854493>,
      < 8.960089, -1.052727, -2.867323>,
      < 8.479073, -1.053018, -2.920353>
    }
    triangle {
      < 8.960083, -0.986467, -2.854493>,
      < 8.479073, -1.053018, -2.920353>,
      < 8.512607, -0.987057, -2.904079>
    }
    triangle {
      < 8.960090, -1.052727, -2.422608>,
      < 8.960083, -0.986465, -2.435430>,
      < 8.646121, -0.987057, -2.401382>
    }
    triangle {
      < 8.960090, -1.052727, -2.422608>,
      < 8.646121, -0.987057, -2.401382>,
      < 8.643591, -1.053018, -2.388639>
    }
    triangle {
      < 8.959701, -1.122852, -2.419671>,
      < 8.960090, -1.052727, -2.422608>,
      < 8.643591, -1.053018, -2.388639>
    }
    triangle {
      < 8.959701, -1.122852, -2.419671>,
      < 8.643591, -1.053018, -2.388639>,
      < 8.644594, -1.121615, -2.386132>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.751030, -0.614104, -2.469737>,
      < 8.707627, -0.614107, -2.823626>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.707627, -0.614107, -2.823626>,
      < 8.595420, -0.830281, -2.867272>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.595420, -0.830281, -2.867272>,
      < 8.580131, -0.859736, -2.875572>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.580131, -0.859736, -2.875572>,
      < 8.555034, -0.908087, -2.884316>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.555034, -0.908087, -2.884316>,
      < 8.518878, -0.977744, -2.897499>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.518878, -0.977744, -2.897499>,
      < 8.512607, -0.987057, -2.904079>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.512607, -0.987057, -2.904079>,
      < 8.479073, -1.053018, -2.920353>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.479073, -1.053018, -2.920353>,
      < 8.444201, -1.121615, -2.926036>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.444201, -1.121615, -2.926036>,
      < 8.459005, -1.093092, -2.830714>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.459005, -1.093092, -2.830714>,
      < 8.467582, -1.076569, -2.737815>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.467582, -1.076569, -2.737815>,
      < 8.469930, -1.072046, -2.644964>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.469930, -1.072046, -2.644964>,
      < 8.467582, -1.076569, -2.552113>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.467582, -1.076569, -2.552113>,
      < 8.459005, -1.093092, -2.459214>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.459005, -1.093092, -2.459214>,
      < 8.644594, -1.121615, -2.386132>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.644594, -1.121615, -2.386132>,
      < 8.643591, -1.053018, -2.388639>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.643591, -1.053018, -2.388639>,
      < 8.646121, -0.987057, -2.401382>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.646121, -0.987057, -2.401382>,
      < 8.649097, -0.944318, -2.417719>
    }
    triangle {
      < 8.679832, -0.804513, -2.445628>,
      < 8.649097, -0.944318, -2.417719>,
      < 8.651061, -0.887410, -2.425891>
    }
    triangle {
      < 8.651061, -0.887410, -2.425891>,
      < 8.717892, -0.792896, -2.455984>,
      < 8.679832, -0.804513, -2.445628>
    }
    triangle {
      < 8.824248, -0.614106, -2.525269>,
      < 8.808414, -0.614105, -2.755522>,
      < 8.774693, -0.614101, -2.793777>
    }
    triangle {
      < 8.824248, -0.614106, -2.525269>,
      < 8.774693, -0.614101, -2.793777>,
      < 8.797588, -0.614102, -2.484731>
    }
    triangle {
      < 8.808414, -0.614105, -2.755522>,
      < 8.824248, -0.614106, -2.525269>,
      < 8.839004, -0.614109, -2.564248>
    }
    triangle {
      < 8.808414, -0.614105, -2.755522>,
      < 8.839004, -0.614109, -2.564248>,
      < 8.845336, -0.614110, -2.603681>
    }
    triangle {
      < 8.808414, -0.614105, -2.755522>,
      < 8.845336, -0.614110, -2.603681>,
      < 8.840004, -0.614110, -2.681164>
    }
    triangle {
      < 8.808414, -0.614105, -2.755522>,
      < 8.840004, -0.614110, -2.681164>,
      < 8.828353, -0.614108, -2.718993>
    }
    triangle {
      < 8.797588, -0.614102, -2.484731>,
      < 8.774693, -0.614101, -2.793777>,
      < 8.707627, -0.614107, -2.823626>
    }
    triangle {
      < 8.797588, -0.614102, -2.484731>,
      < 8.707627, -0.614107, -2.823626>,
      < 8.751030, -0.614104, -2.469737>
    }
    triangle {
      < 8.965602, -1.066637, -2.719638>,
      < 8.980003, -1.076569, -2.718220>,
      < 8.980003, -1.093092, -2.791477>
    }
    triangle {
      < 8.965602, -1.066637, -2.719638>,
      < 8.980003, -1.093092, -2.791477>,
      < 8.965602, -1.083502, -2.794408>
    }
    triangle {
      < 8.980003, -1.076569, -2.718220>,
      < 8.959940, -1.076448, -2.718238>,
      < 8.959952, -1.092693, -2.791599>
    }
    triangle {
      < 8.980003, -1.076569, -2.718220>,
      < 8.959952, -1.092693, -2.791599>,
      < 8.980003, -1.093092, -2.791477>
    }
    triangle {
      < 8.965602, -1.083502, -2.794408>,
      < 8.980003, -1.093092, -2.791477>,
      < 8.980003, -1.121615, -2.864734>
    }
    triangle {
      < 8.965602, -1.083502, -2.794408>,
      < 8.980003, -1.121615, -2.864734>,
      < 8.965602, -1.106616, -2.853772>
    }
    triangle {
      < 8.980003, -1.093092, -2.791477>,
      < 8.959952, -1.092693, -2.791599>,
      < 8.959700, -1.122828, -2.870239>
    }
    triangle {
      < 8.980003, -1.093092, -2.791477>,
      < 8.959700, -1.122828, -2.870239>,
      < 8.980003, -1.121615, -2.864734>
    }
    triangle {
      < 8.965602, -1.106616, -2.853772>,
      < 8.980003, -1.121615, -2.864734>,
      < 8.980003, -1.054430, -2.860515>
    }
    triangle {
      < 8.965602, -1.106616, -2.853772>,
      < 8.980003, -1.054430, -2.860515>,
      < 8.965602, -1.055699, -2.850575>
    }
    triangle {
      < 8.980003, -1.121615, -2.864734>,
      < 8.959700, -1.122828, -2.870239>,
      < 8.960089, -1.052727, -2.867323>
    }
    triangle {
      < 8.980003, -1.121615, -2.864734>,
      < 8.960089, -1.052727, -2.867323>,
      < 8.980003, -1.054430, -2.860515>
    }
    triangle {
      < 8.965602, -1.055699, -2.850575>,
      < 8.980003, -1.054430, -2.860515>,
      < 8.980003, -0.989826, -2.848006>
    }
    triangle {
      < 8.965602, -1.055699, -2.850575>,
      < 8.980003, -0.989826, -2.848006>,
      < 8.965602, -0.992403, -2.838320>
    }
    triangle {
      < 8.980003, -1.054430, -2.860515>,
      < 8.960089, -1.052727, -2.867323>,
      < 8.960083, -0.986467, -2.854493>
    }
    triangle {
      < 8.980003, -1.054430, -2.860515>,
      < 8.960083, -0.986467, -2.854493>,
      < 8.980003, -0.989826, -2.848006>
    }
    triangle {
      < 8.965602, -0.992403, -2.838320>,
      < 8.980003, -0.989826, -2.848006>,
      < 8.980003, -0.930287, -2.827697>
    }
    triangle {
      < 8.965602, -0.992403, -2.838320>,
      < 8.980003, -0.930287, -2.827697>,
      < 8.965602, -0.934245, -2.818481>
    }
    triangle {
      < 8.980003, -0.989826, -2.848006>,
      < 8.960083, -0.986467, -2.854493>,
      < 8.960067, -0.925377, -2.833609>
    }
    triangle {
      < 8.980003, -0.989826, -2.848006>,
      < 8.960067, -0.925377, -2.833609>,
      < 8.980003, -0.930287, -2.827697>
    }
    triangle {
      < 8.965602, -0.934245, -2.818481>,
      < 8.980003, -0.930287, -2.827697>,
      < 8.980003, -0.878102, -2.800366>
    }
    triangle {
      < 8.965602, -0.934245, -2.818481>,
      < 8.980003, -0.878102, -2.800366>,
      < 8.965602, -0.883534, -2.791922>
    }
    triangle {
      < 8.980003, -0.930287, -2.827697>,
      < 8.960067, -0.925377, -2.833609>,
      < 8.960031, -0.871843, -2.805406>
    }
    triangle {
      < 8.980003, -0.930287, -2.827697>,
      < 8.960031, -0.871843, -2.805406>,
      < 8.980003, -0.878102, -2.800366>
    }
    triangle {
      < 8.965602, -0.883534, -2.791922>,
      < 8.980003, -0.878102, -2.800366>,
      < 8.980003, -0.835274, -2.767061>
    }
    triangle {
      < 8.965602, -0.883534, -2.791922>,
      < 8.980003, -0.835274, -2.767061>,
      < 8.965602, -0.842255, -2.759822>
    }
    triangle {
      < 8.980003, -0.878102, -2.800366>,
      < 8.960031, -0.871843, -2.805406>,
      < 8.959985, -0.827876, -2.771059>
    }
    triangle {
      < 8.980003, -0.878102, -2.800366>,
      < 8.959985, -0.827876, -2.771059>,
      < 8.980003, -0.835274, -2.767061>
    }
    triangle {
      < 8.965602, -0.842255, -2.759822>,
      < 8.980003, -0.835274, -2.767061>,
      < 8.980003, -0.803450, -2.729068>
    }
    triangle {
      < 8.965602, -0.842255, -2.759822>,
      < 8.980003, -0.803450, -2.729068>,
      < 8.965602, -0.811934, -2.723623>
    }
    triangle {
      < 8.980003, -0.835274, -2.767061>,
      < 8.959985, -0.827876, -2.771059>,
      < 8.959958, -0.794904, -2.732029>
    }
    triangle {
      < 8.980003, -0.835274, -2.767061>,
      < 8.959958, -0.794904, -2.732029>,
      < 8.980003, -0.803450, -2.729068>
    }
    triangle {
      < 8.965602, -0.811934, -2.723623>,
      < 8.980003, -0.803450, -2.729068>,
      < 8.980003, -0.783853, -2.687839>
    }
    triangle {
      < 8.965602, -0.811934, -2.723623>,
      < 8.980003, -0.783853, -2.687839>,
      < 8.965602, -0.793512, -2.684868>
    }
    triangle {
      < 8.980003, -0.803450, -2.729068>,
      < 8.959958, -0.794904, -2.732029>,
      < 8.961579, -0.774074, -2.689483>
    }
    triangle {
      < 8.980003, -0.803450, -2.729068>,
      < 8.961579, -0.774074, -2.689483>,
      < 8.980003, -0.783853, -2.687839>
    }
    triangle {
      < 8.965602, -0.793512, -2.684868>,
      < 8.980003, -0.783853, -2.687839>,
      < 8.980003, -0.777236, -2.644964>
    }
    triangle {
      < 8.965602, -0.793512, -2.684868>,
      < 8.980003, -0.777236, -2.644964>,
      < 8.965602, -0.787354, -2.644964>
    }
    triangle {
      < 8.980003, -0.783853, -2.687839>,
      < 8.961579, -0.774074, -2.689483>,
      < 8.962034, -0.766628, -2.644964>
    }
    triangle {
      < 8.980003, -0.783853, -2.687839>,
      < 8.962034, -0.766628, -2.644964>,
      < 8.980003, -0.777236, -2.644964>
    }
    triangle {
      < 8.965602, -0.787354, -2.644964>,
      < 8.965602, -0.793512, -2.605060>,
      < 8.941601, -0.803172, -2.608031>
    }
    triangle {
      < 8.965602, -0.787354, -2.644964>,
      < 8.941601, -0.803172, -2.608031>,
      < 8.941601, -0.797472, -2.644964>
    }
    triangle {
      < 8.980003, -0.777236, -2.644964>,
      < 8.962034, -0.766628, -2.644964>,
      < 8.961579, -0.774073, -2.600444>
    }
    triangle {
      < 8.980003, -0.777236, -2.644964>,
      < 8.961579, -0.774073, -2.600444>,
      < 8.980003, -0.783852, -2.602088>
    }
    triangle {
      < 8.965602, -0.793512, -2.605060>,
      < 8.980003, -0.783852, -2.602088>,
      < 8.980003, -0.803450, -2.560860>
    }
    triangle {
      < 8.965602, -0.793512, -2.605060>,
      < 8.980003, -0.803450, -2.560860>,
      < 8.965602, -0.811934, -2.566304>
    }
    triangle {
      < 8.980003, -0.783852, -2.602088>,
      < 8.961579, -0.774073, -2.600444>,
      < 8.959958, -0.794904, -2.557899>
    }
    triangle {
      < 8.980003, -0.783852, -2.602088>,
      < 8.959958, -0.794904, -2.557899>,
      < 8.980003, -0.803450, -2.560860>
    }
    triangle {
      < 8.965602, -0.811934, -2.566304>,
      < 8.980003, -0.803450, -2.560860>,
      < 8.980003, -0.835274, -2.522865>
    }
    triangle {
      < 8.965602, -0.811934, -2.566304>,
      < 8.980003, -0.835274, -2.522865>,
      < 8.965602, -0.842255, -2.530104>
    }
    triangle {
      < 8.980003, -0.803450, -2.560860>,
      < 8.959958, -0.794904, -2.557899>,
      < 8.959985, -0.827876, -2.518867>
    }
    triangle {
      < 8.980003, -0.803450, -2.560860>,
      < 8.959985, -0.827876, -2.518867>,
      < 8.980003, -0.835274, -2.522865>
    }
    triangle {
      < 8.965602, -0.842255, -2.530104>,
      < 8.980003, -0.835274, -2.522865>,
      < 8.980003, -0.878102, -2.489562>
    }
    triangle {
      < 8.965602, -0.842255, -2.530104>,
      < 8.980003, -0.878102, -2.489562>,
      < 8.965602, -0.883534, -2.498005>
    }
    triangle {
      < 8.980003, -0.835274, -2.522865>,
      < 8.959985, -0.827876, -2.518867>,
      < 8.960031, -0.871843, -2.484521>
    }
    triangle {
      < 8.980003, -0.835274, -2.522865>,
      < 8.960031, -0.871843, -2.484521>,
      < 8.980003, -0.878102, -2.489562>
    }
    triangle {
      < 8.965602, -0.883534, -2.498005>,
      < 8.980003, -0.878102, -2.489562>,
      < 8.980003, -0.930287, -2.462231>
    }
    triangle {
      < 8.965602, -0.883534, -2.498005>,
      < 8.980003, -0.930287, -2.462231>,
      < 8.965602, -0.934245, -2.471447>
    }
    triangle {
      < 8.980003, -0.878102, -2.489562>,
      < 8.960031, -0.871843, -2.484521>,
      < 8.960067, -0.925376, -2.456316>
    }
    triangle {
      < 8.980003, -0.878102, -2.489562>,
      < 8.960067, -0.925376, -2.456316>,
      < 8.980003, -0.930287, -2.462231>
    }
    triangle {
      < 8.965602, -0.934245, -2.471447>,
      < 8.980003, -0.930287, -2.462231>,
      < 8.980003, -0.989826, -2.441921>
    }
    triangle {
      < 8.965602, -0.934245, -2.471447>,
      < 8.980003, -0.989826, -2.441921>,
      < 8.965602, -0.992403, -2.451608>
    }
    triangle {
      < 8.980003, -0.930287, -2.462231>,
      < 8.960067, -0.925376, -2.456316>,
      < 8.960083, -0.986465, -2.435430>
    }
    triangle {
      < 8.980003, -0.930287, -2.462231>,
      < 8.960083, -0.986465, -2.435430>,
      < 8.980003, -0.989826, -2.441921>
    }
    triangle {
      < 8.965602, -0.992403, -2.451608>,
      < 8.980003, -0.989826, -2.441921>,
      < 8.980003, -1.054430, -2.429415>
    }
    triangle {
      < 8.965602, -0.992403, -2.451608>,
      < 8.980003, -1.054430, -2.429415>,
      < 8.965602, -1.055699, -2.439355>
    }
    triangle {
      < 8.980003, -0.989826, -2.441921>,
      < 8.960083, -0.986465, -2.435430>,
      < 8.960090, -1.052727, -2.422608>
    }
    triangle {
      < 8.980003, -0.989826, -2.441921>,
      < 8.960090, -1.052727, -2.422608>,
      < 8.980003, -1.054430, -2.429415>
    }
    triangle {
      < 8.965602, -1.055699, -2.439355>,
      < 8.980003, -1.054430, -2.429415>,
      < 8.980003, -1.121615, -2.425193>
    }
    triangle {
      < 8.965602, -1.055699, -2.439355>,
      < 8.980003, -1.121615, -2.425193>,
      < 8.965602, -1.106615, -2.436155>
    }
    triangle {
      < 8.980003, -1.054430, -2.429415>,
      < 8.960090, -1.052727, -2.422608>,
      < 8.959701, -1.122852, -2.419671>
    }
    triangle {
      < 8.980003, -1.054430, -2.429415>,
      < 8.959701, -1.122852, -2.419671>,
      < 8.980003, -1.121615, -2.425193>
    }
    triangle {
      < 8.965602, -1.106615, -2.436155>,
      < 8.980003, -1.121615, -2.425193>,
      < 8.980003, -1.093092, -2.498450>
    }
    triangle {
      < 8.965602, -1.106615, -2.436155>,
      < 8.980003, -1.093092, -2.498450>,
      < 8.965602, -1.083502, -2.495519>
    }
    triangle {
      < 8.980003, -1.121615, -2.425193>,
      < 8.959701, -1.122852, -2.419671>,
      < 8.959952, -1.092699, -2.498330>
    }
    triangle {
      < 8.980003, -1.121615, -2.425193>,
      < 8.959952, -1.092699, -2.498330>,
      < 8.980003, -1.093092, -2.498450>
    }
    triangle {
      < 8.965602, -1.083502, -2.495519>,
      < 8.980003, -1.093092, -2.498450>,
      < 8.980003, -1.076569, -2.571707>
    }
    triangle {
      < 8.965602, -1.083502, -2.495519>,
      < 8.980003, -1.076569, -2.571707>,
      < 8.965602, -1.066637, -2.570289>
    }
    triangle {
      < 8.980003, -1.093092, -2.498450>,
      < 8.959952, -1.092699, -2.498330>,
      < 8.959940, -1.076448, -2.571689>
    }
    triangle {
      < 8.980003, -1.093092, -2.498450>,
      < 8.959940, -1.076448, -2.571689>,
      < 8.980003, -1.076569, -2.571707>
    }
    triangle {
      < 8.965602, -1.066637, -2.570289>,
      < 8.980003, -1.076569, -2.571707>,
      < 8.980003, -1.072046, -2.644964>
    }
    triangle {
      < 8.965602, -1.066637, -2.570289>,
      < 8.980003, -1.072046, -2.644964>,
      < 8.965602, -1.062027, -2.644964>
    }
    triangle {
      < 8.980003, -1.076569, -2.571707>,
      < 8.959940, -1.076448, -2.571689>,
      < 8.959966, -1.072025, -2.644964>
    }
    triangle {
      < 8.980003, -1.076569, -2.571707>,
      < 8.959966, -1.072025, -2.644964>,
      < 8.980003, -1.072046, -2.644964>
    }
    triangle {
      < 8.965602, -1.062027, -2.644964>,
      < 8.980003, -1.072046, -2.644964>,
      < 8.980003, -1.076569, -2.718220>
    }
    triangle {
      < 8.965602, -1.062027, -2.644964>,
      < 8.980003, -1.076569, -2.718220>,
      < 8.965602, -1.066637, -2.719638>
    }
    triangle {
      < 8.980003, -1.072046, -2.644964>,
      < 8.959966, -1.072025, -2.644964>,
      < 8.959940, -1.076448, -2.718238>
    }
    triangle {
      < 8.980003, -1.072046, -2.644964>,
      < 8.959940, -1.076448, -2.718238>,
      < 8.980003, -1.076569, -2.718220>
    }
    triangle {
      < 8.965602, -0.793512, -2.684868>,
      < 8.965602, -0.787354, -2.644964>,
      < 8.941601, -0.797472, -2.644964>
    }
    triangle {
      < 8.965602, -0.793512, -2.684868>,
      < 8.941601, -0.797472, -2.644964>,
      < 8.941601, -0.803172, -2.681896>
    }
    triangle {
      < 8.965602, -0.811934, -2.723623>,
      < 8.965602, -0.793512, -2.684868>,
      < 8.941601, -0.803172, -2.681896>
    }
    triangle {
      < 8.965602, -0.811934, -2.723623>,
      < 8.941601, -0.803172, -2.681896>,
      < 8.941601, -0.820418, -2.718179>
    }
    triangle {
      < 8.965602, -0.842255, -2.759822>,
      < 8.965602, -0.811934, -2.723623>,
      < 8.941601, -0.820418, -2.718179>
    }
    triangle {
      < 8.965602, -0.842255, -2.759822>,
      < 8.941601, -0.820418, -2.718179>,
      < 8.941601, -0.849236, -2.752583>
    }
    triangle {
      < 8.965602, -0.883534, -2.791922>,
      < 8.965602, -0.842255, -2.759822>,
      < 8.941601, -0.849236, -2.752583>
    }
    triangle {
      < 8.965602, -0.883534, -2.791922>,
      < 8.941601, -0.849236, -2.752583>,
      < 8.941601, -0.888966, -2.783479>
    }
    triangle {
      < 8.965602, -0.934245, -2.818481>,
      < 8.965602, -0.883534, -2.791922>,
      < 8.941601, -0.888966, -2.783479>
    }
    triangle {
      < 8.965602, -0.934245, -2.818481>,
      < 8.941601, -0.888966, -2.783479>,
      < 8.941601, -0.938202, -2.809265>
    }
    triangle {
      < 8.965602, -0.992403, -2.838320>,
      < 8.965602, -0.934245, -2.818481>,
      < 8.941601, -0.938202, -2.809265>
    }
    triangle {
      < 8.965602, -0.992403, -2.838320>,
      < 8.941601, -0.938202, -2.809265>,
      < 8.941601, -0.994980, -2.828633>
    }
    triangle {
      < 8.965602, -1.055699, -2.850575>,
      < 8.965602, -0.992403, -2.838320>,
      < 8.941601, -0.994980, -2.828633>
    }
    triangle {
      < 8.965602, -1.055699, -2.850575>,
      < 8.941601, -0.994980, -2.828633>,
      < 8.941601, -1.056968, -2.840635>
    }
    triangle {
      < 8.965602, -1.106616, -2.853772>,
      < 8.965602, -1.055699, -2.850575>,
      < 8.941601, -1.056968, -2.840635>
    }
    triangle {
      < 8.965602, -1.106616, -2.853772>,
      < 8.941601, -1.056968, -2.840635>,
      < 8.941601, -1.091616, -2.842811>
    }
    triangle {
      < 8.965602, -1.083502, -2.794408>,
      < 8.965602, -1.106616, -2.853772>,
      < 8.941601, -1.091616, -2.842811>
    }
    triangle {
      < 8.965602, -1.083502, -2.794408>,
      < 8.941601, -1.091616, -2.842811>,
      < 8.941601, -1.073912, -2.797338>
    }
    triangle {
      < 8.965602, -1.066637, -2.719638>,
      < 8.965602, -1.083502, -2.794408>,
      < 8.941601, -1.073912, -2.797338>
    }
    triangle {
      < 8.965602, -1.066637, -2.719638>,
      < 8.941601, -1.073912, -2.797338>,
      < 8.941601, -1.056706, -2.721055>
    }
    triangle {
      < 8.965602, -1.062027, -2.644964>,
      < 8.965602, -1.066637, -2.719638>,
      < 8.941601, -1.056706, -2.721055>
    }
    triangle {
      < 8.965602, -1.062027, -2.644964>,
      < 8.941601, -1.056706, -2.721055>,
      < 8.941601, -1.052008, -2.644964>
    }
    triangle {
      < 8.965602, -1.066637, -2.570289>,
      < 8.965602, -1.062027, -2.644964>,
      < 8.941601, -1.052008, -2.644964>
    }
    triangle {
      < 8.965602, -1.066637, -2.570289>,
      < 8.941601, -1.052008, -2.644964>,
      < 8.941601, -1.056706, -2.568872>
    }
    triangle {
      < 8.965602, -1.083502, -2.495519>,
      < 8.965602, -1.066637, -2.570289>,
      < 8.941601, -1.056706, -2.568872>
    }
    triangle {
      < 8.965602, -1.083502, -2.495519>,
      < 8.941601, -1.056706, -2.568872>,
      < 8.941601, -1.073912, -2.492589>
    }
    triangle {
      < 8.965602, -1.106615, -2.436155>,
      < 8.965602, -1.083502, -2.495519>,
      < 8.941601, -1.073912, -2.492589>
    }
    triangle {
      < 8.965602, -1.106615, -2.436155>,
      < 8.941601, -1.073912, -2.492589>,
      < 8.941601, -1.091616, -2.447118>
    }
    triangle {
      < 8.965602, -1.055699, -2.439355>,
      < 8.965602, -1.106615, -2.436155>,
      < 8.941601, -1.091616, -2.447118>
    }
    triangle {
      < 8.965602, -1.055699, -2.439355>,
      < 8.941601, -1.091616, -2.447118>,
      < 8.941601, -1.056968, -2.449295>
    }
    triangle {
      < 8.965602, -0.992403, -2.451608>,
      < 8.965602, -1.055699, -2.439355>,
      < 8.941601, -1.056968, -2.449295>
    }
    triangle {
      < 8.965602, -0.992403, -2.451608>,
      < 8.941601, -1.056968, -2.449295>,
      < 8.941601, -0.994980, -2.461295>
    }
    triangle {
      < 8.965602, -0.934245, -2.471447>,
      < 8.965602, -0.992403, -2.451608>,
      < 8.941601, -0.994980, -2.461295>
    }
    triangle {
      < 8.965602, -0.934245, -2.471447>,
      < 8.941601, -0.994980, -2.461295>,
      < 8.941601, -0.938202, -2.480663>
    }
    triangle {
      < 8.965602, -0.883534, -2.498005>,
      < 8.965602, -0.934245, -2.471447>,
      < 8.941601, -0.938202, -2.480663>
    }
    triangle {
      < 8.965602, -0.883534, -2.498005>,
      < 8.941601, -0.938202, -2.480663>,
      < 8.941601, -0.888966, -2.506449>
    }
    triangle {
      < 8.965602, -0.842255, -2.530104>,
      < 8.965602, -0.883534, -2.498005>,
      < 8.941601, -0.888966, -2.506449>
    }
    triangle {
      < 8.965602, -0.842255, -2.530104>,
      < 8.941601, -0.888966, -2.506449>,
      < 8.941601, -0.849236, -2.537343>
    }
    triangle {
      < 8.965602, -0.811934, -2.566304>,
      < 8.965602, -0.842255, -2.530104>,
      < 8.941601, -0.849236, -2.537343>
    }
    triangle {
      < 8.965602, -0.811934, -2.566304>,
      < 8.941601, -0.849236, -2.537343>,
      < 8.941601, -0.820418, -2.571748>
    }
    triangle {
      < 8.965602, -0.793512, -2.605060>,
      < 8.965602, -0.811934, -2.566304>,
      < 8.941601, -0.820418, -2.571748>
    }
    triangle {
      < 8.965602, -0.793512, -2.605060>,
      < 8.941601, -0.820418, -2.571748>,
      < 8.941601, -0.803172, -2.608031>
    }
    triangle {
      < 8.965602, -0.793512, -2.605060>,
      < 8.965602, -0.787354, -2.644964>,
      < 8.980003, -0.777236, -2.644964>
    }
    triangle {
      < 8.965602, -0.793512, -2.605060>,
      < 8.980003, -0.777236, -2.644964>,
      < 8.980003, -0.783852, -2.602088>
    }
    triangle {
      < 9.315598, -1.150710, -2.644820>,
      < 9.380916, -1.178265, -2.644820>,
      < 9.379009, -1.182890, -2.702599>
    }
    triangle {
      < 9.315598, -1.150710, -2.644820>,
      < 9.379009, -1.182890, -2.702599>,
      < 9.315598, -1.157051, -2.708993>
    }
    triangle {
      < 9.315598, -1.157051, -2.708993>,
      < 9.379009, -1.182890, -2.702599>,
      < 9.373309, -1.196726, -2.757550>
    }
    triangle {
      < 9.315598, -1.157051, -2.708993>,
      < 9.373309, -1.196726, -2.757550>,
      < 9.315598, -1.175642, -2.768791>
    }
    triangle {
      < 9.315598, -1.175642, -2.768791>,
      < 9.373309, -1.196726, -2.757550>,
      < 9.363877, -1.219617, -2.806843>
    }
    triangle {
      < 9.315598, -1.175642, -2.768791>,
      < 9.363877, -1.219617, -2.806843>,
      < 9.315598, -1.205215, -2.820142>
    }
    triangle {
      < 9.315598, -1.205215, -2.820142>,
      < 9.363877, -1.219617, -2.806843>,
      < 9.350867, -1.251195, -2.847646>
    }
    triangle {
      < 9.315598, -1.205215, -2.820142>,
      < 9.350867, -1.251195, -2.847646>,
      < 9.315598, -1.243755, -2.859545>
    }
    triangle {
      < 9.315598, -1.243755, -2.859545>,
      < 9.350867, -1.251195, -2.847646>,
      < 9.334587, -1.290710, -2.877168>
    }
    triangle {
      < 9.315598, -1.243755, -2.859545>,
      < 9.334587, -1.290710, -2.877168>,
      < 9.315598, -1.288637, -2.884313>
    }
    triangle {
      < 9.315598, -1.288637, -2.884313>,
      < 9.334587, -1.290710, -2.877168>,
      < 9.315598, -1.336800, -2.892762>
    }
    triangle {
      < 9.315598, -1.288637, -2.884313>,
      < 9.315598, -1.336800, -2.892762>,
      < 9.219997, -1.336800, -2.914267>
    }
    triangle {
      < 9.315598, -1.288637, -2.884313>,
      < 9.219997, -1.336800, -2.914267>,
      < 9.219997, -1.281780, -2.905086>
    }
    triangle {
      < 9.315598, -1.336800, -2.892762>,
      < 9.309299, -1.384550, -2.884313>,
      < 9.219997, -1.391820, -2.905086>
    }
    triangle {
      < 9.315598, -1.336800, -2.892762>,
      < 9.219997, -1.391820, -2.905086>,
      < 9.219997, -1.336800, -2.914267>
    }
    triangle {
      < 9.309299, -1.384550, -2.884313>,
      < 9.303433, -1.429047, -2.859545>,
      < 9.219997, -1.443090, -2.878169>
    }
    triangle {
      < 9.309299, -1.384550, -2.884313>,
      < 9.219997, -1.443090, -2.878169>,
      < 9.219997, -1.391820, -2.905086>
    }
    triangle {
      < 9.303433, -1.429047, -2.859545>,
      < 9.298392, -1.467256, -2.820142>,
      < 9.219997, -1.487116, -2.835349>
    }
    triangle {
      < 9.303433, -1.429047, -2.859545>,
      < 9.219997, -1.487116, -2.835349>,
      < 9.219997, -1.443090, -2.878169>
    }
    triangle {
      < 9.298392, -1.467256, -2.820142>,
      < 9.294526, -1.496575, -2.768791>,
      < 9.219997, -1.520899, -2.779544>
    }
    triangle {
      < 9.298392, -1.467256, -2.820142>,
      < 9.219997, -1.520899, -2.779544>,
      < 9.219997, -1.487116, -2.835349>
    }
    triangle {
      < 9.294526, -1.496575, -2.768791>,
      < 9.292098, -1.515007, -2.708993>,
      < 9.219997, -1.542136, -2.714559>
    }
    triangle {
      < 9.294526, -1.496575, -2.768791>,
      < 9.219997, -1.542136, -2.714559>,
      < 9.219997, -1.520899, -2.779544>
    }
    triangle {
      < 9.292098, -1.515007, -2.708993>,
      < 9.291270, -1.521293, -2.644820>,
      < 9.219997, -1.549379, -2.644820>
    }
    triangle {
      < 9.292098, -1.515007, -2.708993>,
      < 9.219997, -1.549379, -2.644820>,
      < 9.219997, -1.542136, -2.714559>
    }
    triangle {
      < 9.315598, -1.150710, -2.644820>,
      < 9.315598, -1.157051, -2.708993>,
      < 9.219997, -1.131464, -2.714559>
    }
    triangle {
      < 9.315598, -1.150710, -2.644820>,
      < 9.219997, -1.131464, -2.714559>,
      < 9.219997, -1.124221, -2.644820>
    }
    triangle {
      < 9.315598, -1.157051, -2.708993>,
      < 9.315598, -1.175642, -2.768791>,
      < 9.219997, -1.152701, -2.779544>
    }
    triangle {
      < 9.315598, -1.157051, -2.708993>,
      < 9.219997, -1.152701, -2.779544>,
      < 9.219997, -1.131464, -2.714559>
    }
    triangle {
      < 9.315598, -1.175642, -2.768791>,
      < 9.315598, -1.205215, -2.820142>,
      < 9.219997, -1.186484, -2.835349>
    }
    triangle {
      < 9.315598, -1.175642, -2.768791>,
      < 9.219997, -1.186484, -2.835349>,
      < 9.219997, -1.152701, -2.779544>
    }
    triangle {
      < 9.315598, -1.205215, -2.820142>,
      < 9.315598, -1.243755, -2.859545>,
      < 9.219997, -1.230511, -2.878169>
    }
    triangle {
      < 9.315598, -1.205215, -2.820142>,
      < 9.219997, -1.230511, -2.878169>,
      < 9.219997, -1.186484, -2.835349>
    }
    triangle {
      < 9.315598, -1.243755, -2.859545>,
      < 9.315598, -1.288637, -2.884313>,
      < 9.219997, -1.281780, -2.905086>
    }
    triangle {
      < 9.315598, -1.243755, -2.859545>,
      < 9.219997, -1.281780, -2.905086>,
      < 9.219997, -1.230511, -2.878169>
    }
    triangle {
      < 9.219997, -1.152701, -2.779544>,
      < 9.219997, -1.186484, -2.835349>,
      < 9.114798, -1.176142, -2.845933>
    }
    triangle {
      < 9.219997, -1.152701, -2.779544>,
      < 9.114798, -1.176142, -2.845933>,
      < 9.114798, -1.140034, -2.787029>
    }
    triangle {
      < 9.219997, -1.186484, -2.835349>,
      < 9.219997, -1.230511, -2.878169>,
      < 9.114798, -1.223197, -2.891132>
    }
    triangle {
      < 9.219997, -1.186484, -2.835349>,
      < 9.114798, -1.223197, -2.891132>,
      < 9.114798, -1.176142, -2.845933>
    }
    triangle {
      < 9.219997, -1.230511, -2.878169>,
      < 9.219997, -1.281780, -2.905086>,
      < 9.114798, -1.277995, -2.919545>
    }
    triangle {
      < 9.219997, -1.230511, -2.878169>,
      < 9.114798, -1.277995, -2.919545>,
      < 9.114798, -1.223197, -2.891132>
    }
    triangle {
      < 9.219997, -1.281780, -2.905086>,
      < 9.219997, -1.336800, -2.914267>,
      < 9.114798, -1.277995, -2.919545>
    }
    triangle {
      < 9.219997, -1.336800, -2.914267>,
      < 9.219997, -1.391820, -2.905086>,
      < 9.114798, -1.395606, -2.919545>
    }
    triangle {
      < 9.219997, -1.391820, -2.905086>,
      < 9.219997, -1.443090, -2.878169>,
      < 9.114798, -1.450403, -2.891132>
    }
    triangle {
      < 9.219997, -1.391820, -2.905086>,
      < 9.114798, -1.450403, -2.891132>,
      < 9.114798, -1.395606, -2.919545>
    }
    triangle {
      < 9.219997, -1.443090, -2.878169>,
      < 9.219997, -1.487116, -2.835349>,
      < 9.114798, -1.497459, -2.845933>
    }
    triangle {
      < 9.219997, -1.443090, -2.878169>,
      < 9.114798, -1.497459, -2.845933>,
      < 9.114798, -1.450403, -2.891132>
    }
    triangle {
      < 9.219997, -1.487116, -2.835349>,
      < 9.219997, -1.520899, -2.779544>,
      < 9.114798, -1.533566, -2.787029>
    }
    triangle {
      < 9.219997, -1.487116, -2.835349>,
      < 9.114798, -1.533566, -2.787029>,
      < 9.114798, -1.497459, -2.845933>
    }
    triangle {
      < 9.219997, -1.520899, -2.779544>,
      < 9.219997, -1.542136, -2.714559>,
      < 9.114798, -1.556264, -2.718433>
    }
    triangle {
      < 9.219997, -1.520899, -2.779544>,
      < 9.114798, -1.556264, -2.718433>,
      < 9.114798, -1.533566, -2.787029>
    }
    triangle {
      < 9.219997, -1.542136, -2.714559>,
      < 9.219997, -1.549379, -2.644820>,
      < 9.114798, -1.564006, -2.644820>
    }
    triangle {
      < 9.219997, -1.542136, -2.714559>,
      < 9.114798, -1.564006, -2.644820>,
      < 9.114798, -1.556264, -2.718433>
    }
    triangle {
      < 9.219997, -1.124221, -2.644820>,
      < 9.219997, -1.131464, -2.714559>,
      < 9.114798, -1.117336, -2.718433>
    }
    triangle {
      < 9.219997, -1.124221, -2.644820>,
      < 9.114798, -1.117336, -2.718433>,
      < 9.114798, -1.109594, -2.644820>
    }
    triangle {
      < 9.219997, -1.131464, -2.714559>,
      < 9.219997, -1.152701, -2.779544>,
      < 9.114798, -1.140034, -2.787029>
    }
    triangle {
      < 9.219997, -1.131464, -2.714559>,
      < 9.114798, -1.140034, -2.787029>,
      < 9.114798, -1.117336, -2.718433>
    }
    triangle {
      < 9.114798, -1.109594, -2.644820>,
      < 9.114798, -1.117336, -2.718433>,
      < 9.011996, -1.107063, -2.720609>
    }
    triangle {
      < 9.114798, -1.109594, -2.644820>,
      < 9.011996, -1.107063, -2.720609>,
      < 9.011996, -1.098959, -2.644820>
    }
    triangle {
      < 9.114798, -1.117336, -2.718433>,
      < 9.114798, -1.140034, -2.787029>,
      < 9.011996, -1.130823, -2.791230>
    }
    triangle {
      < 9.114798, -1.117336, -2.718433>,
      < 9.011996, -1.130823, -2.791230>,
      < 9.011996, -1.107063, -2.720609>
    }
    triangle {
      < 9.114798, -1.140034, -2.787029>,
      < 9.114798, -1.176142, -2.845933>,
      < 9.011996, -1.168621, -2.851875>
    }
    triangle {
      < 9.114798, -1.140034, -2.787029>,
      < 9.011996, -1.168621, -2.851875>,
      < 9.011996, -1.130823, -2.791230>
    }
    triangle {
      < 9.114798, -1.176142, -2.845933>,
      < 9.114798, -1.223197, -2.891132>,
      < 9.011996, -1.217880, -2.898409>
    }
    triangle {
      < 9.114798, -1.176142, -2.845933>,
      < 9.011996, -1.217880, -2.898409>,
      < 9.011996, -1.168621, -2.851875>
    }
    triangle {
      < 9.114798, -1.223197, -2.891132>,
      < 9.114798, -1.277995, -2.919545>,
      < 9.011996, -1.246561, -2.913035>
    }
    triangle {
      < 9.114798, -1.223197, -2.891132>,
      < 9.011996, -1.246561, -2.913035>,
      < 9.011996, -1.217880, -2.898409>
    }
    triangle {
      < 9.114798, -1.277995, -2.919545>,
      < 9.114798, -1.336800, -2.950837>,
      < 9.011996, -1.336800, -2.985639>
    }
    triangle {
      < 9.114798, -1.277995, -2.919545>,
      < 9.011996, -1.336800, -2.985639>,
      < 9.011996, -1.246561, -2.913035>
    }
    triangle {
      < 9.114798, -1.336800, -2.950837>,
      < 9.114798, -1.395606, -2.919545>,
      < 9.011996, -1.427040, -2.913035>
    }
    triangle {
      < 9.114798, -1.336800, -2.950837>,
      < 9.011996, -1.427040, -2.913035>,
      < 9.011996, -1.336800, -2.985639>
    }
    triangle {
      < 9.114798, -1.395606, -2.919545>,
      < 9.114798, -1.450403, -2.891132>,
      < 9.011996, -1.455721, -2.898409>
    }
    triangle {
      < 9.114798, -1.395606, -2.919545>,
      < 9.011996, -1.455721, -2.898409>,
      < 9.011996, -1.427040, -2.913035>
    }
    triangle {
      < 9.114798, -1.450403, -2.891132>,
      < 9.114798, -1.497459, -2.845933>,
      < 9.011996, -1.504979, -2.851875>
    }
    triangle {
      < 9.114798, -1.450403, -2.891132>,
      < 9.011996, -1.504979, -2.851875>,
      < 9.011996, -1.455721, -2.898409>
    }
    triangle {
      < 9.114798, -1.497459, -2.845933>,
      < 9.114798, -1.533566, -2.787029>,
      < 9.011996, -1.542776, -2.791230>
    }
    triangle {
      < 9.114798, -1.497459, -2.845933>,
      < 9.011996, -1.542776, -2.791230>,
      < 9.011996, -1.504979, -2.851875>
    }
    triangle {
      < 9.114798, -1.533566, -2.787029>,
      < 9.114798, -1.556264, -2.718433>,
      < 9.011996, -1.566538, -2.720609>
    }
    triangle {
      < 9.114798, -1.533566, -2.787029>,
      < 9.011996, -1.566538, -2.720609>,
      < 9.011996, -1.542776, -2.791230>
    }
    triangle {
      < 9.114798, -1.556264, -2.718433>,
      < 9.114798, -1.564006, -2.644820>,
      < 9.011996, -1.574642, -2.644820>
    }
    triangle {
      < 9.114798, -1.556264, -2.718433>,
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.566538, -2.720609>
    }
    triangle {
      < 9.011996, -1.098959, -2.644820>,
      < 9.011996, -1.107063, -2.720609>,
      < 8.981197, -1.107063, -2.720609>
    }
    triangle {
      < 9.011996, -1.098959, -2.644820>,
      < 8.981197, -1.107063, -2.720609>,
      < 8.981197, -1.098959, -2.644820>
    }
    triangle {
      < 9.011996, -1.107063, -2.720609>,
      < 9.011996, -1.130823, -2.791230>,
      < 8.981197, -1.130823, -2.791230>
    }
    triangle {
      < 9.011996, -1.107063, -2.720609>,
      < 8.981197, -1.130823, -2.791230>,
      < 8.981197, -1.107063, -2.720609>
    }
    triangle {
      < 9.011996, -1.130823, -2.791230>,
      < 9.011996, -1.168621, -2.851875>,
      < 8.981197, -1.168621, -2.851875>
    }
    triangle {
      < 9.011996, -1.130823, -2.791230>,
      < 8.981197, -1.168621, -2.851875>,
      < 8.981197, -1.130823, -2.791230>
    }
    triangle {
      < 9.011996, -1.168621, -2.851875>,
      < 9.011996, -1.217880, -2.898409>,
      < 8.981197, -1.217880, -2.898409>
    }
    triangle {
      < 9.011996, -1.168621, -2.851875>,
      < 8.981197, -1.217880, -2.898409>,
      < 8.981197, -1.168621, -2.851875>
    }
    triangle {
      < 9.011996, -1.217880, -2.898409>,
      < 9.011996, -1.246561, -2.913035>,
      < 8.981197, -1.246561, -2.913035>
    }
    triangle {
      < 9.011996, -1.217880, -2.898409>,
      < 8.981197, -1.246561, -2.913035>,
      < 8.981197, -1.217880, -2.898409>
    }
    triangle {
      < 9.011996, -1.336800, -2.985639>,
      < 8.981197, -1.336800, -2.990439>,
      < 8.981197, -1.246561, -2.913035>
    }
    triangle {
      < 9.011996, -1.336800, -2.985639>,
      < 8.981197, -1.246561, -2.913035>,
      < 9.011996, -1.246561, -2.913035>
    }
    triangle {
      < 9.011996, -1.336800, -2.985639>,
      < 9.011996, -1.427040, -2.913035>,
      < 8.981197, -1.427040, -2.913035>
    }
    triangle {
      < 9.011996, -1.336800, -2.985639>,
      < 8.981197, -1.427040, -2.913035>,
      < 8.981197, -1.336800, -2.990439>
    }
    triangle {
      < 8.981197, -1.427040, -2.913035>,
      < 9.011996, -1.427040, -2.913035>,
      < 9.011996, -1.455721, -2.898409>
    }
    triangle {
      < 8.981197, -1.427040, -2.913035>,
      < 9.011996, -1.455721, -2.898409>,
      < 8.981197, -1.455721, -2.898409>
    }
    triangle {
      < 8.999084, -1.510549, -2.891735>,
      < 8.999141, -1.636898, -2.862385>,
      < 8.981197, -1.637952, -2.867971>
    }
    triangle {
      < 8.999084, -1.510549, -2.891735>,
      < 8.981197, -1.637952, -2.867971>,
      < 8.981197, -1.506510, -2.898409>
    }
    triangle {
      < 8.999141, -1.636898, -2.862385>,
      < 8.999117, -1.734657, -2.799072>,
      < 8.981197, -1.738812, -2.802612>
    }
    triangle {
      < 8.999141, -1.636898, -2.862385>,
      < 8.981197, -1.738812, -2.802612>,
      < 8.981197, -1.637952, -2.867971>
    }
    triangle {
      < 8.999117, -1.734657, -2.799072>,
      < 8.999216, -1.796273, -2.724938>,
      < 8.981197, -1.802217, -2.726501>
    }
    triangle {
      < 8.999117, -1.734657, -2.799072>,
      < 8.981197, -1.802217, -2.726501>,
      < 8.981197, -1.738812, -2.802612>
    }
    triangle {
      < 8.999216, -1.796273, -2.724938>,
      < 8.999288, -1.817396, -2.644820>,
      < 8.981197, -1.823841, -2.644820>
    }
    triangle {
      < 8.999216, -1.796273, -2.724938>,
      < 8.981197, -1.823841, -2.644820>,
      < 8.981197, -1.802217, -2.726501>
    }
    triangle {
      < 8.981197, -1.455721, -2.898409>,
      < 9.011996, -1.455721, -2.898409>,
      < 8.999084, -1.510549, -2.891735>
    }
    triangle {
      < 8.981197, -1.455721, -2.898409>,
      < 8.999084, -1.510549, -2.891735>,
      < 8.981197, -1.506510, -2.898409>
    }
    triangle {
      < 8.085253, -1.849633, -2.722595>,
      < 8.080274, -1.783448, -2.792820>,
      < 8.981197, -1.738812, -2.802612>
    }
    triangle {
      < 8.085253, -1.849633, -2.722595>,
      < 8.981197, -1.738812, -2.802612>,
      < 8.981197, -1.802217, -2.726501>
    }
    triangle {
      < 8.092828, -1.873096, -2.644820>,
      < 8.085253, -1.849633, -2.722595>,
      < 8.981197, -1.802217, -2.726501>
    }
    triangle {
      < 8.092828, -1.873096, -2.644820>,
      < 8.981197, -1.802217, -2.726501>,
      < 8.981197, -1.823841, -2.644820>
    }
    triangle {
      < 8.080274, -1.783448, -2.792820>,
      < 8.093800, -1.679864, -2.852874>,
      < 8.981197, -1.637952, -2.867971>
    }
    triangle {
      < 8.080274, -1.783448, -2.792820>,
      < 8.981197, -1.637952, -2.867971>,
      < 8.981197, -1.738812, -2.802612>
    }
    triangle {
      < 8.267190, -1.359515, -2.905232>,
      < 8.302703, -1.293414, -2.907693>,
      < 8.460090, -1.282344, -2.905087>
    }
    triangle {
      < 8.267190, -1.359515, -2.905232>,
      < 8.460090, -1.282344, -2.905087>,
      < 8.319522, -1.348837, -2.905452>
    }
    triangle {
      < 8.460090, -1.282344, -2.905087>,
      < 8.335473, -1.231890, -2.887792>,
      < 8.339134, -1.223811, -2.884065>
    }
    triangle {
      < 8.460090, -1.282344, -2.905087>,
      < 8.339134, -1.223811, -2.884065>,
      < 8.981197, -1.217880, -2.898409>
    }
    triangle {
      < 8.460090, -1.282344, -2.905087>,
      < 8.981197, -1.217880, -2.898409>,
      < 8.981197, -1.246561, -2.913035>
    }
    triangle {
      < 8.339134, -1.223811, -2.884065>,
      < 8.364557, -1.176428, -2.845050>,
      < 8.981197, -1.168621, -2.851875>
    }
    triangle {
      < 8.339134, -1.223811, -2.884065>,
      < 8.981197, -1.168621, -2.851875>,
      < 8.981197, -1.217880, -2.898409>
    }
    triangle {
      < 8.364557, -1.176428, -2.845050>,
      < 8.386551, -1.134575, -2.786947>,
      < 8.981197, -1.130823, -2.791230>
    }
    triangle {
      < 8.364557, -1.176428, -2.845050>,
      < 8.981197, -1.130823, -2.791230>,
      < 8.981197, -1.168621, -2.851875>
    }
    triangle {
      < 8.386551, -1.134575, -2.786947>,
      < 8.400378, -1.108249, -2.718540>,
      < 8.981197, -1.107063, -2.720609>
    }
    triangle {
      < 8.386551, -1.134575, -2.786947>,
      < 8.981197, -1.107063, -2.720609>,
      < 8.981197, -1.130823, -2.791230>
    }
    triangle {
      < 8.400378, -1.108249, -2.718540>,
      < 8.405093, -1.099273, -2.644820>,
      < 8.981197, -1.098959, -2.644820>
    }
    triangle {
      < 8.400378, -1.108249, -2.718540>,
      < 8.981197, -1.098959, -2.644820>,
      < 8.981197, -1.107063, -2.720609>
    }
    triangle {
      < 8.230967, -1.425997, -2.899253>,
      < 8.267190, -1.359515, -2.905232>,
      < 8.319522, -1.348837, -2.905452>
    }
    triangle {
      < 8.230967, -1.425997, -2.899253>,
      < 8.319522, -1.348837, -2.905452>,
      < 8.459869, -1.411076, -2.902306>
    }
    triangle {
      < 8.093800, -1.679864, -2.852874>,
      < 8.170268, -1.538336, -2.883126>,
      < 8.981197, -1.506510, -2.898409>
    }
    triangle {
      < 8.093800, -1.679864, -2.852874>,
      < 8.981197, -1.506510, -2.898409>,
      < 8.981197, -1.637952, -2.867971>
    }
    triangle {
      < 8.208865, -1.466886, -2.897391>,
      < 8.230967, -1.425997, -2.899253>,
      < 8.459869, -1.411076, -2.902306>
    }
    triangle {
      < 8.170268, -1.538336, -2.883126>,
      < 8.205842, -1.472367, -2.895818>,
      < 8.981197, -1.455721, -2.898409>
    }
    triangle {
      < 8.170268, -1.538336, -2.883126>,
      < 8.981197, -1.455721, -2.898409>,
      < 8.981197, -1.506510, -2.898409>
    }
    triangle {
      < 8.448472, -1.346491, -2.973640>,
      < 8.460090, -1.282344, -2.905087>,
      < 8.981197, -1.246561, -2.913035>
    }
    triangle {
      < 8.448472, -1.346491, -2.973640>,
      < 8.981197, -1.246561, -2.913035>,
      < 8.981197, -1.336800, -2.990439>
    }
    triangle {
      < 8.459869, -1.411076, -2.902306>,
      < 8.448472, -1.346491, -2.973640>,
      < 8.981197, -1.336800, -2.990439>
    }
    triangle {
      < 8.459869, -1.411076, -2.902306>,
      < 8.981197, -1.336800, -2.990439>,
      < 8.981197, -1.427040, -2.913035>
    }
    triangle {
      < 9.219997, -1.336800, -2.914267>,
      < 9.114798, -1.395606, -2.919545>,
      < 9.114798, -1.336800, -2.950837>
    }
    triangle {
      < 9.114798, -1.277995, -2.919545>,
      < 9.219997, -1.336800, -2.914267>,
      < 9.114798, -1.336800, -2.950837>
    }
    triangle {
      < 8.448472, -1.346491, -2.973640>,
      < 8.459869, -1.411076, -2.902306>,
      < 8.319522, -1.348837, -2.905452>
    }
    triangle {
      < 8.460090, -1.282344, -2.905087>,
      < 8.448472, -1.346491, -2.973640>,
      < 8.319522, -1.348837, -2.905452>
    }
    triangle {
      < 8.208865, -1.466886, -2.897391>,
      < 8.459869, -1.411076, -2.902306>,
      < 8.981197, -1.427040, -2.913035>
    }
    triangle {
      < 8.208865, -1.466886, -2.897391>,
      < 8.981197, -1.427040, -2.913035>,
      < 8.981197, -1.455721, -2.898409>
    }
    triangle {
      < 8.208865, -1.466886, -2.897391>,
      < 8.981197, -1.455721, -2.898409>,
      < 8.205842, -1.472367, -2.895818>
    }
    triangle {
      < 8.302703, -1.293414, -2.907693>,
      < 8.335473, -1.231890, -2.887792>,
      < 8.460090, -1.282344, -2.905087>
    }
    triangle {
      < 9.292098, -1.515007, -2.708993>,
      < 9.294526, -1.496575, -2.768791>,
      < 9.308848, -1.487641, -2.764788>
    }
    triangle {
      < 9.292098, -1.515007, -2.708993>,
      < 9.308848, -1.487641, -2.764788>,
      < 9.306579, -1.505469, -2.707011>
    }
    triangle {
      < 9.294526, -1.496575, -2.768791>,
      < 9.298392, -1.467256, -2.820142>,
      < 9.312419, -1.459459, -2.814084>
    }
    triangle {
      < 9.294526, -1.496575, -2.768791>,
      < 9.312419, -1.459459, -2.814084>,
      < 9.308848, -1.487641, -2.764788>
    }
    triangle {
      < 9.298392, -1.467256, -2.820142>,
      < 9.303433, -1.429047, -2.859545>,
      < 9.316981, -1.423095, -2.851523>
    }
    triangle {
      < 9.298392, -1.467256, -2.820142>,
      < 9.316981, -1.423095, -2.851523>,
      < 9.312419, -1.459459, -2.814084>
    }
    triangle {
      < 9.303433, -1.429047, -2.859545>,
      < 9.309299, -1.384550, -2.884313>,
      < 9.322154, -1.381266, -2.874760>
    }
    triangle {
      < 9.303433, -1.429047, -2.859545>,
      < 9.322154, -1.381266, -2.874760>,
      < 9.316981, -1.423095, -2.851523>
    }
    triangle {
      < 9.309299, -1.384550, -2.884313>,
      < 9.315598, -1.336800, -2.892762>,
      < 9.327429, -1.337455, -2.882406>
    }
    triangle {
      < 9.309299, -1.384550, -2.884313>,
      < 9.327429, -1.337455, -2.882406>,
      < 9.322154, -1.381266, -2.874760>
    }
    triangle {
      < 9.315598, -1.336800, -2.892762>,
      < 9.334587, -1.290710, -2.877168>,
      < 9.345465, -1.295034, -2.868094>
    }
    triangle {
      < 9.315598, -1.336800, -2.892762>,
      < 9.345465, -1.295034, -2.868094>,
      < 9.327429, -1.337455, -2.882406>
    }
    triangle {
      < 9.334587, -1.290710, -2.877168>,
      < 9.350867, -1.251195, -2.847646>,
      < 9.361150, -1.257808, -2.840219>
    }
    triangle {
      < 9.334587, -1.290710, -2.877168>,
      < 9.361150, -1.257808, -2.840219>,
      < 9.345465, -1.295034, -2.868094>
    }
    triangle {
      < 9.350867, -1.251195, -2.847646>,
      < 9.363877, -1.219617, -2.806843>,
      < 9.373755, -1.227783, -2.801352>
    }
    triangle {
      < 9.350867, -1.251195, -2.847646>,
      < 9.373755, -1.227783, -2.801352>,
      < 9.361150, -1.257808, -2.840219>
    }
    triangle {
      < 9.363877, -1.219617, -2.806843>,
      < 9.373309, -1.196726, -2.757550>,
      < 9.382946, -1.205820, -2.753986>
    }
    triangle {
      < 9.363877, -1.219617, -2.806843>,
      < 9.382946, -1.205820, -2.753986>,
      < 9.373755, -1.227783, -2.801352>
    }
    triangle {
      < 9.373309, -1.196726, -2.757550>,
      < 9.379009, -1.182890, -2.702599>,
      < 9.388523, -1.192460, -2.700856>
    }
    triangle {
      < 9.373309, -1.196726, -2.757550>,
      < 9.388523, -1.192460, -2.700856>,
      < 9.382946, -1.205820, -2.753986>
    }
    triangle {
      < 9.379009, -1.182890, -2.702599>,
      < 9.380916, -1.178265, -2.644820>,
      < 9.390391, -1.187980, -2.644820>
    }
    triangle {
      < 9.379009, -1.182890, -2.702599>,
      < 9.390391, -1.187980, -2.644820>,
      < 9.388523, -1.192460, -2.700856>
    }
    triangle {
      < 9.291270, -1.521293, -2.644820>,
      < 9.292098, -1.515007, -2.708993>,
      < 9.306579, -1.505469, -2.707011>
    }
    triangle {
      < 9.291270, -1.521293, -2.644820>,
      < 9.306579, -1.505469, -2.707011>,
      < 9.305799, -1.511568, -2.644820>
    }
    triangle {
      < 9.305799, -1.511568, -2.644820>,
      < 9.306579, -1.505469, -2.707011>,
      < 9.315593, -1.489255, -2.703642>
    }
    triangle {
      < 9.305799, -1.511568, -2.644820>,
      < 9.315593, -1.489255, -2.703642>,
      < 9.314896, -1.495034, -2.644820>
    }
    triangle {
      < 9.306579, -1.505469, -2.707011>,
      < 9.308848, -1.487641, -2.764788>,
      < 9.317596, -1.472453, -2.757983>
    }
    triangle {
      < 9.306579, -1.505469, -2.707011>,
      < 9.317596, -1.472453, -2.757983>,
      < 9.315593, -1.489255, -2.703642>
    }
    triangle {
      < 9.308848, -1.487641, -2.764788>,
      < 9.312419, -1.459459, -2.814084>,
      < 9.320664, -1.446203, -2.803785>
    }
    triangle {
      < 9.308848, -1.487641, -2.764788>,
      < 9.320664, -1.446203, -2.803785>,
      < 9.317596, -1.472453, -2.757983>
    }
    triangle {
      < 9.312419, -1.459459, -2.814084>,
      < 9.316981, -1.423095, -2.851523>,
      < 9.324411, -1.412976, -2.837886>
    }
    triangle {
      < 9.312419, -1.459459, -2.814084>,
      < 9.324411, -1.412976, -2.837886>,
      < 9.320664, -1.446203, -2.803785>
    }
    triangle {
      < 9.316981, -1.423095, -2.851523>,
      < 9.322154, -1.381266, -2.874760>,
      < 9.328403, -1.375694, -2.858512>
    }
    triangle {
      < 9.316981, -1.423095, -2.851523>,
      < 9.328403, -1.375694, -2.858512>,
      < 9.324411, -1.412976, -2.837886>
    }
    triangle {
      < 9.322154, -1.381266, -2.874760>,
      < 9.327429, -1.337455, -2.882406>,
      < 9.331939, -1.338572, -2.864783>
    }
    triangle {
      < 9.322154, -1.381266, -2.874760>,
      < 9.331939, -1.338572, -2.864783>,
      < 9.328403, -1.375694, -2.858512>
    }
    triangle {
      < 9.327429, -1.337455, -2.882406>,
      < 9.345465, -1.295034, -2.868094>,
      < 9.348357, -1.302375, -2.852660>
    }
    triangle {
      < 9.327429, -1.337455, -2.882406>,
      < 9.348357, -1.302375, -2.852660>,
      < 9.331939, -1.338572, -2.864783>
    }
    triangle {
      < 9.345465, -1.295034, -2.868094>,
      < 9.361150, -1.257808, -2.840219>,
      < 9.363029, -1.269052, -2.827596>
    }
    triangle {
      < 9.345465, -1.295034, -2.868094>,
      < 9.363029, -1.269052, -2.827596>,
      < 9.348357, -1.302375, -2.852660>
    }
    triangle {
      < 9.361150, -1.257808, -2.840219>,
      < 9.373755, -1.227783, -2.801352>,
      < 9.374948, -1.241667, -2.792017>
    }
    triangle {
      < 9.361150, -1.257808, -2.840219>,
      < 9.374948, -1.241667, -2.792017>,
      < 9.363029, -1.269052, -2.827596>
    }
    triangle {
      < 9.373755, -1.227783, -2.801352>,
      < 9.382946, -1.205820, -2.753986>,
      < 9.383728, -1.221281, -2.747927>
    }
    triangle {
      < 9.373755, -1.227783, -2.801352>,
      < 9.383728, -1.221281, -2.747927>,
      < 9.374948, -1.241667, -2.792017>
    }
    triangle {
      < 9.382946, -1.205820, -2.753986>,
      < 9.388523, -1.192460, -2.700856>,
      < 9.389095, -1.208729, -2.697892>
    }
    triangle {
      < 9.382946, -1.205820, -2.753986>,
      < 9.389095, -1.208729, -2.697892>,
      < 9.383728, -1.221281, -2.747927>
    }
    triangle {
      < 9.388523, -1.192460, -2.700856>,
      < 9.390391, -1.187980, -2.644820>,
      < 9.390900, -1.204495, -2.644820>
    }
    triangle {
      < 9.388523, -1.192460, -2.700856>,
      < 9.390900, -1.204495, -2.644820>,
      < 9.389095, -1.208729, -2.697892>
    }
    triangle {
      < 9.348357, -1.302375, -2.852660>,
      < 9.363029, -1.269052, -2.827596>,
      < 9.355305, -1.280296, -2.814973>
    }
    triangle {
      < 9.348357, -1.302375, -2.852660>,
      < 9.355305, -1.280296, -2.814973>,
      < 9.341655, -1.309691, -2.837207>
    }
    triangle {
      < 9.363029, -1.269052, -2.827596>,
      < 9.374948, -1.241667, -2.792017>,
      < 9.366538, -1.255551, -2.782683>
    }
    triangle {
      < 9.363029, -1.269052, -2.827596>,
      < 9.366538, -1.255551, -2.782683>,
      < 9.355305, -1.280296, -2.814973>
    }
    triangle {
      < 9.374948, -1.241667, -2.792017>,
      < 9.383728, -1.221281, -2.747927>,
      < 9.374908, -1.236742, -2.741868>
    }
    triangle {
      < 9.374948, -1.241667, -2.792017>,
      < 9.374908, -1.236742, -2.741868>,
      < 9.366538, -1.255551, -2.782683>
    }
    triangle {
      < 9.383728, -1.221281, -2.747927>,
      < 9.389095, -1.208729, -2.697892>,
      < 9.380066, -1.224998, -2.694929>
    }
    triangle {
      < 9.383728, -1.221281, -2.747927>,
      < 9.380066, -1.224998, -2.694929>,
      < 9.374908, -1.236742, -2.741868>
    }
    triangle {
      < 9.389095, -1.208729, -2.697892>,
      < 9.390900, -1.204495, -2.644820>,
      < 9.381806, -1.221010, -2.644820>
    }
    triangle {
      < 9.389095, -1.208729, -2.697892>,
      < 9.381806, -1.221010, -2.644820>,
      < 9.380066, -1.224998, -2.694929>
    }
    triangle {
      < 9.314896, -1.495034, -2.644820>,
      < 9.315593, -1.489255, -2.703642>,
      < 9.315006, -1.473042, -2.700272>
    }
    triangle {
      < 9.314896, -1.495034, -2.644820>,
      < 9.315006, -1.473042, -2.700272>,
      < 9.314393, -1.478501, -2.644820>
    }
    triangle {
      < 9.315593, -1.489255, -2.703642>,
      < 9.317596, -1.472453, -2.757983>,
      < 9.316745, -1.457265, -2.751179>
    }
    triangle {
      < 9.315593, -1.489255, -2.703642>,
      < 9.316745, -1.457265, -2.751179>,
      < 9.315006, -1.473042, -2.700272>
    }
    triangle {
      < 9.317596, -1.472453, -2.757983>,
      < 9.320664, -1.446203, -2.803785>,
      < 9.319310, -1.432948, -2.793487>
    }
    triangle {
      < 9.317596, -1.472453, -2.757983>,
      < 9.319310, -1.432948, -2.793487>,
      < 9.316745, -1.457265, -2.751179>
    }
    triangle {
      < 9.320664, -1.446203, -2.803785>,
      < 9.324411, -1.412976, -2.837886>,
      < 9.322242, -1.402857, -2.824250>
    }
    triangle {
      < 9.320664, -1.446203, -2.803785>,
      < 9.322242, -1.402857, -2.824250>,
      < 9.319310, -1.432948, -2.793487>
    }
    triangle {
      < 9.324411, -1.412976, -2.837886>,
      < 9.328403, -1.375694, -2.858512>,
      < 9.325043, -1.370153, -2.842247>
    }
    triangle {
      < 9.324411, -1.412976, -2.837886>,
      < 9.325043, -1.370153, -2.842247>,
      < 9.322242, -1.402857, -2.824250>
    }
    triangle {
      < 9.328403, -1.375694, -2.858512>,
      < 9.331939, -1.338572, -2.864783>,
      < 9.326846, -1.339696, -2.847115>
    }
    triangle {
      < 9.328403, -1.375694, -2.858512>,
      < 9.326846, -1.339696, -2.847115>,
      < 9.325043, -1.370153, -2.842247>
    }
    triangle {
      < 9.331939, -1.338572, -2.864783>,
      < 9.348357, -1.302375, -2.852660>,
      < 9.341655, -1.309691, -2.837207>
    }
    triangle {
      < 9.331939, -1.338572, -2.864783>,
      < 9.341655, -1.309691, -2.837207>,
      < 9.326846, -1.339696, -2.847115>
    }
    triangle {
      < 9.322242, -1.402857, -2.824250>,
      < 9.325043, -1.370153, -2.842247>,
      < 9.316450, -1.366276, -2.830745>
    }
    triangle {
      < 9.322242, -1.402857, -2.824250>,
      < 9.316450, -1.366276, -2.830745>,
      < 9.314498, -1.395712, -2.814626>
    }
    triangle {
      < 9.325043, -1.370153, -2.842247>,
      < 9.326846, -1.339696, -2.847115>,
      < 9.317037, -1.340499, -2.834590>
    }
    triangle {
      < 9.325043, -1.370153, -2.842247>,
      < 9.317037, -1.340499, -2.834590>,
      < 9.316450, -1.366276, -2.830745>
    }
    triangle {
      < 9.326846, -1.339696, -2.847115>,
      < 9.341655, -1.309691, -2.837207>,
      < 9.330718, -1.314826, -2.826277>
    }
    triangle {
      < 9.326846, -1.339696, -2.847115>,
      < 9.330718, -1.314826, -2.826277>,
      < 9.317037, -1.340499, -2.834590>
    }
    triangle {
      < 9.341655, -1.309691, -2.837207>,
      < 9.355305, -1.280296, -2.814973>,
      < 9.343640, -1.288234, -2.806063>
    }
    triangle {
      < 9.341655, -1.309691, -2.837207>,
      < 9.343640, -1.288234, -2.806063>,
      < 9.330718, -1.314826, -2.826277>
    }
    triangle {
      < 9.355305, -1.280296, -2.814973>,
      < 9.366538, -1.255551, -2.782683>,
      < 9.354388, -1.265352, -2.776094>
    }
    triangle {
      < 9.355305, -1.280296, -2.814973>,
      < 9.354388, -1.265352, -2.776094>,
      < 9.343640, -1.288234, -2.806063>
    }
    triangle {
      < 9.366538, -1.255551, -2.782683>,
      < 9.374908, -1.236742, -2.741868>,
      < 9.362471, -1.247656, -2.737591>
    }
    triangle {
      < 9.366538, -1.255551, -2.782683>,
      < 9.362471, -1.247656, -2.737591>,
      < 9.354388, -1.265352, -2.776094>
    }
    triangle {
      < 9.374908, -1.236742, -2.741868>,
      < 9.380066, -1.224998, -2.694929>,
      < 9.367479, -1.236482, -2.692837>
    }
    triangle {
      < 9.374908, -1.236742, -2.741868>,
      < 9.367479, -1.236482, -2.692837>,
      < 9.362471, -1.247656, -2.737591>
    }
    triangle {
      < 9.380066, -1.224998, -2.694929>,
      < 9.381806, -1.221010, -2.644820>,
      < 9.369174, -1.232667, -2.644820>
    }
    triangle {
      < 9.380066, -1.224998, -2.694929>,
      < 9.369174, -1.232667, -2.644820>,
      < 9.367479, -1.236482, -2.692837>
    }
    triangle {
      < 9.314393, -1.478501, -2.644820>,
      < 9.315006, -1.473042, -2.700272>,
      < 9.308381, -1.461597, -2.697894>
    }
    triangle {
      < 9.314393, -1.478501, -2.644820>,
      < 9.308381, -1.461597, -2.697894>,
      < 9.307826, -1.466830, -2.644820>
    }
    triangle {
      < 9.315006, -1.473042, -2.700272>,
      < 9.316745, -1.457265, -2.751179>,
      < 9.309932, -1.446544, -2.746375>
    }
    triangle {
      < 9.315006, -1.473042, -2.700272>,
      < 9.309932, -1.446544, -2.746375>,
      < 9.308381, -1.461597, -2.697894>
    }
    triangle {
      < 9.316745, -1.457265, -2.751179>,
      < 9.319310, -1.432948, -2.793487>,
      < 9.312142, -1.423590, -2.786218>
    }
    triangle {
      < 9.316745, -1.457265, -2.751179>,
      < 9.312142, -1.423590, -2.786218>,
      < 9.309932, -1.446544, -2.746375>
    }
    triangle {
      < 9.319310, -1.432948, -2.793487>,
      < 9.322242, -1.402857, -2.824250>,
      < 9.314498, -1.395712, -2.814626>
    }
    triangle {
      < 9.319310, -1.432948, -2.793487>,
      < 9.314498, -1.395712, -2.814626>,
      < 9.312142, -1.423590, -2.786218>
    }
    triangle {
      < 9.308381, -1.461597, -2.697894>,
      < 9.309932, -1.446544, -2.746375>,
      < 9.270059, -1.437610, -2.742372>
    }
    triangle {
      < 9.308381, -1.461597, -2.697894>,
      < 9.270059, -1.437610, -2.742372>,
      < 9.270059, -1.452059, -2.695912>
    }
    triangle {
      < 9.309932, -1.446544, -2.746375>,
      < 9.312142, -1.423590, -2.786218>,
      < 9.270059, -1.415792, -2.780160>
    }
    triangle {
      < 9.309932, -1.446544, -2.746375>,
      < 9.270059, -1.415792, -2.780160>,
      < 9.270059, -1.437610, -2.742372>
    }
    triangle {
      < 9.312142, -1.423590, -2.786218>,
      < 9.314498, -1.395712, -2.814626>,
      < 9.270059, -1.389757, -2.806606>
    }
    triangle {
      < 9.312142, -1.423590, -2.786218>,
      < 9.270059, -1.389757, -2.806606>,
      < 9.270059, -1.415792, -2.780160>
    }
    triangle {
      < 9.314498, -1.395712, -2.814626>,
      < 9.316450, -1.366276, -2.830745>,
      < 9.270059, -1.363081, -2.821137>
    }
    triangle {
      < 9.314498, -1.395712, -2.814626>,
      < 9.270059, -1.363081, -2.821137>,
      < 9.270059, -1.389757, -2.806606>
    }
    triangle {
      < 9.316450, -1.366276, -2.830745>,
      < 9.317037, -1.340499, -2.834590>,
      < 9.270059, -1.341180, -2.824098>
    }
    triangle {
      < 9.316450, -1.366276, -2.830745>,
      < 9.270059, -1.341180, -2.824098>,
      < 9.270059, -1.363081, -2.821137>
    }
    triangle {
      < 9.317037, -1.340499, -2.834590>,
      < 9.330718, -1.314826, -2.826277>,
      < 9.270059, -1.319076, -2.817147>
    }
    triangle {
      < 9.317037, -1.340499, -2.834590>,
      < 9.270059, -1.319076, -2.817147>,
      < 9.270059, -1.341180, -2.824098>
    }
    triangle {
      < 9.330718, -1.314826, -2.826277>,
      < 9.343640, -1.288234, -2.806063>,
      < 9.270059, -1.294850, -2.798639>
    }
    triangle {
      < 9.330718, -1.314826, -2.826277>,
      < 9.270059, -1.294850, -2.798639>,
      < 9.270059, -1.319076, -2.817147>
    }
    triangle {
      < 9.343640, -1.288234, -2.806063>,
      < 9.354388, -1.265352, -2.776094>,
      < 9.270059, -1.273519, -2.770604>
    }
    triangle {
      < 9.343640, -1.288234, -2.806063>,
      < 9.270059, -1.273519, -2.770604>,
      < 9.270059, -1.294850, -2.798639>
    }
    triangle {
      < 9.354388, -1.265352, -2.776094>,
      < 9.362471, -1.247656, -2.737591>,
      < 9.270059, -1.256751, -2.734026>
    }
    triangle {
      < 9.354388, -1.265352, -2.776094>,
      < 9.270059, -1.256751, -2.734026>,
      < 9.270059, -1.273519, -2.770604>
    }
    triangle {
      < 9.362471, -1.247656, -2.737591>,
      < 9.367479, -1.236482, -2.692837>,
      < 9.270059, -1.246052, -2.691093>
    }
    triangle {
      < 9.362471, -1.247656, -2.737591>,
      < 9.270059, -1.246052, -2.691093>,
      < 9.270059, -1.256751, -2.734026>
    }
    triangle {
      < 9.367479, -1.236482, -2.692837>,
      < 9.369174, -1.232667, -2.644820>,
      < 9.270059, -1.242382, -2.644820>
    }
    triangle {
      < 9.367479, -1.236482, -2.692837>,
      < 9.270059, -1.242382, -2.644820>,
      < 9.270059, -1.246052, -2.691093>
    }
    triangle {
      < 9.307826, -1.466830, -2.644820>,
      < 9.308381, -1.461597, -2.697894>,
      < 9.270059, -1.452059, -2.695912>
    }
    triangle {
      < 9.307826, -1.466830, -2.644820>,
      < 9.270059, -1.452059, -2.695912>,
      < 9.270059, -1.457104, -2.644820>
    }
    triangle {
      < 8.999084, -1.510549, -2.891735>,
      < 9.011996, -1.455721, -2.898409>,
      < 9.011996, -1.512208, -2.877201>
    }
    triangle {
      < 8.999141, -1.636898, -2.862385>,
      < 8.999084, -1.510549, -2.891735>,
      < 9.011996, -1.512208, -2.877201>
    }
    triangle {
      < 8.999141, -1.636898, -2.862385>,
      < 9.011996, -1.512208, -2.877201>,
      < 9.011996, -1.632657, -2.849308>
    }
    triangle {
      < 8.999117, -1.734657, -2.799072>,
      < 8.999141, -1.636898, -2.862385>,
      < 9.011996, -1.632657, -2.849308>
    }
    triangle {
      < 8.999117, -1.734657, -2.799072>,
      < 9.011996, -1.632657, -2.849308>,
      < 9.011996, -1.725083, -2.789415>
    }
    triangle {
      < 8.999216, -1.796273, -2.724938>,
      < 8.999117, -1.734657, -2.799072>,
      < 9.011996, -1.725083, -2.789415>
    }
    triangle {
      < 8.999216, -1.796273, -2.724938>,
      < 9.011996, -1.725083, -2.789415>,
      < 9.011996, -1.783185, -2.719670>
    }
    triangle {
      < 8.999288, -1.817396, -2.644820>,
      < 8.999216, -1.796273, -2.724938>,
      < 9.011996, -1.783185, -2.719670>
    }
    triangle {
      < 8.999288, -1.817396, -2.644820>,
      < 9.011996, -1.783185, -2.719670>,
      < 9.011996, -1.803000, -2.644820>
    }
    triangle {
      < 9.011996, -1.504979, -2.851875>,
      < 9.011996, -1.512208, -2.877201>,
      < 9.011996, -1.455721, -2.898409>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.591105, -2.725988>,
      < 9.011996, -1.596210, -2.678245>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.596210, -2.678245>,
      < 9.011996, -1.610935, -2.669820>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.610935, -2.669820>,
      < 9.011996, -1.756696, -2.669820>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.756696, -2.669820>,
      < 9.011996, -1.769008, -2.675535>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.769008, -2.675535>,
      < 9.011996, -1.760434, -2.707922>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.760434, -2.707922>,
      < 9.011996, -1.708303, -2.770498>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.708303, -2.770498>,
      < 9.011996, -1.622743, -2.825943>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.622743, -2.825943>,
      < 9.011996, -1.558760, -2.842789>
    }
    triangle {
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.558760, -2.842789>,
      < 9.011996, -1.546386, -2.833008>
    }
    triangle {
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.610935, -2.619820>,
      < 9.011996, -1.756696, -2.619820>
    }
    triangle {
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.756696, -2.619820>,
      < 9.011996, -1.803000, -2.644820>
    }
    triangle {
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.803000, -2.644820>,
      < 9.011996, -1.756696, -2.669820>
    }
    triangle {
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.756696, -2.669820>,
      < 9.011996, -1.610935, -2.669820>
    }
    triangle {
      < 9.011996, -1.803000, -2.644820>,
      < 9.011996, -1.783185, -2.719670>,
      < 9.011996, -1.760434, -2.707922>
    }
    triangle {
      < 9.011996, -1.803000, -2.644820>,
      < 9.011996, -1.760434, -2.707922>,
      < 9.011996, -1.769008, -2.675535>
    }
    triangle {
      < 9.011996, -1.783185, -2.719670>,
      < 9.011996, -1.725083, -2.789415>,
      < 9.011996, -1.708303, -2.770498>
    }
    triangle {
      < 9.011996, -1.783185, -2.719670>,
      < 9.011996, -1.708303, -2.770498>,
      < 9.011996, -1.760434, -2.707922>
    }
    triangle {
      < 9.011996, -1.725083, -2.789415>,
      < 9.011996, -1.632657, -2.849308>,
      < 9.011996, -1.622743, -2.825943>
    }
    triangle {
      < 9.011996, -1.725083, -2.789415>,
      < 9.011996, -1.622743, -2.825943>,
      < 9.011996, -1.708303, -2.770498>
    }
    triangle {
      < 9.011996, -1.632657, -2.849308>,
      < 9.011996, -1.512208, -2.877201>,
      < 9.011996, -1.558760, -2.842789>
    }
    triangle {
      < 9.011996, -1.632657, -2.849308>,
      < 9.011996, -1.558760, -2.842789>,
      < 9.011996, -1.622743, -2.825943>
    }
    triangle {
      < 9.011996, -1.512208, -2.877201>,
      < 9.011996, -1.504979, -2.851875>,
      < 9.011996, -1.546386, -2.833008>
    }
    triangle {
      < 9.011996, -1.512208, -2.877201>,
      < 9.011996, -1.546386, -2.833008>,
      < 9.011996, -1.558760, -2.842789>
    }
    triangle {
      < 9.011996, -1.504979, -2.851875>,
      < 9.011996, -1.542776, -2.791230>,
      < 9.011996, -1.565539, -2.801973>
    }
    triangle {
      < 9.011996, -1.504979, -2.851875>,
      < 9.011996, -1.565539, -2.801973>,
      < 9.011996, -1.546386, -2.833008>
    }
    triangle {
      < 9.011996, -1.542776, -2.791230>,
      < 9.011996, -1.566538, -2.720609>,
      < 9.011996, -1.591105, -2.725988>
    }
    triangle {
      < 9.011996, -1.542776, -2.791230>,
      < 9.011996, -1.591105, -2.725988>,
      < 9.011996, -1.565539, -2.801973>
    }
    triangle {
      < 9.011996, -1.566538, -2.720609>,
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.596210, -2.678245>
    }
    triangle {
      < 9.011996, -1.566538, -2.720609>,
      < 9.011996, -1.596210, -2.678245>,
      < 9.011996, -1.591105, -2.725988>
    }
    triangle {
      < 9.011996, -1.756696, -2.669820>,
      < 9.011996, -1.803000, -2.644820>,
      < 9.011996, -1.769008, -2.675535>
    }
    triangle {
      < 9.011996, -1.596210, -2.678245>,
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.610935, -2.669820>
    }
    triangle {
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.596210, -2.611395>,
      < 9.011996, -1.610935, -2.619820>
    }
    triangle {
      < 9.011996, -1.803000, -2.644820>,
      < 9.011996, -1.756696, -2.619820>,
      < 9.011996, -1.769008, -2.614105>
    }
    triangle {
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.566538, -2.569031>,
      < 9.011996, -1.591105, -2.563652>
    }
    triangle {
      < 9.011996, -1.574642, -2.644820>,
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.596210, -2.611395>
    }
    triangle {
      < 9.011996, -1.566538, -2.569031>,
      < 9.011996, -1.542776, -2.498410>,
      < 9.011996, -1.565539, -2.487667>
    }
    triangle {
      < 9.011996, -1.566538, -2.569031>,
      < 9.011996, -1.565539, -2.487667>,
      < 9.011996, -1.591105, -2.563652>
    }
    triangle {
      < 9.011996, -1.542776, -2.498410>,
      < 9.011996, -1.504979, -2.437765>,
      < 9.011996, -1.546386, -2.456632>
    }
    triangle {
      < 9.011996, -1.542776, -2.498410>,
      < 9.011996, -1.546386, -2.456632>,
      < 9.011996, -1.565539, -2.487667>
    }
    triangle {
      < 9.011996, -1.504979, -2.437765>,
      < 9.011996, -1.512208, -2.412439>,
      < 9.011996, -1.558760, -2.446851>
    }
    triangle {
      < 9.011996, -1.504979, -2.437765>,
      < 9.011996, -1.558760, -2.446851>,
      < 9.011996, -1.546386, -2.456632>
    }
    triangle {
      < 9.011996, -1.512208, -2.412439>,
      < 9.011996, -1.632657, -2.440332>,
      < 9.011996, -1.622743, -2.463698>
    }
    triangle {
      < 9.011996, -1.512208, -2.412439>,
      < 9.011996, -1.622743, -2.463698>,
      < 9.011996, -1.558760, -2.446851>
    }
    triangle {
      < 9.011996, -1.632657, -2.440332>,
      < 9.011996, -1.725083, -2.500225>,
      < 9.011996, -1.708303, -2.519142>
    }
    triangle {
      < 9.011996, -1.632657, -2.440332>,
      < 9.011996, -1.708303, -2.519142>,
      < 9.011996, -1.622743, -2.463698>
    }
    triangle {
      < 9.011996, -1.725083, -2.500225>,
      < 9.011996, -1.783185, -2.569970>,
      < 9.011996, -1.760434, -2.581719>
    }
    triangle {
      < 9.011996, -1.725083, -2.500225>,
      < 9.011996, -1.760434, -2.581719>,
      < 9.011996, -1.708303, -2.519142>
    }
    triangle {
      < 9.011996, -1.783185, -2.569970>,
      < 9.011996, -1.803000, -2.644820>,
      < 9.011996, -1.769008, -2.614105>
    }
    triangle {
      < 9.011996, -1.783185, -2.569970>,
      < 9.011996, -1.769008, -2.614105>,
      < 9.011996, -1.760434, -2.581719>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.565539, -2.487667>,
      < 9.011996, -1.546386, -2.456632>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.546386, -2.456632>,
      < 9.011996, -1.558760, -2.446851>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.558760, -2.446851>,
      < 9.011996, -1.622743, -2.463698>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.622743, -2.463698>,
      < 9.011996, -1.708303, -2.519142>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.708303, -2.519142>,
      < 9.011996, -1.760434, -2.581719>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.760434, -2.581719>,
      < 9.011996, -1.769008, -2.614105>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.769008, -2.614105>,
      < 9.011996, -1.756696, -2.619820>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.756696, -2.619820>,
      < 9.011996, -1.610935, -2.619820>
    }
    triangle {
      < 9.011996, -1.591105, -2.563652>,
      < 9.011996, -1.610935, -2.619820>,
      < 9.011996, -1.596210, -2.611395>
    }
    triangle {
      < 9.011996, -1.512208, -2.412439>,
      < 9.011996, -1.504979, -2.437765>,
      < 9.011996, -1.455721, -2.391231>
    }
    triangle {
      < 8.999216, -1.796273, -2.564702>,
      < 8.999288, -1.817396, -2.644820>,
      < 9.011996, -1.803000, -2.644820>
    }
    triangle {
      < 8.999216, -1.796273, -2.564702>,
      < 9.011996, -1.803000, -2.644820>,
      < 9.011996, -1.783185, -2.569970>
    }
    triangle {
      < 8.999117, -1.734657, -2.490569>,
      < 8.999216, -1.796273, -2.564702>,
      < 9.011996, -1.783185, -2.569970>
    }
    triangle {
      < 8.999117, -1.734657, -2.490569>,
      < 9.011996, -1.783185, -2.569970>,
      < 9.011996, -1.725083, -2.500225>
    }
    triangle {
      < 8.999141, -1.636898, -2.427255>,
      < 8.999117, -1.734657, -2.490569>,
      < 9.011996, -1.725083, -2.500225>
    }
    triangle {
      < 8.999141, -1.636898, -2.427255>,
      < 9.011996, -1.725083, -2.500225>,
      < 9.011996, -1.632657, -2.440332>
    }
    triangle {
      < 8.999084, -1.510549, -2.397905>,
      < 8.999141, -1.636898, -2.427255>,
      < 9.011996, -1.632657, -2.440332>
    }
    triangle {
      < 8.999084, -1.510549, -2.397905>,
      < 9.011996, -1.632657, -2.440332>,
      < 9.011996, -1.512208, -2.412439>
    }
    triangle {
      < 9.011996, -1.455721, -2.391231>,
      < 8.999084, -1.510549, -2.397905>,
      < 9.011996, -1.512208, -2.412439>
    }
    triangle {
      < 9.308381, -1.461597, -2.591746>,
      < 9.307826, -1.466830, -2.644820>,
      < 9.270059, -1.457104, -2.644820>
    }
    triangle {
      < 9.308381, -1.461597, -2.591746>,
      < 9.270059, -1.457104, -2.644820>,
      < 9.270059, -1.452059, -2.593728>
    }
    triangle {
      < 9.369174, -1.232667, -2.644820>,
      < 9.367479, -1.236482, -2.596803>,
      < 9.270059, -1.246052, -2.598547>
    }
    triangle {
      < 9.369174, -1.232667, -2.644820>,
      < 9.270059, -1.246052, -2.598547>,
      < 9.270059, -1.242382, -2.644820>
    }
    triangle {
      < 9.367479, -1.236482, -2.596803>,
      < 9.362471, -1.247656, -2.552050>,
      < 9.270059, -1.256751, -2.555614>
    }
    triangle {
      < 9.367479, -1.236482, -2.596803>,
      < 9.270059, -1.256751, -2.555614>,
      < 9.270059, -1.246052, -2.598547>
    }
    triangle {
      < 9.362471, -1.247656, -2.552050>,
      < 9.354388, -1.265352, -2.513546>,
      < 9.270059, -1.273519, -2.519037>
    }
    triangle {
      < 9.362471, -1.247656, -2.552050>,
      < 9.270059, -1.273519, -2.519037>,
      < 9.270059, -1.256751, -2.555614>
    }
    triangle {
      < 9.354388, -1.265352, -2.513546>,
      < 9.343640, -1.288234, -2.483577>,
      < 9.270059, -1.294850, -2.491002>
    }
    triangle {
      < 9.354388, -1.265352, -2.513546>,
      < 9.270059, -1.294850, -2.491002>,
      < 9.270059, -1.273519, -2.519037>
    }
    triangle {
      < 9.343640, -1.288234, -2.483577>,
      < 9.330718, -1.314826, -2.463363>,
      < 9.270059, -1.319076, -2.472493>
    }
    triangle {
      < 9.343640, -1.288234, -2.483577>,
      < 9.270059, -1.319076, -2.472493>,
      < 9.270059, -1.294850, -2.491002>
    }
    triangle {
      < 9.330718, -1.314826, -2.463363>,
      < 9.317037, -1.340499, -2.455050>,
      < 9.270059, -1.341180, -2.465543>
    }
    triangle {
      < 9.330718, -1.314826, -2.463363>,
      < 9.270059, -1.341180, -2.465543>,
      < 9.270059, -1.319076, -2.472493>
    }
    triangle {
      < 9.317037, -1.340499, -2.455050>,
      < 9.316450, -1.366276, -2.458895>,
      < 9.270059, -1.363081, -2.468503>
    }
    triangle {
      < 9.317037, -1.340499, -2.455050>,
      < 9.270059, -1.363081, -2.468503>,
      < 9.270059, -1.341180, -2.465543>
    }
    triangle {
      < 9.316450, -1.366276, -2.458895>,
      < 9.314498, -1.395712, -2.475014>,
      < 9.270059, -1.389757, -2.483034>
    }
    triangle {
      < 9.316450, -1.366276, -2.458895>,
      < 9.270059, -1.389757, -2.483034>,
      < 9.270059, -1.363081, -2.468503>
    }
    triangle {
      < 9.314498, -1.395712, -2.475014>,
      < 9.312142, -1.423590, -2.503422>,
      < 9.270059, -1.415792, -2.509480>
    }
    triangle {
      < 9.314498, -1.395712, -2.475014>,
      < 9.270059, -1.415792, -2.509480>,
      < 9.270059, -1.389757, -2.483034>
    }
    triangle {
      < 9.312142, -1.423590, -2.503422>,
      < 9.309932, -1.446544, -2.543265>,
      < 9.270059, -1.437610, -2.547268>
    }
    triangle {
      < 9.312142, -1.423590, -2.503422>,
      < 9.270059, -1.437610, -2.547268>,
      < 9.270059, -1.415792, -2.509480>
    }
    triangle {
      < 9.309932, -1.446544, -2.543265>,
      < 9.308381, -1.461597, -2.591746>,
      < 9.270059, -1.452059, -2.593728>
    }
    triangle {
      < 9.309932, -1.446544, -2.543265>,
      < 9.270059, -1.452059, -2.593728>,
      < 9.270059, -1.437610, -2.547268>
    }
    triangle {
      < 9.322242, -1.402857, -2.465390>,
      < 9.319310, -1.432948, -2.496153>,
      < 9.312142, -1.423590, -2.503422>
    }
    triangle {
      < 9.322242, -1.402857, -2.465390>,
      < 9.312142, -1.423590, -2.503422>,
      < 9.314498, -1.395712, -2.475014>
    }
    triangle {
      < 9.319310, -1.432948, -2.496153>,
      < 9.316745, -1.457265, -2.538462>,
      < 9.309932, -1.446544, -2.543265>
    }
    triangle {
      < 9.319310, -1.432948, -2.496153>,
      < 9.309932, -1.446544, -2.543265>,
      < 9.312142, -1.423590, -2.503422>
    }
    triangle {
      < 9.316745, -1.457265, -2.538462>,
      < 9.315006, -1.473042, -2.589368>,
      < 9.308381, -1.461597, -2.591746>
    }
    triangle {
      < 9.316745, -1.457265, -2.538462>,
      < 9.308381, -1.461597, -2.591746>,
      < 9.309932, -1.446544, -2.543265>
    }
    triangle {
      < 9.315006, -1.473042, -2.589368>,
      < 9.314393, -1.478501, -2.644820>,
      < 9.307826, -1.466830, -2.644820>
    }
    triangle {
      < 9.315006, -1.473042, -2.589368>,
      < 9.307826, -1.466830, -2.644820>,
      < 9.308381, -1.461597, -2.591746>
    }
    triangle {
      < 9.381806, -1.221010, -2.644820>,
      < 9.380066, -1.224998, -2.594712>,
      < 9.367479, -1.236482, -2.596803>
    }
    triangle {
      < 9.381806, -1.221010, -2.644820>,
      < 9.367479, -1.236482, -2.596803>,
      < 9.369174, -1.232667, -2.644820>
    }
    triangle {
      < 9.380066, -1.224998, -2.594712>,
      < 9.374908, -1.236742, -2.547772>,
      < 9.362471, -1.247656, -2.552050>
    }
    triangle {
      < 9.380066, -1.224998, -2.594712>,
      < 9.362471, -1.247656, -2.552050>,
      < 9.367479, -1.236482, -2.596803>
    }
    triangle {
      < 9.374908, -1.236742, -2.547772>,
      < 9.366538, -1.255551, -2.506957>,
      < 9.354388, -1.265352, -2.513546>
    }
    triangle {
      < 9.374908, -1.236742, -2.547772>,
      < 9.354388, -1.265352, -2.513546>,
      < 9.362471, -1.247656, -2.552050>
    }
    triangle {
      < 9.366538, -1.255551, -2.506957>,
      < 9.355305, -1.280296, -2.474667>,
      < 9.343640, -1.288234, -2.483577>
    }
    triangle {
      < 9.366538, -1.255551, -2.506957>,
      < 9.343640, -1.288234, -2.483577>,
      < 9.354388, -1.265352, -2.513546>
    }
    triangle {
      < 9.355305, -1.280296, -2.474667>,
      < 9.341655, -1.309691, -2.452433>,
      < 9.330718, -1.314826, -2.463363>
    }
    triangle {
      < 9.355305, -1.280296, -2.474667>,
      < 9.330718, -1.314826, -2.463363>,
      < 9.343640, -1.288234, -2.483577>
    }
    triangle {
      < 9.341655, -1.309691, -2.452433>,
      < 9.326846, -1.339696, -2.442525>,
      < 9.317037, -1.340499, -2.455050>
    }
    triangle {
      < 9.341655, -1.309691, -2.452433>,
      < 9.317037, -1.340499, -2.455050>,
      < 9.330718, -1.314826, -2.463363>
    }
    triangle {
      < 9.326846, -1.339696, -2.442525>,
      < 9.325043, -1.370153, -2.447393>,
      < 9.316450, -1.366276, -2.458895>
    }
    triangle {
      < 9.326846, -1.339696, -2.442525>,
      < 9.316450, -1.366276, -2.458895>,
      < 9.317037, -1.340499, -2.455050>
    }
    triangle {
      < 9.325043, -1.370153, -2.447393>,
      < 9.322242, -1.402857, -2.465390>,
      < 9.314498, -1.395712, -2.475014>
    }
    triangle {
      < 9.325043, -1.370153, -2.447393>,
      < 9.314498, -1.395712, -2.475014>,
      < 9.316450, -1.366276, -2.458895>
    }
    triangle {
      < 9.348357, -1.302375, -2.436980>,
      < 9.331939, -1.338572, -2.424857>,
      < 9.326846, -1.339696, -2.442525>
    }
    triangle {
      < 9.348357, -1.302375, -2.436980>,
      < 9.326846, -1.339696, -2.442525>,
      < 9.341655, -1.309691, -2.452433>
    }
    triangle {
      < 9.331939, -1.338572, -2.424857>,
      < 9.328403, -1.375694, -2.431128>,
      < 9.325043, -1.370153, -2.447393>
    }
    triangle {
      < 9.331939, -1.338572, -2.424857>,
      < 9.325043, -1.370153, -2.447393>,
      < 9.326846, -1.339696, -2.442525>
    }
    triangle {
      < 9.328403, -1.375694, -2.431128>,
      < 9.324411, -1.412976, -2.451754>,
      < 9.322242, -1.402857, -2.465390>
    }
    triangle {
      < 9.328403, -1.375694, -2.431128>,
      < 9.322242, -1.402857, -2.465390>,
      < 9.325043, -1.370153, -2.447393>
    }
    triangle {
      < 9.324411, -1.412976, -2.451754>,
      < 9.320664, -1.446203, -2.485855>,
      < 9.319310, -1.432948, -2.496153>
    }
    triangle {
      < 9.324411, -1.412976, -2.451754>,
      < 9.319310, -1.432948, -2.496153>,
      < 9.322242, -1.402857, -2.465390>
    }
    triangle {
      < 9.320664, -1.446203, -2.485855>,
      < 9.317596, -1.472453, -2.531657>,
      < 9.316745, -1.457265, -2.538462>
    }
    triangle {
      < 9.320664, -1.446203, -2.485855>,
      < 9.316745, -1.457265, -2.538462>,
      < 9.319310, -1.432948, -2.496153>
    }
    triangle {
      < 9.317596, -1.472453, -2.531657>,
      < 9.315593, -1.489255, -2.585999>,
      < 9.315006, -1.473042, -2.589368>
    }
    triangle {
      < 9.317596, -1.472453, -2.531657>,
      < 9.315006, -1.473042, -2.589368>,
      < 9.316745, -1.457265, -2.538462>
    }
    triangle {
      < 9.315593, -1.489255, -2.585999>,
      < 9.314896, -1.495034, -2.644820>,
      < 9.314393, -1.478501, -2.644820>
    }
    triangle {
      < 9.315593, -1.489255, -2.585999>,
      < 9.314393, -1.478501, -2.644820>,
      < 9.315006, -1.473042, -2.589368>
    }
    triangle {
      < 9.390900, -1.204495, -2.644820>,
      < 9.389095, -1.208729, -2.591748>,
      < 9.380066, -1.224998, -2.594712>
    }
    triangle {
      < 9.390900, -1.204495, -2.644820>,
      < 9.380066, -1.224998, -2.594712>,
      < 9.381806, -1.221010, -2.644820>
    }
    triangle {
      < 9.389095, -1.208729, -2.591748>,
      < 9.383728, -1.221281, -2.541713>,
      < 9.374908, -1.236742, -2.547772>
    }
    triangle {
      < 9.389095, -1.208729, -2.591748>,
      < 9.374908, -1.236742, -2.547772>,
      < 9.380066, -1.224998, -2.594712>
    }
    triangle {
      < 9.383728, -1.221281, -2.541713>,
      < 9.374948, -1.241667, -2.497623>,
      < 9.366538, -1.255551, -2.506957>
    }
    triangle {
      < 9.383728, -1.221281, -2.541713>,
      < 9.366538, -1.255551, -2.506957>,
      < 9.374908, -1.236742, -2.547772>
    }
    triangle {
      < 9.374948, -1.241667, -2.497623>,
      < 9.363029, -1.269052, -2.462044>,
      < 9.355305, -1.280296, -2.474667>
    }
    triangle {
      < 9.374948, -1.241667, -2.497623>,
      < 9.355305, -1.280296, -2.474667>,
      < 9.366538, -1.255551, -2.506957>
    }
    triangle {
      < 9.363029, -1.269052, -2.462044>,
      < 9.348357, -1.302375, -2.436980>,
      < 9.341655, -1.309691, -2.452433>
    }
    triangle {
      < 9.363029, -1.269052, -2.462044>,
      < 9.341655, -1.309691, -2.452433>,
      < 9.355305, -1.280296, -2.474667>
    }
    triangle {
      < 9.390391, -1.187980, -2.644820>,
      < 9.388523, -1.192460, -2.588784>,
      < 9.389095, -1.208729, -2.591748>
    }
    triangle {
      < 9.390391, -1.187980, -2.644820>,
      < 9.389095, -1.208729, -2.591748>,
      < 9.390900, -1.204495, -2.644820>
    }
    triangle {
      < 9.388523, -1.192460, -2.588784>,
      < 9.382946, -1.205820, -2.535654>,
      < 9.383728, -1.221281, -2.541713>
    }
    triangle {
      < 9.388523, -1.192460, -2.588784>,
      < 9.383728, -1.221281, -2.541713>,
      < 9.389095, -1.208729, -2.591748>
    }
    triangle {
      < 9.382946, -1.205820, -2.535654>,
      < 9.373755, -1.227783, -2.488288>,
      < 9.374948, -1.241667, -2.497623>
    }
    triangle {
      < 9.382946, -1.205820, -2.535654>,
      < 9.374948, -1.241667, -2.497623>,
      < 9.383728, -1.221281, -2.541713>
    }
    triangle {
      < 9.373755, -1.227783, -2.488288>,
      < 9.361150, -1.257808, -2.449421>,
      < 9.363029, -1.269052, -2.462044>
    }
    triangle {
      < 9.373755, -1.227783, -2.488288>,
      < 9.363029, -1.269052, -2.462044>,
      < 9.374948, -1.241667, -2.497623>
    }
    triangle {
      < 9.361150, -1.257808, -2.449421>,
      < 9.345465, -1.295034, -2.421546>,
      < 9.348357, -1.302375, -2.436980>
    }
    triangle {
      < 9.361150, -1.257808, -2.449421>,
      < 9.348357, -1.302375, -2.436980>,
      < 9.363029, -1.269052, -2.462044>
    }
    triangle {
      < 9.345465, -1.295034, -2.421546>,
      < 9.327429, -1.337455, -2.407234>,
      < 9.331939, -1.338572, -2.424857>
    }
    triangle {
      < 9.345465, -1.295034, -2.421546>,
      < 9.331939, -1.338572, -2.424857>,
      < 9.348357, -1.302375, -2.436980>
    }
    triangle {
      < 9.327429, -1.337455, -2.407234>,
      < 9.322154, -1.381266, -2.414880>,
      < 9.328403, -1.375694, -2.431128>
    }
    triangle {
      < 9.327429, -1.337455, -2.407234>,
      < 9.328403, -1.375694, -2.431128>,
      < 9.331939, -1.338572, -2.424857>
    }
    triangle {
      < 9.322154, -1.381266, -2.414880>,
      < 9.316981, -1.423095, -2.438118>,
      < 9.324411, -1.412976, -2.451754>
    }
    triangle {
      < 9.322154, -1.381266, -2.414880>,
      < 9.324411, -1.412976, -2.451754>,
      < 9.328403, -1.375694, -2.431128>
    }
    triangle {
      < 9.316981, -1.423095, -2.438118>,
      < 9.312419, -1.459459, -2.475556>,
      < 9.320664, -1.446203, -2.485855>
    }
    triangle {
      < 9.316981, -1.423095, -2.438118>,
      < 9.320664, -1.446203, -2.485855>,
      < 9.324411, -1.412976, -2.451754>
    }
    triangle {
      < 9.312419, -1.459459, -2.475556>,
      < 9.308848, -1.487641, -2.524852>,
      < 9.317596, -1.472453, -2.531657>
    }
    triangle {
      < 9.312419, -1.459459, -2.475556>,
      < 9.317596, -1.472453, -2.531657>,
      < 9.320664, -1.446203, -2.485855>
    }
    triangle {
      < 9.308848, -1.487641, -2.524852>,
      < 9.306579, -1.505469, -2.582629>,
      < 9.315593, -1.489255, -2.585999>
    }
    triangle {
      < 9.308848, -1.487641, -2.524852>,
      < 9.315593, -1.489255, -2.585999>,
      < 9.317596, -1.472453, -2.531657>
    }
    triangle {
      < 9.306579, -1.505469, -2.582629>,
      < 9.305799, -1.511568, -2.644820>,
      < 9.314896, -1.495034, -2.644820>
    }
    triangle {
      < 9.306579, -1.505469, -2.582629>,
      < 9.314896, -1.495034, -2.644820>,
      < 9.315593, -1.489255, -2.585999>
    }
    triangle {
      < 9.292098, -1.515007, -2.580647>,
      < 9.291270, -1.521293, -2.644820>,
      < 9.305799, -1.511568, -2.644820>
    }
    triangle {
      < 9.292098, -1.515007, -2.580647>,
      < 9.305799, -1.511568, -2.644820>,
      < 9.306579, -1.505469, -2.582629>
    }
    triangle {
      < 9.380916, -1.178265, -2.644820>,
      < 9.379009, -1.182890, -2.587041>,
      < 9.388523, -1.192460, -2.588784>
    }
    triangle {
      < 9.380916, -1.178265, -2.644820>,
      < 9.388523, -1.192460, -2.588784>,
      < 9.390391, -1.187980, -2.644820>
    }
    triangle {
      < 9.379009, -1.182890, -2.587041>,
      < 9.373309, -1.196726, -2.532090>,
      < 9.382946, -1.205820, -2.535654>
    }
    triangle {
      < 9.379009, -1.182890, -2.587041>,
      < 9.382946, -1.205820, -2.535654>,
      < 9.388523, -1.192460, -2.588784>
    }
    triangle {
      < 9.373309, -1.196726, -2.532090>,
      < 9.363877, -1.219617, -2.482797>,
      < 9.373755, -1.227783, -2.488288>
    }
    triangle {
      < 9.373309, -1.196726, -2.532090>,
      < 9.373755, -1.227783, -2.488288>,
      < 9.382946, -1.205820, -2.535654>
    }
    triangle {
      < 9.363877, -1.219617, -2.482797>,
      < 9.350867, -1.251195, -2.441995>,
      < 9.361150, -1.257808, -2.449421>
    }
    triangle {
      < 9.363877, -1.219617, -2.482797>,
      < 9.361150, -1.257808, -2.449421>,
      < 9.373755, -1.227783, -2.488288>
    }
    triangle {
      < 9.350867, -1.251195, -2.441995>,
      < 9.334587, -1.290710, -2.412472>,
      < 9.345465, -1.295034, -2.421546>
    }
    triangle {
      < 9.350867, -1.251195, -2.441995>,
      < 9.345465, -1.295034, -2.421546>,
      < 9.361150, -1.257808, -2.449421>
    }
    triangle {
      < 9.334587, -1.290710, -2.412472>,
      < 9.315598, -1.336800, -2.396878>,
      < 9.327429, -1.337455, -2.407234>
    }
    triangle {
      < 9.334587, -1.290710, -2.412472>,
      < 9.327429, -1.337455, -2.407234>,
      < 9.345465, -1.295034, -2.421546>
    }
    triangle {
      < 9.315598, -1.336800, -2.396878>,
      < 9.309299, -1.384550, -2.405327>,
      < 9.322154, -1.381266, -2.414880>
    }
    triangle {
      < 9.315598, -1.336800, -2.396878>,
      < 9.322154, -1.381266, -2.414880>,
      < 9.327429, -1.337455, -2.407234>
    }
    triangle {
      < 9.309299, -1.384550, -2.405327>,
      < 9.303433, -1.429047, -2.430096>,
      < 9.316981, -1.423095, -2.438118>
    }
    triangle {
      < 9.309299, -1.384550, -2.405327>,
      < 9.316981, -1.423095, -2.438118>,
      < 9.322154, -1.381266, -2.414880>
    }
    triangle {
      < 9.303433, -1.429047, -2.430096>,
      < 9.298392, -1.467256, -2.469498>,
      < 9.312419, -1.459459, -2.475556>
    }
    triangle {
      < 9.303433, -1.429047, -2.430096>,
      < 9.312419, -1.459459, -2.475556>,
      < 9.316981, -1.423095, -2.438118>
    }
    triangle {
      < 9.298392, -1.467256, -2.469498>,
      < 9.294526, -1.496575, -2.520849>,
      < 9.308848, -1.487641, -2.524852>
    }
    triangle {
      < 9.298392, -1.467256, -2.469498>,
      < 9.308848, -1.487641, -2.524852>,
      < 9.312419, -1.459459, -2.475556>
    }
    triangle {
      < 9.294526, -1.496575, -2.520849>,
      < 9.292098, -1.515007, -2.580647>,
      < 9.306579, -1.505469, -2.582629>
    }
    triangle {
      < 9.294526, -1.496575, -2.520849>,
      < 9.306579, -1.505469, -2.582629>,
      < 9.308848, -1.487641, -2.524852>
    }
    triangle {
      < 8.335473, -1.231890, -2.401848>,
      < 8.302703, -1.293414, -2.381948>,
      < 8.460090, -1.282344, -2.384554>
    }
    triangle {
      < 8.459869, -1.411076, -2.387335>,
      < 8.208865, -1.466886, -2.392249>,
      < 8.205842, -1.472367, -2.393822>
    }
    triangle {
      < 8.459869, -1.411076, -2.387335>,
      < 8.205842, -1.472367, -2.393822>,
      < 8.981197, -1.455721, -2.391231>
    }
    triangle {
      < 8.459869, -1.411076, -2.387335>,
      < 8.981197, -1.455721, -2.391231>,
      < 8.981197, -1.427040, -2.376605>
    }
    triangle {
      < 8.448472, -1.346491, -2.316001>,
      < 8.460090, -1.282344, -2.384554>,
      < 8.319522, -1.348837, -2.384191>
    }
    triangle {
      < 8.459869, -1.411076, -2.387335>,
      < 8.448472, -1.346491, -2.316001>,
      < 8.319522, -1.348837, -2.384191>
    }
    triangle {
      < 9.219997, -1.336800, -2.375373>,
      < 9.114798, -1.277995, -2.370095>,
      < 9.114798, -1.336800, -2.338804>
    }
    triangle {
      < 9.114798, -1.395606, -2.370095>,
      < 9.219997, -1.336800, -2.375373>,
      < 9.114798, -1.336800, -2.338804>
    }
    triangle {
      < 8.448472, -1.346491, -2.316001>,
      < 8.459869, -1.411076, -2.387335>,
      < 8.981197, -1.427040, -2.376605>
    }
    triangle {
      < 8.448472, -1.346491, -2.316001>,
      < 8.981197, -1.427040, -2.376605>,
      < 8.981197, -1.336800, -2.299201>
    }
    triangle {
      < 8.460090, -1.282344, -2.384554>,
      < 8.448472, -1.346491, -2.316001>,
      < 8.981197, -1.336800, -2.299201>
    }
    triangle {
      < 8.460090, -1.282344, -2.384554>,
      < 8.981197, -1.336800, -2.299201>,
      < 8.981197, -1.246561, -2.376605>
    }
    triangle {
      < 8.205842, -1.472367, -2.393822>,
      < 8.170268, -1.538336, -2.406514>,
      < 8.981197, -1.506510, -2.391231>
    }
    triangle {
      < 8.205842, -1.472367, -2.393822>,
      < 8.981197, -1.506510, -2.391231>,
      < 8.981197, -1.455721, -2.391231>
    }
    triangle {
      < 8.230967, -1.425997, -2.390388>,
      < 8.208865, -1.466886, -2.392249>,
      < 8.459869, -1.411076, -2.387335>
    }
    triangle {
      < 8.170268, -1.538336, -2.406514>,
      < 8.093800, -1.679864, -2.436767>,
      < 8.981197, -1.637952, -2.421669>
    }
    triangle {
      < 8.170268, -1.538336, -2.406514>,
      < 8.981197, -1.637952, -2.421669>,
      < 8.981197, -1.506510, -2.391231>
    }
    triangle {
      < 8.267190, -1.359515, -2.384410>,
      < 8.230967, -1.425997, -2.390388>,
      < 8.459869, -1.411076, -2.387335>
    }
    triangle {
      < 8.267190, -1.359515, -2.384410>,
      < 8.459869, -1.411076, -2.387335>,
      < 8.319522, -1.348837, -2.384191>
    }
    triangle {
      < 8.405093, -1.099273, -2.644820>,
      < 8.400378, -1.108249, -2.571100>,
      < 8.981197, -1.107063, -2.569031>
    }
    triangle {
      < 8.405093, -1.099273, -2.644820>,
      < 8.981197, -1.107063, -2.569031>,
      < 8.981197, -1.098959, -2.644820>
    }
    triangle {
      < 8.400378, -1.108249, -2.571100>,
      < 8.386551, -1.134575, -2.502693>,
      < 8.981197, -1.130823, -2.498410>
    }
    triangle {
      < 8.400378, -1.108249, -2.571100>,
      < 8.981197, -1.130823, -2.498410>,
      < 8.981197, -1.107063, -2.569031>
    }
    triangle {
      < 8.386551, -1.134575, -2.502693>,
      < 8.364557, -1.176428, -2.444590>,
      < 8.981197, -1.168621, -2.437765>
    }
    triangle {
      < 8.386551, -1.134575, -2.502693>,
      < 8.981197, -1.168621, -2.437765>,
      < 8.981197, -1.130823, -2.498410>
    }
    triangle {
      < 8.364557, -1.176428, -2.444590>,
      < 8.339134, -1.223811, -2.405575>,
      < 8.981197, -1.217880, -2.391231>
    }
    triangle {
      < 8.364557, -1.176428, -2.444590>,
      < 8.981197, -1.217880, -2.391231>,
      < 8.981197, -1.168621, -2.437765>
    }
    triangle {
      < 8.335473, -1.231890, -2.401848>,
      < 8.460090, -1.282344, -2.384554>,
      < 8.981197, -1.246561, -2.376605>
    }
    triangle {
      < 8.335473, -1.231890, -2.401848>,
      < 8.981197, -1.246561, -2.376605>,
      < 8.981197, -1.217880, -2.391231>
    }
    triangle {
      < 8.335473, -1.231890, -2.401848>,
      < 8.981197, -1.217880, -2.391231>,
      < 8.339134, -1.223811, -2.405575>
    }
    triangle {
      < 8.302703, -1.293414, -2.381948>,
      < 8.267190, -1.359515, -2.384410>,
      < 8.319522, -1.348837, -2.384191>
    }
    triangle {
      < 8.302703, -1.293414, -2.381948>,
      < 8.319522, -1.348837, -2.384191>,
      < 8.460090, -1.282344, -2.384554>
    }
    triangle {
      < 8.093800, -1.679864, -2.436767>,
      < 8.080274, -1.783448, -2.496820>,
      < 8.981197, -1.738812, -2.487029>
    }
    triangle {
      < 8.093800, -1.679864, -2.436767>,
      < 8.981197, -1.738812, -2.487029>,
      < 8.981197, -1.637952, -2.421669>
    }
    triangle {
      < 8.085253, -1.849633, -2.567045>,
      < 8.092828, -1.873096, -2.644820>,
      < 8.981197, -1.823841, -2.644820>
    }
    triangle {
      < 8.085253, -1.849633, -2.567045>,
      < 8.981197, -1.823841, -2.644820>,
      < 8.981197, -1.802217, -2.563139>
    }
    triangle {
      < 8.080274, -1.783448, -2.496820>,
      < 8.085253, -1.849633, -2.567045>,
      < 8.981197, -1.802217, -2.563139>
    }
    triangle {
      < 8.080274, -1.783448, -2.496820>,
      < 8.981197, -1.802217, -2.563139>,
      < 8.981197, -1.738812, -2.487029>
    }
    triangle {
      < 9.011996, -1.455721, -2.391231>,
      < 8.981197, -1.455721, -2.391231>,
      < 8.981197, -1.506510, -2.391231>
    }
    triangle {
      < 9.011996, -1.455721, -2.391231>,
      < 8.981197, -1.506510, -2.391231>,
      < 8.999084, -1.510549, -2.397905>
    }
    triangle {
      < 8.999288, -1.817396, -2.644820>,
      < 8.999216, -1.796273, -2.564702>,
      < 8.981197, -1.802217, -2.563139>
    }
    triangle {
      < 8.999288, -1.817396, -2.644820>,
      < 8.981197, -1.802217, -2.563139>,
      < 8.981197, -1.823841, -2.644820>
    }
    triangle {
      < 8.999216, -1.796273, -2.564702>,
      < 8.999117, -1.734657, -2.490569>,
      < 8.981197, -1.738812, -2.487029>
    }
    triangle {
      < 8.999216, -1.796273, -2.564702>,
      < 8.981197, -1.738812, -2.487029>,
      < 8.981197, -1.802217, -2.563139>
    }
    triangle {
      < 8.999117, -1.734657, -2.490569>,
      < 8.999141, -1.636898, -2.427255>,
      < 8.981197, -1.637952, -2.421669>
    }
    triangle {
      < 8.999117, -1.734657, -2.490569>,
      < 8.981197, -1.637952, -2.421669>,
      < 8.981197, -1.738812, -2.487029>
    }
    triangle {
      < 8.999141, -1.636898, -2.427255>,
      < 8.999084, -1.510549, -2.397905>,
      < 8.981197, -1.506510, -2.391231>
    }
    triangle {
      < 8.999141, -1.636898, -2.427255>,
      < 8.981197, -1.506510, -2.391231>,
      < 8.981197, -1.637952, -2.421669>
    }
    triangle {
      < 9.011996, -1.427040, -2.376605>,
      < 8.981197, -1.427040, -2.376605>,
      < 8.981197, -1.455721, -2.391231>
    }
    triangle {
      < 9.011996, -1.427040, -2.376605>,
      < 8.981197, -1.455721, -2.391231>,
      < 9.011996, -1.455721, -2.391231>
    }
    triangle {
      < 9.011996, -1.427040, -2.376605>,
      < 9.011996, -1.336800, -2.304001>,
      < 8.981197, -1.336800, -2.299201>
    }
    triangle {
      < 9.011996, -1.427040, -2.376605>,
      < 8.981197, -1.336800, -2.299201>,
      < 8.981197, -1.427040, -2.376605>
    }
    triangle {
      < 8.981197, -1.336800, -2.299201>,
      < 9.011996, -1.336800, -2.304001>,
      < 9.011996, -1.246561, -2.376605>
    }
    triangle {
      < 8.981197, -1.336800, -2.299201>,
      < 9.011996, -1.246561, -2.376605>,
      < 8.981197, -1.246561, -2.376605>
    }
    triangle {
      < 9.011996, -1.246561, -2.376605>,
      < 9.011996, -1.217880, -2.391231>,
      < 8.981197, -1.217880, -2.391231>
    }
    triangle {
      < 9.011996, -1.246561, -2.376605>,
      < 8.981197, -1.217880, -2.391231>,
      < 8.981197, -1.246561, -2.376605>
    }
    triangle {
      < 9.011996, -1.217880, -2.391231>,
      < 9.011996, -1.168621, -2.437765>,
      < 8.981197, -1.168621, -2.437765>
    }
    triangle {
      < 9.011996, -1.217880, -2.391231>,
      < 8.981197, -1.168621, -2.437765>,
      < 8.981197, -1.217880, -2.391231>
    }
    triangle {
      < 9.011996, -1.168621, -2.437765>,
      < 9.011996, -1.130823, -2.498410>,
      < 8.981197, -1.130823, -2.498410>
    }
    triangle {
      < 9.011996, -1.168621, -2.437765>,
      < 8.981197, -1.130823, -2.498410>,
      < 8.981197, -1.168621, -2.437765>
    }
    triangle {
      < 9.011996, -1.130823, -2.498410>,
      < 9.011996, -1.107063, -2.569031>,
      < 8.981197, -1.107063, -2.569031>
    }
    triangle {
      < 9.011996, -1.130823, -2.498410>,
      < 8.981197, -1.107063, -2.569031>,
      < 8.981197, -1.130823, -2.498410>
    }
    triangle {
      < 9.011996, -1.107063, -2.569031>,
      < 9.011996, -1.098959, -2.644820>,
      < 8.981197, -1.098959, -2.644820>
    }
    triangle {
      < 9.011996, -1.107063, -2.569031>,
      < 8.981197, -1.098959, -2.644820>,
      < 8.981197, -1.107063, -2.569031>
    }
    triangle {
      < 9.114798, -1.564006, -2.644820>,
      < 9.114798, -1.556264, -2.571207>,
      < 9.011996, -1.566538, -2.569031>
    }
    triangle {
      < 9.114798, -1.564006, -2.644820>,
      < 9.011996, -1.566538, -2.569031>,
      < 9.011996, -1.574642, -2.644820>
    }
    triangle {
      < 9.114798, -1.556264, -2.571207>,
      < 9.114798, -1.533566, -2.502611>,
      < 9.011996, -1.542776, -2.498410>
    }
    triangle {
      < 9.114798, -1.556264, -2.571207>,
      < 9.011996, -1.542776, -2.498410>,
      < 9.011996, -1.566538, -2.569031>
    }
    triangle {
      < 9.114798, -1.533566, -2.502611>,
      < 9.114798, -1.497459, -2.443707>,
      < 9.011996, -1.504979, -2.437765>
    }
    triangle {
      < 9.114798, -1.533566, -2.502611>,
      < 9.011996, -1.504979, -2.437765>,
      < 9.011996, -1.542776, -2.498410>
    }
    triangle {
      < 9.114798, -1.497459, -2.443707>,
      < 9.114798, -1.450403, -2.398508>,
      < 9.011996, -1.455721, -2.391231>
    }
    triangle {
      < 9.114798, -1.497459, -2.443707>,
      < 9.011996, -1.455721, -2.391231>,
      < 9.011996, -1.504979, -2.437765>
    }
    triangle {
      < 9.114798, -1.450403, -2.398508>,
      < 9.114798, -1.395606, -2.370095>,
      < 9.011996, -1.427040, -2.376605>
    }
    triangle {
      < 9.114798, -1.450403, -2.398508>,
      < 9.011996, -1.427040, -2.376605>,
      < 9.011996, -1.455721, -2.391231>
    }
    triangle {
      < 9.114798, -1.395606, -2.370095>,
      < 9.114798, -1.336800, -2.338804>,
      < 9.011996, -1.336800, -2.304001>
    }
    triangle {
      < 9.114798, -1.395606, -2.370095>,
      < 9.011996, -1.336800, -2.304001>,
      < 9.011996, -1.427040, -2.376605>
    }
    triangle {
      < 9.114798, -1.336800, -2.338804>,
      < 9.114798, -1.277995, -2.370095>,
      < 9.011996, -1.246561, -2.376605>
    }
    triangle {
      < 9.114798, -1.336800, -2.338804>,
      < 9.011996, -1.246561, -2.376605>,
      < 9.011996, -1.336800, -2.304001>
    }
    triangle {
      < 9.114798, -1.277995, -2.370095>,
      < 9.114798, -1.223197, -2.398508>,
      < 9.011996, -1.217880, -2.391231>
    }
    triangle {
      < 9.114798, -1.277995, -2.370095>,
      < 9.011996, -1.217880, -2.391231>,
      < 9.011996, -1.246561, -2.376605>
    }
    triangle {
      < 9.114798, -1.223197, -2.398508>,
      < 9.114798, -1.176142, -2.443707>,
      < 9.011996, -1.168621, -2.437765>
    }
    triangle {
      < 9.114798, -1.223197, -2.398508>,
      < 9.011996, -1.168621, -2.437765>,
      < 9.011996, -1.217880, -2.391231>
    }
    triangle {
      < 9.114798, -1.176142, -2.443707>,
      < 9.114798, -1.140034, -2.502611>,
      < 9.011996, -1.130823, -2.498410>
    }
    triangle {
      < 9.114798, -1.176142, -2.443707>,
      < 9.011996, -1.130823, -2.498410>,
      < 9.011996, -1.168621, -2.437765>
    }
    triangle {
      < 9.114798, -1.140034, -2.502611>,
      < 9.114798, -1.117336, -2.571207>,
      < 9.011996, -1.107063, -2.569031>
    }
    triangle {
      < 9.114798, -1.140034, -2.502611>,
      < 9.011996, -1.107063, -2.569031>,
      < 9.011996, -1.130823, -2.498410>
    }
    triangle {
      < 9.114798, -1.117336, -2.571207>,
      < 9.114798, -1.109594, -2.644820>,
      < 9.011996, -1.098959, -2.644820>
    }
    triangle {
      < 9.114798, -1.117336, -2.571207>,
      < 9.011996, -1.098959, -2.644820>,
      < 9.011996, -1.107063, -2.569031>
    }
    triangle {
      < 9.219997, -1.152701, -2.510096>,
      < 9.219997, -1.131464, -2.575081>,
      < 9.114798, -1.117336, -2.571207>
    }
    triangle {
      < 9.219997, -1.152701, -2.510096>,
      < 9.114798, -1.117336, -2.571207>,
      < 9.114798, -1.140034, -2.502611>
    }
    triangle {
      < 9.219997, -1.131464, -2.575081>,
      < 9.219997, -1.124221, -2.644820>,
      < 9.114798, -1.109594, -2.644820>
    }
    triangle {
      < 9.219997, -1.131464, -2.575081>,
      < 9.114798, -1.109594, -2.644820>,
      < 9.114798, -1.117336, -2.571207>
    }
    triangle {
      < 9.219997, -1.549379, -2.644820>,
      < 9.219997, -1.542136, -2.575081>,
      < 9.114798, -1.556264, -2.571207>
    }
    triangle {
      < 9.219997, -1.549379, -2.644820>,
      < 9.114798, -1.556264, -2.571207>,
      < 9.114798, -1.564006, -2.644820>
    }
    triangle {
      < 9.219997, -1.542136, -2.575081>,
      < 9.219997, -1.520899, -2.510096>,
      < 9.114798, -1.533566, -2.502611>
    }
    triangle {
      < 9.219997, -1.542136, -2.575081>,
      < 9.114798, -1.533566, -2.502611>,
      < 9.114798, -1.556264, -2.571207>
    }
    triangle {
      < 9.219997, -1.520899, -2.510096>,
      < 9.219997, -1.487116, -2.454291>,
      < 9.114798, -1.497459, -2.443707>
    }
    triangle {
      < 9.219997, -1.520899, -2.510096>,
      < 9.114798, -1.497459, -2.443707>,
      < 9.114798, -1.533566, -2.502611>
    }
    triangle {
      < 9.219997, -1.487116, -2.454291>,
      < 9.219997, -1.443090, -2.411471>,
      < 9.114798, -1.450403, -2.398508>
    }
    triangle {
      < 9.219997, -1.487116, -2.454291>,
      < 9.114798, -1.450403, -2.398508>,
      < 9.114798, -1.497459, -2.443707>
    }
    triangle {
      < 9.219997, -1.443090, -2.411471>,
      < 9.219997, -1.391820, -2.384554>,
      < 9.114798, -1.395606, -2.370095>
    }
    triangle {
      < 9.219997, -1.443090, -2.411471>,
      < 9.114798, -1.395606, -2.370095>,
      < 9.114798, -1.450403, -2.398508>
    }
    triangle {
      < 9.219997, -1.391820, -2.384554>,
      < 9.219997, -1.336800, -2.375373>,
      < 9.114798, -1.395606, -2.370095>
    }
    triangle {
      < 9.219997, -1.336800, -2.375373>,
      < 9.219997, -1.281780, -2.384554>,
      < 9.114798, -1.277995, -2.370095>
    }
    triangle {
      < 9.219997, -1.281780, -2.384554>,
      < 9.219997, -1.230511, -2.411471>,
      < 9.114798, -1.223197, -2.398508>
    }
    triangle {
      < 9.219997, -1.281780, -2.384554>,
      < 9.114798, -1.223197, -2.398508>,
      < 9.114798, -1.277995, -2.370095>
    }
    triangle {
      < 9.219997, -1.230511, -2.411471>,
      < 9.219997, -1.186484, -2.454291>,
      < 9.114798, -1.176142, -2.443707>
    }
    triangle {
      < 9.219997, -1.230511, -2.411471>,
      < 9.114798, -1.176142, -2.443707>,
      < 9.114798, -1.223197, -2.398508>
    }
    triangle {
      < 9.219997, -1.186484, -2.454291>,
      < 9.219997, -1.152701, -2.510096>,
      < 9.114798, -1.140034, -2.502611>
    }
    triangle {
      < 9.219997, -1.186484, -2.454291>,
      < 9.114798, -1.140034, -2.502611>,
      < 9.114798, -1.176142, -2.443707>
    }
    triangle {
      < 9.315598, -1.288637, -2.405327>,
      < 9.315598, -1.243755, -2.430096>,
      < 9.219997, -1.230511, -2.411471>
    }
    triangle {
      < 9.315598, -1.288637, -2.405327>,
      < 9.219997, -1.230511, -2.411471>,
      < 9.219997, -1.281780, -2.384554>
    }
    triangle {
      < 9.315598, -1.243755, -2.430096>,
      < 9.315598, -1.205215, -2.469498>,
      < 9.219997, -1.186484, -2.454291>
    }
    triangle {
      < 9.315598, -1.243755, -2.430096>,
      < 9.219997, -1.186484, -2.454291>,
      < 9.219997, -1.230511, -2.411471>
    }
    triangle {
      < 9.315598, -1.205215, -2.469498>,
      < 9.315598, -1.175642, -2.520849>,
      < 9.219997, -1.152701, -2.510096>
    }
    triangle {
      < 9.315598, -1.205215, -2.469498>,
      < 9.219997, -1.152701, -2.510096>,
      < 9.219997, -1.186484, -2.454291>
    }
    triangle {
      < 9.315598, -1.175642, -2.520849>,
      < 9.315598, -1.157051, -2.580647>,
      < 9.219997, -1.131464, -2.575081>
    }
    triangle {
      < 9.315598, -1.175642, -2.520849>,
      < 9.219997, -1.131464, -2.575081>,
      < 9.219997, -1.152701, -2.510096>
    }
    triangle {
      < 9.315598, -1.157051, -2.580647>,
      < 9.315598, -1.150710, -2.644820>,
      < 9.219997, -1.124221, -2.644820>
    }
    triangle {
      < 9.315598, -1.157051, -2.580647>,
      < 9.219997, -1.124221, -2.644820>,
      < 9.219997, -1.131464, -2.575081>
    }
    triangle {
      < 9.291270, -1.521293, -2.644820>,
      < 9.292098, -1.515007, -2.580647>,
      < 9.219997, -1.542136, -2.575081>
    }
    triangle {
      < 9.291270, -1.521293, -2.644820>,
      < 9.219997, -1.542136, -2.575081>,
      < 9.219997, -1.549379, -2.644820>
    }
    triangle {
      < 9.292098, -1.515007, -2.580647>,
      < 9.294526, -1.496575, -2.520849>,
      < 9.219997, -1.520899, -2.510096>
    }
    triangle {
      < 9.292098, -1.515007, -2.580647>,
      < 9.219997, -1.520899, -2.510096>,
      < 9.219997, -1.542136, -2.575081>
    }
    triangle {
      < 9.294526, -1.496575, -2.520849>,
      < 9.298392, -1.467256, -2.469498>,
      < 9.219997, -1.487116, -2.454291>
    }
    triangle {
      < 9.294526, -1.496575, -2.520849>,
      < 9.219997, -1.487116, -2.454291>,
      < 9.219997, -1.520899, -2.510096>
    }
    triangle {
      < 9.298392, -1.467256, -2.469498>,
      < 9.303433, -1.429047, -2.430096>,
      < 9.219997, -1.443090, -2.411471>
    }
    triangle {
      < 9.298392, -1.467256, -2.469498>,
      < 9.219997, -1.443090, -2.411471>,
      < 9.219997, -1.487116, -2.454291>
    }
    triangle {
      < 9.303433, -1.429047, -2.430096>,
      < 9.309299, -1.384550, -2.405327>,
      < 9.219997, -1.391820, -2.384554>
    }
    triangle {
      < 9.303433, -1.429047, -2.430096>,
      < 9.219997, -1.391820, -2.384554>,
      < 9.219997, -1.443090, -2.411471>
    }
    triangle {
      < 9.309299, -1.384550, -2.405327>,
      < 9.315598, -1.336800, -2.396878>,
      < 9.219997, -1.336800, -2.375373>
    }
    triangle {
      < 9.309299, -1.384550, -2.405327>,
      < 9.219997, -1.336800, -2.375373>,
      < 9.219997, -1.391820, -2.384554>
    }
    triangle {
      < 9.315598, -1.336800, -2.396878>,
      < 9.315598, -1.288637, -2.405327>,
      < 9.219997, -1.281780, -2.384554>
    }
    triangle {
      < 9.315598, -1.336800, -2.396878>,
      < 9.219997, -1.281780, -2.384554>,
      < 9.219997, -1.336800, -2.375373>
    }
    triangle {
      < 9.334587, -1.290710, -2.412472>,
      < 9.315598, -1.288637, -2.405327>,
      < 9.315598, -1.336800, -2.396878>
    }
    triangle {
      < 9.350867, -1.251195, -2.441995>,
      < 9.315598, -1.243755, -2.430096>,
      < 9.315598, -1.288637, -2.405327>
    }
    triangle {
      < 9.350867, -1.251195, -2.441995>,
      < 9.315598, -1.288637, -2.405327>,
      < 9.334587, -1.290710, -2.412472>
    }
    triangle {
      < 9.363877, -1.219617, -2.482797>,
      < 9.315598, -1.205215, -2.469498>,
      < 9.315598, -1.243755, -2.430096>
    }
    triangle {
      < 9.363877, -1.219617, -2.482797>,
      < 9.315598, -1.243755, -2.430096>,
      < 9.350867, -1.251195, -2.441995>
    }
    triangle {
      < 9.373309, -1.196726, -2.532090>,
      < 9.315598, -1.175642, -2.520849>,
      < 9.315598, -1.205215, -2.469498>
    }
    triangle {
      < 9.373309, -1.196726, -2.532090>,
      < 9.315598, -1.205215, -2.469498>,
      < 9.363877, -1.219617, -2.482797>
    }
    triangle {
      < 9.379009, -1.182890, -2.587041>,
      < 9.315598, -1.157051, -2.580647>,
      < 9.315598, -1.175642, -2.520849>
    }
    triangle {
      < 9.379009, -1.182890, -2.587041>,
      < 9.315598, -1.175642, -2.520849>,
      < 9.373309, -1.196726, -2.532090>
    }
    triangle {
      < 9.380916, -1.178265, -2.644820>,
      < 9.315598, -1.150710, -2.644820>,
      < 9.315598, -1.157051, -2.580647>
    }
    triangle {
      < 9.380916, -1.178265, -2.644820>,
      < 9.315598, -1.157051, -2.580647>,
      < 9.379009, -1.182890, -2.587041>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.154132, -1.525767, -2.866223>,
      < 8.077214, -1.667549, -2.837213>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.077214, -1.667549, -2.837213>,
      < 8.065619, -1.771058, -2.779412>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.065619, -1.771058, -2.779412>,
      < 8.072523, -1.834216, -2.713687>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.072523, -1.834216, -2.713687>,
      < 8.080665, -1.855267, -2.644820>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.080665, -1.855267, -2.644820>,
      < 8.072523, -1.834216, -2.575953>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.072523, -1.834216, -2.575953>,
      < 8.065619, -1.771058, -2.510228>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.065619, -1.771058, -2.510228>,
      < 8.077214, -1.667549, -2.452427>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.077214, -1.667549, -2.452427>,
      < 8.154132, -1.525767, -2.423417>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.154132, -1.525767, -2.423417>,
      < 8.184558, -1.469478, -2.412012>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.184558, -1.469478, -2.412012>,
      < 8.214829, -1.413472, -2.406681>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.214829, -1.413472, -2.406681>,
      < 8.249680, -1.349446, -2.402216>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.249680, -1.349446, -2.402216>,
      < 8.282547, -1.289467, -2.402460>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.282547, -1.289467, -2.402460>,
      < 8.313235, -1.233391, -2.421941>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.313235, -1.233391, -2.421941>,
      < 8.339499, -1.185391, -2.462717>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.339499, -1.185391, -2.462717>,
      < 8.359615, -1.148616, -2.515956>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.359615, -1.148616, -2.515956>,
      < 8.372250, -1.125510, -2.578075>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.372250, -1.125510, -2.578075>,
      < 8.376558, -1.117629, -2.644820>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.376558, -1.117629, -2.644820>,
      < 8.372250, -1.125510, -2.711565>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.372250, -1.125510, -2.711565>,
      < 8.359615, -1.148616, -2.773684>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.359615, -1.148616, -2.773684>,
      < 8.339499, -1.185391, -2.826924>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.339499, -1.185391, -2.826924>,
      < 8.313235, -1.233391, -2.867699>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.313235, -1.233391, -2.867699>,
      < 8.282547, -1.289467, -2.887181>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.282547, -1.289467, -2.887181>,
      < 8.249680, -1.349446, -2.887426>
    }
    triangle {
      < 8.184558, -1.469478, -2.877629>,
      < 8.249680, -1.349446, -2.887426>,
      < 8.214829, -1.413472, -2.882961>
    }
    triangle {
      < 8.187676, -1.474211, -2.398489>,
      < 8.205842, -1.472367, -2.393822>,
      < 8.208865, -1.466886, -2.392249>
    }
    triangle {
      < 8.321421, -1.228575, -2.409326>,
      < 8.335473, -1.231890, -2.401848>,
      < 8.339134, -1.223811, -2.405575>
    }
    triangle {
      < 8.321421, -1.228575, -2.880314>,
      < 8.339134, -1.223811, -2.884065>,
      < 8.335473, -1.231890, -2.887792>
    }
    triangle {
      < 8.187676, -1.474211, -2.891151>,
      < 8.208865, -1.466886, -2.897391>,
      < 8.205842, -1.472367, -2.895818>
    }
    triangle {
      < 8.093800, -1.679864, -2.852874>,
      < 8.079331, -1.674044, -2.850661>,
      < 8.157306, -1.530575, -2.879811>
    }
    triangle {
      < 8.093800, -1.679864, -2.852874>,
      < 8.157306, -1.530575, -2.879811>,
      < 8.170268, -1.538336, -2.883126>
    }
    triangle {
      < 8.079331, -1.674044, -2.850661>,
      < 8.077214, -1.667549, -2.837213>,
      < 8.154132, -1.525767, -2.866223>
    }
    triangle {
      < 8.079331, -1.674044, -2.850661>,
      < 8.154132, -1.525767, -2.866223>,
      < 8.157306, -1.530575, -2.879811>
    }
    triangle {
      < 8.080274, -1.783448, -2.792820>,
      < 8.065534, -1.780562, -2.790235>,
      < 8.079331, -1.674044, -2.850661>
    }
    triangle {
      < 8.080274, -1.783448, -2.792820>,
      < 8.079331, -1.674044, -2.850661>,
      < 8.093800, -1.679864, -2.852874>
    }
    triangle {
      < 8.065534, -1.780562, -2.790235>,
      < 8.065619, -1.771058, -2.779412>,
      < 8.077214, -1.667549, -2.837213>
    }
    triangle {
      < 8.065534, -1.780562, -2.790235>,
      < 8.077214, -1.667549, -2.837213>,
      < 8.079331, -1.674044, -2.850661>
    }
    triangle {
      < 8.085253, -1.849633, -2.722595>,
      < 8.070304, -1.846896, -2.720089>,
      < 8.065534, -1.780562, -2.790235>
    }
    triangle {
      < 8.085253, -1.849633, -2.722595>,
      < 8.065534, -1.780562, -2.790235>,
      < 8.080274, -1.783448, -2.792820>
    }
    triangle {
      < 8.070304, -1.846896, -2.720089>,
      < 8.072523, -1.834216, -2.713687>,
      < 8.065619, -1.771058, -2.779412>
    }
    triangle {
      < 8.070304, -1.846896, -2.720089>,
      < 8.065619, -1.771058, -2.779412>,
      < 8.065534, -1.780562, -2.790235>
    }
    triangle {
      < 8.092828, -1.873096, -2.644820>,
      < 8.077331, -1.869403, -2.644820>,
      < 8.070304, -1.846896, -2.720089>
    }
    triangle {
      < 8.092828, -1.873096, -2.644820>,
      < 8.070304, -1.846896, -2.720089>,
      < 8.085253, -1.849633, -2.722595>
    }
    triangle {
      < 8.077331, -1.869403, -2.644820>,
      < 8.080665, -1.855267, -2.644820>,
      < 8.072523, -1.834216, -2.713687>
    }
    triangle {
      < 8.077331, -1.869403, -2.644820>,
      < 8.072523, -1.834216, -2.713687>,
      < 8.070304, -1.846896, -2.720089>
    }
    triangle {
      < 8.085253, -1.849633, -2.567045>,
      < 8.070304, -1.846896, -2.569551>,
      < 8.077331, -1.869403, -2.644820>
    }
    triangle {
      < 8.085253, -1.849633, -2.567045>,
      < 8.077331, -1.869403, -2.644820>,
      < 8.092828, -1.873096, -2.644820>
    }
    triangle {
      < 8.070304, -1.846896, -2.569551>,
      < 8.072523, -1.834216, -2.575953>,
      < 8.080665, -1.855267, -2.644820>
    }
    triangle {
      < 8.070304, -1.846896, -2.569551>,
      < 8.080665, -1.855267, -2.644820>,
      < 8.077331, -1.869403, -2.644820>
    }
    triangle {
      < 8.080274, -1.783448, -2.496820>,
      < 8.065534, -1.780562, -2.499405>,
      < 8.070304, -1.846896, -2.569551>
    }
    triangle {
      < 8.080274, -1.783448, -2.496820>,
      < 8.070304, -1.846896, -2.569551>,
      < 8.085253, -1.849633, -2.567045>
    }
    triangle {
      < 8.065534, -1.780562, -2.499405>,
      < 8.065619, -1.771058, -2.510228>,
      < 8.072523, -1.834216, -2.575953>
    }
    triangle {
      < 8.065534, -1.780562, -2.499405>,
      < 8.072523, -1.834216, -2.575953>,
      < 8.070304, -1.846896, -2.569551>
    }
    triangle {
      < 8.093800, -1.679864, -2.436767>,
      < 8.079331, -1.674044, -2.438979>,
      < 8.065534, -1.780562, -2.499405>
    }
    triangle {
      < 8.093800, -1.679864, -2.436767>,
      < 8.065534, -1.780562, -2.499405>,
      < 8.080274, -1.783448, -2.496820>
    }
    triangle {
      < 8.079331, -1.674044, -2.438979>,
      < 8.077214, -1.667549, -2.452427>,
      < 8.065619, -1.771058, -2.510228>
    }
    triangle {
      < 8.079331, -1.674044, -2.438979>,
      < 8.065619, -1.771058, -2.510228>,
      < 8.065534, -1.780562, -2.499405>
    }
    triangle {
      < 8.170268, -1.538336, -2.406514>,
      < 8.157306, -1.530575, -2.409829>,
      < 8.079331, -1.674044, -2.438979>
    }
    triangle {
      < 8.170268, -1.538336, -2.406514>,
      < 8.079331, -1.674044, -2.438979>,
      < 8.093800, -1.679864, -2.436767>
    }
    triangle {
      < 8.157306, -1.530575, -2.409829>,
      < 8.154132, -1.525767, -2.423417>,
      < 8.077214, -1.667549, -2.452427>
    }
    triangle {
      < 8.157306, -1.530575, -2.409829>,
      < 8.077214, -1.667549, -2.452427>,
      < 8.079331, -1.674044, -2.438979>
    }
    triangle {
      < 8.205842, -1.472367, -2.393822>,
      < 8.187676, -1.474211, -2.398489>,
      < 8.157306, -1.530575, -2.409829>
    }
    triangle {
      < 8.205842, -1.472367, -2.393822>,
      < 8.157306, -1.530575, -2.409829>,
      < 8.170268, -1.538336, -2.406514>
    }
    triangle {
      < 8.187676, -1.474211, -2.398489>,
      < 8.184558, -1.469478, -2.412012>,
      < 8.154132, -1.525767, -2.423417>
    }
    triangle {
      < 8.187676, -1.474211, -2.398489>,
      < 8.154132, -1.525767, -2.423417>,
      < 8.157306, -1.530575, -2.409829>
    }
    triangle {
      < 8.230967, -1.425997, -2.390388>,
      < 8.217980, -1.418262, -2.393451>,
      < 8.187676, -1.474211, -2.398489>
    }
    triangle {
      < 8.230967, -1.425997, -2.390388>,
      < 8.187676, -1.474211, -2.398489>,
      < 8.208865, -1.466886, -2.392249>
    }
    triangle {
      < 8.217980, -1.418262, -2.393451>,
      < 8.214829, -1.413472, -2.406681>,
      < 8.184558, -1.469478, -2.412012>
    }
    triangle {
      < 8.217980, -1.418262, -2.393451>,
      < 8.184558, -1.469478, -2.412012>,
      < 8.187676, -1.474211, -2.398489>
    }
    triangle {
      < 8.267190, -1.359515, -2.384410>,
      < 8.253754, -1.352098, -2.388959>,
      < 8.217980, -1.418262, -2.393451>
    }
    triangle {
      < 8.267190, -1.359515, -2.384410>,
      < 8.217980, -1.418262, -2.393451>,
      < 8.230967, -1.425997, -2.390388>
    }
    triangle {
      < 8.253754, -1.352098, -2.388959>,
      < 8.249680, -1.349446, -2.402216>,
      < 8.214829, -1.413472, -2.406681>
    }
    triangle {
      < 8.253754, -1.352098, -2.388959>,
      < 8.214829, -1.413472, -2.406681>,
      < 8.217980, -1.418262, -2.393451>
    }
    triangle {
      < 8.302703, -1.293414, -2.381948>,
      < 8.288815, -1.288256, -2.388882>,
      < 8.253754, -1.352098, -2.388959>
    }
    triangle {
      < 8.302703, -1.293414, -2.381948>,
      < 8.253754, -1.352098, -2.388959>,
      < 8.267190, -1.359515, -2.384410>
    }
    triangle {
      < 8.288815, -1.288256, -2.388882>,
      < 8.282547, -1.289467, -2.402460>,
      < 8.249680, -1.349446, -2.402216>
    }
    triangle {
      < 8.288815, -1.288256, -2.388882>,
      < 8.249680, -1.349446, -2.402216>,
      < 8.253754, -1.352098, -2.388959>
    }
    triangle {
      < 8.335473, -1.231890, -2.401848>,
      < 8.321421, -1.228575, -2.409326>,
      < 8.288815, -1.288256, -2.388882>
    }
    triangle {
      < 8.335473, -1.231890, -2.401848>,
      < 8.288815, -1.288256, -2.388882>,
      < 8.302703, -1.293414, -2.381948>
    }
    triangle {
      < 8.321421, -1.228575, -2.409326>,
      < 8.313235, -1.233391, -2.421941>,
      < 8.282547, -1.289467, -2.402460>
    }
    triangle {
      < 8.321421, -1.228575, -2.409326>,
      < 8.282547, -1.289467, -2.402460>,
      < 8.288815, -1.288256, -2.388882>
    }
    triangle {
      < 8.364557, -1.176428, -2.444590>,
      < 8.349296, -1.177620, -2.452194>,
      < 8.321421, -1.228575, -2.409326>
    }
    triangle {
      < 8.364557, -1.176428, -2.444590>,
      < 8.321421, -1.228575, -2.409326>,
      < 8.339134, -1.223811, -2.405575>
    }
    triangle {
      < 8.349296, -1.177620, -2.452194>,
      < 8.339499, -1.185391, -2.462717>,
      < 8.313235, -1.233391, -2.421941>
    }
    triangle {
      < 8.349296, -1.177620, -2.452194>,
      < 8.313235, -1.233391, -2.421941>,
      < 8.321421, -1.228575, -2.409326>
    }
    triangle {
      < 8.386551, -1.134575, -2.502693>,
      < 8.370643, -1.138463, -2.508483>,
      < 8.349296, -1.177620, -2.452194>
    }
    triangle {
      < 8.386551, -1.134575, -2.502693>,
      < 8.349296, -1.177620, -2.452194>,
      < 8.364557, -1.176428, -2.444590>
    }
    triangle {
      < 8.370643, -1.138463, -2.508483>,
      < 8.359615, -1.148616, -2.515956>,
      < 8.339499, -1.185391, -2.462717>
    }
    triangle {
      < 8.370643, -1.138463, -2.508483>,
      < 8.339499, -1.185391, -2.462717>,
      < 8.349296, -1.177620, -2.452194>
    }
    triangle {
      < 8.400378, -1.108249, -2.571100>,
      < 8.384037, -1.113869, -2.574205>,
      < 8.370643, -1.138463, -2.508483>
    }
    triangle {
      < 8.400378, -1.108249, -2.571100>,
      < 8.370643, -1.138463, -2.508483>,
      < 8.386551, -1.134575, -2.502693>
    }
    triangle {
      < 8.384037, -1.113869, -2.574205>,
      < 8.372250, -1.125510, -2.578075>,
      < 8.359615, -1.148616, -2.515956>
    }
    triangle {
      < 8.384037, -1.113869, -2.574205>,
      < 8.359615, -1.148616, -2.515956>,
      < 8.370643, -1.138463, -2.508483>
    }
    triangle {
      < 8.405093, -1.099273, -2.644820>,
      < 8.388602, -1.105485, -2.644820>,
      < 8.384037, -1.113869, -2.574205>
    }
    triangle {
      < 8.405093, -1.099273, -2.644820>,
      < 8.384037, -1.113869, -2.574205>,
      < 8.400378, -1.108249, -2.571100>
    }
    triangle {
      < 8.388602, -1.105485, -2.644820>,
      < 8.376558, -1.117629, -2.644820>,
      < 8.372250, -1.125510, -2.578075>
    }
    triangle {
      < 8.388602, -1.105485, -2.644820>,
      < 8.372250, -1.125510, -2.578075>,
      < 8.384037, -1.113869, -2.574205>
    }
    triangle {
      < 8.400378, -1.108249, -2.718540>,
      < 8.384037, -1.113869, -2.715435>,
      < 8.388602, -1.105485, -2.644820>
    }
    triangle {
      < 8.400378, -1.108249, -2.718540>,
      < 8.388602, -1.105485, -2.644820>,
      < 8.405093, -1.099273, -2.644820>
    }
    triangle {
      < 8.384037, -1.113869, -2.715435>,
      < 8.372250, -1.125510, -2.711565>,
      < 8.376558, -1.117629, -2.644820>
    }
    triangle {
      < 8.384037, -1.113869, -2.715435>,
      < 8.376558, -1.117629, -2.644820>,
      < 8.388602, -1.105485, -2.644820>
    }
    triangle {
      < 8.386551, -1.134575, -2.786947>,
      < 8.370643, -1.138463, -2.781157>,
      < 8.384037, -1.113869, -2.715435>
    }
    triangle {
      < 8.386551, -1.134575, -2.786947>,
      < 8.384037, -1.113869, -2.715435>,
      < 8.400378, -1.108249, -2.718540>
    }
    triangle {
      < 8.370643, -1.138463, -2.781157>,
      < 8.359615, -1.148616, -2.773684>,
      < 8.372250, -1.125510, -2.711565>
    }
    triangle {
      < 8.370643, -1.138463, -2.781157>,
      < 8.372250, -1.125510, -2.711565>,
      < 8.384037, -1.113869, -2.715435>
    }
    triangle {
      < 8.364557, -1.176428, -2.845050>,
      < 8.349296, -1.177620, -2.837446>,
      < 8.370643, -1.138463, -2.781157>
    }
    triangle {
      < 8.364557, -1.176428, -2.845050>,
      < 8.370643, -1.138463, -2.781157>,
      < 8.386551, -1.134575, -2.786947>
    }
    triangle {
      < 8.349296, -1.177620, -2.837446>,
      < 8.339499, -1.185391, -2.826924>,
      < 8.359615, -1.148616, -2.773684>
    }
    triangle {
      < 8.349296, -1.177620, -2.837446>,
      < 8.359615, -1.148616, -2.773684>,
      < 8.370643, -1.138463, -2.781157>
    }
    triangle {
      < 8.339134, -1.223811, -2.884065>,
      < 8.321421, -1.228575, -2.880314>,
      < 8.349296, -1.177620, -2.837446>
    }
    triangle {
      < 8.339134, -1.223811, -2.884065>,
      < 8.349296, -1.177620, -2.837446>,
      < 8.364557, -1.176428, -2.845050>
    }
    triangle {
      < 8.321421, -1.228575, -2.880314>,
      < 8.313235, -1.233391, -2.867699>,
      < 8.339499, -1.185391, -2.826924>
    }
    triangle {
      < 8.321421, -1.228575, -2.880314>,
      < 8.339499, -1.185391, -2.826924>,
      < 8.349296, -1.177620, -2.837446>
    }
    triangle {
      < 8.302703, -1.293414, -2.907693>,
      < 8.288815, -1.288256, -2.900759>,
      < 8.321421, -1.228575, -2.880314>
    }
    triangle {
      < 8.302703, -1.293414, -2.907693>,
      < 8.321421, -1.228575, -2.880314>,
      < 8.335473, -1.231890, -2.887792>
    }
    triangle {
      < 8.288815, -1.288256, -2.900759>,
      < 8.282547, -1.289467, -2.887181>,
      < 8.313235, -1.233391, -2.867699>
    }
    triangle {
      < 8.288815, -1.288256, -2.900759>,
      < 8.313235, -1.233391, -2.867699>,
      < 8.321421, -1.228575, -2.880314>
    }
    triangle {
      < 8.267190, -1.359515, -2.905232>,
      < 8.253754, -1.352098, -2.900683>,
      < 8.288815, -1.288256, -2.900759>
    }
    triangle {
      < 8.267190, -1.359515, -2.905232>,
      < 8.288815, -1.288256, -2.900759>,
      < 8.302703, -1.293414, -2.907693>
    }
    triangle {
      < 8.253754, -1.352098, -2.900683>,
      < 8.249680, -1.349446, -2.887426>,
      < 8.282547, -1.289467, -2.887181>
    }
    triangle {
      < 8.253754, -1.352098, -2.900683>,
      < 8.282547, -1.289467, -2.887181>,
      < 8.288815, -1.288256, -2.900759>
    }
    triangle {
      < 8.230967, -1.425997, -2.899253>,
      < 8.217980, -1.418262, -2.896190>,
      < 8.253754, -1.352098, -2.900683>
    }
    triangle {
      < 8.230967, -1.425997, -2.899253>,
      < 8.253754, -1.352098, -2.900683>,
      < 8.267190, -1.359515, -2.905232>
    }
    triangle {
      < 8.217980, -1.418262, -2.896190>,
      < 8.214829, -1.413472, -2.882961>,
      < 8.249680, -1.349446, -2.887426>
    }
    triangle {
      < 8.217980, -1.418262, -2.896190>,
      < 8.249680, -1.349446, -2.887426>,
      < 8.253754, -1.352098, -2.900683>
    }
    triangle {
      < 8.208865, -1.466886, -2.897391>,
      < 8.187676, -1.474211, -2.891151>,
      < 8.217980, -1.418262, -2.896190>
    }
    triangle {
      < 8.208865, -1.466886, -2.897391>,
      < 8.217980, -1.418262, -2.896190>,
      < 8.230967, -1.425997, -2.899253>
    }
    triangle {
      < 8.187676, -1.474211, -2.891151>,
      < 8.184558, -1.469478, -2.877629>,
      < 8.214829, -1.413472, -2.882961>
    }
    triangle {
      < 8.187676, -1.474211, -2.891151>,
      < 8.214829, -1.413472, -2.882961>,
      < 8.217980, -1.418262, -2.896190>
    }
    triangle {
      < 8.170268, -1.538336, -2.883126>,
      < 8.157306, -1.530575, -2.879811>,
      < 8.187676, -1.474211, -2.891151>
    }
    triangle {
      < 8.170268, -1.538336, -2.883126>,
      < 8.187676, -1.474211, -2.891151>,
      < 8.205842, -1.472367, -2.895818>
    }
    triangle {
      < 8.157306, -1.530575, -2.879811>,
      < 8.154132, -1.525767, -2.866223>,
      < 8.184558, -1.469478, -2.877629>
    }
    triangle {
      < 8.157306, -1.530575, -2.879811>,
      < 8.184558, -1.469478, -2.877629>,
      < 8.187676, -1.474211, -2.891151>
    }
    triangle {
      < -5.980997, 0.378348, -1.436069>,
      < -5.980997, 0.336490, -1.429760>,
      < -6.083289, 0.336490, -1.429760>
    }
    triangle {
      < -5.980997, 0.378348, -1.436069>,
      < -6.083289, 0.336490, -1.429760>,
      < -6.083289, 0.378348, -1.436069>
    }
    triangle {
      < -6.083289, 0.336490, -1.429760>,
      < -5.980997, 0.336490, -1.429760>,
      < -5.980997, 0.298351, -1.411393>
    }
    triangle {
      < -6.083289, 0.336490, -1.429760>,
      < -5.980997, 0.298351, -1.411393>,
      < -6.083289, 0.298351, -1.411393>
    }
    triangle {
      < -6.083289, 0.298351, -1.411393>,
      < -5.980997, 0.298351, -1.411393>,
      < -5.980997, 0.267320, -1.382600>
    }
    triangle {
      < -6.083289, 0.298351, -1.411393>,
      < -5.980997, 0.267320, -1.382600>,
      < -6.083289, 0.267320, -1.382600>
    }
    triangle {
      < -6.083289, 0.267320, -1.382600>,
      < -5.980997, 0.267320, -1.382600>,
      < -5.980997, 0.246154, -1.345941>
    }
    triangle {
      < -6.083289, 0.267320, -1.382600>,
      < -5.980997, 0.246154, -1.345941>,
      < -6.083289, 0.246154, -1.345941>
    }
    triangle {
      < -6.083289, 0.246154, -1.345941>,
      < -5.980997, 0.246154, -1.345941>,
      < -5.980997, 0.236735, -1.304671>
    }
    triangle {
      < -6.083289, 0.246154, -1.345941>,
      < -5.980997, 0.236735, -1.304671>,
      < -6.083289, 0.236735, -1.304671>
    }
    triangle {
      < -6.083289, 0.236735, -1.304671>,
      < -5.980997, 0.236735, -1.304671>,
      < -5.980997, 0.239898, -1.262458>
    }
    triangle {
      < -6.083289, 0.236735, -1.304671>,
      < -5.980997, 0.239898, -1.262458>,
      < -6.083289, 0.239898, -1.262458>
    }
    triangle {
      < -6.083289, 0.239898, -1.262458>,
      < -5.980997, 0.239898, -1.262458>,
      < -5.980997, 0.255363, -1.223053>
    }
    triangle {
      < -6.083289, 0.239898, -1.262458>,
      < -5.980997, 0.255363, -1.223053>,
      < -6.083289, 0.255363, -1.223053>
    }
    triangle {
      < -6.083289, 0.255363, -1.223053>,
      < -5.980997, 0.255363, -1.223053>,
      < -5.980997, 0.281756, -1.189957>
    }
    triangle {
      < -6.083289, 0.255363, -1.223053>,
      < -5.980997, 0.281756, -1.189957>,
      < -6.083289, 0.281756, -1.189957>
    }
    triangle {
      < -6.083289, 0.281756, -1.189957>,
      < -5.980997, 0.281756, -1.189957>,
      < -5.980997, 0.316732, -1.166111>
    }
    triangle {
      < -6.083289, 0.281756, -1.189957>,
      < -5.980997, 0.316732, -1.166111>,
      < -6.083289, 0.316732, -1.166111>
    }
    triangle {
      < -6.083289, 0.316732, -1.166111>,
      < -5.980997, 0.316732, -1.166111>,
      < -5.980997, 0.357183, -1.153634>
    }
    triangle {
      < -6.083289, 0.316732, -1.166111>,
      < -5.980997, 0.357183, -1.153634>,
      < -6.083289, 0.357183, -1.153634>
    }
    triangle {
      < -6.083289, 0.357183, -1.153634>,
      < -5.980997, 0.357183, -1.153634>,
      < -5.980997, 0.399514, -1.153634>
    }
    triangle {
      < -6.083289, 0.357183, -1.153634>,
      < -5.980997, 0.399514, -1.153634>,
      < -6.083289, 0.399514, -1.153634>
    }
    triangle {
      < -6.083289, 0.399514, -1.153634>,
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.439965, -1.166111>
    }
    triangle {
      < -6.083289, 0.399514, -1.153634>,
      < -5.980997, 0.439965, -1.166111>,
      < -6.083289, 0.439965, -1.166111>
    }
    triangle {
      < -6.083289, 0.399514, -1.153634>,
      < -6.083289, 0.439965, -1.166111>,
      < -6.083289, 0.412997, -1.157793>
    }
    triangle {
      < -6.083289, 0.439965, -1.166111>,
      < -5.980997, 0.439965, -1.166111>,
      < -5.980997, 0.474940, -1.189957>
    }
    triangle {
      < -6.083289, 0.439965, -1.166111>,
      < -5.980997, 0.474940, -1.189957>,
      < -6.083289, 0.474940, -1.189957>
    }
    triangle {
      < -6.083289, 0.474940, -1.189957>,
      < -5.980997, 0.474940, -1.189957>,
      < -5.980997, 0.501333, -1.223053>
    }
    triangle {
      < -6.083289, 0.474940, -1.189957>,
      < -5.980997, 0.501333, -1.223053>,
      < -6.083289, 0.501333, -1.223053>
    }
    triangle {
      < -6.083289, 0.501333, -1.223053>,
      < -5.980997, 0.501333, -1.223053>,
      < -5.980997, 0.516798, -1.262458>
    }
    triangle {
      < -6.083289, 0.501333, -1.223053>,
      < -5.980997, 0.516798, -1.262458>,
      < -6.083289, 0.516798, -1.262458>
    }
    triangle {
      < -6.083289, 0.516798, -1.262458>,
      < -5.980997, 0.516798, -1.262458>,
      < -5.980997, 0.519962, -1.304671>
    }
    triangle {
      < -6.083289, 0.516798, -1.262458>,
      < -5.980997, 0.519962, -1.304671>,
      < -6.083289, 0.519962, -1.304671>
    }
    triangle {
      < -6.083289, 0.519962, -1.304671>,
      < -5.980997, 0.519962, -1.304671>,
      < -5.980997, 0.510542, -1.345941>
    }
    triangle {
      < -6.083289, 0.519962, -1.304671>,
      < -5.980997, 0.510542, -1.345941>,
      < -6.083289, 0.510542, -1.345941>
    }
    triangle {
      < -6.083289, 0.510542, -1.345941>,
      < -5.980997, 0.510542, -1.345941>,
      < -5.980997, 0.489377, -1.382600>
    }
    triangle {
      < -6.083289, 0.510542, -1.345941>,
      < -5.980997, 0.489377, -1.382600>,
      < -6.083289, 0.489377, -1.382600>
    }
    triangle {
      < -6.083289, 0.489377, -1.382600>,
      < -5.980997, 0.489377, -1.382600>,
      < -5.980997, 0.458346, -1.411393>
    }
    triangle {
      < -6.083289, 0.489377, -1.382600>,
      < -5.980997, 0.458346, -1.411393>,
      < -6.083289, 0.458346, -1.411393>
    }
    triangle {
      < -6.083289, 0.458346, -1.411393>,
      < -5.980997, 0.458346, -1.411393>,
      < -5.980997, 0.420207, -1.429760>
    }
    triangle {
      < -6.083289, 0.458346, -1.411393>,
      < -5.980997, 0.420207, -1.429760>,
      < -6.083289, 0.420207, -1.429760>
    }
    triangle {
      < -5.980997, 0.420207, -1.429760>,
      < -5.980997, 0.378348, -1.436069>,
      < -6.083289, 0.378348, -1.436069>
    }
    triangle {
      < -5.980997, 0.420207, -1.429760>,
      < -6.083289, 0.378348, -1.436069>,
      < -6.083289, 0.420207, -1.429760>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.357183, -1.153634>,
      < -5.980997, 0.316732, -1.166111>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.316732, -1.166111>,
      < -5.980997, 0.281756, -1.189957>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.281756, -1.189957>,
      < -5.980997, 0.255363, -1.223053>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.255363, -1.223053>,
      < -5.980997, 0.239898, -1.262458>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.239898, -1.262458>,
      < -5.980997, 0.236735, -1.304671>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.236735, -1.304671>,
      < -5.980997, 0.246154, -1.345941>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.246154, -1.345941>,
      < -5.980997, 0.267320, -1.382600>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.267320, -1.382600>,
      < -5.980997, 0.298351, -1.411393>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.298351, -1.411393>,
      < -5.980997, 0.336490, -1.429760>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.336490, -1.429760>,
      < -5.980997, 0.378348, -1.436069>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.378348, -1.436069>,
      < -5.980997, 0.420207, -1.429760>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.420207, -1.429760>,
      < -5.980997, 0.458346, -1.411393>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.458346, -1.411393>,
      < -5.980997, 0.489377, -1.382600>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.489377, -1.382600>,
      < -5.980997, 0.510542, -1.345941>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.510542, -1.345941>,
      < -5.980997, 0.519962, -1.304671>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.519962, -1.304671>,
      < -5.980997, 0.516798, -1.262458>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.516798, -1.262458>,
      < -5.980997, 0.501333, -1.223053>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.501333, -1.223053>,
      < -5.980997, 0.474940, -1.189957>
    }
    triangle {
      < -5.980997, 0.399514, -1.153634>,
      < -5.980997, 0.474940, -1.189957>,
      < -5.980997, 0.439965, -1.166111>
    }
    triangle {
      < -6.083289, 0.420207, -1.429760>,
      < -6.083289, 0.378348, -1.436069>,
      < -6.083289, 0.378348, -1.415843>
    }
    triangle {
      < -6.083289, 0.420207, -1.429760>,
      < -6.083289, 0.378348, -1.415843>,
      < -6.083289, 0.414245, -1.410433>
    }
    triangle {
      < -6.083289, 0.378348, -1.415843>,
      < -6.218211, 0.342452, -1.410433>,
      < -6.083289, 0.342452, -1.410433>
    }
    triangle {
      < -6.230585, 0.336490, -1.429760>,
      < -6.375861, 0.298351, -1.411393>,
      < -6.347029, 0.309745, -1.394682>
    }
    triangle {
      < -6.230585, 0.336490, -1.429760>,
      < -6.347029, 0.309745, -1.394682>,
      < -6.218211, 0.342452, -1.410433>
    }
    triangle {
      < -6.375861, 0.298351, -1.411393>,
      < -6.470540, 0.267320, -1.382600>,
      < -6.434062, 0.283133, -1.369990>
    }
    triangle {
      < -6.375861, 0.298351, -1.411393>,
      < -6.434062, 0.283133, -1.369990>,
      < -6.347029, 0.309745, -1.394682>
    }
    triangle {
      < -6.533354, 0.246154, -1.345941>,
      < -6.555851, 0.236735, -1.304671>,
      < -6.518501, 0.256904, -1.303159>
    }
    triangle {
      < -6.533354, 0.246154, -1.345941>,
      < -6.518501, 0.256904, -1.303159>,
      < -6.491998, 0.264982, -1.338551>
    }
    triangle {
      < -6.555851, 0.236735, -1.304671>,
      < -6.555851, 0.239898, -1.262458>,
      < -6.518501, 0.259617, -1.266958>
    }
    triangle {
      < -6.555851, 0.236735, -1.304671>,
      < -6.518501, 0.259617, -1.266958>,
      < -6.518501, 0.256904, -1.303159>
    }
    triangle {
      < -6.555851, 0.239898, -1.262458>,
      < -6.538155, 0.255363, -1.223053>,
      < -6.508452, 0.272880, -1.233166>
    }
    triangle {
      < -6.555851, 0.239898, -1.262458>,
      < -6.508452, 0.272880, -1.233166>,
      < -6.518501, 0.259617, -1.266958>
    }
    triangle {
      < -6.500612, 0.281756, -1.189957>,
      < -6.422616, 0.316732, -1.166111>,
      < -6.387126, 0.325508, -1.184334>
    }
    triangle {
      < -6.500612, 0.281756, -1.189957>,
      < -6.387126, 0.325508, -1.184334>,
      < -6.459853, 0.295514, -1.204784>
    }
    triangle {
      < -6.422616, 0.316732, -1.166111>,
      < -6.292230, 0.357183, -1.153634>,
      < -6.271077, 0.360197, -1.173634>
    }
    triangle {
      < -6.422616, 0.316732, -1.166111>,
      < -6.271077, 0.360197, -1.173634>,
      < -6.387126, 0.325508, -1.184334>
    }
    triangle {
      < -6.271077, 0.360197, -1.173634>,
      < -6.292230, 0.357183, -1.153634>,
      < -6.135707, 0.399514, -1.153634>
    }
    triangle {
      < -6.271077, 0.360197, -1.173634>,
      < -6.135707, 0.399514, -1.153634>,
      < -6.136846, 0.396500, -1.173634>
    }
    triangle {
      < -6.083289, 0.408063, -1.177201>,
      < -6.136846, 0.396500, -1.173634>,
      < -6.135707, 0.399514, -1.153634>
    }
    triangle {
      < -6.083289, 0.408063, -1.177201>,
      < -6.135707, 0.399514, -1.153634>,
      < -6.083289, 0.412997, -1.157793>
    }
    triangle {
      < -6.083289, 0.439965, -1.166111>,
      < -6.083289, 0.474940, -1.189957>,
      < -6.083289, 0.461183, -1.204784>
    }
    triangle {
      < -6.083289, 0.439965, -1.166111>,
      < -6.083289, 0.461183, -1.204784>,
      < -6.083289, 0.431189, -1.184334>
    }
    triangle {
      < -6.083289, 0.474940, -1.189957>,
      < -6.083289, 0.501333, -1.223053>,
      < -6.083289, 0.483817, -1.233166>
    }
    triangle {
      < -6.083289, 0.474940, -1.189957>,
      < -6.083289, 0.483817, -1.233166>,
      < -6.083289, 0.461183, -1.204784>
    }
    triangle {
      < -6.083289, 0.501333, -1.223053>,
      < -6.083289, 0.516798, -1.262458>,
      < -6.083289, 0.497080, -1.266958>
    }
    triangle {
      < -6.083289, 0.501333, -1.223053>,
      < -6.083289, 0.497080, -1.266958>,
      < -6.083289, 0.483817, -1.233166>
    }
    triangle {
      < -6.083289, 0.516798, -1.262458>,
      < -6.083289, 0.519962, -1.304671>,
      < -6.083289, 0.499793, -1.303159>
    }
    triangle {
      < -6.083289, 0.516798, -1.262458>,
      < -6.083289, 0.499793, -1.303159>,
      < -6.083289, 0.497080, -1.266958>
    }
    triangle {
      < -6.083289, 0.519962, -1.304671>,
      < -6.083289, 0.510542, -1.345941>,
      < -6.083289, 0.491715, -1.338551>
    }
    triangle {
      < -6.083289, 0.519962, -1.304671>,
      < -6.083289, 0.491715, -1.338551>,
      < -6.083289, 0.499793, -1.303159>
    }
    triangle {
      < -6.083289, 0.510542, -1.345941>,
      < -6.083289, 0.489377, -1.382600>,
      < -6.083289, 0.473564, -1.369990>
    }
    triangle {
      < -6.083289, 0.510542, -1.345941>,
      < -6.083289, 0.473564, -1.369990>,
      < -6.083289, 0.491715, -1.338551>
    }
    triangle {
      < -6.083289, 0.489377, -1.382600>,
      < -6.083289, 0.458346, -1.411393>,
      < -6.083289, 0.446952, -1.394682>
    }
    triangle {
      < -6.083289, 0.489377, -1.382600>,
      < -6.083289, 0.446952, -1.394682>,
      < -6.083289, 0.473564, -1.369990>
    }
    triangle {
      < -6.083289, 0.458346, -1.411393>,
      < -6.083289, 0.420207, -1.429760>,
      < -6.083289, 0.414245, -1.410433>
    }
    triangle {
      < -6.083289, 0.458346, -1.411393>,
      < -6.083289, 0.414245, -1.410433>,
      < -6.083289, 0.446952, -1.394682>
    }
    triangle {
      < -6.083289, 0.408063, -1.177201>,
      < -6.083289, 0.412997, -1.157793>,
      < -6.083289, 0.439965, -1.166111>
    }
    triangle {
      < -6.083289, 0.408063, -1.177201>,
      < -6.083289, 0.439965, -1.166111>,
      < -6.083289, 0.431189, -1.184334>
    }
    triangle {
      < -6.083289, 0.378348, -1.436069>,
      < -6.083289, 0.336490, -1.429760>,
      < -6.230585, 0.336490, -1.429760>
    }
    triangle {
      < -6.083289, 0.336490, -1.429760>,
      < -6.083289, 0.298351, -1.411393>,
      < -6.375861, 0.298351, -1.411393>
    }
    triangle {
      < -6.083289, 0.336490, -1.429760>,
      < -6.375861, 0.298351, -1.411393>,
      < -6.230585, 0.336490, -1.429760>
    }
    triangle {
      < -6.083289, 0.298351, -1.411393>,
      < -6.083289, 0.267320, -1.382600>,
      < -6.470540, 0.267320, -1.382600>
    }
    triangle {
      < -6.083289, 0.298351, -1.411393>,
      < -6.470540, 0.267320, -1.382600>,
      < -6.375861, 0.298351, -1.411393>
    }
    triangle {
      < -6.083289, 0.267320, -1.382600>,
      < -6.083289, 0.246154, -1.345941>,
      < -6.533354, 0.246154, -1.345941>
    }
    triangle {
      < -6.083289, 0.267320, -1.382600>,
      < -6.533354, 0.246154, -1.345941>,
      < -6.470540, 0.267320, -1.382600>
    }
    triangle {
      < -6.083289, 0.246154, -1.345941>,
      < -6.083289, 0.236735, -1.304671>,
      < -6.555851, 0.236735, -1.304671>
    }
    triangle {
      < -6.083289, 0.246154, -1.345941>,
      < -6.555851, 0.236735, -1.304671>,
      < -6.533354, 0.246154, -1.345941>
    }
    triangle {
      < -6.083289, 0.236735, -1.304671>,
      < -6.083289, 0.239898, -1.262458>,
      < -6.555851, 0.239898, -1.262458>
    }
    triangle {
      < -6.083289, 0.236735, -1.304671>,
      < -6.555851, 0.239898, -1.262458>,
      < -6.555851, 0.236735, -1.304671>
    }
    triangle {
      < -6.083289, 0.239898, -1.262458>,
      < -6.083289, 0.255363, -1.223053>,
      < -6.538155, 0.255363, -1.223053>
    }
    triangle {
      < -6.083289, 0.239898, -1.262458>,
      < -6.538155, 0.255363, -1.223053>,
      < -6.555851, 0.239898, -1.262458>
    }
    triangle {
      < -6.083289, 0.255363, -1.223053>,
      < -6.083289, 0.281756, -1.189957>,
      < -6.500612, 0.281756, -1.189957>
    }
    triangle {
      < -6.083289, 0.255363, -1.223053>,
      < -6.500612, 0.281756, -1.189957>,
      < -6.538155, 0.255363, -1.223053>
    }
    triangle {
      < -6.083289, 0.281756, -1.189957>,
      < -6.083289, 0.316732, -1.166111>,
      < -6.422616, 0.316732, -1.166111>
    }
    triangle {
      < -6.083289, 0.281756, -1.189957>,
      < -6.422616, 0.316732, -1.166111>,
      < -6.500612, 0.281756, -1.189957>
    }
    triangle {
      < -6.083289, 0.316732, -1.166111>,
      < -6.083289, 0.357183, -1.153634>,
      < -6.292230, 0.357183, -1.153634>
    }
    triangle {
      < -6.083289, 0.316732, -1.166111>,
      < -6.292230, 0.357183, -1.153634>,
      < -6.422616, 0.316732, -1.166111>
    }
    triangle {
      < -6.083289, 0.357183, -1.153634>,
      < -6.083289, 0.399514, -1.153634>,
      < -6.135707, 0.399514, -1.153634>
    }
    triangle {
      < -6.083289, 0.357183, -1.153634>,
      < -6.135707, 0.399514, -1.153634>,
      < -6.292230, 0.357183, -1.153634>
    }
    triangle {
      < -6.083289, 0.399514, -1.153634>,
      < -6.083289, 0.412997, -1.157793>,
      < -6.135707, 0.399514, -1.153634>
    }
    triangle {
      < -6.083289, 0.396500, -1.173634>,
      < -6.136846, 0.396500, -1.173634>,
      < -6.083289, 0.408063, -1.177201>
    }
    triangle {
      < -6.083289, 0.396500, -1.173634>,
      < -6.083289, 0.360197, -1.173634>,
      < -6.271077, 0.360197, -1.173634>
    }
    triangle {
      < -6.083289, 0.396500, -1.173634>,
      < -6.271077, 0.360197, -1.173634>,
      < -6.136846, 0.396500, -1.173634>
    }
    triangle {
      < -6.083289, 0.360197, -1.173634>,
      < -6.083289, 0.325508, -1.184334>,
      < -6.387126, 0.325508, -1.184334>
    }
    triangle {
      < -6.083289, 0.360197, -1.173634>,
      < -6.387126, 0.325508, -1.184334>,
      < -6.271077, 0.360197, -1.173634>
    }
    triangle {
      < -6.083289, 0.325508, -1.184334>,
      < -6.083289, 0.295514, -1.204784>,
      < -6.459853, 0.295514, -1.204784>
    }
    triangle {
      < -6.083289, 0.325508, -1.184334>,
      < -6.459853, 0.295514, -1.204784>,
      < -6.387126, 0.325508, -1.184334>
    }
    triangle {
      < -6.083289, 0.295514, -1.204784>,
      < -6.083289, 0.272880, -1.233166>,
      < -6.508452, 0.272880, -1.233166>
    }
    triangle {
      < -6.083289, 0.295514, -1.204784>,
      < -6.508452, 0.272880, -1.233166>,
      < -6.459853, 0.295514, -1.204784>
    }
    triangle {
      < -6.083289, 0.272880, -1.233166>,
      < -6.083289, 0.259617, -1.266958>,
      < -6.518501, 0.259617, -1.266958>
    }
    triangle {
      < -6.083289, 0.272880, -1.233166>,
      < -6.518501, 0.259617, -1.266958>,
      < -6.508452, 0.272880, -1.233166>
    }
    triangle {
      < -6.083289, 0.259617, -1.266958>,
      < -6.083289, 0.256904, -1.303159>,
      < -6.518501, 0.256904, -1.303159>
    }
    triangle {
      < -6.083289, 0.259617, -1.266958>,
      < -6.518501, 0.256904, -1.303159>,
      < -6.518501, 0.259617, -1.266958>
    }
    triangle {
      < -6.083289, 0.256904, -1.303159>,
      < -6.083289, 0.264982, -1.338551>,
      < -6.491998, 0.264982, -1.338551>
    }
    triangle {
      < -6.083289, 0.256904, -1.303159>,
      < -6.491998, 0.264982, -1.338551>,
      < -6.518501, 0.256904, -1.303159>
    }
    triangle {
      < -6.083289, 0.264982, -1.338551>,
      < -6.083289, 0.283133, -1.369990>,
      < -6.434062, 0.283133, -1.369990>
    }
    triangle {
      < -6.083289, 0.264982, -1.338551>,
      < -6.434062, 0.283133, -1.369990>,
      < -6.491998, 0.264982, -1.338551>
    }
    triangle {
      < -6.083289, 0.283133, -1.369990>,
      < -6.083289, 0.309745, -1.394682>,
      < -6.347029, 0.309745, -1.394682>
    }
    triangle {
      < -6.083289, 0.283133, -1.369990>,
      < -6.347029, 0.309745, -1.394682>,
      < -6.434062, 0.283133, -1.369990>
    }
    triangle {
      < -6.083289, 0.309745, -1.394682>,
      < -6.083289, 0.342452, -1.410433>,
      < -6.218211, 0.342452, -1.410433>
    }
    triangle {
      < -6.083289, 0.309745, -1.394682>,
      < -6.218211, 0.342452, -1.410433>,
      < -6.347029, 0.309745, -1.394682>
    }
    triangle {
      < -6.491998, 0.264982, -1.338551>,
      < -6.434062, 0.283133, -1.369990>,
      < -6.470540, 0.267320, -1.382600>
    }
    triangle {
      < -6.491998, 0.264982, -1.338551>,
      < -6.470540, 0.267320, -1.382600>,
      < -6.533354, 0.246154, -1.345941>
    }
    triangle {
      < -6.459853, 0.295514, -1.204784>,
      < -6.508452, 0.272880, -1.233166>,
      < -6.538155, 0.255363, -1.223053>
    }
    triangle {
      < -6.459853, 0.295514, -1.204784>,
      < -6.538155, 0.255363, -1.223053>,
      < -6.500612, 0.281756, -1.189957>
    }
    triangle {
      < -6.218211, 0.342452, -1.410433>,
      < -6.083289, 0.378348, -1.415843>,
      < -6.083289, 0.378348, -1.436069>
    }
    triangle {
      < -6.218211, 0.342452, -1.410433>,
      < -6.083289, 0.378348, -1.436069>,
      < -6.230585, 0.336490, -1.429760>
    }
    triangle {
      < -6.083289, 0.414245, -1.410433>,
      < -6.083289, 0.378348, -1.415843>,
      < -6.130356, 0.377279, -1.332787>
    }
    triangle {
      < -6.083289, 0.414245, -1.410433>,
      < -6.130356, 0.377279, -1.332787>,
      < -6.130355, 0.389329, -1.331434>
    }
    triangle {
      < -6.083289, 0.378348, -1.415843>,
      < -6.083289, 0.342452, -1.410433>,
      < -6.130356, 0.365366, -1.330530>
    }
    triangle {
      < -6.083289, 0.378348, -1.415843>,
      < -6.130356, 0.365366, -1.330530>,
      < -6.130356, 0.377279, -1.332787>
    }
    triangle {
      < -6.083289, 0.342452, -1.410433>,
      < -6.083289, 0.309745, -1.394682>,
      < -6.130357, 0.354647, -1.324861>
    }
    triangle {
      < -6.083289, 0.342452, -1.410433>,
      < -6.130357, 0.354647, -1.324861>,
      < -6.130356, 0.365366, -1.330530>
    }
    triangle {
      < -6.083289, 0.309745, -1.394682>,
      < -6.083289, 0.283133, -1.369990>,
      < -6.130356, 0.346076, -1.316284>
    }
    triangle {
      < -6.083289, 0.309745, -1.394682>,
      < -6.130356, 0.346076, -1.316284>,
      < -6.130357, 0.354647, -1.324861>
    }
    triangle {
      < -6.083289, 0.283133, -1.369990>,
      < -6.083289, 0.264982, -1.338551>,
      < -6.130356, 0.340413, -1.305562>
    }
    triangle {
      < -6.083289, 0.283133, -1.369990>,
      < -6.130356, 0.340413, -1.305562>,
      < -6.130356, 0.346076, -1.316284>
    }
    triangle {
      < -6.083289, 0.264982, -1.338551>,
      < -6.083289, 0.256904, -1.303159>,
      < -6.130356, 0.338162, -1.293647>
    }
    triangle {
      < -6.083289, 0.264982, -1.338551>,
      < -6.130356, 0.338162, -1.293647>,
      < -6.130356, 0.340413, -1.305562>
    }
    triangle {
      < -6.083289, 0.256904, -1.303159>,
      < -6.083289, 0.259617, -1.266958>,
      < -6.130356, 0.339524, -1.281599>
    }
    triangle {
      < -6.083289, 0.256904, -1.303159>,
      < -6.130356, 0.339524, -1.281599>,
      < -6.130356, 0.338162, -1.293647>
    }
    triangle {
      < -6.083289, 0.259617, -1.266958>,
      < -6.083289, 0.272880, -1.233166>,
      < -6.130356, 0.344376, -1.270486>
    }
    triangle {
      < -6.083289, 0.259617, -1.266958>,
      < -6.130356, 0.344376, -1.270486>,
      < -6.130356, 0.339524, -1.281599>
    }
    triangle {
      < -6.083289, 0.272880, -1.233166>,
      < -6.083289, 0.295514, -1.204784>,
      < -6.130357, 0.352288, -1.261298>
    }
    triangle {
      < -6.083289, 0.272880, -1.233166>,
      < -6.130357, 0.352288, -1.261298>,
      < -6.130356, 0.344376, -1.270486>
    }
    triangle {
      < -6.083289, 0.295514, -1.204784>,
      < -6.083289, 0.325508, -1.184334>,
      < -6.130356, 0.362556, -1.254850>
    }
    triangle {
      < -6.083289, 0.295514, -1.204784>,
      < -6.130356, 0.362556, -1.254850>,
      < -6.130357, 0.352288, -1.261298>
    }
    triangle {
      < -6.083289, 0.325508, -1.184334>,
      < -6.083289, 0.360197, -1.173634>,
      < -6.130356, 0.374270, -1.251715>
    }
    triangle {
      < -6.083289, 0.325508, -1.184334>,
      < -6.130356, 0.374270, -1.251715>,
      < -6.130356, 0.362556, -1.254850>
    }
    triangle {
      < -6.083289, 0.360197, -1.173634>,
      < -6.083289, 0.396500, -1.173634>,
      < -6.130356, 0.386387, -1.252172>
    }
    triangle {
      < -6.083289, 0.360197, -1.173634>,
      < -6.130356, 0.386387, -1.252172>,
      < -6.130356, 0.374270, -1.251715>
    }
    triangle {
      < -6.083289, 0.396500, -1.173634>,
      < -6.083289, 0.408063, -1.177201>,
      < -6.130356, 0.386387, -1.252172>
    }
    triangle {
      < -6.083289, 0.408063, -1.177201>,
      < -6.083289, 0.431189, -1.184334>,
      < -6.130355, 0.397830, -1.256180>
    }
    triangle {
      < -6.083289, 0.408063, -1.177201>,
      < -6.130355, 0.397830, -1.256180>,
      < -6.130356, 0.386387, -1.252172>
    }
    triangle {
      < -6.083289, 0.431189, -1.184334>,
      < -6.083289, 0.461183, -1.204784>,
      < -6.130356, 0.407584, -1.263384>
    }
    triangle {
      < -6.083289, 0.431189, -1.184334>,
      < -6.130356, 0.407584, -1.263384>,
      < -6.130355, 0.397830, -1.256180>
    }
    triangle {
      < -6.083289, 0.461183, -1.204784>,
      < -6.083289, 0.483817, -1.233166>,
      < -6.130355, 0.414782, -1.273142>
    }
    triangle {
      < -6.083289, 0.461183, -1.204784>,
      < -6.130355, 0.414782, -1.273142>,
      < -6.130356, 0.407584, -1.263384>
    }
    triangle {
      < -6.083289, 0.483817, -1.233166>,
      < -6.083289, 0.497080, -1.266958>,
      < -6.130355, 0.418783, -1.284588>
    }
    triangle {
      < -6.083289, 0.483817, -1.233166>,
      < -6.130355, 0.418783, -1.284588>,
      < -6.130355, 0.414782, -1.273142>
    }
    triangle {
      < -6.083289, 0.497080, -1.266958>,
      < -6.083289, 0.499793, -1.303159>,
      < -6.130355, 0.419233, -1.296705>
    }
    triangle {
      < -6.083289, 0.497080, -1.266958>,
      < -6.130355, 0.419233, -1.296705>,
      < -6.130355, 0.418783, -1.284588>
    }
    triangle {
      < -6.083289, 0.499793, -1.303159>,
      < -6.083289, 0.491715, -1.338551>,
      < -6.130356, 0.416091, -1.308416>
    }
    triangle {
      < -6.083289, 0.499793, -1.303159>,
      < -6.130356, 0.416091, -1.308416>,
      < -6.130355, 0.419233, -1.296705>
    }
    triangle {
      < -6.083289, 0.491715, -1.338551>,
      < -6.083289, 0.473564, -1.369990>,
      < -6.130355, 0.409637, -1.318682>
    }
    triangle {
      < -6.083289, 0.491715, -1.338551>,
      < -6.130355, 0.409637, -1.318682>,
      < -6.130356, 0.416091, -1.308416>
    }
    triangle {
      < -6.083289, 0.473564, -1.369990>,
      < -6.083289, 0.446952, -1.394682>,
      < -6.130355, 0.400444, -1.326588>
    }
    triangle {
      < -6.083289, 0.473564, -1.369990>,
      < -6.130355, 0.400444, -1.326588>,
      < -6.130355, 0.409637, -1.318682>
    }
    triangle {
      < -6.083289, 0.446952, -1.394682>,
      < -6.083289, 0.414245, -1.410433>,
      < -6.130355, 0.389329, -1.331434>
    }
    triangle {
      < -6.083289, 0.446952, -1.394682>,
      < -6.130355, 0.389329, -1.331434>,
      < -6.130355, 0.400444, -1.326588>
    }
    triangle {
      < -6.130356, 0.407584, -1.263384>,
      < -6.130355, 0.414782, -1.273142>,
      < -6.305160, 0.415470, -1.274511>
    }
    triangle {
      < -6.130356, 0.407584, -1.263384>,
      < -6.305160, 0.415470, -1.274511>,
      < -6.305160, 0.408645, -1.264489>
    }
    triangle {
      < -6.130355, 0.414782, -1.273142>,
      < -6.130355, 0.418783, -1.284588>,
      < -6.305160, 0.419036, -1.286100>
    }
    triangle {
      < -6.130355, 0.414782, -1.273142>,
      < -6.305160, 0.419036, -1.286100>,
      < -6.305160, 0.415470, -1.274511>
    }
    triangle {
      < -6.000756, 0.633820, -1.291040>,
      < -6.151561, 0.611398, -1.292655>,
      < -6.151562, 0.611403, -1.284654>
    }
    triangle {
      < -6.000756, 0.633820, -1.291040>,
      < -6.151562, 0.611403, -1.284654>,
      < -6.000756, 0.633495, -1.282280>
    }
    triangle {
      < -6.130355, 0.419233, -1.296705>,
      < -6.130356, 0.416091, -1.308416>,
      < -6.305160, 0.415448, -1.309810>
    }
    triangle {
      < -6.130355, 0.419233, -1.296705>,
      < -6.305160, 0.415448, -1.309810>,
      < -6.305159, 0.419029, -1.298226>
    }
    triangle {
      < -6.130356, 0.416091, -1.308416>,
      < -6.130355, 0.409637, -1.318682>,
      < -6.305160, 0.408612, -1.319825>
    }
    triangle {
      < -6.130356, 0.416091, -1.308416>,
      < -6.305160, 0.408612, -1.319825>,
      < -6.305160, 0.415448, -1.309810>
    }
    triangle {
      < -6.130355, 0.409637, -1.318682>,
      < -6.130355, 0.400444, -1.326588>,
      < -6.305161, 0.399127, -1.327379>
    }
    triangle {
      < -6.130355, 0.409637, -1.318682>,
      < -6.305161, 0.399127, -1.327379>,
      < -6.305160, 0.408612, -1.319825>
    }
    triangle {
      < -6.130355, 0.400444, -1.326588>,
      < -6.130355, 0.389329, -1.331434>,
      < -6.305160, 0.387837, -1.331802>
    }
    triangle {
      < -6.130355, 0.400444, -1.326588>,
      < -6.305160, 0.387837, -1.331802>,
      < -6.305161, 0.399127, -1.327379>
    }
    triangle {
      < -6.130355, 0.389329, -1.331434>,
      < -6.130356, 0.377279, -1.332787>,
      < -6.305161, 0.375745, -1.332700>
    }
    triangle {
      < -6.130355, 0.389329, -1.331434>,
      < -6.305161, 0.375745, -1.332700>,
      < -6.305160, 0.387837, -1.331802>
    }
    triangle {
      < -6.130356, 0.377279, -1.332787>,
      < -6.130356, 0.365366, -1.330530>,
      < -6.305160, 0.363925, -1.329995>
    }
    triangle {
      < -6.130356, 0.377279, -1.332787>,
      < -6.305160, 0.363925, -1.329995>,
      < -6.305161, 0.375745, -1.332700>
    }
    triangle {
      < -6.000753, 0.252266, -1.513536>,
      < -6.151559, 0.262074, -1.493312>,
      < -6.151557, 0.269000, -1.497316>
    }
    triangle {
      < -6.000753, 0.252266, -1.513536>,
      < -6.151557, 0.269000, -1.497316>,
      < -6.000752, 0.260016, -1.517634>
    }
    triangle {
      < -6.130357, 0.354647, -1.324861>,
      < -6.130356, 0.346076, -1.316284>,
      < -6.305161, 0.345186, -1.315033>
    }
    triangle {
      < -6.130357, 0.354647, -1.324861>,
      < -6.305161, 0.345186, -1.315033>,
      < -6.305162, 0.353428, -1.323927>
    }
    triangle {
      < -6.130356, 0.346076, -1.316284>,
      < -6.130356, 0.340413, -1.305562>,
      < -6.305164, 0.339932, -1.304105>
    }
    triangle {
      < -6.130356, 0.346076, -1.316284>,
      < -6.305164, 0.339932, -1.304105>,
      < -6.305161, 0.345186, -1.315033>
    }
    triangle {
      < -6.130356, 0.340413, -1.305562>,
      < -6.130356, 0.338162, -1.293647>,
      < -6.305162, 0.338132, -1.292114>
    }
    triangle {
      < -6.130356, 0.340413, -1.305562>,
      < -6.305162, 0.338132, -1.292114>,
      < -6.305164, 0.339932, -1.304105>
    }
    triangle {
      < -6.130356, 0.338162, -1.293647>,
      < -6.130356, 0.339524, -1.281599>,
      < -6.305160, 0.339946, -1.280126>
    }
    triangle {
      < -6.130356, 0.338162, -1.293647>,
      < -6.305160, 0.339946, -1.280126>,
      < -6.305162, 0.338132, -1.292114>
    }
    triangle {
      < -6.130356, 0.339524, -1.281599>,
      < -6.130356, 0.344376, -1.270486>,
      < -6.305161, 0.345213, -1.269204>
    }
    triangle {
      < -6.130356, 0.339524, -1.281599>,
      < -6.305161, 0.345213, -1.269204>,
      < -6.305160, 0.339946, -1.280126>
    }
    triangle {
      < -6.130356, 0.344376, -1.270486>,
      < -6.130357, 0.352288, -1.261298>,
      < -6.305162, 0.353466, -1.260320>
    }
    triangle {
      < -6.130356, 0.344376, -1.270486>,
      < -6.305162, 0.353466, -1.260320>,
      < -6.305161, 0.345213, -1.269204>
    }
    triangle {
      < -6.000752, 0.250350, -1.071848>,
      < -6.151558, 0.262956, -1.090456>,
      < -6.151559, 0.256026, -1.094451>
    }
    triangle {
      < -6.000752, 0.250350, -1.071848>,
      < -6.151559, 0.256026, -1.094451>,
      < -6.000753, 0.242926, -1.076510>
    }
    triangle {
      < -6.130356, 0.362556, -1.254850>,
      < -6.130356, 0.374270, -1.251715>,
      < -6.305161, 0.375794, -1.251572>
    }
    triangle {
      < -6.130356, 0.362556, -1.254850>,
      < -6.305161, 0.375794, -1.251572>,
      < -6.305161, 0.363970, -1.254264>
    }
    triangle {
      < -6.130356, 0.374270, -1.251715>,
      < -6.130356, 0.386387, -1.252172>,
      < -6.305161, 0.387885, -1.252486>
    }
    triangle {
      < -6.130356, 0.374270, -1.251715>,
      < -6.305161, 0.387885, -1.252486>,
      < -6.305161, 0.375794, -1.251572>
    }
    triangle {
      < -6.130356, 0.386387, -1.252172>,
      < -6.130355, 0.397830, -1.256180>,
      < -6.305161, 0.399169, -1.256923>
    }
    triangle {
      < -6.130356, 0.386387, -1.252172>,
      < -6.305161, 0.399169, -1.256923>,
      < -6.305161, 0.387885, -1.252486>
    }
    triangle {
      < -6.130355, 0.397830, -1.256180>,
      < -6.130356, 0.407584, -1.263384>,
      < -6.305160, 0.408645, -1.264489>
    }
    triangle {
      < -6.130355, 0.397830, -1.256180>,
      < -6.305160, 0.408645, -1.264489>,
      < -6.305161, 0.399169, -1.256923>
    }
    triangle {
      < -6.305161, 0.375794, -1.251572>,
      < -6.305161, 0.387885, -1.252486>,
      < -6.381561, 0.386062, -1.260462>
    }
    triangle {
      < -6.305161, 0.375794, -1.251572>,
      < -6.381561, 0.386062, -1.260462>,
      < -6.381562, 0.376403, -1.259732>
    }
    triangle {
      < -6.305161, 0.387885, -1.252486>,
      < -6.305161, 0.399169, -1.256923>,
      < -6.381561, 0.395076, -1.264006>
    }
    triangle {
      < -6.305161, 0.387885, -1.252486>,
      < -6.381561, 0.395076, -1.264006>,
      < -6.381561, 0.386062, -1.260462>
    }
    triangle {
      < -6.305161, 0.399169, -1.256923>,
      < -6.305160, 0.408645, -1.264489>,
      < -6.381560, 0.402646, -1.270050>
    }
    triangle {
      < -6.305161, 0.399169, -1.256923>,
      < -6.381560, 0.402646, -1.270050>,
      < -6.381561, 0.395076, -1.264006>
    }
    triangle {
      < -6.305160, 0.408645, -1.264489>,
      < -6.305160, 0.415470, -1.274511>,
      < -6.381560, 0.408097, -1.278057>
    }
    triangle {
      < -6.305160, 0.408645, -1.264489>,
      < -6.381560, 0.408097, -1.278057>,
      < -6.381560, 0.402646, -1.270050>
    }
    triangle {
      < -6.305160, 0.415470, -1.274511>,
      < -6.305160, 0.419036, -1.286100>,
      < -6.381559, 0.410947, -1.287314>
    }
    triangle {
      < -6.305160, 0.415470, -1.274511>,
      < -6.381559, 0.410947, -1.287314>,
      < -6.381560, 0.408097, -1.278057>
    }
    triangle {
      < -6.305160, 0.419036, -1.286100>,
      < -6.305159, 0.419029, -1.298226>,
      < -6.381561, 0.410942, -1.297001>
    }
    triangle {
      < -6.305160, 0.419036, -1.286100>,
      < -6.381561, 0.410942, -1.297001>,
      < -6.381559, 0.410947, -1.287314>
    }
    triangle {
      < -6.305159, 0.419029, -1.298226>,
      < -6.305160, 0.415448, -1.309810>,
      < -6.381560, 0.408081, -1.306255>
    }
    triangle {
      < -6.305159, 0.419029, -1.298226>,
      < -6.381560, 0.408081, -1.306255>,
      < -6.381561, 0.410942, -1.297001>
    }
    triangle {
      < -6.305160, 0.415448, -1.309810>,
      < -6.305160, 0.408612, -1.319825>,
      < -6.381561, 0.402619, -1.314256>
    }
    triangle {
      < -6.305160, 0.415448, -1.309810>,
      < -6.381561, 0.402619, -1.314256>,
      < -6.381560, 0.408081, -1.306255>
    }
    triangle {
      < -6.305160, 0.408612, -1.319825>,
      < -6.305161, 0.399127, -1.327379>,
      < -6.381561, 0.395043, -1.320290>
    }
    triangle {
      < -6.305160, 0.408612, -1.319825>,
      < -6.381561, 0.395043, -1.320290>,
      < -6.381561, 0.402619, -1.314256>
    }
    triangle {
      < -6.305161, 0.399127, -1.327379>,
      < -6.305160, 0.387837, -1.331802>,
      < -6.381560, 0.386024, -1.323823>
    }
    triangle {
      < -6.305161, 0.399127, -1.327379>,
      < -6.381560, 0.386024, -1.323823>,
      < -6.381561, 0.395043, -1.320290>
    }
    triangle {
      < -6.305160, 0.387837, -1.331802>,
      < -6.305161, 0.375745, -1.332700>,
      < -6.381562, 0.376364, -1.324542>
    }
    triangle {
      < -6.305160, 0.387837, -1.331802>,
      < -6.381562, 0.376364, -1.324542>,
      < -6.381560, 0.386024, -1.323823>
    }
    triangle {
      < -6.305161, 0.375745, -1.332700>,
      < -6.305160, 0.363925, -1.329995>,
      < -6.381563, 0.366922, -1.322380>
    }
    triangle {
      < -6.305161, 0.375745, -1.332700>,
      < -6.381563, 0.366922, -1.322380>,
      < -6.381562, 0.376364, -1.324542>
    }
    triangle {
      < -6.305160, 0.363925, -1.329995>,
      < -6.305162, 0.353428, -1.323927>,
      < -6.381563, 0.358536, -1.317533>
    }
    triangle {
      < -6.305160, 0.363925, -1.329995>,
      < -6.381563, 0.358536, -1.317533>,
      < -6.381563, 0.366922, -1.322380>
    }
    triangle {
      < -6.305162, 0.353428, -1.323927>,
      < -6.305161, 0.345186, -1.315033>,
      < -6.381562, 0.351952, -1.310428>
    }
    triangle {
      < -6.305162, 0.353428, -1.323927>,
      < -6.381562, 0.351952, -1.310428>,
      < -6.381563, 0.358536, -1.317533>
    }
    triangle {
      < -6.305161, 0.345186, -1.315033>,
      < -6.305164, 0.339932, -1.304105>,
      < -6.381562, 0.347754, -1.301698>
    }
    triangle {
      < -6.305161, 0.345186, -1.315033>,
      < -6.381562, 0.347754, -1.301698>,
      < -6.381562, 0.351952, -1.310428>
    }
    triangle {
      < -6.305164, 0.339932, -1.304105>,
      < -6.305162, 0.338132, -1.292114>,
      < -6.381562, 0.346316, -1.292119>
    }
    triangle {
      < -6.305164, 0.339932, -1.304105>,
      < -6.381562, 0.346316, -1.292119>,
      < -6.381562, 0.347754, -1.301698>
    }
    triangle {
      < -6.305162, 0.338132, -1.292114>,
      < -6.305160, 0.339946, -1.280126>,
      < -6.381563, 0.347766, -1.282542>
    }
    triangle {
      < -6.305162, 0.338132, -1.292114>,
      < -6.381563, 0.347766, -1.282542>,
      < -6.381562, 0.346316, -1.292119>
    }
    triangle {
      < -6.305160, 0.339946, -1.280126>,
      < -6.305161, 0.345213, -1.269204>,
      < -6.381563, 0.351974, -1.273817>
    }
    triangle {
      < -6.305160, 0.339946, -1.280126>,
      < -6.381563, 0.351974, -1.273817>,
      < -6.381563, 0.347766, -1.282542>
    }
    triangle {
      < -6.305161, 0.345213, -1.269204>,
      < -6.305162, 0.353466, -1.260320>,
      < -6.381563, 0.358566, -1.266720>
    }
    triangle {
      < -6.305161, 0.345213, -1.269204>,
      < -6.381563, 0.358566, -1.266720>,
      < -6.381563, 0.351974, -1.273817>
    }
    triangle {
      < -6.305162, 0.353466, -1.260320>,
      < -6.305161, 0.363970, -1.254264>,
      < -6.381561, 0.366958, -1.261882>
    }
    triangle {
      < -6.305162, 0.353466, -1.260320>,
      < -6.381561, 0.366958, -1.261882>,
      < -6.381563, 0.358566, -1.266720>
    }
    triangle {
      < -6.305161, 0.363970, -1.254264>,
      < -6.305161, 0.375794, -1.251572>,
      < -6.381562, 0.376403, -1.259732>
    }
    triangle {
      < -6.305161, 0.363970, -1.254264>,
      < -6.381562, 0.376403, -1.259732>,
      < -6.381561, 0.366958, -1.261882>
    }
    triangle {
      < -6.381563, 0.351974, -1.273817>,
      < -6.381563, 0.358566, -1.266720>,
      < -6.431553, 0.364656, -1.274363>
    }
    triangle {
      < -6.381563, 0.351974, -1.273817>,
      < -6.431553, 0.364656, -1.274363>,
      < -6.431556, 0.360045, -1.279326>
    }
    triangle {
      < -6.381563, 0.358566, -1.266720>,
      < -6.381561, 0.366958, -1.261882>,
      < -6.431552, 0.370524, -1.270979>
    }
    triangle {
      < -6.381563, 0.358566, -1.266720>,
      < -6.431552, 0.370524, -1.270979>,
      < -6.431553, 0.364656, -1.274363>
    }
    triangle {
      < -6.381561, 0.366958, -1.261882>,
      < -6.381562, 0.376403, -1.259732>,
      < -6.431551, 0.377129, -1.269476>
    }
    triangle {
      < -6.381561, 0.366958, -1.261882>,
      < -6.431551, 0.377129, -1.269476>,
      < -6.431552, 0.370524, -1.270979>
    }
    triangle {
      < -6.381562, 0.376403, -1.259732>,
      < -6.381561, 0.386062, -1.260462>,
      < -6.431551, 0.383884, -1.269987>
    }
    triangle {
      < -6.381562, 0.376403, -1.259732>,
      < -6.431551, 0.383884, -1.269987>,
      < -6.431551, 0.377129, -1.269476>
    }
    triangle {
      < -6.381561, 0.386062, -1.260462>,
      < -6.381561, 0.395076, -1.264006>,
      < -6.431551, 0.390187, -1.272465>
    }
    triangle {
      < -6.381561, 0.386062, -1.260462>,
      < -6.431551, 0.390187, -1.272465>,
      < -6.431551, 0.383884, -1.269987>
    }
    triangle {
      < -6.381561, 0.395076, -1.264006>,
      < -6.381560, 0.402646, -1.270050>,
      < -6.431551, 0.395481, -1.276692>
    }
    triangle {
      < -6.381561, 0.395076, -1.264006>,
      < -6.431551, 0.395481, -1.276692>,
      < -6.431551, 0.390187, -1.272465>
    }
    triangle {
      < -6.381560, 0.402646, -1.270050>,
      < -6.381560, 0.408097, -1.278057>,
      < -6.431554, 0.399294, -1.282291>
    }
    triangle {
      < -6.381560, 0.402646, -1.270050>,
      < -6.431554, 0.399294, -1.282291>,
      < -6.431551, 0.395481, -1.276692>
    }
    triangle {
      < -6.381560, 0.408097, -1.278057>,
      < -6.381559, 0.410947, -1.287314>,
      < -6.431551, 0.401285, -1.288764>
    }
    triangle {
      < -6.381560, 0.408097, -1.278057>,
      < -6.431551, 0.401285, -1.288764>,
      < -6.431554, 0.399294, -1.282291>
    }
    triangle {
      < -6.381559, 0.410947, -1.287314>,
      < -6.381561, 0.410942, -1.297001>,
      < -6.431551, 0.401282, -1.295539>
    }
    triangle {
      < -6.381559, 0.410947, -1.287314>,
      < -6.431551, 0.401282, -1.295539>,
      < -6.431551, 0.401285, -1.288764>
    }
    triangle {
      < -6.381561, 0.410942, -1.297001>,
      < -6.381560, 0.408081, -1.306255>,
      < -6.431551, 0.399282, -1.302010>
    }
    triangle {
      < -6.381561, 0.410942, -1.297001>,
      < -6.431551, 0.399282, -1.302010>,
      < -6.431551, 0.401282, -1.295539>
    }
    triangle {
      < -6.381560, 0.408081, -1.306255>,
      < -6.381561, 0.402619, -1.314256>,
      < -6.431554, 0.395462, -1.307605>
    }
    triangle {
      < -6.381560, 0.408081, -1.306255>,
      < -6.431554, 0.395462, -1.307605>,
      < -6.431551, 0.399282, -1.302010>
    }
    triangle {
      < -6.381561, 0.402619, -1.314256>,
      < -6.381561, 0.395043, -1.320290>,
      < -6.431554, 0.390164, -1.311825>
    }
    triangle {
      < -6.381561, 0.402619, -1.314256>,
      < -6.431554, 0.390164, -1.311825>,
      < -6.431554, 0.395462, -1.307605>
    }
    triangle {
      < -6.381561, 0.395043, -1.320290>,
      < -6.381560, 0.386024, -1.323823>,
      < -6.431553, 0.383857, -1.314296>
    }
    triangle {
      < -6.381561, 0.395043, -1.320290>,
      < -6.431553, 0.383857, -1.314296>,
      < -6.431554, 0.390164, -1.311825>
    }
    triangle {
      < -6.381560, 0.386024, -1.323823>,
      < -6.381562, 0.376364, -1.324542>,
      < -6.431552, 0.377102, -1.314798>
    }
    triangle {
      < -6.381560, 0.386024, -1.323823>,
      < -6.431552, 0.377102, -1.314798>,
      < -6.431553, 0.383857, -1.314296>
    }
    triangle {
      < -6.381562, 0.376364, -1.324542>,
      < -6.381563, 0.366922, -1.322380>,
      < -6.431549, 0.370499, -1.313287>
    }
    triangle {
      < -6.381562, 0.376364, -1.324542>,
      < -6.431549, 0.370499, -1.313287>,
      < -6.431552, 0.377102, -1.314798>
    }
    triangle {
      < -6.381563, 0.366922, -1.322380>,
      < -6.381563, 0.358536, -1.317533>,
      < -6.431552, 0.364634, -1.309896>
    }
    triangle {
      < -6.381563, 0.366922, -1.322380>,
      < -6.431552, 0.364634, -1.309896>,
      < -6.431549, 0.370499, -1.313287>
    }
    triangle {
      < -6.381563, 0.358536, -1.317533>,
      < -6.381562, 0.351952, -1.310428>,
      < -6.431554, 0.360030, -1.304928>
    }
    triangle {
      < -6.381563, 0.358536, -1.317533>,
      < -6.431554, 0.360030, -1.304928>,
      < -6.431552, 0.364634, -1.309896>
    }
    triangle {
      < -6.381562, 0.351952, -1.310428>,
      < -6.381562, 0.347754, -1.301698>,
      < -6.431552, 0.357095, -1.298823>
    }
    triangle {
      < -6.381562, 0.351952, -1.310428>,
      < -6.431552, 0.357095, -1.298823>,
      < -6.431554, 0.360030, -1.304928>
    }
    triangle {
      < -6.381562, 0.347754, -1.301698>,
      < -6.381562, 0.346316, -1.292119>,
      < -6.431554, 0.356089, -1.292125>
    }
    triangle {
      < -6.381562, 0.347754, -1.301698>,
      < -6.431554, 0.356089, -1.292125>,
      < -6.431552, 0.357095, -1.298823>
    }
    triangle {
      < -6.381562, 0.346316, -1.292119>,
      < -6.381563, 0.347766, -1.282542>,
      < -6.431550, 0.357103, -1.285427>
    }
    triangle {
      < -6.381562, 0.346316, -1.292119>,
      < -6.431550, 0.357103, -1.285427>,
      < -6.431554, 0.356089, -1.292125>
    }
    triangle {
      < -6.381563, 0.347766, -1.282542>,
      < -6.381563, 0.351974, -1.273817>,
      < -6.431556, 0.360045, -1.279326>
    }
    triangle {
      < -6.381563, 0.347766, -1.282542>,
      < -6.431556, 0.360045, -1.279326>,
      < -6.431550, 0.357103, -1.285427>
    }
    triangle {
      < -6.431552, 0.357095, -1.298823>,
      < -6.431554, 0.356089, -1.292125>,
      < -6.467154, 0.366120, -1.292130>
    }
    triangle {
      < -6.431552, 0.357095, -1.298823>,
      < -6.467154, 0.366120, -1.292130>,
      < -6.467153, 0.366682, -1.295872>
    }
    triangle {
      < -6.431554, 0.356089, -1.292125>,
      < -6.431550, 0.357103, -1.285427>,
      < -6.467155, 0.366686, -1.288389>
    }
    triangle {
      < -6.431554, 0.356089, -1.292125>,
      < -6.467155, 0.366686, -1.288389>,
      < -6.467154, 0.366120, -1.292130>
    }
    triangle {
      < -6.431550, 0.357103, -1.285427>,
      < -6.431556, 0.360045, -1.279326>,
      < -6.467149, 0.368330, -1.284980>
    }
    triangle {
      < -6.431550, 0.357103, -1.285427>,
      < -6.467149, 0.368330, -1.284980>,
      < -6.467155, 0.366686, -1.288389>
    }
    triangle {
      < -6.431556, 0.360045, -1.279326>,
      < -6.431553, 0.364656, -1.274363>,
      < -6.467151, 0.370905, -1.282208>
    }
    triangle {
      < -6.431556, 0.360045, -1.279326>,
      < -6.467151, 0.370905, -1.282208>,
      < -6.467149, 0.368330, -1.284980>
    }
    triangle {
      < -6.431553, 0.364656, -1.274363>,
      < -6.431552, 0.370524, -1.270979>,
      < -6.467153, 0.374184, -1.280318>
    }
    triangle {
      < -6.431553, 0.364656, -1.274363>,
      < -6.467153, 0.374184, -1.280318>,
      < -6.467151, 0.370905, -1.282208>
    }
    triangle {
      < -6.431552, 0.370524, -1.270979>,
      < -6.431551, 0.377129, -1.269476>,
      < -6.467154, 0.377874, -1.279477>
    }
    triangle {
      < -6.431552, 0.370524, -1.270979>,
      < -6.467154, 0.377874, -1.279477>,
      < -6.467153, 0.374184, -1.280318>
    }
    triangle {
      < -6.431551, 0.377129, -1.269476>,
      < -6.431551, 0.383884, -1.269987>,
      < -6.467153, 0.381647, -1.279763>
    }
    triangle {
      < -6.431551, 0.377129, -1.269476>,
      < -6.467153, 0.381647, -1.279763>,
      < -6.467154, 0.377874, -1.279477>
    }
    triangle {
      < -6.431551, 0.383884, -1.269987>,
      < -6.431551, 0.390187, -1.272465>,
      < -6.467152, 0.385169, -1.281148>
    }
    triangle {
      < -6.431551, 0.383884, -1.269987>,
      < -6.467152, 0.385169, -1.281148>,
      < -6.467153, 0.381647, -1.279763>
    }
    triangle {
      < -6.431551, 0.390187, -1.272465>,
      < -6.431551, 0.395481, -1.276692>,
      < -6.467155, 0.388126, -1.283509>
    }
    triangle {
      < -6.431551, 0.390187, -1.272465>,
      < -6.467155, 0.388126, -1.283509>,
      < -6.467152, 0.385169, -1.281148>
    }
    triangle {
      < -6.431551, 0.395481, -1.276692>,
      < -6.431554, 0.399294, -1.282291>,
      < -6.467151, 0.390256, -1.286636>
    }
    triangle {
      < -6.431551, 0.395481, -1.276692>,
      < -6.467151, 0.390256, -1.286636>,
      < -6.467155, 0.388126, -1.283509>
    }
    triangle {
      < -6.431554, 0.399294, -1.282291>,
      < -6.431551, 0.401285, -1.288764>,
      < -6.467152, 0.391369, -1.290253>
    }
    triangle {
      < -6.431554, 0.399294, -1.282291>,
      < -6.467152, 0.391369, -1.290253>,
      < -6.467151, 0.390256, -1.286636>
    }
    triangle {
      < -6.431551, 0.401285, -1.288764>,
      < -6.431551, 0.401282, -1.295539>,
      < -6.467149, 0.391367, -1.294037>
    }
    triangle {
      < -6.431551, 0.401285, -1.288764>,
      < -6.467149, 0.391367, -1.294037>,
      < -6.467152, 0.391369, -1.290253>
    }
    triangle {
      < -6.431551, 0.401282, -1.295539>,
      < -6.431551, 0.399282, -1.302010>,
      < -6.467149, 0.390249, -1.297653>
    }
    triangle {
      < -6.431551, 0.401282, -1.295539>,
      < -6.467149, 0.390249, -1.297653>,
      < -6.467149, 0.391367, -1.294037>
    }
    triangle {
      < -6.431551, 0.399282, -1.302010>,
      < -6.431554, 0.395462, -1.307605>,
      < -6.467152, 0.388115, -1.300779>
    }
    triangle {
      < -6.431551, 0.399282, -1.302010>,
      < -6.467152, 0.388115, -1.300779>,
      < -6.467149, 0.390249, -1.297653>
    }
    triangle {
      < -6.431554, 0.395462, -1.307605>,
      < -6.431554, 0.390164, -1.311825>,
      < -6.467151, 0.385155, -1.303136>
    }
    triangle {
      < -6.431554, 0.395462, -1.307605>,
      < -6.467151, 0.385155, -1.303136>,
      < -6.467152, 0.388115, -1.300779>
    }
    triangle {
      < -6.431554, 0.390164, -1.311825>,
      < -6.431553, 0.383857, -1.314296>,
      < -6.467153, 0.381632, -1.304516>
    }
    triangle {
      < -6.431554, 0.390164, -1.311825>,
      < -6.467153, 0.381632, -1.304516>,
      < -6.467151, 0.385155, -1.303136>
    }
    triangle {
      < -6.431553, 0.383857, -1.314296>,
      < -6.431552, 0.377102, -1.314798>,
      < -6.467153, 0.377859, -1.304797>
    }
    triangle {
      < -6.431553, 0.383857, -1.314296>,
      < -6.467153, 0.377859, -1.304797>,
      < -6.467153, 0.381632, -1.304516>
    }
    triangle {
      < -6.431552, 0.377102, -1.314798>,
      < -6.431549, 0.370499, -1.313287>,
      < -6.467153, 0.374170, -1.303952>
    }
    triangle {
      < -6.431552, 0.377102, -1.314798>,
      < -6.467153, 0.374170, -1.303952>,
      < -6.467153, 0.377859, -1.304797>
    }
    triangle {
      < -6.431549, 0.370499, -1.313287>,
      < -6.431552, 0.364634, -1.309896>,
      < -6.467153, 0.370894, -1.302058>
    }
    triangle {
      < -6.431549, 0.370499, -1.313287>,
      < -6.467153, 0.370894, -1.302058>,
      < -6.467153, 0.374170, -1.303952>
    }
    triangle {
      < -6.431552, 0.364634, -1.309896>,
      < -6.431554, 0.360030, -1.304928>,
      < -6.467158, 0.368321, -1.299283>
    }
    triangle {
      < -6.431552, 0.364634, -1.309896>,
      < -6.467158, 0.368321, -1.299283>,
      < -6.467153, 0.370894, -1.302058>
    }
    triangle {
      < -6.431554, 0.360030, -1.304928>,
      < -6.431552, 0.357095, -1.298823>,
      < -6.467153, 0.366682, -1.295872>
    }
    triangle {
      < -6.431554, 0.360030, -1.304928>,
      < -6.467153, 0.366682, -1.295872>,
      < -6.467158, 0.368321, -1.299283>
    }
    triangle {
      < -6.467153, 0.374170, -1.303952>,
      < -6.467153, 0.370894, -1.302058>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467153, 0.370894, -1.302058>,
      < -6.467158, 0.368321, -1.299283>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467158, 0.368321, -1.299283>,
      < -6.467153, 0.366682, -1.295872>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467153, 0.366682, -1.295872>,
      < -6.467154, 0.366120, -1.292130>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467154, 0.366120, -1.292130>,
      < -6.467155, 0.366686, -1.288389>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467155, 0.366686, -1.288389>,
      < -6.467149, 0.368330, -1.284980>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467149, 0.368330, -1.284980>,
      < -6.467151, 0.370905, -1.282208>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467151, 0.370905, -1.282208>,
      < -6.467153, 0.374184, -1.280318>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467153, 0.374184, -1.280318>,
      < -6.467154, 0.377874, -1.279477>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467154, 0.377874, -1.279477>,
      < -6.467153, 0.381647, -1.279763>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467153, 0.381647, -1.279763>,
      < -6.467152, 0.385169, -1.281148>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467152, 0.385169, -1.281148>,
      < -6.467155, 0.388126, -1.283509>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467155, 0.388126, -1.283509>,
      < -6.467151, 0.390256, -1.286636>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467151, 0.390256, -1.286636>,
      < -6.467152, 0.391369, -1.290253>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467152, 0.391369, -1.290253>,
      < -6.467149, 0.391367, -1.294037>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467149, 0.391367, -1.294037>,
      < -6.467149, 0.390249, -1.297653>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467149, 0.390249, -1.297653>,
      < -6.467152, 0.388115, -1.300779>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467152, 0.388115, -1.300779>,
      < -6.467151, 0.385155, -1.303136>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467151, 0.385155, -1.303136>,
      < -6.467153, 0.381632, -1.304516>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467153, 0.381632, -1.304516>,
      < -6.467153, 0.377859, -1.304797>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.467153, 0.377859, -1.304797>,
      < -6.467153, 0.374170, -1.303952>,
      < -6.500353, 0.378816, -1.292139>
    }
    triangle {
      < -6.000756, 0.633495, -1.282280>,
      < -6.130355, 0.418783, -1.284588>,
      < -6.053556, 0.419042, -1.282304>
    }
    triangle {
      < -6.053556, 0.419042, -1.282304>,
      < -6.053556, 0.419043, -1.295002>,
      < -6.000756, 0.633820, -1.291040>
    }
    triangle {
      < -6.053556, 0.419042, -1.282304>,
      < -6.000756, 0.633820, -1.291040>,
      < -6.000756, 0.633495, -1.282280>
    }
    triangle {
      < -6.130355, 0.419233, -1.296705>,
      < -6.305159, 0.419029, -1.298226>,
      < -6.151561, 0.611398, -1.292655>
    }
    triangle {
      < -6.130355, 0.419233, -1.296705>,
      < -6.151561, 0.611398, -1.292655>,
      < -6.000756, 0.633820, -1.291040>
    }
    triangle {
      < -6.305159, 0.419029, -1.298226>,
      < -6.305160, 0.419036, -1.286100>,
      < -6.151562, 0.611403, -1.284654>
    }
    triangle {
      < -6.305159, 0.419029, -1.298226>,
      < -6.151562, 0.611403, -1.284654>,
      < -6.151561, 0.611398, -1.292655>
    }
    triangle {
      < -6.305162, 0.353466, -1.260320>,
      < -6.130357, 0.352288, -1.261298>,
      < -6.000753, 0.242926, -1.076510>
    }
    triangle {
      < -6.305162, 0.353466, -1.260320>,
      < -6.000753, 0.242926, -1.076510>,
      < -6.151559, 0.256026, -1.094451>
    }
    triangle {
      < -6.053653, 0.352225, -1.261200>,
      < -6.053653, 0.363062, -1.254569>,
      < -6.000752, 0.250350, -1.071848>
    }
    triangle {
      < -6.053653, 0.352225, -1.261200>,
      < -6.000752, 0.250350, -1.071848>,
      < -6.000753, 0.242926, -1.076510>
    }
    triangle {
      < -6.130356, 0.362556, -1.254850>,
      < -6.000752, 0.250350, -1.071848>,
      < -6.053653, 0.363062, -1.254569>
    }
    triangle {
      < -6.305161, 0.363970, -1.254264>,
      < -6.305162, 0.353466, -1.260320>,
      < -6.151559, 0.256026, -1.094451>
    }
    triangle {
      < -6.305161, 0.363970, -1.254264>,
      < -6.151559, 0.256026, -1.094451>,
      < -6.151558, 0.262956, -1.090456>
    }
    triangle {
      < -6.305160, 0.363925, -1.329995>,
      < -6.130356, 0.365366, -1.330530>,
      < -6.000752, 0.260016, -1.517634>
    }
    triangle {
      < -6.305160, 0.363925, -1.329995>,
      < -6.000752, 0.260016, -1.517634>,
      < -6.151557, 0.269000, -1.497316>
    }
    triangle {
      < -6.053653, 0.365750, -1.331035>,
      < -6.053653, 0.354613, -1.324923>,
      < -6.000753, 0.252266, -1.513536>
    }
    triangle {
      < -6.053653, 0.365750, -1.331035>,
      < -6.000753, 0.252266, -1.513536>,
      < -6.000752, 0.260016, -1.517634>
    }
    triangle {
      < -6.130357, 0.354647, -1.324861>,
      < -6.305162, 0.353428, -1.323927>,
      < -6.151559, 0.262074, -1.493312>
    }
    triangle {
      < -6.130357, 0.354647, -1.324861>,
      < -6.151559, 0.262074, -1.493312>,
      < -6.000753, 0.252266, -1.513536>
    }
    triangle {
      < -6.305162, 0.353428, -1.323927>,
      < -6.305160, 0.363925, -1.329995>,
      < -6.151557, 0.269000, -1.497316>
    }
    triangle {
      < -6.305162, 0.353428, -1.323927>,
      < -6.151557, 0.269000, -1.497316>,
      < -6.151559, 0.262074, -1.493312>
    }
    triangle {
      < -6.053653, 0.354613, -1.324923>,
      < -6.053653, 0.365750, -1.331035>,
      < -6.130356, 0.365366, -1.330530>
    }
    triangle {
      < -6.053653, 0.354613, -1.324923>,
      < -6.130356, 0.365366, -1.330530>,
      < -6.130357, 0.354647, -1.324861>
    }
    triangle {
      < -6.053556, 0.419043, -1.295002>,
      < -6.053556, 0.419042, -1.282304>,
      < -6.130355, 0.418783, -1.284588>
    }
    triangle {
      < -6.053556, 0.419043, -1.295002>,
      < -6.130355, 0.418783, -1.284588>,
      < -6.130355, 0.419233, -1.296705>
    }
    triangle {
      < -6.053653, 0.363062, -1.254569>,
      < -6.053653, 0.352225, -1.261200>,
      < -6.130357, 0.352288, -1.261298>
    }
    triangle {
      < -6.053653, 0.363062, -1.254569>,
      < -6.130357, 0.352288, -1.261298>,
      < -6.130356, 0.362556, -1.254850>
    }
    triangle {
      < -6.130355, 0.419233, -1.296705>,
      < -6.000756, 0.633820, -1.291040>,
      < -6.053556, 0.419043, -1.295002>
    }
    triangle {
      < -6.000752, 0.260016, -1.517634>,
      < -6.130356, 0.365366, -1.330530>,
      < -6.053653, 0.365750, -1.331035>
    }
    triangle {
      < -6.130355, 0.418783, -1.284588>,
      < -6.000756, 0.633495, -1.282280>,
      < -6.151562, 0.611403, -1.284654>
    }
    triangle {
      < -6.130355, 0.418783, -1.284588>,
      < -6.151562, 0.611403, -1.284654>,
      < -6.305160, 0.419036, -1.286100>
    }
    triangle {
      < -6.000752, 0.250350, -1.071848>,
      < -6.130356, 0.362556, -1.254850>,
      < -6.305161, 0.363970, -1.254264>
    }
    triangle {
      < -6.000752, 0.250350, -1.071848>,
      < -6.305161, 0.363970, -1.254264>,
      < -6.151558, 0.262956, -1.090456>
    }
    triangle {
      < -6.130357, 0.354647, -1.324861>,
      < -6.000753, 0.252266, -1.513536>,
      < -6.053653, 0.354613, -1.324923>
    }
    triangle {
      < -6.000753, 0.242926, -1.076510>,
      < -6.130357, 0.352288, -1.261298>,
      < -6.053653, 0.352225, -1.261200>
    }
    triangle {
      < -7.156101, -0.649382, 0.000000>,
      < -7.217670, -0.594650, 0.000000>,
      < -7.153274, -0.609095, -0.660402>
    }
    triangle {
      < -7.156101, -0.649382, 0.000000>,
      < -7.153274, -0.609095, -0.660402>,
      < -7.091707, -0.662036, -0.660402>
    }
    triangle {
      < -7.217670, -0.594650, 0.000000>,
      < -7.217670, -0.559311, 0.000000>,
      < -7.153274, -0.574912, -0.660402>
    }
    triangle {
      < -7.217670, -0.594650, 0.000000>,
      < -7.153274, -0.574912, -0.660402>,
      < -7.153274, -0.609095, -0.660402>
    }
    triangle {
      < -7.217670, -0.559311, 0.000000>,
      < -7.165748, -0.506341, 0.000000>,
      < -7.102151, -0.523676, -0.660402>
    }
    triangle {
      < -7.217670, -0.559311, 0.000000>,
      < -7.102151, -0.523676, -0.660402>,
      < -7.153274, -0.574912, -0.660402>
    }
    triangle {
      < -7.165748, -0.506341, 0.000000>,
      < -7.104059, -0.469687, 0.000000>,
      < -7.040987, -0.488222, -0.660402>
    }
    triangle {
      < -7.165748, -0.506341, 0.000000>,
      < -7.040987, -0.488222, -0.660402>,
      < -7.102151, -0.523676, -0.660402>
    }
    triangle {
      < -7.104059, -0.469687, 0.000000>,
      < -7.040373, -0.449391, 0.000000>,
      < -6.980371, -0.468551, -0.660402>
    }
    triangle {
      < -7.104059, -0.469687, 0.000000>,
      < -6.980371, -0.468551, -0.660402>,
      < -7.040987, -0.488222, -0.660402>
    }
    triangle {
      < -7.040373, -0.449391, 0.000000>,
      < -7.040370, -0.649382, 0.000000>,
      < -6.980371, -0.662036, -0.660402>
    }
    triangle {
      < -7.040373, -0.449391, 0.000000>,
      < -6.980371, -0.662036, -0.660402>,
      < -6.980371, -0.468551, -0.660402>
    }
    triangle {
      < -7.040370, -0.649382, 0.000000>,
      < -7.156101, -0.649382, 0.000000>,
      < -7.091707, -0.662036, -0.660402>
    }
    triangle {
      < -7.040370, -0.649382, 0.000000>,
      < -7.091707, -0.662036, -0.660402>,
      < -6.980371, -0.662036, -0.660402>
    }
    triangle {
      < -6.679999, -0.975397, -2.898600>,
      < -6.679766, -0.975385, -2.725400>,
      < -6.769086, -0.975397, -2.725227>
    }
    triangle {
      < -6.679999, -0.975397, -2.898600>,
      < -6.769086, -0.975397, -2.725227>,
      < -6.830757, -0.975397, -2.763283>
    }
    triangle {
      < -6.679999, -0.975397, -2.898600>,
      < -6.830757, -0.975397, -2.763283>,
      < -6.830800, -0.975397, -2.793523>
    }
    triangle {
      < -6.679999, -0.975397, -2.898600>,
      < -6.830800, -0.975397, -2.793523>,
      < -6.783732, -0.975397, -2.834125>
    }
    triangle {
      < -6.679999, -0.975397, -2.898600>,
      < -6.783732, -0.975397, -2.834125>,
      < -6.725246, -0.975397, -2.865391>
    }
    triangle {
      < -7.102151, -0.523676, -0.660402>,
      < -7.040987, -0.488222, -0.660402>,
      < -6.970352, -0.511978, -1.284801>
    }
    triangle {
      < -7.102151, -0.523676, -0.660402>,
      < -6.970352, -0.511978, -1.284801>,
      < -7.030923, -0.546992, -1.284801>
    }
    triangle {
      < -7.040987, -0.488222, -0.660402>,
      < -6.980371, -0.468551, -0.660402>,
      < -6.913171, -0.492551, -1.284801>
    }
    triangle {
      < -7.040987, -0.488222, -0.660402>,
      < -6.913171, -0.492551, -1.284801>,
      < -6.970352, -0.511978, -1.284801>
    }
    triangle {
      < -6.980371, -0.468551, -0.660402>,
      < -6.980371, -0.662036, -0.660402>,
      < -6.913171, -0.683637, -1.284801>
    }
    triangle {
      < -6.980371, -0.468551, -0.660402>,
      < -6.913171, -0.683637, -1.284801>,
      < -6.913171, -0.492551, -1.284801>
    }
    triangle {
      < -6.980371, -0.662036, -0.660402>,
      < -7.091707, -0.662036, -0.660402>,
      < -7.019585, -0.683637, -1.284801>
    }
    triangle {
      < -6.980371, -0.662036, -0.660402>,
      < -7.019585, -0.683637, -1.284801>,
      < -6.913171, -0.683637, -1.284801>
    }
    triangle {
      < -7.091707, -0.662036, -0.660402>,
      < -7.153274, -0.609095, -0.660402>,
      < -7.081152, -0.631353, -1.284801>
    }
    triangle {
      < -7.091707, -0.662036, -0.660402>,
      < -7.081152, -0.631353, -1.284801>,
      < -7.019585, -0.683637, -1.284801>
    }
    triangle {
      < -7.153274, -0.609095, -0.660402>,
      < -7.153274, -0.574912, -0.660402>,
      < -7.081152, -0.597594, -1.284801>
    }
    triangle {
      < -7.153274, -0.609095, -0.660402>,
      < -7.081152, -0.597594, -1.284801>,
      < -7.081152, -0.631353, -1.284801>
    }
    triangle {
      < -7.153274, -0.574912, -0.660402>,
      < -7.102151, -0.523676, -0.660402>,
      < -7.030923, -0.546992, -1.284801>
    }
    triangle {
      < -7.153274, -0.574912, -0.660402>,
      < -7.030923, -0.546992, -1.284801>,
      < -7.081152, -0.597594, -1.284801>
    }
    triangle {
      < -7.019585, -0.683637, -1.284801>,
      < -7.081152, -0.631353, -1.284801>,
      < -7.003879, -0.663932, -1.851601>
    }
    triangle {
      < -7.019585, -0.683637, -1.284801>,
      < -7.003879, -0.663932, -1.851601>,
      < -6.942312, -0.714928, -1.851601>
    }
    triangle {
      < -7.081152, -0.631353, -1.284801>,
      < -7.081152, -0.597594, -1.284801>,
      < -7.003879, -0.631005, -1.851601>
    }
    triangle {
      < -7.081152, -0.631353, -1.284801>,
      < -7.003879, -0.631005, -1.851601>,
      < -7.003879, -0.663932, -1.851601>
    }
    triangle {
      < -7.081152, -0.597594, -1.284801>,
      < -7.030923, -0.546992, -1.284801>,
      < -6.954609, -0.581651, -1.851601>
    }
    triangle {
      < -7.081152, -0.597594, -1.284801>,
      < -6.954609, -0.581651, -1.851601>,
      < -7.003879, -0.631005, -1.851601>
    }
    triangle {
      < -7.030923, -0.546992, -1.284801>,
      < -6.970352, -0.511978, -1.284801>,
      < -6.894668, -0.547499, -1.851601>
    }
    triangle {
      < -7.030923, -0.546992, -1.284801>,
      < -6.894668, -0.547499, -1.851601>,
      < -6.954609, -0.581651, -1.851601>
    }
    triangle {
      < -6.970352, -0.511978, -1.284801>,
      < -6.913171, -0.492551, -1.284801>,
      < -6.841173, -0.528551, -1.851601>
    }
    triangle {
      < -6.970352, -0.511978, -1.284801>,
      < -6.841173, -0.528551, -1.851601>,
      < -6.894668, -0.547499, -1.851601>
    }
    triangle {
      < -6.913171, -0.492551, -1.284801>,
      < -6.913171, -0.683637, -1.284801>,
      < -6.841173, -0.714928, -1.851601>
    }
    triangle {
      < -6.913171, -0.492551, -1.284801>,
      < -6.841173, -0.714928, -1.851601>,
      < -6.841173, -0.528551, -1.851601>
    }
    triangle {
      < -6.913171, -0.683637, -1.284801>,
      < -7.019585, -0.683637, -1.284801>,
      < -6.942312, -0.714928, -1.851601>
    }
    triangle {
      < -6.913171, -0.683637, -1.284801>,
      < -6.942312, -0.714928, -1.851601>,
      < -6.841173, -0.714928, -1.851601>
    }
    triangle {
      < -6.894668, -0.547499, -1.851601>,
      < -6.841173, -0.528551, -1.851601>,
      < -6.795573, -0.564551, -2.248002>
    }
    triangle {
      < -6.894668, -0.547499, -1.851601>,
      < -6.795573, -0.564551, -2.248002>,
      < -6.846962, -0.583301, -2.244705>
    }
    triangle {
      < -6.841173, -0.528551, -1.851601>,
      < -6.841173, -0.714928, -1.851601>,
      < -6.795341, -0.748094, -2.215616>
    }
    triangle {
      < -6.841173, -0.528551, -1.851601>,
      < -6.795341, -0.748094, -2.215616>,
      < -6.795573, -0.564551, -2.248002>
    }
    triangle {
      < -6.841173, -0.714928, -1.851601>,
      < -6.942312, -0.714928, -1.851601>,
      < -6.893474, -0.748249, -2.215607>
    }
    triangle {
      < -6.841173, -0.714928, -1.851601>,
      < -6.893474, -0.748249, -2.215607>,
      < -6.795341, -0.748094, -2.215616>
    }
    triangle {
      < -6.942312, -0.714928, -1.851601>,
      < -7.003879, -0.663932, -1.851601>,
      < -6.955111, -0.698103, -2.224465>
    }
    triangle {
      < -6.942312, -0.714928, -1.851601>,
      < -6.955111, -0.698103, -2.224465>,
      < -6.893474, -0.748249, -2.215607>
    }
    triangle {
      < -7.003879, -0.663932, -1.851601>,
      < -7.003879, -0.631005, -1.851601>,
      < -6.955161, -0.665677, -2.230188>
    }
    triangle {
      < -7.003879, -0.663932, -1.851601>,
      < -6.955161, -0.665677, -2.230188>,
      < -6.955111, -0.698103, -2.224465>
    }
    triangle {
      < -7.003879, -0.631005, -1.851601>,
      < -6.954609, -0.581651, -1.851601>,
      < -6.906495, -0.617009, -2.238770>
    }
    triangle {
      < -7.003879, -0.631005, -1.851601>,
      < -6.906495, -0.617009, -2.238770>,
      < -6.955161, -0.665677, -2.230188>
    }
    triangle {
      < -6.954609, -0.581651, -1.851601>,
      < -6.894668, -0.547499, -1.851601>,
      < -6.846962, -0.583301, -2.244705>
    }
    triangle {
      < -6.954609, -0.581651, -1.851601>,
      < -6.846962, -0.583301, -2.244705>,
      < -6.906495, -0.617009, -2.238770>
    }
    triangle {
      < -6.955111, -0.698103, -2.224465>,
      < -6.955161, -0.665677, -2.230188>,
      < -6.921178, -0.705357, -2.436850>
    }
    triangle {
      < -6.955111, -0.698103, -2.224465>,
      < -6.921178, -0.705357, -2.436850>,
      < -6.921115, -0.736619, -2.429191>
    }
    triangle {
      < -6.955161, -0.665677, -2.230188>,
      < -6.906495, -0.617009, -2.238770>,
      < -6.873030, -0.658395, -2.448340>
    }
    triangle {
      < -6.955161, -0.665677, -2.230188>,
      < -6.873030, -0.658395, -2.448340>,
      < -6.921178, -0.705357, -2.436850>
    }
    triangle {
      < -6.906495, -0.617009, -2.238770>,
      < -6.846962, -0.583301, -2.244705>,
      < -6.813840, -0.625849, -2.456295>
    }
    triangle {
      < -6.906495, -0.617009, -2.238770>,
      < -6.813840, -0.625849, -2.456295>,
      < -6.873030, -0.658395, -2.448340>
    }
    triangle {
      < -6.846962, -0.583301, -2.244705>,
      < -6.795573, -0.564551, -2.248002>,
      < -6.764312, -0.607716, -2.465000>
    }
    triangle {
      < -6.846962, -0.583301, -2.244705>,
      < -6.764312, -0.607716, -2.465000>,
      < -6.813840, -0.625849, -2.456295>
    }
    triangle {
      < -6.795573, -0.564551, -2.248002>,
      < -6.795341, -0.748094, -2.215616>,
      < -6.763950, -0.784674, -2.420194>
    }
    triangle {
      < -6.795573, -0.564551, -2.248002>,
      < -6.763950, -0.784674, -2.420194>,
      < -6.764312, -0.607716, -2.465000>
    }
    triangle {
      < -6.795341, -0.748094, -2.215616>,
      < -6.893474, -0.748249, -2.215607>,
      < -6.859429, -0.784919, -2.420162>
    }
    triangle {
      < -6.795341, -0.748094, -2.215616>,
      < -6.859429, -0.784919, -2.420162>,
      < -6.763950, -0.784674, -2.420194>
    }
    triangle {
      < -6.893474, -0.748249, -2.215607>,
      < -6.955111, -0.698103, -2.224465>,
      < -6.921115, -0.736619, -2.429191>
    }
    triangle {
      < -6.893474, -0.748249, -2.215607>,
      < -6.921115, -0.736619, -2.429191>,
      < -6.859429, -0.784919, -2.420162>
    }
    triangle {
      < -6.764312, -0.607716, -2.465000>,
      < -6.763950, -0.784674, -2.420194>,
      < -6.744702, -0.806197, -2.513059>
    }
    triangle {
      < -6.764312, -0.607716, -2.465000>,
      < -6.744702, -0.806197, -2.513059>,
      < -6.745065, -0.639569, -2.571234>
    }
    triangle {
      < -6.763950, -0.784674, -2.420194>,
      < -6.859429, -0.784919, -2.420162>,
      < -6.838772, -0.806440, -2.513008>
    }
    triangle {
      < -6.763950, -0.784674, -2.420194>,
      < -6.838772, -0.806440, -2.513008>,
      < -6.744702, -0.806197, -2.513059>
    }
    triangle {
      < -6.859429, -0.784919, -2.420162>,
      < -6.921115, -0.736619, -2.429191>,
      < -6.900463, -0.764452, -2.522529>
    }
    triangle {
      < -6.859429, -0.784919, -2.420162>,
      < -6.900463, -0.764452, -2.522529>,
      < -6.838772, -0.806440, -2.513008>
    }
    triangle {
      < -6.921115, -0.736619, -2.429191>,
      < -6.921178, -0.705357, -2.436850>,
      < -6.900524, -0.734166, -2.532471>
    }
    triangle {
      < -6.921115, -0.736619, -2.429191>,
      < -6.900524, -0.734166, -2.532471>,
      < -6.900463, -0.764452, -2.522529>
    }
    triangle {
      < -6.921178, -0.705357, -2.436850>,
      < -6.873030, -0.658395, -2.448340>,
      < -6.852634, -0.688671, -2.547393>
    }
    triangle {
      < -6.921178, -0.705357, -2.436850>,
      < -6.852634, -0.688671, -2.547393>,
      < -6.900524, -0.734166, -2.532471>
    }
    triangle {
      < -6.873030, -0.658395, -2.448340>,
      < -6.813840, -0.625849, -2.456295>,
      < -6.793611, -0.657139, -2.557726>
    }
    triangle {
      < -6.873030, -0.658395, -2.448340>,
      < -6.793611, -0.657139, -2.557726>,
      < -6.852634, -0.688671, -2.547393>
    }
    triangle {
      < -6.813840, -0.625849, -2.456295>,
      < -6.764312, -0.607716, -2.465000>,
      < -6.745065, -0.639569, -2.571234>
    }
    triangle {
      < -6.813840, -0.625849, -2.456295>,
      < -6.745065, -0.639569, -2.571234>,
      < -6.793611, -0.657139, -2.557726>
    }
    triangle {
      < -6.900524, -0.734166, -2.532471>,
      < -6.852634, -0.688671, -2.547393>,
      < -6.834761, -0.729891, -2.647045>
    }
    triangle {
      < -6.900524, -0.734166, -2.532471>,
      < -6.834761, -0.729891, -2.647045>,
      < -6.882408, -0.771376, -2.624346>
    }
    triangle {
      < -6.852634, -0.688671, -2.547393>,
      < -6.793611, -0.657139, -2.557726>,
      < -6.775896, -0.701126, -2.662767>
    }
    triangle {
      < -6.852634, -0.688671, -2.547393>,
      < -6.775896, -0.701126, -2.662767>,
      < -6.834761, -0.729891, -2.647045>
    }
    triangle {
      < -6.793611, -0.657139, -2.557726>,
      < -6.745065, -0.639569, -2.571234>,
      < -6.728222, -0.685081, -2.682935>
    }
    triangle {
      < -6.793611, -0.657139, -2.557726>,
      < -6.728222, -0.685081, -2.682935>,
      < -6.775896, -0.701126, -2.662767>
    }
    triangle {
      < -6.745065, -0.639569, -2.571234>,
      < -6.744702, -0.806197, -2.513059>,
      < -6.727795, -0.836503, -2.594472>
    }
    triangle {
      < -6.745065, -0.639569, -2.571234>,
      < -6.727795, -0.836503, -2.594472>,
      < -6.728222, -0.685081, -2.682935>
    }
    triangle {
      < -6.744702, -0.806197, -2.513059>,
      < -6.838772, -0.806440, -2.513008>,
      < -6.820625, -0.836784, -2.594374>
    }
    triangle {
      < -6.744702, -0.806197, -2.513059>,
      < -6.820625, -0.836784, -2.594374>,
      < -6.727795, -0.836503, -2.594472>
    }
    triangle {
      < -6.838772, -0.806440, -2.513008>,
      < -6.900463, -0.764452, -2.522529>,
      < -6.882334, -0.798975, -2.609227>
    }
    triangle {
      < -6.838772, -0.806440, -2.513008>,
      < -6.882334, -0.798975, -2.609227>,
      < -6.820625, -0.836784, -2.594374>
    }
    triangle {
      < -6.900463, -0.764452, -2.522529>,
      < -6.900524, -0.734166, -2.532471>,
      < -6.882408, -0.771376, -2.624346>
    }
    triangle {
      < -6.900463, -0.764452, -2.522529>,
      < -6.882408, -0.771376, -2.624346>,
      < -6.882334, -0.798975, -2.609227>
    }
    triangle {
      < -6.727795, -0.836503, -2.594472>,
      < -6.820625, -0.836784, -2.594374>,
      < -6.794872, -0.889850, -2.667313>
    }
    triangle {
      < -6.727795, -0.836503, -2.594472>,
      < -6.794872, -0.889850, -2.667313>,
      < -6.703798, -0.889672, -2.667458>
    }
    triangle {
      < -6.820625, -0.836784, -2.594374>,
      < -6.882334, -0.798975, -2.609227>,
      < -6.856548, -0.856801, -2.685278>
    }
    triangle {
      < -6.820625, -0.836784, -2.594374>,
      < -6.856548, -0.856801, -2.685278>,
      < -6.794872, -0.889850, -2.667313>
    }
    triangle {
      < -6.882334, -0.798975, -2.609227>,
      < -6.882408, -0.771376, -2.624346>,
      < -6.856605, -0.835405, -2.703960>
    }
    triangle {
      < -6.882334, -0.798975, -2.609227>,
      < -6.856605, -0.835405, -2.703960>,
      < -6.856548, -0.856801, -2.685278>
    }
    triangle {
      < -6.882408, -0.771376, -2.624346>,
      < -6.834761, -0.729891, -2.647045>,
      < -6.809236, -0.803261, -2.732023>
    }
    triangle {
      < -6.882408, -0.771376, -2.624346>,
      < -6.809236, -0.803261, -2.732023>,
      < -6.856605, -0.835405, -2.703960>
    }
    triangle {
      < -6.834761, -0.729891, -2.647045>,
      < -6.775896, -0.701126, -2.662767>,
      < -6.750566, -0.780981, -2.751467>
    }
    triangle {
      < -6.834761, -0.729891, -2.647045>,
      < -6.750566, -0.780981, -2.751467>,
      < -6.809236, -0.803261, -2.732023>
    }
    triangle {
      < -6.775896, -0.701126, -2.662767>,
      < -6.728222, -0.685081, -2.682935>,
      < -6.704106, -0.768564, -2.776783>
    }
    triangle {
      < -6.775896, -0.701126, -2.662767>,
      < -6.704106, -0.768564, -2.776783>,
      < -6.750566, -0.780981, -2.751467>
    }
    triangle {
      < -6.728222, -0.685081, -2.682935>,
      < -6.727795, -0.836503, -2.594472>,
      < -6.703798, -0.889672, -2.667458>
    }
    triangle {
      < -6.728222, -0.685081, -2.682935>,
      < -6.703798, -0.889672, -2.667458>,
      < -6.704106, -0.768564, -2.776783>
    }
    triangle {
      < -6.809236, -0.803261, -2.732023>,
      < -6.750566, -0.780981, -2.751467>,
      < -6.725217, -0.921603, -2.841858>
    }
    triangle {
      < -6.809236, -0.803261, -2.732023>,
      < -6.725217, -0.921603, -2.841858>,
      < -6.783704, -0.932582, -2.815392>
    }
    triangle {
      < -6.750566, -0.780981, -2.751467>,
      < -6.704106, -0.768564, -2.776783>,
      < -6.679971, -0.915506, -2.874271>
    }
    triangle {
      < -6.750566, -0.780981, -2.751467>,
      < -6.679971, -0.915506, -2.874271>,
      < -6.725217, -0.921603, -2.841858>
    }
    triangle {
      < -6.704106, -0.768564, -2.776783>,
      < -6.703798, -0.889672, -2.667458>,
      < -6.679766, -0.975385, -2.725400>
    }
    triangle {
      < -6.704106, -0.768564, -2.776783>,
      < -6.679766, -0.975385, -2.725400>,
      < -6.679971, -0.915506, -2.874271>
    }
    triangle {
      < -6.703798, -0.889672, -2.667458>,
      < -6.794872, -0.889850, -2.667313>,
      < -6.769086, -0.975397, -2.725227>
    }
    triangle {
      < -6.703798, -0.889672, -2.667458>,
      < -6.769086, -0.975397, -2.725227>,
      < -6.679766, -0.975385, -2.725400>
    }
    triangle {
      < -6.794872, -0.889850, -2.667313>,
      < -6.856548, -0.856801, -2.685278>,
      < -6.830726, -0.959023, -2.751749>
    }
    triangle {
      < -6.794872, -0.889850, -2.667313>,
      < -6.830726, -0.959023, -2.751749>,
      < -6.769086, -0.975397, -2.725227>
    }
    triangle {
      < -6.856548, -0.856801, -2.685278>,
      < -6.856605, -0.835405, -2.703960>,
      < -6.830770, -0.948443, -2.777189>
    }
    triangle {
      < -6.856548, -0.856801, -2.685278>,
      < -6.830770, -0.948443, -2.777189>,
      < -6.830726, -0.959023, -2.751749>
    }
    triangle {
      < -6.856605, -0.835405, -2.703960>,
      < -6.809236, -0.803261, -2.732023>,
      < -6.783704, -0.932582, -2.815392>
    }
    triangle {
      < -6.856605, -0.835405, -2.703960>,
      < -6.783704, -0.932582, -2.815392>,
      < -6.830770, -0.948443, -2.777189>
    }
    triangle {
      < -6.769086, -0.975397, -2.725227>,
      < -6.830726, -0.959023, -2.751749>,
      < -6.830757, -0.975397, -2.763283>
    }
    triangle {
      < -6.830726, -0.959023, -2.751749>,
      < -6.830770, -0.948443, -2.777189>,
      < -6.830800, -0.975397, -2.793523>
    }
    triangle {
      < -6.830726, -0.959023, -2.751749>,
      < -6.830800, -0.975397, -2.793523>,
      < -6.830757, -0.975397, -2.763283>
    }
    triangle {
      < -6.830770, -0.948443, -2.777189>,
      < -6.783704, -0.932582, -2.815392>,
      < -6.783732, -0.975397, -2.834125>
    }
    triangle {
      < -6.830770, -0.948443, -2.777189>,
      < -6.783732, -0.975397, -2.834125>,
      < -6.830800, -0.975397, -2.793523>
    }
    triangle {
      < -6.783704, -0.932582, -2.815392>,
      < -6.725217, -0.921603, -2.841858>,
      < -6.725246, -0.975397, -2.865391>
    }
    triangle {
      < -6.783704, -0.932582, -2.815392>,
      < -6.725246, -0.975397, -2.865391>,
      < -6.783732, -0.975397, -2.834125>
    }
    triangle {
      < -6.725217, -0.921603, -2.841858>,
      < -6.679971, -0.915506, -2.874271>,
      < -6.679999, -0.975397, -2.898600>
    }
    triangle {
      < -6.725217, -0.921603, -2.841858>,
      < -6.679999, -0.975397, -2.898600>,
      < -6.725246, -0.975397, -2.865391>
    }
    triangle {
      < -6.679971, -0.915506, -2.874271>,
      < -6.679766, -0.975385, -2.725400>,
      < -6.679999, -0.975397, -2.898600>
    }
    triangle {
      < -7.088053, -1.366763, 0.000000>,
      < -6.928576, -1.359446, -1.742034>,
      < -7.000368, -1.396264, -1.751397>
    }
    triangle {
      < -7.088053, -1.366763, 0.000000>,
      < -7.000368, -1.396264, -1.751397>,
      < -7.166669, -1.402146, 0.000000>
    }
    triangle {
      < -6.387282, -1.658624, -2.864736>,
      < -6.422453, -1.549520, -2.907676>,
      < -5.965001, -1.564561, -2.923875>
    }
    triangle {
      < -6.387282, -1.658624, -2.864736>,
      < -5.965001, -1.564561, -2.923875>,
      < -5.908761, -1.658627, -2.888216>
    }
    triangle {
      < -6.806197, -1.329456, -1.724040>,
      < -6.928576, -1.359446, -1.742034>,
      < -7.088053, -1.366763, 0.000000>
    }
    triangle {
      < -6.806197, -1.329456, -1.724040>,
      < -7.088053, -1.366763, 0.000000>,
      < -7.001560, -1.324139, 0.000000>
    }
    triangle {
      < -7.285424, -1.538095, 0.000000>,
      < -7.105881, -1.534636, -1.767466>,
      < -7.084901, -1.589411, -1.766879>
    }
    triangle {
      < -7.285424, -1.538095, 0.000000>,
      < -7.084901, -1.589411, -1.766879>,
      < -7.260464, -1.592207, 0.000000>
    }
    triangle {
      < -6.422453, -1.549520, -2.907676>,
      < -6.437954, -1.474521, -2.968994>,
      < -5.946338, -1.504564, -2.972630>
    }
    triangle {
      < -6.422453, -1.549520, -2.907676>,
      < -5.946338, -1.504564, -2.972630>,
      < -5.965001, -1.564561, -2.923875>
    }
    triangle {
      < -5.994472, -1.120564, -3.065847>,
      < -5.795750, -1.119792, -3.044409>,
      < -5.776556, -1.177829, -3.017266>
    }
    triangle {
      < -5.994472, -1.120564, -3.065847>,
      < -5.776556, -1.177829, -3.017266>,
      < -5.977087, -1.168581, -3.057851>
    }
    triangle {
      < -6.943068, -1.013447, -2.837431>,
      < -7.003592, -1.010780, -2.706787>,
      < -6.943775, -0.989475, -2.705712>
    }
    triangle {
      < -6.943068, -1.013447, -2.837431>,
      < -6.943775, -0.989475, -2.705712>,
      < -6.896116, -0.992319, -2.807465>
    }
    triangle {
      < -6.444781, -1.384520, -2.944435>,
      < -6.437954, -1.474521, -2.968994>,
      < -6.661417, -1.464500, -2.930422>
    }
    triangle {
      < -6.444781, -1.384520, -2.944435>,
      < -6.661417, -1.464500, -2.930422>,
      < -6.647933, -1.394501, -2.909369>
    }
    triangle {
      < -6.756017, -1.770061, -2.657989>,
      < -6.661929, -1.769979, -2.720089>,
      < -6.596330, -1.859547, -2.644202>
    }
    triangle {
      < -6.756017, -1.770061, -2.657989>,
      < -6.596330, -1.859547, -2.644202>,
      < -6.686976, -1.859547, -2.586358>
    }
    triangle {
      < -7.022886, -1.409456, -2.450853>,
      < -6.931129, -1.659463, -2.403928>,
      < -7.005176, -1.550954, -2.317360>
    }
    triangle {
      < -6.990645, -1.226394, -2.190381>,
      < -6.976470, -1.298631, -2.102237>,
      < -6.899156, -1.264157, -2.076385>
    }
    triangle {
      < -6.990645, -1.226394, -2.190381>,
      < -6.899156, -1.264157, -2.076385>,
      < -6.915789, -1.194457, -2.154421>
    }
    triangle {
      < -5.980691, -1.027046, -3.030011>,
      < -6.493579, -1.016994, -3.008955>,
      < -6.488513, -0.995182, -2.962733>
    }
    triangle {
      < -5.980691, -1.027046, -3.030011>,
      < -6.488513, -0.995182, -2.962733>,
      < -5.975104, -1.009408, -2.989822>
    }
    triangle {
      < -6.444781, -1.384520, -2.944435>,
      < -6.453266, -1.284490, -2.965122>,
      < -5.945208, -1.284483, -2.987595>
    }
    triangle {
      < -6.444781, -1.384520, -2.944435>,
      < -5.945208, -1.284483, -2.987595>,
      < -5.944620, -1.416520, -2.956802>
    }
    triangle {
      < -6.647933, -1.394501, -2.909369>,
      < -6.666018, -1.284488, -2.935784>,
      < -6.453266, -1.284490, -2.965122>
    }
    triangle {
      < -6.647933, -1.394501, -2.909369>,
      < -6.453266, -1.284490, -2.965122>,
      < -6.444781, -1.384520, -2.944435>
    }
    triangle {
      < -6.919416, -1.284488, -2.764061>,
      < -6.904433, -1.463284, -2.706286>,
      < -6.939265, -1.460639, -2.654139>
    }
    triangle {
      < -6.919416, -1.284488, -2.764061>,
      < -6.939265, -1.460639, -2.654139>,
      < -6.981668, -1.284483, -2.668404>
    }
    triangle {
      < -6.939265, -1.460639, -2.654139>,
      < -7.005966, -1.416750, -2.478881>,
      < -7.014936, -1.369458, -2.490375>
    }
    triangle {
      < -6.939265, -1.460639, -2.654139>,
      < -7.014936, -1.369458, -2.490375>,
      < -6.981668, -1.284483, -2.668404>
    }
    triangle {
      < -6.626447, -1.658622, -2.817301>,
      < -6.640931, -1.539500, -2.868735>,
      < -6.422453, -1.549520, -2.907676>
    }
    triangle {
      < -6.626447, -1.658622, -2.817301>,
      < -6.422453, -1.549520, -2.907676>,
      < -6.387282, -1.658624, -2.864736>
    }
    triangle {
      < -6.764087, -1.284490, -2.897935>,
      < -6.746375, -1.424491, -2.866534>,
      < -6.758198, -1.464489, -2.842342>
    }
    triangle {
      < -6.764087, -1.284490, -2.897935>,
      < -6.758198, -1.464489, -2.842342>,
      < -6.838706, -1.284492, -2.838292>
    }
    triangle {
      < -6.808095, -1.658623, -2.710665>,
      < -6.758198, -1.464489, -2.842342>,
      < -6.732902, -1.514492, -2.845476>
    }
    triangle {
      < -6.808095, -1.658623, -2.710665>,
      < -6.732902, -1.514492, -2.845476>,
      < -6.714914, -1.658623, -2.773726>
    }
    triangle {
      < -5.908761, -1.658627, -2.888216>,
      < -5.965001, -1.564561, -2.923875>,
      < -5.853824, -1.549571, -2.935682>
    }
    triangle {
      < -6.437954, -1.474521, -2.968994>,
      < -6.422453, -1.549520, -2.907676>,
      < -6.640931, -1.539500, -2.868735>
    }
    triangle {
      < -6.437954, -1.474521, -2.968994>,
      < -6.640931, -1.539500, -2.868735>,
      < -6.661417, -1.464500, -2.930422>
    }
    triangle {
      < -5.965001, -1.564561, -2.923875>,
      < -5.946338, -1.504564, -2.972630>,
      < -5.853824, -1.549571, -2.935682>
    }
    triangle {
      < -6.486555, -1.169997, -3.044676>,
      < -6.707731, -1.171216, -3.021462>,
      < -6.719749, -1.120220, -3.039568>
    }
    triangle {
      < -6.486555, -1.169997, -3.044676>,
      < -6.719749, -1.120220, -3.039568>,
      < -6.497226, -1.120446, -3.059467>
    }
    triangle {
      < -6.989767, -1.172314, -2.848089>,
      < -7.069232, -1.171446, -2.694571>,
      < -7.088174, -1.119861, -2.700568>
    }
    triangle {
      < -6.989767, -1.172314, -2.848089>,
      < -7.088174, -1.119861, -2.700568>,
      < -7.005646, -1.119330, -2.870995>
    }
    triangle {
      < -6.906362, -1.172695, -2.924689>,
      < -6.989767, -1.172314, -2.848089>,
      < -7.005646, -1.119330, -2.870995>
    }
    triangle {
      < -6.906362, -1.172695, -2.924689>,
      < -7.005646, -1.119330, -2.870995>,
      < -6.923314, -1.119656, -2.946822>
    }
    triangle {
      < -6.707731, -1.171216, -3.021462>,
      < -6.819161, -1.172247, -2.985674>,
      < -6.833333, -1.119999, -3.006480>
    }
    triangle {
      < -6.707731, -1.171216, -3.021462>,
      < -6.833333, -1.119999, -3.006480>,
      < -6.719749, -1.120220, -3.039568>
    }
    triangle {
      < -5.977087, -1.168581, -3.057851>,
      < -6.486555, -1.169997, -3.044676>,
      < -6.497226, -1.120446, -3.059467>
    }
    triangle {
      < -5.977087, -1.168581, -3.057851>,
      < -6.497226, -1.120446, -3.059467>,
      < -5.994472, -1.120564, -3.065847>
    }
    triangle {
      < -6.806467, -1.012607, -2.958068>,
      < -6.878011, -1.012117, -2.905717>,
      < -6.841444, -0.989483, -2.868588>
    }
    triangle {
      < -6.806467, -1.012607, -2.958068>,
      < -6.841444, -0.989483, -2.868588>,
      < -6.782897, -0.989486, -2.914382>
    }
    triangle {
      < -6.493579, -1.016994, -3.008955>,
      < -6.710935, -1.012946, -2.986064>,
      < -6.700897, -0.989491, -2.938380>
    }
    triangle {
      < -6.493579, -1.016994, -3.008955>,
      < -6.700897, -0.989491, -2.938380>,
      < -6.488513, -0.995182, -2.962733>
    }
    triangle {
      < -6.710935, -1.012946, -2.986064>,
      < -6.806467, -1.012607, -2.958068>,
      < -6.782897, -0.989486, -2.914382>
    }
    triangle {
      < -6.710935, -1.012946, -2.986064>,
      < -6.782897, -0.989486, -2.914382>,
      < -6.700897, -0.989491, -2.938380>
    }
    triangle {
      < -6.878011, -1.012117, -2.905717>,
      < -6.943068, -1.013447, -2.837431>,
      < -6.896116, -0.992319, -2.807465>
    }
    triangle {
      < -6.878011, -1.012117, -2.905717>,
      < -6.896116, -0.992319, -2.807465>,
      < -6.841444, -0.989483, -2.868588>
    }
    triangle {
      < -7.075849, -1.580462, -1.933608>,
      < -7.084901, -1.589411, -1.766879>,
      < -7.105881, -1.534636, -1.767466>
    }
    triangle {
      < -7.075849, -1.580462, -1.933608>,
      < -7.105881, -1.534636, -1.767466>,
      < -7.094053, -1.527854, -1.920331>
    }
    triangle {
      < -7.093822, -1.417261, -2.193316>,
      < -7.097250, -1.331093, -2.310717>,
      < -7.091934, -1.354392, -2.349924>
    }
    triangle {
      < -7.093822, -1.417261, -2.193316>,
      < -7.091934, -1.354392, -2.349924>,
      < -7.080834, -1.458599, -2.229285>
    }
    triangle {
      < -6.979893, -1.388660, -1.881194>,
      < -7.000368, -1.396264, -1.751397>,
      < -6.928576, -1.359446, -1.742034>
    }
    triangle {
      < -6.979893, -1.388660, -1.881194>,
      < -6.928576, -1.359446, -1.742034>,
      < -6.903983, -1.350924, -1.865938>
    }
    triangle {
      < -6.899156, -1.264157, -2.076385>,
      < -6.787118, -1.231666, -2.049427>,
      < -6.807567, -1.164466, -2.123392>
    }
    triangle {
      < -6.899156, -1.264157, -2.076385>,
      < -6.807567, -1.164466, -2.123392>,
      < -6.915789, -1.194457, -2.154421>
    }
    triangle {
      < -6.784866, -1.318434, -1.846585>,
      < -6.903983, -1.350924, -1.865938>,
      < -6.928576, -1.359446, -1.742034>
    }
    triangle {
      < -6.784866, -1.318434, -1.846585>,
      < -6.928576, -1.359446, -1.742034>,
      < -6.806197, -1.329456, -1.724040>
    }
    triangle {
      < -7.005966, -1.416750, -2.478881>,
      < -7.022886, -1.409456, -2.450853>,
      < -7.014936, -1.369458, -2.490375>
    }
    triangle {
      < -7.142025, -1.789917, 0.000000>,
      < -6.972465, -1.791266, -1.766075>,
      < -6.923715, -1.859547, -1.767040>
    }
    triangle {
      < -7.142025, -1.789917, 0.000000>,
      < -6.923715, -1.859547, -1.767040>,
      < -7.096247, -1.859547, 0.000000>
    }
    triangle {
      < -6.370975, -1.859520, -2.723353>,
      < -6.015004, -1.819897, -2.788333>,
      < -6.073455, -1.859547, -2.746403>
    }
    triangle {
      < -6.661929, -1.769979, -2.720089>,
      < -6.569460, -1.769633, -2.765059>,
      < -6.503947, -1.859547, -2.688095>
    }
    triangle {
      < -6.661929, -1.769979, -2.720089>,
      < -6.503947, -1.859547, -2.688095>,
      < -6.596330, -1.859547, -2.644202>
    }
    triangle {
      < -6.381032, -1.768794, -2.807622>,
      < -6.370975, -1.859520, -2.723353>,
      < -6.503947, -1.859547, -2.688095>
    }
    triangle {
      < -6.381032, -1.768794, -2.807622>,
      < -6.503947, -1.859547, -2.688095>,
      < -6.569460, -1.769633, -2.765059>
    }
    triangle {
      < -6.972465, -1.791266, -1.766075>,
      < -6.954820, -1.787191, -1.967162>,
      < -6.893315, -1.859547, -1.965427>
    }
    triangle {
      < -6.972465, -1.791266, -1.766075>,
      < -6.893315, -1.859547, -1.965427>,
      < -6.923715, -1.859547, -1.767040>
    }
    triangle {
      < -6.752730, -1.859547, -2.511016>,
      < -6.823873, -1.769634, -2.576504>,
      < -6.756017, -1.770061, -2.657989>
    }
    triangle {
      < -6.752730, -1.859547, -2.511016>,
      < -6.756017, -1.770061, -2.657989>,
      < -6.686976, -1.859547, -2.586358>
    }
    triangle {
      < -6.823873, -1.769634, -2.576504>,
      < -6.752730, -1.859547, -2.511016>,
      < -6.830263, -1.859547, -2.349217>
    }
    triangle {
      < -6.823873, -1.769634, -2.576504>,
      < -6.830263, -1.859547, -2.349217>,
      < -6.894863, -1.767690, -2.380389>
    }
    triangle {
      < -5.791178, -1.031257, -3.006389>,
      < -5.980691, -1.027046, -3.030011>,
      < -5.975104, -1.009408, -2.989822>
    }
    triangle {
      < -5.791178, -1.031257, -3.006389>,
      < -5.975104, -1.009408, -2.989822>,
      < -5.794860, -1.020287, -2.986475>
    }
    triangle {
      < -6.819161, -1.172247, -2.985674>,
      < -6.906362, -1.172695, -2.924689>,
      < -6.923314, -1.119656, -2.946822>
    }
    triangle {
      < -6.819161, -1.172247, -2.985674>,
      < -6.923314, -1.119656, -2.946822>,
      < -6.833333, -1.119999, -3.006480>
    }
    triangle {
      < -6.862916, -1.859547, -2.163813>,
      < -6.940769, -1.760330, -2.159502>,
      < -6.894863, -1.767690, -2.380389>
    }
    triangle {
      < -6.862916, -1.859547, -2.163813>,
      < -6.894863, -1.767690, -2.380389>,
      < -6.830263, -1.859547, -2.349217>
    }
    triangle {
      < -6.904433, -1.463284, -2.706286>,
      < -6.919416, -1.284488, -2.764061>,
      < -6.838706, -1.284492, -2.838292>
    }
    triangle {
      < -6.904433, -1.463284, -2.706286>,
      < -6.838706, -1.284492, -2.838292>,
      < -6.830558, -1.467492, -2.783210>
    }
    triangle {
      < -6.746375, -1.424491, -2.866534>,
      < -6.764087, -1.284490, -2.897935>,
      < -6.666018, -1.284488, -2.935784>
    }
    triangle {
      < -6.746375, -1.424491, -2.866534>,
      < -6.666018, -1.284488, -2.935784>,
      < -6.647933, -1.394501, -2.909369>
    }
    triangle {
      < -6.714914, -1.658623, -2.773726>,
      < -6.732902, -1.514492, -2.845476>,
      < -6.640931, -1.539500, -2.868735>
    }
    triangle {
      < -6.714914, -1.658623, -2.773726>,
      < -6.640931, -1.539500, -2.868735>,
      < -6.626447, -1.658622, -2.817301>
    }
    triangle {
      < -6.838706, -1.284492, -2.838292>,
      < -6.758198, -1.464489, -2.842342>,
      < -6.830558, -1.467492, -2.783210>
    }
    triangle {
      < -6.661417, -1.464500, -2.930422>,
      < -6.640931, -1.539500, -2.868735>,
      < -6.732902, -1.514492, -2.845476>
    }
    triangle {
      < -6.661417, -1.464500, -2.930422>,
      < -6.732902, -1.514492, -2.845476>,
      < -6.758198, -1.464489, -2.842342>
    }
    triangle {
      < -6.647933, -1.394501, -2.909369>,
      < -6.661417, -1.464500, -2.930422>,
      < -6.758198, -1.464489, -2.842342>
    }
    triangle {
      < -6.647933, -1.394501, -2.909369>,
      < -6.758198, -1.464489, -2.842342>,
      < -6.746375, -1.424491, -2.866534>
    }
    triangle {
      < -6.437954, -1.474521, -2.968994>,
      < -6.444781, -1.384520, -2.944435>,
      < -5.944620, -1.416520, -2.956802>
    }
    triangle {
      < -6.437954, -1.474521, -2.968994>,
      < -5.944620, -1.416520, -2.956802>,
      < -5.946338, -1.504564, -2.972630>
    }
    triangle {
      < -5.853824, -1.549571, -2.935682>,
      < -5.946338, -1.504564, -2.972630>,
      < -5.809381, -1.454192, -2.953298>
    }
    triangle {
      < -5.944620, -1.416520, -2.956802>,
      < -5.945208, -1.284483, -2.987595>,
      < -5.820180, -1.284486, -2.983333>
    }
    triangle {
      < -5.944620, -1.416520, -2.956802>,
      < -5.820180, -1.284486, -2.983333>,
      < -5.809381, -1.454192, -2.953298>
    }
    triangle {
      < -5.946338, -1.504564, -2.972630>,
      < -5.944620, -1.416520, -2.956802>,
      < -5.809381, -1.454192, -2.953298>
    }
    triangle {
      < -7.089150, -1.340504, -2.363926>,
      < -7.091934, -1.354392, -2.349924>,
      < -7.097250, -1.331093, -2.310717>
    }
    triangle {
      < -7.089150, -1.340504, -2.363926>,
      < -7.097250, -1.331093, -2.310717>,
      < -7.101055, -1.325408, -2.314543>
    }
    triangle {
      < -6.903983, -1.350924, -1.865938>,
      < -6.784866, -1.318434, -1.846585>,
      < -6.778671, -1.284465, -1.951116>
    }
    triangle {
      < -6.903983, -1.350924, -1.865938>,
      < -6.778671, -1.284465, -1.951116>,
      < -6.884923, -1.319456, -1.971828>
    }
    triangle {
      < -6.964900, -1.355802, -1.990809>,
      < -6.979893, -1.388660, -1.881194>,
      < -6.903983, -1.350924, -1.865938>
    }
    triangle {
      < -6.964900, -1.355802, -1.990809>,
      < -6.903983, -1.350924, -1.865938>,
      < -6.884923, -1.319456, -1.971828>
    }
    triangle {
      < -7.072170, -1.535828, -2.082598>,
      < -7.075849, -1.580462, -1.933608>,
      < -7.094053, -1.527854, -1.920331>
    }
    triangle {
      < -7.072170, -1.535828, -2.082598>,
      < -7.094053, -1.527854, -1.920331>,
      < -7.087876, -1.487158, -2.054882>
    }
    triangle {
      < -7.005176, -1.550954, -2.317360>,
      < -6.931129, -1.659463, -2.403928>,
      < -6.989864, -1.644451, -2.150267>
    }
    triangle {
      < -7.080834, -1.458599, -2.229285>,
      < -7.072170, -1.535828, -2.082598>,
      < -7.087876, -1.487158, -2.054882>
    }
    triangle {
      < -7.080834, -1.458599, -2.229285>,
      < -7.087876, -1.487158, -2.054882>,
      < -7.093822, -1.417261, -2.193316>
    }
    triangle {
      < -6.976470, -1.298631, -2.102237>,
      < -6.964900, -1.355802, -1.990809>,
      < -6.884923, -1.319456, -1.971828>
    }
    triangle {
      < -6.976470, -1.298631, -2.102237>,
      < -6.884923, -1.319456, -1.971828>,
      < -6.899156, -1.264157, -2.076385>
    }
    triangle {
      < -6.787118, -1.231666, -2.049427>,
      < -6.899156, -1.264157, -2.076385>,
      < -6.884923, -1.319456, -1.971828>
    }
    triangle {
      < -6.787118, -1.231666, -2.049427>,
      < -6.884923, -1.319456, -1.971828>,
      < -6.778671, -1.284465, -1.951116>
    }
    triangle {
      < -6.954820, -1.787191, -1.967162>,
      < -6.940769, -1.760330, -2.159502>,
      < -6.862916, -1.859547, -2.163813>
    }
    triangle {
      < -6.954820, -1.787191, -1.967162>,
      < -6.862916, -1.859547, -2.163813>,
      < -6.893315, -1.859547, -1.965427>
    }
    triangle {
      < -5.742157, -1.255670, -2.984018>,
      < -5.809381, -1.454192, -2.953298>,
      < -5.820180, -1.284486, -2.983333>
    }
    triangle {
      < -6.769863, -1.171843, -2.115272>,
      < -6.807567, -1.164466, -2.123392>,
      < -6.787118, -1.231666, -2.049427>
    }
    triangle {
      < -6.769863, -1.171843, -2.115272>,
      < -6.787118, -1.231666, -2.049427>,
      < -6.748319, -1.231666, -2.049427>
    }
    triangle {
      < -6.752730, -1.859547, -2.511016>,
      < -6.686976, -1.859547, -2.586358>,
      < -6.713930, -1.859547, -2.511016>
    }
    triangle {
      < -6.787118, -1.231666, -2.049427>,
      < -6.778671, -1.284465, -1.951116>,
      < -6.739871, -1.284465, -1.951116>
    }
    triangle {
      < -6.787118, -1.231666, -2.049427>,
      < -6.739871, -1.284465, -1.951116>,
      < -6.748319, -1.231666, -2.049427>
    }
    triangle {
      < -6.778671, -1.284465, -1.951116>,
      < -6.784866, -1.318434, -1.846585>,
      < -6.746067, -1.318434, -1.846585>
    }
    triangle {
      < -6.778671, -1.284465, -1.951116>,
      < -6.746067, -1.318434, -1.846585>,
      < -6.739871, -1.284465, -1.951116>
    }
    triangle {
      < -6.784866, -1.318434, -1.846585>,
      < -6.806197, -1.329456, -1.724040>,
      < -6.767396, -1.329456, -1.724040>
    }
    triangle {
      < -6.784866, -1.318434, -1.846585>,
      < -6.767396, -1.329456, -1.724040>,
      < -6.746067, -1.318434, -1.846585>
    }
    triangle {
      < -6.806197, -1.329456, -1.724040>,
      < -7.001560, -1.324139, 0.000000>,
      < -6.962760, -1.324139, 0.000000>
    }
    triangle {
      < -6.806197, -1.329456, -1.724040>,
      < -6.962760, -1.324139, 0.000000>,
      < -6.767396, -1.329456, -1.724040>
    }
    triangle {
      < -7.096247, -1.859547, 0.000000>,
      < -6.923715, -1.859547, -1.767040>,
      < -6.884914, -1.859547, -1.767040>
    }
    triangle {
      < -7.096247, -1.859547, 0.000000>,
      < -6.884914, -1.859547, -1.767040>,
      < -7.057447, -1.859547, 0.000000>
    }
    triangle {
      < -6.923715, -1.859547, -1.767040>,
      < -6.893315, -1.859547, -1.965427>,
      < -6.854515, -1.859547, -1.965427>
    }
    triangle {
      < -6.923715, -1.859547, -1.767040>,
      < -6.854515, -1.859547, -1.965427>,
      < -6.884914, -1.859547, -1.767040>
    }
    triangle {
      < -6.893315, -1.859547, -1.965427>,
      < -6.862916, -1.859547, -2.163813>,
      < -6.824117, -1.859547, -2.163813>
    }
    triangle {
      < -6.893315, -1.859547, -1.965427>,
      < -6.824117, -1.859547, -2.163813>,
      < -6.854515, -1.859547, -1.965427>
    }
    triangle {
      < -6.862916, -1.859547, -2.163813>,
      < -6.830263, -1.859547, -2.349217>,
      < -6.791463, -1.859547, -2.349217>
    }
    triangle {
      < -6.862916, -1.859547, -2.163813>,
      < -6.791463, -1.859547, -2.349217>,
      < -6.824117, -1.859547, -2.163813>
    }
    triangle {
      < -6.830263, -1.859547, -2.349217>,
      < -6.752730, -1.859547, -2.511016>,
      < -6.713930, -1.859547, -2.511016>
    }
    triangle {
      < -6.830263, -1.859547, -2.349217>,
      < -6.713930, -1.859547, -2.511016>,
      < -6.791463, -1.859547, -2.349217>
    }
    triangle {
      < -6.896116, -0.992319, -2.807465>,
      < -6.943775, -0.989475, -2.705712>,
      < -6.890060, -0.976641, -2.663275>
    }
    triangle {
      < -6.896116, -0.992319, -2.807465>,
      < -6.890060, -0.976641, -2.663275>,
      < -6.850533, -0.979485, -2.765028>
    }
    triangle {
      < -6.686976, -1.859547, -2.586358>,
      < -6.596330, -1.859547, -2.644202>,
      < -6.584070, -1.846712, -2.601764>
    }
    triangle {
      < -6.686976, -1.859547, -2.586358>,
      < -6.584070, -1.846712, -2.601764>,
      < -6.674716, -1.846712, -2.543921>
    }
    triangle {
      < -6.596330, -1.859547, -2.644202>,
      < -6.503947, -1.859547, -2.688095>,
      < -6.491687, -1.846712, -2.645658>
    }
    triangle {
      < -6.596330, -1.859547, -2.644202>,
      < -6.491687, -1.846712, -2.645658>,
      < -6.584070, -1.846712, -2.601764>
    }
    triangle {
      < -6.503947, -1.859547, -2.688095>,
      < -6.370975, -1.859520, -2.723353>,
      < -6.358714, -1.846712, -2.680916>
    }
    triangle {
      < -6.503947, -1.859547, -2.688095>,
      < -6.358714, -1.846712, -2.680916>,
      < -6.491687, -1.846712, -2.645658>
    }
    triangle {
      < -6.370975, -1.859520, -2.723353>,
      < -6.073455, -1.859547, -2.746403>,
      < -6.064945, -1.846712, -2.703966>
    }
    triangle {
      < -6.370975, -1.859520, -2.723353>,
      < -6.064945, -1.846712, -2.703966>,
      < -6.358714, -1.846712, -2.680916>
    }
    triangle {
      < -6.015004, -1.819897, -2.788333>,
      < -6.002273, -1.805053, -2.739253>,
      < -6.064945, -1.846712, -2.703966>
    }
    triangle {
      < -6.015004, -1.819897, -2.788333>,
      < -6.064945, -1.846712, -2.703966>,
      < -6.073455, -1.859547, -2.746403>
    }
    triangle {
      < -5.908761, -1.658627, -2.888216>,
      < -5.853824, -1.549571, -2.935682>,
      < -5.836937, -1.536736, -2.893245>
    }
    triangle {
      < -5.908761, -1.658627, -2.888216>,
      < -5.836937, -1.536736, -2.893245>,
      < -5.893969, -1.645792, -2.845779>
    }
    triangle {
      < -5.853824, -1.549571, -2.935682>,
      < -5.809381, -1.454192, -2.953298>,
      < -5.790800, -1.441357, -2.910861>
    }
    triangle {
      < -5.853824, -1.549571, -2.935682>,
      < -5.790800, -1.441357, -2.910861>,
      < -5.836937, -1.536736, -2.893245>
    }
    triangle {
      < -5.809381, -1.454192, -2.953298>,
      < -5.742157, -1.255670, -2.984018>,
      < -5.721012, -1.242835, -2.941581>
    }
    triangle {
      < -5.809381, -1.454192, -2.953298>,
      < -5.721012, -1.242835, -2.941581>,
      < -5.790800, -1.441357, -2.910861>
    }
    triangle {
      < -5.742157, -1.255670, -2.984018>,
      < -5.676820, -1.177579, -2.983173>,
      < -5.653183, -1.164744, -2.940736>
    }
    triangle {
      < -5.742157, -1.255670, -2.984018>,
      < -5.653183, -1.164744, -2.940736>,
      < -5.721012, -1.242835, -2.941581>
    }
    triangle {
      < -5.676820, -1.177579, -2.983173>,
      < -5.646147, -1.119743, -2.978052>,
      < -5.624572, -1.107859, -2.939728>
    }
    triangle {
      < -5.676820, -1.177579, -2.983173>,
      < -5.624572, -1.107859, -2.939728>,
      < -5.653183, -1.164744, -2.940736>
    }
    triangle {
      < -5.656684, -1.083012, -2.978059>,
      < -5.685392, -1.083939, -3.010567>,
      < -5.720068, -1.044287, -2.980925>
    }
    triangle {
      < -5.720068, -1.044287, -2.980925>,
      < -5.794860, -1.020287, -2.986475>,
      < -5.775725, -1.007452, -2.944038>
    }
    triangle {
      < -5.720068, -1.044287, -2.980925>,
      < -5.775725, -1.007452, -2.944038>,
      < -5.698081, -1.031452, -2.938488>
    }
    triangle {
      < -5.794860, -1.020287, -2.986475>,
      < -5.975104, -1.009408, -2.989822>,
      < -5.962842, -0.996574, -2.947385>
    }
    triangle {
      < -5.794860, -1.020287, -2.986475>,
      < -5.962842, -0.996574, -2.947385>,
      < -5.775725, -1.007452, -2.944038>
    }
    triangle {
      < -5.975104, -1.009408, -2.989822>,
      < -6.488513, -0.995182, -2.962733>,
      < -6.476254, -0.982347, -2.920296>
    }
    triangle {
      < -5.975104, -1.009408, -2.989822>,
      < -6.476254, -0.982347, -2.920296>,
      < -5.962842, -0.996574, -2.947385>
    }
    triangle {
      < -6.488513, -0.995182, -2.962733>,
      < -6.700897, -0.989491, -2.938380>,
      < -6.688638, -0.976656, -2.895943>
    }
    triangle {
      < -6.488513, -0.995182, -2.962733>,
      < -6.688638, -0.976656, -2.895943>,
      < -6.476254, -0.982347, -2.920296>
    }
    triangle {
      < -6.700897, -0.989491, -2.938380>,
      < -6.782897, -0.989486, -2.914382>,
      < -6.756642, -0.976652, -2.871945>
    }
    triangle {
      < -6.700897, -0.989491, -2.938380>,
      < -6.756642, -0.976652, -2.871945>,
      < -6.688638, -0.976656, -2.895943>
    }
    triangle {
      < -6.782897, -0.989486, -2.914382>,
      < -6.841444, -0.989483, -2.868588>,
      < -6.805195, -0.976648, -2.826151>
    }
    triangle {
      < -6.782897, -0.989486, -2.914382>,
      < -6.805195, -0.976648, -2.826151>,
      < -6.756642, -0.976652, -2.871945>
    }
    triangle {
      < -6.841444, -0.989483, -2.868588>,
      < -6.896116, -0.992319, -2.807465>,
      < -6.850533, -0.979485, -2.765028>
    }
    triangle {
      < -6.841444, -0.989483, -2.868588>,
      < -6.850533, -0.979485, -2.765028>,
      < -6.805195, -0.976648, -2.826151>
    }
    triangle {
      < -5.656684, -1.083012, -2.978059>,
      < -5.720068, -1.044287, -2.980925>,
      < -5.698081, -1.031452, -2.938488>
    }
    triangle {
      < -5.656684, -1.083012, -2.978059>,
      < -5.698081, -1.031452, -2.938488>,
      < -5.633726, -1.072891, -2.939160>
    }
    triangle {
      < -6.674716, -1.846712, -2.543921>,
      < -6.713930, -1.859547, -2.511016>,
      < -6.686976, -1.859547, -2.586358>
    }
    triangle {
      < -6.934447, -0.995402, -2.521949>,
      < -6.925117, -1.015730, -2.338184>,
      < -6.809928, -0.996376, -2.297940>
    }
    triangle {
      < -6.934447, -0.995402, -2.521949>,
      < -6.809928, -0.996376, -2.297940>,
      < -6.849995, -0.979308, -2.480608>
    }
    triangle {
      < -5.676820, -1.177579, -2.983173>,
      < -5.682071, -1.120353, -3.016435>,
      < -5.646147, -1.119743, -2.978052>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.809928, -0.996376, -2.297940>,
      < -6.769863, -1.171843, -2.115272>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.769863, -1.171843, -2.115272>,
      < -6.748319, -1.231666, -2.049427>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.748319, -1.231666, -2.049427>,
      < -6.739871, -1.284465, -1.951116>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.739871, -1.284465, -1.951116>,
      < -6.746067, -1.318434, -1.846585>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.746067, -1.318434, -1.846585>,
      < -6.767396, -1.329456, -1.724040>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.767396, -1.329456, -1.724040>,
      < -6.962760, -1.324139, 0.000000>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.962760, -1.324139, 0.000000>,
      < -7.057447, -1.859547, 0.000000>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -7.057447, -1.859547, 0.000000>,
      < -6.884914, -1.859547, -1.767040>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.884914, -1.859547, -1.767040>,
      < -6.854515, -1.859547, -1.965427>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.854515, -1.859547, -1.965427>,
      < -6.824117, -1.859547, -2.163813>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.824117, -1.859547, -2.163813>,
      < -6.791463, -1.859547, -2.349217>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.791463, -1.859547, -2.349217>,
      < -6.713930, -1.859547, -2.511016>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.713930, -1.859547, -2.511016>,
      < -6.674716, -1.846712, -2.543921>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.674716, -1.846712, -2.543921>,
      < -6.584070, -1.846712, -2.601764>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.584070, -1.846712, -2.601764>,
      < -6.491687, -1.846712, -2.645658>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.491687, -1.846712, -2.645658>,
      < -6.358714, -1.846712, -2.680916>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.358714, -1.846712, -2.680916>,
      < -6.064945, -1.846712, -2.703966>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.064945, -1.846712, -2.703966>,
      < -6.002273, -1.805053, -2.739253>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.002273, -1.805053, -2.739253>,
      < -5.959691, -1.748931, -2.783729>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.959691, -1.748931, -2.783729>,
      < -5.893969, -1.645792, -2.845779>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.893969, -1.645792, -2.845779>,
      < -5.836937, -1.536736, -2.893245>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.836937, -1.536736, -2.893245>,
      < -5.790800, -1.441357, -2.910861>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.790800, -1.441357, -2.910861>,
      < -5.721012, -1.242835, -2.941581>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.721012, -1.242835, -2.941581>,
      < -5.653183, -1.164744, -2.940736>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.653183, -1.164744, -2.940736>,
      < -5.624572, -1.107859, -2.939728>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.624572, -1.107859, -2.939728>,
      < -5.633726, -1.072891, -2.939160>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.633726, -1.072891, -2.939160>,
      < -5.698081, -1.031452, -2.938488>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.698081, -1.031452, -2.938488>,
      < -5.775725, -1.007452, -2.944038>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.775725, -1.007452, -2.944038>,
      < -5.962842, -0.996574, -2.947385>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -5.962842, -0.996574, -2.947385>,
      < -6.476254, -0.982347, -2.920296>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.476254, -0.982347, -2.920296>,
      < -6.688638, -0.976656, -2.895943>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.688638, -0.976656, -2.895943>,
      < -6.756642, -0.976652, -2.871945>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.756642, -0.976652, -2.871945>,
      < -6.805195, -0.976648, -2.826151>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.805195, -0.976648, -2.826151>,
      < -6.850533, -0.979485, -2.765028>
    }
    triangle {
      < -6.849995, -0.979308, -2.480608>,
      < -6.850533, -0.979485, -2.765028>,
      < -6.890060, -0.976641, -2.663275>
    }
    triangle {
      < -7.097256, -1.200142, -2.440864>,
      < -7.092591, -1.120285, -2.570540>,
      < -7.072962, -1.169511, -2.602265>
    }
    triangle {
      < -7.097256, -1.200142, -2.440864>,
      < -7.072962, -1.169511, -2.602265>,
      < -7.086562, -1.251685, -2.454475>
    }
    triangle {
      < -6.925117, -1.015730, -2.338184>,
      < -6.934447, -0.995402, -2.521949>,
      < -6.999403, -1.015503, -2.533619>
    }
    triangle {
      < -6.925117, -1.015730, -2.338184>,
      < -6.999403, -1.015503, -2.533619>,
      < -6.995774, -1.060152, -2.360948>
    }
    triangle {
      < -6.934447, -0.995402, -2.521949>,
      < -6.849995, -0.979308, -2.480608>,
      < -6.890060, -0.976641, -2.663275>
    }
    triangle {
      < -6.934447, -0.995402, -2.521949>,
      < -6.890060, -0.976641, -2.663275>,
      < -6.943775, -0.989475, -2.705712>
    }
    triangle {
      < -7.003592, -1.010780, -2.706787>,
      < -6.999403, -1.015503, -2.533619>,
      < -6.934447, -0.995402, -2.521949>
    }
    triangle {
      < -7.003592, -1.010780, -2.706787>,
      < -6.934447, -0.995402, -2.521949>,
      < -6.943775, -0.989475, -2.705712>
    }
    triangle {
      < -7.069232, -1.171446, -2.694571>,
      < -7.072962, -1.169511, -2.602265>,
      < -7.092591, -1.120285, -2.570540>
    }
    triangle {
      < -7.069232, -1.171446, -2.694571>,
      < -7.092591, -1.120285, -2.570540>,
      < -7.088174, -1.119861, -2.700568>
    }
    triangle {
      < -7.086562, -1.251685, -2.454475>,
      < -7.089150, -1.340504, -2.363926>,
      < -7.101055, -1.325408, -2.314543>
    }
    triangle {
      < -7.086562, -1.251685, -2.454475>,
      < -7.101055, -1.325408, -2.314543>,
      < -7.097256, -1.200142, -2.440864>
    }
    triangle {
      < -6.995774, -1.060152, -2.360948>,
      < -6.990645, -1.226394, -2.190381>,
      < -6.915789, -1.194457, -2.154421>
    }
    triangle {
      < -6.995774, -1.060152, -2.360948>,
      < -6.915789, -1.194457, -2.154421>,
      < -6.925117, -1.015730, -2.338184>
    }
    triangle {
      < -6.809928, -0.996376, -2.297940>,
      < -6.925117, -1.015730, -2.338184>,
      < -6.915789, -1.194457, -2.154421>
    }
    triangle {
      < -6.809928, -0.996376, -2.297940>,
      < -6.915789, -1.194457, -2.154421>,
      < -6.807567, -1.164466, -2.123392>
    }
    triangle {
      < -6.809928, -0.996376, -2.297940>,
      < -6.807567, -1.164466, -2.123392>,
      < -6.769863, -1.171843, -2.115272>
    }
    triangle {
      < -6.497888, -1.051763, -3.041027>,
      < -5.987155, -1.057072, -3.055558>,
      < -5.994500, -1.085873, -3.065178>
    }
    triangle {
      < -6.497888, -1.051763, -3.041027>,
      < -5.994500, -1.085873, -3.065178>,
      < -6.500500, -1.083424, -3.057768>
    }
    triangle {
      < -6.718443, -1.049612, -3.020045>,
      < -6.497888, -1.051763, -3.041027>,
      < -6.500500, -1.083424, -3.057768>
    }
    triangle {
      < -6.718443, -1.049612, -3.020045>,
      < -6.500500, -1.083424, -3.057768>,
      < -6.722644, -1.082780, -3.038282>
    }
    triangle {
      < -6.824194, -1.049274, -2.989464>,
      < -6.718443, -1.049612, -3.020045>,
      < -6.722644, -1.082780, -3.038282>
    }
    triangle {
      < -6.824194, -1.049274, -2.989464>,
      < -6.722644, -1.082780, -3.038282>,
      < -6.834136, -1.082776, -3.006559>
    }
    triangle {
      < -6.906083, -1.048785, -2.932867>,
      < -6.824194, -1.049274, -2.989464>,
      < -6.834136, -1.082776, -3.006559>
    }
    triangle {
      < -6.906083, -1.048785, -2.932867>,
      < -6.834136, -1.082776, -3.006559>,
      < -6.922107, -1.082584, -2.948084>
    }
    triangle {
      < -6.979820, -1.049169, -2.860212>,
      < -6.906083, -1.048785, -2.932867>,
      < -6.922107, -1.082584, -2.948084>
    }
    triangle {
      < -6.979820, -1.049169, -2.860212>,
      < -6.922107, -1.082584, -2.948084>,
      < -7.001381, -1.082450, -2.873451>
    }
    triangle {
      < -7.052166, -1.047451, -2.705376>,
      < -6.979820, -1.049169, -2.860212>,
      < -7.001381, -1.082450, -2.873451>
    }
    triangle {
      < -7.052166, -1.047451, -2.705376>,
      < -7.001381, -1.082450, -2.873451>,
      < -7.081670, -1.081432, -2.703891>
    }
    triangle {
      < -7.052245, -1.050272, -2.547867>,
      < -7.052166, -1.047451, -2.705376>,
      < -7.081670, -1.081432, -2.703891>
    }
    triangle {
      < -7.052245, -1.050272, -2.547867>,
      < -7.081670, -1.081432, -2.703891>,
      < -7.084155, -1.082392, -2.558994>
    }
    triangle {
      < -7.052882, -1.116151, -2.390855>,
      < -7.052245, -1.050272, -2.547867>,
      < -7.084155, -1.082392, -2.558994>
    }
    triangle {
      < -7.052882, -1.116151, -2.390855>,
      < -7.084155, -1.082392, -2.558994>,
      < -7.090330, -1.166159, -2.418246>
    }
    triangle {
      < -7.052018, -1.268057, -2.235946>,
      < -7.052882, -1.116151, -2.390855>,
      < -7.090330, -1.166159, -2.418246>
    }
    triangle {
      < -7.052018, -1.268057, -2.235946>,
      < -7.090330, -1.166159, -2.418246>,
      < -7.092793, -1.305835, -2.277045>
    }
    triangle {
      < -7.040924, -1.344459, -2.136715>,
      < -7.052018, -1.268057, -2.235946>,
      < -7.092793, -1.305835, -2.277045>
    }
    triangle {
      < -7.040924, -1.344459, -2.136715>,
      < -7.092793, -1.305835, -2.277045>,
      < -7.084328, -1.386593, -2.168316>
    }
    triangle {
      < -7.032433, -1.405797, -2.015038>,
      < -7.040924, -1.344459, -2.136715>,
      < -7.084328, -1.386593, -2.168316>
    }
    triangle {
      < -7.032433, -1.405797, -2.015038>,
      < -7.084328, -1.386593, -2.168316>,
      < -7.078613, -1.452749, -2.036877>
    }
    triangle {
      < -7.043485, -1.441088, -1.897489>,
      < -7.032433, -1.405797, -2.015038>,
      < -7.078613, -1.452749, -2.036877>
    }
    triangle {
      < -7.043485, -1.441088, -1.897489>,
      < -7.078613, -1.452749, -2.036877>,
      < -7.086372, -1.490089, -1.910542>
    }
    triangle {
      < -7.060020, -1.447926, -1.759758>,
      < -7.043485, -1.441088, -1.897489>,
      < -7.086372, -1.490089, -1.910542>
    }
    triangle {
      < -7.060020, -1.447926, -1.759758>,
      < -7.086372, -1.490089, -1.910542>,
      < -7.099501, -1.495746, -1.765560>
    }
    triangle {
      < -7.233485, -1.452667, 0.000000>,
      < -7.060020, -1.447926, -1.759758>,
      < -7.099501, -1.495746, -1.765560>
    }
    triangle {
      < -7.233485, -1.452667, 0.000000>,
      < -7.099501, -1.495746, -1.765560>,
      < -7.279100, -1.500665, 0.000000>
    }
    triangle {
      < -5.987155, -1.057072, -3.055558>,
      < -5.796717, -1.080906, -3.038786>,
      < -5.994500, -1.085873, -3.065178>
    }
    triangle {
      < -6.493579, -1.016994, -3.008955>,
      < -5.980691, -1.027046, -3.030011>,
      < -5.987155, -1.057072, -3.055558>
    }
    triangle {
      < -6.493579, -1.016994, -3.008955>,
      < -5.987155, -1.057072, -3.055558>,
      < -6.497888, -1.051763, -3.041027>
    }
    triangle {
      < -6.710935, -1.012946, -2.986064>,
      < -6.493579, -1.016994, -3.008955>,
      < -6.497888, -1.051763, -3.041027>
    }
    triangle {
      < -6.710935, -1.012946, -2.986064>,
      < -6.497888, -1.051763, -3.041027>,
      < -6.718443, -1.049612, -3.020045>
    }
    triangle {
      < -6.806467, -1.012607, -2.958068>,
      < -6.710935, -1.012946, -2.986064>,
      < -6.718443, -1.049612, -3.020045>
    }
    triangle {
      < -6.806467, -1.012607, -2.958068>,
      < -6.718443, -1.049612, -3.020045>,
      < -6.824194, -1.049274, -2.989464>
    }
    triangle {
      < -6.878011, -1.012117, -2.905717>,
      < -6.806467, -1.012607, -2.958068>,
      < -6.824194, -1.049274, -2.989464>
    }
    triangle {
      < -6.878011, -1.012117, -2.905717>,
      < -6.824194, -1.049274, -2.989464>,
      < -6.906083, -1.048785, -2.932867>
    }
    triangle {
      < -6.943068, -1.013447, -2.837431>,
      < -6.878011, -1.012117, -2.905717>,
      < -6.906083, -1.048785, -2.932867>
    }
    triangle {
      < -6.943068, -1.013447, -2.837431>,
      < -6.906083, -1.048785, -2.932867>,
      < -6.979820, -1.049169, -2.860212>
    }
    triangle {
      < -7.003592, -1.010780, -2.706787>,
      < -6.943068, -1.013447, -2.837431>,
      < -6.979820, -1.049169, -2.860212>
    }
    triangle {
      < -7.003592, -1.010780, -2.706787>,
      < -6.979820, -1.049169, -2.860212>,
      < -7.052166, -1.047451, -2.705376>
    }
    triangle {
      < -6.999403, -1.015503, -2.533619>,
      < -7.003592, -1.010780, -2.706787>,
      < -7.052166, -1.047451, -2.705376>
    }
    triangle {
      < -6.999403, -1.015503, -2.533619>,
      < -7.052166, -1.047451, -2.705376>,
      < -7.052245, -1.050272, -2.547867>
    }
    triangle {
      < -6.995774, -1.060152, -2.360948>,
      < -6.999403, -1.015503, -2.533619>,
      < -7.052245, -1.050272, -2.547867>
    }
    triangle {
      < -6.995774, -1.060152, -2.360948>,
      < -7.052245, -1.050272, -2.547867>,
      < -7.052882, -1.116151, -2.390855>
    }
    triangle {
      < -6.990645, -1.226394, -2.190381>,
      < -6.995774, -1.060152, -2.360948>,
      < -7.052882, -1.116151, -2.390855>
    }
    triangle {
      < -6.990645, -1.226394, -2.190381>,
      < -7.052882, -1.116151, -2.390855>,
      < -7.052018, -1.268057, -2.235946>
    }
    triangle {
      < -6.976470, -1.298631, -2.102237>,
      < -6.990645, -1.226394, -2.190381>,
      < -7.052018, -1.268057, -2.235946>
    }
    triangle {
      < -6.976470, -1.298631, -2.102237>,
      < -7.052018, -1.268057, -2.235946>,
      < -7.040924, -1.344459, -2.136715>
    }
    triangle {
      < -6.964900, -1.355802, -1.990809>,
      < -6.976470, -1.298631, -2.102237>,
      < -7.040924, -1.344459, -2.136715>
    }
    triangle {
      < -6.964900, -1.355802, -1.990809>,
      < -7.040924, -1.344459, -2.136715>,
      < -7.032433, -1.405797, -2.015038>
    }
    triangle {
      < -6.979893, -1.388660, -1.881194>,
      < -6.964900, -1.355802, -1.990809>,
      < -7.032433, -1.405797, -2.015038>
    }
    triangle {
      < -6.979893, -1.388660, -1.881194>,
      < -7.032433, -1.405797, -2.015038>,
      < -7.043485, -1.441088, -1.897489>
    }
    triangle {
      < -7.000368, -1.396264, -1.751397>,
      < -6.979893, -1.388660, -1.881194>,
      < -7.043485, -1.441088, -1.897489>
    }
    triangle {
      < -7.000368, -1.396264, -1.751397>,
      < -7.043485, -1.441088, -1.897489>,
      < -7.060020, -1.447926, -1.759758>
    }
    triangle {
      < -7.166669, -1.402146, 0.000000>,
      < -7.000368, -1.396264, -1.751397>,
      < -7.060020, -1.447926, -1.759758>
    }
    triangle {
      < -7.166669, -1.402146, 0.000000>,
      < -7.060020, -1.447926, -1.759758>,
      < -7.233485, -1.452667, 0.000000>
    }
    triangle {
      < -5.960658, -1.230247, -3.031562>,
      < -5.742157, -1.255670, -2.984018>,
      < -5.820180, -1.284486, -2.983333>
    }
    triangle {
      < -5.960658, -1.230247, -3.031562>,
      < -5.820180, -1.284486, -2.983333>,
      < -5.945208, -1.284483, -2.987595>
    }
    triangle {
      < -6.470497, -1.231665, -3.013400>,
      < -5.960658, -1.230247, -3.031562>,
      < -5.945208, -1.284483, -2.987595>
    }
    triangle {
      < -6.470497, -1.231665, -3.013400>,
      < -5.945208, -1.284483, -2.987595>,
      < -6.453266, -1.284490, -2.965122>
    }
    triangle {
      < -6.688596, -1.232883, -2.986616>,
      < -6.470497, -1.231665, -3.013400>,
      < -6.453266, -1.284490, -2.965122>
    }
    triangle {
      < -6.688596, -1.232883, -2.986616>,
      < -6.453266, -1.284490, -2.965122>,
      < -6.666018, -1.284488, -2.935784>
    }
    triangle {
      < -6.795163, -1.233915, -2.948795>,
      < -6.688596, -1.232883, -2.986616>,
      < -6.666018, -1.284488, -2.935784>
    }
    triangle {
      < -6.795163, -1.233915, -2.948795>,
      < -6.666018, -1.284488, -2.935784>,
      < -6.764087, -1.284490, -2.897935>
    }
    triangle {
      < -6.877378, -1.234364, -2.887440>,
      < -6.795163, -1.233915, -2.948795>,
      < -6.764087, -1.284490, -2.897935>
    }
    triangle {
      < -6.877378, -1.234364, -2.887440>,
      < -6.764087, -1.284490, -2.897935>,
      < -6.838706, -1.284492, -2.838292>
    }
    triangle {
      < -6.960782, -1.233981, -2.810840>,
      < -6.877378, -1.234364, -2.887440>,
      < -6.838706, -1.284492, -2.838292>
    }
    triangle {
      < -6.960782, -1.233981, -2.810840>,
      < -6.838706, -1.284492, -2.838292>,
      < -6.919416, -1.284488, -2.764061>
    }
    triangle {
      < -7.033287, -1.233111, -2.683546>,
      < -6.960782, -1.233981, -2.810840>,
      < -6.919416, -1.284488, -2.764061>
    }
    triangle {
      < -7.033287, -1.233111, -2.683546>,
      < -6.919416, -1.284488, -2.764061>,
      < -6.981668, -1.284483, -2.668404>
    }
    triangle {
      < -7.035861, -1.231102, -2.636836>,
      < -7.033287, -1.233111, -2.683546>,
      < -6.981668, -1.284483, -2.668404>
    }
    triangle {
      < -7.059394, -1.313596, -2.475299>,
      < -7.035861, -1.231102, -2.636836>,
      < -6.981668, -1.284483, -2.668404>
    }
    triangle {
      < -7.059394, -1.313596, -2.475299>,
      < -6.981668, -1.284483, -2.668404>,
      < -7.014936, -1.369458, -2.490375>
    }
    triangle {
      < -7.060826, -1.357175, -2.430345>,
      < -7.059394, -1.313596, -2.475299>,
      < -7.014936, -1.369458, -2.490375>
    }
    triangle {
      < -7.066261, -1.384395, -2.403169>,
      < -7.060826, -1.357175, -2.430345>,
      < -7.014936, -1.369458, -2.490375>
    }
    triangle {
      < -7.066261, -1.384395, -2.403169>,
      < -7.014936, -1.369458, -2.490375>,
      < -7.022886, -1.409456, -2.450853>
    }
    triangle {
      < -7.051721, -1.508370, -2.275134>,
      < -7.066261, -1.384395, -2.403169>,
      < -7.022886, -1.409456, -2.450853>
    }
    triangle {
      < -7.051721, -1.508370, -2.275134>,
      < -7.022886, -1.409456, -2.450853>,
      < -7.005176, -1.550954, -2.317360>
    }
    triangle {
      < -7.039617, -1.594165, -2.117850>,
      < -7.051721, -1.508370, -2.275134>,
      < -7.005176, -1.550954, -2.317360>
    }
    triangle {
      < -7.039617, -1.594165, -2.117850>,
      < -7.005176, -1.550954, -2.317360>,
      < -6.989864, -1.644451, -2.150267>
    }
    triangle {
      < -7.040084, -1.643732, -1.950409>,
      < -7.039617, -1.594165, -2.117850>,
      < -6.989864, -1.644451, -2.150267>
    }
    triangle {
      < -7.040084, -1.643732, -1.950409>,
      < -6.989864, -1.644451, -2.150267>,
      < -6.987468, -1.698019, -1.965227>
    }
    triangle {
      < -7.045925, -1.654414, -1.765231>,
      < -7.040084, -1.643732, -1.950409>,
      < -6.987468, -1.698019, -1.965227>
    }
    triangle {
      < -7.045925, -1.654414, -1.765231>,
      < -6.987468, -1.698019, -1.965227>,
      < -6.990606, -1.709441, -1.762173>
    }
    triangle {
      < -7.216501, -1.655390, 0.000000>,
      < -7.045925, -1.654414, -1.765231>,
      < -6.990606, -1.709441, -1.762173>
    }
    triangle {
      < -7.216501, -1.655390, 0.000000>,
      < -6.990606, -1.709441, -1.762173>,
      < -7.156614, -1.707875, 0.000000>
    }
    triangle {
      < -5.776556, -1.177829, -3.017266>,
      < -5.742157, -1.255670, -2.984018>,
      < -5.960658, -1.230247, -3.031562>
    }
    triangle {
      < -5.776556, -1.177829, -3.017266>,
      < -5.960658, -1.230247, -3.031562>,
      < -5.977087, -1.168581, -3.057851>
    }
    triangle {
      < -6.486555, -1.169997, -3.044676>,
      < -5.977087, -1.168581, -3.057851>,
      < -5.960658, -1.230247, -3.031562>
    }
    triangle {
      < -6.486555, -1.169997, -3.044676>,
      < -5.960658, -1.230247, -3.031562>,
      < -6.470497, -1.231665, -3.013400>
    }
    triangle {
      < -6.707731, -1.171216, -3.021462>,
      < -6.486555, -1.169997, -3.044676>,
      < -6.470497, -1.231665, -3.013400>
    }
    triangle {
      < -6.707731, -1.171216, -3.021462>,
      < -6.470497, -1.231665, -3.013400>,
      < -6.688596, -1.232883, -2.986616>
    }
    triangle {
      < -6.819161, -1.172247, -2.985674>,
      < -6.707731, -1.171216, -3.021462>,
      < -6.688596, -1.232883, -2.986616>
    }
    triangle {
      < -6.819161, -1.172247, -2.985674>,
      < -6.688596, -1.232883, -2.986616>,
      < -6.795163, -1.233915, -2.948795>
    }
    triangle {
      < -6.906362, -1.172695, -2.924689>,
      < -6.819161, -1.172247, -2.985674>,
      < -6.795163, -1.233915, -2.948795>
    }
    triangle {
      < -6.906362, -1.172695, -2.924689>,
      < -6.795163, -1.233915, -2.948795>,
      < -6.877378, -1.234364, -2.887440>
    }
    triangle {
      < -6.989767, -1.172314, -2.848089>,
      < -6.906362, -1.172695, -2.924689>,
      < -6.877378, -1.234364, -2.887440>
    }
    triangle {
      < -6.989767, -1.172314, -2.848089>,
      < -6.877378, -1.234364, -2.887440>,
      < -6.960782, -1.233981, -2.810840>
    }
    triangle {
      < -7.069232, -1.171446, -2.694571>,
      < -6.989767, -1.172314, -2.848089>,
      < -6.960782, -1.233981, -2.810840>
    }
    triangle {
      < -7.069232, -1.171446, -2.694571>,
      < -6.960782, -1.233981, -2.810840>,
      < -7.033287, -1.233111, -2.683546>
    }
    triangle {
      < -7.072962, -1.169511, -2.602265>,
      < -7.069232, -1.171446, -2.694571>,
      < -7.033287, -1.233111, -2.683546>
    }
    triangle {
      < -7.072962, -1.169511, -2.602265>,
      < -7.033287, -1.233111, -2.683546>,
      < -7.035861, -1.231102, -2.636836>
    }
    triangle {
      < -7.086562, -1.251685, -2.454475>,
      < -7.072962, -1.169511, -2.602265>,
      < -7.035861, -1.231102, -2.636836>
    }
    triangle {
      < -7.086562, -1.251685, -2.454475>,
      < -7.035861, -1.231102, -2.636836>,
      < -7.059394, -1.313596, -2.475299>
    }
    triangle {
      < -7.089150, -1.340504, -2.363926>,
      < -7.086562, -1.251685, -2.454475>,
      < -7.059394, -1.313596, -2.475299>
    }
    triangle {
      < -7.089150, -1.340504, -2.363926>,
      < -7.059394, -1.313596, -2.475299>,
      < -7.060826, -1.357175, -2.430345>
    }
    triangle {
      < -7.091934, -1.354392, -2.349924>,
      < -7.089150, -1.340504, -2.363926>,
      < -7.060826, -1.357175, -2.430345>
    }
    triangle {
      < -7.091934, -1.354392, -2.349924>,
      < -7.060826, -1.357175, -2.430345>,
      < -7.066261, -1.384395, -2.403169>
    }
    triangle {
      < -7.080834, -1.458599, -2.229285>,
      < -7.091934, -1.354392, -2.349924>,
      < -7.066261, -1.384395, -2.403169>
    }
    triangle {
      < -7.080834, -1.458599, -2.229285>,
      < -7.066261, -1.384395, -2.403169>,
      < -7.051721, -1.508370, -2.275134>
    }
    triangle {
      < -7.072170, -1.535828, -2.082598>,
      < -7.080834, -1.458599, -2.229285>,
      < -7.051721, -1.508370, -2.275134>
    }
    triangle {
      < -7.072170, -1.535828, -2.082598>,
      < -7.051721, -1.508370, -2.275134>,
      < -7.039617, -1.594165, -2.117850>
    }
    triangle {
      < -7.075849, -1.580462, -1.933608>,
      < -7.072170, -1.535828, -2.082598>,
      < -7.039617, -1.594165, -2.117850>
    }
    triangle {
      < -7.075849, -1.580462, -1.933608>,
      < -7.039617, -1.594165, -2.117850>,
      < -7.040084, -1.643732, -1.950409>
    }
    triangle {
      < -7.084901, -1.589411, -1.766879>,
      < -7.075849, -1.580462, -1.933608>,
      < -7.040084, -1.643732, -1.950409>
    }
    triangle {
      < -7.084901, -1.589411, -1.766879>,
      < -7.040084, -1.643732, -1.950409>,
      < -7.045925, -1.654414, -1.765231>
    }
    triangle {
      < -7.260464, -1.592207, 0.000000>,
      < -7.084901, -1.589411, -1.766879>,
      < -7.045925, -1.654414, -1.765231>
    }
    triangle {
      < -7.260464, -1.592207, 0.000000>,
      < -7.045925, -1.654414, -1.765231>,
      < -7.216501, -1.655390, 0.000000>
    }
    triangle {
      < -5.791178, -1.031257, -3.006389>,
      < -5.794860, -1.020287, -2.986475>,
      < -5.720068, -1.044287, -2.980925>
    }
    triangle {
      < -5.796717, -1.080906, -3.038786>,
      < -5.791178, -1.031257, -3.006389>,
      < -5.720068, -1.044287, -2.980925>
    }
    triangle {
      < -5.796717, -1.080906, -3.038786>,
      < -5.720068, -1.044287, -2.980925>,
      < -5.685392, -1.083939, -3.010567>
    }
    triangle {
      < -7.092793, -1.305835, -2.277045>,
      < -7.101055, -1.325408, -2.314543>,
      < -7.097250, -1.331093, -2.310717>
    }
    triangle {
      < -5.624572, -1.107859, -2.939728>,
      < -5.646147, -1.119743, -2.978052>,
      < -5.656684, -1.083012, -2.978059>
    }
    triangle {
      < -5.624572, -1.107859, -2.939728>,
      < -5.656684, -1.083012, -2.978059>,
      < -5.633726, -1.072891, -2.939160>
    }
    triangle {
      < -5.646147, -1.119743, -2.978052>,
      < -5.682071, -1.120353, -3.016435>,
      < -5.685392, -1.083939, -3.010567>
    }
    triangle {
      < -5.646147, -1.119743, -2.978052>,
      < -5.685392, -1.083939, -3.010567>,
      < -5.656684, -1.083012, -2.978059>
    }
    triangle {
      < -5.796717, -1.080906, -3.038786>,
      < -5.685392, -1.083939, -3.010567>,
      < -5.682071, -1.120353, -3.016435>
    }
    triangle {
      < -5.796717, -1.080906, -3.038786>,
      < -5.682071, -1.120353, -3.016435>,
      < -5.795750, -1.119792, -3.044409>
    }
    triangle {
      < -5.994500, -1.085873, -3.065178>,
      < -5.796717, -1.080906, -3.038786>,
      < -5.795750, -1.119792, -3.044409>
    }
    triangle {
      < -5.994500, -1.085873, -3.065178>,
      < -5.795750, -1.119792, -3.044409>,
      < -5.994472, -1.120564, -3.065847>
    }
    triangle {
      < -6.500500, -1.083424, -3.057768>,
      < -5.994500, -1.085873, -3.065178>,
      < -5.994472, -1.120564, -3.065847>
    }
    triangle {
      < -6.500500, -1.083424, -3.057768>,
      < -5.994472, -1.120564, -3.065847>,
      < -6.497226, -1.120446, -3.059467>
    }
    triangle {
      < -6.722644, -1.082780, -3.038282>,
      < -6.500500, -1.083424, -3.057768>,
      < -6.497226, -1.120446, -3.059467>
    }
    triangle {
      < -6.722644, -1.082780, -3.038282>,
      < -6.497226, -1.120446, -3.059467>,
      < -6.719749, -1.120220, -3.039568>
    }
    triangle {
      < -6.834136, -1.082776, -3.006559>,
      < -6.722644, -1.082780, -3.038282>,
      < -6.719749, -1.120220, -3.039568>
    }
    triangle {
      < -6.834136, -1.082776, -3.006559>,
      < -6.719749, -1.120220, -3.039568>,
      < -6.833333, -1.119999, -3.006480>
    }
    triangle {
      < -6.922107, -1.082584, -2.948084>,
      < -6.834136, -1.082776, -3.006559>,
      < -6.833333, -1.119999, -3.006480>
    }
    triangle {
      < -6.922107, -1.082584, -2.948084>,
      < -6.833333, -1.119999, -3.006480>,
      < -6.923314, -1.119656, -2.946822>
    }
    triangle {
      < -7.001381, -1.082450, -2.873451>,
      < -6.922107, -1.082584, -2.948084>,
      < -6.923314, -1.119656, -2.946822>
    }
    triangle {
      < -7.001381, -1.082450, -2.873451>,
      < -6.923314, -1.119656, -2.946822>,
      < -7.005646, -1.119330, -2.870995>
    }
    triangle {
      < -7.081670, -1.081432, -2.703891>,
      < -7.001381, -1.082450, -2.873451>,
      < -7.005646, -1.119330, -2.870995>
    }
    triangle {
      < -7.081670, -1.081432, -2.703891>,
      < -7.005646, -1.119330, -2.870995>,
      < -7.088174, -1.119861, -2.700568>
    }
    triangle {
      < -7.084155, -1.082392, -2.558994>,
      < -7.081670, -1.081432, -2.703891>,
      < -7.088174, -1.119861, -2.700568>
    }
    triangle {
      < -7.084155, -1.082392, -2.558994>,
      < -7.088174, -1.119861, -2.700568>,
      < -7.092591, -1.120285, -2.570540>
    }
    triangle {
      < -7.090330, -1.166159, -2.418246>,
      < -7.084155, -1.082392, -2.558994>,
      < -7.092591, -1.120285, -2.570540>
    }
    triangle {
      < -7.090330, -1.166159, -2.418246>,
      < -7.092591, -1.120285, -2.570540>,
      < -7.097256, -1.200142, -2.440864>
    }
    triangle {
      < -7.092793, -1.305835, -2.277045>,
      < -7.090330, -1.166159, -2.418246>,
      < -7.097256, -1.200142, -2.440864>
    }
    triangle {
      < -7.092793, -1.305835, -2.277045>,
      < -7.097256, -1.200142, -2.440864>,
      < -7.101055, -1.325408, -2.314543>
    }
    triangle {
      < -7.084328, -1.386593, -2.168316>,
      < -7.092793, -1.305835, -2.277045>,
      < -7.097250, -1.331093, -2.310717>
    }
    triangle {
      < -7.084328, -1.386593, -2.168316>,
      < -7.097250, -1.331093, -2.310717>,
      < -7.093822, -1.417261, -2.193316>
    }
    triangle {
      < -7.078613, -1.452749, -2.036877>,
      < -7.084328, -1.386593, -2.168316>,
      < -7.093822, -1.417261, -2.193316>
    }
    triangle {
      < -7.078613, -1.452749, -2.036877>,
      < -7.093822, -1.417261, -2.193316>,
      < -7.087876, -1.487158, -2.054882>
    }
    triangle {
      < -7.087876, -1.487158, -2.054882>,
      < -7.094053, -1.527854, -1.920331>,
      < -7.086372, -1.490089, -1.910542>
    }
    triangle {
      < -7.087876, -1.487158, -2.054882>,
      < -7.086372, -1.490089, -1.910542>,
      < -7.078613, -1.452749, -2.036877>
    }
    triangle {
      < -7.094053, -1.527854, -1.920331>,
      < -7.105881, -1.534636, -1.767466>,
      < -7.099501, -1.495746, -1.765560>
    }
    triangle {
      < -7.094053, -1.527854, -1.920331>,
      < -7.099501, -1.495746, -1.765560>,
      < -7.086372, -1.490089, -1.910542>
    }
    triangle {
      < -7.105881, -1.534636, -1.767466>,
      < -7.285424, -1.538095, 0.000000>,
      < -7.279100, -1.500665, 0.000000>
    }
    triangle {
      < -7.105881, -1.534636, -1.767466>,
      < -7.279100, -1.500665, 0.000000>,
      < -7.099501, -1.495746, -1.765560>
    }
    triangle {
      < -6.972465, -1.791266, -1.766075>,
      < -7.142025, -1.789917, 0.000000>,
      < -7.156614, -1.707875, 0.000000>
    }
    triangle {
      < -6.972465, -1.791266, -1.766075>,
      < -7.156614, -1.707875, 0.000000>,
      < -6.990606, -1.709441, -1.762173>
    }
    triangle {
      < -6.954820, -1.787191, -1.967162>,
      < -6.972465, -1.791266, -1.766075>,
      < -6.990606, -1.709441, -1.762173>
    }
    triangle {
      < -6.954820, -1.787191, -1.967162>,
      < -6.990606, -1.709441, -1.762173>,
      < -6.987468, -1.698019, -1.965227>
    }
    triangle {
      < -6.940769, -1.760330, -2.159502>,
      < -6.954820, -1.787191, -1.967162>,
      < -6.987468, -1.698019, -1.965227>
    }
    triangle {
      < -6.940769, -1.760330, -2.159502>,
      < -6.987468, -1.698019, -1.965227>,
      < -6.989864, -1.644451, -2.150267>
    }
    triangle {
      < -6.894863, -1.767690, -2.380389>,
      < -6.940769, -1.760330, -2.159502>,
      < -6.989864, -1.644451, -2.150267>
    }
    triangle {
      < -6.894863, -1.767690, -2.380389>,
      < -6.989864, -1.644451, -2.150267>,
      < -6.931129, -1.659463, -2.403928>
    }
    triangle {
      < -6.823873, -1.769634, -2.576504>,
      < -6.894863, -1.767690, -2.380389>,
      < -6.931129, -1.659463, -2.403928>
    }
    triangle {
      < -6.823873, -1.769634, -2.576504>,
      < -6.931129, -1.659463, -2.403928>,
      < -6.872228, -1.658624, -2.629164>
    }
    triangle {
      < -6.756017, -1.770061, -2.657989>,
      < -6.823873, -1.769634, -2.576504>,
      < -6.872228, -1.658624, -2.629164>
    }
    triangle {
      < -6.756017, -1.770061, -2.657989>,
      < -6.872228, -1.658624, -2.629164>,
      < -6.808095, -1.658623, -2.710665>
    }
    triangle {
      < -6.661929, -1.769979, -2.720089>,
      < -6.756017, -1.770061, -2.657989>,
      < -6.808095, -1.658623, -2.710665>
    }
    triangle {
      < -6.661929, -1.769979, -2.720089>,
      < -6.808095, -1.658623, -2.710665>,
      < -6.714914, -1.658623, -2.773726>
    }
    triangle {
      < -6.569460, -1.769633, -2.765059>,
      < -6.661929, -1.769979, -2.720089>,
      < -6.714914, -1.658623, -2.773726>
    }
    triangle {
      < -6.569460, -1.769633, -2.765059>,
      < -6.714914, -1.658623, -2.773726>,
      < -6.626447, -1.658622, -2.817301>
    }
    triangle {
      < -6.381032, -1.768794, -2.807622>,
      < -6.569460, -1.769633, -2.765059>,
      < -6.626447, -1.658622, -2.817301>
    }
    triangle {
      < -6.381032, -1.768794, -2.807622>,
      < -6.626447, -1.658622, -2.817301>,
      < -6.387282, -1.658624, -2.864736>
    }
    triangle {
      < -5.973347, -1.763105, -2.830594>,
      < -6.381032, -1.768794, -2.807622>,
      < -6.387282, -1.658624, -2.864736>
    }
    triangle {
      < -5.973347, -1.763105, -2.830594>,
      < -6.387282, -1.658624, -2.864736>,
      < -5.908761, -1.658627, -2.888216>
    }
    triangle {
      < -6.830558, -1.467492, -2.783210>,
      < -6.758198, -1.464489, -2.842342>,
      < -6.808095, -1.658623, -2.710665>
    }
    triangle {
      < -6.904433, -1.463284, -2.706286>,
      < -6.830558, -1.467492, -2.783210>,
      < -6.808095, -1.658623, -2.710665>
    }
    triangle {
      < -6.904433, -1.463284, -2.706286>,
      < -6.808095, -1.658623, -2.710665>,
      < -6.872228, -1.658624, -2.629164>
    }
    triangle {
      < -6.939265, -1.460639, -2.654139>,
      < -6.904433, -1.463284, -2.706286>,
      < -6.872228, -1.658624, -2.629164>
    }
    triangle {
      < -7.005966, -1.416750, -2.478881>,
      < -6.939265, -1.460639, -2.654139>,
      < -6.872228, -1.658624, -2.629164>
    }
    triangle {
      < -7.005966, -1.416750, -2.478881>,
      < -6.872228, -1.658624, -2.629164>,
      < -6.931129, -1.659463, -2.403928>
    }
    triangle {
      < -7.022886, -1.409456, -2.450853>,
      < -7.005966, -1.416750, -2.478881>,
      < -6.931129, -1.659463, -2.403928>
    }
    triangle {
      < -5.959691, -1.748931, -2.783729>,
      < -5.973347, -1.763105, -2.830594>,
      < -5.908761, -1.658627, -2.888216>
    }
    triangle {
      < -5.959691, -1.748931, -2.783729>,
      < -5.908761, -1.658627, -2.888216>,
      < -5.893969, -1.645792, -2.845779>
    }
    triangle {
      < -6.015004, -1.819897, -2.788333>,
      < -6.370975, -1.859520, -2.723353>,
      < -6.381032, -1.768794, -2.807622>
    }
    triangle {
      < -6.015004, -1.819897, -2.788333>,
      < -6.381032, -1.768794, -2.807622>,
      < -5.973347, -1.763105, -2.830594>
    }
    triangle {
      < -6.002273, -1.805053, -2.739253>,
      < -6.015004, -1.819897, -2.788333>,
      < -5.973347, -1.763105, -2.830594>
    }
    triangle {
      < -6.002273, -1.805053, -2.739253>,
      < -5.973347, -1.763105, -2.830594>,
      < -5.959691, -1.748931, -2.783729>
    }
    triangle {
      < -5.796717, -1.080906, -3.038786>,
      < -5.987155, -1.057072, -3.055558>,
      < -5.980691, -1.027046, -3.030011>
    }
    triangle {
      < -5.796717, -1.080906, -3.038786>,
      < -5.980691, -1.027046, -3.030011>,
      < -5.791178, -1.031257, -3.006389>
    }
    triangle {
      < -5.776556, -1.177829, -3.017266>,
      < -5.795750, -1.119792, -3.044409>,
      < -5.682071, -1.120353, -3.016435>
    }
    triangle {
      < -5.776556, -1.177829, -3.017266>,
      < -5.682071, -1.120353, -3.016435>,
      < -5.676820, -1.177579, -2.983173>
    }
    triangle {
      < -5.742157, -1.255670, -2.984018>,
      < -5.776556, -1.177829, -3.017266>,
      < -5.676820, -1.177579, -2.983173>
    }
    triangle {
      < -1.362498, 1.685040, -1.934339>,
      < -1.326746, 1.641951, -2.066452>,
      < -1.228930, 1.658054, -2.065620>
    }
    triangle {
      < -1.362498, 1.685040, -1.934339>,
      < -1.228930, 1.658054, -2.065620>,
      < -1.278242, 1.700844, -1.934251>
    }
    triangle {
      < 2.385818, 0.275118, -2.594347>,
      < 2.393729, 0.259716, -2.691078>,
      < 1.780270, 0.339770, -2.680530>
    }
    triangle {
      < 2.385818, 0.275118, -2.594347>,
      < 1.780270, 0.339770, -2.680530>,
      < 1.773786, 0.360172, -2.588591>
    }
    triangle {
      < -1.148572, 0.470027, -2.602251>,
      < -1.186268, 0.540032, -2.545651>,
      < -1.146178, 0.546644, -2.545252>
    }
    triangle {
      < 9.222689, 0.314422, -2.613701>,
      < 9.180755, 0.280451, -2.586335>,
      < 9.182425, 0.260078, -2.585223>
    }
    triangle {
      < 9.222689, 0.314422, -2.613701>,
      < 9.182425, 0.260078, -2.585223>,
      < 9.228248, 0.270685, -2.612574>
    }
    triangle {
      < -1.203056, 1.340038, -2.383760>,
      < -1.165747, 1.355034, -2.403962>,
      < -1.146178, 0.546644, -2.545252>
    }
    triangle {
      < -1.203056, 1.340038, -2.383760>,
      < -1.146178, 0.546644, -2.545252>,
      < -1.186268, 0.540032, -2.545651>
    }
    triangle {
      < -0.378037, 0.453098, -2.588279>,
      < -0.370346, 0.444959, -2.605526>,
      < -0.950543, 0.463118, -2.608058>
    }
    triangle {
      < -0.378037, 0.453098, -2.588279>,
      < -0.950543, 0.463118, -2.608058>,
      < -0.930255, 0.470592, -2.588926>
    }
    triangle {
      < -0.378037, 0.453098, -2.588279>,
      < -0.930255, 0.470592, -2.588926>,
      < -0.900545, 0.471350, -2.584866>
    }
    triangle {
      < -1.861263, 0.540159, -2.372707>,
      < -1.663497, 0.535625, -2.475946>,
      < -1.738342, 0.485082, -2.495975>
    }
    triangle {
      < -1.861263, 0.540159, -2.372707>,
      < -1.738342, 0.485082, -2.495975>,
      < -1.937317, 0.490102, -2.388227>
    }
    triangle {
      < 3.013547, 0.399663, -2.652796>,
      < 3.009002, 0.415065, -2.549848>,
      < 3.625835, 0.430011, -2.554180>
    }
    triangle {
      < 3.013547, 0.399663, -2.652796>,
      < 3.625835, 0.430011, -2.554180>,
      < 3.618461, 0.419610, -2.634592>
    }
    triangle {
      < 6.016443, 0.397662, -2.695796>,
      < 6.016861, 0.389399, -2.722277>,
      < 5.193110, 0.404471, -2.716558>
    }
    triangle {
      < 6.016443, 0.397662, -2.695796>,
      < 5.193110, 0.404471, -2.716558>,
      < 5.194430, 0.418646, -2.698007>
    }
    triangle {
      < 4.980284, 0.424102, -2.646861>,
      < 4.972139, 0.422715, -2.646387>,
      < 4.968434, 0.412051, -2.634367>
    }
    triangle {
      < 8.832082, -0.613710, -2.541341>,
      < 9.228248, 0.270685, -2.612574>,
      < 9.182425, 0.260078, -2.585223>
    }
    triangle {
      < 8.832082, -0.613710, -2.541341>,
      < 9.182425, 0.260078, -2.585223>,
      < 8.795041, -0.613710, -2.488710>
    }
    triangle {
      < 8.842156, -0.613710, -2.604175>,
      < 8.838814, -0.613710, -2.671821>,
      < 8.859509, -0.613710, -2.657776>
    }
    triangle {
      < 8.842156, -0.613710, -2.604175>,
      < 8.859509, -0.613710, -2.657776>,
      < 8.860677, -0.613710, -2.620058>
    }
    triangle {
      < 8.879555, -0.281976, -2.769261>,
      < 8.784227, -0.613710, -2.779588>,
      < 8.735338, -0.613710, -2.826938>
    }
    triangle {
      < 9.179888, 0.277209, -2.695884>,
      < 9.181384, 0.256832, -2.696940>,
      < 9.140353, 0.244126, -2.728450>
    }
    triangle {
      < 6.015857, 0.447026, -2.646350>,
      < 5.197360, 0.457936, -2.650850>,
      < 5.196445, 0.435444, -2.645413>
    }
    triangle {
      < 6.015857, 0.447026, -2.646350>,
      < 5.196445, 0.435444, -2.645413>,
      < 6.013980, 0.420398, -2.638773>
    }
    triangle {
      < 4.937755, 0.418982, -2.677343>,
      < 4.965728, 0.419402, -2.685982>,
      < 4.966898, 0.413589, -2.698662>
    }
    triangle {
      < 4.975909, 0.453292, -2.679017>,
      < 4.977233, 0.452511, -2.650693>,
      < 5.003514, 0.457348, -2.652287>
    }
    triangle {
      < 4.975909, 0.453292, -2.679017>,
      < 5.003514, 0.457348, -2.652287>,
      < 5.002436, 0.458145, -2.680569>
    }
    triangle {
      < 6.015857, 0.447026, -2.646350>,
      < 6.018072, 0.447388, -2.673555>,
      < 5.197023, 0.458783, -2.679006>
    }
    triangle {
      < 6.015857, 0.447026, -2.646350>,
      < 5.197023, 0.458783, -2.679006>,
      < 5.197360, 0.457936, -2.650850>
    }
    triangle {
      < 9.268064, 0.349557, -2.657365>,
      < 9.268329, 0.350512, -2.632469>,
      < 9.279998, 0.280421, -2.632423>
    }
    triangle {
      < 9.268064, 0.349557, -2.657365>,
      < 9.279998, 0.280421, -2.632423>,
      < 9.279105, 0.279658, -2.657954>
    }
    triangle {
      < 9.279998, 0.280421, -2.632423>,
      < 8.860677, -0.613710, -2.620058>,
      < 8.859509, -0.613710, -2.657776>
    }
    triangle {
      < 9.279998, 0.280421, -2.632423>,
      < 8.859509, -0.613710, -2.657776>,
      < 9.279105, 0.279658, -2.657954>
    }
    triangle {
      < 9.138460, 0.315434, -2.687874>,
      < 9.179888, 0.277209, -2.695884>,
      < 9.140353, 0.244126, -2.728450>
    }
    triangle {
      < 9.138460, 0.315434, -2.687874>,
      < 9.140353, 0.244126, -2.728450>,
      < 9.095436, 0.283447, -2.717090>
    }
    triangle {
      < 9.268329, 0.350512, -2.632469>,
      < 9.268064, 0.349557, -2.657365>,
      < 9.227866, 0.390941, -2.655616>
    }
    triangle {
      < 9.268329, 0.350512, -2.632469>,
      < 9.227866, 0.390941, -2.655616>,
      < 9.227504, 0.392088, -2.631354>
    }
    triangle {
      < 9.116157, 0.318534, -2.687459>,
      < 9.138460, 0.315434, -2.687874>,
      < 9.095436, 0.283447, -2.717090>
    }
    triangle {
      < 9.227504, 0.392088, -2.631354>,
      < 9.227866, 0.390941, -2.655616>,
      < 9.158513, 0.403807, -2.652705>
    }
    triangle {
      < 9.227504, 0.392088, -2.631354>,
      < 9.158513, 0.403807, -2.652705>,
      < 9.157522, 0.405147, -2.629079>
    }
    triangle {
      < 9.133686, 0.322956, -2.591057>,
      < 9.179674, 0.355510, -2.615465>,
      < 9.134267, 0.362971, -2.613432>
    }
    triangle {
      < 9.133686, 0.322956, -2.591057>,
      < 9.134267, 0.362971, -2.613432>,
      < 9.111607, 0.326064, -2.589782>
    }
    triangle {
      < 9.180755, 0.280451, -2.586335>,
      < 9.222689, 0.314422, -2.613701>,
      < 9.179674, 0.355510, -2.615465>
    }
    triangle {
      < 9.180755, 0.280451, -2.586335>,
      < 9.179674, 0.355510, -2.615465>,
      < 9.133686, 0.322956, -2.591057>
    }
    triangle {
      < 5.195446, 0.416846, -2.633922>,
      < 4.980284, 0.424102, -2.646861>,
      < 4.968434, 0.412051, -2.634367>
    }
    triangle {
      < 5.195446, 0.416846, -2.633922>,
      < 4.968434, 0.412051, -2.634367>,
      < 5.194364, 0.402142, -2.616375>
    }
    triangle {
      < 5.002436, 0.458145, -2.680569>,
      < 5.003514, 0.457348, -2.652287>,
      < 5.197360, 0.457936, -2.650850>
    }
    triangle {
      < 5.002436, 0.458145, -2.680569>,
      < 5.197360, 0.457936, -2.650850>,
      < 5.197023, 0.458783, -2.679006>
    }
    triangle {
      < 4.979320, 0.424974, -2.686347>,
      < 5.194430, 0.418646, -2.698007>,
      < 5.193110, 0.404471, -2.716558>
    }
    triangle {
      < 4.979320, 0.424974, -2.686347>,
      < 5.193110, 0.404471, -2.716558>,
      < 4.966898, 0.413589, -2.698662>
    }
    triangle {
      < 4.955920, 0.439473, -2.649575>,
      < 4.954349, 0.440237, -2.677941>,
      < 4.937755, 0.418982, -2.677343>
    }
    triangle {
      < 4.955920, 0.439473, -2.649575>,
      < 4.937755, 0.418982, -2.677343>,
      < 4.939573, 0.418233, -2.648936>
    }
    triangle {
      < 4.954349, 0.440237, -2.677941>,
      < 4.955920, 0.439473, -2.649575>,
      < 4.977233, 0.452511, -2.650693>
    }
    triangle {
      < 4.954349, 0.440237, -2.677941>,
      < 4.977233, 0.452511, -2.650693>,
      < 4.975909, 0.453292, -2.679017>
    }
    triangle {
      < 4.965728, 0.419402, -2.685982>,
      < 4.971589, 0.423416, -2.686000>,
      < 4.966898, 0.413589, -2.698662>
    }
    triangle {
      < 4.971589, 0.423416, -2.686000>,
      < 4.979320, 0.424974, -2.686347>,
      < 4.966898, 0.413589, -2.698662>
    }
    triangle {
      < 4.972139, 0.422715, -2.646387>,
      < 4.966338, 0.418596, -2.645824>,
      < 4.968434, 0.412051, -2.634367>
    }
    triangle {
      < 4.966338, 0.418596, -2.645824>,
      < 4.939573, 0.418233, -2.648936>,
      < 4.968434, 0.412051, -2.634367>
    }
    triangle {
      < 9.138460, 0.315434, -2.687874>,
      < 9.116157, 0.318534, -2.687459>,
      < 9.137182, 0.358654, -2.665998>
    }
    triangle {
      < 9.138460, 0.315434, -2.687874>,
      < 9.137182, 0.358654, -2.665998>,
      < 9.182603, 0.351266, -2.667382>
    }
    triangle {
      < 9.179888, 0.277209, -2.695884>,
      < 9.138460, 0.315434, -2.687874>,
      < 9.182603, 0.351266, -2.667382>
    }
    triangle {
      < 9.179888, 0.277209, -2.695884>,
      < 9.182603, 0.351266, -2.667382>,
      < 9.222457, 0.312353, -2.672189>
    }
    triangle {
      < 9.181384, 0.256832, -2.696940>,
      < 9.179888, 0.277209, -2.695884>,
      < 9.222457, 0.312353, -2.672189>
    }
    triangle {
      < 9.181384, 0.256832, -2.696940>,
      < 9.222457, 0.312353, -2.672189>,
      < 9.227635, 0.268676, -2.673442>
    }
    triangle {
      < 8.784227, -0.613710, -2.779588>,
      < 9.181384, 0.256832, -2.696940>,
      < 9.227635, 0.268676, -2.673442>
    }
    triangle {
      < 8.784227, -0.613710, -2.779588>,
      < 9.227635, 0.268676, -2.673442>,
      < 8.825618, -0.613710, -2.723200>
    }
    triangle {
      < 9.133686, 0.322956, -2.591057>,
      < 9.111607, 0.326064, -2.589782>,
      < 9.089541, 0.294427, -2.558130>
    }
    triangle {
      < 9.180755, 0.280451, -2.586335>,
      < 9.133686, 0.322956, -2.591057>,
      < 9.089541, 0.294427, -2.558130>
    }
    triangle {
      < 9.180755, 0.280451, -2.586335>,
      < 9.089541, 0.294427, -2.558130>,
      < 9.142529, 0.248598, -2.550370>
    }
    triangle {
      < 9.182425, 0.260078, -2.585223>,
      < 9.180755, 0.280451, -2.586335>,
      < 9.142529, 0.248598, -2.550370>
    }
    triangle {
      < 8.795041, -0.613710, -2.488710>,
      < 9.182425, 0.260078, -2.585223>,
      < 9.142529, 0.248598, -2.550370>
    }
    triangle {
      < 8.795041, -0.613710, -2.488710>,
      < 9.142529, 0.248598, -2.550370>,
      < 8.749555, -0.613710, -2.466970>
    }
    triangle {
      < 9.228248, 0.270685, -2.612574>,
      < 8.832082, -0.613710, -2.541341>,
      < 8.842156, -0.613710, -2.604175>
    }
    triangle {
      < 9.228248, 0.270685, -2.612574>,
      < 8.842156, -0.613710, -2.604175>,
      < 9.279998, 0.280421, -2.632423>
    }
    triangle {
      < 9.222689, 0.314422, -2.613701>,
      < 9.228248, 0.270685, -2.612574>,
      < 9.279998, 0.280421, -2.632423>
    }
    triangle {
      < 9.222689, 0.314422, -2.613701>,
      < 9.279998, 0.280421, -2.632423>,
      < 9.268329, 0.350512, -2.632469>
    }
    triangle {
      < 9.179674, 0.355510, -2.615465>,
      < 9.222689, 0.314422, -2.613701>,
      < 9.268329, 0.350512, -2.632469>
    }
    triangle {
      < 9.179674, 0.355510, -2.615465>,
      < 9.268329, 0.350512, -2.632469>,
      < 9.227504, 0.392088, -2.631354>
    }
    triangle {
      < 9.134267, 0.362971, -2.613432>,
      < 9.179674, 0.355510, -2.615465>,
      < 9.227504, 0.392088, -2.631354>
    }
    triangle {
      < 9.134267, 0.362971, -2.613432>,
      < 9.227504, 0.392088, -2.631354>,
      < 9.157522, 0.405147, -2.629079>
    }
    triangle {
      < 9.182603, 0.351266, -2.667382>,
      < 9.137182, 0.358654, -2.665998>,
      < 9.158513, 0.403807, -2.652705>
    }
    triangle {
      < 9.182603, 0.351266, -2.667382>,
      < 9.158513, 0.403807, -2.652705>,
      < 9.227866, 0.390941, -2.655616>
    }
    triangle {
      < 9.222457, 0.312353, -2.672189>,
      < 9.182603, 0.351266, -2.667382>,
      < 9.227866, 0.390941, -2.655616>
    }
    triangle {
      < 9.222457, 0.312353, -2.672189>,
      < 9.227866, 0.390941, -2.655616>,
      < 9.268064, 0.349557, -2.657365>
    }
    triangle {
      < 9.227635, 0.268676, -2.673442>,
      < 9.222457, 0.312353, -2.672189>,
      < 9.268064, 0.349557, -2.657365>
    }
    triangle {
      < 9.227635, 0.268676, -2.673442>,
      < 9.268064, 0.349557, -2.657365>,
      < 9.279105, 0.279658, -2.657954>
    }
    triangle {
      < 8.825618, -0.613710, -2.723200>,
      < 9.227635, 0.268676, -2.673442>,
      < 9.279105, 0.279658, -2.657954>
    }
    triangle {
      < 8.825618, -0.613710, -2.723200>,
      < 9.279105, 0.279658, -2.657954>,
      < 8.838814, -0.613710, -2.671821>
    }
    triangle {
      < 9.279998, 0.280421, -2.632423>,
      < 8.842156, -0.613710, -2.604175>,
      < 8.860677, -0.613710, -2.620058>
    }
    triangle {
      < 8.838814, -0.613710, -2.671821>,
      < 9.279105, 0.279658, -2.657954>,
      < 8.859509, -0.613710, -2.657776>
    }
    triangle {
      < 4.980284, 0.424102, -2.646861>,
      < 5.195446, 0.416846, -2.633922>,
      < 5.196445, 0.435444, -2.645413>
    }
    triangle {
      < 4.980284, 0.424102, -2.646861>,
      < 5.196445, 0.435444, -2.645413>,
      < 4.991977, 0.439201, -2.652834>
    }
    triangle {
      < 4.972139, 0.422715, -2.646387>,
      < 4.980284, 0.424102, -2.646861>,
      < 4.991977, 0.439201, -2.652834>
    }
    triangle {
      < 4.972139, 0.422715, -2.646387>,
      < 4.991977, 0.439201, -2.652834>,
      < 4.975072, 0.436202, -2.651829>
    }
    triangle {
      < 4.966338, 0.418596, -2.645824>,
      < 4.972139, 0.422715, -2.646387>,
      < 4.975072, 0.436202, -2.651829>
    }
    triangle {
      < 4.966338, 0.418596, -2.645824>,
      < 4.975072, 0.436202, -2.651829>,
      < 4.962166, 0.427737, -2.650893>
    }
    triangle {
      < 4.939573, 0.418233, -2.648936>,
      < 4.966338, 0.418596, -2.645824>,
      < 4.962166, 0.427737, -2.650893>
    }
    triangle {
      < 4.961545, 0.428285, -2.679075>,
      < 4.937755, 0.418982, -2.677343>,
      < 4.954349, 0.440237, -2.677941>
    }
    triangle {
      < 4.974592, 0.436650, -2.679451>,
      < 4.961545, 0.428285, -2.679075>,
      < 4.954349, 0.440237, -2.677941>
    }
    triangle {
      < 4.974592, 0.436650, -2.679451>,
      < 4.954349, 0.440237, -2.677941>,
      < 4.975909, 0.453292, -2.679017>
    }
    triangle {
      < 4.991166, 0.439826, -2.680316>,
      < 4.974592, 0.436650, -2.679451>,
      < 4.975909, 0.453292, -2.679017>
    }
    triangle {
      < 4.991166, 0.439826, -2.680316>,
      < 4.975909, 0.453292, -2.679017>,
      < 5.002436, 0.458145, -2.680569>
    }
    triangle {
      < 5.195735, 0.436750, -2.685490>,
      < 4.991166, 0.439826, -2.680316>,
      < 5.002436, 0.458145, -2.680569>
    }
    triangle {
      < 5.195735, 0.436750, -2.685490>,
      < 5.002436, 0.458145, -2.680569>,
      < 5.197023, 0.458783, -2.679006>
    }
    triangle {
      < 4.991166, 0.439826, -2.680316>,
      < 5.195735, 0.436750, -2.685490>,
      < 5.194430, 0.418646, -2.698007>
    }
    triangle {
      < 4.991166, 0.439826, -2.680316>,
      < 5.194430, 0.418646, -2.698007>,
      < 4.979320, 0.424974, -2.686347>
    }
    triangle {
      < 4.974592, 0.436650, -2.679451>,
      < 4.991166, 0.439826, -2.680316>,
      < 4.979320, 0.424974, -2.686347>
    }
    triangle {
      < 4.974592, 0.436650, -2.679451>,
      < 4.979320, 0.424974, -2.686347>,
      < 4.971589, 0.423416, -2.686000>
    }
    triangle {
      < 4.961545, 0.428285, -2.679075>,
      < 4.974592, 0.436650, -2.679451>,
      < 4.971589, 0.423416, -2.686000>
    }
    triangle {
      < 4.961545, 0.428285, -2.679075>,
      < 4.971589, 0.423416, -2.686000>,
      < 4.965728, 0.419402, -2.685982>
    }
    triangle {
      < 4.937755, 0.418982, -2.677343>,
      < 4.961545, 0.428285, -2.679075>,
      < 4.965728, 0.419402, -2.685982>
    }
    triangle {
      < 4.991977, 0.439201, -2.652834>,
      < 5.196445, 0.435444, -2.645413>,
      < 5.197360, 0.457936, -2.650850>
    }
    triangle {
      < 4.991977, 0.439201, -2.652834>,
      < 5.197360, 0.457936, -2.650850>,
      < 5.003514, 0.457348, -2.652287>
    }
    triangle {
      < 4.975072, 0.436202, -2.651829>,
      < 4.991977, 0.439201, -2.652834>,
      < 5.003514, 0.457348, -2.652287>
    }
    triangle {
      < 4.975072, 0.436202, -2.651829>,
      < 5.003514, 0.457348, -2.652287>,
      < 4.977233, 0.452511, -2.650693>
    }
    triangle {
      < 4.962166, 0.427737, -2.650893>,
      < 4.975072, 0.436202, -2.651829>,
      < 4.977233, 0.452511, -2.650693>
    }
    triangle {
      < 4.962166, 0.427737, -2.650893>,
      < 4.977233, 0.452511, -2.650693>,
      < 4.955920, 0.439473, -2.649575>
    }
    triangle {
      < 4.939573, 0.418233, -2.648936>,
      < 4.962166, 0.427737, -2.650893>,
      < 4.955920, 0.439473, -2.649575>
    }
    triangle {
      < 6.018072, 0.447388, -2.673555>,
      < 6.018225, 0.420453, -2.681422>,
      < 5.195735, 0.436750, -2.685490>
    }
    triangle {
      < 6.018072, 0.447388, -2.673555>,
      < 5.195735, 0.436750, -2.685490>,
      < 5.197023, 0.458783, -2.679006>
    }
    triangle {
      < 6.018225, 0.420453, -2.681422>,
      < 6.016443, 0.397662, -2.695796>,
      < 5.194430, 0.418646, -2.698007>
    }
    triangle {
      < 6.018225, 0.420453, -2.681422>,
      < 5.194430, 0.418646, -2.698007>,
      < 5.195735, 0.436750, -2.685490>
    }
    triangle {
      < 6.013906, 0.397873, -2.624697>,
      < 6.013980, 0.420398, -2.638773>,
      < 5.196445, 0.435444, -2.645413>
    }
    triangle {
      < 6.013906, 0.397873, -2.624697>,
      < 5.196445, 0.435444, -2.645413>,
      < 5.195446, 0.416846, -2.633922>
    }
    triangle {
      < 6.014196, 0.389435, -2.592635>,
      < 6.013906, 0.397873, -2.624697>,
      < 5.195446, 0.416846, -2.633922>
    }
    triangle {
      < 6.014196, 0.389435, -2.592635>,
      < 5.195446, 0.416846, -2.633922>,
      < 5.194364, 0.402142, -2.616375>
    }
    triangle {
      < 6.013906, 0.397873, -2.624697>,
      < 6.014196, 0.389435, -2.592635>,
      < 7.656147, 0.345041, -2.573846>
    }
    triangle {
      < 6.013906, 0.397873, -2.624697>,
      < 7.656147, 0.345041, -2.573846>,
      < 7.655514, 0.359819, -2.606194>
    }
    triangle {
      < 6.013980, 0.420398, -2.638773>,
      < 6.013906, 0.397873, -2.624697>,
      < 7.655514, 0.359819, -2.606194>
    }
    triangle {
      < 6.013980, 0.420398, -2.638773>,
      < 7.655514, 0.359819, -2.606194>,
      < 7.657019, 0.390159, -2.625429>
    }
    triangle {
      < 6.015857, 0.447026, -2.646350>,
      < 6.013980, 0.420398, -2.638773>,
      < 7.657019, 0.390159, -2.625429>
    }
    triangle {
      < 6.015857, 0.447026, -2.646350>,
      < 7.657019, 0.390159, -2.625429>,
      < 7.655910, 0.425164, -2.637334>
    }
    triangle {
      < 6.018072, 0.447388, -2.673555>,
      < 6.015857, 0.447026, -2.646350>,
      < 7.655910, 0.425164, -2.637334>
    }
    triangle {
      < 6.018072, 0.447388, -2.673555>,
      < 7.655910, 0.425164, -2.637334>,
      < 7.656977, 0.424645, -2.662674>
    }
    triangle {
      < 6.018225, 0.420453, -2.681422>,
      < 6.018072, 0.447388, -2.673555>,
      < 7.656977, 0.424645, -2.662674>
    }
    triangle {
      < 6.018225, 0.420453, -2.681422>,
      < 7.656977, 0.424645, -2.662674>,
      < 7.656381, 0.387995, -2.673321>
    }
    triangle {
      < 6.016443, 0.397662, -2.695796>,
      < 6.018225, 0.420453, -2.681422>,
      < 7.656381, 0.387995, -2.673321>
    }
    triangle {
      < 6.016443, 0.397662, -2.695796>,
      < 7.656381, 0.387995, -2.673321>,
      < 7.655323, 0.355826, -2.691388>
    }
    triangle {
      < 6.016861, 0.389399, -2.722277>,
      < 6.016443, 0.397662, -2.695796>,
      < 7.655323, 0.355826, -2.691388>
    }
    triangle {
      < 6.016861, 0.389399, -2.722277>,
      < 7.655323, 0.355826, -2.691388>,
      < 7.653469, 0.344960, -2.729584>
    }
    triangle {
      < 7.655514, 0.359819, -2.606194>,
      < 7.656147, 0.345041, -2.573846>,
      < 9.089541, 0.294427, -2.558130>
    }
    triangle {
      < 7.655514, 0.359819, -2.606194>,
      < 9.089541, 0.294427, -2.558130>,
      < 9.111607, 0.326064, -2.589782>
    }
    triangle {
      < 7.657019, 0.390159, -2.625429>,
      < 7.655514, 0.359819, -2.606194>,
      < 9.111607, 0.326064, -2.589782>
    }
    triangle {
      < 7.657019, 0.390159, -2.625429>,
      < 9.111607, 0.326064, -2.589782>,
      < 9.134267, 0.362971, -2.613432>
    }
    triangle {
      < 7.655910, 0.425164, -2.637334>,
      < 7.657019, 0.390159, -2.625429>,
      < 9.134267, 0.362971, -2.613432>
    }
    triangle {
      < 7.655910, 0.425164, -2.637334>,
      < 9.134267, 0.362971, -2.613432>,
      < 9.157522, 0.405147, -2.629079>
    }
    triangle {
      < 7.656977, 0.424645, -2.662674>,
      < 7.655910, 0.425164, -2.637334>,
      < 9.157522, 0.405147, -2.629079>
    }
    triangle {
      < 7.656977, 0.424645, -2.662674>,
      < 9.157522, 0.405147, -2.629079>,
      < 9.158513, 0.403807, -2.652705>
    }
    triangle {
      < 7.656381, 0.387995, -2.673321>,
      < 7.656977, 0.424645, -2.662674>,
      < 9.158513, 0.403807, -2.652705>
    }
    triangle {
      < 7.656381, 0.387995, -2.673321>,
      < 9.158513, 0.403807, -2.652705>,
      < 9.137182, 0.358654, -2.665998>
    }
    triangle {
      < 7.655323, 0.355826, -2.691388>,
      < 7.656381, 0.387995, -2.673321>,
      < 9.137182, 0.358654, -2.665998>
    }
    triangle {
      < 7.655323, 0.355826, -2.691388>,
      < 9.137182, 0.358654, -2.665998>,
      < 9.116157, 0.318534, -2.687459>
    }
    triangle {
      < 7.653469, 0.344960, -2.729584>,
      < 7.655323, 0.355826, -2.691388>,
      < 9.116157, 0.318534, -2.687459>
    }
    triangle {
      < 7.653469, 0.344960, -2.729584>,
      < 9.116157, 0.318534, -2.687459>,
      < 9.095436, 0.283447, -2.717090>
    }
    triangle {
      < -2.563848, 0.664836, 0.000000>,
      < -2.513843, 0.640220, -1.116418>,
      < -2.596643, 0.595192, -1.118505>
    }
    triangle {
      < -2.563848, 0.664836, 0.000000>,
      < -2.596643, 0.595192, -1.118505>,
      < -2.647161, 0.620226, 0.000000>
    }
    triangle {
      < -2.046178, 0.563892, -2.239006>,
      < -1.861263, 0.540159, -2.372707>,
      < -1.937317, 0.490102, -2.388227>
    }
    triangle {
      < -2.046178, 0.563892, -2.239006>,
      < -1.937317, 0.490102, -2.388227>,
      < -2.124247, 0.515122, -2.250817>
    }
    triangle {
      < -2.257701, 0.588659, -1.967557>,
      < -2.137997, 0.572132, -2.146596>,
      < -2.216968, 0.523991, -2.156171>
    }
    triangle {
      < -2.257701, 0.588659, -1.967557>,
      < -2.216968, 0.523991, -2.156171>,
      < -2.338066, 0.541556, -1.972795>
    }
    triangle {
      < -2.137997, 0.572132, -2.146596>,
      < -2.046178, 0.563892, -2.239006>,
      < -2.124247, 0.515122, -2.250817>
    }
    triangle {
      < -2.137997, 0.572132, -2.146596>,
      < -2.124247, 0.515122, -2.250817>,
      < -2.216968, 0.523991, -2.156171>
    }
    triangle {
      < -2.395683, 0.616269, -1.677391>,
      < -2.257701, 0.588659, -1.967557>,
      < -2.338066, 0.541556, -1.972795>
    }
    triangle {
      < -2.395683, 0.616269, -1.677391>,
      < -2.338066, 0.541556, -1.972795>,
      < -2.477282, 0.570167, -1.677680>
    }
    triangle {
      < -1.148572, 0.470027, -2.602251>,
      < -1.534455, 0.475062, -2.550094>,
      < -1.738342, 0.485082, -2.495975>
    }
    triangle {
      < -1.148572, 0.470027, -2.602251>,
      < -1.738342, 0.485082, -2.495975>,
      < -1.663497, 0.535625, -2.475946>
    }
    triangle {
      < -1.148572, 0.470027, -2.602251>,
      < -1.663497, 0.535625, -2.475946>,
      < -1.186268, 0.540032, -2.545651>
    }
    triangle {
      < -2.513843, 0.640220, -1.116418>,
      < -2.395683, 0.616269, -1.677391>,
      < -2.477282, 0.570167, -1.677680>
    }
    triangle {
      < -2.513843, 0.640220, -1.116418>,
      < -2.477282, 0.570167, -1.677680>,
      < -2.551558, 0.580177, -1.443880>
    }
    triangle {
      < -2.513843, 0.640220, -1.116418>,
      < -2.551558, 0.580177, -1.443880>,
      < -2.596643, 0.595192, -1.118505>
    }
    triangle {
      < -2.513843, 0.640220, -1.116418>,
      < -2.563848, 0.664836, 0.000000>,
      < -2.518123, 0.717825, 0.000000>
    }
    triangle {
      < -2.513843, 0.640220, -1.116418>,
      < -2.518123, 0.717825, 0.000000>,
      < -2.468745, 0.693699, -1.113939>
    }
    triangle {
      < -2.395683, 0.616269, -1.677391>,
      < -2.513843, 0.640220, -1.116418>,
      < -2.468745, 0.693699, -1.113939>
    }
    triangle {
      < -2.395683, 0.616269, -1.677391>,
      < -2.468745, 0.693699, -1.113939>,
      < -2.352075, 0.671026, -1.677048>
    }
    triangle {
      < -2.257701, 0.588659, -1.967557>,
      < -2.395683, 0.616269, -1.677391>,
      < -2.352075, 0.671026, -1.677048>
    }
    triangle {
      < -2.257701, 0.588659, -1.967557>,
      < -2.352075, 0.671026, -1.677048>,
      < -2.216012, 0.644890, -1.967351>
    }
    triangle {
      < -2.137997, 0.572132, -2.146596>,
      < -2.257701, 0.588659, -1.967557>,
      < -2.216012, 0.644890, -1.967351>
    }
    triangle {
      < -2.137997, 0.572132, -2.146596>,
      < -2.216012, 0.644890, -1.967351>,
      < -2.097687, 0.629337, -2.144970>
    }
    triangle {
      < -2.046178, 0.563892, -2.239006>,
      < -2.137997, 0.572132, -2.146596>,
      < -2.097687, 0.629337, -2.144970>
    }
    triangle {
      < -2.046178, 0.563892, -2.239006>,
      < -2.097687, 0.629337, -2.144970>,
      < -2.007033, 0.621876, -2.236672>
    }
    triangle {
      < -1.861263, 0.540159, -2.372707>,
      < -2.046178, 0.563892, -2.239006>,
      < -2.007033, 0.621876, -2.236672>
    }
    triangle {
      < -1.861263, 0.540159, -2.372707>,
      < -2.007033, 0.621876, -2.236672>,
      < -1.824827, 0.599804, -2.368844>
    }
    triangle {
      < -1.663497, 0.535625, -2.475946>,
      < -1.861263, 0.540159, -2.372707>,
      < -1.824827, 0.599804, -2.368844>
    }
    triangle {
      < -1.663497, 0.535625, -2.475946>,
      < -1.824827, 0.599804, -2.368844>,
      < -1.629170, 0.596234, -2.469007>
    }
    triangle {
      < -1.663497, 0.535625, -2.475946>,
      < -1.629170, 0.596234, -2.469007>,
      < -1.509560, 0.599953, -2.486600>
    }
    triangle {
      < -1.663497, 0.535625, -2.475946>,
      < -1.509560, 0.599953, -2.486600>,
      < -1.186268, 0.540032, -2.545651>
    }
    triangle {
      < -1.520526, 1.815788, -1.061110>,
      < -1.550691, 1.836236, 0.000000>,
      < -1.496285, 1.900125, 0.000000>
    }
    triangle {
      < -1.520526, 1.815788, -1.061110>,
      < -1.496285, 1.900125, 0.000000>,
      < -1.466633, 1.880095, -1.058952>
    }
    triangle {
      < -1.468092, 1.779693, -1.670048>,
      < -1.520526, 1.815788, -1.061110>,
      < -1.466633, 1.880095, -1.058952>
    }
    triangle {
      < -1.468092, 1.779693, -1.670048>,
      < -1.466633, 1.880095, -1.058952>,
      < -1.415399, 1.845075, -1.669688>
    }
    triangle {
      < -1.412507, 1.728679, -1.963380>,
      < -1.468092, 1.779693, -1.670048>,
      < -1.415399, 1.845075, -1.669688>
    }
    triangle {
      < -1.412507, 1.728679, -1.963380>,
      < -1.415399, 1.845075, -1.669688>,
      < -1.361049, 1.795061, -1.962939>
    }
    triangle {
      < -1.359722, 1.677634, -2.114707>,
      < -1.412507, 1.728679, -1.963380>,
      < -1.361049, 1.795061, -1.962939>
    }
    triangle {
      < -1.359722, 1.677634, -2.114707>,
      < -1.361049, 1.795061, -1.962939>,
      < -1.309657, 1.745054, -2.112932>
    }
    triangle {
      < -1.331195, 1.624870, -2.195607>,
      < -1.359722, 1.677634, -2.114707>,
      < -1.309657, 1.745054, -2.112932>
    }
    triangle {
      < -1.331195, 1.624870, -2.195607>,
      < -1.309657, 1.745054, -2.112932>,
      < -1.280637, 1.695050, -2.192977>
    }
    triangle {
      < -1.295008, 1.471234, -2.311228>,
      < -1.331195, 1.624870, -2.195607>,
      < -1.280637, 1.695050, -2.192977>
    }
    triangle {
      < -1.295008, 1.471234, -2.311228>,
      < -1.280637, 1.695050, -2.192977>,
      < -1.261595, 1.640047, -2.239476>
    }
    triangle {
      < -1.295008, 1.471234, -2.311228>,
      < -1.261595, 1.640047, -2.239476>,
      < -1.241647, 1.550043, -2.306568>
    }
    triangle {
      < -1.262364, 1.249839, -2.392038>,
      < -1.295008, 1.471234, -2.311228>,
      < -1.241647, 1.550043, -2.306568>
    }
    triangle {
      < -1.262364, 1.249839, -2.392038>,
      < -1.241647, 1.550043, -2.306568>,
      < -1.203056, 1.340038, -2.383760>
    }
    triangle {
      < -2.216012, 0.644890, -1.967351>,
      < -2.352075, 0.671026, -1.677048>,
      < -2.306105, 0.664578, -1.673231>
    }
    triangle {
      < -2.216012, 0.644890, -1.967351>,
      < -2.306105, 0.664578, -1.673231>,
      < -2.173151, 0.642992, -1.948107>
    }
    triangle {
      < -2.007033, 0.621876, -2.236672>,
      < -2.097687, 0.629337, -2.144970>,
      < -2.055634, 0.627002, -2.125403>
    }
    triangle {
      < -2.007033, 0.621876, -2.236672>,
      < -2.055634, 0.627002, -2.125403>,
      < -1.972645, 0.624423, -2.205898>
    }
    triangle {
      < -1.629170, 0.596234, -2.469007>,
      < -1.824827, 0.599804, -2.368844>,
      < -1.792238, 0.600730, -2.337865>
    }
    triangle {
      < -1.629170, 0.596234, -2.469007>,
      < -1.792238, 0.600730, -2.337865>,
      < -1.614355, 0.602091, -2.428892>
    }
    triangle {
      < -1.509560, 0.599953, -2.486600>,
      < -1.405537, 0.619055, -2.498667>,
      < -1.186268, 0.540032, -2.545651>
    }
    triangle {
      < -1.186268, 0.540032, -2.545651>,
      < -1.267084, 0.844988, -2.473849>,
      < -1.262364, 1.249839, -2.392038>
    }
    triangle {
      < -1.186268, 0.540032, -2.545651>,
      < -1.262364, 1.249839, -2.392038>,
      < -1.203056, 1.340038, -2.383760>
    }
    triangle {
      < -1.186268, 0.540032, -2.545651>,
      < -1.284299, 0.741572, -2.492291>,
      < -1.267084, 0.844988, -2.473849>
    }
    triangle {
      < -1.186268, 0.540032, -2.545651>,
      < -1.405537, 0.619055, -2.498667>,
      < -1.323216, 0.659235, -2.503107>
    }
    triangle {
      < -1.186268, 0.540032, -2.545651>,
      < -1.323216, 0.659235, -2.503107>,
      < -1.284299, 0.741572, -2.492291>
    }
    triangle {
      < -1.550691, 1.836236, 0.000000>,
      < -1.520526, 1.815788, -1.061110>,
      < -1.501422, 1.776069, -1.058051>
    }
    triangle {
      < -1.550691, 1.836236, 0.000000>,
      < -1.501422, 1.776069, -1.058051>,
      < -1.531823, 1.796562, 0.000000>
    }
    triangle {
      < -1.520526, 1.815788, -1.061110>,
      < -1.468092, 1.779693, -1.670048>,
      < -1.448195, 1.740140, -1.666425>
    }
    triangle {
      < -1.520526, 1.815788, -1.061110>,
      < -1.448195, 1.740140, -1.666425>,
      < -1.501422, 1.776069, -1.058051>
    }
    triangle {
      < -2.352075, 0.671026, -1.677048>,
      < -2.468745, 0.693699, -1.113939>,
      < -2.421983, 0.687416, -1.109558>
    }
    triangle {
      < -2.352075, 0.671026, -1.677048>,
      < -2.421983, 0.687416, -1.109558>,
      < -2.306105, 0.664578, -1.673231>
    }
    triangle {
      < -2.468745, 0.693699, -1.113939>,
      < -2.518123, 0.717825, 0.000000>,
      < -2.471125, 0.711497, 0.000000>
    }
    triangle {
      < -2.468745, 0.693699, -1.113939>,
      < -2.471125, 0.711497, 0.000000>,
      < -2.421983, 0.687416, -1.109558>
    }
    triangle {
      < -2.097687, 0.629337, -2.144970>,
      < -2.216012, 0.644890, -1.967351>,
      < -2.173151, 0.642992, -1.948107>
    }
    triangle {
      < -2.097687, 0.629337, -2.144970>,
      < -2.173151, 0.642992, -1.948107>,
      < -2.055634, 0.627002, -2.125403>
    }
    triangle {
      < -1.412507, 1.728679, -1.963380>,
      < -1.359722, 1.677634, -2.114707>,
      < -1.340144, 1.643680, -2.095907>
    }
    triangle {
      < -1.412507, 1.728679, -1.963380>,
      < -1.340144, 1.643680, -2.095907>,
      < -1.393737, 1.694287, -1.944256>
    }
    triangle {
      < -1.824827, 0.599804, -2.368844>,
      < -2.007033, 0.621876, -2.236672>,
      < -1.972645, 0.624423, -2.205898>
    }
    triangle {
      < -1.824827, 0.599804, -2.368844>,
      < -1.972645, 0.624423, -2.205898>,
      < -1.792238, 0.600730, -2.337865>
    }
    triangle {
      < -1.331195, 1.624870, -2.195607>,
      < -1.295008, 1.471234, -2.311228>,
      < -1.285982, 1.434658, -2.282372>
    }
    triangle {
      < -1.331195, 1.624870, -2.195607>,
      < -1.285982, 1.434658, -2.282372>,
      < -1.317752, 1.596914, -2.165866>
    }
    triangle {
      < -1.262364, 1.249839, -2.392038>,
      < -1.267084, 0.844988, -2.473849>,
      < -1.268391, 0.835856, -2.433827>
    }
    triangle {
      < -1.262364, 1.249839, -2.392038>,
      < -1.268391, 0.835856, -2.433827>,
      < -1.260878, 1.233804, -2.353841>
    }
    triangle {
      < -1.267084, 0.844988, -2.473849>,
      < -1.284299, 0.741572, -2.492291>,
      < -1.285062, 0.735826, -2.451662>
    }
    triangle {
      < -1.267084, 0.844988, -2.473849>,
      < -1.285062, 0.735826, -2.451662>,
      < -1.268391, 0.835856, -2.433827>
    }
    triangle {
      < -1.284299, 0.741572, -2.492291>,
      < -1.323216, 0.659235, -2.503107>,
      < -1.322724, 0.656193, -2.462118>
    }
    triangle {
      < -1.284299, 0.741572, -2.492291>,
      < -1.322724, 0.656193, -2.462118>,
      < -1.285062, 0.735826, -2.451662>
    }
    triangle {
      < -1.323216, 0.659235, -2.503107>,
      < -1.405537, 0.619055, -2.498667>,
      < -1.402362, 0.617344, -2.457819>
    }
    triangle {
      < -1.323216, 0.659235, -2.503107>,
      < -1.402362, 0.617344, -2.457819>,
      < -1.322724, 0.656193, -2.462118>
    }
    triangle {
      < -1.405537, 0.619055, -2.498667>,
      < -1.509560, 0.599953, -2.486600>,
      < -1.502984, 0.598885, -2.446143>
    }
    triangle {
      < -1.405537, 0.619055, -2.498667>,
      < -1.502984, 0.598885, -2.446143>,
      < -1.402362, 0.617344, -2.457819>
    }
    triangle {
      < -1.509560, 0.599953, -2.486600>,
      < -1.629170, 0.596234, -2.469007>,
      < -1.614355, 0.602091, -2.428892>
    }
    triangle {
      < -1.509560, 0.599953, -2.486600>,
      < -1.614355, 0.602091, -2.428892>,
      < -1.502984, 0.598885, -2.446143>
    }
    triangle {
      < -1.393737, 1.694287, -1.944256>,
      < -1.448195, 1.740140, -1.666425>,
      < -1.468092, 1.779693, -1.670048>
    }
    triangle {
      < -1.393737, 1.694287, -1.944256>,
      < -1.468092, 1.779693, -1.670048>,
      < -1.412507, 1.728679, -1.963380>
    }
    triangle {
      < -1.317752, 1.596914, -2.165866>,
      < -1.340144, 1.643680, -2.095907>,
      < -1.359722, 1.677634, -2.114707>
    }
    triangle {
      < -1.317752, 1.596914, -2.165866>,
      < -1.359722, 1.677634, -2.114707>,
      < -1.331195, 1.624870, -2.195607>
    }
    triangle {
      < -1.260878, 1.233804, -2.353841>,
      < -1.285982, 1.434658, -2.282372>,
      < -1.295008, 1.471234, -2.311228>
    }
    triangle {
      < -1.260878, 1.233804, -2.353841>,
      < -1.295008, 1.471234, -2.311228>,
      < -1.262364, 1.249839, -2.392038>
    }
    triangle {
      < -1.033102, 0.465816, -2.607353>,
      < -1.148572, 0.470027, -2.602251>,
      < -1.146178, 0.546644, -2.545252>
    }
    triangle {
      < -1.033102, 0.465816, -2.607353>,
      < -1.146178, 0.546644, -2.545252>,
      < -1.009507, 0.547531, -2.545279>
    }
    triangle {
      < -1.033102, 0.465816, -2.607353>,
      < -1.009507, 0.547531, -2.545279>,
      < -0.986746, 0.484704, -2.592602>
    }
    triangle {
      < -0.961274, 0.491229, -2.574352>,
      < -0.986746, 0.484704, -2.592602>,
      < -1.009507, 0.547531, -2.545279>
    }
    triangle {
      < -0.961274, 0.491229, -2.574352>,
      < -1.009507, 0.547531, -2.545279>,
      < -0.976372, 0.551342, -2.528678>
    }
    triangle {
      < -0.443789, 0.479750, -2.581917>,
      < -0.441565, 0.481225, -2.501955>,
      < -0.379683, 0.470362, -2.504004>
    }
    triangle {
      < -0.443789, 0.479750, -2.581917>,
      < -0.379683, 0.470362, -2.504004>,
      < -0.381252, 0.460833, -2.577173>
    }
    triangle {
      < 0.816296, 0.404855, -2.649039>,
      < 0.819398, 0.425256, -2.554250>,
      < 1.773786, 0.360172, -2.588591>
    }
    triangle {
      < 0.816296, 0.404855, -2.649039>,
      < 1.773786, 0.360172, -2.588591>,
      < 1.780270, 0.339770, -2.680530>
    }
    triangle {
      < -0.370346, 0.444959, -2.605526>,
      < -0.378037, 0.453098, -2.588279>,
      < -0.379683, 0.470362, -2.504004>
    }
    triangle {
      < -0.937812, 0.552421, -2.521091>,
      < -0.914157, 0.494912, -2.560705>,
      < -0.961274, 0.491229, -2.574352>
    }
    triangle {
      < -0.937812, 0.552421, -2.521091>,
      < -0.961274, 0.491229, -2.574352>,
      < -0.976372, 0.551342, -2.528678>
    }
    triangle {
      < -0.986746, 0.484704, -2.592602>,
      < -0.950543, 0.463118, -2.608058>,
      < -1.033102, 0.465816, -2.607353>
    }
    triangle {
      < -0.930255, 0.470592, -2.588926>,
      < -0.950543, 0.463118, -2.608058>,
      < -0.986746, 0.484704, -2.592602>
    }
    triangle {
      < -0.930255, 0.470592, -2.588926>,
      < -0.986746, 0.484704, -2.592602>,
      < -0.961274, 0.491229, -2.574352>
    }
    triangle {
      < -0.961274, 0.491229, -2.574352>,
      < -0.914157, 0.494912, -2.560705>,
      < -0.900545, 0.471350, -2.584866>
    }
    triangle {
      < -0.961274, 0.491229, -2.574352>,
      < -0.900545, 0.471350, -2.584866>,
      < -0.930255, 0.470592, -2.588926>
    }
    triangle {
      < -0.378037, 0.453098, -2.588279>,
      < -0.900545, 0.471350, -2.584866>,
      < -0.914157, 0.494912, -2.560705>
    }
    triangle {
      < -0.378037, 0.453098, -2.588279>,
      < -0.914157, 0.494912, -2.560705>,
      < -0.443789, 0.479750, -2.581917>
    }
    triangle {
      < -0.378037, 0.453098, -2.588279>,
      < -0.443789, 0.479750, -2.581917>,
      < -0.381252, 0.460833, -2.577173>
    }
    triangle {
      < -1.261595, 1.640047, -2.239476>,
      < -1.280637, 1.695050, -2.192977>,
      < -1.217837, 1.695050, -2.192977>
    }
    triangle {
      < -1.261595, 1.640047, -2.239476>,
      < -1.217837, 1.695050, -2.192977>,
      < -1.198795, 1.640047, -2.239476>
    }
    triangle {
      < -1.280637, 1.695050, -2.192977>,
      < -1.309657, 1.745054, -2.112932>,
      < -1.246857, 1.745054, -2.112932>
    }
    triangle {
      < -1.280637, 1.695050, -2.192977>,
      < -1.246857, 1.745054, -2.112932>,
      < -1.217837, 1.695050, -2.192977>
    }
    triangle {
      < -1.309657, 1.745054, -2.112932>,
      < -1.361049, 1.795061, -1.962939>,
      < -1.298249, 1.795061, -1.962939>
    }
    triangle {
      < -1.309657, 1.745054, -2.112932>,
      < -1.298249, 1.795061, -1.962939>,
      < -1.246857, 1.745054, -2.112932>
    }
    triangle {
      < -1.361049, 1.795061, -1.962939>,
      < -1.415399, 1.845075, -1.669688>,
      < -1.352599, 1.845075, -1.669688>
    }
    triangle {
      < -1.361049, 1.795061, -1.962939>,
      < -1.352599, 1.845075, -1.669688>,
      < -1.298249, 1.795061, -1.962939>
    }
    triangle {
      < -1.415399, 1.845075, -1.669688>,
      < -1.466633, 1.880095, -1.058952>,
      < -1.403833, 1.880095, -1.058952>
    }
    triangle {
      < -1.415399, 1.845075, -1.669688>,
      < -1.403833, 1.880095, -1.058952>,
      < -1.352599, 1.845075, -1.669688>
    }
    triangle {
      < -1.466633, 1.880095, -1.058952>,
      < -1.496285, 1.900125, 0.000000>,
      < -1.433485, 1.900125, 0.000000>
    }
    triangle {
      < -1.466633, 1.880095, -1.058952>,
      < -1.433485, 1.900125, 0.000000>,
      < -1.403833, 1.880095, -1.058952>
    }
    triangle {
      < -1.166484, 1.570037, -2.336873>,
      < -1.261595, 1.640047, -2.239476>,
      < -1.198795, 1.640047, -2.239476>
    }
    triangle {
      < -1.298249, 1.795061, -1.962939>,
      < -1.352599, 1.845075, -1.669688>,
      < -1.331573, 1.748010, -1.655882>
    }
    triangle {
      < -1.298249, 1.795061, -1.962939>,
      < -1.331573, 1.748010, -1.655882>,
      < -1.278242, 1.700844, -1.934251>
    }
    triangle {
      < -1.352599, 1.845075, -1.669688>,
      < -1.403833, 1.880095, -1.058952>,
      < -1.382452, 1.782476, -1.054004>
    }
    triangle {
      < -1.352599, 1.845075, -1.669688>,
      < -1.382452, 1.782476, -1.054004>,
      < -1.331573, 1.748010, -1.655882>
    }
    triangle {
      < -1.403833, 1.880095, -1.058952>,
      < -1.433485, 1.900125, 0.000000>,
      < -1.408941, 1.800495, 0.000000>
    }
    triangle {
      < -1.403833, 1.880095, -1.058952>,
      < -1.408941, 1.800495, 0.000000>,
      < -1.382452, 1.782476, -1.054004>
    }
    triangle {
      < -2.129741, 0.602935, -1.940372>,
      < -2.129692, 0.526073, -1.940406>,
      < -2.015709, 0.512791, -2.120956>
    }
    triangle {
      < -2.129741, 0.602935, -1.940372>,
      < -2.015709, 0.512791, -2.120956>,
      < -2.015777, 0.587300, -2.120876>
    }
    triangle {
      < -1.146178, 0.546644, -2.545252>,
      < -1.165747, 1.355034, -2.403962>,
      < -1.163142, 1.331583, -2.306517>
    }
    triangle {
      < -1.146178, 0.546644, -2.545252>,
      < -1.163142, 1.331583, -2.306517>,
      < -1.128806, 0.567268, -2.456757>
    }
    triangle {
      < -1.165747, 1.355034, -2.403962>,
      < -1.166484, 1.570037, -2.336873>,
      < -1.155437, 1.509682, -2.251191>
    }
    triangle {
      < -1.165747, 1.355034, -2.403962>,
      < -1.155437, 1.509682, -2.251191>,
      < -1.163142, 1.331583, -2.306517>
    }
    triangle {
      < -1.166484, 1.570037, -2.336873>,
      < -1.198795, 1.640047, -2.239476>,
      < -1.184809, 1.568264, -2.169792>
    }
    triangle {
      < -1.166484, 1.570037, -2.336873>,
      < -1.184809, 1.568264, -2.169792>,
      < -1.155437, 1.509682, -2.251191>
    }
    triangle {
      < -1.198795, 1.640047, -2.239476>,
      < -1.217837, 1.695050, -2.192977>,
      < -1.203585, 1.622177, -2.124300>
    }
    triangle {
      < -1.198795, 1.640047, -2.239476>,
      < -1.203585, 1.622177, -2.124300>,
      < -1.184809, 1.568264, -2.169792>
    }
    triangle {
      < -1.217837, 1.695050, -2.192977>,
      < -1.246857, 1.745054, -2.112932>,
      < -1.228930, 1.658054, -2.065620>
    }
    triangle {
      < -1.217837, 1.695050, -2.192977>,
      < -1.228930, 1.658054, -2.065620>,
      < -1.203585, 1.622177, -2.124300>
    }
    triangle {
      < -1.246857, 1.745054, -2.112932>,
      < -1.298249, 1.795061, -1.962939>,
      < -1.278242, 1.700844, -1.934251>
    }
    triangle {
      < -1.246857, 1.745054, -2.112932>,
      < -1.278242, 1.700844, -1.934251>,
      < -1.228930, 1.658054, -2.065620>
    }
    triangle {
      < -1.494550, 1.785838, 0.000000>,
      < -1.467670, 1.767479, -1.054614>,
      < -1.382452, 1.782476, -1.054004>
    }
    triangle {
      < -1.494550, 1.785838, 0.000000>,
      < -1.382452, 1.782476, -1.054004>,
      < -1.408941, 1.800495, 0.000000>
    }
    triangle {
      < -2.366911, 0.579198, -1.099482>,
      < -2.366984, 0.665475, -1.099416>,
      < -2.419312, 0.712380, 0.000000>
    }
    triangle {
      < -2.366911, 0.579198, -1.099482>,
      < -2.419312, 0.712380, 0.000000>,
      < -2.419305, 0.619042, 0.000000>
    }
    triangle {
      < -1.467670, 1.767479, -1.054614>,
      < -1.416259, 1.732549, -1.655801>,
      < -1.331573, 1.748010, -1.655882>
    }
    triangle {
      < -1.467670, 1.767479, -1.054614>,
      < -1.331573, 1.748010, -1.655882>,
      < -1.382452, 1.782476, -1.054004>
    }
    triangle {
      < -2.258311, 0.539354, -1.650110>,
      < -2.258348, 0.618570, -1.650021>,
      < -2.366984, 0.665475, -1.099416>
    }
    triangle {
      < -2.258311, 0.539354, -1.650110>,
      < -2.366984, 0.665475, -1.099416>,
      < -2.366911, 0.579198, -1.099482>
    }
    triangle {
      < -1.416259, 1.732549, -1.655801>,
      < -1.362498, 1.685040, -1.934339>,
      < -1.278242, 1.700844, -1.934251>
    }
    triangle {
      < -1.416259, 1.732549, -1.655801>,
      < -1.278242, 1.700844, -1.934251>,
      < -1.331573, 1.748010, -1.655882>
    }
    triangle {
      < -2.129692, 0.526073, -1.940406>,
      < -2.129741, 0.602935, -1.940372>,
      < -2.258348, 0.618570, -1.650021>
    }
    triangle {
      < -2.129692, 0.526073, -1.940406>,
      < -2.258348, 0.618570, -1.650021>,
      < -2.258311, 0.539354, -1.650110>
    }
    triangle {
      < -2.015777, 0.587300, -2.120876>,
      < -2.015709, 0.512791, -2.120956>,
      < -1.939025, 0.508364, -2.193487>
    }
    triangle {
      < -2.015777, 0.587300, -2.120876>,
      < -1.939025, 0.508364, -2.193487>,
      < -1.939041, 0.582088, -2.193431>
    }
    triangle {
      < -1.326746, 1.641951, -2.066452>,
      < -1.308735, 1.605871, -2.125383>,
      < -1.203585, 1.622177, -2.124300>
    }
    triangle {
      < -1.326746, 1.641951, -2.066452>,
      < -1.203585, 1.622177, -2.124300>,
      < -1.228930, 1.658054, -2.065620>
    }
    triangle {
      < -1.939041, 0.582088, -2.193431>,
      < -1.939025, 0.508364, -2.193487>,
      < -1.765427, 0.503937, -2.299581>
    }
    triangle {
      < -1.939041, 0.582088, -2.193431>,
      < -1.765427, 0.503937, -2.299581>,
      < -1.765442, 0.576877, -2.299501>
    }
    triangle {
      < -1.308735, 1.605871, -2.125383>,
      < -1.294507, 1.551115, -2.172036>,
      < -1.184809, 1.568264, -2.169792>
    }
    triangle {
      < -1.308735, 1.605871, -2.125383>,
      < -1.184809, 1.568264, -2.169792>,
      < -1.203585, 1.622177, -2.124300>
    }
    triangle {
      < -1.267328, 0.572570, -2.419982>,
      < -1.077008, 0.499510, -2.477921>,
      < -1.128806, 0.567268, -2.456757>
    }
    triangle {
      < -1.305959, 0.682560, -2.392979>,
      < -1.267328, 0.572570, -2.419982>,
      < -1.264699, 0.815249, -2.377412>
    }
    triangle {
      < -1.294507, 1.551115, -2.172036>,
      < -1.286024, 1.491526, -2.253235>,
      < -1.155437, 1.509682, -2.251191>
    }
    triangle {
      < -1.294507, 1.551115, -2.172036>,
      < -1.155437, 1.509682, -2.251191>,
      < -1.184809, 1.568264, -2.169792>
    }
    triangle {
      < -1.593830, 0.501724, -2.368387>,
      < -1.593866, 0.574271, -2.356469>,
      < -1.765442, 0.576877, -2.299501>
    }
    triangle {
      < -1.593830, 0.501724, -2.368387>,
      < -1.765442, 0.576877, -2.299501>,
      < -1.765427, 0.503937, -2.299581>
    }
    triangle {
      < -1.163142, 1.331583, -2.306517>,
      < -1.260465, 1.206042, -2.308860>,
      < -1.264699, 0.815249, -2.377412>
    }
    triangle {
      < -1.163142, 1.331583, -2.306517>,
      < -1.264699, 0.815249, -2.377412>,
      < -1.267328, 0.572570, -2.419982>
    }
    triangle {
      < -1.163142, 1.331583, -2.306517>,
      < -1.267328, 0.572570, -2.419982>,
      < -1.128806, 0.567268, -2.456757>
    }
    triangle {
      < -1.267328, 0.572570, -2.419982>,
      < -1.396127, 0.602132, -2.389802>,
      < -1.535205, 0.573965, -2.367879>
    }
    triangle {
      < -1.267328, 0.572570, -2.419982>,
      < -1.305959, 0.682560, -2.392979>,
      < -1.396127, 0.602132, -2.389802>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -1.267328, 0.572570, -2.419982>,
      < -1.535205, 0.573965, -2.367879>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -1.535205, 0.573965, -2.367879>,
      < -1.593866, 0.574271, -2.356469>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -1.593866, 0.574271, -2.356469>,
      < -1.593830, 0.501724, -2.368387>
    }
    triangle {
      < -0.937812, 0.552421, -2.521091>,
      < -0.976372, 0.551342, -2.528678>,
      < -1.011091, 0.553864, -2.511151>
    }
    triangle {
      < -0.937812, 0.552421, -2.521091>,
      < -1.011091, 0.553864, -2.511151>,
      < -0.976847, 0.555205, -2.507884>
    }
    triangle {
      < -0.976372, 0.551342, -2.528678>,
      < -1.009507, 0.547531, -2.545279>,
      < -1.011921, 0.548908, -2.535374>
    }
    triangle {
      < -0.976372, 0.551342, -2.528678>,
      < -1.011921, 0.548908, -2.535374>,
      < -1.011091, 0.553864, -2.511151>
    }
    triangle {
      < -1.009507, 0.547531, -2.545279>,
      < -1.146178, 0.546644, -2.545252>,
      < -1.134118, 0.547666, -2.535246>
    }
    triangle {
      < -1.009507, 0.547531, -2.545279>,
      < -1.134118, 0.547666, -2.535246>,
      < -1.011921, 0.548908, -2.535374>
    }
    triangle {
      < -1.146178, 0.546644, -2.545252>,
      < -1.128806, 0.567268, -2.456757>,
      < -1.120671, 0.565656, -2.457738>
    }
    triangle {
      < -1.146178, 0.546644, -2.545252>,
      < -1.120671, 0.565656, -2.457738>,
      < -1.134118, 0.547666, -2.535246>
    }
    triangle {
      < -1.011921, 0.548908, -2.535374>,
      < -1.134118, 0.547666, -2.535246>,
      < -1.158844, 1.569088, -2.356722>
    }
    triangle {
      < -1.011921, 0.548908, -2.535374>,
      < -1.158844, 1.569088, -2.356722>,
      < -1.036647, 1.570330, -2.356851>
    }
    triangle {
      < -1.134118, 0.547666, -2.535246>,
      < -1.120671, 0.565656, -2.457738>,
      < -1.145396, 1.587077, -2.279214>
    }
    triangle {
      < -1.134118, 0.547666, -2.535246>,
      < -1.145396, 1.587077, -2.279214>,
      < -1.158844, 1.569088, -2.356722>
    }
    triangle {
      < -0.976847, 0.555205, -2.507884>,
      < -1.011091, 0.553864, -2.511151>,
      < -1.035817, 1.575286, -2.332628>
    }
    triangle {
      < -0.976847, 0.555205, -2.507884>,
      < -1.035817, 1.575286, -2.332628>,
      < -1.001572, 1.576626, -2.329360>
    }
    triangle {
      < -1.011091, 0.553864, -2.511151>,
      < -1.011921, 0.548908, -2.535374>,
      < -1.036647, 1.570330, -2.356851>
    }
    triangle {
      < -1.011091, 0.553864, -2.511151>,
      < -1.036647, 1.570330, -2.356851>,
      < -1.035817, 1.575286, -2.332628>
    }
    triangle {
      < -0.998839, 1.579408, -2.289442>,
      < -1.145396, 1.587077, -2.279214>,
      < -1.120671, 0.565656, -2.457738>
    }
    triangle {
      < -0.998839, 1.579408, -2.289442>,
      < -1.120671, 0.565656, -2.457738>,
      < -0.972757, 0.557578, -2.469685>
    }
    triangle {
      < -0.998839, 1.579408, -2.289442>,
      < -1.035817, 1.575286, -2.332628>,
      < -1.145396, 1.587077, -2.279214>
    }
    triangle {
      < -0.998839, 1.579408, -2.289442>,
      < -0.972757, 0.557578, -2.469685>,
      < -0.924028, 0.604633, -2.464607>
    }
    triangle {
      < -0.998839, 1.579408, -2.289442>,
      < -0.924028, 0.604633, -2.464607>,
      < -0.947583, 1.527573, -2.301732>
    }
    triangle {
      < -0.976847, 0.555205, -2.507884>,
      < -1.001572, 1.576626, -2.329360>,
      < -0.950451, 1.525363, -2.342247>
    }
    triangle {
      < -0.976847, 0.555205, -2.507884>,
      < -0.950451, 1.525363, -2.342247>,
      < -0.928116, 0.602701, -2.503510>
    }
    triangle {
      < 5.027698, 0.491304, -2.367082>,
      < 4.812309, 0.452697, -2.525539>,
      < 4.778682, 0.457080, -2.450184>
    }
    triangle {
      < 5.027698, 0.491304, -2.367082>,
      < 4.778682, 0.457080, -2.450184>,
      < 4.971003, 0.493964, -2.309541>
    }
    triangle {
      < 4.812309, 0.452697, -2.525539>,
      < 4.633741, 0.426260, -2.557898>,
      < 4.618841, 0.431370, -2.478587>
    }
    triangle {
      < 4.812309, 0.452697, -2.525539>,
      < 4.618841, 0.431370, -2.478587>,
      < 4.778682, 0.457080, -2.450184>
    }
    triangle {
      < 4.633741, 0.426260, -2.557898>,
      < 4.278938, 0.429553, -2.620985>,
      < 4.271063, 0.434863, -2.541304>
    }
    triangle {
      < 4.633741, 0.426260, -2.557898>,
      < 4.271063, 0.434863, -2.541304>,
      < 4.618841, 0.431370, -2.478587>
    }
    triangle {
      < 4.278938, 0.429553, -2.620985>,
      < 3.618461, 0.419610, -2.634592>,
      < 3.625835, 0.430011, -2.554180>
    }
    triangle {
      < 4.278938, 0.429553, -2.620985>,
      < 3.625835, 0.430011, -2.554180>,
      < 4.271063, 0.434863, -2.541304>
    }
    triangle {
      < 5.484661, 0.611664, 0.000000>,
      < 5.435663, 0.594303, -1.148942>,
      < 5.355932, 0.593194, -1.141120>
    }
    triangle {
      < 5.484661, 0.611664, 0.000000>,
      < 5.355932, 0.593194, -1.141120>,
      < 5.401163, 0.604866, 0.000000>
    }
    triangle {
      < 5.435663, 0.594303, -1.148942>,
      < 5.336588, 0.556670, -1.801338>,
      < 5.258856, 0.556459, -1.780305>
    }
    triangle {
      < 5.435663, 0.594303, -1.148942>,
      < 5.258856, 0.556459, -1.780305>,
      < 5.355932, 0.593194, -1.141120>
    }
    triangle {
      < 5.336588, 0.556670, -1.801338>,
      < 5.203112, 0.518845, -2.137795>,
      < 5.132811, 0.520019, -2.098088>
    }
    triangle {
      < 5.336588, 0.556670, -1.801338>,
      < 5.132811, 0.520019, -2.098088>,
      < 5.258856, 0.556459, -1.780305>
    }
    triangle {
      < 5.203112, 0.518845, -2.137795>,
      < 5.027698, 0.491304, -2.367082>,
      < 4.971003, 0.493964, -2.309541>
    }
    triangle {
      < 5.203112, 0.518845, -2.137795>,
      < 4.971003, 0.493964, -2.309541>,
      < 5.132811, 0.520019, -2.098088>
    }
    triangle {
      < 2.393729, 0.259716, -2.691078>,
      < 2.385818, 0.275118, -2.594347>,
      < 2.552528, 0.340104, -2.576065>
    }
    triangle {
      < 2.393729, 0.259716, -2.691078>,
      < 2.552528, 0.340104, -2.576065>,
      < 2.546063, 0.324703, -2.677072>
    }
    triangle {
      < 2.745803, 0.369686, -2.664615>,
      < 2.752269, 0.385087, -2.563607>,
      < 3.009002, 0.415065, -2.549848>
    }
    triangle {
      < 2.745803, 0.369686, -2.664615>,
      < 3.009002, 0.415065, -2.549848>,
      < 3.013547, 0.399663, -2.652796>
    }
    triangle {
      < 2.546063, 0.324703, -2.677072>,
      < 2.552528, 0.340104, -2.576065>,
      < 2.752269, 0.385087, -2.563607>
    }
    triangle {
      < 2.546063, 0.324703, -2.677072>,
      < 2.752269, 0.385087, -2.563607>,
      < 2.745803, 0.369686, -2.664615>
    }
    triangle {
      < -1.145396, 1.587077, -2.279214>,
      < -1.035817, 1.575286, -2.332628>,
      < -1.036647, 1.570330, -2.356851>
    }
    triangle {
      < -1.145396, 1.587077, -2.279214>,
      < -1.036647, 1.570330, -2.356851>,
      < -1.158844, 1.569088, -2.356722>
    }
    triangle {
      < -1.260465, 1.206042, -2.308860>,
      < -1.163142, 1.331583, -2.306517>,
      < -1.155437, 1.509682, -2.251191>
    }
    triangle {
      < -1.260465, 1.206042, -2.308860>,
      < -1.155437, 1.509682, -2.251191>,
      < -1.286024, 1.491526, -2.253235>
    }
    triangle {
      < -0.379683, 0.470362, -2.504004>,
      < -0.378037, 0.453098, -2.588279>,
      < -0.381252, 0.460833, -2.577173>
    }
    triangle {
      < 0.819398, 0.425256, -2.554250>,
      < 0.816296, 0.404855, -2.649039>,
      < -0.370346, 0.444959, -2.605526>
    }
    triangle {
      < 0.819398, 0.425256, -2.554250>,
      < -0.370346, 0.444959, -2.605526>,
      < -0.379683, 0.470362, -2.504004>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -0.972757, 0.557578, -2.469685>,
      < -1.120671, 0.565656, -2.457738>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -1.120671, 0.565656, -2.457738>,
      < -1.128806, 0.567268, -2.456757>
    }
    triangle {
      < -0.441565, 0.481225, -2.501955>,
      < -1.077008, 0.499510, -2.477921>,
      < -0.379683, 0.470362, -2.504004>
    }
    triangle {
      < -0.998839, 1.579408, -2.289442>,
      < -1.001572, 1.576626, -2.329360>,
      < -1.035817, 1.575286, -2.332628>
    }
    triangle {
      < 8.784227, -0.613710, -2.779588>,
      < 8.879555, -0.281976, -2.769261>,
      < 8.934355, -0.179734, -2.773799>
    }
    triangle {
      < 8.784227, -0.613710, -2.779588>,
      < 8.934355, -0.179734, -2.773799>,
      < 9.045938, 0.054134, -2.755627>
    }
    triangle {
      < 8.784227, -0.613710, -2.779588>,
      < 9.045938, 0.054134, -2.755627>,
      < 9.140353, 0.244126, -2.728450>
    }
    triangle {
      < 8.784227, -0.613710, -2.779588>,
      < 9.140353, 0.244126, -2.728450>,
      < 9.181384, 0.256832, -2.696940>
    }
    triangle {
      < 8.838814, -0.613710, -2.671821>,
      < 8.842156, -0.613710, -2.604175>,
      < 8.832082, -0.613710, -2.541341>
    }
    triangle {
      < 8.838814, -0.613710, -2.671821>,
      < 8.832082, -0.613710, -2.541341>,
      < 8.795041, -0.613710, -2.488710>
    }
    triangle {
      < 8.838814, -0.613710, -2.671821>,
      < 8.795041, -0.613710, -2.488710>,
      < 8.749555, -0.613710, -2.466970>
    }
    triangle {
      < 8.838814, -0.613710, -2.671821>,
      < 8.749555, -0.613710, -2.466970>,
      < 8.735338, -0.613710, -2.826938>
    }
    triangle {
      < 8.838814, -0.613710, -2.671821>,
      < 8.735338, -0.613710, -2.826938>,
      < 8.784227, -0.613710, -2.779588>
    }
    triangle {
      < 8.838814, -0.613710, -2.671821>,
      < 8.784227, -0.613710, -2.779588>,
      < 8.825618, -0.613710, -2.723200>
    }
    triangle {
      < -1.166484, 1.570037, -2.336873>,
      < -1.241647, 1.550043, -2.306568>,
      < -1.261595, 1.640047, -2.239476>
    }
    triangle {
      < -1.165747, 1.355034, -2.403962>,
      < -1.203056, 1.340038, -2.383760>,
      < -1.241647, 1.550043, -2.306568>
    }
    triangle {
      < -1.165747, 1.355034, -2.403962>,
      < -1.241647, 1.550043, -2.306568>,
      < -1.166484, 1.570037, -2.336873>
    }
    triangle {
      < -6.857495, -0.015160, 2.045397>,
      < -6.858537, -0.013427, 2.025174>,
      < -6.833982, -0.079470, 2.018336>
    }
    triangle {
      < -6.857495, -0.015160, 2.045397>,
      < -6.833982, -0.079470, 2.018336>,
      < -6.834251, -0.079229, 2.038333>
    }
    triangle {
      < -6.858537, -0.013427, 2.025174>,
      < -6.922982, 0.060807, 2.034971>,
      < -6.846581, 0.069217, 2.034971>
    }
    triangle {
      < -6.858537, -0.013427, 2.025174>,
      < -6.846581, 0.069217, 2.034971>,
      < -6.782136, -0.009468, 2.025174>
    }
    triangle {
      < -6.922982, 0.060807, 2.034971>,
      < -7.037093, 0.190717, 2.118648>,
      < -6.960692, 0.206915, 2.118648>
    }
    triangle {
      < -6.922982, 0.060807, 2.034971>,
      < -6.960692, 0.206915, 2.118648>,
      < -6.846581, 0.069217, 2.034971>
    }
    triangle {
      < -7.037093, 0.190717, 2.118648>,
      < -7.098756, 0.251030, 2.233527>,
      < -7.022356, 0.270845, 2.233527>
    }
    triangle {
      < -7.037093, 0.190717, 2.118648>,
      < -7.022356, 0.270845, 2.233527>,
      < -6.960692, 0.206915, 2.118648>
    }
    triangle {
      < -7.098756, 0.251030, 2.233527>,
      < -7.140397, 0.296924, 2.411743>,
      < -7.063996, 0.318964, 2.411743>
    }
    triangle {
      < -7.098756, 0.251030, 2.233527>,
      < -7.063996, 0.318964, 2.411743>,
      < -7.022356, 0.270845, 2.233527>
    }
    triangle {
      < -7.140397, 0.296924, 2.411743>,
      < -7.145110, 0.297465, 2.499018>,
      < -7.068709, 0.320061, 2.499018>
    }
    triangle {
      < -7.140397, 0.296924, 2.411743>,
      < -7.068709, 0.320061, 2.499018>,
      < -7.063996, 0.318964, 2.411743>
    }
    triangle {
      < -7.145110, 0.297465, 2.499018>,
      < -7.111449, 0.255661, 2.670665>,
      < -7.035048, 0.275753, 2.670665>
    }
    triangle {
      < -7.145110, 0.297465, 2.499018>,
      < -7.035048, 0.275753, 2.670665>,
      < -7.068709, 0.320061, 2.499018>
    }
    triangle {
      < -7.111449, 0.255661, 2.670665>,
      < -7.037015, 0.181421, 2.795497>,
      < -6.960614, 0.197063, 2.795497>
    }
    triangle {
      < -7.111449, 0.255661, 2.670665>,
      < -6.960614, 0.197063, 2.795497>,
      < -7.035048, 0.275753, 2.670665>
    }
    triangle {
      < -7.037015, 0.181421, 2.795497>,
      < -6.931751, 0.056148, 2.862890>,
      < -6.855350, 0.064279, 2.862890>
    }
    triangle {
      < -7.037015, 0.181421, 2.795497>,
      < -6.855350, 0.064279, 2.862890>,
      < -6.960614, 0.197063, 2.795497>
    }
    triangle {
      < -6.931751, 0.056148, 2.862890>,
      < -6.875800, -0.013447, 2.873777>,
      < -6.799399, -0.009489, 2.873777>
    }
    triangle {
      < -6.931751, 0.056148, 2.862890>,
      < -6.799399, -0.009489, 2.873777>,
      < -6.855350, 0.064279, 2.862890>
    }
    triangle {
      < -6.875800, -0.013447, 2.873777>,
      < -6.845516, -0.069121, 2.876542>,
      < -6.769115, -0.068501, 2.876542>
    }
    triangle {
      < -6.875800, -0.013447, 2.873777>,
      < -6.769115, -0.068501, 2.876542>,
      < -6.799399, -0.009489, 2.873777>
    }
    triangle {
      < -6.845516, -0.069121, 2.876542>,
      < -6.842030, -0.294491, 2.856221>,
      < -6.765629, -0.294491, 2.856221>
    }
    triangle {
      < -6.845516, -0.069121, 2.876542>,
      < -6.765629, -0.294491, 2.856221>,
      < -6.769115, -0.068501, 2.876542>
    }
    triangle {
      < -6.833982, -0.079470, 2.018336>,
      < -6.858537, -0.013427, 2.025174>,
      < -6.782136, -0.009468, 2.025174>
    }
    triangle {
      < -6.833982, -0.079470, 2.018336>,
      < -6.782136, -0.009468, 2.025174>,
      < -6.757581, -0.079470, 2.018336>
    }
    triangle {
      < -6.928379, 0.052304, 2.843365>,
      < -6.874547, -0.014609, 2.853755>,
      < -6.875800, -0.013447, 2.873777>
    }
    triangle {
      < -6.928379, 0.052304, 2.843365>,
      < -6.875800, -0.013447, 2.873777>,
      < -6.931751, 0.056148, 2.862890>
    }
    triangle {
      < -6.857495, -0.015160, 2.045397>,
      < -6.919741, 0.056316, 2.054514>,
      < -6.922982, 0.060807, 2.034971>
    }
    triangle {
      < -6.857495, -0.015160, 2.045397>,
      < -6.922982, 0.060807, 2.034971>,
      < -6.858537, -0.013427, 2.025174>
    }
    triangle {
      < -6.919741, 0.056316, 2.054514>,
      < -7.029095, 0.180308, 2.134510>,
      < -7.037093, 0.190717, 2.118648>
    }
    triangle {
      < -6.919741, 0.056316, 2.054514>,
      < -7.037093, 0.190717, 2.118648>,
      < -6.922982, 0.060807, 2.034971>
    }
    triangle {
      < -7.029095, 0.180308, 2.134510>,
      < -7.087681, 0.236878, 2.242903>,
      < -7.098756, 0.251030, 2.233527>
    }
    triangle {
      < -7.029095, 0.180308, 2.134510>,
      < -7.098756, 0.251030, 2.233527>,
      < -7.037093, 0.190717, 2.118648>
    }
    triangle {
      < -7.087681, 0.236878, 2.242903>,
      < -7.128163, 0.281420, 2.415889>,
      < -7.140397, 0.296924, 2.411743>
    }
    triangle {
      < -7.087681, 0.236878, 2.242903>,
      < -7.140397, 0.296924, 2.411743>,
      < -7.098756, 0.251030, 2.233527>
    }
    triangle {
      < -7.128163, 0.281420, 2.415889>,
      < -7.132436, 0.281541, 2.496710>,
      < -7.145110, 0.297465, 2.499018>
    }
    triangle {
      < -7.128163, 0.281420, 2.415889>,
      < -7.145110, 0.297465, 2.499018>,
      < -7.140397, 0.296924, 2.411743>
    }
    triangle {
      < -7.132436, 0.281541, 2.496710>,
      < -7.100271, 0.241778, 2.660793>,
      < -7.111449, 0.255661, 2.670665>
    }
    triangle {
      < -7.132436, 0.281541, 2.496710>,
      < -7.111449, 0.255661, 2.670665>,
      < -7.145110, 0.297465, 2.499018>
    }
    triangle {
      < -7.100271, 0.241778, 2.660793>,
      < -7.029285, 0.172025, 2.778870>,
      < -7.037015, 0.181421, 2.795497>
    }
    triangle {
      < -7.100271, 0.241778, 2.660793>,
      < -7.037015, 0.181421, 2.795497>,
      < -7.111449, 0.255661, 2.670665>
    }
    triangle {
      < -7.029285, 0.172025, 2.778870>,
      < -6.928379, 0.052304, 2.843365>,
      < -6.931751, 0.056148, 2.862890>
    }
    triangle {
      < -7.029285, 0.172025, 2.778870>,
      < -6.931751, 0.056148, 2.862890>,
      < -7.037015, 0.181421, 2.795497>
    }
    triangle {
      < -6.845248, -0.069362, 2.856545>,
      < -6.841718, -0.289349, 2.836606>,
      < -6.842030, -0.294491, 2.856221>
    }
    triangle {
      < -6.845248, -0.069362, 2.856545>,
      < -6.842030, -0.294491, 2.856221>,
      < -6.845516, -0.069121, 2.876542>
    }
    triangle {
      < -6.845516, -0.069121, 2.876542>,
      < -6.875800, -0.013447, 2.873777>,
      < -6.874547, -0.014609, 2.853755>
    }
    triangle {
      < -6.845516, -0.069121, 2.876542>,
      < -6.874547, -0.014609, 2.853755>,
      < -6.845248, -0.069362, 2.856545>
    }
    triangle {
      < -6.805484, -0.123162, 2.758246>,
      < -6.805866, -0.226324, 2.743735>,
      < -6.806168, -0.232484, 2.763064>
    }
    triangle {
      < -6.805484, -0.123162, 2.758246>,
      < -6.806168, -0.232484, 2.763064>,
      < -6.805801, -0.122246, 2.778569>
    }
    triangle {
      < -6.805866, -0.226324, 2.743735>,
      < -6.805741, -0.318576, 2.696020>,
      < -6.805990, -0.331365, 2.711921>
    }
    triangle {
      < -6.805866, -0.226324, 2.743735>,
      < -6.805990, -0.331365, 2.711921>,
      < -6.806168, -0.232484, 2.763064>
    }
    triangle {
      < -6.805741, -0.318576, 2.696020>,
      < -6.803799, -0.410023, 2.586029>,
      < -6.803942, -0.428412, 2.595193>
    }
    triangle {
      < -6.805741, -0.318576, 2.696020>,
      < -6.803942, -0.428412, 2.595193>,
      < -6.805990, -0.331365, 2.711921>
    }
    triangle {
      < -6.803799, -0.410023, 2.586029>,
      < -6.801350, -0.442659, 2.447400>,
      < -6.801351, -0.463196, 2.447439>
    }
    triangle {
      < -6.803799, -0.410023, 2.586029>,
      < -6.801351, -0.463196, 2.447439>,
      < -6.803942, -0.428412, 2.595193>
    }
    triangle {
      < -6.801350, -0.442659, 2.447400>,
      < -6.798938, -0.411085, 2.310958>,
      < -6.798798, -0.429527, 2.301943>
    }
    triangle {
      < -6.801350, -0.442659, 2.447400>,
      < -6.798798, -0.429527, 2.301943>,
      < -6.801351, -0.463196, 2.447439>
    }
    triangle {
      < -6.798938, -0.411085, 2.310958>,
      < -6.797009, -0.322354, 2.201725>,
      < -6.796764, -0.335362, 2.186019>
    }
    triangle {
      < -6.798938, -0.411085, 2.310958>,
      < -6.796764, -0.335362, 2.186019>,
      < -6.798798, -0.429527, 2.301943>
    }
    triangle {
      < -6.797009, -0.322354, 2.201725>,
      < -6.796867, -0.232077, 2.153030>,
      < -6.796567, -0.238610, 2.133832>
    }
    triangle {
      < -6.797009, -0.322354, 2.201725>,
      < -6.796567, -0.238610, 2.133832>,
      < -6.796764, -0.335362, 2.186019>
    }
    triangle {
      < -6.796867, -0.232077, 2.153030>,
      < -6.797215, -0.130596, 2.136513>,
      < -6.796898, -0.130108, 2.116174>
    }
    triangle {
      < -6.796867, -0.232077, 2.153030>,
      < -6.796898, -0.130108, 2.116174>,
      < -6.796567, -0.238610, 2.133832>
    }
    triangle {
      < -6.797215, -0.130596, 2.136513>,
      < -6.797060, -0.007134, 2.162727>,
      < -6.796768, 0.001062, 2.144023>
    }
    triangle {
      < -6.797215, -0.130596, 2.136513>,
      < -6.796768, 0.001062, 2.144023>,
      < -6.796898, -0.130108, 2.116174>
    }
    triangle {
      < -6.797060, -0.007134, 2.162727>,
      < -6.797607, 0.095650, 2.235601>,
      < -6.797389, 0.110451, 2.221580>
    }
    triangle {
      < -6.797060, -0.007134, 2.162727>,
      < -6.797389, 0.110451, 2.221580>,
      < -6.796768, 0.001062, 2.144023>
    }
    triangle {
      < -6.797607, 0.095650, 2.235601>,
      < -6.799339, 0.157424, 2.333527>,
      < -6.799222, 0.176365, 2.326069>
    }
    triangle {
      < -6.797607, 0.095650, 2.235601>,
      < -6.799222, 0.176365, 2.326069>,
      < -6.797389, 0.110451, 2.221580>
    }
    triangle {
      < -6.799339, 0.157424, 2.333527>,
      < -6.801351, 0.179053, 2.447468>,
      < -6.801351, 0.199405, 2.447439>
    }
    triangle {
      < -6.799339, 0.157424, 2.333527>,
      < -6.801351, 0.199405, 2.447439>,
      < -6.799222, 0.176365, 2.326069>
    }
    triangle {
      < -6.801351, 0.179053, 2.447468>,
      < -6.803336, 0.158060, 2.559751>,
      < -6.803450, 0.177033, 2.567100>
    }
    triangle {
      < -6.801351, 0.179053, 2.447468>,
      < -6.803450, 0.177033, 2.567100>,
      < -6.801351, 0.199405, 2.447439>
    }
    triangle {
      < -6.803336, 0.158060, 2.559751>,
      < -6.805049, 0.097988, 2.656756>,
      < -6.805265, 0.112938, 2.670601>
    }
    triangle {
      < -6.803336, 0.158060, 2.559751>,
      < -6.805265, 0.112938, 2.670601>,
      < -6.803450, 0.177033, 2.567100>
    }
    triangle {
      < -6.805049, 0.097988, 2.656756>,
      < -6.805604, -0.002191, 2.729949>,
      < -6.805894, 0.006324, 2.748495>
    }
    triangle {
      < -6.805049, 0.097988, 2.656756>,
      < -6.805894, 0.006324, 2.748495>,
      < -6.805265, 0.112938, 2.670601>
    }
    triangle {
      < -6.805604, -0.002191, 2.729949>,
      < -6.805484, -0.123162, 2.758246>,
      < -6.805801, -0.122246, 2.778569>
    }
    triangle {
      < -6.805604, -0.002191, 2.729949>,
      < -6.805801, -0.122246, 2.778569>,
      < -6.805894, 0.006324, 2.748495>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.652828, -1.812349, 2.644820>,
      < 8.727462, -1.812349, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.727462, -1.812349, 2.644820>,
      < 8.773904, -1.757912, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.773904, -1.757912, 2.644820>,
      < 8.773904, -1.572958, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.773904, -1.572958, 2.644820>,
      < 8.754660, -1.517604, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.754660, -1.517604, 2.644820>,
      < 8.816582, -1.480141, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.816582, -1.480141, 2.644820>,
      < 8.866709, -1.430716, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.866709, -1.430716, 2.644820>,
      < 8.905038, -1.369328, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.905038, -1.369328, 2.644820>,
      < 8.840815, -1.275948, 2.644820>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.840815, -1.275948, 2.644820>,
      < 8.756744, -1.206643, 2.644820>
    }
    triangle {
      < 8.989041, -1.369328, 1.032750>,
      < 9.013043, -1.369328, 0.000000>,
      < 8.948820, -1.275948, 0.000000>
    }
    triangle {
      < 8.989041, -1.369328, 1.032750>,
      < 8.948820, -1.275948, 0.000000>,
      < 8.924818, -1.275948, 1.032750>
    }
    triangle {
      < 8.835467, -1.812349, 0.000000>,
      < 8.811465, -1.812349, 1.032750>,
      < 8.736832, -1.812349, 1.032750>
    }
    triangle {
      < 8.835467, -1.812349, 0.000000>,
      < 8.736832, -1.812349, 1.032750>,
      < 8.760834, -1.812349, 0.000000>
    }
    triangle {
      < 8.811465, -1.812349, 1.032750>,
      < 8.835467, -1.812349, 0.000000>,
      < 8.881909, -1.757912, 0.000000>
    }
    triangle {
      < 8.811465, -1.812349, 1.032750>,
      < 8.881909, -1.757912, 0.000000>,
      < 8.857907, -1.757912, 1.032750>
    }
    triangle {
      < 8.736832, -1.812349, 1.032750>,
      < 8.736832, -1.161411, 1.032750>,
      < 8.760834, -1.161411, 0.000000>
    }
    triangle {
      < 8.736832, -1.812349, 1.032750>,
      < 8.760834, -1.161411, 0.000000>,
      < 8.760834, -1.812349, 0.000000>
    }
    triangle {
      < 9.013043, -1.369328, 0.000000>,
      < 8.989041, -1.369328, 1.032750>,
      < 8.950712, -1.430716, 1.032750>
    }
    triangle {
      < 9.013043, -1.369328, 0.000000>,
      < 8.950712, -1.430716, 1.032750>,
      < 8.974714, -1.430716, 0.000000>
    }
    triangle {
      < 8.881909, -1.572958, 0.000000>,
      < 8.857907, -1.572958, 1.032750>,
      < 8.857907, -1.757912, 1.032750>
    }
    triangle {
      < 8.881909, -1.572958, 0.000000>,
      < 8.857907, -1.757912, 1.032750>,
      < 8.881909, -1.757912, 0.000000>
    }
    triangle {
      < 8.760834, -1.161411, 0.000000>,
      < 8.736832, -1.161411, 1.032750>,
      < 8.840748, -1.206643, 1.032750>
    }
    triangle {
      < 8.760834, -1.161411, 0.000000>,
      < 8.840748, -1.206643, 1.032750>,
      < 8.864750, -1.206643, 0.000000>
    }
    triangle {
      < 8.864750, -1.206643, 0.000000>,
      < 8.840748, -1.206643, 1.032750>,
      < 8.924818, -1.275948, 1.032750>
    }
    triangle {
      < 8.864750, -1.206643, 0.000000>,
      < 8.924818, -1.275948, 1.032750>,
      < 8.948820, -1.275948, 0.000000>
    }
    triangle {
      < 8.900585, -1.480141, 1.032750>,
      < 8.924587, -1.480141, 0.000000>,
      < 8.974714, -1.430716, 0.000000>
    }
    triangle {
      < 8.900585, -1.480141, 1.032750>,
      < 8.974714, -1.430716, 0.000000>,
      < 8.950712, -1.430716, 1.032750>
    }
    triangle {
      < 8.838663, -1.517604, 1.032750>,
      < 8.862665, -1.517604, 0.000000>,
      < 8.924587, -1.480141, 0.000000>
    }
    triangle {
      < 8.838663, -1.517604, 1.032750>,
      < 8.924587, -1.480141, 0.000000>,
      < 8.900585, -1.480141, 1.032750>
    }
    triangle {
      < 8.862665, -1.517604, 0.000000>,
      < 8.838663, -1.517604, 1.032750>,
      < 8.857907, -1.572958, 1.032750>
    }
    triangle {
      < 8.862665, -1.517604, 0.000000>,
      < 8.857907, -1.572958, 1.032750>,
      < 8.881909, -1.572958, 0.000000>
    }
    triangle {
      < 8.782664, -1.812349, 1.749258>,
      < 8.708031, -1.812349, 1.749258>,
      < 8.736832, -1.812349, 1.032750>
    }
    triangle {
      < 8.782664, -1.812349, 1.749258>,
      < 8.736832, -1.812349, 1.032750>,
      < 8.811465, -1.812349, 1.032750>
    }
    triangle {
      < 8.708031, -1.812349, 1.749258>,
      < 8.708031, -1.161411, 1.749258>,
      < 8.736832, -1.161411, 1.032750>
    }
    triangle {
      < 8.708031, -1.812349, 1.749258>,
      < 8.736832, -1.161411, 1.032750>,
      < 8.736832, -1.812349, 1.032750>
    }
    triangle {
      < 8.708031, -1.161411, 1.749258>,
      < 8.811947, -1.206643, 1.749258>,
      < 8.840748, -1.206643, 1.032750>
    }
    triangle {
      < 8.708031, -1.161411, 1.749258>,
      < 8.840748, -1.206643, 1.032750>,
      < 8.736832, -1.161411, 1.032750>
    }
    triangle {
      < 8.811947, -1.206643, 1.749258>,
      < 8.896017, -1.275948, 1.749258>,
      < 8.924818, -1.275948, 1.032750>
    }
    triangle {
      < 8.811947, -1.206643, 1.749258>,
      < 8.924818, -1.275948, 1.032750>,
      < 8.840748, -1.206643, 1.032750>
    }
    triangle {
      < 8.896017, -1.275948, 1.749258>,
      < 8.960240, -1.369328, 1.749258>,
      < 8.989041, -1.369328, 1.032750>
    }
    triangle {
      < 8.896017, -1.275948, 1.749258>,
      < 8.989041, -1.369328, 1.032750>,
      < 8.924818, -1.275948, 1.032750>
    }
    triangle {
      < 8.960240, -1.369328, 1.749258>,
      < 8.921911, -1.430716, 1.749258>,
      < 8.950712, -1.430716, 1.032750>
    }
    triangle {
      < 8.960240, -1.369328, 1.749258>,
      < 8.950712, -1.430716, 1.032750>,
      < 8.989041, -1.369328, 1.032750>
    }
    triangle {
      < 8.921911, -1.430716, 1.749258>,
      < 8.871784, -1.480141, 1.749258>,
      < 8.900585, -1.480141, 1.032750>
    }
    triangle {
      < 8.921911, -1.430716, 1.749258>,
      < 8.900585, -1.480141, 1.032750>,
      < 8.950712, -1.430716, 1.032750>
    }
    triangle {
      < 8.871784, -1.480141, 1.749258>,
      < 8.809862, -1.517604, 1.749258>,
      < 8.838663, -1.517604, 1.032750>
    }
    triangle {
      < 8.871784, -1.480141, 1.749258>,
      < 8.838663, -1.517604, 1.032750>,
      < 8.900585, -1.480141, 1.032750>
    }
    triangle {
      < 8.809862, -1.517604, 1.749258>,
      < 8.829106, -1.572958, 1.749258>,
      < 8.857907, -1.572958, 1.032750>
    }
    triangle {
      < 8.809862, -1.517604, 1.749258>,
      < 8.857907, -1.572958, 1.032750>,
      < 8.838663, -1.517604, 1.032750>
    }
    triangle {
      < 8.829106, -1.572958, 1.749258>,
      < 8.829106, -1.757912, 1.749258>,
      < 8.857907, -1.757912, 1.032750>
    }
    triangle {
      < 8.829106, -1.572958, 1.749258>,
      < 8.857907, -1.757912, 1.032750>,
      < 8.857907, -1.572958, 1.032750>
    }
    triangle {
      < 8.829106, -1.757912, 1.749258>,
      < 8.782664, -1.812349, 1.749258>,
      < 8.811465, -1.812349, 1.032750>
    }
    triangle {
      < 8.829106, -1.757912, 1.749258>,
      < 8.811465, -1.812349, 1.032750>,
      < 8.857907, -1.757912, 1.032750>
    }
    triangle {
      < 8.783461, -1.517604, 2.283984>,
      < 8.802705, -1.572958, 2.283984>,
      < 8.829106, -1.572958, 1.749258>
    }
    triangle {
      < 8.783461, -1.517604, 2.283984>,
      < 8.829106, -1.572958, 1.749258>,
      < 8.809862, -1.517604, 1.749258>
    }
    triangle {
      < 8.802705, -1.572958, 2.283984>,
      < 8.802705, -1.757912, 2.283984>,
      < 8.829106, -1.757912, 1.749258>
    }
    triangle {
      < 8.802705, -1.572958, 2.283984>,
      < 8.829106, -1.757912, 1.749258>,
      < 8.829106, -1.572958, 1.749258>
    }
    triangle {
      < 8.802705, -1.757912, 2.283984>,
      < 8.756263, -1.812349, 2.283984>,
      < 8.782664, -1.812349, 1.749258>
    }
    triangle {
      < 8.802705, -1.757912, 2.283984>,
      < 8.782664, -1.812349, 1.749258>,
      < 8.829106, -1.757912, 1.749258>
    }
    triangle {
      < 8.756263, -1.812349, 2.283984>,
      < 8.681629, -1.812349, 2.283984>,
      < 8.708031, -1.812349, 1.749258>
    }
    triangle {
      < 8.756263, -1.812349, 2.283984>,
      < 8.708031, -1.812349, 1.749258>,
      < 8.782664, -1.812349, 1.749258>
    }
    triangle {
      < 8.681629, -1.812349, 2.283984>,
      < 8.681629, -1.161411, 2.283984>,
      < 8.708031, -1.161411, 1.749258>
    }
    triangle {
      < 8.681629, -1.812349, 2.283984>,
      < 8.708031, -1.161411, 1.749258>,
      < 8.708031, -1.812349, 1.749258>
    }
    triangle {
      < 8.681629, -1.161411, 2.283984>,
      < 8.785545, -1.206643, 2.283984>,
      < 8.811947, -1.206643, 1.749258>
    }
    triangle {
      < 8.681629, -1.161411, 2.283984>,
      < 8.811947, -1.206643, 1.749258>,
      < 8.708031, -1.161411, 1.749258>
    }
    triangle {
      < 8.785545, -1.206643, 2.283984>,
      < 8.869616, -1.275948, 2.283984>,
      < 8.896017, -1.275948, 1.749258>
    }
    triangle {
      < 8.785545, -1.206643, 2.283984>,
      < 8.896017, -1.275948, 1.749258>,
      < 8.811947, -1.206643, 1.749258>
    }
    triangle {
      < 8.869616, -1.275948, 2.283984>,
      < 8.933839, -1.369328, 2.283984>,
      < 8.960240, -1.369328, 1.749258>
    }
    triangle {
      < 8.869616, -1.275948, 2.283984>,
      < 8.960240, -1.369328, 1.749258>,
      < 8.896017, -1.275948, 1.749258>
    }
    triangle {
      < 8.933839, -1.369328, 2.283984>,
      < 8.895510, -1.430716, 2.283984>,
      < 8.921911, -1.430716, 1.749258>
    }
    triangle {
      < 8.933839, -1.369328, 2.283984>,
      < 8.921911, -1.430716, 1.749258>,
      < 8.960240, -1.369328, 1.749258>
    }
    triangle {
      < 8.895510, -1.430716, 2.283984>,
      < 8.845383, -1.480141, 2.283984>,
      < 8.871784, -1.480141, 1.749258>
    }
    triangle {
      < 8.895510, -1.430716, 2.283984>,
      < 8.871784, -1.480141, 1.749258>,
      < 8.921911, -1.430716, 1.749258>
    }
    triangle {
      < 8.845383, -1.480141, 2.283984>,
      < 8.783461, -1.517604, 2.283984>,
      < 8.809862, -1.517604, 1.749258>
    }
    triangle {
      < 8.845383, -1.480141, 2.283984>,
      < 8.809862, -1.517604, 1.749258>,
      < 8.871784, -1.480141, 1.749258>
    }
    triangle {
      < 8.905038, -1.369328, 2.644820>,
      < 8.866709, -1.430716, 2.644820>,
      < 8.895510, -1.430716, 2.283984>
    }
    triangle {
      < 8.905038, -1.369328, 2.644820>,
      < 8.895510, -1.430716, 2.283984>,
      < 8.933839, -1.369328, 2.283984>
    }
    triangle {
      < 8.866709, -1.430716, 2.644820>,
      < 8.816582, -1.480141, 2.644820>,
      < 8.845383, -1.480141, 2.283984>
    }
    triangle {
      < 8.866709, -1.430716, 2.644820>,
      < 8.845383, -1.480141, 2.283984>,
      < 8.895510, -1.430716, 2.283984>
    }
    triangle {
      < 8.816582, -1.480141, 2.644820>,
      < 8.754660, -1.517604, 2.644820>,
      < 8.783461, -1.517604, 2.283984>
    }
    triangle {
      < 8.816582, -1.480141, 2.644820>,
      < 8.783461, -1.517604, 2.283984>,
      < 8.845383, -1.480141, 2.283984>
    }
    triangle {
      < 8.754660, -1.517604, 2.644820>,
      < 8.773904, -1.572958, 2.644820>,
      < 8.802705, -1.572958, 2.283984>
    }
    triangle {
      < 8.754660, -1.517604, 2.644820>,
      < 8.802705, -1.572958, 2.283984>,
      < 8.783461, -1.517604, 2.283984>
    }
    triangle {
      < 8.773904, -1.572958, 2.644820>,
      < 8.773904, -1.757912, 2.644820>,
      < 8.802705, -1.757912, 2.283984>
    }
    triangle {
      < 8.773904, -1.572958, 2.644820>,
      < 8.802705, -1.757912, 2.283984>,
      < 8.802705, -1.572958, 2.283984>
    }
    triangle {
      < 8.773904, -1.757912, 2.644820>,
      < 8.727462, -1.812349, 2.644820>,
      < 8.756263, -1.812349, 2.283984>
    }
    triangle {
      < 8.773904, -1.757912, 2.644820>,
      < 8.756263, -1.812349, 2.283984>,
      < 8.802705, -1.757912, 2.283984>
    }
    triangle {
      < 8.727462, -1.812349, 2.644820>,
      < 8.652828, -1.812349, 2.644820>,
      < 8.681629, -1.812349, 2.283984>
    }
    triangle {
      < 8.727462, -1.812349, 2.644820>,
      < 8.681629, -1.812349, 2.283984>,
      < 8.756263, -1.812349, 2.283984>
    }
    triangle {
      < 8.652828, -1.812349, 2.644820>,
      < 8.652828, -1.161411, 2.644820>,
      < 8.681629, -1.161411, 2.283984>
    }
    triangle {
      < 8.652828, -1.812349, 2.644820>,
      < 8.681629, -1.161411, 2.283984>,
      < 8.681629, -1.812349, 2.283984>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.756744, -1.206643, 2.644820>,
      < 8.785545, -1.206643, 2.283984>
    }
    triangle {
      < 8.652828, -1.161411, 2.644820>,
      < 8.785545, -1.206643, 2.283984>,
      < 8.681629, -1.161411, 2.283984>
    }
    triangle {
      < 8.756744, -1.206643, 2.644820>,
      < 8.840815, -1.275948, 2.644820>,
      < 8.869616, -1.275948, 2.283984>
    }
    triangle {
      < 8.756744, -1.206643, 2.644820>,
      < 8.869616, -1.275948, 2.283984>,
      < 8.785545, -1.206643, 2.283984>
    }
    triangle {
      < 8.840815, -1.275948, 2.644820>,
      < 8.905038, -1.369328, 2.644820>,
      < 8.933839, -1.369328, 2.283984>
    }
    triangle {
      < 8.840815, -1.275948, 2.644820>,
      < 8.933839, -1.369328, 2.283984>,
      < 8.869616, -1.275948, 2.283984>
    }
    triangle {
      < 8.810135, -0.869616, 2.822642>,
      < 8.710608, -0.924472, 2.864788>,
      < 8.960067, -0.925377, 2.833609>
    }
    triangle {
      < 8.810135, -0.869616, 2.822642>,
      < 8.960067, -0.925377, 2.833609>,
      < 8.960031, -0.871843, 2.805406>
    }
    triangle {
      < 8.870067, -0.824596, 2.779849>,
      < 8.810135, -0.869616, 2.822642>,
      < 8.960031, -0.871843, 2.805406>
    }
    triangle {
      < 8.870067, -0.824596, 2.779849>,
      < 8.960031, -0.871843, 2.805406>,
      < 8.959985, -0.827876, 2.771059>
    }
    triangle {
      < 8.911533, -0.791144, 2.735415>,
      < 8.870067, -0.824596, 2.779849>,
      < 8.959985, -0.827876, 2.771059>
    }
    triangle {
      < 8.911533, -0.791144, 2.735415>,
      < 8.959985, -0.827876, 2.771059>,
      < 8.959958, -0.794904, 2.732029>
    }
    triangle {
      < 8.938994, -0.770544, 2.690178>,
      < 8.911533, -0.791144, 2.735415>,
      < 8.959958, -0.794904, 2.732029>
    }
    triangle {
      < 8.938994, -0.770544, 2.690178>,
      < 8.959958, -0.794904, 2.732029>,
      < 8.961579, -0.774074, 2.689483>
    }
    triangle {
      < 8.947385, -0.763588, 2.644964>,
      < 8.938994, -0.770544, 2.690178>,
      < 8.961579, -0.774074, 2.689483>
    }
    triangle {
      < 8.947385, -0.763588, 2.644964>,
      < 8.961579, -0.774074, 2.689483>,
      < 8.962034, -0.766628, 2.644964>
    }
    triangle {
      < 8.938996, -0.770543, 2.599750>,
      < 8.947385, -0.763588, 2.644964>,
      < 8.962034, -0.766628, 2.644964>
    }
    triangle {
      < 8.938996, -0.770543, 2.599750>,
      < 8.962034, -0.766628, 2.644964>,
      < 8.961579, -0.774073, 2.600444>
    }
    triangle {
      < 8.911533, -0.791144, 2.554512>,
      < 8.938996, -0.770543, 2.599750>,
      < 8.961579, -0.774073, 2.600444>
    }
    triangle {
      < 8.911533, -0.791144, 2.554512>,
      < 8.961579, -0.774073, 2.600444>,
      < 8.959958, -0.794904, 2.557899>
    }
    triangle {
      < 8.870067, -0.824596, 2.510077>,
      < 8.911533, -0.791144, 2.554512>,
      < 8.959958, -0.794904, 2.557899>
    }
    triangle {
      < 8.870067, -0.824596, 2.510077>,
      < 8.959958, -0.794904, 2.557899>,
      < 8.959985, -0.827876, 2.518867>
    }
    triangle {
      < 8.810135, -0.869616, 2.467286>,
      < 8.870067, -0.824596, 2.510077>,
      < 8.959985, -0.827876, 2.518867>
    }
    triangle {
      < 8.810135, -0.869616, 2.467286>,
      < 8.959985, -0.827876, 2.518867>,
      < 8.960031, -0.871843, 2.484521>
    }
    triangle {
      < 8.710608, -0.924472, 2.425141>,
      < 8.810135, -0.869616, 2.467286>,
      < 8.960031, -0.871843, 2.484521>
    }
    triangle {
      < 8.710608, -0.924472, 2.425141>,
      < 8.960031, -0.871843, 2.484521>,
      < 8.960067, -0.925376, 2.456316>
    }
    triangle {
      < 8.820998, -0.798488, 2.777042>,
      < 8.758994, -0.839533, 2.819914>,
      < 8.810135, -0.869616, 2.822642>
    }
    triangle {
      < 8.820998, -0.798488, 2.777042>,
      < 8.810135, -0.869616, 2.822642>,
      < 8.870067, -0.824596, 2.779849>
    }
    triangle {
      < 8.863870, -0.768167, 2.732650>,
      < 8.820998, -0.798488, 2.777042>,
      < 8.870067, -0.824596, 2.779849>
    }
    triangle {
      < 8.863870, -0.768167, 2.732650>,
      < 8.870067, -0.824596, 2.779849>,
      < 8.911533, -0.791144, 2.735415>
    }
    triangle {
      < 8.891808, -0.749990, 2.688238>,
      < 8.863870, -0.768167, 2.732650>,
      < 8.911533, -0.791144, 2.735415>
    }
    triangle {
      < 8.891808, -0.749990, 2.688238>,
      < 8.911533, -0.791144, 2.735415>,
      < 8.938994, -0.770544, 2.690178>
    }
    triangle {
      < 8.900198, -0.744032, 2.644964>,
      < 8.891808, -0.749990, 2.688238>,
      < 8.938994, -0.770544, 2.690178>
    }
    triangle {
      < 8.900198, -0.744032, 2.644964>,
      < 8.938994, -0.770544, 2.690178>,
      < 8.947385, -0.763588, 2.644964>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.758994, -0.839533, 2.470015>,
      < 8.810135, -0.869616, 2.467286>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.810135, -0.869616, 2.467286>,
      < 8.710608, -0.924472, 2.425141>
    }
    triangle {
      < 8.891810, -0.749989, 2.601691>,
      < 8.900198, -0.744032, 2.644964>,
      < 8.947385, -0.763588, 2.644964>
    }
    triangle {
      < 8.891810, -0.749989, 2.601691>,
      < 8.947385, -0.763588, 2.644964>,
      < 8.938996, -0.770543, 2.599750>
    }
    triangle {
      < 8.863870, -0.768167, 2.557280>,
      < 8.891810, -0.749989, 2.601691>,
      < 8.938996, -0.770543, 2.599750>
    }
    triangle {
      < 8.863870, -0.768167, 2.557280>,
      < 8.938996, -0.770543, 2.599750>,
      < 8.911533, -0.791144, 2.554512>
    }
    triangle {
      < 8.820999, -0.798489, 2.512886>,
      < 8.863870, -0.768167, 2.557280>,
      < 8.911533, -0.791144, 2.554512>
    }
    triangle {
      < 8.820999, -0.798489, 2.512886>,
      < 8.911533, -0.791144, 2.554512>,
      < 8.870067, -0.824596, 2.510077>
    }
    triangle {
      < 8.758994, -0.839533, 2.470015>,
      < 8.820999, -0.798489, 2.512886>,
      < 8.870067, -0.824596, 2.510077>
    }
    triangle {
      < 8.758994, -0.839533, 2.470015>,
      < 8.870067, -0.824596, 2.510077>,
      < 8.810135, -0.869616, 2.467286>
    }
    triangle {
      < 8.710608, -0.924472, 2.864788>,
      < 8.810135, -0.869616, 2.822642>,
      < 8.758994, -0.839533, 2.819914>
    }
    triangle {
      < 8.710608, -0.924472, 2.864788>,
      < 8.758994, -0.839533, 2.819914>,
      < 8.646952, -0.889233, 2.865721>
    }
    triangle {
      < 8.797588, -0.614102, 2.484731>,
      < 8.824248, -0.614106, 2.525269>,
      < 8.782832, -0.750068, 2.501101>
    }
    triangle {
      < 8.797588, -0.614102, 2.484731>,
      < 8.782832, -0.750068, 2.501101>,
      < 8.717892, -0.792896, 2.455984>
    }
    triangle {
      < 8.824248, -0.614106, 2.525269>,
      < 8.839004, -0.614109, 2.564248>,
      < 8.829806, -0.718244, 2.548278>
    }
    triangle {
      < 8.824248, -0.614106, 2.525269>,
      < 8.829806, -0.718244, 2.548278>,
      < 8.782832, -0.750068, 2.501101>
    }
    triangle {
      < 8.839004, -0.614109, 2.564248>,
      < 8.845336, -0.614110, 2.603681>,
      < 8.858260, -0.698646, 2.596554>
    }
    triangle {
      < 8.839004, -0.614109, 2.564248>,
      < 8.858260, -0.698646, 2.596554>,
      < 8.829806, -0.718244, 2.548278>
    }
    triangle {
      < 8.860591, -0.614110, 2.642669>,
      < 8.882192, -0.692030, 2.644964>,
      < 8.877425, -0.695338, 2.620759>
    }
    triangle {
      < 8.860591, -0.614110, 2.642669>,
      < 8.877425, -0.695338, 2.620759>,
      < 8.860164, -0.614110, 2.623175>
    }
    triangle {
      < 8.860591, -0.614110, 2.642669>,
      < 8.857497, -0.614110, 2.661916>,
      < 8.877424, -0.695338, 2.669169>
    }
    triangle {
      < 8.860591, -0.614110, 2.642669>,
      < 8.877424, -0.695338, 2.669169>,
      < 8.882192, -0.692030, 2.644964>
    }
    triangle {
      < 8.840004, -0.614110, 2.681164>,
      < 8.828353, -0.614108, 2.718993>,
      < 8.829806, -0.718244, 2.741650>
    }
    triangle {
      < 8.840004, -0.614110, 2.681164>,
      < 8.829806, -0.718244, 2.741650>,
      < 8.858257, -0.698647, 2.693374>
    }
    triangle {
      < 8.828353, -0.614108, 2.718993>,
      < 8.808414, -0.614105, 2.755522>,
      < 8.782831, -0.750068, 2.788826>
    }
    triangle {
      < 8.828353, -0.614108, 2.718993>,
      < 8.782831, -0.750068, 2.788826>,
      < 8.829806, -0.718244, 2.741650>
    }
    triangle {
      < 8.808414, -0.614105, 2.755522>,
      < 8.774693, -0.614101, 2.793777>,
      < 8.717892, -0.792896, 2.833944>
    }
    triangle {
      < 8.808414, -0.614105, 2.755522>,
      < 8.717892, -0.792896, 2.833944>,
      < 8.782831, -0.750068, 2.788826>
    }
    triangle {
      < 8.782831, -0.750068, 2.788826>,
      < 8.717892, -0.792896, 2.833944>,
      < 8.758994, -0.839533, 2.819914>
    }
    triangle {
      < 8.782831, -0.750068, 2.788826>,
      < 8.758994, -0.839533, 2.819914>,
      < 8.820998, -0.798488, 2.777042>
    }
    triangle {
      < 8.829806, -0.718244, 2.741650>,
      < 8.782831, -0.750068, 2.788826>,
      < 8.820998, -0.798488, 2.777042>
    }
    triangle {
      < 8.829806, -0.718244, 2.741650>,
      < 8.820998, -0.798488, 2.777042>,
      < 8.863870, -0.768167, 2.732650>
    }
    triangle {
      < 8.858257, -0.698647, 2.693374>,
      < 8.829806, -0.718244, 2.741650>,
      < 8.863870, -0.768167, 2.732650>
    }
    triangle {
      < 8.858257, -0.698647, 2.693374>,
      < 8.863870, -0.768167, 2.732650>,
      < 8.891808, -0.749990, 2.688238>
    }
    triangle {
      < 8.882192, -0.692030, 2.644964>,
      < 8.877424, -0.695338, 2.669169>,
      < 8.900198, -0.744032, 2.644964>
    }
    triangle {
      < 8.882192, -0.692030, 2.644964>,
      < 8.900198, -0.744032, 2.644964>,
      < 8.877425, -0.695338, 2.620759>
    }
    triangle {
      < 8.829806, -0.718244, 2.548278>,
      < 8.858260, -0.698646, 2.596554>,
      < 8.891810, -0.749989, 2.601691>
    }
    triangle {
      < 8.829806, -0.718244, 2.548278>,
      < 8.891810, -0.749989, 2.601691>,
      < 8.863870, -0.768167, 2.557280>
    }
    triangle {
      < 8.782832, -0.750068, 2.501101>,
      < 8.829806, -0.718244, 2.548278>,
      < 8.863870, -0.768167, 2.557280>
    }
    triangle {
      < 8.782832, -0.750068, 2.501101>,
      < 8.863870, -0.768167, 2.557280>,
      < 8.820999, -0.798489, 2.512886>
    }
    triangle {
      < 8.717892, -0.792896, 2.455984>,
      < 8.782832, -0.750068, 2.501101>,
      < 8.820999, -0.798489, 2.512886>
    }
    triangle {
      < 8.717892, -0.792896, 2.455984>,
      < 8.820999, -0.798489, 2.512886>,
      < 8.758994, -0.839533, 2.470015>
    }
    triangle {
      < 8.858260, -0.698646, 2.596554>,
      < 8.845336, -0.614110, 2.603681>,
      < 8.860164, -0.614110, 2.623175>
    }
    triangle {
      < 8.858260, -0.698646, 2.596554>,
      < 8.860164, -0.614110, 2.623175>,
      < 8.877425, -0.695338, 2.620759>
    }
    triangle {
      < 8.891810, -0.749989, 2.601691>,
      < 8.858260, -0.698646, 2.596554>,
      < 8.877425, -0.695338, 2.620759>
    }
    triangle {
      < 8.891810, -0.749989, 2.601691>,
      < 8.877425, -0.695338, 2.620759>,
      < 8.900198, -0.744032, 2.644964>
    }
    triangle {
      < 8.858257, -0.698647, 2.693374>,
      < 8.891808, -0.749990, 2.688238>,
      < 8.900198, -0.744032, 2.644964>
    }
    triangle {
      < 8.858257, -0.698647, 2.693374>,
      < 8.900198, -0.744032, 2.644964>,
      < 8.877424, -0.695338, 2.669169>
    }
    triangle {
      < 8.840004, -0.614110, 2.681164>,
      < 8.858257, -0.698647, 2.693374>,
      < 8.877424, -0.695338, 2.669169>
    }
    triangle {
      < 8.840004, -0.614110, 2.681164>,
      < 8.877424, -0.695338, 2.669169>,
      < 8.857497, -0.614110, 2.661916>
    }
    triangle {
      < 8.710608, -0.924472, 2.425141>,
      < 8.649097, -0.944318, 2.417719>,
      < 8.651061, -0.887410, 2.425891>
    }
    triangle {
      < 8.710608, -0.924472, 2.864788>,
      < 8.646952, -0.889233, 2.865721>,
      < 8.555034, -0.908087, 2.884316>
    }
    triangle {
      < 8.710608, -0.924472, 2.864788>,
      < 8.555034, -0.908087, 2.884316>,
      < 8.518878, -0.977744, 2.897499>
    }
    triangle {
      < 8.646952, -0.889233, 2.865721>,
      < 8.580131, -0.859736, 2.875572>,
      < 8.555034, -0.908087, 2.884316>
    }
    triangle {
      < 8.646952, -0.889233, 2.865721>,
      < 8.758994, -0.839533, 2.819914>,
      < 8.717892, -0.792896, 2.833944>
    }
    triangle {
      < 8.646952, -0.889233, 2.865721>,
      < 8.717892, -0.792896, 2.833944>,
      < 8.595420, -0.830281, 2.867272>
    }
    triangle {
      < 8.646952, -0.889233, 2.865721>,
      < 8.595420, -0.830281, 2.867272>,
      < 8.580131, -0.859736, 2.875572>
    }
    triangle {
      < 8.758994, -0.839533, 2.470015>,
      < 8.651061, -0.887410, 2.425891>,
      < 8.717892, -0.792896, 2.455984>
    }
    triangle {
      < 8.717892, -0.792896, 2.833944>,
      < 8.774693, -0.614101, 2.793777>,
      < 8.707627, -0.614107, 2.823626>
    }
    triangle {
      < 8.717892, -0.792896, 2.833944>,
      < 8.707627, -0.614107, 2.823626>,
      < 8.595420, -0.830281, 2.867272>
    }
    triangle {
      < 8.857497, -0.614110, 2.661916>,
      < 8.860591, -0.614110, 2.642669>,
      < 8.860164, -0.614110, 2.623175>
    }
    triangle {
      < 8.857497, -0.614110, 2.661916>,
      < 8.860164, -0.614110, 2.623175>,
      < 8.845336, -0.614110, 2.603681>
    }
    triangle {
      < 8.857497, -0.614110, 2.661916>,
      < 8.845336, -0.614110, 2.603681>,
      < 8.840004, -0.614110, 2.681164>
    }
    triangle {
      < 8.751030, -0.614104, 2.469737>,
      < 8.797588, -0.614102, 2.484731>,
      < 8.717892, -0.792896, 2.455984>
    }
    triangle {
      < 8.751030, -0.614104, 2.469737>,
      < 8.717892, -0.792896, 2.455984>,
      < 8.679832, -0.804513, 2.445628>
    }
    triangle {
      < 8.646121, -0.987057, 2.401382>,
      < 8.649097, -0.944318, 2.417719>,
      < 8.710608, -0.924472, 2.425141>
    }
    triangle {
      < 8.646121, -0.987057, 2.401382>,
      < 8.710608, -0.924472, 2.425141>,
      < 8.960067, -0.925376, 2.456316>
    }
    triangle {
      < 8.646121, -0.987057, 2.401382>,
      < 8.960067, -0.925376, 2.456316>,
      < 8.960083, -0.986465, 2.435430>
    }
    triangle {
      < 8.710608, -0.924472, 2.864788>,
      < 8.518878, -0.977744, 2.897499>,
      < 8.512607, -0.987057, 2.904079>
    }
    triangle {
      < 8.710608, -0.924472, 2.864788>,
      < 8.512607, -0.987057, 2.904079>,
      < 8.960083, -0.986467, 2.854493>
    }
    triangle {
      < 8.710608, -0.924472, 2.864788>,
      < 8.960083, -0.986467, 2.854493>,
      < 8.960067, -0.925377, 2.833609>
    }
    triangle {
      < 8.467582, -1.076569, 2.737815>,
      < 8.469930, -1.072046, 2.644964>,
      < 8.959966, -1.072025, 2.644964>
    }
    triangle {
      < 8.467582, -1.076569, 2.737815>,
      < 8.959966, -1.072025, 2.644964>,
      < 8.959940, -1.076448, 2.718238>
    }
    triangle {
      < 8.469930, -1.072046, 2.644964>,
      < 8.467582, -1.076569, 2.552113>,
      < 8.959940, -1.076448, 2.571689>
    }
    triangle {
      < 8.469930, -1.072046, 2.644964>,
      < 8.959940, -1.076448, 2.571689>,
      < 8.959966, -1.072025, 2.644964>
    }
    triangle {
      < 8.444201, -1.121615, 2.926036>,
      < 8.459005, -1.093092, 2.830714>,
      < 8.959952, -1.092693, 2.791599>
    }
    triangle {
      < 8.444201, -1.121615, 2.926036>,
      < 8.959952, -1.092693, 2.791599>,
      < 8.959700, -1.122828, 2.870239>
    }
    triangle {
      < 8.459005, -1.093092, 2.830714>,
      < 8.467582, -1.076569, 2.737815>,
      < 8.959940, -1.076448, 2.718238>
    }
    triangle {
      < 8.459005, -1.093092, 2.830714>,
      < 8.959940, -1.076448, 2.718238>,
      < 8.959952, -1.092693, 2.791599>
    }
    triangle {
      < 8.467582, -1.076569, 2.552113>,
      < 8.459005, -1.093092, 2.459214>,
      < 8.959952, -1.092699, 2.498330>
    }
    triangle {
      < 8.467582, -1.076569, 2.552113>,
      < 8.959952, -1.092699, 2.498330>,
      < 8.959940, -1.076448, 2.571689>
    }
    triangle {
      < 8.459005, -1.093092, 2.459214>,
      < 8.644594, -1.121615, 2.386132>,
      < 8.959701, -1.122852, 2.419671>
    }
    triangle {
      < 8.459005, -1.093092, 2.459214>,
      < 8.959701, -1.122852, 2.419671>,
      < 8.959952, -1.092699, 2.498330>
    }
    triangle {
      < 8.479073, -1.053018, 2.920353>,
      < 8.444201, -1.121615, 2.926036>,
      < 8.959700, -1.122828, 2.870239>
    }
    triangle {
      < 8.479073, -1.053018, 2.920353>,
      < 8.959700, -1.122828, 2.870239>,
      < 8.960089, -1.052727, 2.867323>
    }
    triangle {
      < 8.512607, -0.987057, 2.904079>,
      < 8.479073, -1.053018, 2.920353>,
      < 8.960089, -1.052727, 2.867323>
    }
    triangle {
      < 8.512607, -0.987057, 2.904079>,
      < 8.960089, -1.052727, 2.867323>,
      < 8.960083, -0.986467, 2.854493>
    }
    triangle {
      < 8.643591, -1.053018, 2.388639>,
      < 8.646121, -0.987057, 2.401382>,
      < 8.960083, -0.986465, 2.435430>
    }
    triangle {
      < 8.643591, -1.053018, 2.388639>,
      < 8.960083, -0.986465, 2.435430>,
      < 8.960090, -1.052727, 2.422608>
    }
    triangle {
      < 8.644594, -1.121615, 2.386132>,
      < 8.643591, -1.053018, 2.388639>,
      < 8.960090, -1.052727, 2.422608>
    }
    triangle {
      < 8.644594, -1.121615, 2.386132>,
      < 8.960090, -1.052727, 2.422608>,
      < 8.959701, -1.122852, 2.419671>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.649097, -0.944318, 2.417719>,
      < 8.646121, -0.987057, 2.401382>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.646121, -0.987057, 2.401382>,
      < 8.643591, -1.053018, 2.388639>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.643591, -1.053018, 2.388639>,
      < 8.644594, -1.121615, 2.386132>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.644594, -1.121615, 2.386132>,
      < 8.459005, -1.093092, 2.459214>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.459005, -1.093092, 2.459214>,
      < 8.467582, -1.076569, 2.552113>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.467582, -1.076569, 2.552113>,
      < 8.469930, -1.072046, 2.644964>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.469930, -1.072046, 2.644964>,
      < 8.467582, -1.076569, 2.737815>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.467582, -1.076569, 2.737815>,
      < 8.459005, -1.093092, 2.830714>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.459005, -1.093092, 2.830714>,
      < 8.444201, -1.121615, 2.926036>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.444201, -1.121615, 2.926036>,
      < 8.479073, -1.053018, 2.920353>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.479073, -1.053018, 2.920353>,
      < 8.512607, -0.987057, 2.904079>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.512607, -0.987057, 2.904079>,
      < 8.518878, -0.977744, 2.897499>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.518878, -0.977744, 2.897499>,
      < 8.555034, -0.908087, 2.884316>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.555034, -0.908087, 2.884316>,
      < 8.580131, -0.859736, 2.875572>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.580131, -0.859736, 2.875572>,
      < 8.595420, -0.830281, 2.867272>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.595420, -0.830281, 2.867272>,
      < 8.707627, -0.614107, 2.823626>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.707627, -0.614107, 2.823626>,
      < 8.751030, -0.614104, 2.469737>
    }
    triangle {
      < 8.651061, -0.887410, 2.425891>,
      < 8.751030, -0.614104, 2.469737>,
      < 8.679832, -0.804513, 2.445628>
    }
    triangle {
      < 8.679832, -0.804513, 2.445628>,
      < 8.717892, -0.792896, 2.455984>,
      < 8.651061, -0.887410, 2.425891>
    }
    triangle {
      < 8.797588, -0.614102, 2.484731>,
      < 8.774693, -0.614101, 2.793777>,
      < 8.808414, -0.614105, 2.755522>
    }
    triangle {
      < 8.797588, -0.614102, 2.484731>,
      < 8.808414, -0.614105, 2.755522>,
      < 8.824248, -0.614106, 2.525269>
    }
    triangle {
      < 8.828353, -0.614108, 2.718993>,
      < 8.840004, -0.614110, 2.681164>,
      < 8.845336, -0.614110, 2.603681>
    }
    triangle {
      < 8.828353, -0.614108, 2.718993>,
      < 8.845336, -0.614110, 2.603681>,
      < 8.839004, -0.614109, 2.564248>
    }
    triangle {
      < 8.828353, -0.614108, 2.718993>,
      < 8.839004, -0.614109, 2.564248>,
      < 8.824248, -0.614106, 2.525269>
    }
    triangle {
      < 8.828353, -0.614108, 2.718993>,
      < 8.824248, -0.614106, 2.525269>,
      < 8.808414, -0.614105, 2.755522>
    }
    triangle {
      < 8.751030, -0.614104, 2.469737>,
      < 8.707627, -0.614107, 2.823626>,
      < 8.774693, -0.614101, 2.793777>
    }
    triangle {
      < 8.751030, -0.614104, 2.469737>,
      < 8.774693, -0.614101, 2.793777>,
      < 8.797588, -0.614102, 2.484731>
    }
    triangle {
      < 8.965602, -1.083502, 2.794408>,
      < 8.980003, -1.093092, 2.791477>,
      < 8.980003, -1.076569, 2.718220>
    }
    triangle {
      < 8.965602, -1.083502, 2.794408>,
      < 8.980003, -1.076569, 2.718220>,
      < 8.965602, -1.066637, 2.719638>
    }
    triangle {
      < 8.980003, -1.093092, 2.791477>,
      < 8.959952, -1.092693, 2.791599>,
      < 8.959940, -1.076448, 2.718238>
    }
    triangle {
      < 8.980003, -1.093092, 2.791477>,
      < 8.959940, -1.076448, 2.718238>,
      < 8.980003, -1.076569, 2.718220>
    }
    triangle {
      < 8.965602, -1.106616, 2.853772>,
      < 8.980003, -1.121615, 2.864734>,
      < 8.980003, -1.093092, 2.791477>
    }
    triangle {
      < 8.965602, -1.106616, 2.853772>,
      < 8.980003, -1.093092, 2.791477>,
      < 8.965602, -1.083502, 2.794408>
    }
    triangle {
      < 8.980003, -1.121615, 2.864734>,
      < 8.959700, -1.122828, 2.870239>,
      < 8.959952, -1.092693, 2.791599>
    }
    triangle {
      < 8.980003, -1.121615, 2.864734>,
      < 8.959952, -1.092693, 2.791599>,
      < 8.980003, -1.093092, 2.791477>
    }
    triangle {
      < 8.965602, -1.055699, 2.850575>,
      < 8.980003, -1.054430, 2.860515>,
      < 8.980003, -1.121615, 2.864734>
    }
    triangle {
      < 8.965602, -1.055699, 2.850575>,
      < 8.980003, -1.121615, 2.864734>,
      < 8.965602, -1.106616, 2.853772>
    }
    triangle {
      < 8.980003, -1.054430, 2.860515>,
      < 8.960089, -1.052727, 2.867323>,
      < 8.959700, -1.122828, 2.870239>
    }
    triangle {
      < 8.980003, -1.054430, 2.860515>,
      < 8.959700, -1.122828, 2.870239>,
      < 8.980003, -1.121615, 2.864734>
    }
    triangle {
      < 8.965602, -0.992403, 2.838320>,
      < 8.980003, -0.989826, 2.848006>,
      < 8.980003, -1.054430, 2.860515>
    }
    triangle {
      < 8.965602, -0.992403, 2.838320>,
      < 8.980003, -1.054430, 2.860515>,
      < 8.965602, -1.055699, 2.850575>
    }
    triangle {
      < 8.980003, -0.989826, 2.848006>,
      < 8.960083, -0.986467, 2.854493>,
      < 8.960089, -1.052727, 2.867323>
    }
    triangle {
      < 8.980003, -0.989826, 2.848006>,
      < 8.960089, -1.052727, 2.867323>,
      < 8.980003, -1.054430, 2.860515>
    }
    triangle {
      < 8.965602, -0.934245, 2.818481>,
      < 8.980003, -0.930287, 2.827697>,
      < 8.980003, -0.989826, 2.848006>
    }
    triangle {
      < 8.965602, -0.934245, 2.818481>,
      < 8.980003, -0.989826, 2.848006>,
      < 8.965602, -0.992403, 2.838320>
    }
    triangle {
      < 8.980003, -0.930287, 2.827697>,
      < 8.960067, -0.925377, 2.833609>,
      < 8.960083, -0.986467, 2.854493>
    }
    triangle {
      < 8.980003, -0.930287, 2.827697>,
      < 8.960083, -0.986467, 2.854493>,
      < 8.980003, -0.989826, 2.848006>
    }
    triangle {
      < 8.965602, -0.883534, 2.791922>,
      < 8.980003, -0.878102, 2.800366>,
      < 8.980003, -0.930287, 2.827697>
    }
    triangle {
      < 8.965602, -0.883534, 2.791922>,
      < 8.980003, -0.930287, 2.827697>,
      < 8.965602, -0.934245, 2.818481>
    }
    triangle {
      < 8.980003, -0.878102, 2.800366>,
      < 8.960031, -0.871843, 2.805406>,
      < 8.960067, -0.925377, 2.833609>
    }
    triangle {
      < 8.980003, -0.878102, 2.800366>,
      < 8.960067, -0.925377, 2.833609>,
      < 8.980003, -0.930287, 2.827697>
    }
    triangle {
      < 8.965602, -0.842255, 2.759822>,
      < 8.980003, -0.835274, 2.767061>,
      < 8.980003, -0.878102, 2.800366>
    }
    triangle {
      < 8.965602, -0.842255, 2.759822>,
      < 8.980003, -0.878102, 2.800366>,
      < 8.965602, -0.883534, 2.791922>
    }
    triangle {
      < 8.980003, -0.835274, 2.767061>,
      < 8.959985, -0.827876, 2.771059>,
      < 8.960031, -0.871843, 2.805406>
    }
    triangle {
      < 8.980003, -0.835274, 2.767061>,
      < 8.960031, -0.871843, 2.805406>,
      < 8.980003, -0.878102, 2.800366>
    }
    triangle {
      < 8.965602, -0.811934, 2.723623>,
      < 8.980003, -0.803450, 2.729068>,
      < 8.980003, -0.835274, 2.767061>
    }
    triangle {
      < 8.965602, -0.811934, 2.723623>,
      < 8.980003, -0.835274, 2.767061>,
      < 8.965602, -0.842255, 2.759822>
    }
    triangle {
      < 8.980003, -0.803450, 2.729068>,
      < 8.959958, -0.794904, 2.732029>,
      < 8.959985, -0.827876, 2.771059>
    }
    triangle {
      < 8.980003, -0.803450, 2.729068>,
      < 8.959985, -0.827876, 2.771059>,
      < 8.980003, -0.835274, 2.767061>
    }
    triangle {
      < 8.965602, -0.793512, 2.684868>,
      < 8.980003, -0.783853, 2.687839>,
      < 8.980003, -0.803450, 2.729068>
    }
    triangle {
      < 8.965602, -0.793512, 2.684868>,
      < 8.980003, -0.803450, 2.729068>,
      < 8.965602, -0.811934, 2.723623>
    }
    triangle {
      < 8.980003, -0.783853, 2.687839>,
      < 8.961579, -0.774074, 2.689483>,
      < 8.959958, -0.794904, 2.732029>
    }
    triangle {
      < 8.980003, -0.783853, 2.687839>,
      < 8.959958, -0.794904, 2.732029>,
      < 8.980003, -0.803450, 2.729068>
    }
    triangle {
      < 8.965602, -0.787354, 2.644964>,
      < 8.980003, -0.777236, 2.644964>,
      < 8.980003, -0.783853, 2.687839>
    }
    triangle {
      < 8.965602, -0.787354, 2.644964>,
      < 8.980003, -0.783853, 2.687839>,
      < 8.965602, -0.793512, 2.684868>
    }
    triangle {
      < 8.980003, -0.777236, 2.644964>,
      < 8.962034, -0.766628, 2.644964>,
      < 8.961579, -0.774074, 2.689483>
    }
    triangle {
      < 8.980003, -0.777236, 2.644964>,
      < 8.961579, -0.774074, 2.689483>,
      < 8.980003, -0.783853, 2.687839>
    }
    triangle {
      < 8.941601, -0.797472, 2.644964>,
      < 8.941601, -0.803172, 2.608031>,
      < 8.965602, -0.793512, 2.605060>
    }
    triangle {
      < 8.941601, -0.797472, 2.644964>,
      < 8.965602, -0.793512, 2.605060>,
      < 8.965602, -0.787354, 2.644964>
    }
    triangle {
      < 8.980003, -0.783852, 2.602088>,
      < 8.961579, -0.774073, 2.600444>,
      < 8.962034, -0.766628, 2.644964>
    }
    triangle {
      < 8.980003, -0.783852, 2.602088>,
      < 8.962034, -0.766628, 2.644964>,
      < 8.980003, -0.777236, 2.644964>
    }
    triangle {
      < 8.965602, -0.811934, 2.566304>,
      < 8.980003, -0.803450, 2.560860>,
      < 8.980003, -0.783852, 2.602088>
    }
    triangle {
      < 8.965602, -0.811934, 2.566304>,
      < 8.980003, -0.783852, 2.602088>,
      < 8.965602, -0.793512, 2.605060>
    }
    triangle {
      < 8.980003, -0.803450, 2.560860>,
      < 8.959958, -0.794904, 2.557899>,
      < 8.961579, -0.774073, 2.600444>
    }
    triangle {
      < 8.980003, -0.803450, 2.560860>,
      < 8.961579, -0.774073, 2.600444>,
      < 8.980003, -0.783852, 2.602088>
    }
    triangle {
      < 8.965602, -0.842255, 2.530104>,
      < 8.980003, -0.835274, 2.522865>,
      < 8.980003, -0.803450, 2.560860>
    }
    triangle {
      < 8.965602, -0.842255, 2.530104>,
      < 8.980003, -0.803450, 2.560860>,
      < 8.965602, -0.811934, 2.566304>
    }
    triangle {
      < 8.980003, -0.835274, 2.522865>,
      < 8.959985, -0.827876, 2.518867>,
      < 8.959958, -0.794904, 2.557899>
    }
    triangle {
      < 8.980003, -0.835274, 2.522865>,
      < 8.959958, -0.794904, 2.557899>,
      < 8.980003, -0.803450, 2.560860>
    }
    triangle {
      < 8.965602, -0.883534, 2.498005>,
      < 8.980003, -0.878102, 2.489562>,
      < 8.980003, -0.835274, 2.522865>
    }
    triangle {
      < 8.965602, -0.883534, 2.498005>,
      < 8.980003, -0.835274, 2.522865>,
      < 8.965602, -0.842255, 2.530104>
    }
    triangle {
      < 8.980003, -0.878102, 2.489562>,
      < 8.960031, -0.871843, 2.484521>,
      < 8.959985, -0.827876, 2.518867>
    }
    triangle {
      < 8.980003, -0.878102, 2.489562>,
      < 8.959985, -0.827876, 2.518867>,
      < 8.980003, -0.835274, 2.522865>
    }
    triangle {
      < 8.965602, -0.934245, 2.471447>,
      < 8.980003, -0.930287, 2.462231>,
      < 8.980003, -0.878102, 2.489562>
    }
    triangle {
      < 8.965602, -0.934245, 2.471447>,
      < 8.980003, -0.878102, 2.489562>,
      < 8.965602, -0.883534, 2.498005>
    }
    triangle {
      < 8.980003, -0.930287, 2.462231>,
      < 8.960067, -0.925376, 2.456316>,
      < 8.960031, -0.871843, 2.484521>
    }
    triangle {
      < 8.980003, -0.930287, 2.462231>,
      < 8.960031, -0.871843, 2.484521>,
      < 8.980003, -0.878102, 2.489562>
    }
    triangle {
      < 8.965602, -0.992403, 2.451608>,
      < 8.980003, -0.989826, 2.441921>,
      < 8.980003, -0.930287, 2.462231>
    }
    triangle {
      < 8.965602, -0.992403, 2.451608>,
      < 8.980003, -0.930287, 2.462231>,
      < 8.965602, -0.934245, 2.471447>
    }
    triangle {
      < 8.980003, -0.989826, 2.441921>,
      < 8.960083, -0.986465, 2.435430>,
      < 8.960067, -0.925376, 2.456316>
    }
    triangle {
      < 8.980003, -0.989826, 2.441921>,
      < 8.960067, -0.925376, 2.456316>,
      < 8.980003, -0.930287, 2.462231>
    }
    triangle {
      < 8.965602, -1.055699, 2.439355>,
      < 8.980003, -1.054430, 2.429415>,
      < 8.980003, -0.989826, 2.441921>
    }
    triangle {
      < 8.965602, -1.055699, 2.439355>,
      < 8.980003, -0.989826, 2.441921>,
      < 8.965602, -0.992403, 2.451608>
    }
    triangle {
      < 8.980003, -1.054430, 2.429415>,
      < 8.960090, -1.052727, 2.422608>,
      < 8.960083, -0.986465, 2.435430>
    }
    triangle {
      < 8.980003, -1.054430, 2.429415>,
      < 8.960083, -0.986465, 2.435430>,
      < 8.980003, -0.989826, 2.441921>
    }
    triangle {
      < 8.965602, -1.106615, 2.436155>,
      < 8.980003, -1.121615, 2.425193>,
      < 8.980003, -1.054430, 2.429415>
    }
    triangle {
      < 8.965602, -1.106615, 2.436155>,
      < 8.980003, -1.054430, 2.429415>,
      < 8.965602, -1.055699, 2.439355>
    }
    triangle {
      < 8.980003, -1.121615, 2.425193>,
      < 8.959701, -1.122852, 2.419671>,
      < 8.960090, -1.052727, 2.422608>
    }
    triangle {
      < 8.980003, -1.121615, 2.425193>,
      < 8.960090, -1.052727, 2.422608>,
      < 8.980003, -1.054430, 2.429415>
    }
    triangle {
      < 8.965602, -1.083502, 2.495519>,
      < 8.980003, -1.093092, 2.498450>,
      < 8.980003, -1.121615, 2.425193>
    }
    triangle {
      < 8.965602, -1.083502, 2.495519>,
      < 8.980003, -1.121615, 2.425193>,
      < 8.965602, -1.106615, 2.436155>
    }
    triangle {
      < 8.980003, -1.093092, 2.498450>,
      < 8.959952, -1.092699, 2.498330>,
      < 8.959701, -1.122852, 2.419671>
    }
    triangle {
      < 8.980003, -1.093092, 2.498450>,
      < 8.959701, -1.122852, 2.419671>,
      < 8.980003, -1.121615, 2.425193>
    }
    triangle {
      < 8.965602, -1.066637, 2.570289>,
      < 8.980003, -1.076569, 2.571707>,
      < 8.980003, -1.093092, 2.498450>
    }
    triangle {
      < 8.965602, -1.066637, 2.570289>,
      < 8.980003, -1.093092, 2.498450>,
      < 8.965602, -1.083502, 2.495519>
    }
    triangle {
      < 8.980003, -1.076569, 2.571707>,
      < 8.959940, -1.076448, 2.571689>,
      < 8.959952, -1.092699, 2.498330>
    }
    triangle {
      < 8.980003, -1.076569, 2.571707>,
      < 8.959952, -1.092699, 2.498330>,
      < 8.980003, -1.093092, 2.498450>
    }
    triangle {
      < 8.965602, -1.062027, 2.644964>,
      < 8.980003, -1.072046, 2.644964>,
      < 8.980003, -1.076569, 2.571707>
    }
    triangle {
      < 8.965602, -1.062027, 2.644964>,
      < 8.980003, -1.076569, 2.571707>,
      < 8.965602, -1.066637, 2.570289>
    }
    triangle {
      < 8.980003, -1.072046, 2.644964>,
      < 8.959966, -1.072025, 2.644964>,
      < 8.959940, -1.076448, 2.571689>
    }
    triangle {
      < 8.980003, -1.072046, 2.644964>,
      < 8.959940, -1.076448, 2.571689>,
      < 8.980003, -1.076569, 2.571707>
    }
    triangle {
      < 8.965602, -1.066637, 2.719638>,
      < 8.980003, -1.076569, 2.718220>,
      < 8.980003, -1.072046, 2.644964>
    }
    triangle {
      < 8.965602, -1.066637, 2.719638>,
      < 8.980003, -1.072046, 2.644964>,
      < 8.965602, -1.062027, 2.644964>
    }
    triangle {
      < 8.980003, -1.076569, 2.718220>,
      < 8.959940, -1.076448, 2.718238>,
      < 8.959966, -1.072025, 2.644964>
    }
    triangle {
      < 8.980003, -1.076569, 2.718220>,
      < 8.959966, -1.072025, 2.644964>,
      < 8.980003, -1.072046, 2.644964>
    }
    triangle {
      < 8.941601, -0.803172, 2.681896>,
      < 8.941601, -0.797472, 2.644964>,
      < 8.965602, -0.787354, 2.644964>
    }
    triangle {
      < 8.941601, -0.803172, 2.681896>,
      < 8.965602, -0.787354, 2.644964>,
      < 8.965602, -0.793512, 2.684868>
    }
    triangle {
      < 8.941601, -0.820418, 2.718179>,
      < 8.941601, -0.803172, 2.681896>,
      < 8.965602, -0.793512, 2.684868>
    }
    triangle {
      < 8.941601, -0.820418, 2.718179>,
      < 8.965602, -0.793512, 2.684868>,
      < 8.965602, -0.811934, 2.723623>
    }
    triangle {
      < 8.941601, -0.849236, 2.752583>,
      < 8.941601, -0.820418, 2.718179>,
      < 8.965602, -0.811934, 2.723623>
    }
    triangle {
      < 8.941601, -0.849236, 2.752583>,
      < 8.965602, -0.811934, 2.723623>,
      < 8.965602, -0.842255, 2.759822>
    }
    triangle {
      < 8.941601, -0.888966, 2.783479>,
      < 8.941601, -0.849236, 2.752583>,
      < 8.965602, -0.842255, 2.759822>
    }
    triangle {
      < 8.941601, -0.888966, 2.783479>,
      < 8.965602, -0.842255, 2.759822>,
      < 8.965602, -0.883534, 2.791922>
    }
    triangle {
      < 8.941601, -0.938202, 2.809265>,
      < 8.941601, -0.888966, 2.783479>,
      < 8.965602, -0.883534, 2.791922>
    }
    triangle {
      < 8.941601, -0.938202, 2.809265>,
      < 8.965602, -0.883534, 2.791922>,
      < 8.965602, -0.934245, 2.818481>
    }
    triangle {
      < 8.941601, -0.994980, 2.828633>,
      < 8.941601, -0.938202, 2.809265>,
      < 8.965602, -0.934245, 2.818481>
    }
    triangle {
      < 8.941601, -0.994980, 2.828633>,
      < 8.965602, -0.934245, 2.818481>,
      < 8.965602, -0.992403, 2.838320>
    }
    triangle {
      < 8.941601, -1.056968, 2.840635>,
      < 8.941601, -0.994980, 2.828633>,
      < 8.965602, -0.992403, 2.838320>
    }
    triangle {
      < 8.941601, -1.056968, 2.840635>,
      < 8.965602, -0.992403, 2.838320>,
      < 8.965602, -1.055699, 2.850575>
    }
    triangle {
      < 8.941601, -1.091616, 2.842811>,
      < 8.941601, -1.056968, 2.840635>,
      < 8.965602, -1.055699, 2.850575>
    }
    triangle {
      < 8.941601, -1.091616, 2.842811>,
      < 8.965602, -1.055699, 2.850575>,
      < 8.965602, -1.106616, 2.853772>
    }
    triangle {
      < 8.941601, -1.073912, 2.797338>,
      < 8.941601, -1.091616, 2.842811>,
      < 8.965602, -1.106616, 2.853772>
    }
    triangle {
      < 8.941601, -1.073912, 2.797338>,
      < 8.965602, -1.106616, 2.853772>,
      < 8.965602, -1.083502, 2.794408>
    }
    triangle {
      < 8.941601, -1.056706, 2.721055>,
      < 8.941601, -1.073912, 2.797338>,
      < 8.965602, -1.083502, 2.794408>
    }
    triangle {
      < 8.941601, -1.056706, 2.721055>,
      < 8.965602, -1.083502, 2.794408>,
      < 8.965602, -1.066637, 2.719638>
    }
    triangle {
      < 8.941601, -1.052008, 2.644964>,
      < 8.941601, -1.056706, 2.721055>,
      < 8.965602, -1.066637, 2.719638>
    }
    triangle {
      < 8.941601, -1.052008, 2.644964>,
      < 8.965602, -1.066637, 2.719638>,
      < 8.965602, -1.062027, 2.644964>
    }
    triangle {
      < 8.941601, -1.056706, 2.568872>,
      < 8.941601, -1.052008, 2.644964>,
      < 8.965602, -1.062027, 2.644964>
    }
    triangle {
      < 8.941601, -1.056706, 2.568872>,
      < 8.965602, -1.062027, 2.644964>,
      < 8.965602, -1.066637, 2.570289>
    }
    triangle {
      < 8.941601, -1.073912, 2.492589>,
      < 8.941601, -1.056706, 2.568872>,
      < 8.965602, -1.066637, 2.570289>
    }
    triangle {
      < 8.941601, -1.073912, 2.492589>,
      < 8.965602, -1.066637, 2.570289>,
      < 8.965602, -1.083502, 2.495519>
    }
    triangle {
      < 8.941601, -1.091616, 2.447118>,
      < 8.941601, -1.073912, 2.492589>,
      < 8.965602, -1.083502, 2.495519>
    }
    triangle {
      < 8.941601, -1.091616, 2.447118>,
      < 8.965602, -1.083502, 2.495519>,
      < 8.965602, -1.106615, 2.436155>
    }
    triangle {
      < 8.941601, -1.056968, 2.449295>,
      < 8.941601, -1.091616, 2.447118>,
      < 8.965602, -1.106615, 2.436155>
    }
    triangle {
      < 8.941601, -1.056968, 2.449295>,
      < 8.965602, -1.106615, 2.436155>,
      < 8.965602, -1.055699, 2.439355>
    }
    triangle {
      < 8.941601, -0.994980, 2.461295>,
      < 8.941601, -1.056968, 2.449295>,
      < 8.965602, -1.055699, 2.439355>
    }
    triangle {
      < 8.941601, -0.994980, 2.461295>,
      < 8.965602, -1.055699, 2.439355>,
      < 8.965602, -0.992403, 2.451608>
    }
    triangle {
      < 8.941601, -0.938202, 2.480663>,
      < 8.941601, -0.994980, 2.461295>,
      < 8.965602, -0.992403, 2.451608>
    }
    triangle {
      < 8.941601, -0.938202, 2.480663>,
      < 8.965602, -0.992403, 2.451608>,
      < 8.965602, -0.934245, 2.471447>
    }
    triangle {
      < 8.941601, -0.888966, 2.506449>,
      < 8.941601, -0.938202, 2.480663>,
      < 8.965602, -0.934245, 2.471447>
    }
    triangle {
      < 8.941601, -0.888966, 2.506449>,
      < 8.965602, -0.934245, 2.471447>,
      < 8.965602, -0.883534, 2.498005>
    }
    triangle {
      < 8.941601, -0.849236, 2.537343>,
      < 8.941601, -0.888966, 2.506449>,
      < 8.965602, -0.883534, 2.498005>
    }
    triangle {
      < 8.941601, -0.849236, 2.537343>,
      < 8.965602, -0.883534, 2.498005>,
      < 8.965602, -0.842255, 2.530104>
    }
    triangle {
      < 8.941601, -0.820418, 2.571748>,
      < 8.941601, -0.849236, 2.537343>,
      < 8.965602, -0.842255, 2.530104>
    }
    triangle {
      < 8.941601, -0.820418, 2.571748>,
      < 8.965602, -0.842255, 2.530104>,
      < 8.965602, -0.811934, 2.566304>
    }
    triangle {
      < 8.941601, -0.803172, 2.608031>,
      < 8.941601, -0.820418, 2.571748>,
      < 8.965602, -0.811934, 2.566304>
    }
    triangle {
      < 8.941601, -0.803172, 2.608031>,
      < 8.965602, -0.811934, 2.566304>,
      < 8.965602, -0.793512, 2.605060>
    }
    triangle {
      < 8.980003, -0.783852, 2.602088>,
      < 8.980003, -0.777236, 2.644964>,
      < 8.965602, -0.787354, 2.644964>
    }
    triangle {
      < 8.980003, -0.783852, 2.602088>,
      < 8.965602, -0.787354, 2.644964>,
      < 8.965602, -0.793512, 2.605060>
    }
    triangle {
      < 9.315598, -1.157051, 2.708993>,
      < 9.379009, -1.182890, 2.702599>,
      < 9.380916, -1.178265, 2.644820>
    }
    triangle {
      < 9.315598, -1.157051, 2.708993>,
      < 9.380916, -1.178265, 2.644820>,
      < 9.315598, -1.150710, 2.644820>
    }
    triangle {
      < 9.315598, -1.175642, 2.768791>,
      < 9.373309, -1.196726, 2.757550>,
      < 9.379009, -1.182890, 2.702599>
    }
    triangle {
      < 9.315598, -1.175642, 2.768791>,
      < 9.379009, -1.182890, 2.702599>,
      < 9.315598, -1.157051, 2.708993>
    }
    triangle {
      < 9.315598, -1.205215, 2.820142>,
      < 9.363877, -1.219617, 2.806843>,
      < 9.373309, -1.196726, 2.757550>
    }
    triangle {
      < 9.315598, -1.205215, 2.820142>,
      < 9.373309, -1.196726, 2.757550>,
      < 9.315598, -1.175642, 2.768791>
    }
    triangle {
      < 9.315598, -1.243755, 2.859545>,
      < 9.350867, -1.251195, 2.847646>,
      < 9.363877, -1.219617, 2.806843>
    }
    triangle {
      < 9.315598, -1.243755, 2.859545>,
      < 9.363877, -1.219617, 2.806843>,
      < 9.315598, -1.205215, 2.820142>
    }
    triangle {
      < 9.315598, -1.288637, 2.884313>,
      < 9.334587, -1.290710, 2.877168>,
      < 9.350867, -1.251195, 2.847646>
    }
    triangle {
      < 9.315598, -1.288637, 2.884313>,
      < 9.350867, -1.251195, 2.847646>,
      < 9.315598, -1.243755, 2.859545>
    }
    triangle {
      < 9.315598, -1.336800, 2.892762>,
      < 9.334587, -1.290710, 2.877168>,
      < 9.315598, -1.288637, 2.884313>
    }
    triangle {
      < 9.219997, -1.281780, 2.905086>,
      < 9.219997, -1.336800, 2.914267>,
      < 9.315598, -1.336800, 2.892762>
    }
    triangle {
      < 9.219997, -1.281780, 2.905086>,
      < 9.315598, -1.336800, 2.892762>,
      < 9.315598, -1.288637, 2.884313>
    }
    triangle {
      < 9.219997, -1.336800, 2.914267>,
      < 9.219997, -1.391820, 2.905086>,
      < 9.309299, -1.384550, 2.884313>
    }
    triangle {
      < 9.219997, -1.336800, 2.914267>,
      < 9.309299, -1.384550, 2.884313>,
      < 9.315598, -1.336800, 2.892762>
    }
    triangle {
      < 9.219997, -1.391820, 2.905086>,
      < 9.219997, -1.443090, 2.878169>,
      < 9.303433, -1.429047, 2.859545>
    }
    triangle {
      < 9.219997, -1.391820, 2.905086>,
      < 9.303433, -1.429047, 2.859545>,
      < 9.309299, -1.384550, 2.884313>
    }
    triangle {
      < 9.219997, -1.443090, 2.878169>,
      < 9.219997, -1.487116, 2.835349>,
      < 9.298392, -1.467256, 2.820142>
    }
    triangle {
      < 9.219997, -1.443090, 2.878169>,
      < 9.298392, -1.467256, 2.820142>,
      < 9.303433, -1.429047, 2.859545>
    }
    triangle {
      < 9.219997, -1.487116, 2.835349>,
      < 9.219997, -1.520899, 2.779544>,
      < 9.294526, -1.496575, 2.768791>
    }
    triangle {
      < 9.219997, -1.487116, 2.835349>,
      < 9.294526, -1.496575, 2.768791>,
      < 9.298392, -1.467256, 2.820142>
    }
    triangle {
      < 9.219997, -1.520899, 2.779544>,
      < 9.219997, -1.542136, 2.714559>,
      < 9.292098, -1.515007, 2.708993>
    }
    triangle {
      < 9.219997, -1.520899, 2.779544>,
      < 9.292098, -1.515007, 2.708993>,
      < 9.294526, -1.496575, 2.768791>
    }
    triangle {
      < 9.219997, -1.542136, 2.714559>,
      < 9.219997, -1.549379, 2.644820>,
      < 9.291270, -1.521293, 2.644820>
    }
    triangle {
      < 9.219997, -1.542136, 2.714559>,
      < 9.291270, -1.521293, 2.644820>,
      < 9.292098, -1.515007, 2.708993>
    }
    triangle {
      < 9.219997, -1.124221, 2.644820>,
      < 9.219997, -1.131464, 2.714559>,
      < 9.315598, -1.157051, 2.708993>
    }
    triangle {
      < 9.219997, -1.124221, 2.644820>,
      < 9.315598, -1.157051, 2.708993>,
      < 9.315598, -1.150710, 2.644820>
    }
    triangle {
      < 9.219997, -1.131464, 2.714559>,
      < 9.219997, -1.152701, 2.779544>,
      < 9.315598, -1.175642, 2.768791>
    }
    triangle {
      < 9.219997, -1.131464, 2.714559>,
      < 9.315598, -1.175642, 2.768791>,
      < 9.315598, -1.157051, 2.708993>
    }
    triangle {
      < 9.219997, -1.152701, 2.779544>,
      < 9.219997, -1.186484, 2.835349>,
      < 9.315598, -1.205215, 2.820142>
    }
    triangle {
      < 9.219997, -1.152701, 2.779544>,
      < 9.315598, -1.205215, 2.820142>,
      < 9.315598, -1.175642, 2.768791>
    }
    triangle {
      < 9.219997, -1.186484, 2.835349>,
      < 9.219997, -1.230511, 2.878169>,
      < 9.315598, -1.243755, 2.859545>
    }
    triangle {
      < 9.219997, -1.186484, 2.835349>,
      < 9.315598, -1.243755, 2.859545>,
      < 9.315598, -1.205215, 2.820142>
    }
    triangle {
      < 9.219997, -1.230511, 2.878169>,
      < 9.219997, -1.281780, 2.905086>,
      < 9.315598, -1.288637, 2.884313>
    }
    triangle {
      < 9.219997, -1.230511, 2.878169>,
      < 9.315598, -1.288637, 2.884313>,
      < 9.315598, -1.243755, 2.859545>
    }
    triangle {
      < 9.114798, -1.140034, 2.787029>,
      < 9.114798, -1.176142, 2.845933>,
      < 9.219997, -1.186484, 2.835349>
    }
    triangle {
      < 9.114798, -1.140034, 2.787029>,
      < 9.219997, -1.186484, 2.835349>,
      < 9.219997, -1.152701, 2.779544>
    }
    triangle {
      < 9.114798, -1.176142, 2.845933>,
      < 9.114798, -1.223197, 2.891132>,
      < 9.219997, -1.230511, 2.878169>
    }
    triangle {
      < 9.114798, -1.176142, 2.845933>,
      < 9.219997, -1.230511, 2.878169>,
      < 9.219997, -1.186484, 2.835349>
    }
    triangle {
      < 9.114798, -1.223197, 2.891132>,
      < 9.114798, -1.277995, 2.919545>,
      < 9.219997, -1.281780, 2.905086>
    }
    triangle {
      < 9.114798, -1.223197, 2.891132>,
      < 9.219997, -1.281780, 2.905086>,
      < 9.219997, -1.230511, 2.878169>
    }
    triangle {
      < 9.114798, -1.277995, 2.919545>,
      < 9.219997, -1.336800, 2.914267>,
      < 9.219997, -1.281780, 2.905086>
    }
    triangle {
      < 9.114798, -1.395606, 2.919545>,
      < 9.219997, -1.391820, 2.905086>,
      < 9.219997, -1.336800, 2.914267>
    }
    triangle {
      < 9.114798, -1.395606, 2.919545>,
      < 9.114798, -1.450403, 2.891132>,
      < 9.219997, -1.443090, 2.878169>
    }
    triangle {
      < 9.114798, -1.395606, 2.919545>,
      < 9.219997, -1.443090, 2.878169>,
      < 9.219997, -1.391820, 2.905086>
    }
    triangle {
      < 9.114798, -1.450403, 2.891132>,
      < 9.114798, -1.497459, 2.845933>,
      < 9.219997, -1.487116, 2.835349>
    }
    triangle {
      < 9.114798, -1.450403, 2.891132>,
      < 9.219997, -1.487116, 2.835349>,
      < 9.219997, -1.443090, 2.878169>
    }
    triangle {
      < 9.114798, -1.497459, 2.845933>,
      < 9.114798, -1.533566, 2.787029>,
      < 9.219997, -1.520899, 2.779544>
    }
    triangle {
      < 9.114798, -1.497459, 2.845933>,
      < 9.219997, -1.520899, 2.779544>,
      < 9.219997, -1.487116, 2.835349>
    }
    triangle {
      < 9.114798, -1.533566, 2.787029>,
      < 9.114798, -1.556264, 2.718433>,
      < 9.219997, -1.542136, 2.714559>
    }
    triangle {
      < 9.114798, -1.533566, 2.787029>,
      < 9.219997, -1.542136, 2.714559>,
      < 9.219997, -1.520899, 2.779544>
    }
    triangle {
      < 9.114798, -1.556264, 2.718433>,
      < 9.114798, -1.564006, 2.644820>,
      < 9.219997, -1.549379, 2.644820>
    }
    triangle {
      < 9.114798, -1.556264, 2.718433>,
      < 9.219997, -1.549379, 2.644820>,
      < 9.219997, -1.542136, 2.714559>
    }
    triangle {
      < 9.114798, -1.109594, 2.644820>,
      < 9.114798, -1.117336, 2.718433>,
      < 9.219997, -1.131464, 2.714559>
    }
    triangle {
      < 9.114798, -1.109594, 2.644820>,
      < 9.219997, -1.131464, 2.714559>,
      < 9.219997, -1.124221, 2.644820>
    }
    triangle {
      < 9.114798, -1.117336, 2.718433>,
      < 9.114798, -1.140034, 2.787029>,
      < 9.219997, -1.152701, 2.779544>
    }
    triangle {
      < 9.114798, -1.117336, 2.718433>,
      < 9.219997, -1.152701, 2.779544>,
      < 9.219997, -1.131464, 2.714559>
    }
    triangle {
      < 9.011996, -1.098959, 2.644820>,
      < 9.011996, -1.107063, 2.720609>,
      < 9.114798, -1.117336, 2.718433>
    }
    triangle {
      < 9.011996, -1.098959, 2.644820>,
      < 9.114798, -1.117336, 2.718433>,
      < 9.114798, -1.109594, 2.644820>
    }
    triangle {
      < 9.011996, -1.107063, 2.720609>,
      < 9.011996, -1.130823, 2.791230>,
      < 9.114798, -1.140034, 2.787029>
    }
    triangle {
      < 9.011996, -1.107063, 2.720609>,
      < 9.114798, -1.140034, 2.787029>,
      < 9.114798, -1.117336, 2.718433>
    }
    triangle {
      < 9.011996, -1.130823, 2.791230>,
      < 9.011996, -1.168621, 2.851875>,
      < 9.114798, -1.176142, 2.845933>
    }
    triangle {
      < 9.011996, -1.130823, 2.791230>,
      < 9.114798, -1.176142, 2.845933>,
      < 9.114798, -1.140034, 2.787029>
    }
    triangle {
      < 9.011996, -1.168621, 2.851875>,
      < 9.011996, -1.217880, 2.898409>,
      < 9.114798, -1.223197, 2.891132>
    }
    triangle {
      < 9.011996, -1.168621, 2.851875>,
      < 9.114798, -1.223197, 2.891132>,
      < 9.114798, -1.176142, 2.845933>
    }
    triangle {
      < 9.011996, -1.217880, 2.898409>,
      < 9.011996, -1.246561, 2.913035>,
      < 9.114798, -1.277995, 2.919545>
    }
    triangle {
      < 9.011996, -1.217880, 2.898409>,
      < 9.114798, -1.277995, 2.919545>,
      < 9.114798, -1.223197, 2.891132>
    }
    triangle {
      < 9.011996, -1.246561, 2.913035>,
      < 9.011996, -1.336800, 2.985639>,
      < 9.114798, -1.336800, 2.950837>
    }
    triangle {
      < 9.011996, -1.246561, 2.913035>,
      < 9.114798, -1.336800, 2.950837>,
      < 9.114798, -1.277995, 2.919545>
    }
    triangle {
      < 9.011996, -1.336800, 2.985639>,
      < 9.011996, -1.427040, 2.913035>,
      < 9.114798, -1.395606, 2.919545>
    }
    triangle {
      < 9.011996, -1.336800, 2.985639>,
      < 9.114798, -1.395606, 2.919545>,
      < 9.114798, -1.336800, 2.950837>
    }
    triangle {
      < 9.011996, -1.427040, 2.913035>,
      < 9.011996, -1.455721, 2.898409>,
      < 9.114798, -1.450403, 2.891132>
    }
    triangle {
      < 9.011996, -1.427040, 2.913035>,
      < 9.114798, -1.450403, 2.891132>,
      < 9.114798, -1.395606, 2.919545>
    }
    triangle {
      < 9.011996, -1.455721, 2.898409>,
      < 9.011996, -1.504979, 2.851875>,
      < 9.114798, -1.497459, 2.845933>
    }
    triangle {
      < 9.011996, -1.455721, 2.898409>,
      < 9.114798, -1.497459, 2.845933>,
      < 9.114798, -1.450403, 2.891132>
    }
    triangle {
      < 9.011996, -1.504979, 2.851875>,
      < 9.011996, -1.542776, 2.791230>,
      < 9.114798, -1.533566, 2.787029>
    }
    triangle {
      < 9.011996, -1.504979, 2.851875>,
      < 9.114798, -1.533566, 2.787029>,
      < 9.114798, -1.497459, 2.845933>
    }
    triangle {
      < 9.011996, -1.542776, 2.791230>,
      < 9.011996, -1.566538, 2.720609>,
      < 9.114798, -1.556264, 2.718433>
    }
    triangle {
      < 9.011996, -1.542776, 2.791230>,
      < 9.114798, -1.556264, 2.718433>,
      < 9.114798, -1.533566, 2.787029>
    }
    triangle {
      < 9.011996, -1.566538, 2.720609>,
      < 9.011996, -1.574642, 2.644820>,
      < 9.114798, -1.564006, 2.644820>
    }
    triangle {
      < 9.011996, -1.566538, 2.720609>,
      < 9.114798, -1.564006, 2.644820>,
      < 9.114798, -1.556264, 2.718433>
    }
    triangle {
      < 8.981197, -1.098959, 2.644820>,
      < 8.981197, -1.107063, 2.720609>,
      < 9.011996, -1.107063, 2.720609>
    }
    triangle {
      < 8.981197, -1.098959, 2.644820>,
      < 9.011996, -1.107063, 2.720609>,
      < 9.011996, -1.098959, 2.644820>
    }
    triangle {
      < 8.981197, -1.107063, 2.720609>,
      < 8.981197, -1.130823, 2.791230>,
      < 9.011996, -1.130823, 2.791230>
    }
    triangle {
      < 8.981197, -1.107063, 2.720609>,
      < 9.011996, -1.130823, 2.791230>,
      < 9.011996, -1.107063, 2.720609>
    }
    triangle {
      < 8.981197, -1.130823, 2.791230>,
      < 8.981197, -1.168621, 2.851875>,
      < 9.011996, -1.168621, 2.851875>
    }
    triangle {
      < 8.981197, -1.130823, 2.791230>,
      < 9.011996, -1.168621, 2.851875>,
      < 9.011996, -1.130823, 2.791230>
    }
    triangle {
      < 8.981197, -1.168621, 2.851875>,
      < 8.981197, -1.217880, 2.898409>,
      < 9.011996, -1.217880, 2.898409>
    }
    triangle {
      < 8.981197, -1.168621, 2.851875>,
      < 9.011996, -1.217880, 2.898409>,
      < 9.011996, -1.168621, 2.851875>
    }
    triangle {
      < 8.981197, -1.217880, 2.898409>,
      < 8.981197, -1.246561, 2.913035>,
      < 9.011996, -1.246561, 2.913035>
    }
    triangle {
      < 8.981197, -1.217880, 2.898409>,
      < 9.011996, -1.246561, 2.913035>,
      < 9.011996, -1.217880, 2.898409>
    }
    triangle {
      < 9.011996, -1.246561, 2.913035>,
      < 8.981197, -1.246561, 2.913035>,
      < 8.981197, -1.336800, 2.990439>
    }
    triangle {
      < 9.011996, -1.246561, 2.913035>,
      < 8.981197, -1.336800, 2.990439>,
      < 9.011996, -1.336800, 2.985639>
    }
    triangle {
      < 8.981197, -1.336800, 2.990439>,
      < 8.981197, -1.427040, 2.913035>,
      < 9.011996, -1.427040, 2.913035>
    }
    triangle {
      < 8.981197, -1.336800, 2.990439>,
      < 9.011996, -1.427040, 2.913035>,
      < 9.011996, -1.336800, 2.985639>
    }
    triangle {
      < 8.981197, -1.455721, 2.898409>,
      < 9.011996, -1.455721, 2.898409>,
      < 9.011996, -1.427040, 2.913035>
    }
    triangle {
      < 8.981197, -1.455721, 2.898409>,
      < 9.011996, -1.427040, 2.913035>,
      < 8.981197, -1.427040, 2.913035>
    }
    triangle {
      < 8.981197, -1.506510, 2.898409>,
      < 8.981197, -1.637952, 2.867971>,
      < 8.999141, -1.636898, 2.862385>
    }
    triangle {
      < 8.981197, -1.506510, 2.898409>,
      < 8.999141, -1.636898, 2.862385>,
      < 8.999084, -1.510549, 2.891735>
    }
    triangle {
      < 8.981197, -1.637952, 2.867971>,
      < 8.981197, -1.738812, 2.802612>,
      < 8.999117, -1.734657, 2.799072>
    }
    triangle {
      < 8.981197, -1.637952, 2.867971>,
      < 8.999117, -1.734657, 2.799072>,
      < 8.999141, -1.636898, 2.862385>
    }
    triangle {
      < 8.981197, -1.738812, 2.802612>,
      < 8.981197, -1.802217, 2.726501>,
      < 8.999216, -1.796273, 2.724938>
    }
    triangle {
      < 8.981197, -1.738812, 2.802612>,
      < 8.999216, -1.796273, 2.724938>,
      < 8.999117, -1.734657, 2.799072>
    }
    triangle {
      < 8.981197, -1.802217, 2.726501>,
      < 8.981197, -1.823841, 2.644820>,
      < 8.999288, -1.817396, 2.644820>
    }
    triangle {
      < 8.981197, -1.802217, 2.726501>,
      < 8.999288, -1.817396, 2.644820>,
      < 8.999216, -1.796273, 2.724938>
    }
    triangle {
      < 8.981197, -1.506510, 2.898409>,
      < 8.999084, -1.510549, 2.891735>,
      < 9.011996, -1.455721, 2.898409>
    }
    triangle {
      < 8.981197, -1.506510, 2.898409>,
      < 9.011996, -1.455721, 2.898409>,
      < 8.981197, -1.455721, 2.898409>
    }
    triangle {
      < 8.981197, -1.802217, 2.726501>,
      < 8.981197, -1.738812, 2.802612>,
      < 8.080274, -1.783448, 2.792820>
    }
    triangle {
      < 8.981197, -1.802217, 2.726501>,
      < 8.080274, -1.783448, 2.792820>,
      < 8.085253, -1.849633, 2.722595>
    }
    triangle {
      < 8.981197, -1.823841, 2.644820>,
      < 8.981197, -1.802217, 2.726501>,
      < 8.085253, -1.849633, 2.722595>
    }
    triangle {
      < 8.981197, -1.823841, 2.644820>,
      < 8.085253, -1.849633, 2.722595>,
      < 8.092828, -1.873096, 2.644820>
    }
    triangle {
      < 8.981197, -1.738812, 2.802612>,
      < 8.981197, -1.637952, 2.867971>,
      < 8.093800, -1.679864, 2.852874>
    }
    triangle {
      < 8.981197, -1.738812, 2.802612>,
      < 8.093800, -1.679864, 2.852874>,
      < 8.080274, -1.783448, 2.792820>
    }
    triangle {
      < 8.319522, -1.348837, 2.905452>,
      < 8.460090, -1.282344, 2.905087>,
      < 8.302703, -1.293414, 2.907693>
    }
    triangle {
      < 8.319522, -1.348837, 2.905452>,
      < 8.302703, -1.293414, 2.907693>,
      < 8.267190, -1.359515, 2.905232>
    }
    triangle {
      < 8.981197, -1.246561, 2.913035>,
      < 8.981197, -1.217880, 2.898409>,
      < 8.339134, -1.223811, 2.884065>
    }
    triangle {
      < 8.981197, -1.246561, 2.913035>,
      < 8.339134, -1.223811, 2.884065>,
      < 8.335473, -1.231890, 2.887792>
    }
    triangle {
      < 8.981197, -1.246561, 2.913035>,
      < 8.335473, -1.231890, 2.887792>,
      < 8.460090, -1.282344, 2.905087>
    }
    triangle {
      < 8.981197, -1.217880, 2.898409>,
      < 8.981197, -1.168621, 2.851875>,
      < 8.364557, -1.176428, 2.845050>
    }
    triangle {
      < 8.981197, -1.217880, 2.898409>,
      < 8.364557, -1.176428, 2.845050>,
      < 8.339134, -1.223811, 2.884065>
    }
    triangle {
      < 8.981197, -1.168621, 2.851875>,
      < 8.981197, -1.130823, 2.791230>,
      < 8.386551, -1.134575, 2.786947>
    }
    triangle {
      < 8.981197, -1.168621, 2.851875>,
      < 8.386551, -1.134575, 2.786947>,
      < 8.364557, -1.176428, 2.845050>
    }
    triangle {
      < 8.981197, -1.130823, 2.791230>,
      < 8.981197, -1.107063, 2.720609>,
      < 8.400378, -1.108249, 2.718540>
    }
    triangle {
      < 8.981197, -1.130823, 2.791230>,
      < 8.400378, -1.108249, 2.718540>,
      < 8.386551, -1.134575, 2.786947>
    }
    triangle {
      < 8.981197, -1.107063, 2.720609>,
      < 8.981197, -1.098959, 2.644820>,
      < 8.405093, -1.099273, 2.644820>
    }
    triangle {
      < 8.981197, -1.107063, 2.720609>,
      < 8.405093, -1.099273, 2.644820>,
      < 8.400378, -1.108249, 2.718540>
    }
    triangle {
      < 8.459869, -1.411076, 2.902306>,
      < 8.319522, -1.348837, 2.905452>,
      < 8.267190, -1.359515, 2.905232>
    }
    triangle {
      < 8.459869, -1.411076, 2.902306>,
      < 8.267190, -1.359515, 2.905232>,
      < 8.230967, -1.425997, 2.899253>
    }
    triangle {
      < 8.981197, -1.637952, 2.867971>,
      < 8.981197, -1.506510, 2.898409>,
      < 8.170268, -1.538336, 2.883126>
    }
    triangle {
      < 8.981197, -1.637952, 2.867971>,
      < 8.170268, -1.538336, 2.883126>,
      < 8.093800, -1.679864, 2.852874>
    }
    triangle {
      < 8.459869, -1.411076, 2.902306>,
      < 8.230967, -1.425997, 2.899253>,
      < 8.208865, -1.466886, 2.897391>
    }
    triangle {
      < 8.981197, -1.506510, 2.898409>,
      < 8.981197, -1.455721, 2.898409>,
      < 8.205842, -1.472367, 2.895818>
    }
    triangle {
      < 8.981197, -1.506510, 2.898409>,
      < 8.205842, -1.472367, 2.895818>,
      < 8.170268, -1.538336, 2.883126>
    }
    triangle {
      < 8.981197, -1.336800, 2.990439>,
      < 8.981197, -1.246561, 2.913035>,
      < 8.460090, -1.282344, 2.905087>
    }
    triangle {
      < 8.981197, -1.336800, 2.990439>,
      < 8.460090, -1.282344, 2.905087>,
      < 8.448472, -1.346491, 2.973640>
    }
    triangle {
      < 8.981197, -1.427040, 2.913035>,
      < 8.981197, -1.336800, 2.990439>,
      < 8.448472, -1.346491, 2.973640>
    }
    triangle {
      < 8.981197, -1.427040, 2.913035>,
      < 8.448472, -1.346491, 2.973640>,
      < 8.459869, -1.411076, 2.902306>
    }
    triangle {
      < 9.114798, -1.336800, 2.950837>,
      < 9.114798, -1.395606, 2.919545>,
      < 9.219997, -1.336800, 2.914267>
    }
    triangle {
      < 9.114798, -1.336800, 2.950837>,
      < 9.219997, -1.336800, 2.914267>,
      < 9.114798, -1.277995, 2.919545>
    }
    triangle {
      < 8.319522, -1.348837, 2.905452>,
      < 8.459869, -1.411076, 2.902306>,
      < 8.448472, -1.346491, 2.973640>
    }
    triangle {
      < 8.319522, -1.348837, 2.905452>,
      < 8.448472, -1.346491, 2.973640>,
      < 8.460090, -1.282344, 2.905087>
    }
    triangle {
      < 8.205842, -1.472367, 2.895818>,
      < 8.981197, -1.455721, 2.898409>,
      < 8.981197, -1.427040, 2.913035>
    }
    triangle {
      < 8.205842, -1.472367, 2.895818>,
      < 8.981197, -1.427040, 2.913035>,
      < 8.459869, -1.411076, 2.902306>
    }
    triangle {
      < 8.205842, -1.472367, 2.895818>,
      < 8.459869, -1.411076, 2.902306>,
      < 8.208865, -1.466886, 2.897391>
    }
    triangle {
      < 8.460090, -1.282344, 2.905087>,
      < 8.335473, -1.231890, 2.887792>,
      < 8.302703, -1.293414, 2.907693>
    }
    triangle {
      < 9.306579, -1.505469, 2.707011>,
      < 9.308848, -1.487641, 2.764788>,
      < 9.294526, -1.496575, 2.768791>
    }
    triangle {
      < 9.306579, -1.505469, 2.707011>,
      < 9.294526, -1.496575, 2.768791>,
      < 9.292098, -1.515007, 2.708993>
    }
    triangle {
      < 9.308848, -1.487641, 2.764788>,
      < 9.312419, -1.459459, 2.814084>,
      < 9.298392, -1.467256, 2.820142>
    }
    triangle {
      < 9.308848, -1.487641, 2.764788>,
      < 9.298392, -1.467256, 2.820142>,
      < 9.294526, -1.496575, 2.768791>
    }
    triangle {
      < 9.312419, -1.459459, 2.814084>,
      < 9.316981, -1.423095, 2.851523>,
      < 9.303433, -1.429047, 2.859545>
    }
    triangle {
      < 9.312419, -1.459459, 2.814084>,
      < 9.303433, -1.429047, 2.859545>,
      < 9.298392, -1.467256, 2.820142>
    }
    triangle {
      < 9.316981, -1.423095, 2.851523>,
      < 9.322154, -1.381266, 2.874760>,
      < 9.309299, -1.384550, 2.884313>
    }
    triangle {
      < 9.316981, -1.423095, 2.851523>,
      < 9.309299, -1.384550, 2.884313>,
      < 9.303433, -1.429047, 2.859545>
    }
    triangle {
      < 9.322154, -1.381266, 2.874760>,
      < 9.327429, -1.337455, 2.882406>,
      < 9.315598, -1.336800, 2.892762>
    }
    triangle {
      < 9.322154, -1.381266, 2.874760>,
      < 9.315598, -1.336800, 2.892762>,
      < 9.309299, -1.384550, 2.884313>
    }
    triangle {
      < 9.327429, -1.337455, 2.882406>,
      < 9.345465, -1.295034, 2.868094>,
      < 9.334587, -1.290710, 2.877168>
    }
    triangle {
      < 9.327429, -1.337455, 2.882406>,
      < 9.334587, -1.290710, 2.877168>,
      < 9.315598, -1.336800, 2.892762>
    }
    triangle {
      < 9.345465, -1.295034, 2.868094>,
      < 9.361150, -1.257808, 2.840219>,
      < 9.350867, -1.251195, 2.847646>
    }
    triangle {
      < 9.345465, -1.295034, 2.868094>,
      < 9.350867, -1.251195, 2.847646>,
      < 9.334587, -1.290710, 2.877168>
    }
    triangle {
      < 9.361150, -1.257808, 2.840219>,
      < 9.373755, -1.227783, 2.801352>,
      < 9.363877, -1.219617, 2.806843>
    }
    triangle {
      < 9.361150, -1.257808, 2.840219>,
      < 9.363877, -1.219617, 2.806843>,
      < 9.350867, -1.251195, 2.847646>
    }
    triangle {
      < 9.373755, -1.227783, 2.801352>,
      < 9.382946, -1.205820, 2.753986>,
      < 9.373309, -1.196726, 2.757550>
    }
    triangle {
      < 9.373755, -1.227783, 2.801352>,
      < 9.373309, -1.196726, 2.757550>,
      < 9.363877, -1.219617, 2.806843>
    }
    triangle {
      < 9.382946, -1.205820, 2.753986>,
      < 9.388523, -1.192460, 2.700856>,
      < 9.379009, -1.182890, 2.702599>
    }
    triangle {
      < 9.382946, -1.205820, 2.753986>,
      < 9.379009, -1.182890, 2.702599>,
      < 9.373309, -1.196726, 2.757550>
    }
    triangle {
      < 9.388523, -1.192460, 2.700856>,
      < 9.390391, -1.187980, 2.644820>,
      < 9.380916, -1.178265, 2.644820>
    }
    triangle {
      < 9.388523, -1.192460, 2.700856>,
      < 9.380916, -1.178265, 2.644820>,
      < 9.379009, -1.182890, 2.702599>
    }
    triangle {
      < 9.305799, -1.511568, 2.644820>,
      < 9.306579, -1.505469, 2.707011>,
      < 9.292098, -1.515007, 2.708993>
    }
    triangle {
      < 9.305799, -1.511568, 2.644820>,
      < 9.292098, -1.515007, 2.708993>,
      < 9.291270, -1.521293, 2.644820>
    }
    triangle {
      < 9.314896, -1.495034, 2.644820>,
      < 9.315593, -1.489255, 2.703642>,
      < 9.306579, -1.505469, 2.707011>
    }
    triangle {
      < 9.314896, -1.495034, 2.644820>,
      < 9.306579, -1.505469, 2.707011>,
      < 9.305799, -1.511568, 2.644820>
    }
    triangle {
      < 9.315593, -1.489255, 2.703642>,
      < 9.317596, -1.472453, 2.757983>,
      < 9.308848, -1.487641, 2.764788>
    }
    triangle {
      < 9.315593, -1.489255, 2.703642>,
      < 9.308848, -1.487641, 2.764788>,
      < 9.306579, -1.505469, 2.707011>
    }
    triangle {
      < 9.317596, -1.472453, 2.757983>,
      < 9.320664, -1.446203, 2.803785>,
      < 9.312419, -1.459459, 2.814084>
    }
    triangle {
      < 9.317596, -1.472453, 2.757983>,
      < 9.312419, -1.459459, 2.814084>,
      < 9.308848, -1.487641, 2.764788>
    }
    triangle {
      < 9.320664, -1.446203, 2.803785>,
      < 9.324411, -1.412976, 2.837886>,
      < 9.316981, -1.423095, 2.851523>
    }
    triangle {
      < 9.320664, -1.446203, 2.803785>,
      < 9.316981, -1.423095, 2.851523>,
      < 9.312419, -1.459459, 2.814084>
    }
    triangle {
      < 9.324411, -1.412976, 2.837886>,
      < 9.328403, -1.375694, 2.858512>,
      < 9.322154, -1.381266, 2.874760>
    }
    triangle {
      < 9.324411, -1.412976, 2.837886>,
      < 9.322154, -1.381266, 2.874760>,
      < 9.316981, -1.423095, 2.851523>
    }
    triangle {
      < 9.328403, -1.375694, 2.858512>,
      < 9.331939, -1.338572, 2.864783>,
      < 9.327429, -1.337455, 2.882406>
    }
    triangle {
      < 9.328403, -1.375694, 2.858512>,
      < 9.327429, -1.337455, 2.882406>,
      < 9.322154, -1.381266, 2.874760>
    }
    triangle {
      < 9.331939, -1.338572, 2.864783>,
      < 9.348357, -1.302375, 2.852660>,
      < 9.345465, -1.295034, 2.868094>
    }
    triangle {
      < 9.331939, -1.338572, 2.864783>,
      < 9.345465, -1.295034, 2.868094>,
      < 9.327429, -1.337455, 2.882406>
    }
    triangle {
      < 9.348357, -1.302375, 2.852660>,
      < 9.363029, -1.269052, 2.827596>,
      < 9.361150, -1.257808, 2.840219>
    }
    triangle {
      < 9.348357, -1.302375, 2.852660>,
      < 9.361150, -1.257808, 2.840219>,
      < 9.345465, -1.295034, 2.868094>
    }
    triangle {
      < 9.363029, -1.269052, 2.827596>,
      < 9.374948, -1.241667, 2.792017>,
      < 9.373755, -1.227783, 2.801352>
    }
    triangle {
      < 9.363029, -1.269052, 2.827596>,
      < 9.373755, -1.227783, 2.801352>,
      < 9.361150, -1.257808, 2.840219>
    }
    triangle {
      < 9.374948, -1.241667, 2.792017>,
      < 9.383728, -1.221281, 2.747927>,
      < 9.382946, -1.205820, 2.753986>
    }
    triangle {
      < 9.374948, -1.241667, 2.792017>,
      < 9.382946, -1.205820, 2.753986>,
      < 9.373755, -1.227783, 2.801352>
    }
    triangle {
      < 9.383728, -1.221281, 2.747927>,
      < 9.389095, -1.208729, 2.697892>,
      < 9.388523, -1.192460, 2.700856>
    }
    triangle {
      < 9.383728, -1.221281, 2.747927>,
      < 9.388523, -1.192460, 2.700856>,
      < 9.382946, -1.205820, 2.753986>
    }
    triangle {
      < 9.389095, -1.208729, 2.697892>,
      < 9.390900, -1.204495, 2.644820>,
      < 9.390391, -1.187980, 2.644820>
    }
    triangle {
      < 9.389095, -1.208729, 2.697892>,
      < 9.390391, -1.187980, 2.644820>,
      < 9.388523, -1.192460, 2.700856>
    }
    triangle {
      < 9.341655, -1.309691, 2.837207>,
      < 9.355305, -1.280296, 2.814973>,
      < 9.363029, -1.269052, 2.827596>
    }
    triangle {
      < 9.341655, -1.309691, 2.837207>,
      < 9.363029, -1.269052, 2.827596>,
      < 9.348357, -1.302375, 2.852660>
    }
    triangle {
      < 9.355305, -1.280296, 2.814973>,
      < 9.366538, -1.255551, 2.782683>,
      < 9.374948, -1.241667, 2.792017>
    }
    triangle {
      < 9.355305, -1.280296, 2.814973>,
      < 9.374948, -1.241667, 2.792017>,
      < 9.363029, -1.269052, 2.827596>
    }
    triangle {
      < 9.366538, -1.255551, 2.782683>,
      < 9.374908, -1.236742, 2.741868>,
      < 9.383728, -1.221281, 2.747927>
    }
    triangle {
      < 9.366538, -1.255551, 2.782683>,
      < 9.383728, -1.221281, 2.747927>,
      < 9.374948, -1.241667, 2.792017>
    }
    triangle {
      < 9.374908, -1.236742, 2.741868>,
      < 9.380066, -1.224998, 2.694929>,
      < 9.389095, -1.208729, 2.697892>
    }
    triangle {
      < 9.374908, -1.236742, 2.741868>,
      < 9.389095, -1.208729, 2.697892>,
      < 9.383728, -1.221281, 2.747927>
    }
    triangle {
      < 9.380066, -1.224998, 2.694929>,
      < 9.381806, -1.221010, 2.644820>,
      < 9.390900, -1.204495, 2.644820>
    }
    triangle {
      < 9.380066, -1.224998, 2.694929>,
      < 9.390900, -1.204495, 2.644820>,
      < 9.389095, -1.208729, 2.697892>
    }
    triangle {
      < 9.314393, -1.478501, 2.644820>,
      < 9.315006, -1.473042, 2.700272>,
      < 9.315593, -1.489255, 2.703642>
    }
    triangle {
      < 9.314393, -1.478501, 2.644820>,
      < 9.315593, -1.489255, 2.703642>,
      < 9.314896, -1.495034, 2.644820>
    }
    triangle {
      < 9.315006, -1.473042, 2.700272>,
      < 9.316745, -1.457265, 2.751179>,
      < 9.317596, -1.472453, 2.757983>
    }
    triangle {
      < 9.315006, -1.473042, 2.700272>,
      < 9.317596, -1.472453, 2.757983>,
      < 9.315593, -1.489255, 2.703642>
    }
    triangle {
      < 9.316745, -1.457265, 2.751179>,
      < 9.319310, -1.432948, 2.793487>,
      < 9.320664, -1.446203, 2.803785>
    }
    triangle {
      < 9.316745, -1.457265, 2.751179>,
      < 9.320664, -1.446203, 2.803785>,
      < 9.317596, -1.472453, 2.757983>
    }
    triangle {
      < 9.319310, -1.432948, 2.793487>,
      < 9.322242, -1.402857, 2.824250>,
      < 9.324411, -1.412976, 2.837886>
    }
    triangle {
      < 9.319310, -1.432948, 2.793487>,
      < 9.324411, -1.412976, 2.837886>,
      < 9.320664, -1.446203, 2.803785>
    }
    triangle {
      < 9.322242, -1.402857, 2.824250>,
      < 9.325043, -1.370153, 2.842247>,
      < 9.328403, -1.375694, 2.858512>
    }
    triangle {
      < 9.322242, -1.402857, 2.824250>,
      < 9.328403, -1.375694, 2.858512>,
      < 9.324411, -1.412976, 2.837886>
    }
    triangle {
      < 9.325043, -1.370153, 2.842247>,
      < 9.326846, -1.339696, 2.847115>,
      < 9.331939, -1.338572, 2.864783>
    }
    triangle {
      < 9.325043, -1.370153, 2.842247>,
      < 9.331939, -1.338572, 2.864783>,
      < 9.328403, -1.375694, 2.858512>
    }
    triangle {
      < 9.326846, -1.339696, 2.847115>,
      < 9.341655, -1.309691, 2.837207>,
      < 9.348357, -1.302375, 2.852660>
    }
    triangle {
      < 9.326846, -1.339696, 2.847115>,
      < 9.348357, -1.302375, 2.852660>,
      < 9.331939, -1.338572, 2.864783>
    }
    triangle {
      < 9.314498, -1.395712, 2.814626>,
      < 9.316450, -1.366276, 2.830745>,
      < 9.325043, -1.370153, 2.842247>
    }
    triangle {
      < 9.314498, -1.395712, 2.814626>,
      < 9.325043, -1.370153, 2.842247>,
      < 9.322242, -1.402857, 2.824250>
    }
    triangle {
      < 9.316450, -1.366276, 2.830745>,
      < 9.317037, -1.340499, 2.834590>,
      < 9.326846, -1.339696, 2.847115>
    }
    triangle {
      < 9.316450, -1.366276, 2.830745>,
      < 9.326846, -1.339696, 2.847115>,
      < 9.325043, -1.370153, 2.842247>
    }
    triangle {
      < 9.317037, -1.340499, 2.834590>,
      < 9.330718, -1.314826, 2.826277>,
      < 9.341655, -1.309691, 2.837207>
    }
    triangle {
      < 9.317037, -1.340499, 2.834590>,
      < 9.341655, -1.309691, 2.837207>,
      < 9.326846, -1.339696, 2.847115>
    }
    triangle {
      < 9.330718, -1.314826, 2.826277>,
      < 9.343640, -1.288234, 2.806063>,
      < 9.355305, -1.280296, 2.814973>
    }
    triangle {
      < 9.330718, -1.314826, 2.826277>,
      < 9.355305, -1.280296, 2.814973>,
      < 9.341655, -1.309691, 2.837207>
    }
    triangle {
      < 9.343640, -1.288234, 2.806063>,
      < 9.354388, -1.265352, 2.776094>,
      < 9.366538, -1.255551, 2.782683>
    }
    triangle {
      < 9.343640, -1.288234, 2.806063>,
      < 9.366538, -1.255551, 2.782683>,
      < 9.355305, -1.280296, 2.814973>
    }
    triangle {
      < 9.354388, -1.265352, 2.776094>,
      < 9.362471, -1.247656, 2.737591>,
      < 9.374908, -1.236742, 2.741868>
    }
    triangle {
      < 9.354388, -1.265352, 2.776094>,
      < 9.374908, -1.236742, 2.741868>,
      < 9.366538, -1.255551, 2.782683>
    }
    triangle {
      < 9.362471, -1.247656, 2.737591>,
      < 9.367479, -1.236482, 2.692837>,
      < 9.380066, -1.224998, 2.694929>
    }
    triangle {
      < 9.362471, -1.247656, 2.737591>,
      < 9.380066, -1.224998, 2.694929>,
      < 9.374908, -1.236742, 2.741868>
    }
    triangle {
      < 9.367479, -1.236482, 2.692837>,
      < 9.369174, -1.232667, 2.644820>,
      < 9.381806, -1.221010, 2.644820>
    }
    triangle {
      < 9.367479, -1.236482, 2.692837>,
      < 9.381806, -1.221010, 2.644820>,
      < 9.380066, -1.224998, 2.694929>
    }
    triangle {
      < 9.307826, -1.466830, 2.644820>,
      < 9.308381, -1.461597, 2.697894>,
      < 9.315006, -1.473042, 2.700272>
    }
    triangle {
      < 9.307826, -1.466830, 2.644820>,
      < 9.315006, -1.473042, 2.700272>,
      < 9.314393, -1.478501, 2.644820>
    }
    triangle {
      < 9.308381, -1.461597, 2.697894>,
      < 9.309932, -1.446544, 2.746375>,
      < 9.316745, -1.457265, 2.751179>
    }
    triangle {
      < 9.308381, -1.461597, 2.697894>,
      < 9.316745, -1.457265, 2.751179>,
      < 9.315006, -1.473042, 2.700272>
    }
    triangle {
      < 9.309932, -1.446544, 2.746375>,
      < 9.312142, -1.423590, 2.786218>,
      < 9.319310, -1.432948, 2.793487>
    }
    triangle {
      < 9.309932, -1.446544, 2.746375>,
      < 9.319310, -1.432948, 2.793487>,
      < 9.316745, -1.457265, 2.751179>
    }
    triangle {
      < 9.312142, -1.423590, 2.786218>,
      < 9.314498, -1.395712, 2.814626>,
      < 9.322242, -1.402857, 2.824250>
    }
    triangle {
      < 9.312142, -1.423590, 2.786218>,
      < 9.322242, -1.402857, 2.824250>,
      < 9.319310, -1.432948, 2.793487>
    }
    triangle {
      < 9.270059, -1.452059, 2.695912>,
      < 9.270059, -1.437610, 2.742372>,
      < 9.309932, -1.446544, 2.746375>
    }
    triangle {
      < 9.270059, -1.452059, 2.695912>,
      < 9.309932, -1.446544, 2.746375>,
      < 9.308381, -1.461597, 2.697894>
    }
    triangle {
      < 9.270059, -1.437610, 2.742372>,
      < 9.270059, -1.415792, 2.780160>,
      < 9.312142, -1.423590, 2.786218>
    }
    triangle {
      < 9.270059, -1.437610, 2.742372>,
      < 9.312142, -1.423590, 2.786218>,
      < 9.309932, -1.446544, 2.746375>
    }
    triangle {
      < 9.270059, -1.415792, 2.780160>,
      < 9.270059, -1.389757, 2.806606>,
      < 9.314498, -1.395712, 2.814626>
    }
    triangle {
      < 9.270059, -1.415792, 2.780160>,
      < 9.314498, -1.395712, 2.814626>,
      < 9.312142, -1.423590, 2.786218>
    }
    triangle {
      < 9.270059, -1.389757, 2.806606>,
      < 9.270059, -1.363081, 2.821137>,
      < 9.316450, -1.366276, 2.830745>
    }
    triangle {
      < 9.270059, -1.389757, 2.806606>,
      < 9.316450, -1.366276, 2.830745>,
      < 9.314498, -1.395712, 2.814626>
    }
    triangle {
      < 9.270059, -1.363081, 2.821137>,
      < 9.270059, -1.341180, 2.824098>,
      < 9.317037, -1.340499, 2.834590>
    }
    triangle {
      < 9.270059, -1.363081, 2.821137>,
      < 9.317037, -1.340499, 2.834590>,
      < 9.316450, -1.366276, 2.830745>
    }
    triangle {
      < 9.270059, -1.341180, 2.824098>,
      < 9.270059, -1.319076, 2.817147>,
      < 9.330718, -1.314826, 2.826277>
    }
    triangle {
      < 9.270059, -1.341180, 2.824098>,
      < 9.330718, -1.314826, 2.826277>,
      < 9.317037, -1.340499, 2.834590>
    }
    triangle {
      < 9.270059, -1.319076, 2.817147>,
      < 9.270059, -1.294850, 2.798639>,
      < 9.343640, -1.288234, 2.806063>
    }
    triangle {
      < 9.270059, -1.319076, 2.817147>,
      < 9.343640, -1.288234, 2.806063>,
      < 9.330718, -1.314826, 2.826277>
    }
    triangle {
      < 9.270059, -1.294850, 2.798639>,
      < 9.270059, -1.273519, 2.770604>,
      < 9.354388, -1.265352, 2.776094>
    }
    triangle {
      < 9.270059, -1.294850, 2.798639>,
      < 9.354388, -1.265352, 2.776094>,
      < 9.343640, -1.288234, 2.806063>
    }
    triangle {
      < 9.270059, -1.273519, 2.770604>,
      < 9.270059, -1.256751, 2.734026>,
      < 9.362471, -1.247656, 2.737591>
    }
    triangle {
      < 9.270059, -1.273519, 2.770604>,
      < 9.362471, -1.247656, 2.737591>,
      < 9.354388, -1.265352, 2.776094>
    }
    triangle {
      < 9.270059, -1.256751, 2.734026>,
      < 9.270059, -1.246052, 2.691093>,
      < 9.367479, -1.236482, 2.692837>
    }
    triangle {
      < 9.270059, -1.256751, 2.734026>,
      < 9.367479, -1.236482, 2.692837>,
      < 9.362471, -1.247656, 2.737591>
    }
    triangle {
      < 9.270059, -1.246052, 2.691093>,
      < 9.270059, -1.242382, 2.644820>,
      < 9.369174, -1.232667, 2.644820>
    }
    triangle {
      < 9.270059, -1.246052, 2.691093>,
      < 9.369174, -1.232667, 2.644820>,
      < 9.367479, -1.236482, 2.692837>
    }
    triangle {
      < 9.270059, -1.457104, 2.644820>,
      < 9.270059, -1.452059, 2.695912>,
      < 9.308381, -1.461597, 2.697894>
    }
    triangle {
      < 9.270059, -1.457104, 2.644820>,
      < 9.308381, -1.461597, 2.697894>,
      < 9.307826, -1.466830, 2.644820>
    }
    triangle {
      < 9.011996, -1.512208, 2.877201>,
      < 9.011996, -1.455721, 2.898409>,
      < 8.999084, -1.510549, 2.891735>
    }
    triangle {
      < 9.011996, -1.632657, 2.849308>,
      < 9.011996, -1.512208, 2.877201>,
      < 8.999084, -1.510549, 2.891735>
    }
    triangle {
      < 9.011996, -1.632657, 2.849308>,
      < 8.999084, -1.510549, 2.891735>,
      < 8.999141, -1.636898, 2.862385>
    }
    triangle {
      < 9.011996, -1.725083, 2.789415>,
      < 9.011996, -1.632657, 2.849308>,
      < 8.999141, -1.636898, 2.862385>
    }
    triangle {
      < 9.011996, -1.725083, 2.789415>,
      < 8.999141, -1.636898, 2.862385>,
      < 8.999117, -1.734657, 2.799072>
    }
    triangle {
      < 9.011996, -1.783185, 2.719670>,
      < 9.011996, -1.725083, 2.789415>,
      < 8.999117, -1.734657, 2.799072>
    }
    triangle {
      < 9.011996, -1.783185, 2.719670>,
      < 8.999117, -1.734657, 2.799072>,
      < 8.999216, -1.796273, 2.724938>
    }
    triangle {
      < 9.011996, -1.803000, 2.644820>,
      < 9.011996, -1.783185, 2.719670>,
      < 8.999216, -1.796273, 2.724938>
    }
    triangle {
      < 9.011996, -1.803000, 2.644820>,
      < 8.999216, -1.796273, 2.724938>,
      < 8.999288, -1.817396, 2.644820>
    }
    triangle {
      < 9.011996, -1.455721, 2.898409>,
      < 9.011996, -1.512208, 2.877201>,
      < 9.011996, -1.504979, 2.851875>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.558760, 2.842789>,
      < 9.011996, -1.622743, 2.825943>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.622743, 2.825943>,
      < 9.011996, -1.708303, 2.770498>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.708303, 2.770498>,
      < 9.011996, -1.760434, 2.707922>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.760434, 2.707922>,
      < 9.011996, -1.769008, 2.675535>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.769008, 2.675535>,
      < 9.011996, -1.756696, 2.669820>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.756696, 2.669820>,
      < 9.011996, -1.610935, 2.669820>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.610935, 2.669820>,
      < 9.011996, -1.596210, 2.678245>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.596210, 2.678245>,
      < 9.011996, -1.591105, 2.725988>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.591105, 2.725988>,
      < 9.011996, -1.565539, 2.801973>
    }
    triangle {
      < 9.011996, -1.610935, 2.669820>,
      < 9.011996, -1.756696, 2.669820>,
      < 9.011996, -1.803000, 2.644820>
    }
    triangle {
      < 9.011996, -1.610935, 2.669820>,
      < 9.011996, -1.803000, 2.644820>,
      < 9.011996, -1.756696, 2.619820>
    }
    triangle {
      < 9.011996, -1.610935, 2.669820>,
      < 9.011996, -1.756696, 2.619820>,
      < 9.011996, -1.610935, 2.619820>
    }
    triangle {
      < 9.011996, -1.610935, 2.669820>,
      < 9.011996, -1.610935, 2.619820>,
      < 9.011996, -1.574642, 2.644820>
    }
    triangle {
      < 9.011996, -1.769008, 2.675535>,
      < 9.011996, -1.760434, 2.707922>,
      < 9.011996, -1.783185, 2.719670>
    }
    triangle {
      < 9.011996, -1.769008, 2.675535>,
      < 9.011996, -1.783185, 2.719670>,
      < 9.011996, -1.803000, 2.644820>
    }
    triangle {
      < 9.011996, -1.760434, 2.707922>,
      < 9.011996, -1.708303, 2.770498>,
      < 9.011996, -1.725083, 2.789415>
    }
    triangle {
      < 9.011996, -1.760434, 2.707922>,
      < 9.011996, -1.725083, 2.789415>,
      < 9.011996, -1.783185, 2.719670>
    }
    triangle {
      < 9.011996, -1.708303, 2.770498>,
      < 9.011996, -1.622743, 2.825943>,
      < 9.011996, -1.632657, 2.849308>
    }
    triangle {
      < 9.011996, -1.708303, 2.770498>,
      < 9.011996, -1.632657, 2.849308>,
      < 9.011996, -1.725083, 2.789415>
    }
    triangle {
      < 9.011996, -1.622743, 2.825943>,
      < 9.011996, -1.558760, 2.842789>,
      < 9.011996, -1.512208, 2.877201>
    }
    triangle {
      < 9.011996, -1.622743, 2.825943>,
      < 9.011996, -1.512208, 2.877201>,
      < 9.011996, -1.632657, 2.849308>
    }
    triangle {
      < 9.011996, -1.558760, 2.842789>,
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.504979, 2.851875>
    }
    triangle {
      < 9.011996, -1.558760, 2.842789>,
      < 9.011996, -1.504979, 2.851875>,
      < 9.011996, -1.512208, 2.877201>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.565539, 2.801973>,
      < 9.011996, -1.542776, 2.791230>
    }
    triangle {
      < 9.011996, -1.546386, 2.833008>,
      < 9.011996, -1.542776, 2.791230>,
      < 9.011996, -1.504979, 2.851875>
    }
    triangle {
      < 9.011996, -1.565539, 2.801973>,
      < 9.011996, -1.591105, 2.725988>,
      < 9.011996, -1.566538, 2.720609>
    }
    triangle {
      < 9.011996, -1.565539, 2.801973>,
      < 9.011996, -1.566538, 2.720609>,
      < 9.011996, -1.542776, 2.791230>
    }
    triangle {
      < 9.011996, -1.591105, 2.725988>,
      < 9.011996, -1.596210, 2.678245>,
      < 9.011996, -1.574642, 2.644820>
    }
    triangle {
      < 9.011996, -1.591105, 2.725988>,
      < 9.011996, -1.574642, 2.644820>,
      < 9.011996, -1.566538, 2.720609>
    }
    triangle {
      < 9.011996, -1.769008, 2.675535>,
      < 9.011996, -1.803000, 2.644820>,
      < 9.011996, -1.756696, 2.669820>
    }
    triangle {
      < 9.011996, -1.610935, 2.669820>,
      < 9.011996, -1.574642, 2.644820>,
      < 9.011996, -1.596210, 2.678245>
    }
    triangle {
      < 9.011996, -1.610935, 2.619820>,
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.574642, 2.644820>
    }
    triangle {
      < 9.011996, -1.769008, 2.614105>,
      < 9.011996, -1.756696, 2.619820>,
      < 9.011996, -1.803000, 2.644820>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.591105, 2.563652>,
      < 9.011996, -1.566538, 2.569031>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.566538, 2.569031>,
      < 9.011996, -1.574642, 2.644820>
    }
    triangle {
      < 9.011996, -1.591105, 2.563652>,
      < 9.011996, -1.565539, 2.487667>,
      < 9.011996, -1.542776, 2.498410>
    }
    triangle {
      < 9.011996, -1.591105, 2.563652>,
      < 9.011996, -1.542776, 2.498410>,
      < 9.011996, -1.566538, 2.569031>
    }
    triangle {
      < 9.011996, -1.565539, 2.487667>,
      < 9.011996, -1.546386, 2.456632>,
      < 9.011996, -1.504979, 2.437765>
    }
    triangle {
      < 9.011996, -1.565539, 2.487667>,
      < 9.011996, -1.504979, 2.437765>,
      < 9.011996, -1.542776, 2.498410>
    }
    triangle {
      < 9.011996, -1.546386, 2.456632>,
      < 9.011996, -1.558760, 2.446851>,
      < 9.011996, -1.512208, 2.412439>
    }
    triangle {
      < 9.011996, -1.546386, 2.456632>,
      < 9.011996, -1.512208, 2.412439>,
      < 9.011996, -1.504979, 2.437765>
    }
    triangle {
      < 9.011996, -1.558760, 2.446851>,
      < 9.011996, -1.622743, 2.463698>,
      < 9.011996, -1.632657, 2.440332>
    }
    triangle {
      < 9.011996, -1.558760, 2.446851>,
      < 9.011996, -1.632657, 2.440332>,
      < 9.011996, -1.512208, 2.412439>
    }
    triangle {
      < 9.011996, -1.622743, 2.463698>,
      < 9.011996, -1.708303, 2.519142>,
      < 9.011996, -1.725083, 2.500225>
    }
    triangle {
      < 9.011996, -1.622743, 2.463698>,
      < 9.011996, -1.725083, 2.500225>,
      < 9.011996, -1.632657, 2.440332>
    }
    triangle {
      < 9.011996, -1.708303, 2.519142>,
      < 9.011996, -1.760434, 2.581719>,
      < 9.011996, -1.783185, 2.569970>
    }
    triangle {
      < 9.011996, -1.708303, 2.519142>,
      < 9.011996, -1.783185, 2.569970>,
      < 9.011996, -1.725083, 2.500225>
    }
    triangle {
      < 9.011996, -1.760434, 2.581719>,
      < 9.011996, -1.769008, 2.614105>,
      < 9.011996, -1.803000, 2.644820>
    }
    triangle {
      < 9.011996, -1.760434, 2.581719>,
      < 9.011996, -1.803000, 2.644820>,
      < 9.011996, -1.783185, 2.569970>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.610935, 2.619820>,
      < 9.011996, -1.756696, 2.619820>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.756696, 2.619820>,
      < 9.011996, -1.769008, 2.614105>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.769008, 2.614105>,
      < 9.011996, -1.760434, 2.581719>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.760434, 2.581719>,
      < 9.011996, -1.708303, 2.519142>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.708303, 2.519142>,
      < 9.011996, -1.622743, 2.463698>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.622743, 2.463698>,
      < 9.011996, -1.558760, 2.446851>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.558760, 2.446851>,
      < 9.011996, -1.546386, 2.456632>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.546386, 2.456632>,
      < 9.011996, -1.565539, 2.487667>
    }
    triangle {
      < 9.011996, -1.596210, 2.611395>,
      < 9.011996, -1.565539, 2.487667>,
      < 9.011996, -1.591105, 2.563652>
    }
    triangle {
      < 9.011996, -1.455721, 2.391231>,
      < 9.011996, -1.504979, 2.437765>,
      < 9.011996, -1.512208, 2.412439>
    }
    triangle {
      < 9.011996, -1.783185, 2.569970>,
      < 9.011996, -1.803000, 2.644820>,
      < 8.999288, -1.817396, 2.644820>
    }
    triangle {
      < 9.011996, -1.783185, 2.569970>,
      < 8.999288, -1.817396, 2.644820>,
      < 8.999216, -1.796273, 2.564702>
    }
    triangle {
      < 9.011996, -1.725083, 2.500225>,
      < 9.011996, -1.783185, 2.569970>,
      < 8.999216, -1.796273, 2.564702>
    }
    triangle {
      < 9.011996, -1.725083, 2.500225>,
      < 8.999216, -1.796273, 2.564702>,
      < 8.999117, -1.734657, 2.490569>
    }
    triangle {
      < 9.011996, -1.632657, 2.440332>,
      < 9.011996, -1.725083, 2.500225>,
      < 8.999117, -1.734657, 2.490569>
    }
    triangle {
      < 9.011996, -1.632657, 2.440332>,
      < 8.999117, -1.734657, 2.490569>,
      < 8.999141, -1.636898, 2.427255>
    }
    triangle {
      < 9.011996, -1.512208, 2.412439>,
      < 9.011996, -1.632657, 2.440332>,
      < 8.999141, -1.636898, 2.427255>
    }
    triangle {
      < 9.011996, -1.512208, 2.412439>,
      < 8.999141, -1.636898, 2.427255>,
      < 8.999084, -1.510549, 2.397905>
    }
    triangle {
      < 9.011996, -1.512208, 2.412439>,
      < 8.999084, -1.510549, 2.397905>,
      < 9.011996, -1.455721, 2.391231>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.270059, -1.457104, 2.644820>,
      < 9.307826, -1.466830, 2.644820>
    }
    triangle {
      < 9.270059, -1.452059, 2.593728>,
      < 9.307826, -1.466830, 2.644820>,
      < 9.308381, -1.461597, 2.591746>
    }
    triangle {
      < 9.270059, -1.242382, 2.644820>,
      < 9.270059, -1.246052, 2.598547>,
      < 9.367479, -1.236482, 2.596803>
    }
    triangle {
      < 9.270059, -1.242382, 2.644820>,
      < 9.367479, -1.236482, 2.596803>,
      < 9.369174, -1.232667, 2.644820>
    }
    triangle {
      < 9.270059, -1.246052, 2.598547>,
      < 9.270059, -1.256751, 2.555614>,
      < 9.362471, -1.247656, 2.552050>
    }
    triangle {
      < 9.270059, -1.246052, 2.598547>,
      < 9.362471, -1.247656, 2.552050>,
      < 9.367479, -1.236482, 2.596803>
    }
    triangle {
      < 9.270059, -1.256751, 2.555614>,
      < 9.270059, -1.273519, 2.519037>,
      < 9.354388, -1.265352, 2.513546>
    }
    triangle {
      < 9.270059, -1.256751, 2.555614>,
      < 9.354388, -1.265352, 2.513546>,
      < 9.362471, -1.247656, 2.552050>
    }
    triangle {
      < 9.270059, -1.273519, 2.519037>,
      < 9.270059, -1.294850, 2.491002>,
      < 9.343640, -1.288234, 2.483577>
    }
    triangle {
      < 9.270059, -1.273519, 2.519037>,
      < 9.343640, -1.288234, 2.483577>,
      < 9.354388, -1.265352, 2.513546>
    }
    triangle {
      < 9.270059, -1.294850, 2.491002>,
      < 9.270059, -1.319076, 2.472493>,
      < 9.330718, -1.314826, 2.463363>
    }
    triangle {
      < 9.270059, -1.294850, 2.491002>,
      < 9.330718, -1.314826, 2.463363>,
      < 9.343640, -1.288234, 2.483577>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.270059, -1.341180, 2.465543>,
      < 9.317037, -1.340499, 2.455050>
    }
    triangle {
      < 9.270059, -1.319076, 2.472493>,
      < 9.317037, -1.340499, 2.455050>,
      < 9.330718, -1.314826, 2.463363>
    }
    triangle {
      < 9.270059, -1.341180, 2.465543>,
      < 9.270059, -1.363081, 2.468503>,
      < 9.316450, -1.366276, 2.458895>
    }
    triangle {
      < 9.270059, -1.341180, 2.465543>,
      < 9.316450, -1.366276, 2.458895>,
      < 9.317037, -1.340499, 2.455050>
    }
    triangle {
      < 9.270059, -1.363081, 2.468503>,
      < 9.270059, -1.389757, 2.483034>,
      < 9.314498, -1.395712, 2.475014>
    }
    triangle {
      < 9.270059, -1.363081, 2.468503>,
      < 9.314498, -1.395712, 2.475014>,
      < 9.316450, -1.366276, 2.458895>
    }
    triangle {
      < 9.270059, -1.389757, 2.483034>,
      < 9.270059, -1.415792, 2.509480>,
      < 9.312142, -1.423590, 2.503422>
    }
    triangle {
      < 9.270059, -1.389757, 2.483034>,
      < 9.312142, -1.423590, 2.503422>,
      < 9.314498, -1.395712, 2.475014>
    }
    triangle {
      < 9.270059, -1.415792, 2.509480>,
      < 9.270059, -1.437610, 2.547268>,
      < 9.309932, -1.446544, 2.543265>
    }
    triangle {
      < 9.270059, -1.415792, 2.509480>,
      < 9.309932, -1.446544, 2.543265>,
      < 9.312142, -1.423590, 2.503422>
    }
    triangle {
      < 9.270059, -1.437610, 2.547268>,
      < 9.270059, -1.452059, 2.593728>,
      < 9.308381, -1.461597, 2.591746>
    }
    triangle {
      < 9.270059, -1.437610, 2.547268>,
      < 9.308381, -1.461597, 2.591746>,
      < 9.309932, -1.446544, 2.543265>
    }
    triangle {
      < 9.314498, -1.395712, 2.475014>,
      < 9.312142, -1.423590, 2.503422>,
      < 9.319310, -1.432948, 2.496153>
    }
    triangle {
      < 9.314498, -1.395712, 2.475014>,
      < 9.319310, -1.432948, 2.496153>,
      < 9.322242, -1.402857, 2.465390>
    }
    triangle {
      < 9.312142, -1.423590, 2.503422>,
      < 9.309932, -1.446544, 2.543265>,
      < 9.316745, -1.457265, 2.538462>
    }
    triangle {
      < 9.312142, -1.423590, 2.503422>,
      < 9.316745, -1.457265, 2.538462>,
      < 9.319310, -1.432948, 2.496153>
    }
    triangle {
      < 9.309932, -1.446544, 2.543265>,
      < 9.308381, -1.461597, 2.591746>,
      < 9.315006, -1.473042, 2.589368>
    }
    triangle {
      < 9.309932, -1.446544, 2.543265>,
      < 9.315006, -1.473042, 2.589368>,
      < 9.316745, -1.457265, 2.538462>
    }
    triangle {
      < 9.308381, -1.461597, 2.591746>,
      < 9.307826, -1.466830, 2.644820>,
      < 9.314393, -1.478501, 2.644820>
    }
    triangle {
      < 9.308381, -1.461597, 2.591746>,
      < 9.314393, -1.478501, 2.644820>,
      < 9.315006, -1.473042, 2.589368>
    }
    triangle {
      < 9.369174, -1.232667, 2.644820>,
      < 9.367479, -1.236482, 2.596803>,
      < 9.380066, -1.224998, 2.594712>
    }
    triangle {
      < 9.369174, -1.232667, 2.644820>,
      < 9.380066, -1.224998, 2.594712>,
      < 9.381806, -1.221010, 2.644820>
    }
    triangle {
      < 9.367479, -1.236482, 2.596803>,
      < 9.362471, -1.247656, 2.552050>,
      < 9.374908, -1.236742, 2.547772>
    }
    triangle {
      < 9.367479, -1.236482, 2.596803>,
      < 9.374908, -1.236742, 2.547772>,
      < 9.380066, -1.224998, 2.594712>
    }
    triangle {
      < 9.362471, -1.247656, 2.552050>,
      < 9.354388, -1.265352, 2.513546>,
      < 9.366538, -1.255551, 2.506957>
    }
    triangle {
      < 9.362471, -1.247656, 2.552050>,
      < 9.366538, -1.255551, 2.506957>,
      < 9.374908, -1.236742, 2.547772>
    }
    triangle {
      < 9.354388, -1.265352, 2.513546>,
      < 9.343640, -1.288234, 2.483577>,
      < 9.355305, -1.280296, 2.474667>
    }
    triangle {
      < 9.354388, -1.265352, 2.513546>,
      < 9.355305, -1.280296, 2.474667>,
      < 9.366538, -1.255551, 2.506957>
    }
    triangle {
      < 9.343640, -1.288234, 2.483577>,
      < 9.330718, -1.314826, 2.463363>,
      < 9.341655, -1.309691, 2.452433>
    }
    triangle {
      < 9.343640, -1.288234, 2.483577>,
      < 9.341655, -1.309691, 2.452433>,
      < 9.355305, -1.280296, 2.474667>
    }
    triangle {
      < 9.330718, -1.314826, 2.463363>,
      < 9.317037, -1.340499, 2.455050>,
      < 9.326846, -1.339696, 2.442525>
    }
    triangle {
      < 9.330718, -1.314826, 2.463363>,
      < 9.326846, -1.339696, 2.442525>,
      < 9.341655, -1.309691, 2.452433>
    }
    triangle {
      < 9.317037, -1.340499, 2.455050>,
      < 9.316450, -1.366276, 2.458895>,
      < 9.325043, -1.370153, 2.447393>
    }
    triangle {
      < 9.317037, -1.340499, 2.455050>,
      < 9.325043, -1.370153, 2.447393>,
      < 9.326846, -1.339696, 2.442525>
    }
    triangle {
      < 9.316450, -1.366276, 2.458895>,
      < 9.314498, -1.395712, 2.475014>,
      < 9.322242, -1.402857, 2.465390>
    }
    triangle {
      < 9.316450, -1.366276, 2.458895>,
      < 9.322242, -1.402857, 2.465390>,
      < 9.325043, -1.370153, 2.447393>
    }
    triangle {
      < 9.341655, -1.309691, 2.452433>,
      < 9.326846, -1.339696, 2.442525>,
      < 9.331939, -1.338572, 2.424857>
    }
    triangle {
      < 9.341655, -1.309691, 2.452433>,
      < 9.331939, -1.338572, 2.424857>,
      < 9.348357, -1.302375, 2.436980>
    }
    triangle {
      < 9.326846, -1.339696, 2.442525>,
      < 9.325043, -1.370153, 2.447393>,
      < 9.328403, -1.375694, 2.431128>
    }
    triangle {
      < 9.326846, -1.339696, 2.442525>,
      < 9.328403, -1.375694, 2.431128>,
      < 9.331939, -1.338572, 2.424857>
    }
    triangle {
      < 9.325043, -1.370153, 2.447393>,
      < 9.322242, -1.402857, 2.465390>,
      < 9.324411, -1.412976, 2.451754>
    }
    triangle {
      < 9.325043, -1.370153, 2.447393>,
      < 9.324411, -1.412976, 2.451754>,
      < 9.328403, -1.375694, 2.431128>
    }
    triangle {
      < 9.322242, -1.402857, 2.465390>,
      < 9.319310, -1.432948, 2.496153>,
      < 9.320664, -1.446203, 2.485855>
    }
    triangle {
      < 9.322242, -1.402857, 2.465390>,
      < 9.320664, -1.446203, 2.485855>,
      < 9.324411, -1.412976, 2.451754>
    }
    triangle {
      < 9.319310, -1.432948, 2.496153>,
      < 9.316745, -1.457265, 2.538462>,
      < 9.317596, -1.472453, 2.531657>
    }
    triangle {
      < 9.319310, -1.432948, 2.496153>,
      < 9.317596, -1.472453, 2.531657>,
      < 9.320664, -1.446203, 2.485855>
    }
    triangle {
      < 9.316745, -1.457265, 2.538462>,
      < 9.315006, -1.473042, 2.589368>,
      < 9.315593, -1.489255, 2.585999>
    }
    triangle {
      < 9.316745, -1.457265, 2.538462>,
      < 9.315593, -1.489255, 2.585999>,
      < 9.317596, -1.472453, 2.531657>
    }
    triangle {
      < 9.315006, -1.473042, 2.589368>,
      < 9.314393, -1.478501, 2.644820>,
      < 9.314896, -1.495034, 2.644820>
    }
    triangle {
      < 9.315006, -1.473042, 2.589368>,
      < 9.314896, -1.495034, 2.644820>,
      < 9.315593, -1.489255, 2.585999>
    }
    triangle {
      < 9.381806, -1.221010, 2.644820>,
      < 9.380066, -1.224998, 2.594712>,
      < 9.389095, -1.208729, 2.591748>
    }
    triangle {
      < 9.381806, -1.221010, 2.644820>,
      < 9.389095, -1.208729, 2.591748>,
      < 9.390900, -1.204495, 2.644820>
    }
    triangle {
      < 9.380066, -1.224998, 2.594712>,
      < 9.374908, -1.236742, 2.547772>,
      < 9.383728, -1.221281, 2.541713>
    }
    triangle {
      < 9.380066, -1.224998, 2.594712>,
      < 9.383728, -1.221281, 2.541713>,
      < 9.389095, -1.208729, 2.591748>
    }
    triangle {
      < 9.374908, -1.236742, 2.547772>,
      < 9.366538, -1.255551, 2.506957>,
      < 9.374948, -1.241667, 2.497623>
    }
    triangle {
      < 9.374908, -1.236742, 2.547772>,
      < 9.374948, -1.241667, 2.497623>,
      < 9.383728, -1.221281, 2.541713>
    }
    triangle {
      < 9.366538, -1.255551, 2.506957>,
      < 9.355305, -1.280296, 2.474667>,
      < 9.363029, -1.269052, 2.462044>
    }
    triangle {
      < 9.366538, -1.255551, 2.506957>,
      < 9.363029, -1.269052, 2.462044>,
      < 9.374948, -1.241667, 2.497623>
    }
    triangle {
      < 9.355305, -1.280296, 2.474667>,
      < 9.341655, -1.309691, 2.452433>,
      < 9.348357, -1.302375, 2.436980>
    }
    triangle {
      < 9.355305, -1.280296, 2.474667>,
      < 9.348357, -1.302375, 2.436980>,
      < 9.363029, -1.269052, 2.462044>
    }
    triangle {
      < 9.390900, -1.204495, 2.644820>,
      < 9.389095, -1.208729, 2.591748>,
      < 9.388523, -1.192460, 2.588784>
    }
    triangle {
      < 9.390900, -1.204495, 2.644820>,
      < 9.388523, -1.192460, 2.588784>,
      < 9.390391, -1.187980, 2.644820>
    }
    triangle {
      < 9.389095, -1.208729, 2.591748>,
      < 9.383728, -1.221281, 2.541713>,
      < 9.382946, -1.205820, 2.535654>
    }
    triangle {
      < 9.389095, -1.208729, 2.591748>,
      < 9.382946, -1.205820, 2.535654>,
      < 9.388523, -1.192460, 2.588784>
    }
    triangle {
      < 9.383728, -1.221281, 2.541713>,
      < 9.374948, -1.241667, 2.497623>,
      < 9.373755, -1.227783, 2.488288>
    }
    triangle {
      < 9.383728, -1.221281, 2.541713>,
      < 9.373755, -1.227783, 2.488288>,
      < 9.382946, -1.205820, 2.535654>
    }
    triangle {
      < 9.374948, -1.241667, 2.497623>,
      < 9.363029, -1.269052, 2.462044>,
      < 9.361150, -1.257808, 2.449421>
    }
    triangle {
      < 9.374948, -1.241667, 2.497623>,
      < 9.361150, -1.257808, 2.449421>,
      < 9.373755, -1.227783, 2.488288>
    }
    triangle {
      < 9.363029, -1.269052, 2.462044>,
      < 9.348357, -1.302375, 2.436980>,
      < 9.345465, -1.295034, 2.421546>
    }
    triangle {
      < 9.363029, -1.269052, 2.462044>,
      < 9.345465, -1.295034, 2.421546>,
      < 9.361150, -1.257808, 2.449421>
    }
    triangle {
      < 9.348357, -1.302375, 2.436980>,
      < 9.331939, -1.338572, 2.424857>,
      < 9.327429, -1.337455, 2.407234>
    }
    triangle {
      < 9.348357, -1.302375, 2.436980>,
      < 9.327429, -1.337455, 2.407234>,
      < 9.345465, -1.295034, 2.421546>
    }
    triangle {
      < 9.331939, -1.338572, 2.424857>,
      < 9.328403, -1.375694, 2.431128>,
      < 9.322154, -1.381266, 2.414880>
    }
    triangle {
      < 9.331939, -1.338572, 2.424857>,
      < 9.322154, -1.381266, 2.414880>,
      < 9.327429, -1.337455, 2.407234>
    }
    triangle {
      < 9.328403, -1.375694, 2.431128>,
      < 9.324411, -1.412976, 2.451754>,
      < 9.316981, -1.423095, 2.438118>
    }
    triangle {
      < 9.328403, -1.375694, 2.431128>,
      < 9.316981, -1.423095, 2.438118>,
      < 9.322154, -1.381266, 2.414880>
    }
    triangle {
      < 9.324411, -1.412976, 2.451754>,
      < 9.320664, -1.446203, 2.485855>,
      < 9.312419, -1.459459, 2.475556>
    }
    triangle {
      < 9.324411, -1.412976, 2.451754>,
      < 9.312419, -1.459459, 2.475556>,
      < 9.316981, -1.423095, 2.438118>
    }
    triangle {
      < 9.320664, -1.446203, 2.485855>,
      < 9.317596, -1.472453, 2.531657>,
      < 9.308848, -1.487641, 2.524852>
    }
    triangle {
      < 9.320664, -1.446203, 2.485855>,
      < 9.308848, -1.487641, 2.524852>,
      < 9.312419, -1.459459, 2.475556>
    }
    triangle {
      < 9.317596, -1.472453, 2.531657>,
      < 9.315593, -1.489255, 2.585999>,
      < 9.306579, -1.505469, 2.582629>
    }
    triangle {
      < 9.317596, -1.472453, 2.531657>,
      < 9.306579, -1.505469, 2.582629>,
      < 9.308848, -1.487641, 2.524852>
    }
    triangle {
      < 9.315593, -1.489255, 2.585999>,
      < 9.314896, -1.495034, 2.644820>,
      < 9.305799, -1.511568, 2.644820>
    }
    triangle {
      < 9.315593, -1.489255, 2.585999>,
      < 9.305799, -1.511568, 2.644820>,
      < 9.306579, -1.505469, 2.582629>
    }
    triangle {
      < 9.306579, -1.505469, 2.582629>,
      < 9.305799, -1.511568, 2.644820>,
      < 9.291270, -1.521293, 2.644820>
    }
    triangle {
      < 9.306579, -1.505469, 2.582629>,
      < 9.291270, -1.521293, 2.644820>,
      < 9.292098, -1.515007, 2.580647>
    }
    triangle {
      < 9.390391, -1.187980, 2.644820>,
      < 9.388523, -1.192460, 2.588784>,
      < 9.379009, -1.182890, 2.587041>
    }
    triangle {
      < 9.390391, -1.187980, 2.644820>,
      < 9.379009, -1.182890, 2.587041>,
      < 9.380916, -1.178265, 2.644820>
    }
    triangle {
      < 9.388523, -1.192460, 2.588784>,
      < 9.382946, -1.205820, 2.535654>,
      < 9.373309, -1.196726, 2.532090>
    }
    triangle {
      < 9.388523, -1.192460, 2.588784>,
      < 9.373309, -1.196726, 2.532090>,
      < 9.379009, -1.182890, 2.587041>
    }
    triangle {
      < 9.382946, -1.205820, 2.535654>,
      < 9.373755, -1.227783, 2.488288>,
      < 9.363877, -1.219617, 2.482797>
    }
    triangle {
      < 9.382946, -1.205820, 2.535654>,
      < 9.363877, -1.219617, 2.482797>,
      < 9.373309, -1.196726, 2.532090>
    }
    triangle {
      < 9.373755, -1.227783, 2.488288>,
      < 9.361150, -1.257808, 2.449421>,
      < 9.350867, -1.251195, 2.441995>
    }
    triangle {
      < 9.373755, -1.227783, 2.488288>,
      < 9.350867, -1.251195, 2.441995>,
      < 9.363877, -1.219617, 2.482797>
    }
    triangle {
      < 9.361150, -1.257808, 2.449421>,
      < 9.345465, -1.295034, 2.421546>,
      < 9.334587, -1.290710, 2.412472>
    }
    triangle {
      < 9.361150, -1.257808, 2.449421>,
      < 9.334587, -1.290710, 2.412472>,
      < 9.350867, -1.251195, 2.441995>
    }
    triangle {
      < 9.345465, -1.295034, 2.421546>,
      < 9.327429, -1.337455, 2.407234>,
      < 9.315598, -1.336800, 2.396878>
    }
    triangle {
      < 9.345465, -1.295034, 2.421546>,
      < 9.315598, -1.336800, 2.396878>,
      < 9.334587, -1.290710, 2.412472>
    }
    triangle {
      < 9.327429, -1.337455, 2.407234>,
      < 9.322154, -1.381266, 2.414880>,
      < 9.309299, -1.384550, 2.405327>
    }
    triangle {
      < 9.327429, -1.337455, 2.407234>,
      < 9.309299, -1.384550, 2.405327>,
      < 9.315598, -1.336800, 2.396878>
    }
    triangle {
      < 9.322154, -1.381266, 2.414880>,
      < 9.316981, -1.423095, 2.438118>,
      < 9.303433, -1.429047, 2.430096>
    }
    triangle {
      < 9.322154, -1.381266, 2.414880>,
      < 9.303433, -1.429047, 2.430096>,
      < 9.309299, -1.384550, 2.405327>
    }
    triangle {
      < 9.316981, -1.423095, 2.438118>,
      < 9.312419, -1.459459, 2.475556>,
      < 9.298392, -1.467256, 2.469498>
    }
    triangle {
      < 9.316981, -1.423095, 2.438118>,
      < 9.298392, -1.467256, 2.469498>,
      < 9.303433, -1.429047, 2.430096>
    }
    triangle {
      < 9.312419, -1.459459, 2.475556>,
      < 9.308848, -1.487641, 2.524852>,
      < 9.294526, -1.496575, 2.520849>
    }
    triangle {
      < 9.312419, -1.459459, 2.475556>,
      < 9.294526, -1.496575, 2.520849>,
      < 9.298392, -1.467256, 2.469498>
    }
    triangle {
      < 9.308848, -1.487641, 2.524852>,
      < 9.306579, -1.505469, 2.582629>,
      < 9.292098, -1.515007, 2.580647>
    }
    triangle {
      < 9.308848, -1.487641, 2.524852>,
      < 9.292098, -1.515007, 2.580647>,
      < 9.294526, -1.496575, 2.520849>
    }
    triangle {
      < 8.460090, -1.282344, 2.384554>,
      < 8.302703, -1.293414, 2.381948>,
      < 8.335473, -1.231890, 2.401848>
    }
    triangle {
      < 8.981197, -1.427040, 2.376605>,
      < 8.981197, -1.455721, 2.391231>,
      < 8.205842, -1.472367, 2.393822>
    }
    triangle {
      < 8.981197, -1.427040, 2.376605>,
      < 8.205842, -1.472367, 2.393822>,
      < 8.208865, -1.466886, 2.392249>
    }
    triangle {
      < 8.981197, -1.427040, 2.376605>,
      < 8.208865, -1.466886, 2.392249>,
      < 8.459869, -1.411076, 2.387335>
    }
    triangle {
      < 8.319522, -1.348837, 2.384191>,
      < 8.460090, -1.282344, 2.384554>,
      < 8.448472, -1.346491, 2.316001>
    }
    triangle {
      < 8.319522, -1.348837, 2.384191>,
      < 8.448472, -1.346491, 2.316001>,
      < 8.459869, -1.411076, 2.387335>
    }
    triangle {
      < 9.114798, -1.336800, 2.338804>,
      < 9.114798, -1.277995, 2.370095>,
      < 9.219997, -1.336800, 2.375373>
    }
    triangle {
      < 9.114798, -1.336800, 2.338804>,
      < 9.219997, -1.336800, 2.375373>,
      < 9.114798, -1.395606, 2.370095>
    }
    triangle {
      < 8.981197, -1.336800, 2.299201>,
      < 8.981197, -1.427040, 2.376605>,
      < 8.459869, -1.411076, 2.387335>
    }
    triangle {
      < 8.981197, -1.336800, 2.299201>,
      < 8.459869, -1.411076, 2.387335>,
      < 8.448472, -1.346491, 2.316001>
    }
    triangle {
      < 8.981197, -1.246561, 2.376605>,
      < 8.981197, -1.336800, 2.299201>,
      < 8.448472, -1.346491, 2.316001>
    }
    triangle {
      < 8.981197, -1.246561, 2.376605>,
      < 8.448472, -1.346491, 2.316001>,
      < 8.460090, -1.282344, 2.384554>
    }
    triangle {
      < 8.981197, -1.455721, 2.391231>,
      < 8.981197, -1.506510, 2.391231>,
      < 8.170268, -1.538336, 2.406514>
    }
    triangle {
      < 8.981197, -1.455721, 2.391231>,
      < 8.170268, -1.538336, 2.406514>,
      < 8.205842, -1.472367, 2.393822>
    }
    triangle {
      < 8.459869, -1.411076, 2.387335>,
      < 8.208865, -1.466886, 2.392249>,
      < 8.230967, -1.425997, 2.390388>
    }
    triangle {
      < 8.981197, -1.506510, 2.391231>,
      < 8.981197, -1.637952, 2.421669>,
      < 8.093800, -1.679864, 2.436767>
    }
    triangle {
      < 8.981197, -1.506510, 2.391231>,
      < 8.093800, -1.679864, 2.436767>,
      < 8.170268, -1.538336, 2.406514>
    }
    triangle {
      < 8.319522, -1.348837, 2.384191>,
      < 8.459869, -1.411076, 2.387335>,
      < 8.230967, -1.425997, 2.390388>
    }
    triangle {
      < 8.319522, -1.348837, 2.384191>,
      < 8.230967, -1.425997, 2.390388>,
      < 8.267190, -1.359515, 2.384410>
    }
    triangle {
      < 8.981197, -1.098959, 2.644820>,
      < 8.981197, -1.107063, 2.569031>,
      < 8.400378, -1.108249, 2.571100>
    }
    triangle {
      < 8.981197, -1.098959, 2.644820>,
      < 8.400378, -1.108249, 2.571100>,
      < 8.405093, -1.099273, 2.644820>
    }
    triangle {
      < 8.981197, -1.107063, 2.569031>,
      < 8.981197, -1.130823, 2.498410>,
      < 8.386551, -1.134575, 2.502693>
    }
    triangle {
      < 8.981197, -1.107063, 2.569031>,
      < 8.386551, -1.134575, 2.502693>,
      < 8.400378, -1.108249, 2.571100>
    }
    triangle {
      < 8.981197, -1.130823, 2.498410>,
      < 8.981197, -1.168621, 2.437765>,
      < 8.364557, -1.176428, 2.444590>
    }
    triangle {
      < 8.981197, -1.130823, 2.498410>,
      < 8.364557, -1.176428, 2.444590>,
      < 8.386551, -1.134575, 2.502693>
    }
    triangle {
      < 8.981197, -1.168621, 2.437765>,
      < 8.981197, -1.217880, 2.391231>,
      < 8.339134, -1.223811, 2.405575>
    }
    triangle {
      < 8.981197, -1.168621, 2.437765>,
      < 8.339134, -1.223811, 2.405575>,
      < 8.364557, -1.176428, 2.444590>
    }
    triangle {
      < 8.339134, -1.223811, 2.405575>,
      < 8.981197, -1.217880, 2.391231>,
      < 8.981197, -1.246561, 2.376605>
    }
    triangle {
      < 8.339134, -1.223811, 2.405575>,
      < 8.981197, -1.246561, 2.376605>,
      < 8.460090, -1.282344, 2.384554>
    }
    triangle {
      < 8.339134, -1.223811, 2.405575>,
      < 8.460090, -1.282344, 2.384554>,
      < 8.335473, -1.231890, 2.401848>
    }
    triangle {
      < 8.460090, -1.282344, 2.384554>,
      < 8.319522, -1.348837, 2.384191>,
      < 8.267190, -1.359515, 2.384410>
    }
    triangle {
      < 8.460090, -1.282344, 2.384554>,
      < 8.267190, -1.359515, 2.384410>,
      < 8.302703, -1.293414, 2.381948>
    }
    triangle {
      < 8.981197, -1.637952, 2.421669>,
      < 8.981197, -1.738812, 2.487029>,
      < 8.080274, -1.783448, 2.496820>
    }
    triangle {
      < 8.981197, -1.637952, 2.421669>,
      < 8.080274, -1.783448, 2.496820>,
      < 8.093800, -1.679864, 2.436767>
    }
    triangle {
      < 8.981197, -1.802217, 2.563139>,
      < 8.981197, -1.823841, 2.644820>,
      < 8.092828, -1.873096, 2.644820>
    }
    triangle {
      < 8.981197, -1.802217, 2.563139>,
      < 8.092828, -1.873096, 2.644820>,
      < 8.085253, -1.849633, 2.567045>
    }
    triangle {
      < 8.981197, -1.738812, 2.487029>,
      < 8.981197, -1.802217, 2.563139>,
      < 8.085253, -1.849633, 2.567045>
    }
    triangle {
      < 8.981197, -1.738812, 2.487029>,
      < 8.085253, -1.849633, 2.567045>,
      < 8.080274, -1.783448, 2.496820>
    }
    triangle {
      < 8.999084, -1.510549, 2.397905>,
      < 8.981197, -1.506510, 2.391231>,
      < 8.981197, -1.455721, 2.391231>
    }
    triangle {
      < 8.999084, -1.510549, 2.397905>,
      < 8.981197, -1.455721, 2.391231>,
      < 9.011996, -1.455721, 2.391231>
    }
    triangle {
      < 8.981197, -1.823841, 2.644820>,
      < 8.981197, -1.802217, 2.563139>,
      < 8.999216, -1.796273, 2.564702>
    }
    triangle {
      < 8.981197, -1.823841, 2.644820>,
      < 8.999216, -1.796273, 2.564702>,
      < 8.999288, -1.817396, 2.644820>
    }
    triangle {
      < 8.981197, -1.802217, 2.563139>,
      < 8.981197, -1.738812, 2.487029>,
      < 8.999117, -1.734657, 2.490569>
    }
    triangle {
      < 8.981197, -1.802217, 2.563139>,
      < 8.999117, -1.734657, 2.490569>,
      < 8.999216, -1.796273, 2.564702>
    }
    triangle {
      < 8.981197, -1.738812, 2.487029>,
      < 8.981197, -1.637952, 2.421669>,
      < 8.999141, -1.636898, 2.427255>
    }
    triangle {
      < 8.981197, -1.738812, 2.487029>,
      < 8.999141, -1.636898, 2.427255>,
      < 8.999117, -1.734657, 2.490569>
    }
    triangle {
      < 8.981197, -1.637952, 2.421669>,
      < 8.981197, -1.506510, 2.391231>,
      < 8.999084, -1.510549, 2.397905>
    }
    triangle {
      < 8.981197, -1.637952, 2.421669>,
      < 8.999084, -1.510549, 2.397905>,
      < 8.999141, -1.636898, 2.427255>
    }
    triangle {
      < 9.011996, -1.455721, 2.391231>,
      < 8.981197, -1.455721, 2.391231>,
      < 8.981197, -1.427040, 2.376605>
    }
    triangle {
      < 9.011996, -1.455721, 2.391231>,
      < 8.981197, -1.427040, 2.376605>,
      < 9.011996, -1.427040, 2.376605>
    }
    triangle {
      < 8.981197, -1.427040, 2.376605>,
      < 8.981197, -1.336800, 2.299201>,
      < 9.011996, -1.336800, 2.304001>
    }
    triangle {
      < 8.981197, -1.427040, 2.376605>,
      < 9.011996, -1.336800, 2.304001>,
      < 9.011996, -1.427040, 2.376605>
    }
    triangle {
      < 8.981197, -1.246561, 2.376605>,
      < 9.011996, -1.246561, 2.376605>,
      < 9.011996, -1.336800, 2.304001>
    }
    triangle {
      < 8.981197, -1.246561, 2.376605>,
      < 9.011996, -1.336800, 2.304001>,
      < 8.981197, -1.336800, 2.299201>
    }
    triangle {
      < 8.981197, -1.246561, 2.376605>,
      < 8.981197, -1.217880, 2.391231>,
      < 9.011996, -1.217880, 2.391231>
    }
    triangle {
      < 8.981197, -1.246561, 2.376605>,
      < 9.011996, -1.217880, 2.391231>,
      < 9.011996, -1.246561, 2.376605>
    }
    triangle {
      < 8.981197, -1.217880, 2.391231>,
      < 8.981197, -1.168621, 2.437765>,
      < 9.011996, -1.168621, 2.437765>
    }
    triangle {
      < 8.981197, -1.217880, 2.391231>,
      < 9.011996, -1.168621, 2.437765>,
      < 9.011996, -1.217880, 2.391231>
    }
    triangle {
      < 8.981197, -1.168621, 2.437765>,
      < 8.981197, -1.130823, 2.498410>,
      < 9.011996, -1.130823, 2.498410>
    }
    triangle {
      < 8.981197, -1.168621, 2.437765>,
      < 9.011996, -1.130823, 2.498410>,
      < 9.011996, -1.168621, 2.437765>
    }
    triangle {
      < 8.981197, -1.130823, 2.498410>,
      < 8.981197, -1.107063, 2.569031>,
      < 9.011996, -1.107063, 2.569031>
    }
    triangle {
      < 8.981197, -1.130823, 2.498410>,
      < 9.011996, -1.107063, 2.569031>,
      < 9.011996, -1.130823, 2.498410>
    }
    triangle {
      < 8.981197, -1.107063, 2.569031>,
      < 8.981197, -1.098959, 2.644820>,
      < 9.011996, -1.098959, 2.644820>
    }
    triangle {
      < 8.981197, -1.107063, 2.569031>,
      < 9.011996, -1.098959, 2.644820>,
      < 9.011996, -1.107063, 2.569031>
    }
    triangle {
      < 9.011996, -1.574642, 2.644820>,
      < 9.011996, -1.566538, 2.569031>,
      < 9.114798, -1.556264, 2.571207>
    }
    triangle {
      < 9.011996, -1.574642, 2.644820>,
      < 9.114798, -1.556264, 2.571207>,
      < 9.114798, -1.564006, 2.644820>
    }
    triangle {
      < 9.011996, -1.566538, 2.569031>,
      < 9.011996, -1.542776, 2.498410>,
      < 9.114798, -1.533566, 2.502611>
    }
    triangle {
      < 9.011996, -1.566538, 2.569031>,
      < 9.114798, -1.533566, 2.502611>,
      < 9.114798, -1.556264, 2.571207>
    }
    triangle {
      < 9.011996, -1.542776, 2.498410>,
      < 9.011996, -1.504979, 2.437765>,
      < 9.114798, -1.497459, 2.443707>
    }
    triangle {
      < 9.011996, -1.542776, 2.498410>,
      < 9.114798, -1.497459, 2.443707>,
      < 9.114798, -1.533566, 2.502611>
    }
    triangle {
      < 9.011996, -1.504979, 2.437765>,
      < 9.011996, -1.455721, 2.391231>,
      < 9.114798, -1.450403, 2.398508>
    }
    triangle {
      < 9.011996, -1.504979, 2.437765>,
      < 9.114798, -1.450403, 2.398508>,
      < 9.114798, -1.497459, 2.443707>
    }
    triangle {
      < 9.011996, -1.455721, 2.391231>,
      < 9.011996, -1.427040, 2.376605>,
      < 9.114798, -1.395606, 2.370095>
    }
    triangle {
      < 9.011996, -1.455721, 2.391231>,
      < 9.114798, -1.395606, 2.370095>,
      < 9.114798, -1.450403, 2.398508>
    }
    triangle {
      < 9.011996, -1.427040, 2.376605>,
      < 9.011996, -1.336800, 2.304001>,
      < 9.114798, -1.336800, 2.338804>
    }
    triangle {
      < 9.011996, -1.427040, 2.376605>,
      < 9.114798, -1.336800, 2.338804>,
      < 9.114798, -1.395606, 2.370095>
    }
    triangle {
      < 9.011996, -1.336800, 2.304001>,
      < 9.011996, -1.246561, 2.376605>,
      < 9.114798, -1.277995, 2.370095>
    }
    triangle {
      < 9.011996, -1.336800, 2.304001>,
      < 9.114798, -1.277995, 2.370095>,
      < 9.114798, -1.336800, 2.338804>
    }
    triangle {
      < 9.011996, -1.246561, 2.376605>,
      < 9.011996, -1.217880, 2.391231>,
      < 9.114798, -1.223197, 2.398508>
    }
    triangle {
      < 9.011996, -1.246561, 2.376605>,
      < 9.114798, -1.223197, 2.398508>,
      < 9.114798, -1.277995, 2.370095>
    }
    triangle {
      < 9.011996, -1.217880, 2.391231>,
      < 9.011996, -1.168621, 2.437765>,
      < 9.114798, -1.176142, 2.443707>
    }
    triangle {
      < 9.011996, -1.217880, 2.391231>,
      < 9.114798, -1.176142, 2.443707>,
      < 9.114798, -1.223197, 2.398508>
    }
    triangle {
      < 9.011996, -1.168621, 2.437765>,
      < 9.011996, -1.130823, 2.498410>,
      < 9.114798, -1.140034, 2.502611>
    }
    triangle {
      < 9.011996, -1.168621, 2.437765>,
      < 9.114798, -1.140034, 2.502611>,
      < 9.114798, -1.176142, 2.443707>
    }
    triangle {
      < 9.011996, -1.130823, 2.498410>,
      < 9.011996, -1.107063, 2.569031>,
      < 9.114798, -1.117336, 2.571207>
    }
    triangle {
      < 9.011996, -1.130823, 2.498410>,
      < 9.114798, -1.117336, 2.571207>,
      < 9.114798, -1.140034, 2.502611>
    }
    triangle {
      < 9.011996, -1.107063, 2.569031>,
      < 9.011996, -1.098959, 2.644820>,
      < 9.114798, -1.109594, 2.644820>
    }
    triangle {
      < 9.011996, -1.107063, 2.569031>,
      < 9.114798, -1.109594, 2.644820>,
      < 9.114798, -1.117336, 2.571207>
    }
    triangle {
      < 9.114798, -1.140034, 2.502611>,
      < 9.114798, -1.117336, 2.571207>,
      < 9.219997, -1.131464, 2.575081>
    }
    triangle {
      < 9.114798, -1.140034, 2.502611>,
      < 9.219997, -1.131464, 2.575081>,
      < 9.219997, -1.152701, 2.510096>
    }
    triangle {
      < 9.114798, -1.117336, 2.571207>,
      < 9.114798, -1.109594, 2.644820>,
      < 9.219997, -1.124221, 2.644820>
    }
    triangle {
      < 9.114798, -1.117336, 2.571207>,
      < 9.219997, -1.124221, 2.644820>,
      < 9.219997, -1.131464, 2.575081>
    }
    triangle {
      < 9.114798, -1.564006, 2.644820>,
      < 9.114798, -1.556264, 2.571207>,
      < 9.219997, -1.542136, 2.575081>
    }
    triangle {
      < 9.114798, -1.564006, 2.644820>,
      < 9.219997, -1.542136, 2.575081>,
      < 9.219997, -1.549379, 2.644820>
    }
    triangle {
      < 9.114798, -1.556264, 2.571207>,
      < 9.114798, -1.533566, 2.502611>,
      < 9.219997, -1.520899, 2.510096>
    }
    triangle {
      < 9.114798, -1.556264, 2.571207>,
      < 9.219997, -1.520899, 2.510096>,
      < 9.219997, -1.542136, 2.575081>
    }
    triangle {
      < 9.114798, -1.533566, 2.502611>,
      < 9.114798, -1.497459, 2.443707>,
      < 9.219997, -1.487116, 2.454291>
    }
    triangle {
      < 9.114798, -1.533566, 2.502611>,
      < 9.219997, -1.487116, 2.454291>,
      < 9.219997, -1.520899, 2.510096>
    }
    triangle {
      < 9.114798, -1.497459, 2.443707>,
      < 9.114798, -1.450403, 2.398508>,
      < 9.219997, -1.443090, 2.411471>
    }
    triangle {
      < 9.114798, -1.497459, 2.443707>,
      < 9.219997, -1.443090, 2.411471>,
      < 9.219997, -1.487116, 2.454291>
    }
    triangle {
      < 9.114798, -1.450403, 2.398508>,
      < 9.114798, -1.395606, 2.370095>,
      < 9.219997, -1.391820, 2.384554>
    }
    triangle {
      < 9.114798, -1.450403, 2.398508>,
      < 9.219997, -1.391820, 2.384554>,
      < 9.219997, -1.443090, 2.411471>
    }
    triangle {
      < 9.114798, -1.395606, 2.370095>,
      < 9.219997, -1.336800, 2.375373>,
      < 9.219997, -1.391820, 2.384554>
    }
    triangle {
      < 9.114798, -1.277995, 2.370095>,
      < 9.219997, -1.281780, 2.384554>,
      < 9.219997, -1.336800, 2.375373>
    }
    triangle {
      < 9.114798, -1.277995, 2.370095>,
      < 9.114798, -1.223197, 2.398508>,
      < 9.219997, -1.230511, 2.411471>
    }
    triangle {
      < 9.114798, -1.277995, 2.370095>,
      < 9.219997, -1.230511, 2.411471>,
      < 9.219997, -1.281780, 2.384554>
    }
    triangle {
      < 9.114798, -1.223197, 2.398508>,
      < 9.114798, -1.176142, 2.443707>,
      < 9.219997, -1.186484, 2.454291>
    }
    triangle {
      < 9.114798, -1.223197, 2.398508>,
      < 9.219997, -1.186484, 2.454291>,
      < 9.219997, -1.230511, 2.411471>
    }
    triangle {
      < 9.114798, -1.176142, 2.443707>,
      < 9.114798, -1.140034, 2.502611>,
      < 9.219997, -1.152701, 2.510096>
    }
    triangle {
      < 9.114798, -1.176142, 2.443707>,
      < 9.219997, -1.152701, 2.510096>,
      < 9.219997, -1.186484, 2.454291>
    }
    triangle {
      < 9.219997, -1.281780, 2.384554>,
      < 9.219997, -1.230511, 2.411471>,
      < 9.315598, -1.243755, 2.430096>
    }
    triangle {
      < 9.219997, -1.281780, 2.384554>,
      < 9.315598, -1.243755, 2.430096>,
      < 9.315598, -1.288637, 2.405327>
    }
    triangle {
      < 9.219997, -1.230511, 2.411471>,
      < 9.219997, -1.186484, 2.454291>,
      < 9.315598, -1.205215, 2.469498>
    }
    triangle {
      < 9.219997, -1.230511, 2.411471>,
      < 9.315598, -1.205215, 2.469498>,
      < 9.315598, -1.243755, 2.430096>
    }
    triangle {
      < 9.219997, -1.186484, 2.454291>,
      < 9.219997, -1.152701, 2.510096>,
      < 9.315598, -1.175642, 2.520849>
    }
    triangle {
      < 9.219997, -1.186484, 2.454291>,
      < 9.315598, -1.175642, 2.520849>,
      < 9.315598, -1.205215, 2.469498>
    }
    triangle {
      < 9.219997, -1.152701, 2.510096>,
      < 9.219997, -1.131464, 2.575081>,
      < 9.315598, -1.157051, 2.580647>
    }
    triangle {
      < 9.219997, -1.152701, 2.510096>,
      < 9.315598, -1.157051, 2.580647>,
      < 9.315598, -1.175642, 2.520849>
    }
    triangle {
      < 9.219997, -1.131464, 2.575081>,
      < 9.219997, -1.124221, 2.644820>,
      < 9.315598, -1.150710, 2.644820>
    }
    triangle {
      < 9.219997, -1.131464, 2.575081>,
      < 9.315598, -1.150710, 2.644820>,
      < 9.315598, -1.157051, 2.580647>
    }
    triangle {
      < 9.219997, -1.549379, 2.644820>,
      < 9.219997, -1.542136, 2.575081>,
      < 9.292098, -1.515007, 2.580647>
    }
    triangle {
      < 9.219997, -1.549379, 2.644820>,
      < 9.292098, -1.515007, 2.580647>,
      < 9.291270, -1.521293, 2.644820>
    }
    triangle {
      < 9.219997, -1.542136, 2.575081>,
      < 9.219997, -1.520899, 2.510096>,
      < 9.294526, -1.496575, 2.520849>
    }
    triangle {
      < 9.219997, -1.542136, 2.575081>,
      < 9.294526, -1.496575, 2.520849>,
      < 9.292098, -1.515007, 2.580647>
    }
    triangle {
      < 9.219997, -1.520899, 2.510096>,
      < 9.219997, -1.487116, 2.454291>,
      < 9.298392, -1.467256, 2.469498>
    }
    triangle {
      < 9.219997, -1.520899, 2.510096>,
      < 9.298392, -1.467256, 2.469498>,
      < 9.294526, -1.496575, 2.520849>
    }
    triangle {
      < 9.219997, -1.487116, 2.454291>,
      < 9.219997, -1.443090, 2.411471>,
      < 9.303433, -1.429047, 2.430096>
    }
    triangle {
      < 9.219997, -1.487116, 2.454291>,
      < 9.303433, -1.429047, 2.430096>,
      < 9.298392, -1.467256, 2.469498>
    }
    triangle {
      < 9.219997, -1.443090, 2.411471>,
      < 9.219997, -1.391820, 2.384554>,
      < 9.309299, -1.384550, 2.405327>
    }
    triangle {
      < 9.219997, -1.443090, 2.411471>,
      < 9.309299, -1.384550, 2.405327>,
      < 9.303433, -1.429047, 2.430096>
    }
    triangle {
      < 9.219997, -1.391820, 2.384554>,
      < 9.219997, -1.336800, 2.375373>,
      < 9.315598, -1.336800, 2.396878>
    }
    triangle {
      < 9.219997, -1.391820, 2.384554>,
      < 9.315598, -1.336800, 2.396878>,
      < 9.309299, -1.384550, 2.405327>
    }
    triangle {
      < 9.219997, -1.336800, 2.375373>,
      < 9.219997, -1.281780, 2.384554>,
      < 9.315598, -1.288637, 2.405327>
    }
    triangle {
      < 9.219997, -1.336800, 2.375373>,
      < 9.315598, -1.288637, 2.405327>,
      < 9.315598, -1.336800, 2.396878>
    }
    triangle {
      < 9.315598, -1.336800, 2.396878>,
      < 9.315598, -1.288637, 2.405327>,
      < 9.334587, -1.290710, 2.412472>
    }
    triangle {
      < 9.334587, -1.290710, 2.412472>,
      < 9.315598, -1.288637, 2.405327>,
      < 9.315598, -1.243755, 2.430096>
    }
    triangle {
      < 9.334587, -1.290710, 2.412472>,
      < 9.315598, -1.243755, 2.430096>,
      < 9.350867, -1.251195, 2.441995>
    }
    triangle {
      < 9.350867, -1.251195, 2.441995>,
      < 9.315598, -1.243755, 2.430096>,
      < 9.315598, -1.205215, 2.469498>
    }
    triangle {
      < 9.350867, -1.251195, 2.441995>,
      < 9.315598, -1.205215, 2.469498>,
      < 9.363877, -1.219617, 2.482797>
    }
    triangle {
      < 9.363877, -1.219617, 2.482797>,
      < 9.315598, -1.205215, 2.469498>,
      < 9.315598, -1.175642, 2.520849>
    }
    triangle {
      < 9.363877, -1.219617, 2.482797>,
      < 9.315598, -1.175642, 2.520849>,
      < 9.373309, -1.196726, 2.532090>
    }
    triangle {
      < 9.373309, -1.196726, 2.532090>,
      < 9.315598, -1.175642, 2.520849>,
      < 9.315598, -1.157051, 2.580647>
    }
    triangle {
      < 9.373309, -1.196726, 2.532090>,
      < 9.315598, -1.157051, 2.580647>,
      < 9.379009, -1.182890, 2.587041>
    }
    triangle {
      < 9.379009, -1.182890, 2.587041>,
      < 9.315598, -1.157051, 2.580647>,
      < 9.315598, -1.150710, 2.644820>
    }
    triangle {
      < 9.379009, -1.182890, 2.587041>,
      < 9.315598, -1.150710, 2.644820>,
      < 9.380916, -1.178265, 2.644820>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.249680, -1.349446, 2.887426>,
      < 8.282547, -1.289467, 2.887181>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.282547, -1.289467, 2.887181>,
      < 8.313235, -1.233391, 2.867699>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.313235, -1.233391, 2.867699>,
      < 8.339499, -1.185391, 2.826924>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.339499, -1.185391, 2.826924>,
      < 8.359615, -1.148616, 2.773684>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.359615, -1.148616, 2.773684>,
      < 8.372250, -1.125510, 2.711565>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.372250, -1.125510, 2.711565>,
      < 8.376558, -1.117629, 2.644820>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.376558, -1.117629, 2.644820>,
      < 8.372250, -1.125510, 2.578075>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.372250, -1.125510, 2.578075>,
      < 8.359615, -1.148616, 2.515956>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.359615, -1.148616, 2.515956>,
      < 8.339499, -1.185391, 2.462717>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.339499, -1.185391, 2.462717>,
      < 8.313235, -1.233391, 2.421941>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.313235, -1.233391, 2.421941>,
      < 8.282547, -1.289467, 2.402460>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.282547, -1.289467, 2.402460>,
      < 8.249680, -1.349446, 2.402216>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.249680, -1.349446, 2.402216>,
      < 8.214829, -1.413472, 2.406681>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.214829, -1.413472, 2.406681>,
      < 8.184558, -1.469478, 2.412012>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.184558, -1.469478, 2.412012>,
      < 8.154132, -1.525767, 2.423417>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.154132, -1.525767, 2.423417>,
      < 8.077214, -1.667549, 2.452427>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.077214, -1.667549, 2.452427>,
      < 8.065619, -1.771058, 2.510228>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.065619, -1.771058, 2.510228>,
      < 8.072523, -1.834216, 2.575953>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.072523, -1.834216, 2.575953>,
      < 8.080665, -1.855267, 2.644820>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.080665, -1.855267, 2.644820>,
      < 8.072523, -1.834216, 2.713687>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.072523, -1.834216, 2.713687>,
      < 8.065619, -1.771058, 2.779412>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.065619, -1.771058, 2.779412>,
      < 8.077214, -1.667549, 2.837213>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.077214, -1.667549, 2.837213>,
      < 8.154132, -1.525767, 2.866223>
    }
    triangle {
      < 8.214829, -1.413472, 2.882961>,
      < 8.154132, -1.525767, 2.866223>,
      < 8.184558, -1.469478, 2.877629>
    }
    triangle {
      < 8.208865, -1.466886, 2.392249>,
      < 8.205842, -1.472367, 2.393822>,
      < 8.187676, -1.474211, 2.398489>
    }
    triangle {
      < 8.339134, -1.223811, 2.405575>,
      < 8.335473, -1.231890, 2.401848>,
      < 8.321421, -1.228575, 2.409326>
    }
    triangle {
      < 8.335473, -1.231890, 2.887792>,
      < 8.339134, -1.223811, 2.884065>,
      < 8.321421, -1.228575, 2.880314>
    }
    triangle {
      < 8.205842, -1.472367, 2.895818>,
      < 8.208865, -1.466886, 2.897391>,
      < 8.187676, -1.474211, 2.891151>
    }
    triangle {
      < 8.170268, -1.538336, 2.883126>,
      < 8.157306, -1.530575, 2.879811>,
      < 8.079331, -1.674044, 2.850661>
    }
    triangle {
      < 8.170268, -1.538336, 2.883126>,
      < 8.079331, -1.674044, 2.850661>,
      < 8.093800, -1.679864, 2.852874>
    }
    triangle {
      < 8.157306, -1.530575, 2.879811>,
      < 8.154132, -1.525767, 2.866223>,
      < 8.077214, -1.667549, 2.837213>
    }
    triangle {
      < 8.157306, -1.530575, 2.879811>,
      < 8.077214, -1.667549, 2.837213>,
      < 8.079331, -1.674044, 2.850661>
    }
    triangle {
      < 8.093800, -1.679864, 2.852874>,
      < 8.079331, -1.674044, 2.850661>,
      < 8.065534, -1.780562, 2.790235>
    }
    triangle {
      < 8.093800, -1.679864, 2.852874>,
      < 8.065534, -1.780562, 2.790235>,
      < 8.080274, -1.783448, 2.792820>
    }
    triangle {
      < 8.079331, -1.674044, 2.850661>,
      < 8.077214, -1.667549, 2.837213>,
      < 8.065619, -1.771058, 2.779412>
    }
    triangle {
      < 8.079331, -1.674044, 2.850661>,
      < 8.065619, -1.771058, 2.779412>,
      < 8.065534, -1.780562, 2.790235>
    }
    triangle {
      < 8.080274, -1.783448, 2.792820>,
      < 8.065534, -1.780562, 2.790235>,
      < 8.070304, -1.846896, 2.720089>
    }
    triangle {
      < 8.080274, -1.783448, 2.792820>,
      < 8.070304, -1.846896, 2.720089>,
      < 8.085253, -1.849633, 2.722595>
    }
    triangle {
      < 8.065534, -1.780562, 2.790235>,
      < 8.065619, -1.771058, 2.779412>,
      < 8.072523, -1.834216, 2.713687>
    }
    triangle {
      < 8.065534, -1.780562, 2.790235>,
      < 8.072523, -1.834216, 2.713687>,
      < 8.070304, -1.846896, 2.720089>
    }
    triangle {
      < 8.085253, -1.849633, 2.722595>,
      < 8.070304, -1.846896, 2.720089>,
      < 8.077331, -1.869403, 2.644820>
    }
    triangle {
      < 8.085253, -1.849633, 2.722595>,
      < 8.077331, -1.869403, 2.644820>,
      < 8.092828, -1.873096, 2.644820>
    }
    triangle {
      < 8.070304, -1.846896, 2.720089>,
      < 8.072523, -1.834216, 2.713687>,
      < 8.080665, -1.855267, 2.644820>
    }
    triangle {
      < 8.070304, -1.846896, 2.720089>,
      < 8.080665, -1.855267, 2.644820>,
      < 8.077331, -1.869403, 2.644820>
    }
    triangle {
      < 8.092828, -1.873096, 2.644820>,
      < 8.077331, -1.869403, 2.644820>,
      < 8.070304, -1.846896, 2.569551>
    }
    triangle {
      < 8.092828, -1.873096, 2.644820>,
      < 8.070304, -1.846896, 2.569551>,
      < 8.085253, -1.849633, 2.567045>
    }
    triangle {
      < 8.077331, -1.869403, 2.644820>,
      < 8.080665, -1.855267, 2.644820>,
      < 8.072523, -1.834216, 2.575953>
    }
    triangle {
      < 8.077331, -1.869403, 2.644820>,
      < 8.072523, -1.834216, 2.575953>,
      < 8.070304, -1.846896, 2.569551>
    }
    triangle {
      < 8.085253, -1.849633, 2.567045>,
      < 8.070304, -1.846896, 2.569551>,
      < 8.065534, -1.780562, 2.499405>
    }
    triangle {
      < 8.085253, -1.849633, 2.567045>,
      < 8.065534, -1.780562, 2.499405>,
      < 8.080274, -1.783448, 2.496820>
    }
    triangle {
      < 8.070304, -1.846896, 2.569551>,
      < 8.072523, -1.834216, 2.575953>,
      < 8.065619, -1.771058, 2.510228>
    }
    triangle {
      < 8.070304, -1.846896, 2.569551>,
      < 8.065619, -1.771058, 2.510228>,
      < 8.065534, -1.780562, 2.499405>
    }
    triangle {
      < 8.080274, -1.783448, 2.496820>,
      < 8.065534, -1.780562, 2.499405>,
      < 8.079331, -1.674044, 2.438979>
    }
    triangle {
      < 8.080274, -1.783448, 2.496820>,
      < 8.079331, -1.674044, 2.438979>,
      < 8.093800, -1.679864, 2.436767>
    }
    triangle {
      < 8.065534, -1.780562, 2.499405>,
      < 8.065619, -1.771058, 2.510228>,
      < 8.077214, -1.667549, 2.452427>
    }
    triangle {
      < 8.065534, -1.780562, 2.499405>,
      < 8.077214, -1.667549, 2.452427>,
      < 8.079331, -1.674044, 2.438979>
    }
    triangle {
      < 8.093800, -1.679864, 2.436767>,
      < 8.079331, -1.674044, 2.438979>,
      < 8.157306, -1.530575, 2.409829>
    }
    triangle {
      < 8.093800, -1.679864, 2.436767>,
      < 8.157306, -1.530575, 2.409829>,
      < 8.170268, -1.538336, 2.406514>
    }
    triangle {
      < 8.079331, -1.674044, 2.438979>,
      < 8.077214, -1.667549, 2.452427>,
      < 8.154132, -1.525767, 2.423417>
    }
    triangle {
      < 8.079331, -1.674044, 2.438979>,
      < 8.154132, -1.525767, 2.423417>,
      < 8.157306, -1.530575, 2.409829>
    }
    triangle {
      < 8.170268, -1.538336, 2.406514>,
      < 8.157306, -1.530575, 2.409829>,
      < 8.187676, -1.474211, 2.398489>
    }
    triangle {
      < 8.170268, -1.538336, 2.406514>,
      < 8.187676, -1.474211, 2.398489>,
      < 8.205842, -1.472367, 2.393822>
    }
    triangle {
      < 8.157306, -1.530575, 2.409829>,
      < 8.154132, -1.525767, 2.423417>,
      < 8.184558, -1.469478, 2.412012>
    }
    triangle {
      < 8.157306, -1.530575, 2.409829>,
      < 8.184558, -1.469478, 2.412012>,
      < 8.187676, -1.474211, 2.398489>
    }
    triangle {
      < 8.208865, -1.466886, 2.392249>,
      < 8.187676, -1.474211, 2.398489>,
      < 8.217980, -1.418262, 2.393451>
    }
    triangle {
      < 8.208865, -1.466886, 2.392249>,
      < 8.217980, -1.418262, 2.393451>,
      < 8.230967, -1.425997, 2.390388>
    }
    triangle {
      < 8.187676, -1.474211, 2.398489>,
      < 8.184558, -1.469478, 2.412012>,
      < 8.214829, -1.413472, 2.406681>
    }
    triangle {
      < 8.187676, -1.474211, 2.398489>,
      < 8.214829, -1.413472, 2.406681>,
      < 8.217980, -1.418262, 2.393451>
    }
    triangle {
      < 8.230967, -1.425997, 2.390388>,
      < 8.217980, -1.418262, 2.393451>,
      < 8.253754, -1.352098, 2.388959>
    }
    triangle {
      < 8.230967, -1.425997, 2.390388>,
      < 8.253754, -1.352098, 2.388959>,
      < 8.267190, -1.359515, 2.384410>
    }
    triangle {
      < 8.217980, -1.418262, 2.393451>,
      < 8.214829, -1.413472, 2.406681>,
      < 8.249680, -1.349446, 2.402216>
    }
    triangle {
      < 8.217980, -1.418262, 2.393451>,
      < 8.249680, -1.349446, 2.402216>,
      < 8.253754, -1.352098, 2.388959>
    }
    triangle {
      < 8.267190, -1.359515, 2.384410>,
      < 8.253754, -1.352098, 2.388959>,
      < 8.288815, -1.288256, 2.388882>
    }
    triangle {
      < 8.267190, -1.359515, 2.384410>,
      < 8.288815, -1.288256, 2.388882>,
      < 8.302703, -1.293414, 2.381948>
    }
    triangle {
      < 8.253754, -1.352098, 2.388959>,
      < 8.249680, -1.349446, 2.402216>,
      < 8.282547, -1.289467, 2.402460>
    }
    triangle {
      < 8.253754, -1.352098, 2.388959>,
      < 8.282547, -1.289467, 2.402460>,
      < 8.288815, -1.288256, 2.388882>
    }
    triangle {
      < 8.302703, -1.293414, 2.381948>,
      < 8.288815, -1.288256, 2.388882>,
      < 8.321421, -1.228575, 2.409326>
    }
    triangle {
      < 8.302703, -1.293414, 2.381948>,
      < 8.321421, -1.228575, 2.409326>,
      < 8.335473, -1.231890, 2.401848>
    }
    triangle {
      < 8.288815, -1.288256, 2.388882>,
      < 8.282547, -1.289467, 2.402460>,
      < 8.313235, -1.233391, 2.421941>
    }
    triangle {
      < 8.288815, -1.288256, 2.388882>,
      < 8.313235, -1.233391, 2.421941>,
      < 8.321421, -1.228575, 2.409326>
    }
    triangle {
      < 8.339134, -1.223811, 2.405575>,
      < 8.321421, -1.228575, 2.409326>,
      < 8.349296, -1.177620, 2.452194>
    }
    triangle {
      < 8.339134, -1.223811, 2.405575>,
      < 8.349296, -1.177620, 2.452194>,
      < 8.364557, -1.176428, 2.444590>
    }
    triangle {
      < 8.321421, -1.228575, 2.409326>,
      < 8.313235, -1.233391, 2.421941>,
      < 8.339499, -1.185391, 2.462717>
    }
    triangle {
      < 8.321421, -1.228575, 2.409326>,
      < 8.339499, -1.185391, 2.462717>,
      < 8.349296, -1.177620, 2.452194>
    }
    triangle {
      < 8.364557, -1.176428, 2.444590>,
      < 8.349296, -1.177620, 2.452194>,
      < 8.370643, -1.138463, 2.508483>
    }
    triangle {
      < 8.364557, -1.176428, 2.444590>,
      < 8.370643, -1.138463, 2.508483>,
      < 8.386551, -1.134575, 2.502693>
    }
    triangle {
      < 8.349296, -1.177620, 2.452194>,
      < 8.339499, -1.185391, 2.462717>,
      < 8.359615, -1.148616, 2.515956>
    }
    triangle {
      < 8.349296, -1.177620, 2.452194>,
      < 8.359615, -1.148616, 2.515956>,
      < 8.370643, -1.138463, 2.508483>
    }
    triangle {
      < 8.386551, -1.134575, 2.502693>,
      < 8.370643, -1.138463, 2.508483>,
      < 8.384037, -1.113869, 2.574205>
    }
    triangle {
      < 8.386551, -1.134575, 2.502693>,
      < 8.384037, -1.113869, 2.574205>,
      < 8.400378, -1.108249, 2.571100>
    }
    triangle {
      < 8.370643, -1.138463, 2.508483>,
      < 8.359615, -1.148616, 2.515956>,
      < 8.372250, -1.125510, 2.578075>
    }
    triangle {
      < 8.370643, -1.138463, 2.508483>,
      < 8.372250, -1.125510, 2.578075>,
      < 8.384037, -1.113869, 2.574205>
    }
    triangle {
      < 8.400378, -1.108249, 2.571100>,
      < 8.384037, -1.113869, 2.574205>,
      < 8.388602, -1.105485, 2.644820>
    }
    triangle {
      < 8.400378, -1.108249, 2.571100>,
      < 8.388602, -1.105485, 2.644820>,
      < 8.405093, -1.099273, 2.644820>
    }
    triangle {
      < 8.384037, -1.113869, 2.574205>,
      < 8.372250, -1.125510, 2.578075>,
      < 8.376558, -1.117629, 2.644820>
    }
    triangle {
      < 8.384037, -1.113869, 2.574205>,
      < 8.376558, -1.117629, 2.644820>,
      < 8.388602, -1.105485, 2.644820>
    }
    triangle {
      < 8.405093, -1.099273, 2.644820>,
      < 8.388602, -1.105485, 2.644820>,
      < 8.384037, -1.113869, 2.715435>
    }
    triangle {
      < 8.405093, -1.099273, 2.644820>,
      < 8.384037, -1.113869, 2.715435>,
      < 8.400378, -1.108249, 2.718540>
    }
    triangle {
      < 8.388602, -1.105485, 2.644820>,
      < 8.376558, -1.117629, 2.644820>,
      < 8.372250, -1.125510, 2.711565>
    }
    triangle {
      < 8.388602, -1.105485, 2.644820>,
      < 8.372250, -1.125510, 2.711565>,
      < 8.384037, -1.113869, 2.715435>
    }
    triangle {
      < 8.400378, -1.108249, 2.718540>,
      < 8.384037, -1.113869, 2.715435>,
      < 8.370643, -1.138463, 2.781157>
    }
    triangle {
      < 8.400378, -1.108249, 2.718540>,
      < 8.370643, -1.138463, 2.781157>,
      < 8.386551, -1.134575, 2.786947>
    }
    triangle {
      < 8.384037, -1.113869, 2.715435>,
      < 8.372250, -1.125510, 2.711565>,
      < 8.359615, -1.148616, 2.773684>
    }
    triangle {
      < 8.384037, -1.113869, 2.715435>,
      < 8.359615, -1.148616, 2.773684>,
      < 8.370643, -1.138463, 2.781157>
    }
    triangle {
      < 8.386551, -1.134575, 2.786947>,
      < 8.370643, -1.138463, 2.781157>,
      < 8.349296, -1.177620, 2.837446>
    }
    triangle {
      < 8.386551, -1.134575, 2.786947>,
      < 8.349296, -1.177620, 2.837446>,
      < 8.364557, -1.176428, 2.845050>
    }
    triangle {
      < 8.370643, -1.138463, 2.781157>,
      < 8.359615, -1.148616, 2.773684>,
      < 8.339499, -1.185391, 2.826924>
    }
    triangle {
      < 8.370643, -1.138463, 2.781157>,
      < 8.339499, -1.185391, 2.826924>,
      < 8.349296, -1.177620, 2.837446>
    }
    triangle {
      < 8.364557, -1.176428, 2.845050>,
      < 8.349296, -1.177620, 2.837446>,
      < 8.321421, -1.228575, 2.880314>
    }
    triangle {
      < 8.364557, -1.176428, 2.845050>,
      < 8.321421, -1.228575, 2.880314>,
      < 8.339134, -1.223811, 2.884065>
    }
    triangle {
      < 8.349296, -1.177620, 2.837446>,
      < 8.339499, -1.185391, 2.826924>,
      < 8.313235, -1.233391, 2.867699>
    }
    triangle {
      < 8.349296, -1.177620, 2.837446>,
      < 8.313235, -1.233391, 2.867699>,
      < 8.321421, -1.228575, 2.880314>
    }
    triangle {
      < 8.335473, -1.231890, 2.887792>,
      < 8.321421, -1.228575, 2.880314>,
      < 8.288815, -1.288256, 2.900759>
    }
    triangle {
      < 8.335473, -1.231890, 2.887792>,
      < 8.288815, -1.288256, 2.900759>,
      < 8.302703, -1.293414, 2.907693>
    }
    triangle {
      < 8.321421, -1.228575, 2.880314>,
      < 8.313235, -1.233391, 2.867699>,
      < 8.282547, -1.289467, 2.887181>
    }
    triangle {
      < 8.321421, -1.228575, 2.880314>,
      < 8.282547, -1.289467, 2.887181>,
      < 8.288815, -1.288256, 2.900759>
    }
    triangle {
      < 8.302703, -1.293414, 2.907693>,
      < 8.288815, -1.288256, 2.900759>,
      < 8.253754, -1.352098, 2.900683>
    }
    triangle {
      < 8.302703, -1.293414, 2.907693>,
      < 8.253754, -1.352098, 2.900683>,
      < 8.267190, -1.359515, 2.905232>
    }
    triangle {
      < 8.288815, -1.288256, 2.900759>,
      < 8.282547, -1.289467, 2.887181>,
      < 8.249680, -1.349446, 2.887426>
    }
    triangle {
      < 8.288815, -1.288256, 2.900759>,
      < 8.249680, -1.349446, 2.887426>,
      < 8.253754, -1.352098, 2.900683>
    }
    triangle {
      < 8.267190, -1.359515, 2.905232>,
      < 8.253754, -1.352098, 2.900683>,
      < 8.217980, -1.418262, 2.896190>
    }
    triangle {
      < 8.267190, -1.359515, 2.905232>,
      < 8.217980, -1.418262, 2.896190>,
      < 8.230967, -1.425997, 2.899253>
    }
    triangle {
      < 8.253754, -1.352098, 2.900683>,
      < 8.249680, -1.349446, 2.887426>,
      < 8.214829, -1.413472, 2.882961>
    }
    triangle {
      < 8.253754, -1.352098, 2.900683>,
      < 8.214829, -1.413472, 2.882961>,
      < 8.217980, -1.418262, 2.896190>
    }
    triangle {
      < 8.230967, -1.425997, 2.899253>,
      < 8.217980, -1.418262, 2.896190>,
      < 8.187676, -1.474211, 2.891151>
    }
    triangle {
      < 8.230967, -1.425997, 2.899253>,
      < 8.187676, -1.474211, 2.891151>,
      < 8.208865, -1.466886, 2.897391>
    }
    triangle {
      < 8.217980, -1.418262, 2.896190>,
      < 8.214829, -1.413472, 2.882961>,
      < 8.184558, -1.469478, 2.877629>
    }
    triangle {
      < 8.217980, -1.418262, 2.896190>,
      < 8.184558, -1.469478, 2.877629>,
      < 8.187676, -1.474211, 2.891151>
    }
    triangle {
      < 8.205842, -1.472367, 2.895818>,
      < 8.187676, -1.474211, 2.891151>,
      < 8.157306, -1.530575, 2.879811>
    }
    triangle {
      < 8.205842, -1.472367, 2.895818>,
      < 8.157306, -1.530575, 2.879811>,
      < 8.170268, -1.538336, 2.883126>
    }
    triangle {
      < 8.187676, -1.474211, 2.891151>,
      < 8.184558, -1.469478, 2.877629>,
      < 8.154132, -1.525767, 2.866223>
    }
    triangle {
      < 8.187676, -1.474211, 2.891151>,
      < 8.154132, -1.525767, 2.866223>,
      < 8.157306, -1.530575, 2.879811>
    }
    triangle {
      < -6.083289, 0.378348, 1.436069>,
      < -6.083289, 0.336490, 1.429760>,
      < -5.980997, 0.336490, 1.429760>
    }
    triangle {
      < -6.083289, 0.378348, 1.436069>,
      < -5.980997, 0.336490, 1.429760>,
      < -5.980997, 0.378348, 1.436069>
    }
    triangle {
      < -6.083289, 0.298351, 1.411393>,
      < -5.980997, 0.298351, 1.411393>,
      < -5.980997, 0.336490, 1.429760>
    }
    triangle {
      < -6.083289, 0.298351, 1.411393>,
      < -5.980997, 0.336490, 1.429760>,
      < -6.083289, 0.336490, 1.429760>
    }
    triangle {
      < -6.083289, 0.267320, 1.382600>,
      < -5.980997, 0.267320, 1.382600>,
      < -5.980997, 0.298351, 1.411393>
    }
    triangle {
      < -6.083289, 0.267320, 1.382600>,
      < -5.980997, 0.298351, 1.411393>,
      < -6.083289, 0.298351, 1.411393>
    }
    triangle {
      < -6.083289, 0.246154, 1.345941>,
      < -5.980997, 0.246154, 1.345941>,
      < -5.980997, 0.267320, 1.382600>
    }
    triangle {
      < -6.083289, 0.246154, 1.345941>,
      < -5.980997, 0.267320, 1.382600>,
      < -6.083289, 0.267320, 1.382600>
    }
    triangle {
      < -6.083289, 0.236735, 1.304671>,
      < -5.980997, 0.236735, 1.304671>,
      < -5.980997, 0.246154, 1.345941>
    }
    triangle {
      < -6.083289, 0.236735, 1.304671>,
      < -5.980997, 0.246154, 1.345941>,
      < -6.083289, 0.246154, 1.345941>
    }
    triangle {
      < -6.083289, 0.239898, 1.262458>,
      < -5.980997, 0.239898, 1.262458>,
      < -5.980997, 0.236735, 1.304671>
    }
    triangle {
      < -6.083289, 0.239898, 1.262458>,
      < -5.980997, 0.236735, 1.304671>,
      < -6.083289, 0.236735, 1.304671>
    }
    triangle {
      < -6.083289, 0.255363, 1.223053>,
      < -5.980997, 0.255363, 1.223053>,
      < -5.980997, 0.239898, 1.262458>
    }
    triangle {
      < -6.083289, 0.255363, 1.223053>,
      < -5.980997, 0.239898, 1.262458>,
      < -6.083289, 0.239898, 1.262458>
    }
    triangle {
      < -6.083289, 0.281756, 1.189957>,
      < -5.980997, 0.281756, 1.189957>,
      < -5.980997, 0.255363, 1.223053>
    }
    triangle {
      < -6.083289, 0.281756, 1.189957>,
      < -5.980997, 0.255363, 1.223053>,
      < -6.083289, 0.255363, 1.223053>
    }
    triangle {
      < -6.083289, 0.316732, 1.166111>,
      < -5.980997, 0.316732, 1.166111>,
      < -5.980997, 0.281756, 1.189957>
    }
    triangle {
      < -6.083289, 0.316732, 1.166111>,
      < -5.980997, 0.281756, 1.189957>,
      < -6.083289, 0.281756, 1.189957>
    }
    triangle {
      < -6.083289, 0.357183, 1.153634>,
      < -5.980997, 0.357183, 1.153634>,
      < -5.980997, 0.316732, 1.166111>
    }
    triangle {
      < -6.083289, 0.357183, 1.153634>,
      < -5.980997, 0.316732, 1.166111>,
      < -6.083289, 0.316732, 1.166111>
    }
    triangle {
      < -6.083289, 0.399514, 1.153634>,
      < -5.980997, 0.399514, 1.153634>,
      < -5.980997, 0.357183, 1.153634>
    }
    triangle {
      < -6.083289, 0.399514, 1.153634>,
      < -5.980997, 0.357183, 1.153634>,
      < -6.083289, 0.357183, 1.153634>
    }
    triangle {
      < -6.083289, 0.412997, 1.157793>,
      < -6.083289, 0.439965, 1.166111>,
      < -5.980997, 0.439965, 1.166111>
    }
    triangle {
      < -6.083289, 0.412997, 1.157793>,
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.399514, 1.153634>
    }
    triangle {
      < -6.083289, 0.412997, 1.157793>,
      < -5.980997, 0.399514, 1.153634>,
      < -6.083289, 0.399514, 1.153634>
    }
    triangle {
      < -6.083289, 0.474940, 1.189957>,
      < -5.980997, 0.474940, 1.189957>,
      < -5.980997, 0.439965, 1.166111>
    }
    triangle {
      < -6.083289, 0.474940, 1.189957>,
      < -5.980997, 0.439965, 1.166111>,
      < -6.083289, 0.439965, 1.166111>
    }
    triangle {
      < -6.083289, 0.501333, 1.223053>,
      < -5.980997, 0.501333, 1.223053>,
      < -5.980997, 0.474940, 1.189957>
    }
    triangle {
      < -6.083289, 0.501333, 1.223053>,
      < -5.980997, 0.474940, 1.189957>,
      < -6.083289, 0.474940, 1.189957>
    }
    triangle {
      < -6.083289, 0.516798, 1.262458>,
      < -5.980997, 0.516798, 1.262458>,
      < -5.980997, 0.501333, 1.223053>
    }
    triangle {
      < -6.083289, 0.516798, 1.262458>,
      < -5.980997, 0.501333, 1.223053>,
      < -6.083289, 0.501333, 1.223053>
    }
    triangle {
      < -6.083289, 0.519962, 1.304671>,
      < -5.980997, 0.519962, 1.304671>,
      < -5.980997, 0.516798, 1.262458>
    }
    triangle {
      < -6.083289, 0.519962, 1.304671>,
      < -5.980997, 0.516798, 1.262458>,
      < -6.083289, 0.516798, 1.262458>
    }
    triangle {
      < -6.083289, 0.510542, 1.345941>,
      < -5.980997, 0.510542, 1.345941>,
      < -5.980997, 0.519962, 1.304671>
    }
    triangle {
      < -6.083289, 0.510542, 1.345941>,
      < -5.980997, 0.519962, 1.304671>,
      < -6.083289, 0.519962, 1.304671>
    }
    triangle {
      < -6.083289, 0.489377, 1.382600>,
      < -5.980997, 0.489377, 1.382600>,
      < -5.980997, 0.510542, 1.345941>
    }
    triangle {
      < -6.083289, 0.489377, 1.382600>,
      < -5.980997, 0.510542, 1.345941>,
      < -6.083289, 0.510542, 1.345941>
    }
    triangle {
      < -6.083289, 0.458346, 1.411393>,
      < -5.980997, 0.458346, 1.411393>,
      < -5.980997, 0.489377, 1.382600>
    }
    triangle {
      < -6.083289, 0.458346, 1.411393>,
      < -5.980997, 0.489377, 1.382600>,
      < -6.083289, 0.489377, 1.382600>
    }
    triangle {
      < -6.083289, 0.420207, 1.429760>,
      < -5.980997, 0.420207, 1.429760>,
      < -5.980997, 0.458346, 1.411393>
    }
    triangle {
      < -6.083289, 0.420207, 1.429760>,
      < -5.980997, 0.458346, 1.411393>,
      < -6.083289, 0.458346, 1.411393>
    }
    triangle {
      < -6.083289, 0.420207, 1.429760>,
      < -6.083289, 0.378348, 1.436069>,
      < -5.980997, 0.378348, 1.436069>
    }
    triangle {
      < -6.083289, 0.420207, 1.429760>,
      < -5.980997, 0.378348, 1.436069>,
      < -5.980997, 0.420207, 1.429760>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.474940, 1.189957>,
      < -5.980997, 0.501333, 1.223053>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.501333, 1.223053>,
      < -5.980997, 0.516798, 1.262458>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.516798, 1.262458>,
      < -5.980997, 0.519962, 1.304671>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.519962, 1.304671>,
      < -5.980997, 0.510542, 1.345941>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.510542, 1.345941>,
      < -5.980997, 0.489377, 1.382600>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.489377, 1.382600>,
      < -5.980997, 0.458346, 1.411393>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.458346, 1.411393>,
      < -5.980997, 0.420207, 1.429760>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.420207, 1.429760>,
      < -5.980997, 0.378348, 1.436069>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.378348, 1.436069>,
      < -5.980997, 0.336490, 1.429760>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.336490, 1.429760>,
      < -5.980997, 0.298351, 1.411393>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.298351, 1.411393>,
      < -5.980997, 0.267320, 1.382600>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.267320, 1.382600>,
      < -5.980997, 0.246154, 1.345941>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.246154, 1.345941>,
      < -5.980997, 0.236735, 1.304671>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.236735, 1.304671>,
      < -5.980997, 0.239898, 1.262458>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.239898, 1.262458>,
      < -5.980997, 0.255363, 1.223053>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.255363, 1.223053>,
      < -5.980997, 0.281756, 1.189957>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.281756, 1.189957>,
      < -5.980997, 0.316732, 1.166111>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.316732, 1.166111>,
      < -5.980997, 0.357183, 1.153634>
    }
    triangle {
      < -5.980997, 0.439965, 1.166111>,
      < -5.980997, 0.357183, 1.153634>,
      < -5.980997, 0.399514, 1.153634>
    }
    triangle {
      < -6.083289, 0.414245, 1.410433>,
      < -6.083289, 0.378348, 1.415843>,
      < -6.083289, 0.378348, 1.436069>
    }
    triangle {
      < -6.083289, 0.414245, 1.410433>,
      < -6.083289, 0.378348, 1.436069>,
      < -6.083289, 0.420207, 1.429760>
    }
    triangle {
      < -6.083289, 0.342452, 1.410433>,
      < -6.218211, 0.342452, 1.410433>,
      < -6.083289, 0.378348, 1.415843>
    }
    triangle {
      < -6.218211, 0.342452, 1.410433>,
      < -6.347029, 0.309745, 1.394682>,
      < -6.375861, 0.298351, 1.411393>
    }
    triangle {
      < -6.218211, 0.342452, 1.410433>,
      < -6.375861, 0.298351, 1.411393>,
      < -6.230585, 0.336490, 1.429760>
    }
    triangle {
      < -6.347029, 0.309745, 1.394682>,
      < -6.434062, 0.283133, 1.369990>,
      < -6.470540, 0.267320, 1.382600>
    }
    triangle {
      < -6.347029, 0.309745, 1.394682>,
      < -6.470540, 0.267320, 1.382600>,
      < -6.375861, 0.298351, 1.411393>
    }
    triangle {
      < -6.491998, 0.264982, 1.338551>,
      < -6.518501, 0.256904, 1.303159>,
      < -6.555851, 0.236735, 1.304671>
    }
    triangle {
      < -6.491998, 0.264982, 1.338551>,
      < -6.555851, 0.236735, 1.304671>,
      < -6.533354, 0.246154, 1.345941>
    }
    triangle {
      < -6.518501, 0.256904, 1.303159>,
      < -6.518501, 0.259617, 1.266958>,
      < -6.555851, 0.239898, 1.262458>
    }
    triangle {
      < -6.518501, 0.256904, 1.303159>,
      < -6.555851, 0.239898, 1.262458>,
      < -6.555851, 0.236735, 1.304671>
    }
    triangle {
      < -6.518501, 0.259617, 1.266958>,
      < -6.508452, 0.272880, 1.233166>,
      < -6.538155, 0.255363, 1.223053>
    }
    triangle {
      < -6.518501, 0.259617, 1.266958>,
      < -6.538155, 0.255363, 1.223053>,
      < -6.555851, 0.239898, 1.262458>
    }
    triangle {
      < -6.459853, 0.295514, 1.204784>,
      < -6.387126, 0.325508, 1.184334>,
      < -6.422616, 0.316732, 1.166111>
    }
    triangle {
      < -6.459853, 0.295514, 1.204784>,
      < -6.422616, 0.316732, 1.166111>,
      < -6.500612, 0.281756, 1.189957>
    }
    triangle {
      < -6.387126, 0.325508, 1.184334>,
      < -6.271077, 0.360197, 1.173634>,
      < -6.292230, 0.357183, 1.153634>
    }
    triangle {
      < -6.387126, 0.325508, 1.184334>,
      < -6.292230, 0.357183, 1.153634>,
      < -6.422616, 0.316732, 1.166111>
    }
    triangle {
      < -6.136846, 0.396500, 1.173634>,
      < -6.135707, 0.399514, 1.153634>,
      < -6.292230, 0.357183, 1.153634>
    }
    triangle {
      < -6.136846, 0.396500, 1.173634>,
      < -6.292230, 0.357183, 1.153634>,
      < -6.271077, 0.360197, 1.173634>
    }
    triangle {
      < -6.083289, 0.412997, 1.157793>,
      < -6.135707, 0.399514, 1.153634>,
      < -6.136846, 0.396500, 1.173634>
    }
    triangle {
      < -6.083289, 0.412997, 1.157793>,
      < -6.136846, 0.396500, 1.173634>,
      < -6.083289, 0.408063, 1.177201>
    }
    triangle {
      < -6.083289, 0.431189, 1.184334>,
      < -6.083289, 0.461183, 1.204784>,
      < -6.083289, 0.474940, 1.189957>
    }
    triangle {
      < -6.083289, 0.431189, 1.184334>,
      < -6.083289, 0.474940, 1.189957>,
      < -6.083289, 0.439965, 1.166111>
    }
    triangle {
      < -6.083289, 0.461183, 1.204784>,
      < -6.083289, 0.483817, 1.233166>,
      < -6.083289, 0.501333, 1.223053>
    }
    triangle {
      < -6.083289, 0.461183, 1.204784>,
      < -6.083289, 0.501333, 1.223053>,
      < -6.083289, 0.474940, 1.189957>
    }
    triangle {
      < -6.083289, 0.483817, 1.233166>,
      < -6.083289, 0.497080, 1.266958>,
      < -6.083289, 0.516798, 1.262458>
    }
    triangle {
      < -6.083289, 0.483817, 1.233166>,
      < -6.083289, 0.516798, 1.262458>,
      < -6.083289, 0.501333, 1.223053>
    }
    triangle {
      < -6.083289, 0.497080, 1.266958>,
      < -6.083289, 0.499793, 1.303159>,
      < -6.083289, 0.519962, 1.304671>
    }
    triangle {
      < -6.083289, 0.497080, 1.266958>,
      < -6.083289, 0.519962, 1.304671>,
      < -6.083289, 0.516798, 1.262458>
    }
    triangle {
      < -6.083289, 0.499793, 1.303159>,
      < -6.083289, 0.491715, 1.338551>,
      < -6.083289, 0.510542, 1.345941>
    }
    triangle {
      < -6.083289, 0.499793, 1.303159>,
      < -6.083289, 0.510542, 1.345941>,
      < -6.083289, 0.519962, 1.304671>
    }
    triangle {
      < -6.083289, 0.491715, 1.338551>,
      < -6.083289, 0.473564, 1.369990>,
      < -6.083289, 0.489377, 1.382600>
    }
    triangle {
      < -6.083289, 0.491715, 1.338551>,
      < -6.083289, 0.489377, 1.382600>,
      < -6.083289, 0.510542, 1.345941>
    }
    triangle {
      < -6.083289, 0.473564, 1.369990>,
      < -6.083289, 0.446952, 1.394682>,
      < -6.083289, 0.458346, 1.411393>
    }
    triangle {
      < -6.083289, 0.473564, 1.369990>,
      < -6.083289, 0.458346, 1.411393>,
      < -6.083289, 0.489377, 1.382600>
    }
    triangle {
      < -6.083289, 0.446952, 1.394682>,
      < -6.083289, 0.414245, 1.410433>,
      < -6.083289, 0.420207, 1.429760>
    }
    triangle {
      < -6.083289, 0.446952, 1.394682>,
      < -6.083289, 0.420207, 1.429760>,
      < -6.083289, 0.458346, 1.411393>
    }
    triangle {
      < -6.083289, 0.431189, 1.184334>,
      < -6.083289, 0.439965, 1.166111>,
      < -6.083289, 0.412997, 1.157793>
    }
    triangle {
      < -6.083289, 0.431189, 1.184334>,
      < -6.083289, 0.412997, 1.157793>,
      < -6.083289, 0.408063, 1.177201>
    }
    triangle {
      < -6.230585, 0.336490, 1.429760>,
      < -6.083289, 0.336490, 1.429760>,
      < -6.083289, 0.378348, 1.436069>
    }
    triangle {
      < -6.230585, 0.336490, 1.429760>,
      < -6.375861, 0.298351, 1.411393>,
      < -6.083289, 0.298351, 1.411393>
    }
    triangle {
      < -6.230585, 0.336490, 1.429760>,
      < -6.083289, 0.298351, 1.411393>,
      < -6.083289, 0.336490, 1.429760>
    }
    triangle {
      < -6.375861, 0.298351, 1.411393>,
      < -6.470540, 0.267320, 1.382600>,
      < -6.083289, 0.267320, 1.382600>
    }
    triangle {
      < -6.375861, 0.298351, 1.411393>,
      < -6.083289, 0.267320, 1.382600>,
      < -6.083289, 0.298351, 1.411393>
    }
    triangle {
      < -6.470540, 0.267320, 1.382600>,
      < -6.533354, 0.246154, 1.345941>,
      < -6.083289, 0.246154, 1.345941>
    }
    triangle {
      < -6.470540, 0.267320, 1.382600>,
      < -6.083289, 0.246154, 1.345941>,
      < -6.083289, 0.267320, 1.382600>
    }
    triangle {
      < -6.533354, 0.246154, 1.345941>,
      < -6.555851, 0.236735, 1.304671>,
      < -6.083289, 0.236735, 1.304671>
    }
    triangle {
      < -6.533354, 0.246154, 1.345941>,
      < -6.083289, 0.236735, 1.304671>,
      < -6.083289, 0.246154, 1.345941>
    }
    triangle {
      < -6.555851, 0.236735, 1.304671>,
      < -6.555851, 0.239898, 1.262458>,
      < -6.083289, 0.239898, 1.262458>
    }
    triangle {
      < -6.555851, 0.236735, 1.304671>,
      < -6.083289, 0.239898, 1.262458>,
      < -6.083289, 0.236735, 1.304671>
    }
    triangle {
      < -6.555851, 0.239898, 1.262458>,
      < -6.538155, 0.255363, 1.223053>,
      < -6.083289, 0.255363, 1.223053>
    }
    triangle {
      < -6.555851, 0.239898, 1.262458>,
      < -6.083289, 0.255363, 1.223053>,
      < -6.083289, 0.239898, 1.262458>
    }
    triangle {
      < -6.538155, 0.255363, 1.223053>,
      < -6.500612, 0.281756, 1.189957>,
      < -6.083289, 0.281756, 1.189957>
    }
    triangle {
      < -6.538155, 0.255363, 1.223053>,
      < -6.083289, 0.281756, 1.189957>,
      < -6.083289, 0.255363, 1.223053>
    }
    triangle {
      < -6.500612, 0.281756, 1.189957>,
      < -6.422616, 0.316732, 1.166111>,
      < -6.083289, 0.316732, 1.166111>
    }
    triangle {
      < -6.500612, 0.281756, 1.189957>,
      < -6.083289, 0.316732, 1.166111>,
      < -6.083289, 0.281756, 1.189957>
    }
    triangle {
      < -6.422616, 0.316732, 1.166111>,
      < -6.292230, 0.357183, 1.153634>,
      < -6.083289, 0.357183, 1.153634>
    }
    triangle {
      < -6.422616, 0.316732, 1.166111>,
      < -6.083289, 0.357183, 1.153634>,
      < -6.083289, 0.316732, 1.166111>
    }
    triangle {
      < -6.292230, 0.357183, 1.153634>,
      < -6.135707, 0.399514, 1.153634>,
      < -6.083289, 0.399514, 1.153634>
    }
    triangle {
      < -6.292230, 0.357183, 1.153634>,
      < -6.083289, 0.399514, 1.153634>,
      < -6.083289, 0.357183, 1.153634>
    }
    triangle {
      < -6.135707, 0.399514, 1.153634>,
      < -6.083289, 0.412997, 1.157793>,
      < -6.083289, 0.399514, 1.153634>
    }
    triangle {
      < -6.083289, 0.408063, 1.177201>,
      < -6.136846, 0.396500, 1.173634>,
      < -6.083289, 0.396500, 1.173634>
    }
    triangle {
      < -6.136846, 0.396500, 1.173634>,
      < -6.271077, 0.360197, 1.173634>,
      < -6.083289, 0.360197, 1.173634>
    }
    triangle {
      < -6.136846, 0.396500, 1.173634>,
      < -6.083289, 0.360197, 1.173634>,
      < -6.083289, 0.396500, 1.173634>
    }
    triangle {
      < -6.271077, 0.360197, 1.173634>,
      < -6.387126, 0.325508, 1.184334>,
      < -6.083289, 0.325508, 1.184334>
    }
    triangle {
      < -6.271077, 0.360197, 1.173634>,
      < -6.083289, 0.325508, 1.184334>,
      < -6.083289, 0.360197, 1.173634>
    }
    triangle {
      < -6.387126, 0.325508, 1.184334>,
      < -6.459853, 0.295514, 1.204784>,
      < -6.083289, 0.295514, 1.204784>
    }
    triangle {
      < -6.387126, 0.325508, 1.184334>,
      < -6.083289, 0.295514, 1.204784>,
      < -6.083289, 0.325508, 1.184334>
    }
    triangle {
      < -6.459853, 0.295514, 1.204784>,
      < -6.508452, 0.272880, 1.233166>,
      < -6.083289, 0.272880, 1.233166>
    }
    triangle {
      < -6.459853, 0.295514, 1.204784>,
      < -6.083289, 0.272880, 1.233166>,
      < -6.083289, 0.295514, 1.204784>
    }
    triangle {
      < -6.508452, 0.272880, 1.233166>,
      < -6.518501, 0.259617, 1.266958>,
      < -6.083289, 0.259617, 1.266958>
    }
    triangle {
      < -6.508452, 0.272880, 1.233166>,
      < -6.083289, 0.259617, 1.266958>,
      < -6.083289, 0.272880, 1.233166>
    }
    triangle {
      < -6.518501, 0.259617, 1.266958>,
      < -6.518501, 0.256904, 1.303159>,
      < -6.083289, 0.256904, 1.303159>
    }
    triangle {
      < -6.518501, 0.259617, 1.266958>,
      < -6.083289, 0.256904, 1.303159>,
      < -6.083289, 0.259617, 1.266958>
    }
    triangle {
      < -6.518501, 0.256904, 1.303159>,
      < -6.491998, 0.264982, 1.338551>,
      < -6.083289, 0.264982, 1.338551>
    }
    triangle {
      < -6.518501, 0.256904, 1.303159>,
      < -6.083289, 0.264982, 1.338551>,
      < -6.083289, 0.256904, 1.303159>
    }
    triangle {
      < -6.491998, 0.264982, 1.338551>,
      < -6.434062, 0.283133, 1.369990>,
      < -6.083289, 0.283133, 1.369990>
    }
    triangle {
      < -6.491998, 0.264982, 1.338551>,
      < -6.083289, 0.283133, 1.369990>,
      < -6.083289, 0.264982, 1.338551>
    }
    triangle {
      < -6.434062, 0.283133, 1.369990>,
      < -6.347029, 0.309745, 1.394682>,
      < -6.083289, 0.309745, 1.394682>
    }
    triangle {
      < -6.434062, 0.283133, 1.369990>,
      < -6.083289, 0.309745, 1.394682>,
      < -6.083289, 0.283133, 1.369990>
    }
    triangle {
      < -6.347029, 0.309745, 1.394682>,
      < -6.218211, 0.342452, 1.410433>,
      < -6.083289, 0.342452, 1.410433>
    }
    triangle {
      < -6.347029, 0.309745, 1.394682>,
      < -6.083289, 0.342452, 1.410433>,
      < -6.083289, 0.309745, 1.394682>
    }
    triangle {
      < -6.533354, 0.246154, 1.345941>,
      < -6.470540, 0.267320, 1.382600>,
      < -6.434062, 0.283133, 1.369990>
    }
    triangle {
      < -6.533354, 0.246154, 1.345941>,
      < -6.434062, 0.283133, 1.369990>,
      < -6.491998, 0.264982, 1.338551>
    }
    triangle {
      < -6.500612, 0.281756, 1.189957>,
      < -6.538155, 0.255363, 1.223053>,
      < -6.508452, 0.272880, 1.233166>
    }
    triangle {
      < -6.500612, 0.281756, 1.189957>,
      < -6.508452, 0.272880, 1.233166>,
      < -6.459853, 0.295514, 1.204784>
    }
    triangle {
      < -6.230585, 0.336490, 1.429760>,
      < -6.083289, 0.378348, 1.436069>,
      < -6.083289, 0.378348, 1.415843>
    }
    triangle {
      < -6.230585, 0.336490, 1.429760>,
      < -6.083289, 0.378348, 1.415843>,
      < -6.218211, 0.342452, 1.410433>
    }
    triangle {
      < -6.130355, 0.389329, 1.331434>,
      < -6.130356, 0.377279, 1.332787>,
      < -6.083289, 0.378348, 1.415843>
    }
    triangle {
      < -6.130355, 0.389329, 1.331434>,
      < -6.083289, 0.378348, 1.415843>,
      < -6.083289, 0.414245, 1.410433>
    }
    triangle {
      < -6.130356, 0.377279, 1.332787>,
      < -6.130356, 0.365366, 1.330530>,
      < -6.083289, 0.342452, 1.410433>
    }
    triangle {
      < -6.130356, 0.377279, 1.332787>,
      < -6.083289, 0.342452, 1.410433>,
      < -6.083289, 0.378348, 1.415843>
    }
    triangle {
      < -6.130356, 0.365366, 1.330530>,
      < -6.130357, 0.354647, 1.324861>,
      < -6.083289, 0.309745, 1.394682>
    }
    triangle {
      < -6.130356, 0.365366, 1.330530>,
      < -6.083289, 0.309745, 1.394682>,
      < -6.083289, 0.342452, 1.410433>
    }
    triangle {
      < -6.130357, 0.354647, 1.324861>,
      < -6.130356, 0.346076, 1.316284>,
      < -6.083289, 0.283133, 1.369990>
    }
    triangle {
      < -6.130357, 0.354647, 1.324861>,
      < -6.083289, 0.283133, 1.369990>,
      < -6.083289, 0.309745, 1.394682>
    }
    triangle {
      < -6.130356, 0.346076, 1.316284>,
      < -6.130356, 0.340413, 1.305562>,
      < -6.083289, 0.264982, 1.338551>
    }
    triangle {
      < -6.130356, 0.346076, 1.316284>,
      < -6.083289, 0.264982, 1.338551>,
      < -6.083289, 0.283133, 1.369990>
    }
    triangle {
      < -6.130356, 0.340413, 1.305562>,
      < -6.130356, 0.338162, 1.293647>,
      < -6.083289, 0.256904, 1.303159>
    }
    triangle {
      < -6.130356, 0.340413, 1.305562>,
      < -6.083289, 0.256904, 1.303159>,
      < -6.083289, 0.264982, 1.338551>
    }
    triangle {
      < -6.130356, 0.338162, 1.293647>,
      < -6.130356, 0.339524, 1.281599>,
      < -6.083289, 0.259617, 1.266958>
    }
    triangle {
      < -6.130356, 0.338162, 1.293647>,
      < -6.083289, 0.259617, 1.266958>,
      < -6.083289, 0.256904, 1.303159>
    }
    triangle {
      < -6.130356, 0.339524, 1.281599>,
      < -6.130356, 0.344376, 1.270486>,
      < -6.083289, 0.272880, 1.233166>
    }
    triangle {
      < -6.130356, 0.339524, 1.281599>,
      < -6.083289, 0.272880, 1.233166>,
      < -6.083289, 0.259617, 1.266958>
    }
    triangle {
      < -6.130356, 0.344376, 1.270486>,
      < -6.130357, 0.352288, 1.261298>,
      < -6.083289, 0.295514, 1.204784>
    }
    triangle {
      < -6.130356, 0.344376, 1.270486>,
      < -6.083289, 0.295514, 1.204784>,
      < -6.083289, 0.272880, 1.233166>
    }
    triangle {
      < -6.130357, 0.352288, 1.261298>,
      < -6.130356, 0.362556, 1.254850>,
      < -6.083289, 0.325508, 1.184334>
    }
    triangle {
      < -6.130357, 0.352288, 1.261298>,
      < -6.083289, 0.325508, 1.184334>,
      < -6.083289, 0.295514, 1.204784>
    }
    triangle {
      < -6.130356, 0.362556, 1.254850>,
      < -6.130356, 0.374270, 1.251715>,
      < -6.083289, 0.360197, 1.173634>
    }
    triangle {
      < -6.130356, 0.362556, 1.254850>,
      < -6.083289, 0.360197, 1.173634>,
      < -6.083289, 0.325508, 1.184334>
    }
    triangle {
      < -6.130356, 0.374270, 1.251715>,
      < -6.130356, 0.386387, 1.252172>,
      < -6.083289, 0.396500, 1.173634>
    }
    triangle {
      < -6.130356, 0.374270, 1.251715>,
      < -6.083289, 0.396500, 1.173634>,
      < -6.083289, 0.360197, 1.173634>
    }
    triangle {
      < -6.130356, 0.386387, 1.252172>,
      < -6.083289, 0.408063, 1.177201>,
      < -6.083289, 0.396500, 1.173634>
    }
    triangle {
      < -6.130356, 0.386387, 1.252172>,
      < -6.130355, 0.397830, 1.256180>,
      < -6.083289, 0.431189, 1.184334>
    }
    triangle {
      < -6.130356, 0.386387, 1.252172>,
      < -6.083289, 0.431189, 1.184334>,
      < -6.083289, 0.408063, 1.177201>
    }
    triangle {
      < -6.130355, 0.397830, 1.256180>,
      < -6.130356, 0.407584, 1.263384>,
      < -6.083289, 0.461183, 1.204784>
    }
    triangle {
      < -6.130355, 0.397830, 1.256180>,
      < -6.083289, 0.461183, 1.204784>,
      < -6.083289, 0.431189, 1.184334>
    }
    triangle {
      < -6.130356, 0.407584, 1.263384>,
      < -6.130355, 0.414782, 1.273142>,
      < -6.083289, 0.483817, 1.233166>
    }
    triangle {
      < -6.130356, 0.407584, 1.263384>,
      < -6.083289, 0.483817, 1.233166>,
      < -6.083289, 0.461183, 1.204784>
    }
    triangle {
      < -6.130355, 0.414782, 1.273142>,
      < -6.130355, 0.418783, 1.284588>,
      < -6.083289, 0.497080, 1.266958>
    }
    triangle {
      < -6.130355, 0.414782, 1.273142>,
      < -6.083289, 0.497080, 1.266958>,
      < -6.083289, 0.483817, 1.233166>
    }
    triangle {
      < -6.130355, 0.418783, 1.284588>,
      < -6.130355, 0.419233, 1.296705>,
      < -6.083289, 0.499793, 1.303159>
    }
    triangle {
      < -6.130355, 0.418783, 1.284588>,
      < -6.083289, 0.499793, 1.303159>,
      < -6.083289, 0.497080, 1.266958>
    }
    triangle {
      < -6.130355, 0.419233, 1.296705>,
      < -6.130356, 0.416091, 1.308416>,
      < -6.083289, 0.491715, 1.338551>
    }
    triangle {
      < -6.130355, 0.419233, 1.296705>,
      < -6.083289, 0.491715, 1.338551>,
      < -6.083289, 0.499793, 1.303159>
    }
    triangle {
      < -6.130356, 0.416091, 1.308416>,
      < -6.130355, 0.409637, 1.318682>,
      < -6.083289, 0.473564, 1.369990>
    }
    triangle {
      < -6.130356, 0.416091, 1.308416>,
      < -6.083289, 0.473564, 1.369990>,
      < -6.083289, 0.491715, 1.338551>
    }
    triangle {
      < -6.130355, 0.409637, 1.318682>,
      < -6.130355, 0.400444, 1.326588>,
      < -6.083289, 0.446952, 1.394682>
    }
    triangle {
      < -6.130355, 0.409637, 1.318682>,
      < -6.083289, 0.446952, 1.394682>,
      < -6.083289, 0.473564, 1.369990>
    }
    triangle {
      < -6.130355, 0.400444, 1.326588>,
      < -6.130355, 0.389329, 1.331434>,
      < -6.083289, 0.414245, 1.410433>
    }
    triangle {
      < -6.130355, 0.400444, 1.326588>,
      < -6.083289, 0.414245, 1.410433>,
      < -6.083289, 0.446952, 1.394682>
    }
    triangle {
      < -6.305160, 0.408645, 1.264489>,
      < -6.305160, 0.415470, 1.274511>,
      < -6.130355, 0.414782, 1.273142>
    }
    triangle {
      < -6.305160, 0.408645, 1.264489>,
      < -6.130355, 0.414782, 1.273142>,
      < -6.130356, 0.407584, 1.263384>
    }
    triangle {
      < -6.305160, 0.415470, 1.274511>,
      < -6.305160, 0.419036, 1.286100>,
      < -6.130355, 0.418783, 1.284588>
    }
    triangle {
      < -6.305160, 0.415470, 1.274511>,
      < -6.130355, 0.418783, 1.284588>,
      < -6.130355, 0.414782, 1.273142>
    }
    triangle {
      < -6.000756, 0.633495, 1.282280>,
      < -6.151562, 0.611403, 1.284654>,
      < -6.151561, 0.611398, 1.292655>
    }
    triangle {
      < -6.000756, 0.633495, 1.282280>,
      < -6.151561, 0.611398, 1.292655>,
      < -6.000756, 0.633820, 1.291040>
    }
    triangle {
      < -6.305159, 0.419029, 1.298226>,
      < -6.305160, 0.415448, 1.309810>,
      < -6.130356, 0.416091, 1.308416>
    }
    triangle {
      < -6.305159, 0.419029, 1.298226>,
      < -6.130356, 0.416091, 1.308416>,
      < -6.130355, 0.419233, 1.296705>
    }
    triangle {
      < -6.305160, 0.415448, 1.309810>,
      < -6.305160, 0.408612, 1.319825>,
      < -6.130355, 0.409637, 1.318682>
    }
    triangle {
      < -6.305160, 0.415448, 1.309810>,
      < -6.130355, 0.409637, 1.318682>,
      < -6.130356, 0.416091, 1.308416>
    }
    triangle {
      < -6.305160, 0.408612, 1.319825>,
      < -6.305161, 0.399127, 1.327379>,
      < -6.130355, 0.400444, 1.326588>
    }
    triangle {
      < -6.305160, 0.408612, 1.319825>,
      < -6.130355, 0.400444, 1.326588>,
      < -6.130355, 0.409637, 1.318682>
    }
    triangle {
      < -6.305161, 0.399127, 1.327379>,
      < -6.305160, 0.387837, 1.331802>,
      < -6.130355, 0.389329, 1.331434>
    }
    triangle {
      < -6.305161, 0.399127, 1.327379>,
      < -6.130355, 0.389329, 1.331434>,
      < -6.130355, 0.400444, 1.326588>
    }
    triangle {
      < -6.305160, 0.387837, 1.331802>,
      < -6.305161, 0.375745, 1.332700>,
      < -6.130356, 0.377279, 1.332787>
    }
    triangle {
      < -6.305160, 0.387837, 1.331802>,
      < -6.130356, 0.377279, 1.332787>,
      < -6.130355, 0.389329, 1.331434>
    }
    triangle {
      < -6.305161, 0.375745, 1.332700>,
      < -6.305160, 0.363925, 1.329995>,
      < -6.130356, 0.365366, 1.330530>
    }
    triangle {
      < -6.305161, 0.375745, 1.332700>,
      < -6.130356, 0.365366, 1.330530>,
      < -6.130356, 0.377279, 1.332787>
    }
    triangle {
      < -6.000752, 0.260016, 1.517634>,
      < -6.151557, 0.269000, 1.497316>,
      < -6.151559, 0.262074, 1.493312>
    }
    triangle {
      < -6.000752, 0.260016, 1.517634>,
      < -6.151559, 0.262074, 1.493312>,
      < -6.000753, 0.252266, 1.513536>
    }
    triangle {
      < -6.305162, 0.353428, 1.323927>,
      < -6.305161, 0.345186, 1.315033>,
      < -6.130356, 0.346076, 1.316284>
    }
    triangle {
      < -6.305162, 0.353428, 1.323927>,
      < -6.130356, 0.346076, 1.316284>,
      < -6.130357, 0.354647, 1.324861>
    }
    triangle {
      < -6.305161, 0.345186, 1.315033>,
      < -6.305164, 0.339932, 1.304105>,
      < -6.130356, 0.340413, 1.305562>
    }
    triangle {
      < -6.305161, 0.345186, 1.315033>,
      < -6.130356, 0.340413, 1.305562>,
      < -6.130356, 0.346076, 1.316284>
    }
    triangle {
      < -6.305164, 0.339932, 1.304105>,
      < -6.305162, 0.338132, 1.292114>,
      < -6.130356, 0.338162, 1.293647>
    }
    triangle {
      < -6.305164, 0.339932, 1.304105>,
      < -6.130356, 0.338162, 1.293647>,
      < -6.130356, 0.340413, 1.305562>
    }
    triangle {
      < -6.305162, 0.338132, 1.292114>,
      < -6.305160, 0.339946, 1.280126>,
      < -6.130356, 0.339524, 1.281599>
    }
    triangle {
      < -6.305162, 0.338132, 1.292114>,
      < -6.130356, 0.339524, 1.281599>,
      < -6.130356, 0.338162, 1.293647>
    }
    triangle {
      < -6.305160, 0.339946, 1.280126>,
      < -6.305161, 0.345213, 1.269204>,
      < -6.130356, 0.344376, 1.270486>
    }
    triangle {
      < -6.305160, 0.339946, 1.280126>,
      < -6.130356, 0.344376, 1.270486>,
      < -6.130356, 0.339524, 1.281599>
    }
    triangle {
      < -6.305161, 0.345213, 1.269204>,
      < -6.305162, 0.353466, 1.260320>,
      < -6.130357, 0.352288, 1.261298>
    }
    triangle {
      < -6.305161, 0.345213, 1.269204>,
      < -6.130357, 0.352288, 1.261298>,
      < -6.130356, 0.344376, 1.270486>
    }
    triangle {
      < -6.000753, 0.242926, 1.076510>,
      < -6.151559, 0.256026, 1.094451>,
      < -6.151558, 0.262956, 1.090456>
    }
    triangle {
      < -6.000753, 0.242926, 1.076510>,
      < -6.151558, 0.262956, 1.090456>,
      < -6.000752, 0.250350, 1.071848>
    }
    triangle {
      < -6.305161, 0.363970, 1.254264>,
      < -6.305161, 0.375794, 1.251572>,
      < -6.130356, 0.374270, 1.251715>
    }
    triangle {
      < -6.305161, 0.363970, 1.254264>,
      < -6.130356, 0.374270, 1.251715>,
      < -6.130356, 0.362556, 1.254850>
    }
    triangle {
      < -6.305161, 0.375794, 1.251572>,
      < -6.305161, 0.387885, 1.252486>,
      < -6.130356, 0.386387, 1.252172>
    }
    triangle {
      < -6.305161, 0.375794, 1.251572>,
      < -6.130356, 0.386387, 1.252172>,
      < -6.130356, 0.374270, 1.251715>
    }
    triangle {
      < -6.305161, 0.387885, 1.252486>,
      < -6.305161, 0.399169, 1.256923>,
      < -6.130355, 0.397830, 1.256180>
    }
    triangle {
      < -6.305161, 0.387885, 1.252486>,
      < -6.130355, 0.397830, 1.256180>,
      < -6.130356, 0.386387, 1.252172>
    }
    triangle {
      < -6.305161, 0.399169, 1.256923>,
      < -6.305160, 0.408645, 1.264489>,
      < -6.130356, 0.407584, 1.263384>
    }
    triangle {
      < -6.305161, 0.399169, 1.256923>,
      < -6.130356, 0.407584, 1.263384>,
      < -6.130355, 0.397830, 1.256180>
    }
    triangle {
      < -6.381562, 0.376403, 1.259732>,
      < -6.381561, 0.386062, 1.260462>,
      < -6.305161, 0.387885, 1.252486>
    }
    triangle {
      < -6.381562, 0.376403, 1.259732>,
      < -6.305161, 0.387885, 1.252486>,
      < -6.305161, 0.375794, 1.251572>
    }
    triangle {
      < -6.381561, 0.386062, 1.260462>,
      < -6.381561, 0.395076, 1.264006>,
      < -6.305161, 0.399169, 1.256923>
    }
    triangle {
      < -6.381561, 0.386062, 1.260462>,
      < -6.305161, 0.399169, 1.256923>,
      < -6.305161, 0.387885, 1.252486>
    }
    triangle {
      < -6.381561, 0.395076, 1.264006>,
      < -6.381560, 0.402646, 1.270050>,
      < -6.305160, 0.408645, 1.264489>
    }
    triangle {
      < -6.381561, 0.395076, 1.264006>,
      < -6.305160, 0.408645, 1.264489>,
      < -6.305161, 0.399169, 1.256923>
    }
    triangle {
      < -6.381560, 0.402646, 1.270050>,
      < -6.381560, 0.408097, 1.278057>,
      < -6.305160, 0.415470, 1.274511>
    }
    triangle {
      < -6.381560, 0.402646, 1.270050>,
      < -6.305160, 0.415470, 1.274511>,
      < -6.305160, 0.408645, 1.264489>
    }
    triangle {
      < -6.381560, 0.408097, 1.278057>,
      < -6.381559, 0.410947, 1.287314>,
      < -6.305160, 0.419036, 1.286100>
    }
    triangle {
      < -6.381560, 0.408097, 1.278057>,
      < -6.305160, 0.419036, 1.286100>,
      < -6.305160, 0.415470, 1.274511>
    }
    triangle {
      < -6.381559, 0.410947, 1.287314>,
      < -6.381561, 0.410942, 1.297001>,
      < -6.305159, 0.419029, 1.298226>
    }
    triangle {
      < -6.381559, 0.410947, 1.287314>,
      < -6.305159, 0.419029, 1.298226>,
      < -6.305160, 0.419036, 1.286100>
    }
    triangle {
      < -6.381561, 0.410942, 1.297001>,
      < -6.381560, 0.408081, 1.306255>,
      < -6.305160, 0.415448, 1.309810>
    }
    triangle {
      < -6.381561, 0.410942, 1.297001>,
      < -6.305160, 0.415448, 1.309810>,
      < -6.305159, 0.419029, 1.298226>
    }
    triangle {
      < -6.381560, 0.408081, 1.306255>,
      < -6.381561, 0.402619, 1.314256>,
      < -6.305160, 0.408612, 1.319825>
    }
    triangle {
      < -6.381560, 0.408081, 1.306255>,
      < -6.305160, 0.408612, 1.319825>,
      < -6.305160, 0.415448, 1.309810>
    }
    triangle {
      < -6.381561, 0.402619, 1.314256>,
      < -6.381561, 0.395043, 1.320290>,
      < -6.305161, 0.399127, 1.327379>
    }
    triangle {
      < -6.381561, 0.402619, 1.314256>,
      < -6.305161, 0.399127, 1.327379>,
      < -6.305160, 0.408612, 1.319825>
    }
    triangle {
      < -6.381561, 0.395043, 1.320290>,
      < -6.381560, 0.386024, 1.323823>,
      < -6.305160, 0.387837, 1.331802>
    }
    triangle {
      < -6.381561, 0.395043, 1.320290>,
      < -6.305160, 0.387837, 1.331802>,
      < -6.305161, 0.399127, 1.327379>
    }
    triangle {
      < -6.381560, 0.386024, 1.323823>,
      < -6.381562, 0.376364, 1.324542>,
      < -6.305161, 0.375745, 1.332700>
    }
    triangle {
      < -6.381560, 0.386024, 1.323823>,
      < -6.305161, 0.375745, 1.332700>,
      < -6.305160, 0.387837, 1.331802>
    }
    triangle {
      < -6.381562, 0.376364, 1.324542>,
      < -6.381563, 0.366922, 1.322380>,
      < -6.305160, 0.363925, 1.329995>
    }
    triangle {
      < -6.381562, 0.376364, 1.324542>,
      < -6.305160, 0.363925, 1.329995>,
      < -6.305161, 0.375745, 1.332700>
    }
    triangle {
      < -6.381563, 0.366922, 1.322380>,
      < -6.381563, 0.358536, 1.317533>,
      < -6.305162, 0.353428, 1.323927>
    }
    triangle {
      < -6.381563, 0.366922, 1.322380>,
      < -6.305162, 0.353428, 1.323927>,
      < -6.305160, 0.363925, 1.329995>
    }
    triangle {
      < -6.381563, 0.358536, 1.317533>,
      < -6.381562, 0.351952, 1.310428>,
      < -6.305161, 0.345186, 1.315033>
    }
    triangle {
      < -6.381563, 0.358536, 1.317533>,
      < -6.305161, 0.345186, 1.315033>,
      < -6.305162, 0.353428, 1.323927>
    }
    triangle {
      < -6.381562, 0.351952, 1.310428>,
      < -6.381562, 0.347754, 1.301698>,
      < -6.305164, 0.339932, 1.304105>
    }
    triangle {
      < -6.381562, 0.351952, 1.310428>,
      < -6.305164, 0.339932, 1.304105>,
      < -6.305161, 0.345186, 1.315033>
    }
    triangle {
      < -6.381562, 0.347754, 1.301698>,
      < -6.381562, 0.346316, 1.292119>,
      < -6.305162, 0.338132, 1.292114>
    }
    triangle {
      < -6.381562, 0.347754, 1.301698>,
      < -6.305162, 0.338132, 1.292114>,
      < -6.305164, 0.339932, 1.304105>
    }
    triangle {
      < -6.381562, 0.346316, 1.292119>,
      < -6.381563, 0.347766, 1.282542>,
      < -6.305160, 0.339946, 1.280126>
    }
    triangle {
      < -6.381562, 0.346316, 1.292119>,
      < -6.305160, 0.339946, 1.280126>,
      < -6.305162, 0.338132, 1.292114>
    }
    triangle {
      < -6.381563, 0.347766, 1.282542>,
      < -6.381563, 0.351974, 1.273817>,
      < -6.305161, 0.345213, 1.269204>
    }
    triangle {
      < -6.381563, 0.347766, 1.282542>,
      < -6.305161, 0.345213, 1.269204>,
      < -6.305160, 0.339946, 1.280126>
    }
    triangle {
      < -6.381563, 0.351974, 1.273817>,
      < -6.381563, 0.358566, 1.266720>,
      < -6.305162, 0.353466, 1.260320>
    }
    triangle {
      < -6.381563, 0.351974, 1.273817>,
      < -6.305162, 0.353466, 1.260320>,
      < -6.305161, 0.345213, 1.269204>
    }
    triangle {
      < -6.381563, 0.358566, 1.266720>,
      < -6.381561, 0.366958, 1.261882>,
      < -6.305161, 0.363970, 1.254264>
    }
    triangle {
      < -6.381563, 0.358566, 1.266720>,
      < -6.305161, 0.363970, 1.254264>,
      < -6.305162, 0.353466, 1.260320>
    }
    triangle {
      < -6.381561, 0.366958, 1.261882>,
      < -6.381562, 0.376403, 1.259732>,
      < -6.305161, 0.375794, 1.251572>
    }
    triangle {
      < -6.381561, 0.366958, 1.261882>,
      < -6.305161, 0.375794, 1.251572>,
      < -6.305161, 0.363970, 1.254264>
    }
    triangle {
      < -6.431556, 0.360045, 1.279326>,
      < -6.431553, 0.364656, 1.274363>,
      < -6.381563, 0.358566, 1.266720>
    }
    triangle {
      < -6.431556, 0.360045, 1.279326>,
      < -6.381563, 0.358566, 1.266720>,
      < -6.381563, 0.351974, 1.273817>
    }
    triangle {
      < -6.431553, 0.364656, 1.274363>,
      < -6.431552, 0.370524, 1.270979>,
      < -6.381561, 0.366958, 1.261882>
    }
    triangle {
      < -6.431553, 0.364656, 1.274363>,
      < -6.381561, 0.366958, 1.261882>,
      < -6.381563, 0.358566, 1.266720>
    }
    triangle {
      < -6.431552, 0.370524, 1.270979>,
      < -6.431551, 0.377129, 1.269476>,
      < -6.381562, 0.376403, 1.259732>
    }
    triangle {
      < -6.431552, 0.370524, 1.270979>,
      < -6.381562, 0.376403, 1.259732>,
      < -6.381561, 0.366958, 1.261882>
    }
    triangle {
      < -6.431551, 0.377129, 1.269476>,
      < -6.431551, 0.383884, 1.269987>,
      < -6.381561, 0.386062, 1.260462>
    }
    triangle {
      < -6.431551, 0.377129, 1.269476>,
      < -6.381561, 0.386062, 1.260462>,
      < -6.381562, 0.376403, 1.259732>
    }
    triangle {
      < -6.431551, 0.383884, 1.269987>,
      < -6.431551, 0.390187, 1.272465>,
      < -6.381561, 0.395076, 1.264006>
    }
    triangle {
      < -6.431551, 0.383884, 1.269987>,
      < -6.381561, 0.395076, 1.264006>,
      < -6.381561, 0.386062, 1.260462>
    }
    triangle {
      < -6.431551, 0.390187, 1.272465>,
      < -6.431551, 0.395481, 1.276692>,
      < -6.381560, 0.402646, 1.270050>
    }
    triangle {
      < -6.431551, 0.390187, 1.272465>,
      < -6.381560, 0.402646, 1.270050>,
      < -6.381561, 0.395076, 1.264006>
    }
    triangle {
      < -6.431551, 0.395481, 1.276692>,
      < -6.431554, 0.399294, 1.282291>,
      < -6.381560, 0.408097, 1.278057>
    }
    triangle {
      < -6.431551, 0.395481, 1.276692>,
      < -6.381560, 0.408097, 1.278057>,
      < -6.381560, 0.402646, 1.270050>
    }
    triangle {
      < -6.431554, 0.399294, 1.282291>,
      < -6.431551, 0.401285, 1.288764>,
      < -6.381559, 0.410947, 1.287314>
    }
    triangle {
      < -6.431554, 0.399294, 1.282291>,
      < -6.381559, 0.410947, 1.287314>,
      < -6.381560, 0.408097, 1.278057>
    }
    triangle {
      < -6.431551, 0.401285, 1.288764>,
      < -6.431551, 0.401282, 1.295539>,
      < -6.381561, 0.410942, 1.297001>
    }
    triangle {
      < -6.431551, 0.401285, 1.288764>,
      < -6.381561, 0.410942, 1.297001>,
      < -6.381559, 0.410947, 1.287314>
    }
    triangle {
      < -6.431551, 0.401282, 1.295539>,
      < -6.431551, 0.399282, 1.302010>,
      < -6.381560, 0.408081, 1.306255>
    }
    triangle {
      < -6.431551, 0.401282, 1.295539>,
      < -6.381560, 0.408081, 1.306255>,
      < -6.381561, 0.410942, 1.297001>
    }
    triangle {
      < -6.431551, 0.399282, 1.302010>,
      < -6.431554, 0.395462, 1.307605>,
      < -6.381561, 0.402619, 1.314256>
    }
    triangle {
      < -6.431551, 0.399282, 1.302010>,
      < -6.381561, 0.402619, 1.314256>,
      < -6.381560, 0.408081, 1.306255>
    }
    triangle {
      < -6.431554, 0.395462, 1.307605>,
      < -6.431554, 0.390164, 1.311825>,
      < -6.381561, 0.395043, 1.320290>
    }
    triangle {
      < -6.431554, 0.395462, 1.307605>,
      < -6.381561, 0.395043, 1.320290>,
      < -6.381561, 0.402619, 1.314256>
    }
    triangle {
      < -6.431554, 0.390164, 1.311825>,
      < -6.431553, 0.383857, 1.314296>,
      < -6.381560, 0.386024, 1.323823>
    }
    triangle {
      < -6.431554, 0.390164, 1.311825>,
      < -6.381560, 0.386024, 1.323823>,
      < -6.381561, 0.395043, 1.320290>
    }
    triangle {
      < -6.431553, 0.383857, 1.314296>,
      < -6.431552, 0.377102, 1.314798>,
      < -6.381562, 0.376364, 1.324542>
    }
    triangle {
      < -6.431553, 0.383857, 1.314296>,
      < -6.381562, 0.376364, 1.324542>,
      < -6.381560, 0.386024, 1.323823>
    }
    triangle {
      < -6.431552, 0.377102, 1.314798>,
      < -6.431549, 0.370499, 1.313287>,
      < -6.381563, 0.366922, 1.322380>
    }
    triangle {
      < -6.431552, 0.377102, 1.314798>,
      < -6.381563, 0.366922, 1.322380>,
      < -6.381562, 0.376364, 1.324542>
    }
    triangle {
      < -6.431549, 0.370499, 1.313287>,
      < -6.431552, 0.364634, 1.309896>,
      < -6.381563, 0.358536, 1.317533>
    }
    triangle {
      < -6.431549, 0.370499, 1.313287>,
      < -6.381563, 0.358536, 1.317533>,
      < -6.381563, 0.366922, 1.322380>
    }
    triangle {
      < -6.431552, 0.364634, 1.309896>,
      < -6.431554, 0.360030, 1.304928>,
      < -6.381562, 0.351952, 1.310428>
    }
    triangle {
      < -6.431552, 0.364634, 1.309896>,
      < -6.381562, 0.351952, 1.310428>,
      < -6.381563, 0.358536, 1.317533>
    }
    triangle {
      < -6.431554, 0.360030, 1.304928>,
      < -6.431552, 0.357095, 1.298823>,
      < -6.381562, 0.347754, 1.301698>
    }
    triangle {
      < -6.431554, 0.360030, 1.304928>,
      < -6.381562, 0.347754, 1.301698>,
      < -6.381562, 0.351952, 1.310428>
    }
    triangle {
      < -6.431552, 0.357095, 1.298823>,
      < -6.431554, 0.356089, 1.292125>,
      < -6.381562, 0.346316, 1.292119>
    }
    triangle {
      < -6.431552, 0.357095, 1.298823>,
      < -6.381562, 0.346316, 1.292119>,
      < -6.381562, 0.347754, 1.301698>
    }
    triangle {
      < -6.431554, 0.356089, 1.292125>,
      < -6.431550, 0.357103, 1.285427>,
      < -6.381563, 0.347766, 1.282542>
    }
    triangle {
      < -6.431554, 0.356089, 1.292125>,
      < -6.381563, 0.347766, 1.282542>,
      < -6.381562, 0.346316, 1.292119>
    }
    triangle {
      < -6.431550, 0.357103, 1.285427>,
      < -6.431556, 0.360045, 1.279326>,
      < -6.381563, 0.351974, 1.273817>
    }
    triangle {
      < -6.431550, 0.357103, 1.285427>,
      < -6.381563, 0.351974, 1.273817>,
      < -6.381563, 0.347766, 1.282542>
    }
    triangle {
      < -6.467153, 0.366682, 1.295872>,
      < -6.467154, 0.366120, 1.292130>,
      < -6.431554, 0.356089, 1.292125>
    }
    triangle {
      < -6.467153, 0.366682, 1.295872>,
      < -6.431554, 0.356089, 1.292125>,
      < -6.431552, 0.357095, 1.298823>
    }
    triangle {
      < -6.467154, 0.366120, 1.292130>,
      < -6.467155, 0.366686, 1.288389>,
      < -6.431550, 0.357103, 1.285427>
    }
    triangle {
      < -6.467154, 0.366120, 1.292130>,
      < -6.431550, 0.357103, 1.285427>,
      < -6.431554, 0.356089, 1.292125>
    }
    triangle {
      < -6.467155, 0.366686, 1.288389>,
      < -6.467149, 0.368330, 1.284980>,
      < -6.431556, 0.360045, 1.279326>
    }
    triangle {
      < -6.467155, 0.366686, 1.288389>,
      < -6.431556, 0.360045, 1.279326>,
      < -6.431550, 0.357103, 1.285427>
    }
    triangle {
      < -6.467149, 0.368330, 1.284980>,
      < -6.467151, 0.370905, 1.282208>,
      < -6.431553, 0.364656, 1.274363>
    }
    triangle {
      < -6.467149, 0.368330, 1.284980>,
      < -6.431553, 0.364656, 1.274363>,
      < -6.431556, 0.360045, 1.279326>
    }
    triangle {
      < -6.467151, 0.370905, 1.282208>,
      < -6.467153, 0.374184, 1.280318>,
      < -6.431552, 0.370524, 1.270979>
    }
    triangle {
      < -6.467151, 0.370905, 1.282208>,
      < -6.431552, 0.370524, 1.270979>,
      < -6.431553, 0.364656, 1.274363>
    }
    triangle {
      < -6.467153, 0.374184, 1.280318>,
      < -6.467154, 0.377874, 1.279477>,
      < -6.431551, 0.377129, 1.269476>
    }
    triangle {
      < -6.467153, 0.374184, 1.280318>,
      < -6.431551, 0.377129, 1.269476>,
      < -6.431552, 0.370524, 1.270979>
    }
    triangle {
      < -6.467154, 0.377874, 1.279477>,
      < -6.467153, 0.381647, 1.279763>,
      < -6.431551, 0.383884, 1.269987>
    }
    triangle {
      < -6.467154, 0.377874, 1.279477>,
      < -6.431551, 0.383884, 1.269987>,
      < -6.431551, 0.377129, 1.269476>
    }
    triangle {
      < -6.467153, 0.381647, 1.279763>,
      < -6.467152, 0.385169, 1.281148>,
      < -6.431551, 0.390187, 1.272465>
    }
    triangle {
      < -6.467153, 0.381647, 1.279763>,
      < -6.431551, 0.390187, 1.272465>,
      < -6.431551, 0.383884, 1.269987>
    }
    triangle {
      < -6.467152, 0.385169, 1.281148>,
      < -6.467155, 0.388126, 1.283509>,
      < -6.431551, 0.395481, 1.276692>
    }
    triangle {
      < -6.467152, 0.385169, 1.281148>,
      < -6.431551, 0.395481, 1.276692>,
      < -6.431551, 0.390187, 1.272465>
    }
    triangle {
      < -6.467155, 0.388126, 1.283509>,
      < -6.467151, 0.390256, 1.286636>,
      < -6.431554, 0.399294, 1.282291>
    }
    triangle {
      < -6.467155, 0.388126, 1.283509>,
      < -6.431554, 0.399294, 1.282291>,
      < -6.431551, 0.395481, 1.276692>
    }
    triangle {
      < -6.467151, 0.390256, 1.286636>,
      < -6.467152, 0.391369, 1.290253>,
      < -6.431551, 0.401285, 1.288764>
    }
    triangle {
      < -6.467151, 0.390256, 1.286636>,
      < -6.431551, 0.401285, 1.288764>,
      < -6.431554, 0.399294, 1.282291>
    }
    triangle {
      < -6.467152, 0.391369, 1.290253>,
      < -6.467149, 0.391367, 1.294037>,
      < -6.431551, 0.401282, 1.295539>
    }
    triangle {
      < -6.467152, 0.391369, 1.290253>,
      < -6.431551, 0.401282, 1.295539>,
      < -6.431551, 0.401285, 1.288764>
    }
    triangle {
      < -6.467149, 0.391367, 1.294037>,
      < -6.467149, 0.390249, 1.297653>,
      < -6.431551, 0.399282, 1.302010>
    }
    triangle {
      < -6.467149, 0.391367, 1.294037>,
      < -6.431551, 0.399282, 1.302010>,
      < -6.431551, 0.401282, 1.295539>
    }
    triangle {
      < -6.467149, 0.390249, 1.297653>,
      < -6.467152, 0.388115, 1.300779>,
      < -6.431554, 0.395462, 1.307605>
    }
    triangle {
      < -6.467149, 0.390249, 1.297653>,
      < -6.431554, 0.395462, 1.307605>,
      < -6.431551, 0.399282, 1.302010>
    }
    triangle {
      < -6.467152, 0.388115, 1.300779>,
      < -6.467151, 0.385155, 1.303136>,
      < -6.431554, 0.390164, 1.311825>
    }
    triangle {
      < -6.467152, 0.388115, 1.300779>,
      < -6.431554, 0.390164, 1.311825>,
      < -6.431554, 0.395462, 1.307605>
    }
    triangle {
      < -6.467151, 0.385155, 1.303136>,
      < -6.467153, 0.381632, 1.304516>,
      < -6.431553, 0.383857, 1.314296>
    }
    triangle {
      < -6.467151, 0.385155, 1.303136>,
      < -6.431553, 0.383857, 1.314296>,
      < -6.431554, 0.390164, 1.311825>
    }
    triangle {
      < -6.467153, 0.381632, 1.304516>,
      < -6.467153, 0.377859, 1.304797>,
      < -6.431552, 0.377102, 1.314798>
    }
    triangle {
      < -6.467153, 0.381632, 1.304516>,
      < -6.431552, 0.377102, 1.314798>,
      < -6.431553, 0.383857, 1.314296>
    }
    triangle {
      < -6.467153, 0.377859, 1.304797>,
      < -6.467153, 0.374170, 1.303952>,
      < -6.431549, 0.370499, 1.313287>
    }
    triangle {
      < -6.467153, 0.377859, 1.304797>,
      < -6.431549, 0.370499, 1.313287>,
      < -6.431552, 0.377102, 1.314798>
    }
    triangle {
      < -6.467153, 0.374170, 1.303952>,
      < -6.467153, 0.370894, 1.302058>,
      < -6.431552, 0.364634, 1.309896>
    }
    triangle {
      < -6.467153, 0.374170, 1.303952>,
      < -6.431552, 0.364634, 1.309896>,
      < -6.431549, 0.370499, 1.313287>
    }
    triangle {
      < -6.467153, 0.370894, 1.302058>,
      < -6.467158, 0.368321, 1.299283>,
      < -6.431554, 0.360030, 1.304928>
    }
    triangle {
      < -6.467153, 0.370894, 1.302058>,
      < -6.431554, 0.360030, 1.304928>,
      < -6.431552, 0.364634, 1.309896>
    }
    triangle {
      < -6.467158, 0.368321, 1.299283>,
      < -6.467153, 0.366682, 1.295872>,
      < -6.431552, 0.357095, 1.298823>
    }
    triangle {
      < -6.467158, 0.368321, 1.299283>,
      < -6.431552, 0.357095, 1.298823>,
      < -6.431554, 0.360030, 1.304928>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467153, 0.370894, 1.302058>,
      < -6.467153, 0.374170, 1.303952>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467158, 0.368321, 1.299283>,
      < -6.467153, 0.370894, 1.302058>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467153, 0.366682, 1.295872>,
      < -6.467158, 0.368321, 1.299283>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467154, 0.366120, 1.292130>,
      < -6.467153, 0.366682, 1.295872>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467155, 0.366686, 1.288389>,
      < -6.467154, 0.366120, 1.292130>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467149, 0.368330, 1.284980>,
      < -6.467155, 0.366686, 1.288389>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467151, 0.370905, 1.282208>,
      < -6.467149, 0.368330, 1.284980>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467153, 0.374184, 1.280318>,
      < -6.467151, 0.370905, 1.282208>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467154, 0.377874, 1.279477>,
      < -6.467153, 0.374184, 1.280318>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467153, 0.381647, 1.279763>,
      < -6.467154, 0.377874, 1.279477>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467152, 0.385169, 1.281148>,
      < -6.467153, 0.381647, 1.279763>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467155, 0.388126, 1.283509>,
      < -6.467152, 0.385169, 1.281148>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467151, 0.390256, 1.286636>,
      < -6.467155, 0.388126, 1.283509>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467152, 0.391369, 1.290253>,
      < -6.467151, 0.390256, 1.286636>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467149, 0.391367, 1.294037>,
      < -6.467152, 0.391369, 1.290253>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467149, 0.390249, 1.297653>,
      < -6.467149, 0.391367, 1.294037>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467152, 0.388115, 1.300779>,
      < -6.467149, 0.390249, 1.297653>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467151, 0.385155, 1.303136>,
      < -6.467152, 0.388115, 1.300779>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467153, 0.381632, 1.304516>,
      < -6.467151, 0.385155, 1.303136>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467153, 0.377859, 1.304797>,
      < -6.467153, 0.381632, 1.304516>
    }
    triangle {
      < -6.500353, 0.378816, 1.292139>,
      < -6.467153, 0.374170, 1.303952>,
      < -6.467153, 0.377859, 1.304797>
    }
    triangle {
      < -6.053556, 0.419042, 1.282304>,
      < -6.130355, 0.418783, 1.284588>,
      < -6.000756, 0.633495, 1.282280>
    }
    triangle {
      < -6.000756, 0.633495, 1.282280>,
      < -6.000756, 0.633820, 1.291040>,
      < -6.053556, 0.419043, 1.295002>
    }
    triangle {
      < -6.000756, 0.633495, 1.282280>,
      < -6.053556, 0.419043, 1.295002>,
      < -6.053556, 0.419042, 1.282304>
    }
    triangle {
      < -6.000756, 0.633820, 1.291040>,
      < -6.151561, 0.611398, 1.292655>,
      < -6.305159, 0.419029, 1.298226>
    }
    triangle {
      < -6.000756, 0.633820, 1.291040>,
      < -6.305159, 0.419029, 1.298226>,
      < -6.130355, 0.419233, 1.296705>
    }
    triangle {
      < -6.151561, 0.611398, 1.292655>,
      < -6.151562, 0.611403, 1.284654>,
      < -6.305160, 0.419036, 1.286100>
    }
    triangle {
      < -6.151561, 0.611398, 1.292655>,
      < -6.305160, 0.419036, 1.286100>,
      < -6.305159, 0.419029, 1.298226>
    }
    triangle {
      < -6.151559, 0.256026, 1.094451>,
      < -6.000753, 0.242926, 1.076510>,
      < -6.130357, 0.352288, 1.261298>
    }
    triangle {
      < -6.151559, 0.256026, 1.094451>,
      < -6.130357, 0.352288, 1.261298>,
      < -6.305162, 0.353466, 1.260320>
    }
    triangle {
      < -6.000753, 0.242926, 1.076510>,
      < -6.000752, 0.250350, 1.071848>,
      < -6.053653, 0.363062, 1.254569>
    }
    triangle {
      < -6.000753, 0.242926, 1.076510>,
      < -6.053653, 0.363062, 1.254569>,
      < -6.053653, 0.352225, 1.261200>
    }
    triangle {
      < -6.053653, 0.363062, 1.254569>,
      < -6.000752, 0.250350, 1.071848>,
      < -6.130356, 0.362556, 1.254850>
    }
    triangle {
      < -6.151558, 0.262956, 1.090456>,
      < -6.151559, 0.256026, 1.094451>,
      < -6.305162, 0.353466, 1.260320>
    }
    triangle {
      < -6.151558, 0.262956, 1.090456>,
      < -6.305162, 0.353466, 1.260320>,
      < -6.305161, 0.363970, 1.254264>
    }
    triangle {
      < -6.151557, 0.269000, 1.497316>,
      < -6.000752, 0.260016, 1.517634>,
      < -6.130356, 0.365366, 1.330530>
    }
    triangle {
      < -6.151557, 0.269000, 1.497316>,
      < -6.130356, 0.365366, 1.330530>,
      < -6.305160, 0.363925, 1.329995>
    }
    triangle {
      < -6.000752, 0.260016, 1.517634>,
      < -6.000753, 0.252266, 1.513536>,
      < -6.053653, 0.354613, 1.324923>
    }
    triangle {
      < -6.000752, 0.260016, 1.517634>,
      < -6.053653, 0.354613, 1.324923>,
      < -6.053653, 0.365750, 1.331035>
    }
    triangle {
      < -6.000753, 0.252266, 1.513536>,
      < -6.151559, 0.262074, 1.493312>,
      < -6.305162, 0.353428, 1.323927>
    }
    triangle {
      < -6.000753, 0.252266, 1.513536>,
      < -6.305162, 0.353428, 1.323927>,
      < -6.130357, 0.354647, 1.324861>
    }
    triangle {
      < -6.151559, 0.262074, 1.493312>,
      < -6.151557, 0.269000, 1.497316>,
      < -6.305160, 0.363925, 1.329995>
    }
    triangle {
      < -6.151559, 0.262074, 1.493312>,
      < -6.305160, 0.363925, 1.329995>,
      < -6.305162, 0.353428, 1.323927>
    }
    triangle {
      < -6.130357, 0.354647, 1.324861>,
      < -6.130356, 0.365366, 1.330530>,
      < -6.053653, 0.365750, 1.331035>
    }
    triangle {
      < -6.130357, 0.354647, 1.324861>,
      < -6.053653, 0.365750, 1.331035>,
      < -6.053653, 0.354613, 1.324923>
    }
    triangle {
      < -6.130355, 0.419233, 1.296705>,
      < -6.130355, 0.418783, 1.284588>,
      < -6.053556, 0.419042, 1.282304>
    }
    triangle {
      < -6.130355, 0.419233, 1.296705>,
      < -6.053556, 0.419042, 1.282304>,
      < -6.053556, 0.419043, 1.295002>
    }
    triangle {
      < -6.130356, 0.362556, 1.254850>,
      < -6.130357, 0.352288, 1.261298>,
      < -6.053653, 0.352225, 1.261200>
    }
    triangle {
      < -6.130356, 0.362556, 1.254850>,
      < -6.053653, 0.352225, 1.261200>,
      < -6.053653, 0.363062, 1.254569>
    }
    triangle {
      < -6.053556, 0.419043, 1.295002>,
      < -6.000756, 0.633820, 1.291040>,
      < -6.130355, 0.419233, 1.296705>
    }
    triangle {
      < -6.053653, 0.365750, 1.331035>,
      < -6.130356, 0.365366, 1.330530>,
      < -6.000752, 0.260016, 1.517634>
    }
    triangle {
      < -6.305160, 0.419036, 1.286100>,
      < -6.151562, 0.611403, 1.284654>,
      < -6.000756, 0.633495, 1.282280>
    }
    triangle {
      < -6.305160, 0.419036, 1.286100>,
      < -6.000756, 0.633495, 1.282280>,
      < -6.130355, 0.418783, 1.284588>
    }
    triangle {
      < -6.151558, 0.262956, 1.090456>,
      < -6.305161, 0.363970, 1.254264>,
      < -6.130356, 0.362556, 1.254850>
    }
    triangle {
      < -6.151558, 0.262956, 1.090456>,
      < -6.130356, 0.362556, 1.254850>,
      < -6.000752, 0.250350, 1.071848>
    }
    triangle {
      < -6.053653, 0.354613, 1.324923>,
      < -6.000753, 0.252266, 1.513536>,
      < -6.130357, 0.354647, 1.324861>
    }
    triangle {
      < -6.053653, 0.352225, 1.261200>,
      < -6.130357, 0.352288, 1.261298>,
      < -6.000753, 0.242926, 1.076510>
    }
    triangle {
      < -7.091707, -0.662036, 0.660402>,
      < -7.153274, -0.609095, 0.660402>,
      < -7.217670, -0.594650, 0.000000>
    }
    triangle {
      < -7.091707, -0.662036, 0.660402>,
      < -7.217670, -0.594650, 0.000000>,
      < -7.156101, -0.649382, 0.000000>
    }
    triangle {
      < -7.153274, -0.609095, 0.660402>,
      < -7.153274, -0.574912, 0.660402>,
      < -7.217670, -0.559311, 0.000000>
    }
    triangle {
      < -7.153274, -0.609095, 0.660402>,
      < -7.217670, -0.559311, 0.000000>,
      < -7.217670, -0.594650, 0.000000>
    }
    triangle {
      < -7.153274, -0.574912, 0.660402>,
      < -7.102151, -0.523676, 0.660402>,
      < -7.165748, -0.506341, 0.000000>
    }
    triangle {
      < -7.153274, -0.574912, 0.660402>,
      < -7.165748, -0.506341, 0.000000>,
      < -7.217670, -0.559311, 0.000000>
    }
    triangle {
      < -7.102151, -0.523676, 0.660402>,
      < -7.040987, -0.488222, 0.660402>,
      < -7.104059, -0.469687, 0.000000>
    }
    triangle {
      < -7.102151, -0.523676, 0.660402>,
      < -7.104059, -0.469687, 0.000000>,
      < -7.165748, -0.506341, 0.000000>
    }
    triangle {
      < -7.040987, -0.488222, 0.660402>,
      < -6.980371, -0.468551, 0.660402>,
      < -7.040373, -0.449391, 0.000000>
    }
    triangle {
      < -7.040987, -0.488222, 0.660402>,
      < -7.040373, -0.449391, 0.000000>,
      < -7.104059, -0.469687, 0.000000>
    }
    triangle {
      < -6.980371, -0.468551, 0.660402>,
      < -6.980371, -0.662036, 0.660402>,
      < -7.040370, -0.649382, 0.000000>
    }
    triangle {
      < -6.980371, -0.468551, 0.660402>,
      < -7.040370, -0.649382, 0.000000>,
      < -7.040373, -0.449391, 0.000000>
    }
    triangle {
      < -6.980371, -0.662036, 0.660402>,
      < -7.091707, -0.662036, 0.660402>,
      < -7.156101, -0.649382, 0.000000>
    }
    triangle {
      < -6.980371, -0.662036, 0.660402>,
      < -7.156101, -0.649382, 0.000000>,
      < -7.040370, -0.649382, 0.000000>
    }
    triangle {
      < -6.725246, -0.975397, 2.865391>,
      < -6.783732, -0.975397, 2.834125>,
      < -6.830800, -0.975397, 2.793523>
    }
    triangle {
      < -6.725246, -0.975397, 2.865391>,
      < -6.830800, -0.975397, 2.793523>,
      < -6.830757, -0.975397, 2.763283>
    }
    triangle {
      < -6.725246, -0.975397, 2.865391>,
      < -6.830757, -0.975397, 2.763283>,
      < -6.769086, -0.975397, 2.725227>
    }
    triangle {
      < -6.725246, -0.975397, 2.865391>,
      < -6.769086, -0.975397, 2.725227>,
      < -6.679766, -0.975385, 2.725400>
    }
    triangle {
      < -6.725246, -0.975397, 2.865391>,
      < -6.679766, -0.975385, 2.725400>,
      < -6.679999, -0.975397, 2.898600>
    }
    triangle {
      < -7.030923, -0.546992, 1.284801>,
      < -6.970352, -0.511978, 1.284801>,
      < -7.040987, -0.488222, 0.660402>
    }
    triangle {
      < -7.030923, -0.546992, 1.284801>,
      < -7.040987, -0.488222, 0.660402>,
      < -7.102151, -0.523676, 0.660402>
    }
    triangle {
      < -6.970352, -0.511978, 1.284801>,
      < -6.913171, -0.492551, 1.284801>,
      < -6.980371, -0.468551, 0.660402>
    }
    triangle {
      < -6.970352, -0.511978, 1.284801>,
      < -6.980371, -0.468551, 0.660402>,
      < -7.040987, -0.488222, 0.660402>
    }
    triangle {
      < -6.913171, -0.492551, 1.284801>,
      < -6.913171, -0.683637, 1.284801>,
      < -6.980371, -0.662036, 0.660402>
    }
    triangle {
      < -6.913171, -0.492551, 1.284801>,
      < -6.980371, -0.662036, 0.660402>,
      < -6.980371, -0.468551, 0.660402>
    }
    triangle {
      < -6.913171, -0.683637, 1.284801>,
      < -7.019585, -0.683637, 1.284801>,
      < -7.091707, -0.662036, 0.660402>
    }
    triangle {
      < -6.913171, -0.683637, 1.284801>,
      < -7.091707, -0.662036, 0.660402>,
      < -6.980371, -0.662036, 0.660402>
    }
    triangle {
      < -7.019585, -0.683637, 1.284801>,
      < -7.081152, -0.631353, 1.284801>,
      < -7.153274, -0.609095, 0.660402>
    }
    triangle {
      < -7.019585, -0.683637, 1.284801>,
      < -7.153274, -0.609095, 0.660402>,
      < -7.091707, -0.662036, 0.660402>
    }
    triangle {
      < -7.081152, -0.631353, 1.284801>,
      < -7.081152, -0.597594, 1.284801>,
      < -7.153274, -0.574912, 0.660402>
    }
    triangle {
      < -7.081152, -0.631353, 1.284801>,
      < -7.153274, -0.574912, 0.660402>,
      < -7.153274, -0.609095, 0.660402>
    }
    triangle {
      < -7.081152, -0.597594, 1.284801>,
      < -7.030923, -0.546992, 1.284801>,
      < -7.102151, -0.523676, 0.660402>
    }
    triangle {
      < -7.081152, -0.597594, 1.284801>,
      < -7.102151, -0.523676, 0.660402>,
      < -7.153274, -0.574912, 0.660402>
    }
    triangle {
      < -6.942312, -0.714928, 1.851601>,
      < -7.003879, -0.663932, 1.851601>,
      < -7.081152, -0.631353, 1.284801>
    }
    triangle {
      < -6.942312, -0.714928, 1.851601>,
      < -7.081152, -0.631353, 1.284801>,
      < -7.019585, -0.683637, 1.284801>
    }
    triangle {
      < -7.003879, -0.663932, 1.851601>,
      < -7.003879, -0.631005, 1.851601>,
      < -7.081152, -0.597594, 1.284801>
    }
    triangle {
      < -7.003879, -0.663932, 1.851601>,
      < -7.081152, -0.597594, 1.284801>,
      < -7.081152, -0.631353, 1.284801>
    }
    triangle {
      < -7.003879, -0.631005, 1.851601>,
      < -6.954609, -0.581651, 1.851601>,
      < -7.030923, -0.546992, 1.284801>
    }
    triangle {
      < -7.003879, -0.631005, 1.851601>,
      < -7.030923, -0.546992, 1.284801>,
      < -7.081152, -0.597594, 1.284801>
    }
    triangle {
      < -6.954609, -0.581651, 1.851601>,
      < -6.894668, -0.547499, 1.851601>,
      < -6.970352, -0.511978, 1.284801>
    }
    triangle {
      < -6.954609, -0.581651, 1.851601>,
      < -6.970352, -0.511978, 1.284801>,
      < -7.030923, -0.546992, 1.284801>
    }
    triangle {
      < -6.894668, -0.547499, 1.851601>,
      < -6.841173, -0.528551, 1.851601>,
      < -6.913171, -0.492551, 1.284801>
    }
    triangle {
      < -6.894668, -0.547499, 1.851601>,
      < -6.913171, -0.492551, 1.284801>,
      < -6.970352, -0.511978, 1.284801>
    }
    triangle {
      < -6.841173, -0.528551, 1.851601>,
      < -6.841173, -0.714928, 1.851601>,
      < -6.913171, -0.683637, 1.284801>
    }
    triangle {
      < -6.841173, -0.528551, 1.851601>,
      < -6.913171, -0.683637, 1.284801>,
      < -6.913171, -0.492551, 1.284801>
    }
    triangle {
      < -6.841173, -0.714928, 1.851601>,
      < -6.942312, -0.714928, 1.851601>,
      < -7.019585, -0.683637, 1.284801>
    }
    triangle {
      < -6.841173, -0.714928, 1.851601>,
      < -7.019585, -0.683637, 1.284801>,
      < -6.913171, -0.683637, 1.284801>
    }
    triangle {
      < -6.846962, -0.583301, 2.244705>,
      < -6.795573, -0.564551, 2.248002>,
      < -6.841173, -0.528551, 1.851601>
    }
    triangle {
      < -6.846962, -0.583301, 2.244705>,
      < -6.841173, -0.528551, 1.851601>,
      < -6.894668, -0.547499, 1.851601>
    }
    triangle {
      < -6.795573, -0.564551, 2.248002>,
      < -6.795341, -0.748094, 2.215616>,
      < -6.841173, -0.714928, 1.851601>
    }
    triangle {
      < -6.795573, -0.564551, 2.248002>,
      < -6.841173, -0.714928, 1.851601>,
      < -6.841173, -0.528551, 1.851601>
    }
    triangle {
      < -6.795341, -0.748094, 2.215616>,
      < -6.893474, -0.748249, 2.215607>,
      < -6.942312, -0.714928, 1.851601>
    }
    triangle {
      < -6.795341, -0.748094, 2.215616>,
      < -6.942312, -0.714928, 1.851601>,
      < -6.841173, -0.714928, 1.851601>
    }
    triangle {
      < -6.893474, -0.748249, 2.215607>,
      < -6.955111, -0.698103, 2.224465>,
      < -7.003879, -0.663932, 1.851601>
    }
    triangle {
      < -6.893474, -0.748249, 2.215607>,
      < -7.003879, -0.663932, 1.851601>,
      < -6.942312, -0.714928, 1.851601>
    }
    triangle {
      < -6.955111, -0.698103, 2.224465>,
      < -6.955161, -0.665677, 2.230188>,
      < -7.003879, -0.631005, 1.851601>
    }
    triangle {
      < -6.955111, -0.698103, 2.224465>,
      < -7.003879, -0.631005, 1.851601>,
      < -7.003879, -0.663932, 1.851601>
    }
    triangle {
      < -6.955161, -0.665677, 2.230188>,
      < -6.906495, -0.617009, 2.238770>,
      < -6.954609, -0.581651, 1.851601>
    }
    triangle {
      < -6.955161, -0.665677, 2.230188>,
      < -6.954609, -0.581651, 1.851601>,
      < -7.003879, -0.631005, 1.851601>
    }
    triangle {
      < -6.906495, -0.617009, 2.238770>,
      < -6.846962, -0.583301, 2.244705>,
      < -6.894668, -0.547499, 1.851601>
    }
    triangle {
      < -6.906495, -0.617009, 2.238770>,
      < -6.894668, -0.547499, 1.851601>,
      < -6.954609, -0.581651, 1.851601>
    }
    triangle {
      < -6.921115, -0.736619, 2.429191>,
      < -6.921178, -0.705357, 2.436850>,
      < -6.955161, -0.665677, 2.230188>
    }
    triangle {
      < -6.921115, -0.736619, 2.429191>,
      < -6.955161, -0.665677, 2.230188>,
      < -6.955111, -0.698103, 2.224465>
    }
    triangle {
      < -6.921178, -0.705357, 2.436850>,
      < -6.873030, -0.658395, 2.448340>,
      < -6.906495, -0.617009, 2.238770>
    }
    triangle {
      < -6.921178, -0.705357, 2.436850>,
      < -6.906495, -0.617009, 2.238770>,
      < -6.955161, -0.665677, 2.230188>
    }
    triangle {
      < -6.873030, -0.658395, 2.448340>,
      < -6.813840, -0.625849, 2.456295>,
      < -6.846962, -0.583301, 2.244705>
    }
    triangle {
      < -6.873030, -0.658395, 2.448340>,
      < -6.846962, -0.583301, 2.244705>,
      < -6.906495, -0.617009, 2.238770>
    }
    triangle {
      < -6.813840, -0.625849, 2.456295>,
      < -6.764312, -0.607716, 2.465000>,
      < -6.795573, -0.564551, 2.248002>
    }
    triangle {
      < -6.813840, -0.625849, 2.456295>,
      < -6.795573, -0.564551, 2.248002>,
      < -6.846962, -0.583301, 2.244705>
    }
    triangle {
      < -6.764312, -0.607716, 2.465000>,
      < -6.763950, -0.784674, 2.420194>,
      < -6.795341, -0.748094, 2.215616>
    }
    triangle {
      < -6.764312, -0.607716, 2.465000>,
      < -6.795341, -0.748094, 2.215616>,
      < -6.795573, -0.564551, 2.248002>
    }
    triangle {
      < -6.763950, -0.784674, 2.420194>,
      < -6.859429, -0.784919, 2.420162>,
      < -6.893474, -0.748249, 2.215607>
    }
    triangle {
      < -6.763950, -0.784674, 2.420194>,
      < -6.893474, -0.748249, 2.215607>,
      < -6.795341, -0.748094, 2.215616>
    }
    triangle {
      < -6.859429, -0.784919, 2.420162>,
      < -6.921115, -0.736619, 2.429191>,
      < -6.955111, -0.698103, 2.224465>
    }
    triangle {
      < -6.859429, -0.784919, 2.420162>,
      < -6.955111, -0.698103, 2.224465>,
      < -6.893474, -0.748249, 2.215607>
    }
    triangle {
      < -6.745065, -0.639569, 2.571234>,
      < -6.744702, -0.806197, 2.513059>,
      < -6.763950, -0.784674, 2.420194>
    }
    triangle {
      < -6.745065, -0.639569, 2.571234>,
      < -6.763950, -0.784674, 2.420194>,
      < -6.764312, -0.607716, 2.465000>
    }
    triangle {
      < -6.744702, -0.806197, 2.513059>,
      < -6.838772, -0.806440, 2.513008>,
      < -6.859429, -0.784919, 2.420162>
    }
    triangle {
      < -6.744702, -0.806197, 2.513059>,
      < -6.859429, -0.784919, 2.420162>,
      < -6.763950, -0.784674, 2.420194>
    }
    triangle {
      < -6.838772, -0.806440, 2.513008>,
      < -6.900463, -0.764452, 2.522529>,
      < -6.921115, -0.736619, 2.429191>
    }
    triangle {
      < -6.838772, -0.806440, 2.513008>,
      < -6.921115, -0.736619, 2.429191>,
      < -6.859429, -0.784919, 2.420162>
    }
    triangle {
      < -6.900463, -0.764452, 2.522529>,
      < -6.900524, -0.734166, 2.532471>,
      < -6.921178, -0.705357, 2.436850>
    }
    triangle {
      < -6.900463, -0.764452, 2.522529>,
      < -6.921178, -0.705357, 2.436850>,
      < -6.921115, -0.736619, 2.429191>
    }
    triangle {
      < -6.900524, -0.734166, 2.532471>,
      < -6.852634, -0.688671, 2.547393>,
      < -6.873030, -0.658395, 2.448340>
    }
    triangle {
      < -6.900524, -0.734166, 2.532471>,
      < -6.873030, -0.658395, 2.448340>,
      < -6.921178, -0.705357, 2.436850>
    }
    triangle {
      < -6.852634, -0.688671, 2.547393>,
      < -6.793611, -0.657139, 2.557726>,
      < -6.813840, -0.625849, 2.456295>
    }
    triangle {
      < -6.852634, -0.688671, 2.547393>,
      < -6.813840, -0.625849, 2.456295>,
      < -6.873030, -0.658395, 2.448340>
    }
    triangle {
      < -6.793611, -0.657139, 2.557726>,
      < -6.745065, -0.639569, 2.571234>,
      < -6.764312, -0.607716, 2.465000>
    }
    triangle {
      < -6.793611, -0.657139, 2.557726>,
      < -6.764312, -0.607716, 2.465000>,
      < -6.813840, -0.625849, 2.456295>
    }
    triangle {
      < -6.882408, -0.771376, 2.624346>,
      < -6.834761, -0.729891, 2.647045>,
      < -6.852634, -0.688671, 2.547393>
    }
    triangle {
      < -6.882408, -0.771376, 2.624346>,
      < -6.852634, -0.688671, 2.547393>,
      < -6.900524, -0.734166, 2.532471>
    }
    triangle {
      < -6.834761, -0.729891, 2.647045>,
      < -6.775896, -0.701126, 2.662767>,
      < -6.793611, -0.657139, 2.557726>
    }
    triangle {
      < -6.834761, -0.729891, 2.647045>,
      < -6.793611, -0.657139, 2.557726>,
      < -6.852634, -0.688671, 2.547393>
    }
    triangle {
      < -6.775896, -0.701126, 2.662767>,
      < -6.728222, -0.685081, 2.682935>,
      < -6.745065, -0.639569, 2.571234>
    }
    triangle {
      < -6.775896, -0.701126, 2.662767>,
      < -6.745065, -0.639569, 2.571234>,
      < -6.793611, -0.657139, 2.557726>
    }
    triangle {
      < -6.728222, -0.685081, 2.682935>,
      < -6.727795, -0.836503, 2.594472>,
      < -6.744702, -0.806197, 2.513059>
    }
    triangle {
      < -6.728222, -0.685081, 2.682935>,
      < -6.744702, -0.806197, 2.513059>,
      < -6.745065, -0.639569, 2.571234>
    }
    triangle {
      < -6.727795, -0.836503, 2.594472>,
      < -6.820625, -0.836784, 2.594374>,
      < -6.838772, -0.806440, 2.513008>
    }
    triangle {
      < -6.727795, -0.836503, 2.594472>,
      < -6.838772, -0.806440, 2.513008>,
      < -6.744702, -0.806197, 2.513059>
    }
    triangle {
      < -6.820625, -0.836784, 2.594374>,
      < -6.882334, -0.798975, 2.609227>,
      < -6.900463, -0.764452, 2.522529>
    }
    triangle {
      < -6.820625, -0.836784, 2.594374>,
      < -6.900463, -0.764452, 2.522529>,
      < -6.838772, -0.806440, 2.513008>
    }
    triangle {
      < -6.882334, -0.798975, 2.609227>,
      < -6.882408, -0.771376, 2.624346>,
      < -6.900524, -0.734166, 2.532471>
    }
    triangle {
      < -6.882334, -0.798975, 2.609227>,
      < -6.900524, -0.734166, 2.532471>,
      < -6.900463, -0.764452, 2.522529>
    }
    triangle {
      < -6.703798, -0.889672, 2.667458>,
      < -6.794872, -0.889850, 2.667313>,
      < -6.820625, -0.836784, 2.594374>
    }
    triangle {
      < -6.703798, -0.889672, 2.667458>,
      < -6.820625, -0.836784, 2.594374>,
      < -6.727795, -0.836503, 2.594472>
    }
    triangle {
      < -6.794872, -0.889850, 2.667313>,
      < -6.856548, -0.856801, 2.685278>,
      < -6.882334, -0.798975, 2.609227>
    }
    triangle {
      < -6.794872, -0.889850, 2.667313>,
      < -6.882334, -0.798975, 2.609227>,
      < -6.820625, -0.836784, 2.594374>
    }
    triangle {
      < -6.856548, -0.856801, 2.685278>,
      < -6.856605, -0.835405, 2.703960>,
      < -6.882408, -0.771376, 2.624346>
    }
    triangle {
      < -6.856548, -0.856801, 2.685278>,
      < -6.882408, -0.771376, 2.624346>,
      < -6.882334, -0.798975, 2.609227>
    }
    triangle {
      < -6.856605, -0.835405, 2.703960>,
      < -6.809236, -0.803261, 2.732023>,
      < -6.834761, -0.729891, 2.647045>
    }
    triangle {
      < -6.856605, -0.835405, 2.703960>,
      < -6.834761, -0.729891, 2.647045>,
      < -6.882408, -0.771376, 2.624346>
    }
    triangle {
      < -6.809236, -0.803261, 2.732023>,
      < -6.750566, -0.780981, 2.751467>,
      < -6.775896, -0.701126, 2.662767>
    }
    triangle {
      < -6.809236, -0.803261, 2.732023>,
      < -6.775896, -0.701126, 2.662767>,
      < -6.834761, -0.729891, 2.647045>
    }
    triangle {
      < -6.750566, -0.780981, 2.751467>,
      < -6.704106, -0.768564, 2.776783>,
      < -6.728222, -0.685081, 2.682935>
    }
    triangle {
      < -6.750566, -0.780981, 2.751467>,
      < -6.728222, -0.685081, 2.682935>,
      < -6.775896, -0.701126, 2.662767>
    }
    triangle {
      < -6.704106, -0.768564, 2.776783>,
      < -6.703798, -0.889672, 2.667458>,
      < -6.727795, -0.836503, 2.594472>
    }
    triangle {
      < -6.704106, -0.768564, 2.776783>,
      < -6.727795, -0.836503, 2.594472>,
      < -6.728222, -0.685081, 2.682935>
    }
    triangle {
      < -6.783704, -0.932582, 2.815392>,
      < -6.725217, -0.921603, 2.841858>,
      < -6.750566, -0.780981, 2.751467>
    }
    triangle {
      < -6.783704, -0.932582, 2.815392>,
      < -6.750566, -0.780981, 2.751467>,
      < -6.809236, -0.803261, 2.732023>
    }
    triangle {
      < -6.725217, -0.921603, 2.841858>,
      < -6.679971, -0.915506, 2.874271>,
      < -6.704106, -0.768564, 2.776783>
    }
    triangle {
      < -6.725217, -0.921603, 2.841858>,
      < -6.704106, -0.768564, 2.776783>,
      < -6.750566, -0.780981, 2.751467>
    }
    triangle {
      < -6.679971, -0.915506, 2.874271>,
      < -6.679766, -0.975385, 2.725400>,
      < -6.703798, -0.889672, 2.667458>
    }
    triangle {
      < -6.679971, -0.915506, 2.874271>,
      < -6.703798, -0.889672, 2.667458>,
      < -6.704106, -0.768564, 2.776783>
    }
    triangle {
      < -6.679766, -0.975385, 2.725400>,
      < -6.769086, -0.975397, 2.725227>,
      < -6.794872, -0.889850, 2.667313>
    }
    triangle {
      < -6.679766, -0.975385, 2.725400>,
      < -6.794872, -0.889850, 2.667313>,
      < -6.703798, -0.889672, 2.667458>
    }
    triangle {
      < -6.769086, -0.975397, 2.725227>,
      < -6.830726, -0.959023, 2.751749>,
      < -6.856548, -0.856801, 2.685278>
    }
    triangle {
      < -6.769086, -0.975397, 2.725227>,
      < -6.856548, -0.856801, 2.685278>,
      < -6.794872, -0.889850, 2.667313>
    }
    triangle {
      < -6.830726, -0.959023, 2.751749>,
      < -6.830770, -0.948443, 2.777189>,
      < -6.856605, -0.835405, 2.703960>
    }
    triangle {
      < -6.830726, -0.959023, 2.751749>,
      < -6.856605, -0.835405, 2.703960>,
      < -6.856548, -0.856801, 2.685278>
    }
    triangle {
      < -6.830770, -0.948443, 2.777189>,
      < -6.783704, -0.932582, 2.815392>,
      < -6.809236, -0.803261, 2.732023>
    }
    triangle {
      < -6.830770, -0.948443, 2.777189>,
      < -6.809236, -0.803261, 2.732023>,
      < -6.856605, -0.835405, 2.703960>
    }
    triangle {
      < -6.830757, -0.975397, 2.763283>,
      < -6.830726, -0.959023, 2.751749>,
      < -6.769086, -0.975397, 2.725227>
    }
    triangle {
      < -6.830757, -0.975397, 2.763283>,
      < -6.830800, -0.975397, 2.793523>,
      < -6.830770, -0.948443, 2.777189>
    }
    triangle {
      < -6.830757, -0.975397, 2.763283>,
      < -6.830770, -0.948443, 2.777189>,
      < -6.830726, -0.959023, 2.751749>
    }
    triangle {
      < -6.830800, -0.975397, 2.793523>,
      < -6.783732, -0.975397, 2.834125>,
      < -6.783704, -0.932582, 2.815392>
    }
    triangle {
      < -6.830800, -0.975397, 2.793523>,
      < -6.783704, -0.932582, 2.815392>,
      < -6.830770, -0.948443, 2.777189>
    }
    triangle {
      < -6.783732, -0.975397, 2.834125>,
      < -6.725246, -0.975397, 2.865391>,
      < -6.725217, -0.921603, 2.841858>
    }
    triangle {
      < -6.783732, -0.975397, 2.834125>,
      < -6.725217, -0.921603, 2.841858>,
      < -6.783704, -0.932582, 2.815392>
    }
    triangle {
      < -6.725246, -0.975397, 2.865391>,
      < -6.679999, -0.975397, 2.898600>,
      < -6.679971, -0.915506, 2.874271>
    }
    triangle {
      < -6.725246, -0.975397, 2.865391>,
      < -6.679971, -0.915506, 2.874271>,
      < -6.725217, -0.921603, 2.841858>
    }
    triangle {
      < -6.679999, -0.975397, 2.898600>,
      < -6.679766, -0.975385, 2.725400>,
      < -6.679971, -0.915506, 2.874271>
    }
    triangle {
      < -7.166669, -1.402146, 0.000000>,
      < -7.000368, -1.396264, 1.751397>,
      < -6.928576, -1.359446, 1.742034>
    }
    triangle {
      < -7.166669, -1.402146, 0.000000>,
      < -6.928576, -1.359446, 1.742034>,
      < -7.088053, -1.366763, 0.000000>
    }
    triangle {
      < -5.908761, -1.658627, 2.888216>,
      < -5.965001, -1.564561, 2.923875>,
      < -6.422453, -1.549520, 2.907676>
    }
    triangle {
      < -5.908761, -1.658627, 2.888216>,
      < -6.422453, -1.549520, 2.907676>,
      < -6.387282, -1.658624, 2.864736>
    }
    triangle {
      < -7.001560, -1.324139, 0.000000>,
      < -7.088053, -1.366763, 0.000000>,
      < -6.928576, -1.359446, 1.742034>
    }
    triangle {
      < -7.001560, -1.324139, 0.000000>,
      < -6.928576, -1.359446, 1.742034>,
      < -6.806197, -1.329456, 1.724040>
    }
    triangle {
      < -7.260464, -1.592207, 0.000000>,
      < -7.084901, -1.589411, 1.766879>,
      < -7.105881, -1.534636, 1.767466>
    }
    triangle {
      < -7.260464, -1.592207, 0.000000>,
      < -7.105881, -1.534636, 1.767466>,
      < -7.285424, -1.538095, 0.000000>
    }
    triangle {
      < -5.965001, -1.564561, 2.923875>,
      < -5.946338, -1.504564, 2.972630>,
      < -6.437954, -1.474521, 2.968994>
    }
    triangle {
      < -5.965001, -1.564561, 2.923875>,
      < -6.437954, -1.474521, 2.968994>,
      < -6.422453, -1.549520, 2.907676>
    }
    triangle {
      < -5.977087, -1.168581, 3.057851>,
      < -5.776556, -1.177829, 3.017266>,
      < -5.795750, -1.119792, 3.044409>
    }
    triangle {
      < -5.977087, -1.168581, 3.057851>,
      < -5.795750, -1.119792, 3.044409>,
      < -5.994472, -1.120564, 3.065847>
    }
    triangle {
      < -6.896116, -0.992319, 2.807465>,
      < -6.943775, -0.989475, 2.705712>,
      < -7.003592, -1.010780, 2.706787>
    }
    triangle {
      < -6.896116, -0.992319, 2.807465>,
      < -7.003592, -1.010780, 2.706787>,
      < -6.943068, -1.013447, 2.837431>
    }
    triangle {
      < -6.647933, -1.394501, 2.909369>,
      < -6.661417, -1.464500, 2.930422>,
      < -6.437954, -1.474521, 2.968994>
    }
    triangle {
      < -6.647933, -1.394501, 2.909369>,
      < -6.437954, -1.474521, 2.968994>,
      < -6.444781, -1.384520, 2.944435>
    }
    triangle {
      < -6.686976, -1.859547, 2.586358>,
      < -6.596330, -1.859547, 2.644202>,
      < -6.661929, -1.769979, 2.720089>
    }
    triangle {
      < -6.686976, -1.859547, 2.586358>,
      < -6.661929, -1.769979, 2.720089>,
      < -6.756017, -1.770061, 2.657989>
    }
    triangle {
      < -7.005176, -1.550954, 2.317360>,
      < -6.931129, -1.659463, 2.403928>,
      < -7.022886, -1.409456, 2.450853>
    }
    triangle {
      < -6.915789, -1.194457, 2.154421>,
      < -6.899156, -1.264157, 2.076385>,
      < -6.976470, -1.298631, 2.102237>
    }
    triangle {
      < -6.915789, -1.194457, 2.154421>,
      < -6.976470, -1.298631, 2.102237>,
      < -6.990645, -1.226394, 2.190381>
    }
    triangle {
      < -5.975104, -1.009408, 2.989822>,
      < -6.488513, -0.995182, 2.962733>,
      < -6.493579, -1.016994, 3.008955>
    }
    triangle {
      < -5.975104, -1.009408, 2.989822>,
      < -6.493579, -1.016994, 3.008955>,
      < -5.980691, -1.027046, 3.030011>
    }
    triangle {
      < -5.944620, -1.416520, 2.956802>,
      < -5.945208, -1.284483, 2.987595>,
      < -6.453266, -1.284490, 2.965122>
    }
    triangle {
      < -5.944620, -1.416520, 2.956802>,
      < -6.453266, -1.284490, 2.965122>,
      < -6.444781, -1.384520, 2.944435>
    }
    triangle {
      < -6.444781, -1.384520, 2.944435>,
      < -6.453266, -1.284490, 2.965122>,
      < -6.666018, -1.284488, 2.935784>
    }
    triangle {
      < -6.444781, -1.384520, 2.944435>,
      < -6.666018, -1.284488, 2.935784>,
      < -6.647933, -1.394501, 2.909369>
    }
    triangle {
      < -6.981668, -1.284483, 2.668404>,
      < -6.939265, -1.460639, 2.654139>,
      < -6.904433, -1.463284, 2.706286>
    }
    triangle {
      < -6.981668, -1.284483, 2.668404>,
      < -6.904433, -1.463284, 2.706286>,
      < -6.919416, -1.284488, 2.764061>
    }
    triangle {
      < -6.981668, -1.284483, 2.668404>,
      < -7.014936, -1.369458, 2.490375>,
      < -7.005966, -1.416750, 2.478881>
    }
    triangle {
      < -6.981668, -1.284483, 2.668404>,
      < -7.005966, -1.416750, 2.478881>,
      < -6.939265, -1.460639, 2.654139>
    }
    triangle {
      < -6.387282, -1.658624, 2.864736>,
      < -6.422453, -1.549520, 2.907676>,
      < -6.640931, -1.539500, 2.868735>
    }
    triangle {
      < -6.387282, -1.658624, 2.864736>,
      < -6.640931, -1.539500, 2.868735>,
      < -6.626447, -1.658622, 2.817301>
    }
    triangle {
      < -6.838706, -1.284492, 2.838292>,
      < -6.758198, -1.464489, 2.842342>,
      < -6.746375, -1.424491, 2.866534>
    }
    triangle {
      < -6.838706, -1.284492, 2.838292>,
      < -6.746375, -1.424491, 2.866534>,
      < -6.764087, -1.284490, 2.897935>
    }
    triangle {
      < -6.714914, -1.658623, 2.773726>,
      < -6.732902, -1.514492, 2.845476>,
      < -6.758198, -1.464489, 2.842342>
    }
    triangle {
      < -6.714914, -1.658623, 2.773726>,
      < -6.758198, -1.464489, 2.842342>,
      < -6.808095, -1.658623, 2.710665>
    }
    triangle {
      < -5.853824, -1.549571, 2.935682>,
      < -5.965001, -1.564561, 2.923875>,
      < -5.908761, -1.658627, 2.888216>
    }
    triangle {
      < -6.661417, -1.464500, 2.930422>,
      < -6.640931, -1.539500, 2.868735>,
      < -6.422453, -1.549520, 2.907676>
    }
    triangle {
      < -6.661417, -1.464500, 2.930422>,
      < -6.422453, -1.549520, 2.907676>,
      < -6.437954, -1.474521, 2.968994>
    }
    triangle {
      < -5.853824, -1.549571, 2.935682>,
      < -5.946338, -1.504564, 2.972630>,
      < -5.965001, -1.564561, 2.923875>
    }
    triangle {
      < -6.497226, -1.120446, 3.059467>,
      < -6.719749, -1.120220, 3.039568>,
      < -6.707731, -1.171216, 3.021462>
    }
    triangle {
      < -6.497226, -1.120446, 3.059467>,
      < -6.707731, -1.171216, 3.021462>,
      < -6.486555, -1.169997, 3.044676>
    }
    triangle {
      < -7.005646, -1.119330, 2.870995>,
      < -7.088174, -1.119861, 2.700568>,
      < -7.069232, -1.171446, 2.694571>
    }
    triangle {
      < -7.005646, -1.119330, 2.870995>,
      < -7.069232, -1.171446, 2.694571>,
      < -6.989767, -1.172314, 2.848089>
    }
    triangle {
      < -6.923314, -1.119656, 2.946822>,
      < -7.005646, -1.119330, 2.870995>,
      < -6.989767, -1.172314, 2.848089>
    }
    triangle {
      < -6.923314, -1.119656, 2.946822>,
      < -6.989767, -1.172314, 2.848089>,
      < -6.906362, -1.172695, 2.924689>
    }
    triangle {
      < -6.719749, -1.120220, 3.039568>,
      < -6.833333, -1.119999, 3.006480>,
      < -6.819161, -1.172247, 2.985674>
    }
    triangle {
      < -6.719749, -1.120220, 3.039568>,
      < -6.819161, -1.172247, 2.985674>,
      < -6.707731, -1.171216, 3.021462>
    }
    triangle {
      < -5.994472, -1.120564, 3.065847>,
      < -6.497226, -1.120446, 3.059467>,
      < -6.486555, -1.169997, 3.044676>
    }
    triangle {
      < -5.994472, -1.120564, 3.065847>,
      < -6.486555, -1.169997, 3.044676>,
      < -5.977087, -1.168581, 3.057851>
    }
    triangle {
      < -6.782897, -0.989486, 2.914382>,
      < -6.841444, -0.989483, 2.868588>,
      < -6.878011, -1.012117, 2.905717>
    }
    triangle {
      < -6.782897, -0.989486, 2.914382>,
      < -6.878011, -1.012117, 2.905717>,
      < -6.806467, -1.012607, 2.958068>
    }
    triangle {
      < -6.488513, -0.995182, 2.962733>,
      < -6.700897, -0.989491, 2.938380>,
      < -6.710935, -1.012946, 2.986064>
    }
    triangle {
      < -6.488513, -0.995182, 2.962733>,
      < -6.710935, -1.012946, 2.986064>,
      < -6.493579, -1.016994, 3.008955>
    }
    triangle {
      < -6.700897, -0.989491, 2.938380>,
      < -6.782897, -0.989486, 2.914382>,
      < -6.806467, -1.012607, 2.958068>
    }
    triangle {
      < -6.700897, -0.989491, 2.938380>,
      < -6.806467, -1.012607, 2.958068>,
      < -6.710935, -1.012946, 2.986064>
    }
    triangle {
      < -6.841444, -0.989483, 2.868588>,
      < -6.896116, -0.992319, 2.807465>,
      < -6.943068, -1.013447, 2.837431>
    }
    triangle {
      < -6.841444, -0.989483, 2.868588>,
      < -6.943068, -1.013447, 2.837431>,
      < -6.878011, -1.012117, 2.905717>
    }
    triangle {
      < -7.094053, -1.527854, 1.920331>,
      < -7.105881, -1.534636, 1.767466>,
      < -7.084901, -1.589411, 1.766879>
    }
    triangle {
      < -7.094053, -1.527854, 1.920331>,
      < -7.084901, -1.589411, 1.766879>,
      < -7.075849, -1.580462, 1.933608>
    }
    triangle {
      < -7.080834, -1.458599, 2.229285>,
      < -7.091934, -1.354392, 2.349924>,
      < -7.097250, -1.331093, 2.310717>
    }
    triangle {
      < -7.080834, -1.458599, 2.229285>,
      < -7.097250, -1.331093, 2.310717>,
      < -7.093822, -1.417261, 2.193316>
    }
    triangle {
      < -6.903983, -1.350924, 1.865938>,
      < -6.928576, -1.359446, 1.742034>,
      < -7.000368, -1.396264, 1.751397>
    }
    triangle {
      < -6.903983, -1.350924, 1.865938>,
      < -7.000368, -1.396264, 1.751397>,
      < -6.979893, -1.388660, 1.881194>
    }
    triangle {
      < -6.915789, -1.194457, 2.154421>,
      < -6.807567, -1.164466, 2.123392>,
      < -6.787118, -1.231666, 2.049427>
    }
    triangle {
      < -6.915789, -1.194457, 2.154421>,
      < -6.787118, -1.231666, 2.049427>,
      < -6.899156, -1.264157, 2.076385>
    }
    triangle {
      < -6.806197, -1.329456, 1.724040>,
      < -6.928576, -1.359446, 1.742034>,
      < -6.903983, -1.350924, 1.865938>
    }
    triangle {
      < -6.806197, -1.329456, 1.724040>,
      < -6.903983, -1.350924, 1.865938>,
      < -6.784866, -1.318434, 1.846585>
    }
    triangle {
      < -7.014936, -1.369458, 2.490375>,
      < -7.022886, -1.409456, 2.450853>,
      < -7.005966, -1.416750, 2.478881>
    }
    triangle {
      < -7.096247, -1.859547, 0.000000>,
      < -6.923715, -1.859547, 1.767040>,
      < -6.972465, -1.791266, 1.766075>
    }
    triangle {
      < -7.096247, -1.859547, 0.000000>,
      < -6.972465, -1.791266, 1.766075>,
      < -7.142025, -1.789917, 0.000000>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.015004, -1.819897, 2.788333>,
      < -6.370975, -1.859520, 2.723353>
    }
    triangle {
      < -6.596330, -1.859547, 2.644202>,
      < -6.503947, -1.859547, 2.688095>,
      < -6.569460, -1.769633, 2.765059>
    }
    triangle {
      < -6.596330, -1.859547, 2.644202>,
      < -6.569460, -1.769633, 2.765059>,
      < -6.661929, -1.769979, 2.720089>
    }
    triangle {
      < -6.569460, -1.769633, 2.765059>,
      < -6.503947, -1.859547, 2.688095>,
      < -6.370975, -1.859520, 2.723353>
    }
    triangle {
      < -6.569460, -1.769633, 2.765059>,
      < -6.370975, -1.859520, 2.723353>,
      < -6.381032, -1.768794, 2.807622>
    }
    triangle {
      < -6.923715, -1.859547, 1.767040>,
      < -6.893315, -1.859547, 1.965427>,
      < -6.954820, -1.787191, 1.967162>
    }
    triangle {
      < -6.923715, -1.859547, 1.767040>,
      < -6.954820, -1.787191, 1.967162>,
      < -6.972465, -1.791266, 1.766075>
    }
    triangle {
      < -6.686976, -1.859547, 2.586358>,
      < -6.756017, -1.770061, 2.657989>,
      < -6.823873, -1.769634, 2.576504>
    }
    triangle {
      < -6.686976, -1.859547, 2.586358>,
      < -6.823873, -1.769634, 2.576504>,
      < -6.752730, -1.859547, 2.511016>
    }
    triangle {
      < -6.894863, -1.767690, 2.380389>,
      < -6.830263, -1.859547, 2.349217>,
      < -6.752730, -1.859547, 2.511016>
    }
    triangle {
      < -6.894863, -1.767690, 2.380389>,
      < -6.752730, -1.859547, 2.511016>,
      < -6.823873, -1.769634, 2.576504>
    }
    triangle {
      < -5.794860, -1.020287, 2.986475>,
      < -5.975104, -1.009408, 2.989822>,
      < -5.980691, -1.027046, 3.030011>
    }
    triangle {
      < -5.794860, -1.020287, 2.986475>,
      < -5.980691, -1.027046, 3.030011>,
      < -5.791178, -1.031257, 3.006389>
    }
    triangle {
      < -6.833333, -1.119999, 3.006480>,
      < -6.923314, -1.119656, 2.946822>,
      < -6.906362, -1.172695, 2.924689>
    }
    triangle {
      < -6.833333, -1.119999, 3.006480>,
      < -6.906362, -1.172695, 2.924689>,
      < -6.819161, -1.172247, 2.985674>
    }
    triangle {
      < -6.830263, -1.859547, 2.349217>,
      < -6.894863, -1.767690, 2.380389>,
      < -6.940769, -1.760330, 2.159502>
    }
    triangle {
      < -6.830263, -1.859547, 2.349217>,
      < -6.940769, -1.760330, 2.159502>,
      < -6.862916, -1.859547, 2.163813>
    }
    triangle {
      < -6.830558, -1.467492, 2.783210>,
      < -6.838706, -1.284492, 2.838292>,
      < -6.919416, -1.284488, 2.764061>
    }
    triangle {
      < -6.830558, -1.467492, 2.783210>,
      < -6.919416, -1.284488, 2.764061>,
      < -6.904433, -1.463284, 2.706286>
    }
    triangle {
      < -6.647933, -1.394501, 2.909369>,
      < -6.666018, -1.284488, 2.935784>,
      < -6.764087, -1.284490, 2.897935>
    }
    triangle {
      < -6.647933, -1.394501, 2.909369>,
      < -6.764087, -1.284490, 2.897935>,
      < -6.746375, -1.424491, 2.866534>
    }
    triangle {
      < -6.626447, -1.658622, 2.817301>,
      < -6.640931, -1.539500, 2.868735>,
      < -6.732902, -1.514492, 2.845476>
    }
    triangle {
      < -6.626447, -1.658622, 2.817301>,
      < -6.732902, -1.514492, 2.845476>,
      < -6.714914, -1.658623, 2.773726>
    }
    triangle {
      < -6.830558, -1.467492, 2.783210>,
      < -6.758198, -1.464489, 2.842342>,
      < -6.838706, -1.284492, 2.838292>
    }
    triangle {
      < -6.758198, -1.464489, 2.842342>,
      < -6.732902, -1.514492, 2.845476>,
      < -6.640931, -1.539500, 2.868735>
    }
    triangle {
      < -6.758198, -1.464489, 2.842342>,
      < -6.640931, -1.539500, 2.868735>,
      < -6.661417, -1.464500, 2.930422>
    }
    triangle {
      < -6.746375, -1.424491, 2.866534>,
      < -6.758198, -1.464489, 2.842342>,
      < -6.661417, -1.464500, 2.930422>
    }
    triangle {
      < -6.746375, -1.424491, 2.866534>,
      < -6.661417, -1.464500, 2.930422>,
      < -6.647933, -1.394501, 2.909369>
    }
    triangle {
      < -5.946338, -1.504564, 2.972630>,
      < -5.944620, -1.416520, 2.956802>,
      < -6.444781, -1.384520, 2.944435>
    }
    triangle {
      < -5.946338, -1.504564, 2.972630>,
      < -6.444781, -1.384520, 2.944435>,
      < -6.437954, -1.474521, 2.968994>
    }
    triangle {
      < -5.809381, -1.454192, 2.953298>,
      < -5.946338, -1.504564, 2.972630>,
      < -5.853824, -1.549571, 2.935682>
    }
    triangle {
      < -5.809381, -1.454192, 2.953298>,
      < -5.820180, -1.284486, 2.983333>,
      < -5.945208, -1.284483, 2.987595>
    }
    triangle {
      < -5.809381, -1.454192, 2.953298>,
      < -5.945208, -1.284483, 2.987595>,
      < -5.944620, -1.416520, 2.956802>
    }
    triangle {
      < -5.809381, -1.454192, 2.953298>,
      < -5.944620, -1.416520, 2.956802>,
      < -5.946338, -1.504564, 2.972630>
    }
    triangle {
      < -7.101055, -1.325408, 2.314543>,
      < -7.097250, -1.331093, 2.310717>,
      < -7.091934, -1.354392, 2.349924>
    }
    triangle {
      < -7.101055, -1.325408, 2.314543>,
      < -7.091934, -1.354392, 2.349924>,
      < -7.089150, -1.340504, 2.363926>
    }
    triangle {
      < -6.884923, -1.319456, 1.971828>,
      < -6.778671, -1.284465, 1.951116>,
      < -6.784866, -1.318434, 1.846585>
    }
    triangle {
      < -6.884923, -1.319456, 1.971828>,
      < -6.784866, -1.318434, 1.846585>,
      < -6.903983, -1.350924, 1.865938>
    }
    triangle {
      < -6.884923, -1.319456, 1.971828>,
      < -6.903983, -1.350924, 1.865938>,
      < -6.979893, -1.388660, 1.881194>
    }
    triangle {
      < -6.884923, -1.319456, 1.971828>,
      < -6.979893, -1.388660, 1.881194>,
      < -6.964900, -1.355802, 1.990809>
    }
    triangle {
      < -7.087876, -1.487158, 2.054882>,
      < -7.094053, -1.527854, 1.920331>,
      < -7.075849, -1.580462, 1.933608>
    }
    triangle {
      < -7.087876, -1.487158, 2.054882>,
      < -7.075849, -1.580462, 1.933608>,
      < -7.072170, -1.535828, 2.082598>
    }
    triangle {
      < -6.989864, -1.644451, 2.150267>,
      < -6.931129, -1.659463, 2.403928>,
      < -7.005176, -1.550954, 2.317360>
    }
    triangle {
      < -7.093822, -1.417261, 2.193316>,
      < -7.087876, -1.487158, 2.054882>,
      < -7.072170, -1.535828, 2.082598>
    }
    triangle {
      < -7.093822, -1.417261, 2.193316>,
      < -7.072170, -1.535828, 2.082598>,
      < -7.080834, -1.458599, 2.229285>
    }
    triangle {
      < -6.899156, -1.264157, 2.076385>,
      < -6.884923, -1.319456, 1.971828>,
      < -6.964900, -1.355802, 1.990809>
    }
    triangle {
      < -6.899156, -1.264157, 2.076385>,
      < -6.964900, -1.355802, 1.990809>,
      < -6.976470, -1.298631, 2.102237>
    }
    triangle {
      < -6.778671, -1.284465, 1.951116>,
      < -6.884923, -1.319456, 1.971828>,
      < -6.899156, -1.264157, 2.076385>
    }
    triangle {
      < -6.778671, -1.284465, 1.951116>,
      < -6.899156, -1.264157, 2.076385>,
      < -6.787118, -1.231666, 2.049427>
    }
    triangle {
      < -6.893315, -1.859547, 1.965427>,
      < -6.862916, -1.859547, 2.163813>,
      < -6.940769, -1.760330, 2.159502>
    }
    triangle {
      < -6.893315, -1.859547, 1.965427>,
      < -6.940769, -1.760330, 2.159502>,
      < -6.954820, -1.787191, 1.967162>
    }
    triangle {
      < -7.233480, -0.594374, 0.000000>,
      < -7.160334, -0.649380, 0.000000>,
      < -7.110587, -0.664402, 0.670581>
    }
    triangle {
      < -7.233480, -0.594374, 0.000000>,
      < -7.110587, -0.664402, 0.670581>,
      < -7.132885, -0.614400, 0.668959>
    }
    triangle {
      < -5.820180, -1.284486, 2.983333>,
      < -5.809381, -1.454192, 2.953298>,
      < -5.742157, -1.255670, 2.984018>
    }
    triangle {
      < -6.748319, -1.231666, 2.049427>,
      < -6.787118, -1.231666, 2.049427>,
      < -6.807567, -1.164466, 2.123392>
    }
    triangle {
      < -6.748319, -1.231666, 2.049427>,
      < -6.807567, -1.164466, 2.123392>,
      < -6.769863, -1.171843, 2.115272>
    }
    triangle {
      < -6.713930, -1.859547, 2.511016>,
      < -6.686976, -1.859547, 2.586358>,
      < -6.752730, -1.859547, 2.511016>
    }
    triangle {
      < -6.748319, -1.231666, 2.049427>,
      < -6.739871, -1.284465, 1.951116>,
      < -6.778671, -1.284465, 1.951116>
    }
    triangle {
      < -6.748319, -1.231666, 2.049427>,
      < -6.778671, -1.284465, 1.951116>,
      < -6.787118, -1.231666, 2.049427>
    }
    triangle {
      < -6.739871, -1.284465, 1.951116>,
      < -6.746067, -1.318434, 1.846585>,
      < -6.784866, -1.318434, 1.846585>
    }
    triangle {
      < -6.739871, -1.284465, 1.951116>,
      < -6.784866, -1.318434, 1.846585>,
      < -6.778671, -1.284465, 1.951116>
    }
    triangle {
      < -6.746067, -1.318434, 1.846585>,
      < -6.767396, -1.329456, 1.724040>,
      < -6.806197, -1.329456, 1.724040>
    }
    triangle {
      < -6.746067, -1.318434, 1.846585>,
      < -6.806197, -1.329456, 1.724040>,
      < -6.784866, -1.318434, 1.846585>
    }
    triangle {
      < -6.767396, -1.329456, 1.724040>,
      < -6.962760, -1.324139, 0.000000>,
      < -7.001560, -1.324139, 0.000000>
    }
    triangle {
      < -6.767396, -1.329456, 1.724040>,
      < -7.001560, -1.324139, 0.000000>,
      < -6.806197, -1.329456, 1.724040>
    }
    triangle {
      < -7.057447, -1.859547, 0.000000>,
      < -6.884914, -1.859547, 1.767040>,
      < -6.923715, -1.859547, 1.767040>
    }
    triangle {
      < -7.057447, -1.859547, 0.000000>,
      < -6.923715, -1.859547, 1.767040>,
      < -7.096247, -1.859547, 0.000000>
    }
    triangle {
      < -6.884914, -1.859547, 1.767040>,
      < -6.854515, -1.859547, 1.965427>,
      < -6.893315, -1.859547, 1.965427>
    }
    triangle {
      < -6.884914, -1.859547, 1.767040>,
      < -6.893315, -1.859547, 1.965427>,
      < -6.923715, -1.859547, 1.767040>
    }
    triangle {
      < -6.854515, -1.859547, 1.965427>,
      < -6.824117, -1.859547, 2.163813>,
      < -6.862916, -1.859547, 2.163813>
    }
    triangle {
      < -6.854515, -1.859547, 1.965427>,
      < -6.862916, -1.859547, 2.163813>,
      < -6.893315, -1.859547, 1.965427>
    }
    triangle {
      < -6.824117, -1.859547, 2.163813>,
      < -6.791463, -1.859547, 2.349217>,
      < -6.830263, -1.859547, 2.349217>
    }
    triangle {
      < -6.824117, -1.859547, 2.163813>,
      < -6.830263, -1.859547, 2.349217>,
      < -6.862916, -1.859547, 2.163813>
    }
    triangle {
      < -6.791463, -1.859547, 2.349217>,
      < -6.713930, -1.859547, 2.511016>,
      < -6.752730, -1.859547, 2.511016>
    }
    triangle {
      < -6.791463, -1.859547, 2.349217>,
      < -6.752730, -1.859547, 2.511016>,
      < -6.830263, -1.859547, 2.349217>
    }
    triangle {
      < -6.850533, -0.979485, 2.765028>,
      < -6.890060, -0.976641, 2.663275>,
      < -6.943775, -0.989475, 2.705712>
    }
    triangle {
      < -6.850533, -0.979485, 2.765028>,
      < -6.943775, -0.989475, 2.705712>,
      < -6.896116, -0.992319, 2.807465>
    }
    triangle {
      < -6.674716, -1.846712, 2.543921>,
      < -6.584070, -1.846712, 2.601764>,
      < -6.596330, -1.859547, 2.644202>
    }
    triangle {
      < -6.674716, -1.846712, 2.543921>,
      < -6.596330, -1.859547, 2.644202>,
      < -6.686976, -1.859547, 2.586358>
    }
    triangle {
      < -6.584070, -1.846712, 2.601764>,
      < -6.491687, -1.846712, 2.645658>,
      < -6.503947, -1.859547, 2.688095>
    }
    triangle {
      < -6.584070, -1.846712, 2.601764>,
      < -6.503947, -1.859547, 2.688095>,
      < -6.596330, -1.859547, 2.644202>
    }
    triangle {
      < -6.491687, -1.846712, 2.645658>,
      < -6.358714, -1.846712, 2.680916>,
      < -6.370975, -1.859520, 2.723353>
    }
    triangle {
      < -6.491687, -1.846712, 2.645658>,
      < -6.370975, -1.859520, 2.723353>,
      < -6.503947, -1.859547, 2.688095>
    }
    triangle {
      < -6.358714, -1.846712, 2.680916>,
      < -6.064945, -1.846712, 2.703966>,
      < -6.073455, -1.859547, 2.746403>
    }
    triangle {
      < -6.358714, -1.846712, 2.680916>,
      < -6.073455, -1.859547, 2.746403>,
      < -6.370975, -1.859520, 2.723353>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.064945, -1.846712, 2.703966>,
      < -6.002273, -1.805053, 2.739253>
    }
    triangle {
      < -6.073455, -1.859547, 2.746403>,
      < -6.002273, -1.805053, 2.739253>,
      < -6.015004, -1.819897, 2.788333>
    }
    triangle {
      < -5.893969, -1.645792, 2.845779>,
      < -5.836937, -1.536736, 2.893245>,
      < -5.853824, -1.549571, 2.935682>
    }
    triangle {
      < -5.893969, -1.645792, 2.845779>,
      < -5.853824, -1.549571, 2.935682>,
      < -5.908761, -1.658627, 2.888216>
    }
    triangle {
      < -5.836937, -1.536736, 2.893245>,
      < -5.790800, -1.441357, 2.910861>,
      < -5.809381, -1.454192, 2.953298>
    }
    triangle {
      < -5.836937, -1.536736, 2.893245>,
      < -5.809381, -1.454192, 2.953298>,
      < -5.853824, -1.549571, 2.935682>
    }
    triangle {
      < -5.790800, -1.441357, 2.910861>,
      < -5.721012, -1.242835, 2.941581>,
      < -5.742157, -1.255670, 2.984018>
    }
    triangle {
      < -5.790800, -1.441357, 2.910861>,
      < -5.742157, -1.255670, 2.984018>,
      < -5.809381, -1.454192, 2.953298>
    }
    triangle {
      < -5.721012, -1.242835, 2.941581>,
      < -5.653183, -1.164744, 2.940736>,
      < -5.676820, -1.177579, 2.983173>
    }
    triangle {
      < -5.721012, -1.242835, 2.941581>,
      < -5.676820, -1.177579, 2.983173>,
      < -5.742157, -1.255670, 2.984018>
    }
    triangle {
      < -5.653183, -1.164744, 2.940736>,
      < -5.624572, -1.107859, 2.939728>,
      < -5.646147, -1.119743, 2.978052>
    }
    triangle {
      < -5.653183, -1.164744, 2.940736>,
      < -5.646147, -1.119743, 2.978052>,
      < -5.676820, -1.177579, 2.983173>
    }
    triangle {
      < -5.720068, -1.044287, 2.980925>,
      < -5.685392, -1.083939, 3.010567>,
      < -5.656684, -1.083012, 2.978059>
    }
    triangle {
      < -5.698081, -1.031452, 2.938488>,
      < -5.775725, -1.007452, 2.944038>,
      < -5.794860, -1.020287, 2.986475>
    }
    triangle {
      < -5.698081, -1.031452, 2.938488>,
      < -5.794860, -1.020287, 2.986475>,
      < -5.720068, -1.044287, 2.980925>
    }
    triangle {
      < -5.775725, -1.007452, 2.944038>,
      < -5.962842, -0.996574, 2.947385>,
      < -5.975104, -1.009408, 2.989822>
    }
    triangle {
      < -5.775725, -1.007452, 2.944038>,
      < -5.975104, -1.009408, 2.989822>,
      < -5.794860, -1.020287, 2.986475>
    }
    triangle {
      < -5.962842, -0.996574, 2.947385>,
      < -6.476254, -0.982347, 2.920296>,
      < -6.488513, -0.995182, 2.962733>
    }
    triangle {
      < -5.962842, -0.996574, 2.947385>,
      < -6.488513, -0.995182, 2.962733>,
      < -5.975104, -1.009408, 2.989822>
    }
    triangle {
      < -6.476254, -0.982347, 2.920296>,
      < -6.688638, -0.976656, 2.895943>,
      < -6.700897, -0.989491, 2.938380>
    }
    triangle {
      < -6.476254, -0.982347, 2.920296>,
      < -6.700897, -0.989491, 2.938380>,
      < -6.488513, -0.995182, 2.962733>
    }
    triangle {
      < -6.688638, -0.976656, 2.895943>,
      < -6.756642, -0.976652, 2.871945>,
      < -6.782897, -0.989486, 2.914382>
    }
    triangle {
      < -6.688638, -0.976656, 2.895943>,
      < -6.782897, -0.989486, 2.914382>,
      < -6.700897, -0.989491, 2.938380>
    }
    triangle {
      < -6.756642, -0.976652, 2.871945>,
      < -6.805195, -0.976648, 2.826151>,
      < -6.841444, -0.989483, 2.868588>
    }
    triangle {
      < -6.756642, -0.976652, 2.871945>,
      < -6.841444, -0.989483, 2.868588>,
      < -6.782897, -0.989486, 2.914382>
    }
    triangle {
      < -6.805195, -0.976648, 2.826151>,
      < -6.850533, -0.979485, 2.765028>,
      < -6.896116, -0.992319, 2.807465>
    }
    triangle {
      < -6.805195, -0.976648, 2.826151>,
      < -6.896116, -0.992319, 2.807465>,
      < -6.841444, -0.989483, 2.868588>
    }
    triangle {
      < -5.633726, -1.072891, 2.939160>,
      < -5.698081, -1.031452, 2.938488>,
      < -5.720068, -1.044287, 2.980925>
    }
    triangle {
      < -5.633726, -1.072891, 2.939160>,
      < -5.720068, -1.044287, 2.980925>,
      < -5.656684, -1.083012, 2.978059>
    }
    triangle {
      < -6.686976, -1.859547, 2.586358>,
      < -6.713930, -1.859547, 2.511016>,
      < -6.674716, -1.846712, 2.543921>
    }
    triangle {
      < -6.849995, -0.979308, 2.480608>,
      < -6.809928, -0.996376, 2.297940>,
      < -6.925117, -1.015730, 2.338184>
    }
    triangle {
      < -6.849995, -0.979308, 2.480608>,
      < -6.925117, -1.015730, 2.338184>,
      < -6.934447, -0.995402, 2.521949>
    }
    triangle {
      < -5.646147, -1.119743, 2.978052>,
      < -5.682071, -1.120353, 3.016435>,
      < -5.676820, -1.177579, 2.983173>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.850533, -0.979485, 2.765028>,
      < -6.805195, -0.976648, 2.826151>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.805195, -0.976648, 2.826151>,
      < -6.756642, -0.976652, 2.871945>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.756642, -0.976652, 2.871945>,
      < -6.688638, -0.976656, 2.895943>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.688638, -0.976656, 2.895943>,
      < -6.476254, -0.982347, 2.920296>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.476254, -0.982347, 2.920296>,
      < -5.962842, -0.996574, 2.947385>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.962842, -0.996574, 2.947385>,
      < -5.775725, -1.007452, 2.944038>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.775725, -1.007452, 2.944038>,
      < -5.698081, -1.031452, 2.938488>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.698081, -1.031452, 2.938488>,
      < -5.633726, -1.072891, 2.939160>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.633726, -1.072891, 2.939160>,
      < -5.624572, -1.107859, 2.939728>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.624572, -1.107859, 2.939728>,
      < -5.653183, -1.164744, 2.940736>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.653183, -1.164744, 2.940736>,
      < -5.721012, -1.242835, 2.941581>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.721012, -1.242835, 2.941581>,
      < -5.790800, -1.441357, 2.910861>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.790800, -1.441357, 2.910861>,
      < -5.836937, -1.536736, 2.893245>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.836937, -1.536736, 2.893245>,
      < -5.893969, -1.645792, 2.845779>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.893969, -1.645792, 2.845779>,
      < -5.959691, -1.748931, 2.783729>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -5.959691, -1.748931, 2.783729>,
      < -6.002273, -1.805053, 2.739253>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.002273, -1.805053, 2.739253>,
      < -6.064945, -1.846712, 2.703966>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.064945, -1.846712, 2.703966>,
      < -6.358714, -1.846712, 2.680916>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.358714, -1.846712, 2.680916>,
      < -6.491687, -1.846712, 2.645658>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.491687, -1.846712, 2.645658>,
      < -6.584070, -1.846712, 2.601764>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.584070, -1.846712, 2.601764>,
      < -6.674716, -1.846712, 2.543921>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.674716, -1.846712, 2.543921>,
      < -6.713930, -1.859547, 2.511016>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.713930, -1.859547, 2.511016>,
      < -6.791463, -1.859547, 2.349217>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.791463, -1.859547, 2.349217>,
      < -6.824117, -1.859547, 2.163813>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.824117, -1.859547, 2.163813>,
      < -6.854515, -1.859547, 1.965427>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.854515, -1.859547, 1.965427>,
      < -6.884914, -1.859547, 1.767040>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.884914, -1.859547, 1.767040>,
      < -7.057447, -1.859547, 0.000000>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -7.057447, -1.859547, 0.000000>,
      < -6.962760, -1.324139, 0.000000>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.962760, -1.324139, 0.000000>,
      < -6.767396, -1.329456, 1.724040>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.767396, -1.329456, 1.724040>,
      < -6.746067, -1.318434, 1.846585>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.746067, -1.318434, 1.846585>,
      < -6.739871, -1.284465, 1.951116>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.739871, -1.284465, 1.951116>,
      < -6.748319, -1.231666, 2.049427>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.748319, -1.231666, 2.049427>,
      < -6.769863, -1.171843, 2.115272>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.769863, -1.171843, 2.115272>,
      < -6.809928, -0.996376, 2.297940>
    }
    triangle {
      < -6.890060, -0.976641, 2.663275>,
      < -6.809928, -0.996376, 2.297940>,
      < -6.849995, -0.979308, 2.480608>
    }
    triangle {
      < -7.086562, -1.251685, 2.454475>,
      < -7.072962, -1.169511, 2.602265>,
      < -7.092591, -1.120285, 2.570540>
    }
    triangle {
      < -7.086562, -1.251685, 2.454475>,
      < -7.092591, -1.120285, 2.570540>,
      < -7.097256, -1.200142, 2.440864>
    }
    triangle {
      < -6.995774, -1.060152, 2.360948>,
      < -6.999403, -1.015503, 2.533619>,
      < -6.934447, -0.995402, 2.521949>
    }
    triangle {
      < -6.995774, -1.060152, 2.360948>,
      < -6.934447, -0.995402, 2.521949>,
      < -6.925117, -1.015730, 2.338184>
    }
    triangle {
      < -6.943775, -0.989475, 2.705712>,
      < -6.890060, -0.976641, 2.663275>,
      < -6.849995, -0.979308, 2.480608>
    }
    triangle {
      < -6.943775, -0.989475, 2.705712>,
      < -6.849995, -0.979308, 2.480608>,
      < -6.934447, -0.995402, 2.521949>
    }
    triangle {
      < -6.943775, -0.989475, 2.705712>,
      < -6.934447, -0.995402, 2.521949>,
      < -6.999403, -1.015503, 2.533619>
    }
    triangle {
      < -6.943775, -0.989475, 2.705712>,
      < -6.999403, -1.015503, 2.533619>,
      < -7.003592, -1.010780, 2.706787>
    }
    triangle {
      < -7.088174, -1.119861, 2.700568>,
      < -7.092591, -1.120285, 2.570540>,
      < -7.072962, -1.169511, 2.602265>
    }
    triangle {
      < -7.088174, -1.119861, 2.700568>,
      < -7.072962, -1.169511, 2.602265>,
      < -7.069232, -1.171446, 2.694571>
    }
    triangle {
      < -7.097256, -1.200142, 2.440864>,
      < -7.101055, -1.325408, 2.314543>,
      < -7.089150, -1.340504, 2.363926>
    }
    triangle {
      < -7.097256, -1.200142, 2.440864>,
      < -7.089150, -1.340504, 2.363926>,
      < -7.086562, -1.251685, 2.454475>
    }
    triangle {
      < -6.925117, -1.015730, 2.338184>,
      < -6.915789, -1.194457, 2.154421>,
      < -6.990645, -1.226394, 2.190381>
    }
    triangle {
      < -6.925117, -1.015730, 2.338184>,
      < -6.990645, -1.226394, 2.190381>,
      < -6.995774, -1.060152, 2.360948>
    }
    triangle {
      < -6.769863, -1.171843, 2.115272>,
      < -6.807567, -1.164466, 2.123392>,
      < -6.915789, -1.194457, 2.154421>
    }
    triangle {
      < -6.769863, -1.171843, 2.115272>,
      < -6.915789, -1.194457, 2.154421>,
      < -6.925117, -1.015730, 2.338184>
    }
    triangle {
      < -6.769863, -1.171843, 2.115272>,
      < -6.925117, -1.015730, 2.338184>,
      < -6.809928, -0.996376, 2.297940>
    }
    triangle {
      < -6.500500, -1.083424, 3.057768>,
      < -5.994500, -1.085873, 3.065178>,
      < -5.987155, -1.057072, 3.055558>
    }
    triangle {
      < -6.500500, -1.083424, 3.057768>,
      < -5.987155, -1.057072, 3.055558>,
      < -6.497888, -1.051763, 3.041027>
    }
    triangle {
      < -6.722644, -1.082780, 3.038282>,
      < -6.500500, -1.083424, 3.057768>,
      < -6.497888, -1.051763, 3.041027>
    }
    triangle {
      < -6.722644, -1.082780, 3.038282>,
      < -6.497888, -1.051763, 3.041027>,
      < -6.718443, -1.049612, 3.020045>
    }
    triangle {
      < -6.834136, -1.082776, 3.006559>,
      < -6.722644, -1.082780, 3.038282>,
      < -6.718443, -1.049612, 3.020045>
    }
    triangle {
      < -6.834136, -1.082776, 3.006559>,
      < -6.718443, -1.049612, 3.020045>,
      < -6.824194, -1.049274, 2.989464>
    }
    triangle {
      < -6.922107, -1.082584, 2.948084>,
      < -6.834136, -1.082776, 3.006559>,
      < -6.824194, -1.049274, 2.989464>
    }
    triangle {
      < -6.922107, -1.082584, 2.948084>,
      < -6.824194, -1.049274, 2.989464>,
      < -6.906083, -1.048785, 2.932867>
    }
    triangle {
      < -7.001381, -1.082450, 2.873451>,
      < -6.922107, -1.082584, 2.948084>,
      < -6.906083, -1.048785, 2.932867>
    }
    triangle {
      < -7.001381, -1.082450, 2.873451>,
      < -6.906083, -1.048785, 2.932867>,
      < -6.979820, -1.049169, 2.860212>
    }
    triangle {
      < -7.081670, -1.081432, 2.703891>,
      < -7.001381, -1.082450, 2.873451>,
      < -6.979820, -1.049169, 2.860212>
    }
    triangle {
      < -7.081670, -1.081432, 2.703891>,
      < -6.979820, -1.049169, 2.860212>,
      < -7.052166, -1.047451, 2.705376>
    }
    triangle {
      < -7.084155, -1.082392, 2.558994>,
      < -7.081670, -1.081432, 2.703891>,
      < -7.052166, -1.047451, 2.705376>
    }
    triangle {
      < -7.084155, -1.082392, 2.558994>,
      < -7.052166, -1.047451, 2.705376>,
      < -7.052245, -1.050272, 2.547867>
    }
    triangle {
      < -7.090330, -1.166159, 2.418246>,
      < -7.084155, -1.082392, 2.558994>,
      < -7.052245, -1.050272, 2.547867>
    }
    triangle {
      < -7.090330, -1.166159, 2.418246>,
      < -7.052245, -1.050272, 2.547867>,
      < -7.052882, -1.116151, 2.390855>
    }
    triangle {
      < -7.092793, -1.305835, 2.277045>,
      < -7.090330, -1.166159, 2.418246>,
      < -7.052882, -1.116151, 2.390855>
    }
    triangle {
      < -7.092793, -1.305835, 2.277045>,
      < -7.052882, -1.116151, 2.390855>,
      < -7.052018, -1.268057, 2.235946>
    }
    triangle {
      < -7.084328, -1.386593, 2.168316>,
      < -7.092793, -1.305835, 2.277045>,
      < -7.052018, -1.268057, 2.235946>
    }
    triangle {
      < -7.084328, -1.386593, 2.168316>,
      < -7.052018, -1.268057, 2.235946>,
      < -7.040924, -1.344459, 2.136715>
    }
    triangle {
      < -7.078613, -1.452749, 2.036877>,
      < -7.084328, -1.386593, 2.168316>,
      < -7.040924, -1.344459, 2.136715>
    }
    triangle {
      < -7.078613, -1.452749, 2.036877>,
      < -7.040924, -1.344459, 2.136715>,
      < -7.032433, -1.405797, 2.015038>
    }
    triangle {
      < -7.086372, -1.490089, 1.910542>,
      < -7.078613, -1.452749, 2.036877>,
      < -7.032433, -1.405797, 2.015038>
    }
    triangle {
      < -7.086372, -1.490089, 1.910542>,
      < -7.032433, -1.405797, 2.015038>,
      < -7.043485, -1.441088, 1.897489>
    }
    triangle {
      < -7.099501, -1.495746, 1.765560>,
      < -7.086372, -1.490089, 1.910542>,
      < -7.043485, -1.441088, 1.897489>
    }
    triangle {
      < -7.099501, -1.495746, 1.765560>,
      < -7.043485, -1.441088, 1.897489>,
      < -7.060020, -1.447926, 1.759758>
    }
    triangle {
      < -7.279100, -1.500665, 0.000000>,
      < -7.099501, -1.495746, 1.765560>,
      < -7.060020, -1.447926, 1.759758>
    }
    triangle {
      < -7.279100, -1.500665, 0.000000>,
      < -7.060020, -1.447926, 1.759758>,
      < -7.233485, -1.452667, 0.000000>
    }
    triangle {
      < -5.994500, -1.085873, 3.065178>,
      < -5.796717, -1.080906, 3.038786>,
      < -5.987155, -1.057072, 3.055558>
    }
    triangle {
      < -6.497888, -1.051763, 3.041027>,
      < -5.987155, -1.057072, 3.055558>,
      < -5.980691, -1.027046, 3.030011>
    }
    triangle {
      < -6.497888, -1.051763, 3.041027>,
      < -5.980691, -1.027046, 3.030011>,
      < -6.493579, -1.016994, 3.008955>
    }
    triangle {
      < -6.718443, -1.049612, 3.020045>,
      < -6.497888, -1.051763, 3.041027>,
      < -6.493579, -1.016994, 3.008955>
    }
    triangle {
      < -6.718443, -1.049612, 3.020045>,
      < -6.493579, -1.016994, 3.008955>,
      < -6.710935, -1.012946, 2.986064>
    }
    triangle {
      < -6.824194, -1.049274, 2.989464>,
      < -6.718443, -1.049612, 3.020045>,
      < -6.710935, -1.012946, 2.986064>
    }
    triangle {
      < -6.824194, -1.049274, 2.989464>,
      < -6.710935, -1.012946, 2.986064>,
      < -6.806467, -1.012607, 2.958068>
    }
    triangle {
      < -6.906083, -1.048785, 2.932867>,
      < -6.824194, -1.049274, 2.989464>,
      < -6.806467, -1.012607, 2.958068>
    }
    triangle {
      < -6.906083, -1.048785, 2.932867>,
      < -6.806467, -1.012607, 2.958068>,
      < -6.878011, -1.012117, 2.905717>
    }
    triangle {
      < -6.979820, -1.049169, 2.860212>,
      < -6.906083, -1.048785, 2.932867>,
      < -6.878011, -1.012117, 2.905717>
    }
    triangle {
      < -6.979820, -1.049169, 2.860212>,
      < -6.878011, -1.012117, 2.905717>,
      < -6.943068, -1.013447, 2.837431>
    }
    triangle {
      < -7.052166, -1.047451, 2.705376>,
      < -6.979820, -1.049169, 2.860212>,
      < -6.943068, -1.013447, 2.837431>
    }
    triangle {
      < -7.052166, -1.047451, 2.705376>,
      < -6.943068, -1.013447, 2.837431>,
      < -7.003592, -1.010780, 2.706787>
    }
    triangle {
      < -7.052245, -1.050272, 2.547867>,
      < -7.052166, -1.047451, 2.705376>,
      < -7.003592, -1.010780, 2.706787>
    }
    triangle {
      < -7.052245, -1.050272, 2.547867>,
      < -7.003592, -1.010780, 2.706787>,
      < -6.999403, -1.015503, 2.533619>
    }
    triangle {
      < -7.052882, -1.116151, 2.390855>,
      < -7.052245, -1.050272, 2.547867>,
      < -6.999403, -1.015503, 2.533619>
    }
    triangle {
      < -7.052882, -1.116151, 2.390855>,
      < -6.999403, -1.015503, 2.533619>,
      < -6.995774, -1.060152, 2.360948>
    }
    triangle {
      < -7.052018, -1.268057, 2.235946>,
      < -7.052882, -1.116151, 2.390855>,
      < -6.995774, -1.060152, 2.360948>
    }
    triangle {
      < -7.052018, -1.268057, 2.235946>,
      < -6.995774, -1.060152, 2.360948>,
      < -6.990645, -1.226394, 2.190381>
    }
    triangle {
      < -7.040924, -1.344459, 2.136715>,
      < -7.052018, -1.268057, 2.235946>,
      < -6.990645, -1.226394, 2.190381>
    }
    triangle {
      < -7.040924, -1.344459, 2.136715>,
      < -6.990645, -1.226394, 2.190381>,
      < -6.976470, -1.298631, 2.102237>
    }
    triangle {
      < -7.032433, -1.405797, 2.015038>,
      < -7.040924, -1.344459, 2.136715>,
      < -6.976470, -1.298631, 2.102237>
    }
    triangle {
      < -7.032433, -1.405797, 2.015038>,
      < -6.976470, -1.298631, 2.102237>,
      < -6.964900, -1.355802, 1.990809>
    }
    triangle {
      < -7.043485, -1.441088, 1.897489>,
      < -7.032433, -1.405797, 2.015038>,
      < -6.964900, -1.355802, 1.990809>
    }
    triangle {
      < -7.043485, -1.441088, 1.897489>,
      < -6.964900, -1.355802, 1.990809>,
      < -6.979893, -1.388660, 1.881194>
    }
    triangle {
      < -7.060020, -1.447926, 1.759758>,
      < -7.043485, -1.441088, 1.897489>,
      < -6.979893, -1.388660, 1.881194>
    }
    triangle {
      < -7.060020, -1.447926, 1.759758>,
      < -6.979893, -1.388660, 1.881194>,
      < -7.000368, -1.396264, 1.751397>
    }
    triangle {
      < -7.233485, -1.452667, 0.000000>,
      < -7.060020, -1.447926, 1.759758>,
      < -7.000368, -1.396264, 1.751397>
    }
    triangle {
      < -7.233485, -1.452667, 0.000000>,
      < -7.000368, -1.396264, 1.751397>,
      < -7.166669, -1.402146, 0.000000>
    }
    triangle {
      < -5.945208, -1.284483, 2.987595>,
      < -5.820180, -1.284486, 2.983333>,
      < -5.742157, -1.255670, 2.984018>
    }
    triangle {
      < -5.945208, -1.284483, 2.987595>,
      < -5.742157, -1.255670, 2.984018>,
      < -5.960658, -1.230247, 3.031562>
    }
    triangle {
      < -6.453266, -1.284490, 2.965122>,
      < -5.945208, -1.284483, 2.987595>,
      < -5.960658, -1.230247, 3.031562>
    }
    triangle {
      < -6.453266, -1.284490, 2.965122>,
      < -5.960658, -1.230247, 3.031562>,
      < -6.470497, -1.231665, 3.013400>
    }
    triangle {
      < -6.666018, -1.284488, 2.935784>,
      < -6.453266, -1.284490, 2.965122>,
      < -6.470497, -1.231665, 3.013400>
    }
    triangle {
      < -6.666018, -1.284488, 2.935784>,
      < -6.470497, -1.231665, 3.013400>,
      < -6.688596, -1.232883, 2.986616>
    }
    triangle {
      < -6.764087, -1.284490, 2.897935>,
      < -6.666018, -1.284488, 2.935784>,
      < -6.688596, -1.232883, 2.986616>
    }
    triangle {
      < -6.764087, -1.284490, 2.897935>,
      < -6.688596, -1.232883, 2.986616>,
      < -6.795163, -1.233915, 2.948795>
    }
    triangle {
      < -6.838706, -1.284492, 2.838292>,
      < -6.764087, -1.284490, 2.897935>,
      < -6.795163, -1.233915, 2.948795>
    }
    triangle {
      < -6.838706, -1.284492, 2.838292>,
      < -6.795163, -1.233915, 2.948795>,
      < -6.877378, -1.234364, 2.887440>
    }
    triangle {
      < -6.919416, -1.284488, 2.764061>,
      < -6.838706, -1.284492, 2.838292>,
      < -6.877378, -1.234364, 2.887440>
    }
    triangle {
      < -6.919416, -1.284488, 2.764061>,
      < -6.877378, -1.234364, 2.887440>,
      < -6.960782, -1.233981, 2.810840>
    }
    triangle {
      < -6.981668, -1.284483, 2.668404>,
      < -6.919416, -1.284488, 2.764061>,
      < -6.960782, -1.233981, 2.810840>
    }
    triangle {
      < -6.981668, -1.284483, 2.668404>,
      < -6.960782, -1.233981, 2.810840>,
      < -7.033287, -1.233111, 2.683546>
    }
    triangle {
      < -6.981668, -1.284483, 2.668404>,
      < -7.033287, -1.233111, 2.683546>,
      < -7.035861, -1.231102, 2.636836>
    }
    triangle {
      < -7.014936, -1.369458, 2.490375>,
      < -6.981668, -1.284483, 2.668404>,
      < -7.035861, -1.231102, 2.636836>
    }
    triangle {
      < -7.014936, -1.369458, 2.490375>,
      < -7.035861, -1.231102, 2.636836>,
      < -7.059394, -1.313596, 2.475299>
    }
    triangle {
      < -7.014936, -1.369458, 2.490375>,
      < -7.059394, -1.313596, 2.475299>,
      < -7.060826, -1.357175, 2.430345>
    }
    triangle {
      < -7.022886, -1.409456, 2.450853>,
      < -7.014936, -1.369458, 2.490375>,
      < -7.060826, -1.357175, 2.430345>
    }
    triangle {
      < -7.022886, -1.409456, 2.450853>,
      < -7.060826, -1.357175, 2.430345>,
      < -7.066261, -1.384395, 2.403169>
    }
    triangle {
      < -7.005176, -1.550954, 2.317360>,
      < -7.022886, -1.409456, 2.450853>,
      < -7.066261, -1.384395, 2.403169>
    }
    triangle {
      < -7.005176, -1.550954, 2.317360>,
      < -7.066261, -1.384395, 2.403169>,
      < -7.051721, -1.508370, 2.275134>
    }
    triangle {
      < -6.989864, -1.644451, 2.150267>,
      < -7.005176, -1.550954, 2.317360>,
      < -7.051721, -1.508370, 2.275134>
    }
    triangle {
      < -6.989864, -1.644451, 2.150267>,
      < -7.051721, -1.508370, 2.275134>,
      < -7.039617, -1.594165, 2.117850>
    }
    triangle {
      < -6.987468, -1.698019, 1.965227>,
      < -6.989864, -1.644451, 2.150267>,
      < -7.039617, -1.594165, 2.117850>
    }
    triangle {
      < -6.987468, -1.698019, 1.965227>,
      < -7.039617, -1.594165, 2.117850>,
      < -7.040084, -1.643732, 1.950409>
    }
    triangle {
      < -6.990606, -1.709441, 1.762173>,
      < -6.987468, -1.698019, 1.965227>,
      < -7.040084, -1.643732, 1.950409>
    }
    triangle {
      < -6.990606, -1.709441, 1.762173>,
      < -7.040084, -1.643732, 1.950409>,
      < -7.045925, -1.654414, 1.765231>
    }
    triangle {
      < -7.156614, -1.707875, 0.000000>,
      < -6.990606, -1.709441, 1.762173>,
      < -7.045925, -1.654414, 1.765231>
    }
    triangle {
      < -7.156614, -1.707875, 0.000000>,
      < -7.045925, -1.654414, 1.765231>,
      < -7.216501, -1.655390, 0.000000>
    }
    triangle {
      < -5.977087, -1.168581, 3.057851>,
      < -5.960658, -1.230247, 3.031562>,
      < -5.742157, -1.255670, 2.984018>
    }
    triangle {
      < -5.977087, -1.168581, 3.057851>,
      < -5.742157, -1.255670, 2.984018>,
      < -5.776556, -1.177829, 3.017266>
    }
    triangle {
      < -6.470497, -1.231665, 3.013400>,
      < -5.960658, -1.230247, 3.031562>,
      < -5.977087, -1.168581, 3.057851>
    }
    triangle {
      < -6.470497, -1.231665, 3.013400>,
      < -5.977087, -1.168581, 3.057851>,
      < -6.486555, -1.169997, 3.044676>
    }
    triangle {
      < -6.688596, -1.232883, 2.986616>,
      < -6.470497, -1.231665, 3.013400>,
      < -6.486555, -1.169997, 3.044676>
    }
    triangle {
      < -6.688596, -1.232883, 2.986616>,
      < -6.486555, -1.169997, 3.044676>,
      < -6.707731, -1.171216, 3.021462>
    }
    triangle {
      < -6.795163, -1.233915, 2.948795>,
      < -6.688596, -1.232883, 2.986616>,
      < -6.707731, -1.171216, 3.021462>
    }
    triangle {
      < -6.795163, -1.233915, 2.948795>,
      < -6.707731, -1.171216, 3.021462>,
      < -6.819161, -1.172247, 2.985674>
    }
    triangle {
      < -6.877378, -1.234364, 2.887440>,
      < -6.795163, -1.233915, 2.948795>,
      < -6.819161, -1.172247, 2.985674>
    }
    triangle {
      < -6.877378, -1.234364, 2.887440>,
      < -6.819161, -1.172247, 2.985674>,
      < -6.906362, -1.172695, 2.924689>
    }
    triangle {
      < -6.960782, -1.233981, 2.810840>,
      < -6.877378, -1.234364, 2.887440>,
      < -6.906362, -1.172695, 2.924689>
    }
    triangle {
      < -6.960782, -1.233981, 2.810840>,
      < -6.906362, -1.172695, 2.924689>,
      < -6.989767, -1.172314, 2.848089>
    }
    triangle {
      < -7.033287, -1.233111, 2.683546>,
      < -6.960782, -1.233981, 2.810840>,
      < -6.989767, -1.172314, 2.848089>
    }
    triangle {
      < -7.033287, -1.233111, 2.683546>,
      < -6.989767, -1.172314, 2.848089>,
      < -7.069232, -1.171446, 2.694571>
    }
    triangle {
      < -7.035861, -1.231102, 2.636836>,
      < -7.033287, -1.233111, 2.683546>,
      < -7.069232, -1.171446, 2.694571>
    }
    triangle {
      < -7.035861, -1.231102, 2.636836>,
      < -7.069232, -1.171446, 2.694571>,
      < -7.072962, -1.169511, 2.602265>
    }
    triangle {
      < -7.059394, -1.313596, 2.475299>,
      < -7.035861, -1.231102, 2.636836>,
      < -7.072962, -1.169511, 2.602265>
    }
    triangle {
      < -7.059394, -1.313596, 2.475299>,
      < -7.072962, -1.169511, 2.602265>,
      < -7.086562, -1.251685, 2.454475>
    }
    triangle {
      < -7.060826, -1.357175, 2.430345>,
      < -7.059394, -1.313596, 2.475299>,
      < -7.086562, -1.251685, 2.454475>
    }
    triangle {
      < -7.060826, -1.357175, 2.430345>,
      < -7.086562, -1.251685, 2.454475>,
      < -7.089150, -1.340504, 2.363926>
    }
    triangle {
      < -7.066261, -1.384395, 2.403169>,
      < -7.060826, -1.357175, 2.430345>,
      < -7.089150, -1.340504, 2.363926>
    }
    triangle {
      < -7.066261, -1.384395, 2.403169>,
      < -7.089150, -1.340504, 2.363926>,
      < -7.091934, -1.354392, 2.349924>
    }
    triangle {
      < -7.051721, -1.508370, 2.275134>,
      < -7.066261, -1.384395, 2.403169>,
      < -7.091934, -1.354392, 2.349924>
    }
    triangle {
      < -7.051721, -1.508370, 2.275134>,
      < -7.091934, -1.354392, 2.349924>,
      < -7.080834, -1.458599, 2.229285>
    }
    triangle {
      < -7.039617, -1.594165, 2.117850>,
      < -7.051721, -1.508370, 2.275134>,
      < -7.080834, -1.458599, 2.229285>
    }
    triangle {
      < -7.039617, -1.594165, 2.117850>,
      < -7.080834, -1.458599, 2.229285>,
      < -7.072170, -1.535828, 2.082598>
    }
    triangle {
      < -7.040084, -1.643732, 1.950409>,
      < -7.039617, -1.594165, 2.117850>,
      < -7.072170, -1.535828, 2.082598>
    }
    triangle {
      < -7.040084, -1.643732, 1.950409>,
      < -7.072170, -1.535828, 2.082598>,
      < -7.075849, -1.580462, 1.933608>
    }
    triangle {
      < -7.045925, -1.654414, 1.765231>,
      < -7.040084, -1.643732, 1.950409>,
      < -7.075849, -1.580462, 1.933608>
    }
    triangle {
      < -7.045925, -1.654414, 1.765231>,
      < -7.075849, -1.580462, 1.933608>,
      < -7.084901, -1.589411, 1.766879>
    }
    triangle {
      < -7.216501, -1.655390, 0.000000>,
      < -7.045925, -1.654414, 1.765231>,
      < -7.084901, -1.589411, 1.766879>
    }
    triangle {
      < -7.216501, -1.655390, 0.000000>,
      < -7.084901, -1.589411, 1.766879>,
      < -7.260464, -1.592207, 0.000000>
    }
    triangle {
      < -5.720068, -1.044287, 2.980925>,
      < -5.794860, -1.020287, 2.986475>,
      < -5.791178, -1.031257, 3.006389>
    }
    triangle {
      < -5.685392, -1.083939, 3.010567>,
      < -5.720068, -1.044287, 2.980925>,
      < -5.791178, -1.031257, 3.006389>
    }
    triangle {
      < -5.685392, -1.083939, 3.010567>,
      < -5.791178, -1.031257, 3.006389>,
      < -5.796717, -1.080906, 3.038786>
    }
    triangle {
      < -7.097250, -1.331093, 2.310717>,
      < -7.101055, -1.325408, 2.314543>,
      < -7.092793, -1.305835, 2.277045>
    }
    triangle {
      < -5.633726, -1.072891, 2.939160>,
      < -5.656684, -1.083012, 2.978059>,
      < -5.646147, -1.119743, 2.978052>
    }
    triangle {
      < -5.633726, -1.072891, 2.939160>,
      < -5.646147, -1.119743, 2.978052>,
      < -5.624572, -1.107859, 2.939728>
    }
    triangle {
      < -5.656684, -1.083012, 2.978059>,
      < -5.685392, -1.083939, 3.010567>,
      < -5.682071, -1.120353, 3.016435>
    }
    triangle {
      < -5.656684, -1.083012, 2.978059>,
      < -5.682071, -1.120353, 3.016435>,
      < -5.646147, -1.119743, 2.978052>
    }
    triangle {
      < -5.795750, -1.119792, 3.044409>,
      < -5.682071, -1.120353, 3.016435>,
      < -5.685392, -1.083939, 3.010567>
    }
    triangle {
      < -5.795750, -1.119792, 3.044409>,
      < -5.685392, -1.083939, 3.010567>,
      < -5.796717, -1.080906, 3.038786>
    }
    triangle {
      < -5.994472, -1.120564, 3.065847>,
      < -5.795750, -1.119792, 3.044409>,
      < -5.796717, -1.080906, 3.038786>
    }
    triangle {
      < -5.994472, -1.120564, 3.065847>,
      < -5.796717, -1.080906, 3.038786>,
      < -5.994500, -1.085873, 3.065178>
    }
    triangle {
      < -6.497226, -1.120446, 3.059467>,
      < -5.994472, -1.120564, 3.065847>,
      < -5.994500, -1.085873, 3.065178>
    }
    triangle {
      < -6.497226, -1.120446, 3.059467>,
      < -5.994500, -1.085873, 3.065178>,
      < -6.500500, -1.083424, 3.057768>
    }
    triangle {
      < -6.719749, -1.120220, 3.039568>,
      < -6.497226, -1.120446, 3.059467>,
      < -6.500500, -1.083424, 3.057768>
    }
    triangle {
      < -6.719749, -1.120220, 3.039568>,
      < -6.500500, -1.083424, 3.057768>,
      < -6.722644, -1.082780, 3.038282>
    }
    triangle {
      < -6.833333, -1.119999, 3.006480>,
      < -6.719749, -1.120220, 3.039568>,
      < -6.722644, -1.082780, 3.038282>
    }
    triangle {
      < -6.833333, -1.119999, 3.006480>,
      < -6.722644, -1.082780, 3.038282>,
      < -6.834136, -1.082776, 3.006559>
    }
    triangle {
      < -6.923314, -1.119656, 2.946822>,
      < -6.833333, -1.119999, 3.006480>,
      < -6.834136, -1.082776, 3.006559>
    }
    triangle {
      < -6.923314, -1.119656, 2.946822>,
      < -6.834136, -1.082776, 3.006559>,
      < -6.922107, -1.082584, 2.948084>
    }
    triangle {
      < -7.005646, -1.119330, 2.870995>,
      < -6.923314, -1.119656, 2.946822>,
      < -6.922107, -1.082584, 2.948084>
    }
    triangle {
      < -7.005646, -1.119330, 2.870995>,
      < -6.922107, -1.082584, 2.948084>,
      < -7.001381, -1.082450, 2.873451>
    }
    triangle {
      < -7.088174, -1.119861, 2.700568>,
      < -7.005646, -1.119330, 2.870995>,
      < -7.001381, -1.082450, 2.873451>
    }
    triangle {
      < -7.088174, -1.119861, 2.700568>,
      < -7.001381, -1.082450, 2.873451>,
      < -7.081670, -1.081432, 2.703891>
    }
    triangle {
      < -7.092591, -1.120285, 2.570540>,
      < -7.088174, -1.119861, 2.700568>,
      < -7.081670, -1.081432, 2.703891>
    }
    triangle {
      < -7.092591, -1.120285, 2.570540>,
      < -7.081670, -1.081432, 2.703891>,
      < -7.084155, -1.082392, 2.558994>
    }
    triangle {
      < -7.097256, -1.200142, 2.440864>,
      < -7.092591, -1.120285, 2.570540>,
      < -7.084155, -1.082392, 2.558994>
    }
    triangle {
      < -7.097256, -1.200142, 2.440864>,
      < -7.084155, -1.082392, 2.558994>,
      < -7.090330, -1.166159, 2.418246>
    }
    triangle {
      < -7.101055, -1.325408, 2.314543>,
      < -7.097256, -1.200142, 2.440864>,
      < -7.090330, -1.166159, 2.418246>
    }
    triangle {
      < -7.101055, -1.325408, 2.314543>,
      < -7.090330, -1.166159, 2.418246>,
      < -7.092793, -1.305835, 2.277045>
    }
    triangle {
      < -7.093822, -1.417261, 2.193316>,
      < -7.097250, -1.331093, 2.310717>,
      < -7.092793, -1.305835, 2.277045>
    }
    triangle {
      < -7.093822, -1.417261, 2.193316>,
      < -7.092793, -1.305835, 2.277045>,
      < -7.084328, -1.386593, 2.168316>
    }
    triangle {
      < -7.087876, -1.487158, 2.054882>,
      < -7.093822, -1.417261, 2.193316>,
      < -7.084328, -1.386593, 2.168316>
    }
    triangle {
      < -7.087876, -1.487158, 2.054882>,
      < -7.084328, -1.386593, 2.168316>,
      < -7.078613, -1.452749, 2.036877>
    }
    triangle {
      < -7.078613, -1.452749, 2.036877>,
      < -7.086372, -1.490089, 1.910542>,
      < -7.094053, -1.527854, 1.920331>
    }
    triangle {
      < -7.078613, -1.452749, 2.036877>,
      < -7.094053, -1.527854, 1.920331>,
      < -7.087876, -1.487158, 2.054882>
    }
    triangle {
      < -7.086372, -1.490089, 1.910542>,
      < -7.099501, -1.495746, 1.765560>,
      < -7.105881, -1.534636, 1.767466>
    }
    triangle {
      < -7.086372, -1.490089, 1.910542>,
      < -7.105881, -1.534636, 1.767466>,
      < -7.094053, -1.527854, 1.920331>
    }
    triangle {
      < -7.099501, -1.495746, 1.765560>,
      < -7.279100, -1.500665, 0.000000>,
      < -7.285424, -1.538095, 0.000000>
    }
    triangle {
      < -7.099501, -1.495746, 1.765560>,
      < -7.285424, -1.538095, 0.000000>,
      < -7.105881, -1.534636, 1.767466>
    }
    triangle {
      < -6.990606, -1.709441, 1.762173>,
      < -7.156614, -1.707875, 0.000000>,
      < -7.142025, -1.789917, 0.000000>
    }
    triangle {
      < -6.990606, -1.709441, 1.762173>,
      < -7.142025, -1.789917, 0.000000>,
      < -6.972465, -1.791266, 1.766075>
    }
    triangle {
      < -6.987468, -1.698019, 1.965227>,
      < -6.990606, -1.709441, 1.762173>,
      < -6.972465, -1.791266, 1.766075>
    }
    triangle {
      < -6.987468, -1.698019, 1.965227>,
      < -6.972465, -1.791266, 1.766075>,
      < -6.954820, -1.787191, 1.967162>
    }
    triangle {
      < -6.989864, -1.644451, 2.150267>,
      < -6.987468, -1.698019, 1.965227>,
      < -6.954820, -1.787191, 1.967162>
    }
    triangle {
      < -6.989864, -1.644451, 2.150267>,
      < -6.954820, -1.787191, 1.967162>,
      < -6.940769, -1.760330, 2.159502>
    }
    triangle {
      < -6.931129, -1.659463, 2.403928>,
      < -6.989864, -1.644451, 2.150267>,
      < -6.940769, -1.760330, 2.159502>
    }
    triangle {
      < -6.931129, -1.659463, 2.403928>,
      < -6.940769, -1.760330, 2.159502>,
      < -6.894863, -1.767690, 2.380389>
    }
    triangle {
      < -6.872228, -1.658624, 2.629164>,
      < -6.931129, -1.659463, 2.403928>,
      < -6.894863, -1.767690, 2.380389>
    }
    triangle {
      < -6.872228, -1.658624, 2.629164>,
      < -6.894863, -1.767690, 2.380389>,
      < -6.823873, -1.769634, 2.576504>
    }
    triangle {
      < -6.808095, -1.658623, 2.710665>,
      < -6.872228, -1.658624, 2.629164>,
      < -6.823873, -1.769634, 2.576504>
    }
    triangle {
      < -6.808095, -1.658623, 2.710665>,
      < -6.823873, -1.769634, 2.576504>,
      < -6.756017, -1.770061, 2.657989>
    }
    triangle {
      < -6.714914, -1.658623, 2.773726>,
      < -6.808095, -1.658623, 2.710665>,
      < -6.756017, -1.770061, 2.657989>
    }
    triangle {
      < -6.714914, -1.658623, 2.773726>,
      < -6.756017, -1.770061, 2.657989>,
      < -6.661929, -1.769979, 2.720089>
    }
    triangle {
      < -6.626447, -1.658622, 2.817301>,
      < -6.714914, -1.658623, 2.773726>,
      < -6.661929, -1.769979, 2.720089>
    }
    triangle {
      < -6.626447, -1.658622, 2.817301>,
      < -6.661929, -1.769979, 2.720089>,
      < -6.569460, -1.769633, 2.765059>
    }
    triangle {
      < -6.387282, -1.658624, 2.864736>,
      < -6.626447, -1.658622, 2.817301>,
      < -6.569460, -1.769633, 2.765059>
    }
    triangle {
      < -6.387282, -1.658624, 2.864736>,
      < -6.569460, -1.769633, 2.765059>,
      < -6.381032, -1.768794, 2.807622>
    }
    triangle {
      < -5.908761, -1.658627, 2.888216>,
      < -6.387282, -1.658624, 2.864736>,
      < -6.381032, -1.768794, 2.807622>
    }
    triangle {
      < -5.908761, -1.658627, 2.888216>,
      < -6.381032, -1.768794, 2.807622>,
      < -5.973347, -1.763105, 2.830594>
    }
    triangle {
      < -6.808095, -1.658623, 2.710665>,
      < -6.758198, -1.464489, 2.842342>,
      < -6.830558, -1.467492, 2.783210>
    }
    triangle {
      < -6.872228, -1.658624, 2.629164>,
      < -6.808095, -1.658623, 2.710665>,
      < -6.830558, -1.467492, 2.783210>
    }
    triangle {
      < -6.872228, -1.658624, 2.629164>,
      < -6.830558, -1.467492, 2.783210>,
      < -6.904433, -1.463284, 2.706286>
    }
    triangle {
      < -6.872228, -1.658624, 2.629164>,
      < -6.904433, -1.463284, 2.706286>,
      < -6.939265, -1.460639, 2.654139>
    }
    triangle {
      < -6.931129, -1.659463, 2.403928>,
      < -6.872228, -1.658624, 2.629164>,
      < -6.939265, -1.460639, 2.654139>
    }
    triangle {
      < -6.931129, -1.659463, 2.403928>,
      < -6.939265, -1.460639, 2.654139>,
      < -7.005966, -1.416750, 2.478881>
    }
    triangle {
      < -6.931129, -1.659463, 2.403928>,
      < -7.005966, -1.416750, 2.478881>,
      < -7.022886, -1.409456, 2.450853>
    }
    triangle {
      < -5.893969, -1.645792, 2.845779>,
      < -5.908761, -1.658627, 2.888216>,
      < -5.973347, -1.763105, 2.830594>
    }
    triangle {
      < -5.893969, -1.645792, 2.845779>,
      < -5.973347, -1.763105, 2.830594>,
      < -5.959691, -1.748931, 2.783729>
    }
    triangle {
      < -5.973347, -1.763105, 2.830594>,
      < -6.381032, -1.768794, 2.807622>,
      < -6.370975, -1.859520, 2.723353>
    }
    triangle {
      < -5.973347, -1.763105, 2.830594>,
      < -6.370975, -1.859520, 2.723353>,
      < -6.015004, -1.819897, 2.788333>
    }
    triangle {
      < -5.959691, -1.748931, 2.783729>,
      < -5.973347, -1.763105, 2.830594>,
      < -6.015004, -1.819897, 2.788333>
    }
    triangle {
      < -5.959691, -1.748931, 2.783729>,
      < -6.015004, -1.819897, 2.788333>,
      < -6.002273, -1.805053, 2.739253>
    }
    triangle {
      < -5.791178, -1.031257, 3.006389>,
      < -5.980691, -1.027046, 3.030011>,
      < -5.987155, -1.057072, 3.055558>
    }
    triangle {
      < -5.791178, -1.031257, 3.006389>,
      < -5.987155, -1.057072, 3.055558>,
      < -5.796717, -1.080906, 3.038786>
    }
    triangle {
      < -5.676820, -1.177579, 2.983173>,
      < -5.682071, -1.120353, 3.016435>,
      < -5.795750, -1.119792, 3.044409>
    }
    triangle {
      < -5.676820, -1.177579, 2.983173>,
      < -5.795750, -1.119792, 3.044409>,
      < -5.776556, -1.177829, 3.017266>
    }
    triangle {
      < -5.676820, -1.177579, 2.983173>,
      < -5.776556, -1.177829, 3.017266>,
      < -5.742157, -1.255670, 2.984018>
    }
    triangle {
      < -1.278242, 1.700844, 1.934251>,
      < -1.228930, 1.658054, 2.065620>,
      < -1.326746, 1.641951, 2.066452>
    }
    triangle {
      < -1.278242, 1.700844, 1.934251>,
      < -1.326746, 1.641951, 2.066452>,
      < -1.362498, 1.685040, 1.934339>
    }
    triangle {
      < 1.773786, 0.360172, 2.588591>,
      < 1.780270, 0.339770, 2.680530>,
      < 2.393729, 0.259716, 2.691078>
    }
    triangle {
      < 1.773786, 0.360172, 2.588591>,
      < 2.393729, 0.259716, 2.691078>,
      < 2.385818, 0.275118, 2.594347>
    }
    triangle {
      < -1.146178, 0.546644, 2.545252>,
      < -1.186268, 0.540032, 2.545651>,
      < -1.148572, 0.470027, 2.602251>
    }
    triangle {
      < 9.228248, 0.270685, 2.612574>,
      < 9.182425, 0.260078, 2.585223>,
      < 9.180755, 0.280451, 2.586335>
    }
    triangle {
      < 9.228248, 0.270685, 2.612574>,
      < 9.180755, 0.280451, 2.586335>,
      < 9.222689, 0.314422, 2.613701>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.146178, 0.546644, 2.545252>,
      < -1.165747, 1.355034, 2.403962>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.165747, 1.355034, 2.403962>,
      < -1.203056, 1.340038, 2.383760>
    }
    triangle {
      < -0.900545, 0.471350, 2.584866>,
      < -0.930255, 0.470592, 2.588926>,
      < -0.950543, 0.463118, 2.608058>
    }
    triangle {
      < -0.900545, 0.471350, 2.584866>,
      < -0.950543, 0.463118, 2.608058>,
      < -0.370346, 0.444959, 2.605526>
    }
    triangle {
      < -0.900545, 0.471350, 2.584866>,
      < -0.370346, 0.444959, 2.605526>,
      < -0.378037, 0.453098, 2.588279>
    }
    triangle {
      < -1.937317, 0.490102, 2.388227>,
      < -1.738342, 0.485082, 2.495975>,
      < -1.663497, 0.535625, 2.475946>
    }
    triangle {
      < -1.937317, 0.490102, 2.388227>,
      < -1.663497, 0.535625, 2.475946>,
      < -1.861263, 0.540159, 2.372707>
    }
    triangle {
      < 3.618461, 0.419610, 2.634592>,
      < 3.625835, 0.430011, 2.554180>,
      < 3.009002, 0.415065, 2.549848>
    }
    triangle {
      < 3.618461, 0.419610, 2.634592>,
      < 3.009002, 0.415065, 2.549848>,
      < 3.013547, 0.399663, 2.652796>
    }
    triangle {
      < 5.194430, 0.418646, 2.698007>,
      < 5.193110, 0.404471, 2.716558>,
      < 6.016861, 0.389399, 2.722277>
    }
    triangle {
      < 5.194430, 0.418646, 2.698007>,
      < 6.016861, 0.389399, 2.722277>,
      < 6.016443, 0.397662, 2.695796>
    }
    triangle {
      < 4.968434, 0.412051, 2.634367>,
      < 4.972139, 0.422715, 2.646387>,
      < 4.980284, 0.424102, 2.646861>
    }
    triangle {
      < 8.795041, -0.613710, 2.488710>,
      < 9.182425, 0.260078, 2.585223>,
      < 9.228248, 0.270685, 2.612574>
    }
    triangle {
      < 8.795041, -0.613710, 2.488710>,
      < 9.228248, 0.270685, 2.612574>,
      < 8.832082, -0.613710, 2.541341>
    }
    triangle {
      < 8.860677, -0.613710, 2.620058>,
      < 8.859509, -0.613710, 2.657776>,
      < 8.838814, -0.613710, 2.671821>
    }
    triangle {
      < 8.860677, -0.613710, 2.620058>,
      < 8.838814, -0.613710, 2.671821>,
      < 8.842156, -0.613710, 2.604175>
    }
    triangle {
      < 8.735338, -0.613710, 2.826938>,
      < 8.784227, -0.613710, 2.779588>,
      < 8.879555, -0.281976, 2.769261>
    }
    triangle {
      < 9.140353, 0.244126, 2.728450>,
      < 9.181384, 0.256832, 2.696940>,
      < 9.179888, 0.277209, 2.695884>
    }
    triangle {
      < 6.013980, 0.420398, 2.638773>,
      < 5.196445, 0.435444, 2.645413>,
      < 5.197360, 0.457936, 2.650850>
    }
    triangle {
      < 6.013980, 0.420398, 2.638773>,
      < 5.197360, 0.457936, 2.650850>,
      < 6.015857, 0.447026, 2.646350>
    }
    triangle {
      < 4.966898, 0.413589, 2.698662>,
      < 4.965728, 0.419402, 2.685982>,
      < 4.937755, 0.418982, 2.677343>
    }
    triangle {
      < 5.002436, 0.458145, 2.680569>,
      < 5.003514, 0.457348, 2.652287>,
      < 4.977233, 0.452511, 2.650693>
    }
    triangle {
      < 5.002436, 0.458145, 2.680569>,
      < 4.977233, 0.452511, 2.650693>,
      < 4.975909, 0.453292, 2.679017>
    }
    triangle {
      < 5.197360, 0.457936, 2.650850>,
      < 5.197023, 0.458783, 2.679006>,
      < 6.018072, 0.447388, 2.673555>
    }
    triangle {
      < 5.197360, 0.457936, 2.650850>,
      < 6.018072, 0.447388, 2.673555>,
      < 6.015857, 0.447026, 2.646350>
    }
    triangle {
      < 9.279105, 0.279658, 2.657954>,
      < 9.279998, 0.280421, 2.632423>,
      < 9.268329, 0.350512, 2.632469>
    }
    triangle {
      < 9.279105, 0.279658, 2.657954>,
      < 9.268329, 0.350512, 2.632469>,
      < 9.268064, 0.349557, 2.657365>
    }
    triangle {
      < 9.279105, 0.279658, 2.657954>,
      < 8.859509, -0.613710, 2.657776>,
      < 8.860677, -0.613710, 2.620058>
    }
    triangle {
      < 9.279105, 0.279658, 2.657954>,
      < 8.860677, -0.613710, 2.620058>,
      < 9.279998, 0.280421, 2.632423>
    }
    triangle {
      < 9.095436, 0.283447, 2.717090>,
      < 9.140353, 0.244126, 2.728450>,
      < 9.179888, 0.277209, 2.695884>
    }
    triangle {
      < 9.095436, 0.283447, 2.717090>,
      < 9.179888, 0.277209, 2.695884>,
      < 9.138460, 0.315434, 2.687874>
    }
    triangle {
      < 9.227504, 0.392088, 2.631354>,
      < 9.227866, 0.390941, 2.655616>,
      < 9.268064, 0.349557, 2.657365>
    }
    triangle {
      < 9.227504, 0.392088, 2.631354>,
      < 9.268064, 0.349557, 2.657365>,
      < 9.268329, 0.350512, 2.632469>
    }
    triangle {
      < 9.095436, 0.283447, 2.717090>,
      < 9.138460, 0.315434, 2.687874>,
      < 9.116157, 0.318534, 2.687459>
    }
    triangle {
      < 9.157522, 0.405147, 2.629079>,
      < 9.158513, 0.403807, 2.652705>,
      < 9.227866, 0.390941, 2.655616>
    }
    triangle {
      < 9.157522, 0.405147, 2.629079>,
      < 9.227866, 0.390941, 2.655616>,
      < 9.227504, 0.392088, 2.631354>
    }
    triangle {
      < 9.111607, 0.326064, 2.589782>,
      < 9.134267, 0.362971, 2.613432>,
      < 9.179674, 0.355510, 2.615465>
    }
    triangle {
      < 9.111607, 0.326064, 2.589782>,
      < 9.179674, 0.355510, 2.615465>,
      < 9.133686, 0.322956, 2.591057>
    }
    triangle {
      < 9.133686, 0.322956, 2.591057>,
      < 9.179674, 0.355510, 2.615465>,
      < 9.222689, 0.314422, 2.613701>
    }
    triangle {
      < 9.133686, 0.322956, 2.591057>,
      < 9.222689, 0.314422, 2.613701>,
      < 9.180755, 0.280451, 2.586335>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 4.968434, 0.412051, 2.634367>,
      < 4.980284, 0.424102, 2.646861>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 4.980284, 0.424102, 2.646861>,
      < 5.195446, 0.416846, 2.633922>
    }
    triangle {
      < 5.197023, 0.458783, 2.679006>,
      < 5.197360, 0.457936, 2.650850>,
      < 5.003514, 0.457348, 2.652287>
    }
    triangle {
      < 5.197023, 0.458783, 2.679006>,
      < 5.003514, 0.457348, 2.652287>,
      < 5.002436, 0.458145, 2.680569>
    }
    triangle {
      < 4.966898, 0.413589, 2.698662>,
      < 5.193110, 0.404471, 2.716558>,
      < 5.194430, 0.418646, 2.698007>
    }
    triangle {
      < 4.966898, 0.413589, 2.698662>,
      < 5.194430, 0.418646, 2.698007>,
      < 4.979320, 0.424974, 2.686347>
    }
    triangle {
      < 4.939573, 0.418233, 2.648936>,
      < 4.937755, 0.418982, 2.677343>,
      < 4.954349, 0.440237, 2.677941>
    }
    triangle {
      < 4.939573, 0.418233, 2.648936>,
      < 4.954349, 0.440237, 2.677941>,
      < 4.955920, 0.439473, 2.649575>
    }
    triangle {
      < 4.975909, 0.453292, 2.679017>,
      < 4.977233, 0.452511, 2.650693>,
      < 4.955920, 0.439473, 2.649575>
    }
    triangle {
      < 4.975909, 0.453292, 2.679017>,
      < 4.955920, 0.439473, 2.649575>,
      < 4.954349, 0.440237, 2.677941>
    }
    triangle {
      < 4.966898, 0.413589, 2.698662>,
      < 4.971589, 0.423416, 2.686000>,
      < 4.965728, 0.419402, 2.685982>
    }
    triangle {
      < 4.966898, 0.413589, 2.698662>,
      < 4.979320, 0.424974, 2.686347>,
      < 4.971589, 0.423416, 2.686000>
    }
    triangle {
      < 4.968434, 0.412051, 2.634367>,
      < 4.966338, 0.418596, 2.645824>,
      < 4.972139, 0.422715, 2.646387>
    }
    triangle {
      < 4.968434, 0.412051, 2.634367>,
      < 4.939573, 0.418233, 2.648936>,
      < 4.966338, 0.418596, 2.645824>
    }
    triangle {
      < 9.182603, 0.351266, 2.667382>,
      < 9.137182, 0.358654, 2.665998>,
      < 9.116157, 0.318534, 2.687459>
    }
    triangle {
      < 9.182603, 0.351266, 2.667382>,
      < 9.116157, 0.318534, 2.687459>,
      < 9.138460, 0.315434, 2.687874>
    }
    triangle {
      < 9.222457, 0.312353, 2.672189>,
      < 9.182603, 0.351266, 2.667382>,
      < 9.138460, 0.315434, 2.687874>
    }
    triangle {
      < 9.222457, 0.312353, 2.672189>,
      < 9.138460, 0.315434, 2.687874>,
      < 9.179888, 0.277209, 2.695884>
    }
    triangle {
      < 9.227635, 0.268676, 2.673442>,
      < 9.222457, 0.312353, 2.672189>,
      < 9.179888, 0.277209, 2.695884>
    }
    triangle {
      < 9.227635, 0.268676, 2.673442>,
      < 9.179888, 0.277209, 2.695884>,
      < 9.181384, 0.256832, 2.696940>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 9.227635, 0.268676, 2.673442>,
      < 9.181384, 0.256832, 2.696940>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 9.181384, 0.256832, 2.696940>,
      < 8.784227, -0.613710, 2.779588>
    }
    triangle {
      < 9.089541, 0.294427, 2.558130>,
      < 9.111607, 0.326064, 2.589782>,
      < 9.133686, 0.322956, 2.591057>
    }
    triangle {
      < 9.142529, 0.248598, 2.550370>,
      < 9.089541, 0.294427, 2.558130>,
      < 9.133686, 0.322956, 2.591057>
    }
    triangle {
      < 9.142529, 0.248598, 2.550370>,
      < 9.133686, 0.322956, 2.591057>,
      < 9.180755, 0.280451, 2.586335>
    }
    triangle {
      < 9.142529, 0.248598, 2.550370>,
      < 9.180755, 0.280451, 2.586335>,
      < 9.182425, 0.260078, 2.585223>
    }
    triangle {
      < 8.749555, -0.613710, 2.466970>,
      < 9.142529, 0.248598, 2.550370>,
      < 9.182425, 0.260078, 2.585223>
    }
    triangle {
      < 8.749555, -0.613710, 2.466970>,
      < 9.182425, 0.260078, 2.585223>,
      < 8.795041, -0.613710, 2.488710>
    }
    triangle {
      < 9.279998, 0.280421, 2.632423>,
      < 8.842156, -0.613710, 2.604175>,
      < 8.832082, -0.613710, 2.541341>
    }
    triangle {
      < 9.279998, 0.280421, 2.632423>,
      < 8.832082, -0.613710, 2.541341>,
      < 9.228248, 0.270685, 2.612574>
    }
    triangle {
      < 9.268329, 0.350512, 2.632469>,
      < 9.279998, 0.280421, 2.632423>,
      < 9.228248, 0.270685, 2.612574>
    }
    triangle {
      < 9.268329, 0.350512, 2.632469>,
      < 9.228248, 0.270685, 2.612574>,
      < 9.222689, 0.314422, 2.613701>
    }
    triangle {
      < 9.227504, 0.392088, 2.631354>,
      < 9.268329, 0.350512, 2.632469>,
      < 9.222689, 0.314422, 2.613701>
    }
    triangle {
      < 9.227504, 0.392088, 2.631354>,
      < 9.222689, 0.314422, 2.613701>,
      < 9.179674, 0.355510, 2.615465>
    }
    triangle {
      < 9.157522, 0.405147, 2.629079>,
      < 9.227504, 0.392088, 2.631354>,
      < 9.179674, 0.355510, 2.615465>
    }
    triangle {
      < 9.157522, 0.405147, 2.629079>,
      < 9.179674, 0.355510, 2.615465>,
      < 9.134267, 0.362971, 2.613432>
    }
    triangle {
      < 9.227866, 0.390941, 2.655616>,
      < 9.158513, 0.403807, 2.652705>,
      < 9.137182, 0.358654, 2.665998>
    }
    triangle {
      < 9.227866, 0.390941, 2.655616>,
      < 9.137182, 0.358654, 2.665998>,
      < 9.182603, 0.351266, 2.667382>
    }
    triangle {
      < 9.268064, 0.349557, 2.657365>,
      < 9.227866, 0.390941, 2.655616>,
      < 9.182603, 0.351266, 2.667382>
    }
    triangle {
      < 9.268064, 0.349557, 2.657365>,
      < 9.182603, 0.351266, 2.667382>,
      < 9.222457, 0.312353, 2.672189>
    }
    triangle {
      < 9.279105, 0.279658, 2.657954>,
      < 9.268064, 0.349557, 2.657365>,
      < 9.222457, 0.312353, 2.672189>
    }
    triangle {
      < 9.279105, 0.279658, 2.657954>,
      < 9.222457, 0.312353, 2.672189>,
      < 9.227635, 0.268676, 2.673442>
    }
    triangle {
      < 8.838814, -0.613710, 2.671821>,
      < 9.279105, 0.279658, 2.657954>,
      < 9.227635, 0.268676, 2.673442>
    }
    triangle {
      < 8.838814, -0.613710, 2.671821>,
      < 9.227635, 0.268676, 2.673442>,
      < 8.825618, -0.613710, 2.723200>
    }
    triangle {
      < 8.860677, -0.613710, 2.620058>,
      < 8.842156, -0.613710, 2.604175>,
      < 9.279998, 0.280421, 2.632423>
    }
    triangle {
      < 8.859509, -0.613710, 2.657776>,
      < 9.279105, 0.279658, 2.657954>,
      < 8.838814, -0.613710, 2.671821>
    }
    triangle {
      < 4.991977, 0.439201, 2.652834>,
      < 5.196445, 0.435444, 2.645413>,
      < 5.195446, 0.416846, 2.633922>
    }
    triangle {
      < 4.991977, 0.439201, 2.652834>,
      < 5.195446, 0.416846, 2.633922>,
      < 4.980284, 0.424102, 2.646861>
    }
    triangle {
      < 4.975072, 0.436202, 2.651829>,
      < 4.991977, 0.439201, 2.652834>,
      < 4.980284, 0.424102, 2.646861>
    }
    triangle {
      < 4.975072, 0.436202, 2.651829>,
      < 4.980284, 0.424102, 2.646861>,
      < 4.972139, 0.422715, 2.646387>
    }
    triangle {
      < 4.962166, 0.427737, 2.650893>,
      < 4.975072, 0.436202, 2.651829>,
      < 4.972139, 0.422715, 2.646387>
    }
    triangle {
      < 4.962166, 0.427737, 2.650893>,
      < 4.972139, 0.422715, 2.646387>,
      < 4.966338, 0.418596, 2.645824>
    }
    triangle {
      < 4.962166, 0.427737, 2.650893>,
      < 4.966338, 0.418596, 2.645824>,
      < 4.939573, 0.418233, 2.648936>
    }
    triangle {
      < 4.954349, 0.440237, 2.677941>,
      < 4.937755, 0.418982, 2.677343>,
      < 4.961545, 0.428285, 2.679075>
    }
    triangle {
      < 4.975909, 0.453292, 2.679017>,
      < 4.954349, 0.440237, 2.677941>,
      < 4.961545, 0.428285, 2.679075>
    }
    triangle {
      < 4.975909, 0.453292, 2.679017>,
      < 4.961545, 0.428285, 2.679075>,
      < 4.974592, 0.436650, 2.679451>
    }
    triangle {
      < 5.002436, 0.458145, 2.680569>,
      < 4.975909, 0.453292, 2.679017>,
      < 4.974592, 0.436650, 2.679451>
    }
    triangle {
      < 5.002436, 0.458145, 2.680569>,
      < 4.974592, 0.436650, 2.679451>,
      < 4.991166, 0.439826, 2.680316>
    }
    triangle {
      < 5.197023, 0.458783, 2.679006>,
      < 5.002436, 0.458145, 2.680569>,
      < 4.991166, 0.439826, 2.680316>
    }
    triangle {
      < 5.197023, 0.458783, 2.679006>,
      < 4.991166, 0.439826, 2.680316>,
      < 5.195735, 0.436750, 2.685490>
    }
    triangle {
      < 4.979320, 0.424974, 2.686347>,
      < 5.194430, 0.418646, 2.698007>,
      < 5.195735, 0.436750, 2.685490>
    }
    triangle {
      < 4.979320, 0.424974, 2.686347>,
      < 5.195735, 0.436750, 2.685490>,
      < 4.991166, 0.439826, 2.680316>
    }
    triangle {
      < 4.971589, 0.423416, 2.686000>,
      < 4.979320, 0.424974, 2.686347>,
      < 4.991166, 0.439826, 2.680316>
    }
    triangle {
      < 4.971589, 0.423416, 2.686000>,
      < 4.991166, 0.439826, 2.680316>,
      < 4.974592, 0.436650, 2.679451>
    }
    triangle {
      < 4.965728, 0.419402, 2.685982>,
      < 4.971589, 0.423416, 2.686000>,
      < 4.974592, 0.436650, 2.679451>
    }
    triangle {
      < 4.965728, 0.419402, 2.685982>,
      < 4.974592, 0.436650, 2.679451>,
      < 4.961545, 0.428285, 2.679075>
    }
    triangle {
      < 4.965728, 0.419402, 2.685982>,
      < 4.961545, 0.428285, 2.679075>,
      < 4.937755, 0.418982, 2.677343>
    }
    triangle {
      < 5.003514, 0.457348, 2.652287>,
      < 5.197360, 0.457936, 2.650850>,
      < 5.196445, 0.435444, 2.645413>
    }
    triangle {
      < 5.003514, 0.457348, 2.652287>,
      < 5.196445, 0.435444, 2.645413>,
      < 4.991977, 0.439201, 2.652834>
    }
    triangle {
      < 4.977233, 0.452511, 2.650693>,
      < 5.003514, 0.457348, 2.652287>,
      < 4.991977, 0.439201, 2.652834>
    }
    triangle {
      < 4.977233, 0.452511, 2.650693>,
      < 4.991977, 0.439201, 2.652834>,
      < 4.975072, 0.436202, 2.651829>
    }
    triangle {
      < 4.955920, 0.439473, 2.649575>,
      < 4.977233, 0.452511, 2.650693>,
      < 4.975072, 0.436202, 2.651829>
    }
    triangle {
      < 4.955920, 0.439473, 2.649575>,
      < 4.975072, 0.436202, 2.651829>,
      < 4.962166, 0.427737, 2.650893>
    }
    triangle {
      < 4.955920, 0.439473, 2.649575>,
      < 4.962166, 0.427737, 2.650893>,
      < 4.939573, 0.418233, 2.648936>
    }
    triangle {
      < 5.197023, 0.458783, 2.679006>,
      < 5.195735, 0.436750, 2.685490>,
      < 6.018225, 0.420453, 2.681422>
    }
    triangle {
      < 5.197023, 0.458783, 2.679006>,
      < 6.018225, 0.420453, 2.681422>,
      < 6.018072, 0.447388, 2.673555>
    }
    triangle {
      < 5.195735, 0.436750, 2.685490>,
      < 5.194430, 0.418646, 2.698007>,
      < 6.016443, 0.397662, 2.695796>
    }
    triangle {
      < 5.195735, 0.436750, 2.685490>,
      < 6.016443, 0.397662, 2.695796>,
      < 6.018225, 0.420453, 2.681422>
    }
    triangle {
      < 5.195446, 0.416846, 2.633922>,
      < 5.196445, 0.435444, 2.645413>,
      < 6.013980, 0.420398, 2.638773>
    }
    triangle {
      < 5.195446, 0.416846, 2.633922>,
      < 6.013980, 0.420398, 2.638773>,
      < 6.013906, 0.397873, 2.624697>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 5.195446, 0.416846, 2.633922>,
      < 6.013906, 0.397873, 2.624697>
    }
    triangle {
      < 5.194364, 0.402142, 2.616375>,
      < 6.013906, 0.397873, 2.624697>,
      < 6.014196, 0.389435, 2.592635>
    }
    triangle {
      < 7.655514, 0.359819, 2.606194>,
      < 7.656147, 0.345041, 2.573846>,
      < 6.014196, 0.389435, 2.592635>
    }
    triangle {
      < 7.655514, 0.359819, 2.606194>,
      < 6.014196, 0.389435, 2.592635>,
      < 6.013906, 0.397873, 2.624697>
    }
    triangle {
      < 7.657019, 0.390159, 2.625429>,
      < 7.655514, 0.359819, 2.606194>,
      < 6.013906, 0.397873, 2.624697>
    }
    triangle {
      < 7.657019, 0.390159, 2.625429>,
      < 6.013906, 0.397873, 2.624697>,
      < 6.013980, 0.420398, 2.638773>
    }
    triangle {
      < 7.655910, 0.425164, 2.637334>,
      < 7.657019, 0.390159, 2.625429>,
      < 6.013980, 0.420398, 2.638773>
    }
    triangle {
      < 7.655910, 0.425164, 2.637334>,
      < 6.013980, 0.420398, 2.638773>,
      < 6.015857, 0.447026, 2.646350>
    }
    triangle {
      < 7.656977, 0.424645, 2.662674>,
      < 7.655910, 0.425164, 2.637334>,
      < 6.015857, 0.447026, 2.646350>
    }
    triangle {
      < 7.656977, 0.424645, 2.662674>,
      < 6.015857, 0.447026, 2.646350>,
      < 6.018072, 0.447388, 2.673555>
    }
    triangle {
      < 7.656381, 0.387995, 2.673321>,
      < 7.656977, 0.424645, 2.662674>,
      < 6.018072, 0.447388, 2.673555>
    }
    triangle {
      < 7.656381, 0.387995, 2.673321>,
      < 6.018072, 0.447388, 2.673555>,
      < 6.018225, 0.420453, 2.681422>
    }
    triangle {
      < 7.655323, 0.355826, 2.691388>,
      < 7.656381, 0.387995, 2.673321>,
      < 6.018225, 0.420453, 2.681422>
    }
    triangle {
      < 7.655323, 0.355826, 2.691388>,
      < 6.018225, 0.420453, 2.681422>,
      < 6.016443, 0.397662, 2.695796>
    }
    triangle {
      < 7.653469, 0.344960, 2.729584>,
      < 7.655323, 0.355826, 2.691388>,
      < 6.016443, 0.397662, 2.695796>
    }
    triangle {
      < 7.653469, 0.344960, 2.729584>,
      < 6.016443, 0.397662, 2.695796>,
      < 6.016861, 0.389399, 2.722277>
    }
    triangle {
      < 9.111607, 0.326064, 2.589782>,
      < 9.089541, 0.294427, 2.558130>,
      < 7.656147, 0.345041, 2.573846>
    }
    triangle {
      < 9.111607, 0.326064, 2.589782>,
      < 7.656147, 0.345041, 2.573846>,
      < 7.655514, 0.359819, 2.606194>
    }
    triangle {
      < 9.134267, 0.362971, 2.613432>,
      < 9.111607, 0.326064, 2.589782>,
      < 7.655514, 0.359819, 2.606194>
    }
    triangle {
      < 9.134267, 0.362971, 2.613432>,
      < 7.655514, 0.359819, 2.606194>,
      < 7.657019, 0.390159, 2.625429>
    }
    triangle {
      < 9.157522, 0.405147, 2.629079>,
      < 9.134267, 0.362971, 2.613432>,
      < 7.657019, 0.390159, 2.625429>
    }
    triangle {
      < 9.157522, 0.405147, 2.629079>,
      < 7.657019, 0.390159, 2.625429>,
      < 7.655910, 0.425164, 2.637334>
    }
    triangle {
      < 9.158513, 0.403807, 2.652705>,
      < 9.157522, 0.405147, 2.629079>,
      < 7.655910, 0.425164, 2.637334>
    }
    triangle {
      < 9.158513, 0.403807, 2.652705>,
      < 7.655910, 0.425164, 2.637334>,
      < 7.656977, 0.424645, 2.662674>
    }
    triangle {
      < 9.137182, 0.358654, 2.665998>,
      < 9.158513, 0.403807, 2.652705>,
      < 7.656977, 0.424645, 2.662674>
    }
    triangle {
      < 9.137182, 0.358654, 2.665998>,
      < 7.656977, 0.424645, 2.662674>,
      < 7.656381, 0.387995, 2.673321>
    }
    triangle {
      < 9.116157, 0.318534, 2.687459>,
      < 9.137182, 0.358654, 2.665998>,
      < 7.656381, 0.387995, 2.673321>
    }
    triangle {
      < 9.116157, 0.318534, 2.687459>,
      < 7.656381, 0.387995, 2.673321>,
      < 7.655323, 0.355826, 2.691388>
    }
    triangle {
      < 9.095436, 0.283447, 2.717090>,
      < 9.116157, 0.318534, 2.687459>,
      < 7.655323, 0.355826, 2.691388>
    }
    triangle {
      < 9.095436, 0.283447, 2.717090>,
      < 7.655323, 0.355826, 2.691388>,
      < 7.653469, 0.344960, 2.729584>
    }
    triangle {
      < -2.647161, 0.620226, 0.000000>,
      < -2.596643, 0.595192, 1.118505>,
      < -2.513843, 0.640220, 1.116418>
    }
    triangle {
      < -2.647161, 0.620226, 0.000000>,
      < -2.513843, 0.640220, 1.116418>,
      < -2.563848, 0.664836, 0.000000>
    }
    triangle {
      < -2.124247, 0.515122, 2.250817>,
      < -1.937317, 0.490102, 2.388227>,
      < -1.861263, 0.540159, 2.372707>
    }
    triangle {
      < -2.124247, 0.515122, 2.250817>,
      < -1.861263, 0.540159, 2.372707>,
      < -2.046178, 0.563892, 2.239006>
    }
    triangle {
      < -2.338066, 0.541556, 1.972795>,
      < -2.216968, 0.523991, 2.156171>,
      < -2.137997, 0.572132, 2.146596>
    }
    triangle {
      < -2.338066, 0.541556, 1.972795>,
      < -2.137997, 0.572132, 2.146596>,
      < -2.257701, 0.588659, 1.967557>
    }
    triangle {
      < -2.216968, 0.523991, 2.156171>,
      < -2.124247, 0.515122, 2.250817>,
      < -2.046178, 0.563892, 2.239006>
    }
    triangle {
      < -2.216968, 0.523991, 2.156171>,
      < -2.046178, 0.563892, 2.239006>,
      < -2.137997, 0.572132, 2.146596>
    }
    triangle {
      < -2.477282, 0.570167, 1.677680>,
      < -2.338066, 0.541556, 1.972795>,
      < -2.257701, 0.588659, 1.967557>
    }
    triangle {
      < -2.477282, 0.570167, 1.677680>,
      < -2.257701, 0.588659, 1.967557>,
      < -2.395683, 0.616269, 1.677391>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.663497, 0.535625, 2.475946>,
      < -1.738342, 0.485082, 2.495975>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.738342, 0.485082, 2.495975>,
      < -1.534455, 0.475062, 2.550094>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.534455, 0.475062, 2.550094>,
      < -1.148572, 0.470027, 2.602251>
    }
    triangle {
      < -2.596643, 0.595192, 1.118505>,
      < -2.551558, 0.580177, 1.443880>,
      < -2.477282, 0.570167, 1.677680>
    }
    triangle {
      < -2.596643, 0.595192, 1.118505>,
      < -2.477282, 0.570167, 1.677680>,
      < -2.395683, 0.616269, 1.677391>
    }
    triangle {
      < -2.596643, 0.595192, 1.118505>,
      < -2.395683, 0.616269, 1.677391>,
      < -2.513843, 0.640220, 1.116418>
    }
    triangle {
      < -2.468745, 0.693699, 1.113939>,
      < -2.518123, 0.717825, 0.000000>,
      < -2.563848, 0.664836, 0.000000>
    }
    triangle {
      < -2.468745, 0.693699, 1.113939>,
      < -2.563848, 0.664836, 0.000000>,
      < -2.513843, 0.640220, 1.116418>
    }
    triangle {
      < -2.352075, 0.671026, 1.677048>,
      < -2.468745, 0.693699, 1.113939>,
      < -2.513843, 0.640220, 1.116418>
    }
    triangle {
      < -2.352075, 0.671026, 1.677048>,
      < -2.513843, 0.640220, 1.116418>,
      < -2.395683, 0.616269, 1.677391>
    }
    triangle {
      < -2.216012, 0.644890, 1.967351>,
      < -2.352075, 0.671026, 1.677048>,
      < -2.395683, 0.616269, 1.677391>
    }
    triangle {
      < -2.216012, 0.644890, 1.967351>,
      < -2.395683, 0.616269, 1.677391>,
      < -2.257701, 0.588659, 1.967557>
    }
    triangle {
      < -2.097687, 0.629337, 2.144970>,
      < -2.216012, 0.644890, 1.967351>,
      < -2.257701, 0.588659, 1.967557>
    }
    triangle {
      < -2.097687, 0.629337, 2.144970>,
      < -2.257701, 0.588659, 1.967557>,
      < -2.137997, 0.572132, 2.146596>
    }
    triangle {
      < -2.007033, 0.621876, 2.236672>,
      < -2.097687, 0.629337, 2.144970>,
      < -2.137997, 0.572132, 2.146596>
    }
    triangle {
      < -2.007033, 0.621876, 2.236672>,
      < -2.137997, 0.572132, 2.146596>,
      < -2.046178, 0.563892, 2.239006>
    }
    triangle {
      < -1.824827, 0.599804, 2.368844>,
      < -2.007033, 0.621876, 2.236672>,
      < -2.046178, 0.563892, 2.239006>
    }
    triangle {
      < -1.824827, 0.599804, 2.368844>,
      < -2.046178, 0.563892, 2.239006>,
      < -1.861263, 0.540159, 2.372707>
    }
    triangle {
      < -1.629170, 0.596234, 2.469007>,
      < -1.824827, 0.599804, 2.368844>,
      < -1.861263, 0.540159, 2.372707>
    }
    triangle {
      < -1.629170, 0.596234, 2.469007>,
      < -1.861263, 0.540159, 2.372707>,
      < -1.663497, 0.535625, 2.475946>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.509560, 0.599953, 2.486600>,
      < -1.629170, 0.596234, 2.469007>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.629170, 0.596234, 2.469007>,
      < -1.663497, 0.535625, 2.475946>
    }
    triangle {
      < -1.466633, 1.880095, 1.058952>,
      < -1.496285, 1.900125, 0.000000>,
      < -1.550691, 1.836236, 0.000000>
    }
    triangle {
      < -1.466633, 1.880095, 1.058952>,
      < -1.550691, 1.836236, 0.000000>,
      < -1.520526, 1.815788, 1.061110>
    }
    triangle {
      < -1.415399, 1.845075, 1.669688>,
      < -1.466633, 1.880095, 1.058952>,
      < -1.520526, 1.815788, 1.061110>
    }
    triangle {
      < -1.415399, 1.845075, 1.669688>,
      < -1.520526, 1.815788, 1.061110>,
      < -1.468092, 1.779693, 1.670048>
    }
    triangle {
      < -1.361049, 1.795061, 1.962939>,
      < -1.415399, 1.845075, 1.669688>,
      < -1.468092, 1.779693, 1.670048>
    }
    triangle {
      < -1.361049, 1.795061, 1.962939>,
      < -1.468092, 1.779693, 1.670048>,
      < -1.412507, 1.728679, 1.963380>
    }
    triangle {
      < -1.309657, 1.745054, 2.112932>,
      < -1.361049, 1.795061, 1.962939>,
      < -1.412507, 1.728679, 1.963380>
    }
    triangle {
      < -1.309657, 1.745054, 2.112932>,
      < -1.412507, 1.728679, 1.963380>,
      < -1.359722, 1.677634, 2.114707>
    }
    triangle {
      < -1.280637, 1.695050, 2.192977>,
      < -1.309657, 1.745054, 2.112932>,
      < -1.359722, 1.677634, 2.114707>
    }
    triangle {
      < -1.280637, 1.695050, 2.192977>,
      < -1.359722, 1.677634, 2.114707>,
      < -1.331195, 1.624870, 2.195607>
    }
    triangle {
      < -1.241647, 1.550043, 2.306568>,
      < -1.261595, 1.640047, 2.239476>,
      < -1.280637, 1.695050, 2.192977>
    }
    triangle {
      < -1.241647, 1.550043, 2.306568>,
      < -1.280637, 1.695050, 2.192977>,
      < -1.331195, 1.624870, 2.195607>
    }
    triangle {
      < -1.241647, 1.550043, 2.306568>,
      < -1.331195, 1.624870, 2.195607>,
      < -1.295008, 1.471234, 2.311228>
    }
    triangle {
      < -1.203056, 1.340038, 2.383760>,
      < -1.241647, 1.550043, 2.306568>,
      < -1.295008, 1.471234, 2.311228>
    }
    triangle {
      < -1.203056, 1.340038, 2.383760>,
      < -1.295008, 1.471234, 2.311228>,
      < -1.262364, 1.249839, 2.392038>
    }
    triangle {
      < -2.173151, 0.642992, 1.948107>,
      < -2.306105, 0.664578, 1.673231>,
      < -2.352075, 0.671026, 1.677048>
    }
    triangle {
      < -2.173151, 0.642992, 1.948107>,
      < -2.352075, 0.671026, 1.677048>,
      < -2.216012, 0.644890, 1.967351>
    }
    triangle {
      < -1.972645, 0.624423, 2.205898>,
      < -2.055634, 0.627002, 2.125403>,
      < -2.097687, 0.629337, 2.144970>
    }
    triangle {
      < -1.972645, 0.624423, 2.205898>,
      < -2.097687, 0.629337, 2.144970>,
      < -2.007033, 0.621876, 2.236672>
    }
    triangle {
      < -1.614355, 0.602091, 2.428892>,
      < -1.792238, 0.600730, 2.337865>,
      < -1.824827, 0.599804, 2.368844>
    }
    triangle {
      < -1.614355, 0.602091, 2.428892>,
      < -1.824827, 0.599804, 2.368844>,
      < -1.629170, 0.596234, 2.469007>
    }
    triangle {
      < -1.186268, 0.540032, 2.545651>,
      < -1.405537, 0.619055, 2.498667>,
      < -1.509560, 0.599953, 2.486600>
    }
    triangle {
      < -1.203056, 1.340038, 2.383760>,
      < -1.262364, 1.249839, 2.392038>,
      < -1.267084, 0.844988, 2.473849>
    }
    triangle {
      < -1.203056, 1.340038, 2.383760>,
      < -1.267084, 0.844988, 2.473849>,
      < -1.186268, 0.540032, 2.545651>
    }
    triangle {
      < -1.267084, 0.844988, 2.473849>,
      < -1.284299, 0.741572, 2.492291>,
      < -1.186268, 0.540032, 2.545651>
    }
    triangle {
      < -1.323216, 0.659235, 2.503107>,
      < -1.405537, 0.619055, 2.498667>,
      < -1.186268, 0.540032, 2.545651>
    }
    triangle {
      < -1.284299, 0.741572, 2.492291>,
      < -1.323216, 0.659235, 2.503107>,
      < -1.186268, 0.540032, 2.545651>
    }
    triangle {
      < -1.531823, 1.796562, 0.000000>,
      < -1.501422, 1.776069, 1.058051>,
      < -1.520526, 1.815788, 1.061110>
    }
    triangle {
      < -1.531823, 1.796562, 0.000000>,
      < -1.520526, 1.815788, 1.061110>,
      < -1.550691, 1.836236, 0.000000>
    }
    triangle {
      < -1.501422, 1.776069, 1.058051>,
      < -1.448195, 1.740140, 1.666425>,
      < -1.468092, 1.779693, 1.670048>
    }
    triangle {
      < -1.501422, 1.776069, 1.058051>,
      < -1.468092, 1.779693, 1.670048>,
      < -1.520526, 1.815788, 1.061110>
    }
    triangle {
      < -2.306105, 0.664578, 1.673231>,
      < -2.421983, 0.687416, 1.109558>,
      < -2.468745, 0.693699, 1.113939>
    }
    triangle {
      < -2.306105, 0.664578, 1.673231>,
      < -2.468745, 0.693699, 1.113939>,
      < -2.352075, 0.671026, 1.677048>
    }
    triangle {
      < -2.421983, 0.687416, 1.109558>,
      < -2.471125, 0.711497, 0.000000>,
      < -2.518123, 0.717825, 0.000000>
    }
    triangle {
      < -2.421983, 0.687416, 1.109558>,
      < -2.518123, 0.717825, 0.000000>,
      < -2.468745, 0.693699, 1.113939>
    }
    triangle {
      < -2.055634, 0.627002, 2.125403>,
      < -2.173151, 0.642992, 1.948107>,
      < -2.216012, 0.644890, 1.967351>
    }
    triangle {
      < -2.055634, 0.627002, 2.125403>,
      < -2.216012, 0.644890, 1.967351>,
      < -2.097687, 0.629337, 2.144970>
    }
    triangle {
      < -1.393737, 1.694287, 1.944256>,
      < -1.340144, 1.643680, 2.095907>,
      < -1.359722, 1.677634, 2.114707>
    }
    triangle {
      < -1.393737, 1.694287, 1.944256>,
      < -1.359722, 1.677634, 2.114707>,
      < -1.412507, 1.728679, 1.963380>
    }
    triangle {
      < -1.792238, 0.600730, 2.337865>,
      < -1.972645, 0.624423, 2.205898>,
      < -2.007033, 0.621876, 2.236672>
    }
    triangle {
      < -1.792238, 0.600730, 2.337865>,
      < -2.007033, 0.621876, 2.236672>,
      < -1.824827, 0.599804, 2.368844>
    }
    triangle {
      < -1.317752, 1.596914, 2.165866>,
      < -1.285982, 1.434658, 2.282372>,
      < -1.295008, 1.471234, 2.311228>
    }
    triangle {
      < -1.317752, 1.596914, 2.165866>,
      < -1.295008, 1.471234, 2.311228>,
      < -1.331195, 1.624870, 2.195607>
    }
    triangle {
      < -1.260878, 1.233804, 2.353841>,
      < -1.268391, 0.835856, 2.433827>,
      < -1.267084, 0.844988, 2.473849>
    }
    triangle {
      < -1.260878, 1.233804, 2.353841>,
      < -1.267084, 0.844988, 2.473849>,
      < -1.262364, 1.249839, 2.392038>
    }
    triangle {
      < -1.268391, 0.835856, 2.433827>,
      < -1.285062, 0.735826, 2.451662>,
      < -1.284299, 0.741572, 2.492291>
    }
    triangle {
      < -1.268391, 0.835856, 2.433827>,
      < -1.284299, 0.741572, 2.492291>,
      < -1.267084, 0.844988, 2.473849>
    }
    triangle {
      < -1.285062, 0.735826, 2.451662>,
      < -1.322724, 0.656193, 2.462118>,
      < -1.323216, 0.659235, 2.503107>
    }
    triangle {
      < -1.285062, 0.735826, 2.451662>,
      < -1.323216, 0.659235, 2.503107>,
      < -1.284299, 0.741572, 2.492291>
    }
    triangle {
      < -1.322724, 0.656193, 2.462118>,
      < -1.402362, 0.617344, 2.457819>,
      < -1.405537, 0.619055, 2.498667>
    }
    triangle {
      < -1.322724, 0.656193, 2.462118>,
      < -1.405537, 0.619055, 2.498667>,
      < -1.323216, 0.659235, 2.503107>
    }
    triangle {
      < -1.402362, 0.617344, 2.457819>,
      < -1.502984, 0.598885, 2.446143>,
      < -1.509560, 0.599953, 2.486600>
    }
    triangle {
      < -1.402362, 0.617344, 2.457819>,
      < -1.509560, 0.599953, 2.486600>,
      < -1.405537, 0.619055, 2.498667>
    }
    triangle {
      < -1.502984, 0.598885, 2.446143>,
      < -1.614355, 0.602091, 2.428892>,
      < -1.629170, 0.596234, 2.469007>
    }
    triangle {
      < -1.502984, 0.598885, 2.446143>,
      < -1.629170, 0.596234, 2.469007>,
      < -1.509560, 0.599953, 2.486600>
    }
    triangle {
      < -1.412507, 1.728679, 1.963380>,
      < -1.468092, 1.779693, 1.670048>,
      < -1.448195, 1.740140, 1.666425>
    }
    triangle {
      < -1.412507, 1.728679, 1.963380>,
      < -1.448195, 1.740140, 1.666425>,
      < -1.393737, 1.694287, 1.944256>
    }
    triangle {
      < -1.331195, 1.624870, 2.195607>,
      < -1.359722, 1.677634, 2.114707>,
      < -1.340144, 1.643680, 2.095907>
    }
    triangle {
      < -1.331195, 1.624870, 2.195607>,
      < -1.340144, 1.643680, 2.095907>,
      < -1.317752, 1.596914, 2.165866>
    }
    triangle {
      < -1.262364, 1.249839, 2.392038>,
      < -1.295008, 1.471234, 2.311228>,
      < -1.285982, 1.434658, 2.282372>
    }
    triangle {
      < -1.262364, 1.249839, 2.392038>,
      < -1.285982, 1.434658, 2.282372>,
      < -1.260878, 1.233804, 2.353841>
    }
    triangle {
      < -0.986746, 0.484704, 2.592602>,
      < -1.009507, 0.547531, 2.545279>,
      < -1.146178, 0.546644, 2.545252>
    }
    triangle {
      < -0.986746, 0.484704, 2.592602>,
      < -1.146178, 0.546644, 2.545252>,
      < -1.148572, 0.470027, 2.602251>
    }
    triangle {
      < -0.986746, 0.484704, 2.592602>,
      < -1.148572, 0.470027, 2.602251>,
      < -1.033102, 0.465816, 2.607353>
    }
    triangle {
      < -0.976372, 0.551342, 2.528678>,
      < -1.009507, 0.547531, 2.545279>,
      < -0.986746, 0.484704, 2.592602>
    }
    triangle {
      < -0.976372, 0.551342, 2.528678>,
      < -0.986746, 0.484704, 2.592602>,
      < -0.961274, 0.491229, 2.574352>
    }
    triangle {
      < -0.381252, 0.460833, 2.577173>,
      < -0.379683, 0.470362, 2.504004>,
      < -0.441565, 0.481225, 2.501955>
    }
    triangle {
      < -0.381252, 0.460833, 2.577173>,
      < -0.441565, 0.481225, 2.501955>,
      < -0.443789, 0.479750, 2.581917>
    }
    triangle {
      < 1.780270, 0.339770, 2.680530>,
      < 1.773786, 0.360172, 2.588591>,
      < 0.819398, 0.425256, 2.554250>
    }
    triangle {
      < 1.780270, 0.339770, 2.680530>,
      < 0.819398, 0.425256, 2.554250>,
      < 0.816296, 0.404855, 2.649039>
    }
    triangle {
      < -0.379683, 0.470362, 2.504004>,
      < -0.378037, 0.453098, 2.588279>,
      < -0.370346, 0.444959, 2.605526>
    }
    triangle {
      < -0.976372, 0.551342, 2.528678>,
      < -0.961274, 0.491229, 2.574352>,
      < -0.914157, 0.494912, 2.560705>
    }
    triangle {
      < -0.976372, 0.551342, 2.528678>,
      < -0.914157, 0.494912, 2.560705>,
      < -0.937812, 0.552421, 2.521091>
    }
    triangle {
      < -1.033102, 0.465816, 2.607353>,
      < -0.950543, 0.463118, 2.608058>,
      < -0.986746, 0.484704, 2.592602>
    }
    triangle {
      < -0.961274, 0.491229, 2.574352>,
      < -0.986746, 0.484704, 2.592602>,
      < -0.950543, 0.463118, 2.608058>
    }
    triangle {
      < -0.961274, 0.491229, 2.574352>,
      < -0.950543, 0.463118, 2.608058>,
      < -0.930255, 0.470592, 2.588926>
    }
    triangle {
      < -0.930255, 0.470592, 2.588926>,
      < -0.900545, 0.471350, 2.584866>,
      < -0.914157, 0.494912, 2.560705>
    }
    triangle {
      < -0.930255, 0.470592, 2.588926>,
      < -0.914157, 0.494912, 2.560705>,
      < -0.961274, 0.491229, 2.574352>
    }
    triangle {
      < -0.381252, 0.460833, 2.577173>,
      < -0.443789, 0.479750, 2.581917>,
      < -0.914157, 0.494912, 2.560705>
    }
    triangle {
      < -0.381252, 0.460833, 2.577173>,
      < -0.914157, 0.494912, 2.560705>,
      < -0.900545, 0.471350, 2.584866>
    }
    triangle {
      < -0.381252, 0.460833, 2.577173>,
      < -0.900545, 0.471350, 2.584866>,
      < -0.378037, 0.453098, 2.588279>
    }
    triangle {
      < -1.198795, 1.640047, 2.239476>,
      < -1.217837, 1.695050, 2.192977>,
      < -1.280637, 1.695050, 2.192977>
    }
    triangle {
      < -1.198795, 1.640047, 2.239476>,
      < -1.280637, 1.695050, 2.192977>,
      < -1.261595, 1.640047, 2.239476>
    }
    triangle {
      < -1.217837, 1.695050, 2.192977>,
      < -1.246857, 1.745054, 2.112932>,
      < -1.309657, 1.745054, 2.112932>
    }
    triangle {
      < -1.217837, 1.695050, 2.192977>,
      < -1.309657, 1.745054, 2.112932>,
      < -1.280637, 1.695050, 2.192977>
    }
    triangle {
      < -1.246857, 1.745054, 2.112932>,
      < -1.298249, 1.795061, 1.962939>,
      < -1.361049, 1.795061, 1.962939>
    }
    triangle {
      < -1.246857, 1.745054, 2.112932>,
      < -1.361049, 1.795061, 1.962939>,
      < -1.309657, 1.745054, 2.112932>
    }
    triangle {
      < -1.298249, 1.795061, 1.962939>,
      < -1.352599, 1.845075, 1.669688>,
      < -1.415399, 1.845075, 1.669688>
    }
    triangle {
      < -1.298249, 1.795061, 1.962939>,
      < -1.415399, 1.845075, 1.669688>,
      < -1.361049, 1.795061, 1.962939>
    }
    triangle {
      < -1.352599, 1.845075, 1.669688>,
      < -1.403833, 1.880095, 1.058952>,
      < -1.466633, 1.880095, 1.058952>
    }
    triangle {
      < -1.352599, 1.845075, 1.669688>,
      < -1.466633, 1.880095, 1.058952>,
      < -1.415399, 1.845075, 1.669688>
    }
    triangle {
      < -1.403833, 1.880095, 1.058952>,
      < -1.433485, 1.900125, 0.000000>,
      < -1.496285, 1.900125, 0.000000>
    }
    triangle {
      < -1.403833, 1.880095, 1.058952>,
      < -1.496285, 1.900125, 0.000000>,
      < -1.466633, 1.880095, 1.058952>
    }
    triangle {
      < -1.198795, 1.640047, 2.239476>,
      < -1.261595, 1.640047, 2.239476>,
      < -1.166484, 1.570037, 2.336873>
    }
    triangle {
      < -1.278242, 1.700844, 1.934251>,
      < -1.331573, 1.748010, 1.655882>,
      < -1.352599, 1.845075, 1.669688>
    }
    triangle {
      < -1.278242, 1.700844, 1.934251>,
      < -1.352599, 1.845075, 1.669688>,
      < -1.298249, 1.795061, 1.962939>
    }
    triangle {
      < -1.331573, 1.748010, 1.655882>,
      < -1.382452, 1.782476, 1.054004>,
      < -1.403833, 1.880095, 1.058952>
    }
    triangle {
      < -1.331573, 1.748010, 1.655882>,
      < -1.403833, 1.880095, 1.058952>,
      < -1.352599, 1.845075, 1.669688>
    }
    triangle {
      < -1.382452, 1.782476, 1.054004>,
      < -1.408941, 1.800495, 0.000000>,
      < -1.433485, 1.900125, 0.000000>
    }
    triangle {
      < -1.382452, 1.782476, 1.054004>,
      < -1.433485, 1.900125, 0.000000>,
      < -1.403833, 1.880095, 1.058952>
    }
    triangle {
      < -2.015777, 0.587300, 2.120876>,
      < -2.015709, 0.512791, 2.120956>,
      < -2.129692, 0.526073, 1.940406>
    }
    triangle {
      < -2.015777, 0.587300, 2.120876>,
      < -2.129692, 0.526073, 1.940406>,
      < -2.129741, 0.602935, 1.940372>
    }
    triangle {
      < -1.128806, 0.567268, 2.456757>,
      < -1.163142, 1.331583, 2.306517>,
      < -1.165747, 1.355034, 2.403962>
    }
    triangle {
      < -1.128806, 0.567268, 2.456757>,
      < -1.165747, 1.355034, 2.403962>,
      < -1.146178, 0.546644, 2.545252>
    }
    triangle {
      < -1.163142, 1.331583, 2.306517>,
      < -1.155437, 1.509682, 2.251191>,
      < -1.166484, 1.570037, 2.336873>
    }
    triangle {
      < -1.163142, 1.331583, 2.306517>,
      < -1.166484, 1.570037, 2.336873>,
      < -1.165747, 1.355034, 2.403962>
    }
    triangle {
      < -1.155437, 1.509682, 2.251191>,
      < -1.184809, 1.568264, 2.169792>,
      < -1.198795, 1.640047, 2.239476>
    }
    triangle {
      < -1.155437, 1.509682, 2.251191>,
      < -1.198795, 1.640047, 2.239476>,
      < -1.166484, 1.570037, 2.336873>
    }
    triangle {
      < -1.184809, 1.568264, 2.169792>,
      < -1.203585, 1.622177, 2.124300>,
      < -1.217837, 1.695050, 2.192977>
    }
    triangle {
      < -1.184809, 1.568264, 2.169792>,
      < -1.217837, 1.695050, 2.192977>,
      < -1.198795, 1.640047, 2.239476>
    }
    triangle {
      < -1.203585, 1.622177, 2.124300>,
      < -1.228930, 1.658054, 2.065620>,
      < -1.246857, 1.745054, 2.112932>
    }
    triangle {
      < -1.203585, 1.622177, 2.124300>,
      < -1.246857, 1.745054, 2.112932>,
      < -1.217837, 1.695050, 2.192977>
    }
    triangle {
      < -1.228930, 1.658054, 2.065620>,
      < -1.278242, 1.700844, 1.934251>,
      < -1.298249, 1.795061, 1.962939>
    }
    triangle {
      < -1.228930, 1.658054, 2.065620>,
      < -1.298249, 1.795061, 1.962939>,
      < -1.246857, 1.745054, 2.112932>
    }
    triangle {
      < -1.408941, 1.800495, 0.000000>,
      < -1.382452, 1.782476, 1.054004>,
      < -1.467670, 1.767479, 1.054614>
    }
    triangle {
      < -1.408941, 1.800495, 0.000000>,
      < -1.467670, 1.767479, 1.054614>,
      < -1.494550, 1.785838, 0.000000>
    }
    triangle {
      < -2.419305, 0.619042, 0.000000>,
      < -2.419312, 0.712380, 0.000000>,
      < -2.366984, 0.665475, 1.099416>
    }
    triangle {
      < -2.419305, 0.619042, 0.000000>,
      < -2.366984, 0.665475, 1.099416>,
      < -2.366911, 0.579198, 1.099482>
    }
    triangle {
      < -1.382452, 1.782476, 1.054004>,
      < -1.331573, 1.748010, 1.655882>,
      < -1.416259, 1.732549, 1.655801>
    }
    triangle {
      < -1.382452, 1.782476, 1.054004>,
      < -1.416259, 1.732549, 1.655801>,
      < -1.467670, 1.767479, 1.054614>
    }
    triangle {
      < -2.366911, 0.579198, 1.099482>,
      < -2.366984, 0.665475, 1.099416>,
      < -2.258348, 0.618570, 1.650021>
    }
    triangle {
      < -2.366911, 0.579198, 1.099482>,
      < -2.258348, 0.618570, 1.650021>,
      < -2.258311, 0.539354, 1.650110>
    }
    triangle {
      < -1.331573, 1.748010, 1.655882>,
      < -1.278242, 1.700844, 1.934251>,
      < -1.362498, 1.685040, 1.934339>
    }
    triangle {
      < -1.331573, 1.748010, 1.655882>,
      < -1.362498, 1.685040, 1.934339>,
      < -1.416259, 1.732549, 1.655801>
    }
    triangle {
      < -2.258311, 0.539354, 1.650110>,
      < -2.258348, 0.618570, 1.650021>,
      < -2.129741, 0.602935, 1.940372>
    }
    triangle {
      < -2.258311, 0.539354, 1.650110>,
      < -2.129741, 0.602935, 1.940372>,
      < -2.129692, 0.526073, 1.940406>
    }
    triangle {
      < -1.939041, 0.582088, 2.193431>,
      < -1.939025, 0.508364, 2.193487>,
      < -2.015709, 0.512791, 2.120956>
    }
    triangle {
      < -1.939041, 0.582088, 2.193431>,
      < -2.015709, 0.512791, 2.120956>,
      < -2.015777, 0.587300, 2.120876>
    }
    triangle {
      < -1.228930, 1.658054, 2.065620>,
      < -1.203585, 1.622177, 2.124300>,
      < -1.308735, 1.605871, 2.125383>
    }
    triangle {
      < -1.228930, 1.658054, 2.065620>,
      < -1.308735, 1.605871, 2.125383>,
      < -1.326746, 1.641951, 2.066452>
    }
    triangle {
      < -1.765442, 0.576877, 2.299501>,
      < -1.765427, 0.503937, 2.299581>,
      < -1.939025, 0.508364, 2.193487>
    }
    triangle {
      < -1.765442, 0.576877, 2.299501>,
      < -1.939025, 0.508364, 2.193487>,
      < -1.939041, 0.582088, 2.193431>
    }
    triangle {
      < -1.203585, 1.622177, 2.124300>,
      < -1.184809, 1.568264, 2.169792>,
      < -1.294507, 1.551115, 2.172036>
    }
    triangle {
      < -1.203585, 1.622177, 2.124300>,
      < -1.294507, 1.551115, 2.172036>,
      < -1.308735, 1.605871, 2.125383>
    }
    triangle {
      < -1.128806, 0.567268, 2.456757>,
      < -1.077008, 0.499510, 2.477921>,
      < -1.267328, 0.572570, 2.419982>
    }
    triangle {
      < -1.264699, 0.815249, 2.377412>,
      < -1.267328, 0.572570, 2.419982>,
      < -1.305959, 0.682560, 2.392979>
    }
    triangle {
      < -1.184809, 1.568264, 2.169792>,
      < -1.155437, 1.509682, 2.251191>,
      < -1.286024, 1.491526, 2.253235>
    }
    triangle {
      < -1.184809, 1.568264, 2.169792>,
      < -1.286024, 1.491526, 2.253235>,
      < -1.294507, 1.551115, 2.172036>
    }
    triangle {
      < -1.765427, 0.503937, 2.299581>,
      < -1.765442, 0.576877, 2.299501>,
      < -1.593866, 0.574271, 2.356469>
    }
    triangle {
      < -1.765427, 0.503937, 2.299581>,
      < -1.593866, 0.574271, 2.356469>,
      < -1.593830, 0.501724, 2.368387>
    }
    triangle {
      < -1.128806, 0.567268, 2.456757>,
      < -1.267328, 0.572570, 2.419982>,
      < -1.264699, 0.815249, 2.377412>
    }
    triangle {
      < -1.128806, 0.567268, 2.456757>,
      < -1.264699, 0.815249, 2.377412>,
      < -1.260465, 1.206042, 2.308860>
    }
    triangle {
      < -1.128806, 0.567268, 2.456757>,
      < -1.260465, 1.206042, 2.308860>,
      < -1.163142, 1.331583, 2.306517>
    }
    triangle {
      < -1.535205, 0.573965, 2.367879>,
      < -1.396127, 0.602132, 2.389802>,
      < -1.267328, 0.572570, 2.419982>
    }
    triangle {
      < -1.396127, 0.602132, 2.389802>,
      < -1.305959, 0.682560, 2.392979>,
      < -1.267328, 0.572570, 2.419982>
    }
    triangle {
      < -1.593830, 0.501724, 2.368387>,
      < -1.593866, 0.574271, 2.356469>,
      < -1.535205, 0.573965, 2.367879>
    }
    triangle {
      < -1.593830, 0.501724, 2.368387>,
      < -1.535205, 0.573965, 2.367879>,
      < -1.267328, 0.572570, 2.419982>
    }
    triangle {
      < -1.593830, 0.501724, 2.368387>,
      < -1.267328, 0.572570, 2.419982>,
      < -1.077008, 0.499510, 2.477921>
    }
    triangle {
      < -0.976847, 0.555205, 2.507884>,
      < -1.011091, 0.553864, 2.511151>,
      < -0.976372, 0.551342, 2.528678>
    }
    triangle {
      < -0.976847, 0.555205, 2.507884>,
      < -0.976372, 0.551342, 2.528678>,
      < -0.937812, 0.552421, 2.521091>
    }
    triangle {
      < -1.011091, 0.553864, 2.511151>,
      < -1.011921, 0.548908, 2.535374>,
      < -1.009507, 0.547531, 2.545279>
    }
    triangle {
      < -1.011091, 0.553864, 2.511151>,
      < -1.009507, 0.547531, 2.545279>,
      < -0.976372, 0.551342, 2.528678>
    }
    triangle {
      < -1.011921, 0.548908, 2.535374>,
      < -1.134118, 0.547666, 2.535246>,
      < -1.146178, 0.546644, 2.545252>
    }
    triangle {
      < -1.011921, 0.548908, 2.535374>,
      < -1.146178, 0.546644, 2.545252>,
      < -1.009507, 0.547531, 2.545279>
    }
    triangle {
      < -1.134118, 0.547666, 2.535246>,
      < -1.120671, 0.565656, 2.457738>,
      < -1.128806, 0.567268, 2.456757>
    }
    triangle {
      < -1.134118, 0.547666, 2.535246>,
      < -1.128806, 0.567268, 2.456757>,
      < -1.146178, 0.546644, 2.545252>
    }
    triangle {
      < -1.036647, 1.570330, 2.356851>,
      < -1.158844, 1.569088, 2.356722>,
      < -1.134118, 0.547666, 2.535246>
    }
    triangle {
      < -1.036647, 1.570330, 2.356851>,
      < -1.134118, 0.547666, 2.535246>,
      < -1.011921, 0.548908, 2.535374>
    }
    triangle {
      < -1.158844, 1.569088, 2.356722>,
      < -1.145396, 1.587077, 2.279214>,
      < -1.120671, 0.565656, 2.457738>
    }
    triangle {
      < -1.158844, 1.569088, 2.356722>,
      < -1.120671, 0.565656, 2.457738>,
      < -1.134118, 0.547666, 2.535246>
    }
    triangle {
      < -1.001572, 1.576626, 2.329360>,
      < -1.035817, 1.575286, 2.332628>,
      < -1.011091, 0.553864, 2.511151>
    }
    triangle {
      < -1.001572, 1.576626, 2.329360>,
      < -1.011091, 0.553864, 2.511151>,
      < -0.976847, 0.555205, 2.507884>
    }
    triangle {
      < -1.035817, 1.575286, 2.332628>,
      < -1.036647, 1.570330, 2.356851>,
      < -1.011921, 0.548908, 2.535374>
    }
    triangle {
      < -1.035817, 1.575286, 2.332628>,
      < -1.011921, 0.548908, 2.535374>,
      < -1.011091, 0.553864, 2.511151>
    }
    triangle {
      < -0.972757, 0.557578, 2.469685>,
      < -1.120671, 0.565656, 2.457738>,
      < -1.145396, 1.587077, 2.279214>
    }
    triangle {
      < -0.972757, 0.557578, 2.469685>,
      < -1.145396, 1.587077, 2.279214>,
      < -0.998839, 1.579408, 2.289442>
    }
    triangle {
      < -1.145396, 1.587077, 2.279214>,
      < -1.035817, 1.575286, 2.332628>,
      < -0.998839, 1.579408, 2.289442>
    }
    triangle {
      < -0.947583, 1.527573, 2.301732>,
      < -0.924028, 0.604633, 2.464607>,
      < -0.972757, 0.557578, 2.469685>
    }
    triangle {
      < -0.947583, 1.527573, 2.301732>,
      < -0.972757, 0.557578, 2.469685>,
      < -0.998839, 1.579408, 2.289442>
    }
    triangle {
      < -0.928116, 0.602701, 2.503510>,
      < -0.950451, 1.525363, 2.342247>,
      < -1.001572, 1.576626, 2.329360>
    }
    triangle {
      < -0.928116, 0.602701, 2.503510>,
      < -1.001572, 1.576626, 2.329360>,
      < -0.976847, 0.555205, 2.507884>
    }
    triangle {
      < 4.971003, 0.493964, 2.309541>,
      < 4.778682, 0.457080, 2.450184>,
      < 4.812309, 0.452697, 2.525539>
    }
    triangle {
      < 4.971003, 0.493964, 2.309541>,
      < 4.812309, 0.452697, 2.525539>,
      < 5.027698, 0.491304, 2.367082>
    }
    triangle {
      < 4.778682, 0.457080, 2.450184>,
      < 4.618841, 0.431370, 2.478587>,
      < 4.633741, 0.426260, 2.557898>
    }
    triangle {
      < 4.778682, 0.457080, 2.450184>,
      < 4.633741, 0.426260, 2.557898>,
      < 4.812309, 0.452697, 2.525539>
    }
    triangle {
      < 4.618841, 0.431370, 2.478587>,
      < 4.271063, 0.434863, 2.541304>,
      < 4.278938, 0.429553, 2.620985>
    }
    triangle {
      < 4.618841, 0.431370, 2.478587>,
      < 4.278938, 0.429553, 2.620985>,
      < 4.633741, 0.426260, 2.557898>
    }
    triangle {
      < 4.271063, 0.434863, 2.541304>,
      < 3.625835, 0.430011, 2.554180>,
      < 3.618461, 0.419610, 2.634592>
    }
    triangle {
      < 4.271063, 0.434863, 2.541304>,
      < 3.618461, 0.419610, 2.634592>,
      < 4.278938, 0.429553, 2.620985>
    }
    triangle {
      < 5.401163, 0.604866, 0.000000>,
      < 5.355932, 0.593194, 1.141120>,
      < 5.435663, 0.594303, 1.148942>
    }
    triangle {
      < 5.401163, 0.604866, 0.000000>,
      < 5.435663, 0.594303, 1.148942>,
      < 5.484661, 0.611664, 0.000000>
    }
    triangle {
      < 5.355932, 0.593194, 1.141120>,
      < 5.258856, 0.556459, 1.780305>,
      < 5.336588, 0.556670, 1.801338>
    }
    triangle {
      < 5.355932, 0.593194, 1.141120>,
      < 5.336588, 0.556670, 1.801338>,
      < 5.435663, 0.594303, 1.148942>
    }
    triangle {
      < 5.258856, 0.556459, 1.780305>,
      < 5.132811, 0.520019, 2.098088>,
      < 5.203112, 0.518845, 2.137795>
    }
    triangle {
      < 5.258856, 0.556459, 1.780305>,
      < 5.203112, 0.518845, 2.137795>,
      < 5.336588, 0.556670, 1.801338>
    }
    triangle {
      < 5.132811, 0.520019, 2.098088>,
      < 4.971003, 0.493964, 2.309541>,
      < 5.027698, 0.491304, 2.367082>
    }
    triangle {
      < 5.132811, 0.520019, 2.098088>,
      < 5.027698, 0.491304, 2.367082>,
      < 5.203112, 0.518845, 2.137795>
    }
    triangle {
      < 2.546063, 0.324703, 2.677072>,
      < 2.552528, 0.340104, 2.576065>,
      < 2.385818, 0.275118, 2.594347>
    }
    triangle {
      < 2.546063, 0.324703, 2.677072>,
      < 2.385818, 0.275118, 2.594347>,
      < 2.393729, 0.259716, 2.691078>
    }
    triangle {
      < 3.013547, 0.399663, 2.652796>,
      < 3.009002, 0.415065, 2.549848>,
      < 2.752269, 0.385087, 2.563607>
    }
    triangle {
      < 3.013547, 0.399663, 2.652796>,
      < 2.752269, 0.385087, 2.563607>,
      < 2.745803, 0.369686, 2.664615>
    }
    triangle {
      < 2.745803, 0.369686, 2.664615>,
      < 2.752269, 0.385087, 2.563607>,
      < 2.552528, 0.340104, 2.576065>
    }
    triangle {
      < 2.745803, 0.369686, 2.664615>,
      < 2.552528, 0.340104, 2.576065>,
      < 2.546063, 0.324703, 2.677072>
    }
    triangle {
      < -1.158844, 1.569088, 2.356722>,
      < -1.036647, 1.570330, 2.356851>,
      < -1.035817, 1.575286, 2.332628>
    }
    triangle {
      < -1.158844, 1.569088, 2.356722>,
      < -1.035817, 1.575286, 2.332628>,
      < -1.145396, 1.587077, 2.279214>
    }
    triangle {
      < -1.286024, 1.491526, 2.253235>,
      < -1.155437, 1.509682, 2.251191>,
      < -1.163142, 1.331583, 2.306517>
    }
    triangle {
      < -1.286024, 1.491526, 2.253235>,
      < -1.163142, 1.331583, 2.306517>,
      < -1.260465, 1.206042, 2.308860>
    }
    triangle {
      < -0.381252, 0.460833, 2.577173>,
      < -0.378037, 0.453098, 2.588279>,
      < -0.379683, 0.470362, 2.504004>
    }
    triangle {
      < -0.379683, 0.470362, 2.504004>,
      < -0.370346, 0.444959, 2.605526>,
      < 0.816296, 0.404855, 2.649039>
    }
    triangle {
      < -0.379683, 0.470362, 2.504004>,
      < 0.816296, 0.404855, 2.649039>,
      < 0.819398, 0.425256, 2.554250>
    }
    triangle {
      < -1.120671, 0.565656, 2.457738>,
      < -0.972757, 0.557578, 2.469685>,
      < -1.077008, 0.499510, 2.477921>
    }
    triangle {
      < -1.128806, 0.567268, 2.456757>,
      < -1.120671, 0.565656, 2.457738>,
      < -1.077008, 0.499510, 2.477921>
    }
    triangle {
      < -0.379683, 0.470362, 2.504004>,
      < -1.077008, 0.499510, 2.477921>,
      < -0.441565, 0.481225, 2.501955>
    }
    triangle {
      < -1.035817, 1.575286, 2.332628>,
      < -1.001572, 1.576626, 2.329360>,
      < -0.998839, 1.579408, 2.289442>
    }
    triangle {
      < 9.181384, 0.256832, 2.696940>,
      < 9.140353, 0.244126, 2.728450>,
      < 9.045938, 0.054134, 2.755627>
    }
    triangle {
      < 9.181384, 0.256832, 2.696940>,
      < 9.045938, 0.054134, 2.755627>,
      < 8.934355, -0.179734, 2.773799>
    }
    triangle {
      < 9.181384, 0.256832, 2.696940>,
      < 8.934355, -0.179734, 2.773799>,
      < 8.879555, -0.281976, 2.769261>
    }
    triangle {
      < 9.181384, 0.256832, 2.696940>,
      < 8.879555, -0.281976, 2.769261>,
      < 8.784227, -0.613710, 2.779588>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 8.784227, -0.613710, 2.779588>,
      < 8.735338, -0.613710, 2.826938>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 8.735338, -0.613710, 2.826938>,
      < 8.749555, -0.613710, 2.466970>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 8.749555, -0.613710, 2.466970>,
      < 8.795041, -0.613710, 2.488710>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 8.795041, -0.613710, 2.488710>,
      < 8.832082, -0.613710, 2.541341>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 8.832082, -0.613710, 2.541341>,
      < 8.842156, -0.613710, 2.604175>
    }
    triangle {
      < 8.825618, -0.613710, 2.723200>,
      < 8.842156, -0.613710, 2.604175>,
      < 8.838814, -0.613710, 2.671821>
    }
    triangle {
      < -1.261595, 1.640047, 2.239476>,
      < -1.241647, 1.550043, 2.306568>,
      < -1.166484, 1.570037, 2.336873>
    }
    triangle {
      < -1.166484, 1.570037, 2.336873>,
      < -1.241647, 1.550043, 2.306568>,
      < -1.203056, 1.340038, 2.383760>
    }
    triangle {
      < -1.166484, 1.570037, 2.336873>,
      < -1.203056, 1.340038, 2.383760>,
      < -1.165747, 1.355034, 2.403962>
    }
    triangle {
      < -0.721885, -1.894566, -2.969619>,
      < -0.708751, -2.068842, -2.887657>,
      < -0.718650, -2.068908, -2.887684>
    }
    triangle {
      < -0.721885, -1.894566, -2.969619>,
      < -0.718650, -2.068908, -2.887684>,
      < -2.184054, -2.078717, -2.891621>
    }
    triangle {
      < -0.721885, -1.894566, -2.969619>,
      < -2.184054, -2.078717, -2.891621>,
      < -2.315767, -2.068706, -2.900358>
    }
    triangle {
      < -0.721885, -1.894566, -2.969619>,
      < -2.315767, -2.068706, -2.900358>,
      < -2.423872, -2.018697, -2.918729>
    }
    triangle {
      < -0.721885, -1.894566, -2.969619>,
      < -2.423872, -2.018697, -2.918729>,
      < -2.538786, -1.898688, -2.974564>
    }
    triangle {
      < -0.717937, -2.055075, -2.859268>,
      < -2.184192, -2.064889, -2.863208>,
      < -2.184054, -2.078717, -2.891621>
    }
    triangle {
      < -0.717937, -2.055075, -2.859268>,
      < -2.184054, -2.078717, -2.891621>,
      < -0.718650, -2.068908, -2.887684>
    }
    triangle {
      < -0.717937, -2.055075, -2.859268>,
      < -0.718650, -2.068908, -2.887684>,
      < -0.708751, -2.068842, -2.887657>
    }
    triangle {
      < -2.184192, -2.064889, -2.863208>,
      < -2.315905, -2.054878, -2.871945>,
      < -2.315767, -2.068706, -2.900358>
    }
    triangle {
      < -2.184192, -2.064889, -2.863208>,
      < -2.315767, -2.068706, -2.900358>,
      < -2.184054, -2.078717, -2.891621>
    }
    triangle {
      < -2.315905, -2.054878, -2.871945>,
      < -2.424010, -2.004869, -2.890315>,
      < -2.423872, -2.018697, -2.918729>
    }
    triangle {
      < -2.315905, -2.054878, -2.871945>,
      < -2.423872, -2.018697, -2.918729>,
      < -2.315767, -2.068706, -2.900358>
    }
    triangle {
      < -2.424010, -2.004869, -2.890315>,
      < -2.538924, -1.884860, -2.946151>,
      < -2.538786, -1.898688, -2.974564>
    }
    triangle {
      < -2.424010, -2.004869, -2.890315>,
      < -2.538786, -1.898688, -2.974564>,
      < -2.423872, -2.018697, -2.918729>
    }
    triangle {
      < -0.713210, -1.880719, -2.941182>,
      < -0.721885, -1.894566, -2.969619>,
      < -2.538786, -1.898688, -2.974564>
    }
    triangle {
      < -0.713210, -1.880719, -2.941182>,
      < -2.538786, -1.898688, -2.974564>,
      < -2.538924, -1.884860, -2.946151>
    }
    triangle {
      < 3.829013, -1.870416, -2.928818>,
      < 3.827017, -1.921838, -2.901567>,
      < 3.827157, -1.935666, -2.929980>
    }
    triangle {
      < 3.829013, -1.870416, -2.928818>,
      < 3.827157, -1.935666, -2.929980>,
      < 3.829153, -1.884244, -2.957231>
    }
    triangle {
      < 3.827017, -1.921838, -2.901567>,
      < 3.789022, -1.973501, -2.874413>,
      < 3.789162, -1.987328, -2.902826>
    }
    triangle {
      < 3.827017, -1.921838, -2.901567>,
      < 3.789162, -1.987328, -2.902826>,
      < 3.827157, -1.935666, -2.929980>
    }
    triangle {
      < 3.789022, -1.973501, -2.874413>,
      < 3.715029, -2.025404, -2.847356>,
      < 3.715169, -2.039232, -2.875769>
    }
    triangle {
      < 3.789022, -1.973501, -2.874413>,
      < 3.715169, -2.039232, -2.875769>,
      < 3.789162, -1.987328, -2.902826>
    }
    triangle {
      < 0.516261, -1.891758, -2.966249>,
      < 0.535682, -1.877886, -2.937782>,
      < 1.650581, -1.875357, -2.934747>
    }
    triangle {
      < 0.516261, -1.891758, -2.966249>,
      < 1.650581, -1.875357, -2.934747>,
      < 1.644794, -1.889198, -2.963177>
    }
    triangle {
      < 0.520566, -2.060614, -2.884354>,
      < 0.516261, -1.891758, -2.966249>,
      < 1.644794, -1.889198, -2.963177>
    }
    triangle {
      < 0.520566, -2.060614, -2.884354>,
      < 1.644794, -1.889198, -2.963177>,
      < 1.650769, -2.053049, -2.881317>
    }
    triangle {
      < -0.721885, -1.894566, -2.969619>,
      < -0.713210, -1.880719, -2.941182>,
      < 0.535682, -1.877886, -2.937782>
    }
    triangle {
      < -0.721885, -1.894566, -2.969619>,
      < 0.535682, -1.877886, -2.937782>,
      < 0.516261, -1.891758, -2.966249>
    }
    triangle {
      < -0.708751, -2.068842, -2.887657>,
      < -0.721885, -1.894566, -2.969619>,
      < 0.516261, -1.891758, -2.966249>
    }
    triangle {
      < -0.708751, -2.068842, -2.887657>,
      < 0.516261, -1.891758, -2.966249>,
      < 0.520566, -2.060614, -2.884354>
    }
    triangle {
      < -0.717937, -2.055075, -2.859268>,
      < -0.708751, -2.068842, -2.887657>,
      < 0.520566, -2.060614, -2.884354>
    }
    triangle {
      < -0.717937, -2.055075, -2.859268>,
      < 0.520566, -2.060614, -2.884354>,
      < 0.527923, -2.046736, -2.855920>
    }
    triangle {
      < 1.647939, -2.039240, -2.852911>,
      < 1.650769, -2.053049, -2.881317>,
      < 3.715169, -2.039232, -2.875769>
    }
    triangle {
      < 1.647939, -2.039240, -2.852911>,
      < 3.715169, -2.039232, -2.875769>,
      < 3.715029, -2.025404, -2.847356>
    }
    triangle {
      < 1.644794, -1.889198, -2.963177>,
      < 1.650581, -1.875357, -2.934747>,
      < 3.829013, -1.870416, -2.928818>
    }
    triangle {
      < 1.644794, -1.889198, -2.963177>,
      < 3.829013, -1.870416, -2.928818>,
      < 3.829153, -1.884244, -2.957231>
    }
    triangle {
      < 1.650769, -2.053049, -2.881317>,
      < 1.644794, -1.889198, -2.963177>,
      < 3.829153, -1.884244, -2.957231>
    }
    triangle {
      < 1.650769, -2.053049, -2.881317>,
      < 3.829153, -1.884244, -2.957231>,
      < 3.827157, -1.935666, -2.929980>
    }
    triangle {
      < 1.650769, -2.053049, -2.881317>,
      < 3.827157, -1.935666, -2.929980>,
      < 3.789162, -1.987328, -2.902826>
    }
    triangle {
      < 1.650769, -2.053049, -2.881317>,
      < 3.789162, -1.987328, -2.902826>,
      < 3.715169, -2.039232, -2.875769>
    }
    triangle {
      < 1.650769, -2.053049, -2.881317>,
      < 1.647939, -2.039240, -2.852911>,
      < 0.527923, -2.046736, -2.855920>
    }
    triangle {
      < 1.650769, -2.053049, -2.881317>,
      < 0.527923, -2.046736, -2.855920>,
      < 0.520566, -2.060614, -2.884354>
    }
    triangle {
      < -2.538786, -1.898688, 2.974564>,
      < -2.423872, -2.018697, 2.918729>,
      < -2.315767, -2.068706, 2.900358>
    }
    triangle {
      < -2.538786, -1.898688, 2.974564>,
      < -2.315767, -2.068706, 2.900358>,
      < -2.184054, -2.078717, 2.891621>
    }
    triangle {
      < -2.538786, -1.898688, 2.974564>,
      < -2.184054, -2.078717, 2.891621>,
      < -0.718650, -2.068908, 2.887684>
    }
    triangle {
      < -2.538786, -1.898688, 2.974564>,
      < -0.718650, -2.068908, 2.887684>,
      < -0.708751, -2.068842, 2.887657>
    }
    triangle {
      < -2.538786, -1.898688, 2.974564>,
      < -0.708751, -2.068842, 2.887657>,
      < -0.721885, -1.894566, 2.969619>
    }
    triangle {
      < -0.708751, -2.068842, 2.887657>,
      < -0.718650, -2.068908, 2.887684>,
      < -2.184054, -2.078717, 2.891621>
    }
    triangle {
      < -0.708751, -2.068842, 2.887657>,
      < -2.184054, -2.078717, 2.891621>,
      < -2.184192, -2.064889, 2.863208>
    }
    triangle {
      < -0.708751, -2.068842, 2.887657>,
      < -2.184192, -2.064889, 2.863208>,
      < -0.717937, -2.055075, 2.859268>
    }
    triangle {
      < -2.184054, -2.078717, 2.891621>,
      < -2.315767, -2.068706, 2.900358>,
      < -2.315905, -2.054878, 2.871945>
    }
    triangle {
      < -2.184054, -2.078717, 2.891621>,
      < -2.315905, -2.054878, 2.871945>,
      < -2.184192, -2.064889, 2.863208>
    }
    triangle {
      < -2.315767, -2.068706, 2.900358>,
      < -2.423872, -2.018697, 2.918729>,
      < -2.424010, -2.004869, 2.890315>
    }
    triangle {
      < -2.315767, -2.068706, 2.900358>,
      < -2.424010, -2.004869, 2.890315>,
      < -2.315905, -2.054878, 2.871945>
    }
    triangle {
      < -2.423872, -2.018697, 2.918729>,
      < -2.538786, -1.898688, 2.974564>,
      < -2.538924, -1.884860, 2.946151>
    }
    triangle {
      < -2.423872, -2.018697, 2.918729>,
      < -2.538924, -1.884860, 2.946151>,
      < -2.424010, -2.004869, 2.890315>
    }
    triangle {
      < -2.538924, -1.884860, 2.946151>,
      < -2.538786, -1.898688, 2.974564>,
      < -0.721885, -1.894566, 2.969619>
    }
    triangle {
      < -2.538924, -1.884860, 2.946151>,
      < -0.721885, -1.894566, 2.969619>,
      < -0.713210, -1.880719, 2.941182>
    }
    triangle {
      < 3.829153, -1.884244, 2.957231>,
      < 3.827157, -1.935666, 2.929980>,
      < 3.827017, -1.921838, 2.901567>
    }
    triangle {
      < 3.829153, -1.884244, 2.957231>,
      < 3.827017, -1.921838, 2.901567>,
      < 3.829013, -1.870416, 2.928818>
    }
    triangle {
      < 3.827157, -1.935666, 2.929980>,
      < 3.789162, -1.987328, 2.902826>,
      < 3.789022, -1.973501, 2.874413>
    }
    triangle {
      < 3.827157, -1.935666, 2.929980>,
      < 3.789022, -1.973501, 2.874413>,
      < 3.827017, -1.921838, 2.901567>
    }
    triangle {
      < 3.789162, -1.987328, 2.902826>,
      < 3.715169, -2.039232, 2.875769>,
      < 3.715029, -2.025404, 2.847356>
    }
    triangle {
      < 3.789162, -1.987328, 2.902826>,
      < 3.715029, -2.025404, 2.847356>,
      < 3.789022, -1.973501, 2.874413>
    }
    triangle {
      < 1.644794, -1.889198, 2.963177>,
      < 1.650581, -1.875357, 2.934747>,
      < 0.535682, -1.877886, 2.937782>
    }
    triangle {
      < 1.644794, -1.889198, 2.963177>,
      < 0.535682, -1.877886, 2.937782>,
      < 0.516261, -1.891758, 2.966249>
    }
    triangle {
      < 1.650769, -2.053049, 2.881317>,
      < 1.644794, -1.889198, 2.963177>,
      < 0.516261, -1.891758, 2.966249>
    }
    triangle {
      < 1.650769, -2.053049, 2.881317>,
      < 0.516261, -1.891758, 2.966249>,
      < 0.520566, -2.060614, 2.884354>
    }
    triangle {
      < 0.516261, -1.891758, 2.966249>,
      < 0.535682, -1.877886, 2.937782>,
      < -0.713210, -1.880719, 2.941182>
    }
    triangle {
      < 0.516261, -1.891758, 2.966249>,
      < -0.713210, -1.880719, 2.941182>,
      < -0.721885, -1.894566, 2.969619>
    }
    triangle {
      < 0.520566, -2.060614, 2.884354>,
      < 0.516261, -1.891758, 2.966249>,
      < -0.721885, -1.894566, 2.969619>
    }
    triangle {
      < 0.520566, -2.060614, 2.884354>,
      < -0.721885, -1.894566, 2.969619>,
      < -0.708751, -2.068842, 2.887657>
    }
    triangle {
      < 0.527923, -2.046736, 2.855920>,
      < 0.520566, -2.060614, 2.884354>,
      < -0.708751, -2.068842, 2.887657>
    }
    triangle {
      < 0.527923, -2.046736, 2.855920>,
      < -0.708751, -2.068842, 2.887657>,
      < -0.717937, -2.055075, 2.859268>
    }
    triangle {
      < 3.715029, -2.025404, 2.847356>,
      < 3.715169, -2.039232, 2.875769>,
      < 1.650769, -2.053049, 2.881317>
    }
    triangle {
      < 3.715029, -2.025404, 2.847356>,
      < 1.650769, -2.053049, 2.881317>,
      < 1.647939, -2.039240, 2.852911>
    }
    triangle {
      < 3.829153, -1.884244, 2.957231>,
      < 3.829013, -1.870416, 2.928818>,
      < 1.650581, -1.875357, 2.934747>
    }
    triangle {
      < 3.829153, -1.884244, 2.957231>,
      < 1.650581, -1.875357, 2.934747>,
      < 1.644794, -1.889198, 2.963177>
    }
    triangle {
      < 3.715169, -2.039232, 2.875769>,
      < 3.789162, -1.987328, 2.902826>,
      < 3.827157, -1.935666, 2.929980>
    }
    triangle {
      < 3.715169, -2.039232, 2.875769>,
      < 3.827157, -1.935666, 2.929980>,
      < 3.829153, -1.884244, 2.957231>
    }
    triangle {
      < 3.715169, -2.039232, 2.875769>,
      < 3.829153, -1.884244, 2.957231>,
      < 1.644794, -1.889198, 2.963177>
    }
    triangle {
      < 3.715169, -2.039232, 2.875769>,
      < 1.644794, -1.889198, 2.963177>,
      < 1.650769, -2.053049, 2.881317>
    }
    triangle {
      < 0.520566, -2.060614, 2.884354>,
      < 0.527923, -2.046736, 2.855920>,
      < 1.647939, -2.039240, 2.852911>
    }
    triangle {
      < 0.520566, -2.060614, 2.884354>,
      < 1.647939, -2.039240, 2.852911>,
      < 1.650769, -2.053049, 2.881317>
    }
    triangle {
      < -6.957200, -1.046400, -1.886322>,
      < -6.889045, -1.016069, -1.887884>,
      < -6.896595, -1.040784, -1.889553>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.681404, -0.959091, -1.884111>,
      < -6.684243, -0.934667, -1.872683>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.684243, -0.934667, -1.872683>,
      < -6.688840, -0.904705, -1.848373>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.688840, -0.904705, -1.848373>,
      < -6.693665, -0.880174, -1.818666>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.693665, -0.880174, -1.818666>,
      < -6.698531, -0.862017, -1.784707>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.698531, -0.862017, -1.784707>,
      < -6.703252, -0.850934, -1.747799>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.703252, -0.850934, -1.747799>,
      < -6.707646, -0.847349, -1.709360>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.707646, -0.847349, -1.709360>,
      < -6.711545, -0.851400, -1.670869>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.711545, -0.851400, -1.670869>,
      < -6.714800, -0.862931, -1.633802>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.714800, -0.862931, -1.633802>,
      < -6.717284, -0.881500, -1.599587>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.717284, -0.881500, -1.599587>,
      < -6.718902, -0.906393, -1.569538>
    }
    triangle {
      < -6.719573, -0.940856, -1.542431>,
      < -6.718902, -0.906393, -1.569538>,
      < -6.719593, -0.936652, -1.544807>
    }
    triangle {
      < -6.824115, -0.973820, -1.879564>,
      < -6.979515, -0.982234, -1.872808>,
      < -6.989600, -0.953247, -1.856404>
    }
    triangle {
      < -6.824115, -0.973820, -1.879564>,
      < -6.989600, -0.953247, -1.856404>,
      < -6.684243, -0.934667, -1.872683>
    }
    triangle {
      < -6.824115, -0.973820, -1.879564>,
      < -6.684243, -0.934667, -1.872683>,
      < -6.681404, -0.959091, -1.884111>
    }
    triangle {
      < -6.989600, -0.953247, -1.561195>,
      < -6.979515, -0.982234, -1.544791>,
      < -6.873342, -0.960375, -1.545218>
    }
    triangle {
      < -6.989600, -0.953247, -1.561195>,
      < -6.873342, -0.960375, -1.545218>,
      < -6.719573, -0.940856, -1.542431>
    }
    triangle {
      < -6.989600, -0.953247, -1.561195>,
      < -6.719573, -0.940856, -1.542431>,
      < -6.719593, -0.936652, -1.544807>
    }
    triangle {
      < -6.979515, -0.982234, -1.544791>,
      < -6.968577, -1.013689, -1.534689>,
      < -6.929565, -1.005945, -1.532979>
    }
    triangle {
      < -6.979515, -0.982234, -1.544791>,
      < -6.929565, -1.005945, -1.532979>,
      < -6.918159, -0.988035, -1.537767>
    }
    triangle {
      < -6.937382, -1.042666, -1.529858>,
      < -6.929565, -1.005945, -1.532979>,
      < -6.968577, -1.013689, -1.534689>
    }
    triangle {
      < -6.937382, -1.042666, -1.529858>,
      < -6.968577, -1.013689, -1.534689>,
      < -6.957200, -1.046400, -1.531278>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.945790, -1.113369, -1.544791>,
      < -6.709462, -1.123200, -1.525288>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.709462, -1.123200, -1.525288>,
      < -6.709947, -1.118215, -1.523827>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.709947, -1.118215, -1.523827>,
      < -6.855919, -1.112782, -1.535495>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.855919, -1.112782, -1.535495>,
      < -6.910044, -1.088383, -1.532162>
    }
    triangle {
      < -6.945790, -1.113369, -1.872808>,
      < -6.951384, -1.080540, -1.882911>,
      < -6.859628, -1.081052, -1.887577>
    }
    triangle {
      < -6.945790, -1.113369, -1.872808>,
      < -6.859628, -1.081052, -1.887577>,
      < -6.818439, -1.096457, -1.886577>
    }
    triangle {
      < -6.703252, -0.850934, -1.747799>,
      < -7.014389, -0.881949, -1.743432>,
      < -7.015512, -0.878727, -1.708800>
    }
    triangle {
      < -6.703252, -0.850934, -1.747799>,
      < -7.015512, -0.878727, -1.708800>,
      < -6.707646, -0.847349, -1.709360>
    }
    triangle {
      < -6.707646, -0.847349, -1.709360>,
      < -7.015512, -0.878727, -1.708800>,
      < -7.014389, -0.881949, -1.674167>
    }
    triangle {
      < -6.707646, -0.847349, -1.709360>,
      < -7.014389, -0.881949, -1.674167>,
      < -6.711545, -0.851400, -1.670869>
    }
    triangle {
      < -7.011074, -0.891490, -1.776734>,
      < -7.014389, -0.881949, -1.743432>,
      < -6.703252, -0.850934, -1.747799>
    }
    triangle {
      < -7.011074, -0.891490, -1.776734>,
      < -6.703252, -0.850934, -1.747799>,
      < -6.698531, -0.862017, -1.784707>
    }
    triangle {
      < -6.711545, -0.851400, -1.670869>,
      < -7.014389, -0.881949, -1.674167>,
      < -7.011074, -0.891490, -1.640865>
    }
    triangle {
      < -6.711545, -0.851400, -1.670869>,
      < -7.011074, -0.891490, -1.640865>,
      < -6.714800, -0.862931, -1.633802>
    }
    triangle {
      < -6.693665, -0.880174, -1.818666>,
      < -7.005685, -0.906986, -1.807425>,
      < -7.011074, -0.891490, -1.776734>
    }
    triangle {
      < -6.693665, -0.880174, -1.818666>,
      < -7.011074, -0.891490, -1.776734>,
      < -6.698531, -0.862017, -1.784707>
    }
    triangle {
      < -6.714800, -0.862931, -1.633802>,
      < -7.011074, -0.891490, -1.640865>,
      < -7.005685, -0.906986, -1.610173>
    }
    triangle {
      < -6.714800, -0.862931, -1.633802>,
      < -7.005685, -0.906986, -1.610173>,
      < -6.717284, -0.881500, -1.599587>
    }
    triangle {
      < -7.051667, -0.890230, -1.674169>,
      < -7.014389, -0.881949, -1.674167>,
      < -7.015512, -0.878727, -1.708800>
    }
    triangle {
      < -7.051667, -0.890230, -1.674169>,
      < -7.015512, -0.878727, -1.708800>,
      < -7.053440, -0.887290, -1.708800>
    }
    triangle {
      < -7.053440, -0.887290, -1.708800>,
      < -7.015512, -0.878727, -1.708800>,
      < -7.014389, -0.881949, -1.743432>
    }
    triangle {
      < -7.053440, -0.887290, -1.708800>,
      < -7.014389, -0.881949, -1.743432>,
      < -7.051696, -0.890201, -1.743434>
    }
    triangle {
      < -6.998435, -0.927838, -1.834327>,
      < -7.005685, -0.906986, -1.807425>,
      < -6.693665, -0.880174, -1.818666>
    }
    triangle {
      < -6.998435, -0.927838, -1.834327>,
      < -6.693665, -0.880174, -1.818666>,
      < -6.688840, -0.904705, -1.848373>
    }
    triangle {
      < -6.717284, -0.881500, -1.599587>,
      < -7.005685, -0.906986, -1.610173>,
      < -6.998435, -0.927838, -1.583273>
    }
    triangle {
      < -6.717284, -0.881500, -1.599587>,
      < -6.998435, -0.927838, -1.583273>,
      < -6.718902, -0.906393, -1.569538>
    }
    triangle {
      < -7.051667, -0.890230, -1.674169>,
      < -7.046462, -0.898906, -1.640872>,
      < -7.011074, -0.891490, -1.640865>
    }
    triangle {
      < -7.051667, -0.890230, -1.674169>,
      < -7.011074, -0.891490, -1.640865>,
      < -7.014389, -0.881949, -1.674167>
    }
    triangle {
      < -7.051696, -0.890201, -1.743434>,
      < -7.014389, -0.881949, -1.743432>,
      < -7.011074, -0.891490, -1.776734>
    }
    triangle {
      < -7.051696, -0.890201, -1.743434>,
      < -7.011074, -0.891490, -1.776734>,
      < -7.046517, -0.898849, -1.776742>
    }
    triangle {
      < -7.046517, -0.898849, -1.776742>,
      < -7.011074, -0.891490, -1.776734>,
      < -7.005685, -0.906986, -1.807425>
    }
    triangle {
      < -7.046517, -0.898849, -1.776742>,
      < -7.005685, -0.906986, -1.807425>,
      < -7.038095, -0.912906, -1.807443>
    }
    triangle {
      < -7.046462, -0.898906, -1.640872>,
      < -7.038013, -0.912989, -1.610191>,
      < -7.005685, -0.906986, -1.610173>
    }
    triangle {
      < -7.046462, -0.898906, -1.640872>,
      < -7.005685, -0.906986, -1.610173>,
      < -7.011074, -0.891490, -1.640865>
    }
    triangle {
      < -6.989600, -0.953247, -1.856404>,
      < -6.998435, -0.927838, -1.834327>,
      < -6.688840, -0.904705, -1.848373>
    }
    triangle {
      < -6.989600, -0.953247, -1.856404>,
      < -6.688840, -0.904705, -1.848373>,
      < -6.684243, -0.934667, -1.872683>
    }
    triangle {
      < -6.718902, -0.906393, -1.569538>,
      < -6.998435, -0.927838, -1.583273>,
      < -6.989600, -0.953247, -1.561195>
    }
    triangle {
      < -6.718902, -0.906393, -1.569538>,
      < -6.989600, -0.953247, -1.561195>,
      < -6.719593, -0.936652, -1.544807>
    }
    triangle {
      < -7.038095, -0.912906, -1.807443>,
      < -7.005685, -0.906986, -1.807425>,
      < -6.998435, -0.927838, -1.834327>
    }
    triangle {
      < -7.038095, -0.912906, -1.807443>,
      < -6.998435, -0.927838, -1.834327>,
      < -7.026746, -0.931825, -1.834356>
    }
    triangle {
      < -7.038013, -0.912989, -1.610191>,
      < -7.026640, -0.931931, -1.583303>,
      < -6.998435, -0.927838, -1.583273>
    }
    triangle {
      < -7.038013, -0.912989, -1.610191>,
      < -6.998435, -0.927838, -1.583273>,
      < -7.005685, -0.906986, -1.610173>
    }
    triangle {
      < -7.026746, -0.931825, -1.834356>,
      < -6.998435, -0.927838, -1.834327>,
      < -6.989600, -0.953247, -1.856404>
    }
    triangle {
      < -7.026746, -0.931825, -1.834356>,
      < -6.989600, -0.953247, -1.856404>,
      < -7.012914, -0.954885, -1.856449>
    }
    triangle {
      < -7.012788, -0.955009, -1.561241>,
      < -6.989600, -0.953247, -1.561195>,
      < -6.998435, -0.927838, -1.583273>
    }
    triangle {
      < -7.012788, -0.955009, -1.561241>,
      < -6.998435, -0.927838, -1.583273>,
      < -7.026640, -0.931931, -1.583303>
    }
    triangle {
      < -6.996993, -0.981333, -1.544854>,
      < -6.979515, -0.982234, -1.544791>,
      < -6.989600, -0.953247, -1.561195>
    }
    triangle {
      < -6.996993, -0.981333, -1.544854>,
      < -6.989600, -0.953247, -1.561195>,
      < -7.012788, -0.955009, -1.561241>
    }
    triangle {
      < -7.012914, -0.954885, -1.856449>,
      < -6.989600, -0.953247, -1.856404>,
      < -6.979515, -0.982234, -1.872808>
    }
    triangle {
      < -7.012914, -0.954885, -1.856449>,
      < -6.979515, -0.982234, -1.872808>,
      < -6.997129, -0.981196, -1.872871>
    }
    triangle {
      < -6.980002, -1.009749, -1.882993>,
      < -6.997129, -0.981196, -1.872871>,
      < -6.979515, -0.982234, -1.872808>
    }
    triangle {
      < -6.980002, -1.009749, -1.882993>,
      < -6.979515, -0.982234, -1.872808>,
      < -6.968577, -1.013689, -1.882911>
    }
    triangle {
      < -6.996993, -0.981333, -1.544854>,
      < -6.979856, -1.009895, -1.534771>,
      < -6.968577, -1.013689, -1.534689>
    }
    triangle {
      < -6.996993, -0.981333, -1.544854>,
      < -6.968577, -1.013689, -1.534689>,
      < -6.979515, -0.982234, -1.544791>
    }
    triangle {
      < -6.957200, -1.046400, -1.886322>,
      < -6.980002, -1.009749, -1.882993>,
      < -6.968577, -1.013689, -1.882911>
    }
    triangle {
      < -6.968577, -1.013689, -1.534689>,
      < -6.979856, -1.009895, -1.534771>,
      < -6.957200, -1.046400, -1.531278>
    }
    triangle {
      < -6.709462, -1.123200, -1.525288>,
      < -6.945790, -1.113369, -1.544791>,
      < -6.940633, -1.143624, -1.561195>
    }
    triangle {
      < -6.709462, -1.123200, -1.525288>,
      < -6.940633, -1.143624, -1.561195>,
      < -6.705269, -1.157442, -1.543269>
    }
    triangle {
      < -6.940633, -1.143624, -1.856404>,
      < -6.945790, -1.113369, -1.872808>,
      < -6.670184, -1.120993, -1.889604>
    }
    triangle {
      < -6.940633, -1.143624, -1.856404>,
      < -6.670184, -1.120993, -1.889604>,
      < -6.669919, -1.155457, -1.871145>
    }
    triangle {
      < -6.936112, -1.170142, -1.834327>,
      < -6.940633, -1.143624, -1.856404>,
      < -6.669919, -1.155457, -1.871145>
    }
    triangle {
      < -6.936112, -1.170142, -1.834327>,
      < -6.669919, -1.155457, -1.871145>,
      < -6.670609, -1.185717, -1.846416>
    }
    triangle {
      < -6.705269, -1.157442, -1.543269>,
      < -6.940633, -1.143624, -1.561195>,
      < -6.936112, -1.170142, -1.583273>
    }
    triangle {
      < -6.705269, -1.157442, -1.543269>,
      < -6.936112, -1.170142, -1.583273>,
      < -6.700672, -1.187404, -1.567580>
    }
    triangle {
      < -6.700672, -1.187404, -1.567580>,
      < -6.936112, -1.170142, -1.583273>,
      < -6.932407, -1.191906, -1.610173>
    }
    triangle {
      < -6.700672, -1.187404, -1.567580>,
      < -6.932407, -1.191906, -1.610173>,
      < -6.695848, -1.211935, -1.597286>
    }
    triangle {
      < -6.932407, -1.191906, -1.807425>,
      < -6.936112, -1.170142, -1.834327>,
      < -6.670609, -1.185717, -1.846416>
    }
    triangle {
      < -6.932407, -1.191906, -1.807425>,
      < -6.670609, -1.185717, -1.846416>,
      < -6.672227, -1.210609, -1.816365>
    }
    triangle {
      < -6.929648, -1.208078, -1.776734>,
      < -6.932407, -1.191906, -1.807425>,
      < -6.672227, -1.210609, -1.816365>
    }
    triangle {
      < -6.929648, -1.208078, -1.776734>,
      < -6.672227, -1.210609, -1.816365>,
      < -6.674712, -1.229178, -1.782150>
    }
    triangle {
      < -6.932407, -1.191906, -1.610173>,
      < -6.929648, -1.208078, -1.640865>,
      < -6.690980, -1.230092, -1.631245>
    }
    triangle {
      < -6.932407, -1.191906, -1.610173>,
      < -6.690980, -1.230092, -1.631245>,
      < -6.695848, -1.211935, -1.597286>
    }
    triangle {
      < -6.927948, -1.218035, -1.743432>,
      < -6.929648, -1.208078, -1.776734>,
      < -6.674712, -1.229178, -1.782150>
    }
    triangle {
      < -6.927948, -1.218035, -1.743432>,
      < -6.674712, -1.229178, -1.782150>,
      < -6.677966, -1.240708, -1.745084>
    }
    triangle {
      < -6.929648, -1.208078, -1.640865>,
      < -6.927948, -1.218035, -1.674167>,
      < -6.686260, -1.241175, -1.668154>
    }
    triangle {
      < -6.929648, -1.208078, -1.640865>,
      < -6.686260, -1.241175, -1.668154>,
      < -6.690980, -1.230092, -1.631245>
    }
    triangle {
      < -6.927948, -1.218035, -1.674167>,
      < -6.927377, -1.221398, -1.708800>,
      < -6.681865, -1.244760, -1.706593>
    }
    triangle {
      < -6.927948, -1.218035, -1.674167>,
      < -6.681865, -1.244760, -1.706593>,
      < -6.686260, -1.241175, -1.668154>
    }
    triangle {
      < -6.927377, -1.221398, -1.708800>,
      < -6.927948, -1.218035, -1.743432>,
      < -6.677966, -1.240708, -1.745084>
    }
    triangle {
      < -6.927377, -1.221398, -1.708800>,
      < -6.677966, -1.240708, -1.745084>,
      < -6.681865, -1.244760, -1.706593>
    }
    triangle {
      < -7.007535, -0.965069, -0.566291>,
      < -6.986362, -0.939410, -0.565277>,
      < -6.873365, -0.975844, -1.497088>
    }
    triangle {
      < -7.007535, -0.965069, -0.566291>,
      < -6.873365, -0.975844, -1.497088>,
      < -6.893028, -0.987278, -1.493569>
    }
    triangle {
      < -6.845813, -1.005988, -1.924408>,
      < -6.838296, -1.009549, -1.997098>,
      < -6.850076, -1.024404, -1.997098>
    }
    triangle {
      < -6.845813, -1.005988, -1.924408>,
      < -6.850076, -1.024404, -1.997098>,
      < -6.857940, -1.021441, -1.925642>
    }
    triangle {
      < -6.818653, -0.996843, -1.997098>,
      < -6.838296, -1.009549, -1.997098>,
      < -6.845813, -1.005988, -1.924408>
    }
    triangle {
      < -6.818653, -0.996843, -1.997098>,
      < -6.845813, -1.005988, -1.924408>,
      < -6.819091, -0.991846, -1.922870>
    }
    triangle {
      < -7.020231, -0.995068, -0.566114>,
      < -7.007535, -0.965069, -0.566291>,
      < -6.893028, -0.987278, -1.493569>
    }
    triangle {
      < -7.020231, -0.995068, -0.566114>,
      < -6.893028, -0.987278, -1.493569>,
      < -6.910412, -1.014001, -1.489675>
    }
    triangle {
      < -6.862194, -1.039120, -1.926475>,
      < -6.853990, -1.041407, -1.997098>,
      < -6.849533, -1.056659, -1.997098>
    }
    triangle {
      < -6.862194, -1.039120, -1.926475>,
      < -6.849533, -1.056659, -1.997098>,
      < -6.858163, -1.055314, -1.926427>
    }
    triangle {
      < -7.019647, -1.060207, -0.564746>,
      < -7.024446, -1.029407, -0.564746>,
      < -6.914555, -1.037143, -1.488165>
    }
    triangle {
      < -7.019647, -1.060207, -0.564746>,
      < -6.914555, -1.037143, -1.488165>,
      < -6.909965, -1.057920, -1.488270>
    }
    triangle {
      < -6.858163, -1.055314, -1.926427>,
      < -6.849533, -1.056659, -1.997098>,
      < -6.831825, -1.071315, -1.997098>
    }
    triangle {
      < -6.858163, -1.055314, -1.926427>,
      < -6.831825, -1.071315, -1.997098>,
      < -6.841156, -1.070764, -1.925938>
    }
    triangle {
      < -6.841156, -1.070764, -1.925938>,
      < -6.831825, -1.071315, -1.997098>,
      < -6.800754, -1.085972, -1.997098>
    }
    triangle {
      < -6.841156, -1.070764, -1.925938>,
      < -6.800754, -1.085972, -1.997098>,
      < -6.810749, -1.086163, -1.925392>
    }
    triangle {
      < -6.967073, -1.119405, -0.562333>,
      < -7.000562, -1.089806, -0.563539>,
      < -6.891643, -1.077870, -1.488896>
    }
    triangle {
      < -6.967073, -1.119405, -0.562333>,
      < -6.891643, -1.077870, -1.488896>,
      < -6.859421, -1.097765, -1.491009>
    }
    triangle {
      < -6.967073, -1.119405, -0.562333>,
      < -6.859421, -1.097765, -1.491009>,
      < -6.715765, -1.102988, -1.479291>
    }
    triangle {
      < -6.967073, -1.119405, -0.562333>,
      < -6.715765, -1.102988, -1.479291>,
      < -6.813701, -1.126607, -0.559919>
    }
    triangle {
      < -6.810749, -1.086163, -1.925392>,
      < -6.800754, -1.085972, -1.997098>,
      < -6.658443, -1.089538, -1.997098>
    }
    triangle {
      < -6.810749, -1.086163, -1.925392>,
      < -6.658443, -1.089538, -1.997098>,
      < -6.666987, -1.091349, -1.930437>
    }
    triangle {
      < -6.986362, -0.939410, -0.565277>,
      < -6.827199, -0.899603, -0.552779>,
      < -6.723890, -0.950218, -1.496050>
    }
    triangle {
      < -6.986362, -0.939410, -0.565277>,
      < -6.723890, -0.950218, -1.496050>,
      < -6.873365, -0.975844, -1.497088>
    }
    triangle {
      < -6.667999, -0.977043, -1.997098>,
      < -6.818653, -0.996843, -1.997098>,
      < -6.819091, -0.991846, -1.922870>
    }
    triangle {
      < -6.667999, -0.977043, -1.997098>,
      < -6.819091, -0.991846, -1.922870>,
      < -6.675989, -0.973215, -1.925578>
    }
    triangle {
      < -6.663667, -0.982041, -2.032474>,
      < -6.808182, -1.000110, -2.032474>,
      < -6.818653, -0.996843, -1.997098>
    }
    triangle {
      < -6.663667, -0.982041, -2.032474>,
      < -6.818653, -0.996843, -1.997098>,
      < -6.667999, -0.977043, -1.997098>
    }
    triangle {
      < -6.663667, -0.982041, -2.032474>,
      < -6.667999, -0.977043, -1.997098>,
      < -6.658443, -1.089538, -1.997098>
    }
    triangle {
      < -6.663667, -0.982041, -2.032474>,
      < -6.658443, -1.089538, -1.997098>,
      < -6.654500, -1.084699, -2.032474>
    }
    triangle {
      < -6.660625, -0.991222, -2.060670>,
      < -6.663667, -0.982041, -2.032474>,
      < -6.654500, -1.084699, -2.032474>
    }
    triangle {
      < -6.660625, -0.991222, -2.060670>,
      < -6.654500, -1.084699, -2.032474>,
      < -6.652500, -1.075653, -2.060670>
    }
    triangle {
      < -6.660625, -0.991222, -2.060670>,
      < -6.788721, -1.006083, -2.060670>,
      < -6.808182, -1.000110, -2.032474>
    }
    triangle {
      < -6.660625, -0.991222, -2.060670>,
      < -6.808182, -1.000110, -2.032474>,
      < -6.663667, -0.982041, -2.032474>
    }
    triangle {
      < -6.747930, -1.016658, -2.081717>,
      < -6.788721, -1.006083, -2.060670>,
      < -6.660625, -0.991222, -2.060670>
    }
    triangle {
      < -6.747930, -1.016658, -2.081717>,
      < -6.660625, -0.991222, -2.060670>,
      < -6.658353, -1.007446, -2.081717>
    }
    triangle {
      < -6.658353, -1.007446, -2.081717>,
      < -6.660625, -0.991222, -2.060670>,
      < -6.652500, -1.075653, -2.060670>
    }
    triangle {
      < -6.658353, -1.007446, -2.081717>,
      < -6.652500, -1.075653, -2.060670>,
      < -6.652669, -1.059781, -2.081717>
    }
    triangle {
      < -6.827026, -1.011704, -2.032474>,
      < -6.838296, -1.009549, -1.997098>,
      < -6.818653, -0.996843, -1.997098>
    }
    triangle {
      < -6.827026, -1.011704, -2.032474>,
      < -6.818653, -0.996843, -1.997098>,
      < -6.808182, -1.000110, -2.032474>
    }
    triangle {
      < -6.805425, -1.015619, -2.060670>,
      < -6.827026, -1.011704, -2.032474>,
      < -6.808182, -1.000110, -2.032474>
    }
    triangle {
      < -6.805425, -1.015619, -2.060670>,
      < -6.808182, -1.000110, -2.032474>,
      < -6.788721, -1.006083, -2.060670>
    }
    triangle {
      < -6.759613, -1.022568, -2.081717>,
      < -6.805425, -1.015619, -2.060670>,
      < -6.788721, -1.006083, -2.060670>
    }
    triangle {
      < -6.759613, -1.022568, -2.081717>,
      < -6.788721, -1.006083, -2.060670>,
      < -6.747930, -1.016658, -2.081717>
    }
    triangle {
      < -6.654481, -1.034126, -2.091248>,
      < -6.658353, -1.007446, -2.081717>,
      < -6.652669, -1.059781, -2.081717>
    }
    triangle {
      < -6.747930, -1.016658, -2.081717>,
      < -6.658353, -1.007446, -2.081717>,
      < -6.654481, -1.034126, -2.091248>
    }
    triangle {
      < -6.827026, -1.011704, -2.032474>,
      < -6.838327, -1.025260, -2.032474>,
      < -6.850076, -1.024404, -1.997098>
    }
    triangle {
      < -6.827026, -1.011704, -2.032474>,
      < -6.850076, -1.024404, -1.997098>,
      < -6.838296, -1.009549, -1.997098>
    }
    triangle {
      < -6.805425, -1.015619, -2.060670>,
      < -6.815441, -1.026767, -2.060670>,
      < -6.838327, -1.025260, -2.032474>
    }
    triangle {
      < -6.805425, -1.015619, -2.060670>,
      < -6.838327, -1.025260, -2.032474>,
      < -6.827026, -1.011704, -2.032474>
    }
    triangle {
      < -6.759613, -1.022568, -2.081717>,
      < -6.766614, -1.029479, -2.081717>,
      < -6.815441, -1.026767, -2.060670>
    }
    triangle {
      < -6.759613, -1.022568, -2.081717>,
      < -6.815441, -1.026767, -2.060670>,
      < -6.805425, -1.015619, -2.060670>
    }
    triangle {
      < -6.759613, -1.022568, -2.081717>,
      < -6.747930, -1.016658, -2.081717>,
      < -6.654481, -1.034126, -2.091248>
    }
    triangle {
      < -6.766614, -1.029479, -2.081717>,
      < -6.759613, -1.022568, -2.081717>,
      < -6.654481, -1.034126, -2.091248>
    }
    triangle {
      < -6.838327, -1.025260, -2.032474>,
      < -6.842080, -1.040777, -2.032474>,
      < -6.853990, -1.041407, -1.997098>
    }
    triangle {
      < -6.838327, -1.025260, -2.032474>,
      < -6.853990, -1.041407, -1.997098>,
      < -6.850076, -1.024404, -1.997098>
    }
    triangle {
      < -6.815441, -1.026767, -2.060670>,
      < -6.818767, -1.039529, -2.060670>,
      < -6.842080, -1.040777, -2.032474>
    }
    triangle {
      < -6.815441, -1.026767, -2.060670>,
      < -6.842080, -1.040777, -2.032474>,
      < -6.838327, -1.025260, -2.032474>
    }
    triangle {
      < -6.766614, -1.029479, -2.081717>,
      < -6.768942, -1.037389, -2.081717>,
      < -6.818767, -1.039529, -2.060670>
    }
    triangle {
      < -6.766614, -1.029479, -2.081717>,
      < -6.818767, -1.039529, -2.060670>,
      < -6.815441, -1.026767, -2.060670>
    }
    triangle {
      < -6.768942, -1.037389, -2.081717>,
      < -6.766614, -1.029479, -2.081717>,
      < -6.654481, -1.034126, -2.091248>
    }
    triangle {
      < -6.654481, -1.034126, -2.091248>,
      < -6.652669, -1.059781, -2.081717>,
      < -6.737285, -1.058122, -2.081717>
    }
    triangle {
      < -6.654481, -1.034126, -2.091248>,
      < -6.755765, -1.051304, -2.081717>,
      < -6.766294, -1.044485, -2.081717>
    }
    triangle {
      < -6.654481, -1.034126, -2.091248>,
      < -6.737285, -1.058122, -2.081717>,
      < -6.755765, -1.051304, -2.081717>
    }
    triangle {
      < -6.654481, -1.034126, -2.091248>,
      < -6.766294, -1.044485, -2.081717>,
      < -6.768942, -1.037389, -2.081717>
    }
    triangle {
      < -6.768942, -1.037389, -2.081717>,
      < -6.766294, -1.044485, -2.081717>,
      < -6.814979, -1.050976, -2.060670>
    }
    triangle {
      < -6.768942, -1.037389, -2.081717>,
      < -6.814979, -1.050976, -2.060670>,
      < -6.818767, -1.039529, -2.060670>
    }
    triangle {
      < -6.818767, -1.039529, -2.060670>,
      < -6.814979, -1.050976, -2.060670>,
      < -6.837805, -1.054695, -2.032474>
    }
    triangle {
      < -6.818767, -1.039529, -2.060670>,
      < -6.837805, -1.054695, -2.032474>,
      < -6.842080, -1.040777, -2.032474>
    }
    triangle {
      < -6.842080, -1.040777, -2.032474>,
      < -6.837805, -1.054695, -2.032474>,
      < -6.849533, -1.056659, -1.997098>
    }
    triangle {
      < -6.842080, -1.040777, -2.032474>,
      < -6.849533, -1.056659, -1.997098>,
      < -6.853990, -1.041407, -1.997098>
    }
    triangle {
      < -6.766294, -1.044485, -2.081717>,
      < -6.755765, -1.051304, -2.081717>,
      < -6.799923, -1.061977, -2.060670>
    }
    triangle {
      < -6.766294, -1.044485, -2.081717>,
      < -6.799923, -1.061977, -2.060670>,
      < -6.814979, -1.050976, -2.060670>
    }
    triangle {
      < -6.814979, -1.050976, -2.060670>,
      < -6.799923, -1.061977, -2.060670>,
      < -6.820820, -1.068070, -2.032474>
    }
    triangle {
      < -6.814979, -1.050976, -2.060670>,
      < -6.820820, -1.068070, -2.032474>,
      < -6.837805, -1.054695, -2.032474>
    }
    triangle {
      < -6.755765, -1.051304, -2.081717>,
      < -6.737285, -1.058122, -2.081717>,
      < -6.773502, -1.072977, -2.060670>
    }
    triangle {
      < -6.755765, -1.051304, -2.081717>,
      < -6.773502, -1.072977, -2.060670>,
      < -6.799923, -1.061977, -2.060670>
    }
    triangle {
      < -6.837805, -1.054695, -2.032474>,
      < -6.820820, -1.068070, -2.032474>,
      < -6.831825, -1.071315, -1.997098>
    }
    triangle {
      < -6.837805, -1.054695, -2.032474>,
      < -6.831825, -1.071315, -1.997098>,
      < -6.849533, -1.056659, -1.997098>
    }
    triangle {
      < -6.737285, -1.058122, -2.081717>,
      < -6.652669, -1.059781, -2.081717>,
      < -6.652500, -1.075653, -2.060670>
    }
    triangle {
      < -6.737285, -1.058122, -2.081717>,
      < -6.652500, -1.075653, -2.060670>,
      < -6.773502, -1.072977, -2.060670>
    }
    triangle {
      < -6.799923, -1.061977, -2.060670>,
      < -6.773502, -1.072977, -2.060670>,
      < -6.791013, -1.081445, -2.032474>
    }
    triangle {
      < -6.799923, -1.061977, -2.060670>,
      < -6.791013, -1.081445, -2.032474>,
      < -6.820820, -1.068070, -2.032474>
    }
    triangle {
      < -6.820820, -1.068070, -2.032474>,
      < -6.791013, -1.081445, -2.032474>,
      < -6.800754, -1.085972, -1.997098>
    }
    triangle {
      < -6.820820, -1.068070, -2.032474>,
      < -6.800754, -1.085972, -1.997098>,
      < -6.831825, -1.071315, -1.997098>
    }
    triangle {
      < -6.773502, -1.072977, -2.060670>,
      < -6.652500, -1.075653, -2.060670>,
      < -6.654500, -1.084699, -2.032474>
    }
    triangle {
      < -6.773502, -1.072977, -2.060670>,
      < -6.654500, -1.084699, -2.032474>,
      < -6.791013, -1.081445, -2.032474>
    }
    triangle {
      < -6.791013, -1.081445, -2.032474>,
      < -6.654500, -1.084699, -2.032474>,
      < -6.658443, -1.089538, -1.997098>
    }
    triangle {
      < -6.791013, -1.081445, -2.032474>,
      < -6.658443, -1.089538, -1.997098>,
      < -6.800754, -1.085972, -1.997098>
    }
    triangle {
      < -7.019647, -1.060207, -0.564746>,
      < -6.909965, -1.057920, -1.488270>,
      < -6.891643, -1.077870, -1.488896>
    }
    triangle {
      < -7.019647, -1.060207, -0.564746>,
      < -6.891643, -1.077870, -1.488896>,
      < -7.000562, -1.089806, -0.563539>
    }
    triangle {
      < -7.020231, -0.995068, -0.566114>,
      < -6.910412, -1.014001, -1.489675>,
      < -6.914555, -1.037143, -1.488165>
    }
    triangle {
      < -7.020231, -0.995068, -0.566114>,
      < -6.914555, -1.037143, -1.488165>,
      < -7.024446, -1.029407, -0.564746>
    }
    triangle {
      < -6.853990, -1.041407, -1.997098>,
      < -6.862194, -1.039120, -1.926475>,
      < -6.857940, -1.021441, -1.925642>
    }
    triangle {
      < -6.853990, -1.041407, -1.997098>,
      < -6.857940, -1.021441, -1.925642>,
      < -6.850076, -1.024404, -1.997098>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.709947, -1.118215, -1.523827>,
      < -6.709462, -1.123200, -1.525288>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.709462, -1.123200, -1.525288>,
      < -6.705269, -1.157442, -1.543269>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.705269, -1.157442, -1.543269>,
      < -6.700672, -1.187404, -1.567580>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.700672, -1.187404, -1.567580>,
      < -6.695848, -1.211935, -1.597286>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.695848, -1.211935, -1.597286>,
      < -6.690980, -1.230092, -1.631245>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.690980, -1.230092, -1.631245>,
      < -6.686260, -1.241175, -1.668154>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.686260, -1.241175, -1.668154>,
      < -6.681865, -1.244760, -1.706593>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.681865, -1.244760, -1.706593>,
      < -6.677966, -1.240708, -1.745084>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.677966, -1.240708, -1.745084>,
      < -6.674712, -1.229178, -1.782150>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.674712, -1.229178, -1.782150>,
      < -6.672227, -1.210609, -1.816365>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.672227, -1.210609, -1.816365>,
      < -6.670609, -1.185717, -1.846416>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.670609, -1.185717, -1.846416>,
      < -6.669919, -1.155457, -1.871145>
    }
    triangle {
      < -6.670900, -1.101832, -1.894609>,
      < -6.669919, -1.155457, -1.871145>,
      < -6.670184, -1.120993, -1.889604>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.666987, -1.091349, -1.930437>,
      < -6.658443, -1.089538, -1.997098>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.658443, -1.089538, -1.997098>,
      < -6.667999, -0.977043, -1.997098>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.667999, -0.977043, -1.997098>,
      < -6.675989, -0.973215, -1.925578>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.675989, -0.973215, -1.925578>,
      < -6.723890, -0.950218, -1.496050>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.723890, -0.950218, -1.496050>,
      < -6.827199, -0.899603, -0.552779>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.827199, -0.899603, -0.552779>,
      < -6.813701, -1.126607, -0.559919>
    }
    triangle {
      < -6.889045, -1.016069, -1.887884>,
      < -6.957200, -1.046400, -1.886322>,
      < -6.968577, -1.013689, -1.882911>
    }
    triangle {
      < -6.889045, -1.016069, -1.887884>,
      < -6.968577, -1.013689, -1.882911>,
      < -6.866357, -0.992143, -1.884759>
    }
    triangle {
      < -6.957200, -1.046400, -1.886322>,
      < -6.896595, -1.040784, -1.889553>,
      < -6.880362, -1.065960, -1.889546>
    }
    triangle {
      < -6.951384, -1.080540, -1.882911>,
      < -6.957200, -1.046400, -1.886322>,
      < -6.880362, -1.065960, -1.889546>
    }
    triangle {
      < -6.951384, -1.080540, -1.882911>,
      < -6.880362, -1.065960, -1.889546>,
      < -6.859628, -1.081052, -1.887577>
    }
    triangle {
      < -6.927031, -1.068548, -1.531153>,
      < -6.951384, -1.080540, -1.534689>,
      < -6.910044, -1.088383, -1.532162>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.927031, -1.068548, -1.531153>,
      < -6.937382, -1.042666, -1.529858>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.937382, -1.042666, -1.529858>,
      < -6.957200, -1.046400, -1.531278>
    }
    triangle {
      < -6.979515, -0.982234, -1.544791>,
      < -6.918159, -0.988035, -1.537767>,
      < -6.873342, -0.960375, -1.545218>
    }
    triangle {
      < -6.945790, -1.113369, -1.872808>,
      < -6.818439, -1.096457, -1.886577>,
      < -6.670900, -1.101832, -1.894609>
    }
    triangle {
      < -6.945790, -1.113369, -1.872808>,
      < -6.670900, -1.101832, -1.894609>,
      < -6.670184, -1.120993, -1.889604>
    }
    triangle {
      < -6.979515, -0.982234, -1.872808>,
      < -6.824115, -0.973820, -1.879564>,
      < -6.866357, -0.992143, -1.884759>
    }
    triangle {
      < -6.979515, -0.982234, -1.872808>,
      < -6.866357, -0.992143, -1.884759>,
      < -6.968577, -1.013689, -1.882911>
    }
    triangle {
      < -6.873365, -0.975844, -1.497088>,
      < -6.723890, -0.950218, -1.496050>,
      < -6.719573, -0.940856, -1.542431>
    }
    triangle {
      < -6.873365, -0.975844, -1.497088>,
      < -6.719573, -0.940856, -1.542431>,
      < -6.873342, -0.960375, -1.545218>
    }
    triangle {
      < -6.893028, -0.987278, -1.493569>,
      < -6.873365, -0.975844, -1.497088>,
      < -6.873342, -0.960375, -1.545218>
    }
    triangle {
      < -6.893028, -0.987278, -1.493569>,
      < -6.873342, -0.960375, -1.545218>,
      < -6.918159, -0.988035, -1.537767>
    }
    triangle {
      < -6.910412, -1.014001, -1.489675>,
      < -6.893028, -0.987278, -1.493569>,
      < -6.918159, -0.988035, -1.537767>
    }
    triangle {
      < -6.910412, -1.014001, -1.489675>,
      < -6.918159, -0.988035, -1.537767>,
      < -6.929565, -1.005945, -1.532979>
    }
    triangle {
      < -6.914555, -1.037143, -1.488165>,
      < -6.910412, -1.014001, -1.489675>,
      < -6.929565, -1.005945, -1.532979>
    }
    triangle {
      < -6.914555, -1.037143, -1.488165>,
      < -6.929565, -1.005945, -1.532979>,
      < -6.937382, -1.042666, -1.529858>
    }
    triangle {
      < -6.909965, -1.057920, -1.488270>,
      < -6.914555, -1.037143, -1.488165>,
      < -6.937382, -1.042666, -1.529858>
    }
    triangle {
      < -6.909965, -1.057920, -1.488270>,
      < -6.937382, -1.042666, -1.529858>,
      < -6.927031, -1.068548, -1.531153>
    }
    triangle {
      < -6.891643, -1.077870, -1.488896>,
      < -6.909965, -1.057920, -1.488270>,
      < -6.927031, -1.068548, -1.531153>
    }
    triangle {
      < -6.891643, -1.077870, -1.488896>,
      < -6.927031, -1.068548, -1.531153>,
      < -6.910044, -1.088383, -1.532162>
    }
    triangle {
      < -6.859421, -1.097765, -1.491009>,
      < -6.891643, -1.077870, -1.488896>,
      < -6.910044, -1.088383, -1.532162>
    }
    triangle {
      < -6.859421, -1.097765, -1.491009>,
      < -6.910044, -1.088383, -1.532162>,
      < -6.855919, -1.112782, -1.535495>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.859421, -1.097765, -1.491009>,
      < -6.855919, -1.112782, -1.535495>
    }
    triangle {
      < -6.715765, -1.102988, -1.479291>,
      < -6.855919, -1.112782, -1.535495>,
      < -6.709947, -1.118215, -1.523827>
    }
    triangle {
      < -6.675989, -0.973215, -1.925578>,
      < -6.819091, -0.991846, -1.922870>,
      < -6.824115, -0.973820, -1.879564>
    }
    triangle {
      < -6.675989, -0.973215, -1.925578>,
      < -6.824115, -0.973820, -1.879564>,
      < -6.681404, -0.959091, -1.884111>
    }
    triangle {
      < -6.819091, -0.991846, -1.922870>,
      < -6.845813, -1.005988, -1.924408>,
      < -6.866357, -0.992143, -1.884759>
    }
    triangle {
      < -6.819091, -0.991846, -1.922870>,
      < -6.866357, -0.992143, -1.884759>,
      < -6.824115, -0.973820, -1.879564>
    }
    triangle {
      < -6.845813, -1.005988, -1.924408>,
      < -6.857940, -1.021441, -1.925642>,
      < -6.889045, -1.016069, -1.887884>
    }
    triangle {
      < -6.845813, -1.005988, -1.924408>,
      < -6.889045, -1.016069, -1.887884>,
      < -6.866357, -0.992143, -1.884759>
    }
    triangle {
      < -6.857940, -1.021441, -1.925642>,
      < -6.862194, -1.039120, -1.926475>,
      < -6.896595, -1.040784, -1.889553>
    }
    triangle {
      < -6.857940, -1.021441, -1.925642>,
      < -6.896595, -1.040784, -1.889553>,
      < -6.889045, -1.016069, -1.887884>
    }
    triangle {
      < -6.862194, -1.039120, -1.926475>,
      < -6.858163, -1.055314, -1.926427>,
      < -6.880362, -1.065960, -1.889546>
    }
    triangle {
      < -6.862194, -1.039120, -1.926475>,
      < -6.880362, -1.065960, -1.889546>,
      < -6.896595, -1.040784, -1.889553>
    }
    triangle {
      < -6.858163, -1.055314, -1.926427>,
      < -6.841156, -1.070764, -1.925938>,
      < -6.859628, -1.081052, -1.887577>
    }
    triangle {
      < -6.858163, -1.055314, -1.926427>,
      < -6.859628, -1.081052, -1.887577>,
      < -6.880362, -1.065960, -1.889546>
    }
    triangle {
      < -6.841156, -1.070764, -1.925938>,
      < -6.810749, -1.086163, -1.925392>,
      < -6.818439, -1.096457, -1.886577>
    }
    triangle {
      < -6.841156, -1.070764, -1.925938>,
      < -6.818439, -1.096457, -1.886577>,
      < -6.859628, -1.081052, -1.887577>
    }
    triangle {
      < -6.810749, -1.086163, -1.925392>,
      < -6.666987, -1.091349, -1.930437>,
      < -6.670900, -1.101832, -1.894609>
    }
    triangle {
      < -6.810749, -1.086163, -1.925392>,
      < -6.670900, -1.101832, -1.894609>,
      < -6.818439, -1.096457, -1.886577>
    }
    triangle {
      < -6.723890, -0.950218, -1.496050>,
      < -6.675989, -0.973215, -1.925578>,
      < -6.681404, -0.959091, -1.884111>
    }
    triangle {
      < -6.723890, -0.950218, -1.496050>,
      < -6.681404, -0.959091, -1.884111>,
      < -6.719573, -0.940856, -1.542431>
    }
    triangle {
      < -6.666987, -1.091349, -1.930437>,
      < -6.715765, -1.102988, -1.479291>,
      < -6.709947, -1.118215, -1.523827>
    }
    triangle {
      < -6.666987, -1.091349, -1.930437>,
      < -6.709947, -1.118215, -1.523827>,
      < -6.670900, -1.101832, -1.894609>
    }
    triangle {
      < -7.051667, -0.890230, -1.674169>,
      < -7.053440, -0.887290, -1.708800>,
      < -7.057078, -0.896686, -1.708805>
    }
    triangle {
      < -7.051667, -0.890230, -1.674169>,
      < -7.057078, -0.896686, -1.708805>,
      < -7.055372, -0.899450, -1.676105>
    }
    triangle {
      < -7.053440, -0.887290, -1.708800>,
      < -7.051696, -0.890201, -1.743434>,
      < -7.055400, -0.899423, -1.741509>
    }
    triangle {
      < -7.053440, -0.887290, -1.708800>,
      < -7.055400, -0.899423, -1.741509>,
      < -7.057078, -0.896686, -1.708805>
    }
    triangle {
      < -7.051696, -0.890201, -1.743434>,
      < -7.046517, -0.898849, -1.776742>,
      < -7.050418, -0.907551, -1.772954>
    }
    triangle {
      < -7.051696, -0.890201, -1.743434>,
      < -7.050418, -0.907551, -1.772954>,
      < -7.055400, -0.899423, -1.741509>
    }
    triangle {
      < -7.046517, -0.898849, -1.776742>,
      < -7.038095, -0.912906, -1.807443>,
      < -7.042318, -0.920759, -1.801926>
    }
    triangle {
      < -7.046517, -0.898849, -1.776742>,
      < -7.042318, -0.920759, -1.801926>,
      < -7.050418, -0.907551, -1.772954>
    }
    triangle {
      < -7.038095, -0.912906, -1.807443>,
      < -7.026746, -0.931825, -1.834356>,
      < -7.031406, -0.938525, -1.827311>
    }
    triangle {
      < -7.038095, -0.912906, -1.807443>,
      < -7.031406, -0.938525, -1.827311>,
      < -7.042318, -0.920759, -1.801926>
    }
    triangle {
      < -7.026746, -0.931825, -1.834356>,
      < -7.012914, -0.954885, -1.856449>,
      < -7.018111, -0.960166, -1.848138>
    }
    triangle {
      < -7.026746, -0.931825, -1.834356>,
      < -7.018111, -0.960166, -1.848138>,
      < -7.031406, -0.938525, -1.827311>
    }
    triangle {
      < -7.012914, -0.954885, -1.856449>,
      < -6.997129, -0.981196, -1.872871>,
      < -7.002946, -0.984845, -1.863612>
    }
    triangle {
      < -7.012914, -0.954885, -1.856449>,
      < -7.002946, -0.984845, -1.863612>,
      < -7.018111, -0.960166, -1.848138>
    }
    triangle {
      < -6.997129, -0.981196, -1.872871>,
      < -6.980002, -1.009749, -1.882993>,
      < -6.986531, -1.011518, -1.873113>
    }
    triangle {
      < -6.997129, -0.981196, -1.872871>,
      < -6.986531, -1.011518, -1.873113>,
      < -7.002946, -0.984845, -1.863612>
    }
    triangle {
      < -6.980002, -1.009749, -1.882993>,
      < -6.957200, -1.046400, -1.886322>,
      < -6.964439, -1.046296, -1.876093>
    }
    triangle {
      < -6.980002, -1.009749, -1.882993>,
      < -6.964439, -1.046296, -1.876093>,
      < -6.986531, -1.011518, -1.873113>
    }
    triangle {
      < -6.957200, -1.046400, -1.886322>,
      < -6.951384, -1.080540, -1.882911>,
      < -6.959292, -1.078673, -1.873063>
    }
    triangle {
      < -6.957200, -1.046400, -1.886322>,
      < -6.959292, -1.078673, -1.873063>,
      < -6.964439, -1.046296, -1.876093>
    }
    triangle {
      < -6.951384, -1.080540, -1.882911>,
      < -6.945790, -1.113369, -1.872808>,
      < -6.954376, -1.109715, -1.863551>
    }
    triangle {
      < -6.951384, -1.080540, -1.882911>,
      < -6.954376, -1.109715, -1.863551>,
      < -6.959292, -1.078673, -1.873063>
    }
    triangle {
      < -6.945790, -1.113369, -1.872808>,
      < -6.940633, -1.143624, -1.856404>,
      < -6.949838, -1.138336, -1.848098>
    }
    triangle {
      < -6.945790, -1.113369, -1.872808>,
      < -6.949838, -1.138336, -1.848098>,
      < -6.954376, -1.109715, -1.863551>
    }
    triangle {
      < -6.940633, -1.143624, -1.856404>,
      < -6.936112, -1.170142, -1.834327>,
      < -6.945855, -1.163436, -1.827289>
    }
    triangle {
      < -6.940633, -1.143624, -1.856404>,
      < -6.945855, -1.163436, -1.827289>,
      < -6.949838, -1.138336, -1.848098>
    }
    triangle {
      < -6.936112, -1.170142, -1.834327>,
      < -6.932407, -1.191906, -1.807425>,
      < -6.942586, -1.184049, -1.801915>
    }
    triangle {
      < -6.936112, -1.170142, -1.834327>,
      < -6.942586, -1.184049, -1.801915>,
      < -6.945855, -1.163436, -1.827289>
    }
    triangle {
      < -6.932407, -1.191906, -1.807425>,
      < -6.929648, -1.208078, -1.776734>,
      < -6.940148, -1.199374, -1.772950>
    }
    triangle {
      < -6.932407, -1.191906, -1.807425>,
      < -6.940148, -1.199374, -1.772950>,
      < -6.942586, -1.184049, -1.801915>
    }
    triangle {
      < -6.929648, -1.208078, -1.776734>,
      < -6.927948, -1.218035, -1.743432>,
      < -6.938645, -1.208813, -1.741507>
    }
    triangle {
      < -6.929648, -1.208078, -1.776734>,
      < -6.938645, -1.208813, -1.741507>,
      < -6.940148, -1.199374, -1.772950>
    }
    triangle {
      < -6.927948, -1.218035, -1.743432>,
      < -6.927377, -1.221398, -1.708800>,
      < -6.938140, -1.212002, -1.708800>
    }
    triangle {
      < -6.927948, -1.218035, -1.743432>,
      < -6.938140, -1.212002, -1.708800>,
      < -6.938645, -1.208813, -1.741507>
    }
    triangle {
      < -6.927377, -1.221398, -1.708800>,
      < -6.927948, -1.218035, -1.674167>,
      < -6.938645, -1.208813, -1.676092>
    }
    triangle {
      < -6.927377, -1.221398, -1.708800>,
      < -6.938645, -1.208813, -1.676092>,
      < -6.938140, -1.212002, -1.708800>
    }
    triangle {
      < -6.927948, -1.218035, -1.674167>,
      < -6.929648, -1.208078, -1.640865>,
      < -6.940149, -1.199374, -1.644649>
    }
    triangle {
      < -6.927948, -1.218035, -1.674167>,
      < -6.940149, -1.199374, -1.644649>,
      < -6.938645, -1.208813, -1.676092>
    }
    triangle {
      < -6.929648, -1.208078, -1.640865>,
      < -6.932407, -1.191906, -1.610173>,
      < -6.942586, -1.184049, -1.615683>
    }
    triangle {
      < -6.929648, -1.208078, -1.640865>,
      < -6.942586, -1.184049, -1.615683>,
      < -6.940149, -1.199374, -1.644649>
    }
    triangle {
      < -6.932407, -1.191906, -1.610173>,
      < -6.936112, -1.170142, -1.583273>,
      < -6.945856, -1.163436, -1.590311>
    }
    triangle {
      < -6.932407, -1.191906, -1.610173>,
      < -6.945856, -1.163436, -1.590311>,
      < -6.942586, -1.184049, -1.615683>
    }
    triangle {
      < -6.936112, -1.170142, -1.583273>,
      < -6.940633, -1.143624, -1.561195>,
      < -6.949839, -1.138336, -1.569501>
    }
    triangle {
      < -6.936112, -1.170142, -1.583273>,
      < -6.949839, -1.138336, -1.569501>,
      < -6.945856, -1.163436, -1.590311>
    }
    triangle {
      < -6.940633, -1.143624, -1.561195>,
      < -6.945790, -1.113369, -1.544791>,
      < -6.954377, -1.109715, -1.554049>
    }
    triangle {
      < -6.940633, -1.143624, -1.561195>,
      < -6.954377, -1.109715, -1.554049>,
      < -6.949839, -1.138336, -1.569501>
    }
    triangle {
      < -6.945790, -1.113369, -1.544791>,
      < -6.951384, -1.080540, -1.534689>,
      < -6.959293, -1.078673, -1.544537>
    }
    triangle {
      < -6.945790, -1.113369, -1.544791>,
      < -6.959293, -1.078673, -1.544537>,
      < -6.954377, -1.109715, -1.554049>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.957200, -1.046400, -1.531278>,
      < -6.964433, -1.046317, -1.541509>
    }
    triangle {
      < -6.951384, -1.080540, -1.534689>,
      < -6.964433, -1.046317, -1.541509>,
      < -6.959293, -1.078673, -1.544537>
    }
    triangle {
      < -6.957200, -1.046400, -1.531278>,
      < -6.979856, -1.009895, -1.534771>,
      < -6.986382, -1.011678, -1.544646>
    }
    triangle {
      < -6.957200, -1.046400, -1.531278>,
      < -6.986382, -1.011678, -1.544646>,
      < -6.964433, -1.046317, -1.541509>
    }
    triangle {
      < -6.979856, -1.009895, -1.534771>,
      < -6.996993, -0.981333, -1.544854>,
      < -7.002814, -0.984973, -1.554118>
    }
    triangle {
      < -6.979856, -1.009895, -1.534771>,
      < -7.002814, -0.984973, -1.554118>,
      < -6.986382, -1.011678, -1.544646>
    }
    triangle {
      < -6.996993, -0.981333, -1.544854>,
      < -7.012788, -0.955009, -1.561241>,
      < -7.017990, -0.960282, -1.569558>
    }
    triangle {
      < -6.996993, -0.981333, -1.544854>,
      < -7.017990, -0.960282, -1.569558>,
      < -7.002814, -0.984973, -1.554118>
    }
    triangle {
      < -7.012788, -0.955009, -1.561241>,
      < -7.026640, -0.931931, -1.583303>,
      < -7.031303, -0.938624, -1.590356>
    }
    triangle {
      < -7.012788, -0.955009, -1.561241>,
      < -7.031303, -0.938624, -1.590356>,
      < -7.017990, -0.960282, -1.569558>
    }
    triangle {
      < -7.026640, -0.931931, -1.583303>,
      < -7.038013, -0.912989, -1.610191>,
      < -7.042238, -0.920836, -1.615717>
    }
    triangle {
      < -7.026640, -0.931931, -1.583303>,
      < -7.042238, -0.920836, -1.615717>,
      < -7.031303, -0.938624, -1.590356>
    }
    triangle {
      < -7.038013, -0.912989, -1.610191>,
      < -7.046462, -0.898906, -1.640872>,
      < -7.050364, -0.907605, -1.644670>
    }
    triangle {
      < -7.038013, -0.912989, -1.610191>,
      < -7.050364, -0.907605, -1.644670>,
      < -7.042238, -0.920836, -1.615717>
    }
    triangle {
      < -7.046462, -0.898906, -1.640872>,
      < -7.051667, -0.890230, -1.674169>,
      < -7.055372, -0.899450, -1.676105>
    }
    triangle {
      < -7.046462, -0.898906, -1.640872>,
      < -7.055372, -0.899450, -1.676105>,
      < -7.050364, -0.907605, -1.644670>
    }
    triangle {
      < -7.031303, -0.938624, -1.590356>,
      < -7.042238, -0.920836, -1.615717>,
      < -7.022464, -0.928684, -1.621243>
    }
    triangle {
      < -7.031303, -0.938624, -1.590356>,
      < -7.022464, -0.928684, -1.621243>,
      < -7.011967, -0.945317, -1.597408>
    }
    triangle {
      < -7.042238, -0.920836, -1.615717>,
      < -7.050364, -0.907605, -1.644670>,
      < -7.030267, -0.916304, -1.648468>
    }
    triangle {
      < -7.042238, -0.920836, -1.615717>,
      < -7.030267, -0.916304, -1.648468>,
      < -7.022464, -0.928684, -1.621243>
    }
    triangle {
      < -7.050364, -0.907605, -1.644670>,
      < -7.055372, -0.899450, -1.676105>,
      < -7.035077, -0.908669, -1.678040>
    }
    triangle {
      < -7.050364, -0.907605, -1.644670>,
      < -7.035077, -0.908669, -1.678040>,
      < -7.030267, -0.916304, -1.648468>
    }
    triangle {
      < -7.055372, -0.899450, -1.676105>,
      < -7.057078, -0.896686, -1.708805>,
      < -7.036716, -0.906082, -1.708811>
    }
    triangle {
      < -7.055372, -0.899450, -1.676105>,
      < -7.036716, -0.906082, -1.708811>,
      < -7.035077, -0.908669, -1.678040>
    }
    triangle {
      < -7.057078, -0.896686, -1.708805>,
      < -7.055400, -0.899423, -1.741509>,
      < -7.035104, -0.908644, -1.739584>
    }
    triangle {
      < -7.057078, -0.896686, -1.708805>,
      < -7.035104, -0.908644, -1.739584>,
      < -7.036716, -0.906082, -1.708811>
    }
    triangle {
      < -7.055400, -0.899423, -1.741509>,
      < -7.050418, -0.907551, -1.772954>,
      < -7.030319, -0.916254, -1.769166>
    }
    triangle {
      < -7.055400, -0.899423, -1.741509>,
      < -7.030319, -0.916254, -1.769166>,
      < -7.035104, -0.908644, -1.739584>
    }
    triangle {
      < -7.050418, -0.907551, -1.772954>,
      < -7.042318, -0.920759, -1.801926>,
      < -7.022541, -0.928612, -1.796410>
    }
    triangle {
      < -7.050418, -0.907551, -1.772954>,
      < -7.022541, -0.928612, -1.796410>,
      < -7.030319, -0.916254, -1.769166>
    }
    triangle {
      < -7.042318, -0.920759, -1.801926>,
      < -7.031406, -0.938525, -1.827311>,
      < -7.012066, -0.945225, -1.820267>
    }
    triangle {
      < -7.042318, -0.920759, -1.801926>,
      < -7.012066, -0.945225, -1.820267>,
      < -7.022541, -0.928612, -1.796410>
    }
    triangle {
      < -7.031406, -0.938525, -1.827311>,
      < -7.018111, -0.960166, -1.848138>,
      < -6.999309, -0.965448, -1.839828>
    }
    triangle {
      < -7.031406, -0.938525, -1.827311>,
      < -6.999309, -0.965448, -1.839828>,
      < -7.012066, -0.945225, -1.820267>
    }
    triangle {
      < -7.018111, -0.960166, -1.848138>,
      < -7.002946, -0.984845, -1.863612>,
      < -6.984763, -0.988495, -1.854352>
    }
    triangle {
      < -7.018111, -0.960166, -1.848138>,
      < -6.984763, -0.988495, -1.854352>,
      < -6.999309, -0.965448, -1.839828>
    }
    triangle {
      < -7.002946, -0.984845, -1.863612>,
      < -6.986531, -1.011518, -1.873113>,
      < -6.969069, -1.013266, -1.863225>
    }
    triangle {
      < -7.002946, -0.984845, -1.863612>,
      < -6.969069, -1.013266, -1.863225>,
      < -6.984763, -0.988495, -1.854352>
    }
    triangle {
      < -6.986531, -1.011518, -1.873113>,
      < -6.964439, -1.046296, -1.876093>,
      < -6.947677, -1.046199, -1.865847>
    }
    triangle {
      < -6.986531, -1.011518, -1.873113>,
      < -6.947677, -1.046199, -1.865847>,
      < -6.969069, -1.013266, -1.863225>
    }
    triangle {
      < -6.964439, -1.046296, -1.876093>,
      < -6.959292, -1.078673, -1.873063>,
      < -6.943190, -1.076833, -1.863206>
    }
    triangle {
      < -6.964439, -1.046296, -1.876093>,
      < -6.943190, -1.076833, -1.863206>,
      < -6.947677, -1.046199, -1.865847>
    }
    triangle {
      < -6.959292, -1.078673, -1.873063>,
      < -6.954376, -1.109715, -1.863551>,
      < -6.938961, -1.106061, -1.854293>
    }
    triangle {
      < -6.959292, -1.078673, -1.873063>,
      < -6.938961, -1.106061, -1.854293>,
      < -6.943190, -1.076833, -1.863206>
    }
    triangle {
      < -6.954376, -1.109715, -1.863551>,
      < -6.949838, -1.138336, -1.848098>,
      < -6.935043, -1.133047, -1.839792>
    }
    triangle {
      < -6.954376, -1.109715, -1.863551>,
      < -6.935043, -1.133047, -1.839792>,
      < -6.938961, -1.106061, -1.854293>
    }
    triangle {
      < -6.949838, -1.138336, -1.848098>,
      < -6.945855, -1.163436, -1.827289>,
      < -6.931598, -1.156729, -1.820251>
    }
    triangle {
      < -6.949838, -1.138336, -1.848098>,
      < -6.931598, -1.156729, -1.820251>,
      < -6.935043, -1.133047, -1.839792>
    }
    triangle {
      < -6.945855, -1.163436, -1.827289>,
      < -6.942586, -1.184049, -1.801915>,
      < -6.928765, -1.176191, -1.796405>
    }
    triangle {
      < -6.945855, -1.163436, -1.827289>,
      < -6.928765, -1.176191, -1.796405>,
      < -6.931598, -1.156729, -1.820251>
    }
    triangle {
      < -6.942586, -1.184049, -1.801915>,
      < -6.940148, -1.199374, -1.772950>,
      < -6.926649, -1.190669, -1.769166>
    }
    triangle {
      < -6.942586, -1.184049, -1.801915>,
      < -6.926649, -1.190669, -1.769166>,
      < -6.928765, -1.176191, -1.796405>
    }
    triangle {
      < -6.940148, -1.199374, -1.772950>,
      < -6.938645, -1.208813, -1.741507>,
      < -6.925343, -1.199592, -1.739582>
    }
    triangle {
      < -6.940148, -1.199374, -1.772950>,
      < -6.925343, -1.199592, -1.739582>,
      < -6.926649, -1.190669, -1.769166>
    }
    triangle {
      < -6.938645, -1.208813, -1.741507>,
      < -6.938140, -1.212002, -1.708800>,
      < -6.924903, -1.202606, -1.708800>
    }
    triangle {
      < -6.938645, -1.208813, -1.741507>,
      < -6.924903, -1.202606, -1.708800>,
      < -6.925343, -1.199592, -1.739582>
    }
    triangle {
      < -6.938140, -1.212002, -1.708800>,
      < -6.938645, -1.208813, -1.676092>,
      < -6.925343, -1.199592, -1.678017>
    }
    triangle {
      < -6.938140, -1.212002, -1.708800>,
      < -6.925343, -1.199592, -1.678017>,
      < -6.924903, -1.202606, -1.708800>
    }
    triangle {
      < -6.938645, -1.208813, -1.676092>,
      < -6.940149, -1.199374, -1.644649>,
      < -6.926651, -1.190670, -1.648432>
    }
    triangle {
      < -6.938645, -1.208813, -1.676092>,
      < -6.926651, -1.190670, -1.648432>,
      < -6.925343, -1.199592, -1.678017>
    }
    triangle {
      < -6.940149, -1.199374, -1.644649>,
      < -6.942586, -1.184049, -1.615683>,
      < -6.928767, -1.176192, -1.621193>
    }
    triangle {
      < -6.940149, -1.199374, -1.644649>,
      < -6.928767, -1.176192, -1.621193>,
      < -6.926651, -1.190670, -1.648432>
    }
    triangle {
      < -6.942586, -1.184049, -1.615683>,
      < -6.945856, -1.163436, -1.590311>,
      < -6.931600, -1.156730, -1.597349>
    }
    triangle {
      < -6.942586, -1.184049, -1.615683>,
      < -6.931600, -1.156730, -1.597349>,
      < -6.928767, -1.176192, -1.621193>
    }
    triangle {
      < -6.945856, -1.163436, -1.590311>,
      < -6.949839, -1.138336, -1.569501>,
      < -6.935046, -1.133048, -1.577806>
    }
    triangle {
      < -6.945856, -1.163436, -1.590311>,
      < -6.935046, -1.133048, -1.577806>,
      < -6.931600, -1.156730, -1.597349>
    }
    triangle {
      < -6.949839, -1.138336, -1.569501>,
      < -6.954377, -1.109715, -1.554049>,
      < -6.938964, -1.106062, -1.563306>
    }
    triangle {
      < -6.949839, -1.138336, -1.569501>,
      < -6.938964, -1.106062, -1.563306>,
      < -6.935046, -1.133048, -1.577806>
    }
    triangle {
      < -6.954377, -1.109715, -1.554049>,
      < -6.959293, -1.078673, -1.544537>,
      < -6.943192, -1.076834, -1.554394>
    }
    triangle {
      < -6.954377, -1.109715, -1.554049>,
      < -6.943192, -1.076834, -1.554394>,
      < -6.938964, -1.106062, -1.563306>
    }
    triangle {
      < -6.959293, -1.078673, -1.544537>,
      < -6.964433, -1.046317, -1.541509>,
      < -6.947663, -1.046240, -1.551756>
    }
    triangle {
      < -6.959293, -1.078673, -1.544537>,
      < -6.947663, -1.046240, -1.551756>,
      < -6.943192, -1.076834, -1.554394>
    }
    triangle {
      < -6.964433, -1.046317, -1.541509>,
      < -6.986382, -1.011678, -1.544646>,
      < -6.968915, -1.013440, -1.554527>
    }
    triangle {
      < -6.964433, -1.046317, -1.541509>,
      < -6.968915, -1.013440, -1.554527>,
      < -6.947663, -1.046240, -1.551756>
    }
    triangle {
      < -6.986382, -1.011678, -1.544646>,
      < -7.002814, -0.984973, -1.554118>,
      < -6.984635, -0.988613, -1.563382>
    }
    triangle {
      < -6.986382, -1.011678, -1.544646>,
      < -6.984635, -0.988613, -1.563382>,
      < -6.968915, -1.013440, -1.554527>
    }
    triangle {
      < -7.002814, -0.984973, -1.554118>,
      < -7.017990, -0.960282, -1.569558>,
      < -6.999192, -0.965555, -1.577874>
    }
    triangle {
      < -7.002814, -0.984973, -1.554118>,
      < -6.999192, -0.965555, -1.577874>,
      < -6.984635, -0.988613, -1.563382>
    }
    triangle {
      < -7.017990, -0.960282, -1.569558>,
      < -7.031303, -0.938624, -1.590356>,
      < -7.011967, -0.945317, -1.597408>
    }
    triangle {
      < -7.017990, -0.960282, -1.569558>,
      < -7.011967, -0.945317, -1.597408>,
      < -6.999192, -0.965555, -1.577874>
    }
    triangle {
      < -6.968915, -1.013440, -1.554527>,
      < -6.984635, -0.988613, -1.563382>,
      < -6.904465, -0.992253, -1.572645>
    }
    triangle {
      < -6.968915, -1.013440, -1.554527>,
      < -6.904465, -0.992253, -1.572645>,
      < -6.904465, -1.015177, -1.564416>
    }
    triangle {
      < -6.984635, -0.988613, -1.563382>,
      < -6.999192, -0.965555, -1.577874>,
      < -6.904465, -0.970829, -1.586191>
    }
    triangle {
      < -6.984635, -0.988613, -1.563382>,
      < -6.904465, -0.970829, -1.586191>,
      < -6.904465, -0.992253, -1.572645>
    }
    triangle {
      < -6.999192, -0.965555, -1.577874>,
      < -7.011967, -0.945317, -1.597408>,
      < -6.904465, -0.952010, -1.604460>
    }
    triangle {
      < -6.999192, -0.965555, -1.577874>,
      < -6.904465, -0.952010, -1.604460>,
      < -6.904465, -0.970829, -1.586191>
    }
    triangle {
      < -7.011967, -0.945317, -1.597408>,
      < -7.022464, -0.928684, -1.621243>,
      < -6.904465, -0.936532, -1.626768>
    }
    triangle {
      < -7.011967, -0.945317, -1.597408>,
      < -6.904465, -0.936532, -1.626768>,
      < -6.904465, -0.952010, -1.604460>
    }
    triangle {
      < -7.022464, -0.928684, -1.621243>,
      < -7.030267, -0.916304, -1.648468>,
      < -6.904465, -0.925003, -1.652266>
    }
    triangle {
      < -7.022464, -0.928684, -1.621243>,
      < -6.904465, -0.925003, -1.652266>,
      < -6.904465, -0.936532, -1.626768>
    }
    triangle {
      < -7.030267, -0.916304, -1.648468>,
      < -7.035077, -0.908669, -1.678040>,
      < -6.904465, -0.917890, -1.679976>
    }
    triangle {
      < -7.030267, -0.916304, -1.648468>,
      < -6.904465, -0.917890, -1.679976>,
      < -6.904465, -0.925003, -1.652266>
    }
    triangle {
      < -7.035077, -0.908669, -1.678040>,
      < -7.036716, -0.906082, -1.708811>,
      < -6.904465, -0.915478, -1.708816>
    }
    triangle {
      < -7.035077, -0.908669, -1.678040>,
      < -6.904465, -0.915478, -1.708816>,
      < -6.904465, -0.917890, -1.679976>
    }
    triangle {
      < -7.036716, -0.906082, -1.708811>,
      < -7.035104, -0.908644, -1.739584>,
      < -6.904465, -0.917866, -1.737659>
    }
    triangle {
      < -7.036716, -0.906082, -1.708811>,
      < -6.904465, -0.917866, -1.737659>,
      < -6.904465, -0.915478, -1.708816>
    }
    triangle {
      < -7.035104, -0.908644, -1.739584>,
      < -7.030319, -0.916254, -1.769166>,
      < -6.904465, -0.924957, -1.765378>
    }
    triangle {
      < -7.035104, -0.908644, -1.739584>,
      < -6.904465, -0.924957, -1.765378>,
      < -6.904465, -0.917866, -1.737659>
    }
    triangle {
      < -7.030319, -0.916254, -1.769166>,
      < -7.022541, -0.928612, -1.796410>,
      < -6.904465, -0.936466, -1.790894>
    }
    triangle {
      < -7.030319, -0.916254, -1.769166>,
      < -6.904465, -0.936466, -1.790894>,
      < -6.904465, -0.924957, -1.765378>
    }
    triangle {
      < -7.022541, -0.928612, -1.796410>,
      < -7.012066, -0.945225, -1.820267>,
      < -6.904465, -0.951925, -1.813223>
    }
    triangle {
      < -7.022541, -0.928612, -1.796410>,
      < -6.904465, -0.951925, -1.813223>,
      < -6.904465, -0.936466, -1.790894>
    }
    triangle {
      < -7.012066, -0.945225, -1.820267>,
      < -6.999309, -0.965448, -1.839828>,
      < -6.904465, -0.970730, -1.831518>
    }
    triangle {
      < -7.012066, -0.945225, -1.820267>,
      < -6.904465, -0.970730, -1.831518>,
      < -6.904465, -0.951925, -1.813223>
    }
    triangle {
      < -6.999309, -0.965448, -1.839828>,
      < -6.984763, -0.988495, -1.854352>,
      < -6.904465, -0.992145, -1.845094>
    }
    triangle {
      < -6.999309, -0.965448, -1.839828>,
      < -6.904465, -0.992145, -1.845094>,
      < -6.904465, -0.970730, -1.831518>
    }
    triangle {
      < -6.984763, -0.988495, -1.854352>,
      < -6.969069, -1.013266, -1.863225>,
      < -6.904465, -1.014989, -1.853330>
    }
    triangle {
      < -6.984763, -0.988495, -1.854352>,
      < -6.904465, -1.014989, -1.853330>,
      < -6.904465, -0.992145, -1.845094>
    }
    triangle {
      < -6.969069, -1.013266, -1.863225>,
      < -6.947677, -1.046199, -1.865847>,
      < -6.904465, -1.046108, -1.855581>
    }
    triangle {
      < -6.969069, -1.013266, -1.863225>,
      < -6.904465, -1.046108, -1.855581>,
      < -6.904465, -1.014989, -1.853330>
    }
    triangle {
      < -6.947677, -1.046199, -1.865847>,
      < -6.943190, -1.076833, -1.863206>,
      < -6.904465, -1.075025, -1.853340>
    }
    triangle {
      < -6.947677, -1.046199, -1.865847>,
      < -6.904465, -1.075025, -1.853340>,
      < -6.904465, -1.046108, -1.855581>
    }
    triangle {
      < -6.943190, -1.076833, -1.863206>,
      < -6.938961, -1.106061, -1.854293>,
      < -6.904465, -1.102407, -1.845036>
    }
    triangle {
      < -6.943190, -1.076833, -1.863206>,
      < -6.904465, -1.102407, -1.845036>,
      < -6.904465, -1.075025, -1.853340>
    }
    triangle {
      < -6.938961, -1.106061, -1.854293>,
      < -6.935043, -1.133047, -1.839792>,
      < -6.904465, -1.127759, -1.831487>
    }
    triangle {
      < -6.938961, -1.106061, -1.854293>,
      < -6.904465, -1.127759, -1.831487>,
      < -6.904465, -1.102407, -1.845036>
    }
    triangle {
      < -6.935043, -1.133047, -1.839792>,
      < -6.931598, -1.156729, -1.820251>,
      < -6.904465, -1.150022, -1.813214>
    }
    triangle {
      < -6.935043, -1.133047, -1.839792>,
      < -6.904465, -1.150022, -1.813214>,
      < -6.904465, -1.127759, -1.831487>
    }
    triangle {
      < -6.931598, -1.156729, -1.820251>,
      < -6.928765, -1.176191, -1.796405>,
      < -6.904465, -1.168333, -1.790896>
    }
    triangle {
      < -6.931598, -1.156729, -1.820251>,
      < -6.904465, -1.168333, -1.790896>,
      < -6.904465, -1.150022, -1.813214>
    }
    triangle {
      < -6.928765, -1.176191, -1.796405>,
      < -6.926649, -1.190669, -1.769166>,
      < -6.904465, -1.181965, -1.765383>
    }
    triangle {
      < -6.928765, -1.176191, -1.796405>,
      < -6.904465, -1.181965, -1.765383>,
      < -6.904465, -1.168333, -1.790896>
    }
    triangle {
      < -6.926649, -1.190669, -1.769166>,
      < -6.925343, -1.199592, -1.739582>,
      < -6.904465, -1.190369, -1.737657>
    }
    triangle {
      < -6.926649, -1.190669, -1.769166>,
      < -6.904465, -1.190369, -1.737657>,
      < -6.904465, -1.181965, -1.765383>
    }
    triangle {
      < -6.925343, -1.199592, -1.739582>,
      < -6.924903, -1.202606, -1.708800>,
      < -6.904465, -1.193210, -1.708800>
    }
    triangle {
      < -6.925343, -1.199592, -1.739582>,
      < -6.904465, -1.193210, -1.708800>,
      < -6.904465, -1.190369, -1.737657>
    }
    triangle {
      < -6.924903, -1.202606, -1.708800>,
      < -6.925343, -1.199592, -1.678017>,
      < -6.904465, -1.190369, -1.679942>
    }
    triangle {
      < -6.924903, -1.202606, -1.708800>,
      < -6.904465, -1.190369, -1.679942>,
      < -6.904465, -1.193210, -1.708800>
    }
    triangle {
      < -6.925343, -1.199592, -1.678017>,
      < -6.926651, -1.190670, -1.648432>,
      < -6.904465, -1.181965, -1.652216>
    }
    triangle {
      < -6.925343, -1.199592, -1.678017>,
      < -6.904465, -1.181965, -1.652216>,
      < -6.904465, -1.190369, -1.679942>
    }
    triangle {
      < -6.926651, -1.190670, -1.648432>,
      < -6.928767, -1.176192, -1.621193>,
      < -6.904465, -1.168334, -1.626702>
    }
    triangle {
      < -6.926651, -1.190670, -1.648432>,
      < -6.904465, -1.168334, -1.626702>,
      < -6.904465, -1.181965, -1.652216>
    }
    triangle {
      < -6.928767, -1.176192, -1.621193>,
      < -6.931600, -1.156730, -1.597349>,
      < -6.904465, -1.150023, -1.604386>
    }
    triangle {
      < -6.928767, -1.176192, -1.621193>,
      < -6.904465, -1.150023, -1.604386>,
      < -6.904465, -1.168334, -1.626702>
    }
    triangle {
      < -6.931600, -1.156730, -1.597349>,
      < -6.935046, -1.133048, -1.577806>,
      < -6.904465, -1.127759, -1.586112>
    }
    triangle {
      < -6.931600, -1.156730, -1.597349>,
      < -6.904465, -1.127759, -1.586112>,
      < -6.904465, -1.150023, -1.604386>
    }
    triangle {
      < -6.935046, -1.133048, -1.577806>,
      < -6.938964, -1.106062, -1.563306>,
      < -6.904465, -1.102408, -1.572563>
    }
    triangle {
      < -6.935046, -1.133048, -1.577806>,
      < -6.904465, -1.102408, -1.572563>,
      < -6.904465, -1.127759, -1.586112>
    }
    triangle {
      < -6.938964, -1.106062, -1.563306>,
      < -6.943192, -1.076834, -1.554394>,
      < -6.904465, -1.075025, -1.564260>
    }
    triangle {
      < -6.938964, -1.106062, -1.563306>,
      < -6.904465, -1.075025, -1.564260>,
      < -6.904465, -1.102408, -1.572563>
    }
    triangle {
      < -6.943192, -1.076834, -1.554394>,
      < -6.947663, -1.046240, -1.551756>,
      < -6.904465, -1.046170, -1.562022>
    }
    triangle {
      < -6.943192, -1.076834, -1.554394>,
      < -6.904465, -1.046170, -1.562022>,
      < -6.904465, -1.075025, -1.564260>
    }
    triangle {
      < -6.947663, -1.046240, -1.551756>,
      < -6.968915, -1.013440, -1.554527>,
      < -6.904465, -1.015177, -1.564416>
    }
    triangle {
      < -6.947663, -1.046240, -1.551756>,
      < -6.904465, -1.015177, -1.564416>,
      < -6.904465, -1.046170, -1.562022>
    }
    triangle {
      < -6.896595, -1.040784, 1.889553>,
      < -6.889045, -1.016069, 1.887884>,
      < -6.957200, -1.046400, 1.886322>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.718902, -0.906393, 1.569538>,
      < -6.717284, -0.881500, 1.599587>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.717284, -0.881500, 1.599587>,
      < -6.714800, -0.862931, 1.633802>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.714800, -0.862931, 1.633802>,
      < -6.711545, -0.851400, 1.670869>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.711545, -0.851400, 1.670869>,
      < -6.707646, -0.847349, 1.709360>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.707646, -0.847349, 1.709360>,
      < -6.703252, -0.850934, 1.747799>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.703252, -0.850934, 1.747799>,
      < -6.698531, -0.862017, 1.784707>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.698531, -0.862017, 1.784707>,
      < -6.693665, -0.880174, 1.818666>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.693665, -0.880174, 1.818666>,
      < -6.688840, -0.904705, 1.848373>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.688840, -0.904705, 1.848373>,
      < -6.684243, -0.934667, 1.872683>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.684243, -0.934667, 1.872683>,
      < -6.681404, -0.959091, 1.884111>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.681404, -0.959091, 1.884111>,
      < -6.719573, -0.940856, 1.542431>
    }
    triangle {
      < -6.681404, -0.959091, 1.884111>,
      < -6.684243, -0.934667, 1.872683>,
      < -6.989600, -0.953247, 1.856404>
    }
    triangle {
      < -6.681404, -0.959091, 1.884111>,
      < -6.989600, -0.953247, 1.856404>,
      < -6.979515, -0.982234, 1.872808>
    }
    triangle {
      < -6.681404, -0.959091, 1.884111>,
      < -6.979515, -0.982234, 1.872808>,
      < -6.824115, -0.973820, 1.879564>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.719573, -0.940856, 1.542431>,
      < -6.873342, -0.960375, 1.545218>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.873342, -0.960375, 1.545218>,
      < -6.979515, -0.982234, 1.544791>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.979515, -0.982234, 1.544791>,
      < -6.989600, -0.953247, 1.561195>
    }
    triangle {
      < -6.918159, -0.988035, 1.537767>,
      < -6.929565, -1.005945, 1.532979>,
      < -6.968577, -1.013689, 1.534689>
    }
    triangle {
      < -6.918159, -0.988035, 1.537767>,
      < -6.968577, -1.013689, 1.534689>,
      < -6.979515, -0.982234, 1.544791>
    }
    triangle {
      < -6.957200, -1.046400, 1.531278>,
      < -6.968577, -1.013689, 1.534689>,
      < -6.929565, -1.005945, 1.532979>
    }
    triangle {
      < -6.957200, -1.046400, 1.531278>,
      < -6.929565, -1.005945, 1.532979>,
      < -6.937382, -1.042666, 1.529858>
    }
    triangle {
      < -6.910044, -1.088383, 1.532162>,
      < -6.855919, -1.112782, 1.535495>,
      < -6.709947, -1.118215, 1.523827>
    }
    triangle {
      < -6.910044, -1.088383, 1.532162>,
      < -6.709947, -1.118215, 1.523827>,
      < -6.709462, -1.123200, 1.525288>
    }
    triangle {
      < -6.910044, -1.088383, 1.532162>,
      < -6.709462, -1.123200, 1.525288>,
      < -6.945790, -1.113369, 1.544791>
    }
    triangle {
      < -6.910044, -1.088383, 1.532162>,
      < -6.945790, -1.113369, 1.544791>,
      < -6.951384, -1.080540, 1.534689>
    }
    triangle {
      < -6.818439, -1.096457, 1.886577>,
      < -6.859628, -1.081052, 1.887577>,
      < -6.951384, -1.080540, 1.882911>
    }
    triangle {
      < -6.818439, -1.096457, 1.886577>,
      < -6.951384, -1.080540, 1.882911>,
      < -6.945790, -1.113369, 1.872808>
    }
    triangle {
      < -6.707646, -0.847349, 1.709360>,
      < -7.015512, -0.878727, 1.708800>,
      < -7.014389, -0.881949, 1.743432>
    }
    triangle {
      < -6.707646, -0.847349, 1.709360>,
      < -7.014389, -0.881949, 1.743432>,
      < -6.703252, -0.850934, 1.747799>
    }
    triangle {
      < -6.711545, -0.851400, 1.670869>,
      < -7.014389, -0.881949, 1.674167>,
      < -7.015512, -0.878727, 1.708800>
    }
    triangle {
      < -6.711545, -0.851400, 1.670869>,
      < -7.015512, -0.878727, 1.708800>,
      < -6.707646, -0.847349, 1.709360>
    }
    triangle {
      < -6.698531, -0.862017, 1.784707>,
      < -6.703252, -0.850934, 1.747799>,
      < -7.014389, -0.881949, 1.743432>
    }
    triangle {
      < -6.698531, -0.862017, 1.784707>,
      < -7.014389, -0.881949, 1.743432>,
      < -7.011074, -0.891490, 1.776734>
    }
    triangle {
      < -6.714800, -0.862931, 1.633802>,
      < -7.011074, -0.891490, 1.640865>,
      < -7.014389, -0.881949, 1.674167>
    }
    triangle {
      < -6.714800, -0.862931, 1.633802>,
      < -7.014389, -0.881949, 1.674167>,
      < -6.711545, -0.851400, 1.670869>
    }
    triangle {
      < -6.698531, -0.862017, 1.784707>,
      < -7.011074, -0.891490, 1.776734>,
      < -7.005685, -0.906986, 1.807425>
    }
    triangle {
      < -6.698531, -0.862017, 1.784707>,
      < -7.005685, -0.906986, 1.807425>,
      < -6.693665, -0.880174, 1.818666>
    }
    triangle {
      < -6.717284, -0.881500, 1.599587>,
      < -7.005685, -0.906986, 1.610173>,
      < -7.011074, -0.891490, 1.640865>
    }
    triangle {
      < -6.717284, -0.881500, 1.599587>,
      < -7.011074, -0.891490, 1.640865>,
      < -6.714800, -0.862931, 1.633802>
    }
    triangle {
      < -7.053440, -0.887290, 1.708800>,
      < -7.015512, -0.878727, 1.708800>,
      < -7.014389, -0.881949, 1.674167>
    }
    triangle {
      < -7.053440, -0.887290, 1.708800>,
      < -7.014389, -0.881949, 1.674167>,
      < -7.051667, -0.890230, 1.674169>
    }
    triangle {
      < -7.051696, -0.890201, 1.743434>,
      < -7.014389, -0.881949, 1.743432>,
      < -7.015512, -0.878727, 1.708800>
    }
    triangle {
      < -7.051696, -0.890201, 1.743434>,
      < -7.015512, -0.878727, 1.708800>,
      < -7.053440, -0.887290, 1.708800>
    }
    triangle {
      < -6.688840, -0.904705, 1.848373>,
      < -6.693665, -0.880174, 1.818666>,
      < -7.005685, -0.906986, 1.807425>
    }
    triangle {
      < -6.688840, -0.904705, 1.848373>,
      < -7.005685, -0.906986, 1.807425>,
      < -6.998435, -0.927838, 1.834327>
    }
    triangle {
      < -6.718902, -0.906393, 1.569538>,
      < -6.998435, -0.927838, 1.583273>,
      < -7.005685, -0.906986, 1.610173>
    }
    triangle {
      < -6.718902, -0.906393, 1.569538>,
      < -7.005685, -0.906986, 1.610173>,
      < -6.717284, -0.881500, 1.599587>
    }
    triangle {
      < -7.014389, -0.881949, 1.674167>,
      < -7.011074, -0.891490, 1.640865>,
      < -7.046462, -0.898906, 1.640872>
    }
    triangle {
      < -7.014389, -0.881949, 1.674167>,
      < -7.046462, -0.898906, 1.640872>,
      < -7.051667, -0.890230, 1.674169>
    }
    triangle {
      < -7.046517, -0.898849, 1.776742>,
      < -7.011074, -0.891490, 1.776734>,
      < -7.014389, -0.881949, 1.743432>
    }
    triangle {
      < -7.046517, -0.898849, 1.776742>,
      < -7.014389, -0.881949, 1.743432>,
      < -7.051696, -0.890201, 1.743434>
    }
    triangle {
      < -7.038095, -0.912906, 1.807443>,
      < -7.005685, -0.906986, 1.807425>,
      < -7.011074, -0.891490, 1.776734>
    }
    triangle {
      < -7.038095, -0.912906, 1.807443>,
      < -7.011074, -0.891490, 1.776734>,
      < -7.046517, -0.898849, 1.776742>
    }
    triangle {
      < -7.011074, -0.891490, 1.640865>,
      < -7.005685, -0.906986, 1.610173>,
      < -7.038013, -0.912989, 1.610191>
    }
    triangle {
      < -7.011074, -0.891490, 1.640865>,
      < -7.038013, -0.912989, 1.610191>,
      < -7.046462, -0.898906, 1.640872>
    }
    triangle {
      < -6.684243, -0.934667, 1.872683>,
      < -6.688840, -0.904705, 1.848373>,
      < -6.998435, -0.927838, 1.834327>
    }
    triangle {
      < -6.684243, -0.934667, 1.872683>,
      < -6.998435, -0.927838, 1.834327>,
      < -6.989600, -0.953247, 1.856404>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.989600, -0.953247, 1.561195>,
      < -6.998435, -0.927838, 1.583273>
    }
    triangle {
      < -6.719593, -0.936652, 1.544807>,
      < -6.998435, -0.927838, 1.583273>,
      < -6.718902, -0.906393, 1.569538>
    }
    triangle {
      < -7.026746, -0.931825, 1.834356>,
      < -6.998435, -0.927838, 1.834327>,
      < -7.005685, -0.906986, 1.807425>
    }
    triangle {
      < -7.026746, -0.931825, 1.834356>,
      < -7.005685, -0.906986, 1.807425>,
      < -7.038095, -0.912906, 1.807443>
    }
    triangle {
      < -7.005685, -0.906986, 1.610173>,
      < -6.998435, -0.927838, 1.583273>,
      < -7.026640, -0.931931, 1.583303>
    }
    triangle {
      < -7.005685, -0.906986, 1.610173>,
      < -7.026640, -0.931931, 1.583303>,
      < -7.038013, -0.912989, 1.610191>
    }
    triangle {
      < -7.012914, -0.954885, 1.856449>,
      < -6.989600, -0.953247, 1.856404>,
      < -6.998435, -0.927838, 1.834327>
    }
    triangle {
      < -7.012914, -0.954885, 1.856449>,
      < -6.998435, -0.927838, 1.834327>,
      < -7.026746, -0.931825, 1.834356>
    }
    triangle {
      < -7.026640, -0.931931, 1.583303>,
      < -6.998435, -0.927838, 1.583273>,
      < -6.989600, -0.953247, 1.561195>
    }
    triangle {
      < -7.026640, -0.931931, 1.583303>,
      < -6.989600, -0.953247, 1.561195>,
      < -7.012788, -0.955009, 1.561241>
    }
    triangle {
      < -7.012788, -0.955009, 1.561241>,
      < -6.989600, -0.953247, 1.561195>,
      < -6.979515, -0.982234, 1.544791>
    }
    triangle {
      < -7.012788, -0.955009, 1.561241>,
      < -6.979515, -0.982234, 1.544791>,
      < -6.996993, -0.981333, 1.544854>
    }
    triangle {
      < -6.997129, -0.981196, 1.872871>,
      < -6.979515, -0.982234, 1.872808>,
      < -6.989600, -0.953247, 1.856404>
    }
    triangle {
      < -6.997129, -0.981196, 1.872871>,
      < -6.989600, -0.953247, 1.856404>,
      < -7.012914, -0.954885, 1.856449>
    }
    triangle {
      < -6.968577, -1.013689, 1.882911>,
      < -6.979515, -0.982234, 1.872808>,
      < -6.997129, -0.981196, 1.872871>
    }
    triangle {
      < -6.968577, -1.013689, 1.882911>,
      < -6.997129, -0.981196, 1.872871>,
      < -6.980002, -1.009749, 1.882993>
    }
    triangle {
      < -6.979515, -0.982234, 1.544791>,
      < -6.968577, -1.013689, 1.534689>,
      < -6.979856, -1.009895, 1.534771>
    }
    triangle {
      < -6.979515, -0.982234, 1.544791>,
      < -6.979856, -1.009895, 1.534771>,
      < -6.996993, -0.981333, 1.544854>
    }
    triangle {
      < -6.968577, -1.013689, 1.882911>,
      < -6.980002, -1.009749, 1.882993>,
      < -6.957200, -1.046400, 1.886322>
    }
    triangle {
      < -6.957200, -1.046400, 1.531278>,
      < -6.979856, -1.009895, 1.534771>,
      < -6.968577, -1.013689, 1.534689>
    }
    triangle {
      < -6.705269, -1.157442, 1.543269>,
      < -6.940633, -1.143624, 1.561195>,
      < -6.945790, -1.113369, 1.544791>
    }
    triangle {
      < -6.705269, -1.157442, 1.543269>,
      < -6.945790, -1.113369, 1.544791>,
      < -6.709462, -1.123200, 1.525288>
    }
    triangle {
      < -6.669919, -1.155457, 1.871145>,
      < -6.670184, -1.120993, 1.889604>,
      < -6.945790, -1.113369, 1.872808>
    }
    triangle {
      < -6.669919, -1.155457, 1.871145>,
      < -6.945790, -1.113369, 1.872808>,
      < -6.940633, -1.143624, 1.856404>
    }
    triangle {
      < -6.670609, -1.185717, 1.846416>,
      < -6.669919, -1.155457, 1.871145>,
      < -6.940633, -1.143624, 1.856404>
    }
    triangle {
      < -6.670609, -1.185717, 1.846416>,
      < -6.940633, -1.143624, 1.856404>,
      < -6.936112, -1.170142, 1.834327>
    }
    triangle {
      < -6.700672, -1.187404, 1.567580>,
      < -6.936112, -1.170142, 1.583273>,
      < -6.940633, -1.143624, 1.561195>
    }
    triangle {
      < -6.700672, -1.187404, 1.567580>,
      < -6.940633, -1.143624, 1.561195>,
      < -6.705269, -1.157442, 1.543269>
    }
    triangle {
      < -6.695848, -1.211935, 1.597286>,
      < -6.932407, -1.191906, 1.610173>,
      < -6.936112, -1.170142, 1.583273>
    }
    triangle {
      < -6.695848, -1.211935, 1.597286>,
      < -6.936112, -1.170142, 1.583273>,
      < -6.700672, -1.187404, 1.567580>
    }
    triangle {
      < -6.672227, -1.210609, 1.816365>,
      < -6.670609, -1.185717, 1.846416>,
      < -6.936112, -1.170142, 1.834327>
    }
    triangle {
      < -6.672227, -1.210609, 1.816365>,
      < -6.936112, -1.170142, 1.834327>,
      < -6.932407, -1.191906, 1.807425>
    }
    triangle {
      < -6.674712, -1.229178, 1.782150>,
      < -6.672227, -1.210609, 1.816365>,
      < -6.932407, -1.191906, 1.807425>
    }
    triangle {
      < -6.674712, -1.229178, 1.782150>,
      < -6.932407, -1.191906, 1.807425>,
      < -6.929648, -1.208078, 1.776734>
    }
    triangle {
      < -6.695848, -1.211935, 1.597286>,
      < -6.690980, -1.230092, 1.631245>,
      < -6.929648, -1.208078, 1.640865>
    }
    triangle {
      < -6.695848, -1.211935, 1.597286>,
      < -6.929648, -1.208078, 1.640865>,
      < -6.932407, -1.191906, 1.610173>
    }
    triangle {
      < -6.677966, -1.240708, 1.745084>,
      < -6.674712, -1.229178, 1.782150>,
      < -6.929648, -1.208078, 1.776734>
    }
    triangle {
      < -6.677966, -1.240708, 1.745084>,
      < -6.929648, -1.208078, 1.776734>,
      < -6.927948, -1.218035, 1.743432>
    }
    triangle {
      < -6.690980, -1.230092, 1.631245>,
      < -6.686260, -1.241175, 1.668154>,
      < -6.927948, -1.218035, 1.674167>
    }
    triangle {
      < -6.690980, -1.230092, 1.631245>,
      < -6.927948, -1.218035, 1.674167>,
      < -6.929648, -1.208078, 1.640865>
    }
    triangle {
      < -6.686260, -1.241175, 1.668154>,
      < -6.681865, -1.244760, 1.706593>,
      < -6.927377, -1.221398, 1.708800>
    }
    triangle {
      < -6.686260, -1.241175, 1.668154>,
      < -6.927377, -1.221398, 1.708800>,
      < -6.927948, -1.218035, 1.674167>
    }
    triangle {
      < -6.681865, -1.244760, 1.706593>,
      < -6.677966, -1.240708, 1.745084>,
      < -6.927948, -1.218035, 1.743432>
    }
    triangle {
      < -6.681865, -1.244760, 1.706593>,
      < -6.927948, -1.218035, 1.743432>,
      < -6.927377, -1.221398, 1.708800>
    }
    triangle {
      < -6.893028, -0.987278, 1.493569>,
      < -6.873365, -0.975844, 1.497088>,
      < -6.986362, -0.939410, 0.565277>
    }
    triangle {
      < -6.893028, -0.987278, 1.493569>,
      < -6.986362, -0.939410, 0.565277>,
      < -7.007535, -0.965069, 0.566291>
    }
    triangle {
      < -6.857940, -1.021441, 1.925642>,
      < -6.850076, -1.024404, 1.997098>,
      < -6.838296, -1.009549, 1.997098>
    }
    triangle {
      < -6.857940, -1.021441, 1.925642>,
      < -6.838296, -1.009549, 1.997098>,
      < -6.845813, -1.005988, 1.924408>
    }
    triangle {
      < -6.819091, -0.991846, 1.922870>,
      < -6.845813, -1.005988, 1.924408>,
      < -6.838296, -1.009549, 1.997098>
    }
    triangle {
      < -6.819091, -0.991846, 1.922870>,
      < -6.838296, -1.009549, 1.997098>,
      < -6.818653, -0.996843, 1.997098>
    }
    triangle {
      < -6.910412, -1.014001, 1.489675>,
      < -6.893028, -0.987278, 1.493569>,
      < -7.007535, -0.965069, 0.566291>
    }
    triangle {
      < -6.910412, -1.014001, 1.489675>,
      < -7.007535, -0.965069, 0.566291>,
      < -7.020231, -0.995068, 0.566114>
    }
    triangle {
      < -6.858163, -1.055314, 1.926427>,
      < -6.849533, -1.056659, 1.997098>,
      < -6.853990, -1.041407, 1.997098>
    }
    triangle {
      < -6.858163, -1.055314, 1.926427>,
      < -6.853990, -1.041407, 1.997098>,
      < -6.862194, -1.039120, 1.926475>
    }
    triangle {
      < -6.909965, -1.057920, 1.488270>,
      < -6.914555, -1.037143, 1.488165>,
      < -7.024446, -1.029407, 0.564746>
    }
    triangle {
      < -6.909965, -1.057920, 1.488270>,
      < -7.024446, -1.029407, 0.564746>,
      < -7.019647, -1.060207, 0.564746>
    }
    triangle {
      < -6.841156, -1.070764, 1.925938>,
      < -6.831825, -1.071315, 1.997098>,
      < -6.849533, -1.056659, 1.997098>
    }
    triangle {
      < -6.841156, -1.070764, 1.925938>,
      < -6.849533, -1.056659, 1.997098>,
      < -6.858163, -1.055314, 1.926427>
    }
    triangle {
      < -6.810749, -1.086163, 1.925392>,
      < -6.800754, -1.085972, 1.997098>,
      < -6.831825, -1.071315, 1.997098>
    }
    triangle {
      < -6.810749, -1.086163, 1.925392>,
      < -6.831825, -1.071315, 1.997098>,
      < -6.841156, -1.070764, 1.925938>
    }
    triangle {
      < -6.859421, -1.097765, 1.491009>,
      < -6.891643, -1.077870, 1.488896>,
      < -7.000562, -1.089806, 0.563539>
    }
    triangle {
      < -6.859421, -1.097765, 1.491009>,
      < -7.000562, -1.089806, 0.563539>,
      < -6.967073, -1.119405, 0.562333>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.715765, -1.102988, 1.479291>,
      < -6.859421, -1.097765, 1.491009>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.859421, -1.097765, 1.491009>,
      < -6.967073, -1.119405, 0.562333>
    }
    triangle {
      < -6.666987, -1.091349, 1.930437>,
      < -6.658443, -1.089538, 1.997098>,
      < -6.800754, -1.085972, 1.997098>
    }
    triangle {
      < -6.666987, -1.091349, 1.930437>,
      < -6.800754, -1.085972, 1.997098>,
      < -6.810749, -1.086163, 1.925392>
    }
    triangle {
      < -6.873365, -0.975844, 1.497088>,
      < -6.723890, -0.950218, 1.496050>,
      < -6.827199, -0.899603, 0.552779>
    }
    triangle {
      < -6.873365, -0.975844, 1.497088>,
      < -6.827199, -0.899603, 0.552779>,
      < -6.986362, -0.939410, 0.565277>
    }
    triangle {
      < -6.675989, -0.973215, 1.925578>,
      < -6.819091, -0.991846, 1.922870>,
      < -6.818653, -0.996843, 1.997098>
    }
    triangle {
      < -6.675989, -0.973215, 1.925578>,
      < -6.818653, -0.996843, 1.997098>,
      < -6.667999, -0.977043, 1.997098>
    }
    triangle {
      < -6.667999, -0.977043, 1.997098>,
      < -6.818653, -0.996843, 1.997098>,
      < -6.808182, -1.000110, 2.032474>
    }
    triangle {
      < -6.667999, -0.977043, 1.997098>,
      < -6.808182, -1.000110, 2.032474>,
      < -6.663667, -0.982041, 2.032474>
    }
    triangle {
      < -6.654500, -1.084699, 2.032474>,
      < -6.658443, -1.089538, 1.997098>,
      < -6.667999, -0.977043, 1.997098>
    }
    triangle {
      < -6.654500, -1.084699, 2.032474>,
      < -6.667999, -0.977043, 1.997098>,
      < -6.663667, -0.982041, 2.032474>
    }
    triangle {
      < -6.652500, -1.075653, 2.060670>,
      < -6.654500, -1.084699, 2.032474>,
      < -6.663667, -0.982041, 2.032474>
    }
    triangle {
      < -6.652500, -1.075653, 2.060670>,
      < -6.663667, -0.982041, 2.032474>,
      < -6.660625, -0.991222, 2.060670>
    }
    triangle {
      < -6.663667, -0.982041, 2.032474>,
      < -6.808182, -1.000110, 2.032474>,
      < -6.788721, -1.006083, 2.060670>
    }
    triangle {
      < -6.663667, -0.982041, 2.032474>,
      < -6.788721, -1.006083, 2.060670>,
      < -6.660625, -0.991222, 2.060670>
    }
    triangle {
      < -6.658353, -1.007446, 2.081717>,
      < -6.660625, -0.991222, 2.060670>,
      < -6.788721, -1.006083, 2.060670>
    }
    triangle {
      < -6.658353, -1.007446, 2.081717>,
      < -6.788721, -1.006083, 2.060670>,
      < -6.747930, -1.016658, 2.081717>
    }
    triangle {
      < -6.652669, -1.059781, 2.081717>,
      < -6.652500, -1.075653, 2.060670>,
      < -6.660625, -0.991222, 2.060670>
    }
    triangle {
      < -6.652669, -1.059781, 2.081717>,
      < -6.660625, -0.991222, 2.060670>,
      < -6.658353, -1.007446, 2.081717>
    }
    triangle {
      < -6.808182, -1.000110, 2.032474>,
      < -6.818653, -0.996843, 1.997098>,
      < -6.838296, -1.009549, 1.997098>
    }
    triangle {
      < -6.808182, -1.000110, 2.032474>,
      < -6.838296, -1.009549, 1.997098>,
      < -6.827026, -1.011704, 2.032474>
    }
    triangle {
      < -6.788721, -1.006083, 2.060670>,
      < -6.808182, -1.000110, 2.032474>,
      < -6.827026, -1.011704, 2.032474>
    }
    triangle {
      < -6.788721, -1.006083, 2.060670>,
      < -6.827026, -1.011704, 2.032474>,
      < -6.805425, -1.015619, 2.060670>
    }
    triangle {
      < -6.747930, -1.016658, 2.081717>,
      < -6.788721, -1.006083, 2.060670>,
      < -6.805425, -1.015619, 2.060670>
    }
    triangle {
      < -6.747930, -1.016658, 2.081717>,
      < -6.805425, -1.015619, 2.060670>,
      < -6.759613, -1.022568, 2.081717>
    }
    triangle {
      < -6.652669, -1.059781, 2.081717>,
      < -6.658353, -1.007446, 2.081717>,
      < -6.654481, -1.034126, 2.091248>
    }
    triangle {
      < -6.654481, -1.034126, 2.091248>,
      < -6.658353, -1.007446, 2.081717>,
      < -6.747930, -1.016658, 2.081717>
    }
    triangle {
      < -6.838296, -1.009549, 1.997098>,
      < -6.850076, -1.024404, 1.997098>,
      < -6.838327, -1.025260, 2.032474>
    }
    triangle {
      < -6.838296, -1.009549, 1.997098>,
      < -6.838327, -1.025260, 2.032474>,
      < -6.827026, -1.011704, 2.032474>
    }
    triangle {
      < -6.827026, -1.011704, 2.032474>,
      < -6.838327, -1.025260, 2.032474>,
      < -6.815441, -1.026767, 2.060670>
    }
    triangle {
      < -6.827026, -1.011704, 2.032474>,
      < -6.815441, -1.026767, 2.060670>,
      < -6.805425, -1.015619, 2.060670>
    }
    triangle {
      < -6.805425, -1.015619, 2.060670>,
      < -6.815441, -1.026767, 2.060670>,
      < -6.766614, -1.029479, 2.081717>
    }
    triangle {
      < -6.805425, -1.015619, 2.060670>,
      < -6.766614, -1.029479, 2.081717>,
      < -6.759613, -1.022568, 2.081717>
    }
    triangle {
      < -6.654481, -1.034126, 2.091248>,
      < -6.747930, -1.016658, 2.081717>,
      < -6.759613, -1.022568, 2.081717>
    }
    triangle {
      < -6.654481, -1.034126, 2.091248>,
      < -6.759613, -1.022568, 2.081717>,
      < -6.766614, -1.029479, 2.081717>
    }
    triangle {
      < -6.850076, -1.024404, 1.997098>,
      < -6.853990, -1.041407, 1.997098>,
      < -6.842080, -1.040777, 2.032474>
    }
    triangle {
      < -6.850076, -1.024404, 1.997098>,
      < -6.842080, -1.040777, 2.032474>,
      < -6.838327, -1.025260, 2.032474>
    }
    triangle {
      < -6.838327, -1.025260, 2.032474>,
      < -6.842080, -1.040777, 2.032474>,
      < -6.818767, -1.039529, 2.060670>
    }
    triangle {
      < -6.838327, -1.025260, 2.032474>,
      < -6.818767, -1.039529, 2.060670>,
      < -6.815441, -1.026767, 2.060670>
    }
    triangle {
      < -6.815441, -1.026767, 2.060670>,
      < -6.818767, -1.039529, 2.060670>,
      < -6.768942, -1.037389, 2.081717>
    }
    triangle {
      < -6.815441, -1.026767, 2.060670>,
      < -6.768942, -1.037389, 2.081717>,
      < -6.766614, -1.029479, 2.081717>
    }
    triangle {
      < -6.654481, -1.034126, 2.091248>,
      < -6.766614, -1.029479, 2.081717>,
      < -6.768942, -1.037389, 2.081717>
    }
    triangle {
      < -6.737285, -1.058122, 2.081717>,
      < -6.652669, -1.059781, 2.081717>,
      < -6.654481, -1.034126, 2.091248>
    }
    triangle {
      < -6.766294, -1.044485, 2.081717>,
      < -6.755765, -1.051304, 2.081717>,
      < -6.654481, -1.034126, 2.091248>
    }
    triangle {
      < -6.755765, -1.051304, 2.081717>,
      < -6.737285, -1.058122, 2.081717>,
      < -6.654481, -1.034126, 2.091248>
    }
    triangle {
      < -6.768942, -1.037389, 2.081717>,
      < -6.766294, -1.044485, 2.081717>,
      < -6.654481, -1.034126, 2.091248>
    }
    triangle {
      < -6.818767, -1.039529, 2.060670>,
      < -6.814979, -1.050976, 2.060670>,
      < -6.766294, -1.044485, 2.081717>
    }
    triangle {
      < -6.818767, -1.039529, 2.060670>,
      < -6.766294, -1.044485, 2.081717>,
      < -6.768942, -1.037389, 2.081717>
    }
    triangle {
      < -6.842080, -1.040777, 2.032474>,
      < -6.837805, -1.054695, 2.032474>,
      < -6.814979, -1.050976, 2.060670>
    }
    triangle {
      < -6.842080, -1.040777, 2.032474>,
      < -6.814979, -1.050976, 2.060670>,
      < -6.818767, -1.039529, 2.060670>
    }
    triangle {
      < -6.853990, -1.041407, 1.997098>,
      < -6.849533, -1.056659, 1.997098>,
      < -6.837805, -1.054695, 2.032474>
    }
    triangle {
      < -6.853990, -1.041407, 1.997098>,
      < -6.837805, -1.054695, 2.032474>,
      < -6.842080, -1.040777, 2.032474>
    }
    triangle {
      < -6.814979, -1.050976, 2.060670>,
      < -6.799923, -1.061977, 2.060670>,
      < -6.755765, -1.051304, 2.081717>
    }
    triangle {
      < -6.814979, -1.050976, 2.060670>,
      < -6.755765, -1.051304, 2.081717>,
      < -6.766294, -1.044485, 2.081717>
    }
    triangle {
      < -6.837805, -1.054695, 2.032474>,
      < -6.820820, -1.068070, 2.032474>,
      < -6.799923, -1.061977, 2.060670>
    }
    triangle {
      < -6.837805, -1.054695, 2.032474>,
      < -6.799923, -1.061977, 2.060670>,
      < -6.814979, -1.050976, 2.060670>
    }
    triangle {
      < -6.799923, -1.061977, 2.060670>,
      < -6.773502, -1.072977, 2.060670>,
      < -6.737285, -1.058122, 2.081717>
    }
    triangle {
      < -6.799923, -1.061977, 2.060670>,
      < -6.737285, -1.058122, 2.081717>,
      < -6.755765, -1.051304, 2.081717>
    }
    triangle {
      < -6.849533, -1.056659, 1.997098>,
      < -6.831825, -1.071315, 1.997098>,
      < -6.820820, -1.068070, 2.032474>
    }
    triangle {
      < -6.849533, -1.056659, 1.997098>,
      < -6.820820, -1.068070, 2.032474>,
      < -6.837805, -1.054695, 2.032474>
    }
    triangle {
      < -6.773502, -1.072977, 2.060670>,
      < -6.652500, -1.075653, 2.060670>,
      < -6.652669, -1.059781, 2.081717>
    }
    triangle {
      < -6.773502, -1.072977, 2.060670>,
      < -6.652669, -1.059781, 2.081717>,
      < -6.737285, -1.058122, 2.081717>
    }
    triangle {
      < -6.820820, -1.068070, 2.032474>,
      < -6.791013, -1.081445, 2.032474>,
      < -6.773502, -1.072977, 2.060670>
    }
    triangle {
      < -6.820820, -1.068070, 2.032474>,
      < -6.773502, -1.072977, 2.060670>,
      < -6.799923, -1.061977, 2.060670>
    }
    triangle {
      < -6.831825, -1.071315, 1.997098>,
      < -6.800754, -1.085972, 1.997098>,
      < -6.791013, -1.081445, 2.032474>
    }
    triangle {
      < -6.831825, -1.071315, 1.997098>,
      < -6.791013, -1.081445, 2.032474>,
      < -6.820820, -1.068070, 2.032474>
    }
    triangle {
      < -6.791013, -1.081445, 2.032474>,
      < -6.654500, -1.084699, 2.032474>,
      < -6.652500, -1.075653, 2.060670>
    }
    triangle {
      < -6.791013, -1.081445, 2.032474>,
      < -6.652500, -1.075653, 2.060670>,
      < -6.773502, -1.072977, 2.060670>
    }
    triangle {
      < -6.800754, -1.085972, 1.997098>,
      < -6.658443, -1.089538, 1.997098>,
      < -6.654500, -1.084699, 2.032474>
    }
    triangle {
      < -6.800754, -1.085972, 1.997098>,
      < -6.654500, -1.084699, 2.032474>,
      < -6.791013, -1.081445, 2.032474>
    }
    triangle {
      < -7.000562, -1.089806, 0.563539>,
      < -6.891643, -1.077870, 1.488896>,
      < -6.909965, -1.057920, 1.488270>
    }
    triangle {
      < -7.000562, -1.089806, 0.563539>,
      < -6.909965, -1.057920, 1.488270>,
      < -7.019647, -1.060207, 0.564746>
    }
    triangle {
      < -7.024446, -1.029407, 0.564746>,
      < -6.914555, -1.037143, 1.488165>,
      < -6.910412, -1.014001, 1.489675>
    }
    triangle {
      < -7.024446, -1.029407, 0.564746>,
      < -6.910412, -1.014001, 1.489675>,
      < -7.020231, -0.995068, 0.566114>
    }
    triangle {
      < -6.850076, -1.024404, 1.997098>,
      < -6.857940, -1.021441, 1.925642>,
      < -6.862194, -1.039120, 1.926475>
    }
    triangle {
      < -6.850076, -1.024404, 1.997098>,
      < -6.862194, -1.039120, 1.926475>,
      < -6.853990, -1.041407, 1.997098>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.669919, -1.155457, 1.871145>,
      < -6.670609, -1.185717, 1.846416>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.670609, -1.185717, 1.846416>,
      < -6.672227, -1.210609, 1.816365>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.672227, -1.210609, 1.816365>,
      < -6.674712, -1.229178, 1.782150>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.674712, -1.229178, 1.782150>,
      < -6.677966, -1.240708, 1.745084>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.677966, -1.240708, 1.745084>,
      < -6.681865, -1.244760, 1.706593>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.681865, -1.244760, 1.706593>,
      < -6.686260, -1.241175, 1.668154>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.686260, -1.241175, 1.668154>,
      < -6.690980, -1.230092, 1.631245>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.690980, -1.230092, 1.631245>,
      < -6.695848, -1.211935, 1.597286>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.695848, -1.211935, 1.597286>,
      < -6.700672, -1.187404, 1.567580>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.700672, -1.187404, 1.567580>,
      < -6.705269, -1.157442, 1.543269>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.705269, -1.157442, 1.543269>,
      < -6.709462, -1.123200, 1.525288>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.709462, -1.123200, 1.525288>,
      < -6.709947, -1.118215, 1.523827>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.709947, -1.118215, 1.523827>,
      < -6.670900, -1.101832, 1.894609>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.827199, -0.899603, 0.552779>,
      < -6.723890, -0.950218, 1.496050>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.723890, -0.950218, 1.496050>,
      < -6.675989, -0.973215, 1.925578>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.675989, -0.973215, 1.925578>,
      < -6.667999, -0.977043, 1.997098>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.667999, -0.977043, 1.997098>,
      < -6.658443, -1.089538, 1.997098>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.658443, -1.089538, 1.997098>,
      < -6.666987, -1.091349, 1.930437>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.666987, -1.091349, 1.930437>,
      < -6.715765, -1.102988, 1.479291>
    }
    triangle {
      < -6.866357, -0.992143, 1.884759>,
      < -6.968577, -1.013689, 1.882911>,
      < -6.957200, -1.046400, 1.886322>
    }
    triangle {
      < -6.866357, -0.992143, 1.884759>,
      < -6.957200, -1.046400, 1.886322>,
      < -6.889045, -1.016069, 1.887884>
    }
    triangle {
      < -6.880362, -1.065960, 1.889546>,
      < -6.896595, -1.040784, 1.889553>,
      < -6.957200, -1.046400, 1.886322>
    }
    triangle {
      < -6.859628, -1.081052, 1.887577>,
      < -6.880362, -1.065960, 1.889546>,
      < -6.957200, -1.046400, 1.886322>
    }
    triangle {
      < -6.859628, -1.081052, 1.887577>,
      < -6.957200, -1.046400, 1.886322>,
      < -6.951384, -1.080540, 1.882911>
    }
    triangle {
      < -6.910044, -1.088383, 1.532162>,
      < -6.951384, -1.080540, 1.534689>,
      < -6.927031, -1.068548, 1.531153>
    }
    triangle {
      < -6.957200, -1.046400, 1.531278>,
      < -6.937382, -1.042666, 1.529858>,
      < -6.927031, -1.068548, 1.531153>
    }
    triangle {
      < -6.957200, -1.046400, 1.531278>,
      < -6.927031, -1.068548, 1.531153>,
      < -6.951384, -1.080540, 1.534689>
    }
    triangle {
      < -6.873342, -0.960375, 1.545218>,
      < -6.918159, -0.988035, 1.537767>,
      < -6.979515, -0.982234, 1.544791>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.670900, -1.101832, 1.894609>,
      < -6.818439, -1.096457, 1.886577>
    }
    triangle {
      < -6.670184, -1.120993, 1.889604>,
      < -6.818439, -1.096457, 1.886577>,
      < -6.945790, -1.113369, 1.872808>
    }
    triangle {
      < -6.968577, -1.013689, 1.882911>,
      < -6.866357, -0.992143, 1.884759>,
      < -6.824115, -0.973820, 1.879564>
    }
    triangle {
      < -6.968577, -1.013689, 1.882911>,
      < -6.824115, -0.973820, 1.879564>,
      < -6.979515, -0.982234, 1.872808>
    }
    triangle {
      < -6.873342, -0.960375, 1.545218>,
      < -6.719573, -0.940856, 1.542431>,
      < -6.723890, -0.950218, 1.496050>
    }
    triangle {
      < -6.873342, -0.960375, 1.545218>,
      < -6.723890, -0.950218, 1.496050>,
      < -6.873365, -0.975844, 1.497088>
    }
    triangle {
      < -6.918159, -0.988035, 1.537767>,
      < -6.873342, -0.960375, 1.545218>,
      < -6.873365, -0.975844, 1.497088>
    }
    triangle {
      < -6.918159, -0.988035, 1.537767>,
      < -6.873365, -0.975844, 1.497088>,
      < -6.893028, -0.987278, 1.493569>
    }
    triangle {
      < -6.929565, -1.005945, 1.532979>,
      < -6.918159, -0.988035, 1.537767>,
      < -6.893028, -0.987278, 1.493569>
    }
    triangle {
      < -6.929565, -1.005945, 1.532979>,
      < -6.893028, -0.987278, 1.493569>,
      < -6.910412, -1.014001, 1.489675>
    }
    triangle {
      < -6.937382, -1.042666, 1.529858>,
      < -6.929565, -1.005945, 1.532979>,
      < -6.910412, -1.014001, 1.489675>
    }
    triangle {
      < -6.937382, -1.042666, 1.529858>,
      < -6.910412, -1.014001, 1.489675>,
      < -6.914555, -1.037143, 1.488165>
    }
    triangle {
      < -6.927031, -1.068548, 1.531153>,
      < -6.937382, -1.042666, 1.529858>,
      < -6.914555, -1.037143, 1.488165>
    }
    triangle {
      < -6.927031, -1.068548, 1.531153>,
      < -6.914555, -1.037143, 1.488165>,
      < -6.909965, -1.057920, 1.488270>
    }
    triangle {
      < -6.910044, -1.088383, 1.532162>,
      < -6.927031, -1.068548, 1.531153>,
      < -6.909965, -1.057920, 1.488270>
    }
    triangle {
      < -6.910044, -1.088383, 1.532162>,
      < -6.909965, -1.057920, 1.488270>,
      < -6.891643, -1.077870, 1.488896>
    }
    triangle {
      < -6.855919, -1.112782, 1.535495>,
      < -6.910044, -1.088383, 1.532162>,
      < -6.891643, -1.077870, 1.488896>
    }
    triangle {
      < -6.855919, -1.112782, 1.535495>,
      < -6.891643, -1.077870, 1.488896>,
      < -6.859421, -1.097765, 1.491009>
    }
    triangle {
      < -6.709947, -1.118215, 1.523827>,
      < -6.855919, -1.112782, 1.535495>,
      < -6.859421, -1.097765, 1.491009>
    }
    triangle {
      < -6.709947, -1.118215, 1.523827>,
      < -6.859421, -1.097765, 1.491009>,
      < -6.715765, -1.102988, 1.479291>
    }
    triangle {
      < -6.681404, -0.959091, 1.884111>,
      < -6.824115, -0.973820, 1.879564>,
      < -6.819091, -0.991846, 1.922870>
    }
    triangle {
      < -6.681404, -0.959091, 1.884111>,
      < -6.819091, -0.991846, 1.922870>,
      < -6.675989, -0.973215, 1.925578>
    }
    triangle {
      < -6.824115, -0.973820, 1.879564>,
      < -6.866357, -0.992143, 1.884759>,
      < -6.845813, -1.005988, 1.924408>
    }
    triangle {
      < -6.824115, -0.973820, 1.879564>,
      < -6.845813, -1.005988, 1.924408>,
      < -6.819091, -0.991846, 1.922870>
    }
    triangle {
      < -6.866357, -0.992143, 1.884759>,
      < -6.889045, -1.016069, 1.887884>,
      < -6.857940, -1.021441, 1.925642>
    }
    triangle {
      < -6.866357, -0.992143, 1.884759>,
      < -6.857940, -1.021441, 1.925642>,
      < -6.845813, -1.005988, 1.924408>
    }
    triangle {
      < -6.889045, -1.016069, 1.887884>,
      < -6.896595, -1.040784, 1.889553>,
      < -6.862194, -1.039120, 1.926475>
    }
    triangle {
      < -6.889045, -1.016069, 1.887884>,
      < -6.862194, -1.039120, 1.926475>,
      < -6.857940, -1.021441, 1.925642>
    }
    triangle {
      < -6.896595, -1.040784, 1.889553>,
      < -6.880362, -1.065960, 1.889546>,
      < -6.858163, -1.055314, 1.926427>
    }
    triangle {
      < -6.896595, -1.040784, 1.889553>,
      < -6.858163, -1.055314, 1.926427>,
      < -6.862194, -1.039120, 1.926475>
    }
    triangle {
      < -6.880362, -1.065960, 1.889546>,
      < -6.859628, -1.081052, 1.887577>,
      < -6.841156, -1.070764, 1.925938>
    }
    triangle {
      < -6.880362, -1.065960, 1.889546>,
      < -6.841156, -1.070764, 1.925938>,
      < -6.858163, -1.055314, 1.926427>
    }
    triangle {
      < -6.859628, -1.081052, 1.887577>,
      < -6.818439, -1.096457, 1.886577>,
      < -6.810749, -1.086163, 1.925392>
    }
    triangle {
      < -6.859628, -1.081052, 1.887577>,
      < -6.810749, -1.086163, 1.925392>,
      < -6.841156, -1.070764, 1.925938>
    }
    triangle {
      < -6.818439, -1.096457, 1.886577>,
      < -6.670900, -1.101832, 1.894609>,
      < -6.666987, -1.091349, 1.930437>
    }
    triangle {
      < -6.818439, -1.096457, 1.886577>,
      < -6.666987, -1.091349, 1.930437>,
      < -6.810749, -1.086163, 1.925392>
    }
    triangle {
      < -6.719573, -0.940856, 1.542431>,
      < -6.681404, -0.959091, 1.884111>,
      < -6.675989, -0.973215, 1.925578>
    }
    triangle {
      < -6.719573, -0.940856, 1.542431>,
      < -6.675989, -0.973215, 1.925578>,
      < -6.723890, -0.950218, 1.496050>
    }
    triangle {
      < -6.670900, -1.101832, 1.894609>,
      < -6.709947, -1.118215, 1.523827>,
      < -6.715765, -1.102988, 1.479291>
    }
    triangle {
      < -6.670900, -1.101832, 1.894609>,
      < -6.715765, -1.102988, 1.479291>,
      < -6.666987, -1.091349, 1.930437>
    }
    triangle {
      < -7.055372, -0.899450, 1.676105>,
      < -7.057078, -0.896686, 1.708805>,
      < -7.053440, -0.887290, 1.708800>
    }
    triangle {
      < -7.055372, -0.899450, 1.676105>,
      < -7.053440, -0.887290, 1.708800>,
      < -7.051667, -0.890230, 1.674169>
    }
    triangle {
      < -7.057078, -0.896686, 1.708805>,
      < -7.055400, -0.899423, 1.741509>,
      < -7.051696, -0.890201, 1.743434>
    }
    triangle {
      < -7.057078, -0.896686, 1.708805>,
      < -7.051696, -0.890201, 1.743434>,
      < -7.053440, -0.887290, 1.708800>
    }
    triangle {
      < -7.055400, -0.899423, 1.741509>,
      < -7.050418, -0.907551, 1.772954>,
      < -7.046517, -0.898849, 1.776742>
    }
    triangle {
      < -7.055400, -0.899423, 1.741509>,
      < -7.046517, -0.898849, 1.776742>,
      < -7.051696, -0.890201, 1.743434>
    }
    triangle {
      < -7.050418, -0.907551, 1.772954>,
      < -7.042318, -0.920759, 1.801926>,
      < -7.038095, -0.912906, 1.807443>
    }
    triangle {
      < -7.050418, -0.907551, 1.772954>,
      < -7.038095, -0.912906, 1.807443>,
      < -7.046517, -0.898849, 1.776742>
    }
    triangle {
      < -7.042318, -0.920759, 1.801926>,
      < -7.031406, -0.938525, 1.827311>,
      < -7.026746, -0.931825, 1.834356>
    }
    triangle {
      < -7.042318, -0.920759, 1.801926>,
      < -7.026746, -0.931825, 1.834356>,
      < -7.038095, -0.912906, 1.807443>
    }
    triangle {
      < -7.031406, -0.938525, 1.827311>,
      < -7.018111, -0.960166, 1.848138>,
      < -7.012914, -0.954885, 1.856449>
    }
    triangle {
      < -7.031406, -0.938525, 1.827311>,
      < -7.012914, -0.954885, 1.856449>,
      < -7.026746, -0.931825, 1.834356>
    }
    triangle {
      < -7.018111, -0.960166, 1.848138>,
      < -7.002946, -0.984845, 1.863612>,
      < -6.997129, -0.981196, 1.872871>
    }
    triangle {
      < -7.018111, -0.960166, 1.848138>,
      < -6.997129, -0.981196, 1.872871>,
      < -7.012914, -0.954885, 1.856449>
    }
    triangle {
      < -7.002946, -0.984845, 1.863612>,
      < -6.986531, -1.011518, 1.873113>,
      < -6.980002, -1.009749, 1.882993>
    }
    triangle {
      < -7.002946, -0.984845, 1.863612>,
      < -6.980002, -1.009749, 1.882993>,
      < -6.997129, -0.981196, 1.872871>
    }
    triangle {
      < -6.986531, -1.011518, 1.873113>,
      < -6.964439, -1.046296, 1.876093>,
      < -6.957200, -1.046400, 1.886322>
    }
    triangle {
      < -6.986531, -1.011518, 1.873113>,
      < -6.957200, -1.046400, 1.886322>,
      < -6.980002, -1.009749, 1.882993>
    }
    triangle {
      < -6.964439, -1.046296, 1.876093>,
      < -6.959292, -1.078673, 1.873063>,
      < -6.951384, -1.080540, 1.882911>
    }
    triangle {
      < -6.964439, -1.046296, 1.876093>,
      < -6.951384, -1.080540, 1.882911>,
      < -6.957200, -1.046400, 1.886322>
    }
    triangle {
      < -6.959292, -1.078673, 1.873063>,
      < -6.954376, -1.109715, 1.863551>,
      < -6.945790, -1.113369, 1.872808>
    }
    triangle {
      < -6.959292, -1.078673, 1.873063>,
      < -6.945790, -1.113369, 1.872808>,
      < -6.951384, -1.080540, 1.882911>
    }
    triangle {
      < -6.954376, -1.109715, 1.863551>,
      < -6.949838, -1.138336, 1.848098>,
      < -6.940633, -1.143624, 1.856404>
    }
    triangle {
      < -6.954376, -1.109715, 1.863551>,
      < -6.940633, -1.143624, 1.856404>,
      < -6.945790, -1.113369, 1.872808>
    }
    triangle {
      < -6.949838, -1.138336, 1.848098>,
      < -6.945855, -1.163436, 1.827289>,
      < -6.936112, -1.170142, 1.834327>
    }
    triangle {
      < -6.949838, -1.138336, 1.848098>,
      < -6.936112, -1.170142, 1.834327>,
      < -6.940633, -1.143624, 1.856404>
    }
    triangle {
      < -6.945855, -1.163436, 1.827289>,
      < -6.942586, -1.184049, 1.801915>,
      < -6.932407, -1.191906, 1.807425>
    }
    triangle {
      < -6.945855, -1.163436, 1.827289>,
      < -6.932407, -1.191906, 1.807425>,
      < -6.936112, -1.170142, 1.834327>
    }
    triangle {
      < -6.942586, -1.184049, 1.801915>,
      < -6.940148, -1.199374, 1.772950>,
      < -6.929648, -1.208078, 1.776734>
    }
    triangle {
      < -6.942586, -1.184049, 1.801915>,
      < -6.929648, -1.208078, 1.776734>,
      < -6.932407, -1.191906, 1.807425>
    }
    triangle {
      < -6.940148, -1.199374, 1.772950>,
      < -6.938645, -1.208813, 1.741507>,
      < -6.927948, -1.218035, 1.743432>
    }
    triangle {
      < -6.940148, -1.199374, 1.772950>,
      < -6.927948, -1.218035, 1.743432>,
      < -6.929648, -1.208078, 1.776734>
    }
    triangle {
      < -6.938645, -1.208813, 1.741507>,
      < -6.938140, -1.212002, 1.708800>,
      < -6.927377, -1.221398, 1.708800>
    }
    triangle {
      < -6.938645, -1.208813, 1.741507>,
      < -6.927377, -1.221398, 1.708800>,
      < -6.927948, -1.218035, 1.743432>
    }
    triangle {
      < -6.938140, -1.212002, 1.708800>,
      < -6.938645, -1.208813, 1.676092>,
      < -6.927948, -1.218035, 1.674167>
    }
    triangle {
      < -6.938140, -1.212002, 1.708800>,
      < -6.927948, -1.218035, 1.674167>,
      < -6.927377, -1.221398, 1.708800>
    }
    triangle {
      < -6.938645, -1.208813, 1.676092>,
      < -6.940149, -1.199374, 1.644649>,
      < -6.929648, -1.208078, 1.640865>
    }
    triangle {
      < -6.938645, -1.208813, 1.676092>,
      < -6.929648, -1.208078, 1.640865>,
      < -6.927948, -1.218035, 1.674167>
    }
    triangle {
      < -6.940149, -1.199374, 1.644649>,
      < -6.942586, -1.184049, 1.615683>,
      < -6.932407, -1.191906, 1.610173>
    }
    triangle {
      < -6.940149, -1.199374, 1.644649>,
      < -6.932407, -1.191906, 1.610173>,
      < -6.929648, -1.208078, 1.640865>
    }
    triangle {
      < -6.942586, -1.184049, 1.615683>,
      < -6.945856, -1.163436, 1.590311>,
      < -6.936112, -1.170142, 1.583273>
    }
    triangle {
      < -6.942586, -1.184049, 1.615683>,
      < -6.936112, -1.170142, 1.583273>,
      < -6.932407, -1.191906, 1.610173>
    }
    triangle {
      < -6.945856, -1.163436, 1.590311>,
      < -6.949839, -1.138336, 1.569501>,
      < -6.940633, -1.143624, 1.561195>
    }
    triangle {
      < -6.945856, -1.163436, 1.590311>,
      < -6.940633, -1.143624, 1.561195>,
      < -6.936112, -1.170142, 1.583273>
    }
    triangle {
      < -6.949839, -1.138336, 1.569501>,
      < -6.954377, -1.109715, 1.554049>,
      < -6.945790, -1.113369, 1.544791>
    }
    triangle {
      < -6.949839, -1.138336, 1.569501>,
      < -6.945790, -1.113369, 1.544791>,
      < -6.940633, -1.143624, 1.561195>
    }
    triangle {
      < -6.954377, -1.109715, 1.554049>,
      < -6.959293, -1.078673, 1.544537>,
      < -6.951384, -1.080540, 1.534689>
    }
    triangle {
      < -6.954377, -1.109715, 1.554049>,
      < -6.951384, -1.080540, 1.534689>,
      < -6.945790, -1.113369, 1.544791>
    }
    triangle {
      < -6.959293, -1.078673, 1.544537>,
      < -6.964433, -1.046317, 1.541509>,
      < -6.957200, -1.046400, 1.531278>
    }
    triangle {
      < -6.959293, -1.078673, 1.544537>,
      < -6.957200, -1.046400, 1.531278>,
      < -6.951384, -1.080540, 1.534689>
    }
    triangle {
      < -6.964433, -1.046317, 1.541509>,
      < -6.986382, -1.011678, 1.544646>,
      < -6.979856, -1.009895, 1.534771>
    }
    triangle {
      < -6.964433, -1.046317, 1.541509>,
      < -6.979856, -1.009895, 1.534771>,
      < -6.957200, -1.046400, 1.531278>
    }
    triangle {
      < -6.986382, -1.011678, 1.544646>,
      < -7.002814, -0.984973, 1.554118>,
      < -6.996993, -0.981333, 1.544854>
    }
    triangle {
      < -6.986382, -1.011678, 1.544646>,
      < -6.996993, -0.981333, 1.544854>,
      < -6.979856, -1.009895, 1.534771>
    }
    triangle {
      < -7.002814, -0.984973, 1.554118>,
      < -7.017990, -0.960282, 1.569558>,
      < -7.012788, -0.955009, 1.561241>
    }
    triangle {
      < -7.002814, -0.984973, 1.554118>,
      < -7.012788, -0.955009, 1.561241>,
      < -6.996993, -0.981333, 1.544854>
    }
    triangle {
      < -7.017990, -0.960282, 1.569558>,
      < -7.031303, -0.938624, 1.590356>,
      < -7.026640, -0.931931, 1.583303>
    }
    triangle {
      < -7.017990, -0.960282, 1.569558>,
      < -7.026640, -0.931931, 1.583303>,
      < -7.012788, -0.955009, 1.561241>
    }
    triangle {
      < -7.031303, -0.938624, 1.590356>,
      < -7.042238, -0.920836, 1.615717>,
      < -7.038013, -0.912989, 1.610191>
    }
    triangle {
      < -7.031303, -0.938624, 1.590356>,
      < -7.038013, -0.912989, 1.610191>,
      < -7.026640, -0.931931, 1.583303>
    }
    triangle {
      < -7.042238, -0.920836, 1.615717>,
      < -7.050364, -0.907605, 1.644670>,
      < -7.046462, -0.898906, 1.640872>
    }
    triangle {
      < -7.042238, -0.920836, 1.615717>,
      < -7.046462, -0.898906, 1.640872>,
      < -7.038013, -0.912989, 1.610191>
    }
    triangle {
      < -7.050364, -0.907605, 1.644670>,
      < -7.055372, -0.899450, 1.676105>,
      < -7.051667, -0.890230, 1.674169>
    }
    triangle {
      < -7.050364, -0.907605, 1.644670>,
      < -7.051667, -0.890230, 1.674169>,
      < -7.046462, -0.898906, 1.640872>
    }
    triangle {
      < -7.011967, -0.945317, 1.597408>,
      < -7.022464, -0.928684, 1.621243>,
      < -7.042238, -0.920836, 1.615717>
    }
    triangle {
      < -7.011967, -0.945317, 1.597408>,
      < -7.042238, -0.920836, 1.615717>,
      < -7.031303, -0.938624, 1.590356>
    }
    triangle {
      < -7.022464, -0.928684, 1.621243>,
      < -7.030267, -0.916304, 1.648468>,
      < -7.050364, -0.907605, 1.644670>
    }
    triangle {
      < -7.022464, -0.928684, 1.621243>,
      < -7.050364, -0.907605, 1.644670>,
      < -7.042238, -0.920836, 1.615717>
    }
    triangle {
      < -7.030267, -0.916304, 1.648468>,
      < -7.035077, -0.908669, 1.678040>,
      < -7.055372, -0.899450, 1.676105>
    }
    triangle {
      < -7.030267, -0.916304, 1.648468>,
      < -7.055372, -0.899450, 1.676105>,
      < -7.050364, -0.907605, 1.644670>
    }
    triangle {
      < -7.035077, -0.908669, 1.678040>,
      < -7.036716, -0.906082, 1.708811>,
      < -7.057078, -0.896686, 1.708805>
    }
    triangle {
      < -7.035077, -0.908669, 1.678040>,
      < -7.057078, -0.896686, 1.708805>,
      < -7.055372, -0.899450, 1.676105>
    }
    triangle {
      < -7.036716, -0.906082, 1.708811>,
      < -7.035104, -0.908644, 1.739584>,
      < -7.055400, -0.899423, 1.741509>
    }
    triangle {
      < -7.036716, -0.906082, 1.708811>,
      < -7.055400, -0.899423, 1.741509>,
      < -7.057078, -0.896686, 1.708805>
    }
    triangle {
      < -7.035104, -0.908644, 1.739584>,
      < -7.030319, -0.916254, 1.769166>,
      < -7.050418, -0.907551, 1.772954>
    }
    triangle {
      < -7.035104, -0.908644, 1.739584>,
      < -7.050418, -0.907551, 1.772954>,
      < -7.055400, -0.899423, 1.741509>
    }
    triangle {
      < -7.030319, -0.916254, 1.769166>,
      < -7.022541, -0.928612, 1.796410>,
      < -7.042318, -0.920759, 1.801926>
    }
    triangle {
      < -7.030319, -0.916254, 1.769166>,
      < -7.042318, -0.920759, 1.801926>,
      < -7.050418, -0.907551, 1.772954>
    }
    triangle {
      < -7.022541, -0.928612, 1.796410>,
      < -7.012066, -0.945225, 1.820267>,
      < -7.031406, -0.938525, 1.827311>
    }
    triangle {
      < -7.022541, -0.928612, 1.796410>,
      < -7.031406, -0.938525, 1.827311>,
      < -7.042318, -0.920759, 1.801926>
    }
    triangle {
      < -7.012066, -0.945225, 1.820267>,
      < -6.999309, -0.965448, 1.839828>,
      < -7.018111, -0.960166, 1.848138>
    }
    triangle {
      < -7.012066, -0.945225, 1.820267>,
      < -7.018111, -0.960166, 1.848138>,
      < -7.031406, -0.938525, 1.827311>
    }
    triangle {
      < -6.999309, -0.965448, 1.839828>,
      < -6.984763, -0.988495, 1.854352>,
      < -7.002946, -0.984845, 1.863612>
    }
    triangle {
      < -6.999309, -0.965448, 1.839828>,
      < -7.002946, -0.984845, 1.863612>,
      < -7.018111, -0.960166, 1.848138>
    }
    triangle {
      < -6.984763, -0.988495, 1.854352>,
      < -6.969069, -1.013266, 1.863225>,
      < -6.986531, -1.011518, 1.873113>
    }
    triangle {
      < -6.984763, -0.988495, 1.854352>,
      < -6.986531, -1.011518, 1.873113>,
      < -7.002946, -0.984845, 1.863612>
    }
    triangle {
      < -6.969069, -1.013266, 1.863225>,
      < -6.947677, -1.046199, 1.865847>,
      < -6.964439, -1.046296, 1.876093>
    }
    triangle {
      < -6.969069, -1.013266, 1.863225>,
      < -6.964439, -1.046296, 1.876093>,
      < -6.986531, -1.011518, 1.873113>
    }
    triangle {
      < -6.947677, -1.046199, 1.865847>,
      < -6.943190, -1.076833, 1.863206>,
      < -6.959292, -1.078673, 1.873063>
    }
    triangle {
      < -6.947677, -1.046199, 1.865847>,
      < -6.959292, -1.078673, 1.873063>,
      < -6.964439, -1.046296, 1.876093>
    }
    triangle {
      < -6.943190, -1.076833, 1.863206>,
      < -6.938961, -1.106061, 1.854293>,
      < -6.954376, -1.109715, 1.863551>
    }
    triangle {
      < -6.943190, -1.076833, 1.863206>,
      < -6.954376, -1.109715, 1.863551>,
      < -6.959292, -1.078673, 1.873063>
    }
    triangle {
      < -6.938961, -1.106061, 1.854293>,
      < -6.935043, -1.133047, 1.839792>,
      < -6.949838, -1.138336, 1.848098>
    }
    triangle {
      < -6.938961, -1.106061, 1.854293>,
      < -6.949838, -1.138336, 1.848098>,
      < -6.954376, -1.109715, 1.863551>
    }
    triangle {
      < -6.935043, -1.133047, 1.839792>,
      < -6.931598, -1.156729, 1.820251>,
      < -6.945855, -1.163436, 1.827289>
    }
    triangle {
      < -6.935043, -1.133047, 1.839792>,
      < -6.945855, -1.163436, 1.827289>,
      < -6.949838, -1.138336, 1.848098>
    }
    triangle {
      < -6.931598, -1.156729, 1.820251>,
      < -6.928765, -1.176191, 1.796405>,
      < -6.942586, -1.184049, 1.801915>
    }
    triangle {
      < -6.931598, -1.156729, 1.820251>,
      < -6.942586, -1.184049, 1.801915>,
      < -6.945855, -1.163436, 1.827289>
    }
    triangle {
      < -6.928765, -1.176191, 1.796405>,
      < -6.926649, -1.190669, 1.769166>,
      < -6.940148, -1.199374, 1.772950>
    }
    triangle {
      < -6.928765, -1.176191, 1.796405>,
      < -6.940148, -1.199374, 1.772950>,
      < -6.942586, -1.184049, 1.801915>
    }
    triangle {
      < -6.926649, -1.190669, 1.769166>,
      < -6.925343, -1.199592, 1.739582>,
      < -6.938645, -1.208813, 1.741507>
    }
    triangle {
      < -6.926649, -1.190669, 1.769166>,
      < -6.938645, -1.208813, 1.741507>,
      < -6.940148, -1.199374, 1.772950>
    }
    triangle {
      < -6.925343, -1.199592, 1.739582>,
      < -6.924903, -1.202606, 1.708800>,
      < -6.938140, -1.212002, 1.708800>
    }
    triangle {
      < -6.925343, -1.199592, 1.739582>,
      < -6.938140, -1.212002, 1.708800>,
      < -6.938645, -1.208813, 1.741507>
    }
    triangle {
      < -6.924903, -1.202606, 1.708800>,
      < -6.925343, -1.199592, 1.678017>,
      < -6.938645, -1.208813, 1.676092>
    }
    triangle {
      < -6.924903, -1.202606, 1.708800>,
      < -6.938645, -1.208813, 1.676092>,
      < -6.938140, -1.212002, 1.708800>
    }
    triangle {
      < -6.925343, -1.199592, 1.678017>,
      < -6.926651, -1.190670, 1.648432>,
      < -6.940149, -1.199374, 1.644649>
    }
    triangle {
      < -6.925343, -1.199592, 1.678017>,
      < -6.940149, -1.199374, 1.644649>,
      < -6.938645, -1.208813, 1.676092>
    }
    triangle {
      < -6.926651, -1.190670, 1.648432>,
      < -6.928767, -1.176192, 1.621193>,
      < -6.942586, -1.184049, 1.615683>
    }
    triangle {
      < -6.926651, -1.190670, 1.648432>,
      < -6.942586, -1.184049, 1.615683>,
      < -6.940149, -1.199374, 1.644649>
    }
    triangle {
      < -6.928767, -1.176192, 1.621193>,
      < -6.931600, -1.156730, 1.597349>,
      < -6.945856, -1.163436, 1.590311>
    }
    triangle {
      < -6.928767, -1.176192, 1.621193>,
      < -6.945856, -1.163436, 1.590311>,
      < -6.942586, -1.184049, 1.615683>
    }
    triangle {
      < -6.931600, -1.156730, 1.597349>,
      < -6.935046, -1.133048, 1.577806>,
      < -6.949839, -1.138336, 1.569501>
    }
    triangle {
      < -6.931600, -1.156730, 1.597349>,
      < -6.949839, -1.138336, 1.569501>,
      < -6.945856, -1.163436, 1.590311>
    }
    triangle {
      < -6.935046, -1.133048, 1.577806>,
      < -6.938964, -1.106062, 1.563306>,
      < -6.954377, -1.109715, 1.554049>
    }
    triangle {
      < -6.935046, -1.133048, 1.577806>,
      < -6.954377, -1.109715, 1.554049>,
      < -6.949839, -1.138336, 1.569501>
    }
    triangle {
      < -6.938964, -1.106062, 1.563306>,
      < -6.943192, -1.076834, 1.554394>,
      < -6.959293, -1.078673, 1.544537>
    }
    triangle {
      < -6.938964, -1.106062, 1.563306>,
      < -6.959293, -1.078673, 1.544537>,
      < -6.954377, -1.109715, 1.554049>
    }
    triangle {
      < -6.943192, -1.076834, 1.554394>,
      < -6.947663, -1.046240, 1.551756>,
      < -6.964433, -1.046317, 1.541509>
    }
    triangle {
      < -6.943192, -1.076834, 1.554394>,
      < -6.964433, -1.046317, 1.541509>,
      < -6.959293, -1.078673, 1.544537>
    }
    triangle {
      < -6.947663, -1.046240, 1.551756>,
      < -6.968915, -1.013440, 1.554527>,
      < -6.986382, -1.011678, 1.544646>
    }
    triangle {
      < -6.947663, -1.046240, 1.551756>,
      < -6.986382, -1.011678, 1.544646>,
      < -6.964433, -1.046317, 1.541509>
    }
    triangle {
      < -6.968915, -1.013440, 1.554527>,
      < -6.984635, -0.988613, 1.563382>,
      < -7.002814, -0.984973, 1.554118>
    }
    triangle {
      < -6.968915, -1.013440, 1.554527>,
      < -7.002814, -0.984973, 1.554118>,
      < -6.986382, -1.011678, 1.544646>
    }
    triangle {
      < -6.984635, -0.988613, 1.563382>,
      < -6.999192, -0.965555, 1.577874>,
      < -7.017990, -0.960282, 1.569558>
    }
    triangle {
      < -6.984635, -0.988613, 1.563382>,
      < -7.017990, -0.960282, 1.569558>,
      < -7.002814, -0.984973, 1.554118>
    }
    triangle {
      < -6.999192, -0.965555, 1.577874>,
      < -7.011967, -0.945317, 1.597408>,
      < -7.031303, -0.938624, 1.590356>
    }
    triangle {
      < -6.999192, -0.965555, 1.577874>,
      < -7.031303, -0.938624, 1.590356>,
      < -7.017990, -0.960282, 1.569558>
    }
    triangle {
      < -6.904465, -1.015177, 1.564416>,
      < -6.904465, -0.992253, 1.572645>,
      < -6.984635, -0.988613, 1.563382>
    }
    triangle {
      < -6.904465, -1.015177, 1.564416>,
      < -6.984635, -0.988613, 1.563382>,
      < -6.968915, -1.013440, 1.554527>
    }
    triangle {
      < -6.904465, -0.992253, 1.572645>,
      < -6.904465, -0.970829, 1.586191>,
      < -6.999192, -0.965555, 1.577874>
    }
    triangle {
      < -6.904465, -0.992253, 1.572645>,
      < -6.999192, -0.965555, 1.577874>,
      < -6.984635, -0.988613, 1.563382>
    }
    triangle {
      < -6.904465, -0.970829, 1.586191>,
      < -6.904465, -0.952010, 1.604460>,
      < -7.011967, -0.945317, 1.597408>
    }
    triangle {
      < -6.904465, -0.970829, 1.586191>,
      < -7.011967, -0.945317, 1.597408>,
      < -6.999192, -0.965555, 1.577874>
    }
    triangle {
      < -6.904465, -0.952010, 1.604460>,
      < -6.904465, -0.936532, 1.626768>,
      < -7.022464, -0.928684, 1.621243>
    }
    triangle {
      < -6.904465, -0.952010, 1.604460>,
      < -7.022464, -0.928684, 1.621243>,
      < -7.011967, -0.945317, 1.597408>
    }
    triangle {
      < -6.904465, -0.936532, 1.626768>,
      < -6.904465, -0.925003, 1.652266>,
      < -7.030267, -0.916304, 1.648468>
    }
    triangle {
      < -6.904465, -0.936532, 1.626768>,
      < -7.030267, -0.916304, 1.648468>,
      < -7.022464, -0.928684, 1.621243>
    }
    triangle {
      < -6.904465, -0.925003, 1.652266>,
      < -6.904465, -0.917890, 1.679976>,
      < -7.035077, -0.908669, 1.678040>
    }
    triangle {
      < -6.904465, -0.925003, 1.652266>,
      < -7.035077, -0.908669, 1.678040>,
      < -7.030267, -0.916304, 1.648468>
    }
    triangle {
      < -6.904465, -0.917890, 1.679976>,
      < -6.904465, -0.915478, 1.708816>,
      < -7.036716, -0.906082, 1.708811>
    }
    triangle {
      < -6.904465, -0.917890, 1.679976>,
      < -7.036716, -0.906082, 1.708811>,
      < -7.035077, -0.908669, 1.678040>
    }
    triangle {
      < -6.904465, -0.915478, 1.708816>,
      < -6.904465, -0.917866, 1.737659>,
      < -7.035104, -0.908644, 1.739584>
    }
    triangle {
      < -6.904465, -0.915478, 1.708816>,
      < -7.035104, -0.908644, 1.739584>,
      < -7.036716, -0.906082, 1.708811>
    }
    triangle {
      < -6.904465, -0.917866, 1.737659>,
      < -6.904465, -0.924957, 1.765378>,
      < -7.030319, -0.916254, 1.769166>
    }
    triangle {
      < -6.904465, -0.917866, 1.737659>,
      < -7.030319, -0.916254, 1.769166>,
      < -7.035104, -0.908644, 1.739584>
    }
    triangle {
      < -6.904465, -0.924957, 1.765378>,
      < -6.904465, -0.936466, 1.790894>,
      < -7.022541, -0.928612, 1.796410>
    }
    triangle {
      < -6.904465, -0.924957, 1.765378>,
      < -7.022541, -0.928612, 1.796410>,
      < -7.030319, -0.916254, 1.769166>
    }
    triangle {
      < -6.904465, -0.936466, 1.790894>,
      < -6.904465, -0.951925, 1.813223>,
      < -7.012066, -0.945225, 1.820267>
    }
    triangle {
      < -6.904465, -0.936466, 1.790894>,
      < -7.012066, -0.945225, 1.820267>,
      < -7.022541, -0.928612, 1.796410>
    }
    triangle {
      < -6.904465, -0.951925, 1.813223>,
      < -6.904465, -0.970730, 1.831518>,
      < -6.999309, -0.965448, 1.839828>
    }
    triangle {
      < -6.904465, -0.951925, 1.813223>,
      < -6.999309, -0.965448, 1.839828>,
      < -7.012066, -0.945225, 1.820267>
    }
    triangle {
      < -6.904465, -0.970730, 1.831518>,
      < -6.904465, -0.992145, 1.845094>,
      < -6.984763, -0.988495, 1.854352>
    }
    triangle {
      < -6.904465, -0.970730, 1.831518>,
      < -6.984763, -0.988495, 1.854352>,
      < -6.999309, -0.965448, 1.839828>
    }
    triangle {
      < -6.904465, -0.992145, 1.845094>,
      < -6.904465, -1.014989, 1.853330>,
      < -6.969069, -1.013266, 1.863225>
    }
    triangle {
      < -6.904465, -0.992145, 1.845094>,
      < -6.969069, -1.013266, 1.863225>,
      < -6.984763, -0.988495, 1.854352>
    }
    triangle {
      < -6.904465, -1.014989, 1.853330>,
      < -6.904465, -1.046108, 1.855581>,
      < -6.947677, -1.046199, 1.865847>
    }
    triangle {
      < -6.904465, -1.014989, 1.853330>,
      < -6.947677, -1.046199, 1.865847>,
      < -6.969069, -1.013266, 1.863225>
    }
    triangle {
      < -6.904465, -1.046108, 1.855581>,
      < -6.904465, -1.075025, 1.853340>,
      < -6.943190, -1.076833, 1.863206>
    }
    triangle {
      < -6.904465, -1.046108, 1.855581>,
      < -6.943190, -1.076833, 1.863206>,
      < -6.947677, -1.046199, 1.865847>
    }
    triangle {
      < -6.904465, -1.075025, 1.853340>,
      < -6.904465, -1.102407, 1.845036>,
      < -6.938961, -1.106061, 1.854293>
    }
    triangle {
      < -6.904465, -1.075025, 1.853340>,
      < -6.938961, -1.106061, 1.854293>,
      < -6.943190, -1.076833, 1.863206>
    }
    triangle {
      < -6.904465, -1.102407, 1.845036>,
      < -6.904465, -1.127759, 1.831487>,
      < -6.935043, -1.133047, 1.839792>
    }
    triangle {
      < -6.904465, -1.102407, 1.845036>,
      < -6.935043, -1.133047, 1.839792>,
      < -6.938961, -1.106061, 1.854293>
    }
    triangle {
      < -6.904465, -1.127759, 1.831487>,
      < -6.904465, -1.150022, 1.813214>,
      < -6.931598, -1.156729, 1.820251>
    }
    triangle {
      < -6.904465, -1.127759, 1.831487>,
      < -6.931598, -1.156729, 1.820251>,
      < -6.935043, -1.133047, 1.839792>
    }
    triangle {
      < -6.904465, -1.150022, 1.813214>,
      < -6.904465, -1.168333, 1.790896>,
      < -6.928765, -1.176191, 1.796405>
    }
    triangle {
      < -6.904465, -1.150022, 1.813214>,
      < -6.928765, -1.176191, 1.796405>,
      < -6.931598, -1.156729, 1.820251>
    }
    triangle {
      < -6.904465, -1.168333, 1.790896>,
      < -6.904465, -1.181965, 1.765383>,
      < -6.926649, -1.190669, 1.769166>
    }
    triangle {
      < -6.904465, -1.168333, 1.790896>,
      < -6.926649, -1.190669, 1.769166>,
      < -6.928765, -1.176191, 1.796405>
    }
    triangle {
      < -6.904465, -1.181965, 1.765383>,
      < -6.904465, -1.190369, 1.737657>,
      < -6.925343, -1.199592, 1.739582>
    }
    triangle {
      < -6.904465, -1.181965, 1.765383>,
      < -6.925343, -1.199592, 1.739582>,
      < -6.926649, -1.190669, 1.769166>
    }
    triangle {
      < -6.904465, -1.190369, 1.737657>,
      < -6.904465, -1.193210, 1.708800>,
      < -6.924903, -1.202606, 1.708800>
    }
    triangle {
      < -6.904465, -1.190369, 1.737657>,
      < -6.924903, -1.202606, 1.708800>,
      < -6.925343, -1.199592, 1.739582>
    }
    triangle {
      < -6.904465, -1.193210, 1.708800>,
      < -6.904465, -1.190369, 1.679942>,
      < -6.925343, -1.199592, 1.678017>
    }
    triangle {
      < -6.904465, -1.193210, 1.708800>,
      < -6.925343, -1.199592, 1.678017>,
      < -6.924903, -1.202606, 1.708800>
    }
    triangle {
      < -6.904465, -1.190369, 1.679942>,
      < -6.904465, -1.181965, 1.652216>,
      < -6.926651, -1.190670, 1.648432>
    }
    triangle {
      < -6.904465, -1.190369, 1.679942>,
      < -6.926651, -1.190670, 1.648432>,
      < -6.925343, -1.199592, 1.678017>
    }
    triangle {
      < -6.904465, -1.181965, 1.652216>,
      < -6.904465, -1.168334, 1.626702>,
      < -6.928767, -1.176192, 1.621193>
    }
    triangle {
      < -6.904465, -1.181965, 1.652216>,
      < -6.928767, -1.176192, 1.621193>,
      < -6.926651, -1.190670, 1.648432>
    }
    triangle {
      < -6.904465, -1.168334, 1.626702>,
      < -6.904465, -1.150023, 1.604386>,
      < -6.931600, -1.156730, 1.597349>
    }
    triangle {
      < -6.904465, -1.168334, 1.626702>,
      < -6.931600, -1.156730, 1.597349>,
      < -6.928767, -1.176192, 1.621193>
    }
    triangle {
      < -6.904465, -1.150023, 1.604386>,
      < -6.904465, -1.127759, 1.586112>,
      < -6.935046, -1.133048, 1.577806>
    }
    triangle {
      < -6.904465, -1.150023, 1.604386>,
      < -6.935046, -1.133048, 1.577806>,
      < -6.931600, -1.156730, 1.597349>
    }
    triangle {
      < -6.904465, -1.127759, 1.586112>,
      < -6.904465, -1.102408, 1.572563>,
      < -6.938964, -1.106062, 1.563306>
    }
    triangle {
      < -6.904465, -1.127759, 1.586112>,
      < -6.938964, -1.106062, 1.563306>,
      < -6.935046, -1.133048, 1.577806>
    }
    triangle {
      < -6.904465, -1.102408, 1.572563>,
      < -6.904465, -1.075025, 1.564260>,
      < -6.943192, -1.076834, 1.554394>
    }
    triangle {
      < -6.904465, -1.102408, 1.572563>,
      < -6.943192, -1.076834, 1.554394>,
      < -6.938964, -1.106062, 1.563306>
    }
    triangle {
      < -6.904465, -1.075025, 1.564260>,
      < -6.904465, -1.046170, 1.562022>,
      < -6.947663, -1.046240, 1.551756>
    }
    triangle {
      < -6.904465, -1.075025, 1.564260>,
      < -6.947663, -1.046240, 1.551756>,
      < -6.943192, -1.076834, 1.554394>
    }
    triangle {
      < -6.904465, -1.046170, 1.562022>,
      < -6.904465, -1.015177, 1.564416>,
      < -6.968915, -1.013440, 1.554527>
    }
    triangle {
      < -6.904465, -1.046170, 1.562022>,
      < -6.968915, -1.013440, 1.554527>,
      < -6.947663, -1.046240, 1.551756>
    }
    triangle {
      < -1.001572, 1.576626, -2.329360>,
      < -0.998839, 1.579408, -2.289442>,
      < -0.600383, 1.572212, -2.278188>
    }
    triangle {
      < -1.001572, 1.576626, -2.329360>,
      < -0.600383, 1.572212, -2.278188>,
      < -0.600850, 1.573510, -2.322724>
    }
    triangle {
      < -0.575657, 0.538790, -2.483112>,
      < -0.441565, 0.481225, -2.501955>,
      < -0.565329, 0.539749, -2.483513>
    }
    triangle {
      < -0.441565, 0.481225, -2.501955>,
      < -0.443789, 0.479750, -2.581917>,
      < -0.566527, 0.538481, -2.537906>
    }
    triangle {
      < -0.441565, 0.481225, -2.501955>,
      < -0.566527, 0.538481, -2.537906>,
      < -0.565329, 0.539749, -2.483513>
    }
    triangle {
      < -0.443789, 0.479750, -2.581917>,
      < -0.914157, 0.494912, -2.560705>,
      < -0.937812, 0.552421, -2.521091>
    }
    triangle {
      < -0.443789, 0.479750, -2.581917>,
      < -0.937812, 0.552421, -2.521091>,
      < -0.566527, 0.538481, -2.537906>
    }
    triangle {
      < -0.565329, 0.539749, -2.483513>,
      < -0.566527, 0.538481, -2.537906>,
      < -0.576124, 0.540088, -2.527648>
    }
    triangle {
      < -0.565329, 0.539749, -2.483513>,
      < -0.576124, 0.540088, -2.527648>,
      < -0.575657, 0.538790, -2.483112>
    }
    triangle {
      < -0.566527, 0.538481, -2.537906>,
      < -0.937812, 0.552421, -2.521091>,
      < -0.976847, 0.555205, -2.507884>
    }
    triangle {
      < -0.566527, 0.538481, -2.537906>,
      < -0.976847, 0.555205, -2.507884>,
      < -0.576124, 0.540088, -2.527648>
    }
    triangle {
      < -0.575657, 0.538790, -2.483112>,
      < -0.576124, 0.540088, -2.527648>,
      < -0.600850, 1.573510, -2.322724>
    }
    triangle {
      < -0.575657, 0.538790, -2.483112>,
      < -0.600850, 1.573510, -2.322724>,
      < -0.600383, 1.572212, -2.278188>
    }
    triangle {
      < -0.972757, 0.557578, -2.469685>,
      < -0.575657, 0.538790, -2.483112>,
      < -0.626836, 0.590539, -2.470842>
    }
    triangle {
      < -0.972757, 0.557578, -2.469685>,
      < -0.626836, 0.590539, -2.470842>,
      < -0.924028, 0.604633, -2.464607>
    }
    triangle {
      < -0.575657, 0.538790, -2.483112>,
      < -0.600383, 1.572212, -2.278188>,
      < -0.649177, 1.525230, -2.292849>
    }
    triangle {
      < -0.575657, 0.538790, -2.483112>,
      < -0.649177, 1.525230, -2.292849>,
      < -0.626836, 0.590539, -2.470842>
    }
    triangle {
      < -0.600383, 1.572212, -2.278188>,
      < -0.998839, 1.579408, -2.289442>,
      < -0.947583, 1.527573, -2.301732>
    }
    triangle {
      < -0.600383, 1.572212, -2.278188>,
      < -0.947583, 1.527573, -2.301732>,
      < -0.649177, 1.525230, -2.292849>
    }
    triangle {
      < -1.001572, 1.576626, -2.329360>,
      < -0.600850, 1.573510, -2.322724>,
      < -0.649581, 1.526013, -2.336698>
    }
    triangle {
      < -1.001572, 1.576626, -2.329360>,
      < -0.649581, 1.526013, -2.336698>,
      < -0.950451, 1.525363, -2.342247>
    }
    triangle {
      < -0.600850, 1.573510, -2.322724>,
      < -0.576124, 0.540088, -2.527648>,
      < -0.627246, 0.591351, -2.514760>
    }
    triangle {
      < -0.600850, 1.573510, -2.322724>,
      < -0.627246, 0.591351, -2.514760>,
      < -0.649581, 1.526013, -2.336698>
    }
    triangle {
      < -0.576124, 0.540088, -2.527648>,
      < -0.976847, 0.555205, -2.507884>,
      < -0.928116, 0.602701, -2.503510>
    }
    triangle {
      < -0.576124, 0.540088, -2.527648>,
      < -0.928116, 0.602701, -2.503510>,
      < -0.627246, 0.591351, -2.514760>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -0.441565, 0.481225, -2.501955>,
      < -0.575657, 0.538790, -2.483112>
    }
    triangle {
      < -1.077008, 0.499510, -2.477921>,
      < -0.575657, 0.538790, -2.483112>,
      < -0.972757, 0.557578, -2.469685>
    }
    triangle {
      < -0.600850, 1.573510, 2.322724>,
      < -0.600383, 1.572212, 2.278188>,
      < -0.998839, 1.579408, 2.289442>
    }
    triangle {
      < -0.600850, 1.573510, 2.322724>,
      < -0.998839, 1.579408, 2.289442>,
      < -1.001572, 1.576626, 2.329360>
    }
    triangle {
      < -0.565329, 0.539749, 2.483513>,
      < -0.441565, 0.481225, 2.501955>,
      < -0.575657, 0.538790, 2.483112>
    }
    triangle {
      < -0.565329, 0.539749, 2.483513>,
      < -0.566527, 0.538481, 2.537906>,
      < -0.443789, 0.479750, 2.581917>
    }
    triangle {
      < -0.565329, 0.539749, 2.483513>,
      < -0.443789, 0.479750, 2.581917>,
      < -0.441565, 0.481225, 2.501955>
    }
    triangle {
      < -0.566527, 0.538481, 2.537906>,
      < -0.937812, 0.552421, 2.521091>,
      < -0.914157, 0.494912, 2.560705>
    }
    triangle {
      < -0.566527, 0.538481, 2.537906>,
      < -0.914157, 0.494912, 2.560705>,
      < -0.443789, 0.479750, 2.581917>
    }
    triangle {
      < -0.575657, 0.538790, 2.483112>,
      < -0.576124, 0.540088, 2.527648>,
      < -0.566527, 0.538481, 2.537906>
    }
    triangle {
      < -0.575657, 0.538790, 2.483112>,
      < -0.566527, 0.538481, 2.537906>,
      < -0.565329, 0.539749, 2.483513>
    }
    triangle {
      < -0.576124, 0.540088, 2.527648>,
      < -0.976847, 0.555205, 2.507884>,
      < -0.937812, 0.552421, 2.521091>
    }
    triangle {
      < -0.576124, 0.540088, 2.527648>,
      < -0.937812, 0.552421, 2.521091>,
      < -0.566527, 0.538481, 2.537906>
    }
    triangle {
      < -0.600383, 1.572212, 2.278188>,
      < -0.600850, 1.573510, 2.322724>,
      < -0.576124, 0.540088, 2.527648>
    }
    triangle {
      < -0.600383, 1.572212, 2.278188>,
      < -0.576124, 0.540088, 2.527648>,
      < -0.575657, 0.538790, 2.483112>
    }
    triangle {
      < -0.924028, 0.604633, 2.464607>,
      < -0.626836, 0.590539, 2.470842>,
      < -0.575657, 0.538790, 2.483112>
    }
    triangle {
      < -0.924028, 0.604633, 2.464607>,
      < -0.575657, 0.538790, 2.483112>,
      < -0.972757, 0.557578, 2.469685>
    }
    triangle {
      < -0.626836, 0.590539, 2.470842>,
      < -0.649177, 1.525230, 2.292849>,
      < -0.600383, 1.572212, 2.278188>
    }
    triangle {
      < -0.626836, 0.590539, 2.470842>,
      < -0.600383, 1.572212, 2.278188>,
      < -0.575657, 0.538790, 2.483112>
    }
    triangle {
      < -0.649177, 1.525230, 2.292849>,
      < -0.947583, 1.527573, 2.301732>,
      < -0.998839, 1.579408, 2.289442>
    }
    triangle {
      < -0.649177, 1.525230, 2.292849>,
      < -0.998839, 1.579408, 2.289442>,
      < -0.600383, 1.572212, 2.278188>
    }
    triangle {
      < -0.950451, 1.525363, 2.342247>,
      < -0.649581, 1.526013, 2.336698>,
      < -0.600850, 1.573510, 2.322724>
    }
    triangle {
      < -0.950451, 1.525363, 2.342247>,
      < -0.600850, 1.573510, 2.322724>,
      < -1.001572, 1.576626, 2.329360>
    }
    triangle {
      < -0.649581, 1.526013, 2.336698>,
      < -0.627246, 0.591351, 2.514760>,
      < -0.576124, 0.540088, 2.527648>
    }
    triangle {
      < -0.649581, 1.526013, 2.336698>,
      < -0.576124, 0.540088, 2.527648>,
      < -0.600850, 1.573510, 2.322724>
    }
    triangle {
      < -0.627246, 0.591351, 2.514760>,
      < -0.928116, 0.602701, 2.503510>,
      < -0.976847, 0.555205, 2.507884>
    }
    triangle {
      < -0.627246, 0.591351, 2.514760>,
      < -0.976847, 0.555205, 2.507884>,
      < -0.576124, 0.540088, 2.527648>
    }
    triangle {
      < -0.972757, 0.557578, 2.469685>,
      < -0.575657, 0.538790, 2.483112>,
      < -0.441565, 0.481225, 2.501955>
    }
    triangle {
      < -0.972757, 0.557578, 2.469685>,
      < -0.441565, 0.481225, 2.501955>,
      < -1.077008, 0.499510, 2.477921>
    }
    triangle {
      < -6.886522, -0.891369, -0.000006>,
      < -6.871792, -0.892162, -0.140769>,
      < -6.983802, -0.913666, -0.129772>
    }
    triangle {
      < -6.886522, -0.891369, -0.000006>,
      < -6.983802, -0.913666, -0.129772>,
      < -7.001808, -0.913647, 0.000000>
    }
    triangle {
      < -6.886522, -0.891369, -0.000006>,
      < -6.873619, -1.127051, -0.000001>,
      < -6.858819, -1.126941, -0.138298>
    }
    triangle {
      < -6.886522, -0.891369, -0.000006>,
      < -6.858819, -1.126941, -0.138298>,
      < -6.871792, -0.892162, -0.140769>
    }
    triangle {
      < -6.983802, -0.913666, -0.129772>,
      < -6.871792, -0.892162, -0.140769>,
      < -6.980532, -0.907000, -0.146452>
    }
    triangle {
      < -6.871792, -0.892162, -0.140769>,
      < -6.828636, -0.900248, -0.539049>,
      < -6.977396, -0.917010, -0.534543>
    }
    triangle {
      < -6.871792, -0.892162, -0.140769>,
      < -6.977396, -0.917010, -0.534543>,
      < -6.980532, -0.907000, -0.146452>
    }
    triangle {
      < -6.827199, -0.899603, -0.552779>,
      < -6.828636, -0.900248, -0.539049>,
      < -6.813701, -1.126607, -0.559919>
    }
    triangle {
      < -6.828636, -0.900248, -0.539049>,
      < -6.827199, -0.899603, -0.552779>,
      < -6.978443, -0.937348, -0.545746>
    }
    triangle {
      < -6.828636, -0.900248, -0.539049>,
      < -6.978443, -0.937348, -0.545746>,
      < -6.977396, -0.917010, -0.534543>
    }
    triangle {
      < -6.986362, -0.939410, -0.565277>,
      < -6.978443, -0.937348, -0.545746>,
      < -6.827199, -0.899603, -0.552779>
    }
    triangle {
      < -6.983802, -0.913666, -0.129772>,
      < -6.980532, -0.907000, -0.146452>,
      < -7.019966, -0.911996, -0.149186>
    }
    triangle {
      < -6.983802, -0.913666, -0.129772>,
      < -7.019966, -0.911996, -0.149186>,
      < -7.024054, -0.920329, -0.128336>
    }
    triangle {
      < -6.980532, -0.907000, -0.146452>,
      < -6.977396, -0.917010, -0.534543>,
      < -7.010245, -0.922430, -0.530327>
    }
    triangle {
      < -6.980532, -0.907000, -0.146452>,
      < -7.010245, -0.922430, -0.530327>,
      < -7.019966, -0.911996, -0.149186>
    }
    triangle {
      < -7.019966, -0.911996, -0.149186>,
      < -7.010245, -0.922430, -0.530327>,
      < -7.038868, -0.929404, -0.516616>
    }
    triangle {
      < -7.019966, -0.911996, -0.149186>,
      < -7.038868, -0.929404, -0.516616>,
      < -7.059401, -0.919393, -0.151920>
    }
    triangle {
      < -7.059401, -0.919393, -0.151920>,
      < -7.064306, -0.929392, -0.126900>,
      < -7.024054, -0.920329, -0.128336>
    }
    triangle {
      < -7.059401, -0.919393, -0.151920>,
      < -7.024054, -0.920329, -0.128336>,
      < -7.019966, -0.911996, -0.149186>
    }
    triangle {
      < -7.001808, -0.913647, 0.000000>,
      < -6.983802, -0.913666, -0.129772>,
      < -7.024054, -0.920329, -0.128336>
    }
    triangle {
      < -7.001808, -0.913647, 0.000000>,
      < -7.024054, -0.920329, -0.128336>,
      < -7.039476, -0.920313, 0.000000>
    }
    triangle {
      < -7.038868, -0.929404, -0.516616>,
      < -7.056583, -0.964400, -0.421163>,
      < -7.072464, -0.958079, -0.159185>
    }
    triangle {
      < -7.038868, -0.929404, -0.516616>,
      < -7.072464, -0.958079, -0.159185>,
      < -7.059401, -0.919393, -0.151920>
    }
    triangle {
      < -7.064306, -0.929392, -0.126900>,
      < -7.059401, -0.919393, -0.151920>,
      < -7.072464, -0.958079, -0.159185>
    }
    triangle {
      < -7.064306, -0.929392, -0.126900>,
      < -7.072464, -0.958079, -0.159185>,
      < -7.076698, -0.963606, -0.138298>
    }
    triangle {
      < -6.977396, -0.917010, -0.534543>,
      < -6.978443, -0.937348, -0.545746>,
      < -7.004519, -0.948634, -0.534332>
    }
    triangle {
      < -6.977396, -0.917010, -0.534543>,
      < -7.004519, -0.948634, -0.534332>,
      < -7.010245, -0.922430, -0.530327>
    }
    triangle {
      < -7.038868, -0.929404, -0.516616>,
      < -7.010245, -0.922430, -0.530327>,
      < -7.004519, -0.948634, -0.534332>
    }
    triangle {
      < -7.038868, -0.929404, -0.516616>,
      < -7.004519, -0.948634, -0.534332>,
      < -7.026527, -0.953779, -0.515213>
    }
    triangle {
      < -7.084741, -0.963822, -0.032127>,
      < -7.077146, -0.929379, 0.000000>,
      < -7.064306, -0.929392, -0.126900>
    }
    triangle {
      < -7.084741, -0.963822, -0.032127>,
      < -7.064306, -0.929392, -0.126900>,
      < -7.076698, -0.963606, -0.138298>
    }
    triangle {
      < -7.047873, -0.979402, -0.455426>,
      < -7.056583, -0.964400, -0.421163>,
      < -7.038868, -0.929404, -0.516616>
    }
    triangle {
      < -7.047873, -0.979402, -0.455426>,
      < -7.038868, -0.929404, -0.516616>,
      < -7.026527, -0.953779, -0.515213>
    }
    triangle {
      < -6.978443, -0.937348, -0.545746>,
      < -6.986362, -0.939410, -0.565277>,
      < -7.009945, -0.965061, -0.552114>
    }
    triangle {
      < -6.978443, -0.937348, -0.545746>,
      < -7.009945, -0.965061, -0.552114>,
      < -7.004519, -0.948634, -0.534332>
    }
    triangle {
      < -7.009945, -0.965061, -0.552114>,
      < -6.986362, -0.939410, -0.565277>,
      < -7.007535, -0.965069, -0.566291>
    }
    triangle {
      < -7.026527, -0.953779, -0.515213>,
      < -7.004519, -0.948634, -0.534332>,
      < -7.009945, -0.965061, -0.552114>
    }
    triangle {
      < -7.026527, -0.953779, -0.515213>,
      < -7.009945, -0.965061, -0.552114>,
      < -7.030439, -0.979405, -0.523954>
    }
    triangle {
      < -7.026527, -0.953779, -0.515213>,
      < -7.030439, -0.979405, -0.523954>,
      < -7.047873, -0.979402, -0.455426>
    }
    triangle {
      < -7.058405, -0.975069, -0.407000>,
      < -7.056583, -0.964400, -0.421163>,
      < -7.067813, -1.029401, -0.487254>
    }
    triangle {
      < -7.058405, -0.975069, -0.407000>,
      < -7.067813, -1.029401, -0.487254>,
      < -7.064786, -1.029065, -0.445514>
    }
    triangle {
      < -7.058405, -0.975069, -0.407000>,
      < -7.064786, -1.029065, -0.445514>,
      < -7.062660, -1.011067, -0.432676>
    }
    triangle {
      < -7.047873, -0.979402, -0.455426>,
      < -7.067813, -1.029401, -0.487254>,
      < -7.056583, -0.964400, -0.421163>
    }
    triangle {
      < -7.009945, -0.965061, -0.552114>,
      < -7.007535, -0.965069, -0.566291>,
      < -7.020231, -0.995068, -0.566114>
    }
    triangle {
      < -7.009945, -0.965061, -0.552114>,
      < -7.020231, -0.995068, -0.566114>,
      < -7.030439, -0.979405, -0.523954>
    }
    triangle {
      < -7.030439, -0.979405, -0.523954>,
      < -7.067813, -1.029401, -0.487254>,
      < -7.047873, -0.979402, -0.455426>
    }
    triangle {
      < -7.030439, -0.979405, -0.523954>,
      < -7.020231, -0.995068, -0.566114>,
      < -7.024446, -1.029407, -0.564746>
    }
    triangle {
      < -7.024446, -1.029407, -0.564746>,
      < -7.067813, -1.029401, -0.487254>,
      < -7.030439, -0.979405, -0.523954>
    }
    triangle {
      < -7.069734, -1.050319, -0.428379>,
      < -7.064786, -1.029065, -0.445514>,
      < -7.067813, -1.029401, -0.487254>
    }
    triangle {
      < -7.067813, -1.029401, -0.487254>,
      < -7.024446, -1.029407, -0.564746>,
      < -7.019647, -1.060207, -0.564746>
    }
    triangle {
      < -7.067813, -1.029401, -0.487254>,
      < -7.019647, -1.060207, -0.564746>,
      < -7.063015, -1.060201, -0.487254>
    }
    triangle {
      < -7.069734, -1.050319, -0.428379>,
      < -7.067813, -1.029401, -0.487254>,
      < -7.063015, -1.060201, -0.487254>
    }
    triangle {
      < -7.069734, -1.050319, -0.428379>,
      < -7.063015, -1.060201, -0.487254>,
      < -7.070283, -1.080199, -0.428782>
    }
    triangle {
      < -7.069734, -1.050319, -0.428379>,
      < -7.070283, -1.080199, -0.428782>,
      < -7.099136, -1.096855, -0.138298>
    }
    triangle {
      < -7.069734, -1.050319, -0.428379>,
      < -7.099136, -1.096855, -0.138298>,
      < -7.094644, -1.067653, -0.137597>
    }
    triangle {
      < -7.063015, -1.060201, -0.487254>,
      < -7.019647, -1.060207, -0.564746>,
      < -7.000562, -1.089806, -0.563539>
    }
    triangle {
      < -7.063015, -1.060201, -0.487254>,
      < -7.000562, -1.089806, -0.563539>,
      < -6.967073, -1.119405, -0.562333>
    }
    triangle {
      < -7.063015, -1.060201, -0.487254>,
      < -6.967073, -1.119405, -0.562333>,
      < -7.070283, -1.080199, -0.428782>
    }
    triangle {
      < -7.070283, -1.080199, -0.428782>,
      < -6.967073, -1.119405, -0.562333>,
      < -7.021850, -1.119405, -0.138298>
    }
    triangle {
      < -7.070283, -1.080199, -0.428782>,
      < -7.021850, -1.119405, -0.138298>,
      < -7.099136, -1.096855, -0.138298>
    }
    triangle {
      < -6.967073, -1.119405, -0.562333>,
      < -6.813701, -1.126607, -0.559919>,
      < -6.858819, -1.126941, -0.138298>
    }
    triangle {
      < -6.967073, -1.119405, -0.562333>,
      < -6.858819, -1.126941, -0.138298>,
      < -7.021850, -1.119405, -0.138298>
    }
    triangle {
      < -7.077146, -0.929379, 0.000000>,
      < -7.039476, -0.920313, 0.000000>,
      < -7.024054, -0.920329, -0.128336>
    }
    triangle {
      < -7.077146, -0.929379, 0.000000>,
      < -7.024054, -0.920329, -0.128336>,
      < -7.064306, -0.929392, -0.126900>
    }
    triangle {
      < -7.001808, -0.913647, 0.000000>,
      < -6.983802, -0.913666, 0.129772>,
      < -6.871792, -0.892162, 0.140769>
    }
    triangle {
      < -7.001808, -0.913647, 0.000000>,
      < -6.871792, -0.892162, 0.140769>,
      < -6.886522, -0.891369, -0.000006>
    }
    triangle {
      < -6.871792, -0.892162, 0.140769>,
      < -6.858819, -1.126941, 0.138298>,
      < -6.873619, -1.127051, -0.000001>
    }
    triangle {
      < -6.871792, -0.892162, 0.140769>,
      < -6.873619, -1.127051, -0.000001>,
      < -6.886522, -0.891369, -0.000006>
    }
    triangle {
      < -6.980532, -0.907000, 0.146452>,
      < -6.871792, -0.892162, 0.140769>,
      < -6.983802, -0.913666, 0.129772>
    }
    triangle {
      < -6.980532, -0.907000, 0.146452>,
      < -6.977396, -0.917010, 0.534543>,
      < -6.828636, -0.900248, 0.539049>
    }
    triangle {
      < -6.980532, -0.907000, 0.146452>,
      < -6.828636, -0.900248, 0.539049>,
      < -6.871792, -0.892162, 0.140769>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.828636, -0.900248, 0.539049>,
      < -6.827199, -0.899603, 0.552779>
    }
    triangle {
      < -6.977396, -0.917010, 0.534543>,
      < -6.978443, -0.937348, 0.545746>,
      < -6.827199, -0.899603, 0.552779>
    }
    triangle {
      < -6.977396, -0.917010, 0.534543>,
      < -6.827199, -0.899603, 0.552779>,
      < -6.828636, -0.900248, 0.539049>
    }
    triangle {
      < -6.827199, -0.899603, 0.552779>,
      < -6.978443, -0.937348, 0.545746>,
      < -6.986362, -0.939410, 0.565277>
    }
    triangle {
      < -7.024054, -0.920329, 0.128336>,
      < -7.019966, -0.911996, 0.149186>,
      < -6.980532, -0.907000, 0.146452>
    }
    triangle {
      < -7.024054, -0.920329, 0.128336>,
      < -6.980532, -0.907000, 0.146452>,
      < -6.983802, -0.913666, 0.129772>
    }
    triangle {
      < -7.019966, -0.911996, 0.149186>,
      < -7.010245, -0.922430, 0.530327>,
      < -6.977396, -0.917010, 0.534543>
    }
    triangle {
      < -7.019966, -0.911996, 0.149186>,
      < -6.977396, -0.917010, 0.534543>,
      < -6.980532, -0.907000, 0.146452>
    }
    triangle {
      < -7.059401, -0.919393, 0.151920>,
      < -7.038868, -0.929404, 0.516616>,
      < -7.010245, -0.922430, 0.530327>
    }
    triangle {
      < -7.059401, -0.919393, 0.151920>,
      < -7.010245, -0.922430, 0.530327>,
      < -7.019966, -0.911996, 0.149186>
    }
    triangle {
      < -7.019966, -0.911996, 0.149186>,
      < -7.024054, -0.920329, 0.128336>,
      < -7.064306, -0.929392, 0.126900>
    }
    triangle {
      < -7.019966, -0.911996, 0.149186>,
      < -7.064306, -0.929392, 0.126900>,
      < -7.059401, -0.919393, 0.151920>
    }
    triangle {
      < -7.039476, -0.920313, 0.000000>,
      < -7.024054, -0.920329, 0.128336>,
      < -6.983802, -0.913666, 0.129772>
    }
    triangle {
      < -7.039476, -0.920313, 0.000000>,
      < -6.983802, -0.913666, 0.129772>,
      < -7.001808, -0.913647, 0.000000>
    }
    triangle {
      < -7.059401, -0.919393, 0.151920>,
      < -7.072464, -0.958079, 0.159185>,
      < -7.056583, -0.964400, 0.421163>
    }
    triangle {
      < -7.059401, -0.919393, 0.151920>,
      < -7.056583, -0.964400, 0.421163>,
      < -7.038868, -0.929404, 0.516616>
    }
    triangle {
      < -7.076698, -0.963606, 0.138298>,
      < -7.072464, -0.958079, 0.159185>,
      < -7.059401, -0.919393, 0.151920>
    }
    triangle {
      < -7.076698, -0.963606, 0.138298>,
      < -7.059401, -0.919393, 0.151920>,
      < -7.064306, -0.929392, 0.126900>
    }
    triangle {
      < -7.010245, -0.922430, 0.530327>,
      < -7.004519, -0.948634, 0.534332>,
      < -6.978443, -0.937348, 0.545746>
    }
    triangle {
      < -7.010245, -0.922430, 0.530327>,
      < -6.978443, -0.937348, 0.545746>,
      < -6.977396, -0.917010, 0.534543>
    }
    triangle {
      < -7.026527, -0.953779, 0.515213>,
      < -7.004519, -0.948634, 0.534332>,
      < -7.010245, -0.922430, 0.530327>
    }
    triangle {
      < -7.026527, -0.953779, 0.515213>,
      < -7.010245, -0.922430, 0.530327>,
      < -7.038868, -0.929404, 0.516616>
    }
    triangle {
      < -7.076698, -0.963606, 0.138298>,
      < -7.064306, -0.929392, 0.126900>,
      < -7.077146, -0.929379, 0.000000>
    }
    triangle {
      < -7.076698, -0.963606, 0.138298>,
      < -7.077146, -0.929379, 0.000000>,
      < -7.084741, -0.963822, 0.032129>
    }
    triangle {
      < -7.026527, -0.953779, 0.515213>,
      < -7.038868, -0.929404, 0.516616>,
      < -7.056583, -0.964400, 0.421163>
    }
    triangle {
      < -7.026527, -0.953779, 0.515213>,
      < -7.056583, -0.964400, 0.421163>,
      < -7.047873, -0.979402, 0.455426>
    }
    triangle {
      < -7.004519, -0.948634, 0.534332>,
      < -7.009945, -0.965061, 0.552114>,
      < -6.986362, -0.939410, 0.565277>
    }
    triangle {
      < -7.004519, -0.948634, 0.534332>,
      < -6.986362, -0.939410, 0.565277>,
      < -6.978443, -0.937348, 0.545746>
    }
    triangle {
      < -7.007535, -0.965069, 0.566291>,
      < -6.986362, -0.939410, 0.565277>,
      < -7.009945, -0.965061, 0.552114>
    }
    triangle {
      < -7.030439, -0.979405, 0.523954>,
      < -7.009945, -0.965061, 0.552114>,
      < -7.004519, -0.948634, 0.534332>
    }
    triangle {
      < -7.030439, -0.979405, 0.523954>,
      < -7.004519, -0.948634, 0.534332>,
      < -7.026527, -0.953779, 0.515213>
    }
    triangle {
      < -7.047873, -0.979402, 0.455426>,
      < -7.030439, -0.979405, 0.523954>,
      < -7.026527, -0.953779, 0.515213>
    }
    triangle {
      < -7.064786, -1.029065, 0.445514>,
      < -7.067813, -1.029401, 0.487254>,
      < -7.062659, -1.011067, 0.432676>
    }
    triangle {
      < -7.056583, -0.964400, 0.421163>,
      < -7.067813, -1.029401, 0.487254>,
      < -7.047873, -0.979402, 0.455426>
    }
    triangle {
      < -7.030439, -0.979405, 0.523954>,
      < -7.020231, -0.995068, 0.566114>,
      < -7.007535, -0.965069, 0.566291>
    }
    triangle {
      < -7.030439, -0.979405, 0.523954>,
      < -7.007535, -0.965069, 0.566291>,
      < -7.009945, -0.965061, 0.552114>
    }
    triangle {
      < -7.047873, -0.979402, 0.455426>,
      < -7.067813, -1.029401, 0.487254>,
      < -7.030439, -0.979405, 0.523954>
    }
    triangle {
      < -7.024446, -1.029407, 0.564746>,
      < -7.020231, -0.995068, 0.566114>,
      < -7.030439, -0.979405, 0.523954>
    }
    triangle {
      < -7.030439, -0.979405, 0.523954>,
      < -7.067813, -1.029401, 0.487254>,
      < -7.024446, -1.029407, 0.564746>
    }
    triangle {
      < -7.067813, -1.029401, 0.487254>,
      < -7.064786, -1.029065, 0.445514>,
      < -7.069733, -1.050319, 0.428379>
    }
    triangle {
      < -7.063015, -1.060201, 0.487254>,
      < -7.019647, -1.060207, 0.564746>,
      < -7.024446, -1.029407, 0.564746>
    }
    triangle {
      < -7.063015, -1.060201, 0.487254>,
      < -7.024446, -1.029407, 0.564746>,
      < -7.067813, -1.029401, 0.487254>
    }
    triangle {
      < -7.070283, -1.080199, 0.428782>,
      < -7.063015, -1.060201, 0.487254>,
      < -7.067813, -1.029401, 0.487254>
    }
    triangle {
      < -7.070283, -1.080199, 0.428782>,
      < -7.067813, -1.029401, 0.487254>,
      < -7.069733, -1.050319, 0.428379>
    }
    triangle {
      < -7.103738, -1.073982, 0.031415>,
      < -7.112873, -1.104784, 0.000000>,
      < -7.099136, -1.096855, 0.138298>
    }
    triangle {
      < -7.103738, -1.073982, 0.031415>,
      < -7.099136, -1.096855, 0.138298>,
      < -7.094642, -1.067653, 0.137597>
    }
    triangle {
      < -7.000562, -1.089806, 0.563539>,
      < -7.019647, -1.060207, 0.564746>,
      < -7.063015, -1.060201, 0.487254>
    }
    triangle {
      < -7.070283, -1.080199, 0.428782>,
      < -6.967073, -1.119405, 0.562333>,
      < -7.000562, -1.089806, 0.563539>
    }
    triangle {
      < -7.070283, -1.080199, 0.428782>,
      < -7.000562, -1.089806, 0.563539>,
      < -7.063015, -1.060201, 0.487254>
    }
    triangle {
      < -7.112873, -1.104784, 0.000000>,
      < -7.039716, -1.119405, 0.000000>,
      < -7.021850, -1.119405, 0.138298>
    }
    triangle {
      < -7.112873, -1.104784, 0.000000>,
      < -7.021850, -1.119405, 0.138298>,
      < -7.099136, -1.096855, 0.138298>
    }
    triangle {
      < -7.039716, -1.119405, 0.000000>,
      < -6.873619, -1.127051, -0.000001>,
      < -6.858819, -1.126941, 0.138298>
    }
    triangle {
      < -7.039716, -1.119405, 0.000000>,
      < -6.858819, -1.126941, 0.138298>,
      < -7.021850, -1.119405, 0.138298>
    }
    triangle {
      < -7.064306, -0.929392, 0.126900>,
      < -7.024054, -0.920329, 0.128336>,
      < -7.039476, -0.920313, 0.000000>
    }
    triangle {
      < -7.064306, -0.929392, 0.126900>,
      < -7.039476, -0.920313, 0.000000>,
      < -7.077146, -0.929379, 0.000000>
    }
    triangle {
      < -7.070283, -1.080199, 0.428782>,
      < -7.069733, -1.050319, 0.428379>,
      < -7.094642, -1.067653, 0.137597>
    }
    triangle {
      < -7.070283, -1.080199, 0.428782>,
      < -7.094642, -1.067653, 0.137597>,
      < -7.099136, -1.096855, 0.138298>
    }
    triangle {
      < -6.967073, -1.119405, 0.562333>,
      < -7.070283, -1.080199, 0.428782>,
      < -7.099136, -1.096855, 0.138298>
    }
    triangle {
      < -6.967073, -1.119405, 0.562333>,
      < -7.099136, -1.096855, 0.138298>,
      < -7.021850, -1.119405, 0.138298>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -6.967073, -1.119405, 0.562333>,
      < -7.021850, -1.119405, 0.138298>
    }
    triangle {
      < -6.813701, -1.126607, 0.559919>,
      < -7.021850, -1.119405, 0.138298>,
      < -6.858819, -1.126941, 0.138298>
    }
    triangle {
      < -7.112873, -1.104784, 0.000000>,
      < -7.103739, -1.073982, -0.031413>,
      < -7.094644, -1.067653, -0.137597>
    }
    triangle {
      < -7.112873, -1.104784, 0.000000>,
      < -7.094644, -1.067653, -0.137597>,
      < -7.099136, -1.096855, -0.138298>
    }
    triangle {
      < -7.039716, -1.119405, 0.000000>,
      < -7.112873, -1.104784, 0.000000>,
      < -7.099136, -1.096855, -0.138298>
    }
    triangle {
      < -7.039716, -1.119405, 0.000000>,
      < -7.099136, -1.096855, -0.138298>,
      < -7.021850, -1.119405, -0.138298>
    }
    triangle {
      < -6.873619, -1.127051, -0.000001>,
      < -7.039716, -1.119405, 0.000000>,
      < -7.021850, -1.119405, -0.138298>
    }
    triangle {
      < -6.873619, -1.127051, -0.000001>,
      < -7.021850, -1.119405, -0.138298>,
      < -6.858819, -1.126941, -0.138298>
    }
    triangle {
      < -7.106380, -1.075926, -0.000833>,
      < -7.103739, -1.073982, -0.031413>,
      < -7.112873, -1.104784, 0.000000>
    }
    triangle {
      < -7.106380, -1.075926, -0.000833>,
      < -7.112873, -1.104784, 0.000000>,
      < -7.103738, -1.073982, 0.031415>
    }
    triangle {
      < -7.087167, -0.963891, -0.000123>,
      < -7.084741, -0.963822, 0.032129>,
      < -7.077146, -0.929379, 0.000000>
    }
    triangle {
      < -7.087167, -0.963891, -0.000123>,
      < -7.077146, -0.929379, 0.000000>,
      < -7.084741, -0.963822, -0.032127>
    }
    triangle {
      < -7.056583, -0.964400, 0.421163>,
      < -7.058404, -0.975070, 0.407000>,
      < -7.062659, -1.011067, 0.432676>
    }
    triangle {
      < -7.056583, -0.964400, 0.421163>,
      < -7.062659, -1.011067, 0.432676>,
      < -7.067813, -1.029401, 0.487254>
    }
    triangle {
      < -6.828636, -0.900248, 0.539049>,
      < -6.813701, -1.126607, 0.559919>,
      < -6.858819, -1.126941, 0.138298>
    }
    triangle {
      < -6.828636, -0.900248, 0.539049>,
      < -6.858819, -1.126941, 0.138298>,
      < -6.871792, -0.892162, 0.140769>
    }
    triangle {
      < -6.813701, -1.126607, -0.559919>,
      < -6.828636, -0.900248, -0.539049>,
      < -6.871792, -0.892162, -0.140769>
    }
    triangle {
      < -6.813701, -1.126607, -0.559919>,
      < -6.871792, -0.892162, -0.140769>,
      < -6.858819, -1.126941, -0.138298>
    }
    triangle {
      < -7.227820, -1.094400, -2.646872>,
      < -7.140909, -1.094400, -2.683300>,
      < -7.140909, -1.172304, -2.670962>
    }
    triangle {
      < -7.227820, -1.094400, -2.646872>,
      < -7.140909, -1.172304, -2.670962>,
      < -7.227820, -1.161047, -2.636316>
    }
    triangle {
      < -7.227820, -1.161047, -2.636316>,
      < -7.140909, -1.172304, -2.670962>,
      < -7.140909, -1.242581, -2.635154>
    }
    triangle {
      < -7.227820, -1.161047, -2.636316>,
      < -7.140909, -1.242581, -2.635154>,
      < -7.227820, -1.221169, -2.605683>
    }
    triangle {
      < -7.227820, -1.221169, -2.605683>,
      < -7.140909, -1.242581, -2.635154>,
      < -7.140909, -1.298354, -2.579380>
    }
    triangle {
      < -7.227820, -1.221169, -2.605683>,
      < -7.140909, -1.298354, -2.579380>,
      < -7.227820, -1.268882, -2.557969>
    }
    triangle {
      < -7.227820, -1.268882, -2.557969>,
      < -7.140909, -1.298354, -2.579380>,
      < -7.140909, -1.334162, -2.509103>
    }
    triangle {
      < -7.227820, -1.268882, -2.557969>,
      < -7.140909, -1.334162, -2.509103>,
      < -7.227820, -1.299516, -2.497847>
    }
    triangle {
      < -7.227820, -1.299516, -2.497847>,
      < -7.140909, -1.334162, -2.509103>,
      < -7.140909, -1.346501, -2.431200>
    }
    triangle {
      < -7.227820, -1.299516, -2.497847>,
      < -7.140909, -1.346501, -2.431200>,
      < -7.227820, -1.310073, -2.431200>
    }
    triangle {
      < -7.227820, -1.310073, -2.431200>,
      < -7.140909, -1.346501, -2.431200>,
      < -7.140909, -1.334162, -2.353297>
    }
    triangle {
      < -7.227820, -1.310073, -2.431200>,
      < -7.140909, -1.334162, -2.353297>,
      < -7.227820, -1.299516, -2.364554>
    }
    triangle {
      < -7.227820, -1.299516, -2.364554>,
      < -7.140909, -1.334162, -2.353297>,
      < -7.140909, -1.298354, -2.283020>
    }
    triangle {
      < -7.227820, -1.299516, -2.364554>,
      < -7.140909, -1.298354, -2.283020>,
      < -7.227820, -1.268882, -2.304432>
    }
    triangle {
      < -7.227820, -1.268882, -2.304432>,
      < -7.140909, -1.298354, -2.283020>,
      < -7.140909, -1.242581, -2.227246>
    }
    triangle {
      < -7.227820, -1.268882, -2.304432>,
      < -7.140909, -1.242581, -2.227246>,
      < -7.227820, -1.221169, -2.256718>
    }
    triangle {
      < -7.227820, -1.221169, -2.256718>,
      < -7.140909, -1.242581, -2.227246>,
      < -7.140909, -1.172304, -2.191437>
    }
    triangle {
      < -7.227820, -1.221169, -2.256718>,
      < -7.140909, -1.172304, -2.191437>,
      < -7.227820, -1.161047, -2.226084>
    }
    triangle {
      < -7.227820, -1.161047, -2.226084>,
      < -7.140909, -1.172304, -2.191437>,
      < -7.140909, -1.094400, -2.179100>
    }
    triangle {
      < -7.227820, -1.161047, -2.226084>,
      < -7.140909, -1.094400, -2.179100>,
      < -7.227820, -1.094400, -2.215528>
    }
    triangle {
      < -7.227820, -1.094400, -2.215528>,
      < -7.140909, -1.094400, -2.179100>,
      < -7.140909, -1.016497, -2.191437>
    }
    triangle {
      < -7.227820, -1.094400, -2.215528>,
      < -7.140909, -1.016497, -2.191437>,
      < -7.227820, -1.027754, -2.226084>
    }
    triangle {
      < -7.227820, -1.027754, -2.226084>,
      < -7.140909, -1.016497, -2.191437>,
      < -7.140909, -0.946219, -2.227246>
    }
    triangle {
      < -7.227820, -1.027754, -2.226084>,
      < -7.140909, -0.946219, -2.227246>,
      < -7.227820, -0.967631, -2.256718>
    }
    triangle {
      < -7.227820, -0.967631, -2.256718>,
      < -7.140909, -0.946219, -2.227246>,
      < -7.140909, -0.890446, -2.283020>
    }
    triangle {
      < -7.227820, -0.967631, -2.256718>,
      < -7.140909, -0.890446, -2.283020>,
      < -7.227820, -0.919918, -2.304432>
    }
    triangle {
      < -7.227820, -0.919918, -2.304432>,
      < -7.140909, -0.890446, -2.283020>,
      < -7.140909, -0.854639, -2.353297>
    }
    triangle {
      < -7.227820, -0.919918, -2.304432>,
      < -7.140909, -0.854639, -2.353297>,
      < -7.227820, -0.889285, -2.364554>
    }
    triangle {
      < -7.227820, -0.889285, -2.364554>,
      < -7.140909, -0.854639, -2.353297>,
      < -7.140909, -0.842299, -2.431200>
    }
    triangle {
      < -7.227820, -0.889285, -2.364554>,
      < -7.140909, -0.842299, -2.431200>,
      < -7.227820, -0.878728, -2.431200>
    }
    triangle {
      < -7.227820, -0.878728, -2.431200>,
      < -7.140909, -0.842299, -2.431200>,
      < -7.140909, -0.854639, -2.509103>
    }
    triangle {
      < -7.227820, -0.878728, -2.431200>,
      < -7.140909, -0.854639, -2.509103>,
      < -7.227820, -0.889285, -2.497847>
    }
    triangle {
      < -7.227820, -0.889285, -2.497847>,
      < -7.140909, -0.854639, -2.509103>,
      < -7.140909, -0.890446, -2.579380>
    }
    triangle {
      < -7.227820, -0.889285, -2.497847>,
      < -7.140909, -0.890446, -2.579380>,
      < -7.227820, -0.919918, -2.557969>
    }
    triangle {
      < -7.227820, -0.919918, -2.557969>,
      < -7.140909, -0.890446, -2.579380>,
      < -7.140909, -0.946219, -2.635154>
    }
    triangle {
      < -7.227820, -0.919918, -2.557969>,
      < -7.140909, -0.946219, -2.635154>,
      < -7.227820, -0.967631, -2.605683>
    }
    triangle {
      < -7.227820, -0.967631, -2.605683>,
      < -7.140909, -0.946219, -2.635154>,
      < -7.140909, -1.016497, -2.670962>
    }
    triangle {
      < -7.227820, -0.967631, -2.605683>,
      < -7.140909, -1.016497, -2.670962>,
      < -7.227820, -1.027754, -2.636316>
    }
    triangle {
      < -7.227820, -1.027754, -2.636316>,
      < -7.140909, -1.016497, -2.670962>,
      < -7.140909, -1.094400, -2.683300>
    }
    triangle {
      < -7.227820, -1.027754, -2.636316>,
      < -7.140909, -1.094400, -2.683300>,
      < -7.227820, -1.094400, -2.646872>
    }
    triangle {
      < -7.140909, -1.172304, -2.191437>,
      < -7.140909, -1.242581, -2.227246>,
      < -7.022911, -1.256779, -2.207705>
    }
    triangle {
      < -7.140909, -1.172304, -2.191437>,
      < -7.022911, -1.256779, -2.207705>,
      < -7.022911, -1.179768, -2.168466>
    }
    triangle {
      < -7.140909, -1.242581, -2.227246>,
      < -7.140909, -1.298354, -2.283020>,
      < -7.022911, -1.317896, -2.268822>
    }
    triangle {
      < -7.140909, -1.242581, -2.227246>,
      < -7.022911, -1.317896, -2.268822>,
      < -7.022911, -1.256779, -2.207705>
    }
    triangle {
      < -7.140909, -1.298354, -2.283020>,
      < -7.140909, -1.334162, -2.353297>,
      < -7.022911, -1.357134, -2.345833>
    }
    triangle {
      < -7.140909, -1.298354, -2.283020>,
      < -7.022911, -1.357134, -2.345833>,
      < -7.022911, -1.317896, -2.268822>
    }
    triangle {
      < -7.140909, -1.334162, -2.353297>,
      < -7.140909, -1.346501, -2.431200>,
      < -7.022911, -1.370656, -2.431200>
    }
    triangle {
      < -7.140909, -1.334162, -2.353297>,
      < -7.022911, -1.370656, -2.431200>,
      < -7.022911, -1.357134, -2.345833>
    }
    triangle {
      < -7.140909, -1.346501, -2.431200>,
      < -7.140909, -1.334162, -2.509103>,
      < -7.022911, -1.357134, -2.516567>
    }
    triangle {
      < -7.140909, -1.346501, -2.431200>,
      < -7.022911, -1.357134, -2.516567>,
      < -7.022911, -1.370656, -2.431200>
    }
    triangle {
      < -7.140909, -1.334162, -2.509103>,
      < -7.140909, -1.298354, -2.579380>,
      < -7.022911, -1.317896, -2.593577>
    }
    triangle {
      < -7.140909, -1.334162, -2.509103>,
      < -7.022911, -1.317896, -2.593577>,
      < -7.022911, -1.357134, -2.516567>
    }
    triangle {
      < -7.140909, -1.298354, -2.579380>,
      < -7.140909, -1.242581, -2.635154>,
      < -7.022911, -1.256779, -2.654695>
    }
    triangle {
      < -7.140909, -1.298354, -2.579380>,
      < -7.022911, -1.256779, -2.654695>,
      < -7.022911, -1.317896, -2.593577>
    }
    triangle {
      < -7.140909, -1.242581, -2.635154>,
      < -7.140909, -1.172304, -2.670962>,
      < -7.022911, -1.179768, -2.693934>
    }
    triangle {
      < -7.140909, -1.242581, -2.635154>,
      < -7.022911, -1.179768, -2.693934>,
      < -7.022911, -1.256779, -2.654695>
    }
    triangle {
      < -7.140909, -1.172304, -2.670962>,
      < -7.140909, -1.094400, -2.683300>,
      < -7.022911, -1.094401, -2.707454>
    }
    triangle {
      < -7.140909, -1.172304, -2.670962>,
      < -7.022911, -1.094401, -2.707454>,
      < -7.022911, -1.179768, -2.693934>
    }
    triangle {
      < -7.140909, -1.094400, -2.683300>,
      < -7.140909, -1.016497, -2.670962>,
      < -7.022911, -1.009033, -2.693934>
    }
    triangle {
      < -7.140909, -1.094400, -2.683300>,
      < -7.022911, -1.009033, -2.693934>,
      < -7.022911, -1.094401, -2.707454>
    }
    triangle {
      < -7.140909, -1.016497, -2.670962>,
      < -7.140909, -0.946219, -2.635154>,
      < -7.022911, -0.932022, -2.654695>
    }
    triangle {
      < -7.140909, -1.016497, -2.670962>,
      < -7.022911, -0.932022, -2.654695>,
      < -7.022911, -1.009033, -2.693934>
    }
    triangle {
      < -7.140909, -0.946219, -2.635154>,
      < -7.140909, -0.890446, -2.579380>,
      < -7.022911, -0.870906, -2.593577>
    }
    triangle {
      < -7.140909, -0.946219, -2.635154>,
      < -7.022911, -0.870906, -2.593577>,
      < -7.022911, -0.932022, -2.654695>
    }
    triangle {
      < -7.140909, -0.890446, -2.579380>,
      < -7.140909, -0.854639, -2.509103>,
      < -7.022911, -0.831667, -2.516567>
    }
    triangle {
      < -7.140909, -0.890446, -2.579380>,
      < -7.022911, -0.831667, -2.516567>,
      < -7.022911, -0.870906, -2.593577>
    }
    triangle {
      < -7.140909, -0.854639, -2.509103>,
      < -7.140909, -0.842299, -2.431200>,
      < -7.022911, -0.818146, -2.431200>
    }
    triangle {
      < -7.140909, -0.854639, -2.509103>,
      < -7.022911, -0.818146, -2.431200>,
      < -7.022911, -0.831667, -2.516567>
    }
    triangle {
      < -7.140909, -0.842299, -2.431200>,
      < -7.140909, -0.854639, -2.353297>,
      < -7.022911, -0.831667, -2.345833>
    }
    triangle {
      < -7.140909, -0.842299, -2.431200>,
      < -7.022911, -0.831667, -2.345833>,
      < -7.022911, -0.818146, -2.431200>
    }
    triangle {
      < -7.140909, -0.854639, -2.353297>,
      < -7.140909, -0.890446, -2.283020>,
      < -7.022911, -0.870906, -2.268822>
    }
    triangle {
      < -7.140909, -0.854639, -2.353297>,
      < -7.022911, -0.870906, -2.268822>,
      < -7.022911, -0.831667, -2.345833>
    }
    triangle {
      < -7.140909, -0.890446, -2.283020>,
      < -7.140909, -0.946219, -2.227246>,
      < -7.022911, -0.932022, -2.207705>
    }
    triangle {
      < -7.140909, -0.890446, -2.283020>,
      < -7.022911, -0.932022, -2.207705>,
      < -7.022911, -0.870906, -2.268822>
    }
    triangle {
      < -7.140909, -0.946219, -2.227246>,
      < -7.140909, -1.016497, -2.191437>,
      < -7.022911, -1.009033, -2.168466>
    }
    triangle {
      < -7.140909, -0.946219, -2.227246>,
      < -7.022911, -1.009033, -2.168466>,
      < -7.022911, -0.932022, -2.207705>
    }
    triangle {
      < -7.140909, -1.016497, -2.191437>,
      < -7.140909, -1.094400, -2.179100>,
      < -7.022911, -1.094401, -2.154945>
    }
    triangle {
      < -7.140909, -1.016497, -2.191437>,
      < -7.022911, -1.094401, -2.154945>,
      < -7.022911, -1.009033, -2.168466>
    }
    triangle {
      < -7.140909, -1.094400, -2.179100>,
      < -7.140909, -1.172304, -2.191437>,
      < -7.022911, -1.179768, -2.168466>
    }
    triangle {
      < -7.140909, -1.094400, -2.179100>,
      < -7.022911, -1.179768, -2.168466>,
      < -7.022911, -1.094401, -2.154945>
    }
    triangle {
      < -7.022911, -0.831667, -2.516567>,
      < -7.022911, -0.818146, -2.431200>,
      < -6.895309, -0.809985, -2.431200>
    }
    triangle {
      < -7.022911, -0.831667, -2.516567>,
      < -6.895309, -0.809985, -2.431200>,
      < -6.895309, -0.823906, -2.519088>
    }
    triangle {
      < -7.022911, -0.818146, -2.431200>,
      < -7.022911, -0.831667, -2.345833>,
      < -6.895309, -0.823906, -2.343311>
    }
    triangle {
      < -7.022911, -0.818146, -2.431200>,
      < -6.895309, -0.823906, -2.343311>,
      < -6.895309, -0.809985, -2.431200>
    }
    triangle {
      < -7.022911, -0.831667, -2.345833>,
      < -7.022911, -0.870906, -2.268822>,
      < -6.895309, -0.864303, -2.264025>
    }
    triangle {
      < -7.022911, -0.831667, -2.345833>,
      < -6.895309, -0.864303, -2.264025>,
      < -6.895309, -0.823906, -2.343311>
    }
    triangle {
      < -7.022911, -0.870906, -2.268822>,
      < -7.022911, -0.932022, -2.207705>,
      < -6.895309, -0.927226, -2.201102>
    }
    triangle {
      < -7.022911, -0.870906, -2.268822>,
      < -6.895309, -0.927226, -2.201102>,
      < -6.895309, -0.864303, -2.264025>
    }
    triangle {
      < -7.022911, -0.932022, -2.207705>,
      < -7.022911, -1.009033, -2.168466>,
      < -6.895309, -1.006511, -2.160704>
    }
    triangle {
      < -7.022911, -0.932022, -2.207705>,
      < -6.895309, -1.006511, -2.160704>,
      < -6.895309, -0.927226, -2.201102>
    }
    triangle {
      < -7.022911, -1.009033, -2.168466>,
      < -7.022911, -1.094401, -2.154945>,
      < -6.895309, -1.094401, -2.146785>
    }
    triangle {
      < -7.022911, -1.009033, -2.168466>,
      < -6.895309, -1.094401, -2.146785>,
      < -6.895309, -1.006511, -2.160704>
    }
    triangle {
      < -7.022911, -1.094401, -2.154945>,
      < -7.022911, -1.179768, -2.168466>,
      < -6.895309, -1.182290, -2.160704>
    }
    triangle {
      < -7.022911, -1.094401, -2.154945>,
      < -6.895309, -1.182290, -2.160704>,
      < -6.895309, -1.094401, -2.146785>
    }
    triangle {
      < -7.022911, -1.179768, -2.168466>,
      < -7.022911, -1.256779, -2.207705>,
      < -6.895309, -1.261576, -2.201102>
    }
    triangle {
      < -7.022911, -1.179768, -2.168466>,
      < -6.895309, -1.261576, -2.201102>,
      < -6.895309, -1.182290, -2.160704>
    }
    triangle {
      < -7.022911, -1.256779, -2.207705>,
      < -7.022911, -1.317896, -2.268822>,
      < -6.895309, -1.324498, -2.264025>
    }
    triangle {
      < -7.022911, -1.256779, -2.207705>,
      < -6.895309, -1.324498, -2.264025>,
      < -6.895309, -1.261576, -2.201102>
    }
    triangle {
      < -7.022911, -1.317896, -2.268822>,
      < -7.022911, -1.357134, -2.345833>,
      < -6.895309, -1.364895, -2.343311>
    }
    triangle {
      < -7.022911, -1.317896, -2.268822>,
      < -6.895309, -1.364895, -2.343311>,
      < -6.895309, -1.324498, -2.264025>
    }
    triangle {
      < -7.022911, -1.357134, -2.345833>,
      < -7.022911, -1.370656, -2.431200>,
      < -6.895309, -1.378816, -2.431200>
    }
    triangle {
      < -7.022911, -1.357134, -2.345833>,
      < -6.895309, -1.378816, -2.431200>,
      < -6.895309, -1.364895, -2.343311>
    }
    triangle {
      < -7.022911, -1.370656, -2.431200>,
      < -7.022911, -1.357134, -2.516567>,
      < -6.895309, -1.364895, -2.519088>
    }
    triangle {
      < -7.022911, -1.370656, -2.431200>,
      < -6.895309, -1.364895, -2.519088>,
      < -6.895309, -1.378816, -2.431200>
    }
    triangle {
      < -7.022911, -1.357134, -2.516567>,
      < -7.022911, -1.317896, -2.593577>,
      < -6.895309, -1.324498, -2.598374>
    }
    triangle {
      < -7.022911, -1.357134, -2.516567>,
      < -6.895309, -1.324498, -2.598374>,
      < -6.895309, -1.364895, -2.519088>
    }
    triangle {
      < -7.022911, -1.317896, -2.593577>,
      < -7.022911, -1.256779, -2.654695>,
      < -6.895309, -1.261576, -2.661297>
    }
    triangle {
      < -7.022911, -1.317896, -2.593577>,
      < -6.895309, -1.261576, -2.661297>,
      < -6.895309, -1.324498, -2.598374>
    }
    triangle {
      < -7.022911, -1.256779, -2.654695>,
      < -7.022911, -1.179768, -2.693934>,
      < -6.895309, -1.182290, -2.701695>
    }
    triangle {
      < -7.022911, -1.256779, -2.654695>,
      < -6.895309, -1.182290, -2.701695>,
      < -6.895309, -1.261576, -2.661297>
    }
    triangle {
      < -7.022911, -1.179768, -2.693934>,
      < -7.022911, -1.094401, -2.707454>,
      < -6.895309, -1.094401, -2.715615>
    }
    triangle {
      < -7.022911, -1.179768, -2.693934>,
      < -6.895309, -1.094401, -2.715615>,
      < -6.895309, -1.182290, -2.701695>
    }
    triangle {
      < -7.022911, -1.094401, -2.707454>,
      < -7.022911, -1.009033, -2.693934>,
      < -6.895309, -1.006511, -2.701695>
    }
    triangle {
      < -7.022911, -1.094401, -2.707454>,
      < -6.895309, -1.006511, -2.701695>,
      < -6.895309, -1.094401, -2.715615>
    }
    triangle {
      < -7.022911, -1.009033, -2.693934>,
      < -7.022911, -0.932022, -2.654695>,
      < -6.895309, -0.927226, -2.661297>
    }
    triangle {
      < -7.022911, -1.009033, -2.693934>,
      < -6.895309, -0.927226, -2.661297>,
      < -6.895309, -1.006511, -2.701695>
    }
    triangle {
      < -7.022911, -0.932022, -2.654695>,
      < -7.022911, -0.870906, -2.593577>,
      < -6.895309, -0.864303, -2.598374>
    }
    triangle {
      < -7.022911, -0.932022, -2.654695>,
      < -6.895309, -0.864303, -2.598374>,
      < -6.895309, -0.927226, -2.661297>
    }
    triangle {
      < -7.022911, -0.870906, -2.593577>,
      < -7.022911, -0.831667, -2.516567>,
      < -6.895309, -0.823906, -2.519088>
    }
    triangle {
      < -7.022911, -0.870906, -2.593577>,
      < -6.895309, -0.823906, -2.519088>,
      < -6.895309, -0.864303, -2.598374>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.371730, -2.521309>,
      < -6.671710, -1.330312, -2.602598>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.330312, -2.602598>,
      < -6.671710, -1.265800, -2.667111>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.265800, -2.667111>,
      < -6.671710, -1.184511, -2.708530>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.184511, -2.708530>,
      < -6.671710, -1.094401, -2.722801>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.094401, -2.722801>,
      < -6.671710, -1.004290, -2.708530>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.004290, -2.708530>,
      < -6.671710, -0.923001, -2.667111>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -0.923001, -2.667111>,
      < -6.671710, -0.858489, -2.602598>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -0.858489, -2.602598>,
      < -6.671710, -0.817071, -2.521309>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -0.817071, -2.521309>,
      < -6.671710, -0.802798, -2.431200>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -0.802798, -2.431200>,
      < -6.671710, -0.817071, -2.341090>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -0.817071, -2.341090>,
      < -6.671710, -0.858489, -2.259801>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -0.858489, -2.259801>,
      < -6.671710, -0.923001, -2.195288>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -0.923001, -2.195288>,
      < -6.671710, -1.004290, -2.153870>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.004290, -2.153870>,
      < -6.671710, -1.094401, -2.139599>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.094401, -2.139599>,
      < -6.671710, -1.184511, -2.153870>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.184511, -2.153870>,
      < -6.671710, -1.265800, -2.195288>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.265800, -2.195288>,
      < -6.671710, -1.330312, -2.259801>
    }
    triangle {
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.330312, -2.259801>,
      < -6.671710, -1.371730, -2.341090>
    }
    triangle {
      < -6.895309, -1.324498, -2.598374>,
      < -6.895309, -1.261576, -2.661297>,
      < -6.671710, -1.265800, -2.667111>
    }
    triangle {
      < -6.895309, -1.324498, -2.598374>,
      < -6.671710, -1.265800, -2.667111>,
      < -6.671710, -1.330312, -2.602598>
    }
    triangle {
      < -6.895309, -1.261576, -2.661297>,
      < -6.895309, -1.182290, -2.701695>,
      < -6.671710, -1.184511, -2.708530>
    }
    triangle {
      < -6.895309, -1.261576, -2.661297>,
      < -6.671710, -1.184511, -2.708530>,
      < -6.671710, -1.265800, -2.667111>
    }
    triangle {
      < -6.895309, -1.182290, -2.701695>,
      < -6.895309, -1.094401, -2.715615>,
      < -6.671710, -1.094401, -2.722801>
    }
    triangle {
      < -6.895309, -1.182290, -2.701695>,
      < -6.671710, -1.094401, -2.722801>,
      < -6.671710, -1.184511, -2.708530>
    }
    triangle {
      < -6.895309, -1.094401, -2.715615>,
      < -6.895309, -1.006511, -2.701695>,
      < -6.671710, -1.004290, -2.708530>
    }
    triangle {
      < -6.895309, -1.094401, -2.715615>,
      < -6.671710, -1.004290, -2.708530>,
      < -6.671710, -1.094401, -2.722801>
    }
    triangle {
      < -6.895309, -1.006511, -2.701695>,
      < -6.895309, -0.927226, -2.661297>,
      < -6.671710, -0.923001, -2.667111>
    }
    triangle {
      < -6.895309, -1.006511, -2.701695>,
      < -6.671710, -0.923001, -2.667111>,
      < -6.671710, -1.004290, -2.708530>
    }
    triangle {
      < -6.895309, -0.927226, -2.661297>,
      < -6.895309, -0.864303, -2.598374>,
      < -6.671710, -0.858489, -2.602598>
    }
    triangle {
      < -6.895309, -0.927226, -2.661297>,
      < -6.671710, -0.858489, -2.602598>,
      < -6.671710, -0.923001, -2.667111>
    }
    triangle {
      < -6.895309, -0.864303, -2.598374>,
      < -6.895309, -0.823906, -2.519088>,
      < -6.671710, -0.817071, -2.521309>
    }
    triangle {
      < -6.895309, -0.864303, -2.598374>,
      < -6.671710, -0.817071, -2.521309>,
      < -6.671710, -0.858489, -2.602598>
    }
    triangle {
      < -6.895309, -0.823906, -2.519088>,
      < -6.895309, -0.809985, -2.431200>,
      < -6.671710, -0.802798, -2.431200>
    }
    triangle {
      < -6.895309, -0.823906, -2.519088>,
      < -6.671710, -0.802798, -2.431200>,
      < -6.671710, -0.817071, -2.521309>
    }
    triangle {
      < -6.895309, -0.809985, -2.431200>,
      < -6.895309, -0.823906, -2.343311>,
      < -6.671710, -0.817071, -2.341090>
    }
    triangle {
      < -6.895309, -0.809985, -2.431200>,
      < -6.671710, -0.817071, -2.341090>,
      < -6.671710, -0.802798, -2.431200>
    }
    triangle {
      < -6.895309, -0.823906, -2.343311>,
      < -6.895309, -0.864303, -2.264025>,
      < -6.671710, -0.858489, -2.259801>
    }
    triangle {
      < -6.895309, -0.823906, -2.343311>,
      < -6.671710, -0.858489, -2.259801>,
      < -6.671710, -0.817071, -2.341090>
    }
    triangle {
      < -6.895309, -0.864303, -2.264025>,
      < -6.895309, -0.927226, -2.201102>,
      < -6.671710, -0.923001, -2.195288>
    }
    triangle {
      < -6.895309, -0.864303, -2.264025>,
      < -6.671710, -0.923001, -2.195288>,
      < -6.671710, -0.858489, -2.259801>
    }
    triangle {
      < -6.895309, -0.927226, -2.201102>,
      < -6.895309, -1.006511, -2.160704>,
      < -6.671710, -1.004290, -2.153870>
    }
    triangle {
      < -6.895309, -0.927226, -2.201102>,
      < -6.671710, -1.004290, -2.153870>,
      < -6.671710, -0.923001, -2.195288>
    }
    triangle {
      < -6.895309, -1.006511, -2.160704>,
      < -6.895309, -1.094401, -2.146785>,
      < -6.671710, -1.094401, -2.139599>
    }
    triangle {
      < -6.895309, -1.006511, -2.160704>,
      < -6.671710, -1.094401, -2.139599>,
      < -6.671710, -1.004290, -2.153870>
    }
    triangle {
      < -6.895309, -1.094401, -2.146785>,
      < -6.895309, -1.182290, -2.160704>,
      < -6.671710, -1.184511, -2.153870>
    }
    triangle {
      < -6.895309, -1.094401, -2.146785>,
      < -6.671710, -1.184511, -2.153870>,
      < -6.671710, -1.094401, -2.139599>
    }
    triangle {
      < -6.895309, -1.182290, -2.160704>,
      < -6.895309, -1.261576, -2.201102>,
      < -6.671710, -1.265800, -2.195288>
    }
    triangle {
      < -6.895309, -1.182290, -2.160704>,
      < -6.671710, -1.265800, -2.195288>,
      < -6.671710, -1.184511, -2.153870>
    }
    triangle {
      < -6.895309, -1.261576, -2.201102>,
      < -6.895309, -1.324498, -2.264025>,
      < -6.671710, -1.330312, -2.259801>
    }
    triangle {
      < -6.895309, -1.261576, -2.201102>,
      < -6.671710, -1.330312, -2.259801>,
      < -6.671710, -1.265800, -2.195288>
    }
    triangle {
      < -6.895309, -1.324498, -2.264025>,
      < -6.895309, -1.364895, -2.343311>,
      < -6.671710, -1.371730, -2.341090>
    }
    triangle {
      < -6.895309, -1.324498, -2.264025>,
      < -6.671710, -1.371730, -2.341090>,
      < -6.671710, -1.330312, -2.259801>
    }
    triangle {
      < -6.895309, -1.364895, -2.343311>,
      < -6.895309, -1.378816, -2.431200>,
      < -6.671710, -1.386003, -2.431200>
    }
    triangle {
      < -6.895309, -1.364895, -2.343311>,
      < -6.671710, -1.386003, -2.431200>,
      < -6.671710, -1.371730, -2.341090>
    }
    triangle {
      < -6.895309, -1.378816, -2.431200>,
      < -6.895309, -1.364895, -2.519088>,
      < -6.671710, -1.371730, -2.521309>
    }
    triangle {
      < -6.895309, -1.378816, -2.431200>,
      < -6.671710, -1.371730, -2.521309>,
      < -6.671710, -1.386003, -2.431200>
    }
    triangle {
      < -6.895309, -1.364895, -2.519088>,
      < -6.895309, -1.324498, -2.598374>,
      < -6.671710, -1.330312, -2.602598>
    }
    triangle {
      < -6.895309, -1.364895, -2.519088>,
      < -6.671710, -1.330312, -2.602598>,
      < -6.671710, -1.371730, -2.521309>
    }
    triangle {
      < -7.227820, -1.161047, 2.636316>,
      < -7.140909, -1.172304, 2.670962>,
      < -7.140909, -1.094400, 2.683300>
    }
    triangle {
      < -7.227820, -1.161047, 2.636316>,
      < -7.140909, -1.094400, 2.683300>,
      < -7.227820, -1.094400, 2.646872>
    }
    triangle {
      < -7.227820, -1.221169, 2.605683>,
      < -7.140909, -1.242581, 2.635154>,
      < -7.140909, -1.172304, 2.670962>
    }
    triangle {
      < -7.227820, -1.221169, 2.605683>,
      < -7.140909, -1.172304, 2.670962>,
      < -7.227820, -1.161047, 2.636316>
    }
    triangle {
      < -7.227820, -1.268882, 2.557969>,
      < -7.140909, -1.298354, 2.579380>,
      < -7.140909, -1.242581, 2.635154>
    }
    triangle {
      < -7.227820, -1.268882, 2.557969>,
      < -7.140909, -1.242581, 2.635154>,
      < -7.227820, -1.221169, 2.605683>
    }
    triangle {
      < -7.227820, -1.299516, 2.497847>,
      < -7.140909, -1.334162, 2.509103>,
      < -7.140909, -1.298354, 2.579380>
    }
    triangle {
      < -7.227820, -1.299516, 2.497847>,
      < -7.140909, -1.298354, 2.579380>,
      < -7.227820, -1.268882, 2.557969>
    }
    triangle {
      < -7.227820, -1.310073, 2.431200>,
      < -7.140909, -1.346501, 2.431200>,
      < -7.140909, -1.334162, 2.509103>
    }
    triangle {
      < -7.227820, -1.310073, 2.431200>,
      < -7.140909, -1.334162, 2.509103>,
      < -7.227820, -1.299516, 2.497847>
    }
    triangle {
      < -7.227820, -1.299516, 2.364554>,
      < -7.140909, -1.334162, 2.353297>,
      < -7.140909, -1.346501, 2.431200>
    }
    triangle {
      < -7.227820, -1.299516, 2.364554>,
      < -7.140909, -1.346501, 2.431200>,
      < -7.227820, -1.310073, 2.431200>
    }
    triangle {
      < -7.227820, -1.268882, 2.304432>,
      < -7.140909, -1.298354, 2.283020>,
      < -7.140909, -1.334162, 2.353297>
    }
    triangle {
      < -7.227820, -1.268882, 2.304432>,
      < -7.140909, -1.334162, 2.353297>,
      < -7.227820, -1.299516, 2.364554>
    }
    triangle {
      < -7.227820, -1.221169, 2.256718>,
      < -7.140909, -1.242581, 2.227246>,
      < -7.140909, -1.298354, 2.283020>
    }
    triangle {
      < -7.227820, -1.221169, 2.256718>,
      < -7.140909, -1.298354, 2.283020>,
      < -7.227820, -1.268882, 2.304432>
    }
    triangle {
      < -7.227820, -1.161047, 2.226084>,
      < -7.140909, -1.172304, 2.191437>,
      < -7.140909, -1.242581, 2.227246>
    }
    triangle {
      < -7.227820, -1.161047, 2.226084>,
      < -7.140909, -1.242581, 2.227246>,
      < -7.227820, -1.221169, 2.256718>
    }
    triangle {
      < -7.227820, -1.094400, 2.215528>,
      < -7.140909, -1.094400, 2.179100>,
      < -7.140909, -1.172304, 2.191437>
    }
    triangle {
      < -7.227820, -1.094400, 2.215528>,
      < -7.140909, -1.172304, 2.191437>,
      < -7.227820, -1.161047, 2.226084>
    }
    triangle {
      < -7.227820, -1.027754, 2.226084>,
      < -7.140909, -1.016497, 2.191437>,
      < -7.140909, -1.094400, 2.179100>
    }
    triangle {
      < -7.227820, -1.027754, 2.226084>,
      < -7.140909, -1.094400, 2.179100>,
      < -7.227820, -1.094400, 2.215528>
    }
    triangle {
      < -7.227820, -0.967631, 2.256718>,
      < -7.140909, -0.946219, 2.227246>,
      < -7.140909, -1.016497, 2.191437>
    }
    triangle {
      < -7.227820, -0.967631, 2.256718>,
      < -7.140909, -1.016497, 2.191437>,
      < -7.227820, -1.027754, 2.226084>
    }
    triangle {
      < -7.227820, -0.919918, 2.304432>,
      < -7.140909, -0.890446, 2.283020>,
      < -7.140909, -0.946219, 2.227246>
    }
    triangle {
      < -7.227820, -0.919918, 2.304432>,
      < -7.140909, -0.946219, 2.227246>,
      < -7.227820, -0.967631, 2.256718>
    }
    triangle {
      < -7.227820, -0.889285, 2.364554>,
      < -7.140909, -0.854639, 2.353297>,
      < -7.140909, -0.890446, 2.283020>
    }
    triangle {
      < -7.227820, -0.889285, 2.364554>,
      < -7.140909, -0.890446, 2.283020>,
      < -7.227820, -0.919918, 2.304432>
    }
    triangle {
      < -7.227820, -0.878728, 2.431200>,
      < -7.140909, -0.842299, 2.431200>,
      < -7.140909, -0.854639, 2.353297>
    }
    triangle {
      < -7.227820, -0.878728, 2.431200>,
      < -7.140909, -0.854639, 2.353297>,
      < -7.227820, -0.889285, 2.364554>
    }
    triangle {
      < -7.227820, -0.889285, 2.497847>,
      < -7.140909, -0.854639, 2.509103>,
      < -7.140909, -0.842299, 2.431200>
    }
    triangle {
      < -7.227820, -0.889285, 2.497847>,
      < -7.140909, -0.842299, 2.431200>,
      < -7.227820, -0.878728, 2.431200>
    }
    triangle {
      < -7.227820, -0.919918, 2.557969>,
      < -7.140909, -0.890446, 2.579380>,
      < -7.140909, -0.854639, 2.509103>
    }
    triangle {
      < -7.227820, -0.919918, 2.557969>,
      < -7.140909, -0.854639, 2.509103>,
      < -7.227820, -0.889285, 2.497847>
    }
    triangle {
      < -7.227820, -0.967631, 2.605683>,
      < -7.140909, -0.946219, 2.635154>,
      < -7.140909, -0.890446, 2.579380>
    }
    triangle {
      < -7.227820, -0.967631, 2.605683>,
      < -7.140909, -0.890446, 2.579380>,
      < -7.227820, -0.919918, 2.557969>
    }
    triangle {
      < -7.227820, -1.027754, 2.636316>,
      < -7.140909, -1.016497, 2.670962>,
      < -7.140909, -0.946219, 2.635154>
    }
    triangle {
      < -7.227820, -1.027754, 2.636316>,
      < -7.140909, -0.946219, 2.635154>,
      < -7.227820, -0.967631, 2.605683>
    }
    triangle {
      < -7.227820, -1.094400, 2.646872>,
      < -7.140909, -1.094400, 2.683300>,
      < -7.140909, -1.016497, 2.670962>
    }
    triangle {
      < -7.227820, -1.094400, 2.646872>,
      < -7.140909, -1.016497, 2.670962>,
      < -7.227820, -1.027754, 2.636316>
    }
    triangle {
      < -7.022911, -1.179768, 2.168466>,
      < -7.022911, -1.256779, 2.207705>,
      < -7.140909, -1.242581, 2.227246>
    }
    triangle {
      < -7.022911, -1.179768, 2.168466>,
      < -7.140909, -1.242581, 2.227246>,
      < -7.140909, -1.172304, 2.191437>
    }
    triangle {
      < -7.022911, -1.256779, 2.207705>,
      < -7.022911, -1.317896, 2.268822>,
      < -7.140909, -1.298354, 2.283020>
    }
    triangle {
      < -7.022911, -1.256779, 2.207705>,
      < -7.140909, -1.298354, 2.283020>,
      < -7.140909, -1.242581, 2.227246>
    }
    triangle {
      < -7.022911, -1.317896, 2.268822>,
      < -7.022911, -1.357134, 2.345833>,
      < -7.140909, -1.334162, 2.353297>
    }
    triangle {
      < -7.022911, -1.317896, 2.268822>,
      < -7.140909, -1.334162, 2.353297>,
      < -7.140909, -1.298354, 2.283020>
    }
    triangle {
      < -7.022911, -1.357134, 2.345833>,
      < -7.022911, -1.370656, 2.431200>,
      < -7.140909, -1.346501, 2.431200>
    }
    triangle {
      < -7.022911, -1.357134, 2.345833>,
      < -7.140909, -1.346501, 2.431200>,
      < -7.140909, -1.334162, 2.353297>
    }
    triangle {
      < -7.022911, -1.370656, 2.431200>,
      < -7.022911, -1.357134, 2.516567>,
      < -7.140909, -1.334162, 2.509103>
    }
    triangle {
      < -7.022911, -1.370656, 2.431200>,
      < -7.140909, -1.334162, 2.509103>,
      < -7.140909, -1.346501, 2.431200>
    }
    triangle {
      < -7.022911, -1.357134, 2.516567>,
      < -7.022911, -1.317896, 2.593577>,
      < -7.140909, -1.298354, 2.579380>
    }
    triangle {
      < -7.022911, -1.357134, 2.516567>,
      < -7.140909, -1.298354, 2.579380>,
      < -7.140909, -1.334162, 2.509103>
    }
    triangle {
      < -7.022911, -1.317896, 2.593577>,
      < -7.022911, -1.256779, 2.654695>,
      < -7.140909, -1.242581, 2.635154>
    }
    triangle {
      < -7.022911, -1.317896, 2.593577>,
      < -7.140909, -1.242581, 2.635154>,
      < -7.140909, -1.298354, 2.579380>
    }
    triangle {
      < -7.022911, -1.256779, 2.654695>,
      < -7.022911, -1.179768, 2.693934>,
      < -7.140909, -1.172304, 2.670962>
    }
    triangle {
      < -7.022911, -1.256779, 2.654695>,
      < -7.140909, -1.172304, 2.670962>,
      < -7.140909, -1.242581, 2.635154>
    }
    triangle {
      < -7.022911, -1.179768, 2.693934>,
      < -7.022911, -1.094401, 2.707454>,
      < -7.140909, -1.094400, 2.683300>
    }
    triangle {
      < -7.022911, -1.179768, 2.693934>,
      < -7.140909, -1.094400, 2.683300>,
      < -7.140909, -1.172304, 2.670962>
    }
    triangle {
      < -7.022911, -1.094401, 2.707454>,
      < -7.022911, -1.009033, 2.693934>,
      < -7.140909, -1.016497, 2.670962>
    }
    triangle {
      < -7.022911, -1.094401, 2.707454>,
      < -7.140909, -1.016497, 2.670962>,
      < -7.140909, -1.094400, 2.683300>
    }
    triangle {
      < -7.022911, -1.009033, 2.693934>,
      < -7.022911, -0.932022, 2.654695>,
      < -7.140909, -0.946219, 2.635154>
    }
    triangle {
      < -7.022911, -1.009033, 2.693934>,
      < -7.140909, -0.946219, 2.635154>,
      < -7.140909, -1.016497, 2.670962>
    }
    triangle {
      < -7.022911, -0.932022, 2.654695>,
      < -7.022911, -0.870906, 2.593577>,
      < -7.140909, -0.890446, 2.579380>
    }
    triangle {
      < -7.022911, -0.932022, 2.654695>,
      < -7.140909, -0.890446, 2.579380>,
      < -7.140909, -0.946219, 2.635154>
    }
    triangle {
      < -7.022911, -0.870906, 2.593577>,
      < -7.022911, -0.831667, 2.516567>,
      < -7.140909, -0.854639, 2.509103>
    }
    triangle {
      < -7.022911, -0.870906, 2.593577>,
      < -7.140909, -0.854639, 2.509103>,
      < -7.140909, -0.890446, 2.579380>
    }
    triangle {
      < -7.022911, -0.831667, 2.516567>,
      < -7.022911, -0.818146, 2.431200>,
      < -7.140909, -0.842299, 2.431200>
    }
    triangle {
      < -7.022911, -0.831667, 2.516567>,
      < -7.140909, -0.842299, 2.431200>,
      < -7.140909, -0.854639, 2.509103>
    }
    triangle {
      < -7.022911, -0.818146, 2.431200>,
      < -7.022911, -0.831667, 2.345833>,
      < -7.140909, -0.854639, 2.353297>
    }
    triangle {
      < -7.022911, -0.818146, 2.431200>,
      < -7.140909, -0.854639, 2.353297>,
      < -7.140909, -0.842299, 2.431200>
    }
    triangle {
      < -7.022911, -0.831667, 2.345833>,
      < -7.022911, -0.870906, 2.268822>,
      < -7.140909, -0.890446, 2.283020>
    }
    triangle {
      < -7.022911, -0.831667, 2.345833>,
      < -7.140909, -0.890446, 2.283020>,
      < -7.140909, -0.854639, 2.353297>
    }
    triangle {
      < -7.022911, -0.870906, 2.268822>,
      < -7.022911, -0.932022, 2.207705>,
      < -7.140909, -0.946219, 2.227246>
    }
    triangle {
      < -7.022911, -0.870906, 2.268822>,
      < -7.140909, -0.946219, 2.227246>,
      < -7.140909, -0.890446, 2.283020>
    }
    triangle {
      < -7.022911, -0.932022, 2.207705>,
      < -7.022911, -1.009033, 2.168466>,
      < -7.140909, -1.016497, 2.191437>
    }
    triangle {
      < -7.022911, -0.932022, 2.207705>,
      < -7.140909, -1.016497, 2.191437>,
      < -7.140909, -0.946219, 2.227246>
    }
    triangle {
      < -7.022911, -1.009033, 2.168466>,
      < -7.022911, -1.094401, 2.154945>,
      < -7.140909, -1.094400, 2.179100>
    }
    triangle {
      < -7.022911, -1.009033, 2.168466>,
      < -7.140909, -1.094400, 2.179100>,
      < -7.140909, -1.016497, 2.191437>
    }
    triangle {
      < -7.022911, -1.094401, 2.154945>,
      < -7.022911, -1.179768, 2.168466>,
      < -7.140909, -1.172304, 2.191437>
    }
    triangle {
      < -7.022911, -1.094401, 2.154945>,
      < -7.140909, -1.172304, 2.191437>,
      < -7.140909, -1.094400, 2.179100>
    }
    triangle {
      < -6.895309, -0.823906, 2.519088>,
      < -6.895309, -0.809985, 2.431200>,
      < -7.022911, -0.818146, 2.431200>
    }
    triangle {
      < -6.895309, -0.823906, 2.519088>,
      < -7.022911, -0.818146, 2.431200>,
      < -7.022911, -0.831667, 2.516567>
    }
    triangle {
      < -6.895309, -0.809985, 2.431200>,
      < -6.895309, -0.823906, 2.343311>,
      < -7.022911, -0.831667, 2.345833>
    }
    triangle {
      < -6.895309, -0.809985, 2.431200>,
      < -7.022911, -0.831667, 2.345833>,
      < -7.022911, -0.818146, 2.431200>
    }
    triangle {
      < -6.895309, -0.823906, 2.343311>,
      < -6.895309, -0.864303, 2.264025>,
      < -7.022911, -0.870906, 2.268822>
    }
    triangle {
      < -6.895309, -0.823906, 2.343311>,
      < -7.022911, -0.870906, 2.268822>,
      < -7.022911, -0.831667, 2.345833>
    }
    triangle {
      < -6.895309, -0.864303, 2.264025>,
      < -6.895309, -0.927226, 2.201102>,
      < -7.022911, -0.932022, 2.207705>
    }
    triangle {
      < -6.895309, -0.864303, 2.264025>,
      < -7.022911, -0.932022, 2.207705>,
      < -7.022911, -0.870906, 2.268822>
    }
    triangle {
      < -6.895309, -0.927226, 2.201102>,
      < -6.895309, -1.006511, 2.160704>,
      < -7.022911, -1.009033, 2.168466>
    }
    triangle {
      < -6.895309, -0.927226, 2.201102>,
      < -7.022911, -1.009033, 2.168466>,
      < -7.022911, -0.932022, 2.207705>
    }
    triangle {
      < -6.895309, -1.006511, 2.160704>,
      < -6.895309, -1.094401, 2.146785>,
      < -7.022911, -1.094401, 2.154945>
    }
    triangle {
      < -6.895309, -1.006511, 2.160704>,
      < -7.022911, -1.094401, 2.154945>,
      < -7.022911, -1.009033, 2.168466>
    }
    triangle {
      < -6.895309, -1.094401, 2.146785>,
      < -6.895309, -1.182290, 2.160704>,
      < -7.022911, -1.179768, 2.168466>
    }
    triangle {
      < -6.895309, -1.094401, 2.146785>,
      < -7.022911, -1.179768, 2.168466>,
      < -7.022911, -1.094401, 2.154945>
    }
    triangle {
      < -6.895309, -1.182290, 2.160704>,
      < -6.895309, -1.261576, 2.201102>,
      < -7.022911, -1.256779, 2.207705>
    }
    triangle {
      < -6.895309, -1.182290, 2.160704>,
      < -7.022911, -1.256779, 2.207705>,
      < -7.022911, -1.179768, 2.168466>
    }
    triangle {
      < -6.895309, -1.261576, 2.201102>,
      < -6.895309, -1.324498, 2.264025>,
      < -7.022911, -1.317896, 2.268822>
    }
    triangle {
      < -6.895309, -1.261576, 2.201102>,
      < -7.022911, -1.317896, 2.268822>,
      < -7.022911, -1.256779, 2.207705>
    }
    triangle {
      < -6.895309, -1.324498, 2.264025>,
      < -6.895309, -1.364895, 2.343311>,
      < -7.022911, -1.357134, 2.345833>
    }
    triangle {
      < -6.895309, -1.324498, 2.264025>,
      < -7.022911, -1.357134, 2.345833>,
      < -7.022911, -1.317896, 2.268822>
    }
    triangle {
      < -6.895309, -1.364895, 2.343311>,
      < -6.895309, -1.378816, 2.431200>,
      < -7.022911, -1.370656, 2.431200>
    }
    triangle {
      < -6.895309, -1.364895, 2.343311>,
      < -7.022911, -1.370656, 2.431200>,
      < -7.022911, -1.357134, 2.345833>
    }
    triangle {
      < -6.895309, -1.378816, 2.431200>,
      < -6.895309, -1.364895, 2.519088>,
      < -7.022911, -1.357134, 2.516567>
    }
    triangle {
      < -6.895309, -1.378816, 2.431200>,
      < -7.022911, -1.357134, 2.516567>,
      < -7.022911, -1.370656, 2.431200>
    }
    triangle {
      < -6.895309, -1.364895, 2.519088>,
      < -6.895309, -1.324498, 2.598374>,
      < -7.022911, -1.317896, 2.593577>
    }
    triangle {
      < -6.895309, -1.364895, 2.519088>,
      < -7.022911, -1.317896, 2.593577>,
      < -7.022911, -1.357134, 2.516567>
    }
    triangle {
      < -6.895309, -1.324498, 2.598374>,
      < -6.895309, -1.261576, 2.661297>,
      < -7.022911, -1.256779, 2.654695>
    }
    triangle {
      < -6.895309, -1.324498, 2.598374>,
      < -7.022911, -1.256779, 2.654695>,
      < -7.022911, -1.317896, 2.593577>
    }
    triangle {
      < -6.895309, -1.261576, 2.661297>,
      < -6.895309, -1.182290, 2.701695>,
      < -7.022911, -1.179768, 2.693934>
    }
    triangle {
      < -6.895309, -1.261576, 2.661297>,
      < -7.022911, -1.179768, 2.693934>,
      < -7.022911, -1.256779, 2.654695>
    }
    triangle {
      < -6.895309, -1.182290, 2.701695>,
      < -6.895309, -1.094401, 2.715615>,
      < -7.022911, -1.094401, 2.707454>
    }
    triangle {
      < -6.895309, -1.182290, 2.701695>,
      < -7.022911, -1.094401, 2.707454>,
      < -7.022911, -1.179768, 2.693934>
    }
    triangle {
      < -6.895309, -1.094401, 2.715615>,
      < -6.895309, -1.006511, 2.701695>,
      < -7.022911, -1.009033, 2.693934>
    }
    triangle {
      < -6.895309, -1.094401, 2.715615>,
      < -7.022911, -1.009033, 2.693934>,
      < -7.022911, -1.094401, 2.707454>
    }
    triangle {
      < -6.895309, -1.006511, 2.701695>,
      < -6.895309, -0.927226, 2.661297>,
      < -7.022911, -0.932022, 2.654695>
    }
    triangle {
      < -6.895309, -1.006511, 2.701695>,
      < -7.022911, -0.932022, 2.654695>,
      < -7.022911, -1.009033, 2.693934>
    }
    triangle {
      < -6.895309, -0.927226, 2.661297>,
      < -6.895309, -0.864303, 2.598374>,
      < -7.022911, -0.870906, 2.593577>
    }
    triangle {
      < -6.895309, -0.927226, 2.661297>,
      < -7.022911, -0.870906, 2.593577>,
      < -7.022911, -0.932022, 2.654695>
    }
    triangle {
      < -6.895309, -0.864303, 2.598374>,
      < -6.895309, -0.823906, 2.519088>,
      < -7.022911, -0.831667, 2.516567>
    }
    triangle {
      < -6.895309, -0.864303, 2.598374>,
      < -7.022911, -0.831667, 2.516567>,
      < -7.022911, -0.870906, 2.593577>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.330312, 2.259801>,
      < -6.671710, -1.265800, 2.195288>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.265800, 2.195288>,
      < -6.671710, -1.184511, 2.153870>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.184511, 2.153870>,
      < -6.671710, -1.094401, 2.139599>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.094401, 2.139599>,
      < -6.671710, -1.004290, 2.153870>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.004290, 2.153870>,
      < -6.671710, -0.923001, 2.195288>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -0.923001, 2.195288>,
      < -6.671710, -0.858489, 2.259801>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -0.858489, 2.259801>,
      < -6.671710, -0.817071, 2.341090>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -0.817071, 2.341090>,
      < -6.671710, -0.802798, 2.431200>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -0.802798, 2.431200>,
      < -6.671710, -0.817071, 2.521309>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -0.817071, 2.521309>,
      < -6.671710, -0.858489, 2.602598>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -0.858489, 2.602598>,
      < -6.671710, -0.923001, 2.667111>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -0.923001, 2.667111>,
      < -6.671710, -1.004290, 2.708530>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.004290, 2.708530>,
      < -6.671710, -1.094401, 2.722801>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.094401, 2.722801>,
      < -6.671710, -1.184511, 2.708530>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.184511, 2.708530>,
      < -6.671710, -1.265800, 2.667111>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.265800, 2.667111>,
      < -6.671710, -1.330312, 2.602598>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.330312, 2.602598>,
      < -6.671710, -1.371730, 2.521309>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.371730, 2.521309>,
      < -6.671710, -1.386003, 2.431200>
    }
    triangle {
      < -6.671710, -1.330312, 2.602598>,
      < -6.671710, -1.265800, 2.667111>,
      < -6.895309, -1.261576, 2.661297>
    }
    triangle {
      < -6.671710, -1.330312, 2.602598>,
      < -6.895309, -1.261576, 2.661297>,
      < -6.895309, -1.324498, 2.598374>
    }
    triangle {
      < -6.671710, -1.265800, 2.667111>,
      < -6.671710, -1.184511, 2.708530>,
      < -6.895309, -1.182290, 2.701695>
    }
    triangle {
      < -6.671710, -1.265800, 2.667111>,
      < -6.895309, -1.182290, 2.701695>,
      < -6.895309, -1.261576, 2.661297>
    }
    triangle {
      < -6.671710, -1.184511, 2.708530>,
      < -6.671710, -1.094401, 2.722801>,
      < -6.895309, -1.094401, 2.715615>
    }
    triangle {
      < -6.671710, -1.184511, 2.708530>,
      < -6.895309, -1.094401, 2.715615>,
      < -6.895309, -1.182290, 2.701695>
    }
    triangle {
      < -6.671710, -1.094401, 2.722801>,
      < -6.671710, -1.004290, 2.708530>,
      < -6.895309, -1.006511, 2.701695>
    }
    triangle {
      < -6.671710, -1.094401, 2.722801>,
      < -6.895309, -1.006511, 2.701695>,
      < -6.895309, -1.094401, 2.715615>
    }
    triangle {
      < -6.671710, -1.004290, 2.708530>,
      < -6.671710, -0.923001, 2.667111>,
      < -6.895309, -0.927226, 2.661297>
    }
    triangle {
      < -6.671710, -1.004290, 2.708530>,
      < -6.895309, -0.927226, 2.661297>,
      < -6.895309, -1.006511, 2.701695>
    }
    triangle {
      < -6.671710, -0.923001, 2.667111>,
      < -6.671710, -0.858489, 2.602598>,
      < -6.895309, -0.864303, 2.598374>
    }
    triangle {
      < -6.671710, -0.923001, 2.667111>,
      < -6.895309, -0.864303, 2.598374>,
      < -6.895309, -0.927226, 2.661297>
    }
    triangle {
      < -6.671710, -0.858489, 2.602598>,
      < -6.671710, -0.817071, 2.521309>,
      < -6.895309, -0.823906, 2.519088>
    }
    triangle {
      < -6.671710, -0.858489, 2.602598>,
      < -6.895309, -0.823906, 2.519088>,
      < -6.895309, -0.864303, 2.598374>
    }
    triangle {
      < -6.671710, -0.817071, 2.521309>,
      < -6.671710, -0.802798, 2.431200>,
      < -6.895309, -0.809985, 2.431200>
    }
    triangle {
      < -6.671710, -0.817071, 2.521309>,
      < -6.895309, -0.809985, 2.431200>,
      < -6.895309, -0.823906, 2.519088>
    }
    triangle {
      < -6.671710, -0.802798, 2.431200>,
      < -6.671710, -0.817071, 2.341090>,
      < -6.895309, -0.823906, 2.343311>
    }
    triangle {
      < -6.671710, -0.802798, 2.431200>,
      < -6.895309, -0.823906, 2.343311>,
      < -6.895309, -0.809985, 2.431200>
    }
    triangle {
      < -6.671710, -0.817071, 2.341090>,
      < -6.671710, -0.858489, 2.259801>,
      < -6.895309, -0.864303, 2.264025>
    }
    triangle {
      < -6.671710, -0.817071, 2.341090>,
      < -6.895309, -0.864303, 2.264025>,
      < -6.895309, -0.823906, 2.343311>
    }
    triangle {
      < -6.671710, -0.858489, 2.259801>,
      < -6.671710, -0.923001, 2.195288>,
      < -6.895309, -0.927226, 2.201102>
    }
    triangle {
      < -6.671710, -0.858489, 2.259801>,
      < -6.895309, -0.927226, 2.201102>,
      < -6.895309, -0.864303, 2.264025>
    }
    triangle {
      < -6.671710, -0.923001, 2.195288>,
      < -6.671710, -1.004290, 2.153870>,
      < -6.895309, -1.006511, 2.160704>
    }
    triangle {
      < -6.671710, -0.923001, 2.195288>,
      < -6.895309, -1.006511, 2.160704>,
      < -6.895309, -0.927226, 2.201102>
    }
    triangle {
      < -6.671710, -1.004290, 2.153870>,
      < -6.671710, -1.094401, 2.139599>,
      < -6.895309, -1.094401, 2.146785>
    }
    triangle {
      < -6.671710, -1.004290, 2.153870>,
      < -6.895309, -1.094401, 2.146785>,
      < -6.895309, -1.006511, 2.160704>
    }
    triangle {
      < -6.671710, -1.094401, 2.139599>,
      < -6.671710, -1.184511, 2.153870>,
      < -6.895309, -1.182290, 2.160704>
    }
    triangle {
      < -6.671710, -1.094401, 2.139599>,
      < -6.895309, -1.182290, 2.160704>,
      < -6.895309, -1.094401, 2.146785>
    }
    triangle {
      < -6.671710, -1.184511, 2.153870>,
      < -6.671710, -1.265800, 2.195288>,
      < -6.895309, -1.261576, 2.201102>
    }
    triangle {
      < -6.671710, -1.184511, 2.153870>,
      < -6.895309, -1.261576, 2.201102>,
      < -6.895309, -1.182290, 2.160704>
    }
    triangle {
      < -6.671710, -1.265800, 2.195288>,
      < -6.671710, -1.330312, 2.259801>,
      < -6.895309, -1.324498, 2.264025>
    }
    triangle {
      < -6.671710, -1.265800, 2.195288>,
      < -6.895309, -1.324498, 2.264025>,
      < -6.895309, -1.261576, 2.201102>
    }
    triangle {
      < -6.671710, -1.330312, 2.259801>,
      < -6.671710, -1.371730, 2.341090>,
      < -6.895309, -1.364895, 2.343311>
    }
    triangle {
      < -6.671710, -1.330312, 2.259801>,
      < -6.895309, -1.364895, 2.343311>,
      < -6.895309, -1.324498, 2.264025>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.671710, -1.386003, 2.431200>,
      < -6.895309, -1.378816, 2.431200>
    }
    triangle {
      < -6.671710, -1.371730, 2.341090>,
      < -6.895309, -1.378816, 2.431200>,
      < -6.895309, -1.364895, 2.343311>
    }
    triangle {
      < -6.671710, -1.386003, 2.431200>,
      < -6.671710, -1.371730, 2.521309>,
      < -6.895309, -1.364895, 2.519088>
    }
    triangle {
      < -6.671710, -1.386003, 2.431200>,
      < -6.895309, -1.364895, 2.519088>,
      < -6.895309, -1.378816, 2.431200>
    }
    triangle {
      < -6.671710, -1.371730, 2.521309>,
      < -6.671710, -1.330312, 2.602598>,
      < -6.895309, -1.324498, 2.598374>
    }
    triangle {
      < -6.671710, -1.371730, 2.521309>,
      < -6.895309, -1.324498, 2.598374>,
      < -6.895309, -1.364895, 2.519088>
    }
    triangle {
      < -7.227820, -1.094400, -2.215528>,
      < -7.227820, -1.027754, -2.226084>,
      < -7.237774, -1.032043, -2.239282>
    }
    triangle {
      < -7.227820, -1.094400, -2.215528>,
      < -7.237774, -1.032043, -2.239282>,
      < -7.237774, -1.094400, -2.229406>
    }
    triangle {
      < -7.227820, -1.027754, -2.226084>,
      < -7.227820, -0.967631, -2.256718>,
      < -7.237774, -0.975788, -2.267945>
    }
    triangle {
      < -7.227820, -1.027754, -2.226084>,
      < -7.237774, -0.975788, -2.267945>,
      < -7.237774, -1.032043, -2.239282>
    }
    triangle {
      < -7.227820, -0.967631, -2.256718>,
      < -7.227820, -0.919918, -2.304432>,
      < -7.237774, -0.931145, -2.312589>
    }
    triangle {
      < -7.227820, -0.967631, -2.256718>,
      < -7.237774, -0.931145, -2.312589>,
      < -7.237774, -0.975788, -2.267945>
    }
    triangle {
      < -7.227820, -0.919918, -2.304432>,
      < -7.227820, -0.889285, -2.364554>,
      < -7.237774, -0.902483, -2.368843>
    }
    triangle {
      < -7.227820, -0.919918, -2.304432>,
      < -7.237774, -0.902483, -2.368843>,
      < -7.237774, -0.931145, -2.312589>
    }
    triangle {
      < -7.227820, -0.889285, -2.364554>,
      < -7.227820, -0.878728, -2.431200>,
      < -7.237774, -0.892606, -2.431200>
    }
    triangle {
      < -7.227820, -0.889285, -2.364554>,
      < -7.237774, -0.892606, -2.431200>,
      < -7.237774, -0.902483, -2.368843>
    }
    triangle {
      < -7.227820, -0.878728, -2.431200>,
      < -7.227820, -0.889285, -2.497847>,
      < -7.237774, -0.902483, -2.493558>
    }
    triangle {
      < -7.227820, -0.878728, -2.431200>,
      < -7.237774, -0.902483, -2.493558>,
      < -7.237774, -0.892606, -2.431200>
    }
    triangle {
      < -7.227820, -0.889285, -2.497847>,
      < -7.227820, -0.919918, -2.557969>,
      < -7.237774, -0.931145, -2.549812>
    }
    triangle {
      < -7.227820, -0.889285, -2.497847>,
      < -7.237774, -0.931145, -2.549812>,
      < -7.237774, -0.902483, -2.493558>
    }
    triangle {
      < -7.227820, -0.919918, -2.557969>,
      < -7.227820, -0.967631, -2.605683>,
      < -7.237774, -0.975788, -2.594456>
    }
    triangle {
      < -7.227820, -0.919918, -2.557969>,
      < -7.237774, -0.975788, -2.594456>,
      < -7.237774, -0.931145, -2.549812>
    }
    triangle {
      < -7.227820, -0.967631, -2.605683>,
      < -7.227820, -1.027754, -2.636316>,
      < -7.237774, -1.032043, -2.623118>
    }
    triangle {
      < -7.227820, -0.967631, -2.605683>,
      < -7.237774, -1.032043, -2.623118>,
      < -7.237774, -0.975788, -2.594456>
    }
    triangle {
      < -7.227820, -1.027754, -2.636316>,
      < -7.227820, -1.094400, -2.646872>,
      < -7.237774, -1.094400, -2.632995>
    }
    triangle {
      < -7.227820, -1.027754, -2.636316>,
      < -7.237774, -1.094400, -2.632995>,
      < -7.237774, -1.032043, -2.623118>
    }
    triangle {
      < -7.227820, -1.094400, -2.646872>,
      < -7.227820, -1.161047, -2.636316>,
      < -7.237774, -1.156758, -2.623118>
    }
    triangle {
      < -7.227820, -1.094400, -2.646872>,
      < -7.237774, -1.156758, -2.623118>,
      < -7.237774, -1.094400, -2.632995>
    }
    triangle {
      < -7.227820, -1.161047, -2.636316>,
      < -7.227820, -1.221169, -2.605683>,
      < -7.237774, -1.213012, -2.594456>
    }
    triangle {
      < -7.227820, -1.161047, -2.636316>,
      < -7.237774, -1.213012, -2.594456>,
      < -7.237774, -1.156758, -2.623118>
    }
    triangle {
      < -7.227820, -1.221169, -2.605683>,
      < -7.227820, -1.268882, -2.557969>,
      < -7.237774, -1.257655, -2.549812>
    }
    triangle {
      < -7.227820, -1.221169, -2.605683>,
      < -7.237774, -1.257655, -2.549812>,
      < -7.237774, -1.213012, -2.594456>
    }
    triangle {
      < -7.227820, -1.268882, -2.557969>,
      < -7.227820, -1.299516, -2.497847>,
      < -7.237774, -1.286318, -2.493558>
    }
    triangle {
      < -7.227820, -1.268882, -2.557969>,
      < -7.237774, -1.286318, -2.493558>,
      < -7.237774, -1.257655, -2.549812>
    }
    triangle {
      < -7.227820, -1.299516, -2.497847>,
      < -7.227820, -1.310073, -2.431200>,
      < -7.237774, -1.296195, -2.431200>
    }
    triangle {
      < -7.227820, -1.299516, -2.497847>,
      < -7.237774, -1.296195, -2.431200>,
      < -7.237774, -1.286318, -2.493558>
    }
    triangle {
      < -7.227820, -1.310073, -2.431200>,
      < -7.227820, -1.299516, -2.364554>,
      < -7.237774, -1.286318, -2.368843>
    }
    triangle {
      < -7.227820, -1.310073, -2.431200>,
      < -7.237774, -1.286318, -2.368843>,
      < -7.237774, -1.296195, -2.431200>
    }
    triangle {
      < -7.227820, -1.299516, -2.364554>,
      < -7.227820, -1.268882, -2.304432>,
      < -7.237774, -1.257655, -2.312589>
    }
    triangle {
      < -7.227820, -1.299516, -2.364554>,
      < -7.237774, -1.257655, -2.312589>,
      < -7.237774, -1.286318, -2.368843>
    }
    triangle {
      < -7.227820, -1.268882, -2.304432>,
      < -7.227820, -1.221169, -2.256718>,
      < -7.237774, -1.213012, -2.267945>
    }
    triangle {
      < -7.227820, -1.268882, -2.304432>,
      < -7.237774, -1.213012, -2.267945>,
      < -7.237774, -1.257655, -2.312589>
    }
    triangle {
      < -7.227820, -1.221169, -2.256718>,
      < -7.227820, -1.161047, -2.226084>,
      < -7.237774, -1.156758, -2.239282>
    }
    triangle {
      < -7.227820, -1.221169, -2.256718>,
      < -7.237774, -1.156758, -2.239282>,
      < -7.237774, -1.213012, -2.267945>
    }
    triangle {
      < -7.227820, -1.161047, -2.226084>,
      < -7.227820, -1.094400, -2.215528>,
      < -7.237774, -1.094400, -2.229406>
    }
    triangle {
      < -7.227820, -1.161047, -2.226084>,
      < -7.237774, -1.094400, -2.229406>,
      < -7.237774, -1.156758, -2.239282>
    }
    triangle {
      < -7.227820, -1.094400, 2.646872>,
      < -7.227820, -1.027754, 2.636316>,
      < -7.237774, -1.032043, 2.623118>
    }
    triangle {
      < -7.227820, -1.094400, 2.646872>,
      < -7.237774, -1.032043, 2.623118>,
      < -7.237774, -1.094400, 2.632995>
    }
    triangle {
      < -7.227820, -1.027754, 2.636316>,
      < -7.227820, -0.967631, 2.605683>,
      < -7.237774, -0.975788, 2.594456>
    }
    triangle {
      < -7.227820, -1.027754, 2.636316>,
      < -7.237774, -0.975788, 2.594456>,
      < -7.237774, -1.032043, 2.623118>
    }
    triangle {
      < -7.227820, -0.967631, 2.605683>,
      < -7.227820, -0.919918, 2.557969>,
      < -7.237774, -0.931145, 2.549812>
    }
    triangle {
      < -7.227820, -0.967631, 2.605683>,
      < -7.237774, -0.931145, 2.549812>,
      < -7.237774, -0.975788, 2.594456>
    }
    triangle {
      < -7.227820, -0.919918, 2.557969>,
      < -7.227820, -0.889285, 2.497847>,
      < -7.237774, -0.902483, 2.493558>
    }
    triangle {
      < -7.227820, -0.919918, 2.557969>,
      < -7.237774, -0.902483, 2.493558>,
      < -7.237774, -0.931145, 2.549812>
    }
    triangle {
      < -7.227820, -0.889285, 2.497847>,
      < -7.227820, -0.878728, 2.431200>,
      < -7.237774, -0.892606, 2.431200>
    }
    triangle {
      < -7.227820, -0.889285, 2.497847>,
      < -7.237774, -0.892606, 2.431200>,
      < -7.237774, -0.902483, 2.493558>
    }
    triangle {
      < -7.227820, -0.878728, 2.431200>,
      < -7.227820, -0.889285, 2.364554>,
      < -7.237774, -0.902483, 2.368843>
    }
    triangle {
      < -7.227820, -0.878728, 2.431200>,
      < -7.237774, -0.902483, 2.368843>,
      < -7.237774, -0.892606, 2.431200>
    }
    triangle {
      < -7.227820, -0.889285, 2.364554>,
      < -7.227820, -0.919918, 2.304432>,
      < -7.237774, -0.931145, 2.312589>
    }
    triangle {
      < -7.227820, -0.889285, 2.364554>,
      < -7.237774, -0.931145, 2.312589>,
      < -7.237774, -0.902483, 2.368843>
    }
    triangle {
      < -7.227820, -0.919918, 2.304432>,
      < -7.227820, -0.967631, 2.256718>,
      < -7.237774, -0.975788, 2.267945>
    }
    triangle {
      < -7.227820, -0.919918, 2.304432>,
      < -7.237774, -0.975788, 2.267945>,
      < -7.237774, -0.931145, 2.312589>
    }
    triangle {
      < -7.227820, -0.967631, 2.256718>,
      < -7.227820, -1.027754, 2.226084>,
      < -7.237774, -1.032043, 2.239282>
    }
    triangle {
      < -7.227820, -0.967631, 2.256718>,
      < -7.237774, -1.032043, 2.239282>,
      < -7.237774, -0.975788, 2.267945>
    }
    triangle {
      < -7.227820, -1.027754, 2.226084>,
      < -7.227820, -1.094400, 2.215528>,
      < -7.237774, -1.094400, 2.229406>
    }
    triangle {
      < -7.227820, -1.027754, 2.226084>,
      < -7.237774, -1.094400, 2.229406>,
      < -7.237774, -1.032043, 2.239282>
    }
    triangle {
      < -7.227820, -1.094400, 2.215528>,
      < -7.227820, -1.161047, 2.226084>,
      < -7.237774, -1.156758, 2.239282>
    }
    triangle {
      < -7.227820, -1.094400, 2.215528>,
      < -7.237774, -1.156758, 2.239282>,
      < -7.237774, -1.094400, 2.229406>
    }
    triangle {
      < -7.227820, -1.161047, 2.226084>,
      < -7.227820, -1.221169, 2.256718>,
      < -7.237774, -1.213012, 2.267945>
    }
    triangle {
      < -7.227820, -1.161047, 2.226084>,
      < -7.237774, -1.213012, 2.267945>,
      < -7.237774, -1.156758, 2.239282>
    }
    triangle {
      < -7.227820, -1.221169, 2.256718>,
      < -7.227820, -1.268882, 2.304432>,
      < -7.237774, -1.257655, 2.312589>
    }
    triangle {
      < -7.227820, -1.221169, 2.256718>,
      < -7.237774, -1.257655, 2.312589>,
      < -7.237774, -1.213012, 2.267945>
    }
    triangle {
      < -7.227820, -1.268882, 2.304432>,
      < -7.227820, -1.299516, 2.364554>,
      < -7.237774, -1.286318, 2.368843>
    }
    triangle {
      < -7.227820, -1.268882, 2.304432>,
      < -7.237774, -1.286318, 2.368843>,
      < -7.237774, -1.257655, 2.312589>
    }
    triangle {
      < -7.227820, -1.299516, 2.364554>,
      < -7.227820, -1.310073, 2.431200>,
      < -7.237774, -1.296195, 2.431200>
    }
    triangle {
      < -7.227820, -1.299516, 2.364554>,
      < -7.237774, -1.296195, 2.431200>,
      < -7.237774, -1.286318, 2.368843>
    }
    triangle {
      < -7.227820, -1.310073, 2.431200>,
      < -7.227820, -1.299516, 2.497847>,
      < -7.237774, -1.286318, 2.493558>
    }
    triangle {
      < -7.227820, -1.310073, 2.431200>,
      < -7.237774, -1.286318, 2.493558>,
      < -7.237774, -1.296195, 2.431200>
    }
    triangle {
      < -7.227820, -1.299516, 2.497847>,
      < -7.227820, -1.268882, 2.557969>,
      < -7.237774, -1.257655, 2.549812>
    }
    triangle {
      < -7.227820, -1.299516, 2.497847>,
      < -7.237774, -1.257655, 2.549812>,
      < -7.237774, -1.286318, 2.493558>
    }
    triangle {
      < -7.227820, -1.268882, 2.557969>,
      < -7.227820, -1.221169, 2.605683>,
      < -7.237774, -1.213012, 2.594456>
    }
    triangle {
      < -7.227820, -1.268882, 2.557969>,
      < -7.237774, -1.213012, 2.594456>,
      < -7.237774, -1.257655, 2.549812>
    }
    triangle {
      < -7.227820, -1.221169, 2.605683>,
      < -7.227820, -1.161047, 2.636316>,
      < -7.237774, -1.156758, 2.623118>
    }
    triangle {
      < -7.227820, -1.221169, 2.605683>,
      < -7.237774, -1.156758, 2.623118>,
      < -7.237774, -1.213012, 2.594456>
    }
    triangle {
      < -7.227820, -1.161047, 2.636316>,
      < -7.227820, -1.094400, 2.646872>,
      < -7.237774, -1.094400, 2.632995>
    }
    triangle {
      < -7.227820, -1.161047, 2.636316>,
      < -7.237774, -1.094400, 2.632995>,
      < -7.237774, -1.156758, 2.623118>
    }
    texture {chrome}
  }
  // lfrim
  union {
    triangle {
      < -4.515183, -1.623114, 2.842164>,
      < -4.514218, -1.629982, 2.828054>,
      < -4.498979, -1.628912, 2.828054>
    }
    triangle {
      < -4.529768, -1.519337, 2.813766>,
      < -4.515183, -1.623114, 2.842164>,
      < -4.513028, -1.518169, 2.813766>
    }
    triangle {
      < -4.506346, -1.413064, 2.769109>,
      < -4.544351, -1.415561, 2.769109>,
      < -4.529768, -1.519337, 2.813766>
    }
    triangle {
      < -4.506346, -1.413064, 2.769109>,
      < -4.529768, -1.519337, 2.813766>,
      < -4.513028, -1.518169, 2.813766>
    }
    triangle {
      < -4.513028, -1.518169, 2.813766>,
      < -4.498978, -1.514298, 2.792428>,
      < -4.498977, -1.399683, 2.756803>
    }
    triangle {
      < -4.513028, -1.518169, 2.813766>,
      < -4.498977, -1.399683, 2.756803>,
      < -4.506346, -1.413064, 2.769109>
    }
    triangle {
      < -4.498977, -1.378512, 2.779159>,
      < -4.549065, -1.382018, 2.779159>,
      < -4.546118, -1.402983, 2.756803>
    }
    triangle {
      < -4.498977, -1.378512, 2.779159>,
      < -4.546118, -1.402983, 2.756803>,
      < -4.498977, -1.399683, 2.756803>
    }
    triangle {
      < -4.498977, -1.293829, 2.764932>,
      < -4.550430, -1.295944, 2.764932>,
      < -4.549065, -1.382018, 2.779159>
    }
    triangle {
      < -4.498977, -1.293829, 2.764932>,
      < -4.549065, -1.382018, 2.779159>,
      < -4.498977, -1.378512, 2.779159>
    }
    triangle {
      < -4.498974, -1.257585, 2.663333>,
      < -4.554622, -1.259871, 2.663333>,
      < -4.550430, -1.295944, 2.764932>
    }
    triangle {
      < -4.498974, -1.257585, 2.663333>,
      < -4.550430, -1.295944, 2.764932>,
      < -4.498977, -1.293829, 2.764932>
    }
    triangle {
      < -4.498974, -1.174595, 2.663332>,
      < -4.577441, -1.180085, 2.663332>,
      < -4.554622, -1.259871, 2.663333>
    }
    triangle {
      < -4.498974, -1.174595, 2.663332>,
      < -4.554622, -1.259871, 2.663333>,
      < -4.498974, -1.257585, 2.663333>
    }
    triangle {
      < -4.498976, -1.166804, 2.744609>,
      < -4.578528, -1.172370, 2.744609>,
      < -4.577441, -1.180085, 2.663332>
    }
    triangle {
      < -4.498976, -1.166804, 2.744609>,
      < -4.577441, -1.180085, 2.663332>,
      < -4.498974, -1.174595, 2.663332>
    }
    triangle {
      < -4.498976, -1.103292, 2.736479>,
      < -4.587367, -1.109476, 2.736479>,
      < -4.578528, -1.172370, 2.744609>
    }
    triangle {
      < -4.498976, -1.103292, 2.736479>,
      < -4.578528, -1.172370, 2.744609>,
      < -4.498976, -1.166804, 2.744609>
    }
    triangle {
      < -4.498973, -1.103207, 2.633340>,
      < -4.587376, -1.109391, 2.633340>,
      < -4.587367, -1.109476, 2.736479>
    }
    triangle {
      < -4.498973, -1.103207, 2.633340>,
      < -4.587367, -1.109476, 2.736479>,
      < -4.498976, -1.103292, 2.736479>
    }
    triangle {
      < -4.515183, -1.623114, 2.842164>,
      < -4.531072, -1.626495, 2.842164>,
      < -4.529160, -1.633162, 2.828054>
    }
    triangle {
      < -4.515183, -1.623114, 2.842164>,
      < -4.529160, -1.633162, 2.828054>,
      < -4.514218, -1.629982, 2.828054>
    }
    triangle {
      < -4.529768, -1.519337, 2.813766>,
      < -4.559957, -1.525758, 2.813766>,
      < -4.531072, -1.626495, 2.842164>
    }
    triangle {
      < -4.529768, -1.519337, 2.813766>,
      < -4.531072, -1.626495, 2.842164>,
      < -4.515183, -1.623114, 2.842164>
    }
    triangle {
      < -4.544351, -1.415561, 2.769109>,
      < -4.588841, -1.425021, 2.769109>,
      < -4.559957, -1.525758, 2.813766>
    }
    triangle {
      < -4.544351, -1.415561, 2.769109>,
      < -4.559957, -1.525758, 2.813766>,
      < -4.529768, -1.519337, 2.813766>
    }
    triangle {
      < -4.546118, -1.402983, 2.756803>,
      < -4.592341, -1.412811, 2.756803>,
      < -4.588841, -1.425021, 2.769109>
    }
    triangle {
      < -4.546118, -1.402983, 2.756803>,
      < -4.588841, -1.425021, 2.769109>,
      < -4.544351, -1.415561, 2.769109>
    }
    triangle {
      < -4.549065, -1.382018, 2.779159>,
      < -4.598177, -1.392461, 2.779159>,
      < -4.592341, -1.412811, 2.756803>
    }
    triangle {
      < -4.549065, -1.382018, 2.779159>,
      < -4.592341, -1.412811, 2.756803>,
      < -4.546118, -1.402983, 2.756803>
    }
    triangle {
      < -4.631938, -1.313273, 2.764932>,
      < -4.598177, -1.392461, 2.779159>,
      < -4.600038, -1.326766, 2.768997>
    }
    triangle {
      < -4.642776, -1.278613, 2.663333>,
      < -4.631938, -1.313273, 2.764932>,
      < -4.600038, -1.326766, 2.768997>
    }
    triangle {
      < -4.642776, -1.278613, 2.663333>,
      < -4.600038, -1.326766, 2.768997>,
      < -4.608274, -1.293206, 2.663333>
    }
    triangle {
      < -4.554622, -1.259871, 2.663333>,
      < -4.642776, -1.278613, 2.663333>,
      < -4.608274, -1.293206, 2.663333>
    }
    triangle {
      < -4.554622, -1.259871, 2.663333>,
      < -4.608274, -1.293206, 2.663333>,
      < -4.580204, -1.287238, 2.663333>
    }
    triangle {
      < -4.578528, -1.172370, 2.744609>,
      < -4.656530, -1.188953, 2.744609>,
      < -4.654381, -1.196442, 2.663332>
    }
    triangle {
      < -4.578528, -1.172370, 2.744609>,
      < -4.654381, -1.196442, 2.663332>,
      < -4.577441, -1.180085, 2.663332>
    }
    triangle {
      < -4.587367, -1.109476, 2.736479>,
      < -4.674037, -1.127901, 2.736479>,
      < -4.656530, -1.188953, 2.744609>
    }
    triangle {
      < -4.587367, -1.109476, 2.736479>,
      < -4.656530, -1.188953, 2.744609>,
      < -4.578528, -1.172370, 2.744609>
    }
    triangle {
      < -4.587376, -1.109391, 2.633340>,
      < -4.674057, -1.127819, 2.633340>,
      < -4.674037, -1.127901, 2.736479>
    }
    triangle {
      < -4.587376, -1.109391, 2.633340>,
      < -4.674037, -1.127901, 2.736479>,
      < -4.587367, -1.109476, 2.736479>
    }
    triangle {
      < -4.531072, -1.626495, 2.842164>,
      < -4.546336, -1.632054, 2.842164>,
      < -4.543515, -1.638390, 2.828054>
    }
    triangle {
      < -4.531072, -1.626495, 2.842164>,
      < -4.543515, -1.638390, 2.828054>,
      < -4.529160, -1.633162, 2.828054>
    }
    triangle {
      < -4.559957, -1.525758, 2.813766>,
      < -4.588959, -1.536317, 2.813766>,
      < -4.546336, -1.632054, 2.842164>
    }
    triangle {
      < -4.559957, -1.525758, 2.813766>,
      < -4.546336, -1.632054, 2.842164>,
      < -4.531072, -1.626495, 2.842164>
    }
    triangle {
      < -4.588841, -1.425021, 2.769109>,
      < -4.631582, -1.440581, 2.769109>,
      < -4.588959, -1.536317, 2.813766>
    }
    triangle {
      < -4.588841, -1.425021, 2.769109>,
      < -4.588959, -1.536317, 2.813766>,
      < -4.559957, -1.525758, 2.813766>
    }
    triangle {
      < -4.592341, -1.412811, 2.756803>,
      < -4.636747, -1.428977, 2.756803>,
      < -4.631582, -1.440581, 2.769109>
    }
    triangle {
      < -4.592341, -1.412811, 2.756803>,
      < -4.631582, -1.440581, 2.769109>,
      < -4.588841, -1.425021, 2.769109>
    }
    triangle {
      < -4.598177, -1.392461, 2.779159>,
      < -4.645359, -1.409637, 2.779159>,
      < -4.636747, -1.428977, 2.756803>
    }
    triangle {
      < -4.598177, -1.392461, 2.779159>,
      < -4.636747, -1.428977, 2.756803>,
      < -4.592341, -1.412811, 2.756803>
    }
    triangle {
      < -4.631938, -1.313273, 2.764932>,
      < -4.679802, -1.332274, 2.764932>,
      < -4.645359, -1.409637, 2.779159>
    }
    triangle {
      < -4.631938, -1.313273, 2.764932>,
      < -4.645359, -1.409637, 2.779159>,
      < -4.598177, -1.392461, 2.779159>
    }
    triangle {
      < -4.642776, -1.278613, 2.663333>,
      < -4.694541, -1.299162, 2.663333>,
      < -4.679802, -1.332274, 2.764932>
    }
    triangle {
      < -4.642776, -1.278613, 2.663333>,
      < -4.679802, -1.332274, 2.764932>,
      < -4.631938, -1.313273, 2.764932>
    }
    triangle {
      < -4.654381, -1.196442, 2.663332>,
      < -4.728295, -1.223347, 2.663332>,
      < -4.694541, -1.299162, 2.663333>
    }
    triangle {
      < -4.654381, -1.196442, 2.663332>,
      < -4.694541, -1.299162, 2.663333>,
      < -4.642776, -1.278613, 2.663333>
    }
    triangle {
      < -4.656530, -1.188953, 2.744609>,
      < -4.731466, -1.216231, 2.744609>,
      < -4.728295, -1.223347, 2.663332>
    }
    triangle {
      < -4.656530, -1.188953, 2.744609>,
      < -4.728295, -1.223347, 2.663332>,
      < -4.654381, -1.196442, 2.663332>
    }
    triangle {
      < -4.674037, -1.127901, 2.736479>,
      < -4.757298, -1.158209, 2.736479>,
      < -4.731466, -1.216231, 2.744609>
    }
    triangle {
      < -4.674037, -1.127901, 2.736479>,
      < -4.731466, -1.216231, 2.744609>,
      < -4.656530, -1.188953, 2.744609>
    }
    triangle {
      < -4.674057, -1.127819, 2.633340>,
      < -4.757330, -1.158131, 2.633340>,
      < -4.757298, -1.158209, 2.736479>
    }
    triangle {
      < -4.674057, -1.127819, 2.633340>,
      < -4.757298, -1.158209, 2.736479>,
      < -4.674037, -1.127901, 2.736479>
    }
    triangle {
      < -4.546336, -1.632054, 2.842164>,
      < -4.560678, -1.639683, 2.842164>,
      < -4.557002, -1.645565, 2.828054>
    }
    triangle {
      < -4.546336, -1.632054, 2.842164>,
      < -4.557002, -1.645565, 2.828054>,
      < -4.543515, -1.638390, 2.828054>
    }
    triangle {
      < -4.588959, -1.536317, 2.813766>,
      < -4.616210, -1.550811, 2.813766>,
      < -4.560678, -1.639683, 2.842164>
    }
    triangle {
      < -4.588959, -1.536317, 2.813766>,
      < -4.560678, -1.639683, 2.842164>,
      < -4.546336, -1.632054, 2.842164>
    }
    triangle {
      < -4.631582, -1.440581, 2.769109>,
      < -4.671741, -1.461937, 2.769109>,
      < -4.616210, -1.550811, 2.813766>
    }
    triangle {
      < -4.631582, -1.440581, 2.769109>,
      < -4.616210, -1.550811, 2.813766>,
      < -4.588959, -1.536317, 2.813766>
    }
    triangle {
      < -4.636747, -1.428977, 2.756803>,
      < -4.678472, -1.451166, 2.756803>,
      < -4.671741, -1.461937, 2.769109>
    }
    triangle {
      < -4.636747, -1.428977, 2.756803>,
      < -4.671741, -1.461937, 2.769109>,
      < -4.631582, -1.440581, 2.769109>
    }
    triangle {
      < -4.645359, -1.409637, 2.779159>,
      < -4.689691, -1.433212, 2.779159>,
      < -4.678472, -1.451166, 2.756803>
    }
    triangle {
      < -4.645359, -1.409637, 2.779159>,
      < -4.678472, -1.451166, 2.756803>,
      < -4.636747, -1.428977, 2.756803>
    }
    triangle {
      < -4.679802, -1.332274, 2.764932>,
      < -4.725947, -1.355134, 2.764932>,
      < -4.689691, -1.433212, 2.779159>
    }
    triangle {
      < -4.679802, -1.332274, 2.764932>,
      < -4.689691, -1.433212, 2.779159>,
      < -4.645359, -1.409637, 2.779159>
    }
    triangle {
      < -4.694541, -1.299162, 2.663333>,
      < -4.744448, -1.323885, 2.663333>,
      < -4.725947, -1.355134, 2.764932>
    }
    triangle {
      < -4.694541, -1.299162, 2.663333>,
      < -4.725947, -1.355134, 2.764932>,
      < -4.679802, -1.332274, 2.764932>
    }
    triangle {
      < -4.728295, -1.223347, 2.663332>,
      < -4.797746, -1.260278, 2.663332>,
      < -4.744448, -1.323885, 2.663333>
    }
    triangle {
      < -4.728295, -1.223347, 2.663332>,
      < -4.744448, -1.323885, 2.663333>,
      < -4.694541, -1.299162, 2.663333>
    }
    triangle {
      < -4.731466, -1.216231, 2.744609>,
      < -4.801876, -1.253672, 2.744609>,
      < -4.797746, -1.260278, 2.663332>
    }
    triangle {
      < -4.731466, -1.216231, 2.744609>,
      < -4.797746, -1.260278, 2.663332>,
      < -4.728295, -1.223347, 2.663332>
    }
    triangle {
      < -4.757298, -1.158209, 2.736479>,
      < -4.835532, -1.199810, 2.736479>,
      < -4.801876, -1.253672, 2.744609>
    }
    triangle {
      < -4.757298, -1.158209, 2.736479>,
      < -4.801876, -1.253672, 2.744609>,
      < -4.731466, -1.216231, 2.744609>
    }
    triangle {
      < -4.757330, -1.158131, 2.633340>,
      < -4.835575, -1.199736, 2.633340>,
      < -4.835532, -1.199810, 2.736479>
    }
    triangle {
      < -4.757330, -1.158131, 2.633340>,
      < -4.835532, -1.199810, 2.736479>,
      < -4.757298, -1.158209, 2.736479>
    }
    triangle {
      < -4.560678, -1.639683, 2.842164>,
      < -4.573817, -1.649235, 2.842164>,
      < -4.569359, -1.654548, 2.828054>
    }
    triangle {
      < -4.560678, -1.639683, 2.842164>,
      < -4.569359, -1.654548, 2.828054>,
      < -4.557002, -1.645565, 2.828054>
    }
    triangle {
      < -4.616210, -1.550811, 2.813766>,
      < -4.641178, -1.568955, 2.813766>,
      < -4.573817, -1.649235, 2.842164>
    }
    triangle {
      < -4.616210, -1.550811, 2.813766>,
      < -4.573817, -1.649235, 2.842164>,
      < -4.560678, -1.639683, 2.842164>
    }
    triangle {
      < -4.671741, -1.461937, 2.769109>,
      < -4.708537, -1.488675, 2.769109>,
      < -4.641178, -1.568955, 2.813766>
    }
    triangle {
      < -4.671741, -1.461937, 2.769109>,
      < -4.641178, -1.568955, 2.813766>,
      < -4.616210, -1.550811, 2.813766>
    }
    triangle {
      < -4.678472, -1.451166, 2.756803>,
      < -4.716701, -1.478945, 2.756803>,
      < -4.708537, -1.488675, 2.769109>
    }
    triangle {
      < -4.678472, -1.451166, 2.756803>,
      < -4.708537, -1.488675, 2.769109>,
      < -4.671741, -1.461937, 2.769109>
    }
    triangle {
      < -4.689691, -1.433212, 2.779159>,
      < -4.730310, -1.462727, 2.779159>,
      < -4.716701, -1.478945, 2.756803>
    }
    triangle {
      < -4.689691, -1.433212, 2.779159>,
      < -4.716701, -1.478945, 2.756803>,
      < -4.678472, -1.451166, 2.756803>
    }
    triangle {
      < -4.793360, -1.404117, 2.764932>,
      < -4.730310, -1.462727, 2.779159>,
      < -4.758729, -1.403468, 2.768997>
    }
    triangle {
      < -4.817358, -1.376861, 2.663333>,
      < -4.793360, -1.404117, 2.764932>,
      < -4.758729, -1.403468, 2.768997>
    }
    triangle {
      < -4.817358, -1.376861, 2.663333>,
      < -4.758729, -1.403468, 2.768997>,
      < -4.779903, -1.376160, 2.663333>
    }
    triangle {
      < -4.744448, -1.323885, 2.663333>,
      < -4.817358, -1.376861, 2.663333>,
      < -4.779903, -1.376160, 2.663333>
    }
    triangle {
      < -4.744448, -1.323885, 2.663333>,
      < -4.779903, -1.376160, 2.663333>,
      < -4.756687, -1.359290, 2.663333>
    }
    triangle {
      < -4.801876, -1.253672, 2.744609>,
      < -4.866391, -1.300547, 2.744609>,
      < -4.861381, -1.306514, 2.663332>
    }
    triangle {
      < -4.801876, -1.253672, 2.744609>,
      < -4.861381, -1.306514, 2.663332>,
      < -4.797746, -1.260278, 2.663332>
    }
    triangle {
      < -4.835532, -1.199810, 2.736479>,
      < -4.907215, -1.251893, 2.736479>,
      < -4.866391, -1.300547, 2.744609>
    }
    triangle {
      < -4.835532, -1.199810, 2.736479>,
      < -4.866391, -1.300547, 2.744609>,
      < -4.801876, -1.253672, 2.744609>
    }
    triangle {
      < -4.835575, -1.199736, 2.633340>,
      < -4.907267, -1.251827, 2.633340>,
      < -4.907215, -1.251893, 2.736479>
    }
    triangle {
      < -4.835575, -1.199736, 2.633340>,
      < -4.907215, -1.251893, 2.736479>,
      < -4.835532, -1.199810, 2.736479>
    }
    triangle {
      < -4.573817, -1.649235, 2.842164>,
      < -4.585500, -1.660522, 2.842164>,
      < -4.580346, -1.665163, 2.828054>
    }
    triangle {
      < -4.573817, -1.649235, 2.842164>,
      < -4.580346, -1.665163, 2.828054>,
      < -4.569359, -1.654548, 2.828054>
    }
    triangle {
      < -4.641178, -1.568955, 2.813766>,
      < -4.663377, -1.590398, 2.813766>,
      < -4.585500, -1.660522, 2.842164>
    }
    triangle {
      < -4.641178, -1.568955, 2.813766>,
      < -4.585500, -1.660522, 2.842164>,
      < -4.573817, -1.649235, 2.842164>
    }
    triangle {
      < -4.708537, -1.488675, 2.769109>,
      < -4.741254, -1.520274, 2.769109>,
      < -4.663377, -1.590398, 2.813766>
    }
    triangle {
      < -4.708537, -1.488675, 2.769109>,
      < -4.663377, -1.590398, 2.813766>,
      < -4.641178, -1.568955, 2.813766>
    }
    triangle {
      < -4.716701, -1.478945, 2.756803>,
      < -4.750693, -1.511774, 2.756803>,
      < -4.741254, -1.520274, 2.769109>
    }
    triangle {
      < -4.716701, -1.478945, 2.756803>,
      < -4.741254, -1.520274, 2.769109>,
      < -4.708537, -1.488675, 2.769109>
    }
    triangle {
      < -4.730310, -1.462727, 2.779159>,
      < -4.766426, -1.497608, 2.779159>,
      < -4.750693, -1.511774, 2.756803>
    }
    triangle {
      < -4.730310, -1.462727, 2.779159>,
      < -4.750693, -1.511774, 2.756803>,
      < -4.716701, -1.478945, 2.756803>
    }
    triangle {
      < -4.793360, -1.404117, 2.764932>,
      < -4.829357, -1.440943, 2.764932>,
      < -4.766426, -1.497608, 2.779159>
    }
    triangle {
      < -4.793360, -1.404117, 2.764932>,
      < -4.766426, -1.497608, 2.779159>,
      < -4.730310, -1.462727, 2.779159>
    }
    triangle {
      < -4.817358, -1.376861, 2.663333>,
      < -4.856290, -1.416689, 2.663333>,
      < -4.829357, -1.440943, 2.764932>
    }
    triangle {
      < -4.817358, -1.376861, 2.663333>,
      < -4.829357, -1.440943, 2.764932>,
      < -4.793360, -1.404117, 2.764932>
    }
    triangle {
      < -4.861381, -1.306514, 2.663332>,
      < -4.917962, -1.361157, 2.663332>,
      < -4.856290, -1.416689, 2.663333>
    }
    triangle {
      < -4.861381, -1.306514, 2.663332>,
      < -4.856290, -1.416689, 2.663333>,
      < -4.817358, -1.376861, 2.663333>
    }
    triangle {
      < -4.866391, -1.300547, 2.744609>,
      < -4.923753, -1.355945, 2.744609>,
      < -4.917962, -1.361157, 2.663332>
    }
    triangle {
      < -4.866391, -1.300547, 2.744609>,
      < -4.917962, -1.361157, 2.663332>,
      < -4.861381, -1.306514, 2.663332>
    }
    triangle {
      < -4.907215, -1.251893, 2.736479>,
      < -4.970952, -1.313446, 2.736479>,
      < -4.923753, -1.355945, 2.744609>
    }
    triangle {
      < -4.907215, -1.251893, 2.736479>,
      < -4.923753, -1.355945, 2.744609>,
      < -4.866391, -1.300547, 2.744609>
    }
    triangle {
      < -4.907267, -1.251827, 2.633340>,
      < -4.971013, -1.313388, 2.633340>,
      < -4.970952, -1.313446, 2.736479>
    }
    triangle {
      < -4.907267, -1.251827, 2.633340>,
      < -4.970952, -1.313446, 2.736479>,
      < -4.907215, -1.251893, 2.736479>
    }
    triangle {
      < -4.585500, -1.660522, 2.842164>,
      < -4.595499, -1.673325, 2.842164>,
      < -4.589748, -1.677203, 2.828054>
    }
    triangle {
      < -4.585500, -1.660522, 2.842164>,
      < -4.589748, -1.677203, 2.828054>,
      < -4.580346, -1.665163, 2.828054>
    }
    triangle {
      < -4.663377, -1.590398, 2.813766>,
      < -4.682377, -1.614722, 2.813766>,
      < -4.595499, -1.673325, 2.842164>
    }
    triangle {
      < -4.663377, -1.590398, 2.813766>,
      < -4.595499, -1.673325, 2.842164>,
      < -4.585500, -1.660522, 2.842164>
    }
    triangle {
      < -4.741254, -1.520274, 2.769109>,
      < -4.769255, -1.556118, 2.769109>,
      < -4.682377, -1.614722, 2.813766>
    }
    triangle {
      < -4.741254, -1.520274, 2.769109>,
      < -4.682377, -1.614722, 2.813766>,
      < -4.663377, -1.590398, 2.813766>
    }
    triangle {
      < -4.750693, -1.511774, 2.756803>,
      < -4.779785, -1.549015, 2.756803>,
      < -4.769255, -1.556118, 2.769109>
    }
    triangle {
      < -4.750693, -1.511774, 2.756803>,
      < -4.769255, -1.556118, 2.769109>,
      < -4.741254, -1.520274, 2.769109>
    }
    triangle {
      < -4.766426, -1.497608, 2.779159>,
      < -4.797337, -1.537177, 2.779159>,
      < -4.779785, -1.549015, 2.756803>
    }
    triangle {
      < -4.766426, -1.497608, 2.779159>,
      < -4.779785, -1.549015, 2.756803>,
      < -4.750693, -1.511774, 2.756803>
    }
    triangle {
      < -4.829357, -1.440943, 2.764932>,
      < -4.862215, -1.480595, 2.764932>,
      < -4.797337, -1.537177, 2.779159>
    }
    triangle {
      < -4.829357, -1.440943, 2.764932>,
      < -4.797337, -1.537177, 2.779159>,
      < -4.766426, -1.497608, 2.779159>
    }
    triangle {
      < -4.856290, -1.416689, 2.663333>,
      < -4.891827, -1.459573, 2.663333>,
      < -4.862215, -1.480595, 2.764932>
    }
    triangle {
      < -4.856290, -1.416689, 2.663333>,
      < -4.862215, -1.480595, 2.764932>,
      < -4.829357, -1.440943, 2.764932>
    }
    triangle {
      < -4.917962, -1.361157, 2.663332>,
      < -4.966388, -1.423142, 2.663332>,
      < -4.891827, -1.459573, 2.663333>
    }
    triangle {
      < -4.917962, -1.361157, 2.663332>,
      < -4.891827, -1.459573, 2.663333>,
      < -4.856290, -1.416689, 2.663333>
    }
    triangle {
      < -4.923753, -1.355945, 2.744609>,
      < -4.972848, -1.418787, 2.744609>,
      < -4.966388, -1.423142, 2.663332>
    }
    triangle {
      < -4.923753, -1.355945, 2.744609>,
      < -4.966388, -1.423142, 2.663332>,
      < -4.917962, -1.361157, 2.663332>
    }
    triangle {
      < -4.970952, -1.313446, 2.736479>,
      < -5.025502, -1.383270, 2.736479>,
      < -4.972848, -1.418787, 2.744609>
    }
    triangle {
      < -4.970952, -1.313446, 2.736479>,
      < -4.972848, -1.418787, 2.744609>,
      < -4.923753, -1.355945, 2.744609>
    }
    triangle {
      < -4.971013, -1.313388, 2.633340>,
      < -5.025570, -1.383221, 2.633340>,
      < -5.025502, -1.383270, 2.736479>
    }
    triangle {
      < -4.971013, -1.313388, 2.633340>,
      < -5.025502, -1.383270, 2.736479>,
      < -4.970952, -1.313446, 2.736479>
    }
    triangle {
      < -4.595499, -1.673325, 2.842164>,
      < -4.603618, -1.687395, 2.842164>,
      < -4.597384, -1.690435, 2.828054>
    }
    triangle {
      < -4.595499, -1.673325, 2.842164>,
      < -4.597384, -1.690435, 2.828054>,
      < -4.589748, -1.677203, 2.828054>
    }
    triangle {
      < -4.682377, -1.614722, 2.813766>,
      < -4.697807, -1.641453, 2.813766>,
      < -4.603618, -1.687395, 2.842164>
    }
    triangle {
      < -4.682377, -1.614722, 2.813766>,
      < -4.603618, -1.687395, 2.842164>,
      < -4.595499, -1.673325, 2.842164>
    }
    triangle {
      < -4.769255, -1.556118, 2.769109>,
      < -4.791996, -1.595510, 2.769109>,
      < -4.697807, -1.641453, 2.813766>
    }
    triangle {
      < -4.769255, -1.556118, 2.769109>,
      < -4.697807, -1.641453, 2.813766>,
      < -4.682377, -1.614722, 2.813766>
    }
    triangle {
      < -4.779785, -1.549015, 2.756803>,
      < -4.803411, -1.589942, 2.756803>,
      < -4.791996, -1.595510, 2.769109>
    }
    triangle {
      < -4.779785, -1.549015, 2.756803>,
      < -4.791996, -1.595510, 2.769109>,
      < -4.769255, -1.556118, 2.769109>
    }
    triangle {
      < -4.797337, -1.537177, 2.779159>,
      < -4.822440, -1.580661, 2.779159>,
      < -4.803411, -1.589942, 2.756803>
    }
    triangle {
      < -4.797337, -1.537177, 2.779159>,
      < -4.803411, -1.589942, 2.756803>,
      < -4.779785, -1.549015, 2.756803>
    }
    triangle {
      < -4.903878, -1.552763, 2.764932>,
      < -4.822440, -1.580661, 2.779159>,
      < -4.872504, -1.538084, 2.768997>
    }
    triangle {
      < -4.936887, -1.537623, 2.663333>,
      < -4.903878, -1.552763, 2.764932>,
      < -4.872504, -1.538084, 2.768997>
    }
    triangle {
      < -4.936887, -1.537623, 2.663333>,
      < -4.872504, -1.538084, 2.768997>,
      < -4.902955, -1.521749, 2.663333>
    }
    triangle {
      < -4.891827, -1.459573, 2.663333>,
      < -4.936887, -1.537623, 2.663333>,
      < -4.902955, -1.521749, 2.663333>
    }
    triangle {
      < -4.891827, -1.459573, 2.663333>,
      < -4.902955, -1.521749, 2.663333>,
      < -4.888607, -1.496895, 2.663333>
    }
    triangle {
      < -4.972848, -1.418787, 2.744609>,
      < -5.012719, -1.487850, 2.744609>,
      < -5.005716, -1.491264, 2.663332>
    }
    triangle {
      < -4.972848, -1.418787, 2.744609>,
      < -5.005716, -1.491264, 2.663332>,
      < -4.966388, -1.423142, 2.663332>
    }
    triangle {
      < -5.025502, -1.383270, 2.736479>,
      < -5.069803, -1.460007, 2.736479>,
      < -5.012719, -1.487850, 2.744609>
    }
    triangle {
      < -5.025502, -1.383270, 2.736479>,
      < -5.012719, -1.487850, 2.744609>,
      < -4.972848, -1.418787, 2.744609>
    }
    triangle {
      < -5.025570, -1.383221, 2.633340>,
      < -5.069879, -1.459967, 2.633340>,
      < -5.069803, -1.460007, 2.736479>
    }
    triangle {
      < -5.025570, -1.383221, 2.633340>,
      < -5.069803, -1.460007, 2.736479>,
      < -5.025502, -1.383270, 2.736479>
    }
    triangle {
      < -4.603618, -1.687395, 2.842164>,
      < -4.609700, -1.702458, 2.842164>,
      < -4.603104, -1.704601, 2.828054>
    }
    triangle {
      < -4.603618, -1.687395, 2.842164>,
      < -4.603104, -1.704601, 2.828054>,
      < -4.597384, -1.690435, 2.828054>
    }
    triangle {
      < -4.697807, -1.641453, 2.813766>,
      < -4.709366, -1.670071, 2.813766>,
      < -4.609700, -1.702458, 2.842164>
    }
    triangle {
      < -4.697807, -1.641453, 2.813766>,
      < -4.609700, -1.702458, 2.842164>,
      < -4.603618, -1.687395, 2.842164>
    }
    triangle {
      < -4.791996, -1.595510, 2.769109>,
      < -4.809032, -1.637684, 2.769109>,
      < -4.709366, -1.670071, 2.813766>
    }
    triangle {
      < -4.791996, -1.595510, 2.769109>,
      < -4.709366, -1.670071, 2.813766>,
      < -4.697807, -1.641453, 2.813766>
    }
    triangle {
      < -4.803411, -1.589942, 2.756803>,
      < -4.821112, -1.633759, 2.756803>,
      < -4.809032, -1.637684, 2.769109>
    }
    triangle {
      < -4.803411, -1.589942, 2.756803>,
      < -4.809032, -1.637684, 2.769109>,
      < -4.791996, -1.595510, 2.769109>
    }
    triangle {
      < -4.822440, -1.580661, 2.779159>,
      < -4.841246, -1.627217, 2.779159>,
      < -4.821112, -1.633759, 2.756803>
    }
    triangle {
      < -4.822440, -1.580661, 2.779159>,
      < -4.821112, -1.633759, 2.756803>,
      < -4.803411, -1.589942, 2.756803>
    }
    triangle {
      < -4.903878, -1.552763, 2.764932>,
      < -4.921784, -1.601046, 2.764932>,
      < -4.841246, -1.627217, 2.779159>
    }
    triangle {
      < -4.903878, -1.552763, 2.764932>,
      < -4.841246, -1.627217, 2.779159>,
      < -4.822440, -1.580661, 2.779159>
    }
    triangle {
      < -4.936887, -1.537623, 2.663333>,
      < -4.956254, -1.589843, 2.663333>,
      < -4.921784, -1.601046, 2.764932>
    }
    triangle {
      < -4.936887, -1.537623, 2.663333>,
      < -4.921784, -1.601046, 2.764932>,
      < -4.903878, -1.552763, 2.764932>
    }
    triangle {
      < -5.005716, -1.491264, 2.663332>,
      < -5.035181, -1.564196, 2.663332>,
      < -4.956254, -1.589843, 2.663333>
    }
    triangle {
      < -5.005716, -1.491264, 2.663332>,
      < -4.956254, -1.589843, 2.663333>,
      < -4.936887, -1.537623, 2.663333>
    }
    triangle {
      < -5.012719, -1.487850, 2.744609>,
      < -5.042591, -1.561790, 2.744609>,
      < -5.035181, -1.564196, 2.663332>
    }
    triangle {
      < -5.012719, -1.487850, 2.744609>,
      < -5.035181, -1.564196, 2.663332>,
      < -5.005716, -1.491264, 2.663332>
    }
    triangle {
      < -5.069803, -1.460007, 2.736479>,
      < -5.102994, -1.542162, 2.736479>,
      < -5.042591, -1.561790, 2.744609>
    }
    triangle {
      < -5.069803, -1.460007, 2.736479>,
      < -5.042591, -1.561790, 2.744609>,
      < -5.012719, -1.487850, 2.744609>
    }
    triangle {
      < -5.069879, -1.459967, 2.633340>,
      < -5.103074, -1.542133, 2.633340>,
      < -5.102994, -1.542162, 2.736479>
    }
    triangle {
      < -5.069879, -1.459967, 2.633340>,
      < -5.102994, -1.542162, 2.736479>,
      < -5.069803, -1.460007, 2.736479>
    }
    triangle {
      < -4.609700, -1.702458, 2.842164>,
      < -4.613626, -1.718220, 2.842164>,
      < -4.606796, -1.719425, 2.828054>
    }
    triangle {
      < -4.609700, -1.702458, 2.842164>,
      < -4.606796, -1.719425, 2.828054>,
      < -4.603104, -1.704601, 2.828054>
    }
    triangle {
      < -4.709366, -1.670071, 2.813766>,
      < -4.716830, -1.700020, 2.813766>,
      < -4.613626, -1.718220, 2.842164>
    }
    triangle {
      < -4.709366, -1.670071, 2.813766>,
      < -4.613626, -1.718220, 2.842164>,
      < -4.609700, -1.702458, 2.842164>
    }
    triangle {
      < -4.809032, -1.637684, 2.769109>,
      < -4.820034, -1.681818, 2.769109>,
      < -4.716830, -1.700020, 2.813766>
    }
    triangle {
      < -4.809032, -1.637684, 2.769109>,
      < -4.716830, -1.700020, 2.813766>,
      < -4.709366, -1.670071, 2.813766>
    }
    triangle {
      < -4.821112, -1.633759, 2.756803>,
      < -4.832542, -1.679612, 2.756803>,
      < -4.820034, -1.681818, 2.769109>
    }
    triangle {
      < -4.821112, -1.633759, 2.756803>,
      < -4.820034, -1.681818, 2.769109>,
      < -4.809032, -1.637684, 2.769109>
    }
    triangle {
      < -4.841246, -1.627217, 2.779159>,
      < -4.853391, -1.675936, 2.779159>,
      < -4.832542, -1.679612, 2.756803>
    }
    triangle {
      < -4.841246, -1.627217, 2.779159>,
      < -4.832542, -1.679612, 2.756803>,
      < -4.821112, -1.633759, 2.756803>
    }
    triangle {
      < -4.921784, -1.601046, 2.764932>,
      < -4.935674, -1.650634, 2.764932>,
      < -4.853391, -1.675936, 2.779159>
    }
    triangle {
      < -4.921784, -1.601046, 2.764932>,
      < -4.853391, -1.675936, 2.779159>,
      < -4.841246, -1.627217, 2.779159>
    }
    triangle {
      < -4.956254, -1.589843, 2.663333>,
      < -4.971276, -1.643473, 2.663333>,
      < -4.935674, -1.650634, 2.764932>
    }
    triangle {
      < -4.956254, -1.589843, 2.663333>,
      < -4.935674, -1.650634, 2.764932>,
      < -4.921784, -1.601046, 2.764932>
    }
    triangle {
      < -5.035181, -1.564196, 2.663332>,
      < -5.054209, -1.640519, 2.663332>,
      < -4.971276, -1.643473, 2.663333>
    }
    triangle {
      < -5.035181, -1.564196, 2.663332>,
      < -4.971276, -1.643473, 2.663333>,
      < -4.956254, -1.589843, 2.663333>
    }
    triangle {
      < -5.042591, -1.561790, 2.744609>,
      < -5.061882, -1.639168, 2.744609>,
      < -5.054209, -1.640519, 2.663332>
    }
    triangle {
      < -5.042591, -1.561790, 2.744609>,
      < -5.054209, -1.640519, 2.663332>,
      < -5.035181, -1.564196, 2.663332>
    }
    triangle {
      < -5.102994, -1.542162, 2.736479>,
      < -5.124429, -1.628137, 2.736479>,
      < -5.061882, -1.639168, 2.744609>
    }
    triangle {
      < -5.102994, -1.542162, 2.736479>,
      < -5.061882, -1.639168, 2.744609>,
      < -5.042591, -1.561790, 2.744609>
    }
    triangle {
      < -5.103074, -1.542133, 2.633340>,
      < -5.124512, -1.628120, 2.633340>,
      < -5.124429, -1.628137, 2.736479>
    }
    triangle {
      < -5.103074, -1.542133, 2.633340>,
      < -5.124429, -1.628137, 2.736479>,
      < -5.102994, -1.542162, 2.736479>
    }
    triangle {
      < -4.613626, -1.718220, 2.842164>,
      < -4.615321, -1.734376, 2.842164>,
      < -4.608390, -1.734618, 2.828054>
    }
    triangle {
      < -4.613626, -1.718220, 2.842164>,
      < -4.608390, -1.734618, 2.828054>,
      < -4.606796, -1.719425, 2.828054>
    }
    triangle {
      < -4.716830, -1.700020, 2.813766>,
      < -4.720053, -1.730716, 2.813766>,
      < -4.615321, -1.734376, 2.842164>
    }
    triangle {
      < -4.716830, -1.700020, 2.813766>,
      < -4.615321, -1.734376, 2.842164>,
      < -4.613626, -1.718220, 2.842164>
    }
    triangle {
      < -4.820034, -1.681818, 2.769109>,
      < -4.824786, -1.727054, 2.769109>,
      < -4.720053, -1.730716, 2.813766>
    }
    triangle {
      < -4.820034, -1.681818, 2.769109>,
      < -4.720053, -1.730716, 2.813766>,
      < -4.716830, -1.700020, 2.813766>
    }
    triangle {
      < -4.832542, -1.679612, 2.756803>,
      < -4.837479, -1.726610, 2.756803>,
      < -4.824786, -1.727054, 2.769109>
    }
    triangle {
      < -4.832542, -1.679612, 2.756803>,
      < -4.824786, -1.727054, 2.769109>,
      < -4.820034, -1.681818, 2.769109>
    }
    triangle {
      < -4.853391, -1.675936, 2.779159>,
      < -4.858637, -1.725872, 2.779159>,
      < -4.837479, -1.726610, 2.756803>
    }
    triangle {
      < -4.853391, -1.675936, 2.779159>,
      < -4.837479, -1.726610, 2.756803>,
      < -4.832542, -1.679612, 2.756803>
    }
    triangle {
      < -4.944382, -1.733508, 2.764932>,
      < -4.858637, -1.725872, 2.779159>,
      < -4.921691, -1.707338, 2.768997>
    }
    triangle {
      < -4.980695, -1.733103, 2.663333>,
      < -4.944382, -1.733508, 2.764932>,
      < -4.921691, -1.707338, 2.768997>
    }
    triangle {
      < -4.980695, -1.733103, 2.663333>,
      < -4.921691, -1.707338, 2.768997>,
      < -4.956154, -1.704800, 2.663333>
    }
    triangle {
      < -4.971276, -1.643473, 2.663333>,
      < -4.980695, -1.733103, 2.663333>,
      < -4.956154, -1.704800, 2.663333>
    }
    triangle {
      < -4.971276, -1.643473, 2.663333>,
      < -4.956154, -1.704800, 2.663333>,
      < -4.953155, -1.676260, 2.663333>
    }
    triangle {
      < -5.061882, -1.639168, 2.744609>,
      < -5.070216, -1.718477, 2.744609>,
      < -5.062430, -1.718747, 2.663332>
    }
    triangle {
      < -5.061882, -1.639168, 2.744609>,
      < -5.062430, -1.718747, 2.663332>,
      < -5.054209, -1.640519, 2.663332>
    }
    triangle {
      < -5.124429, -1.628137, 2.736479>,
      < -5.133690, -1.716258, 2.736479>,
      < -5.070216, -1.718477, 2.744609>
    }
    triangle {
      < -5.124429, -1.628137, 2.736479>,
      < -5.070216, -1.718477, 2.744609>,
      < -5.061882, -1.639168, 2.744609>
    }
    triangle {
      < -5.124512, -1.628120, 2.633340>,
      < -5.133774, -1.716253, 2.633340>,
      < -5.133690, -1.716258, 2.736479>
    }
    triangle {
      < -5.124512, -1.628120, 2.633340>,
      < -5.133690, -1.716258, 2.736479>,
      < -5.124429, -1.628137, 2.736479>
    }
    triangle {
      < -4.615321, -1.734376, 2.842164>,
      < -4.614751, -1.750611, 2.842164>,
      < -4.607853, -1.749886, 2.828054>
    }
    triangle {
      < -4.615321, -1.734376, 2.842164>,
      < -4.607853, -1.749886, 2.828054>,
      < -4.608390, -1.734618, 2.828054>
    }
    triangle {
      < -4.720053, -1.730716, 2.813766>,
      < -4.718974, -1.761561, 2.813766>,
      < -4.614751, -1.750611, 2.842164>
    }
    triangle {
      < -4.720053, -1.730716, 2.813766>,
      < -4.614751, -1.750611, 2.842164>,
      < -4.615321, -1.734376, 2.842164>
    }
    triangle {
      < -4.824786, -1.727054, 2.769109>,
      < -4.823196, -1.772511, 2.769109>,
      < -4.718974, -1.761561, 2.813766>
    }
    triangle {
      < -4.824786, -1.727054, 2.769109>,
      < -4.718974, -1.761561, 2.813766>,
      < -4.720053, -1.730716, 2.813766>
    }
    triangle {
      < -4.837479, -1.726610, 2.756803>,
      < -4.835828, -1.773839, 2.756803>,
      < -4.823196, -1.772511, 2.769109>
    }
    triangle {
      < -4.837479, -1.726610, 2.756803>,
      < -4.823196, -1.772511, 2.769109>,
      < -4.824786, -1.727054, 2.769109>
    }
    triangle {
      < -4.858637, -1.725872, 2.779159>,
      < -4.856883, -1.776051, 2.779159>,
      < -4.835828, -1.773839, 2.756803>
    }
    triangle {
      < -4.858637, -1.725872, 2.779159>,
      < -4.835828, -1.773839, 2.756803>,
      < -4.837479, -1.726610, 2.756803>
    }
    triangle {
      < -4.944382, -1.733508, 2.764932>,
      < -4.941102, -1.784901, 2.764932>,
      < -4.856883, -1.776051, 2.779159>
    }
    triangle {
      < -4.944382, -1.733508, 2.764932>,
      < -4.856883, -1.776051, 2.779159>,
      < -4.858637, -1.725872, 2.779159>
    }
    triangle {
      < -4.980695, -1.733103, 2.663333>,
      < -4.977149, -1.788685, 2.663333>,
      < -4.941102, -1.784901, 2.764932>
    }
    triangle {
      < -4.980695, -1.733103, 2.663333>,
      < -4.941102, -1.784901, 2.764932>,
      < -4.944382, -1.733508, 2.764932>
    }
    triangle {
      < -5.062430, -1.718747, 2.663332>,
      < -5.059684, -1.797358, 2.663332>,
      < -4.977149, -1.788685, 2.663333>
    }
    triangle {
      < -5.062430, -1.718747, 2.663332>,
      < -4.977149, -1.788685, 2.663333>,
      < -4.980695, -1.733103, 2.663333>
    }
    triangle {
      < -5.070216, -1.718477, 2.744609>,
      < -5.067432, -1.798174, 2.744609>,
      < -5.059684, -1.797358, 2.663332>
    }
    triangle {
      < -5.070216, -1.718477, 2.744609>,
      < -5.059684, -1.797358, 2.663332>,
      < -5.062430, -1.718747, 2.663332>
    }
    triangle {
      < -5.133690, -1.716258, 2.736479>,
      < -5.130596, -1.804811, 2.736479>,
      < -5.067432, -1.798174, 2.744609>
    }
    triangle {
      < -5.133690, -1.716258, 2.736479>,
      < -5.067432, -1.798174, 2.744609>,
      < -5.070216, -1.718477, 2.744609>
    }
    triangle {
      < -5.133774, -1.716253, 2.633340>,
      < -5.130681, -1.804817, 2.633340>,
      < -5.130596, -1.804811, 2.736479>
    }
    triangle {
      < -5.133774, -1.716253, 2.633340>,
      < -5.130596, -1.804811, 2.736479>,
      < -5.133690, -1.716258, 2.736479>
    }
    triangle {
      < -4.614751, -1.750611, 2.842164>,
      < -4.611927, -1.766608, 2.842164>,
      < -4.605197, -1.764930, 2.828054>
    }
    triangle {
      < -4.614751, -1.750611, 2.842164>,
      < -4.605197, -1.764930, 2.828054>,
      < -4.607853, -1.749886, 2.828054>
    }
    triangle {
      < -4.718974, -1.761561, 2.813766>,
      < -4.713611, -1.791957, 2.813766>,
      < -4.611927, -1.766608, 2.842164>
    }
    triangle {
      < -4.718974, -1.761561, 2.813766>,
      < -4.611927, -1.766608, 2.842164>,
      < -4.614751, -1.750611, 2.842164>
    }
    triangle {
      < -4.823196, -1.772511, 2.769109>,
      < -4.815295, -1.817305, 2.769109>,
      < -4.713611, -1.791957, 2.813766>
    }
    triangle {
      < -4.823196, -1.772511, 2.769109>,
      < -4.713611, -1.791957, 2.813766>,
      < -4.718974, -1.761561, 2.813766>
    }
    triangle {
      < -4.835828, -1.773839, 2.756803>,
      < -4.827620, -1.820377, 2.756803>,
      < -4.815295, -1.817305, 2.769109>
    }
    triangle {
      < -4.835828, -1.773839, 2.756803>,
      < -4.815295, -1.817305, 2.769109>,
      < -4.823196, -1.772511, 2.769109>
    }
    triangle {
      < -4.856883, -1.776051, 2.779159>,
      < -4.848162, -1.825499, 2.779159>,
      < -4.827620, -1.820377, 2.756803>
    }
    triangle {
      < -4.856883, -1.776051, 2.779159>,
      < -4.827620, -1.820377, 2.756803>,
      < -4.835828, -1.773839, 2.756803>
    }
    triangle {
      < -4.941102, -1.784901, 2.764932>,
      < -4.933622, -1.835851, 2.764932>,
      < -4.848162, -1.825499, 2.779159>
    }
    triangle {
      < -4.941102, -1.784901, 2.764932>,
      < -4.848162, -1.825499, 2.779159>,
      < -4.856883, -1.776051, 2.779159>
    }
    triangle {
      < -4.977149, -1.788685, 2.663333>,
      < -4.969059, -1.843790, 2.663333>,
      < -4.933622, -1.835851, 2.764932>
    }
    triangle {
      < -4.977149, -1.788685, 2.663333>,
      < -4.933622, -1.835851, 2.764932>,
      < -4.941102, -1.784901, 2.764932>
    }
    triangle {
      < -5.059684, -1.797358, 2.663332>,
      < -5.046024, -1.874822, 2.663332>,
      < -4.969059, -1.843790, 2.663333>
    }
    triangle {
      < -5.059684, -1.797358, 2.663332>,
      < -4.969059, -1.843790, 2.663333>,
      < -4.977149, -1.788685, 2.663333>
    }
    triangle {
      < -5.067432, -1.798174, 2.744609>,
      < -5.053583, -1.876708, 2.744609>,
      < -5.046024, -1.874822, 2.663332>
    }
    triangle {
      < -5.067432, -1.798174, 2.744609>,
      < -5.046024, -1.874822, 2.663332>,
      < -5.059684, -1.797358, 2.663332>
    }
    triangle {
      < -5.130596, -1.804811, 2.736479>,
      < -5.115209, -1.892071, 2.736479>,
      < -5.053583, -1.876708, 2.744609>
    }
    triangle {
      < -5.130596, -1.804811, 2.736479>,
      < -5.053583, -1.876708, 2.744609>,
      < -5.067432, -1.798174, 2.744609>
    }
    triangle {
      < -5.130681, -1.804817, 2.633340>,
      < -5.115292, -1.892089, 2.633340>,
      < -5.115209, -1.892071, 2.736479>
    }
    triangle {
      < -5.130681, -1.804817, 2.633340>,
      < -5.115209, -1.892071, 2.736479>,
      < -5.130596, -1.804811, 2.736479>
    }
    triangle {
      < -4.611927, -1.766608, 2.842164>,
      < -4.606904, -1.782057, 2.842164>,
      < -4.600473, -1.779458, 2.828054>
    }
    triangle {
      < -4.611927, -1.766608, 2.842164>,
      < -4.600473, -1.779458, 2.828054>,
      < -4.605197, -1.764930, 2.828054>
    }
    triangle {
      < -4.713611, -1.791957, 2.813766>,
      < -4.704071, -1.821310, 2.813766>,
      < -4.606904, -1.782057, 2.842164>
    }
    triangle {
      < -4.713611, -1.791957, 2.813766>,
      < -4.606904, -1.782057, 2.842164>,
      < -4.611927, -1.766608, 2.842164>
    }
    triangle {
      < -4.815295, -1.817305, 2.769109>,
      < -4.801238, -1.860563, 2.769109>,
      < -4.704071, -1.821310, 2.813766>
    }
    triangle {
      < -4.815295, -1.817305, 2.769109>,
      < -4.704071, -1.821310, 2.813766>,
      < -4.713611, -1.791957, 2.813766>
    }
    triangle {
      < -4.827620, -1.820377, 2.756803>,
      < -4.813015, -1.865320, 2.756803>,
      < -4.801238, -1.860563, 2.769109>
    }
    triangle {
      < -4.827620, -1.820377, 2.756803>,
      < -4.801238, -1.860563, 2.769109>,
      < -4.815295, -1.817305, 2.769109>
    }
    triangle {
      < -4.848162, -1.825499, 2.779159>,
      < -4.832644, -1.873251, 2.779159>,
      < -4.813015, -1.865320, 2.756803>
    }
    triangle {
      < -4.848162, -1.825499, 2.779159>,
      < -4.813015, -1.865320, 2.756803>,
      < -4.827620, -1.820377, 2.756803>
    }
    triangle {
      < -4.907870, -1.915102, 2.764932>,
      < -4.832644, -1.873251, 2.779159>,
      < -4.897785, -1.881966, 2.768997>
    }
    triangle {
      < -4.941208, -1.929502, 2.663333>,
      < -4.907870, -1.915102, 2.764932>,
      < -4.897785, -1.881966, 2.768997>
    }
    triangle {
      < -4.941208, -1.929502, 2.663333>,
      < -4.897785, -1.881966, 2.768997>,
      < -4.930300, -1.893664, 2.663333>
    }
    triangle {
      < -4.969059, -1.843790, 2.663333>,
      < -4.941208, -1.929502, 2.663333>,
      < -4.930300, -1.893664, 2.663333>
    }
    triangle {
      < -4.969059, -1.843790, 2.663333>,
      < -4.930300, -1.893664, 2.663333>,
      < -4.939169, -1.866371, 2.663333>
    }
    triangle {
      < -5.053583, -1.876708, 2.744609>,
      < -5.028939, -1.952551, 2.744609>,
      < -5.021717, -1.949631, 2.663332>
    }
    triangle {
      < -5.053583, -1.876708, 2.744609>,
      < -5.021717, -1.949631, 2.663332>,
      < -5.046024, -1.874822, 2.663332>
    }
    triangle {
      < -5.115209, -1.892071, 2.736479>,
      < -5.087828, -1.976341, 2.736479>,
      < -5.028939, -1.952551, 2.744609>
    }
    triangle {
      < -5.115209, -1.892071, 2.736479>,
      < -5.028939, -1.952551, 2.744609>,
      < -5.053583, -1.876708, 2.744609>
    }
    triangle {
      < -5.115292, -1.892089, 2.633340>,
      < -5.087907, -1.976370, 2.633340>,
      < -5.087828, -1.976341, 2.736479>
    }
    triangle {
      < -5.115292, -1.892089, 2.633340>,
      < -5.087828, -1.976341, 2.736479>,
      < -5.115209, -1.892071, 2.736479>
    }
    triangle {
      < -4.606904, -1.782057, 2.842164>,
      < -4.593773, -1.793188, 2.828054>,
      < -4.600473, -1.779458, 2.828054>
    }
    triangle {
      < -4.704071, -1.821310, 2.813766>,
      < -4.696710, -1.836390, 2.813766>,
      < -4.606904, -1.782057, 2.842164>
    }
    triangle {
      < -4.704071, -1.821310, 2.813766>,
      < -4.801238, -1.860563, 2.769109>,
      < -4.784394, -1.894722, 2.769109>
    }
    triangle {
      < -4.704071, -1.821310, 2.813766>,
      < -4.784394, -1.894722, 2.769109>,
      < -4.696710, -1.836390, 2.813766>
    }
    triangle {
      < -4.801238, -1.860563, 2.769109>,
      < -4.813015, -1.865320, 2.756803>,
      < -4.792297, -1.907794, 2.756803>
    }
    triangle {
      < -4.801238, -1.860563, 2.769109>,
      < -4.792297, -1.907794, 2.756803>,
      < -4.784394, -1.894722, 2.769109>
    }
    triangle {
      < -4.832644, -1.873251, 2.779159>,
      < -4.810631, -1.918379, 2.779159>,
      < -4.792297, -1.907794, 2.756803>
    }
    triangle {
      < -4.832644, -1.873251, 2.779159>,
      < -4.792297, -1.907794, 2.756803>,
      < -4.813015, -1.865320, 2.756803>
    }
    triangle {
      < -4.907870, -1.915102, 2.764932>,
      < -4.883971, -1.960718, 2.764932>,
      < -4.810631, -1.918379, 2.779159>
    }
    triangle {
      < -4.907870, -1.915102, 2.764932>,
      < -4.810631, -1.918379, 2.779159>,
      < -4.832644, -1.873251, 2.779159>
    }
    triangle {
      < -4.941208, -1.929502, 2.663333>,
      < -4.915361, -1.978837, 2.663333>,
      < -4.883971, -1.960718, 2.764932>
    }
    triangle {
      < -4.941208, -1.929502, 2.663333>,
      < -4.883971, -1.960718, 2.764932>,
      < -4.907870, -1.915102, 2.764932>
    }
    triangle {
      < -5.021717, -1.949631, 2.663332>,
      < -4.987234, -2.020329, 2.663332>,
      < -4.915361, -1.978837, 2.663333>
    }
    triangle {
      < -5.021717, -1.949631, 2.663332>,
      < -4.915361, -1.978837, 2.663333>,
      < -4.941208, -1.929502, 2.663333>
    }
    triangle {
      < -5.028939, -1.952551, 2.744609>,
      < -4.993980, -2.024226, 2.744609>,
      < -4.987234, -2.020329, 2.663332>
    }
    triangle {
      < -5.028939, -1.952551, 2.744609>,
      < -4.987234, -2.020329, 2.663332>,
      < -5.021717, -1.949631, 2.663332>
    }
    triangle {
      < -5.087828, -1.976341, 2.736479>,
      < -5.048985, -2.055980, 2.736479>,
      < -4.993980, -2.024226, 2.744609>
    }
    triangle {
      < -5.087828, -1.976341, 2.736479>,
      < -4.993980, -2.024226, 2.744609>,
      < -5.028939, -1.952551, 2.744609>
    }
    triangle {
      < -5.087907, -1.976370, 2.633340>,
      < -5.049059, -2.056020, 2.633340>,
      < -5.048985, -2.055980, 2.736479>
    }
    triangle {
      < -5.087907, -1.976370, 2.633340>,
      < -5.048985, -2.055980, 2.736479>,
      < -5.087828, -1.976341, 2.736479>
    }
    triangle {
      < -4.590693, -1.810121, 2.842164>,
      < -4.585228, -1.805851, 2.828054>,
      < -4.593773, -1.793188, 2.828054>
    }
    triangle {
      < -4.682658, -1.860723, 2.813766>,
      < -4.673277, -1.874636, 2.813766>,
      < -4.590693, -1.810121, 2.842164>
    }
    triangle {
      < -4.777024, -1.907486, 2.769109>,
      < -4.755860, -1.939151, 2.769109>,
      < -4.673277, -1.874636, 2.813766>
    }
    triangle {
      < -4.777024, -1.907486, 2.769109>,
      < -4.673277, -1.874636, 2.813766>,
      < -4.682658, -1.860723, 2.813766>
    }
    triangle {
      < -4.792297, -1.907794, 2.756803>,
      < -4.765870, -1.946970, 2.756803>,
      < -4.755860, -1.939151, 2.769109>
    }
    triangle {
      < -4.792297, -1.907794, 2.756803>,
      < -4.755860, -1.939151, 2.769109>,
      < -4.777024, -1.907486, 2.769109>
    }
    triangle {
      < -4.810631, -1.918379, 2.779159>,
      < -4.782553, -1.960004, 2.779159>,
      < -4.765870, -1.946970, 2.756803>
    }
    triangle {
      < -4.810631, -1.918379, 2.779159>,
      < -4.765870, -1.946970, 2.756803>,
      < -4.792297, -1.907794, 2.756803>
    }
    triangle {
      < -4.883971, -1.960718, 2.764932>,
      < -4.856414, -2.004221, 2.764932>,
      < -4.782553, -1.960004, 2.779159>
    }
    triangle {
      < -4.883971, -1.960718, 2.764932>,
      < -4.782553, -1.960004, 2.779159>,
      < -4.810631, -1.918379, 2.779159>
    }
    triangle {
      < -4.915361, -1.978837, 2.663333>,
      < -4.885559, -2.025887, 2.663333>,
      < -4.856414, -2.004221, 2.764932>
    }
    triangle {
      < -4.915361, -1.978837, 2.663333>,
      < -4.856414, -2.004221, 2.764932>,
      < -4.883971, -1.960718, 2.764932>
    }
    triangle {
      < -4.987234, -2.020329, 2.663332>,
      < -4.943248, -2.085540, 2.663332>,
      < -4.885559, -2.025887, 2.663333>
    }
    triangle {
      < -4.987234, -2.020329, 2.663332>,
      < -4.885559, -2.025887, 2.663333>,
      < -4.915361, -1.978837, 2.663333>
    }
    triangle {
      < -4.993980, -2.024226, 2.744609>,
      < -4.949387, -2.090338, 2.744609>,
      < -4.943248, -2.085540, 2.663332>
    }
    triangle {
      < -4.993980, -2.024226, 2.744609>,
      < -4.943248, -2.085540, 2.663332>,
      < -4.987234, -2.020329, 2.663332>
    }
    triangle {
      < -5.048985, -2.055980, 2.736479>,
      < -4.999436, -2.129438, 2.736479>,
      < -4.949387, -2.090338, 2.744609>
    }
    triangle {
      < -5.048985, -2.055980, 2.736479>,
      < -4.949387, -2.090338, 2.744609>,
      < -4.993980, -2.024226, 2.744609>
    }
    triangle {
      < -5.049059, -2.056020, 2.633340>,
      < -4.999505, -2.129488, 2.633340>,
      < -4.999436, -2.129438, 2.736479>
    }
    triangle {
      < -5.049059, -2.056020, 2.633340>,
      < -4.999436, -2.129438, 2.736479>,
      < -5.048985, -2.055980, 2.736479>
    }
    triangle {
      < -4.590693, -1.810121, 2.842164>,
      < -4.579822, -1.822191, 2.842164>,
      < -4.575004, -1.817202, 2.828054>
    }
    triangle {
      < -4.590693, -1.810121, 2.842164>,
      < -4.575004, -1.817202, 2.828054>,
      < -4.585228, -1.805851, 2.828054>
    }
    triangle {
      < -4.673277, -1.874636, 2.813766>,
      < -4.652623, -1.897572, 2.813766>,
      < -4.579822, -1.822191, 2.842164>
    }
    triangle {
      < -4.673277, -1.874636, 2.813766>,
      < -4.579822, -1.822191, 2.842164>,
      < -4.590693, -1.810121, 2.842164>
    }
    triangle {
      < -4.755860, -1.939151, 2.769109>,
      < -4.725424, -1.972952, 2.769109>,
      < -4.652623, -1.897572, 2.813766>
    }
    triangle {
      < -4.755860, -1.939151, 2.769109>,
      < -4.652623, -1.897572, 2.813766>,
      < -4.673277, -1.874636, 2.813766>
    }
    triangle {
      < -4.765870, -1.946970, 2.756803>,
      < -4.734248, -1.982088, 2.756803>,
      < -4.725424, -1.972952, 2.769109>
    }
    triangle {
      < -4.765870, -1.946970, 2.756803>,
      < -4.725424, -1.972952, 2.769109>,
      < -4.755860, -1.939151, 2.769109>
    }
    triangle {
      < -4.782553, -1.960004, 2.779159>,
      < -4.748954, -1.997317, 2.779159>,
      < -4.734248, -1.982088, 2.756803>
    }
    triangle {
      < -4.782553, -1.960004, 2.779159>,
      < -4.734248, -1.982088, 2.756803>,
      < -4.765870, -1.946970, 2.756803>
    }
    triangle {
      < -4.800654, -2.066147, 2.764932>,
      < -4.748954, -1.997317, 2.779159>,
      < -4.804919, -2.031773, 2.768997>
    }
    triangle {
      < -4.825254, -2.092861, 2.663333>,
      < -4.800654, -2.066147, 2.764932>,
      < -4.804919, -2.031773, 2.768997>
    }
    triangle {
      < -4.825254, -2.092861, 2.663333>,
      < -4.804919, -2.031773, 2.768997>,
      < -4.829865, -2.055685, 2.663333>
    }
    triangle {
      < -4.943248, -2.085540, 2.663332>,
      < -4.890615, -2.143995, 2.663332>,
      < -4.825254, -2.092861, 2.663333>
    }
    triangle {
      < -4.943248, -2.085540, 2.663332>,
      < -4.825254, -2.092861, 2.663333>,
      < -4.885559, -2.025887, 2.663333>
    }
    triangle {
      < -4.949387, -2.090338, 2.744609>,
      < -4.896026, -2.149601, 2.744609>,
      < -4.890615, -2.143995, 2.663332>
    }
    triangle {
      < -4.949387, -2.090338, 2.744609>,
      < -4.890615, -2.143995, 2.663332>,
      < -4.943248, -2.085540, 2.663332>
    }
    triangle {
      < -4.999436, -2.129438, 2.736479>,
      < -4.940147, -2.195286, 2.736479>,
      < -4.896026, -2.149601, 2.744609>
    }
    triangle {
      < -4.999436, -2.129438, 2.736479>,
      < -4.896026, -2.149601, 2.744609>,
      < -4.949387, -2.090338, 2.744609>
    }
    triangle {
      < -4.999505, -2.129488, 2.633340>,
      < -4.940208, -2.195345, 2.633340>,
      < -4.940147, -2.195286, 2.736479>
    }
    triangle {
      < -4.999505, -2.129488, 2.633340>,
      < -4.940147, -2.195286, 2.736479>,
      < -4.999436, -2.129438, 2.736479>
    }
    triangle {
      < -4.579822, -1.822191, 2.842164>,
      < -4.567376, -1.832631, 2.842164>,
      < -4.563299, -1.827019, 2.828054>
    }
    triangle {
      < -4.579822, -1.822191, 2.842164>,
      < -4.563299, -1.827019, 2.828054>,
      < -4.575004, -1.817202, 2.828054>
    }
    triangle {
      < -4.652623, -1.897572, 2.813766>,
      < -4.628977, -1.917409, 2.813766>,
      < -4.567376, -1.832631, 2.842164>
    }
    triangle {
      < -4.652623, -1.897572, 2.813766>,
      < -4.567376, -1.832631, 2.842164>,
      < -4.579822, -1.822191, 2.842164>
    }
    triangle {
      < -4.725424, -1.972952, 2.769109>,
      < -4.690579, -2.002188, 2.769109>,
      < -4.628977, -1.917409, 2.813766>
    }
    triangle {
      < -4.725424, -1.972952, 2.769109>,
      < -4.628977, -1.917409, 2.813766>,
      < -4.652623, -1.897572, 2.813766>
    }
    triangle {
      < -4.734248, -1.982088, 2.756803>,
      < -4.698046, -2.012463, 2.756803>,
      < -4.690579, -2.002188, 2.769109>
    }
    triangle {
      < -4.734248, -1.982088, 2.756803>,
      < -4.690579, -2.002188, 2.769109>,
      < -4.725424, -1.972952, 2.769109>
    }
    triangle {
      < -4.748954, -1.997317, 2.779159>,
      < -4.710490, -2.029590, 2.779159>,
      < -4.698046, -2.012463, 2.756803>
    }
    triangle {
      < -4.748954, -1.997317, 2.779159>,
      < -4.698046, -2.012463, 2.756803>,
      < -4.734248, -1.982088, 2.756803>
    }
    triangle {
      < -4.800654, -2.066147, 2.764932>,
      < -4.760269, -2.098098, 2.764932>,
      < -4.710490, -2.029590, 2.779159>
    }
    triangle {
      < -4.800654, -2.066147, 2.764932>,
      < -4.710490, -2.029590, 2.779159>,
      < -4.748954, -1.997317, 2.779159>
    }
    triangle {
      < -4.825254, -2.092861, 2.663333>,
      < -4.781576, -2.127418, 2.663333>,
      < -4.760269, -2.098098, 2.764932>
    }
    triangle {
      < -4.825254, -2.092861, 2.663333>,
      < -4.760269, -2.098098, 2.764932>,
      < -4.800654, -2.066147, 2.764932>
    }
    triangle {
      < -4.890615, -2.143995, 2.663332>,
      < -4.830359, -2.194556, 2.663332>,
      < -4.781576, -2.127418, 2.663333>
    }
    triangle {
      < -4.890615, -2.143995, 2.663332>,
      < -4.781576, -2.127418, 2.663333>,
      < -4.825254, -2.092861, 2.663333>
    }
    triangle {
      < -4.896026, -2.149601, 2.744609>,
      < -4.834937, -2.200860, 2.744609>,
      < -4.830359, -2.194556, 2.663332>
    }
    triangle {
      < -4.896026, -2.149601, 2.744609>,
      < -4.830359, -2.194556, 2.663332>,
      < -4.890615, -2.143995, 2.663332>
    }
    triangle {
      < -4.940147, -2.195286, 2.736479>,
      < -4.872271, -2.252241, 2.736479>,
      < -4.834937, -2.200860, 2.744609>
    }
    triangle {
      < -4.940147, -2.195286, 2.736479>,
      < -4.834937, -2.200860, 2.744609>,
      < -4.896026, -2.149601, 2.744609>
    }
    triangle {
      < -4.940208, -2.195345, 2.633340>,
      < -4.872323, -2.252308, 2.633340>,
      < -4.872271, -2.252241, 2.736479>
    }
    triangle {
      < -4.940208, -2.195345, 2.633340>,
      < -4.872271, -2.252241, 2.736479>,
      < -4.940147, -2.195286, 2.736479>
    }
    triangle {
      < -4.567376, -1.832631, 2.842164>,
      < -4.553597, -1.841236, 2.842164>,
      < -4.550342, -1.835112, 2.828054>
    }
    triangle {
      < -4.567376, -1.832631, 2.842164>,
      < -4.550342, -1.835112, 2.828054>,
      < -4.563299, -1.827019, 2.828054>
    }
    triangle {
      < -4.628977, -1.917409, 2.813766>,
      < -4.602801, -1.933763, 2.813766>,
      < -4.553597, -1.841236, 2.842164>
    }
    triangle {
      < -4.628977, -1.917409, 2.813766>,
      < -4.553597, -1.841236, 2.842164>,
      < -4.567376, -1.832631, 2.842164>
    }
    triangle {
      < -4.690579, -2.002188, 2.769109>,
      < -4.652005, -2.026290, 2.769109>,
      < -4.602801, -1.933763, 2.813766>
    }
    triangle {
      < -4.690579, -2.002188, 2.769109>,
      < -4.602801, -1.933763, 2.813766>,
      < -4.628977, -1.917409, 2.813766>
    }
    triangle {
      < -4.698046, -2.012463, 2.756803>,
      < -4.657969, -2.037504, 2.756803>,
      < -4.652005, -2.026290, 2.769109>
    }
    triangle {
      < -4.698046, -2.012463, 2.756803>,
      < -4.652005, -2.026290, 2.769109>,
      < -4.690579, -2.002188, 2.769109>
    }
    triangle {
      < -4.710490, -2.029590, 2.779159>,
      < -4.667908, -2.056197, 2.779159>,
      < -4.657969, -2.037504, 2.756803>
    }
    triangle {
      < -4.710490, -2.029590, 2.779159>,
      < -4.657969, -2.037504, 2.756803>,
      < -4.698046, -2.012463, 2.756803>
    }
    triangle {
      < -4.760269, -2.098098, 2.764932>,
      < -4.717400, -2.126633, 2.764932>,
      < -4.667908, -2.056197, 2.779159>
    }
    triangle {
      < -4.760269, -2.098098, 2.764932>,
      < -4.667908, -2.056197, 2.779159>,
      < -4.710490, -2.029590, 2.779159>
    }
    triangle {
      < -4.781576, -2.127418, 2.663333>,
      < -4.735213, -2.158279, 2.663333>,
      < -4.717400, -2.126633, 2.764932>
    }
    triangle {
      < -4.781576, -2.127418, 2.663333>,
      < -4.717400, -2.126633, 2.764932>,
      < -4.760269, -2.098098, 2.764932>
    }
    triangle {
      < -4.830359, -2.194556, 2.663332>,
      < -4.763652, -2.236239, 2.663332>,
      < -4.735213, -2.158279, 2.663333>
    }
    triangle {
      < -4.830359, -2.194556, 2.663332>,
      < -4.735213, -2.158279, 2.663333>,
      < -4.781576, -2.127418, 2.663333>
    }
    triangle {
      < -4.834937, -2.200860, 2.744609>,
      < -4.767308, -2.243119, 2.744609>,
      < -4.763652, -2.236239, 2.663332>
    }
    triangle {
      < -4.834937, -2.200860, 2.744609>,
      < -4.763652, -2.236239, 2.663332>,
      < -4.830359, -2.194556, 2.663332>
    }
    triangle {
      < -4.872271, -2.252241, 2.736479>,
      < -4.797128, -2.299196, 2.736479>,
      < -4.767308, -2.243119, 2.744609>
    }
    triangle {
      < -4.872271, -2.252241, 2.736479>,
      < -4.767308, -2.243119, 2.744609>,
      < -4.834937, -2.200860, 2.744609>
    }
    triangle {
      < -4.872323, -2.252308, 2.633340>,
      < -4.797171, -2.299269, 2.633340>,
      < -4.797128, -2.299196, 2.736479>
    }
    triangle {
      < -4.872323, -2.252308, 2.633340>,
      < -4.797128, -2.299196, 2.736479>,
      < -4.872271, -2.252241, 2.736479>
    }
    triangle {
      < -4.553597, -1.841236, 2.842164>,
      < -4.538756, -1.847841, 2.842164>,
      < -4.536384, -1.841323, 2.828054>
    }
    triangle {
      < -4.553597, -1.841236, 2.842164>,
      < -4.536384, -1.841323, 2.828054>,
      < -4.550342, -1.835112, 2.828054>
    }
    triangle {
      < -4.602801, -1.933763, 2.813766>,
      < -4.574604, -1.946315, 2.813766>,
      < -4.538756, -1.847841, 2.842164>
    }
    triangle {
      < -4.602801, -1.933763, 2.813766>,
      < -4.538756, -1.847841, 2.842164>,
      < -4.553597, -1.841236, 2.842164>
    }
    triangle {
      < -4.652005, -2.026290, 2.769109>,
      < -4.610452, -2.044789, 2.769109>,
      < -4.574604, -1.946315, 2.813766>
    }
    triangle {
      < -4.652005, -2.026290, 2.769109>,
      < -4.574604, -1.946315, 2.813766>,
      < -4.602801, -1.933763, 2.813766>
    }
    triangle {
      < -4.657969, -2.037504, 2.756803>,
      < -4.614797, -2.056724, 2.756803>,
      < -4.610452, -2.044789, 2.769109>
    }
    triangle {
      < -4.657969, -2.037504, 2.756803>,
      < -4.610452, -2.044789, 2.769109>,
      < -4.652005, -2.026290, 2.769109>
    }
    triangle {
      < -4.667908, -2.056197, 2.779159>,
      < -4.622038, -2.076618, 2.779159>,
      < -4.614797, -2.056724, 2.756803>
    }
    triangle {
      < -4.667908, -2.056197, 2.779159>,
      < -4.614797, -2.056724, 2.756803>,
      < -4.657969, -2.037504, 2.756803>
    }
    triangle {
      < -4.641274, -2.160526, 2.764932>,
      < -4.622038, -2.076618, 2.779159>,
      < -4.659151, -2.130858, 2.768997>
    }
    triangle {
      < -4.652881, -2.194936, 2.663333>,
      < -4.641274, -2.160526, 2.764932>,
      < -4.659151, -2.130858, 2.768997>
    }
    triangle {
      < -4.652881, -2.194936, 2.663333>,
      < -4.659151, -2.130858, 2.768997>,
      < -4.672215, -2.162849, 2.663333>
    }
    triangle {
      < -4.763652, -2.236239, 2.663332>,
      < -4.691794, -2.268233, 2.663332>,
      < -4.652881, -2.194936, 2.663333>
    }
    triangle {
      < -4.763652, -2.236239, 2.663332>,
      < -4.652881, -2.194936, 2.663333>,
      < -4.735213, -2.158279, 2.663333>
    }
    triangle {
      < -4.767308, -2.243119, 2.744609>,
      < -4.694457, -2.275555, 2.744609>,
      < -4.691794, -2.268233, 2.663332>
    }
    triangle {
      < -4.767308, -2.243119, 2.744609>,
      < -4.691794, -2.268233, 2.663332>,
      < -4.763652, -2.236239, 2.663332>
    }
    triangle {
      < -4.797128, -2.299196, 2.736479>,
      < -4.716183, -2.335236, 2.736479>,
      < -4.694457, -2.275555, 2.744609>
    }
    triangle {
      < -4.797128, -2.299196, 2.736479>,
      < -4.694457, -2.275555, 2.744609>,
      < -4.767308, -2.243119, 2.744609>
    }
    triangle {
      < -4.797171, -2.299269, 2.633340>,
      < -4.716214, -2.335315, 2.633340>,
      < -4.716183, -2.335236, 2.736479>
    }
    triangle {
      < -4.797171, -2.299269, 2.633340>,
      < -4.716183, -2.335236, 2.736479>,
      < -4.797128, -2.299196, 2.736479>
    }
    triangle {
      < -4.538756, -1.847841, 2.842164>,
      < -4.523140, -1.852316, 2.842164>,
      < -4.521698, -1.845531, 2.828054>
    }
    triangle {
      < -4.538756, -1.847841, 2.842164>,
      < -4.521698, -1.845531, 2.828054>,
      < -4.536384, -1.841323, 2.828054>
    }
    triangle {
      < -4.574604, -1.946315, 2.813766>,
      < -4.544934, -1.954820, 2.813766>,
      < -4.523140, -1.852316, 2.842164>
    }
    triangle {
      < -4.574604, -1.946315, 2.813766>,
      < -4.523140, -1.852316, 2.842164>,
      < -4.538756, -1.847841, 2.842164>
    }
    triangle {
      < -4.610452, -2.044789, 2.769109>,
      < -4.566729, -2.057325, 2.769109>,
      < -4.544934, -1.954820, 2.813766>
    }
    triangle {
      < -4.610452, -2.044789, 2.769109>,
      < -4.544934, -1.954820, 2.813766>,
      < -4.574604, -1.946315, 2.813766>
    }
    triangle {
      < -4.614797, -2.056724, 2.756803>,
      < -4.569371, -2.069749, 2.756803>,
      < -4.566729, -2.057325, 2.769109>
    }
    triangle {
      < -4.614797, -2.056724, 2.756803>,
      < -4.566729, -2.057325, 2.769109>,
      < -4.610452, -2.044789, 2.769109>
    }
    triangle {
      < -4.622038, -2.076618, 2.779159>,
      < -4.573772, -2.090457, 2.779159>,
      < -4.569371, -2.069749, 2.756803>
    }
    triangle {
      < -4.622038, -2.076618, 2.779159>,
      < -4.569371, -2.069749, 2.756803>,
      < -4.614797, -2.056724, 2.756803>
    }
    triangle {
      < -4.641274, -2.160526, 2.764932>,
      < -4.591384, -2.173289, 2.764932>,
      < -4.573772, -2.090457, 2.779159>
    }
    triangle {
      < -4.641274, -2.160526, 2.764932>,
      < -4.573772, -2.090457, 2.779159>,
      < -4.622038, -2.076618, 2.779159>
    }
    triangle {
      < -4.652881, -2.194936, 2.663333>,
      < -4.598924, -2.208740, 2.663333>,
      < -4.591384, -2.173289, 2.764932>
    }
    triangle {
      < -4.652881, -2.194936, 2.663333>,
      < -4.591384, -2.173289, 2.764932>,
      < -4.641274, -2.160526, 2.764932>
    }
    triangle {
      < -4.691794, -2.268233, 2.663332>,
      < -4.616182, -2.289915, 2.663332>,
      < -4.598924, -2.208740, 2.663333>
    }
    triangle {
      < -4.691794, -2.268233, 2.663332>,
      < -4.598924, -2.208740, 2.663333>,
      < -4.652881, -2.194936, 2.663333>
    }
    triangle {
      < -4.694457, -2.275555, 2.744609>,
      < -4.617800, -2.297536, 2.744609>,
      < -4.616182, -2.289915, 2.663332>
    }
    triangle {
      < -4.694457, -2.275555, 2.744609>,
      < -4.616182, -2.289915, 2.663332>,
      < -4.691794, -2.268233, 2.663332>
    }
    triangle {
      < -4.716183, -2.335236, 2.736479>,
      < -4.631009, -2.359660, 2.736479>,
      < -4.617800, -2.297536, 2.744609>
    }
    triangle {
      < -4.716183, -2.335236, 2.736479>,
      < -4.617800, -2.297536, 2.744609>,
      < -4.694457, -2.275555, 2.744609>
    }
    triangle {
      < -4.716214, -2.335315, 2.633340>,
      < -4.631029, -2.359742, 2.633340>,
      < -4.631009, -2.359660, 2.736479>
    }
    triangle {
      < -4.716214, -2.335315, 2.633340>,
      < -4.631009, -2.359660, 2.736479>,
      < -4.716183, -2.335236, 2.736479>
    }
    triangle {
      < -4.523140, -1.852316, 2.842164>,
      < -4.507053, -1.854573, 2.842164>,
      < -4.506569, -1.847654, 2.828054>
    }
    triangle {
      < -4.523140, -1.852316, 2.842164>,
      < -4.506569, -1.847654, 2.828054>,
      < -4.521698, -1.845531, 2.828054>
    }
    triangle {
      < -4.544934, -1.954820, 2.813766>,
      < -4.514369, -1.959114, 2.813766>,
      < -4.507053, -1.854573, 2.842164>
    }
    triangle {
      < -4.544934, -1.954820, 2.813766>,
      < -4.507053, -1.854573, 2.842164>,
      < -4.523140, -1.852316, 2.842164>
    }
    triangle {
      < -4.566729, -2.057325, 2.769109>,
      < -4.521687, -2.063654, 2.769109>,
      < -4.514369, -1.959114, 2.813766>
    }
    triangle {
      < -4.566729, -2.057325, 2.769109>,
      < -4.514369, -1.959114, 2.813766>,
      < -4.544934, -1.954820, 2.813766>
    }
    triangle {
      < -4.569371, -2.069749, 2.756803>,
      < -4.522573, -2.076324, 2.756803>,
      < -4.521687, -2.063654, 2.769109>
    }
    triangle {
      < -4.569371, -2.069749, 2.756803>,
      < -4.521687, -2.063654, 2.769109>,
      < -4.566729, -2.057325, 2.769109>
    }
    triangle {
      < -4.573772, -2.090457, 2.779159>,
      < -4.524051, -2.097444, 2.779159>,
      < -4.522573, -2.076324, 2.756803>
    }
    triangle {
      < -4.573772, -2.090457, 2.779159>,
      < -4.522573, -2.076324, 2.756803>,
      < -4.569371, -2.069749, 2.756803>
    }
    triangle {
      < -4.591384, -2.173289, 2.764932>,
      < -4.540616, -2.181921, 2.764932>,
      < -4.524051, -2.097444, 2.779159>
    }
    triangle {
      < -4.591384, -2.173289, 2.764932>,
      < -4.524051, -2.097444, 2.779159>,
      < -4.573772, -2.090457, 2.779159>
    }
    triangle {
      < -4.598924, -2.208740, 2.663333>,
      < -4.544017, -2.218076, 2.663333>,
      < -4.540616, -2.181921, 2.764932>
    }
    triangle {
      < -4.598924, -2.208740, 2.663333>,
      < -4.540616, -2.181921, 2.764932>,
      < -4.591384, -2.173289, 2.764932>
    }
    triangle {
      < -4.616182, -2.289915, 2.663332>,
      < -4.538289, -2.300864, 2.663332>,
      < -4.544017, -2.218076, 2.663333>
    }
    triangle {
      < -4.616182, -2.289915, 2.663332>,
      < -4.544017, -2.218076, 2.663333>,
      < -4.598924, -2.208740, 2.663333>
    }
    triangle {
      < -4.617800, -2.297536, 2.744609>,
      < -4.538831, -2.308635, 2.744609>,
      < -4.538289, -2.300864, 2.663332>
    }
    triangle {
      < -4.617800, -2.297536, 2.744609>,
      < -4.538289, -2.300864, 2.663332>,
      < -4.616182, -2.289915, 2.663332>
    }
    triangle {
      < -4.631009, -2.359660, 2.736479>,
      < -4.543264, -2.371993, 2.736479>,
      < -4.538831, -2.308635, 2.744609>
    }
    triangle {
      < -4.631009, -2.359660, 2.736479>,
      < -4.538831, -2.308635, 2.744609>,
      < -4.617800, -2.297536, 2.744609>
    }
    triangle {
      < -4.631029, -2.359742, 2.633340>,
      < -4.543273, -2.372077, 2.633340>,
      < -4.543264, -2.371993, 2.736479>
    }
    triangle {
      < -4.631029, -2.359742, 2.633340>,
      < -4.543264, -2.371993, 2.736479>,
      < -4.631009, -2.359660, 2.736479>
    }
    triangle {
      < -4.507053, -1.854573, 2.842164>,
      < -4.490809, -1.854571, 2.842164>,
      < -4.491292, -1.847651, 2.828054>
    }
    triangle {
      < -4.507053, -1.854573, 2.842164>,
      < -4.491292, -1.847651, 2.828054>,
      < -4.506569, -1.847654, 2.828054>
    }
    triangle {
      < -4.514369, -1.959114, 2.813766>,
      < -4.483505, -1.959112, 2.813766>,
      < -4.490809, -1.854571, 2.842164>
    }
    triangle {
      < -4.514369, -1.959114, 2.813766>,
      < -4.490809, -1.854571, 2.842164>,
      < -4.507053, -1.854573, 2.842164>
    }
    triangle {
      < -4.521687, -2.063654, 2.769109>,
      < -4.476202, -2.063653, 2.769109>,
      < -4.483505, -1.959112, 2.813766>
    }
    triangle {
      < -4.521687, -2.063654, 2.769109>,
      < -4.483505, -1.959112, 2.813766>,
      < -4.514369, -1.959114, 2.813766>
    }
    triangle {
      < -4.522573, -2.076324, 2.756803>,
      < -4.475317, -2.076324, 2.756803>,
      < -4.476202, -2.063653, 2.769109>
    }
    triangle {
      < -4.522573, -2.076324, 2.756803>,
      < -4.476202, -2.063653, 2.769109>,
      < -4.521687, -2.063654, 2.769109>
    }
    triangle {
      < -4.524051, -2.097444, 2.779159>,
      < -4.473840, -2.097443, 2.779159>,
      < -4.475317, -2.076324, 2.756803>
    }
    triangle {
      < -4.524051, -2.097444, 2.779159>,
      < -4.475317, -2.076324, 2.756803>,
      < -4.522573, -2.076324, 2.756803>
    }
    triangle {
      < -4.457285, -2.181920, 2.764932>,
      < -4.473840, -2.097443, 2.779159>,
      < -4.485683, -2.162088, 2.768997>
    }
    triangle {
      < -4.453893, -2.218077, 2.663333>,
      < -4.457285, -2.181920, 2.764932>,
      < -4.485683, -2.162088, 2.768997>
    }
    triangle {
      < -4.453893, -2.218077, 2.663333>,
      < -4.485683, -2.162088, 2.768997>,
      < -4.484606, -2.196627, 2.663333>
    }
    triangle {
      < -4.538289, -2.300864, 2.663332>,
      < -4.459630, -2.300864, 2.663332>,
      < -4.453893, -2.218077, 2.663333>
    }
    triangle {
      < -4.538289, -2.300864, 2.663332>,
      < -4.453893, -2.218077, 2.663333>,
      < -4.544017, -2.218076, 2.663333>
    }
    triangle {
      < -4.538831, -2.308635, 2.744609>,
      < -4.459085, -2.308636, 2.744609>,
      < -4.459630, -2.300864, 2.663332>
    }
    triangle {
      < -4.538831, -2.308635, 2.744609>,
      < -4.459630, -2.300864, 2.663332>,
      < -4.538289, -2.300864, 2.663332>
    }
    triangle {
      < -4.543264, -2.371993, 2.736479>,
      < -4.454658, -2.371994, 2.736479>,
      < -4.459085, -2.308636, 2.744609>
    }
    triangle {
      < -4.543264, -2.371993, 2.736479>,
      < -4.459085, -2.308636, 2.744609>,
      < -4.538831, -2.308635, 2.744609>
    }
    triangle {
      < -4.543273, -2.372077, 2.633340>,
      < -4.454655, -2.372079, 2.633340>,
      < -4.454658, -2.371994, 2.736479>
    }
    triangle {
      < -4.543273, -2.372077, 2.633340>,
      < -4.454658, -2.371994, 2.736479>,
      < -4.543264, -2.371993, 2.736479>
    }
    triangle {
      < -4.490809, -1.854571, 2.842164>,
      < -4.474723, -1.852307, 2.842164>,
      < -4.476165, -1.845522, 2.828054>
    }
    triangle {
      < -4.490809, -1.854571, 2.842164>,
      < -4.476165, -1.845522, 2.828054>,
      < -4.491292, -1.847651, 2.828054>
    }
    triangle {
      < -4.483505, -1.959112, 2.813766>,
      < -4.452941, -1.954814, 2.813766>,
      < -4.474723, -1.852307, 2.842164>
    }
    triangle {
      < -4.483505, -1.959112, 2.813766>,
      < -4.474723, -1.852307, 2.842164>,
      < -4.490809, -1.854571, 2.842164>
    }
    triangle {
      < -4.476202, -2.063653, 2.769109>,
      < -4.431159, -2.057322, 2.769109>,
      < -4.452941, -1.954814, 2.813766>
    }
    triangle {
      < -4.476202, -2.063653, 2.769109>,
      < -4.452941, -1.954814, 2.813766>,
      < -4.483505, -1.959112, 2.813766>
    }
    triangle {
      < -4.475317, -2.076324, 2.756803>,
      < -4.428520, -2.069746, 2.756803>,
      < -4.431159, -2.057322, 2.769109>
    }
    triangle {
      < -4.475317, -2.076324, 2.756803>,
      < -4.431159, -2.057322, 2.769109>,
      < -4.476202, -2.063653, 2.769109>
    }
    triangle {
      < -4.473840, -2.097443, 2.779159>,
      < -4.424119, -2.090454, 2.779159>,
      < -4.428520, -2.069746, 2.756803>
    }
    triangle {
      < -4.473840, -2.097443, 2.779159>,
      < -4.428520, -2.069746, 2.756803>,
      < -4.475317, -2.076324, 2.756803>
    }
    triangle {
      < -4.457285, -2.181920, 2.764932>,
      < -4.406517, -2.173288, 2.764932>,
      < -4.424119, -2.090454, 2.779159>
    }
    triangle {
      < -4.457285, -2.181920, 2.764932>,
      < -4.424119, -2.090454, 2.779159>,
      < -4.473840, -2.097443, 2.779159>
    }
    triangle {
      < -4.453893, -2.218077, 2.663333>,
      < -4.398986, -2.208741, 2.663333>,
      < -4.406517, -2.173288, 2.764932>
    }
    triangle {
      < -4.453893, -2.218077, 2.663333>,
      < -4.406517, -2.173288, 2.764932>,
      < -4.457285, -2.181920, 2.764932>
    }
    triangle {
      < -4.459630, -2.300864, 2.663332>,
      < -4.381736, -2.289918, 2.663332>,
      < -4.398986, -2.208741, 2.663333>
    }
    triangle {
      < -4.459630, -2.300864, 2.663332>,
      < -4.398986, -2.208741, 2.663333>,
      < -4.453893, -2.218077, 2.663333>
    }
    triangle {
      < -4.459085, -2.308636, 2.744609>,
      < -4.380115, -2.297539, 2.744609>,
      < -4.381736, -2.289918, 2.663332>
    }
    triangle {
      < -4.459085, -2.308636, 2.744609>,
      < -4.381736, -2.289918, 2.663332>,
      < -4.459630, -2.300864, 2.663332>
    }
    triangle {
      < -4.454658, -2.371994, 2.736479>,
      < -4.366913, -2.359664, 2.736479>,
      < -4.380115, -2.297539, 2.744609>
    }
    triangle {
      < -4.454658, -2.371994, 2.736479>,
      < -4.380115, -2.297539, 2.744609>,
      < -4.459085, -2.308636, 2.744609>
    }
    triangle {
      < -4.454655, -2.372079, 2.633340>,
      < -4.366899, -2.359747, 2.633340>,
      < -4.366913, -2.359664, 2.736479>
    }
    triangle {
      < -4.454655, -2.372079, 2.633340>,
      < -4.366913, -2.359664, 2.736479>,
      < -4.454658, -2.371994, 2.736479>
    }
    triangle {
      < -4.474723, -1.852307, 2.842164>,
      < -4.459108, -1.847826, 2.842164>,
      < -4.461481, -1.841309, 2.828054>
    }
    triangle {
      < -4.474723, -1.852307, 2.842164>,
      < -4.461481, -1.841309, 2.828054>,
      < -4.476165, -1.845522, 2.828054>
    }
    triangle {
      < -4.452941, -1.954814, 2.813766>,
      < -4.423273, -1.946305, 2.813766>,
      < -4.459108, -1.847826, 2.842164>
    }
    triangle {
      < -4.452941, -1.954814, 2.813766>,
      < -4.459108, -1.847826, 2.842164>,
      < -4.474723, -1.852307, 2.842164>
    }
    triangle {
      < -4.431159, -2.057322, 2.769109>,
      < -4.387437, -2.044784, 2.769109>,
      < -4.423273, -1.946305, 2.813766>
    }
    triangle {
      < -4.431159, -2.057322, 2.769109>,
      < -4.423273, -1.946305, 2.813766>,
      < -4.452941, -1.954814, 2.813766>
    }
    triangle {
      < -4.428520, -2.069746, 2.756803>,
      < -4.383094, -2.056719, 2.756803>,
      < -4.387437, -2.044784, 2.769109>
    }
    triangle {
      < -4.428520, -2.069746, 2.756803>,
      < -4.387437, -2.044784, 2.769109>,
      < -4.431159, -2.057322, 2.769109>
    }
    triangle {
      < -4.424119, -2.090454, 2.779159>,
      < -4.375854, -2.076614, 2.779159>,
      < -4.383094, -2.056719, 2.756803>
    }
    triangle {
      < -4.424119, -2.090454, 2.779159>,
      < -4.383094, -2.056719, 2.756803>,
      < -4.428520, -2.069746, 2.756803>
    }
    triangle {
      < -4.406517, -2.173288, 2.764932>,
      < -4.356627, -2.160525, 2.764932>,
      < -4.375854, -2.076614, 2.779159>
    }
    triangle {
      < -4.406517, -2.173288, 2.764932>,
      < -4.375854, -2.076614, 2.779159>,
      < -4.424119, -2.090454, 2.779159>
    }
    triangle {
      < -4.398986, -2.208741, 2.663333>,
      < -4.345028, -2.194938, 2.663333>,
      < -4.356627, -2.160525, 2.764932>
    }
    triangle {
      < -4.398986, -2.208741, 2.663333>,
      < -4.356627, -2.160525, 2.764932>,
      < -4.406517, -2.173288, 2.764932>
    }
    triangle {
      < -4.381736, -2.289918, 2.663332>,
      < -4.306124, -2.268238, 2.663332>,
      < -4.345028, -2.194938, 2.663333>
    }
    triangle {
      < -4.381736, -2.289918, 2.663332>,
      < -4.345028, -2.194938, 2.663333>,
      < -4.398986, -2.208741, 2.663333>
    }
    triangle {
      < -4.380115, -2.297539, 2.744609>,
      < -4.303458, -2.275559, 2.744609>,
      < -4.306124, -2.268238, 2.663332>
    }
    triangle {
      < -4.380115, -2.297539, 2.744609>,
      < -4.306124, -2.268238, 2.663332>,
      < -4.381736, -2.289918, 2.663332>
    }
    triangle {
      < -4.366913, -2.359664, 2.736479>,
      < -4.281739, -2.335242, 2.736479>,
      < -4.303458, -2.275559, 2.744609>
    }
    triangle {
      < -4.366913, -2.359664, 2.736479>,
      < -4.303458, -2.275559, 2.744609>,
      < -4.380115, -2.297539, 2.744609>
    }
    triangle {
      < -4.366899, -2.359747, 2.633340>,
      < -4.281712, -2.335323, 2.633340>,
      < -4.281739, -2.335242, 2.736479>
    }
    triangle {
      < -4.366899, -2.359747, 2.633340>,
      < -4.281739, -2.335242, 2.736479>,
      < -4.366913, -2.359664, 2.736479>
    }
    triangle {
      < -4.459108, -1.847826, 2.842164>,
      < -4.444269, -1.841217, 2.842164>,
      < -4.447526, -1.835093, 2.828054>
    }
    triangle {
      < -4.459108, -1.847826, 2.842164>,
      < -4.447526, -1.835093, 2.828054>,
      < -4.461481, -1.841309, 2.828054>
    }
    triangle {
      < -4.423273, -1.946305, 2.813766>,
      < -4.395077, -1.933749, 2.813766>,
      < -4.444269, -1.841217, 2.842164>
    }
    triangle {
      < -4.423273, -1.946305, 2.813766>,
      < -4.444269, -1.841217, 2.842164>,
      < -4.459108, -1.847826, 2.842164>
    }
    triangle {
      < -4.387437, -2.044784, 2.769109>,
      < -4.345885, -2.026282, 2.769109>,
      < -4.395077, -1.933749, 2.813766>
    }
    triangle {
      < -4.387437, -2.044784, 2.769109>,
      < -4.395077, -1.933749, 2.813766>,
      < -4.423273, -1.946305, 2.813766>
    }
    triangle {
      < -4.383094, -2.056719, 2.756803>,
      < -4.339923, -2.037498, 2.756803>,
      < -4.345885, -2.026282, 2.769109>
    }
    triangle {
      < -4.383094, -2.056719, 2.756803>,
      < -4.345885, -2.026282, 2.769109>,
      < -4.387437, -2.044784, 2.769109>
    }
    triangle {
      < -4.375854, -2.076614, 2.779159>,
      < -4.329984, -2.056191, 2.779159>,
      < -4.339923, -2.037498, 2.756803>
    }
    triangle {
      < -4.375854, -2.076614, 2.779159>,
      < -4.339923, -2.037498, 2.756803>,
      < -4.383094, -2.056719, 2.756803>
    }
    triangle {
      < -4.280501, -2.126631, 2.764932>,
      < -4.329984, -2.056191, 2.779159>,
      < -4.314510, -2.120064, 2.768997>
    }
    triangle {
      < -4.262696, -2.158282, 2.663333>,
      < -4.280501, -2.126631, 2.764932>,
      < -4.314510, -2.120064, 2.768997>
    }
    triangle {
      < -4.262696, -2.158282, 2.663333>,
      < -4.314510, -2.120064, 2.768997>,
      < -4.299478, -2.151179, 2.663333>
    }
    triangle {
      < -4.306124, -2.268238, 2.663332>,
      < -4.234264, -2.236246, 2.663332>,
      < -4.262696, -2.158282, 2.663333>
    }
    triangle {
      < -4.306124, -2.268238, 2.663332>,
      < -4.262696, -2.158282, 2.663333>,
      < -4.345028, -2.194938, 2.663333>
    }
    triangle {
      < -4.303458, -2.275559, 2.744609>,
      < -4.230606, -2.243124, 2.744609>,
      < -4.234264, -2.236246, 2.663332>
    }
    triangle {
      < -4.303458, -2.275559, 2.744609>,
      < -4.234264, -2.236246, 2.663332>,
      < -4.306124, -2.268238, 2.663332>
    }
    triangle {
      < -4.281739, -2.335242, 2.736479>,
      < -4.200792, -2.299204, 2.736479>,
      < -4.230606, -2.243124, 2.744609>
    }
    triangle {
      < -4.281739, -2.335242, 2.736479>,
      < -4.230606, -2.243124, 2.744609>,
      < -4.303458, -2.275559, 2.744609>
    }
    triangle {
      < -4.281712, -2.335323, 2.633340>,
      < -4.200755, -2.299281, 2.633340>,
      < -4.200792, -2.299204, 2.736479>
    }
    triangle {
      < -4.281712, -2.335323, 2.633340>,
      < -4.200792, -2.299204, 2.736479>,
      < -4.281739, -2.335242, 2.736479>
    }
    triangle {
      < -4.444269, -1.841217, 2.842164>,
      < -4.430495, -1.832606, 2.842164>,
      < -4.434571, -1.826995, 2.828054>
    }
    triangle {
      < -4.444269, -1.841217, 2.842164>,
      < -4.434571, -1.826995, 2.828054>,
      < -4.447526, -1.835093, 2.828054>
    }
    triangle {
      < -4.395077, -1.933749, 2.813766>,
      < -4.368903, -1.917392, 2.813766>,
      < -4.430495, -1.832606, 2.842164>
    }
    triangle {
      < -4.395077, -1.933749, 2.813766>,
      < -4.430495, -1.832606, 2.842164>,
      < -4.444269, -1.841217, 2.842164>
    }
    triangle {
      < -4.345885, -2.026282, 2.769109>,
      < -4.307312, -2.002178, 2.769109>,
      < -4.368903, -1.917392, 2.813766>
    }
    triangle {
      < -4.345885, -2.026282, 2.769109>,
      < -4.368903, -1.917392, 2.813766>,
      < -4.395077, -1.933749, 2.813766>
    }
    triangle {
      < -4.339923, -2.037498, 2.756803>,
      < -4.299847, -2.012455, 2.756803>,
      < -4.307312, -2.002178, 2.769109>
    }
    triangle {
      < -4.339923, -2.037498, 2.756803>,
      < -4.307312, -2.002178, 2.769109>,
      < -4.345885, -2.026282, 2.769109>
    }
    triangle {
      < -4.329984, -2.056191, 2.779159>,
      < -4.287404, -2.029583, 2.779159>,
      < -4.299847, -2.012455, 2.756803>
    }
    triangle {
      < -4.329984, -2.056191, 2.779159>,
      < -4.299847, -2.012455, 2.756803>,
      < -4.339923, -2.037498, 2.756803>
    }
    triangle {
      < -4.280501, -2.126631, 2.764932>,
      < -4.237633, -2.098096, 2.764932>,
      < -4.287404, -2.029583, 2.779159>
    }
    triangle {
      < -4.280501, -2.126631, 2.764932>,
      < -4.287404, -2.029583, 2.779159>,
      < -4.329984, -2.056191, 2.779159>
    }
    triangle {
      < -4.262696, -2.158282, 2.663333>,
      < -4.216333, -2.127422, 2.663333>,
      < -4.237633, -2.098096, 2.764932>
    }
    triangle {
      < -4.262696, -2.158282, 2.663333>,
      < -4.237633, -2.098096, 2.764932>,
      < -4.280501, -2.126631, 2.764932>
    }
    triangle {
      < -4.234264, -2.236246, 2.663332>,
      < -4.167557, -2.194565, 2.663332>,
      < -4.216333, -2.127422, 2.663333>
    }
    triangle {
      < -4.234264, -2.236246, 2.663332>,
      < -4.216333, -2.127422, 2.663333>,
      < -4.262696, -2.158282, 2.663333>
    }
    triangle {
      < -4.230606, -2.243124, 2.744609>,
      < -4.162976, -2.200867, 2.744609>,
      < -4.167557, -2.194565, 2.663332>
    }
    triangle {
      < -4.230606, -2.243124, 2.744609>,
      < -4.167557, -2.194565, 2.663332>,
      < -4.234264, -2.236246, 2.663332>
    }
    triangle {
      < -4.200792, -2.299204, 2.736479>,
      < -4.125648, -2.252252, 2.736479>,
      < -4.162976, -2.200867, 2.744609>
    }
    triangle {
      < -4.200792, -2.299204, 2.736479>,
      < -4.162976, -2.200867, 2.744609>,
      < -4.230606, -2.243124, 2.744609>
    }
    triangle {
      < -4.200755, -2.299281, 2.633340>,
      < -4.125600, -2.252322, 2.633340>,
      < -4.125648, -2.252252, 2.736479>
    }
    triangle {
      < -4.200755, -2.299281, 2.633340>,
      < -4.125648, -2.252252, 2.736479>,
      < -4.200792, -2.299204, 2.736479>
    }
    triangle {
      < -4.430495, -1.832606, 2.842164>,
      < -4.418052, -1.822162, 2.842164>,
      < -4.422870, -1.817173, 2.828054>
    }
    triangle {
      < -4.430495, -1.832606, 2.842164>,
      < -4.422870, -1.817173, 2.828054>,
      < -4.434571, -1.826995, 2.828054>
    }
    triangle {
      < -4.368903, -1.917392, 2.813766>,
      < -4.345260, -1.897551, 2.813766>,
      < -4.418052, -1.822162, 2.842164>
    }
    triangle {
      < -4.368903, -1.917392, 2.813766>,
      < -4.418052, -1.822162, 2.842164>,
      < -4.430495, -1.832606, 2.842164>
    }
    triangle {
      < -4.307312, -2.002178, 2.769109>,
      < -4.272469, -1.972941, 2.769109>,
      < -4.345260, -1.897551, 2.813766>
    }
    triangle {
      < -4.307312, -2.002178, 2.769109>,
      < -4.345260, -1.897551, 2.813766>,
      < -4.368903, -1.917392, 2.813766>
    }
    triangle {
      < -4.299847, -2.012455, 2.756803>,
      < -4.263646, -1.982078, 2.756803>,
      < -4.272469, -1.972941, 2.769109>
    }
    triangle {
      < -4.299847, -2.012455, 2.756803>,
      < -4.272469, -1.972941, 2.769109>,
      < -4.307312, -2.002178, 2.769109>
    }
    triangle {
      < -4.287404, -2.029583, 2.779159>,
      < -4.248940, -1.997308, 2.779159>,
      < -4.263646, -1.982078, 2.756803>
    }
    triangle {
      < -4.287404, -2.029583, 2.779159>,
      < -4.263646, -1.982078, 2.756803>,
      < -4.299847, -2.012455, 2.756803>
    }
    triangle {
      < -4.237633, -2.098096, 2.764932>,
      < -4.197247, -2.066145, 2.764932>,
      < -4.248940, -1.997308, 2.779159>
    }
    triangle {
      < -4.237633, -2.098096, 2.764932>,
      < -4.248940, -1.997308, 2.779159>,
      < -4.287404, -2.029583, 2.779159>
    }
    triangle {
      < -4.216333, -2.127422, 2.663333>,
      < -4.172654, -2.092865, 2.663333>,
      < -4.197247, -2.066145, 2.764932>
    }
    triangle {
      < -4.216333, -2.127422, 2.663333>,
      < -4.197247, -2.066145, 2.764932>,
      < -4.237633, -2.098096, 2.764932>
    }
    triangle {
      < -4.167557, -2.194565, 2.663332>,
      < -4.107299, -2.144005, 2.663332>,
      < -4.172654, -2.092865, 2.663333>
    }
    triangle {
      < -4.167557, -2.194565, 2.663332>,
      < -4.172654, -2.092865, 2.663333>,
      < -4.216333, -2.127422, 2.663333>
    }
    triangle {
      < -4.162976, -2.200867, 2.744609>,
      < -4.101886, -2.149608, 2.744609>,
      < -4.107299, -2.144005, 2.663332>
    }
    triangle {
      < -4.162976, -2.200867, 2.744609>,
      < -4.107299, -2.144005, 2.663332>,
      < -4.167557, -2.194565, 2.663332>
    }
    triangle {
      < -4.125648, -2.252252, 2.736479>,
      < -4.057770, -2.195299, 2.736479>,
      < -4.101886, -2.149608, 2.744609>
    }
    triangle {
      < -4.125648, -2.252252, 2.736479>,
      < -4.101886, -2.149608, 2.744609>,
      < -4.162976, -2.200867, 2.744609>
    }
    triangle {
      < -4.125600, -2.252322, 2.633340>,
      < -4.057713, -2.195361, 2.633340>,
      < -4.057770, -2.195299, 2.736479>
    }
    triangle {
      < -4.125600, -2.252322, 2.633340>,
      < -4.057770, -2.195299, 2.736479>,
      < -4.125648, -2.252252, 2.736479>
    }
    triangle {
      < -4.418052, -1.822162, 2.842164>,
      < -4.407185, -1.810088, 2.842164>,
      < -4.412650, -1.805818, 2.828054>
    }
    triangle {
      < -4.418052, -1.822162, 2.842164>,
      < -4.412650, -1.805818, 2.828054>,
      < -4.422870, -1.817173, 2.828054>
    }
    triangle {
      < -4.345260, -1.897551, 2.813766>,
      < -4.324609, -1.874613, 2.813766>,
      < -4.407185, -1.810088, 2.842164>
    }
    triangle {
      < -4.345260, -1.897551, 2.813766>,
      < -4.407185, -1.810088, 2.842164>,
      < -4.418052, -1.822162, 2.842164>
    }
    triangle {
      < -4.272469, -1.972941, 2.769109>,
      < -4.242033, -1.939139, 2.769109>,
      < -4.324609, -1.874613, 2.813766>
    }
    triangle {
      < -4.272469, -1.972941, 2.769109>,
      < -4.324609, -1.874613, 2.813766>,
      < -4.345260, -1.897551, 2.813766>
    }
    triangle {
      < -4.263646, -1.982078, 2.756803>,
      < -4.232026, -1.946959, 2.756803>,
      < -4.242033, -1.939139, 2.769109>
    }
    triangle {
      < -4.263646, -1.982078, 2.756803>,
      < -4.242033, -1.939139, 2.769109>,
      < -4.272469, -1.972941, 2.769109>
    }
    triangle {
      < -4.248940, -1.997308, 2.779159>,
      < -4.215343, -1.959994, 2.779159>,
      < -4.232026, -1.946959, 2.756803>
    }
    triangle {
      < -4.248940, -1.997308, 2.779159>,
      < -4.232026, -1.946959, 2.756803>,
      < -4.263646, -1.982078, 2.756803>
    }
    triangle {
      < -4.141488, -2.004219, 2.764932>,
      < -4.215343, -1.959994, 2.779159>,
      < -4.175228, -2.012052, 2.768997>
    }
    triangle {
      < -4.112349, -2.025892, 2.663333>,
      < -4.141488, -2.004219, 2.764932>,
      < -4.175228, -2.012052, 2.768997>
    }
    triangle {
      < -4.112349, -2.025892, 2.663333>,
      < -4.175228, -2.012052, 2.768997>,
      < -4.148839, -2.034363, 2.663333>
    }
    triangle {
      < -4.107299, -2.144005, 2.663332>,
      < -4.054665, -2.085552, 2.663332>,
      < -4.112349, -2.025892, 2.663333>
    }
    triangle {
      < -4.107299, -2.144005, 2.663332>,
      < -4.112349, -2.025892, 2.663333>,
      < -4.172654, -2.092865, 2.663333>
    }
    triangle {
      < -4.101886, -2.149608, 2.744609>,
      < -4.048524, -2.090347, 2.744609>,
      < -4.054665, -2.085552, 2.663332>
    }
    triangle {
      < -4.101886, -2.149608, 2.744609>,
      < -4.054665, -2.085552, 2.663332>,
      < -4.107299, -2.144005, 2.663332>
    }
    triangle {
      < -4.057770, -2.195299, 2.736479>,
      < -3.998478, -2.129453, 2.736479>,
      < -4.048524, -2.090347, 2.744609>
    }
    triangle {
      < -4.057770, -2.195299, 2.736479>,
      < -4.048524, -2.090347, 2.744609>,
      < -4.101886, -2.149608, 2.744609>
    }
    triangle {
      < -4.057713, -2.195361, 2.633340>,
      < -3.998414, -2.129507, 2.633340>,
      < -3.998478, -2.129453, 2.736479>
    }
    triangle {
      < -4.057713, -2.195361, 2.633340>,
      < -3.998478, -2.129453, 2.736479>,
      < -4.057770, -2.195299, 2.736479>
    }
    triangle {
      < -4.407185, -1.810088, 2.842164>,
      < -4.404109, -1.793151, 2.828054>,
      < -4.412650, -1.805818, 2.828054>
    }
    triangle {
      < -4.324609, -1.874613, 2.813766>,
      < -4.315229, -1.860699, 2.813766>,
      < -4.407185, -1.810088, 2.842164>
    }
    triangle {
      < -4.324609, -1.874613, 2.813766>,
      < -4.242033, -1.939139, 2.769109>,
      < -4.220871, -1.907472, 2.769109>
    }
    triangle {
      < -4.324609, -1.874613, 2.813766>,
      < -4.220871, -1.907472, 2.769109>,
      < -4.315229, -1.860699, 2.813766>
    }
    triangle {
      < -4.242033, -1.939139, 2.769109>,
      < -4.232026, -1.946959, 2.756803>,
      < -4.205600, -1.907782, 2.756803>
    }
    triangle {
      < -4.242033, -1.939139, 2.769109>,
      < -4.205600, -1.907782, 2.756803>,
      < -4.220871, -1.907472, 2.769109>
    }
    triangle {
      < -4.215343, -1.959994, 2.779159>,
      < -4.187266, -1.918368, 2.779159>,
      < -4.205600, -1.907782, 2.756803>
    }
    triangle {
      < -4.215343, -1.959994, 2.779159>,
      < -4.205600, -1.907782, 2.756803>,
      < -4.232026, -1.946959, 2.756803>
    }
    triangle {
      < -4.141488, -2.004219, 2.764932>,
      < -4.113931, -1.960715, 2.764932>,
      < -4.187266, -1.918368, 2.779159>
    }
    triangle {
      < -4.141488, -2.004219, 2.764932>,
      < -4.187266, -1.918368, 2.779159>,
      < -4.215343, -1.959994, 2.779159>
    }
    triangle {
      < -4.112349, -2.025892, 2.663333>,
      < -4.082545, -1.978842, 2.663333>,
      < -4.113931, -1.960715, 2.764932>
    }
    triangle {
      < -4.112349, -2.025892, 2.663333>,
      < -4.113931, -1.960715, 2.764932>,
      < -4.141488, -2.004219, 2.764932>
    }
    triangle {
      < -4.054665, -2.085552, 2.663332>,
      < -4.010677, -2.020342, 2.663332>,
      < -4.082545, -1.978842, 2.663333>
    }
    triangle {
      < -4.054665, -2.085552, 2.663332>,
      < -4.082545, -1.978842, 2.663333>,
      < -4.112349, -2.025892, 2.663333>
    }
    triangle {
      < -4.048524, -2.090347, 2.744609>,
      < -4.003929, -2.024236, 2.744609>,
      < -4.010677, -2.020342, 2.663332>
    }
    triangle {
      < -4.048524, -2.090347, 2.744609>,
      < -4.010677, -2.020342, 2.663332>,
      < -4.054665, -2.085552, 2.663332>
    }
    triangle {
      < -3.998478, -2.129453, 2.736479>,
      < -3.948928, -2.055996, 2.736479>,
      < -4.003929, -2.024236, 2.744609>
    }
    triangle {
      < -3.998478, -2.129453, 2.736479>,
      < -4.003929, -2.024236, 2.744609>,
      < -4.048524, -2.090347, 2.744609>
    }
    triangle {
      < -3.998414, -2.129507, 2.633340>,
      < -3.948856, -2.056041, 2.633340>,
      < -3.948928, -2.055996, 2.736479>
    }
    triangle {
      < -3.998414, -2.129507, 2.633340>,
      < -3.948928, -2.055996, 2.736479>,
      < -3.998478, -2.129453, 2.736479>
    }
    triangle {
      < -4.390984, -1.782018, 2.842164>,
      < -4.397415, -1.779420, 2.828054>,
      < -4.404109, -1.793151, 2.828054>
    }
    triangle {
      < -4.293822, -1.821283, 2.813766>,
      < -4.390984, -1.782018, 2.842164>,
      < -4.301181, -1.836364, 2.813766>
    }
    triangle {
      < -4.213502, -1.894709, 2.769109>,
      < -4.196660, -1.860548, 2.769109>,
      < -4.293822, -1.821283, 2.813766>
    }
    triangle {
      < -4.213502, -1.894709, 2.769109>,
      < -4.293822, -1.821283, 2.813766>,
      < -4.301181, -1.836364, 2.813766>
    }
    triangle {
      < -4.213502, -1.894709, 2.769109>,
      < -4.205600, -1.907782, 2.756803>,
      < -4.184884, -1.865308, 2.756803>
    }
    triangle {
      < -4.213502, -1.894709, 2.769109>,
      < -4.184884, -1.865308, 2.756803>,
      < -4.196660, -1.860548, 2.769109>
    }
    triangle {
      < -4.187266, -1.918368, 2.779159>,
      < -4.165255, -1.873239, 2.779159>,
      < -4.184884, -1.865308, 2.756803>
    }
    triangle {
      < -4.187266, -1.918368, 2.779159>,
      < -4.184884, -1.865308, 2.756803>,
      < -4.205600, -1.907782, 2.756803>
    }
    triangle {
      < -4.113931, -1.960715, 2.764932>,
      < -4.090033, -1.915100, 2.764932>,
      < -4.165255, -1.873239, 2.779159>
    }
    triangle {
      < -4.113931, -1.960715, 2.764932>,
      < -4.165255, -1.873239, 2.779159>,
      < -4.187266, -1.918368, 2.779159>
    }
    triangle {
      < -4.082545, -1.978842, 2.663333>,
      < -4.056698, -1.929508, 2.663333>,
      < -4.090033, -1.915100, 2.764932>
    }
    triangle {
      < -4.082545, -1.978842, 2.663333>,
      < -4.090033, -1.915100, 2.764932>,
      < -4.113931, -1.960715, 2.764932>
    }
    triangle {
      < -4.010677, -2.020342, 2.663332>,
      < -3.976193, -1.949645, 2.663332>,
      < -4.056698, -1.929508, 2.663333>
    }
    triangle {
      < -4.010677, -2.020342, 2.663332>,
      < -4.056698, -1.929508, 2.663333>,
      < -4.082545, -1.978842, 2.663333>
    }
    triangle {
      < -4.003929, -2.024236, 2.744609>,
      < -3.968969, -1.952562, 2.744609>,
      < -3.976193, -1.949645, 2.663332>
    }
    triangle {
      < -4.003929, -2.024236, 2.744609>,
      < -3.976193, -1.949645, 2.663332>,
      < -4.010677, -2.020342, 2.663332>
    }
    triangle {
      < -3.948928, -2.055996, 2.736479>,
      < -3.910083, -1.976358, 2.736479>,
      < -3.968969, -1.952562, 2.744609>
    }
    triangle {
      < -3.948928, -2.055996, 2.736479>,
      < -3.968969, -1.952562, 2.744609>,
      < -4.003929, -2.024236, 2.744609>
    }
    triangle {
      < -3.948856, -2.056041, 2.633340>,
      < -3.910006, -1.976393, 2.633340>,
      < -3.910083, -1.976358, 2.736479>
    }
    triangle {
      < -3.948856, -2.056041, 2.633340>,
      < -3.910083, -1.976358, 2.736479>,
      < -3.948928, -2.055996, 2.736479>
    }
    triangle {
      < -4.390984, -1.782018, 2.842164>,
      < -4.385967, -1.766568, 2.842164>,
      < -4.392696, -1.764889, 2.828054>
    }
    triangle {
      < -4.390984, -1.782018, 2.842164>,
      < -4.392696, -1.764889, 2.828054>,
      < -4.397415, -1.779420, 2.828054>
    }
    triangle {
      < -4.293822, -1.821283, 2.813766>,
      < -4.284286, -1.791928, 2.813766>,
      < -4.385967, -1.766568, 2.842164>
    }
    triangle {
      < -4.293822, -1.821283, 2.813766>,
      < -4.385967, -1.766568, 2.842164>,
      < -4.390984, -1.782018, 2.842164>
    }
    triangle {
      < -4.196660, -1.860548, 2.769109>,
      < -4.182605, -1.817290, 2.769109>,
      < -4.284286, -1.791928, 2.813766>
    }
    triangle {
      < -4.196660, -1.860548, 2.769109>,
      < -4.284286, -1.791928, 2.813766>,
      < -4.293822, -1.821283, 2.813766>
    }
    triangle {
      < -4.184884, -1.865308, 2.756803>,
      < -4.170281, -1.820364, 2.756803>,
      < -4.182605, -1.817290, 2.769109>
    }
    triangle {
      < -4.184884, -1.865308, 2.756803>,
      < -4.182605, -1.817290, 2.769109>,
      < -4.196660, -1.860548, 2.769109>
    }
    triangle {
      < -4.165255, -1.873239, 2.779159>,
      < -4.149739, -1.825486, 2.779159>,
      < -4.170281, -1.820364, 2.756803>
    }
    triangle {
      < -4.165255, -1.873239, 2.779159>,
      < -4.170281, -1.820364, 2.756803>,
      < -4.184884, -1.865308, 2.756803>
    }
    triangle {
      < -4.064281, -1.835848, 2.764932>,
      < -4.149739, -1.825486, 2.779159>,
      < -4.091918, -1.856727, 2.768997>
    }
    triangle {
      < -4.028846, -1.843796, 2.663333>,
      < -4.064281, -1.835848, 2.764932>,
      < -4.091918, -1.856727, 2.768997>
    }
    triangle {
      < -4.028846, -1.843796, 2.663333>,
      < -4.091918, -1.856727, 2.768997>,
      < -4.058736, -1.866377, 2.663333>
    }
    triangle {
      < -3.976193, -1.949645, 2.663332>,
      < -3.951883, -1.874836, 2.663332>,
      < -4.028846, -1.843796, 2.663333>
    }
    triangle {
      < -3.976193, -1.949645, 2.663332>,
      < -4.028846, -1.843796, 2.663333>,
      < -4.056698, -1.929508, 2.663333>
    }
    triangle {
      < -3.968969, -1.952562, 2.744609>,
      < -3.944324, -1.876719, 2.744609>,
      < -3.951883, -1.874836, 2.663332>
    }
    triangle {
      < -3.968969, -1.952562, 2.744609>,
      < -3.951883, -1.874836, 2.663332>,
      < -3.976193, -1.949645, 2.663332>
    }
    triangle {
      < -3.910083, -1.976358, 2.736479>,
      < -3.882699, -1.892089, 2.736479>,
      < -3.944324, -1.876719, 2.744609>
    }
    triangle {
      < -3.910083, -1.976358, 2.736479>,
      < -3.944324, -1.876719, 2.744609>,
      < -3.968969, -1.952562, 2.744609>
    }
    triangle {
      < -3.910006, -1.976393, 2.633340>,
      < -3.882617, -1.892112, 2.633340>,
      < -3.882699, -1.892089, 2.736479>
    }
    triangle {
      < -3.910006, -1.976393, 2.633340>,
      < -3.882699, -1.892089, 2.736479>,
      < -3.910083, -1.976358, 2.736479>
    }
    triangle {
      < -4.385967, -1.766568, 2.842164>,
      < -4.383148, -1.750569, 2.842164>,
      < -4.390046, -1.749844, 2.828054>
    }
    triangle {
      < -4.385967, -1.766568, 2.842164>,
      < -4.390046, -1.749844, 2.828054>,
      < -4.392696, -1.764889, 2.828054>
    }
    triangle {
      < -4.284286, -1.791928, 2.813766>,
      < -4.278927, -1.761532, 2.813766>,
      < -4.383148, -1.750569, 2.842164>
    }
    triangle {
      < -4.284286, -1.791928, 2.813766>,
      < -4.383148, -1.750569, 2.842164>,
      < -4.385967, -1.766568, 2.842164>
    }
    triangle {
      < -4.182605, -1.817290, 2.769109>,
      < -4.174706, -1.772496, 2.769109>,
      < -4.278927, -1.761532, 2.813766>
    }
    triangle {
      < -4.182605, -1.817290, 2.769109>,
      < -4.278927, -1.761532, 2.813766>,
      < -4.284286, -1.791928, 2.813766>
    }
    triangle {
      < -4.170281, -1.820364, 2.756803>,
      < -4.162075, -1.773825, 2.756803>,
      < -4.174706, -1.772496, 2.769109>
    }
    triangle {
      < -4.170281, -1.820364, 2.756803>,
      < -4.174706, -1.772496, 2.769109>,
      < -4.182605, -1.817290, 2.769109>
    }
    triangle {
      < -4.149739, -1.825486, 2.779159>,
      < -4.141020, -1.776039, 2.779159>,
      < -4.162075, -1.773825, 2.756803>
    }
    triangle {
      < -4.149739, -1.825486, 2.779159>,
      < -4.162075, -1.773825, 2.756803>,
      < -4.170281, -1.820364, 2.756803>
    }
    triangle {
      < -4.064281, -1.835848, 2.764932>,
      < -4.056801, -1.784897, 2.764932>,
      < -4.141020, -1.776039, 2.779159>
    }
    triangle {
      < -4.064281, -1.835848, 2.764932>,
      < -4.141020, -1.776039, 2.779159>,
      < -4.149739, -1.825486, 2.779159>
    }
    triangle {
      < -4.028846, -1.843796, 2.663333>,
      < -4.020756, -1.788691, 2.663333>,
      < -4.056801, -1.784897, 2.764932>
    }
    triangle {
      < -4.028846, -1.843796, 2.663333>,
      < -4.056801, -1.784897, 2.764932>,
      < -4.064281, -1.835848, 2.764932>
    }
    triangle {
      < -3.951883, -1.874836, 2.663332>,
      < -3.938221, -1.797373, 2.663332>,
      < -4.020756, -1.788691, 2.663333>
    }
    triangle {
      < -3.951883, -1.874836, 2.663332>,
      < -4.020756, -1.788691, 2.663333>,
      < -4.028846, -1.843796, 2.663333>
    }
    triangle {
      < -3.944324, -1.876719, 2.744609>,
      < -3.930473, -1.798185, 2.744609>,
      < -3.938221, -1.797373, 2.663332>
    }
    triangle {
      < -3.944324, -1.876719, 2.744609>,
      < -3.938221, -1.797373, 2.663332>,
      < -3.951883, -1.874836, 2.663332>
    }
    triangle {
      < -3.882699, -1.892089, 2.736479>,
      < -3.867310, -1.804829, 2.736479>,
      < -3.930473, -1.798185, 2.744609>
    }
    triangle {
      < -3.882699, -1.892089, 2.736479>,
      < -3.930473, -1.798185, 2.744609>,
      < -3.944324, -1.876719, 2.744609>
    }
    triangle {
      < -3.882617, -1.892112, 2.633340>,
      < -3.867225, -1.804841, 2.633340>,
      < -3.867310, -1.804829, 2.736479>
    }
    triangle {
      < -3.882617, -1.892112, 2.633340>,
      < -3.867310, -1.804829, 2.736479>,
      < -3.882699, -1.892089, 2.736479>
    }
    triangle {
      < -4.383148, -1.750569, 2.842164>,
      < -4.382584, -1.734335, 2.842164>,
      < -4.389516, -1.734577, 2.828054>
    }
    triangle {
      < -4.383148, -1.750569, 2.842164>,
      < -4.389516, -1.734577, 2.828054>,
      < -4.390046, -1.749844, 2.828054>
    }
    triangle {
      < -4.278927, -1.761532, 2.813766>,
      < -4.277852, -1.730686, 2.813766>,
      < -4.382584, -1.734335, 2.842164>
    }
    triangle {
      < -4.278927, -1.761532, 2.813766>,
      < -4.382584, -1.734335, 2.842164>,
      < -4.383148, -1.750569, 2.842164>
    }
    triangle {
      < -4.174706, -1.772496, 2.769109>,
      < -4.173119, -1.727039, 2.769109>,
      < -4.277852, -1.730686, 2.813766>
    }
    triangle {
      < -4.174706, -1.772496, 2.769109>,
      < -4.277852, -1.730686, 2.813766>,
      < -4.278927, -1.761532, 2.813766>
    }
    triangle {
      < -4.162075, -1.773825, 2.756803>,
      < -4.160425, -1.726597, 2.756803>,
      < -4.173119, -1.727039, 2.769109>
    }
    triangle {
      < -4.162075, -1.773825, 2.756803>,
      < -4.173119, -1.727039, 2.769109>,
      < -4.174706, -1.772496, 2.769109>
    }
    triangle {
      < -4.141020, -1.776039, 2.779159>,
      < -4.139267, -1.725859, 2.779159>,
      < -4.160425, -1.726597, 2.756803>
    }
    triangle {
      < -4.141020, -1.776039, 2.779159>,
      < -4.160425, -1.726597, 2.756803>,
      < -4.162075, -1.773825, 2.756803>
    }
    triangle {
      < -4.056801, -1.784897, 2.764932>,
      < -4.053522, -1.733505, 2.764932>,
      < -4.139267, -1.725859, 2.779159>
    }
    triangle {
      < -4.056801, -1.784897, 2.764932>,
      < -4.139267, -1.725859, 2.779159>,
      < -4.141020, -1.776039, 2.779159>
    }
    triangle {
      < -4.020756, -1.788691, 2.663333>,
      < -4.017209, -1.733109, 2.663333>,
      < -4.053522, -1.733505, 2.764932>
    }
    triangle {
      < -4.020756, -1.788691, 2.663333>,
      < -4.053522, -1.733505, 2.764932>,
      < -4.056801, -1.784897, 2.764932>
    }
    triangle {
      < -3.938221, -1.797373, 2.663332>,
      < -3.935473, -1.718761, 2.663332>,
      < -4.017209, -1.733109, 2.663333>
    }
    triangle {
      < -3.938221, -1.797373, 2.663332>,
      < -4.017209, -1.733109, 2.663333>,
      < -4.020756, -1.788691, 2.663333>
    }
    triangle {
      < -3.930473, -1.798185, 2.744609>,
      < -3.927687, -1.718488, 2.744609>,
      < -3.935473, -1.718761, 2.663332>
    }
    triangle {
      < -3.930473, -1.798185, 2.744609>,
      < -3.935473, -1.718761, 2.663332>,
      < -3.938221, -1.797373, 2.663332>
    }
    triangle {
      < -3.867310, -1.804829, 2.736479>,
      < -3.864213, -1.716277, 2.736479>,
      < -3.927687, -1.718488, 2.744609>
    }
    triangle {
      < -3.867310, -1.804829, 2.736479>,
      < -3.927687, -1.718488, 2.744609>,
      < -3.930473, -1.798185, 2.744609>
    }
    triangle {
      < -3.867225, -1.804841, 2.633340>,
      < -3.864129, -1.716277, 2.633340>,
      < -3.864213, -1.716277, 2.736479>
    }
    triangle {
      < -3.867225, -1.804841, 2.633340>,
      < -3.864213, -1.716277, 2.736479>,
      < -3.867310, -1.804829, 2.736479>
    }
    triangle {
      < -4.382584, -1.734335, 2.842164>,
      < -4.384284, -1.718179, 2.842164>,
      < -4.391115, -1.719384, 2.828054>
    }
    triangle {
      < -4.382584, -1.734335, 2.842164>,
      < -4.391115, -1.719384, 2.828054>,
      < -4.389516, -1.734577, 2.828054>
    }
    triangle {
      < -4.277852, -1.730686, 2.813766>,
      < -4.281079, -1.699991, 2.813766>,
      < -4.384284, -1.718179, 2.842164>
    }
    triangle {
      < -4.277852, -1.730686, 2.813766>,
      < -4.384284, -1.718179, 2.842164>,
      < -4.382584, -1.734335, 2.842164>
    }
    triangle {
      < -4.173119, -1.727039, 2.769109>,
      < -4.177873, -1.681803, 2.769109>,
      < -4.281079, -1.699991, 2.813766>
    }
    triangle {
      < -4.173119, -1.727039, 2.769109>,
      < -4.281079, -1.699991, 2.813766>,
      < -4.277852, -1.730686, 2.813766>
    }
    triangle {
      < -4.160425, -1.726597, 2.756803>,
      < -4.165364, -1.679599, 2.756803>,
      < -4.177873, -1.681803, 2.769109>
    }
    triangle {
      < -4.160425, -1.726597, 2.756803>,
      < -4.177873, -1.681803, 2.769109>,
      < -4.173119, -1.727039, 2.769109>
    }
    triangle {
      < -4.139267, -1.725859, 2.779159>,
      < -4.144515, -1.675924, 2.779159>,
      < -4.165364, -1.679599, 2.756803>
    }
    triangle {
      < -4.139267, -1.725859, 2.779159>,
      < -4.165364, -1.679599, 2.756803>,
      < -4.160425, -1.726597, 2.756803>
    }
    triangle {
      < -4.062230, -1.650631, 2.764932>,
      < -4.144515, -1.675924, 2.779159>,
      < -4.078987, -1.680946, 2.768997>
    }
    triangle {
      < -4.026626, -1.643479, 2.663333>,
      < -4.062230, -1.650631, 2.764932>,
      < -4.078987, -1.680946, 2.768997>
    }
    triangle {
      < -4.026626, -1.643479, 2.663333>,
      < -4.078987, -1.680946, 2.768997>,
      < -4.044749, -1.676265, 2.663333>
    }
    triangle {
      < -3.935473, -1.718761, 2.663332>,
      < -3.943692, -1.640533, 2.663332>,
      < -4.026626, -1.643479, 2.663333>
    }
    triangle {
      < -3.935473, -1.718761, 2.663332>,
      < -4.026626, -1.643479, 2.663333>,
      < -4.017209, -1.733109, 2.663333>
    }
    triangle {
      < -3.927687, -1.718488, 2.744609>,
      < -3.936020, -1.639179, 2.744609>,
      < -3.943692, -1.640533, 2.663332>
    }
    triangle {
      < -3.927687, -1.718488, 2.744609>,
      < -3.943692, -1.640533, 2.663332>,
      < -3.935473, -1.718761, 2.663332>
    }
    triangle {
      < -3.864213, -1.716277, 2.736479>,
      < -3.873472, -1.628155, 2.736479>,
      < -3.936020, -1.639179, 2.744609>
    }
    triangle {
      < -3.864213, -1.716277, 2.736479>,
      < -3.936020, -1.639179, 2.744609>,
      < -3.927687, -1.718488, 2.744609>
    }
    triangle {
      < -3.864129, -1.716277, 2.633340>,
      < -3.873388, -1.628143, 2.633340>,
      < -3.873472, -1.628155, 2.736479>
    }
    triangle {
      < -3.864129, -1.716277, 2.633340>,
      < -3.873472, -1.628155, 2.736479>,
      < -3.864213, -1.716277, 2.736479>
    }
    triangle {
      < -4.384284, -1.718179, 2.842164>,
      < -4.388216, -1.702418, 2.842164>,
      < -4.394813, -1.704561, 2.828054>
    }
    triangle {
      < -4.384284, -1.718179, 2.842164>,
      < -4.394813, -1.704561, 2.828054>,
      < -4.391115, -1.719384, 2.828054>
    }
    triangle {
      < -4.281079, -1.699991, 2.813766>,
      < -4.288547, -1.670043, 2.813766>,
      < -4.388216, -1.702418, 2.842164>
    }
    triangle {
      < -4.281079, -1.699991, 2.813766>,
      < -4.388216, -1.702418, 2.842164>,
      < -4.384284, -1.718179, 2.842164>
    }
    triangle {
      < -4.177873, -1.681803, 2.769109>,
      < -4.188877, -1.637669, 2.769109>,
      < -4.288547, -1.670043, 2.813766>
    }
    triangle {
      < -4.177873, -1.681803, 2.769109>,
      < -4.288547, -1.670043, 2.813766>,
      < -4.281079, -1.699991, 2.813766>
    }
    triangle {
      < -4.165364, -1.679599, 2.756803>,
      < -4.176796, -1.633745, 2.756803>,
      < -4.188877, -1.637669, 2.769109>
    }
    triangle {
      < -4.165364, -1.679599, 2.756803>,
      < -4.188877, -1.637669, 2.769109>,
      < -4.177873, -1.681803, 2.769109>
    }
    triangle {
      < -4.144515, -1.675924, 2.779159>,
      < -4.156662, -1.627204, 2.779159>,
      < -4.176796, -1.633745, 2.756803>
    }
    triangle {
      < -4.144515, -1.675924, 2.779159>,
      < -4.176796, -1.633745, 2.756803>,
      < -4.165364, -1.679599, 2.756803>
    }
    triangle {
      < -4.062230, -1.650631, 2.764932>,
      < -4.076120, -1.601043, 2.764932>,
      < -4.156662, -1.627204, 2.779159>
    }
    triangle {
      < -4.062230, -1.650631, 2.764932>,
      < -4.156662, -1.627204, 2.779159>,
      < -4.144515, -1.675924, 2.779159>
    }
    triangle {
      < -4.026626, -1.643479, 2.663333>,
      < -4.041648, -1.589848, 2.663333>,
      < -4.076120, -1.601043, 2.764932>
    }
    triangle {
      < -4.026626, -1.643479, 2.663333>,
      < -4.076120, -1.601043, 2.764932>,
      < -4.062230, -1.650631, 2.764932>
    }
    triangle {
      < -3.943692, -1.640533, 2.663332>,
      < -3.962718, -1.564210, 2.663332>,
      < -4.041648, -1.589848, 2.663333>
    }
    triangle {
      < -3.943692, -1.640533, 2.663332>,
      < -4.041648, -1.589848, 2.663333>,
      < -4.026626, -1.643479, 2.663333>
    }
    triangle {
      < -3.936020, -1.639179, 2.744609>,
      < -3.955309, -1.561801, 2.744609>,
      < -3.962718, -1.564210, 2.663332>
    }
    triangle {
      < -3.936020, -1.639179, 2.744609>,
      < -3.962718, -1.564210, 2.663332>,
      < -3.943692, -1.640533, 2.663332>
    }
    triangle {
      < -3.873472, -1.628155, 2.736479>,
      < -3.894904, -1.542180, 2.736479>,
      < -3.955309, -1.561801, 2.744609>
    }
    triangle {
      < -3.873472, -1.628155, 2.736479>,
      < -3.955309, -1.561801, 2.744609>,
      < -3.936020, -1.639179, 2.744609>
    }
    triangle {
      < -3.873388, -1.628143, 2.633340>,
      < -3.894822, -1.542156, 2.633340>,
      < -3.894904, -1.542180, 2.736479>
    }
    triangle {
      < -3.873388, -1.628143, 2.633340>,
      < -3.894904, -1.542180, 2.736479>,
      < -3.873472, -1.628155, 2.736479>
    }
    triangle {
      < -4.388216, -1.702418, 2.842164>,
      < -4.394304, -1.687357, 2.842164>,
      < -4.400538, -1.690398, 2.828054>
    }
    triangle {
      < -4.388216, -1.702418, 2.842164>,
      < -4.400538, -1.690398, 2.828054>,
      < -4.394813, -1.704561, 2.828054>
    }
    triangle {
      < -4.288547, -1.670043, 2.813766>,
      < -4.300110, -1.641426, 2.813766>,
      < -4.394304, -1.687357, 2.842164>
    }
    triangle {
      < -4.288547, -1.670043, 2.813766>,
      < -4.394304, -1.687357, 2.842164>,
      < -4.388216, -1.702418, 2.842164>
    }
    triangle {
      < -4.188877, -1.637669, 2.769109>,
      < -4.205915, -1.595496, 2.769109>,
      < -4.300110, -1.641426, 2.813766>
    }
    triangle {
      < -4.188877, -1.637669, 2.769109>,
      < -4.300110, -1.641426, 2.813766>,
      < -4.288547, -1.670043, 2.813766>
    }
    triangle {
      < -4.176796, -1.633745, 2.756803>,
      < -4.194499, -1.589929, 2.756803>,
      < -4.205915, -1.595496, 2.769109>
    }
    triangle {
      < -4.176796, -1.633745, 2.756803>,
      < -4.205915, -1.595496, 2.769109>,
      < -4.188877, -1.637669, 2.769109>
    }
    triangle {
      < -4.156662, -1.627204, 2.779159>,
      < -4.175470, -1.580650, 2.779159>,
      < -4.194499, -1.589929, 2.756803>
    }
    triangle {
      < -4.156662, -1.627204, 2.779159>,
      < -4.194499, -1.589929, 2.756803>,
      < -4.176796, -1.633745, 2.756803>
    }
    triangle {
      < -4.076120, -1.601043, 2.764932>,
      < -4.094028, -1.552760, 2.764932>,
      < -4.175470, -1.580650, 2.779159>
    }
    triangle {
      < -4.076120, -1.601043, 2.764932>,
      < -4.175470, -1.580650, 2.779159>,
      < -4.156662, -1.627204, 2.779159>
    }
    triangle {
      < -4.041648, -1.589848, 2.663333>,
      < -4.061015, -1.537629, 2.663333>,
      < -4.094028, -1.552760, 2.764932>
    }
    triangle {
      < -4.041648, -1.589848, 2.663333>,
      < -4.094028, -1.552760, 2.764932>,
      < -4.076120, -1.601043, 2.764932>
    }
    triangle {
      < -3.962718, -1.564210, 2.663332>,
      < -3.992181, -1.491277, 2.663332>,
      < -4.061015, -1.537629, 2.663333>
    }
    triangle {
      < -3.962718, -1.564210, 2.663332>,
      < -4.061015, -1.537629, 2.663333>,
      < -4.041648, -1.589848, 2.663333>
    }
    triangle {
      < -3.955309, -1.561801, 2.744609>,
      < -3.985179, -1.487860, 2.744609>,
      < -3.992181, -1.491277, 2.663332>
    }
    triangle {
      < -3.955309, -1.561801, 2.744609>,
      < -3.992181, -1.491277, 2.663332>,
      < -3.962718, -1.564210, 2.663332>
    }
    triangle {
      < -3.894904, -1.542180, 2.736479>,
      < -3.928092, -1.460024, 2.736479>,
      < -3.985179, -1.487860, 2.744609>
    }
    triangle {
      < -3.894904, -1.542180, 2.736479>,
      < -3.985179, -1.487860, 2.744609>,
      < -3.955309, -1.561801, 2.744609>
    }
    triangle {
      < -3.894822, -1.542156, 2.633340>,
      < -3.928015, -1.459989, 2.633340>,
      < -3.928092, -1.460024, 2.736479>
    }
    triangle {
      < -3.894822, -1.542156, 2.633340>,
      < -3.928092, -1.460024, 2.736479>,
      < -3.894904, -1.542180, 2.736479>
    }
    triangle {
      < -4.394304, -1.687357, 2.842164>,
      < -4.402429, -1.673290, 2.842164>,
      < -4.408179, -1.677168, 2.828054>
    }
    triangle {
      < -4.394304, -1.687357, 2.842164>,
      < -4.408179, -1.677168, 2.828054>,
      < -4.400538, -1.690398, 2.828054>
    }
    triangle {
      < -4.300110, -1.641426, 2.813766>,
      < -4.315543, -1.614697, 2.813766>,
      < -4.402429, -1.673290, 2.842164>
    }
    triangle {
      < -4.300110, -1.641426, 2.813766>,
      < -4.402429, -1.673290, 2.842164>,
      < -4.394304, -1.687357, 2.842164>
    }
    triangle {
      < -4.205915, -1.595496, 2.769109>,
      < -4.228657, -1.556105, 2.769109>,
      < -4.315543, -1.614697, 2.813766>
    }
    triangle {
      < -4.205915, -1.595496, 2.769109>,
      < -4.315543, -1.614697, 2.813766>,
      < -4.300110, -1.641426, 2.813766>
    }
    triangle {
      < -4.194499, -1.589929, 2.756803>,
      < -4.218126, -1.549003, 2.756803>,
      < -4.228657, -1.556105, 2.769109>
    }
    triangle {
      < -4.194499, -1.589929, 2.756803>,
      < -4.228657, -1.556105, 2.769109>,
      < -4.205915, -1.595496, 2.769109>
    }
    triangle {
      < -4.175470, -1.580650, 2.779159>,
      < -4.200574, -1.537166, 2.779159>,
      < -4.218126, -1.549003, 2.756803>
    }
    triangle {
      < -4.175470, -1.580650, 2.779159>,
      < -4.218126, -1.549003, 2.756803>,
      < -4.194499, -1.589929, 2.756803>
    }
    triangle {
      < -4.135691, -1.480592, 2.764932>,
      < -4.200574, -1.537166, 2.779159>,
      < -4.138668, -1.515102, 2.768997>
    }
    triangle {
      < -4.106073, -1.459577, 2.663333>,
      < -4.135691, -1.480592, 2.764932>,
      < -4.138668, -1.515102, 2.768997>
    }
    triangle {
      < -4.106073, -1.459577, 2.663333>,
      < -4.138668, -1.515102, 2.768997>,
      < -4.109294, -1.496900, 2.663333>
    }
    triangle {
      < -3.992181, -1.491277, 2.663332>,
      < -4.031507, -1.423154, 2.663332>,
      < -4.106073, -1.459577, 2.663333>
    }
    triangle {
      < -3.992181, -1.491277, 2.663332>,
      < -4.106073, -1.459577, 2.663333>,
      < -4.061015, -1.537629, 2.663333>
    }
    triangle {
      < -3.985179, -1.487860, 2.744609>,
      < -4.025049, -1.418797, 2.744609>,
      < -4.031507, -1.423154, 2.663332>
    }
    triangle {
      < -3.985179, -1.487860, 2.744609>,
      < -4.031507, -1.423154, 2.663332>,
      < -3.992181, -1.491277, 2.663332>
    }
    triangle {
      < -3.928092, -1.460024, 2.736479>,
      < -3.972392, -1.383286, 2.736479>,
      < -4.025049, -1.418797, 2.744609>
    }
    triangle {
      < -3.928092, -1.460024, 2.736479>,
      < -4.025049, -1.418797, 2.744609>,
      < -3.985179, -1.487860, 2.744609>
    }
    triangle {
      < -3.928015, -1.459989, 2.633340>,
      < -3.972320, -1.383241, 2.633340>,
      < -3.972392, -1.383286, 2.736479>
    }
    triangle {
      < -3.928015, -1.459989, 2.633340>,
      < -3.972392, -1.383286, 2.736479>,
      < -3.928092, -1.460024, 2.736479>
    }
    triangle {
      < -4.402429, -1.673290, 2.842164>,
      < -4.412431, -1.660491, 2.842164>,
      < -4.417586, -1.665132, 2.828054>
    }
    triangle {
      < -4.402429, -1.673290, 2.842164>,
      < -4.417586, -1.665132, 2.828054>,
      < -4.408179, -1.677168, 2.828054>
    }
    triangle {
      < -4.315543, -1.614697, 2.813766>,
      < -4.334546, -1.590376, 2.813766>,
      < -4.412431, -1.660491, 2.842164>
    }
    triangle {
      < -4.315543, -1.614697, 2.813766>,
      < -4.412431, -1.660491, 2.842164>,
      < -4.402429, -1.673290, 2.842164>
    }
    triangle {
      < -4.228657, -1.556105, 2.769109>,
      < -4.256660, -1.520262, 2.769109>,
      < -4.334546, -1.590376, 2.813766>
    }
    triangle {
      < -4.228657, -1.556105, 2.769109>,
      < -4.334546, -1.590376, 2.813766>,
      < -4.315543, -1.614697, 2.813766>
    }
    triangle {
      < -4.218126, -1.549003, 2.756803>,
      < -4.247220, -1.511764, 2.756803>,
      < -4.256660, -1.520262, 2.769109>
    }
    triangle {
      < -4.218126, -1.549003, 2.756803>,
      < -4.256660, -1.520262, 2.769109>,
      < -4.228657, -1.556105, 2.769109>
    }
    triangle {
      < -4.200574, -1.537166, 2.779159>,
      < -4.231486, -1.497599, 2.779159>,
      < -4.247220, -1.511764, 2.756803>
    }
    triangle {
      < -4.200574, -1.537166, 2.779159>,
      < -4.247220, -1.511764, 2.756803>,
      < -4.218126, -1.549003, 2.756803>
    }
    triangle {
      < -4.135691, -1.480592, 2.764932>,
      < -4.168549, -1.440941, 2.764932>,
      < -4.231486, -1.497599, 2.779159>
    }
    triangle {
      < -4.135691, -1.480592, 2.764932>,
      < -4.231486, -1.497599, 2.779159>,
      < -4.200574, -1.537166, 2.779159>
    }
    triangle {
      < -4.106073, -1.459577, 2.663333>,
      < -4.141610, -1.416693, 2.663333>,
      < -4.168549, -1.440941, 2.764932>
    }
    triangle {
      < -4.106073, -1.459577, 2.663333>,
      < -4.168549, -1.440941, 2.764932>,
      < -4.135691, -1.480592, 2.764932>
    }
    triangle {
      < -4.031507, -1.423154, 2.663332>,
      < -4.079931, -1.361168, 2.663332>,
      < -4.141610, -1.416693, 2.663333>
    }
    triangle {
      < -4.031507, -1.423154, 2.663332>,
      < -4.141610, -1.416693, 2.663333>,
      < -4.106073, -1.459577, 2.663333>
    }
    triangle {
      < -4.025049, -1.418797, 2.744609>,
      < -4.074143, -1.355954, 2.744609>,
      < -4.079931, -1.361168, 2.663332>
    }
    triangle {
      < -4.025049, -1.418797, 2.744609>,
      < -4.079931, -1.361168, 2.663332>,
      < -4.031507, -1.423154, 2.663332>
    }
    triangle {
      < -3.972392, -1.383286, 2.736479>,
      < -4.026940, -1.313460, 2.736479>,
      < -4.074143, -1.355954, 2.744609>
    }
    triangle {
      < -3.972392, -1.383286, 2.736479>,
      < -4.074143, -1.355954, 2.744609>,
      < -4.025049, -1.418797, 2.744609>
    }
    triangle {
      < -3.972320, -1.383241, 2.633340>,
      < -4.026875, -1.313405, 2.633340>,
      < -4.026940, -1.313460, 2.736479>
    }
    triangle {
      < -3.972320, -1.383241, 2.633340>,
      < -4.026940, -1.313460, 2.736479>,
      < -3.972392, -1.383286, 2.736479>
    }
    triangle {
      < -4.412431, -1.660491, 2.842164>,
      < -4.424119, -1.649208, 2.842164>,
      < -4.428577, -1.654521, 2.828054>
    }
    triangle {
      < -4.412431, -1.660491, 2.842164>,
      < -4.428577, -1.654521, 2.828054>,
      < -4.417586, -1.665132, 2.828054>
    }
    triangle {
      < -4.334546, -1.590376, 2.813766>,
      < -4.356749, -1.568936, 2.813766>,
      < -4.424119, -1.649208, 2.842164>
    }
    triangle {
      < -4.334546, -1.590376, 2.813766>,
      < -4.424119, -1.649208, 2.842164>,
      < -4.412431, -1.660491, 2.842164>
    }
    triangle {
      < -4.256660, -1.520262, 2.769109>,
      < -4.289379, -1.488665, 2.769109>,
      < -4.356749, -1.568936, 2.813766>
    }
    triangle {
      < -4.256660, -1.520262, 2.769109>,
      < -4.356749, -1.568936, 2.813766>,
      < -4.334546, -1.590376, 2.813766>
    }
    triangle {
      < -4.247220, -1.511764, 2.756803>,
      < -4.281213, -1.478936, 2.756803>,
      < -4.289379, -1.488665, 2.769109>
    }
    triangle {
      < -4.247220, -1.511764, 2.756803>,
      < -4.289379, -1.488665, 2.769109>,
      < -4.256660, -1.520262, 2.769109>
    }
    triangle {
      < -4.231486, -1.497599, 2.779159>,
      < -4.267604, -1.462719, 2.779159>,
      < -4.281213, -1.478936, 2.756803>
    }
    triangle {
      < -4.231486, -1.497599, 2.779159>,
      < -4.281213, -1.478936, 2.756803>,
      < -4.247220, -1.511764, 2.756803>
    }
    triangle {
      < -4.168549, -1.440941, 2.764932>,
      < -4.204546, -1.404115, 2.764932>,
      < -4.267604, -1.462719, 2.779159>
    }
    triangle {
      < -4.168549, -1.440941, 2.764932>,
      < -4.267604, -1.462719, 2.779159>,
      < -4.231486, -1.497599, 2.779159>
    }
    triangle {
      < -4.141610, -1.416693, 2.663333>,
      < -4.180542, -1.376865, 2.663333>,
      < -4.204546, -1.404115, 2.764932>
    }
    triangle {
      < -4.141610, -1.416693, 2.663333>,
      < -4.204546, -1.404115, 2.764932>,
      < -4.168549, -1.440941, 2.764932>
    }
    triangle {
      < -4.079931, -1.361168, 2.663332>,
      < -4.136511, -1.306524, 2.663332>,
      < -4.180542, -1.376865, 2.663333>
    }
    triangle {
      < -4.079931, -1.361168, 2.663332>,
      < -4.180542, -1.376865, 2.663333>,
      < -4.141610, -1.416693, 2.663333>
    }
    triangle {
      < -4.074143, -1.355954, 2.744609>,
      < -4.131505, -1.300555, 2.744609>,
      < -4.136511, -1.306524, 2.663332>
    }
    triangle {
      < -4.074143, -1.355954, 2.744609>,
      < -4.136511, -1.306524, 2.663332>,
      < -4.079931, -1.361168, 2.663332>
    }
    triangle {
      < -4.026940, -1.313460, 2.736479>,
      < -4.090675, -1.251905, 2.736479>,
      < -4.131505, -1.300555, 2.744609>
    }
    triangle {
      < -4.026940, -1.313460, 2.736479>,
      < -4.131505, -1.300555, 2.744609>,
      < -4.074143, -1.355954, 2.744609>
    }
    triangle {
      < -4.026875, -1.313405, 2.633340>,
      < -4.090618, -1.251842, 2.633340>,
      < -4.090675, -1.251905, 2.736479>
    }
    triangle {
      < -4.026875, -1.313405, 2.633340>,
      < -4.090675, -1.251905, 2.736479>,
      < -4.026940, -1.313460, 2.736479>
    }
    triangle {
      < -4.424119, -1.649208, 2.842164>,
      < -4.437262, -1.639661, 2.842164>,
      < -4.440938, -1.645543, 2.828054>
    }
    triangle {
      < -4.424119, -1.649208, 2.842164>,
      < -4.440938, -1.645543, 2.828054>,
      < -4.428577, -1.654521, 2.828054>
    }
    triangle {
      < -4.356749, -1.568936, 2.813766>,
      < -4.381719, -1.550795, 2.813766>,
      < -4.437262, -1.639661, 2.842164>
    }
    triangle {
      < -4.356749, -1.568936, 2.813766>,
      < -4.437262, -1.639661, 2.842164>,
      < -4.424119, -1.649208, 2.842164>
    }
    triangle {
      < -4.289379, -1.488665, 2.769109>,
      < -4.326176, -1.461929, 2.769109>,
      < -4.381719, -1.550795, 2.813766>
    }
    triangle {
      < -4.289379, -1.488665, 2.769109>,
      < -4.381719, -1.550795, 2.813766>,
      < -4.356749, -1.568936, 2.813766>
    }
    triangle {
      < -4.281213, -1.478936, 2.756803>,
      < -4.319444, -1.451158, 2.756803>,
      < -4.326176, -1.461929, 2.769109>
    }
    triangle {
      < -4.281213, -1.478936, 2.756803>,
      < -4.326176, -1.461929, 2.769109>,
      < -4.289379, -1.488665, 2.769109>
    }
    triangle {
      < -4.267604, -1.462719, 2.779159>,
      < -4.308224, -1.433205, 2.779159>,
      < -4.319444, -1.451158, 2.756803>
    }
    triangle {
      < -4.267604, -1.462719, 2.779159>,
      < -4.319444, -1.451158, 2.756803>,
      < -4.281213, -1.478936, 2.756803>
    }
    triangle {
      < -4.271960, -1.355132, 2.764932>,
      < -4.308224, -1.433205, 2.779159>,
      < -4.260644, -1.387869, 2.768997>
    }
    triangle {
      < -4.253450, -1.323888, 2.663333>,
      < -4.271960, -1.355132, 2.764932>,
      < -4.260644, -1.387869, 2.768997>
    }
    triangle {
      < -4.253450, -1.323888, 2.663333>,
      < -4.260644, -1.387869, 2.768997>,
      < -4.241212, -1.359294, 2.663333>
    }
    triangle {
      < -4.136511, -1.306524, 2.663332>,
      < -4.200145, -1.260285, 2.663332>,
      < -4.253450, -1.323888, 2.663333>
    }
    triangle {
      < -4.136511, -1.306524, 2.663332>,
      < -4.253450, -1.323888, 2.663333>,
      < -4.180542, -1.376865, 2.663333>
    }
    triangle {
      < -4.131505, -1.300555, 2.744609>,
      < -4.196018, -1.253678, 2.744609>,
      < -4.200145, -1.260285, 2.663332>
    }
    triangle {
      < -4.131505, -1.300555, 2.744609>,
      < -4.200145, -1.260285, 2.663332>,
      < -4.136511, -1.306524, 2.663332>
    }
    triangle {
      < -4.090675, -1.251905, 2.736479>,
      < -4.162356, -1.199819, 2.736479>,
      < -4.196018, -1.253678, 2.744609>
    }
    triangle {
      < -4.090675, -1.251905, 2.736479>,
      < -4.196018, -1.253678, 2.744609>,
      < -4.131505, -1.300555, 2.744609>
    }
    triangle {
      < -4.090618, -1.251842, 2.633340>,
      < -4.162309, -1.199749, 2.633340>,
      < -4.162356, -1.199819, 2.736479>
    }
    triangle {
      < -4.090618, -1.251842, 2.633340>,
      < -4.162356, -1.199819, 2.736479>,
      < -4.090675, -1.251905, 2.736479>
    }
    triangle {
      < -4.437262, -1.639661, 2.842164>,
      < -4.451606, -1.632037, 2.842164>,
      < -4.454427, -1.638373, 2.828054>
    }
    triangle {
      < -4.437262, -1.639661, 2.842164>,
      < -4.454427, -1.638373, 2.828054>,
      < -4.440938, -1.645543, 2.828054>
    }
    triangle {
      < -4.381719, -1.550795, 2.813766>,
      < -4.408971, -1.536305, 2.813766>,
      < -4.451606, -1.632037, 2.842164>
    }
    triangle {
      < -4.381719, -1.550795, 2.813766>,
      < -4.451606, -1.632037, 2.842164>,
      < -4.437262, -1.639661, 2.842164>
    }
    triangle {
      < -4.326176, -1.461929, 2.769109>,
      < -4.366336, -1.440574, 2.769109>,
      < -4.408971, -1.536305, 2.813766>
    }
    triangle {
      < -4.326176, -1.461929, 2.769109>,
      < -4.408971, -1.536305, 2.813766>,
      < -4.381719, -1.550795, 2.813766>
    }
    triangle {
      < -4.319444, -1.451158, 2.756803>,
      < -4.361169, -1.428972, 2.756803>,
      < -4.366336, -1.440574, 2.769109>
    }
    triangle {
      < -4.319444, -1.451158, 2.756803>,
      < -4.366336, -1.440574, 2.769109>,
      < -4.326176, -1.461929, 2.769109>
    }
    triangle {
      < -4.308224, -1.433205, 2.779159>,
      < -4.352557, -1.409632, 2.779159>,
      < -4.361169, -1.428972, 2.756803>
    }
    triangle {
      < -4.308224, -1.433205, 2.779159>,
      < -4.361169, -1.428972, 2.756803>,
      < -4.319444, -1.451158, 2.756803>
    }
    triangle {
      < -4.271960, -1.355132, 2.764932>,
      < -4.318105, -1.332273, 2.764932>,
      < -4.352557, -1.409632, 2.779159>
    }
    triangle {
      < -4.271960, -1.355132, 2.764932>,
      < -4.352557, -1.409632, 2.779159>,
      < -4.308224, -1.433205, 2.779159>
    }
    triangle {
      < -4.253450, -1.323888, 2.663333>,
      < -4.303357, -1.299165, 2.663333>,
      < -4.318105, -1.332273, 2.764932>
    }
    triangle {
      < -4.253450, -1.323888, 2.663333>,
      < -4.318105, -1.332273, 2.764932>,
      < -4.271960, -1.355132, 2.764932>
    }
    triangle {
      < -4.200145, -1.260285, 2.663332>,
      < -4.269595, -1.223353, 2.663332>,
      < -4.303357, -1.299165, 2.663333>
    }
    triangle {
      < -4.200145, -1.260285, 2.663332>,
      < -4.303357, -1.299165, 2.663333>,
      < -4.253450, -1.323888, 2.663333>
    }
    triangle {
      < -4.196018, -1.253678, 2.744609>,
      < -4.266428, -1.216235, 2.744609>,
      < -4.269595, -1.223353, 2.663332>
    }
    triangle {
      < -4.196018, -1.253678, 2.744609>,
      < -4.269595, -1.223353, 2.663332>,
      < -4.200145, -1.260285, 2.663332>
    }
    triangle {
      < -4.162356, -1.199819, 2.736479>,
      < -4.240589, -1.158216, 2.736479>,
      < -4.266428, -1.216235, 2.744609>
    }
    triangle {
      < -4.162356, -1.199819, 2.736479>,
      < -4.266428, -1.216235, 2.744609>,
      < -4.196018, -1.253678, 2.744609>
    }
    triangle {
      < -4.162309, -1.199749, 2.633340>,
      < -4.240552, -1.158140, 2.633340>,
      < -4.240589, -1.158216, 2.736479>
    }
    triangle {
      < -4.162309, -1.199749, 2.633340>,
      < -4.240589, -1.158216, 2.736479>,
      < -4.162356, -1.199819, 2.736479>
    }
    triangle {
      < -4.451606, -1.632037, 2.842164>,
      < -4.466872, -1.626483, 2.842164>,
      < -4.468783, -1.633150, 2.828054>
    }
    triangle {
      < -4.451606, -1.632037, 2.842164>,
      < -4.468783, -1.633150, 2.828054>,
      < -4.454427, -1.638373, 2.828054>
    }
    triangle {
      < -4.408971, -1.536305, 2.813766>,
      < -4.437975, -1.525750, 2.813766>,
      < -4.466872, -1.626483, 2.842164>
    }
    triangle {
      < -4.408971, -1.536305, 2.813766>,
      < -4.466872, -1.626483, 2.842164>,
      < -4.451606, -1.632037, 2.842164>
    }
    triangle {
      < -4.366336, -1.440574, 2.769109>,
      < -4.409078, -1.425017, 2.769109>,
      < -4.437975, -1.525750, 2.813766>
    }
    triangle {
      < -4.366336, -1.440574, 2.769109>,
      < -4.437975, -1.525750, 2.813766>,
      < -4.408971, -1.536305, 2.813766>
    }
    triangle {
      < -4.361169, -1.428972, 2.756803>,
      < -4.405575, -1.412808, 2.756803>,
      < -4.409078, -1.425017, 2.769109>
    }
    triangle {
      < -4.361169, -1.428972, 2.756803>,
      < -4.409078, -1.425017, 2.769109>,
      < -4.366336, -1.440574, 2.769109>
    }
    triangle {
      < -4.352557, -1.409632, 2.779159>,
      < -4.399738, -1.392457, 2.779159>,
      < -4.405575, -1.412808, 2.756803>
    }
    triangle {
      < -4.352557, -1.409632, 2.779159>,
      < -4.405575, -1.412808, 2.756803>,
      < -4.361169, -1.428972, 2.756803>
    }
    triangle {
      < -4.318105, -1.332273, 2.764932>,
      < -4.365968, -1.313272, 2.764932>,
      < -4.399738, -1.392457, 2.779159>
    }
    triangle {
      < -4.318105, -1.332273, 2.764932>,
      < -4.399738, -1.392457, 2.779159>,
      < -4.352557, -1.409632, 2.779159>
    }
    triangle {
      < -4.303357, -1.299165, 2.663333>,
      < -4.355122, -1.278614, 2.663333>,
      < -4.365968, -1.313272, 2.764932>
    }
    triangle {
      < -4.303357, -1.299165, 2.663333>,
      < -4.365968, -1.313272, 2.764932>,
      < -4.318105, -1.332273, 2.764932>
    }
    triangle {
      < -4.269595, -1.223353, 2.663332>,
      < -4.343509, -1.196446, 2.663332>,
      < -4.355122, -1.278614, 2.663333>
    }
    triangle {
      < -4.269595, -1.223353, 2.663332>,
      < -4.355122, -1.278614, 2.663333>,
      < -4.303357, -1.299165, 2.663333>
    }
    triangle {
      < -4.266428, -1.216235, 2.744609>,
      < -4.341362, -1.188956, 2.744609>,
      < -4.343509, -1.196446, 2.663332>
    }
    triangle {
      < -4.266428, -1.216235, 2.744609>,
      < -4.343509, -1.196446, 2.663332>,
      < -4.269595, -1.223353, 2.663332>
    }
    triangle {
      < -4.240589, -1.158216, 2.736479>,
      < -4.323850, -1.127906, 2.736479>,
      < -4.341362, -1.188956, 2.744609>
    }
    triangle {
      < -4.240589, -1.158216, 2.736479>,
      < -4.341362, -1.188956, 2.744609>,
      < -4.266428, -1.216235, 2.744609>
    }
    triangle {
      < -4.240552, -1.158140, 2.633340>,
      < -4.323824, -1.127825, 2.633340>,
      < -4.323850, -1.127906, 2.736479>
    }
    triangle {
      < -4.240552, -1.158140, 2.633340>,
      < -4.323850, -1.127906, 2.736479>,
      < -4.240589, -1.158216, 2.736479>
    }
    triangle {
      < -4.466872, -1.626483, 2.842164>,
      < -4.482761, -1.623108, 2.842164>,
      < -4.483727, -1.629976, 2.828054>
    }
    triangle {
      < -4.466872, -1.626483, 2.842164>,
      < -4.483727, -1.629976, 2.828054>,
      < -4.468783, -1.633150, 2.828054>
    }
    triangle {
      < -4.437975, -1.525750, 2.813766>,
      < -4.468165, -1.519333, 2.813766>,
      < -4.482761, -1.623108, 2.842164>
    }
    triangle {
      < -4.437975, -1.525750, 2.813766>,
      < -4.482761, -1.623108, 2.842164>,
      < -4.466872, -1.626483, 2.842164>
    }
    triangle {
      < -4.409078, -1.425017, 2.769109>,
      < -4.453568, -1.415559, 2.769109>,
      < -4.468165, -1.519333, 2.813766>
    }
    triangle {
      < -4.409078, -1.425017, 2.769109>,
      < -4.468165, -1.519333, 2.813766>,
      < -4.437975, -1.525750, 2.813766>
    }
    triangle {
      < -4.405575, -1.412808, 2.756803>,
      < -4.451799, -1.402981, 2.756803>,
      < -4.453568, -1.415559, 2.769109>
    }
    triangle {
      < -4.405575, -1.412808, 2.756803>,
      < -4.453568, -1.415559, 2.769109>,
      < -4.409078, -1.425017, 2.769109>
    }
    triangle {
      < -4.399738, -1.392457, 2.779159>,
      < -4.448852, -1.382016, 2.779159>,
      < -4.451799, -1.402981, 2.756803>
    }
    triangle {
      < -4.399738, -1.392457, 2.779159>,
      < -4.451799, -1.402981, 2.756803>,
      < -4.405575, -1.412808, 2.756803>
    }
    triangle {
      < -4.447477, -1.295943, 2.764932>,
      < -4.448852, -1.382016, 2.779159>,
      < -4.423824, -1.321247, 2.768997>
    }
    triangle {
      < -4.443275, -1.259872, 2.663333>,
      < -4.447477, -1.295943, 2.764932>,
      < -4.423824, -1.321247, 2.768997>
    }
    triangle {
      < -4.443275, -1.259872, 2.663333>,
      < -4.423824, -1.321247, 2.768997>,
      < -4.417695, -1.287239, 2.663333>
    }
    triangle {
      < -4.343509, -1.196446, 2.663332>,
      < -4.420448, -1.180087, 2.663332>,
      < -4.443275, -1.259872, 2.663333>
    }
    triangle {
      < -4.343509, -1.196446, 2.663332>,
      < -4.443275, -1.259872, 2.663333>,
      < -4.355122, -1.278614, 2.663333>
    }
    triangle {
      < -4.341362, -1.188956, 2.744609>,
      < -4.419365, -1.172372, 2.744609>,
      < -4.420448, -1.180087, 2.663332>
    }
    triangle {
      < -4.341362, -1.188956, 2.744609>,
      < -4.420448, -1.180087, 2.663332>,
      < -4.343509, -1.196446, 2.663332>
    }
    triangle {
      < -4.323850, -1.127906, 2.736479>,
      < -4.410519, -1.109478, 2.736479>,
      < -4.419365, -1.172372, 2.744609>
    }
    triangle {
      < -4.323850, -1.127906, 2.736479>,
      < -4.419365, -1.172372, 2.744609>,
      < -4.341362, -1.188956, 2.744609>
    }
    triangle {
      < -4.323824, -1.127825, 2.633340>,
      < -4.410504, -1.109395, 2.633340>,
      < -4.410519, -1.109478, 2.736479>
    }
    triangle {
      < -4.323824, -1.127825, 2.633340>,
      < -4.410519, -1.109478, 2.736479>,
      < -4.323850, -1.127906, 2.736479>
    }
    triangle {
      < -4.482761, -1.623108, 2.842164>,
      < -4.498979, -1.628912, 2.828054>,
      < -4.483727, -1.629976, 2.828054>
    }
    triangle {
      < -4.468165, -1.519333, 2.813766>,
      < -4.484917, -1.518167, 2.813766>,
      < -4.482761, -1.623108, 2.842164>
    }
    triangle {
      < -4.468165, -1.519333, 2.813766>,
      < -4.453568, -1.415559, 2.769109>,
      < -4.491599, -1.413064, 2.769109>
    }
    triangle {
      < -4.468165, -1.519333, 2.813766>,
      < -4.491599, -1.413064, 2.769109>,
      < -4.484917, -1.518167, 2.813766>
    }
    triangle {
      < -4.453568, -1.415559, 2.769109>,
      < -4.451799, -1.402981, 2.756803>,
      < -4.498977, -1.399683, 2.756803>
    }
    triangle {
      < -4.453568, -1.415559, 2.769109>,
      < -4.498977, -1.399683, 2.756803>,
      < -4.491599, -1.413064, 2.769109>
    }
    triangle {
      < -4.448852, -1.382016, 2.779159>,
      < -4.498977, -1.378512, 2.779159>,
      < -4.498977, -1.399683, 2.756803>
    }
    triangle {
      < -4.448852, -1.382016, 2.779159>,
      < -4.498977, -1.399683, 2.756803>,
      < -4.451799, -1.402981, 2.756803>
    }
    triangle {
      < -4.447477, -1.295943, 2.764932>,
      < -4.498977, -1.293829, 2.764932>,
      < -4.498977, -1.378512, 2.779159>
    }
    triangle {
      < -4.447477, -1.295943, 2.764932>,
      < -4.498977, -1.378512, 2.779159>,
      < -4.448852, -1.382016, 2.779159>
    }
    triangle {
      < -4.443275, -1.259872, 2.663333>,
      < -4.498974, -1.257585, 2.663333>,
      < -4.498977, -1.293829, 2.764932>
    }
    triangle {
      < -4.443275, -1.259872, 2.663333>,
      < -4.498977, -1.293829, 2.764932>,
      < -4.447477, -1.295943, 2.764932>
    }
    triangle {
      < -4.420448, -1.180087, 2.663332>,
      < -4.498974, -1.174595, 2.663332>,
      < -4.498974, -1.257585, 2.663333>
    }
    triangle {
      < -4.420448, -1.180087, 2.663332>,
      < -4.498974, -1.257585, 2.663333>,
      < -4.443275, -1.259872, 2.663333>
    }
    triangle {
      < -4.419365, -1.172372, 2.744609>,
      < -4.498976, -1.166804, 2.744609>,
      < -4.498974, -1.174595, 2.663332>
    }
    triangle {
      < -4.419365, -1.172372, 2.744609>,
      < -4.498974, -1.174595, 2.663332>,
      < -4.420448, -1.180087, 2.663332>
    }
    triangle {
      < -4.410519, -1.109478, 2.736479>,
      < -4.498976, -1.103292, 2.736479>,
      < -4.498976, -1.166804, 2.744609>
    }
    triangle {
      < -4.410519, -1.109478, 2.736479>,
      < -4.498976, -1.166804, 2.744609>,
      < -4.419365, -1.172372, 2.744609>
    }
    triangle {
      < -4.410504, -1.109395, 2.633340>,
      < -4.498973, -1.103207, 2.633340>,
      < -4.498976, -1.103292, 2.736479>
    }
    triangle {
      < -4.410504, -1.109395, 2.633340>,
      < -4.498976, -1.103292, 2.736479>,
      < -4.410519, -1.109478, 2.736479>
    }
    triangle {
      < -4.491599, -1.413064, 2.769109>,
      < -4.498977, -1.399683, 2.756803>,
      < -4.498978, -1.514298, 2.792428>
    }
    triangle {
      < -4.491599, -1.413064, 2.769109>,
      < -4.498978, -1.514298, 2.792428>,
      < -4.484917, -1.518167, 2.813766>
    }
    triangle {
      < -4.205600, -1.907782, 2.756803>,
      < -4.213502, -1.894709, 2.769109>,
      < -4.301181, -1.836364, 2.813766>
    }
    triangle {
      < -4.205600, -1.907782, 2.756803>,
      < -4.301181, -1.836364, 2.813766>,
      < -4.304855, -1.850467, 2.792428>
    }
    triangle {
      < -4.220871, -1.907472, 2.769109>,
      < -4.205600, -1.907782, 2.756803>,
      < -4.304855, -1.850467, 2.792428>
    }
    triangle {
      < -4.220871, -1.907472, 2.769109>,
      < -4.304855, -1.850467, 2.792428>,
      < -4.315229, -1.860699, 2.813766>
    }
    triangle {
      < -4.784394, -1.894722, 2.769109>,
      < -4.792297, -1.907794, 2.756803>,
      < -4.693035, -1.850491, 2.792428>
    }
    triangle {
      < -4.784394, -1.894722, 2.769109>,
      < -4.693035, -1.850491, 2.792428>,
      < -4.696710, -1.836390, 2.813766>
    }
    triangle {
      < -4.546118, -1.402983, 2.756803>,
      < -4.544351, -1.415561, 2.769109>,
      < -4.506346, -1.413064, 2.769109>
    }
    triangle {
      < -4.546118, -1.402983, 2.756803>,
      < -4.506346, -1.413064, 2.769109>,
      < -4.498977, -1.399683, 2.756803>
    }
    triangle {
      < -4.792297, -1.907794, 2.756803>,
      < -4.777024, -1.907486, 2.769109>,
      < -4.682658, -1.860723, 2.813766>
    }
    triangle {
      < -4.792297, -1.907794, 2.756803>,
      < -4.682658, -1.860723, 2.813766>,
      < -4.693035, -1.850491, 2.792428>
    }
    triangle {
      < -4.498979, -1.628912, 2.828054>,
      < -4.482761, -1.623108, 2.842164>,
      < -4.484917, -1.518167, 2.813766>
    }
    triangle {
      < -4.498979, -1.628912, 2.828054>,
      < -4.484917, -1.518167, 2.813766>,
      < -4.498978, -1.514298, 2.792428>
    }
    triangle {
      < -4.515183, -1.623114, 2.842164>,
      < -4.498979, -1.628912, 2.828054>,
      < -4.498978, -1.514298, 2.792428>
    }
    triangle {
      < -4.515183, -1.623114, 2.842164>,
      < -4.498978, -1.514298, 2.792428>,
      < -4.513028, -1.518169, 2.813766>
    }
    triangle {
      < -4.593773, -1.793188, 2.828054>,
      < -4.606904, -1.782057, 2.842164>,
      < -4.696710, -1.836390, 2.813766>
    }
    triangle {
      < -4.593773, -1.793188, 2.828054>,
      < -4.696710, -1.836390, 2.813766>,
      < -4.693035, -1.850491, 2.792428>
    }
    triangle {
      < -4.590693, -1.810121, 2.842164>,
      < -4.593773, -1.793188, 2.828054>,
      < -4.693035, -1.850491, 2.792428>
    }
    triangle {
      < -4.590693, -1.810121, 2.842164>,
      < -4.693035, -1.850491, 2.792428>,
      < -4.682658, -1.860723, 2.813766>
    }
    triangle {
      < -4.404109, -1.793151, 2.828054>,
      < -4.407185, -1.810088, 2.842164>,
      < -4.315229, -1.860699, 2.813766>
    }
    triangle {
      < -4.404109, -1.793151, 2.828054>,
      < -4.315229, -1.860699, 2.813766>,
      < -4.304855, -1.850467, 2.792428>
    }
    triangle {
      < -4.390984, -1.782018, 2.842164>,
      < -4.404109, -1.793151, 2.828054>,
      < -4.304855, -1.850467, 2.792428>
    }
    triangle {
      < -4.390984, -1.782018, 2.842164>,
      < -4.304855, -1.850467, 2.792428>,
      < -4.301181, -1.836364, 2.813766>
    }
    triangle {
      < -4.399738, -1.392457, 2.779159>,
      < -4.397869, -1.326766, 2.768997>,
      < -4.423824, -1.321247, 2.768997>
    }
    triangle {
      < -4.399738, -1.392457, 2.779159>,
      < -4.423824, -1.321247, 2.768997>,
      < -4.448852, -1.382016, 2.779159>
    }
    triangle {
      < -4.365968, -1.313272, 2.764932>,
      < -4.397869, -1.326766, 2.768997>,
      < -4.399738, -1.392457, 2.779159>
    }
    triangle {
      < -4.397869, -1.326766, 2.768997>,
      < -4.389624, -1.293207, 2.663333>,
      < -4.417695, -1.287239, 2.663333>
    }
    triangle {
      < -4.397869, -1.326766, 2.768997>,
      < -4.417695, -1.287239, 2.663333>,
      < -4.423824, -1.321247, 2.768997>
    }
    triangle {
      < -4.365968, -1.313272, 2.764932>,
      < -4.355122, -1.278614, 2.663333>,
      < -4.389624, -1.293207, 2.663333>
    }
    triangle {
      < -4.365968, -1.313272, 2.764932>,
      < -4.389624, -1.293207, 2.663333>,
      < -4.397869, -1.326766, 2.768997>
    }
    triangle {
      < -4.204546, -1.404115, 2.764932>,
      < -4.180542, -1.376865, 2.663333>,
      < -4.217996, -1.376163, 2.663333>
    }
    triangle {
      < -4.204546, -1.404115, 2.764932>,
      < -4.217996, -1.376163, 2.663333>,
      < -4.239177, -1.403467, 2.768997>
    }
    triangle {
      < -4.239177, -1.403467, 2.768997>,
      < -4.217996, -1.376163, 2.663333>,
      < -4.241212, -1.359294, 2.663333>
    }
    triangle {
      < -4.239177, -1.403467, 2.768997>,
      < -4.241212, -1.359294, 2.663333>,
      < -4.260644, -1.387869, 2.768997>
    }
    triangle {
      < -4.267604, -1.462719, 2.779159>,
      < -4.239177, -1.403467, 2.768997>,
      < -4.260644, -1.387869, 2.768997>
    }
    triangle {
      < -4.267604, -1.462719, 2.779159>,
      < -4.260644, -1.387869, 2.768997>,
      < -4.308224, -1.433205, 2.779159>
    }
    triangle {
      < -4.204546, -1.404115, 2.764932>,
      < -4.239177, -1.403467, 2.768997>,
      < -4.267604, -1.462719, 2.779159>
    }
    triangle {
      < -4.175470, -1.580650, 2.779159>,
      < -4.125401, -1.538082, 2.768997>,
      < -4.138668, -1.515102, 2.768997>
    }
    triangle {
      < -4.175470, -1.580650, 2.779159>,
      < -4.138668, -1.515102, 2.768997>,
      < -4.200574, -1.537166, 2.779159>
    }
    triangle {
      < -4.094028, -1.552760, 2.764932>,
      < -4.125401, -1.538082, 2.768997>,
      < -4.175470, -1.580650, 2.779159>
    }
    triangle {
      < -4.125401, -1.538082, 2.768997>,
      < -4.094946, -1.521754, 2.663333>,
      < -4.109294, -1.496900, 2.663333>
    }
    triangle {
      < -4.125401, -1.538082, 2.768997>,
      < -4.109294, -1.496900, 2.663333>,
      < -4.138668, -1.515102, 2.768997>
    }
    triangle {
      < -4.094028, -1.552760, 2.764932>,
      < -4.061015, -1.537629, 2.663333>,
      < -4.094946, -1.521754, 2.663333>
    }
    triangle {
      < -4.094028, -1.552760, 2.764932>,
      < -4.094946, -1.521754, 2.663333>,
      < -4.125401, -1.538082, 2.768997>
    }
    triangle {
      < -4.053522, -1.733505, 2.764932>,
      < -4.017209, -1.733109, 2.663333>,
      < -4.041750, -1.704806, 2.663333>
    }
    triangle {
      < -4.053522, -1.733505, 2.764932>,
      < -4.041750, -1.704806, 2.663333>,
      < -4.076213, -1.707335, 2.768997>
    }
    triangle {
      < -4.076213, -1.707335, 2.768997>,
      < -4.041750, -1.704806, 2.663333>,
      < -4.044749, -1.676265, 2.663333>
    }
    triangle {
      < -4.076213, -1.707335, 2.768997>,
      < -4.044749, -1.676265, 2.663333>,
      < -4.078987, -1.680946, 2.768997>
    }
    triangle {
      < -4.053522, -1.733505, 2.764932>,
      < -4.076213, -1.707335, 2.768997>,
      < -4.139267, -1.725859, 2.779159>
    }
    triangle {
      < -4.139267, -1.725859, 2.779159>,
      < -4.076213, -1.707335, 2.768997>,
      < -4.078987, -1.680946, 2.768997>
    }
    triangle {
      < -4.139267, -1.725859, 2.779159>,
      < -4.078987, -1.680946, 2.768997>,
      < -4.144515, -1.675924, 2.779159>
    }
    triangle {
      < -4.165255, -1.873239, 2.779159>,
      < -4.100119, -1.881963, 2.768997>,
      < -4.091918, -1.856727, 2.768997>
    }
    triangle {
      < -4.165255, -1.873239, 2.779159>,
      < -4.091918, -1.856727, 2.768997>,
      < -4.149739, -1.825486, 2.779159>
    }
    triangle {
      < -4.090033, -1.915100, 2.764932>,
      < -4.100119, -1.881963, 2.768997>,
      < -4.165255, -1.873239, 2.779159>
    }
    triangle {
      < -4.100119, -1.881963, 2.768997>,
      < -4.067605, -1.893670, 2.663333>,
      < -4.058736, -1.866377, 2.663333>
    }
    triangle {
      < -4.100119, -1.881963, 2.768997>,
      < -4.058736, -1.866377, 2.663333>,
      < -4.091918, -1.856727, 2.768997>
    }
    triangle {
      < -4.090033, -1.915100, 2.764932>,
      < -4.056698, -1.929508, 2.663333>,
      < -4.067605, -1.893670, 2.663333>
    }
    triangle {
      < -4.090033, -1.915100, 2.764932>,
      < -4.067605, -1.893670, 2.663333>,
      < -4.100119, -1.881963, 2.768997>
    }
    triangle {
      < -4.197247, -2.066145, 2.764932>,
      < -4.192983, -2.031771, 2.768997>,
      < -4.248940, -1.997308, 2.779159>
    }
    triangle {
      < -4.248940, -1.997308, 2.779159>,
      < -4.192983, -2.031771, 2.768997>,
      < -4.175228, -2.012052, 2.768997>
    }
    triangle {
      < -4.248940, -1.997308, 2.779159>,
      < -4.175228, -2.012052, 2.768997>,
      < -4.215343, -1.959994, 2.779159>
    }
    triangle {
      < -4.192983, -2.031771, 2.768997>,
      < -4.168042, -2.055689, 2.663333>,
      < -4.148839, -2.034363, 2.663333>
    }
    triangle {
      < -4.192983, -2.031771, 2.768997>,
      < -4.148839, -2.034363, 2.663333>,
      < -4.175228, -2.012052, 2.768997>
    }
    triangle {
      < -4.197247, -2.066145, 2.764932>,
      < -4.172654, -2.092865, 2.663333>,
      < -4.168042, -2.055689, 2.663333>
    }
    triangle {
      < -4.197247, -2.066145, 2.764932>,
      < -4.168042, -2.055689, 2.663333>,
      < -4.192983, -2.031771, 2.768997>
    }
    triangle {
      < -4.338751, -2.130857, 2.768997>,
      < -4.325695, -2.162851, 2.663333>,
      < -4.299478, -2.151179, 2.663333>
    }
    triangle {
      < -4.338751, -2.130857, 2.768997>,
      < -4.299478, -2.151179, 2.663333>,
      < -4.314510, -2.120064, 2.768997>
    }
    triangle {
      < -4.356627, -2.160525, 2.764932>,
      < -4.345028, -2.194938, 2.663333>,
      < -4.325695, -2.162851, 2.663333>
    }
    triangle {
      < -4.356627, -2.160525, 2.764932>,
      < -4.325695, -2.162851, 2.663333>,
      < -4.338751, -2.130857, 2.768997>
    }
    triangle {
      < -4.375854, -2.076614, 2.779159>,
      < -4.338751, -2.130857, 2.768997>,
      < -4.314510, -2.120064, 2.768997>
    }
    triangle {
      < -4.375854, -2.076614, 2.779159>,
      < -4.314510, -2.120064, 2.768997>,
      < -4.329984, -2.056191, 2.779159>
    }
    triangle {
      < -4.356627, -2.160525, 2.764932>,
      < -4.338751, -2.130857, 2.768997>,
      < -4.375854, -2.076614, 2.779159>
    }
    triangle {
      < -4.524051, -2.097444, 2.779159>,
      < -4.512218, -2.162088, 2.768997>,
      < -4.485683, -2.162088, 2.768997>
    }
    triangle {
      < -4.524051, -2.097444, 2.779159>,
      < -4.485683, -2.162088, 2.768997>,
      < -4.473840, -2.097443, 2.779159>
    }
    triangle {
      < -4.540616, -2.181921, 2.764932>,
      < -4.512218, -2.162088, 2.768997>,
      < -4.524051, -2.097444, 2.779159>
    }
    triangle {
      < -4.540616, -2.181921, 2.764932>,
      < -4.544017, -2.218076, 2.663333>,
      < -4.513304, -2.196627, 2.663333>
    }
    triangle {
      < -4.540616, -2.181921, 2.764932>,
      < -4.513304, -2.196627, 2.663333>,
      < -4.512218, -2.162088, 2.768997>
    }
    triangle {
      < -4.512218, -2.162088, 2.768997>,
      < -4.513304, -2.196627, 2.663333>,
      < -4.484606, -2.196627, 2.663333>
    }
    triangle {
      < -4.512218, -2.162088, 2.768997>,
      < -4.484606, -2.196627, 2.663333>,
      < -4.485683, -2.162088, 2.768997>
    }
    triangle {
      < -4.683391, -2.120065, 2.768997>,
      < -4.698431, -2.151177, 2.663333>,
      < -4.672215, -2.162849, 2.663333>
    }
    triangle {
      < -4.683391, -2.120065, 2.768997>,
      < -4.672215, -2.162849, 2.663333>,
      < -4.659151, -2.130858, 2.768997>
    }
    triangle {
      < -4.717400, -2.126633, 2.764932>,
      < -4.735213, -2.158279, 2.663333>,
      < -4.698431, -2.151177, 2.663333>
    }
    triangle {
      < -4.717400, -2.126633, 2.764932>,
      < -4.698431, -2.151177, 2.663333>,
      < -4.683391, -2.120065, 2.768997>
    }
    triangle {
      < -4.667908, -2.056197, 2.779159>,
      < -4.683391, -2.120065, 2.768997>,
      < -4.659151, -2.130858, 2.768997>
    }
    triangle {
      < -4.667908, -2.056197, 2.779159>,
      < -4.659151, -2.130858, 2.768997>,
      < -4.622038, -2.076618, 2.779159>
    }
    triangle {
      < -4.717400, -2.126633, 2.764932>,
      < -4.683391, -2.120065, 2.768997>,
      < -4.667908, -2.056197, 2.779159>
    }
    triangle {
      < -4.856414, -2.004221, 2.764932>,
      < -4.885559, -2.025887, 2.663333>,
      < -4.849068, -2.034359, 2.663333>
    }
    triangle {
      < -4.856414, -2.004221, 2.764932>,
      < -4.849068, -2.034359, 2.663333>,
      < -4.822674, -2.012054, 2.768997>
    }
    triangle {
      < -4.822674, -2.012054, 2.768997>,
      < -4.849068, -2.034359, 2.663333>,
      < -4.829865, -2.055685, 2.663333>
    }
    triangle {
      < -4.822674, -2.012054, 2.768997>,
      < -4.829865, -2.055685, 2.663333>,
      < -4.804919, -2.031773, 2.768997>
    }
    triangle {
      < -4.856414, -2.004221, 2.764932>,
      < -4.822674, -2.012054, 2.768997>,
      < -4.782553, -1.960004, 2.779159>
    }
    triangle {
      < -4.782553, -1.960004, 2.779159>,
      < -4.822674, -2.012054, 2.768997>,
      < -4.804919, -2.031773, 2.768997>
    }
    triangle {
      < -4.782553, -1.960004, 2.779159>,
      < -4.804919, -2.031773, 2.768997>,
      < -4.748954, -1.997317, 2.779159>
    }
    triangle {
      < -4.933622, -1.835851, 2.764932>,
      < -4.905985, -1.856730, 2.768997>,
      < -4.848162, -1.825499, 2.779159>
    }
    triangle {
      < -4.848162, -1.825499, 2.779159>,
      < -4.905985, -1.856730, 2.768997>,
      < -4.897785, -1.881966, 2.768997>
    }
    triangle {
      < -4.848162, -1.825499, 2.779159>,
      < -4.897785, -1.881966, 2.768997>,
      < -4.832644, -1.873251, 2.779159>
    }
    triangle {
      < -4.933622, -1.835851, 2.764932>,
      < -4.969059, -1.843790, 2.663333>,
      < -4.939169, -1.866371, 2.663333>
    }
    triangle {
      < -4.933622, -1.835851, 2.764932>,
      < -4.939169, -1.866371, 2.663333>,
      < -4.905985, -1.856730, 2.768997>
    }
    triangle {
      < -4.905985, -1.856730, 2.768997>,
      < -4.939169, -1.866371, 2.663333>,
      < -4.930300, -1.893664, 2.663333>
    }
    triangle {
      < -4.905985, -1.856730, 2.768997>,
      < -4.930300, -1.893664, 2.663333>,
      < -4.897785, -1.881966, 2.768997>
    }
    triangle {
      < -4.853391, -1.675936, 2.779159>,
      < -4.918918, -1.680949, 2.768997>,
      < -4.921691, -1.707338, 2.768997>
    }
    triangle {
      < -4.853391, -1.675936, 2.779159>,
      < -4.921691, -1.707338, 2.768997>,
      < -4.858637, -1.725872, 2.779159>
    }
    triangle {
      < -4.935674, -1.650634, 2.764932>,
      < -4.918918, -1.680949, 2.768997>,
      < -4.853391, -1.675936, 2.779159>
    }
    triangle {
      < -4.918918, -1.680949, 2.768997>,
      < -4.953155, -1.676260, 2.663333>,
      < -4.956154, -1.704800, 2.663333>
    }
    triangle {
      < -4.918918, -1.680949, 2.768997>,
      < -4.956154, -1.704800, 2.663333>,
      < -4.921691, -1.707338, 2.768997>
    }
    triangle {
      < -4.935674, -1.650634, 2.764932>,
      < -4.971276, -1.643473, 2.663333>,
      < -4.953155, -1.676260, 2.663333>
    }
    triangle {
      < -4.935674, -1.650634, 2.764932>,
      < -4.953155, -1.676260, 2.663333>,
      < -4.918918, -1.680949, 2.768997>
    }
    triangle {
      < -4.862215, -1.480595, 2.764932>,
      < -4.891827, -1.459573, 2.663333>,
      < -4.888607, -1.496895, 2.663333>
    }
    triangle {
      < -4.862215, -1.480595, 2.764932>,
      < -4.888607, -1.496895, 2.663333>,
      < -4.859238, -1.515104, 2.768997>
    }
    triangle {
      < -4.859238, -1.515104, 2.768997>,
      < -4.888607, -1.496895, 2.663333>,
      < -4.902955, -1.521749, 2.663333>
    }
    triangle {
      < -4.859238, -1.515104, 2.768997>,
      < -4.902955, -1.521749, 2.663333>,
      < -4.872504, -1.538084, 2.768997>
    }
    triangle {
      < -4.862215, -1.480595, 2.764932>,
      < -4.859238, -1.515104, 2.768997>,
      < -4.797337, -1.537177, 2.779159>
    }
    triangle {
      < -4.797337, -1.537177, 2.779159>,
      < -4.859238, -1.515104, 2.768997>,
      < -4.872504, -1.538084, 2.768997>
    }
    triangle {
      < -4.797337, -1.537177, 2.779159>,
      < -4.872504, -1.538084, 2.768997>,
      < -4.822440, -1.580661, 2.779159>
    }
    triangle {
      < -4.725947, -1.355134, 2.764932>,
      < -4.737262, -1.387871, 2.768997>,
      < -4.689691, -1.433212, 2.779159>
    }
    triangle {
      < -4.689691, -1.433212, 2.779159>,
      < -4.737262, -1.387871, 2.768997>,
      < -4.758729, -1.403468, 2.768997>
    }
    triangle {
      < -4.689691, -1.433212, 2.779159>,
      < -4.758729, -1.403468, 2.768997>,
      < -4.730310, -1.462727, 2.779159>
    }
    triangle {
      < -4.725947, -1.355134, 2.764932>,
      < -4.744448, -1.323885, 2.663333>,
      < -4.756687, -1.359290, 2.663333>
    }
    triangle {
      < -4.725947, -1.355134, 2.764932>,
      < -4.756687, -1.359290, 2.663333>,
      < -4.737262, -1.387871, 2.768997>
    }
    triangle {
      < -4.737262, -1.387871, 2.768997>,
      < -4.756687, -1.359290, 2.663333>,
      < -4.779903, -1.376160, 2.663333>
    }
    triangle {
      < -4.737262, -1.387871, 2.768997>,
      < -4.779903, -1.376160, 2.663333>,
      < -4.758729, -1.403468, 2.768997>
    }
    triangle {
      < -4.549065, -1.382018, 2.779159>,
      < -4.574083, -1.321248, 2.768997>,
      < -4.600038, -1.326766, 2.768997>
    }
    triangle {
      < -4.549065, -1.382018, 2.779159>,
      < -4.600038, -1.326766, 2.768997>,
      < -4.598177, -1.392461, 2.779159>
    }
    triangle {
      < -4.550430, -1.295944, 2.764932>,
      < -4.574083, -1.321248, 2.768997>,
      < -4.549065, -1.382018, 2.779159>
    }
    triangle {
      < -4.550430, -1.295944, 2.764932>,
      < -4.554622, -1.259871, 2.663333>,
      < -4.580204, -1.287238, 2.663333>
    }
    triangle {
      < -4.550430, -1.295944, 2.764932>,
      < -4.580204, -1.287238, 2.663333>,
      < -4.574083, -1.321248, 2.768997>
    }
    triangle {
      < -4.574083, -1.321248, 2.768997>,
      < -4.580204, -1.287238, 2.663333>,
      < -4.608274, -1.293206, 2.663333>
    }
    triangle {
      < -4.574083, -1.321248, 2.768997>,
      < -4.608274, -1.293206, 2.663333>,
      < -4.600038, -1.326766, 2.768997>
    }
    triangle {
      < -4.829865, -2.055685, 2.663333>,
      < -4.849068, -2.034359, 2.663333>,
      < -4.885559, -2.025887, 2.663333>
    }
    triangle {
      < -4.829865, -2.055685, 2.663333>,
      < -4.885559, -2.025887, 2.663333>,
      < -4.825254, -2.092861, 2.663333>
    }
    triangle {
      < -4.672215, -2.162849, 2.663333>,
      < -4.698431, -2.151177, 2.663333>,
      < -4.735213, -2.158279, 2.663333>
    }
    triangle {
      < -4.672215, -2.162849, 2.663333>,
      < -4.735213, -2.158279, 2.663333>,
      < -4.652881, -2.194936, 2.663333>
    }
    triangle {
      < -4.484606, -2.196627, 2.663333>,
      < -4.513304, -2.196627, 2.663333>,
      < -4.544017, -2.218076, 2.663333>
    }
    triangle {
      < -4.484606, -2.196627, 2.663333>,
      < -4.544017, -2.218076, 2.663333>,
      < -4.453893, -2.218077, 2.663333>
    }
    triangle {
      < -4.299478, -2.151179, 2.663333>,
      < -4.325695, -2.162851, 2.663333>,
      < -4.345028, -2.194938, 2.663333>
    }
    triangle {
      < -4.299478, -2.151179, 2.663333>,
      < -4.345028, -2.194938, 2.663333>,
      < -4.262696, -2.158282, 2.663333>
    }
    triangle {
      < -4.148839, -2.034363, 2.663333>,
      < -4.168042, -2.055689, 2.663333>,
      < -4.172654, -2.092865, 2.663333>
    }
    triangle {
      < -4.148839, -2.034363, 2.663333>,
      < -4.172654, -2.092865, 2.663333>,
      < -4.112349, -2.025892, 2.663333>
    }
    triangle {
      < -4.058736, -1.866377, 2.663333>,
      < -4.067605, -1.893670, 2.663333>,
      < -4.056698, -1.929508, 2.663333>
    }
    triangle {
      < -4.058736, -1.866377, 2.663333>,
      < -4.056698, -1.929508, 2.663333>,
      < -4.028846, -1.843796, 2.663333>
    }
    triangle {
      < -4.044749, -1.676265, 2.663333>,
      < -4.041750, -1.704806, 2.663333>,
      < -4.017209, -1.733109, 2.663333>
    }
    triangle {
      < -4.044749, -1.676265, 2.663333>,
      < -4.017209, -1.733109, 2.663333>,
      < -4.026626, -1.643479, 2.663333>
    }
    triangle {
      < -4.109294, -1.496900, 2.663333>,
      < -4.094946, -1.521754, 2.663333>,
      < -4.061015, -1.537629, 2.663333>
    }
    triangle {
      < -4.109294, -1.496900, 2.663333>,
      < -4.061015, -1.537629, 2.663333>,
      < -4.106073, -1.459577, 2.663333>
    }
    triangle {
      < -4.241212, -1.359294, 2.663333>,
      < -4.217996, -1.376163, 2.663333>,
      < -4.180542, -1.376865, 2.663333>
    }
    triangle {
      < -4.241212, -1.359294, 2.663333>,
      < -4.180542, -1.376865, 2.663333>,
      < -4.253450, -1.323888, 2.663333>
    }
    triangle {
      < -4.417695, -1.287239, 2.663333>,
      < -4.389624, -1.293207, 2.663333>,
      < -4.355122, -1.278614, 2.663333>
    }
    triangle {
      < -4.417695, -1.287239, 2.663333>,
      < -4.355122, -1.278614, 2.663333>,
      < -4.443275, -1.259872, 2.663333>
    }
    triangle {
      < -5.046024, -1.874822, 2.663332>,
      < -5.021717, -1.949631, 2.663332>,
      < -4.941208, -1.929502, 2.663333>
    }
    triangle {
      < -5.046024, -1.874822, 2.663332>,
      < -4.941208, -1.929502, 2.663333>,
      < -4.969059, -1.843790, 2.663333>
    }
    triangle {
      < -5.054209, -1.640519, 2.663332>,
      < -5.062430, -1.718747, 2.663332>,
      < -4.980695, -1.733103, 2.663333>
    }
    triangle {
      < -5.054209, -1.640519, 2.663332>,
      < -4.980695, -1.733103, 2.663333>,
      < -4.971276, -1.643473, 2.663333>
    }
    triangle {
      < -4.966388, -1.423142, 2.663332>,
      < -5.005716, -1.491264, 2.663332>,
      < -4.936887, -1.537623, 2.663333>
    }
    triangle {
      < -4.966388, -1.423142, 2.663332>,
      < -4.936887, -1.537623, 2.663333>,
      < -4.891827, -1.459573, 2.663333>
    }
    triangle {
      < -4.797746, -1.260278, 2.663332>,
      < -4.861381, -1.306514, 2.663332>,
      < -4.817358, -1.376861, 2.663333>
    }
    triangle {
      < -4.797746, -1.260278, 2.663332>,
      < -4.817358, -1.376861, 2.663333>,
      < -4.744448, -1.323885, 2.663333>
    }
    triangle {
      < -4.577441, -1.180085, 2.663332>,
      < -4.654381, -1.196442, 2.663332>,
      < -4.642776, -1.278613, 2.663333>
    }
    triangle {
      < -4.577441, -1.180085, 2.663332>,
      < -4.642776, -1.278613, 2.663333>,
      < -4.554622, -1.259871, 2.663333>
    }
    triangle {
      < -4.498962, -1.718909, 2.852781>,
      < -4.498971, -1.670327, 2.844015>,
      < -4.514230, -1.670987, 2.843713>
    }
    triangle {
      < -4.498962, -1.718909, 2.852781>,
      < -4.514230, -1.670987, 2.843713>,
      < -4.513682, -1.718945, 2.852345>
    }
    triangle {
      < -4.528247, -1.719049, 2.851049>,
      < -4.529215, -1.672935, 2.842822>,
      < -4.537259, -1.673463, 2.841802>
    }
    triangle {
      < -4.528247, -1.719049, 2.851049>,
      < -4.513682, -1.718945, 2.852345>,
      < -4.514230, -1.670987, 2.843713>
    }
    triangle {
      < -4.528247, -1.719049, 2.851049>,
      < -4.514230, -1.670987, 2.843713>,
      < -4.529215, -1.672935, 2.842822>
    }
    triangle {
      < -4.498962, -1.718909, 2.852781>,
      < -4.484243, -1.718942, 2.852345>,
      < -4.483706, -1.670982, 2.843714>
    }
    triangle {
      < -4.498962, -1.718909, 2.852781>,
      < -4.483706, -1.670982, 2.843714>,
      < -4.498971, -1.670327, 2.844015>
    }
    triangle {
      < -4.484243, -1.718942, 2.852345>,
      < -4.469678, -1.719043, 2.851051>,
      < -4.468720, -1.672926, 2.842824>
    }
    triangle {
      < -4.484243, -1.718942, 2.852345>,
      < -4.468720, -1.672926, 2.842824>,
      < -4.483706, -1.670982, 2.843714>
    }
    triangle {
      < -4.469678, -1.719043, 2.851051>,
      < -4.460676, -1.673450, 2.841804>,
      < -4.468720, -1.672926, 2.842824>
    }
    triangle {
      < -4.469678, -1.719043, 2.851051>,
      < -4.455413, -1.719208, 2.848939>,
      < -4.446811, -1.677655, 2.840264>
    }
    triangle {
      < -4.469678, -1.719043, 2.851051>,
      < -4.446811, -1.677655, 2.840264>,
      < -4.460676, -1.673450, 2.841804>
    }
    triangle {
      < -4.455413, -1.719208, 2.848939>,
      < -4.443026, -1.708975, 2.845357>,
      < -4.435079, -1.680317, 2.838027>
    }
    triangle {
      < -4.455413, -1.719208, 2.848939>,
      < -4.435079, -1.680317, 2.838027>,
      < -4.446811, -1.677655, 2.840264>
    }
    triangle {
      < -4.443026, -1.708975, 2.845357>,
      < -4.428818, -1.709425, 2.841648>,
      < -4.422682, -1.686381, 2.835714>
    }
    triangle {
      < -4.443026, -1.708975, 2.845357>,
      < -4.422682, -1.686381, 2.835714>,
      < -4.435079, -1.680317, 2.838027>
    }
    triangle {
      < -4.428818, -1.709425, 2.841648>,
      < -4.415323, -1.709956, 2.837276>,
      < -4.417920, -1.692665, 2.835422>
    }
    triangle {
      < -4.415568, -1.728363, 2.838889>,
      < -4.391115, -1.719384, 2.828054>,
      < -4.421799, -1.720634, 2.840566>
    }
    triangle {
      < -4.412143, -1.735762, 2.837839>,
      < -4.412785, -1.738668, 2.838093>,
      < -4.400762, -1.736575, 2.833268>
    }
    triangle {
      < -4.412143, -1.735762, 2.837839>,
      < -4.400762, -1.736575, 2.833268>,
      < -4.391115, -1.719384, 2.828054>
    }
    triangle {
      < -4.412785, -1.738668, 2.838093>,
      < -4.414826, -1.741768, 2.838815>,
      < -4.401987, -1.745914, 2.833677>
    }
    triangle {
      < -4.412785, -1.738668, 2.838093>,
      < -4.401987, -1.745914, 2.833677>,
      < -4.400762, -1.736575, 2.833268>
    }
    triangle {
      < -4.414826, -1.741768, 2.838815>,
      < -4.418086, -1.744261, 2.839917>,
      < -4.404830, -1.754884, 2.834395>
    }
    triangle {
      < -4.414826, -1.741768, 2.838815>,
      < -4.404830, -1.754884, 2.834395>,
      < -4.401987, -1.745914, 2.833677>
    }
    triangle {
      < -4.418086, -1.744261, 2.839917>,
      < -4.422791, -1.747297, 2.841394>,
      < -4.409395, -1.763922, 2.835397>
    }
    triangle {
      < -4.418086, -1.744261, 2.839917>,
      < -4.409395, -1.763922, 2.835397>,
      < -4.404830, -1.754884, 2.834395>
    }
    triangle {
      < -4.422791, -1.747297, 2.841394>,
      < -4.428440, -1.750271, 2.843014>,
      < -4.415427, -1.772594, 2.836540>
    }
    triangle {
      < -4.422791, -1.747297, 2.841394>,
      < -4.415427, -1.772594, 2.836540>,
      < -4.409395, -1.763922, 2.835397>
    }
    triangle {
      < -4.428440, -1.750271, 2.843014>,
      < -4.435215, -1.753411, 2.844747>,
      < -4.422977, -1.780868, 2.837771>
    }
    triangle {
      < -4.428440, -1.750271, 2.843014>,
      < -4.422977, -1.780868, 2.837771>,
      < -4.415427, -1.772594, 2.836540>
    }
    triangle {
      < -4.435215, -1.753411, 2.844747>,
      < -4.443049, -1.757434, 2.846415>,
      < -4.431971, -1.788932, 2.838923>
    }
    triangle {
      < -4.435215, -1.753411, 2.844747>,
      < -4.431971, -1.788932, 2.838923>,
      < -4.422977, -1.780868, 2.837771>
    }
    triangle {
      < -4.443049, -1.757434, 2.846415>,
      < -4.451542, -1.760986, 2.847925>,
      < -4.442109, -1.795994, 2.839975>
    }
    triangle {
      < -4.443049, -1.757434, 2.846415>,
      < -4.442109, -1.795994, 2.839975>,
      < -4.431971, -1.788932, 2.838923>
    }
    triangle {
      < -4.451542, -1.760986, 2.847925>,
      < -4.461042, -1.763883, 2.849307>,
      < -4.453445, -1.801850, 2.840937>
    }
    triangle {
      < -4.451542, -1.760986, 2.847925>,
      < -4.453445, -1.801850, 2.840937>,
      < -4.442109, -1.795994, 2.839975>
    }
    triangle {
      < -4.461042, -1.763883, 2.849307>,
      < -4.471114, -1.766977, 2.850321>,
      < -4.465652, -1.806768, 2.841603>
    }
    triangle {
      < -4.461042, -1.763883, 2.849307>,
      < -4.465652, -1.806768, 2.841603>,
      < -4.453445, -1.801850, 2.840937>
    }
    triangle {
      < -4.471114, -1.766977, 2.850321>,
      < -4.482196, -1.769908, 2.850970>,
      < -4.478774, -1.810492, 2.841981>
    }
    triangle {
      < -4.471114, -1.766977, 2.850321>,
      < -4.478774, -1.810492, 2.841981>,
      < -4.465652, -1.806768, 2.841603>
    }
    triangle {
      < -4.482196, -1.769908, 2.850970>,
      < -4.492434, -1.772411, 2.851121>,
      < -4.491744, -1.812827, 2.842009>
    }
    triangle {
      < -4.482196, -1.769908, 2.850970>,
      < -4.491744, -1.812827, 2.842009>,
      < -4.478774, -1.810492, 2.841981>
    }
    triangle {
      < -4.492434, -1.772411, 2.851121>,
      < -4.505435, -1.772412, 2.851122>,
      < -4.506121, -1.812829, 2.842010>
    }
    triangle {
      < -4.492434, -1.772411, 2.851121>,
      < -4.506121, -1.812829, 2.842010>,
      < -4.491744, -1.812827, 2.842009>
    }
    triangle {
      < -4.505435, -1.772412, 2.851122>,
      < -4.515684, -1.769917, 2.850970>,
      < -4.519097, -1.810501, 2.841982>
    }
    triangle {
      < -4.505435, -1.772412, 2.851122>,
      < -4.519097, -1.810501, 2.841982>,
      < -4.506121, -1.812829, 2.842010>
    }
    triangle {
      < -4.515684, -1.769917, 2.850970>,
      < -4.526771, -1.766988, 2.850321>,
      < -4.532222, -1.806781, 2.841603>
    }
    triangle {
      < -4.515684, -1.769917, 2.850970>,
      < -4.532222, -1.806781, 2.841603>,
      < -4.519097, -1.810501, 2.841982>
    }
    triangle {
      < -4.526771, -1.766988, 2.850321>,
      < -4.536848, -1.763898, 2.849308>,
      < -4.544432, -1.801868, 2.840937>
    }
    triangle {
      < -4.526771, -1.766988, 2.850321>,
      < -4.544432, -1.801868, 2.840937>,
      < -4.532222, -1.806781, 2.841603>
    }
    triangle {
      < -4.536848, -1.763898, 2.849308>,
      < -4.546091, -1.761263, 2.847952>,
      < -4.555644, -1.796140, 2.839976>
    }
    triangle {
      < -4.536848, -1.763898, 2.849308>,
      < -4.555644, -1.796140, 2.839976>,
      < -4.544432, -1.801868, 2.840937>
    }
    triangle {
      < -4.546091, -1.761263, 2.847952>,
      < -4.554851, -1.757454, 2.846414>,
      < -4.565916, -1.788957, 2.838923>
    }
    triangle {
      < -4.546091, -1.761263, 2.847952>,
      < -4.565916, -1.788957, 2.838923>,
      < -4.555644, -1.796140, 2.839976>
    }
    triangle {
      < -4.554851, -1.757454, 2.846414>,
      < -4.562688, -1.753434, 2.844745>,
      < -4.574913, -1.780896, 2.837770>
    }
    triangle {
      < -4.554851, -1.757454, 2.846414>,
      < -4.574913, -1.780896, 2.837770>,
      < -4.565916, -1.788957, 2.838923>
    }
    triangle {
      < -4.562688, -1.753434, 2.844745>,
      < -4.569467, -1.750294, 2.843013>,
      < -4.582467, -1.772623, 2.836539>
    }
    triangle {
      < -4.562688, -1.753434, 2.844745>,
      < -4.582467, -1.772623, 2.836539>,
      < -4.574913, -1.780896, 2.837770>
    }
    triangle {
      < -4.569467, -1.750294, 2.843013>,
      < -4.575357, -1.747036, 2.841324>,
      < -4.588618, -1.763813, 2.835366>
    }
    triangle {
      < -4.569467, -1.750294, 2.843013>,
      < -4.588618, -1.763813, 2.835366>,
      < -4.582467, -1.772623, 2.836539>
    }
    triangle {
      < -4.575357, -1.747036, 2.841324>,
      < -4.579824, -1.744281, 2.839914>,
      < -4.593072, -1.754914, 2.834394>
    }
    triangle {
      < -4.575357, -1.747036, 2.841324>,
      < -4.593072, -1.754914, 2.834394>,
      < -4.588618, -1.763813, 2.835366>
    }
    triangle {
      < -4.579824, -1.744281, 2.839914>,
      < -4.583084, -1.741786, 2.838813>,
      < -4.595918, -1.745944, 2.833675>
    }
    triangle {
      < -4.579824, -1.744281, 2.839914>,
      < -4.595918, -1.745944, 2.833675>,
      < -4.593072, -1.754914, 2.834394>
    }
    triangle {
      < -4.583084, -1.741786, 2.838813>,
      < -4.585126, -1.738689, 2.838090>,
      < -4.597146, -1.736606, 2.833266>
    }
    triangle {
      < -4.583084, -1.741786, 2.838813>,
      < -4.597146, -1.736606, 2.833266>,
      < -4.595918, -1.745944, 2.833675>
    }
    triangle {
      < -4.585126, -1.738689, 2.838090>,
      < -4.585766, -1.735803, 2.837837>,
      < -4.606796, -1.719425, 2.828054>
    }
    triangle {
      < -4.585126, -1.738689, 2.838090>,
      < -4.606796, -1.719425, 2.828054>,
      < -4.597146, -1.736606, 2.833266>
    }
    triangle {
      < -4.582342, -1.728392, 2.838888>,
      < -4.576113, -1.720668, 2.840566>,
      < -4.606796, -1.719425, 2.828054>
    }
    triangle {
      < -4.582591, -1.709989, 2.837276>,
      < -4.597384, -1.690435, 2.828054>,
      < -4.603104, -1.704601, 2.828054>
    }
    triangle {
      < -4.569101, -1.709448, 2.841646>,
      < -4.580003, -1.692694, 2.835421>,
      < -4.582591, -1.709989, 2.837276>
    }
    triangle {
      < -4.569101, -1.709448, 2.841646>,
      < -4.554898, -1.708987, 2.845354>,
      < -4.562851, -1.680337, 2.838025>
    }
    triangle {
      < -4.569101, -1.709448, 2.841646>,
      < -4.562851, -1.680337, 2.838025>,
      < -4.575243, -1.686408, 2.835713>
    }
    triangle {
      < -4.554898, -1.708987, 2.845354>,
      < -4.542511, -1.719217, 2.848936>,
      < -4.551122, -1.677672, 2.840262>
    }
    triangle {
      < -4.554898, -1.708987, 2.845354>,
      < -4.551122, -1.677672, 2.840262>,
      < -4.562851, -1.680337, 2.838025>
    }
    triangle {
      < -4.542511, -1.719217, 2.848936>,
      < -4.528247, -1.719049, 2.851049>,
      < -4.537259, -1.673463, 2.841802>
    }
    triangle {
      < -4.542511, -1.719217, 2.848936>,
      < -4.537259, -1.673463, 2.841802>,
      < -4.551122, -1.677672, 2.840262>
    }
    triangle {
      < -4.577860, -1.713619, 2.848997>,
      < -4.571749, -1.723348, 2.852286>,
      < -4.565133, -1.713125, 2.853366>
    }
    triangle {
      < -4.603104, -1.704601, 2.828054>,
      < -4.606796, -1.719425, 2.828054>,
      < -4.582591, -1.709989, 2.837276>
    }
    triangle {
      < -4.415323, -1.709956, 2.837276>,
      < -4.421799, -1.720634, 2.840566>,
      < -4.391115, -1.719384, 2.828054>
    }
    triangle {
      < -4.420053, -1.713589, 2.848996>,
      < -4.432785, -1.713105, 2.853368>,
      < -4.426163, -1.723317, 2.852286>
    }
    triangle {
      < -4.585766, -1.735803, 2.837837>,
      < -4.582342, -1.728392, 2.838888>,
      < -4.606796, -1.719425, 2.828054>
    }
    triangle {
      < -4.412143, -1.735762, 2.837839>,
      < -4.391115, -1.719384, 2.828054>,
      < -4.415568, -1.728363, 2.838889>
    }
    triangle {
      < -4.505068, -1.770489, 2.862842>,
      < -4.492802, -1.770488, 2.862842>,
      < -4.498962, -1.721745, 2.864501>
    }
    triangle {
      < -4.512849, -1.721778, 2.864064>,
      < -4.505068, -1.770489, 2.862842>,
      < -4.498962, -1.721745, 2.864501>
    }
    triangle {
      < -4.483144, -1.768208, 2.862690>,
      < -4.485075, -1.721775, 2.864065>,
      < -4.492802, -1.770488, 2.862842>
    }
    triangle {
      < -4.498962, -1.721745, 2.864501>,
      < -4.492802, -1.770488, 2.862842>,
      < -4.485075, -1.721775, 2.864065>
    }
    triangle {
      < -4.463186, -1.762718, 2.861027>,
      < -4.454239, -1.722017, 2.859846>,
      < -4.471334, -1.721867, 2.862772>
    }
    triangle {
      < -4.463186, -1.762718, 2.861027>,
      < -4.471334, -1.721867, 2.862772>,
      < -4.472689, -1.765537, 2.862041>
    }
    triangle {
      < -4.485075, -1.721775, 2.864065>,
      < -4.483144, -1.768208, 2.862690>,
      < -4.472689, -1.765537, 2.862041>
    }
    triangle {
      < -4.485075, -1.721775, 2.864065>,
      < -4.472689, -1.765537, 2.862041>,
      < -4.471334, -1.721867, 2.862772>
    }
    triangle {
      < -4.446211, -1.756843, 2.858135>,
      < -4.441517, -1.712695, 2.856265>,
      < -4.454224, -1.760080, 2.859645>
    }
    triangle {
      < -4.454239, -1.722017, 2.859846>,
      < -4.463186, -1.762718, 2.861027>,
      < -4.454224, -1.760080, 2.859645>
    }
    triangle {
      < -4.454239, -1.722017, 2.859846>,
      < -4.454224, -1.760080, 2.859645>,
      < -4.441517, -1.712695, 2.856265>
    }
    triangle {
      < -4.432428, -1.750317, 2.854735>,
      < -4.426163, -1.723317, 2.852286>,
      < -4.432785, -1.713105, 2.853368>
    }
    triangle {
      < -4.432428, -1.750317, 2.854735>,
      < -4.432785, -1.713105, 2.853368>,
      < -4.438821, -1.753178, 2.856467>
    }
    triangle {
      < -4.526590, -1.721872, 2.862770>,
      < -4.525197, -1.765548, 2.862041>,
      < -4.514738, -1.768216, 2.862690>
    }
    triangle {
      < -4.526590, -1.721872, 2.862770>,
      < -4.514738, -1.768216, 2.862690>,
      < -4.512849, -1.721778, 2.864064>
    }
    triangle {
      < -4.505068, -1.770489, 2.862842>,
      < -4.512849, -1.721778, 2.864064>,
      < -4.514738, -1.768216, 2.862690>
    }
    triangle {
      < -4.556407, -1.712705, 2.856261>,
      < -4.543425, -1.760332, 2.859672>,
      < -4.534705, -1.762733, 2.861027>
    }
    triangle {
      < -4.556407, -1.712705, 2.856261>,
      < -4.534705, -1.762733, 2.861027>,
      < -4.543686, -1.722026, 2.859843>
    }
    triangle {
      < -4.525197, -1.765548, 2.862041>,
      < -4.526590, -1.721872, 2.862770>,
      < -4.543686, -1.722026, 2.859843>
    }
    triangle {
      < -4.525197, -1.765548, 2.862041>,
      < -4.543686, -1.722026, 2.859843>,
      < -4.534705, -1.762733, 2.861027>
    }
    triangle {
      < -4.551689, -1.756862, 2.858134>,
      < -4.556407, -1.712705, 2.856261>,
      < -4.565133, -1.713125, 2.853366>
    }
    triangle {
      < -4.551689, -1.756862, 2.858134>,
      < -4.565133, -1.713125, 2.853366>,
      < -4.559083, -1.753199, 2.856466>
    }
    triangle {
      < -4.543425, -1.760332, 2.859672>,
      < -4.556407, -1.712705, 2.856261>,
      < -4.551689, -1.756862, 2.858134>
    }
    triangle {
      < -4.577626, -1.730384, 2.850608>,
      < -4.571035, -1.747370, 2.853045>,
      < -4.565478, -1.750338, 2.854733>
    }
    triangle {
      < -4.577626, -1.730384, 2.850608>,
      < -4.565478, -1.750338, 2.854733>,
      < -4.571749, -1.723348, 2.852286>
    }
    triangle {
      < -4.559083, -1.753199, 2.856466>,
      < -4.565133, -1.713125, 2.853366>,
      < -4.571749, -1.723348, 2.852286>
    }
    triangle {
      < -4.559083, -1.753199, 2.856466>,
      < -4.571749, -1.723348, 2.852286>,
      < -4.565478, -1.750338, 2.854733>
    }
    triangle {
      < -4.580252, -1.739766, 2.849810>,
      < -4.578326, -1.742587, 2.850533>,
      < -4.575250, -1.744860, 2.851635>
    }
    triangle {
      < -4.580252, -1.739766, 2.849810>,
      < -4.575250, -1.744860, 2.851635>,
      < -4.580855, -1.737136, 2.849557>
    }
    triangle {
      < -4.571035, -1.747370, 2.853045>,
      < -4.577626, -1.730384, 2.850608>,
      < -4.580855, -1.737136, 2.849557>
    }
    triangle {
      < -4.571035, -1.747370, 2.853045>,
      < -4.580855, -1.737136, 2.849557>,
      < -4.575250, -1.744860, 2.851635>
    }
    triangle {
      < -4.441517, -1.712695, 2.856265>,
      < -4.446211, -1.756843, 2.858135>,
      < -4.438821, -1.753178, 2.856467>
    }
    triangle {
      < -4.441517, -1.712695, 2.856265>,
      < -4.438821, -1.753178, 2.856467>,
      < -4.432785, -1.713105, 2.853368>
    }
    triangle {
      < -4.422660, -1.744842, 2.851637>,
      < -4.417053, -1.737099, 2.849559>,
      < -4.420285, -1.730358, 2.850609>
    }
    triangle {
      < -4.422660, -1.744842, 2.851637>,
      < -4.420285, -1.730358, 2.850609>,
      < -4.427099, -1.747608, 2.853114>
    }
    triangle {
      < -4.426163, -1.723317, 2.852286>,
      < -4.432428, -1.750317, 2.854735>,
      < -4.427099, -1.747608, 2.853114>
    }
    triangle {
      < -4.426163, -1.723317, 2.852286>,
      < -4.427099, -1.747608, 2.853114>,
      < -4.420285, -1.730358, 2.850609>
    }
    triangle {
      < -4.419585, -1.742571, 2.850535>,
      < -4.417658, -1.739747, 2.849813>,
      < -4.417053, -1.737099, 2.849559>
    }
    triangle {
      < -4.419585, -1.742571, 2.850535>,
      < -4.417053, -1.737099, 2.849559>,
      < -4.422660, -1.744842, 2.851637>
    }
    triangle {
      < -4.569101, -1.709448, 2.841646>,
      < -4.575243, -1.686408, 2.835713>,
      < -4.580003, -1.692694, 2.835421>
    }
    triangle {
      < -4.428818, -1.709425, 2.841648>,
      < -4.417920, -1.692665, 2.835422>,
      < -4.422682, -1.686381, 2.835714>
    }
    triangle {
      < -4.394813, -1.704561, 2.828054>,
      < -4.400538, -1.690398, 2.828054>,
      < -4.415323, -1.709956, 2.837276>
    }
    triangle {
      < -4.589748, -1.677203, 2.828054>,
      < -4.597384, -1.690435, 2.828054>,
      < -4.582591, -1.709989, 2.837276>
    }
    triangle {
      < -4.589748, -1.677203, 2.828054>,
      < -4.582591, -1.709989, 2.837276>,
      < -4.580003, -1.692694, 2.835421>
    }
    triangle {
      < -4.580346, -1.665163, 2.828054>,
      < -4.589748, -1.677203, 2.828054>,
      < -4.580003, -1.692694, 2.835421>
    }
    triangle {
      < -4.580346, -1.665163, 2.828054>,
      < -4.580003, -1.692694, 2.835421>,
      < -4.575243, -1.686408, 2.835713>
    }
    triangle {
      < -4.569359, -1.654548, 2.828054>,
      < -4.580346, -1.665163, 2.828054>,
      < -4.575243, -1.686408, 2.835713>
    }
    triangle {
      < -4.569359, -1.654548, 2.828054>,
      < -4.575243, -1.686408, 2.835713>,
      < -4.562851, -1.680337, 2.838025>
    }
    triangle {
      < -4.557002, -1.645565, 2.828054>,
      < -4.569359, -1.654548, 2.828054>,
      < -4.562851, -1.680337, 2.838025>
    }
    triangle {
      < -4.557002, -1.645565, 2.828054>,
      < -4.562851, -1.680337, 2.838025>,
      < -4.551122, -1.677672, 2.840262>
    }
    triangle {
      < -4.543515, -1.638390, 2.828054>,
      < -4.557002, -1.645565, 2.828054>,
      < -4.551122, -1.677672, 2.840262>
    }
    triangle {
      < -4.543515, -1.638390, 2.828054>,
      < -4.551122, -1.677672, 2.840262>,
      < -4.537259, -1.673463, 2.841802>
    }
    triangle {
      < -4.529160, -1.633162, 2.828054>,
      < -4.543515, -1.638390, 2.828054>,
      < -4.537259, -1.673463, 2.841802>
    }
    triangle {
      < -4.529160, -1.633162, 2.828054>,
      < -4.537259, -1.673463, 2.841802>,
      < -4.529215, -1.672935, 2.842822>
    }
    triangle {
      < -4.514218, -1.629982, 2.828054>,
      < -4.529160, -1.633162, 2.828054>,
      < -4.529215, -1.672935, 2.842822>
    }
    triangle {
      < -4.514218, -1.629982, 2.828054>,
      < -4.529215, -1.672935, 2.842822>,
      < -4.514230, -1.670987, 2.843713>
    }
    triangle {
      < -4.498979, -1.628912, 2.828054>,
      < -4.514218, -1.629982, 2.828054>,
      < -4.514230, -1.670987, 2.843713>
    }
    triangle {
      < -4.498979, -1.628912, 2.828054>,
      < -4.514230, -1.670987, 2.843713>,
      < -4.498971, -1.670327, 2.844015>
    }
    triangle {
      < -4.483727, -1.629976, 2.828054>,
      < -4.498979, -1.628912, 2.828054>,
      < -4.498971, -1.670327, 2.844015>
    }
    triangle {
      < -4.483727, -1.629976, 2.828054>,
      < -4.498971, -1.670327, 2.844015>,
      < -4.483706, -1.670982, 2.843714>
    }
    triangle {
      < -4.468783, -1.633150, 2.828054>,
      < -4.483727, -1.629976, 2.828054>,
      < -4.483706, -1.670982, 2.843714>
    }
    triangle {
      < -4.468783, -1.633150, 2.828054>,
      < -4.483706, -1.670982, 2.843714>,
      < -4.468720, -1.672926, 2.842824>
    }
    triangle {
      < -4.454427, -1.638373, 2.828054>,
      < -4.468783, -1.633150, 2.828054>,
      < -4.468720, -1.672926, 2.842824>
    }
    triangle {
      < -4.454427, -1.638373, 2.828054>,
      < -4.468720, -1.672926, 2.842824>,
      < -4.460676, -1.673450, 2.841804>
    }
    triangle {
      < -4.440938, -1.645543, 2.828054>,
      < -4.454427, -1.638373, 2.828054>,
      < -4.460676, -1.673450, 2.841804>
    }
    triangle {
      < -4.440938, -1.645543, 2.828054>,
      < -4.460676, -1.673450, 2.841804>,
      < -4.446811, -1.677655, 2.840264>
    }
    triangle {
      < -4.428577, -1.654521, 2.828054>,
      < -4.440938, -1.645543, 2.828054>,
      < -4.446811, -1.677655, 2.840264>
    }
    triangle {
      < -4.428577, -1.654521, 2.828054>,
      < -4.446811, -1.677655, 2.840264>,
      < -4.435079, -1.680317, 2.838027>
    }
    triangle {
      < -4.417586, -1.665132, 2.828054>,
      < -4.428577, -1.654521, 2.828054>,
      < -4.435079, -1.680317, 2.838027>
    }
    triangle {
      < -4.417586, -1.665132, 2.828054>,
      < -4.435079, -1.680317, 2.838027>,
      < -4.422682, -1.686381, 2.835714>
    }
    triangle {
      < -4.408179, -1.677168, 2.828054>,
      < -4.417586, -1.665132, 2.828054>,
      < -4.422682, -1.686381, 2.835714>
    }
    triangle {
      < -4.408179, -1.677168, 2.828054>,
      < -4.422682, -1.686381, 2.835714>,
      < -4.417920, -1.692665, 2.835422>
    }
    triangle {
      < -4.400538, -1.690398, 2.828054>,
      < -4.408179, -1.677168, 2.828054>,
      < -4.417920, -1.692665, 2.835422>
    }
    triangle {
      < -4.400538, -1.690398, 2.828054>,
      < -4.417920, -1.692665, 2.835422>,
      < -4.415323, -1.709956, 2.837276>
    }
    triangle {
      < -4.394813, -1.704561, 2.828054>,
      < -4.415323, -1.709956, 2.837276>,
      < -4.391115, -1.719384, 2.828054>
    }
    triangle {
      < -4.389516, -1.734577, 2.828054>,
      < -4.391115, -1.719384, 2.828054>,
      < -4.400762, -1.736575, 2.833268>
    }
    triangle {
      < -4.390046, -1.749844, 2.828054>,
      < -4.389516, -1.734577, 2.828054>,
      < -4.400762, -1.736575, 2.833268>
    }
    triangle {
      < -4.390046, -1.749844, 2.828054>,
      < -4.400762, -1.736575, 2.833268>,
      < -4.401987, -1.745914, 2.833677>
    }
    triangle {
      < -4.392696, -1.764889, 2.828054>,
      < -4.390046, -1.749844, 2.828054>,
      < -4.401987, -1.745914, 2.833677>
    }
    triangle {
      < -4.392696, -1.764889, 2.828054>,
      < -4.401987, -1.745914, 2.833677>,
      < -4.404830, -1.754884, 2.834395>
    }
    triangle {
      < -4.397415, -1.779420, 2.828054>,
      < -4.392696, -1.764889, 2.828054>,
      < -4.404830, -1.754884, 2.834395>
    }
    triangle {
      < -4.397415, -1.779420, 2.828054>,
      < -4.404830, -1.754884, 2.834395>,
      < -4.409395, -1.763922, 2.835397>
    }
    triangle {
      < -4.404109, -1.793151, 2.828054>,
      < -4.397415, -1.779420, 2.828054>,
      < -4.409395, -1.763922, 2.835397>
    }
    triangle {
      < -4.404109, -1.793151, 2.828054>,
      < -4.409395, -1.763922, 2.835397>,
      < -4.415427, -1.772594, 2.836540>
    }
    triangle {
      < -4.412650, -1.805818, 2.828054>,
      < -4.404109, -1.793151, 2.828054>,
      < -4.415427, -1.772594, 2.836540>
    }
    triangle {
      < -4.412650, -1.805818, 2.828054>,
      < -4.415427, -1.772594, 2.836540>,
      < -4.422977, -1.780868, 2.837771>
    }
    triangle {
      < -4.422870, -1.817173, 2.828054>,
      < -4.412650, -1.805818, 2.828054>,
      < -4.422977, -1.780868, 2.837771>
    }
    triangle {
      < -4.422870, -1.817173, 2.828054>,
      < -4.422977, -1.780868, 2.837771>,
      < -4.431971, -1.788932, 2.838923>
    }
    triangle {
      < -4.434571, -1.826995, 2.828054>,
      < -4.422870, -1.817173, 2.828054>,
      < -4.431971, -1.788932, 2.838923>
    }
    triangle {
      < -4.434571, -1.826995, 2.828054>,
      < -4.431971, -1.788932, 2.838923>,
      < -4.442109, -1.795994, 2.839975>
    }
    triangle {
      < -4.447526, -1.835093, 2.828054>,
      < -4.434571, -1.826995, 2.828054>,
      < -4.442109, -1.795994, 2.839975>
    }
    triangle {
      < -4.447526, -1.835093, 2.828054>,
      < -4.442109, -1.795994, 2.839975>,
      < -4.453445, -1.801850, 2.840937>
    }
    triangle {
      < -4.461481, -1.841309, 2.828054>,
      < -4.447526, -1.835093, 2.828054>,
      < -4.453445, -1.801850, 2.840937>
    }
    triangle {
      < -4.461481, -1.841309, 2.828054>,
      < -4.453445, -1.801850, 2.840937>,
      < -4.465652, -1.806768, 2.841603>
    }
    triangle {
      < -4.476165, -1.845522, 2.828054>,
      < -4.461481, -1.841309, 2.828054>,
      < -4.465652, -1.806768, 2.841603>
    }
    triangle {
      < -4.476165, -1.845522, 2.828054>,
      < -4.465652, -1.806768, 2.841603>,
      < -4.478774, -1.810492, 2.841981>
    }
    triangle {
      < -4.491292, -1.847651, 2.828054>,
      < -4.476165, -1.845522, 2.828054>,
      < -4.478774, -1.810492, 2.841981>
    }
    triangle {
      < -4.491292, -1.847651, 2.828054>,
      < -4.478774, -1.810492, 2.841981>,
      < -4.491744, -1.812827, 2.842009>
    }
    triangle {
      < -4.506569, -1.847654, 2.828054>,
      < -4.491292, -1.847651, 2.828054>,
      < -4.491744, -1.812827, 2.842009>
    }
    triangle {
      < -4.506569, -1.847654, 2.828054>,
      < -4.491744, -1.812827, 2.842009>,
      < -4.506121, -1.812829, 2.842010>
    }
    triangle {
      < -4.521698, -1.845531, 2.828054>,
      < -4.506569, -1.847654, 2.828054>,
      < -4.506121, -1.812829, 2.842010>
    }
    triangle {
      < -4.521698, -1.845531, 2.828054>,
      < -4.506121, -1.812829, 2.842010>,
      < -4.519097, -1.810501, 2.841982>
    }
    triangle {
      < -4.536384, -1.841323, 2.828054>,
      < -4.521698, -1.845531, 2.828054>,
      < -4.519097, -1.810501, 2.841982>
    }
    triangle {
      < -4.536384, -1.841323, 2.828054>,
      < -4.519097, -1.810501, 2.841982>,
      < -4.532222, -1.806781, 2.841603>
    }
    triangle {
      < -4.550342, -1.835112, 2.828054>,
      < -4.536384, -1.841323, 2.828054>,
      < -4.532222, -1.806781, 2.841603>
    }
    triangle {
      < -4.550342, -1.835112, 2.828054>,
      < -4.532222, -1.806781, 2.841603>,
      < -4.544432, -1.801868, 2.840937>
    }
    triangle {
      < -4.563299, -1.827019, 2.828054>,
      < -4.550342, -1.835112, 2.828054>,
      < -4.544432, -1.801868, 2.840937>
    }
    triangle {
      < -4.563299, -1.827019, 2.828054>,
      < -4.544432, -1.801868, 2.840937>,
      < -4.555644, -1.796140, 2.839976>
    }
    triangle {
      < -4.575004, -1.817202, 2.828054>,
      < -4.563299, -1.827019, 2.828054>,
      < -4.555644, -1.796140, 2.839976>
    }
    triangle {
      < -4.575004, -1.817202, 2.828054>,
      < -4.555644, -1.796140, 2.839976>,
      < -4.565916, -1.788957, 2.838923>
    }
    triangle {
      < -4.585228, -1.805851, 2.828054>,
      < -4.575004, -1.817202, 2.828054>,
      < -4.565916, -1.788957, 2.838923>
    }
    triangle {
      < -4.585228, -1.805851, 2.828054>,
      < -4.565916, -1.788957, 2.838923>,
      < -4.574913, -1.780896, 2.837770>
    }
    triangle {
      < -4.593773, -1.793188, 2.828054>,
      < -4.585228, -1.805851, 2.828054>,
      < -4.574913, -1.780896, 2.837770>
    }
    triangle {
      < -4.593773, -1.793188, 2.828054>,
      < -4.574913, -1.780896, 2.837770>,
      < -4.582467, -1.772623, 2.836539>
    }
    triangle {
      < -4.600473, -1.779458, 2.828054>,
      < -4.593773, -1.793188, 2.828054>,
      < -4.582467, -1.772623, 2.836539>
    }
    triangle {
      < -4.600473, -1.779458, 2.828054>,
      < -4.582467, -1.772623, 2.836539>,
      < -4.588618, -1.763813, 2.835366>
    }
    triangle {
      < -4.605197, -1.764930, 2.828054>,
      < -4.600473, -1.779458, 2.828054>,
      < -4.588618, -1.763813, 2.835366>
    }
    triangle {
      < -4.605197, -1.764930, 2.828054>,
      < -4.588618, -1.763813, 2.835366>,
      < -4.593072, -1.754914, 2.834394>
    }
    triangle {
      < -4.607853, -1.749886, 2.828054>,
      < -4.605197, -1.764930, 2.828054>,
      < -4.593072, -1.754914, 2.834394>
    }
    triangle {
      < -4.607853, -1.749886, 2.828054>,
      < -4.593072, -1.754914, 2.834394>,
      < -4.595918, -1.745944, 2.833675>
    }
    triangle {
      < -4.608390, -1.734618, 2.828054>,
      < -4.607853, -1.749886, 2.828054>,
      < -4.595918, -1.745944, 2.833675>
    }
    triangle {
      < -4.608390, -1.734618, 2.828054>,
      < -4.595918, -1.745944, 2.833675>,
      < -4.597146, -1.736606, 2.833266>
    }
    triangle {
      < -4.608390, -1.734618, 2.828054>,
      < -4.597146, -1.736606, 2.833266>,
      < -4.606796, -1.719425, 2.828054>
    }
    triangle {
      < -4.576113, -1.720668, 2.840566>,
      < -4.582591, -1.709989, 2.837276>,
      < -4.606796, -1.719425, 2.828054>
    }
    triangle {
      < -4.419585, -1.742571, 2.850535>,
      < -4.422660, -1.744842, 2.851637>,
      < -4.418086, -1.744261, 2.839917>
    }
    triangle {
      < -4.419585, -1.742571, 2.850535>,
      < -4.418086, -1.744261, 2.839917>,
      < -4.414826, -1.741768, 2.838815>
    }
    triangle {
      < -4.422660, -1.744842, 2.851637>,
      < -4.427099, -1.747608, 2.853114>,
      < -4.422791, -1.747297, 2.841394>
    }
    triangle {
      < -4.422660, -1.744842, 2.851637>,
      < -4.422791, -1.747297, 2.841394>,
      < -4.418086, -1.744261, 2.839917>
    }
    triangle {
      < -4.427099, -1.747608, 2.853114>,
      < -4.432428, -1.750317, 2.854735>,
      < -4.428440, -1.750271, 2.843014>
    }
    triangle {
      < -4.427099, -1.747608, 2.853114>,
      < -4.428440, -1.750271, 2.843014>,
      < -4.422791, -1.747297, 2.841394>
    }
    triangle {
      < -4.432428, -1.750317, 2.854735>,
      < -4.438821, -1.753178, 2.856467>,
      < -4.435215, -1.753411, 2.844747>
    }
    triangle {
      < -4.432428, -1.750317, 2.854735>,
      < -4.435215, -1.753411, 2.844747>,
      < -4.428440, -1.750271, 2.843014>
    }
    triangle {
      < -4.438821, -1.753178, 2.856467>,
      < -4.446211, -1.756843, 2.858135>,
      < -4.443049, -1.757434, 2.846415>
    }
    triangle {
      < -4.438821, -1.753178, 2.856467>,
      < -4.443049, -1.757434, 2.846415>,
      < -4.435215, -1.753411, 2.844747>
    }
    triangle {
      < -4.446211, -1.756843, 2.858135>,
      < -4.454224, -1.760080, 2.859645>,
      < -4.451542, -1.760986, 2.847925>
    }
    triangle {
      < -4.446211, -1.756843, 2.858135>,
      < -4.451542, -1.760986, 2.847925>,
      < -4.443049, -1.757434, 2.846415>
    }
    triangle {
      < -4.454224, -1.760080, 2.859645>,
      < -4.463186, -1.762718, 2.861027>,
      < -4.461042, -1.763883, 2.849307>
    }
    triangle {
      < -4.454224, -1.760080, 2.859645>,
      < -4.461042, -1.763883, 2.849307>,
      < -4.451542, -1.760986, 2.847925>
    }
    triangle {
      < -4.463186, -1.762718, 2.861027>,
      < -4.472689, -1.765537, 2.862041>,
      < -4.471114, -1.766977, 2.850321>
    }
    triangle {
      < -4.463186, -1.762718, 2.861027>,
      < -4.471114, -1.766977, 2.850321>,
      < -4.461042, -1.763883, 2.849307>
    }
    triangle {
      < -4.472689, -1.765537, 2.862041>,
      < -4.483144, -1.768208, 2.862690>,
      < -4.482196, -1.769908, 2.850970>
    }
    triangle {
      < -4.472689, -1.765537, 2.862041>,
      < -4.482196, -1.769908, 2.850970>,
      < -4.471114, -1.766977, 2.850321>
    }
    triangle {
      < -4.483144, -1.768208, 2.862690>,
      < -4.492802, -1.770488, 2.862842>,
      < -4.492434, -1.772411, 2.851121>
    }
    triangle {
      < -4.483144, -1.768208, 2.862690>,
      < -4.492434, -1.772411, 2.851121>,
      < -4.482196, -1.769908, 2.850970>
    }
    triangle {
      < -4.492802, -1.770488, 2.862842>,
      < -4.505068, -1.770489, 2.862842>,
      < -4.505435, -1.772412, 2.851122>
    }
    triangle {
      < -4.492802, -1.770488, 2.862842>,
      < -4.505435, -1.772412, 2.851122>,
      < -4.492434, -1.772411, 2.851121>
    }
    triangle {
      < -4.505068, -1.770489, 2.862842>,
      < -4.514738, -1.768216, 2.862690>,
      < -4.515684, -1.769917, 2.850970>
    }
    triangle {
      < -4.505068, -1.770489, 2.862842>,
      < -4.515684, -1.769917, 2.850970>,
      < -4.505435, -1.772412, 2.851122>
    }
    triangle {
      < -4.514738, -1.768216, 2.862690>,
      < -4.525197, -1.765548, 2.862041>,
      < -4.526771, -1.766988, 2.850321>
    }
    triangle {
      < -4.514738, -1.768216, 2.862690>,
      < -4.526771, -1.766988, 2.850321>,
      < -4.515684, -1.769917, 2.850970>
    }
    triangle {
      < -4.525197, -1.765548, 2.862041>,
      < -4.534705, -1.762733, 2.861027>,
      < -4.536848, -1.763898, 2.849308>
    }
    triangle {
      < -4.525197, -1.765548, 2.862041>,
      < -4.536848, -1.763898, 2.849308>,
      < -4.526771, -1.766988, 2.850321>
    }
    triangle {
      < -4.534705, -1.762733, 2.861027>,
      < -4.543425, -1.760332, 2.859672>,
      < -4.546091, -1.761263, 2.847952>
    }
    triangle {
      < -4.534705, -1.762733, 2.861027>,
      < -4.546091, -1.761263, 2.847952>,
      < -4.536848, -1.763898, 2.849308>
    }
    triangle {
      < -4.543425, -1.760332, 2.859672>,
      < -4.551689, -1.756862, 2.858134>,
      < -4.554851, -1.757454, 2.846414>
    }
    triangle {
      < -4.543425, -1.760332, 2.859672>,
      < -4.554851, -1.757454, 2.846414>,
      < -4.546091, -1.761263, 2.847952>
    }
    triangle {
      < -4.551689, -1.756862, 2.858134>,
      < -4.559083, -1.753199, 2.856466>,
      < -4.562688, -1.753434, 2.844745>
    }
    triangle {
      < -4.551689, -1.756862, 2.858134>,
      < -4.562688, -1.753434, 2.844745>,
      < -4.554851, -1.757454, 2.846414>
    }
    triangle {
      < -4.559083, -1.753199, 2.856466>,
      < -4.565478, -1.750338, 2.854733>,
      < -4.569467, -1.750294, 2.843013>
    }
    triangle {
      < -4.559083, -1.753199, 2.856466>,
      < -4.569467, -1.750294, 2.843013>,
      < -4.562688, -1.753434, 2.844745>
    }
    triangle {
      < -4.565478, -1.750338, 2.854733>,
      < -4.571035, -1.747370, 2.853045>,
      < -4.575357, -1.747036, 2.841324>
    }
    triangle {
      < -4.565478, -1.750338, 2.854733>,
      < -4.575357, -1.747036, 2.841324>,
      < -4.569467, -1.750294, 2.843013>
    }
    triangle {
      < -4.571035, -1.747370, 2.853045>,
      < -4.575250, -1.744860, 2.851635>,
      < -4.579824, -1.744281, 2.839914>
    }
    triangle {
      < -4.571035, -1.747370, 2.853045>,
      < -4.579824, -1.744281, 2.839914>,
      < -4.575357, -1.747036, 2.841324>
    }
    triangle {
      < -4.575250, -1.744860, 2.851635>,
      < -4.578326, -1.742587, 2.850533>,
      < -4.583084, -1.741786, 2.838813>
    }
    triangle {
      < -4.575250, -1.744860, 2.851635>,
      < -4.583084, -1.741786, 2.838813>,
      < -4.579824, -1.744281, 2.839914>
    }
    triangle {
      < -4.578326, -1.742587, 2.850533>,
      < -4.580252, -1.739766, 2.849810>,
      < -4.585126, -1.738689, 2.838090>
    }
    triangle {
      < -4.578326, -1.742587, 2.850533>,
      < -4.585126, -1.738689, 2.838090>,
      < -4.583084, -1.741786, 2.838813>
    }
    triangle {
      < -4.580252, -1.739766, 2.849810>,
      < -4.580855, -1.737136, 2.849557>,
      < -4.585766, -1.735803, 2.837837>
    }
    triangle {
      < -4.580252, -1.739766, 2.849810>,
      < -4.585766, -1.735803, 2.837837>,
      < -4.585126, -1.738689, 2.838090>
    }
    triangle {
      < -4.580855, -1.737136, 2.849557>,
      < -4.577626, -1.730384, 2.850608>,
      < -4.582342, -1.728392, 2.838888>
    }
    triangle {
      < -4.580855, -1.737136, 2.849557>,
      < -4.582342, -1.728392, 2.838888>,
      < -4.585766, -1.735803, 2.837837>
    }
    triangle {
      < -4.577626, -1.730384, 2.850608>,
      < -4.571749, -1.723348, 2.852286>,
      < -4.576113, -1.720668, 2.840566>
    }
    triangle {
      < -4.577626, -1.730384, 2.850608>,
      < -4.576113, -1.720668, 2.840566>,
      < -4.582342, -1.728392, 2.838888>
    }
    triangle {
      < -4.571749, -1.723348, 2.852286>,
      < -4.577860, -1.713619, 2.848997>,
      < -4.582591, -1.709989, 2.837276>
    }
    triangle {
      < -4.571749, -1.723348, 2.852286>,
      < -4.582591, -1.709989, 2.837276>,
      < -4.576113, -1.720668, 2.840566>
    }
    triangle {
      < -4.577860, -1.713619, 2.848997>,
      < -4.565133, -1.713125, 2.853366>,
      < -4.569101, -1.709448, 2.841646>
    }
    triangle {
      < -4.577860, -1.713619, 2.848997>,
      < -4.569101, -1.709448, 2.841646>,
      < -4.582591, -1.709989, 2.837276>
    }
    triangle {
      < -4.565133, -1.713125, 2.853366>,
      < -4.556407, -1.712705, 2.856261>,
      < -4.554898, -1.708987, 2.845354>
    }
    triangle {
      < -4.565133, -1.713125, 2.853366>,
      < -4.554898, -1.708987, 2.845354>,
      < -4.569101, -1.709448, 2.841646>
    }
    triangle {
      < -4.556407, -1.712705, 2.856261>,
      < -4.543686, -1.722026, 2.859843>,
      < -4.542511, -1.719217, 2.848936>
    }
    triangle {
      < -4.556407, -1.712705, 2.856261>,
      < -4.542511, -1.719217, 2.848936>,
      < -4.554898, -1.708987, 2.845354>
    }
    triangle {
      < -4.543686, -1.722026, 2.859843>,
      < -4.526590, -1.721872, 2.862770>,
      < -4.528247, -1.719049, 2.851049>
    }
    triangle {
      < -4.543686, -1.722026, 2.859843>,
      < -4.528247, -1.719049, 2.851049>,
      < -4.542511, -1.719217, 2.848936>
    }
    triangle {
      < -4.526590, -1.721872, 2.862770>,
      < -4.512849, -1.721778, 2.864064>,
      < -4.513682, -1.718945, 2.852345>
    }
    triangle {
      < -4.526590, -1.721872, 2.862770>,
      < -4.513682, -1.718945, 2.852345>,
      < -4.528247, -1.719049, 2.851049>
    }
    triangle {
      < -4.512849, -1.721778, 2.864064>,
      < -4.498962, -1.721745, 2.864501>,
      < -4.498962, -1.718909, 2.852781>
    }
    triangle {
      < -4.512849, -1.721778, 2.864064>,
      < -4.498962, -1.718909, 2.852781>,
      < -4.513682, -1.718945, 2.852345>
    }
    triangle {
      < -4.498962, -1.721745, 2.864501>,
      < -4.485075, -1.721775, 2.864065>,
      < -4.484243, -1.718942, 2.852345>
    }
    triangle {
      < -4.498962, -1.721745, 2.864501>,
      < -4.484243, -1.718942, 2.852345>,
      < -4.498962, -1.718909, 2.852781>
    }
    triangle {
      < -4.485075, -1.721775, 2.864065>,
      < -4.471334, -1.721867, 2.862772>,
      < -4.469678, -1.719043, 2.851051>
    }
    triangle {
      < -4.485075, -1.721775, 2.864065>,
      < -4.469678, -1.719043, 2.851051>,
      < -4.484243, -1.718942, 2.852345>
    }
    triangle {
      < -4.471334, -1.721867, 2.862772>,
      < -4.454239, -1.722017, 2.859846>,
      < -4.455413, -1.719208, 2.848939>
    }
    triangle {
      < -4.471334, -1.721867, 2.862772>,
      < -4.455413, -1.719208, 2.848939>,
      < -4.469678, -1.719043, 2.851051>
    }
    triangle {
      < -4.454239, -1.722017, 2.859846>,
      < -4.441517, -1.712695, 2.856265>,
      < -4.443026, -1.708975, 2.845357>
    }
    triangle {
      < -4.454239, -1.722017, 2.859846>,
      < -4.443026, -1.708975, 2.845357>,
      < -4.455413, -1.719208, 2.848939>
    }
    triangle {
      < -4.441517, -1.712695, 2.856265>,
      < -4.432785, -1.713105, 2.853368>,
      < -4.428818, -1.709425, 2.841648>
    }
    triangle {
      < -4.441517, -1.712695, 2.856265>,
      < -4.428818, -1.709425, 2.841648>,
      < -4.443026, -1.708975, 2.845357>
    }
    triangle {
      < -4.432785, -1.713105, 2.853368>,
      < -4.420053, -1.713589, 2.848996>,
      < -4.415323, -1.709956, 2.837276>
    }
    triangle {
      < -4.432785, -1.713105, 2.853368>,
      < -4.415323, -1.709956, 2.837276>,
      < -4.428818, -1.709425, 2.841648>
    }
    triangle {
      < -4.420053, -1.713589, 2.848996>,
      < -4.426163, -1.723317, 2.852286>,
      < -4.421799, -1.720634, 2.840566>
    }
    triangle {
      < -4.420053, -1.713589, 2.848996>,
      < -4.421799, -1.720634, 2.840566>,
      < -4.415323, -1.709956, 2.837276>
    }
    triangle {
      < -4.426163, -1.723317, 2.852286>,
      < -4.420285, -1.730358, 2.850609>,
      < -4.415568, -1.728363, 2.838889>
    }
    triangle {
      < -4.426163, -1.723317, 2.852286>,
      < -4.415568, -1.728363, 2.838889>,
      < -4.421799, -1.720634, 2.840566>
    }
    triangle {
      < -4.420285, -1.730358, 2.850609>,
      < -4.417053, -1.737099, 2.849559>,
      < -4.412143, -1.735762, 2.837839>
    }
    triangle {
      < -4.420285, -1.730358, 2.850609>,
      < -4.412143, -1.735762, 2.837839>,
      < -4.415568, -1.728363, 2.838889>
    }
    triangle {
      < -4.417053, -1.737099, 2.849559>,
      < -4.417658, -1.739747, 2.849813>,
      < -4.412785, -1.738668, 2.838093>
    }
    triangle {
      < -4.417053, -1.737099, 2.849559>,
      < -4.412785, -1.738668, 2.838093>,
      < -4.412143, -1.735762, 2.837839>
    }
    triangle {
      < -4.417658, -1.739747, 2.849813>,
      < -4.419585, -1.742571, 2.850535>,
      < -4.414826, -1.741768, 2.838815>
    }
    triangle {
      < -4.417658, -1.739747, 2.849813>,
      < -4.414826, -1.741768, 2.838815>,
      < -4.412785, -1.738668, 2.838093>
    }
    texture {lfrim}
  }
  // brims
  union {
    triangle {
      < 5.032213, -1.623114, 2.842164>,
      < 5.033179, -1.629982, 2.828054>,
      < 5.048418, -1.628912, 2.828054>
    }
    triangle {
      < 5.017629, -1.519337, 2.813766>,
      < 5.032213, -1.623114, 2.842164>,
      < 5.034369, -1.518169, 2.813766>
    }
    triangle {
      < 5.041050, -1.413064, 2.769109>,
      < 5.003046, -1.415561, 2.769109>,
      < 5.017629, -1.519337, 2.813766>
    }
    triangle {
      < 5.041050, -1.413064, 2.769109>,
      < 5.017629, -1.519337, 2.813766>,
      < 5.034369, -1.518169, 2.813766>
    }
    triangle {
      < 5.034369, -1.518169, 2.813766>,
      < 5.048419, -1.514298, 2.792428>,
      < 5.048420, -1.399683, 2.756803>
    }
    triangle {
      < 5.034369, -1.518169, 2.813766>,
      < 5.048420, -1.399683, 2.756803>,
      < 5.041050, -1.413064, 2.769109>
    }
    triangle {
      < 5.048419, -1.378512, 2.779159>,
      < 4.998332, -1.382018, 2.779159>,
      < 5.001278, -1.402983, 2.756803>
    }
    triangle {
      < 5.048419, -1.378512, 2.779159>,
      < 5.001278, -1.402983, 2.756803>,
      < 5.048420, -1.399683, 2.756803>
    }
    triangle {
      < 5.048420, -1.293829, 2.764932>,
      < 4.996966, -1.295944, 2.764932>,
      < 4.998332, -1.382018, 2.779159>
    }
    triangle {
      < 5.048420, -1.293829, 2.764932>,
      < 4.998332, -1.382018, 2.779159>,
      < 5.048419, -1.378512, 2.779159>
    }
    triangle {
      < 5.048422, -1.257585, 2.663333>,
      < 4.992774, -1.259871, 2.663333>,
      < 4.996966, -1.295944, 2.764932>
    }
    triangle {
      < 5.048422, -1.257585, 2.663333>,
      < 4.996966, -1.295944, 2.764932>,
      < 5.048420, -1.293829, 2.764932>
    }
    triangle {
      < 5.048422, -1.174595, 2.663332>,
      < 4.969955, -1.180085, 2.663332>,
      < 4.992774, -1.259871, 2.663333>
    }
    triangle {
      < 5.048422, -1.174595, 2.663332>,
      < 4.992774, -1.259871, 2.663333>,
      < 5.048422, -1.257585, 2.663333>
    }
    triangle {
      < 5.048420, -1.166804, 2.744609>,
      < 4.968869, -1.172370, 2.744609>,
      < 4.969955, -1.180085, 2.663332>
    }
    triangle {
      < 5.048420, -1.166804, 2.744609>,
      < 4.969955, -1.180085, 2.663332>,
      < 5.048422, -1.174595, 2.663332>
    }
    triangle {
      < 5.048420, -1.103292, 2.736479>,
      < 4.960030, -1.109476, 2.736479>,
      < 4.968869, -1.172370, 2.744609>
    }
    triangle {
      < 5.048420, -1.103292, 2.736479>,
      < 4.968869, -1.172370, 2.744609>,
      < 5.048420, -1.166804, 2.744609>
    }
    triangle {
      < 5.048423, -1.103207, 2.633340>,
      < 4.960021, -1.109391, 2.633340>,
      < 4.960030, -1.109476, 2.736479>
    }
    triangle {
      < 5.048423, -1.103207, 2.633340>,
      < 4.960030, -1.109476, 2.736479>,
      < 5.048420, -1.103292, 2.736479>
    }
    triangle {
      < 5.032213, -1.623114, 2.842164>,
      < 5.016325, -1.626495, 2.842164>,
      < 5.018236, -1.633162, 2.828054>
    }
    triangle {
      < 5.032213, -1.623114, 2.842164>,
      < 5.018236, -1.633162, 2.828054>,
      < 5.033179, -1.629982, 2.828054>
    }
    triangle {
      < 5.017629, -1.519337, 2.813766>,
      < 4.987440, -1.525758, 2.813766>,
      < 5.016325, -1.626495, 2.842164>
    }
    triangle {
      < 5.017629, -1.519337, 2.813766>,
      < 5.016325, -1.626495, 2.842164>,
      < 5.032213, -1.623114, 2.842164>
    }
    triangle {
      < 5.003046, -1.415561, 2.769109>,
      < 4.958556, -1.425021, 2.769109>,
      < 4.987440, -1.525758, 2.813766>
    }
    triangle {
      < 5.003046, -1.415561, 2.769109>,
      < 4.987440, -1.525758, 2.813766>,
      < 5.017629, -1.519337, 2.813766>
    }
    triangle {
      < 5.001278, -1.402983, 2.756803>,
      < 4.955055, -1.412811, 2.756803>,
      < 4.958556, -1.425021, 2.769109>
    }
    triangle {
      < 5.001278, -1.402983, 2.756803>,
      < 4.958556, -1.425021, 2.769109>,
      < 5.003046, -1.415561, 2.769109>
    }
    triangle {
      < 4.998332, -1.382018, 2.779159>,
      < 4.949219, -1.392461, 2.779159>,
      < 4.955055, -1.412811, 2.756803>
    }
    triangle {
      < 4.998332, -1.382018, 2.779159>,
      < 4.955055, -1.412811, 2.756803>,
      < 5.001278, -1.402983, 2.756803>
    }
    triangle {
      < 4.915458, -1.313273, 2.764932>,
      < 4.949219, -1.392461, 2.779159>,
      < 4.947359, -1.326766, 2.768997>
    }
    triangle {
      < 4.904621, -1.278613, 2.663333>,
      < 4.915458, -1.313273, 2.764932>,
      < 4.947359, -1.326766, 2.768997>
    }
    triangle {
      < 4.904621, -1.278613, 2.663333>,
      < 4.947359, -1.326766, 2.768997>,
      < 4.939123, -1.293206, 2.663333>
    }
    triangle {
      < 4.992774, -1.259871, 2.663333>,
      < 4.904621, -1.278613, 2.663333>,
      < 4.939123, -1.293206, 2.663333>
    }
    triangle {
      < 4.992774, -1.259871, 2.663333>,
      < 4.939123, -1.293206, 2.663333>,
      < 4.967193, -1.287238, 2.663333>
    }
    triangle {
      < 4.968869, -1.172370, 2.744609>,
      < 4.890866, -1.188953, 2.744609>,
      < 4.893016, -1.196442, 2.663332>
    }
    triangle {
      < 4.968869, -1.172370, 2.744609>,
      < 4.893016, -1.196442, 2.663332>,
      < 4.969955, -1.180085, 2.663332>
    }
    triangle {
      < 4.960030, -1.109476, 2.736479>,
      < 4.873360, -1.127901, 2.736479>,
      < 4.890866, -1.188953, 2.744609>
    }
    triangle {
      < 4.960030, -1.109476, 2.736479>,
      < 4.890866, -1.188953, 2.744609>,
      < 4.968869, -1.172370, 2.744609>
    }
    triangle {
      < 4.960021, -1.109391, 2.633340>,
      < 4.873340, -1.127819, 2.633340>,
      < 4.873360, -1.127901, 2.736479>
    }
    triangle {
      < 4.960021, -1.109391, 2.633340>,
      < 4.873360, -1.127901, 2.736479>,
      < 4.960030, -1.109476, 2.736479>
    }
    triangle {
      < 5.016325, -1.626495, 2.842164>,
      < 5.001060, -1.632054, 2.842164>,
      < 5.003882, -1.638390, 2.828054>
    }
    triangle {
      < 5.016325, -1.626495, 2.842164>,
      < 5.003882, -1.638390, 2.828054>,
      < 5.018236, -1.633162, 2.828054>
    }
    triangle {
      < 4.987440, -1.525758, 2.813766>,
      < 4.958437, -1.536317, 2.813766>,
      < 5.001060, -1.632054, 2.842164>
    }
    triangle {
      < 4.987440, -1.525758, 2.813766>,
      < 5.001060, -1.632054, 2.842164>,
      < 5.016325, -1.626495, 2.842164>
    }
    triangle {
      < 4.958556, -1.425021, 2.769109>,
      < 4.915815, -1.440581, 2.769109>,
      < 4.958437, -1.536317, 2.813766>
    }
    triangle {
      < 4.958556, -1.425021, 2.769109>,
      < 4.958437, -1.536317, 2.813766>,
      < 4.987440, -1.525758, 2.813766>
    }
    triangle {
      < 4.955055, -1.412811, 2.756803>,
      < 4.910649, -1.428977, 2.756803>,
      < 4.915815, -1.440581, 2.769109>
    }
    triangle {
      < 4.955055, -1.412811, 2.756803>,
      < 4.915815, -1.440581, 2.769109>,
      < 4.958556, -1.425021, 2.769109>
    }
    triangle {
      < 4.949219, -1.392461, 2.779159>,
      < 4.902038, -1.409637, 2.779159>,
      < 4.910649, -1.428977, 2.756803>
    }
    triangle {
      < 4.949219, -1.392461, 2.779159>,
      < 4.910649, -1.428977, 2.756803>,
      < 4.955055, -1.412811, 2.756803>
    }
    triangle {
      < 4.915458, -1.313273, 2.764932>,
      < 4.867595, -1.332274, 2.764932>,
      < 4.902038, -1.409637, 2.779159>
    }
    triangle {
      < 4.915458, -1.313273, 2.764932>,
      < 4.902038, -1.409637, 2.779159>,
      < 4.949219, -1.392461, 2.779159>
    }
    triangle {
      < 4.904621, -1.278613, 2.663333>,
      < 4.852856, -1.299162, 2.663333>,
      < 4.867595, -1.332274, 2.764932>
    }
    triangle {
      < 4.904621, -1.278613, 2.663333>,
      < 4.867595, -1.332274, 2.764932>,
      < 4.915458, -1.313273, 2.764932>
    }
    triangle {
      < 4.893016, -1.196442, 2.663332>,
      < 4.819101, -1.223347, 2.663332>,
      < 4.852856, -1.299162, 2.663333>
    }
    triangle {
      < 4.893016, -1.196442, 2.663332>,
      < 4.852856, -1.299162, 2.663333>,
      < 4.904621, -1.278613, 2.663333>
    }
    triangle {
      < 4.890866, -1.188953, 2.744609>,
      < 4.815930, -1.216231, 2.744609>,
      < 4.819101, -1.223347, 2.663332>
    }
    triangle {
      < 4.890866, -1.188953, 2.744609>,
      < 4.819101, -1.223347, 2.663332>,
      < 4.893016, -1.196442, 2.663332>
    }
    triangle {
      < 4.873360, -1.127901, 2.736479>,
      < 4.790098, -1.158209, 2.736479>,
      < 4.815930, -1.216231, 2.744609>
    }
    triangle {
      < 4.873360, -1.127901, 2.736479>,
      < 4.815930, -1.216231, 2.744609>,
      < 4.890866, -1.188953, 2.744609>
    }
    triangle {
      < 4.873340, -1.127819, 2.633340>,
      < 4.790066, -1.158131, 2.633340>,
      < 4.790098, -1.158209, 2.736479>
    }
    triangle {
      < 4.873340, -1.127819, 2.633340>,
      < 4.790098, -1.158209, 2.736479>,
      < 4.873360, -1.127901, 2.736479>
    }
    triangle {
      < 5.001060, -1.632054, 2.842164>,
      < 4.986719, -1.639683, 2.842164>,
      < 4.990395, -1.645565, 2.828054>
    }
    triangle {
      < 5.001060, -1.632054, 2.842164>,
      < 4.990395, -1.645565, 2.828054>,
      < 5.003882, -1.638390, 2.828054>
    }
    triangle {
      < 4.958437, -1.536317, 2.813766>,
      < 4.931187, -1.550811, 2.813766>,
      < 4.986719, -1.639683, 2.842164>
    }
    triangle {
      < 4.958437, -1.536317, 2.813766>,
      < 4.986719, -1.639683, 2.842164>,
      < 5.001060, -1.632054, 2.842164>
    }
    triangle {
      < 4.915815, -1.440581, 2.769109>,
      < 4.875656, -1.461937, 2.769109>,
      < 4.931187, -1.550811, 2.813766>
    }
    triangle {
      < 4.915815, -1.440581, 2.769109>,
      < 4.931187, -1.550811, 2.813766>,
      < 4.958437, -1.536317, 2.813766>
    }
    triangle {
      < 4.910649, -1.428977, 2.756803>,
      < 4.868925, -1.451166, 2.756803>,
      < 4.875656, -1.461937, 2.769109>
    }
    triangle {
      < 4.910649, -1.428977, 2.756803>,
      < 4.875656, -1.461937, 2.769109>,
      < 4.915815, -1.440581, 2.769109>
    }
    triangle {
      < 4.902038, -1.409637, 2.779159>,
      < 4.857706, -1.433212, 2.779159>,
      < 4.868925, -1.451166, 2.756803>
    }
    triangle {
      < 4.902038, -1.409637, 2.779159>,
      < 4.868925, -1.451166, 2.756803>,
      < 4.910649, -1.428977, 2.756803>
    }
    triangle {
      < 4.867595, -1.332274, 2.764932>,
      < 4.821450, -1.355134, 2.764932>,
      < 4.857706, -1.433212, 2.779159>
    }
    triangle {
      < 4.867595, -1.332274, 2.764932>,
      < 4.857706, -1.433212, 2.779159>,
      < 4.902038, -1.409637, 2.779159>
    }
    triangle {
      < 4.852856, -1.299162, 2.663333>,
      < 4.802948, -1.323885, 2.663333>,
      < 4.821450, -1.355134, 2.764932>
    }
    triangle {
      < 4.852856, -1.299162, 2.663333>,
      < 4.821450, -1.355134, 2.764932>,
      < 4.867595, -1.332274, 2.764932>
    }
    triangle {
      < 4.819101, -1.223347, 2.663332>,
      < 4.749650, -1.260278, 2.663332>,
      < 4.802948, -1.323885, 2.663333>
    }
    triangle {
      < 4.819101, -1.223347, 2.663332>,
      < 4.802948, -1.323885, 2.663333>,
      < 4.852856, -1.299162, 2.663333>
    }
    triangle {
      < 4.815930, -1.216231, 2.744609>,
      < 4.745521, -1.253672, 2.744609>,
      < 4.749650, -1.260278, 2.663332>
    }
    triangle {
      < 4.815930, -1.216231, 2.744609>,
      < 4.749650, -1.260278, 2.663332>,
      < 4.819101, -1.223347, 2.663332>
    }
    triangle {
      < 4.790098, -1.158209, 2.736479>,
      < 4.711864, -1.199810, 2.736479>,
      < 4.745521, -1.253672, 2.744609>
    }
    triangle {
      < 4.790098, -1.158209, 2.736479>,
      < 4.745521, -1.253672, 2.744609>,
      < 4.815930, -1.216231, 2.744609>
    }
    triangle {
      < 4.790066, -1.158131, 2.633340>,
      < 4.711822, -1.199736, 2.633340>,
      < 4.711864, -1.199810, 2.736479>
    }
    triangle {
      < 4.790066, -1.158131, 2.633340>,
      < 4.711864, -1.199810, 2.736479>,
      < 4.790098, -1.158209, 2.736479>
    }
    triangle {
      < 4.986719, -1.639683, 2.842164>,
      < 4.973579, -1.649235, 2.842164>,
      < 4.978038, -1.654548, 2.828054>
    }
    triangle {
      < 4.986719, -1.639683, 2.842164>,
      < 4.978038, -1.654548, 2.828054>,
      < 4.990395, -1.645565, 2.828054>
    }
    triangle {
      < 4.931187, -1.550811, 2.813766>,
      < 4.906219, -1.568955, 2.813766>,
      < 4.973579, -1.649235, 2.842164>
    }
    triangle {
      < 4.931187, -1.550811, 2.813766>,
      < 4.973579, -1.649235, 2.842164>,
      < 4.986719, -1.639683, 2.842164>
    }
    triangle {
      < 4.875656, -1.461937, 2.769109>,
      < 4.838860, -1.488675, 2.769109>,
      < 4.906219, -1.568955, 2.813766>
    }
    triangle {
      < 4.875656, -1.461937, 2.769109>,
      < 4.906219, -1.568955, 2.813766>,
      < 4.931187, -1.550811, 2.813766>
    }
    triangle {
      < 4.868925, -1.451166, 2.756803>,
      < 4.830696, -1.478945, 2.756803>,
      < 4.838860, -1.488675, 2.769109>
    }
    triangle {
      < 4.868925, -1.451166, 2.756803>,
      < 4.838860, -1.488675, 2.769109>,
      < 4.875656, -1.461937, 2.769109>
    }
    triangle {
      < 4.857706, -1.433212, 2.779159>,
      < 4.817087, -1.462727, 2.779159>,
      < 4.830696, -1.478945, 2.756803>
    }
    triangle {
      < 4.857706, -1.433212, 2.779159>,
      < 4.830696, -1.478945, 2.756803>,
      < 4.868925, -1.451166, 2.756803>
    }
    triangle {
      < 4.754036, -1.404117, 2.764932>,
      < 4.817087, -1.462727, 2.779159>,
      < 4.788668, -1.403468, 2.768997>
    }
    triangle {
      < 4.730039, -1.376861, 2.663333>,
      < 4.754036, -1.404117, 2.764932>,
      < 4.788668, -1.403468, 2.768997>
    }
    triangle {
      < 4.730039, -1.376861, 2.663333>,
      < 4.788668, -1.403468, 2.768997>,
      < 4.767493, -1.376160, 2.663333>
    }
    triangle {
      < 4.802948, -1.323885, 2.663333>,
      < 4.730039, -1.376861, 2.663333>,
      < 4.767493, -1.376160, 2.663333>
    }
    triangle {
      < 4.802948, -1.323885, 2.663333>,
      < 4.767493, -1.376160, 2.663333>,
      < 4.790710, -1.359290, 2.663333>
    }
    triangle {
      < 4.745521, -1.253672, 2.744609>,
      < 4.681006, -1.300547, 2.744609>,
      < 4.686016, -1.306514, 2.663332>
    }
    triangle {
      < 4.745521, -1.253672, 2.744609>,
      < 4.686016, -1.306514, 2.663332>,
      < 4.749650, -1.260278, 2.663332>
    }
    triangle {
      < 4.711864, -1.199810, 2.736479>,
      < 4.640182, -1.251893, 2.736479>,
      < 4.681006, -1.300547, 2.744609>
    }
    triangle {
      < 4.711864, -1.199810, 2.736479>,
      < 4.681006, -1.300547, 2.744609>,
      < 4.745521, -1.253672, 2.744609>
    }
    triangle {
      < 4.711822, -1.199736, 2.633340>,
      < 4.640130, -1.251827, 2.633340>,
      < 4.640182, -1.251893, 2.736479>
    }
    triangle {
      < 4.711822, -1.199736, 2.633340>,
      < 4.640182, -1.251893, 2.736479>,
      < 4.711864, -1.199810, 2.736479>
    }
    triangle {
      < 4.973579, -1.649235, 2.842164>,
      < 4.961896, -1.660522, 2.842164>,
      < 4.967051, -1.665163, 2.828054>
    }
    triangle {
      < 4.973579, -1.649235, 2.842164>,
      < 4.967051, -1.665163, 2.828054>,
      < 4.978038, -1.654548, 2.828054>
    }
    triangle {
      < 4.906219, -1.568955, 2.813766>,
      < 4.884019, -1.590398, 2.813766>,
      < 4.961896, -1.660522, 2.842164>
    }
    triangle {
      < 4.906219, -1.568955, 2.813766>,
      < 4.961896, -1.660522, 2.842164>,
      < 4.973579, -1.649235, 2.842164>
    }
    triangle {
      < 4.838860, -1.488675, 2.769109>,
      < 4.806142, -1.520274, 2.769109>,
      < 4.884019, -1.590398, 2.813766>
    }
    triangle {
      < 4.838860, -1.488675, 2.769109>,
      < 4.884019, -1.590398, 2.813766>,
      < 4.906219, -1.568955, 2.813766>
    }
    triangle {
      < 4.830696, -1.478945, 2.756803>,
      < 4.796704, -1.511774, 2.756803>,
      < 4.806142, -1.520274, 2.769109>
    }
    triangle {
      < 4.830696, -1.478945, 2.756803>,
      < 4.806142, -1.520274, 2.769109>,
      < 4.838860, -1.488675, 2.769109>
    }
    triangle {
      < 4.817087, -1.462727, 2.779159>,
      < 4.780971, -1.497608, 2.779159>,
      < 4.796704, -1.511774, 2.756803>
    }
    triangle {
      < 4.817087, -1.462727, 2.779159>,
      < 4.796704, -1.511774, 2.756803>,
      < 4.830696, -1.478945, 2.756803>
    }
    triangle {
      < 4.754036, -1.404117, 2.764932>,
      < 4.718040, -1.440943, 2.764932>,
      < 4.780971, -1.497608, 2.779159>
    }
    triangle {
      < 4.754036, -1.404117, 2.764932>,
      < 4.780971, -1.497608, 2.779159>,
      < 4.817087, -1.462727, 2.779159>
    }
    triangle {
      < 4.730039, -1.376861, 2.663333>,
      < 4.691107, -1.416689, 2.663333>,
      < 4.718040, -1.440943, 2.764932>
    }
    triangle {
      < 4.730039, -1.376861, 2.663333>,
      < 4.718040, -1.440943, 2.764932>,
      < 4.754036, -1.404117, 2.764932>
    }
    triangle {
      < 4.686016, -1.306514, 2.663332>,
      < 4.629435, -1.361157, 2.663332>,
      < 4.691107, -1.416689, 2.663333>
    }
    triangle {
      < 4.686016, -1.306514, 2.663332>,
      < 4.691107, -1.416689, 2.663333>,
      < 4.730039, -1.376861, 2.663333>
    }
    triangle {
      < 4.681006, -1.300547, 2.744609>,
      < 4.623643, -1.355945, 2.744609>,
      < 4.629435, -1.361157, 2.663332>
    }
    triangle {
      < 4.681006, -1.300547, 2.744609>,
      < 4.629435, -1.361157, 2.663332>,
      < 4.686016, -1.306514, 2.663332>
    }
    triangle {
      < 4.640182, -1.251893, 2.736479>,
      < 4.576445, -1.313446, 2.736479>,
      < 4.623643, -1.355945, 2.744609>
    }
    triangle {
      < 4.640182, -1.251893, 2.736479>,
      < 4.623643, -1.355945, 2.744609>,
      < 4.681006, -1.300547, 2.744609>
    }
    triangle {
      < 4.640130, -1.251827, 2.633340>,
      < 4.576384, -1.313388, 2.633340>,
      < 4.576445, -1.313446, 2.736479>
    }
    triangle {
      < 4.640130, -1.251827, 2.633340>,
      < 4.576445, -1.313446, 2.736479>,
      < 4.640182, -1.251893, 2.736479>
    }
    triangle {
      < 4.961896, -1.660522, 2.842164>,
      < 4.951898, -1.673325, 2.842164>,
      < 4.957648, -1.677203, 2.828054>
    }
    triangle {
      < 4.961896, -1.660522, 2.842164>,
      < 4.957648, -1.677203, 2.828054>,
      < 4.967051, -1.665163, 2.828054>
    }
    triangle {
      < 4.884019, -1.590398, 2.813766>,
      < 4.865019, -1.614722, 2.813766>,
      < 4.951898, -1.673325, 2.842164>
    }
    triangle {
      < 4.884019, -1.590398, 2.813766>,
      < 4.951898, -1.673325, 2.842164>,
      < 4.961896, -1.660522, 2.842164>
    }
    triangle {
      < 4.806142, -1.520274, 2.769109>,
      < 4.778141, -1.556118, 2.769109>,
      < 4.865019, -1.614722, 2.813766>
    }
    triangle {
      < 4.806142, -1.520274, 2.769109>,
      < 4.865019, -1.614722, 2.813766>,
      < 4.884019, -1.590398, 2.813766>
    }
    triangle {
      < 4.796704, -1.511774, 2.756803>,
      < 4.767612, -1.549015, 2.756803>,
      < 4.778141, -1.556118, 2.769109>
    }
    triangle {
      < 4.796704, -1.511774, 2.756803>,
      < 4.778141, -1.556118, 2.769109>,
      < 4.806142, -1.520274, 2.769109>
    }
    triangle {
      < 4.780971, -1.497608, 2.779159>,
      < 4.750060, -1.537177, 2.779159>,
      < 4.767612, -1.549015, 2.756803>
    }
    triangle {
      < 4.780971, -1.497608, 2.779159>,
      < 4.767612, -1.549015, 2.756803>,
      < 4.796704, -1.511774, 2.756803>
    }
    triangle {
      < 4.718040, -1.440943, 2.764932>,
      < 4.685182, -1.480595, 2.764932>,
      < 4.750060, -1.537177, 2.779159>
    }
    triangle {
      < 4.718040, -1.440943, 2.764932>,
      < 4.750060, -1.537177, 2.779159>,
      < 4.780971, -1.497608, 2.779159>
    }
    triangle {
      < 4.691107, -1.416689, 2.663333>,
      < 4.655570, -1.459573, 2.663333>,
      < 4.685182, -1.480595, 2.764932>
    }
    triangle {
      < 4.691107, -1.416689, 2.663333>,
      < 4.685182, -1.480595, 2.764932>,
      < 4.718040, -1.440943, 2.764932>
    }
    triangle {
      < 4.629435, -1.361157, 2.663332>,
      < 4.581008, -1.423142, 2.663332>,
      < 4.655570, -1.459573, 2.663333>
    }
    triangle {
      < 4.629435, -1.361157, 2.663332>,
      < 4.655570, -1.459573, 2.663333>,
      < 4.691107, -1.416689, 2.663333>
    }
    triangle {
      < 4.623643, -1.355945, 2.744609>,
      < 4.574549, -1.418787, 2.744609>,
      < 4.581008, -1.423142, 2.663332>
    }
    triangle {
      < 4.623643, -1.355945, 2.744609>,
      < 4.581008, -1.423142, 2.663332>,
      < 4.629435, -1.361157, 2.663332>
    }
    triangle {
      < 4.576445, -1.313446, 2.736479>,
      < 4.521895, -1.383270, 2.736479>,
      < 4.574549, -1.418787, 2.744609>
    }
    triangle {
      < 4.576445, -1.313446, 2.736479>,
      < 4.574549, -1.418787, 2.744609>,
      < 4.623643, -1.355945, 2.744609>
    }
    triangle {
      < 4.576384, -1.313388, 2.633340>,
      < 4.521826, -1.383221, 2.633340>,
      < 4.521895, -1.383270, 2.736479>
    }
    triangle {
      < 4.576384, -1.313388, 2.633340>,
      < 4.521895, -1.383270, 2.736479>,
      < 4.576445, -1.313446, 2.736479>
    }
    triangle {
      < 4.951898, -1.673325, 2.842164>,
      < 4.943779, -1.687395, 2.842164>,
      < 4.950013, -1.690435, 2.828054>
    }
    triangle {
      < 4.951898, -1.673325, 2.842164>,
      < 4.950013, -1.690435, 2.828054>,
      < 4.957648, -1.677203, 2.828054>
    }
    triangle {
      < 4.865019, -1.614722, 2.813766>,
      < 4.849590, -1.641453, 2.813766>,
      < 4.943779, -1.687395, 2.842164>
    }
    triangle {
      < 4.865019, -1.614722, 2.813766>,
      < 4.943779, -1.687395, 2.842164>,
      < 4.951898, -1.673325, 2.842164>
    }
    triangle {
      < 4.778141, -1.556118, 2.769109>,
      < 4.755401, -1.595510, 2.769109>,
      < 4.849590, -1.641453, 2.813766>
    }
    triangle {
      < 4.778141, -1.556118, 2.769109>,
      < 4.849590, -1.641453, 2.813766>,
      < 4.865019, -1.614722, 2.813766>
    }
    triangle {
      < 4.767612, -1.549015, 2.756803>,
      < 4.743986, -1.589942, 2.756803>,
      < 4.755401, -1.595510, 2.769109>
    }
    triangle {
      < 4.767612, -1.549015, 2.756803>,
      < 4.755401, -1.595510, 2.769109>,
      < 4.778141, -1.556118, 2.769109>
    }
    triangle {
      < 4.750060, -1.537177, 2.779159>,
      < 4.724957, -1.580661, 2.779159>,
      < 4.743986, -1.589942, 2.756803>
    }
    triangle {
      < 4.750060, -1.537177, 2.779159>,
      < 4.743986, -1.589942, 2.756803>,
      < 4.767612, -1.549015, 2.756803>
    }
    triangle {
      < 4.643519, -1.552763, 2.764932>,
      < 4.724957, -1.580661, 2.779159>,
      < 4.674892, -1.538084, 2.768997>
    }
    triangle {
      < 4.610510, -1.537623, 2.663333>,
      < 4.643519, -1.552763, 2.764932>,
      < 4.674892, -1.538084, 2.768997>
    }
    triangle {
      < 4.610510, -1.537623, 2.663333>,
      < 4.674892, -1.538084, 2.768997>,
      < 4.644442, -1.521749, 2.663333>
    }
    triangle {
      < 4.655570, -1.459573, 2.663333>,
      < 4.610510, -1.537623, 2.663333>,
      < 4.644442, -1.521749, 2.663333>
    }
    triangle {
      < 4.655570, -1.459573, 2.663333>,
      < 4.644442, -1.521749, 2.663333>,
      < 4.658790, -1.496895, 2.663333>
    }
    triangle {
      < 4.574549, -1.418787, 2.744609>,
      < 4.534678, -1.487850, 2.744609>,
      < 4.541680, -1.491264, 2.663332>
    }
    triangle {
      < 4.574549, -1.418787, 2.744609>,
      < 4.541680, -1.491264, 2.663332>,
      < 4.581008, -1.423142, 2.663332>
    }
    triangle {
      < 4.521895, -1.383270, 2.736479>,
      < 4.477593, -1.460007, 2.736479>,
      < 4.534678, -1.487850, 2.744609>
    }
    triangle {
      < 4.521895, -1.383270, 2.736479>,
      < 4.534678, -1.487850, 2.744609>,
      < 4.574549, -1.418787, 2.744609>
    }
    triangle {
      < 4.521826, -1.383221, 2.633340>,
      < 4.477518, -1.459967, 2.633340>,
      < 4.477593, -1.460007, 2.736479>
    }
    triangle {
      < 4.521826, -1.383221, 2.633340>,
      < 4.477593, -1.460007, 2.736479>,
      < 4.521895, -1.383270, 2.736479>
    }
    triangle {
      < 4.943779, -1.687395, 2.842164>,
      < 4.937696, -1.702458, 2.842164>,
      < 4.944293, -1.704601, 2.828054>
    }
    triangle {
      < 4.943779, -1.687395, 2.842164>,
      < 4.944293, -1.704601, 2.828054>,
      < 4.950013, -1.690435, 2.828054>
    }
    triangle {
      < 4.849590, -1.641453, 2.813766>,
      < 4.838031, -1.670071, 2.813766>,
      < 4.937696, -1.702458, 2.842164>
    }
    triangle {
      < 4.849590, -1.641453, 2.813766>,
      < 4.937696, -1.702458, 2.842164>,
      < 4.943779, -1.687395, 2.842164>
    }
    triangle {
      < 4.755401, -1.595510, 2.769109>,
      < 4.738365, -1.637684, 2.769109>,
      < 4.838031, -1.670071, 2.813766>
    }
    triangle {
      < 4.755401, -1.595510, 2.769109>,
      < 4.838031, -1.670071, 2.813766>,
      < 4.849590, -1.641453, 2.813766>
    }
    triangle {
      < 4.743986, -1.589942, 2.756803>,
      < 4.726285, -1.633759, 2.756803>,
      < 4.738365, -1.637684, 2.769109>
    }
    triangle {
      < 4.743986, -1.589942, 2.756803>,
      < 4.738365, -1.637684, 2.769109>,
      < 4.755401, -1.595510, 2.769109>
    }
    triangle {
      < 4.724957, -1.580661, 2.779159>,
      < 4.706151, -1.627217, 2.779159>,
      < 4.726285, -1.633759, 2.756803>
    }
    triangle {
      < 4.724957, -1.580661, 2.779159>,
      < 4.726285, -1.633759, 2.756803>,
      < 4.743986, -1.589942, 2.756803>
    }
    triangle {
      < 4.643519, -1.552763, 2.764932>,
      < 4.625612, -1.601046, 2.764932>,
      < 4.706151, -1.627217, 2.779159>
    }
    triangle {
      < 4.643519, -1.552763, 2.764932>,
      < 4.706151, -1.627217, 2.779159>,
      < 4.724957, -1.580661, 2.779159>
    }
    triangle {
      < 4.610510, -1.537623, 2.663333>,
      < 4.591143, -1.589843, 2.663333>,
      < 4.625612, -1.601046, 2.764932>
    }
    triangle {
      < 4.610510, -1.537623, 2.663333>,
      < 4.625612, -1.601046, 2.764932>,
      < 4.643519, -1.552763, 2.764932>
    }
    triangle {
      < 4.541680, -1.491264, 2.663332>,
      < 4.512216, -1.564196, 2.663332>,
      < 4.591143, -1.589843, 2.663333>
    }
    triangle {
      < 4.541680, -1.491264, 2.663332>,
      < 4.591143, -1.589843, 2.663333>,
      < 4.610510, -1.537623, 2.663333>
    }
    triangle {
      < 4.534678, -1.487850, 2.744609>,
      < 4.504806, -1.561790, 2.744609>,
      < 4.512216, -1.564196, 2.663332>
    }
    triangle {
      < 4.534678, -1.487850, 2.744609>,
      < 4.512216, -1.564196, 2.663332>,
      < 4.541680, -1.491264, 2.663332>
    }
    triangle {
      < 4.477593, -1.460007, 2.736479>,
      < 4.444402, -1.542162, 2.736479>,
      < 4.504806, -1.561790, 2.744609>
    }
    triangle {
      < 4.477593, -1.460007, 2.736479>,
      < 4.504806, -1.561790, 2.744609>,
      < 4.534678, -1.487850, 2.744609>
    }
    triangle {
      < 4.477518, -1.459967, 2.633340>,
      < 4.444323, -1.542133, 2.633340>,
      < 4.444402, -1.542162, 2.736479>
    }
    triangle {
      < 4.477518, -1.459967, 2.633340>,
      < 4.444402, -1.542162, 2.736479>,
      < 4.477593, -1.460007, 2.736479>
    }
    triangle {
      < 4.937696, -1.702458, 2.842164>,
      < 4.933770, -1.718220, 2.842164>,
      < 4.940600, -1.719425, 2.828054>
    }
    triangle {
      < 4.937696, -1.702458, 2.842164>,
      < 4.940600, -1.719425, 2.828054>,
      < 4.944293, -1.704601, 2.828054>
    }
    triangle {
      < 4.838031, -1.670071, 2.813766>,
      < 4.830566, -1.700020, 2.813766>,
      < 4.933770, -1.718220, 2.842164>
    }
    triangle {
      < 4.838031, -1.670071, 2.813766>,
      < 4.933770, -1.718220, 2.842164>,
      < 4.937696, -1.702458, 2.842164>
    }
    triangle {
      < 4.738365, -1.637684, 2.769109>,
      < 4.727363, -1.681818, 2.769109>,
      < 4.830566, -1.700020, 2.813766>
    }
    triangle {
      < 4.738365, -1.637684, 2.769109>,
      < 4.830566, -1.700020, 2.813766>,
      < 4.838031, -1.670071, 2.813766>
    }
    triangle {
      < 4.726285, -1.633759, 2.756803>,
      < 4.714855, -1.679612, 2.756803>,
      < 4.727363, -1.681818, 2.769109>
    }
    triangle {
      < 4.726285, -1.633759, 2.756803>,
      < 4.727363, -1.681818, 2.769109>,
      < 4.738365, -1.637684, 2.769109>
    }
    triangle {
      < 4.706151, -1.627217, 2.779159>,
      < 4.694005, -1.675936, 2.779159>,
      < 4.714855, -1.679612, 2.756803>
    }
    triangle {
      < 4.706151, -1.627217, 2.779159>,
      < 4.714855, -1.679612, 2.756803>,
      < 4.726285, -1.633759, 2.756803>
    }
    triangle {
      < 4.625612, -1.601046, 2.764932>,
      < 4.611722, -1.650634, 2.764932>,
      < 4.694005, -1.675936, 2.779159>
    }
    triangle {
      < 4.625612, -1.601046, 2.764932>,
      < 4.694005, -1.675936, 2.779159>,
      < 4.706151, -1.627217, 2.779159>
    }
    triangle {
      < 4.591143, -1.589843, 2.663333>,
      < 4.576120, -1.643473, 2.663333>,
      < 4.611722, -1.650634, 2.764932>
    }
    triangle {
      < 4.591143, -1.589843, 2.663333>,
      < 4.611722, -1.650634, 2.764932>,
      < 4.625612, -1.601046, 2.764932>
    }
    triangle {
      < 4.512216, -1.564196, 2.663332>,
      < 4.493187, -1.640519, 2.663332>,
      < 4.576120, -1.643473, 2.663333>
    }
    triangle {
      < 4.512216, -1.564196, 2.663332>,
      < 4.576120, -1.643473, 2.663333>,
      < 4.591143, -1.589843, 2.663333>
    }
    triangle {
      < 4.504806, -1.561790, 2.744609>,
      < 4.485515, -1.639168, 2.744609>,
      < 4.493187, -1.640519, 2.663332>
    }
    triangle {
      < 4.504806, -1.561790, 2.744609>,
      < 4.493187, -1.640519, 2.663332>,
      < 4.512216, -1.564196, 2.663332>
    }
    triangle {
      < 4.444402, -1.542162, 2.736479>,
      < 4.422968, -1.628137, 2.736479>,
      < 4.485515, -1.639168, 2.744609>
    }
    triangle {
      < 4.444402, -1.542162, 2.736479>,
      < 4.485515, -1.639168, 2.744609>,
      < 4.504806, -1.561790, 2.744609>
    }
    triangle {
      < 4.444323, -1.542133, 2.633340>,
      < 4.422885, -1.628120, 2.633340>,
      < 4.422968, -1.628137, 2.736479>
    }
    triangle {
      < 4.444323, -1.542133, 2.633340>,
      < 4.422968, -1.628137, 2.736479>,
      < 4.444402, -1.542162, 2.736479>
    }
    triangle {
      < 4.933770, -1.718220, 2.842164>,
      < 4.932076, -1.734376, 2.842164>,
      < 4.939007, -1.734618, 2.828054>
    }
    triangle {
      < 4.933770, -1.718220, 2.842164>,
      < 4.939007, -1.734618, 2.828054>,
      < 4.940600, -1.719425, 2.828054>
    }
    triangle {
      < 4.830566, -1.700020, 2.813766>,
      < 4.827343, -1.730716, 2.813766>,
      < 4.932076, -1.734376, 2.842164>
    }
    triangle {
      < 4.830566, -1.700020, 2.813766>,
      < 4.932076, -1.734376, 2.842164>,
      < 4.933770, -1.718220, 2.842164>
    }
    triangle {
      < 4.727363, -1.681818, 2.769109>,
      < 4.722611, -1.727054, 2.769109>,
      < 4.827343, -1.730716, 2.813766>
    }
    triangle {
      < 4.727363, -1.681818, 2.769109>,
      < 4.827343, -1.730716, 2.813766>,
      < 4.830566, -1.700020, 2.813766>
    }
    triangle {
      < 4.714855, -1.679612, 2.756803>,
      < 4.709918, -1.726610, 2.756803>,
      < 4.722611, -1.727054, 2.769109>
    }
    triangle {
      < 4.714855, -1.679612, 2.756803>,
      < 4.722611, -1.727054, 2.769109>,
      < 4.727363, -1.681818, 2.769109>
    }
    triangle {
      < 4.694005, -1.675936, 2.779159>,
      < 4.688759, -1.725872, 2.779159>,
      < 4.709918, -1.726610, 2.756803>
    }
    triangle {
      < 4.694005, -1.675936, 2.779159>,
      < 4.709918, -1.726610, 2.756803>,
      < 4.714855, -1.679612, 2.756803>
    }
    triangle {
      < 4.603015, -1.733508, 2.764932>,
      < 4.688759, -1.725872, 2.779159>,
      < 4.625706, -1.707338, 2.768997>
    }
    triangle {
      < 4.566702, -1.733103, 2.663333>,
      < 4.603015, -1.733508, 2.764932>,
      < 4.625706, -1.707338, 2.768997>
    }
    triangle {
      < 4.566702, -1.733103, 2.663333>,
      < 4.625706, -1.707338, 2.768997>,
      < 4.591243, -1.704800, 2.663333>
    }
    triangle {
      < 4.576120, -1.643473, 2.663333>,
      < 4.566702, -1.733103, 2.663333>,
      < 4.591243, -1.704800, 2.663333>
    }
    triangle {
      < 4.576120, -1.643473, 2.663333>,
      < 4.591243, -1.704800, 2.663333>,
      < 4.594242, -1.676260, 2.663333>
    }
    triangle {
      < 4.485515, -1.639168, 2.744609>,
      < 4.477180, -1.718477, 2.744609>,
      < 4.484967, -1.718747, 2.663332>
    }
    triangle {
      < 4.485515, -1.639168, 2.744609>,
      < 4.484967, -1.718747, 2.663332>,
      < 4.493187, -1.640519, 2.663332>
    }
    triangle {
      < 4.422968, -1.628137, 2.736479>,
      < 4.413707, -1.716258, 2.736479>,
      < 4.477180, -1.718477, 2.744609>
    }
    triangle {
      < 4.422968, -1.628137, 2.736479>,
      < 4.477180, -1.718477, 2.744609>,
      < 4.485515, -1.639168, 2.744609>
    }
    triangle {
      < 4.422885, -1.628120, 2.633340>,
      < 4.413622, -1.716253, 2.633340>,
      < 4.413707, -1.716258, 2.736479>
    }
    triangle {
      < 4.422885, -1.628120, 2.633340>,
      < 4.413707, -1.716258, 2.736479>,
      < 4.422968, -1.628137, 2.736479>
    }
    triangle {
      < 4.932076, -1.734376, 2.842164>,
      < 4.932646, -1.750611, 2.842164>,
      < 4.939544, -1.749886, 2.828054>
    }
    triangle {
      < 4.932076, -1.734376, 2.842164>,
      < 4.939544, -1.749886, 2.828054>,
      < 4.939007, -1.734618, 2.828054>
    }
    triangle {
      < 4.827343, -1.730716, 2.813766>,
      < 4.828423, -1.761561, 2.813766>,
      < 4.932646, -1.750611, 2.842164>
    }
    triangle {
      < 4.827343, -1.730716, 2.813766>,
      < 4.932646, -1.750611, 2.842164>,
      < 4.932076, -1.734376, 2.842164>
    }
    triangle {
      < 4.722611, -1.727054, 2.769109>,
      < 4.724201, -1.772511, 2.769109>,
      < 4.828423, -1.761561, 2.813766>
    }
    triangle {
      < 4.722611, -1.727054, 2.769109>,
      < 4.828423, -1.761561, 2.813766>,
      < 4.827343, -1.730716, 2.813766>
    }
    triangle {
      < 4.709918, -1.726610, 2.756803>,
      < 4.711569, -1.773839, 2.756803>,
      < 4.724201, -1.772511, 2.769109>
    }
    triangle {
      < 4.709918, -1.726610, 2.756803>,
      < 4.724201, -1.772511, 2.769109>,
      < 4.722611, -1.727054, 2.769109>
    }
    triangle {
      < 4.688759, -1.725872, 2.779159>,
      < 4.690514, -1.776051, 2.779159>,
      < 4.711569, -1.773839, 2.756803>
    }
    triangle {
      < 4.688759, -1.725872, 2.779159>,
      < 4.711569, -1.773839, 2.756803>,
      < 4.709918, -1.726610, 2.756803>
    }
    triangle {
      < 4.603015, -1.733508, 2.764932>,
      < 4.606295, -1.784901, 2.764932>,
      < 4.690514, -1.776051, 2.779159>
    }
    triangle {
      < 4.603015, -1.733508, 2.764932>,
      < 4.690514, -1.776051, 2.779159>,
      < 4.688759, -1.725872, 2.779159>
    }
    triangle {
      < 4.566702, -1.733103, 2.663333>,
      < 4.570248, -1.788685, 2.663333>,
      < 4.606295, -1.784901, 2.764932>
    }
    triangle {
      < 4.566702, -1.733103, 2.663333>,
      < 4.606295, -1.784901, 2.764932>,
      < 4.603015, -1.733508, 2.764932>
    }
    triangle {
      < 4.484967, -1.718747, 2.663332>,
      < 4.487713, -1.797358, 2.663332>,
      < 4.570248, -1.788685, 2.663333>
    }
    triangle {
      < 4.484967, -1.718747, 2.663332>,
      < 4.570248, -1.788685, 2.663333>,
      < 4.566702, -1.733103, 2.663333>
    }
    triangle {
      < 4.477180, -1.718477, 2.744609>,
      < 4.479965, -1.798174, 2.744609>,
      < 4.487713, -1.797358, 2.663332>
    }
    triangle {
      < 4.477180, -1.718477, 2.744609>,
      < 4.487713, -1.797358, 2.663332>,
      < 4.484967, -1.718747, 2.663332>
    }
    triangle {
      < 4.413707, -1.716258, 2.736479>,
      < 4.416800, -1.804811, 2.736479>,
      < 4.479965, -1.798174, 2.744609>
    }
    triangle {
      < 4.413707, -1.716258, 2.736479>,
      < 4.479965, -1.798174, 2.744609>,
      < 4.477180, -1.718477, 2.744609>
    }
    triangle {
      < 4.413622, -1.716253, 2.633340>,
      < 4.416716, -1.804817, 2.633340>,
      < 4.416800, -1.804811, 2.736479>
    }
    triangle {
      < 4.413622, -1.716253, 2.633340>,
      < 4.416800, -1.804811, 2.736479>,
      < 4.413707, -1.716258, 2.736479>
    }
    triangle {
      < 4.932646, -1.750611, 2.842164>,
      < 4.935470, -1.766608, 2.842164>,
      < 4.942200, -1.764930, 2.828054>
    }
    triangle {
      < 4.932646, -1.750611, 2.842164>,
      < 4.942200, -1.764930, 2.828054>,
      < 4.939544, -1.749886, 2.828054>
    }
    triangle {
      < 4.828423, -1.761561, 2.813766>,
      < 4.833786, -1.791957, 2.813766>,
      < 4.935470, -1.766608, 2.842164>
    }
    triangle {
      < 4.828423, -1.761561, 2.813766>,
      < 4.935470, -1.766608, 2.842164>,
      < 4.932646, -1.750611, 2.842164>
    }
    triangle {
      < 4.724201, -1.772511, 2.769109>,
      < 4.732101, -1.817305, 2.769109>,
      < 4.833786, -1.791957, 2.813766>
    }
    triangle {
      < 4.724201, -1.772511, 2.769109>,
      < 4.833786, -1.791957, 2.813766>,
      < 4.828423, -1.761561, 2.813766>
    }
    triangle {
      < 4.711569, -1.773839, 2.756803>,
      < 4.719777, -1.820377, 2.756803>,
      < 4.732101, -1.817305, 2.769109>
    }
    triangle {
      < 4.711569, -1.773839, 2.756803>,
      < 4.732101, -1.817305, 2.769109>,
      < 4.724201, -1.772511, 2.769109>
    }
    triangle {
      < 4.690514, -1.776051, 2.779159>,
      < 4.699235, -1.825499, 2.779159>,
      < 4.719777, -1.820377, 2.756803>
    }
    triangle {
      < 4.690514, -1.776051, 2.779159>,
      < 4.719777, -1.820377, 2.756803>,
      < 4.711569, -1.773839, 2.756803>
    }
    triangle {
      < 4.606295, -1.784901, 2.764932>,
      < 4.613774, -1.835851, 2.764932>,
      < 4.699235, -1.825499, 2.779159>
    }
    triangle {
      < 4.606295, -1.784901, 2.764932>,
      < 4.699235, -1.825499, 2.779159>,
      < 4.690514, -1.776051, 2.779159>
    }
    triangle {
      < 4.570248, -1.788685, 2.663333>,
      < 4.578337, -1.843790, 2.663333>,
      < 4.613774, -1.835851, 2.764932>
    }
    triangle {
      < 4.570248, -1.788685, 2.663333>,
      < 4.613774, -1.835851, 2.764932>,
      < 4.606295, -1.784901, 2.764932>
    }
    triangle {
      < 4.487713, -1.797358, 2.663332>,
      < 4.501373, -1.874822, 2.663332>,
      < 4.578337, -1.843790, 2.663333>
    }
    triangle {
      < 4.487713, -1.797358, 2.663332>,
      < 4.578337, -1.843790, 2.663333>,
      < 4.570248, -1.788685, 2.663333>
    }
    triangle {
      < 4.479965, -1.798174, 2.744609>,
      < 4.493814, -1.876708, 2.744609>,
      < 4.501373, -1.874822, 2.663332>
    }
    triangle {
      < 4.479965, -1.798174, 2.744609>,
      < 4.501373, -1.874822, 2.663332>,
      < 4.487713, -1.797358, 2.663332>
    }
    triangle {
      < 4.416800, -1.804811, 2.736479>,
      < 4.432188, -1.892071, 2.736479>,
      < 4.493814, -1.876708, 2.744609>
    }
    triangle {
      < 4.416800, -1.804811, 2.736479>,
      < 4.493814, -1.876708, 2.744609>,
      < 4.479965, -1.798174, 2.744609>
    }
    triangle {
      < 4.416716, -1.804817, 2.633340>,
      < 4.432105, -1.892089, 2.633340>,
      < 4.432188, -1.892071, 2.736479>
    }
    triangle {
      < 4.416716, -1.804817, 2.633340>,
      < 4.432188, -1.892071, 2.736479>,
      < 4.416800, -1.804811, 2.736479>
    }
    triangle {
      < 4.935470, -1.766608, 2.842164>,
      < 4.940493, -1.782057, 2.842164>,
      < 4.946923, -1.779458, 2.828054>
    }
    triangle {
      < 4.935470, -1.766608, 2.842164>,
      < 4.946923, -1.779458, 2.828054>,
      < 4.942200, -1.764930, 2.828054>
    }
    triangle {
      < 4.833786, -1.791957, 2.813766>,
      < 4.843326, -1.821310, 2.813766>,
      < 4.940493, -1.782057, 2.842164>
    }
    triangle {
      < 4.833786, -1.791957, 2.813766>,
      < 4.940493, -1.782057, 2.842164>,
      < 4.935470, -1.766608, 2.842164>
    }
    triangle {
      < 4.732101, -1.817305, 2.769109>,
      < 4.746159, -1.860563, 2.769109>,
      < 4.843326, -1.821310, 2.813766>
    }
    triangle {
      < 4.732101, -1.817305, 2.769109>,
      < 4.843326, -1.821310, 2.813766>,
      < 4.833786, -1.791957, 2.813766>
    }
    triangle {
      < 4.719777, -1.820377, 2.756803>,
      < 4.734382, -1.865320, 2.756803>,
      < 4.746159, -1.860563, 2.769109>
    }
    triangle {
      < 4.719777, -1.820377, 2.756803>,
      < 4.746159, -1.860563, 2.769109>,
      < 4.732101, -1.817305, 2.769109>
    }
    triangle {
      < 4.699235, -1.825499, 2.779159>,
      < 4.714753, -1.873251, 2.779159>,
      < 4.734382, -1.865320, 2.756803>
    }
    triangle {
      < 4.699235, -1.825499, 2.779159>,
      < 4.734382, -1.865320, 2.756803>,
      < 4.719777, -1.820377, 2.756803>
    }
    triangle {
      < 4.639527, -1.915102, 2.764932>,
      < 4.714753, -1.873251, 2.779159>,
      < 4.649612, -1.881966, 2.768997>
    }
    triangle {
      < 4.606188, -1.929502, 2.663333>,
      < 4.639527, -1.915102, 2.764932>,
      < 4.649612, -1.881966, 2.768997>
    }
    triangle {
      < 4.606188, -1.929502, 2.663333>,
      < 4.649612, -1.881966, 2.768997>,
      < 4.617096, -1.893664, 2.663333>
    }
    triangle {
      < 4.578337, -1.843790, 2.663333>,
      < 4.606188, -1.929502, 2.663333>,
      < 4.617096, -1.893664, 2.663333>
    }
    triangle {
      < 4.578337, -1.843790, 2.663333>,
      < 4.617096, -1.893664, 2.663333>,
      < 4.608228, -1.866371, 2.663333>
    }
    triangle {
      < 4.493814, -1.876708, 2.744609>,
      < 4.518457, -1.952551, 2.744609>,
      < 4.525680, -1.949631, 2.663332>
    }
    triangle {
      < 4.493814, -1.876708, 2.744609>,
      < 4.525680, -1.949631, 2.663332>,
      < 4.501373, -1.874822, 2.663332>
    }
    triangle {
      < 4.432188, -1.892071, 2.736479>,
      < 4.459569, -1.976341, 2.736479>,
      < 4.518457, -1.952551, 2.744609>
    }
    triangle {
      < 4.432188, -1.892071, 2.736479>,
      < 4.518457, -1.952551, 2.744609>,
      < 4.493814, -1.876708, 2.744609>
    }
    triangle {
      < 4.432105, -1.892089, 2.633340>,
      < 4.459489, -1.976370, 2.633340>,
      < 4.459569, -1.976341, 2.736479>
    }
    triangle {
      < 4.432105, -1.892089, 2.633340>,
      < 4.459569, -1.976341, 2.736479>,
      < 4.432188, -1.892071, 2.736479>
    }
    triangle {
      < 4.940493, -1.782057, 2.842164>,
      < 4.953623, -1.793188, 2.828054>,
      < 4.946923, -1.779458, 2.828054>
    }
    triangle {
      < 4.843326, -1.821310, 2.813766>,
      < 4.850687, -1.836390, 2.813766>,
      < 4.940493, -1.782057, 2.842164>
    }
    triangle {
      < 4.843326, -1.821310, 2.813766>,
      < 4.746159, -1.860563, 2.769109>,
      < 4.763003, -1.894722, 2.769109>
    }
    triangle {
      < 4.843326, -1.821310, 2.813766>,
      < 4.763003, -1.894722, 2.769109>,
      < 4.850687, -1.836390, 2.813766>
    }
    triangle {
      < 4.746159, -1.860563, 2.769109>,
      < 4.734382, -1.865320, 2.756803>,
      < 4.755100, -1.907794, 2.756803>
    }
    triangle {
      < 4.746159, -1.860563, 2.769109>,
      < 4.755100, -1.907794, 2.756803>,
      < 4.763003, -1.894722, 2.769109>
    }
    triangle {
      < 4.714753, -1.873251, 2.779159>,
      < 4.736765, -1.918379, 2.779159>,
      < 4.755100, -1.907794, 2.756803>
    }
    triangle {
      < 4.714753, -1.873251, 2.779159>,
      < 4.755100, -1.907794, 2.756803>,
      < 4.734382, -1.865320, 2.756803>
    }
    triangle {
      < 4.639527, -1.915102, 2.764932>,
      < 4.663425, -1.960718, 2.764932>,
      < 4.736765, -1.918379, 2.779159>
    }
    triangle {
      < 4.639527, -1.915102, 2.764932>,
      < 4.736765, -1.918379, 2.779159>,
      < 4.714753, -1.873251, 2.779159>
    }
    triangle {
      < 4.606188, -1.929502, 2.663333>,
      < 4.632035, -1.978837, 2.663333>,
      < 4.663425, -1.960718, 2.764932>
    }
    triangle {
      < 4.606188, -1.929502, 2.663333>,
      < 4.663425, -1.960718, 2.764932>,
      < 4.639527, -1.915102, 2.764932>
    }
    triangle {
      < 4.525680, -1.949631, 2.663332>,
      < 4.560163, -2.020329, 2.663332>,
      < 4.632035, -1.978837, 2.663333>
    }
    triangle {
      < 4.525680, -1.949631, 2.663332>,
      < 4.632035, -1.978837, 2.663333>,
      < 4.606188, -1.929502, 2.663333>
    }
    triangle {
      < 4.518457, -1.952551, 2.744609>,
      < 4.553416, -2.024226, 2.744609>,
      < 4.560163, -2.020329, 2.663332>
    }
    triangle {
      < 4.518457, -1.952551, 2.744609>,
      < 4.560163, -2.020329, 2.663332>,
      < 4.525680, -1.949631, 2.663332>
    }
    triangle {
      < 4.459569, -1.976341, 2.736479>,
      < 4.498412, -2.055980, 2.736479>,
      < 4.553416, -2.024226, 2.744609>
    }
    triangle {
      < 4.459569, -1.976341, 2.736479>,
      < 4.553416, -2.024226, 2.744609>,
      < 4.518457, -1.952551, 2.744609>
    }
    triangle {
      < 4.459489, -1.976370, 2.633340>,
      < 4.498337, -2.056020, 2.633340>,
      < 4.498412, -2.055980, 2.736479>
    }
    triangle {
      < 4.459489, -1.976370, 2.633340>,
      < 4.498412, -2.055980, 2.736479>,
      < 4.459569, -1.976341, 2.736479>
    }
    triangle {
      < 4.956703, -1.810121, 2.842164>,
      < 4.962169, -1.805851, 2.828054>,
      < 4.953623, -1.793188, 2.828054>
    }
    triangle {
      < 4.864738, -1.860723, 2.813766>,
      < 4.874120, -1.874636, 2.813766>,
      < 4.956703, -1.810121, 2.842164>
    }
    triangle {
      < 4.770373, -1.907486, 2.769109>,
      < 4.791536, -1.939151, 2.769109>,
      < 4.874120, -1.874636, 2.813766>
    }
    triangle {
      < 4.770373, -1.907486, 2.769109>,
      < 4.874120, -1.874636, 2.813766>,
      < 4.864738, -1.860723, 2.813766>
    }
    triangle {
      < 4.755100, -1.907794, 2.756803>,
      < 4.781527, -1.946970, 2.756803>,
      < 4.791536, -1.939151, 2.769109>
    }
    triangle {
      < 4.755100, -1.907794, 2.756803>,
      < 4.791536, -1.939151, 2.769109>,
      < 4.770373, -1.907486, 2.769109>
    }
    triangle {
      < 4.736765, -1.918379, 2.779159>,
      < 4.764844, -1.960004, 2.779159>,
      < 4.781527, -1.946970, 2.756803>
    }
    triangle {
      < 4.736765, -1.918379, 2.779159>,
      < 4.781527, -1.946970, 2.756803>,
      < 4.755100, -1.907794, 2.756803>
    }
    triangle {
      < 4.663425, -1.960718, 2.764932>,
      < 4.690982, -2.004221, 2.764932>,
      < 4.764844, -1.960004, 2.779159>
    }
    triangle {
      < 4.663425, -1.960718, 2.764932>,
      < 4.764844, -1.960004, 2.779159>,
      < 4.736765, -1.918379, 2.779159>
    }
    triangle {
      < 4.632035, -1.978837, 2.663333>,
      < 4.661838, -2.025887, 2.663333>,
      < 4.690982, -2.004221, 2.764932>
    }
    triangle {
      < 4.632035, -1.978837, 2.663333>,
      < 4.690982, -2.004221, 2.764932>,
      < 4.663425, -1.960718, 2.764932>
    }
    triangle {
      < 4.560163, -2.020329, 2.663332>,
      < 4.604148, -2.085540, 2.663332>,
      < 4.661838, -2.025887, 2.663333>
    }
    triangle {
      < 4.560163, -2.020329, 2.663332>,
      < 4.661838, -2.025887, 2.663333>,
      < 4.632035, -1.978837, 2.663333>
    }
    triangle {
      < 4.553416, -2.024226, 2.744609>,
      < 4.598010, -2.090338, 2.744609>,
      < 4.604148, -2.085540, 2.663332>
    }
    triangle {
      < 4.553416, -2.024226, 2.744609>,
      < 4.604148, -2.085540, 2.663332>,
      < 4.560163, -2.020329, 2.663332>
    }
    triangle {
      < 4.498412, -2.055980, 2.736479>,
      < 4.547960, -2.129438, 2.736479>,
      < 4.598010, -2.090338, 2.744609>
    }
    triangle {
      < 4.498412, -2.055980, 2.736479>,
      < 4.598010, -2.090338, 2.744609>,
      < 4.553416, -2.024226, 2.744609>
    }
    triangle {
      < 4.498337, -2.056020, 2.633340>,
      < 4.547892, -2.129488, 2.633340>,
      < 4.547960, -2.129438, 2.736479>
    }
    triangle {
      < 4.498337, -2.056020, 2.633340>,
      < 4.547960, -2.129438, 2.736479>,
      < 4.498412, -2.055980, 2.736479>
    }
    triangle {
      < 4.956703, -1.810121, 2.842164>,
      < 4.967575, -1.822191, 2.842164>,
      < 4.972393, -1.817202, 2.828054>
    }
    triangle {
      < 4.956703, -1.810121, 2.842164>,
      < 4.972393, -1.817202, 2.828054>,
      < 4.962169, -1.805851, 2.828054>
    }
    triangle {
      < 4.874120, -1.874636, 2.813766>,
      < 4.894774, -1.897572, 2.813766>,
      < 4.967575, -1.822191, 2.842164>
    }
    triangle {
      < 4.874120, -1.874636, 2.813766>,
      < 4.967575, -1.822191, 2.842164>,
      < 4.956703, -1.810121, 2.842164>
    }
    triangle {
      < 4.791536, -1.939151, 2.769109>,
      < 4.821973, -1.972952, 2.769109>,
      < 4.894774, -1.897572, 2.813766>
    }
    triangle {
      < 4.791536, -1.939151, 2.769109>,
      < 4.894774, -1.897572, 2.813766>,
      < 4.874120, -1.874636, 2.813766>
    }
    triangle {
      < 4.781527, -1.946970, 2.756803>,
      < 4.813149, -1.982088, 2.756803>,
      < 4.821973, -1.972952, 2.769109>
    }
    triangle {
      < 4.781527, -1.946970, 2.756803>,
      < 4.821973, -1.972952, 2.769109>,
      < 4.791536, -1.939151, 2.769109>
    }
    triangle {
      < 4.764844, -1.960004, 2.779159>,
      < 4.798442, -1.997317, 2.779159>,
      < 4.813149, -1.982088, 2.756803>
    }
    triangle {
      < 4.764844, -1.960004, 2.779159>,
      < 4.813149, -1.982088, 2.756803>,
      < 4.781527, -1.946970, 2.756803>
    }
    triangle {
      < 4.746742, -2.066147, 2.764932>,
      < 4.798442, -1.997317, 2.779159>,
      < 4.742478, -2.031773, 2.768997>
    }
    triangle {
      < 4.722143, -2.092861, 2.663333>,
      < 4.746742, -2.066147, 2.764932>,
      < 4.742478, -2.031773, 2.768997>
    }
    triangle {
      < 4.722143, -2.092861, 2.663333>,
      < 4.742478, -2.031773, 2.768997>,
      < 4.717531, -2.055685, 2.663333>
    }
    triangle {
      < 4.604148, -2.085540, 2.663332>,
      < 4.656782, -2.143995, 2.663332>,
      < 4.722143, -2.092861, 2.663333>
    }
    triangle {
      < 4.604148, -2.085540, 2.663332>,
      < 4.722143, -2.092861, 2.663333>,
      < 4.661838, -2.025887, 2.663333>
    }
    triangle {
      < 4.598010, -2.090338, 2.744609>,
      < 4.651371, -2.149601, 2.744609>,
      < 4.656782, -2.143995, 2.663332>
    }
    triangle {
      < 4.598010, -2.090338, 2.744609>,
      < 4.656782, -2.143995, 2.663332>,
      < 4.604148, -2.085540, 2.663332>
    }
    triangle {
      < 4.547960, -2.129438, 2.736479>,
      < 4.607250, -2.195286, 2.736479>,
      < 4.651371, -2.149601, 2.744609>
    }
    triangle {
      < 4.547960, -2.129438, 2.736479>,
      < 4.651371, -2.149601, 2.744609>,
      < 4.598010, -2.090338, 2.744609>
    }
    triangle {
      < 4.547892, -2.129488, 2.633340>,
      < 4.607189, -2.195345, 2.633340>,
      < 4.607250, -2.195286, 2.736479>
    }
    triangle {
      < 4.547892, -2.129488, 2.633340>,
      < 4.607250, -2.195286, 2.736479>,
      < 4.547960, -2.129438, 2.736479>
    }
    triangle {
      < 4.967575, -1.822191, 2.842164>,
      < 4.980021, -1.832631, 2.842164>,
      < 4.984098, -1.827019, 2.828054>
    }
    triangle {
      < 4.967575, -1.822191, 2.842164>,
      < 4.984098, -1.827019, 2.828054>,
      < 4.972393, -1.817202, 2.828054>
    }
    triangle {
      < 4.894774, -1.897572, 2.813766>,
      < 4.918419, -1.917409, 2.813766>,
      < 4.980021, -1.832631, 2.842164>
    }
    triangle {
      < 4.894774, -1.897572, 2.813766>,
      < 4.980021, -1.832631, 2.842164>,
      < 4.967575, -1.822191, 2.842164>
    }
    triangle {
      < 4.821973, -1.972952, 2.769109>,
      < 4.856817, -2.002188, 2.769109>,
      < 4.918419, -1.917409, 2.813766>
    }
    triangle {
      < 4.821973, -1.972952, 2.769109>,
      < 4.918419, -1.917409, 2.813766>,
      < 4.894774, -1.897572, 2.813766>
    }
    triangle {
      < 4.813149, -1.982088, 2.756803>,
      < 4.849351, -2.012463, 2.756803>,
      < 4.856817, -2.002188, 2.769109>
    }
    triangle {
      < 4.813149, -1.982088, 2.756803>,
      < 4.856817, -2.002188, 2.769109>,
      < 4.821973, -1.972952, 2.769109>
    }
    triangle {
      < 4.798442, -1.997317, 2.779159>,
      < 4.836907, -2.029590, 2.779159>,
      < 4.849351, -2.012463, 2.756803>
    }
    triangle {
      < 4.798442, -1.997317, 2.779159>,
      < 4.849351, -2.012463, 2.756803>,
      < 4.813149, -1.982088, 2.756803>
    }
    triangle {
      < 4.746742, -2.066147, 2.764932>,
      < 4.787128, -2.098098, 2.764932>,
      < 4.836907, -2.029590, 2.779159>
    }
    triangle {
      < 4.746742, -2.066147, 2.764932>,
      < 4.836907, -2.029590, 2.779159>,
      < 4.798442, -1.997317, 2.779159>
    }
    triangle {
      < 4.722143, -2.092861, 2.663333>,
      < 4.765821, -2.127418, 2.663333>,
      < 4.787128, -2.098098, 2.764932>
    }
    triangle {
      < 4.722143, -2.092861, 2.663333>,
      < 4.787128, -2.098098, 2.764932>,
      < 4.746742, -2.066147, 2.764932>
    }
    triangle {
      < 4.656782, -2.143995, 2.663332>,
      < 4.717038, -2.194556, 2.663332>,
      < 4.765821, -2.127418, 2.663333>
    }
    triangle {
      < 4.656782, -2.143995, 2.663332>,
      < 4.765821, -2.127418, 2.663333>,
      < 4.722143, -2.092861, 2.663333>
    }
    triangle {
      < 4.651371, -2.149601, 2.744609>,
      < 4.712460, -2.200860, 2.744609>,
      < 4.717038, -2.194556, 2.663332>
    }
    triangle {
      < 4.651371, -2.149601, 2.744609>,
      < 4.717038, -2.194556, 2.663332>,
      < 4.656782, -2.143995, 2.663332>
    }
    triangle {
      < 4.607250, -2.195286, 2.736479>,
      < 4.675126, -2.252241, 2.736479>,
      < 4.712460, -2.200860, 2.744609>
    }
    triangle {
      < 4.607250, -2.195286, 2.736479>,
      < 4.712460, -2.200860, 2.744609>,
      < 4.651371, -2.149601, 2.744609>
    }
    triangle {
      < 4.607189, -2.195345, 2.633340>,
      < 4.675074, -2.252308, 2.633340>,
      < 4.675126, -2.252241, 2.736479>
    }
    triangle {
      < 4.607189, -2.195345, 2.633340>,
      < 4.675126, -2.252241, 2.736479>,
      < 4.607250, -2.195286, 2.736479>
    }
    triangle {
      < 4.980021, -1.832631, 2.842164>,
      < 4.993799, -1.841236, 2.842164>,
      < 4.997055, -1.835112, 2.828054>
    }
    triangle {
      < 4.980021, -1.832631, 2.842164>,
      < 4.997055, -1.835112, 2.828054>,
      < 4.984098, -1.827019, 2.828054>
    }
    triangle {
      < 4.918419, -1.917409, 2.813766>,
      < 4.944595, -1.933763, 2.813766>,
      < 4.993799, -1.841236, 2.842164>
    }
    triangle {
      < 4.918419, -1.917409, 2.813766>,
      < 4.993799, -1.841236, 2.842164>,
      < 4.980021, -1.832631, 2.842164>
    }
    triangle {
      < 4.856817, -2.002188, 2.769109>,
      < 4.895391, -2.026290, 2.769109>,
      < 4.944595, -1.933763, 2.813766>
    }
    triangle {
      < 4.856817, -2.002188, 2.769109>,
      < 4.944595, -1.933763, 2.813766>,
      < 4.918419, -1.917409, 2.813766>
    }
    triangle {
      < 4.849351, -2.012463, 2.756803>,
      < 4.889428, -2.037504, 2.756803>,
      < 4.895391, -2.026290, 2.769109>
    }
    triangle {
      < 4.849351, -2.012463, 2.756803>,
      < 4.895391, -2.026290, 2.769109>,
      < 4.856817, -2.002188, 2.769109>
    }
    triangle {
      < 4.836907, -2.029590, 2.779159>,
      < 4.879488, -2.056197, 2.779159>,
      < 4.889428, -2.037504, 2.756803>
    }
    triangle {
      < 4.836907, -2.029590, 2.779159>,
      < 4.889428, -2.037504, 2.756803>,
      < 4.849351, -2.012463, 2.756803>
    }
    triangle {
      < 4.787128, -2.098098, 2.764932>,
      < 4.829997, -2.126633, 2.764932>,
      < 4.879488, -2.056197, 2.779159>
    }
    triangle {
      < 4.787128, -2.098098, 2.764932>,
      < 4.879488, -2.056197, 2.779159>,
      < 4.836907, -2.029590, 2.779159>
    }
    triangle {
      < 4.765821, -2.127418, 2.663333>,
      < 4.812184, -2.158279, 2.663333>,
      < 4.829997, -2.126633, 2.764932>
    }
    triangle {
      < 4.765821, -2.127418, 2.663333>,
      < 4.829997, -2.126633, 2.764932>,
      < 4.787128, -2.098098, 2.764932>
    }
    triangle {
      < 4.717038, -2.194556, 2.663332>,
      < 4.783744, -2.236239, 2.663332>,
      < 4.812184, -2.158279, 2.663333>
    }
    triangle {
      < 4.717038, -2.194556, 2.663332>,
      < 4.812184, -2.158279, 2.663333>,
      < 4.765821, -2.127418, 2.663333>
    }
    triangle {
      < 4.712460, -2.200860, 2.744609>,
      < 4.780088, -2.243119, 2.744609>,
      < 4.783744, -2.236239, 2.663332>
    }
    triangle {
      < 4.712460, -2.200860, 2.744609>,
      < 4.783744, -2.236239, 2.663332>,
      < 4.717038, -2.194556, 2.663332>
    }
    triangle {
      < 4.675126, -2.252241, 2.736479>,
      < 4.750268, -2.299196, 2.736479>,
      < 4.780088, -2.243119, 2.744609>
    }
    triangle {
      < 4.675126, -2.252241, 2.736479>,
      < 4.780088, -2.243119, 2.744609>,
      < 4.712460, -2.200860, 2.744609>
    }
    triangle {
      < 4.675074, -2.252308, 2.633340>,
      < 4.750226, -2.299269, 2.633340>,
      < 4.750268, -2.299196, 2.736479>
    }
    triangle {
      < 4.675074, -2.252308, 2.633340>,
      < 4.750268, -2.299196, 2.736479>,
      < 4.675126, -2.252241, 2.736479>
    }
    triangle {
      < 4.993799, -1.841236, 2.842164>,
      < 5.008640, -1.847841, 2.842164>,
      < 5.011013, -1.841323, 2.828054>
    }
    triangle {
      < 4.993799, -1.841236, 2.842164>,
      < 5.011013, -1.841323, 2.828054>,
      < 4.997055, -1.835112, 2.828054>
    }
    triangle {
      < 4.944595, -1.933763, 2.813766>,
      < 4.972793, -1.946315, 2.813766>,
      < 5.008640, -1.847841, 2.842164>
    }
    triangle {
      < 4.944595, -1.933763, 2.813766>,
      < 5.008640, -1.847841, 2.842164>,
      < 4.993799, -1.841236, 2.842164>
    }
    triangle {
      < 4.895391, -2.026290, 2.769109>,
      < 4.936944, -2.044789, 2.769109>,
      < 4.972793, -1.946315, 2.813766>
    }
    triangle {
      < 4.895391, -2.026290, 2.769109>,
      < 4.972793, -1.946315, 2.813766>,
      < 4.944595, -1.933763, 2.813766>
    }
    triangle {
      < 4.889428, -2.037504, 2.756803>,
      < 4.932600, -2.056724, 2.756803>,
      < 4.936944, -2.044789, 2.769109>
    }
    triangle {
      < 4.889428, -2.037504, 2.756803>,
      < 4.936944, -2.044789, 2.769109>,
      < 4.895391, -2.026290, 2.769109>
    }
    triangle {
      < 4.879488, -2.056197, 2.779159>,
      < 4.925358, -2.076618, 2.779159>,
      < 4.932600, -2.056724, 2.756803>
    }
    triangle {
      < 4.879488, -2.056197, 2.779159>,
      < 4.932600, -2.056724, 2.756803>,
      < 4.889428, -2.037504, 2.756803>
    }
    triangle {
      < 4.906123, -2.160526, 2.764932>,
      < 4.925358, -2.076618, 2.779159>,
      < 4.888246, -2.130858, 2.768997>
    }
    triangle {
      < 4.894516, -2.194936, 2.663333>,
      < 4.906123, -2.160526, 2.764932>,
      < 4.888246, -2.130858, 2.768997>
    }
    triangle {
      < 4.894516, -2.194936, 2.663333>,
      < 4.888246, -2.130858, 2.768997>,
      < 4.875182, -2.162849, 2.663333>
    }
    triangle {
      < 4.783744, -2.236239, 2.663332>,
      < 4.855603, -2.268233, 2.663332>,
      < 4.894516, -2.194936, 2.663333>
    }
    triangle {
      < 4.783744, -2.236239, 2.663332>,
      < 4.894516, -2.194936, 2.663333>,
      < 4.812184, -2.158279, 2.663333>
    }
    triangle {
      < 4.780088, -2.243119, 2.744609>,
      < 4.852940, -2.275555, 2.744609>,
      < 4.855603, -2.268233, 2.663332>
    }
    triangle {
      < 4.780088, -2.243119, 2.744609>,
      < 4.855603, -2.268233, 2.663332>,
      < 4.783744, -2.236239, 2.663332>
    }
    triangle {
      < 4.750268, -2.299196, 2.736479>,
      < 4.831214, -2.335236, 2.736479>,
      < 4.852940, -2.275555, 2.744609>
    }
    triangle {
      < 4.750268, -2.299196, 2.736479>,
      < 4.852940, -2.275555, 2.744609>,
      < 4.780088, -2.243119, 2.744609>
    }
    triangle {
      < 4.750226, -2.299269, 2.633340>,
      < 4.831182, -2.335315, 2.633340>,
      < 4.831214, -2.335236, 2.736479>
    }
    triangle {
      < 4.750226, -2.299269, 2.633340>,
      < 4.831214, -2.335236, 2.736479>,
      < 4.750268, -2.299196, 2.736479>
    }
    triangle {
      < 5.008640, -1.847841, 2.842164>,
      < 5.024256, -1.852316, 2.842164>,
      < 5.025699, -1.845531, 2.828054>
    }
    triangle {
      < 5.008640, -1.847841, 2.842164>,
      < 5.025699, -1.845531, 2.828054>,
      < 5.011013, -1.841323, 2.828054>
    }
    triangle {
      < 4.972793, -1.946315, 2.813766>,
      < 5.002462, -1.954820, 2.813766>,
      < 5.024256, -1.852316, 2.842164>
    }
    triangle {
      < 4.972793, -1.946315, 2.813766>,
      < 5.024256, -1.852316, 2.842164>,
      < 5.008640, -1.847841, 2.842164>
    }
    triangle {
      < 4.936944, -2.044789, 2.769109>,
      < 4.980668, -2.057325, 2.769109>,
      < 5.002462, -1.954820, 2.813766>
    }
    triangle {
      < 4.936944, -2.044789, 2.769109>,
      < 5.002462, -1.954820, 2.813766>,
      < 4.972793, -1.946315, 2.813766>
    }
    triangle {
      < 4.932600, -2.056724, 2.756803>,
      < 4.978026, -2.069749, 2.756803>,
      < 4.980668, -2.057325, 2.769109>
    }
    triangle {
      < 4.932600, -2.056724, 2.756803>,
      < 4.980668, -2.057325, 2.769109>,
      < 4.936944, -2.044789, 2.769109>
    }
    triangle {
      < 4.925358, -2.076618, 2.779159>,
      < 4.973624, -2.090457, 2.779159>,
      < 4.978026, -2.069749, 2.756803>
    }
    triangle {
      < 4.925358, -2.076618, 2.779159>,
      < 4.978026, -2.069749, 2.756803>,
      < 4.932600, -2.056724, 2.756803>
    }
    triangle {
      < 4.906123, -2.160526, 2.764932>,
      < 4.956013, -2.173289, 2.764932>,
      < 4.973624, -2.090457, 2.779159>
    }
    triangle {
      < 4.906123, -2.160526, 2.764932>,
      < 4.973624, -2.090457, 2.779159>,
      < 4.925358, -2.076618, 2.779159>
    }
    triangle {
      < 4.894516, -2.194936, 2.663333>,
      < 4.948473, -2.208740, 2.663333>,
      < 4.956013, -2.173289, 2.764932>
    }
    triangle {
      < 4.894516, -2.194936, 2.663333>,
      < 4.956013, -2.173289, 2.764932>,
      < 4.906123, -2.160526, 2.764932>
    }
    triangle {
      < 4.855603, -2.268233, 2.663332>,
      < 4.931214, -2.289915, 2.663332>,
      < 4.948473, -2.208740, 2.663333>
    }
    triangle {
      < 4.855603, -2.268233, 2.663332>,
      < 4.948473, -2.208740, 2.663333>,
      < 4.894516, -2.194936, 2.663333>
    }
    triangle {
      < 4.852940, -2.275555, 2.744609>,
      < 4.929596, -2.297536, 2.744609>,
      < 4.931214, -2.289915, 2.663332>
    }
    triangle {
      < 4.852940, -2.275555, 2.744609>,
      < 4.931214, -2.289915, 2.663332>,
      < 4.855603, -2.268233, 2.663332>
    }
    triangle {
      < 4.831214, -2.335236, 2.736479>,
      < 4.916388, -2.359660, 2.736479>,
      < 4.929596, -2.297536, 2.744609>
    }
    triangle {
      < 4.831214, -2.335236, 2.736479>,
      < 4.929596, -2.297536, 2.744609>,
      < 4.852940, -2.275555, 2.744609>
    }
    triangle {
      < 4.831182, -2.335315, 2.633340>,
      < 4.916368, -2.359742, 2.633340>,
      < 4.916388, -2.359660, 2.736479>
    }
    triangle {
      < 4.831182, -2.335315, 2.633340>,
      < 4.916388, -2.359660, 2.736479>,
      < 4.831214, -2.335236, 2.736479>
    }
    triangle {
      < 5.024256, -1.852316, 2.842164>,
      < 5.040343, -1.854573, 2.842164>,
      < 5.040827, -1.847654, 2.828054>
    }
    triangle {
      < 5.024256, -1.852316, 2.842164>,
      < 5.040827, -1.847654, 2.828054>,
      < 5.025699, -1.845531, 2.828054>
    }
    triangle {
      < 5.002462, -1.954820, 2.813766>,
      < 5.033027, -1.959114, 2.813766>,
      < 5.040343, -1.854573, 2.842164>
    }
    triangle {
      < 5.002462, -1.954820, 2.813766>,
      < 5.040343, -1.854573, 2.842164>,
      < 5.024256, -1.852316, 2.842164>
    }
    triangle {
      < 4.980668, -2.057325, 2.769109>,
      < 5.025710, -2.063654, 2.769109>,
      < 5.033027, -1.959114, 2.813766>
    }
    triangle {
      < 4.980668, -2.057325, 2.769109>,
      < 5.033027, -1.959114, 2.813766>,
      < 5.002462, -1.954820, 2.813766>
    }
    triangle {
      < 4.978026, -2.069749, 2.756803>,
      < 5.024823, -2.076324, 2.756803>,
      < 5.025710, -2.063654, 2.769109>
    }
    triangle {
      < 4.978026, -2.069749, 2.756803>,
      < 5.025710, -2.063654, 2.769109>,
      < 4.980668, -2.057325, 2.769109>
    }
    triangle {
      < 4.973624, -2.090457, 2.779159>,
      < 5.023346, -2.097444, 2.779159>,
      < 5.024823, -2.076324, 2.756803>
    }
    triangle {
      < 4.973624, -2.090457, 2.779159>,
      < 5.024823, -2.076324, 2.756803>,
      < 4.978026, -2.069749, 2.756803>
    }
    triangle {
      < 4.956013, -2.173289, 2.764932>,
      < 5.006781, -2.181921, 2.764932>,
      < 5.023346, -2.097444, 2.779159>
    }
    triangle {
      < 4.956013, -2.173289, 2.764932>,
      < 5.023346, -2.097444, 2.779159>,
      < 4.973624, -2.090457, 2.779159>
    }
    triangle {
      < 4.948473, -2.208740, 2.663333>,
      < 5.003380, -2.218076, 2.663333>,
      < 5.006781, -2.181921, 2.764932>
    }
    triangle {
      < 4.948473, -2.208740, 2.663333>,
      < 5.006781, -2.181921, 2.764932>,
      < 4.956013, -2.173289, 2.764932>
    }
    triangle {
      < 4.931214, -2.289915, 2.663332>,
      < 5.009108, -2.300864, 2.663332>,
      < 5.003380, -2.218076, 2.663333>
    }
    triangle {
      < 4.931214, -2.289915, 2.663332>,
      < 5.003380, -2.218076, 2.663333>,
      < 4.948473, -2.208740, 2.663333>
    }
    triangle {
      < 4.929596, -2.297536, 2.744609>,
      < 5.008566, -2.308635, 2.744609>,
      < 5.009108, -2.300864, 2.663332>
    }
    triangle {
      < 4.929596, -2.297536, 2.744609>,
      < 5.009108, -2.300864, 2.663332>,
      < 4.931214, -2.289915, 2.663332>
    }
    triangle {
      < 4.916388, -2.359660, 2.736479>,
      < 5.004132, -2.371993, 2.736479>,
      < 5.008566, -2.308635, 2.744609>
    }
    triangle {
      < 4.916388, -2.359660, 2.736479>,
      < 5.008566, -2.308635, 2.744609>,
      < 4.929596, -2.297536, 2.744609>
    }
    triangle {
      < 4.916368, -2.359742, 2.633340>,
      < 5.004124, -2.372077, 2.633340>,
      < 5.004132, -2.371993, 2.736479>
    }
    triangle {
      < 4.916368, -2.359742, 2.633340>,
      < 5.004132, -2.371993, 2.736479>,
      < 4.916388, -2.359660, 2.736479>
    }
    triangle {
      < 5.040343, -1.854573, 2.842164>,
      < 5.056588, -1.854571, 2.842164>,
      < 5.056104, -1.847651, 2.828054>
    }
    triangle {
      < 5.040343, -1.854573, 2.842164>,
      < 5.056104, -1.847651, 2.828054>,
      < 5.040827, -1.847654, 2.828054>
    }
    triangle {
      < 5.033027, -1.959114, 2.813766>,
      < 5.063892, -1.959112, 2.813766>,
      < 5.056588, -1.854571, 2.842164>
    }
    triangle {
      < 5.033027, -1.959114, 2.813766>,
      < 5.056588, -1.854571, 2.842164>,
      < 5.040343, -1.854573, 2.842164>
    }
    triangle {
      < 5.025710, -2.063654, 2.769109>,
      < 5.071195, -2.063653, 2.769109>,
      < 5.063892, -1.959112, 2.813766>
    }
    triangle {
      < 5.025710, -2.063654, 2.769109>,
      < 5.063892, -1.959112, 2.813766>,
      < 5.033027, -1.959114, 2.813766>
    }
    triangle {
      < 5.024823, -2.076324, 2.756803>,
      < 5.072080, -2.076324, 2.756803>,
      < 5.071195, -2.063653, 2.769109>
    }
    triangle {
      < 5.024823, -2.076324, 2.756803>,
      < 5.071195, -2.063653, 2.769109>,
      < 5.025710, -2.063654, 2.769109>
    }
    triangle {
      < 5.023346, -2.097444, 2.779159>,
      < 5.073556, -2.097443, 2.779159>,
      < 5.072080, -2.076324, 2.756803>
    }
    triangle {
      < 5.023346, -2.097444, 2.779159>,
      < 5.072080, -2.076324, 2.756803>,
      < 5.024823, -2.076324, 2.756803>
    }
    triangle {
      < 5.090111, -2.181920, 2.764932>,
      < 5.073556, -2.097443, 2.779159>,
      < 5.061714, -2.162088, 2.768997>
    }
    triangle {
      < 5.093503, -2.218077, 2.663333>,
      < 5.090111, -2.181920, 2.764932>,
      < 5.061714, -2.162088, 2.768997>
    }
    triangle {
      < 5.093503, -2.218077, 2.663333>,
      < 5.061714, -2.162088, 2.768997>,
      < 5.062791, -2.196627, 2.663333>
    }
    triangle {
      < 5.009108, -2.300864, 2.663332>,
      < 5.087767, -2.300864, 2.663332>,
      < 5.093503, -2.218077, 2.663333>
    }
    triangle {
      < 5.009108, -2.300864, 2.663332>,
      < 5.093503, -2.218077, 2.663333>,
      < 5.003380, -2.218076, 2.663333>
    }
    triangle {
      < 5.008566, -2.308635, 2.744609>,
      < 5.088312, -2.308636, 2.744609>,
      < 5.087767, -2.300864, 2.663332>
    }
    triangle {
      < 5.008566, -2.308635, 2.744609>,
      < 5.087767, -2.300864, 2.663332>,
      < 5.009108, -2.300864, 2.663332>
    }
    triangle {
      < 5.004132, -2.371993, 2.736479>,
      < 5.092739, -2.371994, 2.736479>,
      < 5.088312, -2.308636, 2.744609>
    }
    triangle {
      < 5.004132, -2.371993, 2.736479>,
      < 5.088312, -2.308636, 2.744609>,
      < 5.008566, -2.308635, 2.744609>
    }
    triangle {
      < 5.004124, -2.372077, 2.633340>,
      < 5.092742, -2.372079, 2.633340>,
      < 5.092739, -2.371994, 2.736479>
    }
    triangle {
      < 5.004124, -2.372077, 2.633340>,
      < 5.092739, -2.371994, 2.736479>,
      < 5.004132, -2.371993, 2.736479>
    }
    triangle {
      < 5.056588, -1.854571, 2.842164>,
      < 5.072674, -1.852307, 2.842164>,
      < 5.071232, -1.845522, 2.828054>
    }
    triangle {
      < 5.056588, -1.854571, 2.842164>,
      < 5.071232, -1.845522, 2.828054>,
      < 5.056104, -1.847651, 2.828054>
    }
    triangle {
      < 5.063892, -1.959112, 2.813766>,
      < 5.094456, -1.954814, 2.813766>,
      < 5.072674, -1.852307, 2.842164>
    }
    triangle {
      < 5.063892, -1.959112, 2.813766>,
      < 5.072674, -1.852307, 2.842164>,
      < 5.056588, -1.854571, 2.842164>
    }
    triangle {
      < 5.071195, -2.063653, 2.769109>,
      < 5.116237, -2.057322, 2.769109>,
      < 5.094456, -1.954814, 2.813766>
    }
    triangle {
      < 5.071195, -2.063653, 2.769109>,
      < 5.094456, -1.954814, 2.813766>,
      < 5.063892, -1.959112, 2.813766>
    }
    triangle {
      < 5.072080, -2.076324, 2.756803>,
      < 5.118877, -2.069746, 2.756803>,
      < 5.116237, -2.057322, 2.769109>
    }
    triangle {
      < 5.072080, -2.076324, 2.756803>,
      < 5.116237, -2.057322, 2.769109>,
      < 5.071195, -2.063653, 2.769109>
    }
    triangle {
      < 5.073556, -2.097443, 2.779159>,
      < 5.123278, -2.090454, 2.779159>,
      < 5.118877, -2.069746, 2.756803>
    }
    triangle {
      < 5.073556, -2.097443, 2.779159>,
      < 5.118877, -2.069746, 2.756803>,
      < 5.072080, -2.076324, 2.756803>
    }
    triangle {
      < 5.090111, -2.181920, 2.764932>,
      < 5.140880, -2.173288, 2.764932>,
      < 5.123278, -2.090454, 2.779159>
    }
    triangle {
      < 5.090111, -2.181920, 2.764932>,
      < 5.123278, -2.090454, 2.779159>,
      < 5.073556, -2.097443, 2.779159>
    }
    triangle {
      < 5.093503, -2.218077, 2.663333>,
      < 5.148411, -2.208741, 2.663333>,
      < 5.140880, -2.173288, 2.764932>
    }
    triangle {
      < 5.093503, -2.218077, 2.663333>,
      < 5.140880, -2.173288, 2.764932>,
      < 5.090111, -2.181920, 2.764932>
    }
    triangle {
      < 5.087767, -2.300864, 2.663332>,
      < 5.165660, -2.289918, 2.663332>,
      < 5.148411, -2.208741, 2.663333>
    }
    triangle {
      < 5.087767, -2.300864, 2.663332>,
      < 5.148411, -2.208741, 2.663333>,
      < 5.093503, -2.218077, 2.663333>
    }
    triangle {
      < 5.088312, -2.308636, 2.744609>,
      < 5.167282, -2.297539, 2.744609>,
      < 5.165660, -2.289918, 2.663332>
    }
    triangle {
      < 5.088312, -2.308636, 2.744609>,
      < 5.165660, -2.289918, 2.663332>,
      < 5.087767, -2.300864, 2.663332>
    }
    triangle {
      < 5.092739, -2.371994, 2.736479>,
      < 5.180483, -2.359664, 2.736479>,
      < 5.167282, -2.297539, 2.744609>
    }
    triangle {
      < 5.092739, -2.371994, 2.736479>,
      < 5.167282, -2.297539, 2.744609>,
      < 5.088312, -2.308636, 2.744609>
    }
    triangle {
      < 5.092742, -2.372079, 2.633340>,
      < 5.180498, -2.359747, 2.633340>,
      < 5.180483, -2.359664, 2.736479>
    }
    triangle {
      < 5.092742, -2.372079, 2.633340>,
      < 5.180483, -2.359664, 2.736479>,
      < 5.092739, -2.371994, 2.736479>
    }
    triangle {
      < 5.072674, -1.852307, 2.842164>,
      < 5.088288, -1.847826, 2.842164>,
      < 5.085916, -1.841309, 2.828054>
    }
    triangle {
      < 5.072674, -1.852307, 2.842164>,
      < 5.085916, -1.841309, 2.828054>,
      < 5.071232, -1.845522, 2.828054>
    }
    triangle {
      < 5.094456, -1.954814, 2.813766>,
      < 5.124124, -1.946305, 2.813766>,
      < 5.088288, -1.847826, 2.842164>
    }
    triangle {
      < 5.094456, -1.954814, 2.813766>,
      < 5.088288, -1.847826, 2.842164>,
      < 5.072674, -1.852307, 2.842164>
    }
    triangle {
      < 5.116237, -2.057322, 2.769109>,
      < 5.159960, -2.044784, 2.769109>,
      < 5.124124, -1.946305, 2.813766>
    }
    triangle {
      < 5.116237, -2.057322, 2.769109>,
      < 5.124124, -1.946305, 2.813766>,
      < 5.094456, -1.954814, 2.813766>
    }
    triangle {
      < 5.118877, -2.069746, 2.756803>,
      < 5.164303, -2.056719, 2.756803>,
      < 5.159960, -2.044784, 2.769109>
    }
    triangle {
      < 5.118877, -2.069746, 2.756803>,
      < 5.159960, -2.044784, 2.769109>,
      < 5.116237, -2.057322, 2.769109>
    }
    triangle {
      < 5.123278, -2.090454, 2.779159>,
      < 5.171543, -2.076614, 2.779159>,
      < 5.164303, -2.056719, 2.756803>
    }
    triangle {
      < 5.123278, -2.090454, 2.779159>,
      < 5.164303, -2.056719, 2.756803>,
      < 5.118877, -2.069746, 2.756803>
    }
    triangle {
      < 5.140880, -2.173288, 2.764932>,
      < 5.190770, -2.160525, 2.764932>,
      < 5.171543, -2.076614, 2.779159>
    }
    triangle {
      < 5.140880, -2.173288, 2.764932>,
      < 5.171543, -2.076614, 2.779159>,
      < 5.123278, -2.090454, 2.779159>
    }
    triangle {
      < 5.148411, -2.208741, 2.663333>,
      < 5.202368, -2.194938, 2.663333>,
      < 5.190770, -2.160525, 2.764932>
    }
    triangle {
      < 5.148411, -2.208741, 2.663333>,
      < 5.190770, -2.160525, 2.764932>,
      < 5.140880, -2.173288, 2.764932>
    }
    triangle {
      < 5.165660, -2.289918, 2.663332>,
      < 5.241273, -2.268238, 2.663332>,
      < 5.202368, -2.194938, 2.663333>
    }
    triangle {
      < 5.165660, -2.289918, 2.663332>,
      < 5.202368, -2.194938, 2.663333>,
      < 5.148411, -2.208741, 2.663333>
    }
    triangle {
      < 5.167282, -2.297539, 2.744609>,
      < 5.243939, -2.275559, 2.744609>,
      < 5.241273, -2.268238, 2.663332>
    }
    triangle {
      < 5.167282, -2.297539, 2.744609>,
      < 5.241273, -2.268238, 2.663332>,
      < 5.165660, -2.289918, 2.663332>
    }
    triangle {
      < 5.180483, -2.359664, 2.736479>,
      < 5.265658, -2.335242, 2.736479>,
      < 5.243939, -2.275559, 2.744609>
    }
    triangle {
      < 5.180483, -2.359664, 2.736479>,
      < 5.243939, -2.275559, 2.744609>,
      < 5.167282, -2.297539, 2.744609>
    }
    triangle {
      < 5.180498, -2.359747, 2.633340>,
      < 5.265685, -2.335323, 2.633340>,
      < 5.265658, -2.335242, 2.736479>
    }
    triangle {
      < 5.180498, -2.359747, 2.633340>,
      < 5.265658, -2.335242, 2.736479>,
      < 5.180483, -2.359664, 2.736479>
    }
    triangle {
      < 5.088288, -1.847826, 2.842164>,
      < 5.103127, -1.841217, 2.842164>,
      < 5.099871, -1.835093, 2.828054>
    }
    triangle {
      < 5.088288, -1.847826, 2.842164>,
      < 5.099871, -1.835093, 2.828054>,
      < 5.085916, -1.841309, 2.828054>
    }
    triangle {
      < 5.124124, -1.946305, 2.813766>,
      < 5.152320, -1.933749, 2.813766>,
      < 5.103127, -1.841217, 2.842164>
    }
    triangle {
      < 5.124124, -1.946305, 2.813766>,
      < 5.103127, -1.841217, 2.842164>,
      < 5.088288, -1.847826, 2.842164>
    }
    triangle {
      < 5.159960, -2.044784, 2.769109>,
      < 5.201512, -2.026282, 2.769109>,
      < 5.152320, -1.933749, 2.813766>
    }
    triangle {
      < 5.159960, -2.044784, 2.769109>,
      < 5.152320, -1.933749, 2.813766>,
      < 5.124124, -1.946305, 2.813766>
    }
    triangle {
      < 5.164303, -2.056719, 2.756803>,
      < 5.207474, -2.037498, 2.756803>,
      < 5.201512, -2.026282, 2.769109>
    }
    triangle {
      < 5.164303, -2.056719, 2.756803>,
      < 5.201512, -2.026282, 2.769109>,
      < 5.159960, -2.044784, 2.769109>
    }
    triangle {
      < 5.171543, -2.076614, 2.779159>,
      < 5.217412, -2.056191, 2.779159>,
      < 5.207474, -2.037498, 2.756803>
    }
    triangle {
      < 5.171543, -2.076614, 2.779159>,
      < 5.207474, -2.037498, 2.756803>,
      < 5.164303, -2.056719, 2.756803>
    }
    triangle {
      < 5.266896, -2.126631, 2.764932>,
      < 5.217412, -2.056191, 2.779159>,
      < 5.232887, -2.120064, 2.768997>
    }
    triangle {
      < 5.284700, -2.158282, 2.663333>,
      < 5.266896, -2.126631, 2.764932>,
      < 5.232887, -2.120064, 2.768997>
    }
    triangle {
      < 5.284700, -2.158282, 2.663333>,
      < 5.232887, -2.120064, 2.768997>,
      < 5.247919, -2.151179, 2.663333>
    }
    triangle {
      < 5.241273, -2.268238, 2.663332>,
      < 5.313132, -2.236246, 2.663332>,
      < 5.284700, -2.158282, 2.663333>
    }
    triangle {
      < 5.241273, -2.268238, 2.663332>,
      < 5.284700, -2.158282, 2.663333>,
      < 5.202368, -2.194938, 2.663333>
    }
    triangle {
      < 5.243939, -2.275559, 2.744609>,
      < 5.316791, -2.243124, 2.744609>,
      < 5.313132, -2.236246, 2.663332>
    }
    triangle {
      < 5.243939, -2.275559, 2.744609>,
      < 5.313132, -2.236246, 2.663332>,
      < 5.241273, -2.268238, 2.663332>
    }
    triangle {
      < 5.265658, -2.335242, 2.736479>,
      < 5.346605, -2.299204, 2.736479>,
      < 5.316791, -2.243124, 2.744609>
    }
    triangle {
      < 5.265658, -2.335242, 2.736479>,
      < 5.316791, -2.243124, 2.744609>,
      < 5.243939, -2.275559, 2.744609>
    }
    triangle {
      < 5.265685, -2.335323, 2.633340>,
      < 5.346642, -2.299281, 2.633340>,
      < 5.346605, -2.299204, 2.736479>
    }
    triangle {
      < 5.265685, -2.335323, 2.633340>,
      < 5.346605, -2.299204, 2.736479>,
      < 5.265658, -2.335242, 2.736479>
    }
    triangle {
      < 5.103127, -1.841217, 2.842164>,
      < 5.116902, -1.832606, 2.842164>,
      < 5.112825, -1.826995, 2.828054>
    }
    triangle {
      < 5.103127, -1.841217, 2.842164>,
      < 5.112825, -1.826995, 2.828054>,
      < 5.099871, -1.835093, 2.828054>
    }
    triangle {
      < 5.152320, -1.933749, 2.813766>,
      < 5.178493, -1.917392, 2.813766>,
      < 5.116902, -1.832606, 2.842164>
    }
    triangle {
      < 5.152320, -1.933749, 2.813766>,
      < 5.116902, -1.832606, 2.842164>,
      < 5.103127, -1.841217, 2.842164>
    }
    triangle {
      < 5.201512, -2.026282, 2.769109>,
      < 5.240085, -2.002178, 2.769109>,
      < 5.178493, -1.917392, 2.813766>
    }
    triangle {
      < 5.201512, -2.026282, 2.769109>,
      < 5.178493, -1.917392, 2.813766>,
      < 5.152320, -1.933749, 2.813766>
    }
    triangle {
      < 5.207474, -2.037498, 2.756803>,
      < 5.247550, -2.012455, 2.756803>,
      < 5.240085, -2.002178, 2.769109>
    }
    triangle {
      < 5.207474, -2.037498, 2.756803>,
      < 5.240085, -2.002178, 2.769109>,
      < 5.201512, -2.026282, 2.769109>
    }
    triangle {
      < 5.217412, -2.056191, 2.779159>,
      < 5.259993, -2.029583, 2.779159>,
      < 5.247550, -2.012455, 2.756803>
    }
    triangle {
      < 5.217412, -2.056191, 2.779159>,
      < 5.247550, -2.012455, 2.756803>,
      < 5.207474, -2.037498, 2.756803>
    }
    triangle {
      < 5.266896, -2.126631, 2.764932>,
      < 5.309764, -2.098096, 2.764932>,
      < 5.259993, -2.029583, 2.779159>
    }
    triangle {
      < 5.266896, -2.126631, 2.764932>,
      < 5.259993, -2.029583, 2.779159>,
      < 5.217412, -2.056191, 2.779159>
    }
    triangle {
      < 5.284700, -2.158282, 2.663333>,
      < 5.331064, -2.127422, 2.663333>,
      < 5.309764, -2.098096, 2.764932>
    }
    triangle {
      < 5.284700, -2.158282, 2.663333>,
      < 5.309764, -2.098096, 2.764932>,
      < 5.266896, -2.126631, 2.764932>
    }
    triangle {
      < 5.313132, -2.236246, 2.663332>,
      < 5.379840, -2.194565, 2.663332>,
      < 5.331064, -2.127422, 2.663333>
    }
    triangle {
      < 5.313132, -2.236246, 2.663332>,
      < 5.331064, -2.127422, 2.663333>,
      < 5.284700, -2.158282, 2.663333>
    }
    triangle {
      < 5.316791, -2.243124, 2.744609>,
      < 5.384420, -2.200867, 2.744609>,
      < 5.379840, -2.194565, 2.663332>
    }
    triangle {
      < 5.316791, -2.243124, 2.744609>,
      < 5.379840, -2.194565, 2.663332>,
      < 5.313132, -2.236246, 2.663332>
    }
    triangle {
      < 5.346605, -2.299204, 2.736479>,
      < 5.421749, -2.252252, 2.736479>,
      < 5.384420, -2.200867, 2.744609>
    }
    triangle {
      < 5.346605, -2.299204, 2.736479>,
      < 5.384420, -2.200867, 2.744609>,
      < 5.316791, -2.243124, 2.744609>
    }
    triangle {
      < 5.346642, -2.299281, 2.633340>,
      < 5.421796, -2.252322, 2.633340>,
      < 5.421749, -2.252252, 2.736479>
    }
    triangle {
      < 5.346642, -2.299281, 2.633340>,
      < 5.421749, -2.252252, 2.736479>,
      < 5.346605, -2.299204, 2.736479>
    }
    triangle {
      < 5.116902, -1.832606, 2.842164>,
      < 5.129344, -1.822162, 2.842164>,
      < 5.124527, -1.817173, 2.828054>
    }
    triangle {
      < 5.116902, -1.832606, 2.842164>,
      < 5.124527, -1.817173, 2.828054>,
      < 5.112825, -1.826995, 2.828054>
    }
    triangle {
      < 5.178493, -1.917392, 2.813766>,
      < 5.202137, -1.897551, 2.813766>,
      < 5.129344, -1.822162, 2.842164>
    }
    triangle {
      < 5.178493, -1.917392, 2.813766>,
      < 5.129344, -1.822162, 2.842164>,
      < 5.116902, -1.832606, 2.842164>
    }
    triangle {
      < 5.240085, -2.002178, 2.769109>,
      < 5.274928, -1.972941, 2.769109>,
      < 5.202137, -1.897551, 2.813766>
    }
    triangle {
      < 5.240085, -2.002178, 2.769109>,
      < 5.202137, -1.897551, 2.813766>,
      < 5.178493, -1.917392, 2.813766>
    }
    triangle {
      < 5.247550, -2.012455, 2.756803>,
      < 5.283751, -1.982078, 2.756803>,
      < 5.274928, -1.972941, 2.769109>
    }
    triangle {
      < 5.247550, -2.012455, 2.756803>,
      < 5.274928, -1.972941, 2.769109>,
      < 5.240085, -2.002178, 2.769109>
    }
    triangle {
      < 5.259993, -2.029583, 2.779159>,
      < 5.298456, -1.997308, 2.779159>,
      < 5.283751, -1.982078, 2.756803>
    }
    triangle {
      < 5.259993, -2.029583, 2.779159>,
      < 5.283751, -1.982078, 2.756803>,
      < 5.247550, -2.012455, 2.756803>
    }
    triangle {
      < 5.309764, -2.098096, 2.764932>,
      < 5.350150, -2.066145, 2.764932>,
      < 5.298456, -1.997308, 2.779159>
    }
    triangle {
      < 5.309764, -2.098096, 2.764932>,
      < 5.298456, -1.997308, 2.779159>,
      < 5.259993, -2.029583, 2.779159>
    }
    triangle {
      < 5.331064, -2.127422, 2.663333>,
      < 5.374743, -2.092865, 2.663333>,
      < 5.350150, -2.066145, 2.764932>
    }
    triangle {
      < 5.331064, -2.127422, 2.663333>,
      < 5.350150, -2.066145, 2.764932>,
      < 5.309764, -2.098096, 2.764932>
    }
    triangle {
      < 5.379840, -2.194565, 2.663332>,
      < 5.440097, -2.144005, 2.663332>,
      < 5.374743, -2.092865, 2.663333>
    }
    triangle {
      < 5.379840, -2.194565, 2.663332>,
      < 5.374743, -2.092865, 2.663333>,
      < 5.331064, -2.127422, 2.663333>
    }
    triangle {
      < 5.384420, -2.200867, 2.744609>,
      < 5.445510, -2.149608, 2.744609>,
      < 5.440097, -2.144005, 2.663332>
    }
    triangle {
      < 5.384420, -2.200867, 2.744609>,
      < 5.440097, -2.144005, 2.663332>,
      < 5.379840, -2.194565, 2.663332>
    }
    triangle {
      < 5.421749, -2.252252, 2.736479>,
      < 5.489627, -2.195299, 2.736479>,
      < 5.445510, -2.149608, 2.744609>
    }
    triangle {
      < 5.421749, -2.252252, 2.736479>,
      < 5.445510, -2.149608, 2.744609>,
      < 5.384420, -2.200867, 2.744609>
    }
    triangle {
      < 5.421796, -2.252322, 2.633340>,
      < 5.489684, -2.195361, 2.633340>,
      < 5.489627, -2.195299, 2.736479>
    }
    triangle {
      < 5.421796, -2.252322, 2.633340>,
      < 5.489627, -2.195299, 2.736479>,
      < 5.421749, -2.252252, 2.736479>
    }
    triangle {
      < 5.129344, -1.822162, 2.842164>,
      < 5.140212, -1.810088, 2.842164>,
      < 5.134747, -1.805818, 2.828054>
    }
    triangle {
      < 5.129344, -1.822162, 2.842164>,
      < 5.134747, -1.805818, 2.828054>,
      < 5.124527, -1.817173, 2.828054>
    }
    triangle {
      < 5.202137, -1.897551, 2.813766>,
      < 5.222787, -1.874613, 2.813766>,
      < 5.140212, -1.810088, 2.842164>
    }
    triangle {
      < 5.202137, -1.897551, 2.813766>,
      < 5.140212, -1.810088, 2.842164>,
      < 5.129344, -1.822162, 2.842164>
    }
    triangle {
      < 5.274928, -1.972941, 2.769109>,
      < 5.305363, -1.939139, 2.769109>,
      < 5.222787, -1.874613, 2.813766>
    }
    triangle {
      < 5.274928, -1.972941, 2.769109>,
      < 5.222787, -1.874613, 2.813766>,
      < 5.202137, -1.897551, 2.813766>
    }
    triangle {
      < 5.283751, -1.982078, 2.756803>,
      < 5.315371, -1.946959, 2.756803>,
      < 5.305363, -1.939139, 2.769109>
    }
    triangle {
      < 5.283751, -1.982078, 2.756803>,
      < 5.305363, -1.939139, 2.769109>,
      < 5.274928, -1.972941, 2.769109>
    }
    triangle {
      < 5.298456, -1.997308, 2.779159>,
      < 5.332053, -1.959994, 2.779159>,
      < 5.315371, -1.946959, 2.756803>
    }
    triangle {
      < 5.298456, -1.997308, 2.779159>,
      < 5.315371, -1.946959, 2.756803>,
      < 5.283751, -1.982078, 2.756803>
    }
    triangle {
      < 5.405909, -2.004219, 2.764932>,
      < 5.332053, -1.959994, 2.779159>,
      < 5.372169, -2.012052, 2.768997>
    }
    triangle {
      < 5.435048, -2.025892, 2.663333>,
      < 5.405909, -2.004219, 2.764932>,
      < 5.372169, -2.012052, 2.768997>
    }
    triangle {
      < 5.435048, -2.025892, 2.663333>,
      < 5.372169, -2.012052, 2.768997>,
      < 5.398557, -2.034363, 2.663333>
    }
    triangle {
      < 5.440097, -2.144005, 2.663332>,
      < 5.492732, -2.085552, 2.663332>,
      < 5.435048, -2.025892, 2.663333>
    }
    triangle {
      < 5.440097, -2.144005, 2.663332>,
      < 5.435048, -2.025892, 2.663333>,
      < 5.374743, -2.092865, 2.663333>
    }
    triangle {
      < 5.445510, -2.149608, 2.744609>,
      < 5.498872, -2.090347, 2.744609>,
      < 5.492732, -2.085552, 2.663332>
    }
    triangle {
      < 5.445510, -2.149608, 2.744609>,
      < 5.492732, -2.085552, 2.663332>,
      < 5.440097, -2.144005, 2.663332>
    }
    triangle {
      < 5.489627, -2.195299, 2.736479>,
      < 5.548918, -2.129453, 2.736479>,
      < 5.498872, -2.090347, 2.744609>
    }
    triangle {
      < 5.489627, -2.195299, 2.736479>,
      < 5.498872, -2.090347, 2.744609>,
      < 5.445510, -2.149608, 2.744609>
    }
    triangle {
      < 5.489684, -2.195361, 2.633340>,
      < 5.548983, -2.129507, 2.633340>,
      < 5.548918, -2.129453, 2.736479>
    }
    triangle {
      < 5.489684, -2.195361, 2.633340>,
      < 5.548918, -2.129453, 2.736479>,
      < 5.489627, -2.195299, 2.736479>
    }
    triangle {
      < 5.140212, -1.810088, 2.842164>,
      < 5.143287, -1.793151, 2.828054>,
      < 5.134747, -1.805818, 2.828054>
    }
    triangle {
      < 5.222787, -1.874613, 2.813766>,
      < 5.232167, -1.860699, 2.813766>,
      < 5.140212, -1.810088, 2.842164>
    }
    triangle {
      < 5.222787, -1.874613, 2.813766>,
      < 5.305363, -1.939139, 2.769109>,
      < 5.326525, -1.907472, 2.769109>
    }
    triangle {
      < 5.222787, -1.874613, 2.813766>,
      < 5.326525, -1.907472, 2.769109>,
      < 5.232167, -1.860699, 2.813766>
    }
    triangle {
      < 5.305363, -1.939139, 2.769109>,
      < 5.315371, -1.946959, 2.756803>,
      < 5.341797, -1.907782, 2.756803>
    }
    triangle {
      < 5.305363, -1.939139, 2.769109>,
      < 5.341797, -1.907782, 2.756803>,
      < 5.326525, -1.907472, 2.769109>
    }
    triangle {
      < 5.332053, -1.959994, 2.779159>,
      < 5.360131, -1.918368, 2.779159>,
      < 5.341797, -1.907782, 2.756803>
    }
    triangle {
      < 5.332053, -1.959994, 2.779159>,
      < 5.341797, -1.907782, 2.756803>,
      < 5.315371, -1.946959, 2.756803>
    }
    triangle {
      < 5.405909, -2.004219, 2.764932>,
      < 5.433465, -1.960715, 2.764932>,
      < 5.360131, -1.918368, 2.779159>
    }
    triangle {
      < 5.405909, -2.004219, 2.764932>,
      < 5.360131, -1.918368, 2.779159>,
      < 5.332053, -1.959994, 2.779159>
    }
    triangle {
      < 5.435048, -2.025892, 2.663333>,
      < 5.464851, -1.978842, 2.663333>,
      < 5.433465, -1.960715, 2.764932>
    }
    triangle {
      < 5.435048, -2.025892, 2.663333>,
      < 5.433465, -1.960715, 2.764932>,
      < 5.405909, -2.004219, 2.764932>
    }
    triangle {
      < 5.492732, -2.085552, 2.663332>,
      < 5.536720, -2.020342, 2.663332>,
      < 5.464851, -1.978842, 2.663333>
    }
    triangle {
      < 5.492732, -2.085552, 2.663332>,
      < 5.464851, -1.978842, 2.663333>,
      < 5.435048, -2.025892, 2.663333>
    }
    triangle {
      < 5.498872, -2.090347, 2.744609>,
      < 5.543468, -2.024236, 2.744609>,
      < 5.536720, -2.020342, 2.663332>
    }
    triangle {
      < 5.498872, -2.090347, 2.744609>,
      < 5.536720, -2.020342, 2.663332>,
      < 5.492732, -2.085552, 2.663332>
    }
    triangle {
      < 5.548918, -2.129453, 2.736479>,
      < 5.598469, -2.055996, 2.736479>,
      < 5.543468, -2.024236, 2.744609>
    }
    triangle {
      < 5.548918, -2.129453, 2.736479>,
      < 5.543468, -2.024236, 2.744609>,
      < 5.498872, -2.090347, 2.744609>
    }
    triangle {
      < 5.548983, -2.129507, 2.633340>,
      < 5.598540, -2.056041, 2.633340>,
      < 5.598469, -2.055996, 2.736479>
    }
    triangle {
      < 5.548983, -2.129507, 2.633340>,
      < 5.598469, -2.055996, 2.736479>,
      < 5.548918, -2.129453, 2.736479>
    }
    triangle {
      < 5.156413, -1.782018, 2.842164>,
      < 5.149981, -1.779420, 2.828054>,
      < 5.143287, -1.793151, 2.828054>
    }
    triangle {
      < 5.253574, -1.821283, 2.813766>,
      < 5.156413, -1.782018, 2.842164>,
      < 5.246215, -1.836364, 2.813766>
    }
    triangle {
      < 5.333894, -1.894709, 2.769109>,
      < 5.350737, -1.860548, 2.769109>,
      < 5.253574, -1.821283, 2.813766>
    }
    triangle {
      < 5.333894, -1.894709, 2.769109>,
      < 5.253574, -1.821283, 2.813766>,
      < 5.246215, -1.836364, 2.813766>
    }
    triangle {
      < 5.333894, -1.894709, 2.769109>,
      < 5.341797, -1.907782, 2.756803>,
      < 5.362513, -1.865308, 2.756803>
    }
    triangle {
      < 5.333894, -1.894709, 2.769109>,
      < 5.362513, -1.865308, 2.756803>,
      < 5.350737, -1.860548, 2.769109>
    }
    triangle {
      < 5.360131, -1.918368, 2.779159>,
      < 5.382142, -1.873239, 2.779159>,
      < 5.362513, -1.865308, 2.756803>
    }
    triangle {
      < 5.360131, -1.918368, 2.779159>,
      < 5.362513, -1.865308, 2.756803>,
      < 5.341797, -1.907782, 2.756803>
    }
    triangle {
      < 5.433465, -1.960715, 2.764932>,
      < 5.457364, -1.915100, 2.764932>,
      < 5.382142, -1.873239, 2.779159>
    }
    triangle {
      < 5.433465, -1.960715, 2.764932>,
      < 5.382142, -1.873239, 2.779159>,
      < 5.360131, -1.918368, 2.779159>
    }
    triangle {
      < 5.464851, -1.978842, 2.663333>,
      < 5.490699, -1.929508, 2.663333>,
      < 5.457364, -1.915100, 2.764932>
    }
    triangle {
      < 5.464851, -1.978842, 2.663333>,
      < 5.457364, -1.915100, 2.764932>,
      < 5.433465, -1.960715, 2.764932>
    }
    triangle {
      < 5.536720, -2.020342, 2.663332>,
      < 5.571204, -1.949645, 2.663332>,
      < 5.490699, -1.929508, 2.663333>
    }
    triangle {
      < 5.536720, -2.020342, 2.663332>,
      < 5.490699, -1.929508, 2.663333>,
      < 5.464851, -1.978842, 2.663333>
    }
    triangle {
      < 5.543468, -2.024236, 2.744609>,
      < 5.578428, -1.952562, 2.744609>,
      < 5.571204, -1.949645, 2.663332>
    }
    triangle {
      < 5.543468, -2.024236, 2.744609>,
      < 5.571204, -1.949645, 2.663332>,
      < 5.536720, -2.020342, 2.663332>
    }
    triangle {
      < 5.598469, -2.055996, 2.736479>,
      < 5.637314, -1.976358, 2.736479>,
      < 5.578428, -1.952562, 2.744609>
    }
    triangle {
      < 5.598469, -2.055996, 2.736479>,
      < 5.578428, -1.952562, 2.744609>,
      < 5.543468, -2.024236, 2.744609>
    }
    triangle {
      < 5.598540, -2.056041, 2.633340>,
      < 5.637391, -1.976393, 2.633340>,
      < 5.637314, -1.976358, 2.736479>
    }
    triangle {
      < 5.598540, -2.056041, 2.633340>,
      < 5.637314, -1.976358, 2.736479>,
      < 5.598469, -2.055996, 2.736479>
    }
    triangle {
      < 5.156413, -1.782018, 2.842164>,
      < 5.161430, -1.766568, 2.842164>,
      < 5.154700, -1.764889, 2.828054>
    }
    triangle {
      < 5.156413, -1.782018, 2.842164>,
      < 5.154700, -1.764889, 2.828054>,
      < 5.149981, -1.779420, 2.828054>
    }
    triangle {
      < 5.253574, -1.821283, 2.813766>,
      < 5.263111, -1.791928, 2.813766>,
      < 5.161430, -1.766568, 2.842164>
    }
    triangle {
      < 5.253574, -1.821283, 2.813766>,
      < 5.161430, -1.766568, 2.842164>,
      < 5.156413, -1.782018, 2.842164>
    }
    triangle {
      < 5.350737, -1.860548, 2.769109>,
      < 5.364792, -1.817290, 2.769109>,
      < 5.263111, -1.791928, 2.813766>
    }
    triangle {
      < 5.350737, -1.860548, 2.769109>,
      < 5.263111, -1.791928, 2.813766>,
      < 5.253574, -1.821283, 2.813766>
    }
    triangle {
      < 5.362513, -1.865308, 2.756803>,
      < 5.377116, -1.820364, 2.756803>,
      < 5.364792, -1.817290, 2.769109>
    }
    triangle {
      < 5.362513, -1.865308, 2.756803>,
      < 5.364792, -1.817290, 2.769109>,
      < 5.350737, -1.860548, 2.769109>
    }
    triangle {
      < 5.382142, -1.873239, 2.779159>,
      < 5.397657, -1.825486, 2.779159>,
      < 5.377116, -1.820364, 2.756803>
    }
    triangle {
      < 5.382142, -1.873239, 2.779159>,
      < 5.377116, -1.820364, 2.756803>,
      < 5.362513, -1.865308, 2.756803>
    }
    triangle {
      < 5.483116, -1.835848, 2.764932>,
      < 5.397657, -1.825486, 2.779159>,
      < 5.455479, -1.856727, 2.768997>
    }
    triangle {
      < 5.518551, -1.843796, 2.663333>,
      < 5.483116, -1.835848, 2.764932>,
      < 5.455479, -1.856727, 2.768997>
    }
    triangle {
      < 5.518551, -1.843796, 2.663333>,
      < 5.455479, -1.856727, 2.768997>,
      < 5.488660, -1.866377, 2.663333>
    }
    triangle {
      < 5.571204, -1.949645, 2.663332>,
      < 5.595513, -1.874836, 2.663332>,
      < 5.518551, -1.843796, 2.663333>
    }
    triangle {
      < 5.571204, -1.949645, 2.663332>,
      < 5.518551, -1.843796, 2.663333>,
      < 5.490699, -1.929508, 2.663333>
    }
    triangle {
      < 5.578428, -1.952562, 2.744609>,
      < 5.603073, -1.876719, 2.744609>,
      < 5.595513, -1.874836, 2.663332>
    }
    triangle {
      < 5.578428, -1.952562, 2.744609>,
      < 5.595513, -1.874836, 2.663332>,
      < 5.571204, -1.949645, 2.663332>
    }
    triangle {
      < 5.637314, -1.976358, 2.736479>,
      < 5.664698, -1.892089, 2.736479>,
      < 5.603073, -1.876719, 2.744609>
    }
    triangle {
      < 5.637314, -1.976358, 2.736479>,
      < 5.603073, -1.876719, 2.744609>,
      < 5.578428, -1.952562, 2.744609>
    }
    triangle {
      < 5.637391, -1.976393, 2.633340>,
      < 5.664779, -1.892112, 2.633340>,
      < 5.664698, -1.892089, 2.736479>
    }
    triangle {
      < 5.637391, -1.976393, 2.633340>,
      < 5.664698, -1.892089, 2.736479>,
      < 5.637314, -1.976358, 2.736479>
    }
    triangle {
      < 5.161430, -1.766568, 2.842164>,
      < 5.164248, -1.750569, 2.842164>,
      < 5.157351, -1.749844, 2.828054>
    }
    triangle {
      < 5.161430, -1.766568, 2.842164>,
      < 5.157351, -1.749844, 2.828054>,
      < 5.154700, -1.764889, 2.828054>
    }
    triangle {
      < 5.263111, -1.791928, 2.813766>,
      < 5.268469, -1.761532, 2.813766>,
      < 5.164248, -1.750569, 2.842164>
    }
    triangle {
      < 5.263111, -1.791928, 2.813766>,
      < 5.164248, -1.750569, 2.842164>,
      < 5.161430, -1.766568, 2.842164>
    }
    triangle {
      < 5.364792, -1.817290, 2.769109>,
      < 5.372690, -1.772496, 2.769109>,
      < 5.268469, -1.761532, 2.813766>
    }
    triangle {
      < 5.364792, -1.817290, 2.769109>,
      < 5.268469, -1.761532, 2.813766>,
      < 5.263111, -1.791928, 2.813766>
    }
    triangle {
      < 5.377116, -1.820364, 2.756803>,
      < 5.385322, -1.773825, 2.756803>,
      < 5.372690, -1.772496, 2.769109>
    }
    triangle {
      < 5.377116, -1.820364, 2.756803>,
      < 5.372690, -1.772496, 2.769109>,
      < 5.364792, -1.817290, 2.769109>
    }
    triangle {
      < 5.397657, -1.825486, 2.779159>,
      < 5.406377, -1.776039, 2.779159>,
      < 5.385322, -1.773825, 2.756803>
    }
    triangle {
      < 5.397657, -1.825486, 2.779159>,
      < 5.385322, -1.773825, 2.756803>,
      < 5.377116, -1.820364, 2.756803>
    }
    triangle {
      < 5.483116, -1.835848, 2.764932>,
      < 5.490595, -1.784897, 2.764932>,
      < 5.406377, -1.776039, 2.779159>
    }
    triangle {
      < 5.483116, -1.835848, 2.764932>,
      < 5.406377, -1.776039, 2.779159>,
      < 5.397657, -1.825486, 2.779159>
    }
    triangle {
      < 5.518551, -1.843796, 2.663333>,
      < 5.526640, -1.788691, 2.663333>,
      < 5.490595, -1.784897, 2.764932>
    }
    triangle {
      < 5.518551, -1.843796, 2.663333>,
      < 5.490595, -1.784897, 2.764932>,
      < 5.483116, -1.835848, 2.764932>
    }
    triangle {
      < 5.595513, -1.874836, 2.663332>,
      < 5.609175, -1.797373, 2.663332>,
      < 5.526640, -1.788691, 2.663333>
    }
    triangle {
      < 5.595513, -1.874836, 2.663332>,
      < 5.526640, -1.788691, 2.663333>,
      < 5.518551, -1.843796, 2.663333>
    }
    triangle {
      < 5.603073, -1.876719, 2.744609>,
      < 5.616923, -1.798185, 2.744609>,
      < 5.609175, -1.797373, 2.663332>
    }
    triangle {
      < 5.603073, -1.876719, 2.744609>,
      < 5.609175, -1.797373, 2.663332>,
      < 5.595513, -1.874836, 2.663332>
    }
    triangle {
      < 5.664698, -1.892089, 2.736479>,
      < 5.680087, -1.804829, 2.736479>,
      < 5.616923, -1.798185, 2.744609>
    }
    triangle {
      < 5.664698, -1.892089, 2.736479>,
      < 5.616923, -1.798185, 2.744609>,
      < 5.603073, -1.876719, 2.744609>
    }
    triangle {
      < 5.664779, -1.892112, 2.633340>,
      < 5.680171, -1.804841, 2.633340>,
      < 5.680087, -1.804829, 2.736479>
    }
    triangle {
      < 5.664779, -1.892112, 2.633340>,
      < 5.680087, -1.804829, 2.736479>,
      < 5.664698, -1.892089, 2.736479>
    }
    triangle {
      < 5.164248, -1.750569, 2.842164>,
      < 5.164813, -1.734335, 2.842164>,
      < 5.157881, -1.734577, 2.828054>
    }
    triangle {
      < 5.164248, -1.750569, 2.842164>,
      < 5.157881, -1.734577, 2.828054>,
      < 5.157351, -1.749844, 2.828054>
    }
    triangle {
      < 5.268469, -1.761532, 2.813766>,
      < 5.269545, -1.730686, 2.813766>,
      < 5.164813, -1.734335, 2.842164>
    }
    triangle {
      < 5.268469, -1.761532, 2.813766>,
      < 5.164813, -1.734335, 2.842164>,
      < 5.164248, -1.750569, 2.842164>
    }
    triangle {
      < 5.372690, -1.772496, 2.769109>,
      < 5.374278, -1.727039, 2.769109>,
      < 5.269545, -1.730686, 2.813766>
    }
    triangle {
      < 5.372690, -1.772496, 2.769109>,
      < 5.269545, -1.730686, 2.813766>,
      < 5.268469, -1.761532, 2.813766>
    }
    triangle {
      < 5.385322, -1.773825, 2.756803>,
      < 5.386971, -1.726597, 2.756803>,
      < 5.374278, -1.727039, 2.769109>
    }
    triangle {
      < 5.385322, -1.773825, 2.756803>,
      < 5.374278, -1.727039, 2.769109>,
      < 5.372690, -1.772496, 2.769109>
    }
    triangle {
      < 5.406377, -1.776039, 2.779159>,
      < 5.408130, -1.725859, 2.779159>,
      < 5.386971, -1.726597, 2.756803>
    }
    triangle {
      < 5.406377, -1.776039, 2.779159>,
      < 5.386971, -1.726597, 2.756803>,
      < 5.385322, -1.773825, 2.756803>
    }
    triangle {
      < 5.490595, -1.784897, 2.764932>,
      < 5.493875, -1.733505, 2.764932>,
      < 5.408130, -1.725859, 2.779159>
    }
    triangle {
      < 5.490595, -1.784897, 2.764932>,
      < 5.408130, -1.725859, 2.779159>,
      < 5.406377, -1.776039, 2.779159>
    }
    triangle {
      < 5.526640, -1.788691, 2.663333>,
      < 5.530188, -1.733109, 2.663333>,
      < 5.493875, -1.733505, 2.764932>
    }
    triangle {
      < 5.526640, -1.788691, 2.663333>,
      < 5.493875, -1.733505, 2.764932>,
      < 5.490595, -1.784897, 2.764932>
    }
    triangle {
      < 5.609175, -1.797373, 2.663332>,
      < 5.611923, -1.718761, 2.663332>,
      < 5.530188, -1.733109, 2.663333>
    }
    triangle {
      < 5.609175, -1.797373, 2.663332>,
      < 5.530188, -1.733109, 2.663333>,
      < 5.526640, -1.788691, 2.663333>
    }
    triangle {
      < 5.616923, -1.798185, 2.744609>,
      < 5.619709, -1.718488, 2.744609>,
      < 5.611923, -1.718761, 2.663332>
    }
    triangle {
      < 5.616923, -1.798185, 2.744609>,
      < 5.611923, -1.718761, 2.663332>,
      < 5.609175, -1.797373, 2.663332>
    }
    triangle {
      < 5.680087, -1.804829, 2.736479>,
      < 5.683183, -1.716277, 2.736479>,
      < 5.619709, -1.718488, 2.744609>
    }
    triangle {
      < 5.680087, -1.804829, 2.736479>,
      < 5.619709, -1.718488, 2.744609>,
      < 5.616923, -1.798185, 2.744609>
    }
    triangle {
      < 5.680171, -1.804841, 2.633340>,
      < 5.683268, -1.716277, 2.633340>,
      < 5.683183, -1.716277, 2.736479>
    }
    triangle {
      < 5.680171, -1.804841, 2.633340>,
      < 5.683183, -1.716277, 2.736479>,
      < 5.680087, -1.804829, 2.736479>
    }
    triangle {
      < 5.164813, -1.734335, 2.842164>,
      < 5.163112, -1.718179, 2.842164>,
      < 5.156281, -1.719384, 2.828054>
    }
    triangle {
      < 5.164813, -1.734335, 2.842164>,
      < 5.156281, -1.719384, 2.828054>,
      < 5.157881, -1.734577, 2.828054>
    }
    triangle {
      < 5.269545, -1.730686, 2.813766>,
      < 5.266318, -1.699991, 2.813766>,
      < 5.163112, -1.718179, 2.842164>
    }
    triangle {
      < 5.269545, -1.730686, 2.813766>,
      < 5.163112, -1.718179, 2.842164>,
      < 5.164813, -1.734335, 2.842164>
    }
    triangle {
      < 5.374278, -1.727039, 2.769109>,
      < 5.369524, -1.681803, 2.769109>,
      < 5.266318, -1.699991, 2.813766>
    }
    triangle {
      < 5.374278, -1.727039, 2.769109>,
      < 5.266318, -1.699991, 2.813766>,
      < 5.269545, -1.730686, 2.813766>
    }
    triangle {
      < 5.386971, -1.726597, 2.756803>,
      < 5.382032, -1.679599, 2.756803>,
      < 5.369524, -1.681803, 2.769109>
    }
    triangle {
      < 5.386971, -1.726597, 2.756803>,
      < 5.369524, -1.681803, 2.769109>,
      < 5.374278, -1.727039, 2.769109>
    }
    triangle {
      < 5.408130, -1.725859, 2.779159>,
      < 5.402882, -1.675924, 2.779159>,
      < 5.382032, -1.679599, 2.756803>
    }
    triangle {
      < 5.408130, -1.725859, 2.779159>,
      < 5.382032, -1.679599, 2.756803>,
      < 5.386971, -1.726597, 2.756803>
    }
    triangle {
      < 5.485167, -1.650631, 2.764932>,
      < 5.402882, -1.675924, 2.779159>,
      < 5.468410, -1.680946, 2.768997>
    }
    triangle {
      < 5.520771, -1.643479, 2.663333>,
      < 5.485167, -1.650631, 2.764932>,
      < 5.468410, -1.680946, 2.768997>
    }
    triangle {
      < 5.520771, -1.643479, 2.663333>,
      < 5.468410, -1.680946, 2.768997>,
      < 5.502648, -1.676265, 2.663333>
    }
    triangle {
      < 5.611923, -1.718761, 2.663332>,
      < 5.603704, -1.640533, 2.663332>,
      < 5.520771, -1.643479, 2.663333>
    }
    triangle {
      < 5.611923, -1.718761, 2.663332>,
      < 5.520771, -1.643479, 2.663333>,
      < 5.530188, -1.733109, 2.663333>
    }
    triangle {
      < 5.619709, -1.718488, 2.744609>,
      < 5.611377, -1.639179, 2.744609>,
      < 5.603704, -1.640533, 2.663332>
    }
    triangle {
      < 5.619709, -1.718488, 2.744609>,
      < 5.603704, -1.640533, 2.663332>,
      < 5.611923, -1.718761, 2.663332>
    }
    triangle {
      < 5.683183, -1.716277, 2.736479>,
      < 5.673925, -1.628155, 2.736479>,
      < 5.611377, -1.639179, 2.744609>
    }
    triangle {
      < 5.683183, -1.716277, 2.736479>,
      < 5.611377, -1.639179, 2.744609>,
      < 5.619709, -1.718488, 2.744609>
    }
    triangle {
      < 5.683268, -1.716277, 2.633340>,
      < 5.674009, -1.628143, 2.633340>,
      < 5.673925, -1.628155, 2.736479>
    }
    triangle {
      < 5.683268, -1.716277, 2.633340>,
      < 5.673925, -1.628155, 2.736479>,
      < 5.683183, -1.716277, 2.736479>
    }
    triangle {
      < 5.163112, -1.718179, 2.842164>,
      < 5.159180, -1.702418, 2.842164>,
      < 5.152584, -1.704561, 2.828054>
    }
    triangle {
      < 5.163112, -1.718179, 2.842164>,
      < 5.152584, -1.704561, 2.828054>,
      < 5.156281, -1.719384, 2.828054>
    }
    triangle {
      < 5.266318, -1.699991, 2.813766>,
      < 5.258850, -1.670043, 2.813766>,
      < 5.159180, -1.702418, 2.842164>
    }
    triangle {
      < 5.266318, -1.699991, 2.813766>,
      < 5.159180, -1.702418, 2.842164>,
      < 5.163112, -1.718179, 2.842164>
    }
    triangle {
      < 5.369524, -1.681803, 2.769109>,
      < 5.358520, -1.637669, 2.769109>,
      < 5.258850, -1.670043, 2.813766>
    }
    triangle {
      < 5.369524, -1.681803, 2.769109>,
      < 5.258850, -1.670043, 2.813766>,
      < 5.266318, -1.699991, 2.813766>
    }
    triangle {
      < 5.382032, -1.679599, 2.756803>,
      < 5.370600, -1.633745, 2.756803>,
      < 5.358520, -1.637669, 2.769109>
    }
    triangle {
      < 5.382032, -1.679599, 2.756803>,
      < 5.358520, -1.637669, 2.769109>,
      < 5.369524, -1.681803, 2.769109>
    }
    triangle {
      < 5.402882, -1.675924, 2.779159>,
      < 5.390735, -1.627204, 2.779159>,
      < 5.370600, -1.633745, 2.756803>
    }
    triangle {
      < 5.402882, -1.675924, 2.779159>,
      < 5.370600, -1.633745, 2.756803>,
      < 5.382032, -1.679599, 2.756803>
    }
    triangle {
      < 5.485167, -1.650631, 2.764932>,
      < 5.471276, -1.601043, 2.764932>,
      < 5.390735, -1.627204, 2.779159>
    }
    triangle {
      < 5.485167, -1.650631, 2.764932>,
      < 5.390735, -1.627204, 2.779159>,
      < 5.402882, -1.675924, 2.779159>
    }
    triangle {
      < 5.520771, -1.643479, 2.663333>,
      < 5.505748, -1.589848, 2.663333>,
      < 5.471276, -1.601043, 2.764932>
    }
    triangle {
      < 5.520771, -1.643479, 2.663333>,
      < 5.471276, -1.601043, 2.764932>,
      < 5.485167, -1.650631, 2.764932>
    }
    triangle {
      < 5.603704, -1.640533, 2.663332>,
      < 5.584679, -1.564210, 2.663332>,
      < 5.505748, -1.589848, 2.663333>
    }
    triangle {
      < 5.603704, -1.640533, 2.663332>,
      < 5.505748, -1.589848, 2.663333>,
      < 5.520771, -1.643479, 2.663333>
    }
    triangle {
      < 5.611377, -1.639179, 2.744609>,
      < 5.592087, -1.561801, 2.744609>,
      < 5.584679, -1.564210, 2.663332>
    }
    triangle {
      < 5.611377, -1.639179, 2.744609>,
      < 5.584679, -1.564210, 2.663332>,
      < 5.603704, -1.640533, 2.663332>
    }
    triangle {
      < 5.673925, -1.628155, 2.736479>,
      < 5.652493, -1.542180, 2.736479>,
      < 5.592087, -1.561801, 2.744609>
    }
    triangle {
      < 5.673925, -1.628155, 2.736479>,
      < 5.592087, -1.561801, 2.744609>,
      < 5.611377, -1.639179, 2.744609>
    }
    triangle {
      < 5.674009, -1.628143, 2.633340>,
      < 5.652575, -1.542156, 2.633340>,
      < 5.652493, -1.542180, 2.736479>
    }
    triangle {
      < 5.674009, -1.628143, 2.633340>,
      < 5.652493, -1.542180, 2.736479>,
      < 5.673925, -1.628155, 2.736479>
    }
    triangle {
      < 5.159180, -1.702418, 2.842164>,
      < 5.153092, -1.687357, 2.842164>,
      < 5.146858, -1.690398, 2.828054>
    }
    triangle {
      < 5.159180, -1.702418, 2.842164>,
      < 5.146858, -1.690398, 2.828054>,
      < 5.152584, -1.704561, 2.828054>
    }
    triangle {
      < 5.258850, -1.670043, 2.813766>,
      < 5.247287, -1.641426, 2.813766>,
      < 5.153092, -1.687357, 2.842164>
    }
    triangle {
      < 5.258850, -1.670043, 2.813766>,
      < 5.153092, -1.687357, 2.842164>,
      < 5.159180, -1.702418, 2.842164>
    }
    triangle {
      < 5.358520, -1.637669, 2.769109>,
      < 5.341481, -1.595496, 2.769109>,
      < 5.247287, -1.641426, 2.813766>
    }
    triangle {
      < 5.358520, -1.637669, 2.769109>,
      < 5.247287, -1.641426, 2.813766>,
      < 5.258850, -1.670043, 2.813766>
    }
    triangle {
      < 5.370600, -1.633745, 2.756803>,
      < 5.352898, -1.589929, 2.756803>,
      < 5.341481, -1.595496, 2.769109>
    }
    triangle {
      < 5.370600, -1.633745, 2.756803>,
      < 5.341481, -1.595496, 2.769109>,
      < 5.358520, -1.637669, 2.769109>
    }
    triangle {
      < 5.390735, -1.627204, 2.779159>,
      < 5.371927, -1.580650, 2.779159>,
      < 5.352898, -1.589929, 2.756803>
    }
    triangle {
      < 5.390735, -1.627204, 2.779159>,
      < 5.352898, -1.589929, 2.756803>,
      < 5.370600, -1.633745, 2.756803>
    }
    triangle {
      < 5.471276, -1.601043, 2.764932>,
      < 5.453369, -1.552760, 2.764932>,
      < 5.371927, -1.580650, 2.779159>
    }
    triangle {
      < 5.471276, -1.601043, 2.764932>,
      < 5.371927, -1.580650, 2.779159>,
      < 5.390735, -1.627204, 2.779159>
    }
    triangle {
      < 5.505748, -1.589848, 2.663333>,
      < 5.486382, -1.537629, 2.663333>,
      < 5.453369, -1.552760, 2.764932>
    }
    triangle {
      < 5.505748, -1.589848, 2.663333>,
      < 5.453369, -1.552760, 2.764932>,
      < 5.471276, -1.601043, 2.764932>
    }
    triangle {
      < 5.584679, -1.564210, 2.663332>,
      < 5.555216, -1.491277, 2.663332>,
      < 5.486382, -1.537629, 2.663333>
    }
    triangle {
      < 5.584679, -1.564210, 2.663332>,
      < 5.486382, -1.537629, 2.663333>,
      < 5.505748, -1.589848, 2.663333>
    }
    triangle {
      < 5.592087, -1.561801, 2.744609>,
      < 5.562217, -1.487860, 2.744609>,
      < 5.555216, -1.491277, 2.663332>
    }
    triangle {
      < 5.592087, -1.561801, 2.744609>,
      < 5.555216, -1.491277, 2.663332>,
      < 5.584679, -1.564210, 2.663332>
    }
    triangle {
      < 5.652493, -1.542180, 2.736479>,
      < 5.619304, -1.460024, 2.736479>,
      < 5.562217, -1.487860, 2.744609>
    }
    triangle {
      < 5.652493, -1.542180, 2.736479>,
      < 5.562217, -1.487860, 2.744609>,
      < 5.592087, -1.561801, 2.744609>
    }
    triangle {
      < 5.652575, -1.542156, 2.633340>,
      < 5.619381, -1.459989, 2.633340>,
      < 5.619304, -1.460024, 2.736479>
    }
    triangle {
      < 5.652575, -1.542156, 2.633340>,
      < 5.619304, -1.460024, 2.736479>,
      < 5.652493, -1.542180, 2.736479>
    }
    triangle {
      < 5.153092, -1.687357, 2.842164>,
      < 5.144968, -1.673290, 2.842164>,
      < 5.139218, -1.677168, 2.828054>
    }
    triangle {
      < 5.153092, -1.687357, 2.842164>,
      < 5.139218, -1.677168, 2.828054>,
      < 5.146858, -1.690398, 2.828054>
    }
    triangle {
      < 5.247287, -1.641426, 2.813766>,
      < 5.231853, -1.614697, 2.813766>,
      < 5.144968, -1.673290, 2.842164>
    }
    triangle {
      < 5.247287, -1.641426, 2.813766>,
      < 5.144968, -1.673290, 2.842164>,
      < 5.153092, -1.687357, 2.842164>
    }
    triangle {
      < 5.341481, -1.595496, 2.769109>,
      < 5.318739, -1.556105, 2.769109>,
      < 5.231853, -1.614697, 2.813766>
    }
    triangle {
      < 5.341481, -1.595496, 2.769109>,
      < 5.231853, -1.614697, 2.813766>,
      < 5.247287, -1.641426, 2.813766>
    }
    triangle {
      < 5.352898, -1.589929, 2.756803>,
      < 5.329270, -1.549003, 2.756803>,
      < 5.318739, -1.556105, 2.769109>
    }
    triangle {
      < 5.352898, -1.589929, 2.756803>,
      < 5.318739, -1.556105, 2.769109>,
      < 5.341481, -1.595496, 2.769109>
    }
    triangle {
      < 5.371927, -1.580650, 2.779159>,
      < 5.346822, -1.537166, 2.779159>,
      < 5.329270, -1.549003, 2.756803>
    }
    triangle {
      < 5.371927, -1.580650, 2.779159>,
      < 5.329270, -1.549003, 2.756803>,
      < 5.352898, -1.589929, 2.756803>
    }
    triangle {
      < 5.411706, -1.480592, 2.764932>,
      < 5.346822, -1.537166, 2.779159>,
      < 5.408729, -1.515102, 2.768997>
    }
    triangle {
      < 5.441323, -1.459577, 2.663333>,
      < 5.411706, -1.480592, 2.764932>,
      < 5.408729, -1.515102, 2.768997>
    }
    triangle {
      < 5.441323, -1.459577, 2.663333>,
      < 5.408729, -1.515102, 2.768997>,
      < 5.438103, -1.496900, 2.663333>
    }
    triangle {
      < 5.555216, -1.491277, 2.663332>,
      < 5.515889, -1.423154, 2.663332>,
      < 5.441323, -1.459577, 2.663333>
    }
    triangle {
      < 5.555216, -1.491277, 2.663332>,
      < 5.441323, -1.459577, 2.663333>,
      < 5.486382, -1.537629, 2.663333>
    }
    triangle {
      < 5.562217, -1.487860, 2.744609>,
      < 5.522347, -1.418797, 2.744609>,
      < 5.515889, -1.423154, 2.663332>
    }
    triangle {
      < 5.562217, -1.487860, 2.744609>,
      < 5.515889, -1.423154, 2.663332>,
      < 5.555216, -1.491277, 2.663332>
    }
    triangle {
      < 5.619304, -1.460024, 2.736479>,
      < 5.575005, -1.383286, 2.736479>,
      < 5.522347, -1.418797, 2.744609>
    }
    triangle {
      < 5.619304, -1.460024, 2.736479>,
      < 5.522347, -1.418797, 2.744609>,
      < 5.562217, -1.487860, 2.744609>
    }
    triangle {
      < 5.619381, -1.459989, 2.633340>,
      < 5.575077, -1.383241, 2.633340>,
      < 5.575005, -1.383286, 2.736479>
    }
    triangle {
      < 5.619381, -1.459989, 2.633340>,
      < 5.575005, -1.383286, 2.736479>,
      < 5.619304, -1.460024, 2.736479>
    }
    triangle {
      < 5.144968, -1.673290, 2.842164>,
      < 5.134965, -1.660491, 2.842164>,
      < 5.129811, -1.665132, 2.828054>
    }
    triangle {
      < 5.144968, -1.673290, 2.842164>,
      < 5.129811, -1.665132, 2.828054>,
      < 5.139218, -1.677168, 2.828054>
    }
    triangle {
      < 5.231853, -1.614697, 2.813766>,
      < 5.212851, -1.590376, 2.813766>,
      < 5.134965, -1.660491, 2.842164>
    }
    triangle {
      < 5.231853, -1.614697, 2.813766>,
      < 5.134965, -1.660491, 2.842164>,
      < 5.144968, -1.673290, 2.842164>
    }
    triangle {
      < 5.318739, -1.556105, 2.769109>,
      < 5.290737, -1.520262, 2.769109>,
      < 5.212851, -1.590376, 2.813766>
    }
    triangle {
      < 5.318739, -1.556105, 2.769109>,
      < 5.212851, -1.590376, 2.813766>,
      < 5.231853, -1.614697, 2.813766>
    }
    triangle {
      < 5.329270, -1.549003, 2.756803>,
      < 5.300177, -1.511764, 2.756803>,
      < 5.290737, -1.520262, 2.769109>
    }
    triangle {
      < 5.329270, -1.549003, 2.756803>,
      < 5.290737, -1.520262, 2.769109>,
      < 5.318739, -1.556105, 2.769109>
    }
    triangle {
      < 5.346822, -1.537166, 2.779159>,
      < 5.315910, -1.497599, 2.779159>,
      < 5.300177, -1.511764, 2.756803>
    }
    triangle {
      < 5.346822, -1.537166, 2.779159>,
      < 5.300177, -1.511764, 2.756803>,
      < 5.329270, -1.549003, 2.756803>
    }
    triangle {
      < 5.411706, -1.480592, 2.764932>,
      < 5.378848, -1.440941, 2.764932>,
      < 5.315910, -1.497599, 2.779159>
    }
    triangle {
      < 5.411706, -1.480592, 2.764932>,
      < 5.315910, -1.497599, 2.779159>,
      < 5.346822, -1.537166, 2.779159>
    }
    triangle {
      < 5.441323, -1.459577, 2.663333>,
      < 5.405787, -1.416693, 2.663333>,
      < 5.378848, -1.440941, 2.764932>
    }
    triangle {
      < 5.441323, -1.459577, 2.663333>,
      < 5.378848, -1.440941, 2.764932>,
      < 5.411706, -1.480592, 2.764932>
    }
    triangle {
      < 5.515889, -1.423154, 2.663332>,
      < 5.467465, -1.361168, 2.663332>,
      < 5.405787, -1.416693, 2.663333>
    }
    triangle {
      < 5.515889, -1.423154, 2.663332>,
      < 5.405787, -1.416693, 2.663333>,
      < 5.441323, -1.459577, 2.663333>
    }
    triangle {
      < 5.522347, -1.418797, 2.744609>,
      < 5.473254, -1.355954, 2.744609>,
      < 5.467465, -1.361168, 2.663332>
    }
    triangle {
      < 5.522347, -1.418797, 2.744609>,
      < 5.467465, -1.361168, 2.663332>,
      < 5.515889, -1.423154, 2.663332>
    }
    triangle {
      < 5.575005, -1.383286, 2.736479>,
      < 5.520457, -1.313460, 2.736479>,
      < 5.473254, -1.355954, 2.744609>
    }
    triangle {
      < 5.575005, -1.383286, 2.736479>,
      < 5.473254, -1.355954, 2.744609>,
      < 5.522347, -1.418797, 2.744609>
    }
    triangle {
      < 5.575077, -1.383241, 2.633340>,
      < 5.520522, -1.313405, 2.633340>,
      < 5.520457, -1.313460, 2.736479>
    }
    triangle {
      < 5.575077, -1.383241, 2.633340>,
      < 5.520457, -1.313460, 2.736479>,
      < 5.575005, -1.383286, 2.736479>
    }
    triangle {
      < 5.134965, -1.660491, 2.842164>,
      < 5.123278, -1.649208, 2.842164>,
      < 5.118820, -1.654521, 2.828054>
    }
    triangle {
      < 5.134965, -1.660491, 2.842164>,
      < 5.118820, -1.654521, 2.828054>,
      < 5.129811, -1.665132, 2.828054>
    }
    triangle {
      < 5.212851, -1.590376, 2.813766>,
      < 5.190648, -1.568936, 2.813766>,
      < 5.123278, -1.649208, 2.842164>
    }
    triangle {
      < 5.212851, -1.590376, 2.813766>,
      < 5.123278, -1.649208, 2.842164>,
      < 5.134965, -1.660491, 2.842164>
    }
    triangle {
      < 5.290737, -1.520262, 2.769109>,
      < 5.258018, -1.488665, 2.769109>,
      < 5.190648, -1.568936, 2.813766>
    }
    triangle {
      < 5.290737, -1.520262, 2.769109>,
      < 5.190648, -1.568936, 2.813766>,
      < 5.212851, -1.590376, 2.813766>
    }
    triangle {
      < 5.300177, -1.511764, 2.756803>,
      < 5.266183, -1.478936, 2.756803>,
      < 5.258018, -1.488665, 2.769109>
    }
    triangle {
      < 5.300177, -1.511764, 2.756803>,
      < 5.258018, -1.488665, 2.769109>,
      < 5.290737, -1.520262, 2.769109>
    }
    triangle {
      < 5.315910, -1.497599, 2.779159>,
      < 5.279793, -1.462719, 2.779159>,
      < 5.266183, -1.478936, 2.756803>
    }
    triangle {
      < 5.315910, -1.497599, 2.779159>,
      < 5.266183, -1.478936, 2.756803>,
      < 5.300177, -1.511764, 2.756803>
    }
    triangle {
      < 5.378848, -1.440941, 2.764932>,
      < 5.342851, -1.404115, 2.764932>,
      < 5.279793, -1.462719, 2.779159>
    }
    triangle {
      < 5.378848, -1.440941, 2.764932>,
      < 5.279793, -1.462719, 2.779159>,
      < 5.315910, -1.497599, 2.779159>
    }
    triangle {
      < 5.405787, -1.416693, 2.663333>,
      < 5.366855, -1.376865, 2.663333>,
      < 5.342851, -1.404115, 2.764932>
    }
    triangle {
      < 5.405787, -1.416693, 2.663333>,
      < 5.342851, -1.404115, 2.764932>,
      < 5.378848, -1.440941, 2.764932>
    }
    triangle {
      < 5.467465, -1.361168, 2.663332>,
      < 5.410885, -1.306524, 2.663332>,
      < 5.366855, -1.376865, 2.663333>
    }
    triangle {
      < 5.467465, -1.361168, 2.663332>,
      < 5.366855, -1.376865, 2.663333>,
      < 5.405787, -1.416693, 2.663333>
    }
    triangle {
      < 5.473254, -1.355954, 2.744609>,
      < 5.415892, -1.300555, 2.744609>,
      < 5.410885, -1.306524, 2.663332>
    }
    triangle {
      < 5.473254, -1.355954, 2.744609>,
      < 5.410885, -1.306524, 2.663332>,
      < 5.467465, -1.361168, 2.663332>
    }
    triangle {
      < 5.520457, -1.313460, 2.736479>,
      < 5.456722, -1.251905, 2.736479>,
      < 5.415892, -1.300555, 2.744609>
    }
    triangle {
      < 5.520457, -1.313460, 2.736479>,
      < 5.415892, -1.300555, 2.744609>,
      < 5.473254, -1.355954, 2.744609>
    }
    triangle {
      < 5.520522, -1.313405, 2.633340>,
      < 5.456779, -1.251842, 2.633340>,
      < 5.456722, -1.251905, 2.736479>
    }
    triangle {
      < 5.520522, -1.313405, 2.633340>,
      < 5.456722, -1.251905, 2.736479>,
      < 5.520457, -1.313460, 2.736479>
    }
    triangle {
      < 5.123278, -1.649208, 2.842164>,
      < 5.110135, -1.639661, 2.842164>,
      < 5.106459, -1.645543, 2.828054>
    }
    triangle {
      < 5.123278, -1.649208, 2.842164>,
      < 5.106459, -1.645543, 2.828054>,
      < 5.118820, -1.654521, 2.828054>
    }
    triangle {
      < 5.190648, -1.568936, 2.813766>,
      < 5.165678, -1.550795, 2.813766>,
      < 5.110135, -1.639661, 2.842164>
    }
    triangle {
      < 5.190648, -1.568936, 2.813766>,
      < 5.110135, -1.639661, 2.842164>,
      < 5.123278, -1.649208, 2.842164>
    }
    triangle {
      < 5.258018, -1.488665, 2.769109>,
      < 5.221220, -1.461929, 2.769109>,
      < 5.165678, -1.550795, 2.813766>
    }
    triangle {
      < 5.258018, -1.488665, 2.769109>,
      < 5.165678, -1.550795, 2.813766>,
      < 5.190648, -1.568936, 2.813766>
    }
    triangle {
      < 5.266183, -1.478936, 2.756803>,
      < 5.227952, -1.451158, 2.756803>,
      < 5.221220, -1.461929, 2.769109>
    }
    triangle {
      < 5.266183, -1.478936, 2.756803>,
      < 5.221220, -1.461929, 2.769109>,
      < 5.258018, -1.488665, 2.769109>
    }
    triangle {
      < 5.279793, -1.462719, 2.779159>,
      < 5.239172, -1.433205, 2.779159>,
      < 5.227952, -1.451158, 2.756803>
    }
    triangle {
      < 5.279793, -1.462719, 2.779159>,
      < 5.227952, -1.451158, 2.756803>,
      < 5.266183, -1.478936, 2.756803>
    }
    triangle {
      < 5.275437, -1.355132, 2.764932>,
      < 5.239172, -1.433205, 2.779159>,
      < 5.286753, -1.387869, 2.768997>
    }
    triangle {
      < 5.293946, -1.323888, 2.663333>,
      < 5.275437, -1.355132, 2.764932>,
      < 5.286753, -1.387869, 2.768997>
    }
    triangle {
      < 5.293946, -1.323888, 2.663333>,
      < 5.286753, -1.387869, 2.768997>,
      < 5.306184, -1.359294, 2.663333>
    }
    triangle {
      < 5.410885, -1.306524, 2.663332>,
      < 5.347251, -1.260285, 2.663332>,
      < 5.293946, -1.323888, 2.663333>
    }
    triangle {
      < 5.410885, -1.306524, 2.663332>,
      < 5.293946, -1.323888, 2.663333>,
      < 5.366855, -1.376865, 2.663333>
    }
    triangle {
      < 5.415892, -1.300555, 2.744609>,
      < 5.351379, -1.253678, 2.744609>,
      < 5.347251, -1.260285, 2.663332>
    }
    triangle {
      < 5.415892, -1.300555, 2.744609>,
      < 5.347251, -1.260285, 2.663332>,
      < 5.410885, -1.306524, 2.663332>
    }
    triangle {
      < 5.456722, -1.251905, 2.736479>,
      < 5.385041, -1.199819, 2.736479>,
      < 5.351379, -1.253678, 2.744609>
    }
    triangle {
      < 5.456722, -1.251905, 2.736479>,
      < 5.351379, -1.253678, 2.744609>,
      < 5.415892, -1.300555, 2.744609>
    }
    triangle {
      < 5.456779, -1.251842, 2.633340>,
      < 5.385088, -1.199749, 2.633340>,
      < 5.385041, -1.199819, 2.736479>
    }
    triangle {
      < 5.456779, -1.251842, 2.633340>,
      < 5.385041, -1.199819, 2.736479>,
      < 5.456722, -1.251905, 2.736479>
    }
    triangle {
      < 5.110135, -1.639661, 2.842164>,
      < 5.095791, -1.632037, 2.842164>,
      < 5.092969, -1.638373, 2.828054>
    }
    triangle {
      < 5.110135, -1.639661, 2.842164>,
      < 5.092969, -1.638373, 2.828054>,
      < 5.106459, -1.645543, 2.828054>
    }
    triangle {
      < 5.165678, -1.550795, 2.813766>,
      < 5.138425, -1.536305, 2.813766>,
      < 5.095791, -1.632037, 2.842164>
    }
    triangle {
      < 5.165678, -1.550795, 2.813766>,
      < 5.095791, -1.632037, 2.842164>,
      < 5.110135, -1.639661, 2.842164>
    }
    triangle {
      < 5.221220, -1.461929, 2.769109>,
      < 5.181060, -1.440574, 2.769109>,
      < 5.138425, -1.536305, 2.813766>
    }
    triangle {
      < 5.221220, -1.461929, 2.769109>,
      < 5.138425, -1.536305, 2.813766>,
      < 5.165678, -1.550795, 2.813766>
    }
    triangle {
      < 5.227952, -1.451158, 2.756803>,
      < 5.186228, -1.428972, 2.756803>,
      < 5.181060, -1.440574, 2.769109>
    }
    triangle {
      < 5.227952, -1.451158, 2.756803>,
      < 5.181060, -1.440574, 2.769109>,
      < 5.221220, -1.461929, 2.769109>
    }
    triangle {
      < 5.239172, -1.433205, 2.779159>,
      < 5.194840, -1.409632, 2.779159>,
      < 5.186228, -1.428972, 2.756803>
    }
    triangle {
      < 5.239172, -1.433205, 2.779159>,
      < 5.186228, -1.428972, 2.756803>,
      < 5.227952, -1.451158, 2.756803>
    }
    triangle {
      < 5.275437, -1.355132, 2.764932>,
      < 5.229292, -1.332273, 2.764932>,
      < 5.194840, -1.409632, 2.779159>
    }
    triangle {
      < 5.275437, -1.355132, 2.764932>,
      < 5.194840, -1.409632, 2.779159>,
      < 5.239172, -1.433205, 2.779159>
    }
    triangle {
      < 5.293946, -1.323888, 2.663333>,
      < 5.244040, -1.299165, 2.663333>,
      < 5.229292, -1.332273, 2.764932>
    }
    triangle {
      < 5.293946, -1.323888, 2.663333>,
      < 5.229292, -1.332273, 2.764932>,
      < 5.275437, -1.355132, 2.764932>
    }
    triangle {
      < 5.347251, -1.260285, 2.663332>,
      < 5.277802, -1.223353, 2.663332>,
      < 5.244040, -1.299165, 2.663333>
    }
    triangle {
      < 5.347251, -1.260285, 2.663332>,
      < 5.244040, -1.299165, 2.663333>,
      < 5.293946, -1.323888, 2.663333>
    }
    triangle {
      < 5.351379, -1.253678, 2.744609>,
      < 5.280969, -1.216235, 2.744609>,
      < 5.277802, -1.223353, 2.663332>
    }
    triangle {
      < 5.351379, -1.253678, 2.744609>,
      < 5.277802, -1.223353, 2.663332>,
      < 5.347251, -1.260285, 2.663332>
    }
    triangle {
      < 5.385041, -1.199819, 2.736479>,
      < 5.306808, -1.158216, 2.736479>,
      < 5.280969, -1.216235, 2.744609>
    }
    triangle {
      < 5.385041, -1.199819, 2.736479>,
      < 5.280969, -1.216235, 2.744609>,
      < 5.351379, -1.253678, 2.744609>
    }
    triangle {
      < 5.385088, -1.199749, 2.633340>,
      < 5.306845, -1.158140, 2.633340>,
      < 5.306808, -1.158216, 2.736479>
    }
    triangle {
      < 5.385088, -1.199749, 2.633340>,
      < 5.306808, -1.158216, 2.736479>,
      < 5.385041, -1.199819, 2.736479>
    }
    triangle {
      < 5.095791, -1.632037, 2.842164>,
      < 5.080525, -1.626483, 2.842164>,
      < 5.078613, -1.633150, 2.828054>
    }
    triangle {
      < 5.095791, -1.632037, 2.842164>,
      < 5.078613, -1.633150, 2.828054>,
      < 5.092969, -1.638373, 2.828054>
    }
    triangle {
      < 5.138425, -1.536305, 2.813766>,
      < 5.109422, -1.525750, 2.813766>,
      < 5.080525, -1.626483, 2.842164>
    }
    triangle {
      < 5.138425, -1.536305, 2.813766>,
      < 5.080525, -1.626483, 2.842164>,
      < 5.095791, -1.632037, 2.842164>
    }
    triangle {
      < 5.181060, -1.440574, 2.769109>,
      < 5.138319, -1.425017, 2.769109>,
      < 5.109422, -1.525750, 2.813766>
    }
    triangle {
      < 5.181060, -1.440574, 2.769109>,
      < 5.109422, -1.525750, 2.813766>,
      < 5.138425, -1.536305, 2.813766>
    }
    triangle {
      < 5.186228, -1.428972, 2.756803>,
      < 5.141821, -1.412808, 2.756803>,
      < 5.138319, -1.425017, 2.769109>
    }
    triangle {
      < 5.186228, -1.428972, 2.756803>,
      < 5.138319, -1.425017, 2.769109>,
      < 5.181060, -1.440574, 2.769109>
    }
    triangle {
      < 5.194840, -1.409632, 2.779159>,
      < 5.147658, -1.392457, 2.779159>,
      < 5.141821, -1.412808, 2.756803>
    }
    triangle {
      < 5.194840, -1.409632, 2.779159>,
      < 5.141821, -1.412808, 2.756803>,
      < 5.186228, -1.428972, 2.756803>
    }
    triangle {
      < 5.229292, -1.332273, 2.764932>,
      < 5.181429, -1.313272, 2.764932>,
      < 5.147658, -1.392457, 2.779159>
    }
    triangle {
      < 5.229292, -1.332273, 2.764932>,
      < 5.147658, -1.392457, 2.779159>,
      < 5.194840, -1.409632, 2.779159>
    }
    triangle {
      < 5.244040, -1.299165, 2.663333>,
      < 5.192275, -1.278614, 2.663333>,
      < 5.181429, -1.313272, 2.764932>
    }
    triangle {
      < 5.244040, -1.299165, 2.663333>,
      < 5.181429, -1.313272, 2.764932>,
      < 5.229292, -1.332273, 2.764932>
    }
    triangle {
      < 5.277802, -1.223353, 2.663332>,
      < 5.203888, -1.196446, 2.663332>,
      < 5.192275, -1.278614, 2.663333>
    }
    triangle {
      < 5.277802, -1.223353, 2.663332>,
      < 5.192275, -1.278614, 2.663333>,
      < 5.244040, -1.299165, 2.663333>
    }
    triangle {
      < 5.280969, -1.216235, 2.744609>,
      < 5.206034, -1.188956, 2.744609>,
      < 5.203888, -1.196446, 2.663332>
    }
    triangle {
      < 5.280969, -1.216235, 2.744609>,
      < 5.203888, -1.196446, 2.663332>,
      < 5.277802, -1.223353, 2.663332>
    }
    triangle {
      < 5.306808, -1.158216, 2.736479>,
      < 5.223547, -1.127906, 2.736479>,
      < 5.206034, -1.188956, 2.744609>
    }
    triangle {
      < 5.306808, -1.158216, 2.736479>,
      < 5.206034, -1.188956, 2.744609>,
      < 5.280969, -1.216235, 2.744609>
    }
    triangle {
      < 5.306845, -1.158140, 2.633340>,
      < 5.223573, -1.127825, 2.633340>,
      < 5.223547, -1.127906, 2.736479>
    }
    triangle {
      < 5.306845, -1.158140, 2.633340>,
      < 5.223547, -1.127906, 2.736479>,
      < 5.306808, -1.158216, 2.736479>
    }
    triangle {
      < 5.080525, -1.626483, 2.842164>,
      < 5.064635, -1.623108, 2.842164>,
      < 5.063670, -1.629976, 2.828054>
    }
    triangle {
      < 5.080525, -1.626483, 2.842164>,
      < 5.063670, -1.629976, 2.828054>,
      < 5.078613, -1.633150, 2.828054>
    }
    triangle {
      < 5.109422, -1.525750, 2.813766>,
      < 5.079231, -1.519333, 2.813766>,
      < 5.064635, -1.623108, 2.842164>
    }
    triangle {
      < 5.109422, -1.525750, 2.813766>,
      < 5.064635, -1.623108, 2.842164>,
      < 5.080525, -1.626483, 2.842164>
    }
    triangle {
      < 5.138319, -1.425017, 2.769109>,
      < 5.093828, -1.415559, 2.769109>,
      < 5.079231, -1.519333, 2.813766>
    }
    triangle {
      < 5.138319, -1.425017, 2.769109>,
      < 5.079231, -1.519333, 2.813766>,
      < 5.109422, -1.525750, 2.813766>
    }
    triangle {
      < 5.141821, -1.412808, 2.756803>,
      < 5.095597, -1.402981, 2.756803>,
      < 5.093828, -1.415559, 2.769109>
    }
    triangle {
      < 5.141821, -1.412808, 2.756803>,
      < 5.093828, -1.415559, 2.769109>,
      < 5.138319, -1.425017, 2.769109>
    }
    triangle {
      < 5.147658, -1.392457, 2.779159>,
      < 5.098545, -1.382016, 2.779159>,
      < 5.095597, -1.402981, 2.756803>
    }
    triangle {
      < 5.147658, -1.392457, 2.779159>,
      < 5.095597, -1.402981, 2.756803>,
      < 5.141821, -1.412808, 2.756803>
    }
    triangle {
      < 5.099920, -1.295943, 2.764932>,
      < 5.098545, -1.382016, 2.779159>,
      < 5.123573, -1.321247, 2.768997>
    }
    triangle {
      < 5.104121, -1.259872, 2.663333>,
      < 5.099920, -1.295943, 2.764932>,
      < 5.123573, -1.321247, 2.768997>
    }
    triangle {
      < 5.104121, -1.259872, 2.663333>,
      < 5.123573, -1.321247, 2.768997>,
      < 5.129702, -1.287239, 2.663333>
    }
    triangle {
      < 5.203888, -1.196446, 2.663332>,
      < 5.126949, -1.180087, 2.663332>,
      < 5.104121, -1.259872, 2.663333>
    }
    triangle {
      < 5.203888, -1.196446, 2.663332>,
      < 5.104121, -1.259872, 2.663333>,
      < 5.192275, -1.278614, 2.663333>
    }
    triangle {
      < 5.206034, -1.188956, 2.744609>,
      < 5.128032, -1.172372, 2.744609>,
      < 5.126949, -1.180087, 2.663332>
    }
    triangle {
      < 5.206034, -1.188956, 2.744609>,
      < 5.126949, -1.180087, 2.663332>,
      < 5.203888, -1.196446, 2.663332>
    }
    triangle {
      < 5.223547, -1.127906, 2.736479>,
      < 5.136878, -1.109478, 2.736479>,
      < 5.128032, -1.172372, 2.744609>
    }
    triangle {
      < 5.223547, -1.127906, 2.736479>,
      < 5.128032, -1.172372, 2.744609>,
      < 5.206034, -1.188956, 2.744609>
    }
    triangle {
      < 5.223573, -1.127825, 2.633340>,
      < 5.136892, -1.109395, 2.633340>,
      < 5.136878, -1.109478, 2.736479>
    }
    triangle {
      < 5.223573, -1.127825, 2.633340>,
      < 5.136878, -1.109478, 2.736479>,
      < 5.223547, -1.127906, 2.736479>
    }
    triangle {
      < 5.064635, -1.623108, 2.842164>,
      < 5.048418, -1.628912, 2.828054>,
      < 5.063670, -1.629976, 2.828054>
    }
    triangle {
      < 5.079231, -1.519333, 2.813766>,
      < 5.062479, -1.518167, 2.813766>,
      < 5.064635, -1.623108, 2.842164>
    }
    triangle {
      < 5.079231, -1.519333, 2.813766>,
      < 5.093828, -1.415559, 2.769109>,
      < 5.055798, -1.413064, 2.769109>
    }
    triangle {
      < 5.079231, -1.519333, 2.813766>,
      < 5.055798, -1.413064, 2.769109>,
      < 5.062479, -1.518167, 2.813766>
    }
    triangle {
      < 5.093828, -1.415559, 2.769109>,
      < 5.095597, -1.402981, 2.756803>,
      < 5.048420, -1.399683, 2.756803>
    }
    triangle {
      < 5.093828, -1.415559, 2.769109>,
      < 5.048420, -1.399683, 2.756803>,
      < 5.055798, -1.413064, 2.769109>
    }
    triangle {
      < 5.098545, -1.382016, 2.779159>,
      < 5.048419, -1.378512, 2.779159>,
      < 5.048420, -1.399683, 2.756803>
    }
    triangle {
      < 5.098545, -1.382016, 2.779159>,
      < 5.048420, -1.399683, 2.756803>,
      < 5.095597, -1.402981, 2.756803>
    }
    triangle {
      < 5.099920, -1.295943, 2.764932>,
      < 5.048420, -1.293829, 2.764932>,
      < 5.048419, -1.378512, 2.779159>
    }
    triangle {
      < 5.099920, -1.295943, 2.764932>,
      < 5.048419, -1.378512, 2.779159>,
      < 5.098545, -1.382016, 2.779159>
    }
    triangle {
      < 5.104121, -1.259872, 2.663333>,
      < 5.048422, -1.257585, 2.663333>,
      < 5.048420, -1.293829, 2.764932>
    }
    triangle {
      < 5.104121, -1.259872, 2.663333>,
      < 5.048420, -1.293829, 2.764932>,
      < 5.099920, -1.295943, 2.764932>
    }
    triangle {
      < 5.126949, -1.180087, 2.663332>,
      < 5.048422, -1.174595, 2.663332>,
      < 5.048422, -1.257585, 2.663333>
    }
    triangle {
      < 5.126949, -1.180087, 2.663332>,
      < 5.048422, -1.257585, 2.663333>,
      < 5.104121, -1.259872, 2.663333>
    }
    triangle {
      < 5.128032, -1.172372, 2.744609>,
      < 5.048420, -1.166804, 2.744609>,
      < 5.048422, -1.174595, 2.663332>
    }
    triangle {
      < 5.128032, -1.172372, 2.744609>,
      < 5.048422, -1.174595, 2.663332>,
      < 5.126949, -1.180087, 2.663332>
    }
    triangle {
      < 5.136878, -1.109478, 2.736479>,
      < 5.048420, -1.103292, 2.736479>,
      < 5.048420, -1.166804, 2.744609>
    }
    triangle {
      < 5.136878, -1.109478, 2.736479>,
      < 5.048420, -1.166804, 2.744609>,
      < 5.128032, -1.172372, 2.744609>
    }
    triangle {
      < 5.136892, -1.109395, 2.633340>,
      < 5.048423, -1.103207, 2.633340>,
      < 5.048420, -1.103292, 2.736479>
    }
    triangle {
      < 5.136892, -1.109395, 2.633340>,
      < 5.048420, -1.103292, 2.736479>,
      < 5.136878, -1.109478, 2.736479>
    }
    triangle {
      < 5.055798, -1.413064, 2.769109>,
      < 5.048420, -1.399683, 2.756803>,
      < 5.048419, -1.514298, 2.792428>
    }
    triangle {
      < 5.055798, -1.413064, 2.769109>,
      < 5.048419, -1.514298, 2.792428>,
      < 5.062479, -1.518167, 2.813766>
    }
    triangle {
      < 5.341797, -1.907782, 2.756803>,
      < 5.333894, -1.894709, 2.769109>,
      < 5.246215, -1.836364, 2.813766>
    }
    triangle {
      < 5.341797, -1.907782, 2.756803>,
      < 5.246215, -1.836364, 2.813766>,
      < 5.242542, -1.850467, 2.792428>
    }
    triangle {
      < 5.326525, -1.907472, 2.769109>,
      < 5.341797, -1.907782, 2.756803>,
      < 5.242542, -1.850467, 2.792428>
    }
    triangle {
      < 5.326525, -1.907472, 2.769109>,
      < 5.242542, -1.850467, 2.792428>,
      < 5.232167, -1.860699, 2.813766>
    }
    triangle {
      < 4.763003, -1.894722, 2.769109>,
      < 4.755100, -1.907794, 2.756803>,
      < 4.854362, -1.850491, 2.792428>
    }
    triangle {
      < 4.763003, -1.894722, 2.769109>,
      < 4.854362, -1.850491, 2.792428>,
      < 4.850687, -1.836390, 2.813766>
    }
    triangle {
      < 5.001278, -1.402983, 2.756803>,
      < 5.003046, -1.415561, 2.769109>,
      < 5.041050, -1.413064, 2.769109>
    }
    triangle {
      < 5.001278, -1.402983, 2.756803>,
      < 5.041050, -1.413064, 2.769109>,
      < 5.048420, -1.399683, 2.756803>
    }
    triangle {
      < 4.755100, -1.907794, 2.756803>,
      < 4.770373, -1.907486, 2.769109>,
      < 4.864738, -1.860723, 2.813766>
    }
    triangle {
      < 4.755100, -1.907794, 2.756803>,
      < 4.864738, -1.860723, 2.813766>,
      < 4.854362, -1.850491, 2.792428>
    }
    triangle {
      < 5.048418, -1.628912, 2.828054>,
      < 5.064635, -1.623108, 2.842164>,
      < 5.062479, -1.518167, 2.813766>
    }
    triangle {
      < 5.048418, -1.628912, 2.828054>,
      < 5.062479, -1.518167, 2.813766>,
      < 5.048419, -1.514298, 2.792428>
    }
    triangle {
      < 5.032213, -1.623114, 2.842164>,
      < 5.048418, -1.628912, 2.828054>,
      < 5.048419, -1.514298, 2.792428>
    }
    triangle {
      < 5.032213, -1.623114, 2.842164>,
      < 5.048419, -1.514298, 2.792428>,
      < 5.034369, -1.518169, 2.813766>
    }
    triangle {
      < 4.953623, -1.793188, 2.828054>,
      < 4.940493, -1.782057, 2.842164>,
      < 4.850687, -1.836390, 2.813766>
    }
    triangle {
      < 4.953623, -1.793188, 2.828054>,
      < 4.850687, -1.836390, 2.813766>,
      < 4.854362, -1.850491, 2.792428>
    }
    triangle {
      < 4.956703, -1.810121, 2.842164>,
      < 4.953623, -1.793188, 2.828054>,
      < 4.854362, -1.850491, 2.792428>
    }
    triangle {
      < 4.956703, -1.810121, 2.842164>,
      < 4.854362, -1.850491, 2.792428>,
      < 4.864738, -1.860723, 2.813766>
    }
    triangle {
      < 5.143287, -1.793151, 2.828054>,
      < 5.140212, -1.810088, 2.842164>,
      < 5.232167, -1.860699, 2.813766>
    }
    triangle {
      < 5.143287, -1.793151, 2.828054>,
      < 5.232167, -1.860699, 2.813766>,
      < 5.242542, -1.850467, 2.792428>
    }
    triangle {
      < 5.156413, -1.782018, 2.842164>,
      < 5.143287, -1.793151, 2.828054>,
      < 5.242542, -1.850467, 2.792428>
    }
    triangle {
      < 5.156413, -1.782018, 2.842164>,
      < 5.242542, -1.850467, 2.792428>,
      < 5.246215, -1.836364, 2.813766>
    }
    triangle {
      < 5.147658, -1.392457, 2.779159>,
      < 5.149528, -1.326766, 2.768997>,
      < 5.123573, -1.321247, 2.768997>
    }
    triangle {
      < 5.147658, -1.392457, 2.779159>,
      < 5.123573, -1.321247, 2.768997>,
      < 5.098545, -1.382016, 2.779159>
    }
    triangle {
      < 5.181429, -1.313272, 2.764932>,
      < 5.149528, -1.326766, 2.768997>,
      < 5.147658, -1.392457, 2.779159>
    }
    triangle {
      < 5.149528, -1.326766, 2.768997>,
      < 5.157773, -1.293207, 2.663333>,
      < 5.129702, -1.287239, 2.663333>
    }
    triangle {
      < 5.149528, -1.326766, 2.768997>,
      < 5.129702, -1.287239, 2.663333>,
      < 5.123573, -1.321247, 2.768997>
    }
    triangle {
      < 5.181429, -1.313272, 2.764932>,
      < 5.192275, -1.278614, 2.663333>,
      < 5.157773, -1.293207, 2.663333>
    }
    triangle {
      < 5.181429, -1.313272, 2.764932>,
      < 5.157773, -1.293207, 2.663333>,
      < 5.149528, -1.326766, 2.768997>
    }
    triangle {
      < 5.342851, -1.404115, 2.764932>,
      < 5.366855, -1.376865, 2.663333>,
      < 5.329401, -1.376163, 2.663333>
    }
    triangle {
      < 5.342851, -1.404115, 2.764932>,
      < 5.329401, -1.376163, 2.663333>,
      < 5.308219, -1.403467, 2.768997>
    }
    triangle {
      < 5.308219, -1.403467, 2.768997>,
      < 5.329401, -1.376163, 2.663333>,
      < 5.306184, -1.359294, 2.663333>
    }
    triangle {
      < 5.308219, -1.403467, 2.768997>,
      < 5.306184, -1.359294, 2.663333>,
      < 5.286753, -1.387869, 2.768997>
    }
    triangle {
      < 5.279793, -1.462719, 2.779159>,
      < 5.308219, -1.403467, 2.768997>,
      < 5.286753, -1.387869, 2.768997>
    }
    triangle {
      < 5.279793, -1.462719, 2.779159>,
      < 5.286753, -1.387869, 2.768997>,
      < 5.239172, -1.433205, 2.779159>
    }
    triangle {
      < 5.342851, -1.404115, 2.764932>,
      < 5.308219, -1.403467, 2.768997>,
      < 5.279793, -1.462719, 2.779159>
    }
    triangle {
      < 5.371927, -1.580650, 2.779159>,
      < 5.421995, -1.538082, 2.768997>,
      < 5.408729, -1.515102, 2.768997>
    }
    triangle {
      < 5.371927, -1.580650, 2.779159>,
      < 5.408729, -1.515102, 2.768997>,
      < 5.346822, -1.537166, 2.779159>
    }
    triangle {
      < 5.453369, -1.552760, 2.764932>,
      < 5.421995, -1.538082, 2.768997>,
      < 5.371927, -1.580650, 2.779159>
    }
    triangle {
      < 5.421995, -1.538082, 2.768997>,
      < 5.452451, -1.521754, 2.663333>,
      < 5.438103, -1.496900, 2.663333>
    }
    triangle {
      < 5.421995, -1.538082, 2.768997>,
      < 5.438103, -1.496900, 2.663333>,
      < 5.408729, -1.515102, 2.768997>
    }
    triangle {
      < 5.453369, -1.552760, 2.764932>,
      < 5.486382, -1.537629, 2.663333>,
      < 5.452451, -1.521754, 2.663333>
    }
    triangle {
      < 5.453369, -1.552760, 2.764932>,
      < 5.452451, -1.521754, 2.663333>,
      < 5.421995, -1.538082, 2.768997>
    }
    triangle {
      < 5.493875, -1.733505, 2.764932>,
      < 5.530188, -1.733109, 2.663333>,
      < 5.505647, -1.704806, 2.663333>
    }
    triangle {
      < 5.493875, -1.733505, 2.764932>,
      < 5.505647, -1.704806, 2.663333>,
      < 5.471183, -1.707335, 2.768997>
    }
    triangle {
      < 5.471183, -1.707335, 2.768997>,
      < 5.505647, -1.704806, 2.663333>,
      < 5.502648, -1.676265, 2.663333>
    }
    triangle {
      < 5.471183, -1.707335, 2.768997>,
      < 5.502648, -1.676265, 2.663333>,
      < 5.468410, -1.680946, 2.768997>
    }
    triangle {
      < 5.493875, -1.733505, 2.764932>,
      < 5.471183, -1.707335, 2.768997>,
      < 5.408130, -1.725859, 2.779159>
    }
    triangle {
      < 5.408130, -1.725859, 2.779159>,
      < 5.471183, -1.707335, 2.768997>,
      < 5.468410, -1.680946, 2.768997>
    }
    triangle {
      < 5.408130, -1.725859, 2.779159>,
      < 5.468410, -1.680946, 2.768997>,
      < 5.402882, -1.675924, 2.779159>
    }
    triangle {
      < 5.382142, -1.873239, 2.779159>,
      < 5.447278, -1.881963, 2.768997>,
      < 5.455479, -1.856727, 2.768997>
    }
    triangle {
      < 5.382142, -1.873239, 2.779159>,
      < 5.455479, -1.856727, 2.768997>,
      < 5.397657, -1.825486, 2.779159>
    }
    triangle {
      < 5.457364, -1.915100, 2.764932>,
      < 5.447278, -1.881963, 2.768997>,
      < 5.382142, -1.873239, 2.779159>
    }
    triangle {
      < 5.447278, -1.881963, 2.768997>,
      < 5.479791, -1.893670, 2.663333>,
      < 5.488660, -1.866377, 2.663333>
    }
    triangle {
      < 5.447278, -1.881963, 2.768997>,
      < 5.488660, -1.866377, 2.663333>,
      < 5.455479, -1.856727, 2.768997>
    }
    triangle {
      < 5.457364, -1.915100, 2.764932>,
      < 5.490699, -1.929508, 2.663333>,
      < 5.479791, -1.893670, 2.663333>
    }
    triangle {
      < 5.457364, -1.915100, 2.764932>,
      < 5.479791, -1.893670, 2.663333>,
      < 5.447278, -1.881963, 2.768997>
    }
    triangle {
      < 5.350150, -2.066145, 2.764932>,
      < 5.354414, -2.031771, 2.768997>,
      < 5.298456, -1.997308, 2.779159>
    }
    triangle {
      < 5.298456, -1.997308, 2.779159>,
      < 5.354414, -2.031771, 2.768997>,
      < 5.372169, -2.012052, 2.768997>
    }
    triangle {
      < 5.298456, -1.997308, 2.779159>,
      < 5.372169, -2.012052, 2.768997>,
      < 5.332053, -1.959994, 2.779159>
    }
    triangle {
      < 5.354414, -2.031771, 2.768997>,
      < 5.379354, -2.055689, 2.663333>,
      < 5.398557, -2.034363, 2.663333>
    }
    triangle {
      < 5.354414, -2.031771, 2.768997>,
      < 5.398557, -2.034363, 2.663333>,
      < 5.372169, -2.012052, 2.768997>
    }
    triangle {
      < 5.350150, -2.066145, 2.764932>,
      < 5.374743, -2.092865, 2.663333>,
      < 5.379354, -2.055689, 2.663333>
    }
    triangle {
      < 5.350150, -2.066145, 2.764932>,
      < 5.379354, -2.055689, 2.663333>,
      < 5.354414, -2.031771, 2.768997>
    }
    triangle {
      < 5.208646, -2.130857, 2.768997>,
      < 5.221702, -2.162851, 2.663333>,
      < 5.247919, -2.151179, 2.663333>
    }
    triangle {
      < 5.208646, -2.130857, 2.768997>,
      < 5.247919, -2.151179, 2.663333>,
      < 5.232887, -2.120064, 2.768997>
    }
    triangle {
      < 5.190770, -2.160525, 2.764932>,
      < 5.202368, -2.194938, 2.663333>,
      < 5.221702, -2.162851, 2.663333>
    }
    triangle {
      < 5.190770, -2.160525, 2.764932>,
      < 5.221702, -2.162851, 2.663333>,
      < 5.208646, -2.130857, 2.768997>
    }
    triangle {
      < 5.171543, -2.076614, 2.779159>,
      < 5.208646, -2.130857, 2.768997>,
      < 5.232887, -2.120064, 2.768997>
    }
    triangle {
      < 5.171543, -2.076614, 2.779159>,
      < 5.232887, -2.120064, 2.768997>,
      < 5.217412, -2.056191, 2.779159>
    }
    triangle {
      < 5.190770, -2.160525, 2.764932>,
      < 5.208646, -2.130857, 2.768997>,
      < 5.171543, -2.076614, 2.779159>
    }
    triangle {
      < 5.023346, -2.097444, 2.779159>,
      < 5.035179, -2.162088, 2.768997>,
      < 5.061714, -2.162088, 2.768997>
    }
    triangle {
      < 5.023346, -2.097444, 2.779159>,
      < 5.061714, -2.162088, 2.768997>,
      < 5.073556, -2.097443, 2.779159>
    }
    triangle {
      < 5.006781, -2.181921, 2.764932>,
      < 5.035179, -2.162088, 2.768997>,
      < 5.023346, -2.097444, 2.779159>
    }
    triangle {
      < 5.006781, -2.181921, 2.764932>,
      < 5.003380, -2.218076, 2.663333>,
      < 5.034093, -2.196627, 2.663333>
    }
    triangle {
      < 5.006781, -2.181921, 2.764932>,
      < 5.034093, -2.196627, 2.663333>,
      < 5.035179, -2.162088, 2.768997>
    }
    triangle {
      < 5.035179, -2.162088, 2.768997>,
      < 5.034093, -2.196627, 2.663333>,
      < 5.062791, -2.196627, 2.663333>
    }
    triangle {
      < 5.035179, -2.162088, 2.768997>,
      < 5.062791, -2.196627, 2.663333>,
      < 5.061714, -2.162088, 2.768997>
    }
    triangle {
      < 4.864006, -2.120065, 2.768997>,
      < 4.848965, -2.151177, 2.663333>,
      < 4.875182, -2.162849, 2.663333>
    }
    triangle {
      < 4.864006, -2.120065, 2.768997>,
      < 4.875182, -2.162849, 2.663333>,
      < 4.888246, -2.130858, 2.768997>
    }
    triangle {
      < 4.829997, -2.126633, 2.764932>,
      < 4.812184, -2.158279, 2.663333>,
      < 4.848965, -2.151177, 2.663333>
    }
    triangle {
      < 4.829997, -2.126633, 2.764932>,
      < 4.848965, -2.151177, 2.663333>,
      < 4.864006, -2.120065, 2.768997>
    }
    triangle {
      < 4.879488, -2.056197, 2.779159>,
      < 4.864006, -2.120065, 2.768997>,
      < 4.888246, -2.130858, 2.768997>
    }
    triangle {
      < 4.879488, -2.056197, 2.779159>,
      < 4.888246, -2.130858, 2.768997>,
      < 4.925358, -2.076618, 2.779159>
    }
    triangle {
      < 4.829997, -2.126633, 2.764932>,
      < 4.864006, -2.120065, 2.768997>,
      < 4.879488, -2.056197, 2.779159>
    }
    triangle {
      < 4.690982, -2.004221, 2.764932>,
      < 4.661838, -2.025887, 2.663333>,
      < 4.698328, -2.034359, 2.663333>
    }
    triangle {
      < 4.690982, -2.004221, 2.764932>,
      < 4.698328, -2.034359, 2.663333>,
      < 4.724722, -2.012054, 2.768997>
    }
    triangle {
      < 4.724722, -2.012054, 2.768997>,
      < 4.698328, -2.034359, 2.663333>,
      < 4.717531, -2.055685, 2.663333>
    }
    triangle {
      < 4.724722, -2.012054, 2.768997>,
      < 4.717531, -2.055685, 2.663333>,
      < 4.742478, -2.031773, 2.768997>
    }
    triangle {
      < 4.690982, -2.004221, 2.764932>,
      < 4.724722, -2.012054, 2.768997>,
      < 4.764844, -1.960004, 2.779159>
    }
    triangle {
      < 4.764844, -1.960004, 2.779159>,
      < 4.724722, -2.012054, 2.768997>,
      < 4.742478, -2.031773, 2.768997>
    }
    triangle {
      < 4.764844, -1.960004, 2.779159>,
      < 4.742478, -2.031773, 2.768997>,
      < 4.798442, -1.997317, 2.779159>
    }
    triangle {
      < 4.613774, -1.835851, 2.764932>,
      < 4.641412, -1.856730, 2.768997>,
      < 4.699235, -1.825499, 2.779159>
    }
    triangle {
      < 4.699235, -1.825499, 2.779159>,
      < 4.641412, -1.856730, 2.768997>,
      < 4.649612, -1.881966, 2.768997>
    }
    triangle {
      < 4.699235, -1.825499, 2.779159>,
      < 4.649612, -1.881966, 2.768997>,
      < 4.714753, -1.873251, 2.779159>
    }
    triangle {
      < 4.613774, -1.835851, 2.764932>,
      < 4.578337, -1.843790, 2.663333>,
      < 4.608228, -1.866371, 2.663333>
    }
    triangle {
      < 4.613774, -1.835851, 2.764932>,
      < 4.608228, -1.866371, 2.663333>,
      < 4.641412, -1.856730, 2.768997>
    }
    triangle {
      < 4.641412, -1.856730, 2.768997>,
      < 4.608228, -1.866371, 2.663333>,
      < 4.617096, -1.893664, 2.663333>
    }
    triangle {
      < 4.641412, -1.856730, 2.768997>,
      < 4.617096, -1.893664, 2.663333>,
      < 4.649612, -1.881966, 2.768997>
    }
    triangle {
      < 4.694005, -1.675936, 2.779159>,
      < 4.628479, -1.680949, 2.768997>,
      < 4.625706, -1.707338, 2.768997>
    }
    triangle {
      < 4.694005, -1.675936, 2.779159>,
      < 4.625706, -1.707338, 2.768997>,
      < 4.688759, -1.725872, 2.779159>
    }
    triangle {
      < 4.611722, -1.650634, 2.764932>,
      < 4.628479, -1.680949, 2.768997>,
      < 4.694005, -1.675936, 2.779159>
    }
    triangle {
      < 4.628479, -1.680949, 2.768997>,
      < 4.594242, -1.676260, 2.663333>,
      < 4.591243, -1.704800, 2.663333>
    }
    triangle {
      < 4.628479, -1.680949, 2.768997>,
      < 4.591243, -1.704800, 2.663333>,
      < 4.625706, -1.707338, 2.768997>
    }
    triangle {
      < 4.611722, -1.650634, 2.764932>,
      < 4.576120, -1.643473, 2.663333>,
      < 4.594242, -1.676260, 2.663333>
    }
    triangle {
      < 4.611722, -1.650634, 2.764932>,
      < 4.594242, -1.676260, 2.663333>,
      < 4.628479, -1.680949, 2.768997>
    }
    triangle {
      < 4.685182, -1.480595, 2.764932>,
      < 4.655570, -1.459573, 2.663333>,
      < 4.658790, -1.496895, 2.663333>
    }
    triangle {
      < 4.685182, -1.480595, 2.764932>,
      < 4.658790, -1.496895, 2.663333>,
      < 4.688159, -1.515104, 2.768997>
    }
    triangle {
      < 4.688159, -1.515104, 2.768997>,
      < 4.658790, -1.496895, 2.663333>,
      < 4.644442, -1.521749, 2.663333>
    }
    triangle {
      < 4.688159, -1.515104, 2.768997>,
      < 4.644442, -1.521749, 2.663333>,
      < 4.674892, -1.538084, 2.768997>
    }
    triangle {
      < 4.685182, -1.480595, 2.764932>,
      < 4.688159, -1.515104, 2.768997>,
      < 4.750060, -1.537177, 2.779159>
    }
    triangle {
      < 4.750060, -1.537177, 2.779159>,
      < 4.688159, -1.515104, 2.768997>,
      < 4.674892, -1.538084, 2.768997>
    }
    triangle {
      < 4.750060, -1.537177, 2.779159>,
      < 4.674892, -1.538084, 2.768997>,
      < 4.724957, -1.580661, 2.779159>
    }
    triangle {
      < 4.821450, -1.355134, 2.764932>,
      < 4.810134, -1.387871, 2.768997>,
      < 4.857706, -1.433212, 2.779159>
    }
    triangle {
      < 4.857706, -1.433212, 2.779159>,
      < 4.810134, -1.387871, 2.768997>,
      < 4.788668, -1.403468, 2.768997>
    }
    triangle {
      < 4.857706, -1.433212, 2.779159>,
      < 4.788668, -1.403468, 2.768997>,
      < 4.817087, -1.462727, 2.779159>
    }
    triangle {
      < 4.821450, -1.355134, 2.764932>,
      < 4.802948, -1.323885, 2.663333>,
      < 4.790710, -1.359290, 2.663333>
    }
    triangle {
      < 4.821450, -1.355134, 2.764932>,
      < 4.790710, -1.359290, 2.663333>,
      < 4.810134, -1.387871, 2.768997>
    }
    triangle {
      < 4.810134, -1.387871, 2.768997>,
      < 4.790710, -1.359290, 2.663333>,
      < 4.767493, -1.376160, 2.663333>
    }
    triangle {
      < 4.810134, -1.387871, 2.768997>,
      < 4.767493, -1.376160, 2.663333>,
      < 4.788668, -1.403468, 2.768997>
    }
    triangle {
      < 4.998332, -1.382018, 2.779159>,
      < 4.973314, -1.321248, 2.768997>,
      < 4.947359, -1.326766, 2.768997>
    }
    triangle {
      < 4.998332, -1.382018, 2.779159>,
      < 4.947359, -1.326766, 2.768997>,
      < 4.949219, -1.392461, 2.779159>
    }
    triangle {
      < 4.996966, -1.295944, 2.764932>,
      < 4.973314, -1.321248, 2.768997>,
      < 4.998332, -1.382018, 2.779159>
    }
    triangle {
      < 4.996966, -1.295944, 2.764932>,
      < 4.992774, -1.259871, 2.663333>,
      < 4.967193, -1.287238, 2.663333>
    }
    triangle {
      < 4.996966, -1.295944, 2.764932>,
      < 4.967193, -1.287238, 2.663333>,
      < 4.973314, -1.321248, 2.768997>
    }
    triangle {
      < 4.973314, -1.321248, 2.768997>,
      < 4.967193, -1.287238, 2.663333>,
      < 4.939123, -1.293206, 2.663333>
    }
    triangle {
      < 4.973314, -1.321248, 2.768997>,
      < 4.939123, -1.293206, 2.663333>,
      < 4.947359, -1.326766, 2.768997>
    }
    triangle {
      < 4.717531, -2.055685, 2.663333>,
      < 4.698328, -2.034359, 2.663333>,
      < 4.661838, -2.025887, 2.663333>
    }
    triangle {
      < 4.717531, -2.055685, 2.663333>,
      < 4.661838, -2.025887, 2.663333>,
      < 4.722143, -2.092861, 2.663333>
    }
    triangle {
      < 4.875182, -2.162849, 2.663333>,
      < 4.848965, -2.151177, 2.663333>,
      < 4.812184, -2.158279, 2.663333>
    }
    triangle {
      < 4.875182, -2.162849, 2.663333>,
      < 4.812184, -2.158279, 2.663333>,
      < 4.894516, -2.194936, 2.663333>
    }
    triangle {
      < 5.062791, -2.196627, 2.663333>,
      < 5.034093, -2.196627, 2.663333>,
      < 5.003380, -2.218076, 2.663333>
    }
    triangle {
      < 5.062791, -2.196627, 2.663333>,
      < 5.003380, -2.218076, 2.663333>,
      < 5.093503, -2.218077, 2.663333>
    }
    triangle {
      < 5.247919, -2.151179, 2.663333>,
      < 5.221702, -2.162851, 2.663333>,
      < 5.202368, -2.194938, 2.663333>
    }
    triangle {
      < 5.247919, -2.151179, 2.663333>,
      < 5.202368, -2.194938, 2.663333>,
      < 5.284700, -2.158282, 2.663333>
    }
    triangle {
      < 5.398557, -2.034363, 2.663333>,
      < 5.379354, -2.055689, 2.663333>,
      < 5.374743, -2.092865, 2.663333>
    }
    triangle {
      < 5.398557, -2.034363, 2.663333>,
      < 5.374743, -2.092865, 2.663333>,
      < 5.435048, -2.025892, 2.663333>
    }
    triangle {
      < 5.488660, -1.866377, 2.663333>,
      < 5.479791, -1.893670, 2.663333>,
      < 5.490699, -1.929508, 2.663333>
    }
    triangle {
      < 5.488660, -1.866377, 2.663333>,
      < 5.490699, -1.929508, 2.663333>,
      < 5.518551, -1.843796, 2.663333>
    }
    triangle {
      < 5.502648, -1.676265, 2.663333>,
      < 5.505647, -1.704806, 2.663333>,
      < 5.530188, -1.733109, 2.663333>
    }
    triangle {
      < 5.502648, -1.676265, 2.663333>,
      < 5.530188, -1.733109, 2.663333>,
      < 5.520771, -1.643479, 2.663333>
    }
    triangle {
      < 5.438103, -1.496900, 2.663333>,
      < 5.452451, -1.521754, 2.663333>,
      < 5.486382, -1.537629, 2.663333>
    }
    triangle {
      < 5.438103, -1.496900, 2.663333>,
      < 5.486382, -1.537629, 2.663333>,
      < 5.441323, -1.459577, 2.663333>
    }
    triangle {
      < 5.306184, -1.359294, 2.663333>,
      < 5.329401, -1.376163, 2.663333>,
      < 5.366855, -1.376865, 2.663333>
    }
    triangle {
      < 5.306184, -1.359294, 2.663333>,
      < 5.366855, -1.376865, 2.663333>,
      < 5.293946, -1.323888, 2.663333>
    }
    triangle {
      < 5.129702, -1.287239, 2.663333>,
      < 5.157773, -1.293207, 2.663333>,
      < 5.192275, -1.278614, 2.663333>
    }
    triangle {
      < 5.129702, -1.287239, 2.663333>,
      < 5.192275, -1.278614, 2.663333>,
      < 5.104121, -1.259872, 2.663333>
    }
    triangle {
      < 4.501373, -1.874822, 2.663332>,
      < 4.525680, -1.949631, 2.663332>,
      < 4.606188, -1.929502, 2.663333>
    }
    triangle {
      < 4.501373, -1.874822, 2.663332>,
      < 4.606188, -1.929502, 2.663333>,
      < 4.578337, -1.843790, 2.663333>
    }
    triangle {
      < 4.493187, -1.640519, 2.663332>,
      < 4.484967, -1.718747, 2.663332>,
      < 4.566702, -1.733103, 2.663333>
    }
    triangle {
      < 4.493187, -1.640519, 2.663332>,
      < 4.566702, -1.733103, 2.663333>,
      < 4.576120, -1.643473, 2.663333>
    }
    triangle {
      < 4.581008, -1.423142, 2.663332>,
      < 4.541680, -1.491264, 2.663332>,
      < 4.610510, -1.537623, 2.663333>
    }
    triangle {
      < 4.581008, -1.423142, 2.663332>,
      < 4.610510, -1.537623, 2.663333>,
      < 4.655570, -1.459573, 2.663333>
    }
    triangle {
      < 4.749650, -1.260278, 2.663332>,
      < 4.686016, -1.306514, 2.663332>,
      < 4.730039, -1.376861, 2.663333>
    }
    triangle {
      < 4.749650, -1.260278, 2.663332>,
      < 4.730039, -1.376861, 2.663333>,
      < 4.802948, -1.323885, 2.663333>
    }
    triangle {
      < 4.969955, -1.180085, 2.663332>,
      < 4.893016, -1.196442, 2.663332>,
      < 4.904621, -1.278613, 2.663333>
    }
    triangle {
      < 4.969955, -1.180085, 2.663332>,
      < 4.904621, -1.278613, 2.663333>,
      < 4.992774, -1.259871, 2.663333>
    }
    triangle {
      < 5.048434, -1.718909, 2.852781>,
      < 5.048425, -1.670327, 2.844015>,
      < 5.033167, -1.670987, 2.843713>
    }
    triangle {
      < 5.048434, -1.718909, 2.852781>,
      < 5.033167, -1.670987, 2.843713>,
      < 5.033715, -1.718945, 2.852345>
    }
    triangle {
      < 5.019150, -1.719049, 2.851049>,
      < 5.018181, -1.672935, 2.842822>,
      < 5.010138, -1.673463, 2.841802>
    }
    triangle {
      < 5.019150, -1.719049, 2.851049>,
      < 5.033715, -1.718945, 2.852345>,
      < 5.033167, -1.670987, 2.843713>
    }
    triangle {
      < 5.019150, -1.719049, 2.851049>,
      < 5.033167, -1.670987, 2.843713>,
      < 5.018181, -1.672935, 2.842822>
    }
    triangle {
      < 5.048434, -1.718909, 2.852781>,
      < 5.063154, -1.718942, 2.852345>,
      < 5.063690, -1.670982, 2.843714>
    }
    triangle {
      < 5.048434, -1.718909, 2.852781>,
      < 5.063690, -1.670982, 2.843714>,
      < 5.048425, -1.670327, 2.844015>
    }
    triangle {
      < 5.063154, -1.718942, 2.852345>,
      < 5.077719, -1.719043, 2.851051>,
      < 5.078677, -1.672926, 2.842824>
    }
    triangle {
      < 5.063154, -1.718942, 2.852345>,
      < 5.078677, -1.672926, 2.842824>,
      < 5.063690, -1.670982, 2.843714>
    }
    triangle {
      < 5.077719, -1.719043, 2.851051>,
      < 5.086721, -1.673450, 2.841804>,
      < 5.078677, -1.672926, 2.842824>
    }
    triangle {
      < 5.077719, -1.719043, 2.851051>,
      < 5.091983, -1.719208, 2.848939>,
      < 5.100585, -1.677655, 2.840264>
    }
    triangle {
      < 5.077719, -1.719043, 2.851051>,
      < 5.100585, -1.677655, 2.840264>,
      < 5.086721, -1.673450, 2.841804>
    }
    triangle {
      < 5.091983, -1.719208, 2.848939>,
      < 5.104371, -1.708975, 2.845357>,
      < 5.112318, -1.680317, 2.838027>
    }
    triangle {
      < 5.091983, -1.719208, 2.848939>,
      < 5.112318, -1.680317, 2.838027>,
      < 5.100585, -1.677655, 2.840264>
    }
    triangle {
      < 5.104371, -1.708975, 2.845357>,
      < 5.118579, -1.709425, 2.841648>,
      < 5.124714, -1.686381, 2.835714>
    }
    triangle {
      < 5.104371, -1.708975, 2.845357>,
      < 5.124714, -1.686381, 2.835714>,
      < 5.112318, -1.680317, 2.838027>
    }
    triangle {
      < 5.118579, -1.709425, 2.841648>,
      < 5.132073, -1.709956, 2.837276>,
      < 5.129477, -1.692665, 2.835422>
    }
    triangle {
      < 5.131828, -1.728363, 2.838889>,
      < 5.156281, -1.719384, 2.828054>,
      < 5.125597, -1.720634, 2.840566>
    }
    triangle {
      < 5.135253, -1.735762, 2.837839>,
      < 5.134612, -1.738668, 2.838093>,
      < 5.146635, -1.736575, 2.833268>
    }
    triangle {
      < 5.135253, -1.735762, 2.837839>,
      < 5.146635, -1.736575, 2.833268>,
      < 5.156281, -1.719384, 2.828054>
    }
    triangle {
      < 5.134612, -1.738668, 2.838093>,
      < 5.132570, -1.741768, 2.838815>,
      < 5.145410, -1.745914, 2.833677>
    }
    triangle {
      < 5.134612, -1.738668, 2.838093>,
      < 5.145410, -1.745914, 2.833677>,
      < 5.146635, -1.736575, 2.833268>
    }
    triangle {
      < 5.132570, -1.741768, 2.838815>,
      < 5.129311, -1.744261, 2.839917>,
      < 5.142567, -1.754884, 2.834395>
    }
    triangle {
      < 5.132570, -1.741768, 2.838815>,
      < 5.142567, -1.754884, 2.834395>,
      < 5.145410, -1.745914, 2.833677>
    }
    triangle {
      < 5.129311, -1.744261, 2.839917>,
      < 5.124606, -1.747297, 2.841394>,
      < 5.138001, -1.763922, 2.835397>
    }
    triangle {
      < 5.129311, -1.744261, 2.839917>,
      < 5.138001, -1.763922, 2.835397>,
      < 5.142567, -1.754884, 2.834395>
    }
    triangle {
      < 5.124606, -1.747297, 2.841394>,
      < 5.118957, -1.750271, 2.843014>,
      < 5.131969, -1.772594, 2.836540>
    }
    triangle {
      < 5.124606, -1.747297, 2.841394>,
      < 5.131969, -1.772594, 2.836540>,
      < 5.138001, -1.763922, 2.835397>
    }
    triangle {
      < 5.118957, -1.750271, 2.843014>,
      < 5.112181, -1.753411, 2.844747>,
      < 5.124419, -1.780868, 2.837771>
    }
    triangle {
      < 5.118957, -1.750271, 2.843014>,
      < 5.124419, -1.780868, 2.837771>,
      < 5.131969, -1.772594, 2.836540>
    }
    triangle {
      < 5.112181, -1.753411, 2.844747>,
      < 5.104347, -1.757434, 2.846415>,
      < 5.115426, -1.788932, 2.838923>
    }
    triangle {
      < 5.112181, -1.753411, 2.844747>,
      < 5.115426, -1.788932, 2.838923>,
      < 5.124419, -1.780868, 2.837771>
    }
    triangle {
      < 5.104347, -1.757434, 2.846415>,
      < 5.095855, -1.760986, 2.847925>,
      < 5.105288, -1.795994, 2.839975>
    }
    triangle {
      < 5.104347, -1.757434, 2.846415>,
      < 5.105288, -1.795994, 2.839975>,
      < 5.115426, -1.788932, 2.838923>
    }
    triangle {
      < 5.095855, -1.760986, 2.847925>,
      < 5.086355, -1.763883, 2.849307>,
      < 5.093951, -1.801850, 2.840937>
    }
    triangle {
      < 5.095855, -1.760986, 2.847925>,
      < 5.093951, -1.801850, 2.840937>,
      < 5.105288, -1.795994, 2.839975>
    }
    triangle {
      < 5.086355, -1.763883, 2.849307>,
      < 5.076283, -1.766977, 2.850321>,
      < 5.081745, -1.806768, 2.841603>
    }
    triangle {
      < 5.086355, -1.763883, 2.849307>,
      < 5.081745, -1.806768, 2.841603>,
      < 5.093951, -1.801850, 2.840937>
    }
    triangle {
      < 5.076283, -1.766977, 2.850321>,
      < 5.065201, -1.769908, 2.850970>,
      < 5.068623, -1.810492, 2.841981>
    }
    triangle {
      < 5.076283, -1.766977, 2.850321>,
      < 5.068623, -1.810492, 2.841981>,
      < 5.081745, -1.806768, 2.841603>
    }
    triangle {
      < 5.065201, -1.769908, 2.850970>,
      < 5.054963, -1.772411, 2.851121>,
      < 5.055653, -1.812827, 2.842009>
    }
    triangle {
      < 5.065201, -1.769908, 2.850970>,
      < 5.055653, -1.812827, 2.842009>,
      < 5.068623, -1.810492, 2.841981>
    }
    triangle {
      < 5.054963, -1.772411, 2.851121>,
      < 5.041962, -1.772412, 2.851122>,
      < 5.041276, -1.812829, 2.842010>
    }
    triangle {
      < 5.054963, -1.772411, 2.851121>,
      < 5.041276, -1.812829, 2.842010>,
      < 5.055653, -1.812827, 2.842009>
    }
    triangle {
      < 5.041962, -1.772412, 2.851122>,
      < 5.031713, -1.769917, 2.850970>,
      < 5.028300, -1.810501, 2.841982>
    }
    triangle {
      < 5.041962, -1.772412, 2.851122>,
      < 5.028300, -1.810501, 2.841982>,
      < 5.041276, -1.812829, 2.842010>
    }
    triangle {
      < 5.031713, -1.769917, 2.850970>,
      < 5.020626, -1.766988, 2.850321>,
      < 5.015175, -1.806781, 2.841603>
    }
    triangle {
      < 5.031713, -1.769917, 2.850970>,
      < 5.015175, -1.806781, 2.841603>,
      < 5.028300, -1.810501, 2.841982>
    }
    triangle {
      < 5.020626, -1.766988, 2.850321>,
      < 5.010549, -1.763898, 2.849308>,
      < 5.002964, -1.801868, 2.840937>
    }
    triangle {
      < 5.020626, -1.766988, 2.850321>,
      < 5.002964, -1.801868, 2.840937>,
      < 5.015175, -1.806781, 2.841603>
    }
    triangle {
      < 5.010549, -1.763898, 2.849308>,
      < 5.001306, -1.761263, 2.847952>,
      < 4.991753, -1.796140, 2.839976>
    }
    triangle {
      < 5.010549, -1.763898, 2.849308>,
      < 4.991753, -1.796140, 2.839976>,
      < 5.002964, -1.801868, 2.840937>
    }
    triangle {
      < 5.001306, -1.761263, 2.847952>,
      < 4.992546, -1.757454, 2.846414>,
      < 4.981481, -1.788957, 2.838923>
    }
    triangle {
      < 5.001306, -1.761263, 2.847952>,
      < 4.981481, -1.788957, 2.838923>,
      < 4.991753, -1.796140, 2.839976>
    }
    triangle {
      < 4.992546, -1.757454, 2.846414>,
      < 4.984708, -1.753434, 2.844745>,
      < 4.972484, -1.780896, 2.837770>
    }
    triangle {
      < 4.992546, -1.757454, 2.846414>,
      < 4.972484, -1.780896, 2.837770>,
      < 4.981481, -1.788957, 2.838923>
    }
    triangle {
      < 4.984708, -1.753434, 2.844745>,
      < 4.977930, -1.750294, 2.843013>,
      < 4.964930, -1.772623, 2.836539>
    }
    triangle {
      < 4.984708, -1.753434, 2.844745>,
      < 4.964930, -1.772623, 2.836539>,
      < 4.972484, -1.780896, 2.837770>
    }
    triangle {
      < 4.977930, -1.750294, 2.843013>,
      < 4.972040, -1.747036, 2.841324>,
      < 4.958778, -1.763813, 2.835366>
    }
    triangle {
      < 4.977930, -1.750294, 2.843013>,
      < 4.958778, -1.763813, 2.835366>,
      < 4.964930, -1.772623, 2.836539>
    }
    triangle {
      < 4.972040, -1.747036, 2.841324>,
      < 4.967573, -1.744281, 2.839914>,
      < 4.954325, -1.754914, 2.834394>
    }
    triangle {
      < 4.972040, -1.747036, 2.841324>,
      < 4.954325, -1.754914, 2.834394>,
      < 4.958778, -1.763813, 2.835366>
    }
    triangle {
      < 4.967573, -1.744281, 2.839914>,
      < 4.964313, -1.741786, 2.838813>,
      < 4.951478, -1.745944, 2.833675>
    }
    triangle {
      < 4.967573, -1.744281, 2.839914>,
      < 4.951478, -1.745944, 2.833675>,
      < 4.954325, -1.754914, 2.834394>
    }
    triangle {
      < 4.964313, -1.741786, 2.838813>,
      < 4.962271, -1.738689, 2.838090>,
      < 4.950251, -1.736606, 2.833266>
    }
    triangle {
      < 4.964313, -1.741786, 2.838813>,
      < 4.950251, -1.736606, 2.833266>,
      < 4.951478, -1.745944, 2.833675>
    }
    triangle {
      < 4.962271, -1.738689, 2.838090>,
      < 4.961631, -1.735803, 2.837837>,
      < 4.940600, -1.719425, 2.828054>
    }
    triangle {
      < 4.962271, -1.738689, 2.838090>,
      < 4.940600, -1.719425, 2.828054>,
      < 4.950251, -1.736606, 2.833266>
    }
    triangle {
      < 4.965055, -1.728392, 2.838888>,
      < 4.971284, -1.720668, 2.840566>,
      < 4.940600, -1.719425, 2.828054>
    }
    triangle {
      < 4.964806, -1.709989, 2.837276>,
      < 4.950013, -1.690435, 2.828054>,
      < 4.944293, -1.704601, 2.828054>
    }
    triangle {
      < 4.978296, -1.709448, 2.841646>,
      < 4.967393, -1.692694, 2.835421>,
      < 4.964806, -1.709989, 2.837276>
    }
    triangle {
      < 4.978296, -1.709448, 2.841646>,
      < 4.992498, -1.708987, 2.845354>,
      < 4.984545, -1.680337, 2.838025>
    }
    triangle {
      < 4.978296, -1.709448, 2.841646>,
      < 4.984545, -1.680337, 2.838025>,
      < 4.972154, -1.686408, 2.835713>
    }
    triangle {
      < 4.992498, -1.708987, 2.845354>,
      < 5.004886, -1.719217, 2.848936>,
      < 4.996275, -1.677672, 2.840262>
    }
    triangle {
      < 4.992498, -1.708987, 2.845354>,
      < 4.996275, -1.677672, 2.840262>,
      < 4.984545, -1.680337, 2.838025>
    }
    triangle {
      < 5.004886, -1.719217, 2.848936>,
      < 5.019150, -1.719049, 2.851049>,
      < 5.010138, -1.673463, 2.841802>
    }
    triangle {
      < 5.004886, -1.719217, 2.848936>,
      < 5.010138, -1.673463, 2.841802>,
      < 4.996275, -1.677672, 2.840262>
    }
    triangle {
      < 4.969537, -1.713619, 2.848997>,
      < 4.975648, -1.723348, 2.852286>,
      < 4.982264, -1.713125, 2.853366>
    }
    triangle {
      < 4.944293, -1.704601, 2.828054>,
      < 4.940600, -1.719425, 2.828054>,
      < 4.964806, -1.709989, 2.837276>
    }
    triangle {
      < 5.132073, -1.709956, 2.837276>,
      < 5.125597, -1.720634, 2.840566>,
      < 5.156281, -1.719384, 2.828054>
    }
    triangle {
      < 5.127343, -1.713589, 2.848996>,
      < 5.114612, -1.713105, 2.853368>,
      < 5.121234, -1.723317, 2.852286>
    }
    triangle {
      < 4.961631, -1.735803, 2.837837>,
      < 4.965055, -1.728392, 2.838888>,
      < 4.940600, -1.719425, 2.828054>
    }
    triangle {
      < 5.135253, -1.735762, 2.837839>,
      < 5.156281, -1.719384, 2.828054>,
      < 5.131828, -1.728363, 2.838889>
    }
    triangle {
      < 5.042328, -1.770489, 2.862842>,
      < 5.054595, -1.770488, 2.862842>,
      < 5.048435, -1.721745, 2.864501>
    }
    triangle {
      < 5.034548, -1.721778, 2.864064>,
      < 5.042328, -1.770489, 2.862842>,
      < 5.048435, -1.721745, 2.864501>
    }
    triangle {
      < 5.064253, -1.768208, 2.862690>,
      < 5.062322, -1.721775, 2.864065>,
      < 5.054595, -1.770488, 2.862842>
    }
    triangle {
      < 5.048435, -1.721745, 2.864501>,
      < 5.054595, -1.770488, 2.862842>,
      < 5.062322, -1.721775, 2.864065>
    }
    triangle {
      < 5.084210, -1.762718, 2.861027>,
      < 5.093158, -1.722017, 2.859846>,
      < 5.076063, -1.721867, 2.862772>
    }
    triangle {
      < 5.084210, -1.762718, 2.861027>,
      < 5.076063, -1.721867, 2.862772>,
      < 5.074708, -1.765537, 2.862041>
    }
    triangle {
      < 5.062322, -1.721775, 2.864065>,
      < 5.064253, -1.768208, 2.862690>,
      < 5.074708, -1.765537, 2.862041>
    }
    triangle {
      < 5.062322, -1.721775, 2.864065>,
      < 5.074708, -1.765537, 2.862041>,
      < 5.076063, -1.721867, 2.862772>
    }
    triangle {
      < 5.101185, -1.756843, 2.858135>,
      < 5.105880, -1.712695, 2.856265>,
      < 5.093173, -1.760080, 2.859645>
    }
    triangle {
      < 5.093158, -1.722017, 2.859846>,
      < 5.084210, -1.762718, 2.861027>,
      < 5.093173, -1.760080, 2.859645>
    }
    triangle {
      < 5.093158, -1.722017, 2.859846>,
      < 5.093173, -1.760080, 2.859645>,
      < 5.105880, -1.712695, 2.856265>
    }
    triangle {
      < 5.114968, -1.750317, 2.854735>,
      < 5.121234, -1.723317, 2.852286>,
      < 5.114612, -1.713105, 2.853368>
    }
    triangle {
      < 5.114968, -1.750317, 2.854735>,
      < 5.114612, -1.713105, 2.853368>,
      < 5.108576, -1.753178, 2.856467>
    }
    triangle {
      < 5.020807, -1.721872, 2.862770>,
      < 5.022200, -1.765548, 2.862041>,
      < 5.032659, -1.768216, 2.862690>
    }
    triangle {
      < 5.020807, -1.721872, 2.862770>,
      < 5.032659, -1.768216, 2.862690>,
      < 5.034548, -1.721778, 2.864064>
    }
    triangle {
      < 5.042328, -1.770489, 2.862842>,
      < 5.034548, -1.721778, 2.864064>,
      < 5.032659, -1.768216, 2.862690>
    }
    triangle {
      < 4.990989, -1.712705, 2.856261>,
      < 5.003972, -1.760332, 2.859672>,
      < 5.012692, -1.762733, 2.861027>
    }
    triangle {
      < 4.990989, -1.712705, 2.856261>,
      < 5.012692, -1.762733, 2.861027>,
      < 5.003711, -1.722026, 2.859843>
    }
    triangle {
      < 5.022200, -1.765548, 2.862041>,
      < 5.020807, -1.721872, 2.862770>,
      < 5.003711, -1.722026, 2.859843>
    }
    triangle {
      < 5.022200, -1.765548, 2.862041>,
      < 5.003711, -1.722026, 2.859843>,
      < 5.012692, -1.762733, 2.861027>
    }
    triangle {
      < 4.995708, -1.756862, 2.858134>,
      < 4.990989, -1.712705, 2.856261>,
      < 4.982264, -1.713125, 2.853366>
    }
    triangle {
      < 4.995708, -1.756862, 2.858134>,
      < 4.982264, -1.713125, 2.853366>,
      < 4.988314, -1.753199, 2.856466>
    }
    triangle {
      < 5.003972, -1.760332, 2.859672>,
      < 4.990989, -1.712705, 2.856261>,
      < 4.995708, -1.756862, 2.858134>
    }
    triangle {
      < 4.969771, -1.730384, 2.850608>,
      < 4.976361, -1.747370, 2.853045>,
      < 4.981918, -1.750338, 2.854733>
    }
    triangle {
      < 4.969771, -1.730384, 2.850608>,
      < 4.981918, -1.750338, 2.854733>,
      < 4.975648, -1.723348, 2.852286>
    }
    triangle {
      < 4.988314, -1.753199, 2.856466>,
      < 4.982264, -1.713125, 2.853366>,
      < 4.975648, -1.723348, 2.852286>
    }
    triangle {
      < 4.988314, -1.753199, 2.856466>,
      < 4.975648, -1.723348, 2.852286>,
      < 4.981918, -1.750338, 2.854733>
    }
    triangle {
      < 4.967145, -1.739766, 2.849810>,
      < 4.969071, -1.742587, 2.850533>,
      < 4.972147, -1.744860, 2.851635>
    }
    triangle {
      < 4.967145, -1.739766, 2.849810>,
      < 4.972147, -1.744860, 2.851635>,
      < 4.966541, -1.737136, 2.849557>
    }
    triangle {
      < 4.976361, -1.747370, 2.853045>,
      < 4.969771, -1.730384, 2.850608>,
      < 4.966541, -1.737136, 2.849557>
    }
    triangle {
      < 4.976361, -1.747370, 2.853045>,
      < 4.966541, -1.737136, 2.849557>,
      < 4.972147, -1.744860, 2.851635>
    }
    triangle {
      < 5.105880, -1.712695, 2.856265>,
      < 5.101185, -1.756843, 2.858135>,
      < 5.108576, -1.753178, 2.856467>
    }
    triangle {
      < 5.105880, -1.712695, 2.856265>,
      < 5.108576, -1.753178, 2.856467>,
      < 5.114612, -1.713105, 2.853368>
    }
    triangle {
      < 5.124737, -1.744842, 2.851637>,
      < 5.130343, -1.737099, 2.849559>,
      < 5.127112, -1.730358, 2.850609>
    }
    triangle {
      < 5.124737, -1.744842, 2.851637>,
      < 5.127112, -1.730358, 2.850609>,
      < 5.120298, -1.747608, 2.853114>
    }
    triangle {
      < 5.121234, -1.723317, 2.852286>,
      < 5.114968, -1.750317, 2.854735>,
      < 5.120298, -1.747608, 2.853114>
    }
    triangle {
      < 5.121234, -1.723317, 2.852286>,
      < 5.120298, -1.747608, 2.853114>,
      < 5.127112, -1.730358, 2.850609>
    }
    triangle {
      < 5.127812, -1.742571, 2.850535>,
      < 5.129738, -1.739747, 2.849813>,
      < 5.130343, -1.737099, 2.849559>
    }
    triangle {
      < 5.127812, -1.742571, 2.850535>,
      < 5.130343, -1.737099, 2.849559>,
      < 5.124737, -1.744842, 2.851637>
    }
    triangle {
      < 4.978296, -1.709448, 2.841646>,
      < 4.972154, -1.686408, 2.835713>,
      < 4.967393, -1.692694, 2.835421>
    }
    triangle {
      < 5.118579, -1.709425, 2.841648>,
      < 5.129477, -1.692665, 2.835422>,
      < 5.124714, -1.686381, 2.835714>
    }
    triangle {
      < 5.152584, -1.704561, 2.828054>,
      < 5.146858, -1.690398, 2.828054>,
      < 5.132073, -1.709956, 2.837276>
    }
    triangle {
      < 4.957648, -1.677203, 2.828054>,
      < 4.950013, -1.690435, 2.828054>,
      < 4.964806, -1.709989, 2.837276>
    }
    triangle {
      < 4.957648, -1.677203, 2.828054>,
      < 4.964806, -1.709989, 2.837276>,
      < 4.967393, -1.692694, 2.835421>
    }
    triangle {
      < 4.967051, -1.665163, 2.828054>,
      < 4.957648, -1.677203, 2.828054>,
      < 4.967393, -1.692694, 2.835421>
    }
    triangle {
      < 4.967051, -1.665163, 2.828054>,
      < 4.967393, -1.692694, 2.835421>,
      < 4.972154, -1.686408, 2.835713>
    }
    triangle {
      < 4.978038, -1.654548, 2.828054>,
      < 4.967051, -1.665163, 2.828054>,
      < 4.972154, -1.686408, 2.835713>
    }
    triangle {
      < 4.978038, -1.654548, 2.828054>,
      < 4.972154, -1.686408, 2.835713>,
      < 4.984545, -1.680337, 2.838025>
    }
    triangle {
      < 4.990395, -1.645565, 2.828054>,
      < 4.978038, -1.654548, 2.828054>,
      < 4.984545, -1.680337, 2.838025>
    }
    triangle {
      < 4.990395, -1.645565, 2.828054>,
      < 4.984545, -1.680337, 2.838025>,
      < 4.996275, -1.677672, 2.840262>
    }
    triangle {
      < 5.003882, -1.638390, 2.828054>,
      < 4.990395, -1.645565, 2.828054>,
      < 4.996275, -1.677672, 2.840262>
    }
    triangle {
      < 5.003882, -1.638390, 2.828054>,
      < 4.996275, -1.677672, 2.840262>,
      < 5.010138, -1.673463, 2.841802>
    }
    triangle {
      < 5.018236, -1.633162, 2.828054>,
      < 5.003882, -1.638390, 2.828054>,
      < 5.010138, -1.673463, 2.841802>
    }
    triangle {
      < 5.018236, -1.633162, 2.828054>,
      < 5.010138, -1.673463, 2.841802>,
      < 5.018181, -1.672935, 2.842822>
    }
    triangle {
      < 5.033179, -1.629982, 2.828054>,
      < 5.018236, -1.633162, 2.828054>,
      < 5.018181, -1.672935, 2.842822>
    }
    triangle {
      < 5.033179, -1.629982, 2.828054>,
      < 5.018181, -1.672935, 2.842822>,
      < 5.033167, -1.670987, 2.843713>
    }
    triangle {
      < 5.048418, -1.628912, 2.828054>,
      < 5.033179, -1.629982, 2.828054>,
      < 5.033167, -1.670987, 2.843713>
    }
    triangle {
      < 5.048418, -1.628912, 2.828054>,
      < 5.033167, -1.670987, 2.843713>,
      < 5.048425, -1.670327, 2.844015>
    }
    triangle {
      < 5.063670, -1.629976, 2.828054>,
      < 5.048418, -1.628912, 2.828054>,
      < 5.048425, -1.670327, 2.844015>
    }
    triangle {
      < 5.063670, -1.629976, 2.828054>,
      < 5.048425, -1.670327, 2.844015>,
      < 5.063690, -1.670982, 2.843714>
    }
    triangle {
      < 5.078613, -1.633150, 2.828054>,
      < 5.063670, -1.629976, 2.828054>,
      < 5.063690, -1.670982, 2.843714>
    }
    triangle {
      < 5.078613, -1.633150, 2.828054>,
      < 5.063690, -1.670982, 2.843714>,
      < 5.078677, -1.672926, 2.842824>
    }
    triangle {
      < 5.092969, -1.638373, 2.828054>,
      < 5.078613, -1.633150, 2.828054>,
      < 5.078677, -1.672926, 2.842824>
    }
    triangle {
      < 5.092969, -1.638373, 2.828054>,
      < 5.078677, -1.672926, 2.842824>,
      < 5.086721, -1.673450, 2.841804>
    }
    triangle {
      < 5.106459, -1.645543, 2.828054>,
      < 5.092969, -1.638373, 2.828054>,
      < 5.086721, -1.673450, 2.841804>
    }
    triangle {
      < 5.106459, -1.645543, 2.828054>,
      < 5.086721, -1.673450, 2.841804>,
      < 5.100585, -1.677655, 2.840264>
    }
    triangle {
      < 5.118820, -1.654521, 2.828054>,
      < 5.106459, -1.645543, 2.828054>,
      < 5.100585, -1.677655, 2.840264>
    }
    triangle {
      < 5.118820, -1.654521, 2.828054>,
      < 5.100585, -1.677655, 2.840264>,
      < 5.112318, -1.680317, 2.838027>
    }
    triangle {
      < 5.129811, -1.665132, 2.828054>,
      < 5.118820, -1.654521, 2.828054>,
      < 5.112318, -1.680317, 2.838027>
    }
    triangle {
      < 5.129811, -1.665132, 2.828054>,
      < 5.112318, -1.680317, 2.838027>,
      < 5.124714, -1.686381, 2.835714>
    }
    triangle {
      < 5.139218, -1.677168, 2.828054>,
      < 5.129811, -1.665132, 2.828054>,
      < 5.124714, -1.686381, 2.835714>
    }
    triangle {
      < 5.139218, -1.677168, 2.828054>,
      < 5.124714, -1.686381, 2.835714>,
      < 5.129477, -1.692665, 2.835422>
    }
    triangle {
      < 5.146858, -1.690398, 2.828054>,
      < 5.139218, -1.677168, 2.828054>,
      < 5.129477, -1.692665, 2.835422>
    }
    triangle {
      < 5.146858, -1.690398, 2.828054>,
      < 5.129477, -1.692665, 2.835422>,
      < 5.132073, -1.709956, 2.837276>
    }
    triangle {
      < 5.152584, -1.704561, 2.828054>,
      < 5.132073, -1.709956, 2.837276>,
      < 5.156281, -1.719384, 2.828054>
    }
    triangle {
      < 5.157881, -1.734577, 2.828054>,
      < 5.156281, -1.719384, 2.828054>,
      < 5.146635, -1.736575, 2.833268>
    }
    triangle {
      < 5.157351, -1.749844, 2.828054>,
      < 5.157881, -1.734577, 2.828054>,
      < 5.146635, -1.736575, 2.833268>
    }
    triangle {
      < 5.157351, -1.749844, 2.828054>,
      < 5.146635, -1.736575, 2.833268>,
      < 5.145410, -1.745914, 2.833677>
    }
    triangle {
      < 5.154700, -1.764889, 2.828054>,
      < 5.157351, -1.749844, 2.828054>,
      < 5.145410, -1.745914, 2.833677>
    }
    triangle {
      < 5.154700, -1.764889, 2.828054>,
      < 5.145410, -1.745914, 2.833677>,
      < 5.142567, -1.754884, 2.834395>
    }
    triangle {
      < 5.149981, -1.779420, 2.828054>,
      < 5.154700, -1.764889, 2.828054>,
      < 5.142567, -1.754884, 2.834395>
    }
    triangle {
      < 5.149981, -1.779420, 2.828054>,
      < 5.142567, -1.754884, 2.834395>,
      < 5.138001, -1.763922, 2.835397>
    }
    triangle {
      < 5.143287, -1.793151, 2.828054>,
      < 5.149981, -1.779420, 2.828054>,
      < 5.138001, -1.763922, 2.835397>
    }
    triangle {
      < 5.143287, -1.793151, 2.828054>,
      < 5.138001, -1.763922, 2.835397>,
      < 5.131969, -1.772594, 2.836540>
    }
    triangle {
      < 5.134747, -1.805818, 2.828054>,
      < 5.143287, -1.793151, 2.828054>,
      < 5.131969, -1.772594, 2.836540>
    }
    triangle {
      < 5.134747, -1.805818, 2.828054>,
      < 5.131969, -1.772594, 2.836540>,
      < 5.124419, -1.780868, 2.837771>
    }
    triangle {
      < 5.124527, -1.817173, 2.828054>,
      < 5.134747, -1.805818, 2.828054>,
      < 5.124419, -1.780868, 2.837771>
    }
    triangle {
      < 5.124527, -1.817173, 2.828054>,
      < 5.124419, -1.780868, 2.837771>,
      < 5.115426, -1.788932, 2.838923>
    }
    triangle {
      < 5.112825, -1.826995, 2.828054>,
      < 5.124527, -1.817173, 2.828054>,
      < 5.115426, -1.788932, 2.838923>
    }
    triangle {
      < 5.112825, -1.826995, 2.828054>,
      < 5.115426, -1.788932, 2.838923>,
      < 5.105288, -1.795994, 2.839975>
    }
    triangle {
      < 5.099871, -1.835093, 2.828054>,
      < 5.112825, -1.826995, 2.828054>,
      < 5.105288, -1.795994, 2.839975>
    }
    triangle {
      < 5.099871, -1.835093, 2.828054>,
      < 5.105288, -1.795994, 2.839975>,
      < 5.093951, -1.801850, 2.840937>
    }
    triangle {
      < 5.085916, -1.841309, 2.828054>,
      < 5.099871, -1.835093, 2.828054>,
      < 5.093951, -1.801850, 2.840937>
    }
    triangle {
      < 5.085916, -1.841309, 2.828054>,
      < 5.093951, -1.801850, 2.840937>,
      < 5.081745, -1.806768, 2.841603>
    }
    triangle {
      < 5.071232, -1.845522, 2.828054>,
      < 5.085916, -1.841309, 2.828054>,
      < 5.081745, -1.806768, 2.841603>
    }
    triangle {
      < 5.071232, -1.845522, 2.828054>,
      < 5.081745, -1.806768, 2.841603>,
      < 5.068623, -1.810492, 2.841981>
    }
    triangle {
      < 5.056104, -1.847651, 2.828054>,
      < 5.071232, -1.845522, 2.828054>,
      < 5.068623, -1.810492, 2.841981>
    }
    triangle {
      < 5.056104, -1.847651, 2.828054>,
      < 5.068623, -1.810492, 2.841981>,
      < 5.055653, -1.812827, 2.842009>
    }
    triangle {
      < 5.040827, -1.847654, 2.828054>,
      < 5.056104, -1.847651, 2.828054>,
      < 5.055653, -1.812827, 2.842009>
    }
    triangle {
      < 5.040827, -1.847654, 2.828054>,
      < 5.055653, -1.812827, 2.842009>,
      < 5.041276, -1.812829, 2.842010>
    }
    triangle {
      < 5.025699, -1.845531, 2.828054>,
      < 5.040827, -1.847654, 2.828054>,
      < 5.041276, -1.812829, 2.842010>
    }
    triangle {
      < 5.025699, -1.845531, 2.828054>,
      < 5.041276, -1.812829, 2.842010>,
      < 5.028300, -1.810501, 2.841982>
    }
    triangle {
      < 5.011013, -1.841323, 2.828054>,
      < 5.025699, -1.845531, 2.828054>,
      < 5.028300, -1.810501, 2.841982>
    }
    triangle {
      < 5.011013, -1.841323, 2.828054>,
      < 5.028300, -1.810501, 2.841982>,
      < 5.015175, -1.806781, 2.841603>
    }
    triangle {
      < 4.997055, -1.835112, 2.828054>,
      < 5.011013, -1.841323, 2.828054>,
      < 5.015175, -1.806781, 2.841603>
    }
    triangle {
      < 4.997055, -1.835112, 2.828054>,
      < 5.015175, -1.806781, 2.841603>,
      < 5.002964, -1.801868, 2.840937>
    }
    triangle {
      < 4.984098, -1.827019, 2.828054>,
      < 4.997055, -1.835112, 2.828054>,
      < 5.002964, -1.801868, 2.840937>
    }
    triangle {
      < 4.984098, -1.827019, 2.828054>,
      < 5.002964, -1.801868, 2.840937>,
      < 4.991753, -1.796140, 2.839976>
    }
    triangle {
      < 4.972393, -1.817202, 2.828054>,
      < 4.984098, -1.827019, 2.828054>,
      < 4.991753, -1.796140, 2.839976>
    }
    triangle {
      < 4.972393, -1.817202, 2.828054>,
      < 4.991753, -1.796140, 2.839976>,
      < 4.981481, -1.788957, 2.838923>
    }
    triangle {
      < 4.962169, -1.805851, 2.828054>,
      < 4.972393, -1.817202, 2.828054>,
      < 4.981481, -1.788957, 2.838923>
    }
    triangle {
      < 4.962169, -1.805851, 2.828054>,
      < 4.981481, -1.788957, 2.838923>,
      < 4.972484, -1.780896, 2.837770>
    }
    triangle {
      < 4.953623, -1.793188, 2.828054>,
      < 4.962169, -1.805851, 2.828054>,
      < 4.972484, -1.780896, 2.837770>
    }
    triangle {
      < 4.953623, -1.793188, 2.828054>,
      < 4.972484, -1.780896, 2.837770>,
      < 4.964930, -1.772623, 2.836539>
    }
    triangle {
      < 4.946923, -1.779458, 2.828054>,
      < 4.953623, -1.793188, 2.828054>,
      < 4.964930, -1.772623, 2.836539>
    }
    triangle {
      < 4.946923, -1.779458, 2.828054>,
      < 4.964930, -1.772623, 2.836539>,
      < 4.958778, -1.763813, 2.835366>
    }
    triangle {
      < 4.942200, -1.764930, 2.828054>,
      < 4.946923, -1.779458, 2.828054>,
      < 4.958778, -1.763813, 2.835366>
    }
    triangle {
      < 4.942200, -1.764930, 2.828054>,
      < 4.958778, -1.763813, 2.835366>,
      < 4.954325, -1.754914, 2.834394>
    }
    triangle {
      < 4.939544, -1.749886, 2.828054>,
      < 4.942200, -1.764930, 2.828054>,
      < 4.954325, -1.754914, 2.834394>
    }
    triangle {
      < 4.939544, -1.749886, 2.828054>,
      < 4.954325, -1.754914, 2.834394>,
      < 4.951478, -1.745944, 2.833675>
    }
    triangle {
      < 4.939007, -1.734618, 2.828054>,
      < 4.939544, -1.749886, 2.828054>,
      < 4.951478, -1.745944, 2.833675>
    }
    triangle {
      < 4.939007, -1.734618, 2.828054>,
      < 4.951478, -1.745944, 2.833675>,
      < 4.950251, -1.736606, 2.833266>
    }
    triangle {
      < 4.939007, -1.734618, 2.828054>,
      < 4.950251, -1.736606, 2.833266>,
      < 4.940600, -1.719425, 2.828054>
    }
    triangle {
      < 4.971284, -1.720668, 2.840566>,
      < 4.964806, -1.709989, 2.837276>,
      < 4.940600, -1.719425, 2.828054>
    }
    triangle {
      < 5.127812, -1.742571, 2.850535>,
      < 5.124737, -1.744842, 2.851637>,
      < 5.129311, -1.744261, 2.839917>
    }
    triangle {
      < 5.127812, -1.742571, 2.850535>,
      < 5.129311, -1.744261, 2.839917>,
      < 5.132570, -1.741768, 2.838815>
    }
    triangle {
      < 5.124737, -1.744842, 2.851637>,
      < 5.120298, -1.747608, 2.853114>,
      < 5.124606, -1.747297, 2.841394>
    }
    triangle {
      < 5.124737, -1.744842, 2.851637>,
      < 5.124606, -1.747297, 2.841394>,
      < 5.129311, -1.744261, 2.839917>
    }
    triangle {
      < 5.120298, -1.747608, 2.853114>,
      < 5.114968, -1.750317, 2.854735>,
      < 5.118957, -1.750271, 2.843014>
    }
    triangle {
      < 5.120298, -1.747608, 2.853114>,
      < 5.118957, -1.750271, 2.843014>,
      < 5.124606, -1.747297, 2.841394>
    }
    triangle {
      < 5.114968, -1.750317, 2.854735>,
      < 5.108576, -1.753178, 2.856467>,
      < 5.112181, -1.753411, 2.844747>
    }
    triangle {
      < 5.114968, -1.750317, 2.854735>,
      < 5.112181, -1.753411, 2.844747>,
      < 5.118957, -1.750271, 2.843014>
    }
    triangle {
      < 5.108576, -1.753178, 2.856467>,
      < 5.101185, -1.756843, 2.858135>,
      < 5.104347, -1.757434, 2.846415>
    }
    triangle {
      < 5.108576, -1.753178, 2.856467>,
      < 5.104347, -1.757434, 2.846415>,
      < 5.112181, -1.753411, 2.844747>
    }
    triangle {
      < 5.101185, -1.756843, 2.858135>,
      < 5.093173, -1.760080, 2.859645>,
      < 5.095855, -1.760986, 2.847925>
    }
    triangle {
      < 5.101185, -1.756843, 2.858135>,
      < 5.095855, -1.760986, 2.847925>,
      < 5.104347, -1.757434, 2.846415>
    }
    triangle {
      < 5.093173, -1.760080, 2.859645>,
      < 5.084210, -1.762718, 2.861027>,
      < 5.086355, -1.763883, 2.849307>
    }
    triangle {
      < 5.093173, -1.760080, 2.859645>,
      < 5.086355, -1.763883, 2.849307>,
      < 5.095855, -1.760986, 2.847925>
    }
    triangle {
      < 5.084210, -1.762718, 2.861027>,
      < 5.074708, -1.765537, 2.862041>,
      < 5.076283, -1.766977, 2.850321>
    }
    triangle {
      < 5.084210, -1.762718, 2.861027>,
      < 5.076283, -1.766977, 2.850321>,
      < 5.086355, -1.763883, 2.849307>
    }
    triangle {
      < 5.074708, -1.765537, 2.862041>,
      < 5.064253, -1.768208, 2.862690>,
      < 5.065201, -1.769908, 2.850970>
    }
    triangle {
      < 5.074708, -1.765537, 2.862041>,
      < 5.065201, -1.769908, 2.850970>,
      < 5.076283, -1.766977, 2.850321>
    }
    triangle {
      < 5.064253, -1.768208, 2.862690>,
      < 5.054595, -1.770488, 2.862842>,
      < 5.054963, -1.772411, 2.851121>
    }
    triangle {
      < 5.064253, -1.768208, 2.862690>,
      < 5.054963, -1.772411, 2.851121>,
      < 5.065201, -1.769908, 2.850970>
    }
    triangle {
      < 5.054595, -1.770488, 2.862842>,
      < 5.042328, -1.770489, 2.862842>,
      < 5.041962, -1.772412, 2.851122>
    }
    triangle {
      < 5.054595, -1.770488, 2.862842>,
      < 5.041962, -1.772412, 2.851122>,
      < 5.054963, -1.772411, 2.851121>
    }
    triangle {
      < 5.042328, -1.770489, 2.862842>,
      < 5.032659, -1.768216, 2.862690>,
      < 5.031713, -1.769917, 2.850970>
    }
    triangle {
      < 5.042328, -1.770489, 2.862842>,
      < 5.031713, -1.769917, 2.850970>,
      < 5.041962, -1.772412, 2.851122>
    }
    triangle {
      < 5.032659, -1.768216, 2.862690>,
      < 5.022200, -1.765548, 2.862041>,
      < 5.020626, -1.766988, 2.850321>
    }
    triangle {
      < 5.032659, -1.768216, 2.862690>,
      < 5.020626, -1.766988, 2.850321>,
      < 5.031713, -1.769917, 2.850970>
    }
    triangle {
      < 5.022200, -1.765548, 2.862041>,
      < 5.012692, -1.762733, 2.861027>,
      < 5.010549, -1.763898, 2.849308>
    }
    triangle {
      < 5.022200, -1.765548, 2.862041>,
      < 5.010549, -1.763898, 2.849308>,
      < 5.020626, -1.766988, 2.850321>
    }
    triangle {
      < 5.012692, -1.762733, 2.861027>,
      < 5.003972, -1.760332, 2.859672>,
      < 5.001306, -1.761263, 2.847952>
    }
    triangle {
      < 5.012692, -1.762733, 2.861027>,
      < 5.001306, -1.761263, 2.847952>,
      < 5.010549, -1.763898, 2.849308>
    }
    triangle {
      < 5.003972, -1.760332, 2.859672>,
      < 4.995708, -1.756862, 2.858134>,
      < 4.992546, -1.757454, 2.846414>
    }
    triangle {
      < 5.003972, -1.760332, 2.859672>,
      < 4.992546, -1.757454, 2.846414>,
      < 5.001306, -1.761263, 2.847952>
    }
    triangle {
      < 4.995708, -1.756862, 2.858134>,
      < 4.988314, -1.753199, 2.856466>,
      < 4.984708, -1.753434, 2.844745>
    }
    triangle {
      < 4.995708, -1.756862, 2.858134>,
      < 4.984708, -1.753434, 2.844745>,
      < 4.992546, -1.757454, 2.846414>
    }
    triangle {
      < 4.988314, -1.753199, 2.856466>,
      < 4.981918, -1.750338, 2.854733>,
      < 4.977930, -1.750294, 2.843013>
    }
    triangle {
      < 4.988314, -1.753199, 2.856466>,
      < 4.977930, -1.750294, 2.843013>,
      < 4.984708, -1.753434, 2.844745>
    }
    triangle {
      < 4.981918, -1.750338, 2.854733>,
      < 4.976361, -1.747370, 2.853045>,
      < 4.972040, -1.747036, 2.841324>
    }
    triangle {
      < 4.981918, -1.750338, 2.854733>,
      < 4.972040, -1.747036, 2.841324>,
      < 4.977930, -1.750294, 2.843013>
    }
    triangle {
      < 4.976361, -1.747370, 2.853045>,
      < 4.972147, -1.744860, 2.851635>,
      < 4.967573, -1.744281, 2.839914>
    }
    triangle {
      < 4.976361, -1.747370, 2.853045>,
      < 4.967573, -1.744281, 2.839914>,
      < 4.972040, -1.747036, 2.841324>
    }
    triangle {
      < 4.972147, -1.744860, 2.851635>,
      < 4.969071, -1.742587, 2.850533>,
      < 4.964313, -1.741786, 2.838813>
    }
    triangle {
      < 4.972147, -1.744860, 2.851635>,
      < 4.964313, -1.741786, 2.838813>,
      < 4.967573, -1.744281, 2.839914>
    }
    triangle {
      < 4.969071, -1.742587, 2.850533>,
      < 4.967145, -1.739766, 2.849810>,
      < 4.962271, -1.738689, 2.838090>
    }
    triangle {
      < 4.969071, -1.742587, 2.850533>,
      < 4.962271, -1.738689, 2.838090>,
      < 4.964313, -1.741786, 2.838813>
    }
    triangle {
      < 4.967145, -1.739766, 2.849810>,
      < 4.966541, -1.737136, 2.849557>,
      < 4.961631, -1.735803, 2.837837>
    }
    triangle {
      < 4.967145, -1.739766, 2.849810>,
      < 4.961631, -1.735803, 2.837837>,
      < 4.962271, -1.738689, 2.838090>
    }
    triangle {
      < 4.966541, -1.737136, 2.849557>,
      < 4.969771, -1.730384, 2.850608>,
      < 4.965055, -1.728392, 2.838888>
    }
    triangle {
      < 4.966541, -1.737136, 2.849557>,
      < 4.965055, -1.728392, 2.838888>,
      < 4.961631, -1.735803, 2.837837>
    }
    triangle {
      < 4.969771, -1.730384, 2.850608>,
      < 4.975648, -1.723348, 2.852286>,
      < 4.971284, -1.720668, 2.840566>
    }
    triangle {
      < 4.969771, -1.730384, 2.850608>,
      < 4.971284, -1.720668, 2.840566>,
      < 4.965055, -1.728392, 2.838888>
    }
    triangle {
      < 4.975648, -1.723348, 2.852286>,
      < 4.969537, -1.713619, 2.848997>,
      < 4.964806, -1.709989, 2.837276>
    }
    triangle {
      < 4.975648, -1.723348, 2.852286>,
      < 4.964806, -1.709989, 2.837276>,
      < 4.971284, -1.720668, 2.840566>
    }
    triangle {
      < 4.969537, -1.713619, 2.848997>,
      < 4.982264, -1.713125, 2.853366>,
      < 4.978296, -1.709448, 2.841646>
    }
    triangle {
      < 4.969537, -1.713619, 2.848997>,
      < 4.978296, -1.709448, 2.841646>,
      < 4.964806, -1.709989, 2.837276>
    }
    triangle {
      < 4.982264, -1.713125, 2.853366>,
      < 4.990989, -1.712705, 2.856261>,
      < 4.992498, -1.708987, 2.845354>
    }
    triangle {
      < 4.982264, -1.713125, 2.853366>,
      < 4.992498, -1.708987, 2.845354>,
      < 4.978296, -1.709448, 2.841646>
    }
    triangle {
      < 4.990989, -1.712705, 2.856261>,
      < 5.003711, -1.722026, 2.859843>,
      < 5.004886, -1.719217, 2.848936>
    }
    triangle {
      < 4.990989, -1.712705, 2.856261>,
      < 5.004886, -1.719217, 2.848936>,
      < 4.992498, -1.708987, 2.845354>
    }
    triangle {
      < 5.003711, -1.722026, 2.859843>,
      < 5.020807, -1.721872, 2.862770>,
      < 5.019150, -1.719049, 2.851049>
    }
    triangle {
      < 5.003711, -1.722026, 2.859843>,
      < 5.019150, -1.719049, 2.851049>,
      < 5.004886, -1.719217, 2.848936>
    }
    triangle {
      < 5.020807, -1.721872, 2.862770>,
      < 5.034548, -1.721778, 2.864064>,
      < 5.033715, -1.718945, 2.852345>
    }
    triangle {
      < 5.020807, -1.721872, 2.862770>,
      < 5.033715, -1.718945, 2.852345>,
      < 5.019150, -1.719049, 2.851049>
    }
    triangle {
      < 5.034548, -1.721778, 2.864064>,
      < 5.048435, -1.721745, 2.864501>,
      < 5.048434, -1.718909, 2.852781>
    }
    triangle {
      < 5.034548, -1.721778, 2.864064>,
      < 5.048434, -1.718909, 2.852781>,
      < 5.033715, -1.718945, 2.852345>
    }
    triangle {
      < 5.048435, -1.721745, 2.864501>,
      < 5.062322, -1.721775, 2.864065>,
      < 5.063154, -1.718942, 2.852345>
    }
    triangle {
      < 5.048435, -1.721745, 2.864501>,
      < 5.063154, -1.718942, 2.852345>,
      < 5.048434, -1.718909, 2.852781>
    }
    triangle {
      < 5.062322, -1.721775, 2.864065>,
      < 5.076063, -1.721867, 2.862772>,
      < 5.077719, -1.719043, 2.851051>
    }
    triangle {
      < 5.062322, -1.721775, 2.864065>,
      < 5.077719, -1.719043, 2.851051>,
      < 5.063154, -1.718942, 2.852345>
    }
    triangle {
      < 5.076063, -1.721867, 2.862772>,
      < 5.093158, -1.722017, 2.859846>,
      < 5.091983, -1.719208, 2.848939>
    }
    triangle {
      < 5.076063, -1.721867, 2.862772>,
      < 5.091983, -1.719208, 2.848939>,
      < 5.077719, -1.719043, 2.851051>
    }
    triangle {
      < 5.093158, -1.722017, 2.859846>,
      < 5.105880, -1.712695, 2.856265>,
      < 5.104371, -1.708975, 2.845357>
    }
    triangle {
      < 5.093158, -1.722017, 2.859846>,
      < 5.104371, -1.708975, 2.845357>,
      < 5.091983, -1.719208, 2.848939>
    }
    triangle {
      < 5.105880, -1.712695, 2.856265>,
      < 5.114612, -1.713105, 2.853368>,
      < 5.118579, -1.709425, 2.841648>
    }
    triangle {
      < 5.105880, -1.712695, 2.856265>,
      < 5.118579, -1.709425, 2.841648>,
      < 5.104371, -1.708975, 2.845357>
    }
    triangle {
      < 5.114612, -1.713105, 2.853368>,
      < 5.127343, -1.713589, 2.848996>,
      < 5.132073, -1.709956, 2.837276>
    }
    triangle {
      < 5.114612, -1.713105, 2.853368>,
      < 5.132073, -1.709956, 2.837276>,
      < 5.118579, -1.709425, 2.841648>
    }
    triangle {
      < 5.127343, -1.713589, 2.848996>,
      < 5.121234, -1.723317, 2.852286>,
      < 5.125597, -1.720634, 2.840566>
    }
    triangle {
      < 5.127343, -1.713589, 2.848996>,
      < 5.125597, -1.720634, 2.840566>,
      < 5.132073, -1.709956, 2.837276>
    }
    triangle {
      < 5.121234, -1.723317, 2.852286>,
      < 5.127112, -1.730358, 2.850609>,
      < 5.131828, -1.728363, 2.838889>
    }
    triangle {
      < 5.121234, -1.723317, 2.852286>,
      < 5.131828, -1.728363, 2.838889>,
      < 5.125597, -1.720634, 2.840566>
    }
    triangle {
      < 5.127112, -1.730358, 2.850609>,
      < 5.130343, -1.737099, 2.849559>,
      < 5.135253, -1.735762, 2.837839>
    }
    triangle {
      < 5.127112, -1.730358, 2.850609>,
      < 5.135253, -1.735762, 2.837839>,
      < 5.131828, -1.728363, 2.838889>
    }
    triangle {
      < 5.130343, -1.737099, 2.849559>,
      < 5.129738, -1.739747, 2.849813>,
      < 5.134612, -1.738668, 2.838093>
    }
    triangle {
      < 5.130343, -1.737099, 2.849559>,
      < 5.134612, -1.738668, 2.838093>,
      < 5.135253, -1.735762, 2.837839>
    }
    triangle {
      < 5.129738, -1.739747, 2.849813>,
      < 5.127812, -1.742571, 2.850535>,
      < 5.132570, -1.741768, 2.838815>
    }
    triangle {
      < 5.129738, -1.739747, 2.849813>,
      < 5.132570, -1.741768, 2.838815>,
      < 5.134612, -1.738668, 2.838093>
    }
    texture {brims}
  }
  // rfrim
  union {
    triangle {
      < -4.498979, -1.628912, -2.828054>,
      < -4.514218, -1.629982, -2.828054>,
      < -4.515183, -1.623114, -2.842164>
    }
    triangle {
      < -4.513028, -1.518169, -2.813766>,
      < -4.515183, -1.623114, -2.842164>,
      < -4.529768, -1.519337, -2.813766>
    }
    triangle {
      < -4.513028, -1.518169, -2.813766>,
      < -4.529768, -1.519337, -2.813766>,
      < -4.544351, -1.415561, -2.769109>
    }
    triangle {
      < -4.513028, -1.518169, -2.813766>,
      < -4.544351, -1.415561, -2.769109>,
      < -4.506346, -1.413064, -2.769109>
    }
    triangle {
      < -4.506346, -1.413064, -2.769109>,
      < -4.498977, -1.399683, -2.756803>,
      < -4.498978, -1.514298, -2.792428>
    }
    triangle {
      < -4.506346, -1.413064, -2.769109>,
      < -4.498978, -1.514298, -2.792428>,
      < -4.513028, -1.518169, -2.813766>
    }
    triangle {
      < -4.498977, -1.399683, -2.756803>,
      < -4.546118, -1.402983, -2.756803>,
      < -4.549065, -1.382018, -2.779159>
    }
    triangle {
      < -4.498977, -1.399683, -2.756803>,
      < -4.549065, -1.382018, -2.779159>,
      < -4.498977, -1.378512, -2.779159>
    }
    triangle {
      < -4.498977, -1.378512, -2.779159>,
      < -4.549065, -1.382018, -2.779159>,
      < -4.550430, -1.295944, -2.764932>
    }
    triangle {
      < -4.498977, -1.378512, -2.779159>,
      < -4.550430, -1.295944, -2.764932>,
      < -4.498977, -1.293829, -2.764932>
    }
    triangle {
      < -4.498977, -1.293829, -2.764932>,
      < -4.550430, -1.295944, -2.764932>,
      < -4.554622, -1.259871, -2.663333>
    }
    triangle {
      < -4.498977, -1.293829, -2.764932>,
      < -4.554622, -1.259871, -2.663333>,
      < -4.498974, -1.257585, -2.663333>
    }
    triangle {
      < -4.498974, -1.257585, -2.663333>,
      < -4.554622, -1.259871, -2.663333>,
      < -4.577441, -1.180085, -2.663332>
    }
    triangle {
      < -4.498974, -1.257585, -2.663333>,
      < -4.577441, -1.180085, -2.663332>,
      < -4.498974, -1.174595, -2.663332>
    }
    triangle {
      < -4.498974, -1.174595, -2.663332>,
      < -4.577441, -1.180085, -2.663332>,
      < -4.578528, -1.172370, -2.744609>
    }
    triangle {
      < -4.498974, -1.174595, -2.663332>,
      < -4.578528, -1.172370, -2.744609>,
      < -4.498976, -1.166804, -2.744609>
    }
    triangle {
      < -4.498976, -1.166804, -2.744609>,
      < -4.578528, -1.172370, -2.744609>,
      < -4.587367, -1.109476, -2.736479>
    }
    triangle {
      < -4.498976, -1.166804, -2.744609>,
      < -4.587367, -1.109476, -2.736479>,
      < -4.498976, -1.103292, -2.736479>
    }
    triangle {
      < -4.498976, -1.103292, -2.736479>,
      < -4.587367, -1.109476, -2.736479>,
      < -4.587376, -1.109391, -2.633340>
    }
    triangle {
      < -4.498976, -1.103292, -2.736479>,
      < -4.587376, -1.109391, -2.633340>,
      < -4.498973, -1.103207, -2.633340>
    }
    triangle {
      < -4.514218, -1.629982, -2.828054>,
      < -4.529160, -1.633162, -2.828054>,
      < -4.531072, -1.626495, -2.842164>
    }
    triangle {
      < -4.514218, -1.629982, -2.828054>,
      < -4.531072, -1.626495, -2.842164>,
      < -4.515183, -1.623114, -2.842164>
    }
    triangle {
      < -4.515183, -1.623114, -2.842164>,
      < -4.531072, -1.626495, -2.842164>,
      < -4.559957, -1.525758, -2.813766>
    }
    triangle {
      < -4.515183, -1.623114, -2.842164>,
      < -4.559957, -1.525758, -2.813766>,
      < -4.529768, -1.519337, -2.813766>
    }
    triangle {
      < -4.529768, -1.519337, -2.813766>,
      < -4.559957, -1.525758, -2.813766>,
      < -4.588841, -1.425021, -2.769109>
    }
    triangle {
      < -4.529768, -1.519337, -2.813766>,
      < -4.588841, -1.425021, -2.769109>,
      < -4.544351, -1.415561, -2.769109>
    }
    triangle {
      < -4.544351, -1.415561, -2.769109>,
      < -4.588841, -1.425021, -2.769109>,
      < -4.592341, -1.412811, -2.756803>
    }
    triangle {
      < -4.544351, -1.415561, -2.769109>,
      < -4.592341, -1.412811, -2.756803>,
      < -4.546118, -1.402983, -2.756803>
    }
    triangle {
      < -4.546118, -1.402983, -2.756803>,
      < -4.592341, -1.412811, -2.756803>,
      < -4.598177, -1.392461, -2.779159>
    }
    triangle {
      < -4.546118, -1.402983, -2.756803>,
      < -4.598177, -1.392461, -2.779159>,
      < -4.549065, -1.382018, -2.779159>
    }
    triangle {
      < -4.600038, -1.326766, -2.768997>,
      < -4.598177, -1.392461, -2.779159>,
      < -4.631938, -1.313273, -2.764932>
    }
    triangle {
      < -4.608274, -1.293206, -2.663333>,
      < -4.600038, -1.326766, -2.768997>,
      < -4.631938, -1.313273, -2.764932>
    }
    triangle {
      < -4.608274, -1.293206, -2.663333>,
      < -4.631938, -1.313273, -2.764932>,
      < -4.642776, -1.278613, -2.663333>
    }
    triangle {
      < -4.580204, -1.287238, -2.663333>,
      < -4.608274, -1.293206, -2.663333>,
      < -4.642776, -1.278613, -2.663333>
    }
    triangle {
      < -4.580204, -1.287238, -2.663333>,
      < -4.642776, -1.278613, -2.663333>,
      < -4.554622, -1.259871, -2.663333>
    }
    triangle {
      < -4.577441, -1.180085, -2.663332>,
      < -4.654381, -1.196442, -2.663332>,
      < -4.656530, -1.188953, -2.744609>
    }
    triangle {
      < -4.577441, -1.180085, -2.663332>,
      < -4.656530, -1.188953, -2.744609>,
      < -4.578528, -1.172370, -2.744609>
    }
    triangle {
      < -4.578528, -1.172370, -2.744609>,
      < -4.656530, -1.188953, -2.744609>,
      < -4.674037, -1.127901, -2.736479>
    }
    triangle {
      < -4.578528, -1.172370, -2.744609>,
      < -4.674037, -1.127901, -2.736479>,
      < -4.587367, -1.109476, -2.736479>
    }
    triangle {
      < -4.587367, -1.109476, -2.736479>,
      < -4.674037, -1.127901, -2.736479>,
      < -4.674057, -1.127819, -2.633340>
    }
    triangle {
      < -4.587367, -1.109476, -2.736479>,
      < -4.674057, -1.127819, -2.633340>,
      < -4.587376, -1.109391, -2.633340>
    }
    triangle {
      < -4.529160, -1.633162, -2.828054>,
      < -4.543515, -1.638390, -2.828054>,
      < -4.546336, -1.632054, -2.842164>
    }
    triangle {
      < -4.529160, -1.633162, -2.828054>,
      < -4.546336, -1.632054, -2.842164>,
      < -4.531072, -1.626495, -2.842164>
    }
    triangle {
      < -4.531072, -1.626495, -2.842164>,
      < -4.546336, -1.632054, -2.842164>,
      < -4.588959, -1.536317, -2.813766>
    }
    triangle {
      < -4.531072, -1.626495, -2.842164>,
      < -4.588959, -1.536317, -2.813766>,
      < -4.559957, -1.525758, -2.813766>
    }
    triangle {
      < -4.559957, -1.525758, -2.813766>,
      < -4.588959, -1.536317, -2.813766>,
      < -4.631582, -1.440581, -2.769109>
    }
    triangle {
      < -4.559957, -1.525758, -2.813766>,
      < -4.631582, -1.440581, -2.769109>,
      < -4.588841, -1.425021, -2.769109>
    }
    triangle {
      < -4.588841, -1.425021, -2.769109>,
      < -4.631582, -1.440581, -2.769109>,
      < -4.636747, -1.428977, -2.756803>
    }
    triangle {
      < -4.588841, -1.425021, -2.769109>,
      < -4.636747, -1.428977, -2.756803>,
      < -4.592341, -1.412811, -2.756803>
    }
    triangle {
      < -4.592341, -1.412811, -2.756803>,
      < -4.636747, -1.428977, -2.756803>,
      < -4.645359, -1.409637, -2.779159>
    }
    triangle {
      < -4.592341, -1.412811, -2.756803>,
      < -4.645359, -1.409637, -2.779159>,
      < -4.598177, -1.392461, -2.779159>
    }
    triangle {
      < -4.598177, -1.392461, -2.779159>,
      < -4.645359, -1.409637, -2.779159>,
      < -4.679802, -1.332274, -2.764932>
    }
    triangle {
      < -4.598177, -1.392461, -2.779159>,
      < -4.679802, -1.332274, -2.764932>,
      < -4.631938, -1.313273, -2.764932>
    }
    triangle {
      < -4.631938, -1.313273, -2.764932>,
      < -4.679802, -1.332274, -2.764932>,
      < -4.694541, -1.299162, -2.663333>
    }
    triangle {
      < -4.631938, -1.313273, -2.764932>,
      < -4.694541, -1.299162, -2.663333>,
      < -4.642776, -1.278613, -2.663333>
    }
    triangle {
      < -4.642776, -1.278613, -2.663333>,
      < -4.694541, -1.299162, -2.663333>,
      < -4.728295, -1.223347, -2.663332>
    }
    triangle {
      < -4.642776, -1.278613, -2.663333>,
      < -4.728295, -1.223347, -2.663332>,
      < -4.654381, -1.196442, -2.663332>
    }
    triangle {
      < -4.654381, -1.196442, -2.663332>,
      < -4.728295, -1.223347, -2.663332>,
      < -4.731466, -1.216231, -2.744609>
    }
    triangle {
      < -4.654381, -1.196442, -2.663332>,
      < -4.731466, -1.216231, -2.744609>,
      < -4.656530, -1.188953, -2.744609>
    }
    triangle {
      < -4.656530, -1.188953, -2.744609>,
      < -4.731466, -1.216231, -2.744609>,
      < -4.757298, -1.158209, -2.736479>
    }
    triangle {
      < -4.656530, -1.188953, -2.744609>,
      < -4.757298, -1.158209, -2.736479>,
      < -4.674037, -1.127901, -2.736479>
    }
    triangle {
      < -4.674037, -1.127901, -2.736479>,
      < -4.757298, -1.158209, -2.736479>,
      < -4.757330, -1.158131, -2.633340>
    }
    triangle {
      < -4.674037, -1.127901, -2.736479>,
      < -4.757330, -1.158131, -2.633340>,
      < -4.674057, -1.127819, -2.633340>
    }
    triangle {
      < -4.543515, -1.638390, -2.828054>,
      < -4.557002, -1.645565, -2.828054>,
      < -4.560678, -1.639683, -2.842164>
    }
    triangle {
      < -4.543515, -1.638390, -2.828054>,
      < -4.560678, -1.639683, -2.842164>,
      < -4.546336, -1.632054, -2.842164>
    }
    triangle {
      < -4.546336, -1.632054, -2.842164>,
      < -4.560678, -1.639683, -2.842164>,
      < -4.616210, -1.550811, -2.813766>
    }
    triangle {
      < -4.546336, -1.632054, -2.842164>,
      < -4.616210, -1.550811, -2.813766>,
      < -4.588959, -1.536317, -2.813766>
    }
    triangle {
      < -4.588959, -1.536317, -2.813766>,
      < -4.616210, -1.550811, -2.813766>,
      < -4.671741, -1.461937, -2.769109>
    }
    triangle {
      < -4.588959, -1.536317, -2.813766>,
      < -4.671741, -1.461937, -2.769109>,
      < -4.631582, -1.440581, -2.769109>
    }
    triangle {
      < -4.631582, -1.440581, -2.769109>,
      < -4.671741, -1.461937, -2.769109>,
      < -4.678472, -1.451166, -2.756803>
    }
    triangle {
      < -4.631582, -1.440581, -2.769109>,
      < -4.678472, -1.451166, -2.756803>,
      < -4.636747, -1.428977, -2.756803>
    }
    triangle {
      < -4.636747, -1.428977, -2.756803>,
      < -4.678472, -1.451166, -2.756803>,
      < -4.689691, -1.433212, -2.779159>
    }
    triangle {
      < -4.636747, -1.428977, -2.756803>,
      < -4.689691, -1.433212, -2.779159>,
      < -4.645359, -1.409637, -2.779159>
    }
    triangle {
      < -4.645359, -1.409637, -2.779159>,
      < -4.689691, -1.433212, -2.779159>,
      < -4.725947, -1.355134, -2.764932>
    }
    triangle {
      < -4.645359, -1.409637, -2.779159>,
      < -4.725947, -1.355134, -2.764932>,
      < -4.679802, -1.332274, -2.764932>
    }
    triangle {
      < -4.679802, -1.332274, -2.764932>,
      < -4.725947, -1.355134, -2.764932>,
      < -4.744448, -1.323885, -2.663333>
    }
    triangle {
      < -4.679802, -1.332274, -2.764932>,
      < -4.744448, -1.323885, -2.663333>,
      < -4.694541, -1.299162, -2.663333>
    }
    triangle {
      < -4.694541, -1.299162, -2.663333>,
      < -4.744448, -1.323885, -2.663333>,
      < -4.797746, -1.260278, -2.663332>
    }
    triangle {
      < -4.694541, -1.299162, -2.663333>,
      < -4.797746, -1.260278, -2.663332>,
      < -4.728295, -1.223347, -2.663332>
    }
    triangle {
      < -4.728295, -1.223347, -2.663332>,
      < -4.797746, -1.260278, -2.663332>,
      < -4.801876, -1.253672, -2.744609>
    }
    triangle {
      < -4.728295, -1.223347, -2.663332>,
      < -4.801876, -1.253672, -2.744609>,
      < -4.731466, -1.216231, -2.744609>
    }
    triangle {
      < -4.731466, -1.216231, -2.744609>,
      < -4.801876, -1.253672, -2.744609>,
      < -4.835532, -1.199810, -2.736479>
    }
    triangle {
      < -4.731466, -1.216231, -2.744609>,
      < -4.835532, -1.199810, -2.736479>,
      < -4.757298, -1.158209, -2.736479>
    }
    triangle {
      < -4.757298, -1.158209, -2.736479>,
      < -4.835532, -1.199810, -2.736479>,
      < -4.835575, -1.199736, -2.633340>
    }
    triangle {
      < -4.757298, -1.158209, -2.736479>,
      < -4.835575, -1.199736, -2.633340>,
      < -4.757330, -1.158131, -2.633340>
    }
    triangle {
      < -4.557002, -1.645565, -2.828054>,
      < -4.569359, -1.654548, -2.828054>,
      < -4.573817, -1.649235, -2.842164>
    }
    triangle {
      < -4.557002, -1.645565, -2.828054>,
      < -4.573817, -1.649235, -2.842164>,
      < -4.560678, -1.639683, -2.842164>
    }
    triangle {
      < -4.560678, -1.639683, -2.842164>,
      < -4.573817, -1.649235, -2.842164>,
      < -4.641178, -1.568955, -2.813766>
    }
    triangle {
      < -4.560678, -1.639683, -2.842164>,
      < -4.641178, -1.568955, -2.813766>,
      < -4.616210, -1.550811, -2.813766>
    }
    triangle {
      < -4.616210, -1.550811, -2.813766>,
      < -4.641178, -1.568955, -2.813766>,
      < -4.708537, -1.488675, -2.769109>
    }
    triangle {
      < -4.616210, -1.550811, -2.813766>,
      < -4.708537, -1.488675, -2.769109>,
      < -4.671741, -1.461937, -2.769109>
    }
    triangle {
      < -4.671741, -1.461937, -2.769109>,
      < -4.708537, -1.488675, -2.769109>,
      < -4.716701, -1.478945, -2.756803>
    }
    triangle {
      < -4.671741, -1.461937, -2.769109>,
      < -4.716701, -1.478945, -2.756803>,
      < -4.678472, -1.451166, -2.756803>
    }
    triangle {
      < -4.678472, -1.451166, -2.756803>,
      < -4.716701, -1.478945, -2.756803>,
      < -4.730310, -1.462727, -2.779159>
    }
    triangle {
      < -4.678472, -1.451166, -2.756803>,
      < -4.730310, -1.462727, -2.779159>,
      < -4.689691, -1.433212, -2.779159>
    }
    triangle {
      < -4.758729, -1.403468, -2.768997>,
      < -4.730310, -1.462727, -2.779159>,
      < -4.793360, -1.404117, -2.764932>
    }
    triangle {
      < -4.779903, -1.376160, -2.663333>,
      < -4.758729, -1.403468, -2.768997>,
      < -4.793360, -1.404117, -2.764932>
    }
    triangle {
      < -4.779903, -1.376160, -2.663333>,
      < -4.793360, -1.404117, -2.764932>,
      < -4.817358, -1.376861, -2.663333>
    }
    triangle {
      < -4.756687, -1.359290, -2.663333>,
      < -4.779903, -1.376160, -2.663333>,
      < -4.817358, -1.376861, -2.663333>
    }
    triangle {
      < -4.756687, -1.359290, -2.663333>,
      < -4.817358, -1.376861, -2.663333>,
      < -4.744448, -1.323885, -2.663333>
    }
    triangle {
      < -4.797746, -1.260278, -2.663332>,
      < -4.861381, -1.306514, -2.663332>,
      < -4.866391, -1.300547, -2.744609>
    }
    triangle {
      < -4.797746, -1.260278, -2.663332>,
      < -4.866391, -1.300547, -2.744609>,
      < -4.801876, -1.253672, -2.744609>
    }
    triangle {
      < -4.801876, -1.253672, -2.744609>,
      < -4.866391, -1.300547, -2.744609>,
      < -4.907215, -1.251893, -2.736479>
    }
    triangle {
      < -4.801876, -1.253672, -2.744609>,
      < -4.907215, -1.251893, -2.736479>,
      < -4.835532, -1.199810, -2.736479>
    }
    triangle {
      < -4.835532, -1.199810, -2.736479>,
      < -4.907215, -1.251893, -2.736479>,
      < -4.907267, -1.251827, -2.633340>
    }
    triangle {
      < -4.835532, -1.199810, -2.736479>,
      < -4.907267, -1.251827, -2.633340>,
      < -4.835575, -1.199736, -2.633340>
    }
    triangle {
      < -4.569359, -1.654548, -2.828054>,
      < -4.580346, -1.665163, -2.828054>,
      < -4.585500, -1.660522, -2.842164>
    }
    triangle {
      < -4.569359, -1.654548, -2.828054>,
      < -4.585500, -1.660522, -2.842164>,
      < -4.573817, -1.649235, -2.842164>
    }
    triangle {
      < -4.573817, -1.649235, -2.842164>,
      < -4.585500, -1.660522, -2.842164>,
      < -4.663377, -1.590398, -2.813766>
    }
    triangle {
      < -4.573817, -1.649235, -2.842164>,
      < -4.663377, -1.590398, -2.813766>,
      < -4.641178, -1.568955, -2.813766>
    }
    triangle {
      < -4.641178, -1.568955, -2.813766>,
      < -4.663377, -1.590398, -2.813766>,
      < -4.741254, -1.520274, -2.769109>
    }
    triangle {
      < -4.641178, -1.568955, -2.813766>,
      < -4.741254, -1.520274, -2.769109>,
      < -4.708537, -1.488675, -2.769109>
    }
    triangle {
      < -4.708537, -1.488675, -2.769109>,
      < -4.741254, -1.520274, -2.769109>,
      < -4.750693, -1.511774, -2.756803>
    }
    triangle {
      < -4.708537, -1.488675, -2.769109>,
      < -4.750693, -1.511774, -2.756803>,
      < -4.716701, -1.478945, -2.756803>
    }
    triangle {
      < -4.716701, -1.478945, -2.756803>,
      < -4.750693, -1.511774, -2.756803>,
      < -4.766426, -1.497608, -2.779159>
    }
    triangle {
      < -4.716701, -1.478945, -2.756803>,
      < -4.766426, -1.497608, -2.779159>,
      < -4.730310, -1.462727, -2.779159>
    }
    triangle {
      < -4.730310, -1.462727, -2.779159>,
      < -4.766426, -1.497608, -2.779159>,
      < -4.829357, -1.440943, -2.764932>
    }
    triangle {
      < -4.730310, -1.462727, -2.779159>,
      < -4.829357, -1.440943, -2.764932>,
      < -4.793360, -1.404117, -2.764932>
    }
    triangle {
      < -4.793360, -1.404117, -2.764932>,
      < -4.829357, -1.440943, -2.764932>,
      < -4.856290, -1.416689, -2.663333>
    }
    triangle {
      < -4.793360, -1.404117, -2.764932>,
      < -4.856290, -1.416689, -2.663333>,
      < -4.817358, -1.376861, -2.663333>
    }
    triangle {
      < -4.817358, -1.376861, -2.663333>,
      < -4.856290, -1.416689, -2.663333>,
      < -4.917962, -1.361157, -2.663332>
    }
    triangle {
      < -4.817358, -1.376861, -2.663333>,
      < -4.917962, -1.361157, -2.663332>,
      < -4.861381, -1.306514, -2.663332>
    }
    triangle {
      < -4.861381, -1.306514, -2.663332>,
      < -4.917962, -1.361157, -2.663332>,
      < -4.923753, -1.355945, -2.744609>
    }
    triangle {
      < -4.861381, -1.306514, -2.663332>,
      < -4.923753, -1.355945, -2.744609>,
      < -4.866391, -1.300547, -2.744609>
    }
    triangle {
      < -4.866391, -1.300547, -2.744609>,
      < -4.923753, -1.355945, -2.744609>,
      < -4.970952, -1.313446, -2.736479>
    }
    triangle {
      < -4.866391, -1.300547, -2.744609>,
      < -4.970952, -1.313446, -2.736479>,
      < -4.907215, -1.251893, -2.736479>
    }
    triangle {
      < -4.907215, -1.251893, -2.736479>,
      < -4.970952, -1.313446, -2.736479>,
      < -4.971013, -1.313388, -2.633340>
    }
    triangle {
      < -4.907215, -1.251893, -2.736479>,
      < -4.971013, -1.313388, -2.633340>,
      < -4.907267, -1.251827, -2.633340>
    }
    triangle {
      < -4.580346, -1.665163, -2.828054>,
      < -4.589748, -1.677203, -2.828054>,
      < -4.595499, -1.673325, -2.842164>
    }
    triangle {
      < -4.580346, -1.665163, -2.828054>,
      < -4.595499, -1.673325, -2.842164>,
      < -4.585500, -1.660522, -2.842164>
    }
    triangle {
      < -4.585500, -1.660522, -2.842164>,
      < -4.595499, -1.673325, -2.842164>,
      < -4.682377, -1.614722, -2.813766>
    }
    triangle {
      < -4.585500, -1.660522, -2.842164>,
      < -4.682377, -1.614722, -2.813766>,
      < -4.663377, -1.590398, -2.813766>
    }
    triangle {
      < -4.663377, -1.590398, -2.813766>,
      < -4.682377, -1.614722, -2.813766>,
      < -4.769255, -1.556118, -2.769109>
    }
    triangle {
      < -4.663377, -1.590398, -2.813766>,
      < -4.769255, -1.556118, -2.769109>,
      < -4.741254, -1.520274, -2.769109>
    }
    triangle {
      < -4.741254, -1.520274, -2.769109>,
      < -4.769255, -1.556118, -2.769109>,
      < -4.779785, -1.549015, -2.756803>
    }
    triangle {
      < -4.741254, -1.520274, -2.769109>,
      < -4.779785, -1.549015, -2.756803>,
      < -4.750693, -1.511774, -2.756803>
    }
    triangle {
      < -4.750693, -1.511774, -2.756803>,
      < -4.779785, -1.549015, -2.756803>,
      < -4.797337, -1.537177, -2.779159>
    }
    triangle {
      < -4.750693, -1.511774, -2.756803>,
      < -4.797337, -1.537177, -2.779159>,
      < -4.766426, -1.497608, -2.779159>
    }
    triangle {
      < -4.766426, -1.497608, -2.779159>,
      < -4.797337, -1.537177, -2.779159>,
      < -4.862215, -1.480595, -2.764932>
    }
    triangle {
      < -4.766426, -1.497608, -2.779159>,
      < -4.862215, -1.480595, -2.764932>,
      < -4.829357, -1.440943, -2.764932>
    }
    triangle {
      < -4.829357, -1.440943, -2.764932>,
      < -4.862215, -1.480595, -2.764932>,
      < -4.891827, -1.459573, -2.663333>
    }
    triangle {
      < -4.829357, -1.440943, -2.764932>,
      < -4.891827, -1.459573, -2.663333>,
      < -4.856290, -1.416689, -2.663333>
    }
    triangle {
      < -4.856290, -1.416689, -2.663333>,
      < -4.891827, -1.459573, -2.663333>,
      < -4.966388, -1.423142, -2.663332>
    }
    triangle {
      < -4.856290, -1.416689, -2.663333>,
      < -4.966388, -1.423142, -2.663332>,
      < -4.917962, -1.361157, -2.663332>
    }
    triangle {
      < -4.917962, -1.361157, -2.663332>,
      < -4.966388, -1.423142, -2.663332>,
      < -4.972848, -1.418787, -2.744609>
    }
    triangle {
      < -4.917962, -1.361157, -2.663332>,
      < -4.972848, -1.418787, -2.744609>,
      < -4.923753, -1.355945, -2.744609>
    }
    triangle {
      < -4.923753, -1.355945, -2.744609>,
      < -4.972848, -1.418787, -2.744609>,
      < -5.025502, -1.383270, -2.736479>
    }
    triangle {
      < -4.923753, -1.355945, -2.744609>,
      < -5.025502, -1.383270, -2.736479>,
      < -4.970952, -1.313446, -2.736479>
    }
    triangle {
      < -4.970952, -1.313446, -2.736479>,
      < -5.025502, -1.383270, -2.736479>,
      < -5.025570, -1.383221, -2.633340>
    }
    triangle {
      < -4.970952, -1.313446, -2.736479>,
      < -5.025570, -1.383221, -2.633340>,
      < -4.971013, -1.313388, -2.633340>
    }
    triangle {
      < -4.589748, -1.677203, -2.828054>,
      < -4.597384, -1.690435, -2.828054>,
      < -4.603618, -1.687395, -2.842164>
    }
    triangle {
      < -4.589748, -1.677203, -2.828054>,
      < -4.603618, -1.687395, -2.842164>,
      < -4.595499, -1.673325, -2.842164>
    }
    triangle {
      < -4.595499, -1.673325, -2.842164>,
      < -4.603618, -1.687395, -2.842164>,
      < -4.697807, -1.641453, -2.813766>
    }
    triangle {
      < -4.595499, -1.673325, -2.842164>,
      < -4.697807, -1.641453, -2.813766>,
      < -4.682377, -1.614722, -2.813766>
    }
    triangle {
      < -4.682377, -1.614722, -2.813766>,
      < -4.697807, -1.641453, -2.813766>,
      < -4.791996, -1.595510, -2.769109>
    }
    triangle {
      < -4.682377, -1.614722, -2.813766>,
      < -4.791996, -1.595510, -2.769109>,
      < -4.769255, -1.556118, -2.769109>
    }
    triangle {
      < -4.769255, -1.556118, -2.769109>,
      < -4.791996, -1.595510, -2.769109>,
      < -4.803411, -1.589942, -2.756803>
    }
    triangle {
      < -4.769255, -1.556118, -2.769109>,
      < -4.803411, -1.589942, -2.756803>,
      < -4.779785, -1.549015, -2.756803>
    }
    triangle {
      < -4.779785, -1.549015, -2.756803>,
      < -4.803411, -1.589942, -2.756803>,
      < -4.822440, -1.580661, -2.779159>
    }
    triangle {
      < -4.779785, -1.549015, -2.756803>,
      < -4.822440, -1.580661, -2.779159>,
      < -4.797337, -1.537177, -2.779159>
    }
    triangle {
      < -4.872504, -1.538084, -2.768997>,
      < -4.822440, -1.580661, -2.779159>,
      < -4.903878, -1.552763, -2.764932>
    }
    triangle {
      < -4.902955, -1.521749, -2.663333>,
      < -4.872504, -1.538084, -2.768997>,
      < -4.903878, -1.552763, -2.764932>
    }
    triangle {
      < -4.902955, -1.521749, -2.663333>,
      < -4.903878, -1.552763, -2.764932>,
      < -4.936887, -1.537623, -2.663333>
    }
    triangle {
      < -4.888607, -1.496895, -2.663333>,
      < -4.902955, -1.521749, -2.663333>,
      < -4.936887, -1.537623, -2.663333>
    }
    triangle {
      < -4.888607, -1.496895, -2.663333>,
      < -4.936887, -1.537623, -2.663333>,
      < -4.891827, -1.459573, -2.663333>
    }
    triangle {
      < -4.966388, -1.423142, -2.663332>,
      < -5.005716, -1.491264, -2.663332>,
      < -5.012719, -1.487850, -2.744609>
    }
    triangle {
      < -4.966388, -1.423142, -2.663332>,
      < -5.012719, -1.487850, -2.744609>,
      < -4.972848, -1.418787, -2.744609>
    }
    triangle {
      < -4.972848, -1.418787, -2.744609>,
      < -5.012719, -1.487850, -2.744609>,
      < -5.069803, -1.460007, -2.736479>
    }
    triangle {
      < -4.972848, -1.418787, -2.744609>,
      < -5.069803, -1.460007, -2.736479>,
      < -5.025502, -1.383270, -2.736479>
    }
    triangle {
      < -5.025502, -1.383270, -2.736479>,
      < -5.069803, -1.460007, -2.736479>,
      < -5.069879, -1.459967, -2.633340>
    }
    triangle {
      < -5.025502, -1.383270, -2.736479>,
      < -5.069879, -1.459967, -2.633340>,
      < -5.025570, -1.383221, -2.633340>
    }
    triangle {
      < -4.597384, -1.690435, -2.828054>,
      < -4.603104, -1.704601, -2.828054>,
      < -4.609700, -1.702458, -2.842164>
    }
    triangle {
      < -4.597384, -1.690435, -2.828054>,
      < -4.609700, -1.702458, -2.842164>,
      < -4.603618, -1.687395, -2.842164>
    }
    triangle {
      < -4.603618, -1.687395, -2.842164>,
      < -4.609700, -1.702458, -2.842164>,
      < -4.709366, -1.670071, -2.813766>
    }
    triangle {
      < -4.603618, -1.687395, -2.842164>,
      < -4.709366, -1.670071, -2.813766>,
      < -4.697807, -1.641453, -2.813766>
    }
    triangle {
      < -4.697807, -1.641453, -2.813766>,
      < -4.709366, -1.670071, -2.813766>,
      < -4.809032, -1.637684, -2.769109>
    }
    triangle {
      < -4.697807, -1.641453, -2.813766>,
      < -4.809032, -1.637684, -2.769109>,
      < -4.791996, -1.595510, -2.769109>
    }
    triangle {
      < -4.791996, -1.595510, -2.769109>,
      < -4.809032, -1.637684, -2.769109>,
      < -4.821112, -1.633759, -2.756803>
    }
    triangle {
      < -4.791996, -1.595510, -2.769109>,
      < -4.821112, -1.633759, -2.756803>,
      < -4.803411, -1.589942, -2.756803>
    }
    triangle {
      < -4.803411, -1.589942, -2.756803>,
      < -4.821112, -1.633759, -2.756803>,
      < -4.841246, -1.627217, -2.779159>
    }
    triangle {
      < -4.803411, -1.589942, -2.756803>,
      < -4.841246, -1.627217, -2.779159>,
      < -4.822440, -1.580661, -2.779159>
    }
    triangle {
      < -4.822440, -1.580661, -2.779159>,
      < -4.841246, -1.627217, -2.779159>,
      < -4.921784, -1.601046, -2.764932>
    }
    triangle {
      < -4.822440, -1.580661, -2.779159>,
      < -4.921784, -1.601046, -2.764932>,
      < -4.903878, -1.552763, -2.764932>
    }
    triangle {
      < -4.903878, -1.552763, -2.764932>,
      < -4.921784, -1.601046, -2.764932>,
      < -4.956254, -1.589843, -2.663333>
    }
    triangle {
      < -4.903878, -1.552763, -2.764932>,
      < -4.956254, -1.589843, -2.663333>,
      < -4.936887, -1.537623, -2.663333>
    }
    triangle {
      < -4.936887, -1.537623, -2.663333>,
      < -4.956254, -1.589843, -2.663333>,
      < -5.035181, -1.564196, -2.663332>
    }
    triangle {
      < -4.936887, -1.537623, -2.663333>,
      < -5.035181, -1.564196, -2.663332>,
      < -5.005716, -1.491264, -2.663332>
    }
    triangle {
      < -5.005716, -1.491264, -2.663332>,
      < -5.035181, -1.564196, -2.663332>,
      < -5.042591, -1.561790, -2.744609>
    }
    triangle {
      < -5.005716, -1.491264, -2.663332>,
      < -5.042591, -1.561790, -2.744609>,
      < -5.012719, -1.487850, -2.744609>
    }
    triangle {
      < -5.012719, -1.487850, -2.744609>,
      < -5.042591, -1.561790, -2.744609>,
      < -5.102994, -1.542162, -2.736479>
    }
    triangle {
      < -5.012719, -1.487850, -2.744609>,
      < -5.102994, -1.542162, -2.736479>,
      < -5.069803, -1.460007, -2.736479>
    }
    triangle {
      < -5.069803, -1.460007, -2.736479>,
      < -5.102994, -1.542162, -2.736479>,
      < -5.103074, -1.542133, -2.633340>
    }
    triangle {
      < -5.069803, -1.460007, -2.736479>,
      < -5.103074, -1.542133, -2.633340>,
      < -5.069879, -1.459967, -2.633340>
    }
    triangle {
      < -4.603104, -1.704601, -2.828054>,
      < -4.606796, -1.719425, -2.828054>,
      < -4.613626, -1.718220, -2.842164>
    }
    triangle {
      < -4.603104, -1.704601, -2.828054>,
      < -4.613626, -1.718220, -2.842164>,
      < -4.609700, -1.702458, -2.842164>
    }
    triangle {
      < -4.609700, -1.702458, -2.842164>,
      < -4.613626, -1.718220, -2.842164>,
      < -4.716830, -1.700020, -2.813766>
    }
    triangle {
      < -4.609700, -1.702458, -2.842164>,
      < -4.716830, -1.700020, -2.813766>,
      < -4.709366, -1.670071, -2.813766>
    }
    triangle {
      < -4.709366, -1.670071, -2.813766>,
      < -4.716830, -1.700020, -2.813766>,
      < -4.820034, -1.681818, -2.769109>
    }
    triangle {
      < -4.709366, -1.670071, -2.813766>,
      < -4.820034, -1.681818, -2.769109>,
      < -4.809032, -1.637684, -2.769109>
    }
    triangle {
      < -4.809032, -1.637684, -2.769109>,
      < -4.820034, -1.681818, -2.769109>,
      < -4.832542, -1.679612, -2.756803>
    }
    triangle {
      < -4.809032, -1.637684, -2.769109>,
      < -4.832542, -1.679612, -2.756803>,
      < -4.821112, -1.633759, -2.756803>
    }
    triangle {
      < -4.821112, -1.633759, -2.756803>,
      < -4.832542, -1.679612, -2.756803>,
      < -4.853391, -1.675936, -2.779159>
    }
    triangle {
      < -4.821112, -1.633759, -2.756803>,
      < -4.853391, -1.675936, -2.779159>,
      < -4.841246, -1.627217, -2.779159>
    }
    triangle {
      < -4.841246, -1.627217, -2.779159>,
      < -4.853391, -1.675936, -2.779159>,
      < -4.935674, -1.650634, -2.764932>
    }
    triangle {
      < -4.841246, -1.627217, -2.779159>,
      < -4.935674, -1.650634, -2.764932>,
      < -4.921784, -1.601046, -2.764932>
    }
    triangle {
      < -4.921784, -1.601046, -2.764932>,
      < -4.935674, -1.650634, -2.764932>,
      < -4.971276, -1.643473, -2.663333>
    }
    triangle {
      < -4.921784, -1.601046, -2.764932>,
      < -4.971276, -1.643473, -2.663333>,
      < -4.956254, -1.589843, -2.663333>
    }
    triangle {
      < -4.956254, -1.589843, -2.663333>,
      < -4.971276, -1.643473, -2.663333>,
      < -5.054209, -1.640519, -2.663332>
    }
    triangle {
      < -4.956254, -1.589843, -2.663333>,
      < -5.054209, -1.640519, -2.663332>,
      < -5.035181, -1.564196, -2.663332>
    }
    triangle {
      < -5.035181, -1.564196, -2.663332>,
      < -5.054209, -1.640519, -2.663332>,
      < -5.061882, -1.639168, -2.744609>
    }
    triangle {
      < -5.035181, -1.564196, -2.663332>,
      < -5.061882, -1.639168, -2.744609>,
      < -5.042591, -1.561790, -2.744609>
    }
    triangle {
      < -5.042591, -1.561790, -2.744609>,
      < -5.061882, -1.639168, -2.744609>,
      < -5.124429, -1.628137, -2.736479>
    }
    triangle {
      < -5.042591, -1.561790, -2.744609>,
      < -5.124429, -1.628137, -2.736479>,
      < -5.102994, -1.542162, -2.736479>
    }
    triangle {
      < -5.102994, -1.542162, -2.736479>,
      < -5.124429, -1.628137, -2.736479>,
      < -5.124512, -1.628120, -2.633340>
    }
    triangle {
      < -5.102994, -1.542162, -2.736479>,
      < -5.124512, -1.628120, -2.633340>,
      < -5.103074, -1.542133, -2.633340>
    }
    triangle {
      < -4.606796, -1.719425, -2.828054>,
      < -4.608390, -1.734618, -2.828054>,
      < -4.615321, -1.734376, -2.842164>
    }
    triangle {
      < -4.606796, -1.719425, -2.828054>,
      < -4.615321, -1.734376, -2.842164>,
      < -4.613626, -1.718220, -2.842164>
    }
    triangle {
      < -4.613626, -1.718220, -2.842164>,
      < -4.615321, -1.734376, -2.842164>,
      < -4.720053, -1.730716, -2.813766>
    }
    triangle {
      < -4.613626, -1.718220, -2.842164>,
      < -4.720053, -1.730716, -2.813766>,
      < -4.716830, -1.700020, -2.813766>
    }
    triangle {
      < -4.716830, -1.700020, -2.813766>,
      < -4.720053, -1.730716, -2.813766>,
      < -4.824786, -1.727054, -2.769109>
    }
    triangle {
      < -4.716830, -1.700020, -2.813766>,
      < -4.824786, -1.727054, -2.769109>,
      < -4.820034, -1.681818, -2.769109>
    }
    triangle {
      < -4.820034, -1.681818, -2.769109>,
      < -4.824786, -1.727054, -2.769109>,
      < -4.837479, -1.726610, -2.756803>
    }
    triangle {
      < -4.820034, -1.681818, -2.769109>,
      < -4.837479, -1.726610, -2.756803>,
      < -4.832542, -1.679612, -2.756803>
    }
    triangle {
      < -4.832542, -1.679612, -2.756803>,
      < -4.837479, -1.726610, -2.756803>,
      < -4.858637, -1.725872, -2.779159>
    }
    triangle {
      < -4.832542, -1.679612, -2.756803>,
      < -4.858637, -1.725872, -2.779159>,
      < -4.853391, -1.675936, -2.779159>
    }
    triangle {
      < -4.921691, -1.707338, -2.768997>,
      < -4.858637, -1.725872, -2.779159>,
      < -4.944382, -1.733508, -2.764932>
    }
    triangle {
      < -4.956154, -1.704800, -2.663333>,
      < -4.921691, -1.707338, -2.768997>,
      < -4.944382, -1.733508, -2.764932>
    }
    triangle {
      < -4.956154, -1.704800, -2.663333>,
      < -4.944382, -1.733508, -2.764932>,
      < -4.980695, -1.733103, -2.663333>
    }
    triangle {
      < -4.953155, -1.676260, -2.663333>,
      < -4.956154, -1.704800, -2.663333>,
      < -4.980695, -1.733103, -2.663333>
    }
    triangle {
      < -4.953155, -1.676260, -2.663333>,
      < -4.980695, -1.733103, -2.663333>,
      < -4.971276, -1.643473, -2.663333>
    }
    triangle {
      < -5.054209, -1.640519, -2.663332>,
      < -5.062430, -1.718747, -2.663332>,
      < -5.070216, -1.718477, -2.744609>
    }
    triangle {
      < -5.054209, -1.640519, -2.663332>,
      < -5.070216, -1.718477, -2.744609>,
      < -5.061882, -1.639168, -2.744609>
    }
    triangle {
      < -5.061882, -1.639168, -2.744609>,
      < -5.070216, -1.718477, -2.744609>,
      < -5.133690, -1.716258, -2.736479>
    }
    triangle {
      < -5.061882, -1.639168, -2.744609>,
      < -5.133690, -1.716258, -2.736479>,
      < -5.124429, -1.628137, -2.736479>
    }
    triangle {
      < -5.124429, -1.628137, -2.736479>,
      < -5.133690, -1.716258, -2.736479>,
      < -5.133774, -1.716253, -2.633340>
    }
    triangle {
      < -5.124429, -1.628137, -2.736479>,
      < -5.133774, -1.716253, -2.633340>,
      < -5.124512, -1.628120, -2.633340>
    }
    triangle {
      < -4.608390, -1.734618, -2.828054>,
      < -4.607853, -1.749886, -2.828054>,
      < -4.614751, -1.750611, -2.842164>
    }
    triangle {
      < -4.608390, -1.734618, -2.828054>,
      < -4.614751, -1.750611, -2.842164>,
      < -4.615321, -1.734376, -2.842164>
    }
    triangle {
      < -4.615321, -1.734376, -2.842164>,
      < -4.614751, -1.750611, -2.842164>,
      < -4.718974, -1.761561, -2.813766>
    }
    triangle {
      < -4.615321, -1.734376, -2.842164>,
      < -4.718974, -1.761561, -2.813766>,
      < -4.720053, -1.730716, -2.813766>
    }
    triangle {
      < -4.720053, -1.730716, -2.813766>,
      < -4.718974, -1.761561, -2.813766>,
      < -4.823196, -1.772511, -2.769109>
    }
    triangle {
      < -4.720053, -1.730716, -2.813766>,
      < -4.823196, -1.772511, -2.769109>,
      < -4.824786, -1.727054, -2.769109>
    }
    triangle {
      < -4.824786, -1.727054, -2.769109>,
      < -4.823196, -1.772511, -2.769109>,
      < -4.835828, -1.773839, -2.756803>
    }
    triangle {
      < -4.824786, -1.727054, -2.769109>,
      < -4.835828, -1.773839, -2.756803>,
      < -4.837479, -1.726610, -2.756803>
    }
    triangle {
      < -4.837479, -1.726610, -2.756803>,
      < -4.835828, -1.773839, -2.756803>,
      < -4.856883, -1.776051, -2.779159>
    }
    triangle {
      < -4.837479, -1.726610, -2.756803>,
      < -4.856883, -1.776051, -2.779159>,
      < -4.858637, -1.725872, -2.779159>
    }
    triangle {
      < -4.858637, -1.725872, -2.779159>,
      < -4.856883, -1.776051, -2.779159>,
      < -4.941102, -1.784901, -2.764932>
    }
    triangle {
      < -4.858637, -1.725872, -2.779159>,
      < -4.941102, -1.784901, -2.764932>,
      < -4.944382, -1.733508, -2.764932>
    }
    triangle {
      < -4.944382, -1.733508, -2.764932>,
      < -4.941102, -1.784901, -2.764932>,
      < -4.977149, -1.788685, -2.663333>
    }
    triangle {
      < -4.944382, -1.733508, -2.764932>,
      < -4.977149, -1.788685, -2.663333>,
      < -4.980695, -1.733103, -2.663333>
    }
    triangle {
      < -4.980695, -1.733103, -2.663333>,
      < -4.977149, -1.788685, -2.663333>,
      < -5.059684, -1.797358, -2.663332>
    }
    triangle {
      < -4.980695, -1.733103, -2.663333>,
      < -5.059684, -1.797358, -2.663332>,
      < -5.062430, -1.718747, -2.663332>
    }
    triangle {
      < -5.062430, -1.718747, -2.663332>,
      < -5.059684, -1.797358, -2.663332>,
      < -5.067432, -1.798174, -2.744609>
    }
    triangle {
      < -5.062430, -1.718747, -2.663332>,
      < -5.067432, -1.798174, -2.744609>,
      < -5.070216, -1.718477, -2.744609>
    }
    triangle {
      < -5.070216, -1.718477, -2.744609>,
      < -5.067432, -1.798174, -2.744609>,
      < -5.130596, -1.804811, -2.736479>
    }
    triangle {
      < -5.070216, -1.718477, -2.744609>,
      < -5.130596, -1.804811, -2.736479>,
      < -5.133690, -1.716258, -2.736479>
    }
    triangle {
      < -5.133690, -1.716258, -2.736479>,
      < -5.130596, -1.804811, -2.736479>,
      < -5.130681, -1.804817, -2.633340>
    }
    triangle {
      < -5.133690, -1.716258, -2.736479>,
      < -5.130681, -1.804817, -2.633340>,
      < -5.133774, -1.716253, -2.633340>
    }
    triangle {
      < -4.607853, -1.749886, -2.828054>,
      < -4.605197, -1.764930, -2.828054>,
      < -4.611927, -1.766608, -2.842164>
    }
    triangle {
      < -4.607853, -1.749886, -2.828054>,
      < -4.611927, -1.766608, -2.842164>,
      < -4.614751, -1.750611, -2.842164>
    }
    triangle {
      < -4.614751, -1.750611, -2.842164>,
      < -4.611927, -1.766608, -2.842164>,
      < -4.713611, -1.791957, -2.813766>
    }
    triangle {
      < -4.614751, -1.750611, -2.842164>,
      < -4.713611, -1.791957, -2.813766>,
      < -4.718974, -1.761561, -2.813766>
    }
    triangle {
      < -4.718974, -1.761561, -2.813766>,
      < -4.713611, -1.791957, -2.813766>,
      < -4.815295, -1.817305, -2.769109>
    }
    triangle {
      < -4.718974, -1.761561, -2.813766>,
      < -4.815295, -1.817305, -2.769109>,
      < -4.823196, -1.772511, -2.769109>
    }
    triangle {
      < -4.823196, -1.772511, -2.769109>,
      < -4.815295, -1.817305, -2.769109>,
      < -4.827620, -1.820377, -2.756803>
    }
    triangle {
      < -4.823196, -1.772511, -2.769109>,
      < -4.827620, -1.820377, -2.756803>,
      < -4.835828, -1.773839, -2.756803>
    }
    triangle {
      < -4.835828, -1.773839, -2.756803>,
      < -4.827620, -1.820377, -2.756803>,
      < -4.848162, -1.825499, -2.779159>
    }
    triangle {
      < -4.835828, -1.773839, -2.756803>,
      < -4.848162, -1.825499, -2.779159>,
      < -4.856883, -1.776051, -2.779159>
    }
    triangle {
      < -4.856883, -1.776051, -2.779159>,
      < -4.848162, -1.825499, -2.779159>,
      < -4.933622, -1.835851, -2.764932>
    }
    triangle {
      < -4.856883, -1.776051, -2.779159>,
      < -4.933622, -1.835851, -2.764932>,
      < -4.941102, -1.784901, -2.764932>
    }
    triangle {
      < -4.941102, -1.784901, -2.764932>,
      < -4.933622, -1.835851, -2.764932>,
      < -4.969059, -1.843790, -2.663333>
    }
    triangle {
      < -4.941102, -1.784901, -2.764932>,
      < -4.969059, -1.843790, -2.663333>,
      < -4.977149, -1.788685, -2.663333>
    }
    triangle {
      < -4.977149, -1.788685, -2.663333>,
      < -4.969059, -1.843790, -2.663333>,
      < -5.046024, -1.874822, -2.663332>
    }
    triangle {
      < -4.977149, -1.788685, -2.663333>,
      < -5.046024, -1.874822, -2.663332>,
      < -5.059684, -1.797358, -2.663332>
    }
    triangle {
      < -5.059684, -1.797358, -2.663332>,
      < -5.046024, -1.874822, -2.663332>,
      < -5.053583, -1.876708, -2.744609>
    }
    triangle {
      < -5.059684, -1.797358, -2.663332>,
      < -5.053583, -1.876708, -2.744609>,
      < -5.067432, -1.798174, -2.744609>
    }
    triangle {
      < -5.067432, -1.798174, -2.744609>,
      < -5.053583, -1.876708, -2.744609>,
      < -5.115209, -1.892071, -2.736479>
    }
    triangle {
      < -5.067432, -1.798174, -2.744609>,
      < -5.115209, -1.892071, -2.736479>,
      < -5.130596, -1.804811, -2.736479>
    }
    triangle {
      < -5.130596, -1.804811, -2.736479>,
      < -5.115209, -1.892071, -2.736479>,
      < -5.115292, -1.892089, -2.633340>
    }
    triangle {
      < -5.130596, -1.804811, -2.736479>,
      < -5.115292, -1.892089, -2.633340>,
      < -5.130681, -1.804817, -2.633340>
    }
    triangle {
      < -4.605197, -1.764930, -2.828054>,
      < -4.600473, -1.779458, -2.828054>,
      < -4.606904, -1.782057, -2.842164>
    }
    triangle {
      < -4.605197, -1.764930, -2.828054>,
      < -4.606904, -1.782057, -2.842164>,
      < -4.611927, -1.766608, -2.842164>
    }
    triangle {
      < -4.611927, -1.766608, -2.842164>,
      < -4.606904, -1.782057, -2.842164>,
      < -4.704071, -1.821310, -2.813766>
    }
    triangle {
      < -4.611927, -1.766608, -2.842164>,
      < -4.704071, -1.821310, -2.813766>,
      < -4.713611, -1.791957, -2.813766>
    }
    triangle {
      < -4.713611, -1.791957, -2.813766>,
      < -4.704071, -1.821310, -2.813766>,
      < -4.801238, -1.860563, -2.769109>
    }
    triangle {
      < -4.713611, -1.791957, -2.813766>,
      < -4.801238, -1.860563, -2.769109>,
      < -4.815295, -1.817305, -2.769109>
    }
    triangle {
      < -4.815295, -1.817305, -2.769109>,
      < -4.801238, -1.860563, -2.769109>,
      < -4.813015, -1.865320, -2.756803>
    }
    triangle {
      < -4.815295, -1.817305, -2.769109>,
      < -4.813015, -1.865320, -2.756803>,
      < -4.827620, -1.820377, -2.756803>
    }
    triangle {
      < -4.827620, -1.820377, -2.756803>,
      < -4.813015, -1.865320, -2.756803>,
      < -4.832644, -1.873251, -2.779159>
    }
    triangle {
      < -4.827620, -1.820377, -2.756803>,
      < -4.832644, -1.873251, -2.779159>,
      < -4.848162, -1.825499, -2.779159>
    }
    triangle {
      < -4.897785, -1.881966, -2.768997>,
      < -4.832644, -1.873251, -2.779159>,
      < -4.907870, -1.915102, -2.764932>
    }
    triangle {
      < -4.930300, -1.893664, -2.663333>,
      < -4.897785, -1.881966, -2.768997>,
      < -4.907870, -1.915102, -2.764932>
    }
    triangle {
      < -4.930300, -1.893664, -2.663333>,
      < -4.907870, -1.915102, -2.764932>,
      < -4.941208, -1.929502, -2.663333>
    }
    triangle {
      < -4.939169, -1.866371, -2.663333>,
      < -4.930300, -1.893664, -2.663333>,
      < -4.941208, -1.929502, -2.663333>
    }
    triangle {
      < -4.939169, -1.866371, -2.663333>,
      < -4.941208, -1.929502, -2.663333>,
      < -4.969059, -1.843790, -2.663333>
    }
    triangle {
      < -5.046024, -1.874822, -2.663332>,
      < -5.021717, -1.949631, -2.663332>,
      < -5.028939, -1.952551, -2.744609>
    }
    triangle {
      < -5.046024, -1.874822, -2.663332>,
      < -5.028939, -1.952551, -2.744609>,
      < -5.053583, -1.876708, -2.744609>
    }
    triangle {
      < -5.053583, -1.876708, -2.744609>,
      < -5.028939, -1.952551, -2.744609>,
      < -5.087828, -1.976341, -2.736479>
    }
    triangle {
      < -5.053583, -1.876708, -2.744609>,
      < -5.087828, -1.976341, -2.736479>,
      < -5.115209, -1.892071, -2.736479>
    }
    triangle {
      < -5.115209, -1.892071, -2.736479>,
      < -5.087828, -1.976341, -2.736479>,
      < -5.087907, -1.976370, -2.633340>
    }
    triangle {
      < -5.115209, -1.892071, -2.736479>,
      < -5.087907, -1.976370, -2.633340>,
      < -5.115292, -1.892089, -2.633340>
    }
    triangle {
      < -4.600473, -1.779458, -2.828054>,
      < -4.593773, -1.793188, -2.828054>,
      < -4.606904, -1.782057, -2.842164>
    }
    triangle {
      < -4.606904, -1.782057, -2.842164>,
      < -4.696710, -1.836390, -2.813766>,
      < -4.704071, -1.821310, -2.813766>
    }
    triangle {
      < -4.696710, -1.836390, -2.813766>,
      < -4.784394, -1.894722, -2.769109>,
      < -4.801238, -1.860563, -2.769109>
    }
    triangle {
      < -4.696710, -1.836390, -2.813766>,
      < -4.801238, -1.860563, -2.769109>,
      < -4.704071, -1.821310, -2.813766>
    }
    triangle {
      < -4.784394, -1.894722, -2.769109>,
      < -4.792297, -1.907794, -2.756803>,
      < -4.813015, -1.865320, -2.756803>
    }
    triangle {
      < -4.784394, -1.894722, -2.769109>,
      < -4.813015, -1.865320, -2.756803>,
      < -4.801238, -1.860563, -2.769109>
    }
    triangle {
      < -4.813015, -1.865320, -2.756803>,
      < -4.792297, -1.907794, -2.756803>,
      < -4.810631, -1.918379, -2.779159>
    }
    triangle {
      < -4.813015, -1.865320, -2.756803>,
      < -4.810631, -1.918379, -2.779159>,
      < -4.832644, -1.873251, -2.779159>
    }
    triangle {
      < -4.832644, -1.873251, -2.779159>,
      < -4.810631, -1.918379, -2.779159>,
      < -4.883971, -1.960718, -2.764932>
    }
    triangle {
      < -4.832644, -1.873251, -2.779159>,
      < -4.883971, -1.960718, -2.764932>,
      < -4.907870, -1.915102, -2.764932>
    }
    triangle {
      < -4.907870, -1.915102, -2.764932>,
      < -4.883971, -1.960718, -2.764932>,
      < -4.915361, -1.978837, -2.663333>
    }
    triangle {
      < -4.907870, -1.915102, -2.764932>,
      < -4.915361, -1.978837, -2.663333>,
      < -4.941208, -1.929502, -2.663333>
    }
    triangle {
      < -4.941208, -1.929502, -2.663333>,
      < -4.915361, -1.978837, -2.663333>,
      < -4.987234, -2.020329, -2.663332>
    }
    triangle {
      < -4.941208, -1.929502, -2.663333>,
      < -4.987234, -2.020329, -2.663332>,
      < -5.021717, -1.949631, -2.663332>
    }
    triangle {
      < -5.021717, -1.949631, -2.663332>,
      < -4.987234, -2.020329, -2.663332>,
      < -4.993980, -2.024226, -2.744609>
    }
    triangle {
      < -5.021717, -1.949631, -2.663332>,
      < -4.993980, -2.024226, -2.744609>,
      < -5.028939, -1.952551, -2.744609>
    }
    triangle {
      < -5.028939, -1.952551, -2.744609>,
      < -4.993980, -2.024226, -2.744609>,
      < -5.048985, -2.055980, -2.736479>
    }
    triangle {
      < -5.028939, -1.952551, -2.744609>,
      < -5.048985, -2.055980, -2.736479>,
      < -5.087828, -1.976341, -2.736479>
    }
    triangle {
      < -5.087828, -1.976341, -2.736479>,
      < -5.048985, -2.055980, -2.736479>,
      < -5.049059, -2.056020, -2.633340>
    }
    triangle {
      < -5.087828, -1.976341, -2.736479>,
      < -5.049059, -2.056020, -2.633340>,
      < -5.087907, -1.976370, -2.633340>
    }
    triangle {
      < -4.593773, -1.793188, -2.828054>,
      < -4.585228, -1.805851, -2.828054>,
      < -4.590693, -1.810121, -2.842164>
    }
    triangle {
      < -4.590693, -1.810121, -2.842164>,
      < -4.673277, -1.874636, -2.813766>,
      < -4.682658, -1.860723, -2.813766>
    }
    triangle {
      < -4.682658, -1.860723, -2.813766>,
      < -4.673277, -1.874636, -2.813766>,
      < -4.755860, -1.939151, -2.769109>
    }
    triangle {
      < -4.682658, -1.860723, -2.813766>,
      < -4.755860, -1.939151, -2.769109>,
      < -4.777024, -1.907486, -2.769109>
    }
    triangle {
      < -4.777024, -1.907486, -2.769109>,
      < -4.755860, -1.939151, -2.769109>,
      < -4.765870, -1.946970, -2.756803>
    }
    triangle {
      < -4.777024, -1.907486, -2.769109>,
      < -4.765870, -1.946970, -2.756803>,
      < -4.792297, -1.907794, -2.756803>
    }
    triangle {
      < -4.792297, -1.907794, -2.756803>,
      < -4.765870, -1.946970, -2.756803>,
      < -4.782553, -1.960004, -2.779159>
    }
    triangle {
      < -4.792297, -1.907794, -2.756803>,
      < -4.782553, -1.960004, -2.779159>,
      < -4.810631, -1.918379, -2.779159>
    }
    triangle {
      < -4.810631, -1.918379, -2.779159>,
      < -4.782553, -1.960004, -2.779159>,
      < -4.856414, -2.004221, -2.764932>
    }
    triangle {
      < -4.810631, -1.918379, -2.779159>,
      < -4.856414, -2.004221, -2.764932>,
      < -4.883971, -1.960718, -2.764932>
    }
    triangle {
      < -4.883971, -1.960718, -2.764932>,
      < -4.856414, -2.004221, -2.764932>,
      < -4.885559, -2.025887, -2.663333>
    }
    triangle {
      < -4.883971, -1.960718, -2.764932>,
      < -4.885559, -2.025887, -2.663333>,
      < -4.915361, -1.978837, -2.663333>
    }
    triangle {
      < -4.915361, -1.978837, -2.663333>,
      < -4.885559, -2.025887, -2.663333>,
      < -4.943248, -2.085540, -2.663332>
    }
    triangle {
      < -4.915361, -1.978837, -2.663333>,
      < -4.943248, -2.085540, -2.663332>,
      < -4.987234, -2.020329, -2.663332>
    }
    triangle {
      < -4.987234, -2.020329, -2.663332>,
      < -4.943248, -2.085540, -2.663332>,
      < -4.949387, -2.090338, -2.744609>
    }
    triangle {
      < -4.987234, -2.020329, -2.663332>,
      < -4.949387, -2.090338, -2.744609>,
      < -4.993980, -2.024226, -2.744609>
    }
    triangle {
      < -4.993980, -2.024226, -2.744609>,
      < -4.949387, -2.090338, -2.744609>,
      < -4.999436, -2.129438, -2.736479>
    }
    triangle {
      < -4.993980, -2.024226, -2.744609>,
      < -4.999436, -2.129438, -2.736479>,
      < -5.048985, -2.055980, -2.736479>
    }
    triangle {
      < -5.048985, -2.055980, -2.736479>,
      < -4.999436, -2.129438, -2.736479>,
      < -4.999505, -2.129488, -2.633340>
    }
    triangle {
      < -5.048985, -2.055980, -2.736479>,
      < -4.999505, -2.129488, -2.633340>,
      < -5.049059, -2.056020, -2.633340>
    }
    triangle {
      < -4.585228, -1.805851, -2.828054>,
      < -4.575004, -1.817202, -2.828054>,
      < -4.579822, -1.822191, -2.842164>
    }
    triangle {
      < -4.585228, -1.805851, -2.828054>,
      < -4.579822, -1.822191, -2.842164>,
      < -4.590693, -1.810121, -2.842164>
    }
    triangle {
      < -4.590693, -1.810121, -2.842164>,
      < -4.579822, -1.822191, -2.842164>,
      < -4.652623, -1.897572, -2.813766>
    }
    triangle {
      < -4.590693, -1.810121, -2.842164>,
      < -4.652623, -1.897572, -2.813766>,
      < -4.673277, -1.874636, -2.813766>
    }
    triangle {
      < -4.673277, -1.874636, -2.813766>,
      < -4.652623, -1.897572, -2.813766>,
      < -4.725424, -1.972952, -2.769109>
    }
    triangle {
      < -4.673277, -1.874636, -2.813766>,
      < -4.725424, -1.972952, -2.769109>,
      < -4.755860, -1.939151, -2.769109>
    }
    triangle {
      < -4.755860, -1.939151, -2.769109>,
      < -4.725424, -1.972952, -2.769109>,
      < -4.734248, -1.982088, -2.756803>
    }
    triangle {
      < -4.755860, -1.939151, -2.769109>,
      < -4.734248, -1.982088, -2.756803>,
      < -4.765870, -1.946970, -2.756803>
    }
    triangle {
      < -4.765870, -1.946970, -2.756803>,
      < -4.734248, -1.982088, -2.756803>,
      < -4.748954, -1.997317, -2.779159>
    }
    triangle {
      < -4.765870, -1.946970, -2.756803>,
      < -4.748954, -1.997317, -2.779159>,
      < -4.782553, -1.960004, -2.779159>
    }
    triangle {
      < -4.804919, -2.031773, -2.768997>,
      < -4.748954, -1.997317, -2.779159>,
      < -4.800654, -2.066147, -2.764932>
    }
    triangle {
      < -4.829865, -2.055685, -2.663333>,
      < -4.804919, -2.031773, -2.768997>,
      < -4.800654, -2.066147, -2.764932>
    }
    triangle {
      < -4.829865, -2.055685, -2.663333>,
      < -4.800654, -2.066147, -2.764932>,
      < -4.825254, -2.092861, -2.663333>
    }
    triangle {
      < -4.885559, -2.025887, -2.663333>,
      < -4.825254, -2.092861, -2.663333>,
      < -4.890615, -2.143995, -2.663332>
    }
    triangle {
      < -4.885559, -2.025887, -2.663333>,
      < -4.890615, -2.143995, -2.663332>,
      < -4.943248, -2.085540, -2.663332>
    }
    triangle {
      < -4.943248, -2.085540, -2.663332>,
      < -4.890615, -2.143995, -2.663332>,
      < -4.896026, -2.149601, -2.744609>
    }
    triangle {
      < -4.943248, -2.085540, -2.663332>,
      < -4.896026, -2.149601, -2.744609>,
      < -4.949387, -2.090338, -2.744609>
    }
    triangle {
      < -4.949387, -2.090338, -2.744609>,
      < -4.896026, -2.149601, -2.744609>,
      < -4.940147, -2.195286, -2.736479>
    }
    triangle {
      < -4.949387, -2.090338, -2.744609>,
      < -4.940147, -2.195286, -2.736479>,
      < -4.999436, -2.129438, -2.736479>
    }
    triangle {
      < -4.999436, -2.129438, -2.736479>,
      < -4.940147, -2.195286, -2.736479>,
      < -4.940208, -2.195345, -2.633340>
    }
    triangle {
      < -4.999436, -2.129438, -2.736479>,
      < -4.940208, -2.195345, -2.633340>,
      < -4.999505, -2.129488, -2.633340>
    }
    triangle {
      < -4.575004, -1.817202, -2.828054>,
      < -4.563299, -1.827019, -2.828054>,
      < -4.567376, -1.832631, -2.842164>
    }
    triangle {
      < -4.575004, -1.817202, -2.828054>,
      < -4.567376, -1.832631, -2.842164>,
      < -4.579822, -1.822191, -2.842164>
    }
    triangle {
      < -4.579822, -1.822191, -2.842164>,
      < -4.567376, -1.832631, -2.842164>,
      < -4.628977, -1.917409, -2.813766>
    }
    triangle {
      < -4.579822, -1.822191, -2.842164>,
      < -4.628977, -1.917409, -2.813766>,
      < -4.652623, -1.897572, -2.813766>
    }
    triangle {
      < -4.652623, -1.897572, -2.813766>,
      < -4.628977, -1.917409, -2.813766>,
      < -4.690579, -2.002188, -2.769109>
    }
    triangle {
      < -4.652623, -1.897572, -2.813766>,
      < -4.690579, -2.002188, -2.769109>,
      < -4.725424, -1.972952, -2.769109>
    }
    triangle {
      < -4.725424, -1.972952, -2.769109>,
      < -4.690579, -2.002188, -2.769109>,
      < -4.698046, -2.012463, -2.756803>
    }
    triangle {
      < -4.725424, -1.972952, -2.769109>,
      < -4.698046, -2.012463, -2.756803>,
      < -4.734248, -1.982088, -2.756803>
    }
    triangle {
      < -4.734248, -1.982088, -2.756803>,
      < -4.698046, -2.012463, -2.756803>,
      < -4.710490, -2.029590, -2.779159>
    }
    triangle {
      < -4.734248, -1.982088, -2.756803>,
      < -4.710490, -2.029590, -2.779159>,
      < -4.748954, -1.997317, -2.779159>
    }
    triangle {
      < -4.748954, -1.997317, -2.779159>,
      < -4.710490, -2.029590, -2.779159>,
      < -4.760269, -2.098098, -2.764932>
    }
    triangle {
      < -4.748954, -1.997317, -2.779159>,
      < -4.760269, -2.098098, -2.764932>,
      < -4.800654, -2.066147, -2.764932>
    }
    triangle {
      < -4.800654, -2.066147, -2.764932>,
      < -4.760269, -2.098098, -2.764932>,
      < -4.781576, -2.127418, -2.663333>
    }
    triangle {
      < -4.800654, -2.066147, -2.764932>,
      < -4.781576, -2.127418, -2.663333>,
      < -4.825254, -2.092861, -2.663333>
    }
    triangle {
      < -4.825254, -2.092861, -2.663333>,
      < -4.781576, -2.127418, -2.663333>,
      < -4.830359, -2.194556, -2.663332>
    }
    triangle {
      < -4.825254, -2.092861, -2.663333>,
      < -4.830359, -2.194556, -2.663332>,
      < -4.890615, -2.143995, -2.663332>
    }
    triangle {
      < -4.890615, -2.143995, -2.663332>,
      < -4.830359, -2.194556, -2.663332>,
      < -4.834937, -2.200860, -2.744609>
    }
    triangle {
      < -4.890615, -2.143995, -2.663332>,
      < -4.834937, -2.200860, -2.744609>,
      < -4.896026, -2.149601, -2.744609>
    }
    triangle {
      < -4.896026, -2.149601, -2.744609>,
      < -4.834937, -2.200860, -2.744609>,
      < -4.872271, -2.252241, -2.736479>
    }
    triangle {
      < -4.896026, -2.149601, -2.744609>,
      < -4.872271, -2.252241, -2.736479>,
      < -4.940147, -2.195286, -2.736479>
    }
    triangle {
      < -4.940147, -2.195286, -2.736479>,
      < -4.872271, -2.252241, -2.736479>,
      < -4.872323, -2.252308, -2.633340>
    }
    triangle {
      < -4.940147, -2.195286, -2.736479>,
      < -4.872323, -2.252308, -2.633340>,
      < -4.940208, -2.195345, -2.633340>
    }
    triangle {
      < -4.563299, -1.827019, -2.828054>,
      < -4.550342, -1.835112, -2.828054>,
      < -4.553597, -1.841236, -2.842164>
    }
    triangle {
      < -4.563299, -1.827019, -2.828054>,
      < -4.553597, -1.841236, -2.842164>,
      < -4.567376, -1.832631, -2.842164>
    }
    triangle {
      < -4.567376, -1.832631, -2.842164>,
      < -4.553597, -1.841236, -2.842164>,
      < -4.602801, -1.933763, -2.813766>
    }
    triangle {
      < -4.567376, -1.832631, -2.842164>,
      < -4.602801, -1.933763, -2.813766>,
      < -4.628977, -1.917409, -2.813766>
    }
    triangle {
      < -4.628977, -1.917409, -2.813766>,
      < -4.602801, -1.933763, -2.813766>,
      < -4.652005, -2.026290, -2.769109>
    }
    triangle {
      < -4.628977, -1.917409, -2.813766>,
      < -4.652005, -2.026290, -2.769109>,
      < -4.690579, -2.002188, -2.769109>
    }
    triangle {
      < -4.690579, -2.002188, -2.769109>,
      < -4.652005, -2.026290, -2.769109>,
      < -4.657969, -2.037504, -2.756803>
    }
    triangle {
      < -4.690579, -2.002188, -2.769109>,
      < -4.657969, -2.037504, -2.756803>,
      < -4.698046, -2.012463, -2.756803>
    }
    triangle {
      < -4.698046, -2.012463, -2.756803>,
      < -4.657969, -2.037504, -2.756803>,
      < -4.667908, -2.056197, -2.779159>
    }
    triangle {
      < -4.698046, -2.012463, -2.756803>,
      < -4.667908, -2.056197, -2.779159>,
      < -4.710490, -2.029590, -2.779159>
    }
    triangle {
      < -4.710490, -2.029590, -2.779159>,
      < -4.667908, -2.056197, -2.779159>,
      < -4.717400, -2.126633, -2.764932>
    }
    triangle {
      < -4.710490, -2.029590, -2.779159>,
      < -4.717400, -2.126633, -2.764932>,
      < -4.760269, -2.098098, -2.764932>
    }
    triangle {
      < -4.760269, -2.098098, -2.764932>,
      < -4.717400, -2.126633, -2.764932>,
      < -4.735213, -2.158279, -2.663333>
    }
    triangle {
      < -4.760269, -2.098098, -2.764932>,
      < -4.735213, -2.158279, -2.663333>,
      < -4.781576, -2.127418, -2.663333>
    }
    triangle {
      < -4.781576, -2.127418, -2.663333>,
      < -4.735213, -2.158279, -2.663333>,
      < -4.763652, -2.236239, -2.663332>
    }
    triangle {
      < -4.781576, -2.127418, -2.663333>,
      < -4.763652, -2.236239, -2.663332>,
      < -4.830359, -2.194556, -2.663332>
    }
    triangle {
      < -4.830359, -2.194556, -2.663332>,
      < -4.763652, -2.236239, -2.663332>,
      < -4.767308, -2.243119, -2.744609>
    }
    triangle {
      < -4.830359, -2.194556, -2.663332>,
      < -4.767308, -2.243119, -2.744609>,
      < -4.834937, -2.200860, -2.744609>
    }
    triangle {
      < -4.834937, -2.200860, -2.744609>,
      < -4.767308, -2.243119, -2.744609>,
      < -4.797128, -2.299196, -2.736479>
    }
    triangle {
      < -4.834937, -2.200860, -2.744609>,
      < -4.797128, -2.299196, -2.736479>,
      < -4.872271, -2.252241, -2.736479>
    }
    triangle {
      < -4.872271, -2.252241, -2.736479>,
      < -4.797128, -2.299196, -2.736479>,
      < -4.797171, -2.299269, -2.633340>
    }
    triangle {
      < -4.872271, -2.252241, -2.736479>,
      < -4.797171, -2.299269, -2.633340>,
      < -4.872323, -2.252308, -2.633340>
    }
    triangle {
      < -4.550342, -1.835112, -2.828054>,
      < -4.536384, -1.841323, -2.828054>,
      < -4.538756, -1.847841, -2.842164>
    }
    triangle {
      < -4.550342, -1.835112, -2.828054>,
      < -4.538756, -1.847841, -2.842164>,
      < -4.553597, -1.841236, -2.842164>
    }
    triangle {
      < -4.553597, -1.841236, -2.842164>,
      < -4.538756, -1.847841, -2.842164>,
      < -4.574604, -1.946315, -2.813766>
    }
    triangle {
      < -4.553597, -1.841236, -2.842164>,
      < -4.574604, -1.946315, -2.813766>,
      < -4.602801, -1.933763, -2.813766>
    }
    triangle {
      < -4.602801, -1.933763, -2.813766>,
      < -4.574604, -1.946315, -2.813766>,
      < -4.610452, -2.044789, -2.769109>
    }
    triangle {
      < -4.602801, -1.933763, -2.813766>,
      < -4.610452, -2.044789, -2.769109>,
      < -4.652005, -2.026290, -2.769109>
    }
    triangle {
      < -4.652005, -2.026290, -2.769109>,
      < -4.610452, -2.044789, -2.769109>,
      < -4.614797, -2.056724, -2.756803>
    }
    triangle {
      < -4.652005, -2.026290, -2.769109>,
      < -4.614797, -2.056724, -2.756803>,
      < -4.657969, -2.037504, -2.756803>
    }
    triangle {
      < -4.657969, -2.037504, -2.756803>,
      < -4.614797, -2.056724, -2.756803>,
      < -4.622038, -2.076618, -2.779159>
    }
    triangle {
      < -4.657969, -2.037504, -2.756803>,
      < -4.622038, -2.076618, -2.779159>,
      < -4.667908, -2.056197, -2.779159>
    }
    triangle {
      < -4.659151, -2.130858, -2.768997>,
      < -4.622038, -2.076618, -2.779159>,
      < -4.641274, -2.160526, -2.764932>
    }
    triangle {
      < -4.672215, -2.162849, -2.663333>,
      < -4.659151, -2.130858, -2.768997>,
      < -4.641274, -2.160526, -2.764932>
    }
    triangle {
      < -4.672215, -2.162849, -2.663333>,
      < -4.641274, -2.160526, -2.764932>,
      < -4.652881, -2.194936, -2.663333>
    }
    triangle {
      < -4.735213, -2.158279, -2.663333>,
      < -4.652881, -2.194936, -2.663333>,
      < -4.691794, -2.268233, -2.663332>
    }
    triangle {
      < -4.735213, -2.158279, -2.663333>,
      < -4.691794, -2.268233, -2.663332>,
      < -4.763652, -2.236239, -2.663332>
    }
    triangle {
      < -4.763652, -2.236239, -2.663332>,
      < -4.691794, -2.268233, -2.663332>,
      < -4.694457, -2.275555, -2.744609>
    }
    triangle {
      < -4.763652, -2.236239, -2.663332>,
      < -4.694457, -2.275555, -2.744609>,
      < -4.767308, -2.243119, -2.744609>
    }
    triangle {
      < -4.767308, -2.243119, -2.744609>,
      < -4.694457, -2.275555, -2.744609>,
      < -4.716183, -2.335236, -2.736479>
    }
    triangle {
      < -4.767308, -2.243119, -2.744609>,
      < -4.716183, -2.335236, -2.736479>,
      < -4.797128, -2.299196, -2.736479>
    }
    triangle {
      < -4.797128, -2.299196, -2.736479>,
      < -4.716183, -2.335236, -2.736479>,
      < -4.716214, -2.335315, -2.633340>
    }
    triangle {
      < -4.797128, -2.299196, -2.736479>,
      < -4.716214, -2.335315, -2.633340>,
      < -4.797171, -2.299269, -2.633340>
    }
    triangle {
      < -4.536384, -1.841323, -2.828054>,
      < -4.521698, -1.845531, -2.828054>,
      < -4.523140, -1.852316, -2.842164>
    }
    triangle {
      < -4.536384, -1.841323, -2.828054>,
      < -4.523140, -1.852316, -2.842164>,
      < -4.538756, -1.847841, -2.842164>
    }
    triangle {
      < -4.538756, -1.847841, -2.842164>,
      < -4.523140, -1.852316, -2.842164>,
      < -4.544934, -1.954820, -2.813766>
    }
    triangle {
      < -4.538756, -1.847841, -2.842164>,
      < -4.544934, -1.954820, -2.813766>,
      < -4.574604, -1.946315, -2.813766>
    }
    triangle {
      < -4.574604, -1.946315, -2.813766>,
      < -4.544934, -1.954820, -2.813766>,
      < -4.566729, -2.057325, -2.769109>
    }
    triangle {
      < -4.574604, -1.946315, -2.813766>,
      < -4.566729, -2.057325, -2.769109>,
      < -4.610452, -2.044789, -2.769109>
    }
    triangle {
      < -4.610452, -2.044789, -2.769109>,
      < -4.566729, -2.057325, -2.769109>,
      < -4.569371, -2.069749, -2.756803>
    }
    triangle {
      < -4.610452, -2.044789, -2.769109>,
      < -4.569371, -2.069749, -2.756803>,
      < -4.614797, -2.056724, -2.756803>
    }
    triangle {
      < -4.614797, -2.056724, -2.756803>,
      < -4.569371, -2.069749, -2.756803>,
      < -4.573772, -2.090457, -2.779159>
    }
    triangle {
      < -4.614797, -2.056724, -2.756803>,
      < -4.573772, -2.090457, -2.779159>,
      < -4.622038, -2.076618, -2.779159>
    }
    triangle {
      < -4.622038, -2.076618, -2.779159>,
      < -4.573772, -2.090457, -2.779159>,
      < -4.591384, -2.173289, -2.764932>
    }
    triangle {
      < -4.622038, -2.076618, -2.779159>,
      < -4.591384, -2.173289, -2.764932>,
      < -4.641274, -2.160526, -2.764932>
    }
    triangle {
      < -4.641274, -2.160526, -2.764932>,
      < -4.591384, -2.173289, -2.764932>,
      < -4.598924, -2.208740, -2.663333>
    }
    triangle {
      < -4.641274, -2.160526, -2.764932>,
      < -4.598924, -2.208740, -2.663333>,
      < -4.652881, -2.194936, -2.663333>
    }
    triangle {
      < -4.652881, -2.194936, -2.663333>,
      < -4.598924, -2.208740, -2.663333>,
      < -4.616182, -2.289915, -2.663332>
    }
    triangle {
      < -4.652881, -2.194936, -2.663333>,
      < -4.616182, -2.289915, -2.663332>,
      < -4.691794, -2.268233, -2.663332>
    }
    triangle {
      < -4.691794, -2.268233, -2.663332>,
      < -4.616182, -2.289915, -2.663332>,
      < -4.617800, -2.297536, -2.744609>
    }
    triangle {
      < -4.691794, -2.268233, -2.663332>,
      < -4.617800, -2.297536, -2.744609>,
      < -4.694457, -2.275555, -2.744609>
    }
    triangle {
      < -4.694457, -2.275555, -2.744609>,
      < -4.617800, -2.297536, -2.744609>,
      < -4.631009, -2.359660, -2.736479>
    }
    triangle {
      < -4.694457, -2.275555, -2.744609>,
      < -4.631009, -2.359660, -2.736479>,
      < -4.716183, -2.335236, -2.736479>
    }
    triangle {
      < -4.716183, -2.335236, -2.736479>,
      < -4.631009, -2.359660, -2.736479>,
      < -4.631029, -2.359742, -2.633340>
    }
    triangle {
      < -4.716183, -2.335236, -2.736479>,
      < -4.631029, -2.359742, -2.633340>,
      < -4.716214, -2.335315, -2.633340>
    }
    triangle {
      < -4.521698, -1.845531, -2.828054>,
      < -4.506569, -1.847654, -2.828054>,
      < -4.507053, -1.854573, -2.842164>
    }
    triangle {
      < -4.521698, -1.845531, -2.828054>,
      < -4.507053, -1.854573, -2.842164>,
      < -4.523140, -1.852316, -2.842164>
    }
    triangle {
      < -4.523140, -1.852316, -2.842164>,
      < -4.507053, -1.854573, -2.842164>,
      < -4.514369, -1.959114, -2.813766>
    }
    triangle {
      < -4.523140, -1.852316, -2.842164>,
      < -4.514369, -1.959114, -2.813766>,
      < -4.544934, -1.954820, -2.813766>
    }
    triangle {
      < -4.544934, -1.954820, -2.813766>,
      < -4.514369, -1.959114, -2.813766>,
      < -4.521687, -2.063654, -2.769109>
    }
    triangle {
      < -4.544934, -1.954820, -2.813766>,
      < -4.521687, -2.063654, -2.769109>,
      < -4.566729, -2.057325, -2.769109>
    }
    triangle {
      < -4.566729, -2.057325, -2.769109>,
      < -4.521687, -2.063654, -2.769109>,
      < -4.522573, -2.076324, -2.756803>
    }
    triangle {
      < -4.566729, -2.057325, -2.769109>,
      < -4.522573, -2.076324, -2.756803>,
      < -4.569371, -2.069749, -2.756803>
    }
    triangle {
      < -4.569371, -2.069749, -2.756803>,
      < -4.522573, -2.076324, -2.756803>,
      < -4.524051, -2.097444, -2.779159>
    }
    triangle {
      < -4.569371, -2.069749, -2.756803>,
      < -4.524051, -2.097444, -2.779159>,
      < -4.573772, -2.090457, -2.779159>
    }
    triangle {
      < -4.573772, -2.090457, -2.779159>,
      < -4.524051, -2.097444, -2.779159>,
      < -4.540616, -2.181921, -2.764932>
    }
    triangle {
      < -4.573772, -2.090457, -2.779159>,
      < -4.540616, -2.181921, -2.764932>,
      < -4.591384, -2.173289, -2.764932>
    }
    triangle {
      < -4.591384, -2.173289, -2.764932>,
      < -4.540616, -2.181921, -2.764932>,
      < -4.544017, -2.218076, -2.663333>
    }
    triangle {
      < -4.591384, -2.173289, -2.764932>,
      < -4.544017, -2.218076, -2.663333>,
      < -4.598924, -2.208740, -2.663333>
    }
    triangle {
      < -4.598924, -2.208740, -2.663333>,
      < -4.544017, -2.218076, -2.663333>,
      < -4.538289, -2.300864, -2.663332>
    }
    triangle {
      < -4.598924, -2.208740, -2.663333>,
      < -4.538289, -2.300864, -2.663332>,
      < -4.616182, -2.289915, -2.663332>
    }
    triangle {
      < -4.616182, -2.289915, -2.663332>,
      < -4.538289, -2.300864, -2.663332>,
      < -4.538831, -2.308635, -2.744609>
    }
    triangle {
      < -4.616182, -2.289915, -2.663332>,
      < -4.538831, -2.308635, -2.744609>,
      < -4.617800, -2.297536, -2.744609>
    }
    triangle {
      < -4.617800, -2.297536, -2.744609>,
      < -4.538831, -2.308635, -2.744609>,
      < -4.543264, -2.371993, -2.736479>
    }
    triangle {
      < -4.617800, -2.297536, -2.744609>,
      < -4.543264, -2.371993, -2.736479>,
      < -4.631009, -2.359660, -2.736479>
    }
    triangle {
      < -4.631009, -2.359660, -2.736479>,
      < -4.543264, -2.371993, -2.736479>,
      < -4.543273, -2.372077, -2.633340>
    }
    triangle {
      < -4.631009, -2.359660, -2.736479>,
      < -4.543273, -2.372077, -2.633340>,
      < -4.631029, -2.359742, -2.633340>
    }
    triangle {
      < -4.506569, -1.847654, -2.828054>,
      < -4.491292, -1.847651, -2.828054>,
      < -4.490809, -1.854571, -2.842164>
    }
    triangle {
      < -4.506569, -1.847654, -2.828054>,
      < -4.490809, -1.854571, -2.842164>,
      < -4.507053, -1.854573, -2.842164>
    }
    triangle {
      < -4.507053, -1.854573, -2.842164>,
      < -4.490809, -1.854571, -2.842164>,
      < -4.483505, -1.959112, -2.813766>
    }
    triangle {
      < -4.507053, -1.854573, -2.842164>,
      < -4.483505, -1.959112, -2.813766>,
      < -4.514369, -1.959114, -2.813766>
    }
    triangle {
      < -4.514369, -1.959114, -2.813766>,
      < -4.483505, -1.959112, -2.813766>,
      < -4.476202, -2.063653, -2.769109>
    }
    triangle {
      < -4.514369, -1.959114, -2.813766>,
      < -4.476202, -2.063653, -2.769109>,
      < -4.521687, -2.063654, -2.769109>
    }
    triangle {
      < -4.521687, -2.063654, -2.769109>,
      < -4.476202, -2.063653, -2.769109>,
      < -4.475317, -2.076324, -2.756803>
    }
    triangle {
      < -4.521687, -2.063654, -2.769109>,
      < -4.475317, -2.076324, -2.756803>,
      < -4.522573, -2.076324, -2.756803>
    }
    triangle {
      < -4.522573, -2.076324, -2.756803>,
      < -4.475317, -2.076324, -2.756803>,
      < -4.473840, -2.097443, -2.779159>
    }
    triangle {
      < -4.522573, -2.076324, -2.756803>,
      < -4.473840, -2.097443, -2.779159>,
      < -4.524051, -2.097444, -2.779159>
    }
    triangle {
      < -4.485683, -2.162088, -2.768997>,
      < -4.473840, -2.097443, -2.779159>,
      < -4.457285, -2.181920, -2.764932>
    }
    triangle {
      < -4.484606, -2.196627, -2.663333>,
      < -4.485683, -2.162088, -2.768997>,
      < -4.457285, -2.181920, -2.764932>
    }
    triangle {
      < -4.484606, -2.196627, -2.663333>,
      < -4.457285, -2.181920, -2.764932>,
      < -4.453893, -2.218077, -2.663333>
    }
    triangle {
      < -4.544017, -2.218076, -2.663333>,
      < -4.453893, -2.218077, -2.663333>,
      < -4.459630, -2.300864, -2.663332>
    }
    triangle {
      < -4.544017, -2.218076, -2.663333>,
      < -4.459630, -2.300864, -2.663332>,
      < -4.538289, -2.300864, -2.663332>
    }
    triangle {
      < -4.538289, -2.300864, -2.663332>,
      < -4.459630, -2.300864, -2.663332>,
      < -4.459085, -2.308636, -2.744609>
    }
    triangle {
      < -4.538289, -2.300864, -2.663332>,
      < -4.459085, -2.308636, -2.744609>,
      < -4.538831, -2.308635, -2.744609>
    }
    triangle {
      < -4.538831, -2.308635, -2.744609>,
      < -4.459085, -2.308636, -2.744609>,
      < -4.454658, -2.371994, -2.736479>
    }
    triangle {
      < -4.538831, -2.308635, -2.744609>,
      < -4.454658, -2.371994, -2.736479>,
      < -4.543264, -2.371993, -2.736479>
    }
    triangle {
      < -4.543264, -2.371993, -2.736479>,
      < -4.454658, -2.371994, -2.736479>,
      < -4.454655, -2.372079, -2.633340>
    }
    triangle {
      < -4.543264, -2.371993, -2.736479>,
      < -4.454655, -2.372079, -2.633340>,
      < -4.543273, -2.372077, -2.633340>
    }
    triangle {
      < -4.491292, -1.847651, -2.828054>,
      < -4.476165, -1.845522, -2.828054>,
      < -4.474723, -1.852307, -2.842164>
    }
    triangle {
      < -4.491292, -1.847651, -2.828054>,
      < -4.474723, -1.852307, -2.842164>,
      < -4.490809, -1.854571, -2.842164>
    }
    triangle {
      < -4.490809, -1.854571, -2.842164>,
      < -4.474723, -1.852307, -2.842164>,
      < -4.452941, -1.954814, -2.813766>
    }
    triangle {
      < -4.490809, -1.854571, -2.842164>,
      < -4.452941, -1.954814, -2.813766>,
      < -4.483505, -1.959112, -2.813766>
    }
    triangle {
      < -4.483505, -1.959112, -2.813766>,
      < -4.452941, -1.954814, -2.813766>,
      < -4.431159, -2.057322, -2.769109>
    }
    triangle {
      < -4.483505, -1.959112, -2.813766>,
      < -4.431159, -2.057322, -2.769109>,
      < -4.476202, -2.063653, -2.769109>
    }
    triangle {
      < -4.476202, -2.063653, -2.769109>,
      < -4.431159, -2.057322, -2.769109>,
      < -4.428520, -2.069746, -2.756803>
    }
    triangle {
      < -4.476202, -2.063653, -2.769109>,
      < -4.428520, -2.069746, -2.756803>,
      < -4.475317, -2.076324, -2.756803>
    }
    triangle {
      < -4.475317, -2.076324, -2.756803>,
      < -4.428520, -2.069746, -2.756803>,
      < -4.424119, -2.090454, -2.779159>
    }
    triangle {
      < -4.475317, -2.076324, -2.756803>,
      < -4.424119, -2.090454, -2.779159>,
      < -4.473840, -2.097443, -2.779159>
    }
    triangle {
      < -4.473840, -2.097443, -2.779159>,
      < -4.424119, -2.090454, -2.779159>,
      < -4.406517, -2.173288, -2.764932>
    }
    triangle {
      < -4.473840, -2.097443, -2.779159>,
      < -4.406517, -2.173288, -2.764932>,
      < -4.457285, -2.181920, -2.764932>
    }
    triangle {
      < -4.457285, -2.181920, -2.764932>,
      < -4.406517, -2.173288, -2.764932>,
      < -4.398986, -2.208741, -2.663333>
    }
    triangle {
      < -4.457285, -2.181920, -2.764932>,
      < -4.398986, -2.208741, -2.663333>,
      < -4.453893, -2.218077, -2.663333>
    }
    triangle {
      < -4.453893, -2.218077, -2.663333>,
      < -4.398986, -2.208741, -2.663333>,
      < -4.381736, -2.289918, -2.663332>
    }
    triangle {
      < -4.453893, -2.218077, -2.663333>,
      < -4.381736, -2.289918, -2.663332>,
      < -4.459630, -2.300864, -2.663332>
    }
    triangle {
      < -4.459630, -2.300864, -2.663332>,
      < -4.381736, -2.289918, -2.663332>,
      < -4.380115, -2.297539, -2.744609>
    }
    triangle {
      < -4.459630, -2.300864, -2.663332>,
      < -4.380115, -2.297539, -2.744609>,
      < -4.459085, -2.308636, -2.744609>
    }
    triangle {
      < -4.459085, -2.308636, -2.744609>,
      < -4.380115, -2.297539, -2.744609>,
      < -4.366913, -2.359664, -2.736479>
    }
    triangle {
      < -4.459085, -2.308636, -2.744609>,
      < -4.366913, -2.359664, -2.736479>,
      < -4.454658, -2.371994, -2.736479>
    }
    triangle {
      < -4.454658, -2.371994, -2.736479>,
      < -4.366913, -2.359664, -2.736479>,
      < -4.366899, -2.359747, -2.633340>
    }
    triangle {
      < -4.454658, -2.371994, -2.736479>,
      < -4.366899, -2.359747, -2.633340>,
      < -4.454655, -2.372079, -2.633340>
    }
    triangle {
      < -4.476165, -1.845522, -2.828054>,
      < -4.461481, -1.841309, -2.828054>,
      < -4.459108, -1.847826, -2.842164>
    }
    triangle {
      < -4.476165, -1.845522, -2.828054>,
      < -4.459108, -1.847826, -2.842164>,
      < -4.474723, -1.852307, -2.842164>
    }
    triangle {
      < -4.474723, -1.852307, -2.842164>,
      < -4.459108, -1.847826, -2.842164>,
      < -4.423273, -1.946305, -2.813766>
    }
    triangle {
      < -4.474723, -1.852307, -2.842164>,
      < -4.423273, -1.946305, -2.813766>,
      < -4.452941, -1.954814, -2.813766>
    }
    triangle {
      < -4.452941, -1.954814, -2.813766>,
      < -4.423273, -1.946305, -2.813766>,
      < -4.387437, -2.044784, -2.769109>
    }
    triangle {
      < -4.452941, -1.954814, -2.813766>,
      < -4.387437, -2.044784, -2.769109>,
      < -4.431159, -2.057322, -2.769109>
    }
    triangle {
      < -4.431159, -2.057322, -2.769109>,
      < -4.387437, -2.044784, -2.769109>,
      < -4.383094, -2.056719, -2.756803>
    }
    triangle {
      < -4.431159, -2.057322, -2.769109>,
      < -4.383094, -2.056719, -2.756803>,
      < -4.428520, -2.069746, -2.756803>
    }
    triangle {
      < -4.428520, -2.069746, -2.756803>,
      < -4.383094, -2.056719, -2.756803>,
      < -4.375854, -2.076614, -2.779159>
    }
    triangle {
      < -4.428520, -2.069746, -2.756803>,
      < -4.375854, -2.076614, -2.779159>,
      < -4.424119, -2.090454, -2.779159>
    }
    triangle {
      < -4.424119, -2.090454, -2.779159>,
      < -4.375854, -2.076614, -2.779159>,
      < -4.356627, -2.160525, -2.764932>
    }
    triangle {
      < -4.424119, -2.090454, -2.779159>,
      < -4.356627, -2.160525, -2.764932>,
      < -4.406517, -2.173288, -2.764932>
    }
    triangle {
      < -4.406517, -2.173288, -2.764932>,
      < -4.356627, -2.160525, -2.764932>,
      < -4.345028, -2.194938, -2.663333>
    }
    triangle {
      < -4.406517, -2.173288, -2.764932>,
      < -4.345028, -2.194938, -2.663333>,
      < -4.398986, -2.208741, -2.663333>
    }
    triangle {
      < -4.398986, -2.208741, -2.663333>,
      < -4.345028, -2.194938, -2.663333>,
      < -4.306124, -2.268238, -2.663332>
    }
    triangle {
      < -4.398986, -2.208741, -2.663333>,
      < -4.306124, -2.268238, -2.663332>,
      < -4.381736, -2.289918, -2.663332>
    }
    triangle {
      < -4.381736, -2.289918, -2.663332>,
      < -4.306124, -2.268238, -2.663332>,
      < -4.303458, -2.275559, -2.744609>
    }
    triangle {
      < -4.381736, -2.289918, -2.663332>,
      < -4.303458, -2.275559, -2.744609>,
      < -4.380115, -2.297539, -2.744609>
    }
    triangle {
      < -4.380115, -2.297539, -2.744609>,
      < -4.303458, -2.275559, -2.744609>,
      < -4.281739, -2.335242, -2.736479>
    }
    triangle {
      < -4.380115, -2.297539, -2.744609>,
      < -4.281739, -2.335242, -2.736479>,
      < -4.366913, -2.359664, -2.736479>
    }
    triangle {
      < -4.366913, -2.359664, -2.736479>,
      < -4.281739, -2.335242, -2.736479>,
      < -4.281712, -2.335323, -2.633340>
    }
    triangle {
      < -4.366913, -2.359664, -2.736479>,
      < -4.281712, -2.335323, -2.633340>,
      < -4.366899, -2.359747, -2.633340>
    }
    triangle {
      < -4.461481, -1.841309, -2.828054>,
      < -4.447526, -1.835093, -2.828054>,
      < -4.444269, -1.841217, -2.842164>
    }
    triangle {
      < -4.461481, -1.841309, -2.828054>,
      < -4.444269, -1.841217, -2.842164>,
      < -4.459108, -1.847826, -2.842164>
    }
    triangle {
      < -4.459108, -1.847826, -2.842164>,
      < -4.444269, -1.841217, -2.842164>,
      < -4.395077, -1.933749, -2.813766>
    }
    triangle {
      < -4.459108, -1.847826, -2.842164>,
      < -4.395077, -1.933749, -2.813766>,
      < -4.423273, -1.946305, -2.813766>
    }
    triangle {
      < -4.423273, -1.946305, -2.813766>,
      < -4.395077, -1.933749, -2.813766>,
      < -4.345885, -2.026282, -2.769109>
    }
    triangle {
      < -4.423273, -1.946305, -2.813766>,
      < -4.345885, -2.026282, -2.769109>,
      < -4.387437, -2.044784, -2.769109>
    }
    triangle {
      < -4.387437, -2.044784, -2.769109>,
      < -4.345885, -2.026282, -2.769109>,
      < -4.339923, -2.037498, -2.756803>
    }
    triangle {
      < -4.387437, -2.044784, -2.769109>,
      < -4.339923, -2.037498, -2.756803>,
      < -4.383094, -2.056719, -2.756803>
    }
    triangle {
      < -4.383094, -2.056719, -2.756803>,
      < -4.339923, -2.037498, -2.756803>,
      < -4.329984, -2.056191, -2.779159>
    }
    triangle {
      < -4.383094, -2.056719, -2.756803>,
      < -4.329984, -2.056191, -2.779159>,
      < -4.375854, -2.076614, -2.779159>
    }
    triangle {
      < -4.314510, -2.120064, -2.768997>,
      < -4.329984, -2.056191, -2.779159>,
      < -4.280501, -2.126631, -2.764932>
    }
    triangle {
      < -4.299478, -2.151179, -2.663333>,
      < -4.314510, -2.120064, -2.768997>,
      < -4.280501, -2.126631, -2.764932>
    }
    triangle {
      < -4.299478, -2.151179, -2.663333>,
      < -4.280501, -2.126631, -2.764932>,
      < -4.262696, -2.158282, -2.663333>
    }
    triangle {
      < -4.345028, -2.194938, -2.663333>,
      < -4.262696, -2.158282, -2.663333>,
      < -4.234264, -2.236246, -2.663332>
    }
    triangle {
      < -4.345028, -2.194938, -2.663333>,
      < -4.234264, -2.236246, -2.663332>,
      < -4.306124, -2.268238, -2.663332>
    }
    triangle {
      < -4.306124, -2.268238, -2.663332>,
      < -4.234264, -2.236246, -2.663332>,
      < -4.230606, -2.243124, -2.744609>
    }
    triangle {
      < -4.306124, -2.268238, -2.663332>,
      < -4.230606, -2.243124, -2.744609>,
      < -4.303458, -2.275559, -2.744609>
    }
    triangle {
      < -4.303458, -2.275559, -2.744609>,
      < -4.230606, -2.243124, -2.744609>,
      < -4.200792, -2.299204, -2.736479>
    }
    triangle {
      < -4.303458, -2.275559, -2.744609>,
      < -4.200792, -2.299204, -2.736479>,
      < -4.281739, -2.335242, -2.736479>
    }
    triangle {
      < -4.281739, -2.335242, -2.736479>,
      < -4.200792, -2.299204, -2.736479>,
      < -4.200755, -2.299281, -2.633340>
    }
    triangle {
      < -4.281739, -2.335242, -2.736479>,
      < -4.200755, -2.299281, -2.633340>,
      < -4.281712, -2.335323, -2.633340>
    }
    triangle {
      < -4.447526, -1.835093, -2.828054>,
      < -4.434571, -1.826995, -2.828054>,
      < -4.430495, -1.832606, -2.842164>
    }
    triangle {
      < -4.447526, -1.835093, -2.828054>,
      < -4.430495, -1.832606, -2.842164>,
      < -4.444269, -1.841217, -2.842164>
    }
    triangle {
      < -4.444269, -1.841217, -2.842164>,
      < -4.430495, -1.832606, -2.842164>,
      < -4.368903, -1.917392, -2.813766>
    }
    triangle {
      < -4.444269, -1.841217, -2.842164>,
      < -4.368903, -1.917392, -2.813766>,
      < -4.395077, -1.933749, -2.813766>
    }
    triangle {
      < -4.395077, -1.933749, -2.813766>,
      < -4.368903, -1.917392, -2.813766>,
      < -4.307312, -2.002178, -2.769109>
    }
    triangle {
      < -4.395077, -1.933749, -2.813766>,
      < -4.307312, -2.002178, -2.769109>,
      < -4.345885, -2.026282, -2.769109>
    }
    triangle {
      < -4.345885, -2.026282, -2.769109>,
      < -4.307312, -2.002178, -2.769109>,
      < -4.299847, -2.012455, -2.756803>
    }
    triangle {
      < -4.345885, -2.026282, -2.769109>,
      < -4.299847, -2.012455, -2.756803>,
      < -4.339923, -2.037498, -2.756803>
    }
    triangle {
      < -4.339923, -2.037498, -2.756803>,
      < -4.299847, -2.012455, -2.756803>,
      < -4.287404, -2.029583, -2.779159>
    }
    triangle {
      < -4.339923, -2.037498, -2.756803>,
      < -4.287404, -2.029583, -2.779159>,
      < -4.329984, -2.056191, -2.779159>
    }
    triangle {
      < -4.329984, -2.056191, -2.779159>,
      < -4.287404, -2.029583, -2.779159>,
      < -4.237633, -2.098096, -2.764932>
    }
    triangle {
      < -4.329984, -2.056191, -2.779159>,
      < -4.237633, -2.098096, -2.764932>,
      < -4.280501, -2.126631, -2.764932>
    }
    triangle {
      < -4.280501, -2.126631, -2.764932>,
      < -4.237633, -2.098096, -2.764932>,
      < -4.216333, -2.127422, -2.663333>
    }
    triangle {
      < -4.280501, -2.126631, -2.764932>,
      < -4.216333, -2.127422, -2.663333>,
      < -4.262696, -2.158282, -2.663333>
    }
    triangle {
      < -4.262696, -2.158282, -2.663333>,
      < -4.216333, -2.127422, -2.663333>,
      < -4.167557, -2.194565, -2.663332>
    }
    triangle {
      < -4.262696, -2.158282, -2.663333>,
      < -4.167557, -2.194565, -2.663332>,
      < -4.234264, -2.236246, -2.663332>
    }
    triangle {
      < -4.234264, -2.236246, -2.663332>,
      < -4.167557, -2.194565, -2.663332>,
      < -4.162976, -2.200867, -2.744609>
    }
    triangle {
      < -4.234264, -2.236246, -2.663332>,
      < -4.162976, -2.200867, -2.744609>,
      < -4.230606, -2.243124, -2.744609>
    }
    triangle {
      < -4.230606, -2.243124, -2.744609>,
      < -4.162976, -2.200867, -2.744609>,
      < -4.125648, -2.252252, -2.736479>
    }
    triangle {
      < -4.230606, -2.243124, -2.744609>,
      < -4.125648, -2.252252, -2.736479>,
      < -4.200792, -2.299204, -2.736479>
    }
    triangle {
      < -4.200792, -2.299204, -2.736479>,
      < -4.125648, -2.252252, -2.736479>,
      < -4.125600, -2.252322, -2.633340>
    }
    triangle {
      < -4.200792, -2.299204, -2.736479>,
      < -4.125600, -2.252322, -2.633340>,
      < -4.200755, -2.299281, -2.633340>
    }
    triangle {
      < -4.434571, -1.826995, -2.828054>,
      < -4.422870, -1.817173, -2.828054>,
      < -4.418052, -1.822162, -2.842164>
    }
    triangle {
      < -4.434571, -1.826995, -2.828054>,
      < -4.418052, -1.822162, -2.842164>,
      < -4.430495, -1.832606, -2.842164>
    }
    triangle {
      < -4.430495, -1.832606, -2.842164>,
      < -4.418052, -1.822162, -2.842164>,
      < -4.345260, -1.897551, -2.813766>
    }
    triangle {
      < -4.430495, -1.832606, -2.842164>,
      < -4.345260, -1.897551, -2.813766>,
      < -4.368903, -1.917392, -2.813766>
    }
    triangle {
      < -4.368903, -1.917392, -2.813766>,
      < -4.345260, -1.897551, -2.813766>,
      < -4.272469, -1.972941, -2.769109>
    }
    triangle {
      < -4.368903, -1.917392, -2.813766>,
      < -4.272469, -1.972941, -2.769109>,
      < -4.307312, -2.002178, -2.769109>
    }
    triangle {
      < -4.307312, -2.002178, -2.769109>,
      < -4.272469, -1.972941, -2.769109>,
      < -4.263646, -1.982078, -2.756803>
    }
    triangle {
      < -4.307312, -2.002178, -2.769109>,
      < -4.263646, -1.982078, -2.756803>,
      < -4.299847, -2.012455, -2.756803>
    }
    triangle {
      < -4.299847, -2.012455, -2.756803>,
      < -4.263646, -1.982078, -2.756803>,
      < -4.248940, -1.997308, -2.779159>
    }
    triangle {
      < -4.299847, -2.012455, -2.756803>,
      < -4.248940, -1.997308, -2.779159>,
      < -4.287404, -2.029583, -2.779159>
    }
    triangle {
      < -4.287404, -2.029583, -2.779159>,
      < -4.248940, -1.997308, -2.779159>,
      < -4.197247, -2.066145, -2.764932>
    }
    triangle {
      < -4.287404, -2.029583, -2.779159>,
      < -4.197247, -2.066145, -2.764932>,
      < -4.237633, -2.098096, -2.764932>
    }
    triangle {
      < -4.237633, -2.098096, -2.764932>,
      < -4.197247, -2.066145, -2.764932>,
      < -4.172654, -2.092865, -2.663333>
    }
    triangle {
      < -4.237633, -2.098096, -2.764932>,
      < -4.172654, -2.092865, -2.663333>,
      < -4.216333, -2.127422, -2.663333>
    }
    triangle {
      < -4.216333, -2.127422, -2.663333>,
      < -4.172654, -2.092865, -2.663333>,
      < -4.107299, -2.144005, -2.663332>
    }
    triangle {
      < -4.216333, -2.127422, -2.663333>,
      < -4.107299, -2.144005, -2.663332>,
      < -4.167557, -2.194565, -2.663332>
    }
    triangle {
      < -4.167557, -2.194565, -2.663332>,
      < -4.107299, -2.144005, -2.663332>,
      < -4.101886, -2.149608, -2.744609>
    }
    triangle {
      < -4.167557, -2.194565, -2.663332>,
      < -4.101886, -2.149608, -2.744609>,
      < -4.162976, -2.200867, -2.744609>
    }
    triangle {
      < -4.162976, -2.200867, -2.744609>,
      < -4.101886, -2.149608, -2.744609>,
      < -4.057770, -2.195299, -2.736479>
    }
    triangle {
      < -4.162976, -2.200867, -2.744609>,
      < -4.057770, -2.195299, -2.736479>,
      < -4.125648, -2.252252, -2.736479>
    }
    triangle {
      < -4.125648, -2.252252, -2.736479>,
      < -4.057770, -2.195299, -2.736479>,
      < -4.057713, -2.195361, -2.633340>
    }
    triangle {
      < -4.125648, -2.252252, -2.736479>,
      < -4.057713, -2.195361, -2.633340>,
      < -4.125600, -2.252322, -2.633340>
    }
    triangle {
      < -4.422870, -1.817173, -2.828054>,
      < -4.412650, -1.805818, -2.828054>,
      < -4.407185, -1.810088, -2.842164>
    }
    triangle {
      < -4.422870, -1.817173, -2.828054>,
      < -4.407185, -1.810088, -2.842164>,
      < -4.418052, -1.822162, -2.842164>
    }
    triangle {
      < -4.418052, -1.822162, -2.842164>,
      < -4.407185, -1.810088, -2.842164>,
      < -4.324609, -1.874613, -2.813766>
    }
    triangle {
      < -4.418052, -1.822162, -2.842164>,
      < -4.324609, -1.874613, -2.813766>,
      < -4.345260, -1.897551, -2.813766>
    }
    triangle {
      < -4.345260, -1.897551, -2.813766>,
      < -4.324609, -1.874613, -2.813766>,
      < -4.242033, -1.939139, -2.769109>
    }
    triangle {
      < -4.345260, -1.897551, -2.813766>,
      < -4.242033, -1.939139, -2.769109>,
      < -4.272469, -1.972941, -2.769109>
    }
    triangle {
      < -4.272469, -1.972941, -2.769109>,
      < -4.242033, -1.939139, -2.769109>,
      < -4.232026, -1.946959, -2.756803>
    }
    triangle {
      < -4.272469, -1.972941, -2.769109>,
      < -4.232026, -1.946959, -2.756803>,
      < -4.263646, -1.982078, -2.756803>
    }
    triangle {
      < -4.263646, -1.982078, -2.756803>,
      < -4.232026, -1.946959, -2.756803>,
      < -4.215343, -1.959994, -2.779159>
    }
    triangle {
      < -4.263646, -1.982078, -2.756803>,
      < -4.215343, -1.959994, -2.779159>,
      < -4.248940, -1.997308, -2.779159>
    }
    triangle {
      < -4.175228, -2.012052, -2.768997>,
      < -4.215343, -1.959994, -2.779159>,
      < -4.141488, -2.004219, -2.764932>
    }
    triangle {
      < -4.148839, -2.034363, -2.663333>,
      < -4.175228, -2.012052, -2.768997>,
      < -4.141488, -2.004219, -2.764932>
    }
    triangle {
      < -4.148839, -2.034363, -2.663333>,
      < -4.141488, -2.004219, -2.764932>,
      < -4.112349, -2.025892, -2.663333>
    }
    triangle {
      < -4.172654, -2.092865, -2.663333>,
      < -4.112349, -2.025892, -2.663333>,
      < -4.054665, -2.085552, -2.663332>
    }
    triangle {
      < -4.172654, -2.092865, -2.663333>,
      < -4.054665, -2.085552, -2.663332>,
      < -4.107299, -2.144005, -2.663332>
    }
    triangle {
      < -4.107299, -2.144005, -2.663332>,
      < -4.054665, -2.085552, -2.663332>,
      < -4.048524, -2.090347, -2.744609>
    }
    triangle {
      < -4.107299, -2.144005, -2.663332>,
      < -4.048524, -2.090347, -2.744609>,
      < -4.101886, -2.149608, -2.744609>
    }
    triangle {
      < -4.101886, -2.149608, -2.744609>,
      < -4.048524, -2.090347, -2.744609>,
      < -3.998478, -2.129453, -2.736479>
    }
    triangle {
      < -4.101886, -2.149608, -2.744609>,
      < -3.998478, -2.129453, -2.736479>,
      < -4.057770, -2.195299, -2.736479>
    }
    triangle {
      < -4.057770, -2.195299, -2.736479>,
      < -3.998478, -2.129453, -2.736479>,
      < -3.998414, -2.129507, -2.633340>
    }
    triangle {
      < -4.057770, -2.195299, -2.736479>,
      < -3.998414, -2.129507, -2.633340>,
      < -4.057713, -2.195361, -2.633340>
    }
    triangle {
      < -4.412650, -1.805818, -2.828054>,
      < -4.404109, -1.793151, -2.828054>,
      < -4.407185, -1.810088, -2.842164>
    }
    triangle {
      < -4.407185, -1.810088, -2.842164>,
      < -4.315229, -1.860699, -2.813766>,
      < -4.324609, -1.874613, -2.813766>
    }
    triangle {
      < -4.315229, -1.860699, -2.813766>,
      < -4.220871, -1.907472, -2.769109>,
      < -4.242033, -1.939139, -2.769109>
    }
    triangle {
      < -4.315229, -1.860699, -2.813766>,
      < -4.242033, -1.939139, -2.769109>,
      < -4.324609, -1.874613, -2.813766>
    }
    triangle {
      < -4.220871, -1.907472, -2.769109>,
      < -4.205600, -1.907782, -2.756803>,
      < -4.232026, -1.946959, -2.756803>
    }
    triangle {
      < -4.220871, -1.907472, -2.769109>,
      < -4.232026, -1.946959, -2.756803>,
      < -4.242033, -1.939139, -2.769109>
    }
    triangle {
      < -4.232026, -1.946959, -2.756803>,
      < -4.205600, -1.907782, -2.756803>,
      < -4.187266, -1.918368, -2.779159>
    }
    triangle {
      < -4.232026, -1.946959, -2.756803>,
      < -4.187266, -1.918368, -2.779159>,
      < -4.215343, -1.959994, -2.779159>
    }
    triangle {
      < -4.215343, -1.959994, -2.779159>,
      < -4.187266, -1.918368, -2.779159>,
      < -4.113931, -1.960715, -2.764932>
    }
    triangle {
      < -4.215343, -1.959994, -2.779159>,
      < -4.113931, -1.960715, -2.764932>,
      < -4.141488, -2.004219, -2.764932>
    }
    triangle {
      < -4.141488, -2.004219, -2.764932>,
      < -4.113931, -1.960715, -2.764932>,
      < -4.082545, -1.978842, -2.663333>
    }
    triangle {
      < -4.141488, -2.004219, -2.764932>,
      < -4.082545, -1.978842, -2.663333>,
      < -4.112349, -2.025892, -2.663333>
    }
    triangle {
      < -4.112349, -2.025892, -2.663333>,
      < -4.082545, -1.978842, -2.663333>,
      < -4.010677, -2.020342, -2.663332>
    }
    triangle {
      < -4.112349, -2.025892, -2.663333>,
      < -4.010677, -2.020342, -2.663332>,
      < -4.054665, -2.085552, -2.663332>
    }
    triangle {
      < -4.054665, -2.085552, -2.663332>,
      < -4.010677, -2.020342, -2.663332>,
      < -4.003929, -2.024236, -2.744609>
    }
    triangle {
      < -4.054665, -2.085552, -2.663332>,
      < -4.003929, -2.024236, -2.744609>,
      < -4.048524, -2.090347, -2.744609>
    }
    triangle {
      < -4.048524, -2.090347, -2.744609>,
      < -4.003929, -2.024236, -2.744609>,
      < -3.948928, -2.055996, -2.736479>
    }
    triangle {
      < -4.048524, -2.090347, -2.744609>,
      < -3.948928, -2.055996, -2.736479>,
      < -3.998478, -2.129453, -2.736479>
    }
    triangle {
      < -3.998478, -2.129453, -2.736479>,
      < -3.948928, -2.055996, -2.736479>,
      < -3.948856, -2.056041, -2.633340>
    }
    triangle {
      < -3.998478, -2.129453, -2.736479>,
      < -3.948856, -2.056041, -2.633340>,
      < -3.998414, -2.129507, -2.633340>
    }
    triangle {
      < -4.404109, -1.793151, -2.828054>,
      < -4.397415, -1.779420, -2.828054>,
      < -4.390984, -1.782018, -2.842164>
    }
    triangle {
      < -4.301181, -1.836364, -2.813766>,
      < -4.390984, -1.782018, -2.842164>,
      < -4.293822, -1.821283, -2.813766>
    }
    triangle {
      < -4.301181, -1.836364, -2.813766>,
      < -4.293822, -1.821283, -2.813766>,
      < -4.196660, -1.860548, -2.769109>
    }
    triangle {
      < -4.301181, -1.836364, -2.813766>,
      < -4.196660, -1.860548, -2.769109>,
      < -4.213502, -1.894709, -2.769109>
    }
    triangle {
      < -4.196660, -1.860548, -2.769109>,
      < -4.184884, -1.865308, -2.756803>,
      < -4.205600, -1.907782, -2.756803>
    }
    triangle {
      < -4.196660, -1.860548, -2.769109>,
      < -4.205600, -1.907782, -2.756803>,
      < -4.213502, -1.894709, -2.769109>
    }
    triangle {
      < -4.205600, -1.907782, -2.756803>,
      < -4.184884, -1.865308, -2.756803>,
      < -4.165255, -1.873239, -2.779159>
    }
    triangle {
      < -4.205600, -1.907782, -2.756803>,
      < -4.165255, -1.873239, -2.779159>,
      < -4.187266, -1.918368, -2.779159>
    }
    triangle {
      < -4.187266, -1.918368, -2.779159>,
      < -4.165255, -1.873239, -2.779159>,
      < -4.090033, -1.915100, -2.764932>
    }
    triangle {
      < -4.187266, -1.918368, -2.779159>,
      < -4.090033, -1.915100, -2.764932>,
      < -4.113931, -1.960715, -2.764932>
    }
    triangle {
      < -4.113931, -1.960715, -2.764932>,
      < -4.090033, -1.915100, -2.764932>,
      < -4.056698, -1.929508, -2.663333>
    }
    triangle {
      < -4.113931, -1.960715, -2.764932>,
      < -4.056698, -1.929508, -2.663333>,
      < -4.082545, -1.978842, -2.663333>
    }
    triangle {
      < -4.082545, -1.978842, -2.663333>,
      < -4.056698, -1.929508, -2.663333>,
      < -3.976193, -1.949645, -2.663332>
    }
    triangle {
      < -4.082545, -1.978842, -2.663333>,
      < -3.976193, -1.949645, -2.663332>,
      < -4.010677, -2.020342, -2.663332>
    }
    triangle {
      < -4.010677, -2.020342, -2.663332>,
      < -3.976193, -1.949645, -2.663332>,
      < -3.968969, -1.952562, -2.744609>
    }
    triangle {
      < -4.010677, -2.020342, -2.663332>,
      < -3.968969, -1.952562, -2.744609>,
      < -4.003929, -2.024236, -2.744609>
    }
    triangle {
      < -4.003929, -2.024236, -2.744609>,
      < -3.968969, -1.952562, -2.744609>,
      < -3.910083, -1.976358, -2.736479>
    }
    triangle {
      < -4.003929, -2.024236, -2.744609>,
      < -3.910083, -1.976358, -2.736479>,
      < -3.948928, -2.055996, -2.736479>
    }
    triangle {
      < -3.948928, -2.055996, -2.736479>,
      < -3.910083, -1.976358, -2.736479>,
      < -3.910006, -1.976393, -2.633340>
    }
    triangle {
      < -3.948928, -2.055996, -2.736479>,
      < -3.910006, -1.976393, -2.633340>,
      < -3.948856, -2.056041, -2.633340>
    }
    triangle {
      < -4.397415, -1.779420, -2.828054>,
      < -4.392696, -1.764889, -2.828054>,
      < -4.385967, -1.766568, -2.842164>
    }
    triangle {
      < -4.397415, -1.779420, -2.828054>,
      < -4.385967, -1.766568, -2.842164>,
      < -4.390984, -1.782018, -2.842164>
    }
    triangle {
      < -4.390984, -1.782018, -2.842164>,
      < -4.385967, -1.766568, -2.842164>,
      < -4.284286, -1.791928, -2.813766>
    }
    triangle {
      < -4.390984, -1.782018, -2.842164>,
      < -4.284286, -1.791928, -2.813766>,
      < -4.293822, -1.821283, -2.813766>
    }
    triangle {
      < -4.293822, -1.821283, -2.813766>,
      < -4.284286, -1.791928, -2.813766>,
      < -4.182605, -1.817290, -2.769109>
    }
    triangle {
      < -4.293822, -1.821283, -2.813766>,
      < -4.182605, -1.817290, -2.769109>,
      < -4.196660, -1.860548, -2.769109>
    }
    triangle {
      < -4.196660, -1.860548, -2.769109>,
      < -4.182605, -1.817290, -2.769109>,
      < -4.170281, -1.820364, -2.756803>
    }
    triangle {
      < -4.196660, -1.860548, -2.769109>,
      < -4.170281, -1.820364, -2.756803>,
      < -4.184884, -1.865308, -2.756803>
    }
    triangle {
      < -4.184884, -1.865308, -2.756803>,
      < -4.170281, -1.820364, -2.756803>,
      < -4.149739, -1.825486, -2.779159>
    }
    triangle {
      < -4.184884, -1.865308, -2.756803>,
      < -4.149739, -1.825486, -2.779159>,
      < -4.165255, -1.873239, -2.779159>
    }
    triangle {
      < -4.091918, -1.856727, -2.768997>,
      < -4.149739, -1.825486, -2.779159>,
      < -4.064281, -1.835848, -2.764932>
    }
    triangle {
      < -4.058736, -1.866377, -2.663333>,
      < -4.091918, -1.856727, -2.768997>,
      < -4.064281, -1.835848, -2.764932>
    }
    triangle {
      < -4.058736, -1.866377, -2.663333>,
      < -4.064281, -1.835848, -2.764932>,
      < -4.028846, -1.843796, -2.663333>
    }
    triangle {
      < -4.056698, -1.929508, -2.663333>,
      < -4.028846, -1.843796, -2.663333>,
      < -3.951883, -1.874836, -2.663332>
    }
    triangle {
      < -4.056698, -1.929508, -2.663333>,
      < -3.951883, -1.874836, -2.663332>,
      < -3.976193, -1.949645, -2.663332>
    }
    triangle {
      < -3.976193, -1.949645, -2.663332>,
      < -3.951883, -1.874836, -2.663332>,
      < -3.944324, -1.876719, -2.744609>
    }
    triangle {
      < -3.976193, -1.949645, -2.663332>,
      < -3.944324, -1.876719, -2.744609>,
      < -3.968969, -1.952562, -2.744609>
    }
    triangle {
      < -3.968969, -1.952562, -2.744609>,
      < -3.944324, -1.876719, -2.744609>,
      < -3.882699, -1.892089, -2.736479>
    }
    triangle {
      < -3.968969, -1.952562, -2.744609>,
      < -3.882699, -1.892089, -2.736479>,
      < -3.910083, -1.976358, -2.736479>
    }
    triangle {
      < -3.910083, -1.976358, -2.736479>,
      < -3.882699, -1.892089, -2.736479>,
      < -3.882617, -1.892112, -2.633340>
    }
    triangle {
      < -3.910083, -1.976358, -2.736479>,
      < -3.882617, -1.892112, -2.633340>,
      < -3.910006, -1.976393, -2.633340>
    }
    triangle {
      < -4.392696, -1.764889, -2.828054>,
      < -4.390046, -1.749844, -2.828054>,
      < -4.383148, -1.750569, -2.842164>
    }
    triangle {
      < -4.392696, -1.764889, -2.828054>,
      < -4.383148, -1.750569, -2.842164>,
      < -4.385967, -1.766568, -2.842164>
    }
    triangle {
      < -4.385967, -1.766568, -2.842164>,
      < -4.383148, -1.750569, -2.842164>,
      < -4.278927, -1.761532, -2.813766>
    }
    triangle {
      < -4.385967, -1.766568, -2.842164>,
      < -4.278927, -1.761532, -2.813766>,
      < -4.284286, -1.791928, -2.813766>
    }
    triangle {
      < -4.284286, -1.791928, -2.813766>,
      < -4.278927, -1.761532, -2.813766>,
      < -4.174706, -1.772496, -2.769109>
    }
    triangle {
      < -4.284286, -1.791928, -2.813766>,
      < -4.174706, -1.772496, -2.769109>,
      < -4.182605, -1.817290, -2.769109>
    }
    triangle {
      < -4.182605, -1.817290, -2.769109>,
      < -4.174706, -1.772496, -2.769109>,
      < -4.162075, -1.773825, -2.756803>
    }
    triangle {
      < -4.182605, -1.817290, -2.769109>,
      < -4.162075, -1.773825, -2.756803>,
      < -4.170281, -1.820364, -2.756803>
    }
    triangle {
      < -4.170281, -1.820364, -2.756803>,
      < -4.162075, -1.773825, -2.756803>,
      < -4.141020, -1.776039, -2.779159>
    }
    triangle {
      < -4.170281, -1.820364, -2.756803>,
      < -4.141020, -1.776039, -2.779159>,
      < -4.149739, -1.825486, -2.779159>
    }
    triangle {
      < -4.149739, -1.825486, -2.779159>,
      < -4.141020, -1.776039, -2.779159>,
      < -4.056801, -1.784897, -2.764932>
    }
    triangle {
      < -4.149739, -1.825486, -2.779159>,
      < -4.056801, -1.784897, -2.764932>,
      < -4.064281, -1.835848, -2.764932>
    }
    triangle {
      < -4.064281, -1.835848, -2.764932>,
      < -4.056801, -1.784897, -2.764932>,
      < -4.020756, -1.788691, -2.663333>
    }
    triangle {
      < -4.064281, -1.835848, -2.764932>,
      < -4.020756, -1.788691, -2.663333>,
      < -4.028846, -1.843796, -2.663333>
    }
    triangle {
      < -4.028846, -1.843796, -2.663333>,
      < -4.020756, -1.788691, -2.663333>,
      < -3.938221, -1.797373, -2.663332>
    }
    triangle {
      < -4.028846, -1.843796, -2.663333>,
      < -3.938221, -1.797373, -2.663332>,
      < -3.951883, -1.874836, -2.663332>
    }
    triangle {
      < -3.951883, -1.874836, -2.663332>,
      < -3.938221, -1.797373, -2.663332>,
      < -3.930473, -1.798185, -2.744609>
    }
    triangle {
      < -3.951883, -1.874836, -2.663332>,
      < -3.930473, -1.798185, -2.744609>,
      < -3.944324, -1.876719, -2.744609>
    }
    triangle {
      < -3.944324, -1.876719, -2.744609>,
      < -3.930473, -1.798185, -2.744609>,
      < -3.867310, -1.804829, -2.736479>
    }
    triangle {
      < -3.944324, -1.876719, -2.744609>,
      < -3.867310, -1.804829, -2.736479>,
      < -3.882699, -1.892089, -2.736479>
    }
    triangle {
      < -3.882699, -1.892089, -2.736479>,
      < -3.867310, -1.804829, -2.736479>,
      < -3.867225, -1.804841, -2.633340>
    }
    triangle {
      < -3.882699, -1.892089, -2.736479>,
      < -3.867225, -1.804841, -2.633340>,
      < -3.882617, -1.892112, -2.633340>
    }
    triangle {
      < -4.390046, -1.749844, -2.828054>,
      < -4.389516, -1.734577, -2.828054>,
      < -4.382584, -1.734335, -2.842164>
    }
    triangle {
      < -4.390046, -1.749844, -2.828054>,
      < -4.382584, -1.734335, -2.842164>,
      < -4.383148, -1.750569, -2.842164>
    }
    triangle {
      < -4.383148, -1.750569, -2.842164>,
      < -4.382584, -1.734335, -2.842164>,
      < -4.277852, -1.730686, -2.813766>
    }
    triangle {
      < -4.383148, -1.750569, -2.842164>,
      < -4.277852, -1.730686, -2.813766>,
      < -4.278927, -1.761532, -2.813766>
    }
    triangle {
      < -4.278927, -1.761532, -2.813766>,
      < -4.277852, -1.730686, -2.813766>,
      < -4.173119, -1.727039, -2.769109>
    }
    triangle {
      < -4.278927, -1.761532, -2.813766>,
      < -4.173119, -1.727039, -2.769109>,
      < -4.174706, -1.772496, -2.769109>
    }
    triangle {
      < -4.174706, -1.772496, -2.769109>,
      < -4.173119, -1.727039, -2.769109>,
      < -4.160425, -1.726597, -2.756803>
    }
    triangle {
      < -4.174706, -1.772496, -2.769109>,
      < -4.160425, -1.726597, -2.756803>,
      < -4.162075, -1.773825, -2.756803>
    }
    triangle {
      < -4.162075, -1.773825, -2.756803>,
      < -4.160425, -1.726597, -2.756803>,
      < -4.139267, -1.725859, -2.779159>
    }
    triangle {
      < -4.162075, -1.773825, -2.756803>,
      < -4.139267, -1.725859, -2.779159>,
      < -4.141020, -1.776039, -2.779159>
    }
    triangle {
      < -4.141020, -1.776039, -2.779159>,
      < -4.139267, -1.725859, -2.779159>,
      < -4.053522, -1.733505, -2.764932>
    }
    triangle {
      < -4.141020, -1.776039, -2.779159>,
      < -4.053522, -1.733505, -2.764932>,
      < -4.056801, -1.784897, -2.764932>
    }
    triangle {
      < -4.056801, -1.784897, -2.764932>,
      < -4.053522, -1.733505, -2.764932>,
      < -4.017209, -1.733109, -2.663333>
    }
    triangle {
      < -4.056801, -1.784897, -2.764932>,
      < -4.017209, -1.733109, -2.663333>,
      < -4.020756, -1.788691, -2.663333>
    }
    triangle {
      < -4.020756, -1.788691, -2.663333>,
      < -4.017209, -1.733109, -2.663333>,
      < -3.935473, -1.718761, -2.663332>
    }
    triangle {
      < -4.020756, -1.788691, -2.663333>,
      < -3.935473, -1.718761, -2.663332>,
      < -3.938221, -1.797373, -2.663332>
    }
    triangle {
      < -3.938221, -1.797373, -2.663332>,
      < -3.935473, -1.718761, -2.663332>,
      < -3.927687, -1.718488, -2.744609>
    }
    triangle {
      < -3.938221, -1.797373, -2.663332>,
      < -3.927687, -1.718488, -2.744609>,
      < -3.930473, -1.798185, -2.744609>
    }
    triangle {
      < -3.930473, -1.798185, -2.744609>,
      < -3.927687, -1.718488, -2.744609>,
      < -3.864213, -1.716277, -2.736479>
    }
    triangle {
      < -3.930473, -1.798185, -2.744609>,
      < -3.864213, -1.716277, -2.736479>,
      < -3.867310, -1.804829, -2.736479>
    }
    triangle {
      < -3.867310, -1.804829, -2.736479>,
      < -3.864213, -1.716277, -2.736479>,
      < -3.864129, -1.716277, -2.633340>
    }
    triangle {
      < -3.867310, -1.804829, -2.736479>,
      < -3.864129, -1.716277, -2.633340>,
      < -3.867225, -1.804841, -2.633340>
    }
    triangle {
      < -4.389516, -1.734577, -2.828054>,
      < -4.391115, -1.719384, -2.828054>,
      < -4.384284, -1.718179, -2.842164>
    }
    triangle {
      < -4.389516, -1.734577, -2.828054>,
      < -4.384284, -1.718179, -2.842164>,
      < -4.382584, -1.734335, -2.842164>
    }
    triangle {
      < -4.382584, -1.734335, -2.842164>,
      < -4.384284, -1.718179, -2.842164>,
      < -4.281079, -1.699991, -2.813766>
    }
    triangle {
      < -4.382584, -1.734335, -2.842164>,
      < -4.281079, -1.699991, -2.813766>,
      < -4.277852, -1.730686, -2.813766>
    }
    triangle {
      < -4.277852, -1.730686, -2.813766>,
      < -4.281079, -1.699991, -2.813766>,
      < -4.177873, -1.681803, -2.769109>
    }
    triangle {
      < -4.277852, -1.730686, -2.813766>,
      < -4.177873, -1.681803, -2.769109>,
      < -4.173119, -1.727039, -2.769109>
    }
    triangle {
      < -4.173119, -1.727039, -2.769109>,
      < -4.177873, -1.681803, -2.769109>,
      < -4.165364, -1.679599, -2.756803>
    }
    triangle {
      < -4.173119, -1.727039, -2.769109>,
      < -4.165364, -1.679599, -2.756803>,
      < -4.160425, -1.726597, -2.756803>
    }
    triangle {
      < -4.160425, -1.726597, -2.756803>,
      < -4.165364, -1.679599, -2.756803>,
      < -4.144515, -1.675924, -2.779159>
    }
    triangle {
      < -4.160425, -1.726597, -2.756803>,
      < -4.144515, -1.675924, -2.779159>,
      < -4.139267, -1.725859, -2.779159>
    }
    triangle {
      < -4.078987, -1.680946, -2.768997>,
      < -4.144515, -1.675924, -2.779159>,
      < -4.062230, -1.650631, -2.764932>
    }
    triangle {
      < -4.044749, -1.676265, -2.663333>,
      < -4.078987, -1.680946, -2.768997>,
      < -4.062230, -1.650631, -2.764932>
    }
    triangle {
      < -4.044749, -1.676265, -2.663333>,
      < -4.062230, -1.650631, -2.764932>,
      < -4.026626, -1.643479, -2.663333>
    }
    triangle {
      < -4.017209, -1.733109, -2.663333>,
      < -4.026626, -1.643479, -2.663333>,
      < -3.943692, -1.640533, -2.663332>
    }
    triangle {
      < -4.017209, -1.733109, -2.663333>,
      < -3.943692, -1.640533, -2.663332>,
      < -3.935473, -1.718761, -2.663332>
    }
    triangle {
      < -3.935473, -1.718761, -2.663332>,
      < -3.943692, -1.640533, -2.663332>,
      < -3.936020, -1.639179, -2.744609>
    }
    triangle {
      < -3.935473, -1.718761, -2.663332>,
      < -3.936020, -1.639179, -2.744609>,
      < -3.927687, -1.718488, -2.744609>
    }
    triangle {
      < -3.927687, -1.718488, -2.744609>,
      < -3.936020, -1.639179, -2.744609>,
      < -3.873472, -1.628155, -2.736479>
    }
    triangle {
      < -3.927687, -1.718488, -2.744609>,
      < -3.873472, -1.628155, -2.736479>,
      < -3.864213, -1.716277, -2.736479>
    }
    triangle {
      < -3.864213, -1.716277, -2.736479>,
      < -3.873472, -1.628155, -2.736479>,
      < -3.873388, -1.628143, -2.633340>
    }
    triangle {
      < -3.864213, -1.716277, -2.736479>,
      < -3.873388, -1.628143, -2.633340>,
      < -3.864129, -1.716277, -2.633340>
    }
    triangle {
      < -4.391115, -1.719384, -2.828054>,
      < -4.394813, -1.704561, -2.828054>,
      < -4.388216, -1.702418, -2.842164>
    }
    triangle {
      < -4.391115, -1.719384, -2.828054>,
      < -4.388216, -1.702418, -2.842164>,
      < -4.384284, -1.718179, -2.842164>
    }
    triangle {
      < -4.384284, -1.718179, -2.842164>,
      < -4.388216, -1.702418, -2.842164>,
      < -4.288547, -1.670043, -2.813766>
    }
    triangle {
      < -4.384284, -1.718179, -2.842164>,
      < -4.288547, -1.670043, -2.813766>,
      < -4.281079, -1.699991, -2.813766>
    }
    triangle {
      < -4.281079, -1.699991, -2.813766>,
      < -4.288547, -1.670043, -2.813766>,
      < -4.188877, -1.637669, -2.769109>
    }
    triangle {
      < -4.281079, -1.699991, -2.813766>,
      < -4.188877, -1.637669, -2.769109>,
      < -4.177873, -1.681803, -2.769109>
    }
    triangle {
      < -4.177873, -1.681803, -2.769109>,
      < -4.188877, -1.637669, -2.769109>,
      < -4.176796, -1.633745, -2.756803>
    }
    triangle {
      < -4.177873, -1.681803, -2.769109>,
      < -4.176796, -1.633745, -2.756803>,
      < -4.165364, -1.679599, -2.756803>
    }
    triangle {
      < -4.165364, -1.679599, -2.756803>,
      < -4.176796, -1.633745, -2.756803>,
      < -4.156662, -1.627204, -2.779159>
    }
    triangle {
      < -4.165364, -1.679599, -2.756803>,
      < -4.156662, -1.627204, -2.779159>,
      < -4.144515, -1.675924, -2.779159>
    }
    triangle {
      < -4.144515, -1.675924, -2.779159>,
      < -4.156662, -1.627204, -2.779159>,
      < -4.076120, -1.601043, -2.764932>
    }
    triangle {
      < -4.144515, -1.675924, -2.779159>,
      < -4.076120, -1.601043, -2.764932>,
      < -4.062230, -1.650631, -2.764932>
    }
    triangle {
      < -4.062230, -1.650631, -2.764932>,
      < -4.076120, -1.601043, -2.764932>,
      < -4.041648, -1.589848, -2.663333>
    }
    triangle {
      < -4.062230, -1.650631, -2.764932>,
      < -4.041648, -1.589848, -2.663333>,
      < -4.026626, -1.643479, -2.663333>
    }
    triangle {
      < -4.026626, -1.643479, -2.663333>,
      < -4.041648, -1.589848, -2.663333>,
      < -3.962718, -1.564210, -2.663332>
    }
    triangle {
      < -4.026626, -1.643479, -2.663333>,
      < -3.962718, -1.564210, -2.663332>,
      < -3.943692, -1.640533, -2.663332>
    }
    triangle {
      < -3.943692, -1.640533, -2.663332>,
      < -3.962718, -1.564210, -2.663332>,
      < -3.955309, -1.561801, -2.744609>
    }
    triangle {
      < -3.943692, -1.640533, -2.663332>,
      < -3.955309, -1.561801, -2.744609>,
      < -3.936020, -1.639179, -2.744609>
    }
    triangle {
      < -3.936020, -1.639179, -2.744609>,
      < -3.955309, -1.561801, -2.744609>,
      < -3.894904, -1.542180, -2.736479>
    }
    triangle {
      < -3.936020, -1.639179, -2.744609>,
      < -3.894904, -1.542180, -2.736479>,
      < -3.873472, -1.628155, -2.736479>
    }
    triangle {
      < -3.873472, -1.628155, -2.736479>,
      < -3.894904, -1.542180, -2.736479>,
      < -3.894822, -1.542156, -2.633340>
    }
    triangle {
      < -3.873472, -1.628155, -2.736479>,
      < -3.894822, -1.542156, -2.633340>,
      < -3.873388, -1.628143, -2.633340>
    }
    triangle {
      < -4.394813, -1.704561, -2.828054>,
      < -4.400538, -1.690398, -2.828054>,
      < -4.394304, -1.687357, -2.842164>
    }
    triangle {
      < -4.394813, -1.704561, -2.828054>,
      < -4.394304, -1.687357, -2.842164>,
      < -4.388216, -1.702418, -2.842164>
    }
    triangle {
      < -4.388216, -1.702418, -2.842164>,
      < -4.394304, -1.687357, -2.842164>,
      < -4.300110, -1.641426, -2.813766>
    }
    triangle {
      < -4.388216, -1.702418, -2.842164>,
      < -4.300110, -1.641426, -2.813766>,
      < -4.288547, -1.670043, -2.813766>
    }
    triangle {
      < -4.288547, -1.670043, -2.813766>,
      < -4.300110, -1.641426, -2.813766>,
      < -4.205915, -1.595496, -2.769109>
    }
    triangle {
      < -4.288547, -1.670043, -2.813766>,
      < -4.205915, -1.595496, -2.769109>,
      < -4.188877, -1.637669, -2.769109>
    }
    triangle {
      < -4.188877, -1.637669, -2.769109>,
      < -4.205915, -1.595496, -2.769109>,
      < -4.194499, -1.589929, -2.756803>
    }
    triangle {
      < -4.188877, -1.637669, -2.769109>,
      < -4.194499, -1.589929, -2.756803>,
      < -4.176796, -1.633745, -2.756803>
    }
    triangle {
      < -4.176796, -1.633745, -2.756803>,
      < -4.194499, -1.589929, -2.756803>,
      < -4.175470, -1.580650, -2.779159>
    }
    triangle {
      < -4.176796, -1.633745, -2.756803>,
      < -4.175470, -1.580650, -2.779159>,
      < -4.156662, -1.627204, -2.779159>
    }
    triangle {
      < -4.156662, -1.627204, -2.779159>,
      < -4.175470, -1.580650, -2.779159>,
      < -4.094028, -1.552760, -2.764932>
    }
    triangle {
      < -4.156662, -1.627204, -2.779159>,
      < -4.094028, -1.552760, -2.764932>,
      < -4.076120, -1.601043, -2.764932>
    }
    triangle {
      < -4.076120, -1.601043, -2.764932>,
      < -4.094028, -1.552760, -2.764932>,
      < -4.061015, -1.537629, -2.663333>
    }
    triangle {
      < -4.076120, -1.601043, -2.764932>,
      < -4.061015, -1.537629, -2.663333>,
      < -4.041648, -1.589848, -2.663333>
    }
    triangle {
      < -4.041648, -1.589848, -2.663333>,
      < -4.061015, -1.537629, -2.663333>,
      < -3.992181, -1.491277, -2.663332>
    }
    triangle {
      < -4.041648, -1.589848, -2.663333>,
      < -3.992181, -1.491277, -2.663332>,
      < -3.962718, -1.564210, -2.663332>
    }
    triangle {
      < -3.962718, -1.564210, -2.663332>,
      < -3.992181, -1.491277, -2.663332>,
      < -3.985179, -1.487860, -2.744609>
    }
    triangle {
      < -3.962718, -1.564210, -2.663332>,
      < -3.985179, -1.487860, -2.744609>,
      < -3.955309, -1.561801, -2.744609>
    }
    triangle {
      < -3.955309, -1.561801, -2.744609>,
      < -3.985179, -1.487860, -2.744609>,
      < -3.928092, -1.460024, -2.736479>
    }
    triangle {
      < -3.955309, -1.561801, -2.744609>,
      < -3.928092, -1.460024, -2.736479>,
      < -3.894904, -1.542180, -2.736479>
    }
    triangle {
      < -3.894904, -1.542180, -2.736479>,
      < -3.928092, -1.460024, -2.736479>,
      < -3.928015, -1.459989, -2.633340>
    }
    triangle {
      < -3.894904, -1.542180, -2.736479>,
      < -3.928015, -1.459989, -2.633340>,
      < -3.894822, -1.542156, -2.633340>
    }
    triangle {
      < -4.400538, -1.690398, -2.828054>,
      < -4.408179, -1.677168, -2.828054>,
      < -4.402429, -1.673290, -2.842164>
    }
    triangle {
      < -4.400538, -1.690398, -2.828054>,
      < -4.402429, -1.673290, -2.842164>,
      < -4.394304, -1.687357, -2.842164>
    }
    triangle {
      < -4.394304, -1.687357, -2.842164>,
      < -4.402429, -1.673290, -2.842164>,
      < -4.315543, -1.614697, -2.813766>
    }
    triangle {
      < -4.394304, -1.687357, -2.842164>,
      < -4.315543, -1.614697, -2.813766>,
      < -4.300110, -1.641426, -2.813766>
    }
    triangle {
      < -4.300110, -1.641426, -2.813766>,
      < -4.315543, -1.614697, -2.813766>,
      < -4.228657, -1.556105, -2.769109>
    }
    triangle {
      < -4.300110, -1.641426, -2.813766>,
      < -4.228657, -1.556105, -2.769109>,
      < -4.205915, -1.595496, -2.769109>
    }
    triangle {
      < -4.205915, -1.595496, -2.769109>,
      < -4.228657, -1.556105, -2.769109>,
      < -4.218126, -1.549003, -2.756803>
    }
    triangle {
      < -4.205915, -1.595496, -2.769109>,
      < -4.218126, -1.549003, -2.756803>,
      < -4.194499, -1.589929, -2.756803>
    }
    triangle {
      < -4.194499, -1.589929, -2.756803>,
      < -4.218126, -1.549003, -2.756803>,
      < -4.200574, -1.537166, -2.779159>
    }
    triangle {
      < -4.194499, -1.589929, -2.756803>,
      < -4.200574, -1.537166, -2.779159>,
      < -4.175470, -1.580650, -2.779159>
    }
    triangle {
      < -4.138668, -1.515102, -2.768997>,
      < -4.200574, -1.537166, -2.779159>,
      < -4.135691, -1.480592, -2.764932>
    }
    triangle {
      < -4.109294, -1.496900, -2.663333>,
      < -4.138668, -1.515102, -2.768997>,
      < -4.135691, -1.480592, -2.764932>
    }
    triangle {
      < -4.109294, -1.496900, -2.663333>,
      < -4.135691, -1.480592, -2.764932>,
      < -4.106073, -1.459577, -2.663333>
    }
    triangle {
      < -4.061015, -1.537629, -2.663333>,
      < -4.106073, -1.459577, -2.663333>,
      < -4.031507, -1.423154, -2.663332>
    }
    triangle {
      < -4.061015, -1.537629, -2.663333>,
      < -4.031507, -1.423154, -2.663332>,
      < -3.992181, -1.491277, -2.663332>
    }
    triangle {
      < -3.992181, -1.491277, -2.663332>,
      < -4.031507, -1.423154, -2.663332>,
      < -4.025049, -1.418797, -2.744609>
    }
    triangle {
      < -3.992181, -1.491277, -2.663332>,
      < -4.025049, -1.418797, -2.744609>,
      < -3.985179, -1.487860, -2.744609>
    }
    triangle {
      < -3.985179, -1.487860, -2.744609>,
      < -4.025049, -1.418797, -2.744609>,
      < -3.972392, -1.383286, -2.736479>
    }
    triangle {
      < -3.985179, -1.487860, -2.744609>,
      < -3.972392, -1.383286, -2.736479>,
      < -3.928092, -1.460024, -2.736479>
    }
    triangle {
      < -3.928092, -1.460024, -2.736479>,
      < -3.972392, -1.383286, -2.736479>,
      < -3.972320, -1.383241, -2.633340>
    }
    triangle {
      < -3.928092, -1.460024, -2.736479>,
      < -3.972320, -1.383241, -2.633340>,
      < -3.928015, -1.459989, -2.633340>
    }
    triangle {
      < -4.408179, -1.677168, -2.828054>,
      < -4.417586, -1.665132, -2.828054>,
      < -4.412431, -1.660491, -2.842164>
    }
    triangle {
      < -4.408179, -1.677168, -2.828054>,
      < -4.412431, -1.660491, -2.842164>,
      < -4.402429, -1.673290, -2.842164>
    }
    triangle {
      < -4.402429, -1.673290, -2.842164>,
      < -4.412431, -1.660491, -2.842164>,
      < -4.334546, -1.590376, -2.813766>
    }
    triangle {
      < -4.402429, -1.673290, -2.842164>,
      < -4.334546, -1.590376, -2.813766>,
      < -4.315543, -1.614697, -2.813766>
    }
    triangle {
      < -4.315543, -1.614697, -2.813766>,
      < -4.334546, -1.590376, -2.813766>,
      < -4.256660, -1.520262, -2.769109>
    }
    triangle {
      < -4.315543, -1.614697, -2.813766>,
      < -4.256660, -1.520262, -2.769109>,
      < -4.228657, -1.556105, -2.769109>
    }
    triangle {
      < -4.228657, -1.556105, -2.769109>,
      < -4.256660, -1.520262, -2.769109>,
      < -4.247220, -1.511764, -2.756803>
    }
    triangle {
      < -4.228657, -1.556105, -2.769109>,
      < -4.247220, -1.511764, -2.756803>,
      < -4.218126, -1.549003, -2.756803>
    }
    triangle {
      < -4.218126, -1.549003, -2.756803>,
      < -4.247220, -1.511764, -2.756803>,
      < -4.231486, -1.497599, -2.779159>
    }
    triangle {
      < -4.218126, -1.549003, -2.756803>,
      < -4.231486, -1.497599, -2.779159>,
      < -4.200574, -1.537166, -2.779159>
    }
    triangle {
      < -4.200574, -1.537166, -2.779159>,
      < -4.231486, -1.497599, -2.779159>,
      < -4.168549, -1.440941, -2.764932>
    }
    triangle {
      < -4.200574, -1.537166, -2.779159>,
      < -4.168549, -1.440941, -2.764932>,
      < -4.135691, -1.480592, -2.764932>
    }
    triangle {
      < -4.135691, -1.480592, -2.764932>,
      < -4.168549, -1.440941, -2.764932>,
      < -4.141610, -1.416693, -2.663333>
    }
    triangle {
      < -4.135691, -1.480592, -2.764932>,
      < -4.141610, -1.416693, -2.663333>,
      < -4.106073, -1.459577, -2.663333>
    }
    triangle {
      < -4.106073, -1.459577, -2.663333>,
      < -4.141610, -1.416693, -2.663333>,
      < -4.079931, -1.361168, -2.663332>
    }
    triangle {
      < -4.106073, -1.459577, -2.663333>,
      < -4.079931, -1.361168, -2.663332>,
      < -4.031507, -1.423154, -2.663332>
    }
    triangle {
      < -4.031507, -1.423154, -2.663332>,
      < -4.079931, -1.361168, -2.663332>,
      < -4.074143, -1.355954, -2.744609>
    }
    triangle {
      < -4.031507, -1.423154, -2.663332>,
      < -4.074143, -1.355954, -2.744609>,
      < -4.025049, -1.418797, -2.744609>
    }
    triangle {
      < -4.025049, -1.418797, -2.744609>,
      < -4.074143, -1.355954, -2.744609>,
      < -4.026940, -1.313460, -2.736479>
    }
    triangle {
      < -4.025049, -1.418797, -2.744609>,
      < -4.026940, -1.313460, -2.736479>,
      < -3.972392, -1.383286, -2.736479>
    }
    triangle {
      < -3.972392, -1.383286, -2.736479>,
      < -4.026940, -1.313460, -2.736479>,
      < -4.026875, -1.313405, -2.633340>
    }
    triangle {
      < -3.972392, -1.383286, -2.736479>,
      < -4.026875, -1.313405, -2.633340>,
      < -3.972320, -1.383241, -2.633340>
    }
    triangle {
      < -4.417586, -1.665132, -2.828054>,
      < -4.428577, -1.654521, -2.828054>,
      < -4.424119, -1.649208, -2.842164>
    }
    triangle {
      < -4.417586, -1.665132, -2.828054>,
      < -4.424119, -1.649208, -2.842164>,
      < -4.412431, -1.660491, -2.842164>
    }
    triangle {
      < -4.412431, -1.660491, -2.842164>,
      < -4.424119, -1.649208, -2.842164>,
      < -4.356749, -1.568936, -2.813766>
    }
    triangle {
      < -4.412431, -1.660491, -2.842164>,
      < -4.356749, -1.568936, -2.813766>,
      < -4.334546, -1.590376, -2.813766>
    }
    triangle {
      < -4.334546, -1.590376, -2.813766>,
      < -4.356749, -1.568936, -2.813766>,
      < -4.289379, -1.488665, -2.769109>
    }
    triangle {
      < -4.334546, -1.590376, -2.813766>,
      < -4.289379, -1.488665, -2.769109>,
      < -4.256660, -1.520262, -2.769109>
    }
    triangle {
      < -4.256660, -1.520262, -2.769109>,
      < -4.289379, -1.488665, -2.769109>,
      < -4.281213, -1.478936, -2.756803>
    }
    triangle {
      < -4.256660, -1.520262, -2.769109>,
      < -4.281213, -1.478936, -2.756803>,
      < -4.247220, -1.511764, -2.756803>
    }
    triangle {
      < -4.247220, -1.511764, -2.756803>,
      < -4.281213, -1.478936, -2.756803>,
      < -4.267604, -1.462719, -2.779159>
    }
    triangle {
      < -4.247220, -1.511764, -2.756803>,
      < -4.267604, -1.462719, -2.779159>,
      < -4.231486, -1.497599, -2.779159>
    }
    triangle {
      < -4.231486, -1.497599, -2.779159>,
      < -4.267604, -1.462719, -2.779159>,
      < -4.204546, -1.404115, -2.764932>
    }
    triangle {
      < -4.231486, -1.497599, -2.779159>,
      < -4.204546, -1.404115, -2.764932>,
      < -4.168549, -1.440941, -2.764932>
    }
    triangle {
      < -4.168549, -1.440941, -2.764932>,
      < -4.204546, -1.404115, -2.764932>,
      < -4.180542, -1.376865, -2.663333>
    }
    triangle {
      < -4.168549, -1.440941, -2.764932>,
      < -4.180542, -1.376865, -2.663333>,
      < -4.141610, -1.416693, -2.663333>
    }
    triangle {
      < -4.141610, -1.416693, -2.663333>,
      < -4.180542, -1.376865, -2.663333>,
      < -4.136511, -1.306524, -2.663332>
    }
    triangle {
      < -4.141610, -1.416693, -2.663333>,
      < -4.136511, -1.306524, -2.663332>,
      < -4.079931, -1.361168, -2.663332>
    }
    triangle {
      < -4.079931, -1.361168, -2.663332>,
      < -4.136511, -1.306524, -2.663332>,
      < -4.131505, -1.300555, -2.744609>
    }
    triangle {
      < -4.079931, -1.361168, -2.663332>,
      < -4.131505, -1.300555, -2.744609>,
      < -4.074143, -1.355954, -2.744609>
    }
    triangle {
      < -4.074143, -1.355954, -2.744609>,
      < -4.131505, -1.300555, -2.744609>,
      < -4.090675, -1.251905, -2.736479>
    }
    triangle {
      < -4.074143, -1.355954, -2.744609>,
      < -4.090675, -1.251905, -2.736479>,
      < -4.026940, -1.313460, -2.736479>
    }
    triangle {
      < -4.026940, -1.313460, -2.736479>,
      < -4.090675, -1.251905, -2.736479>,
      < -4.090618, -1.251842, -2.633340>
    }
    triangle {
      < -4.026940, -1.313460, -2.736479>,
      < -4.090618, -1.251842, -2.633340>,
      < -4.026875, -1.313405, -2.633340>
    }
    triangle {
      < -4.428577, -1.654521, -2.828054>,
      < -4.440938, -1.645543, -2.828054>,
      < -4.437262, -1.639661, -2.842164>
    }
    triangle {
      < -4.428577, -1.654521, -2.828054>,
      < -4.437262, -1.639661, -2.842164>,
      < -4.424119, -1.649208, -2.842164>
    }
    triangle {
      < -4.424119, -1.649208, -2.842164>,
      < -4.437262, -1.639661, -2.842164>,
      < -4.381719, -1.550795, -2.813766>
    }
    triangle {
      < -4.424119, -1.649208, -2.842164>,
      < -4.381719, -1.550795, -2.813766>,
      < -4.356749, -1.568936, -2.813766>
    }
    triangle {
      < -4.356749, -1.568936, -2.813766>,
      < -4.381719, -1.550795, -2.813766>,
      < -4.326176, -1.461929, -2.769109>
    }
    triangle {
      < -4.356749, -1.568936, -2.813766>,
      < -4.326176, -1.461929, -2.769109>,
      < -4.289379, -1.488665, -2.769109>
    }
    triangle {
      < -4.289379, -1.488665, -2.769109>,
      < -4.326176, -1.461929, -2.769109>,
      < -4.319444, -1.451158, -2.756803>
    }
    triangle {
      < -4.289379, -1.488665, -2.769109>,
      < -4.319444, -1.451158, -2.756803>,
      < -4.281213, -1.478936, -2.756803>
    }
    triangle {
      < -4.281213, -1.478936, -2.756803>,
      < -4.319444, -1.451158, -2.756803>,
      < -4.308224, -1.433205, -2.779159>
    }
    triangle {
      < -4.281213, -1.478936, -2.756803>,
      < -4.308224, -1.433205, -2.779159>,
      < -4.267604, -1.462719, -2.779159>
    }
    triangle {
      < -4.260644, -1.387869, -2.768997>,
      < -4.308224, -1.433205, -2.779159>,
      < -4.271960, -1.355132, -2.764932>
    }
    triangle {
      < -4.241212, -1.359294, -2.663333>,
      < -4.260644, -1.387869, -2.768997>,
      < -4.271960, -1.355132, -2.764932>
    }
    triangle {
      < -4.241212, -1.359294, -2.663333>,
      < -4.271960, -1.355132, -2.764932>,
      < -4.253450, -1.323888, -2.663333>
    }
    triangle {
      < -4.180542, -1.376865, -2.663333>,
      < -4.253450, -1.323888, -2.663333>,
      < -4.200145, -1.260285, -2.663332>
    }
    triangle {
      < -4.180542, -1.376865, -2.663333>,
      < -4.200145, -1.260285, -2.663332>,
      < -4.136511, -1.306524, -2.663332>
    }
    triangle {
      < -4.136511, -1.306524, -2.663332>,
      < -4.200145, -1.260285, -2.663332>,
      < -4.196018, -1.253678, -2.744609>
    }
    triangle {
      < -4.136511, -1.306524, -2.663332>,
      < -4.196018, -1.253678, -2.744609>,
      < -4.131505, -1.300555, -2.744609>
    }
    triangle {
      < -4.131505, -1.300555, -2.744609>,
      < -4.196018, -1.253678, -2.744609>,
      < -4.162356, -1.199819, -2.736479>
    }
    triangle {
      < -4.131505, -1.300555, -2.744609>,
      < -4.162356, -1.199819, -2.736479>,
      < -4.090675, -1.251905, -2.736479>
    }
    triangle {
      < -4.090675, -1.251905, -2.736479>,
      < -4.162356, -1.199819, -2.736479>,
      < -4.162309, -1.199749, -2.633340>
    }
    triangle {
      < -4.090675, -1.251905, -2.736479>,
      < -4.162309, -1.199749, -2.633340>,
      < -4.090618, -1.251842, -2.633340>
    }
    triangle {
      < -4.440938, -1.645543, -2.828054>,
      < -4.454427, -1.638373, -2.828054>,
      < -4.451606, -1.632037, -2.842164>
    }
    triangle {
      < -4.440938, -1.645543, -2.828054>,
      < -4.451606, -1.632037, -2.842164>,
      < -4.437262, -1.639661, -2.842164>
    }
    triangle {
      < -4.437262, -1.639661, -2.842164>,
      < -4.451606, -1.632037, -2.842164>,
      < -4.408971, -1.536305, -2.813766>
    }
    triangle {
      < -4.437262, -1.639661, -2.842164>,
      < -4.408971, -1.536305, -2.813766>,
      < -4.381719, -1.550795, -2.813766>
    }
    triangle {
      < -4.381719, -1.550795, -2.813766>,
      < -4.408971, -1.536305, -2.813766>,
      < -4.366336, -1.440574, -2.769109>
    }
    triangle {
      < -4.381719, -1.550795, -2.813766>,
      < -4.366336, -1.440574, -2.769109>,
      < -4.326176, -1.461929, -2.769109>
    }
    triangle {
      < -4.326176, -1.461929, -2.769109>,
      < -4.366336, -1.440574, -2.769109>,
      < -4.361169, -1.428972, -2.756803>
    }
    triangle {
      < -4.326176, -1.461929, -2.769109>,
      < -4.361169, -1.428972, -2.756803>,
      < -4.319444, -1.451158, -2.756803>
    }
    triangle {
      < -4.319444, -1.451158, -2.756803>,
      < -4.361169, -1.428972, -2.756803>,
      < -4.352557, -1.409632, -2.779159>
    }
    triangle {
      < -4.319444, -1.451158, -2.756803>,
      < -4.352557, -1.409632, -2.779159>,
      < -4.308224, -1.433205, -2.779159>
    }
    triangle {
      < -4.308224, -1.433205, -2.779159>,
      < -4.352557, -1.409632, -2.779159>,
      < -4.318105, -1.332273, -2.764932>
    }
    triangle {
      < -4.308224, -1.433205, -2.779159>,
      < -4.318105, -1.332273, -2.764932>,
      < -4.271960, -1.355132, -2.764932>
    }
    triangle {
      < -4.271960, -1.355132, -2.764932>,
      < -4.318105, -1.332273, -2.764932>,
      < -4.303357, -1.299165, -2.663333>
    }
    triangle {
      < -4.271960, -1.355132, -2.764932>,
      < -4.303357, -1.299165, -2.663333>,
      < -4.253450, -1.323888, -2.663333>
    }
    triangle {
      < -4.253450, -1.323888, -2.663333>,
      < -4.303357, -1.299165, -2.663333>,
      < -4.269595, -1.223353, -2.663332>
    }
    triangle {
      < -4.253450, -1.323888, -2.663333>,
      < -4.269595, -1.223353, -2.663332>,
      < -4.200145, -1.260285, -2.663332>
    }
    triangle {
      < -4.200145, -1.260285, -2.663332>,
      < -4.269595, -1.223353, -2.663332>,
      < -4.266428, -1.216235, -2.744609>
    }
    triangle {
      < -4.200145, -1.260285, -2.663332>,
      < -4.266428, -1.216235, -2.744609>,
      < -4.196018, -1.253678, -2.744609>
    }
    triangle {
      < -4.196018, -1.253678, -2.744609>,
      < -4.266428, -1.216235, -2.744609>,
      < -4.240589, -1.158216, -2.736479>
    }
    triangle {
      < -4.196018, -1.253678, -2.744609>,
      < -4.240589, -1.158216, -2.736479>,
      < -4.162356, -1.199819, -2.736479>
    }
    triangle {
      < -4.162356, -1.199819, -2.736479>,
      < -4.240589, -1.158216, -2.736479>,
      < -4.240552, -1.158140, -2.633340>
    }
    triangle {
      < -4.162356, -1.199819, -2.736479>,
      < -4.240552, -1.158140, -2.633340>,
      < -4.162309, -1.199749, -2.633340>
    }
    triangle {
      < -4.454427, -1.638373, -2.828054>,
      < -4.468783, -1.633150, -2.828054>,
      < -4.466872, -1.626483, -2.842164>
    }
    triangle {
      < -4.454427, -1.638373, -2.828054>,
      < -4.466872, -1.626483, -2.842164>,
      < -4.451606, -1.632037, -2.842164>
    }
    triangle {
      < -4.451606, -1.632037, -2.842164>,
      < -4.466872, -1.626483, -2.842164>,
      < -4.437975, -1.525750, -2.813766>
    }
    triangle {
      < -4.451606, -1.632037, -2.842164>,
      < -4.437975, -1.525750, -2.813766>,
      < -4.408971, -1.536305, -2.813766>
    }
    triangle {
      < -4.408971, -1.536305, -2.813766>,
      < -4.437975, -1.525750, -2.813766>,
      < -4.409078, -1.425017, -2.769109>
    }
    triangle {
      < -4.408971, -1.536305, -2.813766>,
      < -4.409078, -1.425017, -2.769109>,
      < -4.366336, -1.440574, -2.769109>
    }
    triangle {
      < -4.366336, -1.440574, -2.769109>,
      < -4.409078, -1.425017, -2.769109>,
      < -4.405575, -1.412808, -2.756803>
    }
    triangle {
      < -4.366336, -1.440574, -2.769109>,
      < -4.405575, -1.412808, -2.756803>,
      < -4.361169, -1.428972, -2.756803>
    }
    triangle {
      < -4.361169, -1.428972, -2.756803>,
      < -4.405575, -1.412808, -2.756803>,
      < -4.399738, -1.392457, -2.779159>
    }
    triangle {
      < -4.361169, -1.428972, -2.756803>,
      < -4.399738, -1.392457, -2.779159>,
      < -4.352557, -1.409632, -2.779159>
    }
    triangle {
      < -4.352557, -1.409632, -2.779159>,
      < -4.399738, -1.392457, -2.779159>,
      < -4.365968, -1.313272, -2.764932>
    }
    triangle {
      < -4.352557, -1.409632, -2.779159>,
      < -4.365968, -1.313272, -2.764932>,
      < -4.318105, -1.332273, -2.764932>
    }
    triangle {
      < -4.318105, -1.332273, -2.764932>,
      < -4.365968, -1.313272, -2.764932>,
      < -4.355122, -1.278614, -2.663333>
    }
    triangle {
      < -4.318105, -1.332273, -2.764932>,
      < -4.355122, -1.278614, -2.663333>,
      < -4.303357, -1.299165, -2.663333>
    }
    triangle {
      < -4.303357, -1.299165, -2.663333>,
      < -4.355122, -1.278614, -2.663333>,
      < -4.343509, -1.196446, -2.663332>
    }
    triangle {
      < -4.303357, -1.299165, -2.663333>,
      < -4.343509, -1.196446, -2.663332>,
      < -4.269595, -1.223353, -2.663332>
    }
    triangle {
      < -4.269595, -1.223353, -2.663332>,
      < -4.343509, -1.196446, -2.663332>,
      < -4.341362, -1.188956, -2.744609>
    }
    triangle {
      < -4.269595, -1.223353, -2.663332>,
      < -4.341362, -1.188956, -2.744609>,
      < -4.266428, -1.216235, -2.744609>
    }
    triangle {
      < -4.266428, -1.216235, -2.744609>,
      < -4.341362, -1.188956, -2.744609>,
      < -4.323850, -1.127906, -2.736479>
    }
    triangle {
      < -4.266428, -1.216235, -2.744609>,
      < -4.323850, -1.127906, -2.736479>,
      < -4.240589, -1.158216, -2.736479>
    }
    triangle {
      < -4.240589, -1.158216, -2.736479>,
      < -4.323850, -1.127906, -2.736479>,
      < -4.323824, -1.127825, -2.633340>
    }
    triangle {
      < -4.240589, -1.158216, -2.736479>,
      < -4.323824, -1.127825, -2.633340>,
      < -4.240552, -1.158140, -2.633340>
    }
    triangle {
      < -4.468783, -1.633150, -2.828054>,
      < -4.483727, -1.629976, -2.828054>,
      < -4.482761, -1.623108, -2.842164>
    }
    triangle {
      < -4.468783, -1.633150, -2.828054>,
      < -4.482761, -1.623108, -2.842164>,
      < -4.466872, -1.626483, -2.842164>
    }
    triangle {
      < -4.466872, -1.626483, -2.842164>,
      < -4.482761, -1.623108, -2.842164>,
      < -4.468165, -1.519333, -2.813766>
    }
    triangle {
      < -4.466872, -1.626483, -2.842164>,
      < -4.468165, -1.519333, -2.813766>,
      < -4.437975, -1.525750, -2.813766>
    }
    triangle {
      < -4.437975, -1.525750, -2.813766>,
      < -4.468165, -1.519333, -2.813766>,
      < -4.453568, -1.415559, -2.769109>
    }
    triangle {
      < -4.437975, -1.525750, -2.813766>,
      < -4.453568, -1.415559, -2.769109>,
      < -4.409078, -1.425017, -2.769109>
    }
    triangle {
      < -4.409078, -1.425017, -2.769109>,
      < -4.453568, -1.415559, -2.769109>,
      < -4.451799, -1.402981, -2.756803>
    }
    triangle {
      < -4.409078, -1.425017, -2.769109>,
      < -4.451799, -1.402981, -2.756803>,
      < -4.405575, -1.412808, -2.756803>
    }
    triangle {
      < -4.405575, -1.412808, -2.756803>,
      < -4.451799, -1.402981, -2.756803>,
      < -4.448852, -1.382016, -2.779159>
    }
    triangle {
      < -4.405575, -1.412808, -2.756803>,
      < -4.448852, -1.382016, -2.779159>,
      < -4.399738, -1.392457, -2.779159>
    }
    triangle {
      < -4.423824, -1.321247, -2.768997>,
      < -4.448852, -1.382016, -2.779159>,
      < -4.447477, -1.295943, -2.764932>
    }
    triangle {
      < -4.417695, -1.287239, -2.663333>,
      < -4.423824, -1.321247, -2.768997>,
      < -4.447477, -1.295943, -2.764932>
    }
    triangle {
      < -4.417695, -1.287239, -2.663333>,
      < -4.447477, -1.295943, -2.764932>,
      < -4.443275, -1.259872, -2.663333>
    }
    triangle {
      < -4.355122, -1.278614, -2.663333>,
      < -4.443275, -1.259872, -2.663333>,
      < -4.420448, -1.180087, -2.663332>
    }
    triangle {
      < -4.355122, -1.278614, -2.663333>,
      < -4.420448, -1.180087, -2.663332>,
      < -4.343509, -1.196446, -2.663332>
    }
    triangle {
      < -4.343509, -1.196446, -2.663332>,
      < -4.420448, -1.180087, -2.663332>,
      < -4.419365, -1.172372, -2.744609>
    }
    triangle {
      < -4.343509, -1.196446, -2.663332>,
      < -4.419365, -1.172372, -2.744609>,
      < -4.341362, -1.188956, -2.744609>
    }
    triangle {
      < -4.341362, -1.188956, -2.744609>,
      < -4.419365, -1.172372, -2.744609>,
      < -4.410519, -1.109478, -2.736479>
    }
    triangle {
      < -4.341362, -1.188956, -2.744609>,
      < -4.410519, -1.109478, -2.736479>,
      < -4.323850, -1.127906, -2.736479>
    }
    triangle {
      < -4.323850, -1.127906, -2.736479>,
      < -4.410519, -1.109478, -2.736479>,
      < -4.410504, -1.109395, -2.633340>
    }
    triangle {
      < -4.323850, -1.127906, -2.736479>,
      < -4.410504, -1.109395, -2.633340>,
      < -4.323824, -1.127825, -2.633340>
    }
    triangle {
      < -4.483727, -1.629976, -2.828054>,
      < -4.498979, -1.628912, -2.828054>,
      < -4.482761, -1.623108, -2.842164>
    }
    triangle {
      < -4.482761, -1.623108, -2.842164>,
      < -4.484917, -1.518167, -2.813766>,
      < -4.468165, -1.519333, -2.813766>
    }
    triangle {
      < -4.484917, -1.518167, -2.813766>,
      < -4.491599, -1.413064, -2.769109>,
      < -4.453568, -1.415559, -2.769109>
    }
    triangle {
      < -4.484917, -1.518167, -2.813766>,
      < -4.453568, -1.415559, -2.769109>,
      < -4.468165, -1.519333, -2.813766>
    }
    triangle {
      < -4.491599, -1.413064, -2.769109>,
      < -4.498977, -1.399683, -2.756803>,
      < -4.451799, -1.402981, -2.756803>
    }
    triangle {
      < -4.491599, -1.413064, -2.769109>,
      < -4.451799, -1.402981, -2.756803>,
      < -4.453568, -1.415559, -2.769109>
    }
    triangle {
      < -4.451799, -1.402981, -2.756803>,
      < -4.498977, -1.399683, -2.756803>,
      < -4.498977, -1.378512, -2.779159>
    }
    triangle {
      < -4.451799, -1.402981, -2.756803>,
      < -4.498977, -1.378512, -2.779159>,
      < -4.448852, -1.382016, -2.779159>
    }
    triangle {
      < -4.448852, -1.382016, -2.779159>,
      < -4.498977, -1.378512, -2.779159>,
      < -4.498977, -1.293829, -2.764932>
    }
    triangle {
      < -4.448852, -1.382016, -2.779159>,
      < -4.498977, -1.293829, -2.764932>,
      < -4.447477, -1.295943, -2.764932>
    }
    triangle {
      < -4.447477, -1.295943, -2.764932>,
      < -4.498977, -1.293829, -2.764932>,
      < -4.498974, -1.257585, -2.663333>
    }
    triangle {
      < -4.447477, -1.295943, -2.764932>,
      < -4.498974, -1.257585, -2.663333>,
      < -4.443275, -1.259872, -2.663333>
    }
    triangle {
      < -4.443275, -1.259872, -2.663333>,
      < -4.498974, -1.257585, -2.663333>,
      < -4.498974, -1.174595, -2.663332>
    }
    triangle {
      < -4.443275, -1.259872, -2.663333>,
      < -4.498974, -1.174595, -2.663332>,
      < -4.420448, -1.180087, -2.663332>
    }
    triangle {
      < -4.420448, -1.180087, -2.663332>,
      < -4.498974, -1.174595, -2.663332>,
      < -4.498976, -1.166804, -2.744609>
    }
    triangle {
      < -4.420448, -1.180087, -2.663332>,
      < -4.498976, -1.166804, -2.744609>,
      < -4.419365, -1.172372, -2.744609>
    }
    triangle {
      < -4.419365, -1.172372, -2.744609>,
      < -4.498976, -1.166804, -2.744609>,
      < -4.498976, -1.103292, -2.736479>
    }
    triangle {
      < -4.419365, -1.172372, -2.744609>,
      < -4.498976, -1.103292, -2.736479>,
      < -4.410519, -1.109478, -2.736479>
    }
    triangle {
      < -4.410519, -1.109478, -2.736479>,
      < -4.498976, -1.103292, -2.736479>,
      < -4.498973, -1.103207, -2.633340>
    }
    triangle {
      < -4.410519, -1.109478, -2.736479>,
      < -4.498973, -1.103207, -2.633340>,
      < -4.410504, -1.109395, -2.633340>
    }
    triangle {
      < -4.484917, -1.518167, -2.813766>,
      < -4.498978, -1.514298, -2.792428>,
      < -4.498977, -1.399683, -2.756803>
    }
    triangle {
      < -4.484917, -1.518167, -2.813766>,
      < -4.498977, -1.399683, -2.756803>,
      < -4.491599, -1.413064, -2.769109>
    }
    triangle {
      < -4.304855, -1.850467, -2.792428>,
      < -4.301181, -1.836364, -2.813766>,
      < -4.213502, -1.894709, -2.769109>
    }
    triangle {
      < -4.304855, -1.850467, -2.792428>,
      < -4.213502, -1.894709, -2.769109>,
      < -4.205600, -1.907782, -2.756803>
    }
    triangle {
      < -4.315229, -1.860699, -2.813766>,
      < -4.304855, -1.850467, -2.792428>,
      < -4.205600, -1.907782, -2.756803>
    }
    triangle {
      < -4.315229, -1.860699, -2.813766>,
      < -4.205600, -1.907782, -2.756803>,
      < -4.220871, -1.907472, -2.769109>
    }
    triangle {
      < -4.696710, -1.836390, -2.813766>,
      < -4.693035, -1.850491, -2.792428>,
      < -4.792297, -1.907794, -2.756803>
    }
    triangle {
      < -4.696710, -1.836390, -2.813766>,
      < -4.792297, -1.907794, -2.756803>,
      < -4.784394, -1.894722, -2.769109>
    }
    triangle {
      < -4.498977, -1.399683, -2.756803>,
      < -4.506346, -1.413064, -2.769109>,
      < -4.544351, -1.415561, -2.769109>
    }
    triangle {
      < -4.498977, -1.399683, -2.756803>,
      < -4.544351, -1.415561, -2.769109>,
      < -4.546118, -1.402983, -2.756803>
    }
    triangle {
      < -4.693035, -1.850491, -2.792428>,
      < -4.682658, -1.860723, -2.813766>,
      < -4.777024, -1.907486, -2.769109>
    }
    triangle {
      < -4.693035, -1.850491, -2.792428>,
      < -4.777024, -1.907486, -2.769109>,
      < -4.792297, -1.907794, -2.756803>
    }
    triangle {
      < -4.498978, -1.514298, -2.792428>,
      < -4.484917, -1.518167, -2.813766>,
      < -4.482761, -1.623108, -2.842164>
    }
    triangle {
      < -4.498978, -1.514298, -2.792428>,
      < -4.482761, -1.623108, -2.842164>,
      < -4.498979, -1.628912, -2.828054>
    }
    triangle {
      < -4.513028, -1.518169, -2.813766>,
      < -4.498978, -1.514298, -2.792428>,
      < -4.498979, -1.628912, -2.828054>
    }
    triangle {
      < -4.513028, -1.518169, -2.813766>,
      < -4.498979, -1.628912, -2.828054>,
      < -4.515183, -1.623114, -2.842164>
    }
    triangle {
      < -4.693035, -1.850491, -2.792428>,
      < -4.696710, -1.836390, -2.813766>,
      < -4.606904, -1.782057, -2.842164>
    }
    triangle {
      < -4.693035, -1.850491, -2.792428>,
      < -4.606904, -1.782057, -2.842164>,
      < -4.593773, -1.793188, -2.828054>
    }
    triangle {
      < -4.682658, -1.860723, -2.813766>,
      < -4.693035, -1.850491, -2.792428>,
      < -4.593773, -1.793188, -2.828054>
    }
    triangle {
      < -4.682658, -1.860723, -2.813766>,
      < -4.593773, -1.793188, -2.828054>,
      < -4.590693, -1.810121, -2.842164>
    }
    triangle {
      < -4.304855, -1.850467, -2.792428>,
      < -4.315229, -1.860699, -2.813766>,
      < -4.407185, -1.810088, -2.842164>
    }
    triangle {
      < -4.304855, -1.850467, -2.792428>,
      < -4.407185, -1.810088, -2.842164>,
      < -4.404109, -1.793151, -2.828054>
    }
    triangle {
      < -4.301181, -1.836364, -2.813766>,
      < -4.304855, -1.850467, -2.792428>,
      < -4.404109, -1.793151, -2.828054>
    }
    triangle {
      < -4.301181, -1.836364, -2.813766>,
      < -4.404109, -1.793151, -2.828054>,
      < -4.390984, -1.782018, -2.842164>
    }
    triangle {
      < -4.448852, -1.382016, -2.779159>,
      < -4.423824, -1.321247, -2.768997>,
      < -4.397869, -1.326766, -2.768997>
    }
    triangle {
      < -4.448852, -1.382016, -2.779159>,
      < -4.397869, -1.326766, -2.768997>,
      < -4.399738, -1.392457, -2.779159>
    }
    triangle {
      < -4.399738, -1.392457, -2.779159>,
      < -4.397869, -1.326766, -2.768997>,
      < -4.365968, -1.313272, -2.764932>
    }
    triangle {
      < -4.423824, -1.321247, -2.768997>,
      < -4.417695, -1.287239, -2.663333>,
      < -4.389624, -1.293207, -2.663333>
    }
    triangle {
      < -4.423824, -1.321247, -2.768997>,
      < -4.389624, -1.293207, -2.663333>,
      < -4.397869, -1.326766, -2.768997>
    }
    triangle {
      < -4.397869, -1.326766, -2.768997>,
      < -4.389624, -1.293207, -2.663333>,
      < -4.355122, -1.278614, -2.663333>
    }
    triangle {
      < -4.397869, -1.326766, -2.768997>,
      < -4.355122, -1.278614, -2.663333>,
      < -4.365968, -1.313272, -2.764932>
    }
    triangle {
      < -4.239177, -1.403467, -2.768997>,
      < -4.217996, -1.376163, -2.663333>,
      < -4.180542, -1.376865, -2.663333>
    }
    triangle {
      < -4.239177, -1.403467, -2.768997>,
      < -4.180542, -1.376865, -2.663333>,
      < -4.204546, -1.404115, -2.764932>
    }
    triangle {
      < -4.260644, -1.387869, -2.768997>,
      < -4.241212, -1.359294, -2.663333>,
      < -4.217996, -1.376163, -2.663333>
    }
    triangle {
      < -4.260644, -1.387869, -2.768997>,
      < -4.217996, -1.376163, -2.663333>,
      < -4.239177, -1.403467, -2.768997>
    }
    triangle {
      < -4.308224, -1.433205, -2.779159>,
      < -4.260644, -1.387869, -2.768997>,
      < -4.239177, -1.403467, -2.768997>
    }
    triangle {
      < -4.308224, -1.433205, -2.779159>,
      < -4.239177, -1.403467, -2.768997>,
      < -4.267604, -1.462719, -2.779159>
    }
    triangle {
      < -4.267604, -1.462719, -2.779159>,
      < -4.239177, -1.403467, -2.768997>,
      < -4.204546, -1.404115, -2.764932>
    }
    triangle {
      < -4.200574, -1.537166, -2.779159>,
      < -4.138668, -1.515102, -2.768997>,
      < -4.125401, -1.538082, -2.768997>
    }
    triangle {
      < -4.200574, -1.537166, -2.779159>,
      < -4.125401, -1.538082, -2.768997>,
      < -4.175470, -1.580650, -2.779159>
    }
    triangle {
      < -4.175470, -1.580650, -2.779159>,
      < -4.125401, -1.538082, -2.768997>,
      < -4.094028, -1.552760, -2.764932>
    }
    triangle {
      < -4.138668, -1.515102, -2.768997>,
      < -4.109294, -1.496900, -2.663333>,
      < -4.094946, -1.521754, -2.663333>
    }
    triangle {
      < -4.138668, -1.515102, -2.768997>,
      < -4.094946, -1.521754, -2.663333>,
      < -4.125401, -1.538082, -2.768997>
    }
    triangle {
      < -4.125401, -1.538082, -2.768997>,
      < -4.094946, -1.521754, -2.663333>,
      < -4.061015, -1.537629, -2.663333>
    }
    triangle {
      < -4.125401, -1.538082, -2.768997>,
      < -4.061015, -1.537629, -2.663333>,
      < -4.094028, -1.552760, -2.764932>
    }
    triangle {
      < -4.076213, -1.707335, -2.768997>,
      < -4.041750, -1.704806, -2.663333>,
      < -4.017209, -1.733109, -2.663333>
    }
    triangle {
      < -4.076213, -1.707335, -2.768997>,
      < -4.017209, -1.733109, -2.663333>,
      < -4.053522, -1.733505, -2.764932>
    }
    triangle {
      < -4.078987, -1.680946, -2.768997>,
      < -4.044749, -1.676265, -2.663333>,
      < -4.041750, -1.704806, -2.663333>
    }
    triangle {
      < -4.078987, -1.680946, -2.768997>,
      < -4.041750, -1.704806, -2.663333>,
      < -4.076213, -1.707335, -2.768997>
    }
    triangle {
      < -4.139267, -1.725859, -2.779159>,
      < -4.076213, -1.707335, -2.768997>,
      < -4.053522, -1.733505, -2.764932>
    }
    triangle {
      < -4.144515, -1.675924, -2.779159>,
      < -4.078987, -1.680946, -2.768997>,
      < -4.076213, -1.707335, -2.768997>
    }
    triangle {
      < -4.144515, -1.675924, -2.779159>,
      < -4.076213, -1.707335, -2.768997>,
      < -4.139267, -1.725859, -2.779159>
    }
    triangle {
      < -4.149739, -1.825486, -2.779159>,
      < -4.091918, -1.856727, -2.768997>,
      < -4.100119, -1.881963, -2.768997>
    }
    triangle {
      < -4.149739, -1.825486, -2.779159>,
      < -4.100119, -1.881963, -2.768997>,
      < -4.165255, -1.873239, -2.779159>
    }
    triangle {
      < -4.165255, -1.873239, -2.779159>,
      < -4.100119, -1.881963, -2.768997>,
      < -4.090033, -1.915100, -2.764932>
    }
    triangle {
      < -4.091918, -1.856727, -2.768997>,
      < -4.058736, -1.866377, -2.663333>,
      < -4.067605, -1.893670, -2.663333>
    }
    triangle {
      < -4.091918, -1.856727, -2.768997>,
      < -4.067605, -1.893670, -2.663333>,
      < -4.100119, -1.881963, -2.768997>
    }
    triangle {
      < -4.100119, -1.881963, -2.768997>,
      < -4.067605, -1.893670, -2.663333>,
      < -4.056698, -1.929508, -2.663333>
    }
    triangle {
      < -4.100119, -1.881963, -2.768997>,
      < -4.056698, -1.929508, -2.663333>,
      < -4.090033, -1.915100, -2.764932>
    }
    triangle {
      < -4.248940, -1.997308, -2.779159>,
      < -4.192983, -2.031771, -2.768997>,
      < -4.197247, -2.066145, -2.764932>
    }
    triangle {
      < -4.215343, -1.959994, -2.779159>,
      < -4.175228, -2.012052, -2.768997>,
      < -4.192983, -2.031771, -2.768997>
    }
    triangle {
      < -4.215343, -1.959994, -2.779159>,
      < -4.192983, -2.031771, -2.768997>,
      < -4.248940, -1.997308, -2.779159>
    }
    triangle {
      < -4.175228, -2.012052, -2.768997>,
      < -4.148839, -2.034363, -2.663333>,
      < -4.168042, -2.055689, -2.663333>
    }
    triangle {
      < -4.175228, -2.012052, -2.768997>,
      < -4.168042, -2.055689, -2.663333>,
      < -4.192983, -2.031771, -2.768997>
    }
    triangle {
      < -4.192983, -2.031771, -2.768997>,
      < -4.168042, -2.055689, -2.663333>,
      < -4.172654, -2.092865, -2.663333>
    }
    triangle {
      < -4.192983, -2.031771, -2.768997>,
      < -4.172654, -2.092865, -2.663333>,
      < -4.197247, -2.066145, -2.764932>
    }
    triangle {
      < -4.314510, -2.120064, -2.768997>,
      < -4.299478, -2.151179, -2.663333>,
      < -4.325695, -2.162851, -2.663333>
    }
    triangle {
      < -4.314510, -2.120064, -2.768997>,
      < -4.325695, -2.162851, -2.663333>,
      < -4.338751, -2.130857, -2.768997>
    }
    triangle {
      < -4.338751, -2.130857, -2.768997>,
      < -4.325695, -2.162851, -2.663333>,
      < -4.345028, -2.194938, -2.663333>
    }
    triangle {
      < -4.338751, -2.130857, -2.768997>,
      < -4.345028, -2.194938, -2.663333>,
      < -4.356627, -2.160525, -2.764932>
    }
    triangle {
      < -4.329984, -2.056191, -2.779159>,
      < -4.314510, -2.120064, -2.768997>,
      < -4.338751, -2.130857, -2.768997>
    }
    triangle {
      < -4.329984, -2.056191, -2.779159>,
      < -4.338751, -2.130857, -2.768997>,
      < -4.375854, -2.076614, -2.779159>
    }
    triangle {
      < -4.375854, -2.076614, -2.779159>,
      < -4.338751, -2.130857, -2.768997>,
      < -4.356627, -2.160525, -2.764932>
    }
    triangle {
      < -4.473840, -2.097443, -2.779159>,
      < -4.485683, -2.162088, -2.768997>,
      < -4.512218, -2.162088, -2.768997>
    }
    triangle {
      < -4.473840, -2.097443, -2.779159>,
      < -4.512218, -2.162088, -2.768997>,
      < -4.524051, -2.097444, -2.779159>
    }
    triangle {
      < -4.524051, -2.097444, -2.779159>,
      < -4.512218, -2.162088, -2.768997>,
      < -4.540616, -2.181921, -2.764932>
    }
    triangle {
      < -4.512218, -2.162088, -2.768997>,
      < -4.513304, -2.196627, -2.663333>,
      < -4.544017, -2.218076, -2.663333>
    }
    triangle {
      < -4.512218, -2.162088, -2.768997>,
      < -4.544017, -2.218076, -2.663333>,
      < -4.540616, -2.181921, -2.764932>
    }
    triangle {
      < -4.485683, -2.162088, -2.768997>,
      < -4.484606, -2.196627, -2.663333>,
      < -4.513304, -2.196627, -2.663333>
    }
    triangle {
      < -4.485683, -2.162088, -2.768997>,
      < -4.513304, -2.196627, -2.663333>,
      < -4.512218, -2.162088, -2.768997>
    }
    triangle {
      < -4.659151, -2.130858, -2.768997>,
      < -4.672215, -2.162849, -2.663333>,
      < -4.698431, -2.151177, -2.663333>
    }
    triangle {
      < -4.659151, -2.130858, -2.768997>,
      < -4.698431, -2.151177, -2.663333>,
      < -4.683391, -2.120065, -2.768997>
    }
    triangle {
      < -4.683391, -2.120065, -2.768997>,
      < -4.698431, -2.151177, -2.663333>,
      < -4.735213, -2.158279, -2.663333>
    }
    triangle {
      < -4.683391, -2.120065, -2.768997>,
      < -4.735213, -2.158279, -2.663333>,
      < -4.717400, -2.126633, -2.764932>
    }
    triangle {
      < -4.622038, -2.076618, -2.779159>,
      < -4.659151, -2.130858, -2.768997>,
      < -4.683391, -2.120065, -2.768997>
    }
    triangle {
      < -4.622038, -2.076618, -2.779159>,
      < -4.683391, -2.120065, -2.768997>,
      < -4.667908, -2.056197, -2.779159>
    }
    triangle {
      < -4.667908, -2.056197, -2.779159>,
      < -4.683391, -2.120065, -2.768997>,
      < -4.717400, -2.126633, -2.764932>
    }
    triangle {
      < -4.822674, -2.012054, -2.768997>,
      < -4.849068, -2.034359, -2.663333>,
      < -4.885559, -2.025887, -2.663333>
    }
    triangle {
      < -4.822674, -2.012054, -2.768997>,
      < -4.885559, -2.025887, -2.663333>,
      < -4.856414, -2.004221, -2.764932>
    }
    triangle {
      < -4.804919, -2.031773, -2.768997>,
      < -4.829865, -2.055685, -2.663333>,
      < -4.849068, -2.034359, -2.663333>
    }
    triangle {
      < -4.804919, -2.031773, -2.768997>,
      < -4.849068, -2.034359, -2.663333>,
      < -4.822674, -2.012054, -2.768997>
    }
    triangle {
      < -4.782553, -1.960004, -2.779159>,
      < -4.822674, -2.012054, -2.768997>,
      < -4.856414, -2.004221, -2.764932>
    }
    triangle {
      < -4.748954, -1.997317, -2.779159>,
      < -4.804919, -2.031773, -2.768997>,
      < -4.822674, -2.012054, -2.768997>
    }
    triangle {
      < -4.748954, -1.997317, -2.779159>,
      < -4.822674, -2.012054, -2.768997>,
      < -4.782553, -1.960004, -2.779159>
    }
    triangle {
      < -4.848162, -1.825499, -2.779159>,
      < -4.905985, -1.856730, -2.768997>,
      < -4.933622, -1.835851, -2.764932>
    }
    triangle {
      < -4.832644, -1.873251, -2.779159>,
      < -4.897785, -1.881966, -2.768997>,
      < -4.905985, -1.856730, -2.768997>
    }
    triangle {
      < -4.832644, -1.873251, -2.779159>,
      < -4.905985, -1.856730, -2.768997>,
      < -4.848162, -1.825499, -2.779159>
    }
    triangle {
      < -4.905985, -1.856730, -2.768997>,
      < -4.939169, -1.866371, -2.663333>,
      < -4.969059, -1.843790, -2.663333>
    }
    triangle {
      < -4.905985, -1.856730, -2.768997>,
      < -4.969059, -1.843790, -2.663333>,
      < -4.933622, -1.835851, -2.764932>
    }
    triangle {
      < -4.897785, -1.881966, -2.768997>,
      < -4.930300, -1.893664, -2.663333>,
      < -4.939169, -1.866371, -2.663333>
    }
    triangle {
      < -4.897785, -1.881966, -2.768997>,
      < -4.939169, -1.866371, -2.663333>,
      < -4.905985, -1.856730, -2.768997>
    }
    triangle {
      < -4.858637, -1.725872, -2.779159>,
      < -4.921691, -1.707338, -2.768997>,
      < -4.918918, -1.680949, -2.768997>
    }
    triangle {
      < -4.858637, -1.725872, -2.779159>,
      < -4.918918, -1.680949, -2.768997>,
      < -4.853391, -1.675936, -2.779159>
    }
    triangle {
      < -4.853391, -1.675936, -2.779159>,
      < -4.918918, -1.680949, -2.768997>,
      < -4.935674, -1.650634, -2.764932>
    }
    triangle {
      < -4.921691, -1.707338, -2.768997>,
      < -4.956154, -1.704800, -2.663333>,
      < -4.953155, -1.676260, -2.663333>
    }
    triangle {
      < -4.921691, -1.707338, -2.768997>,
      < -4.953155, -1.676260, -2.663333>,
      < -4.918918, -1.680949, -2.768997>
    }
    triangle {
      < -4.918918, -1.680949, -2.768997>,
      < -4.953155, -1.676260, -2.663333>,
      < -4.971276, -1.643473, -2.663333>
    }
    triangle {
      < -4.918918, -1.680949, -2.768997>,
      < -4.971276, -1.643473, -2.663333>,
      < -4.935674, -1.650634, -2.764932>
    }
    triangle {
      < -4.859238, -1.515104, -2.768997>,
      < -4.888607, -1.496895, -2.663333>,
      < -4.891827, -1.459573, -2.663333>
    }
    triangle {
      < -4.859238, -1.515104, -2.768997>,
      < -4.891827, -1.459573, -2.663333>,
      < -4.862215, -1.480595, -2.764932>
    }
    triangle {
      < -4.872504, -1.538084, -2.768997>,
      < -4.902955, -1.521749, -2.663333>,
      < -4.888607, -1.496895, -2.663333>
    }
    triangle {
      < -4.872504, -1.538084, -2.768997>,
      < -4.888607, -1.496895, -2.663333>,
      < -4.859238, -1.515104, -2.768997>
    }
    triangle {
      < -4.797337, -1.537177, -2.779159>,
      < -4.859238, -1.515104, -2.768997>,
      < -4.862215, -1.480595, -2.764932>
    }
    triangle {
      < -4.822440, -1.580661, -2.779159>,
      < -4.872504, -1.538084, -2.768997>,
      < -4.859238, -1.515104, -2.768997>
    }
    triangle {
      < -4.822440, -1.580661, -2.779159>,
      < -4.859238, -1.515104, -2.768997>,
      < -4.797337, -1.537177, -2.779159>
    }
    triangle {
      < -4.689691, -1.433212, -2.779159>,
      < -4.737262, -1.387871, -2.768997>,
      < -4.725947, -1.355134, -2.764932>
    }
    triangle {
      < -4.730310, -1.462727, -2.779159>,
      < -4.758729, -1.403468, -2.768997>,
      < -4.737262, -1.387871, -2.768997>
    }
    triangle {
      < -4.730310, -1.462727, -2.779159>,
      < -4.737262, -1.387871, -2.768997>,
      < -4.689691, -1.433212, -2.779159>
    }
    triangle {
      < -4.737262, -1.387871, -2.768997>,
      < -4.756687, -1.359290, -2.663333>,
      < -4.744448, -1.323885, -2.663333>
    }
    triangle {
      < -4.737262, -1.387871, -2.768997>,
      < -4.744448, -1.323885, -2.663333>,
      < -4.725947, -1.355134, -2.764932>
    }
    triangle {
      < -4.758729, -1.403468, -2.768997>,
      < -4.779903, -1.376160, -2.663333>,
      < -4.756687, -1.359290, -2.663333>
    }
    triangle {
      < -4.758729, -1.403468, -2.768997>,
      < -4.756687, -1.359290, -2.663333>,
      < -4.737262, -1.387871, -2.768997>
    }
    triangle {
      < -4.598177, -1.392461, -2.779159>,
      < -4.600038, -1.326766, -2.768997>,
      < -4.574083, -1.321248, -2.768997>
    }
    triangle {
      < -4.598177, -1.392461, -2.779159>,
      < -4.574083, -1.321248, -2.768997>,
      < -4.549065, -1.382018, -2.779159>
    }
    triangle {
      < -4.549065, -1.382018, -2.779159>,
      < -4.574083, -1.321248, -2.768997>,
      < -4.550430, -1.295944, -2.764932>
    }
    triangle {
      < -4.574083, -1.321248, -2.768997>,
      < -4.580204, -1.287238, -2.663333>,
      < -4.554622, -1.259871, -2.663333>
    }
    triangle {
      < -4.574083, -1.321248, -2.768997>,
      < -4.554622, -1.259871, -2.663333>,
      < -4.550430, -1.295944, -2.764932>
    }
    triangle {
      < -4.600038, -1.326766, -2.768997>,
      < -4.608274, -1.293206, -2.663333>,
      < -4.580204, -1.287238, -2.663333>
    }
    triangle {
      < -4.600038, -1.326766, -2.768997>,
      < -4.580204, -1.287238, -2.663333>,
      < -4.574083, -1.321248, -2.768997>
    }
    triangle {
      < -4.825254, -2.092861, -2.663333>,
      < -4.885559, -2.025887, -2.663333>,
      < -4.849068, -2.034359, -2.663333>
    }
    triangle {
      < -4.825254, -2.092861, -2.663333>,
      < -4.849068, -2.034359, -2.663333>,
      < -4.829865, -2.055685, -2.663333>
    }
    triangle {
      < -4.652881, -2.194936, -2.663333>,
      < -4.735213, -2.158279, -2.663333>,
      < -4.698431, -2.151177, -2.663333>
    }
    triangle {
      < -4.652881, -2.194936, -2.663333>,
      < -4.698431, -2.151177, -2.663333>,
      < -4.672215, -2.162849, -2.663333>
    }
    triangle {
      < -4.453893, -2.218077, -2.663333>,
      < -4.544017, -2.218076, -2.663333>,
      < -4.513304, -2.196627, -2.663333>
    }
    triangle {
      < -4.453893, -2.218077, -2.663333>,
      < -4.513304, -2.196627, -2.663333>,
      < -4.484606, -2.196627, -2.663333>
    }
    triangle {
      < -4.262696, -2.158282, -2.663333>,
      < -4.345028, -2.194938, -2.663333>,
      < -4.325695, -2.162851, -2.663333>
    }
    triangle {
      < -4.262696, -2.158282, -2.663333>,
      < -4.325695, -2.162851, -2.663333>,
      < -4.299478, -2.151179, -2.663333>
    }
    triangle {
      < -4.112349, -2.025892, -2.663333>,
      < -4.172654, -2.092865, -2.663333>,
      < -4.168042, -2.055689, -2.663333>
    }
    triangle {
      < -4.112349, -2.025892, -2.663333>,
      < -4.168042, -2.055689, -2.663333>,
      < -4.148839, -2.034363, -2.663333>
    }
    triangle {
      < -4.028846, -1.843796, -2.663333>,
      < -4.056698, -1.929508, -2.663333>,
      < -4.067605, -1.893670, -2.663333>
    }
    triangle {
      < -4.028846, -1.843796, -2.663333>,
      < -4.067605, -1.893670, -2.663333>,
      < -4.058736, -1.866377, -2.663333>
    }
    triangle {
      < -4.026626, -1.643479, -2.663333>,
      < -4.017209, -1.733109, -2.663333>,
      < -4.041750, -1.704806, -2.663333>
    }
    triangle {
      < -4.026626, -1.643479, -2.663333>,
      < -4.041750, -1.704806, -2.663333>,
      < -4.044749, -1.676265, -2.663333>
    }
    triangle {
      < -4.106073, -1.459577, -2.663333>,
      < -4.061015, -1.537629, -2.663333>,
      < -4.094946, -1.521754, -2.663333>
    }
    triangle {
      < -4.106073, -1.459577, -2.663333>,
      < -4.094946, -1.521754, -2.663333>,
      < -4.109294, -1.496900, -2.663333>
    }
    triangle {
      < -4.253450, -1.323888, -2.663333>,
      < -4.180542, -1.376865, -2.663333>,
      < -4.217996, -1.376163, -2.663333>
    }
    triangle {
      < -4.253450, -1.323888, -2.663333>,
      < -4.217996, -1.376163, -2.663333>,
      < -4.241212, -1.359294, -2.663333>
    }
    triangle {
      < -4.443275, -1.259872, -2.663333>,
      < -4.355122, -1.278614, -2.663333>,
      < -4.389624, -1.293207, -2.663333>
    }
    triangle {
      < -4.443275, -1.259872, -2.663333>,
      < -4.389624, -1.293207, -2.663333>,
      < -4.417695, -1.287239, -2.663333>
    }
    triangle {
      < -4.969059, -1.843790, -2.663333>,
      < -4.941208, -1.929502, -2.663333>,
      < -5.021717, -1.949631, -2.663332>
    }
    triangle {
      < -4.969059, -1.843790, -2.663333>,
      < -5.021717, -1.949631, -2.663332>,
      < -5.046024, -1.874822, -2.663332>
    }
    triangle {
      < -4.971276, -1.643473, -2.663333>,
      < -4.980695, -1.733103, -2.663333>,
      < -5.062430, -1.718747, -2.663332>
    }
    triangle {
      < -4.971276, -1.643473, -2.663333>,
      < -5.062430, -1.718747, -2.663332>,
      < -5.054209, -1.640519, -2.663332>
    }
    triangle {
      < -4.891827, -1.459573, -2.663333>,
      < -4.936887, -1.537623, -2.663333>,
      < -5.005716, -1.491264, -2.663332>
    }
    triangle {
      < -4.891827, -1.459573, -2.663333>,
      < -5.005716, -1.491264, -2.663332>,
      < -4.966388, -1.423142, -2.663332>
    }
    triangle {
      < -4.744448, -1.323885, -2.663333>,
      < -4.817358, -1.376861, -2.663333>,
      < -4.861381, -1.306514, -2.663332>
    }
    triangle {
      < -4.744448, -1.323885, -2.663333>,
      < -4.861381, -1.306514, -2.663332>,
      < -4.797746, -1.260278, -2.663332>
    }
    triangle {
      < -4.554622, -1.259871, -2.663333>,
      < -4.642776, -1.278613, -2.663333>,
      < -4.654381, -1.196442, -2.663332>
    }
    triangle {
      < -4.554622, -1.259871, -2.663333>,
      < -4.654381, -1.196442, -2.663332>,
      < -4.577441, -1.180085, -2.663332>
    }
    triangle {
      < -4.513682, -1.718945, -2.852345>,
      < -4.514230, -1.670987, -2.843713>,
      < -4.498971, -1.670327, -2.844015>
    }
    triangle {
      < -4.513682, -1.718945, -2.852345>,
      < -4.498971, -1.670327, -2.844015>,
      < -4.498962, -1.718909, -2.852781>
    }
    triangle {
      < -4.537259, -1.673463, -2.841802>,
      < -4.529215, -1.672935, -2.842822>,
      < -4.528247, -1.719049, -2.851049>
    }
    triangle {
      < -4.529215, -1.672935, -2.842822>,
      < -4.514230, -1.670987, -2.843713>,
      < -4.513682, -1.718945, -2.852345>
    }
    triangle {
      < -4.529215, -1.672935, -2.842822>,
      < -4.513682, -1.718945, -2.852345>,
      < -4.528247, -1.719049, -2.851049>
    }
    triangle {
      < -4.498971, -1.670327, -2.844015>,
      < -4.483706, -1.670982, -2.843714>,
      < -4.484243, -1.718942, -2.852345>
    }
    triangle {
      < -4.498971, -1.670327, -2.844015>,
      < -4.484243, -1.718942, -2.852345>,
      < -4.498962, -1.718909, -2.852781>
    }
    triangle {
      < -4.483706, -1.670982, -2.843714>,
      < -4.468720, -1.672926, -2.842824>,
      < -4.469678, -1.719043, -2.851051>
    }
    triangle {
      < -4.483706, -1.670982, -2.843714>,
      < -4.469678, -1.719043, -2.851051>,
      < -4.484243, -1.718942, -2.852345>
    }
    triangle {
      < -4.468720, -1.672926, -2.842824>,
      < -4.460676, -1.673450, -2.841804>,
      < -4.469678, -1.719043, -2.851051>
    }
    triangle {
      < -4.460676, -1.673450, -2.841804>,
      < -4.446811, -1.677655, -2.840264>,
      < -4.455413, -1.719208, -2.848939>
    }
    triangle {
      < -4.460676, -1.673450, -2.841804>,
      < -4.455413, -1.719208, -2.848939>,
      < -4.469678, -1.719043, -2.851051>
    }
    triangle {
      < -4.446811, -1.677655, -2.840264>,
      < -4.435079, -1.680317, -2.838027>,
      < -4.443026, -1.708975, -2.845357>
    }
    triangle {
      < -4.446811, -1.677655, -2.840264>,
      < -4.443026, -1.708975, -2.845357>,
      < -4.455413, -1.719208, -2.848939>
    }
    triangle {
      < -4.435079, -1.680317, -2.838027>,
      < -4.422682, -1.686381, -2.835714>,
      < -4.428818, -1.709425, -2.841648>
    }
    triangle {
      < -4.435079, -1.680317, -2.838027>,
      < -4.428818, -1.709425, -2.841648>,
      < -4.443026, -1.708975, -2.845357>
    }
    triangle {
      < -4.417920, -1.692665, -2.835422>,
      < -4.415323, -1.709956, -2.837276>,
      < -4.428818, -1.709425, -2.841648>
    }
    triangle {
      < -4.421799, -1.720634, -2.840566>,
      < -4.391115, -1.719384, -2.828054>,
      < -4.415568, -1.728363, -2.838889>
    }
    triangle {
      < -4.391115, -1.719384, -2.828054>,
      < -4.400762, -1.736575, -2.833268>,
      < -4.412785, -1.738668, -2.838093>
    }
    triangle {
      < -4.391115, -1.719384, -2.828054>,
      < -4.412785, -1.738668, -2.838093>,
      < -4.412143, -1.735762, -2.837839>
    }
    triangle {
      < -4.400762, -1.736575, -2.833268>,
      < -4.401987, -1.745914, -2.833677>,
      < -4.414826, -1.741768, -2.838815>
    }
    triangle {
      < -4.400762, -1.736575, -2.833268>,
      < -4.414826, -1.741768, -2.838815>,
      < -4.412785, -1.738668, -2.838093>
    }
    triangle {
      < -4.401987, -1.745914, -2.833677>,
      < -4.404830, -1.754884, -2.834395>,
      < -4.418086, -1.744261, -2.839917>
    }
    triangle {
      < -4.401987, -1.745914, -2.833677>,
      < -4.418086, -1.744261, -2.839917>,
      < -4.414826, -1.741768, -2.838815>
    }
    triangle {
      < -4.404830, -1.754884, -2.834395>,
      < -4.409395, -1.763922, -2.835397>,
      < -4.422791, -1.747297, -2.841394>
    }
    triangle {
      < -4.404830, -1.754884, -2.834395>,
      < -4.422791, -1.747297, -2.841394>,
      < -4.418086, -1.744261, -2.839917>
    }
    triangle {
      < -4.409395, -1.763922, -2.835397>,
      < -4.415427, -1.772594, -2.836540>,
      < -4.428440, -1.750271, -2.843014>
    }
    triangle {
      < -4.409395, -1.763922, -2.835397>,
      < -4.428440, -1.750271, -2.843014>,
      < -4.422791, -1.747297, -2.841394>
    }
    triangle {
      < -4.415427, -1.772594, -2.836540>,
      < -4.422977, -1.780868, -2.837771>,
      < -4.435215, -1.753411, -2.844747>
    }
    triangle {
      < -4.415427, -1.772594, -2.836540>,
      < -4.435215, -1.753411, -2.844747>,
      < -4.428440, -1.750271, -2.843014>
    }
    triangle {
      < -4.422977, -1.780868, -2.837771>,
      < -4.431971, -1.788932, -2.838923>,
      < -4.443049, -1.757434, -2.846415>
    }
    triangle {
      < -4.422977, -1.780868, -2.837771>,
      < -4.443049, -1.757434, -2.846415>,
      < -4.435215, -1.753411, -2.844747>
    }
    triangle {
      < -4.431971, -1.788932, -2.838923>,
      < -4.442109, -1.795994, -2.839975>,
      < -4.451542, -1.760986, -2.847925>
    }
    triangle {
      < -4.431971, -1.788932, -2.838923>,
      < -4.451542, -1.760986, -2.847925>,
      < -4.443049, -1.757434, -2.846415>
    }
    triangle {
      < -4.442109, -1.795994, -2.839975>,
      < -4.453445, -1.801850, -2.840937>,
      < -4.461042, -1.763883, -2.849307>
    }
    triangle {
      < -4.442109, -1.795994, -2.839975>,
      < -4.461042, -1.763883, -2.849307>,
      < -4.451542, -1.760986, -2.847925>
    }
    triangle {
      < -4.453445, -1.801850, -2.840937>,
      < -4.465652, -1.806768, -2.841603>,
      < -4.471114, -1.766977, -2.850321>
    }
    triangle {
      < -4.453445, -1.801850, -2.840937>,
      < -4.471114, -1.766977, -2.850321>,
      < -4.461042, -1.763883, -2.849307>
    }
    triangle {
      < -4.465652, -1.806768, -2.841603>,
      < -4.478774, -1.810492, -2.841981>,
      < -4.482196, -1.769908, -2.850970>
    }
    triangle {
      < -4.465652, -1.806768, -2.841603>,
      < -4.482196, -1.769908, -2.850970>,
      < -4.471114, -1.766977, -2.850321>
    }
    triangle {
      < -4.478774, -1.810492, -2.841981>,
      < -4.491744, -1.812827, -2.842009>,
      < -4.492434, -1.772411, -2.851121>
    }
    triangle {
      < -4.478774, -1.810492, -2.841981>,
      < -4.492434, -1.772411, -2.851121>,
      < -4.482196, -1.769908, -2.850970>
    }
    triangle {
      < -4.491744, -1.812827, -2.842009>,
      < -4.506121, -1.812829, -2.842010>,
      < -4.505435, -1.772412, -2.851122>
    }
    triangle {
      < -4.491744, -1.812827, -2.842009>,
      < -4.505435, -1.772412, -2.851122>,
      < -4.492434, -1.772411, -2.851121>
    }
    triangle {
      < -4.506121, -1.812829, -2.842010>,
      < -4.519097, -1.810501, -2.841982>,
      < -4.515684, -1.769917, -2.850970>
    }
    triangle {
      < -4.506121, -1.812829, -2.842010>,
      < -4.515684, -1.769917, -2.850970>,
      < -4.505435, -1.772412, -2.851122>
    }
    triangle {
      < -4.519097, -1.810501, -2.841982>,
      < -4.532222, -1.806781, -2.841603>,
      < -4.526771, -1.766988, -2.850321>
    }
    triangle {
      < -4.519097, -1.810501, -2.841982>,
      < -4.526771, -1.766988, -2.850321>,
      < -4.515684, -1.769917, -2.850970>
    }
    triangle {
      < -4.532222, -1.806781, -2.841603>,
      < -4.544432, -1.801868, -2.840937>,
      < -4.536848, -1.763898, -2.849308>
    }
    triangle {
      < -4.532222, -1.806781, -2.841603>,
      < -4.536848, -1.763898, -2.849308>,
      < -4.526771, -1.766988, -2.850321>
    }
    triangle {
      < -4.544432, -1.801868, -2.840937>,
      < -4.555644, -1.796140, -2.839976>,
      < -4.546091, -1.761263, -2.847952>
    }
    triangle {
      < -4.544432, -1.801868, -2.840937>,
      < -4.546091, -1.761263, -2.847952>,
      < -4.536848, -1.763898, -2.849308>
    }
    triangle {
      < -4.555644, -1.796140, -2.839976>,
      < -4.565916, -1.788957, -2.838923>,
      < -4.554851, -1.757454, -2.846414>
    }
    triangle {
      < -4.555644, -1.796140, -2.839976>,
      < -4.554851, -1.757454, -2.846414>,
      < -4.546091, -1.761263, -2.847952>
    }
    triangle {
      < -4.565916, -1.788957, -2.838923>,
      < -4.574913, -1.780896, -2.837770>,
      < -4.562688, -1.753434, -2.844745>
    }
    triangle {
      < -4.565916, -1.788957, -2.838923>,
      < -4.562688, -1.753434, -2.844745>,
      < -4.554851, -1.757454, -2.846414>
    }
    triangle {
      < -4.574913, -1.780896, -2.837770>,
      < -4.582467, -1.772623, -2.836539>,
      < -4.569467, -1.750294, -2.843013>
    }
    triangle {
      < -4.574913, -1.780896, -2.837770>,
      < -4.569467, -1.750294, -2.843013>,
      < -4.562688, -1.753434, -2.844745>
    }
    triangle {
      < -4.582467, -1.772623, -2.836539>,
      < -4.588618, -1.763813, -2.835366>,
      < -4.575357, -1.747036, -2.841324>
    }
    triangle {
      < -4.582467, -1.772623, -2.836539>,
      < -4.575357, -1.747036, -2.841324>,
      < -4.569467, -1.750294, -2.843013>
    }
    triangle {
      < -4.588618, -1.763813, -2.835366>,
      < -4.593072, -1.754914, -2.834394>,
      < -4.579824, -1.744281, -2.839914>
    }
    triangle {
      < -4.588618, -1.763813, -2.835366>,
      < -4.579824, -1.744281, -2.839914>,
      < -4.575357, -1.747036, -2.841324>
    }
    triangle {
      < -4.593072, -1.754914, -2.834394>,
      < -4.595918, -1.745944, -2.833675>,
      < -4.583084, -1.741786, -2.838813>
    }
    triangle {
      < -4.593072, -1.754914, -2.834394>,
      < -4.583084, -1.741786, -2.838813>,
      < -4.579824, -1.744281, -2.839914>
    }
    triangle {
      < -4.595918, -1.745944, -2.833675>,
      < -4.597146, -1.736606, -2.833266>,
      < -4.585126, -1.738689, -2.838090>
    }
    triangle {
      < -4.595918, -1.745944, -2.833675>,
      < -4.585126, -1.738689, -2.838090>,
      < -4.583084, -1.741786, -2.838813>
    }
    triangle {
      < -4.597146, -1.736606, -2.833266>,
      < -4.606796, -1.719425, -2.828054>,
      < -4.585766, -1.735803, -2.837837>
    }
    triangle {
      < -4.597146, -1.736606, -2.833266>,
      < -4.585766, -1.735803, -2.837837>,
      < -4.585126, -1.738689, -2.838090>
    }
    triangle {
      < -4.606796, -1.719425, -2.828054>,
      < -4.576113, -1.720668, -2.840566>,
      < -4.582342, -1.728392, -2.838888>
    }
    triangle {
      < -4.603104, -1.704601, -2.828054>,
      < -4.597384, -1.690435, -2.828054>,
      < -4.582591, -1.709989, -2.837276>
    }
    triangle {
      < -4.582591, -1.709989, -2.837276>,
      < -4.580003, -1.692694, -2.835421>,
      < -4.569101, -1.709448, -2.841646>
    }
    triangle {
      < -4.575243, -1.686408, -2.835713>,
      < -4.562851, -1.680337, -2.838025>,
      < -4.554898, -1.708987, -2.845354>
    }
    triangle {
      < -4.575243, -1.686408, -2.835713>,
      < -4.554898, -1.708987, -2.845354>,
      < -4.569101, -1.709448, -2.841646>
    }
    triangle {
      < -4.562851, -1.680337, -2.838025>,
      < -4.551122, -1.677672, -2.840262>,
      < -4.542511, -1.719217, -2.848936>
    }
    triangle {
      < -4.562851, -1.680337, -2.838025>,
      < -4.542511, -1.719217, -2.848936>,
      < -4.554898, -1.708987, -2.845354>
    }
    triangle {
      < -4.551122, -1.677672, -2.840262>,
      < -4.537259, -1.673463, -2.841802>,
      < -4.528247, -1.719049, -2.851049>
    }
    triangle {
      < -4.551122, -1.677672, -2.840262>,
      < -4.528247, -1.719049, -2.851049>,
      < -4.542511, -1.719217, -2.848936>
    }
    triangle {
      < -4.565133, -1.713125, -2.853366>,
      < -4.571749, -1.723348, -2.852286>,
      < -4.577860, -1.713619, -2.848997>
    }
    triangle {
      < -4.582591, -1.709989, -2.837276>,
      < -4.606796, -1.719425, -2.828054>,
      < -4.603104, -1.704601, -2.828054>
    }
    triangle {
      < -4.391115, -1.719384, -2.828054>,
      < -4.421799, -1.720634, -2.840566>,
      < -4.415323, -1.709956, -2.837276>
    }
    triangle {
      < -4.426163, -1.723317, -2.852286>,
      < -4.432785, -1.713105, -2.853368>,
      < -4.420053, -1.713589, -2.848996>
    }
    triangle {
      < -4.606796, -1.719425, -2.828054>,
      < -4.582342, -1.728392, -2.838888>,
      < -4.585766, -1.735803, -2.837837>
    }
    triangle {
      < -4.415568, -1.728363, -2.838889>,
      < -4.391115, -1.719384, -2.828054>,
      < -4.412143, -1.735762, -2.837839>
    }
    triangle {
      < -4.498962, -1.721745, -2.864501>,
      < -4.492802, -1.770488, -2.862842>,
      < -4.505068, -1.770489, -2.862842>
    }
    triangle {
      < -4.498962, -1.721745, -2.864501>,
      < -4.505068, -1.770489, -2.862842>,
      < -4.512849, -1.721778, -2.864064>
    }
    triangle {
      < -4.492802, -1.770488, -2.862842>,
      < -4.485075, -1.721775, -2.864065>,
      < -4.483144, -1.768208, -2.862690>
    }
    triangle {
      < -4.485075, -1.721775, -2.864065>,
      < -4.492802, -1.770488, -2.862842>,
      < -4.498962, -1.721745, -2.864501>
    }
    triangle {
      < -4.472689, -1.765537, -2.862041>,
      < -4.471334, -1.721867, -2.862772>,
      < -4.454239, -1.722017, -2.859846>
    }
    triangle {
      < -4.472689, -1.765537, -2.862041>,
      < -4.454239, -1.722017, -2.859846>,
      < -4.463186, -1.762718, -2.861027>
    }
    triangle {
      < -4.471334, -1.721867, -2.862772>,
      < -4.472689, -1.765537, -2.862041>,
      < -4.483144, -1.768208, -2.862690>
    }
    triangle {
      < -4.471334, -1.721867, -2.862772>,
      < -4.483144, -1.768208, -2.862690>,
      < -4.485075, -1.721775, -2.864065>
    }
    triangle {
      < -4.454224, -1.760080, -2.859645>,
      < -4.441517, -1.712695, -2.856265>,
      < -4.446211, -1.756843, -2.858135>
    }
    triangle {
      < -4.441517, -1.712695, -2.856265>,
      < -4.454224, -1.760080, -2.859645>,
      < -4.463186, -1.762718, -2.861027>
    }
    triangle {
      < -4.441517, -1.712695, -2.856265>,
      < -4.463186, -1.762718, -2.861027>,
      < -4.454239, -1.722017, -2.859846>
    }
    triangle {
      < -4.438821, -1.753178, -2.856467>,
      < -4.432785, -1.713105, -2.853368>,
      < -4.426163, -1.723317, -2.852286>
    }
    triangle {
      < -4.438821, -1.753178, -2.856467>,
      < -4.426163, -1.723317, -2.852286>,
      < -4.432428, -1.750317, -2.854735>
    }
    triangle {
      < -4.512849, -1.721778, -2.864064>,
      < -4.514738, -1.768216, -2.862690>,
      < -4.525197, -1.765548, -2.862041>
    }
    triangle {
      < -4.512849, -1.721778, -2.864064>,
      < -4.525197, -1.765548, -2.862041>,
      < -4.526590, -1.721872, -2.862770>
    }
    triangle {
      < -4.514738, -1.768216, -2.862690>,
      < -4.512849, -1.721778, -2.864064>,
      < -4.505068, -1.770489, -2.862842>
    }
    triangle {
      < -4.543686, -1.722026, -2.859843>,
      < -4.534705, -1.762733, -2.861027>,
      < -4.543425, -1.760332, -2.859672>
    }
    triangle {
      < -4.543686, -1.722026, -2.859843>,
      < -4.543425, -1.760332, -2.859672>,
      < -4.556407, -1.712705, -2.856261>
    }
    triangle {
      < -4.534705, -1.762733, -2.861027>,
      < -4.543686, -1.722026, -2.859843>,
      < -4.526590, -1.721872, -2.862770>
    }
    triangle {
      < -4.534705, -1.762733, -2.861027>,
      < -4.526590, -1.721872, -2.862770>,
      < -4.525197, -1.765548, -2.862041>
    }
    triangle {
      < -4.559083, -1.753199, -2.856466>,
      < -4.565133, -1.713125, -2.853366>,
      < -4.556407, -1.712705, -2.856261>
    }
    triangle {
      < -4.559083, -1.753199, -2.856466>,
      < -4.556407, -1.712705, -2.856261>,
      < -4.551689, -1.756862, -2.858134>
    }
    triangle {
      < -4.551689, -1.756862, -2.858134>,
      < -4.556407, -1.712705, -2.856261>,
      < -4.543425, -1.760332, -2.859672>
    }
    triangle {
      < -4.571749, -1.723348, -2.852286>,
      < -4.565478, -1.750338, -2.854733>,
      < -4.571035, -1.747370, -2.853045>
    }
    triangle {
      < -4.571749, -1.723348, -2.852286>,
      < -4.571035, -1.747370, -2.853045>,
      < -4.577626, -1.730384, -2.850608>
    }
    triangle {
      < -4.565478, -1.750338, -2.854733>,
      < -4.571749, -1.723348, -2.852286>,
      < -4.565133, -1.713125, -2.853366>
    }
    triangle {
      < -4.565478, -1.750338, -2.854733>,
      < -4.565133, -1.713125, -2.853366>,
      < -4.559083, -1.753199, -2.856466>
    }
    triangle {
      < -4.580855, -1.737136, -2.849557>,
      < -4.575250, -1.744860, -2.851635>,
      < -4.578326, -1.742587, -2.850533>
    }
    triangle {
      < -4.580855, -1.737136, -2.849557>,
      < -4.578326, -1.742587, -2.850533>,
      < -4.580252, -1.739766, -2.849810>
    }
    triangle {
      < -4.575250, -1.744860, -2.851635>,
      < -4.580855, -1.737136, -2.849557>,
      < -4.577626, -1.730384, -2.850608>
    }
    triangle {
      < -4.575250, -1.744860, -2.851635>,
      < -4.577626, -1.730384, -2.850608>,
      < -4.571035, -1.747370, -2.853045>
    }
    triangle {
      < -4.432785, -1.713105, -2.853368>,
      < -4.438821, -1.753178, -2.856467>,
      < -4.446211, -1.756843, -2.858135>
    }
    triangle {
      < -4.432785, -1.713105, -2.853368>,
      < -4.446211, -1.756843, -2.858135>,
      < -4.441517, -1.712695, -2.856265>
    }
    triangle {
      < -4.427099, -1.747608, -2.853114>,
      < -4.420285, -1.730358, -2.850609>,
      < -4.417053, -1.737099, -2.849559>
    }
    triangle {
      < -4.427099, -1.747608, -2.853114>,
      < -4.417053, -1.737099, -2.849559>,
      < -4.422660, -1.744842, -2.851637>
    }
    triangle {
      < -4.420285, -1.730358, -2.850609>,
      < -4.427099, -1.747608, -2.853114>,
      < -4.432428, -1.750317, -2.854735>
    }
    triangle {
      < -4.420285, -1.730358, -2.850609>,
      < -4.432428, -1.750317, -2.854735>,
      < -4.426163, -1.723317, -2.852286>
    }
    triangle {
      < -4.422660, -1.744842, -2.851637>,
      < -4.417053, -1.737099, -2.849559>,
      < -4.417658, -1.739747, -2.849813>
    }
    triangle {
      < -4.422660, -1.744842, -2.851637>,
      < -4.417658, -1.739747, -2.849813>,
      < -4.419585, -1.742571, -2.850535>
    }
    triangle {
      < -4.580003, -1.692694, -2.835421>,
      < -4.575243, -1.686408, -2.835713>,
      < -4.569101, -1.709448, -2.841646>
    }
    triangle {
      < -4.422682, -1.686381, -2.835714>,
      < -4.417920, -1.692665, -2.835422>,
      < -4.428818, -1.709425, -2.841648>
    }
    triangle {
      < -4.415323, -1.709956, -2.837276>,
      < -4.400538, -1.690398, -2.828054>,
      < -4.394813, -1.704561, -2.828054>
    }
    triangle {
      < -4.580003, -1.692694, -2.835421>,
      < -4.582591, -1.709989, -2.837276>,
      < -4.597384, -1.690435, -2.828054>
    }
    triangle {
      < -4.580003, -1.692694, -2.835421>,
      < -4.597384, -1.690435, -2.828054>,
      < -4.589748, -1.677203, -2.828054>
    }
    triangle {
      < -4.575243, -1.686408, -2.835713>,
      < -4.580003, -1.692694, -2.835421>,
      < -4.589748, -1.677203, -2.828054>
    }
    triangle {
      < -4.575243, -1.686408, -2.835713>,
      < -4.589748, -1.677203, -2.828054>,
      < -4.580346, -1.665163, -2.828054>
    }
    triangle {
      < -4.562851, -1.680337, -2.838025>,
      < -4.575243, -1.686408, -2.835713>,
      < -4.580346, -1.665163, -2.828054>
    }
    triangle {
      < -4.562851, -1.680337, -2.838025>,
      < -4.580346, -1.665163, -2.828054>,
      < -4.569359, -1.654548, -2.828054>
    }
    triangle {
      < -4.551122, -1.677672, -2.840262>,
      < -4.562851, -1.680337, -2.838025>,
      < -4.569359, -1.654548, -2.828054>
    }
    triangle {
      < -4.551122, -1.677672, -2.840262>,
      < -4.569359, -1.654548, -2.828054>,
      < -4.557002, -1.645565, -2.828054>
    }
    triangle {
      < -4.537259, -1.673463, -2.841802>,
      < -4.551122, -1.677672, -2.840262>,
      < -4.557002, -1.645565, -2.828054>
    }
    triangle {
      < -4.537259, -1.673463, -2.841802>,
      < -4.557002, -1.645565, -2.828054>,
      < -4.543515, -1.638390, -2.828054>
    }
    triangle {
      < -4.529215, -1.672935, -2.842822>,
      < -4.537259, -1.673463, -2.841802>,
      < -4.543515, -1.638390, -2.828054>
    }
    triangle {
      < -4.529215, -1.672935, -2.842822>,
      < -4.543515, -1.638390, -2.828054>,
      < -4.529160, -1.633162, -2.828054>
    }
    triangle {
      < -4.514230, -1.670987, -2.843713>,
      < -4.529215, -1.672935, -2.842822>,
      < -4.529160, -1.633162, -2.828054>
    }
    triangle {
      < -4.514230, -1.670987, -2.843713>,
      < -4.529160, -1.633162, -2.828054>,
      < -4.514218, -1.629982, -2.828054>
    }
    triangle {
      < -4.498971, -1.670327, -2.844015>,
      < -4.514230, -1.670987, -2.843713>,
      < -4.514218, -1.629982, -2.828054>
    }
    triangle {
      < -4.498971, -1.670327, -2.844015>,
      < -4.514218, -1.629982, -2.828054>,
      < -4.498979, -1.628912, -2.828054>
    }
    triangle {
      < -4.483706, -1.670982, -2.843714>,
      < -4.498971, -1.670327, -2.844015>,
      < -4.498979, -1.628912, -2.828054>
    }
    triangle {
      < -4.483706, -1.670982, -2.843714>,
      < -4.498979, -1.628912, -2.828054>,
      < -4.483727, -1.629976, -2.828054>
    }
    triangle {
      < -4.468720, -1.672926, -2.842824>,
      < -4.483706, -1.670982, -2.843714>,
      < -4.483727, -1.629976, -2.828054>
    }
    triangle {
      < -4.468720, -1.672926, -2.842824>,
      < -4.483727, -1.629976, -2.828054>,
      < -4.468783, -1.633150, -2.828054>
    }
    triangle {
      < -4.460676, -1.673450, -2.841804>,
      < -4.468720, -1.672926, -2.842824>,
      < -4.468783, -1.633150, -2.828054>
    }
    triangle {
      < -4.460676, -1.673450, -2.841804>,
      < -4.468783, -1.633150, -2.828054>,
      < -4.454427, -1.638373, -2.828054>
    }
    triangle {
      < -4.446811, -1.677655, -2.840264>,
      < -4.460676, -1.673450, -2.841804>,
      < -4.454427, -1.638373, -2.828054>
    }
    triangle {
      < -4.446811, -1.677655, -2.840264>,
      < -4.454427, -1.638373, -2.828054>,
      < -4.440938, -1.645543, -2.828054>
    }
    triangle {
      < -4.435079, -1.680317, -2.838027>,
      < -4.446811, -1.677655, -2.840264>,
      < -4.440938, -1.645543, -2.828054>
    }
    triangle {
      < -4.435079, -1.680317, -2.838027>,
      < -4.440938, -1.645543, -2.828054>,
      < -4.428577, -1.654521, -2.828054>
    }
    triangle {
      < -4.422682, -1.686381, -2.835714>,
      < -4.435079, -1.680317, -2.838027>,
      < -4.428577, -1.654521, -2.828054>
    }
    triangle {
      < -4.422682, -1.686381, -2.835714>,
      < -4.428577, -1.654521, -2.828054>,
      < -4.417586, -1.665132, -2.828054>
    }
    triangle {
      < -4.417920, -1.692665, -2.835422>,
      < -4.422682, -1.686381, -2.835714>,
      < -4.417586, -1.665132, -2.828054>
    }
    triangle {
      < -4.417920, -1.692665, -2.835422>,
      < -4.417586, -1.665132, -2.828054>,
      < -4.408179, -1.677168, -2.828054>
    }
    triangle {
      < -4.415323, -1.709956, -2.837276>,
      < -4.417920, -1.692665, -2.835422>,
      < -4.408179, -1.677168, -2.828054>
    }
    triangle {
      < -4.415323, -1.709956, -2.837276>,
      < -4.408179, -1.677168, -2.828054>,
      < -4.400538, -1.690398, -2.828054>
    }
    triangle {
      < -4.391115, -1.719384, -2.828054>,
      < -4.415323, -1.709956, -2.837276>,
      < -4.394813, -1.704561, -2.828054>
    }
    triangle {
      < -4.400762, -1.736575, -2.833268>,
      < -4.391115, -1.719384, -2.828054>,
      < -4.389516, -1.734577, -2.828054>
    }
    triangle {
      < -4.401987, -1.745914, -2.833677>,
      < -4.400762, -1.736575, -2.833268>,
      < -4.389516, -1.734577, -2.828054>
    }
    triangle {
      < -4.401987, -1.745914, -2.833677>,
      < -4.389516, -1.734577, -2.828054>,
      < -4.390046, -1.749844, -2.828054>
    }
    triangle {
      < -4.404830, -1.754884, -2.834395>,
      < -4.401987, -1.745914, -2.833677>,
      < -4.390046, -1.749844, -2.828054>
    }
    triangle {
      < -4.404830, -1.754884, -2.834395>,
      < -4.390046, -1.749844, -2.828054>,
      < -4.392696, -1.764889, -2.828054>
    }
    triangle {
      < -4.409395, -1.763922, -2.835397>,
      < -4.404830, -1.754884, -2.834395>,
      < -4.392696, -1.764889, -2.828054>
    }
    triangle {
      < -4.409395, -1.763922, -2.835397>,
      < -4.392696, -1.764889, -2.828054>,
      < -4.397415, -1.779420, -2.828054>
    }
    triangle {
      < -4.415427, -1.772594, -2.836540>,
      < -4.409395, -1.763922, -2.835397>,
      < -4.397415, -1.779420, -2.828054>
    }
    triangle {
      < -4.415427, -1.772594, -2.836540>,
      < -4.397415, -1.779420, -2.828054>,
      < -4.404109, -1.793151, -2.828054>
    }
    triangle {
      < -4.422977, -1.780868, -2.837771>,
      < -4.415427, -1.772594, -2.836540>,
      < -4.404109, -1.793151, -2.828054>
    }
    triangle {
      < -4.422977, -1.780868, -2.837771>,
      < -4.404109, -1.793151, -2.828054>,
      < -4.412650, -1.805818, -2.828054>
    }
    triangle {
      < -4.431971, -1.788932, -2.838923>,
      < -4.422977, -1.780868, -2.837771>,
      < -4.412650, -1.805818, -2.828054>
    }
    triangle {
      < -4.431971, -1.788932, -2.838923>,
      < -4.412650, -1.805818, -2.828054>,
      < -4.422870, -1.817173, -2.828054>
    }
    triangle {
      < -4.442109, -1.795994, -2.839975>,
      < -4.431971, -1.788932, -2.838923>,
      < -4.422870, -1.817173, -2.828054>
    }
    triangle {
      < -4.442109, -1.795994, -2.839975>,
      < -4.422870, -1.817173, -2.828054>,
      < -4.434571, -1.826995, -2.828054>
    }
    triangle {
      < -4.453445, -1.801850, -2.840937>,
      < -4.442109, -1.795994, -2.839975>,
      < -4.434571, -1.826995, -2.828054>
    }
    triangle {
      < -4.453445, -1.801850, -2.840937>,
      < -4.434571, -1.826995, -2.828054>,
      < -4.447526, -1.835093, -2.828054>
    }
    triangle {
      < -4.465652, -1.806768, -2.841603>,
      < -4.453445, -1.801850, -2.840937>,
      < -4.447526, -1.835093, -2.828054>
    }
    triangle {
      < -4.465652, -1.806768, -2.841603>,
      < -4.447526, -1.835093, -2.828054>,
      < -4.461481, -1.841309, -2.828054>
    }
    triangle {
      < -4.478774, -1.810492, -2.841981>,
      < -4.465652, -1.806768, -2.841603>,
      < -4.461481, -1.841309, -2.828054>
    }
    triangle {
      < -4.478774, -1.810492, -2.841981>,
      < -4.461481, -1.841309, -2.828054>,
      < -4.476165, -1.845522, -2.828054>
    }
    triangle {
      < -4.491744, -1.812827, -2.842009>,
      < -4.478774, -1.810492, -2.841981>,
      < -4.476165, -1.845522, -2.828054>
    }
    triangle {
      < -4.491744, -1.812827, -2.842009>,
      < -4.476165, -1.845522, -2.828054>,
      < -4.491292, -1.847651, -2.828054>
    }
    triangle {
      < -4.506121, -1.812829, -2.842010>,
      < -4.491744, -1.812827, -2.842009>,
      < -4.491292, -1.847651, -2.828054>
    }
    triangle {
      < -4.506121, -1.812829, -2.842010>,
      < -4.491292, -1.847651, -2.828054>,
      < -4.506569, -1.847654, -2.828054>
    }
    triangle {
      < -4.519097, -1.810501, -2.841982>,
      < -4.506121, -1.812829, -2.842010>,
      < -4.506569, -1.847654, -2.828054>
    }
    triangle {
      < -4.519097, -1.810501, -2.841982>,
      < -4.506569, -1.847654, -2.828054>,
      < -4.521698, -1.845531, -2.828054>
    }
    triangle {
      < -4.532222, -1.806781, -2.841603>,
      < -4.519097, -1.810501, -2.841982>,
      < -4.521698, -1.845531, -2.828054>
    }
    triangle {
      < -4.532222, -1.806781, -2.841603>,
      < -4.521698, -1.845531, -2.828054>,
      < -4.536384, -1.841323, -2.828054>
    }
    triangle {
      < -4.544432, -1.801868, -2.840937>,
      < -4.532222, -1.806781, -2.841603>,
      < -4.536384, -1.841323, -2.828054>
    }
    triangle {
      < -4.544432, -1.801868, -2.840937>,
      < -4.536384, -1.841323, -2.828054>,
      < -4.550342, -1.835112, -2.828054>
    }
    triangle {
      < -4.555644, -1.796140, -2.839976>,
      < -4.544432, -1.801868, -2.840937>,
      < -4.550342, -1.835112, -2.828054>
    }
    triangle {
      < -4.555644, -1.796140, -2.839976>,
      < -4.550342, -1.835112, -2.828054>,
      < -4.563299, -1.827019, -2.828054>
    }
    triangle {
      < -4.565916, -1.788957, -2.838923>,
      < -4.555644, -1.796140, -2.839976>,
      < -4.563299, -1.827019, -2.828054>
    }
    triangle {
      < -4.565916, -1.788957, -2.838923>,
      < -4.563299, -1.827019, -2.828054>,
      < -4.575004, -1.817202, -2.828054>
    }
    triangle {
      < -4.574913, -1.780896, -2.837770>,
      < -4.565916, -1.788957, -2.838923>,
      < -4.575004, -1.817202, -2.828054>
    }
    triangle {
      < -4.574913, -1.780896, -2.837770>,
      < -4.575004, -1.817202, -2.828054>,
      < -4.585228, -1.805851, -2.828054>
    }
    triangle {
      < -4.582467, -1.772623, -2.836539>,
      < -4.574913, -1.780896, -2.837770>,
      < -4.585228, -1.805851, -2.828054>
    }
    triangle {
      < -4.582467, -1.772623, -2.836539>,
      < -4.585228, -1.805851, -2.828054>,
      < -4.593773, -1.793188, -2.828054>
    }
    triangle {
      < -4.588618, -1.763813, -2.835366>,
      < -4.582467, -1.772623, -2.836539>,
      < -4.593773, -1.793188, -2.828054>
    }
    triangle {
      < -4.588618, -1.763813, -2.835366>,
      < -4.593773, -1.793188, -2.828054>,
      < -4.600473, -1.779458, -2.828054>
    }
    triangle {
      < -4.593072, -1.754914, -2.834394>,
      < -4.588618, -1.763813, -2.835366>,
      < -4.600473, -1.779458, -2.828054>
    }
    triangle {
      < -4.593072, -1.754914, -2.834394>,
      < -4.600473, -1.779458, -2.828054>,
      < -4.605197, -1.764930, -2.828054>
    }
    triangle {
      < -4.595918, -1.745944, -2.833675>,
      < -4.593072, -1.754914, -2.834394>,
      < -4.605197, -1.764930, -2.828054>
    }
    triangle {
      < -4.595918, -1.745944, -2.833675>,
      < -4.605197, -1.764930, -2.828054>,
      < -4.607853, -1.749886, -2.828054>
    }
    triangle {
      < -4.597146, -1.736606, -2.833266>,
      < -4.595918, -1.745944, -2.833675>,
      < -4.607853, -1.749886, -2.828054>
    }
    triangle {
      < -4.597146, -1.736606, -2.833266>,
      < -4.607853, -1.749886, -2.828054>,
      < -4.608390, -1.734618, -2.828054>
    }
    triangle {
      < -4.606796, -1.719425, -2.828054>,
      < -4.597146, -1.736606, -2.833266>,
      < -4.608390, -1.734618, -2.828054>
    }
    triangle {
      < -4.606796, -1.719425, -2.828054>,
      < -4.582591, -1.709989, -2.837276>,
      < -4.576113, -1.720668, -2.840566>
    }
    triangle {
      < -4.414826, -1.741768, -2.838815>,
      < -4.418086, -1.744261, -2.839917>,
      < -4.422660, -1.744842, -2.851637>
    }
    triangle {
      < -4.414826, -1.741768, -2.838815>,
      < -4.422660, -1.744842, -2.851637>,
      < -4.419585, -1.742571, -2.850535>
    }
    triangle {
      < -4.418086, -1.744261, -2.839917>,
      < -4.422791, -1.747297, -2.841394>,
      < -4.427099, -1.747608, -2.853114>
    }
    triangle {
      < -4.418086, -1.744261, -2.839917>,
      < -4.427099, -1.747608, -2.853114>,
      < -4.422660, -1.744842, -2.851637>
    }
    triangle {
      < -4.422791, -1.747297, -2.841394>,
      < -4.428440, -1.750271, -2.843014>,
      < -4.432428, -1.750317, -2.854735>
    }
    triangle {
      < -4.422791, -1.747297, -2.841394>,
      < -4.432428, -1.750317, -2.854735>,
      < -4.427099, -1.747608, -2.853114>
    }
    triangle {
      < -4.428440, -1.750271, -2.843014>,
      < -4.435215, -1.753411, -2.844747>,
      < -4.438821, -1.753178, -2.856467>
    }
    triangle {
      < -4.428440, -1.750271, -2.843014>,
      < -4.438821, -1.753178, -2.856467>,
      < -4.432428, -1.750317, -2.854735>
    }
    triangle {
      < -4.435215, -1.753411, -2.844747>,
      < -4.443049, -1.757434, -2.846415>,
      < -4.446211, -1.756843, -2.858135>
    }
    triangle {
      < -4.435215, -1.753411, -2.844747>,
      < -4.446211, -1.756843, -2.858135>,
      < -4.438821, -1.753178, -2.856467>
    }
    triangle {
      < -4.443049, -1.757434, -2.846415>,
      < -4.451542, -1.760986, -2.847925>,
      < -4.454224, -1.760080, -2.859645>
    }
    triangle {
      < -4.443049, -1.757434, -2.846415>,
      < -4.454224, -1.760080, -2.859645>,
      < -4.446211, -1.756843, -2.858135>
    }
    triangle {
      < -4.451542, -1.760986, -2.847925>,
      < -4.461042, -1.763883, -2.849307>,
      < -4.463186, -1.762718, -2.861027>
    }
    triangle {
      < -4.451542, -1.760986, -2.847925>,
      < -4.463186, -1.762718, -2.861027>,
      < -4.454224, -1.760080, -2.859645>
    }
    triangle {
      < -4.461042, -1.763883, -2.849307>,
      < -4.471114, -1.766977, -2.850321>,
      < -4.472689, -1.765537, -2.862041>
    }
    triangle {
      < -4.461042, -1.763883, -2.849307>,
      < -4.472689, -1.765537, -2.862041>,
      < -4.463186, -1.762718, -2.861027>
    }
    triangle {
      < -4.471114, -1.766977, -2.850321>,
      < -4.482196, -1.769908, -2.850970>,
      < -4.483144, -1.768208, -2.862690>
    }
    triangle {
      < -4.471114, -1.766977, -2.850321>,
      < -4.483144, -1.768208, -2.862690>,
      < -4.472689, -1.765537, -2.862041>
    }
    triangle {
      < -4.482196, -1.769908, -2.850970>,
      < -4.492434, -1.772411, -2.851121>,
      < -4.492802, -1.770488, -2.862842>
    }
    triangle {
      < -4.482196, -1.769908, -2.850970>,
      < -4.492802, -1.770488, -2.862842>,
      < -4.483144, -1.768208, -2.862690>
    }
    triangle {
      < -4.492434, -1.772411, -2.851121>,
      < -4.505435, -1.772412, -2.851122>,
      < -4.505068, -1.770489, -2.862842>
    }
    triangle {
      < -4.492434, -1.772411, -2.851121>,
      < -4.505068, -1.770489, -2.862842>,
      < -4.492802, -1.770488, -2.862842>
    }
    triangle {
      < -4.505435, -1.772412, -2.851122>,
      < -4.515684, -1.769917, -2.850970>,
      < -4.514738, -1.768216, -2.862690>
    }
    triangle {
      < -4.505435, -1.772412, -2.851122>,
      < -4.514738, -1.768216, -2.862690>,
      < -4.505068, -1.770489, -2.862842>
    }
    triangle {
      < -4.515684, -1.769917, -2.850970>,
      < -4.526771, -1.766988, -2.850321>,
      < -4.525197, -1.765548, -2.862041>
    }
    triangle {
      < -4.515684, -1.769917, -2.850970>,
      < -4.525197, -1.765548, -2.862041>,
      < -4.514738, -1.768216, -2.862690>
    }
    triangle {
      < -4.526771, -1.766988, -2.850321>,
      < -4.536848, -1.763898, -2.849308>,
      < -4.534705, -1.762733, -2.861027>
    }
    triangle {
      < -4.526771, -1.766988, -2.850321>,
      < -4.534705, -1.762733, -2.861027>,
      < -4.525197, -1.765548, -2.862041>
    }
    triangle {
      < -4.536848, -1.763898, -2.849308>,
      < -4.546091, -1.761263, -2.847952>,
      < -4.543425, -1.760332, -2.859672>
    }
    triangle {
      < -4.536848, -1.763898, -2.849308>,
      < -4.543425, -1.760332, -2.859672>,
      < -4.534705, -1.762733, -2.861027>
    }
    triangle {
      < -4.546091, -1.761263, -2.847952>,
      < -4.554851, -1.757454, -2.846414>,
      < -4.551689, -1.756862, -2.858134>
    }
    triangle {
      < -4.546091, -1.761263, -2.847952>,
      < -4.551689, -1.756862, -2.858134>,
      < -4.543425, -1.760332, -2.859672>
    }
    triangle {
      < -4.554851, -1.757454, -2.846414>,
      < -4.562688, -1.753434, -2.844745>,
      < -4.559083, -1.753199, -2.856466>
    }
    triangle {
      < -4.554851, -1.757454, -2.846414>,
      < -4.559083, -1.753199, -2.856466>,
      < -4.551689, -1.756862, -2.858134>
    }
    triangle {
      < -4.562688, -1.753434, -2.844745>,
      < -4.569467, -1.750294, -2.843013>,
      < -4.565478, -1.750338, -2.854733>
    }
    triangle {
      < -4.562688, -1.753434, -2.844745>,
      < -4.565478, -1.750338, -2.854733>,
      < -4.559083, -1.753199, -2.856466>
    }
    triangle {
      < -4.569467, -1.750294, -2.843013>,
      < -4.575357, -1.747036, -2.841324>,
      < -4.571035, -1.747370, -2.853045>
    }
    triangle {
      < -4.569467, -1.750294, -2.843013>,
      < -4.571035, -1.747370, -2.853045>,
      < -4.565478, -1.750338, -2.854733>
    }
    triangle {
      < -4.575357, -1.747036, -2.841324>,
      < -4.579824, -1.744281, -2.839914>,
      < -4.575250, -1.744860, -2.851635>
    }
    triangle {
      < -4.575357, -1.747036, -2.841324>,
      < -4.575250, -1.744860, -2.851635>,
      < -4.571035, -1.747370, -2.853045>
    }
    triangle {
      < -4.579824, -1.744281, -2.839914>,
      < -4.583084, -1.741786, -2.838813>,
      < -4.578326, -1.742587, -2.850533>
    }
    triangle {
      < -4.579824, -1.744281, -2.839914>,
      < -4.578326, -1.742587, -2.850533>,
      < -4.575250, -1.744860, -2.851635>
    }
    triangle {
      < -4.583084, -1.741786, -2.838813>,
      < -4.585126, -1.738689, -2.838090>,
      < -4.580252, -1.739766, -2.849810>
    }
    triangle {
      < -4.583084, -1.741786, -2.838813>,
      < -4.580252, -1.739766, -2.849810>,
      < -4.578326, -1.742587, -2.850533>
    }
    triangle {
      < -4.585126, -1.738689, -2.838090>,
      < -4.585766, -1.735803, -2.837837>,
      < -4.580855, -1.737136, -2.849557>
    }
    triangle {
      < -4.585126, -1.738689, -2.838090>,
      < -4.580855, -1.737136, -2.849557>,
      < -4.580252, -1.739766, -2.849810>
    }
    triangle {
      < -4.585766, -1.735803, -2.837837>,
      < -4.582342, -1.728392, -2.838888>,
      < -4.577626, -1.730384, -2.850608>
    }
    triangle {
      < -4.585766, -1.735803, -2.837837>,
      < -4.577626, -1.730384, -2.850608>,
      < -4.580855, -1.737136, -2.849557>
    }
    triangle {
      < -4.582342, -1.728392, -2.838888>,
      < -4.576113, -1.720668, -2.840566>,
      < -4.571749, -1.723348, -2.852286>
    }
    triangle {
      < -4.582342, -1.728392, -2.838888>,
      < -4.571749, -1.723348, -2.852286>,
      < -4.577626, -1.730384, -2.850608>
    }
    triangle {
      < -4.576113, -1.720668, -2.840566>,
      < -4.582591, -1.709989, -2.837276>,
      < -4.577860, -1.713619, -2.848997>
    }
    triangle {
      < -4.576113, -1.720668, -2.840566>,
      < -4.577860, -1.713619, -2.848997>,
      < -4.571749, -1.723348, -2.852286>
    }
    triangle {
      < -4.582591, -1.709989, -2.837276>,
      < -4.569101, -1.709448, -2.841646>,
      < -4.565133, -1.713125, -2.853366>
    }
    triangle {
      < -4.582591, -1.709989, -2.837276>,
      < -4.565133, -1.713125, -2.853366>,
      < -4.577860, -1.713619, -2.848997>
    }
    triangle {
      < -4.569101, -1.709448, -2.841646>,
      < -4.554898, -1.708987, -2.845354>,
      < -4.556407, -1.712705, -2.856261>
    }
    triangle {
      < -4.569101, -1.709448, -2.841646>,
      < -4.556407, -1.712705, -2.856261>,
      < -4.565133, -1.713125, -2.853366>
    }
    triangle {
      < -4.554898, -1.708987, -2.845354>,
      < -4.542511, -1.719217, -2.848936>,
      < -4.543686, -1.722026, -2.859843>
    }
    triangle {
      < -4.554898, -1.708987, -2.845354>,
      < -4.543686, -1.722026, -2.859843>,
      < -4.556407, -1.712705, -2.856261>
    }
    triangle {
      < -4.542511, -1.719217, -2.848936>,
      < -4.528247, -1.719049, -2.851049>,
      < -4.526590, -1.721872, -2.862770>
    }
    triangle {
      < -4.542511, -1.719217, -2.848936>,
      < -4.526590, -1.721872, -2.862770>,
      < -4.543686, -1.722026, -2.859843>
    }
    triangle {
      < -4.528247, -1.719049, -2.851049>,
      < -4.513682, -1.718945, -2.852345>,
      < -4.512849, -1.721778, -2.864064>
    }
    triangle {
      < -4.528247, -1.719049, -2.851049>,
      < -4.512849, -1.721778, -2.864064>,
      < -4.526590, -1.721872, -2.862770>
    }
    triangle {
      < -4.513682, -1.718945, -2.852345>,
      < -4.498962, -1.718909, -2.852781>,
      < -4.498962, -1.721745, -2.864501>
    }
    triangle {
      < -4.513682, -1.718945, -2.852345>,
      < -4.498962, -1.721745, -2.864501>,
      < -4.512849, -1.721778, -2.864064>
    }
    triangle {
      < -4.498962, -1.718909, -2.852781>,
      < -4.484243, -1.718942, -2.852345>,
      < -4.485075, -1.721775, -2.864065>
    }
    triangle {
      < -4.498962, -1.718909, -2.852781>,
      < -4.485075, -1.721775, -2.864065>,
      < -4.498962, -1.721745, -2.864501>
    }
    triangle {
      < -4.484243, -1.718942, -2.852345>,
      < -4.469678, -1.719043, -2.851051>,
      < -4.471334, -1.721867, -2.862772>
    }
    triangle {
      < -4.484243, -1.718942, -2.852345>,
      < -4.471334, -1.721867, -2.862772>,
      < -4.485075, -1.721775, -2.864065>
    }
    triangle {
      < -4.469678, -1.719043, -2.851051>,
      < -4.455413, -1.719208, -2.848939>,
      < -4.454239, -1.722017, -2.859846>
    }
    triangle {
      < -4.469678, -1.719043, -2.851051>,
      < -4.454239, -1.722017, -2.859846>,
      < -4.471334, -1.721867, -2.862772>
    }
    triangle {
      < -4.455413, -1.719208, -2.848939>,
      < -4.443026, -1.708975, -2.845357>,
      < -4.441517, -1.712695, -2.856265>
    }
    triangle {
      < -4.455413, -1.719208, -2.848939>,
      < -4.441517, -1.712695, -2.856265>,
      < -4.454239, -1.722017, -2.859846>
    }
    triangle {
      < -4.443026, -1.708975, -2.845357>,
      < -4.428818, -1.709425, -2.841648>,
      < -4.432785, -1.713105, -2.853368>
    }
    triangle {
      < -4.443026, -1.708975, -2.845357>,
      < -4.432785, -1.713105, -2.853368>,
      < -4.441517, -1.712695, -2.856265>
    }
    triangle {
      < -4.428818, -1.709425, -2.841648>,
      < -4.415323, -1.709956, -2.837276>,
      < -4.420053, -1.713589, -2.848996>
    }
    triangle {
      < -4.428818, -1.709425, -2.841648>,
      < -4.420053, -1.713589, -2.848996>,
      < -4.432785, -1.713105, -2.853368>
    }
    triangle {
      < -4.415323, -1.709956, -2.837276>,
      < -4.421799, -1.720634, -2.840566>,
      < -4.426163, -1.723317, -2.852286>
    }
    triangle {
      < -4.415323, -1.709956, -2.837276>,
      < -4.426163, -1.723317, -2.852286>,
      < -4.420053, -1.713589, -2.848996>
    }
    triangle {
      < -4.421799, -1.720634, -2.840566>,
      < -4.415568, -1.728363, -2.838889>,
      < -4.420285, -1.730358, -2.850609>
    }
    triangle {
      < -4.421799, -1.720634, -2.840566>,
      < -4.420285, -1.730358, -2.850609>,
      < -4.426163, -1.723317, -2.852286>
    }
    triangle {
      < -4.415568, -1.728363, -2.838889>,
      < -4.412143, -1.735762, -2.837839>,
      < -4.417053, -1.737099, -2.849559>
    }
    triangle {
      < -4.415568, -1.728363, -2.838889>,
      < -4.417053, -1.737099, -2.849559>,
      < -4.420285, -1.730358, -2.850609>
    }
    triangle {
      < -4.412143, -1.735762, -2.837839>,
      < -4.412785, -1.738668, -2.838093>,
      < -4.417658, -1.739747, -2.849813>
    }
    triangle {
      < -4.412143, -1.735762, -2.837839>,
      < -4.417658, -1.739747, -2.849813>,
      < -4.417053, -1.737099, -2.849559>
    }
    triangle {
      < -4.412785, -1.738668, -2.838093>,
      < -4.414826, -1.741768, -2.838815>,
      < -4.419585, -1.742571, -2.850535>
    }
    triangle {
      < -4.412785, -1.738668, -2.838093>,
      < -4.419585, -1.742571, -2.850535>,
      < -4.417658, -1.739747, -2.849813>
    }
    texture {rfrim}
  }
  // brims
  union {
    triangle {
      < 5.048418, -1.628912, -2.828054>,
      < 5.033179, -1.629982, -2.828054>,
      < 5.032213, -1.623114, -2.842164>
    }
    triangle {
      < 5.034369, -1.518169, -2.813766>,
      < 5.032213, -1.623114, -2.842164>,
      < 5.017629, -1.519337, -2.813766>
    }
    triangle {
      < 5.034369, -1.518169, -2.813766>,
      < 5.017629, -1.519337, -2.813766>,
      < 5.003046, -1.415561, -2.769109>
    }
    triangle {
      < 5.034369, -1.518169, -2.813766>,
      < 5.003046, -1.415561, -2.769109>,
      < 5.041050, -1.413064, -2.769109>
    }
    triangle {
      < 5.041050, -1.413064, -2.769109>,
      < 5.048420, -1.399683, -2.756803>,
      < 5.048419, -1.514298, -2.792428>
    }
    triangle {
      < 5.041050, -1.413064, -2.769109>,
      < 5.048419, -1.514298, -2.792428>,
      < 5.034369, -1.518169, -2.813766>
    }
    triangle {
      < 5.048420, -1.399683, -2.756803>,
      < 5.001278, -1.402983, -2.756803>,
      < 4.998332, -1.382018, -2.779159>
    }
    triangle {
      < 5.048420, -1.399683, -2.756803>,
      < 4.998332, -1.382018, -2.779159>,
      < 5.048419, -1.378512, -2.779159>
    }
    triangle {
      < 5.048419, -1.378512, -2.779159>,
      < 4.998332, -1.382018, -2.779159>,
      < 4.996966, -1.295944, -2.764932>
    }
    triangle {
      < 5.048419, -1.378512, -2.779159>,
      < 4.996966, -1.295944, -2.764932>,
      < 5.048420, -1.293829, -2.764932>
    }
    triangle {
      < 5.048420, -1.293829, -2.764932>,
      < 4.996966, -1.295944, -2.764932>,
      < 4.992774, -1.259871, -2.663333>
    }
    triangle {
      < 5.048420, -1.293829, -2.764932>,
      < 4.992774, -1.259871, -2.663333>,
      < 5.048422, -1.257585, -2.663333>
    }
    triangle {
      < 5.048422, -1.257585, -2.663333>,
      < 4.992774, -1.259871, -2.663333>,
      < 4.969955, -1.180085, -2.663332>
    }
    triangle {
      < 5.048422, -1.257585, -2.663333>,
      < 4.969955, -1.180085, -2.663332>,
      < 5.048422, -1.174595, -2.663332>
    }
    triangle {
      < 5.048422, -1.174595, -2.663332>,
      < 4.969955, -1.180085, -2.663332>,
      < 4.968869, -1.172370, -2.744609>
    }
    triangle {
      < 5.048422, -1.174595, -2.663332>,
      < 4.968869, -1.172370, -2.744609>,
      < 5.048420, -1.166804, -2.744609>
    }
    triangle {
      < 5.048420, -1.166804, -2.744609>,
      < 4.968869, -1.172370, -2.744609>,
      < 4.960030, -1.109476, -2.736479>
    }
    triangle {
      < 5.048420, -1.166804, -2.744609>,
      < 4.960030, -1.109476, -2.736479>,
      < 5.048420, -1.103292, -2.736479>
    }
    triangle {
      < 5.048420, -1.103292, -2.736479>,
      < 4.960030, -1.109476, -2.736479>,
      < 4.960021, -1.109391, -2.633340>
    }
    triangle {
      < 5.048420, -1.103292, -2.736479>,
      < 4.960021, -1.109391, -2.633340>,
      < 5.048423, -1.103207, -2.633340>
    }
    triangle {
      < 5.033179, -1.629982, -2.828054>,
      < 5.018236, -1.633162, -2.828054>,
      < 5.016325, -1.626495, -2.842164>
    }
    triangle {
      < 5.033179, -1.629982, -2.828054>,
      < 5.016325, -1.626495, -2.842164>,
      < 5.032213, -1.623114, -2.842164>
    }
    triangle {
      < 5.032213, -1.623114, -2.842164>,
      < 5.016325, -1.626495, -2.842164>,
      < 4.987440, -1.525758, -2.813766>
    }
    triangle {
      < 5.032213, -1.623114, -2.842164>,
      < 4.987440, -1.525758, -2.813766>,
      < 5.017629, -1.519337, -2.813766>
    }
    triangle {
      < 5.017629, -1.519337, -2.813766>,
      < 4.987440, -1.525758, -2.813766>,
      < 4.958556, -1.425021, -2.769109>
    }
    triangle {
      < 5.017629, -1.519337, -2.813766>,
      < 4.958556, -1.425021, -2.769109>,
      < 5.003046, -1.415561, -2.769109>
    }
    triangle {
      < 5.003046, -1.415561, -2.769109>,
      < 4.958556, -1.425021, -2.769109>,
      < 4.955055, -1.412811, -2.756803>
    }
    triangle {
      < 5.003046, -1.415561, -2.769109>,
      < 4.955055, -1.412811, -2.756803>,
      < 5.001278, -1.402983, -2.756803>
    }
    triangle {
      < 5.001278, -1.402983, -2.756803>,
      < 4.955055, -1.412811, -2.756803>,
      < 4.949219, -1.392461, -2.779159>
    }
    triangle {
      < 5.001278, -1.402983, -2.756803>,
      < 4.949219, -1.392461, -2.779159>,
      < 4.998332, -1.382018, -2.779159>
    }
    triangle {
      < 4.947359, -1.326766, -2.768997>,
      < 4.949219, -1.392461, -2.779159>,
      < 4.915458, -1.313273, -2.764932>
    }
    triangle {
      < 4.939123, -1.293206, -2.663333>,
      < 4.947359, -1.326766, -2.768997>,
      < 4.915458, -1.313273, -2.764932>
    }
    triangle {
      < 4.939123, -1.293206, -2.663333>,
      < 4.915458, -1.313273, -2.764932>,
      < 4.904621, -1.278613, -2.663333>
    }
    triangle {
      < 4.967193, -1.287238, -2.663333>,
      < 4.939123, -1.293206, -2.663333>,
      < 4.904621, -1.278613, -2.663333>
    }
    triangle {
      < 4.967193, -1.287238, -2.663333>,
      < 4.904621, -1.278613, -2.663333>,
      < 4.992774, -1.259871, -2.663333>
    }
    triangle {
      < 4.969955, -1.180085, -2.663332>,
      < 4.893016, -1.196442, -2.663332>,
      < 4.890866, -1.188953, -2.744609>
    }
    triangle {
      < 4.969955, -1.180085, -2.663332>,
      < 4.890866, -1.188953, -2.744609>,
      < 4.968869, -1.172370, -2.744609>
    }
    triangle {
      < 4.968869, -1.172370, -2.744609>,
      < 4.890866, -1.188953, -2.744609>,
      < 4.873360, -1.127901, -2.736479>
    }
    triangle {
      < 4.968869, -1.172370, -2.744609>,
      < 4.873360, -1.127901, -2.736479>,
      < 4.960030, -1.109476, -2.736479>
    }
    triangle {
      < 4.960030, -1.109476, -2.736479>,
      < 4.873360, -1.127901, -2.736479>,
      < 4.873340, -1.127819, -2.633340>
    }
    triangle {
      < 4.960030, -1.109476, -2.736479>,
      < 4.873340, -1.127819, -2.633340>,
      < 4.960021, -1.109391, -2.633340>
    }
    triangle {
      < 5.018236, -1.633162, -2.828054>,
      < 5.003882, -1.638390, -2.828054>,
      < 5.001060, -1.632054, -2.842164>
    }
    triangle {
      < 5.018236, -1.633162, -2.828054>,
      < 5.001060, -1.632054, -2.842164>,
      < 5.016325, -1.626495, -2.842164>
    }
    triangle {
      < 5.016325, -1.626495, -2.842164>,
      < 5.001060, -1.632054, -2.842164>,
      < 4.958437, -1.536317, -2.813766>
    }
    triangle {
      < 5.016325, -1.626495, -2.842164>,
      < 4.958437, -1.536317, -2.813766>,
      < 4.987440, -1.525758, -2.813766>
    }
    triangle {
      < 4.987440, -1.525758, -2.813766>,
      < 4.958437, -1.536317, -2.813766>,
      < 4.915815, -1.440581, -2.769109>
    }
    triangle {
      < 4.987440, -1.525758, -2.813766>,
      < 4.915815, -1.440581, -2.769109>,
      < 4.958556, -1.425021, -2.769109>
    }
    triangle {
      < 4.958556, -1.425021, -2.769109>,
      < 4.915815, -1.440581, -2.769109>,
      < 4.910649, -1.428977, -2.756803>
    }
    triangle {
      < 4.958556, -1.425021, -2.769109>,
      < 4.910649, -1.428977, -2.756803>,
      < 4.955055, -1.412811, -2.756803>
    }
    triangle {
      < 4.955055, -1.412811, -2.756803>,
      < 4.910649, -1.428977, -2.756803>,
      < 4.902038, -1.409637, -2.779159>
    }
    triangle {
      < 4.955055, -1.412811, -2.756803>,
      < 4.902038, -1.409637, -2.779159>,
      < 4.949219, -1.392461, -2.779159>
    }
    triangle {
      < 4.949219, -1.392461, -2.779159>,
      < 4.902038, -1.409637, -2.779159>,
      < 4.867595, -1.332274, -2.764932>
    }
    triangle {
      < 4.949219, -1.392461, -2.779159>,
      < 4.867595, -1.332274, -2.764932>,
      < 4.915458, -1.313273, -2.764932>
    }
    triangle {
      < 4.915458, -1.313273, -2.764932>,
      < 4.867595, -1.332274, -2.764932>,
      < 4.852856, -1.299162, -2.663333>
    }
    triangle {
      < 4.915458, -1.313273, -2.764932>,
      < 4.852856, -1.299162, -2.663333>,
      < 4.904621, -1.278613, -2.663333>
    }
    triangle {
      < 4.904621, -1.278613, -2.663333>,
      < 4.852856, -1.299162, -2.663333>,
      < 4.819101, -1.223347, -2.663332>
    }
    triangle {
      < 4.904621, -1.278613, -2.663333>,
      < 4.819101, -1.223347, -2.663332>,
      < 4.893016, -1.196442, -2.663332>
    }
    triangle {
      < 4.893016, -1.196442, -2.663332>,
      < 4.819101, -1.223347, -2.663332>,
      < 4.815930, -1.216231, -2.744609>
    }
    triangle {
      < 4.893016, -1.196442, -2.663332>,
      < 4.815930, -1.216231, -2.744609>,
      < 4.890866, -1.188953, -2.744609>
    }
    triangle {
      < 4.890866, -1.188953, -2.744609>,
      < 4.815930, -1.216231, -2.744609>,
      < 4.790098, -1.158209, -2.736479>
    }
    triangle {
      < 4.890866, -1.188953, -2.744609>,
      < 4.790098, -1.158209, -2.736479>,
      < 4.873360, -1.127901, -2.736479>
    }
    triangle {
      < 4.873360, -1.127901, -2.736479>,
      < 4.790098, -1.158209, -2.736479>,
      < 4.790066, -1.158131, -2.633340>
    }
    triangle {
      < 4.873360, -1.127901, -2.736479>,
      < 4.790066, -1.158131, -2.633340>,
      < 4.873340, -1.127819, -2.633340>
    }
    triangle {
      < 5.003882, -1.638390, -2.828054>,
      < 4.990395, -1.645565, -2.828054>,
      < 4.986719, -1.639683, -2.842164>
    }
    triangle {
      < 5.003882, -1.638390, -2.828054>,
      < 4.986719, -1.639683, -2.842164>,
      < 5.001060, -1.632054, -2.842164>
    }
    triangle {
      < 5.001060, -1.632054, -2.842164>,
      < 4.986719, -1.639683, -2.842164>,
      < 4.931187, -1.550811, -2.813766>
    }
    triangle {
      < 5.001060, -1.632054, -2.842164>,
      < 4.931187, -1.550811, -2.813766>,
      < 4.958437, -1.536317, -2.813766>
    }
    triangle {
      < 4.958437, -1.536317, -2.813766>,
      < 4.931187, -1.550811, -2.813766>,
      < 4.875656, -1.461937, -2.769109>
    }
    triangle {
      < 4.958437, -1.536317, -2.813766>,
      < 4.875656, -1.461937, -2.769109>,
      < 4.915815, -1.440581, -2.769109>
    }
    triangle {
      < 4.915815, -1.440581, -2.769109>,
      < 4.875656, -1.461937, -2.769109>,
      < 4.868925, -1.451166, -2.756803>
    }
    triangle {
      < 4.915815, -1.440581, -2.769109>,
      < 4.868925, -1.451166, -2.756803>,
      < 4.910649, -1.428977, -2.756803>
    }
    triangle {
      < 4.910649, -1.428977, -2.756803>,
      < 4.868925, -1.451166, -2.756803>,
      < 4.857706, -1.433212, -2.779159>
    }
    triangle {
      < 4.910649, -1.428977, -2.756803>,
      < 4.857706, -1.433212, -2.779159>,
      < 4.902038, -1.409637, -2.779159>
    }
    triangle {
      < 4.902038, -1.409637, -2.779159>,
      < 4.857706, -1.433212, -2.779159>,
      < 4.821450, -1.355134, -2.764932>
    }
    triangle {
      < 4.902038, -1.409637, -2.779159>,
      < 4.821450, -1.355134, -2.764932>,
      < 4.867595, -1.332274, -2.764932>
    }
    triangle {
      < 4.867595, -1.332274, -2.764932>,
      < 4.821450, -1.355134, -2.764932>,
      < 4.802948, -1.323885, -2.663333>
    }
    triangle {
      < 4.867595, -1.332274, -2.764932>,
      < 4.802948, -1.323885, -2.663333>,
      < 4.852856, -1.299162, -2.663333>
    }
    triangle {
      < 4.852856, -1.299162, -2.663333>,
      < 4.802948, -1.323885, -2.663333>,
      < 4.749650, -1.260278, -2.663332>
    }
    triangle {
      < 4.852856, -1.299162, -2.663333>,
      < 4.749650, -1.260278, -2.663332>,
      < 4.819101, -1.223347, -2.663332>
    }
    triangle {
      < 4.819101, -1.223347, -2.663332>,
      < 4.749650, -1.260278, -2.663332>,
      < 4.745521, -1.253672, -2.744609>
    }
    triangle {
      < 4.819101, -1.223347, -2.663332>,
      < 4.745521, -1.253672, -2.744609>,
      < 4.815930, -1.216231, -2.744609>
    }
    triangle {
      < 4.815930, -1.216231, -2.744609>,
      < 4.745521, -1.253672, -2.744609>,
      < 4.711864, -1.199810, -2.736479>
    }
    triangle {
      < 4.815930, -1.216231, -2.744609>,
      < 4.711864, -1.199810, -2.736479>,
      < 4.790098, -1.158209, -2.736479>
    }
    triangle {
      < 4.790098, -1.158209, -2.736479>,
      < 4.711864, -1.199810, -2.736479>,
      < 4.711822, -1.199736, -2.633340>
    }
    triangle {
      < 4.790098, -1.158209, -2.736479>,
      < 4.711822, -1.199736, -2.633340>,
      < 4.790066, -1.158131, -2.633340>
    }
    triangle {
      < 4.990395, -1.645565, -2.828054>,
      < 4.978038, -1.654548, -2.828054>,
      < 4.973579, -1.649235, -2.842164>
    }
    triangle {
      < 4.990395, -1.645565, -2.828054>,
      < 4.973579, -1.649235, -2.842164>,
      < 4.986719, -1.639683, -2.842164>
    }
    triangle {
      < 4.986719, -1.639683, -2.842164>,
      < 4.973579, -1.649235, -2.842164>,
      < 4.906219, -1.568955, -2.813766>
    }
    triangle {
      < 4.986719, -1.639683, -2.842164>,
      < 4.906219, -1.568955, -2.813766>,
      < 4.931187, -1.550811, -2.813766>
    }
    triangle {
      < 4.931187, -1.550811, -2.813766>,
      < 4.906219, -1.568955, -2.813766>,
      < 4.838860, -1.488675, -2.769109>
    }
    triangle {
      < 4.931187, -1.550811, -2.813766>,
      < 4.838860, -1.488675, -2.769109>,
      < 4.875656, -1.461937, -2.769109>
    }
    triangle {
      < 4.875656, -1.461937, -2.769109>,
      < 4.838860, -1.488675, -2.769109>,
      < 4.830696, -1.478945, -2.756803>
    }
    triangle {
      < 4.875656, -1.461937, -2.769109>,
      < 4.830696, -1.478945, -2.756803>,
      < 4.868925, -1.451166, -2.756803>
    }
    triangle {
      < 4.868925, -1.451166, -2.756803>,
      < 4.830696, -1.478945, -2.756803>,
      < 4.817087, -1.462727, -2.779159>
    }
    triangle {
      < 4.868925, -1.451166, -2.756803>,
      < 4.817087, -1.462727, -2.779159>,
      < 4.857706, -1.433212, -2.779159>
    }
    triangle {
      < 4.788668, -1.403468, -2.768997>,
      < 4.817087, -1.462727, -2.779159>,
      < 4.754036, -1.404117, -2.764932>
    }
    triangle {
      < 4.767493, -1.376160, -2.663333>,
      < 4.788668, -1.403468, -2.768997>,
      < 4.754036, -1.404117, -2.764932>
    }
    triangle {
      < 4.767493, -1.376160, -2.663333>,
      < 4.754036, -1.404117, -2.764932>,
      < 4.730039, -1.376861, -2.663333>
    }
    triangle {
      < 4.790710, -1.359290, -2.663333>,
      < 4.767493, -1.376160, -2.663333>,
      < 4.730039, -1.376861, -2.663333>
    }
    triangle {
      < 4.790710, -1.359290, -2.663333>,
      < 4.730039, -1.376861, -2.663333>,
      < 4.802948, -1.323885, -2.663333>
    }
    triangle {
      < 4.749650, -1.260278, -2.663332>,
      < 4.686016, -1.306514, -2.663332>,
      < 4.681006, -1.300547, -2.744609>
    }
    triangle {
      < 4.749650, -1.260278, -2.663332>,
      < 4.681006, -1.300547, -2.744609>,
      < 4.745521, -1.253672, -2.744609>
    }
    triangle {
      < 4.745521, -1.253672, -2.744609>,
      < 4.681006, -1.300547, -2.744609>,
      < 4.640182, -1.251893, -2.736479>
    }
    triangle {
      < 4.745521, -1.253672, -2.744609>,
      < 4.640182, -1.251893, -2.736479>,
      < 4.711864, -1.199810, -2.736479>
    }
    triangle {
      < 4.711864, -1.199810, -2.736479>,
      < 4.640182, -1.251893, -2.736479>,
      < 4.640130, -1.251827, -2.633340>
    }
    triangle {
      < 4.711864, -1.199810, -2.736479>,
      < 4.640130, -1.251827, -2.633340>,
      < 4.711822, -1.199736, -2.633340>
    }
    triangle {
      < 4.978038, -1.654548, -2.828054>,
      < 4.967051, -1.665163, -2.828054>,
      < 4.961896, -1.660522, -2.842164>
    }
    triangle {
      < 4.978038, -1.654548, -2.828054>,
      < 4.961896, -1.660522, -2.842164>,
      < 4.973579, -1.649235, -2.842164>
    }
    triangle {
      < 4.973579, -1.649235, -2.842164>,
      < 4.961896, -1.660522, -2.842164>,
      < 4.884019, -1.590398, -2.813766>
    }
    triangle {
      < 4.973579, -1.649235, -2.842164>,
      < 4.884019, -1.590398, -2.813766>,
      < 4.906219, -1.568955, -2.813766>
    }
    triangle {
      < 4.906219, -1.568955, -2.813766>,
      < 4.884019, -1.590398, -2.813766>,
      < 4.806142, -1.520274, -2.769109>
    }
    triangle {
      < 4.906219, -1.568955, -2.813766>,
      < 4.806142, -1.520274, -2.769109>,
      < 4.838860, -1.488675, -2.769109>
    }
    triangle {
      < 4.838860, -1.488675, -2.769109>,
      < 4.806142, -1.520274, -2.769109>,
      < 4.796704, -1.511774, -2.756803>
    }
    triangle {
      < 4.838860, -1.488675, -2.769109>,
      < 4.796704, -1.511774, -2.756803>,
      < 4.830696, -1.478945, -2.756803>
    }
    triangle {
      < 4.830696, -1.478945, -2.756803>,
      < 4.796704, -1.511774, -2.756803>,
      < 4.780971, -1.497608, -2.779159>
    }
    triangle {
      < 4.830696, -1.478945, -2.756803>,
      < 4.780971, -1.497608, -2.779159>,
      < 4.817087, -1.462727, -2.779159>
    }
    triangle {
      < 4.817087, -1.462727, -2.779159>,
      < 4.780971, -1.497608, -2.779159>,
      < 4.718040, -1.440943, -2.764932>
    }
    triangle {
      < 4.817087, -1.462727, -2.779159>,
      < 4.718040, -1.440943, -2.764932>,
      < 4.754036, -1.404117, -2.764932>
    }
    triangle {
      < 4.754036, -1.404117, -2.764932>,
      < 4.718040, -1.440943, -2.764932>,
      < 4.691107, -1.416689, -2.663333>
    }
    triangle {
      < 4.754036, -1.404117, -2.764932>,
      < 4.691107, -1.416689, -2.663333>,
      < 4.730039, -1.376861, -2.663333>
    }
    triangle {
      < 4.730039, -1.376861, -2.663333>,
      < 4.691107, -1.416689, -2.663333>,
      < 4.629435, -1.361157, -2.663332>
    }
    triangle {
      < 4.730039, -1.376861, -2.663333>,
      < 4.629435, -1.361157, -2.663332>,
      < 4.686016, -1.306514, -2.663332>
    }
    triangle {
      < 4.686016, -1.306514, -2.663332>,
      < 4.629435, -1.361157, -2.663332>,
      < 4.623643, -1.355945, -2.744609>
    }
    triangle {
      < 4.686016, -1.306514, -2.663332>,
      < 4.623643, -1.355945, -2.744609>,
      < 4.681006, -1.300547, -2.744609>
    }
    triangle {
      < 4.681006, -1.300547, -2.744609>,
      < 4.623643, -1.355945, -2.744609>,
      < 4.576445, -1.313446, -2.736479>
    }
    triangle {
      < 4.681006, -1.300547, -2.744609>,
      < 4.576445, -1.313446, -2.736479>,
      < 4.640182, -1.251893, -2.736479>
    }
    triangle {
      < 4.640182, -1.251893, -2.736479>,
      < 4.576445, -1.313446, -2.736479>,
      < 4.576384, -1.313388, -2.633340>
    }
    triangle {
      < 4.640182, -1.251893, -2.736479>,
      < 4.576384, -1.313388, -2.633340>,
      < 4.640130, -1.251827, -2.633340>
    }
    triangle {
      < 4.967051, -1.665163, -2.828054>,
      < 4.957648, -1.677203, -2.828054>,
      < 4.951898, -1.673325, -2.842164>
    }
    triangle {
      < 4.967051, -1.665163, -2.828054>,
      < 4.951898, -1.673325, -2.842164>,
      < 4.961896, -1.660522, -2.842164>
    }
    triangle {
      < 4.961896, -1.660522, -2.842164>,
      < 4.951898, -1.673325, -2.842164>,
      < 4.865019, -1.614722, -2.813766>
    }
    triangle {
      < 4.961896, -1.660522, -2.842164>,
      < 4.865019, -1.614722, -2.813766>,
      < 4.884019, -1.590398, -2.813766>
    }
    triangle {
      < 4.884019, -1.590398, -2.813766>,
      < 4.865019, -1.614722, -2.813766>,
      < 4.778141, -1.556118, -2.769109>
    }
    triangle {
      < 4.884019, -1.590398, -2.813766>,
      < 4.778141, -1.556118, -2.769109>,
      < 4.806142, -1.520274, -2.769109>
    }
    triangle {
      < 4.806142, -1.520274, -2.769109>,
      < 4.778141, -1.556118, -2.769109>,
      < 4.767612, -1.549015, -2.756803>
    }
    triangle {
      < 4.806142, -1.520274, -2.769109>,
      < 4.767612, -1.549015, -2.756803>,
      < 4.796704, -1.511774, -2.756803>
    }
    triangle {
      < 4.796704, -1.511774, -2.756803>,
      < 4.767612, -1.549015, -2.756803>,
      < 4.750060, -1.537177, -2.779159>
    }
    triangle {
      < 4.796704, -1.511774, -2.756803>,
      < 4.750060, -1.537177, -2.779159>,
      < 4.780971, -1.497608, -2.779159>
    }
    triangle {
      < 4.780971, -1.497608, -2.779159>,
      < 4.750060, -1.537177, -2.779159>,
      < 4.685182, -1.480595, -2.764932>
    }
    triangle {
      < 4.780971, -1.497608, -2.779159>,
      < 4.685182, -1.480595, -2.764932>,
      < 4.718040, -1.440943, -2.764932>
    }
    triangle {
      < 4.718040, -1.440943, -2.764932>,
      < 4.685182, -1.480595, -2.764932>,
      < 4.655570, -1.459573, -2.663333>
    }
    triangle {
      < 4.718040, -1.440943, -2.764932>,
      < 4.655570, -1.459573, -2.663333>,
      < 4.691107, -1.416689, -2.663333>
    }
    triangle {
      < 4.691107, -1.416689, -2.663333>,
      < 4.655570, -1.459573, -2.663333>,
      < 4.581008, -1.423142, -2.663332>
    }
    triangle {
      < 4.691107, -1.416689, -2.663333>,
      < 4.581008, -1.423142, -2.663332>,
      < 4.629435, -1.361157, -2.663332>
    }
    triangle {
      < 4.629435, -1.361157, -2.663332>,
      < 4.581008, -1.423142, -2.663332>,
      < 4.574549, -1.418787, -2.744609>
    }
    triangle {
      < 4.629435, -1.361157, -2.663332>,
      < 4.574549, -1.418787, -2.744609>,
      < 4.623643, -1.355945, -2.744609>
    }
    triangle {
      < 4.623643, -1.355945, -2.744609>,
      < 4.574549, -1.418787, -2.744609>,
      < 4.521895, -1.383270, -2.736479>
    }
    triangle {
      < 4.623643, -1.355945, -2.744609>,
      < 4.521895, -1.383270, -2.736479>,
      < 4.576445, -1.313446, -2.736479>
    }
    triangle {
      < 4.576445, -1.313446, -2.736479>,
      < 4.521895, -1.383270, -2.736479>,
      < 4.521826, -1.383221, -2.633340>
    }
    triangle {
      < 4.576445, -1.313446, -2.736479>,
      < 4.521826, -1.383221, -2.633340>,
      < 4.576384, -1.313388, -2.633340>
    }
    triangle {
      < 4.957648, -1.677203, -2.828054>,
      < 4.950013, -1.690435, -2.828054>,
      < 4.943779, -1.687395, -2.842164>
    }
    triangle {
      < 4.957648, -1.677203, -2.828054>,
      < 4.943779, -1.687395, -2.842164>,
      < 4.951898, -1.673325, -2.842164>
    }
    triangle {
      < 4.951898, -1.673325, -2.842164>,
      < 4.943779, -1.687395, -2.842164>,
      < 4.849590, -1.641453, -2.813766>
    }
    triangle {
      < 4.951898, -1.673325, -2.842164>,
      < 4.849590, -1.641453, -2.813766>,
      < 4.865019, -1.614722, -2.813766>
    }
    triangle {
      < 4.865019, -1.614722, -2.813766>,
      < 4.849590, -1.641453, -2.813766>,
      < 4.755401, -1.595510, -2.769109>
    }
    triangle {
      < 4.865019, -1.614722, -2.813766>,
      < 4.755401, -1.595510, -2.769109>,
      < 4.778141, -1.556118, -2.769109>
    }
    triangle {
      < 4.778141, -1.556118, -2.769109>,
      < 4.755401, -1.595510, -2.769109>,
      < 4.743986, -1.589942, -2.756803>
    }
    triangle {
      < 4.778141, -1.556118, -2.769109>,
      < 4.743986, -1.589942, -2.756803>,
      < 4.767612, -1.549015, -2.756803>
    }
    triangle {
      < 4.767612, -1.549015, -2.756803>,
      < 4.743986, -1.589942, -2.756803>,
      < 4.724957, -1.580661, -2.779159>
    }
    triangle {
      < 4.767612, -1.549015, -2.756803>,
      < 4.724957, -1.580661, -2.779159>,
      < 4.750060, -1.537177, -2.779159>
    }
    triangle {
      < 4.674892, -1.538084, -2.768997>,
      < 4.724957, -1.580661, -2.779159>,
      < 4.643519, -1.552763, -2.764932>
    }
    triangle {
      < 4.644442, -1.521749, -2.663333>,
      < 4.674892, -1.538084, -2.768997>,
      < 4.643519, -1.552763, -2.764932>
    }
    triangle {
      < 4.644442, -1.521749, -2.663333>,
      < 4.643519, -1.552763, -2.764932>,
      < 4.610510, -1.537623, -2.663333>
    }
    triangle {
      < 4.658790, -1.496895, -2.663333>,
      < 4.644442, -1.521749, -2.663333>,
      < 4.610510, -1.537623, -2.663333>
    }
    triangle {
      < 4.658790, -1.496895, -2.663333>,
      < 4.610510, -1.537623, -2.663333>,
      < 4.655570, -1.459573, -2.663333>
    }
    triangle {
      < 4.581008, -1.423142, -2.663332>,
      < 4.541680, -1.491264, -2.663332>,
      < 4.534678, -1.487850, -2.744609>
    }
    triangle {
      < 4.581008, -1.423142, -2.663332>,
      < 4.534678, -1.487850, -2.744609>,
      < 4.574549, -1.418787, -2.744609>
    }
    triangle {
      < 4.574549, -1.418787, -2.744609>,
      < 4.534678, -1.487850, -2.744609>,
      < 4.477593, -1.460007, -2.736479>
    }
    triangle {
      < 4.574549, -1.418787, -2.744609>,
      < 4.477593, -1.460007, -2.736479>,
      < 4.521895, -1.383270, -2.736479>
    }
    triangle {
      < 4.521895, -1.383270, -2.736479>,
      < 4.477593, -1.460007, -2.736479>,
      < 4.477518, -1.459967, -2.633340>
    }
    triangle {
      < 4.521895, -1.383270, -2.736479>,
      < 4.477518, -1.459967, -2.633340>,
      < 4.521826, -1.383221, -2.633340>
    }
    triangle {
      < 4.950013, -1.690435, -2.828054>,
      < 4.944293, -1.704601, -2.828054>,
      < 4.937696, -1.702458, -2.842164>
    }
    triangle {
      < 4.950013, -1.690435, -2.828054>,
      < 4.937696, -1.702458, -2.842164>,
      < 4.943779, -1.687395, -2.842164>
    }
    triangle {
      < 4.943779, -1.687395, -2.842164>,
      < 4.937696, -1.702458, -2.842164>,
      < 4.838031, -1.670071, -2.813766>
    }
    triangle {
      < 4.943779, -1.687395, -2.842164>,
      < 4.838031, -1.670071, -2.813766>,
      < 4.849590, -1.641453, -2.813766>
    }
    triangle {
      < 4.849590, -1.641453, -2.813766>,
      < 4.838031, -1.670071, -2.813766>,
      < 4.738365, -1.637684, -2.769109>
    }
    triangle {
      < 4.849590, -1.641453, -2.813766>,
      < 4.738365, -1.637684, -2.769109>,
      < 4.755401, -1.595510, -2.769109>
    }
    triangle {
      < 4.755401, -1.595510, -2.769109>,
      < 4.738365, -1.637684, -2.769109>,
      < 4.726285, -1.633759, -2.756803>
    }
    triangle {
      < 4.755401, -1.595510, -2.769109>,
      < 4.726285, -1.633759, -2.756803>,
      < 4.743986, -1.589942, -2.756803>
    }
    triangle {
      < 4.743986, -1.589942, -2.756803>,
      < 4.726285, -1.633759, -2.756803>,
      < 4.706151, -1.627217, -2.779159>
    }
    triangle {
      < 4.743986, -1.589942, -2.756803>,
      < 4.706151, -1.627217, -2.779159>,
      < 4.724957, -1.580661, -2.779159>
    }
    triangle {
      < 4.724957, -1.580661, -2.779159>,
      < 4.706151, -1.627217, -2.779159>,
      < 4.625612, -1.601046, -2.764932>
    }
    triangle {
      < 4.724957, -1.580661, -2.779159>,
      < 4.625612, -1.601046, -2.764932>,
      < 4.643519, -1.552763, -2.764932>
    }
    triangle {
      < 4.643519, -1.552763, -2.764932>,
      < 4.625612, -1.601046, -2.764932>,
      < 4.591143, -1.589843, -2.663333>
    }
    triangle {
      < 4.643519, -1.552763, -2.764932>,
      < 4.591143, -1.589843, -2.663333>,
      < 4.610510, -1.537623, -2.663333>
    }
    triangle {
      < 4.610510, -1.537623, -2.663333>,
      < 4.591143, -1.589843, -2.663333>,
      < 4.512216, -1.564196, -2.663332>
    }
    triangle {
      < 4.610510, -1.537623, -2.663333>,
      < 4.512216, -1.564196, -2.663332>,
      < 4.541680, -1.491264, -2.663332>
    }
    triangle {
      < 4.541680, -1.491264, -2.663332>,
      < 4.512216, -1.564196, -2.663332>,
      < 4.504806, -1.561790, -2.744609>
    }
    triangle {
      < 4.541680, -1.491264, -2.663332>,
      < 4.504806, -1.561790, -2.744609>,
      < 4.534678, -1.487850, -2.744609>
    }
    triangle {
      < 4.534678, -1.487850, -2.744609>,
      < 4.504806, -1.561790, -2.744609>,
      < 4.444402, -1.542162, -2.736479>
    }
    triangle {
      < 4.534678, -1.487850, -2.744609>,
      < 4.444402, -1.542162, -2.736479>,
      < 4.477593, -1.460007, -2.736479>
    }
    triangle {
      < 4.477593, -1.460007, -2.736479>,
      < 4.444402, -1.542162, -2.736479>,
      < 4.444323, -1.542133, -2.633340>
    }
    triangle {
      < 4.477593, -1.460007, -2.736479>,
      < 4.444323, -1.542133, -2.633340>,
      < 4.477518, -1.459967, -2.633340>
    }
    triangle {
      < 4.944293, -1.704601, -2.828054>,
      < 4.940600, -1.719425, -2.828054>,
      < 4.933770, -1.718220, -2.842164>
    }
    triangle {
      < 4.944293, -1.704601, -2.828054>,
      < 4.933770, -1.718220, -2.842164>,
      < 4.937696, -1.702458, -2.842164>
    }
    triangle {
      < 4.937696, -1.702458, -2.842164>,
      < 4.933770, -1.718220, -2.842164>,
      < 4.830566, -1.700020, -2.813766>
    }
    triangle {
      < 4.937696, -1.702458, -2.842164>,
      < 4.830566, -1.700020, -2.813766>,
      < 4.838031, -1.670071, -2.813766>
    }
    triangle {
      < 4.838031, -1.670071, -2.813766>,
      < 4.830566, -1.700020, -2.813766>,
      < 4.727363, -1.681818, -2.769109>
    }
    triangle {
      < 4.838031, -1.670071, -2.813766>,
      < 4.727363, -1.681818, -2.769109>,
      < 4.738365, -1.637684, -2.769109>
    }
    triangle {
      < 4.738365, -1.637684, -2.769109>,
      < 4.727363, -1.681818, -2.769109>,
      < 4.714855, -1.679612, -2.756803>
    }
    triangle {
      < 4.738365, -1.637684, -2.769109>,
      < 4.714855, -1.679612, -2.756803>,
      < 4.726285, -1.633759, -2.756803>
    }
    triangle {
      < 4.726285, -1.633759, -2.756803>,
      < 4.714855, -1.679612, -2.756803>,
      < 4.694005, -1.675936, -2.779159>
    }
    triangle {
      < 4.726285, -1.633759, -2.756803>,
      < 4.694005, -1.675936, -2.779159>,
      < 4.706151, -1.627217, -2.779159>
    }
    triangle {
      < 4.706151, -1.627217, -2.779159>,
      < 4.694005, -1.675936, -2.779159>,
      < 4.611722, -1.650634, -2.764932>
    }
    triangle {
      < 4.706151, -1.627217, -2.779159>,
      < 4.611722, -1.650634, -2.764932>,
      < 4.625612, -1.601046, -2.764932>
    }
    triangle {
      < 4.625612, -1.601046, -2.764932>,
      < 4.611722, -1.650634, -2.764932>,
      < 4.576120, -1.643473, -2.663333>
    }
    triangle {
      < 4.625612, -1.601046, -2.764932>,
      < 4.576120, -1.643473, -2.663333>,
      < 4.591143, -1.589843, -2.663333>
    }
    triangle {
      < 4.591143, -1.589843, -2.663333>,
      < 4.576120, -1.643473, -2.663333>,
      < 4.493187, -1.640519, -2.663332>
    }
    triangle {
      < 4.591143, -1.589843, -2.663333>,
      < 4.493187, -1.640519, -2.663332>,
      < 4.512216, -1.564196, -2.663332>
    }
    triangle {
      < 4.512216, -1.564196, -2.663332>,
      < 4.493187, -1.640519, -2.663332>,
      < 4.485515, -1.639168, -2.744609>
    }
    triangle {
      < 4.512216, -1.564196, -2.663332>,
      < 4.485515, -1.639168, -2.744609>,
      < 4.504806, -1.561790, -2.744609>
    }
    triangle {
      < 4.504806, -1.561790, -2.744609>,
      < 4.485515, -1.639168, -2.744609>,
      < 4.422968, -1.628137, -2.736479>
    }
    triangle {
      < 4.504806, -1.561790, -2.744609>,
      < 4.422968, -1.628137, -2.736479>,
      < 4.444402, -1.542162, -2.736479>
    }
    triangle {
      < 4.444402, -1.542162, -2.736479>,
      < 4.422968, -1.628137, -2.736479>,
      < 4.422885, -1.628120, -2.633340>
    }
    triangle {
      < 4.444402, -1.542162, -2.736479>,
      < 4.422885, -1.628120, -2.633340>,
      < 4.444323, -1.542133, -2.633340>
    }
    triangle {
      < 4.940600, -1.719425, -2.828054>,
      < 4.939007, -1.734618, -2.828054>,
      < 4.932076, -1.734376, -2.842164>
    }
    triangle {
      < 4.940600, -1.719425, -2.828054>,
      < 4.932076, -1.734376, -2.842164>,
      < 4.933770, -1.718220, -2.842164>
    }
    triangle {
      < 4.933770, -1.718220, -2.842164>,
      < 4.932076, -1.734376, -2.842164>,
      < 4.827343, -1.730716, -2.813766>
    }
    triangle {
      < 4.933770, -1.718220, -2.842164>,
      < 4.827343, -1.730716, -2.813766>,
      < 4.830566, -1.700020, -2.813766>
    }
    triangle {
      < 4.830566, -1.700020, -2.813766>,
      < 4.827343, -1.730716, -2.813766>,
      < 4.722611, -1.727054, -2.769109>
    }
    triangle {
      < 4.830566, -1.700020, -2.813766>,
      < 4.722611, -1.727054, -2.769109>,
      < 4.727363, -1.681818, -2.769109>
    }
    triangle {
      < 4.727363, -1.681818, -2.769109>,
      < 4.722611, -1.727054, -2.769109>,
      < 4.709918, -1.726610, -2.756803>
    }
    triangle {
      < 4.727363, -1.681818, -2.769109>,
      < 4.709918, -1.726610, -2.756803>,
      < 4.714855, -1.679612, -2.756803>
    }
    triangle {
      < 4.714855, -1.679612, -2.756803>,
      < 4.709918, -1.726610, -2.756803>,
      < 4.688759, -1.725872, -2.779159>
    }
    triangle {
      < 4.714855, -1.679612, -2.756803>,
      < 4.688759, -1.725872, -2.779159>,
      < 4.694005, -1.675936, -2.779159>
    }
    triangle {
      < 4.625706, -1.707338, -2.768997>,
      < 4.688759, -1.725872, -2.779159>,
      < 4.603015, -1.733508, -2.764932>
    }
    triangle {
      < 4.591243, -1.704800, -2.663333>,
      < 4.625706, -1.707338, -2.768997>,
      < 4.603015, -1.733508, -2.764932>
    }
    triangle {
      < 4.591243, -1.704800, -2.663333>,
      < 4.603015, -1.733508, -2.764932>,
      < 4.566702, -1.733103, -2.663333>
    }
    triangle {
      < 4.594242, -1.676260, -2.663333>,
      < 4.591243, -1.704800, -2.663333>,
      < 4.566702, -1.733103, -2.663333>
    }
    triangle {
      < 4.594242, -1.676260, -2.663333>,
      < 4.566702, -1.733103, -2.663333>,
      < 4.576120, -1.643473, -2.663333>
    }
    triangle {
      < 4.493187, -1.640519, -2.663332>,
      < 4.484967, -1.718747, -2.663332>,
      < 4.477180, -1.718477, -2.744609>
    }
    triangle {
      < 4.493187, -1.640519, -2.663332>,
      < 4.477180, -1.718477, -2.744609>,
      < 4.485515, -1.639168, -2.744609>
    }
    triangle {
      < 4.485515, -1.639168, -2.744609>,
      < 4.477180, -1.718477, -2.744609>,
      < 4.413707, -1.716258, -2.736479>
    }
    triangle {
      < 4.485515, -1.639168, -2.744609>,
      < 4.413707, -1.716258, -2.736479>,
      < 4.422968, -1.628137, -2.736479>
    }
    triangle {
      < 4.422968, -1.628137, -2.736479>,
      < 4.413707, -1.716258, -2.736479>,
      < 4.413622, -1.716253, -2.633340>
    }
    triangle {
      < 4.422968, -1.628137, -2.736479>,
      < 4.413622, -1.716253, -2.633340>,
      < 4.422885, -1.628120, -2.633340>
    }
    triangle {
      < 4.939007, -1.734618, -2.828054>,
      < 4.939544, -1.749886, -2.828054>,
      < 4.932646, -1.750611, -2.842164>
    }
    triangle {
      < 4.939007, -1.734618, -2.828054>,
      < 4.932646, -1.750611, -2.842164>,
      < 4.932076, -1.734376, -2.842164>
    }
    triangle {
      < 4.932076, -1.734376, -2.842164>,
      < 4.932646, -1.750611, -2.842164>,
      < 4.828423, -1.761561, -2.813766>
    }
    triangle {
      < 4.932076, -1.734376, -2.842164>,
      < 4.828423, -1.761561, -2.813766>,
      < 4.827343, -1.730716, -2.813766>
    }
    triangle {
      < 4.827343, -1.730716, -2.813766>,
      < 4.828423, -1.761561, -2.813766>,
      < 4.724201, -1.772511, -2.769109>
    }
    triangle {
      < 4.827343, -1.730716, -2.813766>,
      < 4.724201, -1.772511, -2.769109>,
      < 4.722611, -1.727054, -2.769109>
    }
    triangle {
      < 4.722611, -1.727054, -2.769109>,
      < 4.724201, -1.772511, -2.769109>,
      < 4.711569, -1.773839, -2.756803>
    }
    triangle {
      < 4.722611, -1.727054, -2.769109>,
      < 4.711569, -1.773839, -2.756803>,
      < 4.709918, -1.726610, -2.756803>
    }
    triangle {
      < 4.709918, -1.726610, -2.756803>,
      < 4.711569, -1.773839, -2.756803>,
      < 4.690514, -1.776051, -2.779159>
    }
    triangle {
      < 4.709918, -1.726610, -2.756803>,
      < 4.690514, -1.776051, -2.779159>,
      < 4.688759, -1.725872, -2.779159>
    }
    triangle {
      < 4.688759, -1.725872, -2.779159>,
      < 4.690514, -1.776051, -2.779159>,
      < 4.606295, -1.784901, -2.764932>
    }
    triangle {
      < 4.688759, -1.725872, -2.779159>,
      < 4.606295, -1.784901, -2.764932>,
      < 4.603015, -1.733508, -2.764932>
    }
    triangle {
      < 4.603015, -1.733508, -2.764932>,
      < 4.606295, -1.784901, -2.764932>,
      < 4.570248, -1.788685, -2.663333>
    }
    triangle {
      < 4.603015, -1.733508, -2.764932>,
      < 4.570248, -1.788685, -2.663333>,
      < 4.566702, -1.733103, -2.663333>
    }
    triangle {
      < 4.566702, -1.733103, -2.663333>,
      < 4.570248, -1.788685, -2.663333>,
      < 4.487713, -1.797358, -2.663332>
    }
    triangle {
      < 4.566702, -1.733103, -2.663333>,
      < 4.487713, -1.797358, -2.663332>,
      < 4.484967, -1.718747, -2.663332>
    }
    triangle {
      < 4.484967, -1.718747, -2.663332>,
      < 4.487713, -1.797358, -2.663332>,
      < 4.479965, -1.798174, -2.744609>
    }
    triangle {
      < 4.484967, -1.718747, -2.663332>,
      < 4.479965, -1.798174, -2.744609>,
      < 4.477180, -1.718477, -2.744609>
    }
    triangle {
      < 4.477180, -1.718477, -2.744609>,
      < 4.479965, -1.798174, -2.744609>,
      < 4.416800, -1.804811, -2.736479>
    }
    triangle {
      < 4.477180, -1.718477, -2.744609>,
      < 4.416800, -1.804811, -2.736479>,
      < 4.413707, -1.716258, -2.736479>
    }
    triangle {
      < 4.413707, -1.716258, -2.736479>,
      < 4.416800, -1.804811, -2.736479>,
      < 4.416716, -1.804817, -2.633340>
    }
    triangle {
      < 4.413707, -1.716258, -2.736479>,
      < 4.416716, -1.804817, -2.633340>,
      < 4.413622, -1.716253, -2.633340>
    }
    triangle {
      < 4.939544, -1.749886, -2.828054>,
      < 4.942200, -1.764930, -2.828054>,
      < 4.935470, -1.766608, -2.842164>
    }
    triangle {
      < 4.939544, -1.749886, -2.828054>,
      < 4.935470, -1.766608, -2.842164>,
      < 4.932646, -1.750611, -2.842164>
    }
    triangle {
      < 4.932646, -1.750611, -2.842164>,
      < 4.935470, -1.766608, -2.842164>,
      < 4.833786, -1.791957, -2.813766>
    }
    triangle {
      < 4.932646, -1.750611, -2.842164>,
      < 4.833786, -1.791957, -2.813766>,
      < 4.828423, -1.761561, -2.813766>
    }
    triangle {
      < 4.828423, -1.761561, -2.813766>,
      < 4.833786, -1.791957, -2.813766>,
      < 4.732101, -1.817305, -2.769109>
    }
    triangle {
      < 4.828423, -1.761561, -2.813766>,
      < 4.732101, -1.817305, -2.769109>,
      < 4.724201, -1.772511, -2.769109>
    }
    triangle {
      < 4.724201, -1.772511, -2.769109>,
      < 4.732101, -1.817305, -2.769109>,
      < 4.719777, -1.820377, -2.756803>
    }
    triangle {
      < 4.724201, -1.772511, -2.769109>,
      < 4.719777, -1.820377, -2.756803>,
      < 4.711569, -1.773839, -2.756803>
    }
    triangle {
      < 4.711569, -1.773839, -2.756803>,
      < 4.719777, -1.820377, -2.756803>,
      < 4.699235, -1.825499, -2.779159>
    }
    triangle {
      < 4.711569, -1.773839, -2.756803>,
      < 4.699235, -1.825499, -2.779159>,
      < 4.690514, -1.776051, -2.779159>
    }
    triangle {
      < 4.690514, -1.776051, -2.779159>,
      < 4.699235, -1.825499, -2.779159>,
      < 4.613774, -1.835851, -2.764932>
    }
    triangle {
      < 4.690514, -1.776051, -2.779159>,
      < 4.613774, -1.835851, -2.764932>,
      < 4.606295, -1.784901, -2.764932>
    }
    triangle {
      < 4.606295, -1.784901, -2.764932>,
      < 4.613774, -1.835851, -2.764932>,
      < 4.578337, -1.843790, -2.663333>
    }
    triangle {
      < 4.606295, -1.784901, -2.764932>,
      < 4.578337, -1.843790, -2.663333>,
      < 4.570248, -1.788685, -2.663333>
    }
    triangle {
      < 4.570248, -1.788685, -2.663333>,
      < 4.578337, -1.843790, -2.663333>,
      < 4.501373, -1.874822, -2.663332>
    }
    triangle {
      < 4.570248, -1.788685, -2.663333>,
      < 4.501373, -1.874822, -2.663332>,
      < 4.487713, -1.797358, -2.663332>
    }
    triangle {
      < 4.487713, -1.797358, -2.663332>,
      < 4.501373, -1.874822, -2.663332>,
      < 4.493814, -1.876708, -2.744609>
    }
    triangle {
      < 4.487713, -1.797358, -2.663332>,
      < 4.493814, -1.876708, -2.744609>,
      < 4.479965, -1.798174, -2.744609>
    }
    triangle {
      < 4.479965, -1.798174, -2.744609>,
      < 4.493814, -1.876708, -2.744609>,
      < 4.432188, -1.892071, -2.736479>
    }
    triangle {
      < 4.479965, -1.798174, -2.744609>,
      < 4.432188, -1.892071, -2.736479>,
      < 4.416800, -1.804811, -2.736479>
    }
    triangle {
      < 4.416800, -1.804811, -2.736479>,
      < 4.432188, -1.892071, -2.736479>,
      < 4.432105, -1.892089, -2.633340>
    }
    triangle {
      < 4.416800, -1.804811, -2.736479>,
      < 4.432105, -1.892089, -2.633340>,
      < 4.416716, -1.804817, -2.633340>
    }
    triangle {
      < 4.942200, -1.764930, -2.828054>,
      < 4.946923, -1.779458, -2.828054>,
      < 4.940493, -1.782057, -2.842164>
    }
    triangle {
      < 4.942200, -1.764930, -2.828054>,
      < 4.940493, -1.782057, -2.842164>,
      < 4.935470, -1.766608, -2.842164>
    }
    triangle {
      < 4.935470, -1.766608, -2.842164>,
      < 4.940493, -1.782057, -2.842164>,
      < 4.843326, -1.821310, -2.813766>
    }
    triangle {
      < 4.935470, -1.766608, -2.842164>,
      < 4.843326, -1.821310, -2.813766>,
      < 4.833786, -1.791957, -2.813766>
    }
    triangle {
      < 4.833786, -1.791957, -2.813766>,
      < 4.843326, -1.821310, -2.813766>,
      < 4.746159, -1.860563, -2.769109>
    }
    triangle {
      < 4.833786, -1.791957, -2.813766>,
      < 4.746159, -1.860563, -2.769109>,
      < 4.732101, -1.817305, -2.769109>
    }
    triangle {
      < 4.732101, -1.817305, -2.769109>,
      < 4.746159, -1.860563, -2.769109>,
      < 4.734382, -1.865320, -2.756803>
    }
    triangle {
      < 4.732101, -1.817305, -2.769109>,
      < 4.734382, -1.865320, -2.756803>,
      < 4.719777, -1.820377, -2.756803>
    }
    triangle {
      < 4.719777, -1.820377, -2.756803>,
      < 4.734382, -1.865320, -2.756803>,
      < 4.714753, -1.873251, -2.779159>
    }
    triangle {
      < 4.719777, -1.820377, -2.756803>,
      < 4.714753, -1.873251, -2.779159>,
      < 4.699235, -1.825499, -2.779159>
    }
    triangle {
      < 4.649612, -1.881966, -2.768997>,
      < 4.714753, -1.873251, -2.779159>,
      < 4.639527, -1.915102, -2.764932>
    }
    triangle {
      < 4.617096, -1.893664, -2.663333>,
      < 4.649612, -1.881966, -2.768997>,
      < 4.639527, -1.915102, -2.764932>
    }
    triangle {
      < 4.617096, -1.893664, -2.663333>,
      < 4.639527, -1.915102, -2.764932>,
      < 4.606188, -1.929502, -2.663333>
    }
    triangle {
      < 4.608228, -1.866371, -2.663333>,
      < 4.617096, -1.893664, -2.663333>,
      < 4.606188, -1.929502, -2.663333>
    }
    triangle {
      < 4.608228, -1.866371, -2.663333>,
      < 4.606188, -1.929502, -2.663333>,
      < 4.578337, -1.843790, -2.663333>
    }
    triangle {
      < 4.501373, -1.874822, -2.663332>,
      < 4.525680, -1.949631, -2.663332>,
      < 4.518457, -1.952551, -2.744609>
    }
    triangle {
      < 4.501373, -1.874822, -2.663332>,
      < 4.518457, -1.952551, -2.744609>,
      < 4.493814, -1.876708, -2.744609>
    }
    triangle {
      < 4.493814, -1.876708, -2.744609>,
      < 4.518457, -1.952551, -2.744609>,
      < 4.459569, -1.976341, -2.736479>
    }
    triangle {
      < 4.493814, -1.876708, -2.744609>,
      < 4.459569, -1.976341, -2.736479>,
      < 4.432188, -1.892071, -2.736479>
    }
    triangle {
      < 4.432188, -1.892071, -2.736479>,
      < 4.459569, -1.976341, -2.736479>,
      < 4.459489, -1.976370, -2.633340>
    }
    triangle {
      < 4.432188, -1.892071, -2.736479>,
      < 4.459489, -1.976370, -2.633340>,
      < 4.432105, -1.892089, -2.633340>
    }
    triangle {
      < 4.946923, -1.779458, -2.828054>,
      < 4.953623, -1.793188, -2.828054>,
      < 4.940493, -1.782057, -2.842164>
    }
    triangle {
      < 4.940493, -1.782057, -2.842164>,
      < 4.850687, -1.836390, -2.813766>,
      < 4.843326, -1.821310, -2.813766>
    }
    triangle {
      < 4.850687, -1.836390, -2.813766>,
      < 4.763003, -1.894722, -2.769109>,
      < 4.746159, -1.860563, -2.769109>
    }
    triangle {
      < 4.850687, -1.836390, -2.813766>,
      < 4.746159, -1.860563, -2.769109>,
      < 4.843326, -1.821310, -2.813766>
    }
    triangle {
      < 4.763003, -1.894722, -2.769109>,
      < 4.755100, -1.907794, -2.756803>,
      < 4.734382, -1.865320, -2.756803>
    }
    triangle {
      < 4.763003, -1.894722, -2.769109>,
      < 4.734382, -1.865320, -2.756803>,
      < 4.746159, -1.860563, -2.769109>
    }
    triangle {
      < 4.734382, -1.865320, -2.756803>,
      < 4.755100, -1.907794, -2.756803>,
      < 4.736765, -1.918379, -2.779159>
    }
    triangle {
      < 4.734382, -1.865320, -2.756803>,
      < 4.736765, -1.918379, -2.779159>,
      < 4.714753, -1.873251, -2.779159>
    }
    triangle {
      < 4.714753, -1.873251, -2.779159>,
      < 4.736765, -1.918379, -2.779159>,
      < 4.663425, -1.960718, -2.764932>
    }
    triangle {
      < 4.714753, -1.873251, -2.779159>,
      < 4.663425, -1.960718, -2.764932>,
      < 4.639527, -1.915102, -2.764932>
    }
    triangle {
      < 4.639527, -1.915102, -2.764932>,
      < 4.663425, -1.960718, -2.764932>,
      < 4.632035, -1.978837, -2.663333>
    }
    triangle {
      < 4.639527, -1.915102, -2.764932>,
      < 4.632035, -1.978837, -2.663333>,
      < 4.606188, -1.929502, -2.663333>
    }
    triangle {
      < 4.606188, -1.929502, -2.663333>,
      < 4.632035, -1.978837, -2.663333>,
      < 4.560163, -2.020329, -2.663332>
    }
    triangle {
      < 4.606188, -1.929502, -2.663333>,
      < 4.560163, -2.020329, -2.663332>,
      < 4.525680, -1.949631, -2.663332>
    }
    triangle {
      < 4.525680, -1.949631, -2.663332>,
      < 4.560163, -2.020329, -2.663332>,
      < 4.553416, -2.024226, -2.744609>
    }
    triangle {
      < 4.525680, -1.949631, -2.663332>,
      < 4.553416, -2.024226, -2.744609>,
      < 4.518457, -1.952551, -2.744609>
    }
    triangle {
      < 4.518457, -1.952551, -2.744609>,
      < 4.553416, -2.024226, -2.744609>,
      < 4.498412, -2.055980, -2.736479>
    }
    triangle {
      < 4.518457, -1.952551, -2.744609>,
      < 4.498412, -2.055980, -2.736479>,
      < 4.459569, -1.976341, -2.736479>
    }
    triangle {
      < 4.459569, -1.976341, -2.736479>,
      < 4.498412, -2.055980, -2.736479>,
      < 4.498337, -2.056020, -2.633340>
    }
    triangle {
      < 4.459569, -1.976341, -2.736479>,
      < 4.498337, -2.056020, -2.633340>,
      < 4.459489, -1.976370, -2.633340>
    }
    triangle {
      < 4.953623, -1.793188, -2.828054>,
      < 4.962169, -1.805851, -2.828054>,
      < 4.956703, -1.810121, -2.842164>
    }
    triangle {
      < 4.956703, -1.810121, -2.842164>,
      < 4.874120, -1.874636, -2.813766>,
      < 4.864738, -1.860723, -2.813766>
    }
    triangle {
      < 4.864738, -1.860723, -2.813766>,
      < 4.874120, -1.874636, -2.813766>,
      < 4.791536, -1.939151, -2.769109>
    }
    triangle {
      < 4.864738, -1.860723, -2.813766>,
      < 4.791536, -1.939151, -2.769109>,
      < 4.770373, -1.907486, -2.769109>
    }
    triangle {
      < 4.770373, -1.907486, -2.769109>,
      < 4.791536, -1.939151, -2.769109>,
      < 4.781527, -1.946970, -2.756803>
    }
    triangle {
      < 4.770373, -1.907486, -2.769109>,
      < 4.781527, -1.946970, -2.756803>,
      < 4.755100, -1.907794, -2.756803>
    }
    triangle {
      < 4.755100, -1.907794, -2.756803>,
      < 4.781527, -1.946970, -2.756803>,
      < 4.764844, -1.960004, -2.779159>
    }
    triangle {
      < 4.755100, -1.907794, -2.756803>,
      < 4.764844, -1.960004, -2.779159>,
      < 4.736765, -1.918379, -2.779159>
    }
    triangle {
      < 4.736765, -1.918379, -2.779159>,
      < 4.764844, -1.960004, -2.779159>,
      < 4.690982, -2.004221, -2.764932>
    }
    triangle {
      < 4.736765, -1.918379, -2.779159>,
      < 4.690982, -2.004221, -2.764932>,
      < 4.663425, -1.960718, -2.764932>
    }
    triangle {
      < 4.663425, -1.960718, -2.764932>,
      < 4.690982, -2.004221, -2.764932>,
      < 4.661838, -2.025887, -2.663333>
    }
    triangle {
      < 4.663425, -1.960718, -2.764932>,
      < 4.661838, -2.025887, -2.663333>,
      < 4.632035, -1.978837, -2.663333>
    }
    triangle {
      < 4.632035, -1.978837, -2.663333>,
      < 4.661838, -2.025887, -2.663333>,
      < 4.604148, -2.085540, -2.663332>
    }
    triangle {
      < 4.632035, -1.978837, -2.663333>,
      < 4.604148, -2.085540, -2.663332>,
      < 4.560163, -2.020329, -2.663332>
    }
    triangle {
      < 4.560163, -2.020329, -2.663332>,
      < 4.604148, -2.085540, -2.663332>,
      < 4.598010, -2.090338, -2.744609>
    }
    triangle {
      < 4.560163, -2.020329, -2.663332>,
      < 4.598010, -2.090338, -2.744609>,
      < 4.553416, -2.024226, -2.744609>
    }
    triangle {
      < 4.553416, -2.024226, -2.744609>,
      < 4.598010, -2.090338, -2.744609>,
      < 4.547960, -2.129438, -2.736479>
    }
    triangle {
      < 4.553416, -2.024226, -2.744609>,
      < 4.547960, -2.129438, -2.736479>,
      < 4.498412, -2.055980, -2.736479>
    }
    triangle {
      < 4.498412, -2.055980, -2.736479>,
      < 4.547960, -2.129438, -2.736479>,
      < 4.547892, -2.129488, -2.633340>
    }
    triangle {
      < 4.498412, -2.055980, -2.736479>,
      < 4.547892, -2.129488, -2.633340>,
      < 4.498337, -2.056020, -2.633340>
    }
    triangle {
      < 4.962169, -1.805851, -2.828054>,
      < 4.972393, -1.817202, -2.828054>,
      < 4.967575, -1.822191, -2.842164>
    }
    triangle {
      < 4.962169, -1.805851, -2.828054>,
      < 4.967575, -1.822191, -2.842164>,
      < 4.956703, -1.810121, -2.842164>
    }
    triangle {
      < 4.956703, -1.810121, -2.842164>,
      < 4.967575, -1.822191, -2.842164>,
      < 4.894774, -1.897572, -2.813766>
    }
    triangle {
      < 4.956703, -1.810121, -2.842164>,
      < 4.894774, -1.897572, -2.813766>,
      < 4.874120, -1.874636, -2.813766>
    }
    triangle {
      < 4.874120, -1.874636, -2.813766>,
      < 4.894774, -1.897572, -2.813766>,
      < 4.821973, -1.972952, -2.769109>
    }
    triangle {
      < 4.874120, -1.874636, -2.813766>,
      < 4.821973, -1.972952, -2.769109>,
      < 4.791536, -1.939151, -2.769109>
    }
    triangle {
      < 4.791536, -1.939151, -2.769109>,
      < 4.821973, -1.972952, -2.769109>,
      < 4.813149, -1.982088, -2.756803>
    }
    triangle {
      < 4.791536, -1.939151, -2.769109>,
      < 4.813149, -1.982088, -2.756803>,
      < 4.781527, -1.946970, -2.756803>
    }
    triangle {
      < 4.781527, -1.946970, -2.756803>,
      < 4.813149, -1.982088, -2.756803>,
      < 4.798442, -1.997317, -2.779159>
    }
    triangle {
      < 4.781527, -1.946970, -2.756803>,
      < 4.798442, -1.997317, -2.779159>,
      < 4.764844, -1.960004, -2.779159>
    }
    triangle {
      < 4.742478, -2.031773, -2.768997>,
      < 4.798442, -1.997317, -2.779159>,
      < 4.746742, -2.066147, -2.764932>
    }
    triangle {
      < 4.717531, -2.055685, -2.663333>,
      < 4.742478, -2.031773, -2.768997>,
      < 4.746742, -2.066147, -2.764932>
    }
    triangle {
      < 4.717531, -2.055685, -2.663333>,
      < 4.746742, -2.066147, -2.764932>,
      < 4.722143, -2.092861, -2.663333>
    }
    triangle {
      < 4.661838, -2.025887, -2.663333>,
      < 4.722143, -2.092861, -2.663333>,
      < 4.656782, -2.143995, -2.663332>
    }
    triangle {
      < 4.661838, -2.025887, -2.663333>,
      < 4.656782, -2.143995, -2.663332>,
      < 4.604148, -2.085540, -2.663332>
    }
    triangle {
      < 4.604148, -2.085540, -2.663332>,
      < 4.656782, -2.143995, -2.663332>,
      < 4.651371, -2.149601, -2.744609>
    }
    triangle {
      < 4.604148, -2.085540, -2.663332>,
      < 4.651371, -2.149601, -2.744609>,
      < 4.598010, -2.090338, -2.744609>
    }
    triangle {
      < 4.598010, -2.090338, -2.744609>,
      < 4.651371, -2.149601, -2.744609>,
      < 4.607250, -2.195286, -2.736479>
    }
    triangle {
      < 4.598010, -2.090338, -2.744609>,
      < 4.607250, -2.195286, -2.736479>,
      < 4.547960, -2.129438, -2.736479>
    }
    triangle {
      < 4.547960, -2.129438, -2.736479>,
      < 4.607250, -2.195286, -2.736479>,
      < 4.607189, -2.195345, -2.633340>
    }
    triangle {
      < 4.547960, -2.129438, -2.736479>,
      < 4.607189, -2.195345, -2.633340>,
      < 4.547892, -2.129488, -2.633340>
    }
    triangle {
      < 4.972393, -1.817202, -2.828054>,
      < 4.984098, -1.827019, -2.828054>,
      < 4.980021, -1.832631, -2.842164>
    }
    triangle {
      < 4.972393, -1.817202, -2.828054>,
      < 4.980021, -1.832631, -2.842164>,
      < 4.967575, -1.822191, -2.842164>
    }
    triangle {
      < 4.967575, -1.822191, -2.842164>,
      < 4.980021, -1.832631, -2.842164>,
      < 4.918419, -1.917409, -2.813766>
    }
    triangle {
      < 4.967575, -1.822191, -2.842164>,
      < 4.918419, -1.917409, -2.813766>,
      < 4.894774, -1.897572, -2.813766>
    }
    triangle {
      < 4.894774, -1.897572, -2.813766>,
      < 4.918419, -1.917409, -2.813766>,
      < 4.856817, -2.002188, -2.769109>
    }
    triangle {
      < 4.894774, -1.897572, -2.813766>,
      < 4.856817, -2.002188, -2.769109>,
      < 4.821973, -1.972952, -2.769109>
    }
    triangle {
      < 4.821973, -1.972952, -2.769109>,
      < 4.856817, -2.002188, -2.769109>,
      < 4.849351, -2.012463, -2.756803>
    }
    triangle {
      < 4.821973, -1.972952, -2.769109>,
      < 4.849351, -2.012463, -2.756803>,
      < 4.813149, -1.982088, -2.756803>
    }
    triangle {
      < 4.813149, -1.982088, -2.756803>,
      < 4.849351, -2.012463, -2.756803>,
      < 4.836907, -2.029590, -2.779159>
    }
    triangle {
      < 4.813149, -1.982088, -2.756803>,
      < 4.836907, -2.029590, -2.779159>,
      < 4.798442, -1.997317, -2.779159>
    }
    triangle {
      < 4.798442, -1.997317, -2.779159>,
      < 4.836907, -2.029590, -2.779159>,
      < 4.787128, -2.098098, -2.764932>
    }
    triangle {
      < 4.798442, -1.997317, -2.779159>,
      < 4.787128, -2.098098, -2.764932>,
      < 4.746742, -2.066147, -2.764932>
    }
    triangle {
      < 4.746742, -2.066147, -2.764932>,
      < 4.787128, -2.098098, -2.764932>,
      < 4.765821, -2.127418, -2.663333>
    }
    triangle {
      < 4.746742, -2.066147, -2.764932>,
      < 4.765821, -2.127418, -2.663333>,
      < 4.722143, -2.092861, -2.663333>
    }
    triangle {
      < 4.722143, -2.092861, -2.663333>,
      < 4.765821, -2.127418, -2.663333>,
      < 4.717038, -2.194556, -2.663332>
    }
    triangle {
      < 4.722143, -2.092861, -2.663333>,
      < 4.717038, -2.194556, -2.663332>,
      < 4.656782, -2.143995, -2.663332>
    }
    triangle {
      < 4.656782, -2.143995, -2.663332>,
      < 4.717038, -2.194556, -2.663332>,
      < 4.712460, -2.200860, -2.744609>
    }
    triangle {
      < 4.656782, -2.143995, -2.663332>,
      < 4.712460, -2.200860, -2.744609>,
      < 4.651371, -2.149601, -2.744609>
    }
    triangle {
      < 4.651371, -2.149601, -2.744609>,
      < 4.712460, -2.200860, -2.744609>,
      < 4.675126, -2.252241, -2.736479>
    }
    triangle {
      < 4.651371, -2.149601, -2.744609>,
      < 4.675126, -2.252241, -2.736479>,
      < 4.607250, -2.195286, -2.736479>
    }
    triangle {
      < 4.607250, -2.195286, -2.736479>,
      < 4.675126, -2.252241, -2.736479>,
      < 4.675074, -2.252308, -2.633340>
    }
    triangle {
      < 4.607250, -2.195286, -2.736479>,
      < 4.675074, -2.252308, -2.633340>,
      < 4.607189, -2.195345, -2.633340>
    }
    triangle {
      < 4.984098, -1.827019, -2.828054>,
      < 4.997055, -1.835112, -2.828054>,
      < 4.993799, -1.841236, -2.842164>
    }
    triangle {
      < 4.984098, -1.827019, -2.828054>,
      < 4.993799, -1.841236, -2.842164>,
      < 4.980021, -1.832631, -2.842164>
    }
    triangle {
      < 4.980021, -1.832631, -2.842164>,
      < 4.993799, -1.841236, -2.842164>,
      < 4.944595, -1.933763, -2.813766>
    }
    triangle {
      < 4.980021, -1.832631, -2.842164>,
      < 4.944595, -1.933763, -2.813766>,
      < 4.918419, -1.917409, -2.813766>
    }
    triangle {
      < 4.918419, -1.917409, -2.813766>,
      < 4.944595, -1.933763, -2.813766>,
      < 4.895391, -2.026290, -2.769109>
    }
    triangle {
      < 4.918419, -1.917409, -2.813766>,
      < 4.895391, -2.026290, -2.769109>,
      < 4.856817, -2.002188, -2.769109>
    }
    triangle {
      < 4.856817, -2.002188, -2.769109>,
      < 4.895391, -2.026290, -2.769109>,
      < 4.889428, -2.037504, -2.756803>
    }
    triangle {
      < 4.856817, -2.002188, -2.769109>,
      < 4.889428, -2.037504, -2.756803>,
      < 4.849351, -2.012463, -2.756803>
    }
    triangle {
      < 4.849351, -2.012463, -2.756803>,
      < 4.889428, -2.037504, -2.756803>,
      < 4.879488, -2.056197, -2.779159>
    }
    triangle {
      < 4.849351, -2.012463, -2.756803>,
      < 4.879488, -2.056197, -2.779159>,
      < 4.836907, -2.029590, -2.779159>
    }
    triangle {
      < 4.836907, -2.029590, -2.779159>,
      < 4.879488, -2.056197, -2.779159>,
      < 4.829997, -2.126633, -2.764932>
    }
    triangle {
      < 4.836907, -2.029590, -2.779159>,
      < 4.829997, -2.126633, -2.764932>,
      < 4.787128, -2.098098, -2.764932>
    }
    triangle {
      < 4.787128, -2.098098, -2.764932>,
      < 4.829997, -2.126633, -2.764932>,
      < 4.812184, -2.158279, -2.663333>
    }
    triangle {
      < 4.787128, -2.098098, -2.764932>,
      < 4.812184, -2.158279, -2.663333>,
      < 4.765821, -2.127418, -2.663333>
    }
    triangle {
      < 4.765821, -2.127418, -2.663333>,
      < 4.812184, -2.158279, -2.663333>,
      < 4.783744, -2.236239, -2.663332>
    }
    triangle {
      < 4.765821, -2.127418, -2.663333>,
      < 4.783744, -2.236239, -2.663332>,
      < 4.717038, -2.194556, -2.663332>
    }
    triangle {
      < 4.717038, -2.194556, -2.663332>,
      < 4.783744, -2.236239, -2.663332>,
      < 4.780088, -2.243119, -2.744609>
    }
    triangle {
      < 4.717038, -2.194556, -2.663332>,
      < 4.780088, -2.243119, -2.744609>,
      < 4.712460, -2.200860, -2.744609>
    }
    triangle {
      < 4.712460, -2.200860, -2.744609>,
      < 4.780088, -2.243119, -2.744609>,
      < 4.750268, -2.299196, -2.736479>
    }
    triangle {
      < 4.712460, -2.200860, -2.744609>,
      < 4.750268, -2.299196, -2.736479>,
      < 4.675126, -2.252241, -2.736479>
    }
    triangle {
      < 4.675126, -2.252241, -2.736479>,
      < 4.750268, -2.299196, -2.736479>,
      < 4.750226, -2.299269, -2.633340>
    }
    triangle {
      < 4.675126, -2.252241, -2.736479>,
      < 4.750226, -2.299269, -2.633340>,
      < 4.675074, -2.252308, -2.633340>
    }
    triangle {
      < 4.997055, -1.835112, -2.828054>,
      < 5.011013, -1.841323, -2.828054>,
      < 5.008640, -1.847841, -2.842164>
    }
    triangle {
      < 4.997055, -1.835112, -2.828054>,
      < 5.008640, -1.847841, -2.842164>,
      < 4.993799, -1.841236, -2.842164>
    }
    triangle {
      < 4.993799, -1.841236, -2.842164>,
      < 5.008640, -1.847841, -2.842164>,
      < 4.972793, -1.946315, -2.813766>
    }
    triangle {
      < 4.993799, -1.841236, -2.842164>,
      < 4.972793, -1.946315, -2.813766>,
      < 4.944595, -1.933763, -2.813766>
    }
    triangle {
      < 4.944595, -1.933763, -2.813766>,
      < 4.972793, -1.946315, -2.813766>,
      < 4.936944, -2.044789, -2.769109>
    }
    triangle {
      < 4.944595, -1.933763, -2.813766>,
      < 4.936944, -2.044789, -2.769109>,
      < 4.895391, -2.026290, -2.769109>
    }
    triangle {
      < 4.895391, -2.026290, -2.769109>,
      < 4.936944, -2.044789, -2.769109>,
      < 4.932600, -2.056724, -2.756803>
    }
    triangle {
      < 4.895391, -2.026290, -2.769109>,
      < 4.932600, -2.056724, -2.756803>,
      < 4.889428, -2.037504, -2.756803>
    }
    triangle {
      < 4.889428, -2.037504, -2.756803>,
      < 4.932600, -2.056724, -2.756803>,
      < 4.925358, -2.076618, -2.779159>
    }
    triangle {
      < 4.889428, -2.037504, -2.756803>,
      < 4.925358, -2.076618, -2.779159>,
      < 4.879488, -2.056197, -2.779159>
    }
    triangle {
      < 4.888246, -2.130858, -2.768997>,
      < 4.925358, -2.076618, -2.779159>,
      < 4.906123, -2.160526, -2.764932>
    }
    triangle {
      < 4.875182, -2.162849, -2.663333>,
      < 4.888246, -2.130858, -2.768997>,
      < 4.906123, -2.160526, -2.764932>
    }
    triangle {
      < 4.875182, -2.162849, -2.663333>,
      < 4.906123, -2.160526, -2.764932>,
      < 4.894516, -2.194936, -2.663333>
    }
    triangle {
      < 4.812184, -2.158279, -2.663333>,
      < 4.894516, -2.194936, -2.663333>,
      < 4.855603, -2.268233, -2.663332>
    }
    triangle {
      < 4.812184, -2.158279, -2.663333>,
      < 4.855603, -2.268233, -2.663332>,
      < 4.783744, -2.236239, -2.663332>
    }
    triangle {
      < 4.783744, -2.236239, -2.663332>,
      < 4.855603, -2.268233, -2.663332>,
      < 4.852940, -2.275555, -2.744609>
    }
    triangle {
      < 4.783744, -2.236239, -2.663332>,
      < 4.852940, -2.275555, -2.744609>,
      < 4.780088, -2.243119, -2.744609>
    }
    triangle {
      < 4.780088, -2.243119, -2.744609>,
      < 4.852940, -2.275555, -2.744609>,
      < 4.831214, -2.335236, -2.736479>
    }
    triangle {
      < 4.780088, -2.243119, -2.744609>,
      < 4.831214, -2.335236, -2.736479>,
      < 4.750268, -2.299196, -2.736479>
    }
    triangle {
      < 4.750268, -2.299196, -2.736479>,
      < 4.831214, -2.335236, -2.736479>,
      < 4.831182, -2.335315, -2.633340>
    }
    triangle {
      < 4.750268, -2.299196, -2.736479>,
      < 4.831182, -2.335315, -2.633340>,
      < 4.750226, -2.299269, -2.633340>
    }
    triangle {
      < 5.011013, -1.841323, -2.828054>,
      < 5.025699, -1.845531, -2.828054>,
      < 5.024256, -1.852316, -2.842164>
    }
    triangle {
      < 5.011013, -1.841323, -2.828054>,
      < 5.024256, -1.852316, -2.842164>,
      < 5.008640, -1.847841, -2.842164>
    }
    triangle {
      < 5.008640, -1.847841, -2.842164>,
      < 5.024256, -1.852316, -2.842164>,
      < 5.002462, -1.954820, -2.813766>
    }
    triangle {
      < 5.008640, -1.847841, -2.842164>,
      < 5.002462, -1.954820, -2.813766>,
      < 4.972793, -1.946315, -2.813766>
    }
    triangle {
      < 4.972793, -1.946315, -2.813766>,
      < 5.002462, -1.954820, -2.813766>,
      < 4.980668, -2.057325, -2.769109>
    }
    triangle {
      < 4.972793, -1.946315, -2.813766>,
      < 4.980668, -2.057325, -2.769109>,
      < 4.936944, -2.044789, -2.769109>
    }
    triangle {
      < 4.936944, -2.044789, -2.769109>,
      < 4.980668, -2.057325, -2.769109>,
      < 4.978026, -2.069749, -2.756803>
    }
    triangle {
      < 4.936944, -2.044789, -2.769109>,
      < 4.978026, -2.069749, -2.756803>,
      < 4.932600, -2.056724, -2.756803>
    }
    triangle {
      < 4.932600, -2.056724, -2.756803>,
      < 4.978026, -2.069749, -2.756803>,
      < 4.973624, -2.090457, -2.779159>
    }
    triangle {
      < 4.932600, -2.056724, -2.756803>,
      < 4.973624, -2.090457, -2.779159>,
      < 4.925358, -2.076618, -2.779159>
    }
    triangle {
      < 4.925358, -2.076618, -2.779159>,
      < 4.973624, -2.090457, -2.779159>,
      < 4.956013, -2.173289, -2.764932>
    }
    triangle {
      < 4.925358, -2.076618, -2.779159>,
      < 4.956013, -2.173289, -2.764932>,
      < 4.906123, -2.160526, -2.764932>
    }
    triangle {
      < 4.906123, -2.160526, -2.764932>,
      < 4.956013, -2.173289, -2.764932>,
      < 4.948473, -2.208740, -2.663333>
    }
    triangle {
      < 4.906123, -2.160526, -2.764932>,
      < 4.948473, -2.208740, -2.663333>,
      < 4.894516, -2.194936, -2.663333>
    }
    triangle {
      < 4.894516, -2.194936, -2.663333>,
      < 4.948473, -2.208740, -2.663333>,
      < 4.931214, -2.289915, -2.663332>
    }
    triangle {
      < 4.894516, -2.194936, -2.663333>,
      < 4.931214, -2.289915, -2.663332>,
      < 4.855603, -2.268233, -2.663332>
    }
    triangle {
      < 4.855603, -2.268233, -2.663332>,
      < 4.931214, -2.289915, -2.663332>,
      < 4.929596, -2.297536, -2.744609>
    }
    triangle {
      < 4.855603, -2.268233, -2.663332>,
      < 4.929596, -2.297536, -2.744609>,
      < 4.852940, -2.275555, -2.744609>
    }
    triangle {
      < 4.852940, -2.275555, -2.744609>,
      < 4.929596, -2.297536, -2.744609>,
      < 4.916388, -2.359660, -2.736479>
    }
    triangle {
      < 4.852940, -2.275555, -2.744609>,
      < 4.916388, -2.359660, -2.736479>,
      < 4.831214, -2.335236, -2.736479>
    }
    triangle {
      < 4.831214, -2.335236, -2.736479>,
      < 4.916388, -2.359660, -2.736479>,
      < 4.916368, -2.359742, -2.633340>
    }
    triangle {
      < 4.831214, -2.335236, -2.736479>,
      < 4.916368, -2.359742, -2.633340>,
      < 4.831182, -2.335315, -2.633340>
    }
    triangle {
      < 5.025699, -1.845531, -2.828054>,
      < 5.040827, -1.847654, -2.828054>,
      < 5.040343, -1.854573, -2.842164>
    }
    triangle {
      < 5.025699, -1.845531, -2.828054>,
      < 5.040343, -1.854573, -2.842164>,
      < 5.024256, -1.852316, -2.842164>
    }
    triangle {
      < 5.024256, -1.852316, -2.842164>,
      < 5.040343, -1.854573, -2.842164>,
      < 5.033027, -1.959114, -2.813766>
    }
    triangle {
      < 5.024256, -1.852316, -2.842164>,
      < 5.033027, -1.959114, -2.813766>,
      < 5.002462, -1.954820, -2.813766>
    }
    triangle {
      < 5.002462, -1.954820, -2.813766>,
      < 5.033027, -1.959114, -2.813766>,
      < 5.025710, -2.063654, -2.769109>
    }
    triangle {
      < 5.002462, -1.954820, -2.813766>,
      < 5.025710, -2.063654, -2.769109>,
      < 4.980668, -2.057325, -2.769109>
    }
    triangle {
      < 4.980668, -2.057325, -2.769109>,
      < 5.025710, -2.063654, -2.769109>,
      < 5.024823, -2.076324, -2.756803>
    }
    triangle {
      < 4.980668, -2.057325, -2.769109>,
      < 5.024823, -2.076324, -2.756803>,
      < 4.978026, -2.069749, -2.756803>
    }
    triangle {
      < 4.978026, -2.069749, -2.756803>,
      < 5.024823, -2.076324, -2.756803>,
      < 5.023346, -2.097444, -2.779159>
    }
    triangle {
      < 4.978026, -2.069749, -2.756803>,
      < 5.023346, -2.097444, -2.779159>,
      < 4.973624, -2.090457, -2.779159>
    }
    triangle {
      < 4.973624, -2.090457, -2.779159>,
      < 5.023346, -2.097444, -2.779159>,
      < 5.006781, -2.181921, -2.764932>
    }
    triangle {
      < 4.973624, -2.090457, -2.779159>,
      < 5.006781, -2.181921, -2.764932>,
      < 4.956013, -2.173289, -2.764932>
    }
    triangle {
      < 4.956013, -2.173289, -2.764932>,
      < 5.006781, -2.181921, -2.764932>,
      < 5.003380, -2.218076, -2.663333>
    }
    triangle {
      < 4.956013, -2.173289, -2.764932>,
      < 5.003380, -2.218076, -2.663333>,
      < 4.948473, -2.208740, -2.663333>
    }
    triangle {
      < 4.948473, -2.208740, -2.663333>,
      < 5.003380, -2.218076, -2.663333>,
      < 5.009108, -2.300864, -2.663332>
    }
    triangle {
      < 4.948473, -2.208740, -2.663333>,
      < 5.009108, -2.300864, -2.663332>,
      < 4.931214, -2.289915, -2.663332>
    }
    triangle {
      < 4.931214, -2.289915, -2.663332>,
      < 5.009108, -2.300864, -2.663332>,
      < 5.008566, -2.308635, -2.744609>
    }
    triangle {
      < 4.931214, -2.289915, -2.663332>,
      < 5.008566, -2.308635, -2.744609>,
      < 4.929596, -2.297536, -2.744609>
    }
    triangle {
      < 4.929596, -2.297536, -2.744609>,
      < 5.008566, -2.308635, -2.744609>,
      < 5.004132, -2.371993, -2.736479>
    }
    triangle {
      < 4.929596, -2.297536, -2.744609>,
      < 5.004132, -2.371993, -2.736479>,
      < 4.916388, -2.359660, -2.736479>
    }
    triangle {
      < 4.916388, -2.359660, -2.736479>,
      < 5.004132, -2.371993, -2.736479>,
      < 5.004124, -2.372077, -2.633340>
    }
    triangle {
      < 4.916388, -2.359660, -2.736479>,
      < 5.004124, -2.372077, -2.633340>,
      < 4.916368, -2.359742, -2.633340>
    }
    triangle {
      < 5.040827, -1.847654, -2.828054>,
      < 5.056104, -1.847651, -2.828054>,
      < 5.056588, -1.854571, -2.842164>
    }
    triangle {
      < 5.040827, -1.847654, -2.828054>,
      < 5.056588, -1.854571, -2.842164>,
      < 5.040343, -1.854573, -2.842164>
    }
    triangle {
      < 5.040343, -1.854573, -2.842164>,
      < 5.056588, -1.854571, -2.842164>,
      < 5.063892, -1.959112, -2.813766>
    }
    triangle {
      < 5.040343, -1.854573, -2.842164>,
      < 5.063892, -1.959112, -2.813766>,
      < 5.033027, -1.959114, -2.813766>
    }
    triangle {
      < 5.033027, -1.959114, -2.813766>,
      < 5.063892, -1.959112, -2.813766>,
      < 5.071195, -2.063653, -2.769109>
    }
    triangle {
      < 5.033027, -1.959114, -2.813766>,
      < 5.071195, -2.063653, -2.769109>,
      < 5.025710, -2.063654, -2.769109>
    }
    triangle {
      < 5.025710, -2.063654, -2.769109>,
      < 5.071195, -2.063653, -2.769109>,
      < 5.072080, -2.076324, -2.756803>
    }
    triangle {
      < 5.025710, -2.063654, -2.769109>,
      < 5.072080, -2.076324, -2.756803>,
      < 5.024823, -2.076324, -2.756803>
    }
    triangle {
      < 5.024823, -2.076324, -2.756803>,
      < 5.072080, -2.076324, -2.756803>,
      < 5.073556, -2.097443, -2.779159>
    }
    triangle {
      < 5.024823, -2.076324, -2.756803>,
      < 5.073556, -2.097443, -2.779159>,
      < 5.023346, -2.097444, -2.779159>
    }
    triangle {
      < 5.061714, -2.162088, -2.768997>,
      < 5.073556, -2.097443, -2.779159>,
      < 5.090111, -2.181920, -2.764932>
    }
    triangle {
      < 5.062791, -2.196627, -2.663333>,
      < 5.061714, -2.162088, -2.768997>,
      < 5.090111, -2.181920, -2.764932>
    }
    triangle {
      < 5.062791, -2.196627, -2.663333>,
      < 5.090111, -2.181920, -2.764932>,
      < 5.093503, -2.218077, -2.663333>
    }
    triangle {
      < 5.003380, -2.218076, -2.663333>,
      < 5.093503, -2.218077, -2.663333>,
      < 5.087767, -2.300864, -2.663332>
    }
    triangle {
      < 5.003380, -2.218076, -2.663333>,
      < 5.087767, -2.300864, -2.663332>,
      < 5.009108, -2.300864, -2.663332>
    }
    triangle {
      < 5.009108, -2.300864, -2.663332>,
      < 5.087767, -2.300864, -2.663332>,
      < 5.088312, -2.308636, -2.744609>
    }
    triangle {
      < 5.009108, -2.300864, -2.663332>,
      < 5.088312, -2.308636, -2.744609>,
      < 5.008566, -2.308635, -2.744609>
    }
    triangle {
      < 5.008566, -2.308635, -2.744609>,
      < 5.088312, -2.308636, -2.744609>,
      < 5.092739, -2.371994, -2.736479>
    }
    triangle {
      < 5.008566, -2.308635, -2.744609>,
      < 5.092739, -2.371994, -2.736479>,
      < 5.004132, -2.371993, -2.736479>
    }
    triangle {
      < 5.004132, -2.371993, -2.736479>,
      < 5.092739, -2.371994, -2.736479>,
      < 5.092742, -2.372079, -2.633340>
    }
    triangle {
      < 5.004132, -2.371993, -2.736479>,
      < 5.092742, -2.372079, -2.633340>,
      < 5.004124, -2.372077, -2.633340>
    }
    triangle {
      < 5.056104, -1.847651, -2.828054>,
      < 5.071232, -1.845522, -2.828054>,
      < 5.072674, -1.852307, -2.842164>
    }
    triangle {
      < 5.056104, -1.847651, -2.828054>,
      < 5.072674, -1.852307, -2.842164>,
      < 5.056588, -1.854571, -2.842164>
    }
    triangle {
      < 5.056588, -1.854571, -2.842164>,
      < 5.072674, -1.852307, -2.842164>,
      < 5.094456, -1.954814, -2.813766>
    }
    triangle {
      < 5.056588, -1.854571, -2.842164>,
      < 5.094456, -1.954814, -2.813766>,
      < 5.063892, -1.959112, -2.813766>
    }
    triangle {
      < 5.063892, -1.959112, -2.813766>,
      < 5.094456, -1.954814, -2.813766>,
      < 5.116237, -2.057322, -2.769109>
    }
    triangle {
      < 5.063892, -1.959112, -2.813766>,
      < 5.116237, -2.057322, -2.769109>,
      < 5.071195, -2.063653, -2.769109>
    }
    triangle {
      < 5.071195, -2.063653, -2.769109>,
      < 5.116237, -2.057322, -2.769109>,
      < 5.118877, -2.069746, -2.756803>
    }
    triangle {
      < 5.071195, -2.063653, -2.769109>,
      < 5.118877, -2.069746, -2.756803>,
      < 5.072080, -2.076324, -2.756803>
    }
    triangle {
      < 5.072080, -2.076324, -2.756803>,
      < 5.118877, -2.069746, -2.756803>,
      < 5.123278, -2.090454, -2.779159>
    }
    triangle {
      < 5.072080, -2.076324, -2.756803>,
      < 5.123278, -2.090454, -2.779159>,
      < 5.073556, -2.097443, -2.779159>
    }
    triangle {
      < 5.073556, -2.097443, -2.779159>,
      < 5.123278, -2.090454, -2.779159>,
      < 5.140880, -2.173288, -2.764932>
    }
    triangle {
      < 5.073556, -2.097443, -2.779159>,
      < 5.140880, -2.173288, -2.764932>,
      < 5.090111, -2.181920, -2.764932>
    }
    triangle {
      < 5.090111, -2.181920, -2.764932>,
      < 5.140880, -2.173288, -2.764932>,
      < 5.148411, -2.208741, -2.663333>
    }
    triangle {
      < 5.090111, -2.181920, -2.764932>,
      < 5.148411, -2.208741, -2.663333>,
      < 5.093503, -2.218077, -2.663333>
    }
    triangle {
      < 5.093503, -2.218077, -2.663333>,
      < 5.148411, -2.208741, -2.663333>,
      < 5.165660, -2.289918, -2.663332>
    }
    triangle {
      < 5.093503, -2.218077, -2.663333>,
      < 5.165660, -2.289918, -2.663332>,
      < 5.087767, -2.300864, -2.663332>
    }
    triangle {
      < 5.087767, -2.300864, -2.663332>,
      < 5.165660, -2.289918, -2.663332>,
      < 5.167282, -2.297539, -2.744609>
    }
    triangle {
      < 5.087767, -2.300864, -2.663332>,
      < 5.167282, -2.297539, -2.744609>,
      < 5.088312, -2.308636, -2.744609>
    }
    triangle {
      < 5.088312, -2.308636, -2.744609>,
      < 5.167282, -2.297539, -2.744609>,
      < 5.180483, -2.359664, -2.736479>
    }
    triangle {
      < 5.088312, -2.308636, -2.744609>,
      < 5.180483, -2.359664, -2.736479>,
      < 5.092739, -2.371994, -2.736479>
    }
    triangle {
      < 5.092739, -2.371994, -2.736479>,
      < 5.180483, -2.359664, -2.736479>,
      < 5.180498, -2.359747, -2.633340>
    }
    triangle {
      < 5.092739, -2.371994, -2.736479>,
      < 5.180498, -2.359747, -2.633340>,
      < 5.092742, -2.372079, -2.633340>
    }
    triangle {
      < 5.071232, -1.845522, -2.828054>,
      < 5.085916, -1.841309, -2.828054>,
      < 5.088288, -1.847826, -2.842164>
    }
    triangle {
      < 5.071232, -1.845522, -2.828054>,
      < 5.088288, -1.847826, -2.842164>,
      < 5.072674, -1.852307, -2.842164>
    }
    triangle {
      < 5.072674, -1.852307, -2.842164>,
      < 5.088288, -1.847826, -2.842164>,
      < 5.124124, -1.946305, -2.813766>
    }
    triangle {
      < 5.072674, -1.852307, -2.842164>,
      < 5.124124, -1.946305, -2.813766>,
      < 5.094456, -1.954814, -2.813766>
    }
    triangle {
      < 5.094456, -1.954814, -2.813766>,
      < 5.124124, -1.946305, -2.813766>,
      < 5.159960, -2.044784, -2.769109>
    }
    triangle {
      < 5.094456, -1.954814, -2.813766>,
      < 5.159960, -2.044784, -2.769109>,
      < 5.116237, -2.057322, -2.769109>
    }
    triangle {
      < 5.116237, -2.057322, -2.769109>,
      < 5.159960, -2.044784, -2.769109>,
      < 5.164303, -2.056719, -2.756803>
    }
    triangle {
      < 5.116237, -2.057322, -2.769109>,
      < 5.164303, -2.056719, -2.756803>,
      < 5.118877, -2.069746, -2.756803>
    }
    triangle {
      < 5.118877, -2.069746, -2.756803>,
      < 5.164303, -2.056719, -2.756803>,
      < 5.171543, -2.076614, -2.779159>
    }
    triangle {
      < 5.118877, -2.069746, -2.756803>,
      < 5.171543, -2.076614, -2.779159>,
      < 5.123278, -2.090454, -2.779159>
    }
    triangle {
      < 5.123278, -2.090454, -2.779159>,
      < 5.171543, -2.076614, -2.779159>,
      < 5.190770, -2.160525, -2.764932>
    }
    triangle {
      < 5.123278, -2.090454, -2.779159>,
      < 5.190770, -2.160525, -2.764932>,
      < 5.140880, -2.173288, -2.764932>
    }
    triangle {
      < 5.140880, -2.173288, -2.764932>,
      < 5.190770, -2.160525, -2.764932>,
      < 5.202368, -2.194938, -2.663333>
    }
    triangle {
      < 5.140880, -2.173288, -2.764932>,
      < 5.202368, -2.194938, -2.663333>,
      < 5.148411, -2.208741, -2.663333>
    }
    triangle {
      < 5.148411, -2.208741, -2.663333>,
      < 5.202368, -2.194938, -2.663333>,
      < 5.241273, -2.268238, -2.663332>
    }
    triangle {
      < 5.148411, -2.208741, -2.663333>,
      < 5.241273, -2.268238, -2.663332>,
      < 5.165660, -2.289918, -2.663332>
    }
    triangle {
      < 5.165660, -2.289918, -2.663332>,
      < 5.241273, -2.268238, -2.663332>,
      < 5.243939, -2.275559, -2.744609>
    }
    triangle {
      < 5.165660, -2.289918, -2.663332>,
      < 5.243939, -2.275559, -2.744609>,
      < 5.167282, -2.297539, -2.744609>
    }
    triangle {
      < 5.167282, -2.297539, -2.744609>,
      < 5.243939, -2.275559, -2.744609>,
      < 5.265658, -2.335242, -2.736479>
    }
    triangle {
      < 5.167282, -2.297539, -2.744609>,
      < 5.265658, -2.335242, -2.736479>,
      < 5.180483, -2.359664, -2.736479>
    }
    triangle {
      < 5.180483, -2.359664, -2.736479>,
      < 5.265658, -2.335242, -2.736479>,
      < 5.265685, -2.335323, -2.633340>
    }
    triangle {
      < 5.180483, -2.359664, -2.736479>,
      < 5.265685, -2.335323, -2.633340>,
      < 5.180498, -2.359747, -2.633340>
    }
    triangle {
      < 5.085916, -1.841309, -2.828054>,
      < 5.099871, -1.835093, -2.828054>,
      < 5.103127, -1.841217, -2.842164>
    }
    triangle {
      < 5.085916, -1.841309, -2.828054>,
      < 5.103127, -1.841217, -2.842164>,
      < 5.088288, -1.847826, -2.842164>
    }
    triangle {
      < 5.088288, -1.847826, -2.842164>,
      < 5.103127, -1.841217, -2.842164>,
      < 5.152320, -1.933749, -2.813766>
    }
    triangle {
      < 5.088288, -1.847826, -2.842164>,
      < 5.152320, -1.933749, -2.813766>,
      < 5.124124, -1.946305, -2.813766>
    }
    triangle {
      < 5.124124, -1.946305, -2.813766>,
      < 5.152320, -1.933749, -2.813766>,
      < 5.201512, -2.026282, -2.769109>
    }
    triangle {
      < 5.124124, -1.946305, -2.813766>,
      < 5.201512, -2.026282, -2.769109>,
      < 5.159960, -2.044784, -2.769109>
    }
    triangle {
      < 5.159960, -2.044784, -2.769109>,
      < 5.201512, -2.026282, -2.769109>,
      < 5.207474, -2.037498, -2.756803>
    }
    triangle {
      < 5.159960, -2.044784, -2.769109>,
      < 5.207474, -2.037498, -2.756803>,
      < 5.164303, -2.056719, -2.756803>
    }
    triangle {
      < 5.164303, -2.056719, -2.756803>,
      < 5.207474, -2.037498, -2.756803>,
      < 5.217412, -2.056191, -2.779159>
    }
    triangle {
      < 5.164303, -2.056719, -2.756803>,
      < 5.217412, -2.056191, -2.779159>,
      < 5.171543, -2.076614, -2.779159>
    }
    triangle {
      < 5.232887, -2.120064, -2.768997>,
      < 5.217412, -2.056191, -2.779159>,
      < 5.266896, -2.126631, -2.764932>
    }
    triangle {
      < 5.247919, -2.151179, -2.663333>,
      < 5.232887, -2.120064, -2.768997>,
      < 5.266896, -2.126631, -2.764932>
    }
    triangle {
      < 5.247919, -2.151179, -2.663333>,
      < 5.266896, -2.126631, -2.764932>,
      < 5.284700, -2.158282, -2.663333>
    }
    triangle {
      < 5.202368, -2.194938, -2.663333>,
      < 5.284700, -2.158282, -2.663333>,
      < 5.313132, -2.236246, -2.663332>
    }
    triangle {
      < 5.202368, -2.194938, -2.663333>,
      < 5.313132, -2.236246, -2.663332>,
      < 5.241273, -2.268238, -2.663332>
    }
    triangle {
      < 5.241273, -2.268238, -2.663332>,
      < 5.313132, -2.236246, -2.663332>,
      < 5.316791, -2.243124, -2.744609>
    }
    triangle {
      < 5.241273, -2.268238, -2.663332>,
      < 5.316791, -2.243124, -2.744609>,
      < 5.243939, -2.275559, -2.744609>
    }
    triangle {
      < 5.243939, -2.275559, -2.744609>,
      < 5.316791, -2.243124, -2.744609>,
      < 5.346605, -2.299204, -2.736479>
    }
    triangle {
      < 5.243939, -2.275559, -2.744609>,
      < 5.346605, -2.299204, -2.736479>,
      < 5.265658, -2.335242, -2.736479>
    }
    triangle {
      < 5.265658, -2.335242, -2.736479>,
      < 5.346605, -2.299204, -2.736479>,
      < 5.346642, -2.299281, -2.633340>
    }
    triangle {
      < 5.265658, -2.335242, -2.736479>,
      < 5.346642, -2.299281, -2.633340>,
      < 5.265685, -2.335323, -2.633340>
    }
    triangle {
      < 5.099871, -1.835093, -2.828054>,
      < 5.112825, -1.826995, -2.828054>,
      < 5.116902, -1.832606, -2.842164>
    }
    triangle {
      < 5.099871, -1.835093, -2.828054>,
      < 5.116902, -1.832606, -2.842164>,
      < 5.103127, -1.841217, -2.842164>
    }
    triangle {
      < 5.103127, -1.841217, -2.842164>,
      < 5.116902, -1.832606, -2.842164>,
      < 5.178493, -1.917392, -2.813766>
    }
    triangle {
      < 5.103127, -1.841217, -2.842164>,
      < 5.178493, -1.917392, -2.813766>,
      < 5.152320, -1.933749, -2.813766>
    }
    triangle {
      < 5.152320, -1.933749, -2.813766>,
      < 5.178493, -1.917392, -2.813766>,
      < 5.240085, -2.002178, -2.769109>
    }
    triangle {
      < 5.152320, -1.933749, -2.813766>,
      < 5.240085, -2.002178, -2.769109>,
      < 5.201512, -2.026282, -2.769109>
    }
    triangle {
      < 5.201512, -2.026282, -2.769109>,
      < 5.240085, -2.002178, -2.769109>,
      < 5.247550, -2.012455, -2.756803>
    }
    triangle {
      < 5.201512, -2.026282, -2.769109>,
      < 5.247550, -2.012455, -2.756803>,
      < 5.207474, -2.037498, -2.756803>
    }
    triangle {
      < 5.207474, -2.037498, -2.756803>,
      < 5.247550, -2.012455, -2.756803>,
      < 5.259993, -2.029583, -2.779159>
    }
    triangle {
      < 5.207474, -2.037498, -2.756803>,
      < 5.259993, -2.029583, -2.779159>,
      < 5.217412, -2.056191, -2.779159>
    }
    triangle {
      < 5.217412, -2.056191, -2.779159>,
      < 5.259993, -2.029583, -2.779159>,
      < 5.309764, -2.098096, -2.764932>
    }
    triangle {
      < 5.217412, -2.056191, -2.779159>,
      < 5.309764, -2.098096, -2.764932>,
      < 5.266896, -2.126631, -2.764932>
    }
    triangle {
      < 5.266896, -2.126631, -2.764932>,
      < 5.309764, -2.098096, -2.764932>,
      < 5.331064, -2.127422, -2.663333>
    }
    triangle {
      < 5.266896, -2.126631, -2.764932>,
      < 5.331064, -2.127422, -2.663333>,
      < 5.284700, -2.158282, -2.663333>
    }
    triangle {
      < 5.284700, -2.158282, -2.663333>,
      < 5.331064, -2.127422, -2.663333>,
      < 5.379840, -2.194565, -2.663332>
    }
    triangle {
      < 5.284700, -2.158282, -2.663333>,
      < 5.379840, -2.194565, -2.663332>,
      < 5.313132, -2.236246, -2.663332>
    }
    triangle {
      < 5.313132, -2.236246, -2.663332>,
      < 5.379840, -2.194565, -2.663332>,
      < 5.384420, -2.200867, -2.744609>
    }
    triangle {
      < 5.313132, -2.236246, -2.663332>,
      < 5.384420, -2.200867, -2.744609>,
      < 5.316791, -2.243124, -2.744609>
    }
    triangle {
      < 5.316791, -2.243124, -2.744609>,
      < 5.384420, -2.200867, -2.744609>,
      < 5.421749, -2.252252, -2.736479>
    }
    triangle {
      < 5.316791, -2.243124, -2.744609>,
      < 5.421749, -2.252252, -2.736479>,
      < 5.346605, -2.299204, -2.736479>
    }
    triangle {
      < 5.346605, -2.299204, -2.736479>,
      < 5.421749, -2.252252, -2.736479>,
      < 5.421796, -2.252322, -2.633340>
    }
    triangle {
      < 5.346605, -2.299204, -2.736479>,
      < 5.421796, -2.252322, -2.633340>,
      < 5.346642, -2.299281, -2.633340>
    }
    triangle {
      < 5.112825, -1.826995, -2.828054>,
      < 5.124527, -1.817173, -2.828054>,
      < 5.129344, -1.822162, -2.842164>
    }
    triangle {
      < 5.112825, -1.826995, -2.828054>,
      < 5.129344, -1.822162, -2.842164>,
      < 5.116902, -1.832606, -2.842164>
    }
    triangle {
      < 5.116902, -1.832606, -2.842164>,
      < 5.129344, -1.822162, -2.842164>,
      < 5.202137, -1.897551, -2.813766>
    }
    triangle {
      < 5.116902, -1.832606, -2.842164>,
      < 5.202137, -1.897551, -2.813766>,
      < 5.178493, -1.917392, -2.813766>
    }
    triangle {
      < 5.178493, -1.917392, -2.813766>,
      < 5.202137, -1.897551, -2.813766>,
      < 5.274928, -1.972941, -2.769109>
    }
    triangle {
      < 5.178493, -1.917392, -2.813766>,
      < 5.274928, -1.972941, -2.769109>,
      < 5.240085, -2.002178, -2.769109>
    }
    triangle {
      < 5.240085, -2.002178, -2.769109>,
      < 5.274928, -1.972941, -2.769109>,
      < 5.283751, -1.982078, -2.756803>
    }
    triangle {
      < 5.240085, -2.002178, -2.769109>,
      < 5.283751, -1.982078, -2.756803>,
      < 5.247550, -2.012455, -2.756803>
    }
    triangle {
      < 5.247550, -2.012455, -2.756803>,
      < 5.283751, -1.982078, -2.756803>,
      < 5.298456, -1.997308, -2.779159>
    }
    triangle {
      < 5.247550, -2.012455, -2.756803>,
      < 5.298456, -1.997308, -2.779159>,
      < 5.259993, -2.029583, -2.779159>
    }
    triangle {
      < 5.259993, -2.029583, -2.779159>,
      < 5.298456, -1.997308, -2.779159>,
      < 5.350150, -2.066145, -2.764932>
    }
    triangle {
      < 5.259993, -2.029583, -2.779159>,
      < 5.350150, -2.066145, -2.764932>,
      < 5.309764, -2.098096, -2.764932>
    }
    triangle {
      < 5.309764, -2.098096, -2.764932>,
      < 5.350150, -2.066145, -2.764932>,
      < 5.374743, -2.092865, -2.663333>
    }
    triangle {
      < 5.309764, -2.098096, -2.764932>,
      < 5.374743, -2.092865, -2.663333>,
      < 5.331064, -2.127422, -2.663333>
    }
    triangle {
      < 5.331064, -2.127422, -2.663333>,
      < 5.374743, -2.092865, -2.663333>,
      < 5.440097, -2.144005, -2.663332>
    }
    triangle {
      < 5.331064, -2.127422, -2.663333>,
      < 5.440097, -2.144005, -2.663332>,
      < 5.379840, -2.194565, -2.663332>
    }
    triangle {
      < 5.379840, -2.194565, -2.663332>,
      < 5.440097, -2.144005, -2.663332>,
      < 5.445510, -2.149608, -2.744609>
    }
    triangle {
      < 5.379840, -2.194565, -2.663332>,
      < 5.445510, -2.149608, -2.744609>,
      < 5.384420, -2.200867, -2.744609>
    }
    triangle {
      < 5.384420, -2.200867, -2.744609>,
      < 5.445510, -2.149608, -2.744609>,
      < 5.489627, -2.195299, -2.736479>
    }
    triangle {
      < 5.384420, -2.200867, -2.744609>,
      < 5.489627, -2.195299, -2.736479>,
      < 5.421749, -2.252252, -2.736479>
    }
    triangle {
      < 5.421749, -2.252252, -2.736479>,
      < 5.489627, -2.195299, -2.736479>,
      < 5.489684, -2.195361, -2.633340>
    }
    triangle {
      < 5.421749, -2.252252, -2.736479>,
      < 5.489684, -2.195361, -2.633340>,
      < 5.421796, -2.252322, -2.633340>
    }
    triangle {
      < 5.124527, -1.817173, -2.828054>,
      < 5.134747, -1.805818, -2.828054>,
      < 5.140212, -1.810088, -2.842164>
    }
    triangle {
      < 5.124527, -1.817173, -2.828054>,
      < 5.140212, -1.810088, -2.842164>,
      < 5.129344, -1.822162, -2.842164>
    }
    triangle {
      < 5.129344, -1.822162, -2.842164>,
      < 5.140212, -1.810088, -2.842164>,
      < 5.222787, -1.874613, -2.813766>
    }
    triangle {
      < 5.129344, -1.822162, -2.842164>,
      < 5.222787, -1.874613, -2.813766>,
      < 5.202137, -1.897551, -2.813766>
    }
    triangle {
      < 5.202137, -1.897551, -2.813766>,
      < 5.222787, -1.874613, -2.813766>,
      < 5.305363, -1.939139, -2.769109>
    }
    triangle {
      < 5.202137, -1.897551, -2.813766>,
      < 5.305363, -1.939139, -2.769109>,
      < 5.274928, -1.972941, -2.769109>
    }
    triangle {
      < 5.274928, -1.972941, -2.769109>,
      < 5.305363, -1.939139, -2.769109>,
      < 5.315371, -1.946959, -2.756803>
    }
    triangle {
      < 5.274928, -1.972941, -2.769109>,
      < 5.315371, -1.946959, -2.756803>,
      < 5.283751, -1.982078, -2.756803>
    }
    triangle {
      < 5.283751, -1.982078, -2.756803>,
      < 5.315371, -1.946959, -2.756803>,
      < 5.332053, -1.959994, -2.779159>
    }
    triangle {
      < 5.283751, -1.982078, -2.756803>,
      < 5.332053, -1.959994, -2.779159>,
      < 5.298456, -1.997308, -2.779159>
    }
    triangle {
      < 5.372169, -2.012052, -2.768997>,
      < 5.332053, -1.959994, -2.779159>,
      < 5.405909, -2.004219, -2.764932>
    }
    triangle {
      < 5.398557, -2.034363, -2.663333>,
      < 5.372169, -2.012052, -2.768997>,
      < 5.405909, -2.004219, -2.764932>
    }
    triangle {
      < 5.398557, -2.034363, -2.663333>,
      < 5.405909, -2.004219, -2.764932>,
      < 5.435048, -2.025892, -2.663333>
    }
    triangle {
      < 5.374743, -2.092865, -2.663333>,
      < 5.435048, -2.025892, -2.663333>,
      < 5.492732, -2.085552, -2.663332>
    }
    triangle {
      < 5.374743, -2.092865, -2.663333>,
      < 5.492732, -2.085552, -2.663332>,
      < 5.440097, -2.144005, -2.663332>
    }
    triangle {
      < 5.440097, -2.144005, -2.663332>,
      < 5.492732, -2.085552, -2.663332>,
      < 5.498872, -2.090347, -2.744609>
    }
    triangle {
      < 5.440097, -2.144005, -2.663332>,
      < 5.498872, -2.090347, -2.744609>,
      < 5.445510, -2.149608, -2.744609>
    }
    triangle {
      < 5.445510, -2.149608, -2.744609>,
      < 5.498872, -2.090347, -2.744609>,
      < 5.548918, -2.129453, -2.736479>
    }
    triangle {
      < 5.445510, -2.149608, -2.744609>,
      < 5.548918, -2.129453, -2.736479>,
      < 5.489627, -2.195299, -2.736479>
    }
    triangle {
      < 5.489627, -2.195299, -2.736479>,
      < 5.548918, -2.129453, -2.736479>,
      < 5.548983, -2.129507, -2.633340>
    }
    triangle {
      < 5.489627, -2.195299, -2.736479>,
      < 5.548983, -2.129507, -2.633340>,
      < 5.489684, -2.195361, -2.633340>
    }
    triangle {
      < 5.134747, -1.805818, -2.828054>,
      < 5.143287, -1.793151, -2.828054>,
      < 5.140212, -1.810088, -2.842164>
    }
    triangle {
      < 5.140212, -1.810088, -2.842164>,
      < 5.232167, -1.860699, -2.813766>,
      < 5.222787, -1.874613, -2.813766>
    }
    triangle {
      < 5.232167, -1.860699, -2.813766>,
      < 5.326525, -1.907472, -2.769109>,
      < 5.305363, -1.939139, -2.769109>
    }
    triangle {
      < 5.232167, -1.860699, -2.813766>,
      < 5.305363, -1.939139, -2.769109>,
      < 5.222787, -1.874613, -2.813766>
    }
    triangle {
      < 5.326525, -1.907472, -2.769109>,
      < 5.341797, -1.907782, -2.756803>,
      < 5.315371, -1.946959, -2.756803>
    }
    triangle {
      < 5.326525, -1.907472, -2.769109>,
      < 5.315371, -1.946959, -2.756803>,
      < 5.305363, -1.939139, -2.769109>
    }
    triangle {
      < 5.315371, -1.946959, -2.756803>,
      < 5.341797, -1.907782, -2.756803>,
      < 5.360131, -1.918368, -2.779159>
    }
    triangle {
      < 5.315371, -1.946959, -2.756803>,
      < 5.360131, -1.918368, -2.779159>,
      < 5.332053, -1.959994, -2.779159>
    }
    triangle {
      < 5.332053, -1.959994, -2.779159>,
      < 5.360131, -1.918368, -2.779159>,
      < 5.433465, -1.960715, -2.764932>
    }
    triangle {
      < 5.332053, -1.959994, -2.779159>,
      < 5.433465, -1.960715, -2.764932>,
      < 5.405909, -2.004219, -2.764932>
    }
    triangle {
      < 5.405909, -2.004219, -2.764932>,
      < 5.433465, -1.960715, -2.764932>,
      < 5.464851, -1.978842, -2.663333>
    }
    triangle {
      < 5.405909, -2.004219, -2.764932>,
      < 5.464851, -1.978842, -2.663333>,
      < 5.435048, -2.025892, -2.663333>
    }
    triangle {
      < 5.435048, -2.025892, -2.663333>,
      < 5.464851, -1.978842, -2.663333>,
      < 5.536720, -2.020342, -2.663332>
    }
    triangle {
      < 5.435048, -2.025892, -2.663333>,
      < 5.536720, -2.020342, -2.663332>,
      < 5.492732, -2.085552, -2.663332>
    }
    triangle {
      < 5.492732, -2.085552, -2.663332>,
      < 5.536720, -2.020342, -2.663332>,
      < 5.543468, -2.024236, -2.744609>
    }
    triangle {
      < 5.492732, -2.085552, -2.663332>,
      < 5.543468, -2.024236, -2.744609>,
      < 5.498872, -2.090347, -2.744609>
    }
    triangle {
      < 5.498872, -2.090347, -2.744609>,
      < 5.543468, -2.024236, -2.744609>,
      < 5.598469, -2.055996, -2.736479>
    }
    triangle {
      < 5.498872, -2.090347, -2.744609>,
      < 5.598469, -2.055996, -2.736479>,
      < 5.548918, -2.129453, -2.736479>
    }
    triangle {
      < 5.548918, -2.129453, -2.736479>,
      < 5.598469, -2.055996, -2.736479>,
      < 5.598540, -2.056041, -2.633340>
    }
    triangle {
      < 5.548918, -2.129453, -2.736479>,
      < 5.598540, -2.056041, -2.633340>,
      < 5.548983, -2.129507, -2.633340>
    }
    triangle {
      < 5.143287, -1.793151, -2.828054>,
      < 5.149981, -1.779420, -2.828054>,
      < 5.156413, -1.782018, -2.842164>
    }
    triangle {
      < 5.246215, -1.836364, -2.813766>,
      < 5.156413, -1.782018, -2.842164>,
      < 5.253574, -1.821283, -2.813766>
    }
    triangle {
      < 5.246215, -1.836364, -2.813766>,
      < 5.253574, -1.821283, -2.813766>,
      < 5.350737, -1.860548, -2.769109>
    }
    triangle {
      < 5.246215, -1.836364, -2.813766>,
      < 5.350737, -1.860548, -2.769109>,
      < 5.333894, -1.894709, -2.769109>
    }
    triangle {
      < 5.350737, -1.860548, -2.769109>,
      < 5.362513, -1.865308, -2.756803>,
      < 5.341797, -1.907782, -2.756803>
    }
    triangle {
      < 5.350737, -1.860548, -2.769109>,
      < 5.341797, -1.907782, -2.756803>,
      < 5.333894, -1.894709, -2.769109>
    }
    triangle {
      < 5.341797, -1.907782, -2.756803>,
      < 5.362513, -1.865308, -2.756803>,
      < 5.382142, -1.873239, -2.779159>
    }
    triangle {
      < 5.341797, -1.907782, -2.756803>,
      < 5.382142, -1.873239, -2.779159>,
      < 5.360131, -1.918368, -2.779159>
    }
    triangle {
      < 5.360131, -1.918368, -2.779159>,
      < 5.382142, -1.873239, -2.779159>,
      < 5.457364, -1.915100, -2.764932>
    }
    triangle {
      < 5.360131, -1.918368, -2.779159>,
      < 5.457364, -1.915100, -2.764932>,
      < 5.433465, -1.960715, -2.764932>
    }
    triangle {
      < 5.433465, -1.960715, -2.764932>,
      < 5.457364, -1.915100, -2.764932>,
      < 5.490699, -1.929508, -2.663333>
    }
    triangle {
      < 5.433465, -1.960715, -2.764932>,
      < 5.490699, -1.929508, -2.663333>,
      < 5.464851, -1.978842, -2.663333>
    }
    triangle {
      < 5.464851, -1.978842, -2.663333>,
      < 5.490699, -1.929508, -2.663333>,
      < 5.571204, -1.949645, -2.663332>
    }
    triangle {
      < 5.464851, -1.978842, -2.663333>,
      < 5.571204, -1.949645, -2.663332>,
      < 5.536720, -2.020342, -2.663332>
    }
    triangle {
      < 5.536720, -2.020342, -2.663332>,
      < 5.571204, -1.949645, -2.663332>,
      < 5.578428, -1.952562, -2.744609>
    }
    triangle {
      < 5.536720, -2.020342, -2.663332>,
      < 5.578428, -1.952562, -2.744609>,
      < 5.543468, -2.024236, -2.744609>
    }
    triangle {
      < 5.543468, -2.024236, -2.744609>,
      < 5.578428, -1.952562, -2.744609>,
      < 5.637314, -1.976358, -2.736479>
    }
    triangle {
      < 5.543468, -2.024236, -2.744609>,
      < 5.637314, -1.976358, -2.736479>,
      < 5.598469, -2.055996, -2.736479>
    }
    triangle {
      < 5.598469, -2.055996, -2.736479>,
      < 5.637314, -1.976358, -2.736479>,
      < 5.637391, -1.976393, -2.633340>
    }
    triangle {
      < 5.598469, -2.055996, -2.736479>,
      < 5.637391, -1.976393, -2.633340>,
      < 5.598540, -2.056041, -2.633340>
    }
    triangle {
      < 5.149981, -1.779420, -2.828054>,
      < 5.154700, -1.764889, -2.828054>,
      < 5.161430, -1.766568, -2.842164>
    }
    triangle {
      < 5.149981, -1.779420, -2.828054>,
      < 5.161430, -1.766568, -2.842164>,
      < 5.156413, -1.782018, -2.842164>
    }
    triangle {
      < 5.156413, -1.782018, -2.842164>,
      < 5.161430, -1.766568, -2.842164>,
      < 5.263111, -1.791928, -2.813766>
    }
    triangle {
      < 5.156413, -1.782018, -2.842164>,
      < 5.263111, -1.791928, -2.813766>,
      < 5.253574, -1.821283, -2.813766>
    }
    triangle {
      < 5.253574, -1.821283, -2.813766>,
      < 5.263111, -1.791928, -2.813766>,
      < 5.364792, -1.817290, -2.769109>
    }
    triangle {
      < 5.253574, -1.821283, -2.813766>,
      < 5.364792, -1.817290, -2.769109>,
      < 5.350737, -1.860548, -2.769109>
    }
    triangle {
      < 5.350737, -1.860548, -2.769109>,
      < 5.364792, -1.817290, -2.769109>,
      < 5.377116, -1.820364, -2.756803>
    }
    triangle {
      < 5.350737, -1.860548, -2.769109>,
      < 5.377116, -1.820364, -2.756803>,
      < 5.362513, -1.865308, -2.756803>
    }
    triangle {
      < 5.362513, -1.865308, -2.756803>,
      < 5.377116, -1.820364, -2.756803>,
      < 5.397657, -1.825486, -2.779159>
    }
    triangle {
      < 5.362513, -1.865308, -2.756803>,
      < 5.397657, -1.825486, -2.779159>,
      < 5.382142, -1.873239, -2.779159>
    }
    triangle {
      < 5.455479, -1.856727, -2.768997>,
      < 5.397657, -1.825486, -2.779159>,
      < 5.483116, -1.835848, -2.764932>
    }
    triangle {
      < 5.488660, -1.866377, -2.663333>,
      < 5.455479, -1.856727, -2.768997>,
      < 5.483116, -1.835848, -2.764932>
    }
    triangle {
      < 5.488660, -1.866377, -2.663333>,
      < 5.483116, -1.835848, -2.764932>,
      < 5.518551, -1.843796, -2.663333>
    }
    triangle {
      < 5.490699, -1.929508, -2.663333>,
      < 5.518551, -1.843796, -2.663333>,
      < 5.595513, -1.874836, -2.663332>
    }
    triangle {
      < 5.490699, -1.929508, -2.663333>,
      < 5.595513, -1.874836, -2.663332>,
      < 5.571204, -1.949645, -2.663332>
    }
    triangle {
      < 5.571204, -1.949645, -2.663332>,
      < 5.595513, -1.874836, -2.663332>,
      < 5.603073, -1.876719, -2.744609>
    }
    triangle {
      < 5.571204, -1.949645, -2.663332>,
      < 5.603073, -1.876719, -2.744609>,
      < 5.578428, -1.952562, -2.744609>
    }
    triangle {
      < 5.578428, -1.952562, -2.744609>,
      < 5.603073, -1.876719, -2.744609>,
      < 5.664698, -1.892089, -2.736479>
    }
    triangle {
      < 5.578428, -1.952562, -2.744609>,
      < 5.664698, -1.892089, -2.736479>,
      < 5.637314, -1.976358, -2.736479>
    }
    triangle {
      < 5.637314, -1.976358, -2.736479>,
      < 5.664698, -1.892089, -2.736479>,
      < 5.664779, -1.892112, -2.633340>
    }
    triangle {
      < 5.637314, -1.976358, -2.736479>,
      < 5.664779, -1.892112, -2.633340>,
      < 5.637391, -1.976393, -2.633340>
    }
    triangle {
      < 5.154700, -1.764889, -2.828054>,
      < 5.157351, -1.749844, -2.828054>,
      < 5.164248, -1.750569, -2.842164>
    }
    triangle {
      < 5.154700, -1.764889, -2.828054>,
      < 5.164248, -1.750569, -2.842164>,
      < 5.161430, -1.766568, -2.842164>
    }
    triangle {
      < 5.161430, -1.766568, -2.842164>,
      < 5.164248, -1.750569, -2.842164>,
      < 5.268469, -1.761532, -2.813766>
    }
    triangle {
      < 5.161430, -1.766568, -2.842164>,
      < 5.268469, -1.761532, -2.813766>,
      < 5.263111, -1.791928, -2.813766>
    }
    triangle {
      < 5.263111, -1.791928, -2.813766>,
      < 5.268469, -1.761532, -2.813766>,
      < 5.372690, -1.772496, -2.769109>
    }
    triangle {
      < 5.263111, -1.791928, -2.813766>,
      < 5.372690, -1.772496, -2.769109>,
      < 5.364792, -1.817290, -2.769109>
    }
    triangle {
      < 5.364792, -1.817290, -2.769109>,
      < 5.372690, -1.772496, -2.769109>,
      < 5.385322, -1.773825, -2.756803>
    }
    triangle {
      < 5.364792, -1.817290, -2.769109>,
      < 5.385322, -1.773825, -2.756803>,
      < 5.377116, -1.820364, -2.756803>
    }
    triangle {
      < 5.377116, -1.820364, -2.756803>,
      < 5.385322, -1.773825, -2.756803>,
      < 5.406377, -1.776039, -2.779159>
    }
    triangle {
      < 5.377116, -1.820364, -2.756803>,
      < 5.406377, -1.776039, -2.779159>,
      < 5.397657, -1.825486, -2.779159>
    }
    triangle {
      < 5.397657, -1.825486, -2.779159>,
      < 5.406377, -1.776039, -2.779159>,
      < 5.490595, -1.784897, -2.764932>
    }
    triangle {
      < 5.397657, -1.825486, -2.779159>,
      < 5.490595, -1.784897, -2.764932>,
      < 5.483116, -1.835848, -2.764932>
    }
    triangle {
      < 5.483116, -1.835848, -2.764932>,
      < 5.490595, -1.784897, -2.764932>,
      < 5.526640, -1.788691, -2.663333>
    }
    triangle {
      < 5.483116, -1.835848, -2.764932>,
      < 5.526640, -1.788691, -2.663333>,
      < 5.518551, -1.843796, -2.663333>
    }
    triangle {
      < 5.518551, -1.843796, -2.663333>,
      < 5.526640, -1.788691, -2.663333>,
      < 5.609175, -1.797373, -2.663332>
    }
    triangle {
      < 5.518551, -1.843796, -2.663333>,
      < 5.609175, -1.797373, -2.663332>,
      < 5.595513, -1.874836, -2.663332>
    }
    triangle {
      < 5.595513, -1.874836, -2.663332>,
      < 5.609175, -1.797373, -2.663332>,
      < 5.616923, -1.798185, -2.744609>
    }
    triangle {
      < 5.595513, -1.874836, -2.663332>,
      < 5.616923, -1.798185, -2.744609>,
      < 5.603073, -1.876719, -2.744609>
    }
    triangle {
      < 5.603073, -1.876719, -2.744609>,
      < 5.616923, -1.798185, -2.744609>,
      < 5.680087, -1.804829, -2.736479>
    }
    triangle {
      < 5.603073, -1.876719, -2.744609>,
      < 5.680087, -1.804829, -2.736479>,
      < 5.664698, -1.892089, -2.736479>
    }
    triangle {
      < 5.664698, -1.892089, -2.736479>,
      < 5.680087, -1.804829, -2.736479>,
      < 5.680171, -1.804841, -2.633340>
    }
    triangle {
      < 5.664698, -1.892089, -2.736479>,
      < 5.680171, -1.804841, -2.633340>,
      < 5.664779, -1.892112, -2.633340>
    }
    triangle {
      < 5.157351, -1.749844, -2.828054>,
      < 5.157881, -1.734577, -2.828054>,
      < 5.164813, -1.734335, -2.842164>
    }
    triangle {
      < 5.157351, -1.749844, -2.828054>,
      < 5.164813, -1.734335, -2.842164>,
      < 5.164248, -1.750569, -2.842164>
    }
    triangle {
      < 5.164248, -1.750569, -2.842164>,
      < 5.164813, -1.734335, -2.842164>,
      < 5.269545, -1.730686, -2.813766>
    }
    triangle {
      < 5.164248, -1.750569, -2.842164>,
      < 5.269545, -1.730686, -2.813766>,
      < 5.268469, -1.761532, -2.813766>
    }
    triangle {
      < 5.268469, -1.761532, -2.813766>,
      < 5.269545, -1.730686, -2.813766>,
      < 5.374278, -1.727039, -2.769109>
    }
    triangle {
      < 5.268469, -1.761532, -2.813766>,
      < 5.374278, -1.727039, -2.769109>,
      < 5.372690, -1.772496, -2.769109>
    }
    triangle {
      < 5.372690, -1.772496, -2.769109>,
      < 5.374278, -1.727039, -2.769109>,
      < 5.386971, -1.726597, -2.756803>
    }
    triangle {
      < 5.372690, -1.772496, -2.769109>,
      < 5.386971, -1.726597, -2.756803>,
      < 5.385322, -1.773825, -2.756803>
    }
    triangle {
      < 5.385322, -1.773825, -2.756803>,
      < 5.386971, -1.726597, -2.756803>,
      < 5.408130, -1.725859, -2.779159>
    }
    triangle {
      < 5.385322, -1.773825, -2.756803>,
      < 5.408130, -1.725859, -2.779159>,
      < 5.406377, -1.776039, -2.779159>
    }
    triangle {
      < 5.406377, -1.776039, -2.779159>,
      < 5.408130, -1.725859, -2.779159>,
      < 5.493875, -1.733505, -2.764932>
    }
    triangle {
      < 5.406377, -1.776039, -2.779159>,
      < 5.493875, -1.733505, -2.764932>,
      < 5.490595, -1.784897, -2.764932>
    }
    triangle {
      < 5.490595, -1.784897, -2.764932>,
      < 5.493875, -1.733505, -2.764932>,
      < 5.530188, -1.733109, -2.663333>
    }
    triangle {
      < 5.490595, -1.784897, -2.764932>,
      < 5.530188, -1.733109, -2.663333>,
      < 5.526640, -1.788691, -2.663333>
    }
    triangle {
      < 5.526640, -1.788691, -2.663333>,
      < 5.530188, -1.733109, -2.663333>,
      < 5.611923, -1.718761, -2.663332>
    }
    triangle {
      < 5.526640, -1.788691, -2.663333>,
      < 5.611923, -1.718761, -2.663332>,
      < 5.609175, -1.797373, -2.663332>
    }
    triangle {
      < 5.609175, -1.797373, -2.663332>,
      < 5.611923, -1.718761, -2.663332>,
      < 5.619709, -1.718488, -2.744609>
    }
    triangle {
      < 5.609175, -1.797373, -2.663332>,
      < 5.619709, -1.718488, -2.744609>,
      < 5.616923, -1.798185, -2.744609>
    }
    triangle {
      < 5.616923, -1.798185, -2.744609>,
      < 5.619709, -1.718488, -2.744609>,
      < 5.683183, -1.716277, -2.736479>
    }
    triangle {
      < 5.616923, -1.798185, -2.744609>,
      < 5.683183, -1.716277, -2.736479>,
      < 5.680087, -1.804829, -2.736479>
    }
    triangle {
      < 5.680087, -1.804829, -2.736479>,
      < 5.683183, -1.716277, -2.736479>,
      < 5.683268, -1.716277, -2.633340>
    }
    triangle {
      < 5.680087, -1.804829, -2.736479>,
      < 5.683268, -1.716277, -2.633340>,
      < 5.680171, -1.804841, -2.633340>
    }
    triangle {
      < 5.157881, -1.734577, -2.828054>,
      < 5.156281, -1.719384, -2.828054>,
      < 5.163112, -1.718179, -2.842164>
    }
    triangle {
      < 5.157881, -1.734577, -2.828054>,
      < 5.163112, -1.718179, -2.842164>,
      < 5.164813, -1.734335, -2.842164>
    }
    triangle {
      < 5.164813, -1.734335, -2.842164>,
      < 5.163112, -1.718179, -2.842164>,
      < 5.266318, -1.699991, -2.813766>
    }
    triangle {
      < 5.164813, -1.734335, -2.842164>,
      < 5.266318, -1.699991, -2.813766>,
      < 5.269545, -1.730686, -2.813766>
    }
    triangle {
      < 5.269545, -1.730686, -2.813766>,
      < 5.266318, -1.699991, -2.813766>,
      < 5.369524, -1.681803, -2.769109>
    }
    triangle {
      < 5.269545, -1.730686, -2.813766>,
      < 5.369524, -1.681803, -2.769109>,
      < 5.374278, -1.727039, -2.769109>
    }
    triangle {
      < 5.374278, -1.727039, -2.769109>,
      < 5.369524, -1.681803, -2.769109>,
      < 5.382032, -1.679599, -2.756803>
    }
    triangle {
      < 5.374278, -1.727039, -2.769109>,
      < 5.382032, -1.679599, -2.756803>,
      < 5.386971, -1.726597, -2.756803>
    }
    triangle {
      < 5.386971, -1.726597, -2.756803>,
      < 5.382032, -1.679599, -2.756803>,
      < 5.402882, -1.675924, -2.779159>
    }
    triangle {
      < 5.386971, -1.726597, -2.756803>,
      < 5.402882, -1.675924, -2.779159>,
      < 5.408130, -1.725859, -2.779159>
    }
    triangle {
      < 5.468410, -1.680946, -2.768997>,
      < 5.402882, -1.675924, -2.779159>,
      < 5.485167, -1.650631, -2.764932>
    }
    triangle {
      < 5.502648, -1.676265, -2.663333>,
      < 5.468410, -1.680946, -2.768997>,
      < 5.485167, -1.650631, -2.764932>
    }
    triangle {
      < 5.502648, -1.676265, -2.663333>,
      < 5.485167, -1.650631, -2.764932>,
      < 5.520771, -1.643479, -2.663333>
    }
    triangle {
      < 5.530188, -1.733109, -2.663333>,
      < 5.520771, -1.643479, -2.663333>,
      < 5.603704, -1.640533, -2.663332>
    }
    triangle {
      < 5.530188, -1.733109, -2.663333>,
      < 5.603704, -1.640533, -2.663332>,
      < 5.611923, -1.718761, -2.663332>
    }
    triangle {
      < 5.611923, -1.718761, -2.663332>,
      < 5.603704, -1.640533, -2.663332>,
      < 5.611377, -1.639179, -2.744609>
    }
    triangle {
      < 5.611923, -1.718761, -2.663332>,
      < 5.611377, -1.639179, -2.744609>,
      < 5.619709, -1.718488, -2.744609>
    }
    triangle {
      < 5.619709, -1.718488, -2.744609>,
      < 5.611377, -1.639179, -2.744609>,
      < 5.673925, -1.628155, -2.736479>
    }
    triangle {
      < 5.619709, -1.718488, -2.744609>,
      < 5.673925, -1.628155, -2.736479>,
      < 5.683183, -1.716277, -2.736479>
    }
    triangle {
      < 5.683183, -1.716277, -2.736479>,
      < 5.673925, -1.628155, -2.736479>,
      < 5.674009, -1.628143, -2.633340>
    }
    triangle {
      < 5.683183, -1.716277, -2.736479>,
      < 5.674009, -1.628143, -2.633340>,
      < 5.683268, -1.716277, -2.633340>
    }
    triangle {
      < 5.156281, -1.719384, -2.828054>,
      < 5.152584, -1.704561, -2.828054>,
      < 5.159180, -1.702418, -2.842164>
    }
    triangle {
      < 5.156281, -1.719384, -2.828054>,
      < 5.159180, -1.702418, -2.842164>,
      < 5.163112, -1.718179, -2.842164>
    }
    triangle {
      < 5.163112, -1.718179, -2.842164>,
      < 5.159180, -1.702418, -2.842164>,
      < 5.258850, -1.670043, -2.813766>
    }
    triangle {
      < 5.163112, -1.718179, -2.842164>,
      < 5.258850, -1.670043, -2.813766>,
      < 5.266318, -1.699991, -2.813766>
    }
    triangle {
      < 5.266318, -1.699991, -2.813766>,
      < 5.258850, -1.670043, -2.813766>,
      < 5.358520, -1.637669, -2.769109>
    }
    triangle {
      < 5.266318, -1.699991, -2.813766>,
      < 5.358520, -1.637669, -2.769109>,
      < 5.369524, -1.681803, -2.769109>
    }
    triangle {
      < 5.369524, -1.681803, -2.769109>,
      < 5.358520, -1.637669, -2.769109>,
      < 5.370600, -1.633745, -2.756803>
    }
    triangle {
      < 5.369524, -1.681803, -2.769109>,
      < 5.370600, -1.633745, -2.756803>,
      < 5.382032, -1.679599, -2.756803>
    }
    triangle {
      < 5.382032, -1.679599, -2.756803>,
      < 5.370600, -1.633745, -2.756803>,
      < 5.390735, -1.627204, -2.779159>
    }
    triangle {
      < 5.382032, -1.679599, -2.756803>,
      < 5.390735, -1.627204, -2.779159>,
      < 5.402882, -1.675924, -2.779159>
    }
    triangle {
      < 5.402882, -1.675924, -2.779159>,
      < 5.390735, -1.627204, -2.779159>,
      < 5.471276, -1.601043, -2.764932>
    }
    triangle {
      < 5.402882, -1.675924, -2.779159>,
      < 5.471276, -1.601043, -2.764932>,
      < 5.485167, -1.650631, -2.764932>
    }
    triangle {
      < 5.485167, -1.650631, -2.764932>,
      < 5.471276, -1.601043, -2.764932>,
      < 5.505748, -1.589848, -2.663333>
    }
    triangle {
      < 5.485167, -1.650631, -2.764932>,
      < 5.505748, -1.589848, -2.663333>,
      < 5.520771, -1.643479, -2.663333>
    }
    triangle {
      < 5.520771, -1.643479, -2.663333>,
      < 5.505748, -1.589848, -2.663333>,
      < 5.584679, -1.564210, -2.663332>
    }
    triangle {
      < 5.520771, -1.643479, -2.663333>,
      < 5.584679, -1.564210, -2.663332>,
      < 5.603704, -1.640533, -2.663332>
    }
    triangle {
      < 5.603704, -1.640533, -2.663332>,
      < 5.584679, -1.564210, -2.663332>,
      < 5.592087, -1.561801, -2.744609>
    }
    triangle {
      < 5.603704, -1.640533, -2.663332>,
      < 5.592087, -1.561801, -2.744609>,
      < 5.611377, -1.639179, -2.744609>
    }
    triangle {
      < 5.611377, -1.639179, -2.744609>,
      < 5.592087, -1.561801, -2.744609>,
      < 5.652493, -1.542180, -2.736479>
    }
    triangle {
      < 5.611377, -1.639179, -2.744609>,
      < 5.652493, -1.542180, -2.736479>,
      < 5.673925, -1.628155, -2.736479>
    }
    triangle {
      < 5.673925, -1.628155, -2.736479>,
      < 5.652493, -1.542180, -2.736479>,
      < 5.652575, -1.542156, -2.633340>
    }
    triangle {
      < 5.673925, -1.628155, -2.736479>,
      < 5.652575, -1.542156, -2.633340>,
      < 5.674009, -1.628143, -2.633340>
    }
    triangle {
      < 5.152584, -1.704561, -2.828054>,
      < 5.146858, -1.690398, -2.828054>,
      < 5.153092, -1.687357, -2.842164>
    }
    triangle {
      < 5.152584, -1.704561, -2.828054>,
      < 5.153092, -1.687357, -2.842164>,
      < 5.159180, -1.702418, -2.842164>
    }
    triangle {
      < 5.159180, -1.702418, -2.842164>,
      < 5.153092, -1.687357, -2.842164>,
      < 5.247287, -1.641426, -2.813766>
    }
    triangle {
      < 5.159180, -1.702418, -2.842164>,
      < 5.247287, -1.641426, -2.813766>,
      < 5.258850, -1.670043, -2.813766>
    }
    triangle {
      < 5.258850, -1.670043, -2.813766>,
      < 5.247287, -1.641426, -2.813766>,
      < 5.341481, -1.595496, -2.769109>
    }
    triangle {
      < 5.258850, -1.670043, -2.813766>,
      < 5.341481, -1.595496, -2.769109>,
      < 5.358520, -1.637669, -2.769109>
    }
    triangle {
      < 5.358520, -1.637669, -2.769109>,
      < 5.341481, -1.595496, -2.769109>,
      < 5.352898, -1.589929, -2.756803>
    }
    triangle {
      < 5.358520, -1.637669, -2.769109>,
      < 5.352898, -1.589929, -2.756803>,
      < 5.370600, -1.633745, -2.756803>
    }
    triangle {
      < 5.370600, -1.633745, -2.756803>,
      < 5.352898, -1.589929, -2.756803>,
      < 5.371927, -1.580650, -2.779159>
    }
    triangle {
      < 5.370600, -1.633745, -2.756803>,
      < 5.371927, -1.580650, -2.779159>,
      < 5.390735, -1.627204, -2.779159>
    }
    triangle {
      < 5.390735, -1.627204, -2.779159>,
      < 5.371927, -1.580650, -2.779159>,
      < 5.453369, -1.552760, -2.764932>
    }
    triangle {
      < 5.390735, -1.627204, -2.779159>,
      < 5.453369, -1.552760, -2.764932>,
      < 5.471276, -1.601043, -2.764932>
    }
    triangle {
      < 5.471276, -1.601043, -2.764932>,
      < 5.453369, -1.552760, -2.764932>,
      < 5.486382, -1.537629, -2.663333>
    }
    triangle {
      < 5.471276, -1.601043, -2.764932>,
      < 5.486382, -1.537629, -2.663333>,
      < 5.505748, -1.589848, -2.663333>
    }
    triangle {
      < 5.505748, -1.589848, -2.663333>,
      < 5.486382, -1.537629, -2.663333>,
      < 5.555216, -1.491277, -2.663332>
    }
    triangle {
      < 5.505748, -1.589848, -2.663333>,
      < 5.555216, -1.491277, -2.663332>,
      < 5.584679, -1.564210, -2.663332>
    }
    triangle {
      < 5.584679, -1.564210, -2.663332>,
      < 5.555216, -1.491277, -2.663332>,
      < 5.562217, -1.487860, -2.744609>
    }
    triangle {
      < 5.584679, -1.564210, -2.663332>,
      < 5.562217, -1.487860, -2.744609>,
      < 5.592087, -1.561801, -2.744609>
    }
    triangle {
      < 5.592087, -1.561801, -2.744609>,
      < 5.562217, -1.487860, -2.744609>,
      < 5.619304, -1.460024, -2.736479>
    }
    triangle {
      < 5.592087, -1.561801, -2.744609>,
      < 5.619304, -1.460024, -2.736479>,
      < 5.652493, -1.542180, -2.736479>
    }
    triangle {
      < 5.652493, -1.542180, -2.736479>,
      < 5.619304, -1.460024, -2.736479>,
      < 5.619381, -1.459989, -2.633340>
    }
    triangle {
      < 5.652493, -1.542180, -2.736479>,
      < 5.619381, -1.459989, -2.633340>,
      < 5.652575, -1.542156, -2.633340>
    }
    triangle {
      < 5.146858, -1.690398, -2.828054>,
      < 5.139218, -1.677168, -2.828054>,
      < 5.144968, -1.673290, -2.842164>
    }
    triangle {
      < 5.146858, -1.690398, -2.828054>,
      < 5.144968, -1.673290, -2.842164>,
      < 5.153092, -1.687357, -2.842164>
    }
    triangle {
      < 5.153092, -1.687357, -2.842164>,
      < 5.144968, -1.673290, -2.842164>,
      < 5.231853, -1.614697, -2.813766>
    }
    triangle {
      < 5.153092, -1.687357, -2.842164>,
      < 5.231853, -1.614697, -2.813766>,
      < 5.247287, -1.641426, -2.813766>
    }
    triangle {
      < 5.247287, -1.641426, -2.813766>,
      < 5.231853, -1.614697, -2.813766>,
      < 5.318739, -1.556105, -2.769109>
    }
    triangle {
      < 5.247287, -1.641426, -2.813766>,
      < 5.318739, -1.556105, -2.769109>,
      < 5.341481, -1.595496, -2.769109>
    }
    triangle {
      < 5.341481, -1.595496, -2.769109>,
      < 5.318739, -1.556105, -2.769109>,
      < 5.329270, -1.549003, -2.756803>
    }
    triangle {
      < 5.341481, -1.595496, -2.769109>,
      < 5.329270, -1.549003, -2.756803>,
      < 5.352898, -1.589929, -2.756803>
    }
    triangle {
      < 5.352898, -1.589929, -2.756803>,
      < 5.329270, -1.549003, -2.756803>,
      < 5.346822, -1.537166, -2.779159>
    }
    triangle {
      < 5.352898, -1.589929, -2.756803>,
      < 5.346822, -1.537166, -2.779159>,
      < 5.371927, -1.580650, -2.779159>
    }
    triangle {
      < 5.408729, -1.515102, -2.768997>,
      < 5.346822, -1.537166, -2.779159>,
      < 5.411706, -1.480592, -2.764932>
    }
    triangle {
      < 5.438103, -1.496900, -2.663333>,
      < 5.408729, -1.515102, -2.768997>,
      < 5.411706, -1.480592, -2.764932>
    }
    triangle {
      < 5.438103, -1.496900, -2.663333>,
      < 5.411706, -1.480592, -2.764932>,
      < 5.441323, -1.459577, -2.663333>
    }
    triangle {
      < 5.486382, -1.537629, -2.663333>,
      < 5.441323, -1.459577, -2.663333>,
      < 5.515889, -1.423154, -2.663332>
    }
    triangle {
      < 5.486382, -1.537629, -2.663333>,
      < 5.515889, -1.423154, -2.663332>,
      < 5.555216, -1.491277, -2.663332>
    }
    triangle {
      < 5.555216, -1.491277, -2.663332>,
      < 5.515889, -1.423154, -2.663332>,
      < 5.522347, -1.418797, -2.744609>
    }
    triangle {
      < 5.555216, -1.491277, -2.663332>,
      < 5.522347, -1.418797, -2.744609>,
      < 5.562217, -1.487860, -2.744609>
    }
    triangle {
      < 5.562217, -1.487860, -2.744609>,
      < 5.522347, -1.418797, -2.744609>,
      < 5.575005, -1.383286, -2.736479>
    }
    triangle {
      < 5.562217, -1.487860, -2.744609>,
      < 5.575005, -1.383286, -2.736479>,
      < 5.619304, -1.460024, -2.736479>
    }
    triangle {
      < 5.619304, -1.460024, -2.736479>,
      < 5.575005, -1.383286, -2.736479>,
      < 5.575077, -1.383241, -2.633340>
    }
    triangle {
      < 5.619304, -1.460024, -2.736479>,
      < 5.575077, -1.383241, -2.633340>,
      < 5.619381, -1.459989, -2.633340>
    }
    triangle {
      < 5.139218, -1.677168, -2.828054>,
      < 5.129811, -1.665132, -2.828054>,
      < 5.134965, -1.660491, -2.842164>
    }
    triangle {
      < 5.139218, -1.677168, -2.828054>,
      < 5.134965, -1.660491, -2.842164>,
      < 5.144968, -1.673290, -2.842164>
    }
    triangle {
      < 5.144968, -1.673290, -2.842164>,
      < 5.134965, -1.660491, -2.842164>,
      < 5.212851, -1.590376, -2.813766>
    }
    triangle {
      < 5.144968, -1.673290, -2.842164>,
      < 5.212851, -1.590376, -2.813766>,
      < 5.231853, -1.614697, -2.813766>
    }
    triangle {
      < 5.231853, -1.614697, -2.813766>,
      < 5.212851, -1.590376, -2.813766>,
      < 5.290737, -1.520262, -2.769109>
    }
    triangle {
      < 5.231853, -1.614697, -2.813766>,
      < 5.290737, -1.520262, -2.769109>,
      < 5.318739, -1.556105, -2.769109>
    }
    triangle {
      < 5.318739, -1.556105, -2.769109>,
      < 5.290737, -1.520262, -2.769109>,
      < 5.300177, -1.511764, -2.756803>
    }
    triangle {
      < 5.318739, -1.556105, -2.769109>,
      < 5.300177, -1.511764, -2.756803>,
      < 5.329270, -1.549003, -2.756803>
    }
    triangle {
      < 5.329270, -1.549003, -2.756803>,
      < 5.300177, -1.511764, -2.756803>,
      < 5.315910, -1.497599, -2.779159>
    }
    triangle {
      < 5.329270, -1.549003, -2.756803>,
      < 5.315910, -1.497599, -2.779159>,
      < 5.346822, -1.537166, -2.779159>
    }
    triangle {
      < 5.346822, -1.537166, -2.779159>,
      < 5.315910, -1.497599, -2.779159>,
      < 5.378848, -1.440941, -2.764932>
    }
    triangle {
      < 5.346822, -1.537166, -2.779159>,
      < 5.378848, -1.440941, -2.764932>,
      < 5.411706, -1.480592, -2.764932>
    }
    triangle {
      < 5.411706, -1.480592, -2.764932>,
      < 5.378848, -1.440941, -2.764932>,
      < 5.405787, -1.416693, -2.663333>
    }
    triangle {
      < 5.411706, -1.480592, -2.764932>,
      < 5.405787, -1.416693, -2.663333>,
      < 5.441323, -1.459577, -2.663333>
    }
    triangle {
      < 5.441323, -1.459577, -2.663333>,
      < 5.405787, -1.416693, -2.663333>,
      < 5.467465, -1.361168, -2.663332>
    }
    triangle {
      < 5.441323, -1.459577, -2.663333>,
      < 5.467465, -1.361168, -2.663332>,
      < 5.515889, -1.423154, -2.663332>
    }
    triangle {
      < 5.515889, -1.423154, -2.663332>,
      < 5.467465, -1.361168, -2.663332>,
      < 5.473254, -1.355954, -2.744609>
    }
    triangle {
      < 5.515889, -1.423154, -2.663332>,
      < 5.473254, -1.355954, -2.744609>,
      < 5.522347, -1.418797, -2.744609>
    }
    triangle {
      < 5.522347, -1.418797, -2.744609>,
      < 5.473254, -1.355954, -2.744609>,
      < 5.520457, -1.313460, -2.736479>
    }
    triangle {
      < 5.522347, -1.418797, -2.744609>,
      < 5.520457, -1.313460, -2.736479>,
      < 5.575005, -1.383286, -2.736479>
    }
    triangle {
      < 5.575005, -1.383286, -2.736479>,
      < 5.520457, -1.313460, -2.736479>,
      < 5.520522, -1.313405, -2.633340>
    }
    triangle {
      < 5.575005, -1.383286, -2.736479>,
      < 5.520522, -1.313405, -2.633340>,
      < 5.575077, -1.383241, -2.633340>
    }
    triangle {
      < 5.129811, -1.665132, -2.828054>,
      < 5.118820, -1.654521, -2.828054>,
      < 5.123278, -1.649208, -2.842164>
    }
    triangle {
      < 5.129811, -1.665132, -2.828054>,
      < 5.123278, -1.649208, -2.842164>,
      < 5.134965, -1.660491, -2.842164>
    }
    triangle {
      < 5.134965, -1.660491, -2.842164>,
      < 5.123278, -1.649208, -2.842164>,
      < 5.190648, -1.568936, -2.813766>
    }
    triangle {
      < 5.134965, -1.660491, -2.842164>,
      < 5.190648, -1.568936, -2.813766>,
      < 5.212851, -1.590376, -2.813766>
    }
    triangle {
      < 5.212851, -1.590376, -2.813766>,
      < 5.190648, -1.568936, -2.813766>,
      < 5.258018, -1.488665, -2.769109>
    }
    triangle {
      < 5.212851, -1.590376, -2.813766>,
      < 5.258018, -1.488665, -2.769109>,
      < 5.290737, -1.520262, -2.769109>
    }
    triangle {
      < 5.290737, -1.520262, -2.769109>,
      < 5.258018, -1.488665, -2.769109>,
      < 5.266183, -1.478936, -2.756803>
    }
    triangle {
      < 5.290737, -1.520262, -2.769109>,
      < 5.266183, -1.478936, -2.756803>,
      < 5.300177, -1.511764, -2.756803>
    }
    triangle {
      < 5.300177, -1.511764, -2.756803>,
      < 5.266183, -1.478936, -2.756803>,
      < 5.279793, -1.462719, -2.779159>
    }
    triangle {
      < 5.300177, -1.511764, -2.756803>,
      < 5.279793, -1.462719, -2.779159>,
      < 5.315910, -1.497599, -2.779159>
    }
    triangle {
      < 5.315910, -1.497599, -2.779159>,
      < 5.279793, -1.462719, -2.779159>,
      < 5.342851, -1.404115, -2.764932>
    }
    triangle {
      < 5.315910, -1.497599, -2.779159>,
      < 5.342851, -1.404115, -2.764932>,
      < 5.378848, -1.440941, -2.764932>
    }
    triangle {
      < 5.378848, -1.440941, -2.764932>,
      < 5.342851, -1.404115, -2.764932>,
      < 5.366855, -1.376865, -2.663333>
    }
    triangle {
      < 5.378848, -1.440941, -2.764932>,
      < 5.366855, -1.376865, -2.663333>,
      < 5.405787, -1.416693, -2.663333>
    }
    triangle {
      < 5.405787, -1.416693, -2.663333>,
      < 5.366855, -1.376865, -2.663333>,
      < 5.410885, -1.306524, -2.663332>
    }
    triangle {
      < 5.405787, -1.416693, -2.663333>,
      < 5.410885, -1.306524, -2.663332>,
      < 5.467465, -1.361168, -2.663332>
    }
    triangle {
      < 5.467465, -1.361168, -2.663332>,
      < 5.410885, -1.306524, -2.663332>,
      < 5.415892, -1.300555, -2.744609>
    }
    triangle {
      < 5.467465, -1.361168, -2.663332>,
      < 5.415892, -1.300555, -2.744609>,
      < 5.473254, -1.355954, -2.744609>
    }
    triangle {
      < 5.473254, -1.355954, -2.744609>,
      < 5.415892, -1.300555, -2.744609>,
      < 5.456722, -1.251905, -2.736479>
    }
    triangle {
      < 5.473254, -1.355954, -2.744609>,
      < 5.456722, -1.251905, -2.736479>,
      < 5.520457, -1.313460, -2.736479>
    }
    triangle {
      < 5.520457, -1.313460, -2.736479>,
      < 5.456722, -1.251905, -2.736479>,
      < 5.456779, -1.251842, -2.633340>
    }
    triangle {
      < 5.520457, -1.313460, -2.736479>,
      < 5.456779, -1.251842, -2.633340>,
      < 5.520522, -1.313405, -2.633340>
    }
    triangle {
      < 5.118820, -1.654521, -2.828054>,
      < 5.106459, -1.645543, -2.828054>,
      < 5.110135, -1.639661, -2.842164>
    }
    triangle {
      < 5.118820, -1.654521, -2.828054>,
      < 5.110135, -1.639661, -2.842164>,
      < 5.123278, -1.649208, -2.842164>
    }
    triangle {
      < 5.123278, -1.649208, -2.842164>,
      < 5.110135, -1.639661, -2.842164>,
      < 5.165678, -1.550795, -2.813766>
    }
    triangle {
      < 5.123278, -1.649208, -2.842164>,
      < 5.165678, -1.550795, -2.813766>,
      < 5.190648, -1.568936, -2.813766>
    }
    triangle {
      < 5.190648, -1.568936, -2.813766>,
      < 5.165678, -1.550795, -2.813766>,
      < 5.221220, -1.461929, -2.769109>
    }
    triangle {
      < 5.190648, -1.568936, -2.813766>,
      < 5.221220, -1.461929, -2.769109>,
      < 5.258018, -1.488665, -2.769109>
    }
    triangle {
      < 5.258018, -1.488665, -2.769109>,
      < 5.221220, -1.461929, -2.769109>,
      < 5.227952, -1.451158, -2.756803>
    }
    triangle {
      < 5.258018, -1.488665, -2.769109>,
      < 5.227952, -1.451158, -2.756803>,
      < 5.266183, -1.478936, -2.756803>
    }
    triangle {
      < 5.266183, -1.478936, -2.756803>,
      < 5.227952, -1.451158, -2.756803>,
      < 5.239172, -1.433205, -2.779159>
    }
    triangle {
      < 5.266183, -1.478936, -2.756803>,
      < 5.239172, -1.433205, -2.779159>,
      < 5.279793, -1.462719, -2.779159>
    }
    triangle {
      < 5.286753, -1.387869, -2.768997>,
      < 5.239172, -1.433205, -2.779159>,
      < 5.275437, -1.355132, -2.764932>
    }
    triangle {
      < 5.306184, -1.359294, -2.663333>,
      < 5.286753, -1.387869, -2.768997>,
      < 5.275437, -1.355132, -2.764932>
    }
    triangle {
      < 5.306184, -1.359294, -2.663333>,
      < 5.275437, -1.355132, -2.764932>,
      < 5.293946, -1.323888, -2.663333>
    }
    triangle {
      < 5.366855, -1.376865, -2.663333>,
      < 5.293946, -1.323888, -2.663333>,
      < 5.347251, -1.260285, -2.663332>
    }
    triangle {
      < 5.366855, -1.376865, -2.663333>,
      < 5.347251, -1.260285, -2.663332>,
      < 5.410885, -1.306524, -2.663332>
    }
    triangle {
      < 5.410885, -1.306524, -2.663332>,
      < 5.347251, -1.260285, -2.663332>,
      < 5.351379, -1.253678, -2.744609>
    }
    triangle {
      < 5.410885, -1.306524, -2.663332>,
      < 5.351379, -1.253678, -2.744609>,
      < 5.415892, -1.300555, -2.744609>
    }
    triangle {
      < 5.415892, -1.300555, -2.744609>,
      < 5.351379, -1.253678, -2.744609>,
      < 5.385041, -1.199819, -2.736479>
    }
    triangle {
      < 5.415892, -1.300555, -2.744609>,
      < 5.385041, -1.199819, -2.736479>,
      < 5.456722, -1.251905, -2.736479>
    }
    triangle {
      < 5.456722, -1.251905, -2.736479>,
      < 5.385041, -1.199819, -2.736479>,
      < 5.385088, -1.199749, -2.633340>
    }
    triangle {
      < 5.456722, -1.251905, -2.736479>,
      < 5.385088, -1.199749, -2.633340>,
      < 5.456779, -1.251842, -2.633340>
    }
    triangle {
      < 5.106459, -1.645543, -2.828054>,
      < 5.092969, -1.638373, -2.828054>,
      < 5.095791, -1.632037, -2.842164>
    }
    triangle {
      < 5.106459, -1.645543, -2.828054>,
      < 5.095791, -1.632037, -2.842164>,
      < 5.110135, -1.639661, -2.842164>
    }
    triangle {
      < 5.110135, -1.639661, -2.842164>,
      < 5.095791, -1.632037, -2.842164>,
      < 5.138425, -1.536305, -2.813766>
    }
    triangle {
      < 5.110135, -1.639661, -2.842164>,
      < 5.138425, -1.536305, -2.813766>,
      < 5.165678, -1.550795, -2.813766>
    }
    triangle {
      < 5.165678, -1.550795, -2.813766>,
      < 5.138425, -1.536305, -2.813766>,
      < 5.181060, -1.440574, -2.769109>
    }
    triangle {
      < 5.165678, -1.550795, -2.813766>,
      < 5.181060, -1.440574, -2.769109>,
      < 5.221220, -1.461929, -2.769109>
    }
    triangle {
      < 5.221220, -1.461929, -2.769109>,
      < 5.181060, -1.440574, -2.769109>,
      < 5.186228, -1.428972, -2.756803>
    }
    triangle {
      < 5.221220, -1.461929, -2.769109>,
      < 5.186228, -1.428972, -2.756803>,
      < 5.227952, -1.451158, -2.756803>
    }
    triangle {
      < 5.227952, -1.451158, -2.756803>,
      < 5.186228, -1.428972, -2.756803>,
      < 5.194840, -1.409632, -2.779159>
    }
    triangle {
      < 5.227952, -1.451158, -2.756803>,
      < 5.194840, -1.409632, -2.779159>,
      < 5.239172, -1.433205, -2.779159>
    }
    triangle {
      < 5.239172, -1.433205, -2.779159>,
      < 5.194840, -1.409632, -2.779159>,
      < 5.229292, -1.332273, -2.764932>
    }
    triangle {
      < 5.239172, -1.433205, -2.779159>,
      < 5.229292, -1.332273, -2.764932>,
      < 5.275437, -1.355132, -2.764932>
    }
    triangle {
      < 5.275437, -1.355132, -2.764932>,
      < 5.229292, -1.332273, -2.764932>,
      < 5.244040, -1.299165, -2.663333>
    }
    triangle {
      < 5.275437, -1.355132, -2.764932>,
      < 5.244040, -1.299165, -2.663333>,
      < 5.293946, -1.323888, -2.663333>
    }
    triangle {
      < 5.293946, -1.323888, -2.663333>,
      < 5.244040, -1.299165, -2.663333>,
      < 5.277802, -1.223353, -2.663332>
    }
    triangle {
      < 5.293946, -1.323888, -2.663333>,
      < 5.277802, -1.223353, -2.663332>,
      < 5.347251, -1.260285, -2.663332>
    }
    triangle {
      < 5.347251, -1.260285, -2.663332>,
      < 5.277802, -1.223353, -2.663332>,
      < 5.280969, -1.216235, -2.744609>
    }
    triangle {
      < 5.347251, -1.260285, -2.663332>,
      < 5.280969, -1.216235, -2.744609>,
      < 5.351379, -1.253678, -2.744609>
    }
    triangle {
      < 5.351379, -1.253678, -2.744609>,
      < 5.280969, -1.216235, -2.744609>,
      < 5.306808, -1.158216, -2.736479>
    }
    triangle {
      < 5.351379, -1.253678, -2.744609>,
      < 5.306808, -1.158216, -2.736479>,
      < 5.385041, -1.199819, -2.736479>
    }
    triangle {
      < 5.385041, -1.199819, -2.736479>,
      < 5.306808, -1.158216, -2.736479>,
      < 5.306845, -1.158140, -2.633340>
    }
    triangle {
      < 5.385041, -1.199819, -2.736479>,
      < 5.306845, -1.158140, -2.633340>,
      < 5.385088, -1.199749, -2.633340>
    }
    triangle {
      < 5.092969, -1.638373, -2.828054>,
      < 5.078613, -1.633150, -2.828054>,
      < 5.080525, -1.626483, -2.842164>
    }
    triangle {
      < 5.092969, -1.638373, -2.828054>,
      < 5.080525, -1.626483, -2.842164>,
      < 5.095791, -1.632037, -2.842164>
    }
    triangle {
      < 5.095791, -1.632037, -2.842164>,
      < 5.080525, -1.626483, -2.842164>,
      < 5.109422, -1.525750, -2.813766>
    }
    triangle {
      < 5.095791, -1.632037, -2.842164>,
      < 5.109422, -1.525750, -2.813766>,
      < 5.138425, -1.536305, -2.813766>
    }
    triangle {
      < 5.138425, -1.536305, -2.813766>,
      < 5.109422, -1.525750, -2.813766>,
      < 5.138319, -1.425017, -2.769109>
    }
    triangle {
      < 5.138425, -1.536305, -2.813766>,
      < 5.138319, -1.425017, -2.769109>,
      < 5.181060, -1.440574, -2.769109>
    }
    triangle {
      < 5.181060, -1.440574, -2.769109>,
      < 5.138319, -1.425017, -2.769109>,
      < 5.141821, -1.412808, -2.756803>
    }
    triangle {
      < 5.181060, -1.440574, -2.769109>,
      < 5.141821, -1.412808, -2.756803>,
      < 5.186228, -1.428972, -2.756803>
    }
    triangle {
      < 5.186228, -1.428972, -2.756803>,
      < 5.141821, -1.412808, -2.756803>,
      < 5.147658, -1.392457, -2.779159>
    }
    triangle {
      < 5.186228, -1.428972, -2.756803>,
      < 5.147658, -1.392457, -2.779159>,
      < 5.194840, -1.409632, -2.779159>
    }
    triangle {
      < 5.194840, -1.409632, -2.779159>,
      < 5.147658, -1.392457, -2.779159>,
      < 5.181429, -1.313272, -2.764932>
    }
    triangle {
      < 5.194840, -1.409632, -2.779159>,
      < 5.181429, -1.313272, -2.764932>,
      < 5.229292, -1.332273, -2.764932>
    }
    triangle {
      < 5.229292, -1.332273, -2.764932>,
      < 5.181429, -1.313272, -2.764932>,
      < 5.192275, -1.278614, -2.663333>
    }
    triangle {
      < 5.229292, -1.332273, -2.764932>,
      < 5.192275, -1.278614, -2.663333>,
      < 5.244040, -1.299165, -2.663333>
    }
    triangle {
      < 5.244040, -1.299165, -2.663333>,
      < 5.192275, -1.278614, -2.663333>,
      < 5.203888, -1.196446, -2.663332>
    }
    triangle {
      < 5.244040, -1.299165, -2.663333>,
      < 5.203888, -1.196446, -2.663332>,
      < 5.277802, -1.223353, -2.663332>
    }
    triangle {
      < 5.277802, -1.223353, -2.663332>,
      < 5.203888, -1.196446, -2.663332>,
      < 5.206034, -1.188956, -2.744609>
    }
    triangle {
      < 5.277802, -1.223353, -2.663332>,
      < 5.206034, -1.188956, -2.744609>,
      < 5.280969, -1.216235, -2.744609>
    }
    triangle {
      < 5.280969, -1.216235, -2.744609>,
      < 5.206034, -1.188956, -2.744609>,
      < 5.223547, -1.127906, -2.736479>
    }
    triangle {
      < 5.280969, -1.216235, -2.744609>,
      < 5.223547, -1.127906, -2.736479>,
      < 5.306808, -1.158216, -2.736479>
    }
    triangle {
      < 5.306808, -1.158216, -2.736479>,
      < 5.223547, -1.127906, -2.736479>,
      < 5.223573, -1.127825, -2.633340>
    }
    triangle {
      < 5.306808, -1.158216, -2.736479>,
      < 5.223573, -1.127825, -2.633340>,
      < 5.306845, -1.158140, -2.633340>
    }
    triangle {
      < 5.078613, -1.633150, -2.828054>,
      < 5.063670, -1.629976, -2.828054>,
      < 5.064635, -1.623108, -2.842164>
    }
    triangle {
      < 5.078613, -1.633150, -2.828054>,
      < 5.064635, -1.623108, -2.842164>,
      < 5.080525, -1.626483, -2.842164>
    }
    triangle {
      < 5.080525, -1.626483, -2.842164>,
      < 5.064635, -1.623108, -2.842164>,
      < 5.079231, -1.519333, -2.813766>
    }
    triangle {
      < 5.080525, -1.626483, -2.842164>,
      < 5.079231, -1.519333, -2.813766>,
      < 5.109422, -1.525750, -2.813766>
    }
    triangle {
      < 5.109422, -1.525750, -2.813766>,
      < 5.079231, -1.519333, -2.813766>,
      < 5.093828, -1.415559, -2.769109>
    }
    triangle {
      < 5.109422, -1.525750, -2.813766>,
      < 5.093828, -1.415559, -2.769109>,
      < 5.138319, -1.425017, -2.769109>
    }
    triangle {
      < 5.138319, -1.425017, -2.769109>,
      < 5.093828, -1.415559, -2.769109>,
      < 5.095597, -1.402981, -2.756803>
    }
    triangle {
      < 5.138319, -1.425017, -2.769109>,
      < 5.095597, -1.402981, -2.756803>,
      < 5.141821, -1.412808, -2.756803>
    }
    triangle {
      < 5.141821, -1.412808, -2.756803>,
      < 5.095597, -1.402981, -2.756803>,
      < 5.098545, -1.382016, -2.779159>
    }
    triangle {
      < 5.141821, -1.412808, -2.756803>,
      < 5.098545, -1.382016, -2.779159>,
      < 5.147658, -1.392457, -2.779159>
    }
    triangle {
      < 5.123573, -1.321247, -2.768997>,
      < 5.098545, -1.382016, -2.779159>,
      < 5.099920, -1.295943, -2.764932>
    }
    triangle {
      < 5.129702, -1.287239, -2.663333>,
      < 5.123573, -1.321247, -2.768997>,
      < 5.099920, -1.295943, -2.764932>
    }
    triangle {
      < 5.129702, -1.287239, -2.663333>,
      < 5.099920, -1.295943, -2.764932>,
      < 5.104121, -1.259872, -2.663333>
    }
    triangle {
      < 5.192275, -1.278614, -2.663333>,
      < 5.104121, -1.259872, -2.663333>,
      < 5.126949, -1.180087, -2.663332>
    }
    triangle {
      < 5.192275, -1.278614, -2.663333>,
      < 5.126949, -1.180087, -2.663332>,
      < 5.203888, -1.196446, -2.663332>
    }
    triangle {
      < 5.203888, -1.196446, -2.663332>,
      < 5.126949, -1.180087, -2.663332>,
      < 5.128032, -1.172372, -2.744609>
    }
    triangle {
      < 5.203888, -1.196446, -2.663332>,
      < 5.128032, -1.172372, -2.744609>,
      < 5.206034, -1.188956, -2.744609>
    }
    triangle {
      < 5.206034, -1.188956, -2.744609>,
      < 5.128032, -1.172372, -2.744609>,
      < 5.136878, -1.109478, -2.736479>
    }
    triangle {
      < 5.206034, -1.188956, -2.744609>,
      < 5.136878, -1.109478, -2.736479>,
      < 5.223547, -1.127906, -2.736479>
    }
    triangle {
      < 5.223547, -1.127906, -2.736479>,
      < 5.136878, -1.109478, -2.736479>,
      < 5.136892, -1.109395, -2.633340>
    }
    triangle {
      < 5.223547, -1.127906, -2.736479>,
      < 5.136892, -1.109395, -2.633340>,
      < 5.223573, -1.127825, -2.633340>
    }
    triangle {
      < 5.063670, -1.629976, -2.828054>,
      < 5.048418, -1.628912, -2.828054>,
      < 5.064635, -1.623108, -2.842164>
    }
    triangle {
      < 5.064635, -1.623108, -2.842164>,
      < 5.062479, -1.518167, -2.813766>,
      < 5.079231, -1.519333, -2.813766>
    }
    triangle {
      < 5.062479, -1.518167, -2.813766>,
      < 5.055798, -1.413064, -2.769109>,
      < 5.093828, -1.415559, -2.769109>
    }
    triangle {
      < 5.062479, -1.518167, -2.813766>,
      < 5.093828, -1.415559, -2.769109>,
      < 5.079231, -1.519333, -2.813766>
    }
    triangle {
      < 5.055798, -1.413064, -2.769109>,
      < 5.048420, -1.399683, -2.756803>,
      < 5.095597, -1.402981, -2.756803>
    }
    triangle {
      < 5.055798, -1.413064, -2.769109>,
      < 5.095597, -1.402981, -2.756803>,
      < 5.093828, -1.415559, -2.769109>
    }
    triangle {
      < 5.095597, -1.402981, -2.756803>,
      < 5.048420, -1.399683, -2.756803>,
      < 5.048419, -1.378512, -2.779159>
    }
    triangle {
      < 5.095597, -1.402981, -2.756803>,
      < 5.048419, -1.378512, -2.779159>,
      < 5.098545, -1.382016, -2.779159>
    }
    triangle {
      < 5.098545, -1.382016, -2.779159>,
      < 5.048419, -1.378512, -2.779159>,
      < 5.048420, -1.293829, -2.764932>
    }
    triangle {
      < 5.098545, -1.382016, -2.779159>,
      < 5.048420, -1.293829, -2.764932>,
      < 5.099920, -1.295943, -2.764932>
    }
    triangle {
      < 5.099920, -1.295943, -2.764932>,
      < 5.048420, -1.293829, -2.764932>,
      < 5.048422, -1.257585, -2.663333>
    }
    triangle {
      < 5.099920, -1.295943, -2.764932>,
      < 5.048422, -1.257585, -2.663333>,
      < 5.104121, -1.259872, -2.663333>
    }
    triangle {
      < 5.104121, -1.259872, -2.663333>,
      < 5.048422, -1.257585, -2.663333>,
      < 5.048422, -1.174595, -2.663332>
    }
    triangle {
      < 5.104121, -1.259872, -2.663333>,
      < 5.048422, -1.174595, -2.663332>,
      < 5.126949, -1.180087, -2.663332>
    }
    triangle {
      < 5.126949, -1.180087, -2.663332>,
      < 5.048422, -1.174595, -2.663332>,
      < 5.048420, -1.166804, -2.744609>
    }
    triangle {
      < 5.126949, -1.180087, -2.663332>,
      < 5.048420, -1.166804, -2.744609>,
      < 5.128032, -1.172372, -2.744609>
    }
    triangle {
      < 5.128032, -1.172372, -2.744609>,
      < 5.048420, -1.166804, -2.744609>,
      < 5.048420, -1.103292, -2.736479>
    }
    triangle {
      < 5.128032, -1.172372, -2.744609>,
      < 5.048420, -1.103292, -2.736479>,
      < 5.136878, -1.109478, -2.736479>
    }
    triangle {
      < 5.136878, -1.109478, -2.736479>,
      < 5.048420, -1.103292, -2.736479>,
      < 5.048423, -1.103207, -2.633340>
    }
    triangle {
      < 5.136878, -1.109478, -2.736479>,
      < 5.048423, -1.103207, -2.633340>,
      < 5.136892, -1.109395, -2.633340>
    }
    triangle {
      < 5.062479, -1.518167, -2.813766>,
      < 5.048419, -1.514298, -2.792428>,
      < 5.048420, -1.399683, -2.756803>
    }
    triangle {
      < 5.062479, -1.518167, -2.813766>,
      < 5.048420, -1.399683, -2.756803>,
      < 5.055798, -1.413064, -2.769109>
    }
    triangle {
      < 5.242542, -1.850467, -2.792428>,
      < 5.246215, -1.836364, -2.813766>,
      < 5.333894, -1.894709, -2.769109>
    }
    triangle {
      < 5.242542, -1.850467, -2.792428>,
      < 5.333894, -1.894709, -2.769109>,
      < 5.341797, -1.907782, -2.756803>
    }
    triangle {
      < 5.232167, -1.860699, -2.813766>,
      < 5.242542, -1.850467, -2.792428>,
      < 5.341797, -1.907782, -2.756803>
    }
    triangle {
      < 5.232167, -1.860699, -2.813766>,
      < 5.341797, -1.907782, -2.756803>,
      < 5.326525, -1.907472, -2.769109>
    }
    triangle {
      < 4.850687, -1.836390, -2.813766>,
      < 4.854362, -1.850491, -2.792428>,
      < 4.755100, -1.907794, -2.756803>
    }
    triangle {
      < 4.850687, -1.836390, -2.813766>,
      < 4.755100, -1.907794, -2.756803>,
      < 4.763003, -1.894722, -2.769109>
    }
    triangle {
      < 5.048420, -1.399683, -2.756803>,
      < 5.041050, -1.413064, -2.769109>,
      < 5.003046, -1.415561, -2.769109>
    }
    triangle {
      < 5.048420, -1.399683, -2.756803>,
      < 5.003046, -1.415561, -2.769109>,
      < 5.001278, -1.402983, -2.756803>
    }
    triangle {
      < 4.854362, -1.850491, -2.792428>,
      < 4.864738, -1.860723, -2.813766>,
      < 4.770373, -1.907486, -2.769109>
    }
    triangle {
      < 4.854362, -1.850491, -2.792428>,
      < 4.770373, -1.907486, -2.769109>,
      < 4.755100, -1.907794, -2.756803>
    }
    triangle {
      < 5.048419, -1.514298, -2.792428>,
      < 5.062479, -1.518167, -2.813766>,
      < 5.064635, -1.623108, -2.842164>
    }
    triangle {
      < 5.048419, -1.514298, -2.792428>,
      < 5.064635, -1.623108, -2.842164>,
      < 5.048418, -1.628912, -2.828054>
    }
    triangle {
      < 5.034369, -1.518169, -2.813766>,
      < 5.048419, -1.514298, -2.792428>,
      < 5.048418, -1.628912, -2.828054>
    }
    triangle {
      < 5.034369, -1.518169, -2.813766>,
      < 5.048418, -1.628912, -2.828054>,
      < 5.032213, -1.623114, -2.842164>
    }
    triangle {
      < 4.854362, -1.850491, -2.792428>,
      < 4.850687, -1.836390, -2.813766>,
      < 4.940493, -1.782057, -2.842164>
    }
    triangle {
      < 4.854362, -1.850491, -2.792428>,
      < 4.940493, -1.782057, -2.842164>,
      < 4.953623, -1.793188, -2.828054>
    }
    triangle {
      < 4.864738, -1.860723, -2.813766>,
      < 4.854362, -1.850491, -2.792428>,
      < 4.953623, -1.793188, -2.828054>
    }
    triangle {
      < 4.864738, -1.860723, -2.813766>,
      < 4.953623, -1.793188, -2.828054>,
      < 4.956703, -1.810121, -2.842164>
    }
    triangle {
      < 5.242542, -1.850467, -2.792428>,
      < 5.232167, -1.860699, -2.813766>,
      < 5.140212, -1.810088, -2.842164>
    }
    triangle {
      < 5.242542, -1.850467, -2.792428>,
      < 5.140212, -1.810088, -2.842164>,
      < 5.143287, -1.793151, -2.828054>
    }
    triangle {
      < 5.246215, -1.836364, -2.813766>,
      < 5.242542, -1.850467, -2.792428>,
      < 5.143287, -1.793151, -2.828054>
    }
    triangle {
      < 5.246215, -1.836364, -2.813766>,
      < 5.143287, -1.793151, -2.828054>,
      < 5.156413, -1.782018, -2.842164>
    }
    triangle {
      < 5.098545, -1.382016, -2.779159>,
      < 5.123573, -1.321247, -2.768997>,
      < 5.149528, -1.326766, -2.768997>
    }
    triangle {
      < 5.098545, -1.382016, -2.779159>,
      < 5.149528, -1.326766, -2.768997>,
      < 5.147658, -1.392457, -2.779159>
    }
    triangle {
      < 5.147658, -1.392457, -2.779159>,
      < 5.149528, -1.326766, -2.768997>,
      < 5.181429, -1.313272, -2.764932>
    }
    triangle {
      < 5.123573, -1.321247, -2.768997>,
      < 5.129702, -1.287239, -2.663333>,
      < 5.157773, -1.293207, -2.663333>
    }
    triangle {
      < 5.123573, -1.321247, -2.768997>,
      < 5.157773, -1.293207, -2.663333>,
      < 5.149528, -1.326766, -2.768997>
    }
    triangle {
      < 5.149528, -1.326766, -2.768997>,
      < 5.157773, -1.293207, -2.663333>,
      < 5.192275, -1.278614, -2.663333>
    }
    triangle {
      < 5.149528, -1.326766, -2.768997>,
      < 5.192275, -1.278614, -2.663333>,
      < 5.181429, -1.313272, -2.764932>
    }
    triangle {
      < 5.308219, -1.403467, -2.768997>,
      < 5.329401, -1.376163, -2.663333>,
      < 5.366855, -1.376865, -2.663333>
    }
    triangle {
      < 5.308219, -1.403467, -2.768997>,
      < 5.366855, -1.376865, -2.663333>,
      < 5.342851, -1.404115, -2.764932>
    }
    triangle {
      < 5.286753, -1.387869, -2.768997>,
      < 5.306184, -1.359294, -2.663333>,
      < 5.329401, -1.376163, -2.663333>
    }
    triangle {
      < 5.286753, -1.387869, -2.768997>,
      < 5.329401, -1.376163, -2.663333>,
      < 5.308219, -1.403467, -2.768997>
    }
    triangle {
      < 5.239172, -1.433205, -2.779159>,
      < 5.286753, -1.387869, -2.768997>,
      < 5.308219, -1.403467, -2.768997>
    }
    triangle {
      < 5.239172, -1.433205, -2.779159>,
      < 5.308219, -1.403467, -2.768997>,
      < 5.279793, -1.462719, -2.779159>
    }
    triangle {
      < 5.279793, -1.462719, -2.779159>,
      < 5.308219, -1.403467, -2.768997>,
      < 5.342851, -1.404115, -2.764932>
    }
    triangle {
      < 5.346822, -1.537166, -2.779159>,
      < 5.408729, -1.515102, -2.768997>,
      < 5.421995, -1.538082, -2.768997>
    }
    triangle {
      < 5.346822, -1.537166, -2.779159>,
      < 5.421995, -1.538082, -2.768997>,
      < 5.371927, -1.580650, -2.779159>
    }
    triangle {
      < 5.371927, -1.580650, -2.779159>,
      < 5.421995, -1.538082, -2.768997>,
      < 5.453369, -1.552760, -2.764932>
    }
    triangle {
      < 5.408729, -1.515102, -2.768997>,
      < 5.438103, -1.496900, -2.663333>,
      < 5.452451, -1.521754, -2.663333>
    }
    triangle {
      < 5.408729, -1.515102, -2.768997>,
      < 5.452451, -1.521754, -2.663333>,
      < 5.421995, -1.538082, -2.768997>
    }
    triangle {
      < 5.421995, -1.538082, -2.768997>,
      < 5.452451, -1.521754, -2.663333>,
      < 5.486382, -1.537629, -2.663333>
    }
    triangle {
      < 5.421995, -1.538082, -2.768997>,
      < 5.486382, -1.537629, -2.663333>,
      < 5.453369, -1.552760, -2.764932>
    }
    triangle {
      < 5.471183, -1.707335, -2.768997>,
      < 5.505647, -1.704806, -2.663333>,
      < 5.530188, -1.733109, -2.663333>
    }
    triangle {
      < 5.471183, -1.707335, -2.768997>,
      < 5.530188, -1.733109, -2.663333>,
      < 5.493875, -1.733505, -2.764932>
    }
    triangle {
      < 5.468410, -1.680946, -2.768997>,
      < 5.502648, -1.676265, -2.663333>,
      < 5.505647, -1.704806, -2.663333>
    }
    triangle {
      < 5.468410, -1.680946, -2.768997>,
      < 5.505647, -1.704806, -2.663333>,
      < 5.471183, -1.707335, -2.768997>
    }
    triangle {
      < 5.408130, -1.725859, -2.779159>,
      < 5.471183, -1.707335, -2.768997>,
      < 5.493875, -1.733505, -2.764932>
    }
    triangle {
      < 5.402882, -1.675924, -2.779159>,
      < 5.468410, -1.680946, -2.768997>,
      < 5.471183, -1.707335, -2.768997>
    }
    triangle {
      < 5.402882, -1.675924, -2.779159>,
      < 5.471183, -1.707335, -2.768997>,
      < 5.408130, -1.725859, -2.779159>
    }
    triangle {
      < 5.397657, -1.825486, -2.779159>,
      < 5.455479, -1.856727, -2.768997>,
      < 5.447278, -1.881963, -2.768997>
    }
    triangle {
      < 5.397657, -1.825486, -2.779159>,
      < 5.447278, -1.881963, -2.768997>,
      < 5.382142, -1.873239, -2.779159>
    }
    triangle {
      < 5.382142, -1.873239, -2.779159>,
      < 5.447278, -1.881963, -2.768997>,
      < 5.457364, -1.915100, -2.764932>
    }
    triangle {
      < 5.455479, -1.856727, -2.768997>,
      < 5.488660, -1.866377, -2.663333>,
      < 5.479791, -1.893670, -2.663333>
    }
    triangle {
      < 5.455479, -1.856727, -2.768997>,
      < 5.479791, -1.893670, -2.663333>,
      < 5.447278, -1.881963, -2.768997>
    }
    triangle {
      < 5.447278, -1.881963, -2.768997>,
      < 5.479791, -1.893670, -2.663333>,
      < 5.490699, -1.929508, -2.663333>
    }
    triangle {
      < 5.447278, -1.881963, -2.768997>,
      < 5.490699, -1.929508, -2.663333>,
      < 5.457364, -1.915100, -2.764932>
    }
    triangle {
      < 5.298456, -1.997308, -2.779159>,
      < 5.354414, -2.031771, -2.768997>,
      < 5.350150, -2.066145, -2.764932>
    }
    triangle {
      < 5.332053, -1.959994, -2.779159>,
      < 5.372169, -2.012052, -2.768997>,
      < 5.354414, -2.031771, -2.768997>
    }
    triangle {
      < 5.332053, -1.959994, -2.779159>,
      < 5.354414, -2.031771, -2.768997>,
      < 5.298456, -1.997308, -2.779159>
    }
    triangle {
      < 5.372169, -2.012052, -2.768997>,
      < 5.398557, -2.034363, -2.663333>,
      < 5.379354, -2.055689, -2.663333>
    }
    triangle {
      < 5.372169, -2.012052, -2.768997>,
      < 5.379354, -2.055689, -2.663333>,
      < 5.354414, -2.031771, -2.768997>
    }
    triangle {
      < 5.354414, -2.031771, -2.768997>,
      < 5.379354, -2.055689, -2.663333>,
      < 5.374743, -2.092865, -2.663333>
    }
    triangle {
      < 5.354414, -2.031771, -2.768997>,
      < 5.374743, -2.092865, -2.663333>,
      < 5.350150, -2.066145, -2.764932>
    }
    triangle {
      < 5.232887, -2.120064, -2.768997>,
      < 5.247919, -2.151179, -2.663333>,
      < 5.221702, -2.162851, -2.663333>
    }
    triangle {
      < 5.232887, -2.120064, -2.768997>,
      < 5.221702, -2.162851, -2.663333>,
      < 5.208646, -2.130857, -2.768997>
    }
    triangle {
      < 5.208646, -2.130857, -2.768997>,
      < 5.221702, -2.162851, -2.663333>,
      < 5.202368, -2.194938, -2.663333>
    }
    triangle {
      < 5.208646, -2.130857, -2.768997>,
      < 5.202368, -2.194938, -2.663333>,
      < 5.190770, -2.160525, -2.764932>
    }
    triangle {
      < 5.217412, -2.056191, -2.779159>,
      < 5.232887, -2.120064, -2.768997>,
      < 5.208646, -2.130857, -2.768997>
    }
    triangle {
      < 5.217412, -2.056191, -2.779159>,
      < 5.208646, -2.130857, -2.768997>,
      < 5.171543, -2.076614, -2.779159>
    }
    triangle {
      < 5.171543, -2.076614, -2.779159>,
      < 5.208646, -2.130857, -2.768997>,
      < 5.190770, -2.160525, -2.764932>
    }
    triangle {
      < 5.073556, -2.097443, -2.779159>,
      < 5.061714, -2.162088, -2.768997>,
      < 5.035179, -2.162088, -2.768997>
    }
    triangle {
      < 5.073556, -2.097443, -2.779159>,
      < 5.035179, -2.162088, -2.768997>,
      < 5.023346, -2.097444, -2.779159>
    }
    triangle {
      < 5.023346, -2.097444, -2.779159>,
      < 5.035179, -2.162088, -2.768997>,
      < 5.006781, -2.181921, -2.764932>
    }
    triangle {
      < 5.035179, -2.162088, -2.768997>,
      < 5.034093, -2.196627, -2.663333>,
      < 5.003380, -2.218076, -2.663333>
    }
    triangle {
      < 5.035179, -2.162088, -2.768997>,
      < 5.003380, -2.218076, -2.663333>,
      < 5.006781, -2.181921, -2.764932>
    }
    triangle {
      < 5.061714, -2.162088, -2.768997>,
      < 5.062791, -2.196627, -2.663333>,
      < 5.034093, -2.196627, -2.663333>
    }
    triangle {
      < 5.061714, -2.162088, -2.768997>,
      < 5.034093, -2.196627, -2.663333>,
      < 5.035179, -2.162088, -2.768997>
    }
    triangle {
      < 4.888246, -2.130858, -2.768997>,
      < 4.875182, -2.162849, -2.663333>,
      < 4.848965, -2.151177, -2.663333>
    }
    triangle {
      < 4.888246, -2.130858, -2.768997>,
      < 4.848965, -2.151177, -2.663333>,
      < 4.864006, -2.120065, -2.768997>
    }
    triangle {
      < 4.864006, -2.120065, -2.768997>,
      < 4.848965, -2.151177, -2.663333>,
      < 4.812184, -2.158279, -2.663333>
    }
    triangle {
      < 4.864006, -2.120065, -2.768997>,
      < 4.812184, -2.158279, -2.663333>,
      < 4.829997, -2.126633, -2.764932>
    }
    triangle {
      < 4.925358, -2.076618, -2.779159>,
      < 4.888246, -2.130858, -2.768997>,
      < 4.864006, -2.120065, -2.768997>
    }
    triangle {
      < 4.925358, -2.076618, -2.779159>,
      < 4.864006, -2.120065, -2.768997>,
      < 4.879488, -2.056197, -2.779159>
    }
    triangle {
      < 4.879488, -2.056197, -2.779159>,
      < 4.864006, -2.120065, -2.768997>,
      < 4.829997, -2.126633, -2.764932>
    }
    triangle {
      < 4.724722, -2.012054, -2.768997>,
      < 4.698328, -2.034359, -2.663333>,
      < 4.661838, -2.025887, -2.663333>
    }
    triangle {
      < 4.724722, -2.012054, -2.768997>,
      < 4.661838, -2.025887, -2.663333>,
      < 4.690982, -2.004221, -2.764932>
    }
    triangle {
      < 4.742478, -2.031773, -2.768997>,
      < 4.717531, -2.055685, -2.663333>,
      < 4.698328, -2.034359, -2.663333>
    }
    triangle {
      < 4.742478, -2.031773, -2.768997>,
      < 4.698328, -2.034359, -2.663333>,
      < 4.724722, -2.012054, -2.768997>
    }
    triangle {
      < 4.764844, -1.960004, -2.779159>,
      < 4.724722, -2.012054, -2.768997>,
      < 4.690982, -2.004221, -2.764932>
    }
    triangle {
      < 4.798442, -1.997317, -2.779159>,
      < 4.742478, -2.031773, -2.768997>,
      < 4.724722, -2.012054, -2.768997>
    }
    triangle {
      < 4.798442, -1.997317, -2.779159>,
      < 4.724722, -2.012054, -2.768997>,
      < 4.764844, -1.960004, -2.779159>
    }
    triangle {
      < 4.699235, -1.825499, -2.779159>,
      < 4.641412, -1.856730, -2.768997>,
      < 4.613774, -1.835851, -2.764932>
    }
    triangle {
      < 4.714753, -1.873251, -2.779159>,
      < 4.649612, -1.881966, -2.768997>,
      < 4.641412, -1.856730, -2.768997>
    }
    triangle {
      < 4.714753, -1.873251, -2.779159>,
      < 4.641412, -1.856730, -2.768997>,
      < 4.699235, -1.825499, -2.779159>
    }
    triangle {
      < 4.641412, -1.856730, -2.768997>,
      < 4.608228, -1.866371, -2.663333>,
      < 4.578337, -1.843790, -2.663333>
    }
    triangle {
      < 4.641412, -1.856730, -2.768997>,
      < 4.578337, -1.843790, -2.663333>,
      < 4.613774, -1.835851, -2.764932>
    }
    triangle {
      < 4.649612, -1.881966, -2.768997>,
      < 4.617096, -1.893664, -2.663333>,
      < 4.608228, -1.866371, -2.663333>
    }
    triangle {
      < 4.649612, -1.881966, -2.768997>,
      < 4.608228, -1.866371, -2.663333>,
      < 4.641412, -1.856730, -2.768997>
    }
    triangle {
      < 4.688759, -1.725872, -2.779159>,
      < 4.625706, -1.707338, -2.768997>,
      < 4.628479, -1.680949, -2.768997>
    }
    triangle {
      < 4.688759, -1.725872, -2.779159>,
      < 4.628479, -1.680949, -2.768997>,
      < 4.694005, -1.675936, -2.779159>
    }
    triangle {
      < 4.694005, -1.675936, -2.779159>,
      < 4.628479, -1.680949, -2.768997>,
      < 4.611722, -1.650634, -2.764932>
    }
    triangle {
      < 4.625706, -1.707338, -2.768997>,
      < 4.591243, -1.704800, -2.663333>,
      < 4.594242, -1.676260, -2.663333>
    }
    triangle {
      < 4.625706, -1.707338, -2.768997>,
      < 4.594242, -1.676260, -2.663333>,
      < 4.628479, -1.680949, -2.768997>
    }
    triangle {
      < 4.628479, -1.680949, -2.768997>,
      < 4.594242, -1.676260, -2.663333>,
      < 4.576120, -1.643473, -2.663333>
    }
    triangle {
      < 4.628479, -1.680949, -2.768997>,
      < 4.576120, -1.643473, -2.663333>,
      < 4.611722, -1.650634, -2.764932>
    }
    triangle {
      < 4.688159, -1.515104, -2.768997>,
      < 4.658790, -1.496895, -2.663333>,
      < 4.655570, -1.459573, -2.663333>
    }
    triangle {
      < 4.688159, -1.515104, -2.768997>,
      < 4.655570, -1.459573, -2.663333>,
      < 4.685182, -1.480595, -2.764932>
    }
    triangle {
      < 4.674892, -1.538084, -2.768997>,
      < 4.644442, -1.521749, -2.663333>,
      < 4.658790, -1.496895, -2.663333>
    }
    triangle {
      < 4.674892, -1.538084, -2.768997>,
      < 4.658790, -1.496895, -2.663333>,
      < 4.688159, -1.515104, -2.768997>
    }
    triangle {
      < 4.750060, -1.537177, -2.779159>,
      < 4.688159, -1.515104, -2.768997>,
      < 4.685182, -1.480595, -2.764932>
    }
    triangle {
      < 4.724957, -1.580661, -2.779159>,
      < 4.674892, -1.538084, -2.768997>,
      < 4.688159, -1.515104, -2.768997>
    }
    triangle {
      < 4.724957, -1.580661, -2.779159>,
      < 4.688159, -1.515104, -2.768997>,
      < 4.750060, -1.537177, -2.779159>
    }
    triangle {
      < 4.857706, -1.433212, -2.779159>,
      < 4.810134, -1.387871, -2.768997>,
      < 4.821450, -1.355134, -2.764932>
    }
    triangle {
      < 4.817087, -1.462727, -2.779159>,
      < 4.788668, -1.403468, -2.768997>,
      < 4.810134, -1.387871, -2.768997>
    }
    triangle {
      < 4.817087, -1.462727, -2.779159>,
      < 4.810134, -1.387871, -2.768997>,
      < 4.857706, -1.433212, -2.779159>
    }
    triangle {
      < 4.810134, -1.387871, -2.768997>,
      < 4.790710, -1.359290, -2.663333>,
      < 4.802948, -1.323885, -2.663333>
    }
    triangle {
      < 4.810134, -1.387871, -2.768997>,
      < 4.802948, -1.323885, -2.663333>,
      < 4.821450, -1.355134, -2.764932>
    }
    triangle {
      < 4.788668, -1.403468, -2.768997>,
      < 4.767493, -1.376160, -2.663333>,
      < 4.790710, -1.359290, -2.663333>
    }
    triangle {
      < 4.788668, -1.403468, -2.768997>,
      < 4.790710, -1.359290, -2.663333>,
      < 4.810134, -1.387871, -2.768997>
    }
    triangle {
      < 4.949219, -1.392461, -2.779159>,
      < 4.947359, -1.326766, -2.768997>,
      < 4.973314, -1.321248, -2.768997>
    }
    triangle {
      < 4.949219, -1.392461, -2.779159>,
      < 4.973314, -1.321248, -2.768997>,
      < 4.998332, -1.382018, -2.779159>
    }
    triangle {
      < 4.998332, -1.382018, -2.779159>,
      < 4.973314, -1.321248, -2.768997>,
      < 4.996966, -1.295944, -2.764932>
    }
    triangle {
      < 4.973314, -1.321248, -2.768997>,
      < 4.967193, -1.287238, -2.663333>,
      < 4.992774, -1.259871, -2.663333>
    }
    triangle {
      < 4.973314, -1.321248, -2.768997>,
      < 4.992774, -1.259871, -2.663333>,
      < 4.996966, -1.295944, -2.764932>
    }
    triangle {
      < 4.947359, -1.326766, -2.768997>,
      < 4.939123, -1.293206, -2.663333>,
      < 4.967193, -1.287238, -2.663333>
    }
    triangle {
      < 4.947359, -1.326766, -2.768997>,
      < 4.967193, -1.287238, -2.663333>,
      < 4.973314, -1.321248, -2.768997>
    }
    triangle {
      < 4.722143, -2.092861, -2.663333>,
      < 4.661838, -2.025887, -2.663333>,
      < 4.698328, -2.034359, -2.663333>
    }
    triangle {
      < 4.722143, -2.092861, -2.663333>,
      < 4.698328, -2.034359, -2.663333>,
      < 4.717531, -2.055685, -2.663333>
    }
    triangle {
      < 4.894516, -2.194936, -2.663333>,
      < 4.812184, -2.158279, -2.663333>,
      < 4.848965, -2.151177, -2.663333>
    }
    triangle {
      < 4.894516, -2.194936, -2.663333>,
      < 4.848965, -2.151177, -2.663333>,
      < 4.875182, -2.162849, -2.663333>
    }
    triangle {
      < 5.093503, -2.218077, -2.663333>,
      < 5.003380, -2.218076, -2.663333>,
      < 5.034093, -2.196627, -2.663333>
    }
    triangle {
      < 5.093503, -2.218077, -2.663333>,
      < 5.034093, -2.196627, -2.663333>,
      < 5.062791, -2.196627, -2.663333>
    }
    triangle {
      < 5.284700, -2.158282, -2.663333>,
      < 5.202368, -2.194938, -2.663333>,
      < 5.221702, -2.162851, -2.663333>
    }
    triangle {
      < 5.284700, -2.158282, -2.663333>,
      < 5.221702, -2.162851, -2.663333>,
      < 5.247919, -2.151179, -2.663333>
    }
    triangle {
      < 5.435048, -2.025892, -2.663333>,
      < 5.374743, -2.092865, -2.663333>,
      < 5.379354, -2.055689, -2.663333>
    }
    triangle {
      < 5.435048, -2.025892, -2.663333>,
      < 5.379354, -2.055689, -2.663333>,
      < 5.398557, -2.034363, -2.663333>
    }
    triangle {
      < 5.518551, -1.843796, -2.663333>,
      < 5.490699, -1.929508, -2.663333>,
      < 5.479791, -1.893670, -2.663333>
    }
    triangle {
      < 5.518551, -1.843796, -2.663333>,
      < 5.479791, -1.893670, -2.663333>,
      < 5.488660, -1.866377, -2.663333>
    }
    triangle {
      < 5.520771, -1.643479, -2.663333>,
      < 5.530188, -1.733109, -2.663333>,
      < 5.505647, -1.704806, -2.663333>
    }
    triangle {
      < 5.520771, -1.643479, -2.663333>,
      < 5.505647, -1.704806, -2.663333>,
      < 5.502648, -1.676265, -2.663333>
    }
    triangle {
      < 5.441323, -1.459577, -2.663333>,
      < 5.486382, -1.537629, -2.663333>,
      < 5.452451, -1.521754, -2.663333>
    }
    triangle {
      < 5.441323, -1.459577, -2.663333>,
      < 5.452451, -1.521754, -2.663333>,
      < 5.438103, -1.496900, -2.663333>
    }
    triangle {
      < 5.293946, -1.323888, -2.663333>,
      < 5.366855, -1.376865, -2.663333>,
      < 5.329401, -1.376163, -2.663333>
    }
    triangle {
      < 5.293946, -1.323888, -2.663333>,
      < 5.329401, -1.376163, -2.663333>,
      < 5.306184, -1.359294, -2.663333>
    }
    triangle {
      < 5.104121, -1.259872, -2.663333>,
      < 5.192275, -1.278614, -2.663333>,
      < 5.157773, -1.293207, -2.663333>
    }
    triangle {
      < 5.104121, -1.259872, -2.663333>,
      < 5.157773, -1.293207, -2.663333>,
      < 5.129702, -1.287239, -2.663333>
    }
    triangle {
      < 4.578337, -1.843790, -2.663333>,
      < 4.606188, -1.929502, -2.663333>,
      < 4.525680, -1.949631, -2.663332>
    }
    triangle {
      < 4.578337, -1.843790, -2.663333>,
      < 4.525680, -1.949631, -2.663332>,
      < 4.501373, -1.874822, -2.663332>
    }
    triangle {
      < 4.576120, -1.643473, -2.663333>,
      < 4.566702, -1.733103, -2.663333>,
      < 4.484967, -1.718747, -2.663332>
    }
    triangle {
      < 4.576120, -1.643473, -2.663333>,
      < 4.484967, -1.718747, -2.663332>,
      < 4.493187, -1.640519, -2.663332>
    }
    triangle {
      < 4.655570, -1.459573, -2.663333>,
      < 4.610510, -1.537623, -2.663333>,
      < 4.541680, -1.491264, -2.663332>
    }
    triangle {
      < 4.655570, -1.459573, -2.663333>,
      < 4.541680, -1.491264, -2.663332>,
      < 4.581008, -1.423142, -2.663332>
    }
    triangle {
      < 4.802948, -1.323885, -2.663333>,
      < 4.730039, -1.376861, -2.663333>,
      < 4.686016, -1.306514, -2.663332>
    }
    triangle {
      < 4.802948, -1.323885, -2.663333>,
      < 4.686016, -1.306514, -2.663332>,
      < 4.749650, -1.260278, -2.663332>
    }
    triangle {
      < 4.992774, -1.259871, -2.663333>,
      < 4.904621, -1.278613, -2.663333>,
      < 4.893016, -1.196442, -2.663332>
    }
    triangle {
      < 4.992774, -1.259871, -2.663333>,
      < 4.893016, -1.196442, -2.663332>,
      < 4.969955, -1.180085, -2.663332>
    }
    triangle {
      < 5.033715, -1.718945, -2.852345>,
      < 5.033167, -1.670987, -2.843713>,
      < 5.048425, -1.670327, -2.844015>
    }
    triangle {
      < 5.033715, -1.718945, -2.852345>,
      < 5.048425, -1.670327, -2.844015>,
      < 5.048434, -1.718909, -2.852781>
    }
    triangle {
      < 5.010138, -1.673463, -2.841802>,
      < 5.018181, -1.672935, -2.842822>,
      < 5.019150, -1.719049, -2.851049>
    }
    triangle {
      < 5.018181, -1.672935, -2.842822>,
      < 5.033167, -1.670987, -2.843713>,
      < 5.033715, -1.718945, -2.852345>
    }
    triangle {
      < 5.018181, -1.672935, -2.842822>,
      < 5.033715, -1.718945, -2.852345>,
      < 5.019150, -1.719049, -2.851049>
    }
    triangle {
      < 5.048425, -1.670327, -2.844015>,
      < 5.063690, -1.670982, -2.843714>,
      < 5.063154, -1.718942, -2.852345>
    }
    triangle {
      < 5.048425, -1.670327, -2.844015>,
      < 5.063154, -1.718942, -2.852345>,
      < 5.048434, -1.718909, -2.852781>
    }
    triangle {
      < 5.063690, -1.670982, -2.843714>,
      < 5.078677, -1.672926, -2.842824>,
      < 5.077719, -1.719043, -2.851051>
    }
    triangle {
      < 5.063690, -1.670982, -2.843714>,
      < 5.077719, -1.719043, -2.851051>,
      < 5.063154, -1.718942, -2.852345>
    }
    triangle {
      < 5.078677, -1.672926, -2.842824>,
      < 5.086721, -1.673450, -2.841804>,
      < 5.077719, -1.719043, -2.851051>
    }
    triangle {
      < 5.086721, -1.673450, -2.841804>,
      < 5.100585, -1.677655, -2.840264>,
      < 5.091983, -1.719208, -2.848939>
    }
    triangle {
      < 5.086721, -1.673450, -2.841804>,
      < 5.091983, -1.719208, -2.848939>,
      < 5.077719, -1.719043, -2.851051>
    }
    triangle {
      < 5.100585, -1.677655, -2.840264>,
      < 5.112318, -1.680317, -2.838027>,
      < 5.104371, -1.708975, -2.845357>
    }
    triangle {
      < 5.100585, -1.677655, -2.840264>,
      < 5.104371, -1.708975, -2.845357>,
      < 5.091983, -1.719208, -2.848939>
    }
    triangle {
      < 5.112318, -1.680317, -2.838027>,
      < 5.124714, -1.686381, -2.835714>,
      < 5.118579, -1.709425, -2.841648>
    }
    triangle {
      < 5.112318, -1.680317, -2.838027>,
      < 5.118579, -1.709425, -2.841648>,
      < 5.104371, -1.708975, -2.845357>
    }
    triangle {
      < 5.129477, -1.692665, -2.835422>,
      < 5.132073, -1.709956, -2.837276>,
      < 5.118579, -1.709425, -2.841648>
    }
    triangle {
      < 5.125597, -1.720634, -2.840566>,
      < 5.156281, -1.719384, -2.828054>,
      < 5.131828, -1.728363, -2.838889>
    }
    triangle {
      < 5.156281, -1.719384, -2.828054>,
      < 5.146635, -1.736575, -2.833268>,
      < 5.134612, -1.738668, -2.838093>
    }
    triangle {
      < 5.156281, -1.719384, -2.828054>,
      < 5.134612, -1.738668, -2.838093>,
      < 5.135253, -1.735762, -2.837839>
    }
    triangle {
      < 5.146635, -1.736575, -2.833268>,
      < 5.145410, -1.745914, -2.833677>,
      < 5.132570, -1.741768, -2.838815>
    }
    triangle {
      < 5.146635, -1.736575, -2.833268>,
      < 5.132570, -1.741768, -2.838815>,
      < 5.134612, -1.738668, -2.838093>
    }
    triangle {
      < 5.145410, -1.745914, -2.833677>,
      < 5.142567, -1.754884, -2.834395>,
      < 5.129311, -1.744261, -2.839917>
    }
    triangle {
      < 5.145410, -1.745914, -2.833677>,
      < 5.129311, -1.744261, -2.839917>,
      < 5.132570, -1.741768, -2.838815>
    }
    triangle {
      < 5.142567, -1.754884, -2.834395>,
      < 5.138001, -1.763922, -2.835397>,
      < 5.124606, -1.747297, -2.841394>
    }
    triangle {
      < 5.142567, -1.754884, -2.834395>,
      < 5.124606, -1.747297, -2.841394>,
      < 5.129311, -1.744261, -2.839917>
    }
    triangle {
      < 5.138001, -1.763922, -2.835397>,
      < 5.131969, -1.772594, -2.836540>,
      < 5.118957, -1.750271, -2.843014>
    }
    triangle {
      < 5.138001, -1.763922, -2.835397>,
      < 5.118957, -1.750271, -2.843014>,
      < 5.124606, -1.747297, -2.841394>
    }
    triangle {
      < 5.131969, -1.772594, -2.836540>,
      < 5.124419, -1.780868, -2.837771>,
      < 5.112181, -1.753411, -2.844747>
    }
    triangle {
      < 5.131969, -1.772594, -2.836540>,
      < 5.112181, -1.753411, -2.844747>,
      < 5.118957, -1.750271, -2.843014>
    }
    triangle {
      < 5.124419, -1.780868, -2.837771>,
      < 5.115426, -1.788932, -2.838923>,
      < 5.104347, -1.757434, -2.846415>
    }
    triangle {
      < 5.124419, -1.780868, -2.837771>,
      < 5.104347, -1.757434, -2.846415>,
      < 5.112181, -1.753411, -2.844747>
    }
    triangle {
      < 5.115426, -1.788932, -2.838923>,
      < 5.105288, -1.795994, -2.839975>,
      < 5.095855, -1.760986, -2.847925>
    }
    triangle {
      < 5.115426, -1.788932, -2.838923>,
      < 5.095855, -1.760986, -2.847925>,
      < 5.104347, -1.757434, -2.846415>
    }
    triangle {
      < 5.105288, -1.795994, -2.839975>,
      < 5.093951, -1.801850, -2.840937>,
      < 5.086355, -1.763883, -2.849307>
    }
    triangle {
      < 5.105288, -1.795994, -2.839975>,
      < 5.086355, -1.763883, -2.849307>,
      < 5.095855, -1.760986, -2.847925>
    }
    triangle {
      < 5.093951, -1.801850, -2.840937>,
      < 5.081745, -1.806768, -2.841603>,
      < 5.076283, -1.766977, -2.850321>
    }
    triangle {
      < 5.093951, -1.801850, -2.840937>,
      < 5.076283, -1.766977, -2.850321>,
      < 5.086355, -1.763883, -2.849307>
    }
    triangle {
      < 5.081745, -1.806768, -2.841603>,
      < 5.068623, -1.810492, -2.841981>,
      < 5.065201, -1.769908, -2.850970>
    }
    triangle {
      < 5.081745, -1.806768, -2.841603>,
      < 5.065201, -1.769908, -2.850970>,
      < 5.076283, -1.766977, -2.850321>
    }
    triangle {
      < 5.068623, -1.810492, -2.841981>,
      < 5.055653, -1.812827, -2.842009>,
      < 5.054963, -1.772411, -2.851121>
    }
    triangle {
      < 5.068623, -1.810492, -2.841981>,
      < 5.054963, -1.772411, -2.851121>,
      < 5.065201, -1.769908, -2.850970>
    }
    triangle {
      < 5.055653, -1.812827, -2.842009>,
      < 5.041276, -1.812829, -2.842010>,
      < 5.041962, -1.772412, -2.851122>
    }
    triangle {
      < 5.055653, -1.812827, -2.842009>,
      < 5.041962, -1.772412, -2.851122>,
      < 5.054963, -1.772411, -2.851121>
    }
    triangle {
      < 5.041276, -1.812829, -2.842010>,
      < 5.028300, -1.810501, -2.841982>,
      < 5.031713, -1.769917, -2.850970>
    }
    triangle {
      < 5.041276, -1.812829, -2.842010>,
      < 5.031713, -1.769917, -2.850970>,
      < 5.041962, -1.772412, -2.851122>
    }
    triangle {
      < 5.028300, -1.810501, -2.841982>,
      < 5.015175, -1.806781, -2.841603>,
      < 5.020626, -1.766988, -2.850321>
    }
    triangle {
      < 5.028300, -1.810501, -2.841982>,
      < 5.020626, -1.766988, -2.850321>,
      < 5.031713, -1.769917, -2.850970>
    }
    triangle {
      < 5.015175, -1.806781, -2.841603>,
      < 5.002964, -1.801868, -2.840937>,
      < 5.010549, -1.763898, -2.849308>
    }
    triangle {
      < 5.015175, -1.806781, -2.841603>,
      < 5.010549, -1.763898, -2.849308>,
      < 5.020626, -1.766988, -2.850321>
    }
    triangle {
      < 5.002964, -1.801868, -2.840937>,
      < 4.991753, -1.796140, -2.839976>,
      < 5.001306, -1.761263, -2.847952>
    }
    triangle {
      < 5.002964, -1.801868, -2.840937>,
      < 5.001306, -1.761263, -2.847952>,
      < 5.010549, -1.763898, -2.849308>
    }
    triangle {
      < 4.991753, -1.796140, -2.839976>,
      < 4.981481, -1.788957, -2.838923>,
      < 4.992546, -1.757454, -2.846414>
    }
    triangle {
      < 4.991753, -1.796140, -2.839976>,
      < 4.992546, -1.757454, -2.846414>,
      < 5.001306, -1.761263, -2.847952>
    }
    triangle {
      < 4.981481, -1.788957, -2.838923>,
      < 4.972484, -1.780896, -2.837770>,
      < 4.984708, -1.753434, -2.844745>
    }
    triangle {
      < 4.981481, -1.788957, -2.838923>,
      < 4.984708, -1.753434, -2.844745>,
      < 4.992546, -1.757454, -2.846414>
    }
    triangle {
      < 4.972484, -1.780896, -2.837770>,
      < 4.964930, -1.772623, -2.836539>,
      < 4.977930, -1.750294, -2.843013>
    }
    triangle {
      < 4.972484, -1.780896, -2.837770>,
      < 4.977930, -1.750294, -2.843013>,
      < 4.984708, -1.753434, -2.844745>
    }
    triangle {
      < 4.964930, -1.772623, -2.836539>,
      < 4.958778, -1.763813, -2.835366>,
      < 4.972040, -1.747036, -2.841324>
    }
    triangle {
      < 4.964930, -1.772623, -2.836539>,
      < 4.972040, -1.747036, -2.841324>,
      < 4.977930, -1.750294, -2.843013>
    }
    triangle {
      < 4.958778, -1.763813, -2.835366>,
      < 4.954325, -1.754914, -2.834394>,
      < 4.967573, -1.744281, -2.839914>
    }
    triangle {
      < 4.958778, -1.763813, -2.835366>,
      < 4.967573, -1.744281, -2.839914>,
      < 4.972040, -1.747036, -2.841324>
    }
    triangle {
      < 4.954325, -1.754914, -2.834394>,
      < 4.951478, -1.745944, -2.833675>,
      < 4.964313, -1.741786, -2.838813>
    }
    triangle {
      < 4.954325, -1.754914, -2.834394>,
      < 4.964313, -1.741786, -2.838813>,
      < 4.967573, -1.744281, -2.839914>
    }
    triangle {
      < 4.951478, -1.745944, -2.833675>,
      < 4.950251, -1.736606, -2.833266>,
      < 4.962271, -1.738689, -2.838090>
    }
    triangle {
      < 4.951478, -1.745944, -2.833675>,
      < 4.962271, -1.738689, -2.838090>,
      < 4.964313, -1.741786, -2.838813>
    }
    triangle {
      < 4.950251, -1.736606, -2.833266>,
      < 4.940600, -1.719425, -2.828054>,
      < 4.961631, -1.735803, -2.837837>
    }
    triangle {
      < 4.950251, -1.736606, -2.833266>,
      < 4.961631, -1.735803, -2.837837>,
      < 4.962271, -1.738689, -2.838090>
    }
    triangle {
      < 4.940600, -1.719425, -2.828054>,
      < 4.971284, -1.720668, -2.840566>,
      < 4.965055, -1.728392, -2.838888>
    }
    triangle {
      < 4.944293, -1.704601, -2.828054>,
      < 4.950013, -1.690435, -2.828054>,
      < 4.964806, -1.709989, -2.837276>
    }
    triangle {
      < 4.964806, -1.709989, -2.837276>,
      < 4.967393, -1.692694, -2.835421>,
      < 4.978296, -1.709448, -2.841646>
    }
    triangle {
      < 4.972154, -1.686408, -2.835713>,
      < 4.984545, -1.680337, -2.838025>,
      < 4.992498, -1.708987, -2.845354>
    }
    triangle {
      < 4.972154, -1.686408, -2.835713>,
      < 4.992498, -1.708987, -2.845354>,
      < 4.978296, -1.709448, -2.841646>
    }
    triangle {
      < 4.984545, -1.680337, -2.838025>,
      < 4.996275, -1.677672, -2.840262>,
      < 5.004886, -1.719217, -2.848936>
    }
    triangle {
      < 4.984545, -1.680337, -2.838025>,
      < 5.004886, -1.719217, -2.848936>,
      < 4.992498, -1.708987, -2.845354>
    }
    triangle {
      < 4.996275, -1.677672, -2.840262>,
      < 5.010138, -1.673463, -2.841802>,
      < 5.019150, -1.719049, -2.851049>
    }
    triangle {
      < 4.996275, -1.677672, -2.840262>,
      < 5.019150, -1.719049, -2.851049>,
      < 5.004886, -1.719217, -2.848936>
    }
    triangle {
      < 4.982264, -1.713125, -2.853366>,
      < 4.975648, -1.723348, -2.852286>,
      < 4.969537, -1.713619, -2.848997>
    }
    triangle {
      < 4.964806, -1.709989, -2.837276>,
      < 4.940600, -1.719425, -2.828054>,
      < 4.944293, -1.704601, -2.828054>
    }
    triangle {
      < 5.156281, -1.719384, -2.828054>,
      < 5.125597, -1.720634, -2.840566>,
      < 5.132073, -1.709956, -2.837276>
    }
    triangle {
      < 5.121234, -1.723317, -2.852286>,
      < 5.114612, -1.713105, -2.853368>,
      < 5.127343, -1.713589, -2.848996>
    }
    triangle {
      < 4.940600, -1.719425, -2.828054>,
      < 4.965055, -1.728392, -2.838888>,
      < 4.961631, -1.735803, -2.837837>
    }
    triangle {
      < 5.131828, -1.728363, -2.838889>,
      < 5.156281, -1.719384, -2.828054>,
      < 5.135253, -1.735762, -2.837839>
    }
    triangle {
      < 5.048435, -1.721745, -2.864501>,
      < 5.054595, -1.770488, -2.862842>,
      < 5.042328, -1.770489, -2.862842>
    }
    triangle {
      < 5.048435, -1.721745, -2.864501>,
      < 5.042328, -1.770489, -2.862842>,
      < 5.034548, -1.721778, -2.864064>
    }
    triangle {
      < 5.054595, -1.770488, -2.862842>,
      < 5.062322, -1.721775, -2.864065>,
      < 5.064253, -1.768208, -2.862690>
    }
    triangle {
      < 5.062322, -1.721775, -2.864065>,
      < 5.054595, -1.770488, -2.862842>,
      < 5.048435, -1.721745, -2.864501>
    }
    triangle {
      < 5.074708, -1.765537, -2.862041>,
      < 5.076063, -1.721867, -2.862772>,
      < 5.093158, -1.722017, -2.859846>
    }
    triangle {
      < 5.074708, -1.765537, -2.862041>,
      < 5.093158, -1.722017, -2.859846>,
      < 5.084210, -1.762718, -2.861027>
    }
    triangle {
      < 5.076063, -1.721867, -2.862772>,
      < 5.074708, -1.765537, -2.862041>,
      < 5.064253, -1.768208, -2.862690>
    }
    triangle {
      < 5.076063, -1.721867, -2.862772>,
      < 5.064253, -1.768208, -2.862690>,
      < 5.062322, -1.721775, -2.864065>
    }
    triangle {
      < 5.093173, -1.760080, -2.859645>,
      < 5.105880, -1.712695, -2.856265>,
      < 5.101185, -1.756843, -2.858135>
    }
    triangle {
      < 5.105880, -1.712695, -2.856265>,
      < 5.093173, -1.760080, -2.859645>,
      < 5.084210, -1.762718, -2.861027>
    }
    triangle {
      < 5.105880, -1.712695, -2.856265>,
      < 5.084210, -1.762718, -2.861027>,
      < 5.093158, -1.722017, -2.859846>
    }
    triangle {
      < 5.108576, -1.753178, -2.856467>,
      < 5.114612, -1.713105, -2.853368>,
      < 5.121234, -1.723317, -2.852286>
    }
    triangle {
      < 5.108576, -1.753178, -2.856467>,
      < 5.121234, -1.723317, -2.852286>,
      < 5.114968, -1.750317, -2.854735>
    }
    triangle {
      < 5.034548, -1.721778, -2.864064>,
      < 5.032659, -1.768216, -2.862690>,
      < 5.022200, -1.765548, -2.862041>
    }
    triangle {
      < 5.034548, -1.721778, -2.864064>,
      < 5.022200, -1.765548, -2.862041>,
      < 5.020807, -1.721872, -2.862770>
    }
    triangle {
      < 5.032659, -1.768216, -2.862690>,
      < 5.034548, -1.721778, -2.864064>,
      < 5.042328, -1.770489, -2.862842>
    }
    triangle {
      < 5.003711, -1.722026, -2.859843>,
      < 5.012692, -1.762733, -2.861027>,
      < 5.003972, -1.760332, -2.859672>
    }
    triangle {
      < 5.003711, -1.722026, -2.859843>,
      < 5.003972, -1.760332, -2.859672>,
      < 4.990989, -1.712705, -2.856261>
    }
    triangle {
      < 5.012692, -1.762733, -2.861027>,
      < 5.003711, -1.722026, -2.859843>,
      < 5.020807, -1.721872, -2.862770>
    }
    triangle {
      < 5.012692, -1.762733, -2.861027>,
      < 5.020807, -1.721872, -2.862770>,
      < 5.022200, -1.765548, -2.862041>
    }
    triangle {
      < 4.988314, -1.753199, -2.856466>,
      < 4.982264, -1.713125, -2.853366>,
      < 4.990989, -1.712705, -2.856261>
    }
    triangle {
      < 4.988314, -1.753199, -2.856466>,
      < 4.990989, -1.712705, -2.856261>,
      < 4.995708, -1.756862, -2.858134>
    }
    triangle {
      < 4.995708, -1.756862, -2.858134>,
      < 4.990989, -1.712705, -2.856261>,
      < 5.003972, -1.760332, -2.859672>
    }
    triangle {
      < 4.975648, -1.723348, -2.852286>,
      < 4.981918, -1.750338, -2.854733>,
      < 4.976361, -1.747370, -2.853045>
    }
    triangle {
      < 4.975648, -1.723348, -2.852286>,
      < 4.976361, -1.747370, -2.853045>,
      < 4.969771, -1.730384, -2.850608>
    }
    triangle {
      < 4.981918, -1.750338, -2.854733>,
      < 4.975648, -1.723348, -2.852286>,
      < 4.982264, -1.713125, -2.853366>
    }
    triangle {
      < 4.981918, -1.750338, -2.854733>,
      < 4.982264, -1.713125, -2.853366>,
      < 4.988314, -1.753199, -2.856466>
    }
    triangle {
      < 4.966541, -1.737136, -2.849557>,
      < 4.972147, -1.744860, -2.851635>,
      < 4.969071, -1.742587, -2.850533>
    }
    triangle {
      < 4.966541, -1.737136, -2.849557>,
      < 4.969071, -1.742587, -2.850533>,
      < 4.967145, -1.739766, -2.849810>
    }
    triangle {
      < 4.972147, -1.744860, -2.851635>,
      < 4.966541, -1.737136, -2.849557>,
      < 4.969771, -1.730384, -2.850608>
    }
    triangle {
      < 4.972147, -1.744860, -2.851635>,
      < 4.969771, -1.730384, -2.850608>,
      < 4.976361, -1.747370, -2.853045>
    }
    triangle {
      < 5.114612, -1.713105, -2.853368>,
      < 5.108576, -1.753178, -2.856467>,
      < 5.101185, -1.756843, -2.858135>
    }
    triangle {
      < 5.114612, -1.713105, -2.853368>,
      < 5.101185, -1.756843, -2.858135>,
      < 5.105880, -1.712695, -2.856265>
    }
    triangle {
      < 5.120298, -1.747608, -2.853114>,
      < 5.127112, -1.730358, -2.850609>,
      < 5.130343, -1.737099, -2.849559>
    }
    triangle {
      < 5.120298, -1.747608, -2.853114>,
      < 5.130343, -1.737099, -2.849559>,
      < 5.124737, -1.744842, -2.851637>
    }
    triangle {
      < 5.127112, -1.730358, -2.850609>,
      < 5.120298, -1.747608, -2.853114>,
      < 5.114968, -1.750317, -2.854735>
    }
    triangle {
      < 5.127112, -1.730358, -2.850609>,
      < 5.114968, -1.750317, -2.854735>,
      < 5.121234, -1.723317, -2.852286>
    }
    triangle {
      < 5.124737, -1.744842, -2.851637>,
      < 5.130343, -1.737099, -2.849559>,
      < 5.129738, -1.739747, -2.849813>
    }
    triangle {
      < 5.124737, -1.744842, -2.851637>,
      < 5.129738, -1.739747, -2.849813>,
      < 5.127812, -1.742571, -2.850535>
    }
    triangle {
      < 4.967393, -1.692694, -2.835421>,
      < 4.972154, -1.686408, -2.835713>,
      < 4.978296, -1.709448, -2.841646>
    }
    triangle {
      < 5.124714, -1.686381, -2.835714>,
      < 5.129477, -1.692665, -2.835422>,
      < 5.118579, -1.709425, -2.841648>
    }
    triangle {
      < 5.132073, -1.709956, -2.837276>,
      < 5.146858, -1.690398, -2.828054>,
      < 5.152584, -1.704561, -2.828054>
    }
    triangle {
      < 4.967393, -1.692694, -2.835421>,
      < 4.964806, -1.709989, -2.837276>,
      < 4.950013, -1.690435, -2.828054>
    }
    triangle {
      < 4.967393, -1.692694, -2.835421>,
      < 4.950013, -1.690435, -2.828054>,
      < 4.957648, -1.677203, -2.828054>
    }
    triangle {
      < 4.972154, -1.686408, -2.835713>,
      < 4.967393, -1.692694, -2.835421>,
      < 4.957648, -1.677203, -2.828054>
    }
    triangle {
      < 4.972154, -1.686408, -2.835713>,
      < 4.957648, -1.677203, -2.828054>,
      < 4.967051, -1.665163, -2.828054>
    }
    triangle {
      < 4.984545, -1.680337, -2.838025>,
      < 4.972154, -1.686408, -2.835713>,
      < 4.967051, -1.665163, -2.828054>
    }
    triangle {
      < 4.984545, -1.680337, -2.838025>,
      < 4.967051, -1.665163, -2.828054>,
      < 4.978038, -1.654548, -2.828054>
    }
    triangle {
      < 4.996275, -1.677672, -2.840262>,
      < 4.984545, -1.680337, -2.838025>,
      < 4.978038, -1.654548, -2.828054>
    }
    triangle {
      < 4.996275, -1.677672, -2.840262>,
      < 4.978038, -1.654548, -2.828054>,
      < 4.990395, -1.645565, -2.828054>
    }
    triangle {
      < 5.010138, -1.673463, -2.841802>,
      < 4.996275, -1.677672, -2.840262>,
      < 4.990395, -1.645565, -2.828054>
    }
    triangle {
      < 5.010138, -1.673463, -2.841802>,
      < 4.990395, -1.645565, -2.828054>,
      < 5.003882, -1.638390, -2.828054>
    }
    triangle {
      < 5.018181, -1.672935, -2.842822>,
      < 5.010138, -1.673463, -2.841802>,
      < 5.003882, -1.638390, -2.828054>
    }
    triangle {
      < 5.018181, -1.672935, -2.842822>,
      < 5.003882, -1.638390, -2.828054>,
      < 5.018236, -1.633162, -2.828054>
    }
    triangle {
      < 5.033167, -1.670987, -2.843713>,
      < 5.018181, -1.672935, -2.842822>,
      < 5.018236, -1.633162, -2.828054>
    }
    triangle {
      < 5.033167, -1.670987, -2.843713>,
      < 5.018236, -1.633162, -2.828054>,
      < 5.033179, -1.629982, -2.828054>
    }
    triangle {
      < 5.048425, -1.670327, -2.844015>,
      < 5.033167, -1.670987, -2.843713>,
      < 5.033179, -1.629982, -2.828054>
    }
    triangle {
      < 5.048425, -1.670327, -2.844015>,
      < 5.033179, -1.629982, -2.828054>,
      < 5.048418, -1.628912, -2.828054>
    }
    triangle {
      < 5.063690, -1.670982, -2.843714>,
      < 5.048425, -1.670327, -2.844015>,
      < 5.048418, -1.628912, -2.828054>
    }
    triangle {
      < 5.063690, -1.670982, -2.843714>,
      < 5.048418, -1.628912, -2.828054>,
      < 5.063670, -1.629976, -2.828054>
    }
    triangle {
      < 5.078677, -1.672926, -2.842824>,
      < 5.063690, -1.670982, -2.843714>,
      < 5.063670, -1.629976, -2.828054>
    }
    triangle {
      < 5.078677, -1.672926, -2.842824>,
      < 5.063670, -1.629976, -2.828054>,
      < 5.078613, -1.633150, -2.828054>
    }
    triangle {
      < 5.086721, -1.673450, -2.841804>,
      < 5.078677, -1.672926, -2.842824>,
      < 5.078613, -1.633150, -2.828054>
    }
    triangle {
      < 5.086721, -1.673450, -2.841804>,
      < 5.078613, -1.633150, -2.828054>,
      < 5.092969, -1.638373, -2.828054>
    }
    triangle {
      < 5.100585, -1.677655, -2.840264>,
      < 5.086721, -1.673450, -2.841804>,
      < 5.092969, -1.638373, -2.828054>
    }
    triangle {
      < 5.100585, -1.677655, -2.840264>,
      < 5.092969, -1.638373, -2.828054>,
      < 5.106459, -1.645543, -2.828054>
    }
    triangle {
      < 5.112318, -1.680317, -2.838027>,
      < 5.100585, -1.677655, -2.840264>,
      < 5.106459, -1.645543, -2.828054>
    }
    triangle {
      < 5.112318, -1.680317, -2.838027>,
      < 5.106459, -1.645543, -2.828054>,
      < 5.118820, -1.654521, -2.828054>
    }
    triangle {
      < 5.124714, -1.686381, -2.835714>,
      < 5.112318, -1.680317, -2.838027>,
      < 5.118820, -1.654521, -2.828054>
    }
    triangle {
      < 5.124714, -1.686381, -2.835714>,
      < 5.118820, -1.654521, -2.828054>,
      < 5.129811, -1.665132, -2.828054>
    }
    triangle {
      < 5.129477, -1.692665, -2.835422>,
      < 5.124714, -1.686381, -2.835714>,
      < 5.129811, -1.665132, -2.828054>
    }
    triangle {
      < 5.129477, -1.692665, -2.835422>,
      < 5.129811, -1.665132, -2.828054>,
      < 5.139218, -1.677168, -2.828054>
    }
    triangle {
      < 5.132073, -1.709956, -2.837276>,
      < 5.129477, -1.692665, -2.835422>,
      < 5.139218, -1.677168, -2.828054>
    }
    triangle {
      < 5.132073, -1.709956, -2.837276>,
      < 5.139218, -1.677168, -2.828054>,
      < 5.146858, -1.690398, -2.828054>
    }
    triangle {
      < 5.156281, -1.719384, -2.828054>,
      < 5.132073, -1.709956, -2.837276>,
      < 5.152584, -1.704561, -2.828054>
    }
    triangle {
      < 5.146635, -1.736575, -2.833268>,
      < 5.156281, -1.719384, -2.828054>,
      < 5.157881, -1.734577, -2.828054>
    }
    triangle {
      < 5.145410, -1.745914, -2.833677>,
      < 5.146635, -1.736575, -2.833268>,
      < 5.157881, -1.734577, -2.828054>
    }
    triangle {
      < 5.145410, -1.745914, -2.833677>,
      < 5.157881, -1.734577, -2.828054>,
      < 5.157351, -1.749844, -2.828054>
    }
    triangle {
      < 5.142567, -1.754884, -2.834395>,
      < 5.145410, -1.745914, -2.833677>,
      < 5.157351, -1.749844, -2.828054>
    }
    triangle {
      < 5.142567, -1.754884, -2.834395>,
      < 5.157351, -1.749844, -2.828054>,
      < 5.154700, -1.764889, -2.828054>
    }
    triangle {
      < 5.138001, -1.763922, -2.835397>,
      < 5.142567, -1.754884, -2.834395>,
      < 5.154700, -1.764889, -2.828054>
    }
    triangle {
      < 5.138001, -1.763922, -2.835397>,
      < 5.154700, -1.764889, -2.828054>,
      < 5.149981, -1.779420, -2.828054>
    }
    triangle {
      < 5.131969, -1.772594, -2.836540>,
      < 5.138001, -1.763922, -2.835397>,
      < 5.149981, -1.779420, -2.828054>
    }
    triangle {
      < 5.131969, -1.772594, -2.836540>,
      < 5.149981, -1.779420, -2.828054>,
      < 5.143287, -1.793151, -2.828054>
    }
    triangle {
      < 5.124419, -1.780868, -2.837771>,
      < 5.131969, -1.772594, -2.836540>,
      < 5.143287, -1.793151, -2.828054>
    }
    triangle {
      < 5.124419, -1.780868, -2.837771>,
      < 5.143287, -1.793151, -2.828054>,
      < 5.134747, -1.805818, -2.828054>
    }
    triangle {
      < 5.115426, -1.788932, -2.838923>,
      < 5.124419, -1.780868, -2.837771>,
      < 5.134747, -1.805818, -2.828054>
    }
    triangle {
      < 5.115426, -1.788932, -2.838923>,
      < 5.134747, -1.805818, -2.828054>,
      < 5.124527, -1.817173, -2.828054>
    }
    triangle {
      < 5.105288, -1.795994, -2.839975>,
      < 5.115426, -1.788932, -2.838923>,
      < 5.124527, -1.817173, -2.828054>
    }
    triangle {
      < 5.105288, -1.795994, -2.839975>,
      < 5.124527, -1.817173, -2.828054>,
      < 5.112825, -1.826995, -2.828054>
    }
    triangle {
      < 5.093951, -1.801850, -2.840937>,
      < 5.105288, -1.795994, -2.839975>,
      < 5.112825, -1.826995, -2.828054>
    }
    triangle {
      < 5.093951, -1.801850, -2.840937>,
      < 5.112825, -1.826995, -2.828054>,
      < 5.099871, -1.835093, -2.828054>
    }
    triangle {
      < 5.081745, -1.806768, -2.841603>,
      < 5.093951, -1.801850, -2.840937>,
      < 5.099871, -1.835093, -2.828054>
    }
    triangle {
      < 5.081745, -1.806768, -2.841603>,
      < 5.099871, -1.835093, -2.828054>,
      < 5.085916, -1.841309, -2.828054>
    }
    triangle {
      < 5.068623, -1.810492, -2.841981>,
      < 5.081745, -1.806768, -2.841603>,
      < 5.085916, -1.841309, -2.828054>
    }
    triangle {
      < 5.068623, -1.810492, -2.841981>,
      < 5.085916, -1.841309, -2.828054>,
      < 5.071232, -1.845522, -2.828054>
    }
    triangle {
      < 5.055653, -1.812827, -2.842009>,
      < 5.068623, -1.810492, -2.841981>,
      < 5.071232, -1.845522, -2.828054>
    }
    triangle {
      < 5.055653, -1.812827, -2.842009>,
      < 5.071232, -1.845522, -2.828054>,
      < 5.056104, -1.847651, -2.828054>
    }
    triangle {
      < 5.041276, -1.812829, -2.842010>,
      < 5.055653, -1.812827, -2.842009>,
      < 5.056104, -1.847651, -2.828054>
    }
    triangle {
      < 5.041276, -1.812829, -2.842010>,
      < 5.056104, -1.847651, -2.828054>,
      < 5.040827, -1.847654, -2.828054>
    }
    triangle {
      < 5.028300, -1.810501, -2.841982>,
      < 5.041276, -1.812829, -2.842010>,
      < 5.040827, -1.847654, -2.828054>
    }
    triangle {
      < 5.028300, -1.810501, -2.841982>,
      < 5.040827, -1.847654, -2.828054>,
      < 5.025699, -1.845531, -2.828054>
    }
    triangle {
      < 5.015175, -1.806781, -2.841603>,
      < 5.028300, -1.810501, -2.841982>,
      < 5.025699, -1.845531, -2.828054>
    }
    triangle {
      < 5.015175, -1.806781, -2.841603>,
      < 5.025699, -1.845531, -2.828054>,
      < 5.011013, -1.841323, -2.828054>
    }
    triangle {
      < 5.002964, -1.801868, -2.840937>,
      < 5.015175, -1.806781, -2.841603>,
      < 5.011013, -1.841323, -2.828054>
    }
    triangle {
      < 5.002964, -1.801868, -2.840937>,
      < 5.011013, -1.841323, -2.828054>,
      < 4.997055, -1.835112, -2.828054>
    }
    triangle {
      < 4.991753, -1.796140, -2.839976>,
      < 5.002964, -1.801868, -2.840937>,
      < 4.997055, -1.835112, -2.828054>
    }
    triangle {
      < 4.991753, -1.796140, -2.839976>,
      < 4.997055, -1.835112, -2.828054>,
      < 4.984098, -1.827019, -2.828054>
    }
    triangle {
      < 4.981481, -1.788957, -2.838923>,
      < 4.991753, -1.796140, -2.839976>,
      < 4.984098, -1.827019, -2.828054>
    }
    triangle {
      < 4.981481, -1.788957, -2.838923>,
      < 4.984098, -1.827019, -2.828054>,
      < 4.972393, -1.817202, -2.828054>
    }
    triangle {
      < 4.972484, -1.780896, -2.837770>,
      < 4.981481, -1.788957, -2.838923>,
      < 4.972393, -1.817202, -2.828054>
    }
    triangle {
      < 4.972484, -1.780896, -2.837770>,
      < 4.972393, -1.817202, -2.828054>,
      < 4.962169, -1.805851, -2.828054>
    }
    triangle {
      < 4.964930, -1.772623, -2.836539>,
      < 4.972484, -1.780896, -2.837770>,
      < 4.962169, -1.805851, -2.828054>
    }
    triangle {
      < 4.964930, -1.772623, -2.836539>,
      < 4.962169, -1.805851, -2.828054>,
      < 4.953623, -1.793188, -2.828054>
    }
    triangle {
      < 4.958778, -1.763813, -2.835366>,
      < 4.964930, -1.772623, -2.836539>,
      < 4.953623, -1.793188, -2.828054>
    }
    triangle {
      < 4.958778, -1.763813, -2.835366>,
      < 4.953623, -1.793188, -2.828054>,
      < 4.946923, -1.779458, -2.828054>
    }
    triangle {
      < 4.954325, -1.754914, -2.834394>,
      < 4.958778, -1.763813, -2.835366>,
      < 4.946923, -1.779458, -2.828054>
    }
    triangle {
      < 4.954325, -1.754914, -2.834394>,
      < 4.946923, -1.779458, -2.828054>,
      < 4.942200, -1.764930, -2.828054>
    }
    triangle {
      < 4.951478, -1.745944, -2.833675>,
      < 4.954325, -1.754914, -2.834394>,
      < 4.942200, -1.764930, -2.828054>
    }
    triangle {
      < 4.951478, -1.745944, -2.833675>,
      < 4.942200, -1.764930, -2.828054>,
      < 4.939544, -1.749886, -2.828054>
    }
    triangle {
      < 4.950251, -1.736606, -2.833266>,
      < 4.951478, -1.745944, -2.833675>,
      < 4.939544, -1.749886, -2.828054>
    }
    triangle {
      < 4.950251, -1.736606, -2.833266>,
      < 4.939544, -1.749886, -2.828054>,
      < 4.939007, -1.734618, -2.828054>
    }
    triangle {
      < 4.940600, -1.719425, -2.828054>,
      < 4.950251, -1.736606, -2.833266>,
      < 4.939007, -1.734618, -2.828054>
    }
    triangle {
      < 4.940600, -1.719425, -2.828054>,
      < 4.964806, -1.709989, -2.837276>,
      < 4.971284, -1.720668, -2.840566>
    }
    triangle {
      < 5.132570, -1.741768, -2.838815>,
      < 5.129311, -1.744261, -2.839917>,
      < 5.124737, -1.744842, -2.851637>
    }
    triangle {
      < 5.132570, -1.741768, -2.838815>,
      < 5.124737, -1.744842, -2.851637>,
      < 5.127812, -1.742571, -2.850535>
    }
    triangle {
      < 5.129311, -1.744261, -2.839917>,
      < 5.124606, -1.747297, -2.841394>,
      < 5.120298, -1.747608, -2.853114>
    }
    triangle {
      < 5.129311, -1.744261, -2.839917>,
      < 5.120298, -1.747608, -2.853114>,
      < 5.124737, -1.744842, -2.851637>
    }
    triangle {
      < 5.124606, -1.747297, -2.841394>,
      < 5.118957, -1.750271, -2.843014>,
      < 5.114968, -1.750317, -2.854735>
    }
    triangle {
      < 5.124606, -1.747297, -2.841394>,
      < 5.114968, -1.750317, -2.854735>,
      < 5.120298, -1.747608, -2.853114>
    }
    triangle {
      < 5.118957, -1.750271, -2.843014>,
      < 5.112181, -1.753411, -2.844747>,
      < 5.108576, -1.753178, -2.856467>
    }
    triangle {
      < 5.118957, -1.750271, -2.843014>,
      < 5.108576, -1.753178, -2.856467>,
      < 5.114968, -1.750317, -2.854735>
    }
    triangle {
      < 5.112181, -1.753411, -2.844747>,
      < 5.104347, -1.757434, -2.846415>,
      < 5.101185, -1.756843, -2.858135>
    }
    triangle {
      < 5.112181, -1.753411, -2.844747>,
      < 5.101185, -1.756843, -2.858135>,
      < 5.108576, -1.753178, -2.856467>
    }
    triangle {
      < 5.104347, -1.757434, -2.846415>,
      < 5.095855, -1.760986, -2.847925>,
      < 5.093173, -1.760080, -2.859645>
    }
    triangle {
      < 5.104347, -1.757434, -2.846415>,
      < 5.093173, -1.760080, -2.859645>,
      < 5.101185, -1.756843, -2.858135>
    }
    triangle {
      < 5.095855, -1.760986, -2.847925>,
      < 5.086355, -1.763883, -2.849307>,
      < 5.084210, -1.762718, -2.861027>
    }
    triangle {
      < 5.095855, -1.760986, -2.847925>,
      < 5.084210, -1.762718, -2.861027>,
      < 5.093173, -1.760080, -2.859645>
    }
    triangle {
      < 5.086355, -1.763883, -2.849307>,
      < 5.076283, -1.766977, -2.850321>,
      < 5.074708, -1.765537, -2.862041>
    }
    triangle {
      < 5.086355, -1.763883, -2.849307>,
      < 5.074708, -1.765537, -2.862041>,
      < 5.084210, -1.762718, -2.861027>
    }
    triangle {
      < 5.076283, -1.766977, -2.850321>,
      < 5.065201, -1.769908, -2.850970>,
      < 5.064253, -1.768208, -2.862690>
    }
    triangle {
      < 5.076283, -1.766977, -2.850321>,
      < 5.064253, -1.768208, -2.862690>,
      < 5.074708, -1.765537, -2.862041>
    }
    triangle {
      < 5.065201, -1.769908, -2.850970>,
      < 5.054963, -1.772411, -2.851121>,
      < 5.054595, -1.770488, -2.862842>
    }
    triangle {
      < 5.065201, -1.769908, -2.850970>,
      < 5.054595, -1.770488, -2.862842>,
      < 5.064253, -1.768208, -2.862690>
    }
    triangle {
      < 5.054963, -1.772411, -2.851121>,
      < 5.041962, -1.772412, -2.851122>,
      < 5.042328, -1.770489, -2.862842>
    }
    triangle {
      < 5.054963, -1.772411, -2.851121>,
      < 5.042328, -1.770489, -2.862842>,
      < 5.054595, -1.770488, -2.862842>
    }
    triangle {
      < 5.041962, -1.772412, -2.851122>,
      < 5.031713, -1.769917, -2.850970>,
      < 5.032659, -1.768216, -2.862690>
    }
    triangle {
      < 5.041962, -1.772412, -2.851122>,
      < 5.032659, -1.768216, -2.862690>,
      < 5.042328, -1.770489, -2.862842>
    }
    triangle {
      < 5.031713, -1.769917, -2.850970>,
      < 5.020626, -1.766988, -2.850321>,
      < 5.022200, -1.765548, -2.862041>
    }
    triangle {
      < 5.031713, -1.769917, -2.850970>,
      < 5.022200, -1.765548, -2.862041>,
      < 5.032659, -1.768216, -2.862690>
    }
    triangle {
      < 5.020626, -1.766988, -2.850321>,
      < 5.010549, -1.763898, -2.849308>,
      < 5.012692, -1.762733, -2.861027>
    }
    triangle {
      < 5.020626, -1.766988, -2.850321>,
      < 5.012692, -1.762733, -2.861027>,
      < 5.022200, -1.765548, -2.862041>
    }
    triangle {
      < 5.010549, -1.763898, -2.849308>,
      < 5.001306, -1.761263, -2.847952>,
      < 5.003972, -1.760332, -2.859672>
    }
    triangle {
      < 5.010549, -1.763898, -2.849308>,
      < 5.003972, -1.760332, -2.859672>,
      < 5.012692, -1.762733, -2.861027>
    }
    triangle {
      < 5.001306, -1.761263, -2.847952>,
      < 4.992546, -1.757454, -2.846414>,
      < 4.995708, -1.756862, -2.858134>
    }
    triangle {
      < 5.001306, -1.761263, -2.847952>,
      < 4.995708, -1.756862, -2.858134>,
      < 5.003972, -1.760332, -2.859672>
    }
    triangle {
      < 4.992546, -1.757454, -2.846414>,
      < 4.984708, -1.753434, -2.844745>,
      < 4.988314, -1.753199, -2.856466>
    }
    triangle {
      < 4.992546, -1.757454, -2.846414>,
      < 4.988314, -1.753199, -2.856466>,
      < 4.995708, -1.756862, -2.858134>
    }
    triangle {
      < 4.984708, -1.753434, -2.844745>,
      < 4.977930, -1.750294, -2.843013>,
      < 4.981918, -1.750338, -2.854733>
    }
    triangle {
      < 4.984708, -1.753434, -2.844745>,
      < 4.981918, -1.750338, -2.854733>,
      < 4.988314, -1.753199, -2.856466>
    }
    triangle {
      < 4.977930, -1.750294, -2.843013>,
      < 4.972040, -1.747036, -2.841324>,
      < 4.976361, -1.747370, -2.853045>
    }
    triangle {
      < 4.977930, -1.750294, -2.843013>,
      < 4.976361, -1.747370, -2.853045>,
      < 4.981918, -1.750338, -2.854733>
    }
    triangle {
      < 4.972040, -1.747036, -2.841324>,
      < 4.967573, -1.744281, -2.839914>,
      < 4.972147, -1.744860, -2.851635>
    }
    triangle {
      < 4.972040, -1.747036, -2.841324>,
      < 4.972147, -1.744860, -2.851635>,
      < 4.976361, -1.747370, -2.853045>
    }
    triangle {
      < 4.967573, -1.744281, -2.839914>,
      < 4.964313, -1.741786, -2.838813>,
      < 4.969071, -1.742587, -2.850533>
    }
    triangle {
      < 4.967573, -1.744281, -2.839914>,
      < 4.969071, -1.742587, -2.850533>,
      < 4.972147, -1.744860, -2.851635>
    }
    triangle {
      < 4.964313, -1.741786, -2.838813>,
      < 4.962271, -1.738689, -2.838090>,
      < 4.967145, -1.739766, -2.849810>
    }
    triangle {
      < 4.964313, -1.741786, -2.838813>,
      < 4.967145, -1.739766, -2.849810>,
      < 4.969071, -1.742587, -2.850533>
    }
    triangle {
      < 4.962271, -1.738689, -2.838090>,
      < 4.961631, -1.735803, -2.837837>,
      < 4.966541, -1.737136, -2.849557>
    }
    triangle {
      < 4.962271, -1.738689, -2.838090>,
      < 4.966541, -1.737136, -2.849557>,
      < 4.967145, -1.739766, -2.849810>
    }
    triangle {
      < 4.961631, -1.735803, -2.837837>,
      < 4.965055, -1.728392, -2.838888>,
      < 4.969771, -1.730384, -2.850608>
    }
    triangle {
      < 4.961631, -1.735803, -2.837837>,
      < 4.969771, -1.730384, -2.850608>,
      < 4.966541, -1.737136, -2.849557>
    }
    triangle {
      < 4.965055, -1.728392, -2.838888>,
      < 4.971284, -1.720668, -2.840566>,
      < 4.975648, -1.723348, -2.852286>
    }
    triangle {
      < 4.965055, -1.728392, -2.838888>,
      < 4.975648, -1.723348, -2.852286>,
      < 4.969771, -1.730384, -2.850608>
    }
    triangle {
      < 4.971284, -1.720668, -2.840566>,
      < 4.964806, -1.709989, -2.837276>,
      < 4.969537, -1.713619, -2.848997>
    }
    triangle {
      < 4.971284, -1.720668, -2.840566>,
      < 4.969537, -1.713619, -2.848997>,
      < 4.975648, -1.723348, -2.852286>
    }
    triangle {
      < 4.964806, -1.709989, -2.837276>,
      < 4.978296, -1.709448, -2.841646>,
      < 4.982264, -1.713125, -2.853366>
    }
    triangle {
      < 4.964806, -1.709989, -2.837276>,
      < 4.982264, -1.713125, -2.853366>,
      < 4.969537, -1.713619, -2.848997>
    }
    triangle {
      < 4.978296, -1.709448, -2.841646>,
      < 4.992498, -1.708987, -2.845354>,
      < 4.990989, -1.712705, -2.856261>
    }
    triangle {
      < 4.978296, -1.709448, -2.841646>,
      < 4.990989, -1.712705, -2.856261>,
      < 4.982264, -1.713125, -2.853366>
    }
    triangle {
      < 4.992498, -1.708987, -2.845354>,
      < 5.004886, -1.719217, -2.848936>,
      < 5.003711, -1.722026, -2.859843>
    }
    triangle {
      < 4.992498, -1.708987, -2.845354>,
      < 5.003711, -1.722026, -2.859843>,
      < 4.990989, -1.712705, -2.856261>
    }
    triangle {
      < 5.004886, -1.719217, -2.848936>,
      < 5.019150, -1.719049, -2.851049>,
      < 5.020807, -1.721872, -2.862770>
    }
    triangle {
      < 5.004886, -1.719217, -2.848936>,
      < 5.020807, -1.721872, -2.862770>,
      < 5.003711, -1.722026, -2.859843>
    }
    triangle {
      < 5.019150, -1.719049, -2.851049>,
      < 5.033715, -1.718945, -2.852345>,
      < 5.034548, -1.721778, -2.864064>
    }
    triangle {
      < 5.019150, -1.719049, -2.851049>,
      < 5.034548, -1.721778, -2.864064>,
      < 5.020807, -1.721872, -2.862770>
    }
    triangle {
      < 5.033715, -1.718945, -2.852345>,
      < 5.048434, -1.718909, -2.852781>,
      < 5.048435, -1.721745, -2.864501>
    }
    triangle {
      < 5.033715, -1.718945, -2.852345>,
      < 5.048435, -1.721745, -2.864501>,
      < 5.034548, -1.721778, -2.864064>
    }
    triangle {
      < 5.048434, -1.718909, -2.852781>,
      < 5.063154, -1.718942, -2.852345>,
      < 5.062322, -1.721775, -2.864065>
    }
    triangle {
      < 5.048434, -1.718909, -2.852781>,
      < 5.062322, -1.721775, -2.864065>,
      < 5.048435, -1.721745, -2.864501>
    }
    triangle {
      < 5.063154, -1.718942, -2.852345>,
      < 5.077719, -1.719043, -2.851051>,
      < 5.076063, -1.721867, -2.862772>
    }
    triangle {
      < 5.063154, -1.718942, -2.852345>,
      < 5.076063, -1.721867, -2.862772>,
      < 5.062322, -1.721775, -2.864065>
    }
    triangle {
      < 5.077719, -1.719043, -2.851051>,
      < 5.091983, -1.719208, -2.848939>,
      < 5.093158, -1.722017, -2.859846>
    }
    triangle {
      < 5.077719, -1.719043, -2.851051>,
      < 5.093158, -1.722017, -2.859846>,
      < 5.076063, -1.721867, -2.862772>
    }
    triangle {
      < 5.091983, -1.719208, -2.848939>,
      < 5.104371, -1.708975, -2.845357>,
      < 5.105880, -1.712695, -2.856265>
    }
    triangle {
      < 5.091983, -1.719208, -2.848939>,
      < 5.105880, -1.712695, -2.856265>,
      < 5.093158, -1.722017, -2.859846>
    }
    triangle {
      < 5.104371, -1.708975, -2.845357>,
      < 5.118579, -1.709425, -2.841648>,
      < 5.114612, -1.713105, -2.853368>
    }
    triangle {
      < 5.104371, -1.708975, -2.845357>,
      < 5.114612, -1.713105, -2.853368>,
      < 5.105880, -1.712695, -2.856265>
    }
    triangle {
      < 5.118579, -1.709425, -2.841648>,
      < 5.132073, -1.709956, -2.837276>,
      < 5.127343, -1.713589, -2.848996>
    }
    triangle {
      < 5.118579, -1.709425, -2.841648>,
      < 5.127343, -1.713589, -2.848996>,
      < 5.114612, -1.713105, -2.853368>
    }
    triangle {
      < 5.132073, -1.709956, -2.837276>,
      < 5.125597, -1.720634, -2.840566>,
      < 5.121234, -1.723317, -2.852286>
    }
    triangle {
      < 5.132073, -1.709956, -2.837276>,
      < 5.121234, -1.723317, -2.852286>,
      < 5.127343, -1.713589, -2.848996>
    }
    triangle {
      < 5.125597, -1.720634, -2.840566>,
      < 5.131828, -1.728363, -2.838889>,
      < 5.127112, -1.730358, -2.850609>
    }
    triangle {
      < 5.125597, -1.720634, -2.840566>,
      < 5.127112, -1.730358, -2.850609>,
      < 5.121234, -1.723317, -2.852286>
    }
    triangle {
      < 5.131828, -1.728363, -2.838889>,
      < 5.135253, -1.735762, -2.837839>,
      < 5.130343, -1.737099, -2.849559>
    }
    triangle {
      < 5.131828, -1.728363, -2.838889>,
      < 5.130343, -1.737099, -2.849559>,
      < 5.127112, -1.730358, -2.850609>
    }
    triangle {
      < 5.135253, -1.735762, -2.837839>,
      < 5.134612, -1.738668, -2.838093>,
      < 5.129738, -1.739747, -2.849813>
    }
    triangle {
      < 5.135253, -1.735762, -2.837839>,
      < 5.129738, -1.739747, -2.849813>,
      < 5.130343, -1.737099, -2.849559>
    }
    triangle {
      < 5.134612, -1.738668, -2.838093>,
      < 5.132570, -1.741768, -2.838815>,
      < 5.127812, -1.742571, -2.850535>
    }
    triangle {
      < 5.134612, -1.738668, -2.838093>,
      < 5.127812, -1.742571, -2.850535>,
      < 5.129738, -1.739747, -2.849813>
    }
    texture {brims}
  }
  rotate x*0
  rotate y*0
  rotate z*0
}
