
// This file is a POV V2.0 document that describes
// the image of an A10M airplane. This image was
// converted from A10M.obj found on avalon.chinalake.navy.mil
// by Keith Rule (keithr@lucy1.pen.tek.com).
//
// The original file "a10m.obj" had no comments or restrictions
// associated with it, and no additional restrictions have been
// added to this version of the file.
//
// This file was automatically generated from a10m.obj. Occasional
// warnings will be reported by povray about this file. These
// warnings, though annoying, do not affect the resultant raytraced
// image.

#include "colors.inc"
#include "textures.inc"

camera {
   location  <5, 5, -12>
   direction <0, 0,  1>
   up        <0, 1,  0>
   right   <4/3, 0,  0>
   look_at   <0, 0, 0>
}

light_source {<1, 15, -3> color White}
light_source {<1, 15, 10> color White}
light_source {<1, -15, 2> color White}
light_source {<5, 5, -16> color White}

/* Sky */
sphere { <0, -39000, 0>, 40000
   inverse

   pigment {
      bozo
      turbulence 0.6
      colour_map {
         [0 0.5 colour red 0.4 green 0.5 blue 1
                colour red 0.4 green 0.5 blue 1.0]
         [0.5 0.7 colour red 0.4 green 0.5 blue 1
                  colour red 1 green 1 blue 1.0]
         [0.7 1 colour red 1 green 1 blue 1
                colour red 0.7 green 0.7 blue 0.7]
      }
      scale 500
      quick_color red 0.4 green 0.5 blue 1
   }
   finish {
      ambient 1
      diffuse 0
   }
}

/* Ground */
plane { y, -5000
   pigment { Green }
   finish {
      crand 0.05
      ambient 0.5
      diffuse 0.5
   }
}

// A10M Image start here and continues to the end of the file.

#declare body_texture = texture {pigment{MediumSeaGreen} finish {ambient 0.5 diffuse 0.25 roughness 0.5}}
#declare wheels = texture {pigment{color Black} finish{Metal}}
#declare ordinance1 = texture {pigment{color White} finish {Metal}}
#declare ordinance2 = texture {pigment{color White} finish {Metal}}
#declare cannon = texture {pigment{ color Black } finish {Metal}}
#declare eng1 = texture {pigment{ color Black } finish {Metal}}
#declare eng2 = texture {pigment{color Black} finish{Metal}}
#declare eng2_sc = texture {pigment{color White} finish{Metal}}
#declare parts_turbine = texture {body_texture}
#declare eng1_parts = texture {body_texture}
#declare parts_intake = texture {body_texture}
#declare parts_fuselage = texture {body_texture}
#declare parts_cockpit = texture {Glass}
#declare parts_wings = texture {body_texture}
#declare parts_flaps1 = texture {body_texture}
#declare parts_gearbay = texture {body_texture}
#declare parts_rudder = texture {body_texture}
#declare parts_stabilizers = texture {body_texture}
#declare parts_flaps2 = texture {body_texture}
#declare parts_slings = texture {body_texture}
union {
  // wheels
  union {
    triangle {
      < 1.344794, -0.600999, -2.024494>,
      < 1.338306, -0.600321, -2.024492>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.344811, -0.614393, -1.990766>,
      < 1.335543, -0.613424, -1.990763>,
      < 1.338306, -0.600321, -2.024492>
    }
    triangle {
      < 1.344811, -0.614393, -1.990766>,
      < 1.338306, -0.600321, -2.024492>,
      < 1.344794, -0.600999, -2.024494>
    }
    triangle {
      < 1.344845, -0.679026, -2.008970>,
      < 1.322138, -0.676654, -2.008961>,
      < 1.335543, -0.613424, -1.990763>
    }
    triangle {
      < 1.344845, -0.679026, -2.008970>,
      < 1.335543, -0.613424, -1.990763>,
      < 1.344811, -0.614393, -1.990766>
    }
    triangle {
      < 1.344842, -0.679018, -2.021945>,
      < 1.322135, -0.676646, -2.021936>,
      < 1.322138, -0.676654, -2.008961>
    }
    triangle {
      < 1.344842, -0.679018, -2.021945>,
      < 1.322138, -0.676654, -2.008961>,
      < 1.344845, -0.679026, -2.008970>
    }
    triangle {
      < 1.344854, -0.699079, -2.021958>,
      < 1.317977, -0.696271, -2.021946>,
      < 1.322135, -0.676646, -2.021936>
    }
    triangle {
      < 1.344854, -0.699079, -2.021958>,
      < 1.322135, -0.676646, -2.021936>,
      < 1.344842, -0.679018, -2.021945>
    }
    triangle {
      < 1.344851, -0.707979, -2.050509>,
      < 1.316121, -0.704977, -2.050497>,
      < 1.317977, -0.696271, -2.021946>
    }
    triangle {
      < 1.344851, -0.707979, -2.050509>,
      < 1.317977, -0.696271, -2.021946>,
      < 1.344854, -0.699079, -2.021958>
    }
    triangle {
      < 1.344885, -0.770385, -2.063521>,
      < 1.303179, -0.766029, -2.063504>,
      < 1.316121, -0.704977, -2.050497>
    }
    triangle {
      < 1.344885, -0.770385, -2.063521>,
      < 1.316121, -0.704977, -2.050497>,
      < 1.344851, -0.707979, -2.050509>
    }
    triangle {
      < 1.344911, -0.806060, -2.047971>,
      < 1.295790, -0.800928, -2.047952>,
      < 1.303179, -0.766029, -2.063504>
    }
    triangle {
      < 1.344911, -0.806060, -2.047971>,
      < 1.303179, -0.766029, -2.063504>,
      < 1.344885, -0.770385, -2.063521>
    }
    triangle {
      < 1.344934, -0.832829, -2.014251>,
      < 1.290254, -0.827116, -2.014229>,
      < 1.295790, -0.800928, -2.047952>
    }
    triangle {
      < 1.344934, -0.832829, -2.014251>,
      < 1.295790, -0.800928, -2.047952>,
      < 1.344911, -0.806060, -2.047971>
    }
    triangle {
      < 1.344943, -0.837301, -1.990898>,
      < 1.289336, -0.831491, -1.990876>,
      < 1.290254, -0.827116, -2.014229>
    }
    triangle {
      < 1.344943, -0.837301, -1.990898>,
      < 1.290254, -0.827116, -2.014229>,
      < 1.344934, -0.832829, -2.014251>
    }
    triangle {
      < 1.344949, -0.837315, -1.967543>,
      < 1.289342, -0.831505, -1.967520>,
      < 1.289336, -0.831491, -1.990876>
    }
    triangle {
      < 1.344949, -0.837315, -1.967543>,
      < 1.289336, -0.831491, -1.990876>,
      < 1.344943, -0.837301, -1.990898>
    }
    triangle {
      < 1.338306, -0.600321, -2.024492>,
      < 1.332102, -0.598309, -2.024488>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.335543, -0.613424, -1.990763>,
      < 1.326679, -0.610550, -1.990758>,
      < 1.332102, -0.598309, -2.024488>
    }
    triangle {
      < 1.335543, -0.613424, -1.990763>,
      < 1.332102, -0.598309, -2.024488>,
      < 1.338306, -0.600321, -2.024492>
    }
    triangle {
      < 1.322138, -0.676654, -2.008961>,
      < 1.300422, -0.669613, -2.008949>,
      < 1.326679, -0.610550, -1.990758>
    }
    triangle {
      < 1.322138, -0.676654, -2.008961>,
      < 1.326679, -0.610550, -1.990758>,
      < 1.335543, -0.613424, -1.990763>
    }
    triangle {
      < 1.322135, -0.676646, -2.021936>,
      < 1.300418, -0.669605, -2.021925>,
      < 1.300422, -0.669613, -2.008949>
    }
    triangle {
      < 1.322135, -0.676646, -2.021936>,
      < 1.300422, -0.669613, -2.008949>,
      < 1.322138, -0.676654, -2.008961>
    }
    triangle {
      < 1.317977, -0.696271, -2.021946>,
      < 1.292270, -0.687938, -2.021933>,
      < 1.300418, -0.669605, -2.021925>
    }
    triangle {
      < 1.317977, -0.696271, -2.021946>,
      < 1.300418, -0.669605, -2.021925>,
      < 1.322135, -0.676646, -2.021936>
    }
    triangle {
      < 1.316121, -0.704977, -2.050497>,
      < 1.288642, -0.696069, -2.050482>,
      < 1.292270, -0.687938, -2.021933>
    }
    triangle {
      < 1.316121, -0.704977, -2.050497>,
      < 1.292270, -0.687938, -2.021933>,
      < 1.317977, -0.696271, -2.021946>
    }
    triangle {
      < 1.303179, -0.766029, -2.063504>,
      < 1.263291, -0.753096, -2.063482>,
      < 1.288642, -0.696069, -2.050482>
    }
    triangle {
      < 1.303179, -0.766029, -2.063504>,
      < 1.288642, -0.696069, -2.050482>,
      < 1.316121, -0.704977, -2.050497>
    }
    triangle {
      < 1.295790, -0.800928, -2.047952>,
      < 1.248810, -0.785697, -2.047927>,
      < 1.263291, -0.753096, -2.063482>
    }
    triangle {
      < 1.295790, -0.800928, -2.047952>,
      < 1.263291, -0.753096, -2.063482>,
      < 1.303179, -0.766029, -2.063504>
    }
    triangle {
      < 1.290254, -0.827116, -2.014229>,
      < 1.237955, -0.810161, -2.014201>,
      < 1.248810, -0.785697, -2.047927>
    }
    triangle {
      < 1.290254, -0.827116, -2.014229>,
      < 1.248810, -0.785697, -2.047927>,
      < 1.295790, -0.800928, -2.047952>
    }
    triangle {
      < 1.289336, -0.831491, -1.990876>,
      < 1.236150, -0.814249, -1.990847>,
      < 1.237955, -0.810161, -2.014201>
    }
    triangle {
      < 1.289336, -0.831491, -1.990876>,
      < 1.237955, -0.810161, -2.014201>,
      < 1.290254, -0.827116, -2.014229>
    }
    triangle {
      < 1.289342, -0.831505, -1.967520>,
      < 1.236157, -0.814262, -1.967492>,
      < 1.236150, -0.814249, -1.990847>
    }
    triangle {
      < 1.289342, -0.831505, -1.967520>,
      < 1.236150, -0.814249, -1.990847>,
      < 1.289336, -0.831491, -1.990876>
    }
    triangle {
      < 1.332102, -0.598309, -2.024488>,
      < 1.326451, -0.595052, -2.024484>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.326679, -0.610550, -1.990758>,
      < 1.318606, -0.605897, -1.990752>,
      < 1.326451, -0.595052, -2.024484>
    }
    triangle {
      < 1.326679, -0.610550, -1.990758>,
      < 1.326451, -0.595052, -2.024484>,
      < 1.332102, -0.598309, -2.024488>
    }
    triangle {
      < 1.300422, -0.669613, -2.008949>,
      < 1.280642, -0.658210, -2.008936>,
      < 1.318606, -0.605897, -1.990752>
    }
    triangle {
      < 1.300422, -0.669613, -2.008949>,
      < 1.318606, -0.605897, -1.990752>,
      < 1.326679, -0.610550, -1.990758>
    }
    triangle {
      < 1.300418, -0.669605, -2.021925>,
      < 1.280638, -0.658203, -2.021911>,
      < 1.280642, -0.658210, -2.008936>
    }
    triangle {
      < 1.300418, -0.669605, -2.021925>,
      < 1.280642, -0.658210, -2.008936>,
      < 1.300422, -0.669613, -2.008949>
    }
    triangle {
      < 1.292270, -0.687938, -2.021933>,
      < 1.268858, -0.674442, -2.021917>,
      < 1.280638, -0.658203, -2.021911>
    }
    triangle {
      < 1.292270, -0.687938, -2.021933>,
      < 1.280638, -0.658203, -2.021911>,
      < 1.300418, -0.669605, -2.021925>
    }
    triangle {
      < 1.288642, -0.696069, -2.050482>,
      < 1.263615, -0.681642, -2.050465>,
      < 1.268858, -0.674442, -2.021917>
    }
    triangle {
      < 1.288642, -0.696069, -2.050482>,
      < 1.268858, -0.674442, -2.021917>,
      < 1.292270, -0.687938, -2.021933>
    }
    triangle {
      < 1.263291, -0.753096, -2.063482>,
      < 1.226962, -0.732155, -2.063458>,
      < 1.263615, -0.681642, -2.050465>
    }
    triangle {
      < 1.263291, -0.753096, -2.063482>,
      < 1.263615, -0.681642, -2.050465>,
      < 1.288642, -0.696069, -2.050482>
    }
    triangle {
      < 1.248810, -0.785697, -2.047927>,
      < 1.206022, -0.761033, -2.047897>,
      < 1.226962, -0.732155, -2.063458>
    }
    triangle {
      < 1.248810, -0.785697, -2.047927>,
      < 1.226962, -0.732155, -2.063458>,
      < 1.263291, -0.753096, -2.063482>
    }
    triangle {
      < 1.237955, -0.810161, -2.014201>,
      < 1.190324, -0.782704, -2.014169>,
      < 1.206022, -0.761033, -2.047897>
    }
    triangle {
      < 1.237955, -0.810161, -2.014201>,
      < 1.206022, -0.761033, -2.047897>,
      < 1.248810, -0.785697, -2.047927>
    }
    triangle {
      < 1.236150, -0.814249, -1.990847>,
      < 1.187711, -0.786327, -1.990814>,
      < 1.190324, -0.782704, -2.014169>
    }
    triangle {
      < 1.236150, -0.814249, -1.990847>,
      < 1.190324, -0.782704, -2.014169>,
      < 1.237955, -0.810161, -2.014201>
    }
    triangle {
      < 1.236157, -0.814262, -1.967492>,
      < 1.187718, -0.786340, -1.967458>,
      < 1.187711, -0.786327, -1.990814>
    }
    triangle {
      < 1.236157, -0.814262, -1.967492>,
      < 1.187711, -0.786327, -1.990814>,
      < 1.236150, -0.814249, -1.990847>
    }
    triangle {
      < 1.326451, -0.595052, -2.024484>,
      < 1.321600, -0.590691, -2.024480>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.318606, -0.605897, -1.990752>,
      < 1.311676, -0.599668, -1.990746>,
      < 1.321600, -0.590691, -2.024480>
    }
    triangle {
      < 1.318606, -0.605897, -1.990752>,
      < 1.321600, -0.590691, -2.024480>,
      < 1.326451, -0.595052, -2.024484>
    }
    triangle {
      < 1.280642, -0.658210, -2.008936>,
      < 1.263665, -0.642947, -2.008921>,
      < 1.311676, -0.599668, -1.990746>
    }
    triangle {
      < 1.280642, -0.658210, -2.008936>,
      < 1.311676, -0.599668, -1.990746>,
      < 1.318606, -0.605897, -1.990752>
    }
    triangle {
      < 1.280638, -0.658203, -2.021911>,
      < 1.263662, -0.642939, -2.021896>,
      < 1.263665, -0.642947, -2.008921>
    }
    triangle {
      < 1.280638, -0.658203, -2.021911>,
      < 1.263665, -0.642947, -2.008921>,
      < 1.280642, -0.658210, -2.008936>
    }
    triangle {
      < 1.268858, -0.674442, -2.021917>,
      < 1.248762, -0.656375, -2.021899>,
      < 1.263662, -0.642939, -2.021896>
    }
    triangle {
      < 1.268858, -0.674442, -2.021917>,
      < 1.263662, -0.642939, -2.021896>,
      < 1.280638, -0.658203, -2.021911>
    }
    triangle {
      < 1.263615, -0.681642, -2.050465>,
      < 1.242134, -0.662329, -2.050446>,
      < 1.248762, -0.656375, -2.021899>
    }
    triangle {
      < 1.263615, -0.681642, -2.050465>,
      < 1.248762, -0.656375, -2.021899>,
      < 1.268858, -0.674442, -2.021917>
    }
    triangle {
      < 1.226962, -0.732155, -2.063458>,
      < 1.195778, -0.704119, -2.063430>,
      < 1.242134, -0.662329, -2.050446>
    }
    triangle {
      < 1.226962, -0.732155, -2.063458>,
      < 1.242134, -0.662329, -2.050446>,
      < 1.263615, -0.681642, -2.050465>
    }
    triangle {
      < 1.206022, -0.761033, -2.047897>,
      < 1.169296, -0.728013, -2.047865>,
      < 1.195778, -0.704119, -2.063430>
    }
    triangle {
      < 1.206022, -0.761033, -2.047897>,
      < 1.195778, -0.704119, -2.063430>,
      < 1.226962, -0.732155, -2.063458>
    }
    triangle {
      < 1.190324, -0.782704, -2.014169>,
      < 1.149440, -0.745947, -2.014132>,
      < 1.169296, -0.728013, -2.047865>
    }
    triangle {
      < 1.190324, -0.782704, -2.014169>,
      < 1.169296, -0.728013, -2.047865>,
      < 1.206022, -0.761033, -2.047897>
    }
    triangle {
      < 1.187711, -0.786327, -1.990814>,
      < 1.146135, -0.748946, -1.990777>,
      < 1.149440, -0.745947, -2.014132>
    }
    triangle {
      < 1.187711, -0.786327, -1.990814>,
      < 1.149440, -0.745947, -2.014132>,
      < 1.190324, -0.782704, -2.014169>
    }
    triangle {
      < 1.187718, -0.786340, -1.967458>,
      < 1.146140, -0.748960, -1.967422>,
      < 1.146135, -0.748946, -1.990777>
    }
    triangle {
      < 1.187718, -0.786340, -1.967458>,
      < 1.146135, -0.748946, -1.990777>,
      < 1.187711, -0.786327, -1.990814>
    }
    triangle {
      < 1.321600, -0.590691, -2.024480>,
      < 1.317762, -0.585416, -2.024476>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.311676, -0.599668, -1.990746>,
      < 1.306193, -0.592133, -1.990739>,
      < 1.317762, -0.585416, -2.024476>
    }
    triangle {
      < 1.311676, -0.599668, -1.990746>,
      < 1.317762, -0.585416, -2.024476>,
      < 1.321600, -0.590691, -2.024480>
    }
    triangle {
      < 1.263665, -0.642947, -2.008921>,
      < 1.250231, -0.624488, -2.008905>,
      < 1.306193, -0.592133, -1.990739>
    }
    triangle {
      < 1.263665, -0.642947, -2.008921>,
      < 1.306193, -0.592133, -1.990739>,
      < 1.311676, -0.599668, -1.990746>
    }
    triangle {
      < 1.263662, -0.642939, -2.021896>,
      < 1.250228, -0.624480, -2.021880>,
      < 1.250231, -0.624488, -2.008905>
    }
    triangle {
      < 1.263662, -0.642939, -2.021896>,
      < 1.250231, -0.624488, -2.008905>,
      < 1.263665, -0.642947, -2.008921>
    }
    triangle {
      < 1.248762, -0.656375, -2.021899>,
      < 1.232862, -0.634525, -2.021881>,
      < 1.250228, -0.624480, -2.021880>
    }
    triangle {
      < 1.248762, -0.656375, -2.021899>,
      < 1.250228, -0.624480, -2.021880>,
      < 1.263662, -0.642939, -2.021896>
    }
    triangle {
      < 1.242134, -0.662329, -2.050446>,
      < 1.225136, -0.638972, -2.050426>,
      < 1.232862, -0.634525, -2.021881>
    }
    triangle {
      < 1.242134, -0.662329, -2.050446>,
      < 1.232862, -0.634525, -2.021881>,
      < 1.248762, -0.656375, -2.021899>
    }
    triangle {
      < 1.195778, -0.704119, -2.063430>,
      < 1.171106, -0.670214, -2.063402>,
      < 1.225136, -0.638972, -2.050426>
    }
    triangle {
      < 1.195778, -0.704119, -2.063430>,
      < 1.225136, -0.638972, -2.050426>,
      < 1.242134, -0.662329, -2.050446>
    }
    triangle {
      < 1.169296, -0.728013, -2.047865>,
      < 1.140236, -0.688080, -2.047831>,
      < 1.171106, -0.670214, -2.063402>
    }
    triangle {
      < 1.169296, -0.728013, -2.047865>,
      < 1.171106, -0.670214, -2.063402>,
      < 1.195778, -0.704119, -2.063430>
    }
    triangle {
      < 1.149440, -0.745947, -2.014132>,
      < 1.117090, -0.701494, -2.014095>,
      < 1.140236, -0.688080, -2.047831>
    }
    triangle {
      < 1.149440, -0.745947, -2.014132>,
      < 1.140236, -0.688080, -2.047831>,
      < 1.169296, -0.728013, -2.047865>
    }
    triangle {
      < 1.146135, -0.748946, -1.990777>,
      < 1.113237, -0.703740, -1.990739>,
      < 1.117090, -0.701494, -2.014095>
    }
    triangle {
      < 1.146135, -0.748946, -1.990777>,
      < 1.117090, -0.701494, -2.014095>,
      < 1.149440, -0.745947, -2.014132>
    }
    triangle {
      < 1.146140, -0.748960, -1.967422>,
      < 1.113243, -0.703754, -1.967384>,
      < 1.113237, -0.703740, -1.990739>
    }
    triangle {
      < 1.146140, -0.748960, -1.967422>,
      < 1.113237, -0.703740, -1.990739>,
      < 1.146135, -0.748946, -1.990777>
    }
    triangle {
      < 1.317762, -0.585416, -2.024476>,
      < 1.315104, -0.579459, -2.024472>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.306193, -0.592133, -1.990739>,
      < 1.302396, -0.583623, -1.990733>,
      < 1.315104, -0.579459, -2.024472>
    }
    triangle {
      < 1.306193, -0.592133, -1.990739>,
      < 1.315104, -0.579459, -2.024472>,
      < 1.317762, -0.585416, -2.024476>
    }
    triangle {
      < 1.250231, -0.624488, -2.008905>,
      < 1.240929, -0.603639, -2.008889>,
      < 1.302396, -0.583623, -1.990733>
    }
    triangle {
      < 1.250231, -0.624488, -2.008905>,
      < 1.302396, -0.583623, -1.990733>,
      < 1.306193, -0.592133, -1.990739>
    }
    triangle {
      < 1.250228, -0.624480, -2.021880>,
      < 1.240926, -0.603631, -2.021865>,
      < 1.240929, -0.603639, -2.008889>
    }
    triangle {
      < 1.250228, -0.624480, -2.021880>,
      < 1.240929, -0.603639, -2.008889>,
      < 1.250231, -0.624488, -2.008905>
    }
    triangle {
      < 1.232862, -0.634525, -2.021881>,
      < 1.221850, -0.609847, -2.021862>,
      < 1.240926, -0.603631, -2.021865>
    }
    triangle {
      < 1.232862, -0.634525, -2.021881>,
      < 1.240926, -0.603631, -2.021865>,
      < 1.250228, -0.624480, -2.021880>
    }
    triangle {
      < 1.225136, -0.638972, -2.050426>,
      < 1.213366, -0.612592, -2.050407>,
      < 1.221850, -0.609847, -2.021862>
    }
    triangle {
      < 1.225136, -0.638972, -2.050426>,
      < 1.221850, -0.609847, -2.021862>,
      < 1.232862, -0.634525, -2.021881>
    }
    triangle {
      < 1.171106, -0.670214, -2.063402>,
      < 1.154019, -0.631921, -2.063373>,
      < 1.213366, -0.612592, -2.050407>
    }
    triangle {
      < 1.171106, -0.670214, -2.063402>,
      < 1.213366, -0.612592, -2.050407>,
      < 1.225136, -0.638972, -2.050426>
    }
    triangle {
      < 1.140236, -0.688080, -2.047831>,
      < 1.120112, -0.642979, -2.047798>,
      < 1.154019, -0.631921, -2.063373>
    }
    triangle {
      < 1.140236, -0.688080, -2.047831>,
      < 1.154019, -0.631921, -2.063373>,
      < 1.171106, -0.670214, -2.063402>
    }
    triangle {
      < 1.117090, -0.701494, -2.014095>,
      < 1.094688, -0.651286, -2.014058>,
      < 1.120112, -0.642979, -2.047798>
    }
    triangle {
      < 1.117090, -0.701494, -2.014095>,
      < 1.120112, -0.642979, -2.047798>,
      < 1.140236, -0.688080, -2.047831>
    }
    triangle {
      < 1.113237, -0.703740, -1.990739>,
      < 1.090454, -0.652681, -1.990702>,
      < 1.094688, -0.651286, -2.014058>
    }
    triangle {
      < 1.113237, -0.703740, -1.990739>,
      < 1.094688, -0.651286, -2.014058>,
      < 1.117090, -0.701494, -2.014095>
    }
    triangle {
      < 1.113243, -0.703754, -1.967384>,
      < 1.090461, -0.652695, -1.967345>,
      < 1.090454, -0.652681, -1.990702>
    }
    triangle {
      < 1.113243, -0.703754, -1.967384>,
      < 1.090454, -0.652681, -1.990702>,
      < 1.113237, -0.703740, -1.990739>
    }
    triangle {
      < 1.315104, -0.579459, -2.024472>,
      < 1.313743, -0.573080, -2.024467>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.315104, -0.579459, -2.024472>,
      < 1.346993, -0.569556, -2.024477>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.302396, -0.583623, -1.990733>,
      < 1.300451, -0.574510, -1.990727>,
      < 1.313743, -0.573080, -2.024467>
    }
    triangle {
      < 1.302396, -0.583623, -1.990733>,
      < 1.313743, -0.573080, -2.024467>,
      < 1.315104, -0.579459, -2.024472>
    }
    triangle {
      < 1.240929, -0.603639, -2.008889>,
      < 1.236163, -0.581312, -2.008875>,
      < 1.300451, -0.574510, -1.990727>
    }
    triangle {
      < 1.240929, -0.603639, -2.008889>,
      < 1.300451, -0.574510, -1.990727>,
      < 1.302396, -0.583623, -1.990733>
    }
    triangle {
      < 1.240926, -0.603631, -2.021865>,
      < 1.236159, -0.581304, -2.021850>,
      < 1.236163, -0.581312, -2.008875>
    }
    triangle {
      < 1.240926, -0.603631, -2.021865>,
      < 1.236163, -0.581312, -2.008875>,
      < 1.240929, -0.603639, -2.008889>
    }
    triangle {
      < 1.221850, -0.609847, -2.021862>,
      < 1.216210, -0.583419, -2.021845>,
      < 1.236159, -0.581304, -2.021850>
    }
    triangle {
      < 1.221850, -0.609847, -2.021862>,
      < 1.236159, -0.581304, -2.021850>,
      < 1.240926, -0.603631, -2.021865>
    }
    triangle {
      < 1.213366, -0.612592, -2.050407>,
      < 1.207336, -0.584342, -2.050388>,
      < 1.216210, -0.583419, -2.021845>
    }
    triangle {
      < 1.213366, -0.612592, -2.050407>,
      < 1.216210, -0.583419, -2.021845>,
      < 1.221850, -0.609847, -2.021862>
    }
    triangle {
      < 1.154019, -0.631921, -2.063373>,
      < 1.145266, -0.590912, -2.063346>,
      < 1.207336, -0.584342, -2.050388>
    }
    triangle {
      < 1.154019, -0.631921, -2.063373>,
      < 1.207336, -0.584342, -2.050388>,
      < 1.213366, -0.612592, -2.050407>
    }
    triangle {
      < 1.120112, -0.642979, -2.047798>,
      < 1.109802, -0.594680, -2.047765>,
      < 1.145266, -0.590912, -2.063346>
    }
    triangle {
      < 1.120112, -0.642979, -2.047798>,
      < 1.145266, -0.590912, -2.063346>,
      < 1.154019, -0.631921, -2.063373>
    }
    triangle {
      < 1.094688, -0.651286, -2.014058>,
      < 1.083211, -0.597519, -2.014022>,
      < 1.109802, -0.594680, -2.047765>
    }
    triangle {
      < 1.094688, -0.651286, -2.014058>,
      < 1.109802, -0.594680, -2.047765>,
      < 1.120112, -0.642979, -2.047798>
    }
    triangle {
      < 1.090454, -0.652681, -1.990702>,
      < 1.078785, -0.598003, -1.990664>,
      < 1.083211, -0.597519, -2.014022>
    }
    triangle {
      < 1.090454, -0.652681, -1.990702>,
      < 1.083211, -0.597519, -2.014022>,
      < 1.094688, -0.651286, -2.014058>
    }
    triangle {
      < 1.090461, -0.652695, -1.967345>,
      < 1.078790, -0.598016, -1.967309>,
      < 1.078785, -0.598003, -1.990664>
    }
    triangle {
      < 1.090461, -0.652695, -1.967345>,
      < 1.078785, -0.598003, -1.990664>,
      < 1.090454, -0.652681, -1.990702>
    }
    triangle {
      < 1.313743, -0.573080, -2.024467>,
      < 1.313738, -0.566558, -2.024463>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.300451, -0.574510, -1.990727>,
      < 1.300442, -0.565192, -1.990722>,
      < 1.313738, -0.566558, -2.024463>
    }
    triangle {
      < 1.300451, -0.574510, -1.990727>,
      < 1.313738, -0.566558, -2.024463>,
      < 1.313743, -0.573080, -2.024467>
    }
    triangle {
      < 1.236163, -0.581312, -2.008875>,
      < 1.236143, -0.558482, -2.008862>,
      < 1.300442, -0.565192, -1.990722>
    }
    triangle {
      < 1.236163, -0.581312, -2.008875>,
      < 1.300442, -0.565192, -1.990722>,
      < 1.300451, -0.574510, -1.990727>
    }
    triangle {
      < 1.236159, -0.581304, -2.021850>,
      < 1.236139, -0.558474, -2.021837>,
      < 1.236143, -0.558482, -2.008862>
    }
    triangle {
      < 1.236159, -0.581304, -2.021850>,
      < 1.236143, -0.558482, -2.008862>,
      < 1.236163, -0.581312, -2.008875>
    }
    triangle {
      < 1.216210, -0.583419, -2.021845>,
      < 1.216186, -0.556395, -2.021829>,
      < 1.236139, -0.558474, -2.021837>
    }
    triangle {
      < 1.216210, -0.583419, -2.021845>,
      < 1.236139, -0.558474, -2.021837>,
      < 1.236159, -0.581304, -2.021850>
    }
    triangle {
      < 1.207336, -0.584342, -2.050388>,
      < 1.207310, -0.555455, -2.050371>,
      < 1.216186, -0.556395, -2.021829>
    }
    triangle {
      < 1.207336, -0.584342, -2.050388>,
      < 1.216186, -0.556395, -2.021829>,
      < 1.216210, -0.583419, -2.021845>
    }
    triangle {
      < 1.145266, -0.590912, -2.063346>,
      < 1.145228, -0.548980, -2.063321>,
      < 1.207310, -0.555455, -2.050371>
    }
    triangle {
      < 1.145266, -0.590912, -2.063346>,
      < 1.207310, -0.555455, -2.050371>,
      < 1.207336, -0.584342, -2.050388>
    }
    triangle {
      < 1.109802, -0.594680, -2.047765>,
      < 1.109759, -0.545292, -2.047736>,
      < 1.145228, -0.548980, -2.063321>
    }
    triangle {
      < 1.109802, -0.594680, -2.047765>,
      < 1.145228, -0.548980, -2.063321>,
      < 1.145266, -0.590912, -2.063346>
    }
    triangle {
      < 1.083211, -0.597519, -2.014022>,
      < 1.083163, -0.542541, -2.013989>,
      < 1.109759, -0.545292, -2.047736>
    }
    triangle {
      < 1.083211, -0.597519, -2.014022>,
      < 1.109759, -0.545292, -2.047736>,
      < 1.109802, -0.594680, -2.047765>
    }
    triangle {
      < 1.078785, -0.598003, -1.990664>,
      < 1.078734, -0.542093, -1.990632>,
      < 1.083163, -0.542541, -2.013989>
    }
    triangle {
      < 1.078785, -0.598003, -1.990664>,
      < 1.083163, -0.542541, -2.013989>,
      < 1.083211, -0.597519, -2.014022>
    }
    triangle {
      < 1.078790, -0.598016, -1.967309>,
      < 1.078740, -0.542107, -1.967276>,
      < 1.078734, -0.542093, -1.990632>
    }
    triangle {
      < 1.078790, -0.598016, -1.967309>,
      < 1.078734, -0.542093, -1.990632>,
      < 1.078785, -0.598003, -1.990664>
    }
    triangle {
      < 1.313738, -0.566558, -2.024463>,
      < 1.315087, -0.560176, -2.024460>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.300442, -0.565192, -1.990722>,
      < 1.302372, -0.556074, -1.990717>,
      < 1.315087, -0.560176, -2.024460>
    }
    triangle {
      < 1.300442, -0.565192, -1.990722>,
      < 1.315087, -0.560176, -2.024460>,
      < 1.313738, -0.566558, -2.024463>
    }
    triangle {
      < 1.236143, -0.558482, -2.008862>,
      < 1.240869, -0.536146, -2.008849>,
      < 1.302372, -0.556074, -1.990717>
    }
    triangle {
      < 1.236143, -0.558482, -2.008862>,
      < 1.302372, -0.556074, -1.990717>,
      < 1.300442, -0.565192, -1.990722>
    }
    triangle {
      < 1.236139, -0.558474, -2.021837>,
      < 1.240866, -0.536139, -2.021825>,
      < 1.240869, -0.536146, -2.008849>
    }
    triangle {
      < 1.236139, -0.558474, -2.021837>,
      < 1.240869, -0.536146, -2.008849>,
      < 1.236143, -0.558482, -2.008862>
    }
    triangle {
      < 1.216186, -0.556395, -2.021829>,
      < 1.221779, -0.529958, -2.021815>,
      < 1.240866, -0.536139, -2.021825>
    }
    triangle {
      < 1.216186, -0.556395, -2.021829>,
      < 1.240866, -0.536139, -2.021825>,
      < 1.236139, -0.558474, -2.021837>
    }
    triangle {
      < 1.207310, -0.555455, -2.050371>,
      < 1.213290, -0.527193, -2.050356>,
      < 1.221779, -0.529958, -2.021815>
    }
    triangle {
      < 1.207310, -0.555455, -2.050371>,
      < 1.221779, -0.529958, -2.021815>,
      < 1.216186, -0.556395, -2.021829>
    }
    triangle {
      < 1.145228, -0.548980, -2.063321>,
      < 1.153909, -0.507954, -2.063299>,
      < 1.213290, -0.527193, -2.050356>
    }
    triangle {
      < 1.145228, -0.548980, -2.063321>,
      < 1.213290, -0.527193, -2.050356>,
      < 1.207310, -0.555455, -2.050371>
    }
    triangle {
      < 1.109759, -0.545292, -2.047736>,
      < 1.119982, -0.496975, -2.047710>,
      < 1.153909, -0.507954, -2.063299>
    }
    triangle {
      < 1.109759, -0.545292, -2.047736>,
      < 1.153909, -0.507954, -2.063299>,
      < 1.145228, -0.548980, -2.063321>
    }
    triangle {
      < 1.083163, -0.542541, -2.013989>,
      < 1.094543, -0.488753, -2.013961>,
      < 1.119982, -0.496975, -2.047710>
    }
    triangle {
      < 1.083163, -0.542541, -2.013989>,
      < 1.119982, -0.496975, -2.047710>,
      < 1.109759, -0.545292, -2.047736>
    }
    triangle {
      < 1.078734, -0.542093, -1.990632>,
      < 1.090308, -0.487393, -1.990603>,
      < 1.094543, -0.488753, -2.013961>
    }
    triangle {
      < 1.078734, -0.542093, -1.990632>,
      < 1.094543, -0.488753, -2.013961>,
      < 1.083163, -0.542541, -2.013989>
    }
    triangle {
      < 1.078740, -0.542107, -1.967276>,
      < 1.090314, -0.487407, -1.967248>,
      < 1.090308, -0.487393, -1.990603>
    }
    triangle {
      < 1.078740, -0.542107, -1.967276>,
      < 1.090308, -0.487393, -1.990603>,
      < 1.078734, -0.542093, -1.990632>
    }
    triangle {
      < 1.315087, -0.560176, -2.024460>,
      < 1.317734, -0.554215, -2.024457>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.302372, -0.556074, -1.990717>,
      < 1.306154, -0.547559, -1.990713>,
      < 1.317734, -0.554215, -2.024457>
    }
    triangle {
      < 1.302372, -0.556074, -1.990717>,
      < 1.317734, -0.554215, -2.024457>,
      < 1.315087, -0.560176, -2.024460>
    }
    triangle {
      < 1.240869, -0.536146, -2.008849>,
      < 1.250134, -0.515282, -2.008841>,
      < 1.306154, -0.547559, -1.990713>
    }
    triangle {
      < 1.240869, -0.536146, -2.008849>,
      < 1.306154, -0.547559, -1.990713>,
      < 1.302372, -0.556074, -1.990717>
    }
    triangle {
      < 1.240866, -0.536139, -2.021825>,
      < 1.250130, -0.515274, -2.021816>,
      < 1.250134, -0.515282, -2.008841>
    }
    triangle {
      < 1.240866, -0.536139, -2.021825>,
      < 1.250134, -0.515282, -2.008841>,
      < 1.240869, -0.536146, -2.008849>
    }
    triangle {
      < 1.221779, -0.529958, -2.021815>,
      < 1.232747, -0.505260, -2.021804>,
      < 1.250130, -0.515274, -2.021816>
    }
    triangle {
      < 1.221779, -0.529958, -2.021815>,
      < 1.250130, -0.515274, -2.021816>,
      < 1.240866, -0.536139, -2.021825>
    }
    triangle {
      < 1.213290, -0.527193, -2.050356>,
      < 1.225014, -0.500792, -2.050344>,
      < 1.232747, -0.505260, -2.021804>
    }
    triangle {
      < 1.213290, -0.527193, -2.050356>,
      < 1.232747, -0.505260, -2.021804>,
      < 1.221779, -0.529958, -2.021815>
    }
    triangle {
      < 1.153909, -0.507954, -2.063299>,
      < 1.170927, -0.469631, -2.063282>,
      < 1.225014, -0.500792, -2.050344>
    }
    triangle {
      < 1.153909, -0.507954, -2.063299>,
      < 1.225014, -0.500792, -2.050344>,
      < 1.213290, -0.527193, -2.050356>
    }
    triangle {
      < 1.119982, -0.496975, -2.047710>,
      < 1.140026, -0.451838, -2.047692>,
      < 1.170927, -0.469631, -2.063282>
    }
    triangle {
      < 1.119982, -0.496975, -2.047710>,
      < 1.170927, -0.469631, -2.063282>,
      < 1.153909, -0.507954, -2.063299>
    }
    triangle {
      < 1.094543, -0.488753, -2.013961>,
      < 1.116857, -0.438506, -2.013940>,
      < 1.140026, -0.451838, -2.047692>
    }
    triangle {
      < 1.094543, -0.488753, -2.013961>,
      < 1.140026, -0.451838, -2.047692>,
      < 1.119982, -0.496975, -2.047710>
    }
    triangle {
      < 1.090308, -0.487393, -1.990603>,
      < 1.112999, -0.436295, -1.990581>,
      < 1.116857, -0.438506, -2.013940>
    }
    triangle {
      < 1.090308, -0.487393, -1.990603>,
      < 1.116857, -0.438506, -2.013940>,
      < 1.094543, -0.488753, -2.013961>
    }
    triangle {
      < 1.090314, -0.487407, -1.967248>,
      < 1.113006, -0.436309, -1.967225>,
      < 1.112999, -0.436295, -1.990581>
    }
    triangle {
      < 1.090314, -0.487407, -1.967248>,
      < 1.112999, -0.436295, -1.990581>,
      < 1.090308, -0.487393, -1.990603>
    }
    triangle {
      < 1.317734, -0.554215, -2.024457>,
      < 1.321562, -0.548934, -2.024456>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.306154, -0.547559, -1.990713>,
      < 1.311623, -0.540015, -1.990710>,
      < 1.321562, -0.548934, -2.024456>
    }
    triangle {
      < 1.306154, -0.547559, -1.990713>,
      < 1.321562, -0.548934, -2.024456>,
      < 1.317734, -0.554215, -2.024457>
    }
    triangle {
      < 1.250134, -0.515282, -2.008841>,
      < 1.263535, -0.496798, -2.008835>,
      < 1.311623, -0.540015, -1.990710>
    }
    triangle {
      < 1.250134, -0.515282, -2.008841>,
      < 1.311623, -0.540015, -1.990710>,
      < 1.306154, -0.547559, -1.990713>
    }
    triangle {
      < 1.250130, -0.515274, -2.021816>,
      < 1.263531, -0.496790, -2.021810>,
      < 1.263535, -0.496798, -2.008835>
    }
    triangle {
      < 1.250130, -0.515274, -2.021816>,
      < 1.263535, -0.496798, -2.008835>,
      < 1.250134, -0.515282, -2.008841>
    }
    triangle {
      < 1.232747, -0.505260, -2.021804>,
      < 1.248609, -0.483382, -2.021796>,
      < 1.263531, -0.496790, -2.021810>
    }
    triangle {
      < 1.232747, -0.505260, -2.021804>,
      < 1.263531, -0.496790, -2.021810>,
      < 1.250130, -0.515274, -2.021816>
    }
    triangle {
      < 1.225014, -0.500792, -2.050344>,
      < 1.241969, -0.477405, -2.050337>,
      < 1.248609, -0.483382, -2.021796>
    }
    triangle {
      < 1.225014, -0.500792, -2.050344>,
      < 1.248609, -0.483382, -2.021796>,
      < 1.232747, -0.505260, -2.021804>
    }
    triangle {
      < 1.170927, -0.469631, -2.063282>,
      < 1.195541, -0.435681, -2.063272>,
      < 1.241969, -0.477405, -2.050337>
    }
    triangle {
      < 1.170927, -0.469631, -2.063282>,
      < 1.241969, -0.477405, -2.050337>,
      < 1.225014, -0.500792, -2.050344>
    }
    triangle {
      < 1.140026, -0.451838, -2.047692>,
      < 1.169015, -0.411853, -2.047677>,
      < 1.195541, -0.435681, -2.063272>
    }
    triangle {
      < 1.140026, -0.451838, -2.047692>,
      < 1.195541, -0.435681, -2.063272>,
      < 1.170927, -0.469631, -2.063282>
    }
    triangle {
      < 1.116857, -0.438506, -2.013940>,
      < 1.149127, -0.393996, -2.013924>,
      < 1.169015, -0.411853, -2.047677>
    }
    triangle {
      < 1.116857, -0.438506, -2.013940>,
      < 1.169015, -0.411853, -2.047677>,
      < 1.140026, -0.451838, -2.047692>
    }
    triangle {
      < 1.112999, -0.436295, -1.990581>,
      < 1.145817, -0.391029, -1.990565>,
      < 1.149127, -0.393996, -2.013924>
    }
    triangle {
      < 1.112999, -0.436295, -1.990581>,
      < 1.149127, -0.393996, -2.013924>,
      < 1.116857, -0.438506, -2.013940>
    }
    triangle {
      < 1.113006, -0.436309, -1.967225>,
      < 1.145822, -0.391044, -1.967209>,
      < 1.145817, -0.391029, -1.990565>
    }
    triangle {
      < 1.113006, -0.436309, -1.967225>,
      < 1.145817, -0.391029, -1.990565>,
      < 1.112999, -0.436295, -1.990581>
    }
    triangle {
      < 1.321562, -0.548934, -2.024456>,
      < 1.326406, -0.544564, -2.024454>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.311623, -0.540015, -1.990710>,
      < 1.318542, -0.533772, -1.990709>,
      < 1.326406, -0.544564, -2.024454>
    }
    triangle {
      < 1.311623, -0.540015, -1.990710>,
      < 1.326406, -0.544564, -2.024454>,
      < 1.321562, -0.548934, -2.024456>
    }
    triangle {
      < 1.263535, -0.496798, -2.008835>,
      < 1.280486, -0.481505, -2.008831>,
      < 1.318542, -0.533772, -1.990709>
    }
    triangle {
      < 1.263535, -0.496798, -2.008835>,
      < 1.318542, -0.533772, -1.990709>,
      < 1.311623, -0.540015, -1.990710>
    }
    triangle {
      < 1.263531, -0.496790, -2.021810>,
      < 1.280481, -0.481497, -2.021807>,
      < 1.280486, -0.481505, -2.008831>
    }
    triangle {
      < 1.263531, -0.496790, -2.021810>,
      < 1.280486, -0.481505, -2.008831>,
      < 1.263535, -0.496798, -2.008835>
    }
    triangle {
      < 1.248609, -0.483382, -2.021796>,
      < 1.268672, -0.465278, -2.021792>,
      < 1.280481, -0.481497, -2.021807>
    }
    triangle {
      < 1.248609, -0.483382, -2.021796>,
      < 1.280481, -0.481497, -2.021807>,
      < 1.263531, -0.496790, -2.021810>
    }
    triangle {
      < 1.241969, -0.477405, -2.050337>,
      < 1.263416, -0.458053, -2.050333>,
      < 1.268672, -0.465278, -2.021792>
    }
    triangle {
      < 1.241969, -0.477405, -2.050337>,
      < 1.268672, -0.465278, -2.021792>,
      < 1.248609, -0.483382, -2.021796>
    }
    triangle {
      < 1.195541, -0.435681, -2.063272>,
      < 1.226673, -0.407590, -2.063266>,
      < 1.263416, -0.458053, -2.050333>
    }
    triangle {
      < 1.195541, -0.435681, -2.063272>,
      < 1.263416, -0.458053, -2.050333>,
      < 1.241969, -0.477405, -2.050337>
    }
    triangle {
      < 1.169015, -0.411853, -2.047677>,
      < 1.205682, -0.378768, -2.047671>,
      < 1.226673, -0.407590, -2.063266>
    }
    triangle {
      < 1.169015, -0.411853, -2.047677>,
      < 1.226673, -0.407590, -2.063266>,
      < 1.195541, -0.435681, -2.063272>
    }
    triangle {
      < 1.149127, -0.393996, -2.013924>,
      < 1.189945, -0.357166, -2.013916>,
      < 1.205682, -0.378768, -2.047671>
    }
    triangle {
      < 1.149127, -0.393996, -2.013924>,
      < 1.205682, -0.378768, -2.047671>,
      < 1.169015, -0.411853, -2.047677>
    }
    triangle {
      < 1.145817, -0.391029, -1.990565>,
      < 1.187327, -0.353575, -1.990558>,
      < 1.189945, -0.357166, -2.013916>
    }
    triangle {
      < 1.145817, -0.391029, -1.990565>,
      < 1.189945, -0.357166, -2.013916>,
      < 1.149127, -0.393996, -2.013924>
    }
    triangle {
      < 1.145822, -0.391044, -1.967209>,
      < 1.187334, -0.353589, -1.967201>,
      < 1.187327, -0.353575, -1.990558>
    }
    triangle {
      < 1.145822, -0.391044, -1.967209>,
      < 1.187327, -0.353575, -1.990558>,
      < 1.145817, -0.391029, -1.990565>
    }
    triangle {
      < 1.326406, -0.544564, -2.024454>,
      < 1.332051, -0.541295, -2.024455>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.318542, -0.533772, -1.990709>,
      < 1.326606, -0.529104, -1.990710>,
      < 1.332051, -0.541295, -2.024455>
    }
    triangle {
      < 1.318542, -0.533772, -1.990709>,
      < 1.332051, -0.541295, -2.024455>,
      < 1.326406, -0.544564, -2.024454>
    }
    triangle {
      < 1.280486, -0.481505, -2.008831>,
      < 1.300244, -0.470067, -2.008831>,
      < 1.326606, -0.529104, -1.990710>
    }
    triangle {
      < 1.280486, -0.481505, -2.008831>,
      < 1.326606, -0.529104, -1.990710>,
      < 1.318542, -0.533772, -1.990709>
    }
    triangle {
      < 1.280481, -0.481497, -2.021807>,
      < 1.300240, -0.470060, -2.021806>,
      < 1.300244, -0.470067, -2.008831>
    }
    triangle {
      < 1.280481, -0.481497, -2.021807>,
      < 1.300244, -0.470067, -2.008831>,
      < 1.280486, -0.481505, -2.008831>
    }
    triangle {
      < 1.268672, -0.465278, -2.021792>,
      < 1.292060, -0.451742, -2.021792>,
      < 1.300240, -0.470060, -2.021806>
    }
    triangle {
      < 1.268672, -0.465278, -2.021792>,
      < 1.300240, -0.470060, -2.021806>,
      < 1.280481, -0.481497, -2.021807>
    }
    triangle {
      < 1.263416, -0.458053, -2.050333>,
      < 1.288417, -0.443584, -2.050332>,
      < 1.292060, -0.451742, -2.021792>
    }
    triangle {
      < 1.263416, -0.458053, -2.050333>,
      < 1.292060, -0.451742, -2.021792>,
      < 1.268672, -0.465278, -2.021792>
    }
    triangle {
      < 1.226673, -0.407590, -2.063266>,
      < 1.262965, -0.386585, -2.063265>,
      < 1.288417, -0.443584, -2.050332>
    }
    triangle {
      < 1.226673, -0.407590, -2.063266>,
      < 1.288417, -0.443584, -2.050332>,
      < 1.263416, -0.458053, -2.050333>
    }
    triangle {
      < 1.205682, -0.378768, -2.047671>,
      < 1.248426, -0.354028, -2.047671>,
      < 1.262965, -0.386585, -2.063265>
    }
    triangle {
      < 1.205682, -0.378768, -2.047671>,
      < 1.262965, -0.386585, -2.063265>,
      < 1.226673, -0.407590, -2.063266>
    }
    triangle {
      < 1.189945, -0.357166, -2.013916>,
      < 1.237528, -0.329624, -2.013916>,
      < 1.248426, -0.354028, -2.047671>
    }
    triangle {
      < 1.189945, -0.357166, -2.013916>,
      < 1.248426, -0.354028, -2.047671>,
      < 1.205682, -0.378768, -2.047671>
    }
    triangle {
      < 1.187327, -0.353575, -1.990558>,
      < 1.235716, -0.325568, -1.990557>,
      < 1.237528, -0.329624, -2.013916>
    }
    triangle {
      < 1.187327, -0.353575, -1.990558>,
      < 1.237528, -0.329624, -2.013916>,
      < 1.189945, -0.357166, -2.013916>
    }
    triangle {
      < 1.187334, -0.353589, -1.967201>,
      < 1.235722, -0.325581, -1.967202>,
      < 1.235716, -0.325568, -1.990557>
    }
    triangle {
      < 1.187334, -0.353589, -1.967201>,
      < 1.235716, -0.325568, -1.990557>,
      < 1.187327, -0.353575, -1.990558>
    }
    triangle {
      < 1.332051, -0.541295, -2.024455>,
      < 1.338252, -0.539274, -2.024456>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.332051, -0.541295, -2.024455>,
      < 1.345242, -0.571971, -2.024478>,
      < 1.346993, -0.569556, -2.024477>
    }
    triangle {
      < 1.326606, -0.529104, -1.990710>,
      < 1.335466, -0.526214, -1.990711>,
      < 1.338252, -0.539274, -2.024456>
    }
    triangle {
      < 1.326606, -0.529104, -1.990710>,
      < 1.338252, -0.539274, -2.024456>,
      < 1.332051, -0.541295, -2.024455>
    }
    triangle {
      < 1.300244, -0.470067, -2.008831>,
      < 1.321949, -0.462988, -2.008834>,
      < 1.335466, -0.526214, -1.990711>
    }
    triangle {
      < 1.300244, -0.470067, -2.008831>,
      < 1.335466, -0.526214, -1.990711>,
      < 1.326606, -0.529104, -1.990710>
    }
    triangle {
      < 1.300240, -0.470060, -2.021806>,
      < 1.321946, -0.462981, -2.021810>,
      < 1.321949, -0.462988, -2.008834>
    }
    triangle {
      < 1.300240, -0.470060, -2.021806>,
      < 1.321949, -0.462988, -2.008834>,
      < 1.300244, -0.470067, -2.008831>
    }
    triangle {
      < 1.292060, -0.451742, -2.021792>,
      < 1.317751, -0.443362, -2.021796>,
      < 1.321946, -0.462981, -2.021810>
    }
    triangle {
      < 1.292060, -0.451742, -2.021792>,
      < 1.321946, -0.462981, -2.021810>,
      < 1.300240, -0.470060, -2.021806>
    }
    triangle {
      < 1.288417, -0.443584, -2.050332>,
      < 1.315881, -0.434625, -2.050337>,
      < 1.317751, -0.443362, -2.021796>
    }
    triangle {
      < 1.288417, -0.443584, -2.050332>,
      < 1.317751, -0.443362, -2.021796>,
      < 1.292060, -0.451742, -2.021792>
    }
    triangle {
      < 1.262965, -0.386585, -2.063265>,
      < 1.302830, -0.373582, -2.063271>,
      < 1.315881, -0.434625, -2.050337>
    }
    triangle {
      < 1.262965, -0.386585, -2.063265>,
      < 1.315881, -0.434625, -2.050337>,
      < 1.288417, -0.443584, -2.050332>
    }
    triangle {
      < 1.248426, -0.354028, -2.047671>,
      < 1.295379, -0.338713, -2.047678>,
      < 1.302830, -0.373582, -2.063271>
    }
    triangle {
      < 1.248426, -0.354028, -2.047671>,
      < 1.302830, -0.373582, -2.063271>,
      < 1.262965, -0.386585, -2.063265>
    }
    triangle {
      < 1.237528, -0.329624, -2.013916>,
      < 1.289796, -0.312576, -2.013924>,
      < 1.295379, -0.338713, -2.047678>
    }
    triangle {
      < 1.237528, -0.329624, -2.013916>,
      < 1.295379, -0.338713, -2.047678>,
      < 1.248426, -0.354028, -2.047671>
    }
    triangle {
      < 1.235716, -0.325568, -1.990557>,
      < 1.288870, -0.308230, -1.990566>,
      < 1.289796, -0.312576, -2.013924>
    }
    triangle {
      < 1.235716, -0.325568, -1.990557>,
      < 1.289796, -0.312576, -2.013924>,
      < 1.237528, -0.329624, -2.013916>
    }
    triangle {
      < 1.235722, -0.325581, -1.967202>,
      < 1.288876, -0.308243, -1.967210>,
      < 1.288870, -0.308230, -1.990566>
    }
    triangle {
      < 1.235722, -0.325581, -1.967202>,
      < 1.288870, -0.308230, -1.990566>,
      < 1.235716, -0.325568, -1.990557>
    }
    triangle {
      < 1.338252, -0.539274, -2.024456>,
      < 1.344739, -0.538584, -2.024457>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.335466, -0.526214, -1.990711>,
      < 1.344732, -0.525229, -1.990713>,
      < 1.344739, -0.538584, -2.024457>
    }
    triangle {
      < 1.335466, -0.526214, -1.990711>,
      < 1.344739, -0.538584, -2.024457>,
      < 1.338252, -0.539274, -2.024456>
    }
    triangle {
      < 1.321949, -0.462988, -2.008834>,
      < 1.344650, -0.460575, -2.008840>,
      < 1.344732, -0.525229, -1.990713>
    }
    triangle {
      < 1.321949, -0.462988, -2.008834>,
      < 1.344732, -0.525229, -1.990713>,
      < 1.335466, -0.526214, -1.990711>
    }
    triangle {
      < 1.321946, -0.462981, -2.021810>,
      < 1.344647, -0.460567, -2.021816>,
      < 1.344650, -0.460575, -2.008840>
    }
    triangle {
      < 1.321946, -0.462981, -2.021810>,
      < 1.344650, -0.460575, -2.008840>,
      < 1.321949, -0.462988, -2.008834>
    }
    triangle {
      < 1.317751, -0.443362, -2.021796>,
      < 1.344623, -0.440506, -2.021804>,
      < 1.344647, -0.460567, -2.021816>
    }
    triangle {
      < 1.317751, -0.443362, -2.021796>,
      < 1.344647, -0.460567, -2.021816>,
      < 1.321946, -0.462981, -2.021810>
    }
    triangle {
      < 1.315881, -0.434625, -2.050337>,
      < 1.344605, -0.431572, -2.050345>,
      < 1.344623, -0.440506, -2.021804>
    }
    triangle {
      < 1.315881, -0.434625, -2.050337>,
      < 1.344623, -0.440506, -2.021804>,
      < 1.317751, -0.443362, -2.021796>
    }
    triangle {
      < 1.302830, -0.373582, -2.063271>,
      < 1.344528, -0.369150, -2.063283>,
      < 1.344605, -0.431572, -2.050345>
    }
    triangle {
      < 1.302830, -0.373582, -2.063271>,
      < 1.344605, -0.431572, -2.050345>,
      < 1.315881, -0.434625, -2.050337>
    }
    triangle {
      < 1.295379, -0.338713, -2.047678>,
      < 1.344490, -0.333494, -2.047692>,
      < 1.344528, -0.369150, -2.063283>
    }
    triangle {
      < 1.295379, -0.338713, -2.047678>,
      < 1.344528, -0.369150, -2.063283>,
      < 1.302830, -0.373582, -2.063271>
    }
    triangle {
      < 1.289796, -0.312576, -2.013924>,
      < 1.344467, -0.306766, -2.013940>,
      < 1.344490, -0.333494, -2.047692>
    }
    triangle {
      < 1.289796, -0.312576, -2.013924>,
      < 1.344490, -0.333494, -2.047692>,
      < 1.295379, -0.338713, -2.047678>
    }
    triangle {
      < 1.288870, -0.308230, -1.990566>,
      < 1.344468, -0.302321, -1.990582>,
      < 1.344467, -0.306766, -2.013940>
    }
    triangle {
      < 1.288870, -0.308230, -1.990566>,
      < 1.344467, -0.306766, -2.013940>,
      < 1.289796, -0.312576, -2.013924>
    }
    triangle {
      < 1.288876, -0.308243, -1.967210>,
      < 1.344474, -0.302335, -1.967226>,
      < 1.344468, -0.302321, -1.990582>
    }
    triangle {
      < 1.288876, -0.308243, -1.967210>,
      < 1.344468, -0.302321, -1.990582>,
      < 1.288870, -0.308230, -1.990566>
    }
    triangle {
      < 1.344739, -0.538584, -2.024457>,
      < 1.351226, -0.539258, -2.024460>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.344732, -0.525229, -1.990713>,
      < 1.354000, -0.526193, -1.990718>,
      < 1.351226, -0.539258, -2.024460>
    }
    triangle {
      < 1.344732, -0.525229, -1.990713>,
      < 1.351226, -0.539258, -2.024460>,
      < 1.344739, -0.538584, -2.024457>
    }
    triangle {
      < 1.344650, -0.460575, -2.008840>,
      < 1.367358, -0.462934, -2.008850>,
      < 1.354000, -0.526193, -1.990718>
    }
    triangle {
      < 1.344650, -0.460575, -2.008840>,
      < 1.354000, -0.526193, -1.990718>,
      < 1.344732, -0.525229, -1.990713>
    }
    triangle {
      < 1.344647, -0.460567, -2.021816>,
      < 1.367355, -0.462926, -2.021825>,
      < 1.367358, -0.462934, -2.008850>
    }
    triangle {
      < 1.344647, -0.460567, -2.021816>,
      < 1.367358, -0.462934, -2.008850>,
      < 1.344650, -0.460575, -2.008840>
    }
    triangle {
      < 1.344623, -0.440506, -2.021804>,
      < 1.371502, -0.443298, -2.021816>,
      < 1.367355, -0.462926, -2.021825>
    }
    triangle {
      < 1.344623, -0.440506, -2.021804>,
      < 1.367355, -0.462926, -2.021825>,
      < 1.344647, -0.460567, -2.021816>
    }
    triangle {
      < 1.344605, -0.431572, -2.050345>,
      < 1.373338, -0.434558, -2.050357>,
      < 1.371502, -0.443298, -2.021816>
    }
    triangle {
      < 1.344605, -0.431572, -2.050345>,
      < 1.371502, -0.443298, -2.021816>,
      < 1.344623, -0.440506, -2.021804>
    }
    triangle {
      < 1.344528, -0.369150, -2.063283>,
      < 1.386236, -0.373483, -2.063300>,
      < 1.373338, -0.434558, -2.050357>
    }
    triangle {
      < 1.344528, -0.369150, -2.063283>,
      < 1.373338, -0.434558, -2.050357>,
      < 1.344605, -0.431572, -2.050345>
    }
    triangle {
      < 1.344490, -0.333494, -2.047692>,
      < 1.393614, -0.338598, -2.047712>,
      < 1.386236, -0.373483, -2.063300>
    }
    triangle {
      < 1.344490, -0.333494, -2.047692>,
      < 1.386236, -0.373483, -2.063300>,
      < 1.344528, -0.369150, -2.063283>
    }
    triangle {
      < 1.344467, -0.306766, -2.013940>,
      < 1.399150, -0.312446, -2.013962>,
      < 1.393614, -0.338598, -2.047712>
    }
    triangle {
      < 1.344467, -0.306766, -2.013940>,
      < 1.393614, -0.338598, -2.047712>,
      < 1.344490, -0.333494, -2.047692>
    }
    triangle {
      < 1.344468, -0.302321, -1.990582>,
      < 1.400078, -0.308098, -1.990604>,
      < 1.399150, -0.312446, -2.013962>
    }
    triangle {
      < 1.344468, -0.302321, -1.990582>,
      < 1.399150, -0.312446, -2.013962>,
      < 1.344467, -0.306766, -2.013940>
    }
    triangle {
      < 1.344474, -0.302335, -1.967226>,
      < 1.400084, -0.308112, -1.967248>,
      < 1.400078, -0.308098, -1.990604>
    }
    triangle {
      < 1.344474, -0.302335, -1.967226>,
      < 1.400078, -0.308098, -1.990604>,
      < 1.344468, -0.302321, -1.990582>
    }
    triangle {
      < 1.351226, -0.539258, -2.024460>,
      < 1.357434, -0.541267, -2.024464>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.354000, -0.526193, -1.990718>,
      < 1.362866, -0.529061, -1.990722>,
      < 1.357434, -0.541267, -2.024464>
    }
    triangle {
      < 1.354000, -0.526193, -1.990718>,
      < 1.357434, -0.541267, -2.024464>,
      < 1.351226, -0.539258, -2.024460>
    }
    triangle {
      < 1.367358, -0.462934, -2.008850>,
      < 1.389080, -0.469962, -2.008862>,
      < 1.362866, -0.529061, -1.990722>
    }
    triangle {
      < 1.367358, -0.462934, -2.008850>,
      < 1.362866, -0.529061, -1.990722>,
      < 1.354000, -0.526193, -1.990718>
    }
    triangle {
      < 1.367355, -0.462926, -2.021825>,
      < 1.389076, -0.469954, -2.021837>,
      < 1.389080, -0.469962, -2.008862>
    }
    triangle {
      < 1.367355, -0.462926, -2.021825>,
      < 1.389080, -0.469962, -2.008862>,
      < 1.367358, -0.462934, -2.008850>
    }
    triangle {
      < 1.371502, -0.443298, -2.021816>,
      < 1.397213, -0.451617, -2.021829>,
      < 1.389076, -0.469954, -2.021837>
    }
    triangle {
      < 1.371502, -0.443298, -2.021816>,
      < 1.389076, -0.469954, -2.021837>,
      < 1.367355, -0.462926, -2.021825>
    }
    triangle {
      < 1.373338, -0.434558, -2.050357>,
      < 1.400822, -0.443449, -2.050371>,
      < 1.397213, -0.451617, -2.021829>
    }
    triangle {
      < 1.373338, -0.434558, -2.050357>,
      < 1.397213, -0.451617, -2.021829>,
      < 1.371502, -0.443298, -2.021816>
    }
    triangle {
      < 1.386236, -0.373483, -2.063300>,
      < 1.426133, -0.386392, -2.063322>,
      < 1.400822, -0.443449, -2.050371>
    }
    triangle {
      < 1.386236, -0.373483, -2.063300>,
      < 1.400822, -0.443449, -2.050371>,
      < 1.373338, -0.434558, -2.050357>
    }
    triangle {
      < 1.393614, -0.338598, -2.047712>,
      < 1.440602, -0.353801, -2.047737>,
      < 1.426133, -0.386392, -2.063322>
    }
    triangle {
      < 1.393614, -0.338598, -2.047712>,
      < 1.426133, -0.386392, -2.063322>,
      < 1.386236, -0.373483, -2.063300>
    }
    triangle {
      < 1.399150, -0.312446, -2.013962>,
      < 1.451460, -0.329370, -2.013990>,
      < 1.440602, -0.353801, -2.047737>
    }
    triangle {
      < 1.399150, -0.312446, -2.013962>,
      < 1.440602, -0.353801, -2.047737>,
      < 1.393614, -0.338598, -2.047712>
    }
    triangle {
      < 1.400078, -0.308098, -1.990604>,
      < 1.453274, -0.325309, -1.990632>,
      < 1.451460, -0.329370, -2.013990>
    }
    triangle {
      < 1.400078, -0.308098, -1.990604>,
      < 1.451460, -0.329370, -2.013990>,
      < 1.399150, -0.312446, -2.013962>
    }
    triangle {
      < 1.400084, -0.308112, -1.967248>,
      < 1.453280, -0.325323, -1.967276>,
      < 1.453274, -0.325309, -1.990632>
    }
    triangle {
      < 1.400084, -0.308112, -1.967248>,
      < 1.453274, -0.325309, -1.990632>,
      < 1.400078, -0.308098, -1.990604>
    }
    triangle {
      < 1.357434, -0.541267, -2.024464>,
      < 1.363086, -0.544520, -2.024467>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.362866, -0.529061, -1.990722>,
      < 1.370942, -0.533710, -1.990728>,
      < 1.363086, -0.544520, -2.024467>
    }
    triangle {
      < 1.362866, -0.529061, -1.990722>,
      < 1.363086, -0.544520, -2.024467>,
      < 1.357434, -0.541267, -2.024464>
    }
    triangle {
      < 1.389080, -0.469962, -2.008862>,
      < 1.408866, -0.481351, -2.008876>,
      < 1.370942, -0.533710, -1.990728>
    }
    triangle {
      < 1.389080, -0.469962, -2.008862>,
      < 1.370942, -0.533710, -1.990728>,
      < 1.362866, -0.529061, -1.990722>
    }
    triangle {
      < 1.389076, -0.469954, -2.021837>,
      < 1.408862, -0.481344, -2.021851>,
      < 1.408866, -0.481351, -2.008876>
    }
    triangle {
      < 1.389076, -0.469954, -2.021837>,
      < 1.408866, -0.481351, -2.008876>,
      < 1.389080, -0.469962, -2.008862>
    }
    triangle {
      < 1.397213, -0.451617, -2.021829>,
      < 1.420633, -0.465099, -2.021845>,
      < 1.408862, -0.481344, -2.021851>
    }
    triangle {
      < 1.397213, -0.451617, -2.021829>,
      < 1.408862, -0.481344, -2.021851>,
      < 1.389076, -0.469954, -2.021837>
    }
    triangle {
      < 1.400822, -0.443449, -2.050371>,
      < 1.425858, -0.457861, -2.050388>,
      < 1.420633, -0.465099, -2.021845>
    }
    triangle {
      < 1.400822, -0.443449, -2.050371>,
      < 1.420633, -0.465099, -2.021845>,
      < 1.397213, -0.451617, -2.021829>
    }
    triangle {
      < 1.426133, -0.386392, -2.063322>,
      < 1.462474, -0.407312, -2.063346>,
      < 1.425858, -0.457861, -2.050388>
    }
    triangle {
      < 1.426133, -0.386392, -2.063322>,
      < 1.425858, -0.457861, -2.050388>,
      < 1.400822, -0.443449, -2.050371>
    }
    triangle {
      < 1.440602, -0.353801, -2.047737>,
      < 1.483404, -0.378439, -2.047766>,
      < 1.462474, -0.407312, -2.063346>
    }
    triangle {
      < 1.440602, -0.353801, -2.047737>,
      < 1.462474, -0.407312, -2.063346>,
      < 1.426133, -0.386392, -2.063322>
    }
    triangle {
      < 1.451460, -0.329370, -2.013990>,
      < 1.499107, -0.356799, -2.014023>,
      < 1.483404, -0.378439, -2.047766>
    }
    triangle {
      < 1.451460, -0.329370, -2.013990>,
      < 1.483404, -0.378439, -2.047766>,
      < 1.440602, -0.353801, -2.047737>
    }
    triangle {
      < 1.453274, -0.325309, -1.990632>,
      < 1.501729, -0.353203, -1.990665>,
      < 1.499107, -0.356799, -2.014023>
    }
    triangle {
      < 1.453274, -0.325309, -1.990632>,
      < 1.499107, -0.356799, -2.014023>,
      < 1.451460, -0.329370, -2.013990>
    }
    triangle {
      < 1.453280, -0.325323, -1.967276>,
      < 1.501734, -0.353216, -1.967310>,
      < 1.501729, -0.353203, -1.990665>
    }
    triangle {
      < 1.453280, -0.325323, -1.967276>,
      < 1.501729, -0.353203, -1.990665>,
      < 1.453274, -0.325309, -1.990632>
    }
    triangle {
      < 1.363086, -0.544520, -2.024467>,
      < 1.367939, -0.548879, -2.024472>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.370942, -0.533710, -1.990728>,
      < 1.377875, -0.539936, -1.990734>,
      < 1.367939, -0.548879, -2.024472>
    }
    triangle {
      < 1.370942, -0.533710, -1.990728>,
      < 1.367939, -0.548879, -2.024472>,
      < 1.363086, -0.544520, -2.024467>
    }
    triangle {
      < 1.408866, -0.481351, -2.008876>,
      < 1.425852, -0.496606, -2.008890>,
      < 1.377875, -0.539936, -1.990734>
    }
    triangle {
      < 1.408866, -0.481351, -2.008876>,
      < 1.377875, -0.539936, -1.990734>,
      < 1.370942, -0.533710, -1.990728>
    }
    triangle {
      < 1.408862, -0.481344, -2.021851>,
      < 1.425849, -0.496598, -2.021866>,
      < 1.425852, -0.496606, -2.008890>
    }
    triangle {
      < 1.408862, -0.481344, -2.021851>,
      < 1.425852, -0.496606, -2.008890>,
      < 1.408866, -0.481351, -2.008876>
    }
    triangle {
      < 1.420633, -0.465099, -2.021845>,
      < 1.440739, -0.483154, -2.021863>,
      < 1.425849, -0.496598, -2.021866>
    }
    triangle {
      < 1.420633, -0.465099, -2.021845>,
      < 1.425849, -0.496598, -2.021866>,
      < 1.408862, -0.481344, -2.021851>
    }
    triangle {
      < 1.425858, -0.457861, -2.050388>,
      < 1.447350, -0.477162, -2.050407>,
      < 1.440739, -0.483154, -2.021863>
    }
    triangle {
      < 1.425858, -0.457861, -2.050388>,
      < 1.440739, -0.483154, -2.021863>,
      < 1.420633, -0.465099, -2.021845>
    }
    triangle {
      < 1.462474, -0.407312, -2.063346>,
      < 1.493673, -0.435329, -2.063374>,
      < 1.447350, -0.477162, -2.050407>
    }
    triangle {
      < 1.462474, -0.407312, -2.063346>,
      < 1.447350, -0.477162, -2.050407>,
      < 1.425858, -0.457861, -2.050388>
    }
    triangle {
      < 1.483404, -0.378439, -2.047766>,
      < 1.520150, -0.411437, -2.047799>,
      < 1.493673, -0.435329, -2.063374>
    }
    triangle {
      < 1.483404, -0.378439, -2.047766>,
      < 1.493673, -0.435329, -2.063374>,
      < 1.462474, -0.407312, -2.063346>
    }
    triangle {
      < 1.499107, -0.356799, -2.014023>,
      < 1.540013, -0.393532, -2.014058>,
      < 1.520150, -0.411437, -2.047799>
    }
    triangle {
      < 1.499107, -0.356799, -2.014023>,
      < 1.520150, -0.411437, -2.047799>,
      < 1.483404, -0.378439, -2.047766>
    }
    triangle {
      < 1.501729, -0.353203, -1.990665>,
      < 1.543328, -0.390558, -1.990702>,
      < 1.540013, -0.393532, -2.014058>
    }
    triangle {
      < 1.501729, -0.353203, -1.990665>,
      < 1.540013, -0.393532, -2.014058>,
      < 1.499107, -0.356799, -2.014023>
    }
    triangle {
      < 1.501734, -0.353216, -1.967310>,
      < 1.543334, -0.390572, -1.967346>,
      < 1.543328, -0.390558, -1.990702>
    }
    triangle {
      < 1.501734, -0.353216, -1.967310>,
      < 1.543328, -0.390558, -1.990702>,
      < 1.501729, -0.353203, -1.990665>
    }
    triangle {
      < 1.367939, -0.548879, -2.024472>,
      < 1.371781, -0.554151, -2.024476>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.377875, -0.539936, -1.990734>,
      < 1.383362, -0.547467, -1.990740>,
      < 1.371781, -0.554151, -2.024476>
    }
    triangle {
      < 1.377875, -0.539936, -1.990734>,
      < 1.371781, -0.554151, -2.024476>,
      < 1.367939, -0.548879, -2.024472>
    }
    triangle {
      < 1.425852, -0.496606, -2.008890>,
      < 1.439296, -0.515058, -2.008905>,
      < 1.383362, -0.547467, -1.990740>
    }
    triangle {
      < 1.425852, -0.496606, -2.008890>,
      < 1.383362, -0.547467, -1.990740>,
      < 1.377875, -0.539936, -1.990734>
    }
    triangle {
      < 1.425849, -0.496598, -2.021866>,
      < 1.439293, -0.515050, -2.021881>,
      < 1.439296, -0.515058, -2.008905>
    }
    triangle {
      < 1.425849, -0.496598, -2.021866>,
      < 1.439296, -0.515058, -2.008905>,
      < 1.425852, -0.496606, -2.008890>
    }
    triangle {
      < 1.440739, -0.483154, -2.021863>,
      < 1.456653, -0.504995, -2.021881>,
      < 1.439293, -0.515050, -2.021881>
    }
    triangle {
      < 1.440739, -0.483154, -2.021863>,
      < 1.439293, -0.515050, -2.021881>,
      < 1.425849, -0.496598, -2.021866>
    }
    triangle {
      < 1.447350, -0.477162, -2.050407>,
      < 1.464361, -0.500508, -2.050427>,
      < 1.456653, -0.504995, -2.021881>
    }
    triangle {
      < 1.447350, -0.477162, -2.050407>,
      < 1.456653, -0.504995, -2.021881>,
      < 1.440739, -0.483154, -2.021863>
    }
    triangle {
      < 1.493673, -0.435329, -2.063374>,
      < 1.518367, -0.469219, -2.063402>,
      < 1.464361, -0.500508, -2.050427>
    }
    triangle {
      < 1.493673, -0.435329, -2.063374>,
      < 1.464361, -0.500508, -2.050427>,
      < 1.447350, -0.477162, -2.050407>
    }
    triangle {
      < 1.520150, -0.411437, -2.047799>,
      < 1.549234, -0.451352, -2.047832>,
      < 1.518367, -0.469219, -2.063402>
    }
    triangle {
      < 1.520150, -0.411437, -2.047799>,
      < 1.518367, -0.469219, -2.063402>,
      < 1.493673, -0.435329, -2.063374>
    }
    triangle {
      < 1.540013, -0.393532, -2.014058>,
      < 1.572389, -0.437966, -2.014096>,
      < 1.549234, -0.451352, -2.047832>
    }
    triangle {
      < 1.540013, -0.393532, -2.014058>,
      < 1.549234, -0.451352, -2.047832>,
      < 1.520150, -0.411437, -2.047799>
    }
    triangle {
      < 1.543328, -0.390558, -1.990702>,
      < 1.576253, -0.435745, -1.990740>,
      < 1.572389, -0.437966, -2.014096>
    }
    triangle {
      < 1.543328, -0.390558, -1.990702>,
      < 1.572389, -0.437966, -2.014096>,
      < 1.540013, -0.393532, -2.014058>
    }
    triangle {
      < 1.543334, -0.390572, -1.967346>,
      < 1.576259, -0.435759, -1.967384>,
      < 1.576253, -0.435745, -1.990740>
    }
    triangle {
      < 1.543334, -0.390572, -1.967346>,
      < 1.576253, -0.435745, -1.990740>,
      < 1.543328, -0.390558, -1.990702>
    }
    triangle {
      < 1.371781, -0.554151, -2.024476>,
      < 1.374442, -0.560106, -2.024480>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.371781, -0.554151, -2.024476>,
      < 1.342657, -0.570483, -2.024476>,
      < 1.345242, -0.571971, -2.024478>
    }
    triangle {
      < 1.383362, -0.547467, -1.990740>,
      < 1.387165, -0.555975, -1.990746>,
      < 1.374442, -0.560106, -2.024480>
    }
    triangle {
      < 1.383362, -0.547467, -1.990740>,
      < 1.374442, -0.560106, -2.024480>,
      < 1.371781, -0.554151, -2.024476>
    }
    triangle {
      < 1.439296, -0.515058, -2.008905>,
      < 1.448611, -0.535900, -2.008921>,
      < 1.387165, -0.555975, -1.990746>
    }
    triangle {
      < 1.439296, -0.515058, -2.008905>,
      < 1.387165, -0.555975, -1.990746>,
      < 1.383362, -0.547467, -1.990740>
    }
    triangle {
      < 1.439293, -0.515050, -2.021881>,
      < 1.448608, -0.535893, -2.021896>,
      < 1.448611, -0.535900, -2.008921>
    }
    triangle {
      < 1.439293, -0.515050, -2.021881>,
      < 1.448611, -0.535900, -2.008921>,
      < 1.439296, -0.515058, -2.008905>
    }
    triangle {
      < 1.456653, -0.504995, -2.021881>,
      < 1.467678, -0.529666, -2.021899>,
      < 1.448608, -0.535893, -2.021896>
    }
    triangle {
      < 1.456653, -0.504995, -2.021881>,
      < 1.448608, -0.535893, -2.021896>,
      < 1.439293, -0.515050, -2.021881>
    }
    triangle {
      < 1.464361, -0.500508, -2.050427>,
      < 1.476147, -0.526882, -2.050447>,
      < 1.467678, -0.529666, -2.021899>
    }
    triangle {
      < 1.464361, -0.500508, -2.050427>,
      < 1.467678, -0.529666, -2.021899>,
      < 1.456653, -0.504995, -2.021881>
    }
    triangle {
      < 1.518367, -0.469219, -2.063402>,
      < 1.535477, -0.507503, -2.063431>,
      < 1.476147, -0.526882, -2.050447>
    }
    triangle {
      < 1.518367, -0.469219, -2.063402>,
      < 1.476147, -0.526882, -2.050447>,
      < 1.464361, -0.500508, -2.050427>
    }
    triangle {
      < 1.549234, -0.451352, -2.047832>,
      < 1.569384, -0.496443, -2.047866>,
      < 1.535477, -0.507503, -2.063431>
    }
    triangle {
      < 1.549234, -0.451352, -2.047832>,
      < 1.535477, -0.507503, -2.063431>,
      < 1.518367, -0.469219, -2.063402>
    }
    triangle {
      < 1.572389, -0.437966, -2.014096>,
      < 1.594821, -0.488160, -2.014133>,
      < 1.569384, -0.496443, -2.047866>
    }
    triangle {
      < 1.572389, -0.437966, -2.014096>,
      < 1.569384, -0.496443, -2.047866>,
      < 1.549234, -0.451352, -2.047832>
    }
    triangle {
      < 1.576253, -0.435745, -1.990740>,
      < 1.599065, -0.486791, -1.990779>,
      < 1.594821, -0.488160, -2.014133>
    }
    triangle {
      < 1.576253, -0.435745, -1.990740>,
      < 1.594821, -0.488160, -2.014133>,
      < 1.572389, -0.437966, -2.014096>
    }
    triangle {
      < 1.576259, -0.435759, -1.967384>,
      < 1.599070, -0.486804, -1.967423>,
      < 1.599065, -0.486791, -1.990779>
    }
    triangle {
      < 1.576259, -0.435759, -1.967384>,
      < 1.599065, -0.486791, -1.990779>,
      < 1.576253, -0.435745, -1.990740>
    }
    triangle {
      < 1.374442, -0.560106, -2.024480>,
      < 1.375807, -0.566484, -2.024485>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.387165, -0.555975, -1.990746>,
      < 1.389115, -0.565086, -1.990752>,
      < 1.375807, -0.566484, -2.024485>
    }
    triangle {
      < 1.387165, -0.555975, -1.990746>,
      < 1.375807, -0.566484, -2.024485>,
      < 1.374442, -0.560106, -2.024480>
    }
    triangle {
      < 1.448611, -0.535900, -2.008921>,
      < 1.453390, -0.558224, -2.008936>,
      < 1.389115, -0.565086, -1.990752>
    }
    triangle {
      < 1.448611, -0.535900, -2.008921>,
      < 1.389115, -0.565086, -1.990752>,
      < 1.387165, -0.555975, -1.990746>
    }
    triangle {
      < 1.448608, -0.535893, -2.021896>,
      < 1.453386, -0.558216, -2.021912>,
      < 1.453390, -0.558224, -2.008936>
    }
    triangle {
      < 1.448608, -0.535893, -2.021896>,
      < 1.453390, -0.558224, -2.008936>,
      < 1.448611, -0.535900, -2.008921>
    }
    triangle {
      < 1.467678, -0.529666, -2.021899>,
      < 1.473335, -0.556091, -2.021917>,
      < 1.453386, -0.558216, -2.021912>
    }
    triangle {
      < 1.467678, -0.529666, -2.021899>,
      < 1.453386, -0.558216, -2.021912>,
      < 1.448608, -0.535893, -2.021896>
    }
    triangle {
      < 1.476147, -0.526882, -2.050447>,
      < 1.482194, -0.555128, -2.050465>,
      < 1.473335, -0.556091, -2.021917>
    }
    triangle {
      < 1.476147, -0.526882, -2.050447>,
      < 1.473335, -0.556091, -2.021917>,
      < 1.467678, -0.529666, -2.021899>
    }
    triangle {
      < 1.535477, -0.507503, -2.063431>,
      < 1.544254, -0.548506, -2.063458>,
      < 1.482194, -0.555128, -2.050465>
    }
    triangle {
      < 1.535477, -0.507503, -2.063431>,
      < 1.482194, -0.555128, -2.050465>,
      < 1.476147, -0.526882, -2.050447>
    }
    triangle {
      < 1.569384, -0.496443, -2.047866>,
      < 1.579722, -0.544736, -2.047897>,
      < 1.544254, -0.548506, -2.063458>
    }
    triangle {
      < 1.569384, -0.496443, -2.047866>,
      < 1.544254, -0.548506, -2.063458>,
      < 1.535477, -0.507503, -2.063431>
    }
    triangle {
      < 1.594821, -0.488160, -2.014133>,
      < 1.606329, -0.541920, -2.014169>,
      < 1.579722, -0.544736, -2.047897>
    }
    triangle {
      < 1.594821, -0.488160, -2.014133>,
      < 1.579722, -0.544736, -2.047897>,
      < 1.569384, -0.496443, -2.047866>
    }
    triangle {
      < 1.599065, -0.486791, -1.990779>,
      < 1.610769, -0.541462, -1.990815>,
      < 1.606329, -0.541920, -2.014169>
    }
    triangle {
      < 1.599065, -0.486791, -1.990779>,
      < 1.606329, -0.541920, -2.014169>,
      < 1.594821, -0.488160, -2.014133>
    }
    triangle {
      < 1.599070, -0.486804, -1.967423>,
      < 1.610774, -0.541476, -1.967459>,
      < 1.610769, -0.541462, -1.990815>
    }
    triangle {
      < 1.599070, -0.486804, -1.967423>,
      < 1.610769, -0.541462, -1.990815>,
      < 1.599065, -0.486791, -1.990779>
    }
    triangle {
      < 1.375807, -0.566484, -2.024485>,
      < 1.375817, -0.573007, -2.024488>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.389115, -0.565086, -1.990752>,
      < 1.389129, -0.574405, -1.990758>,
      < 1.375817, -0.573007, -2.024488>
    }
    triangle {
      < 1.389115, -0.565086, -1.990752>,
      < 1.375817, -0.573007, -2.024488>,
      < 1.375807, -0.566484, -2.024485>
    }
    triangle {
      < 1.453390, -0.558224, -2.008936>,
      < 1.453424, -0.581054, -2.008950>,
      < 1.389129, -0.574405, -1.990758>
    }
    triangle {
      < 1.453390, -0.558224, -2.008936>,
      < 1.389129, -0.574405, -1.990758>,
      < 1.389115, -0.565086, -1.990752>
    }
    triangle {
      < 1.453386, -0.558216, -2.021912>,
      < 1.453420, -0.581047, -2.021925>,
      < 1.453424, -0.581054, -2.008950>
    }
    triangle {
      < 1.453386, -0.558216, -2.021912>,
      < 1.453424, -0.581054, -2.008950>,
      < 1.453390, -0.558224, -2.008936>
    }
    triangle {
      < 1.473335, -0.556091, -2.021917>,
      < 1.473376, -0.583115, -2.021933>,
      < 1.453420, -0.581047, -2.021925>
    }
    triangle {
      < 1.473335, -0.556091, -2.021917>,
      < 1.453420, -0.581047, -2.021925>,
      < 1.453386, -0.558216, -2.021912>
    }
    triangle {
      < 1.482194, -0.555128, -2.050465>,
      < 1.482237, -0.584016, -2.050483>,
      < 1.473376, -0.583115, -2.021933>
    }
    triangle {
      < 1.482194, -0.555128, -2.050465>,
      < 1.473376, -0.583115, -2.021933>,
      < 1.473335, -0.556091, -2.021917>
    }
    triangle {
      < 1.544254, -0.548506, -2.063458>,
      < 1.544316, -0.590439, -2.063483>,
      < 1.482237, -0.584016, -2.050483>
    }
    triangle {
      < 1.544254, -0.548506, -2.063458>,
      < 1.482237, -0.584016, -2.050483>,
      < 1.482194, -0.555128, -2.050465>
    }
    triangle {
      < 1.579722, -0.544736, -2.047897>,
      < 1.579795, -0.594123, -2.047927>,
      < 1.544316, -0.590439, -2.063483>
    }
    triangle {
      < 1.579722, -0.544736, -2.047897>,
      < 1.544316, -0.590439, -2.063483>,
      < 1.544254, -0.548506, -2.063458>
    }
    triangle {
      < 1.606329, -0.541920, -2.014169>,
      < 1.606410, -0.596898, -2.014202>,
      < 1.579795, -0.594123, -2.047927>
    }
    triangle {
      < 1.606329, -0.541920, -2.014169>,
      < 1.579795, -0.594123, -2.047927>,
      < 1.579722, -0.544736, -2.047897>
    }
    triangle {
      < 1.610769, -0.541462, -1.990815>,
      < 1.610851, -0.597372, -1.990848>,
      < 1.606410, -0.596898, -2.014202>
    }
    triangle {
      < 1.610769, -0.541462, -1.990815>,
      < 1.606410, -0.596898, -2.014202>,
      < 1.606329, -0.541920, -2.014169>
    }
    triangle {
      < 1.610774, -0.541476, -1.967459>,
      < 1.610857, -0.597386, -1.967492>,
      < 1.610851, -0.597372, -1.990848>
    }
    triangle {
      < 1.610774, -0.541476, -1.967459>,
      < 1.610851, -0.597372, -1.990848>,
      < 1.610769, -0.541462, -1.990815>
    }
    triangle {
      < 1.375817, -0.573007, -2.024488>,
      < 1.374470, -0.579389, -2.024492>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.389129, -0.574405, -1.990758>,
      < 1.387206, -0.583523, -1.990762>,
      < 1.374470, -0.579389, -2.024492>
    }
    triangle {
      < 1.389129, -0.574405, -1.990758>,
      < 1.374470, -0.579389, -2.024492>,
      < 1.375817, -0.573007, -2.024488>
    }
    triangle {
      < 1.453424, -0.581054, -2.008950>,
      < 1.448711, -0.603393, -2.008961>,
      < 1.387206, -0.583523, -1.990762>
    }
    triangle {
      < 1.453424, -0.581054, -2.008950>,
      < 1.387206, -0.583523, -1.990762>,
      < 1.389129, -0.574405, -1.990758>
    }
    triangle {
      < 1.453420, -0.581047, -2.021925>,
      < 1.448708, -0.603385, -2.021936>,
      < 1.448711, -0.603393, -2.008961>
    }
    triangle {
      < 1.453420, -0.581047, -2.021925>,
      < 1.448711, -0.603393, -2.008961>,
      < 1.453424, -0.581054, -2.008950>
    }
    triangle {
      < 1.473376, -0.583115, -2.021933>,
      < 1.467797, -0.609555, -2.021947>,
      < 1.448708, -0.603385, -2.021936>
    }
    triangle {
      < 1.473376, -0.583115, -2.021933>,
      < 1.448708, -0.603385, -2.021936>,
      < 1.453420, -0.581047, -2.021925>
    }
    triangle {
      < 1.482237, -0.584016, -2.050483>,
      < 1.476274, -0.612280, -2.050498>,
      < 1.467797, -0.609555, -2.021947>
    }
    triangle {
      < 1.482237, -0.584016, -2.050483>,
      < 1.467797, -0.609555, -2.021947>,
      < 1.473376, -0.583115, -2.021933>
    }
    triangle {
      < 1.544316, -0.590439, -2.063483>,
      < 1.535659, -0.631469, -2.063505>,
      < 1.476274, -0.612280, -2.050498>
    }
    triangle {
      < 1.544316, -0.590439, -2.063483>,
      < 1.476274, -0.612280, -2.050498>,
      < 1.482237, -0.584016, -2.050483>
    }
    triangle {
      < 1.579795, -0.594123, -2.047927>,
      < 1.569601, -0.642446, -2.047952>,
      < 1.535659, -0.631469, -2.063505>
    }
    triangle {
      < 1.579795, -0.594123, -2.047927>,
      < 1.535659, -0.631469, -2.063505>,
      < 1.544316, -0.590439, -2.063483>
    }
    triangle {
      < 1.606410, -0.596898, -2.014202>,
      < 1.595062, -0.650694, -2.014230>,
      < 1.569601, -0.642446, -2.047952>
    }
    triangle {
      < 1.606410, -0.596898, -2.014202>,
      < 1.569601, -0.642446, -2.047952>,
      < 1.579795, -0.594123, -2.047927>
    }
    triangle {
      < 1.610851, -0.597372, -1.990848>,
      < 1.599310, -0.652077, -1.990876>,
      < 1.595062, -0.650694, -2.014230>
    }
    triangle {
      < 1.610851, -0.597372, -1.990848>,
      < 1.595062, -0.650694, -2.014230>,
      < 1.606410, -0.596898, -2.014202>
    }
    triangle {
      < 1.610857, -0.597386, -1.967492>,
      < 1.599316, -0.652091, -1.967520>,
      < 1.599310, -0.652077, -1.990876>
    }
    triangle {
      < 1.610857, -0.597386, -1.967492>,
      < 1.599310, -0.652077, -1.990876>,
      < 1.610851, -0.597372, -1.990848>
    }
    triangle {
      < 1.374470, -0.579389, -2.024492>,
      < 1.371826, -0.585352, -2.024494>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.387206, -0.583523, -1.990762>,
      < 1.383428, -0.592040, -1.990767>,
      < 1.371826, -0.585352, -2.024494>
    }
    triangle {
      < 1.387206, -0.583523, -1.990762>,
      < 1.371826, -0.585352, -2.024494>,
      < 1.374470, -0.579389, -2.024492>
    }
    triangle {
      < 1.448711, -0.603393, -2.008961>,
      < 1.439458, -0.624264, -2.008971>,
      < 1.383428, -0.592040, -1.990767>
    }
    triangle {
      < 1.448711, -0.603393, -2.008961>,
      < 1.383428, -0.592040, -1.990767>,
      < 1.387206, -0.583523, -1.990762>
    }
    triangle {
      < 1.448708, -0.603385, -2.021936>,
      < 1.439454, -0.624256, -2.021946>,
      < 1.439458, -0.624264, -2.008971>
    }
    triangle {
      < 1.448708, -0.603385, -2.021936>,
      < 1.439458, -0.624264, -2.008971>,
      < 1.448711, -0.603393, -2.008961>
    }
    triangle {
      < 1.467797, -0.609555, -2.021947>,
      < 1.456845, -0.634259, -2.021957>,
      < 1.439454, -0.624256, -2.021946>
    }
    triangle {
      < 1.467797, -0.609555, -2.021947>,
      < 1.439454, -0.624256, -2.021946>,
      < 1.448708, -0.603385, -2.021936>
    }
    triangle {
      < 1.476274, -0.612280, -2.050498>,
      < 1.464566, -0.638688, -2.050509>,
      < 1.456845, -0.634259, -2.021957>
    }
    triangle {
      < 1.476274, -0.612280, -2.050498>,
      < 1.456845, -0.634259, -2.021957>,
      < 1.467797, -0.609555, -2.021947>
    }
    triangle {
      < 1.535659, -0.631469, -2.063505>,
      < 1.518665, -0.669802, -2.063522>,
      < 1.464566, -0.638688, -2.050509>
    }
    triangle {
      < 1.535659, -0.631469, -2.063505>,
      < 1.464566, -0.638688, -2.050509>,
      < 1.476274, -0.612280, -2.050498>
    }
    triangle {
      < 1.569601, -0.642446, -2.047952>,
      < 1.549583, -0.687596, -2.047972>,
      < 1.518665, -0.669802, -2.063522>
    }
    triangle {
      < 1.569601, -0.642446, -2.047952>,
      < 1.518665, -0.669802, -2.063522>,
      < 1.535659, -0.631469, -2.063505>
    }
    triangle {
      < 1.595062, -0.650694, -2.014230>,
      < 1.572778, -0.700953, -2.014252>,
      < 1.549583, -0.687596, -2.047972>
    }
    triangle {
      < 1.595062, -0.650694, -2.014230>,
      < 1.549583, -0.687596, -2.047972>,
      < 1.569601, -0.642446, -2.047952>
    }
    triangle {
      < 1.599310, -0.652077, -1.990876>,
      < 1.576649, -0.703190, -1.990899>,
      < 1.572778, -0.700953, -2.014252>
    }
    triangle {
      < 1.599310, -0.652077, -1.990876>,
      < 1.572778, -0.700953, -2.014252>,
      < 1.595062, -0.650694, -2.014230>
    }
    triangle {
      < 1.599316, -0.652091, -1.967520>,
      < 1.576655, -0.703203, -1.967543>,
      < 1.576649, -0.703190, -1.990899>
    }
    triangle {
      < 1.599316, -0.652091, -1.967520>,
      < 1.576649, -0.703190, -1.990899>,
      < 1.599310, -0.652077, -1.990876>
    }
    triangle {
      < 1.371826, -0.585352, -2.024494>,
      < 1.368001, -0.590635, -2.024496>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.383428, -0.592040, -1.990767>,
      < 1.377963, -0.599589, -1.990769>,
      < 1.368001, -0.590635, -2.024496>
    }
    triangle {
      < 1.383428, -0.592040, -1.990767>,
      < 1.368001, -0.590635, -2.024496>,
      < 1.371826, -0.585352, -2.024494>
    }
    triangle {
      < 1.439458, -0.624264, -2.008971>,
      < 1.426068, -0.642755, -2.008977>,
      < 1.377963, -0.599589, -1.990769>
    }
    triangle {
      < 1.439458, -0.624264, -2.008971>,
      < 1.377963, -0.599589, -1.990769>,
      < 1.383428, -0.592040, -1.990767>
    }
    triangle {
      < 1.439454, -0.624256, -2.021946>,
      < 1.426065, -0.642747, -2.021952>,
      < 1.426068, -0.642755, -2.008977>
    }
    triangle {
      < 1.439454, -0.624256, -2.021946>,
      < 1.426068, -0.642755, -2.008977>,
      < 1.439458, -0.624264, -2.008971>
    }
    triangle {
      < 1.456845, -0.634259, -2.021957>,
      < 1.440996, -0.656147, -2.021965>,
      < 1.426065, -0.642747, -2.021952>
    }
    triangle {
      < 1.456845, -0.634259, -2.021957>,
      < 1.426065, -0.642747, -2.021952>,
      < 1.439454, -0.624256, -2.021946>
    }
    triangle {
      < 1.464566, -0.638688, -2.050509>,
      < 1.447624, -0.662085, -2.050517>,
      < 1.440996, -0.656147, -2.021965>
    }
    triangle {
      < 1.464566, -0.638688, -2.050509>,
      < 1.440996, -0.656147, -2.021965>,
      < 1.456845, -0.634259, -2.021957>
    }
    triangle {
      < 1.518665, -0.669802, -2.063522>,
      < 1.494071, -0.703765, -2.063533>,
      < 1.447624, -0.662085, -2.050517>
    }
    triangle {
      < 1.518665, -0.669802, -2.063522>,
      < 1.447624, -0.662085, -2.050517>,
      < 1.464566, -0.638688, -2.050509>
    }
    triangle {
      < 1.549583, -0.687596, -2.047972>,
      < 1.520618, -0.727597, -2.047986>,
      < 1.494071, -0.703765, -2.063533>
    }
    triangle {
      < 1.549583, -0.687596, -2.047972>,
      < 1.494071, -0.703765, -2.063533>,
      < 1.518665, -0.669802, -2.063522>
    }
    triangle {
      < 1.572778, -0.700953, -2.014252>,
      < 1.540534, -0.745483, -2.014267>,
      < 1.520618, -0.727597, -2.047986>
    }
    triangle {
      < 1.572778, -0.700953, -2.014252>,
      < 1.520618, -0.727597, -2.047986>,
      < 1.549583, -0.687596, -2.047972>
    }
    triangle {
      < 1.576649, -0.703190, -1.990899>,
      < 1.543858, -0.748474, -1.990915>,
      < 1.540534, -0.745483, -2.014267>
    }
    triangle {
      < 1.576649, -0.703190, -1.990899>,
      < 1.540534, -0.745483, -2.014267>,
      < 1.572778, -0.700953, -2.014252>
    }
    triangle {
      < 1.576655, -0.703203, -1.967543>,
      < 1.543864, -0.748488, -1.967559>,
      < 1.543858, -0.748474, -1.990915>
    }
    triangle {
      < 1.576655, -0.703203, -1.967543>,
      < 1.543858, -0.748474, -1.990915>,
      < 1.576649, -0.703190, -1.990899>
    }
    triangle {
      < 1.368001, -0.590635, -2.024496>,
      < 1.363161, -0.595007, -2.024497>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.377963, -0.599589, -1.990769>,
      < 1.371049, -0.605835, -1.990770>,
      < 1.363161, -0.595007, -2.024497>
    }
    triangle {
      < 1.377963, -0.599589, -1.990769>,
      < 1.363161, -0.595007, -2.024497>,
      < 1.368001, -0.590635, -2.024496>
    }
    triangle {
      < 1.426068, -0.642755, -2.008977>,
      < 1.409127, -0.658058, -2.008980>,
      < 1.371049, -0.605835, -1.990770>
    }
    triangle {
      < 1.426068, -0.642755, -2.008977>,
      < 1.371049, -0.605835, -1.990770>,
      < 1.377963, -0.599589, -1.990769>
    }
    triangle {
      < 1.426065, -0.642747, -2.021952>,
      < 1.409124, -0.658050, -2.021955>,
      < 1.409127, -0.658058, -2.008980>
    }
    triangle {
      < 1.426065, -0.642747, -2.021952>,
      < 1.409127, -0.658058, -2.008980>,
      < 1.426068, -0.642755, -2.008977>
    }
    triangle {
      < 1.440996, -0.656147, -2.021965>,
      < 1.420943, -0.674262, -2.021969>,
      < 1.409124, -0.658050, -2.021955>
    }
    triangle {
      < 1.440996, -0.656147, -2.021965>,
      < 1.409124, -0.658050, -2.021955>,
      < 1.426065, -0.642747, -2.021952>
    }
    triangle {
      < 1.447624, -0.662085, -2.050517>,
      < 1.426189, -0.681450, -2.050521>,
      < 1.420943, -0.674262, -2.021969>
    }
    triangle {
      < 1.447624, -0.662085, -2.050517>,
      < 1.420943, -0.674262, -2.021969>,
      < 1.440996, -0.656147, -2.021965>
    }
    triangle {
      < 1.494071, -0.703765, -2.063533>,
      < 1.462955, -0.731875, -2.063539>,
      < 1.426189, -0.681450, -2.050521>
    }
    triangle {
      < 1.494071, -0.703765, -2.063533>,
      < 1.426189, -0.681450, -2.050521>,
      < 1.447624, -0.662085, -2.050517>
    }
    triangle {
      < 1.520618, -0.727597, -2.047986>,
      < 1.483970, -0.760704, -2.047993>,
      < 1.462955, -0.731875, -2.063539>
    }
    triangle {
      < 1.520618, -0.727597, -2.047986>,
      < 1.462955, -0.731875, -2.063539>,
      < 1.494071, -0.703765, -2.063533>
    }
    triangle {
      < 1.540534, -0.745483, -2.014267>,
      < 1.499738, -0.782338, -2.014275>,
      < 1.483970, -0.760704, -2.047993>
    }
    triangle {
      < 1.540534, -0.745483, -2.014267>,
      < 1.483970, -0.760704, -2.047993>,
      < 1.520618, -0.727597, -2.047986>
    }
    triangle {
      < 1.543858, -0.748474, -1.990915>,
      < 1.502370, -0.785954, -1.990923>,
      < 1.499738, -0.782338, -2.014275>
    }
    triangle {
      < 1.543858, -0.748474, -1.990915>,
      < 1.499738, -0.782338, -2.014275>,
      < 1.540534, -0.745483, -2.014267>
    }
    triangle {
      < 1.543864, -0.748488, -1.967559>,
      < 1.502376, -0.785967, -1.967566>,
      < 1.502370, -0.785954, -1.990923>
    }
    triangle {
      < 1.543864, -0.748488, -1.967559>,
      < 1.502370, -0.785954, -1.990923>,
      < 1.543858, -0.748474, -1.990915>
    }
    triangle {
      < 1.363161, -0.595007, -2.024497>,
      < 1.357518, -0.598279, -2.024497>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.363161, -0.595007, -2.024497>,
      < 1.344774, -0.567563, -2.024475>,
      < 1.342657, -0.570483, -2.024476>
    }
    triangle {
      < 1.371049, -0.605835, -1.990770>,
      < 1.362987, -0.610507, -1.990770>,
      < 1.357518, -0.598279, -2.024497>
    }
    triangle {
      < 1.371049, -0.605835, -1.990770>,
      < 1.357518, -0.598279, -2.024497>,
      < 1.363161, -0.595007, -2.024497>
    }
    triangle {
      < 1.409127, -0.658058, -2.008980>,
      < 1.389375, -0.669507, -2.008980>,
      < 1.362987, -0.610507, -1.990770>
    }
    triangle {
      < 1.409127, -0.658058, -2.008980>,
      < 1.362987, -0.610507, -1.990770>,
      < 1.371049, -0.605835, -1.990770>
    }
    triangle {
      < 1.409124, -0.658050, -2.021955>,
      < 1.389372, -0.669499, -2.021955>,
      < 1.389375, -0.669507, -2.008980>
    }
    triangle {
      < 1.409124, -0.658050, -2.021955>,
      < 1.389375, -0.669507, -2.008980>,
      < 1.409127, -0.658058, -2.008980>
    }
    triangle {
      < 1.420943, -0.674262, -2.021969>,
      < 1.397563, -0.687813, -2.021969>,
      < 1.389372, -0.669499, -2.021955>
    }
    triangle {
      < 1.420943, -0.674262, -2.021969>,
      < 1.389372, -0.669499, -2.021955>,
      < 1.409124, -0.658050, -2.021955>
    }
    triangle {
      < 1.426189, -0.681450, -2.050521>,
      < 1.401196, -0.695935, -2.050521>,
      < 1.397563, -0.687813, -2.021969>
    }
    triangle {
      < 1.426189, -0.681450, -2.050521>,
      < 1.397563, -0.687813, -2.021969>,
      < 1.420943, -0.674262, -2.021969>
    }
    triangle {
      < 1.462955, -0.731875, -2.063539>,
      < 1.426676, -0.752902, -2.063539>,
      < 1.401196, -0.695935, -2.050521>
    }
    triangle {
      < 1.462955, -0.731875, -2.063539>,
      < 1.401196, -0.695935, -2.050521>,
      < 1.426189, -0.681450, -2.050521>
    }
    triangle {
      < 1.483970, -0.760704, -2.047993>,
      < 1.441242, -0.785469, -2.047993>,
      < 1.426676, -0.752902, -2.063539>
    }
    triangle {
      < 1.483970, -0.760704, -2.047993>,
      < 1.426676, -0.752902, -2.063539>,
      < 1.462955, -0.731875, -2.063539>
    }
    triangle {
      < 1.499738, -0.782338, -2.014275>,
      < 1.452171, -0.809906, -2.014275>,
      < 1.441242, -0.785469, -2.047993>
    }
    triangle {
      < 1.499738, -0.782338, -2.014275>,
      < 1.441242, -0.785469, -2.047993>,
      < 1.483970, -0.760704, -2.047993>
    }
    triangle {
      < 1.502370, -0.785954, -1.990923>,
      < 1.453998, -0.813990, -1.990922>,
      < 1.452171, -0.809906, -2.014275>
    }
    triangle {
      < 1.502370, -0.785954, -1.990923>,
      < 1.452171, -0.809906, -2.014275>,
      < 1.499738, -0.782338, -2.014275>
    }
    triangle {
      < 1.502376, -0.785967, -1.967566>,
      < 1.454004, -0.814004, -1.967567>,
      < 1.453998, -0.813990, -1.990922>
    }
    triangle {
      < 1.502376, -0.785967, -1.967566>,
      < 1.453998, -0.813990, -1.990922>,
      < 1.502370, -0.785954, -1.990923>
    }
    triangle {
      < 1.357518, -0.598279, -2.024497>,
      < 1.351317, -0.600305, -2.024496>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.362987, -0.610507, -1.990770>,
      < 1.354130, -0.613402, -1.990769>,
      < 1.351317, -0.600305, -2.024496>
    }
    triangle {
      < 1.362987, -0.610507, -1.990770>,
      < 1.351317, -0.600305, -2.024496>,
      < 1.357518, -0.598279, -2.024497>
    }
    triangle {
      < 1.389375, -0.669507, -2.008980>,
      < 1.367675, -0.676599, -2.008977>,
      < 1.354130, -0.613402, -1.990769>
    }
    triangle {
      < 1.389375, -0.669507, -2.008980>,
      < 1.354130, -0.613402, -1.990769>,
      < 1.362987, -0.610507, -1.990770>
    }
    triangle {
      < 1.389372, -0.669499, -2.021955>,
      < 1.367671, -0.676591, -2.021952>,
      < 1.367675, -0.676599, -2.008977>
    }
    triangle {
      < 1.389372, -0.669499, -2.021955>,
      < 1.367675, -0.676599, -2.008977>,
      < 1.389375, -0.669507, -2.008980>
    }
    triangle {
      < 1.397563, -0.687813, -2.021969>,
      < 1.371876, -0.696207, -2.021965>,
      < 1.367671, -0.676591, -2.021952>
    }
    triangle {
      < 1.397563, -0.687813, -2.021969>,
      < 1.367671, -0.676591, -2.021952>,
      < 1.389372, -0.669499, -2.021955>
    }
    triangle {
      < 1.401196, -0.695935, -2.050521>,
      < 1.373738, -0.704908, -2.050517>,
      < 1.371876, -0.696207, -2.021965>
    }
    triangle {
      < 1.401196, -0.695935, -2.050521>,
      < 1.371876, -0.696207, -2.021965>,
      < 1.397563, -0.687813, -2.021969>
    }
    triangle {
      < 1.426676, -0.752902, -2.063539>,
      < 1.386818, -0.765929, -2.063533>,
      < 1.373738, -0.704908, -2.050517>
    }
    triangle {
      < 1.426676, -0.752902, -2.063539>,
      < 1.373738, -0.704908, -2.050517>,
      < 1.401196, -0.695935, -2.050521>
    }
    triangle {
      < 1.441242, -0.785469, -2.047993>,
      < 1.394298, -0.800811, -2.047985>,
      < 1.386818, -0.765929, -2.063533>
    }
    triangle {
      < 1.441242, -0.785469, -2.047993>,
      < 1.386818, -0.765929, -2.063533>,
      < 1.426676, -0.752902, -2.063539>
    }
    triangle {
      < 1.452171, -0.809906, -2.014275>,
      < 1.399913, -0.826985, -2.014267>,
      < 1.394298, -0.800811, -2.047985>
    }
    triangle {
      < 1.452171, -0.809906, -2.014275>,
      < 1.394298, -0.800811, -2.047985>,
      < 1.441242, -0.785469, -2.047993>
    }
    triangle {
      < 1.453998, -0.813990, -1.990922>,
      < 1.400854, -0.831358, -1.990914>,
      < 1.399913, -0.826985, -2.014267>
    }
    triangle {
      < 1.453998, -0.813990, -1.990922>,
      < 1.399913, -0.826985, -2.014267>,
      < 1.452171, -0.809906, -2.014275>
    }
    triangle {
      < 1.454004, -0.814004, -1.967567>,
      < 1.400860, -0.831372, -1.967558>,
      < 1.400854, -0.831358, -1.990914>
    }
    triangle {
      < 1.454004, -0.814004, -1.967567>,
      < 1.400854, -0.831358, -1.990914>,
      < 1.453998, -0.813990, -1.990922>
    }
    triangle {
      < 1.351317, -0.600305, -2.024496>,
      < 1.344794, -0.600999, -2.024494>,
      < 1.344774, -0.567563, -2.024475>
    }
    triangle {
      < 1.354130, -0.613402, -1.990769>,
      < 1.344811, -0.614393, -1.990766>,
      < 1.344794, -0.600999, -2.024494>
    }
    triangle {
      < 1.354130, -0.613402, -1.990769>,
      < 1.344794, -0.600999, -2.024494>,
      < 1.351317, -0.600305, -2.024496>
    }
    triangle {
      < 1.367675, -0.676599, -2.008977>,
      < 1.344845, -0.679026, -2.008970>,
      < 1.344811, -0.614393, -1.990766>
    }
    triangle {
      < 1.367675, -0.676599, -2.008977>,
      < 1.344811, -0.614393, -1.990766>,
      < 1.354130, -0.613402, -1.990769>
    }
    triangle {
      < 1.367671, -0.676591, -2.021952>,
      < 1.344842, -0.679018, -2.021945>,
      < 1.344845, -0.679026, -2.008970>
    }
    triangle {
      < 1.367671, -0.676591, -2.021952>,
      < 1.344845, -0.679026, -2.008970>,
      < 1.367675, -0.676599, -2.008977>
    }
    triangle {
      < 1.371876, -0.696207, -2.021965>,
      < 1.344854, -0.699079, -2.021958>,
      < 1.344842, -0.679018, -2.021945>
    }
    triangle {
      < 1.371876, -0.696207, -2.021965>,
      < 1.344842, -0.679018, -2.021945>,
      < 1.367671, -0.676591, -2.021952>
    }
    triangle {
      < 1.373738, -0.704908, -2.050517>,
      < 1.344851, -0.707979, -2.050509>,
      < 1.344854, -0.699079, -2.021958>
    }
    triangle {
      < 1.373738, -0.704908, -2.050517>,
      < 1.344854, -0.699079, -2.021958>,
      < 1.371876, -0.696207, -2.021965>
    }
    triangle {
      < 1.386818, -0.765929, -2.063533>,
      < 1.344885, -0.770385, -2.063521>,
      < 1.344851, -0.707979, -2.050509>
    }
    triangle {
      < 1.386818, -0.765929, -2.063533>,
      < 1.344851, -0.707979, -2.050509>,
      < 1.373738, -0.704908, -2.050517>
    }
    triangle {
      < 1.394298, -0.800811, -2.047985>,
      < 1.344911, -0.806060, -2.047971>,
      < 1.344885, -0.770385, -2.063521>
    }
    triangle {
      < 1.394298, -0.800811, -2.047985>,
      < 1.344885, -0.770385, -2.063521>,
      < 1.386818, -0.765929, -2.063533>
    }
    triangle {
      < 1.399913, -0.826985, -2.014267>,
      < 1.344934, -0.832829, -2.014251>,
      < 1.344911, -0.806060, -2.047971>
    }
    triangle {
      < 1.399913, -0.826985, -2.014267>,
      < 1.344911, -0.806060, -2.047971>,
      < 1.394298, -0.800811, -2.047985>
    }
    triangle {
      < 1.400854, -0.831358, -1.990914>,
      < 1.344943, -0.837301, -1.990898>,
      < 1.344934, -0.832829, -2.014251>
    }
    triangle {
      < 1.400854, -0.831358, -1.990914>,
      < 1.344934, -0.832829, -2.014251>,
      < 1.399913, -0.826985, -2.014267>
    }
    triangle {
      < 1.400860, -0.831372, -1.967558>,
      < 1.344949, -0.837315, -1.967543>,
      < 1.344943, -0.837301, -1.990898>
    }
    triangle {
      < 1.400860, -0.831372, -1.967558>,
      < 1.344943, -0.837301, -1.990898>,
      < 1.400854, -0.831358, -1.990914>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.338336, -0.600389, -1.909659>,
      < 1.344824, -0.601066, -1.909661>
    }
    triangle {
      < 1.344824, -0.601066, -1.909661>,
      < 1.338336, -0.600389, -1.909659>,
      < 1.335555, -0.613453, -1.943401>
    }
    triangle {
      < 1.344824, -0.601066, -1.909661>,
      < 1.335555, -0.613453, -1.943401>,
      < 1.344823, -0.614421, -1.943405>
    }
    triangle {
      < 1.344823, -0.614421, -1.943405>,
      < 1.335555, -0.613453, -1.943401>,
      < 1.322159, -0.676703, -1.925269>
    }
    triangle {
      < 1.344823, -0.614421, -1.943405>,
      < 1.322159, -0.676703, -1.925269>,
      < 1.344866, -0.679075, -1.925278>
    }
    triangle {
      < 1.344866, -0.679075, -1.925278>,
      < 1.322159, -0.676703, -1.925269>,
      < 1.322163, -0.676710, -1.912293>
    }
    triangle {
      < 1.344866, -0.679075, -1.925278>,
      < 1.322163, -0.676710, -1.912293>,
      < 1.344870, -0.679083, -1.912302>
    }
    triangle {
      < 1.344870, -0.679083, -1.912302>,
      < 1.322163, -0.676710, -1.912293>,
      < 1.318005, -0.696337, -1.912303>
    }
    triangle {
      < 1.344870, -0.679083, -1.912302>,
      < 1.318005, -0.696337, -1.912303>,
      < 1.344882, -0.699145, -1.912314>
    }
    triangle {
      < 1.344882, -0.699145, -1.912314>,
      < 1.318005, -0.696337, -1.912303>,
      < 1.316163, -0.705075, -1.883762>
    }
    triangle {
      < 1.344882, -0.699145, -1.912314>,
      < 1.316163, -0.705075, -1.883762>,
      < 1.344894, -0.708078, -1.883774>
    }
    triangle {
      < 1.344894, -0.708078, -1.883774>,
      < 1.316163, -0.705075, -1.883762>,
      < 1.303228, -0.766142, -1.870818>
    }
    triangle {
      < 1.344894, -0.708078, -1.883774>,
      < 1.303228, -0.766142, -1.870818>,
      < 1.344934, -0.770500, -1.870836>
    }
    triangle {
      < 1.344934, -0.770500, -1.870836>,
      < 1.303228, -0.766142, -1.870818>,
      < 1.295831, -0.801023, -1.886407>
    }
    triangle {
      < 1.344934, -0.770500, -1.870836>,
      < 1.295831, -0.801023, -1.886407>,
      < 1.344951, -0.806156, -1.886427>
    }
    triangle {
      < 1.344951, -0.806156, -1.886427>,
      < 1.295831, -0.801023, -1.886407>,
      < 1.290278, -0.827171, -1.920156>
    }
    triangle {
      < 1.344951, -0.806156, -1.886427>,
      < 1.290278, -0.827171, -1.920156>,
      < 1.344958, -0.832885, -1.920179>
    }
    triangle {
      < 1.344958, -0.832885, -1.920179>,
      < 1.290278, -0.827171, -1.920156>,
      < 1.289348, -0.831519, -1.943514>
    }
    triangle {
      < 1.344958, -0.832885, -1.920179>,
      < 1.289348, -0.831519, -1.943514>,
      < 1.344955, -0.837330, -1.943537>
    }
    triangle {
      < 1.344955, -0.837330, -1.943537>,
      < 1.289348, -0.831519, -1.943514>,
      < 1.289342, -0.831505, -1.967520>
    }
    triangle {
      < 1.344955, -0.837330, -1.943537>,
      < 1.289342, -0.831505, -1.967520>,
      < 1.344949, -0.837315, -1.967543>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.332131, -0.598377, -1.909655>,
      < 1.338336, -0.600389, -1.909659>
    }
    triangle {
      < 1.338336, -0.600389, -1.909659>,
      < 1.332131, -0.598377, -1.909655>,
      < 1.326691, -0.610579, -1.943396>
    }
    triangle {
      < 1.338336, -0.600389, -1.909659>,
      < 1.326691, -0.610579, -1.943396>,
      < 1.335555, -0.613453, -1.943401>
    }
    triangle {
      < 1.335555, -0.613453, -1.943401>,
      < 1.326691, -0.610579, -1.943396>,
      < 1.300442, -0.669662, -1.925257>
    }
    triangle {
      < 1.335555, -0.613453, -1.943401>,
      < 1.300442, -0.669662, -1.925257>,
      < 1.322159, -0.676703, -1.925269>
    }
    triangle {
      < 1.322159, -0.676703, -1.925269>,
      < 1.300442, -0.669662, -1.925257>,
      < 1.300446, -0.669669, -1.912282>
    }
    triangle {
      < 1.322159, -0.676703, -1.925269>,
      < 1.300446, -0.669669, -1.912282>,
      < 1.322163, -0.676710, -1.912293>
    }
    triangle {
      < 1.322163, -0.676710, -1.912293>,
      < 1.300446, -0.669669, -1.912282>,
      < 1.292298, -0.688002, -1.912290>
    }
    triangle {
      < 1.322163, -0.676710, -1.912293>,
      < 1.292298, -0.688002, -1.912290>,
      < 1.318005, -0.696337, -1.912303>
    }
    triangle {
      < 1.318005, -0.696337, -1.912303>,
      < 1.292298, -0.688002, -1.912290>,
      < 1.288684, -0.696167, -1.883747>
    }
    triangle {
      < 1.318005, -0.696337, -1.912303>,
      < 1.288684, -0.696167, -1.883747>,
      < 1.316163, -0.705075, -1.883762>
    }
    triangle {
      < 1.316163, -0.705075, -1.883762>,
      < 1.288684, -0.696167, -1.883747>,
      < 1.263340, -0.753210, -1.870797>
    }
    triangle {
      < 1.316163, -0.705075, -1.883762>,
      < 1.263340, -0.753210, -1.870797>,
      < 1.303228, -0.766142, -1.870818>
    }
    triangle {
      < 1.303228, -0.766142, -1.870818>,
      < 1.263340, -0.753210, -1.870797>,
      < 1.248851, -0.785793, -1.886382>
    }
    triangle {
      < 1.303228, -0.766142, -1.870818>,
      < 1.248851, -0.785793, -1.886382>,
      < 1.295831, -0.801023, -1.886407>
    }
    triangle {
      < 1.295831, -0.801023, -1.886407>,
      < 1.248851, -0.785793, -1.886382>,
      < 1.237979, -0.810217, -1.920128>
    }
    triangle {
      < 1.295831, -0.801023, -1.886407>,
      < 1.237979, -0.810217, -1.920128>,
      < 1.290278, -0.827171, -1.920156>
    }
    triangle {
      < 1.290278, -0.827171, -1.920156>,
      < 1.237979, -0.810217, -1.920128>,
      < 1.236162, -0.814276, -1.943486>
    }
    triangle {
      < 1.290278, -0.827171, -1.920156>,
      < 1.236162, -0.814276, -1.943486>,
      < 1.289348, -0.831519, -1.943514>
    }
    triangle {
      < 1.289348, -0.831519, -1.943514>,
      < 1.236162, -0.814276, -1.943486>,
      < 1.236157, -0.814262, -1.967492>
    }
    triangle {
      < 1.289348, -0.831519, -1.943514>,
      < 1.236157, -0.814262, -1.967492>,
      < 1.289342, -0.831505, -1.967520>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.326480, -0.595120, -1.909651>,
      < 1.332131, -0.598377, -1.909655>
    }
    triangle {
      < 1.332131, -0.598377, -1.909655>,
      < 1.326480, -0.595120, -1.909651>,
      < 1.318618, -0.605925, -1.943391>
    }
    triangle {
      < 1.332131, -0.598377, -1.909655>,
      < 1.318618, -0.605925, -1.943391>,
      < 1.326691, -0.610579, -1.943396>
    }
    triangle {
      < 1.326691, -0.610579, -1.943396>,
      < 1.318618, -0.605925, -1.943391>,
      < 1.280663, -0.658260, -1.925243>
    }
    triangle {
      < 1.326691, -0.610579, -1.943396>,
      < 1.280663, -0.658260, -1.925243>,
      < 1.300442, -0.669662, -1.925257>
    }
    triangle {
      < 1.300442, -0.669662, -1.925257>,
      < 1.280663, -0.658260, -1.925243>,
      < 1.280666, -0.658268, -1.912268>
    }
    triangle {
      < 1.300442, -0.669662, -1.925257>,
      < 1.280666, -0.658268, -1.912268>,
      < 1.300446, -0.669669, -1.912282>
    }
    triangle {
      < 1.300446, -0.669669, -1.912282>,
      < 1.280666, -0.658268, -1.912268>,
      < 1.268886, -0.674507, -1.912273>
    }
    triangle {
      < 1.300446, -0.669669, -1.912282>,
      < 1.268886, -0.674507, -1.912273>,
      < 1.292298, -0.688002, -1.912290>
    }
    triangle {
      < 1.292298, -0.688002, -1.912290>,
      < 1.268886, -0.674507, -1.912273>,
      < 1.263658, -0.681741, -1.883730>
    }
    triangle {
      < 1.292298, -0.688002, -1.912290>,
      < 1.263658, -0.681741, -1.883730>,
      < 1.288684, -0.696167, -1.883747>
    }
    triangle {
      < 1.288684, -0.696167, -1.883747>,
      < 1.263658, -0.681741, -1.883730>,
      < 1.227010, -0.732269, -1.870772>
    }
    triangle {
      < 1.288684, -0.696167, -1.883747>,
      < 1.227010, -0.732269, -1.870772>,
      < 1.263340, -0.753210, -1.870797>
    }
    triangle {
      < 1.263340, -0.753210, -1.870797>,
      < 1.227010, -0.732269, -1.870772>,
      < 1.206064, -0.761129, -1.886352>
    }
    triangle {
      < 1.263340, -0.753210, -1.870797>,
      < 1.206064, -0.761129, -1.886352>,
      < 1.248851, -0.785793, -1.886382>
    }
    triangle {
      < 1.248851, -0.785793, -1.886382>,
      < 1.206064, -0.761129, -1.886352>,
      < 1.190348, -0.782760, -1.920096>
    }
    triangle {
      < 1.248851, -0.785793, -1.886382>,
      < 1.190348, -0.782760, -1.920096>,
      < 1.237979, -0.810217, -1.920128>
    }
    triangle {
      < 1.237979, -0.810217, -1.920128>,
      < 1.190348, -0.782760, -1.920096>,
      < 1.187723, -0.786355, -1.943452>
    }
    triangle {
      < 1.237979, -0.810217, -1.920128>,
      < 1.187723, -0.786355, -1.943452>,
      < 1.236162, -0.814276, -1.943486>
    }
    triangle {
      < 1.236162, -0.814276, -1.943486>,
      < 1.187723, -0.786355, -1.943452>,
      < 1.187718, -0.786340, -1.967458>
    }
    triangle {
      < 1.236162, -0.814276, -1.943486>,
      < 1.187718, -0.786340, -1.967458>,
      < 1.236157, -0.814262, -1.967492>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.321630, -0.590758, -1.909647>,
      < 1.326480, -0.595120, -1.909651>
    }
    triangle {
      < 1.326480, -0.595120, -1.909651>,
      < 1.321630, -0.590758, -1.909647>,
      < 1.311689, -0.599695, -1.943385>
    }
    triangle {
      < 1.326480, -0.595120, -1.909651>,
      < 1.311689, -0.599695, -1.943385>,
      < 1.318618, -0.605925, -1.943391>
    }
    triangle {
      < 1.318618, -0.605925, -1.943391>,
      < 1.311689, -0.599695, -1.943385>,
      < 1.263686, -0.642997, -1.925228>
    }
    triangle {
      < 1.318618, -0.605925, -1.943391>,
      < 1.263686, -0.642997, -1.925228>,
      < 1.280663, -0.658260, -1.925243>
    }
    triangle {
      < 1.280663, -0.658260, -1.925243>,
      < 1.263686, -0.642997, -1.925228>,
      < 1.263690, -0.643005, -1.912253>
    }
    triangle {
      < 1.280663, -0.658260, -1.925243>,
      < 1.263690, -0.643005, -1.912253>,
      < 1.280666, -0.658268, -1.912268>
    }
    triangle {
      < 1.280666, -0.658268, -1.912268>,
      < 1.263690, -0.643005, -1.912253>,
      < 1.248790, -0.656440, -1.912256>
    }
    triangle {
      < 1.280666, -0.658268, -1.912268>,
      < 1.248790, -0.656440, -1.912256>,
      < 1.268886, -0.674507, -1.912273>
    }
    triangle {
      < 1.268886, -0.674507, -1.912273>,
      < 1.248790, -0.656440, -1.912256>,
      < 1.242176, -0.662427, -1.883711>
    }
    triangle {
      < 1.268886, -0.674507, -1.912273>,
      < 1.242176, -0.662427, -1.883711>,
      < 1.263658, -0.681741, -1.883730>
    }
    triangle {
      < 1.263658, -0.681741, -1.883730>,
      < 1.242176, -0.662427, -1.883711>,
      < 1.195828, -0.704234, -1.870745>
    }
    triangle {
      < 1.263658, -0.681741, -1.883730>,
      < 1.195828, -0.704234, -1.870745>,
      < 1.227010, -0.732269, -1.870772>
    }
    triangle {
      < 1.227010, -0.732269, -1.870772>,
      < 1.195828, -0.704234, -1.870745>,
      < 1.169338, -0.728109, -1.886320>
    }
    triangle {
      < 1.227010, -0.732269, -1.870772>,
      < 1.169338, -0.728109, -1.886320>,
      < 1.206064, -0.761129, -1.886352>
    }
    triangle {
      < 1.206064, -0.761129, -1.886352>,
      < 1.169338, -0.728109, -1.886320>,
      < 1.149463, -0.746003, -1.920059>
    }
    triangle {
      < 1.206064, -0.761129, -1.886352>,
      < 1.149463, -0.746003, -1.920059>,
      < 1.190348, -0.782760, -1.920096>
    }
    triangle {
      < 1.190348, -0.782760, -1.920096>,
      < 1.149463, -0.746003, -1.920059>,
      < 1.146146, -0.748974, -1.943416>
    }
    triangle {
      < 1.190348, -0.782760, -1.920096>,
      < 1.146146, -0.748974, -1.943416>,
      < 1.187723, -0.786355, -1.943452>
    }
    triangle {
      < 1.187723, -0.786355, -1.943452>,
      < 1.146146, -0.748974, -1.943416>,
      < 1.146140, -0.748960, -1.967422>
    }
    triangle {
      < 1.187723, -0.786355, -1.943452>,
      < 1.146140, -0.748960, -1.967422>,
      < 1.187718, -0.786340, -1.967458>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.317792, -0.585485, -1.909642>,
      < 1.321630, -0.590758, -1.909647>
    }
    triangle {
      < 1.321630, -0.590758, -1.909647>,
      < 1.317792, -0.585485, -1.909642>,
      < 1.306205, -0.592161, -1.943379>
    }
    triangle {
      < 1.321630, -0.590758, -1.909647>,
      < 1.306205, -0.592161, -1.943379>,
      < 1.311689, -0.599695, -1.943385>
    }
    triangle {
      < 1.311689, -0.599695, -1.943385>,
      < 1.306205, -0.592161, -1.943379>,
      < 1.250253, -0.624538, -1.925213>
    }
    triangle {
      < 1.311689, -0.599695, -1.943385>,
      < 1.250253, -0.624538, -1.925213>,
      < 1.263686, -0.642997, -1.925228>
    }
    triangle {
      < 1.263686, -0.642997, -1.925228>,
      < 1.250253, -0.624538, -1.925213>,
      < 1.250256, -0.624545, -1.912237>
    }
    triangle {
      < 1.263686, -0.642997, -1.925228>,
      < 1.250256, -0.624545, -1.912237>,
      < 1.263690, -0.643005, -1.912253>
    }
    triangle {
      < 1.263690, -0.643005, -1.912253>,
      < 1.250256, -0.624545, -1.912237>,
      < 1.232890, -0.634589, -1.912238>
    }
    triangle {
      < 1.263690, -0.643005, -1.912253>,
      < 1.232890, -0.634589, -1.912238>,
      < 1.248790, -0.656440, -1.912256>
    }
    triangle {
      < 1.248790, -0.656440, -1.912256>,
      < 1.232890, -0.634589, -1.912238>,
      < 1.225178, -0.639071, -1.883692>
    }
    triangle {
      < 1.248790, -0.656440, -1.912256>,
      < 1.225178, -0.639071, -1.883692>,
      < 1.242176, -0.662427, -1.883711>
    }
    triangle {
      < 1.242176, -0.662427, -1.883711>,
      < 1.225178, -0.639071, -1.883692>,
      < 1.171154, -0.670329, -1.870716>
    }
    triangle {
      < 1.242176, -0.662427, -1.883711>,
      < 1.171154, -0.670329, -1.870716>,
      < 1.195828, -0.704234, -1.870745>
    }
    triangle {
      < 1.195828, -0.704234, -1.870745>,
      < 1.171154, -0.670329, -1.870716>,
      < 1.140277, -0.688175, -1.886286>
    }
    triangle {
      < 1.195828, -0.704234, -1.870745>,
      < 1.140277, -0.688175, -1.886286>,
      < 1.169338, -0.728109, -1.886320>
    }
    triangle {
      < 1.169338, -0.728109, -1.886320>,
      < 1.140277, -0.688175, -1.886286>,
      < 1.117114, -0.701549, -1.920022>
    }
    triangle {
      < 1.169338, -0.728109, -1.886320>,
      < 1.117114, -0.701549, -1.920022>,
      < 1.149463, -0.746003, -1.920059>
    }
    triangle {
      < 1.149463, -0.746003, -1.920059>,
      < 1.117114, -0.701549, -1.920022>,
      < 1.113249, -0.703767, -1.943378>
    }
    triangle {
      < 1.149463, -0.746003, -1.920059>,
      < 1.113249, -0.703767, -1.943378>,
      < 1.146146, -0.748974, -1.943416>
    }
    triangle {
      < 1.146146, -0.748974, -1.943416>,
      < 1.113249, -0.703767, -1.943378>,
      < 1.113243, -0.703754, -1.967384>
    }
    triangle {
      < 1.146146, -0.748974, -1.943416>,
      < 1.113243, -0.703754, -1.967384>,
      < 1.146140, -0.748960, -1.967422>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.315134, -0.579528, -1.909638>,
      < 1.317792, -0.585485, -1.909642>
    }
    triangle {
      < 1.317792, -0.585485, -1.909642>,
      < 1.315134, -0.579528, -1.909638>,
      < 1.302408, -0.583651, -1.943372>
    }
    triangle {
      < 1.317792, -0.585485, -1.909642>,
      < 1.302408, -0.583651, -1.943372>,
      < 1.306205, -0.592161, -1.943379>
    }
    triangle {
      < 1.306205, -0.592161, -1.943379>,
      < 1.302408, -0.583651, -1.943372>,
      < 1.240950, -0.603689, -1.925197>
    }
    triangle {
      < 1.306205, -0.592161, -1.943379>,
      < 1.240950, -0.603689, -1.925197>,
      < 1.250253, -0.624538, -1.925213>
    }
    triangle {
      < 1.250253, -0.624538, -1.925213>,
      < 1.240950, -0.603689, -1.925197>,
      < 1.240954, -0.603697, -1.912222>
    }
    triangle {
      < 1.250253, -0.624538, -1.925213>,
      < 1.240954, -0.603697, -1.912222>,
      < 1.250256, -0.624545, -1.912237>
    }
    triangle {
      < 1.250256, -0.624545, -1.912237>,
      < 1.240954, -0.603697, -1.912222>,
      < 1.221879, -0.609912, -1.912219>
    }
    triangle {
      < 1.250256, -0.624545, -1.912237>,
      < 1.221879, -0.609912, -1.912219>,
      < 1.232890, -0.634589, -1.912238>
    }
    triangle {
      < 1.232890, -0.634589, -1.912238>,
      < 1.221879, -0.609912, -1.912219>,
      < 1.213408, -0.612691, -1.883672>
    }
    triangle {
      < 1.232890, -0.634589, -1.912238>,
      < 1.213408, -0.612691, -1.883672>,
      < 1.225178, -0.639071, -1.883692>
    }
    triangle {
      < 1.225178, -0.639071, -1.883692>,
      < 1.213408, -0.612691, -1.883672>,
      < 1.154068, -0.632035, -1.870687>
    }
    triangle {
      < 1.225178, -0.639071, -1.883692>,
      < 1.154068, -0.632035, -1.870687>,
      < 1.171154, -0.670329, -1.870716>
    }
    triangle {
      < 1.171154, -0.670329, -1.870716>,
      < 1.154068, -0.632035, -1.870687>,
      < 1.120153, -0.643075, -1.886253>
    }
    triangle {
      < 1.171154, -0.670329, -1.870716>,
      < 1.120153, -0.643075, -1.886253>,
      < 1.140277, -0.688175, -1.886286>
    }
    triangle {
      < 1.140277, -0.688175, -1.886286>,
      < 1.120153, -0.643075, -1.886253>,
      < 1.094712, -0.651341, -1.919985>
    }
    triangle {
      < 1.140277, -0.688175, -1.886286>,
      < 1.094712, -0.651341, -1.919985>,
      < 1.117114, -0.701549, -1.920022>
    }
    triangle {
      < 1.117114, -0.701549, -1.920022>,
      < 1.094712, -0.651341, -1.919985>,
      < 1.090466, -0.652709, -1.943340>
    }
    triangle {
      < 1.117114, -0.701549, -1.920022>,
      < 1.090466, -0.652709, -1.943340>,
      < 1.113249, -0.703767, -1.943378>
    }
    triangle {
      < 1.113249, -0.703767, -1.943378>,
      < 1.090466, -0.652709, -1.943340>,
      < 1.090461, -0.652695, -1.967345>
    }
    triangle {
      < 1.113249, -0.703767, -1.943378>,
      < 1.090461, -0.652695, -1.967345>,
      < 1.113243, -0.703754, -1.967384>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.347022, -0.569625, -1.909643>,
      < 1.313771, -0.573149, -1.909634>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.313771, -0.573149, -1.909634>,
      < 1.315134, -0.579528, -1.909638>
    }
    triangle {
      < 1.315134, -0.579528, -1.909638>,
      < 1.313771, -0.573149, -1.909634>,
      < 1.300463, -0.574538, -1.943366>
    }
    triangle {
      < 1.315134, -0.579528, -1.909638>,
      < 1.300463, -0.574538, -1.943366>,
      < 1.302408, -0.583651, -1.943372>
    }
    triangle {
      < 1.302408, -0.583651, -1.943372>,
      < 1.300463, -0.574538, -1.943366>,
      < 1.236184, -0.581362, -1.925183>
    }
    triangle {
      < 1.302408, -0.583651, -1.943372>,
      < 1.236184, -0.581362, -1.925183>,
      < 1.240950, -0.603689, -1.925197>
    }
    triangle {
      < 1.240950, -0.603689, -1.925197>,
      < 1.236184, -0.581362, -1.925183>,
      < 1.236187, -0.581369, -1.912207>
    }
    triangle {
      < 1.240950, -0.603689, -1.925197>,
      < 1.236187, -0.581369, -1.912207>,
      < 1.240954, -0.603697, -1.912222>
    }
    triangle {
      < 1.240954, -0.603697, -1.912222>,
      < 1.236187, -0.581369, -1.912207>,
      < 1.216238, -0.583484, -1.912202>
    }
    triangle {
      < 1.240954, -0.603697, -1.912222>,
      < 1.216238, -0.583484, -1.912202>,
      < 1.221879, -0.609912, -1.912219>
    }
    triangle {
      < 1.221879, -0.609912, -1.912219>,
      < 1.216238, -0.583484, -1.912202>,
      < 1.207378, -0.584440, -1.883653>
    }
    triangle {
      < 1.221879, -0.609912, -1.912219>,
      < 1.207378, -0.584440, -1.883653>,
      < 1.213408, -0.612691, -1.883672>
    }
    triangle {
      < 1.213408, -0.612691, -1.883672>,
      < 1.207378, -0.584440, -1.883653>,
      < 1.145314, -0.591027, -1.870660>
    }
    triangle {
      < 1.213408, -0.612691, -1.883672>,
      < 1.145314, -0.591027, -1.870660>,
      < 1.154068, -0.632035, -1.870687>
    }
    triangle {
      < 1.154068, -0.632035, -1.870687>,
      < 1.145314, -0.591027, -1.870660>,
      < 1.109844, -0.594775, -1.886220>
    }
    triangle {
      < 1.154068, -0.632035, -1.870687>,
      < 1.109844, -0.594775, -1.886220>,
      < 1.120153, -0.643075, -1.886253>
    }
    triangle {
      < 1.120153, -0.643075, -1.886253>,
      < 1.109844, -0.594775, -1.886220>,
      < 1.083235, -0.597575, -1.919949>
    }
    triangle {
      < 1.120153, -0.643075, -1.886253>,
      < 1.083235, -0.597575, -1.919949>,
      < 1.094712, -0.651341, -1.919985>
    }
    triangle {
      < 1.094712, -0.651341, -1.919985>,
      < 1.083235, -0.597575, -1.919949>,
      < 1.078797, -0.598031, -1.943304>
    }
    triangle {
      < 1.094712, -0.651341, -1.919985>,
      < 1.078797, -0.598031, -1.943304>,
      < 1.090466, -0.652709, -1.943340>
    }
    triangle {
      < 1.090466, -0.652709, -1.943340>,
      < 1.078797, -0.598031, -1.943304>,
      < 1.078790, -0.598016, -1.967309>
    }
    triangle {
      < 1.090466, -0.652709, -1.943340>,
      < 1.078790, -0.598016, -1.967309>,
      < 1.090461, -0.652695, -1.967345>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.313766, -0.566625, -1.909629>,
      < 1.313771, -0.573149, -1.909634>
    }
    triangle {
      < 1.313771, -0.573149, -1.909634>,
      < 1.313766, -0.566625, -1.909629>,
      < 1.300455, -0.565219, -1.943360>
    }
    triangle {
      < 1.313771, -0.573149, -1.909634>,
      < 1.300455, -0.565219, -1.943360>,
      < 1.300463, -0.574538, -1.943366>
    }
    triangle {
      < 1.300463, -0.574538, -1.943366>,
      < 1.300455, -0.565219, -1.943360>,
      < 1.236164, -0.558531, -1.925169>
    }
    triangle {
      < 1.300463, -0.574538, -1.943366>,
      < 1.236164, -0.558531, -1.925169>,
      < 1.236184, -0.581362, -1.925183>
    }
    triangle {
      < 1.236184, -0.581362, -1.925183>,
      < 1.236164, -0.558531, -1.925169>,
      < 1.236168, -0.558539, -1.912194>
    }
    triangle {
      < 1.236184, -0.581362, -1.925183>,
      < 1.236168, -0.558539, -1.912194>,
      < 1.236187, -0.581369, -1.912207>
    }
    triangle {
      < 1.236187, -0.581369, -1.912207>,
      < 1.236168, -0.558539, -1.912194>,
      < 1.216214, -0.556461, -1.912186>
    }
    triangle {
      < 1.236187, -0.581369, -1.912207>,
      < 1.216214, -0.556461, -1.912186>,
      < 1.216238, -0.583484, -1.912202>
    }
    triangle {
      < 1.216238, -0.583484, -1.912202>,
      < 1.216214, -0.556461, -1.912186>,
      < 1.207352, -0.555554, -1.883636>
    }
    triangle {
      < 1.216238, -0.583484, -1.912202>,
      < 1.207352, -0.555554, -1.883636>,
      < 1.207378, -0.584440, -1.883653>
    }
    triangle {
      < 1.207378, -0.584440, -1.883653>,
      < 1.207352, -0.555554, -1.883636>,
      < 1.145277, -0.549094, -1.870635>
    }
    triangle {
      < 1.207378, -0.584440, -1.883653>,
      < 1.145277, -0.549094, -1.870635>,
      < 1.145314, -0.591027, -1.870660>
    }
    triangle {
      < 1.145314, -0.591027, -1.870660>,
      < 1.145277, -0.549094, -1.870635>,
      < 1.109800, -0.545388, -1.886191>
    }
    triangle {
      < 1.145314, -0.591027, -1.870660>,
      < 1.109800, -0.545388, -1.886191>,
      < 1.109844, -0.594775, -1.886220>
    }
    triangle {
      < 1.109844, -0.594775, -1.886220>,
      < 1.109800, -0.545388, -1.886191>,
      < 1.083187, -0.542597, -1.919916>
    }
    triangle {
      < 1.109844, -0.594775, -1.886220>,
      < 1.083187, -0.542597, -1.919916>,
      < 1.083235, -0.597575, -1.919949>
    }
    triangle {
      < 1.083235, -0.597575, -1.919949>,
      < 1.083187, -0.542597, -1.919916>,
      < 1.078746, -0.542120, -1.943270>
    }
    triangle {
      < 1.083235, -0.597575, -1.919949>,
      < 1.078746, -0.542120, -1.943270>,
      < 1.078797, -0.598031, -1.943304>
    }
    triangle {
      < 1.078797, -0.598031, -1.943304>,
      < 1.078746, -0.542120, -1.943270>,
      < 1.078740, -0.542107, -1.967276>
    }
    triangle {
      < 1.078797, -0.598031, -1.943304>,
      < 1.078740, -0.542107, -1.967276>,
      < 1.078790, -0.598016, -1.967309>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.315116, -0.560244, -1.909627>,
      < 1.313766, -0.566625, -1.909629>
    }
    triangle {
      < 1.313766, -0.566625, -1.909629>,
      < 1.315116, -0.560244, -1.909627>,
      < 1.302384, -0.556103, -1.943356>
    }
    triangle {
      < 1.313766, -0.566625, -1.909629>,
      < 1.302384, -0.556103, -1.943356>,
      < 1.300455, -0.565219, -1.943360>
    }
    triangle {
      < 1.300455, -0.565219, -1.943360>,
      < 1.302384, -0.556103, -1.943356>,
      < 1.240890, -0.536196, -1.925157>
    }
    triangle {
      < 1.300455, -0.565219, -1.943360>,
      < 1.240890, -0.536196, -1.925157>,
      < 1.236164, -0.558531, -1.925169>
    }
    triangle {
      < 1.236164, -0.558531, -1.925169>,
      < 1.240890, -0.536196, -1.925157>,
      < 1.240894, -0.536204, -1.912182>
    }
    triangle {
      < 1.236164, -0.558531, -1.925169>,
      < 1.240894, -0.536204, -1.912182>,
      < 1.236168, -0.558539, -1.912194>
    }
    triangle {
      < 1.236168, -0.558539, -1.912194>,
      < 1.240894, -0.536204, -1.912182>,
      < 1.221807, -0.530022, -1.912171>
    }
    triangle {
      < 1.236168, -0.558539, -1.912194>,
      < 1.221807, -0.530022, -1.912171>,
      < 1.216214, -0.556461, -1.912186>
    }
    triangle {
      < 1.216214, -0.556461, -1.912186>,
      < 1.221807, -0.530022, -1.912171>,
      < 1.213332, -0.527291, -1.883621>
    }
    triangle {
      < 1.216214, -0.556461, -1.912186>,
      < 1.213332, -0.527291, -1.883621>,
      < 1.207352, -0.555554, -1.883636>
    }
    triangle {
      < 1.207352, -0.555554, -1.883636>,
      < 1.213332, -0.527291, -1.883621>,
      < 1.153958, -0.508069, -1.870614>
    }
    triangle {
      < 1.207352, -0.555554, -1.883636>,
      < 1.153958, -0.508069, -1.870614>,
      < 1.145277, -0.549094, -1.870635>
    }
    triangle {
      < 1.145277, -0.549094, -1.870635>,
      < 1.153958, -0.508069, -1.870614>,
      < 1.120023, -0.497071, -1.886166>
    }
    triangle {
      < 1.145277, -0.549094, -1.870635>,
      < 1.120023, -0.497071, -1.886166>,
      < 1.109800, -0.545388, -1.886191>
    }
    triangle {
      < 1.109800, -0.545388, -1.886191>,
      < 1.120023, -0.497071, -1.886166>,
      < 1.094567, -0.488809, -1.919889>
    }
    triangle {
      < 1.109800, -0.545388, -1.886191>,
      < 1.094567, -0.488809, -1.919889>,
      < 1.083187, -0.542597, -1.919916>
    }
    triangle {
      < 1.083187, -0.542597, -1.919916>,
      < 1.094567, -0.488809, -1.919889>,
      < 1.090320, -0.487421, -1.943242>
    }
    triangle {
      < 1.083187, -0.542597, -1.919916>,
      < 1.090320, -0.487421, -1.943242>,
      < 1.078746, -0.542120, -1.943270>
    }
    triangle {
      < 1.078746, -0.542120, -1.943270>,
      < 1.090320, -0.487421, -1.943242>,
      < 1.090314, -0.487407, -1.967248>
    }
    triangle {
      < 1.078746, -0.542120, -1.943270>,
      < 1.090314, -0.487407, -1.967248>,
      < 1.078740, -0.542107, -1.967276>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.317763, -0.554282, -1.909624>,
      < 1.315116, -0.560244, -1.909627>
    }
    triangle {
      < 1.315116, -0.560244, -1.909627>,
      < 1.317763, -0.554282, -1.909624>,
      < 1.306166, -0.547587, -1.943352>
    }
    triangle {
      < 1.315116, -0.560244, -1.909627>,
      < 1.306166, -0.547587, -1.943352>,
      < 1.302384, -0.556103, -1.943356>
    }
    triangle {
      < 1.302384, -0.556103, -1.943356>,
      < 1.306166, -0.547587, -1.943352>,
      < 1.250155, -0.515331, -1.925148>
    }
    triangle {
      < 1.302384, -0.556103, -1.943356>,
      < 1.250155, -0.515331, -1.925148>,
      < 1.240890, -0.536196, -1.925157>
    }
    triangle {
      < 1.240890, -0.536196, -1.925157>,
      < 1.250155, -0.515331, -1.925148>,
      < 1.250158, -0.515338, -1.912173>
    }
    triangle {
      < 1.240890, -0.536196, -1.925157>,
      < 1.250158, -0.515338, -1.912173>,
      < 1.240894, -0.536204, -1.912182>
    }
    triangle {
      < 1.240894, -0.536204, -1.912182>,
      < 1.250158, -0.515338, -1.912173>,
      < 1.232775, -0.505325, -1.912161>
    }
    triangle {
      < 1.240894, -0.536204, -1.912182>,
      < 1.232775, -0.505325, -1.912161>,
      < 1.221807, -0.530022, -1.912171>
    }
    triangle {
      < 1.221807, -0.530022, -1.912171>,
      < 1.232775, -0.505325, -1.912161>,
      < 1.225056, -0.500891, -1.883609>
    }
    triangle {
      < 1.221807, -0.530022, -1.912171>,
      < 1.225056, -0.500891, -1.883609>,
      < 1.213332, -0.527291, -1.883621>
    }
    triangle {
      < 1.213332, -0.527291, -1.883621>,
      < 1.225056, -0.500891, -1.883609>,
      < 1.170977, -0.469745, -1.870597>
    }
    triangle {
      < 1.213332, -0.527291, -1.883621>,
      < 1.170977, -0.469745, -1.870597>,
      < 1.153958, -0.508069, -1.870614>
    }
    triangle {
      < 1.153958, -0.508069, -1.870614>,
      < 1.170977, -0.469745, -1.870597>,
      < 1.140067, -0.451934, -1.886146>
    }
    triangle {
      < 1.153958, -0.508069, -1.870614>,
      < 1.140067, -0.451934, -1.886146>,
      < 1.120023, -0.497071, -1.886166>
    }
    triangle {
      < 1.120023, -0.497071, -1.886166>,
      < 1.140067, -0.451934, -1.886146>,
      < 1.116881, -0.438562, -1.919867>
    }
    triangle {
      < 1.120023, -0.497071, -1.886166>,
      < 1.116881, -0.438562, -1.919867>,
      < 1.094567, -0.488809, -1.919889>
    }
    triangle {
      < 1.094567, -0.488809, -1.919889>,
      < 1.116881, -0.438562, -1.919867>,
      < 1.113011, -0.436323, -1.943220>
    }
    triangle {
      < 1.094567, -0.488809, -1.919889>,
      < 1.113011, -0.436323, -1.943220>,
      < 1.090320, -0.487421, -1.943242>
    }
    triangle {
      < 1.090320, -0.487421, -1.943242>,
      < 1.113011, -0.436323, -1.943220>,
      < 1.113006, -0.436309, -1.967225>
    }
    triangle {
      < 1.090320, -0.487421, -1.943242>,
      < 1.113006, -0.436309, -1.967225>,
      < 1.090314, -0.487407, -1.967248>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.321592, -0.549001, -1.909622>,
      < 1.317763, -0.554282, -1.909624>
    }
    triangle {
      < 1.317763, -0.554282, -1.909624>,
      < 1.321592, -0.549001, -1.909622>,
      < 1.311635, -0.540042, -1.943350>
    }
    triangle {
      < 1.317763, -0.554282, -1.909624>,
      < 1.311635, -0.540042, -1.943350>,
      < 1.306166, -0.547587, -1.943352>
    }
    triangle {
      < 1.306166, -0.547587, -1.943352>,
      < 1.311635, -0.540042, -1.943350>,
      < 1.263556, -0.496847, -1.925142>
    }
    triangle {
      < 1.306166, -0.547587, -1.943352>,
      < 1.263556, -0.496847, -1.925142>,
      < 1.250155, -0.515331, -1.925148>
    }
    triangle {
      < 1.250155, -0.515331, -1.925148>,
      < 1.263556, -0.496847, -1.925142>,
      < 1.263559, -0.496855, -1.912166>
    }
    triangle {
      < 1.250155, -0.515331, -1.925148>,
      < 1.263559, -0.496855, -1.912166>,
      < 1.250158, -0.515338, -1.912173>
    }
    triangle {
      < 1.250158, -0.515338, -1.912173>,
      < 1.263559, -0.496855, -1.912166>,
      < 1.248637, -0.483446, -1.912154>
    }
    triangle {
      < 1.250158, -0.515338, -1.912173>,
      < 1.248637, -0.483446, -1.912154>,
      < 1.232775, -0.505325, -1.912161>
    }
    triangle {
      < 1.232775, -0.505325, -1.912161>,
      < 1.248637, -0.483446, -1.912154>,
      < 1.242011, -0.477504, -1.883602>
    }
    triangle {
      < 1.232775, -0.505325, -1.912161>,
      < 1.242011, -0.477504, -1.883602>,
      < 1.225056, -0.500891, -1.883609>
    }
    triangle {
      < 1.225056, -0.500891, -1.883609>,
      < 1.242011, -0.477504, -1.883602>,
      < 1.195590, -0.435796, -1.870585>
    }
    triangle {
      < 1.225056, -0.500891, -1.883609>,
      < 1.195590, -0.435796, -1.870585>,
      < 1.170977, -0.469745, -1.870597>
    }
    triangle {
      < 1.170977, -0.469745, -1.870597>,
      < 1.195590, -0.435796, -1.870585>,
      < 1.169057, -0.411949, -1.886132>
    }
    triangle {
      < 1.170977, -0.469745, -1.870597>,
      < 1.169057, -0.411949, -1.886132>,
      < 1.140067, -0.451934, -1.886146>
    }
    triangle {
      < 1.140067, -0.451934, -1.886146>,
      < 1.169057, -0.411949, -1.886132>,
      < 1.149151, -0.394051, -1.919851>
    }
    triangle {
      < 1.140067, -0.451934, -1.886146>,
      < 1.149151, -0.394051, -1.919851>,
      < 1.116881, -0.438562, -1.919867>
    }
    triangle {
      < 1.116881, -0.438562, -1.919867>,
      < 1.149151, -0.394051, -1.919851>,
      < 1.145829, -0.391058, -1.943204>
    }
    triangle {
      < 1.116881, -0.438562, -1.919867>,
      < 1.145829, -0.391058, -1.943204>,
      < 1.113011, -0.436323, -1.943220>
    }
    triangle {
      < 1.113011, -0.436323, -1.943220>,
      < 1.145829, -0.391058, -1.943204>,
      < 1.145822, -0.391044, -1.967209>
    }
    triangle {
      < 1.113011, -0.436323, -1.943220>,
      < 1.145822, -0.391044, -1.967209>,
      < 1.113006, -0.436309, -1.967225>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.326435, -0.544632, -1.909621>,
      < 1.321592, -0.549001, -1.909622>
    }
    triangle {
      < 1.321592, -0.549001, -1.909622>,
      < 1.326435, -0.544632, -1.909621>,
      < 1.318554, -0.533799, -1.943349>
    }
    triangle {
      < 1.321592, -0.549001, -1.909622>,
      < 1.318554, -0.533799, -1.943349>,
      < 1.311635, -0.540042, -1.943350>
    }
    triangle {
      < 1.311635, -0.540042, -1.943350>,
      < 1.318554, -0.533799, -1.943349>,
      < 1.280506, -0.481554, -1.925139>
    }
    triangle {
      < 1.311635, -0.540042, -1.943350>,
      < 1.280506, -0.481554, -1.925139>,
      < 1.263556, -0.496847, -1.925142>
    }
    triangle {
      < 1.263556, -0.496847, -1.925142>,
      < 1.280506, -0.481554, -1.925139>,
      < 1.280509, -0.481561, -1.912164>
    }
    triangle {
      < 1.263556, -0.496847, -1.925142>,
      < 1.280509, -0.481561, -1.912164>,
      < 1.263559, -0.496855, -1.912166>
    }
    triangle {
      < 1.263559, -0.496855, -1.912166>,
      < 1.280509, -0.481561, -1.912164>,
      < 1.268701, -0.465343, -1.912149>
    }
    triangle {
      < 1.263559, -0.496855, -1.912166>,
      < 1.268701, -0.465343, -1.912149>,
      < 1.248637, -0.483446, -1.912154>
    }
    triangle {
      < 1.248637, -0.483446, -1.912154>,
      < 1.268701, -0.465343, -1.912149>,
      < 1.263458, -0.458152, -1.883597>
    }
    triangle {
      < 1.248637, -0.483446, -1.912154>,
      < 1.263458, -0.458152, -1.883597>,
      < 1.242011, -0.477504, -1.883602>
    }
    triangle {
      < 1.242011, -0.477504, -1.883602>,
      < 1.263458, -0.458152, -1.883597>,
      < 1.226722, -0.407705, -1.870579>
    }
    triangle {
      < 1.242011, -0.477504, -1.883602>,
      < 1.226722, -0.407705, -1.870579>,
      < 1.195590, -0.435796, -1.870585>
    }
    triangle {
      < 1.195590, -0.435796, -1.870585>,
      < 1.226722, -0.407705, -1.870579>,
      < 1.205723, -0.378864, -1.886126>
    }
    triangle {
      < 1.195590, -0.435796, -1.870585>,
      < 1.205723, -0.378864, -1.886126>,
      < 1.169057, -0.411949, -1.886132>
    }
    triangle {
      < 1.169057, -0.411949, -1.886132>,
      < 1.205723, -0.378864, -1.886126>,
      < 1.189969, -0.357221, -1.919844>
    }
    triangle {
      < 1.169057, -0.411949, -1.886132>,
      < 1.189969, -0.357221, -1.919844>,
      < 1.149151, -0.394051, -1.919851>
    }
    triangle {
      < 1.149151, -0.394051, -1.919851>,
      < 1.189969, -0.357221, -1.919844>,
      < 1.187339, -0.353603, -1.943196>
    }
    triangle {
      < 1.149151, -0.394051, -1.919851>,
      < 1.187339, -0.353603, -1.943196>,
      < 1.145829, -0.391058, -1.943204>
    }
    triangle {
      < 1.145829, -0.391058, -1.943204>,
      < 1.187339, -0.353603, -1.943196>,
      < 1.187334, -0.353589, -1.967201>
    }
    triangle {
      < 1.145829, -0.391058, -1.943204>,
      < 1.187334, -0.353589, -1.967201>,
      < 1.145822, -0.391044, -1.967209>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.332081, -0.541364, -1.909621>,
      < 1.326435, -0.544632, -1.909621>
    }
    triangle {
      < 1.326435, -0.544632, -1.909621>,
      < 1.332081, -0.541364, -1.909621>,
      < 1.326618, -0.529131, -1.943348>
    }
    triangle {
      < 1.326435, -0.544632, -1.909621>,
      < 1.326618, -0.529131, -1.943348>,
      < 1.318554, -0.533799, -1.943349>
    }
    triangle {
      < 1.318554, -0.533799, -1.943349>,
      < 1.326618, -0.529131, -1.943348>,
      < 1.300265, -0.470117, -1.925138>
    }
    triangle {
      < 1.318554, -0.533799, -1.943349>,
      < 1.300265, -0.470117, -1.925138>,
      < 1.280506, -0.481554, -1.925139>
    }
    triangle {
      < 1.280506, -0.481554, -1.925139>,
      < 1.300265, -0.470117, -1.925138>,
      < 1.300268, -0.470125, -1.912163>
    }
    triangle {
      < 1.280506, -0.481554, -1.925139>,
      < 1.300268, -0.470125, -1.912163>,
      < 1.280509, -0.481561, -1.912164>
    }
    triangle {
      < 1.280509, -0.481561, -1.912164>,
      < 1.300268, -0.470125, -1.912163>,
      < 1.292088, -0.451806, -1.912149>
    }
    triangle {
      < 1.280509, -0.481561, -1.912164>,
      < 1.292088, -0.451806, -1.912149>,
      < 1.268701, -0.465343, -1.912149>
    }
    triangle {
      < 1.268701, -0.465343, -1.912149>,
      < 1.292088, -0.451806, -1.912149>,
      < 1.288459, -0.443682, -1.883597>
    }
    triangle {
      < 1.268701, -0.465343, -1.912149>,
      < 1.288459, -0.443682, -1.883597>,
      < 1.263458, -0.458152, -1.883597>
    }
    triangle {
      < 1.263458, -0.458152, -1.883597>,
      < 1.288459, -0.443682, -1.883597>,
      < 1.263014, -0.386699, -1.870579>
    }
    triangle {
      < 1.263458, -0.458152, -1.883597>,
      < 1.263014, -0.386699, -1.870579>,
      < 1.226722, -0.407705, -1.870579>
    }
    triangle {
      < 1.226722, -0.407705, -1.870579>,
      < 1.263014, -0.386699, -1.870579>,
      < 1.248467, -0.354124, -1.886126>
    }
    triangle {
      < 1.226722, -0.407705, -1.870579>,
      < 1.248467, -0.354124, -1.886126>,
      < 1.205723, -0.378864, -1.886126>
    }
    triangle {
      < 1.205723, -0.378864, -1.886126>,
      < 1.248467, -0.354124, -1.886126>,
      < 1.237552, -0.329679, -1.919843>
    }
    triangle {
      < 1.205723, -0.378864, -1.886126>,
      < 1.237552, -0.329679, -1.919843>,
      < 1.189969, -0.357221, -1.919844>
    }
    triangle {
      < 1.189969, -0.357221, -1.919844>,
      < 1.237552, -0.329679, -1.919843>,
      < 1.235728, -0.325595, -1.943197>
    }
    triangle {
      < 1.189969, -0.357221, -1.919844>,
      < 1.235728, -0.325595, -1.943197>,
      < 1.187339, -0.353603, -1.943196>
    }
    triangle {
      < 1.187339, -0.353603, -1.943196>,
      < 1.235728, -0.325595, -1.943197>,
      < 1.235722, -0.325581, -1.967202>
    }
    triangle {
      < 1.187339, -0.353603, -1.943196>,
      < 1.235722, -0.325581, -1.967202>,
      < 1.187334, -0.353589, -1.967201>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.345271, -0.572039, -1.909644>,
      < 1.338282, -0.539341, -1.909622>
    }
    triangle {
      < 1.347022, -0.569625, -1.909643>,
      < 1.338282, -0.539341, -1.909622>,
      < 1.332081, -0.541364, -1.909621>
    }
    triangle {
      < 1.332081, -0.541364, -1.909621>,
      < 1.338282, -0.539341, -1.909622>,
      < 1.335478, -0.526243, -1.943349>
    }
    triangle {
      < 1.332081, -0.541364, -1.909621>,
      < 1.335478, -0.526243, -1.943349>,
      < 1.326618, -0.529131, -1.943348>
    }
    triangle {
      < 1.326618, -0.529131, -1.943348>,
      < 1.335478, -0.526243, -1.943349>,
      < 1.321970, -0.463038, -1.925142>
    }
    triangle {
      < 1.326618, -0.529131, -1.943348>,
      < 1.321970, -0.463038, -1.925142>,
      < 1.300265, -0.470117, -1.925138>
    }
    triangle {
      < 1.300265, -0.470117, -1.925138>,
      < 1.321970, -0.463038, -1.925142>,
      < 1.321974, -0.463045, -1.912167>
    }
    triangle {
      < 1.300265, -0.470117, -1.925138>,
      < 1.321974, -0.463045, -1.912167>,
      < 1.300268, -0.470125, -1.912163>
    }
    triangle {
      < 1.300268, -0.470125, -1.912163>,
      < 1.321974, -0.463045, -1.912167>,
      < 1.317779, -0.443427, -1.912154>
    }
    triangle {
      < 1.300268, -0.470125, -1.912163>,
      < 1.317779, -0.443427, -1.912154>,
      < 1.292088, -0.451806, -1.912149>
    }
    triangle {
      < 1.292088, -0.451806, -1.912149>,
      < 1.317779, -0.443427, -1.912154>,
      < 1.315923, -0.434724, -1.883602>
    }
    triangle {
      < 1.292088, -0.451806, -1.912149>,
      < 1.315923, -0.434724, -1.883602>,
      < 1.288459, -0.443682, -1.883597>
    }
    triangle {
      < 1.288459, -0.443682, -1.883597>,
      < 1.315923, -0.434724, -1.883602>,
      < 1.302880, -0.373697, -1.870586>
    }
    triangle {
      < 1.288459, -0.443682, -1.883597>,
      < 1.302880, -0.373697, -1.870586>,
      < 1.263014, -0.386699, -1.870579>
    }
    triangle {
      < 1.263014, -0.386699, -1.870579>,
      < 1.302880, -0.373697, -1.870586>,
      < 1.295421, -0.338809, -1.886133>
    }
    triangle {
      < 1.263014, -0.386699, -1.870579>,
      < 1.295421, -0.338809, -1.886133>,
      < 1.248467, -0.354124, -1.886126>
    }
    triangle {
      < 1.248467, -0.354124, -1.886126>,
      < 1.295421, -0.338809, -1.886133>,
      < 1.289820, -0.312632, -1.919851>
    }
    triangle {
      < 1.248467, -0.354124, -1.886126>,
      < 1.289820, -0.312632, -1.919851>,
      < 1.237552, -0.329679, -1.919843>
    }
    triangle {
      < 1.237552, -0.329679, -1.919843>,
      < 1.289820, -0.312632, -1.919851>,
      < 1.288882, -0.308258, -1.943204>
    }
    triangle {
      < 1.237552, -0.329679, -1.919843>,
      < 1.288882, -0.308258, -1.943204>,
      < 1.235728, -0.325595, -1.943197>
    }
    triangle {
      < 1.235728, -0.325595, -1.943197>,
      < 1.288882, -0.308258, -1.943204>,
      < 1.288876, -0.308243, -1.967210>
    }
    triangle {
      < 1.235728, -0.325595, -1.943197>,
      < 1.288876, -0.308243, -1.967210>,
      < 1.235722, -0.325581, -1.967202>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.344769, -0.538652, -1.909624>,
      < 1.338282, -0.539341, -1.909622>
    }
    triangle {
      < 1.338282, -0.539341, -1.909622>,
      < 1.344769, -0.538652, -1.909624>,
      < 1.344744, -0.525258, -1.943353>
    }
    triangle {
      < 1.338282, -0.539341, -1.909622>,
      < 1.344744, -0.525258, -1.943353>,
      < 1.335478, -0.526243, -1.943349>
    }
    triangle {
      < 1.335478, -0.526243, -1.943349>,
      < 1.344744, -0.525258, -1.943353>,
      < 1.344672, -0.460625, -1.925148>
    }
    triangle {
      < 1.335478, -0.526243, -1.943349>,
      < 1.344672, -0.460625, -1.925148>,
      < 1.321970, -0.463038, -1.925142>
    }
    triangle {
      < 1.321970, -0.463038, -1.925142>,
      < 1.344672, -0.460625, -1.925148>,
      < 1.344675, -0.460633, -1.912172>
    }
    triangle {
      < 1.321970, -0.463038, -1.925142>,
      < 1.344675, -0.460633, -1.912172>,
      < 1.321974, -0.463045, -1.912167>
    }
    triangle {
      < 1.321974, -0.463045, -1.912167>,
      < 1.344675, -0.460633, -1.912172>,
      < 1.344651, -0.440571, -1.912161>
    }
    triangle {
      < 1.321974, -0.463045, -1.912167>,
      < 1.344651, -0.440571, -1.912161>,
      < 1.317779, -0.443427, -1.912154>
    }
    triangle {
      < 1.317779, -0.443427, -1.912154>,
      < 1.344651, -0.440571, -1.912161>,
      < 1.344647, -0.431671, -1.883609>
    }
    triangle {
      < 1.317779, -0.443427, -1.912154>,
      < 1.344647, -0.431671, -1.883609>,
      < 1.315923, -0.434724, -1.883602>
    }
    triangle {
      < 1.315923, -0.434724, -1.883602>,
      < 1.344647, -0.431671, -1.883609>,
      < 1.344577, -0.369265, -1.870597>
    }
    triangle {
      < 1.315923, -0.434724, -1.883602>,
      < 1.344577, -0.369265, -1.870597>,
      < 1.302880, -0.373697, -1.870586>
    }
    triangle {
      < 1.302880, -0.373697, -1.870586>,
      < 1.344577, -0.369265, -1.870597>,
      < 1.344531, -0.333590, -1.886147>
    }
    triangle {
      < 1.302880, -0.373697, -1.870586>,
      < 1.344531, -0.333590, -1.886147>,
      < 1.295421, -0.338809, -1.886133>
    }
    triangle {
      < 1.295421, -0.338809, -1.886133>,
      < 1.344531, -0.333590, -1.886147>,
      < 1.344491, -0.306821, -1.919867>
    }
    triangle {
      < 1.295421, -0.338809, -1.886133>,
      < 1.344491, -0.306821, -1.919867>,
      < 1.289820, -0.312632, -1.919851>
    }
    triangle {
      < 1.289820, -0.312632, -1.919851>,
      < 1.344491, -0.306821, -1.919867>,
      < 1.344480, -0.302349, -1.943220>
    }
    triangle {
      < 1.289820, -0.312632, -1.919851>,
      < 1.344480, -0.302349, -1.943220>,
      < 1.288882, -0.308258, -1.943204>
    }
    triangle {
      < 1.288882, -0.308258, -1.943204>,
      < 1.344480, -0.302349, -1.943220>,
      < 1.344474, -0.302335, -1.967226>
    }
    triangle {
      < 1.288882, -0.308258, -1.943204>,
      < 1.344474, -0.302335, -1.967226>,
      < 1.288876, -0.308243, -1.967210>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.351256, -0.539326, -1.909627>,
      < 1.344769, -0.538652, -1.909624>
    }
    triangle {
      < 1.344769, -0.538652, -1.909624>,
      < 1.351256, -0.539326, -1.909627>,
      < 1.354012, -0.526220, -1.943356>
    }
    triangle {
      < 1.344769, -0.538652, -1.909624>,
      < 1.354012, -0.526220, -1.943356>,
      < 1.344744, -0.525258, -1.943353>
    }
    triangle {
      < 1.344744, -0.525258, -1.943353>,
      < 1.354012, -0.526220, -1.943356>,
      < 1.367380, -0.462984, -1.925158>
    }
    triangle {
      < 1.344744, -0.525258, -1.943353>,
      < 1.367380, -0.462984, -1.925158>,
      < 1.344672, -0.460625, -1.925148>
    }
    triangle {
      < 1.344672, -0.460625, -1.925148>,
      < 1.367380, -0.462984, -1.925158>,
      < 1.367383, -0.462992, -1.912182>
    }
    triangle {
      < 1.344672, -0.460625, -1.925148>,
      < 1.367383, -0.462992, -1.912182>,
      < 1.344675, -0.460633, -1.912172>
    }
    triangle {
      < 1.344675, -0.460633, -1.912172>,
      < 1.367383, -0.462992, -1.912182>,
      < 1.371530, -0.443363, -1.912172>
    }
    triangle {
      < 1.344675, -0.460633, -1.912172>,
      < 1.371530, -0.443363, -1.912172>,
      < 1.344651, -0.440571, -1.912161>
    }
    triangle {
      < 1.344651, -0.440571, -1.912161>,
      < 1.371530, -0.443363, -1.912172>,
      < 1.373380, -0.434656, -1.883622>
    }
    triangle {
      < 1.344651, -0.440571, -1.912161>,
      < 1.373380, -0.434656, -1.883622>,
      < 1.344647, -0.431671, -1.883609>
    }
    triangle {
      < 1.344647, -0.431671, -1.883609>,
      < 1.373380, -0.434656, -1.883622>,
      < 1.386285, -0.373598, -1.870615>
    }
    triangle {
      < 1.344647, -0.431671, -1.883609>,
      < 1.386285, -0.373598, -1.870615>,
      < 1.344577, -0.369265, -1.870597>
    }
    triangle {
      < 1.344577, -0.369265, -1.870597>,
      < 1.386285, -0.373598, -1.870615>,
      < 1.393654, -0.338694, -1.886167>
    }
    triangle {
      < 1.344577, -0.369265, -1.870597>,
      < 1.393654, -0.338694, -1.886167>,
      < 1.344531, -0.333590, -1.886147>
    }
    triangle {
      < 1.344531, -0.333590, -1.886147>,
      < 1.393654, -0.338694, -1.886167>,
      < 1.399174, -0.312502, -1.919889>
    }
    triangle {
      < 1.344531, -0.333590, -1.886147>,
      < 1.399174, -0.312502, -1.919889>,
      < 1.344491, -0.306821, -1.919867>
    }
    triangle {
      < 1.344491, -0.306821, -1.919867>,
      < 1.399174, -0.312502, -1.919889>,
      < 1.400090, -0.308127, -1.943243>
    }
    triangle {
      < 1.344491, -0.306821, -1.919867>,
      < 1.400090, -0.308127, -1.943243>,
      < 1.344480, -0.302349, -1.943220>
    }
    triangle {
      < 1.344480, -0.302349, -1.943220>,
      < 1.400090, -0.308127, -1.943243>,
      < 1.400084, -0.308112, -1.967248>
    }
    triangle {
      < 1.344480, -0.302349, -1.943220>,
      < 1.400084, -0.308112, -1.967248>,
      < 1.344474, -0.302335, -1.967226>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.357462, -0.541334, -1.909630>,
      < 1.351256, -0.539326, -1.909627>
    }
    triangle {
      < 1.351256, -0.539326, -1.909627>,
      < 1.357462, -0.541334, -1.909630>,
      < 1.362878, -0.529089, -1.943361>
    }
    triangle {
      < 1.351256, -0.539326, -1.909627>,
      < 1.362878, -0.529089, -1.943361>,
      < 1.354012, -0.526220, -1.943356>
    }
    triangle {
      < 1.354012, -0.526220, -1.943356>,
      < 1.362878, -0.529089, -1.943361>,
      < 1.389101, -0.470012, -1.925169>
    }
    triangle {
      < 1.354012, -0.526220, -1.943356>,
      < 1.389101, -0.470012, -1.925169>,
      < 1.367380, -0.462984, -1.925158>
    }
    triangle {
      < 1.367380, -0.462984, -1.925158>,
      < 1.389101, -0.470012, -1.925169>,
      < 1.389104, -0.470019, -1.912194>
    }
    triangle {
      < 1.367380, -0.462984, -1.925158>,
      < 1.389104, -0.470019, -1.912194>,
      < 1.367383, -0.462992, -1.912182>
    }
    triangle {
      < 1.367383, -0.462992, -1.912182>,
      < 1.389104, -0.470019, -1.912194>,
      < 1.397241, -0.451681, -1.912186>
    }
    triangle {
      < 1.367383, -0.462992, -1.912182>,
      < 1.397241, -0.451681, -1.912186>,
      < 1.371530, -0.443363, -1.912172>
    }
    triangle {
      < 1.371530, -0.443363, -1.912172>,
      < 1.397241, -0.451681, -1.912186>,
      < 1.400864, -0.443548, -1.883636>
    }
    triangle {
      < 1.371530, -0.443363, -1.912172>,
      < 1.400864, -0.443548, -1.883636>,
      < 1.373380, -0.434656, -1.883622>
    }
    triangle {
      < 1.373380, -0.434656, -1.883622>,
      < 1.400864, -0.443548, -1.883636>,
      < 1.426182, -0.386507, -1.870635>
    }
    triangle {
      < 1.373380, -0.434656, -1.883622>,
      < 1.426182, -0.386507, -1.870635>,
      < 1.386285, -0.373598, -1.870615>
    }
    triangle {
      < 1.386285, -0.373598, -1.870615>,
      < 1.426182, -0.386507, -1.870635>,
      < 1.440643, -0.353896, -1.886192>
    }
    triangle {
      < 1.386285, -0.373598, -1.870615>,
      < 1.440643, -0.353896, -1.886192>,
      < 1.393654, -0.338694, -1.886167>
    }
    triangle {
      < 1.393654, -0.338694, -1.886167>,
      < 1.440643, -0.353896, -1.886192>,
      < 1.451483, -0.329426, -1.919918>
    }
    triangle {
      < 1.393654, -0.338694, -1.886167>,
      < 1.451483, -0.329426, -1.919918>,
      < 1.399174, -0.312502, -1.919889>
    }
    triangle {
      < 1.399174, -0.312502, -1.919889>,
      < 1.451483, -0.329426, -1.919918>,
      < 1.453286, -0.325338, -1.943271>
    }
    triangle {
      < 1.399174, -0.312502, -1.919889>,
      < 1.453286, -0.325338, -1.943271>,
      < 1.400090, -0.308127, -1.943243>
    }
    triangle {
      < 1.400090, -0.308127, -1.943243>,
      < 1.453286, -0.325338, -1.943271>,
      < 1.453280, -0.325323, -1.967276>
    }
    triangle {
      < 1.400090, -0.308127, -1.943243>,
      < 1.453280, -0.325323, -1.967276>,
      < 1.400084, -0.308112, -1.967248>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.363115, -0.544588, -1.909634>,
      < 1.357462, -0.541334, -1.909630>
    }
    triangle {
      < 1.357462, -0.541334, -1.909630>,
      < 1.363115, -0.544588, -1.909634>,
      < 1.370954, -0.533738, -1.943366>
    }
    triangle {
      < 1.357462, -0.541334, -1.909630>,
      < 1.370954, -0.533738, -1.943366>,
      < 1.362878, -0.529089, -1.943361>
    }
    triangle {
      < 1.362878, -0.529089, -1.943361>,
      < 1.370954, -0.533738, -1.943366>,
      < 1.408886, -0.481401, -1.925183>
    }
    triangle {
      < 1.362878, -0.529089, -1.943361>,
      < 1.408886, -0.481401, -1.925183>,
      < 1.389101, -0.470012, -1.925169>
    }
    triangle {
      < 1.389101, -0.470012, -1.925169>,
      < 1.408886, -0.481401, -1.925183>,
      < 1.408890, -0.481409, -1.912207>
    }
    triangle {
      < 1.389101, -0.470012, -1.925169>,
      < 1.408890, -0.481409, -1.912207>,
      < 1.389104, -0.470019, -1.912194>
    }
    triangle {
      < 1.389104, -0.470019, -1.912194>,
      < 1.408890, -0.481409, -1.912207>,
      < 1.420661, -0.465164, -1.912202>
    }
    triangle {
      < 1.389104, -0.470019, -1.912194>,
      < 1.420661, -0.465164, -1.912202>,
      < 1.397241, -0.451681, -1.912186>
    }
    triangle {
      < 1.397241, -0.451681, -1.912186>,
      < 1.420661, -0.465164, -1.912202>,
      < 1.425900, -0.457960, -1.883653>
    }
    triangle {
      < 1.397241, -0.451681, -1.912186>,
      < 1.425900, -0.457960, -1.883653>,
      < 1.400864, -0.443548, -1.883636>
    }
    triangle {
      < 1.400864, -0.443548, -1.883636>,
      < 1.425900, -0.457960, -1.883653>,
      < 1.462524, -0.407426, -1.870661>
    }
    triangle {
      < 1.400864, -0.443548, -1.883636>,
      < 1.462524, -0.407426, -1.870661>,
      < 1.426182, -0.386507, -1.870635>
    }
    triangle {
      < 1.426182, -0.386507, -1.870635>,
      < 1.462524, -0.407426, -1.870661>,
      < 1.483446, -0.378535, -1.886221>
    }
    triangle {
      < 1.426182, -0.386507, -1.870635>,
      < 1.483446, -0.378535, -1.886221>,
      < 1.440643, -0.353896, -1.886192>
    }
    triangle {
      < 1.440643, -0.353896, -1.886192>,
      < 1.483446, -0.378535, -1.886221>,
      < 1.499131, -0.356855, -1.919950>
    }
    triangle {
      < 1.440643, -0.353896, -1.886192>,
      < 1.499131, -0.356855, -1.919950>,
      < 1.451483, -0.329426, -1.919918>
    }
    triangle {
      < 1.451483, -0.329426, -1.919918>,
      < 1.499131, -0.356855, -1.919950>,
      < 1.501741, -0.353231, -1.943305>
    }
    triangle {
      < 1.451483, -0.329426, -1.919918>,
      < 1.501741, -0.353231, -1.943305>,
      < 1.453286, -0.325338, -1.943271>
    }
    triangle {
      < 1.453286, -0.325338, -1.943271>,
      < 1.501741, -0.353231, -1.943305>,
      < 1.501734, -0.353216, -1.967310>
    }
    triangle {
      < 1.453286, -0.325338, -1.943271>,
      < 1.501734, -0.353216, -1.967310>,
      < 1.453280, -0.325323, -1.967276>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.367968, -0.548947, -1.909638>,
      < 1.363115, -0.544588, -1.909634>
    }
    triangle {
      < 1.363115, -0.544588, -1.909634>,
      < 1.367968, -0.548947, -1.909638>,
      < 1.377887, -0.539963, -1.943372>
    }
    triangle {
      < 1.363115, -0.544588, -1.909634>,
      < 1.377887, -0.539963, -1.943372>,
      < 1.370954, -0.533738, -1.943366>
    }
    triangle {
      < 1.370954, -0.533738, -1.943366>,
      < 1.377887, -0.539963, -1.943372>,
      < 1.425874, -0.496655, -1.925197>
    }
    triangle {
      < 1.370954, -0.533738, -1.943366>,
      < 1.425874, -0.496655, -1.925197>,
      < 1.408886, -0.481401, -1.925183>
    }
    triangle {
      < 1.408886, -0.481401, -1.925183>,
      < 1.425874, -0.496655, -1.925197>,
      < 1.425877, -0.496663, -1.912222>
    }
    triangle {
      < 1.408886, -0.481401, -1.925183>,
      < 1.425877, -0.496663, -1.912222>,
      < 1.408890, -0.481409, -1.912207>
    }
    triangle {
      < 1.408890, -0.481409, -1.912207>,
      < 1.425877, -0.496663, -1.912222>,
      < 1.440767, -0.483219, -1.912219>
    }
    triangle {
      < 1.408890, -0.481409, -1.912207>,
      < 1.440767, -0.483219, -1.912219>,
      < 1.420661, -0.465164, -1.912202>
    }
    triangle {
      < 1.420661, -0.465164, -1.912202>,
      < 1.440767, -0.483219, -1.912219>,
      < 1.447393, -0.477261, -1.883673>
    }
    triangle {
      < 1.420661, -0.465164, -1.912202>,
      < 1.447393, -0.477261, -1.883673>,
      < 1.425900, -0.457960, -1.883653>
    }
    triangle {
      < 1.425900, -0.457960, -1.883653>,
      < 1.447393, -0.477261, -1.883673>,
      < 1.493722, -0.435443, -1.870688>
    }
    triangle {
      < 1.425900, -0.457960, -1.883653>,
      < 1.493722, -0.435443, -1.870688>,
      < 1.462524, -0.407426, -1.870661>
    }
    triangle {
      < 1.462524, -0.407426, -1.870661>,
      < 1.493722, -0.435443, -1.870688>,
      < 1.520191, -0.411533, -1.886254>
    }
    triangle {
      < 1.462524, -0.407426, -1.870661>,
      < 1.520191, -0.411533, -1.886254>,
      < 1.483446, -0.378535, -1.886221>
    }
    triangle {
      < 1.483446, -0.378535, -1.886221>,
      < 1.520191, -0.411533, -1.886254>,
      < 1.540037, -0.393588, -1.919986>
    }
    triangle {
      < 1.483446, -0.378535, -1.886221>,
      < 1.540037, -0.393588, -1.919986>,
      < 1.499131, -0.356855, -1.919950>
    }
    triangle {
      < 1.499131, -0.356855, -1.919950>,
      < 1.540037, -0.393588, -1.919986>,
      < 1.543340, -0.390587, -1.943341>
    }
    triangle {
      < 1.499131, -0.356855, -1.919950>,
      < 1.543340, -0.390587, -1.943341>,
      < 1.501741, -0.353231, -1.943305>
    }
    triangle {
      < 1.501741, -0.353231, -1.943305>,
      < 1.543340, -0.390587, -1.943341>,
      < 1.543334, -0.390572, -1.967346>
    }
    triangle {
      < 1.501741, -0.353231, -1.943305>,
      < 1.543334, -0.390572, -1.967346>,
      < 1.501734, -0.353216, -1.967310>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.371810, -0.554218, -1.909643>,
      < 1.367968, -0.548947, -1.909638>
    }
    triangle {
      < 1.367968, -0.548947, -1.909638>,
      < 1.371810, -0.554218, -1.909643>,
      < 1.383374, -0.547495, -1.943379>
    }
    triangle {
      < 1.367968, -0.548947, -1.909638>,
      < 1.383374, -0.547495, -1.943379>,
      < 1.377887, -0.539963, -1.943372>
    }
    triangle {
      < 1.377887, -0.539963, -1.943372>,
      < 1.383374, -0.547495, -1.943379>,
      < 1.439317, -0.515107, -1.925213>
    }
    triangle {
      < 1.377887, -0.539963, -1.943372>,
      < 1.439317, -0.515107, -1.925213>,
      < 1.425874, -0.496655, -1.925197>
    }
    triangle {
      < 1.425874, -0.496655, -1.925197>,
      < 1.439317, -0.515107, -1.925213>,
      < 1.439321, -0.515114, -1.912237>
    }
    triangle {
      < 1.425874, -0.496655, -1.925197>,
      < 1.439321, -0.515114, -1.912237>,
      < 1.425877, -0.496663, -1.912222>
    }
    triangle {
      < 1.425877, -0.496663, -1.912222>,
      < 1.439321, -0.515114, -1.912237>,
      < 1.456681, -0.505060, -1.912238>
    }
    triangle {
      < 1.425877, -0.496663, -1.912222>,
      < 1.456681, -0.505060, -1.912238>,
      < 1.440767, -0.483219, -1.912219>
    }
    triangle {
      < 1.440767, -0.483219, -1.912219>,
      < 1.456681, -0.505060, -1.912238>,
      < 1.464404, -0.500607, -1.883692>
    }
    triangle {
      < 1.440767, -0.483219, -1.912219>,
      < 1.464404, -0.500607, -1.883692>,
      < 1.447393, -0.477261, -1.883673>
    }
    triangle {
      < 1.447393, -0.477261, -1.883673>,
      < 1.464404, -0.500607, -1.883692>,
      < 1.518417, -0.469333, -1.870717>
    }
    triangle {
      < 1.447393, -0.477261, -1.883673>,
      < 1.518417, -0.469333, -1.870717>,
      < 1.493722, -0.435443, -1.870688>
    }
    triangle {
      < 1.493722, -0.435443, -1.870688>,
      < 1.518417, -0.469333, -1.870717>,
      < 1.549274, -0.451448, -1.886287>
    }
    triangle {
      < 1.493722, -0.435443, -1.870688>,
      < 1.549274, -0.451448, -1.886287>,
      < 1.520191, -0.411533, -1.886254>
    }
    triangle {
      < 1.520191, -0.411533, -1.886254>,
      < 1.549274, -0.451448, -1.886287>,
      < 1.572413, -0.438021, -1.920023>
    }
    triangle {
      < 1.520191, -0.411533, -1.886254>,
      < 1.572413, -0.438021, -1.920023>,
      < 1.540037, -0.393588, -1.919986>
    }
    triangle {
      < 1.540037, -0.393588, -1.919986>,
      < 1.572413, -0.438021, -1.920023>,
      < 1.576264, -0.435774, -1.943379>
    }
    triangle {
      < 1.540037, -0.393588, -1.919986>,
      < 1.576264, -0.435774, -1.943379>,
      < 1.543340, -0.390587, -1.943341>
    }
    triangle {
      < 1.543340, -0.390587, -1.943341>,
      < 1.576264, -0.435774, -1.943379>,
      < 1.576259, -0.435759, -1.967384>
    }
    triangle {
      < 1.543340, -0.390587, -1.943341>,
      < 1.576259, -0.435759, -1.967384>,
      < 1.543334, -0.390572, -1.967346>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.342686, -0.570550, -1.909643>,
      < 1.374471, -0.560173, -1.909647>
    }
    triangle {
      < 1.345271, -0.572039, -1.909644>,
      < 1.374471, -0.560173, -1.909647>,
      < 1.371810, -0.554218, -1.909643>
    }
    triangle {
      < 1.371810, -0.554218, -1.909643>,
      < 1.374471, -0.560173, -1.909647>,
      < 1.387177, -0.556003, -1.943385>
    }
    triangle {
      < 1.371810, -0.554218, -1.909643>,
      < 1.387177, -0.556003, -1.943385>,
      < 1.383374, -0.547495, -1.943379>
    }
    triangle {
      < 1.383374, -0.547495, -1.943379>,
      < 1.387177, -0.556003, -1.943385>,
      < 1.448633, -0.535950, -1.925228>
    }
    triangle {
      < 1.383374, -0.547495, -1.943379>,
      < 1.448633, -0.535950, -1.925228>,
      < 1.439317, -0.515107, -1.925213>
    }
    triangle {
      < 1.439317, -0.515107, -1.925213>,
      < 1.448633, -0.535950, -1.925228>,
      < 1.448636, -0.535957, -1.912253>
    }
    triangle {
      < 1.439317, -0.515107, -1.925213>,
      < 1.448636, -0.535957, -1.912253>,
      < 1.439321, -0.515114, -1.912237>
    }
    triangle {
      < 1.439321, -0.515114, -1.912237>,
      < 1.448636, -0.535957, -1.912253>,
      < 1.467706, -0.529731, -1.912256>
    }
    triangle {
      < 1.439321, -0.515114, -1.912237>,
      < 1.467706, -0.529731, -1.912256>,
      < 1.456681, -0.505060, -1.912238>
    }
    triangle {
      < 1.456681, -0.505060, -1.912238>,
      < 1.467706, -0.529731, -1.912256>,
      < 1.476190, -0.526981, -1.883712>
    }
    triangle {
      < 1.456681, -0.505060, -1.912238>,
      < 1.476190, -0.526981, -1.883712>,
      < 1.464404, -0.500607, -1.883692>
    }
    triangle {
      < 1.464404, -0.500607, -1.883692>,
      < 1.476190, -0.526981, -1.883712>,
      < 1.535526, -0.507617, -1.870745>
    }
    triangle {
      < 1.464404, -0.500607, -1.883692>,
      < 1.535526, -0.507617, -1.870745>,
      < 1.518417, -0.469333, -1.870717>
    }
    triangle {
      < 1.518417, -0.469333, -1.870717>,
      < 1.535526, -0.507617, -1.870745>,
      < 1.569426, -0.496538, -1.886321>
    }
    triangle {
      < 1.518417, -0.469333, -1.870717>,
      < 1.569426, -0.496538, -1.886321>,
      < 1.549274, -0.451448, -1.886287>
    }
    triangle {
      < 1.549274, -0.451448, -1.886287>,
      < 1.569426, -0.496538, -1.886321>,
      < 1.594845, -0.488216, -1.920061>
    }
    triangle {
      < 1.549274, -0.451448, -1.886287>,
      < 1.594845, -0.488216, -1.920061>,
      < 1.572413, -0.438021, -1.920023>
    }
    triangle {
      < 1.572413, -0.438021, -1.920023>,
      < 1.594845, -0.488216, -1.920061>,
      < 1.599077, -0.486819, -1.943417>
    }
    triangle {
      < 1.572413, -0.438021, -1.920023>,
      < 1.599077, -0.486819, -1.943417>,
      < 1.576264, -0.435774, -1.943379>
    }
    triangle {
      < 1.576264, -0.435774, -1.943379>,
      < 1.599077, -0.486819, -1.943417>,
      < 1.599070, -0.486804, -1.967423>
    }
    triangle {
      < 1.576264, -0.435774, -1.943379>,
      < 1.599070, -0.486804, -1.967423>,
      < 1.576259, -0.435759, -1.967384>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.375836, -0.566552, -1.909651>,
      < 1.374471, -0.560173, -1.909647>
    }
    triangle {
      < 1.374471, -0.560173, -1.909647>,
      < 1.375836, -0.566552, -1.909651>,
      < 1.389127, -0.565115, -1.943391>
    }
    triangle {
      < 1.374471, -0.560173, -1.909647>,
      < 1.389127, -0.565115, -1.943391>,
      < 1.387177, -0.556003, -1.943385>
    }
    triangle {
      < 1.387177, -0.556003, -1.943385>,
      < 1.389127, -0.565115, -1.943391>,
      < 1.453411, -0.558273, -1.925244>
    }
    triangle {
      < 1.387177, -0.556003, -1.943385>,
      < 1.453411, -0.558273, -1.925244>,
      < 1.448633, -0.535950, -1.925228>
    }
    triangle {
      < 1.448633, -0.535950, -1.925228>,
      < 1.453411, -0.558273, -1.925244>,
      < 1.453414, -0.558281, -1.912269>
    }
    triangle {
      < 1.448633, -0.535950, -1.925228>,
      < 1.453414, -0.558281, -1.912269>,
      < 1.448636, -0.535957, -1.912253>
    }
    triangle {
      < 1.448636, -0.535957, -1.912253>,
      < 1.453414, -0.558281, -1.912269>,
      < 1.473363, -0.556156, -1.912274>
    }
    triangle {
      < 1.448636, -0.535957, -1.912253>,
      < 1.473363, -0.556156, -1.912274>,
      < 1.467706, -0.529731, -1.912256>
    }
    triangle {
      < 1.467706, -0.529731, -1.912256>,
      < 1.473363, -0.556156, -1.912274>,
      < 1.482237, -0.555227, -1.883730>
    }
    triangle {
      < 1.467706, -0.529731, -1.912256>,
      < 1.482237, -0.555227, -1.883730>,
      < 1.476190, -0.526981, -1.883712>
    }
    triangle {
      < 1.476190, -0.526981, -1.883712>,
      < 1.482237, -0.555227, -1.883730>,
      < 1.544302, -0.548620, -1.870773>
    }
    triangle {
      < 1.476190, -0.526981, -1.883712>,
      < 1.544302, -0.548620, -1.870773>,
      < 1.535526, -0.507617, -1.870745>
    }
    triangle {
      < 1.535526, -0.507617, -1.870745>,
      < 1.544302, -0.548620, -1.870773>,
      < 1.579763, -0.544831, -1.886353>
    }
    triangle {
      < 1.535526, -0.507617, -1.870745>,
      < 1.579763, -0.544831, -1.886353>,
      < 1.569426, -0.496538, -1.886321>
    }
    triangle {
      < 1.569426, -0.496538, -1.886321>,
      < 1.579763, -0.544831, -1.886353>,
      < 1.606353, -0.541976, -1.920097>
    }
    triangle {
      < 1.569426, -0.496538, -1.886321>,
      < 1.606353, -0.541976, -1.920097>,
      < 1.594845, -0.488216, -1.920061>
    }
    triangle {
      < 1.594845, -0.488216, -1.920061>,
      < 1.606353, -0.541976, -1.920097>,
      < 1.610781, -0.541490, -1.943453>
    }
    triangle {
      < 1.594845, -0.488216, -1.920061>,
      < 1.610781, -0.541490, -1.943453>,
      < 1.599077, -0.486819, -1.943417>
    }
    triangle {
      < 1.599077, -0.486819, -1.943417>,
      < 1.610781, -0.541490, -1.943453>,
      < 1.610774, -0.541476, -1.967459>
    }
    triangle {
      < 1.599077, -0.486819, -1.943417>,
      < 1.610774, -0.541476, -1.967459>,
      < 1.599070, -0.486804, -1.967423>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.375846, -0.573075, -1.909655>,
      < 1.375836, -0.566552, -1.909651>
    }
    triangle {
      < 1.375836, -0.566552, -1.909651>,
      < 1.375846, -0.573075, -1.909655>,
      < 1.389141, -0.574433, -1.943397>
    }
    triangle {
      < 1.375836, -0.566552, -1.909651>,
      < 1.389141, -0.574433, -1.943397>,
      < 1.389127, -0.565115, -1.943391>
    }
    triangle {
      < 1.389127, -0.565115, -1.943391>,
      < 1.389141, -0.574433, -1.943397>,
      < 1.453445, -0.581104, -1.925257>
    }
    triangle {
      < 1.389127, -0.565115, -1.943391>,
      < 1.453445, -0.581104, -1.925257>,
      < 1.453411, -0.558273, -1.925244>
    }
    triangle {
      < 1.453411, -0.558273, -1.925244>,
      < 1.453445, -0.581104, -1.925257>,
      < 1.453448, -0.581112, -1.912282>
    }
    triangle {
      < 1.453411, -0.558273, -1.925244>,
      < 1.453448, -0.581112, -1.912282>,
      < 1.453414, -0.558281, -1.912269>
    }
    triangle {
      < 1.453414, -0.558281, -1.912269>,
      < 1.453448, -0.581112, -1.912282>,
      < 1.473403, -0.583179, -1.912290>
    }
    triangle {
      < 1.453414, -0.558281, -1.912269>,
      < 1.473403, -0.583179, -1.912290>,
      < 1.473363, -0.556156, -1.912274>
    }
    triangle {
      < 1.473363, -0.556156, -1.912274>,
      < 1.473403, -0.583179, -1.912290>,
      < 1.482279, -0.584115, -1.883747>
    }
    triangle {
      < 1.473363, -0.556156, -1.912274>,
      < 1.482279, -0.584115, -1.883747>,
      < 1.482237, -0.555227, -1.883730>
    }
    triangle {
      < 1.482237, -0.555227, -1.883730>,
      < 1.482279, -0.584115, -1.883747>,
      < 1.544365, -0.590553, -1.870797>
    }
    triangle {
      < 1.482237, -0.555227, -1.883730>,
      < 1.544365, -0.590553, -1.870797>,
      < 1.544302, -0.548620, -1.870773>
    }
    triangle {
      < 1.544302, -0.548620, -1.870773>,
      < 1.544365, -0.590553, -1.870797>,
      < 1.579837, -0.594219, -1.886382>
    }
    triangle {
      < 1.544302, -0.548620, -1.870773>,
      < 1.579837, -0.594219, -1.886382>,
      < 1.579763, -0.544831, -1.886353>
    }
    triangle {
      < 1.579763, -0.544831, -1.886353>,
      < 1.579837, -0.594219, -1.886382>,
      < 1.606434, -0.596954, -1.920129>
    }
    triangle {
      < 1.579763, -0.544831, -1.886353>,
      < 1.606434, -0.596954, -1.920129>,
      < 1.606353, -0.541976, -1.920097>
    }
    triangle {
      < 1.606353, -0.541976, -1.920097>,
      < 1.606434, -0.596954, -1.920129>,
      < 1.610863, -0.597400, -1.943487>
    }
    triangle {
      < 1.606353, -0.541976, -1.920097>,
      < 1.610863, -0.597400, -1.943487>,
      < 1.610781, -0.541490, -1.943453>
    }
    triangle {
      < 1.610781, -0.541490, -1.943453>,
      < 1.610863, -0.597400, -1.943487>,
      < 1.610857, -0.597386, -1.967492>
    }
    triangle {
      < 1.610781, -0.541490, -1.943453>,
      < 1.610857, -0.597386, -1.967492>,
      < 1.610774, -0.541476, -1.967459>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.374500, -0.579457, -1.909658>,
      < 1.375846, -0.573075, -1.909655>
    }
    triangle {
      < 1.375846, -0.573075, -1.909655>,
      < 1.374500, -0.579457, -1.909658>,
      < 1.387218, -0.583551, -1.943402>
    }
    triangle {
      < 1.375846, -0.573075, -1.909655>,
      < 1.387218, -0.583551, -1.943402>,
      < 1.389141, -0.574433, -1.943397>
    }
    triangle {
      < 1.389141, -0.574433, -1.943397>,
      < 1.387218, -0.583551, -1.943402>,
      < 1.448733, -0.603442, -1.925269>
    }
    triangle {
      < 1.389141, -0.574433, -1.943397>,
      < 1.448733, -0.603442, -1.925269>,
      < 1.453445, -0.581104, -1.925257>
    }
    triangle {
      < 1.453445, -0.581104, -1.925257>,
      < 1.448733, -0.603442, -1.925269>,
      < 1.448736, -0.603450, -1.912293>
    }
    triangle {
      < 1.453445, -0.581104, -1.925257>,
      < 1.448736, -0.603450, -1.912293>,
      < 1.453448, -0.581112, -1.912282>
    }
    triangle {
      < 1.453448, -0.581112, -1.912282>,
      < 1.448736, -0.603450, -1.912293>,
      < 1.467825, -0.609620, -1.912304>
    }
    triangle {
      < 1.453448, -0.581112, -1.912282>,
      < 1.467825, -0.609620, -1.912304>,
      < 1.473403, -0.583179, -1.912290>
    }
    triangle {
      < 1.473403, -0.583179, -1.912290>,
      < 1.467825, -0.609620, -1.912304>,
      < 1.476316, -0.612379, -1.883762>
    }
    triangle {
      < 1.473403, -0.583179, -1.912290>,
      < 1.476316, -0.612379, -1.883762>,
      < 1.482279, -0.584115, -1.883747>
    }
    triangle {
      < 1.482279, -0.584115, -1.883747>,
      < 1.476316, -0.612379, -1.883762>,
      < 1.535710, -0.631582, -1.870818>
    }
    triangle {
      < 1.482279, -0.584115, -1.883747>,
      < 1.535710, -0.631582, -1.870818>,
      < 1.544365, -0.590553, -1.870797>
    }
    triangle {
      < 1.544365, -0.590553, -1.870797>,
      < 1.535710, -0.631582, -1.870818>,
      < 1.569642, -0.642542, -1.886407>
    }
    triangle {
      < 1.544365, -0.590553, -1.870797>,
      < 1.569642, -0.642542, -1.886407>,
      < 1.579837, -0.594219, -1.886382>
    }
    triangle {
      < 1.579837, -0.594219, -1.886382>,
      < 1.569642, -0.642542, -1.886407>,
      < 1.595086, -0.650749, -1.920158>
    }
    triangle {
      < 1.579837, -0.594219, -1.886382>,
      < 1.595086, -0.650749, -1.920158>,
      < 1.606434, -0.596954, -1.920129>
    }
    triangle {
      < 1.606434, -0.596954, -1.920129>,
      < 1.595086, -0.650749, -1.920158>,
      < 1.599322, -0.652106, -1.943515>
    }
    triangle {
      < 1.606434, -0.596954, -1.920129>,
      < 1.599322, -0.652106, -1.943515>,
      < 1.610863, -0.597400, -1.943487>
    }
    triangle {
      < 1.610863, -0.597400, -1.943487>,
      < 1.599322, -0.652106, -1.943515>,
      < 1.599316, -0.652091, -1.967520>
    }
    triangle {
      < 1.610863, -0.597400, -1.943487>,
      < 1.599316, -0.652091, -1.967520>,
      < 1.610857, -0.597386, -1.967492>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.371856, -0.585420, -1.909661>,
      < 1.374500, -0.579457, -1.909658>
    }
    triangle {
      < 1.374500, -0.579457, -1.909658>,
      < 1.371856, -0.585420, -1.909661>,
      < 1.383440, -0.592069, -1.943405>
    }
    triangle {
      < 1.374500, -0.579457, -1.909658>,
      < 1.383440, -0.592069, -1.943405>,
      < 1.387218, -0.583551, -1.943402>
    }
    triangle {
      < 1.387218, -0.583551, -1.943402>,
      < 1.383440, -0.592069, -1.943405>,
      < 1.439479, -0.624314, -1.925278>
    }
    triangle {
      < 1.387218, -0.583551, -1.943402>,
      < 1.439479, -0.624314, -1.925278>,
      < 1.448733, -0.603442, -1.925269>
    }
    triangle {
      < 1.448733, -0.603442, -1.925269>,
      < 1.439479, -0.624314, -1.925278>,
      < 1.439482, -0.624321, -1.912303>
    }
    triangle {
      < 1.448733, -0.603442, -1.925269>,
      < 1.439482, -0.624321, -1.912303>,
      < 1.448736, -0.603450, -1.912293>
    }
    triangle {
      < 1.448736, -0.603450, -1.912293>,
      < 1.439482, -0.624321, -1.912303>,
      < 1.456873, -0.634324, -1.912314>
    }
    triangle {
      < 1.448736, -0.603450, -1.912293>,
      < 1.456873, -0.634324, -1.912314>,
      < 1.467825, -0.609620, -1.912304>
    }
    triangle {
      < 1.467825, -0.609620, -1.912304>,
      < 1.456873, -0.634324, -1.912314>,
      < 1.464608, -0.638787, -1.883774>
    }
    triangle {
      < 1.467825, -0.609620, -1.912304>,
      < 1.464608, -0.638787, -1.883774>,
      < 1.476316, -0.612379, -1.883762>
    }
    triangle {
      < 1.476316, -0.612379, -1.883762>,
      < 1.464608, -0.638787, -1.883774>,
      < 1.518714, -0.669916, -1.870835>
    }
    triangle {
      < 1.476316, -0.612379, -1.883762>,
      < 1.518714, -0.669916, -1.870835>,
      < 1.535710, -0.631582, -1.870818>
    }
    triangle {
      < 1.535710, -0.631582, -1.870818>,
      < 1.518714, -0.669916, -1.870835>,
      < 1.549625, -0.687691, -1.886428>
    }
    triangle {
      < 1.535710, -0.631582, -1.870818>,
      < 1.549625, -0.687691, -1.886428>,
      < 1.569642, -0.642542, -1.886407>
    }
    triangle {
      < 1.569642, -0.642542, -1.886407>,
      < 1.549625, -0.687691, -1.886428>,
      < 1.572802, -0.701009, -1.920179>
    }
    triangle {
      < 1.569642, -0.642542, -1.886407>,
      < 1.572802, -0.701009, -1.920179>,
      < 1.595086, -0.650749, -1.920158>
    }
    triangle {
      < 1.595086, -0.650749, -1.920158>,
      < 1.572802, -0.701009, -1.920179>,
      < 1.576661, -0.703218, -1.943538>
    }
    triangle {
      < 1.595086, -0.650749, -1.920158>,
      < 1.576661, -0.703218, -1.943538>,
      < 1.599322, -0.652106, -1.943515>
    }
    triangle {
      < 1.599322, -0.652106, -1.943515>,
      < 1.576661, -0.703218, -1.943538>,
      < 1.576655, -0.703203, -1.967543>
    }
    triangle {
      < 1.599322, -0.652106, -1.943515>,
      < 1.576655, -0.703203, -1.967543>,
      < 1.599316, -0.652091, -1.967520>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.368030, -0.590704, -1.909663>,
      < 1.371856, -0.585420, -1.909661>
    }
    triangle {
      < 1.371856, -0.585420, -1.909661>,
      < 1.368030, -0.590704, -1.909663>,
      < 1.377975, -0.599616, -1.943408>
    }
    triangle {
      < 1.371856, -0.585420, -1.909661>,
      < 1.377975, -0.599616, -1.943408>,
      < 1.383440, -0.592069, -1.943405>
    }
    triangle {
      < 1.383440, -0.592069, -1.943405>,
      < 1.377975, -0.599616, -1.943408>,
      < 1.426090, -0.642805, -1.925284>
    }
    triangle {
      < 1.383440, -0.592069, -1.943405>,
      < 1.426090, -0.642805, -1.925284>,
      < 1.439479, -0.624314, -1.925278>
    }
    triangle {
      < 1.439479, -0.624314, -1.925278>,
      < 1.426090, -0.642805, -1.925284>,
      < 1.426093, -0.642813, -1.912309>
    }
    triangle {
      < 1.439479, -0.624314, -1.925278>,
      < 1.426093, -0.642813, -1.912309>,
      < 1.439482, -0.624321, -1.912303>
    }
    triangle {
      < 1.439482, -0.624321, -1.912303>,
      < 1.426093, -0.642813, -1.912309>,
      < 1.441023, -0.656212, -1.912321>
    }
    triangle {
      < 1.439482, -0.624321, -1.912303>,
      < 1.441023, -0.656212, -1.912321>,
      < 1.456873, -0.634324, -1.912314>
    }
    triangle {
      < 1.456873, -0.634324, -1.912314>,
      < 1.441023, -0.656212, -1.912321>,
      < 1.447666, -0.662184, -1.883782>
    }
    triangle {
      < 1.456873, -0.634324, -1.912314>,
      < 1.447666, -0.662184, -1.883782>,
      < 1.464608, -0.638787, -1.883774>
    }
    triangle {
      < 1.464608, -0.638787, -1.883774>,
      < 1.447666, -0.662184, -1.883782>,
      < 1.494120, -0.703879, -1.870847>
    }
    triangle {
      < 1.464608, -0.638787, -1.883774>,
      < 1.494120, -0.703879, -1.870847>,
      < 1.518714, -0.669916, -1.870835>
    }
    triangle {
      < 1.518714, -0.669916, -1.870835>,
      < 1.494120, -0.703879, -1.870847>,
      < 1.520659, -0.727693, -1.886441>
    }
    triangle {
      < 1.518714, -0.669916, -1.870835>,
      < 1.520659, -0.727693, -1.886441>,
      < 1.549625, -0.687691, -1.886428>
    }
    triangle {
      < 1.549625, -0.687691, -1.886428>,
      < 1.520659, -0.727693, -1.886441>,
      < 1.540558, -0.745539, -1.920195>
    }
    triangle {
      < 1.549625, -0.687691, -1.886428>,
      < 1.540558, -0.745539, -1.920195>,
      < 1.572802, -0.701009, -1.920179>
    }
    triangle {
      < 1.572802, -0.701009, -1.920179>,
      < 1.540558, -0.745539, -1.920195>,
      < 1.543870, -0.748503, -1.943553>
    }
    triangle {
      < 1.572802, -0.701009, -1.920179>,
      < 1.543870, -0.748503, -1.943553>,
      < 1.576661, -0.703218, -1.943538>
    }
    triangle {
      < 1.576661, -0.703218, -1.943538>,
      < 1.543870, -0.748503, -1.943553>,
      < 1.543864, -0.748488, -1.967559>
    }
    triangle {
      < 1.576661, -0.703218, -1.943538>,
      < 1.543864, -0.748488, -1.967559>,
      < 1.576655, -0.703203, -1.967543>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.363190, -0.595076, -1.909663>,
      < 1.368030, -0.590704, -1.909663>
    }
    triangle {
      < 1.368030, -0.590704, -1.909663>,
      < 1.363190, -0.595076, -1.909663>,
      < 1.371062, -0.605863, -1.943409>
    }
    triangle {
      < 1.368030, -0.590704, -1.909663>,
      < 1.371062, -0.605863, -1.943409>,
      < 1.377975, -0.599616, -1.943408>
    }
    triangle {
      < 1.377975, -0.599616, -1.943408>,
      < 1.371062, -0.605863, -1.943409>,
      < 1.409149, -0.658108, -1.925288>
    }
    triangle {
      < 1.377975, -0.599616, -1.943408>,
      < 1.409149, -0.658108, -1.925288>,
      < 1.426090, -0.642805, -1.925284>
    }
    triangle {
      < 1.426090, -0.642805, -1.925284>,
      < 1.409149, -0.658108, -1.925288>,
      < 1.409152, -0.658116, -1.912312>
    }
    triangle {
      < 1.426090, -0.642805, -1.925284>,
      < 1.409152, -0.658116, -1.912312>,
      < 1.426093, -0.642813, -1.912309>
    }
    triangle {
      < 1.426093, -0.642813, -1.912309>,
      < 1.409152, -0.658116, -1.912312>,
      < 1.420970, -0.674326, -1.912325>
    }
    triangle {
      < 1.426093, -0.642813, -1.912309>,
      < 1.420970, -0.674326, -1.912325>,
      < 1.441023, -0.656212, -1.912321>
    }
    triangle {
      < 1.441023, -0.656212, -1.912321>,
      < 1.420970, -0.674326, -1.912325>,
      < 1.426231, -0.681548, -1.883786>
    }
    triangle {
      < 1.441023, -0.656212, -1.912321>,
      < 1.426231, -0.681548, -1.883786>,
      < 1.447666, -0.662184, -1.883782>
    }
    triangle {
      < 1.447666, -0.662184, -1.883782>,
      < 1.426231, -0.681548, -1.883786>,
      < 1.463005, -0.731989, -1.870853>
    }
    triangle {
      < 1.447666, -0.662184, -1.883782>,
      < 1.463005, -0.731989, -1.870853>,
      < 1.494120, -0.703879, -1.870847>
    }
    triangle {
      < 1.494120, -0.703879, -1.870847>,
      < 1.463005, -0.731989, -1.870853>,
      < 1.484011, -0.760799, -1.886448>
    }
    triangle {
      < 1.494120, -0.703879, -1.870847>,
      < 1.484011, -0.760799, -1.886448>,
      < 1.520659, -0.727693, -1.886441>
    }
    triangle {
      < 1.520659, -0.727693, -1.886441>,
      < 1.484011, -0.760799, -1.886448>,
      < 1.499762, -0.782393, -1.920202>
    }
    triangle {
      < 1.520659, -0.727693, -1.886441>,
      < 1.499762, -0.782393, -1.920202>,
      < 1.540558, -0.745539, -1.920195>
    }
    triangle {
      < 1.540558, -0.745539, -1.920195>,
      < 1.499762, -0.782393, -1.920202>,
      < 1.502382, -0.785982, -1.943561>
    }
    triangle {
      < 1.540558, -0.745539, -1.920195>,
      < 1.502382, -0.785982, -1.943561>,
      < 1.543870, -0.748503, -1.943553>
    }
    triangle {
      < 1.543870, -0.748503, -1.943553>,
      < 1.502382, -0.785982, -1.943561>,
      < 1.502376, -0.785967, -1.967566>
    }
    triangle {
      < 1.543870, -0.748503, -1.943553>,
      < 1.502376, -0.785967, -1.967566>,
      < 1.543864, -0.748488, -1.967559>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.344804, -0.567630, -1.909641>,
      < 1.357546, -0.598347, -1.909664>
    }
    triangle {
      < 1.342686, -0.570550, -1.909643>,
      < 1.357546, -0.598347, -1.909664>,
      < 1.363190, -0.595076, -1.909663>
    }
    triangle {
      < 1.363190, -0.595076, -1.909663>,
      < 1.357546, -0.598347, -1.909664>,
      < 1.362999, -0.610535, -1.943409>
    }
    triangle {
      < 1.363190, -0.595076, -1.909663>,
      < 1.362999, -0.610535, -1.943409>,
      < 1.371062, -0.605863, -1.943409>
    }
    triangle {
      < 1.371062, -0.605863, -1.943409>,
      < 1.362999, -0.610535, -1.943409>,
      < 1.389397, -0.669557, -1.925287>
    }
    triangle {
      < 1.371062, -0.605863, -1.943409>,
      < 1.389397, -0.669557, -1.925287>,
      < 1.409149, -0.658108, -1.925288>
    }
    triangle {
      < 1.409149, -0.658108, -1.925288>,
      < 1.389397, -0.669557, -1.925287>,
      < 1.389400, -0.669565, -1.912312>
    }
    triangle {
      < 1.409149, -0.658108, -1.925288>,
      < 1.389400, -0.669565, -1.912312>,
      < 1.409152, -0.658116, -1.912312>
    }
    triangle {
      < 1.409152, -0.658116, -1.912312>,
      < 1.389400, -0.669565, -1.912312>,
      < 1.397591, -0.687877, -1.912326>
    }
    triangle {
      < 1.409152, -0.658116, -1.912312>,
      < 1.397591, -0.687877, -1.912326>,
      < 1.420970, -0.674326, -1.912325>
    }
    triangle {
      < 1.420970, -0.674326, -1.912325>,
      < 1.397591, -0.687877, -1.912326>,
      < 1.401238, -0.696034, -1.883786>
    }
    triangle {
      < 1.420970, -0.674326, -1.912325>,
      < 1.401238, -0.696034, -1.883786>,
      < 1.426231, -0.681548, -1.883786>
    }
    triangle {
      < 1.426231, -0.681548, -1.883786>,
      < 1.401238, -0.696034, -1.883786>,
      < 1.426725, -0.753016, -1.870853>
    }
    triangle {
      < 1.426231, -0.681548, -1.883786>,
      < 1.426725, -0.753016, -1.870853>,
      < 1.463005, -0.731989, -1.870853>
    }
    triangle {
      < 1.463005, -0.731989, -1.870853>,
      < 1.426725, -0.753016, -1.870853>,
      < 1.441283, -0.785564, -1.886448>
    }
    triangle {
      < 1.463005, -0.731989, -1.870853>,
      < 1.441283, -0.785564, -1.886448>,
      < 1.484011, -0.760799, -1.886448>
    }
    triangle {
      < 1.484011, -0.760799, -1.886448>,
      < 1.441283, -0.785564, -1.886448>,
      < 1.452195, -0.809962, -1.920202>
    }
    triangle {
      < 1.484011, -0.760799, -1.886448>,
      < 1.452195, -0.809962, -1.920202>,
      < 1.499762, -0.782393, -1.920202>
    }
    triangle {
      < 1.499762, -0.782393, -1.920202>,
      < 1.452195, -0.809962, -1.920202>,
      < 1.454010, -0.814018, -1.943561>
    }
    triangle {
      < 1.499762, -0.782393, -1.920202>,
      < 1.454010, -0.814018, -1.943561>,
      < 1.502382, -0.785982, -1.943561>
    }
    triangle {
      < 1.502382, -0.785982, -1.943561>,
      < 1.454010, -0.814018, -1.943561>,
      < 1.454004, -0.814004, -1.967567>
    }
    triangle {
      < 1.502382, -0.785982, -1.943561>,
      < 1.454004, -0.814004, -1.967567>,
      < 1.502376, -0.785967, -1.967566>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.351346, -0.600373, -1.909663>,
      < 1.357546, -0.598347, -1.909664>
    }
    triangle {
      < 1.357546, -0.598347, -1.909664>,
      < 1.351346, -0.600373, -1.909663>,
      < 1.354142, -0.613431, -1.943407>
    }
    triangle {
      < 1.357546, -0.598347, -1.909664>,
      < 1.354142, -0.613431, -1.943407>,
      < 1.362999, -0.610535, -1.943409>
    }
    triangle {
      < 1.362999, -0.610535, -1.943409>,
      < 1.354142, -0.613431, -1.943407>,
      < 1.367696, -0.676649, -1.925284>
    }
    triangle {
      < 1.362999, -0.610535, -1.943409>,
      < 1.367696, -0.676649, -1.925284>,
      < 1.389397, -0.669557, -1.925287>
    }
    triangle {
      < 1.389397, -0.669557, -1.925287>,
      < 1.367696, -0.676649, -1.925284>,
      < 1.367699, -0.676657, -1.912309>
    }
    triangle {
      < 1.389397, -0.669557, -1.925287>,
      < 1.367699, -0.676657, -1.912309>,
      < 1.389400, -0.669565, -1.912312>
    }
    triangle {
      < 1.389400, -0.669565, -1.912312>,
      < 1.367699, -0.676657, -1.912309>,
      < 1.371904, -0.696273, -1.912322>
    }
    triangle {
      < 1.389400, -0.669565, -1.912312>,
      < 1.371904, -0.696273, -1.912322>,
      < 1.397591, -0.687877, -1.912326>
    }
    triangle {
      < 1.397591, -0.687877, -1.912326>,
      < 1.371904, -0.696273, -1.912322>,
      < 1.373781, -0.705007, -1.883782>
    }
    triangle {
      < 1.397591, -0.687877, -1.912326>,
      < 1.373781, -0.705007, -1.883782>,
      < 1.401238, -0.696034, -1.883786>
    }
    triangle {
      < 1.401238, -0.696034, -1.883786>,
      < 1.373781, -0.705007, -1.883782>,
      < 1.386866, -0.766043, -1.870847>
    }
    triangle {
      < 1.401238, -0.696034, -1.883786>,
      < 1.386866, -0.766043, -1.870847>,
      < 1.426725, -0.753016, -1.870853>
    }
    triangle {
      < 1.426725, -0.753016, -1.870853>,
      < 1.386866, -0.766043, -1.870847>,
      < 1.394339, -0.800907, -1.886441>
    }
    triangle {
      < 1.426725, -0.753016, -1.870853>,
      < 1.394339, -0.800907, -1.886441>,
      < 1.441283, -0.785564, -1.886448>
    }
    triangle {
      < 1.441283, -0.785564, -1.886448>,
      < 1.394339, -0.800907, -1.886441>,
      < 1.399937, -0.827041, -1.920194>
    }
    triangle {
      < 1.441283, -0.785564, -1.886448>,
      < 1.399937, -0.827041, -1.920194>,
      < 1.452195, -0.809962, -1.920202>
    }
    triangle {
      < 1.452195, -0.809962, -1.920202>,
      < 1.399937, -0.827041, -1.920194>,
      < 1.400866, -0.831387, -1.943553>
    }
    triangle {
      < 1.452195, -0.809962, -1.920202>,
      < 1.400866, -0.831387, -1.943553>,
      < 1.454010, -0.814018, -1.943561>
    }
    triangle {
      < 1.454010, -0.814018, -1.943561>,
      < 1.400866, -0.831387, -1.943553>,
      < 1.400860, -0.831372, -1.967558>
    }
    triangle {
      < 1.454010, -0.814018, -1.943561>,
      < 1.400860, -0.831372, -1.967558>,
      < 1.454004, -0.814004, -1.967567>
    }
    triangle {
      < 1.344804, -0.567630, -1.909641>,
      < 1.344824, -0.601066, -1.909661>,
      < 1.351346, -0.600373, -1.909663>
    }
    triangle {
      < 1.351346, -0.600373, -1.909663>,
      < 1.344824, -0.601066, -1.909661>,
      < 1.344823, -0.614421, -1.943405>
    }
    triangle {
      < 1.351346, -0.600373, -1.909663>,
      < 1.344823, -0.614421, -1.943405>,
      < 1.354142, -0.613431, -1.943407>
    }
    triangle {
      < 1.354142, -0.613431, -1.943407>,
      < 1.344823, -0.614421, -1.943405>,
      < 1.344866, -0.679075, -1.925278>
    }
    triangle {
      < 1.354142, -0.613431, -1.943407>,
      < 1.344866, -0.679075, -1.925278>,
      < 1.367696, -0.676649, -1.925284>
    }
    triangle {
      < 1.367696, -0.676649, -1.925284>,
      < 1.344866, -0.679075, -1.925278>,
      < 1.344870, -0.679083, -1.912302>
    }
    triangle {
      < 1.367696, -0.676649, -1.925284>,
      < 1.344870, -0.679083, -1.912302>,
      < 1.367699, -0.676657, -1.912309>
    }
    triangle {
      < 1.367699, -0.676657, -1.912309>,
      < 1.344870, -0.679083, -1.912302>,
      < 1.344882, -0.699145, -1.912314>
    }
    triangle {
      < 1.367699, -0.676657, -1.912309>,
      < 1.344882, -0.699145, -1.912314>,
      < 1.371904, -0.696273, -1.912322>
    }
    triangle {
      < 1.371904, -0.696273, -1.912322>,
      < 1.344882, -0.699145, -1.912314>,
      < 1.344894, -0.708078, -1.883774>
    }
    triangle {
      < 1.371904, -0.696273, -1.912322>,
      < 1.344894, -0.708078, -1.883774>,
      < 1.373781, -0.705007, -1.883782>
    }
    triangle {
      < 1.373781, -0.705007, -1.883782>,
      < 1.344894, -0.708078, -1.883774>,
      < 1.344934, -0.770500, -1.870836>
    }
    triangle {
      < 1.373781, -0.705007, -1.883782>,
      < 1.344934, -0.770500, -1.870836>,
      < 1.386866, -0.766043, -1.870847>
    }
    triangle {
      < 1.386866, -0.766043, -1.870847>,
      < 1.344934, -0.770500, -1.870836>,
      < 1.344951, -0.806156, -1.886427>
    }
    triangle {
      < 1.386866, -0.766043, -1.870847>,
      < 1.344951, -0.806156, -1.886427>,
      < 1.394339, -0.800907, -1.886441>
    }
    triangle {
      < 1.394339, -0.800907, -1.886441>,
      < 1.344951, -0.806156, -1.886427>,
      < 1.344958, -0.832885, -1.920179>
    }
    triangle {
      < 1.394339, -0.800907, -1.886441>,
      < 1.344958, -0.832885, -1.920179>,
      < 1.399937, -0.827041, -1.920194>
    }
    triangle {
      < 1.399937, -0.827041, -1.920194>,
      < 1.344958, -0.832885, -1.920179>,
      < 1.344955, -0.837330, -1.943537>
    }
    triangle {
      < 1.399937, -0.827041, -1.920194>,
      < 1.344955, -0.837330, -1.943537>,
      < 1.400866, -0.831387, -1.943553>
    }
    triangle {
      < 1.400866, -0.831387, -1.943553>,
      < 1.344955, -0.837330, -1.943537>,
      < 1.344949, -0.837315, -1.967543>
    }
    triangle {
      < 1.400866, -0.831387, -1.943553>,
      < 1.344949, -0.837315, -1.967543>,
      < 1.400860, -0.831372, -1.967558>
    }
    texture {wheels}
  }
  // ordinance1
  union {
    triangle {
      < -0.290819, -0.692866, -3.051893>,
      < -0.254624, -0.862994, -2.900065>,
      < -0.254615, -0.876200, -2.908645>
    }
    triangle {
      < -0.290819, -0.692866, -3.051893>,
      < -0.254615, -0.876200, -2.908645>,
      < -0.290809, -0.710580, -3.069655>
    }
    triangle {
      < -0.290819, -0.692866, -3.051893>,
      < -0.254629, -0.854307, -2.886668>,
      < -0.254624, -0.862994, -2.900065>
    }
    triangle {
      < -0.446151, -0.710672, -3.069655>,
      < -0.446716, -0.863108, -2.900065>,
      < -0.446721, -0.854421, -2.886668>
    }
    triangle {
      < -0.446151, -0.710672, -3.069655>,
      < -0.446721, -0.854421, -2.886668>,
      < -0.446161, -0.692958, -3.051893>
    }
    triangle {
      < -0.446151, -0.710672, -3.069655>,
      < -0.446708, -0.876314, -2.908645>,
      < -0.446716, -0.863108, -2.900065>
    }
    triangle {
      < -0.446161, -0.692958, -3.051893>,
      < -0.446721, -0.854421, -2.886668>,
      < -0.254629, -0.854307, -2.886668>
    }
    triangle {
      < -0.446161, -0.692958, -3.051893>,
      < -0.254629, -0.854307, -2.886668>,
      < -0.290819, -0.692866, -3.051893>
    }
    triangle {
      < -0.290809, -0.710580, -3.069655>,
      < -0.254615, -0.876200, -2.908645>,
      < -0.446708, -0.876314, -2.908645>
    }
    triangle {
      < -0.290809, -0.710580, -3.069655>,
      < -0.446708, -0.876314, -2.908645>,
      < -0.446151, -0.710672, -3.069655>
    }
    triangle {
      < 0.488519, -0.820266, -2.920178>,
      < 0.519017, -0.862535, -2.900065>,
      < 0.521297, -0.875740, -2.908645>
    }
    triangle {
      < 0.488519, -0.820266, -2.920178>,
      < 0.521297, -0.875740, -2.908645>,
      < 0.488532, -0.842172, -2.942143>
    }
    triangle {
      < 0.488519, -0.820266, -2.920178>,
      < 0.521296, -0.853847, -2.886668>,
      < 0.519017, -0.862535, -2.900065>
    }
    triangle {
      < -0.217239, -0.710536, -3.069655>,
      < -0.163649, -0.862940, -2.900065>,
      < -0.163654, -0.854253, -2.886668>
    }
    triangle {
      < -0.217239, -0.710536, -3.069655>,
      < -0.163654, -0.854253, -2.886668>,
      < -0.217249, -0.692822, -3.051893>
    }
    triangle {
      < -0.217239, -0.710536, -3.069655>,
      < -0.163641, -0.876146, -2.908645>,
      < -0.163649, -0.862940, -2.900065>
    }
    triangle {
      < -0.217249, -0.692822, -3.051893>,
      < -0.163654, -0.854253, -2.886668>,
      < 0.521296, -0.853847, -2.886668>
    }
    triangle {
      < -0.217249, -0.692822, -3.051893>,
      < 0.521296, -0.853847, -2.886668>,
      < 0.488519, -0.820266, -2.920178>
    }
    triangle {
      < 0.488532, -0.842172, -2.942143>,
      < 0.521297, -0.875740, -2.908645>,
      < -0.163641, -0.876146, -2.908645>
    }
    triangle {
      < 0.488532, -0.842172, -2.942143>,
      < -0.163641, -0.876146, -2.908645>,
      < -0.217239, -0.710536, -3.069655>
    }
    triangle {
      < -0.290808, -0.711139, -2.598528>,
      < -0.254619, -0.870307, -2.762055>,
      < -0.254629, -0.854325, -2.781749>
    }
    triangle {
      < -0.290808, -0.711139, -2.598528>,
      < -0.254629, -0.854325, -2.781749>,
      < -0.290819, -0.693382, -2.616250>
    }
    triangle {
      < -0.290808, -0.711139, -2.598528>,
      < -0.254616, -0.875741, -2.759294>,
      < -0.254619, -0.870307, -2.762055>
    }
    triangle {
      < -0.446161, -0.693474, -2.616250>,
      < -0.446711, -0.870421, -2.762055>,
      < -0.446709, -0.875854, -2.759294>
    }
    triangle {
      < -0.446161, -0.693474, -2.616250>,
      < -0.446709, -0.875854, -2.759294>,
      < -0.446151, -0.711230, -2.598528>
    }
    triangle {
      < -0.446161, -0.693474, -2.616250>,
      < -0.446721, -0.854438, -2.781749>,
      < -0.446711, -0.870421, -2.762055>
    }
    triangle {
      < -0.446151, -0.711230, -2.598528>,
      < -0.446709, -0.875854, -2.759294>,
      < -0.254616, -0.875741, -2.759294>
    }
    triangle {
      < -0.446151, -0.711230, -2.598528>,
      < -0.254616, -0.875741, -2.759294>,
      < -0.290808, -0.711139, -2.598528>
    }
    triangle {
      < -0.290819, -0.693382, -2.616250>,
      < -0.254629, -0.854325, -2.781749>,
      < -0.446721, -0.854438, -2.781749>
    }
    triangle {
      < -0.290819, -0.693382, -2.616250>,
      < -0.446721, -0.854438, -2.781749>,
      < -0.446161, -0.693474, -2.616250>
    }
    triangle {
      < 0.488532, -0.842428, -2.726353>,
      < 0.519372, -0.869848, -2.762055>,
      < 0.521193, -0.853865, -2.781749>
    }
    triangle {
      < 0.488532, -0.842428, -2.726353>,
      < 0.521193, -0.853865, -2.781749>,
      < 0.488519, -0.820469, -2.748266>
    }
    triangle {
      < 0.488532, -0.842428, -2.726353>,
      < 0.520675, -0.875281, -2.759294>,
      < 0.519372, -0.869848, -2.762055>
    }
    triangle {
      < -0.217249, -0.693338, -2.616249>,
      < -0.163644, -0.870253, -2.762055>,
      < -0.163642, -0.875687, -2.759294>
    }
    triangle {
      < -0.217249, -0.693338, -2.616249>,
      < -0.163642, -0.875687, -2.759294>,
      < -0.217238, -0.711095, -2.598528>
    }
    triangle {
      < -0.217249, -0.693338, -2.616249>,
      < -0.163654, -0.854271, -2.781749>,
      < -0.163644, -0.870253, -2.762055>
    }
    triangle {
      < -0.217238, -0.711095, -2.598528>,
      < -0.163642, -0.875687, -2.759294>,
      < 0.520675, -0.875281, -2.759294>
    }
    triangle {
      < -0.217238, -0.711095, -2.598528>,
      < 0.520675, -0.875281, -2.759294>,
      < 0.488532, -0.842428, -2.726353>
    }
    triangle {
      < 0.488519, -0.820469, -2.748266>,
      < 0.521193, -0.853865, -2.781749>,
      < -0.163654, -0.854271, -2.781749>
    }
    triangle {
      < 0.488519, -0.820469, -2.748266>,
      < -0.163654, -0.854271, -2.781749>,
      < -0.217249, -0.693338, -2.616249>
    }
    triangle {
      < -0.290540, -1.164507, -2.616668>,
      < -0.254540, -1.004026, -2.781084>,
      < -0.254553, -0.982107, -2.759133>
    }
    triangle {
      < -0.290540, -1.164507, -2.616668>,
      < -0.254553, -0.982107, -2.759133>,
      < -0.290550, -1.146781, -2.598916>
    }
    triangle {
      < -0.445892, -1.146873, -2.598916>,
      < -0.446646, -0.982221, -2.759133>,
      < -0.446632, -1.004140, -2.781084>
    }
    triangle {
      < -0.445892, -1.146873, -2.598916>,
      < -0.446632, -1.004140, -2.781084>,
      < -0.445882, -1.164600, -2.616668>
    }
    triangle {
      < -0.445882, -1.164600, -2.616668>,
      < -0.446632, -1.004140, -2.781084>,
      < -0.254540, -1.004026, -2.781084>
    }
    triangle {
      < -0.445882, -1.164600, -2.616668>,
      < -0.254540, -1.004026, -2.781084>,
      < -0.290540, -1.164507, -2.616668>
    }
    triangle {
      < -0.290550, -1.146781, -2.598916>,
      < -0.254553, -0.982107, -2.759133>,
      < -0.446646, -0.982221, -2.759133>
    }
    triangle {
      < -0.290550, -1.146781, -2.598916>,
      < -0.446646, -0.982221, -2.759133>,
      < -0.445892, -1.146873, -2.598916>
    }
    triangle {
      < 0.488647, -1.036261, -2.748458>,
      < 0.520502, -1.003567, -2.781084>,
      < 0.520489, -0.981647, -2.759133>
    }
    triangle {
      < 0.488647, -1.036261, -2.748458>,
      < 0.520489, -0.981647, -2.759133>,
      < 0.488634, -1.014341, -2.726506>
    }
    triangle {
      < -0.216980, -1.146737, -2.598916>,
      < -0.163579, -0.982053, -2.759133>,
      < -0.163565, -1.003972, -2.781084>
    }
    triangle {
      < -0.216980, -1.146737, -2.598916>,
      < -0.163565, -1.003972, -2.781084>,
      < -0.216970, -1.164464, -2.616668>
    }
    triangle {
      < -0.216970, -1.164464, -2.616668>,
      < -0.163565, -1.003972, -2.781084>,
      < 0.520502, -1.003567, -2.781084>
    }
    triangle {
      < -0.216970, -1.164464, -2.616668>,
      < 0.520502, -1.003567, -2.781084>,
      < 0.488647, -1.036261, -2.748458>
    }
    triangle {
      < 0.488634, -1.014341, -2.726506>,
      < 0.520489, -0.981647, -2.759133>,
      < -0.163579, -0.982053, -2.759133>
    }
    triangle {
      < 0.488634, -1.014341, -2.726506>,
      < -0.163579, -0.982053, -2.759133>,
      < -0.216980, -1.146737, -2.598916>
    }
    triangle {
      < -0.290550, -1.146502, -3.070043>,
      < -0.254542, -1.000938, -2.892879>,
      < -0.254540, -1.003707, -2.887449>
    }
    triangle {
      < -0.290550, -1.146502, -3.070043>,
      < -0.254540, -1.003707, -2.887449>,
      < -0.290540, -1.164249, -3.052311>
    }
    triangle {
      < -0.290550, -1.146502, -3.070043>,
      < -0.254553, -0.981219, -2.908833>,
      < -0.254542, -1.000938, -2.892879>
    }
    triangle {
      < -0.445882, -1.164341, -3.052311>,
      < -0.446634, -1.001051, -2.892879>,
      < -0.446646, -0.981333, -2.908833>
    }
    triangle {
      < -0.445882, -1.164341, -3.052311>,
      < -0.446646, -0.981333, -2.908833>,
      < -0.445892, -1.146594, -3.070043>
    }
    triangle {
      < -0.445882, -1.164341, -3.052311>,
      < -0.446632, -1.003820, -2.887449>,
      < -0.446634, -1.001051, -2.892879>
    }
    triangle {
      < -0.445892, -1.146594, -3.070043>,
      < -0.446646, -0.981333, -2.908833>,
      < -0.254553, -0.981219, -2.908833>
    }
    triangle {
      < -0.445892, -1.146594, -3.070043>,
      < -0.254553, -0.981219, -2.908833>,
      < -0.290550, -1.146502, -3.070043>
    }
    triangle {
      < -0.290540, -1.164249, -3.052311>,
      < -0.254540, -1.003707, -2.887449>,
      < -0.446632, -1.003820, -2.887449>
    }
    triangle {
      < -0.290540, -1.164249, -3.052311>,
      < -0.446632, -1.003820, -2.887449>,
      < -0.445882, -1.164341, -3.052311>
    }
    triangle {
      < 0.488634, -1.014213, -2.942296>,
      < 0.519449, -1.000479, -2.892879>,
      < 0.520751, -1.003247, -2.887449>
    }
    triangle {
      < 0.488634, -1.014213, -2.942296>,
      < 0.520751, -1.003247, -2.887449>,
      < 0.488647, -1.036158, -2.920370>
    }
    triangle {
      < 0.488634, -1.014213, -2.942296>,
      < 0.521267, -0.980760, -2.908833>,
      < 0.519449, -1.000479, -2.892879>
    }
    triangle {
      < -0.216970, -1.164205, -3.052311>,
      < -0.163567, -1.000884, -2.892879>,
      < -0.163579, -0.981165, -2.908833>
    }
    triangle {
      < -0.216970, -1.164205, -3.052311>,
      < -0.163579, -0.981165, -2.908833>,
      < -0.216980, -1.146458, -3.070043>
    }
    triangle {
      < -0.216970, -1.164205, -3.052311>,
      < -0.163566, -1.003653, -2.887449>,
      < -0.163567, -1.000884, -2.892879>
    }
    triangle {
      < -0.216980, -1.146458, -3.070043>,
      < -0.163579, -0.981165, -2.908833>,
      < 0.521267, -0.980760, -2.908833>
    }
    triangle {
      < -0.216980, -1.146458, -3.070043>,
      < 0.521267, -0.980760, -2.908833>,
      < 0.488634, -1.014213, -2.942296>
    }
    triangle {
      < 0.488647, -1.036158, -2.920370>,
      < 0.520751, -1.003247, -2.887449>,
      < -0.163566, -1.003653, -2.887449>
    }
    triangle {
      < 0.488647, -1.036158, -2.920370>,
      < -0.163566, -1.003653, -2.887449>,
      < -0.216970, -1.164205, -3.052311>
    }
    triangle {
      < 0.488519, -0.820266, -2.920178>,
      < 0.488532, -0.842172, -2.942143>,
      < -0.217239, -0.710536, -3.069655>
    }
    triangle {
      < 0.488519, -0.820266, -2.920178>,
      < -0.217239, -0.710536, -3.069655>,
      < -0.217249, -0.692822, -3.051893>
    }
    triangle {
      < -0.290819, -0.692866, -3.051893>,
      < -0.290809, -0.710580, -3.069655>,
      < -0.446151, -0.710672, -3.069655>
    }
    triangle {
      < -0.290819, -0.692866, -3.051893>,
      < -0.446151, -0.710672, -3.069655>,
      < -0.446161, -0.692958, -3.051893>
    }
    triangle {
      < 0.488634, -1.014213, -2.942296>,
      < 0.488647, -1.036158, -2.920370>,
      < -0.216970, -1.164205, -3.052311>
    }
    triangle {
      < 0.488634, -1.014213, -2.942296>,
      < -0.216970, -1.164205, -3.052311>,
      < -0.216980, -1.146458, -3.070043>
    }
    triangle {
      < -0.290550, -1.146502, -3.070043>,
      < -0.290540, -1.164249, -3.052311>,
      < -0.445882, -1.164341, -3.052311>
    }
    triangle {
      < -0.290550, -1.146502, -3.070043>,
      < -0.445882, -1.164341, -3.052311>,
      < -0.445892, -1.146594, -3.070043>
    }
    triangle {
      < 0.488532, -0.842428, -2.726353>,
      < 0.488519, -0.820469, -2.748266>,
      < -0.217249, -0.693338, -2.616249>
    }
    triangle {
      < 0.488532, -0.842428, -2.726353>,
      < -0.217249, -0.693338, -2.616249>,
      < -0.217238, -0.711095, -2.598528>
    }
    triangle {
      < -0.290808, -0.711139, -2.598528>,
      < -0.290819, -0.693382, -2.616250>,
      < -0.446161, -0.693474, -2.616250>
    }
    triangle {
      < -0.290808, -0.711139, -2.598528>,
      < -0.446161, -0.693474, -2.616250>,
      < -0.446151, -0.711230, -2.598528>
    }
    triangle {
      < 0.488647, -1.036261, -2.748458>,
      < 0.488634, -1.014341, -2.726506>,
      < -0.216980, -1.146737, -2.598916>
    }
    triangle {
      < 0.488647, -1.036261, -2.748458>,
      < -0.216980, -1.146737, -2.598916>,
      < -0.216970, -1.164464, -2.616668>
    }
    triangle {
      < -0.290540, -1.164507, -2.616668>,
      < -0.290550, -1.146781, -2.598916>,
      < -0.445892, -1.146873, -2.598916>
    }
    triangle {
      < -0.290540, -1.164507, -2.616668>,
      < -0.445892, -1.146873, -2.598916>,
      < -0.445882, -1.164600, -2.616668>
    }
    triangle {
      < 0.916933, -0.841217, -2.867551>,
      < 0.521296, -0.853847, -2.886668>,
      < -0.163654, -0.854253, -2.886668>
    }
    triangle {
      < 0.916933, -0.841217, -2.867551>,
      < 0.916945, -0.862300, -2.900065>,
      < 0.519017, -0.862535, -2.900065>
    }
    triangle {
      < 0.916933, -0.841217, -2.867551>,
      < 0.519017, -0.862535, -2.900065>,
      < 0.521296, -0.853847, -2.886668>
    }
    triangle {
      < -0.254629, -0.854307, -2.886668>,
      < 0.916933, -0.841217, -2.867551>,
      < -0.163654, -0.854253, -2.886668>
    }
    triangle {
      < -0.163649, -0.862940, -2.900065>,
      < -0.254629, -0.854307, -2.886668>,
      < -0.163654, -0.854253, -2.886668>
    }
    triangle {
      < -0.254629, -0.854307, -2.886668>,
      < -0.446721, -0.854421, -2.886668>,
      < -0.471259, -0.842040, -2.867551>
    }
    triangle {
      < -0.254629, -0.854307, -2.886668>,
      < -0.471259, -0.842040, -2.867551>,
      < 0.916933, -0.841217, -2.867551>
    }
    triangle {
      < -0.446721, -0.854421, -2.886668>,
      < -0.446716, -0.863108, -2.900065>,
      < -0.471246, -0.863122, -2.900065>
    }
    triangle {
      < -0.446721, -0.854421, -2.886668>,
      < -0.471246, -0.863122, -2.900065>,
      < -0.471259, -0.842040, -2.867551>
    }
    triangle {
      < -0.163649, -0.862940, -2.900065>,
      < -0.254624, -0.862994, -2.900065>,
      < -0.254629, -0.854307, -2.886668>
    }
    triangle {
      < -0.471256, -0.846085, -2.792061>,
      < -0.446721, -0.854438, -2.781749>,
      < -0.254629, -0.854325, -2.781749>
    }
    triangle {
      < -0.471256, -0.846085, -2.792061>,
      < -0.471242, -0.870435, -2.762055>,
      < -0.446711, -0.870421, -2.762055>
    }
    triangle {
      < -0.471256, -0.846085, -2.792061>,
      < -0.446711, -0.870421, -2.762055>,
      < -0.446721, -0.854438, -2.781749>
    }
    triangle {
      < -0.163654, -0.854271, -2.781749>,
      < -0.471256, -0.846085, -2.792061>,
      < -0.254629, -0.854325, -2.781749>
    }
    triangle {
      < -0.254619, -0.870307, -2.762055>,
      < -0.163654, -0.854271, -2.781749>,
      < -0.254629, -0.854325, -2.781749>
    }
    triangle {
      < -0.163654, -0.854271, -2.781749>,
      < 0.521193, -0.853865, -2.781749>,
      < 0.916934, -0.845262, -2.792061>
    }
    triangle {
      < -0.163654, -0.854271, -2.781749>,
      < 0.916934, -0.845262, -2.792061>,
      < -0.471256, -0.846085, -2.792061>
    }
    triangle {
      < 0.521193, -0.853865, -2.781749>,
      < 0.519372, -0.869848, -2.762055>,
      < 0.916949, -0.869613, -2.762055>
    }
    triangle {
      < 0.521193, -0.853865, -2.781749>,
      < 0.916949, -0.869613, -2.762055>,
      < 0.916934, -0.845262, -2.792061>
    }
    triangle {
      < -0.254619, -0.870307, -2.762055>,
      < -0.163644, -0.870253, -2.762055>,
      < -0.163654, -0.854271, -2.781749>
    }
    triangle {
      < 0.916969, -0.904062, -2.744545>,
      < 0.520675, -0.875281, -2.759294>,
      < -0.163642, -0.875687, -2.759294>
    }
    triangle {
      < 0.916969, -0.904062, -2.744545>,
      < 0.916949, -0.869613, -2.762055>,
      < 0.519372, -0.869848, -2.762055>
    }
    triangle {
      < 0.916969, -0.904062, -2.744545>,
      < 0.519372, -0.869848, -2.762055>,
      < 0.520675, -0.875281, -2.759294>
    }
    triangle {
      < -0.254616, -0.875741, -2.759294>,
      < 0.916969, -0.904062, -2.744545>,
      < -0.163642, -0.875687, -2.759294>
    }
    triangle {
      < -0.163644, -0.870253, -2.762055>,
      < -0.254616, -0.875741, -2.759294>,
      < -0.163642, -0.875687, -2.759294>
    }
    triangle {
      < -0.254616, -0.875741, -2.759294>,
      < -0.446709, -0.875854, -2.759294>,
      < -0.471222, -0.904884, -2.744545>
    }
    triangle {
      < -0.254616, -0.875741, -2.759294>,
      < -0.471222, -0.904884, -2.744545>,
      < 0.916969, -0.904062, -2.744545>
    }
    triangle {
      < -0.446709, -0.875854, -2.759294>,
      < -0.446711, -0.870421, -2.762055>,
      < -0.471242, -0.870435, -2.762055>
    }
    triangle {
      < -0.446709, -0.875854, -2.759294>,
      < -0.471242, -0.870435, -2.762055>,
      < -0.471222, -0.904884, -2.744545>
    }
    triangle {
      < -0.163644, -0.870253, -2.762055>,
      < -0.254619, -0.870307, -2.762055>,
      < -0.254616, -0.875741, -2.759294>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < 0.520489, -0.981647, -2.759133>,
      < 0.917014, -0.978719, -2.756435>
    }
    triangle {
      < 0.520489, -0.981647, -2.759133>,
      < 0.520502, -1.003567, -2.781084>,
      < 0.917030, -1.006024, -2.783781>
    }
    triangle {
      < 0.520489, -0.981647, -2.759133>,
      < 0.917030, -1.006024, -2.783781>,
      < 0.917014, -0.978719, -2.756435>
    }
    triangle {
      < 0.520502, -1.003567, -2.781084>,
      < -0.163565, -1.003972, -2.781084>,
      < 0.917030, -1.006024, -2.783781>
    }
    triangle {
      < -0.163565, -1.003972, -2.781084>,
      < -0.254540, -1.004026, -2.781084>,
      < 0.917030, -1.006024, -2.783781>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < -0.163579, -0.982053, -2.759133>,
      < 0.520489, -0.981647, -2.759133>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < -0.254553, -0.982107, -2.759133>,
      < -0.163579, -0.982053, -2.759133>
    }
    triangle {
      < -0.254553, -0.982107, -2.759133>,
      < -0.163565, -1.003972, -2.781084>,
      < -0.163579, -0.982053, -2.759133>
    }
    triangle {
      < -0.254553, -0.982107, -2.759133>,
      < -0.254540, -1.004026, -2.781084>,
      < -0.163565, -1.003972, -2.781084>
    }
    triangle {
      < -0.254540, -1.004026, -2.781084>,
      < -0.446632, -1.004140, -2.781084>,
      < -0.471161, -1.006846, -2.783781>
    }
    triangle {
      < -0.254540, -1.004026, -2.781084>,
      < -0.471161, -1.006846, -2.783781>,
      < 0.917030, -1.006024, -2.783781>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < -0.446646, -0.982221, -2.759133>,
      < -0.254553, -0.982107, -2.759133>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < -0.446632, -1.004140, -2.781084>,
      < -0.446646, -0.982221, -2.759133>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < -0.471161, -1.006846, -2.783781>,
      < -0.446632, -1.004140, -2.781084>
    }
    triangle {
      < -0.471154, -1.018627, -2.858456>,
      < -0.446632, -1.003820, -2.887449>,
      < -0.254540, -1.003707, -2.887449>
    }
    triangle {
      < -0.471154, -1.018627, -2.858456>,
      < -0.471164, -1.001066, -2.892879>,
      < -0.446634, -1.001051, -2.892879>
    }
    triangle {
      < -0.471154, -1.018627, -2.858456>,
      < -0.446634, -1.001051, -2.892879>,
      < -0.446632, -1.003820, -2.887449>
    }
    triangle {
      < -0.163566, -1.003653, -2.887449>,
      < -0.471154, -1.018627, -2.858456>,
      < -0.254540, -1.003707, -2.887449>
    }
    triangle {
      < -0.254542, -1.000938, -2.892879>,
      < -0.163566, -1.003653, -2.887449>,
      < -0.254540, -1.003707, -2.887449>
    }
    triangle {
      < -0.163566, -1.003653, -2.887449>,
      < 0.520751, -1.003247, -2.887449>,
      < 0.917037, -1.017804, -2.858456>
    }
    triangle {
      < -0.163566, -1.003653, -2.887449>,
      < 0.917037, -1.017804, -2.858456>,
      < -0.471154, -1.018627, -2.858456>
    }
    triangle {
      < 0.520751, -1.003247, -2.887449>,
      < 0.519449, -1.000479, -2.892879>,
      < 0.917026, -1.000243, -2.892879>
    }
    triangle {
      < 0.520751, -1.003247, -2.887449>,
      < 0.917026, -1.000243, -2.892879>,
      < 0.917037, -1.017804, -2.858456>
    }
    triangle {
      < -0.254542, -1.000938, -2.892879>,
      < -0.163567, -1.000884, -2.892879>,
      < -0.163566, -1.003653, -2.887449>
    }
    triangle {
      < 0.917009, -0.970201, -2.917185>,
      < 0.521267, -0.980760, -2.908833>,
      < -0.163579, -0.981165, -2.908833>
    }
    triangle {
      < 0.917009, -0.970201, -2.917185>,
      < 0.917026, -1.000243, -2.892879>,
      < 0.519449, -1.000479, -2.892879>
    }
    triangle {
      < 0.917009, -0.970201, -2.917185>,
      < 0.519449, -1.000479, -2.892879>,
      < 0.521267, -0.980760, -2.908833>
    }
    triangle {
      < -0.254553, -0.981219, -2.908833>,
      < 0.917009, -0.970201, -2.917185>,
      < -0.163579, -0.981165, -2.908833>
    }
    triangle {
      < -0.163567, -1.000884, -2.892879>,
      < -0.254553, -0.981219, -2.908833>,
      < -0.163579, -0.981165, -2.908833>
    }
    triangle {
      < -0.254553, -0.981219, -2.908833>,
      < -0.446646, -0.981333, -2.908833>,
      < -0.471182, -0.971024, -2.917186>
    }
    triangle {
      < -0.254553, -0.981219, -2.908833>,
      < -0.471182, -0.971024, -2.917186>,
      < 0.917009, -0.970201, -2.917185>
    }
    triangle {
      < -0.446646, -0.981333, -2.908833>,
      < -0.446634, -1.001051, -2.892879>,
      < -0.471164, -1.001066, -2.892879>
    }
    triangle {
      < -0.446646, -0.981333, -2.908833>,
      < -0.471164, -1.001066, -2.892879>,
      < -0.471182, -0.971024, -2.917186>
    }
    triangle {
      < -0.163567, -1.000884, -2.892879>,
      < -0.254542, -1.000938, -2.892879>,
      < -0.254553, -0.981219, -2.908833>
    }
    triangle {
      < -0.471227, -0.895528, -2.921119>,
      < -0.446708, -0.876314, -2.908645>,
      < -0.254615, -0.876200, -2.908645>
    }
    triangle {
      < -0.471227, -0.895528, -2.921119>,
      < -0.471246, -0.863122, -2.900065>,
      < -0.446716, -0.863108, -2.900065>
    }
    triangle {
      < -0.471227, -0.895528, -2.921119>,
      < -0.446716, -0.863108, -2.900065>,
      < -0.446708, -0.876314, -2.908645>
    }
    triangle {
      < -0.163641, -0.876146, -2.908645>,
      < -0.471227, -0.895528, -2.921119>,
      < -0.254615, -0.876200, -2.908645>
    }
    triangle {
      < -0.254624, -0.862994, -2.900065>,
      < -0.163641, -0.876146, -2.908645>,
      < -0.254615, -0.876200, -2.908645>
    }
    triangle {
      < -0.163641, -0.876146, -2.908645>,
      < 0.521297, -0.875740, -2.908645>,
      < 0.916964, -0.894705, -2.921118>
    }
    triangle {
      < -0.163641, -0.876146, -2.908645>,
      < 0.916964, -0.894705, -2.921118>,
      < -0.471227, -0.895528, -2.921119>
    }
    triangle {
      < 0.521297, -0.875740, -2.908645>,
      < 0.519017, -0.862535, -2.900065>,
      < 0.916945, -0.862300, -2.900065>
    }
    triangle {
      < 0.521297, -0.875740, -2.908645>,
      < 0.916945, -0.862300, -2.900065>,
      < 0.916964, -0.894705, -2.921118>
    }
    triangle {
      < -0.254624, -0.862994, -2.900065>,
      < -0.163649, -0.862940, -2.900065>,
      < -0.163641, -0.876146, -2.908645>
    }
    triangle {
      < 1.139642, -0.875315, -2.886922>,
      < 1.139657, -0.901239, -2.903765>,
      < 0.916964, -0.894705, -2.921118>
    }
    triangle {
      < 1.139642, -0.875315, -2.886922>,
      < 0.916964, -0.894705, -2.921118>,
      < 0.916945, -0.862300, -2.900065>
    }
    triangle {
      < 1.139632, -0.858449, -2.860911>,
      < 1.139642, -0.875315, -2.886922>,
      < 0.916945, -0.862300, -2.900065>
    }
    triangle {
      < 1.139632, -0.858449, -2.860911>,
      < 0.916945, -0.862300, -2.900065>,
      < 0.916933, -0.841217, -2.867551>
    }
    triangle {
      < -0.471259, -0.842040, -2.867551>,
      < -0.471246, -0.863122, -2.900065>,
      < -0.482807, -0.876276, -2.886922>
    }
    triangle {
      < -0.471259, -0.842040, -2.867551>,
      < -0.482807, -0.876276, -2.886922>,
      < -0.482818, -0.859411, -2.860911>
    }
    triangle {
      < -0.471246, -0.863122, -2.900065>,
      < -0.471227, -0.895528, -2.921119>,
      < -0.482791, -0.902200, -2.903765>
    }
    triangle {
      < -0.471246, -0.863122, -2.900065>,
      < -0.482791, -0.902200, -2.903765>,
      < -0.482807, -0.876276, -2.886922>
    }
    triangle {
      < 0.916964, -0.894705, -2.921118>,
      < 0.916987, -0.932871, -2.927174>,
      < -0.471205, -0.933694, -2.927174>
    }
    triangle {
      < 0.916964, -0.894705, -2.921118>,
      < -0.471205, -0.933694, -2.927174>,
      < -0.471227, -0.895528, -2.921119>
    }
    triangle {
      < -0.471227, -0.895528, -2.921119>,
      < -0.471205, -0.933694, -2.927174>,
      < -0.482773, -0.932733, -2.908609>
    }
    triangle {
      < -0.471227, -0.895528, -2.921119>,
      < -0.482773, -0.932733, -2.908609>,
      < -0.482791, -0.902200, -2.903765>
    }
    triangle {
      < 1.139657, -0.901239, -2.903765>,
      < 1.139675, -0.931772, -2.908609>,
      < 0.916987, -0.932871, -2.927174>
    }
    triangle {
      < 1.139657, -0.901239, -2.903765>,
      < 0.916987, -0.932871, -2.927174>,
      < 0.916964, -0.894705, -2.921118>
    }
    triangle {
      < 0.916929, -0.835218, -2.829375>,
      < 0.916933, -0.841217, -2.867551>,
      < -0.471259, -0.842040, -2.867551>
    }
    triangle {
      < 0.916929, -0.835218, -2.829375>,
      < -0.471259, -0.842040, -2.867551>,
      < -0.471263, -0.836041, -2.829376>
    }
    triangle {
      < 1.139629, -0.853650, -2.830371>,
      < 1.139632, -0.858449, -2.860911>,
      < 0.916933, -0.841217, -2.867551>
    }
    triangle {
      < 1.139629, -0.853650, -2.830371>,
      < 0.916933, -0.841217, -2.867551>,
      < 0.916929, -0.835218, -2.829375>
    }
    triangle {
      < -0.471263, -0.836041, -2.829376>,
      < -0.471259, -0.842040, -2.867551>,
      < -0.482818, -0.859411, -2.860911>
    }
    triangle {
      < -0.471263, -0.836041, -2.829376>,
      < -0.482818, -0.859411, -2.860911>,
      < -0.482820, -0.854611, -2.830371>
    }
    triangle {
      < 1.237973, -0.875754, -2.854270>,
      < 1.237981, -0.888404, -2.873778>,
      < 1.139642, -0.875315, -2.886922>
    }
    triangle {
      < 1.237973, -0.875754, -2.854270>,
      < 1.139642, -0.875315, -2.886922>,
      < 1.139632, -0.858449, -2.860911>
    }
    triangle {
      < -0.482818, -0.859411, -2.860911>,
      < -0.482807, -0.876276, -2.886922>,
      < -0.398926, -0.895008, -2.868147>
    }
    triangle {
      < -0.482818, -0.859411, -2.860911>,
      < -0.398926, -0.895008, -2.868147>,
      < -0.398932, -0.884166, -2.851424>
    }
    triangle {
      < 1.237981, -0.888404, -2.873778>,
      < 1.237992, -0.907846, -2.886411>,
      < 1.139657, -0.901239, -2.903765>
    }
    triangle {
      < 1.237981, -0.888404, -2.873778>,
      < 1.139657, -0.901239, -2.903765>,
      < 1.139642, -0.875315, -2.886922>
    }
    triangle {
      < -0.482807, -0.876276, -2.886922>,
      < -0.482791, -0.902200, -2.903765>,
      < -0.398916, -0.911674, -2.878974>
    }
    triangle {
      < -0.482807, -0.876276, -2.886922>,
      < -0.398916, -0.911674, -2.878974>,
      < -0.398926, -0.895008, -2.868147>
    }
    triangle {
      < 1.237992, -0.907846, -2.886411>,
      < 1.238006, -0.930747, -2.890044>,
      < 1.139675, -0.931772, -2.908609>
    }
    triangle {
      < 1.237992, -0.907846, -2.886411>,
      < 1.139675, -0.931772, -2.908609>,
      < 1.139657, -0.901239, -2.903765>
    }
    triangle {
      < -0.482791, -0.902200, -2.903765>,
      < -0.482773, -0.932733, -2.908609>,
      < -0.398904, -0.931302, -2.882088>
    }
    triangle {
      < -0.482791, -0.902200, -2.903765>,
      < -0.398904, -0.931302, -2.882088>,
      < -0.398916, -0.911674, -2.878974>
    }
    triangle {
      < -0.482820, -0.854611, -2.830371>,
      < -0.482818, -0.859411, -2.860911>,
      < -0.398932, -0.884166, -2.851424>
    }
    triangle {
      < -0.482820, -0.854611, -2.830371>,
      < -0.398932, -0.884166, -2.851424>,
      < -0.398934, -0.881080, -2.831792>
    }
    triangle {
      < 1.237971, -0.872154, -2.831365>,
      < 1.237973, -0.875754, -2.854270>,
      < 1.139632, -0.858449, -2.860911>
    }
    triangle {
      < 1.237971, -0.872154, -2.831365>,
      < 1.139632, -0.858449, -2.860911>,
      < 1.139629, -0.853650, -2.830371>
    }
    triangle {
      < 1.139675, -0.931772, -2.908609>,
      < 1.139693, -0.961636, -2.900618>,
      < 0.917009, -0.970201, -2.917185>
    }
    triangle {
      < 1.139675, -0.931772, -2.908609>,
      < 0.917009, -0.970201, -2.917185>,
      < 0.916987, -0.932871, -2.927174>
    }
    triangle {
      < -0.471205, -0.933694, -2.927174>,
      < -0.471182, -0.971024, -2.917186>,
      < -0.482756, -0.962597, -2.900618>
    }
    triangle {
      < -0.471205, -0.933694, -2.927174>,
      < -0.482756, -0.962597, -2.900618>,
      < -0.482773, -0.932733, -2.908609>
    }
    triangle {
      < 0.916987, -0.932871, -2.927174>,
      < 0.917009, -0.970201, -2.917185>,
      < -0.471182, -0.971024, -2.917186>
    }
    triangle {
      < 0.916987, -0.932871, -2.927174>,
      < -0.471182, -0.971024, -2.917186>,
      < -0.471205, -0.933694, -2.927174>
    }
    triangle {
      < 1.139634, -0.861686, -2.800518>,
      < 1.139629, -0.853650, -2.830371>,
      < 0.916929, -0.835218, -2.829375>
    }
    triangle {
      < 1.139634, -0.861686, -2.800518>,
      < 0.916929, -0.835218, -2.829375>,
      < 0.916934, -0.845262, -2.792061>
    }
    triangle {
      < 0.916934, -0.845262, -2.792061>,
      < 0.916929, -0.835218, -2.829375>,
      < -0.471263, -0.836041, -2.829376>
    }
    triangle {
      < 0.916934, -0.845262, -2.792061>,
      < -0.471263, -0.836041, -2.829376>,
      < -0.471256, -0.846085, -2.792061>
    }
    triangle {
      < -0.471256, -0.846085, -2.792061>,
      < -0.471263, -0.836041, -2.829376>,
      < -0.482820, -0.854611, -2.830371>
    }
    triangle {
      < -0.471256, -0.846085, -2.792061>,
      < -0.482820, -0.854611, -2.830371>,
      < -0.482815, -0.862647, -2.800519>
    }
    triangle {
      < 1.292934, -0.895566, -2.846681>,
      < 1.292938, -0.903397, -2.858758>,
      < 1.237981, -0.888404, -2.873778>
    }
    triangle {
      < 1.292934, -0.895566, -2.846681>,
      < 1.237981, -0.888404, -2.873778>,
      < 1.237973, -0.875754, -2.854270>
    }
    triangle {
      < 1.292938, -0.903397, -2.858758>,
      < 1.292945, -0.915433, -2.866578>,
      < 1.237992, -0.907846, -2.886411>
    }
    triangle {
      < 1.292938, -0.903397, -2.858758>,
      < 1.237992, -0.907846, -2.886411>,
      < 1.237981, -0.888404, -2.873778>
    }
    triangle {
      < 1.292945, -0.915433, -2.866578>,
      < 1.292953, -0.929609, -2.868827>,
      < 1.238006, -0.930747, -2.890044>
    }
    triangle {
      < 1.292945, -0.915433, -2.866578>,
      < 1.238006, -0.930747, -2.890044>,
      < 1.237992, -0.907846, -2.886411>
    }
    triangle {
      < 1.292932, -0.893337, -2.832502>,
      < 1.292934, -0.895566, -2.846681>,
      < 1.237973, -0.875754, -2.854270>
    }
    triangle {
      < 1.292932, -0.893337, -2.832502>,
      < 1.237973, -0.875754, -2.854270>,
      < 1.237971, -0.872154, -2.831365>
    }
    triangle {
      < 1.238006, -0.930747, -2.890044>,
      < 1.238018, -0.953145, -2.884050>,
      < 1.139693, -0.961636, -2.900618>
    }
    triangle {
      < 1.238006, -0.930747, -2.890044>,
      < 1.139693, -0.961636, -2.900618>,
      < 1.139675, -0.931772, -2.908609>
    }
    triangle {
      < -0.482773, -0.932733, -2.908609>,
      < -0.482756, -0.962597, -2.900618>,
      < -0.398894, -0.950500, -2.876951>
    }
    triangle {
      < -0.482773, -0.932733, -2.908609>,
      < -0.398894, -0.950500, -2.876951>,
      < -0.398904, -0.931302, -2.882088>
    }
    triangle {
      < 1.237974, -0.878181, -2.808976>,
      < 1.237971, -0.872154, -2.831365>,
      < 1.139629, -0.853650, -2.830371>
    }
    triangle {
      < 1.237974, -0.878181, -2.808976>,
      < 1.139629, -0.853650, -2.830371>,
      < 1.139634, -0.861686, -2.800518>
    }
    triangle {
      < -0.482815, -0.862647, -2.800519>,
      < -0.482820, -0.854611, -2.830371>,
      < -0.398934, -0.881080, -2.831792>
    }
    triangle {
      < -0.482815, -0.862647, -2.800519>,
      < -0.398934, -0.881080, -2.831792>,
      < -0.398931, -0.886246, -2.812601>
    }
    triangle {
      < -0.398932, -0.884166, -2.851424>,
      < -0.398926, -0.895008, -2.868147>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < -0.398926, -0.895008, -2.868147>,
      < -0.398916, -0.911674, -2.878974>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < -0.398916, -0.911674, -2.878974>,
      < -0.398904, -0.931302, -2.882088>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < -0.398934, -0.881080, -2.831792>,
      < -0.398932, -0.884166, -2.851424>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.292953, -0.929609, -2.868827>,
      < 1.292962, -0.943474, -2.865117>,
      < 1.238018, -0.953145, -2.884050>
    }
    triangle {
      < 1.292953, -0.929609, -2.868827>,
      < 1.238018, -0.953145, -2.884050>,
      < 1.238006, -0.930747, -2.890044>
    }
    triangle {
      < 1.292935, -0.897068, -2.818642>,
      < 1.292932, -0.893337, -2.832502>,
      < 1.237971, -0.872154, -2.831365>
    }
    triangle {
      < 1.292935, -0.897068, -2.818642>,
      < 1.237971, -0.872154, -2.831365>,
      < 1.237974, -0.878181, -2.808976>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292945, -0.915433, -2.866578>,
      < 1.292938, -0.903397, -2.858758>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292938, -0.903397, -2.858758>,
      < 1.292934, -0.895566, -2.846681>
    }
    triangle {
      < -0.398904, -0.931302, -2.882088>,
      < -0.398894, -0.950500, -2.876951>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < -0.398931, -0.886246, -2.812601>,
      < -0.398934, -0.881080, -2.831792>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292953, -0.929609, -2.868827>,
      < 1.292945, -0.915433, -2.866578>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292934, -0.895566, -2.846681>,
      < 1.292932, -0.893337, -2.832502>
    }
    triangle {
      < -0.471182, -0.971024, -2.917186>,
      < -0.471164, -1.001066, -2.892879>,
      < -0.482742, -0.986631, -2.881173>
    }
    triangle {
      < -0.471182, -0.971024, -2.917186>,
      < -0.482742, -0.986631, -2.881173>,
      < -0.482756, -0.962597, -2.900618>
    }
    triangle {
      < 1.139693, -0.961636, -2.900618>,
      < 1.139708, -0.985670, -2.881173>,
      < 0.917026, -1.000243, -2.892879>
    }
    triangle {
      < 1.139693, -0.961636, -2.900618>,
      < 0.917026, -1.000243, -2.892879>,
      < 0.917009, -0.970201, -2.917185>
    }
    triangle {
      < -0.471242, -0.870435, -2.762055>,
      < -0.471256, -0.846085, -2.792061>,
      < -0.482815, -0.862647, -2.800519>
    }
    triangle {
      < -0.471242, -0.870435, -2.762055>,
      < -0.482815, -0.862647, -2.800519>,
      < -0.482804, -0.882127, -2.776514>
    }
    triangle {
      < 1.139646, -0.881166, -2.776514>,
      < 1.139634, -0.861686, -2.800518>,
      < 0.916934, -0.845262, -2.792061>
    }
    triangle {
      < 1.139646, -0.881166, -2.776514>,
      < 0.916934, -0.845262, -2.792061>,
      < 0.916949, -0.869613, -2.762055>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292962, -0.943474, -2.865117>,
      < 1.292953, -0.929609, -2.868827>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292932, -0.893337, -2.832502>,
      < 1.292935, -0.897068, -2.818642>
    }
    triangle {
      < 1.238018, -0.953145, -2.884050>,
      < 1.238029, -0.971170, -2.869467>,
      < 1.139708, -0.985670, -2.881173>
    }
    triangle {
      < 1.238018, -0.953145, -2.884050>,
      < 1.139708, -0.985670, -2.881173>,
      < 1.139693, -0.961636, -2.900618>
    }
    triangle {
      < -0.482756, -0.962597, -2.900618>,
      < -0.482742, -0.986631, -2.881173>,
      < -0.398884, -0.965951, -2.864451>
    }
    triangle {
      < -0.482756, -0.962597, -2.900618>,
      < -0.398884, -0.965951, -2.864451>,
      < -0.398894, -0.950500, -2.876951>
    }
    triangle {
      < 1.237983, -0.892792, -2.790972>,
      < 1.237974, -0.878181, -2.808976>,
      < 1.139634, -0.861686, -2.800518>
    }
    triangle {
      < 1.237983, -0.892792, -2.790972>,
      < 1.139634, -0.861686, -2.800518>,
      < 1.139646, -0.881166, -2.776514>
    }
    triangle {
      < -0.482804, -0.882127, -2.776514>,
      < -0.482815, -0.862647, -2.800519>,
      < -0.398931, -0.886246, -2.812601>
    }
    triangle {
      < -0.482804, -0.882127, -2.776514>,
      < -0.398931, -0.886246, -2.812601>,
      < -0.398924, -0.898769, -2.797170>
    }
    triangle {
      < 1.292962, -0.943474, -2.865117>,
      < 1.292969, -0.954632, -2.856089>,
      < 1.238029, -0.971170, -2.869467>
    }
    triangle {
      < 1.292962, -0.943474, -2.865117>,
      < 1.238029, -0.971170, -2.869467>,
      < 1.238018, -0.953145, -2.884050>
    }
    triangle {
      < 1.292940, -0.906113, -2.807497>,
      < 1.292935, -0.897068, -2.818642>,
      < 1.237974, -0.878181, -2.808976>
    }
    triangle {
      < 1.292940, -0.906113, -2.807497>,
      < 1.237974, -0.878181, -2.808976>,
      < 1.237983, -0.892792, -2.790972>
    }
    triangle {
      < -0.398894, -0.950500, -2.876951>,
      < -0.398884, -0.965951, -2.864451>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < -0.398924, -0.898769, -2.797170>,
      < -0.398931, -0.886246, -2.812601>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292969, -0.954632, -2.856089>,
      < 1.292962, -0.943474, -2.865117>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292935, -0.897068, -2.818642>,
      < 1.292940, -0.906113, -2.807497>
    }
    triangle {
      < -0.398913, -0.916486, -2.788164>,
      < -0.398924, -0.898769, -2.797170>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292972, -0.961155, -2.843303>,
      < 1.292969, -0.954632, -2.856089>
    }
    triangle {
      < -0.398902, -0.936334, -2.787142>,
      < -0.398913, -0.916486, -2.788164>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < -0.398882, -0.968924, -2.808343>,
      < -0.398891, -0.954881, -2.794279>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < -0.398891, -0.954881, -2.794279>,
      < -0.398902, -0.936334, -2.787142>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292963, -0.946638, -2.805410>,
      < 1.292970, -0.956780, -2.815567>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292940, -0.906113, -2.807497>,
      < 1.292947, -0.918908, -2.800993>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292947, -0.918908, -2.800993>,
      < 1.292955, -0.933242, -2.800255>
    }
    triangle {
      < -0.398884, -0.965951, -2.864451>,
      < -0.398878, -0.974982, -2.846747>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292972, -0.961915, -2.828970>,
      < 1.292972, -0.961155, -2.843303>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292955, -0.933242, -2.800255>,
      < 1.292963, -0.946638, -2.805410>
    }
    triangle {
      < -0.398878, -0.974982, -2.846747>,
      < -0.398878, -0.976034, -2.826902>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.339226, -0.927784, -2.834349>,
      < 1.292970, -0.956780, -2.815567>,
      < 1.292972, -0.961915, -2.828970>
    }
    triangle {
      < -0.398878, -0.976034, -2.826902>,
      < -0.398882, -0.968924, -2.808343>,
      < -0.381554, -0.928804, -2.834350>
    }
    triangle {
      < 1.292969, -0.954632, -2.856089>,
      < 1.292972, -0.961155, -2.843303>,
      < 1.238035, -0.981706, -2.848813>
    }
    triangle {
      < 1.292969, -0.954632, -2.856089>,
      < 1.238035, -0.981706, -2.848813>,
      < 1.238029, -0.971170, -2.869467>
    }
    triangle {
      < 1.292947, -0.918908, -2.800993>,
      < 1.292940, -0.906113, -2.807497>,
      < 1.237983, -0.892792, -2.790972>
    }
    triangle {
      < 1.292947, -0.918908, -2.800993>,
      < 1.237983, -0.892792, -2.790972>,
      < 1.237995, -0.913461, -2.780466>
    }
    triangle {
      < -0.482742, -0.986631, -2.881173>,
      < -0.482734, -1.000679, -2.853635>,
      < -0.398878, -0.974982, -2.846747>
    }
    triangle {
      < -0.482742, -0.986631, -2.881173>,
      < -0.398878, -0.974982, -2.846747>,
      < -0.398884, -0.965951, -2.864451>
    }
    triangle {
      < -0.482787, -0.909686, -2.762506>,
      < -0.482804, -0.882127, -2.776514>,
      < -0.398924, -0.898769, -2.797170>
    }
    triangle {
      < -0.482787, -0.909686, -2.762506>,
      < -0.398924, -0.898769, -2.797170>,
      < -0.398913, -0.916486, -2.788164>
    }
    triangle {
      < 1.238029, -0.971170, -2.869467>,
      < 1.238035, -0.981706, -2.848813>,
      < 1.139716, -0.999718, -2.853635>
    }
    triangle {
      < 1.238029, -0.971170, -2.869467>,
      < 1.139716, -0.999718, -2.853635>,
      < 1.139708, -0.985670, -2.881173>
    }
    triangle {
      < 1.237995, -0.913461, -2.780466>,
      < 1.237983, -0.892792, -2.790972>,
      < 1.139646, -0.881166, -2.776514>
    }
    triangle {
      < 1.237995, -0.913461, -2.780466>,
      < 1.139646, -0.881166, -2.776514>,
      < 1.139662, -0.908725, -2.762506>
    }
    triangle {
      < -0.471164, -1.001066, -2.892879>,
      < -0.471154, -1.018627, -2.858456>,
      < -0.482734, -1.000679, -2.853635>
    }
    triangle {
      < -0.471164, -1.001066, -2.892879>,
      < -0.482734, -1.000679, -2.853635>,
      < -0.482742, -0.986631, -2.881173>
    }
    triangle {
      < 1.139708, -0.985670, -2.881173>,
      < 1.139716, -0.999718, -2.853635>,
      < 0.917037, -1.017804, -2.858456>
    }
    triangle {
      < 1.139708, -0.985670, -2.881173>,
      < 0.917037, -1.017804, -2.858456>,
      < 0.917026, -1.000243, -2.892879>
    }
    triangle {
      < 1.139662, -0.908725, -2.762506>,
      < 1.139646, -0.881166, -2.776514>,
      < 0.916949, -0.869613, -2.762055>
    }
    triangle {
      < 1.139662, -0.908725, -2.762506>,
      < 0.916949, -0.869613, -2.762055>,
      < 0.916969, -0.904062, -2.744545>
    }
    triangle {
      < -0.471222, -0.904884, -2.744545>,
      < -0.471242, -0.870435, -2.762055>,
      < -0.482804, -0.882127, -2.776514>
    }
    triangle {
      < -0.471222, -0.904884, -2.744545>,
      < -0.482804, -0.882127, -2.776514>,
      < -0.482787, -0.909686, -2.762506>
    }
    triangle {
      < 1.292972, -0.961155, -2.843303>,
      < 1.292972, -0.961915, -2.828970>,
      < 1.238036, -0.982933, -2.825660>
    }
    triangle {
      < 1.292972, -0.961155, -2.843303>,
      < 1.238036, -0.982933, -2.825660>,
      < 1.238035, -0.981706, -2.848813>
    }
    triangle {
      < 1.292955, -0.933242, -2.800255>,
      < 1.292947, -0.918908, -2.800993>,
      < 1.237995, -0.913461, -2.780466>
    }
    triangle {
      < 1.292955, -0.933242, -2.800255>,
      < 1.237995, -0.913461, -2.780466>,
      < 1.238009, -0.936616, -2.779274>
    }
    triangle {
      < -0.482734, -1.000679, -2.853635>,
      < -0.482732, -1.002316, -2.822764>,
      < -0.398878, -0.976034, -2.826902>
    }
    triangle {
      < -0.482734, -1.000679, -2.853635>,
      < -0.398878, -0.976034, -2.826902>,
      < -0.398878, -0.974982, -2.846747>
    }
    triangle {
      < -0.482769, -0.940560, -2.760916>,
      < -0.482787, -0.909686, -2.762506>,
      < -0.398913, -0.916486, -2.788164>
    }
    triangle {
      < -0.482769, -0.940560, -2.760916>,
      < -0.398913, -0.916486, -2.788164>,
      < -0.398902, -0.936334, -2.787142>
    }
    triangle {
      < 1.238035, -0.981706, -2.848813>,
      < 1.238036, -0.982933, -2.825660>,
      < 1.139717, -1.001354, -2.822764>
    }
    triangle {
      < 1.238035, -0.981706, -2.848813>,
      < 1.139717, -1.001354, -2.822764>,
      < 1.139716, -0.999718, -2.853635>
    }
    triangle {
      < 1.292972, -0.961915, -2.828970>,
      < 1.292970, -0.956780, -2.815567>,
      < 1.238032, -0.974638, -2.804009>
    }
    triangle {
      < 1.292972, -0.961915, -2.828970>,
      < 1.238032, -0.974638, -2.804009>,
      < 1.238036, -0.982933, -2.825660>
    }
    triangle {
      < 1.238009, -0.936616, -2.779274>,
      < 1.237995, -0.913461, -2.780466>,
      < 1.139662, -0.908725, -2.762506>
    }
    triangle {
      < 1.238009, -0.936616, -2.779274>,
      < 1.139662, -0.908725, -2.762506>,
      < 1.139681, -0.939599, -2.760916>
    }
    triangle {
      < 1.292963, -0.946638, -2.805410>,
      < 1.292955, -0.933242, -2.800255>,
      < 1.238009, -0.936616, -2.779274>
    }
    triangle {
      < 1.292963, -0.946638, -2.805410>,
      < 1.238009, -0.936616, -2.779274>,
      < 1.238022, -0.958255, -2.787601>
    }
    triangle {
      < 1.292970, -0.956780, -2.815567>,
      < 1.292963, -0.946638, -2.805410>,
      < 1.238022, -0.958255, -2.787601>
    }
    triangle {
      < 1.292970, -0.956780, -2.815567>,
      < 1.238022, -0.958255, -2.787601>,
      < 1.238032, -0.974638, -2.804009>
    }
    triangle {
      < -0.471154, -1.018627, -2.858456>,
      < -0.471153, -1.020671, -2.819866>,
      < -0.482732, -1.002316, -2.822764>
    }
    triangle {
      < -0.471154, -1.018627, -2.858456>,
      < -0.482732, -1.002316, -2.822764>,
      < -0.482734, -1.000679, -2.853635>
    }
    triangle {
      < 1.139716, -0.999718, -2.853635>,
      < 1.139717, -1.001354, -2.822764>,
      < 0.917038, -1.019849, -2.819866>
    }
    triangle {
      < 1.139716, -0.999718, -2.853635>,
      < 0.917038, -1.019849, -2.819866>,
      < 0.917037, -1.017804, -2.858456>
    }
    triangle {
      < 1.139681, -0.939599, -2.760916>,
      < 1.139662, -0.908725, -2.762506>,
      < 0.916969, -0.904062, -2.744545>
    }
    triangle {
      < 1.139681, -0.939599, -2.760916>,
      < 0.916969, -0.904062, -2.744545>,
      < 0.916992, -0.942654, -2.742557>
    }
    triangle {
      < -0.471199, -0.943477, -2.742558>,
      < -0.471222, -0.904884, -2.744545>,
      < -0.482787, -0.909686, -2.762506>
    }
    triangle {
      < -0.471199, -0.943477, -2.742558>,
      < -0.482787, -0.909686, -2.762506>,
      < -0.482769, -0.940560, -2.760916>
    }
    triangle {
      < -0.482732, -1.002316, -2.822764>,
      < -0.482739, -0.991256, -2.793895>,
      < -0.398882, -0.968924, -2.808343>
    }
    triangle {
      < -0.482732, -1.002316, -2.822764>,
      < -0.398882, -0.968924, -2.808343>,
      < -0.398878, -0.976034, -2.826902>
    }
    triangle {
      < -0.482752, -0.969412, -2.772019>,
      < -0.482769, -0.940560, -2.760916>,
      < -0.398902, -0.936334, -2.787142>
    }
    triangle {
      < -0.482752, -0.969412, -2.772019>,
      < -0.398902, -0.936334, -2.787142>,
      < -0.398891, -0.954881, -2.794279>
    }
    triangle {
      < 1.238036, -0.982933, -2.825660>,
      < 1.238032, -0.974638, -2.804009>,
      < 1.139711, -0.990295, -2.793895>
    }
    triangle {
      < 1.238036, -0.982933, -2.825660>,
      < 1.139711, -0.990295, -2.793895>,
      < 1.139717, -1.001354, -2.822764>
    }
    triangle {
      < 1.238022, -0.958255, -2.787601>,
      < 1.238009, -0.936616, -2.779274>,
      < 1.139681, -0.939599, -2.760916>
    }
    triangle {
      < 1.238022, -0.958255, -2.787601>,
      < 1.139681, -0.939599, -2.760916>,
      < 1.139697, -0.968451, -2.772018>
    }
    triangle {
      < 0.917037, -1.017804, -2.858456>,
      < 0.917038, -1.019849, -2.819866>,
      < -0.471153, -1.020671, -2.819866>
    }
    triangle {
      < 0.917037, -1.017804, -2.858456>,
      < -0.471153, -1.020671, -2.819866>,
      < -0.471154, -1.018627, -2.858456>
    }
    triangle {
      < 0.916992, -0.942654, -2.742557>,
      < 0.916969, -0.904062, -2.744545>,
      < -0.471222, -0.904884, -2.744545>
    }
    triangle {
      < 0.916992, -0.942654, -2.742557>,
      < -0.471222, -0.904884, -2.744545>,
      < -0.471199, -0.943477, -2.742558>
    }
    triangle {
      < -0.482739, -0.991256, -2.793895>,
      < -0.482752, -0.969412, -2.772019>,
      < -0.398891, -0.954881, -2.794279>
    }
    triangle {
      < -0.482739, -0.991256, -2.793895>,
      < -0.398891, -0.954881, -2.794279>,
      < -0.398882, -0.968924, -2.808343>
    }
    triangle {
      < 1.238032, -0.974638, -2.804009>,
      < 1.238022, -0.958255, -2.787601>,
      < 1.139697, -0.968451, -2.772018>
    }
    triangle {
      < 1.238032, -0.974638, -2.804009>,
      < 1.139697, -0.968451, -2.772018>,
      < 1.139711, -0.990295, -2.793895>
    }
    triangle {
      < -0.471153, -1.020671, -2.819866>,
      < -0.471161, -1.006846, -2.783781>,
      < -0.482739, -0.991256, -2.793895>
    }
    triangle {
      < -0.471153, -1.020671, -2.819866>,
      < -0.482739, -0.991256, -2.793895>,
      < -0.482732, -1.002316, -2.822764>
    }
    triangle {
      < 1.139717, -1.001354, -2.822764>,
      < 1.139711, -0.990295, -2.793895>,
      < 0.917030, -1.006024, -2.783781>
    }
    triangle {
      < 1.139717, -1.001354, -2.822764>,
      < 0.917030, -1.006024, -2.783781>,
      < 0.917038, -1.019849, -2.819866>
    }
    triangle {
      < 1.139697, -0.968451, -2.772018>,
      < 1.139681, -0.939599, -2.760916>,
      < 0.916992, -0.942654, -2.742557>
    }
    triangle {
      < 1.139697, -0.968451, -2.772018>,
      < 0.916992, -0.942654, -2.742557>,
      < 0.917014, -0.978719, -2.756435>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < -0.471199, -0.943477, -2.742558>,
      < -0.482769, -0.940560, -2.760916>
    }
    triangle {
      < -0.471177, -0.979542, -2.756436>,
      < -0.482769, -0.940560, -2.760916>,
      < -0.482752, -0.969412, -2.772019>
    }
    triangle {
      < -0.471161, -1.006846, -2.783781>,
      < -0.471177, -0.979542, -2.756436>,
      < -0.482752, -0.969412, -2.772019>
    }
    triangle {
      < -0.471161, -1.006846, -2.783781>,
      < -0.482752, -0.969412, -2.772019>,
      < -0.482739, -0.991256, -2.793895>
    }
    triangle {
      < 1.139711, -0.990295, -2.793895>,
      < 1.139697, -0.968451, -2.772018>,
      < 0.917014, -0.978719, -2.756435>
    }
    triangle {
      < 1.139711, -0.990295, -2.793895>,
      < 0.917014, -0.978719, -2.756435>,
      < 0.917030, -1.006024, -2.783781>
    }
    triangle {
      < 0.917038, -1.019849, -2.819866>,
      < 0.917030, -1.006024, -2.783781>,
      < -0.471161, -1.006846, -2.783781>
    }
    triangle {
      < 0.917038, -1.019849, -2.819866>,
      < -0.471161, -1.006846, -2.783781>,
      < -0.471153, -1.020671, -2.819866>
    }
    triangle {
      < 0.917014, -0.978719, -2.756435>,
      < 0.916992, -0.942654, -2.742557>,
      < -0.471199, -0.943477, -2.742558>
    }
    triangle {
      < 0.917014, -0.978719, -2.756435>,
      < -0.471199, -0.943477, -2.742558>,
      < -0.471177, -0.979542, -2.756436>
    }
    triangle {
      < -0.307225, -0.492508, -3.379137>,
      < -0.271030, -0.662638, -3.227311>,
      < -0.271021, -0.675843, -3.235890>
    }
    triangle {
      < -0.307225, -0.492508, -3.379137>,
      < -0.271021, -0.675843, -3.235890>,
      < -0.307214, -0.510223, -3.396899>
    }
    triangle {
      < -0.307225, -0.492508, -3.379137>,
      < -0.271035, -0.653950, -3.213912>,
      < -0.271030, -0.662638, -3.227311>
    }
    triangle {
      < -0.462557, -0.510315, -3.396899>,
      < -0.463122, -0.662751, -3.227311>,
      < -0.463127, -0.654064, -3.213912>
    }
    triangle {
      < -0.462557, -0.510315, -3.396899>,
      < -0.463127, -0.654064, -3.213912>,
      < -0.462568, -0.492601, -3.379137>
    }
    triangle {
      < -0.462557, -0.510315, -3.396899>,
      < -0.463114, -0.675957, -3.235890>,
      < -0.463122, -0.662751, -3.227311>
    }
    triangle {
      < -0.462568, -0.492601, -3.379137>,
      < -0.463127, -0.654064, -3.213912>,
      < -0.271035, -0.653950, -3.213912>
    }
    triangle {
      < -0.462568, -0.492601, -3.379137>,
      < -0.271035, -0.653950, -3.213912>,
      < -0.307225, -0.492508, -3.379137>
    }
    triangle {
      < -0.307214, -0.510223, -3.396899>,
      < -0.271021, -0.675843, -3.235890>,
      < -0.463114, -0.675957, -3.235890>
    }
    triangle {
      < -0.307214, -0.510223, -3.396899>,
      < -0.463114, -0.675957, -3.235890>,
      < -0.462557, -0.510315, -3.396899>
    }
    triangle {
      < 0.472114, -0.619910, -3.247423>,
      < 0.502611, -0.662179, -3.227311>,
      < 0.504892, -0.675384, -3.235890>
    }
    triangle {
      < 0.472114, -0.619910, -3.247423>,
      < 0.504892, -0.675384, -3.235890>,
      < 0.472126, -0.641815, -3.269388>
    }
    triangle {
      < 0.472114, -0.619910, -3.247423>,
      < 0.504891, -0.653490, -3.213912>,
      < 0.502611, -0.662179, -3.227311>
    }
    triangle {
      < -0.233644, -0.510180, -3.396899>,
      < -0.180054, -0.662584, -3.227311>,
      < -0.180059, -0.653896, -3.213912>
    }
    triangle {
      < -0.233644, -0.510180, -3.396899>,
      < -0.180059, -0.653896, -3.213912>,
      < -0.233654, -0.492465, -3.379137>
    }
    triangle {
      < -0.233644, -0.510180, -3.396899>,
      < -0.180046, -0.675789, -3.235890>,
      < -0.180054, -0.662584, -3.227311>
    }
    triangle {
      < -0.233654, -0.492465, -3.379137>,
      < -0.180059, -0.653896, -3.213912>,
      < 0.504891, -0.653490, -3.213912>
    }
    triangle {
      < -0.233654, -0.492465, -3.379137>,
      < 0.504891, -0.653490, -3.213912>,
      < 0.472114, -0.619910, -3.247423>
    }
    triangle {
      < 0.472126, -0.641815, -3.269388>,
      < 0.504892, -0.675384, -3.235890>,
      < -0.180046, -0.675789, -3.235890>
    }
    triangle {
      < 0.472126, -0.641815, -3.269388>,
      < -0.180046, -0.675789, -3.235890>,
      < -0.233644, -0.510180, -3.396899>
    }
    triangle {
      < -0.307214, -0.510781, -2.925774>,
      < -0.271025, -0.669950, -3.089300>,
      < -0.271035, -0.653968, -3.108994>
    }
    triangle {
      < -0.307214, -0.510781, -2.925774>,
      < -0.271035, -0.653968, -3.108994>,
      < -0.307225, -0.493023, -2.943494>
    }
    triangle {
      < -0.307214, -0.510781, -2.925774>,
      < -0.271022, -0.675384, -3.086538>,
      < -0.271025, -0.669950, -3.089300>
    }
    triangle {
      < -0.462568, -0.493116, -2.943494>,
      < -0.463117, -0.670064, -3.089300>,
      < -0.463115, -0.675497, -3.086538>
    }
    triangle {
      < -0.462568, -0.493116, -2.943494>,
      < -0.463115, -0.675497, -3.086538>,
      < -0.462557, -0.510874, -2.925774>
    }
    triangle {
      < -0.462568, -0.493116, -2.943494>,
      < -0.463127, -0.654081, -3.108994>,
      < -0.463117, -0.670064, -3.089300>
    }
    triangle {
      < -0.462557, -0.510874, -2.925774>,
      < -0.463115, -0.675497, -3.086538>,
      < -0.271022, -0.675384, -3.086538>
    }
    triangle {
      < -0.462557, -0.510874, -2.925774>,
      < -0.271022, -0.675384, -3.086538>,
      < -0.307214, -0.510781, -2.925774>
    }
    triangle {
      < -0.307225, -0.493023, -2.943494>,
      < -0.271035, -0.653968, -3.108994>,
      < -0.463127, -0.654081, -3.108994>
    }
    triangle {
      < -0.307225, -0.493023, -2.943494>,
      < -0.463127, -0.654081, -3.108994>,
      < -0.462568, -0.493116, -2.943494>
    }
    triangle {
      < 0.472127, -0.642071, -3.053597>,
      < 0.502967, -0.669492, -3.089300>,
      < 0.504787, -0.653508, -3.108994>
    }
    triangle {
      < 0.472127, -0.642071, -3.053597>,
      < 0.504787, -0.653508, -3.108994>,
      < 0.472114, -0.620113, -3.075511>
    }
    triangle {
      < 0.472127, -0.642071, -3.053597>,
      < 0.504269, -0.674924, -3.086538>,
      < 0.502967, -0.669492, -3.089300>
    }
    triangle {
      < -0.233654, -0.492980, -2.943494>,
      < -0.180049, -0.669897, -3.089300>,
      < -0.180047, -0.675330, -3.086538>
    }
    triangle {
      < -0.233654, -0.492980, -2.943494>,
      < -0.180047, -0.675330, -3.086538>,
      < -0.233644, -0.510738, -2.925774>
    }
    triangle {
      < -0.233654, -0.492980, -2.943494>,
      < -0.180059, -0.653914, -3.108994>,
      < -0.180049, -0.669897, -3.089300>
    }
    triangle {
      < -0.233644, -0.510738, -2.925774>,
      < -0.180047, -0.675330, -3.086538>,
      < 0.504269, -0.674924, -3.086538>
    }
    triangle {
      < -0.233644, -0.510738, -2.925774>,
      < 0.504269, -0.674924, -3.086538>,
      < 0.472127, -0.642071, -3.053597>
    }
    triangle {
      < 0.472114, -0.620113, -3.075511>,
      < 0.504787, -0.653508, -3.108994>,
      < -0.180059, -0.653914, -3.108994>
    }
    triangle {
      < 0.472114, -0.620113, -3.075511>,
      < -0.180059, -0.653914, -3.108994>,
      < -0.233654, -0.492980, -2.943494>
    }
    triangle {
      < -0.306946, -0.964150, -2.943913>,
      < -0.270946, -0.803670, -3.108328>,
      < -0.270959, -0.781750, -3.086377>
    }
    triangle {
      < -0.306946, -0.964150, -2.943913>,
      < -0.270959, -0.781750, -3.086377>,
      < -0.306956, -0.946424, -2.926160>
    }
    triangle {
      < -0.462299, -0.946517, -2.926160>,
      < -0.463052, -0.781864, -3.086377>,
      < -0.463038, -0.803783, -3.108328>
    }
    triangle {
      < -0.462299, -0.946517, -2.926160>,
      < -0.463038, -0.803783, -3.108328>,
      < -0.462289, -0.964243, -2.943913>
    }
    triangle {
      < -0.462289, -0.964243, -2.943913>,
      < -0.463038, -0.803783, -3.108328>,
      < -0.270946, -0.803670, -3.108328>
    }
    triangle {
      < -0.462289, -0.964243, -2.943913>,
      < -0.270946, -0.803670, -3.108328>,
      < -0.306946, -0.964150, -2.943913>
    }
    triangle {
      < -0.306956, -0.946424, -2.926160>,
      < -0.270959, -0.781750, -3.086377>,
      < -0.463052, -0.781864, -3.086377>
    }
    triangle {
      < -0.306956, -0.946424, -2.926160>,
      < -0.463052, -0.781864, -3.086377>,
      < -0.462299, -0.946517, -2.926160>
    }
    triangle {
      < 0.472242, -0.835903, -3.075702>,
      < 0.504096, -0.803210, -3.108328>,
      < 0.504083, -0.781290, -3.086377>
    }
    triangle {
      < 0.472242, -0.835903, -3.075702>,
      < 0.504083, -0.781290, -3.086377>,
      < 0.472229, -0.813984, -3.053751>
    }
    triangle {
      < -0.233385, -0.946381, -2.926160>,
      < -0.179984, -0.781696, -3.086377>,
      < -0.179970, -0.803616, -3.108328>
    }
    triangle {
      < -0.233385, -0.946381, -2.926160>,
      < -0.179970, -0.803616, -3.108328>,
      < -0.233375, -0.964107, -2.943913>
    }
    triangle {
      < -0.233375, -0.964107, -2.943913>,
      < -0.179970, -0.803616, -3.108328>,
      < 0.504096, -0.803210, -3.108328>
    }
    triangle {
      < -0.233375, -0.964107, -2.943913>,
      < 0.504096, -0.803210, -3.108328>,
      < 0.472242, -0.835903, -3.075702>
    }
    triangle {
      < 0.472229, -0.813984, -3.053751>,
      < 0.504083, -0.781290, -3.086377>,
      < -0.179984, -0.781696, -3.086377>
    }
    triangle {
      < 0.472229, -0.813984, -3.053751>,
      < -0.179984, -0.781696, -3.086377>,
      < -0.233385, -0.946381, -2.926160>
    }
    triangle {
      < -0.306956, -0.946145, -3.397288>,
      < -0.270948, -0.800581, -3.220124>,
      < -0.270946, -0.803349, -3.214695>
    }
    triangle {
      < -0.306956, -0.946145, -3.397288>,
      < -0.270946, -0.803349, -3.214695>,
      < -0.306946, -0.963892, -3.379556>
    }
    triangle {
      < -0.306956, -0.946145, -3.397288>,
      < -0.270959, -0.780863, -3.236077>,
      < -0.270948, -0.800581, -3.220124>
    }
    triangle {
      < -0.462289, -0.963984, -3.379556>,
      < -0.463040, -0.800694, -3.220124>,
      < -0.463052, -0.780976, -3.236077>
    }
    triangle {
      < -0.462289, -0.963984, -3.379556>,
      < -0.463052, -0.780976, -3.236077>,
      < -0.462299, -0.946238, -3.397288>
    }
    triangle {
      < -0.462289, -0.963984, -3.379556>,
      < -0.463038, -0.803463, -3.214695>,
      < -0.463040, -0.800694, -3.220124>
    }
    triangle {
      < -0.462299, -0.946238, -3.397288>,
      < -0.463052, -0.780976, -3.236077>,
      < -0.270959, -0.780863, -3.236077>
    }
    triangle {
      < -0.462299, -0.946238, -3.397288>,
      < -0.270959, -0.780863, -3.236077>,
      < -0.306956, -0.946145, -3.397288>
    }
    triangle {
      < -0.306946, -0.963892, -3.379556>,
      < -0.270946, -0.803349, -3.214695>,
      < -0.463038, -0.803463, -3.214695>
    }
    triangle {
      < -0.306946, -0.963892, -3.379556>,
      < -0.463038, -0.803463, -3.214695>,
      < -0.462289, -0.963984, -3.379556>
    }
    triangle {
      < 0.472229, -0.813857, -3.269541>,
      < 0.503044, -0.800122, -3.220123>,
      < 0.504345, -0.802890, -3.214694>
    }
    triangle {
      < 0.472229, -0.813857, -3.269541>,
      < 0.504345, -0.802890, -3.214694>,
      < 0.472242, -0.835801, -3.247615>
    }
    triangle {
      < 0.472229, -0.813857, -3.269541>,
      < 0.504862, -0.780403, -3.236077>,
      < 0.503044, -0.800122, -3.220123>
    }
    triangle {
      < -0.233375, -0.963849, -3.379556>,
      < -0.179972, -0.800527, -3.220124>,
      < -0.179984, -0.780809, -3.236077>
    }
    triangle {
      < -0.233375, -0.963849, -3.379556>,
      < -0.179984, -0.780809, -3.236077>,
      < -0.233385, -0.946102, -3.397288>
    }
    triangle {
      < -0.233375, -0.963849, -3.379556>,
      < -0.179970, -0.803296, -3.214695>,
      < -0.179972, -0.800527, -3.220124>
    }
    triangle {
      < -0.233385, -0.946102, -3.397288>,
      < -0.179984, -0.780809, -3.236077>,
      < 0.504862, -0.780403, -3.236077>
    }
    triangle {
      < -0.233385, -0.946102, -3.397288>,
      < 0.504862, -0.780403, -3.236077>,
      < 0.472229, -0.813857, -3.269541>
    }
    triangle {
      < 0.472242, -0.835801, -3.247615>,
      < 0.504345, -0.802890, -3.214694>,
      < -0.179970, -0.803296, -3.214695>
    }
    triangle {
      < 0.472242, -0.835801, -3.247615>,
      < -0.179970, -0.803296, -3.214695>,
      < -0.233375, -0.963849, -3.379556>
    }
    triangle {
      < 0.472114, -0.619910, -3.247423>,
      < 0.472126, -0.641815, -3.269388>,
      < -0.233644, -0.510180, -3.396899>
    }
    triangle {
      < 0.472114, -0.619910, -3.247423>,
      < -0.233644, -0.510180, -3.396899>,
      < -0.233654, -0.492465, -3.379137>
    }
    triangle {
      < -0.307225, -0.492508, -3.379137>,
      < -0.307214, -0.510223, -3.396899>,
      < -0.462557, -0.510315, -3.396899>
    }
    triangle {
      < -0.307225, -0.492508, -3.379137>,
      < -0.462557, -0.510315, -3.396899>,
      < -0.462568, -0.492601, -3.379137>
    }
    triangle {
      < 0.472229, -0.813857, -3.269541>,
      < 0.472242, -0.835801, -3.247615>,
      < -0.233375, -0.963849, -3.379556>
    }
    triangle {
      < 0.472229, -0.813857, -3.269541>,
      < -0.233375, -0.963849, -3.379556>,
      < -0.233385, -0.946102, -3.397288>
    }
    triangle {
      < -0.306956, -0.946145, -3.397288>,
      < -0.306946, -0.963892, -3.379556>,
      < -0.462289, -0.963984, -3.379556>
    }
    triangle {
      < -0.306956, -0.946145, -3.397288>,
      < -0.462289, -0.963984, -3.379556>,
      < -0.462299, -0.946238, -3.397288>
    }
    triangle {
      < 0.472127, -0.642071, -3.053597>,
      < 0.472114, -0.620113, -3.075511>,
      < -0.233654, -0.492980, -2.943494>
    }
    triangle {
      < 0.472127, -0.642071, -3.053597>,
      < -0.233654, -0.492980, -2.943494>,
      < -0.233644, -0.510738, -2.925774>
    }
    triangle {
      < -0.307214, -0.510781, -2.925774>,
      < -0.307225, -0.493023, -2.943494>,
      < -0.462568, -0.493116, -2.943494>
    }
    triangle {
      < -0.307214, -0.510781, -2.925774>,
      < -0.462568, -0.493116, -2.943494>,
      < -0.462557, -0.510874, -2.925774>
    }
    triangle {
      < 0.472242, -0.835903, -3.075702>,
      < 0.472229, -0.813984, -3.053751>,
      < -0.233385, -0.946381, -2.926160>
    }
    triangle {
      < 0.472242, -0.835903, -3.075702>,
      < -0.233385, -0.946381, -2.926160>,
      < -0.233375, -0.964107, -2.943913>
    }
    triangle {
      < -0.306946, -0.964150, -2.943913>,
      < -0.306956, -0.946424, -2.926160>,
      < -0.462299, -0.946517, -2.926160>
    }
    triangle {
      < -0.306946, -0.964150, -2.943913>,
      < -0.462299, -0.946517, -2.926160>,
      < -0.462289, -0.964243, -2.943913>
    }
    triangle {
      < 0.900527, -0.640860, -3.194795>,
      < 0.504891, -0.653490, -3.213912>,
      < -0.180059, -0.653896, -3.213912>
    }
    triangle {
      < 0.900527, -0.640860, -3.194795>,
      < 0.900540, -0.661943, -3.227310>,
      < 0.502611, -0.662179, -3.227311>
    }
    triangle {
      < 0.900527, -0.640860, -3.194795>,
      < 0.502611, -0.662179, -3.227311>,
      < 0.504891, -0.653490, -3.213912>
    }
    triangle {
      < -0.271035, -0.653950, -3.213912>,
      < 0.900527, -0.640860, -3.194795>,
      < -0.180059, -0.653896, -3.213912>
    }
    triangle {
      < -0.180054, -0.662584, -3.227311>,
      < -0.271035, -0.653950, -3.213912>,
      < -0.180059, -0.653896, -3.213912>
    }
    triangle {
      < -0.271035, -0.653950, -3.213912>,
      < -0.463127, -0.654064, -3.213912>,
      < -0.487665, -0.641683, -3.194795>
    }
    triangle {
      < -0.271035, -0.653950, -3.213912>,
      < -0.487665, -0.641683, -3.194795>,
      < 0.900527, -0.640860, -3.194795>
    }
    triangle {
      < -0.463127, -0.654064, -3.213912>,
      < -0.463122, -0.662751, -3.227311>,
      < -0.487652, -0.662765, -3.227311>
    }
    triangle {
      < -0.463127, -0.654064, -3.213912>,
      < -0.487652, -0.662765, -3.227311>,
      < -0.487665, -0.641683, -3.194795>
    }
    triangle {
      < -0.180054, -0.662584, -3.227311>,
      < -0.271030, -0.662638, -3.227311>,
      < -0.271035, -0.653950, -3.213912>
    }
    triangle {
      < -0.487662, -0.645728, -3.119306>,
      < -0.463127, -0.654081, -3.108994>,
      < -0.271035, -0.653968, -3.108994>
    }
    triangle {
      < -0.487662, -0.645728, -3.119306>,
      < -0.487648, -0.670078, -3.089300>,
      < -0.463117, -0.670064, -3.089300>
    }
    triangle {
      < -0.487662, -0.645728, -3.119306>,
      < -0.463117, -0.670064, -3.089300>,
      < -0.463127, -0.654081, -3.108994>
    }
    triangle {
      < -0.180059, -0.653914, -3.108994>,
      < -0.487662, -0.645728, -3.119306>,
      < -0.271035, -0.653968, -3.108994>
    }
    triangle {
      < -0.271025, -0.669950, -3.089300>,
      < -0.180059, -0.653914, -3.108994>,
      < -0.271035, -0.653968, -3.108994>
    }
    triangle {
      < -0.180059, -0.653914, -3.108994>,
      < 0.504787, -0.653508, -3.108994>,
      < 0.900529, -0.644905, -3.119305>
    }
    triangle {
      < -0.180059, -0.653914, -3.108994>,
      < 0.900529, -0.644905, -3.119305>,
      < -0.487662, -0.645728, -3.119306>
    }
    triangle {
      < 0.504787, -0.653508, -3.108994>,
      < 0.502967, -0.669492, -3.089300>,
      < 0.900544, -0.669256, -3.089299>
    }
    triangle {
      < 0.504787, -0.653508, -3.108994>,
      < 0.900544, -0.669256, -3.089299>,
      < 0.900529, -0.644905, -3.119305>
    }
    triangle {
      < -0.271025, -0.669950, -3.089300>,
      < -0.180049, -0.669897, -3.089300>,
      < -0.180059, -0.653914, -3.108994>
    }
    triangle {
      < 0.900564, -0.703705, -3.071789>,
      < 0.504269, -0.674924, -3.086538>,
      < -0.180047, -0.675330, -3.086538>
    }
    triangle {
      < 0.900564, -0.703705, -3.071789>,
      < 0.900544, -0.669256, -3.089299>,
      < 0.502967, -0.669492, -3.089300>
    }
    triangle {
      < 0.900564, -0.703705, -3.071789>,
      < 0.502967, -0.669492, -3.089300>,
      < 0.504269, -0.674924, -3.086538>
    }
    triangle {
      < -0.271022, -0.675384, -3.086538>,
      < 0.900564, -0.703705, -3.071789>,
      < -0.180047, -0.675330, -3.086538>
    }
    triangle {
      < -0.180049, -0.669897, -3.089300>,
      < -0.271022, -0.675384, -3.086538>,
      < -0.180047, -0.675330, -3.086538>
    }
    triangle {
      < -0.271022, -0.675384, -3.086538>,
      < -0.463115, -0.675497, -3.086538>,
      < -0.487627, -0.704527, -3.071790>
    }
    triangle {
      < -0.271022, -0.675384, -3.086538>,
      < -0.487627, -0.704527, -3.071790>,
      < 0.900564, -0.703705, -3.071789>
    }
    triangle {
      < -0.463115, -0.675497, -3.086538>,
      < -0.463117, -0.670064, -3.089300>,
      < -0.487648, -0.670078, -3.089300>
    }
    triangle {
      < -0.463115, -0.675497, -3.086538>,
      < -0.487648, -0.670078, -3.089300>,
      < -0.487627, -0.704527, -3.071790>
    }
    triangle {
      < -0.180049, -0.669897, -3.089300>,
      < -0.271025, -0.669950, -3.089300>,
      < -0.271022, -0.675384, -3.086538>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < 0.504083, -0.781290, -3.086377>,
      < 0.900608, -0.778363, -3.083680>
    }
    triangle {
      < 0.504083, -0.781290, -3.086377>,
      < 0.504096, -0.803210, -3.108328>,
      < 0.900625, -0.805667, -3.111025>
    }
    triangle {
      < 0.504083, -0.781290, -3.086377>,
      < 0.900625, -0.805667, -3.111025>,
      < 0.900608, -0.778363, -3.083680>
    }
    triangle {
      < 0.504096, -0.803210, -3.108328>,
      < -0.179970, -0.803616, -3.108328>,
      < 0.900625, -0.805667, -3.111025>
    }
    triangle {
      < -0.179970, -0.803616, -3.108328>,
      < -0.270946, -0.803670, -3.108328>,
      < 0.900625, -0.805667, -3.111025>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < -0.179984, -0.781696, -3.086377>,
      < 0.504083, -0.781290, -3.086377>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < -0.270959, -0.781750, -3.086377>,
      < -0.179984, -0.781696, -3.086377>
    }
    triangle {
      < -0.270959, -0.781750, -3.086377>,
      < -0.179970, -0.803616, -3.108328>,
      < -0.179984, -0.781696, -3.086377>
    }
    triangle {
      < -0.270959, -0.781750, -3.086377>,
      < -0.270946, -0.803670, -3.108328>,
      < -0.179970, -0.803616, -3.108328>
    }
    triangle {
      < -0.270946, -0.803670, -3.108328>,
      < -0.463038, -0.803783, -3.108328>,
      < -0.487567, -0.806489, -3.111026>
    }
    triangle {
      < -0.270946, -0.803670, -3.108328>,
      < -0.487567, -0.806489, -3.111026>,
      < 0.900625, -0.805667, -3.111025>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < -0.463052, -0.781864, -3.086377>,
      < -0.270959, -0.781750, -3.086377>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < -0.463038, -0.803783, -3.108328>,
      < -0.463052, -0.781864, -3.086377>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < -0.487567, -0.806489, -3.111026>,
      < -0.463038, -0.803783, -3.108328>
    }
    triangle {
      < -0.487561, -0.818270, -3.185700>,
      < -0.463038, -0.803463, -3.214695>,
      < -0.270946, -0.803349, -3.214695>
    }
    triangle {
      < -0.487561, -0.818270, -3.185700>,
      < -0.487570, -0.800709, -3.220124>,
      < -0.463040, -0.800694, -3.220124>
    }
    triangle {
      < -0.487561, -0.818270, -3.185700>,
      < -0.463040, -0.800694, -3.220124>,
      < -0.463038, -0.803463, -3.214695>
    }
    triangle {
      < -0.179970, -0.803296, -3.214695>,
      < -0.487561, -0.818270, -3.185700>,
      < -0.270946, -0.803349, -3.214695>
    }
    triangle {
      < -0.270948, -0.800581, -3.220124>,
      < -0.179970, -0.803296, -3.214695>,
      < -0.270946, -0.803349, -3.214695>
    }
    triangle {
      < -0.179970, -0.803296, -3.214695>,
      < 0.504345, -0.802890, -3.214694>,
      < 0.900632, -0.817447, -3.185700>
    }
    triangle {
      < -0.179970, -0.803296, -3.214695>,
      < 0.900632, -0.817447, -3.185700>,
      < -0.487561, -0.818270, -3.185700>
    }
    triangle {
      < 0.504345, -0.802890, -3.214694>,
      < 0.503044, -0.800122, -3.220123>,
      < 0.900621, -0.799886, -3.220123>
    }
    triangle {
      < 0.504345, -0.802890, -3.214694>,
      < 0.900621, -0.799886, -3.220123>,
      < 0.900632, -0.817447, -3.185700>
    }
    triangle {
      < -0.270948, -0.800581, -3.220124>,
      < -0.179972, -0.800527, -3.220124>,
      < -0.179970, -0.803296, -3.214695>
    }
    triangle {
      < 0.900604, -0.769844, -3.244430>,
      < 0.504862, -0.780403, -3.236077>,
      < -0.179984, -0.780809, -3.236077>
    }
    triangle {
      < 0.900604, -0.769844, -3.244430>,
      < 0.900621, -0.799886, -3.220123>,
      < 0.503044, -0.800122, -3.220123>
    }
    triangle {
      < 0.900604, -0.769844, -3.244430>,
      < 0.503044, -0.800122, -3.220123>,
      < 0.504862, -0.780403, -3.236077>
    }
    triangle {
      < -0.270959, -0.780863, -3.236077>,
      < 0.900604, -0.769844, -3.244430>,
      < -0.179984, -0.780809, -3.236077>
    }
    triangle {
      < -0.179972, -0.800527, -3.220124>,
      < -0.270959, -0.780863, -3.236077>,
      < -0.179984, -0.780809, -3.236077>
    }
    triangle {
      < -0.270959, -0.780863, -3.236077>,
      < -0.463052, -0.780976, -3.236077>,
      < -0.487588, -0.770667, -3.244430>
    }
    triangle {
      < -0.270959, -0.780863, -3.236077>,
      < -0.487588, -0.770667, -3.244430>,
      < 0.900604, -0.769844, -3.244430>
    }
    triangle {
      < -0.463052, -0.780976, -3.236077>,
      < -0.463040, -0.800694, -3.220124>,
      < -0.487570, -0.800709, -3.220124>
    }
    triangle {
      < -0.463052, -0.780976, -3.236077>,
      < -0.487570, -0.800709, -3.220124>,
      < -0.487588, -0.770667, -3.244430>
    }
    triangle {
      < -0.179972, -0.800527, -3.220124>,
      < -0.270948, -0.800581, -3.220124>,
      < -0.270959, -0.780863, -3.236077>
    }
    triangle {
      < -0.487633, -0.695170, -3.248363>,
      < -0.463114, -0.675957, -3.235890>,
      < -0.271021, -0.675843, -3.235890>
    }
    triangle {
      < -0.487633, -0.695170, -3.248363>,
      < -0.487652, -0.662765, -3.227311>,
      < -0.463122, -0.662751, -3.227311>
    }
    triangle {
      < -0.487633, -0.695170, -3.248363>,
      < -0.463122, -0.662751, -3.227311>,
      < -0.463114, -0.675957, -3.235890>
    }
    triangle {
      < -0.180046, -0.675789, -3.235890>,
      < -0.487633, -0.695170, -3.248363>,
      < -0.271021, -0.675843, -3.235890>
    }
    triangle {
      < -0.271030, -0.662638, -3.227311>,
      < -0.180046, -0.675789, -3.235890>,
      < -0.271021, -0.675843, -3.235890>
    }
    triangle {
      < -0.180046, -0.675789, -3.235890>,
      < 0.504892, -0.675384, -3.235890>,
      < 0.900559, -0.694347, -3.248363>
    }
    triangle {
      < -0.180046, -0.675789, -3.235890>,
      < 0.900559, -0.694347, -3.248363>,
      < -0.487633, -0.695170, -3.248363>
    }
    triangle {
      < 0.504892, -0.675384, -3.235890>,
      < 0.502611, -0.662179, -3.227311>,
      < 0.900540, -0.661943, -3.227310>
    }
    triangle {
      < 0.504892, -0.675384, -3.235890>,
      < 0.900540, -0.661943, -3.227310>,
      < 0.900559, -0.694347, -3.248363>
    }
    triangle {
      < -0.271030, -0.662638, -3.227311>,
      < -0.180054, -0.662584, -3.227311>,
      < -0.180046, -0.675789, -3.235890>
    }
    triangle {
      < 1.123236, -0.674957, -3.214167>,
      < 1.123251, -0.700881, -3.231009>,
      < 0.900559, -0.694347, -3.248363>
    }
    triangle {
      < 1.123236, -0.674957, -3.214167>,
      < 0.900559, -0.694347, -3.248363>,
      < 0.900540, -0.661943, -3.227310>
    }
    triangle {
      < 1.123226, -0.658092, -3.188155>,
      < 1.123236, -0.674957, -3.214167>,
      < 0.900540, -0.661943, -3.227310>
    }
    triangle {
      < 1.123226, -0.658092, -3.188155>,
      < 0.900540, -0.661943, -3.227310>,
      < 0.900527, -0.640860, -3.194795>
    }
    triangle {
      < -0.487665, -0.641683, -3.194795>,
      < -0.487652, -0.662765, -3.227311>,
      < -0.499213, -0.675919, -3.214167>
    }
    triangle {
      < -0.487665, -0.641683, -3.194795>,
      < -0.499213, -0.675919, -3.214167>,
      < -0.499223, -0.659054, -3.188155>
    }
    triangle {
      < -0.487652, -0.662765, -3.227311>,
      < -0.487633, -0.695170, -3.248363>,
      < -0.499198, -0.701843, -3.231009>
    }
    triangle {
      < -0.487652, -0.662765, -3.227311>,
      < -0.499198, -0.701843, -3.231009>,
      < -0.499213, -0.675919, -3.214167>
    }
    triangle {
      < 0.900559, -0.694347, -3.248363>,
      < 0.900581, -0.732515, -3.254419>,
      < -0.487611, -0.733337, -3.254419>
    }
    triangle {
      < 0.900559, -0.694347, -3.248363>,
      < -0.487611, -0.733337, -3.254419>,
      < -0.487633, -0.695170, -3.248363>
    }
    triangle {
      < -0.487633, -0.695170, -3.248363>,
      < -0.487611, -0.733337, -3.254419>,
      < -0.499180, -0.732376, -3.235854>
    }
    triangle {
      < -0.487633, -0.695170, -3.248363>,
      < -0.499180, -0.732376, -3.235854>,
      < -0.499198, -0.701843, -3.231009>
    }
    triangle {
      < 1.123251, -0.700881, -3.231009>,
      < 1.123270, -0.731414, -3.235853>,
      < 0.900581, -0.732515, -3.254419>
    }
    triangle {
      < 1.123251, -0.700881, -3.231009>,
      < 0.900581, -0.732515, -3.254419>,
      < 0.900559, -0.694347, -3.248363>
    }
    triangle {
      < 0.900524, -0.634861, -3.156621>,
      < 0.900527, -0.640860, -3.194795>,
      < -0.487665, -0.641683, -3.194795>
    }
    triangle {
      < 0.900524, -0.634861, -3.156621>,
      < -0.487665, -0.641683, -3.194795>,
      < -0.487669, -0.635684, -3.156621>
    }
    triangle {
      < 1.123223, -0.653292, -3.157615>,
      < 1.123226, -0.658092, -3.188155>,
      < 0.900527, -0.640860, -3.194795>
    }
    triangle {
      < 1.123223, -0.653292, -3.157615>,
      < 0.900527, -0.640860, -3.194795>,
      < 0.900524, -0.634861, -3.156621>
    }
    triangle {
      < -0.487669, -0.635684, -3.156621>,
      < -0.487665, -0.641683, -3.194795>,
      < -0.499223, -0.659054, -3.188155>
    }
    triangle {
      < -0.487669, -0.635684, -3.156621>,
      < -0.499223, -0.659054, -3.188155>,
      < -0.499226, -0.654254, -3.157616>
    }
    triangle {
      < 1.221567, -0.675397, -3.181515>,
      < 1.221575, -0.688047, -3.201024>,
      < 1.123236, -0.674957, -3.214167>
    }
    triangle {
      < 1.221567, -0.675397, -3.181515>,
      < 1.123236, -0.674957, -3.214167>,
      < 1.123226, -0.658092, -3.188155>
    }
    triangle {
      < -0.499223, -0.659054, -3.188155>,
      < -0.499213, -0.675919, -3.214167>,
      < -0.415332, -0.694651, -3.195392>
    }
    triangle {
      < -0.499223, -0.659054, -3.188155>,
      < -0.415332, -0.694651, -3.195392>,
      < -0.415338, -0.683809, -3.178669>
    }
    triangle {
      < 1.221575, -0.688047, -3.201024>,
      < 1.221586, -0.707490, -3.213656>,
      < 1.123251, -0.700881, -3.231009>
    }
    triangle {
      < 1.221575, -0.688047, -3.201024>,
      < 1.123251, -0.700881, -3.231009>,
      < 1.123236, -0.674957, -3.214167>
    }
    triangle {
      < -0.499213, -0.675919, -3.214167>,
      < -0.499198, -0.701843, -3.231009>,
      < -0.415322, -0.711317, -3.206218>
    }
    triangle {
      < -0.499213, -0.675919, -3.214167>,
      < -0.415322, -0.711317, -3.206218>,
      < -0.415332, -0.694651, -3.195392>
    }
    triangle {
      < 1.221586, -0.707490, -3.213656>,
      < 1.221600, -0.730389, -3.217288>,
      < 1.123270, -0.731414, -3.235853>
    }
    triangle {
      < 1.221586, -0.707490, -3.213656>,
      < 1.123270, -0.731414, -3.235853>,
      < 1.123251, -0.700881, -3.231009>
    }
    triangle {
      < -0.499198, -0.701843, -3.231009>,
      < -0.499180, -0.732376, -3.235854>,
      < -0.415310, -0.730945, -3.209333>
    }
    triangle {
      < -0.499198, -0.701843, -3.231009>,
      < -0.415310, -0.730945, -3.209333>,
      < -0.415322, -0.711317, -3.206218>
    }
    triangle {
      < -0.499226, -0.654254, -3.157616>,
      < -0.499223, -0.659054, -3.188155>,
      < -0.415338, -0.683809, -3.178669>
    }
    triangle {
      < -0.499226, -0.654254, -3.157616>,
      < -0.415338, -0.683809, -3.178669>,
      < -0.415340, -0.680724, -3.159037>
    }
    triangle {
      < 1.221565, -0.671797, -3.158610>,
      < 1.221567, -0.675397, -3.181515>,
      < 1.123226, -0.658092, -3.188155>
    }
    triangle {
      < 1.221565, -0.671797, -3.158610>,
      < 1.123226, -0.658092, -3.188155>,
      < 1.123223, -0.653292, -3.157615>
    }
    triangle {
      < 1.123270, -0.731414, -3.235853>,
      < 1.123287, -0.761278, -3.227862>,
      < 0.900604, -0.769844, -3.244430>
    }
    triangle {
      < 1.123270, -0.731414, -3.235853>,
      < 0.900604, -0.769844, -3.244430>,
      < 0.900581, -0.732515, -3.254419>
    }
    triangle {
      < -0.487611, -0.733337, -3.254419>,
      < -0.487588, -0.770667, -3.244430>,
      < -0.499162, -0.762240, -3.227862>
    }
    triangle {
      < -0.487611, -0.733337, -3.254419>,
      < -0.499162, -0.762240, -3.227862>,
      < -0.499180, -0.732376, -3.235854>
    }
    triangle {
      < 0.900581, -0.732515, -3.254419>,
      < 0.900604, -0.769844, -3.244430>,
      < -0.487588, -0.770667, -3.244430>
    }
    triangle {
      < 0.900581, -0.732515, -3.254419>,
      < -0.487588, -0.770667, -3.244430>,
      < -0.487611, -0.733337, -3.254419>
    }
    triangle {
      < 1.123228, -0.661328, -3.127763>,
      < 1.123223, -0.653292, -3.157615>,
      < 0.900524, -0.634861, -3.156621>
    }
    triangle {
      < 1.123228, -0.661328, -3.127763>,
      < 0.900524, -0.634861, -3.156621>,
      < 0.900529, -0.644905, -3.119305>
    }
    triangle {
      < 0.900529, -0.644905, -3.119305>,
      < 0.900524, -0.634861, -3.156621>,
      < -0.487669, -0.635684, -3.156621>
    }
    triangle {
      < 0.900529, -0.644905, -3.119305>,
      < -0.487669, -0.635684, -3.156621>,
      < -0.487662, -0.645728, -3.119306>
    }
    triangle {
      < -0.487662, -0.645728, -3.119306>,
      < -0.487669, -0.635684, -3.156621>,
      < -0.499226, -0.654254, -3.157616>
    }
    triangle {
      < -0.487662, -0.645728, -3.119306>,
      < -0.499226, -0.654254, -3.157616>,
      < -0.499221, -0.662290, -3.127763>
    }
    triangle {
      < 1.276528, -0.695208, -3.173926>,
      < 1.276532, -0.703039, -3.186003>,
      < 1.221575, -0.688047, -3.201024>
    }
    triangle {
      < 1.276528, -0.695208, -3.173926>,
      < 1.221575, -0.688047, -3.201024>,
      < 1.221567, -0.675397, -3.181515>
    }
    triangle {
      < 1.276532, -0.703039, -3.186003>,
      < 1.276539, -0.715075, -3.193823>,
      < 1.221586, -0.707490, -3.213656>
    }
    triangle {
      < 1.276532, -0.703039, -3.186003>,
      < 1.221586, -0.707490, -3.213656>,
      < 1.221575, -0.688047, -3.201024>
    }
    triangle {
      < 1.276539, -0.715075, -3.193823>,
      < 1.276547, -0.729251, -3.196071>,
      < 1.221600, -0.730389, -3.217288>
    }
    triangle {
      < 1.276539, -0.715075, -3.193823>,
      < 1.221600, -0.730389, -3.217288>,
      < 1.221586, -0.707490, -3.213656>
    }
    triangle {
      < 1.276526, -0.692980, -3.159747>,
      < 1.276528, -0.695208, -3.173926>,
      < 1.221567, -0.675397, -3.181515>
    }
    triangle {
      < 1.276526, -0.692980, -3.159747>,
      < 1.221567, -0.675397, -3.181515>,
      < 1.221565, -0.671797, -3.158610>
    }
    triangle {
      < 1.221600, -0.730389, -3.217288>,
      < 1.221613, -0.752788, -3.211295>,
      < 1.123287, -0.761278, -3.227862>
    }
    triangle {
      < 1.221600, -0.730389, -3.217288>,
      < 1.123287, -0.761278, -3.227862>,
      < 1.123270, -0.731414, -3.235853>
    }
    triangle {
      < -0.499180, -0.732376, -3.235854>,
      < -0.499162, -0.762240, -3.227862>,
      < -0.415299, -0.750143, -3.204196>
    }
    triangle {
      < -0.499180, -0.732376, -3.235854>,
      < -0.415299, -0.750143, -3.204196>,
      < -0.415310, -0.730945, -3.209333>
    }
    triangle {
      < 1.221568, -0.677824, -3.136221>,
      < 1.221565, -0.671797, -3.158610>,
      < 1.123223, -0.653292, -3.157615>
    }
    triangle {
      < 1.221568, -0.677824, -3.136221>,
      < 1.123223, -0.653292, -3.157615>,
      < 1.123228, -0.661328, -3.127763>
    }
    triangle {
      < -0.499221, -0.662290, -3.127763>,
      < -0.499226, -0.654254, -3.157616>,
      < -0.415340, -0.680724, -3.159037>
    }
    triangle {
      < -0.499221, -0.662290, -3.127763>,
      < -0.415340, -0.680724, -3.159037>,
      < -0.415337, -0.685889, -3.139846>
    }
    triangle {
      < -0.415338, -0.683809, -3.178669>,
      < -0.415332, -0.694651, -3.195392>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < -0.415332, -0.694651, -3.195392>,
      < -0.415322, -0.711317, -3.206218>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < -0.415322, -0.711317, -3.206218>,
      < -0.415310, -0.730945, -3.209333>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < -0.415340, -0.680724, -3.159037>,
      < -0.415338, -0.683809, -3.178669>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.276547, -0.729251, -3.196071>,
      < 1.276556, -0.743117, -3.192362>,
      < 1.221613, -0.752788, -3.211295>
    }
    triangle {
      < 1.276547, -0.729251, -3.196071>,
      < 1.221613, -0.752788, -3.211295>,
      < 1.221600, -0.730389, -3.217288>
    }
    triangle {
      < 1.276528, -0.696711, -3.145887>,
      < 1.276526, -0.692980, -3.159747>,
      < 1.221565, -0.671797, -3.158610>
    }
    triangle {
      < 1.276528, -0.696711, -3.145887>,
      < 1.221565, -0.671797, -3.158610>,
      < 1.221568, -0.677824, -3.136221>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276539, -0.715075, -3.193823>,
      < 1.276532, -0.703039, -3.186003>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276532, -0.703039, -3.186003>,
      < 1.276528, -0.695208, -3.173926>
    }
    triangle {
      < -0.415310, -0.730945, -3.209333>,
      < -0.415299, -0.750143, -3.204196>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < -0.415337, -0.685889, -3.139846>,
      < -0.415340, -0.680724, -3.159037>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276547, -0.729251, -3.196071>,
      < 1.276539, -0.715075, -3.193823>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276528, -0.695208, -3.173926>,
      < 1.276526, -0.692980, -3.159747>
    }
    triangle {
      < -0.487588, -0.770667, -3.244430>,
      < -0.487570, -0.800709, -3.220124>,
      < -0.499148, -0.786274, -3.208418>
    }
    triangle {
      < -0.487588, -0.770667, -3.244430>,
      < -0.499148, -0.786274, -3.208418>,
      < -0.499162, -0.762240, -3.227862>
    }
    triangle {
      < 1.123287, -0.761278, -3.227862>,
      < 1.123302, -0.785312, -3.208417>,
      < 0.900621, -0.799886, -3.220123>
    }
    triangle {
      < 1.123287, -0.761278, -3.227862>,
      < 0.900621, -0.799886, -3.220123>,
      < 0.900604, -0.769844, -3.244430>
    }
    triangle {
      < -0.487648, -0.670078, -3.089300>,
      < -0.487662, -0.645728, -3.119306>,
      < -0.499221, -0.662290, -3.127763>
    }
    triangle {
      < -0.487648, -0.670078, -3.089300>,
      < -0.499221, -0.662290, -3.127763>,
      < -0.499209, -0.681770, -3.103759>
    }
    triangle {
      < 1.123240, -0.680809, -3.103758>,
      < 1.123228, -0.661328, -3.127763>,
      < 0.900529, -0.644905, -3.119305>
    }
    triangle {
      < 1.123240, -0.680809, -3.103758>,
      < 0.900529, -0.644905, -3.119305>,
      < 0.900544, -0.669256, -3.089299>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276556, -0.743117, -3.192362>,
      < 1.276547, -0.729251, -3.196071>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276526, -0.692980, -3.159747>,
      < 1.276528, -0.696711, -3.145887>
    }
    triangle {
      < 1.221613, -0.752788, -3.211295>,
      < 1.221624, -0.770813, -3.196711>,
      < 1.123302, -0.785312, -3.208417>
    }
    triangle {
      < 1.221613, -0.752788, -3.211295>,
      < 1.123302, -0.785312, -3.208417>,
      < 1.123287, -0.761278, -3.227862>
    }
    triangle {
      < -0.499162, -0.762240, -3.227862>,
      < -0.499148, -0.786274, -3.208418>,
      < -0.415290, -0.765594, -3.191696>
    }
    triangle {
      < -0.499162, -0.762240, -3.227862>,
      < -0.415290, -0.765594, -3.191696>,
      < -0.415299, -0.750143, -3.204196>
    }
    triangle {
      < 1.221577, -0.692435, -3.118217>,
      < 1.221568, -0.677824, -3.136221>,
      < 1.123228, -0.661328, -3.127763>
    }
    triangle {
      < 1.221577, -0.692435, -3.118217>,
      < 1.123228, -0.661328, -3.127763>,
      < 1.123240, -0.680809, -3.103758>
    }
    triangle {
      < -0.499209, -0.681770, -3.103759>,
      < -0.499221, -0.662290, -3.127763>,
      < -0.415337, -0.685889, -3.139846>
    }
    triangle {
      < -0.499209, -0.681770, -3.103759>,
      < -0.415337, -0.685889, -3.139846>,
      < -0.415330, -0.698412, -3.124414>
    }
    triangle {
      < 1.276556, -0.743117, -3.192362>,
      < 1.276563, -0.754275, -3.183333>,
      < 1.221624, -0.770813, -3.196711>
    }
    triangle {
      < 1.276556, -0.743117, -3.192362>,
      < 1.221624, -0.770813, -3.196711>,
      < 1.221613, -0.752788, -3.211295>
    }
    triangle {
      < 1.276534, -0.705756, -3.134742>,
      < 1.276528, -0.696711, -3.145887>,
      < 1.221568, -0.677824, -3.136221>
    }
    triangle {
      < 1.276534, -0.705756, -3.134742>,
      < 1.221568, -0.677824, -3.136221>,
      < 1.221577, -0.692435, -3.118217>
    }
    triangle {
      < -0.415299, -0.750143, -3.204196>,
      < -0.415290, -0.765594, -3.191696>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < -0.415330, -0.698412, -3.124414>,
      < -0.415337, -0.685889, -3.139846>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276563, -0.754275, -3.183333>,
      < 1.276556, -0.743117, -3.192362>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276528, -0.696711, -3.145887>,
      < 1.276534, -0.705756, -3.134742>
    }
    triangle {
      < -0.415319, -0.716129, -3.115410>,
      < -0.415330, -0.698412, -3.124414>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276566, -0.760799, -3.170548>,
      < 1.276563, -0.754275, -3.183333>
    }
    triangle {
      < -0.415308, -0.735977, -3.114387>,
      < -0.415319, -0.716129, -3.115410>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < -0.415288, -0.768567, -3.135588>,
      < -0.415297, -0.754525, -3.121524>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < -0.415297, -0.754525, -3.121524>,
      < -0.415308, -0.735977, -3.114387>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276557, -0.746281, -3.132655>,
      < 1.276564, -0.756423, -3.142811>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276534, -0.705756, -3.134742>,
      < 1.276541, -0.718552, -3.128238>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276541, -0.718552, -3.128238>,
      < 1.276549, -0.732885, -3.127500>
    }
    triangle {
      < -0.415290, -0.765594, -3.191696>,
      < -0.415284, -0.774625, -3.173992>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276566, -0.761558, -3.156215>,
      < 1.276566, -0.760799, -3.170548>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276549, -0.732885, -3.127500>,
      < 1.276557, -0.746281, -3.132655>
    }
    triangle {
      < -0.415284, -0.774625, -3.173992>,
      < -0.415284, -0.775677, -3.154146>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.322820, -0.727427, -3.161595>,
      < 1.276564, -0.756423, -3.142811>,
      < 1.276566, -0.761558, -3.156215>
    }
    triangle {
      < -0.415284, -0.775677, -3.154146>,
      < -0.415288, -0.768567, -3.135588>,
      < -0.397960, -0.728447, -3.161595>
    }
    triangle {
      < 1.276563, -0.754275, -3.183333>,
      < 1.276566, -0.760799, -3.170548>,
      < 1.221629, -0.781349, -3.176058>
    }
    triangle {
      < 1.276563, -0.754275, -3.183333>,
      < 1.221629, -0.781349, -3.176058>,
      < 1.221624, -0.770813, -3.196711>
    }
    triangle {
      < 1.276541, -0.718552, -3.128238>,
      < 1.276534, -0.705756, -3.134742>,
      < 1.221577, -0.692435, -3.118217>
    }
    triangle {
      < 1.276541, -0.718552, -3.128238>,
      < 1.221577, -0.692435, -3.118217>,
      < 1.221590, -0.713104, -3.107711>
    }
    triangle {
      < -0.499148, -0.786274, -3.208418>,
      < -0.499139, -0.800323, -3.180879>,
      < -0.415284, -0.774625, -3.173992>
    }
    triangle {
      < -0.499148, -0.786274, -3.208418>,
      < -0.415284, -0.774625, -3.173992>,
      < -0.415290, -0.765594, -3.191696>
    }
    triangle {
      < -0.499193, -0.709329, -3.089751>,
      < -0.499209, -0.681770, -3.103759>,
      < -0.415330, -0.698412, -3.124414>
    }
    triangle {
      < -0.499193, -0.709329, -3.089751>,
      < -0.415330, -0.698412, -3.124414>,
      < -0.415319, -0.716129, -3.115410>
    }
    triangle {
      < 1.221624, -0.770813, -3.196711>,
      < 1.221629, -0.781349, -3.176058>,
      < 1.123310, -0.799360, -3.180879>
    }
    triangle {
      < 1.221624, -0.770813, -3.196711>,
      < 1.123310, -0.799360, -3.180879>,
      < 1.123302, -0.785312, -3.208417>
    }
    triangle {
      < 1.221590, -0.713104, -3.107711>,
      < 1.221577, -0.692435, -3.118217>,
      < 1.123240, -0.680809, -3.103758>
    }
    triangle {
      < 1.221590, -0.713104, -3.107711>,
      < 1.123240, -0.680809, -3.103758>,
      < 1.123256, -0.708367, -3.089750>
    }
    triangle {
      < -0.487570, -0.800709, -3.220124>,
      < -0.487561, -0.818270, -3.185700>,
      < -0.499139, -0.800323, -3.180879>
    }
    triangle {
      < -0.487570, -0.800709, -3.220124>,
      < -0.499139, -0.800323, -3.180879>,
      < -0.499148, -0.786274, -3.208418>
    }
    triangle {
      < 1.123302, -0.785312, -3.208417>,
      < 1.123310, -0.799360, -3.180879>,
      < 0.900632, -0.817447, -3.185700>
    }
    triangle {
      < 1.123302, -0.785312, -3.208417>,
      < 0.900632, -0.817447, -3.185700>,
      < 0.900621, -0.799886, -3.220123>
    }
    triangle {
      < 1.123256, -0.708367, -3.089750>,
      < 1.123240, -0.680809, -3.103758>,
      < 0.900544, -0.669256, -3.089299>
    }
    triangle {
      < 1.123256, -0.708367, -3.089750>,
      < 0.900544, -0.669256, -3.089299>,
      < 0.900564, -0.703705, -3.071789>
    }
    triangle {
      < -0.487627, -0.704527, -3.071790>,
      < -0.487648, -0.670078, -3.089300>,
      < -0.499209, -0.681770, -3.103759>
    }
    triangle {
      < -0.487627, -0.704527, -3.071790>,
      < -0.499209, -0.681770, -3.103759>,
      < -0.499193, -0.709329, -3.089751>
    }
    triangle {
      < 1.276566, -0.760799, -3.170548>,
      < 1.276566, -0.761558, -3.156215>,
      < 1.221630, -0.782577, -3.152905>
    }
    triangle {
      < 1.276566, -0.760799, -3.170548>,
      < 1.221630, -0.782577, -3.152905>,
      < 1.221629, -0.781349, -3.176058>
    }
    triangle {
      < 1.276549, -0.732885, -3.127500>,
      < 1.276541, -0.718552, -3.128238>,
      < 1.221590, -0.713104, -3.107711>
    }
    triangle {
      < 1.276549, -0.732885, -3.127500>,
      < 1.221590, -0.713104, -3.107711>,
      < 1.221603, -0.736259, -3.106518>
    }
    triangle {
      < -0.499139, -0.800323, -3.180879>,
      < -0.499138, -0.801959, -3.150009>,
      < -0.415284, -0.775677, -3.154146>
    }
    triangle {
      < -0.499139, -0.800323, -3.180879>,
      < -0.415284, -0.775677, -3.154146>,
      < -0.415284, -0.774625, -3.173992>
    }
    triangle {
      < -0.499175, -0.740203, -3.088160>,
      < -0.499193, -0.709329, -3.089751>,
      < -0.415319, -0.716129, -3.115410>
    }
    triangle {
      < -0.499175, -0.740203, -3.088160>,
      < -0.415319, -0.716129, -3.115410>,
      < -0.415308, -0.735977, -3.114387>
    }
    triangle {
      < 1.221629, -0.781349, -3.176058>,
      < 1.221630, -0.782577, -3.152905>,
      < 1.123311, -0.800997, -3.150008>
    }
    triangle {
      < 1.221629, -0.781349, -3.176058>,
      < 1.123311, -0.800997, -3.150008>,
      < 1.123310, -0.799360, -3.180879>
    }
    triangle {
      < 1.276566, -0.761558, -3.156215>,
      < 1.276564, -0.756423, -3.142811>,
      < 1.221626, -0.774281, -3.131252>
    }
    triangle {
      < 1.276566, -0.761558, -3.156215>,
      < 1.221626, -0.774281, -3.131252>,
      < 1.221630, -0.782577, -3.152905>
    }
    triangle {
      < 1.221603, -0.736259, -3.106518>,
      < 1.221590, -0.713104, -3.107711>,
      < 1.123256, -0.708367, -3.089750>
    }
    triangle {
      < 1.221603, -0.736259, -3.106518>,
      < 1.123256, -0.708367, -3.089750>,
      < 1.123275, -0.739241, -3.088160>
    }
    triangle {
      < 1.276557, -0.746281, -3.132655>,
      < 1.276549, -0.732885, -3.127500>,
      < 1.221603, -0.736259, -3.106518>
    }
    triangle {
      < 1.276557, -0.746281, -3.132655>,
      < 1.221603, -0.736259, -3.106518>,
      < 1.221616, -0.757898, -3.114846>
    }
    triangle {
      < 1.276564, -0.756423, -3.142811>,
      < 1.276557, -0.746281, -3.132655>,
      < 1.221616, -0.757898, -3.114846>
    }
    triangle {
      < 1.276564, -0.756423, -3.142811>,
      < 1.221616, -0.757898, -3.114846>,
      < 1.221626, -0.774281, -3.131252>
    }
    triangle {
      < -0.487561, -0.818270, -3.185700>,
      < -0.487559, -0.820314, -3.147111>,
      < -0.499138, -0.801959, -3.150009>
    }
    triangle {
      < -0.487561, -0.818270, -3.185700>,
      < -0.499138, -0.801959, -3.150009>,
      < -0.499139, -0.800323, -3.180879>
    }
    triangle {
      < 1.123310, -0.799360, -3.180879>,
      < 1.123311, -0.800997, -3.150008>,
      < 0.900633, -0.819492, -3.147110>
    }
    triangle {
      < 1.123310, -0.799360, -3.180879>,
      < 0.900633, -0.819492, -3.147110>,
      < 0.900632, -0.817447, -3.185700>
    }
    triangle {
      < 1.123275, -0.739241, -3.088160>,
      < 1.123256, -0.708367, -3.089750>,
      < 0.900564, -0.703705, -3.071789>
    }
    triangle {
      < 1.123275, -0.739241, -3.088160>,
      < 0.900564, -0.703705, -3.071789>,
      < 0.900588, -0.742297, -3.069802>
    }
    triangle {
      < -0.487605, -0.743120, -3.069802>,
      < -0.487627, -0.704527, -3.071790>,
      < -0.499193, -0.709329, -3.089751>
    }
    triangle {
      < -0.487605, -0.743120, -3.069802>,
      < -0.499193, -0.709329, -3.089751>,
      < -0.499175, -0.740203, -3.088160>
    }
    triangle {
      < -0.499138, -0.801959, -3.150009>,
      < -0.499145, -0.790899, -3.121140>,
      < -0.415288, -0.768567, -3.135588>
    }
    triangle {
      < -0.499138, -0.801959, -3.150009>,
      < -0.415288, -0.768567, -3.135588>,
      < -0.415284, -0.775677, -3.154146>
    }
    triangle {
      < -0.499158, -0.769056, -3.099263>,
      < -0.499175, -0.740203, -3.088160>,
      < -0.415308, -0.735977, -3.114387>
    }
    triangle {
      < -0.499158, -0.769056, -3.099263>,
      < -0.415308, -0.735977, -3.114387>,
      < -0.415297, -0.754525, -3.121524>
    }
    triangle {
      < 1.221630, -0.782577, -3.152905>,
      < 1.221626, -0.774281, -3.131252>,
      < 1.123304, -0.789937, -3.121139>
    }
    triangle {
      < 1.221630, -0.782577, -3.152905>,
      < 1.123304, -0.789937, -3.121139>,
      < 1.123311, -0.800997, -3.150008>
    }
    triangle {
      < 1.221616, -0.757898, -3.114846>,
      < 1.221603, -0.736259, -3.106518>,
      < 1.123275, -0.739241, -3.088160>
    }
    triangle {
      < 1.221616, -0.757898, -3.114846>,
      < 1.123275, -0.739241, -3.088160>,
      < 1.123292, -0.768094, -3.099263>
    }
    triangle {
      < 0.900632, -0.817447, -3.185700>,
      < 0.900633, -0.819492, -3.147110>,
      < -0.487559, -0.820314, -3.147111>
    }
    triangle {
      < 0.900632, -0.817447, -3.185700>,
      < -0.487559, -0.820314, -3.147111>,
      < -0.487561, -0.818270, -3.185700>
    }
    triangle {
      < 0.900588, -0.742297, -3.069802>,
      < 0.900564, -0.703705, -3.071789>,
      < -0.487627, -0.704527, -3.071790>
    }
    triangle {
      < 0.900588, -0.742297, -3.069802>,
      < -0.487627, -0.704527, -3.071790>,
      < -0.487605, -0.743120, -3.069802>
    }
    triangle {
      < -0.499145, -0.790899, -3.121140>,
      < -0.499158, -0.769056, -3.099263>,
      < -0.415297, -0.754525, -3.121524>
    }
    triangle {
      < -0.499145, -0.790899, -3.121140>,
      < -0.415297, -0.754525, -3.121524>,
      < -0.415288, -0.768567, -3.135588>
    }
    triangle {
      < 1.221626, -0.774281, -3.131252>,
      < 1.221616, -0.757898, -3.114846>,
      < 1.123292, -0.768094, -3.099263>
    }
    triangle {
      < 1.221626, -0.774281, -3.131252>,
      < 1.123292, -0.768094, -3.099263>,
      < 1.123304, -0.789937, -3.121139>
    }
    triangle {
      < -0.487559, -0.820314, -3.147111>,
      < -0.487567, -0.806489, -3.111026>,
      < -0.499145, -0.790899, -3.121140>
    }
    triangle {
      < -0.487559, -0.820314, -3.147111>,
      < -0.499145, -0.790899, -3.121140>,
      < -0.499138, -0.801959, -3.150009>
    }
    triangle {
      < 1.123311, -0.800997, -3.150008>,
      < 1.123304, -0.789937, -3.121139>,
      < 0.900625, -0.805667, -3.111025>
    }
    triangle {
      < 1.123311, -0.800997, -3.150008>,
      < 0.900625, -0.805667, -3.111025>,
      < 0.900633, -0.819492, -3.147110>
    }
    triangle {
      < 1.123292, -0.768094, -3.099263>,
      < 1.123275, -0.739241, -3.088160>,
      < 0.900588, -0.742297, -3.069802>
    }
    triangle {
      < 1.123292, -0.768094, -3.099263>,
      < 0.900588, -0.742297, -3.069802>,
      < 0.900608, -0.778363, -3.083680>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < -0.487605, -0.743120, -3.069802>,
      < -0.499175, -0.740203, -3.088160>
    }
    triangle {
      < -0.487583, -0.779185, -3.083680>,
      < -0.499175, -0.740203, -3.088160>,
      < -0.499158, -0.769056, -3.099263>
    }
    triangle {
      < -0.487567, -0.806489, -3.111026>,
      < -0.487583, -0.779185, -3.083680>,
      < -0.499158, -0.769056, -3.099263>
    }
    triangle {
      < -0.487567, -0.806489, -3.111026>,
      < -0.499158, -0.769056, -3.099263>,
      < -0.499145, -0.790899, -3.121140>
    }
    triangle {
      < 1.123304, -0.789937, -3.121139>,
      < 1.123292, -0.768094, -3.099263>,
      < 0.900608, -0.778363, -3.083680>
    }
    triangle {
      < 1.123304, -0.789937, -3.121139>,
      < 0.900608, -0.778363, -3.083680>,
      < 0.900625, -0.805667, -3.111025>
    }
    triangle {
      < 0.900633, -0.819492, -3.147110>,
      < 0.900625, -0.805667, -3.111025>,
      < -0.487567, -0.806489, -3.111026>
    }
    triangle {
      < 0.900633, -0.819492, -3.147110>,
      < -0.487567, -0.806489, -3.111026>,
      < -0.487559, -0.820314, -3.147111>
    }
    triangle {
      < 0.900608, -0.778363, -3.083680>,
      < 0.900588, -0.742297, -3.069802>,
      < -0.487605, -0.743120, -3.069802>
    }
    triangle {
      < 0.900608, -0.778363, -3.083680>,
      < -0.487605, -0.743120, -3.069802>,
      < -0.487583, -0.779185, -3.083680>
    }
    triangle {
      < -0.290938, -0.492498, -2.743191>,
      < -0.254742, -0.662627, -2.591365>,
      < -0.254734, -0.675833, -2.599945>
    }
    triangle {
      < -0.290938, -0.492498, -2.743191>,
      < -0.254734, -0.675833, -2.599945>,
      < -0.290927, -0.510214, -2.760954>
    }
    triangle {
      < -0.290938, -0.492498, -2.743191>,
      < -0.254748, -0.653940, -2.577968>,
      < -0.254742, -0.662627, -2.591365>
    }
    triangle {
      < -0.446269, -0.510306, -2.760954>,
      < -0.446835, -0.662741, -2.591365>,
      < -0.446840, -0.654053, -2.577968>
    }
    triangle {
      < -0.446269, -0.510306, -2.760954>,
      < -0.446840, -0.654053, -2.577968>,
      < -0.446280, -0.492590, -2.743191>
    }
    triangle {
      < -0.446269, -0.510306, -2.760954>,
      < -0.446827, -0.675946, -2.599945>,
      < -0.446835, -0.662741, -2.591365>
    }
    triangle {
      < -0.446280, -0.492590, -2.743191>,
      < -0.446840, -0.654053, -2.577968>,
      < -0.254748, -0.653940, -2.577968>
    }
    triangle {
      < -0.446280, -0.492590, -2.743191>,
      < -0.254748, -0.653940, -2.577968>,
      < -0.290938, -0.492498, -2.743191>
    }
    triangle {
      < -0.290927, -0.510214, -2.760954>,
      < -0.254734, -0.675833, -2.599945>,
      < -0.446827, -0.675946, -2.599945>
    }
    triangle {
      < -0.290927, -0.510214, -2.760954>,
      < -0.446827, -0.675946, -2.599945>,
      < -0.446269, -0.510306, -2.760954>
    }
    triangle {
      < 0.488400, -0.619899, -2.611477>,
      < 0.518899, -0.662168, -2.591365>,
      < 0.521178, -0.675373, -2.599945>
    }
    triangle {
      < 0.488400, -0.619899, -2.611477>,
      < 0.521178, -0.675373, -2.599945>,
      < 0.488413, -0.641805, -2.633442>
    }
    triangle {
      < 0.488400, -0.619899, -2.611477>,
      < 0.521177, -0.653480, -2.577968>,
      < 0.518899, -0.662168, -2.591365>
    }
    triangle {
      < -0.217357, -0.510170, -2.760954>,
      < -0.163768, -0.662573, -2.591365>,
      < -0.163773, -0.653886, -2.577968>
    }
    triangle {
      < -0.217357, -0.510170, -2.760954>,
      < -0.163773, -0.653886, -2.577968>,
      < -0.217368, -0.492454, -2.743191>
    }
    triangle {
      < -0.217357, -0.510170, -2.760954>,
      < -0.163759, -0.675779, -2.599945>,
      < -0.163768, -0.662573, -2.591365>
    }
    triangle {
      < -0.217368, -0.492454, -2.743191>,
      < -0.163773, -0.653886, -2.577968>,
      < 0.521177, -0.653480, -2.577968>
    }
    triangle {
      < -0.217368, -0.492454, -2.743191>,
      < 0.521177, -0.653480, -2.577968>,
      < 0.488400, -0.619899, -2.611477>
    }
    triangle {
      < 0.488413, -0.641805, -2.633442>,
      < 0.521178, -0.675373, -2.599945>,
      < -0.163759, -0.675779, -2.599945>
    }
    triangle {
      < 0.488413, -0.641805, -2.633442>,
      < -0.163759, -0.675779, -2.599945>,
      < -0.217357, -0.510170, -2.760954>
    }
    triangle {
      < -0.290927, -0.510772, -2.289828>,
      < -0.254738, -0.669941, -2.453354>,
      < -0.254748, -0.653958, -2.473049>
    }
    triangle {
      < -0.290927, -0.510772, -2.289828>,
      < -0.254748, -0.653958, -2.473049>,
      < -0.290938, -0.493014, -2.307549>
    }
    triangle {
      < -0.290927, -0.510772, -2.289828>,
      < -0.254735, -0.675374, -2.450594>,
      < -0.254738, -0.669941, -2.453354>
    }
    triangle {
      < -0.446280, -0.493106, -2.307549>,
      < -0.446830, -0.670054, -2.453354>,
      < -0.446828, -0.675488, -2.450594>
    }
    triangle {
      < -0.446280, -0.493106, -2.307549>,
      < -0.446828, -0.675488, -2.450594>,
      < -0.446269, -0.510864, -2.289828>
    }
    triangle {
      < -0.446280, -0.493106, -2.307549>,
      < -0.446840, -0.654072, -2.473049>,
      < -0.446830, -0.670054, -2.453354>
    }
    triangle {
      < -0.446269, -0.510864, -2.289828>,
      < -0.446828, -0.675488, -2.450594>,
      < -0.254735, -0.675374, -2.450594>
    }
    triangle {
      < -0.446269, -0.510864, -2.289828>,
      < -0.254735, -0.675374, -2.450594>,
      < -0.290927, -0.510772, -2.289828>
    }
    triangle {
      < -0.290938, -0.493014, -2.307549>,
      < -0.254748, -0.653958, -2.473049>,
      < -0.446840, -0.654072, -2.473049>
    }
    triangle {
      < -0.290938, -0.493014, -2.307549>,
      < -0.446840, -0.654072, -2.473049>,
      < -0.446280, -0.493106, -2.307549>
    }
    triangle {
      < 0.488413, -0.642061, -2.417652>,
      < 0.519253, -0.669482, -2.453354>,
      < 0.521074, -0.653498, -2.473048>
    }
    triangle {
      < 0.488413, -0.642061, -2.417652>,
      < 0.521074, -0.653498, -2.473048>,
      < 0.488400, -0.620103, -2.439565>
    }
    triangle {
      < 0.488413, -0.642061, -2.417652>,
      < 0.520556, -0.674914, -2.450593>,
      < 0.519253, -0.669482, -2.453354>
    }
    triangle {
      < -0.217368, -0.492970, -2.307549>,
      < -0.163763, -0.669887, -2.453354>,
      < -0.163760, -0.675320, -2.450594>
    }
    triangle {
      < -0.217368, -0.492970, -2.307549>,
      < -0.163760, -0.675320, -2.450594>,
      < -0.217357, -0.510728, -2.289828>
    }
    triangle {
      < -0.217368, -0.492970, -2.307549>,
      < -0.163773, -0.653904, -2.473049>,
      < -0.163763, -0.669887, -2.453354>
    }
    triangle {
      < -0.217357, -0.510728, -2.289828>,
      < -0.163760, -0.675320, -2.450594>,
      < 0.520556, -0.674914, -2.450593>
    }
    triangle {
      < -0.217357, -0.510728, -2.289828>,
      < 0.520556, -0.674914, -2.450593>,
      < 0.488413, -0.642061, -2.417652>
    }
    triangle {
      < 0.488400, -0.620103, -2.439565>,
      < 0.521074, -0.653498, -2.473048>,
      < -0.163773, -0.653904, -2.473049>
    }
    triangle {
      < 0.488400, -0.620103, -2.439565>,
      < -0.163773, -0.653904, -2.473049>,
      < -0.217368, -0.492970, -2.307549>
    }
    triangle {
      < -0.290659, -0.964141, -2.307967>,
      < -0.254659, -0.803659, -2.472384>,
      < -0.254672, -0.781740, -2.450432>
    }
    triangle {
      < -0.290659, -0.964141, -2.307967>,
      < -0.254672, -0.781740, -2.450432>,
      < -0.290668, -0.946415, -2.290215>
    }
    triangle {
      < -0.446011, -0.946507, -2.290215>,
      < -0.446764, -0.781853, -2.450432>,
      < -0.446751, -0.803773, -2.472384>
    }
    triangle {
      < -0.446011, -0.946507, -2.290215>,
      < -0.446751, -0.803773, -2.472384>,
      < -0.446001, -0.964233, -2.307967>
    }
    triangle {
      < -0.446001, -0.964233, -2.307967>,
      < -0.446751, -0.803773, -2.472384>,
      < -0.254659, -0.803659, -2.472384>
    }
    triangle {
      < -0.446001, -0.964233, -2.307967>,
      < -0.254659, -0.803659, -2.472384>,
      < -0.290659, -0.964141, -2.307967>
    }
    triangle {
      < -0.290668, -0.946415, -2.290215>,
      < -0.254672, -0.781740, -2.450432>,
      < -0.446764, -0.781853, -2.450432>
    }
    triangle {
      < -0.290668, -0.946415, -2.290215>,
      < -0.446764, -0.781853, -2.450432>,
      < -0.446011, -0.946507, -2.290215>
    }
    triangle {
      < 0.488528, -0.835893, -2.439757>,
      < 0.520383, -0.803199, -2.472383>,
      < 0.520370, -0.781280, -2.450432>
    }
    triangle {
      < 0.488528, -0.835893, -2.439757>,
      < 0.520370, -0.781280, -2.450432>,
      < 0.488515, -0.813974, -2.417805>
    }
    triangle {
      < -0.217099, -0.946371, -2.290215>,
      < -0.163697, -0.781686, -2.450432>,
      < -0.163684, -0.803605, -2.472384>
    }
    triangle {
      < -0.217099, -0.946371, -2.290215>,
      < -0.163684, -0.803605, -2.472384>,
      < -0.217089, -0.964097, -2.307967>
    }
    triangle {
      < -0.217089, -0.964097, -2.307967>,
      < -0.163684, -0.803605, -2.472384>,
      < 0.520383, -0.803199, -2.472383>
    }
    triangle {
      < -0.217089, -0.964097, -2.307967>,
      < 0.520383, -0.803199, -2.472383>,
      < 0.488528, -0.835893, -2.439757>
    }
    triangle {
      < 0.488515, -0.813974, -2.417805>,
      < 0.520370, -0.781280, -2.450432>,
      < -0.163697, -0.781686, -2.450432>
    }
    triangle {
      < 0.488515, -0.813974, -2.417805>,
      < -0.163697, -0.781686, -2.450432>,
      < -0.217099, -0.946371, -2.290215>
    }
    triangle {
      < -0.290668, -0.946136, -2.761342>,
      < -0.254660, -0.800570, -2.584178>,
      < -0.254659, -0.803340, -2.578749>
    }
    triangle {
      < -0.290668, -0.946136, -2.761342>,
      < -0.254659, -0.803340, -2.578749>,
      < -0.290659, -0.963882, -2.743611>
    }
    triangle {
      < -0.290668, -0.946136, -2.761342>,
      < -0.254672, -0.780853, -2.600132>,
      < -0.254660, -0.800570, -2.584178>
    }
    triangle {
      < -0.446001, -0.963975, -2.743611>,
      < -0.446753, -0.800684, -2.584178>,
      < -0.446764, -0.780966, -2.600132>
    }
    triangle {
      < -0.446001, -0.963975, -2.743611>,
      < -0.446764, -0.780966, -2.600132>,
      < -0.446011, -0.946228, -2.761342>
    }
    triangle {
      < -0.446001, -0.963975, -2.743611>,
      < -0.446751, -0.803454, -2.578749>,
      < -0.446753, -0.800684, -2.584178>
    }
    triangle {
      < -0.446011, -0.946228, -2.761342>,
      < -0.446764, -0.780966, -2.600132>,
      < -0.254672, -0.780853, -2.600132>
    }
    triangle {
      < -0.446011, -0.946228, -2.761342>,
      < -0.254672, -0.780853, -2.600132>,
      < -0.290668, -0.946136, -2.761342>
    }
    triangle {
      < -0.290659, -0.963882, -2.743611>,
      < -0.254659, -0.803340, -2.578749>,
      < -0.446751, -0.803454, -2.578749>
    }
    triangle {
      < -0.290659, -0.963882, -2.743611>,
      < -0.446751, -0.803454, -2.578749>,
      < -0.446001, -0.963975, -2.743611>
    }
    triangle {
      < 0.488515, -0.813846, -2.633596>,
      < 0.519332, -0.800111, -2.584178>,
      < 0.520632, -0.802881, -2.578749>
    }
    triangle {
      < 0.488515, -0.813846, -2.633596>,
      < 0.520632, -0.802881, -2.578749>,
      < 0.488528, -0.835791, -2.611670>
    }
    triangle {
      < 0.488515, -0.813846, -2.633596>,
      < 0.521150, -0.780393, -2.600132>,
      < 0.519332, -0.800111, -2.584178>
    }
    triangle {
      < -0.217089, -0.963839, -2.743611>,
      < -0.163686, -0.800516, -2.584178>,
      < -0.163697, -0.780799, -2.600132>
    }
    triangle {
      < -0.217089, -0.963839, -2.743611>,
      < -0.163697, -0.780799, -2.600132>,
      < -0.217099, -0.946092, -2.761342>
    }
    triangle {
      < -0.217089, -0.963839, -2.743611>,
      < -0.163685, -0.803286, -2.578749>,
      < -0.163686, -0.800516, -2.584178>
    }
    triangle {
      < -0.217099, -0.946092, -2.761342>,
      < -0.163697, -0.780799, -2.600132>,
      < 0.521150, -0.780393, -2.600132>
    }
    triangle {
      < -0.217099, -0.946092, -2.761342>,
      < 0.521150, -0.780393, -2.600132>,
      < 0.488515, -0.813846, -2.633596>
    }
    triangle {
      < 0.488528, -0.835791, -2.611670>,
      < 0.520632, -0.802881, -2.578749>,
      < -0.163685, -0.803286, -2.578749>
    }
    triangle {
      < 0.488528, -0.835791, -2.611670>,
      < -0.163685, -0.803286, -2.578749>,
      < -0.217089, -0.963839, -2.743611>
    }
    triangle {
      < 0.488400, -0.619899, -2.611477>,
      < 0.488413, -0.641805, -2.633442>,
      < -0.217357, -0.510170, -2.760954>
    }
    triangle {
      < 0.488400, -0.619899, -2.611477>,
      < -0.217357, -0.510170, -2.760954>,
      < -0.217368, -0.492454, -2.743191>
    }
    triangle {
      < -0.290938, -0.492498, -2.743191>,
      < -0.290927, -0.510214, -2.760954>,
      < -0.446269, -0.510306, -2.760954>
    }
    triangle {
      < -0.290938, -0.492498, -2.743191>,
      < -0.446269, -0.510306, -2.760954>,
      < -0.446280, -0.492590, -2.743191>
    }
    triangle {
      < 0.488515, -0.813846, -2.633596>,
      < 0.488528, -0.835791, -2.611670>,
      < -0.217089, -0.963839, -2.743611>
    }
    triangle {
      < 0.488515, -0.813846, -2.633596>,
      < -0.217089, -0.963839, -2.743611>,
      < -0.217099, -0.946092, -2.761342>
    }
    triangle {
      < -0.290668, -0.946136, -2.761342>,
      < -0.290659, -0.963882, -2.743611>,
      < -0.446001, -0.963975, -2.743611>
    }
    triangle {
      < -0.290668, -0.946136, -2.761342>,
      < -0.446001, -0.963975, -2.743611>,
      < -0.446011, -0.946228, -2.761342>
    }
    triangle {
      < 0.488413, -0.642061, -2.417652>,
      < 0.488400, -0.620103, -2.439565>,
      < -0.217368, -0.492970, -2.307549>
    }
    triangle {
      < 0.488413, -0.642061, -2.417652>,
      < -0.217368, -0.492970, -2.307549>,
      < -0.217357, -0.510728, -2.289828>
    }
    triangle {
      < -0.290927, -0.510772, -2.289828>,
      < -0.290938, -0.493014, -2.307549>,
      < -0.446280, -0.493106, -2.307549>
    }
    triangle {
      < -0.290927, -0.510772, -2.289828>,
      < -0.446280, -0.493106, -2.307549>,
      < -0.446269, -0.510864, -2.289828>
    }
    triangle {
      < 0.488528, -0.835893, -2.439757>,
      < 0.488515, -0.813974, -2.417805>,
      < -0.217099, -0.946371, -2.290215>
    }
    triangle {
      < 0.488528, -0.835893, -2.439757>,
      < -0.217099, -0.946371, -2.290215>,
      < -0.217089, -0.964097, -2.307967>
    }
    triangle {
      < -0.290659, -0.964141, -2.307967>,
      < -0.290668, -0.946415, -2.290215>,
      < -0.446011, -0.946507, -2.290215>
    }
    triangle {
      < -0.290659, -0.964141, -2.307967>,
      < -0.446011, -0.946507, -2.290215>,
      < -0.446001, -0.964233, -2.307967>
    }
    triangle {
      < 0.916814, -0.640850, -2.558851>,
      < 0.521177, -0.653480, -2.577968>,
      < -0.163773, -0.653886, -2.577968>
    }
    triangle {
      < 0.916814, -0.640850, -2.558851>,
      < 0.916825, -0.661932, -2.591365>,
      < 0.518899, -0.662168, -2.591365>
    }
    triangle {
      < 0.916814, -0.640850, -2.558851>,
      < 0.518899, -0.662168, -2.591365>,
      < 0.521177, -0.653480, -2.577968>
    }
    triangle {
      < -0.254748, -0.653940, -2.577968>,
      < 0.916814, -0.640850, -2.558851>,
      < -0.163773, -0.653886, -2.577968>
    }
    triangle {
      < -0.163768, -0.662573, -2.591365>,
      < -0.254748, -0.653940, -2.577968>,
      < -0.163773, -0.653886, -2.577968>
    }
    triangle {
      < -0.254748, -0.653940, -2.577968>,
      < -0.446840, -0.654053, -2.577968>,
      < -0.471378, -0.641672, -2.558851>
    }
    triangle {
      < -0.254748, -0.653940, -2.577968>,
      < -0.471378, -0.641672, -2.558851>,
      < 0.916814, -0.640850, -2.558851>
    }
    triangle {
      < -0.446840, -0.654053, -2.577968>,
      < -0.446835, -0.662741, -2.591365>,
      < -0.471365, -0.662755, -2.591365>
    }
    triangle {
      < -0.446840, -0.654053, -2.577968>,
      < -0.471365, -0.662755, -2.591365>,
      < -0.471378, -0.641672, -2.558851>
    }
    triangle {
      < -0.163768, -0.662573, -2.591365>,
      < -0.254742, -0.662627, -2.591365>,
      < -0.254748, -0.653940, -2.577968>
    }
    triangle {
      < -0.471375, -0.645718, -2.483360>,
      < -0.446840, -0.654072, -2.473049>,
      < -0.254748, -0.653958, -2.473049>
    }
    triangle {
      < -0.471375, -0.645718, -2.483360>,
      < -0.471361, -0.670069, -2.453354>,
      < -0.446830, -0.670054, -2.453354>
    }
    triangle {
      < -0.471375, -0.645718, -2.483360>,
      < -0.446830, -0.670054, -2.453354>,
      < -0.446840, -0.654072, -2.473049>
    }
    triangle {
      < -0.163773, -0.653904, -2.473049>,
      < -0.471375, -0.645718, -2.483360>,
      < -0.254748, -0.653958, -2.473049>
    }
    triangle {
      < -0.254738, -0.669941, -2.453354>,
      < -0.163773, -0.653904, -2.473049>,
      < -0.254748, -0.653958, -2.473049>
    }
    triangle {
      < -0.163773, -0.653904, -2.473049>,
      < 0.521074, -0.653498, -2.473048>,
      < 0.916816, -0.644896, -2.483360>
    }
    triangle {
      < -0.163773, -0.653904, -2.473049>,
      < 0.916816, -0.644896, -2.483360>,
      < -0.471375, -0.645718, -2.483360>
    }
    triangle {
      < 0.521074, -0.653498, -2.473048>,
      < 0.519253, -0.669482, -2.453354>,
      < 0.916830, -0.669246, -2.453354>
    }
    triangle {
      < 0.521074, -0.653498, -2.473048>,
      < 0.916830, -0.669246, -2.453354>,
      < 0.916816, -0.644896, -2.483360>
    }
    triangle {
      < -0.254738, -0.669941, -2.453354>,
      < -0.163763, -0.669887, -2.453354>,
      < -0.163773, -0.653904, -2.473049>
    }
    triangle {
      < 0.916851, -0.703694, -2.435845>,
      < 0.520556, -0.674914, -2.450593>,
      < -0.163760, -0.675320, -2.450594>
    }
    triangle {
      < 0.916851, -0.703694, -2.435845>,
      < 0.916830, -0.669246, -2.453354>,
      < 0.519253, -0.669482, -2.453354>
    }
    triangle {
      < 0.916851, -0.703694, -2.435845>,
      < 0.519253, -0.669482, -2.453354>,
      < 0.520556, -0.674914, -2.450593>
    }
    triangle {
      < -0.254735, -0.675374, -2.450594>,
      < 0.916851, -0.703694, -2.435845>,
      < -0.163760, -0.675320, -2.450594>
    }
    triangle {
      < -0.163763, -0.669887, -2.453354>,
      < -0.254735, -0.675374, -2.450594>,
      < -0.163760, -0.675320, -2.450594>
    }
    triangle {
      < -0.254735, -0.675374, -2.450594>,
      < -0.446828, -0.675488, -2.450594>,
      < -0.471341, -0.704517, -2.435845>
    }
    triangle {
      < -0.254735, -0.675374, -2.450594>,
      < -0.471341, -0.704517, -2.435845>,
      < 0.916851, -0.703694, -2.435845>
    }
    triangle {
      < -0.446828, -0.675488, -2.450594>,
      < -0.446830, -0.670054, -2.453354>,
      < -0.471361, -0.670069, -2.453354>
    }
    triangle {
      < -0.446828, -0.675488, -2.450594>,
      < -0.471361, -0.670069, -2.453354>,
      < -0.471341, -0.704517, -2.435845>
    }
    triangle {
      < -0.163763, -0.669887, -2.453354>,
      < -0.254738, -0.669941, -2.453354>,
      < -0.254735, -0.675374, -2.450594>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < 0.520370, -0.781280, -2.450432>,
      < 0.916895, -0.778352, -2.447734>
    }
    triangle {
      < 0.520370, -0.781280, -2.450432>,
      < 0.520383, -0.803199, -2.472383>,
      < 0.916911, -0.805657, -2.475080>
    }
    triangle {
      < 0.520370, -0.781280, -2.450432>,
      < 0.916911, -0.805657, -2.475080>,
      < 0.916895, -0.778352, -2.447734>
    }
    triangle {
      < 0.520383, -0.803199, -2.472383>,
      < -0.163684, -0.803605, -2.472384>,
      < 0.916911, -0.805657, -2.475080>
    }
    triangle {
      < -0.163684, -0.803605, -2.472384>,
      < -0.254659, -0.803659, -2.472384>,
      < 0.916911, -0.805657, -2.475080>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < -0.163697, -0.781686, -2.450432>,
      < 0.520370, -0.781280, -2.450432>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < -0.254672, -0.781740, -2.450432>,
      < -0.163697, -0.781686, -2.450432>
    }
    triangle {
      < -0.254672, -0.781740, -2.450432>,
      < -0.163684, -0.803605, -2.472384>,
      < -0.163697, -0.781686, -2.450432>
    }
    triangle {
      < -0.254672, -0.781740, -2.450432>,
      < -0.254659, -0.803659, -2.472384>,
      < -0.163684, -0.803605, -2.472384>
    }
    triangle {
      < -0.254659, -0.803659, -2.472384>,
      < -0.446751, -0.803773, -2.472384>,
      < -0.471280, -0.806480, -2.475080>
    }
    triangle {
      < -0.254659, -0.803659, -2.472384>,
      < -0.471280, -0.806480, -2.475080>,
      < 0.916911, -0.805657, -2.475080>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < -0.446764, -0.781853, -2.450432>,
      < -0.254672, -0.781740, -2.450432>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < -0.446751, -0.803773, -2.472384>,
      < -0.446764, -0.781853, -2.450432>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < -0.471280, -0.806480, -2.475080>,
      < -0.446751, -0.803773, -2.472384>
    }
    triangle {
      < -0.471273, -0.818260, -2.549755>,
      < -0.446751, -0.803454, -2.578749>,
      < -0.254659, -0.803340, -2.578749>
    }
    triangle {
      < -0.471273, -0.818260, -2.549755>,
      < -0.471283, -0.800698, -2.584178>,
      < -0.446753, -0.800684, -2.584178>
    }
    triangle {
      < -0.471273, -0.818260, -2.549755>,
      < -0.446753, -0.800684, -2.584178>,
      < -0.446751, -0.803454, -2.578749>
    }
    triangle {
      < -0.163685, -0.803286, -2.578749>,
      < -0.471273, -0.818260, -2.549755>,
      < -0.254659, -0.803340, -2.578749>
    }
    triangle {
      < -0.254660, -0.800570, -2.584178>,
      < -0.163685, -0.803286, -2.578749>,
      < -0.254659, -0.803340, -2.578749>
    }
    triangle {
      < -0.163685, -0.803286, -2.578749>,
      < 0.520632, -0.802881, -2.578749>,
      < 0.916918, -0.817438, -2.549755>
    }
    triangle {
      < -0.163685, -0.803286, -2.578749>,
      < 0.916918, -0.817438, -2.549755>,
      < -0.471273, -0.818260, -2.549755>
    }
    triangle {
      < 0.520632, -0.802881, -2.578749>,
      < 0.519332, -0.800111, -2.584178>,
      < 0.916907, -0.799876, -2.584178>
    }
    triangle {
      < 0.520632, -0.802881, -2.578749>,
      < 0.916907, -0.799876, -2.584178>,
      < 0.916918, -0.817438, -2.549755>
    }
    triangle {
      < -0.254660, -0.800570, -2.584178>,
      < -0.163686, -0.800516, -2.584178>,
      < -0.163685, -0.803286, -2.578749>
    }
    triangle {
      < 0.916890, -0.769834, -2.608484>,
      < 0.521150, -0.780393, -2.600132>,
      < -0.163697, -0.780799, -2.600132>
    }
    triangle {
      < 0.916890, -0.769834, -2.608484>,
      < 0.916907, -0.799876, -2.584178>,
      < 0.519332, -0.800111, -2.584178>
    }
    triangle {
      < 0.916890, -0.769834, -2.608484>,
      < 0.519332, -0.800111, -2.584178>,
      < 0.521150, -0.780393, -2.600132>
    }
    triangle {
      < -0.254672, -0.780853, -2.600132>,
      < 0.916890, -0.769834, -2.608484>,
      < -0.163697, -0.780799, -2.600132>
    }
    triangle {
      < -0.163686, -0.800516, -2.584178>,
      < -0.254672, -0.780853, -2.600132>,
      < -0.163697, -0.780799, -2.600132>
    }
    triangle {
      < -0.254672, -0.780853, -2.600132>,
      < -0.446764, -0.780966, -2.600132>,
      < -0.471301, -0.770656, -2.608485>
    }
    triangle {
      < -0.254672, -0.780853, -2.600132>,
      < -0.471301, -0.770656, -2.608485>,
      < 0.916890, -0.769834, -2.608484>
    }
    triangle {
      < -0.446764, -0.780966, -2.600132>,
      < -0.446753, -0.800684, -2.584178>,
      < -0.471283, -0.800698, -2.584178>
    }
    triangle {
      < -0.446764, -0.780966, -2.600132>,
      < -0.471283, -0.800698, -2.584178>,
      < -0.471301, -0.770656, -2.608485>
    }
    triangle {
      < -0.163686, -0.800516, -2.584178>,
      < -0.254660, -0.800570, -2.584178>,
      < -0.254672, -0.780853, -2.600132>
    }
    triangle {
      < -0.471346, -0.695160, -2.612419>,
      < -0.446827, -0.675946, -2.599945>,
      < -0.254734, -0.675833, -2.599945>
    }
    triangle {
      < -0.471346, -0.695160, -2.612419>,
      < -0.471365, -0.662755, -2.591365>,
      < -0.446835, -0.662741, -2.591365>
    }
    triangle {
      < -0.471346, -0.695160, -2.612419>,
      < -0.446835, -0.662741, -2.591365>,
      < -0.446827, -0.675946, -2.599945>
    }
    triangle {
      < -0.163759, -0.675779, -2.599945>,
      < -0.471346, -0.695160, -2.612419>,
      < -0.254734, -0.675833, -2.599945>
    }
    triangle {
      < -0.254742, -0.662627, -2.591365>,
      < -0.163759, -0.675779, -2.599945>,
      < -0.254734, -0.675833, -2.599945>
    }
    triangle {
      < -0.163759, -0.675779, -2.599945>,
      < 0.521178, -0.675373, -2.599945>,
      < 0.916845, -0.694338, -2.612418>
    }
    triangle {
      < -0.163759, -0.675779, -2.599945>,
      < 0.916845, -0.694338, -2.612418>,
      < -0.471346, -0.695160, -2.612419>
    }
    triangle {
      < 0.521178, -0.675373, -2.599945>,
      < 0.518899, -0.662168, -2.591365>,
      < 0.916825, -0.661932, -2.591365>
    }
    triangle {
      < 0.521178, -0.675373, -2.599945>,
      < 0.916825, -0.661932, -2.591365>,
      < 0.916845, -0.694338, -2.612418>
    }
    triangle {
      < -0.254742, -0.662627, -2.591365>,
      < -0.163768, -0.662573, -2.591365>,
      < -0.163759, -0.675779, -2.599945>
    }
    triangle {
      < 1.139523, -0.674948, -2.578222>,
      < 1.139539, -0.700872, -2.595064>,
      < 0.916845, -0.694338, -2.612418>
    }
    triangle {
      < 1.139523, -0.674948, -2.578222>,
      < 0.916845, -0.694338, -2.612418>,
      < 0.916825, -0.661932, -2.591365>
    }
    triangle {
      < 1.139513, -0.658083, -2.552210>,
      < 1.139523, -0.674948, -2.578222>,
      < 0.916825, -0.661932, -2.591365>
    }
    triangle {
      < 1.139513, -0.658083, -2.552210>,
      < 0.916825, -0.661932, -2.591365>,
      < 0.916814, -0.640850, -2.558851>
    }
    triangle {
      < -0.471378, -0.641672, -2.558851>,
      < -0.471365, -0.662755, -2.591365>,
      < -0.482926, -0.675910, -2.578222>
    }
    triangle {
      < -0.471378, -0.641672, -2.558851>,
      < -0.482926, -0.675910, -2.578222>,
      < -0.482936, -0.659044, -2.552210>
    }
    triangle {
      < -0.471365, -0.662755, -2.591365>,
      < -0.471346, -0.695160, -2.612419>,
      < -0.482910, -0.701834, -2.595064>
    }
    triangle {
      < -0.471365, -0.662755, -2.591365>,
      < -0.482910, -0.701834, -2.595064>,
      < -0.482926, -0.675910, -2.578222>
    }
    triangle {
      < 0.916845, -0.694338, -2.612418>,
      < 0.916868, -0.732504, -2.618473>,
      < -0.471324, -0.733327, -2.618474>
    }
    triangle {
      < 0.916845, -0.694338, -2.612418>,
      < -0.471324, -0.733327, -2.618474>,
      < -0.471346, -0.695160, -2.612419>
    }
    triangle {
      < -0.471346, -0.695160, -2.612419>,
      < -0.471324, -0.733327, -2.618474>,
      < -0.482892, -0.732367, -2.599909>
    }
    triangle {
      < -0.471346, -0.695160, -2.612419>,
      < -0.482892, -0.732367, -2.599909>,
      < -0.482910, -0.701834, -2.595064>
    }
    triangle {
      < 1.139539, -0.700872, -2.595064>,
      < 1.139557, -0.731405, -2.599909>,
      < 0.916868, -0.732504, -2.618473>
    }
    triangle {
      < 1.139539, -0.700872, -2.595064>,
      < 0.916868, -0.732504, -2.618473>,
      < 0.916845, -0.694338, -2.612418>
    }
    triangle {
      < 0.916810, -0.634852, -2.520676>,
      < 0.916814, -0.640850, -2.558851>,
      < -0.471378, -0.641672, -2.558851>
    }
    triangle {
      < 0.916810, -0.634852, -2.520676>,
      < -0.471378, -0.641672, -2.558851>,
      < -0.471381, -0.635674, -2.520676>
    }
    triangle {
      < 1.139511, -0.653282, -2.521670>,
      < 1.139513, -0.658083, -2.552210>,
      < 0.916814, -0.640850, -2.558851>
    }
    triangle {
      < 1.139511, -0.653282, -2.521670>,
      < 0.916814, -0.640850, -2.558851>,
      < 0.916810, -0.634852, -2.520676>
    }
    triangle {
      < -0.471381, -0.635674, -2.520676>,
      < -0.471378, -0.641672, -2.558851>,
      < -0.482936, -0.659044, -2.552210>
    }
    triangle {
      < -0.471381, -0.635674, -2.520676>,
      < -0.482936, -0.659044, -2.552210>,
      < -0.482939, -0.654244, -2.521670>
    }
    triangle {
      < 1.237855, -0.675387, -2.545570>,
      < 1.237862, -0.688037, -2.565078>,
      < 1.139523, -0.674948, -2.578222>
    }
    triangle {
      < 1.237855, -0.675387, -2.545570>,
      < 1.139523, -0.674948, -2.578222>,
      < 1.139513, -0.658083, -2.552210>
    }
    triangle {
      < -0.482936, -0.659044, -2.552210>,
      < -0.482926, -0.675910, -2.578222>,
      < -0.399045, -0.694642, -2.559446>
    }
    triangle {
      < -0.482936, -0.659044, -2.552210>,
      < -0.399045, -0.694642, -2.559446>,
      < -0.399051, -0.683799, -2.542725>
    }
    triangle {
      < 1.237862, -0.688037, -2.565078>,
      < 1.237873, -0.707480, -2.577710>,
      < 1.139539, -0.700872, -2.595064>
    }
    triangle {
      < 1.237862, -0.688037, -2.565078>,
      < 1.139539, -0.700872, -2.595064>,
      < 1.139523, -0.674948, -2.578222>
    }
    triangle {
      < -0.482926, -0.675910, -2.578222>,
      < -0.482910, -0.701834, -2.595064>,
      < -0.399035, -0.711307, -2.570273>
    }
    triangle {
      < -0.482926, -0.675910, -2.578222>,
      < -0.399035, -0.711307, -2.570273>,
      < -0.399045, -0.694642, -2.559446>
    }
    triangle {
      < 1.237873, -0.707480, -2.577710>,
      < 1.237887, -0.730379, -2.581344>,
      < 1.139557, -0.731405, -2.599909>
    }
    triangle {
      < 1.237873, -0.707480, -2.577710>,
      < 1.139557, -0.731405, -2.599909>,
      < 1.139539, -0.700872, -2.595064>
    }
    triangle {
      < -0.482910, -0.701834, -2.595064>,
      < -0.482892, -0.732367, -2.599909>,
      < -0.399023, -0.730935, -2.573387>
    }
    triangle {
      < -0.482910, -0.701834, -2.595064>,
      < -0.399023, -0.730935, -2.573387>,
      < -0.399035, -0.711307, -2.570273>
    }
    triangle {
      < -0.482939, -0.654244, -2.521670>,
      < -0.482936, -0.659044, -2.552210>,
      < -0.399051, -0.683799, -2.542725>
    }
    triangle {
      < -0.482939, -0.654244, -2.521670>,
      < -0.399051, -0.683799, -2.542725>,
      < -0.399053, -0.680714, -2.523091>
    }
    triangle {
      < 1.237852, -0.671788, -2.522666>,
      < 1.237855, -0.675387, -2.545570>,
      < 1.139513, -0.658083, -2.552210>
    }
    triangle {
      < 1.237852, -0.671788, -2.522666>,
      < 1.139513, -0.658083, -2.552210>,
      < 1.139511, -0.653282, -2.521670>
    }
    triangle {
      < 1.139557, -0.731405, -2.599909>,
      < 1.139575, -0.761270, -2.591917>,
      < 0.916890, -0.769834, -2.608484>
    }
    triangle {
      < 1.139557, -0.731405, -2.599909>,
      < 0.916890, -0.769834, -2.608484>,
      < 0.916868, -0.732504, -2.618473>
    }
    triangle {
      < -0.471324, -0.733327, -2.618474>,
      < -0.471301, -0.770656, -2.608485>,
      < -0.482875, -0.762231, -2.591918>
    }
    triangle {
      < -0.471324, -0.733327, -2.618474>,
      < -0.482875, -0.762231, -2.591918>,
      < -0.482892, -0.732367, -2.599909>
    }
    triangle {
      < 0.916868, -0.732504, -2.618473>,
      < 0.916890, -0.769834, -2.608484>,
      < -0.471301, -0.770656, -2.608485>
    }
    triangle {
      < 0.916868, -0.732504, -2.618473>,
      < -0.471301, -0.770656, -2.608485>,
      < -0.471324, -0.733327, -2.618474>
    }
    triangle {
      < 1.139515, -0.661318, -2.491818>,
      < 1.139511, -0.653282, -2.521670>,
      < 0.916810, -0.634852, -2.520676>
    }
    triangle {
      < 1.139515, -0.661318, -2.491818>,
      < 0.916810, -0.634852, -2.520676>,
      < 0.916816, -0.644896, -2.483360>
    }
    triangle {
      < 0.916816, -0.644896, -2.483360>,
      < 0.916810, -0.634852, -2.520676>,
      < -0.471381, -0.635674, -2.520676>
    }
    triangle {
      < 0.916816, -0.644896, -2.483360>,
      < -0.471381, -0.635674, -2.520676>,
      < -0.471375, -0.645718, -2.483360>
    }
    triangle {
      < -0.471375, -0.645718, -2.483360>,
      < -0.471381, -0.635674, -2.520676>,
      < -0.482939, -0.654244, -2.521670>
    }
    triangle {
      < -0.471375, -0.645718, -2.483360>,
      < -0.482939, -0.654244, -2.521670>,
      < -0.482934, -0.662280, -2.491819>
    }
    triangle {
      < 1.292815, -0.695199, -2.537981>,
      < 1.292819, -0.703030, -2.550057>,
      < 1.237862, -0.688037, -2.565078>
    }
    triangle {
      < 1.292815, -0.695199, -2.537981>,
      < 1.237862, -0.688037, -2.565078>,
      < 1.237855, -0.675387, -2.545570>
    }
    triangle {
      < 1.292819, -0.703030, -2.550057>,
      < 1.292827, -0.715066, -2.557877>,
      < 1.237873, -0.707480, -2.577710>
    }
    triangle {
      < 1.292819, -0.703030, -2.550057>,
      < 1.237873, -0.707480, -2.577710>,
      < 1.237862, -0.688037, -2.565078>
    }
    triangle {
      < 1.292827, -0.715066, -2.557877>,
      < 1.292835, -0.729242, -2.560126>,
      < 1.237887, -0.730379, -2.581344>
    }
    triangle {
      < 1.292827, -0.715066, -2.557877>,
      < 1.237887, -0.730379, -2.581344>,
      < 1.237873, -0.707480, -2.577710>
    }
    triangle {
      < 1.292813, -0.692971, -2.523801>,
      < 1.292815, -0.695199, -2.537981>,
      < 1.237855, -0.675387, -2.545570>
    }
    triangle {
      < 1.292813, -0.692971, -2.523801>,
      < 1.237855, -0.675387, -2.545570>,
      < 1.237852, -0.671788, -2.522666>
    }
    triangle {
      < 1.237887, -0.730379, -2.581344>,
      < 1.237900, -0.752778, -2.575350>,
      < 1.139575, -0.761270, -2.591917>
    }
    triangle {
      < 1.237887, -0.730379, -2.581344>,
      < 1.139575, -0.761270, -2.591917>,
      < 1.139557, -0.731405, -2.599909>
    }
    triangle {
      < -0.482892, -0.732367, -2.599909>,
      < -0.482875, -0.762231, -2.591918>,
      < -0.399012, -0.750134, -2.568250>
    }
    triangle {
      < -0.482892, -0.732367, -2.599909>,
      < -0.399012, -0.750134, -2.568250>,
      < -0.399023, -0.730935, -2.573387>
    }
    triangle {
      < 1.237856, -0.677815, -2.500276>,
      < 1.237852, -0.671788, -2.522666>,
      < 1.139511, -0.653282, -2.521670>
    }
    triangle {
      < 1.237856, -0.677815, -2.500276>,
      < 1.139511, -0.653282, -2.521670>,
      < 1.139515, -0.661318, -2.491818>
    }
    triangle {
      < -0.482934, -0.662280, -2.491819>,
      < -0.482939, -0.654244, -2.521670>,
      < -0.399053, -0.680714, -2.523091>
    }
    triangle {
      < -0.482934, -0.662280, -2.491819>,
      < -0.399053, -0.680714, -2.523091>,
      < -0.399050, -0.685879, -2.503901>
    }
    triangle {
      < -0.399051, -0.683799, -2.542725>,
      < -0.399045, -0.694642, -2.559446>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < -0.399045, -0.694642, -2.559446>,
      < -0.399035, -0.711307, -2.570273>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < -0.399035, -0.711307, -2.570273>,
      < -0.399023, -0.730935, -2.573387>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < -0.399053, -0.680714, -2.523091>,
      < -0.399051, -0.683799, -2.542725>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.292835, -0.729242, -2.560126>,
      < 1.292843, -0.743107, -2.556417>,
      < 1.237900, -0.752778, -2.575350>
    }
    triangle {
      < 1.292835, -0.729242, -2.560126>,
      < 1.237900, -0.752778, -2.575350>,
      < 1.237887, -0.730379, -2.581344>
    }
    triangle {
      < 1.292816, -0.696701, -2.509941>,
      < 1.292813, -0.692971, -2.523801>,
      < 1.237852, -0.671788, -2.522666>
    }
    triangle {
      < 1.292816, -0.696701, -2.509941>,
      < 1.237852, -0.671788, -2.522666>,
      < 1.237856, -0.677815, -2.500276>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292827, -0.715066, -2.557877>,
      < 1.292819, -0.703030, -2.550057>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292819, -0.703030, -2.550057>,
      < 1.292815, -0.695199, -2.537981>
    }
    triangle {
      < -0.399023, -0.730935, -2.573387>,
      < -0.399012, -0.750134, -2.568250>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < -0.399050, -0.685879, -2.503901>,
      < -0.399053, -0.680714, -2.523091>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292835, -0.729242, -2.560126>,
      < 1.292827, -0.715066, -2.557877>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292815, -0.695199, -2.537981>,
      < 1.292813, -0.692971, -2.523801>
    }
    triangle {
      < -0.471301, -0.770656, -2.608485>,
      < -0.471283, -0.800698, -2.584178>,
      < -0.482861, -0.786264, -2.572473>
    }
    triangle {
      < -0.471301, -0.770656, -2.608485>,
      < -0.482861, -0.786264, -2.572473>,
      < -0.482875, -0.762231, -2.591918>
    }
    triangle {
      < 1.139575, -0.761270, -2.591917>,
      < 1.139589, -0.785303, -2.572473>,
      < 0.916907, -0.799876, -2.584178>
    }
    triangle {
      < 1.139575, -0.761270, -2.591917>,
      < 0.916907, -0.799876, -2.584178>,
      < 0.916890, -0.769834, -2.608484>
    }
    triangle {
      < -0.471361, -0.670069, -2.453354>,
      < -0.471375, -0.645718, -2.483360>,
      < -0.482934, -0.662280, -2.491819>
    }
    triangle {
      < -0.471361, -0.670069, -2.453354>,
      < -0.482934, -0.662280, -2.491819>,
      < -0.482923, -0.681760, -2.467813>
    }
    triangle {
      < 1.139527, -0.680799, -2.467813>,
      < 1.139515, -0.661318, -2.491818>,
      < 0.916816, -0.644896, -2.483360>
    }
    triangle {
      < 1.139527, -0.680799, -2.467813>,
      < 0.916816, -0.644896, -2.483360>,
      < 0.916830, -0.669246, -2.453354>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292843, -0.743107, -2.556417>,
      < 1.292835, -0.729242, -2.560126>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292813, -0.692971, -2.523801>,
      < 1.292816, -0.696701, -2.509941>
    }
    triangle {
      < 1.237900, -0.752778, -2.575350>,
      < 1.237910, -0.770803, -2.560766>,
      < 1.139589, -0.785303, -2.572473>
    }
    triangle {
      < 1.237900, -0.752778, -2.575350>,
      < 1.139589, -0.785303, -2.572473>,
      < 1.139575, -0.761270, -2.591917>
    }
    triangle {
      < -0.482875, -0.762231, -2.591918>,
      < -0.482861, -0.786264, -2.572473>,
      < -0.399002, -0.765584, -2.555750>
    }
    triangle {
      < -0.482875, -0.762231, -2.591918>,
      < -0.399002, -0.765584, -2.555750>,
      < -0.399012, -0.750134, -2.568250>
    }
    triangle {
      < 1.237864, -0.692424, -2.482272>,
      < 1.237856, -0.677815, -2.500276>,
      < 1.139515, -0.661318, -2.491818>
    }
    triangle {
      < 1.237864, -0.692424, -2.482272>,
      < 1.139515, -0.661318, -2.491818>,
      < 1.139527, -0.680799, -2.467813>
    }
    triangle {
      < -0.482923, -0.681760, -2.467813>,
      < -0.482934, -0.662280, -2.491819>,
      < -0.399050, -0.685879, -2.503901>
    }
    triangle {
      < -0.482923, -0.681760, -2.467813>,
      < -0.399050, -0.685879, -2.503901>,
      < -0.399043, -0.698403, -2.488470>
    }
    triangle {
      < 1.292843, -0.743107, -2.556417>,
      < 1.292850, -0.754266, -2.547389>,
      < 1.237910, -0.770803, -2.560766>
    }
    triangle {
      < 1.292843, -0.743107, -2.556417>,
      < 1.237910, -0.770803, -2.560766>,
      < 1.237900, -0.752778, -2.575350>
    }
    triangle {
      < 1.292821, -0.705747, -2.498797>,
      < 1.292816, -0.696701, -2.509941>,
      < 1.237856, -0.677815, -2.500276>
    }
    triangle {
      < 1.292821, -0.705747, -2.498797>,
      < 1.237856, -0.677815, -2.500276>,
      < 1.237864, -0.692424, -2.482272>
    }
    triangle {
      < -0.399012, -0.750134, -2.568250>,
      < -0.399002, -0.765584, -2.555750>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < -0.399043, -0.698403, -2.488470>,
      < -0.399050, -0.685879, -2.503901>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292850, -0.754266, -2.547389>,
      < 1.292843, -0.743107, -2.556417>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292816, -0.696701, -2.509941>,
      < 1.292821, -0.705747, -2.498797>
    }
    triangle {
      < -0.399032, -0.716119, -2.479464>,
      < -0.399043, -0.698403, -2.488470>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292854, -0.760789, -2.534604>,
      < 1.292850, -0.754266, -2.547389>
    }
    triangle {
      < -0.399020, -0.735967, -2.478442>,
      < -0.399032, -0.716119, -2.479464>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < -0.399001, -0.768557, -2.499642>,
      < -0.399010, -0.754514, -2.485579>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < -0.399010, -0.754514, -2.485579>,
      < -0.399020, -0.735967, -2.478442>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292845, -0.746271, -2.496710>,
      < 1.292851, -0.756413, -2.506866>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292821, -0.705747, -2.498797>,
      < 1.292828, -0.718541, -2.492293>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292828, -0.718541, -2.492293>,
      < 1.292837, -0.732876, -2.491554>
    }
    triangle {
      < -0.399002, -0.765584, -2.555750>,
      < -0.398997, -0.774616, -2.538047>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292854, -0.761548, -2.520270>,
      < 1.292854, -0.760789, -2.534604>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292837, -0.732876, -2.491554>,
      < 1.292845, -0.746271, -2.496710>
    }
    triangle {
      < -0.398997, -0.774616, -2.538047>,
      < -0.398997, -0.775667, -2.518201>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.339107, -0.727418, -2.525649>,
      < 1.292851, -0.756413, -2.506866>,
      < 1.292854, -0.761548, -2.520270>
    }
    triangle {
      < -0.398997, -0.775667, -2.518201>,
      < -0.399001, -0.768557, -2.499642>,
      < -0.381673, -0.728437, -2.525650>
    }
    triangle {
      < 1.292850, -0.754266, -2.547389>,
      < 1.292854, -0.760789, -2.534604>,
      < 1.237917, -0.781340, -2.540113>
    }
    triangle {
      < 1.292850, -0.754266, -2.547389>,
      < 1.237917, -0.781340, -2.540113>,
      < 1.237910, -0.770803, -2.560766>
    }
    triangle {
      < 1.292828, -0.718541, -2.492293>,
      < 1.292821, -0.705747, -2.498797>,
      < 1.237864, -0.692424, -2.482272>
    }
    triangle {
      < 1.292828, -0.718541, -2.492293>,
      < 1.237864, -0.692424, -2.482272>,
      < 1.237876, -0.713094, -2.471766>
    }
    triangle {
      < -0.482861, -0.786264, -2.572473>,
      < -0.482853, -0.800313, -2.544934>,
      < -0.398997, -0.774616, -2.538047>
    }
    triangle {
      < -0.482861, -0.786264, -2.572473>,
      < -0.398997, -0.774616, -2.538047>,
      < -0.399002, -0.765584, -2.555750>
    }
    triangle {
      < -0.482906, -0.709319, -2.453805>,
      < -0.482923, -0.681760, -2.467813>,
      < -0.399043, -0.698403, -2.488470>
    }
    triangle {
      < -0.482906, -0.709319, -2.453805>,
      < -0.399043, -0.698403, -2.488470>,
      < -0.399032, -0.716119, -2.479464>
    }
    triangle {
      < 1.237910, -0.770803, -2.560766>,
      < 1.237917, -0.781340, -2.540113>,
      < 1.139597, -0.799352, -2.544934>
    }
    triangle {
      < 1.237910, -0.770803, -2.560766>,
      < 1.139597, -0.799352, -2.544934>,
      < 1.139589, -0.785303, -2.572473>
    }
    triangle {
      < 1.237876, -0.713094, -2.471766>,
      < 1.237864, -0.692424, -2.482272>,
      < 1.139527, -0.680799, -2.467813>
    }
    triangle {
      < 1.237876, -0.713094, -2.471766>,
      < 1.139527, -0.680799, -2.467813>,
      < 1.139543, -0.708358, -2.453805>
    }
    triangle {
      < -0.471283, -0.800698, -2.584178>,
      < -0.471273, -0.818260, -2.549755>,
      < -0.482853, -0.800313, -2.544934>
    }
    triangle {
      < -0.471283, -0.800698, -2.584178>,
      < -0.482853, -0.800313, -2.544934>,
      < -0.482861, -0.786264, -2.572473>
    }
    triangle {
      < 1.139589, -0.785303, -2.572473>,
      < 1.139597, -0.799352, -2.544934>,
      < 0.916918, -0.817438, -2.549755>
    }
    triangle {
      < 1.139589, -0.785303, -2.572473>,
      < 0.916918, -0.817438, -2.549755>,
      < 0.916907, -0.799876, -2.584178>
    }
    triangle {
      < 1.139543, -0.708358, -2.453805>,
      < 1.139527, -0.680799, -2.467813>,
      < 0.916830, -0.669246, -2.453354>
    }
    triangle {
      < 1.139543, -0.708358, -2.453805>,
      < 0.916830, -0.669246, -2.453354>,
      < 0.916851, -0.703694, -2.435845>
    }
    triangle {
      < -0.471341, -0.704517, -2.435845>,
      < -0.471361, -0.670069, -2.453354>,
      < -0.482923, -0.681760, -2.467813>
    }
    triangle {
      < -0.471341, -0.704517, -2.435845>,
      < -0.482923, -0.681760, -2.467813>,
      < -0.482906, -0.709319, -2.453805>
    }
    triangle {
      < 1.292854, -0.760789, -2.534604>,
      < 1.292854, -0.761548, -2.520270>,
      < 1.237918, -0.782566, -2.516959>
    }
    triangle {
      < 1.292854, -0.760789, -2.534604>,
      < 1.237918, -0.782566, -2.516959>,
      < 1.237917, -0.781340, -2.540113>
    }
    triangle {
      < 1.292837, -0.732876, -2.491554>,
      < 1.292828, -0.718541, -2.492293>,
      < 1.237876, -0.713094, -2.471766>
    }
    triangle {
      < 1.292837, -0.732876, -2.491554>,
      < 1.237876, -0.713094, -2.471766>,
      < 1.237891, -0.736250, -2.470574>
    }
    triangle {
      < -0.482853, -0.800313, -2.544934>,
      < -0.482851, -0.801948, -2.514063>,
      < -0.398997, -0.775667, -2.518201>
    }
    triangle {
      < -0.482853, -0.800313, -2.544934>,
      < -0.398997, -0.775667, -2.518201>,
      < -0.398997, -0.774616, -2.538047>
    }
    triangle {
      < -0.482888, -0.740193, -2.452216>,
      < -0.482906, -0.709319, -2.453805>,
      < -0.399032, -0.716119, -2.479464>
    }
    triangle {
      < -0.482888, -0.740193, -2.452216>,
      < -0.399032, -0.716119, -2.479464>,
      < -0.399020, -0.735967, -2.478442>
    }
    triangle {
      < 1.237917, -0.781340, -2.540113>,
      < 1.237918, -0.782566, -2.516959>,
      < 1.139598, -0.800987, -2.514063>
    }
    triangle {
      < 1.237917, -0.781340, -2.540113>,
      < 1.139598, -0.800987, -2.514063>,
      < 1.139597, -0.799352, -2.544934>
    }
    triangle {
      < 1.292854, -0.761548, -2.520270>,
      < 1.292851, -0.756413, -2.506866>,
      < 1.237913, -0.774272, -2.495308>
    }
    triangle {
      < 1.292854, -0.761548, -2.520270>,
      < 1.237913, -0.774272, -2.495308>,
      < 1.237918, -0.782566, -2.516959>
    }
    triangle {
      < 1.237891, -0.736250, -2.470574>,
      < 1.237876, -0.713094, -2.471766>,
      < 1.139543, -0.708358, -2.453805>
    }
    triangle {
      < 1.237891, -0.736250, -2.470574>,
      < 1.139543, -0.708358, -2.453805>,
      < 1.139562, -0.739231, -2.452215>
    }
    triangle {
      < 1.292845, -0.746271, -2.496710>,
      < 1.292837, -0.732876, -2.491554>,
      < 1.237891, -0.736250, -2.470574>
    }
    triangle {
      < 1.292845, -0.746271, -2.496710>,
      < 1.237891, -0.736250, -2.470574>,
      < 1.237903, -0.757889, -2.478901>
    }
    triangle {
      < 1.292851, -0.756413, -2.506866>,
      < 1.292845, -0.746271, -2.496710>,
      < 1.237903, -0.757889, -2.478901>
    }
    triangle {
      < 1.292851, -0.756413, -2.506866>,
      < 1.237903, -0.757889, -2.478901>,
      < 1.237913, -0.774272, -2.495308>
    }
    triangle {
      < -0.471273, -0.818260, -2.549755>,
      < -0.471272, -0.820304, -2.511166>,
      < -0.482851, -0.801948, -2.514063>
    }
    triangle {
      < -0.471273, -0.818260, -2.549755>,
      < -0.482851, -0.801948, -2.514063>,
      < -0.482853, -0.800313, -2.544934>
    }
    triangle {
      < 1.139597, -0.799352, -2.544934>,
      < 1.139598, -0.800987, -2.514063>,
      < 0.916919, -0.819481, -2.511166>
    }
    triangle {
      < 1.139597, -0.799352, -2.544934>,
      < 0.916919, -0.819481, -2.511166>,
      < 0.916918, -0.817438, -2.549755>
    }
    triangle {
      < 1.139562, -0.739231, -2.452215>,
      < 1.139543, -0.708358, -2.453805>,
      < 0.916851, -0.703694, -2.435845>
    }
    triangle {
      < 1.139562, -0.739231, -2.452215>,
      < 0.916851, -0.703694, -2.435845>,
      < 0.916873, -0.742287, -2.433856>
    }
    triangle {
      < -0.471317, -0.743110, -2.433856>,
      < -0.471341, -0.704517, -2.435845>,
      < -0.482906, -0.709319, -2.453805>
    }
    triangle {
      < -0.471317, -0.743110, -2.433856>,
      < -0.482906, -0.709319, -2.453805>,
      < -0.482888, -0.740193, -2.452216>
    }
    triangle {
      < -0.482851, -0.801948, -2.514063>,
      < -0.482858, -0.790890, -2.485194>,
      < -0.399001, -0.768557, -2.499642>
    }
    triangle {
      < -0.482851, -0.801948, -2.514063>,
      < -0.399001, -0.768557, -2.499642>,
      < -0.398997, -0.775667, -2.518201>
    }
    triangle {
      < -0.482871, -0.769046, -2.463319>,
      < -0.482888, -0.740193, -2.452216>,
      < -0.399020, -0.735967, -2.478442>
    }
    triangle {
      < -0.482871, -0.769046, -2.463319>,
      < -0.399020, -0.735967, -2.478442>,
      < -0.399010, -0.754514, -2.485579>
    }
    triangle {
      < 1.237918, -0.782566, -2.516959>,
      < 1.237913, -0.774272, -2.495308>,
      < 1.139592, -0.789928, -2.485194>
    }
    triangle {
      < 1.237918, -0.782566, -2.516959>,
      < 1.139592, -0.789928, -2.485194>,
      < 1.139598, -0.800987, -2.514063>
    }
    triangle {
      < 1.237903, -0.757889, -2.478901>,
      < 1.237891, -0.736250, -2.470574>,
      < 1.139562, -0.739231, -2.452215>
    }
    triangle {
      < 1.237903, -0.757889, -2.478901>,
      < 1.139562, -0.739231, -2.452215>,
      < 1.139579, -0.768085, -2.463318>
    }
    triangle {
      < 0.916918, -0.817438, -2.549755>,
      < 0.916919, -0.819481, -2.511166>,
      < -0.471272, -0.820304, -2.511166>
    }
    triangle {
      < 0.916918, -0.817438, -2.549755>,
      < -0.471272, -0.820304, -2.511166>,
      < -0.471273, -0.818260, -2.549755>
    }
    triangle {
      < 0.916873, -0.742287, -2.433856>,
      < 0.916851, -0.703694, -2.435845>,
      < -0.471341, -0.704517, -2.435845>
    }
    triangle {
      < 0.916873, -0.742287, -2.433856>,
      < -0.471341, -0.704517, -2.435845>,
      < -0.471317, -0.743110, -2.433856>
    }
    triangle {
      < -0.482858, -0.790890, -2.485194>,
      < -0.482871, -0.769046, -2.463319>,
      < -0.399010, -0.754514, -2.485579>
    }
    triangle {
      < -0.482858, -0.790890, -2.485194>,
      < -0.399010, -0.754514, -2.485579>,
      < -0.399001, -0.768557, -2.499642>
    }
    triangle {
      < 1.237913, -0.774272, -2.495308>,
      < 1.237903, -0.757889, -2.478901>,
      < 1.139579, -0.768085, -2.463318>
    }
    triangle {
      < 1.237913, -0.774272, -2.495308>,
      < 1.139579, -0.768085, -2.463318>,
      < 1.139592, -0.789928, -2.485194>
    }
    triangle {
      < -0.471272, -0.820304, -2.511166>,
      < -0.471280, -0.806480, -2.475080>,
      < -0.482858, -0.790890, -2.485194>
    }
    triangle {
      < -0.471272, -0.820304, -2.511166>,
      < -0.482858, -0.790890, -2.485194>,
      < -0.482851, -0.801948, -2.514063>
    }
    triangle {
      < 1.139598, -0.800987, -2.514063>,
      < 1.139592, -0.789928, -2.485194>,
      < 0.916911, -0.805657, -2.475080>
    }
    triangle {
      < 1.139598, -0.800987, -2.514063>,
      < 0.916911, -0.805657, -2.475080>,
      < 0.916919, -0.819481, -2.511166>
    }
    triangle {
      < 1.139579, -0.768085, -2.463318>,
      < 1.139562, -0.739231, -2.452215>,
      < 0.916873, -0.742287, -2.433856>
    }
    triangle {
      < 1.139579, -0.768085, -2.463318>,
      < 0.916873, -0.742287, -2.433856>,
      < 0.916895, -0.778352, -2.447734>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < -0.471317, -0.743110, -2.433856>,
      < -0.482888, -0.740193, -2.452216>
    }
    triangle {
      < -0.471296, -0.779175, -2.447735>,
      < -0.482888, -0.740193, -2.452216>,
      < -0.482871, -0.769046, -2.463319>
    }
    triangle {
      < -0.471280, -0.806480, -2.475080>,
      < -0.471296, -0.779175, -2.447735>,
      < -0.482871, -0.769046, -2.463319>
    }
    triangle {
      < -0.471280, -0.806480, -2.475080>,
      < -0.482871, -0.769046, -2.463319>,
      < -0.482858, -0.790890, -2.485194>
    }
    triangle {
      < 1.139592, -0.789928, -2.485194>,
      < 1.139579, -0.768085, -2.463318>,
      < 0.916895, -0.778352, -2.447734>
    }
    triangle {
      < 1.139592, -0.789928, -2.485194>,
      < 0.916895, -0.778352, -2.447734>,
      < 0.916911, -0.805657, -2.475080>
    }
    triangle {
      < 0.916919, -0.819481, -2.511166>,
      < 0.916911, -0.805657, -2.475080>,
      < -0.471280, -0.806480, -2.475080>
    }
    triangle {
      < 0.916919, -0.819481, -2.511166>,
      < -0.471280, -0.806480, -2.475080>,
      < -0.471272, -0.820304, -2.511166>
    }
    triangle {
      < 0.916895, -0.778352, -2.447734>,
      < 0.916873, -0.742287, -2.433856>,
      < -0.471317, -0.743110, -2.433856>
    }
    triangle {
      < 0.916895, -0.778352, -2.447734>,
      < -0.471317, -0.743110, -2.433856>,
      < -0.471296, -0.779175, -2.447735>
    }
    triangle {
      < -0.290819, -0.693364, -1.370929>,
      < -0.254624, -0.863493, -1.219102>,
      < -0.254615, -0.876698, -1.227682>
    }
    triangle {
      < -0.290819, -0.693364, -1.370929>,
      < -0.254615, -0.876698, -1.227682>,
      < -0.290809, -0.711079, -1.388692>
    }
    triangle {
      < -0.290819, -0.693364, -1.370929>,
      < -0.254629, -0.854805, -1.205705>,
      < -0.254624, -0.863493, -1.219102>
    }
    triangle {
      < -0.446151, -0.711170, -1.388692>,
      < -0.446716, -0.863606, -1.219102>,
      < -0.446721, -0.854919, -1.205705>
    }
    triangle {
      < -0.446151, -0.711170, -1.388692>,
      < -0.446721, -0.854919, -1.205705>,
      < -0.446161, -0.693456, -1.370929>
    }
    triangle {
      < -0.446151, -0.711170, -1.388692>,
      < -0.446708, -0.876812, -1.227682>,
      < -0.446716, -0.863606, -1.219102>
    }
    triangle {
      < -0.446161, -0.693456, -1.370929>,
      < -0.446721, -0.854919, -1.205705>,
      < -0.254629, -0.854805, -1.205705>
    }
    triangle {
      < -0.446161, -0.693456, -1.370929>,
      < -0.254629, -0.854805, -1.205705>,
      < -0.290819, -0.693364, -1.370929>
    }
    triangle {
      < -0.290809, -0.711079, -1.388692>,
      < -0.254615, -0.876698, -1.227682>,
      < -0.446708, -0.876812, -1.227682>
    }
    triangle {
      < -0.290809, -0.711079, -1.388692>,
      < -0.446708, -0.876812, -1.227682>,
      < -0.446151, -0.711170, -1.388692>
    }
    triangle {
      < 0.488519, -0.820764, -1.239215>,
      < 0.519017, -0.863034, -1.219102>,
      < 0.521297, -0.876239, -1.227682>
    }
    triangle {
      < 0.488519, -0.820764, -1.239215>,
      < 0.521297, -0.876239, -1.227682>,
      < 0.488532, -0.842670, -1.261180>
    }
    triangle {
      < 0.488519, -0.820764, -1.239215>,
      < 0.521296, -0.854345, -1.205705>,
      < 0.519017, -0.863034, -1.219102>
    }
    triangle {
      < -0.217239, -0.711034, -1.388692>,
      < -0.163649, -0.863439, -1.219102>,
      < -0.163654, -0.854751, -1.205705>
    }
    triangle {
      < -0.217239, -0.711034, -1.388692>,
      < -0.163654, -0.854751, -1.205705>,
      < -0.217249, -0.693320, -1.370929>
    }
    triangle {
      < -0.217239, -0.711034, -1.388692>,
      < -0.163641, -0.876644, -1.227682>,
      < -0.163649, -0.863439, -1.219102>
    }
    triangle {
      < -0.217249, -0.693320, -1.370929>,
      < -0.163654, -0.854751, -1.205705>,
      < 0.521296, -0.854345, -1.205705>
    }
    triangle {
      < -0.217249, -0.693320, -1.370929>,
      < 0.521296, -0.854345, -1.205705>,
      < 0.488519, -0.820764, -1.239215>
    }
    triangle {
      < 0.488532, -0.842670, -1.261180>,
      < 0.521297, -0.876239, -1.227682>,
      < -0.163641, -0.876644, -1.227682>
    }
    triangle {
      < 0.488532, -0.842670, -1.261180>,
      < -0.163641, -0.876644, -1.227682>,
      < -0.217239, -0.711034, -1.388692>
    }
    triangle {
      < -0.290808, -0.711637, -0.917565>,
      < -0.254619, -0.870805, -1.081092>,
      < -0.254629, -0.854823, -1.100786>
    }
    triangle {
      < -0.290808, -0.711637, -0.917565>,
      < -0.254629, -0.854823, -1.100786>,
      < -0.290819, -0.693880, -0.935286>
    }
    triangle {
      < -0.290808, -0.711637, -0.917565>,
      < -0.254616, -0.876239, -1.078331>,
      < -0.254619, -0.870805, -1.081092>
    }
    triangle {
      < -0.446161, -0.693972, -0.935286>,
      < -0.446711, -0.870919, -1.081092>,
      < -0.446709, -0.876352, -1.078331>
    }
    triangle {
      < -0.446161, -0.693972, -0.935286>,
      < -0.446709, -0.876352, -1.078331>,
      < -0.446151, -0.711729, -0.917565>
    }
    triangle {
      < -0.446161, -0.693972, -0.935286>,
      < -0.446721, -0.854936, -1.100786>,
      < -0.446711, -0.870919, -1.081092>
    }
    triangle {
      < -0.446151, -0.711729, -0.917565>,
      < -0.446709, -0.876352, -1.078331>,
      < -0.254616, -0.876239, -1.078331>
    }
    triangle {
      < -0.446151, -0.711729, -0.917565>,
      < -0.254616, -0.876239, -1.078331>,
      < -0.290808, -0.711637, -0.917565>
    }
    triangle {
      < -0.290819, -0.693880, -0.935286>,
      < -0.254629, -0.854823, -1.100786>,
      < -0.446721, -0.854936, -1.100786>
    }
    triangle {
      < -0.290819, -0.693880, -0.935286>,
      < -0.446721, -0.854936, -1.100786>,
      < -0.446161, -0.693972, -0.935286>
    }
    triangle {
      < 0.488532, -0.842926, -1.045390>,
      < 0.519372, -0.870346, -1.081092>,
      < 0.521193, -0.854363, -1.100786>
    }
    triangle {
      < 0.488532, -0.842926, -1.045390>,
      < 0.521193, -0.854363, -1.100786>,
      < 0.488519, -0.820968, -1.067302>
    }
    triangle {
      < 0.488532, -0.842926, -1.045390>,
      < 0.520675, -0.875779, -1.078330>,
      < 0.519372, -0.870346, -1.081092>
    }
    triangle {
      < -0.217249, -0.693836, -0.935286>,
      < -0.163644, -0.870752, -1.081092>,
      < -0.163642, -0.876185, -1.078331>
    }
    triangle {
      < -0.217249, -0.693836, -0.935286>,
      < -0.163642, -0.876185, -1.078331>,
      < -0.217238, -0.711593, -0.917565>
    }
    triangle {
      < -0.217249, -0.693836, -0.935286>,
      < -0.163654, -0.854769, -1.100786>,
      < -0.163644, -0.870752, -1.081092>
    }
    triangle {
      < -0.217238, -0.711593, -0.917565>,
      < -0.163642, -0.876185, -1.078331>,
      < 0.520675, -0.875779, -1.078330>
    }
    triangle {
      < -0.217238, -0.711593, -0.917565>,
      < 0.520675, -0.875779, -1.078330>,
      < 0.488532, -0.842926, -1.045390>
    }
    triangle {
      < 0.488519, -0.820968, -1.067302>,
      < 0.521193, -0.854363, -1.100786>,
      < -0.163654, -0.854769, -1.100786>
    }
    triangle {
      < 0.488519, -0.820968, -1.067302>,
      < -0.163654, -0.854769, -1.100786>,
      < -0.217249, -0.693836, -0.935286>
    }
    triangle {
      < -0.290540, -1.165005, -0.935705>,
      < -0.254540, -1.004524, -1.100121>,
      < -0.254553, -0.982605, -1.078169>
    }
    triangle {
      < -0.290540, -1.165005, -0.935705>,
      < -0.254553, -0.982605, -1.078169>,
      < -0.290550, -1.147279, -0.917952>
    }
    triangle {
      < -0.445892, -1.147372, -0.917952>,
      < -0.446646, -0.982719, -1.078169>,
      < -0.446632, -1.004638, -1.100121>
    }
    triangle {
      < -0.445892, -1.147372, -0.917952>,
      < -0.446632, -1.004638, -1.100121>,
      < -0.445882, -1.165098, -0.935705>
    }
    triangle {
      < -0.445882, -1.165098, -0.935705>,
      < -0.446632, -1.004638, -1.100121>,
      < -0.254540, -1.004524, -1.100121>
    }
    triangle {
      < -0.445882, -1.165098, -0.935705>,
      < -0.254540, -1.004524, -1.100121>,
      < -0.290540, -1.165005, -0.935705>
    }
    triangle {
      < -0.290550, -1.147279, -0.917952>,
      < -0.254553, -0.982605, -1.078169>,
      < -0.446646, -0.982719, -1.078169>
    }
    triangle {
      < -0.290550, -1.147279, -0.917952>,
      < -0.446646, -0.982719, -1.078169>,
      < -0.445892, -1.147372, -0.917952>
    }
    triangle {
      < 0.488647, -1.036759, -1.067494>,
      < 0.520502, -1.004064, -1.100120>,
      < 0.520489, -0.982145, -1.078168>
    }
    triangle {
      < 0.488647, -1.036759, -1.067494>,
      < 0.520489, -0.982145, -1.078168>,
      < 0.488634, -1.014839, -1.045542>
    }
    triangle {
      < -0.216980, -1.147236, -0.917952>,
      < -0.163579, -0.982551, -1.078168>,
      < -0.163565, -1.004470, -1.100121>
    }
    triangle {
      < -0.216980, -1.147236, -0.917952>,
      < -0.163565, -1.004470, -1.100121>,
      < -0.216970, -1.164962, -0.935705>
    }
    triangle {
      < -0.216970, -1.164962, -0.935705>,
      < -0.163565, -1.004470, -1.100121>,
      < 0.520502, -1.004064, -1.100120>
    }
    triangle {
      < -0.216970, -1.164962, -0.935705>,
      < 0.520502, -1.004064, -1.100120>,
      < 0.488647, -1.036759, -1.067494>
    }
    triangle {
      < 0.488634, -1.014839, -1.045542>,
      < 0.520489, -0.982145, -1.078168>,
      < -0.163579, -0.982551, -1.078168>
    }
    triangle {
      < 0.488634, -1.014839, -1.045542>,
      < -0.163579, -0.982551, -1.078168>,
      < -0.216980, -1.147236, -0.917952>
    }
    triangle {
      < -0.290550, -1.147000, -1.389079>,
      < -0.254542, -1.001436, -1.211916>,
      < -0.254540, -1.004205, -1.206486>
    }
    triangle {
      < -0.290550, -1.147000, -1.389079>,
      < -0.254540, -1.004205, -1.206486>,
      < -0.290540, -1.164747, -1.371348>
    }
    triangle {
      < -0.290550, -1.147000, -1.389079>,
      < -0.254553, -0.981718, -1.227869>,
      < -0.254542, -1.001436, -1.211916>
    }
    triangle {
      < -0.445882, -1.164839, -1.371348>,
      < -0.446634, -1.001549, -1.211916>,
      < -0.446646, -0.981831, -1.227869>
    }
    triangle {
      < -0.445882, -1.164839, -1.371348>,
      < -0.446646, -0.981831, -1.227869>,
      < -0.445892, -1.147092, -1.389079>
    }
    triangle {
      < -0.445882, -1.164839, -1.371348>,
      < -0.446632, -1.004318, -1.206486>,
      < -0.446634, -1.001549, -1.211916>
    }
    triangle {
      < -0.445892, -1.147092, -1.389079>,
      < -0.446646, -0.981831, -1.227869>,
      < -0.254553, -0.981718, -1.227869>
    }
    triangle {
      < -0.445892, -1.147092, -1.389079>,
      < -0.254553, -0.981718, -1.227869>,
      < -0.290550, -1.147000, -1.389079>
    }
    triangle {
      < -0.290540, -1.164747, -1.371348>,
      < -0.254540, -1.004205, -1.206486>,
      < -0.446632, -1.004318, -1.206486>
    }
    triangle {
      < -0.290540, -1.164747, -1.371348>,
      < -0.446632, -1.004318, -1.206486>,
      < -0.445882, -1.164839, -1.371348>
    }
    triangle {
      < 0.488634, -1.014711, -1.261333>,
      < 0.519449, -1.000977, -1.211916>,
      < 0.520751, -1.003745, -1.206486>
    }
    triangle {
      < 0.488634, -1.014711, -1.261333>,
      < 0.520751, -1.003745, -1.206486>,
      < 0.488647, -1.036656, -1.239407>
    }
    triangle {
      < 0.488634, -1.014711, -1.261333>,
      < 0.521267, -0.981258, -1.227869>,
      < 0.519449, -1.000977, -1.211916>
    }
    triangle {
      < -0.216970, -1.164704, -1.371348>,
      < -0.163567, -1.001382, -1.211916>,
      < -0.163579, -0.981664, -1.227869>
    }
    triangle {
      < -0.216970, -1.164704, -1.371348>,
      < -0.163579, -0.981664, -1.227869>,
      < -0.216980, -1.146957, -1.389079>
    }
    triangle {
      < -0.216970, -1.164704, -1.371348>,
      < -0.163566, -1.004151, -1.206486>,
      < -0.163567, -1.001382, -1.211916>
    }
    triangle {
      < -0.216980, -1.146957, -1.389079>,
      < -0.163579, -0.981664, -1.227869>,
      < 0.521267, -0.981258, -1.227869>
    }
    triangle {
      < -0.216980, -1.146957, -1.389079>,
      < 0.521267, -0.981258, -1.227869>,
      < 0.488634, -1.014711, -1.261333>
    }
    triangle {
      < 0.488647, -1.036656, -1.239407>,
      < 0.520751, -1.003745, -1.206486>,
      < -0.163566, -1.004151, -1.206486>
    }
    triangle {
      < 0.488647, -1.036656, -1.239407>,
      < -0.163566, -1.004151, -1.206486>,
      < -0.216970, -1.164704, -1.371348>
    }
    triangle {
      < 0.488519, -0.820764, -1.239215>,
      < 0.488532, -0.842670, -1.261180>,
      < -0.217239, -0.711034, -1.388692>
    }
    triangle {
      < 0.488519, -0.820764, -1.239215>,
      < -0.217239, -0.711034, -1.388692>,
      < -0.217249, -0.693320, -1.370929>
    }
    triangle {
      < -0.290819, -0.693364, -1.370929>,
      < -0.290809, -0.711079, -1.388692>,
      < -0.446151, -0.711170, -1.388692>
    }
    triangle {
      < -0.290819, -0.693364, -1.370929>,
      < -0.446151, -0.711170, -1.388692>,
      < -0.446161, -0.693456, -1.370929>
    }
    triangle {
      < 0.488634, -1.014711, -1.261333>,
      < 0.488647, -1.036656, -1.239407>,
      < -0.216970, -1.164704, -1.371348>
    }
    triangle {
      < 0.488634, -1.014711, -1.261333>,
      < -0.216970, -1.164704, -1.371348>,
      < -0.216980, -1.146957, -1.389079>
    }
    triangle {
      < -0.290550, -1.147000, -1.389079>,
      < -0.290540, -1.164747, -1.371348>,
      < -0.445882, -1.164839, -1.371348>
    }
    triangle {
      < -0.290550, -1.147000, -1.389079>,
      < -0.445882, -1.164839, -1.371348>,
      < -0.445892, -1.147092, -1.389079>
    }
    triangle {
      < 0.488532, -0.842926, -1.045390>,
      < 0.488519, -0.820968, -1.067302>,
      < -0.217249, -0.693836, -0.935286>
    }
    triangle {
      < 0.488532, -0.842926, -1.045390>,
      < -0.217249, -0.693836, -0.935286>,
      < -0.217238, -0.711593, -0.917565>
    }
    triangle {
      < -0.290808, -0.711637, -0.917565>,
      < -0.290819, -0.693880, -0.935286>,
      < -0.446161, -0.693972, -0.935286>
    }
    triangle {
      < -0.290808, -0.711637, -0.917565>,
      < -0.446161, -0.693972, -0.935286>,
      < -0.446151, -0.711729, -0.917565>
    }
    triangle {
      < 0.488647, -1.036759, -1.067494>,
      < 0.488634, -1.014839, -1.045542>,
      < -0.216980, -1.147236, -0.917952>
    }
    triangle {
      < 0.488647, -1.036759, -1.067494>,
      < -0.216980, -1.147236, -0.917952>,
      < -0.216970, -1.164962, -0.935705>
    }
    triangle {
      < -0.290540, -1.165005, -0.935705>,
      < -0.290550, -1.147279, -0.917952>,
      < -0.445892, -1.147372, -0.917952>
    }
    triangle {
      < -0.290540, -1.165005, -0.935705>,
      < -0.445892, -1.147372, -0.917952>,
      < -0.445882, -1.165098, -0.935705>
    }
    triangle {
      < 0.916933, -0.841715, -1.186588>,
      < 0.521296, -0.854345, -1.205705>,
      < -0.163654, -0.854751, -1.205705>
    }
    triangle {
      < 0.916933, -0.841715, -1.186588>,
      < 0.916945, -0.862798, -1.219102>,
      < 0.519017, -0.863034, -1.219102>
    }
    triangle {
      < 0.916933, -0.841715, -1.186588>,
      < 0.519017, -0.863034, -1.219102>,
      < 0.521296, -0.854345, -1.205705>
    }
    triangle {
      < -0.254629, -0.854805, -1.205705>,
      < 0.916933, -0.841715, -1.186588>,
      < -0.163654, -0.854751, -1.205705>
    }
    triangle {
      < -0.163649, -0.863439, -1.219102>,
      < -0.254629, -0.854805, -1.205705>,
      < -0.163654, -0.854751, -1.205705>
    }
    triangle {
      < -0.254629, -0.854805, -1.205705>,
      < -0.446721, -0.854919, -1.205705>,
      < -0.471259, -0.842538, -1.186588>
    }
    triangle {
      < -0.254629, -0.854805, -1.205705>,
      < -0.471259, -0.842538, -1.186588>,
      < 0.916933, -0.841715, -1.186588>
    }
    triangle {
      < -0.446721, -0.854919, -1.205705>,
      < -0.446716, -0.863606, -1.219102>,
      < -0.471246, -0.863620, -1.219102>
    }
    triangle {
      < -0.446721, -0.854919, -1.205705>,
      < -0.471246, -0.863620, -1.219102>,
      < -0.471259, -0.842538, -1.186588>
    }
    triangle {
      < -0.163649, -0.863439, -1.219102>,
      < -0.254624, -0.863493, -1.219102>,
      < -0.254629, -0.854805, -1.205705>
    }
    triangle {
      < -0.471256, -0.846583, -1.111098>,
      < -0.446721, -0.854936, -1.100786>,
      < -0.254629, -0.854823, -1.100786>
    }
    triangle {
      < -0.471256, -0.846583, -1.111098>,
      < -0.471242, -0.870933, -1.081092>,
      < -0.446711, -0.870919, -1.081092>
    }
    triangle {
      < -0.471256, -0.846583, -1.111098>,
      < -0.446711, -0.870919, -1.081092>,
      < -0.446721, -0.854936, -1.100786>
    }
    triangle {
      < -0.163654, -0.854769, -1.100786>,
      < -0.471256, -0.846583, -1.111098>,
      < -0.254629, -0.854823, -1.100786>
    }
    triangle {
      < -0.254619, -0.870805, -1.081092>,
      < -0.163654, -0.854769, -1.100786>,
      < -0.254629, -0.854823, -1.100786>
    }
    triangle {
      < -0.163654, -0.854769, -1.100786>,
      < 0.521193, -0.854363, -1.100786>,
      < 0.916934, -0.845760, -1.111098>
    }
    triangle {
      < -0.163654, -0.854769, -1.100786>,
      < 0.916934, -0.845760, -1.111098>,
      < -0.471256, -0.846583, -1.111098>
    }
    triangle {
      < 0.521193, -0.854363, -1.100786>,
      < 0.519372, -0.870346, -1.081092>,
      < 0.916949, -0.870111, -1.081092>
    }
    triangle {
      < 0.521193, -0.854363, -1.100786>,
      < 0.916949, -0.870111, -1.081092>,
      < 0.916934, -0.845760, -1.111098>
    }
    triangle {
      < -0.254619, -0.870805, -1.081092>,
      < -0.163644, -0.870752, -1.081092>,
      < -0.163654, -0.854769, -1.100786>
    }
    triangle {
      < 0.916969, -0.904560, -1.063582>,
      < 0.520675, -0.875779, -1.078330>,
      < -0.163642, -0.876185, -1.078331>
    }
    triangle {
      < 0.916969, -0.904560, -1.063582>,
      < 0.916949, -0.870111, -1.081092>,
      < 0.519372, -0.870346, -1.081092>
    }
    triangle {
      < 0.916969, -0.904560, -1.063582>,
      < 0.519372, -0.870346, -1.081092>,
      < 0.520675, -0.875779, -1.078330>
    }
    triangle {
      < -0.254616, -0.876239, -1.078331>,
      < 0.916969, -0.904560, -1.063582>,
      < -0.163642, -0.876185, -1.078331>
    }
    triangle {
      < -0.163644, -0.870752, -1.081092>,
      < -0.254616, -0.876239, -1.078331>,
      < -0.163642, -0.876185, -1.078331>
    }
    triangle {
      < -0.254616, -0.876239, -1.078331>,
      < -0.446709, -0.876352, -1.078331>,
      < -0.471222, -0.905382, -1.063582>
    }
    triangle {
      < -0.254616, -0.876239, -1.078331>,
      < -0.471222, -0.905382, -1.063582>,
      < 0.916969, -0.904560, -1.063582>
    }
    triangle {
      < -0.446709, -0.876352, -1.078331>,
      < -0.446711, -0.870919, -1.081092>,
      < -0.471242, -0.870933, -1.081092>
    }
    triangle {
      < -0.446709, -0.876352, -1.078331>,
      < -0.471242, -0.870933, -1.081092>,
      < -0.471222, -0.905382, -1.063582>
    }
    triangle {
      < -0.163644, -0.870752, -1.081092>,
      < -0.254619, -0.870805, -1.081092>,
      < -0.254616, -0.876239, -1.078331>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < 0.520489, -0.982145, -1.078168>,
      < 0.917014, -0.979218, -1.075472>
    }
    triangle {
      < 0.520489, -0.982145, -1.078168>,
      < 0.520502, -1.004064, -1.100120>,
      < 0.917030, -1.006522, -1.102818>
    }
    triangle {
      < 0.520489, -0.982145, -1.078168>,
      < 0.917030, -1.006522, -1.102818>,
      < 0.917014, -0.979218, -1.075472>
    }
    triangle {
      < 0.520502, -1.004064, -1.100120>,
      < -0.163565, -1.004470, -1.100121>,
      < 0.917030, -1.006522, -1.102818>
    }
    triangle {
      < -0.163565, -1.004470, -1.100121>,
      < -0.254540, -1.004524, -1.100121>,
      < 0.917030, -1.006522, -1.102818>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < -0.163579, -0.982551, -1.078168>,
      < 0.520489, -0.982145, -1.078168>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < -0.254553, -0.982605, -1.078169>,
      < -0.163579, -0.982551, -1.078168>
    }
    triangle {
      < -0.254553, -0.982605, -1.078169>,
      < -0.163565, -1.004470, -1.100121>,
      < -0.163579, -0.982551, -1.078168>
    }
    triangle {
      < -0.254553, -0.982605, -1.078169>,
      < -0.254540, -1.004524, -1.100121>,
      < -0.163565, -1.004470, -1.100121>
    }
    triangle {
      < -0.254540, -1.004524, -1.100121>,
      < -0.446632, -1.004638, -1.100121>,
      < -0.471161, -1.007344, -1.102818>
    }
    triangle {
      < -0.254540, -1.004524, -1.100121>,
      < -0.471161, -1.007344, -1.102818>,
      < 0.917030, -1.006522, -1.102818>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < -0.446646, -0.982719, -1.078169>,
      < -0.254553, -0.982605, -1.078169>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < -0.446632, -1.004638, -1.100121>,
      < -0.446646, -0.982719, -1.078169>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < -0.471161, -1.007344, -1.102818>,
      < -0.446632, -1.004638, -1.100121>
    }
    triangle {
      < -0.471154, -1.019125, -1.177493>,
      < -0.446632, -1.004318, -1.206486>,
      < -0.254540, -1.004205, -1.206486>
    }
    triangle {
      < -0.471154, -1.019125, -1.177493>,
      < -0.471164, -1.001564, -1.211916>,
      < -0.446634, -1.001549, -1.211916>
    }
    triangle {
      < -0.471154, -1.019125, -1.177493>,
      < -0.446634, -1.001549, -1.211916>,
      < -0.446632, -1.004318, -1.206486>
    }
    triangle {
      < -0.163566, -1.004151, -1.206486>,
      < -0.471154, -1.019125, -1.177493>,
      < -0.254540, -1.004205, -1.206486>
    }
    triangle {
      < -0.254542, -1.001436, -1.211916>,
      < -0.163566, -1.004151, -1.206486>,
      < -0.254540, -1.004205, -1.206486>
    }
    triangle {
      < -0.163566, -1.004151, -1.206486>,
      < 0.520751, -1.003745, -1.206486>,
      < 0.917037, -1.018302, -1.177492>
    }
    triangle {
      < -0.163566, -1.004151, -1.206486>,
      < 0.917037, -1.018302, -1.177492>,
      < -0.471154, -1.019125, -1.177493>
    }
    triangle {
      < 0.520751, -1.003745, -1.206486>,
      < 0.519449, -1.000977, -1.211916>,
      < 0.917026, -1.000741, -1.211916>
    }
    triangle {
      < 0.520751, -1.003745, -1.206486>,
      < 0.917026, -1.000741, -1.211916>,
      < 0.917037, -1.018302, -1.177492>
    }
    triangle {
      < -0.254542, -1.001436, -1.211916>,
      < -0.163567, -1.001382, -1.211916>,
      < -0.163566, -1.004151, -1.206486>
    }
    triangle {
      < 0.917009, -0.970699, -1.236221>,
      < 0.521267, -0.981258, -1.227869>,
      < -0.163579, -0.981664, -1.227869>
    }
    triangle {
      < 0.917009, -0.970699, -1.236221>,
      < 0.917026, -1.000741, -1.211916>,
      < 0.519449, -1.000977, -1.211916>
    }
    triangle {
      < 0.917009, -0.970699, -1.236221>,
      < 0.519449, -1.000977, -1.211916>,
      < 0.521267, -0.981258, -1.227869>
    }
    triangle {
      < -0.254553, -0.981718, -1.227869>,
      < 0.917009, -0.970699, -1.236221>,
      < -0.163579, -0.981664, -1.227869>
    }
    triangle {
      < -0.163567, -1.001382, -1.211916>,
      < -0.254553, -0.981718, -1.227869>,
      < -0.163579, -0.981664, -1.227869>
    }
    triangle {
      < -0.254553, -0.981718, -1.227869>,
      < -0.446646, -0.981831, -1.227869>,
      < -0.471182, -0.971522, -1.236221>
    }
    triangle {
      < -0.254553, -0.981718, -1.227869>,
      < -0.471182, -0.971522, -1.236221>,
      < 0.917009, -0.970699, -1.236221>
    }
    triangle {
      < -0.446646, -0.981831, -1.227869>,
      < -0.446634, -1.001549, -1.211916>,
      < -0.471164, -1.001564, -1.211916>
    }
    triangle {
      < -0.446646, -0.981831, -1.227869>,
      < -0.471164, -1.001564, -1.211916>,
      < -0.471182, -0.971522, -1.236221>
    }
    triangle {
      < -0.163567, -1.001382, -1.211916>,
      < -0.254542, -1.001436, -1.211916>,
      < -0.254553, -0.981718, -1.227869>
    }
    triangle {
      < -0.471227, -0.896026, -1.240155>,
      < -0.446708, -0.876812, -1.227682>,
      < -0.254615, -0.876698, -1.227682>
    }
    triangle {
      < -0.471227, -0.896026, -1.240155>,
      < -0.471246, -0.863620, -1.219102>,
      < -0.446716, -0.863606, -1.219102>
    }
    triangle {
      < -0.471227, -0.896026, -1.240155>,
      < -0.446716, -0.863606, -1.219102>,
      < -0.446708, -0.876812, -1.227682>
    }
    triangle {
      < -0.163641, -0.876644, -1.227682>,
      < -0.471227, -0.896026, -1.240155>,
      < -0.254615, -0.876698, -1.227682>
    }
    triangle {
      < -0.254624, -0.863493, -1.219102>,
      < -0.163641, -0.876644, -1.227682>,
      < -0.254615, -0.876698, -1.227682>
    }
    triangle {
      < -0.163641, -0.876644, -1.227682>,
      < 0.521297, -0.876239, -1.227682>,
      < 0.916964, -0.895203, -1.240155>
    }
    triangle {
      < -0.163641, -0.876644, -1.227682>,
      < 0.916964, -0.895203, -1.240155>,
      < -0.471227, -0.896026, -1.240155>
    }
    triangle {
      < 0.521297, -0.876239, -1.227682>,
      < 0.519017, -0.863034, -1.219102>,
      < 0.916945, -0.862798, -1.219102>
    }
    triangle {
      < 0.521297, -0.876239, -1.227682>,
      < 0.916945, -0.862798, -1.219102>,
      < 0.916964, -0.895203, -1.240155>
    }
    triangle {
      < -0.254624, -0.863493, -1.219102>,
      < -0.163649, -0.863439, -1.219102>,
      < -0.163641, -0.876644, -1.227682>
    }
    triangle {
      < 1.139642, -0.875813, -1.205958>,
      < 1.139657, -0.901737, -1.222801>,
      < 0.916964, -0.895203, -1.240155>
    }
    triangle {
      < 1.139642, -0.875813, -1.205958>,
      < 0.916964, -0.895203, -1.240155>,
      < 0.916945, -0.862798, -1.219102>
    }
    triangle {
      < 1.139632, -0.858947, -1.179947>,
      < 1.139642, -0.875813, -1.205958>,
      < 0.916945, -0.862798, -1.219102>
    }
    triangle {
      < 1.139632, -0.858947, -1.179947>,
      < 0.916945, -0.862798, -1.219102>,
      < 0.916933, -0.841715, -1.186588>
    }
    triangle {
      < -0.471259, -0.842538, -1.186588>,
      < -0.471246, -0.863620, -1.219102>,
      < -0.482807, -0.876774, -1.205959>
    }
    triangle {
      < -0.471259, -0.842538, -1.186588>,
      < -0.482807, -0.876774, -1.205959>,
      < -0.482818, -0.859909, -1.179947>
    }
    triangle {
      < -0.471246, -0.863620, -1.219102>,
      < -0.471227, -0.896026, -1.240155>,
      < -0.482791, -0.902698, -1.222801>
    }
    triangle {
      < -0.471246, -0.863620, -1.219102>,
      < -0.482791, -0.902698, -1.222801>,
      < -0.482807, -0.876774, -1.205959>
    }
    triangle {
      < 0.916964, -0.895203, -1.240155>,
      < 0.916987, -0.933370, -1.246210>,
      < -0.471205, -0.934192, -1.246210>
    }
    triangle {
      < 0.916964, -0.895203, -1.240155>,
      < -0.471205, -0.934192, -1.246210>,
      < -0.471227, -0.896026, -1.240155>
    }
    triangle {
      < -0.471227, -0.896026, -1.240155>,
      < -0.471205, -0.934192, -1.246210>,
      < -0.482773, -0.933231, -1.227646>
    }
    triangle {
      < -0.471227, -0.896026, -1.240155>,
      < -0.482773, -0.933231, -1.227646>,
      < -0.482791, -0.902698, -1.222801>
    }
    triangle {
      < 1.139657, -0.901737, -1.222801>,
      < 1.139675, -0.932270, -1.227645>,
      < 0.916987, -0.933370, -1.246210>
    }
    triangle {
      < 1.139657, -0.901737, -1.222801>,
      < 0.916987, -0.933370, -1.246210>,
      < 0.916964, -0.895203, -1.240155>
    }
    triangle {
      < 0.916929, -0.835716, -1.148412>,
      < 0.916933, -0.841715, -1.186588>,
      < -0.471259, -0.842538, -1.186588>
    }
    triangle {
      < 0.916929, -0.835716, -1.148412>,
      < -0.471259, -0.842538, -1.186588>,
      < -0.471263, -0.836539, -1.148413>
    }
    triangle {
      < 1.139629, -0.854148, -1.149408>,
      < 1.139632, -0.858947, -1.179947>,
      < 0.916933, -0.841715, -1.186588>
    }
    triangle {
      < 1.139629, -0.854148, -1.149408>,
      < 0.916933, -0.841715, -1.186588>,
      < 0.916929, -0.835716, -1.148412>
    }
    triangle {
      < -0.471263, -0.836539, -1.148413>,
      < -0.471259, -0.842538, -1.186588>,
      < -0.482818, -0.859909, -1.179947>
    }
    triangle {
      < -0.471263, -0.836539, -1.148413>,
      < -0.482818, -0.859909, -1.179947>,
      < -0.482820, -0.855109, -1.149408>
    }
    triangle {
      < 1.237973, -0.876252, -1.173307>,
      < 1.237981, -0.888902, -1.192815>,
      < 1.139642, -0.875813, -1.205958>
    }
    triangle {
      < 1.237973, -0.876252, -1.173307>,
      < 1.139642, -0.875813, -1.205958>,
      < 1.139632, -0.858947, -1.179947>
    }
    triangle {
      < -0.482818, -0.859909, -1.179947>,
      < -0.482807, -0.876774, -1.205959>,
      < -0.398926, -0.895506, -1.187183>
    }
    triangle {
      < -0.482818, -0.859909, -1.179947>,
      < -0.398926, -0.895506, -1.187183>,
      < -0.398932, -0.884664, -1.170462>
    }
    triangle {
      < 1.237981, -0.888902, -1.192815>,
      < 1.237992, -0.908345, -1.205448>,
      < 1.139657, -0.901737, -1.222801>
    }
    triangle {
      < 1.237981, -0.888902, -1.192815>,
      < 1.139657, -0.901737, -1.222801>,
      < 1.139642, -0.875813, -1.205958>
    }
    triangle {
      < -0.482807, -0.876774, -1.205959>,
      < -0.482791, -0.902698, -1.222801>,
      < -0.398916, -0.912172, -1.198011>
    }
    triangle {
      < -0.482807, -0.876774, -1.205959>,
      < -0.398916, -0.912172, -1.198011>,
      < -0.398926, -0.895506, -1.187183>
    }
    triangle {
      < 1.237992, -0.908345, -1.205448>,
      < 1.238006, -0.931245, -1.209081>,
      < 1.139675, -0.932270, -1.227645>
    }
    triangle {
      < 1.237992, -0.908345, -1.205448>,
      < 1.139675, -0.932270, -1.227645>,
      < 1.139657, -0.901737, -1.222801>
    }
    triangle {
      < -0.482791, -0.902698, -1.222801>,
      < -0.482773, -0.933231, -1.227646>,
      < -0.398904, -0.931800, -1.201125>
    }
    triangle {
      < -0.482791, -0.902698, -1.222801>,
      < -0.398904, -0.931800, -1.201125>,
      < -0.398916, -0.912172, -1.198011>
    }
    triangle {
      < -0.482820, -0.855109, -1.149408>,
      < -0.482818, -0.859909, -1.179947>,
      < -0.398932, -0.884664, -1.170462>
    }
    triangle {
      < -0.482820, -0.855109, -1.149408>,
      < -0.398932, -0.884664, -1.170462>,
      < -0.398934, -0.881579, -1.150829>
    }
    triangle {
      < 1.237971, -0.872652, -1.150402>,
      < 1.237973, -0.876252, -1.173307>,
      < 1.139632, -0.858947, -1.179947>
    }
    triangle {
      < 1.237971, -0.872652, -1.150402>,
      < 1.139632, -0.858947, -1.179947>,
      < 1.139629, -0.854148, -1.149408>
    }
    triangle {
      < 1.139675, -0.932270, -1.227645>,
      < 1.139693, -0.962134, -1.219654>,
      < 0.917009, -0.970699, -1.236221>
    }
    triangle {
      < 1.139675, -0.932270, -1.227645>,
      < 0.917009, -0.970699, -1.236221>,
      < 0.916987, -0.933370, -1.246210>
    }
    triangle {
      < -0.471205, -0.934192, -1.246210>,
      < -0.471182, -0.971522, -1.236221>,
      < -0.482756, -0.963095, -1.219654>
    }
    triangle {
      < -0.471205, -0.934192, -1.246210>,
      < -0.482756, -0.963095, -1.219654>,
      < -0.482773, -0.933231, -1.227646>
    }
    triangle {
      < 0.916987, -0.933370, -1.246210>,
      < 0.917009, -0.970699, -1.236221>,
      < -0.471182, -0.971522, -1.236221>
    }
    triangle {
      < 0.916987, -0.933370, -1.246210>,
      < -0.471182, -0.971522, -1.236221>,
      < -0.471205, -0.934192, -1.246210>
    }
    triangle {
      < 1.139634, -0.862184, -1.119555>,
      < 1.139629, -0.854148, -1.149408>,
      < 0.916929, -0.835716, -1.148412>
    }
    triangle {
      < 1.139634, -0.862184, -1.119555>,
      < 0.916929, -0.835716, -1.148412>,
      < 0.916934, -0.845760, -1.111098>
    }
    triangle {
      < 0.916934, -0.845760, -1.111098>,
      < 0.916929, -0.835716, -1.148412>,
      < -0.471263, -0.836539, -1.148413>
    }
    triangle {
      < 0.916934, -0.845760, -1.111098>,
      < -0.471263, -0.836539, -1.148413>,
      < -0.471256, -0.846583, -1.111098>
    }
    triangle {
      < -0.471256, -0.846583, -1.111098>,
      < -0.471263, -0.836539, -1.148413>,
      < -0.482820, -0.855109, -1.149408>
    }
    triangle {
      < -0.471256, -0.846583, -1.111098>,
      < -0.482820, -0.855109, -1.149408>,
      < -0.482815, -0.863145, -1.119556>
    }
    triangle {
      < 1.292934, -0.896064, -1.165718>,
      < 1.292938, -0.903895, -1.177795>,
      < 1.237981, -0.888902, -1.192815>
    }
    triangle {
      < 1.292934, -0.896064, -1.165718>,
      < 1.237981, -0.888902, -1.192815>,
      < 1.237973, -0.876252, -1.173307>
    }
    triangle {
      < 1.292938, -0.903895, -1.177795>,
      < 1.292945, -0.915931, -1.185615>,
      < 1.237992, -0.908345, -1.205448>
    }
    triangle {
      < 1.292938, -0.903895, -1.177795>,
      < 1.237992, -0.908345, -1.205448>,
      < 1.237981, -0.888902, -1.192815>
    }
    triangle {
      < 1.292945, -0.915931, -1.185615>,
      < 1.292953, -0.930107, -1.187864>,
      < 1.238006, -0.931245, -1.209081>
    }
    triangle {
      < 1.292945, -0.915931, -1.185615>,
      < 1.238006, -0.931245, -1.209081>,
      < 1.237992, -0.908345, -1.205448>
    }
    triangle {
      < 1.292932, -0.893835, -1.151539>,
      < 1.292934, -0.896064, -1.165718>,
      < 1.237973, -0.876252, -1.173307>
    }
    triangle {
      < 1.292932, -0.893835, -1.151539>,
      < 1.237973, -0.876252, -1.173307>,
      < 1.237971, -0.872652, -1.150402>
    }
    triangle {
      < 1.238006, -0.931245, -1.209081>,
      < 1.238018, -0.953643, -1.203087>,
      < 1.139693, -0.962134, -1.219654>
    }
    triangle {
      < 1.238006, -0.931245, -1.209081>,
      < 1.139693, -0.962134, -1.219654>,
      < 1.139675, -0.932270, -1.227645>
    }
    triangle {
      < -0.482773, -0.933231, -1.227646>,
      < -0.482756, -0.963095, -1.219654>,
      < -0.398894, -0.950998, -1.195987>
    }
    triangle {
      < -0.482773, -0.933231, -1.227646>,
      < -0.398894, -0.950998, -1.195987>,
      < -0.398904, -0.931800, -1.201125>
    }
    triangle {
      < 1.237974, -0.878679, -1.128013>,
      < 1.237971, -0.872652, -1.150402>,
      < 1.139629, -0.854148, -1.149408>
    }
    triangle {
      < 1.237974, -0.878679, -1.128013>,
      < 1.139629, -0.854148, -1.149408>,
      < 1.139634, -0.862184, -1.119555>
    }
    triangle {
      < -0.482815, -0.863145, -1.119556>,
      < -0.482820, -0.855109, -1.149408>,
      < -0.398934, -0.881579, -1.150829>
    }
    triangle {
      < -0.482815, -0.863145, -1.119556>,
      < -0.398934, -0.881579, -1.150829>,
      < -0.398931, -0.886744, -1.131638>
    }
    triangle {
      < -0.398932, -0.884664, -1.170462>,
      < -0.398926, -0.895506, -1.187183>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < -0.398926, -0.895506, -1.187183>,
      < -0.398916, -0.912172, -1.198011>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < -0.398916, -0.912172, -1.198011>,
      < -0.398904, -0.931800, -1.201125>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < -0.398934, -0.881579, -1.150829>,
      < -0.398932, -0.884664, -1.170462>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.292953, -0.930107, -1.187864>,
      < 1.292962, -0.943972, -1.184154>,
      < 1.238018, -0.953643, -1.203087>
    }
    triangle {
      < 1.292953, -0.930107, -1.187864>,
      < 1.238018, -0.953643, -1.203087>,
      < 1.238006, -0.931245, -1.209081>
    }
    triangle {
      < 1.292935, -0.897566, -1.137679>,
      < 1.292932, -0.893835, -1.151539>,
      < 1.237971, -0.872652, -1.150402>
    }
    triangle {
      < 1.292935, -0.897566, -1.137679>,
      < 1.237971, -0.872652, -1.150402>,
      < 1.237974, -0.878679, -1.128013>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292945, -0.915931, -1.185615>,
      < 1.292938, -0.903895, -1.177795>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292938, -0.903895, -1.177795>,
      < 1.292934, -0.896064, -1.165718>
    }
    triangle {
      < -0.398904, -0.931800, -1.201125>,
      < -0.398894, -0.950998, -1.195987>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < -0.398931, -0.886744, -1.131638>,
      < -0.398934, -0.881579, -1.150829>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292953, -0.930107, -1.187864>,
      < 1.292945, -0.915931, -1.185615>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292934, -0.896064, -1.165718>,
      < 1.292932, -0.893835, -1.151539>
    }
    triangle {
      < -0.471182, -0.971522, -1.236221>,
      < -0.471164, -1.001564, -1.211916>,
      < -0.482742, -0.987129, -1.200210>
    }
    triangle {
      < -0.471182, -0.971522, -1.236221>,
      < -0.482742, -0.987129, -1.200210>,
      < -0.482756, -0.963095, -1.219654>
    }
    triangle {
      < 1.139693, -0.962134, -1.219654>,
      < 1.139708, -0.986168, -1.200210>,
      < 0.917026, -1.000741, -1.211916>
    }
    triangle {
      < 1.139693, -0.962134, -1.219654>,
      < 0.917026, -1.000741, -1.211916>,
      < 0.917009, -0.970699, -1.236221>
    }
    triangle {
      < -0.471242, -0.870933, -1.081092>,
      < -0.471256, -0.846583, -1.111098>,
      < -0.482815, -0.863145, -1.119556>
    }
    triangle {
      < -0.471242, -0.870933, -1.081092>,
      < -0.482815, -0.863145, -1.119556>,
      < -0.482804, -0.882625, -1.095550>
    }
    triangle {
      < 1.139646, -0.881664, -1.095550>,
      < 1.139634, -0.862184, -1.119555>,
      < 0.916934, -0.845760, -1.111098>
    }
    triangle {
      < 1.139646, -0.881664, -1.095550>,
      < 0.916934, -0.845760, -1.111098>,
      < 0.916949, -0.870111, -1.081092>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292962, -0.943972, -1.184154>,
      < 1.292953, -0.930107, -1.187864>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292932, -0.893835, -1.151539>,
      < 1.292935, -0.897566, -1.137679>
    }
    triangle {
      < 1.238018, -0.953643, -1.203087>,
      < 1.238029, -0.971668, -1.188503>,
      < 1.139708, -0.986168, -1.200210>
    }
    triangle {
      < 1.238018, -0.953643, -1.203087>,
      < 1.139708, -0.986168, -1.200210>,
      < 1.139693, -0.962134, -1.219654>
    }
    triangle {
      < -0.482756, -0.963095, -1.219654>,
      < -0.482742, -0.987129, -1.200210>,
      < -0.398884, -0.966449, -1.183487>
    }
    triangle {
      < -0.482756, -0.963095, -1.219654>,
      < -0.398884, -0.966449, -1.183487>,
      < -0.398894, -0.950998, -1.195987>
    }
    triangle {
      < 1.237983, -0.893290, -1.110009>,
      < 1.237974, -0.878679, -1.128013>,
      < 1.139634, -0.862184, -1.119555>
    }
    triangle {
      < 1.237983, -0.893290, -1.110009>,
      < 1.139634, -0.862184, -1.119555>,
      < 1.139646, -0.881664, -1.095550>
    }
    triangle {
      < -0.482804, -0.882625, -1.095550>,
      < -0.482815, -0.863145, -1.119556>,
      < -0.398931, -0.886744, -1.131638>
    }
    triangle {
      < -0.482804, -0.882625, -1.095550>,
      < -0.398931, -0.886744, -1.131638>,
      < -0.398924, -0.899267, -1.116207>
    }
    triangle {
      < 1.292962, -0.943972, -1.184154>,
      < 1.292969, -0.955130, -1.175125>,
      < 1.238029, -0.971668, -1.188503>
    }
    triangle {
      < 1.292962, -0.943972, -1.184154>,
      < 1.238029, -0.971668, -1.188503>,
      < 1.238018, -0.953643, -1.203087>
    }
    triangle {
      < 1.292940, -0.906611, -1.126534>,
      < 1.292935, -0.897566, -1.137679>,
      < 1.237974, -0.878679, -1.128013>
    }
    triangle {
      < 1.292940, -0.906611, -1.126534>,
      < 1.237974, -0.878679, -1.128013>,
      < 1.237983, -0.893290, -1.110009>
    }
    triangle {
      < -0.398894, -0.950998, -1.195987>,
      < -0.398884, -0.966449, -1.183487>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < -0.398924, -0.899267, -1.116207>,
      < -0.398931, -0.886744, -1.131638>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292969, -0.955130, -1.175125>,
      < 1.292962, -0.943972, -1.184154>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292935, -0.897566, -1.137679>,
      < 1.292940, -0.906611, -1.126534>
    }
    triangle {
      < -0.398913, -0.916984, -1.107201>,
      < -0.398924, -0.899267, -1.116207>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292972, -0.961654, -1.162340>,
      < 1.292969, -0.955130, -1.175125>
    }
    triangle {
      < -0.398902, -0.936832, -1.106179>,
      < -0.398913, -0.916984, -1.107201>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < -0.398882, -0.969422, -1.127379>,
      < -0.398891, -0.955380, -1.113316>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < -0.398891, -0.955380, -1.113316>,
      < -0.398902, -0.936832, -1.106179>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292963, -0.947136, -1.124447>,
      < 1.292970, -0.957278, -1.134604>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292940, -0.906611, -1.126534>,
      < 1.292947, -0.919407, -1.120030>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292947, -0.919407, -1.120030>,
      < 1.292955, -0.933740, -1.119291>
    }
    triangle {
      < -0.398884, -0.966449, -1.183487>,
      < -0.398878, -0.975480, -1.165784>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292972, -0.962413, -1.148007>,
      < 1.292972, -0.961654, -1.162340>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292955, -0.933740, -1.119291>,
      < 1.292963, -0.947136, -1.124447>
    }
    triangle {
      < -0.398878, -0.975480, -1.165784>,
      < -0.398878, -0.976532, -1.145939>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.339226, -0.928282, -1.153386>,
      < 1.292970, -0.957278, -1.134604>,
      < 1.292972, -0.962413, -1.148007>
    }
    triangle {
      < -0.398878, -0.976532, -1.145939>,
      < -0.398882, -0.969422, -1.127379>,
      < -0.381554, -0.929302, -1.153386>
    }
    triangle {
      < 1.292969, -0.955130, -1.175125>,
      < 1.292972, -0.961654, -1.162340>,
      < 1.238035, -0.982204, -1.167850>
    }
    triangle {
      < 1.292969, -0.955130, -1.175125>,
      < 1.238035, -0.982204, -1.167850>,
      < 1.238029, -0.971668, -1.188503>
    }
    triangle {
      < 1.292947, -0.919407, -1.120030>,
      < 1.292940, -0.906611, -1.126534>,
      < 1.237983, -0.893290, -1.110009>
    }
    triangle {
      < 1.292947, -0.919407, -1.120030>,
      < 1.237983, -0.893290, -1.110009>,
      < 1.237995, -0.913959, -1.099503>
    }
    triangle {
      < -0.482742, -0.987129, -1.200210>,
      < -0.482734, -1.001177, -1.172671>,
      < -0.398878, -0.975480, -1.165784>
    }
    triangle {
      < -0.482742, -0.987129, -1.200210>,
      < -0.398878, -0.975480, -1.165784>,
      < -0.398884, -0.966449, -1.183487>
    }
    triangle {
      < -0.482787, -0.910184, -1.081543>,
      < -0.482804, -0.882625, -1.095550>,
      < -0.398924, -0.899267, -1.116207>
    }
    triangle {
      < -0.482787, -0.910184, -1.081543>,
      < -0.398924, -0.899267, -1.116207>,
      < -0.398913, -0.916984, -1.107201>
    }
    triangle {
      < 1.238029, -0.971668, -1.188503>,
      < 1.238035, -0.982204, -1.167850>,
      < 1.139716, -1.000216, -1.172671>
    }
    triangle {
      < 1.238029, -0.971668, -1.188503>,
      < 1.139716, -1.000216, -1.172671>,
      < 1.139708, -0.986168, -1.200210>
    }
    triangle {
      < 1.237995, -0.913959, -1.099503>,
      < 1.237983, -0.893290, -1.110009>,
      < 1.139646, -0.881664, -1.095550>
    }
    triangle {
      < 1.237995, -0.913959, -1.099503>,
      < 1.139646, -0.881664, -1.095550>,
      < 1.139662, -0.909223, -1.081542>
    }
    triangle {
      < -0.471164, -1.001564, -1.211916>,
      < -0.471154, -1.019125, -1.177493>,
      < -0.482734, -1.001177, -1.172671>
    }
    triangle {
      < -0.471164, -1.001564, -1.211916>,
      < -0.482734, -1.001177, -1.172671>,
      < -0.482742, -0.987129, -1.200210>
    }
    triangle {
      < 1.139708, -0.986168, -1.200210>,
      < 1.139716, -1.000216, -1.172671>,
      < 0.917037, -1.018302, -1.177492>
    }
    triangle {
      < 1.139708, -0.986168, -1.200210>,
      < 0.917037, -1.018302, -1.177492>,
      < 0.917026, -1.000741, -1.211916>
    }
    triangle {
      < 1.139662, -0.909223, -1.081542>,
      < 1.139646, -0.881664, -1.095550>,
      < 0.916949, -0.870111, -1.081092>
    }
    triangle {
      < 1.139662, -0.909223, -1.081542>,
      < 0.916949, -0.870111, -1.081092>,
      < 0.916969, -0.904560, -1.063582>
    }
    triangle {
      < -0.471222, -0.905382, -1.063582>,
      < -0.471242, -0.870933, -1.081092>,
      < -0.482804, -0.882625, -1.095550>
    }
    triangle {
      < -0.471222, -0.905382, -1.063582>,
      < -0.482804, -0.882625, -1.095550>,
      < -0.482787, -0.910184, -1.081543>
    }
    triangle {
      < 1.292972, -0.961654, -1.162340>,
      < 1.292972, -0.962413, -1.148007>,
      < 1.238036, -0.983431, -1.144696>
    }
    triangle {
      < 1.292972, -0.961654, -1.162340>,
      < 1.238036, -0.983431, -1.144696>,
      < 1.238035, -0.982204, -1.167850>
    }
    triangle {
      < 1.292955, -0.933740, -1.119291>,
      < 1.292947, -0.919407, -1.120030>,
      < 1.237995, -0.913959, -1.099503>
    }
    triangle {
      < 1.292955, -0.933740, -1.119291>,
      < 1.237995, -0.913959, -1.099503>,
      < 1.238009, -0.937114, -1.098310>
    }
    triangle {
      < -0.482734, -1.001177, -1.172671>,
      < -0.482732, -1.002814, -1.141800>,
      < -0.398878, -0.976532, -1.145939>
    }
    triangle {
      < -0.482734, -1.001177, -1.172671>,
      < -0.398878, -0.976532, -1.145939>,
      < -0.398878, -0.975480, -1.165784>
    }
    triangle {
      < -0.482769, -0.941058, -1.079953>,
      < -0.482787, -0.910184, -1.081543>,
      < -0.398913, -0.916984, -1.107201>
    }
    triangle {
      < -0.482769, -0.941058, -1.079953>,
      < -0.398913, -0.916984, -1.107201>,
      < -0.398902, -0.936832, -1.106179>
    }
    triangle {
      < 1.238035, -0.982204, -1.167850>,
      < 1.238036, -0.983431, -1.144696>,
      < 1.139717, -1.001853, -1.141800>
    }
    triangle {
      < 1.238035, -0.982204, -1.167850>,
      < 1.139717, -1.001853, -1.141800>,
      < 1.139716, -1.000216, -1.172671>
    }
    triangle {
      < 1.292972, -0.962413, -1.148007>,
      < 1.292970, -0.957278, -1.134604>,
      < 1.238032, -0.975136, -1.123045>
    }
    triangle {
      < 1.292972, -0.962413, -1.148007>,
      < 1.238032, -0.975136, -1.123045>,
      < 1.238036, -0.983431, -1.144696>
    }
    triangle {
      < 1.238009, -0.937114, -1.098310>,
      < 1.237995, -0.913959, -1.099503>,
      < 1.139662, -0.909223, -1.081542>
    }
    triangle {
      < 1.238009, -0.937114, -1.098310>,
      < 1.139662, -0.909223, -1.081542>,
      < 1.139681, -0.940097, -1.079952>
    }
    triangle {
      < 1.292963, -0.947136, -1.124447>,
      < 1.292955, -0.933740, -1.119291>,
      < 1.238009, -0.937114, -1.098310>
    }
    triangle {
      < 1.292963, -0.947136, -1.124447>,
      < 1.238009, -0.937114, -1.098310>,
      < 1.238022, -0.958753, -1.106637>
    }
    triangle {
      < 1.292970, -0.957278, -1.134604>,
      < 1.292963, -0.947136, -1.124447>,
      < 1.238022, -0.958753, -1.106637>
    }
    triangle {
      < 1.292970, -0.957278, -1.134604>,
      < 1.238022, -0.958753, -1.106637>,
      < 1.238032, -0.975136, -1.123045>
    }
    triangle {
      < -0.471154, -1.019125, -1.177493>,
      < -0.471153, -1.021169, -1.138903>,
      < -0.482732, -1.002814, -1.141800>
    }
    triangle {
      < -0.471154, -1.019125, -1.177493>,
      < -0.482732, -1.002814, -1.141800>,
      < -0.482734, -1.001177, -1.172671>
    }
    triangle {
      < 1.139716, -1.000216, -1.172671>,
      < 1.139717, -1.001853, -1.141800>,
      < 0.917038, -1.020347, -1.138903>
    }
    triangle {
      < 1.139716, -1.000216, -1.172671>,
      < 0.917038, -1.020347, -1.138903>,
      < 0.917037, -1.018302, -1.177492>
    }
    triangle {
      < 1.139681, -0.940097, -1.079952>,
      < 1.139662, -0.909223, -1.081542>,
      < 0.916969, -0.904560, -1.063582>
    }
    triangle {
      < 1.139681, -0.940097, -1.079952>,
      < 0.916969, -0.904560, -1.063582>,
      < 0.916992, -0.943152, -1.061593>
    }
    triangle {
      < -0.471199, -0.943975, -1.061594>,
      < -0.471222, -0.905382, -1.063582>,
      < -0.482787, -0.910184, -1.081543>
    }
    triangle {
      < -0.471199, -0.943975, -1.061594>,
      < -0.482787, -0.910184, -1.081543>,
      < -0.482769, -0.941058, -1.079953>
    }
    triangle {
      < -0.482732, -1.002814, -1.141800>,
      < -0.482739, -0.991754, -1.112931>,
      < -0.398882, -0.969422, -1.127379>
    }
    triangle {
      < -0.482732, -1.002814, -1.141800>,
      < -0.398882, -0.969422, -1.127379>,
      < -0.398878, -0.976532, -1.145939>
    }
    triangle {
      < -0.482752, -0.969910, -1.091056>,
      < -0.482769, -0.941058, -1.079953>,
      < -0.398902, -0.936832, -1.106179>
    }
    triangle {
      < -0.482752, -0.969910, -1.091056>,
      < -0.398902, -0.936832, -1.106179>,
      < -0.398891, -0.955380, -1.113316>
    }
    triangle {
      < 1.238036, -0.983431, -1.144696>,
      < 1.238032, -0.975136, -1.123045>,
      < 1.139711, -0.990793, -1.112931>
    }
    triangle {
      < 1.238036, -0.983431, -1.144696>,
      < 1.139711, -0.990793, -1.112931>,
      < 1.139717, -1.001853, -1.141800>
    }
    triangle {
      < 1.238022, -0.958753, -1.106637>,
      < 1.238009, -0.937114, -1.098310>,
      < 1.139681, -0.940097, -1.079952>
    }
    triangle {
      < 1.238022, -0.958753, -1.106637>,
      < 1.139681, -0.940097, -1.079952>,
      < 1.139697, -0.968949, -1.091055>
    }
    triangle {
      < 0.917037, -1.018302, -1.177492>,
      < 0.917038, -1.020347, -1.138903>,
      < -0.471153, -1.021169, -1.138903>
    }
    triangle {
      < 0.917037, -1.018302, -1.177492>,
      < -0.471153, -1.021169, -1.138903>,
      < -0.471154, -1.019125, -1.177493>
    }
    triangle {
      < 0.916992, -0.943152, -1.061593>,
      < 0.916969, -0.904560, -1.063582>,
      < -0.471222, -0.905382, -1.063582>
    }
    triangle {
      < 0.916992, -0.943152, -1.061593>,
      < -0.471222, -0.905382, -1.063582>,
      < -0.471199, -0.943975, -1.061594>
    }
    triangle {
      < -0.482739, -0.991754, -1.112931>,
      < -0.482752, -0.969910, -1.091056>,
      < -0.398891, -0.955380, -1.113316>
    }
    triangle {
      < -0.482739, -0.991754, -1.112931>,
      < -0.398891, -0.955380, -1.113316>,
      < -0.398882, -0.969422, -1.127379>
    }
    triangle {
      < 1.238032, -0.975136, -1.123045>,
      < 1.238022, -0.958753, -1.106637>,
      < 1.139697, -0.968949, -1.091055>
    }
    triangle {
      < 1.238032, -0.975136, -1.123045>,
      < 1.139697, -0.968949, -1.091055>,
      < 1.139711, -0.990793, -1.112931>
    }
    triangle {
      < -0.471153, -1.021169, -1.138903>,
      < -0.471161, -1.007344, -1.102818>,
      < -0.482739, -0.991754, -1.112931>
    }
    triangle {
      < -0.471153, -1.021169, -1.138903>,
      < -0.482739, -0.991754, -1.112931>,
      < -0.482732, -1.002814, -1.141800>
    }
    triangle {
      < 1.139717, -1.001853, -1.141800>,
      < 1.139711, -0.990793, -1.112931>,
      < 0.917030, -1.006522, -1.102818>
    }
    triangle {
      < 1.139717, -1.001853, -1.141800>,
      < 0.917030, -1.006522, -1.102818>,
      < 0.917038, -1.020347, -1.138903>
    }
    triangle {
      < 1.139697, -0.968949, -1.091055>,
      < 1.139681, -0.940097, -1.079952>,
      < 0.916992, -0.943152, -1.061593>
    }
    triangle {
      < 1.139697, -0.968949, -1.091055>,
      < 0.916992, -0.943152, -1.061593>,
      < 0.917014, -0.979218, -1.075472>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < -0.471199, -0.943975, -1.061594>,
      < -0.482769, -0.941058, -1.079953>
    }
    triangle {
      < -0.471177, -0.980040, -1.075472>,
      < -0.482769, -0.941058, -1.079953>,
      < -0.482752, -0.969910, -1.091056>
    }
    triangle {
      < -0.471161, -1.007344, -1.102818>,
      < -0.471177, -0.980040, -1.075472>,
      < -0.482752, -0.969910, -1.091056>
    }
    triangle {
      < -0.471161, -1.007344, -1.102818>,
      < -0.482752, -0.969910, -1.091056>,
      < -0.482739, -0.991754, -1.112931>
    }
    triangle {
      < 1.139711, -0.990793, -1.112931>,
      < 1.139697, -0.968949, -1.091055>,
      < 0.917014, -0.979218, -1.075472>
    }
    triangle {
      < 1.139711, -0.990793, -1.112931>,
      < 0.917014, -0.979218, -1.075472>,
      < 0.917030, -1.006522, -1.102818>
    }
    triangle {
      < 0.917038, -1.020347, -1.138903>,
      < 0.917030, -1.006522, -1.102818>,
      < -0.471161, -1.007344, -1.102818>
    }
    triangle {
      < 0.917038, -1.020347, -1.138903>,
      < -0.471161, -1.007344, -1.102818>,
      < -0.471153, -1.021169, -1.138903>
    }
    triangle {
      < 0.917014, -0.979218, -1.075472>,
      < 0.916992, -0.943152, -1.061593>,
      < -0.471199, -0.943975, -1.061594>
    }
    triangle {
      < 0.917014, -0.979218, -1.075472>,
      < -0.471199, -0.943975, -1.061594>,
      < -0.471177, -0.980040, -1.075472>
    }
    triangle {
      < -0.307225, -0.493006, -1.698174>,
      < -0.271030, -0.663136, -1.546347>,
      < -0.271021, -0.676342, -1.554927>
    }
    triangle {
      < -0.307225, -0.493006, -1.698174>,
      < -0.271021, -0.676342, -1.554927>,
      < -0.307214, -0.510721, -1.715936>
    }
    triangle {
      < -0.307225, -0.493006, -1.698174>,
      < -0.271035, -0.654448, -1.532949>,
      < -0.271030, -0.663136, -1.546347>
    }
    triangle {
      < -0.462557, -0.510814, -1.715936>,
      < -0.463122, -0.663249, -1.546347>,
      < -0.463127, -0.654562, -1.532949>
    }
    triangle {
      < -0.462557, -0.510814, -1.715936>,
      < -0.463127, -0.654562, -1.532949>,
      < -0.462568, -0.493099, -1.698174>
    }
    triangle {
      < -0.462557, -0.510814, -1.715936>,
      < -0.463114, -0.676455, -1.554927>,
      < -0.463122, -0.663249, -1.546347>
    }
    triangle {
      < -0.462568, -0.493099, -1.698174>,
      < -0.463127, -0.654562, -1.532949>,
      < -0.271035, -0.654448, -1.532949>
    }
    triangle {
      < -0.462568, -0.493099, -1.698174>,
      < -0.271035, -0.654448, -1.532949>,
      < -0.307225, -0.493006, -1.698174>
    }
    triangle {
      < -0.307214, -0.510721, -1.715936>,
      < -0.271021, -0.676342, -1.554927>,
      < -0.463114, -0.676455, -1.554927>
    }
    triangle {
      < -0.307214, -0.510721, -1.715936>,
      < -0.463114, -0.676455, -1.554927>,
      < -0.462557, -0.510814, -1.715936>
    }
    triangle {
      < 0.472114, -0.620408, -1.566460>,
      < 0.502611, -0.662677, -1.546346>,
      < 0.504892, -0.675882, -1.554926>
    }
    triangle {
      < 0.472114, -0.620408, -1.566460>,
      < 0.504892, -0.675882, -1.554926>,
      < 0.472126, -0.642313, -1.588424>
    }
    triangle {
      < 0.472114, -0.620408, -1.566460>,
      < 0.504891, -0.653989, -1.532949>,
      < 0.502611, -0.662677, -1.546346>
    }
    triangle {
      < -0.233644, -0.510678, -1.715936>,
      < -0.180054, -0.663082, -1.546346>,
      < -0.180059, -0.654394, -1.532949>
    }
    triangle {
      < -0.233644, -0.510678, -1.715936>,
      < -0.180059, -0.654394, -1.532949>,
      < -0.233654, -0.492963, -1.698174>
    }
    triangle {
      < -0.233644, -0.510678, -1.715936>,
      < -0.180046, -0.676288, -1.554927>,
      < -0.180054, -0.663082, -1.546346>
    }
    triangle {
      < -0.233654, -0.492963, -1.698174>,
      < -0.180059, -0.654394, -1.532949>,
      < 0.504891, -0.653989, -1.532949>
    }
    triangle {
      < -0.233654, -0.492963, -1.698174>,
      < 0.504891, -0.653989, -1.532949>,
      < 0.472114, -0.620408, -1.566460>
    }
    triangle {
      < 0.472126, -0.642313, -1.588424>,
      < 0.504892, -0.675882, -1.554926>,
      < -0.180046, -0.676288, -1.554927>
    }
    triangle {
      < 0.472126, -0.642313, -1.588424>,
      < -0.180046, -0.676288, -1.554927>,
      < -0.233644, -0.510678, -1.715936>
    }
    triangle {
      < -0.307214, -0.511279, -1.244810>,
      < -0.271025, -0.670449, -1.408337>,
      < -0.271035, -0.654466, -1.428031>
    }
    triangle {
      < -0.307214, -0.511279, -1.244810>,
      < -0.271035, -0.654466, -1.428031>,
      < -0.307225, -0.493521, -1.262531>
    }
    triangle {
      < -0.307214, -0.511279, -1.244810>,
      < -0.271022, -0.675882, -1.405575>,
      < -0.271025, -0.670449, -1.408337>
    }
    triangle {
      < -0.462568, -0.493614, -1.262531>,
      < -0.463117, -0.670562, -1.408337>,
      < -0.463115, -0.675995, -1.405575>
    }
    triangle {
      < -0.462568, -0.493614, -1.262531>,
      < -0.463115, -0.675995, -1.405575>,
      < -0.462557, -0.511372, -1.244810>
    }
    triangle {
      < -0.462568, -0.493614, -1.262531>,
      < -0.463127, -0.654579, -1.428031>,
      < -0.463117, -0.670562, -1.408337>
    }
    triangle {
      < -0.462557, -0.511372, -1.244810>,
      < -0.463115, -0.675995, -1.405575>,
      < -0.271022, -0.675882, -1.405575>
    }
    triangle {
      < -0.462557, -0.511372, -1.244810>,
      < -0.271022, -0.675882, -1.405575>,
      < -0.307214, -0.511279, -1.244810>
    }
    triangle {
      < -0.307225, -0.493521, -1.262531>,
      < -0.271035, -0.654466, -1.428031>,
      < -0.463127, -0.654579, -1.428031>
    }
    triangle {
      < -0.307225, -0.493521, -1.262531>,
      < -0.463127, -0.654579, -1.428031>,
      < -0.462568, -0.493614, -1.262531>
    }
    triangle {
      < 0.472127, -0.642569, -1.372634>,
      < 0.502967, -0.669990, -1.408336>,
      < 0.504787, -0.654006, -1.428031>
    }
    triangle {
      < 0.472127, -0.642569, -1.372634>,
      < 0.504787, -0.654006, -1.428031>,
      < 0.472114, -0.620611, -1.394547>
    }
    triangle {
      < 0.472127, -0.642569, -1.372634>,
      < 0.504269, -0.675422, -1.405575>,
      < 0.502967, -0.669990, -1.408336>
    }
    triangle {
      < -0.233654, -0.493478, -1.262531>,
      < -0.180049, -0.670395, -1.408337>,
      < -0.180047, -0.675828, -1.405575>
    }
    triangle {
      < -0.233654, -0.493478, -1.262531>,
      < -0.180047, -0.675828, -1.405575>,
      < -0.233644, -0.511236, -1.244810>
    }
    triangle {
      < -0.233654, -0.493478, -1.262531>,
      < -0.180059, -0.654412, -1.428031>,
      < -0.180049, -0.670395, -1.408337>
    }
    triangle {
      < -0.233644, -0.511236, -1.244810>,
      < -0.180047, -0.675828, -1.405575>,
      < 0.504269, -0.675422, -1.405575>
    }
    triangle {
      < -0.233644, -0.511236, -1.244810>,
      < 0.504269, -0.675422, -1.405575>,
      < 0.472127, -0.642569, -1.372634>
    }
    triangle {
      < 0.472114, -0.620611, -1.394547>,
      < 0.504787, -0.654006, -1.428031>,
      < -0.180059, -0.654412, -1.428031>
    }
    triangle {
      < 0.472114, -0.620611, -1.394547>,
      < -0.180059, -0.654412, -1.428031>,
      < -0.233654, -0.493478, -1.262531>
    }
    triangle {
      < -0.306946, -0.964649, -1.262949>,
      < -0.270946, -0.804168, -1.427365>,
      < -0.270959, -0.782248, -1.405413>
    }
    triangle {
      < -0.306946, -0.964649, -1.262949>,
      < -0.270959, -0.782248, -1.405413>,
      < -0.306956, -0.946922, -1.245197>
    }
    triangle {
      < -0.462299, -0.947015, -1.245197>,
      < -0.463052, -0.782362, -1.405413>,
      < -0.463038, -0.804281, -1.427365>
    }
    triangle {
      < -0.462299, -0.947015, -1.245197>,
      < -0.463038, -0.804281, -1.427365>,
      < -0.462289, -0.964741, -1.262949>
    }
    triangle {
      < -0.462289, -0.964741, -1.262949>,
      < -0.463038, -0.804281, -1.427365>,
      < -0.270946, -0.804168, -1.427365>
    }
    triangle {
      < -0.462289, -0.964741, -1.262949>,
      < -0.270946, -0.804168, -1.427365>,
      < -0.306946, -0.964649, -1.262949>
    }
    triangle {
      < -0.306956, -0.946922, -1.245197>,
      < -0.270959, -0.782248, -1.405413>,
      < -0.463052, -0.782362, -1.405413>
    }
    triangle {
      < -0.306956, -0.946922, -1.245197>,
      < -0.463052, -0.782362, -1.405413>,
      < -0.462299, -0.947015, -1.245197>
    }
    triangle {
      < 0.472242, -0.836401, -1.394739>,
      < 0.504096, -0.803708, -1.427365>,
      < 0.504083, -0.781788, -1.405413>
    }
    triangle {
      < 0.472242, -0.836401, -1.394739>,
      < 0.504083, -0.781788, -1.405413>,
      < 0.472229, -0.814482, -1.372787>
    }
    triangle {
      < -0.233385, -0.946879, -1.245197>,
      < -0.179984, -0.782194, -1.405413>,
      < -0.179970, -0.804114, -1.427365>
    }
    triangle {
      < -0.233385, -0.946879, -1.245197>,
      < -0.179970, -0.804114, -1.427365>,
      < -0.233375, -0.964605, -1.262949>
    }
    triangle {
      < -0.233375, -0.964605, -1.262949>,
      < -0.179970, -0.804114, -1.427365>,
      < 0.504096, -0.803708, -1.427365>
    }
    triangle {
      < -0.233375, -0.964605, -1.262949>,
      < 0.504096, -0.803708, -1.427365>,
      < 0.472242, -0.836401, -1.394739>
    }
    triangle {
      < 0.472229, -0.814482, -1.372787>,
      < 0.504083, -0.781788, -1.405413>,
      < -0.179984, -0.782194, -1.405413>
    }
    triangle {
      < 0.472229, -0.814482, -1.372787>,
      < -0.179984, -0.782194, -1.405413>,
      < -0.233385, -0.946879, -1.245197>
    }
    triangle {
      < -0.306956, -0.946643, -1.716324>,
      < -0.270948, -0.801079, -1.539160>,
      < -0.270946, -0.803847, -1.533731>
    }
    triangle {
      < -0.306956, -0.946643, -1.716324>,
      < -0.270946, -0.803847, -1.533731>,
      < -0.306946, -0.964390, -1.698593>
    }
    triangle {
      < -0.306956, -0.946643, -1.716324>,
      < -0.270959, -0.781361, -1.555113>,
      < -0.270948, -0.801079, -1.539160>
    }
    triangle {
      < -0.462289, -0.964483, -1.698593>,
      < -0.463040, -0.801192, -1.539160>,
      < -0.463052, -0.781474, -1.555113>
    }
    triangle {
      < -0.462289, -0.964483, -1.698593>,
      < -0.463052, -0.781474, -1.555113>,
      < -0.462299, -0.946736, -1.716324>
    }
    triangle {
      < -0.462289, -0.964483, -1.698593>,
      < -0.463038, -0.803962, -1.533731>,
      < -0.463040, -0.801192, -1.539160>
    }
    triangle {
      < -0.462299, -0.946736, -1.716324>,
      < -0.463052, -0.781474, -1.555113>,
      < -0.270959, -0.781361, -1.555113>
    }
    triangle {
      < -0.462299, -0.946736, -1.716324>,
      < -0.270959, -0.781361, -1.555113>,
      < -0.306956, -0.946643, -1.716324>
    }
    triangle {
      < -0.306946, -0.964390, -1.698593>,
      < -0.270946, -0.803847, -1.533731>,
      < -0.463038, -0.803962, -1.533731>
    }
    triangle {
      < -0.306946, -0.964390, -1.698593>,
      < -0.463038, -0.803962, -1.533731>,
      < -0.462289, -0.964483, -1.698593>
    }
    triangle {
      < 0.472229, -0.814355, -1.588577>,
      < 0.503044, -0.800620, -1.539160>,
      < 0.504345, -0.803388, -1.533731>
    }
    triangle {
      < 0.472229, -0.814355, -1.588577>,
      < 0.504345, -0.803388, -1.533731>,
      < 0.472242, -0.836300, -1.566652>
    }
    triangle {
      < 0.472229, -0.814355, -1.588577>,
      < 0.504862, -0.780901, -1.555113>,
      < 0.503044, -0.800620, -1.539160>
    }
    triangle {
      < -0.233375, -0.964347, -1.698593>,
      < -0.179972, -0.801025, -1.539160>,
      < -0.179984, -0.781307, -1.555113>
    }
    triangle {
      < -0.233375, -0.964347, -1.698593>,
      < -0.179984, -0.781307, -1.555113>,
      < -0.233385, -0.946600, -1.716324>
    }
    triangle {
      < -0.233375, -0.964347, -1.698593>,
      < -0.179970, -0.803794, -1.533731>,
      < -0.179972, -0.801025, -1.539160>
    }
    triangle {
      < -0.233385, -0.946600, -1.716324>,
      < -0.179984, -0.781307, -1.555113>,
      < 0.504862, -0.780901, -1.555113>
    }
    triangle {
      < -0.233385, -0.946600, -1.716324>,
      < 0.504862, -0.780901, -1.555113>,
      < 0.472229, -0.814355, -1.588577>
    }
    triangle {
      < 0.472242, -0.836300, -1.566652>,
      < 0.504345, -0.803388, -1.533731>,
      < -0.179970, -0.803794, -1.533731>
    }
    triangle {
      < 0.472242, -0.836300, -1.566652>,
      < -0.179970, -0.803794, -1.533731>,
      < -0.233375, -0.964347, -1.698593>
    }
    triangle {
      < 0.472114, -0.620408, -1.566460>,
      < 0.472126, -0.642313, -1.588424>,
      < -0.233644, -0.510678, -1.715936>
    }
    triangle {
      < 0.472114, -0.620408, -1.566460>,
      < -0.233644, -0.510678, -1.715936>,
      < -0.233654, -0.492963, -1.698174>
    }
    triangle {
      < -0.307225, -0.493006, -1.698174>,
      < -0.307214, -0.510721, -1.715936>,
      < -0.462557, -0.510814, -1.715936>
    }
    triangle {
      < -0.307225, -0.493006, -1.698174>,
      < -0.462557, -0.510814, -1.715936>,
      < -0.462568, -0.493099, -1.698174>
    }
    triangle {
      < 0.472229, -0.814355, -1.588577>,
      < 0.472242, -0.836300, -1.566652>,
      < -0.233375, -0.964347, -1.698593>
    }
    triangle {
      < 0.472229, -0.814355, -1.588577>,
      < -0.233375, -0.964347, -1.698593>,
      < -0.233385, -0.946600, -1.716324>
    }
    triangle {
      < -0.306956, -0.946643, -1.716324>,
      < -0.306946, -0.964390, -1.698593>,
      < -0.462289, -0.964483, -1.698593>
    }
    triangle {
      < -0.306956, -0.946643, -1.716324>,
      < -0.462289, -0.964483, -1.698593>,
      < -0.462299, -0.946736, -1.716324>
    }
    triangle {
      < 0.472127, -0.642569, -1.372634>,
      < 0.472114, -0.620611, -1.394547>,
      < -0.233654, -0.493478, -1.262531>
    }
    triangle {
      < 0.472127, -0.642569, -1.372634>,
      < -0.233654, -0.493478, -1.262531>,
      < -0.233644, -0.511236, -1.244810>
    }
    triangle {
      < -0.307214, -0.511279, -1.244810>,
      < -0.307225, -0.493521, -1.262531>,
      < -0.462568, -0.493614, -1.262531>
    }
    triangle {
      < -0.307214, -0.511279, -1.244810>,
      < -0.462568, -0.493614, -1.262531>,
      < -0.462557, -0.511372, -1.244810>
    }
    triangle {
      < 0.472242, -0.836401, -1.394739>,
      < 0.472229, -0.814482, -1.372787>,
      < -0.233385, -0.946879, -1.245197>
    }
    triangle {
      < 0.472242, -0.836401, -1.394739>,
      < -0.233385, -0.946879, -1.245197>,
      < -0.233375, -0.964605, -1.262949>
    }
    triangle {
      < -0.306946, -0.964649, -1.262949>,
      < -0.306956, -0.946922, -1.245197>,
      < -0.462299, -0.947015, -1.245197>
    }
    triangle {
      < -0.306946, -0.964649, -1.262949>,
      < -0.462299, -0.947015, -1.245197>,
      < -0.462289, -0.964741, -1.262949>
    }
    triangle {
      < 0.900527, -0.641358, -1.513832>,
      < 0.504891, -0.653989, -1.532949>,
      < -0.180059, -0.654394, -1.532949>
    }
    triangle {
      < 0.900527, -0.641358, -1.513832>,
      < 0.900540, -0.662441, -1.546346>,
      < 0.502611, -0.662677, -1.546346>
    }
    triangle {
      < 0.900527, -0.641358, -1.513832>,
      < 0.502611, -0.662677, -1.546346>,
      < 0.504891, -0.653989, -1.532949>
    }
    triangle {
      < -0.271035, -0.654448, -1.532949>,
      < 0.900527, -0.641358, -1.513832>,
      < -0.180059, -0.654394, -1.532949>
    }
    triangle {
      < -0.180054, -0.663082, -1.546346>,
      < -0.271035, -0.654448, -1.532949>,
      < -0.180059, -0.654394, -1.532949>
    }
    triangle {
      < -0.271035, -0.654448, -1.532949>,
      < -0.463127, -0.654562, -1.532949>,
      < -0.487665, -0.642181, -1.513832>
    }
    triangle {
      < -0.271035, -0.654448, -1.532949>,
      < -0.487665, -0.642181, -1.513832>,
      < 0.900527, -0.641358, -1.513832>
    }
    triangle {
      < -0.463127, -0.654562, -1.532949>,
      < -0.463122, -0.663249, -1.546347>,
      < -0.487652, -0.663264, -1.546347>
    }
    triangle {
      < -0.463127, -0.654562, -1.532949>,
      < -0.487652, -0.663264, -1.546347>,
      < -0.487665, -0.642181, -1.513832>
    }
    triangle {
      < -0.180054, -0.663082, -1.546346>,
      < -0.271030, -0.663136, -1.546347>,
      < -0.271035, -0.654448, -1.532949>
    }
    triangle {
      < -0.487662, -0.646226, -1.438342>,
      < -0.463127, -0.654579, -1.428031>,
      < -0.271035, -0.654466, -1.428031>
    }
    triangle {
      < -0.487662, -0.646226, -1.438342>,
      < -0.487648, -0.670576, -1.408337>,
      < -0.463117, -0.670562, -1.408337>
    }
    triangle {
      < -0.487662, -0.646226, -1.438342>,
      < -0.463117, -0.670562, -1.408337>,
      < -0.463127, -0.654579, -1.428031>
    }
    triangle {
      < -0.180059, -0.654412, -1.428031>,
      < -0.487662, -0.646226, -1.438342>,
      < -0.271035, -0.654466, -1.428031>
    }
    triangle {
      < -0.271025, -0.670449, -1.408337>,
      < -0.180059, -0.654412, -1.428031>,
      < -0.271035, -0.654466, -1.428031>
    }
    triangle {
      < -0.180059, -0.654412, -1.428031>,
      < 0.504787, -0.654006, -1.428031>,
      < 0.900529, -0.645404, -1.438342>
    }
    triangle {
      < -0.180059, -0.654412, -1.428031>,
      < 0.900529, -0.645404, -1.438342>,
      < -0.487662, -0.646226, -1.438342>
    }
    triangle {
      < 0.504787, -0.654006, -1.428031>,
      < 0.502967, -0.669990, -1.408336>,
      < 0.900544, -0.669754, -1.408336>
    }
    triangle {
      < 0.504787, -0.654006, -1.428031>,
      < 0.900544, -0.669754, -1.408336>,
      < 0.900529, -0.645404, -1.438342>
    }
    triangle {
      < -0.271025, -0.670449, -1.408337>,
      < -0.180049, -0.670395, -1.408337>,
      < -0.180059, -0.654412, -1.428031>
    }
    triangle {
      < 0.900564, -0.704203, -1.390826>,
      < 0.504269, -0.675422, -1.405575>,
      < -0.180047, -0.675828, -1.405575>
    }
    triangle {
      < 0.900564, -0.704203, -1.390826>,
      < 0.900544, -0.669754, -1.408336>,
      < 0.502967, -0.669990, -1.408336>
    }
    triangle {
      < 0.900564, -0.704203, -1.390826>,
      < 0.502967, -0.669990, -1.408336>,
      < 0.504269, -0.675422, -1.405575>
    }
    triangle {
      < -0.271022, -0.675882, -1.405575>,
      < 0.900564, -0.704203, -1.390826>,
      < -0.180047, -0.675828, -1.405575>
    }
    triangle {
      < -0.180049, -0.670395, -1.408337>,
      < -0.271022, -0.675882, -1.405575>,
      < -0.180047, -0.675828, -1.405575>
    }
    triangle {
      < -0.271022, -0.675882, -1.405575>,
      < -0.463115, -0.675995, -1.405575>,
      < -0.487627, -0.705025, -1.390826>
    }
    triangle {
      < -0.271022, -0.675882, -1.405575>,
      < -0.487627, -0.705025, -1.390826>,
      < 0.900564, -0.704203, -1.390826>
    }
    triangle {
      < -0.463115, -0.675995, -1.405575>,
      < -0.463117, -0.670562, -1.408337>,
      < -0.487648, -0.670576, -1.408337>
    }
    triangle {
      < -0.463115, -0.675995, -1.405575>,
      < -0.487648, -0.670576, -1.408337>,
      < -0.487627, -0.705025, -1.390826>
    }
    triangle {
      < -0.180049, -0.670395, -1.408337>,
      < -0.271025, -0.670449, -1.408337>,
      < -0.271022, -0.675882, -1.405575>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < 0.504083, -0.781788, -1.405413>,
      < 0.900608, -0.778861, -1.402717>
    }
    triangle {
      < 0.504083, -0.781788, -1.405413>,
      < 0.504096, -0.803708, -1.427365>,
      < 0.900625, -0.806165, -1.430062>
    }
    triangle {
      < 0.504083, -0.781788, -1.405413>,
      < 0.900625, -0.806165, -1.430062>,
      < 0.900608, -0.778861, -1.402717>
    }
    triangle {
      < 0.504096, -0.803708, -1.427365>,
      < -0.179970, -0.804114, -1.427365>,
      < 0.900625, -0.806165, -1.430062>
    }
    triangle {
      < -0.179970, -0.804114, -1.427365>,
      < -0.270946, -0.804168, -1.427365>,
      < 0.900625, -0.806165, -1.430062>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < -0.179984, -0.782194, -1.405413>,
      < 0.504083, -0.781788, -1.405413>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < -0.270959, -0.782248, -1.405413>,
      < -0.179984, -0.782194, -1.405413>
    }
    triangle {
      < -0.270959, -0.782248, -1.405413>,
      < -0.179970, -0.804114, -1.427365>,
      < -0.179984, -0.782194, -1.405413>
    }
    triangle {
      < -0.270959, -0.782248, -1.405413>,
      < -0.270946, -0.804168, -1.427365>,
      < -0.179970, -0.804114, -1.427365>
    }
    triangle {
      < -0.270946, -0.804168, -1.427365>,
      < -0.463038, -0.804281, -1.427365>,
      < -0.487567, -0.806987, -1.430062>
    }
    triangle {
      < -0.270946, -0.804168, -1.427365>,
      < -0.487567, -0.806987, -1.430062>,
      < 0.900625, -0.806165, -1.430062>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < -0.463052, -0.782362, -1.405413>,
      < -0.270959, -0.782248, -1.405413>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < -0.463038, -0.804281, -1.427365>,
      < -0.463052, -0.782362, -1.405413>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < -0.487567, -0.806987, -1.430062>,
      < -0.463038, -0.804281, -1.427365>
    }
    triangle {
      < -0.487561, -0.818768, -1.504737>,
      < -0.463038, -0.803962, -1.533731>,
      < -0.270946, -0.803847, -1.533731>
    }
    triangle {
      < -0.487561, -0.818768, -1.504737>,
      < -0.487570, -0.801207, -1.539160>,
      < -0.463040, -0.801192, -1.539160>
    }
    triangle {
      < -0.487561, -0.818768, -1.504737>,
      < -0.463040, -0.801192, -1.539160>,
      < -0.463038, -0.803962, -1.533731>
    }
    triangle {
      < -0.179970, -0.803794, -1.533731>,
      < -0.487561, -0.818768, -1.504737>,
      < -0.270946, -0.803847, -1.533731>
    }
    triangle {
      < -0.270948, -0.801079, -1.539160>,
      < -0.179970, -0.803794, -1.533731>,
      < -0.270946, -0.803847, -1.533731>
    }
    triangle {
      < -0.179970, -0.803794, -1.533731>,
      < 0.504345, -0.803388, -1.533731>,
      < 0.900632, -0.817945, -1.504737>
    }
    triangle {
      < -0.179970, -0.803794, -1.533731>,
      < 0.900632, -0.817945, -1.504737>,
      < -0.487561, -0.818768, -1.504737>
    }
    triangle {
      < 0.504345, -0.803388, -1.533731>,
      < 0.503044, -0.800620, -1.539160>,
      < 0.900621, -0.800384, -1.539160>
    }
    triangle {
      < 0.504345, -0.803388, -1.533731>,
      < 0.900621, -0.800384, -1.539160>,
      < 0.900632, -0.817945, -1.504737>
    }
    triangle {
      < -0.270948, -0.801079, -1.539160>,
      < -0.179972, -0.801025, -1.539160>,
      < -0.179970, -0.803794, -1.533731>
    }
    triangle {
      < 0.900604, -0.770342, -1.563467>,
      < 0.504862, -0.780901, -1.555113>,
      < -0.179984, -0.781307, -1.555113>
    }
    triangle {
      < 0.900604, -0.770342, -1.563467>,
      < 0.900621, -0.800384, -1.539160>,
      < 0.503044, -0.800620, -1.539160>
    }
    triangle {
      < 0.900604, -0.770342, -1.563467>,
      < 0.503044, -0.800620, -1.539160>,
      < 0.504862, -0.780901, -1.555113>
    }
    triangle {
      < -0.270959, -0.781361, -1.555113>,
      < 0.900604, -0.770342, -1.563467>,
      < -0.179984, -0.781307, -1.555113>
    }
    triangle {
      < -0.179972, -0.801025, -1.539160>,
      < -0.270959, -0.781361, -1.555113>,
      < -0.179984, -0.781307, -1.555113>
    }
    triangle {
      < -0.270959, -0.781361, -1.555113>,
      < -0.463052, -0.781474, -1.555113>,
      < -0.487588, -0.771165, -1.563467>
    }
    triangle {
      < -0.270959, -0.781361, -1.555113>,
      < -0.487588, -0.771165, -1.563467>,
      < 0.900604, -0.770342, -1.563467>
    }
    triangle {
      < -0.463052, -0.781474, -1.555113>,
      < -0.463040, -0.801192, -1.539160>,
      < -0.487570, -0.801207, -1.539160>
    }
    triangle {
      < -0.463052, -0.781474, -1.555113>,
      < -0.487570, -0.801207, -1.539160>,
      < -0.487588, -0.771165, -1.563467>
    }
    triangle {
      < -0.179972, -0.801025, -1.539160>,
      < -0.270948, -0.801079, -1.539160>,
      < -0.270959, -0.781361, -1.555113>
    }
    triangle {
      < -0.487633, -0.695668, -1.567400>,
      < -0.463114, -0.676455, -1.554927>,
      < -0.271021, -0.676342, -1.554927>
    }
    triangle {
      < -0.487633, -0.695668, -1.567400>,
      < -0.487652, -0.663264, -1.546347>,
      < -0.463122, -0.663249, -1.546347>
    }
    triangle {
      < -0.487633, -0.695668, -1.567400>,
      < -0.463122, -0.663249, -1.546347>,
      < -0.463114, -0.676455, -1.554927>
    }
    triangle {
      < -0.180046, -0.676288, -1.554927>,
      < -0.487633, -0.695668, -1.567400>,
      < -0.271021, -0.676342, -1.554927>
    }
    triangle {
      < -0.271030, -0.663136, -1.546347>,
      < -0.180046, -0.676288, -1.554927>,
      < -0.271021, -0.676342, -1.554927>
    }
    triangle {
      < -0.180046, -0.676288, -1.554927>,
      < 0.504892, -0.675882, -1.554926>,
      < 0.900559, -0.694845, -1.567400>
    }
    triangle {
      < -0.180046, -0.676288, -1.554927>,
      < 0.900559, -0.694845, -1.567400>,
      < -0.487633, -0.695668, -1.567400>
    }
    triangle {
      < 0.504892, -0.675882, -1.554926>,
      < 0.502611, -0.662677, -1.546346>,
      < 0.900540, -0.662441, -1.546346>
    }
    triangle {
      < 0.504892, -0.675882, -1.554926>,
      < 0.900540, -0.662441, -1.546346>,
      < 0.900559, -0.694845, -1.567400>
    }
    triangle {
      < -0.271030, -0.663136, -1.546347>,
      < -0.180054, -0.663082, -1.546346>,
      < -0.180046, -0.676288, -1.554927>
    }
    triangle {
      < 1.123236, -0.675455, -1.533204>,
      < 1.123251, -0.701379, -1.550045>,
      < 0.900559, -0.694845, -1.567400>
    }
    triangle {
      < 1.123236, -0.675455, -1.533204>,
      < 0.900559, -0.694845, -1.567400>,
      < 0.900540, -0.662441, -1.546346>
    }
    triangle {
      < 1.123226, -0.658591, -1.507192>,
      < 1.123236, -0.675455, -1.533204>,
      < 0.900540, -0.662441, -1.546346>
    }
    triangle {
      < 1.123226, -0.658591, -1.507192>,
      < 0.900540, -0.662441, -1.546346>,
      < 0.900527, -0.641358, -1.513832>
    }
    triangle {
      < -0.487665, -0.642181, -1.513832>,
      < -0.487652, -0.663264, -1.546347>,
      < -0.499213, -0.676417, -1.533204>
    }
    triangle {
      < -0.487665, -0.642181, -1.513832>,
      < -0.499213, -0.676417, -1.533204>,
      < -0.499223, -0.659552, -1.507192>
    }
    triangle {
      < -0.487652, -0.663264, -1.546347>,
      < -0.487633, -0.695668, -1.567400>,
      < -0.499198, -0.702341, -1.550045>
    }
    triangle {
      < -0.487652, -0.663264, -1.546347>,
      < -0.499198, -0.702341, -1.550045>,
      < -0.499213, -0.676417, -1.533204>
    }
    triangle {
      < 0.900559, -0.694845, -1.567400>,
      < 0.900581, -0.733013, -1.573455>,
      < -0.487611, -0.733835, -1.573455>
    }
    triangle {
      < 0.900559, -0.694845, -1.567400>,
      < -0.487611, -0.733835, -1.573455>,
      < -0.487633, -0.695668, -1.567400>
    }
    triangle {
      < -0.487633, -0.695668, -1.567400>,
      < -0.487611, -0.733835, -1.573455>,
      < -0.499180, -0.732874, -1.554890>
    }
    triangle {
      < -0.487633, -0.695668, -1.567400>,
      < -0.499180, -0.732874, -1.554890>,
      < -0.499198, -0.702341, -1.550045>
    }
    triangle {
      < 1.123251, -0.701379, -1.550045>,
      < 1.123270, -0.731912, -1.554890>,
      < 0.900581, -0.733013, -1.573455>
    }
    triangle {
      < 1.123251, -0.701379, -1.550045>,
      < 0.900581, -0.733013, -1.573455>,
      < 0.900559, -0.694845, -1.567400>
    }
    triangle {
      < 0.900524, -0.635359, -1.475657>,
      < 0.900527, -0.641358, -1.513832>,
      < -0.487665, -0.642181, -1.513832>
    }
    triangle {
      < 0.900524, -0.635359, -1.475657>,
      < -0.487665, -0.642181, -1.513832>,
      < -0.487669, -0.636182, -1.475657>
    }
    triangle {
      < 1.123223, -0.653790, -1.476652>,
      < 1.123226, -0.658591, -1.507192>,
      < 0.900527, -0.641358, -1.513832>
    }
    triangle {
      < 1.123223, -0.653790, -1.476652>,
      < 0.900527, -0.641358, -1.513832>,
      < 0.900524, -0.635359, -1.475657>
    }
    triangle {
      < -0.487669, -0.636182, -1.475657>,
      < -0.487665, -0.642181, -1.513832>,
      < -0.499223, -0.659552, -1.507192>
    }
    triangle {
      < -0.487669, -0.636182, -1.475657>,
      < -0.499223, -0.659552, -1.507192>,
      < -0.499226, -0.654752, -1.476653>
    }
    triangle {
      < 1.221567, -0.675895, -1.500551>,
      < 1.221575, -0.688545, -1.520061>,
      < 1.123236, -0.675455, -1.533204>
    }
    triangle {
      < 1.221567, -0.675895, -1.500551>,
      < 1.123236, -0.675455, -1.533204>,
      < 1.123226, -0.658591, -1.507192>
    }
    triangle {
      < -0.499223, -0.659552, -1.507192>,
      < -0.499213, -0.676417, -1.533204>,
      < -0.415332, -0.695149, -1.514428>
    }
    triangle {
      < -0.499223, -0.659552, -1.507192>,
      < -0.415332, -0.695149, -1.514428>,
      < -0.415338, -0.684307, -1.497706>
    }
    triangle {
      < 1.221575, -0.688545, -1.520061>,
      < 1.221586, -0.707988, -1.532692>,
      < 1.123251, -0.701379, -1.550045>
    }
    triangle {
      < 1.221575, -0.688545, -1.520061>,
      < 1.123251, -0.701379, -1.550045>,
      < 1.123236, -0.675455, -1.533204>
    }
    triangle {
      < -0.499213, -0.676417, -1.533204>,
      < -0.499198, -0.702341, -1.550045>,
      < -0.415322, -0.711815, -1.525255>
    }
    triangle {
      < -0.499213, -0.676417, -1.533204>,
      < -0.415322, -0.711815, -1.525255>,
      < -0.415332, -0.695149, -1.514428>
    }
    triangle {
      < 1.221586, -0.707988, -1.532692>,
      < 1.221600, -0.730887, -1.536325>,
      < 1.123270, -0.731912, -1.554890>
    }
    triangle {
      < 1.221586, -0.707988, -1.532692>,
      < 1.123270, -0.731912, -1.554890>,
      < 1.123251, -0.701379, -1.550045>
    }
    triangle {
      < -0.499198, -0.702341, -1.550045>,
      < -0.499180, -0.732874, -1.554890>,
      < -0.415310, -0.731443, -1.528369>
    }
    triangle {
      < -0.499198, -0.702341, -1.550045>,
      < -0.415310, -0.731443, -1.528369>,
      < -0.415322, -0.711815, -1.525255>
    }
    triangle {
      < -0.499226, -0.654752, -1.476653>,
      < -0.499223, -0.659552, -1.507192>,
      < -0.415338, -0.684307, -1.497706>
    }
    triangle {
      < -0.499226, -0.654752, -1.476653>,
      < -0.415338, -0.684307, -1.497706>,
      < -0.415340, -0.681222, -1.478073>
    }
    triangle {
      < 1.221565, -0.672296, -1.477647>,
      < 1.221567, -0.675895, -1.500551>,
      < 1.123226, -0.658591, -1.507192>
    }
    triangle {
      < 1.221565, -0.672296, -1.477647>,
      < 1.123226, -0.658591, -1.507192>,
      < 1.123223, -0.653790, -1.476652>
    }
    triangle {
      < 1.123270, -0.731912, -1.554890>,
      < 1.123287, -0.761776, -1.546899>,
      < 0.900604, -0.770342, -1.563467>
    }
    triangle {
      < 1.123270, -0.731912, -1.554890>,
      < 0.900604, -0.770342, -1.563467>,
      < 0.900581, -0.733013, -1.573455>
    }
    triangle {
      < -0.487611, -0.733835, -1.573455>,
      < -0.487588, -0.771165, -1.563467>,
      < -0.499162, -0.762739, -1.546899>
    }
    triangle {
      < -0.487611, -0.733835, -1.573455>,
      < -0.499162, -0.762739, -1.546899>,
      < -0.499180, -0.732874, -1.554890>
    }
    triangle {
      < 0.900581, -0.733013, -1.573455>,
      < 0.900604, -0.770342, -1.563467>,
      < -0.487588, -0.771165, -1.563467>
    }
    triangle {
      < 0.900581, -0.733013, -1.573455>,
      < -0.487588, -0.771165, -1.563467>,
      < -0.487611, -0.733835, -1.573455>
    }
    triangle {
      < 1.123228, -0.661826, -1.446800>,
      < 1.123223, -0.653790, -1.476652>,
      < 0.900524, -0.635359, -1.475657>
    }
    triangle {
      < 1.123228, -0.661826, -1.446800>,
      < 0.900524, -0.635359, -1.475657>,
      < 0.900529, -0.645404, -1.438342>
    }
    triangle {
      < 0.900529, -0.645404, -1.438342>,
      < 0.900524, -0.635359, -1.475657>,
      < -0.487669, -0.636182, -1.475657>
    }
    triangle {
      < 0.900529, -0.645404, -1.438342>,
      < -0.487669, -0.636182, -1.475657>,
      < -0.487662, -0.646226, -1.438342>
    }
    triangle {
      < -0.487662, -0.646226, -1.438342>,
      < -0.487669, -0.636182, -1.475657>,
      < -0.499226, -0.654752, -1.476653>
    }
    triangle {
      < -0.487662, -0.646226, -1.438342>,
      < -0.499226, -0.654752, -1.476653>,
      < -0.499221, -0.662788, -1.446800>
    }
    triangle {
      < 1.276528, -0.695706, -1.492963>,
      < 1.276532, -0.703537, -1.505039>,
      < 1.221575, -0.688545, -1.520061>
    }
    triangle {
      < 1.276528, -0.695706, -1.492963>,
      < 1.221575, -0.688545, -1.520061>,
      < 1.221567, -0.675895, -1.500551>
    }
    triangle {
      < 1.276532, -0.703537, -1.505039>,
      < 1.276539, -0.715573, -1.512859>,
      < 1.221586, -0.707988, -1.532692>
    }
    triangle {
      < 1.276532, -0.703537, -1.505039>,
      < 1.221586, -0.707988, -1.532692>,
      < 1.221575, -0.688545, -1.520061>
    }
    triangle {
      < 1.276539, -0.715573, -1.512859>,
      < 1.276547, -0.729749, -1.515108>,
      < 1.221600, -0.730887, -1.536325>
    }
    triangle {
      < 1.276539, -0.715573, -1.512859>,
      < 1.221600, -0.730887, -1.536325>,
      < 1.221586, -0.707988, -1.532692>
    }
    triangle {
      < 1.276526, -0.693479, -1.478783>,
      < 1.276528, -0.695706, -1.492963>,
      < 1.221567, -0.675895, -1.500551>
    }
    triangle {
      < 1.276526, -0.693479, -1.478783>,
      < 1.221567, -0.675895, -1.500551>,
      < 1.221565, -0.672296, -1.477647>
    }
    triangle {
      < 1.221600, -0.730887, -1.536325>,
      < 1.221613, -0.753286, -1.530332>,
      < 1.123287, -0.761776, -1.546899>
    }
    triangle {
      < 1.221600, -0.730887, -1.536325>,
      < 1.123287, -0.761776, -1.546899>,
      < 1.123270, -0.731912, -1.554890>
    }
    triangle {
      < -0.499180, -0.732874, -1.554890>,
      < -0.499162, -0.762739, -1.546899>,
      < -0.415299, -0.750641, -1.523233>
    }
    triangle {
      < -0.499180, -0.732874, -1.554890>,
      < -0.415299, -0.750641, -1.523233>,
      < -0.415310, -0.731443, -1.528369>
    }
    triangle {
      < 1.221568, -0.678322, -1.455258>,
      < 1.221565, -0.672296, -1.477647>,
      < 1.123223, -0.653790, -1.476652>
    }
    triangle {
      < 1.221568, -0.678322, -1.455258>,
      < 1.123223, -0.653790, -1.476652>,
      < 1.123228, -0.661826, -1.446800>
    }
    triangle {
      < -0.499221, -0.662788, -1.446800>,
      < -0.499226, -0.654752, -1.476653>,
      < -0.415340, -0.681222, -1.478073>
    }
    triangle {
      < -0.499221, -0.662788, -1.446800>,
      < -0.415340, -0.681222, -1.478073>,
      < -0.415337, -0.686387, -1.458883>
    }
    triangle {
      < -0.415338, -0.684307, -1.497706>,
      < -0.415332, -0.695149, -1.514428>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < -0.415332, -0.695149, -1.514428>,
      < -0.415322, -0.711815, -1.525255>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < -0.415322, -0.711815, -1.525255>,
      < -0.415310, -0.731443, -1.528369>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < -0.415340, -0.681222, -1.478073>,
      < -0.415338, -0.684307, -1.497706>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.276547, -0.729749, -1.515108>,
      < 1.276556, -0.743615, -1.511398>,
      < 1.221613, -0.753286, -1.530332>
    }
    triangle {
      < 1.276547, -0.729749, -1.515108>,
      < 1.221613, -0.753286, -1.530332>,
      < 1.221600, -0.730887, -1.536325>
    }
    triangle {
      < 1.276528, -0.697209, -1.464924>,
      < 1.276526, -0.693479, -1.478783>,
      < 1.221565, -0.672296, -1.477647>
    }
    triangle {
      < 1.276528, -0.697209, -1.464924>,
      < 1.221565, -0.672296, -1.477647>,
      < 1.221568, -0.678322, -1.455258>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276539, -0.715573, -1.512859>,
      < 1.276532, -0.703537, -1.505039>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276532, -0.703537, -1.505039>,
      < 1.276528, -0.695706, -1.492963>
    }
    triangle {
      < -0.415310, -0.731443, -1.528369>,
      < -0.415299, -0.750641, -1.523233>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < -0.415337, -0.686387, -1.458883>,
      < -0.415340, -0.681222, -1.478073>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276547, -0.729749, -1.515108>,
      < 1.276539, -0.715573, -1.512859>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276528, -0.695706, -1.492963>,
      < 1.276526, -0.693479, -1.478783>
    }
    triangle {
      < -0.487588, -0.771165, -1.563467>,
      < -0.487570, -0.801207, -1.539160>,
      < -0.499148, -0.786772, -1.527454>
    }
    triangle {
      < -0.487588, -0.771165, -1.563467>,
      < -0.499148, -0.786772, -1.527454>,
      < -0.499162, -0.762739, -1.546899>
    }
    triangle {
      < 1.123287, -0.761776, -1.546899>,
      < 1.123302, -0.785810, -1.527454>,
      < 0.900621, -0.800384, -1.539160>
    }
    triangle {
      < 1.123287, -0.761776, -1.546899>,
      < 0.900621, -0.800384, -1.539160>,
      < 0.900604, -0.770342, -1.563467>
    }
    triangle {
      < -0.487648, -0.670576, -1.408337>,
      < -0.487662, -0.646226, -1.438342>,
      < -0.499221, -0.662788, -1.446800>
    }
    triangle {
      < -0.487648, -0.670576, -1.408337>,
      < -0.499221, -0.662788, -1.446800>,
      < -0.499209, -0.682269, -1.422795>
    }
    triangle {
      < 1.123240, -0.681307, -1.422795>,
      < 1.123228, -0.661826, -1.446800>,
      < 0.900529, -0.645404, -1.438342>
    }
    triangle {
      < 1.123240, -0.681307, -1.422795>,
      < 0.900529, -0.645404, -1.438342>,
      < 0.900544, -0.669754, -1.408336>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276556, -0.743615, -1.511398>,
      < 1.276547, -0.729749, -1.515108>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276526, -0.693479, -1.478783>,
      < 1.276528, -0.697209, -1.464924>
    }
    triangle {
      < 1.221613, -0.753286, -1.530332>,
      < 1.221624, -0.771311, -1.515748>,
      < 1.123302, -0.785810, -1.527454>
    }
    triangle {
      < 1.221613, -0.753286, -1.530332>,
      < 1.123302, -0.785810, -1.527454>,
      < 1.123287, -0.761776, -1.546899>
    }
    triangle {
      < -0.499162, -0.762739, -1.546899>,
      < -0.499148, -0.786772, -1.527454>,
      < -0.415290, -0.766092, -1.510732>
    }
    triangle {
      < -0.499162, -0.762739, -1.546899>,
      < -0.415290, -0.766092, -1.510732>,
      < -0.415299, -0.750641, -1.523233>
    }
    triangle {
      < 1.221577, -0.692933, -1.437254>,
      < 1.221568, -0.678322, -1.455258>,
      < 1.123228, -0.661826, -1.446800>
    }
    triangle {
      < 1.221577, -0.692933, -1.437254>,
      < 1.123228, -0.661826, -1.446800>,
      < 1.123240, -0.681307, -1.422795>
    }
    triangle {
      < -0.499209, -0.682269, -1.422795>,
      < -0.499221, -0.662788, -1.446800>,
      < -0.415337, -0.686387, -1.458883>
    }
    triangle {
      < -0.499209, -0.682269, -1.422795>,
      < -0.415337, -0.686387, -1.458883>,
      < -0.415330, -0.698911, -1.443451>
    }
    triangle {
      < 1.276556, -0.743615, -1.511398>,
      < 1.276563, -0.754773, -1.502370>,
      < 1.221624, -0.771311, -1.515748>
    }
    triangle {
      < 1.276556, -0.743615, -1.511398>,
      < 1.221624, -0.771311, -1.515748>,
      < 1.221613, -0.753286, -1.530332>
    }
    triangle {
      < 1.276534, -0.706254, -1.453778>,
      < 1.276528, -0.697209, -1.464924>,
      < 1.221568, -0.678322, -1.455258>
    }
    triangle {
      < 1.276534, -0.706254, -1.453778>,
      < 1.221568, -0.678322, -1.455258>,
      < 1.221577, -0.692933, -1.437254>
    }
    triangle {
      < -0.415299, -0.750641, -1.523233>,
      < -0.415290, -0.766092, -1.510732>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < -0.415330, -0.698911, -1.443451>,
      < -0.415337, -0.686387, -1.458883>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276563, -0.754773, -1.502370>,
      < 1.276556, -0.743615, -1.511398>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276528, -0.697209, -1.464924>,
      < 1.276534, -0.706254, -1.453778>
    }
    triangle {
      < -0.415319, -0.716627, -1.434446>,
      < -0.415330, -0.698911, -1.443451>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276566, -0.761297, -1.489585>,
      < 1.276563, -0.754773, -1.502370>
    }
    triangle {
      < -0.415308, -0.736475, -1.433424>,
      < -0.415319, -0.716627, -1.434446>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < -0.415288, -0.769065, -1.454624>,
      < -0.415297, -0.755023, -1.440561>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < -0.415297, -0.755023, -1.440561>,
      < -0.415308, -0.736475, -1.433424>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276557, -0.746779, -1.451691>,
      < 1.276564, -0.756921, -1.461848>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276534, -0.706254, -1.453778>,
      < 1.276541, -0.719050, -1.447275>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276541, -0.719050, -1.447275>,
      < 1.276549, -0.733383, -1.446537>
    }
    triangle {
      < -0.415290, -0.766092, -1.510732>,
      < -0.415284, -0.775123, -1.493029>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276566, -0.762056, -1.475252>,
      < 1.276566, -0.761297, -1.489585>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276549, -0.733383, -1.446537>,
      < 1.276557, -0.746779, -1.451691>
    }
    triangle {
      < -0.415284, -0.775123, -1.493029>,
      < -0.415284, -0.776175, -1.473183>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.322820, -0.727925, -1.480631>,
      < 1.276564, -0.756921, -1.461848>,
      < 1.276566, -0.762056, -1.475252>
    }
    triangle {
      < -0.415284, -0.776175, -1.473183>,
      < -0.415288, -0.769065, -1.454624>,
      < -0.397960, -0.728945, -1.480631>
    }
    triangle {
      < 1.276563, -0.754773, -1.502370>,
      < 1.276566, -0.761297, -1.489585>,
      < 1.221629, -0.781847, -1.495094>
    }
    triangle {
      < 1.276563, -0.754773, -1.502370>,
      < 1.221629, -0.781847, -1.495094>,
      < 1.221624, -0.771311, -1.515748>
    }
    triangle {
      < 1.276541, -0.719050, -1.447275>,
      < 1.276534, -0.706254, -1.453778>,
      < 1.221577, -0.692933, -1.437254>
    }
    triangle {
      < 1.276541, -0.719050, -1.447275>,
      < 1.221577, -0.692933, -1.437254>,
      < 1.221590, -0.713602, -1.426748>
    }
    triangle {
      < -0.499148, -0.786772, -1.527454>,
      < -0.499139, -0.800821, -1.499916>,
      < -0.415284, -0.775123, -1.493029>
    }
    triangle {
      < -0.499148, -0.786772, -1.527454>,
      < -0.415284, -0.775123, -1.493029>,
      < -0.415290, -0.766092, -1.510732>
    }
    triangle {
      < -0.499193, -0.709827, -1.408787>,
      < -0.499209, -0.682269, -1.422795>,
      < -0.415330, -0.698911, -1.443451>
    }
    triangle {
      < -0.499193, -0.709827, -1.408787>,
      < -0.415330, -0.698911, -1.443451>,
      < -0.415319, -0.716627, -1.434446>
    }
    triangle {
      < 1.221624, -0.771311, -1.515748>,
      < 1.221629, -0.781847, -1.495094>,
      < 1.123310, -0.799859, -1.499916>
    }
    triangle {
      < 1.221624, -0.771311, -1.515748>,
      < 1.123310, -0.799859, -1.499916>,
      < 1.123302, -0.785810, -1.527454>
    }
    triangle {
      < 1.221590, -0.713602, -1.426748>,
      < 1.221577, -0.692933, -1.437254>,
      < 1.123240, -0.681307, -1.422795>
    }
    triangle {
      < 1.221590, -0.713602, -1.426748>,
      < 1.123240, -0.681307, -1.422795>,
      < 1.123256, -0.708865, -1.408787>
    }
    triangle {
      < -0.487570, -0.801207, -1.539160>,
      < -0.487561, -0.818768, -1.504737>,
      < -0.499139, -0.800821, -1.499916>
    }
    triangle {
      < -0.487570, -0.801207, -1.539160>,
      < -0.499139, -0.800821, -1.499916>,
      < -0.499148, -0.786772, -1.527454>
    }
    triangle {
      < 1.123302, -0.785810, -1.527454>,
      < 1.123310, -0.799859, -1.499916>,
      < 0.900632, -0.817945, -1.504737>
    }
    triangle {
      < 1.123302, -0.785810, -1.527454>,
      < 0.900632, -0.817945, -1.504737>,
      < 0.900621, -0.800384, -1.539160>
    }
    triangle {
      < 1.123256, -0.708865, -1.408787>,
      < 1.123240, -0.681307, -1.422795>,
      < 0.900544, -0.669754, -1.408336>
    }
    triangle {
      < 1.123256, -0.708865, -1.408787>,
      < 0.900544, -0.669754, -1.408336>,
      < 0.900564, -0.704203, -1.390826>
    }
    triangle {
      < -0.487627, -0.705025, -1.390826>,
      < -0.487648, -0.670576, -1.408337>,
      < -0.499209, -0.682269, -1.422795>
    }
    triangle {
      < -0.487627, -0.705025, -1.390826>,
      < -0.499209, -0.682269, -1.422795>,
      < -0.499193, -0.709827, -1.408787>
    }
    triangle {
      < 1.276566, -0.761297, -1.489585>,
      < 1.276566, -0.762056, -1.475252>,
      < 1.221630, -0.783075, -1.471941>
    }
    triangle {
      < 1.276566, -0.761297, -1.489585>,
      < 1.221630, -0.783075, -1.471941>,
      < 1.221629, -0.781847, -1.495094>
    }
    triangle {
      < 1.276549, -0.733383, -1.446537>,
      < 1.276541, -0.719050, -1.447275>,
      < 1.221590, -0.713602, -1.426748>
    }
    triangle {
      < 1.276549, -0.733383, -1.446537>,
      < 1.221590, -0.713602, -1.426748>,
      < 1.221603, -0.736757, -1.425555>
    }
    triangle {
      < -0.499139, -0.800821, -1.499916>,
      < -0.499138, -0.802457, -1.469045>,
      < -0.415284, -0.776175, -1.473183>
    }
    triangle {
      < -0.499139, -0.800821, -1.499916>,
      < -0.415284, -0.776175, -1.473183>,
      < -0.415284, -0.775123, -1.493029>
    }
    triangle {
      < -0.499175, -0.740701, -1.407197>,
      < -0.499193, -0.709827, -1.408787>,
      < -0.415319, -0.716627, -1.434446>
    }
    triangle {
      < -0.499175, -0.740701, -1.407197>,
      < -0.415319, -0.716627, -1.434446>,
      < -0.415308, -0.736475, -1.433424>
    }
    triangle {
      < 1.221629, -0.781847, -1.495094>,
      < 1.221630, -0.783075, -1.471941>,
      < 1.123311, -0.801495, -1.469045>
    }
    triangle {
      < 1.221629, -0.781847, -1.495094>,
      < 1.123311, -0.801495, -1.469045>,
      < 1.123310, -0.799859, -1.499916>
    }
    triangle {
      < 1.276566, -0.762056, -1.475252>,
      < 1.276564, -0.756921, -1.461848>,
      < 1.221626, -0.774779, -1.450289>
    }
    triangle {
      < 1.276566, -0.762056, -1.475252>,
      < 1.221626, -0.774779, -1.450289>,
      < 1.221630, -0.783075, -1.471941>
    }
    triangle {
      < 1.221603, -0.736757, -1.425555>,
      < 1.221590, -0.713602, -1.426748>,
      < 1.123256, -0.708865, -1.408787>
    }
    triangle {
      < 1.221603, -0.736757, -1.425555>,
      < 1.123256, -0.708865, -1.408787>,
      < 1.123275, -0.739739, -1.407197>
    }
    triangle {
      < 1.276557, -0.746779, -1.451691>,
      < 1.276549, -0.733383, -1.446537>,
      < 1.221603, -0.736757, -1.425555>
    }
    triangle {
      < 1.276557, -0.746779, -1.451691>,
      < 1.221603, -0.736757, -1.425555>,
      < 1.221616, -0.758396, -1.433883>
    }
    triangle {
      < 1.276564, -0.756921, -1.461848>,
      < 1.276557, -0.746779, -1.451691>,
      < 1.221616, -0.758396, -1.433883>
    }
    triangle {
      < 1.276564, -0.756921, -1.461848>,
      < 1.221616, -0.758396, -1.433883>,
      < 1.221626, -0.774779, -1.450289>
    }
    triangle {
      < -0.487561, -0.818768, -1.504737>,
      < -0.487559, -0.820812, -1.466147>,
      < -0.499138, -0.802457, -1.469045>
    }
    triangle {
      < -0.487561, -0.818768, -1.504737>,
      < -0.499138, -0.802457, -1.469045>,
      < -0.499139, -0.800821, -1.499916>
    }
    triangle {
      < 1.123310, -0.799859, -1.499916>,
      < 1.123311, -0.801495, -1.469045>,
      < 0.900633, -0.819990, -1.466147>
    }
    triangle {
      < 1.123310, -0.799859, -1.499916>,
      < 0.900633, -0.819990, -1.466147>,
      < 0.900632, -0.817945, -1.504737>
    }
    triangle {
      < 1.123275, -0.739739, -1.407197>,
      < 1.123256, -0.708865, -1.408787>,
      < 0.900564, -0.704203, -1.390826>
    }
    triangle {
      < 1.123275, -0.739739, -1.407197>,
      < 0.900564, -0.704203, -1.390826>,
      < 0.900588, -0.742795, -1.388838>
    }
    triangle {
      < -0.487605, -0.743618, -1.388838>,
      < -0.487627, -0.705025, -1.390826>,
      < -0.499193, -0.709827, -1.408787>
    }
    triangle {
      < -0.487605, -0.743618, -1.388838>,
      < -0.499193, -0.709827, -1.408787>,
      < -0.499175, -0.740701, -1.407197>
    }
    triangle {
      < -0.499138, -0.802457, -1.469045>,
      < -0.499145, -0.791397, -1.440176>,
      < -0.415288, -0.769065, -1.454624>
    }
    triangle {
      < -0.499138, -0.802457, -1.469045>,
      < -0.415288, -0.769065, -1.454624>,
      < -0.415284, -0.776175, -1.473183>
    }
    triangle {
      < -0.499158, -0.769554, -1.418300>,
      < -0.499175, -0.740701, -1.407197>,
      < -0.415308, -0.736475, -1.433424>
    }
    triangle {
      < -0.499158, -0.769554, -1.418300>,
      < -0.415308, -0.736475, -1.433424>,
      < -0.415297, -0.755023, -1.440561>
    }
    triangle {
      < 1.221630, -0.783075, -1.471941>,
      < 1.221626, -0.774779, -1.450289>,
      < 1.123304, -0.790435, -1.440176>
    }
    triangle {
      < 1.221630, -0.783075, -1.471941>,
      < 1.123304, -0.790435, -1.440176>,
      < 1.123311, -0.801495, -1.469045>
    }
    triangle {
      < 1.221616, -0.758396, -1.433883>,
      < 1.221603, -0.736757, -1.425555>,
      < 1.123275, -0.739739, -1.407197>
    }
    triangle {
      < 1.221616, -0.758396, -1.433883>,
      < 1.123275, -0.739739, -1.407197>,
      < 1.123292, -0.768592, -1.418300>
    }
    triangle {
      < 0.900632, -0.817945, -1.504737>,
      < 0.900633, -0.819990, -1.466147>,
      < -0.487559, -0.820812, -1.466147>
    }
    triangle {
      < 0.900632, -0.817945, -1.504737>,
      < -0.487559, -0.820812, -1.466147>,
      < -0.487561, -0.818768, -1.504737>
    }
    triangle {
      < 0.900588, -0.742795, -1.388838>,
      < 0.900564, -0.704203, -1.390826>,
      < -0.487627, -0.705025, -1.390826>
    }
    triangle {
      < 0.900588, -0.742795, -1.388838>,
      < -0.487627, -0.705025, -1.390826>,
      < -0.487605, -0.743618, -1.388838>
    }
    triangle {
      < -0.499145, -0.791397, -1.440176>,
      < -0.499158, -0.769554, -1.418300>,
      < -0.415297, -0.755023, -1.440561>
    }
    triangle {
      < -0.499145, -0.791397, -1.440176>,
      < -0.415297, -0.755023, -1.440561>,
      < -0.415288, -0.769065, -1.454624>
    }
    triangle {
      < 1.221626, -0.774779, -1.450289>,
      < 1.221616, -0.758396, -1.433883>,
      < 1.123292, -0.768592, -1.418300>
    }
    triangle {
      < 1.221626, -0.774779, -1.450289>,
      < 1.123292, -0.768592, -1.418300>,
      < 1.123304, -0.790435, -1.440176>
    }
    triangle {
      < -0.487559, -0.820812, -1.466147>,
      < -0.487567, -0.806987, -1.430062>,
      < -0.499145, -0.791397, -1.440176>
    }
    triangle {
      < -0.487559, -0.820812, -1.466147>,
      < -0.499145, -0.791397, -1.440176>,
      < -0.499138, -0.802457, -1.469045>
    }
    triangle {
      < 1.123311, -0.801495, -1.469045>,
      < 1.123304, -0.790435, -1.440176>,
      < 0.900625, -0.806165, -1.430062>
    }
    triangle {
      < 1.123311, -0.801495, -1.469045>,
      < 0.900625, -0.806165, -1.430062>,
      < 0.900633, -0.819990, -1.466147>
    }
    triangle {
      < 1.123292, -0.768592, -1.418300>,
      < 1.123275, -0.739739, -1.407197>,
      < 0.900588, -0.742795, -1.388838>
    }
    triangle {
      < 1.123292, -0.768592, -1.418300>,
      < 0.900588, -0.742795, -1.388838>,
      < 0.900608, -0.778861, -1.402717>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < -0.487605, -0.743618, -1.388838>,
      < -0.499175, -0.740701, -1.407197>
    }
    triangle {
      < -0.487583, -0.779683, -1.402717>,
      < -0.499175, -0.740701, -1.407197>,
      < -0.499158, -0.769554, -1.418300>
    }
    triangle {
      < -0.487567, -0.806987, -1.430062>,
      < -0.487583, -0.779683, -1.402717>,
      < -0.499158, -0.769554, -1.418300>
    }
    triangle {
      < -0.487567, -0.806987, -1.430062>,
      < -0.499158, -0.769554, -1.418300>,
      < -0.499145, -0.791397, -1.440176>
    }
    triangle {
      < 1.123304, -0.790435, -1.440176>,
      < 1.123292, -0.768592, -1.418300>,
      < 0.900608, -0.778861, -1.402717>
    }
    triangle {
      < 1.123304, -0.790435, -1.440176>,
      < 0.900608, -0.778861, -1.402717>,
      < 0.900625, -0.806165, -1.430062>
    }
    triangle {
      < 0.900633, -0.819990, -1.466147>,
      < 0.900625, -0.806165, -1.430062>,
      < -0.487567, -0.806987, -1.430062>
    }
    triangle {
      < 0.900633, -0.819990, -1.466147>,
      < -0.487567, -0.806987, -1.430062>,
      < -0.487559, -0.820812, -1.466147>
    }
    triangle {
      < 0.900608, -0.778861, -1.402717>,
      < 0.900588, -0.742795, -1.388838>,
      < -0.487605, -0.743618, -1.388838>
    }
    triangle {
      < 0.900608, -0.778861, -1.402717>,
      < -0.487605, -0.743618, -1.388838>,
      < -0.487583, -0.779683, -1.402717>
    }
    triangle {
      < -0.290938, -0.492996, -1.062228>,
      < -0.254742, -0.663125, -0.910402>,
      < -0.254734, -0.676331, -0.918981>
    }
    triangle {
      < -0.290938, -0.492996, -1.062228>,
      < -0.254734, -0.676331, -0.918981>,
      < -0.290927, -0.510712, -1.079991>
    }
    triangle {
      < -0.290938, -0.492996, -1.062228>,
      < -0.254748, -0.654438, -0.897004>,
      < -0.254742, -0.663125, -0.910402>
    }
    triangle {
      < -0.446269, -0.510804, -1.079991>,
      < -0.446835, -0.663239, -0.910402>,
      < -0.446840, -0.654551, -0.897004>
    }
    triangle {
      < -0.446269, -0.510804, -1.079991>,
      < -0.446840, -0.654551, -0.897004>,
      < -0.446280, -0.493088, -1.062228>
    }
    triangle {
      < -0.446269, -0.510804, -1.079991>,
      < -0.446827, -0.676445, -0.918981>,
      < -0.446835, -0.663239, -0.910402>
    }
    triangle {
      < -0.446280, -0.493088, -1.062228>,
      < -0.446840, -0.654551, -0.897004>,
      < -0.254748, -0.654438, -0.897004>
    }
    triangle {
      < -0.446280, -0.493088, -1.062228>,
      < -0.254748, -0.654438, -0.897004>,
      < -0.290938, -0.492996, -1.062228>
    }
    triangle {
      < -0.290927, -0.510712, -1.079991>,
      < -0.254734, -0.676331, -0.918981>,
      < -0.446827, -0.676445, -0.918981>
    }
    triangle {
      < -0.290927, -0.510712, -1.079991>,
      < -0.446827, -0.676445, -0.918981>,
      < -0.446269, -0.510804, -1.079991>
    }
    triangle {
      < 0.488400, -0.620397, -0.930514>,
      < 0.518899, -0.662666, -0.910402>,
      < 0.521178, -0.675871, -0.918981>
    }
    triangle {
      < 0.488400, -0.620397, -0.930514>,
      < 0.521178, -0.675871, -0.918981>,
      < 0.488413, -0.642303, -0.952479>
    }
    triangle {
      < 0.488400, -0.620397, -0.930514>,
      < 0.521177, -0.653978, -0.897004>,
      < 0.518899, -0.662666, -0.910402>
    }
    triangle {
      < -0.217357, -0.510668, -1.079991>,
      < -0.163768, -0.663071, -0.910402>,
      < -0.163773, -0.654384, -0.897004>
    }
    triangle {
      < -0.217357, -0.510668, -1.079991>,
      < -0.163773, -0.654384, -0.897004>,
      < -0.217368, -0.492952, -1.062228>
    }
    triangle {
      < -0.217357, -0.510668, -1.079991>,
      < -0.163759, -0.676277, -0.918981>,
      < -0.163768, -0.663071, -0.910402>
    }
    triangle {
      < -0.217368, -0.492952, -1.062228>,
      < -0.163773, -0.654384, -0.897004>,
      < 0.521177, -0.653978, -0.897004>
    }
    triangle {
      < -0.217368, -0.492952, -1.062228>,
      < 0.521177, -0.653978, -0.897004>,
      < 0.488400, -0.620397, -0.930514>
    }
    triangle {
      < 0.488413, -0.642303, -0.952479>,
      < 0.521178, -0.675871, -0.918981>,
      < -0.163759, -0.676277, -0.918981>
    }
    triangle {
      < 0.488413, -0.642303, -0.952479>,
      < -0.163759, -0.676277, -0.918981>,
      < -0.217357, -0.510668, -1.079991>
    }
    triangle {
      < -0.290927, -0.511270, -0.608865>,
      < -0.254738, -0.670439, -0.772391>,
      < -0.254748, -0.654456, -0.792085>
    }
    triangle {
      < -0.290927, -0.511270, -0.608865>,
      < -0.254748, -0.654456, -0.792085>,
      < -0.290938, -0.493513, -0.626585>
    }
    triangle {
      < -0.290927, -0.511270, -0.608865>,
      < -0.254735, -0.675872, -0.769630>,
      < -0.254738, -0.670439, -0.772391>
    }
    triangle {
      < -0.446280, -0.493604, -0.626585>,
      < -0.446830, -0.670552, -0.772391>,
      < -0.446828, -0.675986, -0.769630>
    }
    triangle {
      < -0.446280, -0.493604, -0.626585>,
      < -0.446828, -0.675986, -0.769630>,
      < -0.446269, -0.511362, -0.608865>
    }
    triangle {
      < -0.446280, -0.493604, -0.626585>,
      < -0.446840, -0.654570, -0.792086>,
      < -0.446830, -0.670552, -0.772391>
    }
    triangle {
      < -0.446269, -0.511362, -0.608865>,
      < -0.446828, -0.675986, -0.769630>,
      < -0.254735, -0.675872, -0.769630>
    }
    triangle {
      < -0.446269, -0.511362, -0.608865>,
      < -0.254735, -0.675872, -0.769630>,
      < -0.290927, -0.511270, -0.608865>
    }
    triangle {
      < -0.290938, -0.493513, -0.626585>,
      < -0.254748, -0.654456, -0.792085>,
      < -0.446840, -0.654570, -0.792086>
    }
    triangle {
      < -0.290938, -0.493513, -0.626585>,
      < -0.446840, -0.654570, -0.792086>,
      < -0.446280, -0.493604, -0.626585>
    }
    triangle {
      < 0.488413, -0.642560, -0.736689>,
      < 0.519253, -0.669980, -0.772391>,
      < 0.521074, -0.653997, -0.792085>
    }
    triangle {
      < 0.488413, -0.642560, -0.736689>,
      < 0.521074, -0.653997, -0.792085>,
      < 0.488400, -0.620601, -0.758602>
    }
    triangle {
      < 0.488413, -0.642560, -0.736689>,
      < 0.520556, -0.675412, -0.769629>,
      < 0.519253, -0.669980, -0.772391>
    }
    triangle {
      < -0.217368, -0.493468, -0.626585>,
      < -0.163763, -0.670385, -0.772391>,
      < -0.163760, -0.675818, -0.769630>
    }
    triangle {
      < -0.217368, -0.493468, -0.626585>,
      < -0.163760, -0.675818, -0.769630>,
      < -0.217357, -0.511226, -0.608865>
    }
    triangle {
      < -0.217368, -0.493468, -0.626585>,
      < -0.163773, -0.654402, -0.792085>,
      < -0.163763, -0.670385, -0.772391>
    }
    triangle {
      < -0.217357, -0.511226, -0.608865>,
      < -0.163760, -0.675818, -0.769630>,
      < 0.520556, -0.675412, -0.769629>
    }
    triangle {
      < -0.217357, -0.511226, -0.608865>,
      < 0.520556, -0.675412, -0.769629>,
      < 0.488413, -0.642560, -0.736689>
    }
    triangle {
      < 0.488400, -0.620601, -0.758602>,
      < 0.521074, -0.653997, -0.792085>,
      < -0.163773, -0.654402, -0.792085>
    }
    triangle {
      < 0.488400, -0.620601, -0.758602>,
      < -0.163773, -0.654402, -0.792085>,
      < -0.217368, -0.493468, -0.626585>
    }
    triangle {
      < -0.290659, -0.964639, -0.627004>,
      < -0.254659, -0.804157, -0.791420>,
      < -0.254672, -0.782238, -0.769469>
    }
    triangle {
      < -0.290659, -0.964639, -0.627004>,
      < -0.254672, -0.782238, -0.769469>,
      < -0.290668, -0.946913, -0.609252>
    }
    triangle {
      < -0.446011, -0.947005, -0.609252>,
      < -0.446764, -0.782351, -0.769469>,
      < -0.446751, -0.804271, -0.791420>
    }
    triangle {
      < -0.446011, -0.947005, -0.609252>,
      < -0.446751, -0.804271, -0.791420>,
      < -0.446001, -0.964731, -0.627004>
    }
    triangle {
      < -0.446001, -0.964731, -0.627004>,
      < -0.446751, -0.804271, -0.791420>,
      < -0.254659, -0.804157, -0.791420>
    }
    triangle {
      < -0.446001, -0.964731, -0.627004>,
      < -0.254659, -0.804157, -0.791420>,
      < -0.290659, -0.964639, -0.627004>
    }
    triangle {
      < -0.290668, -0.946913, -0.609252>,
      < -0.254672, -0.782238, -0.769469>,
      < -0.446764, -0.782351, -0.769469>
    }
    triangle {
      < -0.290668, -0.946913, -0.609252>,
      < -0.446764, -0.782351, -0.769469>,
      < -0.446011, -0.947005, -0.609252>
    }
    triangle {
      < 0.488528, -0.836391, -0.758794>,
      < 0.520383, -0.803697, -0.791420>,
      < 0.520370, -0.781778, -0.769468>
    }
    triangle {
      < 0.488528, -0.836391, -0.758794>,
      < 0.520370, -0.781778, -0.769468>,
      < 0.488515, -0.814472, -0.736842>
    }
    triangle {
      < -0.217099, -0.946869, -0.609252>,
      < -0.163697, -0.782184, -0.769469>,
      < -0.163684, -0.804103, -0.791420>
    }
    triangle {
      < -0.217099, -0.946869, -0.609252>,
      < -0.163684, -0.804103, -0.791420>,
      < -0.217089, -0.964595, -0.627004>
    }
    triangle {
      < -0.217089, -0.964595, -0.627004>,
      < -0.163684, -0.804103, -0.791420>,
      < 0.520383, -0.803697, -0.791420>
    }
    triangle {
      < -0.217089, -0.964595, -0.627004>,
      < 0.520383, -0.803697, -0.791420>,
      < 0.488528, -0.836391, -0.758794>
    }
    triangle {
      < 0.488515, -0.814472, -0.736842>,
      < 0.520370, -0.781778, -0.769468>,
      < -0.163697, -0.782184, -0.769469>
    }
    triangle {
      < 0.488515, -0.814472, -0.736842>,
      < -0.163697, -0.782184, -0.769469>,
      < -0.217099, -0.946869, -0.609252>
    }
    triangle {
      < -0.290668, -0.946634, -1.080379>,
      < -0.254660, -0.801069, -0.903215>,
      < -0.254659, -0.803839, -0.897786>
    }
    triangle {
      < -0.290668, -0.946634, -1.080379>,
      < -0.254659, -0.803839, -0.897786>,
      < -0.290659, -0.964380, -1.062647>
    }
    triangle {
      < -0.290668, -0.946634, -1.080379>,
      < -0.254672, -0.781351, -0.919169>,
      < -0.254660, -0.801069, -0.903215>
    }
    triangle {
      < -0.446001, -0.964473, -1.062647>,
      < -0.446753, -0.801182, -0.903215>,
      < -0.446764, -0.781465, -0.919169>
    }
    triangle {
      < -0.446001, -0.964473, -1.062647>,
      < -0.446764, -0.781465, -0.919169>,
      < -0.446011, -0.946726, -1.080379>
    }
    triangle {
      < -0.446001, -0.964473, -1.062647>,
      < -0.446751, -0.803952, -0.897786>,
      < -0.446753, -0.801182, -0.903215>
    }
    triangle {
      < -0.446011, -0.946726, -1.080379>,
      < -0.446764, -0.781465, -0.919169>,
      < -0.254672, -0.781351, -0.919169>
    }
    triangle {
      < -0.446011, -0.946726, -1.080379>,
      < -0.254672, -0.781351, -0.919169>,
      < -0.290668, -0.946634, -1.080379>
    }
    triangle {
      < -0.290659, -0.964380, -1.062647>,
      < -0.254659, -0.803839, -0.897786>,
      < -0.446751, -0.803952, -0.897786>
    }
    triangle {
      < -0.290659, -0.964380, -1.062647>,
      < -0.446751, -0.803952, -0.897786>,
      < -0.446001, -0.964473, -1.062647>
    }
    triangle {
      < 0.488515, -0.814344, -0.952633>,
      < 0.519332, -0.800610, -0.903215>,
      < 0.520632, -0.803379, -0.897786>
    }
    triangle {
      < 0.488515, -0.814344, -0.952633>,
      < 0.520632, -0.803379, -0.897786>,
      < 0.488528, -0.836289, -0.930707>
    }
    triangle {
      < 0.488515, -0.814344, -0.952633>,
      < 0.521150, -0.780891, -0.919169>,
      < 0.519332, -0.800610, -0.903215>
    }
    triangle {
      < -0.217089, -0.964337, -1.062647>,
      < -0.163686, -0.801015, -0.903215>,
      < -0.163697, -0.781297, -0.919169>
    }
    triangle {
      < -0.217089, -0.964337, -1.062647>,
      < -0.163697, -0.781297, -0.919169>,
      < -0.217099, -0.946590, -1.080379>
    }
    triangle {
      < -0.217089, -0.964337, -1.062647>,
      < -0.163685, -0.803785, -0.897786>,
      < -0.163686, -0.801015, -0.903215>
    }
    triangle {
      < -0.217099, -0.946590, -1.080379>,
      < -0.163697, -0.781297, -0.919169>,
      < 0.521150, -0.780891, -0.919169>
    }
    triangle {
      < -0.217099, -0.946590, -1.080379>,
      < 0.521150, -0.780891, -0.919169>,
      < 0.488515, -0.814344, -0.952633>
    }
    triangle {
      < 0.488528, -0.836289, -0.930707>,
      < 0.520632, -0.803379, -0.897786>,
      < -0.163685, -0.803785, -0.897786>
    }
    triangle {
      < 0.488528, -0.836289, -0.930707>,
      < -0.163685, -0.803785, -0.897786>,
      < -0.217089, -0.964337, -1.062647>
    }
    triangle {
      < 0.488400, -0.620397, -0.930514>,
      < 0.488413, -0.642303, -0.952479>,
      < -0.217357, -0.510668, -1.079991>
    }
    triangle {
      < 0.488400, -0.620397, -0.930514>,
      < -0.217357, -0.510668, -1.079991>,
      < -0.217368, -0.492952, -1.062228>
    }
    triangle {
      < -0.290938, -0.492996, -1.062228>,
      < -0.290927, -0.510712, -1.079991>,
      < -0.446269, -0.510804, -1.079991>
    }
    triangle {
      < -0.290938, -0.492996, -1.062228>,
      < -0.446269, -0.510804, -1.079991>,
      < -0.446280, -0.493088, -1.062228>
    }
    triangle {
      < 0.488515, -0.814344, -0.952633>,
      < 0.488528, -0.836289, -0.930707>,
      < -0.217089, -0.964337, -1.062647>
    }
    triangle {
      < 0.488515, -0.814344, -0.952633>,
      < -0.217089, -0.964337, -1.062647>,
      < -0.217099, -0.946590, -1.080379>
    }
    triangle {
      < -0.290668, -0.946634, -1.080379>,
      < -0.290659, -0.964380, -1.062647>,
      < -0.446001, -0.964473, -1.062647>
    }
    triangle {
      < -0.290668, -0.946634, -1.080379>,
      < -0.446001, -0.964473, -1.062647>,
      < -0.446011, -0.946726, -1.080379>
    }
    triangle {
      < 0.488413, -0.642560, -0.736689>,
      < 0.488400, -0.620601, -0.758602>,
      < -0.217368, -0.493468, -0.626585>
    }
    triangle {
      < 0.488413, -0.642560, -0.736689>,
      < -0.217368, -0.493468, -0.626585>,
      < -0.217357, -0.511226, -0.608865>
    }
    triangle {
      < -0.290927, -0.511270, -0.608865>,
      < -0.290938, -0.493513, -0.626585>,
      < -0.446280, -0.493604, -0.626585>
    }
    triangle {
      < -0.290927, -0.511270, -0.608865>,
      < -0.446280, -0.493604, -0.626585>,
      < -0.446269, -0.511362, -0.608865>
    }
    triangle {
      < 0.488528, -0.836391, -0.758794>,
      < 0.488515, -0.814472, -0.736842>,
      < -0.217099, -0.946869, -0.609252>
    }
    triangle {
      < 0.488528, -0.836391, -0.758794>,
      < -0.217099, -0.946869, -0.609252>,
      < -0.217089, -0.964595, -0.627004>
    }
    triangle {
      < -0.290659, -0.964639, -0.627004>,
      < -0.290668, -0.946913, -0.609252>,
      < -0.446011, -0.947005, -0.609252>
    }
    triangle {
      < -0.290659, -0.964639, -0.627004>,
      < -0.446011, -0.947005, -0.609252>,
      < -0.446001, -0.964731, -0.627004>
    }
    triangle {
      < 0.916814, -0.641348, -0.877888>,
      < 0.521177, -0.653978, -0.897004>,
      < -0.163773, -0.654384, -0.897004>
    }
    triangle {
      < 0.916814, -0.641348, -0.877888>,
      < 0.916825, -0.662430, -0.910402>,
      < 0.518899, -0.662666, -0.910402>
    }
    triangle {
      < 0.916814, -0.641348, -0.877888>,
      < 0.518899, -0.662666, -0.910402>,
      < 0.521177, -0.653978, -0.897004>
    }
    triangle {
      < -0.254748, -0.654438, -0.897004>,
      < 0.916814, -0.641348, -0.877888>,
      < -0.163773, -0.654384, -0.897004>
    }
    triangle {
      < -0.163768, -0.663071, -0.910402>,
      < -0.254748, -0.654438, -0.897004>,
      < -0.163773, -0.654384, -0.897004>
    }
    triangle {
      < -0.254748, -0.654438, -0.897004>,
      < -0.446840, -0.654551, -0.897004>,
      < -0.471378, -0.642170, -0.877888>
    }
    triangle {
      < -0.254748, -0.654438, -0.897004>,
      < -0.471378, -0.642170, -0.877888>,
      < 0.916814, -0.641348, -0.877888>
    }
    triangle {
      < -0.446840, -0.654551, -0.897004>,
      < -0.446835, -0.663239, -0.910402>,
      < -0.471365, -0.663253, -0.910402>
    }
    triangle {
      < -0.446840, -0.654551, -0.897004>,
      < -0.471365, -0.663253, -0.910402>,
      < -0.471378, -0.642170, -0.877888>
    }
    triangle {
      < -0.163768, -0.663071, -0.910402>,
      < -0.254742, -0.663125, -0.910402>,
      < -0.254748, -0.654438, -0.897004>
    }
    triangle {
      < -0.471375, -0.646217, -0.802397>,
      < -0.446840, -0.654570, -0.792086>,
      < -0.254748, -0.654456, -0.792085>
    }
    triangle {
      < -0.471375, -0.646217, -0.802397>,
      < -0.471361, -0.670567, -0.772391>,
      < -0.446830, -0.670552, -0.772391>
    }
    triangle {
      < -0.471375, -0.646217, -0.802397>,
      < -0.446830, -0.670552, -0.772391>,
      < -0.446840, -0.654570, -0.792086>
    }
    triangle {
      < -0.163773, -0.654402, -0.792085>,
      < -0.471375, -0.646217, -0.802397>,
      < -0.254748, -0.654456, -0.792085>
    }
    triangle {
      < -0.254738, -0.670439, -0.772391>,
      < -0.163773, -0.654402, -0.792085>,
      < -0.254748, -0.654456, -0.792085>
    }
    triangle {
      < -0.163773, -0.654402, -0.792085>,
      < 0.521074, -0.653997, -0.792085>,
      < 0.916816, -0.645394, -0.802397>
    }
    triangle {
      < -0.163773, -0.654402, -0.792085>,
      < 0.916816, -0.645394, -0.802397>,
      < -0.471375, -0.646217, -0.802397>
    }
    triangle {
      < 0.521074, -0.653997, -0.792085>,
      < 0.519253, -0.669980, -0.772391>,
      < 0.916830, -0.669744, -0.772391>
    }
    triangle {
      < 0.521074, -0.653997, -0.792085>,
      < 0.916830, -0.669744, -0.772391>,
      < 0.916816, -0.645394, -0.802397>
    }
    triangle {
      < -0.254738, -0.670439, -0.772391>,
      < -0.163763, -0.670385, -0.772391>,
      < -0.163773, -0.654402, -0.792085>
    }
    triangle {
      < 0.916851, -0.704192, -0.754881>,
      < 0.520556, -0.675412, -0.769629>,
      < -0.163760, -0.675818, -0.769630>
    }
    triangle {
      < 0.916851, -0.704192, -0.754881>,
      < 0.916830, -0.669744, -0.772391>,
      < 0.519253, -0.669980, -0.772391>
    }
    triangle {
      < 0.916851, -0.704192, -0.754881>,
      < 0.519253, -0.669980, -0.772391>,
      < 0.520556, -0.675412, -0.769629>
    }
    triangle {
      < -0.254735, -0.675872, -0.769630>,
      < 0.916851, -0.704192, -0.754881>,
      < -0.163760, -0.675818, -0.769630>
    }
    triangle {
      < -0.163763, -0.670385, -0.772391>,
      < -0.254735, -0.675872, -0.769630>,
      < -0.163760, -0.675818, -0.769630>
    }
    triangle {
      < -0.254735, -0.675872, -0.769630>,
      < -0.446828, -0.675986, -0.769630>,
      < -0.471341, -0.705015, -0.754881>
    }
    triangle {
      < -0.254735, -0.675872, -0.769630>,
      < -0.471341, -0.705015, -0.754881>,
      < 0.916851, -0.704192, -0.754881>
    }
    triangle {
      < -0.446828, -0.675986, -0.769630>,
      < -0.446830, -0.670552, -0.772391>,
      < -0.471361, -0.670567, -0.772391>
    }
    triangle {
      < -0.446828, -0.675986, -0.769630>,
      < -0.471361, -0.670567, -0.772391>,
      < -0.471341, -0.705015, -0.754881>
    }
    triangle {
      < -0.163763, -0.670385, -0.772391>,
      < -0.254738, -0.670439, -0.772391>,
      < -0.254735, -0.675872, -0.769630>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < 0.520370, -0.781778, -0.769468>,
      < 0.916895, -0.778850, -0.766771>
    }
    triangle {
      < 0.520370, -0.781778, -0.769468>,
      < 0.520383, -0.803697, -0.791420>,
      < 0.916911, -0.806155, -0.794117>
    }
    triangle {
      < 0.520370, -0.781778, -0.769468>,
      < 0.916911, -0.806155, -0.794117>,
      < 0.916895, -0.778850, -0.766771>
    }
    triangle {
      < 0.520383, -0.803697, -0.791420>,
      < -0.163684, -0.804103, -0.791420>,
      < 0.916911, -0.806155, -0.794117>
    }
    triangle {
      < -0.163684, -0.804103, -0.791420>,
      < -0.254659, -0.804157, -0.791420>,
      < 0.916911, -0.806155, -0.794117>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < -0.163697, -0.782184, -0.769469>,
      < 0.520370, -0.781778, -0.769468>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < -0.254672, -0.782238, -0.769469>,
      < -0.163697, -0.782184, -0.769469>
    }
    triangle {
      < -0.254672, -0.782238, -0.769469>,
      < -0.163684, -0.804103, -0.791420>,
      < -0.163697, -0.782184, -0.769469>
    }
    triangle {
      < -0.254672, -0.782238, -0.769469>,
      < -0.254659, -0.804157, -0.791420>,
      < -0.163684, -0.804103, -0.791420>
    }
    triangle {
      < -0.254659, -0.804157, -0.791420>,
      < -0.446751, -0.804271, -0.791420>,
      < -0.471280, -0.806978, -0.794117>
    }
    triangle {
      < -0.254659, -0.804157, -0.791420>,
      < -0.471280, -0.806978, -0.794117>,
      < 0.916911, -0.806155, -0.794117>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < -0.446764, -0.782351, -0.769469>,
      < -0.254672, -0.782238, -0.769469>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < -0.446751, -0.804271, -0.791420>,
      < -0.446764, -0.782351, -0.769469>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < -0.471280, -0.806978, -0.794117>,
      < -0.446751, -0.804271, -0.791420>
    }
    triangle {
      < -0.471273, -0.818758, -0.868792>,
      < -0.446751, -0.803952, -0.897786>,
      < -0.254659, -0.803839, -0.897786>
    }
    triangle {
      < -0.471273, -0.818758, -0.868792>,
      < -0.471283, -0.801196, -0.903215>,
      < -0.446753, -0.801182, -0.903215>
    }
    triangle {
      < -0.471273, -0.818758, -0.868792>,
      < -0.446753, -0.801182, -0.903215>,
      < -0.446751, -0.803952, -0.897786>
    }
    triangle {
      < -0.163685, -0.803785, -0.897786>,
      < -0.471273, -0.818758, -0.868792>,
      < -0.254659, -0.803839, -0.897786>
    }
    triangle {
      < -0.254660, -0.801069, -0.903215>,
      < -0.163685, -0.803785, -0.897786>,
      < -0.254659, -0.803839, -0.897786>
    }
    triangle {
      < -0.163685, -0.803785, -0.897786>,
      < 0.520632, -0.803379, -0.897786>,
      < 0.916918, -0.817936, -0.868791>
    }
    triangle {
      < -0.163685, -0.803785, -0.897786>,
      < 0.916918, -0.817936, -0.868791>,
      < -0.471273, -0.818758, -0.868792>
    }
    triangle {
      < 0.520632, -0.803379, -0.897786>,
      < 0.519332, -0.800610, -0.903215>,
      < 0.916907, -0.800374, -0.903215>
    }
    triangle {
      < 0.520632, -0.803379, -0.897786>,
      < 0.916907, -0.800374, -0.903215>,
      < 0.916918, -0.817936, -0.868791>
    }
    triangle {
      < -0.254660, -0.801069, -0.903215>,
      < -0.163686, -0.801015, -0.903215>,
      < -0.163685, -0.803785, -0.897786>
    }
    triangle {
      < 0.916890, -0.770332, -0.927521>,
      < 0.521150, -0.780891, -0.919169>,
      < -0.163697, -0.781297, -0.919169>
    }
    triangle {
      < 0.916890, -0.770332, -0.927521>,
      < 0.916907, -0.800374, -0.903215>,
      < 0.519332, -0.800610, -0.903215>
    }
    triangle {
      < 0.916890, -0.770332, -0.927521>,
      < 0.519332, -0.800610, -0.903215>,
      < 0.521150, -0.780891, -0.919169>
    }
    triangle {
      < -0.254672, -0.781351, -0.919169>,
      < 0.916890, -0.770332, -0.927521>,
      < -0.163697, -0.781297, -0.919169>
    }
    triangle {
      < -0.163686, -0.801015, -0.903215>,
      < -0.254672, -0.781351, -0.919169>,
      < -0.163697, -0.781297, -0.919169>
    }
    triangle {
      < -0.254672, -0.781351, -0.919169>,
      < -0.446764, -0.781465, -0.919169>,
      < -0.471301, -0.771154, -0.927521>
    }
    triangle {
      < -0.254672, -0.781351, -0.919169>,
      < -0.471301, -0.771154, -0.927521>,
      < 0.916890, -0.770332, -0.927521>
    }
    triangle {
      < -0.446764, -0.781465, -0.919169>,
      < -0.446753, -0.801182, -0.903215>,
      < -0.471283, -0.801196, -0.903215>
    }
    triangle {
      < -0.446764, -0.781465, -0.919169>,
      < -0.471283, -0.801196, -0.903215>,
      < -0.471301, -0.771154, -0.927521>
    }
    triangle {
      < -0.163686, -0.801015, -0.903215>,
      < -0.254660, -0.801069, -0.903215>,
      < -0.254672, -0.781351, -0.919169>
    }
    triangle {
      < -0.471346, -0.695659, -0.931455>,
      < -0.446827, -0.676445, -0.918981>,
      < -0.254734, -0.676331, -0.918981>
    }
    triangle {
      < -0.471346, -0.695659, -0.931455>,
      < -0.471365, -0.663253, -0.910402>,
      < -0.446835, -0.663239, -0.910402>
    }
    triangle {
      < -0.471346, -0.695659, -0.931455>,
      < -0.446835, -0.663239, -0.910402>,
      < -0.446827, -0.676445, -0.918981>
    }
    triangle {
      < -0.163759, -0.676277, -0.918981>,
      < -0.471346, -0.695659, -0.931455>,
      < -0.254734, -0.676331, -0.918981>
    }
    triangle {
      < -0.254742, -0.663125, -0.910402>,
      < -0.163759, -0.676277, -0.918981>,
      < -0.254734, -0.676331, -0.918981>
    }
    triangle {
      < -0.163759, -0.676277, -0.918981>,
      < 0.521178, -0.675871, -0.918981>,
      < 0.916845, -0.694836, -0.931454>
    }
    triangle {
      < -0.163759, -0.676277, -0.918981>,
      < 0.916845, -0.694836, -0.931454>,
      < -0.471346, -0.695659, -0.931455>
    }
    triangle {
      < 0.521178, -0.675871, -0.918981>,
      < 0.518899, -0.662666, -0.910402>,
      < 0.916825, -0.662430, -0.910402>
    }
    triangle {
      < 0.521178, -0.675871, -0.918981>,
      < 0.916825, -0.662430, -0.910402>,
      < 0.916845, -0.694836, -0.931454>
    }
    triangle {
      < -0.254742, -0.663125, -0.910402>,
      < -0.163768, -0.663071, -0.910402>,
      < -0.163759, -0.676277, -0.918981>
    }
    triangle {
      < 1.139523, -0.675447, -0.897259>,
      < 1.139539, -0.701371, -0.914101>,
      < 0.916845, -0.694836, -0.931454>
    }
    triangle {
      < 1.139523, -0.675447, -0.897259>,
      < 0.916845, -0.694836, -0.931454>,
      < 0.916825, -0.662430, -0.910402>
    }
    triangle {
      < 1.139513, -0.658581, -0.871247>,
      < 1.139523, -0.675447, -0.897259>,
      < 0.916825, -0.662430, -0.910402>
    }
    triangle {
      < 1.139513, -0.658581, -0.871247>,
      < 0.916825, -0.662430, -0.910402>,
      < 0.916814, -0.641348, -0.877888>
    }
    triangle {
      < -0.471378, -0.642170, -0.877888>,
      < -0.471365, -0.663253, -0.910402>,
      < -0.482926, -0.676408, -0.897259>
    }
    triangle {
      < -0.471378, -0.642170, -0.877888>,
      < -0.482926, -0.676408, -0.897259>,
      < -0.482936, -0.659542, -0.871247>
    }
    triangle {
      < -0.471365, -0.663253, -0.910402>,
      < -0.471346, -0.695659, -0.931455>,
      < -0.482910, -0.702332, -0.914101>
    }
    triangle {
      < -0.471365, -0.663253, -0.910402>,
      < -0.482910, -0.702332, -0.914101>,
      < -0.482926, -0.676408, -0.897259>
    }
    triangle {
      < 0.916845, -0.694836, -0.931454>,
      < 0.916868, -0.733002, -0.937510>,
      < -0.471324, -0.733825, -0.937510>
    }
    triangle {
      < 0.916845, -0.694836, -0.931454>,
      < -0.471324, -0.733825, -0.937510>,
      < -0.471346, -0.695659, -0.931455>
    }
    triangle {
      < -0.471346, -0.695659, -0.931455>,
      < -0.471324, -0.733825, -0.937510>,
      < -0.482892, -0.732865, -0.918945>
    }
    triangle {
      < -0.471346, -0.695659, -0.931455>,
      < -0.482892, -0.732865, -0.918945>,
      < -0.482910, -0.702332, -0.914101>
    }
    triangle {
      < 1.139539, -0.701371, -0.914101>,
      < 1.139557, -0.731903, -0.918945>,
      < 0.916868, -0.733002, -0.937510>
    }
    triangle {
      < 1.139539, -0.701371, -0.914101>,
      < 0.916868, -0.733002, -0.937510>,
      < 0.916845, -0.694836, -0.931454>
    }
    triangle {
      < 0.916810, -0.635350, -0.839712>,
      < 0.916814, -0.641348, -0.877888>,
      < -0.471378, -0.642170, -0.877888>
    }
    triangle {
      < 0.916810, -0.635350, -0.839712>,
      < -0.471378, -0.642170, -0.877888>,
      < -0.471381, -0.636172, -0.839713>
    }
    triangle {
      < 1.139511, -0.653780, -0.840707>,
      < 1.139513, -0.658581, -0.871247>,
      < 0.916814, -0.641348, -0.877888>
    }
    triangle {
      < 1.139511, -0.653780, -0.840707>,
      < 0.916814, -0.641348, -0.877888>,
      < 0.916810, -0.635350, -0.839712>
    }
    triangle {
      < -0.471381, -0.636172, -0.839713>,
      < -0.471378, -0.642170, -0.877888>,
      < -0.482936, -0.659542, -0.871247>
    }
    triangle {
      < -0.471381, -0.636172, -0.839713>,
      < -0.482936, -0.659542, -0.871247>,
      < -0.482939, -0.654742, -0.840707>
    }
    triangle {
      < 1.237855, -0.675885, -0.864607>,
      < 1.237862, -0.688535, -0.884115>,
      < 1.139523, -0.675447, -0.897259>
    }
    triangle {
      < 1.237855, -0.675885, -0.864607>,
      < 1.139523, -0.675447, -0.897259>,
      < 1.139513, -0.658581, -0.871247>
    }
    triangle {
      < -0.482936, -0.659542, -0.871247>,
      < -0.482926, -0.676408, -0.897259>,
      < -0.399045, -0.695140, -0.878483>
    }
    triangle {
      < -0.482936, -0.659542, -0.871247>,
      < -0.399045, -0.695140, -0.878483>,
      < -0.399051, -0.684297, -0.861762>
    }
    triangle {
      < 1.237862, -0.688535, -0.884115>,
      < 1.237873, -0.707978, -0.896747>,
      < 1.139539, -0.701371, -0.914101>
    }
    triangle {
      < 1.237862, -0.688535, -0.884115>,
      < 1.139539, -0.701371, -0.914101>,
      < 1.139523, -0.675447, -0.897259>
    }
    triangle {
      < -0.482926, -0.676408, -0.897259>,
      < -0.482910, -0.702332, -0.914101>,
      < -0.399035, -0.711805, -0.889310>
    }
    triangle {
      < -0.482926, -0.676408, -0.897259>,
      < -0.399035, -0.711805, -0.889310>,
      < -0.399045, -0.695140, -0.878483>
    }
    triangle {
      < 1.237873, -0.707978, -0.896747>,
      < 1.237887, -0.730878, -0.900381>,
      < 1.139557, -0.731903, -0.918945>
    }
    triangle {
      < 1.237873, -0.707978, -0.896747>,
      < 1.139557, -0.731903, -0.918945>,
      < 1.139539, -0.701371, -0.914101>
    }
    triangle {
      < -0.482910, -0.702332, -0.914101>,
      < -0.482892, -0.732865, -0.918945>,
      < -0.399023, -0.731433, -0.892424>
    }
    triangle {
      < -0.482910, -0.702332, -0.914101>,
      < -0.399023, -0.731433, -0.892424>,
      < -0.399035, -0.711805, -0.889310>
    }
    triangle {
      < -0.482939, -0.654742, -0.840707>,
      < -0.482936, -0.659542, -0.871247>,
      < -0.399051, -0.684297, -0.861762>
    }
    triangle {
      < -0.482939, -0.654742, -0.840707>,
      < -0.399051, -0.684297, -0.861762>,
      < -0.399053, -0.681212, -0.842128>
    }
    triangle {
      < 1.237852, -0.672286, -0.841702>,
      < 1.237855, -0.675885, -0.864607>,
      < 1.139513, -0.658581, -0.871247>
    }
    triangle {
      < 1.237852, -0.672286, -0.841702>,
      < 1.139513, -0.658581, -0.871247>,
      < 1.139511, -0.653780, -0.840707>
    }
    triangle {
      < 1.139557, -0.731903, -0.918945>,
      < 1.139575, -0.761768, -0.910954>,
      < 0.916890, -0.770332, -0.927521>
    }
    triangle {
      < 1.139557, -0.731903, -0.918945>,
      < 0.916890, -0.770332, -0.927521>,
      < 0.916868, -0.733002, -0.937510>
    }
    triangle {
      < -0.471324, -0.733825, -0.937510>,
      < -0.471301, -0.771154, -0.927521>,
      < -0.482875, -0.762729, -0.910954>
    }
    triangle {
      < -0.471324, -0.733825, -0.937510>,
      < -0.482875, -0.762729, -0.910954>,
      < -0.482892, -0.732865, -0.918945>
    }
    triangle {
      < 0.916868, -0.733002, -0.937510>,
      < 0.916890, -0.770332, -0.927521>,
      < -0.471301, -0.771154, -0.927521>
    }
    triangle {
      < 0.916868, -0.733002, -0.937510>,
      < -0.471301, -0.771154, -0.927521>,
      < -0.471324, -0.733825, -0.937510>
    }
    triangle {
      < 1.139515, -0.661816, -0.810854>,
      < 1.139511, -0.653780, -0.840707>,
      < 0.916810, -0.635350, -0.839712>
    }
    triangle {
      < 1.139515, -0.661816, -0.810854>,
      < 0.916810, -0.635350, -0.839712>,
      < 0.916816, -0.645394, -0.802397>
    }
    triangle {
      < 0.916816, -0.645394, -0.802397>,
      < 0.916810, -0.635350, -0.839712>,
      < -0.471381, -0.636172, -0.839713>
    }
    triangle {
      < 0.916816, -0.645394, -0.802397>,
      < -0.471381, -0.636172, -0.839713>,
      < -0.471375, -0.646217, -0.802397>
    }
    triangle {
      < -0.471375, -0.646217, -0.802397>,
      < -0.471381, -0.636172, -0.839713>,
      < -0.482939, -0.654742, -0.840707>
    }
    triangle {
      < -0.471375, -0.646217, -0.802397>,
      < -0.482939, -0.654742, -0.840707>,
      < -0.482934, -0.662778, -0.810855>
    }
    triangle {
      < 1.292815, -0.695697, -0.857017>,
      < 1.292819, -0.703528, -0.869094>,
      < 1.237862, -0.688535, -0.884115>
    }
    triangle {
      < 1.292815, -0.695697, -0.857017>,
      < 1.237862, -0.688535, -0.884115>,
      < 1.237855, -0.675885, -0.864607>
    }
    triangle {
      < 1.292819, -0.703528, -0.869094>,
      < 1.292827, -0.715564, -0.876914>,
      < 1.237873, -0.707978, -0.896747>
    }
    triangle {
      < 1.292819, -0.703528, -0.869094>,
      < 1.237873, -0.707978, -0.896747>,
      < 1.237862, -0.688535, -0.884115>
    }
    triangle {
      < 1.292827, -0.715564, -0.876914>,
      < 1.292835, -0.729740, -0.879163>,
      < 1.237887, -0.730878, -0.900381>
    }
    triangle {
      < 1.292827, -0.715564, -0.876914>,
      < 1.237887, -0.730878, -0.900381>,
      < 1.237873, -0.707978, -0.896747>
    }
    triangle {
      < 1.292813, -0.693469, -0.842838>,
      < 1.292815, -0.695697, -0.857017>,
      < 1.237855, -0.675885, -0.864607>
    }
    triangle {
      < 1.292813, -0.693469, -0.842838>,
      < 1.237855, -0.675885, -0.864607>,
      < 1.237852, -0.672286, -0.841702>
    }
    triangle {
      < 1.237887, -0.730878, -0.900381>,
      < 1.237900, -0.753276, -0.894387>,
      < 1.139575, -0.761768, -0.910954>
    }
    triangle {
      < 1.237887, -0.730878, -0.900381>,
      < 1.139575, -0.761768, -0.910954>,
      < 1.139557, -0.731903, -0.918945>
    }
    triangle {
      < -0.482892, -0.732865, -0.918945>,
      < -0.482875, -0.762729, -0.910954>,
      < -0.399012, -0.750632, -0.887287>
    }
    triangle {
      < -0.482892, -0.732865, -0.918945>,
      < -0.399012, -0.750632, -0.887287>,
      < -0.399023, -0.731433, -0.892424>
    }
    triangle {
      < 1.237856, -0.678313, -0.819313>,
      < 1.237852, -0.672286, -0.841702>,
      < 1.139511, -0.653780, -0.840707>
    }
    triangle {
      < 1.237856, -0.678313, -0.819313>,
      < 1.139511, -0.653780, -0.840707>,
      < 1.139515, -0.661816, -0.810854>
    }
    triangle {
      < -0.482934, -0.662778, -0.810855>,
      < -0.482939, -0.654742, -0.840707>,
      < -0.399053, -0.681212, -0.842128>
    }
    triangle {
      < -0.482934, -0.662778, -0.810855>,
      < -0.399053, -0.681212, -0.842128>,
      < -0.399050, -0.686377, -0.822937>
    }
    triangle {
      < -0.399051, -0.684297, -0.861762>,
      < -0.399045, -0.695140, -0.878483>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < -0.399045, -0.695140, -0.878483>,
      < -0.399035, -0.711805, -0.889310>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < -0.399035, -0.711805, -0.889310>,
      < -0.399023, -0.731433, -0.892424>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < -0.399053, -0.681212, -0.842128>,
      < -0.399051, -0.684297, -0.861762>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.292835, -0.729740, -0.879163>,
      < 1.292843, -0.743605, -0.875454>,
      < 1.237900, -0.753276, -0.894387>
    }
    triangle {
      < 1.292835, -0.729740, -0.879163>,
      < 1.237900, -0.753276, -0.894387>,
      < 1.237887, -0.730878, -0.900381>
    }
    triangle {
      < 1.292816, -0.697199, -0.828978>,
      < 1.292813, -0.693469, -0.842838>,
      < 1.237852, -0.672286, -0.841702>
    }
    triangle {
      < 1.292816, -0.697199, -0.828978>,
      < 1.237852, -0.672286, -0.841702>,
      < 1.237856, -0.678313, -0.819313>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292827, -0.715564, -0.876914>,
      < 1.292819, -0.703528, -0.869094>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292819, -0.703528, -0.869094>,
      < 1.292815, -0.695697, -0.857017>
    }
    triangle {
      < -0.399023, -0.731433, -0.892424>,
      < -0.399012, -0.750632, -0.887287>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < -0.399050, -0.686377, -0.822937>,
      < -0.399053, -0.681212, -0.842128>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292835, -0.729740, -0.879163>,
      < 1.292827, -0.715564, -0.876914>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292815, -0.695697, -0.857017>,
      < 1.292813, -0.693469, -0.842838>
    }
    triangle {
      < -0.471301, -0.771154, -0.927521>,
      < -0.471283, -0.801196, -0.903215>,
      < -0.482861, -0.786762, -0.891510>
    }
    triangle {
      < -0.471301, -0.771154, -0.927521>,
      < -0.482861, -0.786762, -0.891510>,
      < -0.482875, -0.762729, -0.910954>
    }
    triangle {
      < 1.139575, -0.761768, -0.910954>,
      < 1.139589, -0.785801, -0.891510>,
      < 0.916907, -0.800374, -0.903215>
    }
    triangle {
      < 1.139575, -0.761768, -0.910954>,
      < 0.916907, -0.800374, -0.903215>,
      < 0.916890, -0.770332, -0.927521>
    }
    triangle {
      < -0.471361, -0.670567, -0.772391>,
      < -0.471375, -0.646217, -0.802397>,
      < -0.482934, -0.662778, -0.810855>
    }
    triangle {
      < -0.471361, -0.670567, -0.772391>,
      < -0.482934, -0.662778, -0.810855>,
      < -0.482923, -0.682258, -0.786850>
    }
    triangle {
      < 1.139527, -0.681297, -0.786850>,
      < 1.139515, -0.661816, -0.810854>,
      < 0.916816, -0.645394, -0.802397>
    }
    triangle {
      < 1.139527, -0.681297, -0.786850>,
      < 0.916816, -0.645394, -0.802397>,
      < 0.916830, -0.669744, -0.772391>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292843, -0.743605, -0.875454>,
      < 1.292835, -0.729740, -0.879163>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292813, -0.693469, -0.842838>,
      < 1.292816, -0.697199, -0.828978>
    }
    triangle {
      < 1.237900, -0.753276, -0.894387>,
      < 1.237910, -0.771301, -0.879803>,
      < 1.139589, -0.785801, -0.891510>
    }
    triangle {
      < 1.237900, -0.753276, -0.894387>,
      < 1.139589, -0.785801, -0.891510>,
      < 1.139575, -0.761768, -0.910954>
    }
    triangle {
      < -0.482875, -0.762729, -0.910954>,
      < -0.482861, -0.786762, -0.891510>,
      < -0.399002, -0.766082, -0.874787>
    }
    triangle {
      < -0.482875, -0.762729, -0.910954>,
      < -0.399002, -0.766082, -0.874787>,
      < -0.399012, -0.750632, -0.887287>
    }
    triangle {
      < 1.237864, -0.692922, -0.801309>,
      < 1.237856, -0.678313, -0.819313>,
      < 1.139515, -0.661816, -0.810854>
    }
    triangle {
      < 1.237864, -0.692922, -0.801309>,
      < 1.139515, -0.661816, -0.810854>,
      < 1.139527, -0.681297, -0.786850>
    }
    triangle {
      < -0.482923, -0.682258, -0.786850>,
      < -0.482934, -0.662778, -0.810855>,
      < -0.399050, -0.686377, -0.822937>
    }
    triangle {
      < -0.482923, -0.682258, -0.786850>,
      < -0.399050, -0.686377, -0.822937>,
      < -0.399043, -0.698901, -0.807507>
    }
    triangle {
      < 1.292843, -0.743605, -0.875454>,
      < 1.292850, -0.754764, -0.866425>,
      < 1.237910, -0.771301, -0.879803>
    }
    triangle {
      < 1.292843, -0.743605, -0.875454>,
      < 1.237910, -0.771301, -0.879803>,
      < 1.237900, -0.753276, -0.894387>
    }
    triangle {
      < 1.292821, -0.706245, -0.817834>,
      < 1.292816, -0.697199, -0.828978>,
      < 1.237856, -0.678313, -0.819313>
    }
    triangle {
      < 1.292821, -0.706245, -0.817834>,
      < 1.237856, -0.678313, -0.819313>,
      < 1.237864, -0.692922, -0.801309>
    }
    triangle {
      < -0.399012, -0.750632, -0.887287>,
      < -0.399002, -0.766082, -0.874787>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < -0.399043, -0.698901, -0.807507>,
      < -0.399050, -0.686377, -0.822937>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292850, -0.754764, -0.866425>,
      < 1.292843, -0.743605, -0.875454>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292816, -0.697199, -0.828978>,
      < 1.292821, -0.706245, -0.817834>
    }
    triangle {
      < -0.399032, -0.716617, -0.798501>,
      < -0.399043, -0.698901, -0.807507>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292854, -0.761287, -0.853639>,
      < 1.292850, -0.754764, -0.866425>
    }
    triangle {
      < -0.399020, -0.736465, -0.797478>,
      < -0.399032, -0.716617, -0.798501>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < -0.399001, -0.769055, -0.818679>,
      < -0.399010, -0.755012, -0.804616>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < -0.399010, -0.755012, -0.804616>,
      < -0.399020, -0.736465, -0.797478>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292845, -0.746770, -0.815747>,
      < 1.292851, -0.756911, -0.825903>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292821, -0.706245, -0.817834>,
      < 1.292828, -0.719039, -0.811330>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292828, -0.719039, -0.811330>,
      < 1.292837, -0.733374, -0.810591>
    }
    triangle {
      < -0.399002, -0.766082, -0.874787>,
      < -0.398997, -0.775114, -0.857083>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292854, -0.762046, -0.839306>,
      < 1.292854, -0.761287, -0.853639>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292837, -0.733374, -0.810591>,
      < 1.292845, -0.746770, -0.815747>
    }
    triangle {
      < -0.398997, -0.775114, -0.857083>,
      < -0.398997, -0.776165, -0.837238>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.339107, -0.727916, -0.844686>,
      < 1.292851, -0.756911, -0.825903>,
      < 1.292854, -0.762046, -0.839306>
    }
    triangle {
      < -0.398997, -0.776165, -0.837238>,
      < -0.399001, -0.769055, -0.818679>,
      < -0.381673, -0.728936, -0.844687>
    }
    triangle {
      < 1.292850, -0.754764, -0.866425>,
      < 1.292854, -0.761287, -0.853639>,
      < 1.237917, -0.781838, -0.859150>
    }
    triangle {
      < 1.292850, -0.754764, -0.866425>,
      < 1.237917, -0.781838, -0.859150>,
      < 1.237910, -0.771301, -0.879803>
    }
    triangle {
      < 1.292828, -0.719039, -0.811330>,
      < 1.292821, -0.706245, -0.817834>,
      < 1.237864, -0.692922, -0.801309>
    }
    triangle {
      < 1.292828, -0.719039, -0.811330>,
      < 1.237864, -0.692922, -0.801309>,
      < 1.237876, -0.713592, -0.790803>
    }
    triangle {
      < -0.482861, -0.786762, -0.891510>,
      < -0.482853, -0.800811, -0.863971>,
      < -0.398997, -0.775114, -0.857083>
    }
    triangle {
      < -0.482861, -0.786762, -0.891510>,
      < -0.398997, -0.775114, -0.857083>,
      < -0.399002, -0.766082, -0.874787>
    }
    triangle {
      < -0.482906, -0.709818, -0.772842>,
      < -0.482923, -0.682258, -0.786850>,
      < -0.399043, -0.698901, -0.807507>
    }
    triangle {
      < -0.482906, -0.709818, -0.772842>,
      < -0.399043, -0.698901, -0.807507>,
      < -0.399032, -0.716617, -0.798501>
    }
    triangle {
      < 1.237910, -0.771301, -0.879803>,
      < 1.237917, -0.781838, -0.859150>,
      < 1.139597, -0.799850, -0.863971>
    }
    triangle {
      < 1.237910, -0.771301, -0.879803>,
      < 1.139597, -0.799850, -0.863971>,
      < 1.139589, -0.785801, -0.891510>
    }
    triangle {
      < 1.237876, -0.713592, -0.790803>,
      < 1.237864, -0.692922, -0.801309>,
      < 1.139527, -0.681297, -0.786850>
    }
    triangle {
      < 1.237876, -0.713592, -0.790803>,
      < 1.139527, -0.681297, -0.786850>,
      < 1.139543, -0.708856, -0.772842>
    }
    triangle {
      < -0.471283, -0.801196, -0.903215>,
      < -0.471273, -0.818758, -0.868792>,
      < -0.482853, -0.800811, -0.863971>
    }
    triangle {
      < -0.471283, -0.801196, -0.903215>,
      < -0.482853, -0.800811, -0.863971>,
      < -0.482861, -0.786762, -0.891510>
    }
    triangle {
      < 1.139589, -0.785801, -0.891510>,
      < 1.139597, -0.799850, -0.863971>,
      < 0.916918, -0.817936, -0.868791>
    }
    triangle {
      < 1.139589, -0.785801, -0.891510>,
      < 0.916918, -0.817936, -0.868791>,
      < 0.916907, -0.800374, -0.903215>
    }
    triangle {
      < 1.139543, -0.708856, -0.772842>,
      < 1.139527, -0.681297, -0.786850>,
      < 0.916830, -0.669744, -0.772391>
    }
    triangle {
      < 1.139543, -0.708856, -0.772842>,
      < 0.916830, -0.669744, -0.772391>,
      < 0.916851, -0.704192, -0.754881>
    }
    triangle {
      < -0.471341, -0.705015, -0.754881>,
      < -0.471361, -0.670567, -0.772391>,
      < -0.482923, -0.682258, -0.786850>
    }
    triangle {
      < -0.471341, -0.705015, -0.754881>,
      < -0.482923, -0.682258, -0.786850>,
      < -0.482906, -0.709818, -0.772842>
    }
    triangle {
      < 1.292854, -0.761287, -0.853639>,
      < 1.292854, -0.762046, -0.839306>,
      < 1.237918, -0.783064, -0.835996>
    }
    triangle {
      < 1.292854, -0.761287, -0.853639>,
      < 1.237918, -0.783064, -0.835996>,
      < 1.237917, -0.781838, -0.859150>
    }
    triangle {
      < 1.292837, -0.733374, -0.810591>,
      < 1.292828, -0.719039, -0.811330>,
      < 1.237876, -0.713592, -0.790803>
    }
    triangle {
      < 1.292837, -0.733374, -0.810591>,
      < 1.237876, -0.713592, -0.790803>,
      < 1.237891, -0.736748, -0.789611>
    }
    triangle {
      < -0.482853, -0.800811, -0.863971>,
      < -0.482851, -0.802447, -0.833100>,
      < -0.398997, -0.776165, -0.837238>
    }
    triangle {
      < -0.482853, -0.800811, -0.863971>,
      < -0.398997, -0.776165, -0.837238>,
      < -0.398997, -0.775114, -0.857083>
    }
    triangle {
      < -0.482888, -0.740691, -0.771253>,
      < -0.482906, -0.709818, -0.772842>,
      < -0.399032, -0.716617, -0.798501>
    }
    triangle {
      < -0.482888, -0.740691, -0.771253>,
      < -0.399032, -0.716617, -0.798501>,
      < -0.399020, -0.736465, -0.797478>
    }
    triangle {
      < 1.237917, -0.781838, -0.859150>,
      < 1.237918, -0.783064, -0.835996>,
      < 1.139598, -0.801485, -0.833100>
    }
    triangle {
      < 1.237917, -0.781838, -0.859150>,
      < 1.139598, -0.801485, -0.833100>,
      < 1.139597, -0.799850, -0.863971>
    }
    triangle {
      < 1.292854, -0.762046, -0.839306>,
      < 1.292851, -0.756911, -0.825903>,
      < 1.237913, -0.774770, -0.814345>
    }
    triangle {
      < 1.292854, -0.762046, -0.839306>,
      < 1.237913, -0.774770, -0.814345>,
      < 1.237918, -0.783064, -0.835996>
    }
    triangle {
      < 1.237891, -0.736748, -0.789611>,
      < 1.237876, -0.713592, -0.790803>,
      < 1.139543, -0.708856, -0.772842>
    }
    triangle {
      < 1.237891, -0.736748, -0.789611>,
      < 1.139543, -0.708856, -0.772842>,
      < 1.139562, -0.739729, -0.771252>
    }
    triangle {
      < 1.292845, -0.746770, -0.815747>,
      < 1.292837, -0.733374, -0.810591>,
      < 1.237891, -0.736748, -0.789611>
    }
    triangle {
      < 1.292845, -0.746770, -0.815747>,
      < 1.237891, -0.736748, -0.789611>,
      < 1.237903, -0.758387, -0.797937>
    }
    triangle {
      < 1.292851, -0.756911, -0.825903>,
      < 1.292845, -0.746770, -0.815747>,
      < 1.237903, -0.758387, -0.797937>
    }
    triangle {
      < 1.292851, -0.756911, -0.825903>,
      < 1.237903, -0.758387, -0.797937>,
      < 1.237913, -0.774770, -0.814345>
    }
    triangle {
      < -0.471273, -0.818758, -0.868792>,
      < -0.471272, -0.820802, -0.830203>,
      < -0.482851, -0.802447, -0.833100>
    }
    triangle {
      < -0.471273, -0.818758, -0.868792>,
      < -0.482851, -0.802447, -0.833100>,
      < -0.482853, -0.800811, -0.863971>
    }
    triangle {
      < 1.139597, -0.799850, -0.863971>,
      < 1.139598, -0.801485, -0.833100>,
      < 0.916919, -0.819979, -0.830203>
    }
    triangle {
      < 1.139597, -0.799850, -0.863971>,
      < 0.916919, -0.819979, -0.830203>,
      < 0.916918, -0.817936, -0.868791>
    }
    triangle {
      < 1.139562, -0.739729, -0.771252>,
      < 1.139543, -0.708856, -0.772842>,
      < 0.916851, -0.704192, -0.754881>
    }
    triangle {
      < 1.139562, -0.739729, -0.771252>,
      < 0.916851, -0.704192, -0.754881>,
      < 0.916873, -0.742785, -0.752893>
    }
    triangle {
      < -0.471317, -0.743608, -0.752893>,
      < -0.471341, -0.705015, -0.754881>,
      < -0.482906, -0.709818, -0.772842>
    }
    triangle {
      < -0.471317, -0.743608, -0.752893>,
      < -0.482906, -0.709818, -0.772842>,
      < -0.482888, -0.740691, -0.771253>
    }
    triangle {
      < -0.482851, -0.802447, -0.833100>,
      < -0.482858, -0.791388, -0.804231>,
      < -0.399001, -0.769055, -0.818679>
    }
    triangle {
      < -0.482851, -0.802447, -0.833100>,
      < -0.399001, -0.769055, -0.818679>,
      < -0.398997, -0.776165, -0.837238>
    }
    triangle {
      < -0.482871, -0.769544, -0.782355>,
      < -0.482888, -0.740691, -0.771253>,
      < -0.399020, -0.736465, -0.797478>
    }
    triangle {
      < -0.482871, -0.769544, -0.782355>,
      < -0.399020, -0.736465, -0.797478>,
      < -0.399010, -0.755012, -0.804616>
    }
    triangle {
      < 1.237918, -0.783064, -0.835996>,
      < 1.237913, -0.774770, -0.814345>,
      < 1.139592, -0.790427, -0.804231>
    }
    triangle {
      < 1.237918, -0.783064, -0.835996>,
      < 1.139592, -0.790427, -0.804231>,
      < 1.139598, -0.801485, -0.833100>
    }
    triangle {
      < 1.237903, -0.758387, -0.797937>,
      < 1.237891, -0.736748, -0.789611>,
      < 1.139562, -0.739729, -0.771252>
    }
    triangle {
      < 1.237903, -0.758387, -0.797937>,
      < 1.139562, -0.739729, -0.771252>,
      < 1.139579, -0.768583, -0.782354>
    }
    triangle {
      < 0.916918, -0.817936, -0.868791>,
      < 0.916919, -0.819979, -0.830203>,
      < -0.471272, -0.820802, -0.830203>
    }
    triangle {
      < 0.916918, -0.817936, -0.868791>,
      < -0.471272, -0.820802, -0.830203>,
      < -0.471273, -0.818758, -0.868792>
    }
    triangle {
      < 0.916873, -0.742785, -0.752893>,
      < 0.916851, -0.704192, -0.754881>,
      < -0.471341, -0.705015, -0.754881>
    }
    triangle {
      < 0.916873, -0.742785, -0.752893>,
      < -0.471341, -0.705015, -0.754881>,
      < -0.471317, -0.743608, -0.752893>
    }
    triangle {
      < -0.482858, -0.791388, -0.804231>,
      < -0.482871, -0.769544, -0.782355>,
      < -0.399010, -0.755012, -0.804616>
    }
    triangle {
      < -0.482858, -0.791388, -0.804231>,
      < -0.399010, -0.755012, -0.804616>,
      < -0.399001, -0.769055, -0.818679>
    }
    triangle {
      < 1.237913, -0.774770, -0.814345>,
      < 1.237903, -0.758387, -0.797937>,
      < 1.139579, -0.768583, -0.782354>
    }
    triangle {
      < 1.237913, -0.774770, -0.814345>,
      < 1.139579, -0.768583, -0.782354>,
      < 1.139592, -0.790427, -0.804231>
    }
    triangle {
      < -0.471272, -0.820802, -0.830203>,
      < -0.471280, -0.806978, -0.794117>,
      < -0.482858, -0.791388, -0.804231>
    }
    triangle {
      < -0.471272, -0.820802, -0.830203>,
      < -0.482858, -0.791388, -0.804231>,
      < -0.482851, -0.802447, -0.833100>
    }
    triangle {
      < 1.139598, -0.801485, -0.833100>,
      < 1.139592, -0.790427, -0.804231>,
      < 0.916911, -0.806155, -0.794117>
    }
    triangle {
      < 1.139598, -0.801485, -0.833100>,
      < 0.916911, -0.806155, -0.794117>,
      < 0.916919, -0.819979, -0.830203>
    }
    triangle {
      < 1.139579, -0.768583, -0.782354>,
      < 1.139562, -0.739729, -0.771252>,
      < 0.916873, -0.742785, -0.752893>
    }
    triangle {
      < 1.139579, -0.768583, -0.782354>,
      < 0.916873, -0.742785, -0.752893>,
      < 0.916895, -0.778850, -0.766771>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < -0.471317, -0.743608, -0.752893>,
      < -0.482888, -0.740691, -0.771253>
    }
    triangle {
      < -0.471296, -0.779673, -0.766771>,
      < -0.482888, -0.740691, -0.771253>,
      < -0.482871, -0.769544, -0.782355>
    }
    triangle {
      < -0.471280, -0.806978, -0.794117>,
      < -0.471296, -0.779673, -0.766771>,
      < -0.482871, -0.769544, -0.782355>
    }
    triangle {
      < -0.471280, -0.806978, -0.794117>,
      < -0.482871, -0.769544, -0.782355>,
      < -0.482858, -0.791388, -0.804231>
    }
    triangle {
      < 1.139592, -0.790427, -0.804231>,
      < 1.139579, -0.768583, -0.782354>,
      < 0.916895, -0.778850, -0.766771>
    }
    triangle {
      < 1.139592, -0.790427, -0.804231>,
      < 0.916895, -0.778850, -0.766771>,
      < 0.916911, -0.806155, -0.794117>
    }
    triangle {
      < 0.916919, -0.819979, -0.830203>,
      < 0.916911, -0.806155, -0.794117>,
      < -0.471280, -0.806978, -0.794117>
    }
    triangle {
      < 0.916919, -0.819979, -0.830203>,
      < -0.471280, -0.806978, -0.794117>,
      < -0.471272, -0.820802, -0.830203>
    }
    triangle {
      < 0.916895, -0.778850, -0.766771>,
      < 0.916873, -0.742785, -0.752893>,
      < -0.471317, -0.743608, -0.752893>
    }
    triangle {
      < 0.916895, -0.778850, -0.766771>,
      < -0.471317, -0.743608, -0.752893>,
      < -0.471296, -0.779673, -0.766771>
    }
    texture {ordinance1}
  }
  // ordinance2
  union {
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655422, -0.527754, -3.684720>,
      < 1.655419, -0.521072, -3.693908>
    }
    triangle {
      < 1.655419, -0.521072, -3.693908>,
      < 1.655422, -0.527754, -3.684720>,
      < 1.537423, -0.527824, -3.684720>
    }
    triangle {
      < 1.655419, -0.521072, -3.693908>,
      < 1.537423, -0.527824, -3.684720>,
      < 1.537420, -0.521143, -3.693908>
    }
    triangle {
      < 1.537420, -0.521143, -3.693908>,
      < 1.537423, -0.527824, -3.684720>,
      < 1.502043, -0.560199, -3.701225>
    }
    triangle {
      < 1.537420, -0.521143, -3.693908>,
      < 1.502043, -0.560199, -3.701225>,
      < 1.502035, -0.546834, -3.719602>
    }
    triangle {
      < 1.502035, -0.546834, -3.719602>,
      < 1.502043, -0.560199, -3.701225>,
      < 1.401769, -0.600700, -3.721857>
    }
    triangle {
      < 1.502035, -0.546834, -3.719602>,
      < 1.401769, -0.600700, -3.721857>,
      < 1.401755, -0.578982, -3.751719>
    }
    triangle {
      < 1.401755, -0.578982, -3.751719>,
      < 1.401769, -0.600700, -3.721857>,
      < 0.109683, -0.601466, -3.721857>
    }
    triangle {
      < 1.401755, -0.578982, -3.751719>,
      < 0.109683, -0.601466, -3.721857>,
      < 0.109669, -0.579748, -3.751719>
    }
    triangle {
      < 0.109669, -0.579748, -3.751719>,
      < 0.109683, -0.601466, -3.721857>,
      < 0.074278, -0.593397, -3.717730>
    }
    triangle {
      < 0.109669, -0.579748, -3.751719>,
      < 0.074278, -0.593397, -3.717730>,
      < 0.074266, -0.573351, -3.745295>
    }
    triangle {
      < 0.074266, -0.573351, -3.745295>,
      < 0.074278, -0.593397, -3.717730>,
      < -0.309220, -0.589581, -3.715667>
    }
    triangle {
      < 0.074266, -0.573351, -3.745295>,
      < -0.309220, -0.589581, -3.715667>,
      < -0.309232, -0.570369, -3.742084>
    }
    triangle {
      < -0.309232, -0.570369, -3.742084>,
      < -0.309220, -0.589581, -3.715667>,
      < -0.421336, -0.561339, -3.701225>
    }
    triangle {
      < -0.309232, -0.570369, -3.742084>,
      < -0.421336, -0.561339, -3.701225>,
      < -0.421344, -0.547974, -3.719602>
    }
    triangle {
      < -0.421344, -0.547974, -3.719602>,
      < -0.421336, -0.561339, -3.701225>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655425, -0.531271, -3.673917>,
      < 1.655422, -0.527754, -3.684720>
    }
    triangle {
      < 1.655422, -0.527754, -3.684720>,
      < 1.655425, -0.531271, -3.673917>,
      < 1.537426, -0.531341, -3.673917>
    }
    triangle {
      < 1.655422, -0.527754, -3.684720>,
      < 1.537426, -0.531341, -3.673917>,
      < 1.537423, -0.527824, -3.684720>
    }
    triangle {
      < 1.537423, -0.527824, -3.684720>,
      < 1.537426, -0.531341, -3.673917>,
      < 1.502047, -0.567231, -3.679618>
    }
    triangle {
      < 1.537423, -0.527824, -3.684720>,
      < 1.502047, -0.567231, -3.679618>,
      < 1.502043, -0.560199, -3.701225>
    }
    triangle {
      < 1.502043, -0.560199, -3.701225>,
      < 1.502047, -0.567231, -3.679618>,
      < 1.401775, -0.612128, -3.686746>
    }
    triangle {
      < 1.502043, -0.560199, -3.701225>,
      < 1.401775, -0.612128, -3.686746>,
      < 1.401769, -0.600700, -3.721857>
    }
    triangle {
      < 1.401769, -0.600700, -3.721857>,
      < 1.401775, -0.612128, -3.686746>,
      < 0.109689, -0.612894, -3.686746>
    }
    triangle {
      < 1.401769, -0.600700, -3.721857>,
      < 0.109689, -0.612894, -3.686746>,
      < 0.109683, -0.601466, -3.721857>
    }
    triangle {
      < 0.109683, -0.601466, -3.721857>,
      < 0.109689, -0.612894, -3.686746>,
      < 0.074284, -0.603948, -3.685320>
    }
    triangle {
      < 0.109683, -0.601466, -3.721857>,
      < 0.074284, -0.603948, -3.685320>,
      < 0.074278, -0.593397, -3.717730>
    }
    triangle {
      < 0.074278, -0.593397, -3.717730>,
      < 0.074284, -0.603948, -3.685320>,
      < -0.309215, -0.599691, -3.684607>
    }
    triangle {
      < 0.074278, -0.593397, -3.717730>,
      < -0.309215, -0.599691, -3.684607>,
      < -0.309220, -0.589581, -3.715667>
    }
    triangle {
      < -0.309220, -0.589581, -3.715667>,
      < -0.309215, -0.599691, -3.684607>,
      < -0.421331, -0.568372, -3.679619>
    }
    triangle {
      < -0.309220, -0.589581, -3.715667>,
      < -0.421331, -0.568372, -3.679619>,
      < -0.421336, -0.561339, -3.701225>
    }
    triangle {
      < -0.421336, -0.561339, -3.701225>,
      < -0.421331, -0.568372, -3.679619>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655425, -0.531278, -3.662555>,
      < 1.655425, -0.531271, -3.673917>
    }
    triangle {
      < 1.655425, -0.531271, -3.673917>,
      < 1.655425, -0.531278, -3.662555>,
      < 1.537426, -0.531348, -3.662555>
    }
    triangle {
      < 1.655425, -0.531271, -3.673917>,
      < 1.537426, -0.531348, -3.662555>,
      < 1.537426, -0.531341, -3.673917>
    }
    triangle {
      < 1.537426, -0.531341, -3.673917>,
      < 1.537426, -0.531348, -3.662555>,
      < 1.502047, -0.567245, -3.656895>
    }
    triangle {
      < 1.537426, -0.531341, -3.673917>,
      < 1.502047, -0.567245, -3.656895>,
      < 1.502047, -0.567231, -3.679618>
    }
    triangle {
      < 1.502047, -0.567231, -3.679618>,
      < 1.502047, -0.567245, -3.656895>,
      < 1.401775, -0.612150, -3.649822>
    }
    triangle {
      < 1.502047, -0.567231, -3.679618>,
      < 1.401775, -0.612150, -3.649822>,
      < 1.401775, -0.612128, -3.686746>
    }
    triangle {
      < 1.401775, -0.612128, -3.686746>,
      < 1.401775, -0.612150, -3.649822>,
      < 0.109689, -0.612916, -3.649822>
    }
    triangle {
      < 1.401775, -0.612128, -3.686746>,
      < 0.109689, -0.612916, -3.649822>,
      < 0.109689, -0.612894, -3.686746>
    }
    triangle {
      < 0.109689, -0.612894, -3.686746>,
      < 0.109689, -0.612916, -3.649822>,
      < 0.074284, -0.603967, -3.651237>
    }
    triangle {
      < 0.109689, -0.612894, -3.686746>,
      < 0.074284, -0.603967, -3.651237>,
      < 0.074284, -0.603948, -3.685320>
    }
    triangle {
      < 0.074284, -0.603948, -3.685320>,
      < 0.074284, -0.603967, -3.651237>,
      < -0.309214, -0.599711, -3.651943>
    }
    triangle {
      < 0.074284, -0.603948, -3.685320>,
      < -0.309214, -0.599711, -3.651943>,
      < -0.309215, -0.599691, -3.684607>
    }
    triangle {
      < -0.309215, -0.599691, -3.684607>,
      < -0.309214, -0.599711, -3.651943>,
      < -0.421331, -0.568386, -3.656895>
    }
    triangle {
      < -0.309215, -0.599691, -3.684607>,
      < -0.421331, -0.568386, -3.656895>,
      < -0.421331, -0.568372, -3.679619>
    }
    triangle {
      < -0.421331, -0.568372, -3.679619>,
      < -0.421331, -0.568386, -3.656895>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655422, -0.527775, -3.651748>,
      < 1.655425, -0.531278, -3.662555>
    }
    triangle {
      < 1.655425, -0.531278, -3.662555>,
      < 1.655422, -0.527775, -3.651748>,
      < 1.537423, -0.527845, -3.651748>
    }
    triangle {
      < 1.655425, -0.531278, -3.662555>,
      < 1.537423, -0.527845, -3.651748>,
      < 1.537426, -0.531348, -3.662555>
    }
    triangle {
      < 1.537426, -0.531348, -3.662555>,
      < 1.537423, -0.527845, -3.651748>,
      < 1.502043, -0.560238, -3.635280>
    }
    triangle {
      < 1.537426, -0.531348, -3.662555>,
      < 1.502043, -0.560238, -3.635280>,
      < 1.502047, -0.567245, -3.656895>
    }
    triangle {
      < 1.502047, -0.567245, -3.656895>,
      < 1.502043, -0.560238, -3.635280>,
      < 1.401769, -0.600763, -3.614697>
    }
    triangle {
      < 1.502047, -0.567245, -3.656895>,
      < 1.401769, -0.600763, -3.614697>,
      < 1.401775, -0.612150, -3.649822>
    }
    triangle {
      < 1.401775, -0.612150, -3.649822>,
      < 1.401769, -0.600763, -3.614697>,
      < 0.109683, -0.601529, -3.614697>
    }
    triangle {
      < 1.401775, -0.612150, -3.649822>,
      < 0.109683, -0.601529, -3.614697>,
      < 0.109689, -0.612916, -3.649822>
    }
    triangle {
      < 0.109689, -0.612916, -3.649822>,
      < 0.109683, -0.601529, -3.614697>,
      < 0.074278, -0.593457, -3.618814>
    }
    triangle {
      < 0.109689, -0.612916, -3.649822>,
      < 0.074278, -0.593457, -3.618814>,
      < 0.074284, -0.603967, -3.651237>
    }
    triangle {
      < 0.074284, -0.603967, -3.651237>,
      < 0.074278, -0.593457, -3.618814>,
      < -0.309220, -0.589638, -3.620873>
    }
    triangle {
      < 0.074284, -0.603967, -3.651237>,
      < -0.309220, -0.589638, -3.620873>,
      < -0.309214, -0.599711, -3.651943>
    }
    triangle {
      < -0.309214, -0.599711, -3.651943>,
      < -0.309220, -0.589638, -3.620873>,
      < -0.421336, -0.561378, -3.635281>
    }
    triangle {
      < -0.309214, -0.599711, -3.651943>,
      < -0.421336, -0.561378, -3.635281>,
      < -0.421331, -0.568386, -3.656895>
    }
    triangle {
      < -0.421331, -0.568386, -3.656895>,
      < -0.421336, -0.561378, -3.635281>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655419, -0.521103, -3.642550>,
      < 1.655422, -0.527775, -3.651748>
    }
    triangle {
      < 1.655422, -0.527775, -3.651748>,
      < 1.655419, -0.521103, -3.642550>,
      < 1.537420, -0.521173, -3.642550>
    }
    triangle {
      < 1.655422, -0.527775, -3.651748>,
      < 1.537420, -0.521173, -3.642550>,
      < 1.537423, -0.527845, -3.651748>
    }
    triangle {
      < 1.537423, -0.527845, -3.651748>,
      < 1.537420, -0.521173, -3.642550>,
      < 1.502035, -0.546895, -3.616888>
    }
    triangle {
      < 1.537423, -0.527845, -3.651748>,
      < 1.502035, -0.546895, -3.616888>,
      < 1.502043, -0.560238, -3.635280>
    }
    triangle {
      < 1.502043, -0.560238, -3.635280>,
      < 1.502035, -0.546895, -3.616888>,
      < 1.401755, -0.579081, -3.584809>
    }
    triangle {
      < 1.502043, -0.560238, -3.635280>,
      < 1.401755, -0.579081, -3.584809>,
      < 1.401769, -0.600763, -3.614697>
    }
    triangle {
      < 1.401769, -0.600763, -3.614697>,
      < 1.401755, -0.579081, -3.584809>,
      < 0.109669, -0.579847, -3.584810>
    }
    triangle {
      < 1.401769, -0.600763, -3.614697>,
      < 0.109669, -0.579847, -3.584810>,
      < 0.109683, -0.601529, -3.614697>
    }
    triangle {
      < 0.109683, -0.601529, -3.614697>,
      < 0.109669, -0.579847, -3.584810>,
      < 0.074266, -0.573442, -3.591226>
    }
    triangle {
      < 0.109683, -0.601529, -3.614697>,
      < 0.074266, -0.573442, -3.591226>,
      < 0.074278, -0.593457, -3.618814>
    }
    triangle {
      < 0.074278, -0.593457, -3.618814>,
      < 0.074266, -0.573442, -3.591226>,
      < -0.309232, -0.570457, -3.594433>
    }
    triangle {
      < 0.074278, -0.593457, -3.618814>,
      < -0.309232, -0.570457, -3.594433>,
      < -0.309220, -0.589638, -3.620873>
    }
    triangle {
      < -0.309220, -0.589638, -3.620873>,
      < -0.309232, -0.570457, -3.594433>,
      < -0.421344, -0.548035, -3.616888>
    }
    triangle {
      < -0.309220, -0.589638, -3.620873>,
      < -0.421344, -0.548035, -3.616888>,
      < -0.421336, -0.561378, -3.635281>
    }
    triangle {
      < -0.421336, -0.561378, -3.635281>,
      < -0.421344, -0.548035, -3.616888>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655413, -0.511917, -3.635866>,
      < 1.655419, -0.521103, -3.642550>
    }
    triangle {
      < 1.655419, -0.521103, -3.642550>,
      < 1.655413, -0.511917, -3.635866>,
      < 1.537414, -0.511987, -3.635866>
    }
    triangle {
      < 1.655419, -0.521103, -3.642550>,
      < 1.537414, -0.511987, -3.635866>,
      < 1.537420, -0.521173, -3.642550>
    }
    triangle {
      < 1.537420, -0.521173, -3.642550>,
      < 1.537414, -0.511987, -3.635866>,
      < 1.502024, -0.528522, -3.603518>
    }
    triangle {
      < 1.537420, -0.521173, -3.642550>,
      < 1.502024, -0.528522, -3.603518>,
      < 1.502035, -0.546895, -3.616888>
    }
    triangle {
      < 1.502035, -0.546895, -3.616888>,
      < 1.502024, -0.528522, -3.603518>,
      < 1.401738, -0.549225, -3.563083>
    }
    triangle {
      < 1.502035, -0.546895, -3.616888>,
      < 1.401738, -0.549225, -3.563083>,
      < 1.401755, -0.579081, -3.584809>
    }
    triangle {
      < 1.401755, -0.579081, -3.584809>,
      < 1.401738, -0.549225, -3.563083>,
      < 0.109652, -0.549991, -3.563083>
    }
    triangle {
      < 1.401755, -0.579081, -3.584809>,
      < 0.109652, -0.549991, -3.563083>,
      < 0.109669, -0.579847, -3.584810>
    }
    triangle {
      < 0.109669, -0.579847, -3.584810>,
      < 0.109652, -0.549991, -3.563083>,
      < 0.074250, -0.545883, -3.571170>
    }
    triangle {
      < 0.109669, -0.579847, -3.584810>,
      < 0.074250, -0.545883, -3.571170>,
      < 0.074266, -0.573442, -3.591226>
    }
    triangle {
      < 0.074266, -0.573442, -3.591226>,
      < 0.074250, -0.545883, -3.571170>,
      < -0.309247, -0.544047, -3.575213>
    }
    triangle {
      < 0.074266, -0.573442, -3.591226>,
      < -0.309247, -0.544047, -3.575213>,
      < -0.309232, -0.570457, -3.594433>
    }
    triangle {
      < -0.309232, -0.570457, -3.594433>,
      < -0.309247, -0.544047, -3.575213>,
      < -0.421355, -0.529662, -3.603518>
    }
    triangle {
      < -0.309232, -0.570457, -3.594433>,
      < -0.421355, -0.529662, -3.603518>,
      < -0.421344, -0.548035, -3.616888>
    }
    triangle {
      < -0.421344, -0.548035, -3.616888>,
      < -0.421355, -0.529662, -3.603518>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655407, -0.501114, -3.632346>,
      < 1.655413, -0.511917, -3.635866>
    }
    triangle {
      < 1.655413, -0.511917, -3.635866>,
      < 1.655407, -0.501114, -3.632346>,
      < 1.537408, -0.501184, -3.632346>
    }
    triangle {
      < 1.655413, -0.511917, -3.635866>,
      < 1.537408, -0.501184, -3.632346>,
      < 1.537414, -0.511987, -3.635866>
    }
    triangle {
      < 1.537414, -0.511987, -3.635866>,
      < 1.537408, -0.501184, -3.632346>,
      < 1.502012, -0.506917, -3.596478>
    }
    triangle {
      < 1.537414, -0.511987, -3.635866>,
      < 1.502012, -0.506917, -3.596478>,
      < 1.502024, -0.528522, -3.603518>
    }
    triangle {
      < 1.502024, -0.528522, -3.603518>,
      < 1.502012, -0.506917, -3.596478>,
      < 1.401718, -0.514117, -3.551643>
    }
    triangle {
      < 1.502024, -0.528522, -3.603518>,
      < 1.401718, -0.514117, -3.551643>,
      < 1.401738, -0.549225, -3.563083>
    }
    triangle {
      < 1.401738, -0.549225, -3.563083>,
      < 1.401718, -0.514117, -3.551643>,
      < 0.109632, -0.514883, -3.551643>
    }
    triangle {
      < 1.401738, -0.549225, -3.563083>,
      < 0.109632, -0.514883, -3.551643>,
      < 0.109652, -0.549991, -3.563083>
    }
    triangle {
      < 0.109652, -0.549991, -3.563083>,
      < 0.109632, -0.514883, -3.551643>,
      < 0.074231, -0.513476, -3.560611>
    }
    triangle {
      < 0.109652, -0.549991, -3.563083>,
      < 0.074231, -0.513476, -3.560611>,
      < 0.074250, -0.545883, -3.571170>
    }
    triangle {
      < 0.074250, -0.545883, -3.571170>,
      < 0.074231, -0.513476, -3.560611>,
      < -0.309266, -0.512989, -3.565094>
    }
    triangle {
      < 0.074250, -0.545883, -3.571170>,
      < -0.309266, -0.512989, -3.565094>,
      < -0.309247, -0.544047, -3.575213>
    }
    triangle {
      < -0.309247, -0.544047, -3.575213>,
      < -0.309266, -0.512989, -3.565094>,
      < -0.421367, -0.508058, -3.596478>
    }
    triangle {
      < -0.309247, -0.544047, -3.575213>,
      < -0.421367, -0.508058, -3.596478>,
      < -0.421355, -0.529662, -3.603518>
    }
    triangle {
      < -0.421355, -0.529662, -3.603518>,
      < -0.421367, -0.508058, -3.596478>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655400, -0.489753, -3.632336>,
      < 1.655407, -0.501114, -3.632346>
    }
    triangle {
      < 1.655407, -0.501114, -3.632346>,
      < 1.655400, -0.489753, -3.632336>,
      < 1.537401, -0.489823, -3.632336>
    }
    triangle {
      < 1.655407, -0.501114, -3.632346>,
      < 1.537401, -0.489823, -3.632336>,
      < 1.537408, -0.501184, -3.632346>
    }
    triangle {
      < 1.537408, -0.501184, -3.632346>,
      < 1.537401, -0.489823, -3.632336>,
      < 1.501998, -0.484195, -3.596458>
    }
    triangle {
      < 1.537408, -0.501184, -3.632346>,
      < 1.501998, -0.484195, -3.596458>,
      < 1.502012, -0.506917, -3.596478>
    }
    triangle {
      < 1.502012, -0.506917, -3.596478>,
      < 1.501998, -0.484195, -3.596458>,
      < 1.401695, -0.477193, -3.551611>
    }
    triangle {
      < 1.502012, -0.506917, -3.596478>,
      < 1.401695, -0.477193, -3.551611>,
      < 1.401718, -0.514117, -3.551643>
    }
    triangle {
      < 1.401718, -0.514117, -3.551643>,
      < 1.401695, -0.477193, -3.551611>,
      < 0.109609, -0.477959, -3.551611>
    }
    triangle {
      < 1.401718, -0.514117, -3.551643>,
      < 0.109609, -0.477959, -3.551611>,
      < 0.109632, -0.514883, -3.551643>
    }
    triangle {
      < 0.109632, -0.514883, -3.551643>,
      < 0.109609, -0.477959, -3.551611>,
      < 0.074210, -0.479391, -3.560581>
    }
    triangle {
      < 0.109632, -0.514883, -3.551643>,
      < 0.074210, -0.479391, -3.560581>,
      < 0.074231, -0.513476, -3.560611>
    }
    triangle {
      < 0.074231, -0.513476, -3.560611>,
      < 0.074210, -0.479391, -3.560581>,
      < -0.309285, -0.480325, -3.565065>
    }
    triangle {
      < 0.074231, -0.513476, -3.560611>,
      < -0.309285, -0.480325, -3.565065>,
      < -0.309266, -0.512989, -3.565094>
    }
    triangle {
      < -0.309266, -0.512989, -3.565094>,
      < -0.309285, -0.480325, -3.565065>,
      < -0.421381, -0.485335, -3.596458>
    }
    triangle {
      < -0.309266, -0.512989, -3.565094>,
      < -0.421381, -0.485335, -3.596458>,
      < -0.421367, -0.508058, -3.596478>
    }
    triangle {
      < -0.421367, -0.508058, -3.596478>,
      < -0.421381, -0.485335, -3.596458>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655393, -0.478944, -3.635837>,
      < 1.655400, -0.489753, -3.632336>
    }
    triangle {
      < 1.655400, -0.489753, -3.632336>,
      < 1.655393, -0.478944, -3.635837>,
      < 1.537394, -0.479015, -3.635837>
    }
    triangle {
      < 1.655400, -0.489753, -3.632336>,
      < 1.537394, -0.479015, -3.635837>,
      < 1.537401, -0.489823, -3.632336>
    }
    triangle {
      < 1.537401, -0.489823, -3.632336>,
      < 1.537394, -0.479015, -3.635837>,
      < 1.501985, -0.462578, -3.603459>
    }
    triangle {
      < 1.537401, -0.489823, -3.632336>,
      < 1.501985, -0.462578, -3.603459>,
      < 1.501998, -0.484195, -3.596458>
    }
    triangle {
      < 1.501998, -0.484195, -3.596458>,
      < 1.501985, -0.462578, -3.603459>,
      < 1.401674, -0.442066, -3.562988>
    }
    triangle {
      < 1.501998, -0.484195, -3.596458>,
      < 1.401674, -0.442066, -3.562988>,
      < 1.401695, -0.477193, -3.551611>
    }
    triangle {
      < 1.401695, -0.477193, -3.551611>,
      < 1.401674, -0.442066, -3.562988>,
      < 0.109588, -0.442832, -3.562988>
    }
    triangle {
      < 1.401695, -0.477193, -3.551611>,
      < 0.109588, -0.442832, -3.562988>,
      < 0.109609, -0.477959, -3.551611>
    }
    triangle {
      < 0.109609, -0.477959, -3.551611>,
      < 0.109588, -0.442832, -3.562988>,
      < 0.074191, -0.446967, -3.571082>
    }
    triangle {
      < 0.109609, -0.477959, -3.551611>,
      < 0.074191, -0.446967, -3.571082>,
      < 0.074210, -0.479391, -3.560581>
    }
    triangle {
      < 0.074210, -0.479391, -3.560581>,
      < 0.074191, -0.446967, -3.571082>,
      < -0.309304, -0.449251, -3.575130>
    }
    triangle {
      < 0.074210, -0.479391, -3.560581>,
      < -0.309304, -0.449251, -3.575130>,
      < -0.309285, -0.480325, -3.565065>
    }
    triangle {
      < -0.309285, -0.480325, -3.565065>,
      < -0.309304, -0.449251, -3.575130>,
      < -0.421393, -0.463718, -3.603459>
    }
    triangle {
      < -0.309285, -0.480325, -3.565065>,
      < -0.421393, -0.463718, -3.603459>,
      < -0.421381, -0.485335, -3.596458>
    }
    triangle {
      < -0.421381, -0.485335, -3.596458>,
      < -0.421393, -0.463718, -3.603459>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655388, -0.469746, -3.642506>,
      < 1.655393, -0.478944, -3.635837>
    }
    triangle {
      < 1.655393, -0.478944, -3.635837>,
      < 1.655388, -0.469746, -3.642506>,
      < 1.537389, -0.469816, -3.642506>
    }
    triangle {
      < 1.655393, -0.478944, -3.635837>,
      < 1.537389, -0.469816, -3.642506>,
      < 1.537394, -0.479015, -3.635837>
    }
    triangle {
      < 1.537394, -0.479015, -3.635837>,
      < 1.537389, -0.469816, -3.642506>,
      < 1.501974, -0.444181, -3.616796>
    }
    triangle {
      < 1.537394, -0.479015, -3.635837>,
      < 1.501974, -0.444181, -3.616796>,
      < 1.501985, -0.462578, -3.603459>
    }
    triangle {
      < 1.501985, -0.462578, -3.603459>,
      < 1.501974, -0.444181, -3.616796>,
      < 1.401656, -0.412172, -3.584661>
    }
    triangle {
      < 1.501985, -0.462578, -3.603459>,
      < 1.401656, -0.412172, -3.584661>,
      < 1.401674, -0.442066, -3.562988>
    }
    triangle {
      < 1.401674, -0.442066, -3.562988>,
      < 1.401656, -0.412172, -3.584661>,
      < 0.109571, -0.412937, -3.584661>
    }
    triangle {
      < 1.401674, -0.442066, -3.562988>,
      < 0.109571, -0.412937, -3.584661>,
      < 0.109588, -0.442832, -3.562988>
    }
    triangle {
      < 0.109588, -0.442832, -3.562988>,
      < 0.109571, -0.412937, -3.584661>,
      < 0.074175, -0.419371, -3.591088>
    }
    triangle {
      < 0.109588, -0.442832, -3.562988>,
      < 0.074175, -0.419371, -3.591088>,
      < 0.074191, -0.446967, -3.571082>
    }
    triangle {
      < 0.074191, -0.446967, -3.571082>,
      < 0.074175, -0.419371, -3.591088>,
      < -0.309319, -0.422807, -3.594302>
    }
    triangle {
      < 0.074191, -0.446967, -3.571082>,
      < -0.309319, -0.422807, -3.594302>,
      < -0.309304, -0.449251, -3.575130>
    }
    triangle {
      < -0.309304, -0.449251, -3.575130>,
      < -0.309319, -0.422807, -3.594302>,
      < -0.421404, -0.445322, -3.616797>
    }
    triangle {
      < -0.309304, -0.449251, -3.575130>,
      < -0.421404, -0.445322, -3.616797>,
      < -0.421393, -0.463718, -3.603459>
    }
    triangle {
      < -0.421393, -0.463718, -3.603459>,
      < -0.421404, -0.445322, -3.616797>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655384, -0.463058, -3.651689>,
      < 1.655388, -0.469746, -3.642506>
    }
    triangle {
      < 1.655388, -0.469746, -3.642506>,
      < 1.655384, -0.463058, -3.651689>,
      < 1.537385, -0.463129, -3.651689>
    }
    triangle {
      < 1.655388, -0.469746, -3.642506>,
      < 1.537385, -0.463129, -3.651689>,
      < 1.537389, -0.469816, -3.642506>
    }
    triangle {
      < 1.537389, -0.469816, -3.642506>,
      < 1.537385, -0.463129, -3.651689>,
      < 1.501966, -0.430805, -3.635166>
    }
    triangle {
      < 1.537389, -0.469816, -3.642506>,
      < 1.501966, -0.430805, -3.635166>,
      < 1.501974, -0.444181, -3.616796>
    }
    triangle {
      < 1.501974, -0.444181, -3.616796>,
      < 1.501966, -0.430805, -3.635166>,
      < 1.401644, -0.390436, -3.614510>
    }
    triangle {
      < 1.501974, -0.444181, -3.616796>,
      < 1.401644, -0.390436, -3.614510>,
      < 1.401656, -0.412172, -3.584661>
    }
    triangle {
      < 1.401656, -0.412172, -3.584661>,
      < 1.401644, -0.390436, -3.614510>,
      < 0.109558, -0.391202, -3.614510>
    }
    triangle {
      < 1.401656, -0.412172, -3.584661>,
      < 0.109558, -0.391202, -3.614510>,
      < 0.109571, -0.412937, -3.584661>
    }
    triangle {
      < 0.109571, -0.412937, -3.584661>,
      < 0.109558, -0.391202, -3.614510>,
      < 0.074164, -0.399309, -3.618641>
    }
    triangle {
      < 0.109571, -0.412937, -3.584661>,
      < 0.074164, -0.399309, -3.618641>,
      < 0.074175, -0.419371, -3.591088>
    }
    triangle {
      < 0.074175, -0.419371, -3.591088>,
      < 0.074164, -0.399309, -3.618641>,
      < -0.309331, -0.403579, -3.620707>
    }
    triangle {
      < 0.074175, -0.419371, -3.591088>,
      < -0.309331, -0.403579, -3.620707>,
      < -0.309319, -0.422807, -3.594302>
    }
    triangle {
      < -0.309319, -0.422807, -3.594302>,
      < -0.309331, -0.403579, -3.620707>,
      < -0.421412, -0.431946, -3.635166>
    }
    triangle {
      < -0.309319, -0.422807, -3.594302>,
      < -0.421412, -0.431946, -3.635166>,
      < -0.421404, -0.445322, -3.616797>
    }
    triangle {
      < -0.421404, -0.445322, -3.616797>,
      < -0.421412, -0.431946, -3.635166>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655383, -0.459535, -3.662491>,
      < 1.655384, -0.463058, -3.651689>
    }
    triangle {
      < 1.655384, -0.463058, -3.651689>,
      < 1.655383, -0.459535, -3.662491>,
      < 1.537384, -0.459605, -3.662491>
    }
    triangle {
      < 1.655384, -0.463058, -3.651689>,
      < 1.537384, -0.459605, -3.662491>,
      < 1.537385, -0.463129, -3.651689>
    }
    triangle {
      < 1.537385, -0.463129, -3.651689>,
      < 1.537384, -0.459605, -3.662491>,
      < 1.501962, -0.423759, -3.656768>
    }
    triangle {
      < 1.537385, -0.463129, -3.651689>,
      < 1.501962, -0.423759, -3.656768>,
      < 1.501966, -0.430805, -3.635166>
    }
    triangle {
      < 1.501966, -0.430805, -3.635166>,
      < 1.501962, -0.423759, -3.656768>,
      < 1.401637, -0.378986, -3.649614>
    }
    triangle {
      < 1.501966, -0.430805, -3.635166>,
      < 1.401637, -0.378986, -3.649614>,
      < 1.401644, -0.390436, -3.614510>
    }
    triangle {
      < 1.401644, -0.390436, -3.614510>,
      < 1.401637, -0.378986, -3.649614>,
      < 0.109552, -0.379752, -3.649614>
    }
    triangle {
      < 1.401644, -0.390436, -3.614510>,
      < 0.109552, -0.379752, -3.649614>,
      < 0.109558, -0.391202, -3.614510>
    }
    triangle {
      < 0.109558, -0.391202, -3.614510>,
      < 0.109552, -0.379752, -3.649614>,
      < 0.074157, -0.388739, -3.651045>
    }
    triangle {
      < 0.109558, -0.391202, -3.614510>,
      < 0.074157, -0.388739, -3.651045>,
      < 0.074164, -0.399309, -3.618641>
    }
    triangle {
      < 0.074164, -0.399309, -3.618641>,
      < 0.074157, -0.388739, -3.651045>,
      < -0.309336, -0.393450, -3.651760>
    }
    triangle {
      < 0.074164, -0.399309, -3.618641>,
      < -0.309336, -0.393450, -3.651760>,
      < -0.309331, -0.403579, -3.620707>
    }
    triangle {
      < -0.309331, -0.403579, -3.620707>,
      < -0.309336, -0.393450, -3.651760>,
      < -0.421417, -0.424900, -3.656768>
    }
    triangle {
      < -0.309331, -0.403579, -3.620707>,
      < -0.421417, -0.424900, -3.656768>,
      < -0.421412, -0.431946, -3.635166>
    }
    triangle {
      < -0.421412, -0.431946, -3.635166>,
      < -0.421417, -0.424900, -3.656768>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655383, -0.459522, -3.673852>,
      < 1.655383, -0.459535, -3.662491>
    }
    triangle {
      < 1.655383, -0.459535, -3.662491>,
      < 1.655383, -0.459522, -3.673852>,
      < 1.537384, -0.459592, -3.673852>
    }
    triangle {
      < 1.655383, -0.459535, -3.662491>,
      < 1.537384, -0.459592, -3.673852>,
      < 1.537384, -0.459605, -3.662491>
    }
    triangle {
      < 1.537384, -0.459605, -3.662491>,
      < 1.537384, -0.459592, -3.673852>,
      < 1.501962, -0.423733, -3.679491>
    }
    triangle {
      < 1.537384, -0.459605, -3.662491>,
      < 1.501962, -0.423733, -3.679491>,
      < 1.501962, -0.423759, -3.656768>
    }
    triangle {
      < 1.501962, -0.423759, -3.656768>,
      < 1.501962, -0.423733, -3.679491>,
      < 1.401637, -0.378942, -3.686538>
    }
    triangle {
      < 1.501962, -0.423759, -3.656768>,
      < 1.401637, -0.378942, -3.686538>,
      < 1.401637, -0.378986, -3.649614>
    }
    triangle {
      < 1.401637, -0.378986, -3.649614>,
      < 1.401637, -0.378942, -3.686538>,
      < 0.109552, -0.379708, -3.686538>
    }
    triangle {
      < 1.401637, -0.378986, -3.649614>,
      < 0.109552, -0.379708, -3.686538>,
      < 0.109552, -0.379752, -3.649614>
    }
    triangle {
      < 0.109552, -0.379752, -3.649614>,
      < 0.109552, -0.379708, -3.686538>,
      < 0.074157, -0.388699, -3.685129>
    }
    triangle {
      < 0.109552, -0.379752, -3.649614>,
      < 0.074157, -0.388699, -3.685129>,
      < 0.074157, -0.388739, -3.651045>
    }
    triangle {
      < 0.074157, -0.388739, -3.651045>,
      < 0.074157, -0.388699, -3.685129>,
      < -0.309336, -0.393411, -3.684424>
    }
    triangle {
      < 0.074157, -0.388739, -3.651045>,
      < -0.309336, -0.393411, -3.684424>,
      < -0.309336, -0.393450, -3.651760>
    }
    triangle {
      < -0.309336, -0.393450, -3.651760>,
      < -0.309336, -0.393411, -3.684424>,
      < -0.421417, -0.424873, -3.679492>
    }
    triangle {
      < -0.309336, -0.393450, -3.651760>,
      < -0.421417, -0.424873, -3.679492>,
      < -0.421417, -0.424900, -3.656768>
    }
    triangle {
      < -0.421417, -0.424900, -3.656768>,
      < -0.421417, -0.424873, -3.679492>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655384, -0.463019, -3.684662>,
      < 1.655383, -0.459522, -3.673852>
    }
    triangle {
      < 1.655383, -0.459522, -3.673852>,
      < 1.655384, -0.463019, -3.684662>,
      < 1.537385, -0.463089, -3.684662>
    }
    triangle {
      < 1.655383, -0.459522, -3.673852>,
      < 1.537385, -0.463089, -3.684662>,
      < 1.537384, -0.459592, -3.673852>
    }
    triangle {
      < 1.537384, -0.459592, -3.673852>,
      < 1.537385, -0.463089, -3.684662>,
      < 1.501966, -0.430727, -3.701109>
    }
    triangle {
      < 1.537384, -0.459592, -3.673852>,
      < 1.501966, -0.430727, -3.701109>,
      < 1.501962, -0.423733, -3.679491>
    }
    triangle {
      < 1.501962, -0.423733, -3.679491>,
      < 1.501966, -0.430727, -3.701109>,
      < 1.401644, -0.390309, -3.721670>
    }
    triangle {
      < 1.501962, -0.423733, -3.679491>,
      < 1.401644, -0.390309, -3.721670>,
      < 1.401637, -0.378942, -3.686538>
    }
    triangle {
      < 1.401637, -0.378942, -3.686538>,
      < 1.401644, -0.390309, -3.721670>,
      < 0.109558, -0.391074, -3.721670>
    }
    triangle {
      < 1.401637, -0.378942, -3.686538>,
      < 0.109558, -0.391074, -3.721670>,
      < 0.109552, -0.379708, -3.686538>
    }
    triangle {
      < 0.109552, -0.379708, -3.686538>,
      < 0.109558, -0.391074, -3.721670>,
      < 0.074164, -0.399191, -3.717558>
    }
    triangle {
      < 0.109552, -0.379708, -3.686538>,
      < 0.074164, -0.399191, -3.717558>,
      < 0.074157, -0.388699, -3.685129>
    }
    triangle {
      < 0.074157, -0.388699, -3.685129>,
      < 0.074164, -0.399191, -3.717558>,
      < -0.309331, -0.403467, -3.715502>
    }
    triangle {
      < 0.074157, -0.388699, -3.685129>,
      < -0.309331, -0.403467, -3.715502>,
      < -0.309336, -0.393411, -3.684424>
    }
    triangle {
      < -0.309336, -0.393411, -3.684424>,
      < -0.309331, -0.403467, -3.715502>,
      < -0.421412, -0.431868, -3.701109>
    }
    triangle {
      < -0.309336, -0.393411, -3.684424>,
      < -0.421412, -0.431868, -3.701109>,
      < -0.421417, -0.424873, -3.679492>
    }
    triangle {
      < -0.421417, -0.424873, -3.679492>,
      < -0.421412, -0.431868, -3.701109>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655388, -0.469685, -3.693863>,
      < 1.655384, -0.463019, -3.684662>
    }
    triangle {
      < 1.655384, -0.463019, -3.684662>,
      < 1.655388, -0.469685, -3.693863>,
      < 1.537389, -0.469755, -3.693863>
    }
    triangle {
      < 1.655384, -0.463019, -3.684662>,
      < 1.537389, -0.469755, -3.693863>,
      < 1.537385, -0.463089, -3.684662>
    }
    triangle {
      < 1.537385, -0.463089, -3.684662>,
      < 1.537389, -0.469755, -3.693863>,
      < 1.501974, -0.444059, -3.719510>
    }
    triangle {
      < 1.537385, -0.463089, -3.684662>,
      < 1.501974, -0.444059, -3.719510>,
      < 1.501966, -0.430727, -3.701109>
    }
    triangle {
      < 1.501966, -0.430727, -3.701109>,
      < 1.501974, -0.444059, -3.719510>,
      < 1.401656, -0.411974, -3.751570>
    }
    triangle {
      < 1.501966, -0.430727, -3.701109>,
      < 1.401656, -0.411974, -3.751570>,
      < 1.401644, -0.390309, -3.721670>
    }
    triangle {
      < 1.401644, -0.390309, -3.721670>,
      < 1.401656, -0.411974, -3.751570>,
      < 0.109570, -0.412739, -3.751570>
    }
    triangle {
      < 1.401644, -0.390309, -3.721670>,
      < 0.109570, -0.412739, -3.751570>,
      < 0.109558, -0.391074, -3.721670>
    }
    triangle {
      < 0.109558, -0.391074, -3.721670>,
      < 0.109570, -0.412739, -3.751570>,
      < 0.074175, -0.419189, -3.745158>
    }
    triangle {
      < 0.109558, -0.391074, -3.721670>,
      < 0.074175, -0.419189, -3.745158>,
      < 0.074164, -0.399191, -3.717558>
    }
    triangle {
      < 0.074164, -0.399191, -3.717558>,
      < 0.074175, -0.419189, -3.745158>,
      < -0.309319, -0.422631, -3.741952>
    }
    triangle {
      < 0.074164, -0.399191, -3.717558>,
      < -0.309319, -0.422631, -3.741952>,
      < -0.309331, -0.403467, -3.715502>
    }
    triangle {
      < -0.309331, -0.403467, -3.715502>,
      < -0.309319, -0.422631, -3.741952>,
      < -0.421404, -0.445199, -3.719511>
    }
    triangle {
      < -0.309331, -0.403467, -3.715502>,
      < -0.421404, -0.445199, -3.719511>,
      < -0.421412, -0.431868, -3.701109>
    }
    triangle {
      < -0.421412, -0.431868, -3.701109>,
      < -0.421404, -0.445199, -3.719511>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655393, -0.478868, -3.700552>,
      < 1.655388, -0.469685, -3.693863>
    }
    triangle {
      < 1.655388, -0.469685, -3.693863>,
      < 1.655393, -0.478868, -3.700552>,
      < 1.537394, -0.478938, -3.700552>
    }
    triangle {
      < 1.655388, -0.469685, -3.693863>,
      < 1.537394, -0.478938, -3.700552>,
      < 1.537389, -0.469755, -3.693863>
    }
    triangle {
      < 1.537389, -0.469755, -3.693863>,
      < 1.537394, -0.478938, -3.700552>,
      < 1.501985, -0.462424, -3.732892>
    }
    triangle {
      < 1.537389, -0.469755, -3.693863>,
      < 1.501985, -0.462424, -3.732892>,
      < 1.501974, -0.444059, -3.719510>
    }
    triangle {
      < 1.501974, -0.444059, -3.719510>,
      < 1.501985, -0.462424, -3.732892>,
      < 1.401674, -0.441816, -3.773314>
    }
    triangle {
      < 1.501974, -0.444059, -3.719510>,
      < 1.401674, -0.441816, -3.773314>,
      < 1.401656, -0.411974, -3.751570>
    }
    triangle {
      < 1.401656, -0.411974, -3.751570>,
      < 1.401674, -0.441816, -3.773314>,
      < 0.109588, -0.442582, -3.773314>
    }
    triangle {
      < 1.401656, -0.411974, -3.751570>,
      < 0.109588, -0.442582, -3.773314>,
      < 0.109570, -0.412739, -3.751570>
    }
    triangle {
      < 0.109570, -0.412739, -3.751570>,
      < 0.109588, -0.442582, -3.773314>,
      < 0.074191, -0.446736, -3.765230>
    }
    triangle {
      < 0.109570, -0.412739, -3.751570>,
      < 0.074191, -0.446736, -3.765230>,
      < 0.074175, -0.419189, -3.745158>
    }
    triangle {
      < 0.074175, -0.419189, -3.745158>,
      < 0.074191, -0.446736, -3.765230>,
      < -0.309304, -0.449031, -3.761188>
    }
    triangle {
      < 0.074175, -0.419189, -3.745158>,
      < -0.309304, -0.449031, -3.761188>,
      < -0.309319, -0.422631, -3.741952>
    }
    triangle {
      < -0.309319, -0.422631, -3.741952>,
      < -0.309304, -0.449031, -3.761188>,
      < -0.421393, -0.463564, -3.732892>
    }
    triangle {
      < -0.309319, -0.422631, -3.741952>,
      < -0.421393, -0.463564, -3.732892>,
      < -0.421404, -0.445199, -3.719511>
    }
    triangle {
      < -0.421404, -0.445199, -3.719511>,
      < -0.421393, -0.463564, -3.732892>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655400, -0.489668, -3.704079>,
      < 1.655393, -0.478868, -3.700552>
    }
    triangle {
      < 1.655393, -0.478868, -3.700552>,
      < 1.655400, -0.489668, -3.704079>,
      < 1.537401, -0.489738, -3.704079>
    }
    triangle {
      < 1.655393, -0.478868, -3.700552>,
      < 1.537401, -0.489738, -3.704079>,
      < 1.537394, -0.478938, -3.700552>
    }
    triangle {
      < 1.537394, -0.478938, -3.700552>,
      < 1.537401, -0.489738, -3.704079>,
      < 1.501998, -0.484025, -3.739944>
    }
    triangle {
      < 1.537394, -0.478938, -3.700552>,
      < 1.501998, -0.484025, -3.739944>,
      < 1.501985, -0.462424, -3.732892>
    }
    triangle {
      < 1.501985, -0.462424, -3.732892>,
      < 1.501998, -0.484025, -3.739944>,
      < 1.401695, -0.476917, -3.784775>
    }
    triangle {
      < 1.501985, -0.462424, -3.732892>,
      < 1.401695, -0.476917, -3.784775>,
      < 1.401674, -0.441816, -3.773314>
    }
    triangle {
      < 1.401674, -0.441816, -3.773314>,
      < 1.401695, -0.476917, -3.784775>,
      < 0.109609, -0.477683, -3.784775>
    }
    triangle {
      < 1.401674, -0.441816, -3.773314>,
      < 0.109609, -0.477683, -3.784775>,
      < 0.109588, -0.442582, -3.773314>
    }
    triangle {
      < 0.109588, -0.442582, -3.773314>,
      < 0.109609, -0.477683, -3.784775>,
      < 0.074210, -0.479137, -3.775808>
    }
    triangle {
      < 0.109588, -0.442582, -3.773314>,
      < 0.074210, -0.479137, -3.775808>,
      < 0.074191, -0.446736, -3.765230>
    }
    triangle {
      < 0.074191, -0.446736, -3.765230>,
      < 0.074210, -0.479137, -3.775808>,
      < -0.309285, -0.480081, -3.771325>
    }
    triangle {
      < 0.074191, -0.446736, -3.765230>,
      < -0.309285, -0.480081, -3.771325>,
      < -0.309304, -0.449031, -3.761188>
    }
    triangle {
      < -0.309304, -0.449031, -3.761188>,
      < -0.309285, -0.480081, -3.771325>,
      < -0.421381, -0.485165, -3.739944>
    }
    triangle {
      < -0.309304, -0.449031, -3.761188>,
      < -0.421381, -0.485165, -3.739944>,
      < -0.421393, -0.463564, -3.732892>
    }
    triangle {
      < -0.421393, -0.463564, -3.732892>,
      < -0.421381, -0.485165, -3.739944>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655407, -0.501029, -3.704095>,
      < 1.655400, -0.489668, -3.704079>
    }
    triangle {
      < 1.655400, -0.489668, -3.704079>,
      < 1.655407, -0.501029, -3.704095>,
      < 1.537408, -0.501099, -3.704095>
    }
    triangle {
      < 1.655400, -0.489668, -3.704079>,
      < 1.537408, -0.501099, -3.704095>,
      < 1.537401, -0.489738, -3.704079>
    }
    triangle {
      < 1.537401, -0.489738, -3.704079>,
      < 1.537408, -0.501099, -3.704095>,
      < 1.502012, -0.506747, -3.739977>
    }
    triangle {
      < 1.537401, -0.489738, -3.704079>,
      < 1.502012, -0.506747, -3.739977>,
      < 1.501998, -0.484025, -3.739944>
    }
    triangle {
      < 1.501998, -0.484025, -3.739944>,
      < 1.502012, -0.506747, -3.739977>,
      < 1.401717, -0.513841, -3.784829>
    }
    triangle {
      < 1.501998, -0.484025, -3.739944>,
      < 1.401717, -0.513841, -3.784829>,
      < 1.401695, -0.476917, -3.784775>
    }
    triangle {
      < 1.401695, -0.476917, -3.784775>,
      < 1.401717, -0.513841, -3.784829>,
      < 0.109632, -0.514607, -3.784830>
    }
    triangle {
      < 1.401695, -0.476917, -3.784775>,
      < 0.109632, -0.514607, -3.784830>,
      < 0.109609, -0.477683, -3.784775>
    }
    triangle {
      < 0.109609, -0.477683, -3.784775>,
      < 0.109632, -0.514607, -3.784830>,
      < 0.074231, -0.513221, -3.775859>
    }
    triangle {
      < 0.109609, -0.477683, -3.784775>,
      < 0.074231, -0.513221, -3.775859>,
      < 0.074210, -0.479137, -3.775808>
    }
    triangle {
      < 0.074210, -0.479137, -3.775808>,
      < 0.074231, -0.513221, -3.775859>,
      < -0.309266, -0.512745, -3.771374>
    }
    triangle {
      < 0.074210, -0.479137, -3.775808>,
      < -0.309266, -0.512745, -3.771374>,
      < -0.309285, -0.480081, -3.771325>
    }
    triangle {
      < -0.309285, -0.480081, -3.771325>,
      < -0.309266, -0.512745, -3.771374>,
      < -0.421367, -0.507887, -3.739978>
    }
    triangle {
      < -0.309285, -0.480081, -3.771325>,
      < -0.421367, -0.507887, -3.739978>,
      < -0.421381, -0.485165, -3.739944>
    }
    triangle {
      < -0.421381, -0.485165, -3.739944>,
      < -0.421367, -0.507887, -3.739978>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655413, -0.511839, -3.700602>,
      < 1.655407, -0.501029, -3.704095>
    }
    triangle {
      < 1.655407, -0.501029, -3.704095>,
      < 1.655413, -0.511839, -3.700602>,
      < 1.537414, -0.511909, -3.700602>
    }
    triangle {
      < 1.655407, -0.501029, -3.704095>,
      < 1.537414, -0.511909, -3.700602>,
      < 1.537408, -0.501099, -3.704095>
    }
    triangle {
      < 1.537408, -0.501099, -3.704095>,
      < 1.537414, -0.511909, -3.700602>,
      < 1.502024, -0.528369, -3.732989>
    }
    triangle {
      < 1.537408, -0.501099, -3.704095>,
      < 1.502024, -0.528369, -3.732989>,
      < 1.502012, -0.506747, -3.739977>
    }
    triangle {
      < 1.502012, -0.506747, -3.739977>,
      < 1.502024, -0.528369, -3.732989>,
      < 1.401738, -0.548976, -3.773473>
    }
    triangle {
      < 1.502012, -0.506747, -3.739977>,
      < 1.401738, -0.548976, -3.773473>,
      < 1.401717, -0.513841, -3.784829>
    }
    triangle {
      < 1.401717, -0.513841, -3.784829>,
      < 1.401738, -0.548976, -3.773473>,
      < 0.109652, -0.549742, -3.773473>
    }
    triangle {
      < 1.401717, -0.513841, -3.784829>,
      < 0.109652, -0.549742, -3.773473>,
      < 0.109632, -0.514607, -3.784830>
    }
    triangle {
      < 0.109632, -0.514607, -3.784830>,
      < 0.109652, -0.549742, -3.773473>,
      < 0.074250, -0.545653, -3.765376>
    }
    triangle {
      < 0.109632, -0.514607, -3.784830>,
      < 0.074250, -0.545653, -3.765376>,
      < 0.074231, -0.513221, -3.775859>
    }
    triangle {
      < 0.074231, -0.513221, -3.775859>,
      < 0.074250, -0.545653, -3.765376>,
      < -0.309247, -0.543826, -3.761328>
    }
    triangle {
      < 0.074231, -0.513221, -3.775859>,
      < -0.309247, -0.543826, -3.761328>,
      < -0.309266, -0.512745, -3.771374>
    }
    triangle {
      < -0.309266, -0.512745, -3.771374>,
      < -0.309247, -0.543826, -3.761328>,
      < -0.421355, -0.529509, -3.732989>
    }
    triangle {
      < -0.309266, -0.512745, -3.771374>,
      < -0.421355, -0.529509, -3.732989>,
      < -0.421367, -0.507887, -3.739978>
    }
    triangle {
      < -0.421367, -0.507887, -3.739978>,
      < -0.421355, -0.529509, -3.732989>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < 1.655403, -0.495401, -3.668214>,
      < 1.655419, -0.521072, -3.693908>,
      < 1.655413, -0.511839, -3.700602>
    }
    triangle {
      < 1.655413, -0.511839, -3.700602>,
      < 1.655419, -0.521072, -3.693908>,
      < 1.537420, -0.521143, -3.693908>
    }
    triangle {
      < 1.655413, -0.511839, -3.700602>,
      < 1.537420, -0.521143, -3.693908>,
      < 1.537414, -0.511909, -3.700602>
    }
    triangle {
      < 1.537414, -0.511909, -3.700602>,
      < 1.537420, -0.521143, -3.693908>,
      < 1.502035, -0.546834, -3.719602>
    }
    triangle {
      < 1.537414, -0.511909, -3.700602>,
      < 1.502035, -0.546834, -3.719602>,
      < 1.502024, -0.528369, -3.732989>
    }
    triangle {
      < 1.502024, -0.528369, -3.732989>,
      < 1.502035, -0.546834, -3.719602>,
      < 1.401755, -0.578982, -3.751719>
    }
    triangle {
      < 1.502024, -0.528369, -3.732989>,
      < 1.401755, -0.578982, -3.751719>,
      < 1.401738, -0.548976, -3.773473>
    }
    triangle {
      < 1.401738, -0.548976, -3.773473>,
      < 1.401755, -0.578982, -3.751719>,
      < 0.109669, -0.579748, -3.751719>
    }
    triangle {
      < 1.401738, -0.548976, -3.773473>,
      < 0.109669, -0.579748, -3.751719>,
      < 0.109652, -0.549742, -3.773473>
    }
    triangle {
      < 0.109652, -0.549742, -3.773473>,
      < 0.109669, -0.579748, -3.751719>,
      < 0.074266, -0.573351, -3.745295>
    }
    triangle {
      < 0.109652, -0.549742, -3.773473>,
      < 0.074266, -0.573351, -3.745295>,
      < 0.074250, -0.545653, -3.765376>
    }
    triangle {
      < 0.074250, -0.545653, -3.765376>,
      < 0.074266, -0.573351, -3.745295>,
      < -0.309232, -0.570369, -3.742084>
    }
    triangle {
      < 0.074250, -0.545653, -3.765376>,
      < -0.309232, -0.570369, -3.742084>,
      < -0.309247, -0.543826, -3.761328>
    }
    triangle {
      < -0.309247, -0.543826, -3.761328>,
      < -0.309232, -0.570369, -3.742084>,
      < -0.421344, -0.547974, -3.719602>
    }
    triangle {
      < -0.309247, -0.543826, -3.761328>,
      < -0.421344, -0.547974, -3.719602>,
      < -0.421355, -0.529509, -3.732989>
    }
    triangle {
      < -0.421355, -0.529509, -3.732989>,
      < -0.421344, -0.547974, -3.719602>,
      < -0.498073, -0.496677, -3.668215>
    }
    triangle {
      < -0.090787, -0.655555, -3.489283>,
      < -0.090880, -0.497340, -3.647264>,
      < -0.360101, -0.497499, -3.647264>
    }
    triangle {
      < -0.090787, -0.655555, -3.489283>,
      < -0.360101, -0.497499, -3.647264>,
      < -0.360007, -0.655715, -3.489283>
    }
    triangle {
      < -0.359995, -0.675763, -3.509362>,
      < -0.360089, -0.517549, -3.667343>,
      < -0.090868, -0.517389, -3.667342>
    }
    triangle {
      < -0.359995, -0.675763, -3.509362>,
      < -0.090868, -0.517389, -3.667342>,
      < -0.090775, -0.675604, -3.509362>
    }
    triangle {
      < -0.360007, -0.655715, -3.489283>,
      < -0.360101, -0.497499, -3.647264>,
      < -0.360089, -0.517549, -3.667343>
    }
    triangle {
      < -0.360007, -0.655715, -3.489283>,
      < -0.360089, -0.517549, -3.667343>,
      < -0.359995, -0.675763, -3.509362>
    }
    triangle {
      < -0.090775, -0.675604, -3.509362>,
      < -0.090787, -0.655555, -3.489283>,
      < -0.360007, -0.655715, -3.489283>
    }
    triangle {
      < -0.090775, -0.675604, -3.509362>,
      < -0.360007, -0.655715, -3.489283>,
      < -0.359995, -0.675763, -3.509362>
    }
    triangle {
      < -0.090775, -0.675604, -3.509362>,
      < -0.090868, -0.517389, -3.667342>,
      < -0.090880, -0.497340, -3.647264>
    }
    triangle {
      < -0.090775, -0.675604, -3.509362>,
      < -0.090880, -0.497340, -3.647264>,
      < -0.090787, -0.655555, -3.489283>
    }
    triangle {
      < -0.090880, -0.497340, -3.647264>,
      < -0.090868, -0.517389, -3.667342>,
      < -0.360089, -0.517549, -3.667343>
    }
    triangle {
      < -0.090880, -0.497340, -3.647264>,
      < -0.360089, -0.517549, -3.667343>,
      < -0.360101, -0.497499, -3.647264>
    }
    triangle {
      < 0.291653, -0.655328, -3.489283>,
      < 0.291559, -0.497113, -3.647264>,
      < 0.022339, -0.497272, -3.647264>
    }
    triangle {
      < 0.291653, -0.655328, -3.489283>,
      < 0.022339, -0.497272, -3.647264>,
      < 0.022432, -0.655488, -3.489283>
    }
    triangle {
      < 0.022444, -0.675537, -3.509362>,
      < 0.022351, -0.517322, -3.667342>,
      < 0.291571, -0.517163, -3.667342>
    }
    triangle {
      < 0.022444, -0.675537, -3.509362>,
      < 0.291571, -0.517163, -3.667342>,
      < 0.291665, -0.675377, -3.509362>
    }
    triangle {
      < 0.022432, -0.655488, -3.489283>,
      < 0.022339, -0.497272, -3.647264>,
      < 0.022351, -0.517322, -3.667342>
    }
    triangle {
      < 0.022432, -0.655488, -3.489283>,
      < 0.022351, -0.517322, -3.667342>,
      < 0.022444, -0.675537, -3.509362>
    }
    triangle {
      < 0.291665, -0.675377, -3.509362>,
      < 0.291653, -0.655328, -3.489283>,
      < 0.022432, -0.655488, -3.489283>
    }
    triangle {
      < 0.291665, -0.675377, -3.509362>,
      < 0.022432, -0.655488, -3.489283>,
      < 0.022444, -0.675537, -3.509362>
    }
    triangle {
      < 0.291665, -0.675377, -3.509362>,
      < 0.291571, -0.517163, -3.667342>,
      < 0.291559, -0.497113, -3.647264>
    }
    triangle {
      < 0.291665, -0.675377, -3.509362>,
      < 0.291559, -0.497113, -3.647264>,
      < 0.291653, -0.655328, -3.489283>
    }
    triangle {
      < 0.291559, -0.497113, -3.647264>,
      < 0.291571, -0.517163, -3.667342>,
      < 0.022351, -0.517322, -3.667342>
    }
    triangle {
      < 0.291559, -0.497113, -3.647264>,
      < 0.022351, -0.517322, -3.667342>,
      < 0.022339, -0.497272, -3.647264>
    }
    triangle {
      < -0.090986, -0.317552, -3.509044>,
      < -0.090893, -0.475485, -3.667305>,
      < -0.360113, -0.475645, -3.667305>
    }
    triangle {
      < -0.090986, -0.317552, -3.509044>,
      < -0.360113, -0.475645, -3.667305>,
      < -0.360207, -0.317711, -3.509044>
    }
    triangle {
      < -0.360195, -0.337796, -3.489000>,
      < -0.360102, -0.495730, -3.647262>,
      < -0.090881, -0.495570, -3.647261>
    }
    triangle {
      < -0.360195, -0.337796, -3.489000>,
      < -0.090881, -0.495570, -3.647261>,
      < -0.090975, -0.337637, -3.489000>
    }
    triangle {
      < -0.360207, -0.317711, -3.509044>,
      < -0.360113, -0.475645, -3.667305>,
      < -0.360102, -0.495730, -3.647262>
    }
    triangle {
      < -0.360207, -0.317711, -3.509044>,
      < -0.360102, -0.495730, -3.647262>,
      < -0.360195, -0.337796, -3.489000>
    }
    triangle {
      < -0.090975, -0.337637, -3.489000>,
      < -0.090986, -0.317552, -3.509044>,
      < -0.360207, -0.317711, -3.509044>
    }
    triangle {
      < -0.090975, -0.337637, -3.489000>,
      < -0.360207, -0.317711, -3.509044>,
      < -0.360195, -0.337796, -3.489000>
    }
    triangle {
      < -0.090975, -0.337637, -3.489000>,
      < -0.090881, -0.495570, -3.647261>,
      < -0.090893, -0.475485, -3.667305>
    }
    triangle {
      < -0.090975, -0.337637, -3.489000>,
      < -0.090893, -0.475485, -3.667305>,
      < -0.090986, -0.317552, -3.509044>
    }
    triangle {
      < -0.090893, -0.475485, -3.667305>,
      < -0.090881, -0.495570, -3.647261>,
      < -0.360102, -0.495730, -3.647262>
    }
    triangle {
      < -0.090893, -0.475485, -3.667305>,
      < -0.360102, -0.495730, -3.647262>,
      < -0.360113, -0.475645, -3.667305>
    }
    triangle {
      < 0.291453, -0.317325, -3.509044>,
      < 0.291547, -0.475259, -3.667305>,
      < 0.022326, -0.475418, -3.667305>
    }
    triangle {
      < 0.291453, -0.317325, -3.509044>,
      < 0.022326, -0.475418, -3.667305>,
      < 0.022233, -0.317484, -3.509044>
    }
    triangle {
      < 0.022244, -0.337569, -3.489000>,
      < 0.022338, -0.495503, -3.647261>,
      < 0.291559, -0.495344, -3.647261>
    }
    triangle {
      < 0.022244, -0.337569, -3.489000>,
      < 0.291559, -0.495344, -3.647261>,
      < 0.291465, -0.337410, -3.488999>
    }
    triangle {
      < 0.022233, -0.317484, -3.509044>,
      < 0.022326, -0.475418, -3.667305>,
      < 0.022338, -0.495503, -3.647261>
    }
    triangle {
      < 0.022233, -0.317484, -3.509044>,
      < 0.022338, -0.495503, -3.647261>,
      < 0.022244, -0.337569, -3.489000>
    }
    triangle {
      < 0.291465, -0.337410, -3.488999>,
      < 0.291453, -0.317325, -3.509044>,
      < 0.022233, -0.317484, -3.509044>
    }
    triangle {
      < 0.291465, -0.337410, -3.488999>,
      < 0.022233, -0.317484, -3.509044>,
      < 0.022244, -0.337569, -3.489000>
    }
    triangle {
      < 0.291465, -0.337410, -3.488999>,
      < 0.291559, -0.495344, -3.647261>,
      < 0.291547, -0.475259, -3.667305>
    }
    triangle {
      < 0.291465, -0.337410, -3.488999>,
      < 0.291547, -0.475259, -3.667305>,
      < 0.291453, -0.317325, -3.509044>
    }
    triangle {
      < 0.291547, -0.475259, -3.667305>,
      < 0.291559, -0.495344, -3.647261>,
      < 0.022338, -0.495503, -3.647261>
    }
    triangle {
      < 0.291547, -0.475259, -3.667305>,
      < 0.022338, -0.495503, -3.647261>,
      < 0.022326, -0.475418, -3.667305>
    }
    triangle {
      < -0.090975, -0.337212, -3.847052>,
      < -0.090881, -0.495521, -3.689166>,
      < -0.360102, -0.495680, -3.689166>
    }
    triangle {
      < -0.090975, -0.337212, -3.847052>,
      < -0.360102, -0.495680, -3.689166>,
      < -0.360195, -0.337371, -3.847052>
    }
    triangle {
      < -0.360207, -0.317334, -3.826961>,
      < -0.360113, -0.475642, -3.669075>,
      < -0.090893, -0.475483, -3.669075>
    }
    triangle {
      < -0.360207, -0.317334, -3.826961>,
      < -0.090893, -0.475483, -3.669075>,
      < -0.090986, -0.317175, -3.826961>
    }
    triangle {
      < -0.360195, -0.337371, -3.847052>,
      < -0.360102, -0.495680, -3.689166>,
      < -0.360113, -0.475642, -3.669075>
    }
    triangle {
      < -0.360195, -0.337371, -3.847052>,
      < -0.360113, -0.475642, -3.669075>,
      < -0.360207, -0.317334, -3.826961>
    }
    triangle {
      < -0.090986, -0.317175, -3.826961>,
      < -0.090975, -0.337212, -3.847052>,
      < -0.360195, -0.337371, -3.847052>
    }
    triangle {
      < -0.090986, -0.317175, -3.826961>,
      < -0.360195, -0.337371, -3.847052>,
      < -0.360207, -0.317334, -3.826961>
    }
    triangle {
      < -0.090986, -0.317175, -3.826961>,
      < -0.090893, -0.475483, -3.669075>,
      < -0.090881, -0.495521, -3.689166>
    }
    triangle {
      < -0.090986, -0.317175, -3.826961>,
      < -0.090881, -0.495521, -3.689166>,
      < -0.090975, -0.337212, -3.847052>
    }
    triangle {
      < -0.090881, -0.495521, -3.689166>,
      < -0.090893, -0.475483, -3.669075>,
      < -0.360113, -0.475642, -3.669075>
    }
    triangle {
      < -0.090881, -0.495521, -3.689166>,
      < -0.360113, -0.475642, -3.669075>,
      < -0.360102, -0.495680, -3.689166>
    }
    triangle {
      < 0.291465, -0.336985, -3.847052>,
      < 0.291559, -0.495294, -3.689166>,
      < 0.022338, -0.495454, -3.689166>
    }
    triangle {
      < 0.291465, -0.336985, -3.847052>,
      < 0.022338, -0.495454, -3.689166>,
      < 0.022244, -0.337144, -3.847052>
    }
    triangle {
      < 0.022233, -0.317107, -3.826961>,
      < 0.022326, -0.475416, -3.669074>,
      < 0.291547, -0.475256, -3.669074>
    }
    triangle {
      < 0.022233, -0.317107, -3.826961>,
      < 0.291547, -0.475256, -3.669074>,
      < 0.291452, -0.316948, -3.826961>
    }
    triangle {
      < 0.022244, -0.337144, -3.847052>,
      < 0.022338, -0.495454, -3.689166>,
      < 0.022326, -0.475416, -3.669074>
    }
    triangle {
      < 0.022244, -0.337144, -3.847052>,
      < 0.022326, -0.475416, -3.669074>,
      < 0.022233, -0.317107, -3.826961>
    }
    triangle {
      < 0.291452, -0.316948, -3.826961>,
      < 0.291465, -0.336985, -3.847052>,
      < 0.022244, -0.337144, -3.847052>
    }
    triangle {
      < 0.291452, -0.316948, -3.826961>,
      < 0.022244, -0.337144, -3.847052>,
      < 0.022233, -0.317107, -3.826961>
    }
    triangle {
      < 0.291452, -0.316948, -3.826961>,
      < 0.291547, -0.475256, -3.669074>,
      < 0.291559, -0.495294, -3.689166>
    }
    triangle {
      < 0.291452, -0.316948, -3.826961>,
      < 0.291559, -0.495294, -3.689166>,
      < 0.291465, -0.336985, -3.847052>
    }
    triangle {
      < 0.291559, -0.495294, -3.689166>,
      < 0.291547, -0.475256, -3.669074>,
      < 0.022326, -0.475416, -3.669074>
    }
    triangle {
      < 0.291559, -0.495294, -3.689166>,
      < 0.022326, -0.475416, -3.669074>,
      < 0.022338, -0.495454, -3.689166>
    }
    triangle {
      < -0.090775, -0.675227, -3.827492>,
      < -0.090868, -0.517387, -3.669136>,
      < -0.360089, -0.517546, -3.669137>
    }
    triangle {
      < -0.090775, -0.675227, -3.827492>,
      < -0.360089, -0.517546, -3.669137>,
      < -0.359995, -0.675386, -3.827492>
    }
    triangle {
      < -0.360007, -0.655290, -3.847524>,
      < -0.360101, -0.497449, -3.689168>,
      < -0.090880, -0.497290, -3.689168>
    }
    triangle {
      < -0.360007, -0.655290, -3.847524>,
      < -0.090880, -0.497290, -3.689168>,
      < -0.090787, -0.655131, -3.847524>
    }
    triangle {
      < -0.359995, -0.675386, -3.827492>,
      < -0.360089, -0.517546, -3.669137>,
      < -0.360101, -0.497449, -3.689168>
    }
    triangle {
      < -0.359995, -0.675386, -3.827492>,
      < -0.360101, -0.497449, -3.689168>,
      < -0.360007, -0.655290, -3.847524>
    }
    triangle {
      < -0.090787, -0.655131, -3.847524>,
      < -0.090775, -0.675227, -3.827492>,
      < -0.359995, -0.675386, -3.827492>
    }
    triangle {
      < -0.090787, -0.655131, -3.847524>,
      < -0.359995, -0.675386, -3.827492>,
      < -0.360007, -0.655290, -3.847524>
    }
    triangle {
      < -0.090787, -0.655131, -3.847524>,
      < -0.090880, -0.497290, -3.689168>,
      < -0.090868, -0.517387, -3.669136>
    }
    triangle {
      < -0.090787, -0.655131, -3.847524>,
      < -0.090868, -0.517387, -3.669136>,
      < -0.090775, -0.675227, -3.827492>
    }
    triangle {
      < -0.090868, -0.517387, -3.669136>,
      < -0.090880, -0.497290, -3.689168>,
      < -0.360101, -0.497449, -3.689168>
    }
    triangle {
      < -0.090868, -0.517387, -3.669136>,
      < -0.360101, -0.497449, -3.689168>,
      < -0.360089, -0.517546, -3.669137>
    }
    triangle {
      < 0.291665, -0.675000, -3.827492>,
      < 0.291571, -0.517160, -3.669136>,
      < 0.022351, -0.517320, -3.669136>
    }
    triangle {
      < 0.291665, -0.675000, -3.827492>,
      < 0.022351, -0.517320, -3.669136>,
      < 0.022444, -0.675160, -3.827492>
    }
    triangle {
      < 0.022432, -0.655063, -3.847524>,
      < 0.022339, -0.497222, -3.689168>,
      < 0.291559, -0.497063, -3.689168>
    }
    triangle {
      < 0.022432, -0.655063, -3.847524>,
      < 0.291559, -0.497063, -3.689168>,
      < 0.291653, -0.654904, -3.847524>
    }
    triangle {
      < 0.022444, -0.675160, -3.827492>,
      < 0.022351, -0.517320, -3.669136>,
      < 0.022339, -0.497222, -3.689168>
    }
    triangle {
      < 0.022444, -0.675160, -3.827492>,
      < 0.022339, -0.497222, -3.689168>,
      < 0.022432, -0.655063, -3.847524>
    }
    triangle {
      < 0.291653, -0.654904, -3.847524>,
      < 0.291665, -0.675000, -3.827492>,
      < 0.022444, -0.675160, -3.827492>
    }
    triangle {
      < 0.291653, -0.654904, -3.847524>,
      < 0.022444, -0.675160, -3.827492>,
      < 0.022432, -0.655063, -3.847524>
    }
    triangle {
      < 0.291653, -0.654904, -3.847524>,
      < 0.291559, -0.497063, -3.689168>,
      < 0.291571, -0.517160, -3.669136>
    }
    triangle {
      < 0.291653, -0.654904, -3.847524>,
      < 0.291571, -0.517160, -3.669136>,
      < 0.291665, -0.675000, -3.827492>
    }
    triangle {
      < 0.291571, -0.517160, -3.669136>,
      < 0.291559, -0.497063, -3.689168>,
      < 0.022339, -0.497222, -3.689168>
    }
    triangle {
      < 0.291571, -0.517160, -3.669136>,
      < 0.022339, -0.497222, -3.689168>,
      < 0.022351, -0.517320, -3.669136>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415417, -0.753990, -0.387530>,
      < 1.415413, -0.746565, -0.397740>
    }
    triangle {
      < 1.415413, -0.746565, -0.397740>,
      < 1.415417, -0.753990, -0.387530>,
      < 1.314528, -0.754050, -0.387530>
    }
    triangle {
      < 1.415413, -0.746565, -0.397740>,
      < 1.314528, -0.754050, -0.387530>,
      < 1.314524, -0.746625, -0.397740>
    }
    triangle {
      < 1.314524, -0.746625, -0.397740>,
      < 1.314528, -0.754050, -0.387530>,
      < 1.284282, -0.790017, -0.405870>
    }
    triangle {
      < 1.314524, -0.746625, -0.397740>,
      < 1.284282, -0.790017, -0.405870>,
      < 1.284274, -0.775167, -0.426289>
    }
    triangle {
      < 1.284274, -0.775167, -0.426289>,
      < 1.284282, -0.790017, -0.405870>,
      < 1.198553, -0.835002, -0.428793>
    }
    triangle {
      < 1.284274, -0.775167, -0.426289>,
      < 1.198553, -0.835002, -0.428793>,
      < 1.198539, -0.810871, -0.461974>
    }
    triangle {
      < 1.198539, -0.810871, -0.461974>,
      < 1.198553, -0.835002, -0.428793>,
      < 0.093817, -0.835656, -0.428794>
    }
    triangle {
      < 1.198539, -0.810871, -0.461974>,
      < 0.093817, -0.835656, -0.428794>,
      < 0.093803, -0.811526, -0.461974>
    }
    triangle {
      < 0.093803, -0.811526, -0.461974>,
      < 0.093817, -0.835656, -0.428794>,
      < 0.063546, -0.826687, -0.424209>
    }
    triangle {
      < 0.093803, -0.811526, -0.461974>,
      < 0.063546, -0.826687, -0.424209>,
      < 0.063533, -0.804412, -0.454837>
    }
    triangle {
      < 0.063533, -0.804412, -0.454837>,
      < 0.063546, -0.826687, -0.424209>,
      < -0.264347, -0.822389, -0.421917>
    }
    triangle {
      < 0.063533, -0.804412, -0.454837>,
      < -0.264347, -0.822389, -0.421917>,
      < -0.264359, -0.801042, -0.451268>
    }
    triangle {
      < -0.264359, -0.801042, -0.451268>,
      < -0.264347, -0.822389, -0.421917>,
      < -0.360210, -0.790992, -0.405870>
    }
    triangle {
      < -0.264359, -0.801042, -0.451268>,
      < -0.360210, -0.790992, -0.405870>,
      < -0.360219, -0.776142, -0.426289>
    }
    triangle {
      < -0.360219, -0.776142, -0.426289>,
      < -0.360210, -0.790992, -0.405870>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415419, -0.757898, -0.375528>,
      < 1.415417, -0.753990, -0.387530>
    }
    triangle {
      < 1.415417, -0.753990, -0.387530>,
      < 1.415419, -0.757898, -0.375528>,
      < 1.314530, -0.757958, -0.375528>
    }
    triangle {
      < 1.415417, -0.753990, -0.387530>,
      < 1.314530, -0.757958, -0.375528>,
      < 1.314528, -0.754050, -0.387530>
    }
    triangle {
      < 1.314528, -0.754050, -0.387530>,
      < 1.314530, -0.757958, -0.375528>,
      < 1.284287, -0.797831, -0.381862>
    }
    triangle {
      < 1.314528, -0.754050, -0.387530>,
      < 1.284287, -0.797831, -0.381862>,
      < 1.284282, -0.790017, -0.405870>
    }
    triangle {
      < 1.284282, -0.790017, -0.405870>,
      < 1.284287, -0.797831, -0.381862>,
      < 1.198561, -0.847701, -0.389782>
    }
    triangle {
      < 1.284282, -0.790017, -0.405870>,
      < 1.198561, -0.847701, -0.389782>,
      < 1.198553, -0.835002, -0.428793>
    }
    triangle {
      < 1.198553, -0.835002, -0.428793>,
      < 1.198561, -0.847701, -0.389782>,
      < 0.093825, -0.848356, -0.389782>
    }
    triangle {
      < 1.198553, -0.835002, -0.428793>,
      < 0.093825, -0.848356, -0.389782>,
      < 0.093817, -0.835656, -0.428794>
    }
    triangle {
      < 0.093817, -0.835656, -0.428794>,
      < 0.093825, -0.848356, -0.389782>,
      < 0.063553, -0.838409, -0.388198>
    }
    triangle {
      < 0.093817, -0.835656, -0.428794>,
      < 0.063553, -0.838409, -0.388198>,
      < 0.063546, -0.826687, -0.424209>
    }
    triangle {
      < 0.063546, -0.826687, -0.424209>,
      < 0.063553, -0.838409, -0.388198>,
      < -0.264340, -0.833622, -0.387406>
    }
    triangle {
      < 0.063546, -0.826687, -0.424209>,
      < -0.264340, -0.833622, -0.387406>,
      < -0.264347, -0.822389, -0.421917>
    }
    triangle {
      < -0.264347, -0.822389, -0.421917>,
      < -0.264340, -0.833622, -0.387406>,
      < -0.360206, -0.798806, -0.381863>
    }
    triangle {
      < -0.264347, -0.822389, -0.421917>,
      < -0.360206, -0.798806, -0.381863>,
      < -0.360210, -0.790992, -0.405870>
    }
    triangle {
      < -0.360210, -0.790992, -0.405870>,
      < -0.360206, -0.798806, -0.381863>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415419, -0.757904, -0.362904>,
      < 1.415419, -0.757898, -0.375528>
    }
    triangle {
      < 1.415419, -0.757898, -0.375528>,
      < 1.415419, -0.757904, -0.362904>,
      < 1.314530, -0.757964, -0.362904>
    }
    triangle {
      < 1.415419, -0.757898, -0.375528>,
      < 1.314530, -0.757964, -0.362904>,
      < 1.314530, -0.757958, -0.375528>
    }
    triangle {
      < 1.314530, -0.757958, -0.375528>,
      < 1.314530, -0.757964, -0.362904>,
      < 1.284287, -0.797845, -0.356615>
    }
    triangle {
      < 1.314530, -0.757958, -0.375528>,
      < 1.284287, -0.797845, -0.356615>,
      < 1.284287, -0.797831, -0.381862>
    }
    triangle {
      < 1.284287, -0.797831, -0.381862>,
      < 1.284287, -0.797845, -0.356615>,
      < 1.198561, -0.847725, -0.348754>
    }
    triangle {
      < 1.284287, -0.797831, -0.381862>,
      < 1.198561, -0.847725, -0.348754>,
      < 1.198561, -0.847701, -0.389782>
    }
    triangle {
      < 1.198561, -0.847701, -0.389782>,
      < 1.198561, -0.847725, -0.348754>,
      < 0.093825, -0.848379, -0.348754>
    }
    triangle {
      < 1.198561, -0.847701, -0.389782>,
      < 0.093825, -0.848379, -0.348754>,
      < 0.093825, -0.848356, -0.389782>
    }
    triangle {
      < 0.093825, -0.848356, -0.389782>,
      < 0.093825, -0.848379, -0.348754>,
      < 0.063553, -0.838431, -0.350326>
    }
    triangle {
      < 0.093825, -0.848356, -0.389782>,
      < 0.063553, -0.838431, -0.350326>,
      < 0.063553, -0.838409, -0.388198>
    }
    triangle {
      < 0.063553, -0.838409, -0.388198>,
      < 0.063553, -0.838431, -0.350326>,
      < -0.264340, -0.833644, -0.351113>
    }
    triangle {
      < 0.063553, -0.838409, -0.388198>,
      < -0.264340, -0.833644, -0.351113>,
      < -0.264340, -0.833622, -0.387406>
    }
    triangle {
      < -0.264340, -0.833622, -0.387406>,
      < -0.264340, -0.833644, -0.351113>,
      < -0.360206, -0.798820, -0.356616>
    }
    triangle {
      < -0.264340, -0.833622, -0.387406>,
      < -0.360206, -0.798820, -0.356616>,
      < -0.360206, -0.798806, -0.381863>
    }
    triangle {
      < -0.360206, -0.798806, -0.381863>,
      < -0.360206, -0.798820, -0.356616>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415417, -0.754012, -0.350895>,
      < 1.415419, -0.757904, -0.362904>
    }
    triangle {
      < 1.415419, -0.757904, -0.362904>,
      < 1.415417, -0.754012, -0.350895>,
      < 1.314528, -0.754072, -0.350895>
    }
    triangle {
      < 1.415419, -0.757904, -0.362904>,
      < 1.314528, -0.754072, -0.350895>,
      < 1.314530, -0.757964, -0.362904>
    }
    triangle {
      < 1.314530, -0.757964, -0.362904>,
      < 1.314528, -0.754072, -0.350895>,
      < 1.284282, -0.790059, -0.332598>
    }
    triangle {
      < 1.314530, -0.757964, -0.362904>,
      < 1.284282, -0.790059, -0.332598>,
      < 1.284287, -0.797845, -0.356615>
    }
    triangle {
      < 1.284287, -0.797845, -0.356615>,
      < 1.284282, -0.790059, -0.332598>,
      < 1.198553, -0.835072, -0.309727>
    }
    triangle {
      < 1.284287, -0.797845, -0.356615>,
      < 1.198553, -0.835072, -0.309727>,
      < 1.198561, -0.847725, -0.348754>
    }
    triangle {
      < 1.198561, -0.847725, -0.348754>,
      < 1.198553, -0.835072, -0.309727>,
      < 0.093817, -0.835727, -0.309728>
    }
    triangle {
      < 1.198561, -0.847725, -0.348754>,
      < 0.093817, -0.835727, -0.309728>,
      < 0.093825, -0.848379, -0.348754>
    }
    triangle {
      < 0.093825, -0.848379, -0.348754>,
      < 0.093817, -0.835727, -0.309728>,
      < 0.063546, -0.826753, -0.314302>
    }
    triangle {
      < 0.093825, -0.848379, -0.348754>,
      < 0.063546, -0.826753, -0.314302>,
      < 0.063553, -0.838431, -0.350326>
    }
    triangle {
      < 0.063553, -0.838431, -0.350326>,
      < 0.063546, -0.826753, -0.314302>,
      < -0.264347, -0.822451, -0.316589>
    }
    triangle {
      < 0.063553, -0.838431, -0.350326>,
      < -0.264347, -0.822451, -0.316589>,
      < -0.264340, -0.833644, -0.351113>
    }
    triangle {
      < -0.264340, -0.833644, -0.351113>,
      < -0.264347, -0.822451, -0.316589>,
      < -0.360210, -0.791034, -0.332598>
    }
    triangle {
      < -0.264340, -0.833644, -0.351113>,
      < -0.360210, -0.791034, -0.332598>,
      < -0.360206, -0.798820, -0.356616>
    }
    triangle {
      < -0.360206, -0.798820, -0.356616>,
      < -0.360210, -0.791034, -0.332598>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415413, -0.746599, -0.340677>,
      < 1.415417, -0.754012, -0.350895>
    }
    triangle {
      < 1.415417, -0.754012, -0.350895>,
      < 1.415413, -0.746599, -0.340677>,
      < 1.314524, -0.746659, -0.340677>
    }
    triangle {
      < 1.415417, -0.754012, -0.350895>,
      < 1.314524, -0.746659, -0.340677>,
      < 1.314528, -0.754072, -0.350895>
    }
    triangle {
      < 1.314528, -0.754072, -0.350895>,
      < 1.314524, -0.746659, -0.340677>,
      < 1.284274, -0.775235, -0.312163>
    }
    triangle {
      < 1.314528, -0.754072, -0.350895>,
      < 1.284274, -0.775235, -0.312163>,
      < 1.284282, -0.790059, -0.332598>
    }
    triangle {
      < 1.284282, -0.790059, -0.332598>,
      < 1.284274, -0.775235, -0.312163>,
      < 1.198539, -0.810981, -0.276519>
    }
    triangle {
      < 1.284282, -0.790059, -0.332598>,
      < 1.198539, -0.810981, -0.276519>,
      < 1.198553, -0.835072, -0.309727>
    }
    triangle {
      < 1.198553, -0.835072, -0.309727>,
      < 1.198539, -0.810981, -0.276519>,
      < 0.093803, -0.811636, -0.276520>
    }
    triangle {
      < 1.198553, -0.835072, -0.309727>,
      < 0.093803, -0.811636, -0.276520>,
      < 0.093817, -0.835727, -0.309728>
    }
    triangle {
      < 0.093817, -0.835727, -0.309728>,
      < 0.093803, -0.811636, -0.276520>,
      < 0.063533, -0.804515, -0.283647>
    }
    triangle {
      < 0.093817, -0.835727, -0.309728>,
      < 0.063533, -0.804515, -0.283647>,
      < 0.063546, -0.826753, -0.314302>
    }
    triangle {
      < 0.063546, -0.826753, -0.314302>,
      < 0.063533, -0.804515, -0.283647>,
      < -0.264359, -0.801140, -0.287212>
    }
    triangle {
      < 0.063546, -0.826753, -0.314302>,
      < -0.264359, -0.801140, -0.287212>,
      < -0.264347, -0.822451, -0.316589>
    }
    triangle {
      < -0.264347, -0.822451, -0.316589>,
      < -0.264359, -0.801140, -0.287212>,
      < -0.360219, -0.776209, -0.312163>
    }
    triangle {
      < -0.264347, -0.822451, -0.316589>,
      < -0.360219, -0.776209, -0.312163>,
      < -0.360210, -0.791034, -0.332598>
    }
    triangle {
      < -0.360210, -0.791034, -0.332598>,
      < -0.360219, -0.776209, -0.312163>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415407, -0.736392, -0.333249>,
      < 1.415413, -0.746599, -0.340677>
    }
    triangle {
      < 1.415413, -0.746599, -0.340677>,
      < 1.415407, -0.736392, -0.333249>,
      < 1.314518, -0.736452, -0.333249>
    }
    triangle {
      < 1.415413, -0.746599, -0.340677>,
      < 1.314518, -0.736452, -0.333249>,
      < 1.314524, -0.746659, -0.340677>
    }
    triangle {
      < 1.314524, -0.746659, -0.340677>,
      < 1.314518, -0.736452, -0.333249>,
      < 1.284262, -0.754820, -0.297307>
    }
    triangle {
      < 1.314524, -0.746659, -0.340677>,
      < 1.284262, -0.754820, -0.297307>,
      < 1.284274, -0.775235, -0.312163>
    }
    triangle {
      < 1.284274, -0.775235, -0.312163>,
      < 1.284262, -0.754820, -0.297307>,
      < 1.198519, -0.777808, -0.252378>
    }
    triangle {
      < 1.284274, -0.775235, -0.312163>,
      < 1.198519, -0.777808, -0.252378>,
      < 1.198539, -0.810981, -0.276519>
    }
    triangle {
      < 1.198539, -0.810981, -0.276519>,
      < 1.198519, -0.777808, -0.252378>,
      < 0.093783, -0.778463, -0.252379>
    }
    triangle {
      < 1.198539, -0.810981, -0.276519>,
      < 0.093783, -0.778463, -0.252379>,
      < 0.093803, -0.811636, -0.276520>
    }
    triangle {
      < 0.093803, -0.811636, -0.276520>,
      < 0.093783, -0.778463, -0.252379>,
      < 0.063515, -0.773893, -0.261364>
    }
    triangle {
      < 0.093803, -0.811636, -0.276520>,
      < 0.063515, -0.773893, -0.261364>,
      < 0.063533, -0.804515, -0.283647>
    }
    triangle {
      < 0.063533, -0.804515, -0.283647>,
      < 0.063515, -0.773893, -0.261364>,
      < -0.264377, -0.771794, -0.265857>
    }
    triangle {
      < 0.063533, -0.804515, -0.283647>,
      < -0.264377, -0.771794, -0.265857>,
      < -0.264359, -0.801140, -0.287212>
    }
    triangle {
      < -0.264359, -0.801140, -0.287212>,
      < -0.264377, -0.771794, -0.265857>,
      < -0.360231, -0.755795, -0.297307>
    }
    triangle {
      < -0.264359, -0.801140, -0.287212>,
      < -0.360231, -0.755795, -0.297307>,
      < -0.360219, -0.776209, -0.312163>
    }
    triangle {
      < -0.360219, -0.776209, -0.312163>,
      < -0.360231, -0.755795, -0.297307>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415400, -0.724389, -0.329338>,
      < 1.415407, -0.736392, -0.333249>
    }
    triangle {
      < 1.415407, -0.736392, -0.333249>,
      < 1.415400, -0.724389, -0.329338>,
      < 1.314511, -0.724449, -0.329338>
    }
    triangle {
      < 1.415407, -0.736392, -0.333249>,
      < 1.314511, -0.724449, -0.329338>,
      < 1.314518, -0.736452, -0.333249>
    }
    triangle {
      < 1.314518, -0.736452, -0.333249>,
      < 1.314511, -0.724449, -0.329338>,
      < 1.284247, -0.730814, -0.289485>
    }
    triangle {
      < 1.314518, -0.736452, -0.333249>,
      < 1.284247, -0.730814, -0.289485>,
      < 1.284262, -0.754820, -0.297307>
    }
    triangle {
      < 1.284262, -0.754820, -0.297307>,
      < 1.284247, -0.730814, -0.289485>,
      < 1.198496, -0.738800, -0.239668>
    }
    triangle {
      < 1.284262, -0.754820, -0.297307>,
      < 1.198496, -0.738800, -0.239668>,
      < 1.198519, -0.777808, -0.252378>
    }
    triangle {
      < 1.198519, -0.777808, -0.252378>,
      < 1.198496, -0.738800, -0.239668>,
      < 0.093760, -0.739455, -0.239668>
    }
    triangle {
      < 1.198519, -0.777808, -0.252378>,
      < 0.093760, -0.739455, -0.239668>,
      < 0.093783, -0.778463, -0.252379>
    }
    triangle {
      < 0.093783, -0.778463, -0.252379>,
      < 0.093760, -0.739455, -0.239668>,
      < 0.063493, -0.737886, -0.249632>
    }
    triangle {
      < 0.093783, -0.778463, -0.252379>,
      < 0.063493, -0.737886, -0.249632>,
      < 0.063515, -0.773893, -0.261364>
    }
    triangle {
      < 0.063515, -0.773893, -0.261364>,
      < 0.063493, -0.737886, -0.249632>,
      < -0.264397, -0.737287, -0.254613>
    }
    triangle {
      < 0.063515, -0.773893, -0.261364>,
      < -0.264397, -0.737287, -0.254613>,
      < -0.264377, -0.771794, -0.265857>
    }
    triangle {
      < -0.264377, -0.771794, -0.265857>,
      < -0.264397, -0.737287, -0.254613>,
      < -0.360245, -0.731789, -0.289485>
    }
    triangle {
      < -0.264377, -0.771794, -0.265857>,
      < -0.360245, -0.731789, -0.289485>,
      < -0.360231, -0.755795, -0.297307>
    }
    triangle {
      < -0.360231, -0.755795, -0.297307>,
      < -0.360245, -0.731789, -0.289485>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415392, -0.711766, -0.329327>,
      < 1.415400, -0.724389, -0.329338>
    }
    triangle {
      < 1.415400, -0.724389, -0.329338>,
      < 1.415392, -0.711766, -0.329327>,
      < 1.314503, -0.711826, -0.329327>
    }
    triangle {
      < 1.415400, -0.724389, -0.329338>,
      < 1.314503, -0.711826, -0.329327>,
      < 1.314511, -0.724449, -0.329338>
    }
    triangle {
      < 1.314511, -0.724449, -0.329338>,
      < 1.314503, -0.711826, -0.329327>,
      < 1.284232, -0.705567, -0.289462>
    }
    triangle {
      < 1.314511, -0.724449, -0.329338>,
      < 1.284232, -0.705567, -0.289462>,
      < 1.284247, -0.730814, -0.289485>
    }
    triangle {
      < 1.284247, -0.730814, -0.289485>,
      < 1.284232, -0.705567, -0.289462>,
      < 1.198472, -0.697773, -0.239632>
    }
    triangle {
      < 1.284247, -0.730814, -0.289485>,
      < 1.198472, -0.697773, -0.239632>,
      < 1.198496, -0.738800, -0.239668>
    }
    triangle {
      < 1.198496, -0.738800, -0.239668>,
      < 1.198472, -0.697773, -0.239632>,
      < 0.093736, -0.698428, -0.239632>
    }
    triangle {
      < 1.198496, -0.738800, -0.239668>,
      < 0.093736, -0.698428, -0.239632>,
      < 0.093760, -0.739455, -0.239668>
    }
    triangle {
      < 0.093760, -0.739455, -0.239668>,
      < 0.093736, -0.698428, -0.239632>,
      < 0.063471, -0.700015, -0.249597>
    }
    triangle {
      < 0.093760, -0.739455, -0.239668>,
      < 0.063471, -0.700015, -0.249597>,
      < 0.063493, -0.737886, -0.249632>
    }
    triangle {
      < 0.063493, -0.737886, -0.249632>,
      < 0.063471, -0.700015, -0.249597>,
      < -0.264419, -0.700994, -0.254581>
    }
    triangle {
      < 0.063493, -0.737886, -0.249632>,
      < -0.264419, -0.700994, -0.254581>,
      < -0.264397, -0.737287, -0.254613>
    }
    triangle {
      < -0.264397, -0.737287, -0.254613>,
      < -0.264419, -0.700994, -0.254581>,
      < -0.360260, -0.706542, -0.289462>
    }
    triangle {
      < -0.264397, -0.737287, -0.254613>,
      < -0.360260, -0.706542, -0.289462>,
      < -0.360245, -0.731789, -0.289485>
    }
    triangle {
      < -0.360245, -0.731789, -0.289485>,
      < -0.360260, -0.706542, -0.289462>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415385, -0.699756, -0.333216>,
      < 1.415392, -0.711766, -0.329327>
    }
    triangle {
      < 1.415392, -0.711766, -0.329327>,
      < 1.415385, -0.699756, -0.333216>,
      < 1.314496, -0.699816, -0.333216>
    }
    triangle {
      < 1.415392, -0.711766, -0.329327>,
      < 1.314496, -0.699816, -0.333216>,
      < 1.314503, -0.711826, -0.329327>
    }
    triangle {
      < 1.314503, -0.711826, -0.329327>,
      < 1.314496, -0.699816, -0.333216>,
      < 1.284218, -0.681548, -0.297241>
    }
    triangle {
      < 1.314503, -0.711826, -0.329327>,
      < 1.284218, -0.681548, -0.297241>,
      < 1.284232, -0.705567, -0.289462>
    }
    triangle {
      < 1.284232, -0.705567, -0.289462>,
      < 1.284218, -0.681548, -0.297241>,
      < 1.198449, -0.658742, -0.252273>
    }
    triangle {
      < 1.284232, -0.705567, -0.289462>,
      < 1.198449, -0.658742, -0.252273>,
      < 1.198472, -0.697773, -0.239632>
    }
    triangle {
      < 1.198472, -0.697773, -0.239632>,
      < 1.198449, -0.658742, -0.252273>,
      < 0.093713, -0.659397, -0.252273>
    }
    triangle {
      < 1.198472, -0.697773, -0.239632>,
      < 0.093713, -0.659397, -0.252273>,
      < 0.093736, -0.698428, -0.239632>
    }
    triangle {
      < 0.093736, -0.698428, -0.239632>,
      < 0.093713, -0.659397, -0.252273>,
      < 0.063450, -0.663987, -0.261267>
    }
    triangle {
      < 0.093736, -0.698428, -0.239632>,
      < 0.063450, -0.663987, -0.261267>,
      < 0.063471, -0.700015, -0.249597>
    }
    triangle {
      < 0.063471, -0.700015, -0.249597>,
      < 0.063450, -0.663987, -0.261267>,
      < -0.264439, -0.666466, -0.265763>
    }
    triangle {
      < 0.063471, -0.700015, -0.249597>,
      < -0.264439, -0.666466, -0.265763>,
      < -0.264419, -0.700994, -0.254581>
    }
    triangle {
      < -0.264419, -0.700994, -0.254581>,
      < -0.264439, -0.666466, -0.265763>,
      < -0.360275, -0.682523, -0.297241>
    }
    triangle {
      < -0.264419, -0.700994, -0.254581>,
      < -0.360275, -0.682523, -0.297241>,
      < -0.360260, -0.706542, -0.289462>
    }
    triangle {
      < -0.360260, -0.706542, -0.289462>,
      < -0.360275, -0.682523, -0.297241>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415379, -0.689536, -0.340626>,
      < 1.415385, -0.699756, -0.333216>
    }
    triangle {
      < 1.415385, -0.699756, -0.333216>,
      < 1.415379, -0.689536, -0.340626>,
      < 1.314490, -0.689596, -0.340626>
    }
    triangle {
      < 1.415385, -0.699756, -0.333216>,
      < 1.314490, -0.689596, -0.340626>,
      < 1.314496, -0.699816, -0.333216>
    }
    triangle {
      < 1.314496, -0.699816, -0.333216>,
      < 1.314490, -0.689596, -0.340626>,
      < 1.284206, -0.661108, -0.312061>
    }
    triangle {
      < 1.314496, -0.699816, -0.333216>,
      < 1.284206, -0.661108, -0.312061>,
      < 1.284218, -0.681548, -0.297241>
    }
    triangle {
      < 1.284218, -0.681548, -0.297241>,
      < 1.284206, -0.661108, -0.312061>,
      < 1.198429, -0.625526, -0.276354>
    }
    triangle {
      < 1.284218, -0.681548, -0.297241>,
      < 1.198429, -0.625526, -0.276354>,
      < 1.198449, -0.658742, -0.252273>
    }
    triangle {
      < 1.198449, -0.658742, -0.252273>,
      < 1.198429, -0.625526, -0.276354>,
      < 0.093693, -0.626181, -0.276355>
    }
    triangle {
      < 1.198449, -0.658742, -0.252273>,
      < 0.093693, -0.626181, -0.276355>,
      < 0.093713, -0.659397, -0.252273>
    }
    triangle {
      < 0.093713, -0.659397, -0.252273>,
      < 0.093693, -0.626181, -0.276355>,
      < 0.063431, -0.633326, -0.283496>
    }
    triangle {
      < 0.093713, -0.659397, -0.252273>,
      < 0.063431, -0.633326, -0.283496>,
      < 0.063450, -0.663987, -0.261267>
    }
    triangle {
      < 0.063450, -0.663987, -0.261267>,
      < 0.063431, -0.633326, -0.283496>,
      < -0.264456, -0.637083, -0.287067>
    }
    triangle {
      < 0.063450, -0.663987, -0.261267>,
      < -0.264456, -0.637083, -0.287067>,
      < -0.264439, -0.666466, -0.265763>
    }
    triangle {
      < -0.264439, -0.666466, -0.265763>,
      < -0.264456, -0.637083, -0.287067>,
      < -0.360287, -0.662083, -0.312061>
    }
    triangle {
      < -0.264439, -0.666466, -0.265763>,
      < -0.360287, -0.662083, -0.312061>,
      < -0.360275, -0.682523, -0.297241>
    }
    triangle {
      < -0.360275, -0.682523, -0.297241>,
      < -0.360287, -0.662083, -0.312061>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415375, -0.682105, -0.350830>,
      < 1.415379, -0.689536, -0.340626>
    }
    triangle {
      < 1.415379, -0.689536, -0.340626>,
      < 1.415375, -0.682105, -0.350830>,
      < 1.314486, -0.682165, -0.350830>
    }
    triangle {
      < 1.415379, -0.689536, -0.340626>,
      < 1.314486, -0.682165, -0.350830>,
      < 1.314490, -0.689596, -0.340626>
    }
    triangle {
      < 1.314490, -0.689596, -0.340626>,
      < 1.314486, -0.682165, -0.350830>,
      < 1.284197, -0.646246, -0.332470>
    }
    triangle {
      < 1.314490, -0.689596, -0.340626>,
      < 1.284197, -0.646246, -0.332470>,
      < 1.284206, -0.661108, -0.312061>
    }
    triangle {
      < 1.284206, -0.661108, -0.312061>,
      < 1.284197, -0.646246, -0.332470>,
      < 1.198415, -0.601375, -0.309520>
    }
    triangle {
      < 1.284206, -0.661108, -0.312061>,
      < 1.198415, -0.601375, -0.309520>,
      < 1.198429, -0.625526, -0.276354>
    }
    triangle {
      < 1.198429, -0.625526, -0.276354>,
      < 1.198415, -0.601375, -0.309520>,
      < 0.093679, -0.602030, -0.309520>
    }
    triangle {
      < 1.198429, -0.625526, -0.276354>,
      < 0.093679, -0.602030, -0.309520>,
      < 0.093693, -0.626181, -0.276355>
    }
    triangle {
      < 0.093693, -0.626181, -0.276355>,
      < 0.093679, -0.602030, -0.309520>,
      < 0.063418, -0.611033, -0.314110>
    }
    triangle {
      < 0.093693, -0.626181, -0.276355>,
      < 0.063418, -0.611033, -0.314110>,
      < 0.063431, -0.633326, -0.283496>
    }
    triangle {
      < 0.063431, -0.633326, -0.283496>,
      < 0.063418, -0.611033, -0.314110>,
      < -0.264469, -0.615719, -0.316405>
    }
    triangle {
      < 0.063431, -0.633326, -0.283496>,
      < -0.264469, -0.615719, -0.316405>,
      < -0.264456, -0.637083, -0.287067>
    }
    triangle {
      < -0.264456, -0.637083, -0.287067>,
      < -0.264469, -0.615719, -0.316405>,
      < -0.360295, -0.647221, -0.332471>
    }
    triangle {
      < -0.264456, -0.637083, -0.287067>,
      < -0.360295, -0.647221, -0.332471>,
      < -0.360287, -0.662083, -0.312061>
    }
    triangle {
      < -0.360287, -0.662083, -0.312061>,
      < -0.360295, -0.647221, -0.332471>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415372, -0.678190, -0.362832>,
      < 1.415375, -0.682105, -0.350830>
    }
    triangle {
      < 1.415375, -0.682105, -0.350830>,
      < 1.415372, -0.678190, -0.362832>,
      < 1.314483, -0.678250, -0.362832>
    }
    triangle {
      < 1.415375, -0.682105, -0.350830>,
      < 1.314483, -0.678250, -0.362832>,
      < 1.314486, -0.682165, -0.350830>
    }
    triangle {
      < 1.314486, -0.682165, -0.350830>,
      < 1.314483, -0.678250, -0.362832>,
      < 1.284193, -0.638417, -0.356473>
    }
    triangle {
      < 1.314486, -0.682165, -0.350830>,
      < 1.284193, -0.638417, -0.356473>,
      < 1.284197, -0.646246, -0.332470>
    }
    triangle {
      < 1.284197, -0.646246, -0.332470>,
      < 1.284193, -0.638417, -0.356473>,
      < 1.198407, -0.588654, -0.348524>
    }
    triangle {
      < 1.284197, -0.646246, -0.332470>,
      < 1.198407, -0.588654, -0.348524>,
      < 1.198415, -0.601375, -0.309520>
    }
    triangle {
      < 1.198415, -0.601375, -0.309520>,
      < 1.198407, -0.588654, -0.348524>,
      < 0.093671, -0.589309, -0.348525>
    }
    triangle {
      < 1.198415, -0.601375, -0.309520>,
      < 0.093671, -0.589309, -0.348525>,
      < 0.093679, -0.602030, -0.309520>
    }
    triangle {
      < 0.093679, -0.602030, -0.309520>,
      < 0.093671, -0.589309, -0.348525>,
      < 0.063411, -0.599289, -0.350115>
    }
    triangle {
      < 0.093679, -0.602030, -0.309520>,
      < 0.063411, -0.599289, -0.350115>,
      < 0.063418, -0.611033, -0.314110>
    }
    triangle {
      < 0.063418, -0.611033, -0.314110>,
      < 0.063411, -0.599289, -0.350115>,
      < -0.264476, -0.604465, -0.350909>
    }
    triangle {
      < 0.063418, -0.611033, -0.314110>,
      < -0.264476, -0.604465, -0.350909>,
      < -0.264469, -0.615719, -0.316405>
    }
    triangle {
      < -0.264469, -0.615719, -0.316405>,
      < -0.264476, -0.604465, -0.350909>,
      < -0.360300, -0.639392, -0.356473>
    }
    triangle {
      < -0.264469, -0.615719, -0.316405>,
      < -0.360300, -0.639392, -0.356473>,
      < -0.360295, -0.647221, -0.332471>
    }
    triangle {
      < -0.360295, -0.647221, -0.332471>,
      < -0.360300, -0.639392, -0.356473>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415372, -0.678176, -0.375456>,
      < 1.415372, -0.678190, -0.362832>
    }
    triangle {
      < 1.415372, -0.678190, -0.362832>,
      < 1.415372, -0.678176, -0.375456>,
      < 1.314483, -0.678236, -0.375456>
    }
    triangle {
      < 1.415372, -0.678190, -0.362832>,
      < 1.314483, -0.678236, -0.375456>,
      < 1.314483, -0.678250, -0.362832>
    }
    triangle {
      < 1.314483, -0.678250, -0.362832>,
      < 1.314483, -0.678236, -0.375456>,
      < 1.284193, -0.638388, -0.381720>
    }
    triangle {
      < 1.314483, -0.678250, -0.362832>,
      < 1.284193, -0.638388, -0.381720>,
      < 1.284193, -0.638417, -0.356473>
    }
    triangle {
      < 1.284193, -0.638417, -0.356473>,
      < 1.284193, -0.638388, -0.381720>,
      < 1.198407, -0.588606, -0.389551>
    }
    triangle {
      < 1.284193, -0.638417, -0.356473>,
      < 1.198407, -0.588606, -0.389551>,
      < 1.198407, -0.588654, -0.348524>
    }
    triangle {
      < 1.198407, -0.588654, -0.348524>,
      < 1.198407, -0.588606, -0.389551>,
      < 0.093671, -0.589261, -0.389552>
    }
    triangle {
      < 1.198407, -0.588654, -0.348524>,
      < 0.093671, -0.589261, -0.389552>,
      < 0.093671, -0.589309, -0.348525>
    }
    triangle {
      < 0.093671, -0.589309, -0.348525>,
      < 0.093671, -0.589261, -0.389552>,
      < 0.063411, -0.599245, -0.387986>
    }
    triangle {
      < 0.093671, -0.589309, -0.348525>,
      < 0.063411, -0.599245, -0.387986>,
      < 0.063411, -0.599289, -0.350115>
    }
    triangle {
      < 0.063411, -0.599289, -0.350115>,
      < 0.063411, -0.599245, -0.387986>,
      < -0.264476, -0.604422, -0.387202>
    }
    triangle {
      < 0.063411, -0.599289, -0.350115>,
      < -0.264476, -0.604422, -0.387202>,
      < -0.264476, -0.604465, -0.350909>
    }
    triangle {
      < -0.264476, -0.604465, -0.350909>,
      < -0.264476, -0.604422, -0.387202>,
      < -0.360300, -0.639363, -0.381720>
    }
    triangle {
      < -0.264476, -0.604465, -0.350909>,
      < -0.360300, -0.639363, -0.381720>,
      < -0.360300, -0.639392, -0.356473>
    }
    triangle {
      < -0.360300, -0.639392, -0.356473>,
      < -0.360300, -0.639363, -0.381720>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415375, -0.682061, -0.387466>,
      < 1.415372, -0.678176, -0.375456>
    }
    triangle {
      < 1.415372, -0.678176, -0.375456>,
      < 1.415375, -0.682061, -0.387466>,
      < 1.314485, -0.682121, -0.387466>
    }
    triangle {
      < 1.415372, -0.678176, -0.375456>,
      < 1.314485, -0.682121, -0.387466>,
      < 1.314483, -0.678236, -0.375456>
    }
    triangle {
      < 1.314483, -0.678236, -0.375456>,
      < 1.314485, -0.682121, -0.387466>,
      < 1.284197, -0.646160, -0.405741>
    }
    triangle {
      < 1.314483, -0.678236, -0.375456>,
      < 1.284197, -0.646160, -0.405741>,
      < 1.284193, -0.638388, -0.381720>
    }
    triangle {
      < 1.284193, -0.638388, -0.381720>,
      < 1.284197, -0.646160, -0.405741>,
      < 1.198415, -0.601235, -0.428586>
    }
    triangle {
      < 1.284193, -0.638388, -0.381720>,
      < 1.198415, -0.601235, -0.428586>,
      < 1.198407, -0.588606, -0.389551>
    }
    triangle {
      < 1.198407, -0.588606, -0.389551>,
      < 1.198415, -0.601235, -0.428586>,
      < 0.093679, -0.601890, -0.428586>
    }
    triangle {
      < 1.198407, -0.588606, -0.389551>,
      < 0.093679, -0.601890, -0.428586>,
      < 0.093671, -0.589261, -0.389552>
    }
    triangle {
      < 0.093671, -0.589261, -0.389552>,
      < 0.093679, -0.601890, -0.428586>,
      < 0.063418, -0.610901, -0.424017>
    }
    triangle {
      < 0.093671, -0.589261, -0.389552>,
      < 0.063418, -0.610901, -0.424017>,
      < 0.063411, -0.599245, -0.387986>
    }
    triangle {
      < 0.063411, -0.599245, -0.387986>,
      < 0.063418, -0.610901, -0.424017>,
      < -0.264469, -0.615595, -0.421733>
    }
    triangle {
      < 0.063411, -0.599245, -0.387986>,
      < -0.264469, -0.615595, -0.421733>,
      < -0.264476, -0.604422, -0.387202>
    }
    triangle {
      < -0.264476, -0.604422, -0.387202>,
      < -0.264469, -0.615595, -0.421733>,
      < -0.360296, -0.647135, -0.405742>
    }
    triangle {
      < -0.264476, -0.604422, -0.387202>,
      < -0.360296, -0.647135, -0.405742>,
      < -0.360300, -0.639363, -0.381720>
    }
    triangle {
      < -0.360300, -0.639363, -0.381720>,
      < -0.360296, -0.647135, -0.405742>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415379, -0.689468, -0.397689>,
      < 1.415375, -0.682061, -0.387466>
    }
    triangle {
      < 1.415375, -0.682061, -0.387466>,
      < 1.415379, -0.689468, -0.397689>,
      < 1.314490, -0.689528, -0.397689>
    }
    triangle {
      < 1.415375, -0.682061, -0.387466>,
      < 1.314490, -0.689528, -0.397689>,
      < 1.314485, -0.682121, -0.387466>
    }
    triangle {
      < 1.314485, -0.682121, -0.387466>,
      < 1.314490, -0.689528, -0.397689>,
      < 1.284206, -0.660973, -0.426187>
    }
    triangle {
      < 1.314485, -0.682121, -0.387466>,
      < 1.284206, -0.660973, -0.426187>,
      < 1.284197, -0.646160, -0.405741>
    }
    triangle {
      < 1.284197, -0.646160, -0.405741>,
      < 1.284206, -0.660973, -0.426187>,
      < 1.198429, -0.625306, -0.461809>
    }
    triangle {
      < 1.284197, -0.646160, -0.405741>,
      < 1.198429, -0.625306, -0.461809>,
      < 1.198415, -0.601235, -0.428586>
    }
    triangle {
      < 1.198415, -0.601235, -0.428586>,
      < 1.198429, -0.625306, -0.461809>,
      < 0.093693, -0.625961, -0.461809>
    }
    triangle {
      < 1.198415, -0.601235, -0.428586>,
      < 0.093693, -0.625961, -0.461809>,
      < 0.093679, -0.601890, -0.428586>
    }
    triangle {
      < 0.093679, -0.601890, -0.428586>,
      < 0.093693, -0.625961, -0.461809>,
      < 0.063431, -0.633121, -0.454685>
    }
    triangle {
      < 0.093679, -0.601890, -0.428586>,
      < 0.063431, -0.633121, -0.454685>,
      < 0.063418, -0.610901, -0.424017>
    }
    triangle {
      < 0.063418, -0.610901, -0.424017>,
      < 0.063431, -0.633121, -0.454685>,
      < -0.264457, -0.636888, -0.451123>
    }
    triangle {
      < 0.063418, -0.610901, -0.424017>,
      < -0.264457, -0.636888, -0.451123>,
      < -0.264469, -0.615595, -0.421733>
    }
    triangle {
      < -0.264469, -0.615595, -0.421733>,
      < -0.264457, -0.636888, -0.451123>,
      < -0.360287, -0.661948, -0.426187>
    }
    triangle {
      < -0.264469, -0.615595, -0.421733>,
      < -0.360287, -0.661948, -0.426187>,
      < -0.360296, -0.647135, -0.405742>
    }
    triangle {
      < -0.360296, -0.647135, -0.405742>,
      < -0.360287, -0.661948, -0.426187>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415385, -0.699671, -0.405122>,
      < 1.415379, -0.689468, -0.397689>
    }
    triangle {
      < 1.415379, -0.689468, -0.397689>,
      < 1.415385, -0.699671, -0.405122>,
      < 1.314496, -0.699731, -0.405122>
    }
    triangle {
      < 1.415379, -0.689468, -0.397689>,
      < 1.314496, -0.699731, -0.405122>,
      < 1.314490, -0.689528, -0.397689>
    }
    triangle {
      < 1.314490, -0.689528, -0.397689>,
      < 1.314496, -0.699731, -0.405122>,
      < 1.284218, -0.681378, -0.441055>
    }
    triangle {
      < 1.314490, -0.689528, -0.397689>,
      < 1.284218, -0.681378, -0.441055>,
      < 1.284206, -0.660973, -0.426187>
    }
    triangle {
      < 1.284206, -0.660973, -0.426187>,
      < 1.284218, -0.681378, -0.441055>,
      < 1.198449, -0.658465, -0.485969>
    }
    triangle {
      < 1.284206, -0.660973, -0.426187>,
      < 1.198449, -0.658465, -0.485969>,
      < 1.198429, -0.625306, -0.461809>
    }
    triangle {
      < 1.198429, -0.625306, -0.461809>,
      < 1.198449, -0.658465, -0.485969>,
      < 0.093713, -0.659120, -0.485969>
    }
    triangle {
      < 1.198429, -0.625306, -0.461809>,
      < 0.093713, -0.659120, -0.485969>,
      < 0.093693, -0.625961, -0.461809>
    }
    triangle {
      < 0.093693, -0.625961, -0.461809>,
      < 0.093713, -0.659120, -0.485969>,
      < 0.063449, -0.663731, -0.476987>
    }
    triangle {
      < 0.093693, -0.625961, -0.461809>,
      < 0.063449, -0.663731, -0.476987>,
      < 0.063431, -0.633121, -0.454685>
    }
    triangle {
      < 0.063431, -0.633121, -0.454685>,
      < 0.063449, -0.663731, -0.476987>,
      < -0.264439, -0.666221, -0.472494>
    }
    triangle {
      < 0.063431, -0.633121, -0.454685>,
      < -0.264439, -0.666221, -0.472494>,
      < -0.264457, -0.636888, -0.451123>
    }
    triangle {
      < -0.264457, -0.636888, -0.451123>,
      < -0.264439, -0.666221, -0.472494>,
      < -0.360275, -0.682353, -0.441055>
    }
    triangle {
      < -0.264457, -0.636888, -0.451123>,
      < -0.360275, -0.682353, -0.441055>,
      < -0.360287, -0.661948, -0.426187>
    }
    triangle {
      < -0.360287, -0.661948, -0.426187>,
      < -0.360275, -0.682353, -0.441055>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415392, -0.711672, -0.409041>,
      < 1.415385, -0.699671, -0.405122>
    }
    triangle {
      < 1.415385, -0.699671, -0.405122>,
      < 1.415392, -0.711672, -0.409041>,
      < 1.314503, -0.711732, -0.409041>
    }
    triangle {
      < 1.415385, -0.699671, -0.405122>,
      < 1.314503, -0.711732, -0.409041>,
      < 1.314496, -0.699731, -0.405122>
    }
    triangle {
      < 1.314496, -0.699731, -0.405122>,
      < 1.314503, -0.711732, -0.409041>,
      < 1.284232, -0.705378, -0.448891>
    }
    triangle {
      < 1.314496, -0.699731, -0.405122>,
      < 1.284232, -0.705378, -0.448891>,
      < 1.284218, -0.681378, -0.441055>
    }
    triangle {
      < 1.284218, -0.681378, -0.441055>,
      < 1.284232, -0.705378, -0.448891>,
      < 1.198472, -0.697466, -0.498703>
    }
    triangle {
      < 1.284218, -0.681378, -0.441055>,
      < 1.198472, -0.697466, -0.498703>,
      < 1.198449, -0.658465, -0.485969>
    }
    triangle {
      < 1.198449, -0.658465, -0.485969>,
      < 1.198472, -0.697466, -0.498703>,
      < 0.093736, -0.698121, -0.498703>
    }
    triangle {
      < 1.198449, -0.658465, -0.485969>,
      < 0.093736, -0.698121, -0.498703>,
      < 0.093713, -0.659120, -0.485969>
    }
    triangle {
      < 0.093713, -0.659120, -0.485969>,
      < 0.093736, -0.698121, -0.498703>,
      < 0.063471, -0.699731, -0.488740>
    }
    triangle {
      < 0.093713, -0.659120, -0.485969>,
      < 0.063471, -0.699731, -0.488740>,
      < 0.063449, -0.663731, -0.476987>
    }
    triangle {
      < 0.063449, -0.663731, -0.476987>,
      < 0.063471, -0.699731, -0.488740>,
      < -0.264419, -0.700722, -0.483759>
    }
    triangle {
      < 0.063449, -0.663731, -0.476987>,
      < -0.264419, -0.700722, -0.483759>,
      < -0.264439, -0.666221, -0.472494>
    }
    triangle {
      < -0.264439, -0.666221, -0.472494>,
      < -0.264419, -0.700722, -0.483759>,
      < -0.360260, -0.706353, -0.448891>
    }
    triangle {
      < -0.264439, -0.666221, -0.472494>,
      < -0.360260, -0.706353, -0.448891>,
      < -0.360275, -0.682353, -0.441055>
    }
    triangle {
      < -0.360275, -0.682353, -0.441055>,
      < -0.360260, -0.706353, -0.448891>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415400, -0.724295, -0.409060>,
      < 1.415392, -0.711672, -0.409041>
    }
    triangle {
      < 1.415392, -0.711672, -0.409041>,
      < 1.415400, -0.724295, -0.409060>,
      < 1.314510, -0.724355, -0.409060>
    }
    triangle {
      < 1.415392, -0.711672, -0.409041>,
      < 1.314510, -0.724355, -0.409060>,
      < 1.314503, -0.711732, -0.409041>
    }
    triangle {
      < 1.314503, -0.711732, -0.409041>,
      < 1.314510, -0.724355, -0.409060>,
      < 1.284247, -0.730626, -0.448929>
    }
    triangle {
      < 1.314503, -0.711732, -0.409041>,
      < 1.284247, -0.730626, -0.448929>,
      < 1.284232, -0.705378, -0.448891>
    }
    triangle {
      < 1.284232, -0.705378, -0.448891>,
      < 1.284247, -0.730626, -0.448929>,
      < 1.198496, -0.738492, -0.498764>
    }
    triangle {
      < 1.284232, -0.705378, -0.448891>,
      < 1.198496, -0.738492, -0.498764>,
      < 1.198472, -0.697466, -0.498703>
    }
    triangle {
      < 1.198472, -0.697466, -0.498703>,
      < 1.198496, -0.738492, -0.498764>,
      < 0.093760, -0.739147, -0.498764>
    }
    triangle {
      < 1.198472, -0.697466, -0.498703>,
      < 0.093760, -0.739147, -0.498764>,
      < 0.093736, -0.698121, -0.498703>
    }
    triangle {
      < 0.093736, -0.698121, -0.498703>,
      < 0.093760, -0.739147, -0.498764>,
      < 0.063493, -0.737602, -0.488797>
    }
    triangle {
      < 0.093736, -0.698121, -0.498703>,
      < 0.063493, -0.737602, -0.488797>,
      < 0.063471, -0.699731, -0.488740>
    }
    triangle {
      < 0.063471, -0.699731, -0.488740>,
      < 0.063493, -0.737602, -0.488797>,
      < -0.264397, -0.737016, -0.483813>
    }
    triangle {
      < 0.063471, -0.699731, -0.488740>,
      < -0.264397, -0.737016, -0.483813>,
      < -0.264419, -0.700722, -0.483759>
    }
    triangle {
      < -0.264419, -0.700722, -0.483759>,
      < -0.264397, -0.737016, -0.483813>,
      < -0.360245, -0.731601, -0.448929>
    }
    triangle {
      < -0.264419, -0.700722, -0.483759>,
      < -0.360245, -0.731601, -0.448929>,
      < -0.360260, -0.706353, -0.448891>
    }
    triangle {
      < -0.360260, -0.706353, -0.448891>,
      < -0.360245, -0.731601, -0.448929>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415407, -0.736307, -0.405177>,
      < 1.415400, -0.724295, -0.409060>
    }
    triangle {
      < 1.415400, -0.724295, -0.409060>,
      < 1.415407, -0.736307, -0.405177>,
      < 1.314518, -0.736367, -0.405177>
    }
    triangle {
      < 1.415400, -0.724295, -0.409060>,
      < 1.314518, -0.736367, -0.405177>,
      < 1.314510, -0.724355, -0.409060>
    }
    triangle {
      < 1.314510, -0.724355, -0.409060>,
      < 1.314518, -0.736367, -0.405177>,
      < 1.284261, -0.754649, -0.441164>
    }
    triangle {
      < 1.314510, -0.724355, -0.409060>,
      < 1.284261, -0.754649, -0.441164>,
      < 1.284247, -0.730626, -0.448929>
    }
    triangle {
      < 1.284247, -0.730626, -0.448929>,
      < 1.284261, -0.754649, -0.441164>,
      < 1.198519, -0.777531, -0.486145>
    }
    triangle {
      < 1.284247, -0.730626, -0.448929>,
      < 1.198519, -0.777531, -0.486145>,
      < 1.198496, -0.738492, -0.498764>
    }
    triangle {
      < 1.198496, -0.738492, -0.498764>,
      < 1.198519, -0.777531, -0.486145>,
      < 0.093783, -0.778186, -0.486146>
    }
    triangle {
      < 1.198496, -0.738492, -0.498764>,
      < 0.093783, -0.778186, -0.486146>,
      < 0.093760, -0.739147, -0.498764>
    }
    triangle {
      < 0.093760, -0.739147, -0.498764>,
      < 0.093783, -0.778186, -0.486146>,
      < 0.063515, -0.773637, -0.477149>
    }
    triangle {
      < 0.093760, -0.739147, -0.498764>,
      < 0.063515, -0.773637, -0.477149>,
      < 0.063493, -0.737602, -0.488797>
    }
    triangle {
      < 0.063493, -0.737602, -0.488797>,
      < 0.063515, -0.773637, -0.477149>,
      < -0.264377, -0.771549, -0.472651>
    }
    triangle {
      < 0.063493, -0.737602, -0.488797>,
      < -0.264377, -0.771549, -0.472651>,
      < -0.264397, -0.737016, -0.483813>
    }
    triangle {
      < -0.264397, -0.737016, -0.483813>,
      < -0.264377, -0.771549, -0.472651>,
      < -0.360231, -0.755624, -0.441164>
    }
    triangle {
      < -0.264397, -0.737016, -0.483813>,
      < -0.360231, -0.755624, -0.441164>,
      < -0.360245, -0.731601, -0.448929>
    }
    triangle {
      < -0.360245, -0.731601, -0.448929>,
      < -0.360231, -0.755624, -0.441164>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < 1.415396, -0.718043, -0.369192>,
      < 1.415413, -0.746565, -0.397740>,
      < 1.415407, -0.736307, -0.405177>
    }
    triangle {
      < 1.415407, -0.736307, -0.405177>,
      < 1.415413, -0.746565, -0.397740>,
      < 1.314524, -0.746625, -0.397740>
    }
    triangle {
      < 1.415407, -0.736307, -0.405177>,
      < 1.314524, -0.746625, -0.397740>,
      < 1.314518, -0.736367, -0.405177>
    }
    triangle {
      < 1.314518, -0.736367, -0.405177>,
      < 1.314524, -0.746625, -0.397740>,
      < 1.284274, -0.775167, -0.426289>
    }
    triangle {
      < 1.314518, -0.736367, -0.405177>,
      < 1.284274, -0.775167, -0.426289>,
      < 1.284261, -0.754649, -0.441164>
    }
    triangle {
      < 1.284261, -0.754649, -0.441164>,
      < 1.284274, -0.775167, -0.426289>,
      < 1.198539, -0.810871, -0.461974>
    }
    triangle {
      < 1.284261, -0.754649, -0.441164>,
      < 1.198539, -0.810871, -0.461974>,
      < 1.198519, -0.777531, -0.486145>
    }
    triangle {
      < 1.198519, -0.777531, -0.486145>,
      < 1.198539, -0.810871, -0.461974>,
      < 0.093803, -0.811526, -0.461974>
    }
    triangle {
      < 1.198519, -0.777531, -0.486145>,
      < 0.093803, -0.811526, -0.461974>,
      < 0.093783, -0.778186, -0.486146>
    }
    triangle {
      < 0.093783, -0.778186, -0.486146>,
      < 0.093803, -0.811526, -0.461974>,
      < 0.063533, -0.804412, -0.454837>
    }
    triangle {
      < 0.093783, -0.778186, -0.486146>,
      < 0.063533, -0.804412, -0.454837>,
      < 0.063515, -0.773637, -0.477149>
    }
    triangle {
      < 0.063515, -0.773637, -0.477149>,
      < 0.063533, -0.804412, -0.454837>,
      < -0.264359, -0.801042, -0.451268>
    }
    triangle {
      < 0.063515, -0.773637, -0.477149>,
      < -0.264359, -0.801042, -0.451268>,
      < -0.264377, -0.771549, -0.472651>
    }
    triangle {
      < -0.264377, -0.771549, -0.472651>,
      < -0.264359, -0.801042, -0.451268>,
      < -0.360219, -0.776142, -0.426289>
    }
    triangle {
      < -0.264377, -0.771549, -0.472651>,
      < -0.360219, -0.776142, -0.426289>,
      < -0.360231, -0.755624, -0.441164>
    }
    triangle {
      < -0.360231, -0.755624, -0.441164>,
      < -0.360219, -0.776142, -0.426289>,
      < -0.425831, -0.719134, -0.369192>
    }
    triangle {
      < -0.077575, -0.895725, -0.170378>,
      < -0.077679, -0.719930, -0.345912>,
      < -0.307863, -0.720068, -0.345912>
    }
    triangle {
      < -0.077575, -0.895725, -0.170378>,
      < -0.307863, -0.720068, -0.345912>,
      < -0.307759, -0.895863, -0.170378>
    }
    triangle {
      < -0.307746, -0.918139, -0.192688>,
      < -0.307850, -0.742345, -0.368223>,
      < -0.077666, -0.742208, -0.368223>
    }
    triangle {
      < -0.307746, -0.918139, -0.192688>,
      < -0.077666, -0.742208, -0.368223>,
      < -0.077562, -0.918003, -0.192688>
    }
    triangle {
      < -0.307759, -0.895863, -0.170378>,
      < -0.307863, -0.720068, -0.345912>,
      < -0.307850, -0.742345, -0.368223>
    }
    triangle {
      < -0.307759, -0.895863, -0.170378>,
      < -0.307850, -0.742345, -0.368223>,
      < -0.307746, -0.918139, -0.192688>
    }
    triangle {
      < -0.077562, -0.918003, -0.192688>,
      < -0.077575, -0.895725, -0.170378>,
      < -0.307759, -0.895863, -0.170378>
    }
    triangle {
      < -0.077562, -0.918003, -0.192688>,
      < -0.307759, -0.895863, -0.170378>,
      < -0.307746, -0.918139, -0.192688>
    }
    triangle {
      < -0.077562, -0.918003, -0.192688>,
      < -0.077666, -0.742208, -0.368223>,
      < -0.077679, -0.719930, -0.345912>
    }
    triangle {
      < -0.077562, -0.918003, -0.192688>,
      < -0.077679, -0.719930, -0.345912>,
      < -0.077575, -0.895725, -0.170378>
    }
    triangle {
      < -0.077679, -0.719930, -0.345912>,
      < -0.077666, -0.742208, -0.368223>,
      < -0.307850, -0.742345, -0.368223>
    }
    triangle {
      < -0.077679, -0.719930, -0.345912>,
      < -0.307850, -0.742345, -0.368223>,
      < -0.307863, -0.720068, -0.345912>
    }
    triangle {
      < 0.249411, -0.895532, -0.170378>,
      < 0.249307, -0.719736, -0.345912>,
      < 0.019124, -0.719873, -0.345912>
    }
    triangle {
      < 0.249411, -0.895532, -0.170378>,
      < 0.019124, -0.719873, -0.345912>,
      < 0.019228, -0.895669, -0.170378>
    }
    triangle {
      < 0.019241, -0.917946, -0.192688>,
      < 0.019137, -0.742151, -0.368223>,
      < 0.249320, -0.742014, -0.368223>
    }
    triangle {
      < 0.019241, -0.917946, -0.192688>,
      < 0.249320, -0.742014, -0.368223>,
      < 0.249424, -0.917809, -0.192688>
    }
    triangle {
      < 0.019228, -0.895669, -0.170378>,
      < 0.019124, -0.719873, -0.345912>,
      < 0.019137, -0.742151, -0.368223>
    }
    triangle {
      < 0.019228, -0.895669, -0.170378>,
      < 0.019137, -0.742151, -0.368223>,
      < 0.019241, -0.917946, -0.192688>
    }
    triangle {
      < 0.249424, -0.917809, -0.192688>,
      < 0.249411, -0.895532, -0.170378>,
      < 0.019228, -0.895669, -0.170378>
    }
    triangle {
      < 0.249424, -0.917809, -0.192688>,
      < 0.019228, -0.895669, -0.170378>,
      < 0.019241, -0.917946, -0.192688>
    }
    triangle {
      < 0.249424, -0.917809, -0.192688>,
      < 0.249320, -0.742014, -0.368223>,
      < 0.249307, -0.719736, -0.345912>
    }
    triangle {
      < 0.249424, -0.917809, -0.192688>,
      < 0.249307, -0.719736, -0.345912>,
      < 0.249411, -0.895532, -0.170378>
    }
    triangle {
      < 0.249307, -0.719736, -0.345912>,
      < 0.249320, -0.742014, -0.368223>,
      < 0.019137, -0.742151, -0.368223>
    }
    triangle {
      < 0.249307, -0.719736, -0.345912>,
      < 0.019137, -0.742151, -0.368223>,
      < 0.019124, -0.719873, -0.345912>
    }
    triangle {
      < -0.077798, -0.520166, -0.192334>,
      < -0.077694, -0.695648, -0.368181>,
      < -0.307878, -0.695785, -0.368181>
    }
    triangle {
      < -0.077798, -0.520166, -0.192334>,
      < -0.307878, -0.695785, -0.368181>,
      < -0.307982, -0.520303, -0.192334>
    }
    triangle {
      < -0.307968, -0.542620, -0.170064>,
      < -0.307864, -0.718102, -0.345911>,
      < -0.077680, -0.717965, -0.345911>
    }
    triangle {
      < -0.307968, -0.542620, -0.170064>,
      < -0.077680, -0.717965, -0.345911>,
      < -0.077784, -0.542483, -0.170064>
    }
    triangle {
      < -0.307982, -0.520303, -0.192334>,
      < -0.307878, -0.695785, -0.368181>,
      < -0.307864, -0.718102, -0.345911>
    }
    triangle {
      < -0.307982, -0.520303, -0.192334>,
      < -0.307864, -0.718102, -0.345911>,
      < -0.307968, -0.542620, -0.170064>
    }
    triangle {
      < -0.077784, -0.542483, -0.170064>,
      < -0.077798, -0.520166, -0.192334>,
      < -0.307982, -0.520303, -0.192334>
    }
    triangle {
      < -0.077784, -0.542483, -0.170064>,
      < -0.307982, -0.520303, -0.192334>,
      < -0.307968, -0.542620, -0.170064>
    }
    triangle {
      < -0.077784, -0.542483, -0.170064>,
      < -0.077680, -0.717965, -0.345911>,
      < -0.077694, -0.695648, -0.368181>
    }
    triangle {
      < -0.077784, -0.542483, -0.170064>,
      < -0.077694, -0.695648, -0.368181>,
      < -0.077798, -0.520166, -0.192334>
    }
    triangle {
      < -0.077694, -0.695648, -0.368181>,
      < -0.077680, -0.717965, -0.345911>,
      < -0.307864, -0.718102, -0.345911>
    }
    triangle {
      < -0.077694, -0.695648, -0.368181>,
      < -0.307864, -0.718102, -0.345911>,
      < -0.307878, -0.695785, -0.368181>
    }
    triangle {
      < 0.249188, -0.519972, -0.192334>,
      < 0.249292, -0.695454, -0.368181>,
      < 0.019109, -0.695591, -0.368181>
    }
    triangle {
      < 0.249188, -0.519972, -0.192334>,
      < 0.019109, -0.695591, -0.368181>,
      < 0.019005, -0.520109, -0.192334>
    }
    triangle {
      < 0.019018, -0.542426, -0.170064>,
      < 0.019123, -0.717909, -0.345911>,
      < 0.249305, -0.717771, -0.345911>
    }
    triangle {
      < 0.019018, -0.542426, -0.170064>,
      < 0.249305, -0.717771, -0.345911>,
      < 0.249201, -0.542289, -0.170064>
    }
    triangle {
      < 0.019005, -0.520109, -0.192334>,
      < 0.019109, -0.695591, -0.368181>,
      < 0.019123, -0.717909, -0.345911>
    }
    triangle {
      < 0.019005, -0.520109, -0.192334>,
      < 0.019123, -0.717909, -0.345911>,
      < 0.019018, -0.542426, -0.170064>
    }
    triangle {
      < 0.249201, -0.542289, -0.170064>,
      < 0.249188, -0.519972, -0.192334>,
      < 0.019005, -0.520109, -0.192334>
    }
    triangle {
      < 0.249201, -0.542289, -0.170064>,
      < 0.019005, -0.520109, -0.192334>,
      < 0.019018, -0.542426, -0.170064>
    }
    triangle {
      < 0.249201, -0.542289, -0.170064>,
      < 0.249305, -0.717771, -0.345911>,
      < 0.249292, -0.695454, -0.368181>
    }
    triangle {
      < 0.249201, -0.542289, -0.170064>,
      < 0.249292, -0.695454, -0.368181>,
      < 0.249188, -0.519972, -0.192334>
    }
    triangle {
      < 0.249292, -0.695454, -0.368181>,
      < 0.249305, -0.717771, -0.345911>,
      < 0.019123, -0.717909, -0.345911>
    }
    triangle {
      < 0.249292, -0.695454, -0.368181>,
      < 0.019123, -0.717909, -0.345911>,
      < 0.019109, -0.695591, -0.368181>
    }
    triangle {
      < -0.077785, -0.542012, -0.567901>,
      < -0.077680, -0.717910, -0.392470>,
      < -0.307864, -0.718047, -0.392470>
    }
    triangle {
      < -0.077785, -0.542012, -0.567901>,
      < -0.307864, -0.718047, -0.392470>,
      < -0.307969, -0.542149, -0.567901>
    }
    triangle {
      < -0.307982, -0.519884, -0.545577>,
      < -0.307878, -0.695783, -0.370147>,
      < -0.077694, -0.695646, -0.370147>
    }
    triangle {
      < -0.307982, -0.519884, -0.545577>,
      < -0.077694, -0.695646, -0.370147>,
      < -0.077798, -0.519747, -0.545577>
    }
    triangle {
      < -0.307969, -0.542149, -0.567901>,
      < -0.307864, -0.718047, -0.392470>,
      < -0.307878, -0.695783, -0.370147>
    }
    triangle {
      < -0.307969, -0.542149, -0.567901>,
      < -0.307878, -0.695783, -0.370147>,
      < -0.307982, -0.519884, -0.545577>
    }
    triangle {
      < -0.077798, -0.519747, -0.545577>,
      < -0.077785, -0.542012, -0.567901>,
      < -0.307969, -0.542149, -0.567901>
    }
    triangle {
      < -0.077798, -0.519747, -0.545577>,
      < -0.307969, -0.542149, -0.567901>,
      < -0.307982, -0.519884, -0.545577>
    }
    triangle {
      < -0.077798, -0.519747, -0.545577>,
      < -0.077694, -0.695646, -0.370147>,
      < -0.077680, -0.717910, -0.392470>
    }
    triangle {
      < -0.077798, -0.519747, -0.545577>,
      < -0.077680, -0.717910, -0.392470>,
      < -0.077785, -0.542012, -0.567901>
    }
    triangle {
      < -0.077680, -0.717910, -0.392470>,
      < -0.077694, -0.695646, -0.370147>,
      < -0.307878, -0.695783, -0.370147>
    }
    triangle {
      < -0.077680, -0.717910, -0.392470>,
      < -0.307878, -0.695783, -0.370147>,
      < -0.307864, -0.718047, -0.392470>
    }
    triangle {
      < 0.249201, -0.541818, -0.567901>,
      < 0.249305, -0.717716, -0.392470>,
      < 0.019122, -0.717853, -0.392470>
    }
    triangle {
      < 0.249201, -0.541818, -0.567901>,
      < 0.019122, -0.717853, -0.392470>,
      < 0.019018, -0.541955, -0.567901>
    }
    triangle {
      < 0.019005, -0.519690, -0.545577>,
      < 0.019109, -0.695589, -0.370147>,
      < 0.249292, -0.695452, -0.370147>
    }
    triangle {
      < 0.019005, -0.519690, -0.545577>,
      < 0.249292, -0.695452, -0.370147>,
      < 0.249188, -0.519553, -0.545577>
    }
    triangle {
      < 0.019018, -0.541955, -0.567901>,
      < 0.019122, -0.717853, -0.392470>,
      < 0.019109, -0.695589, -0.370147>
    }
    triangle {
      < 0.019018, -0.541955, -0.567901>,
      < 0.019109, -0.695589, -0.370147>,
      < 0.019005, -0.519690, -0.545577>
    }
    triangle {
      < 0.249188, -0.519553, -0.545577>,
      < 0.249201, -0.541818, -0.567901>,
      < 0.019018, -0.541955, -0.567901>
    }
    triangle {
      < 0.249188, -0.519553, -0.545577>,
      < 0.019018, -0.541955, -0.567901>,
      < 0.019005, -0.519690, -0.545577>
    }
    triangle {
      < 0.249188, -0.519553, -0.545577>,
      < 0.249292, -0.695452, -0.370147>,
      < 0.249305, -0.717716, -0.392470>
    }
    triangle {
      < 0.249188, -0.519553, -0.545577>,
      < 0.249305, -0.717716, -0.392470>,
      < 0.249201, -0.541818, -0.567901>
    }
    triangle {
      < 0.249305, -0.717716, -0.392470>,
      < 0.249292, -0.695452, -0.370147>,
      < 0.019109, -0.695589, -0.370147>
    }
    triangle {
      < 0.249305, -0.717716, -0.392470>,
      < 0.019109, -0.695589, -0.370147>,
      < 0.019122, -0.717853, -0.392470>
    }
    triangle {
      < -0.077562, -0.917583, -0.546167>,
      < -0.077666, -0.742205, -0.370216>,
      < -0.307850, -0.742342, -0.370216>
    }
    triangle {
      < -0.077562, -0.917583, -0.546167>,
      < -0.307850, -0.742342, -0.370216>,
      < -0.307746, -0.917719, -0.546167>
    }
    triangle {
      < -0.307759, -0.895391, -0.568424>,
      < -0.307863, -0.720013, -0.392472>,
      < -0.077679, -0.719876, -0.392472>
    }
    triangle {
      < -0.307759, -0.895391, -0.568424>,
      < -0.077679, -0.719876, -0.392472>,
      < -0.077575, -0.895254, -0.568424>
    }
    triangle {
      < -0.307746, -0.917719, -0.546167>,
      < -0.307850, -0.742342, -0.370216>,
      < -0.307863, -0.720013, -0.392472>
    }
    triangle {
      < -0.307746, -0.917719, -0.546167>,
      < -0.307863, -0.720013, -0.392472>,
      < -0.307759, -0.895391, -0.568424>
    }
    triangle {
      < -0.077575, -0.895254, -0.568424>,
      < -0.077562, -0.917583, -0.546167>,
      < -0.307746, -0.917719, -0.546167>
    }
    triangle {
      < -0.077575, -0.895254, -0.568424>,
      < -0.307746, -0.917719, -0.546167>,
      < -0.307759, -0.895391, -0.568424>
    }
    triangle {
      < -0.077575, -0.895254, -0.568424>,
      < -0.077679, -0.719876, -0.392472>,
      < -0.077666, -0.742205, -0.370216>
    }
    triangle {
      < -0.077575, -0.895254, -0.568424>,
      < -0.077666, -0.742205, -0.370216>,
      < -0.077562, -0.917583, -0.546167>
    }
    triangle {
      < -0.077666, -0.742205, -0.370216>,
      < -0.077679, -0.719876, -0.392472>,
      < -0.307863, -0.720013, -0.392472>
    }
    triangle {
      < -0.077666, -0.742205, -0.370216>,
      < -0.307863, -0.720013, -0.392472>,
      < -0.307850, -0.742342, -0.370216>
    }
    triangle {
      < 0.249424, -0.917389, -0.546167>,
      < 0.249320, -0.742011, -0.370216>,
      < 0.019137, -0.742148, -0.370216>
    }
    triangle {
      < 0.249424, -0.917389, -0.546167>,
      < 0.019137, -0.742148, -0.370216>,
      < 0.019241, -0.917526, -0.546167>
    }
    triangle {
      < 0.019228, -0.895197, -0.568424>,
      < 0.019124, -0.719819, -0.392472>,
      < 0.249307, -0.719682, -0.392472>
    }
    triangle {
      < 0.019228, -0.895197, -0.568424>,
      < 0.249307, -0.719682, -0.392472>,
      < 0.249411, -0.895060, -0.568424>
    }
    triangle {
      < 0.019241, -0.917526, -0.546167>,
      < 0.019137, -0.742148, -0.370216>,
      < 0.019124, -0.719819, -0.392472>
    }
    triangle {
      < 0.019241, -0.917526, -0.546167>,
      < 0.019124, -0.719819, -0.392472>,
      < 0.019228, -0.895197, -0.568424>
    }
    triangle {
      < 0.249411, -0.895060, -0.568424>,
      < 0.249424, -0.917389, -0.546167>,
      < 0.019241, -0.917526, -0.546167>
    }
    triangle {
      < 0.249411, -0.895060, -0.568424>,
      < 0.019241, -0.917526, -0.546167>,
      < 0.019228, -0.895197, -0.568424>
    }
    triangle {
      < 0.249411, -0.895060, -0.568424>,
      < 0.249307, -0.719682, -0.392472>,
      < 0.249320, -0.742011, -0.370216>
    }
    triangle {
      < 0.249411, -0.895060, -0.568424>,
      < 0.249320, -0.742011, -0.370216>,
      < 0.249424, -0.917389, -0.546167>
    }
    triangle {
      < 0.249320, -0.742011, -0.370216>,
      < 0.249307, -0.719682, -0.392472>,
      < 0.019124, -0.719819, -0.392472>
    }
    triangle {
      < 0.249320, -0.742011, -0.370216>,
      < 0.019124, -0.719819, -0.392472>,
      < 0.019137, -0.742148, -0.370216>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415613, -1.084797, -0.221395>,
      < 1.415609, -1.077372, -0.231604>
    }
    triangle {
      < 1.415609, -1.077372, -0.231604>,
      < 1.415613, -1.084797, -0.221395>,
      < 1.314724, -1.084857, -0.221395>
    }
    triangle {
      < 1.415609, -1.077372, -0.231604>,
      < 1.314724, -1.084857, -0.221395>,
      < 1.314720, -1.077432, -0.231604>
    }
    triangle {
      < 1.314720, -1.077432, -0.231604>,
      < 1.314724, -1.084857, -0.221395>,
      < 1.284478, -1.120824, -0.239735>
    }
    triangle {
      < 1.314720, -1.077432, -0.231604>,
      < 1.284478, -1.120824, -0.239735>,
      < 1.284470, -1.105974, -0.260153>
    }
    triangle {
      < 1.284470, -1.105974, -0.260153>,
      < 1.284478, -1.120824, -0.239735>,
      < 1.198749, -1.165809, -0.262658>
    }
    triangle {
      < 1.284470, -1.105974, -0.260153>,
      < 1.198749, -1.165809, -0.262658>,
      < 1.198735, -1.141678, -0.295838>
    }
    triangle {
      < 1.198735, -1.141678, -0.295838>,
      < 1.198749, -1.165809, -0.262658>,
      < 0.094013, -1.166463, -0.262659>
    }
    triangle {
      < 1.198735, -1.141678, -0.295838>,
      < 0.094013, -1.166463, -0.262659>,
      < 0.093999, -1.142332, -0.295839>
    }
    triangle {
      < 0.093999, -1.142332, -0.295839>,
      < 0.094013, -1.166463, -0.262659>,
      < 0.063742, -1.157494, -0.258074>
    }
    triangle {
      < 0.093999, -1.142332, -0.295839>,
      < 0.063742, -1.157494, -0.258074>,
      < 0.063729, -1.135219, -0.288701>
    }
    triangle {
      < 0.063729, -1.135219, -0.288701>,
      < 0.063742, -1.157494, -0.258074>,
      < -0.264151, -1.153196, -0.255782>
    }
    triangle {
      < 0.063729, -1.135219, -0.288701>,
      < -0.264151, -1.153196, -0.255782>,
      < -0.264163, -1.131850, -0.285133>
    }
    triangle {
      < -0.264163, -1.131850, -0.285133>,
      < -0.264151, -1.153196, -0.255782>,
      < -0.360014, -1.121798, -0.239735>
    }
    triangle {
      < -0.264163, -1.131850, -0.285133>,
      < -0.360014, -1.121798, -0.239735>,
      < -0.360023, -1.106949, -0.260153>
    }
    triangle {
      < -0.360023, -1.106949, -0.260153>,
      < -0.360014, -1.121798, -0.239735>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415616, -1.088705, -0.209392>,
      < 1.415613, -1.084797, -0.221395>
    }
    triangle {
      < 1.415613, -1.084797, -0.221395>,
      < 1.415616, -1.088705, -0.209392>,
      < 1.314726, -1.088765, -0.209392>
    }
    triangle {
      < 1.415613, -1.084797, -0.221395>,
      < 1.314726, -1.088765, -0.209392>,
      < 1.314724, -1.084857, -0.221395>
    }
    triangle {
      < 1.314724, -1.084857, -0.221395>,
      < 1.314726, -1.088765, -0.209392>,
      < 1.284483, -1.128638, -0.215727>
    }
    triangle {
      < 1.314724, -1.084857, -0.221395>,
      < 1.284483, -1.128638, -0.215727>,
      < 1.284478, -1.120824, -0.239735>
    }
    triangle {
      < 1.284478, -1.120824, -0.239735>,
      < 1.284483, -1.128638, -0.215727>,
      < 1.198757, -1.178508, -0.223646>
    }
    triangle {
      < 1.284478, -1.120824, -0.239735>,
      < 1.198757, -1.178508, -0.223646>,
      < 1.198749, -1.165809, -0.262658>
    }
    triangle {
      < 1.198749, -1.165809, -0.262658>,
      < 1.198757, -1.178508, -0.223646>,
      < 0.094021, -1.179162, -0.223646>
    }
    triangle {
      < 1.198749, -1.165809, -0.262658>,
      < 0.094021, -1.179162, -0.223646>,
      < 0.094013, -1.166463, -0.262659>
    }
    triangle {
      < 0.094013, -1.166463, -0.262659>,
      < 0.094021, -1.179162, -0.223646>,
      < 0.063749, -1.169216, -0.222063>
    }
    triangle {
      < 0.094013, -1.166463, -0.262659>,
      < 0.063749, -1.169216, -0.222063>,
      < 0.063742, -1.157494, -0.258074>
    }
    triangle {
      < 0.063742, -1.157494, -0.258074>,
      < 0.063749, -1.169216, -0.222063>,
      < -0.264144, -1.164429, -0.221271>
    }
    triangle {
      < 0.063742, -1.157494, -0.258074>,
      < -0.264144, -1.164429, -0.221271>,
      < -0.264151, -1.153196, -0.255782>
    }
    triangle {
      < -0.264151, -1.153196, -0.255782>,
      < -0.264144, -1.164429, -0.221271>,
      < -0.360010, -1.129612, -0.215728>
    }
    triangle {
      < -0.264151, -1.153196, -0.255782>,
      < -0.360010, -1.129612, -0.215728>,
      < -0.360014, -1.121798, -0.239735>
    }
    triangle {
      < -0.360014, -1.121798, -0.239735>,
      < -0.360010, -1.129612, -0.215728>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415616, -1.088712, -0.196768>,
      < 1.415616, -1.088705, -0.209392>
    }
    triangle {
      < 1.415616, -1.088705, -0.209392>,
      < 1.415616, -1.088712, -0.196768>,
      < 1.314726, -1.088772, -0.196768>
    }
    triangle {
      < 1.415616, -1.088705, -0.209392>,
      < 1.314726, -1.088772, -0.196768>,
      < 1.314726, -1.088765, -0.209392>
    }
    triangle {
      < 1.314726, -1.088765, -0.209392>,
      < 1.314726, -1.088772, -0.196768>,
      < 1.284483, -1.128654, -0.190479>
    }
    triangle {
      < 1.314726, -1.088765, -0.209392>,
      < 1.284483, -1.128654, -0.190479>,
      < 1.284483, -1.128638, -0.215727>
    }
    triangle {
      < 1.284483, -1.128638, -0.215727>,
      < 1.284483, -1.128654, -0.190479>,
      < 1.198757, -1.178533, -0.182619>
    }
    triangle {
      < 1.284483, -1.128638, -0.215727>,
      < 1.198757, -1.178533, -0.182619>,
      < 1.198757, -1.178508, -0.223646>
    }
    triangle {
      < 1.198757, -1.178508, -0.223646>,
      < 1.198757, -1.178533, -0.182619>,
      < 0.094021, -1.179187, -0.182619>
    }
    triangle {
      < 1.198757, -1.178508, -0.223646>,
      < 0.094021, -1.179187, -0.182619>,
      < 0.094021, -1.179162, -0.223646>
    }
    triangle {
      < 0.094021, -1.179162, -0.223646>,
      < 0.094021, -1.179187, -0.182619>,
      < 0.063749, -1.169238, -0.184191>
    }
    triangle {
      < 0.094021, -1.179162, -0.223646>,
      < 0.063749, -1.169238, -0.184191>,
      < 0.063749, -1.169216, -0.222063>
    }
    triangle {
      < 0.063749, -1.169216, -0.222063>,
      < 0.063749, -1.169238, -0.184191>,
      < -0.264144, -1.164451, -0.184978>
    }
    triangle {
      < 0.063749, -1.169216, -0.222063>,
      < -0.264144, -1.164451, -0.184978>,
      < -0.264144, -1.164429, -0.221271>
    }
    triangle {
      < -0.264144, -1.164429, -0.221271>,
      < -0.264144, -1.164451, -0.184978>,
      < -0.360010, -1.129627, -0.190480>
    }
    triangle {
      < -0.264144, -1.164429, -0.221271>,
      < -0.360010, -1.129627, -0.190480>,
      < -0.360010, -1.129612, -0.215728>
    }
    triangle {
      < -0.360010, -1.129612, -0.215728>,
      < -0.360010, -1.129627, -0.190480>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415613, -1.084819, -0.184759>,
      < 1.415616, -1.088712, -0.196768>
    }
    triangle {
      < 1.415616, -1.088712, -0.196768>,
      < 1.415613, -1.084819, -0.184759>,
      < 1.314724, -1.084879, -0.184759>
    }
    triangle {
      < 1.415616, -1.088712, -0.196768>,
      < 1.314724, -1.084879, -0.184759>,
      < 1.314726, -1.088772, -0.196768>
    }
    triangle {
      < 1.314726, -1.088772, -0.196768>,
      < 1.314724, -1.084879, -0.184759>,
      < 1.284478, -1.120867, -0.166463>
    }
    triangle {
      < 1.314726, -1.088772, -0.196768>,
      < 1.284478, -1.120867, -0.166463>,
      < 1.284483, -1.128654, -0.190479>
    }
    triangle {
      < 1.284483, -1.128654, -0.190479>,
      < 1.284478, -1.120867, -0.166463>,
      < 1.198749, -1.165880, -0.143591>
    }
    triangle {
      < 1.284483, -1.128654, -0.190479>,
      < 1.198749, -1.165880, -0.143591>,
      < 1.198757, -1.178533, -0.182619>
    }
    triangle {
      < 1.198757, -1.178533, -0.182619>,
      < 1.198749, -1.165880, -0.143591>,
      < 0.094013, -1.166534, -0.143592>
    }
    triangle {
      < 1.198757, -1.178533, -0.182619>,
      < 0.094013, -1.166534, -0.143592>,
      < 0.094021, -1.179187, -0.182619>
    }
    triangle {
      < 0.094021, -1.179187, -0.182619>,
      < 0.094013, -1.166534, -0.143592>,
      < 0.063742, -1.157560, -0.148167>
    }
    triangle {
      < 0.094021, -1.179187, -0.182619>,
      < 0.063742, -1.157560, -0.148167>,
      < 0.063749, -1.169238, -0.184191>
    }
    triangle {
      < 0.063749, -1.169238, -0.184191>,
      < 0.063742, -1.157560, -0.148167>,
      < -0.264151, -1.153258, -0.150454>
    }
    triangle {
      < 0.063749, -1.169238, -0.184191>,
      < -0.264151, -1.153258, -0.150454>,
      < -0.264144, -1.164451, -0.184978>
    }
    triangle {
      < -0.264144, -1.164451, -0.184978>,
      < -0.264151, -1.153258, -0.150454>,
      < -0.360014, -1.121842, -0.166463>
    }
    triangle {
      < -0.264144, -1.164451, -0.184978>,
      < -0.360014, -1.121842, -0.166463>,
      < -0.360010, -1.129627, -0.190480>
    }
    triangle {
      < -0.360010, -1.129627, -0.190480>,
      < -0.360014, -1.121842, -0.166463>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415609, -1.077406, -0.174541>,
      < 1.415613, -1.084819, -0.184759>
    }
    triangle {
      < 1.415613, -1.084819, -0.184759>,
      < 1.415609, -1.077406, -0.174541>,
      < 1.314720, -1.077466, -0.174541>
    }
    triangle {
      < 1.415613, -1.084819, -0.184759>,
      < 1.314720, -1.077466, -0.174541>,
      < 1.314724, -1.084879, -0.184759>
    }
    triangle {
      < 1.314724, -1.084879, -0.184759>,
      < 1.314720, -1.077466, -0.174541>,
      < 1.284470, -1.106042, -0.146027>
    }
    triangle {
      < 1.314724, -1.084879, -0.184759>,
      < 1.284470, -1.106042, -0.146027>,
      < 1.284478, -1.120867, -0.166463>
    }
    triangle {
      < 1.284478, -1.120867, -0.166463>,
      < 1.284470, -1.106042, -0.146027>,
      < 1.198735, -1.141788, -0.110383>
    }
    triangle {
      < 1.284478, -1.120867, -0.166463>,
      < 1.198735, -1.141788, -0.110383>,
      < 1.198749, -1.165880, -0.143591>
    }
    triangle {
      < 1.198749, -1.165880, -0.143591>,
      < 1.198735, -1.141788, -0.110383>,
      < 0.093999, -1.142442, -0.110384>
    }
    triangle {
      < 1.198749, -1.165880, -0.143591>,
      < 0.093999, -1.142442, -0.110384>,
      < 0.094013, -1.166534, -0.143592>
    }
    triangle {
      < 0.094013, -1.166534, -0.143592>,
      < 0.093999, -1.142442, -0.110384>,
      < 0.063729, -1.135321, -0.117512>
    }
    triangle {
      < 0.094013, -1.166534, -0.143592>,
      < 0.063729, -1.135321, -0.117512>,
      < 0.063742, -1.157560, -0.148167>
    }
    triangle {
      < 0.063742, -1.157560, -0.148167>,
      < 0.063729, -1.135321, -0.117512>,
      < -0.264163, -1.131947, -0.121077>
    }
    triangle {
      < 0.063742, -1.157560, -0.148167>,
      < -0.264163, -1.131947, -0.121077>,
      < -0.264151, -1.153258, -0.150454>
    }
    triangle {
      < -0.264151, -1.153258, -0.150454>,
      < -0.264163, -1.131947, -0.121077>,
      < -0.360023, -1.107016, -0.146027>
    }
    triangle {
      < -0.264151, -1.153258, -0.150454>,
      < -0.360023, -1.107016, -0.146027>,
      < -0.360014, -1.121842, -0.166463>
    }
    triangle {
      < -0.360014, -1.121842, -0.166463>,
      < -0.360023, -1.107016, -0.146027>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415603, -1.067199, -0.167113>,
      < 1.415609, -1.077406, -0.174541>
    }
    triangle {
      < 1.415609, -1.077406, -0.174541>,
      < 1.415603, -1.067199, -0.167113>,
      < 1.314714, -1.067259, -0.167113>
    }
    triangle {
      < 1.415609, -1.077406, -0.174541>,
      < 1.314714, -1.067259, -0.167113>,
      < 1.314720, -1.077466, -0.174541>
    }
    triangle {
      < 1.314720, -1.077466, -0.174541>,
      < 1.314714, -1.067259, -0.167113>,
      < 1.284458, -1.085627, -0.131172>
    }
    triangle {
      < 1.314720, -1.077466, -0.174541>,
      < 1.284458, -1.085627, -0.131172>,
      < 1.284470, -1.106042, -0.146027>
    }
    triangle {
      < 1.284470, -1.106042, -0.146027>,
      < 1.284458, -1.085627, -0.131172>,
      < 1.198715, -1.108616, -0.086242>
    }
    triangle {
      < 1.284470, -1.106042, -0.146027>,
      < 1.198715, -1.108616, -0.086242>,
      < 1.198735, -1.141788, -0.110383>
    }
    triangle {
      < 1.198735, -1.141788, -0.110383>,
      < 1.198715, -1.108616, -0.086242>,
      < 0.093979, -1.109270, -0.086243>
    }
    triangle {
      < 1.198735, -1.141788, -0.110383>,
      < 0.093979, -1.109270, -0.086243>,
      < 0.093999, -1.142442, -0.110384>
    }
    triangle {
      < 0.093999, -1.142442, -0.110384>,
      < 0.093979, -1.109270, -0.086243>,
      < 0.063711, -1.104701, -0.095229>
    }
    triangle {
      < 0.093999, -1.142442, -0.110384>,
      < 0.063711, -1.104701, -0.095229>,
      < 0.063729, -1.135321, -0.117512>
    }
    triangle {
      < 0.063729, -1.135321, -0.117512>,
      < 0.063711, -1.104701, -0.095229>,
      < -0.264181, -1.102601, -0.099722>
    }
    triangle {
      < 0.063729, -1.135321, -0.117512>,
      < -0.264181, -1.102601, -0.099722>,
      < -0.264163, -1.131947, -0.121077>
    }
    triangle {
      < -0.264163, -1.131947, -0.121077>,
      < -0.264181, -1.102601, -0.099722>,
      < -0.360035, -1.086601, -0.131172>
    }
    triangle {
      < -0.264163, -1.131947, -0.121077>,
      < -0.360035, -1.086601, -0.131172>,
      < -0.360023, -1.107016, -0.146027>
    }
    triangle {
      < -0.360023, -1.107016, -0.146027>,
      < -0.360035, -1.086601, -0.131172>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415596, -1.055197, -0.163203>,
      < 1.415603, -1.067199, -0.167113>
    }
    triangle {
      < 1.415603, -1.067199, -0.167113>,
      < 1.415596, -1.055197, -0.163203>,
      < 1.314707, -1.055257, -0.163203>
    }
    triangle {
      < 1.415603, -1.067199, -0.167113>,
      < 1.314707, -1.055257, -0.163203>,
      < 1.314714, -1.067259, -0.167113>
    }
    triangle {
      < 1.314714, -1.067259, -0.167113>,
      < 1.314707, -1.055257, -0.163203>,
      < 1.284443, -1.061621, -0.123350>
    }
    triangle {
      < 1.314714, -1.067259, -0.167113>,
      < 1.284443, -1.061621, -0.123350>,
      < 1.284458, -1.085627, -0.131172>
    }
    triangle {
      < 1.284458, -1.085627, -0.131172>,
      < 1.284443, -1.061621, -0.123350>,
      < 1.198692, -1.069607, -0.073533>
    }
    triangle {
      < 1.284458, -1.085627, -0.131172>,
      < 1.198692, -1.069607, -0.073533>,
      < 1.198715, -1.108616, -0.086242>
    }
    triangle {
      < 1.198715, -1.108616, -0.086242>,
      < 1.198692, -1.069607, -0.073533>,
      < 0.093956, -1.070261, -0.073533>
    }
    triangle {
      < 1.198715, -1.108616, -0.086242>,
      < 0.093956, -1.070261, -0.073533>,
      < 0.093979, -1.109270, -0.086243>
    }
    triangle {
      < 0.093979, -1.109270, -0.086243>,
      < 0.093956, -1.070261, -0.073533>,
      < 0.063689, -1.068692, -0.083497>
    }
    triangle {
      < 0.093979, -1.109270, -0.086243>,
      < 0.063689, -1.068692, -0.083497>,
      < 0.063711, -1.104701, -0.095229>
    }
    triangle {
      < 0.063711, -1.104701, -0.095229>,
      < 0.063689, -1.068692, -0.083497>,
      < -0.264201, -1.068094, -0.088477>
    }
    triangle {
      < 0.063711, -1.104701, -0.095229>,
      < -0.264201, -1.068094, -0.088477>,
      < -0.264181, -1.102601, -0.099722>
    }
    triangle {
      < -0.264181, -1.102601, -0.099722>,
      < -0.264201, -1.068094, -0.088477>,
      < -0.360049, -1.062596, -0.123350>
    }
    triangle {
      < -0.264181, -1.102601, -0.099722>,
      < -0.360049, -1.062596, -0.123350>,
      < -0.360035, -1.086601, -0.131172>
    }
    triangle {
      < -0.360035, -1.086601, -0.131172>,
      < -0.360049, -1.062596, -0.123350>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415588, -1.042574, -0.163192>,
      < 1.415596, -1.055197, -0.163203>
    }
    triangle {
      < 1.415596, -1.055197, -0.163203>,
      < 1.415588, -1.042574, -0.163192>,
      < 1.314699, -1.042634, -0.163192>
    }
    triangle {
      < 1.415596, -1.055197, -0.163203>,
      < 1.314699, -1.042634, -0.163192>,
      < 1.314707, -1.055257, -0.163203>
    }
    triangle {
      < 1.314707, -1.055257, -0.163203>,
      < 1.314699, -1.042634, -0.163192>,
      < 1.284428, -1.036374, -0.123326>
    }
    triangle {
      < 1.314707, -1.055257, -0.163203>,
      < 1.284428, -1.036374, -0.123326>,
      < 1.284443, -1.061621, -0.123350>
    }
    triangle {
      < 1.284443, -1.061621, -0.123350>,
      < 1.284428, -1.036374, -0.123326>,
      < 1.198668, -1.028580, -0.073496>
    }
    triangle {
      < 1.284443, -1.061621, -0.123350>,
      < 1.198668, -1.028580, -0.073496>,
      < 1.198692, -1.069607, -0.073533>
    }
    triangle {
      < 1.198692, -1.069607, -0.073533>,
      < 1.198668, -1.028580, -0.073496>,
      < 0.093932, -1.029234, -0.073496>
    }
    triangle {
      < 1.198692, -1.069607, -0.073533>,
      < 0.093932, -1.029234, -0.073496>,
      < 0.093956, -1.070261, -0.073533>
    }
    triangle {
      < 0.093956, -1.070261, -0.073533>,
      < 0.093932, -1.029234, -0.073496>,
      < 0.063667, -1.030821, -0.083462>
    }
    triangle {
      < 0.093956, -1.070261, -0.073533>,
      < 0.063667, -1.030821, -0.083462>,
      < 0.063689, -1.068692, -0.083497>
    }
    triangle {
      < 0.063689, -1.068692, -0.083497>,
      < 0.063667, -1.030821, -0.083462>,
      < -0.264223, -1.031801, -0.088446>
    }
    triangle {
      < 0.063689, -1.068692, -0.083497>,
      < -0.264223, -1.031801, -0.088446>,
      < -0.264201, -1.068094, -0.088477>
    }
    triangle {
      < -0.264201, -1.068094, -0.088477>,
      < -0.264223, -1.031801, -0.088446>,
      < -0.360064, -1.037348, -0.123326>
    }
    triangle {
      < -0.264201, -1.068094, -0.088477>,
      < -0.360064, -1.037348, -0.123326>,
      < -0.360049, -1.062596, -0.123350>
    }
    triangle {
      < -0.360049, -1.062596, -0.123350>,
      < -0.360064, -1.037348, -0.123326>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415581, -1.030563, -0.167080>,
      < 1.415588, -1.042574, -0.163192>
    }
    triangle {
      < 1.415588, -1.042574, -0.163192>,
      < 1.415581, -1.030563, -0.167080>,
      < 1.314692, -1.030623, -0.167080>
    }
    triangle {
      < 1.415588, -1.042574, -0.163192>,
      < 1.314692, -1.030623, -0.167080>,
      < 1.314699, -1.042634, -0.163192>
    }
    triangle {
      < 1.314699, -1.042634, -0.163192>,
      < 1.314692, -1.030623, -0.167080>,
      < 1.284414, -1.012356, -0.131106>
    }
    triangle {
      < 1.314699, -1.042634, -0.163192>,
      < 1.284414, -1.012356, -0.131106>,
      < 1.284428, -1.036374, -0.123326>
    }
    triangle {
      < 1.284428, -1.036374, -0.123326>,
      < 1.284414, -1.012356, -0.131106>,
      < 1.198645, -0.989550, -0.086137>
    }
    triangle {
      < 1.284428, -1.036374, -0.123326>,
      < 1.198645, -0.989550, -0.086137>,
      < 1.198668, -1.028580, -0.073496>
    }
    triangle {
      < 1.198668, -1.028580, -0.073496>,
      < 1.198645, -0.989550, -0.086137>,
      < 0.093909, -0.990203, -0.086137>
    }
    triangle {
      < 1.198668, -1.028580, -0.073496>,
      < 0.093909, -0.990203, -0.086137>,
      < 0.093932, -1.029234, -0.073496>
    }
    triangle {
      < 0.093932, -1.029234, -0.073496>,
      < 0.093909, -0.990203, -0.086137>,
      < 0.063646, -0.994793, -0.095131>
    }
    triangle {
      < 0.093932, -1.029234, -0.073496>,
      < 0.063646, -0.994793, -0.095131>,
      < 0.063667, -1.030821, -0.083462>
    }
    triangle {
      < 0.063667, -1.030821, -0.083462>,
      < 0.063646, -0.994793, -0.095131>,
      < -0.264243, -0.997274, -0.099629>
    }
    triangle {
      < 0.063667, -1.030821, -0.083462>,
      < -0.264243, -0.997274, -0.099629>,
      < -0.264223, -1.031801, -0.088446>
    }
    triangle {
      < -0.264223, -1.031801, -0.088446>,
      < -0.264243, -0.997274, -0.099629>,
      < -0.360079, -1.013331, -0.131106>
    }
    triangle {
      < -0.264223, -1.031801, -0.088446>,
      < -0.360079, -1.013331, -0.131106>,
      < -0.360064, -1.037348, -0.123326>
    }
    triangle {
      < -0.360064, -1.037348, -0.123326>,
      < -0.360079, -1.013331, -0.131106>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415575, -1.020343, -0.174490>,
      < 1.415581, -1.030563, -0.167080>
    }
    triangle {
      < 1.415581, -1.030563, -0.167080>,
      < 1.415575, -1.020343, -0.174490>,
      < 1.314686, -1.020403, -0.174490>
    }
    triangle {
      < 1.415581, -1.030563, -0.167080>,
      < 1.314686, -1.020403, -0.174490>,
      < 1.314692, -1.030623, -0.167080>
    }
    triangle {
      < 1.314692, -1.030623, -0.167080>,
      < 1.314686, -1.020403, -0.174490>,
      < 1.284402, -0.991916, -0.145925>
    }
    triangle {
      < 1.314692, -1.030623, -0.167080>,
      < 1.284402, -0.991916, -0.145925>,
      < 1.284414, -1.012356, -0.131106>
    }
    triangle {
      < 1.284414, -1.012356, -0.131106>,
      < 1.284402, -0.991916, -0.145925>,
      < 1.198625, -0.956333, -0.110218>
    }
    triangle {
      < 1.284414, -1.012356, -0.131106>,
      < 1.198625, -0.956333, -0.110218>,
      < 1.198645, -0.989550, -0.086137>
    }
    triangle {
      < 1.198645, -0.989550, -0.086137>,
      < 1.198625, -0.956333, -0.110218>,
      < 0.093889, -0.956988, -0.110219>
    }
    triangle {
      < 1.198645, -0.989550, -0.086137>,
      < 0.093889, -0.956988, -0.110219>,
      < 0.093909, -0.990203, -0.086137>
    }
    triangle {
      < 0.093909, -0.990203, -0.086137>,
      < 0.093889, -0.956988, -0.110219>,
      < 0.063627, -0.964132, -0.117361>
    }
    triangle {
      < 0.093909, -0.990203, -0.086137>,
      < 0.063627, -0.964132, -0.117361>,
      < 0.063646, -0.994793, -0.095131>
    }
    triangle {
      < 0.063646, -0.994793, -0.095131>,
      < 0.063627, -0.964132, -0.117361>,
      < -0.264260, -0.967890, -0.120931>
    }
    triangle {
      < 0.063646, -0.994793, -0.095131>,
      < -0.264260, -0.967890, -0.120931>,
      < -0.264243, -0.997274, -0.099629>
    }
    triangle {
      < -0.264243, -0.997274, -0.099629>,
      < -0.264260, -0.967890, -0.120931>,
      < -0.360091, -0.992891, -0.145925>
    }
    triangle {
      < -0.264243, -0.997274, -0.099629>,
      < -0.360091, -0.992891, -0.145925>,
      < -0.360079, -1.013331, -0.131106>
    }
    triangle {
      < -0.360079, -1.013331, -0.131106>,
      < -0.360091, -0.992891, -0.145925>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415571, -1.012912, -0.184695>,
      < 1.415575, -1.020343, -0.174490>
    }
    triangle {
      < 1.415575, -1.020343, -0.174490>,
      < 1.415571, -1.012912, -0.184695>,
      < 1.314682, -1.012972, -0.184695>
    }
    triangle {
      < 1.415575, -1.020343, -0.174490>,
      < 1.314682, -1.012972, -0.184695>,
      < 1.314686, -1.020403, -0.174490>
    }
    triangle {
      < 1.314686, -1.020403, -0.174490>,
      < 1.314682, -1.012972, -0.184695>,
      < 1.284393, -0.977054, -0.166336>
    }
    triangle {
      < 1.314686, -1.020403, -0.174490>,
      < 1.284393, -0.977054, -0.166336>,
      < 1.284402, -0.991916, -0.145925>
    }
    triangle {
      < 1.284402, -0.991916, -0.145925>,
      < 1.284393, -0.977054, -0.166336>,
      < 1.198611, -0.932183, -0.143384>
    }
    triangle {
      < 1.284402, -0.991916, -0.145925>,
      < 1.198611, -0.932183, -0.143384>,
      < 1.198625, -0.956333, -0.110218>
    }
    triangle {
      < 1.198625, -0.956333, -0.110218>,
      < 1.198611, -0.932183, -0.143384>,
      < 0.093875, -0.932838, -0.143384>
    }
    triangle {
      < 1.198625, -0.956333, -0.110218>,
      < 0.093875, -0.932838, -0.143384>,
      < 0.093889, -0.956988, -0.110219>
    }
    triangle {
      < 0.093889, -0.956988, -0.110219>,
      < 0.093875, -0.932838, -0.143384>,
      < 0.063614, -0.941840, -0.147975>
    }
    triangle {
      < 0.093889, -0.956988, -0.110219>,
      < 0.063614, -0.941840, -0.147975>,
      < 0.063627, -0.964132, -0.117361>
    }
    triangle {
      < 0.063627, -0.964132, -0.117361>,
      < 0.063614, -0.941840, -0.147975>,
      < -0.264273, -0.946526, -0.150270>
    }
    triangle {
      < 0.063627, -0.964132, -0.117361>,
      < -0.264273, -0.946526, -0.150270>,
      < -0.264260, -0.967890, -0.120931>
    }
    triangle {
      < -0.264260, -0.967890, -0.120931>,
      < -0.264273, -0.946526, -0.150270>,
      < -0.360099, -0.978029, -0.166336>
    }
    triangle {
      < -0.264260, -0.967890, -0.120931>,
      < -0.360099, -0.978029, -0.166336>,
      < -0.360091, -0.992891, -0.145925>
    }
    triangle {
      < -0.360091, -0.992891, -0.145925>,
      < -0.360099, -0.978029, -0.166336>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415568, -1.008999, -0.196697>,
      < 1.415571, -1.012912, -0.184695>
    }
    triangle {
      < 1.415571, -1.012912, -0.184695>,
      < 1.415568, -1.008999, -0.196697>,
      < 1.314679, -1.009059, -0.196697>
    }
    triangle {
      < 1.415571, -1.012912, -0.184695>,
      < 1.314679, -1.009059, -0.196697>,
      < 1.314682, -1.012972, -0.184695>
    }
    triangle {
      < 1.314682, -1.012972, -0.184695>,
      < 1.314679, -1.009059, -0.196697>,
      < 1.284389, -0.969225, -0.190338>
    }
    triangle {
      < 1.314682, -1.012972, -0.184695>,
      < 1.284389, -0.969225, -0.190338>,
      < 1.284393, -0.977054, -0.166336>
    }
    triangle {
      < 1.284393, -0.977054, -0.166336>,
      < 1.284389, -0.969225, -0.190338>,
      < 1.198603, -0.919461, -0.182389>
    }
    triangle {
      < 1.284393, -0.977054, -0.166336>,
      < 1.198603, -0.919461, -0.182389>,
      < 1.198611, -0.932183, -0.143384>
    }
    triangle {
      < 1.198611, -0.932183, -0.143384>,
      < 1.198603, -0.919461, -0.182389>,
      < 0.093867, -0.920116, -0.182390>
    }
    triangle {
      < 1.198611, -0.932183, -0.143384>,
      < 0.093867, -0.920116, -0.182390>,
      < 0.093875, -0.932838, -0.143384>
    }
    triangle {
      < 0.093875, -0.932838, -0.143384>,
      < 0.093867, -0.920116, -0.182390>,
      < 0.063607, -0.930097, -0.183980>
    }
    triangle {
      < 0.093875, -0.932838, -0.143384>,
      < 0.063607, -0.930097, -0.183980>,
      < 0.063614, -0.941840, -0.147975>
    }
    triangle {
      < 0.063614, -0.941840, -0.147975>,
      < 0.063607, -0.930097, -0.183980>,
      < -0.264280, -0.935272, -0.184774>
    }
    triangle {
      < 0.063614, -0.941840, -0.147975>,
      < -0.264280, -0.935272, -0.184774>,
      < -0.264273, -0.946526, -0.150270>
    }
    triangle {
      < -0.264273, -0.946526, -0.150270>,
      < -0.264280, -0.935272, -0.184774>,
      < -0.360104, -0.970200, -0.190338>
    }
    triangle {
      < -0.264273, -0.946526, -0.150270>,
      < -0.360104, -0.970200, -0.190338>,
      < -0.360099, -0.978029, -0.166336>
    }
    triangle {
      < -0.360099, -0.978029, -0.166336>,
      < -0.360104, -0.970200, -0.190338>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415568, -1.008983, -0.209321>,
      < 1.415568, -1.008999, -0.196697>
    }
    triangle {
      < 1.415568, -1.008999, -0.196697>,
      < 1.415568, -1.008983, -0.209321>,
      < 1.314679, -1.009043, -0.209321>
    }
    triangle {
      < 1.415568, -1.008999, -0.196697>,
      < 1.314679, -1.009043, -0.209321>,
      < 1.314679, -1.009059, -0.196697>
    }
    triangle {
      < 1.314679, -1.009059, -0.196697>,
      < 1.314679, -1.009043, -0.209321>,
      < 1.284389, -0.969195, -0.215585>
    }
    triangle {
      < 1.314679, -1.009059, -0.196697>,
      < 1.284389, -0.969195, -0.215585>,
      < 1.284389, -0.969225, -0.190338>
    }
    triangle {
      < 1.284389, -0.969225, -0.190338>,
      < 1.284389, -0.969195, -0.215585>,
      < 1.198603, -0.919413, -0.223415>
    }
    triangle {
      < 1.284389, -0.969225, -0.190338>,
      < 1.198603, -0.919413, -0.223415>,
      < 1.198603, -0.919461, -0.182389>
    }
    triangle {
      < 1.198603, -0.919461, -0.182389>,
      < 1.198603, -0.919413, -0.223415>,
      < 0.093867, -0.920068, -0.223416>
    }
    triangle {
      < 1.198603, -0.919461, -0.182389>,
      < 0.093867, -0.920068, -0.223416>,
      < 0.093867, -0.920116, -0.182390>
    }
    triangle {
      < 0.093867, -0.920116, -0.182390>,
      < 0.093867, -0.920068, -0.223416>,
      < 0.063607, -0.930051, -0.221851>
    }
    triangle {
      < 0.093867, -0.920116, -0.182390>,
      < 0.063607, -0.930051, -0.221851>,
      < 0.063607, -0.930097, -0.183980>
    }
    triangle {
      < 0.063607, -0.930097, -0.183980>,
      < 0.063607, -0.930051, -0.221851>,
      < -0.264280, -0.935229, -0.221067>
    }
    triangle {
      < 0.063607, -0.930097, -0.183980>,
      < -0.264280, -0.935229, -0.221067>,
      < -0.264280, -0.935272, -0.184774>
    }
    triangle {
      < -0.264280, -0.935272, -0.184774>,
      < -0.264280, -0.935229, -0.221067>,
      < -0.360104, -0.970170, -0.215585>
    }
    triangle {
      < -0.264280, -0.935272, -0.184774>,
      < -0.360104, -0.970170, -0.215585>,
      < -0.360104, -0.970200, -0.190338>
    }
    triangle {
      < -0.360104, -0.970200, -0.190338>,
      < -0.360104, -0.970170, -0.215585>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415571, -1.012869, -0.221331>,
      < 1.415568, -1.008983, -0.209321>
    }
    triangle {
      < 1.415568, -1.008983, -0.209321>,
      < 1.415571, -1.012869, -0.221331>,
      < 1.314682, -1.012929, -0.221331>
    }
    triangle {
      < 1.415568, -1.008983, -0.209321>,
      < 1.314682, -1.012929, -0.221331>,
      < 1.314679, -1.009043, -0.209321>
    }
    triangle {
      < 1.314679, -1.009043, -0.209321>,
      < 1.314682, -1.012929, -0.221331>,
      < 1.284393, -0.976967, -0.239606>
    }
    triangle {
      < 1.314679, -1.009043, -0.209321>,
      < 1.284393, -0.976967, -0.239606>,
      < 1.284389, -0.969195, -0.215585>
    }
    triangle {
      < 1.284389, -0.969195, -0.215585>,
      < 1.284393, -0.976967, -0.239606>,
      < 1.198611, -0.932042, -0.262450>
    }
    triangle {
      < 1.284389, -0.969195, -0.215585>,
      < 1.198611, -0.932042, -0.262450>,
      < 1.198603, -0.919413, -0.223415>
    }
    triangle {
      < 1.198603, -0.919413, -0.223415>,
      < 1.198611, -0.932042, -0.262450>,
      < 0.093875, -0.932696, -0.262450>
    }
    triangle {
      < 1.198603, -0.919413, -0.223415>,
      < 0.093875, -0.932696, -0.262450>,
      < 0.093867, -0.920068, -0.223416>
    }
    triangle {
      < 0.093867, -0.920068, -0.223416>,
      < 0.093875, -0.932696, -0.262450>,
      < 0.063614, -0.941709, -0.257882>
    }
    triangle {
      < 0.093867, -0.920068, -0.223416>,
      < 0.063614, -0.941709, -0.257882>,
      < 0.063607, -0.930051, -0.221851>
    }
    triangle {
      < 0.063607, -0.930051, -0.221851>,
      < 0.063614, -0.941709, -0.257882>,
      < -0.264273, -0.946402, -0.255597>
    }
    triangle {
      < 0.063607, -0.930051, -0.221851>,
      < -0.264273, -0.946402, -0.255597>,
      < -0.264280, -0.935229, -0.221067>
    }
    triangle {
      < -0.264280, -0.935229, -0.221067>,
      < -0.264273, -0.946402, -0.255597>,
      < -0.360099, -0.977942, -0.239607>
    }
    triangle {
      < -0.264280, -0.935229, -0.221067>,
      < -0.360099, -0.977942, -0.239607>,
      < -0.360104, -0.970170, -0.215585>
    }
    triangle {
      < -0.360104, -0.970170, -0.215585>,
      < -0.360099, -0.977942, -0.239607>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415575, -1.020275, -0.231553>,
      < 1.415571, -1.012869, -0.221331>
    }
    triangle {
      < 1.415571, -1.012869, -0.221331>,
      < 1.415575, -1.020275, -0.231553>,
      < 1.314686, -1.020335, -0.231553>
    }
    triangle {
      < 1.415571, -1.012869, -0.221331>,
      < 1.314686, -1.020335, -0.231553>,
      < 1.314682, -1.012929, -0.221331>
    }
    triangle {
      < 1.314682, -1.012929, -0.221331>,
      < 1.314686, -1.020335, -0.231553>,
      < 1.284402, -0.991780, -0.260052>
    }
    triangle {
      < 1.314682, -1.012929, -0.221331>,
      < 1.284402, -0.991780, -0.260052>,
      < 1.284393, -0.976967, -0.239606>
    }
    triangle {
      < 1.284393, -0.976967, -0.239606>,
      < 1.284402, -0.991780, -0.260052>,
      < 1.198625, -0.956113, -0.295673>
    }
    triangle {
      < 1.284393, -0.976967, -0.239606>,
      < 1.198625, -0.956113, -0.295673>,
      < 1.198611, -0.932042, -0.262450>
    }
    triangle {
      < 1.198611, -0.932042, -0.262450>,
      < 1.198625, -0.956113, -0.295673>,
      < 0.093889, -0.956768, -0.295674>
    }
    triangle {
      < 1.198611, -0.932042, -0.262450>,
      < 0.093889, -0.956768, -0.295674>,
      < 0.093875, -0.932696, -0.262450>
    }
    triangle {
      < 0.093875, -0.932696, -0.262450>,
      < 0.093889, -0.956768, -0.295674>,
      < 0.063627, -0.963930, -0.288550>
    }
    triangle {
      < 0.093875, -0.932696, -0.262450>,
      < 0.063627, -0.963930, -0.288550>,
      < 0.063614, -0.941709, -0.257882>
    }
    triangle {
      < 0.063614, -0.941709, -0.257882>,
      < 0.063627, -0.963930, -0.288550>,
      < -0.264261, -0.967696, -0.284987>
    }
    triangle {
      < 0.063614, -0.941709, -0.257882>,
      < -0.264261, -0.967696, -0.284987>,
      < -0.264273, -0.946402, -0.255597>
    }
    triangle {
      < -0.264273, -0.946402, -0.255597>,
      < -0.264261, -0.967696, -0.284987>,
      < -0.360091, -0.992755, -0.260052>
    }
    triangle {
      < -0.264273, -0.946402, -0.255597>,
      < -0.360091, -0.992755, -0.260052>,
      < -0.360099, -0.977942, -0.239607>
    }
    triangle {
      < -0.360099, -0.977942, -0.239607>,
      < -0.360091, -0.992755, -0.260052>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415581, -1.030478, -0.238987>,
      < 1.415575, -1.020275, -0.231553>
    }
    triangle {
      < 1.415575, -1.020275, -0.231553>,
      < 1.415581, -1.030478, -0.238987>,
      < 1.314692, -1.030538, -0.238987>
    }
    triangle {
      < 1.415575, -1.020275, -0.231553>,
      < 1.314692, -1.030538, -0.238987>,
      < 1.314686, -1.020335, -0.231553>
    }
    triangle {
      < 1.314686, -1.020335, -0.231553>,
      < 1.314692, -1.030538, -0.238987>,
      < 1.284414, -1.012185, -0.274920>
    }
    triangle {
      < 1.314686, -1.020335, -0.231553>,
      < 1.284414, -1.012185, -0.274920>,
      < 1.284402, -0.991780, -0.260052>
    }
    triangle {
      < 1.284402, -0.991780, -0.260052>,
      < 1.284414, -1.012185, -0.274920>,
      < 1.198645, -0.989272, -0.319834>
    }
    triangle {
      < 1.284402, -0.991780, -0.260052>,
      < 1.198645, -0.989272, -0.319834>,
      < 1.198625, -0.956113, -0.295673>
    }
    triangle {
      < 1.198625, -0.956113, -0.295673>,
      < 1.198645, -0.989272, -0.319834>,
      < 0.093909, -0.989927, -0.319834>
    }
    triangle {
      < 1.198625, -0.956113, -0.295673>,
      < 0.093909, -0.989927, -0.319834>,
      < 0.093889, -0.956768, -0.295674>
    }
    triangle {
      < 0.093889, -0.956768, -0.295674>,
      < 0.093909, -0.989927, -0.319834>,
      < 0.063645, -0.994537, -0.310851>
    }
    triangle {
      < 0.093889, -0.956768, -0.295674>,
      < 0.063645, -0.994537, -0.310851>,
      < 0.063627, -0.963930, -0.288550>
    }
    triangle {
      < 0.063627, -0.963930, -0.288550>,
      < 0.063645, -0.994537, -0.310851>,
      < -0.264243, -0.997028, -0.306359>
    }
    triangle {
      < 0.063627, -0.963930, -0.288550>,
      < -0.264243, -0.997028, -0.306359>,
      < -0.264261, -0.967696, -0.284987>
    }
    triangle {
      < -0.264261, -0.967696, -0.284987>,
      < -0.264243, -0.997028, -0.306359>,
      < -0.360079, -1.013160, -0.274920>
    }
    triangle {
      < -0.264261, -0.967696, -0.284987>,
      < -0.360079, -1.013160, -0.274920>,
      < -0.360091, -0.992755, -0.260052>
    }
    triangle {
      < -0.360091, -0.992755, -0.260052>,
      < -0.360079, -1.013160, -0.274920>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415588, -1.042479, -0.242906>,
      < 1.415581, -1.030478, -0.238987>
    }
    triangle {
      < 1.415581, -1.030478, -0.238987>,
      < 1.415588, -1.042479, -0.242906>,
      < 1.314699, -1.042539, -0.242906>
    }
    triangle {
      < 1.415581, -1.030478, -0.238987>,
      < 1.314699, -1.042539, -0.242906>,
      < 1.314692, -1.030538, -0.238987>
    }
    triangle {
      < 1.314692, -1.030538, -0.238987>,
      < 1.314699, -1.042539, -0.242906>,
      < 1.284428, -1.036186, -0.282755>
    }
    triangle {
      < 1.314692, -1.030538, -0.238987>,
      < 1.284428, -1.036186, -0.282755>,
      < 1.284414, -1.012185, -0.274920>
    }
    triangle {
      < 1.284414, -1.012185, -0.274920>,
      < 1.284428, -1.036186, -0.282755>,
      < 1.198668, -1.028273, -0.332568>
    }
    triangle {
      < 1.284414, -1.012185, -0.274920>,
      < 1.198668, -1.028273, -0.332568>,
      < 1.198645, -0.989272, -0.319834>
    }
    triangle {
      < 1.198645, -0.989272, -0.319834>,
      < 1.198668, -1.028273, -0.332568>,
      < 0.093932, -1.028927, -0.332568>
    }
    triangle {
      < 1.198645, -0.989272, -0.319834>,
      < 0.093932, -1.028927, -0.332568>,
      < 0.093909, -0.989927, -0.319834>
    }
    triangle {
      < 0.093909, -0.989927, -0.319834>,
      < 0.093932, -1.028927, -0.332568>,
      < 0.063667, -1.030537, -0.322605>
    }
    triangle {
      < 0.093909, -0.989927, -0.319834>,
      < 0.063667, -1.030537, -0.322605>,
      < 0.063645, -0.994537, -0.310851>
    }
    triangle {
      < 0.063645, -0.994537, -0.310851>,
      < 0.063667, -1.030537, -0.322605>,
      < -0.264223, -1.031529, -0.317624>
    }
    triangle {
      < 0.063645, -0.994537, -0.310851>,
      < -0.264223, -1.031529, -0.317624>,
      < -0.264243, -0.997028, -0.306359>
    }
    triangle {
      < -0.264243, -0.997028, -0.306359>,
      < -0.264223, -1.031529, -0.317624>,
      < -0.360064, -1.037161, -0.282755>
    }
    triangle {
      < -0.264243, -0.997028, -0.306359>,
      < -0.360064, -1.037161, -0.282755>,
      < -0.360079, -1.013160, -0.274920>
    }
    triangle {
      < -0.360079, -1.013160, -0.274920>,
      < -0.360064, -1.037161, -0.282755>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415596, -1.055103, -0.242925>,
      < 1.415588, -1.042479, -0.242906>
    }
    triangle {
      < 1.415588, -1.042479, -0.242906>,
      < 1.415596, -1.055103, -0.242925>,
      < 1.314707, -1.055163, -0.242925>
    }
    triangle {
      < 1.415588, -1.042479, -0.242906>,
      < 1.314707, -1.055163, -0.242925>,
      < 1.314699, -1.042539, -0.242906>
    }
    triangle {
      < 1.314699, -1.042539, -0.242906>,
      < 1.314707, -1.055163, -0.242925>,
      < 1.284443, -1.061433, -0.282793>
    }
    triangle {
      < 1.314699, -1.042539, -0.242906>,
      < 1.284443, -1.061433, -0.282793>,
      < 1.284428, -1.036186, -0.282755>
    }
    triangle {
      < 1.284428, -1.036186, -0.282755>,
      < 1.284443, -1.061433, -0.282793>,
      < 1.198692, -1.069300, -0.332628>
    }
    triangle {
      < 1.284428, -1.036186, -0.282755>,
      < 1.198692, -1.069300, -0.332628>,
      < 1.198668, -1.028273, -0.332568>
    }
    triangle {
      < 1.198668, -1.028273, -0.332568>,
      < 1.198692, -1.069300, -0.332628>,
      < 0.093956, -1.069954, -0.332628>
    }
    triangle {
      < 1.198668, -1.028273, -0.332568>,
      < 0.093956, -1.069954, -0.332628>,
      < 0.093932, -1.028927, -0.332568>
    }
    triangle {
      < 0.093932, -1.028927, -0.332568>,
      < 0.093956, -1.069954, -0.332628>,
      < 0.063689, -1.068409, -0.322662>
    }
    triangle {
      < 0.093932, -1.028927, -0.332568>,
      < 0.063689, -1.068409, -0.322662>,
      < 0.063667, -1.030537, -0.322605>
    }
    triangle {
      < 0.063667, -1.030537, -0.322605>,
      < 0.063689, -1.068409, -0.322662>,
      < -0.264201, -1.067823, -0.317677>
    }
    triangle {
      < 0.063667, -1.030537, -0.322605>,
      < -0.264201, -1.067823, -0.317677>,
      < -0.264223, -1.031529, -0.317624>
    }
    triangle {
      < -0.264223, -1.031529, -0.317624>,
      < -0.264201, -1.067823, -0.317677>,
      < -0.360049, -1.062408, -0.282793>
    }
    triangle {
      < -0.264223, -1.031529, -0.317624>,
      < -0.360049, -1.062408, -0.282793>,
      < -0.360064, -1.037161, -0.282755>
    }
    triangle {
      < -0.360064, -1.037161, -0.282755>,
      < -0.360049, -1.062408, -0.282793>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415603, -1.067114, -0.239042>,
      < 1.415596, -1.055103, -0.242925>
    }
    triangle {
      < 1.415596, -1.055103, -0.242925>,
      < 1.415603, -1.067114, -0.239042>,
      < 1.314714, -1.067174, -0.239042>
    }
    triangle {
      < 1.415596, -1.055103, -0.242925>,
      < 1.314714, -1.067174, -0.239042>,
      < 1.314707, -1.055163, -0.242925>
    }
    triangle {
      < 1.314707, -1.055163, -0.242925>,
      < 1.314714, -1.067174, -0.239042>,
      < 1.284457, -1.085457, -0.275028>
    }
    triangle {
      < 1.314707, -1.055163, -0.242925>,
      < 1.284457, -1.085457, -0.275028>,
      < 1.284443, -1.061433, -0.282793>
    }
    triangle {
      < 1.284443, -1.061433, -0.282793>,
      < 1.284457, -1.085457, -0.275028>,
      < 1.198715, -1.108338, -0.320010>
    }
    triangle {
      < 1.284443, -1.061433, -0.282793>,
      < 1.198715, -1.108338, -0.320010>,
      < 1.198692, -1.069300, -0.332628>
    }
    triangle {
      < 1.198692, -1.069300, -0.332628>,
      < 1.198715, -1.108338, -0.320010>,
      < 0.093979, -1.108992, -0.320011>
    }
    triangle {
      < 1.198692, -1.069300, -0.332628>,
      < 0.093979, -1.108992, -0.320011>,
      < 0.093956, -1.069954, -0.332628>
    }
    triangle {
      < 0.093956, -1.069954, -0.332628>,
      < 0.093979, -1.108992, -0.320011>,
      < 0.063711, -1.104445, -0.311014>
    }
    triangle {
      < 0.093956, -1.069954, -0.332628>,
      < 0.063711, -1.104445, -0.311014>,
      < 0.063689, -1.068409, -0.322662>
    }
    triangle {
      < 0.063689, -1.068409, -0.322662>,
      < 0.063711, -1.104445, -0.311014>,
      < -0.264181, -1.102356, -0.306516>
    }
    triangle {
      < 0.063689, -1.068409, -0.322662>,
      < -0.264181, -1.102356, -0.306516>,
      < -0.264201, -1.067823, -0.317677>
    }
    triangle {
      < -0.264201, -1.067823, -0.317677>,
      < -0.264181, -1.102356, -0.306516>,
      < -0.360035, -1.086432, -0.275028>
    }
    triangle {
      < -0.264201, -1.067823, -0.317677>,
      < -0.360035, -1.086432, -0.275028>,
      < -0.360049, -1.062408, -0.282793>
    }
    triangle {
      < -0.360049, -1.062408, -0.282793>,
      < -0.360035, -1.086432, -0.275028>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < 1.415592, -1.048850, -0.203056>,
      < 1.415609, -1.077372, -0.231604>,
      < 1.415603, -1.067114, -0.239042>
    }
    triangle {
      < 1.415603, -1.067114, -0.239042>,
      < 1.415609, -1.077372, -0.231604>,
      < 1.314720, -1.077432, -0.231604>
    }
    triangle {
      < 1.415603, -1.067114, -0.239042>,
      < 1.314720, -1.077432, -0.231604>,
      < 1.314714, -1.067174, -0.239042>
    }
    triangle {
      < 1.314714, -1.067174, -0.239042>,
      < 1.314720, -1.077432, -0.231604>,
      < 1.284470, -1.105974, -0.260153>
    }
    triangle {
      < 1.314714, -1.067174, -0.239042>,
      < 1.284470, -1.105974, -0.260153>,
      < 1.284457, -1.085457, -0.275028>
    }
    triangle {
      < 1.284457, -1.085457, -0.275028>,
      < 1.284470, -1.105974, -0.260153>,
      < 1.198735, -1.141678, -0.295838>
    }
    triangle {
      < 1.284457, -1.085457, -0.275028>,
      < 1.198735, -1.141678, -0.295838>,
      < 1.198715, -1.108338, -0.320010>
    }
    triangle {
      < 1.198715, -1.108338, -0.320010>,
      < 1.198735, -1.141678, -0.295838>,
      < 0.093999, -1.142332, -0.295839>
    }
    triangle {
      < 1.198715, -1.108338, -0.320010>,
      < 0.093999, -1.142332, -0.295839>,
      < 0.093979, -1.108992, -0.320011>
    }
    triangle {
      < 0.093979, -1.108992, -0.320011>,
      < 0.093999, -1.142332, -0.295839>,
      < 0.063729, -1.135219, -0.288701>
    }
    triangle {
      < 0.093979, -1.108992, -0.320011>,
      < 0.063729, -1.135219, -0.288701>,
      < 0.063711, -1.104445, -0.311014>
    }
    triangle {
      < 0.063711, -1.104445, -0.311014>,
      < 0.063729, -1.135219, -0.288701>,
      < -0.264163, -1.131850, -0.285133>
    }
    triangle {
      < 0.063711, -1.104445, -0.311014>,
      < -0.264163, -1.131850, -0.285133>,
      < -0.264181, -1.102356, -0.306516>
    }
    triangle {
      < -0.264181, -1.102356, -0.306516>,
      < -0.264163, -1.131850, -0.285133>,
      < -0.360023, -1.106949, -0.260153>
    }
    triangle {
      < -0.264181, -1.102356, -0.306516>,
      < -0.360023, -1.106949, -0.260153>,
      < -0.360035, -1.086432, -0.275028>
    }
    triangle {
      < -0.360035, -1.086432, -0.275028>,
      < -0.360023, -1.106949, -0.260153>,
      < -0.425635, -1.049941, -0.203056>
    }
    triangle {
      < -0.077379, -1.226533, -0.004242>,
      < -0.077483, -1.050738, -0.179777>,
      < -0.307667, -1.050875, -0.179777>
    }
    triangle {
      < -0.077379, -1.226533, -0.004242>,
      < -0.307667, -1.050875, -0.179777>,
      < -0.307563, -1.226670, -0.004242>
    }
    triangle {
      < -0.307550, -1.248947, -0.026553>,
      < -0.307654, -1.073152, -0.202087>,
      < -0.077470, -1.073015, -0.202087>
    }
    triangle {
      < -0.307550, -1.248947, -0.026553>,
      < -0.077470, -1.073015, -0.202087>,
      < -0.077366, -1.248810, -0.026553>
    }
    triangle {
      < -0.307563, -1.226670, -0.004242>,
      < -0.307667, -1.050875, -0.179777>,
      < -0.307654, -1.073152, -0.202087>
    }
    triangle {
      < -0.307563, -1.226670, -0.004242>,
      < -0.307654, -1.073152, -0.202087>,
      < -0.307550, -1.248947, -0.026553>
    }
    triangle {
      < -0.077366, -1.248810, -0.026553>,
      < -0.077379, -1.226533, -0.004242>,
      < -0.307563, -1.226670, -0.004242>
    }
    triangle {
      < -0.077366, -1.248810, -0.026553>,
      < -0.307563, -1.226670, -0.004242>,
      < -0.307550, -1.248947, -0.026553>
    }
    triangle {
      < -0.077366, -1.248810, -0.026553>,
      < -0.077470, -1.073015, -0.202087>,
      < -0.077483, -1.050738, -0.179777>
    }
    triangle {
      < -0.077366, -1.248810, -0.026553>,
      < -0.077483, -1.050738, -0.179777>,
      < -0.077379, -1.226533, -0.004242>
    }
    triangle {
      < -0.077483, -1.050738, -0.179777>,
      < -0.077470, -1.073015, -0.202087>,
      < -0.307654, -1.073152, -0.202087>
    }
    triangle {
      < -0.077483, -1.050738, -0.179777>,
      < -0.307654, -1.073152, -0.202087>,
      < -0.307667, -1.050875, -0.179777>
    }
    triangle {
      < 0.249607, -1.226339, -0.004242>,
      < 0.249503, -1.050544, -0.179777>,
      < 0.019320, -1.050681, -0.179777>
    }
    triangle {
      < 0.249607, -1.226339, -0.004242>,
      < 0.019320, -1.050681, -0.179777>,
      < 0.019424, -1.226476, -0.004242>
    }
    triangle {
      < 0.019437, -1.248753, -0.026553>,
      < 0.019333, -1.072958, -0.202087>,
      < 0.249516, -1.072821, -0.202087>
    }
    triangle {
      < 0.019437, -1.248753, -0.026553>,
      < 0.249516, -1.072821, -0.202087>,
      < 0.249620, -1.248616, -0.026553>
    }
    triangle {
      < 0.019424, -1.226476, -0.004242>,
      < 0.019320, -1.050681, -0.179777>,
      < 0.019333, -1.072958, -0.202087>
    }
    triangle {
      < 0.019424, -1.226476, -0.004242>,
      < 0.019333, -1.072958, -0.202087>,
      < 0.019437, -1.248753, -0.026553>
    }
    triangle {
      < 0.249620, -1.248616, -0.026553>,
      < 0.249607, -1.226339, -0.004242>,
      < 0.019424, -1.226476, -0.004242>
    }
    triangle {
      < 0.249620, -1.248616, -0.026553>,
      < 0.019424, -1.226476, -0.004242>,
      < 0.019437, -1.248753, -0.026553>
    }
    triangle {
      < 0.249620, -1.248616, -0.026553>,
      < 0.249516, -1.072821, -0.202087>,
      < 0.249503, -1.050544, -0.179777>
    }
    triangle {
      < 0.249620, -1.248616, -0.026553>,
      < 0.249503, -1.050544, -0.179777>,
      < 0.249607, -1.226339, -0.004242>
    }
    triangle {
      < 0.249503, -1.050544, -0.179777>,
      < 0.249516, -1.072821, -0.202087>,
      < 0.019333, -1.072958, -0.202087>
    }
    triangle {
      < 0.249503, -1.050544, -0.179777>,
      < 0.019333, -1.072958, -0.202087>,
      < 0.019320, -1.050681, -0.179777>
    }
    triangle {
      < -0.077602, -0.850974, -0.026199>,
      < -0.077498, -1.026456, -0.202046>,
      < -0.307682, -1.026592, -0.202046>
    }
    triangle {
      < -0.077602, -0.850974, -0.026199>,
      < -0.307682, -1.026592, -0.202046>,
      < -0.307786, -0.851111, -0.026199>
    }
    triangle {
      < -0.307772, -0.873427, -0.003929>,
      < -0.307668, -1.048909, -0.179776>,
      < -0.077484, -1.048773, -0.179776>
    }
    triangle {
      < -0.307772, -0.873427, -0.003929>,
      < -0.077484, -1.048773, -0.179776>,
      < -0.077588, -0.873290, -0.003929>
    }
    triangle {
      < -0.307786, -0.851111, -0.026199>,
      < -0.307682, -1.026592, -0.202046>,
      < -0.307668, -1.048909, -0.179776>
    }
    triangle {
      < -0.307786, -0.851111, -0.026199>,
      < -0.307668, -1.048909, -0.179776>,
      < -0.307772, -0.873427, -0.003929>
    }
    triangle {
      < -0.077588, -0.873290, -0.003929>,
      < -0.077602, -0.850974, -0.026199>,
      < -0.307786, -0.851111, -0.026199>
    }
    triangle {
      < -0.077588, -0.873290, -0.003929>,
      < -0.307786, -0.851111, -0.026199>,
      < -0.307772, -0.873427, -0.003929>
    }
    triangle {
      < -0.077588, -0.873290, -0.003929>,
      < -0.077484, -1.048773, -0.179776>,
      < -0.077498, -1.026456, -0.202046>
    }
    triangle {
      < -0.077588, -0.873290, -0.003929>,
      < -0.077498, -1.026456, -0.202046>,
      < -0.077602, -0.850974, -0.026199>
    }
    triangle {
      < -0.077498, -1.026456, -0.202046>,
      < -0.077484, -1.048773, -0.179776>,
      < -0.307668, -1.048909, -0.179776>
    }
    triangle {
      < -0.077498, -1.026456, -0.202046>,
      < -0.307668, -1.048909, -0.179776>,
      < -0.307682, -1.026592, -0.202046>
    }
    triangle {
      < 0.249384, -0.850780, -0.026199>,
      < 0.249488, -1.026262, -0.202046>,
      < 0.019305, -1.026399, -0.202046>
    }
    triangle {
      < 0.249384, -0.850780, -0.026199>,
      < 0.019305, -1.026399, -0.202046>,
      < 0.019201, -0.850917, -0.026199>
    }
    triangle {
      < 0.019214, -0.873233, -0.003929>,
      < 0.019319, -1.048716, -0.179776>,
      < 0.249501, -1.048579, -0.179776>
    }
    triangle {
      < 0.019214, -0.873233, -0.003929>,
      < 0.249501, -1.048579, -0.179776>,
      < 0.249397, -0.873096, -0.003929>
    }
    triangle {
      < 0.019201, -0.850917, -0.026199>,
      < 0.019305, -1.026399, -0.202046>,
      < 0.019319, -1.048716, -0.179776>
    }
    triangle {
      < 0.019201, -0.850917, -0.026199>,
      < 0.019319, -1.048716, -0.179776>,
      < 0.019214, -0.873233, -0.003929>
    }
    triangle {
      < 0.249397, -0.873096, -0.003929>,
      < 0.249384, -0.850780, -0.026199>,
      < 0.019201, -0.850917, -0.026199>
    }
    triangle {
      < 0.249397, -0.873096, -0.003929>,
      < 0.019201, -0.850917, -0.026199>,
      < 0.019214, -0.873233, -0.003929>
    }
    triangle {
      < 0.249397, -0.873096, -0.003929>,
      < 0.249501, -1.048579, -0.179776>,
      < 0.249488, -1.026262, -0.202046>
    }
    triangle {
      < 0.249397, -0.873096, -0.003929>,
      < 0.249488, -1.026262, -0.202046>,
      < 0.249384, -0.850780, -0.026199>
    }
    triangle {
      < 0.249488, -1.026262, -0.202046>,
      < 0.249501, -1.048579, -0.179776>,
      < 0.019319, -1.048716, -0.179776>
    }
    triangle {
      < 0.249488, -1.026262, -0.202046>,
      < 0.019319, -1.048716, -0.179776>,
      < 0.019305, -1.026399, -0.202046>
    }
    triangle {
      < -0.077589, -0.872819, -0.401766>,
      < -0.077484, -1.048718, -0.226335>,
      < -0.307668, -1.048854, -0.226335>
    }
    triangle {
      < -0.077589, -0.872819, -0.401766>,
      < -0.307668, -1.048854, -0.226335>,
      < -0.307773, -0.872956, -0.401766>
    }
    triangle {
      < -0.307786, -0.850693, -0.379442>,
      < -0.307682, -1.026591, -0.204012>,
      < -0.077498, -1.026454, -0.204012>
    }
    triangle {
      < -0.307786, -0.850693, -0.379442>,
      < -0.077498, -1.026454, -0.204012>,
      < -0.077602, -0.850556, -0.379442>
    }
    triangle {
      < -0.307773, -0.872956, -0.401766>,
      < -0.307668, -1.048854, -0.226335>,
      < -0.307682, -1.026591, -0.204012>
    }
    triangle {
      < -0.307773, -0.872956, -0.401766>,
      < -0.307682, -1.026591, -0.204012>,
      < -0.307786, -0.850693, -0.379442>
    }
    triangle {
      < -0.077602, -0.850556, -0.379442>,
      < -0.077589, -0.872819, -0.401766>,
      < -0.307773, -0.872956, -0.401766>
    }
    triangle {
      < -0.077602, -0.850556, -0.379442>,
      < -0.307773, -0.872956, -0.401766>,
      < -0.307786, -0.850693, -0.379442>
    }
    triangle {
      < -0.077602, -0.850556, -0.379442>,
      < -0.077498, -1.026454, -0.204012>,
      < -0.077484, -1.048718, -0.226335>
    }
    triangle {
      < -0.077602, -0.850556, -0.379442>,
      < -0.077484, -1.048718, -0.226335>,
      < -0.077589, -0.872819, -0.401766>
    }
    triangle {
      < -0.077484, -1.048718, -0.226335>,
      < -0.077498, -1.026454, -0.204012>,
      < -0.307682, -1.026591, -0.204012>
    }
    triangle {
      < -0.077484, -1.048718, -0.226335>,
      < -0.307682, -1.026591, -0.204012>,
      < -0.307668, -1.048854, -0.226335>
    }
    triangle {
      < 0.249397, -0.872625, -0.401766>,
      < 0.249501, -1.048524, -0.226335>,
      < 0.019319, -1.048661, -0.226335>
    }
    triangle {
      < 0.249397, -0.872625, -0.401766>,
      < 0.019319, -1.048661, -0.226335>,
      < 0.019214, -0.872762, -0.401766>
    }
    triangle {
      < 0.019201, -0.850499, -0.379442>,
      < 0.019305, -1.026397, -0.204012>,
      < 0.249488, -1.026260, -0.204012>
    }
    triangle {
      < 0.019201, -0.850499, -0.379442>,
      < 0.249488, -1.026260, -0.204012>,
      < 0.249384, -0.850362, -0.379442>
    }
    triangle {
      < 0.019214, -0.872762, -0.401766>,
      < 0.019319, -1.048661, -0.226335>,
      < 0.019305, -1.026397, -0.204012>
    }
    triangle {
      < 0.019214, -0.872762, -0.401766>,
      < 0.019305, -1.026397, -0.204012>,
      < 0.019201, -0.850499, -0.379442>
    }
    triangle {
      < 0.249384, -0.850362, -0.379442>,
      < 0.249397, -0.872625, -0.401766>,
      < 0.019214, -0.872762, -0.401766>
    }
    triangle {
      < 0.249384, -0.850362, -0.379442>,
      < 0.019214, -0.872762, -0.401766>,
      < 0.019201, -0.850499, -0.379442>
    }
    triangle {
      < 0.249384, -0.850362, -0.379442>,
      < 0.249488, -1.026260, -0.204012>,
      < 0.249501, -1.048524, -0.226335>
    }
    triangle {
      < 0.249384, -0.850362, -0.379442>,
      < 0.249501, -1.048524, -0.226335>,
      < 0.249397, -0.872625, -0.401766>
    }
    triangle {
      < 0.249501, -1.048524, -0.226335>,
      < 0.249488, -1.026260, -0.204012>,
      < 0.019305, -1.026397, -0.204012>
    }
    triangle {
      < 0.249501, -1.048524, -0.226335>,
      < 0.019305, -1.026397, -0.204012>,
      < 0.019319, -1.048661, -0.226335>
    }
    triangle {
      < -0.077366, -1.248391, -0.380031>,
      < -0.077470, -1.073014, -0.204081>,
      < -0.307654, -1.073150, -0.204081>
    }
    triangle {
      < -0.077366, -1.248391, -0.380031>,
      < -0.307654, -1.073150, -0.204081>,
      < -0.307550, -1.248528, -0.380031>
    }
    triangle {
      < -0.307563, -1.226199, -0.402288>,
      < -0.307667, -1.050820, -0.226337>,
      < -0.077483, -1.050683, -0.226337>
    }
    triangle {
      < -0.307563, -1.226199, -0.402288>,
      < -0.077483, -1.050683, -0.226337>,
      < -0.077379, -1.226062, -0.402288>
    }
    triangle {
      < -0.307550, -1.248528, -0.380031>,
      < -0.307654, -1.073150, -0.204081>,
      < -0.307667, -1.050820, -0.226337>
    }
    triangle {
      < -0.307550, -1.248528, -0.380031>,
      < -0.307667, -1.050820, -0.226337>,
      < -0.307563, -1.226199, -0.402288>
    }
    triangle {
      < -0.077379, -1.226062, -0.402288>,
      < -0.077366, -1.248391, -0.380031>,
      < -0.307550, -1.248528, -0.380031>
    }
    triangle {
      < -0.077379, -1.226062, -0.402288>,
      < -0.307550, -1.248528, -0.380031>,
      < -0.307563, -1.226199, -0.402288>
    }
    triangle {
      < -0.077379, -1.226062, -0.402288>,
      < -0.077483, -1.050683, -0.226337>,
      < -0.077470, -1.073014, -0.204081>
    }
    triangle {
      < -0.077379, -1.226062, -0.402288>,
      < -0.077470, -1.073014, -0.204081>,
      < -0.077366, -1.248391, -0.380031>
    }
    triangle {
      < -0.077470, -1.073014, -0.204081>,
      < -0.077483, -1.050683, -0.226337>,
      < -0.307667, -1.050820, -0.226337>
    }
    triangle {
      < -0.077470, -1.073014, -0.204081>,
      < -0.307667, -1.050820, -0.226337>,
      < -0.307654, -1.073150, -0.204081>
    }
    triangle {
      < 0.249620, -1.248197, -0.380031>,
      < 0.249516, -1.072820, -0.204081>,
      < 0.019333, -1.072957, -0.204081>
    }
    triangle {
      < 0.249620, -1.248197, -0.380031>,
      < 0.019333, -1.072957, -0.204081>,
      < 0.019437, -1.248334, -0.380031>
    }
    triangle {
      < 0.019424, -1.226005, -0.402288>,
      < 0.019320, -1.050626, -0.226337>,
      < 0.249503, -1.050489, -0.226337>
    }
    triangle {
      < 0.019424, -1.226005, -0.402288>,
      < 0.249503, -1.050489, -0.226337>,
      < 0.249607, -1.225868, -0.402288>
    }
    triangle {
      < 0.019437, -1.248334, -0.380031>,
      < 0.019333, -1.072957, -0.204081>,
      < 0.019320, -1.050626, -0.226337>
    }
    triangle {
      < 0.019437, -1.248334, -0.380031>,
      < 0.019320, -1.050626, -0.226337>,
      < 0.019424, -1.226005, -0.402288>
    }
    triangle {
      < 0.249607, -1.225868, -0.402288>,
      < 0.249620, -1.248197, -0.380031>,
      < 0.019437, -1.248334, -0.380031>
    }
    triangle {
      < 0.249607, -1.225868, -0.402288>,
      < 0.019437, -1.248334, -0.380031>,
      < 0.019424, -1.226005, -0.402288>
    }
    triangle {
      < 0.249607, -1.225868, -0.402288>,
      < 0.249503, -1.050489, -0.226337>,
      < 0.249516, -1.072820, -0.204081>
    }
    triangle {
      < 0.249607, -1.225868, -0.402288>,
      < 0.249516, -1.072820, -0.204081>,
      < 0.249620, -1.248197, -0.380031>
    }
    triangle {
      < 0.249516, -1.072820, -0.204081>,
      < 0.249503, -1.050489, -0.226337>,
      < 0.019320, -1.050626, -0.226337>
    }
    triangle {
      < 0.249516, -1.072820, -0.204081>,
      < 0.019320, -1.050626, -0.226337>,
      < 0.019333, -1.072957, -0.204081>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900245, -0.402949, -4.926103>,
      < 1.900241, -0.396268, -4.935291>
    }
    triangle {
      < 1.900241, -0.396268, -4.935291>,
      < 1.900245, -0.402949, -4.926103>,
      < 1.764786, -0.403029, -4.926103>
    }
    triangle {
      < 1.900241, -0.396268, -4.935291>,
      < 1.764786, -0.403029, -4.926103>,
      < 1.764781, -0.396348, -4.935291>
    }
    triangle {
      < 1.764781, -0.396348, -4.935291>,
      < 1.764786, -0.403029, -4.926103>,
      < 1.724167, -0.435407, -4.942608>
    }
    triangle {
      < 1.764781, -0.396348, -4.935291>,
      < 1.724167, -0.435407, -4.942608>,
      < 1.724159, -0.422042, -4.960985>
    }
    triangle {
      < 1.724159, -0.422042, -4.960985>,
      < 1.724167, -0.435407, -4.942608>,
      < 1.609049, -0.475917, -4.963240>
    }
    triangle {
      < 1.724159, -0.422042, -4.960985>,
      < 1.609049, -0.475917, -4.963240>,
      < 1.609036, -0.454199, -4.993102>
    }
    triangle {
      < 1.609036, -0.454199, -4.993102>,
      < 1.609049, -0.475917, -4.963240>,
      < 0.125761, -0.476796, -4.963241>
    }
    triangle {
      < 1.609036, -0.454199, -4.993102>,
      < 0.125761, -0.476796, -4.963241>,
      < 0.125748, -0.455077, -4.993102>
    }
    triangle {
      < 0.125748, -0.455077, -4.993102>,
      < 0.125761, -0.476796, -4.963241>,
      < 0.085118, -0.468731, -4.959114>
    }
    triangle {
      < 0.125748, -0.455077, -4.993102>,
      < 0.085118, -0.468731, -4.959114>,
      < 0.085106, -0.448685, -4.986679>
    }
    triangle {
      < 0.085106, -0.448685, -4.986679>,
      < 0.085118, -0.468731, -4.959114>,
      < -0.355130, -0.464948, -4.957050>
    }
    triangle {
      < 0.085106, -0.448685, -4.986679>,
      < -0.355130, -0.464948, -4.957050>,
      < -0.355142, -0.445736, -4.983467>
    }
    triangle {
      < -0.355142, -0.445736, -4.983467>,
      < -0.355130, -0.464948, -4.957050>,
      < -0.483835, -0.436716, -4.942608>
    }
    triangle {
      < -0.355142, -0.445736, -4.983467>,
      < -0.483835, -0.436716, -4.942608>,
      < -0.483842, -0.423351, -4.960985>
    }
    triangle {
      < -0.483842, -0.423351, -4.960985>,
      < -0.483835, -0.436716, -4.942608>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900247, -0.406466, -4.915300>,
      < 1.900245, -0.402949, -4.926103>
    }
    triangle {
      < 1.900245, -0.402949, -4.926103>,
      < 1.900247, -0.406466, -4.915300>,
      < 1.764787, -0.406546, -4.915300>
    }
    triangle {
      < 1.900245, -0.402949, -4.926103>,
      < 1.764787, -0.406546, -4.915300>,
      < 1.764786, -0.403029, -4.926103>
    }
    triangle {
      < 1.764786, -0.403029, -4.926103>,
      < 1.764787, -0.406546, -4.915300>,
      < 1.724170, -0.442440, -4.921001>
    }
    triangle {
      < 1.764786, -0.403029, -4.926103>,
      < 1.724170, -0.442440, -4.921001>,
      < 1.724167, -0.435407, -4.942608>
    }
    triangle {
      < 1.724167, -0.435407, -4.942608>,
      < 1.724170, -0.442440, -4.921001>,
      < 1.609056, -0.487345, -4.928129>
    }
    triangle {
      < 1.724167, -0.435407, -4.942608>,
      < 1.609056, -0.487345, -4.928129>,
      < 1.609049, -0.475917, -4.963240>
    }
    triangle {
      < 1.609049, -0.475917, -4.963240>,
      < 1.609056, -0.487345, -4.928129>,
      < 0.125767, -0.488224, -4.928129>
    }
    triangle {
      < 1.609049, -0.475917, -4.963240>,
      < 0.125767, -0.488224, -4.928129>,
      < 0.125761, -0.476796, -4.963241>
    }
    triangle {
      < 0.125761, -0.476796, -4.963241>,
      < 0.125767, -0.488224, -4.928129>,
      < 0.085124, -0.479281, -4.926703>
    }
    triangle {
      < 0.125761, -0.476796, -4.963241>,
      < 0.085124, -0.479281, -4.926703>,
      < 0.085118, -0.468731, -4.959114>
    }
    triangle {
      < 0.085118, -0.468731, -4.959114>,
      < 0.085124, -0.479281, -4.926703>,
      < -0.355124, -0.475058, -4.925991>
    }
    triangle {
      < 0.085118, -0.468731, -4.959114>,
      < -0.355124, -0.475058, -4.925991>,
      < -0.355130, -0.464948, -4.957050>
    }
    triangle {
      < -0.355130, -0.464948, -4.957050>,
      < -0.355124, -0.475058, -4.925991>,
      < -0.483830, -0.443749, -4.921001>
    }
    triangle {
      < -0.355130, -0.464948, -4.957050>,
      < -0.483830, -0.443749, -4.921001>,
      < -0.483835, -0.436716, -4.942608>
    }
    triangle {
      < -0.483835, -0.436716, -4.942608>,
      < -0.483830, -0.443749, -4.921001>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900247, -0.406472, -4.903938>,
      < 1.900247, -0.406466, -4.915300>
    }
    triangle {
      < 1.900247, -0.406466, -4.915300>,
      < 1.900247, -0.406472, -4.903938>,
      < 1.764787, -0.406552, -4.903938>
    }
    triangle {
      < 1.900247, -0.406466, -4.915300>,
      < 1.764787, -0.406552, -4.903938>,
      < 1.764787, -0.406546, -4.915300>
    }
    triangle {
      < 1.764787, -0.406546, -4.915300>,
      < 1.764787, -0.406552, -4.903938>,
      < 1.724170, -0.442454, -4.898279>
    }
    triangle {
      < 1.764787, -0.406546, -4.915300>,
      < 1.724170, -0.442454, -4.898279>,
      < 1.724170, -0.442440, -4.921001>
    }
    triangle {
      < 1.724170, -0.442440, -4.921001>,
      < 1.724170, -0.442454, -4.898279>,
      < 1.609056, -0.487368, -4.891204>
    }
    triangle {
      < 1.724170, -0.442440, -4.921001>,
      < 1.609056, -0.487368, -4.891204>,
      < 1.609056, -0.487345, -4.928129>
    }
    triangle {
      < 1.609056, -0.487345, -4.928129>,
      < 1.609056, -0.487368, -4.891204>,
      < 0.125767, -0.488246, -4.891205>
    }
    triangle {
      < 1.609056, -0.487345, -4.928129>,
      < 0.125767, -0.488246, -4.891205>,
      < 0.125767, -0.488224, -4.928129>
    }
    triangle {
      < 0.125767, -0.488224, -4.928129>,
      < 0.125767, -0.488246, -4.891205>,
      < 0.085124, -0.479301, -4.892620>
    }
    triangle {
      < 0.125767, -0.488224, -4.928129>,
      < 0.085124, -0.479301, -4.892620>,
      < 0.085124, -0.479281, -4.926703>
    }
    triangle {
      < 0.085124, -0.479281, -4.926703>,
      < 0.085124, -0.479301, -4.892620>,
      < -0.355124, -0.475078, -4.893328>
    }
    triangle {
      < 0.085124, -0.479281, -4.926703>,
      < -0.355124, -0.475078, -4.893328>,
      < -0.355124, -0.475058, -4.925991>
    }
    triangle {
      < -0.355124, -0.475058, -4.925991>,
      < -0.355124, -0.475078, -4.893328>,
      < -0.483830, -0.443763, -4.898280>
    }
    triangle {
      < -0.355124, -0.475058, -4.925991>,
      < -0.483830, -0.443763, -4.898280>,
      < -0.483830, -0.443749, -4.921001>
    }
    triangle {
      < -0.483830, -0.443749, -4.921001>,
      < -0.483830, -0.443763, -4.898280>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900245, -0.402969, -4.893131>,
      < 1.900247, -0.406472, -4.903938>
    }
    triangle {
      < 1.900247, -0.406472, -4.903938>,
      < 1.900245, -0.402969, -4.893131>,
      < 1.764786, -0.403049, -4.893131>
    }
    triangle {
      < 1.900247, -0.406472, -4.903938>,
      < 1.764786, -0.403049, -4.893131>,
      < 1.764787, -0.406552, -4.903938>
    }
    triangle {
      < 1.764787, -0.406552, -4.903938>,
      < 1.764786, -0.403049, -4.893131>,
      < 1.724167, -0.435446, -4.876663>
    }
    triangle {
      < 1.764787, -0.406552, -4.903938>,
      < 1.724167, -0.435446, -4.876663>,
      < 1.724170, -0.442454, -4.898279>
    }
    triangle {
      < 1.724170, -0.442454, -4.898279>,
      < 1.724167, -0.435446, -4.876663>,
      < 1.609050, -0.475981, -4.856080>
    }
    triangle {
      < 1.724170, -0.442454, -4.898279>,
      < 1.609050, -0.475981, -4.856080>,
      < 1.609056, -0.487368, -4.891204>
    }
    triangle {
      < 1.609056, -0.487368, -4.891204>,
      < 1.609050, -0.475981, -4.856080>,
      < 0.125761, -0.476859, -4.856080>
    }
    triangle {
      < 1.609056, -0.487368, -4.891204>,
      < 0.125761, -0.476859, -4.856080>,
      < 0.125767, -0.488246, -4.891205>
    }
    triangle {
      < 0.125767, -0.488246, -4.891205>,
      < 0.125761, -0.476859, -4.856080>,
      < 0.085118, -0.468790, -4.860198>
    }
    triangle {
      < 0.125767, -0.488246, -4.891205>,
      < 0.085118, -0.468790, -4.860198>,
      < 0.085124, -0.479301, -4.892620>
    }
    triangle {
      < 0.085124, -0.479301, -4.892620>,
      < 0.085118, -0.468790, -4.860198>,
      < -0.355130, -0.465004, -4.862256>
    }
    triangle {
      < 0.085124, -0.479301, -4.892620>,
      < -0.355130, -0.465004, -4.862256>,
      < -0.355124, -0.475078, -4.893328>
    }
    triangle {
      < -0.355124, -0.475078, -4.893328>,
      < -0.355130, -0.465004, -4.862256>,
      < -0.483835, -0.436754, -4.876664>
    }
    triangle {
      < -0.355124, -0.475078, -4.893328>,
      < -0.483835, -0.436754, -4.876664>,
      < -0.483830, -0.443763, -4.898280>
    }
    triangle {
      < -0.483830, -0.443763, -4.898280>,
      < -0.483835, -0.436754, -4.876664>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900241, -0.396297, -4.883934>,
      < 1.900245, -0.402969, -4.893131>
    }
    triangle {
      < 1.900245, -0.402969, -4.893131>,
      < 1.900241, -0.396297, -4.883934>,
      < 1.764781, -0.396377, -4.883934>
    }
    triangle {
      < 1.900245, -0.402969, -4.893131>,
      < 1.764781, -0.396377, -4.883934>,
      < 1.764786, -0.403049, -4.893131>
    }
    triangle {
      < 1.764786, -0.403049, -4.893131>,
      < 1.764781, -0.396377, -4.883934>,
      < 1.724159, -0.422103, -4.858272>
    }
    triangle {
      < 1.764786, -0.403049, -4.893131>,
      < 1.724159, -0.422103, -4.858272>,
      < 1.724167, -0.435446, -4.876663>
    }
    triangle {
      < 1.724167, -0.435446, -4.876663>,
      < 1.724159, -0.422103, -4.858272>,
      < 1.609036, -0.454299, -4.826192>
    }
    triangle {
      < 1.724167, -0.435446, -4.876663>,
      < 1.609036, -0.454299, -4.826192>,
      < 1.609050, -0.475981, -4.856080>
    }
    triangle {
      < 1.609050, -0.475981, -4.856080>,
      < 1.609036, -0.454299, -4.826192>,
      < 0.125748, -0.455177, -4.826193>
    }
    triangle {
      < 1.609050, -0.475981, -4.856080>,
      < 0.125748, -0.455177, -4.826193>,
      < 0.125761, -0.476859, -4.856080>
    }
    triangle {
      < 0.125761, -0.476859, -4.856080>,
      < 0.125748, -0.455177, -4.826193>,
      < 0.085106, -0.448775, -4.832608>
    }
    triangle {
      < 0.125761, -0.476859, -4.856080>,
      < 0.085106, -0.448775, -4.832608>,
      < 0.085118, -0.468790, -4.860198>
    }
    triangle {
      < 0.085118, -0.468790, -4.860198>,
      < 0.085106, -0.448775, -4.832608>,
      < -0.355142, -0.445824, -4.835817>
    }
    triangle {
      < 0.085118, -0.468790, -4.860198>,
      < -0.355142, -0.445824, -4.835817>,
      < -0.355130, -0.465004, -4.862256>
    }
    triangle {
      < -0.355130, -0.465004, -4.862256>,
      < -0.355142, -0.445824, -4.835817>,
      < -0.483842, -0.423412, -4.858272>
    }
    triangle {
      < -0.355130, -0.465004, -4.862256>,
      < -0.483842, -0.423412, -4.858272>,
      < -0.483835, -0.436754, -4.876664>
    }
    triangle {
      < -0.483835, -0.436754, -4.876664>,
      < -0.483842, -0.423412, -4.858272>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900236, -0.387112, -4.877249>,
      < 1.900241, -0.396297, -4.883934>
    }
    triangle {
      < 1.900241, -0.396297, -4.883934>,
      < 1.900236, -0.387112, -4.877249>,
      < 1.764776, -0.387192, -4.877249>
    }
    triangle {
      < 1.900241, -0.396297, -4.883934>,
      < 1.764776, -0.387192, -4.877249>,
      < 1.764781, -0.396377, -4.883934>
    }
    triangle {
      < 1.764781, -0.396377, -4.883934>,
      < 1.764776, -0.387192, -4.877249>,
      < 1.724148, -0.403730, -4.844901>
    }
    triangle {
      < 1.764781, -0.396377, -4.883934>,
      < 1.724148, -0.403730, -4.844901>,
      < 1.724159, -0.422103, -4.858272>
    }
    triangle {
      < 1.724159, -0.422103, -4.858272>,
      < 1.724148, -0.403730, -4.844901>,
      < 1.609019, -0.424443, -4.804465>
    }
    triangle {
      < 1.724159, -0.422103, -4.858272>,
      < 1.609019, -0.424443, -4.804465>,
      < 1.609036, -0.454299, -4.826192>
    }
    triangle {
      < 1.609036, -0.454299, -4.826192>,
      < 1.609019, -0.424443, -4.804465>,
      < 0.125730, -0.425321, -4.804466>
    }
    triangle {
      < 1.609036, -0.454299, -4.826192>,
      < 0.125730, -0.425321, -4.804466>,
      < 0.125748, -0.455177, -4.826193>
    }
    triangle {
      < 0.125748, -0.455177, -4.826193>,
      < 0.125730, -0.425321, -4.804466>,
      < 0.085090, -0.421217, -4.812552>
    }
    triangle {
      < 0.125748, -0.455177, -4.826193>,
      < 0.085090, -0.421217, -4.812552>,
      < 0.085106, -0.448775, -4.832608>
    }
    triangle {
      < 0.085106, -0.448775, -4.832608>,
      < 0.085090, -0.421217, -4.812552>,
      < -0.355157, -0.419413, -4.816597>
    }
    triangle {
      < 0.085106, -0.448775, -4.832608>,
      < -0.355157, -0.419413, -4.816597>,
      < -0.355142, -0.445824, -4.835817>
    }
    triangle {
      < -0.355142, -0.445824, -4.835817>,
      < -0.355157, -0.419413, -4.816597>,
      < -0.483853, -0.405039, -4.844902>
    }
    triangle {
      < -0.355142, -0.445824, -4.835817>,
      < -0.483853, -0.405039, -4.844902>,
      < -0.483842, -0.423412, -4.858272>
    }
    triangle {
      < -0.483842, -0.423412, -4.858272>,
      < -0.483853, -0.405039, -4.844902>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900229, -0.376309, -4.873730>,
      < 1.900236, -0.387112, -4.877249>
    }
    triangle {
      < 1.900236, -0.387112, -4.877249>,
      < 1.900229, -0.376309, -4.873730>,
      < 1.764769, -0.376390, -4.873730>
    }
    triangle {
      < 1.900236, -0.387112, -4.877249>,
      < 1.764769, -0.376390, -4.873730>,
      < 1.764776, -0.387192, -4.877249>
    }
    triangle {
      < 1.764776, -0.387192, -4.877249>,
      < 1.764769, -0.376390, -4.873730>,
      < 1.724135, -0.382126, -4.837862>
    }
    triangle {
      < 1.764776, -0.387192, -4.877249>,
      < 1.724135, -0.382126, -4.837862>,
      < 1.724148, -0.403730, -4.844901>
    }
    triangle {
      < 1.724148, -0.403730, -4.844901>,
      < 1.724135, -0.382126, -4.837862>,
      < 1.608998, -0.389335, -4.793026>
    }
    triangle {
      < 1.724148, -0.403730, -4.844901>,
      < 1.608998, -0.389335, -4.793026>,
      < 1.609019, -0.424443, -4.804465>
    }
    triangle {
      < 1.609019, -0.424443, -4.804465>,
      < 1.608998, -0.389335, -4.793026>,
      < 0.125709, -0.390213, -4.793026>
    }
    triangle {
      < 1.609019, -0.424443, -4.804465>,
      < 0.125709, -0.390213, -4.793026>,
      < 0.125730, -0.425321, -4.804466>
    }
    triangle {
      < 0.125730, -0.425321, -4.804466>,
      < 0.125709, -0.390213, -4.793026>,
      < 0.085071, -0.388809, -4.801995>
    }
    triangle {
      < 0.125730, -0.425321, -4.804466>,
      < 0.085071, -0.388809, -4.801995>,
      < 0.085090, -0.421217, -4.812552>
    }
    triangle {
      < 0.085090, -0.421217, -4.812552>,
      < 0.085071, -0.388809, -4.801995>,
      < -0.355176, -0.388356, -4.806478>
    }
    triangle {
      < 0.085090, -0.421217, -4.812552>,
      < -0.355176, -0.388356, -4.806478>,
      < -0.355157, -0.419413, -4.816597>
    }
    triangle {
      < -0.355157, -0.419413, -4.816597>,
      < -0.355176, -0.388356, -4.806478>,
      < -0.483866, -0.383435, -4.837862>
    }
    triangle {
      < -0.355157, -0.419413, -4.816597>,
      < -0.483866, -0.383435, -4.837862>,
      < -0.483853, -0.405039, -4.844902>
    }
    triangle {
      < -0.483853, -0.405039, -4.844902>,
      < -0.483866, -0.383435, -4.837862>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900222, -0.364948, -4.873719>,
      < 1.900229, -0.376309, -4.873730>
    }
    triangle {
      < 1.900229, -0.376309, -4.873730>,
      < 1.900222, -0.364948, -4.873719>,
      < 1.764762, -0.365028, -4.873719>
    }
    triangle {
      < 1.900229, -0.376309, -4.873730>,
      < 1.764762, -0.365028, -4.873719>,
      < 1.764769, -0.376390, -4.873730>
    }
    triangle {
      < 1.764769, -0.376390, -4.873730>,
      < 1.764762, -0.365028, -4.873719>,
      < 1.724122, -0.359403, -4.837841>
    }
    triangle {
      < 1.764769, -0.376390, -4.873730>,
      < 1.724122, -0.359403, -4.837841>,
      < 1.724135, -0.382126, -4.837862>
    }
    triangle {
      < 1.724135, -0.382126, -4.837862>,
      < 1.724122, -0.359403, -4.837841>,
      < 1.608976, -0.352410, -4.792994>
    }
    triangle {
      < 1.724135, -0.382126, -4.837862>,
      < 1.608976, -0.352410, -4.792994>,
      < 1.608998, -0.389335, -4.793026>
    }
    triangle {
      < 1.608998, -0.389335, -4.793026>,
      < 1.608976, -0.352410, -4.792994>,
      < 0.125687, -0.353289, -4.792994>
    }
    triangle {
      < 1.608998, -0.389335, -4.793026>,
      < 0.125687, -0.353289, -4.792994>,
      < 0.125709, -0.390213, -4.793026>
    }
    triangle {
      < 0.125709, -0.390213, -4.793026>,
      < 0.125687, -0.353289, -4.792994>,
      < 0.085050, -0.354725, -4.801963>
    }
    triangle {
      < 0.125709, -0.390213, -4.793026>,
      < 0.085050, -0.354725, -4.801963>,
      < 0.085071, -0.388809, -4.801995>
    }
    triangle {
      < 0.085071, -0.388809, -4.801995>,
      < 0.085050, -0.354725, -4.801963>,
      < -0.355195, -0.355692, -4.806449>
    }
    triangle {
      < 0.085071, -0.388809, -4.801995>,
      < -0.355195, -0.355692, -4.806449>,
      < -0.355176, -0.388356, -4.806478>
    }
    triangle {
      < -0.355176, -0.388356, -4.806478>,
      < -0.355195, -0.355692, -4.806449>,
      < -0.483880, -0.360711, -4.837841>
    }
    triangle {
      < -0.355176, -0.388356, -4.806478>,
      < -0.483880, -0.360711, -4.837841>,
      < -0.483866, -0.383435, -4.837862>
    }
    triangle {
      < -0.483866, -0.383435, -4.837862>,
      < -0.483880, -0.360711, -4.837841>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900216, -0.354140, -4.877220>,
      < 1.900222, -0.364948, -4.873719>
    }
    triangle {
      < 1.900222, -0.364948, -4.873719>,
      < 1.900216, -0.354140, -4.877220>,
      < 1.764756, -0.354220, -4.877220>
    }
    triangle {
      < 1.900222, -0.364948, -4.873719>,
      < 1.764756, -0.354220, -4.877220>,
      < 1.764762, -0.365028, -4.873719>
    }
    triangle {
      < 1.764762, -0.365028, -4.873719>,
      < 1.764756, -0.354220, -4.877220>,
      < 1.724109, -0.337786, -4.844843>
    }
    triangle {
      < 1.764762, -0.365028, -4.873719>,
      < 1.724109, -0.337786, -4.844843>,
      < 1.724122, -0.359403, -4.837841>
    }
    triangle {
      < 1.724122, -0.359403, -4.837841>,
      < 1.724109, -0.337786, -4.844843>,
      < 1.608955, -0.317283, -4.804370>
    }
    triangle {
      < 1.724122, -0.359403, -4.837841>,
      < 1.608955, -0.317283, -4.804370>,
      < 1.608976, -0.352410, -4.792994>
    }
    triangle {
      < 1.608976, -0.352410, -4.792994>,
      < 1.608955, -0.317283, -4.804370>,
      < 0.125666, -0.318161, -4.804371>
    }
    triangle {
      < 1.608976, -0.352410, -4.792994>,
      < 0.125666, -0.318161, -4.804371>,
      < 0.125687, -0.353289, -4.792994>
    }
    triangle {
      < 0.125687, -0.353289, -4.792994>,
      < 0.125666, -0.318161, -4.804371>,
      < 0.085031, -0.322300, -4.812465>
    }
    triangle {
      < 0.125687, -0.353289, -4.792994>,
      < 0.085031, -0.322300, -4.812465>,
      < 0.085050, -0.354725, -4.801963>
    }
    triangle {
      < 0.085050, -0.354725, -4.801963>,
      < 0.085031, -0.322300, -4.812465>,
      < -0.355214, -0.324618, -4.816514>
    }
    triangle {
      < 0.085050, -0.354725, -4.801963>,
      < -0.355214, -0.324618, -4.816514>,
      < -0.355195, -0.355692, -4.806449>
    }
    triangle {
      < -0.355195, -0.355692, -4.806449>,
      < -0.355214, -0.324618, -4.816514>,
      < -0.483892, -0.339095, -4.844843>
    }
    triangle {
      < -0.355195, -0.355692, -4.806449>,
      < -0.483892, -0.339095, -4.844843>,
      < -0.483880, -0.360711, -4.837841>
    }
    triangle {
      < -0.483880, -0.360711, -4.837841>,
      < -0.483892, -0.339095, -4.844843>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900210, -0.344941, -4.883889>,
      < 1.900216, -0.354140, -4.877220>
    }
    triangle {
      < 1.900216, -0.354140, -4.877220>,
      < 1.900210, -0.344941, -4.883889>,
      < 1.764751, -0.345021, -4.883889>
    }
    triangle {
      < 1.900216, -0.354140, -4.877220>,
      < 1.764751, -0.345021, -4.883889>,
      < 1.764756, -0.354220, -4.877220>
    }
    triangle {
      < 1.764756, -0.354220, -4.877220>,
      < 1.764751, -0.345021, -4.883889>,
      < 1.724097, -0.319390, -4.858180>
    }
    triangle {
      < 1.764756, -0.354220, -4.877220>,
      < 1.724097, -0.319390, -4.858180>,
      < 1.724109, -0.337786, -4.844843>
    }
    triangle {
      < 1.724109, -0.337786, -4.844843>,
      < 1.724097, -0.319390, -4.858180>,
      < 1.608937, -0.287388, -4.826044>
    }
    triangle {
      < 1.724109, -0.337786, -4.844843>,
      < 1.608937, -0.287388, -4.826044>,
      < 1.608955, -0.317283, -4.804370>
    }
    triangle {
      < 1.608955, -0.317283, -4.804370>,
      < 1.608937, -0.287388, -4.826044>,
      < 0.125649, -0.288267, -4.826044>
    }
    triangle {
      < 1.608955, -0.317283, -4.804370>,
      < 0.125649, -0.288267, -4.826044>,
      < 0.125666, -0.318161, -4.804371>
    }
    triangle {
      < 0.125666, -0.318161, -4.804371>,
      < 0.125649, -0.288267, -4.826044>,
      < 0.085015, -0.294705, -4.832471>
    }
    triangle {
      < 0.125666, -0.318161, -4.804371>,
      < 0.085015, -0.294705, -4.832471>,
      < 0.085031, -0.322300, -4.812465>
    }
    triangle {
      < 0.085031, -0.322300, -4.812465>,
      < 0.085015, -0.294705, -4.832471>,
      < -0.355229, -0.298173, -4.835685>
    }
    triangle {
      < 0.085031, -0.322300, -4.812465>,
      < -0.355229, -0.298173, -4.835685>,
      < -0.355214, -0.324618, -4.816514>
    }
    triangle {
      < -0.355214, -0.324618, -4.816514>,
      < -0.355229, -0.298173, -4.835685>,
      < -0.483903, -0.320699, -4.858180>
    }
    triangle {
      < -0.355214, -0.324618, -4.816514>,
      < -0.483903, -0.320699, -4.858180>,
      < -0.483892, -0.339095, -4.844843>
    }
    triangle {
      < -0.483892, -0.339095, -4.844843>,
      < -0.483903, -0.320699, -4.858180>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900207, -0.338253, -4.893073>,
      < 1.900210, -0.344941, -4.883889>
    }
    triangle {
      < 1.900210, -0.344941, -4.883889>,
      < 1.900207, -0.338253, -4.893073>,
      < 1.764747, -0.338333, -4.893073>
    }
    triangle {
      < 1.900210, -0.344941, -4.883889>,
      < 1.764747, -0.338333, -4.893073>,
      < 1.764751, -0.345021, -4.883889>
    }
    triangle {
      < 1.764751, -0.345021, -4.883889>,
      < 1.764747, -0.338333, -4.893073>,
      < 1.724090, -0.306014, -4.876548>
    }
    triangle {
      < 1.764751, -0.345021, -4.883889>,
      < 1.724090, -0.306014, -4.876548>,
      < 1.724097, -0.319390, -4.858180>
    }
    triangle {
      < 1.724097, -0.319390, -4.858180>,
      < 1.724090, -0.306014, -4.876548>,
      < 1.608925, -0.265653, -4.855893>
    }
    triangle {
      < 1.724097, -0.319390, -4.858180>,
      < 1.608925, -0.265653, -4.855893>,
      < 1.608937, -0.287388, -4.826044>
    }
    triangle {
      < 1.608937, -0.287388, -4.826044>,
      < 1.608925, -0.265653, -4.855893>,
      < 0.125636, -0.266532, -4.855893>
    }
    triangle {
      < 1.608937, -0.287388, -4.826044>,
      < 0.125636, -0.266532, -4.855893>,
      < 0.125649, -0.288267, -4.826044>
    }
    triangle {
      < 0.125649, -0.288267, -4.826044>,
      < 0.125636, -0.266532, -4.855893>,
      < 0.085003, -0.274642, -4.860025>
    }
    triangle {
      < 0.125649, -0.288267, -4.826044>,
      < 0.085003, -0.274642, -4.860025>,
      < 0.085015, -0.294705, -4.832471>
    }
    triangle {
      < 0.085015, -0.294705, -4.832471>,
      < 0.085003, -0.274642, -4.860025>,
      < -0.355241, -0.278946, -4.862090>
    }
    triangle {
      < 0.085015, -0.294705, -4.832471>,
      < -0.355241, -0.278946, -4.862090>,
      < -0.355229, -0.298173, -4.835685>
    }
    triangle {
      < -0.355229, -0.298173, -4.835685>,
      < -0.355241, -0.278946, -4.862090>,
      < -0.483911, -0.307323, -4.876549>
    }
    triangle {
      < -0.355229, -0.298173, -4.835685>,
      < -0.483911, -0.307323, -4.876549>,
      < -0.483903, -0.320699, -4.858180>
    }
    triangle {
      < -0.483903, -0.320699, -4.858180>,
      < -0.483911, -0.307323, -4.876549>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900204, -0.334730, -4.903875>,
      < 1.900207, -0.338253, -4.893073>
    }
    triangle {
      < 1.900207, -0.338253, -4.893073>,
      < 1.900204, -0.334730, -4.903875>,
      < 1.764745, -0.334810, -4.903875>
    }
    triangle {
      < 1.900207, -0.338253, -4.893073>,
      < 1.764745, -0.334810, -4.903875>,
      < 1.764747, -0.338333, -4.893073>
    }
    triangle {
      < 1.764747, -0.338333, -4.893073>,
      < 1.764745, -0.334810, -4.903875>,
      < 1.724086, -0.298968, -4.898151>
    }
    triangle {
      < 1.764747, -0.338333, -4.893073>,
      < 1.724086, -0.298968, -4.898151>,
      < 1.724090, -0.306014, -4.876548>
    }
    triangle {
      < 1.724090, -0.306014, -4.876548>,
      < 1.724086, -0.298968, -4.898151>,
      < 1.608918, -0.254203, -4.890998>
    }
    triangle {
      < 1.724090, -0.306014, -4.876548>,
      < 1.608918, -0.254203, -4.890998>,
      < 1.608925, -0.265653, -4.855893>
    }
    triangle {
      < 1.608925, -0.265653, -4.855893>,
      < 1.608918, -0.254203, -4.890998>,
      < 0.125629, -0.255082, -4.890998>
    }
    triangle {
      < 1.608925, -0.265653, -4.855893>,
      < 0.125629, -0.255082, -4.890998>,
      < 0.125636, -0.266532, -4.855893>
    }
    triangle {
      < 0.125636, -0.266532, -4.855893>,
      < 0.125629, -0.255082, -4.890998>,
      < 0.084997, -0.264073, -4.892428>
    }
    triangle {
      < 0.125636, -0.266532, -4.855893>,
      < 0.084997, -0.264073, -4.892428>,
      < 0.085003, -0.274642, -4.860025>
    }
    triangle {
      < 0.085003, -0.274642, -4.860025>,
      < 0.084997, -0.264073, -4.892428>,
      < -0.355246, -0.268817, -4.893144>
    }
    triangle {
      < 0.085003, -0.274642, -4.860025>,
      < -0.355246, -0.268817, -4.893144>,
      < -0.355241, -0.278946, -4.862090>
    }
    triangle {
      < -0.355241, -0.278946, -4.862090>,
      < -0.355246, -0.268817, -4.893144>,
      < -0.483915, -0.300276, -4.898151>
    }
    triangle {
      < -0.355241, -0.278946, -4.862090>,
      < -0.483915, -0.300276, -4.898151>,
      < -0.483911, -0.307323, -4.876549>
    }
    triangle {
      < -0.483911, -0.307323, -4.876549>,
      < -0.483915, -0.300276, -4.898151>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900204, -0.334716, -4.915236>,
      < 1.900204, -0.334730, -4.903875>
    }
    triangle {
      < 1.900204, -0.334730, -4.903875>,
      < 1.900204, -0.334716, -4.915236>,
      < 1.764745, -0.334796, -4.915236>
    }
    triangle {
      < 1.900204, -0.334730, -4.903875>,
      < 1.764745, -0.334796, -4.915236>,
      < 1.764745, -0.334810, -4.903875>
    }
    triangle {
      < 1.764745, -0.334810, -4.903875>,
      < 1.764745, -0.334796, -4.915236>,
      < 1.724086, -0.298941, -4.920874>
    }
    triangle {
      < 1.764745, -0.334810, -4.903875>,
      < 1.724086, -0.298941, -4.920874>,
      < 1.724086, -0.298968, -4.898151>
    }
    triangle {
      < 1.724086, -0.298968, -4.898151>,
      < 1.724086, -0.298941, -4.920874>,
      < 1.608917, -0.254160, -4.927921>
    }
    triangle {
      < 1.724086, -0.298968, -4.898151>,
      < 1.608917, -0.254160, -4.927921>,
      < 1.608918, -0.254203, -4.890998>
    }
    triangle {
      < 1.608918, -0.254203, -4.890998>,
      < 1.608917, -0.254160, -4.927921>,
      < 0.125629, -0.255038, -4.927922>
    }
    triangle {
      < 1.608918, -0.254203, -4.890998>,
      < 0.125629, -0.255038, -4.927922>,
      < 0.125629, -0.255082, -4.890998>
    }
    triangle {
      < 0.125629, -0.255082, -4.890998>,
      < 0.125629, -0.255038, -4.927922>,
      < 0.084997, -0.264033, -4.926512>
    }
    triangle {
      < 0.125629, -0.255082, -4.890998>,
      < 0.084997, -0.264033, -4.926512>,
      < 0.084997, -0.264073, -4.892428>
    }
    triangle {
      < 0.084997, -0.264073, -4.892428>,
      < 0.084997, -0.264033, -4.926512>,
      < -0.355246, -0.268778, -4.925808>
    }
    triangle {
      < 0.084997, -0.264073, -4.892428>,
      < -0.355246, -0.268778, -4.925808>,
      < -0.355246, -0.268817, -4.893144>
    }
    triangle {
      < -0.355246, -0.268817, -4.893144>,
      < -0.355246, -0.268778, -4.925808>,
      < -0.483916, -0.300250, -4.920875>
    }
    triangle {
      < -0.355246, -0.268817, -4.893144>,
      < -0.483916, -0.300250, -4.920875>,
      < -0.483915, -0.300276, -4.898151>
    }
    triangle {
      < -0.483915, -0.300276, -4.898151>,
      < -0.483916, -0.300250, -4.920875>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900207, -0.338214, -4.926044>,
      < 1.900204, -0.334716, -4.915236>
    }
    triangle {
      < 1.900204, -0.334716, -4.915236>,
      < 1.900207, -0.338214, -4.926044>,
      < 1.764747, -0.338294, -4.926044>
    }
    triangle {
      < 1.900204, -0.334716, -4.915236>,
      < 1.764747, -0.338294, -4.926044>,
      < 1.764745, -0.334796, -4.915236>
    }
    triangle {
      < 1.764745, -0.334796, -4.915236>,
      < 1.764747, -0.338294, -4.926044>,
      < 1.724090, -0.305936, -4.942493>
    }
    triangle {
      < 1.764745, -0.334796, -4.915236>,
      < 1.724090, -0.305936, -4.942493>,
      < 1.724086, -0.298941, -4.920874>
    }
    triangle {
      < 1.724086, -0.298941, -4.920874>,
      < 1.724090, -0.305936, -4.942493>,
      < 1.608925, -0.265526, -4.963052>
    }
    triangle {
      < 1.724086, -0.298941, -4.920874>,
      < 1.608925, -0.265526, -4.963052>,
      < 1.608917, -0.254160, -4.927921>
    }
    triangle {
      < 1.608917, -0.254160, -4.927921>,
      < 1.608925, -0.265526, -4.963052>,
      < 0.125636, -0.266405, -4.963052>
    }
    triangle {
      < 1.608917, -0.254160, -4.927921>,
      < 0.125636, -0.266405, -4.963052>,
      < 0.125629, -0.255038, -4.927922>
    }
    triangle {
      < 0.125629, -0.255038, -4.927922>,
      < 0.125636, -0.266405, -4.963052>,
      < 0.085003, -0.274524, -4.958941>
    }
    triangle {
      < 0.125629, -0.255038, -4.927922>,
      < 0.085003, -0.274524, -4.958941>,
      < 0.084997, -0.264033, -4.926512>
    }
    triangle {
      < 0.084997, -0.264033, -4.926512>,
      < 0.085003, -0.274524, -4.958941>,
      < -0.355241, -0.278834, -4.956885>
    }
    triangle {
      < 0.084997, -0.264033, -4.926512>,
      < -0.355241, -0.278834, -4.956885>,
      < -0.355246, -0.268778, -4.925808>
    }
    triangle {
      < -0.355246, -0.268778, -4.925808>,
      < -0.355241, -0.278834, -4.956885>,
      < -0.483911, -0.307245, -4.942494>
    }
    triangle {
      < -0.355246, -0.268778, -4.925808>,
      < -0.483911, -0.307245, -4.942494>,
      < -0.483916, -0.300250, -4.920875>
    }
    triangle {
      < -0.483916, -0.300250, -4.920875>,
      < -0.483911, -0.307245, -4.942494>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900210, -0.344880, -4.935246>,
      < 1.900207, -0.338214, -4.926044>
    }
    triangle {
      < 1.900207, -0.338214, -4.926044>,
      < 1.900210, -0.344880, -4.935246>,
      < 1.764751, -0.344960, -4.935246>
    }
    triangle {
      < 1.900207, -0.338214, -4.926044>,
      < 1.764751, -0.344960, -4.935246>,
      < 1.764747, -0.338294, -4.926044>
    }
    triangle {
      < 1.764747, -0.338294, -4.926044>,
      < 1.764751, -0.344960, -4.935246>,
      < 1.724097, -0.319268, -4.960893>
    }
    triangle {
      < 1.764747, -0.338294, -4.926044>,
      < 1.724097, -0.319268, -4.960893>,
      < 1.724090, -0.305936, -4.942493>
    }
    triangle {
      < 1.724090, -0.305936, -4.942493>,
      < 1.724097, -0.319268, -4.960893>,
      < 1.608937, -0.287191, -4.992953>
    }
    triangle {
      < 1.724090, -0.305936, -4.942493>,
      < 1.608937, -0.287191, -4.992953>,
      < 1.608925, -0.265526, -4.963052>
    }
    triangle {
      < 1.608925, -0.265526, -4.963052>,
      < 1.608937, -0.287191, -4.992953>,
      < 0.125649, -0.288070, -4.992953>
    }
    triangle {
      < 1.608925, -0.265526, -4.963052>,
      < 0.125649, -0.288070, -4.992953>,
      < 0.125636, -0.266405, -4.963052>
    }
    triangle {
      < 0.125636, -0.266405, -4.963052>,
      < 0.125649, -0.288070, -4.992953>,
      < 0.085015, -0.294523, -4.986542>
    }
    triangle {
      < 0.125636, -0.266405, -4.963052>,
      < 0.085015, -0.294523, -4.986542>,
      < 0.085003, -0.274524, -4.958941>
    }
    triangle {
      < 0.085003, -0.274524, -4.958941>,
      < 0.085015, -0.294523, -4.986542>,
      < -0.355229, -0.297998, -4.983335>
    }
    triangle {
      < 0.085003, -0.274524, -4.958941>,
      < -0.355229, -0.297998, -4.983335>,
      < -0.355241, -0.278834, -4.956885>
    }
    triangle {
      < -0.355241, -0.278834, -4.956885>,
      < -0.355229, -0.297998, -4.983335>,
      < -0.483903, -0.320576, -4.960894>
    }
    triangle {
      < -0.355241, -0.278834, -4.956885>,
      < -0.483903, -0.320576, -4.960894>,
      < -0.483911, -0.307245, -4.942494>
    }
    triangle {
      < -0.483911, -0.307245, -4.942494>,
      < -0.483903, -0.320576, -4.960894>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900216, -0.354062, -4.941936>,
      < 1.900210, -0.344880, -4.935246>
    }
    triangle {
      < 1.900210, -0.344880, -4.935246>,
      < 1.900216, -0.354062, -4.941936>,
      < 1.764756, -0.354142, -4.941936>
    }
    triangle {
      < 1.900210, -0.344880, -4.935246>,
      < 1.764756, -0.354142, -4.941936>,
      < 1.764751, -0.344960, -4.935246>
    }
    triangle {
      < 1.764751, -0.344960, -4.935246>,
      < 1.764756, -0.354142, -4.941936>,
      < 1.724108, -0.337633, -4.974275>
    }
    triangle {
      < 1.764751, -0.344960, -4.935246>,
      < 1.724108, -0.337633, -4.974275>,
      < 1.724097, -0.319268, -4.960893>
    }
    triangle {
      < 1.724097, -0.319268, -4.960893>,
      < 1.724108, -0.337633, -4.974275>,
      < 1.608955, -0.317033, -5.014698>
    }
    triangle {
      < 1.724097, -0.319268, -4.960893>,
      < 1.608955, -0.317033, -5.014698>,
      < 1.608937, -0.287191, -4.992953>
    }
    triangle {
      < 1.608937, -0.287191, -4.992953>,
      < 1.608955, -0.317033, -5.014698>,
      < 0.125666, -0.317912, -5.014699>
    }
    triangle {
      < 1.608937, -0.287191, -4.992953>,
      < 0.125666, -0.317912, -5.014699>,
      < 0.125649, -0.288070, -4.992953>
    }
    triangle {
      < 0.125649, -0.288070, -4.992953>,
      < 0.125666, -0.317912, -5.014699>,
      < 0.085031, -0.322069, -5.006613>
    }
    triangle {
      < 0.125649, -0.288070, -4.992953>,
      < 0.085031, -0.322069, -5.006613>,
      < 0.085015, -0.294523, -4.986542>
    }
    triangle {
      < 0.085015, -0.294523, -4.986542>,
      < 0.085031, -0.322069, -5.006613>,
      < -0.355214, -0.324398, -5.002571>
    }
    triangle {
      < 0.085015, -0.294523, -4.986542>,
      < -0.355214, -0.324398, -5.002571>,
      < -0.355229, -0.297998, -4.983335>
    }
    triangle {
      < -0.355229, -0.297998, -4.983335>,
      < -0.355214, -0.324398, -5.002571>,
      < -0.483892, -0.338941, -4.974275>
    }
    triangle {
      < -0.355229, -0.297998, -4.983335>,
      < -0.483892, -0.338941, -4.974275>,
      < -0.483903, -0.320576, -4.960894>
    }
    triangle {
      < -0.483903, -0.320576, -4.960894>,
      < -0.483892, -0.338941, -4.974275>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900222, -0.364863, -4.945461>,
      < 1.900216, -0.354062, -4.941936>
    }
    triangle {
      < 1.900216, -0.354062, -4.941936>,
      < 1.900222, -0.364863, -4.945461>,
      < 1.764762, -0.364943, -4.945461>
    }
    triangle {
      < 1.900216, -0.354062, -4.941936>,
      < 1.764762, -0.364943, -4.945461>,
      < 1.764756, -0.354142, -4.941936>
    }
    triangle {
      < 1.764756, -0.354142, -4.941936>,
      < 1.764762, -0.364943, -4.945461>,
      < 1.724122, -0.359233, -4.981327>
    }
    triangle {
      < 1.764756, -0.354142, -4.941936>,
      < 1.724122, -0.359233, -4.981327>,
      < 1.724108, -0.337633, -4.974275>
    }
    triangle {
      < 1.724108, -0.337633, -4.974275>,
      < 1.724122, -0.359233, -4.981327>,
      < 1.608976, -0.352134, -5.026159>
    }
    triangle {
      < 1.724108, -0.337633, -4.974275>,
      < 1.608976, -0.352134, -5.026159>,
      < 1.608955, -0.317033, -5.014698>
    }
    triangle {
      < 1.608955, -0.317033, -5.014698>,
      < 1.608976, -0.352134, -5.026159>,
      < 0.125687, -0.353013, -5.026159>
    }
    triangle {
      < 1.608955, -0.317033, -5.014698>,
      < 0.125687, -0.353013, -5.026159>,
      < 0.125666, -0.317912, -5.014699>
    }
    triangle {
      < 0.125666, -0.317912, -5.014699>,
      < 0.125687, -0.353013, -5.026159>,
      < 0.085050, -0.354471, -5.017191>
    }
    triangle {
      < 0.125666, -0.317912, -5.014699>,
      < 0.085050, -0.354471, -5.017191>,
      < 0.085031, -0.322069, -5.006613>
    }
    triangle {
      < 0.085031, -0.322069, -5.006613>,
      < 0.085050, -0.354471, -5.017191>,
      < -0.355195, -0.355448, -5.012709>
    }
    triangle {
      < 0.085031, -0.322069, -5.006613>,
      < -0.355195, -0.355448, -5.012709>,
      < -0.355214, -0.324398, -5.002571>
    }
    triangle {
      < -0.355214, -0.324398, -5.002571>,
      < -0.355195, -0.355448, -5.012709>,
      < -0.483880, -0.360542, -4.981327>
    }
    triangle {
      < -0.355214, -0.324398, -5.002571>,
      < -0.483880, -0.360542, -4.981327>,
      < -0.483892, -0.338941, -4.974275>
    }
    triangle {
      < -0.483892, -0.338941, -4.974275>,
      < -0.483880, -0.360542, -4.981327>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900229, -0.376224, -4.945478>,
      < 1.900222, -0.364863, -4.945461>
    }
    triangle {
      < 1.900222, -0.364863, -4.945461>,
      < 1.900229, -0.376224, -4.945478>,
      < 1.764769, -0.376304, -4.945478>
    }
    triangle {
      < 1.900222, -0.364863, -4.945461>,
      < 1.764769, -0.376304, -4.945478>,
      < 1.764762, -0.364943, -4.945461>
    }
    triangle {
      < 1.764762, -0.364943, -4.945461>,
      < 1.764769, -0.376304, -4.945478>,
      < 1.724135, -0.381956, -4.981360>
    }
    triangle {
      < 1.764762, -0.364943, -4.945461>,
      < 1.724135, -0.381956, -4.981360>,
      < 1.724122, -0.359233, -4.981327>
    }
    triangle {
      < 1.724122, -0.359233, -4.981327>,
      < 1.724135, -0.381956, -4.981360>,
      < 1.608997, -0.389059, -5.026212>
    }
    triangle {
      < 1.724122, -0.359233, -4.981327>,
      < 1.608997, -0.389059, -5.026212>,
      < 1.608976, -0.352134, -5.026159>
    }
    triangle {
      < 1.608976, -0.352134, -5.026159>,
      < 1.608997, -0.389059, -5.026212>,
      < 0.125709, -0.389937, -5.026213>
    }
    triangle {
      < 1.608976, -0.352134, -5.026159>,
      < 0.125709, -0.389937, -5.026213>,
      < 0.125687, -0.353013, -5.026159>
    }
    triangle {
      < 0.125687, -0.353013, -5.026159>,
      < 0.125709, -0.389937, -5.026213>,
      < 0.085071, -0.388555, -5.017243>
    }
    triangle {
      < 0.125687, -0.353013, -5.026159>,
      < 0.085071, -0.388555, -5.017243>,
      < 0.085050, -0.354471, -5.017191>
    }
    triangle {
      < 0.085050, -0.354471, -5.017191>,
      < 0.085071, -0.388555, -5.017243>,
      < -0.355176, -0.388112, -5.012757>
    }
    triangle {
      < 0.085050, -0.354471, -5.017191>,
      < -0.355176, -0.388112, -5.012757>,
      < -0.355195, -0.355448, -5.012709>
    }
    triangle {
      < -0.355195, -0.355448, -5.012709>,
      < -0.355176, -0.388112, -5.012757>,
      < -0.483866, -0.383264, -4.981361>
    }
    triangle {
      < -0.355195, -0.355448, -5.012709>,
      < -0.483866, -0.383264, -4.981361>,
      < -0.483880, -0.360542, -4.981327>
    }
    triangle {
      < -0.483880, -0.360542, -4.981327>,
      < -0.483866, -0.383264, -4.981361>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900236, -0.387034, -4.941985>,
      < 1.900229, -0.376224, -4.945478>
    }
    triangle {
      < 1.900229, -0.376224, -4.945478>,
      < 1.900236, -0.387034, -4.941985>,
      < 1.764776, -0.387114, -4.941985>
    }
    triangle {
      < 1.900229, -0.376224, -4.945478>,
      < 1.764776, -0.387114, -4.941985>,
      < 1.764769, -0.376304, -4.945478>
    }
    triangle {
      < 1.764769, -0.376304, -4.945478>,
      < 1.764776, -0.387114, -4.941985>,
      < 1.724148, -0.403578, -4.974372>
    }
    triangle {
      < 1.764769, -0.376304, -4.945478>,
      < 1.724148, -0.403578, -4.974372>,
      < 1.724135, -0.381956, -4.981360>
    }
    triangle {
      < 1.724135, -0.381956, -4.981360>,
      < 1.724148, -0.403578, -4.974372>,
      < 1.609019, -0.424193, -5.014855>
    }
    triangle {
      < 1.724135, -0.381956, -4.981360>,
      < 1.609019, -0.424193, -5.014855>,
      < 1.608997, -0.389059, -5.026212>
    }
    triangle {
      < 1.608997, -0.389059, -5.026212>,
      < 1.609019, -0.424193, -5.014855>,
      < 0.125730, -0.425071, -5.014856>
    }
    triangle {
      < 1.608997, -0.389059, -5.026212>,
      < 0.125730, -0.425071, -5.014856>,
      < 0.125709, -0.389937, -5.026213>
    }
    triangle {
      < 0.125709, -0.389937, -5.026213>,
      < 0.125730, -0.425071, -5.014856>,
      < 0.085090, -0.420987, -5.006759>
    }
    triangle {
      < 0.125709, -0.389937, -5.026213>,
      < 0.085090, -0.420987, -5.006759>,
      < 0.085071, -0.388555, -5.017243>
    }
    triangle {
      < 0.085071, -0.388555, -5.017243>,
      < 0.085090, -0.420987, -5.006759>,
      < -0.355157, -0.419192, -5.002711>
    }
    triangle {
      < 0.085071, -0.388555, -5.017243>,
      < -0.355157, -0.419192, -5.002711>,
      < -0.355176, -0.388112, -5.012757>
    }
    triangle {
      < -0.355176, -0.388112, -5.012757>,
      < -0.355157, -0.419192, -5.002711>,
      < -0.483853, -0.404886, -4.974373>
    }
    triangle {
      < -0.355176, -0.388112, -5.012757>,
      < -0.483853, -0.404886, -4.974373>,
      < -0.483866, -0.383264, -4.981361>
    }
    triangle {
      < -0.483866, -0.383264, -4.981361>,
      < -0.483853, -0.404886, -4.974373>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < 1.900226, -0.370596, -4.909597>,
      < 1.900241, -0.396268, -4.935291>,
      < 1.900236, -0.387034, -4.941985>
    }
    triangle {
      < 1.900236, -0.387034, -4.941985>,
      < 1.900241, -0.396268, -4.935291>,
      < 1.764781, -0.396348, -4.935291>
    }
    triangle {
      < 1.900236, -0.387034, -4.941985>,
      < 1.764781, -0.396348, -4.935291>,
      < 1.764776, -0.387114, -4.941985>
    }
    triangle {
      < 1.764776, -0.387114, -4.941985>,
      < 1.764781, -0.396348, -4.935291>,
      < 1.724159, -0.422042, -4.960985>
    }
    triangle {
      < 1.764776, -0.387114, -4.941985>,
      < 1.724159, -0.422042, -4.960985>,
      < 1.724148, -0.403578, -4.974372>
    }
    triangle {
      < 1.724148, -0.403578, -4.974372>,
      < 1.724159, -0.422042, -4.960985>,
      < 1.609036, -0.454199, -4.993102>
    }
    triangle {
      < 1.724148, -0.403578, -4.974372>,
      < 1.609036, -0.454199, -4.993102>,
      < 1.609019, -0.424193, -5.014855>
    }
    triangle {
      < 1.609019, -0.424193, -5.014855>,
      < 1.609036, -0.454199, -4.993102>,
      < 0.125748, -0.455077, -4.993102>
    }
    triangle {
      < 1.609019, -0.424193, -5.014855>,
      < 0.125748, -0.455077, -4.993102>,
      < 0.125730, -0.425071, -5.014856>
    }
    triangle {
      < 0.125730, -0.425071, -5.014856>,
      < 0.125748, -0.455077, -4.993102>,
      < 0.085106, -0.448685, -4.986679>
    }
    triangle {
      < 0.125730, -0.425071, -5.014856>,
      < 0.085106, -0.448685, -4.986679>,
      < 0.085090, -0.420987, -5.006759>
    }
    triangle {
      < 0.085090, -0.420987, -5.006759>,
      < 0.085106, -0.448685, -4.986679>,
      < -0.355142, -0.445736, -4.983467>
    }
    triangle {
      < 0.085090, -0.420987, -5.006759>,
      < -0.355142, -0.445736, -4.983467>,
      < -0.355157, -0.419192, -5.002711>
    }
    triangle {
      < -0.355157, -0.419192, -5.002711>,
      < -0.355142, -0.445736, -4.983467>,
      < -0.483842, -0.423351, -4.960985>
    }
    triangle {
      < -0.355157, -0.419192, -5.002711>,
      < -0.483842, -0.423351, -4.960985>,
      < -0.483853, -0.404886, -4.974373>
    }
    triangle {
      < -0.483853, -0.404886, -4.974373>,
      < -0.483842, -0.423351, -4.960985>,
      < -0.571921, -0.372062, -4.909598>
    }
    triangle {
      < -0.104378, -0.530903, -4.730666>,
      < -0.104472, -0.372687, -4.888647>,
      < -0.413532, -0.372870, -4.888647>
    }
    triangle {
      < -0.104378, -0.530903, -4.730666>,
      < -0.413532, -0.372870, -4.888647>,
      < -0.413438, -0.531085, -4.730666>
    }
    triangle {
      < -0.413426, -0.551135, -4.750745>,
      < -0.413519, -0.392919, -4.908726>,
      < -0.104460, -0.392737, -4.908726>
    }
    triangle {
      < -0.413426, -0.551135, -4.750745>,
      < -0.104460, -0.392737, -4.908726>,
      < -0.104366, -0.550952, -4.750745>
    }
    triangle {
      < -0.413438, -0.531085, -4.730666>,
      < -0.413532, -0.372870, -4.888647>,
      < -0.413519, -0.392919, -4.908726>
    }
    triangle {
      < -0.413438, -0.531085, -4.730666>,
      < -0.413519, -0.392919, -4.908726>,
      < -0.413426, -0.551135, -4.750745>
    }
    triangle {
      < -0.104366, -0.550952, -4.750745>,
      < -0.104378, -0.530903, -4.730666>,
      < -0.413438, -0.531085, -4.730666>
    }
    triangle {
      < -0.104366, -0.550952, -4.750745>,
      < -0.413438, -0.531085, -4.730666>,
      < -0.413426, -0.551135, -4.750745>
    }
    triangle {
      < -0.104366, -0.550952, -4.750745>,
      < -0.104460, -0.392737, -4.908726>,
      < -0.104472, -0.372687, -4.888647>
    }
    triangle {
      < -0.104366, -0.550952, -4.750745>,
      < -0.104472, -0.372687, -4.888647>,
      < -0.104378, -0.530903, -4.730666>
    }
    triangle {
      < -0.104472, -0.372687, -4.888647>,
      < -0.104460, -0.392737, -4.908726>,
      < -0.413519, -0.392919, -4.908726>
    }
    triangle {
      < -0.104472, -0.372687, -4.888647>,
      < -0.413519, -0.392919, -4.908726>,
      < -0.413532, -0.372870, -4.888647>
    }
    triangle {
      < 0.334654, -0.530642, -4.730666>,
      < 0.334561, -0.372427, -4.888647>,
      < 0.025501, -0.372610, -4.888647>
    }
    triangle {
      < 0.334654, -0.530642, -4.730666>,
      < 0.025501, -0.372610, -4.888647>,
      < 0.025595, -0.530825, -4.730666>
    }
    triangle {
      < 0.025608, -0.550875, -4.750745>,
      < 0.025513, -0.392659, -4.908726>,
      < 0.334572, -0.392477, -4.908726>
    }
    triangle {
      < 0.025608, -0.550875, -4.750745>,
      < 0.334572, -0.392477, -4.908726>,
      < 0.334667, -0.550692, -4.750745>
    }
    triangle {
      < 0.025595, -0.530825, -4.730666>,
      < 0.025501, -0.372610, -4.888647>,
      < 0.025513, -0.392659, -4.908726>
    }
    triangle {
      < 0.025595, -0.530825, -4.730666>,
      < 0.025513, -0.392659, -4.908726>,
      < 0.025608, -0.550875, -4.750745>
    }
    triangle {
      < 0.334667, -0.550692, -4.750745>,
      < 0.334654, -0.530642, -4.730666>,
      < 0.025595, -0.530825, -4.730666>
    }
    triangle {
      < 0.334667, -0.550692, -4.750745>,
      < 0.025595, -0.530825, -4.730666>,
      < 0.025608, -0.550875, -4.750745>
    }
    triangle {
      < 0.334667, -0.550692, -4.750745>,
      < 0.334572, -0.392477, -4.908726>,
      < 0.334561, -0.372427, -4.888647>
    }
    triangle {
      < 0.334667, -0.550692, -4.750745>,
      < 0.334561, -0.372427, -4.888647>,
      < 0.334654, -0.530642, -4.730666>
    }
    triangle {
      < 0.334561, -0.372427, -4.888647>,
      < 0.334572, -0.392477, -4.908726>,
      < 0.025513, -0.392659, -4.908726>
    }
    triangle {
      < 0.334561, -0.372427, -4.888647>,
      < 0.025513, -0.392659, -4.908726>,
      < 0.025501, -0.372610, -4.888647>
    }
    triangle {
      < -0.104578, -0.192900, -4.750427>,
      < -0.104485, -0.350834, -4.908688>,
      < -0.413545, -0.351016, -4.908688>
    }
    triangle {
      < -0.104578, -0.192900, -4.750427>,
      < -0.413545, -0.351016, -4.908688>,
      < -0.413638, -0.193083, -4.750427>
    }
    triangle {
      < -0.413626, -0.213167, -4.730382>,
      < -0.413533, -0.371101, -4.888646>,
      < -0.104473, -0.370918, -4.888646>
    }
    triangle {
      < -0.413626, -0.213167, -4.730382>,
      < -0.104473, -0.370918, -4.888646>,
      < -0.104566, -0.212985, -4.730382>
    }
    triangle {
      < -0.413638, -0.193083, -4.750427>,
      < -0.413545, -0.351016, -4.908688>,
      < -0.413533, -0.371101, -4.888646>
    }
    triangle {
      < -0.413638, -0.193083, -4.750427>,
      < -0.413533, -0.371101, -4.888646>,
      < -0.413626, -0.213167, -4.730382>
    }
    triangle {
      < -0.104566, -0.212985, -4.730382>,
      < -0.104578, -0.192900, -4.750427>,
      < -0.413638, -0.193083, -4.750427>
    }
    triangle {
      < -0.104566, -0.212985, -4.730382>,
      < -0.413638, -0.193083, -4.750427>,
      < -0.413626, -0.213167, -4.730382>
    }
    triangle {
      < -0.104566, -0.212985, -4.730382>,
      < -0.104473, -0.370918, -4.888646>,
      < -0.104485, -0.350834, -4.908688>
    }
    triangle {
      < -0.104566, -0.212985, -4.730382>,
      < -0.104485, -0.350834, -4.908688>,
      < -0.104578, -0.192900, -4.750427>
    }
    triangle {
      < -0.104485, -0.350834, -4.908688>,
      < -0.104473, -0.370918, -4.888646>,
      < -0.413533, -0.371101, -4.888646>
    }
    triangle {
      < -0.104485, -0.350834, -4.908688>,
      < -0.413533, -0.371101, -4.888646>,
      < -0.413545, -0.351016, -4.908688>
    }
    triangle {
      < 0.334454, -0.192640, -4.750426>,
      < 0.334548, -0.350574, -4.908688>,
      < 0.025489, -0.350756, -4.908688>
    }
    triangle {
      < 0.334454, -0.192640, -4.750426>,
      < 0.025489, -0.350756, -4.908688>,
      < 0.025395, -0.192822, -4.750427>
    }
    triangle {
      < 0.025407, -0.212907, -4.730382>,
      < 0.025501, -0.370841, -4.888646>,
      < 0.334560, -0.370658, -4.888646>
    }
    triangle {
      < 0.025407, -0.212907, -4.730382>,
      < 0.334560, -0.370658, -4.888646>,
      < 0.334466, -0.212725, -4.730382>
    }
    triangle {
      < 0.025395, -0.192822, -4.750427>,
      < 0.025489, -0.350756, -4.908688>,
      < 0.025501, -0.370841, -4.888646>
    }
    triangle {
      < 0.025395, -0.192822, -4.750427>,
      < 0.025501, -0.370841, -4.888646>,
      < 0.025407, -0.212907, -4.730382>
    }
    triangle {
      < 0.334466, -0.212725, -4.730382>,
      < 0.334454, -0.192640, -4.750426>,
      < 0.025395, -0.192822, -4.750427>
    }
    triangle {
      < 0.334466, -0.212725, -4.730382>,
      < 0.025395, -0.192822, -4.750427>,
      < 0.025407, -0.212907, -4.730382>
    }
    triangle {
      < 0.334466, -0.212725, -4.730382>,
      < 0.334560, -0.370658, -4.888646>,
      < 0.334548, -0.350574, -4.908688>
    }
    triangle {
      < 0.334466, -0.212725, -4.730382>,
      < 0.334548, -0.350574, -4.908688>,
      < 0.334454, -0.192640, -4.750426>
    }
    triangle {
      < 0.334548, -0.350574, -4.908688>,
      < 0.334560, -0.370658, -4.888646>,
      < 0.025501, -0.370841, -4.888646>
    }
    triangle {
      < 0.334548, -0.350574, -4.908688>,
      < 0.025501, -0.370841, -4.888646>,
      < 0.025489, -0.350756, -4.908688>
    }
    triangle {
      < -0.104566, -0.212560, -5.088437>,
      < -0.104473, -0.370869, -4.930548>,
      < -0.413533, -0.371052, -4.930549>
    }
    triangle {
      < -0.104566, -0.212560, -5.088437>,
      < -0.413533, -0.371052, -4.930549>,
      < -0.413626, -0.212743, -5.088437>
    }
    triangle {
      < -0.413638, -0.192706, -5.068345>,
      < -0.413545, -0.351014, -4.910458>,
      < -0.104485, -0.350831, -4.910458>
    }
    triangle {
      < -0.413638, -0.192706, -5.068345>,
      < -0.104485, -0.350831, -4.910458>,
      < -0.104578, -0.192523, -5.068345>
    }
    triangle {
      < -0.413626, -0.212743, -5.088437>,
      < -0.413533, -0.371052, -4.930549>,
      < -0.413545, -0.351014, -4.910458>
    }
    triangle {
      < -0.413626, -0.212743, -5.088437>,
      < -0.413545, -0.351014, -4.910458>,
      < -0.413638, -0.192706, -5.068345>
    }
    triangle {
      < -0.104578, -0.192523, -5.068345>,
      < -0.104566, -0.212560, -5.088437>,
      < -0.413626, -0.212743, -5.088437>
    }
    triangle {
      < -0.104578, -0.192523, -5.068345>,
      < -0.413626, -0.212743, -5.088437>,
      < -0.413638, -0.192706, -5.068345>
    }
    triangle {
      < -0.104578, -0.192523, -5.068345>,
      < -0.104485, -0.350831, -4.910458>,
      < -0.104473, -0.370869, -4.930548>
    }
    triangle {
      < -0.104578, -0.192523, -5.068345>,
      < -0.104473, -0.370869, -4.930548>,
      < -0.104566, -0.212560, -5.088437>
    }
    triangle {
      < -0.104473, -0.370869, -4.930548>,
      < -0.104485, -0.350831, -4.910458>,
      < -0.413545, -0.351014, -4.910458>
    }
    triangle {
      < -0.104473, -0.370869, -4.930548>,
      < -0.413545, -0.351014, -4.910458>,
      < -0.413533, -0.371052, -4.930549>
    }
    triangle {
      < 0.334466, -0.212300, -5.088437>,
      < 0.334560, -0.370609, -4.930548>,
      < 0.025501, -0.370792, -4.930548>
    }
    triangle {
      < 0.334466, -0.212300, -5.088437>,
      < 0.025501, -0.370792, -4.930548>,
      < 0.025407, -0.212483, -5.088437>
    }
    triangle {
      < 0.025395, -0.192446, -5.068345>,
      < 0.025489, -0.350754, -4.910458>,
      < 0.334548, -0.350571, -4.910457>
    }
    triangle {
      < 0.025395, -0.192446, -5.068345>,
      < 0.334548, -0.350571, -4.910457>,
      < 0.334454, -0.192263, -5.068345>
    }
    triangle {
      < 0.025407, -0.212483, -5.088437>,
      < 0.025501, -0.370792, -4.930548>,
      < 0.025489, -0.350754, -4.910458>
    }
    triangle {
      < 0.025407, -0.212483, -5.088437>,
      < 0.025489, -0.350754, -4.910458>,
      < 0.025395, -0.192446, -5.068345>
    }
    triangle {
      < 0.334454, -0.192263, -5.068345>,
      < 0.334466, -0.212300, -5.088437>,
      < 0.025407, -0.212483, -5.088437>
    }
    triangle {
      < 0.334454, -0.192263, -5.068345>,
      < 0.025407, -0.212483, -5.088437>,
      < 0.025395, -0.192446, -5.068345>
    }
    triangle {
      < 0.334454, -0.192263, -5.068345>,
      < 0.334548, -0.350571, -4.910457>,
      < 0.334560, -0.370609, -4.930548>
    }
    triangle {
      < 0.334454, -0.192263, -5.068345>,
      < 0.334560, -0.370609, -4.930548>,
      < 0.334466, -0.212300, -5.088437>
    }
    triangle {
      < 0.334560, -0.370609, -4.930548>,
      < 0.334548, -0.350571, -4.910457>,
      < 0.025489, -0.350754, -4.910458>
    }
    triangle {
      < 0.334560, -0.370609, -4.930548>,
      < 0.025489, -0.350754, -4.910458>,
      < 0.025501, -0.370792, -4.930548>
    }
    triangle {
      < -0.104367, -0.550575, -5.068875>,
      < -0.104460, -0.392735, -4.910520>,
      < -0.413519, -0.392918, -4.910520>
    }
    triangle {
      < -0.104367, -0.550575, -5.068875>,
      < -0.413519, -0.392918, -4.910520>,
      < -0.413427, -0.550758, -5.068875>
    }
    triangle {
      < -0.413438, -0.530661, -5.088907>,
      < -0.413532, -0.372820, -4.930551>,
      < -0.104472, -0.372638, -4.930551>
    }
    triangle {
      < -0.413438, -0.530661, -5.088907>,
      < -0.104472, -0.372638, -4.930551>,
      < -0.104378, -0.530479, -5.088907>
    }
    triangle {
      < -0.413427, -0.550758, -5.068875>,
      < -0.413519, -0.392918, -4.910520>,
      < -0.413532, -0.372820, -4.930551>
    }
    triangle {
      < -0.413427, -0.550758, -5.068875>,
      < -0.413532, -0.372820, -4.930551>,
      < -0.413438, -0.530661, -5.088907>
    }
    triangle {
      < -0.104378, -0.530479, -5.088907>,
      < -0.104367, -0.550575, -5.068875>,
      < -0.413427, -0.550758, -5.068875>
    }
    triangle {
      < -0.104378, -0.530479, -5.088907>,
      < -0.413427, -0.550758, -5.068875>,
      < -0.413438, -0.530661, -5.088907>
    }
    triangle {
      < -0.104378, -0.530479, -5.088907>,
      < -0.104472, -0.372638, -4.930551>,
      < -0.104460, -0.392735, -4.910520>
    }
    triangle {
      < -0.104378, -0.530479, -5.088907>,
      < -0.104460, -0.392735, -4.910520>,
      < -0.104367, -0.550575, -5.068875>
    }
    triangle {
      < -0.104460, -0.392735, -4.910520>,
      < -0.104472, -0.372638, -4.930551>,
      < -0.413532, -0.372820, -4.930551>
    }
    triangle {
      < -0.104460, -0.392735, -4.910520>,
      < -0.413532, -0.372820, -4.930551>,
      < -0.413519, -0.392918, -4.910520>
    }
    triangle {
      < 0.334666, -0.550315, -5.068875>,
      < 0.334572, -0.392475, -4.910519>,
      < 0.025513, -0.392658, -4.910520>
    }
    triangle {
      < 0.334666, -0.550315, -5.068875>,
      < 0.025513, -0.392658, -4.910520>,
      < 0.025607, -0.550498, -5.068875>
    }
    triangle {
      < 0.025595, -0.530401, -5.088907>,
      < 0.025501, -0.372560, -4.930551>,
      < 0.334561, -0.372378, -4.930551>
    }
    triangle {
      < 0.025595, -0.530401, -5.088907>,
      < 0.334561, -0.372378, -4.930551>,
      < 0.334654, -0.530219, -5.088907>
    }
    triangle {
      < 0.025607, -0.550498, -5.068875>,
      < 0.025513, -0.392658, -4.910520>,
      < 0.025501, -0.372560, -4.930551>
    }
    triangle {
      < 0.025607, -0.550498, -5.068875>,
      < 0.025501, -0.372560, -4.930551>,
      < 0.025595, -0.530401, -5.088907>
    }
    triangle {
      < 0.334654, -0.530219, -5.088907>,
      < 0.334666, -0.550315, -5.068875>,
      < 0.025607, -0.550498, -5.068875>
    }
    triangle {
      < 0.334654, -0.530219, -5.088907>,
      < 0.025607, -0.550498, -5.068875>,
      < 0.025595, -0.530401, -5.088907>
    }
    triangle {
      < 0.334654, -0.530219, -5.088907>,
      < 0.334561, -0.372378, -4.930551>,
      < 0.334572, -0.392475, -4.910519>
    }
    triangle {
      < 0.334654, -0.530219, -5.088907>,
      < 0.334572, -0.392475, -4.910519>,
      < 0.334666, -0.550315, -5.068875>
    }
    triangle {
      < 0.334572, -0.392475, -4.910519>,
      < 0.334561, -0.372378, -4.930551>,
      < 0.025501, -0.372560, -4.930551>
    }
    triangle {
      < 0.334572, -0.392475, -4.910519>,
      < 0.025501, -0.372560, -4.930551>,
      < 0.025513, -0.392658, -4.910520>
    }
    texture {ordinance2}
  }
  // wheels
  union {
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.338306, -0.601521, 2.024135>,
      < 1.344794, -0.602198, 2.024137>
    }
    triangle {
      < 1.344794, -0.602198, 2.024137>,
      < 1.338306, -0.601521, 2.024135>,
      < 1.335543, -0.614604, 1.990399>
    }
    triangle {
      < 1.344794, -0.602198, 2.024137>,
      < 1.335543, -0.614604, 1.990399>,
      < 1.344811, -0.615572, 1.990402>
    }
    triangle {
      < 1.344811, -0.615572, 1.990402>,
      < 1.335543, -0.614604, 1.990399>,
      < 1.322138, -0.677844, 2.008560>
    }
    triangle {
      < 1.344811, -0.615572, 1.990402>,
      < 1.322138, -0.677844, 2.008560>,
      < 1.344845, -0.680216, 2.008567>
    }
    triangle {
      < 1.344845, -0.680216, 2.008567>,
      < 1.322138, -0.677844, 2.008560>,
      < 1.322135, -0.677844, 2.021535>
    }
    triangle {
      < 1.344845, -0.680216, 2.008567>,
      < 1.322135, -0.677844, 2.021535>,
      < 1.344842, -0.680216, 2.021542>
    }
    triangle {
      < 1.344842, -0.680216, 2.021542>,
      < 1.322135, -0.677844, 2.021535>,
      < 1.317977, -0.697469, 2.021533>
    }
    triangle {
      < 1.344842, -0.680216, 2.021542>,
      < 1.317977, -0.697469, 2.021533>,
      < 1.344854, -0.700277, 2.021543>
    }
    triangle {
      < 1.344854, -0.700277, 2.021543>,
      < 1.317977, -0.697469, 2.021533>,
      < 1.316121, -0.706192, 2.050079>
    }
    triangle {
      < 1.344854, -0.700277, 2.021543>,
      < 1.316121, -0.706192, 2.050079>,
      < 1.344851, -0.709194, 2.050089>
    }
    triangle {
      < 1.344851, -0.709194, 2.050089>,
      < 1.316121, -0.706192, 2.050079>,
      < 1.303179, -0.767251, 2.063050>
    }
    triangle {
      < 1.344851, -0.709194, 2.050089>,
      < 1.303179, -0.767251, 2.063050>,
      < 1.344885, -0.771608, 2.063064>
    }
    triangle {
      < 1.344885, -0.771608, 2.063064>,
      < 1.303179, -0.767251, 2.063050>,
      < 1.295790, -0.802141, 2.047477>
    }
    triangle {
      < 1.344885, -0.771608, 2.063064>,
      < 1.295790, -0.802141, 2.047477>,
      < 1.344911, -0.807274, 2.047494>
    }
    triangle {
      < 1.344911, -0.807274, 2.047494>,
      < 1.295790, -0.802141, 2.047477>,
      < 1.290254, -0.828310, 2.013738>
    }
    triangle {
      < 1.344911, -0.807274, 2.047494>,
      < 1.290254, -0.828310, 2.013738>,
      < 1.344934, -0.834023, 2.013757>
    }
    triangle {
      < 1.344934, -0.834023, 2.013757>,
      < 1.290254, -0.828310, 2.013738>,
      < 1.289336, -0.832671, 1.990383>
    }
    triangle {
      < 1.344934, -0.834023, 2.013757>,
      < 1.289336, -0.832671, 1.990383>,
      < 1.344943, -0.838481, 1.990402>
    }
    triangle {
      < 1.344943, -0.838481, 1.990402>,
      < 1.289336, -0.832671, 1.990383>,
      < 1.289342, -0.832671, 1.967027>
    }
    triangle {
      < 1.344943, -0.838481, 1.990402>,
      < 1.289342, -0.832671, 1.967027>,
      < 1.344949, -0.838481, 1.967046>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.332102, -0.599509, 2.024134>,
      < 1.338306, -0.601521, 2.024135>
    }
    triangle {
      < 1.338306, -0.601521, 2.024135>,
      < 1.332102, -0.599509, 2.024134>,
      < 1.326679, -0.611730, 1.990396>
    }
    triangle {
      < 1.338306, -0.601521, 2.024135>,
      < 1.326679, -0.611730, 1.990396>,
      < 1.335543, -0.614604, 1.990399>
    }
    triangle {
      < 1.335543, -0.614604, 1.990399>,
      < 1.326679, -0.611730, 1.990396>,
      < 1.300422, -0.670803, 2.008552>
    }
    triangle {
      < 1.335543, -0.614604, 1.990399>,
      < 1.300422, -0.670803, 2.008552>,
      < 1.322138, -0.677844, 2.008560>
    }
    triangle {
      < 1.322138, -0.677844, 2.008560>,
      < 1.300422, -0.670803, 2.008552>,
      < 1.300418, -0.670803, 2.021528>
    }
    triangle {
      < 1.322138, -0.677844, 2.008560>,
      < 1.300418, -0.670803, 2.021528>,
      < 1.322135, -0.677844, 2.021535>
    }
    triangle {
      < 1.322135, -0.677844, 2.021535>,
      < 1.300418, -0.670803, 2.021528>,
      < 1.292270, -0.689136, 2.021524>
    }
    triangle {
      < 1.322135, -0.677844, 2.021535>,
      < 1.292270, -0.689136, 2.021524>,
      < 1.317977, -0.697469, 2.021533>
    }
    triangle {
      < 1.317977, -0.697469, 2.021533>,
      < 1.292270, -0.689136, 2.021524>,
      < 1.288642, -0.697284, 2.050070>
    }
    triangle {
      < 1.317977, -0.697469, 2.021533>,
      < 1.288642, -0.697284, 2.050070>,
      < 1.316121, -0.706192, 2.050079>
    }
    triangle {
      < 1.316121, -0.706192, 2.050079>,
      < 1.288642, -0.697284, 2.050070>,
      < 1.263291, -0.754319, 2.063036>
    }
    triangle {
      < 1.316121, -0.706192, 2.050079>,
      < 1.263291, -0.754319, 2.063036>,
      < 1.303179, -0.767251, 2.063050>
    }
    triangle {
      < 1.303179, -0.767251, 2.063050>,
      < 1.263291, -0.754319, 2.063036>,
      < 1.248810, -0.786911, 2.047460>
    }
    triangle {
      < 1.303179, -0.767251, 2.063050>,
      < 1.248810, -0.786911, 2.047460>,
      < 1.295790, -0.802141, 2.047477>
    }
    triangle {
      < 1.295790, -0.802141, 2.047477>,
      < 1.248810, -0.786911, 2.047460>,
      < 1.237955, -0.811354, 2.013720>
    }
    triangle {
      < 1.295790, -0.802141, 2.047477>,
      < 1.237955, -0.811354, 2.013720>,
      < 1.290254, -0.828310, 2.013738>
    }
    triangle {
      < 1.290254, -0.828310, 2.013738>,
      < 1.237955, -0.811354, 2.013720>,
      < 1.236150, -0.815428, 1.990364>
    }
    triangle {
      < 1.290254, -0.828310, 2.013738>,
      < 1.236150, -0.815428, 1.990364>,
      < 1.289336, -0.832671, 1.990383>
    }
    triangle {
      < 1.289336, -0.832671, 1.990383>,
      < 1.236150, -0.815428, 1.990364>,
      < 1.236157, -0.815428, 1.967009>
    }
    triangle {
      < 1.289336, -0.832671, 1.990383>,
      < 1.236157, -0.815428, 1.967009>,
      < 1.289342, -0.832671, 1.967027>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.326451, -0.596252, 2.024132>,
      < 1.332102, -0.599509, 2.024134>
    }
    triangle {
      < 1.332102, -0.599509, 2.024134>,
      < 1.326451, -0.596252, 2.024132>,
      < 1.318606, -0.607076, 1.990393>
    }
    triangle {
      < 1.332102, -0.599509, 2.024134>,
      < 1.318606, -0.607076, 1.990393>,
      < 1.326679, -0.611730, 1.990396>
    }
    triangle {
      < 1.326679, -0.611730, 1.990396>,
      < 1.318606, -0.607076, 1.990393>,
      < 1.280642, -0.659401, 2.008546>
    }
    triangle {
      < 1.326679, -0.611730, 1.990396>,
      < 1.280642, -0.659401, 2.008546>,
      < 1.300422, -0.670803, 2.008552>
    }
    triangle {
      < 1.300422, -0.670803, 2.008552>,
      < 1.280642, -0.659401, 2.008546>,
      < 1.280638, -0.659401, 2.021521>
    }
    triangle {
      < 1.300422, -0.670803, 2.008552>,
      < 1.280638, -0.659401, 2.021521>,
      < 1.300418, -0.670803, 2.021528>
    }
    triangle {
      < 1.300418, -0.670803, 2.021528>,
      < 1.280638, -0.659401, 2.021521>,
      < 1.268858, -0.675640, 2.021517>
    }
    triangle {
      < 1.300418, -0.670803, 2.021528>,
      < 1.268858, -0.675640, 2.021517>,
      < 1.292270, -0.689136, 2.021524>
    }
    triangle {
      < 1.292270, -0.689136, 2.021524>,
      < 1.268858, -0.675640, 2.021517>,
      < 1.263615, -0.682857, 2.050061>
    }
    triangle {
      < 1.292270, -0.689136, 2.021524>,
      < 1.263615, -0.682857, 2.050061>,
      < 1.288642, -0.697284, 2.050070>
    }
    triangle {
      < 1.288642, -0.697284, 2.050070>,
      < 1.263615, -0.682857, 2.050061>,
      < 1.226962, -0.733378, 2.063024>
    }
    triangle {
      < 1.288642, -0.697284, 2.050070>,
      < 1.226962, -0.733378, 2.063024>,
      < 1.263291, -0.754319, 2.063036>
    }
    triangle {
      < 1.263291, -0.754319, 2.063036>,
      < 1.226962, -0.733378, 2.063024>,
      < 1.206022, -0.762247, 2.047445>
    }
    triangle {
      < 1.263291, -0.754319, 2.063036>,
      < 1.206022, -0.762247, 2.047445>,
      < 1.248810, -0.786911, 2.047460>
    }
    triangle {
      < 1.248810, -0.786911, 2.047460>,
      < 1.206022, -0.762247, 2.047445>,
      < 1.190324, -0.783898, 2.013705>
    }
    triangle {
      < 1.248810, -0.786911, 2.047460>,
      < 1.190324, -0.783898, 2.013705>,
      < 1.237955, -0.811354, 2.013720>
    }
    triangle {
      < 1.237955, -0.811354, 2.013720>,
      < 1.190324, -0.783898, 2.013705>,
      < 1.187711, -0.787507, 1.990348>
    }
    triangle {
      < 1.237955, -0.811354, 2.013720>,
      < 1.187711, -0.787507, 1.990348>,
      < 1.236150, -0.815428, 1.990364>
    }
    triangle {
      < 1.236150, -0.815428, 1.990364>,
      < 1.187711, -0.787507, 1.990348>,
      < 1.187718, -0.787506, 1.966991>
    }
    triangle {
      < 1.236150, -0.815428, 1.990364>,
      < 1.187718, -0.787506, 1.966991>,
      < 1.236157, -0.815428, 1.967009>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.321600, -0.591890, 2.024129>,
      < 1.326451, -0.596252, 2.024132>
    }
    triangle {
      < 1.326451, -0.596252, 2.024132>,
      < 1.321600, -0.591890, 2.024129>,
      < 1.311676, -0.600847, 1.990390>
    }
    triangle {
      < 1.326451, -0.596252, 2.024132>,
      < 1.311676, -0.600847, 1.990390>,
      < 1.318606, -0.607076, 1.990393>
    }
    triangle {
      < 1.318606, -0.607076, 1.990393>,
      < 1.311676, -0.600847, 1.990390>,
      < 1.263665, -0.644138, 2.008539>
    }
    triangle {
      < 1.318606, -0.607076, 1.990393>,
      < 1.263665, -0.644138, 2.008539>,
      < 1.280642, -0.659401, 2.008546>
    }
    triangle {
      < 1.280642, -0.659401, 2.008546>,
      < 1.263665, -0.644138, 2.008539>,
      < 1.263662, -0.644137, 2.021515>
    }
    triangle {
      < 1.280642, -0.659401, 2.008546>,
      < 1.263662, -0.644137, 2.021515>,
      < 1.280638, -0.659401, 2.021521>
    }
    triangle {
      < 1.280638, -0.659401, 2.021521>,
      < 1.263662, -0.644137, 2.021515>,
      < 1.248762, -0.657573, 2.021510>
    }
    triangle {
      < 1.280638, -0.659401, 2.021521>,
      < 1.248762, -0.657573, 2.021510>,
      < 1.268858, -0.675640, 2.021517>
    }
    triangle {
      < 1.268858, -0.675640, 2.021517>,
      < 1.248762, -0.657573, 2.021510>,
      < 1.242134, -0.663544, 2.050053>
    }
    triangle {
      < 1.268858, -0.675640, 2.021517>,
      < 1.242134, -0.663544, 2.050053>,
      < 1.263615, -0.682857, 2.050061>
    }
    triangle {
      < 1.263615, -0.682857, 2.050061>,
      < 1.242134, -0.663544, 2.050053>,
      < 1.195778, -0.705342, 2.063013>
    }
    triangle {
      < 1.263615, -0.682857, 2.050061>,
      < 1.195778, -0.705342, 2.063013>,
      < 1.226962, -0.733378, 2.063024>
    }
    triangle {
      < 1.226962, -0.733378, 2.063024>,
      < 1.195778, -0.705342, 2.063013>,
      < 1.169296, -0.729227, 2.047433>
    }
    triangle {
      < 1.226962, -0.733378, 2.063024>,
      < 1.169296, -0.729227, 2.047433>,
      < 1.206022, -0.762247, 2.047445>
    }
    triangle {
      < 1.206022, -0.762247, 2.047445>,
      < 1.169296, -0.729227, 2.047433>,
      < 1.149440, -0.747141, 2.013690>
    }
    triangle {
      < 1.206022, -0.762247, 2.047445>,
      < 1.149440, -0.747141, 2.013690>,
      < 1.190324, -0.783898, 2.013705>
    }
    triangle {
      < 1.190324, -0.783898, 2.013705>,
      < 1.149440, -0.747141, 2.013690>,
      < 1.146135, -0.750126, 1.990333>
    }
    triangle {
      < 1.190324, -0.783898, 2.013705>,
      < 1.146135, -0.750126, 1.990333>,
      < 1.187711, -0.787507, 1.990348>
    }
    triangle {
      < 1.187711, -0.787507, 1.990348>,
      < 1.146135, -0.750126, 1.990333>,
      < 1.146140, -0.750126, 1.966978>
    }
    triangle {
      < 1.187711, -0.787507, 1.990348>,
      < 1.146140, -0.750126, 1.966978>,
      < 1.187718, -0.787506, 1.966991>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.317762, -0.586616, 2.024129>,
      < 1.321600, -0.591890, 2.024129>
    }
    triangle {
      < 1.321600, -0.591890, 2.024129>,
      < 1.317762, -0.586616, 2.024129>,
      < 1.306193, -0.593312, 1.990388>
    }
    triangle {
      < 1.321600, -0.591890, 2.024129>,
      < 1.306193, -0.593312, 1.990388>,
      < 1.311676, -0.600847, 1.990390>
    }
    triangle {
      < 1.311676, -0.600847, 1.990390>,
      < 1.306193, -0.593312, 1.990388>,
      < 1.250231, -0.625678, 2.008535>
    }
    triangle {
      < 1.311676, -0.600847, 1.990390>,
      < 1.250231, -0.625678, 2.008535>,
      < 1.263665, -0.644138, 2.008539>
    }
    triangle {
      < 1.263665, -0.644138, 2.008539>,
      < 1.250231, -0.625678, 2.008535>,
      < 1.250228, -0.625678, 2.021510>
    }
    triangle {
      < 1.263665, -0.644138, 2.008539>,
      < 1.250228, -0.625678, 2.021510>,
      < 1.263662, -0.644137, 2.021515>
    }
    triangle {
      < 1.263662, -0.644137, 2.021515>,
      < 1.250228, -0.625678, 2.021510>,
      < 1.232862, -0.635723, 2.021504>
    }
    triangle {
      < 1.263662, -0.644137, 2.021515>,
      < 1.232862, -0.635723, 2.021504>,
      < 1.248762, -0.657573, 2.021510>
    }
    triangle {
      < 1.248762, -0.657573, 2.021510>,
      < 1.232862, -0.635723, 2.021504>,
      < 1.225136, -0.640187, 2.050047>
    }
    triangle {
      < 1.248762, -0.657573, 2.021510>,
      < 1.225136, -0.640187, 2.050047>,
      < 1.242134, -0.663544, 2.050053>
    }
    triangle {
      < 1.242134, -0.663544, 2.050053>,
      < 1.225136, -0.640187, 2.050047>,
      < 1.171106, -0.671437, 2.063004>
    }
    triangle {
      < 1.242134, -0.663544, 2.050053>,
      < 1.171106, -0.671437, 2.063004>,
      < 1.195778, -0.705342, 2.063013>
    }
    triangle {
      < 1.195778, -0.705342, 2.063013>,
      < 1.171106, -0.671437, 2.063004>,
      < 1.140236, -0.689294, 2.047423>
    }
    triangle {
      < 1.195778, -0.705342, 2.063013>,
      < 1.140236, -0.689294, 2.047423>,
      < 1.169296, -0.729227, 2.047433>
    }
    triangle {
      < 1.169296, -0.729227, 2.047433>,
      < 1.140236, -0.689294, 2.047423>,
      < 1.117090, -0.702687, 2.013679>
    }
    triangle {
      < 1.169296, -0.729227, 2.047433>,
      < 1.117090, -0.702687, 2.013679>,
      < 1.149440, -0.747141, 2.013690>
    }
    triangle {
      < 1.149440, -0.747141, 2.013690>,
      < 1.117090, -0.702687, 2.013679>,
      < 1.113237, -0.704919, 1.990322>
    }
    triangle {
      < 1.149440, -0.747141, 2.013690>,
      < 1.113237, -0.704919, 1.990322>,
      < 1.146135, -0.750126, 1.990333>
    }
    triangle {
      < 1.146135, -0.750126, 1.990333>,
      < 1.113237, -0.704919, 1.990322>,
      < 1.113243, -0.704920, 1.966967>
    }
    triangle {
      < 1.146135, -0.750126, 1.990333>,
      < 1.113243, -0.704920, 1.966967>,
      < 1.146140, -0.750126, 1.966978>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.315104, -0.580659, 2.024128>,
      < 1.317762, -0.586616, 2.024129>
    }
    triangle {
      < 1.317762, -0.586616, 2.024129>,
      < 1.315104, -0.580659, 2.024128>,
      < 1.302396, -0.584803, 1.990387>
    }
    triangle {
      < 1.317762, -0.586616, 2.024129>,
      < 1.302396, -0.584803, 1.990387>,
      < 1.306193, -0.593312, 1.990388>
    }
    triangle {
      < 1.306193, -0.593312, 1.990388>,
      < 1.302396, -0.584803, 1.990387>,
      < 1.240929, -0.604830, 2.008531>
    }
    triangle {
      < 1.306193, -0.593312, 1.990388>,
      < 1.240929, -0.604830, 2.008531>,
      < 1.250231, -0.625678, 2.008535>
    }
    triangle {
      < 1.250231, -0.625678, 2.008535>,
      < 1.240929, -0.604830, 2.008531>,
      < 1.240926, -0.604829, 2.021507>
    }
    triangle {
      < 1.250231, -0.625678, 2.008535>,
      < 1.240926, -0.604829, 2.021507>,
      < 1.250228, -0.625678, 2.021510>
    }
    triangle {
      < 1.250228, -0.625678, 2.021510>,
      < 1.240926, -0.604829, 2.021507>,
      < 1.221850, -0.611045, 2.021501>
    }
    triangle {
      < 1.250228, -0.625678, 2.021510>,
      < 1.221850, -0.611045, 2.021501>,
      < 1.232862, -0.635723, 2.021504>
    }
    triangle {
      < 1.232862, -0.635723, 2.021504>,
      < 1.221850, -0.611045, 2.021501>,
      < 1.213366, -0.613807, 2.050044>
    }
    triangle {
      < 1.232862, -0.635723, 2.021504>,
      < 1.213366, -0.613807, 2.050044>,
      < 1.225136, -0.640187, 2.050047>
    }
    triangle {
      < 1.225136, -0.640187, 2.050047>,
      < 1.213366, -0.613807, 2.050044>,
      < 1.154019, -0.633143, 2.062998>
    }
    triangle {
      < 1.225136, -0.640187, 2.050047>,
      < 1.154019, -0.633143, 2.062998>,
      < 1.171106, -0.671437, 2.063004>
    }
    triangle {
      < 1.171106, -0.671437, 2.063004>,
      < 1.154019, -0.633143, 2.062998>,
      < 1.120112, -0.644192, 2.047416>
    }
    triangle {
      < 1.171106, -0.671437, 2.063004>,
      < 1.120112, -0.644192, 2.047416>,
      < 1.140236, -0.689294, 2.047423>
    }
    triangle {
      < 1.140236, -0.689294, 2.047423>,
      < 1.120112, -0.644192, 2.047416>,
      < 1.094688, -0.652480, 2.013671>
    }
    triangle {
      < 1.140236, -0.689294, 2.047423>,
      < 1.094688, -0.652480, 2.013671>,
      < 1.117090, -0.702687, 2.013679>
    }
    triangle {
      < 1.117090, -0.702687, 2.013679>,
      < 1.094688, -0.652480, 2.013671>,
      < 1.090454, -0.653861, 1.990314>
    }
    triangle {
      < 1.117090, -0.702687, 2.013679>,
      < 1.090454, -0.653861, 1.990314>,
      < 1.113237, -0.704919, 1.990322>
    }
    triangle {
      < 1.113237, -0.704919, 1.990322>,
      < 1.090454, -0.653861, 1.990314>,
      < 1.090461, -0.653860, 1.966958>
    }
    triangle {
      < 1.113237, -0.704919, 1.990322>,
      < 1.090461, -0.653860, 1.966958>,
      < 1.113243, -0.704920, 1.966967>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.346993, -0.570756, 2.024139>,
      < 1.313743, -0.574280, 2.024127>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.313743, -0.574280, 2.024127>,
      < 1.315104, -0.580659, 2.024128>
    }
    triangle {
      < 1.315104, -0.580659, 2.024128>,
      < 1.313743, -0.574280, 2.024127>,
      < 1.300451, -0.575690, 1.990386>
    }
    triangle {
      < 1.315104, -0.580659, 2.024128>,
      < 1.300451, -0.575690, 1.990386>,
      < 1.302396, -0.584803, 1.990387>
    }
    triangle {
      < 1.302396, -0.584803, 1.990387>,
      < 1.300451, -0.575690, 1.990386>,
      < 1.236163, -0.582502, 2.008530>
    }
    triangle {
      < 1.302396, -0.584803, 1.990387>,
      < 1.236163, -0.582502, 2.008530>,
      < 1.240929, -0.604830, 2.008531>
    }
    triangle {
      < 1.240929, -0.604830, 2.008531>,
      < 1.236163, -0.582502, 2.008530>,
      < 1.236159, -0.582502, 2.021505>
    }
    triangle {
      < 1.240929, -0.604830, 2.008531>,
      < 1.236159, -0.582502, 2.021505>,
      < 1.240926, -0.604829, 2.021507>
    }
    triangle {
      < 1.240926, -0.604829, 2.021507>,
      < 1.236159, -0.582502, 2.021505>,
      < 1.216210, -0.584617, 2.021499>
    }
    triangle {
      < 1.240926, -0.604829, 2.021507>,
      < 1.216210, -0.584617, 2.021499>,
      < 1.221850, -0.611045, 2.021501>
    }
    triangle {
      < 1.221850, -0.611045, 2.021501>,
      < 1.216210, -0.584617, 2.021499>,
      < 1.207336, -0.585557, 2.050041>
    }
    triangle {
      < 1.221850, -0.611045, 2.021501>,
      < 1.207336, -0.585557, 2.050041>,
      < 1.213366, -0.613807, 2.050044>
    }
    triangle {
      < 1.213366, -0.613807, 2.050044>,
      < 1.207336, -0.585557, 2.050041>,
      < 1.145266, -0.592135, 2.062995>
    }
    triangle {
      < 1.213366, -0.613807, 2.050044>,
      < 1.145266, -0.592135, 2.062995>,
      < 1.154019, -0.633143, 2.062998>
    }
    triangle {
      < 1.154019, -0.633143, 2.062998>,
      < 1.145266, -0.592135, 2.062995>,
      < 1.109802, -0.595893, 2.047412>
    }
    triangle {
      < 1.154019, -0.633143, 2.062998>,
      < 1.109802, -0.595893, 2.047412>,
      < 1.120112, -0.644192, 2.047416>
    }
    triangle {
      < 1.120112, -0.644192, 2.047416>,
      < 1.109802, -0.595893, 2.047412>,
      < 1.083211, -0.598713, 2.013668>
    }
    triangle {
      < 1.120112, -0.644192, 2.047416>,
      < 1.083211, -0.598713, 2.013668>,
      < 1.094688, -0.652480, 2.013671>
    }
    triangle {
      < 1.094688, -0.652480, 2.013671>,
      < 1.083211, -0.598713, 2.013668>,
      < 1.078785, -0.599183, 1.990310>
    }
    triangle {
      < 1.094688, -0.652480, 2.013671>,
      < 1.078785, -0.599183, 1.990310>,
      < 1.090454, -0.653861, 1.990314>
    }
    triangle {
      < 1.090454, -0.653861, 1.990314>,
      < 1.078785, -0.599183, 1.990310>,
      < 1.078790, -0.599182, 1.966954>
    }
    triangle {
      < 1.090454, -0.653861, 1.990314>,
      < 1.078790, -0.599182, 1.966954>,
      < 1.090461, -0.653860, 1.966958>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.313738, -0.567757, 2.024127>,
      < 1.313743, -0.574280, 2.024127>
    }
    triangle {
      < 1.313743, -0.574280, 2.024127>,
      < 1.313738, -0.567757, 2.024127>,
      < 1.300442, -0.566371, 1.990387>
    }
    triangle {
      < 1.313743, -0.574280, 2.024127>,
      < 1.300442, -0.566371, 1.990387>,
      < 1.300451, -0.575690, 1.990386>
    }
    triangle {
      < 1.300451, -0.575690, 1.990386>,
      < 1.300442, -0.566371, 1.990387>,
      < 1.236143, -0.559672, 2.008530>
    }
    triangle {
      < 1.300451, -0.575690, 1.990386>,
      < 1.236143, -0.559672, 2.008530>,
      < 1.236163, -0.582502, 2.008530>
    }
    triangle {
      < 1.236163, -0.582502, 2.008530>,
      < 1.236143, -0.559672, 2.008530>,
      < 1.236139, -0.559672, 2.021505>
    }
    triangle {
      < 1.236163, -0.582502, 2.008530>,
      < 1.236139, -0.559672, 2.021505>,
      < 1.236159, -0.582502, 2.021505>
    }
    triangle {
      < 1.236159, -0.582502, 2.021505>,
      < 1.236139, -0.559672, 2.021505>,
      < 1.216186, -0.557593, 2.021499>
    }
    triangle {
      < 1.236159, -0.582502, 2.021505>,
      < 1.216186, -0.557593, 2.021499>,
      < 1.216210, -0.584617, 2.021499>
    }
    triangle {
      < 1.216210, -0.584617, 2.021499>,
      < 1.216186, -0.557593, 2.021499>,
      < 1.207310, -0.556670, 2.050041>
    }
    triangle {
      < 1.216210, -0.584617, 2.021499>,
      < 1.207310, -0.556670, 2.050041>,
      < 1.207336, -0.585557, 2.050041>
    }
    triangle {
      < 1.207336, -0.585557, 2.050041>,
      < 1.207310, -0.556670, 2.050041>,
      < 1.145228, -0.550203, 2.062995>
    }
    triangle {
      < 1.207336, -0.585557, 2.050041>,
      < 1.145228, -0.550203, 2.062995>,
      < 1.145266, -0.592135, 2.062995>
    }
    triangle {
      < 1.145266, -0.592135, 2.062995>,
      < 1.145228, -0.550203, 2.062995>,
      < 1.109759, -0.546506, 2.047413>
    }
    triangle {
      < 1.145266, -0.592135, 2.062995>,
      < 1.109759, -0.546506, 2.047413>,
      < 1.109802, -0.595893, 2.047412>
    }
    triangle {
      < 1.109802, -0.595893, 2.047412>,
      < 1.109759, -0.546506, 2.047413>,
      < 1.083163, -0.543734, 2.013667>
    }
    triangle {
      < 1.109802, -0.595893, 2.047412>,
      < 1.083163, -0.543734, 2.013667>,
      < 1.083211, -0.598713, 2.013668>
    }
    triangle {
      < 1.083211, -0.598713, 2.013668>,
      < 1.083163, -0.543734, 2.013667>,
      < 1.078734, -0.543272, 1.990310>
    }
    triangle {
      < 1.083211, -0.598713, 2.013668>,
      < 1.078734, -0.543272, 1.990310>,
      < 1.078785, -0.599183, 1.990310>
    }
    triangle {
      < 1.078785, -0.599183, 1.990310>,
      < 1.078734, -0.543272, 1.990310>,
      < 1.078740, -0.543272, 1.966954>
    }
    triangle {
      < 1.078785, -0.599183, 1.990310>,
      < 1.078740, -0.543272, 1.966954>,
      < 1.078790, -0.599182, 1.966954>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.315087, -0.561376, 2.024127>,
      < 1.313738, -0.567757, 2.024127>
    }
    triangle {
      < 1.313738, -0.567757, 2.024127>,
      < 1.315087, -0.561376, 2.024127>,
      < 1.302372, -0.557254, 1.990387>
    }
    triangle {
      < 1.313738, -0.567757, 2.024127>,
      < 1.302372, -0.557254, 1.990387>,
      < 1.300442, -0.566371, 1.990387>
    }
    triangle {
      < 1.300442, -0.566371, 1.990387>,
      < 1.302372, -0.557254, 1.990387>,
      < 1.240869, -0.537337, 2.008531>
    }
    triangle {
      < 1.300442, -0.566371, 1.990387>,
      < 1.240869, -0.537337, 2.008531>,
      < 1.236143, -0.559672, 2.008530>
    }
    triangle {
      < 1.236143, -0.559672, 2.008530>,
      < 1.240869, -0.537337, 2.008531>,
      < 1.240866, -0.537337, 2.021507>
    }
    triangle {
      < 1.236143, -0.559672, 2.008530>,
      < 1.240866, -0.537337, 2.021507>,
      < 1.236139, -0.559672, 2.021505>
    }
    triangle {
      < 1.236139, -0.559672, 2.021505>,
      < 1.240866, -0.537337, 2.021507>,
      < 1.221779, -0.531156, 2.021500>
    }
    triangle {
      < 1.236139, -0.559672, 2.021505>,
      < 1.221779, -0.531156, 2.021500>,
      < 1.216186, -0.557593, 2.021499>
    }
    triangle {
      < 1.216186, -0.557593, 2.021499>,
      < 1.221779, -0.531156, 2.021500>,
      < 1.213290, -0.528408, 2.050044>
    }
    triangle {
      < 1.216186, -0.557593, 2.021499>,
      < 1.213290, -0.528408, 2.050044>,
      < 1.207310, -0.556670, 2.050041>
    }
    triangle {
      < 1.207310, -0.556670, 2.050041>,
      < 1.213290, -0.528408, 2.050044>,
      < 1.153909, -0.509177, 2.062998>
    }
    triangle {
      < 1.207310, -0.556670, 2.050041>,
      < 1.153909, -0.509177, 2.062998>,
      < 1.145228, -0.550203, 2.062995>
    }
    triangle {
      < 1.145228, -0.550203, 2.062995>,
      < 1.153909, -0.509177, 2.062998>,
      < 1.119982, -0.498188, 2.047415>
    }
    triangle {
      < 1.145228, -0.550203, 2.062995>,
      < 1.119982, -0.498188, 2.047415>,
      < 1.109759, -0.546506, 2.047413>
    }
    triangle {
      < 1.109759, -0.546506, 2.047413>,
      < 1.119982, -0.498188, 2.047415>,
      < 1.094543, -0.489946, 2.013671>
    }
    triangle {
      < 1.109759, -0.546506, 2.047413>,
      < 1.094543, -0.489946, 2.013671>,
      < 1.083163, -0.543734, 2.013667>
    }
    triangle {
      < 1.083163, -0.543734, 2.013667>,
      < 1.094543, -0.489946, 2.013671>,
      < 1.090308, -0.488573, 1.990314>
    }
    triangle {
      < 1.083163, -0.543734, 2.013667>,
      < 1.090308, -0.488573, 1.990314>,
      < 1.078734, -0.543272, 1.990310>
    }
    triangle {
      < 1.078734, -0.543272, 1.990310>,
      < 1.090308, -0.488573, 1.990314>,
      < 1.090314, -0.488572, 1.966958>
    }
    triangle {
      < 1.078734, -0.543272, 1.990310>,
      < 1.090314, -0.488572, 1.966958>,
      < 1.078740, -0.543272, 1.966954>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.317734, -0.555414, 2.024128>,
      < 1.315087, -0.561376, 2.024127>
    }
    triangle {
      < 1.315087, -0.561376, 2.024127>,
      < 1.317734, -0.555414, 2.024128>,
      < 1.306154, -0.548739, 1.990389>
    }
    triangle {
      < 1.315087, -0.561376, 2.024127>,
      < 1.306154, -0.548739, 1.990389>,
      < 1.302372, -0.557254, 1.990387>
    }
    triangle {
      < 1.302372, -0.557254, 1.990387>,
      < 1.306154, -0.548739, 1.990389>,
      < 1.250134, -0.516472, 2.008535>
    }
    triangle {
      < 1.302372, -0.557254, 1.990387>,
      < 1.250134, -0.516472, 2.008535>,
      < 1.240869, -0.537337, 2.008531>
    }
    triangle {
      < 1.240869, -0.537337, 2.008531>,
      < 1.250134, -0.516472, 2.008535>,
      < 1.250130, -0.516472, 2.021510>
    }
    triangle {
      < 1.240869, -0.537337, 2.008531>,
      < 1.250130, -0.516472, 2.021510>,
      < 1.240866, -0.537337, 2.021507>
    }
    triangle {
      < 1.240866, -0.537337, 2.021507>,
      < 1.250130, -0.516472, 2.021510>,
      < 1.232747, -0.506458, 2.021504>
    }
    triangle {
      < 1.240866, -0.537337, 2.021507>,
      < 1.232747, -0.506458, 2.021504>,
      < 1.221779, -0.531156, 2.021500>
    }
    triangle {
      < 1.221779, -0.531156, 2.021500>,
      < 1.232747, -0.506458, 2.021504>,
      < 1.225014, -0.502007, 2.050047>
    }
    triangle {
      < 1.221779, -0.531156, 2.021500>,
      < 1.225014, -0.502007, 2.050047>,
      < 1.213290, -0.528408, 2.050044>
    }
    triangle {
      < 1.213290, -0.528408, 2.050044>,
      < 1.225014, -0.502007, 2.050047>,
      < 1.170927, -0.470854, 2.063004>
    }
    triangle {
      < 1.213290, -0.528408, 2.050044>,
      < 1.170927, -0.470854, 2.063004>,
      < 1.153909, -0.509177, 2.062998>
    }
    triangle {
      < 1.153909, -0.509177, 2.062998>,
      < 1.170927, -0.470854, 2.063004>,
      < 1.140026, -0.453051, 2.047423>
    }
    triangle {
      < 1.153909, -0.509177, 2.062998>,
      < 1.140026, -0.453051, 2.047423>,
      < 1.119982, -0.498188, 2.047415>
    }
    triangle {
      < 1.119982, -0.498188, 2.047415>,
      < 1.140026, -0.453051, 2.047423>,
      < 1.116857, -0.439700, 2.013679>
    }
    triangle {
      < 1.119982, -0.498188, 2.047415>,
      < 1.116857, -0.439700, 2.013679>,
      < 1.094543, -0.489946, 2.013671>
    }
    triangle {
      < 1.094543, -0.489946, 2.013671>,
      < 1.116857, -0.439700, 2.013679>,
      < 1.112999, -0.437475, 1.990322>
    }
    triangle {
      < 1.094543, -0.489946, 2.013671>,
      < 1.112999, -0.437475, 1.990322>,
      < 1.090308, -0.488573, 1.990314>
    }
    triangle {
      < 1.090308, -0.488573, 1.990314>,
      < 1.112999, -0.437475, 1.990322>,
      < 1.113006, -0.437475, 1.966966>
    }
    triangle {
      < 1.090308, -0.488573, 1.990314>,
      < 1.113006, -0.437475, 1.966966>,
      < 1.090314, -0.488572, 1.966958>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.321562, -0.550133, 2.024130>,
      < 1.317734, -0.555414, 2.024128>
    }
    triangle {
      < 1.317734, -0.555414, 2.024128>,
      < 1.321562, -0.550133, 2.024130>,
      < 1.311623, -0.541195, 1.990390>
    }
    triangle {
      < 1.317734, -0.555414, 2.024128>,
      < 1.311623, -0.541195, 1.990390>,
      < 1.306154, -0.548739, 1.990389>
    }
    triangle {
      < 1.306154, -0.548739, 1.990389>,
      < 1.311623, -0.541195, 1.990390>,
      < 1.263535, -0.497988, 2.008540>
    }
    triangle {
      < 1.306154, -0.548739, 1.990389>,
      < 1.263535, -0.497988, 2.008540>,
      < 1.250134, -0.516472, 2.008535>
    }
    triangle {
      < 1.250134, -0.516472, 2.008535>,
      < 1.263535, -0.497988, 2.008540>,
      < 1.263531, -0.497988, 2.021515>
    }
    triangle {
      < 1.250134, -0.516472, 2.008535>,
      < 1.263531, -0.497988, 2.021515>,
      < 1.250130, -0.516472, 2.021510>
    }
    triangle {
      < 1.250130, -0.516472, 2.021510>,
      < 1.263531, -0.497988, 2.021515>,
      < 1.248609, -0.484580, 2.021509>
    }
    triangle {
      < 1.250130, -0.516472, 2.021510>,
      < 1.248609, -0.484580, 2.021509>,
      < 1.232747, -0.506458, 2.021504>
    }
    triangle {
      < 1.232747, -0.506458, 2.021504>,
      < 1.248609, -0.484580, 2.021509>,
      < 1.241969, -0.478620, 2.050053>
    }
    triangle {
      < 1.232747, -0.506458, 2.021504>,
      < 1.241969, -0.478620, 2.050053>,
      < 1.225014, -0.502007, 2.050047>
    }
    triangle {
      < 1.225014, -0.502007, 2.050047>,
      < 1.241969, -0.478620, 2.050053>,
      < 1.195541, -0.436904, 2.063013>
    }
    triangle {
      < 1.225014, -0.502007, 2.050047>,
      < 1.195541, -0.436904, 2.063013>,
      < 1.170927, -0.470854, 2.063004>
    }
    triangle {
      < 1.170927, -0.470854, 2.063004>,
      < 1.195541, -0.436904, 2.063013>,
      < 1.169015, -0.413067, 2.047433>
    }
    triangle {
      < 1.170927, -0.470854, 2.063004>,
      < 1.169015, -0.413067, 2.047433>,
      < 1.140026, -0.453051, 2.047423>
    }
    triangle {
      < 1.140026, -0.453051, 2.047423>,
      < 1.169015, -0.413067, 2.047433>,
      < 1.149127, -0.395189, 2.013690>
    }
    triangle {
      < 1.140026, -0.453051, 2.047423>,
      < 1.149127, -0.395189, 2.013690>,
      < 1.116857, -0.439700, 2.013679>
    }
    triangle {
      < 1.116857, -0.439700, 2.013679>,
      < 1.149127, -0.395189, 2.013690>,
      < 1.145817, -0.392209, 1.990333>
    }
    triangle {
      < 1.116857, -0.439700, 2.013679>,
      < 1.145817, -0.392209, 1.990333>,
      < 1.112999, -0.437475, 1.990322>
    }
    triangle {
      < 1.112999, -0.437475, 1.990322>,
      < 1.145817, -0.392209, 1.990333>,
      < 1.145822, -0.392209, 1.966977>
    }
    triangle {
      < 1.112999, -0.437475, 1.990322>,
      < 1.145822, -0.392209, 1.966977>,
      < 1.113006, -0.437475, 1.966966>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.326406, -0.545764, 2.024131>,
      < 1.321562, -0.550133, 2.024130>
    }
    triangle {
      < 1.321562, -0.550133, 2.024130>,
      < 1.326406, -0.545764, 2.024131>,
      < 1.318542, -0.534951, 1.990393>
    }
    triangle {
      < 1.321562, -0.550133, 2.024130>,
      < 1.318542, -0.534951, 1.990393>,
      < 1.311623, -0.541195, 1.990390>
    }
    triangle {
      < 1.311623, -0.541195, 1.990390>,
      < 1.318542, -0.534951, 1.990393>,
      < 1.280486, -0.482695, 2.008545>
    }
    triangle {
      < 1.311623, -0.541195, 1.990390>,
      < 1.280486, -0.482695, 2.008545>,
      < 1.263535, -0.497988, 2.008540>
    }
    triangle {
      < 1.263535, -0.497988, 2.008540>,
      < 1.280486, -0.482695, 2.008545>,
      < 1.280481, -0.482695, 2.021521>
    }
    triangle {
      < 1.263535, -0.497988, 2.008540>,
      < 1.280481, -0.482695, 2.021521>,
      < 1.263531, -0.497988, 2.021515>
    }
    triangle {
      < 1.263531, -0.497988, 2.021515>,
      < 1.280481, -0.482695, 2.021521>,
      < 1.268672, -0.466477, 2.021516>
    }
    triangle {
      < 1.263531, -0.497988, 2.021515>,
      < 1.268672, -0.466477, 2.021516>,
      < 1.248609, -0.484580, 2.021509>
    }
    triangle {
      < 1.248609, -0.484580, 2.021509>,
      < 1.268672, -0.466477, 2.021516>,
      < 1.263416, -0.459268, 2.050061>
    }
    triangle {
      < 1.248609, -0.484580, 2.021509>,
      < 1.263416, -0.459268, 2.050061>,
      < 1.241969, -0.478620, 2.050053>
    }
    triangle {
      < 1.241969, -0.478620, 2.050053>,
      < 1.263416, -0.459268, 2.050061>,
      < 1.226673, -0.408813, 2.063024>
    }
    triangle {
      < 1.241969, -0.478620, 2.050053>,
      < 1.226673, -0.408813, 2.063024>,
      < 1.195541, -0.436904, 2.063013>
    }
    triangle {
      < 1.195541, -0.436904, 2.063013>,
      < 1.226673, -0.408813, 2.063024>,
      < 1.205682, -0.379982, 2.047446>
    }
    triangle {
      < 1.195541, -0.436904, 2.063013>,
      < 1.205682, -0.379982, 2.047446>,
      < 1.169015, -0.413067, 2.047433>
    }
    triangle {
      < 1.169015, -0.413067, 2.047433>,
      < 1.205682, -0.379982, 2.047446>,
      < 1.189945, -0.358359, 2.013704>
    }
    triangle {
      < 1.169015, -0.413067, 2.047433>,
      < 1.189945, -0.358359, 2.013704>,
      < 1.149127, -0.395189, 2.013690>
    }
    triangle {
      < 1.149127, -0.395189, 2.013690>,
      < 1.189945, -0.358359, 2.013704>,
      < 1.187327, -0.354755, 1.990348>
    }
    triangle {
      < 1.149127, -0.395189, 2.013690>,
      < 1.187327, -0.354755, 1.990348>,
      < 1.145817, -0.392209, 1.990333>
    }
    triangle {
      < 1.145817, -0.392209, 1.990333>,
      < 1.187327, -0.354755, 1.990348>,
      < 1.187334, -0.354755, 1.966992>
    }
    triangle {
      < 1.145817, -0.392209, 1.990333>,
      < 1.187334, -0.354755, 1.966992>,
      < 1.145822, -0.392209, 1.966977>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.332051, -0.542495, 2.024134>,
      < 1.326406, -0.545764, 2.024131>
    }
    triangle {
      < 1.326406, -0.545764, 2.024131>,
      < 1.332051, -0.542495, 2.024134>,
      < 1.326606, -0.530283, 1.990396>
    }
    triangle {
      < 1.326406, -0.545764, 2.024131>,
      < 1.326606, -0.530283, 1.990396>,
      < 1.318542, -0.534951, 1.990393>
    }
    triangle {
      < 1.318542, -0.534951, 1.990393>,
      < 1.326606, -0.530283, 1.990396>,
      < 1.300244, -0.471258, 2.008552>
    }
    triangle {
      < 1.318542, -0.534951, 1.990393>,
      < 1.300244, -0.471258, 2.008552>,
      < 1.280486, -0.482695, 2.008545>
    }
    triangle {
      < 1.280486, -0.482695, 2.008545>,
      < 1.300244, -0.471258, 2.008552>,
      < 1.300240, -0.471258, 2.021528>
    }
    triangle {
      < 1.280486, -0.482695, 2.008545>,
      < 1.300240, -0.471258, 2.021528>,
      < 1.280481, -0.482695, 2.021521>
    }
    triangle {
      < 1.280481, -0.482695, 2.021521>,
      < 1.300240, -0.471258, 2.021528>,
      < 1.292060, -0.452940, 2.021524>
    }
    triangle {
      < 1.280481, -0.482695, 2.021521>,
      < 1.292060, -0.452940, 2.021524>,
      < 1.268672, -0.466477, 2.021516>
    }
    triangle {
      < 1.268672, -0.466477, 2.021516>,
      < 1.292060, -0.452940, 2.021524>,
      < 1.288417, -0.444799, 2.050069>
    }
    triangle {
      < 1.268672, -0.466477, 2.021516>,
      < 1.288417, -0.444799, 2.050069>,
      < 1.263416, -0.459268, 2.050061>
    }
    triangle {
      < 1.263416, -0.459268, 2.050061>,
      < 1.288417, -0.444799, 2.050069>,
      < 1.262965, -0.387807, 2.063035>
    }
    triangle {
      < 1.263416, -0.459268, 2.050061>,
      < 1.262965, -0.387807, 2.063035>,
      < 1.226673, -0.408813, 2.063024>
    }
    triangle {
      < 1.226673, -0.408813, 2.063024>,
      < 1.262965, -0.387807, 2.063035>,
      < 1.248426, -0.355242, 2.047460>
    }
    triangle {
      < 1.226673, -0.408813, 2.063024>,
      < 1.248426, -0.355242, 2.047460>,
      < 1.205682, -0.379982, 2.047446>
    }
    triangle {
      < 1.205682, -0.379982, 2.047446>,
      < 1.248426, -0.355242, 2.047460>,
      < 1.237528, -0.330817, 2.013720>
    }
    triangle {
      < 1.205682, -0.379982, 2.047446>,
      < 1.237528, -0.330817, 2.013720>,
      < 1.189945, -0.358359, 2.013704>
    }
    triangle {
      < 1.189945, -0.358359, 2.013704>,
      < 1.237528, -0.330817, 2.013720>,
      < 1.235716, -0.326747, 1.990364>
    }
    triangle {
      < 1.189945, -0.358359, 2.013704>,
      < 1.235716, -0.326747, 1.990364>,
      < 1.187327, -0.354755, 1.990348>
    }
    triangle {
      < 1.187327, -0.354755, 1.990348>,
      < 1.235716, -0.326747, 1.990364>,
      < 1.235722, -0.326747, 1.967009>
    }
    triangle {
      < 1.187327, -0.354755, 1.990348>,
      < 1.235722, -0.326747, 1.967009>,
      < 1.187334, -0.354755, 1.966992>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.345242, -0.573171, 2.024138>,
      < 1.338252, -0.540473, 2.024136>
    }
    triangle {
      < 1.346993, -0.570756, 2.024139>,
      < 1.338252, -0.540473, 2.024136>,
      < 1.332051, -0.542495, 2.024134>
    }
    triangle {
      < 1.332051, -0.542495, 2.024134>,
      < 1.338252, -0.540473, 2.024136>,
      < 1.335466, -0.527394, 1.990399>
    }
    triangle {
      < 1.332051, -0.542495, 2.024134>,
      < 1.335466, -0.527394, 1.990399>,
      < 1.326606, -0.530283, 1.990396>
    }
    triangle {
      < 1.326606, -0.530283, 1.990396>,
      < 1.335466, -0.527394, 1.990399>,
      < 1.321949, -0.464178, 2.008559>
    }
    triangle {
      < 1.326606, -0.530283, 1.990396>,
      < 1.321949, -0.464178, 2.008559>,
      < 1.300244, -0.471258, 2.008552>
    }
    triangle {
      < 1.300244, -0.471258, 2.008552>,
      < 1.321949, -0.464178, 2.008559>,
      < 1.321946, -0.464179, 2.021535>
    }
    triangle {
      < 1.300244, -0.471258, 2.008552>,
      < 1.321946, -0.464179, 2.021535>,
      < 1.300240, -0.471258, 2.021528>
    }
    triangle {
      < 1.300240, -0.471258, 2.021528>,
      < 1.321946, -0.464179, 2.021535>,
      < 1.317751, -0.444560, 2.021533>
    }
    triangle {
      < 1.300240, -0.471258, 2.021528>,
      < 1.317751, -0.444560, 2.021533>,
      < 1.292060, -0.452940, 2.021524>
    }
    triangle {
      < 1.292060, -0.452940, 2.021524>,
      < 1.317751, -0.444560, 2.021533>,
      < 1.315881, -0.435840, 2.050079>
    }
    triangle {
      < 1.292060, -0.452940, 2.021524>,
      < 1.315881, -0.435840, 2.050079>,
      < 1.288417, -0.444799, 2.050069>
    }
    triangle {
      < 1.288417, -0.444799, 2.050069>,
      < 1.315881, -0.435840, 2.050079>,
      < 1.302830, -0.374805, 2.063050>
    }
    triangle {
      < 1.288417, -0.444799, 2.050069>,
      < 1.302830, -0.374805, 2.063050>,
      < 1.262965, -0.387807, 2.063035>
    }
    triangle {
      < 1.262965, -0.387807, 2.063035>,
      < 1.302830, -0.374805, 2.063050>,
      < 1.295379, -0.339927, 2.047477>
    }
    triangle {
      < 1.262965, -0.387807, 2.063035>,
      < 1.295379, -0.339927, 2.047477>,
      < 1.248426, -0.355242, 2.047460>
    }
    triangle {
      < 1.248426, -0.355242, 2.047460>,
      < 1.295379, -0.339927, 2.047477>,
      < 1.289796, -0.313769, 2.013738>
    }
    triangle {
      < 1.248426, -0.355242, 2.047460>,
      < 1.289796, -0.313769, 2.013738>,
      < 1.237528, -0.330817, 2.013720>
    }
    triangle {
      < 1.237528, -0.330817, 2.013720>,
      < 1.289796, -0.313769, 2.013738>,
      < 1.288870, -0.309410, 1.990383>
    }
    triangle {
      < 1.237528, -0.330817, 2.013720>,
      < 1.288870, -0.309410, 1.990383>,
      < 1.235716, -0.326747, 1.990364>
    }
    triangle {
      < 1.235716, -0.326747, 1.990364>,
      < 1.288870, -0.309410, 1.990383>,
      < 1.288876, -0.309409, 1.967027>
    }
    triangle {
      < 1.235716, -0.326747, 1.990364>,
      < 1.288876, -0.309409, 1.967027>,
      < 1.235722, -0.326747, 1.967009>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.344739, -0.539784, 2.024137>,
      < 1.338252, -0.540473, 2.024136>
    }
    triangle {
      < 1.338252, -0.540473, 2.024136>,
      < 1.344739, -0.539784, 2.024137>,
      < 1.344732, -0.526409, 1.990402>
    }
    triangle {
      < 1.338252, -0.540473, 2.024136>,
      < 1.344732, -0.526409, 1.990402>,
      < 1.335466, -0.527394, 1.990399>
    }
    triangle {
      < 1.335466, -0.527394, 1.990399>,
      < 1.344732, -0.526409, 1.990402>,
      < 1.344650, -0.461766, 2.008567>
    }
    triangle {
      < 1.335466, -0.527394, 1.990399>,
      < 1.344650, -0.461766, 2.008567>,
      < 1.321949, -0.464178, 2.008559>
    }
    triangle {
      < 1.321949, -0.464178, 2.008559>,
      < 1.344650, -0.461766, 2.008567>,
      < 1.344647, -0.461765, 2.021542>
    }
    triangle {
      < 1.321949, -0.464178, 2.008559>,
      < 1.344647, -0.461765, 2.021542>,
      < 1.321946, -0.464179, 2.021535>
    }
    triangle {
      < 1.321946, -0.464179, 2.021535>,
      < 1.344647, -0.461765, 2.021542>,
      < 1.344623, -0.441704, 2.021543>
    }
    triangle {
      < 1.321946, -0.464179, 2.021535>,
      < 1.344623, -0.441704, 2.021543>,
      < 1.317751, -0.444560, 2.021533>
    }
    triangle {
      < 1.317751, -0.444560, 2.021533>,
      < 1.344623, -0.441704, 2.021543>,
      < 1.344605, -0.432787, 2.050089>
    }
    triangle {
      < 1.317751, -0.444560, 2.021533>,
      < 1.344605, -0.432787, 2.050089>,
      < 1.315881, -0.435840, 2.050079>
    }
    triangle {
      < 1.315881, -0.435840, 2.050079>,
      < 1.344605, -0.432787, 2.050089>,
      < 1.344528, -0.370373, 2.063064>
    }
    triangle {
      < 1.315881, -0.435840, 2.050079>,
      < 1.344528, -0.370373, 2.063064>,
      < 1.302830, -0.374805, 2.063050>
    }
    triangle {
      < 1.302830, -0.374805, 2.063050>,
      < 1.344528, -0.370373, 2.063064>,
      < 1.344490, -0.334707, 2.047494>
    }
    triangle {
      < 1.302830, -0.374805, 2.063050>,
      < 1.344490, -0.334707, 2.047494>,
      < 1.295379, -0.339927, 2.047477>
    }
    triangle {
      < 1.295379, -0.339927, 2.047477>,
      < 1.344490, -0.334707, 2.047494>,
      < 1.344467, -0.307959, 2.013758>
    }
    triangle {
      < 1.295379, -0.339927, 2.047477>,
      < 1.344467, -0.307959, 2.013758>,
      < 1.289796, -0.313769, 2.013738>
    }
    triangle {
      < 1.289796, -0.313769, 2.013738>,
      < 1.344467, -0.307959, 2.013758>,
      < 1.344468, -0.303501, 1.990402>
    }
    triangle {
      < 1.289796, -0.313769, 2.013738>,
      < 1.344468, -0.303501, 1.990402>,
      < 1.288870, -0.309410, 1.990383>
    }
    triangle {
      < 1.288870, -0.309410, 1.990383>,
      < 1.344468, -0.303501, 1.990402>,
      < 1.344474, -0.303500, 1.967046>
    }
    triangle {
      < 1.288870, -0.309410, 1.990383>,
      < 1.344474, -0.303500, 1.967046>,
      < 1.288876, -0.309409, 1.967027>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.351226, -0.540457, 2.024140>,
      < 1.344739, -0.539784, 2.024137>
    }
    triangle {
      < 1.344739, -0.539784, 2.024137>,
      < 1.351226, -0.540457, 2.024140>,
      < 1.354000, -0.527372, 1.990405>
    }
    triangle {
      < 1.344739, -0.539784, 2.024137>,
      < 1.354000, -0.527372, 1.990405>,
      < 1.344732, -0.526409, 1.990402>
    }
    triangle {
      < 1.344732, -0.526409, 1.990402>,
      < 1.354000, -0.527372, 1.990405>,
      < 1.367358, -0.464125, 2.008575>
    }
    triangle {
      < 1.344732, -0.526409, 1.990402>,
      < 1.367358, -0.464125, 2.008575>,
      < 1.344650, -0.461766, 2.008567>
    }
    triangle {
      < 1.344650, -0.461766, 2.008567>,
      < 1.367358, -0.464125, 2.008575>,
      < 1.367355, -0.464125, 2.021551>
    }
    triangle {
      < 1.344650, -0.461766, 2.008567>,
      < 1.367355, -0.464125, 2.021551>,
      < 1.344647, -0.461765, 2.021542>
    }
    triangle {
      < 1.344647, -0.461765, 2.021542>,
      < 1.367355, -0.464125, 2.021551>,
      < 1.371502, -0.444497, 2.021552>
    }
    triangle {
      < 1.344647, -0.461765, 2.021542>,
      < 1.371502, -0.444497, 2.021552>,
      < 1.344623, -0.441704, 2.021543>
    }
    triangle {
      < 1.344623, -0.441704, 2.021543>,
      < 1.371502, -0.444497, 2.021552>,
      < 1.373338, -0.435773, 2.050099>
    }
    triangle {
      < 1.344623, -0.441704, 2.021543>,
      < 1.373338, -0.435773, 2.050099>,
      < 1.344605, -0.432787, 2.050089>
    }
    triangle {
      < 1.344605, -0.432787, 2.050089>,
      < 1.373338, -0.435773, 2.050099>,
      < 1.386236, -0.374706, 2.063079>
    }
    triangle {
      < 1.344605, -0.432787, 2.050089>,
      < 1.386236, -0.374706, 2.063079>,
      < 1.344528, -0.370373, 2.063064>
    }
    triangle {
      < 1.344528, -0.370373, 2.063064>,
      < 1.386236, -0.374706, 2.063079>,
      < 1.393614, -0.339812, 2.047511>
    }
    triangle {
      < 1.344528, -0.370373, 2.063064>,
      < 1.393614, -0.339812, 2.047511>,
      < 1.344490, -0.334707, 2.047494>
    }
    triangle {
      < 1.344490, -0.334707, 2.047494>,
      < 1.393614, -0.339812, 2.047511>,
      < 1.399150, -0.313640, 2.013777>
    }
    triangle {
      < 1.344490, -0.334707, 2.047494>,
      < 1.399150, -0.313640, 2.013777>,
      < 1.344467, -0.307959, 2.013758>
    }
    triangle {
      < 1.344467, -0.307959, 2.013758>,
      < 1.399150, -0.313640, 2.013777>,
      < 1.400078, -0.309278, 1.990421>
    }
    triangle {
      < 1.344467, -0.307959, 2.013758>,
      < 1.400078, -0.309278, 1.990421>,
      < 1.344468, -0.303501, 1.990402>
    }
    triangle {
      < 1.344468, -0.303501, 1.990402>,
      < 1.400078, -0.309278, 1.990421>,
      < 1.400084, -0.309278, 1.967065>
    }
    triangle {
      < 1.344468, -0.303501, 1.990402>,
      < 1.400084, -0.309278, 1.967065>,
      < 1.344474, -0.303500, 1.967046>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.357434, -0.542466, 2.024143>,
      < 1.351226, -0.540457, 2.024140>
    }
    triangle {
      < 1.351226, -0.540457, 2.024140>,
      < 1.357434, -0.542466, 2.024143>,
      < 1.362866, -0.530241, 1.990408>
    }
    triangle {
      < 1.351226, -0.540457, 2.024140>,
      < 1.362866, -0.530241, 1.990408>,
      < 1.354000, -0.527372, 1.990405>
    }
    triangle {
      < 1.354000, -0.527372, 1.990405>,
      < 1.362866, -0.530241, 1.990408>,
      < 1.389080, -0.471153, 2.008583>
    }
    triangle {
      < 1.354000, -0.527372, 1.990405>,
      < 1.389080, -0.471153, 2.008583>,
      < 1.367358, -0.464125, 2.008575>
    }
    triangle {
      < 1.367358, -0.464125, 2.008575>,
      < 1.389080, -0.471153, 2.008583>,
      < 1.389076, -0.471153, 2.021558>
    }
    triangle {
      < 1.367358, -0.464125, 2.008575>,
      < 1.389076, -0.471153, 2.021558>,
      < 1.367355, -0.464125, 2.021551>
    }
    triangle {
      < 1.367355, -0.464125, 2.021551>,
      < 1.389076, -0.471153, 2.021558>,
      < 1.397213, -0.452815, 2.021561>
    }
    triangle {
      < 1.367355, -0.464125, 2.021551>,
      < 1.397213, -0.452815, 2.021561>,
      < 1.371502, -0.444497, 2.021552>
    }
    triangle {
      < 1.371502, -0.444497, 2.021552>,
      < 1.397213, -0.452815, 2.021561>,
      < 1.400822, -0.444664, 2.050108>
    }
    triangle {
      < 1.371502, -0.444497, 2.021552>,
      < 1.400822, -0.444664, 2.050108>,
      < 1.373338, -0.435773, 2.050099>
    }
    triangle {
      < 1.373338, -0.435773, 2.050099>,
      < 1.400822, -0.444664, 2.050108>,
      < 1.426133, -0.387615, 2.063092>
    }
    triangle {
      < 1.373338, -0.435773, 2.050099>,
      < 1.426133, -0.387615, 2.063092>,
      < 1.386236, -0.374706, 2.063079>
    }
    triangle {
      < 1.386236, -0.374706, 2.063079>,
      < 1.426133, -0.387615, 2.063092>,
      < 1.440602, -0.355015, 2.047527>
    }
    triangle {
      < 1.386236, -0.374706, 2.063079>,
      < 1.440602, -0.355015, 2.047527>,
      < 1.393614, -0.339812, 2.047511>
    }
    triangle {
      < 1.393614, -0.339812, 2.047511>,
      < 1.440602, -0.355015, 2.047527>,
      < 1.451460, -0.330564, 2.013794>
    }
    triangle {
      < 1.393614, -0.339812, 2.047511>,
      < 1.451460, -0.330564, 2.013794>,
      < 1.399150, -0.313640, 2.013777>
    }
    triangle {
      < 1.399150, -0.313640, 2.013777>,
      < 1.451460, -0.330564, 2.013794>,
      < 1.453274, -0.326489, 1.990439>
    }
    triangle {
      < 1.399150, -0.313640, 2.013777>,
      < 1.453274, -0.326489, 1.990439>,
      < 1.400078, -0.309278, 1.990421>
    }
    triangle {
      < 1.400078, -0.309278, 1.990421>,
      < 1.453274, -0.326489, 1.990439>,
      < 1.453280, -0.326489, 1.967083>
    }
    triangle {
      < 1.400078, -0.309278, 1.990421>,
      < 1.453280, -0.326489, 1.967083>,
      < 1.400084, -0.309278, 1.967065>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.363086, -0.545720, 2.024144>,
      < 1.357434, -0.542466, 2.024143>
    }
    triangle {
      < 1.357434, -0.542466, 2.024143>,
      < 1.363086, -0.545720, 2.024144>,
      < 1.370942, -0.534890, 1.990411>
    }
    triangle {
      < 1.357434, -0.542466, 2.024143>,
      < 1.370942, -0.534890, 1.990411>,
      < 1.362866, -0.530241, 1.990408>
    }
    triangle {
      < 1.362866, -0.530241, 1.990408>,
      < 1.370942, -0.534890, 1.990411>,
      < 1.408866, -0.482542, 2.008590>
    }
    triangle {
      < 1.362866, -0.530241, 1.990408>,
      < 1.408866, -0.482542, 2.008590>,
      < 1.389080, -0.471153, 2.008583>
    }
    triangle {
      < 1.389080, -0.471153, 2.008583>,
      < 1.408866, -0.482542, 2.008590>,
      < 1.408862, -0.482542, 2.021565>
    }
    triangle {
      < 1.389080, -0.471153, 2.008583>,
      < 1.408862, -0.482542, 2.021565>,
      < 1.389076, -0.471153, 2.021558>
    }
    triangle {
      < 1.389076, -0.471153, 2.021558>,
      < 1.408862, -0.482542, 2.021565>,
      < 1.420633, -0.466297, 2.021569>
    }
    triangle {
      < 1.389076, -0.471153, 2.021558>,
      < 1.420633, -0.466297, 2.021569>,
      < 1.397213, -0.452815, 2.021561>
    }
    triangle {
      < 1.397213, -0.452815, 2.021561>,
      < 1.420633, -0.466297, 2.021569>,
      < 1.425858, -0.459076, 2.050117>
    }
    triangle {
      < 1.397213, -0.452815, 2.021561>,
      < 1.425858, -0.459076, 2.050117>,
      < 1.400822, -0.444664, 2.050108>
    }
    triangle {
      < 1.400822, -0.444664, 2.050108>,
      < 1.425858, -0.459076, 2.050117>,
      < 1.462474, -0.408535, 2.063104>
    }
    triangle {
      < 1.400822, -0.444664, 2.050108>,
      < 1.462474, -0.408535, 2.063104>,
      < 1.426133, -0.387615, 2.063092>
    }
    triangle {
      < 1.426133, -0.387615, 2.063092>,
      < 1.462474, -0.408535, 2.063104>,
      < 1.483404, -0.379652, 2.047541>
    }
    triangle {
      < 1.426133, -0.387615, 2.063092>,
      < 1.483404, -0.379652, 2.047541>,
      < 1.440602, -0.355015, 2.047527>
    }
    triangle {
      < 1.440602, -0.355015, 2.047527>,
      < 1.483404, -0.379652, 2.047541>,
      < 1.499107, -0.357993, 2.013811>
    }
    triangle {
      < 1.440602, -0.355015, 2.047527>,
      < 1.499107, -0.357993, 2.013811>,
      < 1.451460, -0.330564, 2.013794>
    }
    triangle {
      < 1.451460, -0.330564, 2.013794>,
      < 1.499107, -0.357993, 2.013811>,
      < 1.501729, -0.354383, 1.990456>
    }
    triangle {
      < 1.451460, -0.330564, 2.013794>,
      < 1.501729, -0.354383, 1.990456>,
      < 1.453274, -0.326489, 1.990439>
    }
    triangle {
      < 1.453274, -0.326489, 1.990439>,
      < 1.501729, -0.354383, 1.990456>,
      < 1.501734, -0.354382, 1.967101>
    }
    triangle {
      < 1.453274, -0.326489, 1.990439>,
      < 1.501734, -0.354382, 1.967101>,
      < 1.453280, -0.326489, 1.967083>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.367939, -0.550078, 2.024146>,
      < 1.363086, -0.545720, 2.024144>
    }
    triangle {
      < 1.363086, -0.545720, 2.024144>,
      < 1.367939, -0.550078, 2.024146>,
      < 1.377875, -0.541115, 1.990413>
    }
    triangle {
      < 1.363086, -0.545720, 2.024144>,
      < 1.377875, -0.541115, 1.990413>,
      < 1.370942, -0.534890, 1.990411>
    }
    triangle {
      < 1.370942, -0.534890, 1.990411>,
      < 1.377875, -0.541115, 1.990413>,
      < 1.425852, -0.497796, 2.008596>
    }
    triangle {
      < 1.370942, -0.534890, 1.990411>,
      < 1.425852, -0.497796, 2.008596>,
      < 1.408866, -0.482542, 2.008590>
    }
    triangle {
      < 1.408866, -0.482542, 2.008590>,
      < 1.425852, -0.497796, 2.008596>,
      < 1.425849, -0.497796, 2.021571>
    }
    triangle {
      < 1.408866, -0.482542, 2.008590>,
      < 1.425849, -0.497796, 2.021571>,
      < 1.408862, -0.482542, 2.021565>
    }
    triangle {
      < 1.408862, -0.482542, 2.021565>,
      < 1.425849, -0.497796, 2.021571>,
      < 1.440739, -0.484352, 2.021576>
    }
    triangle {
      < 1.408862, -0.482542, 2.021565>,
      < 1.440739, -0.484352, 2.021576>,
      < 1.420633, -0.466297, 2.021569>
    }
    triangle {
      < 1.420633, -0.466297, 2.021569>,
      < 1.440739, -0.484352, 2.021576>,
      < 1.447350, -0.478377, 2.050124>
    }
    triangle {
      < 1.420633, -0.466297, 2.021569>,
      < 1.447350, -0.478377, 2.050124>,
      < 1.425858, -0.459076, 2.050117>
    }
    triangle {
      < 1.425858, -0.459076, 2.050117>,
      < 1.447350, -0.478377, 2.050124>,
      < 1.493673, -0.436551, 2.063116>
    }
    triangle {
      < 1.425858, -0.459076, 2.050117>,
      < 1.493673, -0.436551, 2.063116>,
      < 1.462474, -0.408535, 2.063104>
    }
    triangle {
      < 1.462474, -0.408535, 2.063104>,
      < 1.493673, -0.436551, 2.063116>,
      < 1.520150, -0.412651, 2.047555>
    }
    triangle {
      < 1.462474, -0.408535, 2.063104>,
      < 1.520150, -0.412651, 2.047555>,
      < 1.483404, -0.379652, 2.047541>
    }
    triangle {
      < 1.483404, -0.379652, 2.047541>,
      < 1.520150, -0.412651, 2.047555>,
      < 1.540013, -0.394726, 2.013825>
    }
    triangle {
      < 1.483404, -0.379652, 2.047541>,
      < 1.540013, -0.394726, 2.013825>,
      < 1.499107, -0.357993, 2.013811>
    }
    triangle {
      < 1.499107, -0.357993, 2.013811>,
      < 1.540013, -0.394726, 2.013825>,
      < 1.543328, -0.391738, 1.990470>
    }
    triangle {
      < 1.499107, -0.357993, 2.013811>,
      < 1.543328, -0.391738, 1.990470>,
      < 1.501729, -0.354383, 1.990456>
    }
    triangle {
      < 1.501729, -0.354383, 1.990456>,
      < 1.543328, -0.391738, 1.990470>,
      < 1.543334, -0.391738, 1.967114>
    }
    triangle {
      < 1.501729, -0.354383, 1.990456>,
      < 1.543334, -0.391738, 1.967114>,
      < 1.501734, -0.354382, 1.967101>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.371781, -0.555350, 2.024148>,
      < 1.367939, -0.550078, 2.024146>
    }
    triangle {
      < 1.367939, -0.550078, 2.024146>,
      < 1.371781, -0.555350, 2.024148>,
      < 1.383362, -0.548647, 1.990415>
    }
    triangle {
      < 1.367939, -0.550078, 2.024146>,
      < 1.383362, -0.548647, 1.990415>,
      < 1.377875, -0.541115, 1.990413>
    }
    triangle {
      < 1.377875, -0.541115, 1.990413>,
      < 1.383362, -0.548647, 1.990415>,
      < 1.439296, -0.516248, 2.008600>
    }
    triangle {
      < 1.377875, -0.541115, 1.990413>,
      < 1.439296, -0.516248, 2.008600>,
      < 1.425852, -0.497796, 2.008596>
    }
    triangle {
      < 1.425852, -0.497796, 2.008596>,
      < 1.439296, -0.516248, 2.008600>,
      < 1.439293, -0.516248, 2.021575>
    }
    triangle {
      < 1.425852, -0.497796, 2.008596>,
      < 1.439293, -0.516248, 2.021575>,
      < 1.425849, -0.497796, 2.021571>
    }
    triangle {
      < 1.425849, -0.497796, 2.021571>,
      < 1.439293, -0.516248, 2.021575>,
      < 1.456653, -0.506193, 2.021581>
    }
    triangle {
      < 1.425849, -0.497796, 2.021571>,
      < 1.456653, -0.506193, 2.021581>,
      < 1.440739, -0.484352, 2.021576>
    }
    triangle {
      < 1.440739, -0.484352, 2.021576>,
      < 1.456653, -0.506193, 2.021581>,
      < 1.464361, -0.501723, 2.050130>
    }
    triangle {
      < 1.440739, -0.484352, 2.021576>,
      < 1.464361, -0.501723, 2.050130>,
      < 1.447350, -0.478377, 2.050124>
    }
    triangle {
      < 1.447350, -0.478377, 2.050124>,
      < 1.464361, -0.501723, 2.050130>,
      < 1.518367, -0.470442, 2.063124>
    }
    triangle {
      < 1.447350, -0.478377, 2.050124>,
      < 1.518367, -0.470442, 2.063124>,
      < 1.493673, -0.436551, 2.063116>
    }
    triangle {
      < 1.493673, -0.436551, 2.063116>,
      < 1.518367, -0.470442, 2.063124>,
      < 1.549234, -0.452566, 2.047564>
    }
    triangle {
      < 1.493673, -0.436551, 2.063116>,
      < 1.549234, -0.452566, 2.047564>,
      < 1.520150, -0.412651, 2.047555>
    }
    triangle {
      < 1.520150, -0.412651, 2.047555>,
      < 1.549234, -0.452566, 2.047564>,
      < 1.572389, -0.439160, 2.013836>
    }
    triangle {
      < 1.520150, -0.412651, 2.047555>,
      < 1.572389, -0.439160, 2.013836>,
      < 1.540013, -0.394726, 2.013825>
    }
    triangle {
      < 1.540013, -0.394726, 2.013825>,
      < 1.572389, -0.439160, 2.013836>,
      < 1.576253, -0.436925, 1.990482>
    }
    triangle {
      < 1.540013, -0.394726, 2.013825>,
      < 1.576253, -0.436925, 1.990482>,
      < 1.543328, -0.391738, 1.990470>
    }
    triangle {
      < 1.543328, -0.391738, 1.990470>,
      < 1.576253, -0.436925, 1.990482>,
      < 1.576259, -0.436925, 1.967126>
    }
    triangle {
      < 1.543328, -0.391738, 1.990470>,
      < 1.576259, -0.436925, 1.967126>,
      < 1.543334, -0.391738, 1.967114>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.342657, -0.571682, 2.024137>,
      < 1.374442, -0.561305, 2.024148>
    }
    triangle {
      < 1.345242, -0.573171, 2.024138>,
      < 1.374442, -0.561305, 2.024148>,
      < 1.371781, -0.555350, 2.024148>
    }
    triangle {
      < 1.371781, -0.555350, 2.024148>,
      < 1.374442, -0.561305, 2.024148>,
      < 1.387165, -0.557155, 1.990416>
    }
    triangle {
      < 1.371781, -0.555350, 2.024148>,
      < 1.387165, -0.557155, 1.990416>,
      < 1.383362, -0.548647, 1.990415>
    }
    triangle {
      < 1.383362, -0.548647, 1.990415>,
      < 1.387165, -0.557155, 1.990416>,
      < 1.448611, -0.537090, 2.008603>
    }
    triangle {
      < 1.383362, -0.548647, 1.990415>,
      < 1.448611, -0.537090, 2.008603>,
      < 1.439296, -0.516248, 2.008600>
    }
    triangle {
      < 1.439296, -0.516248, 2.008600>,
      < 1.448611, -0.537090, 2.008603>,
      < 1.448608, -0.537091, 2.021579>
    }
    triangle {
      < 1.439296, -0.516248, 2.008600>,
      < 1.448608, -0.537091, 2.021579>,
      < 1.439293, -0.516248, 2.021575>
    }
    triangle {
      < 1.439293, -0.516248, 2.021575>,
      < 1.448608, -0.537091, 2.021579>,
      < 1.467678, -0.530864, 2.021585>
    }
    triangle {
      < 1.439293, -0.516248, 2.021575>,
      < 1.467678, -0.530864, 2.021585>,
      < 1.456653, -0.506193, 2.021581>
    }
    triangle {
      < 1.456653, -0.506193, 2.021581>,
      < 1.467678, -0.530864, 2.021585>,
      < 1.476147, -0.528097, 2.050134>
    }
    triangle {
      < 1.456653, -0.506193, 2.021581>,
      < 1.476147, -0.528097, 2.050134>,
      < 1.464361, -0.501723, 2.050130>
    }
    triangle {
      < 1.464361, -0.501723, 2.050130>,
      < 1.476147, -0.528097, 2.050134>,
      < 1.535477, -0.508726, 2.063130>
    }
    triangle {
      < 1.464361, -0.501723, 2.050130>,
      < 1.535477, -0.508726, 2.063130>,
      < 1.518367, -0.470442, 2.063124>
    }
    triangle {
      < 1.518367, -0.470442, 2.063124>,
      < 1.535477, -0.508726, 2.063130>,
      < 1.569384, -0.497656, 2.047571>
    }
    triangle {
      < 1.518367, -0.470442, 2.063124>,
      < 1.569384, -0.497656, 2.047571>,
      < 1.549234, -0.452566, 2.047564>
    }
    triangle {
      < 1.549234, -0.452566, 2.047564>,
      < 1.569384, -0.497656, 2.047571>,
      < 1.594821, -0.489354, 2.013844>
    }
    triangle {
      < 1.549234, -0.452566, 2.047564>,
      < 1.594821, -0.489354, 2.013844>,
      < 1.572389, -0.439160, 2.013836>
    }
    triangle {
      < 1.572389, -0.439160, 2.013836>,
      < 1.594821, -0.489354, 2.013844>,
      < 1.599065, -0.487971, 1.990490>
    }
    triangle {
      < 1.572389, -0.439160, 2.013836>,
      < 1.599065, -0.487971, 1.990490>,
      < 1.576253, -0.436925, 1.990482>
    }
    triangle {
      < 1.576253, -0.436925, 1.990482>,
      < 1.599065, -0.487971, 1.990490>,
      < 1.599070, -0.487970, 1.967134>
    }
    triangle {
      < 1.576253, -0.436925, 1.990482>,
      < 1.599070, -0.487970, 1.967134>,
      < 1.576259, -0.436925, 1.967126>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.375807, -0.567684, 2.024149>,
      < 1.374442, -0.561305, 2.024148>
    }
    triangle {
      < 1.374442, -0.561305, 2.024148>,
      < 1.375807, -0.567684, 2.024149>,
      < 1.389115, -0.566266, 1.990417>
    }
    triangle {
      < 1.374442, -0.561305, 2.024148>,
      < 1.389115, -0.566266, 1.990417>,
      < 1.387165, -0.557155, 1.990416>
    }
    triangle {
      < 1.387165, -0.557155, 1.990416>,
      < 1.389115, -0.566266, 1.990417>,
      < 1.453390, -0.559414, 2.008605>
    }
    triangle {
      < 1.387165, -0.557155, 1.990416>,
      < 1.453390, -0.559414, 2.008605>,
      < 1.448611, -0.537090, 2.008603>
    }
    triangle {
      < 1.448611, -0.537090, 2.008603>,
      < 1.453390, -0.559414, 2.008605>,
      < 1.453386, -0.559414, 2.021581>
    }
    triangle {
      < 1.448611, -0.537090, 2.008603>,
      < 1.453386, -0.559414, 2.021581>,
      < 1.448608, -0.537091, 2.021579>
    }
    triangle {
      < 1.448608, -0.537091, 2.021579>,
      < 1.453386, -0.559414, 2.021581>,
      < 1.473335, -0.557289, 2.021587>
    }
    triangle {
      < 1.448608, -0.537091, 2.021579>,
      < 1.473335, -0.557289, 2.021587>,
      < 1.467678, -0.530864, 2.021585>
    }
    triangle {
      < 1.467678, -0.530864, 2.021585>,
      < 1.473335, -0.557289, 2.021587>,
      < 1.482194, -0.556343, 2.050136>
    }
    triangle {
      < 1.467678, -0.530864, 2.021585>,
      < 1.482194, -0.556343, 2.050136>,
      < 1.476147, -0.528097, 2.050134>
    }
    triangle {
      < 1.476147, -0.528097, 2.050134>,
      < 1.482194, -0.556343, 2.050136>,
      < 1.544254, -0.549729, 2.063133>
    }
    triangle {
      < 1.476147, -0.528097, 2.050134>,
      < 1.544254, -0.549729, 2.063133>,
      < 1.535477, -0.508726, 2.063130>
    }
    triangle {
      < 1.535477, -0.508726, 2.063130>,
      < 1.544254, -0.549729, 2.063133>,
      < 1.579722, -0.545949, 2.047574>
    }
    triangle {
      < 1.535477, -0.508726, 2.063130>,
      < 1.579722, -0.545949, 2.047574>,
      < 1.569384, -0.497656, 2.047571>
    }
    triangle {
      < 1.569384, -0.497656, 2.047571>,
      < 1.579722, -0.545949, 2.047574>,
      < 1.606329, -0.543114, 2.013848>
    }
    triangle {
      < 1.569384, -0.497656, 2.047571>,
      < 1.606329, -0.543114, 2.013848>,
      < 1.594821, -0.489354, 2.013844>
    }
    triangle {
      < 1.594821, -0.489354, 2.013844>,
      < 1.606329, -0.543114, 2.013848>,
      < 1.610769, -0.542642, 1.990494>
    }
    triangle {
      < 1.594821, -0.489354, 2.013844>,
      < 1.610769, -0.542642, 1.990494>,
      < 1.599065, -0.487971, 1.990490>
    }
    triangle {
      < 1.599065, -0.487971, 1.990490>,
      < 1.610769, -0.542642, 1.990494>,
      < 1.610774, -0.542642, 1.967138>
    }
    triangle {
      < 1.599065, -0.487971, 1.990490>,
      < 1.610774, -0.542642, 1.967138>,
      < 1.599070, -0.487970, 1.967134>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.375817, -0.574206, 2.024148>,
      < 1.375807, -0.567684, 2.024149>
    }
    triangle {
      < 1.375807, -0.567684, 2.024149>,
      < 1.375817, -0.574206, 2.024148>,
      < 1.389129, -0.575584, 1.990417>
    }
    triangle {
      < 1.375807, -0.567684, 2.024149>,
      < 1.389129, -0.575584, 1.990417>,
      < 1.389115, -0.566266, 1.990417>
    }
    triangle {
      < 1.389115, -0.566266, 1.990417>,
      < 1.389129, -0.575584, 1.990417>,
      < 1.453424, -0.582245, 2.008605>
    }
    triangle {
      < 1.389115, -0.566266, 1.990417>,
      < 1.453424, -0.582245, 2.008605>,
      < 1.453390, -0.559414, 2.008605>
    }
    triangle {
      < 1.453390, -0.559414, 2.008605>,
      < 1.453424, -0.582245, 2.008605>,
      < 1.453420, -0.582245, 2.021580>
    }
    triangle {
      < 1.453390, -0.559414, 2.008605>,
      < 1.453420, -0.582245, 2.021580>,
      < 1.453386, -0.559414, 2.021581>
    }
    triangle {
      < 1.453386, -0.559414, 2.021581>,
      < 1.453420, -0.582245, 2.021580>,
      < 1.473376, -0.584313, 2.021587>
    }
    triangle {
      < 1.453386, -0.559414, 2.021581>,
      < 1.473376, -0.584313, 2.021587>,
      < 1.473335, -0.557289, 2.021587>
    }
    triangle {
      < 1.473335, -0.557289, 2.021587>,
      < 1.473376, -0.584313, 2.021587>,
      < 1.482237, -0.585231, 2.050136>
    }
    triangle {
      < 1.473335, -0.557289, 2.021587>,
      < 1.482237, -0.585231, 2.050136>,
      < 1.482194, -0.556343, 2.050136>
    }
    triangle {
      < 1.482194, -0.556343, 2.050136>,
      < 1.482237, -0.585231, 2.050136>,
      < 1.544316, -0.591662, 2.063133>
    }
    triangle {
      < 1.482194, -0.556343, 2.050136>,
      < 1.544316, -0.591662, 2.063133>,
      < 1.544254, -0.549729, 2.063133>
    }
    triangle {
      < 1.544254, -0.549729, 2.063133>,
      < 1.544316, -0.591662, 2.063133>,
      < 1.579795, -0.595336, 2.047575>
    }
    triangle {
      < 1.544254, -0.549729, 2.063133>,
      < 1.579795, -0.595336, 2.047575>,
      < 1.579722, -0.545949, 2.047574>
    }
    triangle {
      < 1.579722, -0.545949, 2.047574>,
      < 1.579795, -0.595336, 2.047575>,
      < 1.606410, -0.598092, 2.013848>
    }
    triangle {
      < 1.579722, -0.545949, 2.047574>,
      < 1.606410, -0.598092, 2.013848>,
      < 1.606329, -0.543114, 2.013848>
    }
    triangle {
      < 1.606329, -0.543114, 2.013848>,
      < 1.606410, -0.598092, 2.013848>,
      < 1.610851, -0.598551, 1.990494>
    }
    triangle {
      < 1.606329, -0.543114, 2.013848>,
      < 1.610851, -0.598551, 1.990494>,
      < 1.610769, -0.542642, 1.990494>
    }
    triangle {
      < 1.610769, -0.542642, 1.990494>,
      < 1.610851, -0.598551, 1.990494>,
      < 1.610857, -0.598552, 1.967138>
    }
    triangle {
      < 1.610769, -0.542642, 1.990494>,
      < 1.610857, -0.598552, 1.967138>,
      < 1.610774, -0.542642, 1.967138>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.374470, -0.580589, 2.024148>,
      < 1.375817, -0.574206, 2.024148>
    }
    triangle {
      < 1.375817, -0.574206, 2.024148>,
      < 1.374470, -0.580589, 2.024148>,
      < 1.387206, -0.584703, 1.990416>
    }
    triangle {
      < 1.375817, -0.574206, 2.024148>,
      < 1.387206, -0.584703, 1.990416>,
      < 1.389129, -0.575584, 1.990417>
    }
    triangle {
      < 1.389129, -0.575584, 1.990417>,
      < 1.387206, -0.584703, 1.990416>,
      < 1.448711, -0.604583, 2.008603>
    }
    triangle {
      < 1.389129, -0.575584, 1.990417>,
      < 1.448711, -0.604583, 2.008603>,
      < 1.453424, -0.582245, 2.008605>
    }
    triangle {
      < 1.453424, -0.582245, 2.008605>,
      < 1.448711, -0.604583, 2.008603>,
      < 1.448708, -0.604583, 2.021579>
    }
    triangle {
      < 1.453424, -0.582245, 2.008605>,
      < 1.448708, -0.604583, 2.021579>,
      < 1.453420, -0.582245, 2.021580>
    }
    triangle {
      < 1.453420, -0.582245, 2.021580>,
      < 1.448708, -0.604583, 2.021579>,
      < 1.467797, -0.610753, 2.021585>
    }
    triangle {
      < 1.453420, -0.582245, 2.021580>,
      < 1.467797, -0.610753, 2.021585>,
      < 1.473376, -0.584313, 2.021587>
    }
    triangle {
      < 1.473376, -0.584313, 2.021587>,
      < 1.467797, -0.610753, 2.021585>,
      < 1.476274, -0.613496, 2.050134>
    }
    triangle {
      < 1.473376, -0.584313, 2.021587>,
      < 1.476274, -0.613496, 2.050134>,
      < 1.482237, -0.585231, 2.050136>
    }
    triangle {
      < 1.482237, -0.585231, 2.050136>,
      < 1.476274, -0.613496, 2.050134>,
      < 1.535659, -0.632691, 2.063130>
    }
    triangle {
      < 1.482237, -0.585231, 2.050136>,
      < 1.535659, -0.632691, 2.063130>,
      < 1.544316, -0.591662, 2.063133>
    }
    triangle {
      < 1.544316, -0.591662, 2.063133>,
      < 1.535659, -0.632691, 2.063130>,
      < 1.569601, -0.643660, 2.047571>
    }
    triangle {
      < 1.544316, -0.591662, 2.063133>,
      < 1.569601, -0.643660, 2.047571>,
      < 1.579795, -0.595336, 2.047575>
    }
    triangle {
      < 1.579795, -0.595336, 2.047575>,
      < 1.569601, -0.643660, 2.047571>,
      < 1.595062, -0.651887, 2.013844>
    }
    triangle {
      < 1.579795, -0.595336, 2.047575>,
      < 1.595062, -0.651887, 2.013844>,
      < 1.606410, -0.598092, 2.013848>
    }
    triangle {
      < 1.606410, -0.598092, 2.013848>,
      < 1.595062, -0.651887, 2.013844>,
      < 1.599310, -0.653257, 1.990490>
    }
    triangle {
      < 1.606410, -0.598092, 2.013848>,
      < 1.599310, -0.653257, 1.990490>,
      < 1.610851, -0.598551, 1.990494>
    }
    triangle {
      < 1.610851, -0.598551, 1.990494>,
      < 1.599310, -0.653257, 1.990490>,
      < 1.599316, -0.653257, 1.967134>
    }
    triangle {
      < 1.610851, -0.598551, 1.990494>,
      < 1.599316, -0.653257, 1.967134>,
      < 1.610857, -0.598552, 1.967138>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.371826, -0.586552, 2.024147>,
      < 1.374470, -0.580589, 2.024148>
    }
    triangle {
      < 1.374470, -0.580589, 2.024148>,
      < 1.371826, -0.586552, 2.024147>,
      < 1.383428, -0.593220, 1.990415>
    }
    triangle {
      < 1.374470, -0.580589, 2.024148>,
      < 1.383428, -0.593220, 1.990415>,
      < 1.387206, -0.584703, 1.990416>
    }
    triangle {
      < 1.387206, -0.584703, 1.990416>,
      < 1.383428, -0.593220, 1.990415>,
      < 1.439458, -0.625454, 2.008600>
    }
    triangle {
      < 1.387206, -0.584703, 1.990416>,
      < 1.439458, -0.625454, 2.008600>,
      < 1.448711, -0.604583, 2.008603>
    }
    triangle {
      < 1.448711, -0.604583, 2.008603>,
      < 1.439458, -0.625454, 2.008600>,
      < 1.439454, -0.625454, 2.021575>
    }
    triangle {
      < 1.448711, -0.604583, 2.008603>,
      < 1.439454, -0.625454, 2.021575>,
      < 1.448708, -0.604583, 2.021579>
    }
    triangle {
      < 1.448708, -0.604583, 2.021579>,
      < 1.439454, -0.625454, 2.021575>,
      < 1.456845, -0.635457, 2.021581>
    }
    triangle {
      < 1.448708, -0.604583, 2.021579>,
      < 1.456845, -0.635457, 2.021581>,
      < 1.467797, -0.610753, 2.021585>
    }
    triangle {
      < 1.467797, -0.610753, 2.021585>,
      < 1.456845, -0.635457, 2.021581>,
      < 1.464566, -0.639903, 2.050131>
    }
    triangle {
      < 1.467797, -0.610753, 2.021585>,
      < 1.464566, -0.639903, 2.050131>,
      < 1.476274, -0.613496, 2.050134>
    }
    triangle {
      < 1.476274, -0.613496, 2.050134>,
      < 1.464566, -0.639903, 2.050131>,
      < 1.518665, -0.671025, 2.063124>
    }
    triangle {
      < 1.476274, -0.613496, 2.050134>,
      < 1.518665, -0.671025, 2.063124>,
      < 1.535659, -0.632691, 2.063130>
    }
    triangle {
      < 1.535659, -0.632691, 2.063130>,
      < 1.518665, -0.671025, 2.063124>,
      < 1.549583, -0.688809, 2.047565>
    }
    triangle {
      < 1.535659, -0.632691, 2.063130>,
      < 1.549583, -0.688809, 2.047565>,
      < 1.569601, -0.643660, 2.047571>
    }
    triangle {
      < 1.569601, -0.643660, 2.047571>,
      < 1.549583, -0.688809, 2.047565>,
      < 1.572778, -0.702146, 2.013836>
    }
    triangle {
      < 1.569601, -0.643660, 2.047571>,
      < 1.572778, -0.702146, 2.013836>,
      < 1.595062, -0.651887, 2.013844>
    }
    triangle {
      < 1.595062, -0.651887, 2.013844>,
      < 1.572778, -0.702146, 2.013836>,
      < 1.576649, -0.704370, 1.990482>
    }
    triangle {
      < 1.595062, -0.651887, 2.013844>,
      < 1.576649, -0.704370, 1.990482>,
      < 1.599310, -0.653257, 1.990490>
    }
    triangle {
      < 1.599310, -0.653257, 1.990490>,
      < 1.576649, -0.704370, 1.990482>,
      < 1.576655, -0.704369, 1.967126>
    }
    triangle {
      < 1.599310, -0.653257, 1.990490>,
      < 1.576655, -0.704369, 1.967126>,
      < 1.599316, -0.653257, 1.967134>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.368001, -0.591835, 2.024146>,
      < 1.371826, -0.586552, 2.024147>
    }
    triangle {
      < 1.371826, -0.586552, 2.024147>,
      < 1.368001, -0.591835, 2.024146>,
      < 1.377963, -0.600768, 1.990413>
    }
    triangle {
      < 1.371826, -0.586552, 2.024147>,
      < 1.377963, -0.600768, 1.990413>,
      < 1.383428, -0.593220, 1.990415>
    }
    triangle {
      < 1.383428, -0.593220, 1.990415>,
      < 1.377963, -0.600768, 1.990413>,
      < 1.426068, -0.643946, 2.008596>
    }
    triangle {
      < 1.383428, -0.593220, 1.990415>,
      < 1.426068, -0.643946, 2.008596>,
      < 1.439458, -0.625454, 2.008600>
    }
    triangle {
      < 1.439458, -0.625454, 2.008600>,
      < 1.426068, -0.643946, 2.008596>,
      < 1.426065, -0.643945, 2.021571>
    }
    triangle {
      < 1.439458, -0.625454, 2.008600>,
      < 1.426065, -0.643945, 2.021571>,
      < 1.439454, -0.625454, 2.021575>
    }
    triangle {
      < 1.439454, -0.625454, 2.021575>,
      < 1.426065, -0.643945, 2.021571>,
      < 1.440996, -0.657345, 2.021576>
    }
    triangle {
      < 1.439454, -0.625454, 2.021575>,
      < 1.440996, -0.657345, 2.021576>,
      < 1.456845, -0.635457, 2.021581>
    }
    triangle {
      < 1.456845, -0.635457, 2.021581>,
      < 1.440996, -0.657345, 2.021576>,
      < 1.447624, -0.663300, 2.050124>
    }
    triangle {
      < 1.456845, -0.635457, 2.021581>,
      < 1.447624, -0.663300, 2.050124>,
      < 1.464566, -0.639903, 2.050131>
    }
    triangle {
      < 1.464566, -0.639903, 2.050131>,
      < 1.447624, -0.663300, 2.050124>,
      < 1.494071, -0.704988, 2.063116>
    }
    triangle {
      < 1.464566, -0.639903, 2.050131>,
      < 1.494071, -0.704988, 2.063116>,
      < 1.518665, -0.671025, 2.063124>
    }
    triangle {
      < 1.518665, -0.671025, 2.063124>,
      < 1.494071, -0.704988, 2.063116>,
      < 1.520618, -0.728811, 2.047554>
    }
    triangle {
      < 1.518665, -0.671025, 2.063124>,
      < 1.520618, -0.728811, 2.047554>,
      < 1.549583, -0.688809, 2.047565>
    }
    triangle {
      < 1.549583, -0.688809, 2.047565>,
      < 1.520618, -0.728811, 2.047554>,
      < 1.540534, -0.746677, 2.013825>
    }
    triangle {
      < 1.549583, -0.688809, 2.047565>,
      < 1.540534, -0.746677, 2.013825>,
      < 1.572778, -0.702146, 2.013836>
    }
    triangle {
      < 1.572778, -0.702146, 2.013836>,
      < 1.540534, -0.746677, 2.013825>,
      < 1.543858, -0.749654, 1.990471>
    }
    triangle {
      < 1.572778, -0.702146, 2.013836>,
      < 1.543858, -0.749654, 1.990471>,
      < 1.576649, -0.704370, 1.990482>
    }
    triangle {
      < 1.576649, -0.704370, 1.990482>,
      < 1.543858, -0.749654, 1.990471>,
      < 1.543864, -0.749654, 1.967115>
    }
    triangle {
      < 1.576649, -0.704370, 1.990482>,
      < 1.543864, -0.749654, 1.967115>,
      < 1.576655, -0.704369, 1.967126>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.363161, -0.596207, 2.024144>,
      < 1.368001, -0.591835, 2.024146>
    }
    triangle {
      < 1.368001, -0.591835, 2.024146>,
      < 1.363161, -0.596207, 2.024144>,
      < 1.371049, -0.607015, 1.990411>
    }
    triangle {
      < 1.368001, -0.591835, 2.024146>,
      < 1.371049, -0.607015, 1.990411>,
      < 1.377963, -0.600768, 1.990413>
    }
    triangle {
      < 1.377963, -0.600768, 1.990413>,
      < 1.371049, -0.607015, 1.990411>,
      < 1.409127, -0.659249, 2.008590>
    }
    triangle {
      < 1.377963, -0.600768, 1.990413>,
      < 1.409127, -0.659249, 2.008590>,
      < 1.426068, -0.643946, 2.008596>
    }
    triangle {
      < 1.426068, -0.643946, 2.008596>,
      < 1.409127, -0.659249, 2.008590>,
      < 1.409124, -0.659249, 2.021565>
    }
    triangle {
      < 1.426068, -0.643946, 2.008596>,
      < 1.409124, -0.659249, 2.021565>,
      < 1.426065, -0.643945, 2.021571>
    }
    triangle {
      < 1.426065, -0.643945, 2.021571>,
      < 1.409124, -0.659249, 2.021565>,
      < 1.420943, -0.675460, 2.021569>
    }
    triangle {
      < 1.426065, -0.643945, 2.021571>,
      < 1.420943, -0.675460, 2.021569>,
      < 1.440996, -0.657345, 2.021576>
    }
    triangle {
      < 1.440996, -0.657345, 2.021576>,
      < 1.420943, -0.675460, 2.021569>,
      < 1.426189, -0.682665, 2.050117>
    }
    triangle {
      < 1.440996, -0.657345, 2.021576>,
      < 1.426189, -0.682665, 2.050117>,
      < 1.447624, -0.663300, 2.050124>
    }
    triangle {
      < 1.447624, -0.663300, 2.050124>,
      < 1.426189, -0.682665, 2.050117>,
      < 1.462955, -0.733098, 2.063105>
    }
    triangle {
      < 1.447624, -0.663300, 2.050124>,
      < 1.462955, -0.733098, 2.063105>,
      < 1.494071, -0.704988, 2.063116>
    }
    triangle {
      < 1.494071, -0.704988, 2.063116>,
      < 1.462955, -0.733098, 2.063105>,
      < 1.483970, -0.761917, 2.047541>
    }
    triangle {
      < 1.494071, -0.704988, 2.063116>,
      < 1.483970, -0.761917, 2.047541>,
      < 1.520618, -0.728811, 2.047554>
    }
    triangle {
      < 1.520618, -0.728811, 2.047554>,
      < 1.483970, -0.761917, 2.047541>,
      < 1.499738, -0.783531, 2.013811>
    }
    triangle {
      < 1.520618, -0.728811, 2.047554>,
      < 1.499738, -0.783531, 2.013811>,
      < 1.540534, -0.746677, 2.013825>
    }
    triangle {
      < 1.540534, -0.746677, 2.013825>,
      < 1.499738, -0.783531, 2.013811>,
      < 1.502370, -0.787134, 1.990456>
    }
    triangle {
      < 1.540534, -0.746677, 2.013825>,
      < 1.502370, -0.787134, 1.990456>,
      < 1.543858, -0.749654, 1.990471>
    }
    triangle {
      < 1.543858, -0.749654, 1.990471>,
      < 1.502370, -0.787134, 1.990456>,
      < 1.502376, -0.787133, 1.967100>
    }
    triangle {
      < 1.543858, -0.749654, 1.990471>,
      < 1.502376, -0.787133, 1.967100>,
      < 1.543864, -0.749654, 1.967115>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.344774, -0.568762, 2.024138>,
      < 1.357518, -0.599479, 2.024143>
    }
    triangle {
      < 1.342657, -0.571682, 2.024137>,
      < 1.357518, -0.599479, 2.024143>,
      < 1.363161, -0.596207, 2.024144>
    }
    triangle {
      < 1.363161, -0.596207, 2.024144>,
      < 1.357518, -0.599479, 2.024143>,
      < 1.362987, -0.611687, 1.990408>
    }
    triangle {
      < 1.363161, -0.596207, 2.024144>,
      < 1.362987, -0.611687, 1.990408>,
      < 1.371049, -0.607015, 1.990411>
    }
    triangle {
      < 1.371049, -0.607015, 1.990411>,
      < 1.362987, -0.611687, 1.990408>,
      < 1.389375, -0.670698, 2.008583>
    }
    triangle {
      < 1.371049, -0.607015, 1.990411>,
      < 1.389375, -0.670698, 2.008583>,
      < 1.409127, -0.659249, 2.008590>
    }
    triangle {
      < 1.409127, -0.659249, 2.008590>,
      < 1.389375, -0.670698, 2.008583>,
      < 1.389372, -0.670697, 2.021558>
    }
    triangle {
      < 1.409127, -0.659249, 2.008590>,
      < 1.389372, -0.670697, 2.021558>,
      < 1.409124, -0.659249, 2.021565>
    }
    triangle {
      < 1.409124, -0.659249, 2.021565>,
      < 1.389372, -0.670697, 2.021558>,
      < 1.397563, -0.689011, 2.021561>
    }
    triangle {
      < 1.409124, -0.659249, 2.021565>,
      < 1.397563, -0.689011, 2.021561>,
      < 1.420943, -0.675460, 2.021569>
    }
    triangle {
      < 1.420943, -0.675460, 2.021569>,
      < 1.397563, -0.689011, 2.021561>,
      < 1.401196, -0.697150, 2.050108>
    }
    triangle {
      < 1.420943, -0.675460, 2.021569>,
      < 1.401196, -0.697150, 2.050108>,
      < 1.426189, -0.682665, 2.050117>
    }
    triangle {
      < 1.426189, -0.682665, 2.050117>,
      < 1.401196, -0.697150, 2.050108>,
      < 1.426676, -0.754125, 2.063092>
    }
    triangle {
      < 1.426189, -0.682665, 2.050117>,
      < 1.426676, -0.754125, 2.063092>,
      < 1.462955, -0.733098, 2.063105>
    }
    triangle {
      < 1.462955, -0.733098, 2.063105>,
      < 1.426676, -0.754125, 2.063092>,
      < 1.441242, -0.786683, 2.047527>
    }
    triangle {
      < 1.462955, -0.733098, 2.063105>,
      < 1.441242, -0.786683, 2.047527>,
      < 1.483970, -0.761917, 2.047541>
    }
    triangle {
      < 1.483970, -0.761917, 2.047541>,
      < 1.441242, -0.786683, 2.047527>,
      < 1.452171, -0.811100, 2.013795>
    }
    triangle {
      < 1.483970, -0.761917, 2.047541>,
      < 1.452171, -0.811100, 2.013795>,
      < 1.499738, -0.783531, 2.013811>
    }
    triangle {
      < 1.499738, -0.783531, 2.013811>,
      < 1.452171, -0.811100, 2.013795>,
      < 1.453998, -0.815170, 1.990439>
    }
    triangle {
      < 1.499738, -0.783531, 2.013811>,
      < 1.453998, -0.815170, 1.990439>,
      < 1.502370, -0.787134, 1.990456>
    }
    triangle {
      < 1.502370, -0.787134, 1.990456>,
      < 1.453998, -0.815170, 1.990439>,
      < 1.454004, -0.815170, 1.967084>
    }
    triangle {
      < 1.502370, -0.787134, 1.990456>,
      < 1.454004, -0.815170, 1.967084>,
      < 1.502376, -0.787133, 1.967100>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.351317, -0.601505, 2.024140>,
      < 1.357518, -0.599479, 2.024143>
    }
    triangle {
      < 1.357518, -0.599479, 2.024143>,
      < 1.351317, -0.601505, 2.024140>,
      < 1.354130, -0.614582, 1.990405>
    }
    triangle {
      < 1.357518, -0.599479, 2.024143>,
      < 1.354130, -0.614582, 1.990405>,
      < 1.362987, -0.611687, 1.990408>
    }
    triangle {
      < 1.362987, -0.611687, 1.990408>,
      < 1.354130, -0.614582, 1.990405>,
      < 1.367675, -0.677790, 2.008575>
    }
    triangle {
      < 1.362987, -0.611687, 1.990408>,
      < 1.367675, -0.677790, 2.008575>,
      < 1.389375, -0.670698, 2.008583>
    }
    triangle {
      < 1.389375, -0.670698, 2.008583>,
      < 1.367675, -0.677790, 2.008575>,
      < 1.367671, -0.677789, 2.021550>
    }
    triangle {
      < 1.389375, -0.670698, 2.008583>,
      < 1.367671, -0.677789, 2.021550>,
      < 1.389372, -0.670697, 2.021558>
    }
    triangle {
      < 1.389372, -0.670697, 2.021558>,
      < 1.367671, -0.677789, 2.021550>,
      < 1.371876, -0.697405, 2.021552>
    }
    triangle {
      < 1.389372, -0.670697, 2.021558>,
      < 1.371876, -0.697405, 2.021552>,
      < 1.397563, -0.689011, 2.021561>
    }
    triangle {
      < 1.397563, -0.689011, 2.021561>,
      < 1.371876, -0.697405, 2.021552>,
      < 1.373738, -0.706124, 2.050099>
    }
    triangle {
      < 1.397563, -0.689011, 2.021561>,
      < 1.373738, -0.706124, 2.050099>,
      < 1.401196, -0.697150, 2.050108>
    }
    triangle {
      < 1.401196, -0.697150, 2.050108>,
      < 1.373738, -0.706124, 2.050099>,
      < 1.386818, -0.767152, 2.063078>
    }
    triangle {
      < 1.401196, -0.697150, 2.050108>,
      < 1.386818, -0.767152, 2.063078>,
      < 1.426676, -0.754125, 2.063092>
    }
    triangle {
      < 1.426676, -0.754125, 2.063092>,
      < 1.386818, -0.767152, 2.063078>,
      < 1.394298, -0.802024, 2.047510>
    }
    triangle {
      < 1.426676, -0.754125, 2.063092>,
      < 1.394298, -0.802024, 2.047510>,
      < 1.441242, -0.786683, 2.047527>
    }
    triangle {
      < 1.441242, -0.786683, 2.047527>,
      < 1.394298, -0.802024, 2.047510>,
      < 1.399913, -0.828179, 2.013776>
    }
    triangle {
      < 1.441242, -0.786683, 2.047527>,
      < 1.399913, -0.828179, 2.013776>,
      < 1.452171, -0.811100, 2.013795>
    }
    triangle {
      < 1.452171, -0.811100, 2.013795>,
      < 1.399913, -0.828179, 2.013776>,
      < 1.400854, -0.832538, 1.990421>
    }
    triangle {
      < 1.452171, -0.811100, 2.013795>,
      < 1.400854, -0.832538, 1.990421>,
      < 1.453998, -0.815170, 1.990439>
    }
    triangle {
      < 1.453998, -0.815170, 1.990439>,
      < 1.400854, -0.832538, 1.990421>,
      < 1.400860, -0.832538, 1.967065>
    }
    triangle {
      < 1.453998, -0.815170, 1.990439>,
      < 1.400860, -0.832538, 1.967065>,
      < 1.454004, -0.815170, 1.967084>
    }
    triangle {
      < 1.344774, -0.568762, 2.024138>,
      < 1.344794, -0.602198, 2.024137>,
      < 1.351317, -0.601505, 2.024140>
    }
    triangle {
      < 1.351317, -0.601505, 2.024140>,
      < 1.344794, -0.602198, 2.024137>,
      < 1.344811, -0.615572, 1.990402>
    }
    triangle {
      < 1.351317, -0.601505, 2.024140>,
      < 1.344811, -0.615572, 1.990402>,
      < 1.354130, -0.614582, 1.990405>
    }
    triangle {
      < 1.354130, -0.614582, 1.990405>,
      < 1.344811, -0.615572, 1.990402>,
      < 1.344845, -0.680216, 2.008567>
    }
    triangle {
      < 1.354130, -0.614582, 1.990405>,
      < 1.344845, -0.680216, 2.008567>,
      < 1.367675, -0.677790, 2.008575>
    }
    triangle {
      < 1.367675, -0.677790, 2.008575>,
      < 1.344845, -0.680216, 2.008567>,
      < 1.344842, -0.680216, 2.021542>
    }
    triangle {
      < 1.367675, -0.677790, 2.008575>,
      < 1.344842, -0.680216, 2.021542>,
      < 1.367671, -0.677789, 2.021550>
    }
    triangle {
      < 1.367671, -0.677789, 2.021550>,
      < 1.344842, -0.680216, 2.021542>,
      < 1.344854, -0.700277, 2.021543>
    }
    triangle {
      < 1.367671, -0.677789, 2.021550>,
      < 1.344854, -0.700277, 2.021543>,
      < 1.371876, -0.697405, 2.021552>
    }
    triangle {
      < 1.371876, -0.697405, 2.021552>,
      < 1.344854, -0.700277, 2.021543>,
      < 1.344851, -0.709194, 2.050089>
    }
    triangle {
      < 1.371876, -0.697405, 2.021552>,
      < 1.344851, -0.709194, 2.050089>,
      < 1.373738, -0.706124, 2.050099>
    }
    triangle {
      < 1.373738, -0.706124, 2.050099>,
      < 1.344851, -0.709194, 2.050089>,
      < 1.344885, -0.771608, 2.063064>
    }
    triangle {
      < 1.373738, -0.706124, 2.050099>,
      < 1.344885, -0.771608, 2.063064>,
      < 1.386818, -0.767152, 2.063078>
    }
    triangle {
      < 1.386818, -0.767152, 2.063078>,
      < 1.344885, -0.771608, 2.063064>,
      < 1.344911, -0.807274, 2.047494>
    }
    triangle {
      < 1.386818, -0.767152, 2.063078>,
      < 1.344911, -0.807274, 2.047494>,
      < 1.394298, -0.802024, 2.047510>
    }
    triangle {
      < 1.394298, -0.802024, 2.047510>,
      < 1.344911, -0.807274, 2.047494>,
      < 1.344934, -0.834023, 2.013757>
    }
    triangle {
      < 1.394298, -0.802024, 2.047510>,
      < 1.344934, -0.834023, 2.013757>,
      < 1.399913, -0.828179, 2.013776>
    }
    triangle {
      < 1.399913, -0.828179, 2.013776>,
      < 1.344934, -0.834023, 2.013757>,
      < 1.344943, -0.838481, 1.990402>
    }
    triangle {
      < 1.399913, -0.828179, 2.013776>,
      < 1.344943, -0.838481, 1.990402>,
      < 1.400854, -0.832538, 1.990421>
    }
    triangle {
      < 1.400854, -0.832538, 1.990421>,
      < 1.344943, -0.838481, 1.990402>,
      < 1.344949, -0.838481, 1.967046>
    }
    triangle {
      < 1.400854, -0.832538, 1.990421>,
      < 1.344949, -0.838481, 1.967046>,
      < 1.400860, -0.832538, 1.967065>
    }
    triangle {
      < 1.344824, -0.602198, 1.909305>,
      < 1.338336, -0.601520, 1.909303>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.344823, -0.615573, 1.943041>,
      < 1.335555, -0.614605, 1.943037>,
      < 1.338336, -0.601520, 1.909303>
    }
    triangle {
      < 1.344823, -0.615573, 1.943041>,
      < 1.338336, -0.601520, 1.909303>,
      < 1.344824, -0.602198, 1.909305>
    }
    triangle {
      < 1.344866, -0.680216, 1.924875>,
      < 1.322159, -0.677844, 1.924867>,
      < 1.335555, -0.614605, 1.943037>
    }
    triangle {
      < 1.344866, -0.680216, 1.924875>,
      < 1.335555, -0.614605, 1.943037>,
      < 1.344823, -0.615573, 1.943041>
    }
    triangle {
      < 1.344870, -0.680216, 1.911899>,
      < 1.322163, -0.677843, 1.911892>,
      < 1.322159, -0.677844, 1.924867>
    }
    triangle {
      < 1.344870, -0.680216, 1.911899>,
      < 1.322159, -0.677844, 1.924867>,
      < 1.344866, -0.680216, 1.924875>
    }
    triangle {
      < 1.344882, -0.700278, 1.911900>,
      < 1.318005, -0.697470, 1.911890>,
      < 1.322163, -0.677843, 1.911892>
    }
    triangle {
      < 1.344882, -0.700278, 1.911900>,
      < 1.322163, -0.677843, 1.911892>,
      < 1.344870, -0.680216, 1.911899>
    }
    triangle {
      < 1.344894, -0.709194, 1.883354>,
      < 1.316163, -0.706192, 1.883344>,
      < 1.318005, -0.697470, 1.911890>
    }
    triangle {
      < 1.344894, -0.709194, 1.883354>,
      < 1.318005, -0.697470, 1.911890>,
      < 1.344882, -0.700278, 1.911900>
    }
    triangle {
      < 1.344934, -0.771609, 1.870378>,
      < 1.303228, -0.767251, 1.870364>,
      < 1.316163, -0.706192, 1.883344>
    }
    triangle {
      < 1.344934, -0.771609, 1.870378>,
      < 1.316163, -0.706192, 1.883344>,
      < 1.344894, -0.709194, 1.883354>
    }
    triangle {
      < 1.344951, -0.807274, 1.885949>,
      < 1.295831, -0.802141, 1.885932>,
      < 1.303228, -0.767251, 1.870364>
    }
    triangle {
      < 1.344951, -0.807274, 1.885949>,
      < 1.303228, -0.767251, 1.870364>,
      < 1.344934, -0.771609, 1.870378>
    }
    triangle {
      < 1.344958, -0.834023, 1.919685>,
      < 1.290278, -0.828309, 1.919666>,
      < 1.295831, -0.802141, 1.885932>
    }
    triangle {
      < 1.344958, -0.834023, 1.919685>,
      < 1.295831, -0.802141, 1.885932>,
      < 1.344951, -0.807274, 1.885949>
    }
    triangle {
      < 1.344955, -0.838481, 1.943040>,
      < 1.289348, -0.832671, 1.943021>,
      < 1.290278, -0.828309, 1.919666>
    }
    triangle {
      < 1.344955, -0.838481, 1.943040>,
      < 1.290278, -0.828309, 1.919666>,
      < 1.344958, -0.834023, 1.919685>
    }
    triangle {
      < 1.344949, -0.838481, 1.967046>,
      < 1.289342, -0.832671, 1.967027>,
      < 1.289348, -0.832671, 1.943021>
    }
    triangle {
      < 1.344949, -0.838481, 1.967046>,
      < 1.289348, -0.832671, 1.943021>,
      < 1.344955, -0.838481, 1.943040>
    }
    triangle {
      < 1.338336, -0.601520, 1.909303>,
      < 1.332131, -0.599508, 1.909300>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.335555, -0.614605, 1.943037>,
      < 1.326691, -0.611730, 1.943034>,
      < 1.332131, -0.599508, 1.909300>
    }
    triangle {
      < 1.335555, -0.614605, 1.943037>,
      < 1.332131, -0.599508, 1.909300>,
      < 1.338336, -0.601520, 1.909303>
    }
    triangle {
      < 1.322159, -0.677844, 1.924867>,
      < 1.300442, -0.670803, 1.924860>,
      < 1.326691, -0.611730, 1.943034>
    }
    triangle {
      < 1.322159, -0.677844, 1.924867>,
      < 1.326691, -0.611730, 1.943034>,
      < 1.335555, -0.614605, 1.943037>
    }
    triangle {
      < 1.322163, -0.677843, 1.911892>,
      < 1.300446, -0.670803, 1.911885>,
      < 1.300442, -0.670803, 1.924860>
    }
    triangle {
      < 1.322163, -0.677843, 1.911892>,
      < 1.300442, -0.670803, 1.924860>,
      < 1.322159, -0.677844, 1.924867>
    }
    triangle {
      < 1.318005, -0.697470, 1.911890>,
      < 1.292298, -0.689135, 1.911881>,
      < 1.300446, -0.670803, 1.911885>
    }
    triangle {
      < 1.318005, -0.697470, 1.911890>,
      < 1.300446, -0.670803, 1.911885>,
      < 1.322163, -0.677843, 1.911892>
    }
    triangle {
      < 1.316163, -0.706192, 1.883344>,
      < 1.288684, -0.697283, 1.883334>,
      < 1.292298, -0.689135, 1.911881>
    }
    triangle {
      < 1.316163, -0.706192, 1.883344>,
      < 1.292298, -0.689135, 1.911881>,
      < 1.318005, -0.697470, 1.911890>
    }
    triangle {
      < 1.303228, -0.767251, 1.870364>,
      < 1.263340, -0.754319, 1.870350>,
      < 1.288684, -0.697283, 1.883334>
    }
    triangle {
      < 1.303228, -0.767251, 1.870364>,
      < 1.288684, -0.697283, 1.883334>,
      < 1.316163, -0.706192, 1.883344>
    }
    triangle {
      < 1.295831, -0.802141, 1.885932>,
      < 1.248851, -0.786911, 1.885916>,
      < 1.263340, -0.754319, 1.870350>
    }
    triangle {
      < 1.295831, -0.802141, 1.885932>,
      < 1.263340, -0.754319, 1.870350>,
      < 1.303228, -0.767251, 1.870364>
    }
    triangle {
      < 1.290278, -0.828309, 1.919666>,
      < 1.237979, -0.811354, 1.919647>,
      < 1.248851, -0.786911, 1.885916>
    }
    triangle {
      < 1.290278, -0.828309, 1.919666>,
      < 1.248851, -0.786911, 1.885916>,
      < 1.295831, -0.802141, 1.885932>
    }
    triangle {
      < 1.289348, -0.832671, 1.943021>,
      < 1.236162, -0.815428, 1.943003>,
      < 1.237979, -0.811354, 1.919647>
    }
    triangle {
      < 1.289348, -0.832671, 1.943021>,
      < 1.237979, -0.811354, 1.919647>,
      < 1.290278, -0.828309, 1.919666>
    }
    triangle {
      < 1.289342, -0.832671, 1.967027>,
      < 1.236157, -0.815428, 1.967009>,
      < 1.236162, -0.815428, 1.943003>
    }
    triangle {
      < 1.289342, -0.832671, 1.967027>,
      < 1.236162, -0.815428, 1.943003>,
      < 1.289348, -0.832671, 1.943021>
    }
    triangle {
      < 1.332131, -0.599508, 1.909300>,
      < 1.326480, -0.596251, 1.909298>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.326691, -0.611730, 1.943034>,
      < 1.318618, -0.607077, 1.943031>,
      < 1.326480, -0.596251, 1.909298>
    }
    triangle {
      < 1.326691, -0.611730, 1.943034>,
      < 1.326480, -0.596251, 1.909298>,
      < 1.332131, -0.599508, 1.909300>
    }
    triangle {
      < 1.300442, -0.670803, 1.924860>,
      < 1.280663, -0.659401, 1.924853>,
      < 1.318618, -0.607077, 1.943031>
    }
    triangle {
      < 1.300442, -0.670803, 1.924860>,
      < 1.318618, -0.607077, 1.943031>,
      < 1.326691, -0.611730, 1.943034>
    }
    triangle {
      < 1.300446, -0.670803, 1.911885>,
      < 1.280666, -0.659401, 1.911877>,
      < 1.280663, -0.659401, 1.924853>
    }
    triangle {
      < 1.300446, -0.670803, 1.911885>,
      < 1.280663, -0.659401, 1.924853>,
      < 1.300442, -0.670803, 1.924860>
    }
    triangle {
      < 1.292298, -0.689135, 1.911881>,
      < 1.268886, -0.675640, 1.911873>,
      < 1.280666, -0.659401, 1.911877>
    }
    triangle {
      < 1.292298, -0.689135, 1.911881>,
      < 1.280666, -0.659401, 1.911877>,
      < 1.300446, -0.670803, 1.911885>
    }
    triangle {
      < 1.288684, -0.697283, 1.883334>,
      < 1.263658, -0.682857, 1.883326>,
      < 1.268886, -0.675640, 1.911873>
    }
    triangle {
      < 1.288684, -0.697283, 1.883334>,
      < 1.268886, -0.675640, 1.911873>,
      < 1.292298, -0.689135, 1.911881>
    }
    triangle {
      < 1.263340, -0.754319, 1.870350>,
      < 1.227010, -0.733377, 1.870338>,
      < 1.263658, -0.682857, 1.883326>
    }
    triangle {
      < 1.263340, -0.754319, 1.870350>,
      < 1.263658, -0.682857, 1.883326>,
      < 1.288684, -0.697283, 1.883334>
    }
    triangle {
      < 1.248851, -0.786911, 1.885916>,
      < 1.206064, -0.762247, 1.885900>,
      < 1.227010, -0.733377, 1.870338>
    }
    triangle {
      < 1.248851, -0.786911, 1.885916>,
      < 1.227010, -0.733377, 1.870338>,
      < 1.263340, -0.754319, 1.870350>
    }
    triangle {
      < 1.237979, -0.811354, 1.919647>,
      < 1.190348, -0.783898, 1.919632>,
      < 1.206064, -0.762247, 1.885900>
    }
    triangle {
      < 1.237979, -0.811354, 1.919647>,
      < 1.206064, -0.762247, 1.885900>,
      < 1.248851, -0.786911, 1.885916>
    }
    triangle {
      < 1.236162, -0.815428, 1.943003>,
      < 1.187723, -0.787506, 1.942986>,
      < 1.190348, -0.783898, 1.919632>
    }
    triangle {
      < 1.236162, -0.815428, 1.943003>,
      < 1.190348, -0.783898, 1.919632>,
      < 1.237979, -0.811354, 1.919647>
    }
    triangle {
      < 1.236157, -0.815428, 1.967009>,
      < 1.187718, -0.787506, 1.966991>,
      < 1.187723, -0.787506, 1.942986>
    }
    triangle {
      < 1.236157, -0.815428, 1.967009>,
      < 1.187723, -0.787506, 1.942986>,
      < 1.236162, -0.815428, 1.943003>
    }
    triangle {
      < 1.326480, -0.596251, 1.909298>,
      < 1.321630, -0.591890, 1.909297>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.318618, -0.607077, 1.943031>,
      < 1.311689, -0.600846, 1.943029>,
      < 1.321630, -0.591890, 1.909297>
    }
    triangle {
      < 1.318618, -0.607077, 1.943031>,
      < 1.321630, -0.591890, 1.909297>,
      < 1.326480, -0.596251, 1.909298>
    }
    triangle {
      < 1.280663, -0.659401, 1.924853>,
      < 1.263686, -0.644138, 1.924847>,
      < 1.311689, -0.600846, 1.943029>
    }
    triangle {
      < 1.280663, -0.659401, 1.924853>,
      < 1.311689, -0.600846, 1.943029>,
      < 1.318618, -0.607077, 1.943031>
    }
    triangle {
      < 1.280666, -0.659401, 1.911877>,
      < 1.263690, -0.644138, 1.911872>,
      < 1.263686, -0.644138, 1.924847>
    }
    triangle {
      < 1.280666, -0.659401, 1.911877>,
      < 1.263686, -0.644138, 1.924847>,
      < 1.280663, -0.659401, 1.924853>
    }
    triangle {
      < 1.268886, -0.675640, 1.911873>,
      < 1.248790, -0.657573, 1.911867>,
      < 1.263690, -0.644138, 1.911872>
    }
    triangle {
      < 1.268886, -0.675640, 1.911873>,
      < 1.263690, -0.644138, 1.911872>,
      < 1.280666, -0.659401, 1.911877>
    }
    triangle {
      < 1.263658, -0.682857, 1.883326>,
      < 1.242176, -0.663544, 1.883318>,
      < 1.248790, -0.657573, 1.911867>
    }
    triangle {
      < 1.263658, -0.682857, 1.883326>,
      < 1.248790, -0.657573, 1.911867>,
      < 1.268886, -0.675640, 1.911873>
    }
    triangle {
      < 1.227010, -0.733377, 1.870338>,
      < 1.195828, -0.705342, 1.870327>,
      < 1.242176, -0.663544, 1.883318>
    }
    triangle {
      < 1.227010, -0.733377, 1.870338>,
      < 1.242176, -0.663544, 1.883318>,
      < 1.263658, -0.682857, 1.883326>
    }
    triangle {
      < 1.206064, -0.762247, 1.885900>,
      < 1.169338, -0.729227, 1.885888>,
      < 1.195828, -0.705342, 1.870327>
    }
    triangle {
      < 1.206064, -0.762247, 1.885900>,
      < 1.195828, -0.705342, 1.870327>,
      < 1.227010, -0.733377, 1.870338>
    }
    triangle {
      < 1.190348, -0.783898, 1.919632>,
      < 1.149463, -0.747141, 1.919617>,
      < 1.169338, -0.729227, 1.885888>
    }
    triangle {
      < 1.190348, -0.783898, 1.919632>,
      < 1.169338, -0.729227, 1.885888>,
      < 1.206064, -0.762247, 1.885900>
    }
    triangle {
      < 1.187723, -0.787506, 1.942986>,
      < 1.146146, -0.750125, 1.942972>,
      < 1.149463, -0.747141, 1.919617>
    }
    triangle {
      < 1.187723, -0.787506, 1.942986>,
      < 1.149463, -0.747141, 1.919617>,
      < 1.190348, -0.783898, 1.919632>
    }
    triangle {
      < 1.187718, -0.787506, 1.966991>,
      < 1.146140, -0.750126, 1.966978>,
      < 1.146146, -0.750125, 1.942972>
    }
    triangle {
      < 1.187718, -0.787506, 1.966991>,
      < 1.146146, -0.750125, 1.942972>,
      < 1.187723, -0.787506, 1.942986>
    }
    triangle {
      < 1.321630, -0.591890, 1.909297>,
      < 1.317792, -0.586616, 1.909295>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.311689, -0.600846, 1.943029>,
      < 1.306205, -0.593313, 1.943027>,
      < 1.317792, -0.586616, 1.909295>
    }
    triangle {
      < 1.311689, -0.600846, 1.943029>,
      < 1.317792, -0.586616, 1.909295>,
      < 1.321630, -0.591890, 1.909297>
    }
    triangle {
      < 1.263686, -0.644138, 1.924847>,
      < 1.250253, -0.625678, 1.924843>,
      < 1.306205, -0.593313, 1.943027>
    }
    triangle {
      < 1.263686, -0.644138, 1.924847>,
      < 1.306205, -0.593313, 1.943027>,
      < 1.311689, -0.600846, 1.943029>
    }
    triangle {
      < 1.263690, -0.644138, 1.911872>,
      < 1.250256, -0.625678, 1.911867>,
      < 1.250253, -0.625678, 1.924843>
    }
    triangle {
      < 1.263690, -0.644138, 1.911872>,
      < 1.250253, -0.625678, 1.924843>,
      < 1.263686, -0.644138, 1.924847>
    }
    triangle {
      < 1.248790, -0.657573, 1.911867>,
      < 1.232890, -0.635723, 1.911861>,
      < 1.250256, -0.625678, 1.911867>
    }
    triangle {
      < 1.248790, -0.657573, 1.911867>,
      < 1.250256, -0.625678, 1.911867>,
      < 1.263690, -0.644138, 1.911872>
    }
    triangle {
      < 1.242176, -0.663544, 1.883318>,
      < 1.225178, -0.640188, 1.883313>,
      < 1.232890, -0.635723, 1.911861>
    }
    triangle {
      < 1.242176, -0.663544, 1.883318>,
      < 1.232890, -0.635723, 1.911861>,
      < 1.248790, -0.657573, 1.911867>
    }
    triangle {
      < 1.195828, -0.705342, 1.870327>,
      < 1.171154, -0.671437, 1.870319>,
      < 1.225178, -0.640188, 1.883313>
    }
    triangle {
      < 1.195828, -0.705342, 1.870327>,
      < 1.225178, -0.640188, 1.883313>,
      < 1.242176, -0.663544, 1.883318>
    }
    triangle {
      < 1.169338, -0.729227, 1.885888>,
      < 1.140277, -0.689293, 1.885878>,
      < 1.171154, -0.671437, 1.870319>
    }
    triangle {
      < 1.169338, -0.729227, 1.885888>,
      < 1.171154, -0.671437, 1.870319>,
      < 1.195828, -0.705342, 1.870327>
    }
    triangle {
      < 1.149463, -0.747141, 1.919617>,
      < 1.117114, -0.702687, 1.919606>,
      < 1.140277, -0.689293, 1.885878>
    }
    triangle {
      < 1.149463, -0.747141, 1.919617>,
      < 1.140277, -0.689293, 1.885878>,
      < 1.169338, -0.729227, 1.885888>
    }
    triangle {
      < 1.146146, -0.750125, 1.942972>,
      < 1.113249, -0.704918, 1.942961>,
      < 1.117114, -0.702687, 1.919606>
    }
    triangle {
      < 1.146146, -0.750125, 1.942972>,
      < 1.117114, -0.702687, 1.919606>,
      < 1.149463, -0.747141, 1.919617>
    }
    triangle {
      < 1.146140, -0.750126, 1.966978>,
      < 1.113243, -0.704920, 1.966967>,
      < 1.113249, -0.704918, 1.942961>
    }
    triangle {
      < 1.146140, -0.750126, 1.966978>,
      < 1.113249, -0.704918, 1.942961>,
      < 1.146146, -0.750125, 1.942972>
    }
    triangle {
      < 1.317792, -0.586616, 1.909295>,
      < 1.315134, -0.580659, 1.909294>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.306205, -0.593313, 1.943027>,
      < 1.302408, -0.584802, 1.943026>,
      < 1.315134, -0.580659, 1.909294>
    }
    triangle {
      < 1.306205, -0.593313, 1.943027>,
      < 1.315134, -0.580659, 1.909294>,
      < 1.317792, -0.586616, 1.909295>
    }
    triangle {
      < 1.250253, -0.625678, 1.924843>,
      < 1.240950, -0.604830, 1.924839>,
      < 1.302408, -0.584802, 1.943026>
    }
    triangle {
      < 1.250253, -0.625678, 1.924843>,
      < 1.302408, -0.584802, 1.943026>,
      < 1.306205, -0.593313, 1.943027>
    }
    triangle {
      < 1.250256, -0.625678, 1.911867>,
      < 1.240954, -0.604830, 1.911864>,
      < 1.240950, -0.604830, 1.924839>
    }
    triangle {
      < 1.250256, -0.625678, 1.911867>,
      < 1.240950, -0.604830, 1.924839>,
      < 1.250253, -0.625678, 1.924843>
    }
    triangle {
      < 1.232890, -0.635723, 1.911861>,
      < 1.221879, -0.611045, 1.911857>,
      < 1.240954, -0.604830, 1.911864>
    }
    triangle {
      < 1.232890, -0.635723, 1.911861>,
      < 1.240954, -0.604830, 1.911864>,
      < 1.250256, -0.625678, 1.911867>
    }
    triangle {
      < 1.225178, -0.640188, 1.883313>,
      < 1.213408, -0.613807, 1.883308>,
      < 1.221879, -0.611045, 1.911857>
    }
    triangle {
      < 1.225178, -0.640188, 1.883313>,
      < 1.221879, -0.611045, 1.911857>,
      < 1.232890, -0.635723, 1.911861>
    }
    triangle {
      < 1.171154, -0.671437, 1.870319>,
      < 1.154068, -0.633143, 1.870312>,
      < 1.213408, -0.613807, 1.883308>
    }
    triangle {
      < 1.171154, -0.671437, 1.870319>,
      < 1.213408, -0.613807, 1.883308>,
      < 1.225178, -0.640188, 1.883313>
    }
    triangle {
      < 1.140277, -0.689293, 1.885878>,
      < 1.120153, -0.644192, 1.885872>,
      < 1.154068, -0.633143, 1.870312>
    }
    triangle {
      < 1.140277, -0.689293, 1.885878>,
      < 1.154068, -0.633143, 1.870312>,
      < 1.171154, -0.671437, 1.870319>
    }
    triangle {
      < 1.117114, -0.702687, 1.919606>,
      < 1.094712, -0.652479, 1.919599>,
      < 1.120153, -0.644192, 1.885872>
    }
    triangle {
      < 1.117114, -0.702687, 1.919606>,
      < 1.120153, -0.644192, 1.885872>,
      < 1.140277, -0.689293, 1.885878>
    }
    triangle {
      < 1.113249, -0.704918, 1.942961>,
      < 1.090466, -0.653861, 1.942953>,
      < 1.094712, -0.652479, 1.919599>
    }
    triangle {
      < 1.113249, -0.704918, 1.942961>,
      < 1.094712, -0.652479, 1.919599>,
      < 1.117114, -0.702687, 1.919606>
    }
    triangle {
      < 1.113243, -0.704920, 1.966967>,
      < 1.090461, -0.653860, 1.966958>,
      < 1.090466, -0.653861, 1.942953>
    }
    triangle {
      < 1.113243, -0.704920, 1.966967>,
      < 1.090466, -0.653861, 1.942953>,
      < 1.113249, -0.704918, 1.942961>
    }
    triangle {
      < 1.315134, -0.580659, 1.909294>,
      < 1.313771, -0.574280, 1.909294>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.315134, -0.580659, 1.909294>,
      < 1.347022, -0.570756, 1.909305>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.302408, -0.584802, 1.943026>,
      < 1.300463, -0.575689, 1.943025>,
      < 1.313771, -0.574280, 1.909294>
    }
    triangle {
      < 1.302408, -0.584802, 1.943026>,
      < 1.313771, -0.574280, 1.909294>,
      < 1.315134, -0.580659, 1.909294>
    }
    triangle {
      < 1.240950, -0.604830, 1.924839>,
      < 1.236184, -0.582502, 1.924838>,
      < 1.300463, -0.575689, 1.943025>
    }
    triangle {
      < 1.240950, -0.604830, 1.924839>,
      < 1.300463, -0.575689, 1.943025>,
      < 1.302408, -0.584802, 1.943026>
    }
    triangle {
      < 1.240954, -0.604830, 1.911864>,
      < 1.236187, -0.582502, 1.911862>,
      < 1.236184, -0.582502, 1.924838>
    }
    triangle {
      < 1.240954, -0.604830, 1.911864>,
      < 1.236184, -0.582502, 1.924838>,
      < 1.240950, -0.604830, 1.924839>
    }
    triangle {
      < 1.221879, -0.611045, 1.911857>,
      < 1.216238, -0.584617, 1.911856>,
      < 1.236187, -0.582502, 1.911862>
    }
    triangle {
      < 1.221879, -0.611045, 1.911857>,
      < 1.236187, -0.582502, 1.911862>,
      < 1.240954, -0.604830, 1.911864>
    }
    triangle {
      < 1.213408, -0.613807, 1.883308>,
      < 1.207378, -0.585556, 1.883307>,
      < 1.216238, -0.584617, 1.911856>
    }
    triangle {
      < 1.213408, -0.613807, 1.883308>,
      < 1.216238, -0.584617, 1.911856>,
      < 1.221879, -0.611045, 1.911857>
    }
    triangle {
      < 1.154068, -0.633143, 1.870312>,
      < 1.145314, -0.592135, 1.870309>,
      < 1.207378, -0.585556, 1.883307>
    }
    triangle {
      < 1.154068, -0.633143, 1.870312>,
      < 1.207378, -0.585556, 1.883307>,
      < 1.213408, -0.613807, 1.883308>
    }
    triangle {
      < 1.120153, -0.644192, 1.885872>,
      < 1.109844, -0.595893, 1.885867>,
      < 1.145314, -0.592135, 1.870309>
    }
    triangle {
      < 1.120153, -0.644192, 1.885872>,
      < 1.145314, -0.592135, 1.870309>,
      < 1.154068, -0.633143, 1.870312>
    }
    triangle {
      < 1.094712, -0.652479, 1.919599>,
      < 1.083235, -0.598713, 1.919595>,
      < 1.109844, -0.595893, 1.885867>
    }
    triangle {
      < 1.094712, -0.652479, 1.919599>,
      < 1.109844, -0.595893, 1.885867>,
      < 1.120153, -0.644192, 1.885872>
    }
    triangle {
      < 1.090466, -0.653861, 1.942953>,
      < 1.078797, -0.599182, 1.942949>,
      < 1.083235, -0.598713, 1.919595>
    }
    triangle {
      < 1.090466, -0.653861, 1.942953>,
      < 1.083235, -0.598713, 1.919595>,
      < 1.094712, -0.652479, 1.919599>
    }
    triangle {
      < 1.090461, -0.653860, 1.966958>,
      < 1.078790, -0.599182, 1.966954>,
      < 1.078797, -0.599182, 1.942949>
    }
    triangle {
      < 1.090461, -0.653860, 1.966958>,
      < 1.078797, -0.599182, 1.942949>,
      < 1.090466, -0.653861, 1.942953>
    }
    triangle {
      < 1.313771, -0.574280, 1.909294>,
      < 1.313766, -0.567757, 1.909293>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.300463, -0.575689, 1.943025>,
      < 1.300455, -0.566371, 1.943025>,
      < 1.313766, -0.567757, 1.909293>
    }
    triangle {
      < 1.300463, -0.575689, 1.943025>,
      < 1.313766, -0.567757, 1.909293>,
      < 1.313771, -0.574280, 1.909294>
    }
    triangle {
      < 1.236184, -0.582502, 1.924838>,
      < 1.236164, -0.559672, 1.924837>,
      < 1.300455, -0.566371, 1.943025>
    }
    triangle {
      < 1.236184, -0.582502, 1.924838>,
      < 1.300455, -0.566371, 1.943025>,
      < 1.300463, -0.575689, 1.943025>
    }
    triangle {
      < 1.236187, -0.582502, 1.911862>,
      < 1.236168, -0.559672, 1.911862>,
      < 1.236164, -0.559672, 1.924837>
    }
    triangle {
      < 1.236187, -0.582502, 1.911862>,
      < 1.236164, -0.559672, 1.924837>,
      < 1.236184, -0.582502, 1.924838>
    }
    triangle {
      < 1.216238, -0.584617, 1.911856>,
      < 1.216214, -0.557594, 1.911856>,
      < 1.236168, -0.559672, 1.911862>
    }
    triangle {
      < 1.216238, -0.584617, 1.911856>,
      < 1.236168, -0.559672, 1.911862>,
      < 1.236187, -0.582502, 1.911862>
    }
    triangle {
      < 1.207378, -0.585556, 1.883307>,
      < 1.207352, -0.556670, 1.883306>,
      < 1.216214, -0.557594, 1.911856>
    }
    triangle {
      < 1.207378, -0.585556, 1.883307>,
      < 1.216214, -0.557594, 1.911856>,
      < 1.216238, -0.584617, 1.911856>
    }
    triangle {
      < 1.145314, -0.592135, 1.870309>,
      < 1.145277, -0.550202, 1.870309>,
      < 1.207352, -0.556670, 1.883306>
    }
    triangle {
      < 1.145314, -0.592135, 1.870309>,
      < 1.207352, -0.556670, 1.883306>,
      < 1.207378, -0.585556, 1.883307>
    }
    triangle {
      < 1.109844, -0.595893, 1.885867>,
      < 1.109800, -0.546506, 1.885868>,
      < 1.145277, -0.550202, 1.870309>
    }
    triangle {
      < 1.109844, -0.595893, 1.885867>,
      < 1.145277, -0.550202, 1.870309>,
      < 1.145314, -0.592135, 1.870309>
    }
    triangle {
      < 1.083235, -0.598713, 1.919595>,
      < 1.083187, -0.543734, 1.919594>,
      < 1.109800, -0.546506, 1.885868>
    }
    triangle {
      < 1.083235, -0.598713, 1.919595>,
      < 1.109800, -0.546506, 1.885868>,
      < 1.109844, -0.595893, 1.885867>
    }
    triangle {
      < 1.078797, -0.599182, 1.942949>,
      < 1.078746, -0.543272, 1.942949>,
      < 1.083187, -0.543734, 1.919594>
    }
    triangle {
      < 1.078797, -0.599182, 1.942949>,
      < 1.083187, -0.543734, 1.919594>,
      < 1.083235, -0.598713, 1.919595>
    }
    triangle {
      < 1.078790, -0.599182, 1.966954>,
      < 1.078740, -0.543272, 1.966954>,
      < 1.078746, -0.543272, 1.942949>
    }
    triangle {
      < 1.078790, -0.599182, 1.966954>,
      < 1.078746, -0.543272, 1.942949>,
      < 1.078797, -0.599182, 1.942949>
    }
    triangle {
      < 1.313766, -0.567757, 1.909293>,
      < 1.315116, -0.561375, 1.909294>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.300455, -0.566371, 1.943025>,
      < 1.302384, -0.557254, 1.943026>,
      < 1.315116, -0.561375, 1.909294>
    }
    triangle {
      < 1.300455, -0.566371, 1.943025>,
      < 1.315116, -0.561375, 1.909294>,
      < 1.313766, -0.567757, 1.909293>
    }
    triangle {
      < 1.236164, -0.559672, 1.924837>,
      < 1.240890, -0.537337, 1.924839>,
      < 1.302384, -0.557254, 1.943026>
    }
    triangle {
      < 1.236164, -0.559672, 1.924837>,
      < 1.302384, -0.557254, 1.943026>,
      < 1.300455, -0.566371, 1.943025>
    }
    triangle {
      < 1.236168, -0.559672, 1.911862>,
      < 1.240894, -0.537337, 1.911864>,
      < 1.240890, -0.537337, 1.924839>
    }
    triangle {
      < 1.236168, -0.559672, 1.911862>,
      < 1.240890, -0.537337, 1.924839>,
      < 1.236164, -0.559672, 1.924837>
    }
    triangle {
      < 1.216214, -0.557594, 1.911856>,
      < 1.221807, -0.531155, 1.911857>,
      < 1.240894, -0.537337, 1.911864>
    }
    triangle {
      < 1.216214, -0.557594, 1.911856>,
      < 1.240894, -0.537337, 1.911864>,
      < 1.236168, -0.559672, 1.911862>
    }
    triangle {
      < 1.207352, -0.556670, 1.883306>,
      < 1.213332, -0.528408, 1.883308>,
      < 1.221807, -0.531155, 1.911857>
    }
    triangle {
      < 1.207352, -0.556670, 1.883306>,
      < 1.221807, -0.531155, 1.911857>,
      < 1.216214, -0.557594, 1.911856>
    }
    triangle {
      < 1.145277, -0.550202, 1.870309>,
      < 1.153958, -0.509177, 1.870312>,
      < 1.213332, -0.528408, 1.883308>
    }
    triangle {
      < 1.145277, -0.550202, 1.870309>,
      < 1.213332, -0.528408, 1.883308>,
      < 1.207352, -0.556670, 1.883306>
    }
    triangle {
      < 1.109800, -0.546506, 1.885868>,
      < 1.120023, -0.498188, 1.885871>,
      < 1.153958, -0.509177, 1.870312>
    }
    triangle {
      < 1.109800, -0.546506, 1.885868>,
      < 1.153958, -0.509177, 1.870312>,
      < 1.145277, -0.550202, 1.870309>
    }
    triangle {
      < 1.083187, -0.543734, 1.919594>,
      < 1.094567, -0.489946, 1.919599>,
      < 1.120023, -0.498188, 1.885871>
    }
    triangle {
      < 1.083187, -0.543734, 1.919594>,
      < 1.120023, -0.498188, 1.885871>,
      < 1.109800, -0.546506, 1.885868>
    }
    triangle {
      < 1.078746, -0.543272, 1.942949>,
      < 1.090320, -0.488573, 1.942953>,
      < 1.094567, -0.489946, 1.919599>
    }
    triangle {
      < 1.078746, -0.543272, 1.942949>,
      < 1.094567, -0.489946, 1.919599>,
      < 1.083187, -0.543734, 1.919594>
    }
    triangle {
      < 1.078740, -0.543272, 1.966954>,
      < 1.090314, -0.488572, 1.966958>,
      < 1.090320, -0.488573, 1.942953>
    }
    triangle {
      < 1.078740, -0.543272, 1.966954>,
      < 1.090320, -0.488573, 1.942953>,
      < 1.078746, -0.543272, 1.942949>
    }
    triangle {
      < 1.315116, -0.561375, 1.909294>,
      < 1.317763, -0.555414, 1.909295>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.302384, -0.557254, 1.943026>,
      < 1.306166, -0.548739, 1.943027>,
      < 1.317763, -0.555414, 1.909295>
    }
    triangle {
      < 1.302384, -0.557254, 1.943026>,
      < 1.317763, -0.555414, 1.909295>,
      < 1.315116, -0.561375, 1.909294>
    }
    triangle {
      < 1.240890, -0.537337, 1.924839>,
      < 1.250155, -0.516472, 1.924842>,
      < 1.306166, -0.548739, 1.943027>
    }
    triangle {
      < 1.240890, -0.537337, 1.924839>,
      < 1.306166, -0.548739, 1.943027>,
      < 1.302384, -0.557254, 1.943026>
    }
    triangle {
      < 1.240894, -0.537337, 1.911864>,
      < 1.250158, -0.516471, 1.911867>,
      < 1.250155, -0.516472, 1.924842>
    }
    triangle {
      < 1.240894, -0.537337, 1.911864>,
      < 1.250155, -0.516472, 1.924842>,
      < 1.240890, -0.537337, 1.924839>
    }
    triangle {
      < 1.221807, -0.531155, 1.911857>,
      < 1.232775, -0.506458, 1.911861>,
      < 1.250158, -0.516471, 1.911867>
    }
    triangle {
      < 1.221807, -0.531155, 1.911857>,
      < 1.250158, -0.516471, 1.911867>,
      < 1.240894, -0.537337, 1.911864>
    }
    triangle {
      < 1.213332, -0.528408, 1.883308>,
      < 1.225056, -0.502008, 1.883312>,
      < 1.232775, -0.506458, 1.911861>
    }
    triangle {
      < 1.213332, -0.528408, 1.883308>,
      < 1.232775, -0.506458, 1.911861>,
      < 1.221807, -0.531155, 1.911857>
    }
    triangle {
      < 1.153958, -0.509177, 1.870312>,
      < 1.170977, -0.470853, 1.870318>,
      < 1.225056, -0.502008, 1.883312>
    }
    triangle {
      < 1.153958, -0.509177, 1.870312>,
      < 1.225056, -0.502008, 1.883312>,
      < 1.213332, -0.528408, 1.883308>
    }
    triangle {
      < 1.120023, -0.498188, 1.885871>,
      < 1.140067, -0.453052, 1.885878>,
      < 1.170977, -0.470853, 1.870318>
    }
    triangle {
      < 1.120023, -0.498188, 1.885871>,
      < 1.170977, -0.470853, 1.870318>,
      < 1.153958, -0.509177, 1.870312>
    }
    triangle {
      < 1.094567, -0.489946, 1.919599>,
      < 1.116881, -0.439700, 1.919607>,
      < 1.140067, -0.453052, 1.885878>
    }
    triangle {
      < 1.094567, -0.489946, 1.919599>,
      < 1.140067, -0.453052, 1.885878>,
      < 1.120023, -0.498188, 1.885871>
    }
    triangle {
      < 1.090320, -0.488573, 1.942953>,
      < 1.113011, -0.437475, 1.942961>,
      < 1.116881, -0.439700, 1.919607>
    }
    triangle {
      < 1.090320, -0.488573, 1.942953>,
      < 1.116881, -0.439700, 1.919607>,
      < 1.094567, -0.489946, 1.919599>
    }
    triangle {
      < 1.090314, -0.488572, 1.966958>,
      < 1.113006, -0.437475, 1.966966>,
      < 1.113011, -0.437475, 1.942961>
    }
    triangle {
      < 1.090314, -0.488572, 1.966958>,
      < 1.113011, -0.437475, 1.942961>,
      < 1.090320, -0.488573, 1.942953>
    }
    triangle {
      < 1.317763, -0.555414, 1.909295>,
      < 1.321592, -0.550133, 1.909296>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.306166, -0.548739, 1.943027>,
      < 1.311635, -0.541193, 1.943029>,
      < 1.321592, -0.550133, 1.909296>
    }
    triangle {
      < 1.306166, -0.548739, 1.943027>,
      < 1.321592, -0.550133, 1.909296>,
      < 1.317763, -0.555414, 1.909295>
    }
    triangle {
      < 1.250155, -0.516472, 1.924842>,
      < 1.263556, -0.497988, 1.924847>,
      < 1.311635, -0.541193, 1.943029>
    }
    triangle {
      < 1.250155, -0.516472, 1.924842>,
      < 1.311635, -0.541193, 1.943029>,
      < 1.306166, -0.548739, 1.943027>
    }
    triangle {
      < 1.250158, -0.516471, 1.911867>,
      < 1.263559, -0.497988, 1.911872>,
      < 1.263556, -0.497988, 1.924847>
    }
    triangle {
      < 1.250158, -0.516471, 1.911867>,
      < 1.263556, -0.497988, 1.924847>,
      < 1.250155, -0.516472, 1.924842>
    }
    triangle {
      < 1.232775, -0.506458, 1.911861>,
      < 1.248637, -0.484579, 1.911867>,
      < 1.263559, -0.497988, 1.911872>
    }
    triangle {
      < 1.232775, -0.506458, 1.911861>,
      < 1.263559, -0.497988, 1.911872>,
      < 1.250158, -0.516471, 1.911867>
    }
    triangle {
      < 1.225056, -0.502008, 1.883312>,
      < 1.242011, -0.478620, 1.883318>,
      < 1.248637, -0.484579, 1.911867>
    }
    triangle {
      < 1.225056, -0.502008, 1.883312>,
      < 1.248637, -0.484579, 1.911867>,
      < 1.232775, -0.506458, 1.911861>
    }
    triangle {
      < 1.170977, -0.470853, 1.870318>,
      < 1.195590, -0.436905, 1.870326>,
      < 1.242011, -0.478620, 1.883318>
    }
    triangle {
      < 1.170977, -0.470853, 1.870318>,
      < 1.242011, -0.478620, 1.883318>,
      < 1.225056, -0.502008, 1.883312>
    }
    triangle {
      < 1.140067, -0.453052, 1.885878>,
      < 1.169057, -0.413067, 1.885888>,
      < 1.195590, -0.436905, 1.870326>
    }
    triangle {
      < 1.140067, -0.453052, 1.885878>,
      < 1.195590, -0.436905, 1.870326>,
      < 1.170977, -0.470853, 1.870318>
    }
    triangle {
      < 1.116881, -0.439700, 1.919607>,
      < 1.149151, -0.395189, 1.919617>,
      < 1.169057, -0.413067, 1.885888>
    }
    triangle {
      < 1.116881, -0.439700, 1.919607>,
      < 1.169057, -0.413067, 1.885888>,
      < 1.140067, -0.453052, 1.885878>
    }
    triangle {
      < 1.113011, -0.437475, 1.942961>,
      < 1.145829, -0.392209, 1.942972>,
      < 1.149151, -0.395189, 1.919617>
    }
    triangle {
      < 1.113011, -0.437475, 1.942961>,
      < 1.149151, -0.395189, 1.919617>,
      < 1.116881, -0.439700, 1.919607>
    }
    triangle {
      < 1.113006, -0.437475, 1.966966>,
      < 1.145822, -0.392209, 1.966977>,
      < 1.145829, -0.392209, 1.942972>
    }
    triangle {
      < 1.113006, -0.437475, 1.966966>,
      < 1.145829, -0.392209, 1.942972>,
      < 1.113011, -0.437475, 1.942961>
    }
    triangle {
      < 1.321592, -0.550133, 1.909296>,
      < 1.326435, -0.545763, 1.909298>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.311635, -0.541193, 1.943029>,
      < 1.318554, -0.534951, 1.943032>,
      < 1.326435, -0.545763, 1.909298>
    }
    triangle {
      < 1.311635, -0.541193, 1.943029>,
      < 1.326435, -0.545763, 1.909298>,
      < 1.321592, -0.550133, 1.909296>
    }
    triangle {
      < 1.263556, -0.497988, 1.924847>,
      < 1.280506, -0.482695, 1.924853>,
      < 1.318554, -0.534951, 1.943032>
    }
    triangle {
      < 1.263556, -0.497988, 1.924847>,
      < 1.318554, -0.534951, 1.943032>,
      < 1.311635, -0.541193, 1.943029>
    }
    triangle {
      < 1.263559, -0.497988, 1.911872>,
      < 1.280509, -0.482694, 1.911878>,
      < 1.280506, -0.482695, 1.924853>
    }
    triangle {
      < 1.263559, -0.497988, 1.911872>,
      < 1.280506, -0.482695, 1.924853>,
      < 1.263556, -0.497988, 1.924847>
    }
    triangle {
      < 1.248637, -0.484579, 1.911867>,
      < 1.268701, -0.466476, 1.911873>,
      < 1.280509, -0.482694, 1.911878>
    }
    triangle {
      < 1.248637, -0.484579, 1.911867>,
      < 1.280509, -0.482694, 1.911878>,
      < 1.263559, -0.497988, 1.911872>
    }
    triangle {
      < 1.242011, -0.478620, 1.883318>,
      < 1.263458, -0.459268, 1.883325>,
      < 1.268701, -0.466476, 1.911873>
    }
    triangle {
      < 1.242011, -0.478620, 1.883318>,
      < 1.268701, -0.466476, 1.911873>,
      < 1.248637, -0.484579, 1.911867>
    }
    triangle {
      < 1.195590, -0.436905, 1.870326>,
      < 1.226722, -0.408813, 1.870337>,
      < 1.263458, -0.459268, 1.883325>
    }
    triangle {
      < 1.195590, -0.436905, 1.870326>,
      < 1.263458, -0.459268, 1.883325>,
      < 1.242011, -0.478620, 1.883318>
    }
    triangle {
      < 1.169057, -0.413067, 1.885888>,
      < 1.205723, -0.379982, 1.885901>,
      < 1.226722, -0.408813, 1.870337>
    }
    triangle {
      < 1.169057, -0.413067, 1.885888>,
      < 1.226722, -0.408813, 1.870337>,
      < 1.195590, -0.436905, 1.870326>
    }
    triangle {
      < 1.149151, -0.395189, 1.919617>,
      < 1.189969, -0.358358, 1.919631>,
      < 1.205723, -0.379982, 1.885901>
    }
    triangle {
      < 1.149151, -0.395189, 1.919617>,
      < 1.205723, -0.379982, 1.885901>,
      < 1.169057, -0.413067, 1.885888>
    }
    triangle {
      < 1.145829, -0.392209, 1.942972>,
      < 1.187339, -0.354755, 1.942986>,
      < 1.189969, -0.358358, 1.919631>
    }
    triangle {
      < 1.145829, -0.392209, 1.942972>,
      < 1.189969, -0.358358, 1.919631>,
      < 1.149151, -0.395189, 1.919617>
    }
    triangle {
      < 1.145822, -0.392209, 1.966977>,
      < 1.187334, -0.354755, 1.966992>,
      < 1.187339, -0.354755, 1.942986>
    }
    triangle {
      < 1.145822, -0.392209, 1.966977>,
      < 1.187339, -0.354755, 1.942986>,
      < 1.145829, -0.392209, 1.942972>
    }
    triangle {
      < 1.326435, -0.545763, 1.909298>,
      < 1.332081, -0.542495, 1.909300>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.318554, -0.534951, 1.943032>,
      < 1.326618, -0.530283, 1.943034>,
      < 1.332081, -0.542495, 1.909300>
    }
    triangle {
      < 1.318554, -0.534951, 1.943032>,
      < 1.332081, -0.542495, 1.909300>,
      < 1.326435, -0.545763, 1.909298>
    }
    triangle {
      < 1.280506, -0.482695, 1.924853>,
      < 1.300265, -0.471258, 1.924860>,
      < 1.326618, -0.530283, 1.943034>
    }
    triangle {
      < 1.280506, -0.482695, 1.924853>,
      < 1.326618, -0.530283, 1.943034>,
      < 1.318554, -0.534951, 1.943032>
    }
    triangle {
      < 1.280509, -0.482694, 1.911878>,
      < 1.300268, -0.471258, 1.911884>,
      < 1.300265, -0.471258, 1.924860>
    }
    triangle {
      < 1.280509, -0.482694, 1.911878>,
      < 1.300265, -0.471258, 1.924860>,
      < 1.280506, -0.482695, 1.924853>
    }
    triangle {
      < 1.268701, -0.466476, 1.911873>,
      < 1.292088, -0.452939, 1.911881>,
      < 1.300268, -0.471258, 1.911884>
    }
    triangle {
      < 1.268701, -0.466476, 1.911873>,
      < 1.300268, -0.471258, 1.911884>,
      < 1.280509, -0.482694, 1.911878>
    }
    triangle {
      < 1.263458, -0.459268, 1.883325>,
      < 1.288459, -0.444798, 1.883334>,
      < 1.292088, -0.452939, 1.911881>
    }
    triangle {
      < 1.263458, -0.459268, 1.883325>,
      < 1.292088, -0.452939, 1.911881>,
      < 1.268701, -0.466476, 1.911873>
    }
    triangle {
      < 1.226722, -0.408813, 1.870337>,
      < 1.263014, -0.387808, 1.870350>,
      < 1.288459, -0.444798, 1.883334>
    }
    triangle {
      < 1.226722, -0.408813, 1.870337>,
      < 1.288459, -0.444798, 1.883334>,
      < 1.263458, -0.459268, 1.883325>
    }
    triangle {
      < 1.205723, -0.379982, 1.885901>,
      < 1.248467, -0.355242, 1.885916>,
      < 1.263014, -0.387808, 1.870350>
    }
    triangle {
      < 1.205723, -0.379982, 1.885901>,
      < 1.263014, -0.387808, 1.870350>,
      < 1.226722, -0.408813, 1.870337>
    }
    triangle {
      < 1.189969, -0.358358, 1.919631>,
      < 1.237552, -0.330817, 1.919648>,
      < 1.248467, -0.355242, 1.885916>
    }
    triangle {
      < 1.189969, -0.358358, 1.919631>,
      < 1.248467, -0.355242, 1.885916>,
      < 1.205723, -0.379982, 1.885901>
    }
    triangle {
      < 1.187339, -0.354755, 1.942986>,
      < 1.235728, -0.326747, 1.943003>,
      < 1.237552, -0.330817, 1.919648>
    }
    triangle {
      < 1.187339, -0.354755, 1.942986>,
      < 1.237552, -0.330817, 1.919648>,
      < 1.189969, -0.358358, 1.919631>
    }
    triangle {
      < 1.187334, -0.354755, 1.966992>,
      < 1.235722, -0.326747, 1.967009>,
      < 1.235728, -0.326747, 1.943003>
    }
    triangle {
      < 1.187334, -0.354755, 1.966992>,
      < 1.235728, -0.326747, 1.943003>,
      < 1.187339, -0.354755, 1.942986>
    }
    triangle {
      < 1.332081, -0.542495, 1.909300>,
      < 1.338282, -0.540473, 1.909302>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.332081, -0.542495, 1.909300>,
      < 1.345271, -0.573171, 1.909304>,
      < 1.347022, -0.570756, 1.909305>
    }
    triangle {
      < 1.326618, -0.530283, 1.943034>,
      < 1.335478, -0.527394, 1.943037>,
      < 1.338282, -0.540473, 1.909302>
    }
    triangle {
      < 1.326618, -0.530283, 1.943034>,
      < 1.338282, -0.540473, 1.909302>,
      < 1.332081, -0.542495, 1.909300>
    }
    triangle {
      < 1.300265, -0.471258, 1.924860>,
      < 1.321970, -0.464178, 1.924867>,
      < 1.335478, -0.527394, 1.943037>
    }
    triangle {
      < 1.300265, -0.471258, 1.924860>,
      < 1.335478, -0.527394, 1.943037>,
      < 1.326618, -0.530283, 1.943034>
    }
    triangle {
      < 1.300268, -0.471258, 1.911884>,
      < 1.321974, -0.464179, 1.911892>,
      < 1.321970, -0.464178, 1.924867>
    }
    triangle {
      < 1.300268, -0.471258, 1.911884>,
      < 1.321970, -0.464178, 1.924867>,
      < 1.300265, -0.471258, 1.924860>
    }
    triangle {
      < 1.292088, -0.452939, 1.911881>,
      < 1.317779, -0.444560, 1.911891>,
      < 1.321974, -0.464179, 1.911892>
    }
    triangle {
      < 1.292088, -0.452939, 1.911881>,
      < 1.321974, -0.464179, 1.911892>,
      < 1.300268, -0.471258, 1.911884>
    }
    triangle {
      < 1.288459, -0.444798, 1.883334>,
      < 1.315923, -0.435840, 1.883344>,
      < 1.317779, -0.444560, 1.911891>
    }
    triangle {
      < 1.288459, -0.444798, 1.883334>,
      < 1.317779, -0.444560, 1.911891>,
      < 1.292088, -0.452939, 1.911881>
    }
    triangle {
      < 1.263014, -0.387808, 1.870350>,
      < 1.302880, -0.374805, 1.870364>,
      < 1.315923, -0.435840, 1.883344>
    }
    triangle {
      < 1.263014, -0.387808, 1.870350>,
      < 1.315923, -0.435840, 1.883344>,
      < 1.288459, -0.444798, 1.883334>
    }
    triangle {
      < 1.248467, -0.355242, 1.885916>,
      < 1.295421, -0.339927, 1.885932>,
      < 1.302880, -0.374805, 1.870364>
    }
    triangle {
      < 1.248467, -0.355242, 1.885916>,
      < 1.302880, -0.374805, 1.870364>,
      < 1.263014, -0.387808, 1.870350>
    }
    triangle {
      < 1.237552, -0.330817, 1.919648>,
      < 1.289820, -0.313770, 1.919665>,
      < 1.295421, -0.339927, 1.885932>
    }
    triangle {
      < 1.237552, -0.330817, 1.919648>,
      < 1.295421, -0.339927, 1.885932>,
      < 1.248467, -0.355242, 1.885916>
    }
    triangle {
      < 1.235728, -0.326747, 1.943003>,
      < 1.288882, -0.309409, 1.943021>,
      < 1.289820, -0.313770, 1.919665>
    }
    triangle {
      < 1.235728, -0.326747, 1.943003>,
      < 1.289820, -0.313770, 1.919665>,
      < 1.237552, -0.330817, 1.919648>
    }
    triangle {
      < 1.235722, -0.326747, 1.967009>,
      < 1.288876, -0.309409, 1.967027>,
      < 1.288882, -0.309409, 1.943021>
    }
    triangle {
      < 1.235722, -0.326747, 1.967009>,
      < 1.288882, -0.309409, 1.943021>,
      < 1.235728, -0.326747, 1.943003>
    }
    triangle {
      < 1.338282, -0.540473, 1.909302>,
      < 1.344769, -0.539783, 1.909305>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.335478, -0.527394, 1.943037>,
      < 1.344744, -0.526409, 1.943041>,
      < 1.344769, -0.539783, 1.909305>
    }
    triangle {
      < 1.335478, -0.527394, 1.943037>,
      < 1.344769, -0.539783, 1.909305>,
      < 1.338282, -0.540473, 1.909302>
    }
    triangle {
      < 1.321970, -0.464178, 1.924867>,
      < 1.344672, -0.461766, 1.924875>,
      < 1.344744, -0.526409, 1.943041>
    }
    triangle {
      < 1.321970, -0.464178, 1.924867>,
      < 1.344744, -0.526409, 1.943041>,
      < 1.335478, -0.527394, 1.943037>
    }
    triangle {
      < 1.321974, -0.464179, 1.911892>,
      < 1.344675, -0.461766, 1.911899>,
      < 1.344672, -0.461766, 1.924875>
    }
    triangle {
      < 1.321974, -0.464179, 1.911892>,
      < 1.344672, -0.461766, 1.924875>,
      < 1.321970, -0.464178, 1.924867>
    }
    triangle {
      < 1.317779, -0.444560, 1.911891>,
      < 1.344651, -0.441704, 1.911900>,
      < 1.344675, -0.461766, 1.911899>
    }
    triangle {
      < 1.317779, -0.444560, 1.911891>,
      < 1.344675, -0.461766, 1.911899>,
      < 1.321974, -0.464179, 1.911892>
    }
    triangle {
      < 1.315923, -0.435840, 1.883344>,
      < 1.344647, -0.432788, 1.883353>,
      < 1.344651, -0.441704, 1.911900>
    }
    triangle {
      < 1.315923, -0.435840, 1.883344>,
      < 1.344651, -0.441704, 1.911900>,
      < 1.317779, -0.444560, 1.911891>
    }
    triangle {
      < 1.302880, -0.374805, 1.870364>,
      < 1.344577, -0.370373, 1.870378>,
      < 1.344647, -0.432788, 1.883353>
    }
    triangle {
      < 1.302880, -0.374805, 1.870364>,
      < 1.344647, -0.432788, 1.883353>,
      < 1.315923, -0.435840, 1.883344>
    }
    triangle {
      < 1.295421, -0.339927, 1.885932>,
      < 1.344531, -0.334708, 1.885949>,
      < 1.344577, -0.370373, 1.870378>
    }
    triangle {
      < 1.295421, -0.339927, 1.885932>,
      < 1.344577, -0.370373, 1.870378>,
      < 1.302880, -0.374805, 1.870364>
    }
    triangle {
      < 1.289820, -0.313770, 1.919665>,
      < 1.344491, -0.307958, 1.919685>,
      < 1.344531, -0.334708, 1.885949>
    }
    triangle {
      < 1.289820, -0.313770, 1.919665>,
      < 1.344531, -0.334708, 1.885949>,
      < 1.295421, -0.339927, 1.885932>
    }
    triangle {
      < 1.288882, -0.309409, 1.943021>,
      < 1.344480, -0.303501, 1.943040>,
      < 1.344491, -0.307958, 1.919685>
    }
    triangle {
      < 1.288882, -0.309409, 1.943021>,
      < 1.344491, -0.307958, 1.919685>,
      < 1.289820, -0.313770, 1.919665>
    }
    triangle {
      < 1.288876, -0.309409, 1.967027>,
      < 1.344474, -0.303500, 1.967046>,
      < 1.344480, -0.303501, 1.943040>
    }
    triangle {
      < 1.288876, -0.309409, 1.967027>,
      < 1.344480, -0.303501, 1.943040>,
      < 1.288882, -0.309409, 1.943021>
    }
    triangle {
      < 1.344769, -0.539783, 1.909305>,
      < 1.351256, -0.540458, 1.909307>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.344744, -0.526409, 1.943041>,
      < 1.354012, -0.527372, 1.943044>,
      < 1.351256, -0.540458, 1.909307>
    }
    triangle {
      < 1.344744, -0.526409, 1.943041>,
      < 1.351256, -0.540458, 1.909307>,
      < 1.344769, -0.539783, 1.909305>
    }
    triangle {
      < 1.344672, -0.461766, 1.924875>,
      < 1.367380, -0.464125, 1.924883>,
      < 1.354012, -0.527372, 1.943044>
    }
    triangle {
      < 1.344672, -0.461766, 1.924875>,
      < 1.354012, -0.527372, 1.943044>,
      < 1.344744, -0.526409, 1.943041>
    }
    triangle {
      < 1.344675, -0.461766, 1.911899>,
      < 1.367383, -0.464125, 1.911907>,
      < 1.367380, -0.464125, 1.924883>
    }
    triangle {
      < 1.344675, -0.461766, 1.911899>,
      < 1.367380, -0.464125, 1.924883>,
      < 1.344672, -0.461766, 1.924875>
    }
    triangle {
      < 1.344651, -0.441704, 1.911900>,
      < 1.371530, -0.444496, 1.911909>,
      < 1.367383, -0.464125, 1.911907>
    }
    triangle {
      < 1.344651, -0.441704, 1.911900>,
      < 1.367383, -0.464125, 1.911907>,
      < 1.344675, -0.461766, 1.911899>
    }
    triangle {
      < 1.344647, -0.432788, 1.883353>,
      < 1.373380, -0.435772, 1.883364>,
      < 1.371530, -0.444496, 1.911909>
    }
    triangle {
      < 1.344647, -0.432788, 1.883353>,
      < 1.371530, -0.444496, 1.911909>,
      < 1.344651, -0.441704, 1.911900>
    }
    triangle {
      < 1.344577, -0.370373, 1.870378>,
      < 1.386285, -0.374706, 1.870393>,
      < 1.373380, -0.435772, 1.883364>
    }
    triangle {
      < 1.344577, -0.370373, 1.870378>,
      < 1.373380, -0.435772, 1.883364>,
      < 1.344647, -0.432788, 1.883353>
    }
    triangle {
      < 1.344531, -0.334708, 1.885949>,
      < 1.393654, -0.339812, 1.885966>,
      < 1.386285, -0.374706, 1.870393>
    }
    triangle {
      < 1.344531, -0.334708, 1.885949>,
      < 1.386285, -0.374706, 1.870393>,
      < 1.344577, -0.370373, 1.870378>
    }
    triangle {
      < 1.344491, -0.307958, 1.919685>,
      < 1.399174, -0.313640, 1.919704>,
      < 1.393654, -0.339812, 1.885966>
    }
    triangle {
      < 1.344491, -0.307958, 1.919685>,
      < 1.393654, -0.339812, 1.885966>,
      < 1.344531, -0.334708, 1.885949>
    }
    triangle {
      < 1.344480, -0.303501, 1.943040>,
      < 1.400090, -0.309278, 1.943060>,
      < 1.399174, -0.313640, 1.919704>
    }
    triangle {
      < 1.344480, -0.303501, 1.943040>,
      < 1.399174, -0.313640, 1.919704>,
      < 1.344491, -0.307958, 1.919685>
    }
    triangle {
      < 1.344474, -0.303500, 1.967046>,
      < 1.400084, -0.309278, 1.967065>,
      < 1.400090, -0.309278, 1.943060>
    }
    triangle {
      < 1.344474, -0.303500, 1.967046>,
      < 1.400090, -0.309278, 1.943060>,
      < 1.344480, -0.303501, 1.943040>
    }
    triangle {
      < 1.351256, -0.540458, 1.909307>,
      < 1.357462, -0.542466, 1.909309>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.354012, -0.527372, 1.943044>,
      < 1.362878, -0.530241, 1.943047>,
      < 1.357462, -0.542466, 1.909309>
    }
    triangle {
      < 1.354012, -0.527372, 1.943044>,
      < 1.357462, -0.542466, 1.909309>,
      < 1.351256, -0.540458, 1.909307>
    }
    triangle {
      < 1.367380, -0.464125, 1.924883>,
      < 1.389101, -0.471153, 1.924890>,
      < 1.362878, -0.530241, 1.943047>
    }
    triangle {
      < 1.367380, -0.464125, 1.924883>,
      < 1.362878, -0.530241, 1.943047>,
      < 1.354012, -0.527372, 1.943044>
    }
    triangle {
      < 1.367383, -0.464125, 1.911907>,
      < 1.389104, -0.471152, 1.911915>,
      < 1.389101, -0.471153, 1.924890>
    }
    triangle {
      < 1.367383, -0.464125, 1.911907>,
      < 1.389101, -0.471153, 1.924890>,
      < 1.367380, -0.464125, 1.924883>
    }
    triangle {
      < 1.371530, -0.444496, 1.911909>,
      < 1.397241, -0.452815, 1.911918>,
      < 1.389104, -0.471152, 1.911915>
    }
    triangle {
      < 1.371530, -0.444496, 1.911909>,
      < 1.389104, -0.471152, 1.911915>,
      < 1.367383, -0.464125, 1.911907>
    }
    triangle {
      < 1.373380, -0.435772, 1.883364>,
      < 1.400864, -0.444664, 1.883373>,
      < 1.397241, -0.452815, 1.911918>
    }
    triangle {
      < 1.373380, -0.435772, 1.883364>,
      < 1.397241, -0.452815, 1.911918>,
      < 1.371530, -0.444496, 1.911909>
    }
    triangle {
      < 1.386285, -0.374706, 1.870393>,
      < 1.426182, -0.387615, 1.870406>,
      < 1.400864, -0.444664, 1.883373>
    }
    triangle {
      < 1.386285, -0.374706, 1.870393>,
      < 1.400864, -0.444664, 1.883373>,
      < 1.373380, -0.435772, 1.883364>
    }
    triangle {
      < 1.393654, -0.339812, 1.885966>,
      < 1.440643, -0.355014, 1.885982>,
      < 1.426182, -0.387615, 1.870406>
    }
    triangle {
      < 1.393654, -0.339812, 1.885966>,
      < 1.426182, -0.387615, 1.870406>,
      < 1.386285, -0.374706, 1.870393>
    }
    triangle {
      < 1.399174, -0.313640, 1.919704>,
      < 1.451483, -0.330564, 1.919722>,
      < 1.440643, -0.355014, 1.885982>
    }
    triangle {
      < 1.399174, -0.313640, 1.919704>,
      < 1.440643, -0.355014, 1.885982>,
      < 1.393654, -0.339812, 1.885966>
    }
    triangle {
      < 1.400090, -0.309278, 1.943060>,
      < 1.453286, -0.326489, 1.943078>,
      < 1.451483, -0.330564, 1.919722>
    }
    triangle {
      < 1.400090, -0.309278, 1.943060>,
      < 1.451483, -0.330564, 1.919722>,
      < 1.399174, -0.313640, 1.919704>
    }
    triangle {
      < 1.400084, -0.309278, 1.967065>,
      < 1.453280, -0.326489, 1.967083>,
      < 1.453286, -0.326489, 1.943078>
    }
    triangle {
      < 1.400084, -0.309278, 1.967065>,
      < 1.453286, -0.326489, 1.943078>,
      < 1.400090, -0.309278, 1.943060>
    }
    triangle {
      < 1.357462, -0.542466, 1.909309>,
      < 1.363115, -0.545719, 1.909311>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.362878, -0.530241, 1.943047>,
      < 1.370954, -0.534889, 1.943049>,
      < 1.363115, -0.545719, 1.909311>
    }
    triangle {
      < 1.362878, -0.530241, 1.943047>,
      < 1.363115, -0.545719, 1.909311>,
      < 1.357462, -0.542466, 1.909309>
    }
    triangle {
      < 1.389101, -0.471153, 1.924890>,
      < 1.408886, -0.482542, 1.924897>,
      < 1.370954, -0.534889, 1.943049>
    }
    triangle {
      < 1.389101, -0.471153, 1.924890>,
      < 1.370954, -0.534889, 1.943049>,
      < 1.362878, -0.530241, 1.943047>
    }
    triangle {
      < 1.389104, -0.471152, 1.911915>,
      < 1.408890, -0.482542, 1.911922>,
      < 1.408886, -0.482542, 1.924897>
    }
    triangle {
      < 1.389104, -0.471152, 1.911915>,
      < 1.408886, -0.482542, 1.924897>,
      < 1.389101, -0.471153, 1.924890>
    }
    triangle {
      < 1.397241, -0.452815, 1.911918>,
      < 1.420661, -0.466297, 1.911926>,
      < 1.408890, -0.482542, 1.911922>
    }
    triangle {
      < 1.397241, -0.452815, 1.911918>,
      < 1.408890, -0.482542, 1.911922>,
      < 1.389104, -0.471152, 1.911915>
    }
    triangle {
      < 1.400864, -0.444664, 1.883373>,
      < 1.425900, -0.459076, 1.883382>,
      < 1.420661, -0.466297, 1.911926>
    }
    triangle {
      < 1.400864, -0.444664, 1.883373>,
      < 1.420661, -0.466297, 1.911926>,
      < 1.397241, -0.452815, 1.911918>
    }
    triangle {
      < 1.426182, -0.387615, 1.870406>,
      < 1.462524, -0.408534, 1.870419>,
      < 1.425900, -0.459076, 1.883382>
    }
    triangle {
      < 1.426182, -0.387615, 1.870406>,
      < 1.425900, -0.459076, 1.883382>,
      < 1.400864, -0.444664, 1.883373>
    }
    triangle {
      < 1.440643, -0.355014, 1.885982>,
      < 1.483446, -0.379652, 1.885996>,
      < 1.462524, -0.408534, 1.870419>
    }
    triangle {
      < 1.440643, -0.355014, 1.885982>,
      < 1.462524, -0.408534, 1.870419>,
      < 1.426182, -0.387615, 1.870406>
    }
    triangle {
      < 1.451483, -0.330564, 1.919722>,
      < 1.499131, -0.357993, 1.919738>,
      < 1.483446, -0.379652, 1.885996>
    }
    triangle {
      < 1.451483, -0.330564, 1.919722>,
      < 1.483446, -0.379652, 1.885996>,
      < 1.440643, -0.355014, 1.885982>
    }
    triangle {
      < 1.453286, -0.326489, 1.943078>,
      < 1.501741, -0.354382, 1.943095>,
      < 1.499131, -0.357993, 1.919738>
    }
    triangle {
      < 1.453286, -0.326489, 1.943078>,
      < 1.499131, -0.357993, 1.919738>,
      < 1.451483, -0.330564, 1.919722>
    }
    triangle {
      < 1.453280, -0.326489, 1.967083>,
      < 1.501734, -0.354382, 1.967101>,
      < 1.501741, -0.354382, 1.943095>
    }
    triangle {
      < 1.453280, -0.326489, 1.967083>,
      < 1.501741, -0.354382, 1.943095>,
      < 1.453286, -0.326489, 1.943078>
    }
    triangle {
      < 1.363115, -0.545719, 1.909311>,
      < 1.367968, -0.550079, 1.909312>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.370954, -0.534889, 1.943049>,
      < 1.377887, -0.541115, 1.943052>,
      < 1.367968, -0.550079, 1.909312>
    }
    triangle {
      < 1.370954, -0.534889, 1.943049>,
      < 1.367968, -0.550079, 1.909312>,
      < 1.363115, -0.545719, 1.909311>
    }
    triangle {
      < 1.408886, -0.482542, 1.924897>,
      < 1.425874, -0.497796, 1.924903>,
      < 1.377887, -0.541115, 1.943052>
    }
    triangle {
      < 1.408886, -0.482542, 1.924897>,
      < 1.377887, -0.541115, 1.943052>,
      < 1.370954, -0.534889, 1.943049>
    }
    triangle {
      < 1.408890, -0.482542, 1.911922>,
      < 1.425877, -0.497796, 1.911928>,
      < 1.425874, -0.497796, 1.924903>
    }
    triangle {
      < 1.408890, -0.482542, 1.911922>,
      < 1.425874, -0.497796, 1.924903>,
      < 1.408886, -0.482542, 1.924897>
    }
    triangle {
      < 1.420661, -0.466297, 1.911926>,
      < 1.440767, -0.484352, 1.911932>,
      < 1.425877, -0.497796, 1.911928>
    }
    triangle {
      < 1.420661, -0.466297, 1.911926>,
      < 1.425877, -0.497796, 1.911928>,
      < 1.408890, -0.482542, 1.911922>
    }
    triangle {
      < 1.425900, -0.459076, 1.883382>,
      < 1.447393, -0.478377, 1.883389>,
      < 1.440767, -0.484352, 1.911932>
    }
    triangle {
      < 1.425900, -0.459076, 1.883382>,
      < 1.440767, -0.484352, 1.911932>,
      < 1.420661, -0.466297, 1.911926>
    }
    triangle {
      < 1.462524, -0.408534, 1.870419>,
      < 1.493722, -0.436552, 1.870430>,
      < 1.447393, -0.478377, 1.883389>
    }
    triangle {
      < 1.462524, -0.408534, 1.870419>,
      < 1.447393, -0.478377, 1.883389>,
      < 1.425900, -0.459076, 1.883382>
    }
    triangle {
      < 1.483446, -0.379652, 1.885996>,
      < 1.520191, -0.412651, 1.886010>,
      < 1.493722, -0.436552, 1.870430>
    }
    triangle {
      < 1.483446, -0.379652, 1.885996>,
      < 1.493722, -0.436552, 1.870430>,
      < 1.462524, -0.408534, 1.870419>
    }
    triangle {
      < 1.499131, -0.357993, 1.919738>,
      < 1.540037, -0.394726, 1.919753>,
      < 1.520191, -0.412651, 1.886010>
    }
    triangle {
      < 1.499131, -0.357993, 1.919738>,
      < 1.520191, -0.412651, 1.886010>,
      < 1.483446, -0.379652, 1.885996>
    }
    triangle {
      < 1.501741, -0.354382, 1.943095>,
      < 1.543340, -0.391738, 1.943110>,
      < 1.540037, -0.394726, 1.919753>
    }
    triangle {
      < 1.501741, -0.354382, 1.943095>,
      < 1.540037, -0.394726, 1.919753>,
      < 1.499131, -0.357993, 1.919738>
    }
    triangle {
      < 1.501734, -0.354382, 1.967101>,
      < 1.543334, -0.391738, 1.967114>,
      < 1.543340, -0.391738, 1.943110>
    }
    triangle {
      < 1.501734, -0.354382, 1.967101>,
      < 1.543340, -0.391738, 1.943110>,
      < 1.501741, -0.354382, 1.943095>
    }
    triangle {
      < 1.367968, -0.550079, 1.909312>,
      < 1.371810, -0.555350, 1.909314>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.377887, -0.541115, 1.943052>,
      < 1.383374, -0.548646, 1.943054>,
      < 1.371810, -0.555350, 1.909314>
    }
    triangle {
      < 1.377887, -0.541115, 1.943052>,
      < 1.371810, -0.555350, 1.909314>,
      < 1.367968, -0.550079, 1.909312>
    }
    triangle {
      < 1.425874, -0.497796, 1.924903>,
      < 1.439317, -0.516248, 1.924908>,
      < 1.383374, -0.548646, 1.943054>
    }
    triangle {
      < 1.425874, -0.497796, 1.924903>,
      < 1.383374, -0.548646, 1.943054>,
      < 1.377887, -0.541115, 1.943052>
    }
    triangle {
      < 1.425877, -0.497796, 1.911928>,
      < 1.439321, -0.516247, 1.911932>,
      < 1.439317, -0.516248, 1.924908>
    }
    triangle {
      < 1.425877, -0.497796, 1.911928>,
      < 1.439317, -0.516248, 1.924908>,
      < 1.425874, -0.497796, 1.924903>
    }
    triangle {
      < 1.440767, -0.484352, 1.911932>,
      < 1.456681, -0.506193, 1.911938>,
      < 1.439321, -0.516247, 1.911932>
    }
    triangle {
      < 1.440767, -0.484352, 1.911932>,
      < 1.439321, -0.516247, 1.911932>,
      < 1.425877, -0.497796, 1.911928>
    }
    triangle {
      < 1.447393, -0.478377, 1.883389>,
      < 1.464404, -0.501724, 1.883394>,
      < 1.456681, -0.506193, 1.911938>
    }
    triangle {
      < 1.447393, -0.478377, 1.883389>,
      < 1.456681, -0.506193, 1.911938>,
      < 1.440767, -0.484352, 1.911932>
    }
    triangle {
      < 1.493722, -0.436552, 1.870430>,
      < 1.518417, -0.470441, 1.870438>,
      < 1.464404, -0.501724, 1.883394>
    }
    triangle {
      < 1.493722, -0.436552, 1.870430>,
      < 1.464404, -0.501724, 1.883394>,
      < 1.447393, -0.478377, 1.883389>
    }
    triangle {
      < 1.520191, -0.412651, 1.886010>,
      < 1.549274, -0.452566, 1.886020>,
      < 1.518417, -0.470441, 1.870438>
    }
    triangle {
      < 1.520191, -0.412651, 1.886010>,
      < 1.518417, -0.470441, 1.870438>,
      < 1.493722, -0.436552, 1.870430>
    }
    triangle {
      < 1.540037, -0.394726, 1.919753>,
      < 1.572413, -0.439159, 1.919764>,
      < 1.549274, -0.452566, 1.886020>
    }
    triangle {
      < 1.540037, -0.394726, 1.919753>,
      < 1.549274, -0.452566, 1.886020>,
      < 1.520191, -0.412651, 1.886010>
    }
    triangle {
      < 1.543340, -0.391738, 1.943110>,
      < 1.576264, -0.436925, 1.943120>,
      < 1.572413, -0.439159, 1.919764>
    }
    triangle {
      < 1.543340, -0.391738, 1.943110>,
      < 1.572413, -0.439159, 1.919764>,
      < 1.540037, -0.394726, 1.919753>
    }
    triangle {
      < 1.543334, -0.391738, 1.967114>,
      < 1.576259, -0.436925, 1.967126>,
      < 1.576264, -0.436925, 1.943120>
    }
    triangle {
      < 1.543334, -0.391738, 1.967114>,
      < 1.576264, -0.436925, 1.943120>,
      < 1.543340, -0.391738, 1.943110>
    }
    triangle {
      < 1.371810, -0.555350, 1.909314>,
      < 1.374471, -0.561305, 1.909315>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.371810, -0.555350, 1.909314>,
      < 1.342686, -0.571682, 1.909304>,
      < 1.345271, -0.573171, 1.909304>
    }
    triangle {
      < 1.383374, -0.548646, 1.943054>,
      < 1.387177, -0.557154, 1.943055>,
      < 1.374471, -0.561305, 1.909315>
    }
    triangle {
      < 1.383374, -0.548646, 1.943054>,
      < 1.374471, -0.561305, 1.909315>,
      < 1.371810, -0.555350, 1.909314>
    }
    triangle {
      < 1.439317, -0.516248, 1.924908>,
      < 1.448633, -0.537090, 1.924911>,
      < 1.387177, -0.557154, 1.943055>
    }
    triangle {
      < 1.439317, -0.516248, 1.924908>,
      < 1.387177, -0.557154, 1.943055>,
      < 1.383374, -0.548646, 1.943054>
    }
    triangle {
      < 1.439321, -0.516247, 1.911932>,
      < 1.448636, -0.537091, 1.911935>,
      < 1.448633, -0.537090, 1.924911>
    }
    triangle {
      < 1.439321, -0.516247, 1.911932>,
      < 1.448633, -0.537090, 1.924911>,
      < 1.439317, -0.516248, 1.924908>
    }
    triangle {
      < 1.456681, -0.506193, 1.911938>,
      < 1.467706, -0.530864, 1.911942>,
      < 1.448636, -0.537091, 1.911935>
    }
    triangle {
      < 1.456681, -0.506193, 1.911938>,
      < 1.448636, -0.537091, 1.911935>,
      < 1.439321, -0.516247, 1.911932>
    }
    triangle {
      < 1.464404, -0.501724, 1.883394>,
      < 1.476190, -0.528097, 1.883399>,
      < 1.467706, -0.530864, 1.911942>
    }
    triangle {
      < 1.464404, -0.501724, 1.883394>,
      < 1.467706, -0.530864, 1.911942>,
      < 1.456681, -0.506193, 1.911938>
    }
    triangle {
      < 1.518417, -0.470441, 1.870438>,
      < 1.535526, -0.508725, 1.870444>,
      < 1.476190, -0.528097, 1.883399>
    }
    triangle {
      < 1.518417, -0.470441, 1.870438>,
      < 1.476190, -0.528097, 1.883399>,
      < 1.464404, -0.501724, 1.883394>
    }
    triangle {
      < 1.549274, -0.452566, 1.886020>,
      < 1.569426, -0.497656, 1.886026>,
      < 1.535526, -0.508725, 1.870444>
    }
    triangle {
      < 1.549274, -0.452566, 1.886020>,
      < 1.535526, -0.508725, 1.870444>,
      < 1.518417, -0.470441, 1.870438>
    }
    triangle {
      < 1.572413, -0.439159, 1.919764>,
      < 1.594845, -0.489354, 1.919771>,
      < 1.569426, -0.497656, 1.886026>
    }
    triangle {
      < 1.572413, -0.439159, 1.919764>,
      < 1.569426, -0.497656, 1.886026>,
      < 1.549274, -0.452566, 1.886020>
    }
    triangle {
      < 1.576264, -0.436925, 1.943120>,
      < 1.599077, -0.487970, 1.943128>,
      < 1.594845, -0.489354, 1.919771>
    }
    triangle {
      < 1.576264, -0.436925, 1.943120>,
      < 1.594845, -0.489354, 1.919771>,
      < 1.572413, -0.439159, 1.919764>
    }
    triangle {
      < 1.576259, -0.436925, 1.967126>,
      < 1.599070, -0.487970, 1.967134>,
      < 1.599077, -0.487970, 1.943128>
    }
    triangle {
      < 1.576259, -0.436925, 1.967126>,
      < 1.599077, -0.487970, 1.943128>,
      < 1.576264, -0.436925, 1.943120>
    }
    triangle {
      < 1.374471, -0.561305, 1.909315>,
      < 1.375836, -0.567683, 1.909315>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.387177, -0.557154, 1.943055>,
      < 1.389127, -0.566266, 1.943055>,
      < 1.375836, -0.567683, 1.909315>
    }
    triangle {
      < 1.387177, -0.557154, 1.943055>,
      < 1.375836, -0.567683, 1.909315>,
      < 1.374471, -0.561305, 1.909315>
    }
    triangle {
      < 1.448633, -0.537090, 1.924911>,
      < 1.453411, -0.559414, 1.924913>,
      < 1.389127, -0.566266, 1.943055>
    }
    triangle {
      < 1.448633, -0.537090, 1.924911>,
      < 1.389127, -0.566266, 1.943055>,
      < 1.387177, -0.557154, 1.943055>
    }
    triangle {
      < 1.448636, -0.537091, 1.911935>,
      < 1.453414, -0.559415, 1.911938>,
      < 1.453411, -0.559414, 1.924913>
    }
    triangle {
      < 1.448636, -0.537091, 1.911935>,
      < 1.453411, -0.559414, 1.924913>,
      < 1.448633, -0.537090, 1.924911>
    }
    triangle {
      < 1.467706, -0.530864, 1.911942>,
      < 1.473363, -0.557289, 1.911944>,
      < 1.453414, -0.559415, 1.911938>
    }
    triangle {
      < 1.467706, -0.530864, 1.911942>,
      < 1.453414, -0.559415, 1.911938>,
      < 1.448636, -0.537091, 1.911935>
    }
    triangle {
      < 1.476190, -0.528097, 1.883399>,
      < 1.482237, -0.556344, 1.883401>,
      < 1.473363, -0.557289, 1.911944>
    }
    triangle {
      < 1.476190, -0.528097, 1.883399>,
      < 1.473363, -0.557289, 1.911944>,
      < 1.467706, -0.530864, 1.911942>
    }
    triangle {
      < 1.535526, -0.508725, 1.870444>,
      < 1.544302, -0.549729, 1.870448>,
      < 1.482237, -0.556344, 1.883401>
    }
    triangle {
      < 1.535526, -0.508725, 1.870444>,
      < 1.482237, -0.556344, 1.883401>,
      < 1.476190, -0.528097, 1.883399>
    }
    triangle {
      < 1.569426, -0.497656, 1.886026>,
      < 1.579763, -0.545949, 1.886029>,
      < 1.544302, -0.549729, 1.870448>
    }
    triangle {
      < 1.569426, -0.497656, 1.886026>,
      < 1.544302, -0.549729, 1.870448>,
      < 1.535526, -0.508725, 1.870444>
    }
    triangle {
      < 1.594845, -0.489354, 1.919771>,
      < 1.606353, -0.543114, 1.919775>,
      < 1.579763, -0.545949, 1.886029>
    }
    triangle {
      < 1.594845, -0.489354, 1.919771>,
      < 1.579763, -0.545949, 1.886029>,
      < 1.569426, -0.497656, 1.886026>
    }
    triangle {
      < 1.599077, -0.487970, 1.943128>,
      < 1.610781, -0.542641, 1.943132>,
      < 1.606353, -0.543114, 1.919775>
    }
    triangle {
      < 1.599077, -0.487970, 1.943128>,
      < 1.606353, -0.543114, 1.919775>,
      < 1.594845, -0.489354, 1.919771>
    }
    triangle {
      < 1.599070, -0.487970, 1.967134>,
      < 1.610774, -0.542642, 1.967138>,
      < 1.610781, -0.542641, 1.943132>
    }
    triangle {
      < 1.599070, -0.487970, 1.967134>,
      < 1.610781, -0.542641, 1.943132>,
      < 1.599077, -0.487970, 1.943128>
    }
    triangle {
      < 1.375836, -0.567683, 1.909315>,
      < 1.375846, -0.574207, 1.909315>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.389127, -0.566266, 1.943055>,
      < 1.389141, -0.575585, 1.943056>,
      < 1.375846, -0.574207, 1.909315>
    }
    triangle {
      < 1.389127, -0.566266, 1.943055>,
      < 1.375846, -0.574207, 1.909315>,
      < 1.375836, -0.567683, 1.909315>
    }
    triangle {
      < 1.453411, -0.559414, 1.924913>,
      < 1.453445, -0.582245, 1.924912>,
      < 1.389141, -0.575585, 1.943056>
    }
    triangle {
      < 1.453411, -0.559414, 1.924913>,
      < 1.389141, -0.575585, 1.943056>,
      < 1.389127, -0.566266, 1.943055>
    }
    triangle {
      < 1.453414, -0.559415, 1.911938>,
      < 1.453448, -0.582245, 1.911937>,
      < 1.453445, -0.582245, 1.924912>
    }
    triangle {
      < 1.453414, -0.559415, 1.911938>,
      < 1.453445, -0.582245, 1.924912>,
      < 1.453411, -0.559414, 1.924913>
    }
    triangle {
      < 1.473363, -0.557289, 1.911944>,
      < 1.473403, -0.584312, 1.911944>,
      < 1.453448, -0.582245, 1.911937>
    }
    triangle {
      < 1.473363, -0.557289, 1.911944>,
      < 1.453448, -0.582245, 1.911937>,
      < 1.453414, -0.559415, 1.911938>
    }
    triangle {
      < 1.482237, -0.556344, 1.883401>,
      < 1.482279, -0.585231, 1.883401>,
      < 1.473403, -0.584312, 1.911944>
    }
    triangle {
      < 1.482237, -0.556344, 1.883401>,
      < 1.473403, -0.584312, 1.911944>,
      < 1.473363, -0.557289, 1.911944>
    }
    triangle {
      < 1.544302, -0.549729, 1.870448>,
      < 1.544365, -0.591661, 1.870447>,
      < 1.482279, -0.585231, 1.883401>
    }
    triangle {
      < 1.544302, -0.549729, 1.870448>,
      < 1.482279, -0.585231, 1.883401>,
      < 1.482237, -0.556344, 1.883401>
    }
    triangle {
      < 1.579763, -0.545949, 1.886029>,
      < 1.579837, -0.595336, 1.886030>,
      < 1.544365, -0.591661, 1.870447>
    }
    triangle {
      < 1.579763, -0.545949, 1.886029>,
      < 1.544365, -0.591661, 1.870447>,
      < 1.544302, -0.549729, 1.870448>
    }
    triangle {
      < 1.606353, -0.543114, 1.919775>,
      < 1.606434, -0.598092, 1.919775>,
      < 1.579837, -0.595336, 1.886030>
    }
    triangle {
      < 1.606353, -0.543114, 1.919775>,
      < 1.579837, -0.595336, 1.886030>,
      < 1.579763, -0.545949, 1.886029>
    }
    triangle {
      < 1.610781, -0.542641, 1.943132>,
      < 1.610863, -0.598552, 1.943132>,
      < 1.606434, -0.598092, 1.919775>
    }
    triangle {
      < 1.610781, -0.542641, 1.943132>,
      < 1.606434, -0.598092, 1.919775>,
      < 1.606353, -0.543114, 1.919775>
    }
    triangle {
      < 1.610774, -0.542642, 1.967138>,
      < 1.610857, -0.598552, 1.967138>,
      < 1.610863, -0.598552, 1.943132>
    }
    triangle {
      < 1.610774, -0.542642, 1.967138>,
      < 1.610863, -0.598552, 1.943132>,
      < 1.610781, -0.542641, 1.943132>
    }
    triangle {
      < 1.375846, -0.574207, 1.909315>,
      < 1.374500, -0.580589, 1.909314>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.389141, -0.575585, 1.943056>,
      < 1.387218, -0.584702, 1.943056>,
      < 1.374500, -0.580589, 1.909314>
    }
    triangle {
      < 1.389141, -0.575585, 1.943056>,
      < 1.374500, -0.580589, 1.909314>,
      < 1.375846, -0.574207, 1.909315>
    }
    triangle {
      < 1.453445, -0.582245, 1.924912>,
      < 1.448733, -0.604583, 1.924911>,
      < 1.387218, -0.584702, 1.943056>
    }
    triangle {
      < 1.453445, -0.582245, 1.924912>,
      < 1.387218, -0.584702, 1.943056>,
      < 1.389141, -0.575585, 1.943056>
    }
    triangle {
      < 1.453448, -0.582245, 1.911937>,
      < 1.448736, -0.604583, 1.911935>,
      < 1.448733, -0.604583, 1.924911>
    }
    triangle {
      < 1.453448, -0.582245, 1.911937>,
      < 1.448733, -0.604583, 1.924911>,
      < 1.453445, -0.582245, 1.924912>
    }
    triangle {
      < 1.473403, -0.584312, 1.911944>,
      < 1.467825, -0.610753, 1.911942>,
      < 1.448736, -0.604583, 1.911935>
    }
    triangle {
      < 1.473403, -0.584312, 1.911944>,
      < 1.448736, -0.604583, 1.911935>,
      < 1.453448, -0.582245, 1.911937>
    }
    triangle {
      < 1.482279, -0.585231, 1.883401>,
      < 1.476316, -0.613496, 1.883399>,
      < 1.467825, -0.610753, 1.911942>
    }
    triangle {
      < 1.482279, -0.585231, 1.883401>,
      < 1.467825, -0.610753, 1.911942>,
      < 1.473403, -0.584312, 1.911944>
    }
    triangle {
      < 1.544365, -0.591661, 1.870447>,
      < 1.535710, -0.632691, 1.870444>,
      < 1.476316, -0.613496, 1.883399>
    }
    triangle {
      < 1.544365, -0.591661, 1.870447>,
      < 1.476316, -0.613496, 1.883399>,
      < 1.482279, -0.585231, 1.883401>
    }
    triangle {
      < 1.579837, -0.595336, 1.886030>,
      < 1.569642, -0.643660, 1.886026>,
      < 1.535710, -0.632691, 1.870444>
    }
    triangle {
      < 1.579837, -0.595336, 1.886030>,
      < 1.535710, -0.632691, 1.870444>,
      < 1.544365, -0.591661, 1.870447>
    }
    triangle {
      < 1.606434, -0.598092, 1.919775>,
      < 1.595086, -0.651887, 1.919772>,
      < 1.569642, -0.643660, 1.886026>
    }
    triangle {
      < 1.606434, -0.598092, 1.919775>,
      < 1.569642, -0.643660, 1.886026>,
      < 1.579837, -0.595336, 1.886030>
    }
    triangle {
      < 1.610863, -0.598552, 1.943132>,
      < 1.599322, -0.653257, 1.943128>,
      < 1.595086, -0.651887, 1.919772>
    }
    triangle {
      < 1.610863, -0.598552, 1.943132>,
      < 1.595086, -0.651887, 1.919772>,
      < 1.606434, -0.598092, 1.919775>
    }
    triangle {
      < 1.610857, -0.598552, 1.967138>,
      < 1.599316, -0.653257, 1.967134>,
      < 1.599322, -0.653257, 1.943128>
    }
    triangle {
      < 1.610857, -0.598552, 1.967138>,
      < 1.599322, -0.653257, 1.943128>,
      < 1.610863, -0.598552, 1.943132>
    }
    triangle {
      < 1.374500, -0.580589, 1.909314>,
      < 1.371856, -0.586551, 1.909313>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.387218, -0.584702, 1.943056>,
      < 1.383440, -0.593221, 1.943054>,
      < 1.371856, -0.586551, 1.909313>
    }
    triangle {
      < 1.387218, -0.584702, 1.943056>,
      < 1.371856, -0.586551, 1.909313>,
      < 1.374500, -0.580589, 1.909314>
    }
    triangle {
      < 1.448733, -0.604583, 1.924911>,
      < 1.439479, -0.625454, 1.924908>,
      < 1.383440, -0.593221, 1.943054>
    }
    triangle {
      < 1.448733, -0.604583, 1.924911>,
      < 1.383440, -0.593221, 1.943054>,
      < 1.387218, -0.584702, 1.943056>
    }
    triangle {
      < 1.448736, -0.604583, 1.911935>,
      < 1.439482, -0.625454, 1.911932>,
      < 1.439479, -0.625454, 1.924908>
    }
    triangle {
      < 1.448736, -0.604583, 1.911935>,
      < 1.439479, -0.625454, 1.924908>,
      < 1.448733, -0.604583, 1.924911>
    }
    triangle {
      < 1.467825, -0.610753, 1.911942>,
      < 1.456873, -0.635457, 1.911938>,
      < 1.439482, -0.625454, 1.911932>
    }
    triangle {
      < 1.467825, -0.610753, 1.911942>,
      < 1.439482, -0.625454, 1.911932>,
      < 1.448736, -0.604583, 1.911935>
    }
    triangle {
      < 1.476316, -0.613496, 1.883399>,
      < 1.464608, -0.639903, 1.883395>,
      < 1.456873, -0.635457, 1.911938>
    }
    triangle {
      < 1.476316, -0.613496, 1.883399>,
      < 1.456873, -0.635457, 1.911938>,
      < 1.467825, -0.610753, 1.911942>
    }
    triangle {
      < 1.535710, -0.632691, 1.870444>,
      < 1.518714, -0.671025, 1.870438>,
      < 1.464608, -0.639903, 1.883395>
    }
    triangle {
      < 1.535710, -0.632691, 1.870444>,
      < 1.464608, -0.639903, 1.883395>,
      < 1.476316, -0.613496, 1.883399>
    }
    triangle {
      < 1.569642, -0.643660, 1.886026>,
      < 1.549625, -0.688808, 1.886020>,
      < 1.518714, -0.671025, 1.870438>
    }
    triangle {
      < 1.569642, -0.643660, 1.886026>,
      < 1.518714, -0.671025, 1.870438>,
      < 1.535710, -0.632691, 1.870444>
    }
    triangle {
      < 1.595086, -0.651887, 1.919772>,
      < 1.572802, -0.702146, 1.919763>,
      < 1.549625, -0.688808, 1.886020>
    }
    triangle {
      < 1.595086, -0.651887, 1.919772>,
      < 1.549625, -0.688808, 1.886020>,
      < 1.569642, -0.643660, 1.886026>
    }
    triangle {
      < 1.599322, -0.653257, 1.943128>,
      < 1.576661, -0.704369, 1.943121>,
      < 1.572802, -0.702146, 1.919763>
    }
    triangle {
      < 1.599322, -0.653257, 1.943128>,
      < 1.572802, -0.702146, 1.919763>,
      < 1.595086, -0.651887, 1.919772>
    }
    triangle {
      < 1.599316, -0.653257, 1.967134>,
      < 1.576655, -0.704369, 1.967126>,
      < 1.576661, -0.704369, 1.943121>
    }
    triangle {
      < 1.599316, -0.653257, 1.967134>,
      < 1.576661, -0.704369, 1.943121>,
      < 1.599322, -0.653257, 1.943128>
    }
    triangle {
      < 1.371856, -0.586551, 1.909313>,
      < 1.368030, -0.591835, 1.909312>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.383440, -0.593221, 1.943054>,
      < 1.377975, -0.600768, 1.943053>,
      < 1.368030, -0.591835, 1.909312>
    }
    triangle {
      < 1.383440, -0.593221, 1.943054>,
      < 1.368030, -0.591835, 1.909312>,
      < 1.371856, -0.586551, 1.909313>
    }
    triangle {
      < 1.439479, -0.625454, 1.924908>,
      < 1.426090, -0.643946, 1.924903>,
      < 1.377975, -0.600768, 1.943053>
    }
    triangle {
      < 1.439479, -0.625454, 1.924908>,
      < 1.377975, -0.600768, 1.943053>,
      < 1.383440, -0.593221, 1.943054>
    }
    triangle {
      < 1.439482, -0.625454, 1.911932>,
      < 1.426093, -0.643946, 1.911927>,
      < 1.426090, -0.643946, 1.924903>
    }
    triangle {
      < 1.439482, -0.625454, 1.911932>,
      < 1.426090, -0.643946, 1.924903>,
      < 1.439479, -0.625454, 1.924908>
    }
    triangle {
      < 1.456873, -0.635457, 1.911938>,
      < 1.441023, -0.657345, 1.911932>,
      < 1.426093, -0.643946, 1.911927>
    }
    triangle {
      < 1.456873, -0.635457, 1.911938>,
      < 1.426093, -0.643946, 1.911927>,
      < 1.439482, -0.625454, 1.911932>
    }
    triangle {
      < 1.464608, -0.639903, 1.883395>,
      < 1.447666, -0.663300, 1.883389>,
      < 1.441023, -0.657345, 1.911932>
    }
    triangle {
      < 1.464608, -0.639903, 1.883395>,
      < 1.441023, -0.657345, 1.911932>,
      < 1.456873, -0.635457, 1.911938>
    }
    triangle {
      < 1.518714, -0.671025, 1.870438>,
      < 1.494120, -0.704988, 1.870430>,
      < 1.447666, -0.663300, 1.883389>
    }
    triangle {
      < 1.518714, -0.671025, 1.870438>,
      < 1.447666, -0.663300, 1.883389>,
      < 1.464608, -0.639903, 1.883395>
    }
    triangle {
      < 1.549625, -0.688808, 1.886020>,
      < 1.520659, -0.728811, 1.886010>,
      < 1.494120, -0.704988, 1.870430>
    }
    triangle {
      < 1.549625, -0.688808, 1.886020>,
      < 1.494120, -0.704988, 1.870430>,
      < 1.518714, -0.671025, 1.870438>
    }
    triangle {
      < 1.572802, -0.702146, 1.919763>,
      < 1.540558, -0.746677, 1.919752>,
      < 1.520659, -0.728811, 1.886010>
    }
    triangle {
      < 1.572802, -0.702146, 1.919763>,
      < 1.520659, -0.728811, 1.886010>,
      < 1.549625, -0.688808, 1.886020>
    }
    triangle {
      < 1.576661, -0.704369, 1.943121>,
      < 1.543870, -0.749654, 1.943109>,
      < 1.540558, -0.746677, 1.919752>
    }
    triangle {
      < 1.576661, -0.704369, 1.943121>,
      < 1.540558, -0.746677, 1.919752>,
      < 1.572802, -0.702146, 1.919763>
    }
    triangle {
      < 1.576655, -0.704369, 1.967126>,
      < 1.543864, -0.749654, 1.967115>,
      < 1.543870, -0.749654, 1.943109>
    }
    triangle {
      < 1.576655, -0.704369, 1.967126>,
      < 1.543870, -0.749654, 1.943109>,
      < 1.576661, -0.704369, 1.943121>
    }
    triangle {
      < 1.368030, -0.591835, 1.909312>,
      < 1.363190, -0.596207, 1.909311>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.377975, -0.600768, 1.943053>,
      < 1.371062, -0.607015, 1.943050>,
      < 1.363190, -0.596207, 1.909311>
    }
    triangle {
      < 1.377975, -0.600768, 1.943053>,
      < 1.363190, -0.596207, 1.909311>,
      < 1.368030, -0.591835, 1.909312>
    }
    triangle {
      < 1.426090, -0.643946, 1.924903>,
      < 1.409149, -0.659249, 1.924898>,
      < 1.371062, -0.607015, 1.943050>
    }
    triangle {
      < 1.426090, -0.643946, 1.924903>,
      < 1.371062, -0.607015, 1.943050>,
      < 1.377975, -0.600768, 1.943053>
    }
    triangle {
      < 1.426093, -0.643946, 1.911927>,
      < 1.409152, -0.659249, 1.911922>,
      < 1.409149, -0.659249, 1.924898>
    }
    triangle {
      < 1.426093, -0.643946, 1.911927>,
      < 1.409149, -0.659249, 1.924898>,
      < 1.426090, -0.643946, 1.924903>
    }
    triangle {
      < 1.441023, -0.657345, 1.911932>,
      < 1.420970, -0.675459, 1.911926>,
      < 1.409152, -0.659249, 1.911922>
    }
    triangle {
      < 1.441023, -0.657345, 1.911932>,
      < 1.409152, -0.659249, 1.911922>,
      < 1.426093, -0.643946, 1.911927>
    }
    triangle {
      < 1.447666, -0.663300, 1.883389>,
      < 1.426231, -0.682665, 1.883382>,
      < 1.420970, -0.675459, 1.911926>
    }
    triangle {
      < 1.447666, -0.663300, 1.883389>,
      < 1.420970, -0.675459, 1.911926>,
      < 1.441023, -0.657345, 1.911932>
    }
    triangle {
      < 1.494120, -0.704988, 1.870430>,
      < 1.463005, -0.733097, 1.870419>,
      < 1.426231, -0.682665, 1.883382>
    }
    triangle {
      < 1.494120, -0.704988, 1.870430>,
      < 1.426231, -0.682665, 1.883382>,
      < 1.447666, -0.663300, 1.883389>
    }
    triangle {
      < 1.520659, -0.728811, 1.886010>,
      < 1.484011, -0.761917, 1.885997>,
      < 1.463005, -0.733097, 1.870419>
    }
    triangle {
      < 1.520659, -0.728811, 1.886010>,
      < 1.463005, -0.733097, 1.870419>,
      < 1.494120, -0.704988, 1.870430>
    }
    triangle {
      < 1.540558, -0.746677, 1.919752>,
      < 1.499762, -0.783531, 1.919738>,
      < 1.484011, -0.761917, 1.885997>
    }
    triangle {
      < 1.540558, -0.746677, 1.919752>,
      < 1.484011, -0.761917, 1.885997>,
      < 1.520659, -0.728811, 1.886010>
    }
    triangle {
      < 1.543870, -0.749654, 1.943109>,
      < 1.502382, -0.787133, 1.943095>,
      < 1.499762, -0.783531, 1.919738>
    }
    triangle {
      < 1.543870, -0.749654, 1.943109>,
      < 1.499762, -0.783531, 1.919738>,
      < 1.540558, -0.746677, 1.919752>
    }
    triangle {
      < 1.543864, -0.749654, 1.967115>,
      < 1.502376, -0.787133, 1.967100>,
      < 1.502382, -0.787133, 1.943095>
    }
    triangle {
      < 1.543864, -0.749654, 1.967115>,
      < 1.502382, -0.787133, 1.943095>,
      < 1.543870, -0.749654, 1.943109>
    }
    triangle {
      < 1.363190, -0.596207, 1.909311>,
      < 1.357546, -0.599479, 1.909309>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.363190, -0.596207, 1.909311>,
      < 1.344804, -0.568762, 1.909304>,
      < 1.342686, -0.571682, 1.909304>
    }
    triangle {
      < 1.371062, -0.607015, 1.943050>,
      < 1.362999, -0.611687, 1.943047>,
      < 1.357546, -0.599479, 1.909309>
    }
    triangle {
      < 1.371062, -0.607015, 1.943050>,
      < 1.357546, -0.599479, 1.909309>,
      < 1.363190, -0.596207, 1.909311>
    }
    triangle {
      < 1.409149, -0.659249, 1.924898>,
      < 1.389397, -0.670698, 1.924890>,
      < 1.362999, -0.611687, 1.943047>
    }
    triangle {
      < 1.409149, -0.659249, 1.924898>,
      < 1.362999, -0.611687, 1.943047>,
      < 1.371062, -0.607015, 1.943050>
    }
    triangle {
      < 1.409152, -0.659249, 1.911922>,
      < 1.389400, -0.670698, 1.911915>,
      < 1.389397, -0.670698, 1.924890>
    }
    triangle {
      < 1.409152, -0.659249, 1.911922>,
      < 1.389397, -0.670698, 1.924890>,
      < 1.409149, -0.659249, 1.924898>
    }
    triangle {
      < 1.420970, -0.675459, 1.911926>,
      < 1.397591, -0.689011, 1.911917>,
      < 1.389400, -0.670698, 1.911915>
    }
    triangle {
      < 1.420970, -0.675459, 1.911926>,
      < 1.389400, -0.670698, 1.911915>,
      < 1.409152, -0.659249, 1.911922>
    }
    triangle {
      < 1.426231, -0.682665, 1.883382>,
      < 1.401238, -0.697150, 1.883373>,
      < 1.397591, -0.689011, 1.911917>
    }
    triangle {
      < 1.426231, -0.682665, 1.883382>,
      < 1.397591, -0.689011, 1.911917>,
      < 1.420970, -0.675459, 1.911926>
    }
    triangle {
      < 1.463005, -0.733097, 1.870419>,
      < 1.426725, -0.754125, 1.870406>,
      < 1.401238, -0.697150, 1.883373>
    }
    triangle {
      < 1.463005, -0.733097, 1.870419>,
      < 1.401238, -0.697150, 1.883373>,
      < 1.426231, -0.682665, 1.883382>
    }
    triangle {
      < 1.484011, -0.761917, 1.885997>,
      < 1.441283, -0.786682, 1.885982>,
      < 1.426725, -0.754125, 1.870406>
    }
    triangle {
      < 1.484011, -0.761917, 1.885997>,
      < 1.426725, -0.754125, 1.870406>,
      < 1.463005, -0.733097, 1.870419>
    }
    triangle {
      < 1.499762, -0.783531, 1.919738>,
      < 1.452195, -0.811100, 1.919722>,
      < 1.441283, -0.786682, 1.885982>
    }
    triangle {
      < 1.499762, -0.783531, 1.919738>,
      < 1.441283, -0.786682, 1.885982>,
      < 1.484011, -0.761917, 1.885997>
    }
    triangle {
      < 1.502382, -0.787133, 1.943095>,
      < 1.454010, -0.815170, 1.943079>,
      < 1.452195, -0.811100, 1.919722>
    }
    triangle {
      < 1.502382, -0.787133, 1.943095>,
      < 1.452195, -0.811100, 1.919722>,
      < 1.499762, -0.783531, 1.919738>
    }
    triangle {
      < 1.502376, -0.787133, 1.967100>,
      < 1.454004, -0.815170, 1.967084>,
      < 1.454010, -0.815170, 1.943079>
    }
    triangle {
      < 1.502376, -0.787133, 1.967100>,
      < 1.454010, -0.815170, 1.943079>,
      < 1.502382, -0.787133, 1.943095>
    }
    triangle {
      < 1.357546, -0.599479, 1.909309>,
      < 1.351346, -0.601505, 1.909307>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.362999, -0.611687, 1.943047>,
      < 1.354142, -0.614582, 1.943044>,
      < 1.351346, -0.601505, 1.909307>
    }
    triangle {
      < 1.362999, -0.611687, 1.943047>,
      < 1.351346, -0.601505, 1.909307>,
      < 1.357546, -0.599479, 1.909309>
    }
    triangle {
      < 1.389397, -0.670698, 1.924890>,
      < 1.367696, -0.677790, 1.924883>,
      < 1.354142, -0.614582, 1.943044>
    }
    triangle {
      < 1.389397, -0.670698, 1.924890>,
      < 1.354142, -0.614582, 1.943044>,
      < 1.362999, -0.611687, 1.943047>
    }
    triangle {
      < 1.389400, -0.670698, 1.911915>,
      < 1.367699, -0.677790, 1.911907>,
      < 1.367696, -0.677790, 1.924883>
    }
    triangle {
      < 1.389400, -0.670698, 1.911915>,
      < 1.367696, -0.677790, 1.924883>,
      < 1.389397, -0.670698, 1.924890>
    }
    triangle {
      < 1.397591, -0.689011, 1.911917>,
      < 1.371904, -0.697406, 1.911909>,
      < 1.367699, -0.677790, 1.911907>
    }
    triangle {
      < 1.397591, -0.689011, 1.911917>,
      < 1.367699, -0.677790, 1.911907>,
      < 1.389400, -0.670698, 1.911915>
    }
    triangle {
      < 1.401238, -0.697150, 1.883373>,
      < 1.373781, -0.706124, 1.883364>,
      < 1.371904, -0.697406, 1.911909>
    }
    triangle {
      < 1.401238, -0.697150, 1.883373>,
      < 1.371904, -0.697406, 1.911909>,
      < 1.397591, -0.689011, 1.911917>
    }
    triangle {
      < 1.426725, -0.754125, 1.870406>,
      < 1.386866, -0.767152, 1.870393>,
      < 1.373781, -0.706124, 1.883364>
    }
    triangle {
      < 1.426725, -0.754125, 1.870406>,
      < 1.373781, -0.706124, 1.883364>,
      < 1.401238, -0.697150, 1.883373>
    }
    triangle {
      < 1.441283, -0.786682, 1.885982>,
      < 1.394339, -0.802024, 1.885966>,
      < 1.386866, -0.767152, 1.870393>
    }
    triangle {
      < 1.441283, -0.786682, 1.885982>,
      < 1.386866, -0.767152, 1.870393>,
      < 1.426725, -0.754125, 1.870406>
    }
    triangle {
      < 1.452195, -0.811100, 1.919722>,
      < 1.399937, -0.828179, 1.919703>,
      < 1.394339, -0.802024, 1.885966>
    }
    triangle {
      < 1.452195, -0.811100, 1.919722>,
      < 1.394339, -0.802024, 1.885966>,
      < 1.441283, -0.786682, 1.885982>
    }
    triangle {
      < 1.454010, -0.815170, 1.943079>,
      < 1.400866, -0.832538, 1.943060>,
      < 1.399937, -0.828179, 1.919703>
    }
    triangle {
      < 1.454010, -0.815170, 1.943079>,
      < 1.399937, -0.828179, 1.919703>,
      < 1.452195, -0.811100, 1.919722>
    }
    triangle {
      < 1.454004, -0.815170, 1.967084>,
      < 1.400860, -0.832538, 1.967065>,
      < 1.400866, -0.832538, 1.943060>
    }
    triangle {
      < 1.454004, -0.815170, 1.967084>,
      < 1.400866, -0.832538, 1.943060>,
      < 1.454010, -0.815170, 1.943079>
    }
    triangle {
      < 1.351346, -0.601505, 1.909307>,
      < 1.344824, -0.602198, 1.909305>,
      < 1.344804, -0.568762, 1.909304>
    }
    triangle {
      < 1.354142, -0.614582, 1.943044>,
      < 1.344823, -0.615573, 1.943041>,
      < 1.344824, -0.602198, 1.909305>
    }
    triangle {
      < 1.354142, -0.614582, 1.943044>,
      < 1.344824, -0.602198, 1.909305>,
      < 1.351346, -0.601505, 1.909307>
    }
    triangle {
      < 1.367696, -0.677790, 1.924883>,
      < 1.344866, -0.680216, 1.924875>,
      < 1.344823, -0.615573, 1.943041>
    }
    triangle {
      < 1.367696, -0.677790, 1.924883>,
      < 1.344823, -0.615573, 1.943041>,
      < 1.354142, -0.614582, 1.943044>
    }
    triangle {
      < 1.367699, -0.677790, 1.911907>,
      < 1.344870, -0.680216, 1.911899>,
      < 1.344866, -0.680216, 1.924875>
    }
    triangle {
      < 1.367699, -0.677790, 1.911907>,
      < 1.344866, -0.680216, 1.924875>,
      < 1.367696, -0.677790, 1.924883>
    }
    triangle {
      < 1.371904, -0.697406, 1.911909>,
      < 1.344882, -0.700278, 1.911900>,
      < 1.344870, -0.680216, 1.911899>
    }
    triangle {
      < 1.371904, -0.697406, 1.911909>,
      < 1.344870, -0.680216, 1.911899>,
      < 1.367699, -0.677790, 1.911907>
    }
    triangle {
      < 1.373781, -0.706124, 1.883364>,
      < 1.344894, -0.709194, 1.883354>,
      < 1.344882, -0.700278, 1.911900>
    }
    triangle {
      < 1.373781, -0.706124, 1.883364>,
      < 1.344882, -0.700278, 1.911900>,
      < 1.371904, -0.697406, 1.911909>
    }
    triangle {
      < 1.386866, -0.767152, 1.870393>,
      < 1.344934, -0.771609, 1.870378>,
      < 1.344894, -0.709194, 1.883354>
    }
    triangle {
      < 1.386866, -0.767152, 1.870393>,
      < 1.344894, -0.709194, 1.883354>,
      < 1.373781, -0.706124, 1.883364>
    }
    triangle {
      < 1.394339, -0.802024, 1.885966>,
      < 1.344951, -0.807274, 1.885949>,
      < 1.344934, -0.771609, 1.870378>
    }
    triangle {
      < 1.394339, -0.802024, 1.885966>,
      < 1.344934, -0.771609, 1.870378>,
      < 1.386866, -0.767152, 1.870393>
    }
    triangle {
      < 1.399937, -0.828179, 1.919703>,
      < 1.344958, -0.834023, 1.919685>,
      < 1.344951, -0.807274, 1.885949>
    }
    triangle {
      < 1.399937, -0.828179, 1.919703>,
      < 1.344951, -0.807274, 1.885949>,
      < 1.394339, -0.802024, 1.885966>
    }
    triangle {
      < 1.400866, -0.832538, 1.943060>,
      < 1.344955, -0.838481, 1.943040>,
      < 1.344958, -0.834023, 1.919685>
    }
    triangle {
      < 1.400866, -0.832538, 1.943060>,
      < 1.344958, -0.834023, 1.919685>,
      < 1.399937, -0.828179, 1.919703>
    }
    triangle {
      < 1.400860, -0.832538, 1.967065>,
      < 1.344949, -0.838481, 1.967046>,
      < 1.344955, -0.838481, 1.943040>
    }
    triangle {
      < 1.400860, -0.832538, 1.967065>,
      < 1.344955, -0.838481, 1.943040>,
      < 1.400866, -0.832538, 1.943060>
    }
    texture {wheels}
  }
  // ordinance1
  union {
    triangle {
      < -0.290809, -0.712400, 3.069263>,
      < -0.254615, -0.877924, 2.908155>,
      < -0.254624, -0.864713, 2.899583>
    }
    triangle {
      < -0.290809, -0.712400, 3.069263>,
      < -0.254624, -0.864713, 2.899583>,
      < -0.290819, -0.694674, 3.051511>
    }
    triangle {
      < -0.254624, -0.864713, 2.899583>,
      < -0.254629, -0.856018, 2.886191>,
      < -0.290819, -0.694674, 3.051511>
    }
    triangle {
      < -0.446161, -0.694766, 3.051511>,
      < -0.446721, -0.856131, 2.886191>,
      < -0.446716, -0.864826, 2.899583>
    }
    triangle {
      < -0.446161, -0.694766, 3.051511>,
      < -0.446716, -0.864826, 2.899583>,
      < -0.446151, -0.712491, 3.069263>
    }
    triangle {
      < -0.446716, -0.864826, 2.899583>,
      < -0.446708, -0.878037, 2.908155>,
      < -0.446151, -0.712491, 3.069263>
    }
    triangle {
      < -0.290819, -0.694674, 3.051511>,
      < -0.254629, -0.856018, 2.886191>,
      < -0.446721, -0.856131, 2.886191>
    }
    triangle {
      < -0.290819, -0.694674, 3.051511>,
      < -0.446721, -0.856131, 2.886191>,
      < -0.446161, -0.694766, 3.051511>
    }
    triangle {
      < -0.446151, -0.712491, 3.069263>,
      < -0.446708, -0.878037, 2.908155>,
      < -0.254615, -0.877924, 2.908155>
    }
    triangle {
      < -0.446151, -0.712491, 3.069263>,
      < -0.254615, -0.877924, 2.908155>,
      < -0.290809, -0.712400, 3.069263>
    }
    triangle {
      < 0.488532, -0.843916, 2.941673>,
      < 0.521297, -0.877464, 2.908155>,
      < 0.519017, -0.864254, 2.899583>
    }
    triangle {
      < 0.488532, -0.843916, 2.941673>,
      < 0.519017, -0.864254, 2.899583>,
      < 0.488519, -0.821997, 2.919721>
    }
    triangle {
      < 0.519017, -0.864254, 2.899583>,
      < 0.521296, -0.855558, 2.886191>,
      < 0.488519, -0.821997, 2.919721>
    }
    triangle {
      < -0.217249, -0.694630, 3.051511>,
      < -0.163654, -0.855964, 2.886191>,
      < -0.163649, -0.864659, 2.899583>
    }
    triangle {
      < -0.217249, -0.694630, 3.051511>,
      < -0.163649, -0.864659, 2.899583>,
      < -0.217239, -0.712355, 3.069263>
    }
    triangle {
      < -0.163649, -0.864659, 2.899583>,
      < -0.163641, -0.877870, 2.908155>,
      < -0.217239, -0.712355, 3.069263>
    }
    triangle {
      < 0.488519, -0.821997, 2.919721>,
      < 0.521296, -0.855558, 2.886191>,
      < -0.163654, -0.855964, 2.886191>
    }
    triangle {
      < 0.488519, -0.821997, 2.919721>,
      < -0.163654, -0.855964, 2.886191>,
      < -0.217249, -0.694630, 3.051511>
    }
    triangle {
      < -0.217239, -0.712355, 3.069263>,
      < -0.163641, -0.877870, 2.908155>,
      < 0.521297, -0.877464, 2.908155>
    }
    triangle {
      < -0.217239, -0.712355, 3.069263>,
      < 0.521297, -0.877464, 2.908155>,
      < 0.488532, -0.843916, 2.941673>
    }
    triangle {
      < -0.290819, -0.694932, 2.615868>,
      < -0.254629, -0.855973, 2.781272>,
      < -0.254619, -0.871944, 2.761568>
    }
    triangle {
      < -0.290819, -0.694932, 2.615868>,
      < -0.254619, -0.871944, 2.761568>,
      < -0.290808, -0.712678, 2.598136>
    }
    triangle {
      < -0.254619, -0.871944, 2.761568>,
      < -0.254616, -0.877376, 2.758804>,
      < -0.290808, -0.712678, 2.598136>
    }
    triangle {
      < -0.446151, -0.712770, 2.598136>,
      < -0.446709, -0.877489, 2.758804>,
      < -0.446711, -0.872057, 2.761568>
    }
    triangle {
      < -0.446151, -0.712770, 2.598136>,
      < -0.446711, -0.872057, 2.761568>,
      < -0.446161, -0.695024, 2.615868>
    }
    triangle {
      < -0.446711, -0.872057, 2.761568>,
      < -0.446721, -0.856086, 2.781272>,
      < -0.446161, -0.695024, 2.615868>
    }
    triangle {
      < -0.290808, -0.712678, 2.598136>,
      < -0.254616, -0.877376, 2.758804>,
      < -0.446709, -0.877489, 2.758804>
    }
    triangle {
      < -0.290808, -0.712678, 2.598136>,
      < -0.446709, -0.877489, 2.758804>,
      < -0.446151, -0.712770, 2.598136>
    }
    triangle {
      < -0.446161, -0.695024, 2.615868>,
      < -0.446721, -0.856086, 2.781272>,
      < -0.254629, -0.855973, 2.781272>
    }
    triangle {
      < -0.446161, -0.695024, 2.615868>,
      < -0.254629, -0.855973, 2.781272>,
      < -0.290819, -0.694932, 2.615868>
    }
    triangle {
      < 0.488519, -0.822098, 2.747809>,
      < 0.521193, -0.855513, 2.781273>,
      < 0.519372, -0.871485, 2.761569>
    }
    triangle {
      < 0.488519, -0.822098, 2.747809>,
      < 0.519372, -0.871485, 2.761569>,
      < 0.488532, -0.844043, 2.725883>
    }
    triangle {
      < 0.519372, -0.871485, 2.761569>,
      < 0.520675, -0.876916, 2.758804>,
      < 0.488532, -0.844043, 2.725883>
    }
    triangle {
      < -0.217238, -0.712634, 2.598136>,
      < -0.163642, -0.877322, 2.758804>,
      < -0.163644, -0.871890, 2.761568>
    }
    triangle {
      < -0.217238, -0.712634, 2.598136>,
      < -0.163644, -0.871890, 2.761568>,
      < -0.217249, -0.694888, 2.615868>
    }
    triangle {
      < -0.163644, -0.871890, 2.761568>,
      < -0.163654, -0.855919, 2.781272>,
      < -0.217249, -0.694888, 2.615868>
    }
    triangle {
      < 0.488532, -0.844043, 2.725883>,
      < 0.520675, -0.876916, 2.758804>,
      < -0.163642, -0.877322, 2.758804>
    }
    triangle {
      < 0.488532, -0.844043, 2.725883>,
      < -0.163642, -0.877322, 2.758804>,
      < -0.217238, -0.712634, 2.598136>
    }
    triangle {
      < -0.217249, -0.694888, 2.615868>,
      < -0.163654, -0.855919, 2.781272>,
      < 0.521193, -0.855513, 2.781273>
    }
    triangle {
      < -0.217249, -0.694888, 2.615868>,
      < 0.521193, -0.855513, 2.781273>,
      < 0.488519, -0.822098, 2.747809>
    }
    triangle {
      < -0.290550, -1.148321, 2.598265>,
      < -0.254553, -0.983742, 2.758580>,
      < -0.254540, -1.005674, 2.780518>
    }
    triangle {
      < -0.290550, -1.148321, 2.598265>,
      < -0.254540, -1.005674, 2.780518>,
      < -0.290540, -1.166058, 2.616007>
    }
    triangle {
      < -0.445882, -1.166150, 2.616007>,
      < -0.446632, -1.005788, 2.780518>,
      < -0.446646, -0.983855, 2.758580>
    }
    triangle {
      < -0.445882, -1.166150, 2.616007>,
      < -0.446646, -0.983855, 2.758580>,
      < -0.445892, -1.148413, 2.598265>
    }
    triangle {
      < -0.290540, -1.166058, 2.616007>,
      < -0.254540, -1.005674, 2.780518>,
      < -0.446632, -1.005788, 2.780518>
    }
    triangle {
      < -0.290540, -1.166058, 2.616007>,
      < -0.446632, -1.005788, 2.780518>,
      < -0.445882, -1.166150, 2.616007>
    }
    triangle {
      < -0.445892, -1.148413, 2.598265>,
      < -0.446646, -0.983855, 2.758580>,
      < -0.254553, -0.983742, 2.758580>
    }
    triangle {
      < -0.445892, -1.148413, 2.598265>,
      < -0.254553, -0.983742, 2.758580>,
      < -0.290550, -1.148321, 2.598265>
    }
    triangle {
      < 0.488634, -1.015957, 2.725934>,
      < 0.520489, -0.983282, 2.758580>,
      < 0.520502, -1.005214, 2.780518>
    }
    triangle {
      < 0.488634, -1.015957, 2.725934>,
      < 0.520502, -1.005214, 2.780518>,
      < 0.488647, -1.037889, 2.747873>
    }
    triangle {
      < -0.216970, -1.166015, 2.616007>,
      < -0.163565, -1.005620, 2.780518>,
      < -0.163579, -0.983688, 2.758580>
    }
    triangle {
      < -0.216970, -1.166015, 2.616007>,
      < -0.163579, -0.983688, 2.758580>,
      < -0.216980, -1.148278, 2.598265>
    }
    triangle {
      < 0.488647, -1.037889, 2.747873>,
      < 0.520502, -1.005214, 2.780518>,
      < -0.163565, -1.005620, 2.780518>
    }
    triangle {
      < 0.488647, -1.037889, 2.747873>,
      < -0.163565, -1.005620, 2.780518>,
      < -0.216970, -1.166015, 2.616007>
    }
    triangle {
      < -0.216980, -1.148278, 2.598265>,
      < -0.163579, -0.983688, 2.758580>,
      < 0.520489, -0.983282, 2.758580>
    }
    triangle {
      < -0.216980, -1.148278, 2.598265>,
      < 0.520489, -0.983282, 2.758580>,
      < 0.488634, -1.015957, 2.725934>
    }
    triangle {
      < -0.290540, -1.166057, 3.051650>,
      < -0.254540, -1.005418, 2.886883>,
      < -0.254542, -1.002652, 2.892315>
    }
    triangle {
      < -0.290540, -1.166057, 3.051650>,
      < -0.254542, -1.002652, 2.892315>,
      < -0.290550, -1.148321, 3.069393>
    }
    triangle {
      < -0.254542, -1.002652, 2.892315>,
      < -0.254553, -0.982943, 2.908281>,
      < -0.290550, -1.148321, 3.069393>
    }
    triangle {
      < -0.445892, -1.148414, 3.069393>,
      < -0.446646, -0.983056, 2.908281>,
      < -0.446634, -1.002765, 2.892315>
    }
    triangle {
      < -0.445892, -1.148414, 3.069393>,
      < -0.446634, -1.002765, 2.892315>,
      < -0.445882, -1.166150, 3.051650>
    }
    triangle {
      < -0.446634, -1.002765, 2.892315>,
      < -0.446632, -1.005531, 2.886883>,
      < -0.445882, -1.166150, 3.051650>
    }
    triangle {
      < -0.290550, -1.148321, 3.069393>,
      < -0.254553, -0.982943, 2.908281>,
      < -0.446646, -0.983056, 2.908281>
    }
    triangle {
      < -0.290550, -1.148321, 3.069393>,
      < -0.446646, -0.983056, 2.908281>,
      < -0.445892, -1.148414, 3.069393>
    }
    triangle {
      < -0.445882, -1.166150, 3.051650>,
      < -0.446632, -1.005531, 2.886883>,
      < -0.254540, -1.005418, 2.886883>
    }
    triangle {
      < -0.445882, -1.166150, 3.051650>,
      < -0.254540, -1.005418, 2.886883>,
      < -0.290540, -1.166057, 3.051650>
    }
    triangle {
      < 0.488647, -1.037889, 2.919785>,
      < 0.520751, -1.004958, 2.886883>,
      < 0.519449, -1.002193, 2.892315>
    }
    triangle {
      < 0.488647, -1.037889, 2.919785>,
      < 0.519449, -1.002193, 2.892315>,
      < 0.488634, -1.015957, 2.941724>
    }
    triangle {
      < 0.519449, -1.002193, 2.892315>,
      < 0.521267, -0.982483, 2.908281>,
      < 0.488634, -1.015957, 2.941724>
    }
    triangle {
      < -0.216980, -1.148278, 3.069393>,
      < -0.163579, -0.982889, 2.908281>,
      < -0.163567, -1.002598, 2.892315>
    }
    triangle {
      < -0.216980, -1.148278, 3.069393>,
      < -0.163567, -1.002598, 2.892315>,
      < -0.216970, -1.166014, 3.051650>
    }
    triangle {
      < -0.163567, -1.002598, 2.892315>,
      < -0.163566, -1.005364, 2.886883>,
      < -0.216970, -1.166014, 3.051650>
    }
    triangle {
      < 0.488634, -1.015957, 2.941724>,
      < 0.521267, -0.982483, 2.908281>,
      < -0.163579, -0.982889, 2.908281>
    }
    triangle {
      < 0.488634, -1.015957, 2.941724>,
      < -0.163579, -0.982889, 2.908281>,
      < -0.216980, -1.148278, 3.069393>
    }
    triangle {
      < -0.216970, -1.166014, 3.051650>,
      < -0.163566, -1.005364, 2.886883>,
      < 0.520751, -1.004958, 2.886883>
    }
    triangle {
      < -0.216970, -1.166014, 3.051650>,
      < 0.520751, -1.004958, 2.886883>,
      < 0.488647, -1.037889, 2.919785>
    }
    triangle {
      < -0.217249, -0.694630, 3.051511>,
      < -0.217239, -0.712355, 3.069263>,
      < 0.488532, -0.843916, 2.941673>
    }
    triangle {
      < -0.217249, -0.694630, 3.051511>,
      < 0.488532, -0.843916, 2.941673>,
      < 0.488519, -0.821997, 2.919721>
    }
    triangle {
      < -0.446161, -0.694766, 3.051511>,
      < -0.446151, -0.712491, 3.069263>,
      < -0.290809, -0.712400, 3.069263>
    }
    triangle {
      < -0.446161, -0.694766, 3.051511>,
      < -0.290809, -0.712400, 3.069263>,
      < -0.290819, -0.694674, 3.051511>
    }
    triangle {
      < -0.216980, -1.148278, 3.069393>,
      < -0.216970, -1.166014, 3.051650>,
      < 0.488647, -1.037889, 2.919785>
    }
    triangle {
      < -0.216980, -1.148278, 3.069393>,
      < 0.488647, -1.037889, 2.919785>,
      < 0.488634, -1.015957, 2.941724>
    }
    triangle {
      < -0.445892, -1.148414, 3.069393>,
      < -0.445882, -1.166150, 3.051650>,
      < -0.290540, -1.166057, 3.051650>
    }
    triangle {
      < -0.445892, -1.148414, 3.069393>,
      < -0.290540, -1.166057, 3.051650>,
      < -0.290550, -1.148321, 3.069393>
    }
    triangle {
      < -0.217238, -0.712634, 2.598136>,
      < -0.217249, -0.694888, 2.615868>,
      < 0.488519, -0.822098, 2.747809>
    }
    triangle {
      < -0.217238, -0.712634, 2.598136>,
      < 0.488519, -0.822098, 2.747809>,
      < 0.488532, -0.844043, 2.725883>
    }
    triangle {
      < -0.446151, -0.712770, 2.598136>,
      < -0.446161, -0.695024, 2.615868>,
      < -0.290819, -0.694932, 2.615868>
    }
    triangle {
      < -0.446151, -0.712770, 2.598136>,
      < -0.290819, -0.694932, 2.615868>,
      < -0.290808, -0.712678, 2.598136>
    }
    triangle {
      < -0.216970, -1.166015, 2.616007>,
      < -0.216980, -1.148278, 2.598265>,
      < 0.488634, -1.015957, 2.725934>
    }
    triangle {
      < -0.216970, -1.166015, 2.616007>,
      < 0.488634, -1.015957, 2.725934>,
      < 0.488647, -1.037889, 2.747873>
    }
    triangle {
      < -0.445882, -1.166150, 2.616007>,
      < -0.445892, -1.148413, 2.598265>,
      < -0.290550, -1.148321, 2.598265>
    }
    triangle {
      < -0.445882, -1.166150, 2.616007>,
      < -0.290550, -1.148321, 2.598265>,
      < -0.290540, -1.166058, 2.616007>
    }
    triangle {
      < -0.163654, -0.855964, 2.886191>,
      < 0.521296, -0.855558, 2.886191>,
      < 0.916933, -0.842916, 2.867081>
    }
    triangle {
      < 0.521296, -0.855558, 2.886191>,
      < 0.519017, -0.864254, 2.899583>,
      < 0.916945, -0.864018, 2.899583>
    }
    triangle {
      < 0.521296, -0.855558, 2.886191>,
      < 0.916945, -0.864018, 2.899583>,
      < 0.916933, -0.842916, 2.867081>
    }
    triangle {
      < -0.163654, -0.855964, 2.886191>,
      < 0.916933, -0.842916, 2.867081>,
      < -0.254629, -0.856018, 2.886191>
    }
    triangle {
      < -0.163654, -0.855964, 2.886191>,
      < -0.254629, -0.856018, 2.886191>,
      < -0.163649, -0.864659, 2.899583>
    }
    triangle {
      < 0.916933, -0.842916, 2.867081>,
      < -0.471259, -0.843739, 2.867081>,
      < -0.446721, -0.856131, 2.886191>
    }
    triangle {
      < 0.916933, -0.842916, 2.867081>,
      < -0.446721, -0.856131, 2.886191>,
      < -0.254629, -0.856018, 2.886191>
    }
    triangle {
      < -0.471259, -0.843739, 2.867081>,
      < -0.471246, -0.864841, 2.899583>,
      < -0.446716, -0.864826, 2.899583>
    }
    triangle {
      < -0.471259, -0.843739, 2.867081>,
      < -0.446716, -0.864826, 2.899583>,
      < -0.446721, -0.856131, 2.886191>
    }
    triangle {
      < -0.254629, -0.856018, 2.886191>,
      < -0.254624, -0.864713, 2.899583>,
      < -0.163649, -0.864659, 2.899583>
    }
    triangle {
      < -0.254629, -0.855973, 2.781272>,
      < -0.446721, -0.856086, 2.781272>,
      < -0.471256, -0.847739, 2.791589>
    }
    triangle {
      < -0.446721, -0.856086, 2.781272>,
      < -0.446711, -0.872057, 2.761568>,
      < -0.471242, -0.872072, 2.761568>
    }
    triangle {
      < -0.446721, -0.856086, 2.781272>,
      < -0.471242, -0.872072, 2.761568>,
      < -0.471256, -0.847739, 2.791589>
    }
    triangle {
      < -0.254629, -0.855973, 2.781272>,
      < -0.471256, -0.847739, 2.791589>,
      < -0.163654, -0.855919, 2.781272>
    }
    triangle {
      < -0.254629, -0.855973, 2.781272>,
      < -0.163654, -0.855919, 2.781272>,
      < -0.254619, -0.871944, 2.761568>
    }
    triangle {
      < -0.471256, -0.847739, 2.791589>,
      < 0.916934, -0.846917, 2.791589>,
      < 0.521193, -0.855513, 2.781273>
    }
    triangle {
      < -0.471256, -0.847739, 2.791589>,
      < 0.521193, -0.855513, 2.781273>,
      < -0.163654, -0.855919, 2.781272>
    }
    triangle {
      < 0.916934, -0.846917, 2.791589>,
      < 0.916949, -0.871249, 2.761569>,
      < 0.519372, -0.871485, 2.761569>
    }
    triangle {
      < 0.916934, -0.846917, 2.791589>,
      < 0.519372, -0.871485, 2.761569>,
      < 0.521193, -0.855513, 2.781273>
    }
    triangle {
      < -0.163654, -0.855919, 2.781272>,
      < -0.163644, -0.871890, 2.761568>,
      < -0.254619, -0.871944, 2.761568>
    }
    triangle {
      < -0.163642, -0.877322, 2.758804>,
      < 0.520675, -0.876916, 2.758804>,
      < 0.916969, -0.905688, 2.744038>
    }
    triangle {
      < 0.520675, -0.876916, 2.758804>,
      < 0.519372, -0.871485, 2.761569>,
      < 0.916949, -0.871249, 2.761569>
    }
    triangle {
      < 0.520675, -0.876916, 2.758804>,
      < 0.916949, -0.871249, 2.761569>,
      < 0.916969, -0.905688, 2.744038>
    }
    triangle {
      < -0.163642, -0.877322, 2.758804>,
      < 0.916969, -0.905688, 2.744038>,
      < -0.254616, -0.877376, 2.758804>
    }
    triangle {
      < -0.163642, -0.877322, 2.758804>,
      < -0.254616, -0.877376, 2.758804>,
      < -0.163644, -0.871890, 2.761568>
    }
    triangle {
      < 0.916969, -0.905688, 2.744038>,
      < -0.471222, -0.906511, 2.744038>,
      < -0.446709, -0.877489, 2.758804>
    }
    triangle {
      < 0.916969, -0.905688, 2.744038>,
      < -0.446709, -0.877489, 2.758804>,
      < -0.254616, -0.877376, 2.758804>
    }
    triangle {
      < -0.471222, -0.906511, 2.744038>,
      < -0.471242, -0.872072, 2.761568>,
      < -0.446711, -0.872057, 2.761568>
    }
    triangle {
      < -0.471222, -0.906511, 2.744038>,
      < -0.446711, -0.872057, 2.761568>,
      < -0.446709, -0.877489, 2.758804>
    }
    triangle {
      < -0.254616, -0.877376, 2.758804>,
      < -0.254619, -0.871944, 2.761568>,
      < -0.163644, -0.871890, 2.761568>
    }
    triangle {
      < 0.917014, -0.980353, 2.755884>,
      < 0.520489, -0.983282, 2.758580>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < 0.917014, -0.980353, 2.755884>,
      < 0.917030, -1.007673, 2.783214>,
      < 0.520502, -1.005214, 2.780518>
    }
    triangle {
      < 0.917014, -0.980353, 2.755884>,
      < 0.520502, -1.005214, 2.780518>,
      < 0.520489, -0.983282, 2.758580>
    }
    triangle {
      < 0.917030, -1.007673, 2.783214>,
      < -0.163565, -1.005620, 2.780518>,
      < 0.520502, -1.005214, 2.780518>
    }
    triangle {
      < 0.917030, -1.007673, 2.783214>,
      < -0.254540, -1.005674, 2.780518>,
      < -0.163565, -1.005620, 2.780518>
    }
    triangle {
      < 0.520489, -0.983282, 2.758580>,
      < -0.163579, -0.983688, 2.758580>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < -0.163579, -0.983688, 2.758580>,
      < -0.254553, -0.983742, 2.758580>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < -0.163579, -0.983688, 2.758580>,
      < -0.163565, -1.005620, 2.780518>,
      < -0.254553, -0.983742, 2.758580>
    }
    triangle {
      < -0.163565, -1.005620, 2.780518>,
      < -0.254540, -1.005674, 2.780518>,
      < -0.254553, -0.983742, 2.758580>
    }
    triangle {
      < 0.917030, -1.007673, 2.783214>,
      < -0.471161, -1.008496, 2.783214>,
      < -0.446632, -1.005788, 2.780518>
    }
    triangle {
      < 0.917030, -1.007673, 2.783214>,
      < -0.446632, -1.005788, 2.780518>,
      < -0.254540, -1.005674, 2.780518>
    }
    triangle {
      < -0.254553, -0.983742, 2.758580>,
      < -0.446646, -0.983855, 2.758580>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < -0.446646, -0.983855, 2.758580>,
      < -0.446632, -1.005788, 2.780518>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < -0.446632, -1.005788, 2.780518>,
      < -0.471161, -1.008496, 2.783214>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < -0.254540, -1.005418, 2.886883>,
      < -0.446632, -1.005531, 2.886883>,
      < -0.471154, -1.020321, 2.857881>
    }
    triangle {
      < -0.446632, -1.005531, 2.886883>,
      < -0.446634, -1.002765, 2.892315>,
      < -0.471164, -1.002780, 2.892315>
    }
    triangle {
      < -0.446632, -1.005531, 2.886883>,
      < -0.471164, -1.002780, 2.892315>,
      < -0.471154, -1.020321, 2.857881>
    }
    triangle {
      < -0.254540, -1.005418, 2.886883>,
      < -0.471154, -1.020321, 2.857881>,
      < -0.163566, -1.005364, 2.886883>
    }
    triangle {
      < -0.254540, -1.005418, 2.886883>,
      < -0.163566, -1.005364, 2.886883>,
      < -0.254542, -1.002652, 2.892315>
    }
    triangle {
      < -0.471154, -1.020321, 2.857881>,
      < 0.917037, -1.019498, 2.857881>,
      < 0.520751, -1.004958, 2.886883>
    }
    triangle {
      < -0.471154, -1.020321, 2.857881>,
      < 0.520751, -1.004958, 2.886883>,
      < -0.163566, -1.005364, 2.886883>
    }
    triangle {
      < 0.917037, -1.019498, 2.857881>,
      < 0.917026, -1.001957, 2.892315>,
      < 0.519449, -1.002193, 2.892315>
    }
    triangle {
      < 0.917037, -1.019498, 2.857881>,
      < 0.519449, -1.002193, 2.892315>,
      < 0.520751, -1.004958, 2.886883>
    }
    triangle {
      < -0.163566, -1.005364, 2.886883>,
      < -0.163567, -1.002598, 2.892315>,
      < -0.254542, -1.002652, 2.892315>
    }
    triangle {
      < -0.163579, -0.982889, 2.908281>,
      < 0.521267, -0.982483, 2.908281>,
      < 0.917009, -0.971930, 2.916639>
    }
    triangle {
      < 0.521267, -0.982483, 2.908281>,
      < 0.519449, -1.002193, 2.892315>,
      < 0.917026, -1.001957, 2.892315>
    }
    triangle {
      < 0.521267, -0.982483, 2.908281>,
      < 0.917026, -1.001957, 2.892315>,
      < 0.917009, -0.971930, 2.916639>
    }
    triangle {
      < -0.163579, -0.982889, 2.908281>,
      < 0.917009, -0.971930, 2.916639>,
      < -0.254553, -0.982943, 2.908281>
    }
    triangle {
      < -0.163579, -0.982889, 2.908281>,
      < -0.254553, -0.982943, 2.908281>,
      < -0.163567, -1.002598, 2.892315>
    }
    triangle {
      < 0.917009, -0.971930, 2.916639>,
      < -0.471182, -0.972752, 2.916639>,
      < -0.446646, -0.983056, 2.908281>
    }
    triangle {
      < 0.917009, -0.971930, 2.916639>,
      < -0.446646, -0.983056, 2.908281>,
      < -0.254553, -0.982943, 2.908281>
    }
    triangle {
      < -0.471182, -0.972752, 2.916639>,
      < -0.471164, -1.002780, 2.892315>,
      < -0.446634, -1.002765, 2.892315>
    }
    triangle {
      < -0.471182, -0.972752, 2.916639>,
      < -0.446634, -1.002765, 2.892315>,
      < -0.446646, -0.983056, 2.908281>
    }
    triangle {
      < -0.254553, -0.982943, 2.908281>,
      < -0.254542, -1.002652, 2.892315>,
      < -0.163567, -1.002598, 2.892315>
    }
    triangle {
      < -0.254615, -0.877924, 2.908155>,
      < -0.446708, -0.878037, 2.908155>,
      < -0.471227, -0.897259, 2.920617>
    }
    triangle {
      < -0.446708, -0.878037, 2.908155>,
      < -0.446716, -0.864826, 2.899583>,
      < -0.471246, -0.864841, 2.899583>
    }
    triangle {
      < -0.446708, -0.878037, 2.908155>,
      < -0.471246, -0.864841, 2.899583>,
      < -0.471227, -0.897259, 2.920617>
    }
    triangle {
      < -0.254615, -0.877924, 2.908155>,
      < -0.471227, -0.897259, 2.920617>,
      < -0.163641, -0.877870, 2.908155>
    }
    triangle {
      < -0.254615, -0.877924, 2.908155>,
      < -0.163641, -0.877870, 2.908155>,
      < -0.254624, -0.864713, 2.899583>
    }
    triangle {
      < -0.471227, -0.897259, 2.920617>,
      < 0.916964, -0.896436, 2.920617>,
      < 0.521297, -0.877464, 2.908155>
    }
    triangle {
      < -0.471227, -0.897259, 2.920617>,
      < 0.521297, -0.877464, 2.908155>,
      < -0.163641, -0.877870, 2.908155>
    }
    triangle {
      < 0.916964, -0.896436, 2.920617>,
      < 0.916945, -0.864018, 2.899583>,
      < 0.519017, -0.864254, 2.899583>
    }
    triangle {
      < 0.916964, -0.896436, 2.920617>,
      < 0.519017, -0.864254, 2.899583>,
      < 0.521297, -0.877464, 2.908155>
    }
    triangle {
      < -0.163641, -0.877870, 2.908155>,
      < -0.163649, -0.864659, 2.899583>,
      < -0.254624, -0.864713, 2.899583>
    }
    triangle {
      < 0.916945, -0.864018, 2.899583>,
      < 0.916964, -0.896436, 2.920617>,
      < 1.139657, -0.902960, 2.903260>
    }
    triangle {
      < 0.916945, -0.864018, 2.899583>,
      < 1.139657, -0.902960, 2.903260>,
      < 1.139642, -0.877026, 2.886432>
    }
    triangle {
      < 0.916933, -0.842916, 2.867081>,
      < 0.916945, -0.864018, 2.899583>,
      < 1.139642, -0.877026, 2.886432>
    }
    triangle {
      < 0.916933, -0.842916, 2.867081>,
      < 1.139642, -0.877026, 2.886432>,
      < 1.139632, -0.860145, 2.860431>
    }
    triangle {
      < -0.482818, -0.861106, 2.860431>,
      < -0.482807, -0.877987, 2.886432>,
      < -0.471246, -0.864841, 2.899583>
    }
    triangle {
      < -0.482818, -0.861106, 2.860431>,
      < -0.471246, -0.864841, 2.899583>,
      < -0.471259, -0.843739, 2.867081>
    }
    triangle {
      < -0.482807, -0.877987, 2.886432>,
      < -0.482791, -0.903921, 2.903260>,
      < -0.471227, -0.897259, 2.920617>
    }
    triangle {
      < -0.482807, -0.877987, 2.886432>,
      < -0.471227, -0.897259, 2.920617>,
      < -0.471246, -0.864841, 2.899583>
    }
    triangle {
      < -0.471227, -0.897259, 2.920617>,
      < -0.471205, -0.935429, 2.926650>,
      < 0.916987, -0.934606, 2.926651>
    }
    triangle {
      < -0.471227, -0.897259, 2.920617>,
      < 0.916987, -0.934606, 2.926651>,
      < 0.916964, -0.896436, 2.920617>
    }
    triangle {
      < -0.482791, -0.903921, 2.903260>,
      < -0.482773, -0.934457, 2.908085>,
      < -0.471205, -0.935429, 2.926650>
    }
    triangle {
      < -0.482791, -0.903921, 2.903260>,
      < -0.471205, -0.935429, 2.926650>,
      < -0.471227, -0.897259, 2.920617>
    }
    triangle {
      < 0.916964, -0.896436, 2.920617>,
      < 0.916987, -0.934606, 2.926651>,
      < 1.139675, -0.933495, 2.908086>
    }
    triangle {
      < 0.916964, -0.896436, 2.920617>,
      < 1.139675, -0.933495, 2.908086>,
      < 1.139657, -0.902960, 2.903260>
    }
    triangle {
      < -0.471263, -0.837717, 2.828909>,
      < -0.471259, -0.843739, 2.867081>,
      < 0.916933, -0.842916, 2.867081>
    }
    triangle {
      < -0.471263, -0.837717, 2.828909>,
      < 0.916933, -0.842916, 2.867081>,
      < 0.916929, -0.836895, 2.828910>
    }
    triangle {
      < 0.916929, -0.836895, 2.828910>,
      < 0.916933, -0.842916, 2.867081>,
      < 1.139632, -0.860145, 2.860431>
    }
    triangle {
      < 0.916929, -0.836895, 2.828910>,
      < 1.139632, -0.860145, 2.860431>,
      < 1.139629, -0.855327, 2.829894>
    }
    triangle {
      < -0.482820, -0.856288, 2.829894>,
      < -0.482818, -0.861106, 2.860431>,
      < -0.471259, -0.843739, 2.867081>
    }
    triangle {
      < -0.482820, -0.856288, 2.829894>,
      < -0.471259, -0.843739, 2.867081>,
      < -0.471263, -0.837717, 2.828909>
    }
    triangle {
      < 1.139632, -0.860145, 2.860431>,
      < 1.139642, -0.877026, 2.886432>,
      < 1.237981, -0.890107, 2.873281>
    }
    triangle {
      < 1.139632, -0.860145, 2.860431>,
      < 1.237981, -0.890107, 2.873281>,
      < 1.237973, -0.877445, 2.853781>
    }
    triangle {
      < -0.398932, -0.885856, 2.850930>,
      < -0.398926, -0.896707, 2.867646>,
      < -0.482807, -0.877987, 2.886432>
    }
    triangle {
      < -0.398932, -0.885856, 2.850930>,
      < -0.482807, -0.877987, 2.886432>,
      < -0.482818, -0.861106, 2.860431>
    }
    triangle {
      < 1.139642, -0.877026, 2.886432>,
      < 1.139657, -0.902960, 2.903260>,
      < 1.237992, -0.909557, 2.885902>
    }
    triangle {
      < 1.139642, -0.877026, 2.886432>,
      < 1.237992, -0.909557, 2.885902>,
      < 1.237981, -0.890107, 2.873281>
    }
    triangle {
      < -0.398926, -0.896707, 2.867646>,
      < -0.398916, -0.913380, 2.878463>,
      < -0.482791, -0.903921, 2.903260>
    }
    triangle {
      < -0.398926, -0.896707, 2.867646>,
      < -0.482791, -0.903921, 2.903260>,
      < -0.482807, -0.877987, 2.886432>
    }
    triangle {
      < 1.139657, -0.902960, 2.903260>,
      < 1.139675, -0.933495, 2.908086>,
      < 1.238006, -0.932459, 2.889522>
    }
    triangle {
      < 1.139657, -0.902960, 2.903260>,
      < 1.238006, -0.932459, 2.889522>,
      < 1.237992, -0.909557, 2.885902>
    }
    triangle {
      < -0.398916, -0.913380, 2.878463>,
      < -0.398904, -0.933010, 2.881565>,
      < -0.482773, -0.934457, 2.908085>
    }
    triangle {
      < -0.398916, -0.913380, 2.878463>,
      < -0.482773, -0.934457, 2.908085>,
      < -0.482791, -0.903921, 2.903260>
    }
    triangle {
      < -0.398934, -0.882758, 2.831299>,
      < -0.398932, -0.885856, 2.850930>,
      < -0.482818, -0.861106, 2.860431>
    }
    triangle {
      < -0.398934, -0.882758, 2.831299>,
      < -0.482818, -0.861106, 2.860431>,
      < -0.482820, -0.856288, 2.829894>
    }
    triangle {
      < 1.139629, -0.855327, 2.829894>,
      < 1.139632, -0.860145, 2.860431>,
      < 1.237973, -0.877445, 2.853781>
    }
    triangle {
      < 1.139629, -0.855327, 2.829894>,
      < 1.237973, -0.877445, 2.853781>,
      < 1.237971, -0.873832, 2.830878>
    }
    triangle {
      < 0.916987, -0.934606, 2.926651>,
      < 0.917009, -0.971930, 2.916639>,
      < 1.139693, -0.963355, 2.900078>
    }
    triangle {
      < 0.916987, -0.934606, 2.926651>,
      < 1.139693, -0.963355, 2.900078>,
      < 1.139675, -0.933495, 2.908086>
    }
    triangle {
      < -0.482773, -0.934457, 2.908085>,
      < -0.482756, -0.964316, 2.900077>,
      < -0.471182, -0.972752, 2.916639>
    }
    triangle {
      < -0.482773, -0.934457, 2.908085>,
      < -0.471182, -0.972752, 2.916639>,
      < -0.471205, -0.935429, 2.926650>
    }
    triangle {
      < -0.471205, -0.935429, 2.926650>,
      < -0.471182, -0.972752, 2.916639>,
      < 0.917009, -0.971930, 2.916639>
    }
    triangle {
      < -0.471205, -0.935429, 2.926650>,
      < 0.917009, -0.971930, 2.916639>,
      < 0.916987, -0.934606, 2.926651>
    }
    triangle {
      < 0.916934, -0.846917, 2.791589>,
      < 0.916929, -0.836895, 2.828910>,
      < 1.139629, -0.855327, 2.829894>
    }
    triangle {
      < 0.916934, -0.846917, 2.791589>,
      < 1.139629, -0.855327, 2.829894>,
      < 1.139634, -0.863345, 2.800037>
    }
    triangle {
      < -0.471256, -0.847739, 2.791589>,
      < -0.471263, -0.837717, 2.828909>,
      < 0.916929, -0.836895, 2.828910>
    }
    triangle {
      < -0.471256, -0.847739, 2.791589>,
      < 0.916929, -0.836895, 2.828910>,
      < 0.916934, -0.846917, 2.791589>
    }
    triangle {
      < -0.482815, -0.864306, 2.800037>,
      < -0.482820, -0.856288, 2.829894>,
      < -0.471263, -0.837717, 2.828909>
    }
    triangle {
      < -0.482815, -0.864306, 2.800037>,
      < -0.471263, -0.837717, 2.828909>,
      < -0.471256, -0.847739, 2.791589>
    }
    triangle {
      < 1.237973, -0.877445, 2.853781>,
      < 1.237981, -0.890107, 2.873281>,
      < 1.292938, -0.905091, 2.858252>
    }
    triangle {
      < 1.237973, -0.877445, 2.853781>,
      < 1.292938, -0.905091, 2.858252>,
      < 1.292934, -0.897253, 2.846180>
    }
    triangle {
      < 1.237981, -0.890107, 2.873281>,
      < 1.237992, -0.909557, 2.885902>,
      < 1.292945, -0.917132, 2.866065>
    }
    triangle {
      < 1.237981, -0.890107, 2.873281>,
      < 1.292945, -0.917132, 2.866065>,
      < 1.292938, -0.905091, 2.858252>
    }
    triangle {
      < 1.237992, -0.909557, 2.885902>,
      < 1.238006, -0.932459, 2.889522>,
      < 1.292953, -0.931309, 2.868305>
    }
    triangle {
      < 1.237992, -0.909557, 2.885902>,
      < 1.292953, -0.931309, 2.868305>,
      < 1.292945, -0.917132, 2.866065>
    }
    triangle {
      < 1.237971, -0.873832, 2.830878>,
      < 1.237973, -0.877445, 2.853781>,
      < 1.292934, -0.897253, 2.846180>
    }
    triangle {
      < 1.237971, -0.873832, 2.830878>,
      < 1.292934, -0.897253, 2.846180>,
      < 1.292932, -0.895016, 2.832002>
    }
    triangle {
      < 1.139675, -0.933495, 2.908086>,
      < 1.139693, -0.963355, 2.900078>,
      < 1.238018, -0.954854, 2.883514>
    }
    triangle {
      < 1.139675, -0.933495, 2.908086>,
      < 1.238018, -0.954854, 2.883514>,
      < 1.238006, -0.932459, 2.889522>
    }
    triangle {
      < -0.398904, -0.933010, 2.881565>,
      < -0.398894, -0.952205, 2.876417>,
      < -0.482756, -0.964316, 2.900077>
    }
    triangle {
      < -0.398904, -0.933010, 2.881565>,
      < -0.482756, -0.964316, 2.900077>,
      < -0.482773, -0.934457, 2.908085>
    }
    triangle {
      < 1.139634, -0.863345, 2.800037>,
      < 1.139629, -0.855327, 2.829894>,
      < 1.237971, -0.873832, 2.830878>
    }
    triangle {
      < 1.139634, -0.863345, 2.800037>,
      < 1.237971, -0.873832, 2.830878>,
      < 1.237974, -0.879846, 2.808485>
    }
    triangle {
      < -0.398931, -0.887912, 2.812105>,
      < -0.398934, -0.882758, 2.831299>,
      < -0.482820, -0.856288, 2.829894>
    }
    triangle {
      < -0.398931, -0.887912, 2.812105>,
      < -0.482820, -0.856288, 2.829894>,
      < -0.482815, -0.864306, 2.800037>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398926, -0.896707, 2.867646>,
      < -0.398932, -0.885856, 2.850930>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398916, -0.913380, 2.878463>,
      < -0.398926, -0.896707, 2.867646>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398904, -0.933010, 2.881565>,
      < -0.398916, -0.913380, 2.878463>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398932, -0.885856, 2.850930>,
      < -0.398934, -0.882758, 2.831299>
    }
    triangle {
      < 1.238006, -0.932459, 2.889522>,
      < 1.238018, -0.954854, 2.883514>,
      < 1.292962, -0.945172, 2.864587>
    }
    triangle {
      < 1.238006, -0.932459, 2.889522>,
      < 1.292962, -0.945172, 2.864587>,
      < 1.292953, -0.931309, 2.868305>
    }
    triangle {
      < 1.237974, -0.879846, 2.808485>,
      < 1.237971, -0.873832, 2.830878>,
      < 1.292932, -0.895016, 2.832002>
    }
    triangle {
      < 1.237974, -0.879846, 2.808485>,
      < 1.292932, -0.895016, 2.832002>,
      < 1.292935, -0.898739, 2.818140>
    }
    triangle {
      < 1.292938, -0.905091, 2.858252>,
      < 1.292945, -0.917132, 2.866065>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.292934, -0.897253, 2.846180>,
      < 1.292938, -0.905091, 2.858252>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398894, -0.952205, 2.876417>,
      < -0.398904, -0.933010, 2.881565>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398934, -0.882758, 2.831299>,
      < -0.398931, -0.887912, 2.812105>
    }
    triangle {
      < 1.292945, -0.917132, 2.866065>,
      < 1.292953, -0.931309, 2.868305>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.292932, -0.895016, 2.832002>,
      < 1.292934, -0.897253, 2.846180>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < -0.482756, -0.964316, 2.900077>,
      < -0.482742, -0.988339, 2.880617>,
      < -0.471164, -1.002780, 2.892315>
    }
    triangle {
      < -0.482756, -0.964316, 2.900077>,
      < -0.471164, -1.002780, 2.892315>,
      < -0.471182, -0.972752, 2.916639>
    }
    triangle {
      < 0.917009, -0.971930, 2.916639>,
      < 0.917026, -1.001957, 2.892315>,
      < 1.139708, -0.987377, 2.880618>
    }
    triangle {
      < 0.917009, -0.971930, 2.916639>,
      < 1.139708, -0.987377, 2.880618>,
      < 1.139693, -0.963355, 2.900078>
    }
    triangle {
      < -0.482804, -0.883773, 2.776021>,
      < -0.482815, -0.864306, 2.800037>,
      < -0.471256, -0.847739, 2.791589>
    }
    triangle {
      < -0.482804, -0.883773, 2.776021>,
      < -0.471256, -0.847739, 2.791589>,
      < -0.471242, -0.872072, 2.761568>
    }
    triangle {
      < 0.916949, -0.871249, 2.761569>,
      < 0.916934, -0.846917, 2.791589>,
      < 1.139634, -0.863345, 2.800037>
    }
    triangle {
      < 0.916949, -0.871249, 2.761569>,
      < 1.139634, -0.863345, 2.800037>,
      < 1.139646, -0.882811, 2.776021>
    }
    triangle {
      < 1.292953, -0.931309, 2.868305>,
      < 1.292962, -0.945172, 2.864587>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.292935, -0.898739, 2.818140>,
      < 1.292932, -0.895016, 2.832002>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.139693, -0.963355, 2.900078>,
      < 1.139708, -0.987377, 2.880618>,
      < 1.238029, -0.972870, 2.868920>
    }
    triangle {
      < 1.139693, -0.963355, 2.900078>,
      < 1.238029, -0.972870, 2.868920>,
      < 1.238018, -0.954854, 2.883514>
    }
    triangle {
      < -0.398894, -0.952205, 2.876417>,
      < -0.398884, -0.967648, 2.863908>,
      < -0.482742, -0.988339, 2.880617>
    }
    triangle {
      < -0.398894, -0.952205, 2.876417>,
      < -0.482742, -0.988339, 2.880617>,
      < -0.482756, -0.964316, 2.900077>
    }
    triangle {
      < 1.139646, -0.882811, 2.776021>,
      < 1.139634, -0.863345, 2.800037>,
      < 1.237974, -0.879846, 2.808485>
    }
    triangle {
      < 1.139646, -0.882811, 2.776021>,
      < 1.237974, -0.879846, 2.808485>,
      < 1.237983, -0.894445, 2.790472>
    }
    triangle {
      < -0.398924, -0.900427, 2.796666>,
      < -0.398931, -0.887912, 2.812105>,
      < -0.482815, -0.864306, 2.800037>
    }
    triangle {
      < -0.398924, -0.900427, 2.796666>,
      < -0.482815, -0.864306, 2.800037>,
      < -0.482804, -0.883773, 2.776021>
    }
    triangle {
      < 1.238018, -0.954854, 2.883514>,
      < 1.238029, -0.972870, 2.868920>,
      < 1.292969, -0.956324, 2.855552>
    }
    triangle {
      < 1.238018, -0.954854, 2.883514>,
      < 1.292969, -0.956324, 2.855552>,
      < 1.292962, -0.945172, 2.864587>
    }
    triangle {
      < 1.237983, -0.894445, 2.790472>,
      < 1.237974, -0.879846, 2.808485>,
      < 1.292935, -0.898739, 2.818140>
    }
    triangle {
      < 1.237983, -0.894445, 2.790472>,
      < 1.292935, -0.898739, 2.818140>,
      < 1.292940, -0.907777, 2.806989>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398884, -0.967648, 2.863908>,
      < -0.398894, -0.952205, 2.876417>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398931, -0.887912, 2.812105>,
      < -0.398924, -0.900427, 2.796666>
    }
    triangle {
      < 1.292962, -0.945172, 2.864587>,
      < 1.292969, -0.956324, 2.855552>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.292940, -0.907777, 2.806989>,
      < 1.292935, -0.898739, 2.818140>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398924, -0.900427, 2.796666>,
      < -0.398913, -0.918138, 2.787650>
    }
    triangle {
      < 1.292969, -0.956324, 2.855552>,
      < 1.292972, -0.962840, 2.842763>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398913, -0.918138, 2.787650>,
      < -0.398902, -0.937985, 2.786617>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398891, -0.956537, 2.793742>,
      < -0.398882, -0.970588, 2.807798>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398902, -0.937985, 2.786617>,
      < -0.398891, -0.956537, 2.793742>
    }
    triangle {
      < 1.292970, -0.958448, 2.815029>,
      < 1.292963, -0.948300, 2.804878>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.292947, -0.920568, 2.800478>,
      < 1.292940, -0.907777, 2.806989>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.292955, -0.934901, 2.799731>,
      < 1.292947, -0.920568, 2.800478>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398878, -0.976669, 2.846199>,
      < -0.398884, -0.967648, 2.863908>
    }
    triangle {
      < 1.292972, -0.962840, 2.842763>,
      < 1.292972, -0.963591, 2.828429>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < 1.292963, -0.948300, 2.804878>,
      < 1.292955, -0.934901, 2.799731>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398878, -0.977709, 2.826352>,
      < -0.398878, -0.976669, 2.846199>
    }
    triangle {
      < 1.292972, -0.963591, 2.828429>,
      < 1.292970, -0.958448, 2.815029>,
      < 1.339226, -0.929464, 2.833829>
    }
    triangle {
      < -0.381554, -0.930483, 2.833828>,
      < -0.398882, -0.970588, 2.807798>,
      < -0.398878, -0.977709, 2.826352>
    }
    triangle {
      < 1.238029, -0.972870, 2.868920>,
      < 1.238035, -0.983394, 2.848260>,
      < 1.292972, -0.962840, 2.842763>
    }
    triangle {
      < 1.238029, -0.972870, 2.868920>,
      < 1.292972, -0.962840, 2.842763>,
      < 1.292969, -0.956324, 2.855552>
    }
    triangle {
      < 1.237995, -0.915108, 2.779954>,
      < 1.237983, -0.894445, 2.790472>,
      < 1.292940, -0.907777, 2.806989>
    }
    triangle {
      < 1.237995, -0.915108, 2.779954>,
      < 1.292940, -0.907777, 2.806989>,
      < 1.292947, -0.920568, 2.800478>
    }
    triangle {
      < -0.398884, -0.967648, 2.863908>,
      < -0.398878, -0.976669, 2.846199>,
      < -0.482734, -1.002370, 2.853071>
    }
    triangle {
      < -0.398884, -0.967648, 2.863908>,
      < -0.482734, -1.002370, 2.853071>,
      < -0.482742, -0.988339, 2.880617>
    }
    triangle {
      < -0.398913, -0.918138, 2.787650>,
      < -0.398924, -0.900427, 2.796666>,
      < -0.482804, -0.883773, 2.776021>
    }
    triangle {
      < -0.398913, -0.918138, 2.787650>,
      < -0.482804, -0.883773, 2.776021>,
      < -0.482787, -0.911323, 2.761996>
    }
    triangle {
      < 1.139708, -0.987377, 2.880618>,
      < 1.139716, -1.001409, 2.853072>,
      < 1.238035, -0.983394, 2.848260>
    }
    triangle {
      < 1.139708, -0.987377, 2.880618>,
      < 1.238035, -0.983394, 2.848260>,
      < 1.238029, -0.972870, 2.868920>
    }
    triangle {
      < 1.139662, -0.910362, 2.761996>,
      < 1.139646, -0.882811, 2.776021>,
      < 1.237983, -0.894445, 2.790472>
    }
    triangle {
      < 1.139662, -0.910362, 2.761996>,
      < 1.237983, -0.894445, 2.790472>,
      < 1.237995, -0.915108, 2.779954>
    }
    triangle {
      < -0.482742, -0.988339, 2.880617>,
      < -0.482734, -1.002370, 2.853071>,
      < -0.471154, -1.020321, 2.857881>
    }
    triangle {
      < -0.482742, -0.988339, 2.880617>,
      < -0.471154, -1.020321, 2.857881>,
      < -0.471164, -1.002780, 2.892315>
    }
    triangle {
      < 0.917026, -1.001957, 2.892315>,
      < 0.917037, -1.019498, 2.857881>,
      < 1.139716, -1.001409, 2.853072>
    }
    triangle {
      < 0.917026, -1.001957, 2.892315>,
      < 1.139716, -1.001409, 2.853072>,
      < 1.139708, -0.987377, 2.880618>
    }
    triangle {
      < 0.916969, -0.905688, 2.744038>,
      < 0.916949, -0.871249, 2.761569>,
      < 1.139646, -0.882811, 2.776021>
    }
    triangle {
      < 0.916969, -0.905688, 2.744038>,
      < 1.139646, -0.882811, 2.776021>,
      < 1.139662, -0.910362, 2.761996>
    }
    triangle {
      < -0.482787, -0.911323, 2.761996>,
      < -0.482804, -0.883773, 2.776021>,
      < -0.471242, -0.872072, 2.761568>
    }
    triangle {
      < -0.482787, -0.911323, 2.761996>,
      < -0.471242, -0.872072, 2.761568>,
      < -0.471222, -0.906511, 2.744038>
    }
    triangle {
      < 1.238035, -0.983394, 2.848260>,
      < 1.238036, -0.984608, 2.825107>,
      < 1.292972, -0.963591, 2.828429>
    }
    triangle {
      < 1.238035, -0.983394, 2.848260>,
      < 1.292972, -0.963591, 2.828429>,
      < 1.292972, -0.962840, 2.842763>
    }
    triangle {
      < 1.238009, -0.938263, 2.778748>,
      < 1.237995, -0.915108, 2.779954>,
      < 1.292947, -0.920568, 2.800478>
    }
    triangle {
      < 1.238009, -0.938263, 2.778748>,
      < 1.292947, -0.920568, 2.800478>,
      < 1.292955, -0.934901, 2.799731>
    }
    triangle {
      < -0.398878, -0.976669, 2.846199>,
      < -0.398878, -0.977709, 2.826352>,
      < -0.482732, -1.003988, 2.822199>
    }
    triangle {
      < -0.398878, -0.976669, 2.846199>,
      < -0.482732, -1.003988, 2.822199>,
      < -0.482734, -1.002370, 2.853071>
    }
    triangle {
      < -0.398902, -0.937985, 2.786617>,
      < -0.398913, -0.918138, 2.787650>,
      < -0.482787, -0.911323, 2.761996>
    }
    triangle {
      < -0.398902, -0.937985, 2.786617>,
      < -0.482787, -0.911323, 2.761996>,
      < -0.482769, -0.942196, 2.760387>
    }
    triangle {
      < 1.139716, -1.001409, 2.853072>,
      < 1.139717, -1.003027, 2.822199>,
      < 1.238036, -0.984608, 2.825107>
    }
    triangle {
      < 1.139716, -1.001409, 2.853072>,
      < 1.238036, -0.984608, 2.825107>,
      < 1.238035, -0.983394, 2.848260>
    }
    triangle {
      < 1.238036, -0.984608, 2.825107>,
      < 1.238032, -0.976300, 2.803460>,
      < 1.292970, -0.958448, 2.815029>
    }
    triangle {
      < 1.238036, -0.984608, 2.825107>,
      < 1.292970, -0.958448, 2.815029>,
      < 1.292972, -0.963591, 2.828429>
    }
    triangle {
      < 1.139681, -0.941235, 2.760388>,
      < 1.139662, -0.910362, 2.761996>,
      < 1.237995, -0.915108, 2.779954>
    }
    triangle {
      < 1.139681, -0.941235, 2.760388>,
      < 1.237995, -0.915108, 2.779954>,
      < 1.238009, -0.938263, 2.778748>
    }
    triangle {
      < 1.238022, -0.959907, 2.787063>,
      < 1.238009, -0.938263, 2.778748>,
      < 1.292955, -0.934901, 2.799731>
    }
    triangle {
      < 1.238022, -0.959907, 2.787063>,
      < 1.292955, -0.934901, 2.799731>,
      < 1.292963, -0.948300, 2.804878>
    }
    triangle {
      < 1.238032, -0.976300, 2.803460>,
      < 1.238022, -0.959907, 2.787063>,
      < 1.292963, -0.948300, 2.804878>
    }
    triangle {
      < 1.238032, -0.976300, 2.803460>,
      < 1.292963, -0.948300, 2.804878>,
      < 1.292970, -0.958448, 2.815029>
    }
    triangle {
      < -0.482734, -1.002370, 2.853071>,
      < -0.482732, -1.003988, 2.822199>,
      < -0.471153, -1.022342, 2.819290>
    }
    triangle {
      < -0.482734, -1.002370, 2.853071>,
      < -0.471153, -1.022342, 2.819290>,
      < -0.471154, -1.020321, 2.857881>
    }
    triangle {
      < 0.917037, -1.019498, 2.857881>,
      < 0.917038, -1.021519, 2.819291>,
      < 1.139717, -1.003027, 2.822199>
    }
    triangle {
      < 0.917037, -1.019498, 2.857881>,
      < 1.139717, -1.003027, 2.822199>,
      < 1.139716, -1.001409, 2.853072>
    }
    triangle {
      < 0.916992, -0.944279, 2.742028>,
      < 0.916969, -0.905688, 2.744038>,
      < 1.139662, -0.910362, 2.761996>
    }
    triangle {
      < 0.916992, -0.944279, 2.742028>,
      < 1.139662, -0.910362, 2.761996>,
      < 1.139681, -0.941235, 2.760388>
    }
    triangle {
      < -0.482769, -0.942196, 2.760387>,
      < -0.482787, -0.911323, 2.761996>,
      < -0.471222, -0.906511, 2.744038>
    }
    triangle {
      < -0.482769, -0.942196, 2.760387>,
      < -0.471222, -0.906511, 2.744038>,
      < -0.471199, -0.945102, 2.742028>
    }
    triangle {
      < -0.398878, -0.977709, 2.826352>,
      < -0.398882, -0.970588, 2.807798>,
      < -0.482739, -0.992912, 2.793337>
    }
    triangle {
      < -0.398878, -0.977709, 2.826352>,
      < -0.482739, -0.992912, 2.793337>,
      < -0.482732, -1.003988, 2.822199>
    }
    triangle {
      < -0.398891, -0.956537, 2.793742>,
      < -0.398902, -0.937985, 2.786617>,
      < -0.482769, -0.942196, 2.760387>
    }
    triangle {
      < -0.398891, -0.956537, 2.793742>,
      < -0.482769, -0.942196, 2.760387>,
      < -0.482752, -0.971055, 2.771473>
    }
    triangle {
      < 1.139717, -1.003027, 2.822199>,
      < 1.139711, -0.991950, 2.793337>,
      < 1.238032, -0.976300, 2.803460>
    }
    triangle {
      < 1.139717, -1.003027, 2.822199>,
      < 1.238032, -0.976300, 2.803460>,
      < 1.238036, -0.984608, 2.825107>
    }
    triangle {
      < 1.139697, -0.970094, 2.771474>,
      < 1.139681, -0.941235, 2.760388>,
      < 1.238009, -0.938263, 2.778748>
    }
    triangle {
      < 1.139697, -0.970094, 2.771474>,
      < 1.238009, -0.938263, 2.778748>,
      < 1.238022, -0.959907, 2.787063>
    }
    triangle {
      < -0.471154, -1.020321, 2.857881>,
      < -0.471153, -1.022342, 2.819290>,
      < 0.917038, -1.021519, 2.819291>
    }
    triangle {
      < -0.471154, -1.020321, 2.857881>,
      < 0.917038, -1.021519, 2.819291>,
      < 0.917037, -1.019498, 2.857881>
    }
    triangle {
      < -0.471199, -0.945102, 2.742028>,
      < -0.471222, -0.906511, 2.744038>,
      < 0.916969, -0.905688, 2.744038>
    }
    triangle {
      < -0.471199, -0.945102, 2.742028>,
      < 0.916969, -0.905688, 2.744038>,
      < 0.916992, -0.944279, 2.742028>
    }
    triangle {
      < -0.398882, -0.970588, 2.807798>,
      < -0.398891, -0.956537, 2.793742>,
      < -0.482752, -0.971055, 2.771473>
    }
    triangle {
      < -0.398882, -0.970588, 2.807798>,
      < -0.482752, -0.971055, 2.771473>,
      < -0.482739, -0.992912, 2.793337>
    }
    triangle {
      < 1.139711, -0.991950, 2.793337>,
      < 1.139697, -0.970094, 2.771474>,
      < 1.238022, -0.959907, 2.787063>
    }
    triangle {
      < 1.139711, -0.991950, 2.793337>,
      < 1.238022, -0.959907, 2.787063>,
      < 1.238032, -0.976300, 2.803460>
    }
    triangle {
      < -0.482732, -1.003988, 2.822199>,
      < -0.482739, -0.992912, 2.793337>,
      < -0.471161, -1.008496, 2.783214>
    }
    triangle {
      < -0.482732, -1.003988, 2.822199>,
      < -0.471161, -1.008496, 2.783214>,
      < -0.471153, -1.022342, 2.819290>
    }
    triangle {
      < 0.917038, -1.021519, 2.819291>,
      < 0.917030, -1.007673, 2.783214>,
      < 1.139711, -0.991950, 2.793337>
    }
    triangle {
      < 0.917038, -1.021519, 2.819291>,
      < 1.139711, -0.991950, 2.793337>,
      < 1.139717, -1.003027, 2.822199>
    }
    triangle {
      < 0.917014, -0.980353, 2.755884>,
      < 0.916992, -0.944279, 2.742028>,
      < 1.139681, -0.941235, 2.760388>
    }
    triangle {
      < 0.917014, -0.980353, 2.755884>,
      < 1.139681, -0.941235, 2.760388>,
      < 1.139697, -0.970094, 2.771474>
    }
    triangle {
      < -0.482752, -0.971055, 2.771473>,
      < -0.482769, -0.942196, 2.760387>,
      < -0.471199, -0.945102, 2.742028>
    }
    triangle {
      < -0.482752, -0.971055, 2.771473>,
      < -0.471199, -0.945102, 2.742028>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < -0.482739, -0.992912, 2.793337>,
      < -0.482752, -0.971055, 2.771473>,
      < -0.471177, -0.981175, 2.755884>
    }
    triangle {
      < -0.482739, -0.992912, 2.793337>,
      < -0.471177, -0.981175, 2.755884>,
      < -0.471161, -1.008496, 2.783214>
    }
    triangle {
      < 0.917030, -1.007673, 2.783214>,
      < 0.917014, -0.980353, 2.755884>,
      < 1.139697, -0.970094, 2.771474>
    }
    triangle {
      < 0.917030, -1.007673, 2.783214>,
      < 1.139697, -0.970094, 2.771474>,
      < 1.139711, -0.991950, 2.793337>
    }
    triangle {
      < -0.471153, -1.022342, 2.819290>,
      < -0.471161, -1.008496, 2.783214>,
      < 0.917030, -1.007673, 2.783214>
    }
    triangle {
      < -0.471153, -1.022342, 2.819290>,
      < 0.917030, -1.007673, 2.783214>,
      < 0.917038, -1.021519, 2.819291>
    }
    triangle {
      < -0.471177, -0.981175, 2.755884>,
      < -0.471199, -0.945102, 2.742028>,
      < 0.916992, -0.944279, 2.742028>
    }
    triangle {
      < -0.471177, -0.981175, 2.755884>,
      < 0.916992, -0.944279, 2.742028>,
      < 0.917014, -0.980353, 2.755884>
    }
    triangle {
      < -0.307214, -0.512236, 3.396626>,
      < -0.271021, -0.677761, 3.235518>,
      < -0.271030, -0.664550, 3.226947>
    }
    triangle {
      < -0.307214, -0.512236, 3.396626>,
      < -0.271030, -0.664550, 3.226947>,
      < -0.307225, -0.494510, 3.378874>
    }
    triangle {
      < -0.271030, -0.664550, 3.226947>,
      < -0.271035, -0.655855, 3.213554>,
      < -0.307225, -0.494510, 3.378874>
    }
    triangle {
      < -0.462568, -0.494603, 3.378874>,
      < -0.463127, -0.655968, 3.213554>,
      < -0.463122, -0.664663, 3.226947>
    }
    triangle {
      < -0.462568, -0.494603, 3.378874>,
      < -0.463122, -0.664663, 3.226947>,
      < -0.462557, -0.512328, 3.396626>
    }
    triangle {
      < -0.463122, -0.664663, 3.226947>,
      < -0.463114, -0.677874, 3.235518>,
      < -0.462557, -0.512328, 3.396626>
    }
    triangle {
      < -0.307225, -0.494510, 3.378874>,
      < -0.271035, -0.655855, 3.213554>,
      < -0.463127, -0.655968, 3.213554>
    }
    triangle {
      < -0.307225, -0.494510, 3.378874>,
      < -0.463127, -0.655968, 3.213554>,
      < -0.462568, -0.494603, 3.378874>
    }
    triangle {
      < -0.462557, -0.512328, 3.396626>,
      < -0.463114, -0.677874, 3.235518>,
      < -0.271021, -0.677761, 3.235518>
    }
    triangle {
      < -0.462557, -0.512328, 3.396626>,
      < -0.271021, -0.677761, 3.235518>,
      < -0.307214, -0.512236, 3.396626>
    }
    triangle {
      < 0.472126, -0.643753, 3.269036>,
      < 0.504892, -0.677301, 3.235518>,
      < 0.502611, -0.664091, 3.226947>
    }
    triangle {
      < 0.472126, -0.643753, 3.269036>,
      < 0.502611, -0.664091, 3.226947>,
      < 0.472114, -0.621834, 3.247085>
    }
    triangle {
      < 0.502611, -0.664091, 3.226947>,
      < 0.504891, -0.655395, 3.213554>,
      < 0.472114, -0.621834, 3.247085>
    }
    triangle {
      < -0.233654, -0.494467, 3.378874>,
      < -0.180059, -0.655801, 3.213554>,
      < -0.180054, -0.664496, 3.226947>
    }
    triangle {
      < -0.233654, -0.494467, 3.378874>,
      < -0.180054, -0.664496, 3.226947>,
      < -0.233644, -0.512192, 3.396626>
    }
    triangle {
      < -0.180054, -0.664496, 3.226947>,
      < -0.180046, -0.677707, 3.235518>,
      < -0.233644, -0.512192, 3.396626>
    }
    triangle {
      < 0.472114, -0.621834, 3.247085>,
      < 0.504891, -0.655395, 3.213554>,
      < -0.180059, -0.655801, 3.213554>
    }
    triangle {
      < 0.472114, -0.621834, 3.247085>,
      < -0.180059, -0.655801, 3.213554>,
      < -0.233654, -0.494467, 3.378874>
    }
    triangle {
      < -0.233644, -0.512192, 3.396626>,
      < -0.180046, -0.677707, 3.235518>,
      < 0.504892, -0.677301, 3.235518>
    }
    triangle {
      < -0.233644, -0.512192, 3.396626>,
      < 0.504892, -0.677301, 3.235518>,
      < 0.472126, -0.643753, 3.269036>
    }
    triangle {
      < -0.307225, -0.494767, 2.943231>,
      < -0.271035, -0.655810, 3.108635>,
      < -0.271025, -0.671781, 3.088932>
    }
    triangle {
      < -0.307225, -0.494767, 2.943231>,
      < -0.271025, -0.671781, 3.088932>,
      < -0.307214, -0.512515, 2.925500>
    }
    triangle {
      < -0.271025, -0.671781, 3.088932>,
      < -0.271022, -0.677213, 3.086167>,
      < -0.307214, -0.512515, 2.925500>
    }
    triangle {
      < -0.462557, -0.512607, 2.925500>,
      < -0.463115, -0.677326, 3.086167>,
      < -0.463117, -0.671895, 3.088932>
    }
    triangle {
      < -0.462557, -0.512607, 2.925500>,
      < -0.463117, -0.671895, 3.088932>,
      < -0.462568, -0.494860, 2.943231>
    }
    triangle {
      < -0.463117, -0.671895, 3.088932>,
      < -0.463127, -0.655924, 3.108635>,
      < -0.462568, -0.494860, 2.943231>
    }
    triangle {
      < -0.307214, -0.512515, 2.925500>,
      < -0.271022, -0.677213, 3.086167>,
      < -0.463115, -0.677326, 3.086167>
    }
    triangle {
      < -0.307214, -0.512515, 2.925500>,
      < -0.463115, -0.677326, 3.086167>,
      < -0.462557, -0.512607, 2.925500>
    }
    triangle {
      < -0.462568, -0.494860, 2.943231>,
      < -0.463127, -0.655924, 3.108635>,
      < -0.271035, -0.655810, 3.108635>
    }
    triangle {
      < -0.462568, -0.494860, 2.943231>,
      < -0.271035, -0.655810, 3.108635>,
      < -0.307225, -0.494767, 2.943231>
    }
    triangle {
      < 0.472114, -0.621935, 3.075172>,
      < 0.504787, -0.655350, 3.108635>,
      < 0.502967, -0.671322, 3.088932>
    }
    triangle {
      < 0.472114, -0.621935, 3.075172>,
      < 0.502967, -0.671322, 3.088932>,
      < 0.472127, -0.643880, 3.053246>
    }
    triangle {
      < 0.502967, -0.671322, 3.088932>,
      < 0.504269, -0.676753, 3.086167>,
      < 0.472127, -0.643880, 3.053246>
    }
    triangle {
      < -0.233644, -0.512471, 2.925500>,
      < -0.180047, -0.677159, 3.086167>,
      < -0.180049, -0.671727, 3.088932>
    }
    triangle {
      < -0.233644, -0.512471, 2.925500>,
      < -0.180049, -0.671727, 3.088932>,
      < -0.233654, -0.494724, 2.943231>
    }
    triangle {
      < -0.180049, -0.671727, 3.088932>,
      < -0.180059, -0.655756, 3.108635>,
      < -0.233654, -0.494724, 2.943231>
    }
    triangle {
      < 0.472127, -0.643880, 3.053246>,
      < 0.504269, -0.676753, 3.086167>,
      < -0.180047, -0.677159, 3.086167>
    }
    triangle {
      < 0.472127, -0.643880, 3.053246>,
      < -0.180047, -0.677159, 3.086167>,
      < -0.233644, -0.512471, 2.925500>
    }
    triangle {
      < -0.233654, -0.494724, 2.943231>,
      < -0.180059, -0.655756, 3.108635>,
      < 0.504787, -0.655350, 3.108635>
    }
    triangle {
      < -0.233654, -0.494724, 2.943231>,
      < 0.504787, -0.655350, 3.108635>,
      < 0.472114, -0.621935, 3.075172>
    }
    triangle {
      < -0.306956, -0.948158, 2.925628>,
      < -0.270959, -0.783579, 3.085943>,
      < -0.270946, -0.805511, 3.107881>
    }
    triangle {
      < -0.306956, -0.948158, 2.925628>,
      < -0.270946, -0.805511, 3.107881>,
      < -0.306946, -0.965895, 2.943370>
    }
    triangle {
      < -0.462289, -0.965988, 2.943370>,
      < -0.463038, -0.805625, 3.107881>,
      < -0.463052, -0.783693, 3.085943>
    }
    triangle {
      < -0.462289, -0.965988, 2.943370>,
      < -0.463052, -0.783693, 3.085943>,
      < -0.462299, -0.948251, 2.925628>
    }
    triangle {
      < -0.306946, -0.965895, 2.943370>,
      < -0.270946, -0.805511, 3.107881>,
      < -0.463038, -0.805625, 3.107881>
    }
    triangle {
      < -0.306946, -0.965895, 2.943370>,
      < -0.463038, -0.805625, 3.107881>,
      < -0.462289, -0.965988, 2.943370>
    }
    triangle {
      < -0.462299, -0.948251, 2.925628>,
      < -0.463052, -0.783693, 3.085943>,
      < -0.270959, -0.783579, 3.085943>
    }
    triangle {
      < -0.462299, -0.948251, 2.925628>,
      < -0.270959, -0.783579, 3.085943>,
      < -0.306956, -0.948158, 2.925628>
    }
    triangle {
      < 0.472229, -0.815793, 3.053298>,
      < 0.504083, -0.783119, 3.085943>,
      < 0.504096, -0.805052, 3.107881>
    }
    triangle {
      < 0.472229, -0.815793, 3.053298>,
      < 0.504096, -0.805052, 3.107881>,
      < 0.472242, -0.837725, 3.075236>
    }
    triangle {
      < -0.233375, -0.965852, 2.943370>,
      < -0.179970, -0.805458, 3.107881>,
      < -0.179984, -0.783525, 3.085943>
    }
    triangle {
      < -0.233375, -0.965852, 2.943370>,
      < -0.179984, -0.783525, 3.085943>,
      < -0.233385, -0.948115, 2.925628>
    }
    triangle {
      < 0.472242, -0.837725, 3.075236>,
      < 0.504096, -0.805052, 3.107881>,
      < -0.179970, -0.805458, 3.107881>
    }
    triangle {
      < 0.472242, -0.837725, 3.075236>,
      < -0.179970, -0.805458, 3.107881>,
      < -0.233375, -0.965852, 2.943370>
    }
    triangle {
      < -0.233385, -0.948115, 2.925628>,
      < -0.179984, -0.783525, 3.085943>,
      < 0.504083, -0.783119, 3.085943>
    }
    triangle {
      < -0.233385, -0.948115, 2.925628>,
      < 0.504083, -0.783119, 3.085943>,
      < 0.472229, -0.815793, 3.053298>
    }
    triangle {
      < -0.306946, -0.965894, 3.379014>,
      < -0.270946, -0.805254, 3.214248>,
      < -0.270948, -0.802489, 3.219678>
    }
    triangle {
      < -0.306946, -0.965894, 3.379014>,
      < -0.270948, -0.802489, 3.219678>,
      < -0.306956, -0.948158, 3.396756>
    }
    triangle {
      < -0.270948, -0.802489, 3.219678>,
      < -0.270959, -0.782780, 3.235643>,
      < -0.306956, -0.948158, 3.396756>
    }
    triangle {
      < -0.462299, -0.948251, 3.396756>,
      < -0.463052, -0.782894, 3.235643>,
      < -0.463040, -0.802603, 3.219678>
    }
    triangle {
      < -0.462299, -0.948251, 3.396756>,
      < -0.463040, -0.802603, 3.219678>,
      < -0.462289, -0.965987, 3.379013>
    }
    triangle {
      < -0.463040, -0.802603, 3.219678>,
      < -0.463038, -0.805368, 3.214248>,
      < -0.462289, -0.965987, 3.379013>
    }
    triangle {
      < -0.306956, -0.948158, 3.396756>,
      < -0.270959, -0.782780, 3.235643>,
      < -0.463052, -0.782894, 3.235643>
    }
    triangle {
      < -0.306956, -0.948158, 3.396756>,
      < -0.463052, -0.782894, 3.235643>,
      < -0.462299, -0.948251, 3.396756>
    }
    triangle {
      < -0.462289, -0.965987, 3.379013>,
      < -0.463038, -0.805368, 3.214248>,
      < -0.270946, -0.805254, 3.214248>
    }
    triangle {
      < -0.462289, -0.965987, 3.379013>,
      < -0.270946, -0.805254, 3.214248>,
      < -0.306946, -0.965894, 3.379014>
    }
    triangle {
      < 0.472242, -0.837726, 3.247149>,
      < 0.504345, -0.804795, 3.214248>,
      < 0.503044, -0.802030, 3.219678>
    }
    triangle {
      < 0.472242, -0.837726, 3.247149>,
      < 0.503044, -0.802030, 3.219678>,
      < 0.472229, -0.815794, 3.269088>
    }
    triangle {
      < 0.503044, -0.802030, 3.219678>,
      < 0.504862, -0.782320, 3.235643>,
      < 0.472229, -0.815794, 3.269088>
    }
    triangle {
      < -0.233385, -0.948115, 3.396756>,
      < -0.179984, -0.782726, 3.235643>,
      < -0.179972, -0.802435, 3.219678>
    }
    triangle {
      < -0.233385, -0.948115, 3.396756>,
      < -0.179972, -0.802435, 3.219678>,
      < -0.233375, -0.965851, 3.379014>
    }
    triangle {
      < -0.179972, -0.802435, 3.219678>,
      < -0.179970, -0.805201, 3.214248>,
      < -0.233375, -0.965851, 3.379014>
    }
    triangle {
      < 0.472229, -0.815794, 3.269088>,
      < 0.504862, -0.782320, 3.235643>,
      < -0.179984, -0.782726, 3.235643>
    }
    triangle {
      < 0.472229, -0.815794, 3.269088>,
      < -0.179984, -0.782726, 3.235643>,
      < -0.233385, -0.948115, 3.396756>
    }
    triangle {
      < -0.233375, -0.965851, 3.379014>,
      < -0.179970, -0.805201, 3.214248>,
      < 0.504345, -0.804795, 3.214248>
    }
    triangle {
      < -0.233375, -0.965851, 3.379014>,
      < 0.504345, -0.804795, 3.214248>,
      < 0.472242, -0.837726, 3.247149>
    }
    triangle {
      < -0.233654, -0.494467, 3.378874>,
      < -0.233644, -0.512192, 3.396626>,
      < 0.472126, -0.643753, 3.269036>
    }
    triangle {
      < -0.233654, -0.494467, 3.378874>,
      < 0.472126, -0.643753, 3.269036>,
      < 0.472114, -0.621834, 3.247085>
    }
    triangle {
      < -0.462568, -0.494603, 3.378874>,
      < -0.462557, -0.512328, 3.396626>,
      < -0.307214, -0.512236, 3.396626>
    }
    triangle {
      < -0.462568, -0.494603, 3.378874>,
      < -0.307214, -0.512236, 3.396626>,
      < -0.307225, -0.494510, 3.378874>
    }
    triangle {
      < -0.233385, -0.948115, 3.396756>,
      < -0.233375, -0.965851, 3.379014>,
      < 0.472242, -0.837726, 3.247149>
    }
    triangle {
      < -0.233385, -0.948115, 3.396756>,
      < 0.472242, -0.837726, 3.247149>,
      < 0.472229, -0.815794, 3.269088>
    }
    triangle {
      < -0.462299, -0.948251, 3.396756>,
      < -0.462289, -0.965987, 3.379013>,
      < -0.306946, -0.965894, 3.379014>
    }
    triangle {
      < -0.462299, -0.948251, 3.396756>,
      < -0.306946, -0.965894, 3.379014>,
      < -0.306956, -0.948158, 3.396756>
    }
    triangle {
      < -0.233644, -0.512471, 2.925500>,
      < -0.233654, -0.494724, 2.943231>,
      < 0.472114, -0.621935, 3.075172>
    }
    triangle {
      < -0.233644, -0.512471, 2.925500>,
      < 0.472114, -0.621935, 3.075172>,
      < 0.472127, -0.643880, 3.053246>
    }
    triangle {
      < -0.462557, -0.512607, 2.925500>,
      < -0.462568, -0.494860, 2.943231>,
      < -0.307225, -0.494767, 2.943231>
    }
    triangle {
      < -0.462557, -0.512607, 2.925500>,
      < -0.307225, -0.494767, 2.943231>,
      < -0.307214, -0.512515, 2.925500>
    }
    triangle {
      < -0.233375, -0.965852, 2.943370>,
      < -0.233385, -0.948115, 2.925628>,
      < 0.472229, -0.815793, 3.053298>
    }
    triangle {
      < -0.233375, -0.965852, 2.943370>,
      < 0.472229, -0.815793, 3.053298>,
      < 0.472242, -0.837725, 3.075236>
    }
    triangle {
      < -0.462289, -0.965988, 2.943370>,
      < -0.462299, -0.948251, 2.925628>,
      < -0.306956, -0.948158, 2.925628>
    }
    triangle {
      < -0.462289, -0.965988, 2.943370>,
      < -0.306956, -0.948158, 2.925628>,
      < -0.306946, -0.965895, 2.943370>
    }
    triangle {
      < -0.180059, -0.655801, 3.213554>,
      < 0.504891, -0.655395, 3.213554>,
      < 0.900527, -0.642753, 3.194445>
    }
    triangle {
      < 0.504891, -0.655395, 3.213554>,
      < 0.502611, -0.664091, 3.226947>,
      < 0.900540, -0.663855, 3.226947>
    }
    triangle {
      < 0.504891, -0.655395, 3.213554>,
      < 0.900540, -0.663855, 3.226947>,
      < 0.900527, -0.642753, 3.194445>
    }
    triangle {
      < -0.180059, -0.655801, 3.213554>,
      < 0.900527, -0.642753, 3.194445>,
      < -0.271035, -0.655855, 3.213554>
    }
    triangle {
      < -0.180059, -0.655801, 3.213554>,
      < -0.271035, -0.655855, 3.213554>,
      < -0.180054, -0.664496, 3.226947>
    }
    triangle {
      < 0.900527, -0.642753, 3.194445>,
      < -0.487665, -0.643576, 3.194444>,
      < -0.463127, -0.655968, 3.213554>
    }
    triangle {
      < 0.900527, -0.642753, 3.194445>,
      < -0.463127, -0.655968, 3.213554>,
      < -0.271035, -0.655855, 3.213554>
    }
    triangle {
      < -0.487665, -0.643576, 3.194444>,
      < -0.487652, -0.664678, 3.226947>,
      < -0.463122, -0.664663, 3.226947>
    }
    triangle {
      < -0.487665, -0.643576, 3.194444>,
      < -0.463122, -0.664663, 3.226947>,
      < -0.463127, -0.655968, 3.213554>
    }
    triangle {
      < -0.271035, -0.655855, 3.213554>,
      < -0.271030, -0.664550, 3.226947>,
      < -0.180054, -0.664496, 3.226947>
    }
    triangle {
      < -0.271035, -0.655810, 3.108635>,
      < -0.463127, -0.655924, 3.108635>,
      < -0.487662, -0.647576, 3.118952>
    }
    triangle {
      < -0.463127, -0.655924, 3.108635>,
      < -0.463117, -0.671895, 3.088932>,
      < -0.487648, -0.671909, 3.088932>
    }
    triangle {
      < -0.463127, -0.655924, 3.108635>,
      < -0.487648, -0.671909, 3.088932>,
      < -0.487662, -0.647576, 3.118952>
    }
    triangle {
      < -0.271035, -0.655810, 3.108635>,
      < -0.487662, -0.647576, 3.118952>,
      < -0.180059, -0.655756, 3.108635>
    }
    triangle {
      < -0.271035, -0.655810, 3.108635>,
      < -0.180059, -0.655756, 3.108635>,
      < -0.271025, -0.671781, 3.088932>
    }
    triangle {
      < -0.487662, -0.647576, 3.118952>,
      < 0.900529, -0.646754, 3.118952>,
      < 0.504787, -0.655350, 3.108635>
    }
    triangle {
      < -0.487662, -0.647576, 3.118952>,
      < 0.504787, -0.655350, 3.108635>,
      < -0.180059, -0.655756, 3.108635>
    }
    triangle {
      < 0.900529, -0.646754, 3.118952>,
      < 0.900544, -0.671086, 3.088932>,
      < 0.502967, -0.671322, 3.088932>
    }
    triangle {
      < 0.900529, -0.646754, 3.118952>,
      < 0.502967, -0.671322, 3.088932>,
      < 0.504787, -0.655350, 3.108635>
    }
    triangle {
      < -0.180059, -0.655756, 3.108635>,
      < -0.180049, -0.671727, 3.088932>,
      < -0.271025, -0.671781, 3.088932>
    }
    triangle {
      < -0.180047, -0.677159, 3.086167>,
      < 0.504269, -0.676753, 3.086167>,
      < 0.900564, -0.705525, 3.071401>
    }
    triangle {
      < 0.504269, -0.676753, 3.086167>,
      < 0.502967, -0.671322, 3.088932>,
      < 0.900544, -0.671086, 3.088932>
    }
    triangle {
      < 0.504269, -0.676753, 3.086167>,
      < 0.900544, -0.671086, 3.088932>,
      < 0.900564, -0.705525, 3.071401>
    }
    triangle {
      < -0.180047, -0.677159, 3.086167>,
      < 0.900564, -0.705525, 3.071401>,
      < -0.271022, -0.677213, 3.086167>
    }
    triangle {
      < -0.180047, -0.677159, 3.086167>,
      < -0.271022, -0.677213, 3.086167>,
      < -0.180049, -0.671727, 3.088932>
    }
    triangle {
      < 0.900564, -0.705525, 3.071401>,
      < -0.487627, -0.706348, 3.071401>,
      < -0.463115, -0.677326, 3.086167>
    }
    triangle {
      < 0.900564, -0.705525, 3.071401>,
      < -0.463115, -0.677326, 3.086167>,
      < -0.271022, -0.677213, 3.086167>
    }
    triangle {
      < -0.487627, -0.706348, 3.071401>,
      < -0.487648, -0.671909, 3.088932>,
      < -0.463117, -0.671895, 3.088932>
    }
    triangle {
      < -0.487627, -0.706348, 3.071401>,
      < -0.463117, -0.671895, 3.088932>,
      < -0.463115, -0.677326, 3.086167>
    }
    triangle {
      < -0.271022, -0.677213, 3.086167>,
      < -0.271025, -0.671781, 3.088932>,
      < -0.180049, -0.671727, 3.088932>
    }
    triangle {
      < 0.900608, -0.780190, 3.083247>,
      < 0.504083, -0.783119, 3.085943>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < 0.900608, -0.780190, 3.083247>,
      < 0.900625, -0.807510, 3.110577>,
      < 0.504096, -0.805052, 3.107881>
    }
    triangle {
      < 0.900608, -0.780190, 3.083247>,
      < 0.504096, -0.805052, 3.107881>,
      < 0.504083, -0.783119, 3.085943>
    }
    triangle {
      < 0.900625, -0.807510, 3.110577>,
      < -0.179970, -0.805458, 3.107881>,
      < 0.504096, -0.805052, 3.107881>
    }
    triangle {
      < 0.900625, -0.807510, 3.110577>,
      < -0.270946, -0.805511, 3.107881>,
      < -0.179970, -0.805458, 3.107881>
    }
    triangle {
      < 0.504083, -0.783119, 3.085943>,
      < -0.179984, -0.783525, 3.085943>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < -0.179984, -0.783525, 3.085943>,
      < -0.270959, -0.783579, 3.085943>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < -0.179984, -0.783525, 3.085943>,
      < -0.179970, -0.805458, 3.107881>,
      < -0.270959, -0.783579, 3.085943>
    }
    triangle {
      < -0.179970, -0.805458, 3.107881>,
      < -0.270946, -0.805511, 3.107881>,
      < -0.270959, -0.783579, 3.085943>
    }
    triangle {
      < 0.900625, -0.807510, 3.110577>,
      < -0.487567, -0.808333, 3.110577>,
      < -0.463038, -0.805625, 3.107881>
    }
    triangle {
      < 0.900625, -0.807510, 3.110577>,
      < -0.463038, -0.805625, 3.107881>,
      < -0.270946, -0.805511, 3.107881>
    }
    triangle {
      < -0.270959, -0.783579, 3.085943>,
      < -0.463052, -0.783693, 3.085943>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < -0.463052, -0.783693, 3.085943>,
      < -0.463038, -0.805625, 3.107881>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < -0.463038, -0.805625, 3.107881>,
      < -0.487567, -0.808333, 3.110577>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < -0.270946, -0.805254, 3.214248>,
      < -0.463038, -0.805368, 3.214248>,
      < -0.487561, -0.820158, 3.185244>
    }
    triangle {
      < -0.463038, -0.805368, 3.214248>,
      < -0.463040, -0.802603, 3.219678>,
      < -0.487570, -0.802617, 3.219678>
    }
    triangle {
      < -0.463038, -0.805368, 3.214248>,
      < -0.487570, -0.802617, 3.219678>,
      < -0.487561, -0.820158, 3.185244>
    }
    triangle {
      < -0.270946, -0.805254, 3.214248>,
      < -0.487561, -0.820158, 3.185244>,
      < -0.179970, -0.805201, 3.214248>
    }
    triangle {
      < -0.270946, -0.805254, 3.214248>,
      < -0.179970, -0.805201, 3.214248>,
      < -0.270948, -0.802489, 3.219678>
    }
    triangle {
      < -0.487561, -0.820158, 3.185244>,
      < 0.900632, -0.819335, 3.185245>,
      < 0.504345, -0.804795, 3.214248>
    }
    triangle {
      < -0.487561, -0.820158, 3.185244>,
      < 0.504345, -0.804795, 3.214248>,
      < -0.179970, -0.805201, 3.214248>
    }
    triangle {
      < 0.900632, -0.819335, 3.185245>,
      < 0.900621, -0.801794, 3.219678>,
      < 0.503044, -0.802030, 3.219678>
    }
    triangle {
      < 0.900632, -0.819335, 3.185245>,
      < 0.503044, -0.802030, 3.219678>,
      < 0.504345, -0.804795, 3.214248>
    }
    triangle {
      < -0.179970, -0.805201, 3.214248>,
      < -0.179972, -0.802435, 3.219678>,
      < -0.270948, -0.802489, 3.219678>
    }
    triangle {
      < -0.179984, -0.782726, 3.235643>,
      < 0.504862, -0.782320, 3.235643>,
      < 0.900604, -0.771767, 3.244003>
    }
    triangle {
      < 0.504862, -0.782320, 3.235643>,
      < 0.503044, -0.802030, 3.219678>,
      < 0.900621, -0.801794, 3.219678>
    }
    triangle {
      < 0.504862, -0.782320, 3.235643>,
      < 0.900621, -0.801794, 3.219678>,
      < 0.900604, -0.771767, 3.244003>
    }
    triangle {
      < -0.179984, -0.782726, 3.235643>,
      < 0.900604, -0.771767, 3.244003>,
      < -0.270959, -0.782780, 3.235643>
    }
    triangle {
      < -0.179984, -0.782726, 3.235643>,
      < -0.270959, -0.782780, 3.235643>,
      < -0.179972, -0.802435, 3.219678>
    }
    triangle {
      < 0.900604, -0.771767, 3.244003>,
      < -0.487588, -0.772589, 3.244002>,
      < -0.463052, -0.782894, 3.235643>
    }
    triangle {
      < 0.900604, -0.771767, 3.244003>,
      < -0.463052, -0.782894, 3.235643>,
      < -0.270959, -0.782780, 3.235643>
    }
    triangle {
      < -0.487588, -0.772589, 3.244002>,
      < -0.487570, -0.802617, 3.219678>,
      < -0.463040, -0.802603, 3.219678>
    }
    triangle {
      < -0.487588, -0.772589, 3.244002>,
      < -0.463040, -0.802603, 3.219678>,
      < -0.463052, -0.782894, 3.235643>
    }
    triangle {
      < -0.270959, -0.782780, 3.235643>,
      < -0.270948, -0.802489, 3.219678>,
      < -0.179972, -0.802435, 3.219678>
    }
    triangle {
      < -0.271021, -0.677761, 3.235518>,
      < -0.463114, -0.677874, 3.235518>,
      < -0.487633, -0.697095, 3.247980>
    }
    triangle {
      < -0.463114, -0.677874, 3.235518>,
      < -0.463122, -0.664663, 3.226947>,
      < -0.487652, -0.664678, 3.226947>
    }
    triangle {
      < -0.463114, -0.677874, 3.235518>,
      < -0.487652, -0.664678, 3.226947>,
      < -0.487633, -0.697095, 3.247980>
    }
    triangle {
      < -0.271021, -0.677761, 3.235518>,
      < -0.487633, -0.697095, 3.247980>,
      < -0.180046, -0.677707, 3.235518>
    }
    triangle {
      < -0.271021, -0.677761, 3.235518>,
      < -0.180046, -0.677707, 3.235518>,
      < -0.271030, -0.664550, 3.226947>
    }
    triangle {
      < -0.487633, -0.697095, 3.247980>,
      < 0.900559, -0.696272, 3.247981>,
      < 0.504892, -0.677301, 3.235518>
    }
    triangle {
      < -0.487633, -0.697095, 3.247980>,
      < 0.504892, -0.677301, 3.235518>,
      < -0.180046, -0.677707, 3.235518>
    }
    triangle {
      < 0.900559, -0.696272, 3.247981>,
      < 0.900540, -0.663855, 3.226947>,
      < 0.502611, -0.664091, 3.226947>
    }
    triangle {
      < 0.900559, -0.696272, 3.247981>,
      < 0.502611, -0.664091, 3.226947>,
      < 0.504892, -0.677301, 3.235518>
    }
    triangle {
      < -0.180046, -0.677707, 3.235518>,
      < -0.180054, -0.664496, 3.226947>,
      < -0.271030, -0.664550, 3.226947>
    }
    triangle {
      < 0.900540, -0.663855, 3.226947>,
      < 0.900559, -0.696272, 3.247981>,
      < 1.123251, -0.702796, 3.230623>
    }
    triangle {
      < 0.900540, -0.663855, 3.226947>,
      < 1.123251, -0.702796, 3.230623>,
      < 1.123236, -0.676862, 3.213796>
    }
    triangle {
      < 0.900527, -0.642753, 3.194445>,
      < 0.900540, -0.663855, 3.226947>,
      < 1.123236, -0.676862, 3.213796>
    }
    triangle {
      < 0.900527, -0.642753, 3.194445>,
      < 1.123236, -0.676862, 3.213796>,
      < 1.123226, -0.659982, 3.187794>
    }
    triangle {
      < -0.499223, -0.660943, 3.187793>,
      < -0.499213, -0.677824, 3.213796>,
      < -0.487652, -0.664678, 3.226947>
    }
    triangle {
      < -0.499223, -0.660943, 3.187793>,
      < -0.487652, -0.664678, 3.226947>,
      < -0.487665, -0.643576, 3.194444>
    }
    triangle {
      < -0.499213, -0.677824, 3.213796>,
      < -0.499198, -0.703758, 3.230623>,
      < -0.487633, -0.697095, 3.247980>
    }
    triangle {
      < -0.499213, -0.677824, 3.213796>,
      < -0.487633, -0.697095, 3.247980>,
      < -0.487652, -0.664678, 3.226947>
    }
    triangle {
      < -0.487633, -0.697095, 3.247980>,
      < -0.487611, -0.735266, 3.254013>,
      < 0.900581, -0.734443, 3.254014>
    }
    triangle {
      < -0.487633, -0.697095, 3.247980>,
      < 0.900581, -0.734443, 3.254014>,
      < 0.900559, -0.696272, 3.247981>
    }
    triangle {
      < -0.499198, -0.703758, 3.230623>,
      < -0.499180, -0.734294, 3.235448>,
      < -0.487611, -0.735266, 3.254013>
    }
    triangle {
      < -0.499198, -0.703758, 3.230623>,
      < -0.487611, -0.735266, 3.254013>,
      < -0.487633, -0.697095, 3.247980>
    }
    triangle {
      < 0.900559, -0.696272, 3.247981>,
      < 0.900581, -0.734443, 3.254014>,
      < 1.123270, -0.733332, 3.235449>
    }
    triangle {
      < 0.900559, -0.696272, 3.247981>,
      < 1.123270, -0.733332, 3.235449>,
      < 1.123251, -0.702796, 3.230623>
    }
    triangle {
      < -0.487669, -0.637554, 3.156274>,
      < -0.487665, -0.643576, 3.194444>,
      < 0.900527, -0.642753, 3.194445>
    }
    triangle {
      < -0.487669, -0.637554, 3.156274>,
      < 0.900527, -0.642753, 3.194445>,
      < 0.900524, -0.636732, 3.156274>
    }
    triangle {
      < 0.900524, -0.636732, 3.156274>,
      < 0.900527, -0.642753, 3.194445>,
      < 1.123226, -0.659982, 3.187794>
    }
    triangle {
      < 0.900524, -0.636732, 3.156274>,
      < 1.123226, -0.659982, 3.187794>,
      < 1.123223, -0.655163, 3.157258>
    }
    triangle {
      < -0.499226, -0.656125, 3.157257>,
      < -0.499223, -0.660943, 3.187793>,
      < -0.487665, -0.643576, 3.194444>
    }
    triangle {
      < -0.499226, -0.656125, 3.157257>,
      < -0.487665, -0.643576, 3.194444>,
      < -0.487669, -0.637554, 3.156274>
    }
    triangle {
      < 1.123226, -0.659982, 3.187794>,
      < 1.123236, -0.676862, 3.213796>,
      < 1.221575, -0.689944, 3.200645>
    }
    triangle {
      < 1.123226, -0.659982, 3.187794>,
      < 1.221575, -0.689944, 3.200645>,
      < 1.221567, -0.677282, 3.181144>
    }
    triangle {
      < -0.415338, -0.685693, 3.178293>,
      < -0.415332, -0.696545, 3.195009>,
      < -0.499213, -0.677824, 3.213796>
    }
    triangle {
      < -0.415338, -0.685693, 3.178293>,
      < -0.499213, -0.677824, 3.213796>,
      < -0.499223, -0.660943, 3.187793>
    }
    triangle {
      < 1.123236, -0.676862, 3.213796>,
      < 1.123251, -0.702796, 3.230623>,
      < 1.221586, -0.709394, 3.213265>
    }
    triangle {
      < 1.123236, -0.676862, 3.213796>,
      < 1.221586, -0.709394, 3.213265>,
      < 1.221575, -0.689944, 3.200645>
    }
    triangle {
      < -0.415332, -0.696545, 3.195009>,
      < -0.415322, -0.713217, 3.205826>,
      < -0.499198, -0.703758, 3.230623>
    }
    triangle {
      < -0.415332, -0.696545, 3.195009>,
      < -0.499198, -0.703758, 3.230623>,
      < -0.499213, -0.677824, 3.213796>
    }
    triangle {
      < 1.123251, -0.702796, 3.230623>,
      < 1.123270, -0.733332, 3.235449>,
      < 1.221600, -0.732296, 3.216885>
    }
    triangle {
      < 1.123251, -0.702796, 3.230623>,
      < 1.221600, -0.732296, 3.216885>,
      < 1.221586, -0.709394, 3.213265>
    }
    triangle {
      < -0.415322, -0.713217, 3.205826>,
      < -0.415310, -0.732847, 3.208929>,
      < -0.499180, -0.734294, 3.235448>
    }
    triangle {
      < -0.415322, -0.713217, 3.205826>,
      < -0.499180, -0.734294, 3.235448>,
      < -0.499198, -0.703758, 3.230623>
    }
    triangle {
      < -0.415340, -0.682595, 3.158662>,
      < -0.415338, -0.685693, 3.178293>,
      < -0.499223, -0.660943, 3.187793>
    }
    triangle {
      < -0.415340, -0.682595, 3.158662>,
      < -0.499223, -0.660943, 3.187793>,
      < -0.499226, -0.656125, 3.157257>
    }
    triangle {
      < 1.123223, -0.655163, 3.157258>,
      < 1.123226, -0.659982, 3.187794>,
      < 1.221567, -0.677282, 3.181144>
    }
    triangle {
      < 1.123223, -0.655163, 3.157258>,
      < 1.221567, -0.677282, 3.181144>,
      < 1.221565, -0.673669, 3.158241>
    }
    triangle {
      < 0.900581, -0.734443, 3.254014>,
      < 0.900604, -0.771767, 3.244003>,
      < 1.123287, -0.763191, 3.227440>
    }
    triangle {
      < 0.900581, -0.734443, 3.254014>,
      < 1.123287, -0.763191, 3.227440>,
      < 1.123270, -0.733332, 3.235449>
    }
    triangle {
      < -0.499180, -0.734294, 3.235448>,
      < -0.499162, -0.764153, 3.227439>,
      < -0.487588, -0.772589, 3.244002>
    }
    triangle {
      < -0.499180, -0.734294, 3.235448>,
      < -0.487588, -0.772589, 3.244002>,
      < -0.487611, -0.735266, 3.254013>
    }
    triangle {
      < -0.487611, -0.735266, 3.254013>,
      < -0.487588, -0.772589, 3.244002>,
      < 0.900604, -0.771767, 3.244003>
    }
    triangle {
      < -0.487611, -0.735266, 3.254013>,
      < 0.900604, -0.771767, 3.244003>,
      < 0.900581, -0.734443, 3.254014>
    }
    triangle {
      < 0.900529, -0.646754, 3.118952>,
      < 0.900524, -0.636732, 3.156274>,
      < 1.123223, -0.655163, 3.157258>
    }
    triangle {
      < 0.900529, -0.646754, 3.118952>,
      < 1.123223, -0.655163, 3.157258>,
      < 1.123228, -0.663181, 3.127400>
    }
    triangle {
      < -0.487662, -0.647576, 3.118952>,
      < -0.487669, -0.637554, 3.156274>,
      < 0.900524, -0.636732, 3.156274>
    }
    triangle {
      < -0.487662, -0.647576, 3.118952>,
      < 0.900524, -0.636732, 3.156274>,
      < 0.900529, -0.646754, 3.118952>
    }
    triangle {
      < -0.499221, -0.664144, 3.127400>,
      < -0.499226, -0.656125, 3.157257>,
      < -0.487669, -0.637554, 3.156274>
    }
    triangle {
      < -0.499221, -0.664144, 3.127400>,
      < -0.487669, -0.637554, 3.156274>,
      < -0.487662, -0.647576, 3.118952>
    }
    triangle {
      < 1.221567, -0.677282, 3.181144>,
      < 1.221575, -0.689944, 3.200645>,
      < 1.276532, -0.704927, 3.185615>
    }
    triangle {
      < 1.221567, -0.677282, 3.181144>,
      < 1.276532, -0.704927, 3.185615>,
      < 1.276528, -0.697089, 3.173543>
    }
    triangle {
      < 1.221575, -0.689944, 3.200645>,
      < 1.221586, -0.709394, 3.213265>,
      < 1.276539, -0.716968, 3.193428>
    }
    triangle {
      < 1.221575, -0.689944, 3.200645>,
      < 1.276539, -0.716968, 3.193428>,
      < 1.276532, -0.704927, 3.185615>
    }
    triangle {
      < 1.221586, -0.709394, 3.213265>,
      < 1.221600, -0.732296, 3.216885>,
      < 1.276547, -0.731145, 3.195668>
    }
    triangle {
      < 1.221586, -0.709394, 3.213265>,
      < 1.276547, -0.731145, 3.195668>,
      < 1.276539, -0.716968, 3.193428>
    }
    triangle {
      < 1.221565, -0.673669, 3.158241>,
      < 1.221567, -0.677282, 3.181144>,
      < 1.276528, -0.697089, 3.173543>
    }
    triangle {
      < 1.221565, -0.673669, 3.158241>,
      < 1.276528, -0.697089, 3.173543>,
      < 1.276526, -0.694853, 3.159365>
    }
    triangle {
      < 1.123270, -0.733332, 3.235449>,
      < 1.123287, -0.763191, 3.227440>,
      < 1.221613, -0.754691, 3.210878>
    }
    triangle {
      < 1.123270, -0.733332, 3.235449>,
      < 1.221613, -0.754691, 3.210878>,
      < 1.221600, -0.732296, 3.216885>
    }
    triangle {
      < -0.415310, -0.732847, 3.208929>,
      < -0.415299, -0.752042, 3.203780>,
      < -0.499162, -0.764153, 3.227439>
    }
    triangle {
      < -0.415310, -0.732847, 3.208929>,
      < -0.499162, -0.764153, 3.227439>,
      < -0.499180, -0.734294, 3.235448>
    }
    triangle {
      < 1.123228, -0.663181, 3.127400>,
      < 1.123223, -0.655163, 3.157258>,
      < 1.221565, -0.673669, 3.158241>
    }
    triangle {
      < 1.123228, -0.663181, 3.127400>,
      < 1.221565, -0.673669, 3.158241>,
      < 1.221568, -0.679683, 3.135848>
    }
    triangle {
      < -0.415337, -0.687750, 3.139468>,
      < -0.415340, -0.682595, 3.158662>,
      < -0.499226, -0.656125, 3.157257>
    }
    triangle {
      < -0.415337, -0.687750, 3.139468>,
      < -0.499226, -0.656125, 3.157257>,
      < -0.499221, -0.664144, 3.127400>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415332, -0.696545, 3.195009>,
      < -0.415338, -0.685693, 3.178293>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415322, -0.713217, 3.205826>,
      < -0.415332, -0.696545, 3.195009>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415310, -0.732847, 3.208929>,
      < -0.415322, -0.713217, 3.205826>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415338, -0.685693, 3.178293>,
      < -0.415340, -0.682595, 3.158662>
    }
    triangle {
      < 1.221600, -0.732296, 3.216885>,
      < 1.221613, -0.754691, 3.210878>,
      < 1.276556, -0.745009, 3.191951>
    }
    triangle {
      < 1.221600, -0.732296, 3.216885>,
      < 1.276556, -0.745009, 3.191951>,
      < 1.276547, -0.731145, 3.195668>
    }
    triangle {
      < 1.221568, -0.679683, 3.135848>,
      < 1.221565, -0.673669, 3.158241>,
      < 1.276526, -0.694853, 3.159365>
    }
    triangle {
      < 1.221568, -0.679683, 3.135848>,
      < 1.276526, -0.694853, 3.159365>,
      < 1.276528, -0.698575, 3.145503>
    }
    triangle {
      < 1.276532, -0.704927, 3.185615>,
      < 1.276539, -0.716968, 3.193428>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.276528, -0.697089, 3.173543>,
      < 1.276532, -0.704927, 3.185615>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415299, -0.752042, 3.203780>,
      < -0.415310, -0.732847, 3.208929>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415340, -0.682595, 3.158662>,
      < -0.415337, -0.687750, 3.139468>
    }
    triangle {
      < 1.276539, -0.716968, 3.193428>,
      < 1.276547, -0.731145, 3.195668>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.276526, -0.694853, 3.159365>,
      < 1.276528, -0.697089, 3.173543>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < -0.499162, -0.764153, 3.227439>,
      < -0.499148, -0.788176, 3.207981>,
      < -0.487570, -0.802617, 3.219678>
    }
    triangle {
      < -0.499162, -0.764153, 3.227439>,
      < -0.487570, -0.802617, 3.219678>,
      < -0.487588, -0.772589, 3.244002>
    }
    triangle {
      < 0.900604, -0.771767, 3.244003>,
      < 0.900621, -0.801794, 3.219678>,
      < 1.123302, -0.787214, 3.207981>
    }
    triangle {
      < 0.900604, -0.771767, 3.244003>,
      < 1.123302, -0.787214, 3.207981>,
      < 1.123287, -0.763191, 3.227440>
    }
    triangle {
      < -0.499209, -0.683610, 3.103384>,
      < -0.499221, -0.664144, 3.127400>,
      < -0.487662, -0.647576, 3.118952>
    }
    triangle {
      < -0.499209, -0.683610, 3.103384>,
      < -0.487662, -0.647576, 3.118952>,
      < -0.487648, -0.671909, 3.088932>
    }
    triangle {
      < 0.900544, -0.671086, 3.088932>,
      < 0.900529, -0.646754, 3.118952>,
      < 1.123228, -0.663181, 3.127400>
    }
    triangle {
      < 0.900544, -0.671086, 3.088932>,
      < 1.123228, -0.663181, 3.127400>,
      < 1.123240, -0.682648, 3.103384>
    }
    triangle {
      < 1.276547, -0.731145, 3.195668>,
      < 1.276556, -0.745009, 3.191951>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.276528, -0.698575, 3.145503>,
      < 1.276526, -0.694853, 3.159365>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.123287, -0.763191, 3.227440>,
      < 1.123302, -0.787214, 3.207981>,
      < 1.221624, -0.772707, 3.196284>
    }
    triangle {
      < 1.123287, -0.763191, 3.227440>,
      < 1.221624, -0.772707, 3.196284>,
      < 1.221613, -0.754691, 3.210878>
    }
    triangle {
      < -0.415299, -0.752042, 3.203780>,
      < -0.415290, -0.767485, 3.191271>,
      < -0.499148, -0.788176, 3.207981>
    }
    triangle {
      < -0.415299, -0.752042, 3.203780>,
      < -0.499148, -0.788176, 3.207981>,
      < -0.499162, -0.764153, 3.227439>
    }
    triangle {
      < 1.123240, -0.682648, 3.103384>,
      < 1.123228, -0.663181, 3.127400>,
      < 1.221568, -0.679683, 3.135848>
    }
    triangle {
      < 1.123240, -0.682648, 3.103384>,
      < 1.221568, -0.679683, 3.135848>,
      < 1.221577, -0.694283, 3.117836>
    }
    triangle {
      < -0.415330, -0.700264, 3.124029>,
      < -0.415337, -0.687750, 3.139468>,
      < -0.499221, -0.664144, 3.127400>
    }
    triangle {
      < -0.415330, -0.700264, 3.124029>,
      < -0.499221, -0.664144, 3.127400>,
      < -0.499209, -0.683610, 3.103384>
    }
    triangle {
      < 1.221613, -0.754691, 3.210878>,
      < 1.221624, -0.772707, 3.196284>,
      < 1.276563, -0.756162, 3.182915>
    }
    triangle {
      < 1.221613, -0.754691, 3.210878>,
      < 1.276563, -0.756162, 3.182915>,
      < 1.276556, -0.745009, 3.191951>
    }
    triangle {
      < 1.221577, -0.694283, 3.117836>,
      < 1.221568, -0.679683, 3.135848>,
      < 1.276528, -0.698575, 3.145503>
    }
    triangle {
      < 1.221577, -0.694283, 3.117836>,
      < 1.276528, -0.698575, 3.145503>,
      < 1.276534, -0.707614, 3.134353>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415290, -0.767485, 3.191271>,
      < -0.415299, -0.752042, 3.203780>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415337, -0.687750, 3.139468>,
      < -0.415330, -0.700264, 3.124029>
    }
    triangle {
      < 1.276556, -0.745009, 3.191951>,
      < 1.276563, -0.756162, 3.182915>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.276534, -0.707614, 3.134353>,
      < 1.276528, -0.698575, 3.145503>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415330, -0.700264, 3.124029>,
      < -0.415319, -0.717975, 3.115015>
    }
    triangle {
      < 1.276563, -0.756162, 3.182915>,
      < 1.276566, -0.762677, 3.170126>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415319, -0.717975, 3.115015>,
      < -0.415308, -0.737823, 3.113980>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415297, -0.756375, 3.121106>,
      < -0.415288, -0.770425, 3.135161>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415308, -0.737823, 3.113980>,
      < -0.415297, -0.756375, 3.121106>
    }
    triangle {
      < 1.276564, -0.758285, 3.142392>,
      < 1.276557, -0.748137, 3.132241>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.276541, -0.720405, 3.127841>,
      < 1.276534, -0.707614, 3.134353>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.276549, -0.734739, 3.127095>,
      < 1.276541, -0.720405, 3.127841>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415284, -0.776506, 3.173562>,
      < -0.415290, -0.767485, 3.191271>
    }
    triangle {
      < 1.276566, -0.762677, 3.170126>,
      < 1.276566, -0.763428, 3.155792>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < 1.276557, -0.748137, 3.132241>,
      < 1.276549, -0.734739, 3.127095>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415284, -0.777546, 3.153716>,
      < -0.415284, -0.776506, 3.173562>
    }
    triangle {
      < 1.276566, -0.763428, 3.155792>,
      < 1.276564, -0.758285, 3.142392>,
      < 1.322820, -0.729301, 3.161193>
    }
    triangle {
      < -0.397960, -0.730321, 3.161192>,
      < -0.415288, -0.770425, 3.135161>,
      < -0.415284, -0.777546, 3.153716>
    }
    triangle {
      < 1.221624, -0.772707, 3.196284>,
      < 1.221629, -0.783231, 3.175624>,
      < 1.276566, -0.762677, 3.170126>
    }
    triangle {
      < 1.221624, -0.772707, 3.196284>,
      < 1.276566, -0.762677, 3.170126>,
      < 1.276563, -0.756162, 3.182915>
    }
    triangle {
      < 1.221590, -0.714945, 3.107318>,
      < 1.221577, -0.694283, 3.117836>,
      < 1.276534, -0.707614, 3.134353>
    }
    triangle {
      < 1.221590, -0.714945, 3.107318>,
      < 1.276534, -0.707614, 3.134353>,
      < 1.276541, -0.720405, 3.127841>
    }
    triangle {
      < -0.415290, -0.767485, 3.191271>,
      < -0.415284, -0.776506, 3.173562>,
      < -0.499139, -0.802208, 3.180434>
    }
    triangle {
      < -0.415290, -0.767485, 3.191271>,
      < -0.499139, -0.802208, 3.180434>,
      < -0.499148, -0.788176, 3.207981>
    }
    triangle {
      < -0.415319, -0.717975, 3.115015>,
      < -0.415330, -0.700264, 3.124029>,
      < -0.499209, -0.683610, 3.103384>
    }
    triangle {
      < -0.415319, -0.717975, 3.115015>,
      < -0.499209, -0.683610, 3.103384>,
      < -0.499193, -0.711160, 3.089359>
    }
    triangle {
      < 1.123302, -0.787214, 3.207981>,
      < 1.123310, -0.801245, 3.180434>,
      < 1.221629, -0.783231, 3.175624>
    }
    triangle {
      < 1.123302, -0.787214, 3.207981>,
      < 1.221629, -0.783231, 3.175624>,
      < 1.221624, -0.772707, 3.196284>
    }
    triangle {
      < 1.123256, -0.710198, 3.089360>,
      < 1.123240, -0.682648, 3.103384>,
      < 1.221577, -0.694283, 3.117836>
    }
    triangle {
      < 1.123256, -0.710198, 3.089360>,
      < 1.221577, -0.694283, 3.117836>,
      < 1.221590, -0.714945, 3.107318>
    }
    triangle {
      < -0.499148, -0.788176, 3.207981>,
      < -0.499139, -0.802208, 3.180434>,
      < -0.487561, -0.820158, 3.185244>
    }
    triangle {
      < -0.499148, -0.788176, 3.207981>,
      < -0.487561, -0.820158, 3.185244>,
      < -0.487570, -0.802617, 3.219678>
    }
    triangle {
      < 0.900621, -0.801794, 3.219678>,
      < 0.900632, -0.819335, 3.185245>,
      < 1.123310, -0.801245, 3.180434>
    }
    triangle {
      < 0.900621, -0.801794, 3.219678>,
      < 1.123310, -0.801245, 3.180434>,
      < 1.123302, -0.787214, 3.207981>
    }
    triangle {
      < 0.900564, -0.705525, 3.071401>,
      < 0.900544, -0.671086, 3.088932>,
      < 1.123240, -0.682648, 3.103384>
    }
    triangle {
      < 0.900564, -0.705525, 3.071401>,
      < 1.123240, -0.682648, 3.103384>,
      < 1.123256, -0.710198, 3.089360>
    }
    triangle {
      < -0.499193, -0.711160, 3.089359>,
      < -0.499209, -0.683610, 3.103384>,
      < -0.487648, -0.671909, 3.088932>
    }
    triangle {
      < -0.499193, -0.711160, 3.089359>,
      < -0.487648, -0.671909, 3.088932>,
      < -0.487627, -0.706348, 3.071401>
    }
    triangle {
      < 1.221629, -0.783231, 3.175624>,
      < 1.221630, -0.784445, 3.152470>,
      < 1.276566, -0.763428, 3.155792>
    }
    triangle {
      < 1.221629, -0.783231, 3.175624>,
      < 1.276566, -0.763428, 3.155792>,
      < 1.276566, -0.762677, 3.170126>
    }
    triangle {
      < 1.221603, -0.738100, 3.106111>,
      < 1.221590, -0.714945, 3.107318>,
      < 1.276541, -0.720405, 3.127841>
    }
    triangle {
      < 1.221603, -0.738100, 3.106111>,
      < 1.276541, -0.720405, 3.127841>,
      < 1.276549, -0.734739, 3.127095>
    }
    triangle {
      < -0.415284, -0.776506, 3.173562>,
      < -0.415284, -0.777546, 3.153716>,
      < -0.499138, -0.803826, 3.149562>
    }
    triangle {
      < -0.415284, -0.776506, 3.173562>,
      < -0.499138, -0.803826, 3.149562>,
      < -0.499139, -0.802208, 3.180434>
    }
    triangle {
      < -0.415308, -0.737823, 3.113980>,
      < -0.415319, -0.717975, 3.115015>,
      < -0.499193, -0.711160, 3.089359>
    }
    triangle {
      < -0.415308, -0.737823, 3.113980>,
      < -0.499193, -0.711160, 3.089359>,
      < -0.499175, -0.742033, 3.087751>
    }
    triangle {
      < 1.123310, -0.801245, 3.180434>,
      < 1.123311, -0.802863, 3.149563>,
      < 1.221630, -0.784445, 3.152470>
    }
    triangle {
      < 1.123310, -0.801245, 3.180434>,
      < 1.221630, -0.784445, 3.152470>,
      < 1.221629, -0.783231, 3.175624>
    }
    triangle {
      < 1.221630, -0.784445, 3.152470>,
      < 1.221626, -0.776137, 3.130823>,
      < 1.276564, -0.758285, 3.142392>
    }
    triangle {
      < 1.221630, -0.784445, 3.152470>,
      < 1.276564, -0.758285, 3.142392>,
      < 1.276566, -0.763428, 3.155792>
    }
    triangle {
      < 1.123275, -0.741071, 3.087751>,
      < 1.123256, -0.710198, 3.089360>,
      < 1.221590, -0.714945, 3.107318>
    }
    triangle {
      < 1.123275, -0.741071, 3.087751>,
      < 1.221590, -0.714945, 3.107318>,
      < 1.221603, -0.738100, 3.106111>
    }
    triangle {
      < 1.221616, -0.759744, 3.114426>,
      < 1.221603, -0.738100, 3.106111>,
      < 1.276549, -0.734739, 3.127095>
    }
    triangle {
      < 1.221616, -0.759744, 3.114426>,
      < 1.276549, -0.734739, 3.127095>,
      < 1.276557, -0.748137, 3.132241>
    }
    triangle {
      < 1.221626, -0.776137, 3.130823>,
      < 1.221616, -0.759744, 3.114426>,
      < 1.276557, -0.748137, 3.132241>
    }
    triangle {
      < 1.221626, -0.776137, 3.130823>,
      < 1.276557, -0.748137, 3.132241>,
      < 1.276564, -0.758285, 3.142392>
    }
    triangle {
      < -0.499139, -0.802208, 3.180434>,
      < -0.499138, -0.803826, 3.149562>,
      < -0.487559, -0.822179, 3.146654>
    }
    triangle {
      < -0.499139, -0.802208, 3.180434>,
      < -0.487559, -0.822179, 3.146654>,
      < -0.487561, -0.820158, 3.185244>
    }
    triangle {
      < 0.900632, -0.819335, 3.185245>,
      < 0.900633, -0.821357, 3.146654>,
      < 1.123311, -0.802863, 3.149563>
    }
    triangle {
      < 0.900632, -0.819335, 3.185245>,
      < 1.123311, -0.802863, 3.149563>,
      < 1.123310, -0.801245, 3.180434>
    }
    triangle {
      < 0.900588, -0.744116, 3.069391>,
      < 0.900564, -0.705525, 3.071401>,
      < 1.123256, -0.710198, 3.089360>
    }
    triangle {
      < 0.900588, -0.744116, 3.069391>,
      < 1.123256, -0.710198, 3.089360>,
      < 1.123275, -0.741071, 3.087751>
    }
    triangle {
      < -0.499175, -0.742033, 3.087751>,
      < -0.499193, -0.711160, 3.089359>,
      < -0.487627, -0.706348, 3.071401>
    }
    triangle {
      < -0.499175, -0.742033, 3.087751>,
      < -0.487627, -0.706348, 3.071401>,
      < -0.487605, -0.744939, 3.069391>
    }
    triangle {
      < -0.415284, -0.777546, 3.153716>,
      < -0.415288, -0.770425, 3.135161>,
      < -0.499145, -0.792749, 3.120700>
    }
    triangle {
      < -0.415284, -0.777546, 3.153716>,
      < -0.499145, -0.792749, 3.120700>,
      < -0.499138, -0.803826, 3.149562>
    }
    triangle {
      < -0.415297, -0.756375, 3.121106>,
      < -0.415308, -0.737823, 3.113980>,
      < -0.499175, -0.742033, 3.087751>
    }
    triangle {
      < -0.415297, -0.756375, 3.121106>,
      < -0.499175, -0.742033, 3.087751>,
      < -0.499158, -0.770892, 3.098836>
    }
    triangle {
      < 1.123311, -0.802863, 3.149563>,
      < 1.123304, -0.791787, 3.120700>,
      < 1.221626, -0.776137, 3.130823>
    }
    triangle {
      < 1.123311, -0.802863, 3.149563>,
      < 1.221626, -0.776137, 3.130823>,
      < 1.221630, -0.784445, 3.152470>
    }
    triangle {
      < 1.123292, -0.769931, 3.098837>,
      < 1.123275, -0.741071, 3.087751>,
      < 1.221603, -0.738100, 3.106111>
    }
    triangle {
      < 1.123292, -0.769931, 3.098837>,
      < 1.221603, -0.738100, 3.106111>,
      < 1.221616, -0.759744, 3.114426>
    }
    triangle {
      < -0.487561, -0.820158, 3.185244>,
      < -0.487559, -0.822179, 3.146654>,
      < 0.900633, -0.821357, 3.146654>
    }
    triangle {
      < -0.487561, -0.820158, 3.185244>,
      < 0.900633, -0.821357, 3.146654>,
      < 0.900632, -0.819335, 3.185245>
    }
    triangle {
      < -0.487605, -0.744939, 3.069391>,
      < -0.487627, -0.706348, 3.071401>,
      < 0.900564, -0.705525, 3.071401>
    }
    triangle {
      < -0.487605, -0.744939, 3.069391>,
      < 0.900564, -0.705525, 3.071401>,
      < 0.900588, -0.744116, 3.069391>
    }
    triangle {
      < -0.415288, -0.770425, 3.135161>,
      < -0.415297, -0.756375, 3.121106>,
      < -0.499158, -0.770892, 3.098836>
    }
    triangle {
      < -0.415288, -0.770425, 3.135161>,
      < -0.499158, -0.770892, 3.098836>,
      < -0.499145, -0.792749, 3.120700>
    }
    triangle {
      < 1.123304, -0.791787, 3.120700>,
      < 1.123292, -0.769931, 3.098837>,
      < 1.221616, -0.759744, 3.114426>
    }
    triangle {
      < 1.123304, -0.791787, 3.120700>,
      < 1.221616, -0.759744, 3.114426>,
      < 1.221626, -0.776137, 3.130823>
    }
    triangle {
      < -0.499138, -0.803826, 3.149562>,
      < -0.499145, -0.792749, 3.120700>,
      < -0.487567, -0.808333, 3.110577>
    }
    triangle {
      < -0.499138, -0.803826, 3.149562>,
      < -0.487567, -0.808333, 3.110577>,
      < -0.487559, -0.822179, 3.146654>
    }
    triangle {
      < 0.900633, -0.821357, 3.146654>,
      < 0.900625, -0.807510, 3.110577>,
      < 1.123304, -0.791787, 3.120700>
    }
    triangle {
      < 0.900633, -0.821357, 3.146654>,
      < 1.123304, -0.791787, 3.120700>,
      < 1.123311, -0.802863, 3.149563>
    }
    triangle {
      < 0.900608, -0.780190, 3.083247>,
      < 0.900588, -0.744116, 3.069391>,
      < 1.123275, -0.741071, 3.087751>
    }
    triangle {
      < 0.900608, -0.780190, 3.083247>,
      < 1.123275, -0.741071, 3.087751>,
      < 1.123292, -0.769931, 3.098837>
    }
    triangle {
      < -0.499158, -0.770892, 3.098836>,
      < -0.499175, -0.742033, 3.087751>,
      < -0.487605, -0.744939, 3.069391>
    }
    triangle {
      < -0.499158, -0.770892, 3.098836>,
      < -0.487605, -0.744939, 3.069391>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < -0.499145, -0.792749, 3.120700>,
      < -0.499158, -0.770892, 3.098836>,
      < -0.487583, -0.781013, 3.083247>
    }
    triangle {
      < -0.499145, -0.792749, 3.120700>,
      < -0.487583, -0.781013, 3.083247>,
      < -0.487567, -0.808333, 3.110577>
    }
    triangle {
      < 0.900625, -0.807510, 3.110577>,
      < 0.900608, -0.780190, 3.083247>,
      < 1.123292, -0.769931, 3.098837>
    }
    triangle {
      < 0.900625, -0.807510, 3.110577>,
      < 1.123292, -0.769931, 3.098837>,
      < 1.123304, -0.791787, 3.120700>
    }
    triangle {
      < -0.487559, -0.822179, 3.146654>,
      < -0.487567, -0.808333, 3.110577>,
      < 0.900625, -0.807510, 3.110577>
    }
    triangle {
      < -0.487559, -0.822179, 3.146654>,
      < 0.900625, -0.807510, 3.110577>,
      < 0.900633, -0.821357, 3.146654>
    }
    triangle {
      < -0.487583, -0.781013, 3.083247>,
      < -0.487605, -0.744939, 3.069391>,
      < 0.900588, -0.744116, 3.069391>
    }
    triangle {
      < -0.487583, -0.781013, 3.083247>,
      < 0.900588, -0.744116, 3.069391>,
      < 0.900608, -0.780190, 3.083247>
    }
    triangle {
      < -0.290927, -0.511850, 2.760680>,
      < -0.254734, -0.677374, 2.599574>,
      < -0.254742, -0.664163, 2.591002>
    }
    triangle {
      < -0.290927, -0.511850, 2.760680>,
      < -0.254742, -0.664163, 2.591002>,
      < -0.290938, -0.494124, 2.742929>
    }
    triangle {
      < -0.254742, -0.664163, 2.591002>,
      < -0.254748, -0.655468, 2.577610>,
      < -0.290938, -0.494124, 2.742929>
    }
    triangle {
      < -0.446280, -0.494216, 2.742929>,
      < -0.446840, -0.655581, 2.577610>,
      < -0.446835, -0.664276, 2.591002>
    }
    triangle {
      < -0.446280, -0.494216, 2.742929>,
      < -0.446835, -0.664276, 2.591002>,
      < -0.446269, -0.511942, 2.760680>
    }
    triangle {
      < -0.446835, -0.664276, 2.591002>,
      < -0.446827, -0.677487, 2.599574>,
      < -0.446269, -0.511942, 2.760680>
    }
    triangle {
      < -0.290938, -0.494124, 2.742929>,
      < -0.254748, -0.655468, 2.577610>,
      < -0.446840, -0.655581, 2.577610>
    }
    triangle {
      < -0.290938, -0.494124, 2.742929>,
      < -0.446840, -0.655581, 2.577610>,
      < -0.446280, -0.494216, 2.742929>
    }
    triangle {
      < -0.446269, -0.511942, 2.760680>,
      < -0.446827, -0.677487, 2.599574>,
      < -0.254734, -0.677374, 2.599574>
    }
    triangle {
      < -0.446269, -0.511942, 2.760680>,
      < -0.254734, -0.677374, 2.599574>,
      < -0.290927, -0.511850, 2.760680>
    }
    triangle {
      < 0.488413, -0.643365, 2.633091>,
      < 0.521178, -0.676914, 2.599574>,
      < 0.518899, -0.663704, 2.591002>
    }
    triangle {
      < 0.488413, -0.643365, 2.633091>,
      < 0.518899, -0.663704, 2.591002>,
      < 0.488400, -0.621447, 2.611139>
    }
    triangle {
      < 0.518899, -0.663704, 2.591002>,
      < 0.521177, -0.655008, 2.577610>,
      < 0.488400, -0.621447, 2.611139>
    }
    triangle {
      < -0.217368, -0.494080, 2.742929>,
      < -0.163773, -0.655413, 2.577610>,
      < -0.163768, -0.664109, 2.591002>
    }
    triangle {
      < -0.217368, -0.494080, 2.742929>,
      < -0.163768, -0.664109, 2.591002>,
      < -0.217357, -0.511806, 2.760680>
    }
    triangle {
      < -0.163768, -0.664109, 2.591002>,
      < -0.163759, -0.677320, 2.599574>,
      < -0.217357, -0.511806, 2.760680>
    }
    triangle {
      < 0.488400, -0.621447, 2.611139>,
      < 0.521177, -0.655008, 2.577610>,
      < -0.163773, -0.655413, 2.577610>
    }
    triangle {
      < 0.488400, -0.621447, 2.611139>,
      < -0.163773, -0.655413, 2.577610>,
      < -0.217368, -0.494080, 2.742929>
    }
    triangle {
      < -0.217357, -0.511806, 2.760680>,
      < -0.163759, -0.677320, 2.599574>,
      < 0.521178, -0.676914, 2.599574>
    }
    triangle {
      < -0.217357, -0.511806, 2.760680>,
      < 0.521178, -0.676914, 2.599574>,
      < 0.488413, -0.643365, 2.633091>
    }
    triangle {
      < -0.290938, -0.494382, 2.307286>,
      < -0.254748, -0.655424, 2.472690>,
      < -0.254738, -0.671395, 2.452986>
    }
    triangle {
      < -0.290938, -0.494382, 2.307286>,
      < -0.254738, -0.671395, 2.452986>,
      < -0.290927, -0.512129, 2.289555>
    }
    triangle {
      < -0.254738, -0.671395, 2.452986>,
      < -0.254735, -0.676826, 2.450222>,
      < -0.290927, -0.512129, 2.289555>
    }
    triangle {
      < -0.446269, -0.512221, 2.289555>,
      < -0.446828, -0.676940, 2.450222>,
      < -0.446830, -0.671508, 2.452986>
    }
    triangle {
      < -0.446269, -0.512221, 2.289555>,
      < -0.446830, -0.671508, 2.452986>,
      < -0.446280, -0.494474, 2.307286>
    }
    triangle {
      < -0.446830, -0.671508, 2.452986>,
      < -0.446840, -0.655537, 2.472690>,
      < -0.446280, -0.494474, 2.307286>
    }
    triangle {
      < -0.290927, -0.512129, 2.289555>,
      < -0.254735, -0.676826, 2.450222>,
      < -0.446828, -0.676940, 2.450222>
    }
    triangle {
      < -0.290927, -0.512129, 2.289555>,
      < -0.446828, -0.676940, 2.450222>,
      < -0.446269, -0.512221, 2.289555>
    }
    triangle {
      < -0.446280, -0.494474, 2.307286>,
      < -0.446840, -0.655537, 2.472690>,
      < -0.254748, -0.655424, 2.472690>
    }
    triangle {
      < -0.446280, -0.494474, 2.307286>,
      < -0.254748, -0.655424, 2.472690>,
      < -0.290938, -0.494382, 2.307286>
    }
    triangle {
      < 0.488400, -0.621549, 2.439227>,
      < 0.521074, -0.654964, 2.472690>,
      < 0.519253, -0.670936, 2.452986>
    }
    triangle {
      < 0.488400, -0.621549, 2.439227>,
      < 0.519253, -0.670936, 2.452986>,
      < 0.488413, -0.643494, 2.417300>
    }
    triangle {
      < 0.519253, -0.670936, 2.452986>,
      < 0.520556, -0.676366, 2.450223>,
      < 0.488413, -0.643494, 2.417300>
    }
    triangle {
      < -0.217357, -0.512085, 2.289555>,
      < -0.163760, -0.676772, 2.450222>,
      < -0.163763, -0.671341, 2.452986>
    }
    triangle {
      < -0.217357, -0.512085, 2.289555>,
      < -0.163763, -0.671341, 2.452986>,
      < -0.217368, -0.494338, 2.307286>
    }
    triangle {
      < -0.163763, -0.671341, 2.452986>,
      < -0.163773, -0.655370, 2.472690>,
      < -0.217368, -0.494338, 2.307286>
    }
    triangle {
      < 0.488413, -0.643494, 2.417300>,
      < 0.520556, -0.676366, 2.450223>,
      < -0.163760, -0.676772, 2.450222>
    }
    triangle {
      < 0.488413, -0.643494, 2.417300>,
      < -0.163760, -0.676772, 2.450222>,
      < -0.217357, -0.512085, 2.289555>
    }
    triangle {
      < -0.217368, -0.494338, 2.307286>,
      < -0.163773, -0.655370, 2.472690>,
      < 0.521074, -0.654964, 2.472690>
    }
    triangle {
      < -0.217368, -0.494338, 2.307286>,
      < 0.521074, -0.654964, 2.472690>,
      < 0.488400, -0.621549, 2.439227>
    }
    triangle {
      < -0.290668, -0.947772, 2.289683>,
      < -0.254672, -0.783192, 2.449998>,
      < -0.254659, -0.805124, 2.471937>
    }
    triangle {
      < -0.290668, -0.947772, 2.289683>,
      < -0.254659, -0.805124, 2.471937>,
      < -0.290659, -0.965508, 2.307425>
    }
    triangle {
      < -0.446001, -0.965600, 2.307425>,
      < -0.446751, -0.805238, 2.471937>,
      < -0.446764, -0.783305, 2.449997>
    }
    triangle {
      < -0.446001, -0.965600, 2.307425>,
      < -0.446764, -0.783305, 2.449997>,
      < -0.446011, -0.947864, 2.289683>
    }
    triangle {
      < -0.290659, -0.965508, 2.307425>,
      < -0.254659, -0.805124, 2.471937>,
      < -0.446751, -0.805238, 2.471937>
    }
    triangle {
      < -0.290659, -0.965508, 2.307425>,
      < -0.446751, -0.805238, 2.471937>,
      < -0.446001, -0.965600, 2.307425>
    }
    triangle {
      < -0.446011, -0.947864, 2.289683>,
      < -0.446764, -0.783305, 2.449997>,
      < -0.254672, -0.783192, 2.449998>
    }
    triangle {
      < -0.446011, -0.947864, 2.289683>,
      < -0.254672, -0.783192, 2.449998>,
      < -0.290668, -0.947772, 2.289683>
    }
    triangle {
      < 0.488515, -0.815407, 2.417352>,
      < 0.520370, -0.782732, 2.449998>,
      < 0.520383, -0.804664, 2.471937>
    }
    triangle {
      < 0.488515, -0.815407, 2.417352>,
      < 0.520383, -0.804664, 2.471937>,
      < 0.488528, -0.837339, 2.439291>
    }
    triangle {
      < -0.217089, -0.965464, 2.307425>,
      < -0.163684, -0.805070, 2.471937>,
      < -0.163697, -0.783138, 2.449998>
    }
    triangle {
      < -0.217089, -0.965464, 2.307425>,
      < -0.163697, -0.783138, 2.449998>,
      < -0.217099, -0.947728, 2.289683>
    }
    triangle {
      < 0.488528, -0.837339, 2.439291>,
      < 0.520383, -0.804664, 2.471937>,
      < -0.163684, -0.805070, 2.471937>
    }
    triangle {
      < 0.488528, -0.837339, 2.439291>,
      < -0.163684, -0.805070, 2.471937>,
      < -0.217089, -0.965464, 2.307425>
    }
    triangle {
      < -0.217099, -0.947728, 2.289683>,
      < -0.163697, -0.783138, 2.449998>,
      < 0.520370, -0.782732, 2.449998>
    }
    triangle {
      < -0.217099, -0.947728, 2.289683>,
      < 0.520370, -0.782732, 2.449998>,
      < 0.488515, -0.815407, 2.417352>
    }
    triangle {
      < -0.290659, -0.965508, 2.743069>,
      < -0.254659, -0.804869, 2.578303>,
      < -0.254660, -0.802102, 2.583733>
    }
    triangle {
      < -0.290659, -0.965508, 2.743069>,
      < -0.254660, -0.802102, 2.583733>,
      < -0.290668, -0.947772, 2.760811>
    }
    triangle {
      < -0.254660, -0.802102, 2.583733>,
      < -0.254672, -0.782394, 2.599698>,
      < -0.290668, -0.947772, 2.760811>
    }
    triangle {
      < -0.446011, -0.947864, 2.760811>,
      < -0.446764, -0.782507, 2.599698>,
      < -0.446753, -0.802215, 2.583733>
    }
    triangle {
      < -0.446011, -0.947864, 2.760811>,
      < -0.446753, -0.802215, 2.583733>,
      < -0.446001, -0.965601, 2.743069>
    }
    triangle {
      < -0.446753, -0.802215, 2.583733>,
      < -0.446751, -0.804982, 2.578302>,
      < -0.446001, -0.965601, 2.743069>
    }
    triangle {
      < -0.290668, -0.947772, 2.760811>,
      < -0.254672, -0.782394, 2.599698>,
      < -0.446764, -0.782507, 2.599698>
    }
    triangle {
      < -0.290668, -0.947772, 2.760811>,
      < -0.446764, -0.782507, 2.599698>,
      < -0.446011, -0.947864, 2.760811>
    }
    triangle {
      < -0.446001, -0.965601, 2.743069>,
      < -0.446751, -0.804982, 2.578302>,
      < -0.254659, -0.804869, 2.578303>
    }
    triangle {
      < -0.446001, -0.965601, 2.743069>,
      < -0.254659, -0.804869, 2.578303>,
      < -0.290659, -0.965508, 2.743069>
    }
    triangle {
      < 0.488528, -0.837339, 2.611204>,
      < 0.520632, -0.804409, 2.578303>,
      < 0.519332, -0.801643, 2.583733>
    }
    triangle {
      < 0.488528, -0.837339, 2.611204>,
      < 0.519332, -0.801643, 2.583733>,
      < 0.488515, -0.815407, 2.633142>
    }
    triangle {
      < 0.519332, -0.801643, 2.583733>,
      < 0.521150, -0.781934, 2.599698>,
      < 0.488515, -0.815407, 2.633142>
    }
    triangle {
      < -0.217099, -0.947728, 2.760811>,
      < -0.163697, -0.782340, 2.599698>,
      < -0.163686, -0.802048, 2.583733>
    }
    triangle {
      < -0.217099, -0.947728, 2.760811>,
      < -0.163686, -0.802048, 2.583733>,
      < -0.217089, -0.965465, 2.743069>
    }
    triangle {
      < -0.163686, -0.802048, 2.583733>,
      < -0.163685, -0.804815, 2.578303>,
      < -0.217089, -0.965465, 2.743069>
    }
    triangle {
      < 0.488515, -0.815407, 2.633142>,
      < 0.521150, -0.781934, 2.599698>,
      < -0.163697, -0.782340, 2.599698>
    }
    triangle {
      < 0.488515, -0.815407, 2.633142>,
      < -0.163697, -0.782340, 2.599698>,
      < -0.217099, -0.947728, 2.760811>
    }
    triangle {
      < -0.217089, -0.965465, 2.743069>,
      < -0.163685, -0.804815, 2.578303>,
      < 0.520632, -0.804409, 2.578303>
    }
    triangle {
      < -0.217089, -0.965465, 2.743069>,
      < 0.520632, -0.804409, 2.578303>,
      < 0.488528, -0.837339, 2.611204>
    }
    triangle {
      < -0.217368, -0.494080, 2.742929>,
      < -0.217357, -0.511806, 2.760680>,
      < 0.488413, -0.643365, 2.633091>
    }
    triangle {
      < -0.217368, -0.494080, 2.742929>,
      < 0.488413, -0.643365, 2.633091>,
      < 0.488400, -0.621447, 2.611139>
    }
    triangle {
      < -0.446280, -0.494216, 2.742929>,
      < -0.446269, -0.511942, 2.760680>,
      < -0.290927, -0.511850, 2.760680>
    }
    triangle {
      < -0.446280, -0.494216, 2.742929>,
      < -0.290927, -0.511850, 2.760680>,
      < -0.290938, -0.494124, 2.742929>
    }
    triangle {
      < -0.217099, -0.947728, 2.760811>,
      < -0.217089, -0.965465, 2.743069>,
      < 0.488528, -0.837339, 2.611204>
    }
    triangle {
      < -0.217099, -0.947728, 2.760811>,
      < 0.488528, -0.837339, 2.611204>,
      < 0.488515, -0.815407, 2.633142>
    }
    triangle {
      < -0.446011, -0.947864, 2.760811>,
      < -0.446001, -0.965601, 2.743069>,
      < -0.290659, -0.965508, 2.743069>
    }
    triangle {
      < -0.446011, -0.947864, 2.760811>,
      < -0.290659, -0.965508, 2.743069>,
      < -0.290668, -0.947772, 2.760811>
    }
    triangle {
      < -0.217357, -0.512085, 2.289555>,
      < -0.217368, -0.494338, 2.307286>,
      < 0.488400, -0.621549, 2.439227>
    }
    triangle {
      < -0.217357, -0.512085, 2.289555>,
      < 0.488400, -0.621549, 2.439227>,
      < 0.488413, -0.643494, 2.417300>
    }
    triangle {
      < -0.446269, -0.512221, 2.289555>,
      < -0.446280, -0.494474, 2.307286>,
      < -0.290938, -0.494382, 2.307286>
    }
    triangle {
      < -0.446269, -0.512221, 2.289555>,
      < -0.290938, -0.494382, 2.307286>,
      < -0.290927, -0.512129, 2.289555>
    }
    triangle {
      < -0.217089, -0.965464, 2.307425>,
      < -0.217099, -0.947728, 2.289683>,
      < 0.488515, -0.815407, 2.417352>
    }
    triangle {
      < -0.217089, -0.965464, 2.307425>,
      < 0.488515, -0.815407, 2.417352>,
      < 0.488528, -0.837339, 2.439291>
    }
    triangle {
      < -0.446001, -0.965600, 2.307425>,
      < -0.446011, -0.947864, 2.289683>,
      < -0.290668, -0.947772, 2.289683>
    }
    triangle {
      < -0.446001, -0.965600, 2.307425>,
      < -0.290668, -0.947772, 2.289683>,
      < -0.290659, -0.965508, 2.307425>
    }
    triangle {
      < -0.163773, -0.655413, 2.577610>,
      < 0.521177, -0.655008, 2.577610>,
      < 0.916814, -0.642366, 2.558500>
    }
    triangle {
      < 0.521177, -0.655008, 2.577610>,
      < 0.518899, -0.663704, 2.591002>,
      < 0.916825, -0.663468, 2.591002>
    }
    triangle {
      < 0.521177, -0.655008, 2.577610>,
      < 0.916825, -0.663468, 2.591002>,
      < 0.916814, -0.642366, 2.558500>
    }
    triangle {
      < -0.163773, -0.655413, 2.577610>,
      < 0.916814, -0.642366, 2.558500>,
      < -0.254748, -0.655468, 2.577610>
    }
    triangle {
      < -0.163773, -0.655413, 2.577610>,
      < -0.254748, -0.655468, 2.577610>,
      < -0.163768, -0.664109, 2.591002>
    }
    triangle {
      < 0.916814, -0.642366, 2.558500>,
      < -0.471378, -0.643188, 2.558500>,
      < -0.446840, -0.655581, 2.577610>
    }
    triangle {
      < 0.916814, -0.642366, 2.558500>,
      < -0.446840, -0.655581, 2.577610>,
      < -0.254748, -0.655468, 2.577610>
    }
    triangle {
      < -0.471378, -0.643188, 2.558500>,
      < -0.471365, -0.664291, 2.591002>,
      < -0.446835, -0.664276, 2.591002>
    }
    triangle {
      < -0.471378, -0.643188, 2.558500>,
      < -0.446835, -0.664276, 2.591002>,
      < -0.446840, -0.655581, 2.577610>
    }
    triangle {
      < -0.254748, -0.655468, 2.577610>,
      < -0.254742, -0.664163, 2.591002>,
      < -0.163768, -0.664109, 2.591002>
    }
    triangle {
      < -0.254748, -0.655424, 2.472690>,
      < -0.446840, -0.655537, 2.472690>,
      < -0.471375, -0.647190, 2.483007>
    }
    triangle {
      < -0.446840, -0.655537, 2.472690>,
      < -0.446830, -0.671508, 2.452986>,
      < -0.471361, -0.671523, 2.452986>
    }
    triangle {
      < -0.446840, -0.655537, 2.472690>,
      < -0.471361, -0.671523, 2.452986>,
      < -0.471375, -0.647190, 2.483007>
    }
    triangle {
      < -0.254748, -0.655424, 2.472690>,
      < -0.471375, -0.647190, 2.483007>,
      < -0.163773, -0.655370, 2.472690>
    }
    triangle {
      < -0.254748, -0.655424, 2.472690>,
      < -0.163773, -0.655370, 2.472690>,
      < -0.254738, -0.671395, 2.452986>
    }
    triangle {
      < -0.471375, -0.647190, 2.483007>,
      < 0.916816, -0.646367, 2.483007>,
      < 0.521074, -0.654964, 2.472690>
    }
    triangle {
      < -0.471375, -0.647190, 2.483007>,
      < 0.521074, -0.654964, 2.472690>,
      < -0.163773, -0.655370, 2.472690>
    }
    triangle {
      < 0.916816, -0.646367, 2.483007>,
      < 0.916830, -0.670700, 2.452986>,
      < 0.519253, -0.670936, 2.452986>
    }
    triangle {
      < 0.916816, -0.646367, 2.483007>,
      < 0.519253, -0.670936, 2.452986>,
      < 0.521074, -0.654964, 2.472690>
    }
    triangle {
      < -0.163773, -0.655370, 2.472690>,
      < -0.163763, -0.671341, 2.452986>,
      < -0.254738, -0.671395, 2.452986>
    }
    triangle {
      < -0.163760, -0.676772, 2.450222>,
      < 0.520556, -0.676366, 2.450223>,
      < 0.916851, -0.705138, 2.435457>
    }
    triangle {
      < 0.520556, -0.676366, 2.450223>,
      < 0.519253, -0.670936, 2.452986>,
      < 0.916830, -0.670700, 2.452986>
    }
    triangle {
      < 0.520556, -0.676366, 2.450223>,
      < 0.916830, -0.670700, 2.452986>,
      < 0.916851, -0.705138, 2.435457>
    }
    triangle {
      < -0.163760, -0.676772, 2.450222>,
      < 0.916851, -0.705138, 2.435457>,
      < -0.254735, -0.676826, 2.450222>
    }
    triangle {
      < -0.163760, -0.676772, 2.450222>,
      < -0.254735, -0.676826, 2.450222>,
      < -0.163763, -0.671341, 2.452986>
    }
    triangle {
      < 0.916851, -0.705138, 2.435457>,
      < -0.471341, -0.705960, 2.435457>,
      < -0.446828, -0.676940, 2.450222>
    }
    triangle {
      < 0.916851, -0.705138, 2.435457>,
      < -0.446828, -0.676940, 2.450222>,
      < -0.254735, -0.676826, 2.450222>
    }
    triangle {
      < -0.471341, -0.705960, 2.435457>,
      < -0.471361, -0.671523, 2.452986>,
      < -0.446830, -0.671508, 2.452986>
    }
    triangle {
      < -0.471341, -0.705960, 2.435457>,
      < -0.446830, -0.671508, 2.452986>,
      < -0.446828, -0.676940, 2.450222>
    }
    triangle {
      < -0.254735, -0.676826, 2.450222>,
      < -0.254738, -0.671395, 2.452986>,
      < -0.163763, -0.671341, 2.452986>
    }
    triangle {
      < 0.916895, -0.779803, 2.447302>,
      < 0.520370, -0.782732, 2.449998>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < 0.916895, -0.779803, 2.447302>,
      < 0.916911, -0.807124, 2.474632>,
      < 0.520383, -0.804664, 2.471937>
    }
    triangle {
      < 0.916895, -0.779803, 2.447302>,
      < 0.520383, -0.804664, 2.471937>,
      < 0.520370, -0.782732, 2.449998>
    }
    triangle {
      < 0.916911, -0.807124, 2.474632>,
      < -0.163684, -0.805070, 2.471937>,
      < 0.520383, -0.804664, 2.471937>
    }
    triangle {
      < 0.916911, -0.807124, 2.474632>,
      < -0.254659, -0.805124, 2.471937>,
      < -0.163684, -0.805070, 2.471937>
    }
    triangle {
      < 0.520370, -0.782732, 2.449998>,
      < -0.163697, -0.783138, 2.449998>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < -0.163697, -0.783138, 2.449998>,
      < -0.254672, -0.783192, 2.449998>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < -0.163697, -0.783138, 2.449998>,
      < -0.163684, -0.805070, 2.471937>,
      < -0.254672, -0.783192, 2.449998>
    }
    triangle {
      < -0.163684, -0.805070, 2.471937>,
      < -0.254659, -0.805124, 2.471937>,
      < -0.254672, -0.783192, 2.449998>
    }
    triangle {
      < 0.916911, -0.807124, 2.474632>,
      < -0.471280, -0.807946, 2.474631>,
      < -0.446751, -0.805238, 2.471937>
    }
    triangle {
      < 0.916911, -0.807124, 2.474632>,
      < -0.446751, -0.805238, 2.471937>,
      < -0.254659, -0.805124, 2.471937>
    }
    triangle {
      < -0.254672, -0.783192, 2.449998>,
      < -0.446764, -0.783305, 2.449997>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < -0.446764, -0.783305, 2.449997>,
      < -0.446751, -0.805238, 2.471937>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < -0.446751, -0.805238, 2.471937>,
      < -0.471280, -0.807946, 2.474631>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < -0.254659, -0.804869, 2.578303>,
      < -0.446751, -0.804982, 2.578302>,
      < -0.471273, -0.819771, 2.549299>
    }
    triangle {
      < -0.446751, -0.804982, 2.578302>,
      < -0.446753, -0.802215, 2.583733>,
      < -0.471283, -0.802230, 2.583733>
    }
    triangle {
      < -0.446751, -0.804982, 2.578302>,
      < -0.471283, -0.802230, 2.583733>,
      < -0.471273, -0.819771, 2.549299>
    }
    triangle {
      < -0.254659, -0.804869, 2.578303>,
      < -0.471273, -0.819771, 2.549299>,
      < -0.163685, -0.804815, 2.578303>
    }
    triangle {
      < -0.254659, -0.804869, 2.578303>,
      < -0.163685, -0.804815, 2.578303>,
      < -0.254660, -0.802102, 2.583733>
    }
    triangle {
      < -0.471273, -0.819771, 2.549299>,
      < 0.916918, -0.818949, 2.549299>,
      < 0.520632, -0.804409, 2.578303>
    }
    triangle {
      < -0.471273, -0.819771, 2.549299>,
      < 0.520632, -0.804409, 2.578303>,
      < -0.163685, -0.804815, 2.578303>
    }
    triangle {
      < 0.916918, -0.818949, 2.549299>,
      < 0.916907, -0.801407, 2.583733>,
      < 0.519332, -0.801643, 2.583733>
    }
    triangle {
      < 0.916918, -0.818949, 2.549299>,
      < 0.519332, -0.801643, 2.583733>,
      < 0.520632, -0.804409, 2.578303>
    }
    triangle {
      < -0.163685, -0.804815, 2.578303>,
      < -0.163686, -0.802048, 2.583733>,
      < -0.254660, -0.802102, 2.583733>
    }
    triangle {
      < -0.163697, -0.782340, 2.599698>,
      < 0.521150, -0.781934, 2.599698>,
      < 0.916890, -0.771379, 2.608057>
    }
    triangle {
      < 0.521150, -0.781934, 2.599698>,
      < 0.519332, -0.801643, 2.583733>,
      < 0.916907, -0.801407, 2.583733>
    }
    triangle {
      < 0.521150, -0.781934, 2.599698>,
      < 0.916907, -0.801407, 2.583733>,
      < 0.916890, -0.771379, 2.608057>
    }
    triangle {
      < -0.163697, -0.782340, 2.599698>,
      < 0.916890, -0.771379, 2.608057>,
      < -0.254672, -0.782394, 2.599698>
    }
    triangle {
      < -0.163697, -0.782340, 2.599698>,
      < -0.254672, -0.782394, 2.599698>,
      < -0.163686, -0.802048, 2.583733>
    }
    triangle {
      < 0.916890, -0.771379, 2.608057>,
      < -0.471301, -0.772202, 2.608057>,
      < -0.446764, -0.782507, 2.599698>
    }
    triangle {
      < 0.916890, -0.771379, 2.608057>,
      < -0.446764, -0.782507, 2.599698>,
      < -0.254672, -0.782394, 2.599698>
    }
    triangle {
      < -0.471301, -0.772202, 2.608057>,
      < -0.471283, -0.802230, 2.583733>,
      < -0.446753, -0.802215, 2.583733>
    }
    triangle {
      < -0.471301, -0.772202, 2.608057>,
      < -0.446753, -0.802215, 2.583733>,
      < -0.446764, -0.782507, 2.599698>
    }
    triangle {
      < -0.254672, -0.782394, 2.599698>,
      < -0.254660, -0.802102, 2.583733>,
      < -0.163686, -0.802048, 2.583733>
    }
    triangle {
      < -0.254734, -0.677374, 2.599574>,
      < -0.446827, -0.677487, 2.599574>,
      < -0.471346, -0.696709, 2.612036>
    }
    triangle {
      < -0.446827, -0.677487, 2.599574>,
      < -0.446835, -0.664276, 2.591002>,
      < -0.471365, -0.664291, 2.591002>
    }
    triangle {
      < -0.446827, -0.677487, 2.599574>,
      < -0.471365, -0.664291, 2.591002>,
      < -0.471346, -0.696709, 2.612036>
    }
    triangle {
      < -0.254734, -0.677374, 2.599574>,
      < -0.471346, -0.696709, 2.612036>,
      < -0.163759, -0.677320, 2.599574>
    }
    triangle {
      < -0.254734, -0.677374, 2.599574>,
      < -0.163759, -0.677320, 2.599574>,
      < -0.254742, -0.664163, 2.591002>
    }
    triangle {
      < -0.471346, -0.696709, 2.612036>,
      < 0.916845, -0.695886, 2.612036>,
      < 0.521178, -0.676914, 2.599574>
    }
    triangle {
      < -0.471346, -0.696709, 2.612036>,
      < 0.521178, -0.676914, 2.599574>,
      < -0.163759, -0.677320, 2.599574>
    }
    triangle {
      < 0.916845, -0.695886, 2.612036>,
      < 0.916825, -0.663468, 2.591002>,
      < 0.518899, -0.663704, 2.591002>
    }
    triangle {
      < 0.916845, -0.695886, 2.612036>,
      < 0.518899, -0.663704, 2.591002>,
      < 0.521178, -0.676914, 2.599574>
    }
    triangle {
      < -0.163759, -0.677320, 2.599574>,
      < -0.163768, -0.664109, 2.591002>,
      < -0.254742, -0.664163, 2.591002>
    }
    triangle {
      < 0.916825, -0.663468, 2.591002>,
      < 0.916845, -0.695886, 2.612036>,
      < 1.139539, -0.702410, 2.594677>
    }
    triangle {
      < 0.916825, -0.663468, 2.591002>,
      < 1.139539, -0.702410, 2.594677>,
      < 1.139523, -0.676476, 2.577851>
    }
    triangle {
      < 0.916814, -0.642366, 2.558500>,
      < 0.916825, -0.663468, 2.591002>,
      < 1.139523, -0.676476, 2.577851>
    }
    triangle {
      < 0.916814, -0.642366, 2.558500>,
      < 1.139523, -0.676476, 2.577851>,
      < 1.139513, -0.659595, 2.551849>
    }
    triangle {
      < -0.482936, -0.660556, 2.551849>,
      < -0.482926, -0.677437, 2.577851>,
      < -0.471365, -0.664291, 2.591002>
    }
    triangle {
      < -0.482936, -0.660556, 2.551849>,
      < -0.471365, -0.664291, 2.591002>,
      < -0.471378, -0.643188, 2.558500>
    }
    triangle {
      < -0.482926, -0.677437, 2.577851>,
      < -0.482910, -0.703371, 2.594677>,
      < -0.471346, -0.696709, 2.612036>
    }
    triangle {
      < -0.482926, -0.677437, 2.577851>,
      < -0.471346, -0.696709, 2.612036>,
      < -0.471365, -0.664291, 2.591002>
    }
    triangle {
      < -0.471346, -0.696709, 2.612036>,
      < -0.471324, -0.734878, 2.618068>,
      < 0.916868, -0.734056, 2.618068>
    }
    triangle {
      < -0.471346, -0.696709, 2.612036>,
      < 0.916868, -0.734056, 2.618068>,
      < 0.916845, -0.695886, 2.612036>
    }
    triangle {
      < -0.482910, -0.703371, 2.594677>,
      < -0.482892, -0.733907, 2.599504>,
      < -0.471324, -0.734878, 2.618068>
    }
    triangle {
      < -0.482910, -0.703371, 2.594677>,
      < -0.471324, -0.734878, 2.618068>,
      < -0.471346, -0.696709, 2.612036>
    }
    triangle {
      < 0.916845, -0.695886, 2.612036>,
      < 0.916868, -0.734056, 2.618068>,
      < 1.139557, -0.732946, 2.599504>
    }
    triangle {
      < 0.916845, -0.695886, 2.612036>,
      < 1.139557, -0.732946, 2.599504>,
      < 1.139539, -0.702410, 2.594677>
    }
    triangle {
      < -0.471381, -0.637168, 2.520328>,
      < -0.471378, -0.643188, 2.558500>,
      < 0.916814, -0.642366, 2.558500>
    }
    triangle {
      < -0.471381, -0.637168, 2.520328>,
      < 0.916814, -0.642366, 2.558500>,
      < 0.916810, -0.636345, 2.520329>
    }
    triangle {
      < 0.916810, -0.636345, 2.520329>,
      < 0.916814, -0.642366, 2.558500>,
      < 1.139513, -0.659595, 2.551849>
    }
    triangle {
      < 0.916810, -0.636345, 2.520329>,
      < 1.139513, -0.659595, 2.551849>,
      < 1.139511, -0.654777, 2.521312>
    }
    triangle {
      < -0.482939, -0.655738, 2.521312>,
      < -0.482936, -0.660556, 2.551849>,
      < -0.471378, -0.643188, 2.558500>
    }
    triangle {
      < -0.482939, -0.655738, 2.521312>,
      < -0.471378, -0.643188, 2.558500>,
      < -0.471381, -0.637168, 2.520328>
    }
    triangle {
      < 1.139513, -0.659595, 2.551849>,
      < 1.139523, -0.676476, 2.577851>,
      < 1.237862, -0.689557, 2.564700>
    }
    triangle {
      < 1.139513, -0.659595, 2.551849>,
      < 1.237862, -0.689557, 2.564700>,
      < 1.237855, -0.676896, 2.545199>
    }
    triangle {
      < -0.399051, -0.685305, 2.542349>,
      < -0.399045, -0.696158, 2.559064>,
      < -0.482926, -0.677437, 2.577851>
    }
    triangle {
      < -0.399051, -0.685305, 2.542349>,
      < -0.482926, -0.677437, 2.577851>,
      < -0.482936, -0.660556, 2.551849>
    }
    triangle {
      < 1.139523, -0.676476, 2.577851>,
      < 1.139539, -0.702410, 2.594677>,
      < 1.237873, -0.709008, 2.577320>
    }
    triangle {
      < 1.139523, -0.676476, 2.577851>,
      < 1.237873, -0.709008, 2.577320>,
      < 1.237862, -0.689557, 2.564700>
    }
    triangle {
      < -0.399045, -0.696158, 2.559064>,
      < -0.399035, -0.712830, 2.569880>,
      < -0.482910, -0.703371, 2.594677>
    }
    triangle {
      < -0.399045, -0.696158, 2.559064>,
      < -0.482910, -0.703371, 2.594677>,
      < -0.482926, -0.677437, 2.577851>
    }
    triangle {
      < 1.139539, -0.702410, 2.594677>,
      < 1.139557, -0.732946, 2.599504>,
      < 1.237887, -0.731909, 2.580940>
    }
    triangle {
      < 1.139539, -0.702410, 2.594677>,
      < 1.237887, -0.731909, 2.580940>,
      < 1.237873, -0.709008, 2.577320>
    }
    triangle {
      < -0.399035, -0.712830, 2.569880>,
      < -0.399023, -0.732460, 2.572984>,
      < -0.482892, -0.733907, 2.599504>
    }
    triangle {
      < -0.399035, -0.712830, 2.569880>,
      < -0.482892, -0.733907, 2.599504>,
      < -0.482910, -0.703371, 2.594677>
    }
    triangle {
      < -0.399053, -0.682209, 2.522717>,
      < -0.399051, -0.685305, 2.542349>,
      < -0.482936, -0.660556, 2.551849>
    }
    triangle {
      < -0.399053, -0.682209, 2.522717>,
      < -0.482936, -0.660556, 2.551849>,
      < -0.482939, -0.655738, 2.521312>
    }
    triangle {
      < 1.139511, -0.654777, 2.521312>,
      < 1.139513, -0.659595, 2.551849>,
      < 1.237855, -0.676896, 2.545199>
    }
    triangle {
      < 1.139511, -0.654777, 2.521312>,
      < 1.237855, -0.676896, 2.545199>,
      < 1.237852, -0.673283, 2.522296>
    }
    triangle {
      < 0.916868, -0.734056, 2.618068>,
      < 0.916890, -0.771379, 2.608057>,
      < 1.139575, -0.762806, 2.591495>
    }
    triangle {
      < 0.916868, -0.734056, 2.618068>,
      < 1.139575, -0.762806, 2.591495>,
      < 1.139557, -0.732946, 2.599504>
    }
    triangle {
      < -0.482892, -0.733907, 2.599504>,
      < -0.482875, -0.763767, 2.591495>,
      < -0.471301, -0.772202, 2.608057>
    }
    triangle {
      < -0.482892, -0.733907, 2.599504>,
      < -0.471301, -0.772202, 2.608057>,
      < -0.471324, -0.734878, 2.618068>
    }
    triangle {
      < -0.471324, -0.734878, 2.618068>,
      < -0.471301, -0.772202, 2.608057>,
      < 0.916890, -0.771379, 2.608057>
    }
    triangle {
      < -0.471324, -0.734878, 2.618068>,
      < 0.916890, -0.771379, 2.608057>,
      < 0.916868, -0.734056, 2.618068>
    }
    triangle {
      < 0.916816, -0.646367, 2.483007>,
      < 0.916810, -0.636345, 2.520329>,
      < 1.139511, -0.654777, 2.521312>
    }
    triangle {
      < 0.916816, -0.646367, 2.483007>,
      < 1.139511, -0.654777, 2.521312>,
      < 1.139515, -0.662795, 2.491456>
    }
    triangle {
      < -0.471375, -0.647190, 2.483007>,
      < -0.471381, -0.637168, 2.520328>,
      < 0.916810, -0.636345, 2.520329>
    }
    triangle {
      < -0.471375, -0.647190, 2.483007>,
      < 0.916810, -0.636345, 2.520329>,
      < 0.916816, -0.646367, 2.483007>
    }
    triangle {
      < -0.482934, -0.663756, 2.491455>,
      < -0.482939, -0.655738, 2.521312>,
      < -0.471381, -0.637168, 2.520328>
    }
    triangle {
      < -0.482934, -0.663756, 2.491455>,
      < -0.471381, -0.637168, 2.520328>,
      < -0.471375, -0.647190, 2.483007>
    }
    triangle {
      < 1.237855, -0.676896, 2.545199>,
      < 1.237862, -0.689557, 2.564700>,
      < 1.292819, -0.704541, 2.549670>
    }
    triangle {
      < 1.237855, -0.676896, 2.545199>,
      < 1.292819, -0.704541, 2.549670>,
      < 1.292815, -0.696703, 2.537598>
    }
    triangle {
      < 1.237862, -0.689557, 2.564700>,
      < 1.237873, -0.709008, 2.577320>,
      < 1.292827, -0.716581, 2.557483>
    }
    triangle {
      < 1.237862, -0.689557, 2.564700>,
      < 1.292827, -0.716581, 2.557483>,
      < 1.292819, -0.704541, 2.549670>
    }
    triangle {
      < 1.237873, -0.709008, 2.577320>,
      < 1.237887, -0.731909, 2.580940>,
      < 1.292835, -0.730759, 2.559723>
    }
    triangle {
      < 1.237873, -0.709008, 2.577320>,
      < 1.292835, -0.730759, 2.559723>,
      < 1.292827, -0.716581, 2.557483>
    }
    triangle {
      < 1.237852, -0.673283, 2.522296>,
      < 1.237855, -0.676896, 2.545199>,
      < 1.292815, -0.696703, 2.537598>
    }
    triangle {
      < 1.237852, -0.673283, 2.522296>,
      < 1.292815, -0.696703, 2.537598>,
      < 1.292813, -0.694466, 2.523420>
    }
    triangle {
      < 1.139557, -0.732946, 2.599504>,
      < 1.139575, -0.762806, 2.591495>,
      < 1.237900, -0.754304, 2.574933>
    }
    triangle {
      < 1.139557, -0.732946, 2.599504>,
      < 1.237900, -0.754304, 2.574933>,
      < 1.237887, -0.731909, 2.580940>
    }
    triangle {
      < -0.399023, -0.732460, 2.572984>,
      < -0.399012, -0.751656, 2.567835>,
      < -0.482875, -0.763767, 2.591495>
    }
    triangle {
      < -0.399023, -0.732460, 2.572984>,
      < -0.482875, -0.763767, 2.591495>,
      < -0.482892, -0.733907, 2.599504>
    }
    triangle {
      < 1.139515, -0.662795, 2.491456>,
      < 1.139511, -0.654777, 2.521312>,
      < 1.237852, -0.673283, 2.522296>
    }
    triangle {
      < 1.139515, -0.662795, 2.491456>,
      < 1.237852, -0.673283, 2.522296>,
      < 1.237856, -0.679296, 2.499904>
    }
    triangle {
      < -0.399050, -0.687363, 2.503524>,
      < -0.399053, -0.682209, 2.522717>,
      < -0.482939, -0.655738, 2.521312>
    }
    triangle {
      < -0.399050, -0.687363, 2.503524>,
      < -0.482939, -0.655738, 2.521312>,
      < -0.482934, -0.663756, 2.491455>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399045, -0.696158, 2.559064>,
      < -0.399051, -0.685305, 2.542349>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399035, -0.712830, 2.569880>,
      < -0.399045, -0.696158, 2.559064>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399023, -0.732460, 2.572984>,
      < -0.399035, -0.712830, 2.569880>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399051, -0.685305, 2.542349>,
      < -0.399053, -0.682209, 2.522717>
    }
    triangle {
      < 1.237887, -0.731909, 2.580940>,
      < 1.237900, -0.754304, 2.574933>,
      < 1.292843, -0.744622, 2.556006>
    }
    triangle {
      < 1.237887, -0.731909, 2.580940>,
      < 1.292843, -0.744622, 2.556006>,
      < 1.292835, -0.730759, 2.559723>
    }
    triangle {
      < 1.237856, -0.679296, 2.499904>,
      < 1.237852, -0.673283, 2.522296>,
      < 1.292813, -0.694466, 2.523420>
    }
    triangle {
      < 1.237856, -0.679296, 2.499904>,
      < 1.292813, -0.694466, 2.523420>,
      < 1.292816, -0.698188, 2.509558>
    }
    triangle {
      < 1.292819, -0.704541, 2.549670>,
      < 1.292827, -0.716581, 2.557483>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.292815, -0.696703, 2.537598>,
      < 1.292819, -0.704541, 2.549670>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399012, -0.751656, 2.567835>,
      < -0.399023, -0.732460, 2.572984>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399053, -0.682209, 2.522717>,
      < -0.399050, -0.687363, 2.503524>
    }
    triangle {
      < 1.292827, -0.716581, 2.557483>,
      < 1.292835, -0.730759, 2.559723>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.292813, -0.694466, 2.523420>,
      < 1.292815, -0.696703, 2.537598>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < -0.482875, -0.763767, 2.591495>,
      < -0.482861, -0.787788, 2.572036>,
      < -0.471283, -0.802230, 2.583733>
    }
    triangle {
      < -0.482875, -0.763767, 2.591495>,
      < -0.471283, -0.802230, 2.583733>,
      < -0.471301, -0.772202, 2.608057>
    }
    triangle {
      < 0.916890, -0.771379, 2.608057>,
      < 0.916907, -0.801407, 2.583733>,
      < 1.139589, -0.786827, 2.572037>
    }
    triangle {
      < 0.916890, -0.771379, 2.608057>,
      < 1.139589, -0.786827, 2.572037>,
      < 1.139575, -0.762806, 2.591495>
    }
    triangle {
      < -0.482923, -0.683222, 2.467439>,
      < -0.482934, -0.663756, 2.491455>,
      < -0.471375, -0.647190, 2.483007>
    }
    triangle {
      < -0.482923, -0.683222, 2.467439>,
      < -0.471375, -0.647190, 2.483007>,
      < -0.471361, -0.671523, 2.452986>
    }
    triangle {
      < 0.916830, -0.670700, 2.452986>,
      < 0.916816, -0.646367, 2.483007>,
      < 1.139515, -0.662795, 2.491456>
    }
    triangle {
      < 0.916830, -0.670700, 2.452986>,
      < 1.139515, -0.662795, 2.491456>,
      < 1.139527, -0.682261, 2.467439>
    }
    triangle {
      < 1.292835, -0.730759, 2.559723>,
      < 1.292843, -0.744622, 2.556006>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.292816, -0.698188, 2.509558>,
      < 1.292813, -0.694466, 2.523420>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.139575, -0.762806, 2.591495>,
      < 1.139589, -0.786827, 2.572037>,
      < 1.237910, -0.772320, 2.560338>
    }
    triangle {
      < 1.139575, -0.762806, 2.591495>,
      < 1.237910, -0.772320, 2.560338>,
      < 1.237900, -0.754304, 2.574933>
    }
    triangle {
      < -0.399012, -0.751656, 2.567835>,
      < -0.399002, -0.767099, 2.555326>,
      < -0.482861, -0.787788, 2.572036>
    }
    triangle {
      < -0.399012, -0.751656, 2.567835>,
      < -0.482861, -0.787788, 2.572036>,
      < -0.482875, -0.763767, 2.591495>
    }
    triangle {
      < 1.139527, -0.682261, 2.467439>,
      < 1.139515, -0.662795, 2.491456>,
      < 1.237856, -0.679296, 2.499904>
    }
    triangle {
      < 1.139527, -0.682261, 2.467439>,
      < 1.237856, -0.679296, 2.499904>,
      < 1.237864, -0.693895, 2.481891>
    }
    triangle {
      < -0.399043, -0.699878, 2.488085>,
      < -0.399050, -0.687363, 2.503524>,
      < -0.482934, -0.663756, 2.491455>
    }
    triangle {
      < -0.399043, -0.699878, 2.488085>,
      < -0.482934, -0.663756, 2.491455>,
      < -0.482923, -0.683222, 2.467439>
    }
    triangle {
      < 1.237900, -0.754304, 2.574933>,
      < 1.237910, -0.772320, 2.560338>,
      < 1.292850, -0.755775, 2.546971>
    }
    triangle {
      < 1.237900, -0.754304, 2.574933>,
      < 1.292850, -0.755775, 2.546971>,
      < 1.292843, -0.744622, 2.556006>
    }
    triangle {
      < 1.237864, -0.693895, 2.481891>,
      < 1.237856, -0.679296, 2.499904>,
      < 1.292816, -0.698188, 2.509558>
    }
    triangle {
      < 1.237864, -0.693895, 2.481891>,
      < 1.292816, -0.698188, 2.509558>,
      < 1.292821, -0.707227, 2.498408>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399002, -0.767099, 2.555326>,
      < -0.399012, -0.751656, 2.567835>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399050, -0.687363, 2.503524>,
      < -0.399043, -0.699878, 2.488085>
    }
    triangle {
      < 1.292843, -0.744622, 2.556006>,
      < 1.292850, -0.755775, 2.546971>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.292821, -0.707227, 2.498408>,
      < 1.292816, -0.698188, 2.509558>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399043, -0.699878, 2.488085>,
      < -0.399032, -0.717589, 2.479069>
    }
    triangle {
      < 1.292850, -0.755775, 2.546971>,
      < 1.292854, -0.762291, 2.534182>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399032, -0.717589, 2.479069>,
      < -0.399020, -0.737435, 2.478035>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399010, -0.755987, 2.485162>,
      < -0.399001, -0.770039, 2.499216>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399020, -0.737435, 2.478035>,
      < -0.399010, -0.755987, 2.485162>
    }
    triangle {
      < 1.292851, -0.757899, 2.506447>,
      < 1.292845, -0.747751, 2.496297>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.292828, -0.720018, 2.491896>,
      < 1.292821, -0.707227, 2.498408>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.292837, -0.734352, 2.491149>,
      < 1.292828, -0.720018, 2.491896>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.398997, -0.776120, 2.537617>,
      < -0.399002, -0.767099, 2.555326>
    }
    triangle {
      < 1.292854, -0.762291, 2.534182>,
      < 1.292854, -0.763042, 2.519848>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < 1.292845, -0.747751, 2.496297>,
      < 1.292837, -0.734352, 2.491149>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.398997, -0.777159, 2.517770>,
      < -0.398997, -0.776120, 2.537617>
    }
    triangle {
      < 1.292854, -0.763042, 2.519848>,
      < 1.292851, -0.757899, 2.506447>,
      < 1.339107, -0.728914, 2.525248>
    }
    triangle {
      < -0.381673, -0.729934, 2.525247>,
      < -0.399001, -0.770039, 2.499216>,
      < -0.398997, -0.777159, 2.517770>
    }
    triangle {
      < 1.237910, -0.772320, 2.560338>,
      < 1.237917, -0.782845, 2.539679>,
      < 1.292854, -0.762291, 2.534182>
    }
    triangle {
      < 1.237910, -0.772320, 2.560338>,
      < 1.292854, -0.762291, 2.534182>,
      < 1.292850, -0.755775, 2.546971>
    }
    triangle {
      < 1.237876, -0.714559, 2.471372>,
      < 1.237864, -0.693895, 2.481891>,
      < 1.292821, -0.707227, 2.498408>
    }
    triangle {
      < 1.237876, -0.714559, 2.471372>,
      < 1.292821, -0.707227, 2.498408>,
      < 1.292828, -0.720018, 2.491896>
    }
    triangle {
      < -0.399002, -0.767099, 2.555326>,
      < -0.398997, -0.776120, 2.537617>,
      < -0.482853, -0.801821, 2.544489>
    }
    triangle {
      < -0.399002, -0.767099, 2.555326>,
      < -0.482853, -0.801821, 2.544489>,
      < -0.482861, -0.787788, 2.572036>
    }
    triangle {
      < -0.399032, -0.717589, 2.479069>,
      < -0.399043, -0.699878, 2.488085>,
      < -0.482923, -0.683222, 2.467439>
    }
    triangle {
      < -0.399032, -0.717589, 2.479069>,
      < -0.482923, -0.683222, 2.467439>,
      < -0.482906, -0.710774, 2.453414>
    }
    triangle {
      < 1.139589, -0.786827, 2.572037>,
      < 1.139597, -0.800860, 2.544490>,
      < 1.237917, -0.782845, 2.539679>
    }
    triangle {
      < 1.139589, -0.786827, 2.572037>,
      < 1.237917, -0.782845, 2.539679>,
      < 1.237910, -0.772320, 2.560338>
    }
    triangle {
      < 1.139543, -0.709812, 2.453414>,
      < 1.139527, -0.682261, 2.467439>,
      < 1.237864, -0.693895, 2.481891>
    }
    triangle {
      < 1.139543, -0.709812, 2.453414>,
      < 1.237864, -0.693895, 2.481891>,
      < 1.237876, -0.714559, 2.471372>
    }
    triangle {
      < -0.482861, -0.787788, 2.572036>,
      < -0.482853, -0.801821, 2.544489>,
      < -0.471273, -0.819771, 2.549299>
    }
    triangle {
      < -0.482861, -0.787788, 2.572036>,
      < -0.471273, -0.819771, 2.549299>,
      < -0.471283, -0.802230, 2.583733>
    }
    triangle {
      < 0.916907, -0.801407, 2.583733>,
      < 0.916918, -0.818949, 2.549299>,
      < 1.139597, -0.800860, 2.544490>
    }
    triangle {
      < 0.916907, -0.801407, 2.583733>,
      < 1.139597, -0.800860, 2.544490>,
      < 1.139589, -0.786827, 2.572037>
    }
    triangle {
      < 0.916851, -0.705138, 2.435457>,
      < 0.916830, -0.670700, 2.452986>,
      < 1.139527, -0.682261, 2.467439>
    }
    triangle {
      < 0.916851, -0.705138, 2.435457>,
      < 1.139527, -0.682261, 2.467439>,
      < 1.139543, -0.709812, 2.453414>
    }
    triangle {
      < -0.482906, -0.710774, 2.453414>,
      < -0.482923, -0.683222, 2.467439>,
      < -0.471361, -0.671523, 2.452986>
    }
    triangle {
      < -0.482906, -0.710774, 2.453414>,
      < -0.471361, -0.671523, 2.452986>,
      < -0.471341, -0.705960, 2.435457>
    }
    triangle {
      < 1.237917, -0.782845, 2.539679>,
      < 1.237918, -0.784058, 2.516524>,
      < 1.292854, -0.763042, 2.519848>
    }
    triangle {
      < 1.237917, -0.782845, 2.539679>,
      < 1.292854, -0.763042, 2.519848>,
      < 1.292854, -0.762291, 2.534182>
    }
    triangle {
      < 1.237891, -0.737714, 2.470167>,
      < 1.237876, -0.714559, 2.471372>,
      < 1.292828, -0.720018, 2.491896>
    }
    triangle {
      < 1.237891, -0.737714, 2.470167>,
      < 1.292828, -0.720018, 2.491896>,
      < 1.292837, -0.734352, 2.491149>
    }
    triangle {
      < -0.398997, -0.776120, 2.537617>,
      < -0.398997, -0.777159, 2.517770>,
      < -0.482851, -0.803438, 2.513617>
    }
    triangle {
      < -0.398997, -0.776120, 2.537617>,
      < -0.482851, -0.803438, 2.513617>,
      < -0.482853, -0.801821, 2.544489>
    }
    triangle {
      < -0.399020, -0.737435, 2.478035>,
      < -0.399032, -0.717589, 2.479069>,
      < -0.482906, -0.710774, 2.453414>
    }
    triangle {
      < -0.399020, -0.737435, 2.478035>,
      < -0.482906, -0.710774, 2.453414>,
      < -0.482888, -0.741646, 2.451806>
    }
    triangle {
      < 1.139597, -0.800860, 2.544490>,
      < 1.139598, -0.802477, 2.513617>,
      < 1.237918, -0.784058, 2.516524>
    }
    triangle {
      < 1.139597, -0.800860, 2.544490>,
      < 1.237918, -0.784058, 2.516524>,
      < 1.237917, -0.782845, 2.539679>
    }
    triangle {
      < 1.237918, -0.784058, 2.516524>,
      < 1.237913, -0.775750, 2.494878>,
      < 1.292851, -0.757899, 2.506447>
    }
    triangle {
      < 1.237918, -0.784058, 2.516524>,
      < 1.292851, -0.757899, 2.506447>,
      < 1.292854, -0.763042, 2.519848>
    }
    triangle {
      < 1.139562, -0.740684, 2.451807>,
      < 1.139543, -0.709812, 2.453414>,
      < 1.237876, -0.714559, 2.471372>
    }
    triangle {
      < 1.139562, -0.740684, 2.451807>,
      < 1.237876, -0.714559, 2.471372>,
      < 1.237891, -0.737714, 2.470167>
    }
    triangle {
      < 1.237903, -0.759357, 2.478481>,
      < 1.237891, -0.737714, 2.470167>,
      < 1.292837, -0.734352, 2.491149>
    }
    triangle {
      < 1.237903, -0.759357, 2.478481>,
      < 1.292837, -0.734352, 2.491149>,
      < 1.292845, -0.747751, 2.496297>
    }
    triangle {
      < 1.237913, -0.775750, 2.494878>,
      < 1.237903, -0.759357, 2.478481>,
      < 1.292845, -0.747751, 2.496297>
    }
    triangle {
      < 1.237913, -0.775750, 2.494878>,
      < 1.292845, -0.747751, 2.496297>,
      < 1.292851, -0.757899, 2.506447>
    }
    triangle {
      < -0.482853, -0.801821, 2.544489>,
      < -0.482851, -0.803438, 2.513617>,
      < -0.471272, -0.821792, 2.510709>
    }
    triangle {
      < -0.482853, -0.801821, 2.544489>,
      < -0.471272, -0.821792, 2.510709>,
      < -0.471273, -0.819771, 2.549299>
    }
    triangle {
      < 0.916918, -0.818949, 2.549299>,
      < 0.916919, -0.820969, 2.510709>,
      < 1.139598, -0.802477, 2.513617>
    }
    triangle {
      < 0.916918, -0.818949, 2.549299>,
      < 1.139598, -0.802477, 2.513617>,
      < 1.139597, -0.800860, 2.544490>
    }
    triangle {
      < 0.916873, -0.743729, 2.433446>,
      < 0.916851, -0.705138, 2.435457>,
      < 1.139543, -0.709812, 2.453414>
    }
    triangle {
      < 0.916873, -0.743729, 2.433446>,
      < 1.139543, -0.709812, 2.453414>,
      < 1.139562, -0.740684, 2.451807>
    }
    triangle {
      < -0.482888, -0.741646, 2.451806>,
      < -0.482906, -0.710774, 2.453414>,
      < -0.471341, -0.705960, 2.435457>
    }
    triangle {
      < -0.482888, -0.741646, 2.451806>,
      < -0.471341, -0.705960, 2.435457>,
      < -0.471317, -0.744552, 2.433445>
    }
    triangle {
      < -0.398997, -0.777159, 2.517770>,
      < -0.399001, -0.770039, 2.499216>,
      < -0.482858, -0.792362, 2.484755>
    }
    triangle {
      < -0.398997, -0.777159, 2.517770>,
      < -0.482858, -0.792362, 2.484755>,
      < -0.482851, -0.803438, 2.513617>
    }
    triangle {
      < -0.399010, -0.755987, 2.485162>,
      < -0.399020, -0.737435, 2.478035>,
      < -0.482888, -0.741646, 2.451806>
    }
    triangle {
      < -0.399010, -0.755987, 2.485162>,
      < -0.482888, -0.741646, 2.451806>,
      < -0.482871, -0.770506, 2.462892>
    }
    triangle {
      < 1.139598, -0.802477, 2.513617>,
      < 1.139592, -0.791401, 2.484755>,
      < 1.237913, -0.775750, 2.494878>
    }
    triangle {
      < 1.139598, -0.802477, 2.513617>,
      < 1.237913, -0.775750, 2.494878>,
      < 1.237918, -0.784058, 2.516524>
    }
    triangle {
      < 1.139579, -0.769544, 2.462892>,
      < 1.139562, -0.740684, 2.451807>,
      < 1.237891, -0.737714, 2.470167>
    }
    triangle {
      < 1.139579, -0.769544, 2.462892>,
      < 1.237891, -0.737714, 2.470167>,
      < 1.237903, -0.759357, 2.478481>
    }
    triangle {
      < -0.471273, -0.819771, 2.549299>,
      < -0.471272, -0.821792, 2.510709>,
      < 0.916919, -0.820969, 2.510709>
    }
    triangle {
      < -0.471273, -0.819771, 2.549299>,
      < 0.916919, -0.820969, 2.510709>,
      < 0.916918, -0.818949, 2.549299>
    }
    triangle {
      < -0.471317, -0.744552, 2.433445>,
      < -0.471341, -0.705960, 2.435457>,
      < 0.916851, -0.705138, 2.435457>
    }
    triangle {
      < -0.471317, -0.744552, 2.433445>,
      < 0.916851, -0.705138, 2.435457>,
      < 0.916873, -0.743729, 2.433446>
    }
    triangle {
      < -0.399001, -0.770039, 2.499216>,
      < -0.399010, -0.755987, 2.485162>,
      < -0.482871, -0.770506, 2.462892>
    }
    triangle {
      < -0.399001, -0.770039, 2.499216>,
      < -0.482871, -0.770506, 2.462892>,
      < -0.482858, -0.792362, 2.484755>
    }
    triangle {
      < 1.139592, -0.791401, 2.484755>,
      < 1.139579, -0.769544, 2.462892>,
      < 1.237903, -0.759357, 2.478481>
    }
    triangle {
      < 1.139592, -0.791401, 2.484755>,
      < 1.237903, -0.759357, 2.478481>,
      < 1.237913, -0.775750, 2.494878>
    }
    triangle {
      < -0.482851, -0.803438, 2.513617>,
      < -0.482858, -0.792362, 2.484755>,
      < -0.471280, -0.807946, 2.474631>
    }
    triangle {
      < -0.482851, -0.803438, 2.513617>,
      < -0.471280, -0.807946, 2.474631>,
      < -0.471272, -0.821792, 2.510709>
    }
    triangle {
      < 0.916919, -0.820969, 2.510709>,
      < 0.916911, -0.807124, 2.474632>,
      < 1.139592, -0.791401, 2.484755>
    }
    triangle {
      < 0.916919, -0.820969, 2.510709>,
      < 1.139592, -0.791401, 2.484755>,
      < 1.139598, -0.802477, 2.513617>
    }
    triangle {
      < 0.916895, -0.779803, 2.447302>,
      < 0.916873, -0.743729, 2.433446>,
      < 1.139562, -0.740684, 2.451807>
    }
    triangle {
      < 0.916895, -0.779803, 2.447302>,
      < 1.139562, -0.740684, 2.451807>,
      < 1.139579, -0.769544, 2.462892>
    }
    triangle {
      < -0.482871, -0.770506, 2.462892>,
      < -0.482888, -0.741646, 2.451806>,
      < -0.471317, -0.744552, 2.433445>
    }
    triangle {
      < -0.482871, -0.770506, 2.462892>,
      < -0.471317, -0.744552, 2.433445>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < -0.482858, -0.792362, 2.484755>,
      < -0.482871, -0.770506, 2.462892>,
      < -0.471296, -0.780625, 2.447302>
    }
    triangle {
      < -0.482858, -0.792362, 2.484755>,
      < -0.471296, -0.780625, 2.447302>,
      < -0.471280, -0.807946, 2.474631>
    }
    triangle {
      < 0.916911, -0.807124, 2.474632>,
      < 0.916895, -0.779803, 2.447302>,
      < 1.139579, -0.769544, 2.462892>
    }
    triangle {
      < 0.916911, -0.807124, 2.474632>,
      < 1.139579, -0.769544, 2.462892>,
      < 1.139592, -0.791401, 2.484755>
    }
    triangle {
      < -0.471272, -0.821792, 2.510709>,
      < -0.471280, -0.807946, 2.474631>,
      < 0.916911, -0.807124, 2.474632>
    }
    triangle {
      < -0.471272, -0.821792, 2.510709>,
      < 0.916911, -0.807124, 2.474632>,
      < 0.916919, -0.820969, 2.510709>
    }
    triangle {
      < -0.471296, -0.780625, 2.447302>,
      < -0.471317, -0.744552, 2.433445>,
      < 0.916873, -0.743729, 2.433446>
    }
    triangle {
      < -0.471296, -0.780625, 2.447302>,
      < 0.916873, -0.743729, 2.433446>,
      < 0.916895, -0.779803, 2.447302>
    }
    triangle {
      < -0.290809, -0.711901, 1.388300>,
      < -0.254615, -0.877426, 1.227192>,
      < -0.254624, -0.864215, 1.218620>
    }
    triangle {
      < -0.290809, -0.711901, 1.388300>,
      < -0.254624, -0.864215, 1.218620>,
      < -0.290819, -0.694176, 1.370548>
    }
    triangle {
      < -0.254624, -0.864215, 1.218620>,
      < -0.254629, -0.855520, 1.205227>,
      < -0.290819, -0.694176, 1.370548>
    }
    triangle {
      < -0.446161, -0.694268, 1.370548>,
      < -0.446721, -0.855633, 1.205227>,
      < -0.446716, -0.864328, 1.218620>
    }
    triangle {
      < -0.446161, -0.694268, 1.370548>,
      < -0.446716, -0.864328, 1.218620>,
      < -0.446151, -0.711993, 1.388300>
    }
    triangle {
      < -0.446716, -0.864328, 1.218620>,
      < -0.446708, -0.877539, 1.227192>,
      < -0.446151, -0.711993, 1.388300>
    }
    triangle {
      < -0.290819, -0.694176, 1.370548>,
      < -0.254629, -0.855520, 1.205227>,
      < -0.446721, -0.855633, 1.205227>
    }
    triangle {
      < -0.290819, -0.694176, 1.370548>,
      < -0.446721, -0.855633, 1.205227>,
      < -0.446161, -0.694268, 1.370548>
    }
    triangle {
      < -0.446151, -0.711993, 1.388300>,
      < -0.446708, -0.877539, 1.227192>,
      < -0.254615, -0.877426, 1.227192>
    }
    triangle {
      < -0.446151, -0.711993, 1.388300>,
      < -0.254615, -0.877426, 1.227192>,
      < -0.290809, -0.711901, 1.388300>
    }
    triangle {
      < 0.488532, -0.843418, 1.260710>,
      < 0.521297, -0.876966, 1.227192>,
      < 0.519017, -0.863756, 1.218620>
    }
    triangle {
      < 0.488532, -0.843418, 1.260710>,
      < 0.519017, -0.863756, 1.218620>,
      < 0.488519, -0.821499, 1.238758>
    }
    triangle {
      < 0.519017, -0.863756, 1.218620>,
      < 0.521296, -0.855060, 1.205228>,
      < 0.488519, -0.821499, 1.238758>
    }
    triangle {
      < -0.217249, -0.694132, 1.370548>,
      < -0.163654, -0.855466, 1.205227>,
      < -0.163649, -0.864161, 1.218620>
    }
    triangle {
      < -0.217249, -0.694132, 1.370548>,
      < -0.163649, -0.864161, 1.218620>,
      < -0.217239, -0.711857, 1.388300>
    }
    triangle {
      < -0.163649, -0.864161, 1.218620>,
      < -0.163641, -0.877372, 1.227192>,
      < -0.217239, -0.711857, 1.388300>
    }
    triangle {
      < 0.488519, -0.821499, 1.238758>,
      < 0.521296, -0.855060, 1.205228>,
      < -0.163654, -0.855466, 1.205227>
    }
    triangle {
      < 0.488519, -0.821499, 1.238758>,
      < -0.163654, -0.855466, 1.205227>,
      < -0.217249, -0.694132, 1.370548>
    }
    triangle {
      < -0.217239, -0.711857, 1.388300>,
      < -0.163641, -0.877372, 1.227192>,
      < 0.521297, -0.876966, 1.227192>
    }
    triangle {
      < -0.217239, -0.711857, 1.388300>,
      < 0.521297, -0.876966, 1.227192>,
      < 0.488532, -0.843418, 1.260710>
    }
    triangle {
      < -0.290819, -0.694434, 0.934905>,
      < -0.254629, -0.855475, 1.100309>,
      < -0.254619, -0.871446, 1.080605>
    }
    triangle {
      < -0.290819, -0.694434, 0.934905>,
      < -0.254619, -0.871446, 1.080605>,
      < -0.290808, -0.712180, 0.917173>
    }
    triangle {
      < -0.254619, -0.871446, 1.080605>,
      < -0.254616, -0.876878, 1.077841>,
      < -0.290808, -0.712180, 0.917173>
    }
    triangle {
      < -0.446151, -0.712272, 0.917173>,
      < -0.446709, -0.876991, 1.077841>,
      < -0.446711, -0.871559, 1.080605>
    }
    triangle {
      < -0.446151, -0.712272, 0.917173>,
      < -0.446711, -0.871559, 1.080605>,
      < -0.446161, -0.694526, 0.934905>
    }
    triangle {
      < -0.446711, -0.871559, 1.080605>,
      < -0.446721, -0.855588, 1.100309>,
      < -0.446161, -0.694526, 0.934905>
    }
    triangle {
      < -0.290808, -0.712180, 0.917173>,
      < -0.254616, -0.876878, 1.077841>,
      < -0.446709, -0.876991, 1.077841>
    }
    triangle {
      < -0.290808, -0.712180, 0.917173>,
      < -0.446709, -0.876991, 1.077841>,
      < -0.446151, -0.712272, 0.917173>
    }
    triangle {
      < -0.446161, -0.694526, 0.934905>,
      < -0.446721, -0.855588, 1.100309>,
      < -0.254629, -0.855475, 1.100309>
    }
    triangle {
      < -0.446161, -0.694526, 0.934905>,
      < -0.254629, -0.855475, 1.100309>,
      < -0.290819, -0.694434, 0.934905>
    }
    triangle {
      < 0.488519, -0.821600, 1.066845>,
      < 0.521193, -0.855015, 1.100309>,
      < 0.519372, -0.870987, 1.080605>
    }
    triangle {
      < 0.488519, -0.821600, 1.066845>,
      < 0.519372, -0.870987, 1.080605>,
      < 0.488532, -0.843545, 1.044919>
    }
    triangle {
      < 0.519372, -0.870987, 1.080605>,
      < 0.520675, -0.876418, 1.077841>,
      < 0.488532, -0.843545, 1.044919>
    }
    triangle {
      < -0.217238, -0.712136, 0.917173>,
      < -0.163642, -0.876824, 1.077841>,
      < -0.163644, -0.871392, 1.080605>
    }
    triangle {
      < -0.217238, -0.712136, 0.917173>,
      < -0.163644, -0.871392, 1.080605>,
      < -0.217249, -0.694390, 0.934905>
    }
    triangle {
      < -0.163644, -0.871392, 1.080605>,
      < -0.163654, -0.855421, 1.100309>,
      < -0.217249, -0.694390, 0.934905>
    }
    triangle {
      < 0.488532, -0.843545, 1.044919>,
      < 0.520675, -0.876418, 1.077841>,
      < -0.163642, -0.876824, 1.077841>
    }
    triangle {
      < 0.488532, -0.843545, 1.044919>,
      < -0.163642, -0.876824, 1.077841>,
      < -0.217238, -0.712136, 0.917173>
    }
    triangle {
      < -0.217249, -0.694390, 0.934905>,
      < -0.163654, -0.855421, 1.100309>,
      < 0.521193, -0.855015, 1.100309>
    }
    triangle {
      < -0.217249, -0.694390, 0.934905>,
      < 0.521193, -0.855015, 1.100309>,
      < 0.488519, -0.821600, 1.066845>
    }
    triangle {
      < -0.290550, -1.147823, 0.917302>,
      < -0.254553, -0.983244, 1.077615>,
      < -0.254540, -1.005176, 1.099555>
    }
    triangle {
      < -0.290550, -1.147823, 0.917302>,
      < -0.254540, -1.005176, 1.099555>,
      < -0.290540, -1.165560, 0.935044>
    }
    triangle {
      < -0.445882, -1.165652, 0.935044>,
      < -0.446632, -1.005290, 1.099555>,
      < -0.446646, -0.983357, 1.077615>
    }
    triangle {
      < -0.445882, -1.165652, 0.935044>,
      < -0.446646, -0.983357, 1.077615>,
      < -0.445892, -1.147915, 0.917302>
    }
    triangle {
      < -0.290540, -1.165560, 0.935044>,
      < -0.254540, -1.005176, 1.099555>,
      < -0.446632, -1.005290, 1.099555>
    }
    triangle {
      < -0.290540, -1.165560, 0.935044>,
      < -0.446632, -1.005290, 1.099555>,
      < -0.445882, -1.165652, 0.935044>
    }
    triangle {
      < -0.445892, -1.147915, 0.917302>,
      < -0.446646, -0.983357, 1.077615>,
      < -0.254553, -0.983244, 1.077615>
    }
    triangle {
      < -0.445892, -1.147915, 0.917302>,
      < -0.254553, -0.983244, 1.077615>,
      < -0.290550, -1.147823, 0.917302>
    }
    triangle {
      < 0.488634, -1.015459, 1.044970>,
      < 0.520489, -0.982784, 1.077616>,
      < 0.520502, -1.004716, 1.099555>
    }
    triangle {
      < 0.488634, -1.015459, 1.044970>,
      < 0.520502, -1.004716, 1.099555>,
      < 0.488647, -1.037391, 1.066909>
    }
    triangle {
      < -0.216970, -1.165516, 0.935044>,
      < -0.163565, -1.005122, 1.099555>,
      < -0.163579, -0.983190, 1.077616>
    }
    triangle {
      < -0.216970, -1.165516, 0.935044>,
      < -0.163579, -0.983190, 1.077616>,
      < -0.216980, -1.147779, 0.917302>
    }
    triangle {
      < 0.488647, -1.037391, 1.066909>,
      < 0.520502, -1.004716, 1.099555>,
      < -0.163565, -1.005122, 1.099555>
    }
    triangle {
      < 0.488647, -1.037391, 1.066909>,
      < -0.163565, -1.005122, 1.099555>,
      < -0.216970, -1.165516, 0.935044>
    }
    triangle {
      < -0.216980, -1.147779, 0.917302>,
      < -0.163579, -0.983190, 1.077616>,
      < 0.520489, -0.982784, 1.077616>
    }
    triangle {
      < -0.216980, -1.147779, 0.917302>,
      < 0.520489, -0.982784, 1.077616>,
      < 0.488634, -1.015459, 1.044970>
    }
    triangle {
      < -0.290540, -1.165559, 1.370687>,
      < -0.254540, -1.004920, 1.205920>,
      < -0.254542, -1.002154, 1.211352>
    }
    triangle {
      < -0.290540, -1.165559, 1.370687>,
      < -0.254542, -1.002154, 1.211352>,
      < -0.290550, -1.147823, 1.388429>
    }
    triangle {
      < -0.254542, -1.002154, 1.211352>,
      < -0.254553, -0.982445, 1.227316>,
      < -0.290550, -1.147823, 1.388429>
    }
    triangle {
      < -0.445892, -1.147915, 1.388429>,
      < -0.446646, -0.982558, 1.227316>,
      < -0.446634, -1.002267, 1.211352>
    }
    triangle {
      < -0.445892, -1.147915, 1.388429>,
      < -0.446634, -1.002267, 1.211352>,
      < -0.445882, -1.165652, 1.370687>
    }
    triangle {
      < -0.446634, -1.002267, 1.211352>,
      < -0.446632, -1.005033, 1.205920>,
      < -0.445882, -1.165652, 1.370687>
    }
    triangle {
      < -0.290550, -1.147823, 1.388429>,
      < -0.254553, -0.982445, 1.227316>,
      < -0.446646, -0.982558, 1.227316>
    }
    triangle {
      < -0.290550, -1.147823, 1.388429>,
      < -0.446646, -0.982558, 1.227316>,
      < -0.445892, -1.147915, 1.388429>
    }
    triangle {
      < -0.445882, -1.165652, 1.370687>,
      < -0.446632, -1.005033, 1.205920>,
      < -0.254540, -1.004920, 1.205920>
    }
    triangle {
      < -0.445882, -1.165652, 1.370687>,
      < -0.254540, -1.004920, 1.205920>,
      < -0.290540, -1.165559, 1.370687>
    }
    triangle {
      < 0.488647, -1.037391, 1.238822>,
      < 0.520751, -1.004460, 1.205921>,
      < 0.519449, -1.001695, 1.211352>
    }
    triangle {
      < 0.488647, -1.037391, 1.238822>,
      < 0.519449, -1.001695, 1.211352>,
      < 0.488634, -1.015459, 1.260761>
    }
    triangle {
      < 0.519449, -1.001695, 1.211352>,
      < 0.521267, -0.981985, 1.227317>,
      < 0.488634, -1.015459, 1.260761>
    }
    triangle {
      < -0.216980, -1.147779, 1.388429>,
      < -0.163579, -0.982391, 1.227316>,
      < -0.163567, -1.002100, 1.211352>
    }
    triangle {
      < -0.216980, -1.147779, 1.388429>,
      < -0.163567, -1.002100, 1.211352>,
      < -0.216970, -1.165516, 1.370687>
    }
    triangle {
      < -0.163567, -1.002100, 1.211352>,
      < -0.163566, -1.004866, 1.205920>,
      < -0.216970, -1.165516, 1.370687>
    }
    triangle {
      < 0.488634, -1.015459, 1.260761>,
      < 0.521267, -0.981985, 1.227317>,
      < -0.163579, -0.982391, 1.227316>
    }
    triangle {
      < 0.488634, -1.015459, 1.260761>,
      < -0.163579, -0.982391, 1.227316>,
      < -0.216980, -1.147779, 1.388429>
    }
    triangle {
      < -0.216970, -1.165516, 1.370687>,
      < -0.163566, -1.004866, 1.205920>,
      < 0.520751, -1.004460, 1.205921>
    }
    triangle {
      < -0.216970, -1.165516, 1.370687>,
      < 0.520751, -1.004460, 1.205921>,
      < 0.488647, -1.037391, 1.238822>
    }
    triangle {
      < -0.217249, -0.694132, 1.370548>,
      < -0.217239, -0.711857, 1.388300>,
      < 0.488532, -0.843418, 1.260710>
    }
    triangle {
      < -0.217249, -0.694132, 1.370548>,
      < 0.488532, -0.843418, 1.260710>,
      < 0.488519, -0.821499, 1.238758>
    }
    triangle {
      < -0.446161, -0.694268, 1.370548>,
      < -0.446151, -0.711993, 1.388300>,
      < -0.290809, -0.711901, 1.388300>
    }
    triangle {
      < -0.446161, -0.694268, 1.370548>,
      < -0.290809, -0.711901, 1.388300>,
      < -0.290819, -0.694176, 1.370548>
    }
    triangle {
      < -0.216980, -1.147779, 1.388429>,
      < -0.216970, -1.165516, 1.370687>,
      < 0.488647, -1.037391, 1.238822>
    }
    triangle {
      < -0.216980, -1.147779, 1.388429>,
      < 0.488647, -1.037391, 1.238822>,
      < 0.488634, -1.015459, 1.260761>
    }
    triangle {
      < -0.445892, -1.147915, 1.388429>,
      < -0.445882, -1.165652, 1.370687>,
      < -0.290540, -1.165559, 1.370687>
    }
    triangle {
      < -0.445892, -1.147915, 1.388429>,
      < -0.290540, -1.165559, 1.370687>,
      < -0.290550, -1.147823, 1.388429>
    }
    triangle {
      < -0.217238, -0.712136, 0.917173>,
      < -0.217249, -0.694390, 0.934905>,
      < 0.488519, -0.821600, 1.066845>
    }
    triangle {
      < -0.217238, -0.712136, 0.917173>,
      < 0.488519, -0.821600, 1.066845>,
      < 0.488532, -0.843545, 1.044919>
    }
    triangle {
      < -0.446151, -0.712272, 0.917173>,
      < -0.446161, -0.694526, 0.934905>,
      < -0.290819, -0.694434, 0.934905>
    }
    triangle {
      < -0.446151, -0.712272, 0.917173>,
      < -0.290819, -0.694434, 0.934905>,
      < -0.290808, -0.712180, 0.917173>
    }
    triangle {
      < -0.216970, -1.165516, 0.935044>,
      < -0.216980, -1.147779, 0.917302>,
      < 0.488634, -1.015459, 1.044970>
    }
    triangle {
      < -0.216970, -1.165516, 0.935044>,
      < 0.488634, -1.015459, 1.044970>,
      < 0.488647, -1.037391, 1.066909>
    }
    triangle {
      < -0.445882, -1.165652, 0.935044>,
      < -0.445892, -1.147915, 0.917302>,
      < -0.290550, -1.147823, 0.917302>
    }
    triangle {
      < -0.445882, -1.165652, 0.935044>,
      < -0.290550, -1.147823, 0.917302>,
      < -0.290540, -1.165560, 0.935044>
    }
    triangle {
      < -0.163654, -0.855466, 1.205227>,
      < 0.521296, -0.855060, 1.205228>,
      < 0.916933, -0.842418, 1.186118>
    }
    triangle {
      < 0.521296, -0.855060, 1.205228>,
      < 0.519017, -0.863756, 1.218620>,
      < 0.916945, -0.863520, 1.218620>
    }
    triangle {
      < 0.521296, -0.855060, 1.205228>,
      < 0.916945, -0.863520, 1.218620>,
      < 0.916933, -0.842418, 1.186118>
    }
    triangle {
      < -0.163654, -0.855466, 1.205227>,
      < 0.916933, -0.842418, 1.186118>,
      < -0.254629, -0.855520, 1.205227>
    }
    triangle {
      < -0.163654, -0.855466, 1.205227>,
      < -0.254629, -0.855520, 1.205227>,
      < -0.163649, -0.864161, 1.218620>
    }
    triangle {
      < 0.916933, -0.842418, 1.186118>,
      < -0.471259, -0.843241, 1.186118>,
      < -0.446721, -0.855633, 1.205227>
    }
    triangle {
      < 0.916933, -0.842418, 1.186118>,
      < -0.446721, -0.855633, 1.205227>,
      < -0.254629, -0.855520, 1.205227>
    }
    triangle {
      < -0.471259, -0.843241, 1.186118>,
      < -0.471246, -0.864343, 1.218620>,
      < -0.446716, -0.864328, 1.218620>
    }
    triangle {
      < -0.471259, -0.843241, 1.186118>,
      < -0.446716, -0.864328, 1.218620>,
      < -0.446721, -0.855633, 1.205227>
    }
    triangle {
      < -0.254629, -0.855520, 1.205227>,
      < -0.254624, -0.864215, 1.218620>,
      < -0.163649, -0.864161, 1.218620>
    }
    triangle {
      < -0.254629, -0.855475, 1.100309>,
      < -0.446721, -0.855588, 1.100309>,
      < -0.471256, -0.847241, 1.110626>
    }
    triangle {
      < -0.446721, -0.855588, 1.100309>,
      < -0.446711, -0.871559, 1.080605>,
      < -0.471242, -0.871574, 1.080605>
    }
    triangle {
      < -0.446721, -0.855588, 1.100309>,
      < -0.471242, -0.871574, 1.080605>,
      < -0.471256, -0.847241, 1.110626>
    }
    triangle {
      < -0.254629, -0.855475, 1.100309>,
      < -0.471256, -0.847241, 1.110626>,
      < -0.163654, -0.855421, 1.100309>
    }
    triangle {
      < -0.254629, -0.855475, 1.100309>,
      < -0.163654, -0.855421, 1.100309>,
      < -0.254619, -0.871446, 1.080605>
    }
    triangle {
      < -0.471256, -0.847241, 1.110626>,
      < 0.916934, -0.846419, 1.110626>,
      < 0.521193, -0.855015, 1.100309>
    }
    triangle {
      < -0.471256, -0.847241, 1.110626>,
      < 0.521193, -0.855015, 1.100309>,
      < -0.163654, -0.855421, 1.100309>
    }
    triangle {
      < 0.916934, -0.846419, 1.110626>,
      < 0.916949, -0.870751, 1.080605>,
      < 0.519372, -0.870987, 1.080605>
    }
    triangle {
      < 0.916934, -0.846419, 1.110626>,
      < 0.519372, -0.870987, 1.080605>,
      < 0.521193, -0.855015, 1.100309>
    }
    triangle {
      < -0.163654, -0.855421, 1.100309>,
      < -0.163644, -0.871392, 1.080605>,
      < -0.254619, -0.871446, 1.080605>
    }
    triangle {
      < -0.163642, -0.876824, 1.077841>,
      < 0.520675, -0.876418, 1.077841>,
      < 0.916969, -0.905190, 1.063075>
    }
    triangle {
      < 0.520675, -0.876418, 1.077841>,
      < 0.519372, -0.870987, 1.080605>,
      < 0.916949, -0.870751, 1.080605>
    }
    triangle {
      < 0.520675, -0.876418, 1.077841>,
      < 0.916949, -0.870751, 1.080605>,
      < 0.916969, -0.905190, 1.063075>
    }
    triangle {
      < -0.163642, -0.876824, 1.077841>,
      < 0.916969, -0.905190, 1.063075>,
      < -0.254616, -0.876878, 1.077841>
    }
    triangle {
      < -0.163642, -0.876824, 1.077841>,
      < -0.254616, -0.876878, 1.077841>,
      < -0.163644, -0.871392, 1.080605>
    }
    triangle {
      < 0.916969, -0.905190, 1.063075>,
      < -0.471222, -0.906013, 1.063075>,
      < -0.446709, -0.876991, 1.077841>
    }
    triangle {
      < 0.916969, -0.905190, 1.063075>,
      < -0.446709, -0.876991, 1.077841>,
      < -0.254616, -0.876878, 1.077841>
    }
    triangle {
      < -0.471222, -0.906013, 1.063075>,
      < -0.471242, -0.871574, 1.080605>,
      < -0.446711, -0.871559, 1.080605>
    }
    triangle {
      < -0.471222, -0.906013, 1.063075>,
      < -0.446711, -0.871559, 1.080605>,
      < -0.446709, -0.876991, 1.077841>
    }
    triangle {
      < -0.254616, -0.876878, 1.077841>,
      < -0.254619, -0.871446, 1.080605>,
      < -0.163644, -0.871392, 1.080605>
    }
    triangle {
      < 0.917014, -0.979855, 1.074921>,
      < 0.520489, -0.982784, 1.077616>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < 0.917014, -0.979855, 1.074921>,
      < 0.917030, -1.007175, 1.102251>,
      < 0.520502, -1.004716, 1.099555>
    }
    triangle {
      < 0.917014, -0.979855, 1.074921>,
      < 0.520502, -1.004716, 1.099555>,
      < 0.520489, -0.982784, 1.077616>
    }
    triangle {
      < 0.917030, -1.007175, 1.102251>,
      < -0.163565, -1.005122, 1.099555>,
      < 0.520502, -1.004716, 1.099555>
    }
    triangle {
      < 0.917030, -1.007175, 1.102251>,
      < -0.254540, -1.005176, 1.099555>,
      < -0.163565, -1.005122, 1.099555>
    }
    triangle {
      < 0.520489, -0.982784, 1.077616>,
      < -0.163579, -0.983190, 1.077616>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < -0.163579, -0.983190, 1.077616>,
      < -0.254553, -0.983244, 1.077615>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < -0.163579, -0.983190, 1.077616>,
      < -0.163565, -1.005122, 1.099555>,
      < -0.254553, -0.983244, 1.077615>
    }
    triangle {
      < -0.163565, -1.005122, 1.099555>,
      < -0.254540, -1.005176, 1.099555>,
      < -0.254553, -0.983244, 1.077615>
    }
    triangle {
      < 0.917030, -1.007175, 1.102251>,
      < -0.471161, -1.007998, 1.102250>,
      < -0.446632, -1.005290, 1.099555>
    }
    triangle {
      < 0.917030, -1.007175, 1.102251>,
      < -0.446632, -1.005290, 1.099555>,
      < -0.254540, -1.005176, 1.099555>
    }
    triangle {
      < -0.254553, -0.983244, 1.077615>,
      < -0.446646, -0.983357, 1.077615>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < -0.446646, -0.983357, 1.077615>,
      < -0.446632, -1.005290, 1.099555>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < -0.446632, -1.005290, 1.099555>,
      < -0.471161, -1.007998, 1.102250>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < -0.254540, -1.004920, 1.205920>,
      < -0.446632, -1.005033, 1.205920>,
      < -0.471154, -1.019822, 1.176918>
    }
    triangle {
      < -0.446632, -1.005033, 1.205920>,
      < -0.446634, -1.002267, 1.211352>,
      < -0.471164, -1.002282, 1.211352>
    }
    triangle {
      < -0.446632, -1.005033, 1.205920>,
      < -0.471164, -1.002282, 1.211352>,
      < -0.471154, -1.019822, 1.176918>
    }
    triangle {
      < -0.254540, -1.004920, 1.205920>,
      < -0.471154, -1.019822, 1.176918>,
      < -0.163566, -1.004866, 1.205920>
    }
    triangle {
      < -0.254540, -1.004920, 1.205920>,
      < -0.163566, -1.004866, 1.205920>,
      < -0.254542, -1.002154, 1.211352>
    }
    triangle {
      < -0.471154, -1.019822, 1.176918>,
      < 0.917037, -1.019000, 1.176918>,
      < 0.520751, -1.004460, 1.205921>
    }
    triangle {
      < -0.471154, -1.019822, 1.176918>,
      < 0.520751, -1.004460, 1.205921>,
      < -0.163566, -1.004866, 1.205920>
    }
    triangle {
      < 0.917037, -1.019000, 1.176918>,
      < 0.917026, -1.001459, 1.211352>,
      < 0.519449, -1.001695, 1.211352>
    }
    triangle {
      < 0.917037, -1.019000, 1.176918>,
      < 0.519449, -1.001695, 1.211352>,
      < 0.520751, -1.004460, 1.205921>
    }
    triangle {
      < -0.163566, -1.004866, 1.205920>,
      < -0.163567, -1.002100, 1.211352>,
      < -0.254542, -1.002154, 1.211352>
    }
    triangle {
      < -0.163579, -0.982391, 1.227316>,
      < 0.521267, -0.981985, 1.227317>,
      < 0.917009, -0.971431, 1.235675>
    }
    triangle {
      < 0.521267, -0.981985, 1.227317>,
      < 0.519449, -1.001695, 1.211352>,
      < 0.917026, -1.001459, 1.211352>
    }
    triangle {
      < 0.521267, -0.981985, 1.227317>,
      < 0.917026, -1.001459, 1.211352>,
      < 0.917009, -0.971431, 1.235675>
    }
    triangle {
      < -0.163579, -0.982391, 1.227316>,
      < 0.917009, -0.971431, 1.235675>,
      < -0.254553, -0.982445, 1.227316>
    }
    triangle {
      < -0.163579, -0.982391, 1.227316>,
      < -0.254553, -0.982445, 1.227316>,
      < -0.163567, -1.002100, 1.211352>
    }
    triangle {
      < 0.917009, -0.971431, 1.235675>,
      < -0.471182, -0.972254, 1.235675>,
      < -0.446646, -0.982558, 1.227316>
    }
    triangle {
      < 0.917009, -0.971431, 1.235675>,
      < -0.446646, -0.982558, 1.227316>,
      < -0.254553, -0.982445, 1.227316>
    }
    triangle {
      < -0.471182, -0.972254, 1.235675>,
      < -0.471164, -1.002282, 1.211352>,
      < -0.446634, -1.002267, 1.211352>
    }
    triangle {
      < -0.471182, -0.972254, 1.235675>,
      < -0.446634, -1.002267, 1.211352>,
      < -0.446646, -0.982558, 1.227316>
    }
    triangle {
      < -0.254553, -0.982445, 1.227316>,
      < -0.254542, -1.002154, 1.211352>,
      < -0.163567, -1.002100, 1.211352>
    }
    triangle {
      < -0.254615, -0.877426, 1.227192>,
      < -0.446708, -0.877539, 1.227192>,
      < -0.471227, -0.896761, 1.239654>
    }
    triangle {
      < -0.446708, -0.877539, 1.227192>,
      < -0.446716, -0.864328, 1.218620>,
      < -0.471246, -0.864343, 1.218620>
    }
    triangle {
      < -0.446708, -0.877539, 1.227192>,
      < -0.471246, -0.864343, 1.218620>,
      < -0.471227, -0.896761, 1.239654>
    }
    triangle {
      < -0.254615, -0.877426, 1.227192>,
      < -0.471227, -0.896761, 1.239654>,
      < -0.163641, -0.877372, 1.227192>
    }
    triangle {
      < -0.254615, -0.877426, 1.227192>,
      < -0.163641, -0.877372, 1.227192>,
      < -0.254624, -0.864215, 1.218620>
    }
    triangle {
      < -0.471227, -0.896761, 1.239654>,
      < 0.916964, -0.895938, 1.239654>,
      < 0.521297, -0.876966, 1.227192>
    }
    triangle {
      < -0.471227, -0.896761, 1.239654>,
      < 0.521297, -0.876966, 1.227192>,
      < -0.163641, -0.877372, 1.227192>
    }
    triangle {
      < 0.916964, -0.895938, 1.239654>,
      < 0.916945, -0.863520, 1.218620>,
      < 0.519017, -0.863756, 1.218620>
    }
    triangle {
      < 0.916964, -0.895938, 1.239654>,
      < 0.519017, -0.863756, 1.218620>,
      < 0.521297, -0.876966, 1.227192>
    }
    triangle {
      < -0.163641, -0.877372, 1.227192>,
      < -0.163649, -0.864161, 1.218620>,
      < -0.254624, -0.864215, 1.218620>
    }
    triangle {
      < 0.916945, -0.863520, 1.218620>,
      < 0.916964, -0.895938, 1.239654>,
      < 1.139657, -0.902461, 1.222296>
    }
    triangle {
      < 0.916945, -0.863520, 1.218620>,
      < 1.139657, -0.902461, 1.222296>,
      < 1.139642, -0.876528, 1.205469>
    }
    triangle {
      < 0.916933, -0.842418, 1.186118>,
      < 0.916945, -0.863520, 1.218620>,
      < 1.139642, -0.876528, 1.205469>
    }
    triangle {
      < 0.916933, -0.842418, 1.186118>,
      < 1.139642, -0.876528, 1.205469>,
      < 1.139632, -0.859647, 1.179467>
    }
    triangle {
      < -0.482818, -0.860608, 1.179467>,
      < -0.482807, -0.877489, 1.205469>,
      < -0.471246, -0.864343, 1.218620>
    }
    triangle {
      < -0.482818, -0.860608, 1.179467>,
      < -0.471246, -0.864343, 1.218620>,
      < -0.471259, -0.843241, 1.186118>
    }
    triangle {
      < -0.482807, -0.877489, 1.205469>,
      < -0.482791, -0.903423, 1.222295>,
      < -0.471227, -0.896761, 1.239654>
    }
    triangle {
      < -0.482807, -0.877489, 1.205469>,
      < -0.471227, -0.896761, 1.239654>,
      < -0.471246, -0.864343, 1.218620>
    }
    triangle {
      < -0.471227, -0.896761, 1.239654>,
      < -0.471205, -0.934931, 1.245686>,
      < 0.916987, -0.934108, 1.245686>
    }
    triangle {
      < -0.471227, -0.896761, 1.239654>,
      < 0.916987, -0.934108, 1.245686>,
      < 0.916964, -0.895938, 1.239654>
    }
    triangle {
      < -0.482791, -0.903423, 1.222295>,
      < -0.482773, -0.933958, 1.227122>,
      < -0.471205, -0.934931, 1.245686>
    }
    triangle {
      < -0.482791, -0.903423, 1.222295>,
      < -0.471205, -0.934931, 1.245686>,
      < -0.471227, -0.896761, 1.239654>
    }
    triangle {
      < 0.916964, -0.895938, 1.239654>,
      < 0.916987, -0.934108, 1.245686>,
      < 1.139675, -0.932997, 1.227122>
    }
    triangle {
      < 0.916964, -0.895938, 1.239654>,
      < 1.139675, -0.932997, 1.227122>,
      < 1.139657, -0.902461, 1.222296>
    }
    triangle {
      < -0.471263, -0.837219, 1.147946>,
      < -0.471259, -0.843241, 1.186118>,
      < 0.916933, -0.842418, 1.186118>
    }
    triangle {
      < -0.471263, -0.837219, 1.147946>,
      < 0.916933, -0.842418, 1.186118>,
      < 0.916929, -0.836397, 1.147946>
    }
    triangle {
      < 0.916929, -0.836397, 1.147946>,
      < 0.916933, -0.842418, 1.186118>,
      < 1.139632, -0.859647, 1.179467>
    }
    triangle {
      < 0.916929, -0.836397, 1.147946>,
      < 1.139632, -0.859647, 1.179467>,
      < 1.139629, -0.854829, 1.148931>
    }
    triangle {
      < -0.482820, -0.855790, 1.148931>,
      < -0.482818, -0.860608, 1.179467>,
      < -0.471259, -0.843241, 1.186118>
    }
    triangle {
      < -0.482820, -0.855790, 1.148931>,
      < -0.471259, -0.843241, 1.186118>,
      < -0.471263, -0.837219, 1.147946>
    }
    triangle {
      < 1.139632, -0.859647, 1.179467>,
      < 1.139642, -0.876528, 1.205469>,
      < 1.237981, -0.889609, 1.192318>
    }
    triangle {
      < 1.139632, -0.859647, 1.179467>,
      < 1.237981, -0.889609, 1.192318>,
      < 1.237973, -0.876947, 1.172817>
    }
    triangle {
      < -0.398932, -0.885358, 1.169967>,
      < -0.398926, -0.896209, 1.186682>,
      < -0.482807, -0.877489, 1.205469>
    }
    triangle {
      < -0.398932, -0.885358, 1.169967>,
      < -0.482807, -0.877489, 1.205469>,
      < -0.482818, -0.860608, 1.179467>
    }
    triangle {
      < 1.139642, -0.876528, 1.205469>,
      < 1.139657, -0.902461, 1.222296>,
      < 1.237992, -0.909059, 1.204939>
    }
    triangle {
      < 1.139642, -0.876528, 1.205469>,
      < 1.237992, -0.909059, 1.204939>,
      < 1.237981, -0.889609, 1.192318>
    }
    triangle {
      < -0.398926, -0.896209, 1.186682>,
      < -0.398916, -0.912882, 1.197499>,
      < -0.482791, -0.903423, 1.222295>
    }
    triangle {
      < -0.398926, -0.896209, 1.186682>,
      < -0.482791, -0.903423, 1.222295>,
      < -0.482807, -0.877489, 1.205469>
    }
    triangle {
      < 1.139657, -0.902461, 1.222296>,
      < 1.139675, -0.932997, 1.227122>,
      < 1.238006, -0.931961, 1.208558>
    }
    triangle {
      < 1.139657, -0.902461, 1.222296>,
      < 1.238006, -0.931961, 1.208558>,
      < 1.237992, -0.909059, 1.204939>
    }
    triangle {
      < -0.398916, -0.912882, 1.197499>,
      < -0.398904, -0.932511, 1.200602>,
      < -0.482773, -0.933958, 1.227122>
    }
    triangle {
      < -0.398916, -0.912882, 1.197499>,
      < -0.482773, -0.933958, 1.227122>,
      < -0.482791, -0.903423, 1.222295>
    }
    triangle {
      < -0.398934, -0.882260, 1.150336>,
      < -0.398932, -0.885358, 1.169967>,
      < -0.482818, -0.860608, 1.179467>
    }
    triangle {
      < -0.398934, -0.882260, 1.150336>,
      < -0.482818, -0.860608, 1.179467>,
      < -0.482820, -0.855790, 1.148931>
    }
    triangle {
      < 1.139629, -0.854829, 1.148931>,
      < 1.139632, -0.859647, 1.179467>,
      < 1.237973, -0.876947, 1.172817>
    }
    triangle {
      < 1.139629, -0.854829, 1.148931>,
      < 1.237973, -0.876947, 1.172817>,
      < 1.237971, -0.873334, 1.149915>
    }
    triangle {
      < 0.916987, -0.934108, 1.245686>,
      < 0.917009, -0.971431, 1.235675>,
      < 1.139693, -0.962857, 1.219113>
    }
    triangle {
      < 0.916987, -0.934108, 1.245686>,
      < 1.139693, -0.962857, 1.219113>,
      < 1.139675, -0.932997, 1.227122>
    }
    triangle {
      < -0.482773, -0.933958, 1.227122>,
      < -0.482756, -0.963818, 1.219113>,
      < -0.471182, -0.972254, 1.235675>
    }
    triangle {
      < -0.482773, -0.933958, 1.227122>,
      < -0.471182, -0.972254, 1.235675>,
      < -0.471205, -0.934931, 1.245686>
    }
    triangle {
      < -0.471205, -0.934931, 1.245686>,
      < -0.471182, -0.972254, 1.235675>,
      < 0.917009, -0.971431, 1.235675>
    }
    triangle {
      < -0.471205, -0.934931, 1.245686>,
      < 0.917009, -0.971431, 1.235675>,
      < 0.916987, -0.934108, 1.245686>
    }
    triangle {
      < 0.916934, -0.846419, 1.110626>,
      < 0.916929, -0.836397, 1.147946>,
      < 1.139629, -0.854829, 1.148931>
    }
    triangle {
      < 0.916934, -0.846419, 1.110626>,
      < 1.139629, -0.854829, 1.148931>,
      < 1.139634, -0.862847, 1.119074>
    }
    triangle {
      < -0.471256, -0.847241, 1.110626>,
      < -0.471263, -0.837219, 1.147946>,
      < 0.916929, -0.836397, 1.147946>
    }
    triangle {
      < -0.471256, -0.847241, 1.110626>,
      < 0.916929, -0.836397, 1.147946>,
      < 0.916934, -0.846419, 1.110626>
    }
    triangle {
      < -0.482815, -0.863808, 1.119074>,
      < -0.482820, -0.855790, 1.148931>,
      < -0.471263, -0.837219, 1.147946>
    }
    triangle {
      < -0.482815, -0.863808, 1.119074>,
      < -0.471263, -0.837219, 1.147946>,
      < -0.471256, -0.847241, 1.110626>
    }
    triangle {
      < 1.237973, -0.876947, 1.172817>,
      < 1.237981, -0.889609, 1.192318>,
      < 1.292938, -0.904593, 1.177289>
    }
    triangle {
      < 1.237973, -0.876947, 1.172817>,
      < 1.292938, -0.904593, 1.177289>,
      < 1.292934, -0.896755, 1.165217>
    }
    triangle {
      < 1.237981, -0.889609, 1.192318>,
      < 1.237992, -0.909059, 1.204939>,
      < 1.292945, -0.916634, 1.185102>
    }
    triangle {
      < 1.237981, -0.889609, 1.192318>,
      < 1.292945, -0.916634, 1.185102>,
      < 1.292938, -0.904593, 1.177289>
    }
    triangle {
      < 1.237992, -0.909059, 1.204939>,
      < 1.238006, -0.931961, 1.208558>,
      < 1.292953, -0.930811, 1.187342>
    }
    triangle {
      < 1.237992, -0.909059, 1.204939>,
      < 1.292953, -0.930811, 1.187342>,
      < 1.292945, -0.916634, 1.185102>
    }
    triangle {
      < 1.237971, -0.873334, 1.149915>,
      < 1.237973, -0.876947, 1.172817>,
      < 1.292934, -0.896755, 1.165217>
    }
    triangle {
      < 1.237971, -0.873334, 1.149915>,
      < 1.292934, -0.896755, 1.165217>,
      < 1.292932, -0.894518, 1.151039>
    }
    triangle {
      < 1.139675, -0.932997, 1.227122>,
      < 1.139693, -0.962857, 1.219113>,
      < 1.238018, -0.954356, 1.202551>
    }
    triangle {
      < 1.139675, -0.932997, 1.227122>,
      < 1.238018, -0.954356, 1.202551>,
      < 1.238006, -0.931961, 1.208558>
    }
    triangle {
      < -0.398904, -0.932511, 1.200602>,
      < -0.398894, -0.951707, 1.195453>,
      < -0.482756, -0.963818, 1.219113>
    }
    triangle {
      < -0.398904, -0.932511, 1.200602>,
      < -0.482756, -0.963818, 1.219113>,
      < -0.482773, -0.933958, 1.227122>
    }
    triangle {
      < 1.139634, -0.862847, 1.119074>,
      < 1.139629, -0.854829, 1.148931>,
      < 1.237971, -0.873334, 1.149915>
    }
    triangle {
      < 1.139634, -0.862847, 1.119074>,
      < 1.237971, -0.873334, 1.149915>,
      < 1.237974, -0.879348, 1.127522>
    }
    triangle {
      < -0.398931, -0.887414, 1.131142>,
      < -0.398934, -0.882260, 1.150336>,
      < -0.482820, -0.855790, 1.148931>
    }
    triangle {
      < -0.398931, -0.887414, 1.131142>,
      < -0.482820, -0.855790, 1.148931>,
      < -0.482815, -0.863808, 1.119074>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398926, -0.896209, 1.186682>,
      < -0.398932, -0.885358, 1.169967>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398916, -0.912882, 1.197499>,
      < -0.398926, -0.896209, 1.186682>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398904, -0.932511, 1.200602>,
      < -0.398916, -0.912882, 1.197499>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398932, -0.885358, 1.169967>,
      < -0.398934, -0.882260, 1.150336>
    }
    triangle {
      < 1.238006, -0.931961, 1.208558>,
      < 1.238018, -0.954356, 1.202551>,
      < 1.292962, -0.944673, 1.183624>
    }
    triangle {
      < 1.238006, -0.931961, 1.208558>,
      < 1.292962, -0.944673, 1.183624>,
      < 1.292953, -0.930811, 1.187342>
    }
    triangle {
      < 1.237974, -0.879348, 1.127522>,
      < 1.237971, -0.873334, 1.149915>,
      < 1.292932, -0.894518, 1.151039>
    }
    triangle {
      < 1.237974, -0.879348, 1.127522>,
      < 1.292932, -0.894518, 1.151039>,
      < 1.292935, -0.898241, 1.137177>
    }
    triangle {
      < 1.292938, -0.904593, 1.177289>,
      < 1.292945, -0.916634, 1.185102>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.292934, -0.896755, 1.165217>,
      < 1.292938, -0.904593, 1.177289>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398894, -0.951707, 1.195453>,
      < -0.398904, -0.932511, 1.200602>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398934, -0.882260, 1.150336>,
      < -0.398931, -0.887414, 1.131142>
    }
    triangle {
      < 1.292945, -0.916634, 1.185102>,
      < 1.292953, -0.930811, 1.187342>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.292932, -0.894518, 1.151039>,
      < 1.292934, -0.896755, 1.165217>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < -0.482756, -0.963818, 1.219113>,
      < -0.482742, -0.987840, 1.199654>,
      < -0.471164, -1.002282, 1.211352>
    }
    triangle {
      < -0.482756, -0.963818, 1.219113>,
      < -0.471164, -1.002282, 1.211352>,
      < -0.471182, -0.972254, 1.235675>
    }
    triangle {
      < 0.917009, -0.971431, 1.235675>,
      < 0.917026, -1.001459, 1.211352>,
      < 1.139708, -0.986879, 1.199655>
    }
    triangle {
      < 0.917009, -0.971431, 1.235675>,
      < 1.139708, -0.986879, 1.199655>,
      < 1.139693, -0.962857, 1.219113>
    }
    triangle {
      < -0.482804, -0.883274, 1.095057>,
      < -0.482815, -0.863808, 1.119074>,
      < -0.471256, -0.847241, 1.110626>
    }
    triangle {
      < -0.482804, -0.883274, 1.095057>,
      < -0.471256, -0.847241, 1.110626>,
      < -0.471242, -0.871574, 1.080605>
    }
    triangle {
      < 0.916949, -0.870751, 1.080605>,
      < 0.916934, -0.846419, 1.110626>,
      < 1.139634, -0.862847, 1.119074>
    }
    triangle {
      < 0.916949, -0.870751, 1.080605>,
      < 1.139634, -0.862847, 1.119074>,
      < 1.139646, -0.882313, 1.095057>
    }
    triangle {
      < 1.292953, -0.930811, 1.187342>,
      < 1.292962, -0.944673, 1.183624>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.292935, -0.898241, 1.137177>,
      < 1.292932, -0.894518, 1.151039>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.139693, -0.962857, 1.219113>,
      < 1.139708, -0.986879, 1.199655>,
      < 1.238029, -0.972372, 1.187957>
    }
    triangle {
      < 1.139693, -0.962857, 1.219113>,
      < 1.238029, -0.972372, 1.187957>,
      < 1.238018, -0.954356, 1.202551>
    }
    triangle {
      < -0.398894, -0.951707, 1.195453>,
      < -0.398884, -0.967150, 1.182944>,
      < -0.482742, -0.987840, 1.199654>
    }
    triangle {
      < -0.398894, -0.951707, 1.195453>,
      < -0.482742, -0.987840, 1.199654>,
      < -0.482756, -0.963818, 1.219113>
    }
    triangle {
      < 1.139646, -0.882313, 1.095057>,
      < 1.139634, -0.862847, 1.119074>,
      < 1.237974, -0.879348, 1.127522>
    }
    triangle {
      < 1.139646, -0.882313, 1.095057>,
      < 1.237974, -0.879348, 1.127522>,
      < 1.237983, -0.893947, 1.109509>
    }
    triangle {
      < -0.398924, -0.899929, 1.115703>,
      < -0.398931, -0.887414, 1.131142>,
      < -0.482815, -0.863808, 1.119074>
    }
    triangle {
      < -0.398924, -0.899929, 1.115703>,
      < -0.482815, -0.863808, 1.119074>,
      < -0.482804, -0.883274, 1.095057>
    }
    triangle {
      < 1.238018, -0.954356, 1.202551>,
      < 1.238029, -0.972372, 1.187957>,
      < 1.292969, -0.955826, 1.174589>
    }
    triangle {
      < 1.238018, -0.954356, 1.202551>,
      < 1.292969, -0.955826, 1.174589>,
      < 1.292962, -0.944673, 1.183624>
    }
    triangle {
      < 1.237983, -0.893947, 1.109509>,
      < 1.237974, -0.879348, 1.127522>,
      < 1.292935, -0.898241, 1.137177>
    }
    triangle {
      < 1.237983, -0.893947, 1.109509>,
      < 1.292935, -0.898241, 1.137177>,
      < 1.292940, -0.907279, 1.126026>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398884, -0.967150, 1.182944>,
      < -0.398894, -0.951707, 1.195453>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398931, -0.887414, 1.131142>,
      < -0.398924, -0.899929, 1.115703>
    }
    triangle {
      < 1.292962, -0.944673, 1.183624>,
      < 1.292969, -0.955826, 1.174589>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.292940, -0.907279, 1.126026>,
      < 1.292935, -0.898241, 1.137177>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398924, -0.899929, 1.115703>,
      < -0.398913, -0.917640, 1.106687>
    }
    triangle {
      < 1.292969, -0.955826, 1.174589>,
      < 1.292972, -0.962342, 1.161800>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398913, -0.917640, 1.106687>,
      < -0.398902, -0.937487, 1.105653>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398891, -0.956039, 1.112779>,
      < -0.398882, -0.970090, 1.126834>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398902, -0.937487, 1.105653>,
      < -0.398891, -0.956039, 1.112779>
    }
    triangle {
      < 1.292970, -0.957950, 1.134066>,
      < 1.292963, -0.947802, 1.123915>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.292947, -0.920070, 1.119515>,
      < 1.292940, -0.907279, 1.126026>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.292955, -0.934403, 1.118767>,
      < 1.292947, -0.920070, 1.119515>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398878, -0.976171, 1.165236>,
      < -0.398884, -0.967150, 1.182944>
    }
    triangle {
      < 1.292972, -0.962342, 1.161800>,
      < 1.292972, -0.963093, 1.147466>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < 1.292963, -0.947802, 1.123915>,
      < 1.292955, -0.934403, 1.118767>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398878, -0.977211, 1.145389>,
      < -0.398878, -0.976171, 1.165236>
    }
    triangle {
      < 1.292972, -0.963093, 1.147466>,
      < 1.292970, -0.957950, 1.134066>,
      < 1.339226, -0.928966, 1.152865>
    }
    triangle {
      < -0.381554, -0.929985, 1.152865>,
      < -0.398882, -0.970090, 1.126834>,
      < -0.398878, -0.977211, 1.145389>
    }
    triangle {
      < 1.238029, -0.972372, 1.187957>,
      < 1.238035, -0.982896, 1.167297>,
      < 1.292972, -0.962342, 1.161800>
    }
    triangle {
      < 1.238029, -0.972372, 1.187957>,
      < 1.292972, -0.962342, 1.161800>,
      < 1.292969, -0.955826, 1.174589>
    }
    triangle {
      < 1.237995, -0.914610, 1.098991>,
      < 1.237983, -0.893947, 1.109509>,
      < 1.292940, -0.907279, 1.126026>
    }
    triangle {
      < 1.237995, -0.914610, 1.098991>,
      < 1.292940, -0.907279, 1.126026>,
      < 1.292947, -0.920070, 1.119515>
    }
    triangle {
      < -0.398884, -0.967150, 1.182944>,
      < -0.398878, -0.976171, 1.165236>,
      < -0.482734, -1.001872, 1.172107>
    }
    triangle {
      < -0.398884, -0.967150, 1.182944>,
      < -0.482734, -1.001872, 1.172107>,
      < -0.482742, -0.987840, 1.199654>
    }
    triangle {
      < -0.398913, -0.917640, 1.106687>,
      < -0.398924, -0.899929, 1.115703>,
      < -0.482804, -0.883274, 1.095057>
    }
    triangle {
      < -0.398913, -0.917640, 1.106687>,
      < -0.482804, -0.883274, 1.095057>,
      < -0.482787, -0.910825, 1.081033>
    }
    triangle {
      < 1.139708, -0.986879, 1.199655>,
      < 1.139716, -1.000911, 1.172108>,
      < 1.238035, -0.982896, 1.167297>
    }
    triangle {
      < 1.139708, -0.986879, 1.199655>,
      < 1.238035, -0.982896, 1.167297>,
      < 1.238029, -0.972372, 1.187957>
    }
    triangle {
      < 1.139662, -0.909864, 1.081033>,
      < 1.139646, -0.882313, 1.095057>,
      < 1.237983, -0.893947, 1.109509>
    }
    triangle {
      < 1.139662, -0.909864, 1.081033>,
      < 1.237983, -0.893947, 1.109509>,
      < 1.237995, -0.914610, 1.098991>
    }
    triangle {
      < -0.482742, -0.987840, 1.199654>,
      < -0.482734, -1.001872, 1.172107>,
      < -0.471154, -1.019822, 1.176918>
    }
    triangle {
      < -0.482742, -0.987840, 1.199654>,
      < -0.471154, -1.019822, 1.176918>,
      < -0.471164, -1.002282, 1.211352>
    }
    triangle {
      < 0.917026, -1.001459, 1.211352>,
      < 0.917037, -1.019000, 1.176918>,
      < 1.139716, -1.000911, 1.172108>
    }
    triangle {
      < 0.917026, -1.001459, 1.211352>,
      < 1.139716, -1.000911, 1.172108>,
      < 1.139708, -0.986879, 1.199655>
    }
    triangle {
      < 0.916969, -0.905190, 1.063075>,
      < 0.916949, -0.870751, 1.080605>,
      < 1.139646, -0.882313, 1.095057>
    }
    triangle {
      < 0.916969, -0.905190, 1.063075>,
      < 1.139646, -0.882313, 1.095057>,
      < 1.139662, -0.909864, 1.081033>
    }
    triangle {
      < -0.482787, -0.910825, 1.081033>,
      < -0.482804, -0.883274, 1.095057>,
      < -0.471242, -0.871574, 1.080605>
    }
    triangle {
      < -0.482787, -0.910825, 1.081033>,
      < -0.471242, -0.871574, 1.080605>,
      < -0.471222, -0.906013, 1.063075>
    }
    triangle {
      < 1.238035, -0.982896, 1.167297>,
      < 1.238036, -0.984110, 1.144143>,
      < 1.292972, -0.963093, 1.147466>
    }
    triangle {
      < 1.238035, -0.982896, 1.167297>,
      < 1.292972, -0.963093, 1.147466>,
      < 1.292972, -0.962342, 1.161800>
    }
    triangle {
      < 1.238009, -0.937765, 1.097785>,
      < 1.237995, -0.914610, 1.098991>,
      < 1.292947, -0.920070, 1.119515>
    }
    triangle {
      < 1.238009, -0.937765, 1.097785>,
      < 1.292947, -0.920070, 1.119515>,
      < 1.292955, -0.934403, 1.118767>
    }
    triangle {
      < -0.398878, -0.976171, 1.165236>,
      < -0.398878, -0.977211, 1.145389>,
      < -0.482732, -1.003490, 1.141235>
    }
    triangle {
      < -0.398878, -0.976171, 1.165236>,
      < -0.482732, -1.003490, 1.141235>,
      < -0.482734, -1.001872, 1.172107>
    }
    triangle {
      < -0.398902, -0.937487, 1.105653>,
      < -0.398913, -0.917640, 1.106687>,
      < -0.482787, -0.910825, 1.081033>
    }
    triangle {
      < -0.398902, -0.937487, 1.105653>,
      < -0.482787, -0.910825, 1.081033>,
      < -0.482769, -0.941698, 1.079424>
    }
    triangle {
      < 1.139716, -1.000911, 1.172108>,
      < 1.139717, -1.002529, 1.141235>,
      < 1.238036, -0.984110, 1.144143>
    }
    triangle {
      < 1.139716, -1.000911, 1.172108>,
      < 1.238036, -0.984110, 1.144143>,
      < 1.238035, -0.982896, 1.167297>
    }
    triangle {
      < 1.238036, -0.984110, 1.144143>,
      < 1.238032, -0.975802, 1.122496>,
      < 1.292970, -0.957950, 1.134066>
    }
    triangle {
      < 1.238036, -0.984110, 1.144143>,
      < 1.292970, -0.957950, 1.134066>,
      < 1.292972, -0.963093, 1.147466>
    }
    triangle {
      < 1.139681, -0.940737, 1.079425>,
      < 1.139662, -0.909864, 1.081033>,
      < 1.237995, -0.914610, 1.098991>
    }
    triangle {
      < 1.139681, -0.940737, 1.079425>,
      < 1.237995, -0.914610, 1.098991>,
      < 1.238009, -0.937765, 1.097785>
    }
    triangle {
      < 1.238022, -0.959409, 1.106099>,
      < 1.238009, -0.937765, 1.097785>,
      < 1.292955, -0.934403, 1.118767>
    }
    triangle {
      < 1.238022, -0.959409, 1.106099>,
      < 1.292955, -0.934403, 1.118767>,
      < 1.292963, -0.947802, 1.123915>
    }
    triangle {
      < 1.238032, -0.975802, 1.122496>,
      < 1.238022, -0.959409, 1.106099>,
      < 1.292963, -0.947802, 1.123915>
    }
    triangle {
      < 1.238032, -0.975802, 1.122496>,
      < 1.292963, -0.947802, 1.123915>,
      < 1.292970, -0.957950, 1.134066>
    }
    triangle {
      < -0.482734, -1.001872, 1.172107>,
      < -0.482732, -1.003490, 1.141235>,
      < -0.471153, -1.021844, 1.138327>
    }
    triangle {
      < -0.482734, -1.001872, 1.172107>,
      < -0.471153, -1.021844, 1.138327>,
      < -0.471154, -1.019822, 1.176918>
    }
    triangle {
      < 0.917037, -1.019000, 1.176918>,
      < 0.917038, -1.021021, 1.138327>,
      < 1.139717, -1.002529, 1.141235>
    }
    triangle {
      < 0.917037, -1.019000, 1.176918>,
      < 1.139717, -1.002529, 1.141235>,
      < 1.139716, -1.000911, 1.172108>
    }
    triangle {
      < 0.916992, -0.943781, 1.061064>,
      < 0.916969, -0.905190, 1.063075>,
      < 1.139662, -0.909864, 1.081033>
    }
    triangle {
      < 0.916992, -0.943781, 1.061064>,
      < 1.139662, -0.909864, 1.081033>,
      < 1.139681, -0.940737, 1.079425>
    }
    triangle {
      < -0.482769, -0.941698, 1.079424>,
      < -0.482787, -0.910825, 1.081033>,
      < -0.471222, -0.906013, 1.063075>
    }
    triangle {
      < -0.482769, -0.941698, 1.079424>,
      < -0.471222, -0.906013, 1.063075>,
      < -0.471199, -0.944604, 1.061064>
    }
    triangle {
      < -0.398878, -0.977211, 1.145389>,
      < -0.398882, -0.970090, 1.126834>,
      < -0.482739, -0.992414, 1.112373>
    }
    triangle {
      < -0.398878, -0.977211, 1.145389>,
      < -0.482739, -0.992414, 1.112373>,
      < -0.482732, -1.003490, 1.141235>
    }
    triangle {
      < -0.398891, -0.956039, 1.112779>,
      < -0.398902, -0.937487, 1.105653>,
      < -0.482769, -0.941698, 1.079424>
    }
    triangle {
      < -0.398891, -0.956039, 1.112779>,
      < -0.482769, -0.941698, 1.079424>,
      < -0.482752, -0.970557, 1.090510>
    }
    triangle {
      < 1.139717, -1.002529, 1.141235>,
      < 1.139711, -0.991452, 1.112373>,
      < 1.238032, -0.975802, 1.122496>
    }
    triangle {
      < 1.139717, -1.002529, 1.141235>,
      < 1.238032, -0.975802, 1.122496>,
      < 1.238036, -0.984110, 1.144143>
    }
    triangle {
      < 1.139697, -0.969596, 1.090510>,
      < 1.139681, -0.940737, 1.079425>,
      < 1.238009, -0.937765, 1.097785>
    }
    triangle {
      < 1.139697, -0.969596, 1.090510>,
      < 1.238009, -0.937765, 1.097785>,
      < 1.238022, -0.959409, 1.106099>
    }
    triangle {
      < -0.471154, -1.019822, 1.176918>,
      < -0.471153, -1.021844, 1.138327>,
      < 0.917038, -1.021021, 1.138327>
    }
    triangle {
      < -0.471154, -1.019822, 1.176918>,
      < 0.917038, -1.021021, 1.138327>,
      < 0.917037, -1.019000, 1.176918>
    }
    triangle {
      < -0.471199, -0.944604, 1.061064>,
      < -0.471222, -0.906013, 1.063075>,
      < 0.916969, -0.905190, 1.063075>
    }
    triangle {
      < -0.471199, -0.944604, 1.061064>,
      < 0.916969, -0.905190, 1.063075>,
      < 0.916992, -0.943781, 1.061064>
    }
    triangle {
      < -0.398882, -0.970090, 1.126834>,
      < -0.398891, -0.956039, 1.112779>,
      < -0.482752, -0.970557, 1.090510>
    }
    triangle {
      < -0.398882, -0.970090, 1.126834>,
      < -0.482752, -0.970557, 1.090510>,
      < -0.482739, -0.992414, 1.112373>
    }
    triangle {
      < 1.139711, -0.991452, 1.112373>,
      < 1.139697, -0.969596, 1.090510>,
      < 1.238022, -0.959409, 1.106099>
    }
    triangle {
      < 1.139711, -0.991452, 1.112373>,
      < 1.238022, -0.959409, 1.106099>,
      < 1.238032, -0.975802, 1.122496>
    }
    triangle {
      < -0.482732, -1.003490, 1.141235>,
      < -0.482739, -0.992414, 1.112373>,
      < -0.471161, -1.007998, 1.102250>
    }
    triangle {
      < -0.482732, -1.003490, 1.141235>,
      < -0.471161, -1.007998, 1.102250>,
      < -0.471153, -1.021844, 1.138327>
    }
    triangle {
      < 0.917038, -1.021021, 1.138327>,
      < 0.917030, -1.007175, 1.102251>,
      < 1.139711, -0.991452, 1.112373>
    }
    triangle {
      < 0.917038, -1.021021, 1.138327>,
      < 1.139711, -0.991452, 1.112373>,
      < 1.139717, -1.002529, 1.141235>
    }
    triangle {
      < 0.917014, -0.979855, 1.074921>,
      < 0.916992, -0.943781, 1.061064>,
      < 1.139681, -0.940737, 1.079425>
    }
    triangle {
      < 0.917014, -0.979855, 1.074921>,
      < 1.139681, -0.940737, 1.079425>,
      < 1.139697, -0.969596, 1.090510>
    }
    triangle {
      < -0.482752, -0.970557, 1.090510>,
      < -0.482769, -0.941698, 1.079424>,
      < -0.471199, -0.944604, 1.061064>
    }
    triangle {
      < -0.482752, -0.970557, 1.090510>,
      < -0.471199, -0.944604, 1.061064>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < -0.482739, -0.992414, 1.112373>,
      < -0.482752, -0.970557, 1.090510>,
      < -0.471177, -0.980677, 1.074921>
    }
    triangle {
      < -0.482739, -0.992414, 1.112373>,
      < -0.471177, -0.980677, 1.074921>,
      < -0.471161, -1.007998, 1.102250>
    }
    triangle {
      < 0.917030, -1.007175, 1.102251>,
      < 0.917014, -0.979855, 1.074921>,
      < 1.139697, -0.969596, 1.090510>
    }
    triangle {
      < 0.917030, -1.007175, 1.102251>,
      < 1.139697, -0.969596, 1.090510>,
      < 1.139711, -0.991452, 1.112373>
    }
    triangle {
      < -0.471153, -1.021844, 1.138327>,
      < -0.471161, -1.007998, 1.102250>,
      < 0.917030, -1.007175, 1.102251>
    }
    triangle {
      < -0.471153, -1.021844, 1.138327>,
      < 0.917030, -1.007175, 1.102251>,
      < 0.917038, -1.021021, 1.138327>
    }
    triangle {
      < -0.471177, -0.980677, 1.074921>,
      < -0.471199, -0.944604, 1.061064>,
      < 0.916992, -0.943781, 1.061064>
    }
    triangle {
      < -0.471177, -0.980677, 1.074921>,
      < 0.916992, -0.943781, 1.061064>,
      < 0.917014, -0.979855, 1.074921>
    }
    triangle {
      < -0.307214, -0.511738, 1.715663>,
      < -0.271021, -0.677263, 1.554555>,
      < -0.271030, -0.664052, 1.545983>
    }
    triangle {
      < -0.307214, -0.511738, 1.715663>,
      < -0.271030, -0.664052, 1.545983>,
      < -0.307225, -0.494012, 1.697911>
    }
    triangle {
      < -0.271030, -0.664052, 1.545983>,
      < -0.271035, -0.655357, 1.532591>,
      < -0.307225, -0.494012, 1.697911>
    }
    triangle {
      < -0.462568, -0.494105, 1.697911>,
      < -0.463127, -0.655470, 1.532591>,
      < -0.463122, -0.664165, 1.545983>
    }
    triangle {
      < -0.462568, -0.494105, 1.697911>,
      < -0.463122, -0.664165, 1.545983>,
      < -0.462557, -0.511830, 1.715663>
    }
    triangle {
      < -0.463122, -0.664165, 1.545983>,
      < -0.463114, -0.677376, 1.554555>,
      < -0.462557, -0.511830, 1.715663>
    }
    triangle {
      < -0.307225, -0.494012, 1.697911>,
      < -0.271035, -0.655357, 1.532591>,
      < -0.463127, -0.655470, 1.532591>
    }
    triangle {
      < -0.307225, -0.494012, 1.697911>,
      < -0.463127, -0.655470, 1.532591>,
      < -0.462568, -0.494105, 1.697911>
    }
    triangle {
      < -0.462557, -0.511830, 1.715663>,
      < -0.463114, -0.677376, 1.554555>,
      < -0.271021, -0.677263, 1.554555>
    }
    triangle {
      < -0.462557, -0.511830, 1.715663>,
      < -0.271021, -0.677263, 1.554555>,
      < -0.307214, -0.511738, 1.715663>
    }
    triangle {
      < 0.472126, -0.643255, 1.588073>,
      < 0.504892, -0.676803, 1.554555>,
      < 0.502611, -0.663593, 1.545983>
    }
    triangle {
      < 0.472126, -0.643255, 1.588073>,
      < 0.502611, -0.663593, 1.545983>,
      < 0.472114, -0.621336, 1.566121>
    }
    triangle {
      < 0.502611, -0.663593, 1.545983>,
      < 0.504891, -0.654897, 1.532591>,
      < 0.472114, -0.621336, 1.566121>
    }
    triangle {
      < -0.233654, -0.493969, 1.697911>,
      < -0.180059, -0.655303, 1.532591>,
      < -0.180054, -0.663998, 1.545983>
    }
    triangle {
      < -0.233654, -0.493969, 1.697911>,
      < -0.180054, -0.663998, 1.545983>,
      < -0.233644, -0.511694, 1.715663>
    }
    triangle {
      < -0.180054, -0.663998, 1.545983>,
      < -0.180046, -0.677209, 1.554555>,
      < -0.233644, -0.511694, 1.715663>
    }
    triangle {
      < 0.472114, -0.621336, 1.566121>,
      < 0.504891, -0.654897, 1.532591>,
      < -0.180059, -0.655303, 1.532591>
    }
    triangle {
      < 0.472114, -0.621336, 1.566121>,
      < -0.180059, -0.655303, 1.532591>,
      < -0.233654, -0.493969, 1.697911>
    }
    triangle {
      < -0.233644, -0.511694, 1.715663>,
      < -0.180046, -0.677209, 1.554555>,
      < 0.504892, -0.676803, 1.554555>
    }
    triangle {
      < -0.233644, -0.511694, 1.715663>,
      < 0.504892, -0.676803, 1.554555>,
      < 0.472126, -0.643255, 1.588073>
    }
    triangle {
      < -0.307225, -0.494269, 1.262268>,
      < -0.271035, -0.655312, 1.427672>,
      < -0.271025, -0.671283, 1.407969>
    }
    triangle {
      < -0.307225, -0.494269, 1.262268>,
      < -0.271025, -0.671283, 1.407969>,
      < -0.307214, -0.512017, 1.244536>
    }
    triangle {
      < -0.271025, -0.671283, 1.407969>,
      < -0.271022, -0.676715, 1.405204>,
      < -0.307214, -0.512017, 1.244536>
    }
    triangle {
      < -0.462557, -0.512109, 1.244536>,
      < -0.463115, -0.676828, 1.405204>,
      < -0.463117, -0.671396, 1.407969>
    }
    triangle {
      < -0.462557, -0.512109, 1.244536>,
      < -0.463117, -0.671396, 1.407969>,
      < -0.462568, -0.494362, 1.262268>
    }
    triangle {
      < -0.463117, -0.671396, 1.407969>,
      < -0.463127, -0.655426, 1.427672>,
      < -0.462568, -0.494362, 1.262268>
    }
    triangle {
      < -0.307214, -0.512017, 1.244536>,
      < -0.271022, -0.676715, 1.405204>,
      < -0.463115, -0.676828, 1.405204>
    }
    triangle {
      < -0.307214, -0.512017, 1.244536>,
      < -0.463115, -0.676828, 1.405204>,
      < -0.462557, -0.512109, 1.244536>
    }
    triangle {
      < -0.462568, -0.494362, 1.262268>,
      < -0.463127, -0.655426, 1.427672>,
      < -0.271035, -0.655312, 1.427672>
    }
    triangle {
      < -0.462568, -0.494362, 1.262268>,
      < -0.271035, -0.655312, 1.427672>,
      < -0.307225, -0.494269, 1.262268>
    }
    triangle {
      < 0.472114, -0.621437, 1.394209>,
      < 0.504787, -0.654852, 1.427673>,
      < 0.502967, -0.670824, 1.407969>
    }
    triangle {
      < 0.472114, -0.621437, 1.394209>,
      < 0.502967, -0.670824, 1.407969>,
      < 0.472127, -0.643382, 1.372283>
    }
    triangle {
      < 0.502967, -0.670824, 1.407969>,
      < 0.504269, -0.676255, 1.405204>,
      < 0.472127, -0.643382, 1.372283>
    }
    triangle {
      < -0.233644, -0.511973, 1.244536>,
      < -0.180047, -0.676661, 1.405204>,
      < -0.180049, -0.671229, 1.407969>
    }
    triangle {
      < -0.233644, -0.511973, 1.244536>,
      < -0.180049, -0.671229, 1.407969>,
      < -0.233654, -0.494226, 1.262268>
    }
    triangle {
      < -0.180049, -0.671229, 1.407969>,
      < -0.180059, -0.655258, 1.427672>,
      < -0.233654, -0.494226, 1.262268>
    }
    triangle {
      < 0.472127, -0.643382, 1.372283>,
      < 0.504269, -0.676255, 1.405204>,
      < -0.180047, -0.676661, 1.405204>
    }
    triangle {
      < 0.472127, -0.643382, 1.372283>,
      < -0.180047, -0.676661, 1.405204>,
      < -0.233644, -0.511973, 1.244536>
    }
    triangle {
      < -0.233654, -0.494226, 1.262268>,
      < -0.180059, -0.655258, 1.427672>,
      < 0.504787, -0.654852, 1.427673>
    }
    triangle {
      < -0.233654, -0.494226, 1.262268>,
      < 0.504787, -0.654852, 1.427673>,
      < 0.472114, -0.621437, 1.394209>
    }
    triangle {
      < -0.306956, -0.947660, 1.244665>,
      < -0.270959, -0.783081, 1.404979>,
      < -0.270946, -0.805013, 1.426918>
    }
    triangle {
      < -0.306956, -0.947660, 1.244665>,
      < -0.270946, -0.805013, 1.426918>,
      < -0.306946, -0.965397, 1.262407>
    }
    triangle {
      < -0.462289, -0.965490, 1.262407>,
      < -0.463038, -0.805127, 1.426918>,
      < -0.463052, -0.783195, 1.404979>
    }
    triangle {
      < -0.462289, -0.965490, 1.262407>,
      < -0.463052, -0.783195, 1.404979>,
      < -0.462299, -0.947753, 1.244665>
    }
    triangle {
      < -0.306946, -0.965397, 1.262407>,
      < -0.270946, -0.805013, 1.426918>,
      < -0.463038, -0.805127, 1.426918>
    }
    triangle {
      < -0.306946, -0.965397, 1.262407>,
      < -0.463038, -0.805127, 1.426918>,
      < -0.462289, -0.965490, 1.262407>
    }
    triangle {
      < -0.462299, -0.947753, 1.244665>,
      < -0.463052, -0.783195, 1.404979>,
      < -0.270959, -0.783081, 1.404979>
    }
    triangle {
      < -0.462299, -0.947753, 1.244665>,
      < -0.270959, -0.783081, 1.404979>,
      < -0.306956, -0.947660, 1.244665>
    }
    triangle {
      < 0.472229, -0.815295, 1.372334>,
      < 0.504083, -0.782621, 1.404979>,
      < 0.504096, -0.804554, 1.426918>
    }
    triangle {
      < 0.472229, -0.815295, 1.372334>,
      < 0.504096, -0.804554, 1.426918>,
      < 0.472242, -0.837227, 1.394273>
    }
    triangle {
      < -0.233375, -0.965354, 1.262407>,
      < -0.179970, -0.804959, 1.426918>,
      < -0.179984, -0.783027, 1.404979>
    }
    triangle {
      < -0.233375, -0.965354, 1.262407>,
      < -0.179984, -0.783027, 1.404979>,
      < -0.233385, -0.947617, 1.244665>
    }
    triangle {
      < 0.472242, -0.837227, 1.394273>,
      < 0.504096, -0.804554, 1.426918>,
      < -0.179970, -0.804959, 1.426918>
    }
    triangle {
      < 0.472242, -0.837227, 1.394273>,
      < -0.179970, -0.804959, 1.426918>,
      < -0.233375, -0.965354, 1.262407>
    }
    triangle {
      < -0.233385, -0.947617, 1.244665>,
      < -0.179984, -0.783027, 1.404979>,
      < 0.504083, -0.782621, 1.404979>
    }
    triangle {
      < -0.233385, -0.947617, 1.244665>,
      < 0.504083, -0.782621, 1.404979>,
      < 0.472229, -0.815295, 1.372334>
    }
    triangle {
      < -0.306946, -0.965396, 1.698050>,
      < -0.270946, -0.804756, 1.533284>,
      < -0.270948, -0.801991, 1.538715>
    }
    triangle {
      < -0.306946, -0.965396, 1.698050>,
      < -0.270948, -0.801991, 1.538715>,
      < -0.306956, -0.947660, 1.715792>
    }
    triangle {
      < -0.270948, -0.801991, 1.538715>,
      < -0.270959, -0.782282, 1.554680>,
      < -0.306956, -0.947660, 1.715792>
    }
    triangle {
      < -0.462299, -0.947753, 1.715792>,
      < -0.463052, -0.782396, 1.554680>,
      < -0.463040, -0.802104, 1.538715>
    }
    triangle {
      < -0.462299, -0.947753, 1.715792>,
      < -0.463040, -0.802104, 1.538715>,
      < -0.462289, -0.965489, 1.698050>
    }
    triangle {
      < -0.463040, -0.802104, 1.538715>,
      < -0.463038, -0.804870, 1.533284>,
      < -0.462289, -0.965489, 1.698050>
    }
    triangle {
      < -0.306956, -0.947660, 1.715792>,
      < -0.270959, -0.782282, 1.554680>,
      < -0.463052, -0.782396, 1.554680>
    }
    triangle {
      < -0.306956, -0.947660, 1.715792>,
      < -0.463052, -0.782396, 1.554680>,
      < -0.462299, -0.947753, 1.715792>
    }
    triangle {
      < -0.462289, -0.965489, 1.698050>,
      < -0.463038, -0.804870, 1.533284>,
      < -0.270946, -0.804756, 1.533284>
    }
    triangle {
      < -0.462289, -0.965489, 1.698050>,
      < -0.270946, -0.804756, 1.533284>,
      < -0.306946, -0.965396, 1.698050>
    }
    triangle {
      < 0.472242, -0.837228, 1.566185>,
      < 0.504345, -0.804297, 1.533284>,
      < 0.503044, -0.801532, 1.538715>
    }
    triangle {
      < 0.472242, -0.837228, 1.566185>,
      < 0.503044, -0.801532, 1.538715>,
      < 0.472229, -0.815296, 1.588124>
    }
    triangle {
      < 0.503044, -0.801532, 1.538715>,
      < 0.504862, -0.781822, 1.554680>,
      < 0.472229, -0.815296, 1.588124>
    }
    triangle {
      < -0.233385, -0.947617, 1.715792>,
      < -0.179984, -0.782228, 1.554680>,
      < -0.179972, -0.801937, 1.538715>
    }
    triangle {
      < -0.233385, -0.947617, 1.715792>,
      < -0.179972, -0.801937, 1.538715>,
      < -0.233375, -0.965353, 1.698050>
    }
    triangle {
      < -0.179972, -0.801937, 1.538715>,
      < -0.179970, -0.804703, 1.533284>,
      < -0.233375, -0.965353, 1.698050>
    }
    triangle {
      < 0.472229, -0.815296, 1.588124>,
      < 0.504862, -0.781822, 1.554680>,
      < -0.179984, -0.782228, 1.554680>
    }
    triangle {
      < 0.472229, -0.815296, 1.588124>,
      < -0.179984, -0.782228, 1.554680>,
      < -0.233385, -0.947617, 1.715792>
    }
    triangle {
      < -0.233375, -0.965353, 1.698050>,
      < -0.179970, -0.804703, 1.533284>,
      < 0.504345, -0.804297, 1.533284>
    }
    triangle {
      < -0.233375, -0.965353, 1.698050>,
      < 0.504345, -0.804297, 1.533284>,
      < 0.472242, -0.837228, 1.566185>
    }
    triangle {
      < -0.233654, -0.493969, 1.697911>,
      < -0.233644, -0.511694, 1.715663>,
      < 0.472126, -0.643255, 1.588073>
    }
    triangle {
      < -0.233654, -0.493969, 1.697911>,
      < 0.472126, -0.643255, 1.588073>,
      < 0.472114, -0.621336, 1.566121>
    }
    triangle {
      < -0.462568, -0.494105, 1.697911>,
      < -0.462557, -0.511830, 1.715663>,
      < -0.307214, -0.511738, 1.715663>
    }
    triangle {
      < -0.462568, -0.494105, 1.697911>,
      < -0.307214, -0.511738, 1.715663>,
      < -0.307225, -0.494012, 1.697911>
    }
    triangle {
      < -0.233385, -0.947617, 1.715792>,
      < -0.233375, -0.965353, 1.698050>,
      < 0.472242, -0.837228, 1.566185>
    }
    triangle {
      < -0.233385, -0.947617, 1.715792>,
      < 0.472242, -0.837228, 1.566185>,
      < 0.472229, -0.815296, 1.588124>
    }
    triangle {
      < -0.462299, -0.947753, 1.715792>,
      < -0.462289, -0.965489, 1.698050>,
      < -0.306946, -0.965396, 1.698050>
    }
    triangle {
      < -0.462299, -0.947753, 1.715792>,
      < -0.306946, -0.965396, 1.698050>,
      < -0.306956, -0.947660, 1.715792>
    }
    triangle {
      < -0.233644, -0.511973, 1.244536>,
      < -0.233654, -0.494226, 1.262268>,
      < 0.472114, -0.621437, 1.394209>
    }
    triangle {
      < -0.233644, -0.511973, 1.244536>,
      < 0.472114, -0.621437, 1.394209>,
      < 0.472127, -0.643382, 1.372283>
    }
    triangle {
      < -0.462557, -0.512109, 1.244536>,
      < -0.462568, -0.494362, 1.262268>,
      < -0.307225, -0.494269, 1.262268>
    }
    triangle {
      < -0.462557, -0.512109, 1.244536>,
      < -0.307225, -0.494269, 1.262268>,
      < -0.307214, -0.512017, 1.244536>
    }
    triangle {
      < -0.233375, -0.965354, 1.262407>,
      < -0.233385, -0.947617, 1.244665>,
      < 0.472229, -0.815295, 1.372334>
    }
    triangle {
      < -0.233375, -0.965354, 1.262407>,
      < 0.472229, -0.815295, 1.372334>,
      < 0.472242, -0.837227, 1.394273>
    }
    triangle {
      < -0.462289, -0.965490, 1.262407>,
      < -0.462299, -0.947753, 1.244665>,
      < -0.306956, -0.947660, 1.244665>
    }
    triangle {
      < -0.462289, -0.965490, 1.262407>,
      < -0.306956, -0.947660, 1.244665>,
      < -0.306946, -0.965397, 1.262407>
    }
    triangle {
      < -0.180059, -0.655303, 1.532591>,
      < 0.504891, -0.654897, 1.532591>,
      < 0.900527, -0.642255, 1.513481>
    }
    triangle {
      < 0.504891, -0.654897, 1.532591>,
      < 0.502611, -0.663593, 1.545983>,
      < 0.900540, -0.663357, 1.545983>
    }
    triangle {
      < 0.504891, -0.654897, 1.532591>,
      < 0.900540, -0.663357, 1.545983>,
      < 0.900527, -0.642255, 1.513481>
    }
    triangle {
      < -0.180059, -0.655303, 1.532591>,
      < 0.900527, -0.642255, 1.513481>,
      < -0.271035, -0.655357, 1.532591>
    }
    triangle {
      < -0.180059, -0.655303, 1.532591>,
      < -0.271035, -0.655357, 1.532591>,
      < -0.180054, -0.663998, 1.545983>
    }
    triangle {
      < 0.900527, -0.642255, 1.513481>,
      < -0.487665, -0.643078, 1.513481>,
      < -0.463127, -0.655470, 1.532591>
    }
    triangle {
      < 0.900527, -0.642255, 1.513481>,
      < -0.463127, -0.655470, 1.532591>,
      < -0.271035, -0.655357, 1.532591>
    }
    triangle {
      < -0.487665, -0.643078, 1.513481>,
      < -0.487652, -0.664180, 1.545983>,
      < -0.463122, -0.664165, 1.545983>
    }
    triangle {
      < -0.487665, -0.643078, 1.513481>,
      < -0.463122, -0.664165, 1.545983>,
      < -0.463127, -0.655470, 1.532591>
    }
    triangle {
      < -0.271035, -0.655357, 1.532591>,
      < -0.271030, -0.664052, 1.545983>,
      < -0.180054, -0.663998, 1.545983>
    }
    triangle {
      < -0.271035, -0.655312, 1.427672>,
      < -0.463127, -0.655426, 1.427672>,
      < -0.487662, -0.647078, 1.437989>
    }
    triangle {
      < -0.463127, -0.655426, 1.427672>,
      < -0.463117, -0.671396, 1.407969>,
      < -0.487648, -0.671411, 1.407969>
    }
    triangle {
      < -0.463127, -0.655426, 1.427672>,
      < -0.487648, -0.671411, 1.407969>,
      < -0.487662, -0.647078, 1.437989>
    }
    triangle {
      < -0.271035, -0.655312, 1.427672>,
      < -0.487662, -0.647078, 1.437989>,
      < -0.180059, -0.655258, 1.427672>
    }
    triangle {
      < -0.271035, -0.655312, 1.427672>,
      < -0.180059, -0.655258, 1.427672>,
      < -0.271025, -0.671283, 1.407969>
    }
    triangle {
      < -0.487662, -0.647078, 1.437989>,
      < 0.900529, -0.646256, 1.437989>,
      < 0.504787, -0.654852, 1.427673>
    }
    triangle {
      < -0.487662, -0.647078, 1.437989>,
      < 0.504787, -0.654852, 1.427673>,
      < -0.180059, -0.655258, 1.427672>
    }
    triangle {
      < 0.900529, -0.646256, 1.437989>,
      < 0.900544, -0.670588, 1.407969>,
      < 0.502967, -0.670824, 1.407969>
    }
    triangle {
      < 0.900529, -0.646256, 1.437989>,
      < 0.502967, -0.670824, 1.407969>,
      < 0.504787, -0.654852, 1.427673>
    }
    triangle {
      < -0.180059, -0.655258, 1.427672>,
      < -0.180049, -0.671229, 1.407969>,
      < -0.271025, -0.671283, 1.407969>
    }
    triangle {
      < -0.180047, -0.676661, 1.405204>,
      < 0.504269, -0.676255, 1.405204>,
      < 0.900564, -0.705027, 1.390438>
    }
    triangle {
      < 0.504269, -0.676255, 1.405204>,
      < 0.502967, -0.670824, 1.407969>,
      < 0.900544, -0.670588, 1.407969>
    }
    triangle {
      < 0.504269, -0.676255, 1.405204>,
      < 0.900544, -0.670588, 1.407969>,
      < 0.900564, -0.705027, 1.390438>
    }
    triangle {
      < -0.180047, -0.676661, 1.405204>,
      < 0.900564, -0.705027, 1.390438>,
      < -0.271022, -0.676715, 1.405204>
    }
    triangle {
      < -0.180047, -0.676661, 1.405204>,
      < -0.271022, -0.676715, 1.405204>,
      < -0.180049, -0.671229, 1.407969>
    }
    triangle {
      < 0.900564, -0.705027, 1.390438>,
      < -0.487627, -0.705850, 1.390438>,
      < -0.463115, -0.676828, 1.405204>
    }
    triangle {
      < 0.900564, -0.705027, 1.390438>,
      < -0.463115, -0.676828, 1.405204>,
      < -0.271022, -0.676715, 1.405204>
    }
    triangle {
      < -0.487627, -0.705850, 1.390438>,
      < -0.487648, -0.671411, 1.407969>,
      < -0.463117, -0.671396, 1.407969>
    }
    triangle {
      < -0.487627, -0.705850, 1.390438>,
      < -0.463117, -0.671396, 1.407969>,
      < -0.463115, -0.676828, 1.405204>
    }
    triangle {
      < -0.271022, -0.676715, 1.405204>,
      < -0.271025, -0.671283, 1.407969>,
      < -0.180049, -0.671229, 1.407969>
    }
    triangle {
      < 0.900608, -0.779692, 1.402284>,
      < 0.504083, -0.782621, 1.404979>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < 0.900608, -0.779692, 1.402284>,
      < 0.900625, -0.807012, 1.429614>,
      < 0.504096, -0.804554, 1.426918>
    }
    triangle {
      < 0.900608, -0.779692, 1.402284>,
      < 0.504096, -0.804554, 1.426918>,
      < 0.504083, -0.782621, 1.404979>
    }
    triangle {
      < 0.900625, -0.807012, 1.429614>,
      < -0.179970, -0.804959, 1.426918>,
      < 0.504096, -0.804554, 1.426918>
    }
    triangle {
      < 0.900625, -0.807012, 1.429614>,
      < -0.270946, -0.805013, 1.426918>,
      < -0.179970, -0.804959, 1.426918>
    }
    triangle {
      < 0.504083, -0.782621, 1.404979>,
      < -0.179984, -0.783027, 1.404979>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < -0.179984, -0.783027, 1.404979>,
      < -0.270959, -0.783081, 1.404979>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < -0.179984, -0.783027, 1.404979>,
      < -0.179970, -0.804959, 1.426918>,
      < -0.270959, -0.783081, 1.404979>
    }
    triangle {
      < -0.179970, -0.804959, 1.426918>,
      < -0.270946, -0.805013, 1.426918>,
      < -0.270959, -0.783081, 1.404979>
    }
    triangle {
      < 0.900625, -0.807012, 1.429614>,
      < -0.487567, -0.807835, 1.429613>,
      < -0.463038, -0.805127, 1.426918>
    }
    triangle {
      < 0.900625, -0.807012, 1.429614>,
      < -0.463038, -0.805127, 1.426918>,
      < -0.270946, -0.805013, 1.426918>
    }
    triangle {
      < -0.270959, -0.783081, 1.404979>,
      < -0.463052, -0.783195, 1.404979>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < -0.463052, -0.783195, 1.404979>,
      < -0.463038, -0.805127, 1.426918>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < -0.463038, -0.805127, 1.426918>,
      < -0.487567, -0.807835, 1.429613>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < -0.270946, -0.804756, 1.533284>,
      < -0.463038, -0.804870, 1.533284>,
      < -0.487561, -0.819660, 1.504281>
    }
    triangle {
      < -0.463038, -0.804870, 1.533284>,
      < -0.463040, -0.802104, 1.538715>,
      < -0.487570, -0.802119, 1.538715>
    }
    triangle {
      < -0.463038, -0.804870, 1.533284>,
      < -0.487570, -0.802119, 1.538715>,
      < -0.487561, -0.819660, 1.504281>
    }
    triangle {
      < -0.270946, -0.804756, 1.533284>,
      < -0.487561, -0.819660, 1.504281>,
      < -0.179970, -0.804703, 1.533284>
    }
    triangle {
      < -0.270946, -0.804756, 1.533284>,
      < -0.179970, -0.804703, 1.533284>,
      < -0.270948, -0.801991, 1.538715>
    }
    triangle {
      < -0.487561, -0.819660, 1.504281>,
      < 0.900632, -0.818837, 1.504282>,
      < 0.504345, -0.804297, 1.533284>
    }
    triangle {
      < -0.487561, -0.819660, 1.504281>,
      < 0.504345, -0.804297, 1.533284>,
      < -0.179970, -0.804703, 1.533284>
    }
    triangle {
      < 0.900632, -0.818837, 1.504282>,
      < 0.900621, -0.801296, 1.538715>,
      < 0.503044, -0.801532, 1.538715>
    }
    triangle {
      < 0.900632, -0.818837, 1.504282>,
      < 0.503044, -0.801532, 1.538715>,
      < 0.504345, -0.804297, 1.533284>
    }
    triangle {
      < -0.179970, -0.804703, 1.533284>,
      < -0.179972, -0.801937, 1.538715>,
      < -0.270948, -0.801991, 1.538715>
    }
    triangle {
      < -0.179984, -0.782228, 1.554680>,
      < 0.504862, -0.781822, 1.554680>,
      < 0.900604, -0.771269, 1.563039>
    }
    triangle {
      < 0.504862, -0.781822, 1.554680>,
      < 0.503044, -0.801532, 1.538715>,
      < 0.900621, -0.801296, 1.538715>
    }
    triangle {
      < 0.504862, -0.781822, 1.554680>,
      < 0.900621, -0.801296, 1.538715>,
      < 0.900604, -0.771269, 1.563039>
    }
    triangle {
      < -0.179984, -0.782228, 1.554680>,
      < 0.900604, -0.771269, 1.563039>,
      < -0.270959, -0.782282, 1.554680>
    }
    triangle {
      < -0.179984, -0.782228, 1.554680>,
      < -0.270959, -0.782282, 1.554680>,
      < -0.179972, -0.801937, 1.538715>
    }
    triangle {
      < 0.900604, -0.771269, 1.563039>,
      < -0.487588, -0.772091, 1.563039>,
      < -0.463052, -0.782396, 1.554680>
    }
    triangle {
      < 0.900604, -0.771269, 1.563039>,
      < -0.463052, -0.782396, 1.554680>,
      < -0.270959, -0.782282, 1.554680>
    }
    triangle {
      < -0.487588, -0.772091, 1.563039>,
      < -0.487570, -0.802119, 1.538715>,
      < -0.463040, -0.802104, 1.538715>
    }
    triangle {
      < -0.487588, -0.772091, 1.563039>,
      < -0.463040, -0.802104, 1.538715>,
      < -0.463052, -0.782396, 1.554680>
    }
    triangle {
      < -0.270959, -0.782282, 1.554680>,
      < -0.270948, -0.801991, 1.538715>,
      < -0.179972, -0.801937, 1.538715>
    }
    triangle {
      < -0.271021, -0.677263, 1.554555>,
      < -0.463114, -0.677376, 1.554555>,
      < -0.487633, -0.696597, 1.567017>
    }
    triangle {
      < -0.463114, -0.677376, 1.554555>,
      < -0.463122, -0.664165, 1.545983>,
      < -0.487652, -0.664180, 1.545983>
    }
    triangle {
      < -0.463114, -0.677376, 1.554555>,
      < -0.487652, -0.664180, 1.545983>,
      < -0.487633, -0.696597, 1.567017>
    }
    triangle {
      < -0.271021, -0.677263, 1.554555>,
      < -0.487633, -0.696597, 1.567017>,
      < -0.180046, -0.677209, 1.554555>
    }
    triangle {
      < -0.271021, -0.677263, 1.554555>,
      < -0.180046, -0.677209, 1.554555>,
      < -0.271030, -0.664052, 1.545983>
    }
    triangle {
      < -0.487633, -0.696597, 1.567017>,
      < 0.900559, -0.695774, 1.567017>,
      < 0.504892, -0.676803, 1.554555>
    }
    triangle {
      < -0.487633, -0.696597, 1.567017>,
      < 0.504892, -0.676803, 1.554555>,
      < -0.180046, -0.677209, 1.554555>
    }
    triangle {
      < 0.900559, -0.695774, 1.567017>,
      < 0.900540, -0.663357, 1.545983>,
      < 0.502611, -0.663593, 1.545983>
    }
    triangle {
      < 0.900559, -0.695774, 1.567017>,
      < 0.502611, -0.663593, 1.545983>,
      < 0.504892, -0.676803, 1.554555>
    }
    triangle {
      < -0.180046, -0.677209, 1.554555>,
      < -0.180054, -0.663998, 1.545983>,
      < -0.271030, -0.664052, 1.545983>
    }
    triangle {
      < 0.900540, -0.663357, 1.545983>,
      < 0.900559, -0.695774, 1.567017>,
      < 1.123251, -0.702298, 1.549659>
    }
    triangle {
      < 0.900540, -0.663357, 1.545983>,
      < 1.123251, -0.702298, 1.549659>,
      < 1.123236, -0.676364, 1.532833>
    }
    triangle {
      < 0.900527, -0.642255, 1.513481>,
      < 0.900540, -0.663357, 1.545983>,
      < 1.123236, -0.676364, 1.532833>
    }
    triangle {
      < 0.900527, -0.642255, 1.513481>,
      < 1.123236, -0.676364, 1.532833>,
      < 1.123226, -0.659484, 1.506831>
    }
    triangle {
      < -0.499223, -0.660445, 1.506830>,
      < -0.499213, -0.677326, 1.532833>,
      < -0.487652, -0.664180, 1.545983>
    }
    triangle {
      < -0.499223, -0.660445, 1.506830>,
      < -0.487652, -0.664180, 1.545983>,
      < -0.487665, -0.643078, 1.513481>
    }
    triangle {
      < -0.499213, -0.677326, 1.532833>,
      < -0.499198, -0.703260, 1.549659>,
      < -0.487633, -0.696597, 1.567017>
    }
    triangle {
      < -0.499213, -0.677326, 1.532833>,
      < -0.487633, -0.696597, 1.567017>,
      < -0.487652, -0.664180, 1.545983>
    }
    triangle {
      < -0.487633, -0.696597, 1.567017>,
      < -0.487611, -0.734768, 1.573049>,
      < 0.900581, -0.733945, 1.573049>
    }
    triangle {
      < -0.487633, -0.696597, 1.567017>,
      < 0.900581, -0.733945, 1.573049>,
      < 0.900559, -0.695774, 1.567017>
    }
    triangle {
      < -0.499198, -0.703260, 1.549659>,
      < -0.499180, -0.733796, 1.554485>,
      < -0.487611, -0.734768, 1.573049>
    }
    triangle {
      < -0.499198, -0.703260, 1.549659>,
      < -0.487611, -0.734768, 1.573049>,
      < -0.487633, -0.696597, 1.567017>
    }
    triangle {
      < 0.900559, -0.695774, 1.567017>,
      < 0.900581, -0.733945, 1.573049>,
      < 1.123270, -0.732833, 1.554486>
    }
    triangle {
      < 0.900559, -0.695774, 1.567017>,
      < 1.123270, -0.732833, 1.554486>,
      < 1.123251, -0.702298, 1.549659>
    }
    triangle {
      < -0.487669, -0.637056, 1.475309>,
      < -0.487665, -0.643078, 1.513481>,
      < 0.900527, -0.642255, 1.513481>
    }
    triangle {
      < -0.487669, -0.637056, 1.475309>,
      < 0.900527, -0.642255, 1.513481>,
      < 0.900524, -0.636234, 1.475310>
    }
    triangle {
      < 0.900524, -0.636234, 1.475310>,
      < 0.900527, -0.642255, 1.513481>,
      < 1.123226, -0.659484, 1.506831>
    }
    triangle {
      < 0.900524, -0.636234, 1.475310>,
      < 1.123226, -0.659484, 1.506831>,
      < 1.123223, -0.654665, 1.476294>
    }
    triangle {
      < -0.499226, -0.655627, 1.476294>,
      < -0.499223, -0.660445, 1.506830>,
      < -0.487665, -0.643078, 1.513481>
    }
    triangle {
      < -0.499226, -0.655627, 1.476294>,
      < -0.487665, -0.643078, 1.513481>,
      < -0.487669, -0.637056, 1.475309>
    }
    triangle {
      < 1.123226, -0.659484, 1.506831>,
      < 1.123236, -0.676364, 1.532833>,
      < 1.221575, -0.689446, 1.519682>
    }
    triangle {
      < 1.123226, -0.659484, 1.506831>,
      < 1.221575, -0.689446, 1.519682>,
      < 1.221567, -0.676784, 1.500180>
    }
    triangle {
      < -0.415338, -0.685195, 1.497330>,
      < -0.415332, -0.696047, 1.514045>,
      < -0.499213, -0.677326, 1.532833>
    }
    triangle {
      < -0.415338, -0.685195, 1.497330>,
      < -0.499213, -0.677326, 1.532833>,
      < -0.499223, -0.660445, 1.506830>
    }
    triangle {
      < 1.123236, -0.676364, 1.532833>,
      < 1.123251, -0.702298, 1.549659>,
      < 1.221586, -0.708896, 1.532302>
    }
    triangle {
      < 1.123236, -0.676364, 1.532833>,
      < 1.221586, -0.708896, 1.532302>,
      < 1.221575, -0.689446, 1.519682>
    }
    triangle {
      < -0.415332, -0.696047, 1.514045>,
      < -0.415322, -0.712719, 1.524863>,
      < -0.499198, -0.703260, 1.549659>
    }
    triangle {
      < -0.415332, -0.696047, 1.514045>,
      < -0.499198, -0.703260, 1.549659>,
      < -0.499213, -0.677326, 1.532833>
    }
    triangle {
      < 1.123251, -0.702298, 1.549659>,
      < 1.123270, -0.732833, 1.554486>,
      < 1.221600, -0.731797, 1.535922>
    }
    triangle {
      < 1.123251, -0.702298, 1.549659>,
      < 1.221600, -0.731797, 1.535922>,
      < 1.221586, -0.708896, 1.532302>
    }
    triangle {
      < -0.415322, -0.712719, 1.524863>,
      < -0.415310, -0.732349, 1.527965>,
      < -0.499180, -0.733796, 1.554485>
    }
    triangle {
      < -0.415322, -0.712719, 1.524863>,
      < -0.499180, -0.733796, 1.554485>,
      < -0.499198, -0.703260, 1.549659>
    }
    triangle {
      < -0.415340, -0.682097, 1.477699>,
      < -0.415338, -0.685195, 1.497330>,
      < -0.499223, -0.660445, 1.506830>
    }
    triangle {
      < -0.415340, -0.682097, 1.477699>,
      < -0.499223, -0.660445, 1.506830>,
      < -0.499226, -0.655627, 1.476294>
    }
    triangle {
      < 1.123223, -0.654665, 1.476294>,
      < 1.123226, -0.659484, 1.506831>,
      < 1.221567, -0.676784, 1.500180>
    }
    triangle {
      < 1.123223, -0.654665, 1.476294>,
      < 1.221567, -0.676784, 1.500180>,
      < 1.221565, -0.673171, 1.477278>
    }
    triangle {
      < 0.900581, -0.733945, 1.573049>,
      < 0.900604, -0.771269, 1.563039>,
      < 1.123287, -0.762693, 1.546477>
    }
    triangle {
      < 0.900581, -0.733945, 1.573049>,
      < 1.123287, -0.762693, 1.546477>,
      < 1.123270, -0.732833, 1.554486>
    }
    triangle {
      < -0.499180, -0.733796, 1.554485>,
      < -0.499162, -0.763655, 1.546476>,
      < -0.487588, -0.772091, 1.563039>
    }
    triangle {
      < -0.499180, -0.733796, 1.554485>,
      < -0.487588, -0.772091, 1.563039>,
      < -0.487611, -0.734768, 1.573049>
    }
    triangle {
      < -0.487611, -0.734768, 1.573049>,
      < -0.487588, -0.772091, 1.563039>,
      < 0.900604, -0.771269, 1.563039>
    }
    triangle {
      < -0.487611, -0.734768, 1.573049>,
      < 0.900604, -0.771269, 1.563039>,
      < 0.900581, -0.733945, 1.573049>
    }
    triangle {
      < 0.900529, -0.646256, 1.437989>,
      < 0.900524, -0.636234, 1.475310>,
      < 1.123223, -0.654665, 1.476294>
    }
    triangle {
      < 0.900529, -0.646256, 1.437989>,
      < 1.123223, -0.654665, 1.476294>,
      < 1.123228, -0.662683, 1.446437>
    }
    triangle {
      < -0.487662, -0.647078, 1.437989>,
      < -0.487669, -0.637056, 1.475309>,
      < 0.900524, -0.636234, 1.475310>
    }
    triangle {
      < -0.487662, -0.647078, 1.437989>,
      < 0.900524, -0.636234, 1.475310>,
      < 0.900529, -0.646256, 1.437989>
    }
    triangle {
      < -0.499221, -0.663645, 1.446437>,
      < -0.499226, -0.655627, 1.476294>,
      < -0.487669, -0.637056, 1.475309>
    }
    triangle {
      < -0.499221, -0.663645, 1.446437>,
      < -0.487669, -0.637056, 1.475309>,
      < -0.487662, -0.647078, 1.437989>
    }
    triangle {
      < 1.221567, -0.676784, 1.500180>,
      < 1.221575, -0.689446, 1.519682>,
      < 1.276532, -0.704429, 1.504652>
    }
    triangle {
      < 1.221567, -0.676784, 1.500180>,
      < 1.276532, -0.704429, 1.504652>,
      < 1.276528, -0.696591, 1.492580>
    }
    triangle {
      < 1.221575, -0.689446, 1.519682>,
      < 1.221586, -0.708896, 1.532302>,
      < 1.276539, -0.716470, 1.512465>
    }
    triangle {
      < 1.221575, -0.689446, 1.519682>,
      < 1.276539, -0.716470, 1.512465>,
      < 1.276532, -0.704429, 1.504652>
    }
    triangle {
      < 1.221586, -0.708896, 1.532302>,
      < 1.221600, -0.731797, 1.535922>,
      < 1.276547, -0.730647, 1.514705>
    }
    triangle {
      < 1.221586, -0.708896, 1.532302>,
      < 1.276547, -0.730647, 1.514705>,
      < 1.276539, -0.716470, 1.512465>
    }
    triangle {
      < 1.221565, -0.673171, 1.477278>,
      < 1.221567, -0.676784, 1.500180>,
      < 1.276528, -0.696591, 1.492580>
    }
    triangle {
      < 1.221565, -0.673171, 1.477278>,
      < 1.276528, -0.696591, 1.492580>,
      < 1.276526, -0.694355, 1.478402>
    }
    triangle {
      < 1.123270, -0.732833, 1.554486>,
      < 1.123287, -0.762693, 1.546477>,
      < 1.221613, -0.754193, 1.529915>
    }
    triangle {
      < 1.123270, -0.732833, 1.554486>,
      < 1.221613, -0.754193, 1.529915>,
      < 1.221600, -0.731797, 1.535922>
    }
    triangle {
      < -0.415310, -0.732349, 1.527965>,
      < -0.415299, -0.751544, 1.522817>,
      < -0.499162, -0.763655, 1.546476>
    }
    triangle {
      < -0.415310, -0.732349, 1.527965>,
      < -0.499162, -0.763655, 1.546476>,
      < -0.499180, -0.733796, 1.554485>
    }
    triangle {
      < 1.123228, -0.662683, 1.446437>,
      < 1.123223, -0.654665, 1.476294>,
      < 1.221565, -0.673171, 1.477278>
    }
    triangle {
      < 1.123228, -0.662683, 1.446437>,
      < 1.221565, -0.673171, 1.477278>,
      < 1.221568, -0.679185, 1.454885>
    }
    triangle {
      < -0.415337, -0.687251, 1.458505>,
      < -0.415340, -0.682097, 1.477699>,
      < -0.499226, -0.655627, 1.476294>
    }
    triangle {
      < -0.415337, -0.687251, 1.458505>,
      < -0.499226, -0.655627, 1.476294>,
      < -0.499221, -0.663645, 1.446437>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415332, -0.696047, 1.514045>,
      < -0.415338, -0.685195, 1.497330>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415322, -0.712719, 1.524863>,
      < -0.415332, -0.696047, 1.514045>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415310, -0.732349, 1.527965>,
      < -0.415322, -0.712719, 1.524863>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415338, -0.685195, 1.497330>,
      < -0.415340, -0.682097, 1.477699>
    }
    triangle {
      < 1.221600, -0.731797, 1.535922>,
      < 1.221613, -0.754193, 1.529915>,
      < 1.276556, -0.744511, 1.510987>
    }
    triangle {
      < 1.221600, -0.731797, 1.535922>,
      < 1.276556, -0.744511, 1.510987>,
      < 1.276547, -0.730647, 1.514705>
    }
    triangle {
      < 1.221568, -0.679185, 1.454885>,
      < 1.221565, -0.673171, 1.477278>,
      < 1.276526, -0.694355, 1.478402>
    }
    triangle {
      < 1.221568, -0.679185, 1.454885>,
      < 1.276526, -0.694355, 1.478402>,
      < 1.276528, -0.698077, 1.464540>
    }
    triangle {
      < 1.276532, -0.704429, 1.504652>,
      < 1.276539, -0.716470, 1.512465>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.276528, -0.696591, 1.492580>,
      < 1.276532, -0.704429, 1.504652>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415299, -0.751544, 1.522817>,
      < -0.415310, -0.732349, 1.527965>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415340, -0.682097, 1.477699>,
      < -0.415337, -0.687251, 1.458505>
    }
    triangle {
      < 1.276539, -0.716470, 1.512465>,
      < 1.276547, -0.730647, 1.514705>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.276526, -0.694355, 1.478402>,
      < 1.276528, -0.696591, 1.492580>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < -0.499162, -0.763655, 1.546476>,
      < -0.499148, -0.787678, 1.527017>,
      < -0.487570, -0.802119, 1.538715>
    }
    triangle {
      < -0.499162, -0.763655, 1.546476>,
      < -0.487570, -0.802119, 1.538715>,
      < -0.487588, -0.772091, 1.563039>
    }
    triangle {
      < 0.900604, -0.771269, 1.563039>,
      < 0.900621, -0.801296, 1.538715>,
      < 1.123302, -0.786715, 1.527018>
    }
    triangle {
      < 0.900604, -0.771269, 1.563039>,
      < 1.123302, -0.786715, 1.527018>,
      < 1.123287, -0.762693, 1.546477>
    }
    triangle {
      < -0.499209, -0.683112, 1.422420>,
      < -0.499221, -0.663645, 1.446437>,
      < -0.487662, -0.647078, 1.437989>
    }
    triangle {
      < -0.499209, -0.683112, 1.422420>,
      < -0.487662, -0.647078, 1.437989>,
      < -0.487648, -0.671411, 1.407969>
    }
    triangle {
      < 0.900544, -0.670588, 1.407969>,
      < 0.900529, -0.646256, 1.437989>,
      < 1.123228, -0.662683, 1.446437>
    }
    triangle {
      < 0.900544, -0.670588, 1.407969>,
      < 1.123228, -0.662683, 1.446437>,
      < 1.123240, -0.682150, 1.422420>
    }
    triangle {
      < 1.276547, -0.730647, 1.514705>,
      < 1.276556, -0.744511, 1.510987>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.276528, -0.698077, 1.464540>,
      < 1.276526, -0.694355, 1.478402>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.123287, -0.762693, 1.546477>,
      < 1.123302, -0.786715, 1.527018>,
      < 1.221624, -0.772209, 1.515320>
    }
    triangle {
      < 1.123287, -0.762693, 1.546477>,
      < 1.221624, -0.772209, 1.515320>,
      < 1.221613, -0.754193, 1.529915>
    }
    triangle {
      < -0.415299, -0.751544, 1.522817>,
      < -0.415290, -0.766987, 1.510307>,
      < -0.499148, -0.787678, 1.527017>
    }
    triangle {
      < -0.415299, -0.751544, 1.522817>,
      < -0.499148, -0.787678, 1.527017>,
      < -0.499162, -0.763655, 1.546476>
    }
    triangle {
      < 1.123240, -0.682150, 1.422420>,
      < 1.123228, -0.662683, 1.446437>,
      < 1.221568, -0.679185, 1.454885>
    }
    triangle {
      < 1.123240, -0.682150, 1.422420>,
      < 1.221568, -0.679185, 1.454885>,
      < 1.221577, -0.693784, 1.436872>
    }
    triangle {
      < -0.415330, -0.699766, 1.443066>,
      < -0.415337, -0.687251, 1.458505>,
      < -0.499221, -0.663645, 1.446437>
    }
    triangle {
      < -0.415330, -0.699766, 1.443066>,
      < -0.499221, -0.663645, 1.446437>,
      < -0.499209, -0.683112, 1.422420>
    }
    triangle {
      < 1.221613, -0.754193, 1.529915>,
      < 1.221624, -0.772209, 1.515320>,
      < 1.276563, -0.755663, 1.501952>
    }
    triangle {
      < 1.221613, -0.754193, 1.529915>,
      < 1.276563, -0.755663, 1.501952>,
      < 1.276556, -0.744511, 1.510987>
    }
    triangle {
      < 1.221577, -0.693784, 1.436872>,
      < 1.221568, -0.679185, 1.454885>,
      < 1.276528, -0.698077, 1.464540>
    }
    triangle {
      < 1.221577, -0.693784, 1.436872>,
      < 1.276528, -0.698077, 1.464540>,
      < 1.276534, -0.707116, 1.453389>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415290, -0.766987, 1.510307>,
      < -0.415299, -0.751544, 1.522817>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415337, -0.687251, 1.458505>,
      < -0.415330, -0.699766, 1.443066>
    }
    triangle {
      < 1.276556, -0.744511, 1.510987>,
      < 1.276563, -0.755663, 1.501952>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.276534, -0.707116, 1.453389>,
      < 1.276528, -0.698077, 1.464540>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415330, -0.699766, 1.443066>,
      < -0.415319, -0.717477, 1.434050>
    }
    triangle {
      < 1.276563, -0.755663, 1.501952>,
      < 1.276566, -0.762179, 1.489163>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415319, -0.717477, 1.434050>,
      < -0.415308, -0.737324, 1.433017>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415297, -0.755876, 1.440143>,
      < -0.415288, -0.769927, 1.454197>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415308, -0.737324, 1.433017>,
      < -0.415297, -0.755876, 1.440143>
    }
    triangle {
      < 1.276564, -0.757787, 1.461429>,
      < 1.276557, -0.747639, 1.451278>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.276541, -0.719907, 1.446878>,
      < 1.276534, -0.707116, 1.453389>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.276549, -0.734240, 1.446131>,
      < 1.276541, -0.719907, 1.446878>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415284, -0.776008, 1.492599>,
      < -0.415290, -0.766987, 1.510307>
    }
    triangle {
      < 1.276566, -0.762179, 1.489163>,
      < 1.276566, -0.762930, 1.474829>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < 1.276557, -0.747639, 1.451278>,
      < 1.276549, -0.734240, 1.446131>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415284, -0.777048, 1.472752>,
      < -0.415284, -0.776008, 1.492599>
    }
    triangle {
      < 1.276566, -0.762930, 1.474829>,
      < 1.276564, -0.757787, 1.461429>,
      < 1.322820, -0.728803, 1.480229>
    }
    triangle {
      < -0.397960, -0.729823, 1.480228>,
      < -0.415288, -0.769927, 1.454197>,
      < -0.415284, -0.777048, 1.472752>
    }
    triangle {
      < 1.221624, -0.772209, 1.515320>,
      < 1.221629, -0.782733, 1.494660>,
      < 1.276566, -0.762179, 1.489163>
    }
    triangle {
      < 1.221624, -0.772209, 1.515320>,
      < 1.276566, -0.762179, 1.489163>,
      < 1.276563, -0.755663, 1.501952>
    }
    triangle {
      < 1.221590, -0.714447, 1.426354>,
      < 1.221577, -0.693784, 1.436872>,
      < 1.276534, -0.707116, 1.453389>
    }
    triangle {
      < 1.221590, -0.714447, 1.426354>,
      < 1.276534, -0.707116, 1.453389>,
      < 1.276541, -0.719907, 1.446878>
    }
    triangle {
      < -0.415290, -0.766987, 1.510307>,
      < -0.415284, -0.776008, 1.492599>,
      < -0.499139, -0.801709, 1.499471>
    }
    triangle {
      < -0.415290, -0.766987, 1.510307>,
      < -0.499139, -0.801709, 1.499471>,
      < -0.499148, -0.787678, 1.527017>
    }
    triangle {
      < -0.415319, -0.717477, 1.434050>,
      < -0.415330, -0.699766, 1.443066>,
      < -0.499209, -0.683112, 1.422420>
    }
    triangle {
      < -0.415319, -0.717477, 1.434050>,
      < -0.499209, -0.683112, 1.422420>,
      < -0.499193, -0.710662, 1.408396>
    }
    triangle {
      < 1.123302, -0.786715, 1.527018>,
      < 1.123310, -0.800747, 1.499471>,
      < 1.221629, -0.782733, 1.494660>
    }
    triangle {
      < 1.123302, -0.786715, 1.527018>,
      < 1.221629, -0.782733, 1.494660>,
      < 1.221624, -0.772209, 1.515320>
    }
    triangle {
      < 1.123256, -0.709700, 1.408396>,
      < 1.123240, -0.682150, 1.422420>,
      < 1.221577, -0.693784, 1.436872>
    }
    triangle {
      < 1.123256, -0.709700, 1.408396>,
      < 1.221577, -0.693784, 1.436872>,
      < 1.221590, -0.714447, 1.426354>
    }
    triangle {
      < -0.499148, -0.787678, 1.527017>,
      < -0.499139, -0.801709, 1.499471>,
      < -0.487561, -0.819660, 1.504281>
    }
    triangle {
      < -0.499148, -0.787678, 1.527017>,
      < -0.487561, -0.819660, 1.504281>,
      < -0.487570, -0.802119, 1.538715>
    }
    triangle {
      < 0.900621, -0.801296, 1.538715>,
      < 0.900632, -0.818837, 1.504282>,
      < 1.123310, -0.800747, 1.499471>
    }
    triangle {
      < 0.900621, -0.801296, 1.538715>,
      < 1.123310, -0.800747, 1.499471>,
      < 1.123302, -0.786715, 1.527018>
    }
    triangle {
      < 0.900564, -0.705027, 1.390438>,
      < 0.900544, -0.670588, 1.407969>,
      < 1.123240, -0.682150, 1.422420>
    }
    triangle {
      < 0.900564, -0.705027, 1.390438>,
      < 1.123240, -0.682150, 1.422420>,
      < 1.123256, -0.709700, 1.408396>
    }
    triangle {
      < -0.499193, -0.710662, 1.408396>,
      < -0.499209, -0.683112, 1.422420>,
      < -0.487648, -0.671411, 1.407969>
    }
    triangle {
      < -0.499193, -0.710662, 1.408396>,
      < -0.487648, -0.671411, 1.407969>,
      < -0.487627, -0.705850, 1.390438>
    }
    triangle {
      < 1.221629, -0.782733, 1.494660>,
      < 1.221630, -0.783947, 1.471507>,
      < 1.276566, -0.762930, 1.474829>
    }
    triangle {
      < 1.221629, -0.782733, 1.494660>,
      < 1.276566, -0.762930, 1.474829>,
      < 1.276566, -0.762179, 1.489163>
    }
    triangle {
      < 1.221603, -0.737602, 1.425148>,
      < 1.221590, -0.714447, 1.426354>,
      < 1.276541, -0.719907, 1.446878>
    }
    triangle {
      < 1.221603, -0.737602, 1.425148>,
      < 1.276541, -0.719907, 1.446878>,
      < 1.276549, -0.734240, 1.446131>
    }
    triangle {
      < -0.415284, -0.776008, 1.492599>,
      < -0.415284, -0.777048, 1.472752>,
      < -0.499138, -0.803327, 1.468599>
    }
    triangle {
      < -0.415284, -0.776008, 1.492599>,
      < -0.499138, -0.803327, 1.468599>,
      < -0.499139, -0.801709, 1.499471>
    }
    triangle {
      < -0.415308, -0.737324, 1.433017>,
      < -0.415319, -0.717477, 1.434050>,
      < -0.499193, -0.710662, 1.408396>
    }
    triangle {
      < -0.415308, -0.737324, 1.433017>,
      < -0.499193, -0.710662, 1.408396>,
      < -0.499175, -0.741535, 1.406788>
    }
    triangle {
      < 1.123310, -0.800747, 1.499471>,
      < 1.123311, -0.802365, 1.468600>,
      < 1.221630, -0.783947, 1.471507>
    }
    triangle {
      < 1.123310, -0.800747, 1.499471>,
      < 1.221630, -0.783947, 1.471507>,
      < 1.221629, -0.782733, 1.494660>
    }
    triangle {
      < 1.221630, -0.783947, 1.471507>,
      < 1.221626, -0.775639, 1.449860>,
      < 1.276564, -0.757787, 1.461429>
    }
    triangle {
      < 1.221630, -0.783947, 1.471507>,
      < 1.276564, -0.757787, 1.461429>,
      < 1.276566, -0.762930, 1.474829>
    }
    triangle {
      < 1.123275, -0.740573, 1.406788>,
      < 1.123256, -0.709700, 1.408396>,
      < 1.221590, -0.714447, 1.426354>
    }
    triangle {
      < 1.123275, -0.740573, 1.406788>,
      < 1.221590, -0.714447, 1.426354>,
      < 1.221603, -0.737602, 1.425148>
    }
    triangle {
      < 1.221616, -0.759246, 1.433463>,
      < 1.221603, -0.737602, 1.425148>,
      < 1.276549, -0.734240, 1.446131>
    }
    triangle {
      < 1.221616, -0.759246, 1.433463>,
      < 1.276549, -0.734240, 1.446131>,
      < 1.276557, -0.747639, 1.451278>
    }
    triangle {
      < 1.221626, -0.775639, 1.449860>,
      < 1.221616, -0.759246, 1.433463>,
      < 1.276557, -0.747639, 1.451278>
    }
    triangle {
      < 1.221626, -0.775639, 1.449860>,
      < 1.276557, -0.747639, 1.451278>,
      < 1.276564, -0.757787, 1.461429>
    }
    triangle {
      < -0.499139, -0.801709, 1.499471>,
      < -0.499138, -0.803327, 1.468599>,
      < -0.487559, -0.821681, 1.465690>
    }
    triangle {
      < -0.499139, -0.801709, 1.499471>,
      < -0.487559, -0.821681, 1.465690>,
      < -0.487561, -0.819660, 1.504281>
    }
    triangle {
      < 0.900632, -0.818837, 1.504282>,
      < 0.900633, -0.820859, 1.465691>,
      < 1.123311, -0.802365, 1.468600>
    }
    triangle {
      < 0.900632, -0.818837, 1.504282>,
      < 1.123311, -0.802365, 1.468600>,
      < 1.123310, -0.800747, 1.499471>
    }
    triangle {
      < 0.900588, -0.743618, 1.388427>,
      < 0.900564, -0.705027, 1.390438>,
      < 1.123256, -0.709700, 1.408396>
    }
    triangle {
      < 0.900588, -0.743618, 1.388427>,
      < 1.123256, -0.709700, 1.408396>,
      < 1.123275, -0.740573, 1.406788>
    }
    triangle {
      < -0.499175, -0.741535, 1.406788>,
      < -0.499193, -0.710662, 1.408396>,
      < -0.487627, -0.705850, 1.390438>
    }
    triangle {
      < -0.499175, -0.741535, 1.406788>,
      < -0.487627, -0.705850, 1.390438>,
      < -0.487605, -0.744441, 1.388427>
    }
    triangle {
      < -0.415284, -0.777048, 1.472752>,
      < -0.415288, -0.769927, 1.454197>,
      < -0.499145, -0.792251, 1.439737>
    }
    triangle {
      < -0.415284, -0.777048, 1.472752>,
      < -0.499145, -0.792251, 1.439737>,
      < -0.499138, -0.803327, 1.468599>
    }
    triangle {
      < -0.415297, -0.755876, 1.440143>,
      < -0.415308, -0.737324, 1.433017>,
      < -0.499175, -0.741535, 1.406788>
    }
    triangle {
      < -0.415297, -0.755876, 1.440143>,
      < -0.499175, -0.741535, 1.406788>,
      < -0.499158, -0.770394, 1.417873>
    }
    triangle {
      < 1.123311, -0.802365, 1.468600>,
      < 1.123304, -0.791289, 1.439737>,
      < 1.221626, -0.775639, 1.449860>
    }
    triangle {
      < 1.123311, -0.802365, 1.468600>,
      < 1.221626, -0.775639, 1.449860>,
      < 1.221630, -0.783947, 1.471507>
    }
    triangle {
      < 1.123292, -0.769433, 1.417874>,
      < 1.123275, -0.740573, 1.406788>,
      < 1.221603, -0.737602, 1.425148>
    }
    triangle {
      < 1.123292, -0.769433, 1.417874>,
      < 1.221603, -0.737602, 1.425148>,
      < 1.221616, -0.759246, 1.433463>
    }
    triangle {
      < -0.487561, -0.819660, 1.504281>,
      < -0.487559, -0.821681, 1.465690>,
      < 0.900633, -0.820859, 1.465691>
    }
    triangle {
      < -0.487561, -0.819660, 1.504281>,
      < 0.900633, -0.820859, 1.465691>,
      < 0.900632, -0.818837, 1.504282>
    }
    triangle {
      < -0.487605, -0.744441, 1.388427>,
      < -0.487627, -0.705850, 1.390438>,
      < 0.900564, -0.705027, 1.390438>
    }
    triangle {
      < -0.487605, -0.744441, 1.388427>,
      < 0.900564, -0.705027, 1.390438>,
      < 0.900588, -0.743618, 1.388427>
    }
    triangle {
      < -0.415288, -0.769927, 1.454197>,
      < -0.415297, -0.755876, 1.440143>,
      < -0.499158, -0.770394, 1.417873>
    }
    triangle {
      < -0.415288, -0.769927, 1.454197>,
      < -0.499158, -0.770394, 1.417873>,
      < -0.499145, -0.792251, 1.439737>
    }
    triangle {
      < 1.123304, -0.791289, 1.439737>,
      < 1.123292, -0.769433, 1.417874>,
      < 1.221616, -0.759246, 1.433463>
    }
    triangle {
      < 1.123304, -0.791289, 1.439737>,
      < 1.221616, -0.759246, 1.433463>,
      < 1.221626, -0.775639, 1.449860>
    }
    triangle {
      < -0.499138, -0.803327, 1.468599>,
      < -0.499145, -0.792251, 1.439737>,
      < -0.487567, -0.807835, 1.429613>
    }
    triangle {
      < -0.499138, -0.803327, 1.468599>,
      < -0.487567, -0.807835, 1.429613>,
      < -0.487559, -0.821681, 1.465690>
    }
    triangle {
      < 0.900633, -0.820859, 1.465691>,
      < 0.900625, -0.807012, 1.429614>,
      < 1.123304, -0.791289, 1.439737>
    }
    triangle {
      < 0.900633, -0.820859, 1.465691>,
      < 1.123304, -0.791289, 1.439737>,
      < 1.123311, -0.802365, 1.468600>
    }
    triangle {
      < 0.900608, -0.779692, 1.402284>,
      < 0.900588, -0.743618, 1.388427>,
      < 1.123275, -0.740573, 1.406788>
    }
    triangle {
      < 0.900608, -0.779692, 1.402284>,
      < 1.123275, -0.740573, 1.406788>,
      < 1.123292, -0.769433, 1.417874>
    }
    triangle {
      < -0.499158, -0.770394, 1.417873>,
      < -0.499175, -0.741535, 1.406788>,
      < -0.487605, -0.744441, 1.388427>
    }
    triangle {
      < -0.499158, -0.770394, 1.417873>,
      < -0.487605, -0.744441, 1.388427>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < -0.499145, -0.792251, 1.439737>,
      < -0.499158, -0.770394, 1.417873>,
      < -0.487583, -0.780514, 1.402284>
    }
    triangle {
      < -0.499145, -0.792251, 1.439737>,
      < -0.487583, -0.780514, 1.402284>,
      < -0.487567, -0.807835, 1.429613>
    }
    triangle {
      < 0.900625, -0.807012, 1.429614>,
      < 0.900608, -0.779692, 1.402284>,
      < 1.123292, -0.769433, 1.417874>
    }
    triangle {
      < 0.900625, -0.807012, 1.429614>,
      < 1.123292, -0.769433, 1.417874>,
      < 1.123304, -0.791289, 1.439737>
    }
    triangle {
      < -0.487559, -0.821681, 1.465690>,
      < -0.487567, -0.807835, 1.429613>,
      < 0.900625, -0.807012, 1.429614>
    }
    triangle {
      < -0.487559, -0.821681, 1.465690>,
      < 0.900625, -0.807012, 1.429614>,
      < 0.900633, -0.820859, 1.465691>
    }
    triangle {
      < -0.487583, -0.780514, 1.402284>,
      < -0.487605, -0.744441, 1.388427>,
      < 0.900588, -0.743618, 1.388427>
    }
    triangle {
      < -0.487583, -0.780514, 1.402284>,
      < 0.900588, -0.743618, 1.388427>,
      < 0.900608, -0.779692, 1.402284>
    }
    triangle {
      < -0.290927, -0.511352, 1.079718>,
      < -0.254734, -0.676876, 0.918610>,
      < -0.254742, -0.663665, 0.910039>
    }
    triangle {
      < -0.290927, -0.511352, 1.079718>,
      < -0.254742, -0.663665, 0.910039>,
      < -0.290938, -0.493626, 1.061966>
    }
    triangle {
      < -0.254742, -0.663665, 0.910039>,
      < -0.254748, -0.654969, 0.896646>,
      < -0.290938, -0.493626, 1.061966>
    }
    triangle {
      < -0.446280, -0.493718, 1.061966>,
      < -0.446840, -0.655083, 0.896645>,
      < -0.446835, -0.663778, 0.910039>
    }
    triangle {
      < -0.446280, -0.493718, 1.061966>,
      < -0.446835, -0.663778, 0.910039>,
      < -0.446269, -0.511444, 1.079717>
    }
    triangle {
      < -0.446835, -0.663778, 0.910039>,
      < -0.446827, -0.676989, 0.918610>,
      < -0.446269, -0.511444, 1.079717>
    }
    triangle {
      < -0.290938, -0.493626, 1.061966>,
      < -0.254748, -0.654969, 0.896646>,
      < -0.446840, -0.655083, 0.896645>
    }
    triangle {
      < -0.290938, -0.493626, 1.061966>,
      < -0.446840, -0.655083, 0.896645>,
      < -0.446280, -0.493718, 1.061966>
    }
    triangle {
      < -0.446269, -0.511444, 1.079717>,
      < -0.446827, -0.676989, 0.918610>,
      < -0.254734, -0.676876, 0.918610>
    }
    triangle {
      < -0.446269, -0.511444, 1.079717>,
      < -0.254734, -0.676876, 0.918610>,
      < -0.290927, -0.511352, 1.079718>
    }
    triangle {
      < 0.488413, -0.642867, 0.952128>,
      < 0.521178, -0.676416, 0.918610>,
      < 0.518899, -0.663206, 0.910039>
    }
    triangle {
      < 0.488413, -0.642867, 0.952128>,
      < 0.518899, -0.663206, 0.910039>,
      < 0.488400, -0.620949, 0.930176>
    }
    triangle {
      < 0.518899, -0.663206, 0.910039>,
      < 0.521177, -0.654509, 0.896646>,
      < 0.488400, -0.620949, 0.930176>
    }
    triangle {
      < -0.217368, -0.493582, 1.061966>,
      < -0.163773, -0.654915, 0.896646>,
      < -0.163768, -0.663611, 0.910039>
    }
    triangle {
      < -0.217368, -0.493582, 1.061966>,
      < -0.163768, -0.663611, 0.910039>,
      < -0.217357, -0.511308, 1.079718>
    }
    triangle {
      < -0.163768, -0.663611, 0.910039>,
      < -0.163759, -0.676822, 0.918610>,
      < -0.217357, -0.511308, 1.079718>
    }
    triangle {
      < 0.488400, -0.620949, 0.930176>,
      < 0.521177, -0.654509, 0.896646>,
      < -0.163773, -0.654915, 0.896646>
    }
    triangle {
      < 0.488400, -0.620949, 0.930176>,
      < -0.163773, -0.654915, 0.896646>,
      < -0.217368, -0.493582, 1.061966>
    }
    triangle {
      < -0.217357, -0.511308, 1.079718>,
      < -0.163759, -0.676822, 0.918610>,
      < 0.521178, -0.676416, 0.918610>
    }
    triangle {
      < -0.217357, -0.511308, 1.079718>,
      < 0.521178, -0.676416, 0.918610>,
      < 0.488413, -0.642867, 0.952128>
    }
    triangle {
      < -0.290938, -0.493884, 0.626322>,
      < -0.254748, -0.654926, 0.791727>,
      < -0.254738, -0.670897, 0.772023>
    }
    triangle {
      < -0.290938, -0.493884, 0.626322>,
      < -0.254738, -0.670897, 0.772023>,
      < -0.290927, -0.511631, 0.608592>
    }
    triangle {
      < -0.254738, -0.670897, 0.772023>,
      < -0.254735, -0.676328, 0.769259>,
      < -0.290927, -0.511631, 0.608592>
    }
    triangle {
      < -0.446269, -0.511723, 0.608592>,
      < -0.446828, -0.676442, 0.769259>,
      < -0.446830, -0.671010, 0.772023>
    }
    triangle {
      < -0.446269, -0.511723, 0.608592>,
      < -0.446830, -0.671010, 0.772023>,
      < -0.446280, -0.493976, 0.626322>
    }
    triangle {
      < -0.446830, -0.671010, 0.772023>,
      < -0.446840, -0.655039, 0.791727>,
      < -0.446280, -0.493976, 0.626322>
    }
    triangle {
      < -0.290927, -0.511631, 0.608592>,
      < -0.254735, -0.676328, 0.769259>,
      < -0.446828, -0.676442, 0.769259>
    }
    triangle {
      < -0.290927, -0.511631, 0.608592>,
      < -0.446828, -0.676442, 0.769259>,
      < -0.446269, -0.511723, 0.608592>
    }
    triangle {
      < -0.446280, -0.493976, 0.626322>,
      < -0.446840, -0.655039, 0.791727>,
      < -0.254748, -0.654926, 0.791727>
    }
    triangle {
      < -0.446280, -0.493976, 0.626322>,
      < -0.254748, -0.654926, 0.791727>,
      < -0.290938, -0.493884, 0.626322>
    }
    triangle {
      < 0.488400, -0.621051, 0.758263>,
      < 0.521074, -0.654466, 0.791727>,
      < 0.519253, -0.670438, 0.772023>
    }
    triangle {
      < 0.488400, -0.621051, 0.758263>,
      < 0.519253, -0.670438, 0.772023>,
      < 0.488413, -0.642996, 0.736337>
    }
    triangle {
      < 0.519253, -0.670438, 0.772023>,
      < 0.520556, -0.675868, 0.769259>,
      < 0.488413, -0.642996, 0.736337>
    }
    triangle {
      < -0.217357, -0.511587, 0.608592>,
      < -0.163760, -0.676274, 0.769259>,
      < -0.163763, -0.670843, 0.772023>
    }
    triangle {
      < -0.217357, -0.511587, 0.608592>,
      < -0.163763, -0.670843, 0.772023>,
      < -0.217368, -0.493840, 0.626322>
    }
    triangle {
      < -0.163763, -0.670843, 0.772023>,
      < -0.163773, -0.654872, 0.791727>,
      < -0.217368, -0.493840, 0.626322>
    }
    triangle {
      < 0.488413, -0.642996, 0.736337>,
      < 0.520556, -0.675868, 0.769259>,
      < -0.163760, -0.676274, 0.769259>
    }
    triangle {
      < 0.488413, -0.642996, 0.736337>,
      < -0.163760, -0.676274, 0.769259>,
      < -0.217357, -0.511587, 0.608592>
    }
    triangle {
      < -0.217368, -0.493840, 0.626322>,
      < -0.163773, -0.654872, 0.791727>,
      < 0.521074, -0.654466, 0.791727>
    }
    triangle {
      < -0.217368, -0.493840, 0.626322>,
      < 0.521074, -0.654466, 0.791727>,
      < 0.488400, -0.621051, 0.758263>
    }
    triangle {
      < -0.290668, -0.947274, 0.608720>,
      < -0.254672, -0.782694, 0.769034>,
      < -0.254659, -0.804626, 0.790973>
    }
    triangle {
      < -0.290668, -0.947274, 0.608720>,
      < -0.254659, -0.804626, 0.790973>,
      < -0.290659, -0.965010, 0.626462>
    }
    triangle {
      < -0.446001, -0.965102, 0.626462>,
      < -0.446751, -0.804739, 0.790973>,
      < -0.446764, -0.782807, 0.769034>
    }
    triangle {
      < -0.446001, -0.965102, 0.626462>,
      < -0.446764, -0.782807, 0.769034>,
      < -0.446011, -0.947366, 0.608720>
    }
    triangle {
      < -0.290659, -0.965010, 0.626462>,
      < -0.254659, -0.804626, 0.790973>,
      < -0.446751, -0.804739, 0.790973>
    }
    triangle {
      < -0.290659, -0.965010, 0.626462>,
      < -0.446751, -0.804739, 0.790973>,
      < -0.446001, -0.965102, 0.626462>
    }
    triangle {
      < -0.446011, -0.947366, 0.608720>,
      < -0.446764, -0.782807, 0.769034>,
      < -0.254672, -0.782694, 0.769034>
    }
    triangle {
      < -0.446011, -0.947366, 0.608720>,
      < -0.254672, -0.782694, 0.769034>,
      < -0.290668, -0.947274, 0.608720>
    }
    triangle {
      < 0.488515, -0.814909, 0.736389>,
      < 0.520370, -0.782234, 0.769035>,
      < 0.520383, -0.804166, 0.790973>
    }
    triangle {
      < 0.488515, -0.814909, 0.736389>,
      < 0.520383, -0.804166, 0.790973>,
      < 0.488528, -0.836841, 0.758327>
    }
    triangle {
      < -0.217089, -0.964966, 0.626462>,
      < -0.163684, -0.804572, 0.790973>,
      < -0.163697, -0.782640, 0.769034>
    }
    triangle {
      < -0.217089, -0.964966, 0.626462>,
      < -0.163697, -0.782640, 0.769034>,
      < -0.217099, -0.947230, 0.608720>
    }
    triangle {
      < 0.488528, -0.836841, 0.758327>,
      < 0.520383, -0.804166, 0.790973>,
      < -0.163684, -0.804572, 0.790973>
    }
    triangle {
      < 0.488528, -0.836841, 0.758327>,
      < -0.163684, -0.804572, 0.790973>,
      < -0.217089, -0.964966, 0.626462>
    }
    triangle {
      < -0.217099, -0.947230, 0.608720>,
      < -0.163697, -0.782640, 0.769034>,
      < 0.520370, -0.782234, 0.769035>
    }
    triangle {
      < -0.217099, -0.947230, 0.608720>,
      < 0.520370, -0.782234, 0.769035>,
      < 0.488515, -0.814909, 0.736389>
    }
    triangle {
      < -0.290659, -0.965010, 1.062105>,
      < -0.254659, -0.804371, 0.897339>,
      < -0.254660, -0.801604, 0.902770>
    }
    triangle {
      < -0.290659, -0.965010, 1.062105>,
      < -0.254660, -0.801604, 0.902770>,
      < -0.290668, -0.947274, 1.079848>
    }
    triangle {
      < -0.254660, -0.801604, 0.902770>,
      < -0.254672, -0.781896, 0.918735>,
      < -0.290668, -0.947274, 1.079848>
    }
    triangle {
      < -0.446011, -0.947366, 1.079848>,
      < -0.446764, -0.782009, 0.918735>,
      < -0.446753, -0.801717, 0.902770>
    }
    triangle {
      < -0.446011, -0.947366, 1.079848>,
      < -0.446753, -0.801717, 0.902770>,
      < -0.446001, -0.965103, 1.062105>
    }
    triangle {
      < -0.446753, -0.801717, 0.902770>,
      < -0.446751, -0.804484, 0.897339>,
      < -0.446001, -0.965103, 1.062105>
    }
    triangle {
      < -0.290668, -0.947274, 1.079848>,
      < -0.254672, -0.781896, 0.918735>,
      < -0.446764, -0.782009, 0.918735>
    }
    triangle {
      < -0.290668, -0.947274, 1.079848>,
      < -0.446764, -0.782009, 0.918735>,
      < -0.446011, -0.947366, 1.079848>
    }
    triangle {
      < -0.446001, -0.965103, 1.062105>,
      < -0.446751, -0.804484, 0.897339>,
      < -0.254659, -0.804371, 0.897339>
    }
    triangle {
      < -0.446001, -0.965103, 1.062105>,
      < -0.254659, -0.804371, 0.897339>,
      < -0.290659, -0.965010, 1.062105>
    }
    triangle {
      < 0.488528, -0.836841, 0.930241>,
      < 0.520632, -0.803911, 0.897339>,
      < 0.519332, -0.801145, 0.902770>
    }
    triangle {
      < 0.488528, -0.836841, 0.930241>,
      < 0.519332, -0.801145, 0.902770>,
      < 0.488515, -0.814909, 0.952179>
    }
    triangle {
      < 0.519332, -0.801145, 0.902770>,
      < 0.521150, -0.781436, 0.918735>,
      < 0.488515, -0.814909, 0.952179>
    }
    triangle {
      < -0.217099, -0.947230, 1.079848>,
      < -0.163697, -0.781842, 0.918735>,
      < -0.163686, -0.801550, 0.902770>
    }
    triangle {
      < -0.217099, -0.947230, 1.079848>,
      < -0.163686, -0.801550, 0.902770>,
      < -0.217089, -0.964967, 1.062105>
    }
    triangle {
      < -0.163686, -0.801550, 0.902770>,
      < -0.163685, -0.804317, 0.897339>,
      < -0.217089, -0.964967, 1.062105>
    }
    triangle {
      < 0.488515, -0.814909, 0.952179>,
      < 0.521150, -0.781436, 0.918735>,
      < -0.163697, -0.781842, 0.918735>
    }
    triangle {
      < 0.488515, -0.814909, 0.952179>,
      < -0.163697, -0.781842, 0.918735>,
      < -0.217099, -0.947230, 1.079848>
    }
    triangle {
      < -0.217089, -0.964967, 1.062105>,
      < -0.163685, -0.804317, 0.897339>,
      < 0.520632, -0.803911, 0.897339>
    }
    triangle {
      < -0.217089, -0.964967, 1.062105>,
      < 0.520632, -0.803911, 0.897339>,
      < 0.488528, -0.836841, 0.930241>
    }
    triangle {
      < -0.217368, -0.493582, 1.061966>,
      < -0.217357, -0.511308, 1.079718>,
      < 0.488413, -0.642867, 0.952128>
    }
    triangle {
      < -0.217368, -0.493582, 1.061966>,
      < 0.488413, -0.642867, 0.952128>,
      < 0.488400, -0.620949, 0.930176>
    }
    triangle {
      < -0.446280, -0.493718, 1.061966>,
      < -0.446269, -0.511444, 1.079717>,
      < -0.290927, -0.511352, 1.079718>
    }
    triangle {
      < -0.446280, -0.493718, 1.061966>,
      < -0.290927, -0.511352, 1.079718>,
      < -0.290938, -0.493626, 1.061966>
    }
    triangle {
      < -0.217099, -0.947230, 1.079848>,
      < -0.217089, -0.964967, 1.062105>,
      < 0.488528, -0.836841, 0.930241>
    }
    triangle {
      < -0.217099, -0.947230, 1.079848>,
      < 0.488528, -0.836841, 0.930241>,
      < 0.488515, -0.814909, 0.952179>
    }
    triangle {
      < -0.446011, -0.947366, 1.079848>,
      < -0.446001, -0.965103, 1.062105>,
      < -0.290659, -0.965010, 1.062105>
    }
    triangle {
      < -0.446011, -0.947366, 1.079848>,
      < -0.290659, -0.965010, 1.062105>,
      < -0.290668, -0.947274, 1.079848>
    }
    triangle {
      < -0.217357, -0.511587, 0.608592>,
      < -0.217368, -0.493840, 0.626322>,
      < 0.488400, -0.621051, 0.758263>
    }
    triangle {
      < -0.217357, -0.511587, 0.608592>,
      < 0.488400, -0.621051, 0.758263>,
      < 0.488413, -0.642996, 0.736337>
    }
    triangle {
      < -0.446269, -0.511723, 0.608592>,
      < -0.446280, -0.493976, 0.626322>,
      < -0.290938, -0.493884, 0.626322>
    }
    triangle {
      < -0.446269, -0.511723, 0.608592>,
      < -0.290938, -0.493884, 0.626322>,
      < -0.290927, -0.511631, 0.608592>
    }
    triangle {
      < -0.217089, -0.964966, 0.626462>,
      < -0.217099, -0.947230, 0.608720>,
      < 0.488515, -0.814909, 0.736389>
    }
    triangle {
      < -0.217089, -0.964966, 0.626462>,
      < 0.488515, -0.814909, 0.736389>,
      < 0.488528, -0.836841, 0.758327>
    }
    triangle {
      < -0.446001, -0.965102, 0.626462>,
      < -0.446011, -0.947366, 0.608720>,
      < -0.290668, -0.947274, 0.608720>
    }
    triangle {
      < -0.446001, -0.965102, 0.626462>,
      < -0.290668, -0.947274, 0.608720>,
      < -0.290659, -0.965010, 0.626462>
    }
    triangle {
      < -0.163773, -0.654915, 0.896646>,
      < 0.521177, -0.654509, 0.896646>,
      < 0.916814, -0.641868, 0.877537>
    }
    triangle {
      < 0.521177, -0.654509, 0.896646>,
      < 0.518899, -0.663206, 0.910039>,
      < 0.916825, -0.662970, 0.910039>
    }
    triangle {
      < 0.521177, -0.654509, 0.896646>,
      < 0.916825, -0.662970, 0.910039>,
      < 0.916814, -0.641868, 0.877537>
    }
    triangle {
      < -0.163773, -0.654915, 0.896646>,
      < 0.916814, -0.641868, 0.877537>,
      < -0.254748, -0.654969, 0.896646>
    }
    triangle {
      < -0.163773, -0.654915, 0.896646>,
      < -0.254748, -0.654969, 0.896646>,
      < -0.163768, -0.663611, 0.910039>
    }
    triangle {
      < 0.916814, -0.641868, 0.877537>,
      < -0.471378, -0.642690, 0.877537>,
      < -0.446840, -0.655083, 0.896645>
    }
    triangle {
      < 0.916814, -0.641868, 0.877537>,
      < -0.446840, -0.655083, 0.896645>,
      < -0.254748, -0.654969, 0.896646>
    }
    triangle {
      < -0.471378, -0.642690, 0.877537>,
      < -0.471365, -0.663792, 0.910039>,
      < -0.446835, -0.663778, 0.910039>
    }
    triangle {
      < -0.471378, -0.642690, 0.877537>,
      < -0.446835, -0.663778, 0.910039>,
      < -0.446840, -0.655083, 0.896645>
    }
    triangle {
      < -0.254748, -0.654969, 0.896646>,
      < -0.254742, -0.663665, 0.910039>,
      < -0.163768, -0.663611, 0.910039>
    }
    triangle {
      < -0.254748, -0.654926, 0.791727>,
      < -0.446840, -0.655039, 0.791727>,
      < -0.471375, -0.646692, 0.802044>
    }
    triangle {
      < -0.446840, -0.655039, 0.791727>,
      < -0.446830, -0.671010, 0.772023>,
      < -0.471361, -0.671024, 0.772023>
    }
    triangle {
      < -0.446840, -0.655039, 0.791727>,
      < -0.471361, -0.671024, 0.772023>,
      < -0.471375, -0.646692, 0.802044>
    }
    triangle {
      < -0.254748, -0.654926, 0.791727>,
      < -0.471375, -0.646692, 0.802044>,
      < -0.163773, -0.654872, 0.791727>
    }
    triangle {
      < -0.254748, -0.654926, 0.791727>,
      < -0.163773, -0.654872, 0.791727>,
      < -0.254738, -0.670897, 0.772023>
    }
    triangle {
      < -0.471375, -0.646692, 0.802044>,
      < 0.916816, -0.645869, 0.802044>,
      < 0.521074, -0.654466, 0.791727>
    }
    triangle {
      < -0.471375, -0.646692, 0.802044>,
      < 0.521074, -0.654466, 0.791727>,
      < -0.163773, -0.654872, 0.791727>
    }
    triangle {
      < 0.916816, -0.645869, 0.802044>,
      < 0.916830, -0.670202, 0.772023>,
      < 0.519253, -0.670438, 0.772023>
    }
    triangle {
      < 0.916816, -0.645869, 0.802044>,
      < 0.519253, -0.670438, 0.772023>,
      < 0.521074, -0.654466, 0.791727>
    }
    triangle {
      < -0.163773, -0.654872, 0.791727>,
      < -0.163763, -0.670843, 0.772023>,
      < -0.254738, -0.670897, 0.772023>
    }
    triangle {
      < -0.163760, -0.676274, 0.769259>,
      < 0.520556, -0.675868, 0.769259>,
      < 0.916851, -0.704640, 0.754493>
    }
    triangle {
      < 0.520556, -0.675868, 0.769259>,
      < 0.519253, -0.670438, 0.772023>,
      < 0.916830, -0.670202, 0.772023>
    }
    triangle {
      < 0.520556, -0.675868, 0.769259>,
      < 0.916830, -0.670202, 0.772023>,
      < 0.916851, -0.704640, 0.754493>
    }
    triangle {
      < -0.163760, -0.676274, 0.769259>,
      < 0.916851, -0.704640, 0.754493>,
      < -0.254735, -0.676328, 0.769259>
    }
    triangle {
      < -0.163760, -0.676274, 0.769259>,
      < -0.254735, -0.676328, 0.769259>,
      < -0.163763, -0.670843, 0.772023>
    }
    triangle {
      < 0.916851, -0.704640, 0.754493>,
      < -0.471341, -0.705462, 0.754493>,
      < -0.446828, -0.676442, 0.769259>
    }
    triangle {
      < 0.916851, -0.704640, 0.754493>,
      < -0.446828, -0.676442, 0.769259>,
      < -0.254735, -0.676328, 0.769259>
    }
    triangle {
      < -0.471341, -0.705462, 0.754493>,
      < -0.471361, -0.671024, 0.772023>,
      < -0.446830, -0.671010, 0.772023>
    }
    triangle {
      < -0.471341, -0.705462, 0.754493>,
      < -0.446830, -0.671010, 0.772023>,
      < -0.446828, -0.676442, 0.769259>
    }
    triangle {
      < -0.254735, -0.676328, 0.769259>,
      < -0.254738, -0.670897, 0.772023>,
      < -0.163763, -0.670843, 0.772023>
    }
    triangle {
      < 0.916895, -0.779305, 0.766339>,
      < 0.520370, -0.782234, 0.769035>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < 0.916895, -0.779305, 0.766339>,
      < 0.916911, -0.806626, 0.793669>,
      < 0.520383, -0.804166, 0.790973>
    }
    triangle {
      < 0.916895, -0.779305, 0.766339>,
      < 0.520383, -0.804166, 0.790973>,
      < 0.520370, -0.782234, 0.769035>
    }
    triangle {
      < 0.916911, -0.806626, 0.793669>,
      < -0.163684, -0.804572, 0.790973>,
      < 0.520383, -0.804166, 0.790973>
    }
    triangle {
      < 0.916911, -0.806626, 0.793669>,
      < -0.254659, -0.804626, 0.790973>,
      < -0.163684, -0.804572, 0.790973>
    }
    triangle {
      < 0.520370, -0.782234, 0.769035>,
      < -0.163697, -0.782640, 0.769034>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < -0.163697, -0.782640, 0.769034>,
      < -0.254672, -0.782694, 0.769034>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < -0.163697, -0.782640, 0.769034>,
      < -0.163684, -0.804572, 0.790973>,
      < -0.254672, -0.782694, 0.769034>
    }
    triangle {
      < -0.163684, -0.804572, 0.790973>,
      < -0.254659, -0.804626, 0.790973>,
      < -0.254672, -0.782694, 0.769034>
    }
    triangle {
      < 0.916911, -0.806626, 0.793669>,
      < -0.471280, -0.807448, 0.793668>,
      < -0.446751, -0.804739, 0.790973>
    }
    triangle {
      < 0.916911, -0.806626, 0.793669>,
      < -0.446751, -0.804739, 0.790973>,
      < -0.254659, -0.804626, 0.790973>
    }
    triangle {
      < -0.254672, -0.782694, 0.769034>,
      < -0.446764, -0.782807, 0.769034>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < -0.446764, -0.782807, 0.769034>,
      < -0.446751, -0.804739, 0.790973>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < -0.446751, -0.804739, 0.790973>,
      < -0.471280, -0.807448, 0.793668>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < -0.254659, -0.804371, 0.897339>,
      < -0.446751, -0.804484, 0.897339>,
      < -0.471273, -0.819273, 0.868336>
    }
    triangle {
      < -0.446751, -0.804484, 0.897339>,
      < -0.446753, -0.801717, 0.902770>,
      < -0.471283, -0.801732, 0.902770>
    }
    triangle {
      < -0.446751, -0.804484, 0.897339>,
      < -0.471283, -0.801732, 0.902770>,
      < -0.471273, -0.819273, 0.868336>
    }
    triangle {
      < -0.254659, -0.804371, 0.897339>,
      < -0.471273, -0.819273, 0.868336>,
      < -0.163685, -0.804317, 0.897339>
    }
    triangle {
      < -0.254659, -0.804371, 0.897339>,
      < -0.163685, -0.804317, 0.897339>,
      < -0.254660, -0.801604, 0.902770>
    }
    triangle {
      < -0.471273, -0.819273, 0.868336>,
      < 0.916918, -0.818451, 0.868336>,
      < 0.520632, -0.803911, 0.897339>
    }
    triangle {
      < -0.471273, -0.819273, 0.868336>,
      < 0.520632, -0.803911, 0.897339>,
      < -0.163685, -0.804317, 0.897339>
    }
    triangle {
      < 0.916918, -0.818451, 0.868336>,
      < 0.916907, -0.800909, 0.902770>,
      < 0.519332, -0.801145, 0.902770>
    }
    triangle {
      < 0.916918, -0.818451, 0.868336>,
      < 0.519332, -0.801145, 0.902770>,
      < 0.520632, -0.803911, 0.897339>
    }
    triangle {
      < -0.163685, -0.804317, 0.897339>,
      < -0.163686, -0.801550, 0.902770>,
      < -0.254660, -0.801604, 0.902770>
    }
    triangle {
      < -0.163697, -0.781842, 0.918735>,
      < 0.521150, -0.781436, 0.918735>,
      < 0.916890, -0.770881, 0.927094>
    }
    triangle {
      < 0.521150, -0.781436, 0.918735>,
      < 0.519332, -0.801145, 0.902770>,
      < 0.916907, -0.800909, 0.902770>
    }
    triangle {
      < 0.521150, -0.781436, 0.918735>,
      < 0.916907, -0.800909, 0.902770>,
      < 0.916890, -0.770881, 0.927094>
    }
    triangle {
      < -0.163697, -0.781842, 0.918735>,
      < 0.916890, -0.770881, 0.927094>,
      < -0.254672, -0.781896, 0.918735>
    }
    triangle {
      < -0.163697, -0.781842, 0.918735>,
      < -0.254672, -0.781896, 0.918735>,
      < -0.163686, -0.801550, 0.902770>
    }
    triangle {
      < 0.916890, -0.770881, 0.927094>,
      < -0.471301, -0.771704, 0.927094>,
      < -0.446764, -0.782009, 0.918735>
    }
    triangle {
      < 0.916890, -0.770881, 0.927094>,
      < -0.446764, -0.782009, 0.918735>,
      < -0.254672, -0.781896, 0.918735>
    }
    triangle {
      < -0.471301, -0.771704, 0.927094>,
      < -0.471283, -0.801732, 0.902770>,
      < -0.446753, -0.801717, 0.902770>
    }
    triangle {
      < -0.471301, -0.771704, 0.927094>,
      < -0.446753, -0.801717, 0.902770>,
      < -0.446764, -0.782009, 0.918735>
    }
    triangle {
      < -0.254672, -0.781896, 0.918735>,
      < -0.254660, -0.801604, 0.902770>,
      < -0.163686, -0.801550, 0.902770>
    }
    triangle {
      < -0.254734, -0.676876, 0.918610>,
      < -0.446827, -0.676989, 0.918610>,
      < -0.471346, -0.696210, 0.931072>
    }
    triangle {
      < -0.446827, -0.676989, 0.918610>,
      < -0.446835, -0.663778, 0.910039>,
      < -0.471365, -0.663792, 0.910039>
    }
    triangle {
      < -0.446827, -0.676989, 0.918610>,
      < -0.471365, -0.663792, 0.910039>,
      < -0.471346, -0.696210, 0.931072>
    }
    triangle {
      < -0.254734, -0.676876, 0.918610>,
      < -0.471346, -0.696210, 0.931072>,
      < -0.163759, -0.676822, 0.918610>
    }
    triangle {
      < -0.254734, -0.676876, 0.918610>,
      < -0.163759, -0.676822, 0.918610>,
      < -0.254742, -0.663665, 0.910039>
    }
    triangle {
      < -0.471346, -0.696210, 0.931072>,
      < 0.916845, -0.695388, 0.931072>,
      < 0.521178, -0.676416, 0.918610>
    }
    triangle {
      < -0.471346, -0.696210, 0.931072>,
      < 0.521178, -0.676416, 0.918610>,
      < -0.163759, -0.676822, 0.918610>
    }
    triangle {
      < 0.916845, -0.695388, 0.931072>,
      < 0.916825, -0.662970, 0.910039>,
      < 0.518899, -0.663206, 0.910039>
    }
    triangle {
      < 0.916845, -0.695388, 0.931072>,
      < 0.518899, -0.663206, 0.910039>,
      < 0.521178, -0.676416, 0.918610>
    }
    triangle {
      < -0.163759, -0.676822, 0.918610>,
      < -0.163768, -0.663611, 0.910039>,
      < -0.254742, -0.663665, 0.910039>
    }
    triangle {
      < 0.916825, -0.662970, 0.910039>,
      < 0.916845, -0.695388, 0.931072>,
      < 1.139539, -0.701912, 0.913714>
    }
    triangle {
      < 0.916825, -0.662970, 0.910039>,
      < 1.139539, -0.701912, 0.913714>,
      < 1.139523, -0.675978, 0.896888>
    }
    triangle {
      < 0.916814, -0.641868, 0.877537>,
      < 0.916825, -0.662970, 0.910039>,
      < 1.139523, -0.675978, 0.896888>
    }
    triangle {
      < 0.916814, -0.641868, 0.877537>,
      < 1.139523, -0.675978, 0.896888>,
      < 1.139513, -0.659097, 0.870886>
    }
    triangle {
      < -0.482936, -0.660058, 0.870886>,
      < -0.482926, -0.676939, 0.896887>,
      < -0.471365, -0.663792, 0.910039>
    }
    triangle {
      < -0.482936, -0.660058, 0.870886>,
      < -0.471365, -0.663792, 0.910039>,
      < -0.471378, -0.642690, 0.877537>
    }
    triangle {
      < -0.482926, -0.676939, 0.896887>,
      < -0.482910, -0.702873, 0.913714>,
      < -0.471346, -0.696210, 0.931072>
    }
    triangle {
      < -0.482926, -0.676939, 0.896887>,
      < -0.471346, -0.696210, 0.931072>,
      < -0.471365, -0.663792, 0.910039>
    }
    triangle {
      < -0.471346, -0.696210, 0.931072>,
      < -0.471324, -0.734380, 0.937105>,
      < 0.916868, -0.733558, 0.937105>
    }
    triangle {
      < -0.471346, -0.696210, 0.931072>,
      < 0.916868, -0.733558, 0.937105>,
      < 0.916845, -0.695388, 0.931072>
    }
    triangle {
      < -0.482910, -0.702873, 0.913714>,
      < -0.482892, -0.733409, 0.918540>,
      < -0.471324, -0.734380, 0.937105>
    }
    triangle {
      < -0.482910, -0.702873, 0.913714>,
      < -0.471324, -0.734380, 0.937105>,
      < -0.471346, -0.696210, 0.931072>
    }
    triangle {
      < 0.916845, -0.695388, 0.931072>,
      < 0.916868, -0.733558, 0.937105>,
      < 1.139557, -0.732448, 0.918540>
    }
    triangle {
      < 0.916845, -0.695388, 0.931072>,
      < 1.139557, -0.732448, 0.918540>,
      < 1.139539, -0.701912, 0.913714>
    }
    triangle {
      < -0.471381, -0.636670, 0.839365>,
      < -0.471378, -0.642690, 0.877537>,
      < 0.916814, -0.641868, 0.877537>
    }
    triangle {
      < -0.471381, -0.636670, 0.839365>,
      < 0.916814, -0.641868, 0.877537>,
      < 0.916810, -0.635847, 0.839365>
    }
    triangle {
      < 0.916810, -0.635847, 0.839365>,
      < 0.916814, -0.641868, 0.877537>,
      < 1.139513, -0.659097, 0.870886>
    }
    triangle {
      < 0.916810, -0.635847, 0.839365>,
      < 1.139513, -0.659097, 0.870886>,
      < 1.139511, -0.654279, 0.840349>
    }
    triangle {
      < -0.482939, -0.655240, 0.840349>,
      < -0.482936, -0.660058, 0.870886>,
      < -0.471378, -0.642690, 0.877537>
    }
    triangle {
      < -0.482939, -0.655240, 0.840349>,
      < -0.471378, -0.642690, 0.877537>,
      < -0.471381, -0.636670, 0.839365>
    }
    triangle {
      < 1.139513, -0.659097, 0.870886>,
      < 1.139523, -0.675978, 0.896888>,
      < 1.237862, -0.689058, 0.883737>
    }
    triangle {
      < 1.139513, -0.659097, 0.870886>,
      < 1.237862, -0.689058, 0.883737>,
      < 1.237855, -0.676398, 0.864236>
    }
    triangle {
      < -0.399051, -0.684807, 0.861386>,
      < -0.399045, -0.695660, 0.878101>,
      < -0.482926, -0.676939, 0.896887>
    }
    triangle {
      < -0.399051, -0.684807, 0.861386>,
      < -0.482926, -0.676939, 0.896887>,
      < -0.482936, -0.660058, 0.870886>
    }
    triangle {
      < 1.139523, -0.675978, 0.896888>,
      < 1.139539, -0.701912, 0.913714>,
      < 1.237873, -0.708509, 0.896357>
    }
    triangle {
      < 1.139523, -0.675978, 0.896888>,
      < 1.237873, -0.708509, 0.896357>,
      < 1.237862, -0.689058, 0.883737>
    }
    triangle {
      < -0.399045, -0.695660, 0.878101>,
      < -0.399035, -0.712332, 0.888917>,
      < -0.482910, -0.702873, 0.913714>
    }
    triangle {
      < -0.399045, -0.695660, 0.878101>,
      < -0.482910, -0.702873, 0.913714>,
      < -0.482926, -0.676939, 0.896887>
    }
    triangle {
      < 1.139539, -0.701912, 0.913714>,
      < 1.139557, -0.732448, 0.918540>,
      < 1.237887, -0.731411, 0.899977>
    }
    triangle {
      < 1.139539, -0.701912, 0.913714>,
      < 1.237887, -0.731411, 0.899977>,
      < 1.237873, -0.708509, 0.896357>
    }
    triangle {
      < -0.399035, -0.712332, 0.888917>,
      < -0.399023, -0.731962, 0.892020>,
      < -0.482892, -0.733409, 0.918540>
    }
    triangle {
      < -0.399035, -0.712332, 0.888917>,
      < -0.482892, -0.733409, 0.918540>,
      < -0.482910, -0.702873, 0.913714>
    }
    triangle {
      < -0.399053, -0.681711, 0.841754>,
      < -0.399051, -0.684807, 0.861386>,
      < -0.482936, -0.660058, 0.870886>
    }
    triangle {
      < -0.399053, -0.681711, 0.841754>,
      < -0.482936, -0.660058, 0.870886>,
      < -0.482939, -0.655240, 0.840349>
    }
    triangle {
      < 1.139511, -0.654279, 0.840349>,
      < 1.139513, -0.659097, 0.870886>,
      < 1.237855, -0.676398, 0.864236>
    }
    triangle {
      < 1.139511, -0.654279, 0.840349>,
      < 1.237855, -0.676398, 0.864236>,
      < 1.237852, -0.672785, 0.841333>
    }
    triangle {
      < 0.916868, -0.733558, 0.937105>,
      < 0.916890, -0.770881, 0.927094>,
      < 1.139575, -0.762308, 0.910532>
    }
    triangle {
      < 0.916868, -0.733558, 0.937105>,
      < 1.139575, -0.762308, 0.910532>,
      < 1.139557, -0.732448, 0.918540>
    }
    triangle {
      < -0.482892, -0.733409, 0.918540>,
      < -0.482875, -0.763269, 0.910532>,
      < -0.471301, -0.771704, 0.927094>
    }
    triangle {
      < -0.482892, -0.733409, 0.918540>,
      < -0.471301, -0.771704, 0.927094>,
      < -0.471324, -0.734380, 0.937105>
    }
    triangle {
      < -0.471324, -0.734380, 0.937105>,
      < -0.471301, -0.771704, 0.927094>,
      < 0.916890, -0.770881, 0.927094>
    }
    triangle {
      < -0.471324, -0.734380, 0.937105>,
      < 0.916890, -0.770881, 0.927094>,
      < 0.916868, -0.733558, 0.937105>
    }
    triangle {
      < 0.916816, -0.645869, 0.802044>,
      < 0.916810, -0.635847, 0.839365>,
      < 1.139511, -0.654279, 0.840349>
    }
    triangle {
      < 0.916816, -0.645869, 0.802044>,
      < 1.139511, -0.654279, 0.840349>,
      < 1.139515, -0.662297, 0.810492>
    }
    triangle {
      < -0.471375, -0.646692, 0.802044>,
      < -0.471381, -0.636670, 0.839365>,
      < 0.916810, -0.635847, 0.839365>
    }
    triangle {
      < -0.471375, -0.646692, 0.802044>,
      < 0.916810, -0.635847, 0.839365>,
      < 0.916816, -0.645869, 0.802044>
    }
    triangle {
      < -0.482934, -0.663258, 0.810492>,
      < -0.482939, -0.655240, 0.840349>,
      < -0.471381, -0.636670, 0.839365>
    }
    triangle {
      < -0.482934, -0.663258, 0.810492>,
      < -0.471381, -0.636670, 0.839365>,
      < -0.471375, -0.646692, 0.802044>
    }
    triangle {
      < 1.237855, -0.676398, 0.864236>,
      < 1.237862, -0.689058, 0.883737>,
      < 1.292819, -0.704043, 0.868707>
    }
    triangle {
      < 1.237855, -0.676398, 0.864236>,
      < 1.292819, -0.704043, 0.868707>,
      < 1.292815, -0.696205, 0.856635>
    }
    triangle {
      < 1.237862, -0.689058, 0.883737>,
      < 1.237873, -0.708509, 0.896357>,
      < 1.292827, -0.716083, 0.876520>
    }
    triangle {
      < 1.237862, -0.689058, 0.883737>,
      < 1.292827, -0.716083, 0.876520>,
      < 1.292819, -0.704043, 0.868707>
    }
    triangle {
      < 1.237873, -0.708509, 0.896357>,
      < 1.237887, -0.731411, 0.899977>,
      < 1.292835, -0.730261, 0.878760>
    }
    triangle {
      < 1.237873, -0.708509, 0.896357>,
      < 1.292835, -0.730261, 0.878760>,
      < 1.292827, -0.716083, 0.876520>
    }
    triangle {
      < 1.237852, -0.672785, 0.841333>,
      < 1.237855, -0.676398, 0.864236>,
      < 1.292815, -0.696205, 0.856635>
    }
    triangle {
      < 1.237852, -0.672785, 0.841333>,
      < 1.292815, -0.696205, 0.856635>,
      < 1.292813, -0.693968, 0.842457>
    }
    triangle {
      < 1.139557, -0.732448, 0.918540>,
      < 1.139575, -0.762308, 0.910532>,
      < 1.237900, -0.753806, 0.893970>
    }
    triangle {
      < 1.139557, -0.732448, 0.918540>,
      < 1.237900, -0.753806, 0.893970>,
      < 1.237887, -0.731411, 0.899977>
    }
    triangle {
      < -0.399023, -0.731962, 0.892020>,
      < -0.399012, -0.751158, 0.886872>,
      < -0.482875, -0.763269, 0.910532>
    }
    triangle {
      < -0.399023, -0.731962, 0.892020>,
      < -0.482875, -0.763269, 0.910532>,
      < -0.482892, -0.733409, 0.918540>
    }
    triangle {
      < 1.139515, -0.662297, 0.810492>,
      < 1.139511, -0.654279, 0.840349>,
      < 1.237852, -0.672785, 0.841333>
    }
    triangle {
      < 1.139515, -0.662297, 0.810492>,
      < 1.237852, -0.672785, 0.841333>,
      < 1.237856, -0.678798, 0.818941>
    }
    triangle {
      < -0.399050, -0.686865, 0.822560>,
      < -0.399053, -0.681711, 0.841754>,
      < -0.482939, -0.655240, 0.840349>
    }
    triangle {
      < -0.399050, -0.686865, 0.822560>,
      < -0.482939, -0.655240, 0.840349>,
      < -0.482934, -0.663258, 0.810492>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399045, -0.695660, 0.878101>,
      < -0.399051, -0.684807, 0.861386>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399035, -0.712332, 0.888917>,
      < -0.399045, -0.695660, 0.878101>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399023, -0.731962, 0.892020>,
      < -0.399035, -0.712332, 0.888917>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399051, -0.684807, 0.861386>,
      < -0.399053, -0.681711, 0.841754>
    }
    triangle {
      < 1.237887, -0.731411, 0.899977>,
      < 1.237900, -0.753806, 0.893970>,
      < 1.292843, -0.744124, 0.875042>
    }
    triangle {
      < 1.237887, -0.731411, 0.899977>,
      < 1.292843, -0.744124, 0.875042>,
      < 1.292835, -0.730261, 0.878760>
    }
    triangle {
      < 1.237856, -0.678798, 0.818941>,
      < 1.237852, -0.672785, 0.841333>,
      < 1.292813, -0.693968, 0.842457>
    }
    triangle {
      < 1.237856, -0.678798, 0.818941>,
      < 1.292813, -0.693968, 0.842457>,
      < 1.292816, -0.697690, 0.828595>
    }
    triangle {
      < 1.292819, -0.704043, 0.868707>,
      < 1.292827, -0.716083, 0.876520>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.292815, -0.696205, 0.856635>,
      < 1.292819, -0.704043, 0.868707>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399012, -0.751158, 0.886872>,
      < -0.399023, -0.731962, 0.892020>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399053, -0.681711, 0.841754>,
      < -0.399050, -0.686865, 0.822560>
    }
    triangle {
      < 1.292827, -0.716083, 0.876520>,
      < 1.292835, -0.730261, 0.878760>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.292813, -0.693968, 0.842457>,
      < 1.292815, -0.696205, 0.856635>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < -0.482875, -0.763269, 0.910532>,
      < -0.482861, -0.787290, 0.891073>,
      < -0.471283, -0.801732, 0.902770>
    }
    triangle {
      < -0.482875, -0.763269, 0.910532>,
      < -0.471283, -0.801732, 0.902770>,
      < -0.471301, -0.771704, 0.927094>
    }
    triangle {
      < 0.916890, -0.770881, 0.927094>,
      < 0.916907, -0.800909, 0.902770>,
      < 1.139589, -0.786329, 0.891073>
    }
    triangle {
      < 0.916890, -0.770881, 0.927094>,
      < 1.139589, -0.786329, 0.891073>,
      < 1.139575, -0.762308, 0.910532>
    }
    triangle {
      < -0.482923, -0.682724, 0.786475>,
      < -0.482934, -0.663258, 0.810492>,
      < -0.471375, -0.646692, 0.802044>
    }
    triangle {
      < -0.482923, -0.682724, 0.786475>,
      < -0.471375, -0.646692, 0.802044>,
      < -0.471361, -0.671024, 0.772023>
    }
    triangle {
      < 0.916830, -0.670202, 0.772023>,
      < 0.916816, -0.645869, 0.802044>,
      < 1.139515, -0.662297, 0.810492>
    }
    triangle {
      < 0.916830, -0.670202, 0.772023>,
      < 1.139515, -0.662297, 0.810492>,
      < 1.139527, -0.681763, 0.786476>
    }
    triangle {
      < 1.292835, -0.730261, 0.878760>,
      < 1.292843, -0.744124, 0.875042>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.292816, -0.697690, 0.828595>,
      < 1.292813, -0.693968, 0.842457>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.139575, -0.762308, 0.910532>,
      < 1.139589, -0.786329, 0.891073>,
      < 1.237910, -0.771822, 0.879375>
    }
    triangle {
      < 1.139575, -0.762308, 0.910532>,
      < 1.237910, -0.771822, 0.879375>,
      < 1.237900, -0.753806, 0.893970>
    }
    triangle {
      < -0.399012, -0.751158, 0.886872>,
      < -0.399002, -0.766601, 0.874363>,
      < -0.482861, -0.787290, 0.891073>
    }
    triangle {
      < -0.399012, -0.751158, 0.886872>,
      < -0.482861, -0.787290, 0.891073>,
      < -0.482875, -0.763269, 0.910532>
    }
    triangle {
      < 1.139527, -0.681763, 0.786476>,
      < 1.139515, -0.662297, 0.810492>,
      < 1.237856, -0.678798, 0.818941>
    }
    triangle {
      < 1.139527, -0.681763, 0.786476>,
      < 1.237856, -0.678798, 0.818941>,
      < 1.237864, -0.693397, 0.800928>
    }
    triangle {
      < -0.399043, -0.699379, 0.807122>,
      < -0.399050, -0.686865, 0.822560>,
      < -0.482934, -0.663258, 0.810492>
    }
    triangle {
      < -0.399043, -0.699379, 0.807122>,
      < -0.482934, -0.663258, 0.810492>,
      < -0.482923, -0.682724, 0.786475>
    }
    triangle {
      < 1.237900, -0.753806, 0.893970>,
      < 1.237910, -0.771822, 0.879375>,
      < 1.292850, -0.755277, 0.866007>
    }
    triangle {
      < 1.237900, -0.753806, 0.893970>,
      < 1.292850, -0.755277, 0.866007>,
      < 1.292843, -0.744124, 0.875042>
    }
    triangle {
      < 1.237864, -0.693397, 0.800928>,
      < 1.237856, -0.678798, 0.818941>,
      < 1.292816, -0.697690, 0.828595>
    }
    triangle {
      < 1.237864, -0.693397, 0.800928>,
      < 1.292816, -0.697690, 0.828595>,
      < 1.292821, -0.706729, 0.817445>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399002, -0.766601, 0.874363>,
      < -0.399012, -0.751158, 0.886872>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399050, -0.686865, 0.822560>,
      < -0.399043, -0.699379, 0.807122>
    }
    triangle {
      < 1.292843, -0.744124, 0.875042>,
      < 1.292850, -0.755277, 0.866007>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.292821, -0.706729, 0.817445>,
      < 1.292816, -0.697690, 0.828595>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399043, -0.699379, 0.807122>,
      < -0.399032, -0.717091, 0.798106>
    }
    triangle {
      < 1.292850, -0.755277, 0.866007>,
      < 1.292854, -0.761793, 0.853218>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399032, -0.717091, 0.798106>,
      < -0.399020, -0.736937, 0.797071>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399010, -0.755489, 0.804198>,
      < -0.399001, -0.769540, 0.818253>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399020, -0.736937, 0.797071>,
      < -0.399010, -0.755489, 0.804198>
    }
    triangle {
      < 1.292851, -0.757401, 0.825484>,
      < 1.292845, -0.747253, 0.815334>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.292828, -0.719520, 0.810933>,
      < 1.292821, -0.706729, 0.817445>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.292837, -0.733854, 0.810186>,
      < 1.292828, -0.719520, 0.810933>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.398997, -0.775621, 0.856653>,
      < -0.399002, -0.766601, 0.874363>
    }
    triangle {
      < 1.292854, -0.761793, 0.853218>,
      < 1.292854, -0.762544, 0.838884>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < 1.292845, -0.747253, 0.815334>,
      < 1.292837, -0.733854, 0.810186>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.398997, -0.776661, 0.836807>,
      < -0.398997, -0.775621, 0.856653>
    }
    triangle {
      < 1.292854, -0.762544, 0.838884>,
      < 1.292851, -0.757401, 0.825484>,
      < 1.339107, -0.728416, 0.844284>
    }
    triangle {
      < -0.381673, -0.729436, 0.844284>,
      < -0.399001, -0.769540, 0.818253>,
      < -0.398997, -0.776661, 0.836807>
    }
    triangle {
      < 1.237910, -0.771822, 0.879375>,
      < 1.237917, -0.782347, 0.858716>,
      < 1.292854, -0.761793, 0.853218>
    }
    triangle {
      < 1.237910, -0.771822, 0.879375>,
      < 1.292854, -0.761793, 0.853218>,
      < 1.292850, -0.755277, 0.866007>
    }
    triangle {
      < 1.237876, -0.714061, 0.790409>,
      < 1.237864, -0.693397, 0.800928>,
      < 1.292821, -0.706729, 0.817445>
    }
    triangle {
      < 1.237876, -0.714061, 0.790409>,
      < 1.292821, -0.706729, 0.817445>,
      < 1.292828, -0.719520, 0.810933>
    }
    triangle {
      < -0.399002, -0.766601, 0.874363>,
      < -0.398997, -0.775621, 0.856653>,
      < -0.482853, -0.801323, 0.863526>
    }
    triangle {
      < -0.399002, -0.766601, 0.874363>,
      < -0.482853, -0.801323, 0.863526>,
      < -0.482861, -0.787290, 0.891073>
    }
    triangle {
      < -0.399032, -0.717091, 0.798106>,
      < -0.399043, -0.699379, 0.807122>,
      < -0.482923, -0.682724, 0.786475>
    }
    triangle {
      < -0.399032, -0.717091, 0.798106>,
      < -0.482923, -0.682724, 0.786475>,
      < -0.482906, -0.710275, 0.772451>
    }
    triangle {
      < 1.139589, -0.786329, 0.891073>,
      < 1.139597, -0.800362, 0.863527>,
      < 1.237917, -0.782347, 0.858716>
    }
    triangle {
      < 1.139589, -0.786329, 0.891073>,
      < 1.237917, -0.782347, 0.858716>,
      < 1.237910, -0.771822, 0.879375>
    }
    triangle {
      < 1.139543, -0.709314, 0.772451>,
      < 1.139527, -0.681763, 0.786476>,
      < 1.237864, -0.693397, 0.800928>
    }
    triangle {
      < 1.139543, -0.709314, 0.772451>,
      < 1.237864, -0.693397, 0.800928>,
      < 1.237876, -0.714061, 0.790409>
    }
    triangle {
      < -0.482861, -0.787290, 0.891073>,
      < -0.482853, -0.801323, 0.863526>,
      < -0.471273, -0.819273, 0.868336>
    }
    triangle {
      < -0.482861, -0.787290, 0.891073>,
      < -0.471273, -0.819273, 0.868336>,
      < -0.471283, -0.801732, 0.902770>
    }
    triangle {
      < 0.916907, -0.800909, 0.902770>,
      < 0.916918, -0.818451, 0.868336>,
      < 1.139597, -0.800362, 0.863527>
    }
    triangle {
      < 0.916907, -0.800909, 0.902770>,
      < 1.139597, -0.800362, 0.863527>,
      < 1.139589, -0.786329, 0.891073>
    }
    triangle {
      < 0.916851, -0.704640, 0.754493>,
      < 0.916830, -0.670202, 0.772023>,
      < 1.139527, -0.681763, 0.786476>
    }
    triangle {
      < 0.916851, -0.704640, 0.754493>,
      < 1.139527, -0.681763, 0.786476>,
      < 1.139543, -0.709314, 0.772451>
    }
    triangle {
      < -0.482906, -0.710275, 0.772451>,
      < -0.482923, -0.682724, 0.786475>,
      < -0.471361, -0.671024, 0.772023>
    }
    triangle {
      < -0.482906, -0.710275, 0.772451>,
      < -0.471361, -0.671024, 0.772023>,
      < -0.471341, -0.705462, 0.754493>
    }
    triangle {
      < 1.237917, -0.782347, 0.858716>,
      < 1.237918, -0.783560, 0.835561>,
      < 1.292854, -0.762544, 0.838884>
    }
    triangle {
      < 1.237917, -0.782347, 0.858716>,
      < 1.292854, -0.762544, 0.838884>,
      < 1.292854, -0.761793, 0.853218>
    }
    triangle {
      < 1.237891, -0.737216, 0.789203>,
      < 1.237876, -0.714061, 0.790409>,
      < 1.292828, -0.719520, 0.810933>
    }
    triangle {
      < 1.237891, -0.737216, 0.789203>,
      < 1.292828, -0.719520, 0.810933>,
      < 1.292837, -0.733854, 0.810186>
    }
    triangle {
      < -0.398997, -0.775621, 0.856653>,
      < -0.398997, -0.776661, 0.836807>,
      < -0.482851, -0.802940, 0.832654>
    }
    triangle {
      < -0.398997, -0.775621, 0.856653>,
      < -0.482851, -0.802940, 0.832654>,
      < -0.482853, -0.801323, 0.863526>
    }
    triangle {
      < -0.399020, -0.736937, 0.797071>,
      < -0.399032, -0.717091, 0.798106>,
      < -0.482906, -0.710275, 0.772451>
    }
    triangle {
      < -0.399020, -0.736937, 0.797071>,
      < -0.482906, -0.710275, 0.772451>,
      < -0.482888, -0.741148, 0.770843>
    }
    triangle {
      < 1.139597, -0.800362, 0.863527>,
      < 1.139598, -0.801979, 0.832654>,
      < 1.237918, -0.783560, 0.835561>
    }
    triangle {
      < 1.139597, -0.800362, 0.863527>,
      < 1.237918, -0.783560, 0.835561>,
      < 1.237917, -0.782347, 0.858716>
    }
    triangle {
      < 1.237918, -0.783560, 0.835561>,
      < 1.237913, -0.775252, 0.813915>,
      < 1.292851, -0.757401, 0.825484>
    }
    triangle {
      < 1.237918, -0.783560, 0.835561>,
      < 1.292851, -0.757401, 0.825484>,
      < 1.292854, -0.762544, 0.838884>
    }
    triangle {
      < 1.139562, -0.740186, 0.770843>,
      < 1.139543, -0.709314, 0.772451>,
      < 1.237876, -0.714061, 0.790409>
    }
    triangle {
      < 1.139562, -0.740186, 0.770843>,
      < 1.237876, -0.714061, 0.790409>,
      < 1.237891, -0.737216, 0.789203>
    }
    triangle {
      < 1.237903, -0.758859, 0.797518>,
      < 1.237891, -0.737216, 0.789203>,
      < 1.292837, -0.733854, 0.810186>
    }
    triangle {
      < 1.237903, -0.758859, 0.797518>,
      < 1.292837, -0.733854, 0.810186>,
      < 1.292845, -0.747253, 0.815334>
    }
    triangle {
      < 1.237913, -0.775252, 0.813915>,
      < 1.237903, -0.758859, 0.797518>,
      < 1.292845, -0.747253, 0.815334>
    }
    triangle {
      < 1.237913, -0.775252, 0.813915>,
      < 1.292845, -0.747253, 0.815334>,
      < 1.292851, -0.757401, 0.825484>
    }
    triangle {
      < -0.482853, -0.801323, 0.863526>,
      < -0.482851, -0.802940, 0.832654>,
      < -0.471272, -0.821294, 0.829746>
    }
    triangle {
      < -0.482853, -0.801323, 0.863526>,
      < -0.471272, -0.821294, 0.829746>,
      < -0.471273, -0.819273, 0.868336>
    }
    triangle {
      < 0.916918, -0.818451, 0.868336>,
      < 0.916919, -0.820471, 0.829746>,
      < 1.139598, -0.801979, 0.832654>
    }
    triangle {
      < 0.916918, -0.818451, 0.868336>,
      < 1.139598, -0.801979, 0.832654>,
      < 1.139597, -0.800362, 0.863527>
    }
    triangle {
      < 0.916873, -0.743231, 0.752483>,
      < 0.916851, -0.704640, 0.754493>,
      < 1.139543, -0.709314, 0.772451>
    }
    triangle {
      < 0.916873, -0.743231, 0.752483>,
      < 1.139543, -0.709314, 0.772451>,
      < 1.139562, -0.740186, 0.770843>
    }
    triangle {
      < -0.482888, -0.741148, 0.770843>,
      < -0.482906, -0.710275, 0.772451>,
      < -0.471341, -0.705462, 0.754493>
    }
    triangle {
      < -0.482888, -0.741148, 0.770843>,
      < -0.471341, -0.705462, 0.754493>,
      < -0.471317, -0.744054, 0.752482>
    }
    triangle {
      < -0.398997, -0.776661, 0.836807>,
      < -0.399001, -0.769540, 0.818253>,
      < -0.482858, -0.791864, 0.803792>
    }
    triangle {
      < -0.398997, -0.776661, 0.836807>,
      < -0.482858, -0.791864, 0.803792>,
      < -0.482851, -0.802940, 0.832654>
    }
    triangle {
      < -0.399010, -0.755489, 0.804198>,
      < -0.399020, -0.736937, 0.797071>,
      < -0.482888, -0.741148, 0.770843>
    }
    triangle {
      < -0.399010, -0.755489, 0.804198>,
      < -0.482888, -0.741148, 0.770843>,
      < -0.482871, -0.770008, 0.781928>
    }
    triangle {
      < 1.139598, -0.801979, 0.832654>,
      < 1.139592, -0.790903, 0.803792>,
      < 1.237913, -0.775252, 0.813915>
    }
    triangle {
      < 1.139598, -0.801979, 0.832654>,
      < 1.237913, -0.775252, 0.813915>,
      < 1.237918, -0.783560, 0.835561>
    }
    triangle {
      < 1.139579, -0.769046, 0.781928>,
      < 1.139562, -0.740186, 0.770843>,
      < 1.237891, -0.737216, 0.789203>
    }
    triangle {
      < 1.139579, -0.769046, 0.781928>,
      < 1.237891, -0.737216, 0.789203>,
      < 1.237903, -0.758859, 0.797518>
    }
    triangle {
      < -0.471273, -0.819273, 0.868336>,
      < -0.471272, -0.821294, 0.829746>,
      < 0.916919, -0.820471, 0.829746>
    }
    triangle {
      < -0.471273, -0.819273, 0.868336>,
      < 0.916919, -0.820471, 0.829746>,
      < 0.916918, -0.818451, 0.868336>
    }
    triangle {
      < -0.471317, -0.744054, 0.752482>,
      < -0.471341, -0.705462, 0.754493>,
      < 0.916851, -0.704640, 0.754493>
    }
    triangle {
      < -0.471317, -0.744054, 0.752482>,
      < 0.916851, -0.704640, 0.754493>,
      < 0.916873, -0.743231, 0.752483>
    }
    triangle {
      < -0.399001, -0.769540, 0.818253>,
      < -0.399010, -0.755489, 0.804198>,
      < -0.482871, -0.770008, 0.781928>
    }
    triangle {
      < -0.399001, -0.769540, 0.818253>,
      < -0.482871, -0.770008, 0.781928>,
      < -0.482858, -0.791864, 0.803792>
    }
    triangle {
      < 1.139592, -0.790903, 0.803792>,
      < 1.139579, -0.769046, 0.781928>,
      < 1.237903, -0.758859, 0.797518>
    }
    triangle {
      < 1.139592, -0.790903, 0.803792>,
      < 1.237903, -0.758859, 0.797518>,
      < 1.237913, -0.775252, 0.813915>
    }
    triangle {
      < -0.482851, -0.802940, 0.832654>,
      < -0.482858, -0.791864, 0.803792>,
      < -0.471280, -0.807448, 0.793668>
    }
    triangle {
      < -0.482851, -0.802940, 0.832654>,
      < -0.471280, -0.807448, 0.793668>,
      < -0.471272, -0.821294, 0.829746>
    }
    triangle {
      < 0.916919, -0.820471, 0.829746>,
      < 0.916911, -0.806626, 0.793669>,
      < 1.139592, -0.790903, 0.803792>
    }
    triangle {
      < 0.916919, -0.820471, 0.829746>,
      < 1.139592, -0.790903, 0.803792>,
      < 1.139598, -0.801979, 0.832654>
    }
    triangle {
      < 0.916895, -0.779305, 0.766339>,
      < 0.916873, -0.743231, 0.752483>,
      < 1.139562, -0.740186, 0.770843>
    }
    triangle {
      < 0.916895, -0.779305, 0.766339>,
      < 1.139562, -0.740186, 0.770843>,
      < 1.139579, -0.769046, 0.781928>
    }
    triangle {
      < -0.482871, -0.770008, 0.781928>,
      < -0.482888, -0.741148, 0.770843>,
      < -0.471317, -0.744054, 0.752482>
    }
    triangle {
      < -0.482871, -0.770008, 0.781928>,
      < -0.471317, -0.744054, 0.752482>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < -0.482858, -0.791864, 0.803792>,
      < -0.482871, -0.770008, 0.781928>,
      < -0.471296, -0.780127, 0.766339>
    }
    triangle {
      < -0.482858, -0.791864, 0.803792>,
      < -0.471296, -0.780127, 0.766339>,
      < -0.471280, -0.807448, 0.793668>
    }
    triangle {
      < 0.916911, -0.806626, 0.793669>,
      < 0.916895, -0.779305, 0.766339>,
      < 1.139579, -0.769046, 0.781928>
    }
    triangle {
      < 0.916911, -0.806626, 0.793669>,
      < 1.139579, -0.769046, 0.781928>,
      < 1.139592, -0.790903, 0.803792>
    }
    triangle {
      < -0.471272, -0.821294, 0.829746>,
      < -0.471280, -0.807448, 0.793668>,
      < 0.916911, -0.806626, 0.793669>
    }
    triangle {
      < -0.471272, -0.821294, 0.829746>,
      < 0.916911, -0.806626, 0.793669>,
      < 0.916919, -0.820471, 0.829746>
    }
    triangle {
      < -0.471296, -0.780127, 0.766339>,
      < -0.471317, -0.744054, 0.752482>,
      < 0.916873, -0.743231, 0.752483>
    }
    triangle {
      < -0.471296, -0.780127, 0.766339>,
      < 0.916873, -0.743231, 0.752483>,
      < 0.916895, -0.779305, 0.766339>
    }
    texture {ordinance1}
  }
  // ordinance2
  union {
    triangle {
      < 1.655419, -0.523261, 3.693422>,
      < 1.655422, -0.529938, 3.684230>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537420, -0.523332, 3.693422>,
      < 1.537423, -0.530008, 3.684230>,
      < 1.655422, -0.529938, 3.684230>
    }
    triangle {
      < 1.537420, -0.523332, 3.693422>,
      < 1.655422, -0.529938, 3.684230>,
      < 1.655419, -0.523261, 3.693422>
    }
    triangle {
      < 1.502035, -0.549038, 3.719101>,
      < 1.502043, -0.562392, 3.700716>,
      < 1.537423, -0.530008, 3.684230>
    }
    triangle {
      < 1.502035, -0.549038, 3.719101>,
      < 1.537423, -0.530008, 3.684230>,
      < 1.537420, -0.523332, 3.693422>
    }
    triangle {
      < 1.401755, -0.581205, 3.751199>,
      < 1.401769, -0.602905, 3.721324>,
      < 1.502043, -0.562392, 3.700716>
    }
    triangle {
      < 1.401755, -0.581205, 3.751199>,
      < 1.502043, -0.562392, 3.700716>,
      < 1.502035, -0.549038, 3.719101>
    }
    triangle {
      < 0.109669, -0.581971, 3.751198>,
      < 0.109683, -0.603671, 3.721323>,
      < 1.401769, -0.602905, 3.721324>
    }
    triangle {
      < 0.109669, -0.581971, 3.751198>,
      < 1.401769, -0.602905, 3.721324>,
      < 1.401755, -0.581205, 3.751199>
    }
    triangle {
      < 0.074266, -0.575570, 3.744779>,
      < 0.074278, -0.595600, 3.717201>,
      < 0.109683, -0.603671, 3.721323>
    }
    triangle {
      < 0.074266, -0.575570, 3.744779>,
      < 0.109683, -0.603671, 3.721323>,
      < 0.109669, -0.581971, 3.751198>
    }
    triangle {
      < -0.309232, -0.572587, 3.741569>,
      < -0.309220, -0.591783, 3.715141>,
      < 0.074278, -0.595600, 3.717201>
    }
    triangle {
      < -0.309232, -0.572587, 3.741569>,
      < 0.074278, -0.595600, 3.717201>,
      < 0.074266, -0.575570, 3.744779>
    }
    triangle {
      < -0.421344, -0.550178, 3.719100>,
      < -0.421336, -0.563532, 3.700715>,
      < -0.309220, -0.591783, 3.715141>
    }
    triangle {
      < -0.421344, -0.550178, 3.719100>,
      < -0.309220, -0.591783, 3.715141>,
      < -0.309232, -0.572587, 3.741569>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421336, -0.563532, 3.700715>,
      < -0.421344, -0.550178, 3.719100>
    }
    triangle {
      < 1.655422, -0.529938, 3.684230>,
      < 1.655425, -0.533448, 3.673425>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537423, -0.530008, 3.684230>,
      < 1.537426, -0.533518, 3.673425>,
      < 1.655425, -0.533448, 3.673425>
    }
    triangle {
      < 1.537423, -0.530008, 3.684230>,
      < 1.655425, -0.533448, 3.673425>,
      < 1.655422, -0.529938, 3.684230>
    }
    triangle {
      < 1.502043, -0.562392, 3.700716>,
      < 1.502047, -0.569412, 3.679105>,
      < 1.537426, -0.533518, 3.673425>
    }
    triangle {
      < 1.502043, -0.562392, 3.700716>,
      < 1.537426, -0.533518, 3.673425>,
      < 1.537423, -0.530008, 3.684230>
    }
    triangle {
      < 1.401769, -0.602905, 3.721324>,
      < 1.401775, -0.614313, 3.686206>,
      < 1.502047, -0.569412, 3.679105>
    }
    triangle {
      < 1.401769, -0.602905, 3.721324>,
      < 1.502047, -0.569412, 3.679105>,
      < 1.502043, -0.562392, 3.700716>
    }
    triangle {
      < 0.109683, -0.603671, 3.721323>,
      < 0.109689, -0.615079, 3.686206>,
      < 1.401775, -0.614313, 3.686206>
    }
    triangle {
      < 0.109683, -0.603671, 3.721323>,
      < 1.401775, -0.614313, 3.686206>,
      < 1.401769, -0.602905, 3.721324>
    }
    triangle {
      < 0.074278, -0.595600, 3.717201>,
      < 0.074284, -0.606132, 3.684786>,
      < 0.109689, -0.615079, 3.686206>
    }
    triangle {
      < 0.074278, -0.595600, 3.717201>,
      < 0.109689, -0.615079, 3.686206>,
      < 0.109683, -0.603671, 3.721323>
    }
    triangle {
      < -0.309220, -0.591783, 3.715141>,
      < -0.309215, -0.601874, 3.684075>,
      < 0.074284, -0.606132, 3.684786>
    }
    triangle {
      < -0.309220, -0.591783, 3.715141>,
      < 0.074284, -0.606132, 3.684786>,
      < 0.074278, -0.595600, 3.717201>
    }
    triangle {
      < -0.421336, -0.563532, 3.700715>,
      < -0.421331, -0.570552, 3.679105>,
      < -0.309215, -0.601874, 3.684075>
    }
    triangle {
      < -0.421336, -0.563532, 3.700715>,
      < -0.309215, -0.601874, 3.684075>,
      < -0.309220, -0.591783, 3.715141>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421331, -0.570552, 3.679105>,
      < -0.421336, -0.563532, 3.700715>
    }
    triangle {
      < 1.655425, -0.533448, 3.673425>,
      < 1.655425, -0.533448, 3.662063>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537426, -0.533518, 3.673425>,
      < 1.537426, -0.533518, 3.662063>,
      < 1.655425, -0.533448, 3.662063>
    }
    triangle {
      < 1.537426, -0.533518, 3.673425>,
      < 1.655425, -0.533448, 3.662063>,
      < 1.655425, -0.533448, 3.673425>
    }
    triangle {
      < 1.502047, -0.569412, 3.679105>,
      < 1.502047, -0.569412, 3.656382>,
      < 1.537426, -0.533518, 3.662063>
    }
    triangle {
      < 1.502047, -0.569412, 3.679105>,
      < 1.537426, -0.533518, 3.662063>,
      < 1.537426, -0.533518, 3.673425>
    }
    triangle {
      < 1.401775, -0.614313, 3.686206>,
      < 1.401775, -0.614313, 3.649282>,
      < 1.502047, -0.569412, 3.656382>
    }
    triangle {
      < 1.401775, -0.614313, 3.686206>,
      < 1.502047, -0.569412, 3.656382>,
      < 1.502047, -0.569412, 3.679105>
    }
    triangle {
      < 0.109689, -0.615079, 3.686206>,
      < 0.109689, -0.615079, 3.649282>,
      < 1.401775, -0.614313, 3.649282>
    }
    triangle {
      < 0.109689, -0.615079, 3.686206>,
      < 1.401775, -0.614313, 3.649282>,
      < 1.401775, -0.614313, 3.686206>
    }
    triangle {
      < 0.074284, -0.606132, 3.684786>,
      < 0.074284, -0.606131, 3.650702>,
      < 0.109689, -0.615079, 3.649282>
    }
    triangle {
      < 0.074284, -0.606132, 3.684786>,
      < 0.109689, -0.615079, 3.649282>,
      < 0.109689, -0.615079, 3.686206>
    }
    triangle {
      < -0.309215, -0.601874, 3.684075>,
      < -0.309214, -0.601875, 3.651411>,
      < 0.074284, -0.606131, 3.650702>
    }
    triangle {
      < -0.309215, -0.601874, 3.684075>,
      < 0.074284, -0.606131, 3.650702>,
      < 0.074284, -0.606132, 3.684786>
    }
    triangle {
      < -0.421331, -0.570552, 3.679105>,
      < -0.421331, -0.570553, 3.656381>,
      < -0.309214, -0.601875, 3.651411>
    }
    triangle {
      < -0.421331, -0.570552, 3.679105>,
      < -0.309214, -0.601875, 3.651411>,
      < -0.309215, -0.601874, 3.684075>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421331, -0.570553, 3.656381>,
      < -0.421331, -0.570552, 3.679105>
    }
    triangle {
      < 1.655425, -0.533448, 3.662063>,
      < 1.655422, -0.529939, 3.651258>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537426, -0.533518, 3.662063>,
      < 1.537423, -0.530009, 3.651258>,
      < 1.655422, -0.529939, 3.651258>
    }
    triangle {
      < 1.537426, -0.533518, 3.662063>,
      < 1.655422, -0.529939, 3.651258>,
      < 1.655425, -0.533448, 3.662063>
    }
    triangle {
      < 1.502047, -0.569412, 3.656382>,
      < 1.502043, -0.562392, 3.634771>,
      < 1.537423, -0.530009, 3.651258>
    }
    triangle {
      < 1.502047, -0.569412, 3.656382>,
      < 1.537423, -0.530009, 3.651258>,
      < 1.537426, -0.533518, 3.662063>
    }
    triangle {
      < 1.401775, -0.614313, 3.649282>,
      < 1.401769, -0.602905, 3.614164>,
      < 1.502043, -0.562392, 3.634771>
    }
    triangle {
      < 1.401775, -0.614313, 3.649282>,
      < 1.502043, -0.562392, 3.634771>,
      < 1.502047, -0.569412, 3.656382>
    }
    triangle {
      < 0.109689, -0.615079, 3.649282>,
      < 0.109683, -0.603671, 3.614163>,
      < 1.401769, -0.602905, 3.614164>
    }
    triangle {
      < 0.109689, -0.615079, 3.649282>,
      < 1.401769, -0.602905, 3.614164>,
      < 1.401775, -0.614313, 3.649282>
    }
    triangle {
      < 0.074284, -0.606131, 3.650702>,
      < 0.074278, -0.595601, 3.618285>,
      < 0.109683, -0.603671, 3.614163>
    }
    triangle {
      < 0.074284, -0.606131, 3.650702>,
      < 0.109683, -0.603671, 3.614163>,
      < 0.109689, -0.615079, 3.649282>
    }
    triangle {
      < -0.309214, -0.601875, 3.651411>,
      < -0.309220, -0.591784, 3.620347>,
      < 0.074278, -0.595601, 3.618285>
    }
    triangle {
      < -0.309214, -0.601875, 3.651411>,
      < 0.074278, -0.595601, 3.618285>,
      < 0.074284, -0.606131, 3.650702>
    }
    triangle {
      < -0.421331, -0.570553, 3.656381>,
      < -0.421336, -0.563532, 3.634771>,
      < -0.309220, -0.591784, 3.620347>
    }
    triangle {
      < -0.421331, -0.570553, 3.656381>,
      < -0.309220, -0.591784, 3.620347>,
      < -0.309214, -0.601875, 3.651411>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421336, -0.563532, 3.634771>,
      < -0.421331, -0.570553, 3.656381>
    }
    triangle {
      < 1.655422, -0.529939, 3.651258>,
      < 1.655419, -0.523261, 3.642065>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537423, -0.530009, 3.651258>,
      < 1.537420, -0.523332, 3.642065>,
      < 1.655419, -0.523261, 3.642065>
    }
    triangle {
      < 1.537423, -0.530009, 3.651258>,
      < 1.655419, -0.523261, 3.642065>,
      < 1.655422, -0.529939, 3.651258>
    }
    triangle {
      < 1.502043, -0.562392, 3.634771>,
      < 1.502035, -0.549038, 3.616386>,
      < 1.537420, -0.523332, 3.642065>
    }
    triangle {
      < 1.502043, -0.562392, 3.634771>,
      < 1.537420, -0.523332, 3.642065>,
      < 1.537423, -0.530009, 3.651258>
    }
    triangle {
      < 1.401769, -0.602905, 3.614164>,
      < 1.401755, -0.581205, 3.584289>,
      < 1.502035, -0.549038, 3.616386>
    }
    triangle {
      < 1.401769, -0.602905, 3.614164>,
      < 1.502035, -0.549038, 3.616386>,
      < 1.502043, -0.562392, 3.634771>
    }
    triangle {
      < 0.109683, -0.603671, 3.614163>,
      < 0.109669, -0.581971, 3.584289>,
      < 1.401755, -0.581205, 3.584289>
    }
    triangle {
      < 0.109683, -0.603671, 3.614163>,
      < 1.401755, -0.581205, 3.584289>,
      < 1.401769, -0.602905, 3.614164>
    }
    triangle {
      < 0.074278, -0.595601, 3.618285>,
      < 0.074266, -0.575570, 3.590709>,
      < 0.109669, -0.581971, 3.584289>
    }
    triangle {
      < 0.074278, -0.595601, 3.618285>,
      < 0.109669, -0.581971, 3.584289>,
      < 0.109683, -0.603671, 3.614163>
    }
    triangle {
      < -0.309220, -0.591784, 3.620347>,
      < -0.309232, -0.572587, 3.593918>,
      < 0.074266, -0.575570, 3.590709>
    }
    triangle {
      < -0.309220, -0.591784, 3.620347>,
      < 0.074266, -0.575570, 3.590709>,
      < 0.074278, -0.595601, 3.618285>
    }
    triangle {
      < -0.421336, -0.563532, 3.634771>,
      < -0.421344, -0.550178, 3.616386>,
      < -0.309232, -0.572587, 3.593918>
    }
    triangle {
      < -0.421336, -0.563532, 3.634771>,
      < -0.309232, -0.572587, 3.593918>,
      < -0.309220, -0.591784, 3.620347>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421344, -0.550178, 3.616386>,
      < -0.421336, -0.563532, 3.634771>
    }
    triangle {
      < 1.655419, -0.523261, 3.642065>,
      < 1.655413, -0.514071, 3.635386>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537420, -0.523332, 3.642065>,
      < 1.537414, -0.514142, 3.635386>,
      < 1.655413, -0.514071, 3.635386>
    }
    triangle {
      < 1.537420, -0.523332, 3.642065>,
      < 1.655413, -0.514071, 3.635386>,
      < 1.655419, -0.523261, 3.642065>
    }
    triangle {
      < 1.502035, -0.549038, 3.616386>,
      < 1.502024, -0.530657, 3.603028>,
      < 1.537414, -0.514142, 3.635386>
    }
    triangle {
      < 1.502035, -0.549038, 3.616386>,
      < 1.537414, -0.514142, 3.635386>,
      < 1.537420, -0.523332, 3.642065>
    }
    triangle {
      < 1.401755, -0.581205, 3.584289>,
      < 1.401738, -0.551337, 3.562580>,
      < 1.502024, -0.530657, 3.603028>
    }
    triangle {
      < 1.401755, -0.581205, 3.584289>,
      < 1.502024, -0.530657, 3.603028>,
      < 1.502035, -0.549038, 3.616386>
    }
    triangle {
      < 0.109669, -0.581971, 3.584289>,
      < 0.109652, -0.552103, 3.562580>,
      < 1.401738, -0.551337, 3.562580>
    }
    triangle {
      < 0.109669, -0.581971, 3.584289>,
      < 1.401738, -0.551337, 3.562580>,
      < 1.401755, -0.581205, 3.584289>
    }
    triangle {
      < 0.074266, -0.575570, 3.590709>,
      < 0.074250, -0.547999, 3.570670>,
      < 0.109652, -0.552103, 3.562580>
    }
    triangle {
      < 0.074266, -0.575570, 3.590709>,
      < 0.109652, -0.552103, 3.562580>,
      < 0.109669, -0.581971, 3.584289>
    }
    triangle {
      < -0.309232, -0.572587, 3.593918>,
      < -0.309247, -0.546165, 3.574714>,
      < 0.074250, -0.547999, 3.570670>
    }
    triangle {
      < -0.309232, -0.572587, 3.593918>,
      < 0.074250, -0.547999, 3.570670>,
      < 0.074266, -0.575570, 3.590709>
    }
    triangle {
      < -0.421344, -0.550178, 3.616386>,
      < -0.421355, -0.531797, 3.603027>,
      < -0.309247, -0.546165, 3.574714>
    }
    triangle {
      < -0.421344, -0.550178, 3.616386>,
      < -0.309247, -0.546165, 3.574714>,
      < -0.309232, -0.572587, 3.593918>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421355, -0.531797, 3.603027>,
      < -0.421344, -0.550178, 3.616386>
    }
    triangle {
      < 1.655413, -0.514071, 3.635386>,
      < 1.655407, -0.503267, 3.631872>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537414, -0.514142, 3.635386>,
      < 1.537408, -0.503337, 3.631872>,
      < 1.655407, -0.503267, 3.631872>
    }
    triangle {
      < 1.537414, -0.514142, 3.635386>,
      < 1.655407, -0.503267, 3.631872>,
      < 1.655413, -0.514071, 3.635386>
    }
    triangle {
      < 1.502024, -0.530657, 3.603028>,
      < 1.502012, -0.509048, 3.596001>,
      < 1.537408, -0.503337, 3.631872>
    }
    triangle {
      < 1.502024, -0.530657, 3.603028>,
      < 1.537408, -0.503337, 3.631872>,
      < 1.537414, -0.514142, 3.635386>
    }
    triangle {
      < 1.401738, -0.551337, 3.562580>,
      < 1.401718, -0.516222, 3.551162>,
      < 1.502012, -0.509048, 3.596001>
    }
    triangle {
      < 1.401738, -0.551337, 3.562580>,
      < 1.502012, -0.509048, 3.596001>,
      < 1.502024, -0.530657, 3.603028>
    }
    triangle {
      < 0.109652, -0.552103, 3.562580>,
      < 0.109632, -0.516988, 3.551161>,
      < 1.401718, -0.516222, 3.551162>
    }
    triangle {
      < 0.109652, -0.552103, 3.562580>,
      < 1.401718, -0.516222, 3.551162>,
      < 1.401738, -0.551337, 3.562580>
    }
    triangle {
      < 0.074250, -0.547999, 3.570670>,
      < 0.074231, -0.515586, 3.560129>,
      < 0.109632, -0.516988, 3.551161>
    }
    triangle {
      < 0.074250, -0.547999, 3.570670>,
      < 0.109632, -0.516988, 3.551161>,
      < 0.109652, -0.552103, 3.562580>
    }
    triangle {
      < -0.309247, -0.546165, 3.574714>,
      < -0.309266, -0.515102, 3.564613>,
      < 0.074231, -0.515586, 3.560129>
    }
    triangle {
      < -0.309247, -0.546165, 3.574714>,
      < 0.074231, -0.515586, 3.560129>,
      < 0.074250, -0.547999, 3.570670>
    }
    triangle {
      < -0.421355, -0.531797, 3.603027>,
      < -0.421367, -0.510189, 3.596000>,
      < -0.309266, -0.515102, 3.564613>
    }
    triangle {
      < -0.421355, -0.531797, 3.603027>,
      < -0.309266, -0.515102, 3.564613>,
      < -0.309247, -0.546165, 3.574714>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421367, -0.510189, 3.596000>,
      < -0.421355, -0.531797, 3.603027>
    }
    triangle {
      < 1.655407, -0.503267, 3.631872>,
      < 1.655400, -0.491905, 3.631869>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537408, -0.503337, 3.631872>,
      < 1.537401, -0.491975, 3.631869>,
      < 1.655400, -0.491905, 3.631869>
    }
    triangle {
      < 1.537408, -0.503337, 3.631872>,
      < 1.655400, -0.491905, 3.631869>,
      < 1.655407, -0.503267, 3.631872>
    }
    triangle {
      < 1.502012, -0.509048, 3.596001>,
      < 1.501998, -0.486326, 3.595994>,
      < 1.537401, -0.491975, 3.631869>
    }
    triangle {
      < 1.502012, -0.509048, 3.596001>,
      < 1.537401, -0.491975, 3.631869>,
      < 1.537408, -0.503337, 3.631872>
    }
    triangle {
      < 1.401718, -0.516222, 3.551162>,
      < 1.401695, -0.479297, 3.551151>,
      < 1.501998, -0.486326, 3.595994>
    }
    triangle {
      < 1.401718, -0.516222, 3.551162>,
      < 1.501998, -0.486326, 3.595994>,
      < 1.502012, -0.509048, 3.596001>
    }
    triangle {
      < 0.109632, -0.516988, 3.551161>,
      < 0.109609, -0.480063, 3.551151>,
      < 1.401695, -0.479297, 3.551151>
    }
    triangle {
      < 0.109632, -0.516988, 3.551161>,
      < 1.401695, -0.479297, 3.551151>,
      < 1.401718, -0.516222, 3.551162>
    }
    triangle {
      < 0.074231, -0.515586, 3.560129>,
      < 0.074210, -0.481501, 3.560120>,
      < 0.109609, -0.480063, 3.551151>
    }
    triangle {
      < 0.074231, -0.515586, 3.560129>,
      < 0.109609, -0.480063, 3.551151>,
      < 0.109632, -0.516988, 3.551161>
    }
    triangle {
      < -0.309266, -0.515102, 3.564613>,
      < -0.309285, -0.482438, 3.564603>,
      < 0.074210, -0.481501, 3.560120>
    }
    triangle {
      < -0.309266, -0.515102, 3.564613>,
      < 0.074210, -0.481501, 3.560120>,
      < 0.074231, -0.515586, 3.560129>
    }
    triangle {
      < -0.421367, -0.510189, 3.596000>,
      < -0.421381, -0.487466, 3.595994>,
      < -0.309285, -0.482438, 3.564603>
    }
    triangle {
      < -0.421367, -0.510189, 3.596000>,
      < -0.309285, -0.482438, 3.564603>,
      < -0.309266, -0.515102, 3.564613>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421381, -0.487466, 3.595994>,
      < -0.421367, -0.510189, 3.596000>
    }
    triangle {
      < 1.655400, -0.491905, 3.631869>,
      < 1.655393, -0.481099, 3.635376>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537401, -0.491975, 3.631869>,
      < 1.537394, -0.481169, 3.635376>,
      < 1.655393, -0.481099, 3.635376>
    }
    triangle {
      < 1.537401, -0.491975, 3.631869>,
      < 1.655393, -0.481099, 3.635376>,
      < 1.655400, -0.491905, 3.631869>
    }
    triangle {
      < 1.501998, -0.486326, 3.595994>,
      < 1.501985, -0.464713, 3.603007>,
      < 1.537394, -0.481169, 3.635376>
    }
    triangle {
      < 1.501998, -0.486326, 3.595994>,
      < 1.537394, -0.481169, 3.635376>,
      < 1.537401, -0.491975, 3.631869>
    }
    triangle {
      < 1.401695, -0.479297, 3.551151>,
      < 1.401674, -0.444177, 3.562549>,
      < 1.501985, -0.464713, 3.603007>
    }
    triangle {
      < 1.401695, -0.479297, 3.551151>,
      < 1.501985, -0.464713, 3.603007>,
      < 1.501998, -0.486326, 3.595994>
    }
    triangle {
      < 0.109609, -0.480063, 3.551151>,
      < 0.109588, -0.444943, 3.562549>,
      < 1.401674, -0.444177, 3.562549>
    }
    triangle {
      < 0.109609, -0.480063, 3.551151>,
      < 1.401674, -0.444177, 3.562549>,
      < 1.401695, -0.479297, 3.551151>
    }
    triangle {
      < 0.074210, -0.481501, 3.560120>,
      < 0.074191, -0.449083, 3.570640>,
      < 0.109588, -0.444943, 3.562549>
    }
    triangle {
      < 0.074210, -0.481501, 3.560120>,
      < 0.109588, -0.444943, 3.562549>,
      < 0.109609, -0.480063, 3.551151>
    }
    triangle {
      < -0.309285, -0.482438, 3.564603>,
      < -0.309304, -0.451369, 3.574686>,
      < 0.074191, -0.449083, 3.570640>
    }
    triangle {
      < -0.309285, -0.482438, 3.564603>,
      < 0.074191, -0.449083, 3.570640>,
      < 0.074210, -0.481501, 3.560120>
    }
    triangle {
      < -0.421381, -0.487466, 3.595994>,
      < -0.421393, -0.465853, 3.603007>,
      < -0.309304, -0.451369, 3.574686>
    }
    triangle {
      < -0.421381, -0.487466, 3.595994>,
      < -0.309304, -0.451369, 3.574686>,
      < -0.309285, -0.482438, 3.564603>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421393, -0.465853, 3.603007>,
      < -0.421381, -0.487466, 3.595994>
    }
    triangle {
      < 1.655393, -0.481099, 3.635376>,
      < 1.655388, -0.471905, 3.642050>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537394, -0.481169, 3.635376>,
      < 1.537389, -0.471975, 3.642050>,
      < 1.655388, -0.471905, 3.642050>
    }
    triangle {
      < 1.537394, -0.481169, 3.635376>,
      < 1.655388, -0.471905, 3.642050>,
      < 1.655393, -0.481099, 3.635376>
    }
    triangle {
      < 1.501985, -0.464713, 3.603007>,
      < 1.501974, -0.446325, 3.616356>,
      < 1.537389, -0.471975, 3.642050>
    }
    triangle {
      < 1.501985, -0.464713, 3.603007>,
      < 1.537389, -0.471975, 3.642050>,
      < 1.537394, -0.481169, 3.635376>
    }
    triangle {
      < 1.401674, -0.444177, 3.562549>,
      < 1.401656, -0.414296, 3.584240>,
      < 1.501974, -0.446325, 3.616356>
    }
    triangle {
      < 1.401674, -0.444177, 3.562549>,
      < 1.501974, -0.446325, 3.616356>,
      < 1.501985, -0.464713, 3.603007>
    }
    triangle {
      < 0.109588, -0.444943, 3.562549>,
      < 0.109571, -0.415062, 3.584239>,
      < 1.401656, -0.414296, 3.584240>
    }
    triangle {
      < 0.109588, -0.444943, 3.562549>,
      < 1.401656, -0.414296, 3.584240>,
      < 1.401674, -0.444177, 3.562549>
    }
    triangle {
      < 0.074191, -0.449083, 3.570640>,
      < 0.074175, -0.421499, 3.590663>,
      < 0.109571, -0.415062, 3.584239>
    }
    triangle {
      < 0.074191, -0.449083, 3.570640>,
      < 0.109571, -0.415062, 3.584239>,
      < 0.109588, -0.444943, 3.562549>
    }
    triangle {
      < -0.309304, -0.451369, 3.574686>,
      < -0.309319, -0.424937, 3.593875>,
      < 0.074175, -0.421499, 3.590663>
    }
    triangle {
      < -0.309304, -0.451369, 3.574686>,
      < 0.074175, -0.421499, 3.590663>,
      < 0.074191, -0.449083, 3.570640>
    }
    triangle {
      < -0.421393, -0.465853, 3.603007>,
      < -0.421404, -0.447465, 3.616356>,
      < -0.309319, -0.424937, 3.593875>
    }
    triangle {
      < -0.421393, -0.465853, 3.603007>,
      < -0.309319, -0.424937, 3.593875>,
      < -0.309304, -0.451369, 3.574686>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421404, -0.447465, 3.616356>,
      < -0.421393, -0.465853, 3.603007>
    }
    triangle {
      < 1.655388, -0.471905, 3.642050>,
      < 1.655384, -0.465222, 3.651237>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537389, -0.471975, 3.642050>,
      < 1.537385, -0.465292, 3.651237>,
      < 1.655384, -0.465222, 3.651237>
    }
    triangle {
      < 1.537389, -0.471975, 3.642050>,
      < 1.655384, -0.465222, 3.651237>,
      < 1.655388, -0.471905, 3.642050>
    }
    triangle {
      < 1.501974, -0.446325, 3.616356>,
      < 1.501966, -0.432960, 3.634733>,
      < 1.537385, -0.465292, 3.651237>
    }
    triangle {
      < 1.501974, -0.446325, 3.616356>,
      < 1.537385, -0.465292, 3.651237>,
      < 1.537389, -0.471975, 3.642050>
    }
    triangle {
      < 1.401656, -0.414296, 3.584240>,
      < 1.401644, -0.392578, 3.614101>,
      < 1.501966, -0.432960, 3.634733>
    }
    triangle {
      < 1.401656, -0.414296, 3.584240>,
      < 1.501966, -0.432960, 3.634733>,
      < 1.501974, -0.446325, 3.616356>
    }
    triangle {
      < 0.109571, -0.415062, 3.584239>,
      < 0.109558, -0.393344, 3.614101>,
      < 1.401644, -0.392578, 3.614101>
    }
    triangle {
      < 0.109571, -0.415062, 3.584239>,
      < 1.401644, -0.392578, 3.614101>,
      < 1.401656, -0.414296, 3.584240>
    }
    triangle {
      < 0.074175, -0.421499, 3.590663>,
      < 0.074164, -0.401453, 3.618227>,
      < 0.109558, -0.393344, 3.614101>
    }
    triangle {
      < 0.074175, -0.421499, 3.590663>,
      < 0.109558, -0.393344, 3.614101>,
      < 0.109571, -0.415062, 3.584239>
    }
    triangle {
      < -0.309319, -0.424937, 3.593875>,
      < -0.309331, -0.405725, 3.620291>,
      < 0.074164, -0.401453, 3.618227>
    }
    triangle {
      < -0.309319, -0.424937, 3.593875>,
      < 0.074164, -0.401453, 3.618227>,
      < 0.074175, -0.421499, 3.590663>
    }
    triangle {
      < -0.421404, -0.447465, 3.616356>,
      < -0.421412, -0.434100, 3.634733>,
      < -0.309331, -0.405725, 3.620291>
    }
    triangle {
      < -0.421404, -0.447465, 3.616356>,
      < -0.309331, -0.405725, 3.620291>,
      < -0.309319, -0.424937, 3.593875>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421412, -0.434100, 3.634733>,
      < -0.421404, -0.447465, 3.616356>
    }
    triangle {
      < 1.655384, -0.465222, 3.651237>,
      < 1.655383, -0.461706, 3.662041>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537385, -0.465292, 3.651237>,
      < 1.537384, -0.461776, 3.662041>,
      < 1.655383, -0.461706, 3.662041>
    }
    triangle {
      < 1.537385, -0.465292, 3.651237>,
      < 1.655383, -0.461706, 3.662041>,
      < 1.655384, -0.465222, 3.651237>
    }
    triangle {
      < 1.501966, -0.432960, 3.634733>,
      < 1.501962, -0.425926, 3.656340>,
      < 1.537384, -0.461776, 3.662041>
    }
    triangle {
      < 1.501966, -0.432960, 3.634733>,
      < 1.537384, -0.461776, 3.662041>,
      < 1.537385, -0.465292, 3.651237>
    }
    triangle {
      < 1.401644, -0.392578, 3.614101>,
      < 1.401637, -0.381149, 3.649212>,
      < 1.501962, -0.425926, 3.656340>
    }
    triangle {
      < 1.401644, -0.392578, 3.614101>,
      < 1.501962, -0.425926, 3.656340>,
      < 1.501966, -0.432960, 3.634733>
    }
    triangle {
      < 0.109558, -0.393344, 3.614101>,
      < 0.109552, -0.381915, 3.649212>,
      < 1.401637, -0.381149, 3.649212>
    }
    triangle {
      < 0.109558, -0.393344, 3.614101>,
      < 1.401637, -0.381149, 3.649212>,
      < 1.401644, -0.392578, 3.614101>
    }
    triangle {
      < 0.074164, -0.401453, 3.618227>,
      < 0.074157, -0.390903, 3.650637>,
      < 0.109552, -0.381915, 3.649212>
    }
    triangle {
      < 0.074164, -0.401453, 3.618227>,
      < 0.109552, -0.381915, 3.649212>,
      < 0.109558, -0.393344, 3.614101>
    }
    triangle {
      < -0.309331, -0.405725, 3.620291>,
      < -0.309336, -0.395614, 3.651350>,
      < 0.074157, -0.390903, 3.650637>
    }
    triangle {
      < -0.309331, -0.405725, 3.620291>,
      < 0.074157, -0.390903, 3.650637>,
      < 0.074164, -0.401453, 3.618227>
    }
    triangle {
      < -0.421412, -0.434100, 3.634733>,
      < -0.421417, -0.427066, 3.656339>,
      < -0.309336, -0.395614, 3.651350>
    }
    triangle {
      < -0.421412, -0.434100, 3.634733>,
      < -0.309336, -0.395614, 3.651350>,
      < -0.309331, -0.405725, 3.620291>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421417, -0.427066, 3.656339>,
      < -0.421412, -0.434100, 3.634733>
    }
    triangle {
      < 1.655383, -0.461706, 3.662041>,
      < 1.655383, -0.461699, 3.673403>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537384, -0.461776, 3.662041>,
      < 1.537384, -0.461769, 3.673403>,
      < 1.655383, -0.461699, 3.673403>
    }
    triangle {
      < 1.537384, -0.461776, 3.662041>,
      < 1.655383, -0.461699, 3.673403>,
      < 1.655383, -0.461706, 3.662041>
    }
    triangle {
      < 1.501962, -0.425926, 3.656340>,
      < 1.501962, -0.425913, 3.679063>,
      < 1.537384, -0.461769, 3.673403>
    }
    triangle {
      < 1.501962, -0.425926, 3.656340>,
      < 1.537384, -0.461769, 3.673403>,
      < 1.537384, -0.461776, 3.662041>
    }
    triangle {
      < 1.401637, -0.381149, 3.649212>,
      < 1.401637, -0.381127, 3.686136>,
      < 1.501962, -0.425913, 3.679063>
    }
    triangle {
      < 1.401637, -0.381149, 3.649212>,
      < 1.501962, -0.425913, 3.679063>,
      < 1.501962, -0.425926, 3.656340>
    }
    triangle {
      < 0.109552, -0.381915, 3.649212>,
      < 0.109552, -0.381893, 3.686136>,
      < 1.401637, -0.381127, 3.686136>
    }
    triangle {
      < 0.109552, -0.381915, 3.649212>,
      < 1.401637, -0.381127, 3.686136>,
      < 1.401637, -0.381149, 3.649212>
    }
    triangle {
      < 0.074157, -0.390903, 3.650637>,
      < 0.074157, -0.390883, 3.684721>,
      < 0.109552, -0.381893, 3.686136>
    }
    triangle {
      < 0.074157, -0.390903, 3.650637>,
      < 0.109552, -0.381893, 3.686136>,
      < 0.109552, -0.381915, 3.649212>
    }
    triangle {
      < -0.309336, -0.395614, 3.651350>,
      < -0.309336, -0.395594, 3.684014>,
      < 0.074157, -0.390883, 3.684721>
    }
    triangle {
      < -0.309336, -0.395614, 3.651350>,
      < 0.074157, -0.390883, 3.684721>,
      < 0.074157, -0.390903, 3.650637>
    }
    triangle {
      < -0.421417, -0.427066, 3.656339>,
      < -0.421417, -0.427053, 3.679062>,
      < -0.309336, -0.395594, 3.684014>
    }
    triangle {
      < -0.421417, -0.427066, 3.656339>,
      < -0.309336, -0.395594, 3.684014>,
      < -0.309336, -0.395614, 3.651350>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421417, -0.427053, 3.679062>,
      < -0.421417, -0.427066, 3.656339>
    }
    triangle {
      < 1.655383, -0.461699, 3.673403>,
      < 1.655384, -0.465202, 3.684210>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537384, -0.461769, 3.673403>,
      < 1.537385, -0.465273, 3.684210>,
      < 1.655384, -0.465202, 3.684210>
    }
    triangle {
      < 1.537384, -0.461769, 3.673403>,
      < 1.655384, -0.465202, 3.684210>,
      < 1.655383, -0.461699, 3.673403>
    }
    triangle {
      < 1.501962, -0.425913, 3.679063>,
      < 1.501966, -0.432921, 3.700677>,
      < 1.537385, -0.465273, 3.684210>
    }
    triangle {
      < 1.501962, -0.425913, 3.679063>,
      < 1.537385, -0.465273, 3.684210>,
      < 1.537384, -0.461769, 3.673403>
    }
    triangle {
      < 1.401637, -0.381127, 3.686136>,
      < 1.401644, -0.392514, 3.721261>,
      < 1.501966, -0.432921, 3.700677>
    }
    triangle {
      < 1.401637, -0.381127, 3.686136>,
      < 1.501966, -0.432921, 3.700677>,
      < 1.501962, -0.425913, 3.679063>
    }
    triangle {
      < 0.109552, -0.381893, 3.686136>,
      < 0.109558, -0.393280, 3.721261>,
      < 1.401644, -0.392514, 3.721261>
    }
    triangle {
      < 0.109552, -0.381893, 3.686136>,
      < 1.401644, -0.392514, 3.721261>,
      < 1.401637, -0.381127, 3.686136>
    }
    triangle {
      < 0.074157, -0.390883, 3.684721>,
      < 0.074164, -0.401394, 3.717145>,
      < 0.109558, -0.393280, 3.721261>
    }
    triangle {
      < 0.074157, -0.390883, 3.684721>,
      < 0.109558, -0.393280, 3.721261>,
      < 0.109552, -0.381893, 3.686136>
    }
    triangle {
      < -0.309336, -0.395594, 3.684014>,
      < -0.309331, -0.405668, 3.715086>,
      < 0.074164, -0.401394, 3.717145>
    }
    triangle {
      < -0.309336, -0.395594, 3.684014>,
      < 0.074164, -0.401394, 3.717145>,
      < 0.074157, -0.390883, 3.684721>
    }
    triangle {
      < -0.421417, -0.427053, 3.679062>,
      < -0.421412, -0.434061, 3.700677>,
      < -0.309331, -0.405668, 3.715086>
    }
    triangle {
      < -0.421417, -0.427053, 3.679062>,
      < -0.309331, -0.405668, 3.715086>,
      < -0.309336, -0.395594, 3.684014>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421412, -0.434061, 3.700677>,
      < -0.421417, -0.427053, 3.679062>
    }
    triangle {
      < 1.655384, -0.465202, 3.684210>,
      < 1.655388, -0.471874, 3.693407>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537385, -0.465273, 3.684210>,
      < 1.537389, -0.471944, 3.693407>,
      < 1.655388, -0.471874, 3.693407>
    }
    triangle {
      < 1.537385, -0.465273, 3.684210>,
      < 1.655388, -0.471874, 3.693407>,
      < 1.655384, -0.465202, 3.684210>
    }
    triangle {
      < 1.501966, -0.432921, 3.700677>,
      < 1.501974, -0.446263, 3.719070>,
      < 1.537389, -0.471944, 3.693407>
    }
    triangle {
      < 1.501966, -0.432921, 3.700677>,
      < 1.537389, -0.471944, 3.693407>,
      < 1.537385, -0.465273, 3.684210>
    }
    triangle {
      < 1.401644, -0.392514, 3.721261>,
      < 1.401656, -0.414197, 3.751149>,
      < 1.501974, -0.446263, 3.719070>
    }
    triangle {
      < 1.401644, -0.392514, 3.721261>,
      < 1.501974, -0.446263, 3.719070>,
      < 1.501966, -0.432921, 3.700677>
    }
    triangle {
      < 0.109558, -0.393280, 3.721261>,
      < 0.109570, -0.414963, 3.751149>,
      < 1.401656, -0.414197, 3.751149>
    }
    triangle {
      < 0.109558, -0.393280, 3.721261>,
      < 1.401656, -0.414197, 3.751149>,
      < 1.401644, -0.392514, 3.721261>
    }
    triangle {
      < 0.074164, -0.401394, 3.717145>,
      < 0.074175, -0.421408, 3.744732>,
      < 0.109570, -0.414963, 3.751149>
    }
    triangle {
      < 0.074164, -0.401394, 3.717145>,
      < 0.109570, -0.414963, 3.751149>,
      < 0.109558, -0.393280, 3.721261>
    }
    triangle {
      < -0.309331, -0.405668, 3.715086>,
      < -0.309319, -0.424849, 3.741525>,
      < 0.074175, -0.421408, 3.744732>
    }
    triangle {
      < -0.309331, -0.405668, 3.715086>,
      < 0.074175, -0.421408, 3.744732>,
      < 0.074164, -0.401394, 3.717145>
    }
    triangle {
      < -0.421412, -0.434061, 3.700677>,
      < -0.421404, -0.447403, 3.719069>,
      < -0.309319, -0.424849, 3.741525>
    }
    triangle {
      < -0.421412, -0.434061, 3.700677>,
      < -0.309319, -0.424849, 3.741525>,
      < -0.309331, -0.405668, 3.715086>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421404, -0.447403, 3.719069>,
      < -0.421412, -0.434061, 3.700677>
    }
    triangle {
      < 1.655388, -0.471874, 3.693407>,
      < 1.655393, -0.481061, 3.700091>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537389, -0.471944, 3.693407>,
      < 1.537394, -0.481131, 3.700091>,
      < 1.655393, -0.481061, 3.700091>
    }
    triangle {
      < 1.537389, -0.471944, 3.693407>,
      < 1.655393, -0.481061, 3.700091>,
      < 1.655388, -0.471874, 3.693407>
    }
    triangle {
      < 1.501974, -0.446263, 3.719070>,
      < 1.501985, -0.464636, 3.732440>,
      < 1.537394, -0.481131, 3.700091>
    }
    triangle {
      < 1.501974, -0.446263, 3.719070>,
      < 1.537394, -0.481131, 3.700091>,
      < 1.537389, -0.471944, 3.693407>
    }
    triangle {
      < 1.401656, -0.414197, 3.751149>,
      < 1.401674, -0.444052, 3.772875>,
      < 1.501985, -0.464636, 3.732440>
    }
    triangle {
      < 1.401656, -0.414197, 3.751149>,
      < 1.501985, -0.464636, 3.732440>,
      < 1.501974, -0.446263, 3.719070>
    }
    triangle {
      < 0.109570, -0.414963, 3.751149>,
      < 0.109588, -0.444818, 3.772875>,
      < 1.401674, -0.444052, 3.772875>
    }
    triangle {
      < 0.109570, -0.414963, 3.751149>,
      < 1.401674, -0.444052, 3.772875>,
      < 1.401656, -0.414197, 3.751149>
    }
    triangle {
      < 0.074175, -0.421408, 3.744732>,
      < 0.074191, -0.448968, 3.764788>,
      < 0.109588, -0.444818, 3.772875>
    }
    triangle {
      < 0.074175, -0.421408, 3.744732>,
      < 0.109588, -0.444818, 3.772875>,
      < 0.109570, -0.414963, 3.751149>
    }
    triangle {
      < -0.309319, -0.424849, 3.741525>,
      < -0.309304, -0.451260, 3.760745>,
      < 0.074191, -0.448968, 3.764788>
    }
    triangle {
      < -0.309319, -0.424849, 3.741525>,
      < 0.074191, -0.448968, 3.764788>,
      < 0.074175, -0.421408, 3.744732>
    }
    triangle {
      < -0.421404, -0.447403, 3.719069>,
      < -0.421393, -0.465776, 3.732440>,
      < -0.309304, -0.451260, 3.760745>
    }
    triangle {
      < -0.421404, -0.447403, 3.719069>,
      < -0.309304, -0.451260, 3.760745>,
      < -0.309319, -0.424849, 3.741525>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421393, -0.465776, 3.732440>,
      < -0.421404, -0.447403, 3.719069>
    }
    triangle {
      < 1.655393, -0.481061, 3.700091>,
      < 1.655400, -0.491863, 3.703612>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537394, -0.481131, 3.700091>,
      < 1.537401, -0.491933, 3.703612>,
      < 1.655400, -0.491863, 3.703612>
    }
    triangle {
      < 1.537394, -0.481131, 3.700091>,
      < 1.655400, -0.491863, 3.703612>,
      < 1.655393, -0.481061, 3.700091>
    }
    triangle {
      < 1.501985, -0.464636, 3.732440>,
      < 1.501998, -0.486241, 3.739480>,
      < 1.537401, -0.491933, 3.703612>
    }
    triangle {
      < 1.501985, -0.464636, 3.732440>,
      < 1.537401, -0.491933, 3.703612>,
      < 1.537394, -0.481131, 3.700091>
    }
    triangle {
      < 1.401674, -0.444052, 3.772875>,
      < 1.401695, -0.479160, 3.784314>,
      < 1.501998, -0.486241, 3.739480>
    }
    triangle {
      < 1.401674, -0.444052, 3.772875>,
      < 1.501998, -0.486241, 3.739480>,
      < 1.501985, -0.464636, 3.732440>
    }
    triangle {
      < 0.109588, -0.444818, 3.772875>,
      < 0.109609, -0.479925, 3.784314>,
      < 1.401695, -0.479160, 3.784314>
    }
    triangle {
      < 0.109588, -0.444818, 3.772875>,
      < 1.401695, -0.479160, 3.784314>,
      < 1.401674, -0.444052, 3.772875>
    }
    triangle {
      < 0.074191, -0.448968, 3.764788>,
      < 0.074210, -0.481374, 3.775347>,
      < 0.109609, -0.479925, 3.784314>
    }
    triangle {
      < 0.074191, -0.448968, 3.764788>,
      < 0.109609, -0.479925, 3.784314>,
      < 0.109588, -0.444818, 3.772875>
    }
    triangle {
      < -0.309304, -0.451260, 3.760745>,
      < -0.309285, -0.482316, 3.770863>,
      < 0.074210, -0.481374, 3.775347>
    }
    triangle {
      < -0.309304, -0.451260, 3.760745>,
      < 0.074210, -0.481374, 3.775347>,
      < 0.074191, -0.448968, 3.764788>
    }
    triangle {
      < -0.421393, -0.465776, 3.732440>,
      < -0.421381, -0.487381, 3.739480>,
      < -0.309285, -0.482316, 3.770863>
    }
    triangle {
      < -0.421393, -0.465776, 3.732440>,
      < -0.309285, -0.482316, 3.770863>,
      < -0.309304, -0.451260, 3.760745>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421381, -0.487381, 3.739480>,
      < -0.421393, -0.465776, 3.732440>
    }
    triangle {
      < 1.655400, -0.491863, 3.703612>,
      < 1.655407, -0.503224, 3.703622>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537401, -0.491933, 3.703612>,
      < 1.537408, -0.503294, 3.703622>,
      < 1.655407, -0.503224, 3.703622>
    }
    triangle {
      < 1.537401, -0.491933, 3.703612>,
      < 1.655407, -0.503224, 3.703622>,
      < 1.655400, -0.491863, 3.703612>
    }
    triangle {
      < 1.501998, -0.486241, 3.739480>,
      < 1.502012, -0.508963, 3.739500>,
      < 1.537408, -0.503294, 3.703622>
    }
    triangle {
      < 1.501998, -0.486241, 3.739480>,
      < 1.537408, -0.503294, 3.703622>,
      < 1.537401, -0.491933, 3.703612>
    }
    triangle {
      < 1.401695, -0.479160, 3.784314>,
      < 1.401717, -0.516084, 3.784348>,
      < 1.502012, -0.508963, 3.739500>
    }
    triangle {
      < 1.401695, -0.479160, 3.784314>,
      < 1.502012, -0.508963, 3.739500>,
      < 1.501998, -0.486241, 3.739480>
    }
    triangle {
      < 0.109609, -0.479925, 3.784314>,
      < 0.109632, -0.516850, 3.784348>,
      < 1.401717, -0.516084, 3.784348>
    }
    triangle {
      < 0.109609, -0.479925, 3.784314>,
      < 1.401717, -0.516084, 3.784348>,
      < 1.401695, -0.479160, 3.784314>
    }
    triangle {
      < 0.074210, -0.481374, 3.775347>,
      < 0.074231, -0.515458, 3.775377>,
      < 0.109632, -0.516850, 3.784348>
    }
    triangle {
      < 0.074210, -0.481374, 3.775347>,
      < 0.109632, -0.516850, 3.784348>,
      < 0.109609, -0.479925, 3.784314>
    }
    triangle {
      < -0.309285, -0.482316, 3.770863>,
      < -0.309266, -0.514980, 3.770893>,
      < 0.074231, -0.515458, 3.775377>
    }
    triangle {
      < -0.309285, -0.482316, 3.770863>,
      < 0.074231, -0.515458, 3.775377>,
      < 0.074210, -0.481374, 3.775347>
    }
    triangle {
      < -0.421381, -0.487381, 3.739480>,
      < -0.421367, -0.510103, 3.739500>,
      < -0.309266, -0.514980, 3.770893>
    }
    triangle {
      < -0.421381, -0.487381, 3.739480>,
      < -0.309266, -0.514980, 3.770893>,
      < -0.309285, -0.482316, 3.770863>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421367, -0.510103, 3.739500>,
      < -0.421381, -0.487381, 3.739480>
    }
    triangle {
      < 1.655407, -0.503224, 3.703622>,
      < 1.655413, -0.514032, 3.700121>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537408, -0.503294, 3.703622>,
      < 1.537414, -0.514102, 3.700121>,
      < 1.655413, -0.514032, 3.700121>
    }
    triangle {
      < 1.537408, -0.503294, 3.703622>,
      < 1.655413, -0.514032, 3.700121>,
      < 1.655407, -0.503224, 3.703622>
    }
    triangle {
      < 1.502012, -0.508963, 3.739500>,
      < 1.502024, -0.530581, 3.732499>,
      < 1.537414, -0.514102, 3.700121>
    }
    triangle {
      < 1.502012, -0.508963, 3.739500>,
      < 1.537414, -0.514102, 3.700121>,
      < 1.537408, -0.503294, 3.703622>
    }
    triangle {
      < 1.401717, -0.516084, 3.784348>,
      < 1.401738, -0.551212, 3.772971>,
      < 1.502024, -0.530581, 3.732499>
    }
    triangle {
      < 1.401717, -0.516084, 3.784348>,
      < 1.502024, -0.530581, 3.732499>,
      < 1.502012, -0.508963, 3.739500>
    }
    triangle {
      < 0.109632, -0.516850, 3.784348>,
      < 0.109652, -0.551978, 3.772970>,
      < 1.401738, -0.551212, 3.772971>
    }
    triangle {
      < 0.109632, -0.516850, 3.784348>,
      < 1.401738, -0.551212, 3.772971>,
      < 1.401717, -0.516084, 3.784348>
    }
    triangle {
      < 0.074231, -0.515458, 3.775377>,
      < 0.074250, -0.547884, 3.764876>,
      < 0.109652, -0.551978, 3.772970>
    }
    triangle {
      < 0.074231, -0.515458, 3.775377>,
      < 0.109652, -0.551978, 3.772970>,
      < 0.109632, -0.516850, 3.784348>
    }
    triangle {
      < -0.309266, -0.514980, 3.770893>,
      < -0.309247, -0.546055, 3.760829>,
      < 0.074250, -0.547884, 3.764876>
    }
    triangle {
      < -0.309266, -0.514980, 3.770893>,
      < 0.074250, -0.547884, 3.764876>,
      < 0.074231, -0.515458, 3.775377>
    }
    triangle {
      < -0.421367, -0.510103, 3.739500>,
      < -0.421355, -0.531721, 3.732498>,
      < -0.309247, -0.546055, 3.760829>
    }
    triangle {
      < -0.421367, -0.510103, 3.739500>,
      < -0.309247, -0.546055, 3.760829>,
      < -0.309266, -0.514980, 3.770893>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421355, -0.531721, 3.732498>,
      < -0.421367, -0.510103, 3.739500>
    }
    triangle {
      < 1.655413, -0.514032, 3.700121>,
      < 1.655419, -0.523261, 3.693422>,
      < 1.655403, -0.497575, 3.667744>
    }
    triangle {
      < 1.537414, -0.514102, 3.700121>,
      < 1.537420, -0.523332, 3.693422>,
      < 1.655419, -0.523261, 3.693422>
    }
    triangle {
      < 1.537414, -0.514102, 3.700121>,
      < 1.655419, -0.523261, 3.693422>,
      < 1.655413, -0.514032, 3.700121>
    }
    triangle {
      < 1.502024, -0.530581, 3.732499>,
      < 1.502035, -0.549038, 3.719101>,
      < 1.537420, -0.523332, 3.693422>
    }
    triangle {
      < 1.502024, -0.530581, 3.732499>,
      < 1.537420, -0.523332, 3.693422>,
      < 1.537414, -0.514102, 3.700121>
    }
    triangle {
      < 1.401738, -0.551212, 3.772971>,
      < 1.401755, -0.581205, 3.751199>,
      < 1.502035, -0.549038, 3.719101>
    }
    triangle {
      < 1.401738, -0.551212, 3.772971>,
      < 1.502035, -0.549038, 3.719101>,
      < 1.502024, -0.530581, 3.732499>
    }
    triangle {
      < 0.109652, -0.551978, 3.772970>,
      < 0.109669, -0.581971, 3.751198>,
      < 1.401755, -0.581205, 3.751199>
    }
    triangle {
      < 0.109652, -0.551978, 3.772970>,
      < 1.401755, -0.581205, 3.751199>,
      < 1.401738, -0.551212, 3.772971>
    }
    triangle {
      < 0.074250, -0.547884, 3.764876>,
      < 0.074266, -0.575570, 3.744779>,
      < 0.109669, -0.581971, 3.751198>
    }
    triangle {
      < 0.074250, -0.547884, 3.764876>,
      < 0.109669, -0.581971, 3.751198>,
      < 0.109652, -0.551978, 3.772970>
    }
    triangle {
      < -0.309247, -0.546055, 3.760829>,
      < -0.309232, -0.572587, 3.741569>,
      < 0.074266, -0.575570, 3.744779>
    }
    triangle {
      < -0.309247, -0.546055, 3.760829>,
      < 0.074266, -0.575570, 3.744779>,
      < 0.074250, -0.547884, 3.764876>
    }
    triangle {
      < -0.421355, -0.531721, 3.732498>,
      < -0.421344, -0.550178, 3.719100>,
      < -0.309232, -0.572587, 3.741569>
    }
    triangle {
      < -0.421355, -0.531721, 3.732498>,
      < -0.309232, -0.572587, 3.741569>,
      < -0.309247, -0.546055, 3.760829>
    }
    triangle {
      < -0.498073, -0.498851, 3.667743>,
      < -0.421344, -0.550178, 3.719100>,
      < -0.421355, -0.531721, 3.732498>
    }
    triangle {
      < -0.360007, -0.657782, 3.488717>,
      < -0.360101, -0.499660, 3.646792>,
      < -0.090880, -0.499501, 3.646792>
    }
    triangle {
      < -0.360007, -0.657782, 3.488717>,
      < -0.090880, -0.499501, 3.646792>,
      < -0.090787, -0.657623, 3.488717>
    }
    triangle {
      < -0.090775, -0.677683, 3.508785>,
      < -0.090868, -0.519563, 3.666859>,
      < -0.360089, -0.519722, 3.666859>
    }
    triangle {
      < -0.090775, -0.677683, 3.508785>,
      < -0.360089, -0.519722, 3.666859>,
      < -0.359995, -0.677843, 3.508785>
    }
    triangle {
      < -0.359995, -0.677843, 3.508785>,
      < -0.360089, -0.519722, 3.666859>,
      < -0.360101, -0.499660, 3.646792>
    }
    triangle {
      < -0.359995, -0.677843, 3.508785>,
      < -0.360101, -0.499660, 3.646792>,
      < -0.360007, -0.657782, 3.488717>
    }
    triangle {
      < -0.359995, -0.677843, 3.508785>,
      < -0.360007, -0.657782, 3.488717>,
      < -0.090787, -0.657623, 3.488717>
    }
    triangle {
      < -0.359995, -0.677843, 3.508785>,
      < -0.090787, -0.657623, 3.488717>,
      < -0.090775, -0.677683, 3.508785>
    }
    triangle {
      < -0.090787, -0.657623, 3.488717>,
      < -0.090880, -0.499501, 3.646792>,
      < -0.090868, -0.519563, 3.666859>
    }
    triangle {
      < -0.090787, -0.657623, 3.488717>,
      < -0.090868, -0.519563, 3.666859>,
      < -0.090775, -0.677683, 3.508785>
    }
    triangle {
      < -0.360101, -0.499660, 3.646792>,
      < -0.360089, -0.519722, 3.666859>,
      < -0.090868, -0.519563, 3.666859>
    }
    triangle {
      < -0.360101, -0.499660, 3.646792>,
      < -0.090868, -0.519563, 3.666859>,
      < -0.090880, -0.499501, 3.646792>
    }
    triangle {
      < 0.022432, -0.657555, 3.488717>,
      < 0.022339, -0.499434, 3.646792>,
      < 0.291559, -0.499274, 3.646793>
    }
    triangle {
      < 0.022432, -0.657555, 3.488717>,
      < 0.291559, -0.499274, 3.646793>,
      < 0.291653, -0.657396, 3.488717>
    }
    triangle {
      < 0.291665, -0.677457, 3.508785>,
      < 0.291571, -0.519336, 3.666859>,
      < 0.022351, -0.519495, 3.666859>
    }
    triangle {
      < 0.291665, -0.677457, 3.508785>,
      < 0.022351, -0.519495, 3.666859>,
      < 0.022444, -0.677616, 3.508785>
    }
    triangle {
      < 0.022444, -0.677616, 3.508785>,
      < 0.022351, -0.519495, 3.666859>,
      < 0.022339, -0.499434, 3.646792>
    }
    triangle {
      < 0.022444, -0.677616, 3.508785>,
      < 0.022339, -0.499434, 3.646792>,
      < 0.022432, -0.657555, 3.488717>
    }
    triangle {
      < 0.022444, -0.677616, 3.508785>,
      < 0.022432, -0.657555, 3.488717>,
      < 0.291653, -0.657396, 3.488717>
    }
    triangle {
      < 0.022444, -0.677616, 3.508785>,
      < 0.291653, -0.657396, 3.488717>,
      < 0.291665, -0.677457, 3.508785>
    }
    triangle {
      < 0.291653, -0.657396, 3.488717>,
      < 0.291559, -0.499274, 3.646793>,
      < 0.291571, -0.519336, 3.666859>
    }
    triangle {
      < 0.291653, -0.657396, 3.488717>,
      < 0.291571, -0.519336, 3.666859>,
      < 0.291665, -0.677457, 3.508785>
    }
    triangle {
      < 0.022339, -0.499434, 3.646792>,
      < 0.022351, -0.519495, 3.666859>,
      < 0.291571, -0.519336, 3.666859>
    }
    triangle {
      < 0.022339, -0.499434, 3.646792>,
      < 0.291571, -0.519336, 3.666859>,
      < 0.291559, -0.499274, 3.646793>
    }
    triangle {
      < -0.360207, -0.319790, 3.508679>,
      < -0.360113, -0.477818, 3.666846>,
      < -0.090893, -0.477659, 3.666846>
    }
    triangle {
      < -0.360207, -0.319790, 3.508679>,
      < -0.090893, -0.477659, 3.666846>,
      < -0.090986, -0.319631, 3.508679>
    }
    triangle {
      < -0.090975, -0.339704, 3.488622>,
      < -0.090881, -0.497732, 3.646791>,
      < -0.360102, -0.497891, 3.646791>
    }
    triangle {
      < -0.090975, -0.339704, 3.488622>,
      < -0.360102, -0.497891, 3.646791>,
      < -0.360195, -0.339864, 3.488622>
    }
    triangle {
      < -0.360195, -0.339864, 3.488622>,
      < -0.360102, -0.497891, 3.646791>,
      < -0.360113, -0.477818, 3.666846>
    }
    triangle {
      < -0.360195, -0.339864, 3.488622>,
      < -0.360113, -0.477818, 3.666846>,
      < -0.360207, -0.319790, 3.508679>
    }
    triangle {
      < -0.360195, -0.339864, 3.488622>,
      < -0.360207, -0.319790, 3.508679>,
      < -0.090986, -0.319631, 3.508679>
    }
    triangle {
      < -0.360195, -0.339864, 3.488622>,
      < -0.090986, -0.319631, 3.508679>,
      < -0.090975, -0.339704, 3.488622>
    }
    triangle {
      < -0.090986, -0.319631, 3.508679>,
      < -0.090893, -0.477659, 3.666846>,
      < -0.090881, -0.497732, 3.646791>
    }
    triangle {
      < -0.090986, -0.319631, 3.508679>,
      < -0.090881, -0.497732, 3.646791>,
      < -0.090975, -0.339704, 3.488622>
    }
    triangle {
      < -0.360113, -0.477818, 3.666846>,
      < -0.360102, -0.497891, 3.646791>,
      < -0.090881, -0.497732, 3.646791>
    }
    triangle {
      < -0.360113, -0.477818, 3.666846>,
      < -0.090881, -0.497732, 3.646791>,
      < -0.090893, -0.477659, 3.666846>
    }
    triangle {
      < 0.022233, -0.319564, 3.508679>,
      < 0.022326, -0.477591, 3.666847>,
      < 0.291547, -0.477432, 3.666847>
    }
    triangle {
      < 0.022233, -0.319564, 3.508679>,
      < 0.291547, -0.477432, 3.666847>,
      < 0.291453, -0.319404, 3.508679>
    }
    triangle {
      < 0.291465, -0.339477, 3.488623>,
      < 0.291559, -0.497505, 3.646791>,
      < 0.022338, -0.497664, 3.646791>
    }
    triangle {
      < 0.291465, -0.339477, 3.488623>,
      < 0.022338, -0.497664, 3.646791>,
      < 0.022244, -0.339637, 3.488622>
    }
    triangle {
      < 0.022244, -0.339637, 3.488622>,
      < 0.022338, -0.497664, 3.646791>,
      < 0.022326, -0.477591, 3.666847>
    }
    triangle {
      < 0.022244, -0.339637, 3.488622>,
      < 0.022326, -0.477591, 3.666847>,
      < 0.022233, -0.319564, 3.508679>
    }
    triangle {
      < 0.022244, -0.339637, 3.488622>,
      < 0.022233, -0.319564, 3.508679>,
      < 0.291453, -0.319404, 3.508679>
    }
    triangle {
      < 0.022244, -0.339637, 3.488622>,
      < 0.291453, -0.319404, 3.508679>,
      < 0.291465, -0.339477, 3.488623>
    }
    triangle {
      < 0.291453, -0.319404, 3.508679>,
      < 0.291547, -0.477432, 3.666847>,
      < 0.291559, -0.497505, 3.646791>
    }
    triangle {
      < 0.291453, -0.319404, 3.508679>,
      < 0.291559, -0.497505, 3.646791>,
      < 0.291465, -0.339477, 3.488623>
    }
    triangle {
      < 0.022326, -0.477591, 3.666847>,
      < 0.022338, -0.497664, 3.646791>,
      < 0.291559, -0.497505, 3.646791>
    }
    triangle {
      < 0.022326, -0.477591, 3.666847>,
      < 0.291559, -0.497505, 3.646791>,
      < 0.291547, -0.477432, 3.666847>
    }
    triangle {
      < -0.360195, -0.339651, 3.846676>,
      < -0.360102, -0.497866, 3.688695>,
      < -0.090881, -0.497707, 3.688695>
    }
    triangle {
      < -0.360195, -0.339651, 3.846676>,
      < -0.090881, -0.497707, 3.688695>,
      < -0.090975, -0.339492, 3.846676>
    }
    triangle {
      < -0.090986, -0.319443, 3.826596>,
      < -0.090893, -0.477657, 3.668616>,
      < -0.360113, -0.477817, 3.668616>
    }
    triangle {
      < -0.090986, -0.319443, 3.826596>,
      < -0.360113, -0.477817, 3.668616>,
      < -0.360207, -0.319602, 3.826596>
    }
    triangle {
      < -0.360207, -0.319602, 3.826596>,
      < -0.360113, -0.477817, 3.668616>,
      < -0.360102, -0.497866, 3.688695>
    }
    triangle {
      < -0.360207, -0.319602, 3.826596>,
      < -0.360102, -0.497866, 3.688695>,
      < -0.360195, -0.339651, 3.846676>
    }
    triangle {
      < -0.360207, -0.319602, 3.826596>,
      < -0.360195, -0.339651, 3.846676>,
      < -0.090975, -0.339492, 3.846676>
    }
    triangle {
      < -0.360207, -0.319602, 3.826596>,
      < -0.090975, -0.339492, 3.846676>,
      < -0.090986, -0.319443, 3.826596>
    }
    triangle {
      < -0.090975, -0.339492, 3.846676>,
      < -0.090881, -0.497707, 3.688695>,
      < -0.090893, -0.477657, 3.668616>
    }
    triangle {
      < -0.090975, -0.339492, 3.846676>,
      < -0.090893, -0.477657, 3.668616>,
      < -0.090986, -0.319443, 3.826596>
    }
    triangle {
      < -0.360102, -0.497866, 3.688695>,
      < -0.360113, -0.477817, 3.668616>,
      < -0.090893, -0.477657, 3.668616>
    }
    triangle {
      < -0.360102, -0.497866, 3.688695>,
      < -0.090893, -0.477657, 3.668616>,
      < -0.090881, -0.497707, 3.688695>
    }
    triangle {
      < 0.022244, -0.339424, 3.846676>,
      < 0.022338, -0.497640, 3.688695>,
      < 0.291559, -0.497480, 3.688695>
    }
    triangle {
      < 0.022244, -0.339424, 3.846676>,
      < 0.291559, -0.497480, 3.688695>,
      < 0.291465, -0.339265, 3.846676>
    }
    triangle {
      < 0.291452, -0.319216, 3.826596>,
      < 0.291547, -0.477430, 3.668616>,
      < 0.022326, -0.477590, 3.668616>
    }
    triangle {
      < 0.291452, -0.319216, 3.826596>,
      < 0.022326, -0.477590, 3.668616>,
      < 0.022233, -0.319375, 3.826596>
    }
    triangle {
      < 0.022233, -0.319375, 3.826596>,
      < 0.022326, -0.477590, 3.668616>,
      < 0.022338, -0.497640, 3.688695>
    }
    triangle {
      < 0.022233, -0.319375, 3.826596>,
      < 0.022338, -0.497640, 3.688695>,
      < 0.022244, -0.339424, 3.846676>
    }
    triangle {
      < 0.022233, -0.319375, 3.826596>,
      < 0.022244, -0.339424, 3.846676>,
      < 0.291465, -0.339265, 3.846676>
    }
    triangle {
      < 0.022233, -0.319375, 3.826596>,
      < 0.291465, -0.339265, 3.846676>,
      < 0.291452, -0.319216, 3.826596>
    }
    triangle {
      < 0.291465, -0.339265, 3.846676>,
      < 0.291559, -0.497480, 3.688695>,
      < 0.291547, -0.477430, 3.668616>
    }
    triangle {
      < 0.291465, -0.339265, 3.846676>,
      < 0.291547, -0.477430, 3.668616>,
      < 0.291452, -0.319216, 3.826596>
    }
    triangle {
      < 0.022338, -0.497640, 3.688695>,
      < 0.022326, -0.477590, 3.668616>,
      < 0.291547, -0.477430, 3.668616>
    }
    triangle {
      < 0.022338, -0.497640, 3.688695>,
      < 0.291547, -0.477430, 3.668616>,
      < 0.291559, -0.497480, 3.688695>
    }
    triangle {
      < -0.359995, -0.677654, 3.826915>,
      < -0.360089, -0.519721, 3.668653>,
      < -0.090868, -0.519561, 3.668653>
    }
    triangle {
      < -0.359995, -0.677654, 3.826915>,
      < -0.090868, -0.519561, 3.668653>,
      < -0.090775, -0.677495, 3.826915>
    }
    triangle {
      < -0.090787, -0.657410, 3.846958>,
      < -0.090880, -0.499476, 3.688696>,
      < -0.360101, -0.499635, 3.688696>
    }
    triangle {
      < -0.090787, -0.657410, 3.846958>,
      < -0.360101, -0.499635, 3.688696>,
      < -0.360007, -0.657570, 3.846958>
    }
    triangle {
      < -0.360007, -0.657570, 3.846958>,
      < -0.360101, -0.499635, 3.688696>,
      < -0.360089, -0.519721, 3.668653>
    }
    triangle {
      < -0.360007, -0.657570, 3.846958>,
      < -0.360089, -0.519721, 3.668653>,
      < -0.359995, -0.677654, 3.826915>
    }
    triangle {
      < -0.360007, -0.657570, 3.846958>,
      < -0.359995, -0.677654, 3.826915>,
      < -0.090775, -0.677495, 3.826915>
    }
    triangle {
      < -0.360007, -0.657570, 3.846958>,
      < -0.090775, -0.677495, 3.826915>,
      < -0.090787, -0.657410, 3.846958>
    }
    triangle {
      < -0.090775, -0.677495, 3.826915>,
      < -0.090868, -0.519561, 3.668653>,
      < -0.090880, -0.499476, 3.688696>
    }
    triangle {
      < -0.090775, -0.677495, 3.826915>,
      < -0.090880, -0.499476, 3.688696>,
      < -0.090787, -0.657410, 3.846958>
    }
    triangle {
      < -0.360089, -0.519721, 3.668653>,
      < -0.360101, -0.499635, 3.688696>,
      < -0.090880, -0.499476, 3.688696>
    }
    triangle {
      < -0.360089, -0.519721, 3.668653>,
      < -0.090880, -0.499476, 3.688696>,
      < -0.090868, -0.519561, 3.668653>
    }
    triangle {
      < 0.022444, -0.677428, 3.826915>,
      < 0.022351, -0.519494, 3.668653>,
      < 0.291571, -0.519335, 3.668653>
    }
    triangle {
      < 0.022444, -0.677428, 3.826915>,
      < 0.291571, -0.519335, 3.668653>,
      < 0.291665, -0.677268, 3.826915>
    }
    triangle {
      < 0.291653, -0.657184, 3.846959>,
      < 0.291559, -0.499249, 3.688696>,
      < 0.022339, -0.499408, 3.688696>
    }
    triangle {
      < 0.291653, -0.657184, 3.846959>,
      < 0.022339, -0.499408, 3.688696>,
      < 0.022432, -0.657343, 3.846958>
    }
    triangle {
      < 0.022432, -0.657343, 3.846958>,
      < 0.022339, -0.499408, 3.688696>,
      < 0.022351, -0.519494, 3.668653>
    }
    triangle {
      < 0.022432, -0.657343, 3.846958>,
      < 0.022351, -0.519494, 3.668653>,
      < 0.022444, -0.677428, 3.826915>
    }
    triangle {
      < 0.022432, -0.657343, 3.846958>,
      < 0.022444, -0.677428, 3.826915>,
      < 0.291665, -0.677268, 3.826915>
    }
    triangle {
      < 0.022432, -0.657343, 3.846958>,
      < 0.291665, -0.677268, 3.826915>,
      < 0.291653, -0.657184, 3.846959>
    }
    triangle {
      < 0.291665, -0.677268, 3.826915>,
      < 0.291571, -0.519335, 3.668653>,
      < 0.291559, -0.499249, 3.688696>
    }
    triangle {
      < 0.291665, -0.677268, 3.826915>,
      < 0.291559, -0.499249, 3.688696>,
      < 0.291653, -0.657184, 3.846959>
    }
    triangle {
      < 0.022351, -0.519494, 3.668653>,
      < 0.022339, -0.499408, 3.688696>,
      < 0.291559, -0.499249, 3.688696>
    }
    triangle {
      < 0.022351, -0.519494, 3.668653>,
      < 0.291559, -0.499249, 3.688696>,
      < 0.291571, -0.519335, 3.668653>
    }
    triangle {
      < 1.415413, -0.746801, 0.397298>,
      < 1.415417, -0.754220, 0.387084>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314524, -0.746861, 0.397298>,
      < 1.314528, -0.754280, 0.387084>,
      < 1.415417, -0.754220, 0.387084>
    }
    triangle {
      < 1.314524, -0.746861, 0.397298>,
      < 1.415417, -0.754220, 0.387084>,
      < 1.415413, -0.746801, 0.397298>
    }
    triangle {
      < 1.284274, -0.775419, 0.425829>,
      < 1.284282, -0.790257, 0.405402>,
      < 1.314528, -0.754280, 0.387084>
    }
    triangle {
      < 1.284274, -0.775419, 0.425829>,
      < 1.314528, -0.754280, 0.387084>,
      < 1.314524, -0.746861, 0.397298>
    }
    triangle {
      < 1.198539, -0.811145, 0.461494>,
      < 1.198553, -0.835256, 0.428299>,
      < 1.284282, -0.790257, 0.405402>
    }
    triangle {
      < 1.198539, -0.811145, 0.461494>,
      < 1.284282, -0.790257, 0.405402>,
      < 1.284274, -0.775419, 0.425829>
    }
    triangle {
      < 0.093803, -0.811800, 0.461493>,
      < 0.093817, -0.835910, 0.428298>,
      < 1.198553, -0.835256, 0.428299>
    }
    triangle {
      < 0.093803, -0.811800, 0.461493>,
      < 1.198553, -0.835256, 0.428299>,
      < 1.198539, -0.811145, 0.461494>
    }
    triangle {
      < 0.063533, -0.804682, 0.454361>,
      < 0.063546, -0.826939, 0.423719>,
      < 0.093817, -0.835910, 0.428298>
    }
    triangle {
      < 0.063533, -0.804682, 0.454361>,
      < 0.093817, -0.835910, 0.428298>,
      < 0.093803, -0.811800, 0.461493>
    }
    triangle {
      < -0.264359, -0.801310, 0.450794>,
      < -0.264347, -0.822639, 0.421429>,
      < 0.063546, -0.826939, 0.423719>
    }
    triangle {
      < -0.264359, -0.801310, 0.450794>,
      < 0.063546, -0.826939, 0.423719>,
      < 0.063533, -0.804682, 0.454361>
    }
    triangle {
      < -0.360219, -0.776394, 0.425829>,
      < -0.360210, -0.791232, 0.405402>,
      < -0.264347, -0.822639, 0.421429>
    }
    triangle {
      < -0.360219, -0.776394, 0.425829>,
      < -0.264347, -0.822639, 0.421429>,
      < -0.264359, -0.801310, 0.450794>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360210, -0.791232, 0.405402>,
      < -0.360219, -0.776394, 0.425829>
    }
    triangle {
      < 1.415417, -0.754220, 0.387084>,
      < 1.415419, -0.758120, 0.375078>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314528, -0.754280, 0.387084>,
      < 1.314530, -0.758180, 0.375078>,
      < 1.415419, -0.758120, 0.375078>
    }
    triangle {
      < 1.314528, -0.754280, 0.387084>,
      < 1.415419, -0.758120, 0.375078>,
      < 1.415417, -0.754220, 0.387084>
    }
    triangle {
      < 1.284282, -0.790257, 0.405402>,
      < 1.284287, -0.798057, 0.381390>,
      < 1.314530, -0.758180, 0.375078>
    }
    triangle {
      < 1.284282, -0.790257, 0.405402>,
      < 1.314530, -0.758180, 0.375078>,
      < 1.314528, -0.754280, 0.387084>
    }
    triangle {
      < 1.198553, -0.835256, 0.428299>,
      < 1.198561, -0.847931, 0.389280>,
      < 1.284287, -0.798057, 0.381390>
    }
    triangle {
      < 1.198553, -0.835256, 0.428299>,
      < 1.284287, -0.798057, 0.381390>,
      < 1.284282, -0.790257, 0.405402>
    }
    triangle {
      < 0.093817, -0.835910, 0.428298>,
      < 0.093825, -0.848586, 0.389280>,
      < 1.198561, -0.847931, 0.389280>
    }
    triangle {
      < 0.093817, -0.835910, 0.428298>,
      < 1.198561, -0.847931, 0.389280>,
      < 1.198553, -0.835256, 0.428299>
    }
    triangle {
      < 0.063546, -0.826939, 0.423719>,
      < 0.063553, -0.838639, 0.387702>,
      < 0.093825, -0.848586, 0.389280>
    }
    triangle {
      < 0.063546, -0.826939, 0.423719>,
      < 0.093825, -0.848586, 0.389280>,
      < 0.093817, -0.835910, 0.428298>
    }
    triangle {
      < -0.264347, -0.822639, 0.421429>,
      < -0.264340, -0.833852, 0.386912>,
      < 0.063553, -0.838639, 0.387702>
    }
    triangle {
      < -0.264347, -0.822639, 0.421429>,
      < 0.063553, -0.838639, 0.387702>,
      < 0.063546, -0.826939, 0.423719>
    }
    triangle {
      < -0.360210, -0.791232, 0.405402>,
      < -0.360206, -0.799032, 0.381389>,
      < -0.264340, -0.833852, 0.386912>
    }
    triangle {
      < -0.360210, -0.791232, 0.405402>,
      < -0.264340, -0.833852, 0.386912>,
      < -0.264347, -0.822639, 0.421429>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360206, -0.799032, 0.381389>,
      < -0.360210, -0.791232, 0.405402>
    }
    triangle {
      < 1.415419, -0.758120, 0.375078>,
      < 1.415419, -0.758119, 0.362454>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314530, -0.758180, 0.375078>,
      < 1.314530, -0.758179, 0.362454>,
      < 1.415419, -0.758119, 0.362454>
    }
    triangle {
      < 1.314530, -0.758180, 0.375078>,
      < 1.415419, -0.758119, 0.362454>,
      < 1.415419, -0.758120, 0.375078>
    }
    triangle {
      < 1.284287, -0.798057, 0.381390>,
      < 1.284287, -0.798057, 0.356143>,
      < 1.314530, -0.758179, 0.362454>
    }
    triangle {
      < 1.284287, -0.798057, 0.381390>,
      < 1.314530, -0.758179, 0.362454>,
      < 1.314530, -0.758180, 0.375078>
    }
    triangle {
      < 1.198561, -0.847931, 0.389280>,
      < 1.198561, -0.847931, 0.348252>,
      < 1.284287, -0.798057, 0.356143>
    }
    triangle {
      < 1.198561, -0.847931, 0.389280>,
      < 1.284287, -0.798057, 0.356143>,
      < 1.284287, -0.798057, 0.381390>
    }
    triangle {
      < 0.093825, -0.848586, 0.389280>,
      < 0.093825, -0.848585, 0.348252>,
      < 1.198561, -0.847931, 0.348252>
    }
    triangle {
      < 0.093825, -0.848586, 0.389280>,
      < 1.198561, -0.847931, 0.348252>,
      < 1.198561, -0.847931, 0.389280>
    }
    triangle {
      < 0.063553, -0.838639, 0.387702>,
      < 0.063553, -0.838639, 0.349829>,
      < 0.093825, -0.848585, 0.348252>
    }
    triangle {
      < 0.063553, -0.838639, 0.387702>,
      < 0.093825, -0.848585, 0.348252>,
      < 0.093825, -0.848586, 0.389280>
    }
    triangle {
      < -0.264340, -0.833852, 0.386912>,
      < -0.264340, -0.833852, 0.350619>,
      < 0.063553, -0.838639, 0.349829>
    }
    triangle {
      < -0.264340, -0.833852, 0.386912>,
      < 0.063553, -0.838639, 0.349829>,
      < 0.063553, -0.838639, 0.387702>
    }
    triangle {
      < -0.360206, -0.799032, 0.381389>,
      < -0.360206, -0.799032, 0.356142>,
      < -0.264340, -0.833852, 0.350619>
    }
    triangle {
      < -0.360206, -0.799032, 0.381389>,
      < -0.264340, -0.833852, 0.350619>,
      < -0.264340, -0.833852, 0.386912>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360206, -0.799032, 0.356142>,
      < -0.360206, -0.799032, 0.381389>
    }
    triangle {
      < 1.415419, -0.758119, 0.362454>,
      < 1.415417, -0.754220, 0.350449>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314530, -0.758179, 0.362454>,
      < 1.314528, -0.754280, 0.350449>,
      < 1.415417, -0.754220, 0.350449>
    }
    triangle {
      < 1.314530, -0.758179, 0.362454>,
      < 1.415417, -0.754220, 0.350449>,
      < 1.415419, -0.758119, 0.362454>
    }
    triangle {
      < 1.284287, -0.798057, 0.356143>,
      < 1.284282, -0.790256, 0.332130>,
      < 1.314528, -0.754280, 0.350449>
    }
    triangle {
      < 1.284287, -0.798057, 0.356143>,
      < 1.314528, -0.754280, 0.350449>,
      < 1.314530, -0.758179, 0.362454>
    }
    triangle {
      < 1.198561, -0.847931, 0.348252>,
      < 1.198553, -0.835256, 0.309233>,
      < 1.284282, -0.790256, 0.332130>
    }
    triangle {
      < 1.198561, -0.847931, 0.348252>,
      < 1.284282, -0.790256, 0.332130>,
      < 1.284287, -0.798057, 0.356143>
    }
    triangle {
      < 0.093825, -0.848585, 0.348252>,
      < 0.093817, -0.835911, 0.309232>,
      < 1.198553, -0.835256, 0.309233>
    }
    triangle {
      < 0.093825, -0.848585, 0.348252>,
      < 1.198553, -0.835256, 0.309233>,
      < 1.198561, -0.847931, 0.348252>
    }
    triangle {
      < 0.063553, -0.838639, 0.349829>,
      < 0.063546, -0.826939, 0.313812>,
      < 0.093817, -0.835911, 0.309232>
    }
    triangle {
      < 0.063553, -0.838639, 0.349829>,
      < 0.093817, -0.835911, 0.309232>,
      < 0.093825, -0.848585, 0.348252>
    }
    triangle {
      < -0.264340, -0.833852, 0.350619>,
      < -0.264347, -0.822639, 0.316101>,
      < 0.063546, -0.826939, 0.313812>
    }
    triangle {
      < -0.264340, -0.833852, 0.350619>,
      < 0.063546, -0.826939, 0.313812>,
      < 0.063553, -0.838639, 0.349829>
    }
    triangle {
      < -0.360206, -0.799032, 0.356142>,
      < -0.360210, -0.791231, 0.332130>,
      < -0.264347, -0.822639, 0.316101>
    }
    triangle {
      < -0.360206, -0.799032, 0.356142>,
      < -0.264347, -0.822639, 0.316101>,
      < -0.264340, -0.833852, 0.350619>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360210, -0.791231, 0.332130>,
      < -0.360206, -0.799032, 0.356142>
    }
    triangle {
      < 1.415417, -0.754220, 0.350449>,
      < 1.415413, -0.746801, 0.340235>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314528, -0.754280, 0.350449>,
      < 1.314524, -0.746861, 0.340235>,
      < 1.415413, -0.746801, 0.340235>
    }
    triangle {
      < 1.314528, -0.754280, 0.350449>,
      < 1.415413, -0.746801, 0.340235>,
      < 1.415417, -0.754220, 0.350449>
    }
    triangle {
      < 1.284282, -0.790256, 0.332130>,
      < 1.284274, -0.775419, 0.311703>,
      < 1.314524, -0.746861, 0.340235>
    }
    triangle {
      < 1.284282, -0.790256, 0.332130>,
      < 1.314524, -0.746861, 0.340235>,
      < 1.314528, -0.754280, 0.350449>
    }
    triangle {
      < 1.198553, -0.835256, 0.309233>,
      < 1.198539, -0.811145, 0.276039>,
      < 1.284274, -0.775419, 0.311703>
    }
    triangle {
      < 1.198553, -0.835256, 0.309233>,
      < 1.284274, -0.775419, 0.311703>,
      < 1.284282, -0.790256, 0.332130>
    }
    triangle {
      < 0.093817, -0.835911, 0.309232>,
      < 0.093803, -0.811800, 0.276038>,
      < 1.198539, -0.811145, 0.276039>
    }
    triangle {
      < 0.093817, -0.835911, 0.309232>,
      < 1.198539, -0.811145, 0.276039>,
      < 1.198553, -0.835256, 0.309233>
    }
    triangle {
      < 0.063546, -0.826939, 0.313812>,
      < 0.063533, -0.804683, 0.283171>,
      < 0.093803, -0.811800, 0.276038>
    }
    triangle {
      < 0.063546, -0.826939, 0.313812>,
      < 0.093803, -0.811800, 0.276038>,
      < 0.093817, -0.835911, 0.309232>
    }
    triangle {
      < -0.264347, -0.822639, 0.316101>,
      < -0.264359, -0.801310, 0.286738>,
      < 0.063533, -0.804683, 0.283171>
    }
    triangle {
      < -0.264347, -0.822639, 0.316101>,
      < 0.063533, -0.804683, 0.283171>,
      < 0.063546, -0.826939, 0.313812>
    }
    triangle {
      < -0.360210, -0.791231, 0.332130>,
      < -0.360219, -0.776394, 0.311703>,
      < -0.264359, -0.801310, 0.286738>
    }
    triangle {
      < -0.360210, -0.791231, 0.332130>,
      < -0.264359, -0.801310, 0.286738>,
      < -0.264347, -0.822639, 0.316101>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360219, -0.776394, 0.311703>,
      < -0.360210, -0.791231, 0.332130>
    }
    triangle {
      < 1.415413, -0.746801, 0.340235>,
      < 1.415407, -0.736590, 0.332813>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314524, -0.746861, 0.340235>,
      < 1.314518, -0.736650, 0.332813>,
      < 1.415407, -0.736590, 0.332813>
    }
    triangle {
      < 1.314524, -0.746861, 0.340235>,
      < 1.415407, -0.736590, 0.332813>,
      < 1.415413, -0.746801, 0.340235>
    }
    triangle {
      < 1.284274, -0.775419, 0.311703>,
      < 1.284262, -0.754996, 0.296859>,
      < 1.314518, -0.736650, 0.332813>
    }
    triangle {
      < 1.284274, -0.775419, 0.311703>,
      < 1.314518, -0.736650, 0.332813>,
      < 1.314524, -0.746861, 0.340235>
    }
    triangle {
      < 1.198539, -0.811145, 0.276039>,
      < 1.198519, -0.777958, 0.251917>,
      < 1.284262, -0.754996, 0.296859>
    }
    triangle {
      < 1.198539, -0.811145, 0.276039>,
      < 1.284262, -0.754996, 0.296859>,
      < 1.284274, -0.775419, 0.311703>
    }
    triangle {
      < 0.093803, -0.811800, 0.276038>,
      < 0.093783, -0.778613, 0.251917>,
      < 1.198519, -0.777958, 0.251917>
    }
    triangle {
      < 0.093803, -0.811800, 0.276038>,
      < 1.198519, -0.777958, 0.251917>,
      < 1.198539, -0.811145, 0.276039>
    }
    triangle {
      < 0.063533, -0.804683, 0.283171>,
      < 0.063515, -0.774047, 0.260906>,
      < 0.093783, -0.778613, 0.251917>
    }
    triangle {
      < 0.063533, -0.804683, 0.283171>,
      < 0.093783, -0.778613, 0.251917>,
      < 0.093803, -0.811800, 0.276038>
    }
    triangle {
      < -0.264359, -0.801310, 0.286738>,
      < -0.264377, -0.771952, 0.265399>,
      < 0.063515, -0.774047, 0.260906>
    }
    triangle {
      < -0.264359, -0.801310, 0.286738>,
      < 0.063515, -0.774047, 0.260906>,
      < 0.063533, -0.804683, 0.283171>
    }
    triangle {
      < -0.360219, -0.776394, 0.311703>,
      < -0.360231, -0.755971, 0.296859>,
      < -0.264377, -0.771952, 0.265399>
    }
    triangle {
      < -0.360219, -0.776394, 0.311703>,
      < -0.264377, -0.771952, 0.265399>,
      < -0.264359, -0.801310, 0.286738>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360231, -0.755971, 0.296859>,
      < -0.360219, -0.776394, 0.311703>
    }
    triangle {
      < 1.415407, -0.736590, 0.332813>,
      < 1.415400, -0.724584, 0.328908>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314518, -0.736650, 0.332813>,
      < 1.314511, -0.724644, 0.328908>,
      < 1.415400, -0.724584, 0.328908>
    }
    triangle {
      < 1.314518, -0.736650, 0.332813>,
      < 1.415400, -0.724584, 0.328908>,
      < 1.415407, -0.736590, 0.332813>
    }
    triangle {
      < 1.284262, -0.754996, 0.296859>,
      < 1.284247, -0.730986, 0.289051>,
      < 1.314511, -0.724644, 0.328908>
    }
    triangle {
      < 1.284262, -0.754996, 0.296859>,
      < 1.314511, -0.724644, 0.328908>,
      < 1.314518, -0.736650, 0.332813>
    }
    triangle {
      < 1.198519, -0.777958, 0.251917>,
      < 1.198496, -0.738942, 0.239230>,
      < 1.284247, -0.730986, 0.289051>
    }
    triangle {
      < 1.198519, -0.777958, 0.251917>,
      < 1.284247, -0.730986, 0.289051>,
      < 1.284262, -0.754996, 0.296859>
    }
    triangle {
      < 0.093783, -0.778613, 0.251917>,
      < 0.093760, -0.739597, 0.239230>,
      < 1.198496, -0.738942, 0.239230>
    }
    triangle {
      < 0.093783, -0.778613, 0.251917>,
      < 1.198496, -0.738942, 0.239230>,
      < 1.198519, -0.777958, 0.251917>
    }
    triangle {
      < 0.063515, -0.774047, 0.260906>,
      < 0.063493, -0.738034, 0.249194>,
      < 0.093760, -0.739597, 0.239230>
    }
    triangle {
      < 0.063515, -0.774047, 0.260906>,
      < 0.093760, -0.739597, 0.239230>,
      < 0.093783, -0.778613, 0.251917>
    }
    triangle {
      < -0.264377, -0.771952, 0.265399>,
      < -0.264397, -0.737437, 0.254176>,
      < 0.063493, -0.738034, 0.249194>
    }
    triangle {
      < -0.264377, -0.771952, 0.265399>,
      < 0.063493, -0.738034, 0.249194>,
      < 0.063515, -0.774047, 0.260906>
    }
    triangle {
      < -0.360231, -0.755971, 0.296859>,
      < -0.360245, -0.731961, 0.289051>,
      < -0.264397, -0.737437, 0.254176>
    }
    triangle {
      < -0.360231, -0.755971, 0.296859>,
      < -0.264397, -0.737437, 0.254176>,
      < -0.264377, -0.771952, 0.265399>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360245, -0.731961, 0.289051>,
      < -0.360231, -0.755971, 0.296859>
    }
    triangle {
      < 1.415400, -0.724584, 0.328908>,
      < 1.415392, -0.711961, 0.328905>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314511, -0.724644, 0.328908>,
      < 1.314503, -0.712021, 0.328905>,
      < 1.415392, -0.711961, 0.328905>
    }
    triangle {
      < 1.314511, -0.724644, 0.328908>,
      < 1.415392, -0.711961, 0.328905>,
      < 1.415400, -0.724584, 0.328908>
    }
    triangle {
      < 1.284247, -0.730986, 0.289051>,
      < 1.284232, -0.705739, 0.289044>,
      < 1.314503, -0.712021, 0.328905>
    }
    triangle {
      < 1.284247, -0.730986, 0.289051>,
      < 1.314503, -0.712021, 0.328905>,
      < 1.314511, -0.724644, 0.328908>
    }
    triangle {
      < 1.198496, -0.738942, 0.239230>,
      < 1.198472, -0.697915, 0.239218>,
      < 1.284232, -0.705739, 0.289044>
    }
    triangle {
      < 1.198496, -0.738942, 0.239230>,
      < 1.284232, -0.705739, 0.289044>,
      < 1.284247, -0.730986, 0.289051>
    }
    triangle {
      < 0.093760, -0.739597, 0.239230>,
      < 0.093736, -0.698570, 0.239218>,
      < 1.198472, -0.697915, 0.239218>
    }
    triangle {
      < 0.093760, -0.739597, 0.239230>,
      < 1.198472, -0.697915, 0.239218>,
      < 1.198496, -0.738942, 0.239230>
    }
    triangle {
      < 0.063493, -0.738034, 0.249194>,
      < 0.063471, -0.700163, 0.249183>,
      < 0.093736, -0.698570, 0.239218>
    }
    triangle {
      < 0.063493, -0.738034, 0.249194>,
      < 0.093736, -0.698570, 0.239218>,
      < 0.093760, -0.739597, 0.239230>
    }
    triangle {
      < -0.264397, -0.737437, 0.254176>,
      < -0.264419, -0.701144, 0.254165>,
      < 0.063471, -0.700163, 0.249183>
    }
    triangle {
      < -0.264397, -0.737437, 0.254176>,
      < 0.063471, -0.700163, 0.249183>,
      < 0.063493, -0.738034, 0.249194>
    }
    triangle {
      < -0.360245, -0.731961, 0.289051>,
      < -0.360260, -0.706714, 0.289044>,
      < -0.264419, -0.701144, 0.254165>
    }
    triangle {
      < -0.360245, -0.731961, 0.289051>,
      < -0.264419, -0.701144, 0.254165>,
      < -0.264397, -0.737437, 0.254176>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360260, -0.706714, 0.289044>,
      < -0.360245, -0.731961, 0.289051>
    }
    triangle {
      < 1.415392, -0.711961, 0.328905>,
      < 1.415385, -0.699954, 0.332802>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314503, -0.712021, 0.328905>,
      < 1.314496, -0.700014, 0.332802>,
      < 1.415385, -0.699954, 0.332802>
    }
    triangle {
      < 1.314503, -0.712021, 0.328905>,
      < 1.415385, -0.699954, 0.332802>,
      < 1.415392, -0.711961, 0.328905>
    }
    triangle {
      < 1.284232, -0.705739, 0.289044>,
      < 1.284218, -0.681724, 0.296837>,
      < 1.314496, -0.700014, 0.332802>
    }
    triangle {
      < 1.284232, -0.705739, 0.289044>,
      < 1.314496, -0.700014, 0.332802>,
      < 1.314503, -0.712021, 0.328905>
    }
    triangle {
      < 1.198472, -0.697915, 0.239218>,
      < 1.198449, -0.658892, 0.251883>,
      < 1.284218, -0.681724, 0.296837>
    }
    triangle {
      < 1.198472, -0.697915, 0.239218>,
      < 1.284218, -0.681724, 0.296837>,
      < 1.284232, -0.705739, 0.289044>
    }
    triangle {
      < 0.093736, -0.698570, 0.239218>,
      < 0.093713, -0.659547, 0.251883>,
      < 1.198449, -0.658892, 0.251883>
    }
    triangle {
      < 0.093736, -0.698570, 0.239218>,
      < 1.198449, -0.658892, 0.251883>,
      < 1.198472, -0.697915, 0.239218>
    }
    triangle {
      < 0.063471, -0.700163, 0.249183>,
      < 0.063450, -0.664141, 0.260873>,
      < 0.093713, -0.659547, 0.251883>
    }
    triangle {
      < 0.063471, -0.700163, 0.249183>,
      < 0.093713, -0.659547, 0.251883>,
      < 0.093736, -0.698570, 0.239218>
    }
    triangle {
      < -0.264419, -0.701144, 0.254165>,
      < -0.264439, -0.666624, 0.265368>,
      < 0.063450, -0.664141, 0.260873>
    }
    triangle {
      < -0.264419, -0.701144, 0.254165>,
      < 0.063450, -0.664141, 0.260873>,
      < 0.063471, -0.700163, 0.249183>
    }
    triangle {
      < -0.360260, -0.706714, 0.289044>,
      < -0.360275, -0.682699, 0.296837>,
      < -0.264439, -0.666624, 0.265368>
    }
    triangle {
      < -0.360260, -0.706714, 0.289044>,
      < -0.264439, -0.666624, 0.265368>,
      < -0.264419, -0.701144, 0.254165>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360275, -0.682699, 0.296837>,
      < -0.360260, -0.706714, 0.289044>
    }
    triangle {
      < 1.415385, -0.699954, 0.332802>,
      < 1.415379, -0.689738, 0.340218>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314496, -0.700014, 0.332802>,
      < 1.314490, -0.689798, 0.340218>,
      < 1.415379, -0.689738, 0.340218>
    }
    triangle {
      < 1.314496, -0.700014, 0.332802>,
      < 1.415379, -0.689738, 0.340218>,
      < 1.415385, -0.699954, 0.332802>
    }
    triangle {
      < 1.284218, -0.681724, 0.296837>,
      < 1.284206, -0.661292, 0.311669>,
      < 1.314490, -0.689798, 0.340218>
    }
    triangle {
      < 1.284218, -0.681724, 0.296837>,
      < 1.314490, -0.689798, 0.340218>,
      < 1.314496, -0.700014, 0.332802>
    }
    triangle {
      < 1.198449, -0.658892, 0.251883>,
      < 1.198429, -0.625690, 0.275984>,
      < 1.284206, -0.661292, 0.311669>
    }
    triangle {
      < 1.198449, -0.658892, 0.251883>,
      < 1.284206, -0.661292, 0.311669>,
      < 1.284218, -0.681724, 0.296837>
    }
    triangle {
      < 0.093713, -0.659547, 0.251883>,
      < 0.093693, -0.626345, 0.275983>,
      < 1.198429, -0.625690, 0.275984>
    }
    triangle {
      < 0.093713, -0.659547, 0.251883>,
      < 1.198429, -0.625690, 0.275984>,
      < 1.198449, -0.658892, 0.251883>
    }
    triangle {
      < 0.063450, -0.664141, 0.260873>,
      < 0.063431, -0.633494, 0.283120>,
      < 0.093693, -0.626345, 0.275983>
    }
    triangle {
      < 0.063450, -0.664141, 0.260873>,
      < 0.093693, -0.626345, 0.275983>,
      < 0.093713, -0.659547, 0.251883>
    }
    triangle {
      < -0.264439, -0.666624, 0.265368>,
      < -0.264456, -0.637253, 0.286689>,
      < 0.063431, -0.633494, 0.283120>
    }
    triangle {
      < -0.264439, -0.666624, 0.265368>,
      < 0.063431, -0.633494, 0.283120>,
      < 0.063450, -0.664141, 0.260873>
    }
    triangle {
      < -0.360275, -0.682699, 0.296837>,
      < -0.360287, -0.662267, 0.311669>,
      < -0.264456, -0.637253, 0.286689>
    }
    triangle {
      < -0.360275, -0.682699, 0.296837>,
      < -0.264456, -0.637253, 0.286689>,
      < -0.264439, -0.666624, 0.265368>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360287, -0.662267, 0.311669>,
      < -0.360275, -0.682699, 0.296837>
    }
    triangle {
      < 1.415379, -0.689738, 0.340218>,
      < 1.415375, -0.682313, 0.350426>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314490, -0.689798, 0.340218>,
      < 1.314486, -0.682373, 0.350426>,
      < 1.415375, -0.682313, 0.350426>
    }
    triangle {
      < 1.314490, -0.689798, 0.340218>,
      < 1.415375, -0.682313, 0.350426>,
      < 1.415379, -0.689738, 0.340218>
    }
    triangle {
      < 1.284206, -0.661292, 0.311669>,
      < 1.284197, -0.646443, 0.332087>,
      < 1.314486, -0.682373, 0.350426>
    }
    triangle {
      < 1.284206, -0.661292, 0.311669>,
      < 1.314486, -0.682373, 0.350426>,
      < 1.314490, -0.689798, 0.340218>
    }
    triangle {
      < 1.198429, -0.625690, 0.275984>,
      < 1.198415, -0.601559, 0.309164>,
      < 1.284197, -0.646443, 0.332087>
    }
    triangle {
      < 1.198429, -0.625690, 0.275984>,
      < 1.284197, -0.646443, 0.332087>,
      < 1.284206, -0.661292, 0.311669>
    }
    triangle {
      < 0.093693, -0.626345, 0.275983>,
      < 0.093679, -0.602214, 0.309164>,
      < 1.198415, -0.601559, 0.309164>
    }
    triangle {
      < 0.093693, -0.626345, 0.275983>,
      < 1.198415, -0.601559, 0.309164>,
      < 1.198429, -0.625690, 0.275984>
    }
    triangle {
      < 0.063431, -0.633494, 0.283120>,
      < 0.063418, -0.611219, 0.313748>,
      < 0.093679, -0.602214, 0.309164>
    }
    triangle {
      < 0.063431, -0.633494, 0.283120>,
      < 0.093679, -0.602214, 0.309164>,
      < 0.093693, -0.626345, 0.275983>
    }
    triangle {
      < -0.264456, -0.637253, 0.286689>,
      < -0.264469, -0.615907, 0.316040>,
      < 0.063418, -0.611219, 0.313748>
    }
    triangle {
      < -0.264456, -0.637253, 0.286689>,
      < 0.063418, -0.611219, 0.313748>,
      < 0.063431, -0.633494, 0.283120>
    }
    triangle {
      < -0.360287, -0.662267, 0.311669>,
      < -0.360295, -0.647418, 0.332087>,
      < -0.264469, -0.615907, 0.316040>
    }
    triangle {
      < -0.360287, -0.662267, 0.311669>,
      < -0.264469, -0.615907, 0.316040>,
      < -0.264456, -0.637253, 0.286689>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360295, -0.647418, 0.332087>,
      < -0.360287, -0.662267, 0.311669>
    }
    triangle {
      < 1.415375, -0.682313, 0.350426>,
      < 1.415372, -0.678405, 0.362430>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314486, -0.682373, 0.350426>,
      < 1.314483, -0.678465, 0.362430>,
      < 1.415372, -0.678405, 0.362430>
    }
    triangle {
      < 1.314486, -0.682373, 0.350426>,
      < 1.415372, -0.678405, 0.362430>,
      < 1.415375, -0.682313, 0.350426>
    }
    triangle {
      < 1.284197, -0.646443, 0.332087>,
      < 1.284193, -0.638628, 0.356095>,
      < 1.314483, -0.678465, 0.362430>
    }
    triangle {
      < 1.284197, -0.646443, 0.332087>,
      < 1.314483, -0.678465, 0.362430>,
      < 1.314486, -0.682373, 0.350426>
    }
    triangle {
      < 1.198415, -0.601559, 0.309164>,
      < 1.198407, -0.588860, 0.348175>,
      < 1.284193, -0.638628, 0.356095>
    }
    triangle {
      < 1.198415, -0.601559, 0.309164>,
      < 1.284193, -0.638628, 0.356095>,
      < 1.284197, -0.646443, 0.332087>
    }
    triangle {
      < 0.093679, -0.602214, 0.309164>,
      < 0.093671, -0.589515, 0.348175>,
      < 1.198407, -0.588860, 0.348175>
    }
    triangle {
      < 0.093679, -0.602214, 0.309164>,
      < 1.198407, -0.588860, 0.348175>,
      < 1.198415, -0.601559, 0.309164>
    }
    triangle {
      < 0.063418, -0.611219, 0.313748>,
      < 0.063411, -0.599497, 0.349759>,
      < 0.093671, -0.589515, 0.348175>
    }
    triangle {
      < 0.063418, -0.611219, 0.313748>,
      < 0.093671, -0.589515, 0.348175>,
      < 0.093679, -0.602214, 0.309164>
    }
    triangle {
      < -0.264469, -0.615907, 0.316040>,
      < -0.264476, -0.604673, 0.350551>,
      < 0.063411, -0.599497, 0.349759>
    }
    triangle {
      < -0.264469, -0.615907, 0.316040>,
      < 0.063411, -0.599497, 0.349759>,
      < 0.063418, -0.611219, 0.313748>
    }
    triangle {
      < -0.360295, -0.647418, 0.332087>,
      < -0.360300, -0.639603, 0.356094>,
      < -0.264476, -0.604673, 0.350551>
    }
    triangle {
      < -0.360295, -0.647418, 0.332087>,
      < -0.264476, -0.604673, 0.350551>,
      < -0.264469, -0.615907, 0.316040>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360300, -0.639603, 0.356094>,
      < -0.360295, -0.647418, 0.332087>
    }
    triangle {
      < 1.415372, -0.678405, 0.362430>,
      < 1.415372, -0.678398, 0.375054>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314483, -0.678465, 0.362430>,
      < 1.314483, -0.678458, 0.375054>,
      < 1.415372, -0.678398, 0.375054>
    }
    triangle {
      < 1.314483, -0.678465, 0.362430>,
      < 1.415372, -0.678398, 0.375054>,
      < 1.415372, -0.678405, 0.362430>
    }
    triangle {
      < 1.284193, -0.638628, 0.356095>,
      < 1.284193, -0.638614, 0.381342>,
      < 1.314483, -0.678458, 0.375054>
    }
    triangle {
      < 1.284193, -0.638628, 0.356095>,
      < 1.314483, -0.678458, 0.375054>,
      < 1.314483, -0.678465, 0.362430>
    }
    triangle {
      < 1.198407, -0.588860, 0.348175>,
      < 1.198407, -0.588836, 0.389203>,
      < 1.284193, -0.638614, 0.381342>
    }
    triangle {
      < 1.198407, -0.588860, 0.348175>,
      < 1.284193, -0.638614, 0.381342>,
      < 1.284193, -0.638628, 0.356095>
    }
    triangle {
      < 0.093671, -0.589515, 0.348175>,
      < 0.093671, -0.589491, 0.389202>,
      < 1.198407, -0.588836, 0.389203>
    }
    triangle {
      < 0.093671, -0.589515, 0.348175>,
      < 1.198407, -0.588836, 0.389203>,
      < 1.198407, -0.588860, 0.348175>
    }
    triangle {
      < 0.063411, -0.599497, 0.349759>,
      < 0.063411, -0.599475, 0.387630>,
      < 0.093671, -0.589491, 0.389202>
    }
    triangle {
      < 0.063411, -0.599497, 0.349759>,
      < 0.093671, -0.589491, 0.389202>,
      < 0.093671, -0.589515, 0.348175>
    }
    triangle {
      < -0.264476, -0.604673, 0.350551>,
      < -0.264476, -0.604652, 0.386844>,
      < 0.063411, -0.599475, 0.387630>
    }
    triangle {
      < -0.264476, -0.604673, 0.350551>,
      < 0.063411, -0.599475, 0.387630>,
      < 0.063411, -0.599497, 0.349759>
    }
    triangle {
      < -0.360300, -0.639603, 0.356094>,
      < -0.360300, -0.639589, 0.381341>,
      < -0.264476, -0.604652, 0.386844>
    }
    triangle {
      < -0.360300, -0.639603, 0.356094>,
      < -0.264476, -0.604652, 0.386844>,
      < -0.264476, -0.604673, 0.350551>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360300, -0.639589, 0.381341>,
      < -0.360300, -0.639603, 0.356094>
    }
    triangle {
      < 1.415372, -0.678398, 0.375054>,
      < 1.415375, -0.682291, 0.387062>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314483, -0.678458, 0.375054>,
      < 1.314485, -0.682351, 0.387062>,
      < 1.415375, -0.682291, 0.387062>
    }
    triangle {
      < 1.314483, -0.678458, 0.375054>,
      < 1.415375, -0.682291, 0.387062>,
      < 1.415372, -0.678398, 0.375054>
    }
    triangle {
      < 1.284193, -0.638614, 0.381342>,
      < 1.284197, -0.646400, 0.405358>,
      < 1.314485, -0.682351, 0.387062>
    }
    triangle {
      < 1.284193, -0.638614, 0.381342>,
      < 1.314485, -0.682351, 0.387062>,
      < 1.314483, -0.678458, 0.375054>
    }
    triangle {
      < 1.198407, -0.588836, 0.389203>,
      < 1.198415, -0.601489, 0.428230>,
      < 1.284197, -0.646400, 0.405358>
    }
    triangle {
      < 1.198407, -0.588836, 0.389203>,
      < 1.284197, -0.646400, 0.405358>,
      < 1.284193, -0.638614, 0.381342>
    }
    triangle {
      < 0.093671, -0.589491, 0.389202>,
      < 0.093679, -0.602144, 0.428230>,
      < 1.198415, -0.601489, 0.428230>
    }
    triangle {
      < 0.093671, -0.589491, 0.389202>,
      < 1.198415, -0.601489, 0.428230>,
      < 1.198407, -0.588836, 0.389203>
    }
    triangle {
      < 0.063411, -0.599475, 0.387630>,
      < 0.063418, -0.611153, 0.423655>,
      < 0.093679, -0.602144, 0.428230>
    }
    triangle {
      < 0.063411, -0.599475, 0.387630>,
      < 0.093679, -0.602144, 0.428230>,
      < 0.093671, -0.589491, 0.389202>
    }
    triangle {
      < -0.264476, -0.604652, 0.386844>,
      < -0.264469, -0.615845, 0.421369>,
      < 0.063418, -0.611153, 0.423655>
    }
    triangle {
      < -0.264476, -0.604652, 0.386844>,
      < 0.063418, -0.611153, 0.423655>,
      < 0.063411, -0.599475, 0.387630>
    }
    triangle {
      < -0.360300, -0.639589, 0.381341>,
      < -0.360296, -0.647375, 0.405358>,
      < -0.264469, -0.615845, 0.421369>
    }
    triangle {
      < -0.360300, -0.639589, 0.381341>,
      < -0.264469, -0.615845, 0.421369>,
      < -0.264476, -0.604652, 0.386844>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360296, -0.647375, 0.405358>,
      < -0.360300, -0.639589, 0.381341>
    }
    triangle {
      < 1.415375, -0.682291, 0.387062>,
      < 1.415379, -0.689704, 0.397281>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314485, -0.682351, 0.387062>,
      < 1.314490, -0.689764, 0.397281>,
      < 1.415379, -0.689704, 0.397281>
    }
    triangle {
      < 1.314485, -0.682351, 0.387062>,
      < 1.415379, -0.689704, 0.397281>,
      < 1.415375, -0.682291, 0.387062>
    }
    triangle {
      < 1.284197, -0.646400, 0.405358>,
      < 1.284206, -0.661225, 0.425795>,
      < 1.314490, -0.689764, 0.397281>
    }
    triangle {
      < 1.284197, -0.646400, 0.405358>,
      < 1.314490, -0.689764, 0.397281>,
      < 1.314485, -0.682351, 0.387062>
    }
    triangle {
      < 1.198415, -0.601489, 0.428230>,
      < 1.198429, -0.625580, 0.461439>,
      < 1.284206, -0.661225, 0.425795>
    }
    triangle {
      < 1.198415, -0.601489, 0.428230>,
      < 1.284206, -0.661225, 0.425795>,
      < 1.284197, -0.646400, 0.405358>
    }
    triangle {
      < 0.093679, -0.602144, 0.428230>,
      < 0.093693, -0.626235, 0.461438>,
      < 1.198429, -0.625580, 0.461439>
    }
    triangle {
      < 0.093679, -0.602144, 0.428230>,
      < 1.198429, -0.625580, 0.461439>,
      < 1.198415, -0.601489, 0.428230>
    }
    triangle {
      < 0.063418, -0.611153, 0.423655>,
      < 0.063431, -0.633391, 0.454309>,
      < 0.093693, -0.626235, 0.461438>
    }
    triangle {
      < 0.063418, -0.611153, 0.423655>,
      < 0.093693, -0.626235, 0.461438>,
      < 0.093679, -0.602144, 0.428230>
    }
    triangle {
      < -0.264469, -0.615845, 0.421369>,
      < -0.264457, -0.637156, 0.450745>,
      < 0.063431, -0.633391, 0.454309>
    }
    triangle {
      < -0.264469, -0.615845, 0.421369>,
      < 0.063431, -0.633391, 0.454309>,
      < 0.063418, -0.611153, 0.423655>
    }
    triangle {
      < -0.360296, -0.647375, 0.405358>,
      < -0.360287, -0.662200, 0.425795>,
      < -0.264457, -0.637156, 0.450745>
    }
    triangle {
      < -0.360296, -0.647375, 0.405358>,
      < -0.264457, -0.637156, 0.450745>,
      < -0.264469, -0.615845, 0.421369>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360287, -0.662200, 0.425795>,
      < -0.360296, -0.647375, 0.405358>
    }
    triangle {
      < 1.415379, -0.689704, 0.397281>,
      < 1.415385, -0.699911, 0.404708>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314490, -0.689764, 0.397281>,
      < 1.314496, -0.699971, 0.404708>,
      < 1.415385, -0.699911, 0.404708>
    }
    triangle {
      < 1.314490, -0.689764, 0.397281>,
      < 1.415385, -0.699911, 0.404708>,
      < 1.415379, -0.689704, 0.397281>
    }
    triangle {
      < 1.284206, -0.661225, 0.425795>,
      < 1.284218, -0.681640, 0.440651>,
      < 1.314496, -0.699971, 0.404708>
    }
    triangle {
      < 1.284206, -0.661225, 0.425795>,
      < 1.314496, -0.699971, 0.404708>,
      < 1.314490, -0.689764, 0.397281>
    }
    triangle {
      < 1.198429, -0.625580, 0.461439>,
      < 1.198449, -0.658753, 0.485579>,
      < 1.284218, -0.681640, 0.440651>
    }
    triangle {
      < 1.198429, -0.625580, 0.461439>,
      < 1.284218, -0.681640, 0.440651>,
      < 1.284206, -0.661225, 0.425795>
    }
    triangle {
      < 0.093693, -0.626235, 0.461438>,
      < 0.093713, -0.659408, 0.485579>,
      < 1.198449, -0.658753, 0.485579>
    }
    triangle {
      < 0.093693, -0.626235, 0.461438>,
      < 1.198449, -0.658753, 0.485579>,
      < 1.198429, -0.625580, 0.461439>
    }
    triangle {
      < 0.063431, -0.633391, 0.454309>,
      < 0.063449, -0.664013, 0.476593>,
      < 0.093713, -0.659408, 0.485579>
    }
    triangle {
      < 0.063431, -0.633391, 0.454309>,
      < 0.093713, -0.659408, 0.485579>,
      < 0.093693, -0.626235, 0.461438>
    }
    triangle {
      < -0.264457, -0.637156, 0.450745>,
      < -0.264439, -0.666501, 0.472100>,
      < 0.063449, -0.664013, 0.476593>
    }
    triangle {
      < -0.264457, -0.637156, 0.450745>,
      < 0.063449, -0.664013, 0.476593>,
      < 0.063431, -0.633391, 0.454309>
    }
    triangle {
      < -0.360287, -0.662200, 0.425795>,
      < -0.360275, -0.682615, 0.440651>,
      < -0.264439, -0.666501, 0.472100>
    }
    triangle {
      < -0.360287, -0.662200, 0.425795>,
      < -0.264439, -0.666501, 0.472100>,
      < -0.264457, -0.637156, 0.450745>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360275, -0.682615, 0.440651>,
      < -0.360287, -0.662200, 0.425795>
    }
    triangle {
      < 1.415385, -0.699911, 0.404708>,
      < 1.415392, -0.711914, 0.408619>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314496, -0.699971, 0.404708>,
      < 1.314503, -0.711974, 0.408619>,
      < 1.415392, -0.711914, 0.408619>
    }
    triangle {
      < 1.314496, -0.699971, 0.404708>,
      < 1.415392, -0.711914, 0.408619>,
      < 1.415385, -0.699911, 0.404708>
    }
    triangle {
      < 1.284218, -0.681640, 0.440651>,
      < 1.284232, -0.705644, 0.448473>,
      < 1.314503, -0.711974, 0.408619>
    }
    triangle {
      < 1.284218, -0.681640, 0.440651>,
      < 1.314503, -0.711974, 0.408619>,
      < 1.314496, -0.699971, 0.404708>
    }
    triangle {
      < 1.198449, -0.658753, 0.485579>,
      < 1.198472, -0.697762, 0.498289>,
      < 1.284232, -0.705644, 0.448473>
    }
    triangle {
      < 1.198449, -0.658753, 0.485579>,
      < 1.284232, -0.705644, 0.448473>,
      < 1.284218, -0.681640, 0.440651>
    }
    triangle {
      < 0.093713, -0.659408, 0.485579>,
      < 0.093736, -0.698417, 0.498289>,
      < 1.198472, -0.697762, 0.498289>
    }
    triangle {
      < 0.093713, -0.659408, 0.485579>,
      < 1.198472, -0.697762, 0.498289>,
      < 1.198449, -0.658753, 0.485579>
    }
    triangle {
      < 0.063449, -0.664013, 0.476593>,
      < 0.063471, -0.700021, 0.488326>,
      < 0.093736, -0.698417, 0.498289>
    }
    triangle {
      < 0.063449, -0.664013, 0.476593>,
      < 0.093736, -0.698417, 0.498289>,
      < 0.093713, -0.659408, 0.485579>
    }
    triangle {
      < -0.264439, -0.666501, 0.472100>,
      < -0.264419, -0.701008, 0.483343>,
      < 0.063471, -0.700021, 0.488326>
    }
    triangle {
      < -0.264439, -0.666501, 0.472100>,
      < 0.063471, -0.700021, 0.488326>,
      < 0.063449, -0.664013, 0.476593>
    }
    triangle {
      < -0.360275, -0.682615, 0.440651>,
      < -0.360260, -0.706619, 0.448473>,
      < -0.264419, -0.701008, 0.483343>
    }
    triangle {
      < -0.360275, -0.682615, 0.440651>,
      < -0.264419, -0.701008, 0.483343>,
      < -0.264439, -0.666501, 0.472100>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360260, -0.706619, 0.448473>,
      < -0.360275, -0.682615, 0.440651>
    }
    triangle {
      < 1.415392, -0.711914, 0.408619>,
      < 1.415400, -0.724537, 0.408630>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314503, -0.711974, 0.408619>,
      < 1.314510, -0.724597, 0.408630>,
      < 1.415400, -0.724537, 0.408630>
    }
    triangle {
      < 1.314503, -0.711974, 0.408619>,
      < 1.415400, -0.724537, 0.408630>,
      < 1.415392, -0.711914, 0.408619>
    }
    triangle {
      < 1.284232, -0.705644, 0.448473>,
      < 1.284247, -0.730892, 0.448495>,
      < 1.314510, -0.724597, 0.408630>
    }
    triangle {
      < 1.284232, -0.705644, 0.448473>,
      < 1.314510, -0.724597, 0.408630>,
      < 1.314503, -0.711974, 0.408619>
    }
    triangle {
      < 1.198472, -0.697762, 0.498289>,
      < 1.198496, -0.738788, 0.498326>,
      < 1.284247, -0.730892, 0.448495>
    }
    triangle {
      < 1.198472, -0.697762, 0.498289>,
      < 1.284247, -0.730892, 0.448495>,
      < 1.284232, -0.705644, 0.448473>
    }
    triangle {
      < 0.093736, -0.698417, 0.498289>,
      < 0.093760, -0.739443, 0.498326>,
      < 1.198496, -0.738788, 0.498326>
    }
    triangle {
      < 0.093736, -0.698417, 0.498289>,
      < 1.198496, -0.738788, 0.498326>,
      < 1.198472, -0.697762, 0.498289>
    }
    triangle {
      < 0.063471, -0.700021, 0.488326>,
      < 0.063493, -0.737892, 0.488359>,
      < 0.093760, -0.739443, 0.498326>
    }
    triangle {
      < 0.063471, -0.700021, 0.488326>,
      < 0.093760, -0.739443, 0.498326>,
      < 0.093736, -0.698417, 0.498289>
    }
    triangle {
      < -0.264419, -0.701008, 0.483343>,
      < -0.264397, -0.737302, 0.483377>,
      < 0.063493, -0.737892, 0.488359>
    }
    triangle {
      < -0.264419, -0.701008, 0.483343>,
      < 0.063493, -0.737892, 0.488359>,
      < 0.063471, -0.700021, 0.488326>
    }
    triangle {
      < -0.360260, -0.706619, 0.448473>,
      < -0.360245, -0.731867, 0.448495>,
      < -0.264397, -0.737302, 0.483377>
    }
    triangle {
      < -0.360260, -0.706619, 0.448473>,
      < -0.264397, -0.737302, 0.483377>,
      < -0.264419, -0.701008, 0.483343>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360245, -0.731867, 0.448495>,
      < -0.360260, -0.706619, 0.448473>
    }
    triangle {
      < 1.415400, -0.724537, 0.408630>,
      < 1.415407, -0.736547, 0.404741>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314510, -0.724597, 0.408630>,
      < 1.314518, -0.736607, 0.404741>,
      < 1.415407, -0.736547, 0.404741>
    }
    triangle {
      < 1.314510, -0.724597, 0.408630>,
      < 1.415407, -0.736547, 0.404741>,
      < 1.415400, -0.724537, 0.408630>
    }
    triangle {
      < 1.284247, -0.730892, 0.448495>,
      < 1.284261, -0.754911, 0.440716>,
      < 1.314518, -0.736607, 0.404741>
    }
    triangle {
      < 1.284247, -0.730892, 0.448495>,
      < 1.314518, -0.736607, 0.404741>,
      < 1.314510, -0.724597, 0.408630>
    }
    triangle {
      < 1.198496, -0.738788, 0.498326>,
      < 1.198519, -0.777819, 0.485685>,
      < 1.284261, -0.754911, 0.440716>
    }
    triangle {
      < 1.198496, -0.738788, 0.498326>,
      < 1.284261, -0.754911, 0.440716>,
      < 1.284247, -0.730892, 0.448495>
    }
    triangle {
      < 0.093760, -0.739443, 0.498326>,
      < 0.093783, -0.778474, 0.485684>,
      < 1.198519, -0.777819, 0.485685>
    }
    triangle {
      < 0.093760, -0.739443, 0.498326>,
      < 1.198519, -0.777819, 0.485685>,
      < 1.198496, -0.738788, 0.498326>
    }
    triangle {
      < 0.063493, -0.737892, 0.488359>,
      < 0.063515, -0.773919, 0.476691>,
      < 0.093783, -0.778474, 0.485684>
    }
    triangle {
      < 0.063493, -0.737892, 0.488359>,
      < 0.093783, -0.778474, 0.485684>,
      < 0.093760, -0.739443, 0.498326>
    }
    triangle {
      < -0.264397, -0.737302, 0.483377>,
      < -0.264377, -0.771829, 0.472193>,
      < 0.063515, -0.773919, 0.476691>
    }
    triangle {
      < -0.264397, -0.737302, 0.483377>,
      < 0.063515, -0.773919, 0.476691>,
      < 0.063493, -0.737892, 0.488359>
    }
    triangle {
      < -0.360245, -0.731867, 0.448495>,
      < -0.360231, -0.755886, 0.440716>,
      < -0.264377, -0.771829, 0.472193>
    }
    triangle {
      < -0.360245, -0.731867, 0.448495>,
      < -0.264377, -0.771829, 0.472193>,
      < -0.264397, -0.737302, 0.483377>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360231, -0.755886, 0.440716>,
      < -0.360245, -0.731867, 0.448495>
    }
    triangle {
      < 1.415407, -0.736547, 0.404741>,
      < 1.415413, -0.746801, 0.397298>,
      < 1.415396, -0.718261, 0.368766>
    }
    triangle {
      < 1.314518, -0.736607, 0.404741>,
      < 1.314524, -0.746861, 0.397298>,
      < 1.415413, -0.746801, 0.397298>
    }
    triangle {
      < 1.314518, -0.736607, 0.404741>,
      < 1.415413, -0.746801, 0.397298>,
      < 1.415407, -0.736547, 0.404741>
    }
    triangle {
      < 1.284261, -0.754911, 0.440716>,
      < 1.284274, -0.775419, 0.425829>,
      < 1.314524, -0.746861, 0.397298>
    }
    triangle {
      < 1.284261, -0.754911, 0.440716>,
      < 1.314524, -0.746861, 0.397298>,
      < 1.314518, -0.736607, 0.404741>
    }
    triangle {
      < 1.198519, -0.777819, 0.485685>,
      < 1.198539, -0.811145, 0.461494>,
      < 1.284274, -0.775419, 0.425829>
    }
    triangle {
      < 1.198519, -0.777819, 0.485685>,
      < 1.284274, -0.775419, 0.425829>,
      < 1.284261, -0.754911, 0.440716>
    }
    triangle {
      < 0.093783, -0.778474, 0.485684>,
      < 0.093803, -0.811800, 0.461493>,
      < 1.198539, -0.811145, 0.461494>
    }
    triangle {
      < 0.093783, -0.778474, 0.485684>,
      < 1.198539, -0.811145, 0.461494>,
      < 1.198519, -0.777819, 0.485685>
    }
    triangle {
      < 0.063515, -0.773919, 0.476691>,
      < 0.063533, -0.804682, 0.454361>,
      < 0.093803, -0.811800, 0.461493>
    }
    triangle {
      < 0.063515, -0.773919, 0.476691>,
      < 0.093803, -0.811800, 0.461493>,
      < 0.093783, -0.778474, 0.485684>
    }
    triangle {
      < -0.264377, -0.771829, 0.472193>,
      < -0.264359, -0.801310, 0.450794>,
      < 0.063533, -0.804682, 0.454361>
    }
    triangle {
      < -0.264377, -0.771829, 0.472193>,
      < 0.063533, -0.804682, 0.454361>,
      < 0.063515, -0.773919, 0.476691>
    }
    triangle {
      < -0.360231, -0.755886, 0.440716>,
      < -0.360219, -0.776394, 0.425829>,
      < -0.264359, -0.801310, 0.450794>
    }
    triangle {
      < -0.360231, -0.755886, 0.440716>,
      < -0.264359, -0.801310, 0.450794>,
      < -0.264377, -0.771829, 0.472193>
    }
    triangle {
      < -0.425831, -0.719352, 0.368766>,
      < -0.360219, -0.776394, 0.425829>,
      < -0.360231, -0.755886, 0.440716>
    }
    triangle {
      < -0.307759, -0.895963, 0.169848>,
      < -0.307863, -0.720272, 0.345486>,
      < -0.077679, -0.720135, 0.345486>
    }
    triangle {
      < -0.307759, -0.895963, 0.169848>,
      < -0.077679, -0.720135, 0.345486>,
      < -0.077575, -0.895826, 0.169848>
    }
    triangle {
      < -0.077562, -0.918117, 0.192144>,
      < -0.077666, -0.742426, 0.367783>,
      < -0.307850, -0.742563, 0.367783>
    }
    triangle {
      < -0.077562, -0.918117, 0.192144>,
      < -0.307850, -0.742563, 0.367783>,
      < -0.307746, -0.918253, 0.192144>
    }
    triangle {
      < -0.307746, -0.918253, 0.192144>,
      < -0.307850, -0.742563, 0.367783>,
      < -0.307863, -0.720272, 0.345486>
    }
    triangle {
      < -0.307746, -0.918253, 0.192144>,
      < -0.307863, -0.720272, 0.345486>,
      < -0.307759, -0.895963, 0.169848>
    }
    triangle {
      < -0.307746, -0.918253, 0.192144>,
      < -0.307759, -0.895963, 0.169848>,
      < -0.077575, -0.895826, 0.169848>
    }
    triangle {
      < -0.307746, -0.918253, 0.192144>,
      < -0.077575, -0.895826, 0.169848>,
      < -0.077562, -0.918117, 0.192144>
    }
    triangle {
      < -0.077575, -0.895826, 0.169848>,
      < -0.077679, -0.720135, 0.345486>,
      < -0.077666, -0.742426, 0.367783>
    }
    triangle {
      < -0.077575, -0.895826, 0.169848>,
      < -0.077666, -0.742426, 0.367783>,
      < -0.077562, -0.918117, 0.192144>
    }
    triangle {
      < -0.307863, -0.720272, 0.345486>,
      < -0.307850, -0.742563, 0.367783>,
      < -0.077666, -0.742426, 0.367783>
    }
    triangle {
      < -0.307863, -0.720272, 0.345486>,
      < -0.077666, -0.742426, 0.367783>,
      < -0.077679, -0.720135, 0.345486>
    }
    triangle {
      < 0.019228, -0.895769, 0.169848>,
      < 0.019124, -0.720078, 0.345486>,
      < 0.249307, -0.719941, 0.345486>
    }
    triangle {
      < 0.019228, -0.895769, 0.169848>,
      < 0.249307, -0.719941, 0.345486>,
      < 0.249411, -0.895632, 0.169848>
    }
    triangle {
      < 0.249424, -0.917923, 0.192144>,
      < 0.249320, -0.742232, 0.367783>,
      < 0.019137, -0.742369, 0.367783>
    }
    triangle {
      < 0.249424, -0.917923, 0.192144>,
      < 0.019137, -0.742369, 0.367783>,
      < 0.019241, -0.918060, 0.192144>
    }
    triangle {
      < 0.019241, -0.918060, 0.192144>,
      < 0.019137, -0.742369, 0.367783>,
      < 0.019124, -0.720078, 0.345486>
    }
    triangle {
      < 0.019241, -0.918060, 0.192144>,
      < 0.019124, -0.720078, 0.345486>,
      < 0.019228, -0.895769, 0.169848>
    }
    triangle {
      < 0.019241, -0.918060, 0.192144>,
      < 0.019228, -0.895769, 0.169848>,
      < 0.249411, -0.895632, 0.169848>
    }
    triangle {
      < 0.019241, -0.918060, 0.192144>,
      < 0.249411, -0.895632, 0.169848>,
      < 0.249424, -0.917923, 0.192144>
    }
    triangle {
      < 0.249411, -0.895632, 0.169848>,
      < 0.249307, -0.719941, 0.345486>,
      < 0.249320, -0.742232, 0.367783>
    }
    triangle {
      < 0.249411, -0.895632, 0.169848>,
      < 0.249320, -0.742232, 0.367783>,
      < 0.249424, -0.917923, 0.192144>
    }
    triangle {
      < 0.019124, -0.720078, 0.345486>,
      < 0.019137, -0.742369, 0.367783>,
      < 0.249320, -0.742232, 0.367783>
    }
    triangle {
      < 0.019124, -0.720078, 0.345486>,
      < 0.249320, -0.742232, 0.367783>,
      < 0.249307, -0.719941, 0.345486>
    }
    triangle {
      < -0.307982, -0.520417, 0.192026>,
      < -0.307878, -0.696003, 0.367769>,
      < -0.077694, -0.695866, 0.367769>
    }
    triangle {
      < -0.307982, -0.520417, 0.192026>,
      < -0.077694, -0.695866, 0.367769>,
      < -0.077798, -0.520280, 0.192026>
    }
    triangle {
      < -0.077784, -0.542583, 0.169742>,
      < -0.077680, -0.718170, 0.345485>,
      < -0.307864, -0.718307, 0.345485>
    }
    triangle {
      < -0.077784, -0.542583, 0.169742>,
      < -0.307864, -0.718307, 0.345485>,
      < -0.307968, -0.542720, 0.169742>
    }
    triangle {
      < -0.307968, -0.542720, 0.169742>,
      < -0.307864, -0.718307, 0.345485>,
      < -0.307878, -0.696003, 0.367769>
    }
    triangle {
      < -0.307968, -0.542720, 0.169742>,
      < -0.307878, -0.696003, 0.367769>,
      < -0.307982, -0.520417, 0.192026>
    }
    triangle {
      < -0.307968, -0.542720, 0.169742>,
      < -0.307982, -0.520417, 0.192026>,
      < -0.077798, -0.520280, 0.192026>
    }
    triangle {
      < -0.307968, -0.542720, 0.169742>,
      < -0.077798, -0.520280, 0.192026>,
      < -0.077784, -0.542583, 0.169742>
    }
    triangle {
      < -0.077798, -0.520280, 0.192026>,
      < -0.077694, -0.695866, 0.367769>,
      < -0.077680, -0.718170, 0.345485>
    }
    triangle {
      < -0.077798, -0.520280, 0.192026>,
      < -0.077680, -0.718170, 0.345485>,
      < -0.077784, -0.542583, 0.169742>
    }
    triangle {
      < -0.307878, -0.696003, 0.367769>,
      < -0.307864, -0.718307, 0.345485>,
      < -0.077680, -0.718170, 0.345485>
    }
    triangle {
      < -0.307878, -0.696003, 0.367769>,
      < -0.077680, -0.718170, 0.345485>,
      < -0.077694, -0.695866, 0.367769>
    }
    triangle {
      < 0.019005, -0.520223, 0.192026>,
      < 0.019109, -0.695809, 0.367769>,
      < 0.249292, -0.695672, 0.367769>
    }
    triangle {
      < 0.019005, -0.520223, 0.192026>,
      < 0.249292, -0.695672, 0.367769>,
      < 0.249188, -0.520086, 0.192026>
    }
    triangle {
      < 0.249201, -0.542389, 0.169742>,
      < 0.249305, -0.717976, 0.345485>,
      < 0.019123, -0.718113, 0.345485>
    }
    triangle {
      < 0.249201, -0.542389, 0.169742>,
      < 0.019123, -0.718113, 0.345485>,
      < 0.019018, -0.542526, 0.169742>
    }
    triangle {
      < 0.019018, -0.542526, 0.169742>,
      < 0.019123, -0.718113, 0.345485>,
      < 0.019109, -0.695809, 0.367769>
    }
    triangle {
      < 0.019018, -0.542526, 0.169742>,
      < 0.019109, -0.695809, 0.367769>,
      < 0.019005, -0.520223, 0.192026>
    }
    triangle {
      < 0.019018, -0.542526, 0.169742>,
      < 0.019005, -0.520223, 0.192026>,
      < 0.249188, -0.520086, 0.192026>
    }
    triangle {
      < 0.019018, -0.542526, 0.169742>,
      < 0.249188, -0.520086, 0.192026>,
      < 0.249201, -0.542389, 0.169742>
    }
    triangle {
      < 0.249188, -0.520086, 0.192026>,
      < 0.249292, -0.695672, 0.367769>,
      < 0.249305, -0.717976, 0.345485>
    }
    triangle {
      < 0.249188, -0.520086, 0.192026>,
      < 0.249305, -0.717976, 0.345485>,
      < 0.249201, -0.542389, 0.169742>
    }
    triangle {
      < 0.019109, -0.695809, 0.367769>,
      < 0.019123, -0.718113, 0.345485>,
      < 0.249305, -0.717976, 0.345485>
    }
    triangle {
      < 0.019109, -0.695809, 0.367769>,
      < 0.249305, -0.717976, 0.345485>,
      < 0.249292, -0.695672, 0.367769>
    }
    triangle {
      < -0.307969, -0.542485, 0.567579>,
      < -0.307864, -0.718279, 0.392044>,
      < -0.077680, -0.718142, 0.392044>
    }
    triangle {
      < -0.307969, -0.542485, 0.567579>,
      < -0.077680, -0.718142, 0.392044>,
      < -0.077785, -0.542348, 0.567579>
    }
    triangle {
      < -0.077798, -0.520071, 0.545269>,
      < -0.077694, -0.695866, 0.369735>,
      < -0.307878, -0.696003, 0.369735>
    }
    triangle {
      < -0.077798, -0.520071, 0.545269>,
      < -0.307878, -0.696003, 0.369735>,
      < -0.307982, -0.520208, 0.545269>
    }
    triangle {
      < -0.307982, -0.520208, 0.545269>,
      < -0.307878, -0.696003, 0.369735>,
      < -0.307864, -0.718279, 0.392044>
    }
    triangle {
      < -0.307982, -0.520208, 0.545269>,
      < -0.307864, -0.718279, 0.392044>,
      < -0.307969, -0.542485, 0.567579>
    }
    triangle {
      < -0.307982, -0.520208, 0.545269>,
      < -0.307969, -0.542485, 0.567579>,
      < -0.077785, -0.542348, 0.567579>
    }
    triangle {
      < -0.307982, -0.520208, 0.545269>,
      < -0.077785, -0.542348, 0.567579>,
      < -0.077798, -0.520071, 0.545269>
    }
    triangle {
      < -0.077785, -0.542348, 0.567579>,
      < -0.077680, -0.718142, 0.392044>,
      < -0.077694, -0.695866, 0.369735>
    }
    triangle {
      < -0.077785, -0.542348, 0.567579>,
      < -0.077694, -0.695866, 0.369735>,
      < -0.077798, -0.520071, 0.545269>
    }
    triangle {
      < -0.307864, -0.718279, 0.392044>,
      < -0.307878, -0.696003, 0.369735>,
      < -0.077694, -0.695866, 0.369735>
    }
    triangle {
      < -0.307864, -0.718279, 0.392044>,
      < -0.077694, -0.695866, 0.369735>,
      < -0.077680, -0.718142, 0.392044>
    }
    triangle {
      < 0.019018, -0.542291, 0.567579>,
      < 0.019122, -0.718085, 0.392044>,
      < 0.249305, -0.717948, 0.392044>
    }
    triangle {
      < 0.019018, -0.542291, 0.567579>,
      < 0.249305, -0.717948, 0.392044>,
      < 0.249201, -0.542154, 0.567579>
    }
    triangle {
      < 0.249188, -0.519877, 0.545269>,
      < 0.249292, -0.695672, 0.369735>,
      < 0.019109, -0.695809, 0.369735>
    }
    triangle {
      < 0.249188, -0.519877, 0.545269>,
      < 0.019109, -0.695809, 0.369735>,
      < 0.019005, -0.520014, 0.545269>
    }
    triangle {
      < 0.019005, -0.520014, 0.545269>,
      < 0.019109, -0.695809, 0.369735>,
      < 0.019122, -0.718085, 0.392044>
    }
    triangle {
      < 0.019005, -0.520014, 0.545269>,
      < 0.019122, -0.718085, 0.392044>,
      < 0.019018, -0.542291, 0.567579>
    }
    triangle {
      < 0.019005, -0.520014, 0.545269>,
      < 0.019018, -0.542291, 0.567579>,
      < 0.249201, -0.542154, 0.567579>
    }
    triangle {
      < 0.019005, -0.520014, 0.545269>,
      < 0.249201, -0.542154, 0.567579>,
      < 0.249188, -0.519877, 0.545269>
    }
    triangle {
      < 0.249201, -0.542154, 0.567579>,
      < 0.249305, -0.717948, 0.392044>,
      < 0.249292, -0.695672, 0.369735>
    }
    triangle {
      < 0.249201, -0.542154, 0.567579>,
      < 0.249292, -0.695672, 0.369735>,
      < 0.249188, -0.519877, 0.545269>
    }
    triangle {
      < 0.019122, -0.718085, 0.392044>,
      < 0.019109, -0.695809, 0.369735>,
      < 0.249292, -0.695672, 0.369735>
    }
    triangle {
      < 0.019122, -0.718085, 0.392044>,
      < 0.249292, -0.695672, 0.369735>,
      < 0.249305, -0.717948, 0.392044>
    }
    triangle {
      < -0.307746, -0.918043, 0.545623>,
      < -0.307850, -0.742562, 0.369776>,
      < -0.077666, -0.742425, 0.369776>
    }
    triangle {
      < -0.307746, -0.918043, 0.545623>,
      < -0.077666, -0.742425, 0.369776>,
      < -0.077562, -0.917907, 0.545623>
    }
    triangle {
      < -0.077575, -0.895590, 0.567894>,
      < -0.077679, -0.720108, 0.392046>,
      < -0.307863, -0.720245, 0.392046>
    }
    triangle {
      < -0.077575, -0.895590, 0.567894>,
      < -0.307863, -0.720245, 0.392046>,
      < -0.307759, -0.895727, 0.567894>
    }
    triangle {
      < -0.307759, -0.895727, 0.567894>,
      < -0.307863, -0.720245, 0.392046>,
      < -0.307850, -0.742562, 0.369776>
    }
    triangle {
      < -0.307759, -0.895727, 0.567894>,
      < -0.307850, -0.742562, 0.369776>,
      < -0.307746, -0.918043, 0.545623>
    }
    triangle {
      < -0.307759, -0.895727, 0.567894>,
      < -0.307746, -0.918043, 0.545623>,
      < -0.077562, -0.917907, 0.545623>
    }
    triangle {
      < -0.307759, -0.895727, 0.567894>,
      < -0.077562, -0.917907, 0.545623>,
      < -0.077575, -0.895590, 0.567894>
    }
    triangle {
      < -0.077562, -0.917907, 0.545623>,
      < -0.077666, -0.742425, 0.369776>,
      < -0.077679, -0.720108, 0.392046>
    }
    triangle {
      < -0.077562, -0.917907, 0.545623>,
      < -0.077679, -0.720108, 0.392046>,
      < -0.077575, -0.895590, 0.567894>
    }
    triangle {
      < -0.307850, -0.742562, 0.369776>,
      < -0.307863, -0.720245, 0.392046>,
      < -0.077679, -0.720108, 0.392046>
    }
    triangle {
      < -0.307850, -0.742562, 0.369776>,
      < -0.077679, -0.720108, 0.392046>,
      < -0.077666, -0.742425, 0.369776>
    }
    triangle {
      < 0.019241, -0.917850, 0.545623>,
      < 0.019137, -0.742368, 0.369776>,
      < 0.249320, -0.742231, 0.369776>
    }
    triangle {
      < 0.019241, -0.917850, 0.545623>,
      < 0.249320, -0.742231, 0.369776>,
      < 0.249424, -0.917713, 0.545623>
    }
    triangle {
      < 0.249411, -0.895396, 0.567894>,
      < 0.249307, -0.719914, 0.392046>,
      < 0.019124, -0.720051, 0.392046>
    }
    triangle {
      < 0.249411, -0.895396, 0.567894>,
      < 0.019124, -0.720051, 0.392046>,
      < 0.019228, -0.895533, 0.567894>
    }
    triangle {
      < 0.019228, -0.895533, 0.567894>,
      < 0.019124, -0.720051, 0.392046>,
      < 0.019137, -0.742368, 0.369776>
    }
    triangle {
      < 0.019228, -0.895533, 0.567894>,
      < 0.019137, -0.742368, 0.369776>,
      < 0.019241, -0.917850, 0.545623>
    }
    triangle {
      < 0.019228, -0.895533, 0.567894>,
      < 0.019241, -0.917850, 0.545623>,
      < 0.249424, -0.917713, 0.545623>
    }
    triangle {
      < 0.019228, -0.895533, 0.567894>,
      < 0.249424, -0.917713, 0.545623>,
      < 0.249411, -0.895396, 0.567894>
    }
    triangle {
      < 0.249424, -0.917713, 0.545623>,
      < 0.249320, -0.742231, 0.369776>,
      < 0.249307, -0.719914, 0.392046>
    }
    triangle {
      < 0.249424, -0.917713, 0.545623>,
      < 0.249307, -0.719914, 0.392046>,
      < 0.249411, -0.895396, 0.567894>
    }
    triangle {
      < 0.019137, -0.742368, 0.369776>,
      < 0.019124, -0.720051, 0.392046>,
      < 0.249307, -0.719914, 0.392046>
    }
    triangle {
      < 0.019137, -0.742368, 0.369776>,
      < 0.249307, -0.719914, 0.392046>,
      < 0.249320, -0.742231, 0.369776>
    }
    triangle {
      < 1.415609, -1.077509, 0.230966>,
      < 1.415613, -1.084928, 0.220753>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314720, -1.077569, 0.230966>,
      < 1.314724, -1.084988, 0.220753>,
      < 1.415613, -1.084928, 0.220753>
    }
    triangle {
      < 1.314720, -1.077569, 0.230966>,
      < 1.415613, -1.084928, 0.220753>,
      < 1.415609, -1.077509, 0.230966>
    }
    triangle {
      < 1.284470, -1.106128, 0.259497>,
      < 1.284478, -1.120966, 0.239071>,
      < 1.314724, -1.084988, 0.220753>
    }
    triangle {
      < 1.284470, -1.106128, 0.259497>,
      < 1.314724, -1.084988, 0.220753>,
      < 1.314720, -1.077569, 0.230966>
    }
    triangle {
      < 1.198735, -1.141853, 0.295162>,
      < 1.198749, -1.165965, 0.261968>,
      < 1.284478, -1.120966, 0.239071>
    }
    triangle {
      < 1.198735, -1.141853, 0.295162>,
      < 1.284478, -1.120966, 0.239071>,
      < 1.284470, -1.106128, 0.259497>
    }
    triangle {
      < 0.093999, -1.142508, 0.295161>,
      < 0.094013, -1.166619, 0.261967>,
      < 1.198749, -1.165965, 0.261968>
    }
    triangle {
      < 0.093999, -1.142508, 0.295161>,
      < 1.198749, -1.165965, 0.261968>,
      < 1.198735, -1.141853, 0.295162>
    }
    triangle {
      < 0.063729, -1.135390, 0.288029>,
      < 0.063742, -1.157647, 0.257388>,
      < 0.094013, -1.166619, 0.261967>
    }
    triangle {
      < 0.063729, -1.135390, 0.288029>,
      < 0.094013, -1.166619, 0.261967>,
      < 0.093999, -1.142508, 0.295161>
    }
    triangle {
      < -0.264163, -1.132018, 0.284463>,
      < -0.264151, -1.153348, 0.255098>,
      < 0.063742, -1.157647, 0.257388>
    }
    triangle {
      < -0.264163, -1.132018, 0.284463>,
      < 0.063742, -1.157647, 0.257388>,
      < 0.063729, -1.135390, 0.288029>
    }
    triangle {
      < -0.360023, -1.107103, 0.259497>,
      < -0.360014, -1.121940, 0.239071>,
      < -0.264151, -1.153348, 0.255098>
    }
    triangle {
      < -0.360023, -1.107103, 0.259497>,
      < -0.264151, -1.153348, 0.255098>,
      < -0.264163, -1.132018, 0.284463>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360014, -1.121940, 0.239071>,
      < -0.360023, -1.107103, 0.259497>
    }
    triangle {
      < 1.415613, -1.084928, 0.220753>,
      < 1.415616, -1.088829, 0.208746>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314724, -1.084988, 0.220753>,
      < 1.314726, -1.088889, 0.208746>,
      < 1.415616, -1.088829, 0.208746>
    }
    triangle {
      < 1.314724, -1.084988, 0.220753>,
      < 1.415616, -1.088829, 0.208746>,
      < 1.415613, -1.084928, 0.220753>
    }
    triangle {
      < 1.284478, -1.120966, 0.239071>,
      < 1.284483, -1.128766, 0.215059>,
      < 1.314726, -1.088889, 0.208746>
    }
    triangle {
      < 1.284478, -1.120966, 0.239071>,
      < 1.314726, -1.088889, 0.208746>,
      < 1.314724, -1.084988, 0.220753>
    }
    triangle {
      < 1.198749, -1.165965, 0.261968>,
      < 1.198757, -1.178640, 0.222948>,
      < 1.284483, -1.128766, 0.215059>
    }
    triangle {
      < 1.198749, -1.165965, 0.261968>,
      < 1.284483, -1.128766, 0.215059>,
      < 1.284478, -1.120966, 0.239071>
    }
    triangle {
      < 0.094013, -1.166619, 0.261967>,
      < 0.094021, -1.179294, 0.222948>,
      < 1.198757, -1.178640, 0.222948>
    }
    triangle {
      < 0.094013, -1.166619, 0.261967>,
      < 1.198757, -1.178640, 0.222948>,
      < 1.198749, -1.165965, 0.261968>
    }
    triangle {
      < 0.063742, -1.157647, 0.257388>,
      < 0.063749, -1.169348, 0.221371>,
      < 0.094021, -1.179294, 0.222948>
    }
    triangle {
      < 0.063742, -1.157647, 0.257388>,
      < 0.094021, -1.179294, 0.222948>,
      < 0.094013, -1.166619, 0.261967>
    }
    triangle {
      < -0.264151, -1.153348, 0.255098>,
      < -0.264144, -1.164560, 0.220581>,
      < 0.063749, -1.169348, 0.221371>
    }
    triangle {
      < -0.264151, -1.153348, 0.255098>,
      < 0.063749, -1.169348, 0.221371>,
      < 0.063742, -1.157647, 0.257388>
    }
    triangle {
      < -0.360014, -1.121940, 0.239071>,
      < -0.360010, -1.129740, 0.215058>,
      < -0.264144, -1.164560, 0.220581>
    }
    triangle {
      < -0.360014, -1.121940, 0.239071>,
      < -0.264144, -1.164560, 0.220581>,
      < -0.264151, -1.153348, 0.255098>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360010, -1.129740, 0.215058>,
      < -0.360014, -1.121940, 0.239071>
    }
    triangle {
      < 1.415616, -1.088829, 0.208746>,
      < 1.415616, -1.088828, 0.196122>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314726, -1.088889, 0.208746>,
      < 1.314726, -1.088888, 0.196122>,
      < 1.415616, -1.088828, 0.196122>
    }
    triangle {
      < 1.314726, -1.088889, 0.208746>,
      < 1.415616, -1.088828, 0.196122>,
      < 1.415616, -1.088829, 0.208746>
    }
    triangle {
      < 1.284483, -1.128766, 0.215059>,
      < 1.284483, -1.128766, 0.189811>,
      < 1.314726, -1.088888, 0.196122>
    }
    triangle {
      < 1.284483, -1.128766, 0.215059>,
      < 1.314726, -1.088888, 0.196122>,
      < 1.314726, -1.088889, 0.208746>
    }
    triangle {
      < 1.198757, -1.178640, 0.222948>,
      < 1.198757, -1.178641, 0.181921>,
      < 1.284483, -1.128766, 0.189811>
    }
    triangle {
      < 1.198757, -1.178640, 0.222948>,
      < 1.284483, -1.128766, 0.189811>,
      < 1.284483, -1.128766, 0.215059>
    }
    triangle {
      < 0.094021, -1.179294, 0.222948>,
      < 0.094021, -1.179295, 0.181921>,
      < 1.198757, -1.178641, 0.181921>
    }
    triangle {
      < 0.094021, -1.179294, 0.222948>,
      < 1.198757, -1.178641, 0.181921>,
      < 1.198757, -1.178640, 0.222948>
    }
    triangle {
      < 0.063749, -1.169348, 0.221371>,
      < 0.063749, -1.169347, 0.183499>,
      < 0.094021, -1.179295, 0.181921>
    }
    triangle {
      < 0.063749, -1.169348, 0.221371>,
      < 0.094021, -1.179295, 0.181921>,
      < 0.094021, -1.179294, 0.222948>
    }
    triangle {
      < -0.264144, -1.164560, 0.220581>,
      < -0.264144, -1.164561, 0.184288>,
      < 0.063749, -1.169347, 0.183499>
    }
    triangle {
      < -0.264144, -1.164560, 0.220581>,
      < 0.063749, -1.169347, 0.183499>,
      < 0.063749, -1.169348, 0.221371>
    }
    triangle {
      < -0.360010, -1.129740, 0.215058>,
      < -0.360010, -1.129740, 0.189810>,
      < -0.264144, -1.164561, 0.184288>
    }
    triangle {
      < -0.360010, -1.129740, 0.215058>,
      < -0.264144, -1.164561, 0.184288>,
      < -0.264144, -1.164560, 0.220581>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360010, -1.129740, 0.189810>,
      < -0.360010, -1.129740, 0.215058>
    }
    triangle {
      < 1.415616, -1.088828, 0.196122>,
      < 1.415613, -1.084929, 0.184117>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314726, -1.088888, 0.196122>,
      < 1.314724, -1.084988, 0.184117>,
      < 1.415613, -1.084929, 0.184117>
    }
    triangle {
      < 1.314726, -1.088888, 0.196122>,
      < 1.415613, -1.084929, 0.184117>,
      < 1.415616, -1.088828, 0.196122>
    }
    triangle {
      < 1.284483, -1.128766, 0.189811>,
      < 1.284478, -1.120965, 0.165799>,
      < 1.314724, -1.084988, 0.184117>
    }
    triangle {
      < 1.284483, -1.128766, 0.189811>,
      < 1.314724, -1.084988, 0.184117>,
      < 1.314726, -1.088888, 0.196122>
    }
    triangle {
      < 1.198757, -1.178641, 0.181921>,
      < 1.198749, -1.165965, 0.142901>,
      < 1.284478, -1.120965, 0.165799>
    }
    triangle {
      < 1.198757, -1.178641, 0.181921>,
      < 1.284478, -1.120965, 0.165799>,
      < 1.284483, -1.128766, 0.189811>
    }
    triangle {
      < 0.094021, -1.179295, 0.181921>,
      < 0.094013, -1.166619, 0.142900>,
      < 1.198749, -1.165965, 0.142901>
    }
    triangle {
      < 0.094021, -1.179295, 0.181921>,
      < 1.198749, -1.165965, 0.142901>,
      < 1.198757, -1.178641, 0.181921>
    }
    triangle {
      < 0.063749, -1.169347, 0.183499>,
      < 0.063742, -1.157648, 0.147481>,
      < 0.094013, -1.166619, 0.142900>
    }
    triangle {
      < 0.063749, -1.169347, 0.183499>,
      < 0.094013, -1.166619, 0.142900>,
      < 0.094021, -1.179295, 0.181921>
    }
    triangle {
      < -0.264144, -1.164561, 0.184288>,
      < -0.264151, -1.153347, 0.149770>,
      < 0.063742, -1.157648, 0.147481>
    }
    triangle {
      < -0.264144, -1.164561, 0.184288>,
      < 0.063742, -1.157648, 0.147481>,
      < 0.063749, -1.169347, 0.183499>
    }
    triangle {
      < -0.360010, -1.129740, 0.189810>,
      < -0.360014, -1.121940, 0.165799>,
      < -0.264151, -1.153347, 0.149770>
    }
    triangle {
      < -0.360010, -1.129740, 0.189810>,
      < -0.264151, -1.153347, 0.149770>,
      < -0.264144, -1.164561, 0.184288>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360014, -1.121940, 0.165799>,
      < -0.360010, -1.129740, 0.189810>
    }
    triangle {
      < 1.415613, -1.084929, 0.184117>,
      < 1.415609, -1.077510, 0.173903>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314724, -1.084988, 0.184117>,
      < 1.314720, -1.077569, 0.173903>,
      < 1.415609, -1.077510, 0.173903>
    }
    triangle {
      < 1.314724, -1.084988, 0.184117>,
      < 1.415609, -1.077510, 0.173903>,
      < 1.415613, -1.084929, 0.184117>
    }
    triangle {
      < 1.284478, -1.120965, 0.165799>,
      < 1.284470, -1.106128, 0.145371>,
      < 1.314720, -1.077569, 0.173903>
    }
    triangle {
      < 1.284478, -1.120965, 0.165799>,
      < 1.314720, -1.077569, 0.173903>,
      < 1.314724, -1.084988, 0.184117>
    }
    triangle {
      < 1.198749, -1.165965, 0.142901>,
      < 1.198735, -1.141854, 0.109707>,
      < 1.284470, -1.106128, 0.145371>
    }
    triangle {
      < 1.198749, -1.165965, 0.142901>,
      < 1.284470, -1.106128, 0.145371>,
      < 1.284478, -1.120965, 0.165799>
    }
    triangle {
      < 0.094013, -1.166619, 0.142900>,
      < 0.093999, -1.142508, 0.109706>,
      < 1.198735, -1.141854, 0.109707>
    }
    triangle {
      < 0.094013, -1.166619, 0.142900>,
      < 1.198735, -1.141854, 0.109707>,
      < 1.198749, -1.165965, 0.142901>
    }
    triangle {
      < 0.063742, -1.157648, 0.147481>,
      < 0.063729, -1.135391, 0.116840>,
      < 0.093999, -1.142508, 0.109706>
    }
    triangle {
      < 0.063742, -1.157648, 0.147481>,
      < 0.093999, -1.142508, 0.109706>,
      < 0.094013, -1.166619, 0.142900>
    }
    triangle {
      < -0.264151, -1.153347, 0.149770>,
      < -0.264163, -1.132019, 0.120407>,
      < 0.063729, -1.135391, 0.116840>
    }
    triangle {
      < -0.264151, -1.153347, 0.149770>,
      < 0.063729, -1.135391, 0.116840>,
      < 0.063742, -1.157648, 0.147481>
    }
    triangle {
      < -0.360014, -1.121940, 0.165799>,
      < -0.360023, -1.107102, 0.145371>,
      < -0.264163, -1.132019, 0.120407>
    }
    triangle {
      < -0.360014, -1.121940, 0.165799>,
      < -0.264163, -1.132019, 0.120407>,
      < -0.264151, -1.153347, 0.149770>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360023, -1.107102, 0.145371>,
      < -0.360014, -1.121940, 0.165799>
    }
    triangle {
      < 1.415609, -1.077510, 0.173903>,
      < 1.415603, -1.067298, 0.166481>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314720, -1.077569, 0.173903>,
      < 1.314714, -1.067358, 0.166481>,
      < 1.415603, -1.067298, 0.166481>
    }
    triangle {
      < 1.314720, -1.077569, 0.173903>,
      < 1.415603, -1.067298, 0.166481>,
      < 1.415609, -1.077510, 0.173903>
    }
    triangle {
      < 1.284470, -1.106128, 0.145371>,
      < 1.284458, -1.085705, 0.130528>,
      < 1.314714, -1.067358, 0.166481>
    }
    triangle {
      < 1.284470, -1.106128, 0.145371>,
      < 1.314714, -1.067358, 0.166481>,
      < 1.314720, -1.077569, 0.173903>
    }
    triangle {
      < 1.198735, -1.141854, 0.109707>,
      < 1.198715, -1.108667, 0.085585>,
      < 1.284458, -1.085705, 0.130528>
    }
    triangle {
      < 1.198735, -1.141854, 0.109707>,
      < 1.284458, -1.085705, 0.130528>,
      < 1.284470, -1.106128, 0.145371>
    }
    triangle {
      < 0.093999, -1.142508, 0.109706>,
      < 0.093979, -1.109321, 0.085585>,
      < 1.198715, -1.108667, 0.085585>
    }
    triangle {
      < 0.093999, -1.142508, 0.109706>,
      < 1.198715, -1.108667, 0.085585>,
      < 1.198735, -1.141854, 0.109707>
    }
    triangle {
      < 0.063729, -1.135391, 0.116840>,
      < 0.063711, -1.104757, 0.094575>,
      < 0.093979, -1.109321, 0.085585>
    }
    triangle {
      < 0.063729, -1.135391, 0.116840>,
      < 0.093979, -1.109321, 0.085585>,
      < 0.093999, -1.142508, 0.109706>
    }
    triangle {
      < -0.264163, -1.132019, 0.120407>,
      < -0.264181, -1.102660, 0.099068>,
      < 0.063711, -1.104757, 0.094575>
    }
    triangle {
      < -0.264163, -1.132019, 0.120407>,
      < 0.063711, -1.104757, 0.094575>,
      < 0.063729, -1.135391, 0.116840>
    }
    triangle {
      < -0.360023, -1.107102, 0.145371>,
      < -0.360035, -1.086679, 0.130528>,
      < -0.264181, -1.102660, 0.099068>
    }
    triangle {
      < -0.360023, -1.107102, 0.145371>,
      < -0.264181, -1.102660, 0.099068>,
      < -0.264163, -1.132019, 0.120407>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360035, -1.086679, 0.130528>,
      < -0.360023, -1.107102, 0.145371>
    }
    triangle {
      < 1.415603, -1.067298, 0.166481>,
      < 1.415596, -1.055293, 0.162577>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314714, -1.067358, 0.166481>,
      < 1.314707, -1.055353, 0.162577>,
      < 1.415596, -1.055293, 0.162577>
    }
    triangle {
      < 1.314714, -1.067358, 0.166481>,
      < 1.415596, -1.055293, 0.162577>,
      < 1.415603, -1.067298, 0.166481>
    }
    triangle {
      < 1.284458, -1.085705, 0.130528>,
      < 1.284443, -1.061694, 0.122720>,
      < 1.314707, -1.055353, 0.162577>
    }
    triangle {
      < 1.284458, -1.085705, 0.130528>,
      < 1.314707, -1.055353, 0.162577>,
      < 1.314714, -1.067358, 0.166481>
    }
    triangle {
      < 1.198715, -1.108667, 0.085585>,
      < 1.198692, -1.069651, 0.072899>,
      < 1.284443, -1.061694, 0.122720>
    }
    triangle {
      < 1.198715, -1.108667, 0.085585>,
      < 1.284443, -1.061694, 0.122720>,
      < 1.284458, -1.085705, 0.130528>
    }
    triangle {
      < 0.093979, -1.109321, 0.085585>,
      < 0.093956, -1.070305, 0.072899>,
      < 1.198692, -1.069651, 0.072899>
    }
    triangle {
      < 0.093979, -1.109321, 0.085585>,
      < 1.198692, -1.069651, 0.072899>,
      < 1.198715, -1.108667, 0.085585>
    }
    triangle {
      < 0.063711, -1.104757, 0.094575>,
      < 0.063689, -1.068742, 0.082863>,
      < 0.093956, -1.070305, 0.072899>
    }
    triangle {
      < 0.063711, -1.104757, 0.094575>,
      < 0.093956, -1.070305, 0.072899>,
      < 0.093979, -1.109321, 0.085585>
    }
    triangle {
      < -0.264181, -1.102660, 0.099068>,
      < -0.264201, -1.068146, 0.087844>,
      < 0.063689, -1.068742, 0.082863>
    }
    triangle {
      < -0.264181, -1.102660, 0.099068>,
      < 0.063689, -1.068742, 0.082863>,
      < 0.063711, -1.104757, 0.094575>
    }
    triangle {
      < -0.360035, -1.086679, 0.130528>,
      < -0.360049, -1.062669, 0.122720>,
      < -0.264201, -1.068146, 0.087844>
    }
    triangle {
      < -0.360035, -1.086679, 0.130528>,
      < -0.264201, -1.068146, 0.087844>,
      < -0.264181, -1.102660, 0.099068>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360049, -1.062669, 0.122720>,
      < -0.360035, -1.086679, 0.130528>
    }
    triangle {
      < 1.415596, -1.055293, 0.162577>,
      < 1.415588, -1.042670, 0.162574>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314707, -1.055353, 0.162577>,
      < 1.314699, -1.042730, 0.162574>,
      < 1.415588, -1.042670, 0.162574>
    }
    triangle {
      < 1.314707, -1.055353, 0.162577>,
      < 1.415588, -1.042670, 0.162574>,
      < 1.415596, -1.055293, 0.162577>
    }
    triangle {
      < 1.284443, -1.061694, 0.122720>,
      < 1.284428, -1.036447, 0.122712>,
      < 1.314699, -1.042730, 0.162574>
    }
    triangle {
      < 1.284443, -1.061694, 0.122720>,
      < 1.314699, -1.042730, 0.162574>,
      < 1.314707, -1.055353, 0.162577>
    }
    triangle {
      < 1.198692, -1.069651, 0.072899>,
      < 1.198668, -1.028624, 0.072886>,
      < 1.284428, -1.036447, 0.122712>
    }
    triangle {
      < 1.198692, -1.069651, 0.072899>,
      < 1.284428, -1.036447, 0.122712>,
      < 1.284443, -1.061694, 0.122720>
    }
    triangle {
      < 0.093956, -1.070305, 0.072899>,
      < 0.093932, -1.029278, 0.072886>,
      < 1.198668, -1.028624, 0.072886>
    }
    triangle {
      < 0.093956, -1.070305, 0.072899>,
      < 1.198668, -1.028624, 0.072886>,
      < 1.198692, -1.069651, 0.072899>
    }
    triangle {
      < 0.063689, -1.068742, 0.082863>,
      < 0.063667, -1.030871, 0.082852>,
      < 0.093932, -1.029278, 0.072886>
    }
    triangle {
      < 0.063689, -1.068742, 0.082863>,
      < 0.093932, -1.029278, 0.072886>,
      < 0.093956, -1.070305, 0.072899>
    }
    triangle {
      < -0.264201, -1.068146, 0.087844>,
      < -0.264223, -1.031853, 0.087834>,
      < 0.063667, -1.030871, 0.082852>
    }
    triangle {
      < -0.264201, -1.068146, 0.087844>,
      < 0.063667, -1.030871, 0.082852>,
      < 0.063689, -1.068742, 0.082863>
    }
    triangle {
      < -0.360049, -1.062669, 0.122720>,
      < -0.360064, -1.037421, 0.122712>,
      < -0.264223, -1.031853, 0.087834>
    }
    triangle {
      < -0.360049, -1.062669, 0.122720>,
      < -0.264223, -1.031853, 0.087834>,
      < -0.264201, -1.068146, 0.087844>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360064, -1.037421, 0.122712>,
      < -0.360049, -1.062669, 0.122720>
    }
    triangle {
      < 1.415588, -1.042670, 0.162574>,
      < 1.415581, -1.030662, 0.166470>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314699, -1.042730, 0.162574>,
      < 1.314692, -1.030722, 0.166470>,
      < 1.415581, -1.030662, 0.166470>
    }
    triangle {
      < 1.314699, -1.042730, 0.162574>,
      < 1.415581, -1.030662, 0.166470>,
      < 1.415588, -1.042670, 0.162574>
    }
    triangle {
      < 1.284428, -1.036447, 0.122712>,
      < 1.284414, -1.012434, 0.130506>,
      < 1.314692, -1.030722, 0.166470>
    }
    triangle {
      < 1.284428, -1.036447, 0.122712>,
      < 1.314692, -1.030722, 0.166470>,
      < 1.314699, -1.042730, 0.162574>
    }
    triangle {
      < 1.198668, -1.028624, 0.072886>,
      < 1.198645, -0.989600, 0.085551>,
      < 1.284414, -1.012434, 0.130506>
    }
    triangle {
      < 1.198668, -1.028624, 0.072886>,
      < 1.284414, -1.012434, 0.130506>,
      < 1.284428, -1.036447, 0.122712>
    }
    triangle {
      < 0.093932, -1.029278, 0.072886>,
      < 0.093909, -0.990254, 0.085551>,
      < 1.198645, -0.989600, 0.085551>
    }
    triangle {
      < 0.093932, -1.029278, 0.072886>,
      < 1.198645, -0.989600, 0.085551>,
      < 1.198668, -1.028624, 0.072886>
    }
    triangle {
      < 0.063667, -1.030871, 0.082852>,
      < 0.063646, -0.994849, 0.094541>,
      < 0.093909, -0.990254, 0.085551>
    }
    triangle {
      < 0.063667, -1.030871, 0.082852>,
      < 0.093909, -0.990254, 0.085551>,
      < 0.093932, -1.029278, 0.072886>
    }
    triangle {
      < -0.264223, -1.031853, 0.087834>,
      < -0.264243, -0.997332, 0.099037>,
      < 0.063646, -0.994849, 0.094541>
    }
    triangle {
      < -0.264223, -1.031853, 0.087834>,
      < 0.063646, -0.994849, 0.094541>,
      < 0.063667, -1.030871, 0.082852>
    }
    triangle {
      < -0.360064, -1.037421, 0.122712>,
      < -0.360079, -1.013409, 0.130506>,
      < -0.264243, -0.997332, 0.099037>
    }
    triangle {
      < -0.360064, -1.037421, 0.122712>,
      < -0.264243, -0.997332, 0.099037>,
      < -0.264223, -1.031853, 0.087834>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360079, -1.013409, 0.130506>,
      < -0.360064, -1.037421, 0.122712>
    }
    triangle {
      < 1.415581, -1.030662, 0.166470>,
      < 1.415575, -1.020447, 0.173886>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314692, -1.030722, 0.166470>,
      < 1.314686, -1.020507, 0.173886>,
      < 1.415575, -1.020447, 0.173886>
    }
    triangle {
      < 1.314692, -1.030722, 0.166470>,
      < 1.415575, -1.020447, 0.173886>,
      < 1.415581, -1.030662, 0.166470>
    }
    triangle {
      < 1.284414, -1.012434, 0.130506>,
      < 1.284402, -0.992002, 0.145337>,
      < 1.314686, -1.020507, 0.173886>
    }
    triangle {
      < 1.284414, -1.012434, 0.130506>,
      < 1.314686, -1.020507, 0.173886>,
      < 1.314692, -1.030722, 0.166470>
    }
    triangle {
      < 1.198645, -0.989600, 0.085551>,
      < 1.198625, -0.956399, 0.109652>,
      < 1.284402, -0.992002, 0.145337>
    }
    triangle {
      < 1.198645, -0.989600, 0.085551>,
      < 1.284402, -0.992002, 0.145337>,
      < 1.284414, -1.012434, 0.130506>
    }
    triangle {
      < 0.093909, -0.990254, 0.085551>,
      < 0.093889, -0.957054, 0.109651>,
      < 1.198625, -0.956399, 0.109652>
    }
    triangle {
      < 0.093909, -0.990254, 0.085551>,
      < 1.198625, -0.956399, 0.109652>,
      < 1.198645, -0.989600, 0.085551>
    }
    triangle {
      < 0.063646, -0.994849, 0.094541>,
      < 0.063627, -0.964202, 0.116789>,
      < 0.093889, -0.957054, 0.109651>
    }
    triangle {
      < 0.063646, -0.994849, 0.094541>,
      < 0.093889, -0.957054, 0.109651>,
      < 0.093909, -0.990254, 0.085551>
    }
    triangle {
      < -0.264243, -0.997332, 0.099037>,
      < -0.264260, -0.967962, 0.120357>,
      < 0.063627, -0.964202, 0.116789>
    }
    triangle {
      < -0.264243, -0.997332, 0.099037>,
      < 0.063627, -0.964202, 0.116789>,
      < 0.063646, -0.994849, 0.094541>
    }
    triangle {
      < -0.360079, -1.013409, 0.130506>,
      < -0.360091, -0.992977, 0.145337>,
      < -0.264260, -0.967962, 0.120357>
    }
    triangle {
      < -0.360079, -1.013409, 0.130506>,
      < -0.264260, -0.967962, 0.120357>,
      < -0.264243, -0.997332, 0.099037>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360091, -0.992977, 0.145337>,
      < -0.360079, -1.013409, 0.130506>
    }
    triangle {
      < 1.415575, -1.020447, 0.173886>,
      < 1.415571, -1.013021, 0.184095>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314686, -1.020507, 0.173886>,
      < 1.314682, -1.013081, 0.184095>,
      < 1.415571, -1.013021, 0.184095>
    }
    triangle {
      < 1.314686, -1.020507, 0.173886>,
      < 1.415571, -1.013021, 0.184095>,
      < 1.415575, -1.020447, 0.173886>
    }
    triangle {
      < 1.284402, -0.992002, 0.145337>,
      < 1.284393, -0.977152, 0.165756>,
      < 1.314682, -1.013081, 0.184095>
    }
    triangle {
      < 1.284402, -0.992002, 0.145337>,
      < 1.314682, -1.013081, 0.184095>,
      < 1.314686, -1.020507, 0.173886>
    }
    triangle {
      < 1.198625, -0.956399, 0.109652>,
      < 1.198611, -0.932267, 0.142832>,
      < 1.284393, -0.977152, 0.165756>
    }
    triangle {
      < 1.198625, -0.956399, 0.109652>,
      < 1.284393, -0.977152, 0.165756>,
      < 1.284402, -0.992002, 0.145337>
    }
    triangle {
      < 0.093889, -0.957054, 0.109651>,
      < 0.093875, -0.932922, 0.142832>,
      < 1.198611, -0.932267, 0.142832>
    }
    triangle {
      < 0.093889, -0.957054, 0.109651>,
      < 1.198611, -0.932267, 0.142832>,
      < 1.198625, -0.956399, 0.109652>
    }
    triangle {
      < 0.063627, -0.964202, 0.116789>,
      < 0.063614, -0.941928, 0.147417>,
      < 0.093875, -0.932922, 0.142832>
    }
    triangle {
      < 0.063627, -0.964202, 0.116789>,
      < 0.093875, -0.932922, 0.142832>,
      < 0.093889, -0.957054, 0.109651>
    }
    triangle {
      < -0.264260, -0.967962, 0.120357>,
      < -0.264273, -0.946615, 0.149710>,
      < 0.063614, -0.941928, 0.147417>
    }
    triangle {
      < -0.264260, -0.967962, 0.120357>,
      < 0.063614, -0.941928, 0.147417>,
      < 0.063627, -0.964202, 0.116789>
    }
    triangle {
      < -0.360091, -0.992977, 0.145337>,
      < -0.360099, -0.978127, 0.165756>,
      < -0.264273, -0.946615, 0.149710>
    }
    triangle {
      < -0.360091, -0.992977, 0.145337>,
      < -0.264273, -0.946615, 0.149710>,
      < -0.264260, -0.967962, 0.120357>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360099, -0.978127, 0.165756>,
      < -0.360091, -0.992977, 0.145337>
    }
    triangle {
      < 1.415571, -1.013021, 0.184095>,
      < 1.415568, -1.009115, 0.196099>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314682, -1.013081, 0.184095>,
      < 1.314679, -1.009175, 0.196099>,
      < 1.415568, -1.009115, 0.196099>
    }
    triangle {
      < 1.314682, -1.013081, 0.184095>,
      < 1.415568, -1.009115, 0.196099>,
      < 1.415571, -1.013021, 0.184095>
    }
    triangle {
      < 1.284393, -0.977152, 0.165756>,
      < 1.284389, -0.969337, 0.189764>,
      < 1.314679, -1.009175, 0.196099>
    }
    triangle {
      < 1.284393, -0.977152, 0.165756>,
      < 1.314679, -1.009175, 0.196099>,
      < 1.314682, -1.013081, 0.184095>
    }
    triangle {
      < 1.198611, -0.932267, 0.142832>,
      < 1.198603, -0.919569, 0.181845>,
      < 1.284389, -0.969337, 0.189764>
    }
    triangle {
      < 1.198611, -0.932267, 0.142832>,
      < 1.284389, -0.969337, 0.189764>,
      < 1.284393, -0.977152, 0.165756>
    }
    triangle {
      < 0.093875, -0.932922, 0.142832>,
      < 0.093867, -0.920224, 0.181844>,
      < 1.198603, -0.919569, 0.181845>
    }
    triangle {
      < 0.093875, -0.932922, 0.142832>,
      < 1.198603, -0.919569, 0.181845>,
      < 1.198611, -0.932267, 0.142832>
    }
    triangle {
      < 0.063614, -0.941928, 0.147417>,
      < 0.063607, -0.930205, 0.183428>,
      < 0.093867, -0.920224, 0.181844>
    }
    triangle {
      < 0.063614, -0.941928, 0.147417>,
      < 0.093867, -0.920224, 0.181844>,
      < 0.093875, -0.932922, 0.142832>
    }
    triangle {
      < -0.264273, -0.946615, 0.149710>,
      < -0.264280, -0.935382, 0.184220>,
      < 0.063607, -0.930205, 0.183428>
    }
    triangle {
      < -0.264273, -0.946615, 0.149710>,
      < 0.063607, -0.930205, 0.183428>,
      < 0.063614, -0.941928, 0.147417>
    }
    triangle {
      < -0.360099, -0.978127, 0.165756>,
      < -0.360104, -0.970312, 0.189763>,
      < -0.264280, -0.935382, 0.184220>
    }
    triangle {
      < -0.360099, -0.978127, 0.165756>,
      < -0.264280, -0.935382, 0.184220>,
      < -0.264273, -0.946615, 0.149710>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360104, -0.970312, 0.189763>,
      < -0.360099, -0.978127, 0.165756>
    }
    triangle {
      < 1.415568, -1.009115, 0.196099>,
      < 1.415568, -1.009107, 0.208723>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314679, -1.009175, 0.196099>,
      < 1.314679, -1.009167, 0.208723>,
      < 1.415568, -1.009107, 0.208723>
    }
    triangle {
      < 1.314679, -1.009175, 0.196099>,
      < 1.415568, -1.009107, 0.208723>,
      < 1.415568, -1.009115, 0.196099>
    }
    triangle {
      < 1.284389, -0.969337, 0.189764>,
      < 1.284389, -0.969323, 0.215011>,
      < 1.314679, -1.009167, 0.208723>
    }
    triangle {
      < 1.284389, -0.969337, 0.189764>,
      < 1.314679, -1.009167, 0.208723>,
      < 1.314679, -1.009175, 0.196099>
    }
    triangle {
      < 1.198603, -0.919569, 0.181845>,
      < 1.198603, -0.919545, 0.222871>,
      < 1.284389, -0.969323, 0.215011>
    }
    triangle {
      < 1.198603, -0.919569, 0.181845>,
      < 1.284389, -0.969323, 0.215011>,
      < 1.284389, -0.969337, 0.189764>
    }
    triangle {
      < 0.093867, -0.920224, 0.181844>,
      < 0.093867, -0.920200, 0.222870>,
      < 1.198603, -0.919545, 0.222871>
    }
    triangle {
      < 0.093867, -0.920224, 0.181844>,
      < 1.198603, -0.919545, 0.222871>,
      < 1.198603, -0.919569, 0.181845>
    }
    triangle {
      < 0.063607, -0.930205, 0.183428>,
      < 0.063607, -0.930183, 0.221299>,
      < 0.093867, -0.920200, 0.222870>
    }
    triangle {
      < 0.063607, -0.930205, 0.183428>,
      < 0.093867, -0.920200, 0.222870>,
      < 0.093867, -0.920224, 0.181844>
    }
    triangle {
      < -0.264280, -0.935382, 0.184220>,
      < -0.264280, -0.935360, 0.220513>,
      < 0.063607, -0.930183, 0.221299>
    }
    triangle {
      < -0.264280, -0.935382, 0.184220>,
      < 0.063607, -0.930183, 0.221299>,
      < 0.063607, -0.930205, 0.183428>
    }
    triangle {
      < -0.360104, -0.970312, 0.189763>,
      < -0.360104, -0.970298, 0.215010>,
      < -0.264280, -0.935360, 0.220513>
    }
    triangle {
      < -0.360104, -0.970312, 0.189763>,
      < -0.264280, -0.935360, 0.220513>,
      < -0.264280, -0.935382, 0.184220>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360104, -0.970298, 0.215010>,
      < -0.360104, -0.970312, 0.189763>
    }
    triangle {
      < 1.415568, -1.009107, 0.208723>,
      < 1.415571, -1.013000, 0.220731>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314679, -1.009167, 0.208723>,
      < 1.314682, -1.013060, 0.220731>,
      < 1.415571, -1.013000, 0.220731>
    }
    triangle {
      < 1.314679, -1.009167, 0.208723>,
      < 1.415571, -1.013000, 0.220731>,
      < 1.415568, -1.009107, 0.208723>
    }
    triangle {
      < 1.284389, -0.969323, 0.215011>,
      < 1.284393, -0.977109, 0.239027>,
      < 1.314682, -1.013060, 0.220731>
    }
    triangle {
      < 1.284389, -0.969323, 0.215011>,
      < 1.314682, -1.013060, 0.220731>,
      < 1.314679, -1.009167, 0.208723>
    }
    triangle {
      < 1.198603, -0.919545, 0.222871>,
      < 1.198611, -0.932198, 0.261898>,
      < 1.284393, -0.977109, 0.239027>
    }
    triangle {
      < 1.198603, -0.919545, 0.222871>,
      < 1.284393, -0.977109, 0.239027>,
      < 1.284389, -0.969323, 0.215011>
    }
    triangle {
      < 0.093867, -0.920200, 0.222870>,
      < 0.093875, -0.932852, 0.261898>,
      < 1.198611, -0.932198, 0.261898>
    }
    triangle {
      < 0.093867, -0.920200, 0.222870>,
      < 1.198611, -0.932198, 0.261898>,
      < 1.198603, -0.919545, 0.222871>
    }
    triangle {
      < 0.063607, -0.930183, 0.221299>,
      < 0.063614, -0.941861, 0.257324>,
      < 0.093875, -0.932852, 0.261898>
    }
    triangle {
      < 0.063607, -0.930183, 0.221299>,
      < 0.093875, -0.932852, 0.261898>,
      < 0.093867, -0.920200, 0.222870>
    }
    triangle {
      < -0.264280, -0.935360, 0.220513>,
      < -0.264273, -0.946554, 0.255037>,
      < 0.063614, -0.941861, 0.257324>
    }
    triangle {
      < -0.264280, -0.935360, 0.220513>,
      < 0.063614, -0.941861, 0.257324>,
      < 0.063607, -0.930183, 0.221299>
    }
    triangle {
      < -0.360104, -0.970298, 0.215010>,
      < -0.360099, -0.978084, 0.239027>,
      < -0.264273, -0.946554, 0.255037>
    }
    triangle {
      < -0.360104, -0.970298, 0.215010>,
      < -0.264273, -0.946554, 0.255037>,
      < -0.264280, -0.935360, 0.220513>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360099, -0.978084, 0.239027>,
      < -0.360104, -0.970298, 0.215010>
    }
    triangle {
      < 1.415571, -1.013000, 0.220731>,
      < 1.415575, -1.020412, 0.230949>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314682, -1.013060, 0.220731>,
      < 1.314686, -1.020472, 0.230949>,
      < 1.415575, -1.020412, 0.230949>
    }
    triangle {
      < 1.314682, -1.013060, 0.220731>,
      < 1.415575, -1.020412, 0.230949>,
      < 1.415571, -1.013000, 0.220731>
    }
    triangle {
      < 1.284393, -0.977109, 0.239027>,
      < 1.284402, -0.991934, 0.259464>,
      < 1.314686, -1.020472, 0.230949>
    }
    triangle {
      < 1.284393, -0.977109, 0.239027>,
      < 1.314686, -1.020472, 0.230949>,
      < 1.314682, -1.013060, 0.220731>
    }
    triangle {
      < 1.198611, -0.932198, 0.261898>,
      < 1.198625, -0.956288, 0.295107>,
      < 1.284402, -0.991934, 0.259464>
    }
    triangle {
      < 1.198611, -0.932198, 0.261898>,
      < 1.284402, -0.991934, 0.259464>,
      < 1.284393, -0.977109, 0.239027>
    }
    triangle {
      < 0.093875, -0.932852, 0.261898>,
      < 0.093889, -0.956943, 0.295106>,
      < 1.198625, -0.956288, 0.295107>
    }
    triangle {
      < 0.093875, -0.932852, 0.261898>,
      < 1.198625, -0.956288, 0.295107>,
      < 1.198611, -0.932198, 0.261898>
    }
    triangle {
      < 0.063614, -0.941861, 0.257324>,
      < 0.063627, -0.964100, 0.287978>,
      < 0.093889, -0.956943, 0.295106>
    }
    triangle {
      < 0.063614, -0.941861, 0.257324>,
      < 0.093889, -0.956943, 0.295106>,
      < 0.093875, -0.932852, 0.261898>
    }
    triangle {
      < -0.264273, -0.946554, 0.255037>,
      < -0.264261, -0.967864, 0.284413>,
      < 0.063627, -0.964100, 0.287978>
    }
    triangle {
      < -0.264273, -0.946554, 0.255037>,
      < 0.063627, -0.964100, 0.287978>,
      < 0.063614, -0.941861, 0.257324>
    }
    triangle {
      < -0.360099, -0.978084, 0.239027>,
      < -0.360091, -0.992909, 0.259464>,
      < -0.264261, -0.967864, 0.284413>
    }
    triangle {
      < -0.360099, -0.978084, 0.239027>,
      < -0.264261, -0.967864, 0.284413>,
      < -0.264273, -0.946554, 0.255037>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360091, -0.992909, 0.259464>,
      < -0.360099, -0.978084, 0.239027>
    }
    triangle {
      < 1.415575, -1.020412, 0.230949>,
      < 1.415581, -1.030620, 0.238377>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314686, -1.020472, 0.230949>,
      < 1.314692, -1.030680, 0.238377>,
      < 1.415581, -1.030620, 0.238377>
    }
    triangle {
      < 1.314686, -1.020472, 0.230949>,
      < 1.415581, -1.030620, 0.238377>,
      < 1.415575, -1.020412, 0.230949>
    }
    triangle {
      < 1.284402, -0.991934, 0.259464>,
      < 1.284414, -1.012348, 0.274320>,
      < 1.314692, -1.030680, 0.238377>
    }
    triangle {
      < 1.284402, -0.991934, 0.259464>,
      < 1.314692, -1.030680, 0.238377>,
      < 1.314686, -1.020472, 0.230949>
    }
    triangle {
      < 1.198625, -0.956288, 0.295107>,
      < 1.198645, -0.989462, 0.319248>,
      < 1.284414, -1.012348, 0.274320>
    }
    triangle {
      < 1.198625, -0.956288, 0.295107>,
      < 1.284414, -1.012348, 0.274320>,
      < 1.284402, -0.991934, 0.259464>
    }
    triangle {
      < 0.093889, -0.956943, 0.295106>,
      < 0.093909, -0.990117, 0.319248>,
      < 1.198645, -0.989462, 0.319248>
    }
    triangle {
      < 0.093889, -0.956943, 0.295106>,
      < 1.198645, -0.989462, 0.319248>,
      < 1.198625, -0.956288, 0.295107>
    }
    triangle {
      < 0.063627, -0.964100, 0.287978>,
      < 0.063645, -0.994721, 0.310261>,
      < 0.093909, -0.990117, 0.319248>
    }
    triangle {
      < 0.063627, -0.964100, 0.287978>,
      < 0.093909, -0.990117, 0.319248>,
      < 0.093889, -0.956943, 0.295106>
    }
    triangle {
      < -0.264261, -0.967864, 0.284413>,
      < -0.264243, -0.997210, 0.305769>,
      < 0.063645, -0.994721, 0.310261>
    }
    triangle {
      < -0.264261, -0.967864, 0.284413>,
      < 0.063645, -0.994721, 0.310261>,
      < 0.063627, -0.964100, 0.287978>
    }
    triangle {
      < -0.360091, -0.992909, 0.259464>,
      < -0.360079, -1.013323, 0.274320>,
      < -0.264243, -0.997210, 0.305769>
    }
    triangle {
      < -0.360091, -0.992909, 0.259464>,
      < -0.264243, -0.997210, 0.305769>,
      < -0.264261, -0.967864, 0.284413>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360079, -1.013323, 0.274320>,
      < -0.360091, -0.992909, 0.259464>
    }
    triangle {
      < 1.415581, -1.030620, 0.238377>,
      < 1.415588, -1.042623, 0.242288>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314692, -1.030680, 0.238377>,
      < 1.314699, -1.042683, 0.242288>,
      < 1.415588, -1.042623, 0.242288>
    }
    triangle {
      < 1.314692, -1.030680, 0.238377>,
      < 1.415588, -1.042623, 0.242288>,
      < 1.415581, -1.030620, 0.238377>
    }
    triangle {
      < 1.284414, -1.012348, 0.274320>,
      < 1.284428, -1.036354, 0.282141>,
      < 1.314699, -1.042683, 0.242288>
    }
    triangle {
      < 1.284414, -1.012348, 0.274320>,
      < 1.314699, -1.042683, 0.242288>,
      < 1.314692, -1.030680, 0.238377>
    }
    triangle {
      < 1.198645, -0.989462, 0.319248>,
      < 1.198668, -1.028470, 0.331958>,
      < 1.284428, -1.036354, 0.282141>
    }
    triangle {
      < 1.198645, -0.989462, 0.319248>,
      < 1.284428, -1.036354, 0.282141>,
      < 1.284414, -1.012348, 0.274320>
    }
    triangle {
      < 0.093909, -0.990117, 0.319248>,
      < 0.093932, -1.029124, 0.331958>,
      < 1.198668, -1.028470, 0.331958>
    }
    triangle {
      < 0.093909, -0.990117, 0.319248>,
      < 1.198668, -1.028470, 0.331958>,
      < 1.198645, -0.989462, 0.319248>
    }
    triangle {
      < 0.063645, -0.994721, 0.310261>,
      < 0.063667, -1.030728, 0.321995>,
      < 0.093932, -1.029124, 0.331958>
    }
    triangle {
      < 0.063645, -0.994721, 0.310261>,
      < 0.093932, -1.029124, 0.331958>,
      < 0.093909, -0.990117, 0.319248>
    }
    triangle {
      < -0.264243, -0.997210, 0.305769>,
      < -0.264223, -1.031717, 0.317012>,
      < 0.063667, -1.030728, 0.321995>
    }
    triangle {
      < -0.264243, -0.997210, 0.305769>,
      < 0.063667, -1.030728, 0.321995>,
      < 0.063645, -0.994721, 0.310261>
    }
    triangle {
      < -0.360079, -1.013323, 0.274320>,
      < -0.360064, -1.037329, 0.282141>,
      < -0.264223, -1.031717, 0.317012>
    }
    triangle {
      < -0.360079, -1.013323, 0.274320>,
      < -0.264223, -1.031717, 0.317012>,
      < -0.264243, -0.997210, 0.305769>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360064, -1.037329, 0.282141>,
      < -0.360079, -1.013323, 0.274320>
    }
    triangle {
      < 1.415588, -1.042623, 0.242288>,
      < 1.415596, -1.055247, 0.242299>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314699, -1.042683, 0.242288>,
      < 1.314707, -1.055307, 0.242299>,
      < 1.415596, -1.055247, 0.242299>
    }
    triangle {
      < 1.314699, -1.042683, 0.242288>,
      < 1.415596, -1.055247, 0.242299>,
      < 1.415588, -1.042623, 0.242288>
    }
    triangle {
      < 1.284428, -1.036354, 0.282141>,
      < 1.284443, -1.061601, 0.282163>,
      < 1.314707, -1.055307, 0.242299>
    }
    triangle {
      < 1.284428, -1.036354, 0.282141>,
      < 1.314707, -1.055307, 0.242299>,
      < 1.314699, -1.042683, 0.242288>
    }
    triangle {
      < 1.198668, -1.028470, 0.331958>,
      < 1.198692, -1.069497, 0.331994>,
      < 1.284443, -1.061601, 0.282163>
    }
    triangle {
      < 1.198668, -1.028470, 0.331958>,
      < 1.284443, -1.061601, 0.282163>,
      < 1.284428, -1.036354, 0.282141>
    }
    triangle {
      < 0.093932, -1.029124, 0.331958>,
      < 0.093956, -1.070151, 0.331994>,
      < 1.198692, -1.069497, 0.331994>
    }
    triangle {
      < 0.093932, -1.029124, 0.331958>,
      < 1.198692, -1.069497, 0.331994>,
      < 1.198668, -1.028470, 0.331958>
    }
    triangle {
      < 0.063667, -1.030728, 0.321995>,
      < 0.063689, -1.068600, 0.322028>,
      < 0.093956, -1.070151, 0.331994>
    }
    triangle {
      < 0.063667, -1.030728, 0.321995>,
      < 0.093956, -1.070151, 0.331994>,
      < 0.093932, -1.029124, 0.331958>
    }
    triangle {
      < -0.264223, -1.031717, 0.317012>,
      < -0.264201, -1.068011, 0.317045>,
      < 0.063689, -1.068600, 0.322028>
    }
    triangle {
      < -0.264223, -1.031717, 0.317012>,
      < 0.063689, -1.068600, 0.322028>,
      < 0.063667, -1.030728, 0.321995>
    }
    triangle {
      < -0.360064, -1.037329, 0.282141>,
      < -0.360049, -1.062576, 0.282163>,
      < -0.264201, -1.068011, 0.317045>
    }
    triangle {
      < -0.360064, -1.037329, 0.282141>,
      < -0.264201, -1.068011, 0.317045>,
      < -0.264223, -1.031717, 0.317012>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360049, -1.062576, 0.282163>,
      < -0.360064, -1.037329, 0.282141>
    }
    triangle {
      < 1.415596, -1.055247, 0.242299>,
      < 1.415603, -1.067256, 0.238410>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314707, -1.055307, 0.242299>,
      < 1.314714, -1.067316, 0.238410>,
      < 1.415603, -1.067256, 0.238410>
    }
    triangle {
      < 1.314707, -1.055307, 0.242299>,
      < 1.415603, -1.067256, 0.238410>,
      < 1.415596, -1.055247, 0.242299>
    }
    triangle {
      < 1.284443, -1.061601, 0.282163>,
      < 1.284457, -1.085620, 0.274384>,
      < 1.314714, -1.067316, 0.238410>
    }
    triangle {
      < 1.284443, -1.061601, 0.282163>,
      < 1.314714, -1.067316, 0.238410>,
      < 1.314707, -1.055307, 0.242299>
    }
    triangle {
      < 1.198692, -1.069497, 0.331994>,
      < 1.198715, -1.108528, 0.319354>,
      < 1.284457, -1.085620, 0.274384>
    }
    triangle {
      < 1.198692, -1.069497, 0.331994>,
      < 1.284457, -1.085620, 0.274384>,
      < 1.284443, -1.061601, 0.282163>
    }
    triangle {
      < 0.093956, -1.070151, 0.331994>,
      < 0.093979, -1.109182, 0.319353>,
      < 1.198715, -1.108528, 0.319354>
    }
    triangle {
      < 0.093956, -1.070151, 0.331994>,
      < 1.198715, -1.108528, 0.319354>,
      < 1.198692, -1.069497, 0.331994>
    }
    triangle {
      < 0.063689, -1.068600, 0.322028>,
      < 0.063711, -1.104629, 0.310360>,
      < 0.093979, -1.109182, 0.319353>
    }
    triangle {
      < 0.063689, -1.068600, 0.322028>,
      < 0.093979, -1.109182, 0.319353>,
      < 0.093956, -1.070151, 0.331994>
    }
    triangle {
      < -0.264201, -1.068011, 0.317045>,
      < -0.264181, -1.102538, 0.305862>,
      < 0.063711, -1.104629, 0.310360>
    }
    triangle {
      < -0.264201, -1.068011, 0.317045>,
      < 0.063711, -1.104629, 0.310360>,
      < 0.063689, -1.068600, 0.322028>
    }
    triangle {
      < -0.360049, -1.062576, 0.282163>,
      < -0.360035, -1.086595, 0.274384>,
      < -0.264181, -1.102538, 0.305862>
    }
    triangle {
      < -0.360049, -1.062576, 0.282163>,
      < -0.264181, -1.102538, 0.305862>,
      < -0.264201, -1.068011, 0.317045>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360035, -1.086595, 0.274384>,
      < -0.360049, -1.062576, 0.282163>
    }
    triangle {
      < 1.415603, -1.067256, 0.238410>,
      < 1.415609, -1.077509, 0.230966>,
      < 1.415592, -1.048970, 0.202434>
    }
    triangle {
      < 1.314714, -1.067316, 0.238410>,
      < 1.314720, -1.077569, 0.230966>,
      < 1.415609, -1.077509, 0.230966>
    }
    triangle {
      < 1.314714, -1.067316, 0.238410>,
      < 1.415609, -1.077509, 0.230966>,
      < 1.415603, -1.067256, 0.238410>
    }
    triangle {
      < 1.284457, -1.085620, 0.274384>,
      < 1.284470, -1.106128, 0.259497>,
      < 1.314720, -1.077569, 0.230966>
    }
    triangle {
      < 1.284457, -1.085620, 0.274384>,
      < 1.314720, -1.077569, 0.230966>,
      < 1.314714, -1.067316, 0.238410>
    }
    triangle {
      < 1.198715, -1.108528, 0.319354>,
      < 1.198735, -1.141853, 0.295162>,
      < 1.284470, -1.106128, 0.259497>
    }
    triangle {
      < 1.198715, -1.108528, 0.319354>,
      < 1.284470, -1.106128, 0.259497>,
      < 1.284457, -1.085620, 0.274384>
    }
    triangle {
      < 0.093979, -1.109182, 0.319353>,
      < 0.093999, -1.142508, 0.295161>,
      < 1.198735, -1.141853, 0.295162>
    }
    triangle {
      < 0.093979, -1.109182, 0.319353>,
      < 1.198735, -1.141853, 0.295162>,
      < 1.198715, -1.108528, 0.319354>
    }
    triangle {
      < 0.063711, -1.104629, 0.310360>,
      < 0.063729, -1.135390, 0.288029>,
      < 0.093999, -1.142508, 0.295161>
    }
    triangle {
      < 0.063711, -1.104629, 0.310360>,
      < 0.093999, -1.142508, 0.295161>,
      < 0.093979, -1.109182, 0.319353>
    }
    triangle {
      < -0.264181, -1.102538, 0.305862>,
      < -0.264163, -1.132018, 0.284463>,
      < 0.063729, -1.135390, 0.288029>
    }
    triangle {
      < -0.264181, -1.102538, 0.305862>,
      < 0.063729, -1.135390, 0.288029>,
      < 0.063711, -1.104629, 0.310360>
    }
    triangle {
      < -0.360035, -1.086595, 0.274384>,
      < -0.360023, -1.107103, 0.259497>,
      < -0.264163, -1.132018, 0.284463>
    }
    triangle {
      < -0.360035, -1.086595, 0.274384>,
      < -0.264163, -1.132018, 0.284463>,
      < -0.264181, -1.102538, 0.305862>
    }
    triangle {
      < -0.425635, -1.050061, 0.202434>,
      < -0.360023, -1.107103, 0.259497>,
      < -0.360035, -1.086595, 0.274384>
    }
    triangle {
      < -0.307563, -1.226672, 0.003516>,
      < -0.307667, -1.050981, 0.179155>,
      < -0.077483, -1.050844, 0.179155>
    }
    triangle {
      < -0.307563, -1.226672, 0.003516>,
      < -0.077483, -1.050844, 0.179155>,
      < -0.077379, -1.226535, 0.003516>
    }
    triangle {
      < -0.077366, -1.248826, 0.025813>,
      < -0.077470, -1.073135, 0.201451>,
      < -0.307654, -1.073272, 0.201451>
    }
    triangle {
      < -0.077366, -1.248826, 0.025813>,
      < -0.307654, -1.073272, 0.201451>,
      < -0.307550, -1.248963, 0.025813>
    }
    triangle {
      < -0.307550, -1.248963, 0.025813>,
      < -0.307654, -1.073272, 0.201451>,
      < -0.307667, -1.050981, 0.179155>
    }
    triangle {
      < -0.307550, -1.248963, 0.025813>,
      < -0.307667, -1.050981, 0.179155>,
      < -0.307563, -1.226672, 0.003516>
    }
    triangle {
      < -0.307550, -1.248963, 0.025813>,
      < -0.307563, -1.226672, 0.003516>,
      < -0.077379, -1.226535, 0.003516>
    }
    triangle {
      < -0.307550, -1.248963, 0.025813>,
      < -0.077379, -1.226535, 0.003516>,
      < -0.077366, -1.248826, 0.025813>
    }
    triangle {
      < -0.077379, -1.226535, 0.003516>,
      < -0.077483, -1.050844, 0.179155>,
      < -0.077470, -1.073135, 0.201451>
    }
    triangle {
      < -0.077379, -1.226535, 0.003516>,
      < -0.077470, -1.073135, 0.201451>,
      < -0.077366, -1.248826, 0.025813>
    }
    triangle {
      < -0.307667, -1.050981, 0.179155>,
      < -0.307654, -1.073272, 0.201451>,
      < -0.077470, -1.073135, 0.201451>
    }
    triangle {
      < -0.307667, -1.050981, 0.179155>,
      < -0.077470, -1.073135, 0.201451>,
      < -0.077483, -1.050844, 0.179155>
    }
    triangle {
      < 0.019424, -1.226478, 0.003516>,
      < 0.019320, -1.050787, 0.179155>,
      < 0.249503, -1.050650, 0.179155>
    }
    triangle {
      < 0.019424, -1.226478, 0.003516>,
      < 0.249503, -1.050650, 0.179155>,
      < 0.249607, -1.226341, 0.003516>
    }
    triangle {
      < 0.249620, -1.248632, 0.025813>,
      < 0.249516, -1.072941, 0.201451>,
      < 0.019333, -1.073078, 0.201451>
    }
    triangle {
      < 0.249620, -1.248632, 0.025813>,
      < 0.019333, -1.073078, 0.201451>,
      < 0.019437, -1.248769, 0.025813>
    }
    triangle {
      < 0.019437, -1.248769, 0.025813>,
      < 0.019333, -1.073078, 0.201451>,
      < 0.019320, -1.050787, 0.179155>
    }
    triangle {
      < 0.019437, -1.248769, 0.025813>,
      < 0.019320, -1.050787, 0.179155>,
      < 0.019424, -1.226478, 0.003516>
    }
    triangle {
      < 0.019437, -1.248769, 0.025813>,
      < 0.019424, -1.226478, 0.003516>,
      < 0.249607, -1.226341, 0.003516>
    }
    triangle {
      < 0.019437, -1.248769, 0.025813>,
      < 0.249607, -1.226341, 0.003516>,
      < 0.249620, -1.248632, 0.025813>
    }
    triangle {
      < 0.249607, -1.226341, 0.003516>,
      < 0.249503, -1.050650, 0.179155>,
      < 0.249516, -1.072941, 0.201451>
    }
    triangle {
      < 0.249607, -1.226341, 0.003516>,
      < 0.249516, -1.072941, 0.201451>,
      < 0.249620, -1.248632, 0.025813>
    }
    triangle {
      < 0.019320, -1.050787, 0.179155>,
      < 0.019333, -1.073078, 0.201451>,
      < 0.249516, -1.072941, 0.201451>
    }
    triangle {
      < 0.019320, -1.050787, 0.179155>,
      < 0.249516, -1.072941, 0.201451>,
      < 0.249503, -1.050650, 0.179155>
    }
    triangle {
      < -0.307786, -0.851127, 0.025695>,
      < -0.307682, -1.026712, 0.201438>,
      < -0.077498, -1.026576, 0.201438>
    }
    triangle {
      < -0.307786, -0.851127, 0.025695>,
      < -0.077498, -1.026576, 0.201438>,
      < -0.077602, -0.850990, 0.025695>
    }
    triangle {
      < -0.077588, -0.873292, 0.003411>,
      < -0.077484, -1.048879, 0.179154>,
      < -0.307668, -1.049015, 0.179154>
    }
    triangle {
      < -0.077588, -0.873292, 0.003411>,
      < -0.307668, -1.049015, 0.179154>,
      < -0.307772, -0.873429, 0.003411>
    }
    triangle {
      < -0.307772, -0.873429, 0.003411>,
      < -0.307668, -1.049015, 0.179154>,
      < -0.307682, -1.026712, 0.201438>
    }
    triangle {
      < -0.307772, -0.873429, 0.003411>,
      < -0.307682, -1.026712, 0.201438>,
      < -0.307786, -0.851127, 0.025695>
    }
    triangle {
      < -0.307772, -0.873429, 0.003411>,
      < -0.307786, -0.851127, 0.025695>,
      < -0.077602, -0.850990, 0.025695>
    }
    triangle {
      < -0.307772, -0.873429, 0.003411>,
      < -0.077602, -0.850990, 0.025695>,
      < -0.077588, -0.873292, 0.003411>
    }
    triangle {
      < -0.077602, -0.850990, 0.025695>,
      < -0.077498, -1.026576, 0.201438>,
      < -0.077484, -1.048879, 0.179154>
    }
    triangle {
      < -0.077602, -0.850990, 0.025695>,
      < -0.077484, -1.048879, 0.179154>,
      < -0.077588, -0.873292, 0.003411>
    }
    triangle {
      < -0.307682, -1.026712, 0.201438>,
      < -0.307668, -1.049015, 0.179154>,
      < -0.077484, -1.048879, 0.179154>
    }
    triangle {
      < -0.307682, -1.026712, 0.201438>,
      < -0.077484, -1.048879, 0.179154>,
      < -0.077498, -1.026576, 0.201438>
    }
    triangle {
      < 0.019201, -0.850933, 0.025695>,
      < 0.019305, -1.026519, 0.201438>,
      < 0.249488, -1.026382, 0.201438>
    }
    triangle {
      < 0.019201, -0.850933, 0.025695>,
      < 0.249488, -1.026382, 0.201438>,
      < 0.249384, -0.850796, 0.025695>
    }
    triangle {
      < 0.249397, -0.873098, 0.003411>,
      < 0.249501, -1.048685, 0.179154>,
      < 0.019319, -1.048822, 0.179154>
    }
    triangle {
      < 0.249397, -0.873098, 0.003411>,
      < 0.019319, -1.048822, 0.179154>,
      < 0.019214, -0.873235, 0.003411>
    }
    triangle {
      < 0.019214, -0.873235, 0.003411>,
      < 0.019319, -1.048822, 0.179154>,
      < 0.019305, -1.026519, 0.201438>
    }
    triangle {
      < 0.019214, -0.873235, 0.003411>,
      < 0.019305, -1.026519, 0.201438>,
      < 0.019201, -0.850933, 0.025695>
    }
    triangle {
      < 0.019214, -0.873235, 0.003411>,
      < 0.019201, -0.850933, 0.025695>,
      < 0.249384, -0.850796, 0.025695>
    }
    triangle {
      < 0.019214, -0.873235, 0.003411>,
      < 0.249384, -0.850796, 0.025695>,
      < 0.249397, -0.873098, 0.003411>
    }
    triangle {
      < 0.249384, -0.850796, 0.025695>,
      < 0.249488, -1.026382, 0.201438>,
      < 0.249501, -1.048685, 0.179154>
    }
    triangle {
      < 0.249384, -0.850796, 0.025695>,
      < 0.249501, -1.048685, 0.179154>,
      < 0.249397, -0.873098, 0.003411>
    }
    triangle {
      < 0.019305, -1.026519, 0.201438>,
      < 0.019319, -1.048822, 0.179154>,
      < 0.249501, -1.048685, 0.179154>
    }
    triangle {
      < 0.019305, -1.026519, 0.201438>,
      < 0.249501, -1.048685, 0.179154>,
      < 0.249488, -1.026382, 0.201438>
    }
    triangle {
      < -0.307773, -0.873194, 0.401248>,
      < -0.307668, -1.048988, 0.225713>,
      < -0.077484, -1.048852, 0.225713>
    }
    triangle {
      < -0.307773, -0.873194, 0.401248>,
      < -0.077484, -1.048852, 0.225713>,
      < -0.077589, -0.873057, 0.401248>
    }
    triangle {
      < -0.077602, -0.850780, 0.378938>,
      < -0.077498, -1.026574, 0.203404>,
      < -0.307682, -1.026711, 0.203404>
    }
    triangle {
      < -0.077602, -0.850780, 0.378938>,
      < -0.307682, -1.026711, 0.203404>,
      < -0.307786, -0.850917, 0.378938>
    }
    triangle {
      < -0.307786, -0.850917, 0.378938>,
      < -0.307682, -1.026711, 0.203404>,
      < -0.307668, -1.048988, 0.225713>
    }
    triangle {
      < -0.307786, -0.850917, 0.378938>,
      < -0.307668, -1.048988, 0.225713>,
      < -0.307773, -0.873194, 0.401248>
    }
    triangle {
      < -0.307786, -0.850917, 0.378938>,
      < -0.307773, -0.873194, 0.401248>,
      < -0.077589, -0.873057, 0.401248>
    }
    triangle {
      < -0.307786, -0.850917, 0.378938>,
      < -0.077589, -0.873057, 0.401248>,
      < -0.077602, -0.850780, 0.378938>
    }
    triangle {
      < -0.077589, -0.873057, 0.401248>,
      < -0.077484, -1.048852, 0.225713>,
      < -0.077498, -1.026574, 0.203404>
    }
    triangle {
      < -0.077589, -0.873057, 0.401248>,
      < -0.077498, -1.026574, 0.203404>,
      < -0.077602, -0.850780, 0.378938>
    }
    triangle {
      < -0.307668, -1.048988, 0.225713>,
      < -0.307682, -1.026711, 0.203404>,
      < -0.077498, -1.026574, 0.203404>
    }
    triangle {
      < -0.307668, -1.048988, 0.225713>,
      < -0.077498, -1.026574, 0.203404>,
      < -0.077484, -1.048852, 0.225713>
    }
    triangle {
      < 0.019214, -0.873000, 0.401248>,
      < 0.019319, -1.048795, 0.225713>,
      < 0.249501, -1.048658, 0.225713>
    }
    triangle {
      < 0.019214, -0.873000, 0.401248>,
      < 0.249501, -1.048658, 0.225713>,
      < 0.249397, -0.872863, 0.401248>
    }
    triangle {
      < 0.249384, -0.850586, 0.378938>,
      < 0.249488, -1.026380, 0.203404>,
      < 0.019305, -1.026517, 0.203404>
    }
    triangle {
      < 0.249384, -0.850586, 0.378938>,
      < 0.019305, -1.026517, 0.203404>,
      < 0.019201, -0.850723, 0.378938>
    }
    triangle {
      < 0.019201, -0.850723, 0.378938>,
      < 0.019305, -1.026517, 0.203404>,
      < 0.019319, -1.048795, 0.225713>
    }
    triangle {
      < 0.019201, -0.850723, 0.378938>,
      < 0.019319, -1.048795, 0.225713>,
      < 0.019214, -0.873000, 0.401248>
    }
    triangle {
      < 0.019201, -0.850723, 0.378938>,
      < 0.019214, -0.873000, 0.401248>,
      < 0.249397, -0.872863, 0.401248>
    }
    triangle {
      < 0.019201, -0.850723, 0.378938>,
      < 0.249397, -0.872863, 0.401248>,
      < 0.249384, -0.850586, 0.378938>
    }
    triangle {
      < 0.249397, -0.872863, 0.401248>,
      < 0.249501, -1.048658, 0.225713>,
      < 0.249488, -1.026380, 0.203404>
    }
    triangle {
      < 0.249397, -0.872863, 0.401248>,
      < 0.249488, -1.026380, 0.203404>,
      < 0.249384, -0.850586, 0.378938>
    }
    triangle {
      < 0.019319, -1.048795, 0.225713>,
      < 0.019305, -1.026517, 0.203404>,
      < 0.249488, -1.026380, 0.203404>
    }
    triangle {
      < 0.019319, -1.048795, 0.225713>,
      < 0.249488, -1.026380, 0.203404>,
      < 0.249501, -1.048658, 0.225713>
    }
    triangle {
      < -0.307550, -1.248753, 0.379291>,
      < -0.307654, -1.073270, 0.203445>,
      < -0.077470, -1.073134, 0.203445>
    }
    triangle {
      < -0.307550, -1.248753, 0.379291>,
      < -0.077470, -1.073134, 0.203445>,
      < -0.077366, -1.248616, 0.379291>
    }
    triangle {
      < -0.077379, -1.226300, 0.401562>,
      < -0.077483, -1.050817, 0.225715>,
      < -0.307667, -1.050954, 0.225715>
    }
    triangle {
      < -0.077379, -1.226300, 0.401562>,
      < -0.307667, -1.050954, 0.225715>,
      < -0.307563, -1.226437, 0.401562>
    }
    triangle {
      < -0.307563, -1.226437, 0.401562>,
      < -0.307667, -1.050954, 0.225715>,
      < -0.307654, -1.073270, 0.203445>
    }
    triangle {
      < -0.307563, -1.226437, 0.401562>,
      < -0.307654, -1.073270, 0.203445>,
      < -0.307550, -1.248753, 0.379291>
    }
    triangle {
      < -0.307563, -1.226437, 0.401562>,
      < -0.307550, -1.248753, 0.379291>,
      < -0.077366, -1.248616, 0.379291>
    }
    triangle {
      < -0.307563, -1.226437, 0.401562>,
      < -0.077366, -1.248616, 0.379291>,
      < -0.077379, -1.226300, 0.401562>
    }
    triangle {
      < -0.077366, -1.248616, 0.379291>,
      < -0.077470, -1.073134, 0.203445>,
      < -0.077483, -1.050817, 0.225715>
    }
    triangle {
      < -0.077366, -1.248616, 0.379291>,
      < -0.077483, -1.050817, 0.225715>,
      < -0.077379, -1.226300, 0.401562>
    }
    triangle {
      < -0.307654, -1.073270, 0.203445>,
      < -0.307667, -1.050954, 0.225715>,
      < -0.077483, -1.050817, 0.225715>
    }
    triangle {
      < -0.307654, -1.073270, 0.203445>,
      < -0.077483, -1.050817, 0.225715>,
      < -0.077470, -1.073134, 0.203445>
    }
    triangle {
      < 0.019437, -1.248559, 0.379291>,
      < 0.019333, -1.073077, 0.203445>,
      < 0.249516, -1.072940, 0.203445>
    }
    triangle {
      < 0.019437, -1.248559, 0.379291>,
      < 0.249516, -1.072940, 0.203445>,
      < 0.249620, -1.248422, 0.379291>
    }
    triangle {
      < 0.249607, -1.226106, 0.401562>,
      < 0.249503, -1.050623, 0.225715>,
      < 0.019320, -1.050760, 0.225715>
    }
    triangle {
      < 0.249607, -1.226106, 0.401562>,
      < 0.019320, -1.050760, 0.225715>,
      < 0.019424, -1.226243, 0.401562>
    }
    triangle {
      < 0.019424, -1.226243, 0.401562>,
      < 0.019320, -1.050760, 0.225715>,
      < 0.019333, -1.073077, 0.203445>
    }
    triangle {
      < 0.019424, -1.226243, 0.401562>,
      < 0.019333, -1.073077, 0.203445>,
      < 0.019437, -1.248559, 0.379291>
    }
    triangle {
      < 0.019424, -1.226243, 0.401562>,
      < 0.019437, -1.248559, 0.379291>,
      < 0.249620, -1.248422, 0.379291>
    }
    triangle {
      < 0.019424, -1.226243, 0.401562>,
      < 0.249620, -1.248422, 0.379291>,
      < 0.249607, -1.226106, 0.401562>
    }
    triangle {
      < 0.249620, -1.248422, 0.379291>,
      < 0.249516, -1.072940, 0.203445>,
      < 0.249503, -1.050623, 0.225715>
    }
    triangle {
      < 0.249620, -1.248422, 0.379291>,
      < 0.249503, -1.050623, 0.225715>,
      < 0.249607, -1.226106, 0.401562>
    }
    triangle {
      < 0.019333, -1.073077, 0.203445>,
      < 0.019320, -1.050760, 0.225715>,
      < 0.249503, -1.050623, 0.225715>
    }
    triangle {
      < 0.019333, -1.073077, 0.203445>,
      < 0.249503, -1.050623, 0.225715>,
      < 0.249516, -1.072940, 0.203445>
    }
    triangle {
      < 1.900241, -0.398955, 4.934879>,
      < 1.900245, -0.405631, 4.925687>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764781, -0.399035, 4.934879>,
      < 1.764786, -0.405711, 4.925687>,
      < 1.900245, -0.405631, 4.925687>
    }
    triangle {
      < 1.764781, -0.399035, 4.934879>,
      < 1.900245, -0.405631, 4.925687>,
      < 1.900241, -0.398955, 4.934879>
    }
    triangle {
      < 1.724159, -0.424745, 4.960557>,
      < 1.724167, -0.438099, 4.942173>,
      < 1.764786, -0.405711, 4.925687>
    }
    triangle {
      < 1.724159, -0.424745, 4.960557>,
      < 1.764786, -0.405711, 4.925687>,
      < 1.764781, -0.399035, 4.934879>
    }
    triangle {
      < 1.609036, -0.456921, 4.992655>,
      < 1.609049, -0.478622, 4.962781>,
      < 1.724167, -0.438099, 4.942173>
    }
    triangle {
      < 1.609036, -0.456921, 4.992655>,
      < 1.724167, -0.438099, 4.942173>,
      < 1.724159, -0.424745, 4.960557>
    }
    triangle {
      < 0.125748, -0.457799, 4.992655>,
      < 0.125761, -0.479500, 4.962780>,
      < 1.609049, -0.478622, 4.962781>
    }
    triangle {
      < 0.125748, -0.457799, 4.992655>,
      < 1.609049, -0.478622, 4.962781>,
      < 1.609036, -0.456921, 4.992655>
    }
    triangle {
      < 0.085106, -0.451403, 4.986236>,
      < 0.085118, -0.471433, 4.958659>,
      < 0.125761, -0.479500, 4.962780>
    }
    triangle {
      < 0.085106, -0.451403, 4.986236>,
      < 0.125761, -0.479500, 4.962780>,
      < 0.125748, -0.457799, 4.992655>
    }
    triangle {
      < -0.355142, -0.448452, 4.983025>,
      < -0.355130, -0.467649, 4.956598>,
      < 0.085118, -0.471433, 4.958659>
    }
    triangle {
      < -0.355142, -0.448452, 4.983025>,
      < 0.085118, -0.471433, 4.958659>,
      < 0.085106, -0.451403, 4.986236>
    }
    triangle {
      < -0.483842, -0.426054, 4.960557>,
      < -0.483835, -0.439408, 4.942173>,
      < -0.355130, -0.467649, 4.956598>
    }
    triangle {
      < -0.483842, -0.426054, 4.960557>,
      < -0.355130, -0.467649, 4.956598>,
      < -0.355142, -0.448452, 4.983025>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483835, -0.439408, 4.942173>,
      < -0.483842, -0.426054, 4.960557>
    }
    triangle {
      < 1.900245, -0.405631, 4.925687>,
      < 1.900247, -0.409142, 4.914882>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764786, -0.405711, 4.925687>,
      < 1.764787, -0.409222, 4.914882>,
      < 1.900247, -0.409142, 4.914882>
    }
    triangle {
      < 1.764786, -0.405711, 4.925687>,
      < 1.900247, -0.409142, 4.914882>,
      < 1.900245, -0.405631, 4.925687>
    }
    triangle {
      < 1.724167, -0.438099, 4.942173>,
      < 1.724170, -0.445119, 4.920562>,
      < 1.764787, -0.409222, 4.914882>
    }
    triangle {
      < 1.724167, -0.438099, 4.942173>,
      < 1.764787, -0.409222, 4.914882>,
      < 1.764786, -0.405711, 4.925687>
    }
    triangle {
      < 1.609049, -0.478622, 4.962781>,
      < 1.609056, -0.490029, 4.927663>,
      < 1.724170, -0.445119, 4.920562>
    }
    triangle {
      < 1.609049, -0.478622, 4.962781>,
      < 1.724170, -0.445119, 4.920562>,
      < 1.724167, -0.438099, 4.942173>
    }
    triangle {
      < 0.125761, -0.479500, 4.962780>,
      < 0.125767, -0.490907, 4.927662>,
      < 1.609056, -0.490029, 4.927663>
    }
    triangle {
      < 0.125761, -0.479500, 4.962780>,
      < 1.609056, -0.490029, 4.927663>,
      < 1.609049, -0.478622, 4.962781>
    }
    triangle {
      < 0.085118, -0.471433, 4.958659>,
      < 0.085124, -0.481963, 4.926243>,
      < 0.125767, -0.490907, 4.927662>
    }
    triangle {
      < 0.085118, -0.471433, 4.958659>,
      < 0.125767, -0.490907, 4.927662>,
      < 0.125761, -0.479500, 4.962780>
    }
    triangle {
      < -0.355130, -0.467649, 4.956598>,
      < -0.355124, -0.477740, 4.925533>,
      < 0.085124, -0.481963, 4.926243>
    }
    triangle {
      < -0.355130, -0.467649, 4.956598>,
      < 0.085124, -0.481963, 4.926243>,
      < 0.085118, -0.471433, 4.958659>
    }
    triangle {
      < -0.483835, -0.439408, 4.942173>,
      < -0.483830, -0.446428, 4.920561>,
      < -0.355124, -0.477740, 4.925533>
    }
    triangle {
      < -0.483835, -0.439408, 4.942173>,
      < -0.355124, -0.477740, 4.925533>,
      < -0.355130, -0.467649, 4.956598>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483830, -0.446428, 4.920561>,
      < -0.483835, -0.439408, 4.942173>
    }
    triangle {
      < 1.900247, -0.409142, 4.914882>,
      < 1.900247, -0.409141, 4.903520>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764787, -0.409222, 4.914882>,
      < 1.764787, -0.409221, 4.903520>,
      < 1.900247, -0.409141, 4.903520>
    }
    triangle {
      < 1.764787, -0.409222, 4.914882>,
      < 1.900247, -0.409141, 4.903520>,
      < 1.900247, -0.409142, 4.914882>
    }
    triangle {
      < 1.724170, -0.445119, 4.920562>,
      < 1.724170, -0.445120, 4.897840>,
      < 1.764787, -0.409221, 4.903520>
    }
    triangle {
      < 1.724170, -0.445119, 4.920562>,
      < 1.764787, -0.409221, 4.903520>,
      < 1.764787, -0.409222, 4.914882>
    }
    triangle {
      < 1.609056, -0.490029, 4.927663>,
      < 1.609056, -0.490029, 4.890738>,
      < 1.724170, -0.445120, 4.897840>
    }
    triangle {
      < 1.609056, -0.490029, 4.927663>,
      < 1.724170, -0.445120, 4.897840>,
      < 1.724170, -0.445119, 4.920562>
    }
    triangle {
      < 0.125767, -0.490907, 4.927662>,
      < 0.125767, -0.490908, 4.890738>,
      < 1.609056, -0.490029, 4.890738>
    }
    triangle {
      < 0.125767, -0.490907, 4.927662>,
      < 1.609056, -0.490029, 4.890738>,
      < 1.609056, -0.490029, 4.927663>
    }
    triangle {
      < 0.085124, -0.481963, 4.926243>,
      < 0.085124, -0.481963, 4.892159>,
      < 0.125767, -0.490908, 4.890738>
    }
    triangle {
      < 0.085124, -0.481963, 4.926243>,
      < 0.125767, -0.490908, 4.890738>,
      < 0.125767, -0.490907, 4.927662>
    }
    triangle {
      < -0.355124, -0.477740, 4.925533>,
      < -0.355124, -0.477740, 4.892869>,
      < 0.085124, -0.481963, 4.892159>
    }
    triangle {
      < -0.355124, -0.477740, 4.925533>,
      < 0.085124, -0.481963, 4.892159>,
      < 0.085124, -0.481963, 4.926243>
    }
    triangle {
      < -0.483830, -0.446428, 4.920561>,
      < -0.483830, -0.446428, 4.897839>,
      < -0.355124, -0.477740, 4.892869>
    }
    triangle {
      < -0.483830, -0.446428, 4.920561>,
      < -0.355124, -0.477740, 4.892869>,
      < -0.355124, -0.477740, 4.925533>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483830, -0.446428, 4.897839>,
      < -0.483830, -0.446428, 4.920561>
    }
    triangle {
      < 1.900247, -0.409141, 4.903520>,
      < 1.900245, -0.405631, 4.892715>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764787, -0.409221, 4.903520>,
      < 1.764786, -0.405712, 4.892715>,
      < 1.900245, -0.405631, 4.892715>
    }
    triangle {
      < 1.764787, -0.409221, 4.903520>,
      < 1.900245, -0.405631, 4.892715>,
      < 1.900247, -0.409141, 4.903520>
    }
    triangle {
      < 1.724170, -0.445120, 4.897840>,
      < 1.724167, -0.438099, 4.876228>,
      < 1.764786, -0.405712, 4.892715>
    }
    triangle {
      < 1.724170, -0.445120, 4.897840>,
      < 1.764786, -0.405712, 4.892715>,
      < 1.764787, -0.409221, 4.903520>
    }
    triangle {
      < 1.609056, -0.490029, 4.890738>,
      < 1.609050, -0.478621, 4.855620>,
      < 1.724167, -0.438099, 4.876228>
    }
    triangle {
      < 1.609056, -0.490029, 4.890738>,
      < 1.724167, -0.438099, 4.876228>,
      < 1.724170, -0.445120, 4.897840>
    }
    triangle {
      < 0.125767, -0.490908, 4.890738>,
      < 0.125761, -0.479500, 4.855620>,
      < 1.609050, -0.478621, 4.855620>
    }
    triangle {
      < 0.125767, -0.490908, 4.890738>,
      < 1.609050, -0.478621, 4.855620>,
      < 1.609056, -0.490029, 4.890738>
    }
    triangle {
      < 0.085124, -0.481963, 4.892159>,
      < 0.085118, -0.471433, 4.859743>,
      < 0.125761, -0.479500, 4.855620>
    }
    triangle {
      < 0.085124, -0.481963, 4.892159>,
      < 0.125761, -0.479500, 4.855620>,
      < 0.125767, -0.490908, 4.890738>
    }
    triangle {
      < -0.355124, -0.477740, 4.892869>,
      < -0.355130, -0.467649, 4.861803>,
      < 0.085118, -0.471433, 4.859743>
    }
    triangle {
      < -0.355124, -0.477740, 4.892869>,
      < 0.085118, -0.471433, 4.859743>,
      < 0.085124, -0.481963, 4.892159>
    }
    triangle {
      < -0.483830, -0.446428, 4.897839>,
      < -0.483835, -0.439407, 4.876227>,
      < -0.355130, -0.467649, 4.861803>
    }
    triangle {
      < -0.483830, -0.446428, 4.897839>,
      < -0.355130, -0.467649, 4.861803>,
      < -0.355124, -0.477740, 4.892869>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483835, -0.439407, 4.876227>,
      < -0.483830, -0.446428, 4.897839>
    }
    triangle {
      < 1.900245, -0.405631, 4.892715>,
      < 1.900241, -0.398954, 4.883523>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764786, -0.405712, 4.892715>,
      < 1.764781, -0.399034, 4.883523>,
      < 1.900241, -0.398954, 4.883523>
    }
    triangle {
      < 1.764786, -0.405712, 4.892715>,
      < 1.900241, -0.398954, 4.883523>,
      < 1.900245, -0.405631, 4.892715>
    }
    triangle {
      < 1.724167, -0.438099, 4.876228>,
      < 1.724159, -0.424745, 4.857844>,
      < 1.764781, -0.399034, 4.883523>
    }
    triangle {
      < 1.724167, -0.438099, 4.876228>,
      < 1.764781, -0.399034, 4.883523>,
      < 1.764786, -0.405712, 4.892715>
    }
    triangle {
      < 1.609050, -0.478621, 4.855620>,
      < 1.609036, -0.456921, 4.825746>,
      < 1.724159, -0.424745, 4.857844>
    }
    triangle {
      < 1.609050, -0.478621, 4.855620>,
      < 1.724159, -0.424745, 4.857844>,
      < 1.724167, -0.438099, 4.876228>
    }
    triangle {
      < 0.125761, -0.479500, 4.855620>,
      < 0.125748, -0.457800, 4.825746>,
      < 1.609036, -0.456921, 4.825746>
    }
    triangle {
      < 0.125761, -0.479500, 4.855620>,
      < 1.609036, -0.456921, 4.825746>,
      < 1.609050, -0.478621, 4.855620>
    }
    triangle {
      < 0.085118, -0.471433, 4.859743>,
      < 0.085106, -0.451402, 4.832165>,
      < 0.125748, -0.457800, 4.825746>
    }
    triangle {
      < 0.085118, -0.471433, 4.859743>,
      < 0.125748, -0.457800, 4.825746>,
      < 0.125761, -0.479500, 4.855620>
    }
    triangle {
      < -0.355130, -0.467649, 4.861803>,
      < -0.355142, -0.448453, 4.835376>,
      < 0.085106, -0.451402, 4.832165>
    }
    triangle {
      < -0.355130, -0.467649, 4.861803>,
      < 0.085106, -0.451402, 4.832165>,
      < 0.085118, -0.471433, 4.859743>
    }
    triangle {
      < -0.483835, -0.439407, 4.876227>,
      < -0.483842, -0.426054, 4.857844>,
      < -0.355142, -0.448453, 4.835376>
    }
    triangle {
      < -0.483835, -0.439407, 4.876227>,
      < -0.355142, -0.448453, 4.835376>,
      < -0.355130, -0.467649, 4.861803>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483842, -0.426054, 4.857844>,
      < -0.483835, -0.439407, 4.876227>
    }
    triangle {
      < 1.900241, -0.398954, 4.883523>,
      < 1.900236, -0.389765, 4.876842>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764781, -0.399034, 4.883523>,
      < 1.764776, -0.389845, 4.876842>,
      < 1.900236, -0.389765, 4.876842>
    }
    triangle {
      < 1.764781, -0.399034, 4.883523>,
      < 1.900236, -0.389765, 4.876842>,
      < 1.900241, -0.398954, 4.883523>
    }
    triangle {
      < 1.724159, -0.424745, 4.857844>,
      < 1.724148, -0.406364, 4.844485>,
      < 1.764776, -0.389845, 4.876842>
    }
    triangle {
      < 1.724159, -0.424745, 4.857844>,
      < 1.764776, -0.389845, 4.876842>,
      < 1.764781, -0.399034, 4.883523>
    }
    triangle {
      < 1.609036, -0.456921, 4.825746>,
      < 1.609019, -0.427053, 4.804037>,
      < 1.724148, -0.406364, 4.844485>
    }
    triangle {
      < 1.609036, -0.456921, 4.825746>,
      < 1.724148, -0.406364, 4.844485>,
      < 1.724159, -0.424745, 4.857844>
    }
    triangle {
      < 0.125748, -0.457800, 4.825746>,
      < 0.125730, -0.427932, 4.804037>,
      < 1.609019, -0.427053, 4.804037>
    }
    triangle {
      < 0.125748, -0.457800, 4.825746>,
      < 1.609019, -0.427053, 4.804037>,
      < 1.609036, -0.456921, 4.825746>
    }
    triangle {
      < 0.085106, -0.451402, 4.832165>,
      < 0.085090, -0.423832, 4.812126>,
      < 0.125730, -0.427932, 4.804037>
    }
    triangle {
      < 0.085106, -0.451402, 4.832165>,
      < 0.125730, -0.427932, 4.804037>,
      < 0.125748, -0.457800, 4.825746>
    }
    triangle {
      < -0.355142, -0.448453, 4.835376>,
      < -0.355157, -0.422030, 4.816171>,
      < 0.085090, -0.423832, 4.812126>
    }
    triangle {
      < -0.355142, -0.448453, 4.835376>,
      < 0.085090, -0.423832, 4.812126>,
      < 0.085106, -0.451402, 4.832165>
    }
    triangle {
      < -0.483842, -0.426054, 4.857844>,
      < -0.483853, -0.407673, 4.844484>,
      < -0.355157, -0.422030, 4.816171>
    }
    triangle {
      < -0.483842, -0.426054, 4.857844>,
      < -0.355157, -0.422030, 4.816171>,
      < -0.355142, -0.448453, 4.835376>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483853, -0.407673, 4.844484>,
      < -0.483842, -0.426054, 4.857844>
    }
    triangle {
      < 1.900236, -0.389765, 4.876842>,
      < 1.900229, -0.378961, 4.873330>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764776, -0.389845, 4.876842>,
      < 1.764769, -0.379041, 4.873330>,
      < 1.900229, -0.378961, 4.873330>
    }
    triangle {
      < 1.764776, -0.389845, 4.876842>,
      < 1.900229, -0.378961, 4.873330>,
      < 1.900236, -0.389765, 4.876842>
    }
    triangle {
      < 1.724148, -0.406364, 4.844485>,
      < 1.724135, -0.384756, 4.837459>,
      < 1.764769, -0.379041, 4.873330>
    }
    triangle {
      < 1.724148, -0.406364, 4.844485>,
      < 1.764769, -0.379041, 4.873330>,
      < 1.764776, -0.389845, 4.876842>
    }
    triangle {
      < 1.609019, -0.427053, 4.804037>,
      < 1.608998, -0.391938, 4.792618>,
      < 1.724135, -0.384756, 4.837459>
    }
    triangle {
      < 1.609019, -0.427053, 4.804037>,
      < 1.724135, -0.384756, 4.837459>,
      < 1.724148, -0.406364, 4.844485>
    }
    triangle {
      < 0.125730, -0.427932, 4.804037>,
      < 0.125709, -0.392816, 4.792618>,
      < 1.608998, -0.391938, 4.792618>
    }
    triangle {
      < 0.125730, -0.427932, 4.804037>,
      < 1.608998, -0.391938, 4.792618>,
      < 1.609019, -0.427053, 4.804037>
    }
    triangle {
      < 0.085090, -0.423832, 4.812126>,
      < 0.085071, -0.391418, 4.801587>,
      < 0.125709, -0.392816, 4.792618>
    }
    triangle {
      < 0.085090, -0.423832, 4.812126>,
      < 0.125709, -0.392816, 4.792618>,
      < 0.125730, -0.427932, 4.804037>
    }
    triangle {
      < -0.355157, -0.422030, 4.816171>,
      < -0.355176, -0.390967, 4.806070>,
      < 0.085071, -0.391418, 4.801587>
    }
    triangle {
      < -0.355157, -0.422030, 4.816171>,
      < 0.085071, -0.391418, 4.801587>,
      < 0.085090, -0.423832, 4.812126>
    }
    triangle {
      < -0.483853, -0.407673, 4.844484>,
      < -0.483866, -0.386064, 4.837458>,
      < -0.355176, -0.390967, 4.806070>
    }
    triangle {
      < -0.483853, -0.407673, 4.844484>,
      < -0.355176, -0.390967, 4.806070>,
      < -0.355157, -0.422030, 4.816171>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483866, -0.386064, 4.837458>,
      < -0.483853, -0.407673, 4.844484>
    }
    triangle {
      < 1.900229, -0.378961, 4.873330>,
      < 1.900222, -0.367599, 4.873326>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764769, -0.379041, 4.873330>,
      < 1.764762, -0.367679, 4.873326>,
      < 1.900222, -0.367599, 4.873326>
    }
    triangle {
      < 1.764769, -0.379041, 4.873330>,
      < 1.900222, -0.367599, 4.873326>,
      < 1.900229, -0.378961, 4.873330>
    }
    triangle {
      < 1.724135, -0.384756, 4.837459>,
      < 1.724122, -0.362033, 4.837451>,
      < 1.764762, -0.367679, 4.873326>
    }
    triangle {
      < 1.724135, -0.384756, 4.837459>,
      < 1.764762, -0.367679, 4.873326>,
      < 1.764769, -0.379041, 4.873330>
    }
    triangle {
      < 1.608998, -0.391938, 4.792618>,
      < 1.608976, -0.355014, 4.792607>,
      < 1.724122, -0.362033, 4.837451>
    }
    triangle {
      < 1.608998, -0.391938, 4.792618>,
      < 1.724122, -0.362033, 4.837451>,
      < 1.724135, -0.384756, 4.837459>
    }
    triangle {
      < 0.125709, -0.392816, 4.792618>,
      < 0.125687, -0.355892, 4.792607>,
      < 1.608976, -0.355014, 4.792607>
    }
    triangle {
      < 0.125709, -0.392816, 4.792618>,
      < 1.608976, -0.355014, 4.792607>,
      < 1.608998, -0.391938, 4.792618>
    }
    triangle {
      < 0.085071, -0.391418, 4.801587>,
      < 0.085050, -0.357334, 4.801576>,
      < 0.125687, -0.355892, 4.792607>
    }
    triangle {
      < 0.085071, -0.391418, 4.801587>,
      < 0.125687, -0.355892, 4.792607>,
      < 0.125709, -0.392816, 4.792618>
    }
    triangle {
      < -0.355176, -0.390967, 4.806070>,
      < -0.355195, -0.358304, 4.806061>,
      < 0.085050, -0.357334, 4.801576>
    }
    triangle {
      < -0.355176, -0.390967, 4.806070>,
      < 0.085050, -0.357334, 4.801576>,
      < 0.085071, -0.391418, 4.801587>
    }
    triangle {
      < -0.483866, -0.386064, 4.837458>,
      < -0.483880, -0.363341, 4.837451>,
      < -0.355195, -0.358304, 4.806061>
    }
    triangle {
      < -0.483866, -0.386064, 4.837458>,
      < -0.355195, -0.358304, 4.806061>,
      < -0.355176, -0.390967, 4.806070>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483880, -0.363341, 4.837451>,
      < -0.483866, -0.386064, 4.837458>
    }
    triangle {
      < 1.900222, -0.367599, 4.873326>,
      < 1.900216, -0.356793, 4.876832>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764762, -0.367679, 4.873326>,
      < 1.764756, -0.356873, 4.876832>,
      < 1.900216, -0.356793, 4.876832>
    }
    triangle {
      < 1.764762, -0.367679, 4.873326>,
      < 1.900216, -0.356793, 4.876832>,
      < 1.900222, -0.367599, 4.873326>
    }
    triangle {
      < 1.724122, -0.362033, 4.837451>,
      < 1.724109, -0.340420, 4.844465>,
      < 1.764756, -0.356873, 4.876832>
    }
    triangle {
      < 1.724122, -0.362033, 4.837451>,
      < 1.764756, -0.356873, 4.876832>,
      < 1.764762, -0.367679, 4.873326>
    }
    triangle {
      < 1.608976, -0.355014, 4.792607>,
      < 1.608955, -0.319893, 4.804006>,
      < 1.724109, -0.340420, 4.844465>
    }
    triangle {
      < 1.608976, -0.355014, 4.792607>,
      < 1.724109, -0.340420, 4.844465>,
      < 1.724122, -0.362033, 4.837451>
    }
    triangle {
      < 0.125687, -0.355892, 4.792607>,
      < 0.125666, -0.320771, 4.804005>,
      < 1.608955, -0.319893, 4.804006>
    }
    triangle {
      < 0.125687, -0.355892, 4.792607>,
      < 1.608955, -0.319893, 4.804006>,
      < 1.608976, -0.355014, 4.792607>
    }
    triangle {
      < 0.085050, -0.357334, 4.801576>,
      < 0.085031, -0.324914, 4.812097>,
      < 0.125666, -0.320771, 4.804005>
    }
    triangle {
      < 0.085050, -0.357334, 4.801576>,
      < 0.125666, -0.320771, 4.804005>,
      < 0.125687, -0.355892, 4.792607>
    }
    triangle {
      < -0.355195, -0.358304, 4.806061>,
      < -0.355214, -0.327235, 4.816144>,
      < 0.085031, -0.324914, 4.812097>
    }
    triangle {
      < -0.355195, -0.358304, 4.806061>,
      < 0.085031, -0.324914, 4.812097>,
      < 0.085050, -0.357334, 4.801576>
    }
    triangle {
      < -0.483880, -0.363341, 4.837451>,
      < -0.483892, -0.341729, 4.844465>,
      < -0.355214, -0.327235, 4.816144>
    }
    triangle {
      < -0.483880, -0.363341, 4.837451>,
      < -0.355214, -0.327235, 4.816144>,
      < -0.355195, -0.358304, 4.806061>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483892, -0.341729, 4.844465>,
      < -0.483880, -0.363341, 4.837451>
    }
    triangle {
      < 1.900216, -0.356793, 4.876832>,
      < 1.900210, -0.347598, 4.883507>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764756, -0.356873, 4.876832>,
      < 1.764751, -0.347678, 4.883507>,
      < 1.900210, -0.347598, 4.883507>
    }
    triangle {
      < 1.764756, -0.356873, 4.876832>,
      < 1.900210, -0.347598, 4.883507>,
      < 1.900216, -0.356793, 4.876832>
    }
    triangle {
      < 1.724109, -0.340420, 4.844465>,
      < 1.724097, -0.322032, 4.857813>,
      < 1.764751, -0.347678, 4.883507>
    }
    triangle {
      < 1.724109, -0.340420, 4.844465>,
      < 1.764751, -0.347678, 4.883507>,
      < 1.764756, -0.356873, 4.876832>
    }
    triangle {
      < 1.608955, -0.319893, 4.804006>,
      < 1.608937, -0.290011, 4.825696>,
      < 1.724097, -0.322032, 4.857813>
    }
    triangle {
      < 1.608955, -0.319893, 4.804006>,
      < 1.724097, -0.322032, 4.857813>,
      < 1.724109, -0.340420, 4.844465>
    }
    triangle {
      < 0.125666, -0.320771, 4.804005>,
      < 0.125649, -0.290890, 4.825696>,
      < 1.608937, -0.290011, 4.825696>
    }
    triangle {
      < 0.125666, -0.320771, 4.804005>,
      < 1.608937, -0.290011, 4.825696>,
      < 1.608955, -0.319893, 4.804006>
    }
    triangle {
      < 0.085031, -0.324914, 4.812097>,
      < 0.085015, -0.297332, 4.832119>,
      < 0.125649, -0.290890, 4.825696>
    }
    triangle {
      < 0.085031, -0.324914, 4.812097>,
      < 0.125649, -0.290890, 4.825696>,
      < 0.125666, -0.320771, 4.804005>
    }
    triangle {
      < -0.355214, -0.327235, 4.816144>,
      < -0.355229, -0.300801, 4.835331>,
      < 0.085015, -0.297332, 4.832119>
    }
    triangle {
      < -0.355214, -0.327235, 4.816144>,
      < 0.085015, -0.297332, 4.832119>,
      < 0.085031, -0.324914, 4.812097>
    }
    triangle {
      < -0.483892, -0.341729, 4.844465>,
      < -0.483903, -0.323340, 4.857813>,
      < -0.355229, -0.300801, 4.835331>
    }
    triangle {
      < -0.483892, -0.341729, 4.844465>,
      < -0.355229, -0.300801, 4.835331>,
      < -0.355214, -0.327235, 4.816144>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483903, -0.323340, 4.857813>,
      < -0.483892, -0.341729, 4.844465>
    }
    triangle {
      < 1.900210, -0.347598, 4.883507>,
      < 1.900207, -0.340915, 4.892695>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764751, -0.347678, 4.883507>,
      < 1.764747, -0.340995, 4.892695>,
      < 1.900207, -0.340915, 4.892695>
    }
    triangle {
      < 1.764751, -0.347678, 4.883507>,
      < 1.900207, -0.340915, 4.892695>,
      < 1.900210, -0.347598, 4.883507>
    }
    triangle {
      < 1.724097, -0.322032, 4.857813>,
      < 1.724090, -0.308667, 4.876190>,
      < 1.764747, -0.340995, 4.892695>
    }
    triangle {
      < 1.724097, -0.322032, 4.857813>,
      < 1.764747, -0.340995, 4.892695>,
      < 1.764751, -0.347678, 4.883507>
    }
    triangle {
      < 1.608937, -0.290011, 4.825696>,
      < 1.608925, -0.268294, 4.855558>,
      < 1.724090, -0.308667, 4.876190>
    }
    triangle {
      < 1.608937, -0.290011, 4.825696>,
      < 1.724090, -0.308667, 4.876190>,
      < 1.724097, -0.322032, 4.857813>
    }
    triangle {
      < 0.125649, -0.290890, 4.825696>,
      < 0.125636, -0.269172, 4.855558>,
      < 1.608925, -0.268294, 4.855558>
    }
    triangle {
      < 0.125649, -0.290890, 4.825696>,
      < 1.608925, -0.268294, 4.855558>,
      < 1.608937, -0.290011, 4.825696>
    }
    triangle {
      < 0.085015, -0.297332, 4.832119>,
      < 0.085003, -0.277285, 4.859685>,
      < 0.125636, -0.269172, 4.855558>
    }
    triangle {
      < 0.085015, -0.297332, 4.832119>,
      < 0.125636, -0.269172, 4.855558>,
      < 0.125649, -0.290890, 4.825696>
    }
    triangle {
      < -0.355229, -0.300801, 4.835331>,
      < -0.355241, -0.281591, 4.861747>,
      < 0.085003, -0.277285, 4.859685>
    }
    triangle {
      < -0.355229, -0.300801, 4.835331>,
      < 0.085003, -0.277285, 4.859685>,
      < 0.085015, -0.297332, 4.832119>
    }
    triangle {
      < -0.483903, -0.323340, 4.857813>,
      < -0.483911, -0.309976, 4.876189>,
      < -0.355241, -0.281591, 4.861747>
    }
    triangle {
      < -0.483903, -0.323340, 4.857813>,
      < -0.355241, -0.281591, 4.861747>,
      < -0.355229, -0.300801, 4.835331>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483911, -0.309976, 4.876189>,
      < -0.483903, -0.323340, 4.857813>
    }
    triangle {
      < 1.900207, -0.340915, 4.892695>,
      < 1.900204, -0.337399, 4.903499>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764747, -0.340995, 4.892695>,
      < 1.764745, -0.337480, 4.903499>,
      < 1.900204, -0.337399, 4.903499>
    }
    triangle {
      < 1.764747, -0.340995, 4.892695>,
      < 1.900204, -0.337399, 4.903499>,
      < 1.900207, -0.340915, 4.892695>
    }
    triangle {
      < 1.724090, -0.308667, 4.876190>,
      < 1.724086, -0.301633, 4.897796>,
      < 1.764745, -0.337480, 4.903499>
    }
    triangle {
      < 1.724090, -0.308667, 4.876190>,
      < 1.764745, -0.337480, 4.903499>,
      < 1.764747, -0.340995, 4.892695>
    }
    triangle {
      < 1.608925, -0.268294, 4.855558>,
      < 1.608918, -0.256865, 4.890670>,
      < 1.724086, -0.301633, 4.897796>
    }
    triangle {
      < 1.608925, -0.268294, 4.855558>,
      < 1.724086, -0.301633, 4.897796>,
      < 1.724090, -0.308667, 4.876190>
    }
    triangle {
      < 0.125636, -0.269172, 4.855558>,
      < 0.125629, -0.257743, 4.890670>,
      < 1.608918, -0.256865, 4.890670>
    }
    triangle {
      < 0.125636, -0.269172, 4.855558>,
      < 1.608918, -0.256865, 4.890670>,
      < 1.608925, -0.268294, 4.855558>
    }
    triangle {
      < 0.085003, -0.277285, 4.859685>,
      < 0.084997, -0.266735, 4.892095>,
      < 0.125629, -0.257743, 4.890670>
    }
    triangle {
      < 0.085003, -0.277285, 4.859685>,
      < 0.125629, -0.257743, 4.890670>,
      < 0.125636, -0.269172, 4.855558>
    }
    triangle {
      < -0.355241, -0.281591, 4.861747>,
      < -0.355246, -0.271479, 4.892808>,
      < 0.084997, -0.266735, 4.892095>
    }
    triangle {
      < -0.355241, -0.281591, 4.861747>,
      < 0.084997, -0.266735, 4.892095>,
      < 0.085003, -0.277285, 4.859685>
    }
    triangle {
      < -0.483911, -0.309976, 4.876189>,
      < -0.483915, -0.302942, 4.897796>,
      < -0.355246, -0.271479, 4.892808>
    }
    triangle {
      < -0.483911, -0.309976, 4.876189>,
      < -0.355246, -0.271479, 4.892808>,
      < -0.355241, -0.281591, 4.861747>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483915, -0.302942, 4.897796>,
      < -0.483911, -0.309976, 4.876189>
    }
    triangle {
      < 1.900204, -0.337399, 4.903499>,
      < 1.900204, -0.337392, 4.914859>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764745, -0.337480, 4.903499>,
      < 1.764745, -0.337472, 4.914859>,
      < 1.900204, -0.337392, 4.914859>
    }
    triangle {
      < 1.764745, -0.337480, 4.903499>,
      < 1.900204, -0.337392, 4.914859>,
      < 1.900204, -0.337399, 4.903499>
    }
    triangle {
      < 1.724086, -0.301633, 4.897796>,
      < 1.724086, -0.301620, 4.920519>,
      < 1.764745, -0.337472, 4.914859>
    }
    triangle {
      < 1.724086, -0.301633, 4.897796>,
      < 1.764745, -0.337472, 4.914859>,
      < 1.764745, -0.337480, 4.903499>
    }
    triangle {
      < 1.608918, -0.256865, 4.890670>,
      < 1.608917, -0.256843, 4.927593>,
      < 1.724086, -0.301620, 4.920519>
    }
    triangle {
      < 1.608918, -0.256865, 4.890670>,
      < 1.724086, -0.301620, 4.920519>,
      < 1.724086, -0.301633, 4.897796>
    }
    triangle {
      < 0.125629, -0.257743, 4.890670>,
      < 0.125629, -0.257721, 4.927593>,
      < 1.608917, -0.256843, 4.927593>
    }
    triangle {
      < 0.125629, -0.257743, 4.890670>,
      < 1.608917, -0.256843, 4.927593>,
      < 1.608918, -0.256865, 4.890670>
    }
    triangle {
      < 0.084997, -0.266735, 4.892095>,
      < 0.084997, -0.266716, 4.926178>,
      < 0.125629, -0.257721, 4.927593>
    }
    triangle {
      < 0.084997, -0.266735, 4.892095>,
      < 0.125629, -0.257721, 4.927593>,
      < 0.125629, -0.257743, 4.890670>
    }
    triangle {
      < -0.355246, -0.271479, 4.892808>,
      < -0.355246, -0.271460, 4.925471>,
      < 0.084997, -0.266716, 4.926178>
    }
    triangle {
      < -0.355246, -0.271479, 4.892808>,
      < 0.084997, -0.266716, 4.926178>,
      < 0.084997, -0.266735, 4.892095>
    }
    triangle {
      < -0.483915, -0.302942, 4.897796>,
      < -0.483916, -0.302929, 4.920519>,
      < -0.355246, -0.271460, 4.925471>
    }
    triangle {
      < -0.483915, -0.302942, 4.897796>,
      < -0.355246, -0.271460, 4.925471>,
      < -0.355246, -0.271479, 4.892808>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483916, -0.302929, 4.920519>,
      < -0.483915, -0.302942, 4.897796>
    }
    triangle {
      < 1.900204, -0.337392, 4.914859>,
      < 1.900207, -0.340896, 4.925667>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764745, -0.337472, 4.914859>,
      < 1.764747, -0.340976, 4.925667>,
      < 1.900207, -0.340896, 4.925667>
    }
    triangle {
      < 1.764745, -0.337472, 4.914859>,
      < 1.900207, -0.340896, 4.925667>,
      < 1.900204, -0.337392, 4.914859>
    }
    triangle {
      < 1.724086, -0.301620, 4.920519>,
      < 1.724090, -0.308628, 4.942135>,
      < 1.764747, -0.340976, 4.925667>
    }
    triangle {
      < 1.724086, -0.301620, 4.920519>,
      < 1.764747, -0.340976, 4.925667>,
      < 1.764745, -0.337472, 4.914859>
    }
    triangle {
      < 1.608917, -0.256843, 4.927593>,
      < 1.608925, -0.268230, 4.962718>,
      < 1.724090, -0.308628, 4.942135>
    }
    triangle {
      < 1.608917, -0.256843, 4.927593>,
      < 1.724090, -0.308628, 4.942135>,
      < 1.724086, -0.301620, 4.920519>
    }
    triangle {
      < 0.125629, -0.257721, 4.927593>,
      < 0.125636, -0.269109, 4.962718>,
      < 1.608925, -0.268230, 4.962718>
    }
    triangle {
      < 0.125629, -0.257721, 4.927593>,
      < 1.608925, -0.268230, 4.962718>,
      < 1.608917, -0.256843, 4.927593>
    }
    triangle {
      < 0.084997, -0.266716, 4.926178>,
      < 0.085003, -0.277226, 4.958601>,
      < 0.125636, -0.269109, 4.962718>
    }
    triangle {
      < 0.084997, -0.266716, 4.926178>,
      < 0.125636, -0.269109, 4.962718>,
      < 0.125629, -0.257721, 4.927593>
    }
    triangle {
      < -0.355246, -0.271460, 4.925471>,
      < -0.355241, -0.281534, 4.956542>,
      < 0.085003, -0.277226, 4.958601>
    }
    triangle {
      < -0.355246, -0.271460, 4.925471>,
      < 0.085003, -0.277226, 4.958601>,
      < 0.084997, -0.266716, 4.926178>
    }
    triangle {
      < -0.483916, -0.302929, 4.920519>,
      < -0.483911, -0.309936, 4.942134>,
      < -0.355241, -0.281534, 4.956542>
    }
    triangle {
      < -0.483916, -0.302929, 4.920519>,
      < -0.355241, -0.281534, 4.956542>,
      < -0.355246, -0.271460, 4.925471>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483911, -0.309936, 4.942134>,
      < -0.483916, -0.302929, 4.920519>
    }
    triangle {
      < 1.900207, -0.340896, 4.925667>,
      < 1.900210, -0.347568, 4.934864>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764747, -0.340976, 4.925667>,
      < 1.764751, -0.347648, 4.934864>,
      < 1.900210, -0.347568, 4.934864>
    }
    triangle {
      < 1.764747, -0.340976, 4.925667>,
      < 1.900210, -0.347568, 4.934864>,
      < 1.900207, -0.340896, 4.925667>
    }
    triangle {
      < 1.724090, -0.308628, 4.942135>,
      < 1.724097, -0.321970, 4.960526>,
      < 1.764751, -0.347648, 4.934864>
    }
    triangle {
      < 1.724090, -0.308628, 4.942135>,
      < 1.764751, -0.347648, 4.934864>,
      < 1.764747, -0.340976, 4.925667>
    }
    triangle {
      < 1.608925, -0.268230, 4.962718>,
      < 1.608937, -0.289913, 4.992606>,
      < 1.724097, -0.321970, 4.960526>
    }
    triangle {
      < 1.608925, -0.268230, 4.962718>,
      < 1.724097, -0.321970, 4.960526>,
      < 1.724090, -0.308628, 4.942135>
    }
    triangle {
      < 0.125636, -0.269109, 4.962718>,
      < 0.125649, -0.290791, 4.992606>,
      < 1.608937, -0.289913, 4.992606>
    }
    triangle {
      < 0.125636, -0.269109, 4.962718>,
      < 1.608937, -0.289913, 4.992606>,
      < 1.608925, -0.268230, 4.962718>
    }
    triangle {
      < 0.085003, -0.277226, 4.958601>,
      < 0.085015, -0.297241, 4.986190>,
      < 0.125649, -0.290791, 4.992606>
    }
    triangle {
      < 0.085003, -0.277226, 4.958601>,
      < 0.125649, -0.290791, 4.992606>,
      < 0.125636, -0.269109, 4.962718>
    }
    triangle {
      < -0.355241, -0.281534, 4.956542>,
      < -0.355229, -0.300714, 4.982982>,
      < 0.085015, -0.297241, 4.986190>
    }
    triangle {
      < -0.355241, -0.281534, 4.956542>,
      < 0.085015, -0.297241, 4.986190>,
      < 0.085003, -0.277226, 4.958601>
    }
    triangle {
      < -0.483911, -0.309936, 4.942134>,
      < -0.483903, -0.323279, 4.960526>,
      < -0.355229, -0.300714, 4.982982>
    }
    triangle {
      < -0.483911, -0.309936, 4.942134>,
      < -0.355229, -0.300714, 4.982982>,
      < -0.355241, -0.281534, 4.956542>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483903, -0.323279, 4.960526>,
      < -0.483911, -0.309936, 4.942134>
    }
    triangle {
      < 1.900210, -0.347568, 4.934864>,
      < 1.900216, -0.356753, 4.941549>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764751, -0.347648, 4.934864>,
      < 1.764756, -0.356834, 4.941549>,
      < 1.900216, -0.356753, 4.941549>
    }
    triangle {
      < 1.764751, -0.347648, 4.934864>,
      < 1.900216, -0.356753, 4.941549>,
      < 1.900210, -0.347568, 4.934864>
    }
    triangle {
      < 1.724097, -0.321970, 4.960526>,
      < 1.724108, -0.340344, 4.973897>,
      < 1.764756, -0.356834, 4.941549>
    }
    triangle {
      < 1.724097, -0.321970, 4.960526>,
      < 1.764756, -0.356834, 4.941549>,
      < 1.764751, -0.347648, 4.934864>
    }
    triangle {
      < 1.608937, -0.289913, 4.992606>,
      < 1.608955, -0.319768, 5.014333>,
      < 1.724108, -0.340344, 4.973897>
    }
    triangle {
      < 1.608937, -0.289913, 4.992606>,
      < 1.724108, -0.340344, 4.973897>,
      < 1.724097, -0.321970, 4.960526>
    }
    triangle {
      < 0.125649, -0.290791, 4.992606>,
      < 0.125666, -0.320646, 5.014333>,
      < 1.608955, -0.319768, 5.014333>
    }
    triangle {
      < 0.125649, -0.290791, 4.992606>,
      < 1.608955, -0.319768, 5.014333>,
      < 1.608937, -0.289913, 4.992606>
    }
    triangle {
      < 0.085015, -0.297241, 4.986190>,
      < 0.085031, -0.324799, 5.006245>,
      < 0.125666, -0.320646, 5.014333>
    }
    triangle {
      < 0.085015, -0.297241, 4.986190>,
      < 0.125666, -0.320646, 5.014333>,
      < 0.125649, -0.290791, 4.992606>
    }
    triangle {
      < -0.355229, -0.300714, 4.982982>,
      < -0.355214, -0.327125, 5.002202>,
      < 0.085031, -0.324799, 5.006245>
    }
    triangle {
      < -0.355229, -0.300714, 4.982982>,
      < 0.085031, -0.324799, 5.006245>,
      < 0.085015, -0.297241, 4.986190>
    }
    triangle {
      < -0.483903, -0.323279, 4.960526>,
      < -0.483892, -0.341652, 4.973897>,
      < -0.355214, -0.327125, 5.002202>
    }
    triangle {
      < -0.483903, -0.323279, 4.960526>,
      < -0.355214, -0.327125, 5.002202>,
      < -0.355229, -0.300714, 4.982982>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483892, -0.341652, 4.973897>,
      < -0.483903, -0.323279, 4.960526>
    }
    triangle {
      < 1.900216, -0.356753, 4.941549>,
      < 1.900222, -0.367556, 4.945068>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764756, -0.356834, 4.941549>,
      < 1.764762, -0.367636, 4.945068>,
      < 1.900222, -0.367556, 4.945068>
    }
    triangle {
      < 1.764756, -0.356834, 4.941549>,
      < 1.900222, -0.367556, 4.945068>,
      < 1.900216, -0.356753, 4.941549>
    }
    triangle {
      < 1.724108, -0.340344, 4.973897>,
      < 1.724122, -0.361948, 4.980937>,
      < 1.764762, -0.367636, 4.945068>
    }
    triangle {
      < 1.724108, -0.340344, 4.973897>,
      < 1.764762, -0.367636, 4.945068>,
      < 1.764756, -0.356834, 4.941549>
    }
    triangle {
      < 1.608955, -0.319768, 5.014333>,
      < 1.608976, -0.354876, 5.025773>,
      < 1.724122, -0.361948, 4.980937>
    }
    triangle {
      < 1.608955, -0.319768, 5.014333>,
      < 1.724122, -0.361948, 4.980937>,
      < 1.724108, -0.340344, 4.973897>
    }
    triangle {
      < 0.125666, -0.320646, 5.014333>,
      < 0.125687, -0.355754, 5.025773>,
      < 1.608976, -0.354876, 5.025773>
    }
    triangle {
      < 0.125666, -0.320646, 5.014333>,
      < 1.608976, -0.354876, 5.025773>,
      < 1.608955, -0.319768, 5.014333>
    }
    triangle {
      < 0.085031, -0.324799, 5.006245>,
      < 0.085050, -0.357207, 5.016804>,
      < 0.125687, -0.355754, 5.025773>
    }
    triangle {
      < 0.085031, -0.324799, 5.006245>,
      < 0.125687, -0.355754, 5.025773>,
      < 0.125666, -0.320646, 5.014333>
    }
    triangle {
      < -0.355214, -0.327125, 5.002202>,
      < -0.355195, -0.358181, 5.012321>,
      < 0.085050, -0.357207, 5.016804>
    }
    triangle {
      < -0.355214, -0.327125, 5.002202>,
      < 0.085050, -0.357207, 5.016804>,
      < 0.085031, -0.324799, 5.006245>
    }
    triangle {
      < -0.483892, -0.341652, 4.973897>,
      < -0.483880, -0.363257, 4.980937>,
      < -0.355195, -0.358181, 5.012321>
    }
    triangle {
      < -0.483892, -0.341652, 4.973897>,
      < -0.355195, -0.358181, 5.012321>,
      < -0.355214, -0.327125, 5.002202>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483880, -0.363257, 4.980937>,
      < -0.483892, -0.341652, 4.973897>
    }
    triangle {
      < 1.900222, -0.367556, 4.945068>,
      < 1.900229, -0.378918, 4.945079>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764762, -0.367636, 4.945068>,
      < 1.764769, -0.378998, 4.945079>,
      < 1.900229, -0.378918, 4.945079>
    }
    triangle {
      < 1.764762, -0.367636, 4.945068>,
      < 1.900229, -0.378918, 4.945079>,
      < 1.900222, -0.367556, 4.945068>
    }
    triangle {
      < 1.724122, -0.361948, 4.980937>,
      < 1.724135, -0.384671, 4.980957>,
      < 1.764769, -0.378998, 4.945079>
    }
    triangle {
      < 1.724122, -0.361948, 4.980937>,
      < 1.764769, -0.378998, 4.945079>,
      < 1.764762, -0.367636, 4.945068>
    }
    triangle {
      < 1.608976, -0.354876, 5.025773>,
      < 1.608997, -0.391800, 5.025805>,
      < 1.724135, -0.384671, 4.980957>
    }
    triangle {
      < 1.608976, -0.354876, 5.025773>,
      < 1.724135, -0.384671, 4.980957>,
      < 1.724122, -0.361948, 4.980937>
    }
    triangle {
      < 0.125687, -0.355754, 5.025773>,
      < 0.125709, -0.392679, 5.025804>,
      < 1.608997, -0.391800, 5.025805>
    }
    triangle {
      < 0.125687, -0.355754, 5.025773>,
      < 1.608997, -0.391800, 5.025805>,
      < 1.608976, -0.354876, 5.025773>
    }
    triangle {
      < 0.085050, -0.357207, 5.016804>,
      < 0.085071, -0.391291, 5.016835>,
      < 0.125709, -0.392679, 5.025804>
    }
    triangle {
      < 0.085050, -0.357207, 5.016804>,
      < 0.125709, -0.392679, 5.025804>,
      < 0.125687, -0.355754, 5.025773>
    }
    triangle {
      < -0.355195, -0.358181, 5.012321>,
      < -0.355176, -0.390846, 5.012350>,
      < 0.085071, -0.391291, 5.016835>
    }
    triangle {
      < -0.355195, -0.358181, 5.012321>,
      < 0.085071, -0.391291, 5.016835>,
      < 0.085050, -0.357207, 5.016804>
    }
    triangle {
      < -0.483880, -0.363257, 4.980937>,
      < -0.483866, -0.385979, 4.980957>,
      < -0.355176, -0.390846, 5.012350>
    }
    triangle {
      < -0.483880, -0.363257, 4.980937>,
      < -0.355176, -0.390846, 5.012350>,
      < -0.355195, -0.358181, 5.012321>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483866, -0.385979, 4.980957>,
      < -0.483880, -0.363257, 4.980937>
    }
    triangle {
      < 1.900229, -0.378918, 4.945079>,
      < 1.900236, -0.389726, 4.941577>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764769, -0.378998, 4.945079>,
      < 1.764776, -0.389806, 4.941577>,
      < 1.900236, -0.389726, 4.941577>
    }
    triangle {
      < 1.764769, -0.378998, 4.945079>,
      < 1.900236, -0.389726, 4.941577>,
      < 1.900229, -0.378918, 4.945079>
    }
    triangle {
      < 1.724135, -0.384671, 4.980957>,
      < 1.724148, -0.406288, 4.973956>,
      < 1.764776, -0.389806, 4.941577>
    }
    triangle {
      < 1.724135, -0.384671, 4.980957>,
      < 1.764776, -0.389806, 4.941577>,
      < 1.764769, -0.378998, 4.945079>
    }
    triangle {
      < 1.608997, -0.391800, 5.025805>,
      < 1.609019, -0.426927, 5.014427>,
      < 1.724148, -0.406288, 4.973956>
    }
    triangle {
      < 1.608997, -0.391800, 5.025805>,
      < 1.724148, -0.406288, 4.973956>,
      < 1.724135, -0.384671, 4.980957>
    }
    triangle {
      < 0.125709, -0.392679, 5.025804>,
      < 0.125730, -0.427806, 5.014427>,
      < 1.609019, -0.426927, 5.014427>
    }
    triangle {
      < 0.125709, -0.392679, 5.025804>,
      < 1.609019, -0.426927, 5.014427>,
      < 1.608997, -0.391800, 5.025805>
    }
    triangle {
      < 0.085071, -0.391291, 5.016835>,
      < 0.085090, -0.423716, 5.006332>,
      < 0.125730, -0.427806, 5.014427>
    }
    triangle {
      < 0.085071, -0.391291, 5.016835>,
      < 0.125730, -0.427806, 5.014427>,
      < 0.125709, -0.392679, 5.025804>
    }
    triangle {
      < -0.355176, -0.390846, 5.012350>,
      < -0.355157, -0.421920, 5.002285>,
      < 0.085090, -0.423716, 5.006332>
    }
    triangle {
      < -0.355176, -0.390846, 5.012350>,
      < 0.085090, -0.423716, 5.006332>,
      < 0.085071, -0.391291, 5.016835>
    }
    triangle {
      < -0.483866, -0.385979, 4.980957>,
      < -0.483853, -0.407597, 4.973956>,
      < -0.355157, -0.421920, 5.002285>
    }
    triangle {
      < -0.483866, -0.385979, 4.980957>,
      < -0.355157, -0.421920, 5.002285>,
      < -0.355176, -0.390846, 5.012350>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483853, -0.407597, 4.973956>,
      < -0.483866, -0.385979, 4.980957>
    }
    triangle {
      < 1.900236, -0.389726, 4.941577>,
      < 1.900241, -0.398955, 4.934879>,
      < 1.900226, -0.373269, 4.909201>
    }
    triangle {
      < 1.764776, -0.389806, 4.941577>,
      < 1.764781, -0.399035, 4.934879>,
      < 1.900241, -0.398955, 4.934879>
    }
    triangle {
      < 1.764776, -0.389806, 4.941577>,
      < 1.900241, -0.398955, 4.934879>,
      < 1.900236, -0.389726, 4.941577>
    }
    triangle {
      < 1.724148, -0.406288, 4.973956>,
      < 1.724159, -0.424745, 4.960557>,
      < 1.764781, -0.399035, 4.934879>
    }
    triangle {
      < 1.724148, -0.406288, 4.973956>,
      < 1.764781, -0.399035, 4.934879>,
      < 1.764776, -0.389806, 4.941577>
    }
    triangle {
      < 1.609019, -0.426927, 5.014427>,
      < 1.609036, -0.456921, 4.992655>,
      < 1.724159, -0.424745, 4.960557>
    }
    triangle {
      < 1.609019, -0.426927, 5.014427>,
      < 1.724159, -0.424745, 4.960557>,
      < 1.724148, -0.406288, 4.973956>
    }
    triangle {
      < 0.125730, -0.427806, 5.014427>,
      < 0.125748, -0.457799, 4.992655>,
      < 1.609036, -0.456921, 4.992655>
    }
    triangle {
      < 0.125730, -0.427806, 5.014427>,
      < 1.609036, -0.456921, 4.992655>,
      < 1.609019, -0.426927, 5.014427>
    }
    triangle {
      < 0.085090, -0.423716, 5.006332>,
      < 0.085106, -0.451403, 4.986236>,
      < 0.125748, -0.457799, 4.992655>
    }
    triangle {
      < 0.085090, -0.423716, 5.006332>,
      < 0.125748, -0.457799, 4.992655>,
      < 0.125730, -0.427806, 5.014427>
    }
    triangle {
      < -0.355157, -0.421920, 5.002285>,
      < -0.355142, -0.448452, 4.983025>,
      < 0.085106, -0.451403, 4.986236>
    }
    triangle {
      < -0.355157, -0.421920, 5.002285>,
      < 0.085106, -0.451403, 4.986236>,
      < 0.085090, -0.423716, 5.006332>
    }
    triangle {
      < -0.483853, -0.407597, 4.973956>,
      < -0.483842, -0.426054, 4.960557>,
      < -0.355142, -0.448452, 4.983025>
    }
    triangle {
      < -0.483853, -0.407597, 4.973956>,
      < -0.355142, -0.448452, 4.983025>,
      < -0.355157, -0.421920, 5.002285>
    }
    triangle {
      < -0.571921, -0.374734, 4.909201>,
      < -0.483842, -0.426054, 4.960557>,
      < -0.483853, -0.407597, 4.973956>
    }
    triangle {
      < -0.413438, -0.533652, 4.730174>,
      < -0.413532, -0.375530, 4.888249>,
      < -0.104472, -0.375347, 4.888249>
    }
    triangle {
      < -0.413438, -0.533652, 4.730174>,
      < -0.104472, -0.375347, 4.888249>,
      < -0.104378, -0.533469, 4.730174>
    }
    triangle {
      < -0.104366, -0.553530, 4.750241>,
      < -0.104460, -0.395408, 4.908316>,
      < -0.413519, -0.395591, 4.908316>
    }
    triangle {
      < -0.104366, -0.553530, 4.750241>,
      < -0.413519, -0.395591, 4.908316>,
      < -0.413426, -0.553713, 4.750241>
    }
    triangle {
      < -0.413426, -0.553713, 4.750241>,
      < -0.413519, -0.395591, 4.908316>,
      < -0.413532, -0.375530, 4.888249>
    }
    triangle {
      < -0.413426, -0.553713, 4.750241>,
      < -0.413532, -0.375530, 4.888249>,
      < -0.413438, -0.533652, 4.730174>
    }
    triangle {
      < -0.413426, -0.553713, 4.750241>,
      < -0.413438, -0.533652, 4.730174>,
      < -0.104378, -0.533469, 4.730174>
    }
    triangle {
      < -0.413426, -0.553713, 4.750241>,
      < -0.104378, -0.533469, 4.730174>,
      < -0.104366, -0.553530, 4.750241>
    }
    triangle {
      < -0.104378, -0.533469, 4.730174>,
      < -0.104472, -0.375347, 4.888249>,
      < -0.104460, -0.395408, 4.908316>
    }
    triangle {
      < -0.104378, -0.533469, 4.730174>,
      < -0.104460, -0.395408, 4.908316>,
      < -0.104366, -0.553530, 4.750241>
    }
    triangle {
      < -0.413532, -0.375530, 4.888249>,
      < -0.413519, -0.395591, 4.908316>,
      < -0.104460, -0.395408, 4.908316>
    }
    triangle {
      < -0.413532, -0.375530, 4.888249>,
      < -0.104460, -0.395408, 4.908316>,
      < -0.104472, -0.375347, 4.888249>
    }
    triangle {
      < 0.025595, -0.533391, 4.730174>,
      < 0.025501, -0.375270, 4.888249>,
      < 0.334561, -0.375087, 4.888249>
    }
    triangle {
      < 0.025595, -0.533391, 4.730174>,
      < 0.334561, -0.375087, 4.888249>,
      < 0.334654, -0.533209, 4.730174>
    }
    triangle {
      < 0.334667, -0.553270, 4.750241>,
      < 0.334572, -0.395148, 4.908316>,
      < 0.025513, -0.395331, 4.908316>
    }
    triangle {
      < 0.334667, -0.553270, 4.750241>,
      < 0.025513, -0.395331, 4.908316>,
      < 0.025608, -0.553453, 4.750241>
    }
    triangle {
      < 0.025608, -0.553453, 4.750241>,
      < 0.025513, -0.395331, 4.908316>,
      < 0.025501, -0.375270, 4.888249>
    }
    triangle {
      < 0.025608, -0.553453, 4.750241>,
      < 0.025501, -0.375270, 4.888249>,
      < 0.025595, -0.533391, 4.730174>
    }
    triangle {
      < 0.025608, -0.553453, 4.750241>,
      < 0.025595, -0.533391, 4.730174>,
      < 0.334654, -0.533209, 4.730174>
    }
    triangle {
      < 0.025608, -0.553453, 4.750241>,
      < 0.334654, -0.533209, 4.730174>,
      < 0.334667, -0.553270, 4.750241>
    }
    triangle {
      < 0.334654, -0.533209, 4.730174>,
      < 0.334561, -0.375087, 4.888249>,
      < 0.334572, -0.395148, 4.908316>
    }
    triangle {
      < 0.334654, -0.533209, 4.730174>,
      < 0.334572, -0.395148, 4.908316>,
      < 0.334667, -0.553270, 4.750241>
    }
    triangle {
      < 0.025501, -0.375270, 4.888249>,
      < 0.025513, -0.395331, 4.908316>,
      < 0.334572, -0.395148, 4.908316>
    }
    triangle {
      < 0.025501, -0.375270, 4.888249>,
      < 0.334572, -0.395148, 4.908316>,
      < 0.334561, -0.375087, 4.888249>
    }
    triangle {
      < -0.413638, -0.195661, 4.750135>,
      < -0.413545, -0.353688, 4.908303>,
      < -0.104485, -0.353505, 4.908303>
    }
    triangle {
      < -0.413638, -0.195661, 4.750135>,
      < -0.104485, -0.353505, 4.908303>,
      < -0.104578, -0.195478, 4.750135>
    }
    triangle {
      < -0.104566, -0.215551, 4.730079>,
      < -0.104473, -0.373578, 4.888248>,
      < -0.413533, -0.373761, 4.888248>
    }
    triangle {
      < -0.104566, -0.215551, 4.730079>,
      < -0.413533, -0.373761, 4.888248>,
      < -0.413626, -0.215734, 4.730079>
    }
    triangle {
      < -0.413626, -0.215734, 4.730079>,
      < -0.413533, -0.373761, 4.888248>,
      < -0.413545, -0.353688, 4.908303>
    }
    triangle {
      < -0.413626, -0.215734, 4.730079>,
      < -0.413545, -0.353688, 4.908303>,
      < -0.413638, -0.195661, 4.750135>
    }
    triangle {
      < -0.413626, -0.215734, 4.730079>,
      < -0.413638, -0.195661, 4.750135>,
      < -0.104578, -0.195478, 4.750135>
    }
    triangle {
      < -0.413626, -0.215734, 4.730079>,
      < -0.104578, -0.195478, 4.750135>,
      < -0.104566, -0.215551, 4.730079>
    }
    triangle {
      < -0.104578, -0.195478, 4.750135>,
      < -0.104485, -0.353505, 4.908303>,
      < -0.104473, -0.373578, 4.888248>
    }
    triangle {
      < -0.104578, -0.195478, 4.750135>,
      < -0.104473, -0.373578, 4.888248>,
      < -0.104566, -0.215551, 4.730079>
    }
    triangle {
      < -0.413545, -0.353688, 4.908303>,
      < -0.413533, -0.373761, 4.888248>,
      < -0.104473, -0.373578, 4.888248>
    }
    triangle {
      < -0.413545, -0.353688, 4.908303>,
      < -0.104473, -0.373578, 4.888248>,
      < -0.104485, -0.353505, 4.908303>
    }
    triangle {
      < 0.025395, -0.195401, 4.750135>,
      < 0.025489, -0.353428, 4.908303>,
      < 0.334548, -0.353245, 4.908303>
    }
    triangle {
      < 0.025395, -0.195401, 4.750135>,
      < 0.334548, -0.353245, 4.908303>,
      < 0.334454, -0.195218, 4.750135>
    }
    triangle {
      < 0.334466, -0.215291, 4.730079>,
      < 0.334560, -0.373318, 4.888249>,
      < 0.025501, -0.373501, 4.888249>
    }
    triangle {
      < 0.334466, -0.215291, 4.730079>,
      < 0.025501, -0.373501, 4.888249>,
      < 0.025407, -0.215474, 4.730079>
    }
    triangle {
      < 0.025407, -0.215474, 4.730079>,
      < 0.025501, -0.373501, 4.888249>,
      < 0.025489, -0.353428, 4.908303>
    }
    triangle {
      < 0.025407, -0.215474, 4.730079>,
      < 0.025489, -0.353428, 4.908303>,
      < 0.025395, -0.195401, 4.750135>
    }
    triangle {
      < 0.025407, -0.215474, 4.730079>,
      < 0.025395, -0.195401, 4.750135>,
      < 0.334454, -0.195218, 4.750135>
    }
    triangle {
      < 0.025407, -0.215474, 4.730079>,
      < 0.334454, -0.195218, 4.750135>,
      < 0.334466, -0.215291, 4.730079>
    }
    triangle {
      < 0.334454, -0.195218, 4.750135>,
      < 0.334548, -0.353245, 4.908303>,
      < 0.334560, -0.373318, 4.888249>
    }
    triangle {
      < 0.334454, -0.195218, 4.750135>,
      < 0.334560, -0.373318, 4.888249>,
      < 0.334466, -0.215291, 4.730079>
    }
    triangle {
      < 0.025489, -0.353428, 4.908303>,
      < 0.025501, -0.373501, 4.888249>,
      < 0.334560, -0.373318, 4.888249>
    }
    triangle {
      < 0.025489, -0.353428, 4.908303>,
      < 0.334560, -0.373318, 4.888249>,
      < 0.334548, -0.353245, 4.908303>
    }
    triangle {
      < -0.413626, -0.215521, 5.088133>,
      < -0.413533, -0.373737, 4.930151>,
      < -0.104473, -0.373554, 4.930152>
    }
    triangle {
      < -0.413626, -0.215521, 5.088133>,
      < -0.104473, -0.373554, 4.930152>,
      < -0.104566, -0.215338, 5.088133>
    }
    triangle {
      < -0.104578, -0.195290, 5.068054>,
      < -0.104485, -0.353504, 4.910072>,
      < -0.413545, -0.353687, 4.910072>
    }
    triangle {
      < -0.104578, -0.195290, 5.068054>,
      < -0.413545, -0.353687, 4.910072>,
      < -0.413638, -0.195472, 5.068054>
    }
    triangle {
      < -0.413638, -0.195472, 5.068054>,
      < -0.413545, -0.353687, 4.910072>,
      < -0.413533, -0.373737, 4.930151>
    }
    triangle {
      < -0.413638, -0.195472, 5.068054>,
      < -0.413533, -0.373737, 4.930151>,
      < -0.413626, -0.215521, 5.088133>
    }
    triangle {
      < -0.413638, -0.195472, 5.068054>,
      < -0.413626, -0.215521, 5.088133>,
      < -0.104566, -0.215338, 5.088133>
    }
    triangle {
      < -0.413638, -0.195472, 5.068054>,
      < -0.104566, -0.215338, 5.088133>,
      < -0.104578, -0.195290, 5.068054>
    }
    triangle {
      < -0.104566, -0.215338, 5.088133>,
      < -0.104473, -0.373554, 4.930152>,
      < -0.104485, -0.353504, 4.910072>
    }
    triangle {
      < -0.104566, -0.215338, 5.088133>,
      < -0.104485, -0.353504, 4.910072>,
      < -0.104578, -0.195290, 5.068054>
    }
    triangle {
      < -0.413533, -0.373737, 4.930151>,
      < -0.413545, -0.353687, 4.910072>,
      < -0.104485, -0.353504, 4.910072>
    }
    triangle {
      < -0.413533, -0.373737, 4.930151>,
      < -0.104485, -0.353504, 4.910072>,
      < -0.104473, -0.373554, 4.930152>
    }
    triangle {
      < 0.025407, -0.215261, 5.088133>,
      < 0.025501, -0.373477, 4.930152>,
      < 0.334560, -0.373294, 4.930152>
    }
    triangle {
      < 0.025407, -0.215261, 5.088133>,
      < 0.334560, -0.373294, 4.930152>,
      < 0.334466, -0.215078, 5.088133>
    }
    triangle {
      < 0.334454, -0.195029, 5.068054>,
      < 0.334548, -0.353244, 4.910073>,
      < 0.025489, -0.353427, 4.910072>
    }
    triangle {
      < 0.334454, -0.195029, 5.068054>,
      < 0.025489, -0.353427, 4.910072>,
      < 0.025395, -0.195212, 5.068054>
    }
    triangle {
      < 0.025395, -0.195212, 5.068054>,
      < 0.025489, -0.353427, 4.910072>,
      < 0.025501, -0.373477, 4.930152>
    }
    triangle {
      < 0.025395, -0.195212, 5.068054>,
      < 0.025501, -0.373477, 4.930152>,
      < 0.025407, -0.215261, 5.088133>
    }
    triangle {
      < 0.025395, -0.195212, 5.068054>,
      < 0.025407, -0.215261, 5.088133>,
      < 0.334466, -0.215078, 5.088133>
    }
    triangle {
      < 0.025395, -0.195212, 5.068054>,
      < 0.334466, -0.215078, 5.088133>,
      < 0.334454, -0.195029, 5.068054>
    }
    triangle {
      < 0.334466, -0.215078, 5.088133>,
      < 0.334560, -0.373294, 4.930152>,
      < 0.334548, -0.353244, 4.910073>
    }
    triangle {
      < 0.334466, -0.215078, 5.088133>,
      < 0.334548, -0.353244, 4.910073>,
      < 0.334454, -0.195029, 5.068054>
    }
    triangle {
      < 0.025501, -0.373477, 4.930152>,
      < 0.025489, -0.353427, 4.910072>,
      < 0.334548, -0.353244, 4.910073>
    }
    triangle {
      < 0.025501, -0.373477, 4.930152>,
      < 0.334548, -0.353244, 4.910073>,
      < 0.334560, -0.373294, 4.930152>
    }
    triangle {
      < -0.413427, -0.553525, 5.068371>,
      < -0.413519, -0.395591, 4.910109>,
      < -0.104460, -0.395408, 4.910109>
    }
    triangle {
      < -0.413427, -0.553525, 5.068371>,
      < -0.104460, -0.395408, 4.910109>,
      < -0.104367, -0.553342, 5.068371>
    }
    triangle {
      < -0.104378, -0.533257, 5.088415>,
      < -0.104472, -0.375322, 4.930153>,
      < -0.413532, -0.375505, 4.930153>
    }
    triangle {
      < -0.104378, -0.533257, 5.088415>,
      < -0.413532, -0.375505, 4.930153>,
      < -0.413438, -0.533440, 5.088415>
    }
    triangle {
      < -0.413438, -0.533440, 5.088415>,
      < -0.413532, -0.375505, 4.930153>,
      < -0.413519, -0.395591, 4.910109>
    }
    triangle {
      < -0.413438, -0.533440, 5.088415>,
      < -0.413519, -0.395591, 4.910109>,
      < -0.413427, -0.553525, 5.068371>
    }
    triangle {
      < -0.413438, -0.533440, 5.088415>,
      < -0.413427, -0.553525, 5.068371>,
      < -0.104367, -0.553342, 5.068371>
    }
    triangle {
      < -0.413438, -0.533440, 5.088415>,
      < -0.104367, -0.553342, 5.068371>,
      < -0.104378, -0.533257, 5.088415>
    }
    triangle {
      < -0.104367, -0.553342, 5.068371>,
      < -0.104460, -0.395408, 4.910109>,
      < -0.104472, -0.375322, 4.930153>
    }
    triangle {
      < -0.104367, -0.553342, 5.068371>,
      < -0.104472, -0.375322, 4.930153>,
      < -0.104378, -0.533257, 5.088415>
    }
    triangle {
      < -0.413519, -0.395591, 4.910109>,
      < -0.413532, -0.375505, 4.930153>,
      < -0.104472, -0.375322, 4.930153>
    }
    triangle {
      < -0.413519, -0.395591, 4.910109>,
      < -0.104472, -0.375322, 4.930153>,
      < -0.104460, -0.395408, 4.910109>
    }
    triangle {
      < 0.025607, -0.553265, 5.068371>,
      < 0.025513, -0.395331, 4.910109>,
      < 0.334572, -0.395148, 4.910110>
    }
    triangle {
      < 0.025607, -0.553265, 5.068371>,
      < 0.334572, -0.395148, 4.910110>,
      < 0.334666, -0.553082, 5.068372>
    }
    triangle {
      < 0.334654, -0.532997, 5.088415>,
      < 0.334561, -0.375062, 4.930153>,
      < 0.025501, -0.375245, 4.930153>
    }
    triangle {
      < 0.334654, -0.532997, 5.088415>,
      < 0.025501, -0.375245, 4.930153>,
      < 0.025595, -0.533180, 5.088415>
    }
    triangle {
      < 0.025595, -0.533180, 5.088415>,
      < 0.025501, -0.375245, 4.930153>,
      < 0.025513, -0.395331, 4.910109>
    }
    triangle {
      < 0.025595, -0.533180, 5.088415>,
      < 0.025513, -0.395331, 4.910109>,
      < 0.025607, -0.553265, 5.068371>
    }
    triangle {
      < 0.025595, -0.533180, 5.088415>,
      < 0.025607, -0.553265, 5.068371>,
      < 0.334666, -0.553082, 5.068372>
    }
    triangle {
      < 0.025595, -0.533180, 5.088415>,
      < 0.334666, -0.553082, 5.068372>,
      < 0.334654, -0.532997, 5.088415>
    }
    triangle {
      < 0.334666, -0.553082, 5.068372>,
      < 0.334572, -0.395148, 4.910110>,
      < 0.334561, -0.375062, 4.930153>
    }
    triangle {
      < 0.334666, -0.553082, 5.068372>,
      < 0.334561, -0.375062, 4.930153>,
      < 0.334654, -0.532997, 5.088415>
    }
    triangle {
      < 0.025513, -0.395331, 4.910109>,
      < 0.025501, -0.375245, 4.930153>,
      < 0.334561, -0.375062, 4.930153>
    }
    triangle {
      < 0.025513, -0.395331, 4.910109>,
      < 0.334561, -0.375062, 4.930153>,
      < 0.334572, -0.395148, 4.910110>
    }
    texture {ordinance2}
  }
  // cannon
  union {
    triangle {
      < 6.418575, -0.373276, 0.004162>,
      < 6.418574, -0.371955, 0.003955>,
      < 6.418582, -0.386466, -0.040758>
    }
    triangle {
      < 6.418575, -0.373276, 0.004162>,
      < 6.418582, -0.386466, -0.040758>,
      < 6.418575, -0.373262, -0.042845>
    }
    triangle {
      < 6.418575, -0.373262, -0.042845>,
      < 6.418582, -0.386466, -0.040758>,
      < 6.746758, -0.386272, -0.040757>
    }
    triangle {
      < 6.418575, -0.373262, -0.042845>,
      < 6.746758, -0.386272, -0.040757>,
      < 6.746750, -0.373068, -0.042845>
    }
    triangle {
      < 6.746750, -0.373068, -0.042845>,
      < 6.746758, -0.386272, -0.040757>,
      < 6.746766, -0.399463, -0.081404>
    }
    triangle {
      < 6.746750, -0.373068, -0.042845>,
      < 6.746766, -0.399463, -0.081404>,
      < 6.746750, -0.373056, -0.085579>
    }
    triangle {
      < 6.746750, -0.373056, -0.085579>,
      < 6.746766, -0.399463, -0.081404>,
      < 6.320137, -0.399716, -0.081404>
    }
    triangle {
      < 6.746750, -0.373056, -0.085579>,
      < 6.320137, -0.399716, -0.081404>,
      < 6.320122, -0.373309, -0.085579>
    }
    triangle {
      < 6.320122, -0.373309, -0.085579>,
      < 6.320137, -0.399716, -0.081404>,
      < 6.311931, -0.397082, -0.073276>
    }
    triangle {
      < 6.320122, -0.373309, -0.085579>,
      < 6.311931, -0.397082, -0.073276>,
      < 6.311917, -0.373316, -0.077032>
    }
    triangle {
      < 6.311917, -0.373316, -0.077032>,
      < 6.311931, -0.397082, -0.073276>,
      < 6.090412, -0.397213, -0.073276>
    }
    triangle {
      < 6.311917, -0.373316, -0.077032>,
      < 6.090412, -0.397213, -0.073276>,
      < 6.090398, -0.373447, -0.077032>
    }
    triangle {
      < 6.090398, -0.373447, -0.077032>,
      < 6.090412, -0.397213, -0.073276>,
      < 6.086307, -0.393258, -0.061082>
    }
    triangle {
      < 6.090398, -0.373447, -0.077032>,
      < 6.086307, -0.393258, -0.061082>,
      < 6.086296, -0.373453, -0.064212>
    }
    triangle {
      < 6.086296, -0.373453, -0.064212>,
      < 6.086307, -0.393258, -0.061082>,
      < 6.016569, -0.393300, -0.061082>
    }
    triangle {
      < 6.086296, -0.373453, -0.064212>,
      < 6.016569, -0.393300, -0.061082>,
      < 6.016558, -0.373495, -0.064212>
    }
    triangle {
      < 6.016558, -0.373495, -0.064212>,
      < 6.016569, -0.393300, -0.061082>,
      < 6.000159, -0.389353, -0.048886>
    }
    triangle {
      < 6.016558, -0.373495, -0.064212>,
      < 6.000159, -0.389353, -0.048886>,
      < 6.000150, -0.373508, -0.051392>
    }
    triangle {
      < 6.000150, -0.373508, -0.051392>,
      < 6.000159, -0.389353, -0.048886>,
      < 5.516099, -0.389640, -0.048886>
    }
    triangle {
      < 6.000150, -0.373508, -0.051392>,
      < 5.516099, -0.389640, -0.048886>,
      < 5.516090, -0.373795, -0.051392>
    }
    triangle {
      < 5.516090, -0.373795, -0.051392>,
      < 5.516099, -0.389640, -0.048886>,
      < 5.216638, -0.389818, -0.048887>
    }
    triangle {
      < 5.516090, -0.373795, -0.051392>,
      < 5.216638, -0.389818, -0.048887>,
      < 5.216629, -0.373973, -0.051392>
    }
    triangle {
      < 5.216629, -0.373973, -0.051392>,
      < 5.216638, -0.389818, -0.048887>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418574, -0.371955, 0.003955>,
      < 6.418573, -0.370764, 0.003348>,
      < 6.418590, -0.398379, -0.034693>
    }
    triangle {
      < 6.418574, -0.371955, 0.003955>,
      < 6.418590, -0.398379, -0.034693>,
      < 6.418582, -0.386466, -0.040758>
    }
    triangle {
      < 6.418582, -0.386466, -0.040758>,
      < 6.418590, -0.398379, -0.034693>,
      < 6.746765, -0.398185, -0.034693>
    }
    triangle {
      < 6.418582, -0.386466, -0.040758>,
      < 6.746765, -0.398185, -0.034693>,
      < 6.746758, -0.386272, -0.040757>
    }
    triangle {
      < 6.746758, -0.386272, -0.040757>,
      < 6.746765, -0.398185, -0.034693>,
      < 6.746780, -0.423288, -0.069276>
    }
    triangle {
      < 6.746758, -0.386272, -0.040757>,
      < 6.746780, -0.423288, -0.069276>,
      < 6.746766, -0.399463, -0.081404>
    }
    triangle {
      < 6.746766, -0.399463, -0.081404>,
      < 6.746780, -0.423288, -0.069276>,
      < 6.320151, -0.423541, -0.069276>
    }
    triangle {
      < 6.746766, -0.399463, -0.081404>,
      < 6.320151, -0.423541, -0.069276>,
      < 6.320137, -0.399716, -0.081404>
    }
    triangle {
      < 6.320137, -0.399716, -0.081404>,
      < 6.320151, -0.423541, -0.069276>,
      < 6.311944, -0.418525, -0.062359>
    }
    triangle {
      < 6.320137, -0.399716, -0.081404>,
      < 6.311944, -0.418525, -0.062359>,
      < 6.311931, -0.397082, -0.073276>
    }
    triangle {
      < 6.311931, -0.397082, -0.073276>,
      < 6.311944, -0.418525, -0.062359>,
      < 6.090425, -0.418657, -0.062359>
    }
    triangle {
      < 6.311931, -0.397082, -0.073276>,
      < 6.090425, -0.418657, -0.062359>,
      < 6.090412, -0.397213, -0.073276>
    }
    triangle {
      < 6.090412, -0.397213, -0.073276>,
      < 6.090425, -0.418657, -0.062359>,
      < 6.086318, -0.411128, -0.051985>
    }
    triangle {
      < 6.090412, -0.397213, -0.073276>,
      < 6.086318, -0.411128, -0.051985>,
      < 6.086307, -0.393258, -0.061082>
    }
    triangle {
      < 6.086307, -0.393258, -0.061082>,
      < 6.086318, -0.411128, -0.051985>,
      < 6.016580, -0.411170, -0.051985>
    }
    triangle {
      < 6.086307, -0.393258, -0.061082>,
      < 6.016580, -0.411170, -0.051985>,
      < 6.016569, -0.393300, -0.061082>
    }
    triangle {
      < 6.016569, -0.393300, -0.061082>,
      < 6.016580, -0.411170, -0.051985>,
      < 6.000167, -0.403648, -0.041610>
    }
    triangle {
      < 6.016569, -0.393300, -0.061082>,
      < 6.000167, -0.403648, -0.041610>,
      < 6.000159, -0.389353, -0.048886>
    }
    triangle {
      < 6.000159, -0.389353, -0.048886>,
      < 6.000167, -0.403648, -0.041610>,
      < 5.516108, -0.403935, -0.041610>
    }
    triangle {
      < 6.000159, -0.389353, -0.048886>,
      < 5.516108, -0.403935, -0.041610>,
      < 5.516099, -0.389640, -0.048886>
    }
    triangle {
      < 5.516099, -0.389640, -0.048886>,
      < 5.516108, -0.403935, -0.041610>,
      < 5.216646, -0.404113, -0.041610>
    }
    triangle {
      < 5.516099, -0.389640, -0.048886>,
      < 5.216646, -0.404113, -0.041610>,
      < 5.216638, -0.389818, -0.048887>
    }
    triangle {
      < 5.216638, -0.389818, -0.048887>,
      < 5.216646, -0.404113, -0.041610>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418573, -0.370764, 0.003348>,
      < 6.418572, -0.369819, 0.002402>,
      < 6.418595, -0.407836, -0.025245>
    }
    triangle {
      < 6.418573, -0.370764, 0.003348>,
      < 6.418595, -0.407836, -0.025245>,
      < 6.418590, -0.398379, -0.034693>
    }
    triangle {
      < 6.418590, -0.398379, -0.034693>,
      < 6.418595, -0.407836, -0.025245>,
      < 6.746771, -0.407642, -0.025245>
    }
    triangle {
      < 6.418590, -0.398379, -0.034693>,
      < 6.746771, -0.407642, -0.025245>,
      < 6.746765, -0.398185, -0.034693>
    }
    triangle {
      < 6.746765, -0.398185, -0.034693>,
      < 6.746771, -0.407642, -0.025245>,
      < 6.746791, -0.442202, -0.050380>
    }
    triangle {
      < 6.746765, -0.398185, -0.034693>,
      < 6.746791, -0.442202, -0.050380>,
      < 6.746780, -0.423288, -0.069276>
    }
    triangle {
      < 6.746780, -0.423288, -0.069276>,
      < 6.746791, -0.442202, -0.050380>,
      < 6.320163, -0.442455, -0.050380>
    }
    triangle {
      < 6.746780, -0.423288, -0.069276>,
      < 6.320163, -0.442455, -0.050380>,
      < 6.320151, -0.423541, -0.069276>
    }
    triangle {
      < 6.320151, -0.423541, -0.069276>,
      < 6.320163, -0.442455, -0.050380>,
      < 6.311954, -0.435547, -0.045353>
    }
    triangle {
      < 6.320151, -0.423541, -0.069276>,
      < 6.311954, -0.435547, -0.045353>,
      < 6.311944, -0.418525, -0.062359>
    }
    triangle {
      < 6.311944, -0.418525, -0.062359>,
      < 6.311954, -0.435547, -0.045353>,
      < 6.090435, -0.435679, -0.045353>
    }
    triangle {
      < 6.311944, -0.418525, -0.062359>,
      < 6.090435, -0.435679, -0.045353>,
      < 6.090425, -0.418657, -0.062359>
    }
    triangle {
      < 6.090425, -0.418657, -0.062359>,
      < 6.090435, -0.435679, -0.045353>,
      < 6.086326, -0.425313, -0.037812>
    }
    triangle {
      < 6.090425, -0.418657, -0.062359>,
      < 6.086326, -0.425313, -0.037812>,
      < 6.086318, -0.411128, -0.051985>
    }
    triangle {
      < 6.086318, -0.411128, -0.051985>,
      < 6.086326, -0.425313, -0.037812>,
      < 6.016588, -0.425355, -0.037812>
    }
    triangle {
      < 6.086318, -0.411128, -0.051985>,
      < 6.016588, -0.425355, -0.037812>,
      < 6.016580, -0.411170, -0.051985>
    }
    triangle {
      < 6.016580, -0.411170, -0.051985>,
      < 6.016588, -0.425355, -0.037812>,
      < 6.000174, -0.414996, -0.030272>
    }
    triangle {
      < 6.016580, -0.411170, -0.051985>,
      < 6.000174, -0.414996, -0.030272>,
      < 6.000167, -0.403648, -0.041610>
    }
    triangle {
      < 6.000167, -0.403648, -0.041610>,
      < 6.000174, -0.414996, -0.030272>,
      < 5.516114, -0.415283, -0.030272>
    }
    triangle {
      < 6.000167, -0.403648, -0.041610>,
      < 5.516114, -0.415283, -0.030272>,
      < 5.516108, -0.403935, -0.041610>
    }
    triangle {
      < 5.516108, -0.403935, -0.041610>,
      < 5.516114, -0.415283, -0.030272>,
      < 5.216653, -0.415461, -0.030272>
    }
    triangle {
      < 5.516108, -0.403935, -0.041610>,
      < 5.216653, -0.415461, -0.030272>,
      < 5.216646, -0.404113, -0.041610>
    }
    triangle {
      < 5.216646, -0.404113, -0.041610>,
      < 5.216653, -0.415461, -0.030272>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418572, -0.369819, 0.002402>,
      < 6.418572, -0.369211, 0.001213>,
      < 6.418599, -0.413910, -0.013338>
    }
    triangle {
      < 6.418572, -0.369819, 0.002402>,
      < 6.418599, -0.413910, -0.013338>,
      < 6.418595, -0.407836, -0.025245>
    }
    triangle {
      < 6.418595, -0.407836, -0.025245>,
      < 6.418599, -0.413910, -0.013338>,
      < 6.746774, -0.413716, -0.013338>
    }
    triangle {
      < 6.418595, -0.407836, -0.025245>,
      < 6.746774, -0.413716, -0.013338>,
      < 6.746771, -0.407642, -0.025245>
    }
    triangle {
      < 6.746771, -0.407642, -0.025245>,
      < 6.746774, -0.413716, -0.013338>,
      < 6.746799, -0.454351, -0.026565>
    }
    triangle {
      < 6.746771, -0.407642, -0.025245>,
      < 6.746799, -0.454351, -0.026565>,
      < 6.746791, -0.442202, -0.050380>
    }
    triangle {
      < 6.746791, -0.442202, -0.050380>,
      < 6.746799, -0.454351, -0.026565>,
      < 6.320170, -0.454604, -0.026565>
    }
    triangle {
      < 6.746791, -0.442202, -0.050380>,
      < 6.320170, -0.454604, -0.026565>,
      < 6.320163, -0.442455, -0.050380>
    }
    triangle {
      < 6.320163, -0.442455, -0.050380>,
      < 6.320170, -0.454604, -0.026565>,
      < 6.311960, -0.446482, -0.023919>
    }
    triangle {
      < 6.320163, -0.442455, -0.050380>,
      < 6.311960, -0.446482, -0.023919>,
      < 6.311954, -0.435547, -0.045353>
    }
    triangle {
      < 6.311954, -0.435547, -0.045353>,
      < 6.311960, -0.446482, -0.023919>,
      < 6.090441, -0.446614, -0.023919>
    }
    triangle {
      < 6.311954, -0.435547, -0.045353>,
      < 6.090441, -0.446614, -0.023919>,
      < 6.090435, -0.435679, -0.045353>
    }
    triangle {
      < 6.090435, -0.435679, -0.045353>,
      < 6.090441, -0.446614, -0.023919>,
      < 6.086331, -0.434425, -0.019952>
    }
    triangle {
      < 6.090435, -0.435679, -0.045353>,
      < 6.086331, -0.434425, -0.019952>,
      < 6.086326, -0.425313, -0.037812>
    }
    triangle {
      < 6.086326, -0.425313, -0.037812>,
      < 6.086331, -0.434425, -0.019952>,
      < 6.016593, -0.434467, -0.019952>
    }
    triangle {
      < 6.086326, -0.425313, -0.037812>,
      < 6.016593, -0.434467, -0.019952>,
      < 6.016588, -0.425355, -0.037812>
    }
    triangle {
      < 6.016588, -0.425355, -0.037812>,
      < 6.016593, -0.434467, -0.019952>,
      < 6.000178, -0.422285, -0.015983>
    }
    triangle {
      < 6.016588, -0.425355, -0.037812>,
      < 6.000178, -0.422285, -0.015983>,
      < 6.000174, -0.414996, -0.030272>
    }
    triangle {
      < 6.000174, -0.414996, -0.030272>,
      < 6.000178, -0.422285, -0.015983>,
      < 5.516119, -0.422572, -0.015983>
    }
    triangle {
      < 6.000174, -0.414996, -0.030272>,
      < 5.516119, -0.422572, -0.015983>,
      < 5.516114, -0.415283, -0.030272>
    }
    triangle {
      < 5.516114, -0.415283, -0.030272>,
      < 5.516119, -0.422572, -0.015983>,
      < 5.216657, -0.422750, -0.015983>
    }
    triangle {
      < 5.516114, -0.415283, -0.030272>,
      < 5.216657, -0.422750, -0.015983>,
      < 5.216653, -0.415461, -0.030272>
    }
    triangle {
      < 5.216653, -0.415461, -0.030272>,
      < 5.216657, -0.422750, -0.015983>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418572, -0.369211, 0.001213>,
      < 6.418572, -0.369002, -0.000108>,
      < 6.418600, -0.416009, -0.000136>
    }
    triangle {
      < 6.418572, -0.369211, 0.001213>,
      < 6.418600, -0.416009, -0.000136>,
      < 6.418599, -0.413910, -0.013338>
    }
    triangle {
      < 6.418599, -0.413910, -0.013338>,
      < 6.418600, -0.416009, -0.000136>,
      < 6.746776, -0.415815, -0.000136>
    }
    triangle {
      < 6.418599, -0.413910, -0.013338>,
      < 6.746776, -0.415815, -0.000136>,
      < 6.746774, -0.413716, -0.013338>
    }
    triangle {
      < 6.746774, -0.413716, -0.013338>,
      < 6.746776, -0.415815, -0.000136>,
      < 6.746801, -0.458548, -0.000161>
    }
    triangle {
      < 6.746774, -0.413716, -0.013338>,
      < 6.746801, -0.458548, -0.000161>,
      < 6.746799, -0.454351, -0.026565>
    }
    triangle {
      < 6.746799, -0.454351, -0.026565>,
      < 6.746801, -0.458548, -0.000161>,
      < 6.320172, -0.458801, -0.000161>
    }
    triangle {
      < 6.746799, -0.454351, -0.026565>,
      < 6.320172, -0.458801, -0.000161>,
      < 6.320170, -0.454604, -0.026565>
    }
    triangle {
      < 6.320170, -0.454604, -0.026565>,
      < 6.320172, -0.458801, -0.000161>,
      < 6.311962, -0.450259, -0.000156>
    }
    triangle {
      < 6.320170, -0.454604, -0.026565>,
      < 6.311962, -0.450259, -0.000156>,
      < 6.311960, -0.446482, -0.023919>
    }
    triangle {
      < 6.311960, -0.446482, -0.023919>,
      < 6.311962, -0.450259, -0.000156>,
      < 6.090443, -0.450391, -0.000156>
    }
    triangle {
      < 6.311960, -0.446482, -0.023919>,
      < 6.090443, -0.450391, -0.000156>,
      < 6.090441, -0.446614, -0.023919>
    }
    triangle {
      < 6.090441, -0.446614, -0.023919>,
      < 6.090443, -0.450391, -0.000156>,
      < 6.086333, -0.437573, -0.000149>
    }
    triangle {
      < 6.090441, -0.446614, -0.023919>,
      < 6.086333, -0.437573, -0.000149>,
      < 6.086331, -0.434425, -0.019952>
    }
    triangle {
      < 6.086331, -0.434425, -0.019952>,
      < 6.086333, -0.437573, -0.000149>,
      < 6.016595, -0.437615, -0.000149>
    }
    triangle {
      < 6.086331, -0.434425, -0.019952>,
      < 6.016595, -0.437615, -0.000149>,
      < 6.016593, -0.434467, -0.019952>
    }
    triangle {
      < 6.016593, -0.434467, -0.019952>,
      < 6.016595, -0.437615, -0.000149>,
      < 6.000180, -0.424803, -0.000141>
    }
    triangle {
      < 6.016593, -0.434467, -0.019952>,
      < 6.000180, -0.424803, -0.000141>,
      < 6.000178, -0.422285, -0.015983>
    }
    triangle {
      < 6.000178, -0.422285, -0.015983>,
      < 6.000180, -0.424803, -0.000141>,
      < 5.516120, -0.425090, -0.000141>
    }
    triangle {
      < 6.000178, -0.422285, -0.015983>,
      < 5.516120, -0.425090, -0.000141>,
      < 5.516119, -0.422572, -0.015983>
    }
    triangle {
      < 5.516119, -0.422572, -0.015983>,
      < 5.516120, -0.425090, -0.000141>,
      < 5.216659, -0.425268, -0.000141>
    }
    triangle {
      < 5.516119, -0.422572, -0.015983>,
      < 5.216659, -0.425268, -0.000141>,
      < 5.216657, -0.422750, -0.015983>
    }
    triangle {
      < 5.216657, -0.422750, -0.015983>,
      < 5.216659, -0.425268, -0.000141>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418572, -0.369002, -0.000108>,
      < 6.418572, -0.369210, -0.001428>,
      < 6.418599, -0.413926, 0.013068>
    }
    triangle {
      < 6.418572, -0.369002, -0.000108>,
      < 6.418599, -0.413926, 0.013068>,
      < 6.418600, -0.416009, -0.000136>
    }
    triangle {
      < 6.418600, -0.416009, -0.000136>,
      < 6.418599, -0.413926, 0.013068>,
      < 6.746774, -0.413732, 0.013068>
    }
    triangle {
      < 6.418600, -0.416009, -0.000136>,
      < 6.746774, -0.413732, 0.013068>,
      < 6.746776, -0.415815, -0.000136>
    }
    triangle {
      < 6.746776, -0.415815, -0.000136>,
      < 6.746774, -0.413732, 0.013068>,
      < 6.746799, -0.454383, 0.026247>
    }
    triangle {
      < 6.746776, -0.415815, -0.000136>,
      < 6.746799, -0.454383, 0.026247>,
      < 6.746801, -0.458548, -0.000161>
    }
    triangle {
      < 6.746801, -0.458548, -0.000161>,
      < 6.746799, -0.454383, 0.026247>,
      < 6.320170, -0.454636, 0.026247>
    }
    triangle {
      < 6.746801, -0.458548, -0.000161>,
      < 6.320170, -0.454636, 0.026247>,
      < 6.320172, -0.458801, -0.000161>
    }
    triangle {
      < 6.320172, -0.458801, -0.000161>,
      < 6.320170, -0.454636, 0.026247>,
      < 6.311960, -0.446509, 0.023612>
    }
    triangle {
      < 6.320172, -0.458801, -0.000161>,
      < 6.311960, -0.446509, 0.023612>,
      < 6.311962, -0.450259, -0.000156>
    }
    triangle {
      < 6.311962, -0.450259, -0.000156>,
      < 6.311960, -0.446509, 0.023612>,
      < 6.090441, -0.446641, 0.023612>
    }
    triangle {
      < 6.311962, -0.450259, -0.000156>,
      < 6.090441, -0.446641, 0.023612>,
      < 6.090443, -0.450391, -0.000156>
    }
    triangle {
      < 6.090443, -0.450391, -0.000156>,
      < 6.090441, -0.446641, 0.023612>,
      < 6.086331, -0.434448, 0.019657>
    }
    triangle {
      < 6.090443, -0.450391, -0.000156>,
      < 6.086331, -0.434448, 0.019657>,
      < 6.086333, -0.437573, -0.000149>
    }
    triangle {
      < 6.086333, -0.437573, -0.000149>,
      < 6.086331, -0.434448, 0.019657>,
      < 6.016593, -0.434489, 0.019657>
    }
    triangle {
      < 6.086333, -0.437573, -0.000149>,
      < 6.016593, -0.434489, 0.019657>,
      < 6.016595, -0.437615, -0.000149>
    }
    triangle {
      < 6.016595, -0.437615, -0.000149>,
      < 6.016593, -0.434489, 0.019657>,
      < 6.000178, -0.422304, 0.015704>
    }
    triangle {
      < 6.016595, -0.437615, -0.000149>,
      < 6.000178, -0.422304, 0.015704>,
      < 6.000180, -0.424803, -0.000141>
    }
    triangle {
      < 6.000180, -0.424803, -0.000141>,
      < 6.000178, -0.422304, 0.015704>,
      < 5.516119, -0.422591, 0.015704>
    }
    triangle {
      < 6.000180, -0.424803, -0.000141>,
      < 5.516119, -0.422591, 0.015704>,
      < 5.516120, -0.425090, -0.000141>
    }
    triangle {
      < 5.516120, -0.425090, -0.000141>,
      < 5.516119, -0.422591, 0.015704>,
      < 5.216657, -0.422769, 0.015704>
    }
    triangle {
      < 5.516120, -0.425090, -0.000141>,
      < 5.216657, -0.422769, 0.015704>,
      < 5.216659, -0.425268, -0.000141>
    }
    triangle {
      < 5.216659, -0.425268, -0.000141>,
      < 5.216657, -0.422769, 0.015704>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418572, -0.369210, -0.001428>,
      < 6.418572, -0.369816, -0.002621>,
      < 6.418595, -0.407865, 0.024983>
    }
    triangle {
      < 6.418572, -0.369210, -0.001428>,
      < 6.418595, -0.407865, 0.024983>,
      < 6.418599, -0.413926, 0.013068>
    }
    triangle {
      < 6.418599, -0.413926, 0.013068>,
      < 6.418595, -0.407865, 0.024983>,
      < 6.746771, -0.407671, 0.024983>
    }
    triangle {
      < 6.418599, -0.413926, 0.013068>,
      < 6.746771, -0.407671, 0.024983>,
      < 6.746774, -0.413732, 0.013068>
    }
    triangle {
      < 6.746774, -0.413732, 0.013068>,
      < 6.746771, -0.407671, 0.024983>,
      < 6.746791, -0.442262, 0.050077>
    }
    triangle {
      < 6.746774, -0.413732, 0.013068>,
      < 6.746791, -0.442262, 0.050077>,
      < 6.746799, -0.454383, 0.026247>
    }
    triangle {
      < 6.746799, -0.454383, 0.026247>,
      < 6.746791, -0.442262, 0.050077>,
      < 6.320163, -0.442515, 0.050077>
    }
    triangle {
      < 6.746799, -0.454383, 0.026247>,
      < 6.320163, -0.442515, 0.050077>,
      < 6.320170, -0.454636, 0.026247>
    }
    triangle {
      < 6.320170, -0.454636, 0.026247>,
      < 6.320163, -0.442515, 0.050077>,
      < 6.311954, -0.435600, 0.045058>
    }
    triangle {
      < 6.320170, -0.454636, 0.026247>,
      < 6.311954, -0.435600, 0.045058>,
      < 6.311960, -0.446509, 0.023612>
    }
    triangle {
      < 6.311960, -0.446509, 0.023612>,
      < 6.311954, -0.435600, 0.045058>,
      < 6.090435, -0.435732, 0.045058>
    }
    triangle {
      < 6.311960, -0.446509, 0.023612>,
      < 6.090435, -0.435732, 0.045058>,
      < 6.090441, -0.446641, 0.023612>
    }
    triangle {
      < 6.090441, -0.446641, 0.023612>,
      < 6.090435, -0.435732, 0.045058>,
      < 6.086326, -0.425357, 0.037530>
    }
    triangle {
      < 6.090441, -0.446641, 0.023612>,
      < 6.086326, -0.425357, 0.037530>,
      < 6.086331, -0.434448, 0.019657>
    }
    triangle {
      < 6.086331, -0.434448, 0.019657>,
      < 6.086326, -0.425357, 0.037530>,
      < 6.016588, -0.425399, 0.037530>
    }
    triangle {
      < 6.086331, -0.434448, 0.019657>,
      < 6.016588, -0.425399, 0.037530>,
      < 6.016593, -0.434489, 0.019657>
    }
    triangle {
      < 6.016593, -0.434489, 0.019657>,
      < 6.016588, -0.425399, 0.037530>,
      < 6.000174, -0.415031, 0.030002>
    }
    triangle {
      < 6.016593, -0.434489, 0.019657>,
      < 6.000174, -0.415031, 0.030002>,
      < 6.000178, -0.422304, 0.015704>
    }
    triangle {
      < 6.000178, -0.422304, 0.015704>,
      < 6.000174, -0.415031, 0.030002>,
      < 5.516114, -0.415318, 0.030002>
    }
    triangle {
      < 6.000178, -0.422304, 0.015704>,
      < 5.516114, -0.415318, 0.030002>,
      < 5.516119, -0.422591, 0.015704>
    }
    triangle {
      < 5.516119, -0.422591, 0.015704>,
      < 5.516114, -0.415318, 0.030002>,
      < 5.216653, -0.415496, 0.030002>
    }
    triangle {
      < 5.516119, -0.422591, 0.015704>,
      < 5.216653, -0.415496, 0.030002>,
      < 5.216657, -0.422769, 0.015704>
    }
    triangle {
      < 5.216657, -0.422769, 0.015704>,
      < 5.216653, -0.415496, 0.030002>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418572, -0.369816, -0.002621>,
      < 6.418573, -0.370761, -0.003566>,
      < 6.418590, -0.398420, 0.034442>
    }
    triangle {
      < 6.418572, -0.369816, -0.002621>,
      < 6.418590, -0.398420, 0.034442>,
      < 6.418595, -0.407865, 0.024983>
    }
    triangle {
      < 6.418595, -0.407865, 0.024983>,
      < 6.418590, -0.398420, 0.034442>,
      < 6.746765, -0.398226, 0.034442>
    }
    triangle {
      < 6.418595, -0.407865, 0.024983>,
      < 6.746765, -0.398226, 0.034442>,
      < 6.746771, -0.407671, 0.024983>
    }
    triangle {
      < 6.746771, -0.407671, 0.024983>,
      < 6.746765, -0.398226, 0.034442>,
      < 6.746780, -0.423370, 0.068996>
    }
    triangle {
      < 6.746771, -0.407671, 0.024983>,
      < 6.746780, -0.423370, 0.068996>,
      < 6.746791, -0.442262, 0.050077>
    }
    triangle {
      < 6.746791, -0.442262, 0.050077>,
      < 6.746780, -0.423370, 0.068996>,
      < 6.320151, -0.423623, 0.068995>
    }
    triangle {
      < 6.746791, -0.442262, 0.050077>,
      < 6.320151, -0.423623, 0.068995>,
      < 6.320163, -0.442515, 0.050077>
    }
    triangle {
      < 6.320163, -0.442515, 0.050077>,
      < 6.320151, -0.423623, 0.068995>,
      < 6.311944, -0.418598, 0.062085>
    }
    triangle {
      < 6.320163, -0.442515, 0.050077>,
      < 6.311944, -0.418598, 0.062085>,
      < 6.311954, -0.435600, 0.045058>
    }
    triangle {
      < 6.311954, -0.435600, 0.045058>,
      < 6.311944, -0.418598, 0.062085>,
      < 6.090425, -0.418730, 0.062085>
    }
    triangle {
      < 6.311954, -0.435600, 0.045058>,
      < 6.090425, -0.418730, 0.062085>,
      < 6.090435, -0.435732, 0.045058>
    }
    triangle {
      < 6.090435, -0.435732, 0.045058>,
      < 6.090425, -0.418730, 0.062085>,
      < 6.086318, -0.411189, 0.051719>
    }
    triangle {
      < 6.090435, -0.435732, 0.045058>,
      < 6.086318, -0.411189, 0.051719>,
      < 6.086326, -0.425357, 0.037530>
    }
    triangle {
      < 6.086326, -0.425357, 0.037530>,
      < 6.086318, -0.411189, 0.051719>,
      < 6.016580, -0.411231, 0.051719>
    }
    triangle {
      < 6.086326, -0.425357, 0.037530>,
      < 6.016580, -0.411231, 0.051719>,
      < 6.016588, -0.425399, 0.037530>
    }
    triangle {
      < 6.016588, -0.425399, 0.037530>,
      < 6.016580, -0.411231, 0.051719>,
      < 6.000167, -0.403696, 0.041353>
    }
    triangle {
      < 6.016588, -0.425399, 0.037530>,
      < 6.000167, -0.403696, 0.041353>,
      < 6.000174, -0.415031, 0.030002>
    }
    triangle {
      < 6.000174, -0.415031, 0.030002>,
      < 6.000167, -0.403696, 0.041353>,
      < 5.516108, -0.403983, 0.041353>
    }
    triangle {
      < 6.000174, -0.415031, 0.030002>,
      < 5.516108, -0.403983, 0.041353>,
      < 5.516114, -0.415318, 0.030002>
    }
    triangle {
      < 5.516114, -0.415318, 0.030002>,
      < 5.516108, -0.403983, 0.041353>,
      < 5.216646, -0.404161, 0.041353>
    }
    triangle {
      < 5.516114, -0.415318, 0.030002>,
      < 5.216646, -0.404161, 0.041353>,
      < 5.216653, -0.415496, 0.030002>
    }
    triangle {
      < 5.216653, -0.415496, 0.030002>,
      < 5.216646, -0.404161, 0.041353>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418573, -0.370761, -0.003566>,
      < 6.418574, -0.371951, -0.004173>,
      < 6.418582, -0.386514, 0.040520>
    }
    triangle {
      < 6.418573, -0.370761, -0.003566>,
      < 6.418582, -0.386514, 0.040520>,
      < 6.418590, -0.398420, 0.034442>
    }
    triangle {
      < 6.418590, -0.398420, 0.034442>,
      < 6.418582, -0.386514, 0.040520>,
      < 6.746758, -0.386320, 0.040521>
    }
    triangle {
      < 6.418590, -0.398420, 0.034442>,
      < 6.746758, -0.386320, 0.040521>,
      < 6.746765, -0.398226, 0.034442>
    }
    triangle {
      < 6.746765, -0.398226, 0.034442>,
      < 6.746758, -0.386320, 0.040521>,
      < 6.746766, -0.399559, 0.081153>
    }
    triangle {
      < 6.746765, -0.398226, 0.034442>,
      < 6.746766, -0.399559, 0.081153>,
      < 6.746780, -0.423370, 0.068996>
    }
    triangle {
      < 6.746780, -0.423370, 0.068996>,
      < 6.746766, -0.399559, 0.081153>,
      < 6.320138, -0.399812, 0.081153>
    }
    triangle {
      < 6.746780, -0.423370, 0.068996>,
      < 6.320138, -0.399812, 0.081153>,
      < 6.320151, -0.423623, 0.068995>
    }
    triangle {
      < 6.320151, -0.423623, 0.068995>,
      < 6.320138, -0.399812, 0.081153>,
      < 6.311931, -0.397170, 0.073025>
    }
    triangle {
      < 6.320151, -0.423623, 0.068995>,
      < 6.311931, -0.397170, 0.073025>,
      < 6.311944, -0.418598, 0.062085>
    }
    triangle {
      < 6.311944, -0.418598, 0.062085>,
      < 6.311931, -0.397170, 0.073025>,
      < 6.090412, -0.397301, 0.073025>
    }
    triangle {
      < 6.311944, -0.418598, 0.062085>,
      < 6.090412, -0.397301, 0.073025>,
      < 6.090425, -0.418730, 0.062085>
    }
    triangle {
      < 6.090425, -0.418730, 0.062085>,
      < 6.090412, -0.397301, 0.073025>,
      < 6.086307, -0.393331, 0.060836>
    }
    triangle {
      < 6.090425, -0.418730, 0.062085>,
      < 6.086307, -0.393331, 0.060836>,
      < 6.086318, -0.411189, 0.051719>
    }
    triangle {
      < 6.086318, -0.411189, 0.051719>,
      < 6.086307, -0.393331, 0.060836>,
      < 6.016569, -0.393373, 0.060836>
    }
    triangle {
      < 6.086318, -0.411189, 0.051719>,
      < 6.016569, -0.393373, 0.060836>,
      < 6.016580, -0.411231, 0.051719>
    }
    triangle {
      < 6.016580, -0.411231, 0.051719>,
      < 6.016569, -0.393373, 0.060836>,
      < 6.000159, -0.389409, 0.048647>
    }
    triangle {
      < 6.016580, -0.411231, 0.051719>,
      < 6.000159, -0.389409, 0.048647>,
      < 6.000167, -0.403696, 0.041353>
    }
    triangle {
      < 6.000167, -0.403696, 0.041353>,
      < 6.000159, -0.389409, 0.048647>,
      < 5.516099, -0.389696, 0.048647>
    }
    triangle {
      < 6.000167, -0.403696, 0.041353>,
      < 5.516099, -0.389696, 0.048647>,
      < 5.516108, -0.403983, 0.041353>
    }
    triangle {
      < 5.516108, -0.403983, 0.041353>,
      < 5.516099, -0.389696, 0.048647>,
      < 5.216638, -0.389874, 0.048646>
    }
    triangle {
      < 5.516108, -0.403983, 0.041353>,
      < 5.216638, -0.389874, 0.048646>,
      < 5.216646, -0.404161, 0.041353>
    }
    triangle {
      < 5.216646, -0.404161, 0.041353>,
      < 5.216638, -0.389874, 0.048646>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418574, -0.371951, -0.004173>,
      < 6.418575, -0.373271, -0.004384>,
      < 6.418575, -0.373313, 0.042623>
    }
    triangle {
      < 6.418574, -0.371951, -0.004173>,
      < 6.418575, -0.373313, 0.042623>,
      < 6.418582, -0.386514, 0.040520>
    }
    triangle {
      < 6.418582, -0.386514, 0.040520>,
      < 6.418575, -0.373313, 0.042623>,
      < 6.746750, -0.373119, 0.042623>
    }
    triangle {
      < 6.418582, -0.386514, 0.040520>,
      < 6.746750, -0.373119, 0.042623>,
      < 6.746758, -0.386320, 0.040521>
    }
    triangle {
      < 6.746758, -0.386320, 0.040521>,
      < 6.746750, -0.373119, 0.042623>,
      < 6.746750, -0.373157, 0.085357>
    }
    triangle {
      < 6.746758, -0.386320, 0.040521>,
      < 6.746750, -0.373157, 0.085357>,
      < 6.746766, -0.399559, 0.081153>
    }
    triangle {
      < 6.746766, -0.399559, 0.081153>,
      < 6.746750, -0.373157, 0.085357>,
      < 6.320122, -0.373410, 0.085357>
    }
    triangle {
      < 6.746766, -0.399559, 0.081153>,
      < 6.320122, -0.373410, 0.085357>,
      < 6.320138, -0.399812, 0.081153>
    }
    triangle {
      < 6.320138, -0.399812, 0.081153>,
      < 6.320122, -0.373410, 0.085357>,
      < 6.311917, -0.373407, 0.076810>
    }
    triangle {
      < 6.320138, -0.399812, 0.081153>,
      < 6.311917, -0.373407, 0.076810>,
      < 6.311931, -0.397170, 0.073025>
    }
    triangle {
      < 6.311931, -0.397170, 0.073025>,
      < 6.311917, -0.373407, 0.076810>,
      < 6.090398, -0.373538, 0.076810>
    }
    triangle {
      < 6.311931, -0.397170, 0.073025>,
      < 6.090398, -0.373538, 0.076810>,
      < 6.090412, -0.397301, 0.073025>
    }
    triangle {
      < 6.090412, -0.397301, 0.073025>,
      < 6.090398, -0.373538, 0.076810>,
      < 6.086296, -0.373529, 0.063990>
    }
    triangle {
      < 6.090412, -0.397301, 0.073025>,
      < 6.086296, -0.373529, 0.063990>,
      < 6.086307, -0.393331, 0.060836>
    }
    triangle {
      < 6.086307, -0.393331, 0.060836>,
      < 6.086296, -0.373529, 0.063990>,
      < 6.016558, -0.373571, 0.063990>
    }
    triangle {
      < 6.086307, -0.393331, 0.060836>,
      < 6.016558, -0.373571, 0.063990>,
      < 6.016569, -0.393373, 0.060836>
    }
    triangle {
      < 6.016569, -0.393373, 0.060836>,
      < 6.016558, -0.373571, 0.063990>,
      < 6.000150, -0.373568, 0.051170>
    }
    triangle {
      < 6.016569, -0.393373, 0.060836>,
      < 6.000150, -0.373568, 0.051170>,
      < 6.000159, -0.389409, 0.048647>
    }
    triangle {
      < 6.000159, -0.389409, 0.048647>,
      < 6.000150, -0.373568, 0.051170>,
      < 5.516090, -0.373855, 0.051170>
    }
    triangle {
      < 6.000159, -0.389409, 0.048647>,
      < 5.516090, -0.373855, 0.051170>,
      < 5.516099, -0.389696, 0.048647>
    }
    triangle {
      < 5.516099, -0.389696, 0.048647>,
      < 5.516090, -0.373855, 0.051170>,
      < 5.216629, -0.374033, 0.051170>
    }
    triangle {
      < 5.516099, -0.389696, 0.048647>,
      < 5.216629, -0.374033, 0.051170>,
      < 5.216638, -0.389874, 0.048646>
    }
    triangle {
      < 5.216638, -0.389874, 0.048646>,
      < 5.216629, -0.374033, 0.051170>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418575, -0.373271, -0.004384>,
      < 6.418575, -0.374592, -0.004176>,
      < 6.418567, -0.360108, 0.040544>
    }
    triangle {
      < 6.418575, -0.373271, -0.004384>,
      < 6.418567, -0.360108, 0.040544>,
      < 6.418575, -0.373313, 0.042623>
    }
    triangle {
      < 6.418575, -0.373313, 0.042623>,
      < 6.418567, -0.360108, 0.040544>,
      < 6.746742, -0.359914, 0.040544>
    }
    triangle {
      < 6.418575, -0.373313, 0.042623>,
      < 6.746742, -0.359914, 0.040544>,
      < 6.746750, -0.373119, 0.042623>
    }
    triangle {
      < 6.746750, -0.373119, 0.042623>,
      < 6.746742, -0.359914, 0.040544>,
      < 6.746735, -0.346747, 0.081198>
    }
    triangle {
      < 6.746750, -0.373119, 0.042623>,
      < 6.746735, -0.346747, 0.081198>,
      < 6.746750, -0.373157, 0.085357>
    }
    triangle {
      < 6.746750, -0.373157, 0.085357>,
      < 6.746735, -0.346747, 0.081198>,
      < 6.320106, -0.347000, 0.081198>
    }
    triangle {
      < 6.746750, -0.373157, 0.085357>,
      < 6.320106, -0.347000, 0.081198>,
      < 6.320122, -0.373410, 0.085357>
    }
    triangle {
      < 6.320122, -0.373410, 0.085357>,
      < 6.320106, -0.347000, 0.081198>,
      < 6.311903, -0.349638, 0.073067>
    }
    triangle {
      < 6.320122, -0.373410, 0.085357>,
      < 6.311903, -0.349638, 0.073067>,
      < 6.311917, -0.373407, 0.076810>
    }
    triangle {
      < 6.311917, -0.373407, 0.076810>,
      < 6.311903, -0.349638, 0.073067>,
      < 6.090384, -0.349770, 0.073067>
    }
    triangle {
      < 6.311917, -0.373407, 0.076810>,
      < 6.090384, -0.349770, 0.073067>,
      < 6.090398, -0.373538, 0.076810>
    }
    triangle {
      < 6.090398, -0.373538, 0.076810>,
      < 6.090384, -0.349770, 0.073067>,
      < 6.086284, -0.353721, 0.060871>
    }
    triangle {
      < 6.090398, -0.373538, 0.076810>,
      < 6.086284, -0.353721, 0.060871>,
      < 6.086296, -0.373529, 0.063990>
    }
    triangle {
      < 6.086296, -0.373529, 0.063990>,
      < 6.086284, -0.353721, 0.060871>,
      < 6.016546, -0.353763, 0.060871>
    }
    triangle {
      < 6.086296, -0.373529, 0.063990>,
      < 6.016546, -0.353763, 0.060871>,
      < 6.016558, -0.373571, 0.063990>
    }
    triangle {
      < 6.016558, -0.373571, 0.063990>,
      < 6.016546, -0.353763, 0.060871>,
      < 6.000140, -0.357722, 0.048675>
    }
    triangle {
      < 6.016558, -0.373571, 0.063990>,
      < 6.000140, -0.357722, 0.048675>,
      < 6.000150, -0.373568, 0.051170>
    }
    triangle {
      < 6.000150, -0.373568, 0.051170>,
      < 6.000140, -0.357722, 0.048675>,
      < 5.516080, -0.358009, 0.048675>
    }
    triangle {
      < 6.000150, -0.373568, 0.051170>,
      < 5.516080, -0.358009, 0.048675>,
      < 5.516090, -0.373855, 0.051170>
    }
    triangle {
      < 5.516090, -0.373855, 0.051170>,
      < 5.516080, -0.358009, 0.048675>,
      < 5.216619, -0.358187, 0.048675>
    }
    triangle {
      < 5.516090, -0.373855, 0.051170>,
      < 5.216619, -0.358187, 0.048675>,
      < 5.216629, -0.374033, 0.051170>
    }
    triangle {
      < 5.216629, -0.374033, 0.051170>,
      < 5.216619, -0.358187, 0.048675>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418575, -0.374592, -0.004176>,
      < 6.418576, -0.375784, -0.003570>,
      < 6.418560, -0.348191, 0.034487>
    }
    triangle {
      < 6.418575, -0.374592, -0.004176>,
      < 6.418560, -0.348191, 0.034487>,
      < 6.418567, -0.360108, 0.040544>
    }
    triangle {
      < 6.418567, -0.360108, 0.040544>,
      < 6.418560, -0.348191, 0.034487>,
      < 6.746735, -0.347997, 0.034487>
    }
    triangle {
      < 6.418567, -0.360108, 0.040544>,
      < 6.746735, -0.347997, 0.034487>,
      < 6.746742, -0.359914, 0.040544>
    }
    triangle {
      < 6.746742, -0.359914, 0.040544>,
      < 6.746735, -0.347997, 0.034487>,
      < 6.746720, -0.322913, 0.069085>
    }
    triangle {
      < 6.746742, -0.359914, 0.040544>,
      < 6.746720, -0.322913, 0.069085>,
      < 6.746735, -0.346747, 0.081198>
    }
    triangle {
      < 6.746735, -0.346747, 0.081198>,
      < 6.746720, -0.322913, 0.069085>,
      < 6.320092, -0.323166, 0.069085>
    }
    triangle {
      < 6.746735, -0.346747, 0.081198>,
      < 6.320092, -0.323166, 0.069085>,
      < 6.320106, -0.347000, 0.081198>
    }
    triangle {
      < 6.320106, -0.347000, 0.081198>,
      < 6.320092, -0.323166, 0.069085>,
      < 6.311890, -0.328188, 0.062166>
    }
    triangle {
      < 6.320106, -0.347000, 0.081198>,
      < 6.311890, -0.328188, 0.062166>,
      < 6.311903, -0.349638, 0.073067>
    }
    triangle {
      < 6.311903, -0.349638, 0.073067>,
      < 6.311890, -0.328188, 0.062166>,
      < 6.090371, -0.328319, 0.062166>
    }
    triangle {
      < 6.311903, -0.349638, 0.073067>,
      < 6.090371, -0.328319, 0.062166>,
      < 6.090384, -0.349770, 0.073067>
    }
    triangle {
      < 6.090384, -0.349770, 0.073067>,
      < 6.090371, -0.328319, 0.062166>,
      < 6.086273, -0.335847, 0.051785>
    }
    triangle {
      < 6.090384, -0.349770, 0.073067>,
      < 6.086273, -0.335847, 0.051785>,
      < 6.086284, -0.353721, 0.060871>
    }
    triangle {
      < 6.086284, -0.353721, 0.060871>,
      < 6.086273, -0.335847, 0.051785>,
      < 6.016535, -0.335889, 0.051785>
    }
    triangle {
      < 6.086284, -0.353721, 0.060871>,
      < 6.016535, -0.335889, 0.051785>,
      < 6.016546, -0.353763, 0.060871>
    }
    triangle {
      < 6.016546, -0.353763, 0.060871>,
      < 6.016535, -0.335889, 0.051785>,
      < 6.000132, -0.343423, 0.041406>
    }
    triangle {
      < 6.016546, -0.353763, 0.060871>,
      < 6.000132, -0.343423, 0.041406>,
      < 6.000140, -0.357722, 0.048675>
    }
    triangle {
      < 6.000140, -0.357722, 0.048675>,
      < 6.000132, -0.343423, 0.041406>,
      < 5.516072, -0.343710, 0.041406>
    }
    triangle {
      < 6.000140, -0.357722, 0.048675>,
      < 5.516072, -0.343710, 0.041406>,
      < 5.516080, -0.358009, 0.048675>
    }
    triangle {
      < 5.516080, -0.358009, 0.048675>,
      < 5.516072, -0.343710, 0.041406>,
      < 5.216610, -0.343888, 0.041406>
    }
    triangle {
      < 5.516080, -0.358009, 0.048675>,
      < 5.216610, -0.343888, 0.041406>,
      < 5.216619, -0.358187, 0.048675>
    }
    triangle {
      < 5.216619, -0.358187, 0.048675>,
      < 5.216610, -0.343888, 0.041406>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418576, -0.375784, -0.003570>,
      < 6.418577, -0.376730, -0.002626>,
      < 6.418554, -0.338729, 0.025045>
    }
    triangle {
      < 6.418576, -0.375784, -0.003570>,
      < 6.418554, -0.338729, 0.025045>,
      < 6.418560, -0.348191, 0.034487>
    }
    triangle {
      < 6.418560, -0.348191, 0.034487>,
      < 6.418554, -0.338729, 0.025045>,
      < 6.746730, -0.338535, 0.025045>
    }
    triangle {
      < 6.418560, -0.348191, 0.034487>,
      < 6.746730, -0.338535, 0.025045>,
      < 6.746735, -0.347997, 0.034487>
    }
    triangle {
      < 6.746735, -0.347997, 0.034487>,
      < 6.746730, -0.338535, 0.025045>,
      < 6.746709, -0.303990, 0.050200>
    }
    triangle {
      < 6.746735, -0.347997, 0.034487>,
      < 6.746709, -0.303990, 0.050200>,
      < 6.746720, -0.322913, 0.069085>
    }
    triangle {
      < 6.746720, -0.322913, 0.069085>,
      < 6.746709, -0.303990, 0.050200>,
      < 6.320081, -0.304243, 0.050200>
    }
    triangle {
      < 6.746720, -0.322913, 0.069085>,
      < 6.320081, -0.304243, 0.050200>,
      < 6.320092, -0.323166, 0.069085>
    }
    triangle {
      < 6.320092, -0.323166, 0.069085>,
      < 6.320081, -0.304243, 0.050200>,
      < 6.311880, -0.311157, 0.045169>
    }
    triangle {
      < 6.320092, -0.323166, 0.069085>,
      < 6.311880, -0.311157, 0.045169>,
      < 6.311890, -0.328188, 0.062166>
    }
    triangle {
      < 6.311890, -0.328188, 0.062166>,
      < 6.311880, -0.311157, 0.045169>,
      < 6.090361, -0.311288, 0.045169>
    }
    triangle {
      < 6.311890, -0.328188, 0.062166>,
      < 6.090361, -0.311288, 0.045169>,
      < 6.090371, -0.328319, 0.062166>
    }
    triangle {
      < 6.090371, -0.328319, 0.062166>,
      < 6.090361, -0.311288, 0.045169>,
      < 6.086265, -0.321653, 0.037622>
    }
    triangle {
      < 6.090371, -0.328319, 0.062166>,
      < 6.086265, -0.321653, 0.037622>,
      < 6.086273, -0.335847, 0.051785>
    }
    triangle {
      < 6.086273, -0.335847, 0.051785>,
      < 6.086265, -0.321653, 0.037622>,
      < 6.016527, -0.321695, 0.037622>
    }
    triangle {
      < 6.086273, -0.335847, 0.051785>,
      < 6.016527, -0.321695, 0.037622>,
      < 6.016535, -0.335889, 0.051785>
    }
    triangle {
      < 6.016535, -0.335889, 0.051785>,
      < 6.016527, -0.321695, 0.037622>,
      < 6.000125, -0.332068, 0.030076>
    }
    triangle {
      < 6.016535, -0.335889, 0.051785>,
      < 6.000125, -0.332068, 0.030076>,
      < 6.000132, -0.343423, 0.041406>
    }
    triangle {
      < 6.000132, -0.343423, 0.041406>,
      < 6.000125, -0.332068, 0.030076>,
      < 5.516065, -0.332355, 0.030076>
    }
    triangle {
      < 6.000132, -0.343423, 0.041406>,
      < 5.516065, -0.332355, 0.030076>,
      < 5.516072, -0.343710, 0.041406>
    }
    triangle {
      < 5.516072, -0.343710, 0.041406>,
      < 5.516065, -0.332355, 0.030076>,
      < 5.216604, -0.332533, 0.030075>
    }
    triangle {
      < 5.516072, -0.343710, 0.041406>,
      < 5.216604, -0.332533, 0.030075>,
      < 5.216610, -0.343888, 0.041406>
    }
    triangle {
      < 5.216610, -0.343888, 0.041406>,
      < 5.216604, -0.332533, 0.030075>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418577, -0.376730, -0.002626>,
      < 6.418577, -0.377338, -0.001436>,
      < 6.418550, -0.332648, 0.013140>
    }
    triangle {
      < 6.418577, -0.376730, -0.002626>,
      < 6.418550, -0.332648, 0.013140>,
      < 6.418554, -0.338729, 0.025045>
    }
    triangle {
      < 6.418554, -0.338729, 0.025045>,
      < 6.418550, -0.332648, 0.013140>,
      < 6.746726, -0.332454, 0.013140>
    }
    triangle {
      < 6.418554, -0.338729, 0.025045>,
      < 6.746726, -0.332454, 0.013140>,
      < 6.746730, -0.338535, 0.025045>
    }
    triangle {
      < 6.746730, -0.338535, 0.025045>,
      < 6.746726, -0.332454, 0.013140>,
      < 6.746702, -0.291826, 0.026392>
    }
    triangle {
      < 6.746730, -0.338535, 0.025045>,
      < 6.746702, -0.291826, 0.026392>,
      < 6.746709, -0.303990, 0.050200>
    }
    triangle {
      < 6.746709, -0.303990, 0.050200>,
      < 6.746702, -0.291826, 0.026392>,
      < 6.320074, -0.292079, 0.026391>
    }
    triangle {
      < 6.746709, -0.303990, 0.050200>,
      < 6.320074, -0.292079, 0.026391>,
      < 6.320081, -0.304243, 0.050200>
    }
    triangle {
      < 6.320081, -0.304243, 0.050200>,
      < 6.320074, -0.292079, 0.026391>,
      < 6.311873, -0.300210, 0.023741>
    }
    triangle {
      < 6.320081, -0.304243, 0.050200>,
      < 6.311873, -0.300210, 0.023741>,
      < 6.311880, -0.311157, 0.045169>
    }
    triangle {
      < 6.311880, -0.311157, 0.045169>,
      < 6.311873, -0.300210, 0.023741>,
      < 6.090354, -0.300341, 0.023741>
    }
    triangle {
      < 6.311880, -0.311157, 0.045169>,
      < 6.090354, -0.300341, 0.023741>,
      < 6.090361, -0.311288, 0.045169>
    }
    triangle {
      < 6.090361, -0.311288, 0.045169>,
      < 6.090354, -0.300341, 0.023741>,
      < 6.086259, -0.312531, 0.019766>
    }
    triangle {
      < 6.090361, -0.311288, 0.045169>,
      < 6.086259, -0.312531, 0.019766>,
      < 6.086265, -0.321653, 0.037622>
    }
    triangle {
      < 6.086265, -0.321653, 0.037622>,
      < 6.086259, -0.312531, 0.019766>,
      < 6.016521, -0.312573, 0.019766>
    }
    triangle {
      < 6.086265, -0.321653, 0.037622>,
      < 6.016521, -0.312573, 0.019766>,
      < 6.016527, -0.321695, 0.037622>
    }
    triangle {
      < 6.016527, -0.321695, 0.037622>,
      < 6.016521, -0.312573, 0.019766>,
      < 6.000121, -0.324770, 0.015791>
    }
    triangle {
      < 6.016527, -0.321695, 0.037622>,
      < 6.000121, -0.324770, 0.015791>,
      < 6.000125, -0.332068, 0.030076>
    }
    triangle {
      < 6.000125, -0.332068, 0.030076>,
      < 6.000121, -0.324770, 0.015791>,
      < 5.516061, -0.325057, 0.015791>
    }
    triangle {
      < 6.000125, -0.332068, 0.030076>,
      < 5.516061, -0.325057, 0.015791>,
      < 5.516065, -0.332355, 0.030076>
    }
    triangle {
      < 5.516065, -0.332355, 0.030076>,
      < 5.516061, -0.325057, 0.015791>,
      < 5.216599, -0.325235, 0.015791>
    }
    triangle {
      < 5.516065, -0.332355, 0.030076>,
      < 5.216599, -0.325235, 0.015791>,
      < 5.216604, -0.332533, 0.030075>
    }
    triangle {
      < 5.216604, -0.332533, 0.030075>,
      < 5.216599, -0.325235, 0.015791>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418577, -0.377338, -0.001436>,
      < 6.418577, -0.377548, -0.000116>,
      < 6.418550, -0.330541, -0.000060>
    }
    triangle {
      < 6.418577, -0.377338, -0.001436>,
      < 6.418550, -0.330541, -0.000060>,
      < 6.418550, -0.332648, 0.013140>
    }
    triangle {
      < 6.418550, -0.332648, 0.013140>,
      < 6.418550, -0.330541, -0.000060>,
      < 6.746725, -0.330347, -0.000060>
    }
    triangle {
      < 6.418550, -0.332648, 0.013140>,
      < 6.746725, -0.330347, -0.000060>,
      < 6.746726, -0.332454, 0.013140>
    }
    triangle {
      < 6.746726, -0.332454, 0.013140>,
      < 6.746725, -0.330347, -0.000060>,
      < 6.746699, -0.287613, -0.000009>
    }
    triangle {
      < 6.746726, -0.332454, 0.013140>,
      < 6.746699, -0.287613, -0.000009>,
      < 6.746702, -0.291826, 0.026392>
    }
    triangle {
      < 6.746702, -0.291826, 0.026392>,
      < 6.746699, -0.287613, -0.000009>,
      < 6.320071, -0.287866, -0.000009>
    }
    triangle {
      < 6.746702, -0.291826, 0.026392>,
      < 6.320071, -0.287866, -0.000009>,
      < 6.320074, -0.292079, 0.026391>
    }
    triangle {
      < 6.320074, -0.292079, 0.026391>,
      < 6.320071, -0.287866, -0.000009>,
      < 6.311871, -0.296418, -0.000020>
    }
    triangle {
      < 6.320074, -0.292079, 0.026391>,
      < 6.311871, -0.296418, -0.000020>,
      < 6.311873, -0.300210, 0.023741>
    }
    triangle {
      < 6.311873, -0.300210, 0.023741>,
      < 6.311871, -0.296418, -0.000020>,
      < 6.090352, -0.296549, -0.000020>
    }
    triangle {
      < 6.311873, -0.300210, 0.023741>,
      < 6.090352, -0.296549, -0.000020>,
      < 6.090354, -0.300341, 0.023741>
    }
    triangle {
      < 6.090354, -0.300341, 0.023741>,
      < 6.090352, -0.296549, -0.000020>,
      < 6.086257, -0.309371, -0.000035>
    }
    triangle {
      < 6.090354, -0.300341, 0.023741>,
      < 6.086257, -0.309371, -0.000035>,
      < 6.086259, -0.312531, 0.019766>
    }
    triangle {
      < 6.086259, -0.312531, 0.019766>,
      < 6.086257, -0.309371, -0.000035>,
      < 6.016520, -0.309413, -0.000035>
    }
    triangle {
      < 6.086259, -0.312531, 0.019766>,
      < 6.016520, -0.309413, -0.000035>,
      < 6.016521, -0.312573, 0.019766>
    }
    triangle {
      < 6.016521, -0.312573, 0.019766>,
      < 6.016520, -0.309413, -0.000035>,
      < 6.000119, -0.322242, -0.000050>
    }
    triangle {
      < 6.016521, -0.312573, 0.019766>,
      < 6.000119, -0.322242, -0.000050>,
      < 6.000121, -0.324770, 0.015791>
    }
    triangle {
      < 6.000121, -0.324770, 0.015791>,
      < 6.000119, -0.322242, -0.000050>,
      < 5.516059, -0.322529, -0.000051>
    }
    triangle {
      < 6.000121, -0.324770, 0.015791>,
      < 5.516059, -0.322529, -0.000051>,
      < 5.516061, -0.325057, 0.015791>
    }
    triangle {
      < 5.516061, -0.325057, 0.015791>,
      < 5.516059, -0.322529, -0.000051>,
      < 5.216598, -0.322707, -0.000051>
    }
    triangle {
      < 5.516061, -0.325057, 0.015791>,
      < 5.216598, -0.322707, -0.000051>,
      < 5.216599, -0.325235, 0.015791>
    }
    triangle {
      < 5.216599, -0.325235, 0.015791>,
      < 5.216598, -0.322707, -0.000051>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418577, -0.377548, -0.000116>,
      < 6.418577, -0.377341, 0.001205>,
      < 6.418550, -0.332616, -0.013266>
    }
    triangle {
      < 6.418577, -0.377548, -0.000116>,
      < 6.418550, -0.332616, -0.013266>,
      < 6.418550, -0.330541, -0.000060>
    }
    triangle {
      < 6.418550, -0.330541, -0.000060>,
      < 6.418550, -0.332616, -0.013266>,
      < 6.746726, -0.332422, -0.013266>
    }
    triangle {
      < 6.418550, -0.330541, -0.000060>,
      < 6.746726, -0.332422, -0.013266>,
      < 6.746725, -0.330347, -0.000060>
    }
    triangle {
      < 6.746725, -0.330347, -0.000060>,
      < 6.746726, -0.332422, -0.013266>,
      < 6.746702, -0.291763, -0.026420>
    }
    triangle {
      < 6.746725, -0.330347, -0.000060>,
      < 6.746702, -0.291763, -0.026420>,
      < 6.746699, -0.287613, -0.000009>
    }
    triangle {
      < 6.746699, -0.287613, -0.000009>,
      < 6.746702, -0.291763, -0.026420>,
      < 6.320074, -0.292016, -0.026421>
    }
    triangle {
      < 6.746699, -0.287613, -0.000009>,
      < 6.320074, -0.292016, -0.026421>,
      < 6.320071, -0.287866, -0.000009>
    }
    triangle {
      < 6.320071, -0.287866, -0.000009>,
      < 6.320074, -0.292016, -0.026421>,
      < 6.311873, -0.300153, -0.023790>
    }
    triangle {
      < 6.320071, -0.287866, -0.000009>,
      < 6.311873, -0.300153, -0.023790>,
      < 6.311871, -0.296418, -0.000020>
    }
    triangle {
      < 6.311871, -0.296418, -0.000020>,
      < 6.311873, -0.300153, -0.023790>,
      < 6.090354, -0.300285, -0.023790>
    }
    triangle {
      < 6.311871, -0.296418, -0.000020>,
      < 6.090354, -0.300285, -0.023790>,
      < 6.090352, -0.296549, -0.000020>
    }
    triangle {
      < 6.090352, -0.296549, -0.000020>,
      < 6.090354, -0.300285, -0.023790>,
      < 6.086259, -0.312484, -0.019843>
    }
    triangle {
      < 6.090352, -0.296549, -0.000020>,
      < 6.086259, -0.312484, -0.019843>,
      < 6.086257, -0.309371, -0.000035>
    }
    triangle {
      < 6.086257, -0.309371, -0.000035>,
      < 6.086259, -0.312484, -0.019843>,
      < 6.016521, -0.312526, -0.019843>
    }
    triangle {
      < 6.086257, -0.309371, -0.000035>,
      < 6.016521, -0.312526, -0.019843>,
      < 6.016520, -0.309413, -0.000035>
    }
    triangle {
      < 6.016520, -0.309413, -0.000035>,
      < 6.016521, -0.312526, -0.019843>,
      < 6.000121, -0.324732, -0.015896>
    }
    triangle {
      < 6.016520, -0.309413, -0.000035>,
      < 6.000121, -0.324732, -0.015896>,
      < 6.000119, -0.322242, -0.000050>
    }
    triangle {
      < 6.000119, -0.322242, -0.000050>,
      < 6.000121, -0.324732, -0.015896>,
      < 5.516061, -0.325019, -0.015896>
    }
    triangle {
      < 6.000119, -0.322242, -0.000050>,
      < 5.516061, -0.325019, -0.015896>,
      < 5.516059, -0.322529, -0.000051>
    }
    triangle {
      < 5.516059, -0.322529, -0.000051>,
      < 5.516061, -0.325019, -0.015896>,
      < 5.216599, -0.325197, -0.015896>
    }
    triangle {
      < 5.516059, -0.322529, -0.000051>,
      < 5.216599, -0.325197, -0.015896>,
      < 5.216598, -0.322707, -0.000051>
    }
    triangle {
      < 5.216598, -0.322707, -0.000051>,
      < 5.216599, -0.325197, -0.015896>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418577, -0.377341, 0.001205>,
      < 6.418577, -0.376736, 0.002396>,
      < 6.418554, -0.338670, -0.025184>
    }
    triangle {
      < 6.418577, -0.377341, 0.001205>,
      < 6.418554, -0.338670, -0.025184>,
      < 6.418550, -0.332616, -0.013266>
    }
    triangle {
      < 6.418550, -0.332616, -0.013266>,
      < 6.418554, -0.338670, -0.025184>,
      < 6.746730, -0.338476, -0.025184>
    }
    triangle {
      < 6.418550, -0.332616, -0.013266>,
      < 6.746730, -0.338476, -0.025184>,
      < 6.746726, -0.332422, -0.013266>
    }
    triangle {
      < 6.746726, -0.332422, -0.013266>,
      < 6.746730, -0.338476, -0.025184>,
      < 6.746709, -0.303871, -0.050257>
    }
    triangle {
      < 6.746726, -0.332422, -0.013266>,
      < 6.746709, -0.303871, -0.050257>,
      < 6.746702, -0.291763, -0.026420>
    }
    triangle {
      < 6.746702, -0.291763, -0.026420>,
      < 6.746709, -0.303871, -0.050257>,
      < 6.320081, -0.304124, -0.050257>
    }
    triangle {
      < 6.746702, -0.291763, -0.026420>,
      < 6.320081, -0.304124, -0.050257>,
      < 6.320074, -0.292016, -0.026421>
    }
    triangle {
      < 6.320074, -0.292016, -0.026421>,
      < 6.320081, -0.304124, -0.050257>,
      < 6.311880, -0.311050, -0.045242>
    }
    triangle {
      < 6.320074, -0.292016, -0.026421>,
      < 6.311880, -0.311050, -0.045242>,
      < 6.311873, -0.300153, -0.023790>
    }
    triangle {
      < 6.311873, -0.300153, -0.023790>,
      < 6.311880, -0.311050, -0.045242>,
      < 6.090361, -0.311181, -0.045242>
    }
    triangle {
      < 6.311873, -0.300153, -0.023790>,
      < 6.090361, -0.311181, -0.045242>,
      < 6.090354, -0.300285, -0.023790>
    }
    triangle {
      < 6.090354, -0.300285, -0.023790>,
      < 6.090361, -0.311181, -0.045242>,
      < 6.086265, -0.321565, -0.037720>
    }
    triangle {
      < 6.090354, -0.300285, -0.023790>,
      < 6.086265, -0.321565, -0.037720>,
      < 6.086259, -0.312484, -0.019843>
    }
    triangle {
      < 6.086259, -0.312484, -0.019843>,
      < 6.086265, -0.321565, -0.037720>,
      < 6.016527, -0.321607, -0.037720>
    }
    triangle {
      < 6.086259, -0.312484, -0.019843>,
      < 6.016527, -0.321607, -0.037720>,
      < 6.016521, -0.312526, -0.019843>
    }
    triangle {
      < 6.016521, -0.312526, -0.019843>,
      < 6.016527, -0.321607, -0.037720>,
      < 6.000125, -0.331997, -0.030198>
    }
    triangle {
      < 6.016521, -0.312526, -0.019843>,
      < 6.000125, -0.331997, -0.030198>,
      < 6.000121, -0.324732, -0.015896>
    }
    triangle {
      < 6.000121, -0.324732, -0.015896>,
      < 6.000125, -0.331997, -0.030198>,
      < 5.516065, -0.332284, -0.030198>
    }
    triangle {
      < 6.000121, -0.324732, -0.015896>,
      < 5.516065, -0.332284, -0.030198>,
      < 5.516061, -0.325019, -0.015896>
    }
    triangle {
      < 5.516061, -0.325019, -0.015896>,
      < 5.516065, -0.332284, -0.030198>,
      < 5.216604, -0.332462, -0.030199>
    }
    triangle {
      < 5.516061, -0.325019, -0.015896>,
      < 5.216604, -0.332462, -0.030199>,
      < 5.216599, -0.325197, -0.015896>
    }
    triangle {
      < 5.216599, -0.325197, -0.015896>,
      < 5.216604, -0.332462, -0.030199>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418577, -0.376736, 0.002396>,
      < 6.418576, -0.375791, 0.003343>,
      < 6.418560, -0.348110, -0.034648>
    }
    triangle {
      < 6.418577, -0.376736, 0.002396>,
      < 6.418560, -0.348110, -0.034648>,
      < 6.418554, -0.338670, -0.025184>
    }
    triangle {
      < 6.418554, -0.338670, -0.025184>,
      < 6.418560, -0.348110, -0.034648>,
      < 6.746735, -0.347916, -0.034648>
    }
    triangle {
      < 6.418554, -0.338670, -0.025184>,
      < 6.746735, -0.347916, -0.034648>,
      < 6.746730, -0.338476, -0.025184>
    }
    triangle {
      < 6.746730, -0.338476, -0.025184>,
      < 6.746735, -0.347916, -0.034648>,
      < 6.746720, -0.322751, -0.069187>
    }
    triangle {
      < 6.746730, -0.338476, -0.025184>,
      < 6.746720, -0.322751, -0.069187>,
      < 6.746709, -0.303871, -0.050257>
    }
    triangle {
      < 6.746709, -0.303871, -0.050257>,
      < 6.746720, -0.322751, -0.069187>,
      < 6.320092, -0.323004, -0.069187>
    }
    triangle {
      < 6.746709, -0.303871, -0.050257>,
      < 6.320092, -0.323004, -0.069187>,
      < 6.320081, -0.304124, -0.050257>
    }
    triangle {
      < 6.320081, -0.304124, -0.050257>,
      < 6.320092, -0.323004, -0.069187>,
      < 6.311890, -0.328042, -0.062279>
    }
    triangle {
      < 6.320081, -0.304124, -0.050257>,
      < 6.311890, -0.328042, -0.062279>,
      < 6.311880, -0.311050, -0.045242>
    }
    triangle {
      < 6.311880, -0.311050, -0.045242>,
      < 6.311890, -0.328042, -0.062279>,
      < 6.090371, -0.328173, -0.062279>
    }
    triangle {
      < 6.311880, -0.311050, -0.045242>,
      < 6.090371, -0.328173, -0.062279>,
      < 6.090361, -0.311181, -0.045242>
    }
    triangle {
      < 6.090361, -0.311181, -0.045242>,
      < 6.090371, -0.328173, -0.062279>,
      < 6.086273, -0.335724, -0.051917>
    }
    triangle {
      < 6.090361, -0.311181, -0.045242>,
      < 6.086273, -0.335724, -0.051917>,
      < 6.086265, -0.321565, -0.037720>
    }
    triangle {
      < 6.086265, -0.321565, -0.037720>,
      < 6.086273, -0.335724, -0.051917>,
      < 6.016535, -0.335766, -0.051917>
    }
    triangle {
      < 6.086265, -0.321565, -0.037720>,
      < 6.016535, -0.335766, -0.051917>,
      < 6.016527, -0.321607, -0.037720>
    }
    triangle {
      < 6.016527, -0.321607, -0.037720>,
      < 6.016535, -0.335766, -0.051917>,
      < 6.000132, -0.343325, -0.041556>
    }
    triangle {
      < 6.016527, -0.321607, -0.037720>,
      < 6.000132, -0.343325, -0.041556>,
      < 6.000125, -0.331997, -0.030198>
    }
    triangle {
      < 6.000125, -0.331997, -0.030198>,
      < 6.000132, -0.343325, -0.041556>,
      < 5.516072, -0.343612, -0.041556>
    }
    triangle {
      < 6.000125, -0.331997, -0.030198>,
      < 5.516072, -0.343612, -0.041556>,
      < 5.516065, -0.332284, -0.030198>
    }
    triangle {
      < 5.516065, -0.332284, -0.030198>,
      < 5.516072, -0.343612, -0.041556>,
      < 5.216610, -0.343790, -0.041556>
    }
    triangle {
      < 5.516065, -0.332284, -0.030198>,
      < 5.216610, -0.343790, -0.041556>,
      < 5.216604, -0.332462, -0.030199>
    }
    triangle {
      < 5.216604, -0.332462, -0.030199>,
      < 5.216610, -0.343790, -0.041556>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418576, -0.375791, 0.003343>,
      < 6.418575, -0.374601, 0.003952>,
      < 6.418567, -0.360012, -0.040735>
    }
    triangle {
      < 6.418576, -0.375791, 0.003343>,
      < 6.418567, -0.360012, -0.040735>,
      < 6.418560, -0.348110, -0.034648>
    }
    triangle {
      < 6.418560, -0.348110, -0.034648>,
      < 6.418567, -0.360012, -0.040735>,
      < 6.746742, -0.359818, -0.040735>
    }
    triangle {
      < 6.418560, -0.348110, -0.034648>,
      < 6.746742, -0.359818, -0.040735>,
      < 6.746735, -0.347916, -0.034648>
    }
    triangle {
      < 6.746735, -0.347916, -0.034648>,
      < 6.746742, -0.359818, -0.040735>,
      < 6.746735, -0.346555, -0.081357>
    }
    triangle {
      < 6.746735, -0.347916, -0.034648>,
      < 6.746735, -0.346555, -0.081357>,
      < 6.746720, -0.322751, -0.069187>
    }
    triangle {
      < 6.746720, -0.322751, -0.069187>,
      < 6.746735, -0.346555, -0.081357>,
      < 6.320106, -0.346808, -0.081357>
    }
    triangle {
      < 6.746720, -0.322751, -0.069187>,
      < 6.320106, -0.346808, -0.081357>,
      < 6.320092, -0.323004, -0.069187>
    }
    triangle {
      < 6.320092, -0.323004, -0.069187>,
      < 6.320106, -0.346808, -0.081357>,
      < 6.311903, -0.349465, -0.073233>
    }
    triangle {
      < 6.320092, -0.323004, -0.069187>,
      < 6.311903, -0.349465, -0.073233>,
      < 6.311890, -0.328042, -0.062279>
    }
    triangle {
      < 6.311890, -0.328042, -0.062279>,
      < 6.311903, -0.349465, -0.073233>,
      < 6.090384, -0.349596, -0.073233>
    }
    triangle {
      < 6.311890, -0.328042, -0.062279>,
      < 6.090384, -0.349596, -0.073233>,
      < 6.090371, -0.328173, -0.062279>
    }
    triangle {
      < 6.090371, -0.328173, -0.062279>,
      < 6.090384, -0.349596, -0.073233>,
      < 6.086284, -0.353577, -0.061046>
    }
    triangle {
      < 6.090371, -0.328173, -0.062279>,
      < 6.086284, -0.353577, -0.061046>,
      < 6.086273, -0.335724, -0.051917>
    }
    triangle {
      < 6.086273, -0.335724, -0.051917>,
      < 6.086284, -0.353577, -0.061046>,
      < 6.016546, -0.353619, -0.061046>
    }
    triangle {
      < 6.086273, -0.335724, -0.051917>,
      < 6.016546, -0.353619, -0.061046>,
      < 6.016535, -0.335766, -0.051917>
    }
    triangle {
      < 6.016535, -0.335766, -0.051917>,
      < 6.016546, -0.353619, -0.061046>,
      < 6.000140, -0.357608, -0.048859>
    }
    triangle {
      < 6.016535, -0.335766, -0.051917>,
      < 6.000140, -0.357608, -0.048859>,
      < 6.000132, -0.343325, -0.041556>
    }
    triangle {
      < 6.000132, -0.343325, -0.041556>,
      < 6.000140, -0.357608, -0.048859>,
      < 5.516080, -0.357895, -0.048859>
    }
    triangle {
      < 6.000132, -0.343325, -0.041556>,
      < 5.516080, -0.357895, -0.048859>,
      < 5.516072, -0.343612, -0.041556>
    }
    triangle {
      < 5.516072, -0.343612, -0.041556>,
      < 5.516080, -0.357895, -0.048859>,
      < 5.216619, -0.358073, -0.048859>
    }
    triangle {
      < 5.516072, -0.343612, -0.041556>,
      < 5.216619, -0.358073, -0.048859>,
      < 5.216610, -0.343790, -0.041556>
    }
    triangle {
      < 5.216610, -0.343790, -0.041556>,
      < 5.216619, -0.358073, -0.048859>,
      < 5.187914, -0.374005, -0.000111>
    }
    triangle {
      < 6.418575, -0.374601, 0.003952>,
      < 6.418575, -0.373276, 0.004162>,
      < 6.418575, -0.373262, -0.042845>
    }
    triangle {
      < 6.418575, -0.374601, 0.003952>,
      < 6.418575, -0.373262, -0.042845>,
      < 6.418567, -0.360012, -0.040735>
    }
    triangle {
      < 6.418567, -0.360012, -0.040735>,
      < 6.418575, -0.373262, -0.042845>,
      < 6.746750, -0.373068, -0.042845>
    }
    triangle {
      < 6.418567, -0.360012, -0.040735>,
      < 6.746750, -0.373068, -0.042845>,
      < 6.746742, -0.359818, -0.040735>
    }
    triangle {
      < 6.746742, -0.359818, -0.040735>,
      < 6.746750, -0.373068, -0.042845>,
      < 6.746750, -0.373056, -0.085579>
    }
    triangle {
      < 6.746742, -0.359818, -0.040735>,
      < 6.746750, -0.373056, -0.085579>,
      < 6.746735, -0.346555, -0.081357>
    }
    triangle {
      < 6.746735, -0.346555, -0.081357>,
      < 6.746750, -0.373056, -0.085579>,
      < 6.320122, -0.373309, -0.085579>
    }
    triangle {
      < 6.746735, -0.346555, -0.081357>,
      < 6.320122, -0.373309, -0.085579>,
      < 6.320106, -0.346808, -0.081357>
    }
    triangle {
      < 6.320106, -0.346808, -0.081357>,
      < 6.320122, -0.373309, -0.085579>,
      < 6.311917, -0.373316, -0.077032>
    }
    triangle {
      < 6.320106, -0.346808, -0.081357>,
      < 6.311917, -0.373316, -0.077032>,
      < 6.311903, -0.349465, -0.073233>
    }
    triangle {
      < 6.311903, -0.349465, -0.073233>,
      < 6.311917, -0.373316, -0.077032>,
      < 6.090398, -0.373447, -0.077032>
    }
    triangle {
      < 6.311903, -0.349465, -0.073233>,
      < 6.090398, -0.373447, -0.077032>,
      < 6.090384, -0.349596, -0.073233>
    }
    triangle {
      < 6.090384, -0.349596, -0.073233>,
      < 6.090398, -0.373447, -0.077032>,
      < 6.086296, -0.373453, -0.064212>
    }
    triangle {
      < 6.090384, -0.349596, -0.073233>,
      < 6.086296, -0.373453, -0.064212>,
      < 6.086284, -0.353577, -0.061046>
    }
    triangle {
      < 6.086284, -0.353577, -0.061046>,
      < 6.086296, -0.373453, -0.064212>,
      < 6.016558, -0.373495, -0.064212>
    }
    triangle {
      < 6.086284, -0.353577, -0.061046>,
      < 6.016558, -0.373495, -0.064212>,
      < 6.016546, -0.353619, -0.061046>
    }
    triangle {
      < 6.016546, -0.353619, -0.061046>,
      < 6.016558, -0.373495, -0.064212>,
      < 6.000150, -0.373508, -0.051392>
    }
    triangle {
      < 6.016546, -0.353619, -0.061046>,
      < 6.000150, -0.373508, -0.051392>,
      < 6.000140, -0.357608, -0.048859>
    }
    triangle {
      < 6.000140, -0.357608, -0.048859>,
      < 6.000150, -0.373508, -0.051392>,
      < 5.516090, -0.373795, -0.051392>
    }
    triangle {
      < 6.000140, -0.357608, -0.048859>,
      < 5.516090, -0.373795, -0.051392>,
      < 5.516080, -0.357895, -0.048859>
    }
    triangle {
      < 5.516080, -0.357895, -0.048859>,
      < 5.516090, -0.373795, -0.051392>,
      < 5.216629, -0.373973, -0.051392>
    }
    triangle {
      < 5.516080, -0.357895, -0.048859>,
      < 5.216629, -0.373973, -0.051392>,
      < 5.216619, -0.358073, -0.048859>
    }
    triangle {
      < 5.216619, -0.358073, -0.048859>,
      < 5.216629, -0.373973, -0.051392>,
      < 5.187914, -0.374005, -0.000111>
    }
    texture {cannon}
  }
  // parts_turbine
  union {
    triangle {
      < -3.519228, 0.189814, 1.133963>,
      < -4.090174, 0.184937, 1.135745>,
      < -4.090031, 0.176120, 1.191001>
    }
    triangle {
      < -3.519228, 0.189814, 1.133963>,
      < -4.090031, 0.176120, 1.191001>,
      < -3.519082, 0.180658, 1.191344>
    }
    triangle {
      < -4.090174, 0.184937, 1.135745>,
      < -4.061873, 0.146258, 1.122962>,
      < -4.061697, 0.135406, 1.190969>
    }
    triangle {
      < -4.090174, 0.184937, 1.135745>,
      < -4.061697, 0.135406, 1.190969>,
      < -4.090031, 0.176120, 1.191001>
    }
    triangle {
      < -4.061873, 0.146258, 1.122962>,
      < -3.545550, 0.130421, 1.114747>,
      < -3.545353, 0.118212, 1.191255>
    }
    triangle {
      < -4.061873, 0.146258, 1.122962>,
      < -3.545353, 0.118212, 1.191255>,
      < -4.061697, 0.135406, 1.190969>
    }
    triangle {
      < -3.545550, 0.130421, 1.114747>,
      < -3.507730, -0.038884, 1.059302>,
      < -3.507391, -0.059908, 1.191066>
    }
    triangle {
      < -3.545550, 0.130421, 1.114747>,
      < -3.507391, -0.059908, 1.191066>,
      < -3.545353, 0.118212, 1.191255>
    }
    triangle {
      < -3.507730, -0.038884, 1.059302>,
      < -3.899469, -0.059799, 1.054795>,
      < -3.899118, -0.081503, 1.190808>
    }
    triangle {
      < -3.507730, -0.038884, 1.059302>,
      < -3.899118, -0.081503, 1.190808>,
      < -3.507391, -0.059908, 1.191066>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.899469, -0.059799, 1.054795>,
      < -3.857545, -0.091665, 1.044153>,
      < -3.857166, -0.115064, 1.190794>
    }
    triangle {
      < -3.899469, -0.059799, 1.054795>,
      < -3.857166, -0.115064, 1.190794>,
      < -3.899118, -0.081503, 1.190808>
    }
    triangle {
      < -3.857545, -0.091665, 1.044153>,
      < -3.182120, -0.150105, 1.021103>,
      < -3.181682, -0.177235, 1.191120>
    }
    triangle {
      < -3.857545, -0.091665, 1.044153>,
      < -3.181682, -0.177235, 1.191120>,
      < -3.857166, -0.115064, 1.190794>
    }
    triangle {
      < -3.182120, -0.150105, 1.021103>,
      < -2.686429, -0.166354, 1.012875>,
      < -2.685971, -0.194840, 1.191393>
    }
    triangle {
      < -3.182120, -0.150105, 1.021103>,
      < -2.685971, -0.194840, 1.191393>,
      < -3.181682, -0.177235, 1.191120>
    }
    triangle {
      < -2.686429, -0.166354, 1.012875>,
      < -1.723613, -0.147099, 1.013468>,
      < -1.723154, -0.175584, 1.191986>
    }
    triangle {
      < -2.686429, -0.166354, 1.012875>,
      < -1.723154, -0.175584, 1.191986>,
      < -2.685971, -0.194840, 1.191393>
    }
    triangle {
      < -1.723613, -0.147099, 1.013468>,
      < -1.091830, -0.088679, 1.028791>,
      < -1.091410, -0.114790, 1.192433>
    }
    triangle {
      < -1.723613, -0.147099, 1.013468>,
      < -1.091410, -0.114790, 1.192433>,
      < -1.723154, -0.175584, 1.191986>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.091830, -0.088679, 1.028791>,
      < -0.832079, -0.004994, 1.054551>,
      < -0.831723, -0.027037, 1.192691>
    }
    triangle {
      < -1.091830, -0.088679, 1.028791>,
      < -0.831723, -0.027037, 1.192691>,
      < -1.091410, -0.114790, 1.192433>
    }
    triangle {
      < -0.832079, -0.004994, 1.054551>,
      < -0.846230, 0.014346, 1.060943>,
      < -0.845890, -0.006680, 1.192706>
    }
    triangle {
      < -0.832079, -0.004994, 1.054551>,
      < -0.845890, -0.006680, 1.192706>,
      < -0.831723, -0.027037, 1.192691>
    }
    triangle {
      < -0.846230, 0.014346, 1.060943>,
      < -1.092755, -0.042912, 1.043724>,
      < -1.092372, -0.066650, 1.192489>
    }
    triangle {
      < -0.846230, 0.014346, 1.060943>,
      < -1.092372, -0.066650, 1.192489>,
      < -0.845890, -0.006680, 1.192706>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.092755, -0.042912, 1.043724>,
      < -1.519145, -0.051439, 1.043461>,
      < -1.518762, -0.075178, 1.192226>
    }
    triangle {
      < -1.092755, -0.042912, 1.043724>,
      < -1.518762, -0.075178, 1.192226>,
      < -1.092372, -0.066650, 1.192489>
    }
    triangle {
      < -1.519145, -0.051439, 1.043461>,
      < -1.588437, 0.313459, 1.162887>,
      < -1.588360, 0.308711, 1.192641>
    }
    triangle {
      < -1.519145, -0.051439, 1.043461>,
      < -1.588360, 0.308711, 1.192641>,
      < -1.518762, -0.075178, 1.192226>
    }
    triangle {
      < -1.588437, 0.313459, 1.162887>,
      < -1.499031, 0.315247, 1.162942>,
      < -1.498956, 0.310499, 1.192695>
    }
    triangle {
      < -1.588437, 0.313459, 1.162887>,
      < -1.498956, 0.310499, 1.192695>,
      < -1.588360, 0.308711, 1.192641>
    }
    triangle {
      < -1.499031, 0.315247, 1.162942>,
      < -1.424439, 0.369065, 1.180055>,
      < -1.424407, 0.367030, 1.192806>
    }
    triangle {
      < -1.499031, 0.315247, 1.162942>,
      < -1.424407, 0.367030, 1.192806>,
      < -1.498956, 0.310499, 1.192695>
    }
    triangle {
      < -3.519726, 0.216250, 1.082221>,
      < -4.090652, 0.210394, 1.085919>,
      < -4.090174, 0.184937, 1.135745>
    }
    triangle {
      < -3.519726, 0.216250, 1.082221>,
      < -4.090174, 0.184937, 1.135745>,
      < -3.519228, 0.189814, 1.133963>
    }
    triangle {
      < -4.090652, 0.210394, 1.085919>,
      < -4.062462, 0.177589, 1.061637>,
      < -4.061873, 0.146258, 1.122962>
    }
    triangle {
      < -4.090652, 0.210394, 1.085919>,
      < -4.061873, 0.146258, 1.122962>,
      < -4.090174, 0.184937, 1.135745>
    }
    triangle {
      < -4.062462, 0.177589, 1.061637>,
      < -3.546212, 0.165669, 1.045756>,
      < -3.545550, 0.130421, 1.114747>
    }
    triangle {
      < -4.062462, 0.177589, 1.061637>,
      < -3.545550, 0.130421, 1.114747>,
      < -4.061873, 0.146258, 1.122962>
    }
    triangle {
      < -3.546212, 0.165669, 1.045756>,
      < -3.508871, 0.021822, 0.940486>,
      < -3.507730, -0.038884, 1.059302>
    }
    triangle {
      < -3.546212, 0.165669, 1.045756>,
      < -3.507730, -0.038884, 1.059302>,
      < -3.545550, 0.130421, 1.114747>
    }
    triangle {
      < -3.508871, 0.021822, 0.940486>,
      < -3.900646, 0.002864, 0.932145>,
      < -3.899469, -0.059799, 1.054795>
    }
    triangle {
      < -3.508871, 0.021822, 0.940486>,
      < -3.899469, -0.059799, 1.054795>,
      < -3.507730, -0.038884, 1.059302>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.900646, 0.002864, 0.932145>,
      < -3.858814, -0.024106, 0.911922>,
      < -3.857545, -0.091665, 1.044153>
    }
    triangle {
      < -3.900646, 0.002864, 0.932145>,
      < -3.857545, -0.091665, 1.044153>,
      < -3.899469, -0.059799, 1.054795>
    }
    triangle {
      < -3.858814, -0.024106, 0.911922>,
      < -3.183593, -0.071776, 0.867791>,
      < -3.182120, -0.150105, 1.021103>
    }
    triangle {
      < -3.858814, -0.024106, 0.911922>,
      < -3.182120, -0.150105, 1.021103>,
      < -3.857545, -0.091665, 1.044153>
    }
    triangle {
      < -3.183593, -0.071776, 0.867791>,
      < -2.687975, -0.084109, 0.851897>,
      < -2.686429, -0.166354, 1.012875>
    }
    triangle {
      < -3.183593, -0.071776, 0.867791>,
      < -2.686429, -0.166354, 1.012875>,
      < -3.182120, -0.150105, 1.021103>
    }
    triangle {
      < -2.687975, -0.084109, 0.851897>,
      < -1.725159, -0.064854, 0.852491>,
      < -1.723613, -0.147099, 1.013468>
    }
    triangle {
      < -2.687975, -0.084109, 0.851897>,
      < -1.723613, -0.147099, 1.013468>,
      < -2.686429, -0.166354, 1.012875>
    }
    triangle {
      < -1.725159, -0.064854, 0.852491>,
      < -1.093247, -0.013287, 0.881228>,
      < -1.091830, -0.088679, 1.028791>
    }
    triangle {
      < -1.725159, -0.064854, 0.852491>,
      < -1.091830, -0.088679, 1.028791>,
      < -1.723613, -0.147099, 1.013468>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.093247, -0.013287, 0.881228>,
      < -0.833275, 0.058649, 0.929986>,
      < -0.832079, -0.004994, 1.054551>
    }
    triangle {
      < -1.093247, -0.013287, 0.881228>,
      < -0.832079, -0.004994, 1.054551>,
      < -1.091830, -0.088679, 1.028791>
    }
    triangle {
      < -0.833275, 0.058649, 0.929986>,
      < -0.847370, 0.075050, 0.942126>,
      < -0.846230, 0.014346, 1.060943>
    }
    triangle {
      < -0.833275, 0.058649, 0.929986>,
      < -0.846230, 0.014346, 1.060943>,
      < -0.832079, -0.004994, 1.054551>
    }
    triangle {
      < -0.847370, 0.075050, 0.942126>,
      < -1.094043, 0.025626, 0.909576>,
      < -1.092755, -0.042912, 1.043724>
    }
    triangle {
      < -0.847370, 0.075050, 0.942126>,
      < -1.092755, -0.042912, 1.043724>,
      < -0.846230, 0.014346, 1.060943>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.094043, 0.025626, 0.909576>,
      < -1.520433, 0.017098, 0.909313>,
      < -1.519145, -0.051439, 1.043461>
    }
    triangle {
      < -1.094043, 0.025626, 0.909576>,
      < -1.519145, -0.051439, 1.043461>,
      < -1.092755, -0.042912, 1.043724>
    }
    triangle {
      < -1.520433, 0.017098, 0.909313>,
      < -1.588695, 0.327166, 1.136058>,
      < -1.588437, 0.313459, 1.162887>
    }
    triangle {
      < -1.520433, 0.017098, 0.909313>,
      < -1.588437, 0.313459, 1.162887>,
      < -1.519145, -0.051439, 1.043461>
    }
    triangle {
      < -1.588695, 0.327166, 1.136058>,
      < -1.499289, 0.328955, 1.136113>,
      < -1.499031, 0.315247, 1.162942>
    }
    triangle {
      < -1.588695, 0.327166, 1.136058>,
      < -1.499031, 0.315247, 1.162942>,
      < -1.588437, 0.313459, 1.162887>
    }
    triangle {
      < -1.499289, 0.328955, 1.136113>,
      < -1.424549, 0.374940, 1.168557>,
      < -1.424439, 0.369065, 1.180055>
    }
    triangle {
      < -1.499289, 0.328955, 1.136113>,
      < -1.424439, 0.369065, 1.180055>,
      < -1.499031, 0.315247, 1.162942>
    }
    triangle {
      < -3.520524, 0.257379, 1.041181>,
      < -4.091420, 0.249998, 1.046399>,
      < -4.090652, 0.210394, 1.085919>
    }
    triangle {
      < -3.520524, 0.257379, 1.041181>,
      < -4.090652, 0.210394, 1.085919>,
      < -3.519726, 0.216250, 1.082221>
    }
    triangle {
      < -4.091420, 0.249998, 1.046399>,
      < -4.063406, 0.226334, 1.012998>,
      < -4.062462, 0.177589, 1.061637>
    }
    triangle {
      < -4.091420, 0.249998, 1.046399>,
      < -4.062462, 0.177589, 1.061637>,
      < -4.090652, 0.210394, 1.085919>
    }
    triangle {
      < -4.063406, 0.226334, 1.012998>,
      < -3.547276, 0.220507, 0.991037>,
      < -3.546212, 0.165669, 1.045756>
    }
    triangle {
      < -4.063406, 0.226334, 1.012998>,
      < -3.546212, 0.165669, 1.045756>,
      < -4.062462, 0.177589, 1.061637>
    }
    triangle {
      < -3.547276, 0.220507, 0.991037>,
      < -3.510701, 0.116264, 0.846247>,
      < -3.508871, 0.021822, 0.940486>
    }
    triangle {
      < -3.547276, 0.220507, 0.991037>,
      < -3.508871, 0.021822, 0.940486>,
      < -3.546212, 0.165669, 1.045756>
    }
    triangle {
      < -3.510701, 0.116264, 0.846247>,
      < -3.902536, 0.100354, 0.834866>,
      < -3.900646, 0.002864, 0.932145>
    }
    triangle {
      < -3.510701, 0.116264, 0.846247>,
      < -3.900646, 0.002864, 0.932145>,
      < -3.508871, 0.021822, 0.940486>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.902536, 0.100354, 0.834866>,
      < -3.860851, 0.081000, 0.807043>,
      < -3.858814, -0.024106, 0.911922>
    }
    triangle {
      < -3.902536, 0.100354, 0.834866>,
      < -3.858814, -0.024106, 0.911922>,
      < -3.900646, 0.002864, 0.932145>
    }
    triangle {
      < -3.860851, 0.081000, 0.807043>,
      < -3.185954, 0.050085, 0.746192>,
      < -3.183593, -0.071776, 0.867791>
    }
    triangle {
      < -3.860851, 0.081000, 0.807043>,
      < -3.183593, -0.071776, 0.867791>,
      < -3.858814, -0.024106, 0.911922>
    }
    triangle {
      < -3.185954, 0.050085, 0.746192>,
      < -2.690456, 0.043845, 0.724218>,
      < -2.687975, -0.084109, 0.851897>
    }
    triangle {
      < -3.185954, 0.050085, 0.746192>,
      < -2.687975, -0.084109, 0.851897>,
      < -3.183593, -0.071776, 0.867791>
    }
    triangle {
      < -2.690456, 0.043845, 0.724218>,
      < -1.727640, 0.063101, 0.724812>,
      < -1.725159, -0.064854, 0.852491>
    }
    triangle {
      < -2.690456, 0.043845, 0.724218>,
      < -1.725159, -0.064854, 0.852491>,
      < -2.687975, -0.084109, 0.851897>
    }
    triangle {
      < -1.727640, 0.063101, 0.724812>,
      < -1.095521, 0.104005, 0.764189>,
      < -1.093247, -0.013287, 0.881228>
    }
    triangle {
      < -1.727640, 0.063101, 0.724812>,
      < -1.093247, -0.013287, 0.881228>,
      < -1.725159, -0.064854, 0.852491>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.095521, 0.104005, 0.764189>,
      < -0.835194, 0.157661, 0.831186>,
      < -0.833275, 0.058649, 0.929986>
    }
    triangle {
      < -1.095521, 0.104005, 0.764189>,
      < -0.833275, 0.058649, 0.929986>,
      < -1.093247, -0.013287, 0.881228>
    }
    triangle {
      < -0.835194, 0.157661, 0.831186>,
      < -0.849202, 0.169493, 0.847887>,
      < -0.847370, 0.075050, 0.942126>
    }
    triangle {
      < -0.835194, 0.157661, 0.831186>,
      < -0.847370, 0.075050, 0.942126>,
      < -0.833275, 0.058649, 0.929986>
    }
    triangle {
      < -0.849202, 0.169493, 0.847887>,
      < -1.096110, 0.132256, 0.803178>,
      < -1.094043, 0.025626, 0.909576>
    }
    triangle {
      < -0.849202, 0.169493, 0.847887>,
      < -1.094043, 0.025626, 0.909576>,
      < -0.847370, 0.075050, 0.942126>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.096110, 0.132256, 0.803178>,
      < -1.522500, 0.123728, 0.802914>,
      < -1.520433, 0.017098, 0.909313>
    }
    triangle {
      < -1.096110, 0.132256, 0.803178>,
      < -1.520433, 0.017098, 0.909313>,
      < -1.094043, 0.025626, 0.909576>
    }
    triangle {
      < -1.522500, 0.123728, 0.802914>,
      < -1.589108, 0.348492, 1.114777>,
      < -1.588695, 0.327166, 1.136058>
    }
    triangle {
      < -1.522500, 0.123728, 0.802914>,
      < -1.588695, 0.327166, 1.136058>,
      < -1.520433, 0.017098, 0.909313>
    }
    triangle {
      < -1.589108, 0.348492, 1.114777>,
      < -1.499703, 0.350280, 1.114832>,
      < -1.499289, 0.328955, 1.136113>
    }
    triangle {
      < -1.589108, 0.348492, 1.114777>,
      < -1.499289, 0.328955, 1.136113>,
      < -1.588695, 0.327166, 1.136058>
    }
    triangle {
      < -1.499703, 0.350280, 1.114832>,
      < -1.424727, 0.384079, 1.159437>,
      < -1.424549, 0.374940, 1.168557>
    }
    triangle {
      < -1.499703, 0.350280, 1.114832>,
      < -1.424549, 0.374940, 1.168557>,
      < -1.499289, 0.328955, 1.136113>
    }
    triangle {
      < -3.521542, 0.309173, 1.014862>,
      < -4.092401, 0.299874, 1.021055>,
      < -4.091420, 0.249998, 1.046399>
    }
    triangle {
      < -3.521542, 0.309173, 1.014862>,
      < -4.091420, 0.249998, 1.046399>,
      < -3.520524, 0.257379, 1.041181>
    }
    triangle {
      < -4.092401, 0.299874, 1.021055>,
      < -4.064615, 0.287720, 0.981805>,
      < -4.063406, 0.226334, 1.012998>
    }
    triangle {
      < -4.092401, 0.299874, 1.021055>,
      < -4.063406, 0.226334, 1.012998>,
      < -4.091420, 0.249998, 1.046399>
    }
    triangle {
      < -4.064615, 0.287720, 0.981805>,
      < -3.548635, 0.289566, 0.955945>,
      < -3.547276, 0.220507, 0.991037>
    }
    triangle {
      < -4.064615, 0.287720, 0.981805>,
      < -3.547276, 0.220507, 0.991037>,
      < -4.063406, 0.226334, 1.012998>
    }
    triangle {
      < -3.548635, 0.289566, 0.955945>,
      < -3.513042, 0.235200, 0.785810>,
      < -3.510701, 0.116264, 0.846247>
    }
    triangle {
      < -3.548635, 0.289566, 0.955945>,
      < -3.510701, 0.116264, 0.846247>,
      < -3.547276, 0.220507, 0.991037>
    }
    triangle {
      < -3.513042, 0.235200, 0.785810>,
      < -3.904953, 0.223126, 0.772479>,
      < -3.902536, 0.100354, 0.834866>
    }
    triangle {
      < -3.513042, 0.235200, 0.785810>,
      < -3.902536, 0.100354, 0.834866>,
      < -3.510701, 0.116264, 0.846247>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.904953, 0.223126, 0.772479>,
      < -3.863457, 0.213364, 0.739783>,
      < -3.860851, 0.081000, 0.807043>
    }
    triangle {
      < -3.904953, 0.223126, 0.772479>,
      < -3.860851, 0.081000, 0.807043>,
      < -3.902536, 0.100354, 0.834866>
    }
    triangle {
      < -3.863457, 0.213364, 0.739783>,
      < -3.188976, 0.203551, 0.668209>,
      < -3.185954, 0.050085, 0.746192>
    }
    triangle {
      < -3.863457, 0.213364, 0.739783>,
      < -3.185954, 0.050085, 0.746192>,
      < -3.860851, 0.081000, 0.807043>
    }
    triangle {
      < -3.188976, 0.203551, 0.668209>,
      < -2.693628, 0.204984, 0.642337>,
      < -2.690456, 0.043845, 0.724218>
    }
    triangle {
      < -3.188976, 0.203551, 0.668209>,
      < -2.690456, 0.043845, 0.724218>,
      < -3.185954, 0.050085, 0.746192>
    }
    triangle {
      < -2.693628, 0.204984, 0.642337>,
      < -1.730812, 0.224240, 0.642929>,
      < -1.727640, 0.063101, 0.724812>
    }
    triangle {
      < -2.693628, 0.204984, 0.642337>,
      < -1.727640, 0.063101, 0.724812>,
      < -2.690456, 0.043845, 0.724218>
    }
    triangle {
      < -1.730812, 0.224240, 0.642929>,
      < -1.098429, 0.251716, 0.689131>,
      < -1.095521, 0.104005, 0.764189>
    }
    triangle {
      < -1.730812, 0.224240, 0.642929>,
      < -1.095521, 0.104005, 0.764189>,
      < -1.727640, 0.063101, 0.724812>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.098429, 0.251716, 0.689131>,
      < -0.837649, 0.282351, 0.767825>,
      < -0.835194, 0.157661, 0.831186>
    }
    triangle {
      < -1.098429, 0.251716, 0.689131>,
      < -0.835194, 0.157661, 0.831186>,
      < -1.095521, 0.104005, 0.764189>
    }
    triangle {
      < -0.837649, 0.282351, 0.767825>,
      < -0.851542, 0.288428, 0.787450>,
      < -0.849202, 0.169493, 0.847887>
    }
    triangle {
      < -0.837649, 0.282351, 0.767825>,
      < -0.849202, 0.169493, 0.847887>,
      < -0.835194, 0.157661, 0.831186>
    }
    triangle {
      < -0.851542, 0.288428, 0.787450>,
      < -1.098753, 0.266537, 0.734943>,
      < -1.096110, 0.132256, 0.803178>
    }
    triangle {
      < -0.851542, 0.288428, 0.787450>,
      < -1.096110, 0.132256, 0.803178>,
      < -0.849202, 0.169493, 0.847887>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.098753, 0.266537, 0.734943>,
      < -1.525144, 0.258010, 0.734680>,
      < -1.522500, 0.123728, 0.802914>
    }
    triangle {
      < -1.098753, 0.266537, 0.734943>,
      < -1.522500, 0.123728, 0.802914>,
      < -1.096110, 0.132256, 0.803178>
    }
    triangle {
      < -1.525144, 0.258010, 0.734680>,
      < -1.589636, 0.375348, 1.101131>,
      < -1.589108, 0.348492, 1.114777>
    }
    triangle {
      < -1.525144, 0.258010, 0.734680>,
      < -1.589108, 0.348492, 1.114777>,
      < -1.522500, 0.123728, 0.802914>
    }
    triangle {
      < -1.589636, 0.375348, 1.101131>,
      < -1.500232, 0.377137, 1.101186>,
      < -1.499703, 0.350280, 1.114832>
    }
    triangle {
      < -1.589636, 0.375348, 1.101131>,
      < -1.499703, 0.350280, 1.114832>,
      < -1.589108, 0.348492, 1.114777>
    }
    triangle {
      < -1.500232, 0.377137, 1.101186>,
      < -1.424953, 0.395589, 1.153589>,
      < -1.424727, 0.384079, 1.159437>
    }
    triangle {
      < -1.500232, 0.377137, 1.101186>,
      < -1.424727, 0.384079, 1.159437>,
      < -1.499703, 0.350280, 1.114832>
    }
    triangle {
      < -3.522685, 0.366563, 1.005840>,
      < -4.093502, 0.355140, 1.012366>,
      < -4.092401, 0.299874, 1.021055>
    }
    triangle {
      < -3.522685, 0.366563, 1.005840>,
      < -4.092401, 0.299874, 1.021055>,
      < -3.521542, 0.309173, 1.014862>
    }
    triangle {
      < -4.093502, 0.355140, 1.012366>,
      < -4.065969, 0.355739, 0.971111>,
      < -4.064615, 0.287720, 0.981805>
    }
    triangle {
      < -4.093502, 0.355140, 1.012366>,
      < -4.064615, 0.287720, 0.981805>,
      < -4.092401, 0.299874, 1.021055>
    }
    triangle {
      < -4.065969, 0.355739, 0.971111>,
      < -3.550158, 0.366087, 0.943915>,
      < -3.548635, 0.289566, 0.955945>
    }
    triangle {
      < -4.065969, 0.355739, 0.971111>,
      < -3.548635, 0.289566, 0.955945>,
      < -4.064615, 0.287720, 0.981805>
    }
    triangle {
      < -3.550158, 0.366087, 0.943915>,
      < -3.515665, 0.366987, 0.765092>,
      < -3.513042, 0.235200, 0.785810>
    }
    triangle {
      < -3.550158, 0.366087, 0.943915>,
      < -3.513042, 0.235200, 0.785810>,
      < -3.548635, 0.289566, 0.955945>
    }
    triangle {
      < -3.515665, 0.366987, 0.765092>,
      < -3.907660, 0.359163, 0.751093>,
      < -3.904953, 0.223126, 0.772479>
    }
    triangle {
      < -3.515665, 0.366987, 0.765092>,
      < -3.904953, 0.223126, 0.772479>,
      < -3.513042, 0.235200, 0.785810>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.907660, 0.359163, 0.751093>,
      < -3.866377, 0.360029, 0.716725>,
      < -3.863457, 0.213364, 0.739783>
    }
    triangle {
      < -3.907660, 0.359163, 0.751093>,
      < -3.863457, 0.213364, 0.739783>,
      < -3.904953, 0.223126, 0.772479>
    }
    triangle {
      < -3.866377, 0.360029, 0.716725>,
      < -3.192360, 0.373598, 0.641476>,
      < -3.188976, 0.203551, 0.668209>
    }
    triangle {
      < -3.866377, 0.360029, 0.716725>,
      < -3.188976, 0.203551, 0.668209>,
      < -3.863457, 0.213364, 0.739783>
    }
    triangle {
      < -3.192360, 0.373598, 0.641476>,
      < -2.697182, 0.383533, 0.614266>,
      < -2.693628, 0.204984, 0.642337>
    }
    triangle {
      < -3.192360, 0.373598, 0.641476>,
      < -2.693628, 0.204984, 0.642337>,
      < -3.188976, 0.203551, 0.668209>
    }
    triangle {
      < -2.697182, 0.383533, 0.614266>,
      < -1.734366, 0.402790, 0.614860>,
      < -1.730812, 0.224240, 0.642929>
    }
    triangle {
      < -2.697182, 0.383533, 0.614266>,
      < -1.730812, 0.224240, 0.642929>,
      < -2.693628, 0.204984, 0.642337>
    }
    triangle {
      < -1.734366, 0.402790, 0.614860>,
      < -1.101686, 0.415386, 0.663399>,
      < -1.098429, 0.251716, 0.689131>
    }
    triangle {
      < -1.734366, 0.402790, 0.614860>,
      < -1.098429, 0.251716, 0.689131>,
      < -1.730812, 0.224240, 0.642929>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.101686, 0.415386, 0.663399>,
      < -0.840399, 0.420514, 0.746104>,
      < -0.837649, 0.282351, 0.767825>
    }
    triangle {
      < -1.101686, 0.415386, 0.663399>,
      < -0.837649, 0.282351, 0.767825>,
      < -1.098429, 0.251716, 0.689131>
    }
    triangle {
      < -0.840399, 0.420514, 0.746104>,
      < -0.854165, 0.420215, 0.766732>,
      < -0.851542, 0.288428, 0.787450>
    }
    triangle {
      < -0.840399, 0.420514, 0.746104>,
      < -0.851542, 0.288428, 0.787450>,
      < -0.837649, 0.282351, 0.767825>
    }
    triangle {
      < -0.854165, 0.420215, 0.766732>,
      < -1.101714, 0.415329, 0.711550>,
      < -1.098753, 0.266537, 0.734943>
    }
    triangle {
      < -0.854165, 0.420215, 0.766732>,
      < -1.098753, 0.266537, 0.734943>,
      < -0.851542, 0.288428, 0.787450>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.101714, 0.415329, 0.711550>,
      < -1.528104, 0.406801, 0.711287>,
      < -1.525144, 0.258010, 0.734680>
    }
    triangle {
      < -1.101714, 0.415329, 0.711550>,
      < -1.525144, 0.258010, 0.734680>,
      < -1.098753, 0.266537, 0.734943>
    }
    triangle {
      < -1.528104, 0.406801, 0.711287>,
      < -1.590228, 0.405107, 1.096452>,
      < -1.589636, 0.375348, 1.101131>
    }
    triangle {
      < -1.528104, 0.406801, 0.711287>,
      < -1.589636, 0.375348, 1.101131>,
      < -1.525144, 0.258010, 0.734680>
    }
    triangle {
      < -1.590228, 0.405107, 1.096452>,
      < -1.500824, 0.406895, 1.096508>,
      < -1.500232, 0.377137, 1.101186>
    }
    triangle {
      < -1.590228, 0.405107, 1.096452>,
      < -1.500232, 0.377137, 1.101186>,
      < -1.589636, 0.375348, 1.101131>
    }
    triangle {
      < -1.500824, 0.406895, 1.096508>,
      < -1.425208, 0.408342, 1.151583>,
      < -1.424953, 0.395589, 1.153589>
    }
    triangle {
      < -1.500824, 0.406895, 1.096508>,
      < -1.424953, 0.395589, 1.153589>,
      < -1.500232, 0.377137, 1.101186>
    }
    triangle {
      < -3.523838, 0.423933, 1.014997>,
      < -4.094612, 0.410384, 1.021185>,
      < -4.093502, 0.355140, 1.012366>
    }
    triangle {
      < -3.523838, 0.423933, 1.014997>,
      < -4.093502, 0.355140, 1.012366>,
      < -3.522685, 0.366563, 1.005840>
    }
    triangle {
      < -4.094612, 0.410384, 1.021185>,
      < -4.067335, 0.423732, 0.981965>,
      < -4.065969, 0.355739, 0.971111>
    }
    triangle {
      < -4.094612, 0.410384, 1.021185>,
      < -4.065969, 0.355739, 0.971111>,
      < -4.093502, 0.355140, 1.012366>
    }
    triangle {
      < -4.067335, 0.423732, 0.981965>,
      < -3.551695, 0.442579, 0.956125>,
      < -3.550158, 0.366087, 0.943915>
    }
    triangle {
      < -4.067335, 0.423732, 0.981965>,
      < -3.550158, 0.366087, 0.943915>,
      < -4.065969, 0.355739, 0.971111>
    }
    triangle {
      < -3.551695, 0.442579, 0.956125>,
      < -3.518313, 0.498723, 0.786119>,
      < -3.515665, 0.366987, 0.765092>
    }
    triangle {
      < -3.551695, 0.442579, 0.956125>,
      < -3.515665, 0.366987, 0.765092>,
      < -3.550158, 0.366087, 0.943915>
    }
    triangle {
      < -3.518313, 0.498723, 0.786119>,
      < -3.910393, 0.495150, 0.772798>,
      < -3.907660, 0.359163, 0.751093>
    }
    triangle {
      < -3.518313, 0.498723, 0.786119>,
      < -3.907660, 0.359163, 0.751093>,
      < -3.515665, 0.366987, 0.765092>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.910393, 0.495150, 0.772798>,
      < -3.869323, 0.506640, 0.740127>,
      < -3.866377, 0.360029, 0.716725>
    }
    triangle {
      < -3.910393, 0.495150, 0.772798>,
      < -3.866377, 0.360029, 0.716725>,
      < -3.907660, 0.359163, 0.751093>
    }
    triangle {
      < -3.869323, 0.506640, 0.740127>,
      < -3.195777, 0.543581, 0.668608>,
      < -3.192360, 0.373598, 0.641476>
    }
    triangle {
      < -3.869323, 0.506640, 0.740127>,
      < -3.192360, 0.373598, 0.641476>,
      < -3.866377, 0.360029, 0.716725>
    }
    triangle {
      < -3.195777, 0.543581, 0.668608>,
      < -2.700768, 0.562016, 0.642755>,
      < -2.697182, 0.383533, 0.614266>
    }
    triangle {
      < -3.195777, 0.543581, 0.668608>,
      < -2.697182, 0.383533, 0.614266>,
      < -3.192360, 0.373598, 0.641476>
    }
    triangle {
      < -2.700768, 0.562016, 0.642755>,
      < -1.737952, 0.581271, 0.643349>,
      < -1.734366, 0.402790, 0.614860>
    }
    triangle {
      < -2.700768, 0.562016, 0.642755>,
      < -1.734366, 0.402790, 0.614860>,
      < -2.697182, 0.383533, 0.614266>
    }
    triangle {
      < -1.737952, 0.581271, 0.643349>,
      < -1.104975, 0.578995, 0.689515>,
      < -1.101686, 0.415386, 0.663399>
    }
    triangle {
      < -1.737952, 0.581271, 0.643349>,
      < -1.101686, 0.415386, 0.663399>,
      < -1.734366, 0.402790, 0.614860>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.104975, 0.578995, 0.689515>,
      < -0.843175, 0.558626, 0.768149>,
      < -0.840399, 0.420514, 0.746104>
    }
    triangle {
      < -1.104975, 0.578995, 0.689515>,
      < -0.840399, 0.420514, 0.746104>,
      < -1.101686, 0.415386, 0.663399>
    }
    triangle {
      < -0.843175, 0.558626, 0.768149>,
      < -0.856813, 0.551952, 0.787760>,
      < -0.854165, 0.420215, 0.766732>
    }
    triangle {
      < -0.843175, 0.558626, 0.768149>,
      < -0.854165, 0.420215, 0.766732>,
      < -0.840399, 0.420514, 0.746104>
    }
    triangle {
      < -0.856813, 0.551952, 0.787760>,
      < -1.104704, 0.564065, 0.735292>,
      < -1.101714, 0.415329, 0.711550>
    }
    triangle {
      < -0.856813, 0.551952, 0.787760>,
      < -1.101714, 0.415329, 0.711550>,
      < -0.854165, 0.420215, 0.766732>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.104704, 0.564065, 0.735292>,
      < -1.531094, 0.555537, 0.735029>,
      < -1.528104, 0.406801, 0.711287>
    }
    triangle {
      < -1.104704, 0.564065, 0.735292>,
      < -1.528104, 0.406801, 0.711287>,
      < -1.101714, 0.415329, 0.711550>
    }
    triangle {
      < -1.531094, 0.555537, 0.735029>,
      < -1.590827, 0.434854, 1.101201>,
      < -1.590228, 0.405107, 1.096452>
    }
    triangle {
      < -1.531094, 0.555537, 0.735029>,
      < -1.590228, 0.405107, 1.096452>,
      < -1.528104, 0.406801, 0.711287>
    }
    triangle {
      < -1.590827, 0.434854, 1.101201>,
      < -1.501423, 0.436642, 1.101255>,
      < -1.500824, 0.406895, 1.096508>
    }
    triangle {
      < -1.590827, 0.434854, 1.101201>,
      < -1.500824, 0.406895, 1.096508>,
      < -1.590228, 0.405107, 1.096452>
    }
    triangle {
      < -1.501423, 0.436642, 1.101255>,
      < -1.425464, 0.421092, 1.153618>,
      < -1.425208, 0.408342, 1.151583>
    }
    triangle {
      < -1.501423, 0.436642, 1.101255>,
      < -1.425208, 0.408342, 1.151583>,
      < -1.500824, 0.406895, 1.096508>
    }
    triangle {
      < -3.524888, 0.475665, 1.041438>,
      < -4.095624, 0.460200, 1.046646>,
      < -4.094612, 0.410384, 1.021185>
    }
    triangle {
      < -3.524888, 0.475665, 1.041438>,
      < -4.094612, 0.410384, 1.021185>,
      < -3.523838, 0.423933, 1.014997>
    }
    triangle {
      < -4.095624, 0.460200, 1.046646>,
      < -4.068580, 0.485044, 1.013301>,
      < -4.067335, 0.423732, 0.981965>
    }
    triangle {
      < -4.095624, 0.460200, 1.046646>,
      < -4.067335, 0.423732, 0.981965>,
      < -4.094612, 0.410384, 1.021185>
    }
    triangle {
      < -4.068580, 0.485044, 1.013301>,
      < -3.553096, 0.511555, 0.991379>,
      < -3.551695, 0.442579, 0.956125>
    }
    triangle {
      < -4.068580, 0.485044, 1.013301>,
      < -3.551695, 0.442579, 0.956125>,
      < -4.067335, 0.423732, 0.981965>
    }
    triangle {
      < -3.553096, 0.511555, 0.991379>,
      < -3.520726, 0.617515, 0.846835>,
      < -3.518313, 0.498723, 0.786119>
    }
    triangle {
      < -3.553096, 0.511555, 0.991379>,
      < -3.518313, 0.498723, 0.786119>,
      < -3.551695, 0.442579, 0.956125>
    }
    triangle {
      < -3.520726, 0.617515, 0.846835>,
      < -3.912885, 0.617773, 0.835474>,
      < -3.910393, 0.495150, 0.772798>
    }
    triangle {
      < -3.520726, 0.617515, 0.846835>,
      < -3.910393, 0.495150, 0.772798>,
      < -3.518313, 0.498723, 0.786119>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.912885, 0.617773, 0.835474>,
      < -3.872009, 0.638844, 0.807698>,
      < -3.869323, 0.506640, 0.740127>
    }
    triangle {
      < -3.912885, 0.617773, 0.835474>,
      < -3.869323, 0.506640, 0.740127>,
      < -3.910393, 0.495150, 0.772798>
    }
    triangle {
      < -3.872009, 0.638844, 0.807698>,
      < -3.198890, 0.696861, 0.746951>,
      < -3.195777, 0.543581, 0.668608>
    }
    triangle {
      < -3.872009, 0.638844, 0.807698>,
      < -3.195777, 0.543581, 0.668608>,
      < -3.869323, 0.506640, 0.740127>
    }
    triangle {
      < -3.198890, 0.696861, 0.746951>,
      < -2.704039, 0.722960, 0.725015>,
      < -2.700768, 0.562016, 0.642755>
    }
    triangle {
      < -3.198890, 0.696861, 0.746951>,
      < -2.700768, 0.562016, 0.642755>,
      < -3.195777, 0.543581, 0.668608>
    }
    triangle {
      < -2.704039, 0.722960, 0.725015>,
      < -1.741221, 0.742216, 0.725609>,
      < -1.737952, 0.581271, 0.643349>
    }
    triangle {
      < -2.704039, 0.722960, 0.725015>,
      < -1.737952, 0.581271, 0.643349>,
      < -2.700768, 0.562016, 0.642755>
    }
    triangle {
      < -1.741221, 0.742216, 0.725609>,
      < -1.107971, 0.726527, 0.764920>,
      < -1.104975, 0.578995, 0.689515>
    }
    triangle {
      < -1.741221, 0.742216, 0.725609>,
      < -1.104975, 0.578995, 0.689515>,
      < -1.737952, 0.581271, 0.643349>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.107971, 0.726527, 0.764920>,
      < -0.845704, 0.683166, 0.831803>,
      < -0.843175, 0.558626, 0.768149>
    }
    triangle {
      < -1.107971, 0.726527, 0.764920>,
      < -0.843175, 0.558626, 0.768149>,
      < -1.104975, 0.578995, 0.689515>
    }
    triangle {
      < -0.845704, 0.683166, 0.831803>,
      < -0.859227, 0.670744, 0.848476>,
      < -0.856813, 0.551952, 0.787760>
    }
    triangle {
      < -0.845704, 0.683166, 0.831803>,
      < -0.856813, 0.551952, 0.787760>,
      < -0.843175, 0.558626, 0.768149>
    }
    triangle {
      < -0.859227, 0.670744, 0.848476>,
      < -1.107428, 0.698184, 0.803842>,
      < -1.104704, 0.564065, 0.735292>
    }
    triangle {
      < -0.859227, 0.670744, 0.848476>,
      < -1.104704, 0.564065, 0.735292>,
      < -0.856813, 0.551952, 0.787760>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.107428, 0.698184, 0.803842>,
      < -1.533819, 0.689657, 0.803579>,
      < -1.531094, 0.555537, 0.735029>
    }
    triangle {
      < -1.107428, 0.698184, 0.803842>,
      < -1.531094, 0.555537, 0.735029>,
      < -1.104704, 0.564065, 0.735292>
    }
    triangle {
      < -1.533819, 0.689657, 0.803579>,
      < -1.591372, 0.461678, 1.114910>,
      < -1.590827, 0.434854, 1.101201>
    }
    triangle {
      < -1.533819, 0.689657, 0.803579>,
      < -1.590827, 0.434854, 1.101201>,
      < -1.531094, 0.555537, 0.735029>
    }
    triangle {
      < -1.591372, 0.461678, 1.114910>,
      < -1.501967, 0.463466, 1.114965>,
      < -1.501423, 0.436642, 1.101255>
    }
    triangle {
      < -1.591372, 0.461678, 1.114910>,
      < -1.501423, 0.436642, 1.101255>,
      < -1.590827, 0.434854, 1.101201>
    }
    triangle {
      < -1.501967, 0.463466, 1.114965>,
      < -1.425697, 0.432588, 1.159494>,
      < -1.425464, 0.421092, 1.153618>
    }
    triangle {
      < -1.501967, 0.463466, 1.114965>,
      < -1.425464, 0.421092, 1.153618>,
      < -1.501423, 0.436642, 1.101255>
    }
    triangle {
      < -3.525734, 0.516696, 1.082573>,
      < -4.096439, 0.499711, 1.086259>,
      < -4.095624, 0.460200, 1.046646>
    }
    triangle {
      < -3.525734, 0.516696, 1.082573>,
      < -4.095624, 0.460200, 1.046646>,
      < -3.524888, 0.475665, 1.041438>
    }
    triangle {
      < -4.096439, 0.499711, 1.086259>,
      < -4.069583, 0.533674, 1.062055>,
      < -4.068580, 0.485044, 1.013301>
    }
    triangle {
      < -4.096439, 0.499711, 1.086259>,
      < -4.068580, 0.485044, 1.013301>,
      < -4.095624, 0.460200, 1.046646>
    }
    triangle {
      < -4.069583, 0.533674, 1.062055>,
      < -3.554224, 0.566263, 1.046227>,
      < -3.553096, 0.511555, 0.991379>
    }
    triangle {
      < -4.069583, 0.533674, 1.062055>,
      < -3.553096, 0.511555, 0.991379>,
      < -4.068580, 0.485044, 1.013301>
    }
    triangle {
      < -3.554224, 0.566263, 1.046227>,
      < -3.522669, 0.711734, 0.941296>,
      < -3.520726, 0.617515, 0.846835>
    }
    triangle {
      < -3.554224, 0.566263, 1.046227>,
      < -3.520726, 0.617515, 0.846835>,
      < -3.553096, 0.511555, 0.991379>
    }
    triangle {
      < -3.522669, 0.711734, 0.941296>,
      < -3.914890, 0.715032, 0.932981>,
      < -3.912885, 0.617773, 0.835474>
    }
    triangle {
      < -3.522669, 0.711734, 0.941296>,
      < -3.912885, 0.617773, 0.835474>,
      < -3.520726, 0.617515, 0.846835>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.914890, 0.715032, 0.932981>,
      < -3.874171, 0.743701, 0.912823>,
      < -3.872009, 0.638844, 0.807698>
    }
    triangle {
      < -3.914890, 0.715032, 0.932981>,
      < -3.872009, 0.638844, 0.807698>,
      < -3.912885, 0.617773, 0.835474>
    }
    triangle {
      < -3.874171, 0.743701, 0.912823>,
      < -3.201397, 0.818434, 0.868835>,
      < -3.198890, 0.696861, 0.746951>
    }
    triangle {
      < -3.874171, 0.743701, 0.912823>,
      < -3.198890, 0.696861, 0.746951>,
      < -3.872009, 0.638844, 0.807698>
    }
    triangle {
      < -3.201397, 0.818434, 0.868835>,
      < -2.706670, 0.850612, 0.852994>,
      < -2.704039, 0.722960, 0.725015>
    }
    triangle {
      < -3.201397, 0.818434, 0.868835>,
      < -2.704039, 0.722960, 0.725015>,
      < -3.198890, 0.696861, 0.746951>
    }
    triangle {
      < -2.706670, 0.850612, 0.852994>,
      < -1.743854, 0.869867, 0.853587>,
      < -1.741221, 0.742216, 0.725609>
    }
    triangle {
      < -2.706670, 0.850612, 0.852994>,
      < -1.741221, 0.742216, 0.725609>,
      < -2.704039, 0.722960, 0.725015>
    }
    triangle {
      < -1.743854, 0.869867, 0.853587>,
      < -1.110385, 0.843541, 0.882234>,
      < -1.107971, 0.726527, 0.764920>
    }
    triangle {
      < -1.743854, 0.869867, 0.853587>,
      < -1.107971, 0.726527, 0.764920>,
      < -1.741221, 0.742216, 0.725609>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.110385, 0.843541, 0.882234>,
      < -0.847741, 0.781944, 0.930834>,
      < -0.845704, 0.683166, 0.831803>
    }
    triangle {
      < -1.110385, 0.843541, 0.882234>,
      < -0.845704, 0.683166, 0.831803>,
      < -1.107971, 0.726527, 0.764920>
    }
    triangle {
      < -0.847741, 0.781944, 0.930834>,
      < -0.861169, 0.764964, 0.942936>,
      < -0.859227, 0.670744, 0.848476>
    }
    triangle {
      < -0.847741, 0.781944, 0.930834>,
      < -0.859227, 0.670744, 0.848476>,
      < -0.845704, 0.683166, 0.831803>
    }
    triangle {
      < -0.861169, 0.764964, 0.942936>,
      < -1.109621, 0.804560, 0.910490>,
      < -1.107428, 0.698184, 0.803842>
    }
    triangle {
      < -0.861169, 0.764964, 0.942936>,
      < -1.107428, 0.698184, 0.803842>,
      < -0.859227, 0.670744, 0.848476>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.109621, 0.804560, 0.910490>,
      < -1.536012, 0.796033, 0.910227>,
      < -1.533819, 0.689657, 0.803579>
    }
    triangle {
      < -1.109621, 0.804560, 0.910490>,
      < -1.533819, 0.689657, 0.803579>,
      < -1.107428, 0.698184, 0.803842>
    }
    triangle {
      < -1.536012, 0.796033, 0.910227>,
      < -1.591810, 0.482953, 1.136240>,
      < -1.591372, 0.461678, 1.114910>
    }
    triangle {
      < -1.536012, 0.796033, 0.910227>,
      < -1.591372, 0.461678, 1.114910>,
      < -1.533819, 0.689657, 0.803579>
    }
    triangle {
      < -1.591810, 0.482953, 1.136240>,
      < -1.502405, 0.484742, 1.136295>,
      < -1.501967, 0.463466, 1.114965>
    }
    triangle {
      < -1.591810, 0.482953, 1.136240>,
      < -1.501967, 0.463466, 1.114965>,
      < -1.591372, 0.461678, 1.114910>
    }
    triangle {
      < -1.502405, 0.484742, 1.136295>,
      < -1.425884, 0.441705, 1.168635>,
      < -1.425697, 0.432588, 1.159494>
    }
    triangle {
      < -1.502405, 0.484742, 1.136295>,
      < -1.425697, 0.432588, 1.159494>,
      < -1.501967, 0.463466, 1.114965>
    }
    triangle {
      < -3.526292, 0.543009, 1.134378>,
      < -4.096976, 0.525050, 1.136144>,
      < -4.096439, 0.499711, 1.086259>
    }
    triangle {
      < -3.526292, 0.543009, 1.134378>,
      < -4.096439, 0.499711, 1.086259>,
      < -3.525734, 0.516696, 1.082573>
    }
    triangle {
      < -4.096976, 0.525050, 1.136144>,
      < -4.070245, 0.564859, 1.123453>,
      < -4.069583, 0.533674, 1.062055>
    }
    triangle {
      < -4.096976, 0.525050, 1.136144>,
      < -4.069583, 0.533674, 1.062055>,
      < -4.096439, 0.499711, 1.086259>
    }
    triangle {
      < -4.070245, 0.564859, 1.123453>,
      < -3.554968, 0.601348, 1.115299>,
      < -3.554224, 0.566263, 1.046227>
    }
    triangle {
      < -4.070245, 0.564859, 1.123453>,
      < -3.554224, 0.566263, 1.046227>,
      < -4.069583, 0.533674, 1.062055>
    }
    triangle {
      < -3.554968, 0.601348, 1.115299>,
      < -3.523950, 0.772158, 1.060255>,
      < -3.522669, 0.711734, 0.941296>
    }
    triangle {
      < -3.554968, 0.601348, 1.115299>,
      < -3.522669, 0.711734, 0.941296>,
      < -3.554224, 0.566263, 1.046227>
    }
    triangle {
      < -3.523950, 0.772158, 1.060255>,
      < -3.916212, 0.777404, 1.055777>,
      < -3.914890, 0.715032, 0.932981>
    }
    triangle {
      < -3.523950, 0.772158, 1.060255>,
      < -3.914890, 0.715032, 0.932981>,
      < -3.522669, 0.711734, 0.941296>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.916212, 0.777404, 1.055777>,
      < -3.875597, 0.810946, 1.045213>,
      < -3.874171, 0.743701, 0.912823>
    }
    triangle {
      < -3.916212, 0.777404, 1.055777>,
      < -3.874171, 0.743701, 0.912823>,
      < -3.914890, 0.715032, 0.932981>
    }
    triangle {
      < -3.875597, 0.810946, 1.045213>,
      < -3.203051, 0.896400, 1.022331>,
      < -3.201397, 0.818434, 0.868835>
    }
    triangle {
      < -3.875597, 0.810946, 1.045213>,
      < -3.201397, 0.818434, 0.868835>,
      < -3.874171, 0.743701, 0.912823>
    }
    triangle {
      < -3.203051, 0.896400, 1.022331>,
      < -2.708406, 0.932475, 1.014164>,
      < -2.706670, 0.850612, 0.852994>
    }
    triangle {
      < -3.203051, 0.896400, 1.022331>,
      < -2.706670, 0.850612, 0.852994>,
      < -3.201397, 0.818434, 0.868835>
    }
    triangle {
      < -2.708406, 0.932475, 1.014164>,
      < -1.745590, 0.951731, 1.014757>,
      < -1.743854, 0.869867, 0.853587>
    }
    triangle {
      < -2.708406, 0.932475, 1.014164>,
      < -1.743854, 0.869867, 0.853587>,
      < -2.706670, 0.850612, 0.852994>
    }
    triangle {
      < -1.745590, 0.951731, 1.014757>,
      < -1.111976, 0.918583, 1.029972>,
      < -1.110385, 0.843541, 0.882234>
    }
    triangle {
      < -1.745590, 0.951731, 1.014757>,
      < -1.110385, 0.843541, 0.882234>,
      < -1.743854, 0.869867, 0.853587>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.111976, 0.918583, 1.029972>,
      < -0.849084, 0.845291, 1.055549>,
      < -0.847741, 0.781944, 0.930834>
    }
    triangle {
      < -1.111976, 0.918583, 1.029972>,
      < -0.847741, 0.781944, 0.930834>,
      < -1.110385, 0.843541, 0.882234>
    }
    triangle {
      < -0.849084, 0.845291, 1.055549>,
      < -0.862450, 0.825386, 1.061894>,
      < -0.861169, 0.764964, 0.942936>
    }
    triangle {
      < -0.849084, 0.845291, 1.055549>,
      < -0.861169, 0.764964, 0.942936>,
      < -0.847741, 0.781944, 0.930834>
    }
    triangle {
      < -0.862450, 0.825386, 1.061894>,
      < -1.111069, 0.872780, 1.044798>,
      < -1.109621, 0.804560, 0.910490>
    }
    triangle {
      < -0.862450, 0.825386, 1.061894>,
      < -1.109621, 0.804560, 0.910490>,
      < -0.861169, 0.764964, 0.942936>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.111069, 0.872780, 1.044798>,
      < -1.537459, 0.864253, 1.044536>,
      < -1.536012, 0.796033, 0.910227>
    }
    triangle {
      < -1.111069, 0.872780, 1.044798>,
      < -1.536012, 0.796033, 0.910227>,
      < -1.109621, 0.804560, 0.910490>
    }
    triangle {
      < -1.537459, 0.864253, 1.044536>,
      < -1.592099, 0.496597, 1.163102>,
      < -1.591810, 0.482953, 1.136240>
    }
    triangle {
      < -1.537459, 0.864253, 1.044536>,
      < -1.591810, 0.482953, 1.136240>,
      < -1.536012, 0.796033, 0.910227>
    }
    triangle {
      < -1.592099, 0.496597, 1.163102>,
      < -1.502695, 0.498386, 1.163157>,
      < -1.502405, 0.484742, 1.136295>
    }
    triangle {
      < -1.592099, 0.496597, 1.163102>,
      < -1.502405, 0.484742, 1.136295>,
      < -1.591810, 0.482953, 1.136240>
    }
    triangle {
      < -1.502695, 0.498386, 1.163157>,
      < -1.426009, 0.447552, 1.180147>,
      < -1.425884, 0.441705, 1.168635>
    }
    triangle {
      < -1.502695, 0.498386, 1.163157>,
      < -1.425884, 0.441705, 1.168635>,
      < -1.502405, 0.484742, 1.136295>
    }
    triangle {
      < -3.526508, 0.552030, 1.191780>,
      < -4.097183, 0.533736, 1.191420>,
      < -4.096976, 0.525050, 1.136144>
    }
    triangle {
      < -3.526508, 0.552030, 1.191780>,
      < -4.096976, 0.525050, 1.136144>,
      < -3.526292, 0.543009, 1.134378>
    }
    triangle {
      < -4.097183, 0.533736, 1.191420>,
      < -4.070501, 0.575550, 1.191486>,
      < -4.070245, 0.564859, 1.123453>
    }
    triangle {
      < -4.097183, 0.533736, 1.191420>,
      < -4.070245, 0.564859, 1.123453>,
      < -4.096976, 0.525050, 1.136144>
    }
    triangle {
      < -4.070501, 0.575550, 1.191486>,
      < -3.555256, 0.613374, 1.191836>,
      < -3.554968, 0.601348, 1.115299>
    }
    triangle {
      < -4.070501, 0.575550, 1.191486>,
      < -3.554968, 0.601348, 1.115299>,
      < -4.070245, 0.564859, 1.123453>
    }
    triangle {
      < -3.555256, 0.613374, 1.191836>,
      < -3.524446, 0.792871, 1.192067>,
      < -3.523950, 0.772158, 1.060255>
    }
    triangle {
      < -3.555256, 0.613374, 1.191836>,
      < -3.523950, 0.772158, 1.060255>,
      < -3.554968, 0.601348, 1.115299>
    }
    triangle {
      < -3.524446, 0.792871, 1.192067>,
      < -3.916725, 0.798785, 1.191841>,
      < -3.916212, 0.777404, 1.055777>
    }
    triangle {
      < -3.524446, 0.792871, 1.192067>,
      < -3.916212, 0.777404, 1.055777>,
      < -3.523950, 0.772158, 1.060255>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.916725, 0.798785, 1.191841>,
      < -3.876148, 0.833997, 1.191907>,
      < -3.875597, 0.810946, 1.045213>
    }
    triangle {
      < -3.916725, 0.798785, 1.191841>,
      < -3.875597, 0.810946, 1.045213>,
      < -3.916212, 0.777404, 1.055777>
    }
    triangle {
      < -3.876148, 0.833997, 1.191907>,
      < -3.203690, 0.923126, 1.192411>,
      < -3.203051, 0.896400, 1.022331>
    }
    triangle {
      < -3.876148, 0.833997, 1.191907>,
      < -3.203051, 0.896400, 1.022331>,
      < -3.875597, 0.810946, 1.045213>
    }
    triangle {
      < -3.203690, 0.923126, 1.192411>,
      < -2.709078, 0.960538, 1.192749>,
      < -2.708406, 0.932475, 1.014164>
    }
    triangle {
      < -3.203690, 0.923126, 1.192411>,
      < -2.708406, 0.932475, 1.014164>,
      < -3.203051, 0.896400, 1.022331>
    }
    triangle {
      < -2.709078, 0.960538, 1.192749>,
      < -1.746262, 0.979794, 1.193343>,
      < -1.745590, 0.951731, 1.014757>
    }
    triangle {
      < -2.709078, 0.960538, 1.192749>,
      < -1.745590, 0.951731, 1.014757>,
      < -2.708406, 0.932475, 1.014164>
    }
    triangle {
      < -1.746262, 0.979794, 1.193343>,
      < -1.112591, 0.944307, 1.193675>,
      < -1.111976, 0.918583, 1.029972>
    }
    triangle {
      < -1.746262, 0.979794, 1.193343>,
      < -1.111976, 0.918583, 1.029972>,
      < -1.745590, 0.951731, 1.014757>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.112591, 0.944307, 1.193675>,
      < -0.849604, 0.867006, 1.193740>,
      < -0.849084, 0.845291, 1.055549>
    }
    triangle {
      < -1.112591, 0.944307, 1.193675>,
      < -0.849084, 0.845291, 1.055549>,
      < -1.111976, 0.918583, 1.029972>
    }
    triangle {
      < -0.849604, 0.867006, 1.193740>,
      < -0.862947, 0.846099, 1.193707>,
      < -0.862450, 0.825386, 1.061894>
    }
    triangle {
      < -0.849604, 0.867006, 1.193740>,
      < -0.862450, 0.825386, 1.061894>,
      < -0.849084, 0.845291, 1.055549>
    }
    triangle {
      < -0.862947, 0.846099, 1.193707>,
      < -1.111628, 0.896166, 1.193619>,
      < -1.111069, 0.872780, 1.044798>
    }
    triangle {
      < -0.862947, 0.846099, 1.193707>,
      < -1.111069, 0.872780, 1.044798>,
      < -0.862450, 0.825386, 1.061894>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.111628, 0.896166, 1.193619>,
      < -1.538019, 0.887639, 1.193357>,
      < -1.537459, 0.864253, 1.044536>
    }
    triangle {
      < -1.111628, 0.896166, 1.193619>,
      < -1.537459, 0.864253, 1.044536>,
      < -1.111069, 0.872780, 1.044798>
    }
    triangle {
      < -1.538019, 0.887639, 1.193357>,
      < -1.592212, 0.501275, 1.192866>,
      < -1.592099, 0.496597, 1.163102>
    }
    triangle {
      < -1.538019, 0.887639, 1.193357>,
      < -1.592099, 0.496597, 1.163102>,
      < -1.537459, 0.864253, 1.044536>
    }
    triangle {
      < -1.592212, 0.501275, 1.192866>,
      < -1.502807, 0.503062, 1.192921>,
      < -1.502695, 0.498386, 1.163157>
    }
    triangle {
      < -1.592212, 0.501275, 1.192866>,
      < -1.502695, 0.498386, 1.163157>,
      < -1.592099, 0.496597, 1.163102>
    }
    triangle {
      < -1.502807, 0.503062, 1.192921>,
      < -1.426057, 0.449557, 1.192903>,
      < -1.426009, 0.447552, 1.180147>
    }
    triangle {
      < -1.502807, 0.503062, 1.192921>,
      < -1.426009, 0.447552, 1.180147>,
      < -1.502695, 0.498386, 1.163157>
    }
    triangle {
      < -3.526360, 0.542874, 1.249161>,
      < -4.097042, 0.524919, 1.246676>,
      < -4.097183, 0.533736, 1.191420>
    }
    triangle {
      < -3.526360, 0.542874, 1.249161>,
      < -4.097183, 0.533736, 1.191420>,
      < -3.526508, 0.552030, 1.191780>
    }
    triangle {
      < -4.097042, 0.524919, 1.246676>,
      < -4.070325, 0.564698, 1.259492>,
      < -4.070501, 0.575550, 1.191486>
    }
    triangle {
      < -4.097042, 0.524919, 1.246676>,
      < -4.070501, 0.575550, 1.191486>,
      < -4.097183, 0.533736, 1.191420>
    }
    triangle {
      < -4.070325, 0.564698, 1.259492>,
      < -3.555059, 0.601166, 1.268343>,
      < -3.555256, 0.613374, 1.191836>
    }
    triangle {
      < -4.070325, 0.564698, 1.259492>,
      < -3.555256, 0.613374, 1.191836>,
      < -4.070501, 0.575550, 1.191486>
    }
    triangle {
      < -3.555059, 0.601166, 1.268343>,
      < -3.524106, 0.771845, 1.323830>,
      < -3.524446, 0.792871, 1.192067>
    }
    triangle {
      < -3.555059, 0.601166, 1.268343>,
      < -3.524446, 0.792871, 1.192067>,
      < -3.555256, 0.613374, 1.191836>
    }
    triangle {
      < -3.524106, 0.771845, 1.323830>,
      < -3.916373, 0.777081, 1.327855>,
      < -3.916725, 0.798785, 1.191841>
    }
    triangle {
      < -3.524106, 0.771845, 1.323830>,
      < -3.916725, 0.798785, 1.191841>,
      < -3.524446, 0.792871, 1.192067>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.916373, 0.777081, 1.327855>,
      < -3.875771, 0.810598, 1.338547>,
      < -3.876148, 0.833997, 1.191907>
    }
    triangle {
      < -3.916373, 0.777081, 1.327855>,
      < -3.876148, 0.833997, 1.191907>,
      < -3.916725, 0.798785, 1.191841>
    }
    triangle {
      < -3.875771, 0.810598, 1.338547>,
      < -3.203253, 0.895996, 1.362429>,
      < -3.203690, 0.923126, 1.192411>
    }
    triangle {
      < -3.875771, 0.810598, 1.338547>,
      < -3.203690, 0.923126, 1.192411>,
      < -3.876148, 0.833997, 1.191907>
    }
    triangle {
      < -3.203253, 0.895996, 1.362429>,
      < -2.708618, 0.932052, 1.371268>,
      < -2.709078, 0.960538, 1.192749>
    }
    triangle {
      < -3.203253, 0.895996, 1.362429>,
      < -2.709078, 0.960538, 1.192749>,
      < -3.203690, 0.923126, 1.192411>
    }
    triangle {
      < -2.708618, 0.932052, 1.371268>,
      < -1.745802, 0.951308, 1.371861>,
      < -1.746262, 0.979794, 1.193343>
    }
    triangle {
      < -2.708618, 0.932052, 1.371268>,
      < -1.746262, 0.979794, 1.193343>,
      < -2.709078, 0.960538, 1.192749>
    }
    triangle {
      < -1.745802, 0.951308, 1.371861>,
      < -1.112170, 0.918195, 1.357318>,
      < -1.112591, 0.944307, 1.193675>
    }
    triangle {
      < -1.745802, 0.951308, 1.371861>,
      < -1.112591, 0.944307, 1.193675>,
      < -1.746262, 0.979794, 1.193343>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.112170, 0.918195, 1.357318>,
      < -0.849248, 0.844963, 1.331879>,
      < -0.849604, 0.867006, 1.193740>
    }
    triangle {
      < -1.112170, 0.918195, 1.357318>,
      < -0.849604, 0.867006, 1.193740>,
      < -1.112591, 0.944307, 1.193675>
    }
    triangle {
      < -0.849248, 0.844963, 1.331879>,
      < -0.862606, 0.825074, 1.325471>,
      < -0.862947, 0.846099, 1.193707>
    }
    triangle {
      < -0.849248, 0.844963, 1.331879>,
      < -0.862947, 0.846099, 1.193707>,
      < -0.849604, 0.867006, 1.193740>
    }
    triangle {
      < -0.862606, 0.825074, 1.325471>,
      < -1.111245, 0.872428, 1.342385>,
      < -1.111628, 0.896166, 1.193619>
    }
    triangle {
      < -0.862606, 0.825074, 1.325471>,
      < -1.111628, 0.896166, 1.193619>,
      < -0.862947, 0.846099, 1.193707>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.111245, 0.872428, 1.342385>,
      < -1.537636, 0.863901, 1.342122>,
      < -1.538019, 0.887639, 1.193357>
    }
    triangle {
      < -1.111245, 0.872428, 1.342385>,
      < -1.538019, 0.887639, 1.193357>,
      < -1.111628, 0.896166, 1.193619>
    }
    triangle {
      < -1.537636, 0.863901, 1.342122>,
      < -1.592134, 0.496527, 1.222619>,
      < -1.592212, 0.501275, 1.192866>
    }
    triangle {
      < -1.537636, 0.863901, 1.342122>,
      < -1.592212, 0.501275, 1.192866>,
      < -1.538019, 0.887639, 1.193357>
    }
    triangle {
      < -1.592134, 0.496527, 1.222619>,
      < -1.502730, 0.498315, 1.222674>,
      < -1.502807, 0.503062, 1.192921>
    }
    triangle {
      < -1.592134, 0.496527, 1.222619>,
      < -1.502807, 0.503062, 1.192921>,
      < -1.592212, 0.501275, 1.192866>
    }
    triangle {
      < -1.502730, 0.498315, 1.222674>,
      < -1.426024, 0.447522, 1.205655>,
      < -1.426057, 0.449557, 1.192903>
    }
    triangle {
      < -1.502730, 0.498315, 1.222674>,
      < -1.426057, 0.449557, 1.192903>,
      < -1.502807, 0.503062, 1.192921>
    }
    triangle {
      < -3.525863, 0.516437, 1.300903>,
      < -4.096563, 0.499462, 1.296502>,
      < -4.097042, 0.524919, 1.246676>
    }
    triangle {
      < -3.525863, 0.516437, 1.300903>,
      < -4.097042, 0.524919, 1.246676>,
      < -3.526360, 0.542874, 1.249161>
    }
    triangle {
      < -4.096563, 0.499462, 1.296502>,
      < -4.069736, 0.533367, 1.320817>,
      < -4.070325, 0.564698, 1.259492>
    }
    triangle {
      < -4.096563, 0.499462, 1.296502>,
      < -4.070325, 0.564698, 1.259492>,
      < -4.097042, 0.524919, 1.246676>
    }
    triangle {
      < -4.069736, 0.533367, 1.320817>,
      < -3.554397, 0.565918, 1.337333>,
      < -3.555059, 0.601166, 1.268343>
    }
    triangle {
      < -4.069736, 0.533367, 1.320817>,
      < -3.555059, 0.601166, 1.268343>,
      < -4.070325, 0.564698, 1.259492>
    }
    triangle {
      < -3.554397, 0.565918, 1.337333>,
      < -3.522966, 0.711140, 1.442647>,
      < -3.524106, 0.771845, 1.323830>
    }
    triangle {
      < -3.554397, 0.565918, 1.337333>,
      < -3.524106, 0.771845, 1.323830>,
      < -3.555059, 0.601166, 1.268343>
    }
    triangle {
      < -3.522966, 0.711140, 1.442647>,
      < -3.915196, 0.714418, 1.450505>,
      < -3.916373, 0.777081, 1.327855>
    }
    triangle {
      < -3.522966, 0.711140, 1.442647>,
      < -3.916373, 0.777081, 1.327855>,
      < -3.524106, 0.771845, 1.323830>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.915196, 0.714418, 1.450505>,
      < -3.874502, 0.743039, 1.470778>,
      < -3.875771, 0.810598, 1.338547>
    }
    triangle {
      < -3.915196, 0.714418, 1.450505>,
      < -3.875771, 0.810598, 1.338547>,
      < -3.916373, 0.777081, 1.327855>
    }
    triangle {
      < -3.874502, 0.743039, 1.470778>,
      < -3.201780, 0.817668, 1.515740>,
      < -3.203253, 0.895996, 1.362429>
    }
    triangle {
      < -3.874502, 0.743039, 1.470778>,
      < -3.203253, 0.895996, 1.362429>,
      < -3.875771, 0.810598, 1.338547>
    }
    triangle {
      < -3.201780, 0.817668, 1.515740>,
      < -2.707072, 0.849807, 1.532245>,
      < -2.708618, 0.932052, 1.371268>
    }
    triangle {
      < -3.201780, 0.817668, 1.515740>,
      < -2.708618, 0.932052, 1.371268>,
      < -3.203253, 0.895996, 1.362429>
    }
    triangle {
      < -2.707072, 0.849807, 1.532245>,
      < -1.744256, 0.869062, 1.532838>,
      < -1.745802, 0.951308, 1.371861>
    }
    triangle {
      < -2.707072, 0.849807, 1.532245>,
      < -1.745802, 0.951308, 1.371861>,
      < -2.708618, 0.932052, 1.371268>
    }
    triangle {
      < -1.744256, 0.869062, 1.532838>,
      < -1.110754, 0.842803, 1.504880>,
      < -1.112170, 0.918195, 1.357318>
    }
    triangle {
      < -1.744256, 0.869062, 1.532838>,
      < -1.112170, 0.918195, 1.357318>,
      < -1.745802, 0.951308, 1.371861>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.110754, 0.842803, 1.504880>,
      < -0.848052, 0.781322, 1.456445>,
      < -0.849248, 0.844963, 1.331879>
    }
    triangle {
      < -1.110754, 0.842803, 1.504880>,
      < -0.849248, 0.844963, 1.331879>,
      < -1.112170, 0.918195, 1.357318>
    }
    triangle {
      < -0.848052, 0.781322, 1.456445>,
      < -0.861466, 0.764370, 1.444287>,
      < -0.862606, 0.825074, 1.325471>
    }
    triangle {
      < -0.848052, 0.781322, 1.456445>,
      < -0.862606, 0.825074, 1.325471>,
      < -0.849248, 0.844963, 1.331879>
    }
    triangle {
      < -0.861466, 0.764370, 1.444287>,
      < -1.109957, 0.803890, 1.476532>,
      < -1.111245, 0.872428, 1.342385>
    }
    triangle {
      < -0.861466, 0.764370, 1.444287>,
      < -1.111245, 0.872428, 1.342385>,
      < -0.862606, 0.825074, 1.325471>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.109957, 0.803890, 1.476532>,
      < -1.536347, 0.795363, 1.476269>,
      < -1.537636, 0.863901, 1.342122>
    }
    triangle {
      < -1.109957, 0.803890, 1.476532>,
      < -1.537636, 0.863901, 1.342122>,
      < -1.111245, 0.872428, 1.342385>
    }
    triangle {
      < -1.536347, 0.795363, 1.476269>,
      < -1.591877, 0.482819, 1.249448>,
      < -1.592134, 0.496527, 1.222619>
    }
    triangle {
      < -1.536347, 0.795363, 1.476269>,
      < -1.592134, 0.496527, 1.222619>,
      < -1.537636, 0.863901, 1.342122>
    }
    triangle {
      < -1.591877, 0.482819, 1.249448>,
      < -1.502472, 0.484606, 1.249503>,
      < -1.502730, 0.498315, 1.222674>
    }
    triangle {
      < -1.591877, 0.482819, 1.249448>,
      < -1.502730, 0.498315, 1.222674>,
      < -1.592134, 0.496527, 1.222619>
    }
    triangle {
      < -1.502472, 0.484606, 1.249503>,
      < -1.425913, 0.441647, 1.217153>,
      < -1.426024, 0.447522, 1.205655>
    }
    triangle {
      < -1.502472, 0.484606, 1.249503>,
      < -1.426024, 0.447522, 1.205655>,
      < -1.502730, 0.498315, 1.222674>
    }
    triangle {
      < -3.525066, 0.475309, 1.341943>,
      < -4.095795, 0.459857, 1.336021>,
      < -4.096563, 0.499462, 1.296502>
    }
    triangle {
      < -3.525066, 0.475309, 1.341943>,
      < -4.096563, 0.499462, 1.296502>,
      < -3.525863, 0.516437, 1.300903>
    }
    triangle {
      < -4.095795, 0.459857, 1.336021>,
      < -4.068791, 0.484622, 1.369457>,
      < -4.069736, 0.533367, 1.320817>
    }
    triangle {
      < -4.095795, 0.459857, 1.336021>,
      < -4.069736, 0.533367, 1.320817>,
      < -4.096563, 0.499462, 1.296502>
    }
    triangle {
      < -4.068791, 0.484622, 1.369457>,
      < -3.553333, 0.511081, 1.392054>,
      < -3.554397, 0.565918, 1.337333>
    }
    triangle {
      < -4.068791, 0.484622, 1.369457>,
      < -3.554397, 0.565918, 1.337333>,
      < -4.069736, 0.533367, 1.320817>
    }
    triangle {
      < -3.553333, 0.511081, 1.392054>,
      < -3.521135, 0.616698, 1.536885>,
      < -3.522966, 0.711140, 1.442647>
    }
    triangle {
      < -3.553333, 0.511081, 1.392054>,
      < -3.522966, 0.711140, 1.442647>,
      < -3.554397, 0.565918, 1.337333>
    }
    triangle {
      < -3.521135, 0.616698, 1.536885>,
      < -3.913307, 0.616929, 1.547784>,
      < -3.915196, 0.714418, 1.450505>
    }
    triangle {
      < -3.521135, 0.616698, 1.536885>,
      < -3.915196, 0.714418, 1.450505>,
      < -3.522966, 0.711140, 1.442647>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.913307, 0.616929, 1.547784>,
      < -3.872464, 0.637934, 1.575657>,
      < -3.874502, 0.743039, 1.470778>
    }
    triangle {
      < -3.913307, 0.616929, 1.547784>,
      < -3.874502, 0.743039, 1.470778>,
      < -3.915196, 0.714418, 1.450505>
    }
    triangle {
      < -3.872464, 0.637934, 1.575657>,
      < -3.199418, 0.695805, 1.637339>,
      < -3.201780, 0.817668, 1.515740>
    }
    triangle {
      < -3.872464, 0.637934, 1.575657>,
      < -3.201780, 0.817668, 1.515740>,
      < -3.874502, 0.743039, 1.470778>
    }
    triangle {
      < -3.199418, 0.695805, 1.637339>,
      < -2.704592, 0.721852, 1.659923>,
      < -2.707072, 0.849807, 1.532245>
    }
    triangle {
      < -3.199418, 0.695805, 1.637339>,
      < -2.707072, 0.849807, 1.532245>,
      < -3.201780, 0.817668, 1.515740>
    }
    triangle {
      < -2.704592, 0.721852, 1.659923>,
      < -1.741776, 0.741108, 1.660516>,
      < -1.744256, 0.869062, 1.532838>
    }
    triangle {
      < -2.704592, 0.721852, 1.659923>,
      < -1.744256, 0.869062, 1.532838>,
      < -2.707072, 0.849807, 1.532245>
    }
    triangle {
      < -1.741776, 0.741108, 1.660516>,
      < -1.108479, 0.725511, 1.621919>,
      < -1.110754, 0.842803, 1.504880>
    }
    triangle {
      < -1.741776, 0.741108, 1.660516>,
      < -1.110754, 0.842803, 1.504880>,
      < -1.744256, 0.869062, 1.532838>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.108479, 0.725511, 1.621919>,
      < -0.846133, 0.682308, 1.555244>,
      < -0.848052, 0.781322, 1.456445>
    }
    triangle {
      < -1.108479, 0.725511, 1.621919>,
      < -0.848052, 0.781322, 1.456445>,
      < -1.110754, 0.842803, 1.504880>
    }
    triangle {
      < -0.846133, 0.682308, 1.555244>,
      < -0.859636, 0.669926, 1.538526>,
      < -0.861466, 0.764370, 1.444287>
    }
    triangle {
      < -0.846133, 0.682308, 1.555244>,
      < -0.861466, 0.764370, 1.444287>,
      < -0.848052, 0.781322, 1.456445>
    }
    triangle {
      < -0.859636, 0.669926, 1.538526>,
      < -1.107890, 0.697260, 1.582931>,
      < -1.109957, 0.803890, 1.476532>
    }
    triangle {
      < -0.859636, 0.669926, 1.538526>,
      < -1.109957, 0.803890, 1.476532>,
      < -0.861466, 0.764370, 1.444287>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.107890, 0.697260, 1.582931>,
      < -1.534281, 0.688734, 1.582668>,
      < -1.536347, 0.795363, 1.476269>
    }
    triangle {
      < -1.107890, 0.697260, 1.582931>,
      < -1.536347, 0.795363, 1.476269>,
      < -1.109957, 0.803890, 1.476532>
    }
    triangle {
      < -1.534281, 0.688734, 1.582668>,
      < -1.591464, 0.461494, 1.270729>,
      < -1.591877, 0.482819, 1.249448>
    }
    triangle {
      < -1.534281, 0.688734, 1.582668>,
      < -1.591877, 0.482819, 1.249448>,
      < -1.536347, 0.795363, 1.476269>
    }
    triangle {
      < -1.591464, 0.461494, 1.270729>,
      < -1.502060, 0.463281, 1.270784>,
      < -1.502472, 0.484606, 1.249503>
    }
    triangle {
      < -1.591464, 0.461494, 1.270729>,
      < -1.502472, 0.484606, 1.249503>,
      < -1.591877, 0.482819, 1.249448>
    }
    triangle {
      < -1.502060, 0.463281, 1.270784>,
      < -1.425737, 0.432508, 1.226273>,
      < -1.425913, 0.441647, 1.217153>
    }
    triangle {
      < -1.502060, 0.463281, 1.270784>,
      < -1.425913, 0.441647, 1.217153>,
      < -1.502472, 0.484606, 1.249503>
    }
    triangle {
      < -3.524047, 0.423515, 1.368262>,
      < -4.094814, 0.409981, 1.361366>,
      < -4.095795, 0.459857, 1.336021>
    }
    triangle {
      < -3.524047, 0.423515, 1.368262>,
      < -4.095795, 0.459857, 1.336021>,
      < -3.525066, 0.475309, 1.341943>
    }
    triangle {
      < -4.094814, 0.409981, 1.361366>,
      < -4.067583, 0.423236, 1.400650>,
      < -4.068791, 0.484622, 1.369457>
    }
    triangle {
      < -4.094814, 0.409981, 1.361366>,
      < -4.068791, 0.484622, 1.369457>,
      < -4.095795, 0.459857, 1.336021>
    }
    triangle {
      < -4.067583, 0.423236, 1.400650>,
      < -3.551974, 0.442021, 1.427146>,
      < -3.553333, 0.511081, 1.392054>
    }
    triangle {
      < -4.067583, 0.423236, 1.400650>,
      < -3.553333, 0.511081, 1.392054>,
      < -4.068791, 0.484622, 1.369457>
    }
    triangle {
      < -3.551974, 0.442021, 1.427146>,
      < -3.518794, 0.497762, 1.597322>,
      < -3.521135, 0.616698, 1.536885>
    }
    triangle {
      < -3.551974, 0.442021, 1.427146>,
      < -3.521135, 0.616698, 1.536885>,
      < -3.553333, 0.511081, 1.392054>
    }
    triangle {
      < -3.518794, 0.497762, 1.597322>,
      < -3.910889, 0.494157, 1.610170>,
      < -3.913307, 0.616929, 1.547784>
    }
    triangle {
      < -3.518794, 0.497762, 1.597322>,
      < -3.913307, 0.616929, 1.547784>,
      < -3.521135, 0.616698, 1.536885>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.910889, 0.494157, 1.610170>,
      < -3.869858, 0.505570, 1.642918>,
      < -3.872464, 0.637934, 1.575657>
    }
    triangle {
      < -3.910889, 0.494157, 1.610170>,
      < -3.872464, 0.637934, 1.575657>,
      < -3.913307, 0.616929, 1.547784>
    }
    triangle {
      < -3.869858, 0.505570, 1.642918>,
      < -3.196397, 0.542340, 1.715322>,
      < -3.199418, 0.695805, 1.637339>
    }
    triangle {
      < -3.869858, 0.505570, 1.642918>,
      < -3.199418, 0.695805, 1.637339>,
      < -3.872464, 0.637934, 1.575657>
    }
    triangle {
      < -3.196397, 0.542340, 1.715322>,
      < -2.701420, 0.560713, 1.741805>,
      < -2.704592, 0.721852, 1.659923>
    }
    triangle {
      < -3.196397, 0.542340, 1.715322>,
      < -2.704592, 0.721852, 1.659923>,
      < -3.199418, 0.695805, 1.637339>
    }
    triangle {
      < -2.701420, 0.560713, 1.741805>,
      < -1.738603, 0.579969, 1.742398>,
      < -1.741776, 0.741108, 1.660516>
    }
    triangle {
      < -2.701420, 0.560713, 1.741805>,
      < -1.741776, 0.741108, 1.660516>,
      < -2.704592, 0.721852, 1.659923>
    }
    triangle {
      < -1.738603, 0.579969, 1.742398>,
      < -1.105572, 0.577801, 1.696977>,
      < -1.108479, 0.725511, 1.621919>
    }
    triangle {
      < -1.738603, 0.579969, 1.742398>,
      < -1.108479, 0.725511, 1.621919>,
      < -1.741776, 0.741108, 1.660516>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.105572, 0.577801, 1.696977>,
      < -0.843678, 0.557618, 1.618605>,
      < -0.846133, 0.682308, 1.555244>
    }
    triangle {
      < -1.105572, 0.577801, 1.696977>,
      < -0.846133, 0.682308, 1.555244>,
      < -1.108479, 0.725511, 1.621919>
    }
    triangle {
      < -0.843678, 0.557618, 1.618605>,
      < -0.857294, 0.550991, 1.598963>,
      < -0.859636, 0.669926, 1.538526>
    }
    triangle {
      < -0.843678, 0.557618, 1.618605>,
      < -0.859636, 0.669926, 1.538526>,
      < -0.846133, 0.682308, 1.555244>
    }
    triangle {
      < -0.857294, 0.550991, 1.598963>,
      < -1.105246, 0.562979, 1.651166>,
      < -1.107890, 0.697260, 1.582931>
    }
    triangle {
      < -0.857294, 0.550991, 1.598963>,
      < -1.107890, 0.697260, 1.582931>,
      < -0.859636, 0.669926, 1.538526>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.105246, 0.562979, 1.651166>,
      < -1.531637, 0.554451, 1.650903>,
      < -1.534281, 0.688734, 1.582668>
    }
    triangle {
      < -1.105246, 0.562979, 1.651166>,
      < -1.534281, 0.688734, 1.582668>,
      < -1.107890, 0.697260, 1.582931>
    }
    triangle {
      < -1.531637, 0.554451, 1.650903>,
      < -1.590936, 0.434637, 1.284375>,
      < -1.591464, 0.461494, 1.270729>
    }
    triangle {
      < -1.531637, 0.554451, 1.650903>,
      < -1.591464, 0.461494, 1.270729>,
      < -1.534281, 0.688734, 1.582668>
    }
    triangle {
      < -1.590936, 0.434637, 1.284375>,
      < -1.501531, 0.436425, 1.284430>,
      < -1.502060, 0.463281, 1.270784>
    }
    triangle {
      < -1.590936, 0.434637, 1.284375>,
      < -1.502060, 0.463281, 1.270784>,
      < -1.591464, 0.461494, 1.270729>
    }
    triangle {
      < -1.501531, 0.436425, 1.284430>,
      < -1.425510, 0.420998, 1.232122>,
      < -1.425737, 0.432508, 1.226273>
    }
    triangle {
      < -1.501531, 0.436425, 1.284430>,
      < -1.425737, 0.432508, 1.226273>,
      < -1.502060, 0.463281, 1.270784>
    }
    triangle {
      < -3.522905, 0.366123, 1.377285>,
      < -4.093713, 0.354716, 1.370055>,
      < -4.094814, 0.409981, 1.361366>
    }
    triangle {
      < -3.522905, 0.366123, 1.377285>,
      < -4.094814, 0.409981, 1.361366>,
      < -3.524047, 0.423515, 1.368262>
    }
    triangle {
      < -4.093713, 0.354716, 1.370055>,
      < -4.066229, 0.355217, 1.411343>,
      < -4.067583, 0.423236, 1.400650>
    }
    triangle {
      < -4.093713, 0.354716, 1.370055>,
      < -4.067583, 0.423236, 1.400650>,
      < -4.094814, 0.409981, 1.361366>
    }
    triangle {
      < -4.066229, 0.355217, 1.411343>,
      < -3.550451, 0.365501, 1.439176>,
      < -3.551974, 0.442021, 1.427146>
    }
    triangle {
      < -4.066229, 0.355217, 1.411343>,
      < -3.551974, 0.442021, 1.427146>,
      < -4.067583, 0.423236, 1.400650>
    }
    triangle {
      < -3.550451, 0.365501, 1.439176>,
      < -3.516171, 0.365976, 1.618041>,
      < -3.518794, 0.497762, 1.597322>
    }
    triangle {
      < -3.550451, 0.365501, 1.439176>,
      < -3.518794, 0.497762, 1.597322>,
      < -3.551974, 0.442021, 1.427146>
    }
    triangle {
      < -3.516171, 0.365976, 1.618041>,
      < -3.908181, 0.358120, 1.631557>,
      < -3.910889, 0.494157, 1.610170>
    }
    triangle {
      < -3.516171, 0.365976, 1.618041>,
      < -3.910889, 0.494157, 1.610170>,
      < -3.518794, 0.497762, 1.597322>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.908181, 0.358120, 1.631557>,
      < -3.866939, 0.358904, 1.665975>,
      < -3.869858, 0.505570, 1.642918>
    }
    triangle {
      < -3.908181, 0.358120, 1.631557>,
      < -3.869858, 0.505570, 1.642918>,
      < -3.910889, 0.494157, 1.610170>
    }
    triangle {
      < -3.866939, 0.358904, 1.665975>,
      < -3.193012, 0.372294, 1.742055>,
      < -3.196397, 0.542340, 1.715322>
    }
    triangle {
      < -3.866939, 0.358904, 1.665975>,
      < -3.196397, 0.542340, 1.715322>,
      < -3.869858, 0.505570, 1.642918>
    }
    triangle {
      < -3.193012, 0.372294, 1.742055>,
      < -2.697866, 0.382163, 1.769876>,
      < -2.701420, 0.560713, 1.741805>
    }
    triangle {
      < -3.193012, 0.372294, 1.742055>,
      < -2.701420, 0.560713, 1.741805>,
      < -3.196397, 0.542340, 1.715322>
    }
    triangle {
      < -2.697866, 0.382163, 1.769876>,
      < -1.735051, 0.401420, 1.770469>,
      < -1.738603, 0.579969, 1.742398>
    }
    triangle {
      < -2.697866, 0.382163, 1.769876>,
      < -1.738603, 0.579969, 1.742398>,
      < -2.701420, 0.560713, 1.741805>
    }
    triangle {
      < -1.735051, 0.401420, 1.770469>,
      < -1.102314, 0.414131, 1.722709>,
      < -1.105572, 0.577801, 1.696977>
    }
    triangle {
      < -1.735051, 0.401420, 1.770469>,
      < -1.105572, 0.577801, 1.696977>,
      < -1.738603, 0.579969, 1.742398>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.102314, 0.414131, 1.722709>,
      < -0.840929, 0.419455, 1.640326>,
      < -0.843678, 0.557618, 1.618605>
    }
    triangle {
      < -1.102314, 0.414131, 1.722709>,
      < -0.843678, 0.557618, 1.618605>,
      < -1.105572, 0.577801, 1.696977>
    }
    triangle {
      < -0.840929, 0.419455, 1.640326>,
      < -0.854671, 0.419204, 1.619682>,
      < -0.857294, 0.550991, 1.598963>
    }
    triangle {
      < -0.840929, 0.419455, 1.640326>,
      < -0.857294, 0.550991, 1.598963>,
      < -0.843678, 0.557618, 1.618605>
    }
    triangle {
      < -0.854671, 0.419204, 1.619682>,
      < -1.102285, 0.414187, 1.674558>,
      < -1.105246, 0.562979, 1.651166>
    }
    triangle {
      < -0.854671, 0.419204, 1.619682>,
      < -1.105246, 0.562979, 1.651166>,
      < -0.857294, 0.550991, 1.598963>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.102285, 0.414187, 1.674558>,
      < -1.528675, 0.405660, 1.674296>,
      < -1.531637, 0.554451, 1.650903>
    }
    triangle {
      < -1.102285, 0.414187, 1.674558>,
      < -1.531637, 0.554451, 1.650903>,
      < -1.105246, 0.562979, 1.651166>
    }
    triangle {
      < -1.528675, 0.405660, 1.674296>,
      < -1.590343, 0.404879, 1.289054>,
      < -1.590936, 0.434637, 1.284375>
    }
    triangle {
      < -1.528675, 0.405660, 1.674296>,
      < -1.590936, 0.434637, 1.284375>,
      < -1.531637, 0.554451, 1.650903>
    }
    triangle {
      < -1.590343, 0.404879, 1.289054>,
      < -1.500938, 0.406667, 1.289110>,
      < -1.501531, 0.436425, 1.284430>
    }
    triangle {
      < -1.590343, 0.404879, 1.289054>,
      < -1.501531, 0.436425, 1.284430>,
      < -1.590936, 0.434637, 1.284375>
    }
    triangle {
      < -1.500938, 0.406667, 1.289110>,
      < -1.425257, 0.408245, 1.234127>,
      < -1.425510, 0.420998, 1.232122>
    }
    triangle {
      < -1.500938, 0.406667, 1.289110>,
      < -1.425510, 0.420998, 1.232122>,
      < -1.501531, 0.436425, 1.284430>
    }
    triangle {
      < -3.521752, 0.308754, 1.368127>,
      < -4.092603, 0.299471, 1.361236>,
      < -4.093713, 0.354716, 1.370055>
    }
    triangle {
      < -3.521752, 0.308754, 1.368127>,
      < -4.093713, 0.354716, 1.370055>,
      < -3.522905, 0.366123, 1.377285>
    }
    triangle {
      < -4.092603, 0.299471, 1.361236>,
      < -4.064864, 0.287224, 1.400491>,
      < -4.066229, 0.355217, 1.411343>
    }
    triangle {
      < -4.092603, 0.299471, 1.361236>,
      < -4.066229, 0.355217, 1.411343>,
      < -4.093713, 0.354716, 1.370055>
    }
    triangle {
      < -4.064864, 0.287224, 1.400491>,
      < -3.548914, 0.289007, 1.426966>,
      < -3.550451, 0.365501, 1.439176>
    }
    triangle {
      < -4.064864, 0.287224, 1.400491>,
      < -3.550451, 0.365501, 1.439176>,
      < -4.066229, 0.355217, 1.411343>
    }
    triangle {
      < -3.548914, 0.289007, 1.426966>,
      < -3.513523, 0.234239, 1.597013>,
      < -3.516171, 0.365976, 1.618041>
    }
    triangle {
      < -3.548914, 0.289007, 1.426966>,
      < -3.516171, 0.365976, 1.618041>,
      < -3.550451, 0.365501, 1.439176>
    }
    triangle {
      < -3.513523, 0.234239, 1.597013>,
      < -3.905449, 0.222133, 1.609851>,
      < -3.908181, 0.358120, 1.631557>
    }
    triangle {
      < -3.513523, 0.234239, 1.597013>,
      < -3.908181, 0.358120, 1.631557>,
      < -3.516171, 0.365976, 1.618041>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.905449, 0.222133, 1.609851>,
      < -3.863993, 0.212294, 1.642574>,
      < -3.866939, 0.358904, 1.665975>
    }
    triangle {
      < -3.905449, 0.222133, 1.609851>,
      < -3.866939, 0.358904, 1.665975>,
      < -3.908181, 0.358120, 1.631557>
    }
    triangle {
      < -3.863993, 0.212294, 1.642574>,
      < -3.189596, 0.202310, 1.714923>,
      < -3.193012, 0.372294, 1.742055>
    }
    triangle {
      < -3.863993, 0.212294, 1.642574>,
      < -3.193012, 0.372294, 1.742055>,
      < -3.866939, 0.358904, 1.665975>
    }
    triangle {
      < -3.189596, 0.202310, 1.714923>,
      < -2.694279, 0.203682, 1.741386>,
      < -2.697866, 0.382163, 1.769876>
    }
    triangle {
      < -3.189596, 0.202310, 1.714923>,
      < -2.697866, 0.382163, 1.769876>,
      < -3.193012, 0.372294, 1.742055>
    }
    triangle {
      < -2.694279, 0.203682, 1.741386>,
      < -1.731463, 0.222937, 1.741979>,
      < -1.735051, 0.401420, 1.770469>
    }
    triangle {
      < -2.694279, 0.203682, 1.741386>,
      < -1.735051, 0.401420, 1.770469>,
      < -2.697866, 0.382163, 1.769876>
    }
    triangle {
      < -1.731463, 0.222937, 1.741979>,
      < -1.099026, 0.250522, 1.696593>,
      < -1.102314, 0.414131, 1.722709>
    }
    triangle {
      < -1.731463, 0.222937, 1.741979>,
      < -1.102314, 0.414131, 1.722709>,
      < -1.735051, 0.401420, 1.770469>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.099026, 0.250522, 1.696593>,
      < -0.838153, 0.281344, 1.618281>,
      < -0.840929, 0.419455, 1.640326>
    }
    triangle {
      < -1.099026, 0.250522, 1.696593>,
      < -0.840929, 0.419455, 1.640326>,
      < -1.102314, 0.414131, 1.722709>
    }
    triangle {
      < -0.838153, 0.281344, 1.618281>,
      < -0.852023, 0.287467, 1.598654>,
      < -0.854671, 0.419204, 1.619682>
    }
    triangle {
      < -0.838153, 0.281344, 1.618281>,
      < -0.854671, 0.419204, 1.619682>,
      < -0.840929, 0.419455, 1.640326>
    }
    triangle {
      < -0.852023, 0.287467, 1.598654>,
      < -1.099296, 0.265453, 1.650818>,
      < -1.102285, 0.414187, 1.674558>
    }
    triangle {
      < -0.852023, 0.287467, 1.598654>,
      < -1.102285, 0.414187, 1.674558>,
      < -0.854671, 0.419204, 1.619682>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.099296, 0.265453, 1.650818>,
      < -1.525687, 0.256925, 1.650554>,
      < -1.528675, 0.405660, 1.674296>
    }
    triangle {
      < -1.099296, 0.265453, 1.650818>,
      < -1.528675, 0.405660, 1.674296>,
      < -1.102285, 0.414187, 1.674558>
    }
    triangle {
      < -1.525687, 0.256925, 1.650554>,
      < -1.589745, 0.375132, 1.284306>,
      < -1.590343, 0.404879, 1.289054>
    }
    triangle {
      < -1.525687, 0.256925, 1.650554>,
      < -1.590343, 0.404879, 1.289054>,
      < -1.528675, 0.405660, 1.674296>
    }
    triangle {
      < -1.589745, 0.375132, 1.284306>,
      < -1.500340, 0.376920, 1.284361>,
      < -1.500938, 0.406667, 1.289110>
    }
    triangle {
      < -1.589745, 0.375132, 1.284306>,
      < -1.500938, 0.406667, 1.289110>,
      < -1.590343, 0.404879, 1.289054>
    }
    triangle {
      < -1.500340, 0.376920, 1.284361>,
      < -1.425000, 0.395496, 1.232092>,
      < -1.425257, 0.408245, 1.234127>
    }
    triangle {
      < -1.500340, 0.376920, 1.284361>,
      < -1.425257, 0.408245, 1.234127>,
      < -1.500938, 0.406667, 1.289110>
    }
    triangle {
      < -3.520702, 0.257022, 1.341687>,
      < -4.091591, 0.249656, 1.335775>,
      < -4.092603, 0.299471, 1.361236>
    }
    triangle {
      < -3.520702, 0.257022, 1.341687>,
      < -4.092603, 0.299471, 1.361236>,
      < -3.521752, 0.308754, 1.368127>
    }
    triangle {
      < -4.091591, 0.249656, 1.335775>,
      < -4.063617, 0.225912, 1.369153>,
      < -4.064864, 0.287224, 1.400491>
    }
    triangle {
      < -4.091591, 0.249656, 1.335775>,
      < -4.064864, 0.287224, 1.400491>,
      < -4.092603, 0.299471, 1.361236>
    }
    triangle {
      < -4.063617, 0.225912, 1.369153>,
      < -3.547514, 0.220032, 1.391712>,
      < -3.548914, 0.289007, 1.426966>
    }
    triangle {
      < -4.063617, 0.225912, 1.369153>,
      < -3.548914, 0.289007, 1.426966>,
      < -4.064864, 0.287224, 1.400491>
    }
    triangle {
      < -3.547514, 0.220032, 1.391712>,
      < -3.511110, 0.115447, 1.536297>,
      < -3.513523, 0.234239, 1.597013>
    }
    triangle {
      < -3.547514, 0.220032, 1.391712>,
      < -3.513523, 0.234239, 1.597013>,
      < -3.548914, 0.289007, 1.426966>
    }
    triangle {
      < -3.511110, 0.115447, 1.536297>,
      < -3.902958, 0.099509, 1.547177>,
      < -3.905449, 0.222133, 1.609851>
    }
    triangle {
      < -3.511110, 0.115447, 1.536297>,
      < -3.905449, 0.222133, 1.609851>,
      < -3.513523, 0.234239, 1.597013>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.902958, 0.099509, 1.547177>,
      < -3.861307, 0.080089, 1.575003>,
      < -3.863993, 0.212294, 1.642574>
    }
    triangle {
      < -3.902958, 0.099509, 1.547177>,
      < -3.863993, 0.212294, 1.642574>,
      < -3.905449, 0.222133, 1.609851>
    }
    triangle {
      < -3.861307, 0.080089, 1.575003>,
      < -3.186482, 0.049031, 1.636581>,
      < -3.189596, 0.202310, 1.714923>
    }
    triangle {
      < -3.861307, 0.080089, 1.575003>,
      < -3.189596, 0.202310, 1.714923>,
      < -3.863993, 0.212294, 1.642574>
    }
    triangle {
      < -3.186482, 0.049031, 1.636581>,
      < -2.691010, 0.042738, 1.659126>,
      < -2.694279, 0.203682, 1.741386>
    }
    triangle {
      < -3.186482, 0.049031, 1.636581>,
      < -2.694279, 0.203682, 1.741386>,
      < -3.189596, 0.202310, 1.714923>
    }
    triangle {
      < -2.691010, 0.042738, 1.659126>,
      < -1.728194, 0.061993, 1.659719>,
      < -1.731463, 0.222937, 1.741979>
    }
    triangle {
      < -2.691010, 0.042738, 1.659126>,
      < -1.731463, 0.222937, 1.741979>,
      < -2.694279, 0.203682, 1.741386>
    }
    triangle {
      < -1.728194, 0.061993, 1.659719>,
      < -1.096029, 0.102989, 1.621189>,
      < -1.099026, 0.250522, 1.696593>
    }
    triangle {
      < -1.728194, 0.061993, 1.659719>,
      < -1.099026, 0.250522, 1.696593>,
      < -1.731463, 0.222937, 1.741979>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.096029, 0.102989, 1.621189>,
      < -0.835623, 0.156804, 1.554627>,
      < -0.838153, 0.281344, 1.618281>
    }
    triangle {
      < -1.096029, 0.102989, 1.621189>,
      < -0.838153, 0.281344, 1.618281>,
      < -1.099026, 0.250522, 1.696593>
    }
    triangle {
      < -0.835623, 0.156804, 1.554627>,
      < -0.849611, 0.168675, 1.537938>,
      < -0.852023, 0.287467, 1.598654>
    }
    triangle {
      < -0.835623, 0.156804, 1.554627>,
      < -0.852023, 0.287467, 1.598654>,
      < -0.838153, 0.281344, 1.618281>
    }
    triangle {
      < -0.849611, 0.168675, 1.537938>,
      < -1.096572, 0.131332, 1.582267>,
      < -1.099296, 0.265453, 1.650818>
    }
    triangle {
      < -0.849611, 0.168675, 1.537938>,
      < -1.099296, 0.265453, 1.650818>,
      < -0.852023, 0.287467, 1.598654>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.096572, 0.131332, 1.582267>,
      < -1.522962, 0.122804, 1.582004>,
      < -1.525687, 0.256925, 1.650554>
    }
    triangle {
      < -1.096572, 0.131332, 1.582267>,
      < -1.525687, 0.256925, 1.650554>,
      < -1.099296, 0.265453, 1.650818>
    }
    triangle {
      < -1.522962, 0.122804, 1.582004>,
      < -1.589200, 0.348307, 1.270596>,
      < -1.589745, 0.375132, 1.284306>
    }
    triangle {
      < -1.522962, 0.122804, 1.582004>,
      < -1.589745, 0.375132, 1.284306>,
      < -1.525687, 0.256925, 1.650554>
    }
    triangle {
      < -1.589200, 0.348307, 1.270596>,
      < -1.499795, 0.350095, 1.270651>,
      < -1.500340, 0.376920, 1.284361>
    }
    triangle {
      < -1.589200, 0.348307, 1.270596>,
      < -1.500340, 0.376920, 1.284361>,
      < -1.589745, 0.375132, 1.284306>
    }
    triangle {
      < -1.499795, 0.350095, 1.270651>,
      < -1.424766, 0.384000, 1.226216>,
      < -1.425000, 0.395496, 1.232092>
    }
    triangle {
      < -1.499795, 0.350095, 1.270651>,
      < -1.425000, 0.395496, 1.232092>,
      < -1.500340, 0.376920, 1.284361>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -4.090776, 0.210144, 1.296162>,
      < -4.091591, 0.249656, 1.335775>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -4.091591, 0.249656, 1.335775>,
      < -3.520702, 0.257022, 1.341687>
    }
    triangle {
      < -4.090776, 0.210144, 1.296162>,
      < -4.062615, 0.177282, 1.320399>,
      < -4.063617, 0.225912, 1.369153>
    }
    triangle {
      < -4.090776, 0.210144, 1.296162>,
      < -4.063617, 0.225912, 1.369153>,
      < -4.091591, 0.249656, 1.335775>
    }
    triangle {
      < -4.062615, 0.177282, 1.320399>,
      < -3.546384, 0.165323, 1.336864>,
      < -3.547514, 0.220032, 1.391712>
    }
    triangle {
      < -4.062615, 0.177282, 1.320399>,
      < -3.547514, 0.220032, 1.391712>,
      < -4.063617, 0.225912, 1.369153>
    }
    triangle {
      < -3.546384, 0.165323, 1.336864>,
      < -3.509168, 0.021227, 1.441837>,
      < -3.511110, 0.115447, 1.536297>
    }
    triangle {
      < -3.546384, 0.165323, 1.336864>,
      < -3.511110, 0.115447, 1.536297>,
      < -3.547514, 0.220032, 1.391712>
    }
    triangle {
      < -3.509168, 0.021227, 1.441837>,
      < -3.900953, 0.002250, 1.449669>,
      < -3.902958, 0.099509, 1.547177>
    }
    triangle {
      < -3.509168, 0.021227, 1.441837>,
      < -3.902958, 0.099509, 1.547177>,
      < -3.511110, 0.115447, 1.536297>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.900953, 0.002250, 1.449669>,
      < -3.859144, -0.024767, 1.469878>,
      < -3.861307, 0.080089, 1.575003>
    }
    triangle {
      < -3.900953, 0.002250, 1.449669>,
      < -3.861307, 0.080089, 1.575003>,
      < -3.902958, 0.099509, 1.547177>
    }
    triangle {
      < -3.859144, -0.024767, 1.469878>,
      < -3.183976, -0.072543, 1.514696>,
      < -3.186482, 0.049031, 1.636581>
    }
    triangle {
      < -3.859144, -0.024767, 1.469878>,
      < -3.186482, 0.049031, 1.636581>,
      < -3.861307, 0.080089, 1.575003>
    }
    triangle {
      < -3.183976, -0.072543, 1.514696>,
      < -2.688378, -0.084914, 1.531147>,
      < -2.691010, 0.042738, 1.659126>
    }
    triangle {
      < -3.183976, -0.072543, 1.514696>,
      < -2.691010, 0.042738, 1.659126>,
      < -3.186482, 0.049031, 1.636581>
    }
    triangle {
      < -2.688378, -0.084914, 1.531147>,
      < -1.725561, -0.065659, 1.531741>,
      < -1.728194, 0.061993, 1.659719>
    }
    triangle {
      < -2.688378, -0.084914, 1.531147>,
      < -1.728194, 0.061993, 1.659719>,
      < -2.691010, 0.042738, 1.659126>
    }
    triangle {
      < -1.725561, -0.065659, 1.531741>,
      < -1.093616, -0.014025, 1.503875>,
      < -1.096029, 0.102989, 1.621189>
    }
    triangle {
      < -1.725561, -0.065659, 1.531741>,
      < -1.096029, 0.102989, 1.621189>,
      < -1.728194, 0.061993, 1.659719>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.093616, -0.014025, 1.503875>,
      < -0.833586, 0.058026, 1.455596>,
      < -0.835623, 0.156804, 1.554627>
    }
    triangle {
      < -1.093616, -0.014025, 1.503875>,
      < -0.835623, 0.156804, 1.554627>,
      < -1.096029, 0.102989, 1.621189>
    }
    triangle {
      < -0.833586, 0.058026, 1.455596>,
      < -0.847667, 0.074457, 1.443478>,
      < -0.849611, 0.168675, 1.537938>
    }
    triangle {
      < -0.833586, 0.058026, 1.455596>,
      < -0.849611, 0.168675, 1.537938>,
      < -0.835623, 0.156804, 1.554627>
    }
    triangle {
      < -0.847667, 0.074457, 1.443478>,
      < -1.094378, 0.024956, 1.475618>,
      < -1.096572, 0.131332, 1.582267>
    }
    triangle {
      < -0.847667, 0.074457, 1.443478>,
      < -1.096572, 0.131332, 1.582267>,
      < -0.849611, 0.168675, 1.537938>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.094378, 0.024956, 1.475618>,
      < -1.520769, 0.016428, 1.475356>,
      < -1.522962, 0.122804, 1.582004>
    }
    triangle {
      < -1.094378, 0.024956, 1.475618>,
      < -1.522962, 0.122804, 1.582004>,
      < -1.096572, 0.131332, 1.582267>
    }
    triangle {
      < -1.520769, 0.016428, 1.475356>,
      < -1.588762, 0.327032, 1.249266>,
      < -1.589200, 0.348307, 1.270596>
    }
    triangle {
      < -1.520769, 0.016428, 1.475356>,
      < -1.589200, 0.348307, 1.270596>,
      < -1.522962, 0.122804, 1.582004>
    }
    triangle {
      < -1.588762, 0.327032, 1.249266>,
      < -1.499356, 0.328821, 1.249321>,
      < -1.499795, 0.350095, 1.270651>
    }
    triangle {
      < -1.588762, 0.327032, 1.249266>,
      < -1.499795, 0.350095, 1.270651>,
      < -1.589200, 0.348307, 1.270596>
    }
    triangle {
      < -1.499356, 0.328821, 1.249321>,
      < -1.424578, 0.374882, 1.217075>,
      < -1.424766, 0.384000, 1.226216>
    }
    triangle {
      < -1.499356, 0.328821, 1.249321>,
      < -1.424766, 0.384000, 1.226216>,
      < -1.499795, 0.350095, 1.270651>
    }
    triangle {
      < -3.519296, 0.189678, 1.248746>,
      < -4.090240, 0.184806, 1.246277>,
      < -4.090776, 0.210144, 1.296162>
    }
    triangle {
      < -3.519296, 0.189678, 1.248746>,
      < -4.090776, 0.210144, 1.296162>,
      < -3.519855, 0.215991, 1.300551>
    }
    triangle {
      < -4.090240, 0.184806, 1.246277>,
      < -4.061954, 0.146097, 1.259001>,
      < -4.062615, 0.177282, 1.320399>
    }
    triangle {
      < -4.090240, 0.184806, 1.246277>,
      < -4.062615, 0.177282, 1.320399>,
      < -4.090776, 0.210144, 1.296162>
    }
    triangle {
      < -4.061954, 0.146097, 1.259001>,
      < -3.545641, 0.130239, 1.267791>,
      < -3.546384, 0.165323, 1.336864>
    }
    triangle {
      < -4.061954, 0.146097, 1.259001>,
      < -3.546384, 0.165323, 1.336864>,
      < -4.062615, 0.177282, 1.320399>
    }
    triangle {
      < -3.545641, 0.130239, 1.267791>,
      < -3.507886, -0.039196, 1.322879>,
      < -3.509168, 0.021227, 1.441837>
    }
    triangle {
      < -3.545641, 0.130239, 1.267791>,
      < -3.509168, 0.021227, 1.441837>,
      < -3.546384, 0.165323, 1.336864>
    }
    triangle {
      < -3.507886, -0.039196, 1.322879>,
      < -3.899630, -0.060122, 1.326873>,
      < -3.900953, 0.002250, 1.449669>
    }
    triangle {
      < -3.507886, -0.039196, 1.322879>,
      < -3.900953, 0.002250, 1.449669>,
      < -3.509168, 0.021227, 1.441837>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.899630, -0.060122, 1.326873>,
      < -3.857719, -0.092012, 1.337488>,
      < -3.859144, -0.024767, 1.469878>
    }
    triangle {
      < -3.899630, -0.060122, 1.326873>,
      < -3.859144, -0.024767, 1.469878>,
      < -3.900953, 0.002250, 1.449669>
    }
    triangle {
      < -3.857719, -0.092012, 1.337488>,
      < -3.182322, -0.150508, 1.361200>,
      < -3.183976, -0.072543, 1.514696>
    }
    triangle {
      < -3.857719, -0.092012, 1.337488>,
      < -3.183976, -0.072543, 1.514696>,
      < -3.859144, -0.024767, 1.469878>
    }
    triangle {
      < -3.182322, -0.150508, 1.361200>,
      < -2.686641, -0.166778, 1.369977>,
      < -2.688378, -0.084914, 1.531147>
    }
    triangle {
      < -3.182322, -0.150508, 1.361200>,
      < -2.688378, -0.084914, 1.531147>,
      < -3.183976, -0.072543, 1.514696>
    }
    triangle {
      < -2.686641, -0.166778, 1.369977>,
      < -1.723825, -0.147522, 1.370571>,
      < -1.725561, -0.065659, 1.531741>
    }
    triangle {
      < -2.686641, -0.166778, 1.369977>,
      < -1.725561, -0.065659, 1.531741>,
      < -2.688378, -0.084914, 1.531147>
    }
    triangle {
      < -1.723825, -0.147522, 1.370571>,
      < -1.092024, -0.089067, 1.356135>,
      < -1.093616, -0.014025, 1.503875>
    }
    triangle {
      < -1.723825, -0.147522, 1.370571>,
      < -1.093616, -0.014025, 1.503875>,
      < -1.725561, -0.065659, 1.531741>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.092024, -0.089067, 1.356135>,
      < -0.832243, -0.005322, 1.330881>,
      < -0.833586, 0.058026, 1.455596>
    }
    triangle {
      < -1.092024, -0.089067, 1.356135>,
      < -0.833586, 0.058026, 1.455596>,
      < -1.093616, -0.014025, 1.503875>
    }
    triangle {
      < -0.832243, -0.005322, 1.330881>,
      < -0.846386, 0.014033, 1.324519>,
      < -0.847667, 0.074457, 1.443478>
    }
    triangle {
      < -0.832243, -0.005322, 1.330881>,
      < -0.847667, 0.074457, 1.443478>,
      < -0.833586, 0.058026, 1.455596>
    }
    triangle {
      < -0.846386, 0.014033, 1.324519>,
      < -1.092931, -0.043264, 1.341310>,
      < -1.094378, 0.024956, 1.475618>
    }
    triangle {
      < -0.846386, 0.014033, 1.324519>,
      < -1.094378, 0.024956, 1.475618>,
      < -0.847667, 0.074457, 1.443478>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.092931, -0.043264, 1.341310>,
      < -1.519321, -0.051792, 1.341047>,
      < -1.520769, 0.016428, 1.475356>
    }
    triangle {
      < -1.092931, -0.043264, 1.341310>,
      < -1.520769, 0.016428, 1.475356>,
      < -1.094378, 0.024956, 1.475618>
    }
    triangle {
      < -1.519321, -0.051792, 1.341047>,
      < -1.588473, 0.313388, 1.222404>,
      < -1.588762, 0.327032, 1.249266>
    }
    triangle {
      < -1.519321, -0.051792, 1.341047>,
      < -1.588762, 0.327032, 1.249266>,
      < -1.520769, 0.016428, 1.475356>
    }
    triangle {
      < -1.588473, 0.313388, 1.222404>,
      < -1.499067, 0.315176, 1.222459>,
      < -1.499356, 0.328821, 1.249321>
    }
    triangle {
      < -1.588473, 0.313388, 1.222404>,
      < -1.499356, 0.328821, 1.249321>,
      < -1.588762, 0.327032, 1.249266>
    }
    triangle {
      < -1.499067, 0.315176, 1.222459>,
      < -1.424455, 0.369034, 1.205563>,
      < -1.424578, 0.374882, 1.217075>
    }
    triangle {
      < -1.499067, 0.315176, 1.222459>,
      < -1.424578, 0.374882, 1.217075>,
      < -1.499356, 0.328821, 1.249321>
    }
    triangle {
      < -3.519082, 0.180658, 1.191344>,
      < -4.090031, 0.176120, 1.191001>,
      < -4.090240, 0.184806, 1.246277>
    }
    triangle {
      < -3.519082, 0.180658, 1.191344>,
      < -4.090240, 0.184806, 1.246277>,
      < -3.519296, 0.189678, 1.248746>
    }
    triangle {
      < -4.090031, 0.176120, 1.191001>,
      < -4.061697, 0.135406, 1.190969>,
      < -4.061954, 0.146097, 1.259001>
    }
    triangle {
      < -4.090031, 0.176120, 1.191001>,
      < -4.061954, 0.146097, 1.259001>,
      < -4.090240, 0.184806, 1.246277>
    }
    triangle {
      < -4.061697, 0.135406, 1.190969>,
      < -3.545353, 0.118212, 1.191255>,
      < -3.545641, 0.130239, 1.267791>
    }
    triangle {
      < -4.061697, 0.135406, 1.190969>,
      < -3.545641, 0.130239, 1.267791>,
      < -4.061954, 0.146097, 1.259001>
    }
    triangle {
      < -3.545353, 0.118212, 1.191255>,
      < -3.507391, -0.059908, 1.191066>,
      < -3.507886, -0.039196, 1.322879>
    }
    triangle {
      < -3.545353, 0.118212, 1.191255>,
      < -3.507886, -0.039196, 1.322879>,
      < -3.545641, 0.130239, 1.267791>
    }
    triangle {
      < -3.507391, -0.059908, 1.191066>,
      < -3.899118, -0.081503, 1.190808>,
      < -3.899630, -0.060122, 1.326873>
    }
    triangle {
      < -3.507391, -0.059908, 1.191066>,
      < -3.899630, -0.060122, 1.326873>,
      < -3.507886, -0.039196, 1.322879>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.899118, -0.081503, 1.190808>,
      < -3.857166, -0.115064, 1.190794>,
      < -3.857719, -0.092012, 1.337488>
    }
    triangle {
      < -3.899118, -0.081503, 1.190808>,
      < -3.857719, -0.092012, 1.337488>,
      < -3.899630, -0.060122, 1.326873>
    }
    triangle {
      < -3.857166, -0.115064, 1.190794>,
      < -3.181682, -0.177235, 1.191120>,
      < -3.182322, -0.150508, 1.361200>
    }
    triangle {
      < -3.857166, -0.115064, 1.190794>,
      < -3.182322, -0.150508, 1.361200>,
      < -3.857719, -0.092012, 1.337488>
    }
    triangle {
      < -3.181682, -0.177235, 1.191120>,
      < -2.685971, -0.194840, 1.191393>,
      < -2.686641, -0.166778, 1.369977>
    }
    triangle {
      < -3.181682, -0.177235, 1.191120>,
      < -2.686641, -0.166778, 1.369977>,
      < -3.182322, -0.150508, 1.361200>
    }
    triangle {
      < -2.685971, -0.194840, 1.191393>,
      < -1.723154, -0.175584, 1.191986>,
      < -1.723825, -0.147522, 1.370571>
    }
    triangle {
      < -2.685971, -0.194840, 1.191393>,
      < -1.723825, -0.147522, 1.370571>,
      < -2.686641, -0.166778, 1.369977>
    }
    triangle {
      < -1.723154, -0.175584, 1.191986>,
      < -1.091410, -0.114790, 1.192433>,
      < -1.092024, -0.089067, 1.356135>
    }
    triangle {
      < -1.723154, -0.175584, 1.191986>,
      < -1.092024, -0.089067, 1.356135>,
      < -1.723825, -0.147522, 1.370571>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -1.091410, -0.114790, 1.192433>,
      < -0.831723, -0.027037, 1.192691>,
      < -0.832243, -0.005322, 1.330881>
    }
    triangle {
      < -1.091410, -0.114790, 1.192433>,
      < -0.832243, -0.005322, 1.330881>,
      < -1.092024, -0.089067, 1.356135>
    }
    triangle {
      < -0.831723, -0.027037, 1.192691>,
      < -0.845890, -0.006680, 1.192706>,
      < -0.846386, 0.014033, 1.324519>
    }
    triangle {
      < -0.831723, -0.027037, 1.192691>,
      < -0.846386, 0.014033, 1.324519>,
      < -0.832243, -0.005322, 1.330881>
    }
    triangle {
      < -0.845890, -0.006680, 1.192706>,
      < -1.092372, -0.066650, 1.192489>,
      < -1.092931, -0.043264, 1.341310>
    }
    triangle {
      < -0.845890, -0.006680, 1.192706>,
      < -1.092931, -0.043264, 1.341310>,
      < -0.846386, 0.014033, 1.324519>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.092372, -0.066650, 1.192489>,
      < -1.518762, -0.075178, 1.192226>,
      < -1.519321, -0.051792, 1.341047>
    }
    triangle {
      < -1.092372, -0.066650, 1.192489>,
      < -1.519321, -0.051792, 1.341047>,
      < -1.092931, -0.043264, 1.341310>
    }
    triangle {
      < -1.518762, -0.075178, 1.192226>,
      < -1.588360, 0.308711, 1.192641>,
      < -1.588473, 0.313388, 1.222404>
    }
    triangle {
      < -1.518762, -0.075178, 1.192226>,
      < -1.588473, 0.313388, 1.222404>,
      < -1.519321, -0.051792, 1.341047>
    }
    triangle {
      < -1.588360, 0.308711, 1.192641>,
      < -1.498956, 0.310499, 1.192695>,
      < -1.499067, 0.315176, 1.222459>
    }
    triangle {
      < -1.588360, 0.308711, 1.192641>,
      < -1.499067, 0.315176, 1.222459>,
      < -1.588473, 0.313388, 1.222404>
    }
    triangle {
      < -1.498956, 0.310499, 1.192695>,
      < -1.424407, 0.367030, 1.192806>,
      < -1.424455, 0.369034, 1.205563>
    }
    triangle {
      < -1.498956, 0.310499, 1.192695>,
      < -1.424455, 0.369034, 1.205563>,
      < -1.499067, 0.315176, 1.222459>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.520702, 0.257022, 1.341687>,
      < -3.521752, 0.308754, 1.368127>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.521752, 0.308754, 1.368127>,
      < -3.522905, 0.366123, 1.377285>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.522905, 0.366123, 1.377285>,
      < -3.524047, 0.423515, 1.368262>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.524047, 0.423515, 1.368262>,
      < -3.525066, 0.475309, 1.341943>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.525066, 0.475309, 1.341943>,
      < -3.525863, 0.516437, 1.300903>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.525863, 0.516437, 1.300903>,
      < -3.526360, 0.542874, 1.249161>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.526360, 0.542874, 1.249161>,
      < -3.526508, 0.552030, 1.191780>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.526508, 0.552030, 1.191780>,
      < -3.526292, 0.543009, 1.134378>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.526292, 0.543009, 1.134378>,
      < -3.525734, 0.516696, 1.082573>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.525734, 0.516696, 1.082573>,
      < -3.524888, 0.475665, 1.041438>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.524888, 0.475665, 1.041438>,
      < -3.523838, 0.423933, 1.014997>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.523838, 0.423933, 1.014997>,
      < -3.522685, 0.366563, 1.005840>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.522685, 0.366563, 1.005840>,
      < -3.521542, 0.309173, 1.014862>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.521542, 0.309173, 1.014862>,
      < -3.520524, 0.257379, 1.041181>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.520524, 0.257379, 1.041181>,
      < -3.519726, 0.216250, 1.082221>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.519726, 0.216250, 1.082221>,
      < -3.519228, 0.189814, 1.133963>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.519228, 0.189814, 1.133963>,
      < -3.519082, 0.180658, 1.191344>
    }
    triangle {
      < -3.519855, 0.215991, 1.300551>,
      < -3.519082, 0.180658, 1.191344>,
      < -3.519296, 0.189678, 1.248746>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.424727, 0.384079, 1.159437>,
      < -1.424953, 0.395589, 1.153589>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.424953, 0.395589, 1.153589>,
      < -1.425208, 0.408342, 1.151583>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425208, 0.408342, 1.151583>,
      < -1.425464, 0.421092, 1.153618>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425464, 0.421092, 1.153618>,
      < -1.425697, 0.432588, 1.159494>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425697, 0.432588, 1.159494>,
      < -1.425884, 0.441705, 1.168635>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425884, 0.441705, 1.168635>,
      < -1.426009, 0.447552, 1.180147>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.426009, 0.447552, 1.180147>,
      < -1.426057, 0.449557, 1.192903>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.426057, 0.449557, 1.192903>,
      < -1.426024, 0.447522, 1.205655>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.426024, 0.447522, 1.205655>,
      < -1.425913, 0.441647, 1.217153>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425913, 0.441647, 1.217153>,
      < -1.425737, 0.432508, 1.226273>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425737, 0.432508, 1.226273>,
      < -1.425510, 0.420998, 1.232122>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425510, 0.420998, 1.232122>,
      < -1.425257, 0.408245, 1.234127>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425257, 0.408245, 1.234127>,
      < -1.425000, 0.395496, 1.232092>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.425000, 0.395496, 1.232092>,
      < -1.424766, 0.384000, 1.226216>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.424766, 0.384000, 1.226216>,
      < -1.424578, 0.374882, 1.217075>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.424578, 0.374882, 1.217075>,
      < -1.424455, 0.369034, 1.205563>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.424455, 0.369034, 1.205563>,
      < -1.424407, 0.367030, 1.192806>
    }
    triangle {
      < -1.424549, 0.374940, 1.168557>,
      < -1.424407, 0.367030, 1.192806>,
      < -1.424439, 0.369065, 1.180055>
    }
    triangle {
      < -4.088825, 0.187635, -1.140258>,
      < -3.517882, 0.192507, -1.137787>,
      < -3.517668, 0.183487, -1.195190>
    }
    triangle {
      < -4.088825, 0.187635, -1.140258>,
      < -3.517668, 0.183487, -1.195190>,
      < -4.088617, 0.178948, -1.195533>
    }
    triangle {
      < -4.060540, 0.148925, -1.127533>,
      < -4.088825, 0.187635, -1.140258>,
      < -4.088617, 0.178948, -1.195533>
    }
    triangle {
      < -4.060540, 0.148925, -1.127533>,
      < -4.088617, 0.178948, -1.195533>,
      < -4.060283, 0.138235, -1.195564>
    }
    triangle {
      < -3.544226, 0.133068, -1.118743>,
      < -4.060540, 0.148925, -1.127533>,
      < -4.060283, 0.138235, -1.195564>
    }
    triangle {
      < -3.544226, 0.133068, -1.118743>,
      < -4.060283, 0.138235, -1.195564>,
      < -3.543939, 0.121041, -1.195279>
    }
    triangle {
      < -3.506472, -0.036367, -1.063655>,
      < -3.544226, 0.133068, -1.118743>,
      < -3.543939, 0.121041, -1.195279>
    }
    triangle {
      < -3.506472, -0.036367, -1.063655>,
      < -3.543939, 0.121041, -1.195279>,
      < -3.505976, -0.057080, -1.195468>
    }
    triangle {
      < -3.898216, -0.057293, -1.059661>,
      < -3.506472, -0.036367, -1.063655>,
      < -3.505976, -0.057080, -1.195468>
    }
    triangle {
      < -3.898216, -0.057293, -1.059661>,
      < -3.505976, -0.057080, -1.195468>,
      < -3.897704, -0.078674, -1.195726>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.856304, -0.089183, -1.049046>,
      < -3.898216, -0.057293, -1.059661>,
      < -3.897704, -0.078674, -1.195726>
    }
    triangle {
      < -3.856304, -0.089183, -1.049046>,
      < -3.897704, -0.078674, -1.195726>,
      < -3.855752, -0.112235, -1.195741>
    }
    triangle {
      < -3.180907, -0.147680, -1.025333>,
      < -3.856304, -0.089183, -1.049046>,
      < -3.855752, -0.112235, -1.195741>
    }
    triangle {
      < -3.180907, -0.147680, -1.025333>,
      < -3.855752, -0.112235, -1.195741>,
      < -3.180268, -0.174406, -1.195414>
    }
    triangle {
      < -2.685226, -0.163950, -1.016556>,
      < -3.180907, -0.147680, -1.025333>,
      < -3.180268, -0.174406, -1.195414>
    }
    triangle {
      < -2.685226, -0.163950, -1.016556>,
      < -3.180268, -0.174406, -1.195414>,
      < -2.684556, -0.192012, -1.195141>
    }
    triangle {
      < -1.722411, -0.144694, -1.015962>,
      < -2.685226, -0.163950, -1.016556>,
      < -2.684556, -0.192012, -1.195141>
    }
    triangle {
      < -1.722411, -0.144694, -1.015962>,
      < -2.684556, -0.192012, -1.195141>,
      < -1.721740, -0.172757, -1.194548>
    }
    triangle {
      < -1.090610, -0.086238, -1.030399>,
      < -1.722411, -0.144694, -1.015962>,
      < -1.721740, -0.172757, -1.194548>
    }
    triangle {
      < -1.090610, -0.086238, -1.030399>,
      < -1.721740, -0.172757, -1.194548>,
      < -1.089995, -0.111961, -1.194101>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.830828, -0.002493, -1.055653>,
      < -1.090610, -0.086238, -1.030399>,
      < -1.089995, -0.111961, -1.194101>
    }
    triangle {
      < -0.830828, -0.002493, -1.055653>,
      < -1.089995, -0.111961, -1.194101>,
      < -0.830309, -0.024208, -1.193843>
    }
    triangle {
      < -0.844971, 0.016861, -1.062015>,
      < -0.830828, -0.002493, -1.055653>,
      < -0.830309, -0.024208, -1.193843>
    }
    triangle {
      < -0.844971, 0.016861, -1.062015>,
      < -0.830309, -0.024208, -1.193843>,
      < -0.844476, -0.003851, -1.193827>
    }
    triangle {
      < -1.091517, -0.040435, -1.045223>,
      < -0.844971, 0.016861, -1.062015>,
      < -0.844476, -0.003851, -1.193827>
    }
    triangle {
      < -1.091517, -0.040435, -1.045223>,
      < -0.844476, -0.003851, -1.193827>,
      < -1.090957, -0.063821, -1.194045>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.517907, -0.048963, -1.045486>,
      < -1.091517, -0.040435, -1.045223>,
      < -1.090957, -0.063821, -1.194045>
    }
    triangle {
      < -1.517907, -0.048963, -1.045486>,
      < -1.090957, -0.063821, -1.194045>,
      < -1.517348, -0.072349, -1.194307>
    }
    triangle {
      < -1.587058, 0.316217, -1.164129>,
      < -1.517907, -0.048963, -1.045486>,
      < -1.517348, -0.072349, -1.194307>
    }
    triangle {
      < -1.587058, 0.316217, -1.164129>,
      < -1.517348, -0.072349, -1.194307>,
      < -1.586946, 0.311540, -1.193894>
    }
    triangle {
      < -1.497652, 0.318005, -1.164074>,
      < -1.587058, 0.316217, -1.164129>,
      < -1.586946, 0.311540, -1.193894>
    }
    triangle {
      < -1.497652, 0.318005, -1.164074>,
      < -1.586946, 0.311540, -1.193894>,
      < -1.497541, 0.313328, -1.193839>
    }
    triangle {
      < -1.423040, 0.371863, -1.180971>,
      < -1.497652, 0.318005, -1.164074>,
      < -1.497541, 0.313328, -1.193839>
    }
    triangle {
      < -1.423040, 0.371863, -1.180971>,
      < -1.497541, 0.313328, -1.193839>,
      < -1.422992, 0.369859, -1.193727>
    }
    triangle {
      < -4.089362, 0.212973, -1.090371>,
      < -3.518441, 0.218820, -1.085983>,
      < -3.517882, 0.192507, -1.137787>
    }
    triangle {
      < -4.089362, 0.212973, -1.090371>,
      < -3.517882, 0.192507, -1.137787>,
      < -4.088825, 0.187635, -1.140258>
    }
    triangle {
      < -4.061201, 0.180111, -1.066134>,
      < -4.089362, 0.212973, -1.090371>,
      < -4.088825, 0.187635, -1.140258>
    }
    triangle {
      < -4.061201, 0.180111, -1.066134>,
      < -4.088825, 0.187635, -1.140258>,
      < -4.060540, 0.148925, -1.127533>
    }
    triangle {
      < -3.544970, 0.168152, -1.049669>,
      < -4.061201, 0.180111, -1.066134>,
      < -4.060540, 0.148925, -1.127533>
    }
    triangle {
      < -3.544970, 0.168152, -1.049669>,
      < -4.060540, 0.148925, -1.127533>,
      < -3.544226, 0.133068, -1.118743>
    }
    triangle {
      < -3.507754, 0.024056, -0.944697>,
      < -3.544970, 0.168152, -1.049669>,
      < -3.544226, 0.133068, -1.118743>
    }
    triangle {
      < -3.507754, 0.024056, -0.944697>,
      < -3.544226, 0.133068, -1.118743>,
      < -3.506472, -0.036367, -1.063655>
    }
    triangle {
      < -3.899539, 0.005079, -0.936865>,
      < -3.507754, 0.024056, -0.944697>,
      < -3.506472, -0.036367, -1.063655>
    }
    triangle {
      < -3.899539, 0.005079, -0.936865>,
      < -3.506472, -0.036367, -1.063655>,
      < -3.898216, -0.057293, -1.059661>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.857730, -0.021939, -0.916657>,
      < -3.899539, 0.005079, -0.936865>,
      < -3.898216, -0.057293, -1.059661>
    }
    triangle {
      < -3.857730, -0.021939, -0.916657>,
      < -3.898216, -0.057293, -1.059661>,
      < -3.856304, -0.089183, -1.049046>
    }
    triangle {
      < -3.182562, -0.069715, -0.871838>,
      < -3.857730, -0.021939, -0.916657>,
      < -3.856304, -0.089183, -1.049046>
    }
    triangle {
      < -3.182562, -0.069715, -0.871838>,
      < -3.856304, -0.089183, -1.049046>,
      < -3.180907, -0.147680, -1.025333>
    }
    triangle {
      < -2.686964, -0.082085, -0.855386>,
      < -3.182562, -0.069715, -0.871838>,
      < -3.180907, -0.147680, -1.025333>
    }
    triangle {
      < -2.686964, -0.082085, -0.855386>,
      < -3.180907, -0.147680, -1.025333>,
      < -2.685226, -0.163950, -1.016556>
    }
    triangle {
      < -1.724147, -0.062830, -0.854793>,
      < -2.686964, -0.082085, -0.855386>,
      < -2.685226, -0.163950, -1.016556>
    }
    triangle {
      < -1.724147, -0.062830, -0.854793>,
      < -2.685226, -0.163950, -1.016556>,
      < -1.722411, -0.144694, -1.015962>
    }
    triangle {
      < -1.092202, -0.011196, -0.882659>,
      < -1.724147, -0.062830, -0.854793>,
      < -1.722411, -0.144694, -1.015962>
    }
    triangle {
      < -1.092202, -0.011196, -0.882659>,
      < -1.722411, -0.144694, -1.015962>,
      < -1.090610, -0.086238, -1.030399>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.832172, 0.060854, -0.930938>,
      < -1.092202, -0.011196, -0.882659>,
      < -1.090610, -0.086238, -1.030399>
    }
    triangle {
      < -0.832172, 0.060854, -0.930938>,
      < -1.090610, -0.086238, -1.030399>,
      < -0.830828, -0.002493, -1.055653>
    }
    triangle {
      < -0.846253, 0.077284, -0.943056>,
      < -0.832172, 0.060854, -0.930938>,
      < -0.830828, -0.002493, -1.055653>
    }
    triangle {
      < -0.846253, 0.077284, -0.943056>,
      < -0.830828, -0.002493, -1.055653>,
      < -0.844971, 0.016861, -1.062015>
    }
    triangle {
      < -1.092964, 0.027784, -0.910916>,
      < -0.846253, 0.077284, -0.943056>,
      < -0.844971, 0.016861, -1.062015>
    }
    triangle {
      < -1.092964, 0.027784, -0.910916>,
      < -0.844971, 0.016861, -1.062015>,
      < -1.091517, -0.040435, -1.045223>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.519354, 0.019256, -0.911179>,
      < -1.092964, 0.027784, -0.910916>,
      < -1.091517, -0.040435, -1.045223>
    }
    triangle {
      < -1.519354, 0.019256, -0.911179>,
      < -1.091517, -0.040435, -1.045223>,
      < -1.517907, -0.048963, -1.045486>
    }
    triangle {
      < -1.587348, 0.329861, -1.137268>,
      < -1.519354, 0.019256, -0.911179>,
      < -1.517907, -0.048963, -1.045486>
    }
    triangle {
      < -1.587348, 0.329861, -1.137268>,
      < -1.517907, -0.048963, -1.045486>,
      < -1.587058, 0.316217, -1.164129>
    }
    triangle {
      < -1.497942, 0.331648, -1.137213>,
      < -1.587348, 0.329861, -1.137268>,
      < -1.587058, 0.316217, -1.164129>
    }
    triangle {
      < -1.497942, 0.331648, -1.137213>,
      < -1.587058, 0.316217, -1.164129>,
      < -1.497652, 0.318005, -1.164074>
    }
    triangle {
      < -1.423164, 0.377710, -1.169459>,
      < -1.497942, 0.331648, -1.137213>,
      < -1.497652, 0.318005, -1.164074>
    }
    triangle {
      < -1.423164, 0.377710, -1.169459>,
      < -1.497652, 0.318005, -1.164074>,
      < -1.423040, 0.371863, -1.180971>
    }
    triangle {
      < -4.090177, 0.252484, -1.050759>,
      < -3.519287, 0.259851, -1.044846>,
      < -3.518441, 0.218820, -1.085983>
    }
    triangle {
      < -4.090177, 0.252484, -1.050759>,
      < -3.518441, 0.218820, -1.085983>,
      < -4.089362, 0.212973, -1.090371>
    }
    triangle {
      < -4.062203, 0.228740, -1.017381>,
      < -4.090177, 0.252484, -1.050759>,
      < -4.089362, 0.212973, -1.090371>
    }
    triangle {
      < -4.062203, 0.228740, -1.017381>,
      < -4.089362, 0.212973, -1.090371>,
      < -4.061201, 0.180111, -1.066134>
    }
    triangle {
      < -3.546099, 0.222860, -0.994823>,
      < -4.062203, 0.228740, -1.017381>,
      < -4.061201, 0.180111, -1.066134>
    }
    triangle {
      < -3.546099, 0.222860, -0.994823>,
      < -4.061201, 0.180111, -1.066134>,
      < -3.544970, 0.168152, -1.049669>
    }
    triangle {
      < -3.509696, 0.118276, -0.850236>,
      < -3.546099, 0.222860, -0.994823>,
      < -3.544970, 0.168152, -1.049669>
    }
    triangle {
      < -3.509696, 0.118276, -0.850236>,
      < -3.544970, 0.168152, -1.049669>,
      < -3.507754, 0.024056, -0.944697>
    }
    triangle {
      < -3.901543, 0.102338, -0.839358>,
      < -3.509696, 0.118276, -0.850236>,
      < -3.507754, 0.024056, -0.944697>
    }
    triangle {
      < -3.901543, 0.102338, -0.839358>,
      < -3.507754, 0.024056, -0.944697>,
      < -3.899539, 0.005079, -0.936865>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.859892, 0.082918, -0.811531>,
      < -3.901543, 0.102338, -0.839358>,
      < -3.899539, 0.005079, -0.936865>
    }
    triangle {
      < -3.859892, 0.082918, -0.811531>,
      < -3.899539, 0.005079, -0.936865>,
      < -3.857730, -0.021939, -0.916657>
    }
    triangle {
      < -3.185067, 0.051858, -0.749954>,
      < -3.859892, 0.082918, -0.811531>,
      < -3.857730, -0.021939, -0.916657>
    }
    triangle {
      < -3.185067, 0.051858, -0.749954>,
      < -3.857730, -0.021939, -0.916657>,
      < -3.182562, -0.069715, -0.871838>
    }
    triangle {
      < -2.689596, 0.045566, -0.727407>,
      < -3.185067, 0.051858, -0.749954>,
      < -3.182562, -0.069715, -0.871838>
    }
    triangle {
      < -2.689596, 0.045566, -0.727407>,
      < -3.182562, -0.069715, -0.871838>,
      < -2.686964, -0.082085, -0.855386>
    }
    triangle {
      < -1.726779, 0.064822, -0.726814>,
      < -2.689596, 0.045566, -0.727407>,
      < -2.686964, -0.082085, -0.855386>
    }
    triangle {
      < -1.726779, 0.064822, -0.726814>,
      < -2.686964, -0.082085, -0.855386>,
      < -1.724147, -0.062830, -0.854793>
    }
    triangle {
      < -1.094614, 0.105818, -0.765346>,
      < -1.726779, 0.064822, -0.726814>,
      < -1.724147, -0.062830, -0.854793>
    }
    triangle {
      < -1.094614, 0.105818, -0.765346>,
      < -1.724147, -0.062830, -0.854793>,
      < -1.092202, -0.011196, -0.882659>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.834209, 0.159631, -0.831907>,
      < -1.094614, 0.105818, -0.765346>,
      < -1.092202, -0.011196, -0.882659>
    }
    triangle {
      < -0.834209, 0.159631, -0.831907>,
      < -1.092202, -0.011196, -0.882659>,
      < -0.832172, 0.060854, -0.930938>
    }
    triangle {
      < -0.848196, 0.171504, -0.848596>,
      < -0.834209, 0.159631, -0.831907>,
      < -0.832172, 0.060854, -0.930938>
    }
    triangle {
      < -0.848196, 0.171504, -0.848596>,
      < -0.832172, 0.060854, -0.930938>,
      < -0.846253, 0.077284, -0.943056>
    }
    triangle {
      < -1.095157, 0.134161, -0.804267>,
      < -0.848196, 0.171504, -0.848596>,
      < -0.846253, 0.077284, -0.943056>
    }
    triangle {
      < -1.095157, 0.134161, -0.804267>,
      < -0.846253, 0.077284, -0.943056>,
      < -1.092964, 0.027784, -0.910916>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.521548, 0.125633, -0.804530>,
      < -1.095157, 0.134161, -0.804267>,
      < -1.092964, 0.027784, -0.910916>
    }
    triangle {
      < -1.521548, 0.125633, -0.804530>,
      < -1.092964, 0.027784, -0.910916>,
      < -1.519354, 0.019256, -0.911179>
    }
    triangle {
      < -1.587786, 0.351136, -1.115938>,
      < -1.521548, 0.125633, -0.804530>,
      < -1.519354, 0.019256, -0.911179>
    }
    triangle {
      < -1.587786, 0.351136, -1.115938>,
      < -1.519354, 0.019256, -0.911179>,
      < -1.587348, 0.329861, -1.137268>
    }
    triangle {
      < -1.498381, 0.352924, -1.115883>,
      < -1.587786, 0.351136, -1.115938>,
      < -1.587348, 0.329861, -1.137268>
    }
    triangle {
      < -1.498381, 0.352924, -1.115883>,
      < -1.587348, 0.329861, -1.137268>,
      < -1.497942, 0.331648, -1.137213>
    }
    triangle {
      < -1.423352, 0.386829, -1.160318>,
      < -1.498381, 0.352924, -1.115883>,
      < -1.497942, 0.331648, -1.137213>
    }
    triangle {
      < -1.423352, 0.386829, -1.160318>,
      < -1.497942, 0.331648, -1.137213>,
      < -1.423164, 0.377710, -1.169459>
    }
    triangle {
      < -4.091188, 0.302300, -1.025297>,
      < -3.520337, 0.311583, -1.018406>,
      < -3.519287, 0.259851, -1.044846>
    }
    triangle {
      < -4.091188, 0.302300, -1.025297>,
      < -3.519287, 0.259851, -1.044846>,
      < -4.090177, 0.252484, -1.050759>
    }
    triangle {
      < -4.063449, 0.290053, -0.986044>,
      < -4.091188, 0.302300, -1.025297>,
      < -4.090177, 0.252484, -1.050759>
    }
    triangle {
      < -4.063449, 0.290053, -0.986044>,
      < -4.090177, 0.252484, -1.050759>,
      < -4.062203, 0.228740, -1.017381>
    }
    triangle {
      < -3.547500, 0.291836, -0.959567>,
      < -4.063449, 0.290053, -0.986044>,
      < -4.062203, 0.228740, -1.017381>
    }
    triangle {
      < -3.547500, 0.291836, -0.959567>,
      < -4.062203, 0.228740, -1.017381>,
      < -3.546099, 0.222860, -0.994823>
    }
    triangle {
      < -3.512109, 0.237068, -0.789521>,
      < -3.547500, 0.291836, -0.959567>,
      < -3.546099, 0.222860, -0.994823>
    }
    triangle {
      < -3.512109, 0.237068, -0.789521>,
      < -3.546099, 0.222860, -0.994823>,
      < -3.509696, 0.118276, -0.850236>
    }
    triangle {
      < -3.904035, 0.224962, -0.776684>,
      < -3.512109, 0.237068, -0.789521>,
      < -3.509696, 0.118276, -0.850236>
    }
    triangle {
      < -3.904035, 0.224962, -0.776684>,
      < -3.509696, 0.118276, -0.850236>,
      < -3.901543, 0.102338, -0.839358>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.862578, 0.215123, -0.743960>,
      < -3.904035, 0.224962, -0.776684>,
      < -3.901543, 0.102338, -0.839358>
    }
    triangle {
      < -3.862578, 0.215123, -0.743960>,
      < -3.901543, 0.102338, -0.839358>,
      < -3.859892, 0.082918, -0.811531>
    }
    triangle {
      < -3.188182, 0.205139, -0.671610>,
      < -3.862578, 0.215123, -0.743960>,
      < -3.859892, 0.082918, -0.811531>
    }
    triangle {
      < -3.188182, 0.205139, -0.671610>,
      < -3.859892, 0.082918, -0.811531>,
      < -3.185067, 0.051858, -0.749954>
    }
    triangle {
      < -2.692865, 0.206511, -0.645147>,
      < -3.188182, 0.205139, -0.671610>,
      < -3.185067, 0.051858, -0.749954>
    }
    triangle {
      < -2.692865, 0.206511, -0.645147>,
      < -3.185067, 0.051858, -0.749954>,
      < -2.689596, 0.045566, -0.727407>
    }
    triangle {
      < -1.730049, 0.225766, -0.644554>,
      < -2.692865, 0.206511, -0.645147>,
      < -2.689596, 0.045566, -0.727407>
    }
    triangle {
      < -1.730049, 0.225766, -0.644554>,
      < -2.689596, 0.045566, -0.727407>,
      < -1.726779, 0.064822, -0.726814>
    }
    triangle {
      < -1.097612, 0.253350, -0.689940>,
      < -1.730049, 0.225766, -0.644554>,
      < -1.726779, 0.064822, -0.726814>
    }
    triangle {
      < -1.097612, 0.253350, -0.689940>,
      < -1.726779, 0.064822, -0.726814>,
      < -1.094614, 0.105818, -0.765346>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.836738, 0.284171, -0.768254>,
      < -1.097612, 0.253350, -0.689940>,
      < -1.094614, 0.105818, -0.765346>
    }
    triangle {
      < -0.836738, 0.284171, -0.768254>,
      < -1.094614, 0.105818, -0.765346>,
      < -0.834209, 0.159631, -0.831907>
    }
    triangle {
      < -0.850609, 0.290296, -0.787880>,
      < -0.836738, 0.284171, -0.768254>,
      < -0.834209, 0.159631, -0.831907>
    }
    triangle {
      < -0.850609, 0.290296, -0.787880>,
      < -0.834209, 0.159631, -0.831907>,
      < -0.848196, 0.171504, -0.848596>
    }
    triangle {
      < -1.097882, 0.268281, -0.735717>,
      < -0.850609, 0.290296, -0.787880>,
      < -0.848196, 0.171504, -0.848596>
    }
    triangle {
      < -1.097882, 0.268281, -0.735717>,
      < -0.848196, 0.171504, -0.848596>,
      < -1.095157, 0.134161, -0.804267>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.524272, 0.259753, -0.735980>,
      < -1.097882, 0.268281, -0.735717>,
      < -1.095157, 0.134161, -0.804267>
    }
    triangle {
      < -1.524272, 0.259753, -0.735980>,
      < -1.095157, 0.134161, -0.804267>,
      < -1.521548, 0.125633, -0.804530>
    }
    triangle {
      < -1.588331, 0.377960, -1.102228>,
      < -1.524272, 0.259753, -0.735980>,
      < -1.521548, 0.125633, -0.804530>
    }
    triangle {
      < -1.588331, 0.377960, -1.102228>,
      < -1.521548, 0.125633, -0.804530>,
      < -1.587786, 0.351136, -1.115938>
    }
    triangle {
      < -1.498926, 0.379748, -1.102173>,
      < -1.588331, 0.377960, -1.102228>,
      < -1.587786, 0.351136, -1.115938>
    }
    triangle {
      < -1.498926, 0.379748, -1.102173>,
      < -1.587786, 0.351136, -1.115938>,
      < -1.498381, 0.352924, -1.115883>
    }
    triangle {
      < -1.423585, 0.398325, -1.154442>,
      < -1.498926, 0.379748, -1.102173>,
      < -1.498381, 0.352924, -1.115883>
    }
    triangle {
      < -1.423585, 0.398325, -1.154442>,
      < -1.498381, 0.352924, -1.115883>,
      < -1.423352, 0.386829, -1.160318>
    }
    triangle {
      < -4.092299, 0.357544, -1.016480>,
      < -3.521491, 0.368952, -1.009249>,
      < -3.520337, 0.311583, -1.018406>
    }
    triangle {
      < -4.092299, 0.357544, -1.016480>,
      < -3.520337, 0.311583, -1.018406>,
      < -4.091188, 0.302300, -1.025297>
    }
    triangle {
      < -4.064815, 0.358046, -0.975190>,
      < -4.092299, 0.357544, -1.016480>,
      < -4.091188, 0.302300, -1.025297>
    }
    triangle {
      < -4.064815, 0.358046, -0.975190>,
      < -4.091188, 0.302300, -1.025297>,
      < -4.063449, 0.290053, -0.986044>
    }
    triangle {
      < -3.549037, 0.368328, -0.947359>,
      < -4.064815, 0.358046, -0.975190>,
      < -4.063449, 0.290053, -0.986044>
    }
    triangle {
      < -3.549037, 0.368328, -0.947359>,
      < -4.063449, 0.290053, -0.986044>,
      < -3.547500, 0.291836, -0.959567>
    }
    triangle {
      < -3.514756, 0.368805, -0.768493>,
      < -3.549037, 0.368328, -0.947359>,
      < -3.547500, 0.291836, -0.959567>
    }
    triangle {
      < -3.514756, 0.368805, -0.768493>,
      < -3.547500, 0.291836, -0.959567>,
      < -3.512109, 0.237068, -0.789521>
    }
    triangle {
      < -3.906767, 0.360948, -0.754977>,
      < -3.514756, 0.368805, -0.768493>,
      < -3.512109, 0.237068, -0.789521>
    }
    triangle {
      < -3.906767, 0.360948, -0.754977>,
      < -3.512109, 0.237068, -0.789521>,
      < -3.904035, 0.224962, -0.776684>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.865525, 0.361733, -0.720559>,
      < -3.906767, 0.360948, -0.754977>,
      < -3.904035, 0.224962, -0.776684>
    }
    triangle {
      < -3.865525, 0.361733, -0.720559>,
      < -3.904035, 0.224962, -0.776684>,
      < -3.862578, 0.215123, -0.743960>
    }
    triangle {
      < -3.191597, 0.375122, -0.644479>,
      < -3.865525, 0.361733, -0.720559>,
      < -3.862578, 0.215123, -0.743960>
    }
    triangle {
      < -3.191597, 0.375122, -0.644479>,
      < -3.862578, 0.215123, -0.743960>,
      < -3.188182, 0.205139, -0.671610>
    }
    triangle {
      < -2.696452, 0.384992, -0.616659>,
      < -3.191597, 0.375122, -0.644479>,
      < -3.188182, 0.205139, -0.671610>
    }
    triangle {
      < -2.696452, 0.384992, -0.616659>,
      < -3.188182, 0.205139, -0.671610>,
      < -2.692865, 0.206511, -0.645147>
    }
    triangle {
      < -1.733636, 0.404248, -0.616065>,
      < -2.696452, 0.384992, -0.616659>,
      < -2.692865, 0.206511, -0.645147>
    }
    triangle {
      < -1.733636, 0.404248, -0.616065>,
      < -2.692865, 0.206511, -0.645147>,
      < -1.730049, 0.225766, -0.644554>
    }
    triangle {
      < -1.100900, 0.416959, -0.663826>,
      < -1.733636, 0.404248, -0.616065>,
      < -1.730049, 0.225766, -0.644554>
    }
    triangle {
      < -1.100900, 0.416959, -0.663826>,
      < -1.730049, 0.225766, -0.644554>,
      < -1.097612, 0.253350, -0.689940>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.839515, 0.422283, -0.746208>,
      < -1.100900, 0.416959, -0.663826>,
      < -1.097612, 0.253350, -0.689940>
    }
    triangle {
      < -0.839515, 0.422283, -0.746208>,
      < -1.097612, 0.253350, -0.689940>,
      < -0.836738, 0.284171, -0.768254>
    }
    triangle {
      < -0.853256, 0.422033, -0.766852>,
      < -0.839515, 0.422283, -0.746208>,
      < -0.836738, 0.284171, -0.768254>
    }
    triangle {
      < -0.853256, 0.422033, -0.766852>,
      < -0.836738, 0.284171, -0.768254>,
      < -0.850609, 0.290296, -0.787880>
    }
    triangle {
      < -1.100870, 0.417016, -0.711976>,
      < -0.853256, 0.422033, -0.766852>,
      < -0.850609, 0.290296, -0.787880>
    }
    triangle {
      < -1.100870, 0.417016, -0.711976>,
      < -0.850609, 0.290296, -0.787880>,
      < -1.097882, 0.268281, -0.735717>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.527261, 0.408489, -0.712239>,
      < -1.100870, 0.417016, -0.711976>,
      < -1.097882, 0.268281, -0.735717>
    }
    triangle {
      < -1.527261, 0.408489, -0.712239>,
      < -1.097882, 0.268281, -0.735717>,
      < -1.524272, 0.259753, -0.735980>
    }
    triangle {
      < -1.588928, 0.407707, -1.097480>,
      < -1.527261, 0.408489, -0.712239>,
      < -1.524272, 0.259753, -0.735980>
    }
    triangle {
      < -1.588928, 0.407707, -1.097480>,
      < -1.524272, 0.259753, -0.735980>,
      < -1.588331, 0.377960, -1.102228>
    }
    triangle {
      < -1.499523, 0.409496, -1.097425>,
      < -1.588928, 0.407707, -1.097480>,
      < -1.588331, 0.377960, -1.102228>
    }
    triangle {
      < -1.499523, 0.409496, -1.097425>,
      < -1.588331, 0.377960, -1.102228>,
      < -1.498926, 0.379748, -1.102173>
    }
    triangle {
      < -1.423842, 0.411073, -1.152407>,
      < -1.499523, 0.409496, -1.097425>,
      < -1.498926, 0.379748, -1.102173>
    }
    triangle {
      < -1.423842, 0.411073, -1.152407>,
      < -1.498926, 0.379748, -1.102173>,
      < -1.423585, 0.398325, -1.154442>
    }
    triangle {
      < -4.093400, 0.412809, -1.025168>,
      < -3.522633, 0.426343, -1.018271>,
      < -3.521491, 0.368952, -1.009249>
    }
    triangle {
      < -4.093400, 0.412809, -1.025168>,
      < -3.521491, 0.368952, -1.009249>,
      < -4.092299, 0.357544, -1.016480>
    }
    triangle {
      < -4.066169, 0.426065, -0.985884>,
      < -4.093400, 0.412809, -1.025168>,
      < -4.092299, 0.357544, -1.016480>
    }
    triangle {
      < -4.066169, 0.426065, -0.985884>,
      < -4.092299, 0.357544, -1.016480>,
      < -4.064815, 0.358046, -0.975190>
    }
    triangle {
      < -3.550559, 0.444849, -0.959388>,
      < -4.066169, 0.426065, -0.985884>,
      < -4.064815, 0.358046, -0.975190>
    }
    triangle {
      < -3.550559, 0.444849, -0.959388>,
      < -4.064815, 0.358046, -0.975190>,
      < -3.549037, 0.368328, -0.947359>
    }
    triangle {
      < -3.517379, 0.500590, -0.789211>,
      < -3.550559, 0.444849, -0.959388>,
      < -3.549037, 0.368328, -0.947359>
    }
    triangle {
      < -3.517379, 0.500590, -0.789211>,
      < -3.549037, 0.368328, -0.947359>,
      < -3.514756, 0.368805, -0.768493>
    }
    triangle {
      < -3.909475, 0.496986, -0.776364>,
      < -3.517379, 0.500590, -0.789211>,
      < -3.514756, 0.368805, -0.768493>
    }
    triangle {
      < -3.909475, 0.496986, -0.776364>,
      < -3.514756, 0.368805, -0.768493>,
      < -3.906767, 0.360948, -0.754977>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.868444, 0.508398, -0.743616>,
      < -3.909475, 0.496986, -0.776364>,
      < -3.906767, 0.360948, -0.754977>
    }
    triangle {
      < -3.868444, 0.508398, -0.743616>,
      < -3.906767, 0.360948, -0.754977>,
      < -3.865525, 0.361733, -0.720559>
    }
    triangle {
      < -3.194983, 0.545169, -0.671212>,
      < -3.868444, 0.508398, -0.743616>,
      < -3.865525, 0.361733, -0.720559>
    }
    triangle {
      < -3.194983, 0.545169, -0.671212>,
      < -3.865525, 0.361733, -0.720559>,
      < -3.191597, 0.375122, -0.644479>
    }
    triangle {
      < -2.700005, 0.563541, -0.644729>,
      < -3.194983, 0.545169, -0.671212>,
      < -3.191597, 0.375122, -0.644479>
    }
    triangle {
      < -2.700005, 0.563541, -0.644729>,
      < -3.191597, 0.375122, -0.644479>,
      < -2.696452, 0.384992, -0.616659>
    }
    triangle {
      < -1.737189, 0.582797, -0.644135>,
      < -2.700005, 0.563541, -0.644729>,
      < -2.696452, 0.384992, -0.616659>
    }
    triangle {
      < -1.737189, 0.582797, -0.644135>,
      < -2.696452, 0.384992, -0.616659>,
      < -1.733636, 0.404248, -0.616065>
    }
    triangle {
      < -1.104158, 0.580630, -0.689556>,
      < -1.737189, 0.582797, -0.644135>,
      < -1.733636, 0.404248, -0.616065>
    }
    triangle {
      < -1.104158, 0.580630, -0.689556>,
      < -1.733636, 0.404248, -0.616065>,
      < -1.100900, 0.416959, -0.663826>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.842264, 0.560446, -0.767929>,
      < -1.104158, 0.580630, -0.689556>,
      < -1.100900, 0.416959, -0.663826>
    }
    triangle {
      < -0.842264, 0.560446, -0.767929>,
      < -1.100900, 0.416959, -0.663826>,
      < -0.839515, 0.422283, -0.746208>
    }
    triangle {
      < -0.855880, 0.553820, -0.787570>,
      < -0.842264, 0.560446, -0.767929>,
      < -0.839515, 0.422283, -0.746208>
    }
    triangle {
      < -0.855880, 0.553820, -0.787570>,
      < -0.839515, 0.422283, -0.746208>,
      < -0.853256, 0.422033, -0.766852>
    }
    triangle {
      < -1.103832, 0.565808, -0.735368>,
      < -0.855880, 0.553820, -0.787570>,
      < -0.853256, 0.422033, -0.766852>
    }
    triangle {
      < -1.103832, 0.565808, -0.735368>,
      < -0.853256, 0.422033, -0.766852>,
      < -1.100870, 0.417016, -0.711976>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.530223, 0.557280, -0.735631>,
      < -1.103832, 0.565808, -0.735368>,
      < -1.100870, 0.417016, -0.711976>
    }
    triangle {
      < -1.530223, 0.557280, -0.735631>,
      < -1.100870, 0.417016, -0.711976>,
      < -1.527261, 0.408489, -0.712239>
    }
    triangle {
      < -1.589521, 0.437465, -1.102158>,
      < -1.530223, 0.557280, -0.735631>,
      < -1.527261, 0.408489, -0.712239>
    }
    triangle {
      < -1.589521, 0.437465, -1.102158>,
      < -1.527261, 0.408489, -0.712239>,
      < -1.588928, 0.407707, -1.097480>
    }
    triangle {
      < -1.500117, 0.439253, -1.102103>,
      < -1.589521, 0.437465, -1.102158>,
      < -1.588928, 0.407707, -1.097480>
    }
    triangle {
      < -1.500117, 0.439253, -1.102103>,
      < -1.588928, 0.407707, -1.097480>,
      < -1.499523, 0.409496, -1.097425>
    }
    triangle {
      < -1.424096, 0.423827, -1.154413>,
      < -1.500117, 0.439253, -1.102103>,
      < -1.499523, 0.409496, -1.097425>
    }
    triangle {
      < -1.424096, 0.423827, -1.154413>,
      < -1.499523, 0.409496, -1.097425>,
      < -1.423842, 0.411073, -1.152407>
    }
    triangle {
      < -4.094381, 0.462685, -1.050512>,
      < -3.523652, 0.478138, -1.044591>,
      < -3.522633, 0.426343, -1.018271>
    }
    triangle {
      < -4.094381, 0.462685, -1.050512>,
      < -3.522633, 0.426343, -1.018271>,
      < -4.093400, 0.412809, -1.025168>
    }
    triangle {
      < -4.067377, 0.487451, -1.017078>,
      < -4.094381, 0.462685, -1.050512>,
      < -4.093400, 0.412809, -1.025168>
    }
    triangle {
      < -4.067377, 0.487451, -1.017078>,
      < -4.093400, 0.412809, -1.025168>,
      < -4.066169, 0.426065, -0.985884>
    }
    triangle {
      < -3.551919, 0.513908, -0.994481>,
      < -4.067377, 0.487451, -1.017078>,
      < -4.066169, 0.426065, -0.985884>
    }
    triangle {
      < -3.551919, 0.513908, -0.994481>,
      < -4.066169, 0.426065, -0.985884>,
      < -3.550559, 0.444849, -0.959388>
    }
    triangle {
      < -3.519721, 0.619527, -0.849648>,
      < -3.551919, 0.513908, -0.994481>,
      < -3.550559, 0.444849, -0.959388>
    }
    triangle {
      < -3.519721, 0.619527, -0.849648>,
      < -3.550559, 0.444849, -0.959388>,
      < -3.517379, 0.500590, -0.789211>
    }
    triangle {
      < -3.911893, 0.619758, -0.838750>,
      < -3.519721, 0.619527, -0.849648>,
      < -3.517379, 0.500590, -0.789211>
    }
    triangle {
      < -3.911893, 0.619758, -0.838750>,
      < -3.517379, 0.500590, -0.789211>,
      < -3.909475, 0.496986, -0.776364>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.871050, 0.640762, -0.810877>,
      < -3.911893, 0.619758, -0.838750>,
      < -3.909475, 0.496986, -0.776364>
    }
    triangle {
      < -3.871050, 0.640762, -0.810877>,
      < -3.909475, 0.496986, -0.776364>,
      < -3.868444, 0.508398, -0.743616>
    }
    triangle {
      < -3.198004, 0.698634, -0.749195>,
      < -3.871050, 0.640762, -0.810877>,
      < -3.868444, 0.508398, -0.743616>
    }
    triangle {
      < -3.198004, 0.698634, -0.749195>,
      < -3.868444, 0.508398, -0.743616>,
      < -3.194983, 0.545169, -0.671212>
    }
    triangle {
      < -2.703178, 0.724680, -0.726611>,
      < -3.198004, 0.698634, -0.749195>,
      < -3.194983, 0.545169, -0.671212>
    }
    triangle {
      < -2.703178, 0.724680, -0.726611>,
      < -3.194983, 0.545169, -0.671212>,
      < -2.700005, 0.563541, -0.644729>
    }
    triangle {
      < -1.740361, 0.743937, -0.726018>,
      < -2.703178, 0.724680, -0.726611>,
      < -2.700005, 0.563541, -0.644729>
    }
    triangle {
      < -1.740361, 0.743937, -0.726018>,
      < -2.700005, 0.563541, -0.644729>,
      < -1.737189, 0.582797, -0.644135>
    }
    triangle {
      < -1.107065, 0.728340, -0.764615>,
      < -1.740361, 0.743937, -0.726018>,
      < -1.737189, 0.582797, -0.644135>
    }
    triangle {
      < -1.107065, 0.728340, -0.764615>,
      < -1.737189, 0.582797, -0.644135>,
      < -1.104158, 0.580630, -0.689556>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.844718, 0.685137, -0.831291>,
      < -1.107065, 0.728340, -0.764615>,
      < -1.104158, 0.580630, -0.689556>
    }
    triangle {
      < -0.844718, 0.685137, -0.831291>,
      < -1.104158, 0.580630, -0.689556>,
      < -0.842264, 0.560446, -0.767929>
    }
    triangle {
      < -0.858221, 0.672755, -0.848007>,
      < -0.844718, 0.685137, -0.831291>,
      < -0.842264, 0.560446, -0.767929>
    }
    triangle {
      < -0.858221, 0.672755, -0.848007>,
      < -0.842264, 0.560446, -0.767929>,
      < -0.855880, 0.553820, -0.787570>
    }
    triangle {
      < -1.106476, 0.700089, -0.803603>,
      < -0.858221, 0.672755, -0.848007>,
      < -0.855880, 0.553820, -0.787570>
    }
    triangle {
      < -1.106476, 0.700089, -0.803603>,
      < -0.855880, 0.553820, -0.787570>,
      < -1.103832, 0.565808, -0.735368>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.532866, 0.691562, -0.803866>,
      < -1.106476, 0.700089, -0.803603>,
      < -1.103832, 0.565808, -0.735368>
    }
    triangle {
      < -1.532866, 0.691562, -0.803866>,
      < -1.103832, 0.565808, -0.735368>,
      < -1.530223, 0.557280, -0.735631>
    }
    triangle {
      < -1.590050, 0.464321, -1.115805>,
      < -1.532866, 0.691562, -0.803866>,
      < -1.530223, 0.557280, -0.735631>
    }
    triangle {
      < -1.590050, 0.464321, -1.115805>,
      < -1.530223, 0.557280, -0.735631>,
      < -1.589521, 0.437465, -1.102158>
    }
    triangle {
      < -1.500645, 0.466110, -1.115750>,
      < -1.590050, 0.464321, -1.115805>,
      < -1.589521, 0.437465, -1.102158>
    }
    triangle {
      < -1.500645, 0.466110, -1.115750>,
      < -1.589521, 0.437465, -1.102158>,
      < -1.500117, 0.439253, -1.102103>
    }
    triangle {
      < -1.424322, 0.435336, -1.160261>,
      < -1.500645, 0.466110, -1.115750>,
      < -1.500117, 0.439253, -1.102103>
    }
    triangle {
      < -1.424322, 0.435336, -1.160261>,
      < -1.500117, 0.439253, -1.102103>,
      < -1.424096, 0.423827, -1.154413>
    }
    triangle {
      < -4.095150, 0.502291, -1.090031>,
      < -3.524449, 0.519265, -1.085630>,
      < -3.523652, 0.478138, -1.044591>
    }
    triangle {
      < -4.095150, 0.502291, -1.090031>,
      < -3.523652, 0.478138, -1.044591>,
      < -4.094381, 0.462685, -1.050512>
    }
    triangle {
      < -4.068322, 0.536195, -1.065717>,
      < -4.095150, 0.502291, -1.090031>,
      < -4.094381, 0.462685, -1.050512>
    }
    triangle {
      < -4.068322, 0.536195, -1.065717>,
      < -4.094381, 0.462685, -1.050512>,
      < -4.067377, 0.487451, -1.017078>
    }
    triangle {
      < -3.552983, 0.568747, -1.049200>,
      < -4.068322, 0.536195, -1.065717>,
      < -4.067377, 0.487451, -1.017078>
    }
    triangle {
      < -3.552983, 0.568747, -1.049200>,
      < -4.067377, 0.487451, -1.017078>,
      < -3.551919, 0.513908, -0.994481>
    }
    triangle {
      < -3.521552, 0.713969, -0.943888>,
      < -3.552983, 0.568747, -1.049200>,
      < -3.551919, 0.513908, -0.994481>
    }
    triangle {
      < -3.521552, 0.713969, -0.943888>,
      < -3.551919, 0.513908, -0.994481>,
      < -3.519721, 0.619527, -0.849648>
    }
    triangle {
      < -3.913782, 0.717247, -0.936030>,
      < -3.521552, 0.713969, -0.943888>,
      < -3.519721, 0.619527, -0.849648>
    }
    triangle {
      < -3.913782, 0.717247, -0.936030>,
      < -3.519721, 0.619527, -0.849648>,
      < -3.911893, 0.619758, -0.838750>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.873087, 0.745868, -0.915756>,
      < -3.913782, 0.717247, -0.936030>,
      < -3.911893, 0.619758, -0.838750>
    }
    triangle {
      < -3.873087, 0.745868, -0.915756>,
      < -3.911893, 0.619758, -0.838750>,
      < -3.871050, 0.640762, -0.810877>
    }
    triangle {
      < -3.200366, 0.820496, -0.870793>,
      < -3.873087, 0.745868, -0.915756>,
      < -3.871050, 0.640762, -0.810877>
    }
    triangle {
      < -3.200366, 0.820496, -0.870793>,
      < -3.871050, 0.640762, -0.810877>,
      < -3.198004, 0.698634, -0.749195>
    }
    triangle {
      < -2.705658, 0.852636, -0.854290>,
      < -3.200366, 0.820496, -0.870793>,
      < -3.198004, 0.698634, -0.749195>
    }
    triangle {
      < -2.705658, 0.852636, -0.854290>,
      < -3.198004, 0.698634, -0.749195>,
      < -2.703178, 0.724680, -0.726611>
    }
    triangle {
      < -1.742842, 0.871891, -0.853696>,
      < -2.705658, 0.852636, -0.854290>,
      < -2.703178, 0.724680, -0.726611>
    }
    triangle {
      < -1.742842, 0.871891, -0.853696>,
      < -2.703178, 0.724680, -0.726611>,
      < -1.740361, 0.743937, -0.726018>
    }
    triangle {
      < -1.109339, 0.845632, -0.881653>,
      < -1.742842, 0.871891, -0.853696>,
      < -1.740361, 0.743937, -0.726018>
    }
    triangle {
      < -1.109339, 0.845632, -0.881653>,
      < -1.740361, 0.743937, -0.726018>,
      < -1.107065, 0.728340, -0.764615>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.846638, 0.784149, -0.930089>,
      < -1.109339, 0.845632, -0.881653>,
      < -1.107065, 0.728340, -0.764615>
    }
    triangle {
      < -0.846638, 0.784149, -0.930089>,
      < -1.107065, 0.728340, -0.764615>,
      < -0.844718, 0.685137, -0.831291>
    }
    triangle {
      < -0.860052, 0.767197, -0.942247>,
      < -0.846638, 0.784149, -0.930089>,
      < -0.844718, 0.685137, -0.831291>
    }
    triangle {
      < -0.860052, 0.767197, -0.942247>,
      < -0.844718, 0.685137, -0.831291>,
      < -0.858221, 0.672755, -0.848007>
    }
    triangle {
      < -1.108542, 0.806718, -0.910001>,
      < -0.860052, 0.767197, -0.942247>,
      < -0.858221, 0.672755, -0.848007>
    }
    triangle {
      < -1.108542, 0.806718, -0.910001>,
      < -0.858221, 0.672755, -0.848007>,
      < -1.106476, 0.700089, -0.803603>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.534933, 0.798191, -0.910264>,
      < -1.108542, 0.806718, -0.910001>,
      < -1.106476, 0.700089, -0.803603>
    }
    triangle {
      < -1.534933, 0.798191, -0.910264>,
      < -1.106476, 0.700089, -0.803603>,
      < -1.532866, 0.691562, -0.803866>
    }
    triangle {
      < -1.590463, 0.485647, -1.137085>,
      < -1.534933, 0.798191, -0.910264>,
      < -1.532866, 0.691562, -0.803866>
    }
    triangle {
      < -1.590463, 0.485647, -1.137085>,
      < -1.532866, 0.691562, -0.803866>,
      < -1.590050, 0.464321, -1.115805>
    }
    triangle {
      < -1.501058, 0.487435, -1.137030>,
      < -1.590463, 0.485647, -1.137085>,
      < -1.590050, 0.464321, -1.115805>
    }
    triangle {
      < -1.501058, 0.487435, -1.137030>,
      < -1.590050, 0.464321, -1.115805>,
      < -1.500645, 0.466110, -1.115750>
    }
    triangle {
      < -1.424499, 0.444476, -1.169381>,
      < -1.501058, 0.487435, -1.137030>,
      < -1.500645, 0.466110, -1.115750>
    }
    triangle {
      < -1.424499, 0.444476, -1.169381>,
      < -1.500645, 0.466110, -1.115750>,
      < -1.424322, 0.435336, -1.160261>
    }
    triangle {
      < -4.095627, 0.527748, -1.139858>,
      < -3.524945, 0.545701, -1.137373>,
      < -3.524449, 0.519265, -1.085630>
    }
    triangle {
      < -4.095627, 0.527748, -1.139858>,
      < -3.524449, 0.519265, -1.085630>,
      < -4.095150, 0.502291, -1.090031>
    }
    triangle {
      < -4.068911, 0.567527, -1.127042>,
      < -4.095627, 0.527748, -1.139858>,
      < -4.095150, 0.502291, -1.090031>
    }
    triangle {
      < -4.068911, 0.567527, -1.127042>,
      < -4.095150, 0.502291, -1.090031>,
      < -4.068322, 0.536195, -1.065717>
    }
    triangle {
      < -3.553645, 0.603994, -1.118190>,
      < -4.068911, 0.567527, -1.127042>,
      < -4.068322, 0.536195, -1.065717>
    }
    triangle {
      < -3.553645, 0.603994, -1.118190>,
      < -4.068322, 0.536195, -1.065717>,
      < -3.552983, 0.568747, -1.049200>
    }
    triangle {
      < -3.522692, 0.774674, -1.062703>,
      < -3.553645, 0.603994, -1.118190>,
      < -3.552983, 0.568747, -1.049200>
    }
    triangle {
      < -3.522692, 0.774674, -1.062703>,
      < -3.552983, 0.568747, -1.049200>,
      < -3.521552, 0.713969, -0.943888>
    }
    triangle {
      < -3.914959, 0.779910, -1.058679>,
      < -3.522692, 0.774674, -1.062703>,
      < -3.521552, 0.713969, -0.943888>
    }
    triangle {
      < -3.914959, 0.779910, -1.058679>,
      < -3.521552, 0.713969, -0.943888>,
      < -3.913782, 0.717247, -0.936030>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.874357, 0.813426, -1.047986>,
      < -3.914959, 0.779910, -1.058679>,
      < -3.913782, 0.717247, -0.936030>
    }
    triangle {
      < -3.874357, 0.813426, -1.047986>,
      < -3.913782, 0.717247, -0.936030>,
      < -3.873087, 0.745868, -0.915756>
    }
    triangle {
      < -3.201838, 0.898825, -1.024106>,
      < -3.874357, 0.813426, -1.047986>,
      < -3.873087, 0.745868, -0.915756>
    }
    triangle {
      < -3.201838, 0.898825, -1.024106>,
      < -3.873087, 0.745868, -0.915756>,
      < -3.200366, 0.820496, -0.870793>
    }
    triangle {
      < -2.707204, 0.934881, -1.015267>,
      < -3.201838, 0.898825, -1.024106>,
      < -3.200366, 0.820496, -0.870793>
    }
    triangle {
      < -2.707204, 0.934881, -1.015267>,
      < -3.200366, 0.820496, -0.870793>,
      < -2.705658, 0.852636, -0.854290>
    }
    triangle {
      < -1.744388, 0.954136, -1.014673>,
      < -2.707204, 0.934881, -1.015267>,
      < -2.705658, 0.852636, -0.854290>
    }
    triangle {
      < -1.744388, 0.954136, -1.014673>,
      < -2.705658, 0.852636, -0.854290>,
      < -1.742842, 0.871891, -0.853696>
    }
    triangle {
      < -1.110756, 0.921024, -1.029217>,
      < -1.744388, 0.954136, -1.014673>,
      < -1.742842, 0.871891, -0.853696>
    }
    triangle {
      < -1.110756, 0.921024, -1.029217>,
      < -1.742842, 0.871891, -0.853696>,
      < -1.109339, 0.845632, -0.881653>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.847834, 0.847792, -1.054655>,
      < -1.110756, 0.921024, -1.029217>,
      < -1.109339, 0.845632, -0.881653>
    }
    triangle {
      < -0.847834, 0.847792, -1.054655>,
      < -1.109339, 0.845632, -0.881653>,
      < -0.846638, 0.784149, -0.930089>
    }
    triangle {
      < -0.861192, 0.827903, -1.061063>,
      < -0.847834, 0.847792, -1.054655>,
      < -0.846638, 0.784149, -0.930089>
    }
    triangle {
      < -0.861192, 0.827903, -1.061063>,
      < -0.846638, 0.784149, -0.930089>,
      < -0.860052, 0.767197, -0.942247>
    }
    triangle {
      < -1.109831, 0.875257, -1.044150>,
      < -0.861192, 0.827903, -1.061063>,
      < -0.860052, 0.767197, -0.942247>
    }
    triangle {
      < -1.109831, 0.875257, -1.044150>,
      < -0.860052, 0.767197, -0.942247>,
      < -1.108542, 0.806718, -0.910001>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.536221, 0.866730, -1.044413>,
      < -1.109831, 0.875257, -1.044150>,
      < -1.108542, 0.806718, -0.910001>
    }
    triangle {
      < -1.536221, 0.866730, -1.044413>,
      < -1.108542, 0.806718, -0.910001>,
      < -1.534933, 0.798191, -0.910264>
    }
    triangle {
      < -1.590720, 0.499356, -1.163915>,
      < -1.536221, 0.866730, -1.044413>,
      < -1.534933, 0.798191, -0.910264>
    }
    triangle {
      < -1.590720, 0.499356, -1.163915>,
      < -1.534933, 0.798191, -0.910264>,
      < -1.590463, 0.485647, -1.137085>
    }
    triangle {
      < -1.501316, 0.501144, -1.163860>,
      < -1.590720, 0.499356, -1.163915>,
      < -1.590463, 0.485647, -1.137085>
    }
    triangle {
      < -1.501316, 0.501144, -1.163860>,
      < -1.590463, 0.485647, -1.137085>,
      < -1.501058, 0.487435, -1.137030>
    }
    triangle {
      < -1.424610, 0.450351, -1.180879>,
      < -1.501316, 0.501144, -1.163860>,
      < -1.501058, 0.487435, -1.137030>
    }
    triangle {
      < -1.424610, 0.450351, -1.180879>,
      < -1.501058, 0.487435, -1.137030>,
      < -1.424499, 0.444476, -1.169381>
    }
    triangle {
      < -4.095768, 0.536565, -1.195113>,
      < -3.525094, 0.554857, -1.194754>,
      < -3.524945, 0.545701, -1.137373>
    }
    triangle {
      < -4.095768, 0.536565, -1.195113>,
      < -3.524945, 0.545701, -1.137373>,
      < -4.095627, 0.527748, -1.139858>
    }
    triangle {
      < -4.069087, 0.578378, -1.195049>,
      < -4.095768, 0.536565, -1.195113>,
      < -4.095627, 0.527748, -1.139858>
    }
    triangle {
      < -4.069087, 0.578378, -1.195049>,
      < -4.095627, 0.527748, -1.139858>,
      < -4.068911, 0.567527, -1.127042>
    }
    triangle {
      < -3.553841, 0.616203, -1.194699>,
      < -4.069087, 0.578378, -1.195049>,
      < -4.068911, 0.567527, -1.127042>
    }
    triangle {
      < -3.553841, 0.616203, -1.194699>,
      < -4.068911, 0.567527, -1.127042>,
      < -3.553645, 0.603994, -1.118190>
    }
    triangle {
      < -3.523032, 0.795700, -1.194467>,
      < -3.553841, 0.616203, -1.194699>,
      < -3.553645, 0.603994, -1.118190>
    }
    triangle {
      < -3.523032, 0.795700, -1.194467>,
      < -3.553645, 0.603994, -1.118190>,
      < -3.522692, 0.774674, -1.062703>
    }
    triangle {
      < -3.915311, 0.801614, -1.194692>,
      < -3.523032, 0.795700, -1.194467>,
      < -3.522692, 0.774674, -1.062703>
    }
    triangle {
      < -3.915311, 0.801614, -1.194692>,
      < -3.522692, 0.774674, -1.062703>,
      < -3.914959, 0.779910, -1.058679>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.874734, 0.836825, -1.194627>,
      < -3.915311, 0.801614, -1.194692>,
      < -3.914959, 0.779910, -1.058679>
    }
    triangle {
      < -3.874734, 0.836825, -1.194627>,
      < -3.914959, 0.779910, -1.058679>,
      < -3.874357, 0.813426, -1.047986>
    }
    triangle {
      < -3.202275, 0.925954, -1.194123>,
      < -3.874734, 0.836825, -1.194627>,
      < -3.874357, 0.813426, -1.047986>
    }
    triangle {
      < -3.202275, 0.925954, -1.194123>,
      < -3.874357, 0.813426, -1.047986>,
      < -3.201838, 0.898825, -1.024106>
    }
    triangle {
      < -2.707664, 0.963366, -1.193785>,
      < -3.202275, 0.925954, -1.194123>,
      < -3.201838, 0.898825, -1.024106>
    }
    triangle {
      < -2.707664, 0.963366, -1.193785>,
      < -3.201838, 0.898825, -1.024106>,
      < -2.707204, 0.934881, -1.015267>
    }
    triangle {
      < -1.744848, 0.982622, -1.193192>,
      < -2.707664, 0.963366, -1.193785>,
      < -2.707204, 0.934881, -1.015267>
    }
    triangle {
      < -1.744848, 0.982622, -1.193192>,
      < -2.707204, 0.934881, -1.015267>,
      < -1.744388, 0.954136, -1.014673>
    }
    triangle {
      < -1.111177, 0.947136, -1.192858>,
      < -1.744848, 0.982622, -1.193192>,
      < -1.744388, 0.954136, -1.014673>
    }
    triangle {
      < -1.111177, 0.947136, -1.192858>,
      < -1.744388, 0.954136, -1.014673>,
      < -1.110756, 0.921024, -1.029217>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.848190, 0.869835, -1.192795>,
      < -1.111177, 0.947136, -1.192858>,
      < -1.110756, 0.921024, -1.029217>
    }
    triangle {
      < -0.848190, 0.869835, -1.192795>,
      < -1.110756, 0.921024, -1.029217>,
      < -0.847834, 0.847792, -1.054655>
    }
    triangle {
      < -0.861532, 0.848928, -1.192827>,
      < -0.848190, 0.869835, -1.192795>,
      < -0.847834, 0.847792, -1.054655>
    }
    triangle {
      < -0.861532, 0.848928, -1.192827>,
      < -0.847834, 0.847792, -1.054655>,
      < -0.861192, 0.827903, -1.061063>
    }
    triangle {
      < -1.110214, 0.898994, -1.192914>,
      < -0.861532, 0.848928, -1.192827>,
      < -0.861192, 0.827903, -1.061063>
    }
    triangle {
      < -1.110214, 0.898994, -1.192914>,
      < -0.861192, 0.827903, -1.061063>,
      < -1.109831, 0.875257, -1.044150>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.536604, 0.890467, -1.193178>,
      < -1.110214, 0.898994, -1.192914>,
      < -1.109831, 0.875257, -1.044150>
    }
    triangle {
      < -1.536604, 0.890467, -1.193178>,
      < -1.109831, 0.875257, -1.044150>,
      < -1.536221, 0.866730, -1.044413>
    }
    triangle {
      < -1.590797, 0.504102, -1.193667>,
      < -1.536604, 0.890467, -1.193178>,
      < -1.536221, 0.866730, -1.044413>
    }
    triangle {
      < -1.590797, 0.504102, -1.193667>,
      < -1.536221, 0.866730, -1.044413>,
      < -1.590720, 0.499356, -1.163915>
    }
    triangle {
      < -1.501393, 0.505891, -1.193612>,
      < -1.590797, 0.504102, -1.193667>,
      < -1.590720, 0.499356, -1.163915>
    }
    triangle {
      < -1.501393, 0.505891, -1.193612>,
      < -1.590720, 0.499356, -1.163915>,
      < -1.501316, 0.501144, -1.163860>
    }
    triangle {
      < -1.424643, 0.452386, -1.193630>,
      < -1.501393, 0.505891, -1.193612>,
      < -1.501316, 0.501144, -1.163860>
    }
    triangle {
      < -1.424643, 0.452386, -1.193630>,
      < -1.501316, 0.501144, -1.163860>,
      < -1.424610, 0.450351, -1.180879>
    }
    triangle {
      < -4.095562, 0.527879, -1.250390>,
      < -3.524878, 0.545838, -1.252156>,
      < -3.525094, 0.554857, -1.194754>
    }
    triangle {
      < -4.095562, 0.527879, -1.250390>,
      < -3.525094, 0.554857, -1.194754>,
      < -4.095768, 0.536565, -1.195113>
    }
    triangle {
      < -4.068830, 0.567688, -1.263080>,
      < -4.095562, 0.527879, -1.250390>,
      < -4.095768, 0.536565, -1.195113>
    }
    triangle {
      < -4.068830, 0.567688, -1.263080>,
      < -4.095768, 0.536565, -1.195113>,
      < -4.069087, 0.578378, -1.195049>
    }
    triangle {
      < -3.553554, 0.604176, -1.271234>,
      < -4.068830, 0.567688, -1.263080>,
      < -4.069087, 0.578378, -1.195049>
    }
    triangle {
      < -3.553554, 0.604176, -1.271234>,
      < -4.069087, 0.578378, -1.195049>,
      < -3.553841, 0.616203, -1.194699>
    }
    triangle {
      < -3.522536, 0.774987, -1.326280>,
      < -3.553554, 0.604176, -1.271234>,
      < -3.553841, 0.616203, -1.194699>
    }
    triangle {
      < -3.522536, 0.774987, -1.326280>,
      < -3.553841, 0.616203, -1.194699>,
      < -3.523032, 0.795700, -1.194467>
    }
    triangle {
      < -3.914798, 0.780233, -1.330757>,
      < -3.522536, 0.774987, -1.326280>,
      < -3.523032, 0.795700, -1.194467>
    }
    triangle {
      < -3.914798, 0.780233, -1.330757>,
      < -3.523032, 0.795700, -1.194467>,
      < -3.915311, 0.801614, -1.194692>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.874183, 0.813775, -1.341321>,
      < -3.914798, 0.780233, -1.330757>,
      < -3.915311, 0.801614, -1.194692>
    }
    triangle {
      < -3.874183, 0.813775, -1.341321>,
      < -3.915311, 0.801614, -1.194692>,
      < -3.874734, 0.836825, -1.194627>
    }
    triangle {
      < -3.201637, 0.899228, -1.364203>,
      < -3.874183, 0.813775, -1.341321>,
      < -3.874734, 0.836825, -1.194627>
    }
    triangle {
      < -3.201637, 0.899228, -1.364203>,
      < -3.874734, 0.836825, -1.194627>,
      < -3.202275, 0.925954, -1.194123>
    }
    triangle {
      < -2.706992, 0.935304, -1.372370>,
      < -3.201637, 0.899228, -1.364203>,
      < -3.202275, 0.925954, -1.194123>
    }
    triangle {
      < -2.706992, 0.935304, -1.372370>,
      < -3.202275, 0.925954, -1.194123>,
      < -2.707664, 0.963366, -1.193785>
    }
    triangle {
      < -1.744176, 0.954560, -1.371776>,
      < -2.706992, 0.935304, -1.372370>,
      < -2.707664, 0.963366, -1.193785>
    }
    triangle {
      < -1.744176, 0.954560, -1.371776>,
      < -2.707664, 0.963366, -1.193785>,
      < -1.744848, 0.982622, -1.193192>
    }
    triangle {
      < -1.110562, 0.921412, -1.356561>,
      < -1.744176, 0.954560, -1.371776>,
      < -1.744848, 0.982622, -1.193192>
    }
    triangle {
      < -1.110562, 0.921412, -1.356561>,
      < -1.744848, 0.982622, -1.193192>,
      < -1.111177, 0.947136, -1.192858>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.847670, 0.848120, -1.330984>,
      < -1.110562, 0.921412, -1.356561>,
      < -1.111177, 0.947136, -1.192858>
    }
    triangle {
      < -0.847670, 0.848120, -1.330984>,
      < -1.111177, 0.947136, -1.192858>,
      < -0.848190, 0.869835, -1.192795>
    }
    triangle {
      < -0.861036, 0.828215, -1.324639>,
      < -0.847670, 0.848120, -1.330984>,
      < -0.848190, 0.869835, -1.192795>
    }
    triangle {
      < -0.861036, 0.828215, -1.324639>,
      < -0.848190, 0.869835, -1.192795>,
      < -0.861532, 0.848928, -1.192827>
    }
    triangle {
      < -1.109654, 0.875609, -1.341735>,
      < -0.861036, 0.828215, -1.324639>,
      < -0.861532, 0.848928, -1.192827>
    }
    triangle {
      < -1.109654, 0.875609, -1.341735>,
      < -0.861532, 0.848928, -1.192827>,
      < -1.110214, 0.898994, -1.192914>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.536045, 0.867082, -1.341998>,
      < -1.109654, 0.875609, -1.341735>,
      < -1.110214, 0.898994, -1.192914>
    }
    triangle {
      < -1.536045, 0.867082, -1.341998>,
      < -1.110214, 0.898994, -1.192914>,
      < -1.536604, 0.890467, -1.193178>
    }
    triangle {
      < -1.590685, 0.499426, -1.223432>,
      < -1.536045, 0.867082, -1.341998>,
      < -1.536604, 0.890467, -1.193178>
    }
    triangle {
      < -1.590685, 0.499426, -1.223432>,
      < -1.536604, 0.890467, -1.193178>,
      < -1.590797, 0.504102, -1.193667>
    }
    triangle {
      < -1.501280, 0.501214, -1.223377>,
      < -1.590685, 0.499426, -1.223432>,
      < -1.590797, 0.504102, -1.193667>
    }
    triangle {
      < -1.501280, 0.501214, -1.223377>,
      < -1.590797, 0.504102, -1.193667>,
      < -1.501393, 0.505891, -1.193612>
    }
    triangle {
      < -1.424595, 0.450381, -1.206387>,
      < -1.501280, 0.501214, -1.223377>,
      < -1.501393, 0.505891, -1.193612>
    }
    triangle {
      < -1.424595, 0.450381, -1.206387>,
      < -1.501393, 0.505891, -1.193612>,
      < -1.424643, 0.452386, -1.193630>
    }
    triangle {
      < -4.095025, 0.502539, -1.300276>,
      < -3.524320, 0.519525, -1.303960>,
      < -3.524878, 0.545838, -1.252156>
    }
    triangle {
      < -4.095025, 0.502539, -1.300276>,
      < -3.524878, 0.545838, -1.252156>,
      < -4.095562, 0.527879, -1.250390>
    }
    triangle {
      < -4.068168, 0.536502, -1.324478>,
      < -4.095025, 0.502539, -1.300276>,
      < -4.095562, 0.527879, -1.250390>
    }
    triangle {
      < -4.068168, 0.536502, -1.324478>,
      < -4.095562, 0.527879, -1.250390>,
      < -4.068830, 0.567688, -1.263080>
    }
    triangle {
      < -3.552810, 0.569092, -1.340307>,
      < -4.068168, 0.536502, -1.324478>,
      < -4.068830, 0.567688, -1.263080>
    }
    triangle {
      < -3.552810, 0.569092, -1.340307>,
      < -4.068830, 0.567688, -1.263080>,
      < -3.553554, 0.604176, -1.271234>
    }
    triangle {
      < -3.521255, 0.714563, -1.445238>,
      < -3.552810, 0.569092, -1.340307>,
      < -3.553554, 0.604176, -1.271234>
    }
    triangle {
      < -3.521255, 0.714563, -1.445238>,
      < -3.553554, 0.604176, -1.271234>,
      < -3.522536, 0.774987, -1.326280>
    }
    triangle {
      < -3.913476, 0.717861, -1.453554>,
      < -3.521255, 0.714563, -1.445238>,
      < -3.522536, 0.774987, -1.326280>
    }
    triangle {
      < -3.913476, 0.717861, -1.453554>,
      < -3.522536, 0.774987, -1.326280>,
      < -3.914798, 0.780233, -1.330757>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.872757, 0.746529, -1.473711>,
      < -3.913476, 0.717861, -1.453554>,
      < -3.914798, 0.780233, -1.330757>
    }
    triangle {
      < -3.872757, 0.746529, -1.473711>,
      < -3.914798, 0.780233, -1.330757>,
      < -3.874183, 0.813775, -1.341321>
    }
    triangle {
      < -3.199982, 0.821263, -1.517698>,
      < -3.872757, 0.746529, -1.473711>,
      < -3.874183, 0.813775, -1.341321>
    }
    triangle {
      < -3.199982, 0.821263, -1.517698>,
      < -3.874183, 0.813775, -1.341321>,
      < -3.201637, 0.899228, -1.364203>
    }
    triangle {
      < -2.705255, 0.853440, -1.533540>,
      < -3.199982, 0.821263, -1.517698>,
      < -3.201637, 0.899228, -1.364203>
    }
    triangle {
      < -2.705255, 0.853440, -1.533540>,
      < -3.201637, 0.899228, -1.364203>,
      < -2.706992, 0.935304, -1.372370>
    }
    triangle {
      < -1.742440, 0.872696, -1.532946>,
      < -2.705255, 0.853440, -1.533540>,
      < -2.706992, 0.935304, -1.372370>
    }
    triangle {
      < -1.742440, 0.872696, -1.532946>,
      < -2.706992, 0.935304, -1.372370>,
      < -1.744176, 0.954560, -1.371776>
    }
    triangle {
      < -1.108970, 0.846369, -1.504300>,
      < -1.742440, 0.872696, -1.532946>,
      < -1.744176, 0.954560, -1.371776>
    }
    triangle {
      < -1.108970, 0.846369, -1.504300>,
      < -1.744176, 0.954560, -1.371776>,
      < -1.110562, 0.921412, -1.356561>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.846326, 0.784772, -1.455699>,
      < -1.108970, 0.846369, -1.504300>,
      < -1.110562, 0.921412, -1.356561>
    }
    triangle {
      < -0.846326, 0.784772, -1.455699>,
      < -1.110562, 0.921412, -1.356561>,
      < -0.847670, 0.848120, -1.330984>
    }
    triangle {
      < -0.859755, 0.767792, -1.443599>,
      < -0.846326, 0.784772, -1.455699>,
      < -0.847670, 0.848120, -1.330984>
    }
    triangle {
      < -0.859755, 0.767792, -1.443599>,
      < -0.847670, 0.848120, -1.330984>,
      < -0.861036, 0.828215, -1.324639>
    }
    triangle {
      < -1.108207, 0.807389, -1.476044>,
      < -0.859755, 0.767792, -1.443599>,
      < -0.861036, 0.828215, -1.324639>
    }
    triangle {
      < -1.108207, 0.807389, -1.476044>,
      < -0.861036, 0.828215, -1.324639>,
      < -1.109654, 0.875609, -1.341735>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.534598, 0.798862, -1.476306>,
      < -1.108207, 0.807389, -1.476044>,
      < -1.109654, 0.875609, -1.341735>
    }
    triangle {
      < -1.534598, 0.798862, -1.476306>,
      < -1.109654, 0.875609, -1.341735>,
      < -1.536045, 0.867082, -1.341998>
    }
    triangle {
      < -1.590396, 0.485782, -1.250293>,
      < -1.534598, 0.798862, -1.476306>,
      < -1.536045, 0.867082, -1.341998>
    }
    triangle {
      < -1.590396, 0.485782, -1.250293>,
      < -1.536045, 0.867082, -1.341998>,
      < -1.590685, 0.499426, -1.223432>
    }
    triangle {
      < -1.500991, 0.487569, -1.250238>,
      < -1.590396, 0.485782, -1.250293>,
      < -1.590685, 0.499426, -1.223432>
    }
    triangle {
      < -1.500991, 0.487569, -1.250238>,
      < -1.590685, 0.499426, -1.223432>,
      < -1.501280, 0.501214, -1.223377>
    }
    triangle {
      < -1.424470, 0.444534, -1.217898>,
      < -1.500991, 0.487569, -1.250238>,
      < -1.501280, 0.501214, -1.223377>
    }
    triangle {
      < -1.424470, 0.444534, -1.217898>,
      < -1.501280, 0.501214, -1.223377>,
      < -1.424595, 0.450381, -1.206387>
    }
    triangle {
      < -4.094209, 0.463029, -1.339888>,
      < -3.523474, 0.478493, -1.345097>,
      < -3.524320, 0.519525, -1.303960>
    }
    triangle {
      < -4.094209, 0.463029, -1.339888>,
      < -3.524320, 0.519525, -1.303960>,
      < -4.095025, 0.502539, -1.300276>
    }
    triangle {
      < -4.067166, 0.487872, -1.373232>,
      < -4.094209, 0.463029, -1.339888>,
      < -4.095025, 0.502539, -1.300276>
    }
    triangle {
      < -4.067166, 0.487872, -1.373232>,
      < -4.095025, 0.502539, -1.300276>,
      < -4.068168, 0.536502, -1.324478>
    }
    triangle {
      < -3.551681, 0.514384, -1.395155>,
      < -4.067166, 0.487872, -1.373232>,
      < -4.068168, 0.536502, -1.324478>
    }
    triangle {
      < -3.551681, 0.514384, -1.395155>,
      < -4.068168, 0.536502, -1.324478>,
      < -3.552810, 0.569092, -1.340307>
    }
    triangle {
      < -3.519312, 0.620344, -1.539699>,
      < -3.551681, 0.514384, -1.395155>,
      < -3.552810, 0.569092, -1.340307>
    }
    triangle {
      < -3.519312, 0.620344, -1.539699>,
      < -3.552810, 0.569092, -1.340307>,
      < -3.521255, 0.714563, -1.445238>
    }
    triangle {
      < -3.911471, 0.620602, -1.551061>,
      < -3.519312, 0.620344, -1.539699>,
      < -3.521255, 0.714563, -1.445238>
    }
    triangle {
      < -3.911471, 0.620602, -1.551061>,
      < -3.521255, 0.714563, -1.445238>,
      < -3.913476, 0.717861, -1.453554>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.870595, 0.641672, -1.578836>,
      < -3.911471, 0.620602, -1.551061>,
      < -3.913476, 0.717861, -1.453554>
    }
    triangle {
      < -3.870595, 0.641672, -1.578836>,
      < -3.913476, 0.717861, -1.453554>,
      < -3.872757, 0.746529, -1.473711>
    }
    triangle {
      < -3.197476, 0.699690, -1.639584>,
      < -3.870595, 0.641672, -1.578836>,
      < -3.872757, 0.746529, -1.473711>
    }
    triangle {
      < -3.197476, 0.699690, -1.639584>,
      < -3.872757, 0.746529, -1.473711>,
      < -3.199982, 0.821263, -1.517698>
    }
    triangle {
      < -2.702624, 0.725789, -1.661518>,
      < -3.197476, 0.699690, -1.639584>,
      < -3.199982, 0.821263, -1.517698>
    }
    triangle {
      < -2.702624, 0.725789, -1.661518>,
      < -3.199982, 0.821263, -1.517698>,
      < -2.705255, 0.853440, -1.533540>
    }
    triangle {
      < -1.739807, 0.745044, -1.660925>,
      < -2.702624, 0.725789, -1.661518>,
      < -2.705255, 0.853440, -1.533540>
    }
    triangle {
      < -1.739807, 0.745044, -1.660925>,
      < -2.705255, 0.853440, -1.533540>,
      < -1.742440, 0.872696, -1.532946>
    }
    triangle {
      < -1.106557, 0.729356, -1.621614>,
      < -1.739807, 0.745044, -1.660925>,
      < -1.742440, 0.872696, -1.532946>
    }
    triangle {
      < -1.106557, 0.729356, -1.621614>,
      < -1.742440, 0.872696, -1.532946>,
      < -1.108970, 0.846369, -1.504300>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.844290, 0.685995, -1.554731>,
      < -1.106557, 0.729356, -1.621614>,
      < -1.108970, 0.846369, -1.504300>
    }
    triangle {
      < -0.844290, 0.685995, -1.554731>,
      < -1.108970, 0.846369, -1.504300>,
      < -0.846326, 0.784772, -1.455699>
    }
    triangle {
      < -0.857812, 0.673572, -1.538059>,
      < -0.844290, 0.685995, -1.554731>,
      < -0.846326, 0.784772, -1.455699>
    }
    triangle {
      < -0.857812, 0.673572, -1.538059>,
      < -0.846326, 0.784772, -1.455699>,
      < -0.859755, 0.767792, -1.443599>
    }
    triangle {
      < -1.106014, 0.701013, -1.582693>,
      < -0.857812, 0.673572, -1.538059>,
      < -0.859755, 0.767792, -1.443599>
    }
    triangle {
      < -1.106014, 0.701013, -1.582693>,
      < -0.859755, 0.767792, -1.443599>,
      < -1.108207, 0.807389, -1.476044>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.532405, 0.692485, -1.582956>,
      < -1.106014, 0.701013, -1.582693>,
      < -1.108207, 0.807389, -1.476044>
    }
    triangle {
      < -1.532405, 0.692485, -1.582956>,
      < -1.108207, 0.807389, -1.476044>,
      < -1.534598, 0.798862, -1.476306>
    }
    triangle {
      < -1.589958, 0.464506, -1.271623>,
      < -1.532405, 0.692485, -1.582956>,
      < -1.534598, 0.798862, -1.476306>
    }
    triangle {
      < -1.589958, 0.464506, -1.271623>,
      < -1.534598, 0.798862, -1.476306>,
      < -1.590396, 0.485782, -1.250293>
    }
    triangle {
      < -1.500553, 0.466294, -1.271568>,
      < -1.589958, 0.464506, -1.271623>,
      < -1.590396, 0.485782, -1.250293>
    }
    triangle {
      < -1.500553, 0.466294, -1.271568>,
      < -1.590396, 0.485782, -1.250293>,
      < -1.500991, 0.487569, -1.250238>
    }
    triangle {
      < -1.424283, 0.435416, -1.227040>,
      < -1.500553, 0.466294, -1.271568>,
      < -1.500991, 0.487569, -1.250238>
    }
    triangle {
      < -1.424283, 0.435416, -1.227040>,
      < -1.500991, 0.487569, -1.250238>,
      < -1.424470, 0.444534, -1.217898>
    }
    triangle {
      < -4.093198, 0.413213, -1.365349>,
      < -3.522424, 0.426762, -1.371537>,
      < -3.523474, 0.478493, -1.345097>
    }
    triangle {
      < -4.093198, 0.413213, -1.365349>,
      < -3.523474, 0.478493, -1.345097>,
      < -4.094209, 0.463029, -1.339888>
    }
    triangle {
      < -4.065921, 0.426561, -1.404569>,
      < -4.093198, 0.413213, -1.365349>,
      < -4.094209, 0.463029, -1.339888>
    }
    triangle {
      < -4.065921, 0.426561, -1.404569>,
      < -4.094209, 0.463029, -1.339888>,
      < -4.067166, 0.487872, -1.373232>
    }
    triangle {
      < -3.550280, 0.445408, -1.430409>,
      < -4.065921, 0.426561, -1.404569>,
      < -4.067166, 0.487872, -1.373232>
    }
    triangle {
      < -3.550280, 0.445408, -1.430409>,
      < -4.067166, 0.487872, -1.373232>,
      < -3.551681, 0.514384, -1.395155>
    }
    triangle {
      < -3.516898, 0.501552, -1.600414>,
      < -3.550280, 0.445408, -1.430409>,
      < -3.551681, 0.514384, -1.395155>
    }
    triangle {
      < -3.516898, 0.501552, -1.600414>,
      < -3.551681, 0.514384, -1.395155>,
      < -3.519312, 0.620344, -1.539699>
    }
    triangle {
      < -3.908979, 0.497978, -1.613735>,
      < -3.516898, 0.501552, -1.600414>,
      < -3.519312, 0.620344, -1.539699>
    }
    triangle {
      < -3.908979, 0.497978, -1.613735>,
      < -3.519312, 0.620344, -1.539699>,
      < -3.911471, 0.620602, -1.551061>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.867909, 0.509468, -1.646407>,
      < -3.908979, 0.497978, -1.613735>,
      < -3.911471, 0.620602, -1.551061>
    }
    triangle {
      < -3.867909, 0.509468, -1.646407>,
      < -3.911471, 0.620602, -1.551061>,
      < -3.870595, 0.641672, -1.578836>
    }
    triangle {
      < -3.194362, 0.546410, -1.717926>,
      < -3.867909, 0.509468, -1.646407>,
      < -3.870595, 0.641672, -1.578836>
    }
    triangle {
      < -3.194362, 0.546410, -1.717926>,
      < -3.870595, 0.641672, -1.578836>,
      < -3.197476, 0.699690, -1.639584>
    }
    triangle {
      < -2.699354, 0.564845, -1.743778>,
      < -3.194362, 0.546410, -1.717926>,
      < -3.197476, 0.699690, -1.639584>
    }
    triangle {
      < -2.699354, 0.564845, -1.743778>,
      < -3.197476, 0.699690, -1.639584>,
      < -2.702624, 0.725789, -1.661518>
    }
    triangle {
      < -1.736537, 0.584100, -1.743185>,
      < -2.699354, 0.564845, -1.743778>,
      < -2.702624, 0.725789, -1.661518>
    }
    triangle {
      < -1.736537, 0.584100, -1.743185>,
      < -2.702624, 0.725789, -1.661518>,
      < -1.739807, 0.745044, -1.660925>
    }
    triangle {
      < -1.103561, 0.581824, -1.697019>,
      < -1.736537, 0.584100, -1.743185>,
      < -1.739807, 0.745044, -1.660925>
    }
    triangle {
      < -1.103561, 0.581824, -1.697019>,
      < -1.739807, 0.745044, -1.660925>,
      < -1.106557, 0.729356, -1.621614>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.841760, 0.561454, -1.618385>,
      < -1.103561, 0.581824, -1.697019>,
      < -1.106557, 0.729356, -1.621614>
    }
    triangle {
      < -0.841760, 0.561454, -1.618385>,
      < -1.106557, 0.729356, -1.621614>,
      < -0.844290, 0.685995, -1.554731>
    }
    triangle {
      < -0.855399, 0.554781, -1.598774>,
      < -0.841760, 0.561454, -1.618385>,
      < -0.844290, 0.685995, -1.554731>
    }
    triangle {
      < -0.855399, 0.554781, -1.598774>,
      < -0.844290, 0.685995, -1.554731>,
      < -0.857812, 0.673572, -1.538059>
    }
    triangle {
      < -1.103289, 0.566893, -1.651243>,
      < -0.855399, 0.554781, -1.598774>,
      < -0.857812, 0.673572, -1.538059>
    }
    triangle {
      < -1.103289, 0.566893, -1.651243>,
      < -0.857812, 0.673572, -1.538059>,
      < -1.106014, 0.701013, -1.582693>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.529680, 0.558365, -1.651506>,
      < -1.103289, 0.566893, -1.651243>,
      < -1.106014, 0.701013, -1.582693>
    }
    triangle {
      < -1.529680, 0.558365, -1.651506>,
      < -1.106014, 0.701013, -1.582693>,
      < -1.532405, 0.692485, -1.582956>
    }
    triangle {
      < -1.589413, 0.437683, -1.285333>,
      < -1.529680, 0.558365, -1.651506>,
      < -1.532405, 0.692485, -1.582956>
    }
    triangle {
      < -1.589413, 0.437683, -1.285333>,
      < -1.532405, 0.692485, -1.582956>,
      < -1.589958, 0.464506, -1.271623>
    }
    triangle {
      < -1.500008, 0.439471, -1.285278>,
      < -1.589413, 0.437683, -1.285333>,
      < -1.589958, 0.464506, -1.271623>
    }
    triangle {
      < -1.500008, 0.439471, -1.285278>,
      < -1.589958, 0.464506, -1.271623>,
      < -1.500553, 0.466294, -1.271568>
    }
    triangle {
      < -1.424050, 0.423920, -1.232916>,
      < -1.500008, 0.439471, -1.285278>,
      < -1.500553, 0.466294, -1.271568>
    }
    triangle {
      < -1.424050, 0.423920, -1.232916>,
      < -1.500553, 0.466294, -1.271568>,
      < -1.424283, 0.435416, -1.227040>
    }
    triangle {
      < -4.092087, 0.357969, -1.374168>,
      < -3.521270, 0.369392, -1.380695>,
      < -3.522424, 0.426762, -1.371537>
    }
    triangle {
      < -4.092087, 0.357969, -1.374168>,
      < -3.522424, 0.426762, -1.371537>,
      < -4.093198, 0.413213, -1.365349>
    }
    triangle {
      < -4.064554, 0.358568, -1.415422>,
      < -4.092087, 0.357969, -1.374168>,
      < -4.093198, 0.413213, -1.365349>
    }
    triangle {
      < -4.064554, 0.358568, -1.415422>,
      < -4.093198, 0.413213, -1.365349>,
      < -4.065921, 0.426561, -1.404569>
    }
    triangle {
      < -3.548743, 0.368916, -1.442619>,
      < -4.064554, 0.358568, -1.415422>,
      < -4.065921, 0.426561, -1.404569>
    }
    triangle {
      < -3.548743, 0.368916, -1.442619>,
      < -4.065921, 0.426561, -1.404569>,
      < -3.550280, 0.445408, -1.430409>
    }
    triangle {
      < -3.514251, 0.369815, -1.621442>,
      < -3.548743, 0.368916, -1.442619>,
      < -3.550280, 0.445408, -1.430409>
    }
    triangle {
      < -3.514251, 0.369815, -1.621442>,
      < -3.550280, 0.445408, -1.430409>,
      < -3.516898, 0.501552, -1.600414>
    }
    triangle {
      < -3.906245, 0.361992, -1.635441>,
      < -3.514251, 0.369815, -1.621442>,
      < -3.516898, 0.501552, -1.600414>
    }
    triangle {
      < -3.906245, 0.361992, -1.635441>,
      < -3.516898, 0.501552, -1.600414>,
      < -3.908979, 0.497978, -1.613735>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.864962, 0.362858, -1.669808>,
      < -3.906245, 0.361992, -1.635441>,
      < -3.908979, 0.497978, -1.613735>
    }
    triangle {
      < -3.864962, 0.362858, -1.669808>,
      < -3.908979, 0.497978, -1.613735>,
      < -3.867909, 0.509468, -1.646407>
    }
    triangle {
      < -3.190945, 0.376427, -1.745059>,
      < -3.864962, 0.362858, -1.669808>,
      < -3.867909, 0.509468, -1.646407>
    }
    triangle {
      < -3.190945, 0.376427, -1.745059>,
      < -3.867909, 0.509468, -1.646407>,
      < -3.194362, 0.546410, -1.717926>
    }
    triangle {
      < -2.695767, 0.386362, -1.772268>,
      < -3.190945, 0.376427, -1.745059>,
      < -3.194362, 0.546410, -1.717926>
    }
    triangle {
      < -2.695767, 0.386362, -1.772268>,
      < -3.194362, 0.546410, -1.717926>,
      < -2.699354, 0.564845, -1.743778>
    }
    triangle {
      < -1.732952, 0.405618, -1.771675>,
      < -2.695767, 0.386362, -1.772268>,
      < -2.699354, 0.564845, -1.743778>
    }
    triangle {
      < -1.732952, 0.405618, -1.771675>,
      < -2.699354, 0.564845, -1.743778>,
      < -1.736537, 0.584100, -1.743185>
    }
    triangle {
      < -1.100272, 0.418215, -1.723134>,
      < -1.732952, 0.405618, -1.771675>,
      < -1.736537, 0.584100, -1.743185>
    }
    triangle {
      < -1.100272, 0.418215, -1.723134>,
      < -1.736537, 0.584100, -1.743185>,
      < -1.103561, 0.581824, -1.697019>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.838985, 0.423343, -1.640430>,
      < -1.100272, 0.418215, -1.723134>,
      < -1.103561, 0.581824, -1.697019>
    }
    triangle {
      < -0.838985, 0.423343, -1.640430>,
      < -1.103561, 0.581824, -1.697019>,
      < -0.841760, 0.561454, -1.618385>
    }
    triangle {
      < -0.852751, 0.423044, -1.619802>,
      < -0.838985, 0.423343, -1.640430>,
      < -0.841760, 0.561454, -1.618385>
    }
    triangle {
      < -0.852751, 0.423044, -1.619802>,
      < -0.841760, 0.561454, -1.618385>,
      < -0.855399, 0.554781, -1.598774>
    }
    triangle {
      < -1.100300, 0.418158, -1.674984>,
      < -0.852751, 0.423044, -1.619802>,
      < -0.855399, 0.554781, -1.598774>
    }
    triangle {
      < -1.100300, 0.418158, -1.674984>,
      < -0.855399, 0.554781, -1.598774>,
      < -1.103289, 0.566893, -1.651243>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.526690, 0.409630, -1.675247>,
      < -1.100300, 0.418158, -1.674984>,
      < -1.103289, 0.566893, -1.651243>
    }
    triangle {
      < -1.526690, 0.409630, -1.675247>,
      < -1.103289, 0.566893, -1.651243>,
      < -1.529680, 0.558365, -1.651506>
    }
    triangle {
      < -1.588814, 0.407936, -1.290082>,
      < -1.526690, 0.409630, -1.675247>,
      < -1.529680, 0.558365, -1.651506>
    }
    triangle {
      < -1.588814, 0.407936, -1.290082>,
      < -1.529680, 0.558365, -1.651506>,
      < -1.589413, 0.437683, -1.285333>
    }
    triangle {
      < -1.499409, 0.409723, -1.290026>,
      < -1.588814, 0.407936, -1.290082>,
      < -1.589413, 0.437683, -1.285333>
    }
    triangle {
      < -1.499409, 0.409723, -1.290026>,
      < -1.589413, 0.437683, -1.285333>,
      < -1.500008, 0.439471, -1.285278>
    }
    triangle {
      < -1.423794, 0.411171, -1.234951>,
      < -1.499409, 0.409723, -1.290026>,
      < -1.500008, 0.439471, -1.285278>
    }
    triangle {
      < -1.423794, 0.411171, -1.234951>,
      < -1.500008, 0.439471, -1.285278>,
      < -1.424050, 0.423920, -1.232916>
    }
    triangle {
      < -4.090987, 0.302703, -1.365479>,
      < -3.520128, 0.312002, -1.371672>,
      < -3.521270, 0.369392, -1.380695>
    }
    triangle {
      < -4.090987, 0.302703, -1.365479>,
      < -3.521270, 0.369392, -1.380695>,
      < -4.092087, 0.357969, -1.374168>
    }
    triangle {
      < -4.063201, 0.290549, -1.404729>,
      < -4.090987, 0.302703, -1.365479>,
      < -4.092087, 0.357969, -1.374168>
    }
    triangle {
      < -4.063201, 0.290549, -1.404729>,
      < -4.092087, 0.357969, -1.374168>,
      < -4.064554, 0.358568, -1.415422>
    }
    triangle {
      < -3.547221, 0.292395, -1.430590>,
      < -4.063201, 0.290549, -1.404729>,
      < -4.064554, 0.358568, -1.415422>
    }
    triangle {
      < -3.547221, 0.292395, -1.430590>,
      < -4.064554, 0.358568, -1.415422>,
      < -3.548743, 0.368916, -1.442619>
    }
    triangle {
      < -3.511628, 0.238029, -1.600724>,
      < -3.547221, 0.292395, -1.430590>,
      < -3.548743, 0.368916, -1.442619>
    }
    triangle {
      < -3.511628, 0.238029, -1.600724>,
      < -3.548743, 0.368916, -1.442619>,
      < -3.514251, 0.369815, -1.621442>
    }
    triangle {
      < -3.903538, 0.225954, -1.614054>,
      < -3.511628, 0.238029, -1.600724>,
      < -3.514251, 0.369815, -1.621442>
    }
    triangle {
      < -3.903538, 0.225954, -1.614054>,
      < -3.514251, 0.369815, -1.621442>,
      < -3.906245, 0.361992, -1.635441>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.862043, 0.216193, -1.646751>,
      < -3.903538, 0.225954, -1.614054>,
      < -3.906245, 0.361992, -1.635441>
    }
    triangle {
      < -3.862043, 0.216193, -1.646751>,
      < -3.906245, 0.361992, -1.635441>,
      < -3.864962, 0.362858, -1.669808>
    }
    triangle {
      < -3.187562, 0.206379, -1.718325>,
      < -3.862043, 0.216193, -1.646751>,
      < -3.864962, 0.362858, -1.669808>
    }
    triangle {
      < -3.187562, 0.206379, -1.718325>,
      < -3.864962, 0.362858, -1.669808>,
      < -3.190945, 0.376427, -1.745059>
    }
    triangle {
      < -2.692214, 0.207813, -1.744197>,
      < -3.187562, 0.206379, -1.718325>,
      < -3.190945, 0.376427, -1.745059>
    }
    triangle {
      < -2.692214, 0.207813, -1.744197>,
      < -3.190945, 0.376427, -1.745059>,
      < -2.695767, 0.386362, -1.772268>
    }
    triangle {
      < -1.729398, 0.227068, -1.743604>,
      < -2.692214, 0.207813, -1.744197>,
      < -2.695767, 0.386362, -1.772268>
    }
    triangle {
      < -1.729398, 0.227068, -1.743604>,
      < -2.695767, 0.386362, -1.772268>,
      < -1.732952, 0.405618, -1.771675>
    }
    triangle {
      < -1.097014, 0.254545, -1.697404>,
      < -1.729398, 0.227068, -1.743604>,
      < -1.732952, 0.405618, -1.771675>
    }
    triangle {
      < -1.097014, 0.254545, -1.697404>,
      < -1.732952, 0.405618, -1.771675>,
      < -1.100272, 0.418215, -1.723134>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.836234, 0.285180, -1.618708>,
      < -1.097014, 0.254545, -1.697404>,
      < -1.100272, 0.418215, -1.723134>
    }
    triangle {
      < -0.836234, 0.285180, -1.618708>,
      < -1.100272, 0.418215, -1.723134>,
      < -0.838985, 0.423343, -1.640430>
    }
    triangle {
      < -0.850128, 0.291257, -1.599083>,
      < -0.836234, 0.285180, -1.618708>,
      < -0.838985, 0.423343, -1.640430>
    }
    triangle {
      < -0.850128, 0.291257, -1.599083>,
      < -0.838985, 0.423343, -1.640430>,
      < -0.852751, 0.423044, -1.619802>
    }
    triangle {
      < -1.097339, 0.269366, -1.651592>,
      < -0.850128, 0.291257, -1.599083>,
      < -0.852751, 0.423044, -1.619802>
    }
    triangle {
      < -1.097339, 0.269366, -1.651592>,
      < -0.852751, 0.423044, -1.619802>,
      < -1.100300, 0.418158, -1.674984>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.523730, 0.260839, -1.651855>,
      < -1.097339, 0.269366, -1.651592>,
      < -1.100300, 0.418158, -1.674984>
    }
    triangle {
      < -1.523730, 0.260839, -1.651855>,
      < -1.100300, 0.418158, -1.674984>,
      < -1.526690, 0.409630, -1.675247>
    }
    triangle {
      < -1.588222, 0.378177, -1.285403>,
      < -1.523730, 0.260839, -1.651855>,
      < -1.526690, 0.409630, -1.675247>
    }
    triangle {
      < -1.588222, 0.378177, -1.285403>,
      < -1.526690, 0.409630, -1.675247>,
      < -1.588814, 0.407936, -1.290082>
    }
    triangle {
      < -1.498817, 0.379965, -1.285348>,
      < -1.588222, 0.378177, -1.285403>,
      < -1.588814, 0.407936, -1.290082>
    }
    triangle {
      < -1.498817, 0.379965, -1.285348>,
      < -1.588814, 0.407936, -1.290082>,
      < -1.499409, 0.409723, -1.290026>
    }
    triangle {
      < -1.423539, 0.398418, -1.232946>,
      < -1.498817, 0.379965, -1.285348>,
      < -1.499409, 0.409723, -1.290026>
    }
    triangle {
      < -1.423539, 0.398418, -1.232946>,
      < -1.499409, 0.409723, -1.290026>,
      < -1.423794, 0.411171, -1.234951>
    }
    triangle {
      < -4.090005, 0.252827, -1.340135>,
      < -3.519109, 0.260207, -1.345352>,
      < -3.520128, 0.312002, -1.371672>
    }
    triangle {
      < -4.090005, 0.252827, -1.340135>,
      < -3.520128, 0.312002, -1.371672>,
      < -4.090987, 0.302703, -1.365479>
    }
    triangle {
      < -4.061992, 0.229163, -1.373536>,
      < -4.090005, 0.252827, -1.340135>,
      < -4.090987, 0.302703, -1.365479>
    }
    triangle {
      < -4.061992, 0.229163, -1.373536>,
      < -4.090987, 0.302703, -1.365479>,
      < -4.063201, 0.290549, -1.404729>
    }
    triangle {
      < -3.545862, 0.223336, -1.395497>,
      < -4.061992, 0.229163, -1.373536>,
      < -4.063201, 0.290549, -1.404729>
    }
    triangle {
      < -3.545862, 0.223336, -1.395497>,
      < -4.063201, 0.290549, -1.404729>,
      < -3.547221, 0.292395, -1.430590>
    }
    triangle {
      < -3.509287, 0.119093, -1.540287>,
      < -3.545862, 0.223336, -1.395497>,
      < -3.547221, 0.292395, -1.430590>
    }
    triangle {
      < -3.509287, 0.119093, -1.540287>,
      < -3.547221, 0.292395, -1.430590>,
      < -3.511628, 0.238029, -1.600724>
    }
    triangle {
      < -3.901121, 0.103182, -1.551668>,
      < -3.509287, 0.119093, -1.540287>,
      < -3.511628, 0.238029, -1.600724>
    }
    triangle {
      < -3.901121, 0.103182, -1.551668>,
      < -3.511628, 0.238029, -1.600724>,
      < -3.903538, 0.225954, -1.614054>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.859437, 0.083828, -1.579491>,
      < -3.901121, 0.103182, -1.551668>,
      < -3.903538, 0.225954, -1.614054>
    }
    triangle {
      < -3.859437, 0.083828, -1.579491>,
      < -3.903538, 0.225954, -1.614054>,
      < -3.862043, 0.216193, -1.646751>
    }
    triangle {
      < -3.184540, 0.052914, -1.640342>,
      < -3.859437, 0.083828, -1.579491>,
      < -3.862043, 0.216193, -1.646751>
    }
    triangle {
      < -3.184540, 0.052914, -1.640342>,
      < -3.862043, 0.216193, -1.646751>,
      < -3.187562, 0.206379, -1.718325>
    }
    triangle {
      < -2.689042, 0.046674, -1.662315>,
      < -3.184540, 0.052914, -1.640342>,
      < -3.187562, 0.206379, -1.718325>
    }
    triangle {
      < -2.689042, 0.046674, -1.662315>,
      < -3.187562, 0.206379, -1.718325>,
      < -2.692214, 0.207813, -1.744197>
    }
    triangle {
      < -1.726225, 0.065930, -1.661722>,
      < -2.689042, 0.046674, -1.662315>,
      < -2.692214, 0.207813, -1.744197>
    }
    triangle {
      < -1.726225, 0.065930, -1.661722>,
      < -2.692214, 0.207813, -1.744197>,
      < -1.729398, 0.227068, -1.743604>
    }
    triangle {
      < -1.094107, 0.106834, -1.622345>,
      < -1.726225, 0.065930, -1.661722>,
      < -1.729398, 0.227068, -1.743604>
    }
    triangle {
      < -1.094107, 0.106834, -1.622345>,
      < -1.729398, 0.227068, -1.743604>,
      < -1.097014, 0.254545, -1.697404>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.833780, 0.160490, -1.555348>,
      < -1.094107, 0.106834, -1.622345>,
      < -1.097014, 0.254545, -1.697404>
    }
    triangle {
      < -0.833780, 0.160490, -1.555348>,
      < -1.097014, 0.254545, -1.697404>,
      < -0.836234, 0.285180, -1.618708>
    }
    triangle {
      < -0.847787, 0.172322, -1.538646>,
      < -0.833780, 0.160490, -1.555348>,
      < -0.836234, 0.285180, -1.618708>
    }
    triangle {
      < -0.847787, 0.172322, -1.538646>,
      < -0.836234, 0.285180, -1.618708>,
      < -0.850128, 0.291257, -1.599083>
    }
    triangle {
      < -1.094695, 0.135084, -1.583357>,
      < -0.847787, 0.172322, -1.538646>,
      < -0.850128, 0.291257, -1.599083>
    }
    triangle {
      < -1.094695, 0.135084, -1.583357>,
      < -0.850128, 0.291257, -1.599083>,
      < -1.097339, 0.269366, -1.651592>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.521086, 0.126556, -1.583620>,
      < -1.094695, 0.135084, -1.583357>,
      < -1.097339, 0.269366, -1.651592>
    }
    triangle {
      < -1.521086, 0.126556, -1.583620>,
      < -1.097339, 0.269366, -1.651592>,
      < -1.523730, 0.260839, -1.651855>
    }
    triangle {
      < -1.587694, 0.351321, -1.271756>,
      < -1.521086, 0.126556, -1.583620>,
      < -1.523730, 0.260839, -1.651855>
    }
    triangle {
      < -1.587694, 0.351321, -1.271756>,
      < -1.523730, 0.260839, -1.651855>,
      < -1.588222, 0.378177, -1.285403>
    }
    triangle {
      < -1.498289, 0.353109, -1.271701>,
      < -1.587694, 0.351321, -1.271756>,
      < -1.588222, 0.378177, -1.285403>
    }
    triangle {
      < -1.498289, 0.353109, -1.271701>,
      < -1.588222, 0.378177, -1.285403>,
      < -1.498817, 0.379965, -1.285348>
    }
    triangle {
      < -1.423312, 0.386908, -1.227097>,
      < -1.498289, 0.353109, -1.271701>,
      < -1.498817, 0.379965, -1.285348>
    }
    triangle {
      < -1.423312, 0.386908, -1.227097>,
      < -1.498817, 0.379965, -1.285348>,
      < -1.423539, 0.398418, -1.232946>
    }
    triangle {
      < -4.089237, 0.213222, -1.300615>,
      < -3.518312, 0.219079, -1.304313>,
      < -3.519109, 0.260207, -1.345352>
    }
    triangle {
      < -4.089237, 0.213222, -1.300615>,
      < -3.519109, 0.260207, -1.345352>,
      < -4.090005, 0.252827, -1.340135>
    }
    triangle {
      < -4.061048, 0.180418, -1.324896>,
      < -4.089237, 0.213222, -1.300615>,
      < -4.090005, 0.252827, -1.340135>
    }
    triangle {
      < -4.061048, 0.180418, -1.324896>,
      < -4.090005, 0.252827, -1.340135>,
      < -4.061992, 0.229163, -1.373536>
    }
    triangle {
      < -3.544798, 0.168497, -1.340777>,
      < -4.061048, 0.180418, -1.324896>,
      < -4.061992, 0.229163, -1.373536>
    }
    triangle {
      < -3.544798, 0.168497, -1.340777>,
      < -4.061992, 0.229163, -1.373536>,
      < -3.545862, 0.223336, -1.395497>
    }
    triangle {
      < -3.507457, 0.024650, -1.446048>,
      < -3.544798, 0.168497, -1.340777>,
      < -3.545862, 0.223336, -1.395497>
    }
    triangle {
      < -3.507457, 0.024650, -1.446048>,
      < -3.545862, 0.223336, -1.395497>,
      < -3.509287, 0.119093, -1.540287>
    }
    triangle {
      < -3.899232, 0.005693, -1.454388>,
      < -3.507457, 0.024650, -1.446048>,
      < -3.509287, 0.119093, -1.540287>
    }
    triangle {
      < -3.899232, 0.005693, -1.454388>,
      < -3.509287, 0.119093, -1.540287>,
      < -3.901121, 0.103182, -1.551668>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.857399, -0.021278, -1.474611>,
      < -3.899232, 0.005693, -1.454388>,
      < -3.901121, 0.103182, -1.551668>
    }
    triangle {
      < -3.857399, -0.021278, -1.474611>,
      < -3.901121, 0.103182, -1.551668>,
      < -3.859437, 0.083828, -1.579491>
    }
    triangle {
      < -3.182178, -0.068948, -1.518743>,
      < -3.857399, -0.021278, -1.474611>,
      < -3.859437, 0.083828, -1.579491>
    }
    triangle {
      < -3.182178, -0.068948, -1.518743>,
      < -3.859437, 0.083828, -1.579491>,
      < -3.184540, 0.052914, -1.640342>
    }
    triangle {
      < -2.686561, -0.081280, -1.534637>,
      < -3.182178, -0.068948, -1.518743>,
      < -3.184540, 0.052914, -1.640342>
    }
    triangle {
      < -2.686561, -0.081280, -1.534637>,
      < -3.184540, 0.052914, -1.640342>,
      < -2.689042, 0.046674, -1.662315>
    }
    triangle {
      < -1.723745, -0.062025, -1.534044>,
      < -2.686561, -0.081280, -1.534637>,
      < -2.689042, 0.046674, -1.662315>
    }
    triangle {
      < -1.723745, -0.062025, -1.534044>,
      < -2.689042, 0.046674, -1.662315>,
      < -1.726225, 0.065930, -1.661722>
    }
    triangle {
      < -1.091833, -0.010458, -1.505306>,
      < -1.723745, -0.062025, -1.534044>,
      < -1.726225, 0.065930, -1.661722>
    }
    triangle {
      < -1.091833, -0.010458, -1.505306>,
      < -1.726225, 0.065930, -1.661722>,
      < -1.094107, 0.106834, -1.622345>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.831860, 0.061477, -1.456549>,
      < -1.091833, -0.010458, -1.505306>,
      < -1.094107, 0.106834, -1.622345>
    }
    triangle {
      < -0.831860, 0.061477, -1.456549>,
      < -1.094107, 0.106834, -1.622345>,
      < -0.833780, 0.160490, -1.555348>
    }
    triangle {
      < -0.845955, 0.077879, -1.444408>,
      < -0.831860, 0.061477, -1.456549>,
      < -0.833780, 0.160490, -1.555348>
    }
    triangle {
      < -0.845955, 0.077879, -1.444408>,
      < -0.833780, 0.160490, -1.555348>,
      < -0.847787, 0.172322, -1.538646>
    }
    triangle {
      < -1.092628, 0.028455, -1.476957>,
      < -0.845955, 0.077879, -1.444408>,
      < -0.847787, 0.172322, -1.538646>
    }
    triangle {
      < -1.092628, 0.028455, -1.476957>,
      < -0.847787, 0.172322, -1.538646>,
      < -1.094695, 0.135084, -1.583357>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.519019, 0.019927, -1.477220>,
      < -1.092628, 0.028455, -1.476957>,
      < -1.094695, 0.135084, -1.583357>
    }
    triangle {
      < -1.519019, 0.019927, -1.477220>,
      < -1.094695, 0.135084, -1.583357>,
      < -1.521086, 0.126556, -1.583620>
    }
    triangle {
      < -1.587281, 0.329995, -1.250476>,
      < -1.519019, 0.019927, -1.477220>,
      < -1.521086, 0.126556, -1.583620>
    }
    triangle {
      < -1.587281, 0.329995, -1.250476>,
      < -1.521086, 0.126556, -1.583620>,
      < -1.587694, 0.351321, -1.271756>
    }
    triangle {
      < -1.497875, 0.331783, -1.250421>,
      < -1.587281, 0.329995, -1.250476>,
      < -1.587694, 0.351321, -1.271756>
    }
    triangle {
      < -1.497875, 0.331783, -1.250421>,
      < -1.587694, 0.351321, -1.271756>,
      < -1.498289, 0.353109, -1.271701>
    }
    triangle {
      < -1.423135, 0.377768, -1.217977>,
      < -1.497875, 0.331783, -1.250421>,
      < -1.498289, 0.353109, -1.271701>
    }
    triangle {
      < -1.423135, 0.377768, -1.217977>,
      < -1.498289, 0.353109, -1.271701>,
      < -1.423312, 0.386908, -1.227097>
    }
    triangle {
      < -4.088760, 0.187766, -1.250789>,
      < -3.517814, 0.192643, -1.252570>,
      < -3.518312, 0.219079, -1.304313>
    }
    triangle {
      < -4.088760, 0.187766, -1.250789>,
      < -3.518312, 0.219079, -1.304313>,
      < -4.089237, 0.213222, -1.300615>
    }
    triangle {
      < -4.060459, 0.149086, -1.263572>,
      < -4.088760, 0.187766, -1.250789>,
      < -4.089237, 0.213222, -1.300615>
    }
    triangle {
      < -4.060459, 0.149086, -1.263572>,
      < -4.089237, 0.213222, -1.300615>,
      < -4.061048, 0.180418, -1.324896>
    }
    triangle {
      < -3.544136, 0.133250, -1.271787>,
      < -4.060459, 0.149086, -1.263572>,
      < -4.061048, 0.180418, -1.324896>
    }
    triangle {
      < -3.544136, 0.133250, -1.271787>,
      < -4.061048, 0.180418, -1.324896>,
      < -3.544798, 0.168497, -1.340777>
    }
    triangle {
      < -3.506316, -0.036055, -1.327231>,
      < -3.544136, 0.133250, -1.271787>,
      < -3.544798, 0.168497, -1.340777>
    }
    triangle {
      < -3.506316, -0.036055, -1.327231>,
      < -3.544798, 0.168497, -1.340777>,
      < -3.507457, 0.024650, -1.446048>
    }
    triangle {
      < -3.898055, -0.056970, -1.331740>,
      < -3.506316, -0.036055, -1.327231>,
      < -3.507457, 0.024650, -1.446048>
    }
    triangle {
      < -3.898055, -0.056970, -1.331740>,
      < -3.507457, 0.024650, -1.446048>,
      < -3.899232, 0.005693, -1.454388>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.856130, -0.088836, -1.342381>,
      < -3.898055, -0.056970, -1.331740>,
      < -3.899232, 0.005693, -1.454388>
    }
    triangle {
      < -3.856130, -0.088836, -1.342381>,
      < -3.899232, 0.005693, -1.454388>,
      < -3.857399, -0.021278, -1.474611>
    }
    triangle {
      < -3.180706, -0.147277, -1.365432>,
      < -3.856130, -0.088836, -1.342381>,
      < -3.857399, -0.021278, -1.474611>
    }
    triangle {
      < -3.180706, -0.147277, -1.365432>,
      < -3.857399, -0.021278, -1.474611>,
      < -3.182178, -0.068948, -1.518743>
    }
    triangle {
      < -2.685015, -0.163527, -1.373660>,
      < -3.180706, -0.147277, -1.365432>,
      < -3.182178, -0.068948, -1.518743>
    }
    triangle {
      < -2.685015, -0.163527, -1.373660>,
      < -3.182178, -0.068948, -1.518743>,
      < -2.686561, -0.081280, -1.534637>
    }
    triangle {
      < -1.722199, -0.144271, -1.373066>,
      < -2.685015, -0.163527, -1.373660>,
      < -2.686561, -0.081280, -1.534637>
    }
    triangle {
      < -1.722199, -0.144271, -1.373066>,
      < -2.686561, -0.081280, -1.534637>,
      < -1.723745, -0.062025, -1.534044>
    }
    triangle {
      < -1.090416, -0.085850, -1.357743>,
      < -1.722199, -0.144271, -1.373066>,
      < -1.723745, -0.062025, -1.534044>
    }
    triangle {
      < -1.090416, -0.085850, -1.357743>,
      < -1.723745, -0.062025, -1.534044>,
      < -1.091833, -0.010458, -1.505306>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.830664, -0.002165, -1.331982>,
      < -1.090416, -0.085850, -1.357743>,
      < -1.091833, -0.010458, -1.505306>
    }
    triangle {
      < -0.830664, -0.002165, -1.331982>,
      < -1.091833, -0.010458, -1.505306>,
      < -0.831860, 0.061477, -1.456549>
    }
    triangle {
      < -0.844815, 0.017173, -1.325591>,
      < -0.830664, -0.002165, -1.331982>,
      < -0.831860, 0.061477, -1.456549>
    }
    triangle {
      < -0.844815, 0.017173, -1.325591>,
      < -0.831860, 0.061477, -1.456549>,
      < -0.845955, 0.077879, -1.444408>
    }
    triangle {
      < -1.091340, -0.040083, -1.342810>,
      < -0.844815, 0.017173, -1.325591>,
      < -0.845955, 0.077879, -1.444408>
    }
    triangle {
      < -1.091340, -0.040083, -1.342810>,
      < -0.845955, 0.077879, -1.444408>,
      < -1.092628, 0.028455, -1.476957>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.517731, -0.048611, -1.343072>,
      < -1.091340, -0.040083, -1.342810>,
      < -1.092628, 0.028455, -1.476957>
    }
    triangle {
      < -1.517731, -0.048611, -1.343072>,
      < -1.092628, 0.028455, -1.476957>,
      < -1.519019, 0.019927, -1.477220>
    }
    triangle {
      < -1.587023, 0.316288, -1.223646>,
      < -1.517731, -0.048611, -1.343072>,
      < -1.519019, 0.019927, -1.477220>
    }
    triangle {
      < -1.587023, 0.316288, -1.223646>,
      < -1.519019, 0.019927, -1.477220>,
      < -1.587281, 0.329995, -1.250476>
    }
    triangle {
      < -1.497617, 0.318075, -1.223591>,
      < -1.587023, 0.316288, -1.223646>,
      < -1.587281, 0.329995, -1.250476>
    }
    triangle {
      < -1.497617, 0.318075, -1.223591>,
      < -1.587281, 0.329995, -1.250476>,
      < -1.497875, 0.331783, -1.250421>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.497617, 0.318075, -1.223591>,
      < -1.497875, 0.331783, -1.250421>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.497875, 0.331783, -1.250421>,
      < -1.423135, 0.377768, -1.217977>
    }
    triangle {
      < -4.088617, 0.178948, -1.195533>,
      < -3.517668, 0.183487, -1.195190>,
      < -3.517814, 0.192643, -1.252570>
    }
    triangle {
      < -4.088617, 0.178948, -1.195533>,
      < -3.517814, 0.192643, -1.252570>,
      < -4.088760, 0.187766, -1.250789>
    }
    triangle {
      < -4.060283, 0.138235, -1.195564>,
      < -4.088617, 0.178948, -1.195533>,
      < -4.088760, 0.187766, -1.250789>
    }
    triangle {
      < -4.060283, 0.138235, -1.195564>,
      < -4.088760, 0.187766, -1.250789>,
      < -4.060459, 0.149086, -1.263572>
    }
    triangle {
      < -3.543939, 0.121041, -1.195279>,
      < -4.060283, 0.138235, -1.195564>,
      < -4.060459, 0.149086, -1.263572>
    }
    triangle {
      < -3.543939, 0.121041, -1.195279>,
      < -4.060459, 0.149086, -1.263572>,
      < -3.544136, 0.133250, -1.271787>
    }
    triangle {
      < -3.505976, -0.057080, -1.195468>,
      < -3.543939, 0.121041, -1.195279>,
      < -3.544136, 0.133250, -1.271787>
    }
    triangle {
      < -3.505976, -0.057080, -1.195468>,
      < -3.544136, 0.133250, -1.271787>,
      < -3.506316, -0.036055, -1.327231>
    }
    triangle {
      < -3.897704, -0.078674, -1.195726>,
      < -3.505976, -0.057080, -1.195468>,
      < -3.506316, -0.036055, -1.327231>
    }
    triangle {
      < -3.897704, -0.078674, -1.195726>,
      < -3.506316, -0.036055, -1.327231>,
      < -3.898055, -0.056970, -1.331740>
    }
    texture {parts_turbine}
  }
  // eng1_parts
  union {
    triangle {
      < -3.855752, -0.112235, -1.195741>,
      < -3.897704, -0.078674, -1.195726>,
      < -3.898055, -0.056970, -1.331740>
    }
    triangle {
      < -3.855752, -0.112235, -1.195741>,
      < -3.898055, -0.056970, -1.331740>,
      < -3.856130, -0.088836, -1.342381>
    }
    triangle {
      < -3.180268, -0.174406, -1.195414>,
      < -3.855752, -0.112235, -1.195741>,
      < -3.856130, -0.088836, -1.342381>
    }
    triangle {
      < -3.180268, -0.174406, -1.195414>,
      < -3.856130, -0.088836, -1.342381>,
      < -3.180706, -0.147277, -1.365432>
    }
    triangle {
      < -2.684556, -0.192012, -1.195141>,
      < -3.180268, -0.174406, -1.195414>,
      < -3.180706, -0.147277, -1.365432>
    }
    triangle {
      < -2.684556, -0.192012, -1.195141>,
      < -3.180706, -0.147277, -1.365432>,
      < -2.685015, -0.163527, -1.373660>
    }
    triangle {
      < -1.721740, -0.172757, -1.194548>,
      < -2.684556, -0.192012, -1.195141>,
      < -2.685015, -0.163527, -1.373660>
    }
    triangle {
      < -1.721740, -0.172757, -1.194548>,
      < -2.685015, -0.163527, -1.373660>,
      < -1.722199, -0.144271, -1.373066>
    }
    triangle {
      < -1.089995, -0.111961, -1.194101>,
      < -1.721740, -0.172757, -1.194548>,
      < -1.722199, -0.144271, -1.373066>
    }
    triangle {
      < -1.089995, -0.111961, -1.194101>,
      < -1.722199, -0.144271, -1.373066>,
      < -1.090416, -0.085850, -1.357743>
    }
    texture {eng1_parts}
  }
  // parts_intake
  union {
    triangle {
      < -0.830309, -0.024208, -1.193843>,
      < -1.089995, -0.111961, -1.194101>,
      < -1.090416, -0.085850, -1.357743>
    }
    triangle {
      < -0.830309, -0.024208, -1.193843>,
      < -1.090416, -0.085850, -1.357743>,
      < -0.830664, -0.002165, -1.331982>
    }
    triangle {
      < -0.844476, -0.003851, -1.193827>,
      < -0.830309, -0.024208, -1.193843>,
      < -0.830664, -0.002165, -1.331982>
    }
    triangle {
      < -0.844476, -0.003851, -1.193827>,
      < -0.830664, -0.002165, -1.331982>,
      < -0.844815, 0.017173, -1.325591>
    }
    triangle {
      < -1.090957, -0.063821, -1.194045>,
      < -0.844476, -0.003851, -1.193827>,
      < -0.844815, 0.017173, -1.325591>
    }
    triangle {
      < -1.090957, -0.063821, -1.194045>,
      < -0.844815, 0.017173, -1.325591>,
      < -1.091340, -0.040083, -1.342810>
    }
    texture {parts_intake}
  }
  // parts_turbine
  union {
    triangle {
      < -1.517348, -0.072349, -1.194307>,
      < -1.090957, -0.063821, -1.194045>,
      < -1.091340, -0.040083, -1.342810>
    }
    triangle {
      < -1.517348, -0.072349, -1.194307>,
      < -1.091340, -0.040083, -1.342810>,
      < -1.517731, -0.048611, -1.343072>
    }
    triangle {
      < -1.586946, 0.311540, -1.193894>,
      < -1.517348, -0.072349, -1.194307>,
      < -1.517731, -0.048611, -1.343072>
    }
    triangle {
      < -1.586946, 0.311540, -1.193894>,
      < -1.517731, -0.048611, -1.343072>,
      < -1.587023, 0.316288, -1.223646>
    }
    triangle {
      < -1.497541, 0.313328, -1.193839>,
      < -1.586946, 0.311540, -1.193894>,
      < -1.587023, 0.316288, -1.223646>
    }
    triangle {
      < -1.497541, 0.313328, -1.193839>,
      < -1.587023, 0.316288, -1.223646>,
      < -1.497617, 0.318075, -1.223591>
    }
    triangle {
      < -1.422992, 0.369859, -1.193727>,
      < -1.497541, 0.313328, -1.193839>,
      < -1.497617, 0.318075, -1.223591>
    }
    triangle {
      < -1.422992, 0.369859, -1.193727>,
      < -1.497617, 0.318075, -1.223591>,
      < -1.423025, 0.371893, -1.206478>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.518441, 0.218820, -1.085983>,
      < -3.519287, 0.259851, -1.044846>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.519287, 0.259851, -1.044846>,
      < -3.520337, 0.311583, -1.018406>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.520337, 0.311583, -1.018406>,
      < -3.521491, 0.368952, -1.009249>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.521491, 0.368952, -1.009249>,
      < -3.522633, 0.426343, -1.018271>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.522633, 0.426343, -1.018271>,
      < -3.523652, 0.478138, -1.044591>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.523652, 0.478138, -1.044591>,
      < -3.524449, 0.519265, -1.085630>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.524449, 0.519265, -1.085630>,
      < -3.524945, 0.545701, -1.137373>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.524945, 0.545701, -1.137373>,
      < -3.525094, 0.554857, -1.194754>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.525094, 0.554857, -1.194754>,
      < -3.524878, 0.545838, -1.252156>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.524878, 0.545838, -1.252156>,
      < -3.524320, 0.519525, -1.303960>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.524320, 0.519525, -1.303960>,
      < -3.523474, 0.478493, -1.345097>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.523474, 0.478493, -1.345097>,
      < -3.522424, 0.426762, -1.371537>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.522424, 0.426762, -1.371537>,
      < -3.521270, 0.369392, -1.380695>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.521270, 0.369392, -1.380695>,
      < -3.520128, 0.312002, -1.371672>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.520128, 0.312002, -1.371672>,
      < -3.519109, 0.260207, -1.345352>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.519109, 0.260207, -1.345352>,
      < -3.518312, 0.219079, -1.304313>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.518312, 0.219079, -1.304313>,
      < -3.517814, 0.192643, -1.252570>
    }
    triangle {
      < -3.517882, 0.192507, -1.137787>,
      < -3.517814, 0.192643, -1.252570>,
      < -3.517668, 0.183487, -1.195190>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423135, 0.377768, -1.217977>,
      < -1.423312, 0.386908, -1.227097>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423312, 0.386908, -1.227097>,
      < -1.423539, 0.398418, -1.232946>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423539, 0.398418, -1.232946>,
      < -1.423794, 0.411171, -1.234951>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423794, 0.411171, -1.234951>,
      < -1.424050, 0.423920, -1.232916>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424050, 0.423920, -1.232916>,
      < -1.424283, 0.435416, -1.227040>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424283, 0.435416, -1.227040>,
      < -1.424470, 0.444534, -1.217898>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424470, 0.444534, -1.217898>,
      < -1.424595, 0.450381, -1.206387>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424595, 0.450381, -1.206387>,
      < -1.424643, 0.452386, -1.193630>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424643, 0.452386, -1.193630>,
      < -1.424610, 0.450351, -1.180879>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424610, 0.450351, -1.180879>,
      < -1.424499, 0.444476, -1.169381>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424499, 0.444476, -1.169381>,
      < -1.424322, 0.435336, -1.160261>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424322, 0.435336, -1.160261>,
      < -1.424096, 0.423827, -1.154413>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.424096, 0.423827, -1.154413>,
      < -1.423842, 0.411073, -1.152407>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423842, 0.411073, -1.152407>,
      < -1.423585, 0.398325, -1.154442>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423585, 0.398325, -1.154442>,
      < -1.423352, 0.386829, -1.160318>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423352, 0.386829, -1.160318>,
      < -1.423164, 0.377710, -1.169459>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423164, 0.377710, -1.169459>,
      < -1.423040, 0.371863, -1.180971>
    }
    triangle {
      < -1.423025, 0.371893, -1.206478>,
      < -1.423040, 0.371863, -1.180971>,
      < -1.422992, 0.369859, -1.193727>
    }
    texture {parts_turbine}
  }
  // parts_fuselage
  union {
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.911661, -0.062399, -0.049612>,
      < 6.910817, -0.015226, -0.058867>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.910817, -0.015226, -0.058867>,
      < 6.910316, 0.012487, -0.056630>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.910316, 0.012487, -0.056630>,
      < 6.909820, 0.039815, -0.045926>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.909820, 0.039815, -0.045926>,
      < 6.909614, 0.050989, -0.036574>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.909614, 0.050989, -0.036574>,
      < 6.909470, 0.058427, -0.021891>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.909470, 0.058427, -0.021891>,
      < 6.909413, 0.060882, 0.003803>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.909413, 0.060882, 0.003803>,
      < 6.909443, 0.058367, 0.029490>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.909443, 0.058367, 0.029490>,
      < 6.909571, 0.050893, 0.044156>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.909571, 0.050893, 0.044156>,
      < 6.909767, 0.039697, 0.053480>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.909767, 0.039697, 0.053480>,
      < 6.910252, 0.012345, 0.064121>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.910252, 0.012345, 0.064121>,
      < 6.910750, -0.015375, 0.066293>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.910750, -0.015375, 0.066293>,
      < 6.911604, -0.062526, 0.056927>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.911604, -0.062526, 0.056927>,
      < 6.911885, -0.077433, 0.034451>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.911885, -0.077433, 0.034451>,
      < 6.911934, -0.079561, 0.015987>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.911934, -0.079561, 0.015987>,
      < 6.911947, -0.079532, -0.008712>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.105287, -0.024509, -0.042909>,
      < -6.105064, -0.035790, -0.036590>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.105064, -0.035790, -0.036590>,
      < -6.104941, -0.042186, -0.030594>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.104941, -0.042186, -0.030594>,
      < -6.104814, -0.049007, -0.016801>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.104814, -0.049007, -0.016801>,
      < -6.104812, -0.049484, -0.004721>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.104812, -0.049484, -0.004721>,
      < -6.104828, -0.049035, 0.007361>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.104828, -0.049035, 0.007361>,
      < -6.104971, -0.042247, 0.021170>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.104971, -0.042247, 0.021170>,
      < -6.105103, -0.035866, 0.027180>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.105103, -0.035866, 0.027180>,
      < -6.105331, -0.024599, 0.033526>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.105331, -0.024599, 0.033526>,
      < -6.105809, -0.000666, 0.031090>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.105809, -0.000666, 0.031090>,
      < -6.106342, 0.026157, 0.025268>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106342, 0.026157, 0.025268>,
      < -6.106454, 0.032003, 0.018821>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106454, 0.032003, 0.018821>,
      < -6.106521, 0.035473, 0.012461>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106521, 0.035473, 0.012461>,
      < -6.106542, 0.036612, 0.008938>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106542, 0.036612, 0.008938>,
      < -6.106551, 0.037152, 0.006176>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106551, 0.037152, 0.006176>,
      < -6.106549, 0.037416, -0.004619>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106549, 0.037416, -0.004619>,
      < -6.106538, 0.037178, -0.015415>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106538, 0.037178, -0.015415>,
      < -6.106525, 0.036644, -0.018177>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106525, 0.036644, -0.018177>,
      < -6.106501, 0.035514, -0.021704>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106501, 0.035514, -0.021704>,
      < -6.106427, 0.032059, -0.028071>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106427, 0.032059, -0.028071>,
      < -6.106308, 0.026228, -0.034532>
    }
    triangle {
      < 6.050414, 0.548263, 0.003814>,
      < 6.050787, 0.532710, -0.164313>,
      < 4.624467, 0.714666, -0.196381>
    }
    triangle {
      < 6.050414, 0.548263, 0.003814>,
      < 4.624467, 0.714666, -0.196381>,
      < 5.399979, 0.724540, -0.169506>
    }
    triangle {
      < 6.050414, 0.548263, 0.003814>,
      < 5.399979, 0.724540, -0.169506>,
      < 5.399573, 0.741740, 0.003615>
    }
    triangle {
      < 4.624467, 0.714666, -0.196381>,
      < 6.050787, 0.532710, -0.164313>,
      < 6.051688, 0.485561, -0.257374>
    }
    triangle {
      < 4.624467, 0.714666, -0.196381>,
      < 6.051688, 0.485561, -0.257374>,
      < 5.401195, 0.661241, -0.308919>
    }
    triangle {
      < 4.624467, 0.714666, -0.196381>,
      < 5.401195, 0.661241, -0.308919>,
      < 5.400300, 0.708349, -0.222295>
    }
    triangle {
      < 6.051688, 0.485561, -0.257374>,
      < 6.052994, 0.414746, -0.316643>,
      < 5.402871, 0.570347, -0.379800>
    }
    triangle {
      < 6.051688, 0.485561, -0.257374>,
      < 5.402871, 0.570347, -0.379800>,
      < 5.401195, 0.661241, -0.308919>
    }
    triangle {
      < 6.052994, 0.414746, -0.316643>,
      < 6.056149, 0.241547, -0.384486>,
      < 5.406918, 0.348052, -0.460947>
    }
    triangle {
      < 6.052994, 0.414746, -0.316643>,
      < 5.406918, 0.348052, -0.460947>,
      < 5.402871, 0.570347, -0.379800>
    }
    triangle {
      < 6.056149, 0.241547, -0.384486>,
      < 6.063684, -0.176021, -0.418186>,
      < 5.417311, -0.228089, -0.504318>
    }
    triangle {
      < 6.056149, 0.241547, -0.384486>,
      < 5.417311, -0.228089, -0.504318>,
      < 5.406918, 0.348052, -0.460947>
    }
    triangle {
      < 6.063684, -0.176021, -0.418186>,
      < 6.065095, -0.254629, -0.410432>,
      < 5.418396, -0.288755, -0.492026>
    }
    triangle {
      < 6.063684, -0.176021, -0.418186>,
      < 5.418396, -0.288755, -0.492026>,
      < 5.417311, -0.228089, -0.504318>
    }
    triangle {
      < 6.065095, -0.254629, -0.410432>,
      < 6.066094, -0.312720, -0.326774>,
      < 5.419632, -0.359599, -0.421335>
    }
    triangle {
      < 6.065095, -0.254629, -0.410432>,
      < 5.419632, -0.359599, -0.421335>,
      < 5.418396, -0.288755, -0.492026>
    }
    triangle {
      < 6.066094, -0.312720, -0.326774>,
      < 6.066478, -0.341659, -0.080790>,
      < 5.420188, -0.400418, -0.097842>
    }
    triangle {
      < 6.066094, -0.312720, -0.326774>,
      < 5.420188, -0.400418, -0.097842>,
      < 5.419632, -0.359599, -0.421335>
    }
    triangle {
      < 6.066478, -0.341659, -0.080790>,
      < 6.066389, -0.341858, 0.086329>,
      < 5.420081, -0.400655, 0.102390>
    }
    triangle {
      < 6.066478, -0.341659, -0.080790>,
      < 5.420081, -0.400655, 0.102390>,
      < 5.420188, -0.400418, -0.097842>
    }
    triangle {
      < 6.465039, -0.216685, -0.313307>,
      < 6.465827, -0.262925, -0.234541>,
      < 6.066094, -0.312720, -0.326774>
    }
    triangle {
      < 6.465039, -0.216685, -0.313307>,
      < 6.066094, -0.312720, -0.326774>,
      < 6.065095, -0.254629, -0.410432>
    }
    triangle {
      < 6.465827, -0.262925, -0.234541>,
      < 6.466100, -0.283377, -0.060699>,
      < 6.066478, -0.341659, -0.080790>
    }
    triangle {
      < 6.465827, -0.262925, -0.234541>,
      < 6.066478, -0.341659, -0.080790>,
      < 6.066094, -0.312720, -0.326774>
    }
    triangle {
      < 6.466100, -0.283377, -0.060699>,
      < 6.466032, -0.283528, 0.066903>,
      < 6.066389, -0.341858, 0.086329>
    }
    triangle {
      < 6.466100, -0.283377, -0.060699>,
      < 6.066389, -0.341858, 0.086329>,
      < 6.066478, -0.341659, -0.080790>
    }
    triangle {
      < 6.453789, 0.398580, 0.003902>,
      < 6.454074, 0.386660, -0.124704>,
      < 6.050787, 0.532710, -0.164313>
    }
    triangle {
      < 6.453789, 0.398580, 0.003902>,
      < 6.050787, 0.532710, -0.164313>,
      < 6.050414, 0.548263, 0.003814>
    }
    triangle {
      < 6.454074, 0.386660, -0.124704>,
      < 6.454764, 0.350531, -0.196017>,
      < 6.051688, 0.485561, -0.257374>
    }
    triangle {
      < 6.454074, 0.386660, -0.124704>,
      < 6.051688, 0.485561, -0.257374>,
      < 6.050787, 0.532710, -0.164313>
    }
    triangle {
      < 6.454764, 0.350531, -0.196017>,
      < 6.455766, 0.296264, -0.241435>,
      < 6.052994, 0.414746, -0.316643>
    }
    triangle {
      < 6.454764, 0.350531, -0.196017>,
      < 6.052994, 0.414746, -0.316643>,
      < 6.051688, 0.485561, -0.257374>
    }
    triangle {
      < 6.455766, 0.296264, -0.241435>,
      < 6.458183, 0.163540, -0.293424>,
      < 6.056149, 0.241547, -0.384486>
    }
    triangle {
      < 6.455766, 0.296264, -0.241435>,
      < 6.056149, 0.241547, -0.384486>,
      < 6.052994, 0.414746, -0.316643>
    }
    triangle {
      < 6.458183, 0.163540, -0.293424>,
      < 6.463341, -0.122263, -0.316490>,
      < 6.063684, -0.176021, -0.418186>
    }
    triangle {
      < 6.458183, 0.163540, -0.293424>,
      < 6.063684, -0.176021, -0.418186>,
      < 6.056149, 0.241547, -0.384486>
    }
    triangle {
      < 6.463341, -0.122263, -0.316490>,
      < 6.465039, -0.216685, -0.313307>,
      < 6.065095, -0.254629, -0.410432>
    }
    triangle {
      < 6.463341, -0.122263, -0.316490>,
      < 6.065095, -0.254629, -0.410432>,
      < 6.063684, -0.176021, -0.418186>
    }
    triangle {
      < 6.810624, 0.142407, -0.121215>,
      < 6.811862, 0.074463, -0.147830>,
      < 6.458183, 0.163540, -0.293424>
    }
    triangle {
      < 6.810624, 0.142407, -0.121215>,
      < 6.458183, 0.163540, -0.293424>,
      < 6.455766, 0.296264, -0.241435>
    }
    triangle {
      < 6.811862, 0.074463, -0.147830>,
      < 6.813909, -0.038964, -0.156984>,
      < 6.463341, -0.122263, -0.316490>
    }
    triangle {
      < 6.811862, 0.074463, -0.147830>,
      < 6.463341, -0.122263, -0.316490>,
      < 6.458183, 0.163540, -0.293424>
    }
    triangle {
      < 6.813909, -0.038964, -0.156984>,
      < 6.815204, -0.111728, -0.130381>,
      < 6.465039, -0.216685, -0.313307>
    }
    triangle {
      < 6.813909, -0.038964, -0.156984>,
      < 6.465039, -0.216685, -0.313307>,
      < 6.463341, -0.122263, -0.316490>
    }
    triangle {
      < 6.815204, -0.111728, -0.130381>,
      < 6.815650, -0.137712, -0.091405>,
      < 6.465827, -0.262925, -0.234541>
    }
    triangle {
      < 6.815204, -0.111728, -0.130381>,
      < 6.465827, -0.262925, -0.234541>,
      < 6.465039, -0.216685, -0.313307>
    }
    triangle {
      < 6.815650, -0.137712, -0.091405>,
      < 6.815914, -0.154325, -0.028692>,
      < 6.466100, -0.283377, -0.060699>
    }
    triangle {
      < 6.815650, -0.137712, -0.091405>,
      < 6.466100, -0.283377, -0.060699>,
      < 6.465827, -0.262925, -0.234541>
    }
    triangle {
      < 6.815914, -0.154325, -0.028692>,
      < 6.815879, -0.154401, 0.035663>,
      < 6.466032, -0.283528, 0.066903>
    }
    triangle {
      < 6.815914, -0.154325, -0.028692>,
      < 6.466032, -0.283528, 0.066903>,
      < 6.466100, -0.283377, -0.060699>
    }
    triangle {
      < 6.809612, 0.194786, 0.003895>,
      < 6.809759, 0.188684, -0.061458>,
      < 6.454074, 0.386660, -0.124704>
    }
    triangle {
      < 6.809612, 0.194786, 0.003895>,
      < 6.454074, 0.386660, -0.124704>,
      < 6.453789, 0.398580, 0.003902>
    }
    triangle {
      < 6.809759, 0.188684, -0.061458>,
      < 6.810111, 0.170189, -0.097966>,
      < 6.454764, 0.350531, -0.196017>
    }
    triangle {
      < 6.809759, 0.188684, -0.061458>,
      < 6.454764, 0.350531, -0.196017>,
      < 6.454074, 0.386660, -0.124704>
    }
    triangle {
      < 6.810111, 0.170189, -0.097966>,
      < 6.810624, 0.142407, -0.121215>,
      < 6.455766, 0.296264, -0.241435>
    }
    triangle {
      < 6.810111, 0.170189, -0.097966>,
      < 6.455766, 0.296264, -0.241435>,
      < 6.454764, 0.350531, -0.196017>
    }
    triangle {
      < 6.909413, 0.060882, 0.003803>,
      < 6.909470, 0.058427, -0.021891>,
      < 6.809759, 0.188684, -0.061458>
    }
    triangle {
      < 6.909413, 0.060882, 0.003803>,
      < 6.809759, 0.188684, -0.061458>,
      < 6.809612, 0.194786, 0.003895>
    }
    triangle {
      < 6.909470, 0.058427, -0.021891>,
      < 6.909614, 0.050989, -0.036574>,
      < 6.810111, 0.170189, -0.097966>
    }
    triangle {
      < 6.909470, 0.058427, -0.021891>,
      < 6.810111, 0.170189, -0.097966>,
      < 6.809759, 0.188684, -0.061458>
    }
    triangle {
      < 6.909614, 0.050989, -0.036574>,
      < 6.909820, 0.039815, -0.045926>,
      < 6.810624, 0.142407, -0.121215>
    }
    triangle {
      < 6.909614, 0.050989, -0.036574>,
      < 6.810624, 0.142407, -0.121215>,
      < 6.810111, 0.170189, -0.097966>
    }
    triangle {
      < 6.909820, 0.039815, -0.045926>,
      < 6.910316, 0.012487, -0.056630>,
      < 6.811862, 0.074463, -0.147830>
    }
    triangle {
      < 6.909820, 0.039815, -0.045926>,
      < 6.811862, 0.074463, -0.147830>,
      < 6.810624, 0.142407, -0.121215>
    }
    triangle {
      < 6.910316, 0.012487, -0.056630>,
      < 6.910817, -0.015226, -0.058867>,
      < 6.813909, -0.038964, -0.156984>
    }
    triangle {
      < 6.910316, 0.012487, -0.056630>,
      < 6.813909, -0.038964, -0.156984>,
      < 6.811862, 0.074463, -0.147830>
    }
    triangle {
      < 6.910817, -0.015226, -0.058867>,
      < 6.911661, -0.062399, -0.049612>,
      < 6.815204, -0.111728, -0.130381>
    }
    triangle {
      < 6.910817, -0.015226, -0.058867>,
      < 6.815204, -0.111728, -0.130381>,
      < 6.813909, -0.038964, -0.156984>
    }
    triangle {
      < 6.911661, -0.062399, -0.049612>,
      < 6.911918, -0.077361, -0.027171>,
      < 6.815650, -0.137712, -0.091405>
    }
    triangle {
      < 6.911661, -0.062399, -0.049612>,
      < 6.815650, -0.137712, -0.091405>,
      < 6.815204, -0.111728, -0.130381>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.911947, -0.079532, -0.008712>,
      < 6.815914, -0.154325, -0.028692>
    }
    triangle {
      < 6.911918, -0.077361, -0.027171>,
      < 6.815914, -0.154325, -0.028692>,
      < 6.815650, -0.137712, -0.091405>
    }
    triangle {
      < 6.911947, -0.079532, -0.008712>,
      < 6.911934, -0.079561, 0.015987>,
      < 6.815879, -0.154401, 0.035663>
    }
    triangle {
      < 6.911947, -0.079532, -0.008712>,
      < 6.815879, -0.154401, 0.035663>,
      < 6.815914, -0.154325, -0.028692>
    }
    triangle {
      < 5.358891, 0.704221, -0.234751>,
      < 5.386329, 0.715915, -0.210003>,
      < 5.400300, 0.708349, -0.222295>
    }
    triangle {
      < 5.358891, 0.704221, -0.234751>,
      < 5.400300, 0.708349, -0.222295>,
      < 5.401195, 0.661241, -0.308919>
    }
    triangle {
      < 3.443912, -0.450444, 0.100856>,
      < 3.444031, -0.450206, -0.099375>,
      < 5.420188, -0.400418, -0.097842>
    }
    triangle {
      < 3.443912, -0.450444, 0.100856>,
      < 5.420188, -0.400418, -0.097842>,
      < 5.420081, -0.400655, 0.102390>
    }
    triangle {
      < 3.444031, -0.450206, -0.099375>,
      < 3.443414, -0.409388, -0.422869>,
      < 5.419632, -0.359599, -0.421335>
    }
    triangle {
      < 3.444031, -0.450206, -0.099375>,
      < 5.419632, -0.359599, -0.421335>,
      < 5.420188, -0.400418, -0.097842>
    }
    triangle {
      < 3.443414, -0.409388, -0.422869>,
      < 3.442041, -0.338544, -0.493561>,
      < 5.418396, -0.288755, -0.492026>
    }
    triangle {
      < 3.443414, -0.409388, -0.422869>,
      < 5.418396, -0.288755, -0.492026>,
      < 5.419632, -0.359599, -0.421335>
    }
    triangle {
      < 3.442041, -0.338544, -0.493561>,
      < 3.440835, -0.277878, -0.505852>,
      < 5.417311, -0.228089, -0.504318>
    }
    triangle {
      < 3.442041, -0.338544, -0.493561>,
      < 5.417311, -0.228089, -0.504318>,
      < 5.418396, -0.288755, -0.492026>
    }
    triangle {
      < 3.440835, -0.277878, -0.505852>,
      < 3.426097, 0.457709, -0.462294>,
      < 5.406918, 0.348052, -0.460947>
    }
    triangle {
      < 3.440835, -0.277878, -0.505852>,
      < 5.406918, 0.348052, -0.460947>,
      < 5.417311, -0.228089, -0.504318>
    }
    triangle {
      < 3.426097, 0.457709, -0.462294>,
      < 3.421601, 0.680004, -0.381149>,
      < 5.402871, 0.570347, -0.379800>
    }
    triangle {
      < 3.426097, 0.457709, -0.462294>,
      < 5.402871, 0.570347, -0.379800>,
      < 5.406918, 0.348052, -0.460947>
    }
    triangle {
      < 3.421601, 0.680004, -0.381149>,
      < 3.419740, 0.770898, -0.310266>,
      < 4.638288, 0.702922, -0.309373>
    }
    triangle {
      < 3.421601, 0.680004, -0.381149>,
      < 4.638288, 0.702922, -0.309373>,
      < 5.076170, 0.678999, -0.309112>
    }
    triangle {
      < 3.421601, 0.680004, -0.381149>,
      < 5.076170, 0.678999, -0.309112>,
      < 5.401195, 0.661241, -0.308919>
    }
    triangle {
      < 3.421601, 0.680004, -0.381149>,
      < 5.401195, 0.661241, -0.308919>,
      < 5.402871, 0.570347, -0.379800>
    }
    triangle {
      < 4.612501, 0.732763, -0.296910>,
      < 4.637933, 0.722389, -0.301503>,
      < 4.638288, 0.702922, -0.309373>
    }
    triangle {
      < 4.612501, 0.732763, -0.296910>,
      < 4.638288, 0.702922, -0.309373>,
      < 3.419740, 0.770898, -0.310266>
    }
    triangle {
      < 4.612501, 0.732763, -0.296910>,
      < 3.419740, 0.770898, -0.310266>,
      < 3.986979, 0.748694, -0.280562>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 3.418460, 0.831417, -0.198978>,
      < 3.418271, 0.838645, -0.125812>,
      < 4.016440, 1.102478, -0.175936>
    }
    triangle {
      < 3.418460, 0.831417, -0.198978>,
      < 4.016440, 1.102478, -0.175936>,
      < 3.981828, 1.046763, -0.265169>
    }
    triangle {
      < 4.796057, 1.156596, 0.003709>,
      < 5.399573, 0.741740, 0.003615>,
      < 5.399979, 0.724540, -0.169506>
    }
    triangle {
      < 4.796057, 1.156596, 0.003709>,
      < 5.399979, 0.724540, -0.169506>,
      < 4.816844, 1.147124, -0.123930>
    }
    triangle {
      < 4.613523, 1.195118, 0.003634>,
      < 4.748710, 1.175359, 0.003701>,
      < 4.768688, 1.164907, -0.122669>
    }
    triangle {
      < 4.613523, 1.195118, 0.003634>,
      < 4.768688, 1.164907, -0.122669>,
      < 4.613729, 1.187379, -0.122774>
    }
    triangle {
      < 3.418460, 0.831417, -0.198978>,
      < 3.981828, 1.046763, -0.265169>,
      < 3.986979, 0.748694, -0.280562>
    }
    triangle {
      < 3.418460, 0.831417, -0.198978>,
      < 3.986979, 0.748694, -0.280562>,
      < 3.650708, 0.777855, -0.255508>
    }
    triangle {
      < 3.417936, 0.851397, 0.002268>,
      < 4.045876, 1.128057, 0.003182>,
      < 4.015159, 1.117188, -0.122892>
    }
    triangle {
      < 3.417936, 0.851397, 0.002268>,
      < 4.015159, 1.117188, -0.122892>,
      < 3.418126, 0.844168, -0.069908>
    }
    triangle {
      < 4.724623, 1.074010, -0.261035>,
      < 4.615929, 1.069365, -0.264962>,
      < 4.614146, 1.165641, -0.170464>
    }
    triangle {
      < 4.724623, 1.074010, -0.261035>,
      < 4.614146, 1.165641, -0.170464>,
      < 4.763483, 1.143770, -0.170429>
    }
    triangle {
      < 5.076170, 0.678999, -0.309112>,
      < 4.677096, 0.768769, -0.294339>,
      < 4.768994, 1.040806, -0.267591>
    }
    triangle {
      < 5.358891, 0.704221, -0.234751>,
      < 4.772037, 1.050352, -0.263876>,
      < 4.810962, 1.126351, -0.172464>
    }
    triangle {
      < 5.358891, 0.704221, -0.234751>,
      < 4.810962, 1.126351, -0.172464>,
      < 5.386329, 0.715915, -0.210003>
    }
    triangle {
      < 5.246199, 0.689862, -0.271915>,
      < 5.076170, 0.678999, -0.309112>,
      < 4.768994, 1.040806, -0.267591>
    }
    triangle {
      < 5.246199, 0.689862, -0.271915>,
      < 4.768994, 1.040806, -0.267591>,
      < 4.772037, 1.050352, -0.263876>
    }
    triangle {
      < 5.246199, 0.689862, -0.271915>,
      < 4.772037, 1.050352, -0.263876>,
      < 5.358891, 0.704221, -0.234751>
    }
    triangle {
      < 4.615929, 1.069365, -0.264962>,
      < 4.633419, 0.799140, -0.291090>,
      < 4.612501, 0.732763, -0.296910>
    }
    triangle {
      < 4.615929, 1.069365, -0.264962>,
      < 4.612501, 0.732763, -0.296910>,
      < 3.986979, 0.748694, -0.280562>
    }
    triangle {
      < 4.615929, 1.069365, -0.264962>,
      < 3.986979, 0.748694, -0.280562>,
      < 3.981828, 1.046763, -0.265169>
    }
    triangle {
      < 4.614146, 1.165641, -0.170464>,
      < 4.615929, 1.069365, -0.264962>,
      < 3.981828, 1.046763, -0.265169>
    }
    triangle {
      < 4.614146, 1.165641, -0.170464>,
      < 3.981828, 1.046763, -0.265169>,
      < 4.016440, 1.102478, -0.175936>
    }
    triangle {
      < 4.613523, 1.195118, 0.003634>,
      < 4.613729, 1.187379, -0.122774>,
      < 4.015159, 1.117188, -0.122892>
    }
    triangle {
      < 4.613523, 1.195118, 0.003634>,
      < 4.015159, 1.117188, -0.122892>,
      < 4.045876, 1.128057, 0.003182>
    }
    triangle {
      < 4.615929, 1.069365, -0.264962>,
      < 4.724623, 1.074010, -0.261035>,
      < 4.633419, 0.799140, -0.291090>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 4.638288, 0.702922, -0.309373>,
      < 4.637933, 0.722389, -0.301503>,
      < 4.677096, 0.768769, -0.294339>
    }
    triangle {
      < 4.638288, 0.702922, -0.309373>,
      < 4.677096, 0.768769, -0.294339>,
      < 5.076170, 0.678999, -0.309112>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 4.810962, 1.126351, -0.172464>,
      < 4.763483, 1.143770, -0.170429>,
      < 4.768688, 1.164907, -0.122669>
    }
    triangle {
      < 4.810962, 1.126351, -0.172464>,
      < 4.768688, 1.164907, -0.122669>,
      < 4.816844, 1.147124, -0.123930>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 4.624467, 0.714666, -0.196381>,
      < 5.400300, 0.708349, -0.222295>,
      < 5.386329, 0.715915, -0.210003>
    }
    triangle {
      < 4.624467, 0.714666, -0.196381>,
      < 5.386329, 0.715915, -0.210003>,
      < 5.399979, 0.724540, -0.169506>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 4.768994, 1.040806, -0.267591>,
      < 4.724623, 1.074010, -0.261035>,
      < 4.772037, 1.050352, -0.263876>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 4.637933, 0.722389, -0.301503>,
      < 4.612501, 0.732763, -0.296910>,
      < 4.633419, 0.799140, -0.291090>
    }
    triangle {
      < 4.637933, 0.722389, -0.301503>,
      < 4.633419, 0.799140, -0.291090>,
      < 4.677096, 0.768769, -0.294339>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 5.386329, 0.715915, -0.210003>,
      < 4.810962, 1.126351, -0.172464>,
      < 4.816844, 1.147124, -0.123930>
    }
    triangle {
      < 5.386329, 0.715915, -0.210003>,
      < 4.816844, 1.147124, -0.123930>,
      < 5.399979, 0.724540, -0.169506>
    }
    triangle {
      < 4.763483, 1.143770, -0.170429>,
      < 4.614146, 1.165641, -0.170464>,
      < 4.613729, 1.187379, -0.122774>
    }
    triangle {
      < 4.763483, 1.143770, -0.170429>,
      < 4.613729, 1.187379, -0.122774>,
      < 4.768688, 1.164907, -0.122669>
    }
    triangle {
      < 4.015159, 1.117188, -0.122892>,
      < 4.613729, 1.187379, -0.122774>,
      < 4.614146, 1.165641, -0.170464>
    }
    triangle {
      < 4.015159, 1.117188, -0.122892>,
      < 4.614146, 1.165641, -0.170464>,
      < 4.016440, 1.102478, -0.175936>
    }
    triangle {
      < 3.418126, 0.844168, -0.069908>,
      < 4.015159, 1.117188, -0.122892>,
      < 4.016440, 1.102478, -0.175936>
    }
    triangle {
      < 3.418126, 0.844168, -0.069908>,
      < 4.016440, 1.102478, -0.175936>,
      < 3.418271, 0.838645, -0.125812>
    }
    triangle {
      < 4.796057, 1.156596, 0.003709>,
      < 4.816844, 1.147124, -0.123930>,
      < 4.768688, 1.164907, -0.122669>
    }
    triangle {
      < 4.796057, 1.156596, 0.003709>,
      < 4.768688, 1.164907, -0.122669>,
      < 4.748710, 1.175359, 0.003701>
    }
    triangle {
      < 4.810962, 1.126351, -0.172464>,
      < 4.772037, 1.050352, -0.263876>,
      < 4.724623, 1.074010, -0.261035>
    }
    triangle {
      < 4.810962, 1.126351, -0.172464>,
      < 4.724623, 1.074010, -0.261035>,
      < 4.763483, 1.143770, -0.170429>
    }
    triangle {
      < 4.633419, 0.799140, -0.291090>,
      < 4.724623, 1.074010, -0.261035>,
      < 4.768994, 1.040806, -0.267591>
    }
    triangle {
      < 4.633419, 0.799140, -0.291090>,
      < 4.768994, 1.040806, -0.267591>,
      < 4.677096, 0.768769, -0.294339>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 3.418460, 0.831417, -0.198978>,
      < 3.650708, 0.777855, -0.255508>,
      < 3.419740, 0.770898, -0.310266>
    }
    triangle {
      < 3.650708, 0.777855, -0.255508>,
      < 3.986979, 0.748694, -0.280562>,
      < 3.419740, 0.770898, -0.310266>
    }
    triangle {
      < 5.076170, 0.678999, -0.309112>,
      < 5.246199, 0.689862, -0.271915>,
      < 5.401195, 0.661241, -0.308919>
    }
    triangle {
      < 5.246199, 0.689862, -0.271915>,
      < 5.358891, 0.704221, -0.234751>,
      < 5.401195, 0.661241, -0.308919>
    }
    triangle {
      < 3.204662, -0.282600, -0.505998>,
      < 3.189924, 0.452985, -0.462440>,
      < 3.426097, 0.457709, -0.462294>
    }
    triangle {
      < 3.204662, -0.282600, -0.505998>,
      < 3.426097, 0.457709, -0.462294>,
      < 3.440835, -0.277878, -0.505852>
    }
    triangle {
      < 3.189924, 0.452985, -0.462440>,
      < 3.185428, 0.675280, -0.381294>,
      < 3.421601, 0.680004, -0.381149>
    }
    triangle {
      < 3.189924, 0.452985, -0.462440>,
      < 3.421601, 0.680004, -0.381149>,
      < 3.426097, 0.457709, -0.462294>
    }
    triangle {
      < 3.185428, 0.675280, -0.381294>,
      < 3.183567, 0.766174, -0.310413>,
      < 3.419740, 0.770898, -0.310266>
    }
    triangle {
      < 3.185428, 0.675280, -0.381294>,
      < 3.419740, 0.770898, -0.310266>,
      < 3.421601, 0.680004, -0.381149>
    }
    triangle {
      < 3.183567, 0.766174, -0.310413>,
      < 3.182407, 0.820704, -0.199131>,
      < 3.418460, 0.831417, -0.198978>
    }
    triangle {
      < 3.183567, 0.766174, -0.310413>,
      < 3.418460, 0.831417, -0.198978>,
      < 3.419740, 0.770898, -0.310266>
    }
    triangle {
      < 3.182407, 0.820704, -0.199131>,
      < 3.182232, 0.827210, -0.125965>,
      < 3.418271, 0.838645, -0.125812>
    }
    triangle {
      < 3.182407, 0.820704, -0.199131>,
      < 3.418271, 0.838645, -0.125812>,
      < 3.418460, 0.831417, -0.198978>
    }
    triangle {
      < 3.182232, 0.827210, -0.125965>,
      < 3.182098, 0.832181, -0.070062>,
      < 3.418126, 0.844168, -0.069908>
    }
    triangle {
      < 3.182232, 0.827210, -0.125965>,
      < 3.418126, 0.844168, -0.069908>,
      < 3.418271, 0.838645, -0.125812>
    }
    triangle {
      < 3.182098, 0.832181, -0.070062>,
      < 3.181923, 0.838687, 0.002113>,
      < 3.417936, 0.851397, 0.002268>
    }
    triangle {
      < 3.182098, 0.832181, -0.070062>,
      < 3.417936, 0.851397, 0.002268>,
      < 3.418126, 0.844168, -0.069908>
    }
    triangle {
      < 3.443912, -0.450444, 0.100856>,
      < 3.207739, -0.455167, 0.100711>,
      < 3.207858, -0.454929, -0.099522>
    }
    triangle {
      < 3.443912, -0.450444, 0.100856>,
      < 3.207858, -0.454929, -0.099522>,
      < 3.444031, -0.450206, -0.099375>
    }
    triangle {
      < 3.207858, -0.454929, -0.099522>,
      < 3.207242, -0.414112, -0.423015>,
      < 3.443414, -0.409388, -0.422869>
    }
    triangle {
      < 3.207858, -0.454929, -0.099522>,
      < 3.443414, -0.409388, -0.422869>,
      < 3.444031, -0.450206, -0.099375>
    }
    triangle {
      < 3.207242, -0.414112, -0.423015>,
      < 3.205867, -0.343267, -0.493707>,
      < 3.442041, -0.338544, -0.493561>
    }
    triangle {
      < 3.207242, -0.414112, -0.423015>,
      < 3.442041, -0.338544, -0.493561>,
      < 3.443414, -0.409388, -0.422869>
    }
    triangle {
      < 3.205867, -0.343267, -0.493707>,
      < 3.204662, -0.282600, -0.505998>,
      < 3.440835, -0.277878, -0.505852>
    }
    triangle {
      < 3.205867, -0.343267, -0.493707>,
      < 3.440835, -0.277878, -0.505852>,
      < 3.442041, -0.338544, -0.493561>
    }
    triangle {
      < 1.541242, -0.492372, -0.100830>,
      < 1.540494, -0.445023, -0.424316>,
      < 3.207242, -0.414112, -0.423015>
    }
    triangle {
      < 1.541242, -0.492372, -0.100830>,
      < 3.207242, -0.414112, -0.423015>,
      < 3.207858, -0.454929, -0.099522>
    }
    triangle {
      < 1.540494, -0.445023, -0.424316>,
      < 1.567656, -0.417002, -0.447858>,
      < 1.594818, -0.388980, -0.471402>
    }
    triangle {
      < 1.540494, -0.445023, -0.424316>,
      < 1.594818, -0.388980, -0.471402>,
      < 1.621980, -0.360958, -0.494943>
    }
    triangle {
      < 1.540494, -0.445023, -0.424316>,
      < 1.621980, -0.360958, -0.494943>,
      < 3.205867, -0.343267, -0.493707>
    }
    triangle {
      < 1.540494, -0.445023, -0.424316>,
      < 3.205867, -0.343267, -0.493707>,
      < 3.207242, -0.414112, -0.423015>
    }
    triangle {
      < 1.621980, -0.360958, -0.494943>,
      < 1.593913, -0.342891, -0.499060>,
      < 1.565759, -0.320415, -0.503170>
    }
    triangle {
      < 1.621980, -0.360958, -0.494943>,
      < 1.565759, -0.320415, -0.503170>,
      < 1.537491, -0.292288, -0.507275>
    }
    triangle {
      < 1.621980, -0.360958, -0.494943>,
      < 1.537491, -0.292288, -0.507275>,
      < 3.204662, -0.282600, -0.505998>
    }
    triangle {
      < 1.621980, -0.360958, -0.494943>,
      < 3.204662, -0.282600, -0.505998>,
      < 3.205867, -0.343267, -0.493707>
    }
    triangle {
      < 1.537491, -0.292288, -0.507275>,
      < 1.523624, 0.399720, -0.463767>,
      < 3.189924, 0.452985, -0.462440>
    }
    triangle {
      < 1.537491, -0.292288, -0.507275>,
      < 3.189924, 0.452985, -0.462440>,
      < 3.204662, -0.282600, -0.505998>
    }
    triangle {
      < 1.523624, 0.399720, -0.463767>,
      < 1.519220, 0.617437, -0.382627>,
      < 3.185428, 0.675280, -0.381294>
    }
    triangle {
      < 1.523624, 0.399720, -0.463767>,
      < 3.185428, 0.675280, -0.381294>,
      < 3.189924, 0.452985, -0.462440>
    }
    triangle {
      < 1.519220, 0.617437, -0.382627>,
      < 1.517395, 0.706459, -0.311748>,
      < 3.183567, 0.766174, -0.310413>
    }
    triangle {
      < 1.519220, 0.617437, -0.382627>,
      < 3.183567, 0.766174, -0.310413>,
      < 3.185428, 0.675280, -0.381294>
    }
    triangle {
      < 1.517395, 0.706459, -0.311748>,
      < 1.516259, 0.759864, -0.200468>,
      < 3.182407, 0.820704, -0.199131>
    }
    triangle {
      < 1.517395, 0.706459, -0.311748>,
      < 3.182407, 0.820704, -0.199131>,
      < 3.183567, 0.766174, -0.310413>
    }
    triangle {
      < 1.516259, 0.759864, -0.200468>,
      < 1.516086, 0.766235, -0.127303>,
      < 3.182232, 0.827210, -0.125965>
    }
    triangle {
      < 1.516259, 0.759864, -0.200468>,
      < 3.182232, 0.827210, -0.125965>,
      < 3.182407, 0.820704, -0.199131>
    }
    triangle {
      < 1.516086, 0.766235, -0.127303>,
      < 1.515955, 0.771102, -0.071399>,
      < 3.182098, 0.832181, -0.070062>
    }
    triangle {
      < 1.516086, 0.766235, -0.127303>,
      < 3.182098, 0.832181, -0.070062>,
      < 3.182232, 0.827210, -0.125965>
    }
    triangle {
      < 1.515955, 0.771102, -0.071399>,
      < 1.515782, 0.777472, 0.000775>,
      < 3.181923, 0.838687, 0.002113>
    }
    triangle {
      < 1.515955, 0.771102, -0.071399>,
      < 3.181923, 0.838687, 0.002113>,
      < 3.182098, 0.832181, -0.070062>
    }
    triangle {
      < 3.207739, -0.455167, 0.100711>,
      < 1.541123, -0.492610, 0.099401>,
      < 1.541242, -0.492372, -0.100830>
    }
    triangle {
      < 3.207739, -0.455167, 0.100711>,
      < 1.541242, -0.492372, -0.100830>,
      < 3.207858, -0.454929, -0.099522>
    }
    triangle {
      < -1.246635, 0.603513, -0.066561>,
      < -1.246803, 0.609891, -0.001061>,
      < 1.515782, 0.777472, 0.000775>
    }
    triangle {
      < -1.246635, 0.603513, -0.066561>,
      < 1.515782, 0.777472, 0.000775>,
      < 1.515955, 0.771102, -0.071399>
    }
    triangle {
      < 1.541123, -0.492610, 0.099401>,
      < -1.224787, -0.494007, 0.097761>,
      < -1.224668, -0.493770, -0.102471>
    }
    triangle {
      < 1.541123, -0.492610, 0.099401>,
      < -1.224668, -0.493770, -0.102471>,
      < 1.541242, -0.492372, -0.100830>
    }
    triangle {
      < -1.224668, -0.493770, -0.102471>,
      < -1.224841, -0.475193, -0.425991>,
      < 1.382895, -0.448176, -0.424414>
    }
    triangle {
      < -1.224668, -0.493770, -0.102471>,
      < 1.382895, -0.448176, -0.424414>,
      < 1.540494, -0.445023, -0.424316>
    }
    triangle {
      < -1.224668, -0.493770, -0.102471>,
      < 1.540494, -0.445023, -0.424316>,
      < 1.541242, -0.492372, -0.100830>
    }
    triangle {
      < 1.540494, -0.445023, -0.424316>,
      < 1.518598, -0.426864, -0.440636>,
      < 1.559135, -0.396491, -0.460653>
    }
    triangle {
      < 1.540494, -0.445023, -0.424316>,
      < 1.559135, -0.396491, -0.460653>,
      < 1.567656, -0.417002, -0.447858>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < 1.049418, -0.189575, -0.504524>,
      < 0.655392, -0.114822, -0.501210>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < 0.655392, -0.114822, -0.501210>,
      < 0.215364, -0.044218, -0.499551>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < 0.215364, -0.044218, -0.499551>,
      < -0.225813, 0.017949, -0.496660>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -0.225813, 0.017949, -0.496660>,
      < -0.376411, 0.014991, -0.497510>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -0.376411, 0.014991, -0.497510>,
      < -0.518354, 0.002614, -0.497162>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -0.518354, 0.002614, -0.497162>,
      < -0.670616, -0.039394, -0.499334>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -0.670616, -0.039394, -0.499334>,
      < -0.809350, -0.089921, -0.500278>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -0.809350, -0.089921, -0.500278>,
      < -0.963391, -0.165236, -0.505193>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -0.963391, -0.165236, -0.505193>,
      < -1.228420, -0.293687, -0.508915>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -1.228420, -0.293687, -0.508915>,
      < -1.238962, 0.232139, -0.465603>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < -1.238962, 0.232139, -0.465603>,
      < 1.523624, 0.399720, -0.463767>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < 1.523624, 0.399720, -0.463767>,
      < 1.537491, -0.292288, -0.507275>
    }
    triangle {
      < -1.238962, 0.232139, -0.465603>,
      < -1.243387, 0.449815, -0.349415>,
      < 1.519220, 0.617437, -0.382627>
    }
    triangle {
      < -1.238962, 0.232139, -0.465603>,
      < 1.519220, 0.617437, -0.382627>,
      < 1.523624, 0.399720, -0.463767>
    }
    triangle {
      < -1.243387, 0.449815, -0.349415>,
      < -1.177950, 0.542925, -0.285643>,
      < 1.517395, 0.706459, -0.311748>
    }
    triangle {
      < -1.243387, 0.449815, -0.349415>,
      < 1.517395, 0.706459, -0.311748>,
      < 1.519220, 0.617437, -0.382627>
    }
    triangle {
      < -1.177950, 0.542925, -0.285643>,
      < -1.246338, 0.592262, -0.183857>,
      < 1.516259, 0.759864, -0.200468>
    }
    triangle {
      < -1.177950, 0.542925, -0.285643>,
      < 1.516259, 0.759864, -0.200468>,
      < 1.517395, 0.706459, -0.311748>
    }
    triangle {
      < -1.246338, 0.592262, -0.183857>,
      < -1.246507, 0.598641, -0.117366>,
      < 1.516086, 0.766235, -0.127303>
    }
    triangle {
      < -1.246338, 0.592262, -0.183857>,
      < 1.516086, 0.766235, -0.127303>,
      < 1.516259, 0.759864, -0.200468>
    }
    triangle {
      < -1.246507, 0.598641, -0.117366>,
      < -1.246635, 0.603513, -0.066561>,
      < 1.515955, 0.771102, -0.071399>
    }
    triangle {
      < -1.246507, 0.598641, -0.117366>,
      < 1.515955, 0.771102, -0.071399>,
      < 1.516086, 0.766235, -0.127303>
    }
    texture {parts_fuselage}
  }
  // parts_wings
  union {
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < -0.132211, 0.057195, -6.689893>,
      < -0.200780, 0.057822, -6.696388>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < -0.200780, 0.057822, -6.696388>,
      < -0.164826, 0.059329, -6.698911>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < -0.164826, 0.059329, -6.698911>,
      < -0.124109, 0.061803, -6.704247>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < -0.124109, 0.061803, -6.704247>,
      < -0.087539, 0.064803, -6.711549>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < -0.087539, 0.064803, -6.711549>,
      < -0.047462, 0.067193, -6.716648>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < -0.047462, 0.067193, -6.716648>,
      < -0.010242, 0.069477, -6.721601>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < -0.010242, 0.069477, -6.721601>,
      < 0.029207, 0.071308, -6.724942>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.029207, 0.071308, -6.724942>,
      < 0.138289, 0.077251, -6.737020>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.138289, 0.077251, -6.737020>,
      < 0.266261, 0.082554, -6.745799>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.266261, 0.082554, -6.745799>,
      < 0.380845, 0.083933, -6.742770>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.380845, 0.083933, -6.742770>,
      < 0.491071, 0.082894, -6.732240>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.491071, 0.082894, -6.732240>,
      < 0.519089, 0.081045, -6.724435>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.519089, 0.081045, -6.724435>,
      < 0.529434, 0.078181, -6.714513>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.529434, 0.078181, -6.714513>,
      < 0.528632, 0.075089, -6.704591>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.528632, 0.075089, -6.704591>,
      < 0.516683, 0.071775, -6.694669>
    }
    texture {parts_wings}
  }
  // parts_fuselage
  union {
    triangle {
      < 1.561489, -0.366599, -0.480695>,
      < 1.565759, -0.320415, -0.503170>,
      < 1.593913, -0.342891, -0.499060>
    }
    triangle {
      < 1.561489, -0.366599, -0.480695>,
      < 1.593913, -0.342891, -0.499060>,
      < 1.621980, -0.360958, -0.494943>
    }
    triangle {
      < 1.561489, -0.366599, -0.480695>,
      < 1.621980, -0.360958, -0.494943>,
      < 1.594818, -0.388980, -0.471402>
    }
    triangle {
      < 1.561489, -0.366599, -0.480695>,
      < 1.594818, -0.388980, -0.471402>,
      < 1.567656, -0.417002, -0.447858>
    }
    triangle {
      < 1.561489, -0.366599, -0.480695>,
      < 1.567656, -0.417002, -0.447858>,
      < 1.559135, -0.396491, -0.460653>
    }
    triangle {
      < 1.428477, -0.270357, -0.506525>,
      < 1.537491, -0.292288, -0.507275>,
      < 1.525506, -0.329556, -0.500751>
    }
    triangle {
      < 1.565759, -0.320415, -0.503170>,
      < 1.561489, -0.366599, -0.480695>,
      < 1.525506, -0.329556, -0.500751>
    }
    triangle {
      < 1.565759, -0.320415, -0.503170>,
      < 1.525506, -0.329556, -0.500751>,
      < 1.537491, -0.292288, -0.507275>
    }
    triangle {
      < 1.382895, -0.448176, -0.424414>,
      < 1.518598, -0.426864, -0.440636>,
      < 1.540494, -0.445023, -0.424316>
    }
    triangle {
      < 1.446115, -0.435503, -0.594676>,
      < 1.501142, -0.398032, -0.599437>,
      < 1.559135, -0.396491, -0.460653>
    }
    triangle {
      < 1.446115, -0.435503, -0.594676>,
      < 1.559135, -0.396491, -0.460653>,
      < 1.518598, -0.426864, -0.440636>
    }
    triangle {
      < 1.501142, -0.398032, -0.599437>,
      < 1.505266, -0.367902, -0.600234>,
      < 1.561489, -0.366599, -0.480695>
    }
    triangle {
      < 1.501142, -0.398032, -0.599437>,
      < 1.561489, -0.366599, -0.480695>,
      < 1.559135, -0.396491, -0.460653>
    }
    triangle {
      < 1.505266, -0.367902, -0.600234>,
      < 1.456306, -0.316213, -0.597494>,
      < 1.525506, -0.329556, -0.500751>
    }
    triangle {
      < 1.505266, -0.367902, -0.600234>,
      < 1.525506, -0.329556, -0.500751>,
      < 1.561489, -0.366599, -0.480695>
    }
    triangle {
      < 1.456306, -0.316213, -0.597494>,
      < 1.358011, -0.284441, -0.597527>,
      < 1.428477, -0.270357, -0.506525>
    }
    triangle {
      < 1.456306, -0.316213, -0.597494>,
      < 1.428477, -0.270357, -0.506525>,
      < 1.525506, -0.329556, -0.500751>
    }
    triangle {
      < 1.358011, -0.284441, -0.597527>,
      < 0.989513, -0.237534, -0.598108>,
      < 1.049418, -0.189575, -0.504524>
    }
    triangle {
      < 1.358011, -0.284441, -0.597527>,
      < 1.049418, -0.189575, -0.504524>,
      < 1.428477, -0.270357, -0.506525>
    }
    triangle {
      < 0.989513, -0.237534, -0.598108>,
      < 0.606696, -0.219738, -0.602171>,
      < 0.655392, -0.114822, -0.501210>
    }
    triangle {
      < 0.989513, -0.237534, -0.598108>,
      < 0.655392, -0.114822, -0.501210>,
      < 1.049418, -0.189575, -0.504524>
    }
    triangle {
      < 0.606696, -0.219738, -0.602171>,
      < 0.179576, -0.260280, -0.609575>,
      < 0.215364, -0.044218, -0.499551>
    }
    triangle {
      < 0.606696, -0.219738, -0.602171>,
      < 0.215364, -0.044218, -0.499551>,
      < 0.655392, -0.114822, -0.501210>
    }
    triangle {
      < 0.179576, -0.260280, -0.609575>,
      < -0.239846, -0.312152, -0.617391>,
      < -0.225813, 0.017949, -0.496660>
    }
    triangle {
      < 0.179576, -0.260280, -0.609575>,
      < -0.225813, 0.017949, -0.496660>,
      < 0.215364, -0.044218, -0.499551>
    }
    triangle {
      < -0.239846, -0.312152, -0.617391>,
      < -0.357381, -0.325393, -0.618292>,
      < -0.376411, 0.014991, -0.497510>
    }
    triangle {
      < -0.239846, -0.312152, -0.617391>,
      < -0.376411, 0.014991, -0.497510>,
      < -0.225813, 0.017949, -0.496660>
    }
    triangle {
      < -0.357381, -0.325393, -0.618292>,
      < -0.467646, -0.345177, -0.619443>,
      < -0.518354, 0.002614, -0.497162>
    }
    triangle {
      < -0.357381, -0.325393, -0.618292>,
      < -0.518354, 0.002614, -0.497162>,
      < -0.376411, 0.014991, -0.497510>
    }
    triangle {
      < -0.467646, -0.345177, -0.619443>,
      < -0.586261, -0.367322, -0.620217>,
      < -0.670616, -0.039394, -0.499334>
    }
    triangle {
      < -0.467646, -0.345177, -0.619443>,
      < -0.670616, -0.039394, -0.499334>,
      < -0.518354, 0.002614, -0.497162>
    }
    triangle {
      < -0.586261, -0.367322, -0.620217>,
      < -0.680153, -0.392197, -0.619845>,
      < -0.809350, -0.089921, -0.500278>
    }
    triangle {
      < -0.586261, -0.367322, -0.620217>,
      < -0.809350, -0.089921, -0.500278>,
      < -0.670616, -0.039394, -0.499334>
    }
    triangle {
      < -0.680153, -0.392197, -0.619845>,
      < -0.791325, -0.413795, -0.618408>,
      < -0.963391, -0.165236, -0.505193>
    }
    triangle {
      < -0.680153, -0.392197, -0.619845>,
      < -0.963391, -0.165236, -0.505193>,
      < -0.809350, -0.089921, -0.500278>
    }
    triangle {
      < -0.791325, -0.413795, -0.618408>,
      < -0.940262, -0.446160, -0.609722>,
      < -1.228420, -0.293687, -0.508915>
    }
    triangle {
      < -0.791325, -0.413795, -0.618408>,
      < -1.228420, -0.293687, -0.508915>,
      < -0.963391, -0.165236, -0.505193>
    }
    triangle {
      < -0.940262, -0.446160, -0.609722>,
      < -0.925331, -0.460638, -0.616993>,
      < -1.226364, -0.396862, -0.496674>
    }
    triangle {
      < -0.940262, -0.446160, -0.609722>,
      < -1.226364, -0.396862, -0.496674>,
      < -1.228420, -0.293687, -0.508915>
    }
    triangle {
      < -0.918767, -0.493991, -0.610227>,
      < 1.311996, -0.450444, -0.595910>,
      < 1.382895, -0.448176, -0.424414>
    }
    triangle {
      < -0.918767, -0.493991, -0.610227>,
      < 1.382895, -0.448176, -0.424414>,
      < -1.224841, -0.475193, -0.425991>
    }
    triangle {
      < 1.311996, -0.450444, -0.595910>,
      < 1.446115, -0.435503, -0.594676>,
      < 1.518598, -0.426864, -0.440636>
    }
    triangle {
      < 1.311996, -0.450444, -0.595910>,
      < 1.518598, -0.426864, -0.440636>,
      < 1.382895, -0.448176, -0.424414>
    }
    triangle {
      < -0.918767, -0.493991, -0.610227>,
      < -1.224841, -0.475193, -0.425991>,
      < -1.226364, -0.396862, -0.496674>
    }
    triangle {
      < -0.918767, -0.493991, -0.610227>,
      < -1.226364, -0.396862, -0.496674>,
      < -0.925331, -0.460638, -0.616993>
    }
    texture {parts_fuselage}
  }
  // parts_wings
  union {
    triangle {
      < -0.887309, -0.417502, -1.819137>,
      < -0.886860, -0.439938, -1.819164>,
      < -0.886675, -0.466594, -1.255044>
    }
    triangle {
      < -0.887309, -0.417502, -1.819137>,
      < -0.886675, -0.466594, -1.255044>,
      < -0.886489, -0.493250, -0.690923>
    }
    triangle {
      < -0.887309, -0.417502, -1.819137>,
      < -0.886489, -0.493250, -0.690923>,
      < -0.886939, -0.470761, -0.690896>
    }
    triangle {
      < -0.886675, -0.466594, -1.255044>,
      < -0.295327, -0.454767, -1.254679>,
      < -0.264124, -0.455616, -1.223497>
    }
    triangle {
      < -0.886675, -0.466594, -1.255044>,
      < -0.264124, -0.455616, -1.223497>,
      < -0.201650, -0.455103, -1.207878>
    }
    triangle {
      < -0.886675, -0.466594, -1.255044>,
      < -0.201650, -0.455103, -1.207878>,
      < 1.251371, -0.426043, -1.206983>
    }
    triangle {
      < -0.886675, -0.466594, -1.255044>,
      < 1.251371, -0.426043, -1.206983>,
      < 1.311825, -0.427044, -1.160203>
    }
    triangle {
      < -0.886675, -0.466594, -1.255044>,
      < 1.311825, -0.427044, -1.160203>,
      < 1.311980, -0.449282, -0.689568>
    }
    triangle {
      < -0.886675, -0.466594, -1.255044>,
      < 1.311980, -0.449282, -0.689568>,
      < -0.886489, -0.493250, -0.690923>
    }
    triangle {
      < 1.311825, -0.427044, -1.160203>,
      < 1.311800, -0.423362, -1.238104>,
      < 1.311790, -0.421890, -1.269272>
    }
    triangle {
      < 1.311825, -0.427044, -1.160203>,
      < 1.311790, -0.421890, -1.269272>,
      < 1.311765, -0.418208, -1.347173>
    }
    triangle {
      < 1.311825, -0.427044, -1.160203>,
      < 1.311765, -0.418208, -1.347173>,
      < 1.311610, -0.395970, -1.817809>
    }
    triangle {
      < 1.311825, -0.427044, -1.160203>,
      < 1.311610, -0.395970, -1.817809>,
      < 1.443411, -0.375332, -1.817705>
    }
    triangle {
      < 1.311825, -0.427044, -1.160203>,
      < 1.443411, -0.375332, -1.817705>,
      < 1.443781, -0.428602, -0.689465>
    }
    triangle {
      < 1.311825, -0.427044, -1.160203>,
      < 1.443781, -0.428602, -0.689465>,
      < 1.311980, -0.449282, -0.689568>
    }
    triangle {
      < 1.443411, -0.375332, -1.817705>,
      < 1.482655, -0.340018, -1.817638>,
      < 1.483024, -0.393205, -0.689400>
    }
    triangle {
      < 1.443411, -0.375332, -1.817705>,
      < 1.483024, -0.393205, -0.689400>,
      < 1.443781, -0.428602, -0.689465>
    }
    triangle {
      < 1.482655, -0.340018, -1.817638>,
      < 1.484823, -0.305606, -1.817601>,
      < 1.485206, -0.359547, -0.689359>
    }
    triangle {
      < 1.482655, -0.340018, -1.817638>,
      < 1.485206, -0.359547, -0.689359>,
      < 1.483024, -0.393205, -0.689400>
    }
    triangle {
      < 1.484823, -0.305606, -1.817601>,
      < 1.449907, -0.271919, -1.817586>,
      < 1.450301, -0.326387, -0.689340>
    }
    triangle {
      < 1.484823, -0.305606, -1.817601>,
      < 1.450301, -0.326387, -0.689340>,
      < 1.485206, -0.359547, -0.689359>
    }
    triangle {
      < 1.449907, -0.271919, -1.817586>,
      < 1.387498, -0.254957, -1.817591>,
      < 1.356321, -0.249769, -1.747479>
    }
    triangle {
      < 1.449907, -0.271919, -1.817586>,
      < 1.356321, -0.249769, -1.747479>,
      < 1.356663, -0.299436, -0.689363>
    }
    triangle {
      < 1.449907, -0.271919, -1.817586>,
      < 1.356663, -0.299436, -0.689363>,
      < 1.450301, -0.326387, -0.689340>
    }
    triangle {
      < 1.356321, -0.249769, -1.747479>,
      < 1.286326, -0.240938, -1.817630>,
      < 0.989105, -0.217407, -1.817783>
    }
    triangle {
      < 1.356321, -0.249769, -1.747479>,
      < 0.989105, -0.217407, -1.817783>,
      < 0.989464, -0.270118, -0.689547>
    }
    triangle {
      < 1.356321, -0.249769, -1.747479>,
      < 0.989464, -0.270118, -0.689547>,
      < 1.356663, -0.299436, -0.689363>
    }
    triangle {
      < 0.989105, -0.217407, -1.817783>,
      < 0.607788, -0.214780, -1.818007>,
      < 0.608150, -0.267627, -0.689770>
    }
    triangle {
      < 0.989105, -0.217407, -1.817783>,
      < 0.608150, -0.267627, -0.689770>,
      < 0.989464, -0.270118, -0.689547>
    }
    triangle {
      < 0.607788, -0.214780, -1.818007>,
      < 0.182544, -0.254088, -1.818305>,
      < 0.182907, -0.307008, -0.690068>
    }
    triangle {
      < 0.607788, -0.214780, -1.818007>,
      < 0.182907, -0.307008, -0.690068>,
      < 0.608150, -0.267627, -0.689770>
    }
    triangle {
      < 0.182544, -0.254088, -1.818305>,
      < -0.243750, -0.304845, -1.818620>,
      < -0.243385, -0.357866, -0.690381>
    }
    triangle {
      < 0.182544, -0.254088, -1.818305>,
      < -0.243385, -0.357866, -0.690381>,
      < 0.182907, -0.307008, -0.690068>
    }
    triangle {
      < -0.243750, -0.304845, -1.818620>,
      < -0.354218, -0.318766, -1.818703>,
      < -0.353853, -0.371816, -0.690462>
    }
    triangle {
      < -0.243750, -0.304845, -1.818620>,
      < -0.353853, -0.371816, -0.690462>,
      < -0.243385, -0.357866, -0.690381>
    }
    triangle {
      < -0.354218, -0.318766, -1.818703>,
      < -0.458354, -0.338141, -1.818787>,
      < -0.457988, -0.391231, -0.690548>
    }
    triangle {
      < -0.354218, -0.318766, -1.818703>,
      < -0.457988, -0.391231, -0.690548>,
      < -0.353853, -0.371816, -0.690462>
    }
    triangle {
      < -0.458354, -0.338141, -1.818787>,
      < -0.570499, -0.358204, -1.818878>,
      < -0.570131, -0.411337, -0.690638>
    }
    triangle {
      < -0.458354, -0.338141, -1.818787>,
      < -0.570131, -0.411337, -0.690638>,
      < -0.457988, -0.391231, -0.690548>
    }
    triangle {
      < -0.570499, -0.358204, -1.818878>,
      < -0.672674, -0.385722, -1.818972>,
      < -0.672306, -0.438917, -0.690731>
    }
    triangle {
      < -0.570499, -0.358204, -1.818878>,
      < -0.672306, -0.438917, -0.690731>,
      < -0.570131, -0.411337, -0.690638>
    }
    triangle {
      < -0.672674, -0.385722, -1.818972>,
      < -0.786599, -0.406632, -1.819064>,
      < -0.786230, -0.459871, -0.690824>
    }
    triangle {
      < -0.672674, -0.385722, -1.818972>,
      < -0.786230, -0.459871, -0.690824>,
      < -0.672306, -0.438917, -0.690731>
    }
    triangle {
      < -0.786599, -0.406632, -1.819064>,
      < -0.887309, -0.417502, -1.819137>,
      < -0.886939, -0.470761, -0.690896>
    }
    triangle {
      < -0.786599, -0.406632, -1.819064>,
      < -0.886939, -0.470761, -0.690896>,
      < -0.786230, -0.459871, -0.690824>
    }
    texture {parts_wings}
  }
  // parts_fuselage
  union {
    triangle {
      < -0.925331, -0.460638, -0.616993>,
      < -0.940262, -0.446160, -0.609722>,
      < -0.886939, -0.470761, -0.690896>
    }
    triangle {
      < -0.786230, -0.459871, -0.690824>,
      < -0.886939, -0.470761, -0.690896>,
      < -0.940262, -0.446160, -0.609722>
    }
    triangle {
      < -0.786230, -0.459871, -0.690824>,
      < -0.940262, -0.446160, -0.609722>,
      < -0.791325, -0.413795, -0.618408>
    }
    triangle {
      < -0.672306, -0.438917, -0.690731>,
      < -0.786230, -0.459871, -0.690824>,
      < -0.791325, -0.413795, -0.618408>
    }
    triangle {
      < -0.672306, -0.438917, -0.690731>,
      < -0.791325, -0.413795, -0.618408>,
      < -0.680153, -0.392197, -0.619845>
    }
    triangle {
      < -0.570131, -0.411337, -0.690638>,
      < -0.672306, -0.438917, -0.690731>,
      < -0.680153, -0.392197, -0.619845>
    }
    triangle {
      < -0.570131, -0.411337, -0.690638>,
      < -0.680153, -0.392197, -0.619845>,
      < -0.586261, -0.367322, -0.620217>
    }
    triangle {
      < -0.457988, -0.391231, -0.690548>,
      < -0.570131, -0.411337, -0.690638>,
      < -0.586261, -0.367322, -0.620217>
    }
    triangle {
      < -0.457988, -0.391231, -0.690548>,
      < -0.586261, -0.367322, -0.620217>,
      < -0.467646, -0.345177, -0.619443>
    }
    triangle {
      < -0.353853, -0.371816, -0.690462>,
      < -0.457988, -0.391231, -0.690548>,
      < -0.467646, -0.345177, -0.619443>
    }
    triangle {
      < -0.353853, -0.371816, -0.690462>,
      < -0.467646, -0.345177, -0.619443>,
      < -0.357381, -0.325393, -0.618292>
    }
    triangle {
      < -0.243385, -0.357866, -0.690381>,
      < -0.353853, -0.371816, -0.690462>,
      < -0.357381, -0.325393, -0.618292>
    }
    triangle {
      < -0.243385, -0.357866, -0.690381>,
      < -0.357381, -0.325393, -0.618292>,
      < -0.239846, -0.312152, -0.617391>
    }
    triangle {
      < 0.182907, -0.307008, -0.690068>,
      < -0.243385, -0.357866, -0.690381>,
      < -0.239846, -0.312152, -0.617391>
    }
    triangle {
      < 0.182907, -0.307008, -0.690068>,
      < -0.239846, -0.312152, -0.617391>,
      < 0.179576, -0.260280, -0.609575>
    }
    triangle {
      < 0.608150, -0.267627, -0.689770>,
      < 0.182907, -0.307008, -0.690068>,
      < 0.179576, -0.260280, -0.609575>
    }
    triangle {
      < 0.608150, -0.267627, -0.689770>,
      < 0.179576, -0.260280, -0.609575>,
      < 0.606696, -0.219738, -0.602171>
    }
    triangle {
      < 0.989464, -0.270118, -0.689547>,
      < 0.608150, -0.267627, -0.689770>,
      < 0.606696, -0.219738, -0.602171>
    }
    triangle {
      < 0.989464, -0.270118, -0.689547>,
      < 0.606696, -0.219738, -0.602171>,
      < 0.989513, -0.237534, -0.598108>
    }
    triangle {
      < 1.356663, -0.299436, -0.689363>,
      < 0.989464, -0.270118, -0.689547>,
      < 0.989513, -0.237534, -0.598108>
    }
    triangle {
      < 1.356663, -0.299436, -0.689363>,
      < 0.989513, -0.237534, -0.598108>,
      < 1.358011, -0.284441, -0.597527>
    }
    triangle {
      < 1.450301, -0.326387, -0.689340>,
      < 1.356663, -0.299436, -0.689363>,
      < 1.358011, -0.284441, -0.597527>
    }
    triangle {
      < 1.450301, -0.326387, -0.689340>,
      < 1.358011, -0.284441, -0.597527>,
      < 1.456306, -0.316213, -0.597494>
    }
    triangle {
      < 1.485206, -0.359547, -0.689359>,
      < 1.450301, -0.326387, -0.689340>,
      < 1.456306, -0.316213, -0.597494>
    }
    triangle {
      < 1.485206, -0.359547, -0.689359>,
      < 1.456306, -0.316213, -0.597494>,
      < 1.505266, -0.367902, -0.600234>
    }
    triangle {
      < 1.483024, -0.393205, -0.689400>,
      < 1.485206, -0.359547, -0.689359>,
      < 1.505266, -0.367902, -0.600234>
    }
    triangle {
      < 1.483024, -0.393205, -0.689400>,
      < 1.505266, -0.367902, -0.600234>,
      < 1.501142, -0.398032, -0.599437>
    }
    triangle {
      < 1.443781, -0.428602, -0.689465>,
      < 1.483024, -0.393205, -0.689400>,
      < 1.501142, -0.398032, -0.599437>
    }
    triangle {
      < 1.443781, -0.428602, -0.689465>,
      < 1.501142, -0.398032, -0.599437>,
      < 1.446115, -0.435503, -0.594676>
    }
    triangle {
      < 1.311980, -0.449282, -0.689568>,
      < 1.443781, -0.428602, -0.689465>,
      < 1.446115, -0.435503, -0.594676>
    }
    triangle {
      < 1.311980, -0.449282, -0.689568>,
      < 1.446115, -0.435503, -0.594676>,
      < 1.311996, -0.450444, -0.595910>
    }
    triangle {
      < -0.886489, -0.493250, -0.690923>,
      < 1.311980, -0.449282, -0.689568>,
      < 1.311996, -0.450444, -0.595910>
    }
    triangle {
      < -0.886489, -0.493250, -0.690923>,
      < 1.311996, -0.450444, -0.595910>,
      < -0.918767, -0.493991, -0.610227>
    }
    triangle {
      < -0.886939, -0.470761, -0.690896>,
      < -0.886489, -0.493250, -0.690923>,
      < -0.918767, -0.493991, -0.610227>
    }
    triangle {
      < -0.886939, -0.470761, -0.690896>,
      < -0.918767, -0.493991, -0.610227>,
      < -0.925331, -0.460638, -0.616993>
    }
    texture {parts_fuselage}
  }
  // parts_flaps1
  union {
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.350851, -0.293694, -2.098206>,
      < -0.241508, -0.279912, -2.098163>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.241508, -0.279912, -2.098163>,
      < 0.180439, -0.229676, -2.097913>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < 0.180439, -0.229676, -2.097913>,
      < 0.117970, 0.254525, -6.420486>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < 0.117970, 0.254525, -6.420486>,
      < -0.169188, 0.220348, -6.422487>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.169188, 0.220348, -6.422487>,
      < -0.243602, 0.210973, -6.423039>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.243602, 0.210973, -6.423039>,
      < -0.313750, 0.197928, -6.423829>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.313750, 0.197928, -6.423829>,
      < -0.389290, 0.184419, -6.424646>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.389290, 0.184419, -6.424646>,
      < -0.458118, 0.165890, -6.425788>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.458118, 0.165890, -6.425788>,
      < -0.534859, 0.151811, -6.426641>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.534859, 0.151811, -6.426641>,
      < -0.602699, 0.144491, -6.427065>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.602699, 0.144491, -6.427065>,
      < -0.878539, -0.391446, -2.098285>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.878539, -0.391446, -2.098285>,
      < -0.778848, -0.380679, -2.098287>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.778848, -0.380679, -2.098287>,
      < -0.666076, -0.359975, -2.098279>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.666076, -0.359975, -2.098279>,
      < -0.564933, -0.332735, -2.098264>
    }
    triangle {
      < -0.602699, 0.144491, -6.427065>,
      < -0.602396, 0.129385, -6.428035>,
      < -0.730872, -0.122688, -4.410817>
    }
    triangle {
      < -0.602699, 0.144491, -6.427065>,
      < -0.730872, -0.122688, -4.410817>,
      < -0.740168, -0.141976, -4.264418>
    }
    triangle {
      < -0.602699, 0.144491, -6.427065>,
      < -0.740168, -0.141976, -4.264418>,
      < -0.878099, -0.413651, -2.098285>
    }
    triangle {
      < -0.602699, 0.144491, -6.427065>,
      < -0.878099, -0.413651, -2.098285>,
      < -0.878539, -0.391446, -2.098285>
    }
    texture {parts_flaps1}
  }
  // parts_wings
  union {
    triangle {
      < 0.021887, -0.063962, -4.769609>,
      < 0.068094, -0.057210, -4.816535>,
      < 0.977483, -0.037770, -4.826049>
    }
    triangle {
      < 0.021887, -0.063962, -4.769609>,
      < 0.977483, -0.037770, -4.826049>,
      < 1.038069, -0.042221, -4.780401>
    }
    triangle {
      < 0.021887, -0.063962, -4.769609>,
      < 1.038069, -0.042221, -4.780401>,
      < 1.076022, -0.090090, -4.388656>
    }
    triangle {
      < 0.021887, -0.063962, -4.769609>,
      < 1.076022, -0.090090, -4.388656>,
      < 0.027707, -0.107382, -4.418913>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.227710, -0.281411, -2.822975>,
      < 1.224713, -0.277631, -2.853905>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.224713, -0.277631, -2.853905>,
      < 1.217237, -0.268204, -2.931062>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.217237, -0.268204, -2.931062>,
      < 1.160101, -0.196138, -3.520810>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.160101, -0.196138, -3.520810>,
      < 1.152618, -0.186700, -3.598044>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.152618, -0.186700, -3.598044>,
      < 1.149614, -0.182911, -3.629052>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.149614, -0.182911, -3.629052>,
      < 1.142131, -0.173473, -3.706285>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.142131, -0.173473, -3.706285>,
      < 1.076022, -0.090090, -4.388656>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.076022, -0.090090, -4.388656>,
      < 1.038069, -0.042221, -4.780401>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.038069, -0.042221, -4.780401>,
      < 1.030594, -0.032791, -4.857564>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.030594, -0.032791, -4.857564>,
      < 1.027596, -0.029011, -4.888500>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.027596, -0.029011, -4.888500>,
      < 1.020120, -0.019582, -4.965664>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.020120, -0.019582, -4.965664>,
      < 0.878530, 0.159003, -6.427121>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 0.878530, 0.159003, -6.427121>,
      < 0.967314, 0.172900, -6.426290>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 0.967314, 0.172900, -6.426290>,
      < 1.428557, -0.349757, -2.096411>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.428557, -0.349757, -2.096411>,
      < 1.298080, -0.370169, -2.096622>
    }
    triangle {
      < 0.967314, 0.172900, -6.426290>,
      < 0.993748, 0.196676, -6.424781>,
      < 1.467399, -0.314810, -2.096342>
    }
    triangle {
      < 0.967314, 0.172900, -6.426290>,
      < 1.467399, -0.314810, -2.096342>,
      < 1.428557, -0.349757, -2.096411>
    }
    triangle {
      < 0.993748, 0.196676, -6.424781>,
      < 0.995206, 0.219940, -6.423290>,
      < 1.469532, -0.280613, -2.096335>
    }
    triangle {
      < 0.993748, 0.196676, -6.424781>,
      < 1.469532, -0.280613, -2.096335>,
      < 1.467399, -0.314810, -2.096342>
    }
    triangle {
      < 0.995206, 0.219940, -6.423290>,
      < 0.971684, 0.242689, -6.421815>,
      < 1.434956, -0.247168, -2.096388>
    }
    triangle {
      < 0.995206, 0.219940, -6.423290>,
      < 1.434956, -0.247168, -2.096388>,
      < 1.469532, -0.280613, -2.096335>
    }
    triangle {
      < 0.971684, 0.242689, -6.421815>,
      < 0.908630, 0.259656, -6.420684>,
      < 1.335324, -0.214479, -2.165953>
    }
    triangle {
      < 0.971684, 0.242689, -6.421815>,
      < 1.335324, -0.214479, -2.165953>,
      < 1.373173, -0.230532, -2.096487>
    }
    triangle {
      < 0.971684, 0.242689, -6.421815>,
      < 1.373173, -0.230532, -2.096487>,
      < 1.434956, -0.247168, -2.096388>
    }
    triangle {
      < 1.335324, -0.214479, -2.165953>,
      < 0.908630, 0.259656, -6.420684>,
      < 0.661282, 0.279210, -6.419264>
    }
    triangle {
      < 1.335324, -0.214479, -2.165953>,
      < 0.661282, 0.279210, -6.419264>,
      < 0.978792, -0.193436, -2.097076>
    }
    triangle {
      < 1.335324, -0.214479, -2.165953>,
      < 0.978792, -0.193436, -2.097076>,
      < 1.272313, -0.216675, -2.096640>
    }
    triangle {
      < 0.661282, 0.279210, -6.419264>,
      < 0.404420, 0.280993, -6.418981>,
      < 0.601346, -0.190786, -2.097529>
    }
    triangle {
      < 0.661282, 0.279210, -6.419264>,
      < 0.601346, -0.190786, -2.097529>,
      < 0.978792, -0.193436, -2.097076>
    }
    triangle {
      < 0.404420, 0.280993, -6.418981>,
      < 0.117970, 0.254525, -6.420486>,
      < 0.180439, -0.229676, -2.097913>
    }
    triangle {
      < 0.404420, 0.280993, -6.418981>,
      < 0.180439, -0.229676, -2.097913>,
      < 0.601346, -0.190786, -2.097529>
    }
    triangle {
      < 0.180439, -0.229676, -2.097913>,
      < -0.241508, -0.279912, -2.098163>,
      < -0.243750, -0.304845, -1.818620>
    }
    triangle {
      < 0.180439, -0.229676, -2.097913>,
      < -0.243750, -0.304845, -1.818620>,
      < 0.182544, -0.254088, -1.818305>
    }
    triangle {
      < -0.241508, -0.279912, -2.098163>,
      < -0.350851, -0.293694, -2.098206>,
      < -0.354218, -0.318766, -1.818703>
    }
    triangle {
      < -0.241508, -0.279912, -2.098163>,
      < -0.354218, -0.318766, -1.818703>,
      < -0.243750, -0.304845, -1.818620>
    }
    triangle {
      < -0.350851, -0.293694, -2.098206>,
      < -0.453929, -0.312872, -2.098238>,
      < -0.458354, -0.338141, -1.818787>
    }
    triangle {
      < -0.350851, -0.293694, -2.098206>,
      < -0.458354, -0.338141, -1.818787>,
      < -0.354218, -0.318766, -1.818703>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.564933, -0.332735, -2.098264>,
      < -0.570499, -0.358204, -1.818878>
    }
    triangle {
      < -0.453929, -0.312872, -2.098238>,
      < -0.570499, -0.358204, -1.818878>,
      < -0.458354, -0.338141, -1.818787>
    }
    triangle {
      < -0.564933, -0.332735, -2.098264>,
      < -0.666076, -0.359975, -2.098279>,
      < -0.672674, -0.385722, -1.818972>
    }
    triangle {
      < -0.564933, -0.332735, -2.098264>,
      < -0.672674, -0.385722, -1.818972>,
      < -0.570499, -0.358204, -1.818878>
    }
    triangle {
      < -0.666076, -0.359975, -2.098279>,
      < -0.778848, -0.380679, -2.098287>,
      < -0.786599, -0.406632, -1.819064>
    }
    triangle {
      < -0.666076, -0.359975, -2.098279>,
      < -0.786599, -0.406632, -1.819064>,
      < -0.672674, -0.385722, -1.818972>
    }
    triangle {
      < -0.778848, -0.380679, -2.098287>,
      < -0.878539, -0.391446, -2.098285>,
      < -0.887309, -0.417502, -1.819137>
    }
    triangle {
      < -0.778848, -0.380679, -2.098287>,
      < -0.887309, -0.417502, -1.819137>,
      < -0.786599, -0.406632, -1.819064>
    }
    triangle {
      < -0.878539, -0.391446, -2.098285>,
      < -0.878099, -0.413651, -2.098285>,
      < -0.886860, -0.439938, -1.819164>
    }
    triangle {
      < -0.878539, -0.391446, -2.098285>,
      < -0.886860, -0.439938, -1.819164>,
      < -0.887309, -0.417502, -1.819137>
    }
    triangle {
      < -0.878099, -0.413651, -2.098285>,
      < -0.115636, -0.398417, -2.097703>,
      < -0.252385, -0.409848, -2.004803>
    }
    triangle {
      < -0.878099, -0.413651, -2.098285>,
      < -0.252385, -0.409848, -2.004803>,
      < -0.254393, -0.418587, -1.911799>
    }
    triangle {
      < -0.878099, -0.413651, -2.098285>,
      < -0.254393, -0.418587, -1.911799>,
      < -0.121660, -0.424634, -1.818693>
    }
    triangle {
      < -0.878099, -0.413651, -2.098285>,
      < -0.121660, -0.424634, -1.818693>,
      < -0.886860, -0.439938, -1.819164>
    }
    texture {parts_wings}
  }
  // parts_gearbay
  union {
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.811115, -0.452875, -1.988603>,
      < 1.810869, -0.441036, -1.972708>
    }
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.810869, -0.441036, -1.972708>,
      < 1.810876, -0.442401, -1.941286>
    }
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.810876, -0.442401, -1.941286>,
      < 1.811134, -0.455740, -1.925413>
    }
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.811134, -0.455740, -1.925413>,
      < 1.811386, -0.468392, -1.925428>
    }
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.811386, -0.468392, -1.925428>,
      < 1.811649, -0.481022, -1.941348>
    }
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.811649, -0.481022, -1.941348>,
      < 1.811667, -0.480985, -1.972716>
    }
    texture {parts_gearbay}
  }
  // parts_wings
  union {
    triangle {
      < 1.352784, -0.240393, -1.887555>,
      < 1.345801, -0.228301, -2.026570>,
      < 1.272313, -0.216675, -2.096640>
    }
    triangle {
      < 1.352784, -0.240393, -1.887555>,
      < 1.272313, -0.216675, -2.096640>,
      < 0.978792, -0.193436, -2.097076>
    }
    triangle {
      < 1.352784, -0.240393, -1.887555>,
      < 0.978792, -0.193436, -2.097076>,
      < 0.989105, -0.217407, -1.817783>
    }
    triangle {
      < 1.352784, -0.240393, -1.887555>,
      < 0.989105, -0.217407, -1.817783>,
      < 1.286326, -0.240938, -1.817630>
    }
    triangle {
      < 0.978792, -0.193436, -2.097076>,
      < 0.601346, -0.190786, -2.097529>,
      < 0.607788, -0.214780, -1.818007>
    }
    triangle {
      < 0.978792, -0.193436, -2.097076>,
      < 0.607788, -0.214780, -1.818007>,
      < 0.989105, -0.217407, -1.817783>
    }
    triangle {
      < 0.601346, -0.190786, -2.097529>,
      < 0.180439, -0.229676, -2.097913>,
      < 0.182544, -0.254088, -1.818305>
    }
    triangle {
      < 0.601346, -0.190786, -2.097529>,
      < 0.182544, -0.254088, -1.818305>,
      < 0.607788, -0.214780, -1.818007>
    }
    triangle {
      < -0.139813, 0.216467, -6.641922>,
      < -0.216157, 0.209304, -6.637666>,
      < -0.243602, 0.210973, -6.423039>
    }
    triangle {
      < -0.139813, 0.216467, -6.641922>,
      < -0.243602, 0.210973, -6.423039>,
      < -0.169188, 0.220348, -6.422487>
    }
    triangle {
      < -0.216157, 0.209304, -6.637666>,
      < -0.288155, 0.199544, -6.631355>,
      < -0.313750, 0.197928, -6.423829>
    }
    triangle {
      < -0.216157, 0.209304, -6.637666>,
      < -0.313750, 0.197928, -6.423829>,
      < -0.243602, 0.210973, -6.423039>
    }
    triangle {
      < -0.288155, 0.199544, -6.631355>,
      < -0.365682, 0.189416, -6.624856>,
      < -0.389290, 0.184419, -6.424646>
    }
    triangle {
      < -0.288155, 0.199544, -6.631355>,
      < -0.389290, 0.184419, -6.424646>,
      < -0.313750, 0.197928, -6.423829>
    }
    triangle {
      < -0.365682, 0.189416, -6.624856>,
      < -0.436362, 0.175743, -6.615539>,
      < -0.458118, 0.165890, -6.425788>
    }
    triangle {
      < -0.365682, 0.189416, -6.624856>,
      < -0.458118, 0.165890, -6.425788>,
      < -0.389290, 0.184419, -6.424646>
    }
    triangle {
      < -0.436362, 0.175743, -6.615539>,
      < -0.515126, 0.165201, -6.608741>,
      < -0.534859, 0.151811, -6.426641>
    }
    triangle {
      < -0.436362, 0.175743, -6.615539>,
      < -0.534859, 0.151811, -6.426641>,
      < -0.458118, 0.165890, -6.425788>
    }
    triangle {
      < -0.515126, 0.165201, -6.608741>,
      < -0.544296, 0.160356, -6.605505>,
      < -0.602699, 0.144491, -6.427065>
    }
    triangle {
      < -0.515126, 0.165201, -6.608741>,
      < -0.602699, 0.144491, -6.427065>,
      < -0.534859, 0.151811, -6.426641>
    }
    triangle {
      < -0.544296, 0.160356, -6.605505>,
      < -0.528953, 0.149863, -6.597248>,
      < -0.602396, 0.129385, -6.428035>
    }
    triangle {
      < -0.544296, 0.160356, -6.605505>,
      < -0.602396, 0.129385, -6.428035>,
      < -0.602699, 0.144491, -6.427065>
    }
    triangle {
      < -0.528953, 0.149863, -6.597248>,
      < 0.800193, 0.176445, -6.596428>,
      < 0.878530, 0.159003, -6.427121>
    }
    triangle {
      < -0.528953, 0.149863, -6.597248>,
      < 0.878530, 0.159003, -6.427121>,
      < -0.005659, 0.141325, -6.427707>
    }
    triangle {
      < -0.528953, 0.149863, -6.597248>,
      < -0.005659, 0.141325, -6.427707>,
      < -0.602396, 0.129385, -6.428035>
    }
    triangle {
      < 0.800193, 0.176445, -6.596428>,
      < 0.879926, 0.186704, -6.602994>,
      < 0.967314, 0.172900, -6.426290>
    }
    triangle {
      < 0.800193, 0.176445, -6.596428>,
      < 0.967314, 0.172900, -6.426290>,
      < 0.878530, 0.159003, -6.427121>
    }
    triangle {
      < 0.879926, 0.186704, -6.602994>,
      < 0.903746, 0.203794, -6.615669>,
      < 0.993748, 0.196676, -6.424781>
    }
    triangle {
      < 0.879926, 0.186704, -6.602994>,
      < 0.993748, 0.196676, -6.424781>,
      < 0.967314, 0.172900, -6.426290>
    }
    triangle {
      < 0.903746, 0.203794, -6.615669>,
      < 0.905147, 0.220431, -6.628345>,
      < 0.995206, 0.219940, -6.423290>
    }
    triangle {
      < 0.903746, 0.203794, -6.615669>,
      < 0.995206, 0.219940, -6.423290>,
      < 0.993748, 0.196676, -6.424781>
    }
    triangle {
      < 0.905147, 0.220431, -6.628345>,
      < 0.884130, 0.236607, -6.641029>,
      < 0.971684, 0.242689, -6.421815>
    }
    triangle {
      < 0.905147, 0.220431, -6.628345>,
      < 0.971684, 0.242689, -6.421815>,
      < 0.995206, 0.219940, -6.423290>
    }
    triangle {
      < 0.884130, 0.236607, -6.641029>,
      < 0.827612, 0.248505, -6.651014>,
      < 0.908630, 0.259656, -6.420684>
    }
    triangle {
      < 0.884130, 0.236607, -6.641029>,
      < 0.908630, 0.259656, -6.420684>,
      < 0.971684, 0.242689, -6.421815>
    }
    triangle {
      < 0.827612, 0.248505, -6.651014>,
      < 0.605713, 0.261580, -6.664520>,
      < 0.661282, 0.279210, -6.419264>
    }
    triangle {
      < 0.827612, 0.248505, -6.651014>,
      < 0.661282, 0.279210, -6.419264>,
      < 0.908630, 0.259656, -6.420684>
    }
    triangle {
      < 0.605713, 0.261580, -6.664520>,
      < 0.375204, 0.261914, -6.668440>,
      < 0.404420, 0.280993, -6.418981>
    }
    triangle {
      < 0.605713, 0.261580, -6.664520>,
      < 0.404420, 0.280993, -6.418981>,
      < 0.661282, 0.279210, -6.419264>
    }
    triangle {
      < 0.375204, 0.261914, -6.668440>,
      < 0.118028, 0.241947, -6.657282>,
      < 0.117970, 0.254525, -6.420486>
    }
    triangle {
      < 0.375204, 0.261914, -6.668440>,
      < 0.117970, 0.254525, -6.420486>,
      < 0.404420, 0.280993, -6.418981>
    }
    triangle {
      < 0.118028, 0.241947, -6.657282>,
      < -0.139813, 0.216467, -6.641922>,
      < -0.169188, 0.220348, -6.422487>
    }
    triangle {
      < 0.118028, 0.241947, -6.657282>,
      < -0.169188, 0.220348, -6.422487>,
      < 0.117970, 0.254525, -6.420486>
    }
    triangle {
      < 0.500715, 0.149473, -6.740269>,
      < 0.322649, 0.147329, -6.744976>,
      < 0.375204, 0.261914, -6.668440>
    }
    triangle {
      < 0.500715, 0.149473, -6.740269>,
      < 0.375204, 0.261914, -6.668440>,
      < 0.605713, 0.261580, -6.664520>
    }
    triangle {
      < 0.322649, 0.147329, -6.744976>,
      < 0.123780, 0.139088, -6.731335>,
      < 0.118028, 0.241947, -6.657282>
    }
    triangle {
      < 0.322649, 0.147329, -6.744976>,
      < 0.118028, 0.241947, -6.657282>,
      < 0.375204, 0.261914, -6.668440>
    }
    triangle {
      < 0.123780, 0.139088, -6.731335>,
      < -0.042289, 0.129923, -6.712564>,
      < -0.139813, 0.216467, -6.641922>
    }
    triangle {
      < 0.123780, 0.139088, -6.731335>,
      < -0.139813, 0.216467, -6.641922>,
      < 0.118028, 0.241947, -6.657282>
    }
    triangle {
      < -0.042289, 0.129923, -6.712564>,
      < -0.103593, 0.127075, -6.707367>,
      < -0.216157, 0.209304, -6.637666>
    }
    triangle {
      < -0.042289, 0.129923, -6.712564>,
      < -0.216157, 0.209304, -6.637666>,
      < -0.139813, 0.216467, -6.641922>
    }
    triangle {
      < -0.103593, 0.127075, -6.707367>,
      < -0.161433, 0.123528, -6.699673>,
      < -0.288155, 0.199544, -6.631355>
    }
    triangle {
      < -0.103593, 0.127075, -6.707367>,
      < -0.288155, 0.199544, -6.631355>,
      < -0.216157, 0.209304, -6.637666>
    }
    triangle {
      < -0.161433, 0.123528, -6.699673>,
      < -0.223715, 0.119813, -6.691748>,
      < -0.365682, 0.189416, -6.624856>
    }
    triangle {
      < -0.161433, 0.123528, -6.699673>,
      < -0.365682, 0.189416, -6.624856>,
      < -0.288155, 0.199544, -6.631355>
    }
    triangle {
      < -0.223715, 0.119813, -6.691748>,
      < -0.280543, 0.115151, -6.680402>,
      < -0.436362, 0.175743, -6.615539>
    }
    triangle {
      < -0.223715, 0.119813, -6.691748>,
      < -0.436362, 0.175743, -6.615539>,
      < -0.365682, 0.189416, -6.624856>
    }
    triangle {
      < -0.280543, 0.115151, -6.680402>,
      < -0.343816, 0.111306, -6.672113>,
      < -0.515126, 0.165201, -6.608741>
    }
    triangle {
      < -0.280543, 0.115151, -6.680402>,
      < -0.515126, 0.165201, -6.608741>,
      < -0.436362, 0.175743, -6.615539>
    }
    triangle {
      < -0.343816, 0.111306, -6.672113>,
      < -0.399691, 0.108964, -6.668188>,
      < -0.544296, 0.160356, -6.605505>
    }
    triangle {
      < -0.343816, 0.111306, -6.672113>,
      < -0.544296, 0.160356, -6.605505>,
      < -0.515126, 0.165201, -6.608741>
    }
    triangle {
      < -0.399691, 0.108964, -6.668188>,
      < -0.293134, 0.107989, -6.658093>,
      < -0.528953, 0.149863, -6.597248>
    }
    triangle {
      < -0.399691, 0.108964, -6.668188>,
      < -0.528953, 0.149863, -6.597248>,
      < -0.544296, 0.160356, -6.605505>
    }
    triangle {
      < -0.293134, 0.107989, -6.658093>,
      < 0.650111, 0.126854, -6.657514>,
      < 0.800193, 0.176445, -6.596428>
    }
    triangle {
      < -0.293134, 0.107989, -6.658093>,
      < 0.800193, 0.176445, -6.596428>,
      < -0.528953, 0.149863, -6.597248>
    }
    triangle {
      < 0.650111, 0.126854, -6.657514>,
      < 0.711808, 0.130578, -6.665519>,
      < 0.879926, 0.186704, -6.602994>
    }
    triangle {
      < 0.650111, 0.126854, -6.657514>,
      < 0.879926, 0.186704, -6.602994>,
      < 0.800193, 0.176445, -6.596428>
    }
    triangle {
      < 0.711808, 0.130578, -6.665519>,
      < 0.730378, 0.135728, -6.680936>,
      < 0.903746, 0.203794, -6.615669>
    }
    triangle {
      < 0.711808, 0.130578, -6.665519>,
      < 0.903746, 0.203794, -6.615669>,
      < 0.879926, 0.186704, -6.602994>
    }
    triangle {
      < 0.730378, 0.135728, -6.680936>,
      < 0.731625, 0.140532, -6.696357>,
      < 0.905147, 0.220431, -6.628345>
    }
    triangle {
      < 0.730378, 0.135728, -6.680936>,
      < 0.905147, 0.220431, -6.628345>,
      < 0.903746, 0.203794, -6.615669>
    }
    triangle {
      < 0.731625, 0.140532, -6.696357>,
      < 0.715549, 0.144985, -6.711778>,
      < 0.884130, 0.236607, -6.641029>
    }
    triangle {
      < 0.731625, 0.140532, -6.696357>,
      < 0.884130, 0.236607, -6.641029>,
      < 0.905147, 0.220431, -6.628345>
    }
    triangle {
      < 0.715549, 0.144985, -6.711778>,
      < 0.672007, 0.147859, -6.723906>,
      < 0.827612, 0.248505, -6.651014>
    }
    triangle {
      < 0.715549, 0.144985, -6.711778>,
      < 0.827612, 0.248505, -6.651014>,
      < 0.884130, 0.236607, -6.641029>
    }
    triangle {
      < 0.672007, 0.147859, -6.723906>,
      < 0.500715, 0.149473, -6.740269>,
      < 0.605713, 0.261580, -6.664520>
    }
    triangle {
      < 0.672007, 0.147859, -6.723906>,
      < 0.605713, 0.261580, -6.664520>,
      < 0.827612, 0.248505, -6.651014>
    }
    triangle {
      < 0.529434, 0.078181, -6.714513>,
      < 0.519089, 0.081045, -6.724435>,
      < 0.715549, 0.144985, -6.711778>
    }
    triangle {
      < 0.529434, 0.078181, -6.714513>,
      < 0.715549, 0.144985, -6.711778>,
      < 0.731625, 0.140532, -6.696357>
    }
    triangle {
      < 0.519089, 0.081045, -6.724435>,
      < 0.491071, 0.082894, -6.732240>,
      < 0.672007, 0.147859, -6.723906>
    }
    triangle {
      < 0.519089, 0.081045, -6.724435>,
      < 0.672007, 0.147859, -6.723906>,
      < 0.715549, 0.144985, -6.711778>
    }
    triangle {
      < 0.491071, 0.082894, -6.732240>,
      < 0.380845, 0.083933, -6.742770>,
      < 0.500715, 0.149473, -6.740269>
    }
    triangle {
      < 0.491071, 0.082894, -6.732240>,
      < 0.500715, 0.149473, -6.740269>,
      < 0.672007, 0.147859, -6.723906>
    }
    triangle {
      < 0.380845, 0.083933, -6.742770>,
      < 0.266261, 0.082554, -6.745799>,
      < 0.322649, 0.147329, -6.744976>
    }
    triangle {
      < 0.380845, 0.083933, -6.742770>,
      < 0.322649, 0.147329, -6.744976>,
      < 0.500715, 0.149473, -6.740269>
    }
    triangle {
      < 0.266261, 0.082554, -6.745799>,
      < 0.138289, 0.077251, -6.737020>,
      < 0.123780, 0.139088, -6.731335>
    }
    triangle {
      < 0.266261, 0.082554, -6.745799>,
      < 0.123780, 0.139088, -6.731335>,
      < 0.322649, 0.147329, -6.744976>
    }
    triangle {
      < 0.138289, 0.077251, -6.737020>,
      < 0.029207, 0.071308, -6.724942>,
      < -0.042289, 0.129923, -6.712564>
    }
    triangle {
      < 0.138289, 0.077251, -6.737020>,
      < -0.042289, 0.129923, -6.712564>,
      < 0.123780, 0.139088, -6.731335>
    }
    triangle {
      < 0.029207, 0.071308, -6.724942>,
      < -0.010242, 0.069477, -6.721601>,
      < -0.103593, 0.127075, -6.707367>
    }
    triangle {
      < 0.029207, 0.071308, -6.724942>,
      < -0.103593, 0.127075, -6.707367>,
      < -0.042289, 0.129923, -6.712564>
    }
    triangle {
      < -0.010242, 0.069477, -6.721601>,
      < -0.047462, 0.067193, -6.716648>,
      < -0.161433, 0.123528, -6.699673>
    }
    triangle {
      < -0.010242, 0.069477, -6.721601>,
      < -0.161433, 0.123528, -6.699673>,
      < -0.103593, 0.127075, -6.707367>
    }
    triangle {
      < -0.047462, 0.067193, -6.716648>,
      < -0.087539, 0.064803, -6.711549>,
      < -0.223715, 0.119813, -6.691748>
    }
    triangle {
      < -0.047462, 0.067193, -6.716648>,
      < -0.223715, 0.119813, -6.691748>,
      < -0.161433, 0.123528, -6.699673>
    }
    triangle {
      < -0.087539, 0.064803, -6.711549>,
      < -0.124109, 0.061803, -6.704247>,
      < -0.280543, 0.115151, -6.680402>
    }
    triangle {
      < -0.087539, 0.064803, -6.711549>,
      < -0.280543, 0.115151, -6.680402>,
      < -0.223715, 0.119813, -6.691748>
    }
    triangle {
      < -0.124109, 0.061803, -6.704247>,
      < -0.164826, 0.059329, -6.698911>,
      < -0.343816, 0.111306, -6.672113>
    }
    triangle {
      < -0.124109, 0.061803, -6.704247>,
      < -0.343816, 0.111306, -6.672113>,
      < -0.280543, 0.115151, -6.680402>
    }
    triangle {
      < -0.164826, 0.059329, -6.698911>,
      < -0.200780, 0.057822, -6.696388>,
      < -0.399691, 0.108964, -6.668188>
    }
    triangle {
      < -0.164826, 0.059329, -6.698911>,
      < -0.399691, 0.108964, -6.668188>,
      < -0.343816, 0.111306, -6.672113>
    }
    triangle {
      < -0.200780, 0.057822, -6.696388>,
      < -0.132211, 0.057195, -6.689893>,
      < -0.293134, 0.107989, -6.658093>
    }
    triangle {
      < -0.200780, 0.057822, -6.696388>,
      < -0.293134, 0.107989, -6.658093>,
      < -0.399691, 0.108964, -6.668188>
    }
    triangle {
      < -0.132211, 0.057195, -6.689893>,
      < 0.476981, 0.069378, -6.689517>,
      < 0.650111, 0.126854, -6.657514>
    }
    triangle {
      < -0.132211, 0.057195, -6.689893>,
      < 0.650111, 0.126854, -6.657514>,
      < -0.293134, 0.107989, -6.658093>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.516683, 0.071775, -6.694669>,
      < 0.711808, 0.130578, -6.665519>
    }
    triangle {
      < 0.476981, 0.069378, -6.689517>,
      < 0.711808, 0.130578, -6.665519>,
      < 0.650111, 0.126854, -6.657514>
    }
    triangle {
      < 0.516683, 0.071775, -6.694669>,
      < 0.528632, 0.075089, -6.704591>,
      < 0.730378, 0.135728, -6.680936>
    }
    triangle {
      < 0.516683, 0.071775, -6.694669>,
      < 0.730378, 0.135728, -6.680936>,
      < 0.711808, 0.130578, -6.665519>
    }
    triangle {
      < 0.528632, 0.075089, -6.704591>,
      < 0.529434, 0.078181, -6.714513>,
      < 0.731625, 0.140532, -6.696357>
    }
    triangle {
      < 0.528632, 0.075089, -6.704591>,
      < 0.731625, 0.140532, -6.696357>,
      < 0.730378, 0.135728, -6.680936>
    }
    texture {parts_wings}
  }
  // parts_fuselage
  union {
    triangle {
      < -1.267251, 0.627488, -0.734055>,
      < -3.289023, 0.555030, -0.735338>,
      < -3.559454, 0.567566, -0.735484>
    }
    triangle {
      < -1.267251, 0.627488, -0.734055>,
      < -3.559454, 0.567566, -0.735484>,
      < -3.289833, 0.592256, -0.735295>
    }
    triangle {
      < -1.267251, 0.627488, -0.734055>,
      < -3.289833, 0.592256, -0.735295>,
      < -1.268261, 0.674279, -0.733999>
    }
    triangle {
      < -1.267251, 0.627488, -0.734055>,
      < -1.268261, 0.674279, -0.733999>,
      < -1.205960, 0.658742, -0.733981>
    }
    triangle {
      < -3.441413, 0.410540, -0.153375>,
      < -3.441548, 0.415612, -0.098461>,
      < -1.246507, 0.598641, -0.117366>
    }
    triangle {
      < -3.441413, 0.410540, -0.153375>,
      < -1.246507, 0.598641, -0.117366>,
      < -1.246338, 0.592262, -0.183857>
    }
    triangle {
      < -3.441548, 0.415612, -0.098461>,
      < -3.441652, 0.419486, -0.056504>,
      < -1.246635, 0.603513, -0.066561>
    }
    triangle {
      < -3.441548, 0.415612, -0.098461>,
      < -1.246635, 0.603513, -0.066561>,
      < -1.246507, 0.598641, -0.117366>
    }
    triangle {
      < -3.441652, 0.419486, -0.056504>,
      < -3.441786, 0.424558, -0.002581>,
      < -1.246803, 0.609891, -0.001061>
    }
    triangle {
      < -3.441652, 0.419486, -0.056504>,
      < -1.246803, 0.609891, -0.001061>,
      < -1.246635, 0.603513, -0.066561>
    }
    triangle {
      < -1.224787, -0.494007, 0.097761>,
      < -3.425048, -0.414702, 0.071328>,
      < -3.424959, -0.414524, -0.078459>
    }
    triangle {
      < -1.224787, -0.494007, 0.097761>,
      < -3.424959, -0.414524, -0.078459>,
      < -1.224668, -0.493770, -0.102471>
    }
    triangle {
      < -3.424959, -0.414524, -0.078459>,
      < -3.425067, -0.401566, -0.321275>,
      < -1.224841, -0.475193, -0.425991>
    }
    triangle {
      < -3.424959, -0.414524, -0.078459>,
      < -1.224841, -0.475193, -0.425991>,
      < -1.224668, -0.493770, -0.102471>
    }
    triangle {
      < -3.425067, -0.401566, -0.321275>,
      < -3.426126, -0.347012, -0.374330>,
      < -1.226364, -0.396862, -0.496674>
    }
    triangle {
      < -3.425067, -0.401566, -0.321275>,
      < -1.226364, -0.396862, -0.496674>,
      < -1.224841, -0.475193, -0.425991>
    }
    triangle {
      < -3.426126, -0.347012, -0.374330>,
      < -3.427557, -0.275159, -0.383525>,
      < -1.228420, -0.293687, -0.508915>
    }
    triangle {
      < -3.426126, -0.347012, -0.374330>,
      < -1.228420, -0.293687, -0.508915>,
      < -1.226364, -0.396862, -0.496674>
    }
    triangle {
      < -3.427557, -0.275159, -0.383525>,
      < -3.435561, 0.124018, -0.351012>,
      < -1.238962, 0.232139, -0.465603>
    }
    triangle {
      < -3.427557, -0.275159, -0.383525>,
      < -1.238962, 0.232139, -0.465603>,
      < -1.228420, -0.293687, -0.508915>
    }
    triangle {
      < -3.435561, 0.124018, -0.351012>,
      < -3.439063, 0.297224, -0.290101>,
      < -1.243387, 0.449815, -0.349415>
    }
    triangle {
      < -3.435561, 0.124018, -0.351012>,
      < -1.243387, 0.449815, -0.349415>,
      < -1.238962, 0.232139, -0.465603>
    }
    triangle {
      < -4.348794, -0.211263, -0.303559>,
      < -4.354681, 0.082335, -0.277934>,
      < -3.435561, 0.124018, -0.351012>
    }
    triangle {
      < -4.348794, -0.211263, -0.303559>,
      < -3.435561, 0.124018, -0.351012>,
      < -3.427557, -0.275159, -0.383525>
    }
    triangle {
      < -4.354681, 0.082335, -0.277934>,
      < -4.357258, 0.209653, -0.229889>,
      < -3.439063, 0.297224, -0.290101>
    }
    triangle {
      < -4.354681, 0.082335, -0.277934>,
      < -3.439063, 0.297224, -0.290101>,
      < -3.435561, 0.124018, -0.351012>
    }
    triangle {
      < -4.357258, 0.209653, -0.229889>,
      < -4.358325, 0.261713, -0.187920>,
      < -4.051329, 0.318952, -0.214396>
    }
    triangle {
      < -4.357258, 0.209653, -0.229889>,
      < -4.051329, 0.318952, -0.214396>,
      < -3.439063, 0.297224, -0.290101>
    }
    triangle {
      < -4.358325, 0.261713, -0.187920>,
      < -4.358991, 0.292943, -0.122028>,
      < -3.441413, 0.410540, -0.153375>
    }
    triangle {
      < -4.358325, 0.261713, -0.187920>,
      < -3.441413, 0.410540, -0.153375>,
      < -4.051329, 0.318952, -0.214396>
    }
    triangle {
      < -4.358991, 0.292943, -0.122028>,
      < -4.359092, 0.296667, -0.078703>,
      < -3.441548, 0.415612, -0.098461>
    }
    triangle {
      < -4.358991, 0.292943, -0.122028>,
      < -3.441548, 0.415612, -0.098461>,
      < -3.441413, 0.410540, -0.153375>
    }
    triangle {
      < -4.359092, 0.296667, -0.078703>,
      < -4.359169, 0.299514, -0.045601>,
      < -3.441652, 0.419486, -0.056504>
    }
    triangle {
      < -4.359092, 0.296667, -0.078703>,
      < -3.441652, 0.419486, -0.056504>,
      < -3.441548, 0.415612, -0.098461>
    }
    triangle {
      < -4.359169, 0.299514, -0.045601>,
      < -4.359270, 0.303239, -0.003268>,
      < -3.441786, 0.424558, -0.002581>
    }
    triangle {
      < -4.359169, 0.299514, -0.045601>,
      < -3.441786, 0.424558, -0.002581>,
      < -3.441652, 0.419486, -0.056504>
    }
    triangle {
      < -3.425048, -0.414702, 0.071328>,
      < -4.346814, -0.321354, 0.054877>,
      < -4.346779, -0.321284, -0.004001>
    }
    triangle {
      < -3.425048, -0.414702, 0.071328>,
      < -4.346779, -0.321284, -0.004001>,
      < -4.346744, -0.321215, -0.062879>
    }
    triangle {
      < -3.425048, -0.414702, 0.071328>,
      < -4.346744, -0.321215, -0.062879>,
      < -3.424959, -0.414524, -0.078459>
    }
    triangle {
      < -4.346744, -0.321215, -0.062879>,
      < -4.346830, -0.310991, -0.254448>,
      < -3.425067, -0.401566, -0.321275>
    }
    triangle {
      < -4.346744, -0.321215, -0.062879>,
      < -3.425067, -0.401566, -0.321275>,
      < -3.424959, -0.414524, -0.078459>
    }
    triangle {
      < -4.346830, -0.310991, -0.254448>,
      < -4.347666, -0.267951, -0.296305>,
      < -3.426126, -0.347012, -0.374330>
    }
    triangle {
      < -4.346830, -0.310991, -0.254448>,
      < -3.426126, -0.347012, -0.374330>,
      < -3.425067, -0.401566, -0.321275>
    }
    triangle {
      < -4.347666, -0.267951, -0.296305>,
      < -4.348794, -0.211263, -0.303559>,
      < -3.427557, -0.275159, -0.383525>
    }
    triangle {
      < -4.347666, -0.267951, -0.296305>,
      < -3.427557, -0.275159, -0.383525>,
      < -3.426126, -0.347012, -0.374330>
    }
    triangle {
      < -5.750316, -0.205969, -0.039045>,
      < -5.750318, -0.203108, -0.129610>,
      < -5.149209, -0.230375, -0.188244>
    }
    triangle {
      < -5.750316, -0.205969, -0.039045>,
      < -5.149209, -0.230375, -0.188244>,
      < -5.166157, -0.258407, -0.046144>
    }
    triangle {
      < -4.367004, -0.285714, -0.272016>,
      < -4.417889, -0.258341, -0.288043>,
      < -4.347666, -0.267951, -0.296305>
    }
    triangle {
      < -4.367004, -0.285714, -0.272016>,
      < -4.347666, -0.267951, -0.296305>,
      < -4.346830, -0.310991, -0.254448>
    }
    triangle {
      < -4.417889, -0.258341, -0.288043>,
      < -4.478778, -0.240267, -0.282154>,
      < -4.785917, -0.198238, -0.246021>
    }
    triangle {
      < -4.417889, -0.258341, -0.288043>,
      < -4.785917, -0.198238, -0.246021>,
      < -5.152378, -0.216647, -0.201568>
    }
    triangle {
      < -4.417889, -0.258341, -0.288043>,
      < -5.152378, -0.216647, -0.201568>,
      < -5.751035, -0.166312, -0.158432>
    }
    triangle {
      < -4.417889, -0.258341, -0.288043>,
      < -5.751035, -0.166312, -0.158432>,
      < -5.751968, -0.118978, -0.183466>
    }
    triangle {
      < -4.417889, -0.258341, -0.288043>,
      < -5.751968, -0.118978, -0.183466>,
      < -4.348794, -0.211263, -0.303559>
    }
    triangle {
      < -4.417889, -0.258341, -0.288043>,
      < -4.348794, -0.211263, -0.303559>,
      < -4.347666, -0.267951, -0.296305>
    }
    triangle {
      < -5.751968, -0.118978, -0.183466>,
      < -5.754777, 0.021560, -0.183419>,
      < -4.354681, 0.082335, -0.277934>
    }
    triangle {
      < -5.751968, -0.118978, -0.183466>,
      < -4.354681, 0.082335, -0.277934>,
      < -4.348794, -0.211263, -0.303559>
    }
    triangle {
      < -5.754777, 0.021560, -0.183419>,
      < -5.756555, 0.109295, -0.145500>,
      < -4.357258, 0.209653, -0.229889>
    }
    triangle {
      < -5.754777, 0.021560, -0.183419>,
      < -4.357258, 0.209653, -0.229889>,
      < -4.354681, 0.082335, -0.277934>
    }
    triangle {
      < -5.756555, 0.109295, -0.145500>,
      < -5.757049, 0.132846, -0.109123>,
      < -4.358325, 0.261713, -0.187920>
    }
    triangle {
      < -5.756555, 0.109295, -0.145500>,
      < -4.358325, 0.261713, -0.187920>,
      < -4.357258, 0.209653, -0.229889>
    }
    triangle {
      < -5.757049, 0.132846, -0.109123>,
      < -5.757387, 0.148533, -0.069455>,
      < -4.358991, 0.292943, -0.122028>
    }
    triangle {
      < -5.757049, 0.132846, -0.109123>,
      < -4.358991, 0.292943, -0.122028>,
      < -4.358325, 0.261713, -0.187920>
    }
    triangle {
      < -5.757387, 0.148533, -0.069455>,
      < -5.757511, 0.154000, -0.046231>,
      < -4.359092, 0.296667, -0.078703>
    }
    triangle {
      < -5.757387, 0.148533, -0.069455>,
      < -4.359092, 0.296667, -0.078703>,
      < -4.358991, 0.292943, -0.122028>
    }
    triangle {
      < -5.757511, 0.154000, -0.046231>,
      < -5.757576, 0.156622, -0.027722>,
      < -4.359169, 0.299514, -0.045601>
    }
    triangle {
      < -5.757511, 0.154000, -0.046231>,
      < -4.359169, 0.299514, -0.045601>,
      < -4.359092, 0.296667, -0.078703>
    }
    triangle {
      < -5.757576, 0.156622, -0.027722>,
      < -5.757614, 0.157847, -0.004269>,
      < -4.359270, 0.303239, -0.003268>
    }
    triangle {
      < -5.757576, 0.156622, -0.027722>,
      < -4.359270, 0.303239, -0.003268>,
      < -4.359169, 0.299514, -0.045601>
    }
    triangle {
      < -5.750284, -0.208640, -0.004700>,
      < -5.750316, -0.205969, -0.039045>,
      < -5.166157, -0.258407, -0.046144>
    }
    triangle {
      < -5.750284, -0.208640, -0.004700>,
      < -5.166157, -0.258407, -0.046144>,
      < -4.346744, -0.321215, -0.062879>
    }
    triangle {
      < -5.750284, -0.208640, -0.004700>,
      < -4.346744, -0.321215, -0.062879>,
      < -4.346779, -0.321284, -0.004001>
    }
    triangle {
      < -5.974082, -0.121832, -0.004730>,
      < -5.974094, -0.120545, -0.025256>,
      < -5.750316, -0.205969, -0.039045>
    }
    triangle {
      < -5.974082, -0.121832, -0.004730>,
      < -5.750316, -0.205969, -0.039045>,
      < -5.750284, -0.208640, -0.004700>
    }
    triangle {
      < -5.974094, -0.120545, -0.025256>,
      < -5.974444, -0.101959, -0.062833>,
      < -5.750318, -0.203108, -0.129610>
    }
    triangle {
      < -5.974094, -0.120545, -0.025256>,
      < -5.750318, -0.203108, -0.129610>,
      < -5.750316, -0.205969, -0.039045>
    }
    triangle {
      < -5.974444, -0.101959, -0.062833>,
      < -5.974781, -0.084533, -0.079168>,
      < -5.751035, -0.166312, -0.158432>
    }
    triangle {
      < -5.974444, -0.101959, -0.062833>,
      < -5.751035, -0.166312, -0.158432>,
      < -5.750318, -0.203108, -0.129610>
    }
    triangle {
      < -5.974781, -0.084533, -0.079168>,
      < -5.975385, -0.053797, -0.096385>,
      < -5.751968, -0.118978, -0.183466>
    }
    triangle {
      < -5.974781, -0.084533, -0.079168>,
      < -5.751968, -0.118978, -0.183466>,
      < -5.751035, -0.166312, -0.158432>
    }
    triangle {
      < -5.975385, -0.053797, -0.096385>,
      < -5.976693, 0.011392, -0.089596>,
      < -5.754777, 0.021560, -0.183419>
    }
    triangle {
      < -5.975385, -0.053797, -0.096385>,
      < -5.754777, 0.021560, -0.183419>,
      < -5.751968, -0.118978, -0.183466>
    }
    triangle {
      < -5.976693, 0.011392, -0.089596>,
      < -5.978164, 0.084434, -0.073563>,
      < -5.756555, 0.109295, -0.145500>
    }
    triangle {
      < -5.976693, 0.011392, -0.089596>,
      < -5.756555, 0.109295, -0.145500>,
      < -5.754777, 0.021560, -0.183419>
    }
    triangle {
      < -5.978164, 0.084434, -0.073563>,
      < -5.978493, 0.100320, -0.055959>,
      < -5.757049, 0.132846, -0.109123>
    }
    triangle {
      < -5.978164, 0.084434, -0.073563>,
      < -5.757049, 0.132846, -0.109123>,
      < -5.756555, 0.109295, -0.145500>
    }
    triangle {
      < -5.978493, 0.100320, -0.055959>,
      < -5.978691, 0.109733, -0.038612>,
      < -5.757387, 0.148533, -0.069455>
    }
    triangle {
      < -5.978493, 0.100320, -0.055959>,
      < -5.757387, 0.148533, -0.069455>,
      < -5.757049, 0.132846, -0.109123>
    }
    triangle {
      < -5.978691, 0.109733, -0.038612>,
      < -5.978760, 0.112815, -0.029005>,
      < -5.757511, 0.154000, -0.046231>
    }
    triangle {
      < -5.978691, 0.109733, -0.038612>,
      < -5.757511, 0.154000, -0.046231>,
      < -5.757387, 0.148533, -0.069455>
    }
    triangle {
      < -5.978760, 0.112815, -0.029005>,
      < -5.978794, 0.114267, -0.021478>,
      < -5.757576, 0.156622, -0.027722>
    }
    triangle {
      < -5.978760, 0.112815, -0.029005>,
      < -5.757576, 0.156622, -0.027722>,
      < -5.757511, 0.154000, -0.046231>
    }
    triangle {
      < -5.978794, 0.114267, -0.021478>,
      < -5.978817, 0.114932, -0.004452>,
      < -5.757614, 0.157847, -0.004269>
    }
    triangle {
      < -5.978794, 0.114267, -0.021478>,
      < -5.757614, 0.157847, -0.004269>,
      < -5.757576, 0.156622, -0.027722>
    }
    triangle {
      < -6.106501, 0.035514, -0.021704>,
      < -6.106525, 0.036644, -0.018177>,
      < -5.978760, 0.112815, -0.029005>
    }
    triangle {
      < -6.106501, 0.035514, -0.021704>,
      < -5.978760, 0.112815, -0.029005>,
      < -5.978691, 0.109733, -0.038612>
    }
    triangle {
      < -6.106525, 0.036644, -0.018177>,
      < -6.106538, 0.037178, -0.015415>,
      < -5.978794, 0.114267, -0.021478>
    }
    triangle {
      < -6.106525, 0.036644, -0.018177>,
      < -5.978794, 0.114267, -0.021478>,
      < -5.978760, 0.112815, -0.029005>
    }
    triangle {
      < -6.106538, 0.037178, -0.015415>,
      < -6.106549, 0.037416, -0.004619>,
      < -5.978817, 0.114932, -0.004452>
    }
    triangle {
      < -6.106538, 0.037178, -0.015415>,
      < -5.978817, 0.114932, -0.004452>,
      < -5.978794, 0.114267, -0.021478>
    }
    triangle {
      < -6.104812, -0.049484, -0.004721>,
      < -6.104814, -0.049007, -0.016801>,
      < -5.974094, -0.120545, -0.025256>
    }
    triangle {
      < -6.104812, -0.049484, -0.004721>,
      < -5.974094, -0.120545, -0.025256>,
      < -5.974082, -0.121832, -0.004730>
    }
    triangle {
      < -6.104814, -0.049007, -0.016801>,
      < -6.104941, -0.042186, -0.030594>,
      < -5.974444, -0.101959, -0.062833>
    }
    triangle {
      < -6.104814, -0.049007, -0.016801>,
      < -5.974444, -0.101959, -0.062833>,
      < -5.974094, -0.120545, -0.025256>
    }
    triangle {
      < -6.104941, -0.042186, -0.030594>,
      < -6.105064, -0.035790, -0.036590>,
      < -5.974781, -0.084533, -0.079168>
    }
    triangle {
      < -6.104941, -0.042186, -0.030594>,
      < -5.974781, -0.084533, -0.079168>,
      < -5.974444, -0.101959, -0.062833>
    }
    triangle {
      < -6.105064, -0.035790, -0.036590>,
      < -6.105287, -0.024509, -0.042909>,
      < -5.975385, -0.053797, -0.096385>
    }
    triangle {
      < -6.105064, -0.035790, -0.036590>,
      < -5.975385, -0.053797, -0.096385>,
      < -5.974781, -0.084533, -0.079168>
    }
    triangle {
      < -6.105287, -0.024509, -0.042909>,
      < -6.105766, -0.000581, -0.040417>,
      < -5.976693, 0.011392, -0.089596>
    }
    triangle {
      < -6.105287, -0.024509, -0.042909>,
      < -5.976693, 0.011392, -0.089596>,
      < -5.975385, -0.053797, -0.096385>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -6.106308, 0.026228, -0.034532>,
      < -5.978164, 0.084434, -0.073563>
    }
    triangle {
      < -6.105766, -0.000581, -0.040417>,
      < -5.978164, 0.084434, -0.073563>,
      < -5.976693, 0.011392, -0.089596>
    }
    triangle {
      < -6.106308, 0.026228, -0.034532>,
      < -6.106427, 0.032059, -0.028071>,
      < -5.978493, 0.100320, -0.055959>
    }
    triangle {
      < -6.106308, 0.026228, -0.034532>,
      < -5.978493, 0.100320, -0.055959>,
      < -5.978164, 0.084434, -0.073563>
    }
    triangle {
      < -6.106427, 0.032059, -0.028071>,
      < -6.106501, 0.035514, -0.021704>,
      < -5.978691, 0.109733, -0.038612>
    }
    triangle {
      < -6.106427, 0.032059, -0.028071>,
      < -5.978691, 0.109733, -0.038612>,
      < -5.978493, 0.100320, -0.055959>
    }
    triangle {
      < -5.750318, -0.203108, -0.129610>,
      < -5.751035, -0.166312, -0.158432>,
      < -5.152378, -0.216647, -0.201568>
    }
    triangle {
      < -5.750318, -0.203108, -0.129610>,
      < -5.152378, -0.216647, -0.201568>,
      < -4.785917, -0.198238, -0.246021>
    }
    triangle {
      < -5.750318, -0.203108, -0.129610>,
      < -4.785917, -0.198238, -0.246021>,
      < -5.149209, -0.230375, -0.188244>
    }
    texture {parts_fuselage}
  }
  // parts_rudder
  union {
    triangle {
      < -4.344952, -0.307852, -3.423431>,
      < -4.344753, -0.317848, -3.423443>,
      < -5.146204, -0.254688, -3.401122>
    }
    triangle {
      < -4.344952, -0.307852, -3.423431>,
      < -5.146204, -0.254688, -3.401122>,
      < -5.147305, -0.227183, -3.401090>
    }
    texture {parts_rudder}
  }
  // parts_fuselage
  union {
    triangle {
      < -4.785856, -0.198117, -0.347798>,
      < -5.149181, -0.230319, -0.235744>,
      < -5.149209, -0.230375, -0.188244>
    }
    triangle {
      < -4.785856, -0.198117, -0.347798>,
      < -5.149209, -0.230375, -0.188244>,
      < -4.785917, -0.198238, -0.246021>
    }
    triangle {
      < -5.149181, -0.230319, -0.235744>,
      < -5.166045, -0.258182, -0.235787>,
      < -5.166157, -0.258407, -0.046144>
    }
    triangle {
      < -5.149181, -0.230319, -0.235744>,
      < -5.166157, -0.258407, -0.046144>,
      < -5.149209, -0.230375, -0.188244>
    }
    triangle {
      < -5.166045, -0.258182, -0.235787>,
      < -4.346575, -0.320878, -0.347684>,
      < -4.346744, -0.321215, -0.062879>
    }
    triangle {
      < -5.166045, -0.258182, -0.235787>,
      < -4.346744, -0.321215, -0.062879>,
      < -5.166157, -0.258407, -0.046144>
    }
    triangle {
      < -4.346575, -0.320878, -0.347684>,
      < -4.346775, -0.310881, -0.347671>,
      < -4.346830, -0.310991, -0.254448>
    }
    triangle {
      < -4.346575, -0.320878, -0.347684>,
      < -4.346830, -0.310991, -0.254448>,
      < -4.346744, -0.321215, -0.062879>
    }
    triangle {
      < -4.346775, -0.310881, -0.347671>,
      < -4.366960, -0.285625, -0.347654>,
      < -4.367004, -0.285714, -0.272016>
    }
    triangle {
      < -4.346775, -0.310881, -0.347671>,
      < -4.367004, -0.285714, -0.272016>,
      < -4.346830, -0.310991, -0.254448>
    }
    triangle {
      < -4.366960, -0.285625, -0.347654>,
      < -4.417854, -0.258271, -0.347651>,
      < -4.417889, -0.258341, -0.288043>
    }
    triangle {
      < -4.366960, -0.285625, -0.347654>,
      < -4.417889, -0.258341, -0.288043>,
      < -4.367004, -0.285714, -0.272016>
    }
    triangle {
      < -4.417854, -0.258271, -0.347651>,
      < -4.478740, -0.240189, -0.347666>,
      < -4.478778, -0.240267, -0.282154>
    }
    triangle {
      < -4.417854, -0.258271, -0.347651>,
      < -4.478778, -0.240267, -0.282154>,
      < -4.417889, -0.258341, -0.288043>
    }
    triangle {
      < -4.478740, -0.240189, -0.347666>,
      < -4.785856, -0.198117, -0.347798>,
      < -4.785917, -0.198238, -0.246021>
    }
    triangle {
      < -4.478740, -0.240189, -0.347666>,
      < -4.785917, -0.198238, -0.246021>,
      < -4.478778, -0.240267, -0.282154>
    }
    texture {parts_fuselage}
  }
  // parts_stabilizers
  union {
    triangle {
      < -4.365186, -0.282695, -3.339931>,
      < -4.416080, -0.255340, -3.339929>,
      < -4.417854, -0.258271, -0.347651>
    }
    triangle {
      < -4.365186, -0.282695, -3.339931>,
      < -4.417854, -0.258271, -0.347651>,
      < -4.366960, -0.285625, -0.347654>
    }
    triangle {
      < -4.416080, -0.255340, -3.339929>,
      < -4.476966, -0.237260, -3.339945>,
      < -4.478740, -0.240189, -0.347666>
    }
    triangle {
      < -4.416080, -0.255340, -3.339929>,
      < -4.478740, -0.240189, -0.347666>,
      < -4.417854, -0.258271, -0.347651>
    }
    triangle {
      < -4.476966, -0.237260, -3.339945>,
      < -4.784083, -0.195186, -3.340076>,
      < -4.785856, -0.198117, -0.347798>
    }
    triangle {
      < -4.476966, -0.237260, -3.339945>,
      < -4.785856, -0.198117, -0.347798>,
      < -4.478740, -0.240189, -0.347666>
    }
    triangle {
      < -4.784083, -0.195186, -3.340076>,
      < -5.147327, -0.227228, -3.363051>,
      < -5.149181, -0.230319, -0.235744>
    }
    triangle {
      < -4.784083, -0.195186, -3.340076>,
      < -5.149181, -0.230319, -0.235744>,
      < -4.785856, -0.198117, -0.347798>
    }
    triangle {
      < -5.731069, -0.259152, -0.236123>,
      < -5.729228, -0.256089, -3.340708>,
      < -5.746628, -0.257144, -3.340720>
    }
    triangle {
      < -5.731069, -0.259152, -0.236123>,
      < -5.746628, -0.257144, -3.340720>,
      < -5.748468, -0.260208, -0.236134>
    }
    triangle {
      < -5.146227, -0.254733, -3.363083>,
      < -4.344802, -0.317947, -3.339962>,
      < -4.346575, -0.320878, -0.347684>
    }
    triangle {
      < -5.146227, -0.254733, -3.363083>,
      < -4.346575, -0.320878, -0.347684>,
      < -5.166045, -0.258182, -0.235787>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.345002, -0.307950, -3.339949>,
      < -4.346775, -0.310881, -0.347671>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.346775, -0.310881, -0.347671>,
      < -4.346575, -0.320878, -0.347684>
    }
    texture {parts_stabilizers}
  }
  // parts_rudder
  union {
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.223897, -0.315506, -3.359720>,
      < -4.224097, -0.305510, -3.359709>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.224097, -0.305510, -3.359709>,
      < -4.738334, 1.799446, -3.358614>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.738334, 1.799446, -3.358614>,
      < -4.886660, 1.894031, -3.350061>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.886660, 1.894031, -3.350061>,
      < -5.338473, 1.892523, -3.361748>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -5.338473, 1.892523, -3.361748>,
      < -5.147327, -0.227228, -3.363051>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -5.147327, -0.227228, -3.363051>,
      < -4.784083, -0.195186, -3.340076>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.784083, -0.195186, -3.340076>,
      < -4.476966, -0.237260, -3.339945>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.476966, -0.237260, -3.339945>,
      < -4.416080, -0.255340, -3.339929>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.416080, -0.255340, -3.339929>,
      < -4.365186, -0.282695, -3.339931>
    }
    triangle {
      < -4.344802, -0.317947, -3.339962>,
      < -4.365186, -0.282695, -3.339931>,
      < -4.345002, -0.307950, -3.339949>
    }
    triangle {
      < -4.499843, -0.567682, -3.340349>,
      < -4.499794, -0.567583, -3.423831>,
      < -4.340370, -0.537576, -3.403868>
    }
    triangle {
      < -4.499843, -0.567682, -3.340349>,
      < -4.340370, -0.537576, -3.403868>,
      < -4.340396, -0.537628, -3.360052>
    }
    triangle {
      < -4.224071, -0.305458, -3.403525>,
      < -4.743053, 1.791886, -3.400523>,
      < -4.738334, 1.799446, -3.358614>
    }
    triangle {
      < -4.224071, -0.305458, -3.403525>,
      < -4.738334, 1.799446, -3.358614>,
      < -4.224097, -0.305510, -3.359709>
    }
    triangle {
      < -4.224071, -0.305458, -3.403525>,
      < -4.224097, -0.305510, -3.359709>,
      < -4.223897, -0.315506, -3.359720>
    }
    triangle {
      < -4.224071, -0.305458, -3.403525>,
      < -4.223897, -0.315506, -3.359720>,
      < -4.223872, -0.315454, -3.403536>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -5.338473, 1.892523, -3.361748>,
      < -4.886660, 1.894031, -3.350061>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -4.886660, 1.894031, -3.350061>,
      < -4.918546, 1.900969, -3.401693>
    }
    triangle {
      < -5.673446, -0.167805, -3.401331>,
      < -5.670257, -0.327240, -3.401518>,
      < -5.670280, -0.327285, -3.363479>
    }
    triangle {
      < -5.673446, -0.167805, -3.401331>,
      < -5.670280, -0.327285, -3.363479>,
      < -5.673469, -0.167850, -3.363293>
    }
    triangle {
      < -5.673446, -0.167805, -3.401331>,
      < -5.673469, -0.167850, -3.363293>,
      < -5.674529, -0.142435, -3.363263>
    }
    triangle {
      < -5.673446, -0.167805, -3.401331>,
      < -5.674529, -0.142435, -3.363263>,
      < -5.632493, 1.859568, -3.361962>
    }
    triangle {
      < -5.673446, -0.167805, -3.401331>,
      < -5.632493, 1.859568, -3.361962>,
      < -5.632471, 1.859613, -3.400000>
    }
    triangle {
      < -5.673446, -0.167805, -3.401331>,
      < -5.632471, 1.859613, -3.400000>,
      < -5.674506, -0.142391, -3.401302>
    }
    texture {parts_rudder}
  }
  // parts_stabilizers
  union {
    triangle {
      < -5.729228, -0.256089, -3.340708>,
      < -5.731069, -0.259152, -0.236123>,
      < -5.149181, -0.230319, -0.235744>
    }
    triangle {
      < -5.729228, -0.256089, -3.340708>,
      < -5.149181, -0.230319, -0.235744>,
      < -5.147327, -0.227228, -3.363051>
    }
    texture {parts_stabilizers}
  }
  // parts_fuselage
  union {
    triangle {
      < -5.731069, -0.259152, -0.236123>,
      < -5.748468, -0.260208, -0.236134>,
      < -5.166045, -0.258182, -0.235787>
    }
    triangle {
      < -5.731069, -0.259152, -0.236123>,
      < -5.166045, -0.258182, -0.235787>,
      < -5.149181, -0.230319, -0.235744>
    }
    texture {parts_fuselage}
  }
  // parts_stabilizers
  union {
    triangle {
      < -5.748468, -0.260208, -0.236134>,
      < -5.746628, -0.257144, -3.340720>,
      < -5.146227, -0.254733, -3.363083>
    }
    triangle {
      < -5.748468, -0.260208, -0.236134>,
      < -5.146227, -0.254733, -3.363083>,
      < -5.166045, -0.258182, -0.235787>
    }
    texture {parts_stabilizers}
  }
  // parts_rudder
  union {
    triangle {
      < -5.746628, -0.257144, -3.340720>,
      < -5.729228, -0.256089, -3.340708>,
      < -5.147327, -0.227228, -3.363051>
    }
    triangle {
      < -5.746628, -0.257144, -3.340720>,
      < -5.147327, -0.227228, -3.363051>,
      < -5.146227, -0.254733, -3.363083>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -4.918546, 1.900969, -3.401693>,
      < -4.743053, 1.791886, -3.400523>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -4.743053, 1.791886, -3.400523>,
      < -4.224071, -0.305458, -3.403525>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -4.224071, -0.305458, -3.403525>,
      < -4.223872, -0.315454, -3.403536>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -4.223872, -0.315454, -3.403536>,
      < -4.344753, -0.317848, -3.423443>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -4.344753, -0.317848, -3.423443>,
      < -4.344952, -0.307852, -3.423431>
    }
    triangle {
      < -5.338450, 1.892569, -3.399786>,
      < -4.344952, -0.307852, -3.423431>,
      < -5.147305, -0.227183, -3.401090>
    }
    triangle {
      < -5.142776, -0.427278, -3.363286>,
      < -4.499843, -0.567682, -3.340349>,
      < -4.340396, -0.537628, -3.360052>
    }
    triangle {
      < -5.142776, -0.427278, -3.363286>,
      < -4.340396, -0.537628, -3.360052>,
      < -4.344802, -0.317947, -3.339962>
    }
    triangle {
      < -5.142776, -0.427278, -3.363286>,
      < -4.344802, -0.317947, -3.339962>,
      < -5.146227, -0.254733, -3.363083>
    }
    triangle {
      < -4.340370, -0.537576, -3.403868>,
      < -4.499794, -0.567583, -3.423831>,
      < -5.142754, -0.427232, -3.401325>
    }
    triangle {
      < -4.340370, -0.537576, -3.403868>,
      < -5.142754, -0.427232, -3.401325>,
      < -5.146204, -0.254688, -3.401122>
    }
    triangle {
      < -4.340370, -0.537576, -3.403868>,
      < -5.146204, -0.254688, -3.401122>,
      < -4.344753, -0.317848, -3.423443>
    }
    triangle {
      < -5.142776, -0.427278, -3.363286>,
      < -5.142754, -0.427232, -3.401325>,
      < -4.499794, -0.567583, -3.423831>
    }
    triangle {
      < -5.142776, -0.427278, -3.363286>,
      < -4.499794, -0.567583, -3.423831>,
      < -4.499843, -0.567682, -3.340349>
    }
    triangle {
      < -4.221479, -0.436400, -3.359862>,
      < -4.223897, -0.315506, -3.359720>,
      < -4.344802, -0.317947, -3.339962>
    }
    triangle {
      < -4.221479, -0.436400, -3.359862>,
      < -4.344802, -0.317947, -3.339962>,
      < -4.340396, -0.537628, -3.360052>
    }
    triangle {
      < -4.221453, -0.436348, -3.403678>,
      < -4.221479, -0.436400, -3.359862>,
      < -4.340396, -0.537628, -3.360052>
    }
    triangle {
      < -4.221453, -0.436348, -3.403678>,
      < -4.340396, -0.537628, -3.360052>,
      < -4.340370, -0.537576, -3.403868>
    }
    triangle {
      < -4.221479, -0.436400, -3.359862>,
      < -4.221453, -0.436348, -3.403678>,
      < -4.223872, -0.315454, -3.403536>
    }
    triangle {
      < -4.221479, -0.436400, -3.359862>,
      < -4.223872, -0.315454, -3.403536>,
      < -4.223897, -0.315506, -3.359720>
    }
    texture {parts_rudder}
  }
  // parts_stabilizers
  union {
    triangle {
      < -4.366960, -0.285625, -0.347654>,
      < -4.346775, -0.310881, -0.347671>,
      < -4.345002, -0.307950, -3.339949>
    }
    triangle {
      < -4.366960, -0.285625, -0.347654>,
      < -4.345002, -0.307950, -3.339949>,
      < -4.365186, -0.282695, -3.339931>
    }
    texture {parts_stabilizers}
  }
  // parts_rudder
  union {
    triangle {
      < -4.221453, -0.436348, -3.403678>,
      < -4.340370, -0.537576, -3.403868>,
      < -4.344753, -0.317848, -3.423443>
    }
    triangle {
      < -4.221453, -0.436348, -3.403678>,
      < -4.344753, -0.317848, -3.423443>,
      < -4.223872, -0.315454, -3.403536>
    }
    triangle {
      < -4.738334, 1.799446, -3.358614>,
      < -4.743053, 1.791886, -3.400523>,
      < -4.918546, 1.900969, -3.401693>
    }
    triangle {
      < -4.738334, 1.799446, -3.358614>,
      < -4.918546, 1.900969, -3.401693>,
      < -4.886660, 1.894031, -3.350061>
    }
    triangle {
      < -5.632493, 1.859568, -3.361962>,
      < -5.674529, -0.142435, -3.363263>,
      < -5.147327, -0.227228, -3.363051>
    }
    triangle {
      < -5.632493, 1.859568, -3.361962>,
      < -5.147327, -0.227228, -3.363051>,
      < -5.338473, 1.892523, -3.361748>
    }
    triangle {
      < -5.674529, -0.142435, -3.363263>,
      < -5.673469, -0.167850, -3.363293>,
      < -5.146227, -0.254733, -3.363083>
    }
    triangle {
      < -5.674529, -0.142435, -3.363263>,
      < -5.146227, -0.254733, -3.363083>,
      < -5.147327, -0.227228, -3.363051>
    }
    triangle {
      < -5.673469, -0.167850, -3.363293>,
      < -5.670280, -0.327285, -3.363479>,
      < -5.142776, -0.427278, -3.363286>
    }
    triangle {
      < -5.673469, -0.167850, -3.363293>,
      < -5.142776, -0.427278, -3.363286>,
      < -5.146227, -0.254733, -3.363083>
    }
    triangle {
      < -5.670280, -0.327285, -3.363479>,
      < -5.670257, -0.327240, -3.401518>,
      < -5.142754, -0.427232, -3.401325>
    }
    triangle {
      < -5.670280, -0.327285, -3.363479>,
      < -5.142754, -0.427232, -3.401325>,
      < -5.142776, -0.427278, -3.363286>
    }
    triangle {
      < -5.670257, -0.327240, -3.401518>,
      < -5.673446, -0.167805, -3.401331>,
      < -5.674506, -0.142391, -3.401302>
    }
    triangle {
      < -5.670257, -0.327240, -3.401518>,
      < -5.674506, -0.142391, -3.401302>,
      < -5.632471, 1.859613, -3.400000>
    }
    triangle {
      < -5.670257, -0.327240, -3.401518>,
      < -5.632471, 1.859613, -3.400000>,
      < -5.338450, 1.892569, -3.399786>
    }
    triangle {
      < -5.670257, -0.327240, -3.401518>,
      < -5.338450, 1.892569, -3.399786>,
      < -5.147305, -0.227183, -3.401090>
    }
    triangle {
      < -5.670257, -0.327240, -3.401518>,
      < -5.147305, -0.227183, -3.401090>,
      < -5.146204, -0.254688, -3.401122>
    }
    triangle {
      < -5.670257, -0.327240, -3.401518>,
      < -5.146204, -0.254688, -3.401122>,
      < -5.142754, -0.427232, -3.401325>
    }
    triangle {
      < -5.632471, 1.859613, -3.400000>,
      < -5.632493, 1.859568, -3.361962>,
      < -5.338473, 1.892523, -3.361748>
    }
    triangle {
      < -5.632471, 1.859613, -3.400000>,
      < -5.338473, 1.892523, -3.361748>,
      < -5.338450, 1.892569, -3.399786>
    }
    texture {parts_rudder}
  }
  // parts_fuselage
  union {
    triangle {
      < -1.265815, 0.541765, -0.410334>,
      < -1.199106, 0.573237, -0.410258>,
      < -1.177950, 0.542925, -0.285643>
    }
    triangle {
      < -1.265815, 0.541765, -0.410334>,
      < -1.177950, 0.542925, -0.285643>,
      < -1.243387, 0.449815, -0.349415>
    }
    triangle {
      < -1.199106, 0.573237, -0.410258>,
      < -1.266750, 0.588558, -0.410279>,
      < -1.246338, 0.592262, -0.183857>
    }
    triangle {
      < -1.199106, 0.573237, -0.410258>,
      < -1.246338, 0.592262, -0.183857>,
      < -1.177950, 0.542925, -0.285643>
    }
    triangle {
      < -1.266750, 0.588558, -0.410279>,
      < -3.463659, 0.499421, -0.411687>,
      < -3.441413, 0.410540, -0.153375>
    }
    triangle {
      < -1.266750, 0.588558, -0.410279>,
      < -3.441413, 0.410540, -0.153375>,
      < -1.246338, 0.592262, -0.183857>
    }
    triangle {
      < -3.463659, 0.499421, -0.411687>,
      < -3.756715, 0.473780, -0.411891>,
      < -4.051329, 0.318952, -0.214396>
    }
    triangle {
      < -3.463659, 0.499421, -0.411687>,
      < -4.051329, 0.318952, -0.214396>,
      < -3.441413, 0.410540, -0.153375>
    }
    triangle {
      < -3.756715, 0.473780, -0.411891>,
      < -3.462915, 0.462192, -0.411730>,
      < -3.439063, 0.297224, -0.290101>
    }
    triangle {
      < -3.756715, 0.473780, -0.411891>,
      < -3.439063, 0.297224, -0.290101>,
      < -4.051329, 0.318952, -0.214396>
    }
    triangle {
      < -3.462915, 0.462192, -0.411730>,
      < -1.265815, 0.541765, -0.410334>,
      < -1.243387, 0.449815, -0.349415>
    }
    triangle {
      < -3.462915, 0.462192, -0.411730>,
      < -1.243387, 0.449815, -0.349415>,
      < -3.439063, 0.297224, -0.290101>
    }
    triangle {
      < -3.289833, 0.592256, -0.735295>,
      < -3.559454, 0.567566, -0.735484>,
      < -3.756715, 0.473780, -0.411891>
    }
    triangle {
      < -3.289833, 0.592256, -0.735295>,
      < -3.756715, 0.473780, -0.411891>,
      < -3.463659, 0.499421, -0.411687>
    }
    triangle {
      < -3.559454, 0.567566, -0.735484>,
      < -3.289023, 0.555030, -0.735338>,
      < -3.462915, 0.462192, -0.411730>
    }
    triangle {
      < -3.559454, 0.567566, -0.735484>,
      < -3.462915, 0.462192, -0.411730>,
      < -3.756715, 0.473780, -0.411891>
    }
    triangle {
      < -3.289023, 0.555030, -0.735338>,
      < -1.267251, 0.627488, -0.734055>,
      < -1.265815, 0.541765, -0.410334>
    }
    triangle {
      < -3.289023, 0.555030, -0.735338>,
      < -1.265815, 0.541765, -0.410334>,
      < -3.462915, 0.462192, -0.411730>
    }
    triangle {
      < -1.267251, 0.627488, -0.734055>,
      < -1.205960, 0.658742, -0.733981>,
      < -1.199106, 0.573237, -0.410258>
    }
    triangle {
      < -1.267251, 0.627488, -0.734055>,
      < -1.199106, 0.573237, -0.410258>,
      < -1.265815, 0.541765, -0.410334>
    }
    triangle {
      < -1.205960, 0.658742, -0.733981>,
      < -1.268261, 0.674279, -0.733999>,
      < -1.266750, 0.588558, -0.410279>
    }
    triangle {
      < -1.205960, 0.658742, -0.733981>,
      < -1.266750, 0.588558, -0.410279>,
      < -1.199106, 0.573237, -0.410258>
    }
    triangle {
      < -1.268261, 0.674279, -0.733999>,
      < -3.289833, 0.592256, -0.735295>,
      < -3.463659, 0.499421, -0.411687>
    }
    triangle {
      < -1.268261, 0.674279, -0.733999>,
      < -3.463659, 0.499421, -0.411687>,
      < -1.266750, 0.588558, -0.410279>
    }
    texture {parts_fuselage}
  }
  // parts_flaps2
  union {
    triangle {
      < -0.602396, 0.129385, -6.428035>,
      < -0.005659, 0.141325, -6.427707>,
      < 0.018802, -0.040967, -4.955346>
    }
    triangle {
      < -0.602396, 0.129385, -6.428035>,
      < 0.018802, -0.040967, -4.955346>,
      < 0.020087, -0.050547, -4.877958>
    }
    triangle {
      < -0.602396, 0.129385, -6.428035>,
      < 0.020087, -0.050547, -4.877958>,
      < 0.020602, -0.054381, -4.846996>
    }
    triangle {
      < -0.602396, 0.129385, -6.428035>,
      < 0.020602, -0.054381, -4.846996>,
      < 0.021887, -0.063962, -4.769609>
    }
    triangle {
      < -0.602396, 0.129385, -6.428035>,
      < 0.021887, -0.063962, -4.769609>,
      < 0.027707, -0.107382, -4.418913>
    }
    triangle {
      < -0.602396, 0.129385, -6.428035>,
      < 0.027707, -0.107382, -4.418913>,
      < -0.730872, -0.122688, -4.410817>
    }
    texture {parts_flaps2}
  }
  // parts_wings
  union {
    triangle {
      < -0.151759, -0.129261, -4.271694>,
      < -0.740168, -0.141976, -4.264418>,
      < -0.730872, -0.122688, -4.410817>
    }
    triangle {
      < -0.151759, -0.129261, -4.271694>,
      < -0.730872, -0.122688, -4.410817>,
      < 0.027707, -0.107382, -4.418913>
    }
    texture {parts_wings}
  }
  // parts_flaps2
  union {
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.141365, -0.206687, -3.646320>,
      < -0.140850, -0.210521, -3.615347>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.140850, -0.210521, -3.615347>,
      < -0.139564, -0.220104, -3.537949>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.139564, -0.220104, -3.537949>,
      < -0.129183, -0.297421, -2.913451>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.129183, -0.297421, -2.913451>,
      < -0.127897, -0.307002, -2.836064>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.127897, -0.307002, -2.836064>,
      < -0.127383, -0.310835, -2.805102>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.127383, -0.310835, -2.805102>,
      < -0.126097, -0.320417, -2.727715>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.126097, -0.320417, -2.727715>,
      < -0.115636, -0.398417, -2.097703>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.115636, -0.398417, -2.097703>,
      < -0.878099, -0.413651, -2.098285>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.878099, -0.413651, -2.098285>,
      < -0.740168, -0.141976, -4.264418>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.740168, -0.141976, -4.264418>,
      < -0.151759, -0.129261, -4.271694>
    }
    texture {parts_flaps2}
  }
  // parts_wings
  union {
    triangle {
      < 0.018802, -0.040967, -4.955346>,
      < -0.005659, 0.141325, -6.427707>,
      < 0.878530, 0.159003, -6.427121>
    }
    triangle {
      < 0.018802, -0.040967, -4.955346>,
      < 0.878530, 0.159003, -6.427121>,
      < 1.020120, -0.019582, -4.965664>
    }
    triangle {
      < 0.018802, -0.040967, -4.955346>,
      < 1.020120, -0.019582, -4.965664>,
      < 0.968621, -0.026429, -4.918841>
    }
    triangle {
      < 0.018802, -0.040967, -4.955346>,
      < 0.968621, -0.026429, -4.918841>,
      < 0.066548, -0.045711, -4.909402>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.298080, -0.370169, -2.096622>,
      < -0.115636, -0.398417, -2.097703>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < -0.115636, -0.398417, -2.097703>,
      < -0.126097, -0.320417, -2.727715>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < -0.126097, -0.320417, -2.727715>,
      < -0.080088, -0.313652, -2.774766>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < -0.080088, -0.313652, -2.774766>,
      < 1.171655, -0.286471, -2.791277>
    }
    triangle {
      < -0.093553, -0.213493, -3.583756>,
      < 1.097592, -0.191557, -3.567823>,
      < 1.160101, -0.196138, -3.520810>
    }
    triangle {
      < -0.093553, -0.213493, -3.583756>,
      < 1.160101, -0.196138, -3.520810>,
      < 1.217237, -0.268204, -2.931062>
    }
    triangle {
      < -0.093553, -0.213493, -3.583756>,
      < 1.217237, -0.268204, -2.931062>,
      < 1.162808, -0.275132, -2.884048>
    }
    triangle {
      < -0.093553, -0.213493, -3.583756>,
      < 1.162808, -0.275132, -2.884048>,
      < -0.081631, -0.302155, -2.867634>
    }
    triangle {
      < -0.093553, -0.213493, -3.583756>,
      < -0.081631, -0.302155, -2.867634>,
      < -0.129183, -0.297421, -2.913451>
    }
    triangle {
      < -0.093553, -0.213493, -3.583756>,
      < -0.129183, -0.297421, -2.913451>,
      < -0.139564, -0.220104, -3.537949>
    }
    triangle {
      < -0.886860, -0.439938, -1.819164>,
      < -0.121660, -0.424634, -1.818693>,
      < 1.311610, -0.395970, -1.817809>
    }
    triangle {
      < -0.886860, -0.439938, -1.819164>,
      < 1.311610, -0.395970, -1.817809>,
      < 1.311765, -0.418208, -1.347173>
    }
    triangle {
      < -0.886860, -0.439938, -1.819164>,
      < 1.311765, -0.418208, -1.347173>,
      < 1.251340, -0.421626, -1.300469>
    }
    triangle {
      < -0.886860, -0.439938, -1.819164>,
      < 1.251340, -0.421626, -1.300469>,
      < -0.201681, -0.450685, -1.301364>
    }
    triangle {
      < -0.886860, -0.439938, -1.819164>,
      < -0.201681, -0.450685, -1.301364>,
      < -0.264146, -0.452671, -1.285823>
    }
    triangle {
      < -0.886860, -0.439938, -1.819164>,
      < -0.264146, -0.452671, -1.285823>,
      < -0.295327, -0.454767, -1.254679>
    }
    triangle {
      < -0.886860, -0.439938, -1.819164>,
      < -0.295327, -0.454767, -1.254679>,
      < -0.886675, -0.466594, -1.255044>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.151759, -0.129261, -4.271694>,
      < 0.027707, -0.107382, -4.418913>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < 0.027707, -0.107382, -4.418913>,
      < 1.076022, -0.090090, -4.388656>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < 1.076022, -0.090090, -4.388656>,
      < 1.142131, -0.173473, -3.706285>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < 1.142131, -0.173473, -3.706285>,
      < 1.088718, -0.180190, -3.660823>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < 1.088718, -0.180190, -3.660823>,
      < -0.095097, -0.201991, -3.676659>
    }
    triangle {
      < -0.248546, -0.453095, -1.270234>,
      < -0.248536, -0.454569, -1.239066>,
      < -0.264124, -0.455616, -1.223497>
    }
    triangle {
      < -0.248546, -0.453095, -1.270234>,
      < -0.264124, -0.455616, -1.223497>,
      < -0.295327, -0.454767, -1.254679>
    }
    triangle {
      < -0.248546, -0.453095, -1.270234>,
      < -0.295327, -0.454767, -1.254679>,
      < -0.264146, -0.452671, -1.285823>
    }
    texture {parts_wings}
  }
  // parts_slings
  union {
    triangle {
      < 1.121635, -0.245685, -4.826277>,
      < 0.091932, -0.267545, -4.816714>,
      < 0.044384, -0.264711, -4.847230>
    }
    triangle {
      < 1.121635, -0.245685, -4.826277>,
      < 0.044384, -0.264711, -4.847230>,
      < 0.043816, -0.260879, -4.878194>
    }
    triangle {
      < 1.121635, -0.245685, -4.826277>,
      < 0.043816, -0.260879, -4.878194>,
      < 0.090224, -0.256050, -4.909583>
    }
    triangle {
      < 1.121635, -0.245685, -4.826277>,
      < 0.090224, -0.256050, -4.909583>,
      < 1.111725, -0.234364, -4.919070>
    }
    triangle {
      < 1.121635, -0.245685, -4.826277>,
      < 1.111725, -0.234364, -4.919070>,
      < 1.171056, -0.236948, -4.888662>
    }
    triangle {
      < 1.121635, -0.245685, -4.826277>,
      < 1.171056, -0.236948, -4.888662>,
      < 1.174403, -0.240722, -4.857725>
    }
    triangle {
      < 1.255978, -0.399205, -3.567897>,
      < -0.089174, -0.424204, -3.584068>,
      < -0.136527, -0.421241, -3.615594>
    }
    triangle {
      < 1.255978, -0.399205, -3.567897>,
      < -0.136527, -0.421241, -3.615594>,
      < -0.137097, -0.417407, -3.646568>
    }
    triangle {
      < 1.255978, -0.399205, -3.567897>,
      < -0.137097, -0.417407, -3.646568>,
      < -0.090882, -0.412705, -3.676970>
    }
    triangle {
      < 1.255978, -0.399205, -3.567897>,
      < -0.090882, -0.412705, -3.676970>,
      < 1.246055, -0.387859, -3.660899>
    }
    triangle {
      < 1.255978, -0.399205, -3.567897>,
      < 1.246055, -0.387859, -3.660899>,
      < 1.307295, -0.390564, -3.629205>
    }
    triangle {
      < 1.255978, -0.399205, -3.567897>,
      < 1.307295, -0.390564, -3.629205>,
      < 1.310649, -0.394345, -3.598197>
    }
    triangle {
      < 1.338776, -0.493924, -2.791510>,
      < -0.074288, -0.524351, -2.774944>,
      < -0.121638, -0.521526, -2.805348>
    }
    triangle {
      < 1.338776, -0.493924, -2.791510>,
      < -0.121638, -0.521526, -2.805348>,
      < -0.122206, -0.517695, -2.836310>
    }
    triangle {
      < 1.338776, -0.493924, -2.791510>,
      < -0.122206, -0.517695, -2.836310>,
      < -0.075993, -0.512855, -2.867811>
    }
    triangle {
      < 1.338776, -0.493924, -2.791510>,
      < -0.075993, -0.512855, -2.867811>,
      < 1.328883, -0.482606, -2.884281>
    }
    triangle {
      < 1.338776, -0.493924, -2.791510>,
      < 1.328883, -0.482606, -2.884281>,
      < 1.391146, -0.485109, -2.854052>
    }
    triangle {
      < 1.338776, -0.493924, -2.791510>,
      < 1.391146, -0.485109, -2.854052>,
      < 1.394493, -0.488881, -2.823123>
    }
    triangle {
      < 1.427921, -0.633319, -1.207124>,
      < -0.210525, -0.666087, -1.208134>,
      < -0.257411, -0.665551, -1.239322>
    }
    triangle {
      < 1.427921, -0.633319, -1.207124>,
      < -0.257411, -0.665551, -1.239322>,
      < -0.257422, -0.664079, -1.270489>
    }
    triangle {
      < 1.427921, -0.633319, -1.207124>,
      < -0.257422, -0.664079, -1.270489>,
      < -0.210555, -0.661669, -1.301619>
    }
    triangle {
      < 1.427921, -0.633319, -1.207124>,
      < -0.210555, -0.661669, -1.301619>,
      < 1.427890, -0.628901, -1.300609>
    }
    triangle {
      < 1.427921, -0.633319, -1.207124>,
      < 1.427890, -0.628901, -1.300609>,
      < 1.488341, -0.629165, -1.269413>
    }
    triangle {
      < 1.427921, -0.633319, -1.207124>,
      < 1.488341, -0.629165, -1.269413>,
      < 1.488350, -0.630637, -1.238245>
    }
    triangle {
      < 0.043816, -0.260879, -4.878194>,
      < 0.044384, -0.264711, -4.847230>,
      < 0.020602, -0.054381, -4.846996>
    }
    triangle {
      < 0.043816, -0.260879, -4.878194>,
      < 0.020602, -0.054381, -4.846996>,
      < 0.020087, -0.050547, -4.877958>
    }
    triangle {
      < 0.091932, -0.267545, -4.816714>,
      < 1.121635, -0.245685, -4.826277>,
      < 0.977483, -0.037770, -4.826049>
    }
    triangle {
      < 0.091932, -0.267545, -4.816714>,
      < 0.977483, -0.037770, -4.826049>,
      < 0.068094, -0.057210, -4.816535>
    }
    triangle {
      < 1.174403, -0.240722, -4.857725>,
      < 1.171056, -0.236948, -4.888662>,
      < 1.027596, -0.029011, -4.888500>
    }
    triangle {
      < 1.174403, -0.240722, -4.857725>,
      < 1.027596, -0.029011, -4.888500>,
      < 1.030594, -0.032791, -4.857564>
    }
    triangle {
      < 1.111725, -0.234364, -4.919070>,
      < 0.090224, -0.256050, -4.909583>,
      < 0.066548, -0.045711, -4.909402>
    }
    triangle {
      < 1.111725, -0.234364, -4.919070>,
      < 0.066548, -0.045711, -4.909402>,
      < 0.968621, -0.026429, -4.918841>
    }
    triangle {
      < -0.137097, -0.417407, -3.646568>,
      < -0.136527, -0.421241, -3.615594>,
      < -0.140850, -0.210521, -3.615347>
    }
    triangle {
      < -0.137097, -0.417407, -3.646568>,
      < -0.140850, -0.210521, -3.615347>,
      < -0.141365, -0.206687, -3.646320>
    }
    triangle {
      < -0.089174, -0.424204, -3.584068>,
      < 1.255978, -0.399205, -3.567897>,
      < 1.097592, -0.191557, -3.567823>
    }
    triangle {
      < -0.089174, -0.424204, -3.584068>,
      < 1.097592, -0.191557, -3.567823>,
      < -0.093553, -0.213493, -3.583756>
    }
    triangle {
      < 1.310649, -0.394345, -3.598197>,
      < 1.307295, -0.390564, -3.629205>,
      < 1.149614, -0.182911, -3.629052>
    }
    triangle {
      < 1.310649, -0.394345, -3.598197>,
      < 1.149614, -0.182911, -3.629052>,
      < 1.152618, -0.186700, -3.598044>
    }
    triangle {
      < 1.246055, -0.387859, -3.660899>,
      < -0.090882, -0.412705, -3.676970>,
      < -0.095097, -0.201991, -3.676659>
    }
    triangle {
      < 1.246055, -0.387859, -3.660899>,
      < -0.095097, -0.201991, -3.676659>,
      < 1.088718, -0.180190, -3.660823>
    }
    triangle {
      < -0.122206, -0.517695, -2.836310>,
      < -0.121638, -0.521526, -2.805348>,
      < -0.127383, -0.310835, -2.805102>
    }
    triangle {
      < -0.122206, -0.517695, -2.836310>,
      < -0.127383, -0.310835, -2.805102>,
      < -0.127897, -0.307002, -2.836064>
    }
    triangle {
      < -0.074288, -0.524351, -2.774944>,
      < 1.338776, -0.493924, -2.791510>,
      < 1.171655, -0.286471, -2.791277>
    }
    triangle {
      < -0.074288, -0.524351, -2.774944>,
      < 1.171655, -0.286471, -2.791277>,
      < -0.080088, -0.313652, -2.774766>
    }
    triangle {
      < 1.394493, -0.488881, -2.823123>,
      < 1.391146, -0.485109, -2.854052>,
      < 1.224713, -0.277631, -2.853905>
    }
    triangle {
      < 1.394493, -0.488881, -2.823123>,
      < 1.224713, -0.277631, -2.853905>,
      < 1.227710, -0.281411, -2.822975>
    }
    triangle {
      < 1.328883, -0.482606, -2.884281>,
      < -0.075993, -0.512855, -2.867811>,
      < -0.081631, -0.302155, -2.867634>
    }
    triangle {
      < 1.328883, -0.482606, -2.884281>,
      < -0.081631, -0.302155, -2.867634>,
      < 1.162808, -0.275132, -2.884048>
    }
    triangle {
      < -0.257422, -0.664079, -1.270489>,
      < -0.257411, -0.665551, -1.239322>,
      < -0.248536, -0.454569, -1.239066>
    }
    triangle {
      < -0.257422, -0.664079, -1.270489>,
      < -0.248536, -0.454569, -1.239066>,
      < -0.248546, -0.453095, -1.270234>
    }
    triangle {
      < -0.210525, -0.666087, -1.208134>,
      < 1.427921, -0.633319, -1.207124>,
      < 1.251371, -0.426043, -1.206983>
    }
    triangle {
      < -0.210525, -0.666087, -1.208134>,
      < 1.251371, -0.426043, -1.206983>,
      < -0.201650, -0.455103, -1.207878>
    }
    triangle {
      < 1.488350, -0.630637, -1.238245>,
      < 1.488341, -0.629165, -1.269413>,
      < 1.311790, -0.421890, -1.269272>
    }
    triangle {
      < 1.488350, -0.630637, -1.238245>,
      < 1.311790, -0.421890, -1.269272>,
      < 1.311800, -0.423362, -1.238104>
    }
    triangle {
      < 1.427890, -0.628901, -1.300609>,
      < -0.210555, -0.661669, -1.301619>,
      < -0.201681, -0.450685, -1.301364>
    }
    triangle {
      < 1.427890, -0.628901, -1.300609>,
      < -0.201681, -0.450685, -1.301364>,
      < 1.251340, -0.421626, -1.300469>
    }
    texture {parts_slings}
  }
  // parts_wings
  union {
    triangle {
      < 0.018802, -0.040967, -4.955346>,
      < 0.066548, -0.045711, -4.909402>,
      < 0.020087, -0.050547, -4.877958>
    }
    triangle {
      < -0.142651, -0.197104, -3.723719>,
      < -0.095097, -0.201991, -3.676659>,
      < -0.141365, -0.206687, -3.646320>
    }
    triangle {
      < -0.129183, -0.297421, -2.913451>,
      < -0.081631, -0.302155, -2.867634>,
      < -0.127897, -0.307002, -2.836064>
    }
    triangle {
      < -0.264146, -0.452671, -1.285823>,
      < -0.201681, -0.450685, -1.301364>,
      < -0.248546, -0.453095, -1.270234>
    }
    triangle {
      < 1.020120, -0.019582, -4.965664>,
      < 1.027596, -0.029011, -4.888500>,
      < 0.968621, -0.026429, -4.918841>
    }
    triangle {
      < 1.038069, -0.042221, -4.780401>,
      < 0.977483, -0.037770, -4.826049>,
      < 1.030594, -0.032791, -4.857564>
    }
    triangle {
      < 1.160101, -0.196138, -3.520810>,
      < 1.097592, -0.191557, -3.567823>,
      < 1.152618, -0.186700, -3.598044>
    }
    triangle {
      < 1.142131, -0.173473, -3.706285>,
      < 1.149614, -0.182911, -3.629052>,
      < 1.088718, -0.180190, -3.660823>
    }
    triangle {
      < 1.217237, -0.268204, -2.931062>,
      < 1.224713, -0.277631, -2.853905>,
      < 1.162808, -0.275132, -2.884048>
    }
    triangle {
      < 1.235184, -0.290839, -2.745819>,
      < 1.171655, -0.286471, -2.791277>,
      < 1.227710, -0.281411, -2.822975>
    }
    triangle {
      < 1.311765, -0.418208, -1.347173>,
      < 1.311790, -0.421890, -1.269272>,
      < 1.251340, -0.421626, -1.300469>
    }
    triangle {
      < 1.311825, -0.427044, -1.160203>,
      < 1.251371, -0.426043, -1.206983>,
      < 1.311800, -0.423362, -1.238104>
    }
    triangle {
      < -0.264124, -0.455616, -1.223497>,
      < -0.248536, -0.454569, -1.239066>,
      < -0.201650, -0.455103, -1.207878>
    }
    triangle {
      < -0.126097, -0.320417, -2.727715>,
      < -0.127383, -0.310835, -2.805102>,
      < -0.080088, -0.313652, -2.774766>
    }
    triangle {
      < -0.139564, -0.220104, -3.537949>,
      < -0.140850, -0.210521, -3.615347>,
      < -0.093553, -0.213493, -3.583756>
    }
    triangle {
      < 0.021887, -0.063962, -4.769609>,
      < 0.020602, -0.054381, -4.846996>,
      < 0.068094, -0.057210, -4.816535>
    }
    texture {parts_wings}
  }
  // parts_slings
  union {
    triangle {
      < 0.043816, -0.260879, -4.878194>,
      < 0.020087, -0.050547, -4.877958>,
      < 0.066548, -0.045711, -4.909402>
    }
    triangle {
      < 0.043816, -0.260879, -4.878194>,
      < 0.066548, -0.045711, -4.909402>,
      < 0.090224, -0.256050, -4.909583>
    }
    triangle {
      < -0.137097, -0.417407, -3.646568>,
      < -0.141365, -0.206687, -3.646320>,
      < -0.095097, -0.201991, -3.676659>
    }
    triangle {
      < -0.137097, -0.417407, -3.646568>,
      < -0.095097, -0.201991, -3.676659>,
      < -0.090882, -0.412705, -3.676970>
    }
    triangle {
      < -0.122206, -0.517695, -2.836310>,
      < -0.127897, -0.307002, -2.836064>,
      < -0.081631, -0.302155, -2.867634>
    }
    triangle {
      < -0.122206, -0.517695, -2.836310>,
      < -0.081631, -0.302155, -2.867634>,
      < -0.075993, -0.512855, -2.867811>
    }
    triangle {
      < -0.257422, -0.664079, -1.270489>,
      < -0.248546, -0.453095, -1.270234>,
      < -0.201681, -0.450685, -1.301364>
    }
    triangle {
      < -0.257422, -0.664079, -1.270489>,
      < -0.201681, -0.450685, -1.301364>,
      < -0.210555, -0.661669, -1.301619>
    }
    triangle {
      < 1.111725, -0.234364, -4.919070>,
      < 0.968621, -0.026429, -4.918841>,
      < 1.027596, -0.029011, -4.888500>
    }
    triangle {
      < 1.111725, -0.234364, -4.919070>,
      < 1.027596, -0.029011, -4.888500>,
      < 1.171056, -0.236948, -4.888662>
    }
    triangle {
      < 1.174403, -0.240722, -4.857725>,
      < 1.030594, -0.032791, -4.857564>,
      < 0.977483, -0.037770, -4.826049>
    }
    triangle {
      < 1.174403, -0.240722, -4.857725>,
      < 0.977483, -0.037770, -4.826049>,
      < 1.121635, -0.245685, -4.826277>
    }
    triangle {
      < 1.310649, -0.394345, -3.598197>,
      < 1.152618, -0.186700, -3.598044>,
      < 1.097592, -0.191557, -3.567823>
    }
    triangle {
      < 1.310649, -0.394345, -3.598197>,
      < 1.097592, -0.191557, -3.567823>,
      < 1.255978, -0.399205, -3.567897>
    }
    triangle {
      < 1.246055, -0.387859, -3.660899>,
      < 1.088718, -0.180190, -3.660823>,
      < 1.149614, -0.182911, -3.629052>
    }
    triangle {
      < 1.246055, -0.387859, -3.660899>,
      < 1.149614, -0.182911, -3.629052>,
      < 1.307295, -0.390564, -3.629205>
    }
    triangle {
      < 1.328883, -0.482606, -2.884281>,
      < 1.162808, -0.275132, -2.884048>,
      < 1.224713, -0.277631, -2.853905>
    }
    triangle {
      < 1.328883, -0.482606, -2.884281>,
      < 1.224713, -0.277631, -2.853905>,
      < 1.391146, -0.485109, -2.854052>
    }
    triangle {
      < 1.394493, -0.488881, -2.823123>,
      < 1.227710, -0.281411, -2.822975>,
      < 1.171655, -0.286471, -2.791277>
    }
    triangle {
      < 1.394493, -0.488881, -2.823123>,
      < 1.171655, -0.286471, -2.791277>,
      < 1.338776, -0.493924, -2.791510>
    }
    triangle {
      < 1.427890, -0.628901, -1.300609>,
      < 1.251340, -0.421626, -1.300469>,
      < 1.311790, -0.421890, -1.269272>
    }
    triangle {
      < 1.427890, -0.628901, -1.300609>,
      < 1.311790, -0.421890, -1.269272>,
      < 1.488341, -0.629165, -1.269413>
    }
    triangle {
      < 1.488350, -0.630637, -1.238245>,
      < 1.311800, -0.423362, -1.238104>,
      < 1.251371, -0.426043, -1.206983>
    }
    triangle {
      < 1.488350, -0.630637, -1.238245>,
      < 1.251371, -0.426043, -1.206983>,
      < 1.427921, -0.633319, -1.207124>
    }
    triangle {
      < -0.210525, -0.666087, -1.208134>,
      < -0.201650, -0.455103, -1.207878>,
      < -0.248536, -0.454569, -1.239066>
    }
    triangle {
      < -0.210525, -0.666087, -1.208134>,
      < -0.248536, -0.454569, -1.239066>,
      < -0.257411, -0.665551, -1.239322>
    }
    triangle {
      < -0.074288, -0.524351, -2.774944>,
      < -0.080088, -0.313652, -2.774766>,
      < -0.127383, -0.310835, -2.805102>
    }
    triangle {
      < -0.074288, -0.524351, -2.774944>,
      < -0.127383, -0.310835, -2.805102>,
      < -0.121638, -0.521526, -2.805348>
    }
    triangle {
      < -0.089174, -0.424204, -3.584068>,
      < -0.093553, -0.213493, -3.583756>,
      < -0.140850, -0.210521, -3.615347>
    }
    triangle {
      < -0.089174, -0.424204, -3.584068>,
      < -0.140850, -0.210521, -3.615347>,
      < -0.136527, -0.421241, -3.615594>
    }
    triangle {
      < 0.091932, -0.267545, -4.816714>,
      < 0.068094, -0.057210, -4.816535>,
      < 0.020602, -0.054381, -4.846996>
    }
    triangle {
      < 0.091932, -0.267545, -4.816714>,
      < 0.020602, -0.054381, -4.846996>,
      < 0.044384, -0.264711, -4.847230>
    }
    texture {parts_slings}
  }
  // parts_gearbay
  union {
    triangle {
      < -0.121660, -0.424634, -1.818693>,
      < -0.120391, -0.488077, -1.818767>,
      < 1.713720, -0.427276, -1.817604>
    }
    triangle {
      < -0.121660, -0.424634, -1.818693>,
      < 1.713720, -0.427276, -1.817604>,
      < 1.311610, -0.395970, -1.817809>
    }
    triangle {
      < 1.711468, -0.312558, -1.887593>,
      < 1.711433, -0.306532, -2.026287>,
      < 1.345801, -0.228301, -2.026570>
    }
    triangle {
      < 1.711468, -0.312558, -1.887593>,
      < 1.345801, -0.228301, -2.026570>,
      < 1.352784, -0.240393, -1.887555>
    }
    triangle {
      < 1.467399, -0.314810, -2.096342>,
      < 1.469532, -0.280613, -2.096335>,
      < 1.712521, -0.358788, -2.096440>
    }
    triangle {
      < 1.467399, -0.314810, -2.096342>,
      < 1.712521, -0.358788, -2.096440>,
      < 1.714283, -0.446879, -2.096467>
    }
    triangle {
      < 1.467399, -0.314810, -2.096342>,
      < 1.714283, -0.446879, -2.096467>,
      < 1.298080, -0.370169, -2.096622>
    }
    triangle {
      < 1.467399, -0.314810, -2.096342>,
      < 1.298080, -0.370169, -2.096622>,
      < 1.428557, -0.349757, -2.096411>
    }
    triangle {
      < -0.119513, -0.519778, -1.829017>,
      < -0.114182, -0.519403, -2.056464>,
      < 1.715601, -0.482773, -2.086198>
    }
    triangle {
      < -0.119513, -0.519778, -1.829017>,
      < 1.715601, -0.482773, -2.086198>,
      < 1.714571, -0.483060, -1.859137>
    }
    texture {parts_gearbay}
  }
  // parts_wings
  union {
    triangle {
      < -0.115636, -0.398417, -2.097703>,
      < -0.114024, -0.479034, -2.097797>,
      < -0.252385, -0.409848, -2.004803>
    }
    triangle {
      < 1.286326, -0.240938, -1.817630>,
      < 1.356321, -0.249769, -1.747479>,
      < 1.387498, -0.254957, -1.817591>
    }
    triangle {
      < 1.286326, -0.240938, -1.817630>,
      < 1.387498, -0.254957, -1.817591>,
      < 1.352784, -0.240393, -1.887555>
    }
    triangle {
      < 1.335324, -0.214479, -2.165953>,
      < 1.272313, -0.216675, -2.096640>,
      < 1.345801, -0.228301, -2.026570>
    }
    triangle {
      < 1.335324, -0.214479, -2.165953>,
      < 1.345801, -0.228301, -2.026570>,
      < 1.373173, -0.230532, -2.096487>
    }
    texture {parts_wings}
  }
  // parts_gearbay
  union {
    triangle {
      < -0.119513, -0.519778, -1.829017>,
      < 1.714571, -0.483060, -1.859137>,
      < 1.713720, -0.427276, -1.817604>
    }
    triangle {
      < -0.119513, -0.519778, -1.829017>,
      < 1.713720, -0.427276, -1.817604>,
      < -0.120391, -0.488077, -1.818767>
    }
    triangle {
      < 1.711468, -0.312558, -1.887593>,
      < 1.352784, -0.240393, -1.887555>,
      < 1.387498, -0.254957, -1.817591>
    }
    triangle {
      < 1.711468, -0.312558, -1.887593>,
      < 1.387498, -0.254957, -1.817591>,
      < 1.712602, -0.371432, -1.817535>
    }
    triangle {
      < 1.712521, -0.358788, -2.096440>,
      < 1.373173, -0.230532, -2.096487>,
      < 1.345801, -0.228301, -2.026570>
    }
    triangle {
      < 1.712521, -0.358788, -2.096440>,
      < 1.345801, -0.228301, -2.026570>,
      < 1.711433, -0.306532, -2.026287>
    }
    triangle {
      < 1.715601, -0.482773, -2.086198>,
      < -0.114182, -0.519403, -2.056464>,
      < -0.114024, -0.479034, -2.097797>
    }
    triangle {
      < 1.715601, -0.482773, -2.086198>,
      < -0.114024, -0.479034, -2.097797>,
      < 1.714283, -0.446879, -2.096467>
    }
    triangle {
      < 1.469532, -0.280613, -2.096335>,
      < 1.434956, -0.247168, -2.096388>,
      < 1.373173, -0.230532, -2.096487>
    }
    triangle {
      < 1.469532, -0.280613, -2.096335>,
      < 1.373173, -0.230532, -2.096487>,
      < 1.712521, -0.358788, -2.096440>
    }
    triangle {
      < -0.114024, -0.479034, -2.097797>,
      < -0.115636, -0.398417, -2.097703>,
      < 1.298080, -0.370169, -2.096622>
    }
    triangle {
      < -0.114024, -0.479034, -2.097797>,
      < 1.298080, -0.370169, -2.096622>,
      < 1.714283, -0.446879, -2.096467>
    }
    triangle {
      < 1.443411, -0.375332, -1.817705>,
      < 1.311610, -0.395970, -1.817809>,
      < 1.713720, -0.427276, -1.817604>
    }
    triangle {
      < 1.387498, -0.254957, -1.817591>,
      < 1.449907, -0.271919, -1.817586>,
      < 1.712602, -0.371432, -1.817535>
    }
    triangle {
      < 1.482655, -0.340018, -1.817638>,
      < 1.443411, -0.375332, -1.817705>,
      < 1.713720, -0.427276, -1.817604>
    }
    triangle {
      < 1.712602, -0.371432, -1.817535>,
      < 1.484823, -0.305606, -1.817601>,
      < 1.482655, -0.340018, -1.817638>
    }
    triangle {
      < 1.712602, -0.371432, -1.817535>,
      < 1.482655, -0.340018, -1.817638>,
      < 1.713720, -0.427276, -1.817604>
    }
    triangle {
      < 1.449907, -0.271919, -1.817586>,
      < 1.484823, -0.305606, -1.817601>,
      < 1.712602, -0.371432, -1.817535>
    }
    triangle {
      < 1.768274, -0.356911, -2.006053>,
      < 1.769045, -0.393913, -2.055728>,
      < 1.712521, -0.358788, -2.096440>
    }
    triangle {
      < 1.768274, -0.356911, -2.006053>,
      < 1.712521, -0.358788, -2.096440>,
      < 1.711433, -0.306532, -2.026287>
    }
    triangle {
      < 1.769045, -0.393913, -2.055728>,
      < 1.770293, -0.456289, -2.055747>,
      < 1.714283, -0.446879, -2.096467>
    }
    triangle {
      < 1.769045, -0.393913, -2.055728>,
      < 1.714283, -0.446879, -2.096467>,
      < 1.712521, -0.358788, -2.096440>
    }
    triangle {
      < 1.770293, -0.456289, -2.055747>,
      < 1.770771, -0.481764, -2.006074>,
      < 1.715601, -0.482773, -2.086198>
    }
    triangle {
      < 1.770293, -0.456289, -2.055747>,
      < 1.715601, -0.482773, -2.086198>,
      < 1.714283, -0.446879, -2.096467>
    }
    triangle {
      < 1.770771, -0.481764, -2.006074>,
      < 1.770713, -0.481880, -1.908039>,
      < 1.714571, -0.483060, -1.859137>
    }
    triangle {
      < 1.770771, -0.481764, -2.006074>,
      < 1.714571, -0.483060, -1.859137>,
      < 1.715601, -0.482773, -2.086198>
    }
    triangle {
      < 1.770713, -0.481880, -1.908039>,
      < 1.769893, -0.442408, -1.858288>,
      < 1.713720, -0.427276, -1.817604>
    }
    triangle {
      < 1.770713, -0.481880, -1.908039>,
      < 1.713720, -0.427276, -1.817604>,
      < 1.714571, -0.483060, -1.859137>
    }
    triangle {
      < 1.769893, -0.442408, -1.858288>,
      < 1.769103, -0.402865, -1.858238>,
      < 1.712602, -0.371432, -1.817535>
    }
    triangle {
      < 1.769893, -0.442408, -1.858288>,
      < 1.712602, -0.371432, -1.817535>,
      < 1.713720, -0.427276, -1.817604>
    }
    triangle {
      < 1.769103, -0.402865, -1.858238>,
      < 1.768299, -0.361178, -1.907846>,
      < 1.711468, -0.312558, -1.887593>
    }
    triangle {
      < 1.769103, -0.402865, -1.858238>,
      < 1.711468, -0.312558, -1.887593>,
      < 1.712602, -0.371432, -1.817535>
    }
    triangle {
      < 1.768299, -0.361178, -1.907846>,
      < 1.768274, -0.356911, -2.006053>,
      < 1.711433, -0.306532, -2.026287>
    }
    triangle {
      < 1.768299, -0.361178, -1.907846>,
      < 1.711433, -0.306532, -2.026287>,
      < 1.711468, -0.312558, -1.887593>
    }
    triangle {
      < 1.811386, -0.468392, -1.925428>,
      < 1.811134, -0.455740, -1.925413>,
      < 1.769103, -0.402865, -1.858238>
    }
    triangle {
      < 1.811386, -0.468392, -1.925428>,
      < 1.769103, -0.402865, -1.858238>,
      < 1.769893, -0.442408, -1.858288>
    }
    triangle {
      < 1.811134, -0.455740, -1.925413>,
      < 1.810876, -0.442401, -1.941286>,
      < 1.768299, -0.361178, -1.907846>
    }
    triangle {
      < 1.811134, -0.455740, -1.925413>,
      < 1.768299, -0.361178, -1.907846>,
      < 1.769103, -0.402865, -1.858238>
    }
    triangle {
      < 1.810876, -0.442401, -1.941286>,
      < 1.810869, -0.441036, -1.972708>,
      < 1.768274, -0.356911, -2.006053>
    }
    triangle {
      < 1.810876, -0.442401, -1.941286>,
      < 1.768274, -0.356911, -2.006053>,
      < 1.768299, -0.361178, -1.907846>
    }
    triangle {
      < 1.810869, -0.441036, -1.972708>,
      < 1.811115, -0.452875, -1.988603>,
      < 1.769045, -0.393913, -2.055728>
    }
    triangle {
      < 1.810869, -0.441036, -1.972708>,
      < 1.769045, -0.393913, -2.055728>,
      < 1.768274, -0.356911, -2.006053>
    }
    triangle {
      < 1.811115, -0.452875, -1.988603>,
      < 1.811514, -0.472833, -1.988609>,
      < 1.770293, -0.456289, -2.055747>
    }
    triangle {
      < 1.811115, -0.452875, -1.988603>,
      < 1.770293, -0.456289, -2.055747>,
      < 1.769045, -0.393913, -2.055728>
    }
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.811667, -0.480985, -1.972716>,
      < 1.770771, -0.481764, -2.006074>
    }
    triangle {
      < 1.811514, -0.472833, -1.988609>,
      < 1.770771, -0.481764, -2.006074>,
      < 1.770293, -0.456289, -2.055747>
    }
    triangle {
      < 1.811667, -0.480985, -1.972716>,
      < 1.811649, -0.481022, -1.941348>,
      < 1.770713, -0.481880, -1.908039>
    }
    triangle {
      < 1.811667, -0.480985, -1.972716>,
      < 1.770713, -0.481880, -1.908039>,
      < 1.770771, -0.481764, -2.006074>
    }
    triangle {
      < 1.811649, -0.481022, -1.941348>,
      < 1.811386, -0.468392, -1.925428>,
      < 1.769893, -0.442408, -1.858288>
    }
    triangle {
      < 1.811649, -0.481022, -1.941348>,
      < 1.769893, -0.442408, -1.858288>,
      < 1.770713, -0.481880, -1.908039>
    }
    texture {parts_gearbay}
  }
  // parts_wings
  union {
    triangle {
      < -0.119513, -0.519778, -1.829017>,
      < -0.254393, -0.418587, -1.911799>,
      < -0.252385, -0.409848, -2.004803>
    }
    triangle {
      < -0.119513, -0.519778, -1.829017>,
      < -0.252385, -0.409848, -2.004803>,
      < -0.114182, -0.519403, -2.056464>
    }
    triangle {
      < -0.120391, -0.488077, -1.818767>,
      < -0.254393, -0.418587, -1.911799>,
      < -0.119513, -0.519778, -1.829017>
    }
    triangle {
      < -0.114182, -0.519403, -2.056464>,
      < -0.252385, -0.409848, -2.004803>,
      < -0.114024, -0.479034, -2.097797>
    }
    triangle {
      < -0.121660, -0.424634, -1.818693>,
      < -0.254393, -0.418587, -1.911799>,
      < -0.120391, -0.488077, -1.818767>
    }
    triangle {
      < -0.123813, -0.428941, 1.815447>,
      < -0.122544, -0.492384, 1.815372>,
      < -0.256657, -0.423115, 1.908410>
    }
    triangle {
      < -0.116617, -0.524275, 2.053002>,
      < -0.116508, -0.484003, 2.094430>,
      < -0.254759, -0.414596, 2.001437>
    }
    triangle {
      < -0.122544, -0.492384, 1.815372>,
      < -0.121679, -0.524109, 1.825548>,
      < -0.256657, -0.423115, 1.908410>
    }
    triangle {
      < -0.256657, -0.423115, 1.908410>,
      < -0.121679, -0.524109, 1.825548>,
      < -0.116617, -0.524275, 2.053002>
    }
    triangle {
      < -0.256657, -0.423115, 1.908410>,
      < -0.116617, -0.524275, 2.053002>,
      < -0.254759, -0.414596, 2.001437>
    }
    texture {parts_wings}
  }
  // parts_gearbay
  union {
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.809348, -0.485622, 1.940259>,
      < 1.768452, -0.486401, 1.906900>
    }
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.768452, -0.486401, 1.906900>,
      < 1.767691, -0.446812, 1.857242>
    }
    triangle {
      < 1.809348, -0.485622, 1.940259>,
      < 1.809330, -0.485659, 1.971627>,
      < 1.768394, -0.486517, 2.004936>
    }
    triangle {
      < 1.809348, -0.485622, 1.940259>,
      < 1.768394, -0.486517, 2.004936>,
      < 1.768452, -0.486401, 1.906900>
    }
    triangle {
      < 1.809330, -0.485659, 1.971627>,
      < 1.809158, -0.477546, 1.987540>,
      < 1.767857, -0.461160, 2.054668>
    }
    triangle {
      < 1.809330, -0.485659, 1.971627>,
      < 1.767857, -0.461160, 2.054668>,
      < 1.768394, -0.486517, 2.004936>
    }
    triangle {
      < 1.809158, -0.477546, 1.987540>,
      < 1.808759, -0.457588, 1.987581>,
      < 1.766609, -0.398784, 2.054795>
    }
    triangle {
      < 1.809158, -0.477546, 1.987540>,
      < 1.766609, -0.398784, 2.054795>,
      < 1.767857, -0.461160, 2.054668>
    }
    triangle {
      < 1.808759, -0.457588, 1.987581>,
      < 1.808531, -0.445711, 1.971714>,
      < 1.765897, -0.361665, 2.005208>
    }
    triangle {
      < 1.808759, -0.457588, 1.987581>,
      < 1.765897, -0.361665, 2.005208>,
      < 1.766609, -0.398784, 2.054795>
    }
    triangle {
      < 1.808531, -0.445711, 1.971714>,
      < 1.808576, -0.447002, 1.940288>,
      < 1.766038, -0.365699, 1.906990>
    }
    triangle {
      < 1.808531, -0.445711, 1.971714>,
      < 1.766038, -0.365699, 1.906990>,
      < 1.765897, -0.361665, 2.005208>
    }
    triangle {
      < 1.808576, -0.447002, 1.940288>,
      < 1.808852, -0.460303, 1.924383>,
      < 1.766901, -0.407269, 1.857285>
    }
    triangle {
      < 1.808576, -0.447002, 1.940288>,
      < 1.766901, -0.407269, 1.857285>,
      < 1.766038, -0.365699, 1.906990>
    }
    triangle {
      < 1.808852, -0.460303, 1.924383>,
      < 1.809105, -0.472955, 1.924370>,
      < 1.767691, -0.446812, 1.857242>
    }
    triangle {
      < 1.808852, -0.460303, 1.924383>,
      < 1.767691, -0.446812, 1.857242>,
      < 1.766901, -0.407269, 1.857285>
    }
    triangle {
      < 1.765897, -0.361665, 2.005208>,
      < 1.766038, -0.365699, 1.906990>,
      < 1.709231, -0.317032, 1.886786>
    }
    triangle {
      < 1.765897, -0.361665, 2.005208>,
      < 1.709231, -0.317032, 1.886786>,
      < 1.709032, -0.311335, 2.025492>
    }
    triangle {
      < 1.766038, -0.365699, 1.906990>,
      < 1.766901, -0.407269, 1.857285>,
      < 1.710449, -0.375740, 1.816589>
    }
    triangle {
      < 1.766038, -0.365699, 1.906990>,
      < 1.710449, -0.375740, 1.816589>,
      < 1.709231, -0.317032, 1.886786>
    }
    triangle {
      < 1.766901, -0.407269, 1.857285>,
      < 1.767691, -0.446812, 1.857242>,
      < 1.711566, -0.431584, 1.816528>
    }
    triangle {
      < 1.766901, -0.407269, 1.857285>,
      < 1.711566, -0.431584, 1.816528>,
      < 1.710449, -0.375740, 1.816589>
    }
    triangle {
      < 1.767691, -0.446812, 1.857242>,
      < 1.768452, -0.486401, 1.906900>,
      < 1.712368, -0.487466, 1.857929>
    }
    triangle {
      < 1.767691, -0.446812, 1.857242>,
      < 1.712368, -0.487466, 1.857929>,
      < 1.711566, -0.431584, 1.816528>
    }
    triangle {
      < 1.768452, -0.486401, 1.906900>,
      < 1.768394, -0.486517, 2.004936>,
      < 1.713129, -0.487716, 2.084991>
    }
    triangle {
      < 1.768452, -0.486401, 1.906900>,
      < 1.713129, -0.487716, 2.084991>,
      < 1.712368, -0.487466, 1.857929>
    }
    triangle {
      < 1.768394, -0.486517, 2.004936>,
      < 1.767857, -0.461160, 2.054668>,
      < 1.711799, -0.451847, 2.095342>
    }
    triangle {
      < 1.768394, -0.486517, 2.004936>,
      < 1.711799, -0.451847, 2.095342>,
      < 1.713129, -0.487716, 2.084991>
    }
    triangle {
      < 1.767857, -0.461160, 2.054668>,
      < 1.766609, -0.398784, 2.054795>,
      < 1.710037, -0.363757, 2.095523>
    }
    triangle {
      < 1.767857, -0.461160, 2.054668>,
      < 1.710037, -0.363757, 2.095523>,
      < 1.711799, -0.451847, 2.095342>
    }
    triangle {
      < 1.766609, -0.398784, 2.054795>,
      < 1.765897, -0.361665, 2.005208>,
      < 1.709032, -0.311335, 2.025492>
    }
    triangle {
      < 1.766609, -0.398784, 2.054795>,
      < 1.709032, -0.311335, 2.025492>,
      < 1.710037, -0.363757, 2.095523>
    }
    triangle {
      < 1.447753, -0.276226, 1.816565>,
      < 1.710449, -0.375740, 1.816589>,
      < 1.482669, -0.309913, 1.816542>
    }
    triangle {
      < 1.482669, -0.309913, 1.816542>,
      < 1.710449, -0.375740, 1.816589>,
      < 1.711566, -0.431584, 1.816528>
    }
    triangle {
      < 1.482669, -0.309913, 1.816542>,
      < 1.711566, -0.431584, 1.816528>,
      < 1.480502, -0.344325, 1.816494>
    }
    triangle {
      < 1.480502, -0.344325, 1.816494>,
      < 1.711566, -0.431584, 1.816528>,
      < 1.441257, -0.379639, 1.816431>
    }
    triangle {
      < 1.385345, -0.259265, 1.816537>,
      < 1.710449, -0.375740, 1.816589>,
      < 1.447753, -0.276226, 1.816565>
    }
    triangle {
      < 1.441257, -0.379639, 1.816431>,
      < 1.711566, -0.431584, 1.816528>,
      < 1.309456, -0.400276, 1.816330>
    }
    triangle {
      < -0.118120, -0.403385, 2.094525>,
      < -0.116508, -0.484003, 2.094430>,
      < 1.711799, -0.451847, 2.095342>
    }
    triangle {
      < -0.118120, -0.403385, 2.094525>,
      < 1.711799, -0.451847, 2.095342>,
      < 1.295596, -0.375138, 2.095187>
    }
    triangle {
      < 1.432472, -0.252136, 2.095407>,
      < 1.467049, -0.285581, 2.095315>,
      < 1.710037, -0.363757, 2.095523>
    }
    triangle {
      < 1.432472, -0.252136, 2.095407>,
      < 1.710037, -0.363757, 2.095523>,
      < 1.370689, -0.235500, 2.095472>
    }
    triangle {
      < -0.116617, -0.524275, 2.053002>,
      < 1.713129, -0.487716, 2.084991>,
      < 1.711799, -0.451847, 2.095342>
    }
    triangle {
      < -0.116617, -0.524275, 2.053002>,
      < 1.711799, -0.451847, 2.095342>,
      < -0.116508, -0.484003, 2.094430>
    }
    triangle {
      < 1.370689, -0.235500, 2.095472>,
      < 1.710037, -0.363757, 2.095523>,
      < 1.709032, -0.311335, 2.025492>
    }
    triangle {
      < 1.370689, -0.235500, 2.095472>,
      < 1.709032, -0.311335, 2.025492>,
      < 1.343399, -0.233104, 2.025528>
    }
    triangle {
      < 1.350548, -0.244866, 1.886493>,
      < 1.709231, -0.317032, 1.886786>,
      < 1.710449, -0.375740, 1.816589>
    }
    triangle {
      < 1.350548, -0.244866, 1.886493>,
      < 1.710449, -0.375740, 1.816589>,
      < 1.385345, -0.259265, 1.816537>
    }
    triangle {
      < 1.712368, -0.487466, 1.857929>,
      < -0.121679, -0.524109, 1.825548>,
      < -0.122544, -0.492384, 1.815372>
    }
    triangle {
      < 1.712368, -0.487466, 1.857929>,
      < -0.122544, -0.492384, 1.815372>,
      < 1.711566, -0.431584, 1.816528>
    }
    texture {parts_gearbay}
  }
  // parts_wings
  union {
    triangle {
      < 1.269829, -0.221644, 2.095538>,
      < 1.332758, -0.219613, 2.164931>,
      < 1.370689, -0.235500, 2.095472>
    }
    triangle {
      < 1.269829, -0.221644, 2.095538>,
      < 1.370689, -0.235500, 2.095472>,
      < 1.343399, -0.233104, 2.025528>
    }
    triangle {
      < 1.354251, -0.253910, 1.746400>,
      < 1.284173, -0.245246, 1.816489>,
      < 1.350548, -0.244866, 1.886493>
    }
    triangle {
      < 1.354251, -0.253910, 1.746400>,
      < 1.350548, -0.244866, 1.886493>,
      < 1.385345, -0.259265, 1.816537>
    }
    triangle {
      < -0.118120, -0.403385, 2.094525>,
      < -0.254759, -0.414596, 2.001437>,
      < -0.116508, -0.484003, 2.094430>
    }
    texture {parts_wings}
  }
  // parts_gearbay
  union {
    triangle {
      < -0.116617, -0.524275, 2.053002>,
      < -0.121679, -0.524109, 1.825548>,
      < 1.712368, -0.487466, 1.857929>
    }
    triangle {
      < -0.116617, -0.524275, 2.053002>,
      < 1.712368, -0.487466, 1.857929>,
      < 1.713129, -0.487716, 2.084991>
    }
    triangle {
      < 1.711799, -0.451847, 2.095342>,
      < 1.710037, -0.363757, 2.095523>,
      < 1.467049, -0.285581, 2.095315>
    }
    triangle {
      < 1.711799, -0.451847, 2.095342>,
      < 1.467049, -0.285581, 2.095315>,
      < 1.464915, -0.319778, 2.095240>
    }
    triangle {
      < 1.711799, -0.451847, 2.095342>,
      < 1.464915, -0.319778, 2.095240>,
      < 1.426072, -0.354725, 2.095179>
    }
    triangle {
      < 1.711799, -0.451847, 2.095342>,
      < 1.426072, -0.354725, 2.095179>,
      < 1.295596, -0.375138, 2.095187>
    }
    triangle {
      < 1.709032, -0.311335, 2.025492>,
      < 1.709231, -0.317032, 1.886786>,
      < 1.350548, -0.244866, 1.886493>
    }
    triangle {
      < 1.709032, -0.311335, 2.025492>,
      < 1.350548, -0.244866, 1.886493>,
      < 1.343399, -0.233104, 2.025528>
    }
    triangle {
      < -0.122544, -0.492384, 1.815372>,
      < -0.123813, -0.428941, 1.815447>,
      < 1.309456, -0.400276, 1.816330>
    }
    triangle {
      < -0.122544, -0.492384, 1.815372>,
      < 1.309456, -0.400276, 1.816330>,
      < 1.711566, -0.431584, 1.816528>
    }
    texture {parts_gearbay}
  }
  // parts_slings
  union {
    triangle {
      < 0.062386, -0.068625, 4.814374>,
      < 0.086224, -0.278960, 4.814084>,
      < 0.038641, -0.276198, 4.844552>
    }
    triangle {
      < 0.062386, -0.068625, 4.814374>,
      < 0.038641, -0.276198, 4.844552>,
      < 0.014858, -0.065869, 4.844786>
    }
    triangle {
      < -0.097799, -0.221985, 3.581039>,
      < -0.093420, -0.432696, 3.580854>,
      < -0.140810, -0.429807, 3.612332>
    }
    triangle {
      < -0.097799, -0.221985, 3.581039>,
      < -0.140810, -0.429807, 3.612332>,
      < -0.145133, -0.219089, 3.612580>
    }
    triangle {
      < -0.083375, -0.320226, 2.771829>,
      < -0.077575, -0.530924, 2.771513>,
      < -0.124961, -0.528172, 2.801869>
    }
    triangle {
      < -0.083375, -0.320226, 2.771829>,
      < -0.124961, -0.528172, 2.801869>,
      < -0.130706, -0.317481, 2.802115>
    }
    triangle {
      < -0.203080, -0.457962, 1.204468>,
      < -0.211955, -0.668946, 1.204213>,
      < -0.258878, -0.668485, 1.235345>
    }
    triangle {
      < -0.203080, -0.457962, 1.204468>,
      < -0.258878, -0.668485, 1.235345>,
      < -0.250002, -0.457501, 1.235600>
    }
    triangle {
      < 1.310333, -0.426295, 1.236563>,
      < 1.486884, -0.633570, 1.236422>,
      < 1.426492, -0.636178, 1.205222>
    }
    triangle {
      < 1.310333, -0.426295, 1.236563>,
      < 1.426492, -0.636178, 1.205222>,
      < 1.249941, -0.428902, 1.205363>
    }
    triangle {
      < 1.249800, -0.424707, 1.298859>,
      < 1.426350, -0.631982, 1.298717>,
      < 1.486837, -0.632171, 1.267593>
    }
    triangle {
      < 1.249800, -0.424707, 1.298859>,
      < 1.486837, -0.632171, 1.267593>,
      < 1.310287, -0.424896, 1.267733>
    }
    triangle {
      < 1.224365, -0.288101, 2.821665>,
      < 1.391147, -0.495572, 2.821519>,
      < 1.335469, -0.500540, 2.789827>
    }
    triangle {
      < 1.224365, -0.288101, 2.821665>,
      < 1.335469, -0.500540, 2.789827>,
      < 1.168347, -0.293087, 2.789888>
    }
    triangle {
      < 1.159391, -0.281967, 2.882676>,
      < 1.325465, -0.489441, 2.882614>,
      < 1.387765, -0.491872, 2.852453>
    }
    triangle {
      < 1.159391, -0.281967, 2.882676>,
      < 1.387765, -0.491872, 2.852453>,
      < 1.221331, -0.284395, 2.852600>
    }
    triangle {
      < 1.084380, -0.188866, 3.659585>,
      < 1.241717, -0.396535, 3.659354>,
      < 1.302994, -0.399165, 3.627726>
    }
    triangle {
      < 1.084380, -0.188866, 3.659585>,
      < 1.302994, -0.399165, 3.627726>,
      < 1.145314, -0.191512, 3.627879>
    }
    triangle {
      < 1.148354, -0.195228, 3.596868>,
      < 1.306386, -0.402873, 3.596714>,
      < 1.251750, -0.407660, 3.566338>
    }
    triangle {
      < 1.148354, -0.195228, 3.596868>,
      < 1.251750, -0.407660, 3.566338>,
      < 1.093364, -0.200013, 3.566569>
    }
    triangle {
      < 1.024837, -0.044305, 4.856603>,
      < 1.168646, -0.252235, 4.856441>,
      < 1.115916, -0.257124, 4.824918>
    }
    triangle {
      < 1.024837, -0.044305, 4.856603>,
      < 1.115916, -0.257124, 4.824918>,
      < 0.971763, -0.049209, 4.825014>
    }
    triangle {
      < 0.962791, -0.038087, 4.917821>,
      < 1.105896, -0.246024, 4.917726>,
      < 1.165262, -0.248535, 4.887382>
    }
    triangle {
      < 0.962791, -0.038087, 4.917821>,
      < 1.165262, -0.248535, 4.887382>,
      < 1.021802, -0.040599, 4.887544>
    }
    triangle {
      < -0.250050, -0.456103, 1.266772>,
      < -0.258925, -0.667085, 1.266518>,
      < -0.212096, -0.664749, 1.297708>
    }
    triangle {
      < -0.250050, -0.456103, 1.266772>,
      < -0.212096, -0.664749, 1.297708>,
      < -0.203222, -0.453767, 1.297963>
    }
    triangle {
      < -0.131256, -0.313721, 2.833086>,
      < -0.125565, -0.524413, 2.832840>,
      < -0.079390, -0.519650, 2.864407>
    }
    triangle {
      < -0.131256, -0.313721, 2.833086>,
      < -0.079390, -0.519650, 2.864407>,
      < -0.085029, -0.308949, 2.864722>
    }
    triangle {
      < -0.145685, -0.215327, 3.643562>,
      < -0.141417, -0.426048, 3.643314>,
      < -0.095238, -0.421418, 3.673782>
    }
    triangle {
      < -0.145685, -0.215327, 3.643562>,
      < -0.095238, -0.421418, 3.673782>,
      < -0.099453, -0.210703, 3.673967>
    }
    triangle {
      < 0.014307, -0.062108, 4.875757>,
      < 0.038036, -0.272440, 4.875522>,
      < 0.084407, -0.267686, 4.906978>
    }
    triangle {
      < 0.014307, -0.062108, 4.875757>,
      < 0.084407, -0.267686, 4.906978>,
      < 0.060731, -0.057347, 4.907268>
    }
    texture {parts_slings}
  }
  // parts_wings
  union {
    triangle {
      < 0.016235, -0.075266, 4.767378>,
      < 0.062386, -0.068625, 4.814374>,
      < 0.014858, -0.065869, 4.844786>
    }
    triangle {
      < -0.143755, -0.228487, 3.535160>,
      < -0.097799, -0.221985, 3.581039>,
      < -0.145133, -0.219089, 3.612580>
    }
    triangle {
      < -0.129329, -0.326878, 2.724708>,
      < -0.083375, -0.320226, 2.771829>,
      < -0.130706, -0.317481, 2.802115>
    }
    triangle {
      < -0.265572, -0.458512, 1.220010>,
      < -0.203080, -0.457962, 1.204468>,
      < -0.250002, -0.457501, 1.235600>
    }
    triangle {
      < 1.310451, -0.429792, 1.158653>,
      < 1.310333, -0.426295, 1.236563>,
      < 1.249941, -0.428902, 1.205363>
    }
    triangle {
      < 1.310169, -0.421400, 1.345644>,
      < 1.249800, -0.424707, 1.298859>,
      < 1.310287, -0.424896, 1.267733>
    }
    triangle {
      < 1.231930, -0.297347, 2.744495>,
      < 1.224365, -0.288101, 2.821665>,
      < 1.168347, -0.293087, 2.789888>
    }
    triangle {
      < 1.213764, -0.275150, 2.929769>,
      < 1.159391, -0.281967, 2.882676>,
      < 1.221331, -0.284395, 2.852600>
    }
    triangle {
      < 1.137739, -0.182258, 3.705126>,
      < 1.084380, -0.188866, 3.659585>,
      < 1.145314, -0.191512, 3.627879>
    }
    triangle {
      < 1.155929, -0.204483, 3.519621>,
      < 1.148354, -0.195228, 3.596868>,
      < 1.093364, -0.200013, 3.566569>
    }
    triangle {
      < 1.032404, -0.053552, 4.779426>,
      < 1.024837, -0.044305, 4.856603>,
      < 0.971763, -0.049209, 4.825014>
    }
    triangle {
      < 1.014235, -0.031352, 4.964720>,
      < 0.962791, -0.038087, 4.917821>,
      < 1.021802, -0.040599, 4.887544>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < -0.250050, -0.456103, 1.266772>,
      < -0.203222, -0.453767, 1.297963>
    }
    triangle {
      < -0.132634, -0.304324, 2.910494>,
      < -0.131256, -0.313721, 2.833086>,
      < -0.085029, -0.308949, 2.864722>
    }
    triangle {
      < -0.147063, -0.205927, 3.720980>,
      < -0.145685, -0.215327, 3.643562>,
      < -0.099453, -0.210703, 3.673967>
    }
    triangle {
      < 0.012930, -0.052711, 4.953165>,
      < 0.014307, -0.062108, 4.875757>,
      < 0.060731, -0.057347, 4.907268>
    }
    texture {parts_wings}
  }
  // parts_slings
  union {
    triangle {
      < -0.212096, -0.664749, 1.297708>,
      < 1.426350, -0.631982, 1.298717>,
      < 1.249800, -0.424707, 1.298859>
    }
    triangle {
      < -0.212096, -0.664749, 1.297708>,
      < 1.249800, -0.424707, 1.298859>,
      < -0.203222, -0.453767, 1.297963>
    }
    triangle {
      < 1.486837, -0.632171, 1.267593>,
      < 1.486884, -0.633570, 1.236422>,
      < 1.310333, -0.426295, 1.236563>
    }
    triangle {
      < 1.486837, -0.632171, 1.267593>,
      < 1.310333, -0.426295, 1.236563>,
      < 1.310287, -0.424896, 1.267733>
    }
    triangle {
      < 1.426492, -0.636178, 1.205222>,
      < -0.211955, -0.668946, 1.204213>,
      < -0.203080, -0.457962, 1.204468>
    }
    triangle {
      < 1.426492, -0.636178, 1.205222>,
      < -0.203080, -0.457962, 1.204468>,
      < 1.249941, -0.428902, 1.205363>
    }
    triangle {
      < -0.258878, -0.668485, 1.235345>,
      < -0.258925, -0.667085, 1.266518>,
      < -0.250050, -0.456103, 1.266772>
    }
    triangle {
      < -0.258878, -0.668485, 1.235345>,
      < -0.250050, -0.456103, 1.266772>,
      < -0.250002, -0.457501, 1.235600>
    }
    triangle {
      < -0.079390, -0.519650, 2.864407>,
      < 1.325465, -0.489441, 2.882614>,
      < 1.159391, -0.281967, 2.882676>
    }
    triangle {
      < -0.079390, -0.519650, 2.864407>,
      < 1.159391, -0.281967, 2.882676>,
      < -0.085029, -0.308949, 2.864722>
    }
    triangle {
      < 1.387765, -0.491872, 2.852453>,
      < 1.391147, -0.495572, 2.821519>,
      < 1.224365, -0.288101, 2.821665>
    }
    triangle {
      < 1.387765, -0.491872, 2.852453>,
      < 1.224365, -0.288101, 2.821665>,
      < 1.221331, -0.284395, 2.852600>
    }
    triangle {
      < 1.335469, -0.500540, 2.789827>,
      < -0.077575, -0.530924, 2.771513>,
      < -0.083375, -0.320226, 2.771829>
    }
    triangle {
      < 1.335469, -0.500540, 2.789827>,
      < -0.083375, -0.320226, 2.771829>,
      < 1.168347, -0.293087, 2.789888>
    }
    triangle {
      < -0.124961, -0.528172, 2.801869>,
      < -0.125565, -0.524413, 2.832840>,
      < -0.131256, -0.313721, 2.833086>
    }
    triangle {
      < -0.124961, -0.528172, 2.801869>,
      < -0.131256, -0.313721, 2.833086>,
      < -0.130706, -0.317481, 2.802115>
    }
    triangle {
      < -0.095238, -0.421418, 3.673782>,
      < 1.241717, -0.396535, 3.659354>,
      < 1.084380, -0.188866, 3.659585>
    }
    triangle {
      < -0.095238, -0.421418, 3.673782>,
      < 1.084380, -0.188866, 3.659585>,
      < -0.099453, -0.210703, 3.673967>
    }
    triangle {
      < 1.302994, -0.399165, 3.627726>,
      < 1.306386, -0.402873, 3.596714>,
      < 1.148354, -0.195228, 3.596868>
    }
    triangle {
      < 1.302994, -0.399165, 3.627726>,
      < 1.148354, -0.195228, 3.596868>,
      < 1.145314, -0.191512, 3.627879>
    }
    triangle {
      < 1.251750, -0.407660, 3.566338>,
      < -0.093420, -0.432696, 3.580854>,
      < -0.097799, -0.221985, 3.581039>
    }
    triangle {
      < 1.251750, -0.407660, 3.566338>,
      < -0.097799, -0.221985, 3.581039>,
      < 1.093364, -0.200013, 3.566569>
    }
    triangle {
      < -0.140810, -0.429807, 3.612332>,
      < -0.141417, -0.426048, 3.643314>,
      < -0.145685, -0.215327, 3.643562>
    }
    triangle {
      < -0.140810, -0.429807, 3.612332>,
      < -0.145685, -0.215327, 3.643562>,
      < -0.145133, -0.219089, 3.612580>
    }
    triangle {
      < 0.084407, -0.267686, 4.906978>,
      < 1.105896, -0.246024, 4.917726>,
      < 0.962791, -0.038087, 4.917821>
    }
    triangle {
      < 0.084407, -0.267686, 4.906978>,
      < 0.962791, -0.038087, 4.917821>,
      < 0.060731, -0.057347, 4.907268>
    }
    triangle {
      < 1.165262, -0.248535, 4.887382>,
      < 1.168646, -0.252235, 4.856441>,
      < 1.024837, -0.044305, 4.856603>
    }
    triangle {
      < 1.165262, -0.248535, 4.887382>,
      < 1.024837, -0.044305, 4.856603>,
      < 1.021802, -0.040599, 4.887544>
    }
    triangle {
      < 1.115916, -0.257124, 4.824918>,
      < 0.086224, -0.278960, 4.814084>,
      < 0.062386, -0.068625, 4.814374>
    }
    triangle {
      < 1.115916, -0.257124, 4.824918>,
      < 0.062386, -0.068625, 4.814374>,
      < 0.971763, -0.049209, 4.825014>
    }
    triangle {
      < 0.038641, -0.276198, 4.844552>,
      < 0.038036, -0.272440, 4.875522>,
      < 0.014307, -0.062108, 4.875757>
    }
    triangle {
      < 0.038641, -0.276198, 4.844552>,
      < 0.014307, -0.062108, 4.875757>,
      < 0.014858, -0.065869, 4.844786>
    }
    triangle {
      < 1.426350, -0.631982, 1.298717>,
      < -0.212096, -0.664749, 1.297708>,
      < -0.258925, -0.667085, 1.266518>
    }
    triangle {
      < 1.426350, -0.631982, 1.298717>,
      < -0.258925, -0.667085, 1.266518>,
      < -0.258878, -0.668485, 1.235345>
    }
    triangle {
      < 1.426350, -0.631982, 1.298717>,
      < -0.258878, -0.668485, 1.235345>,
      < -0.211955, -0.668946, 1.204213>
    }
    triangle {
      < 1.426350, -0.631982, 1.298717>,
      < -0.211955, -0.668946, 1.204213>,
      < 1.426492, -0.636178, 1.205222>
    }
    triangle {
      < 1.426350, -0.631982, 1.298717>,
      < 1.426492, -0.636178, 1.205222>,
      < 1.486884, -0.633570, 1.236422>
    }
    triangle {
      < 1.426350, -0.631982, 1.298717>,
      < 1.486884, -0.633570, 1.236422>,
      < 1.486837, -0.632171, 1.267593>
    }
    triangle {
      < 1.325465, -0.489441, 2.882614>,
      < -0.079390, -0.519650, 2.864407>,
      < -0.125565, -0.524413, 2.832840>
    }
    triangle {
      < 1.325465, -0.489441, 2.882614>,
      < -0.125565, -0.524413, 2.832840>,
      < -0.124961, -0.528172, 2.801869>
    }
    triangle {
      < 1.325465, -0.489441, 2.882614>,
      < -0.124961, -0.528172, 2.801869>,
      < -0.077575, -0.530924, 2.771513>
    }
    triangle {
      < 1.325465, -0.489441, 2.882614>,
      < -0.077575, -0.530924, 2.771513>,
      < 1.335469, -0.500540, 2.789827>
    }
    triangle {
      < 1.325465, -0.489441, 2.882614>,
      < 1.335469, -0.500540, 2.789827>,
      < 1.391147, -0.495572, 2.821519>
    }
    triangle {
      < 1.325465, -0.489441, 2.882614>,
      < 1.391147, -0.495572, 2.821519>,
      < 1.387765, -0.491872, 2.852453>
    }
    triangle {
      < 1.241717, -0.396535, 3.659354>,
      < -0.095238, -0.421418, 3.673782>,
      < -0.141417, -0.426048, 3.643314>
    }
    triangle {
      < 1.241717, -0.396535, 3.659354>,
      < -0.141417, -0.426048, 3.643314>,
      < -0.140810, -0.429807, 3.612332>
    }
    triangle {
      < 1.241717, -0.396535, 3.659354>,
      < -0.140810, -0.429807, 3.612332>,
      < -0.093420, -0.432696, 3.580854>
    }
    triangle {
      < 1.241717, -0.396535, 3.659354>,
      < -0.093420, -0.432696, 3.580854>,
      < 1.251750, -0.407660, 3.566338>
    }
    triangle {
      < 1.241717, -0.396535, 3.659354>,
      < 1.251750, -0.407660, 3.566338>,
      < 1.306386, -0.402873, 3.596714>
    }
    triangle {
      < 1.241717, -0.396535, 3.659354>,
      < 1.306386, -0.402873, 3.596714>,
      < 1.302994, -0.399165, 3.627726>
    }
    triangle {
      < 1.105896, -0.246024, 4.917726>,
      < 0.084407, -0.267686, 4.906978>,
      < 0.038036, -0.272440, 4.875522>
    }
    triangle {
      < 1.105896, -0.246024, 4.917726>,
      < 0.038036, -0.272440, 4.875522>,
      < 0.038641, -0.276198, 4.844552>
    }
    triangle {
      < 1.105896, -0.246024, 4.917726>,
      < 0.038641, -0.276198, 4.844552>,
      < 0.086224, -0.278960, 4.814084>
    }
    triangle {
      < 1.105896, -0.246024, 4.917726>,
      < 0.086224, -0.278960, 4.814084>,
      < 1.115916, -0.257124, 4.824918>
    }
    triangle {
      < 1.105896, -0.246024, 4.917726>,
      < 1.115916, -0.257124, 4.824918>,
      < 1.168646, -0.252235, 4.856441>
    }
    triangle {
      < 1.105896, -0.246024, 4.917726>,
      < 1.168646, -0.252235, 4.856441>,
      < 1.165262, -0.248535, 4.887382>
    }
    texture {parts_slings}
  }
  // parts_wings
  union {
    triangle {
      < -0.265572, -0.458512, 1.220010>,
      < -0.250002, -0.457501, 1.235600>,
      < -0.250050, -0.456103, 1.266772>
    }
    triangle {
      < -0.265572, -0.458512, 1.220010>,
      < -0.250050, -0.456103, 1.266772>,
      < -0.265667, -0.455715, 1.282343>
    }
    triangle {
      < -0.265572, -0.458512, 1.220010>,
      < -0.265667, -0.455715, 1.282343>,
      < -0.296812, -0.457737, 1.251158>
    }
    triangle {
      < 1.137739, -0.182258, 3.705126>,
      < 1.070821, -0.100492, 4.387614>,
      < 0.022471, -0.117855, 4.416588>
    }
    triangle {
      < 1.137739, -0.182258, 3.705126>,
      < 0.022471, -0.117855, 4.416588>,
      < -0.156820, -0.139384, 4.269105>
    }
    triangle {
      < 1.137739, -0.182258, 3.705126>,
      < -0.156820, -0.139384, 4.269105>,
      < -0.147063, -0.205927, 3.720980>
    }
    triangle {
      < 1.137739, -0.182258, 3.705126>,
      < -0.147063, -0.205927, 3.720980>,
      < -0.099453, -0.210703, 3.673967>
    }
    triangle {
      < 1.137739, -0.182258, 3.705126>,
      < -0.099453, -0.210703, 3.673967>,
      < 1.084380, -0.188866, 3.659585>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < -0.203222, -0.453767, 1.297963>,
      < 1.249800, -0.424707, 1.298859>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < 1.249800, -0.424707, 1.298859>,
      < 1.310169, -0.421400, 1.345644>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < 1.310169, -0.421400, 1.345644>,
      < 1.309456, -0.400276, 1.816330>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < 1.309456, -0.400276, 1.816330>,
      < -0.123813, -0.428941, 1.815447>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < -0.123813, -0.428941, 1.815447>,
      < -0.889014, -0.444245, 1.814975>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < -0.889014, -0.444245, 1.814975>,
      < -0.888160, -0.469564, 1.250793>
    }
    triangle {
      < -0.265667, -0.455715, 1.282343>,
      < -0.888160, -0.469564, 1.250793>,
      < -0.296812, -0.457737, 1.251158>
    }
    triangle {
      < -0.085029, -0.308949, 2.864722>,
      < 1.159391, -0.281967, 2.882676>,
      < 1.213764, -0.275150, 2.929769>
    }
    triangle {
      < -0.085029, -0.308949, 2.864722>,
      < 1.213764, -0.275150, 2.929769>,
      < 1.155929, -0.204483, 3.519621>
    }
    triangle {
      < -0.085029, -0.308949, 2.864722>,
      < 1.155929, -0.204483, 3.519621>,
      < 1.093364, -0.200013, 3.566569>
    }
    triangle {
      < -0.085029, -0.308949, 2.864722>,
      < 1.093364, -0.200013, 3.566569>,
      < -0.097799, -0.221985, 3.581039>
    }
    triangle {
      < -0.085029, -0.308949, 2.864722>,
      < -0.097799, -0.221985, 3.581039>,
      < -0.143755, -0.228487, 3.535160>
    }
    triangle {
      < -0.085029, -0.308949, 2.864722>,
      < -0.143755, -0.228487, 3.535160>,
      < -0.132634, -0.304324, 2.910494>
    }
    triangle {
      < -0.129329, -0.326878, 2.724708>,
      < -0.118120, -0.403385, 2.094525>,
      < 1.295596, -0.375138, 2.095187>
    }
    triangle {
      < -0.129329, -0.326878, 2.724708>,
      < 1.295596, -0.375138, 2.095187>,
      < 1.231930, -0.297347, 2.744495>
    }
    triangle {
      < -0.129329, -0.326878, 2.724708>,
      < 1.231930, -0.297347, 2.744495>,
      < 1.168347, -0.293087, 2.789888>
    }
    triangle {
      < -0.129329, -0.326878, 2.724708>,
      < 1.168347, -0.293087, 2.789888>,
      < -0.083375, -0.320226, 2.771829>
    }
    triangle {
      < 1.014235, -0.031352, 4.964720>,
      < 0.870913, 0.143768, 6.426429>,
      < -0.013276, 0.126090, 6.425924>
    }
    triangle {
      < 1.014235, -0.031352, 4.964720>,
      < -0.013276, 0.126090, 6.425924>,
      < 0.012930, -0.052711, 4.953165>
    }
    triangle {
      < 1.014235, -0.031352, 4.964720>,
      < 0.012930, -0.052711, 4.953165>,
      < 0.060731, -0.057347, 4.907268>
    }
    triangle {
      < 1.014235, -0.031352, 4.964720>,
      < 0.060731, -0.057347, 4.907268>,
      < 0.962791, -0.038087, 4.917821>
    }
    texture {parts_wings}
  }
  // parts_flaps2
  union {
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.118120, -0.403385, 2.094525>,
      < -0.129329, -0.326878, 2.724708>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.129329, -0.326878, 2.724708>,
      < -0.130706, -0.317481, 2.802115>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.130706, -0.317481, 2.802115>,
      < -0.131256, -0.313721, 2.833086>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.131256, -0.313721, 2.833086>,
      < -0.132634, -0.304324, 2.910494>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.132634, -0.304324, 2.910494>,
      < -0.143755, -0.228487, 3.535160>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.143755, -0.228487, 3.535160>,
      < -0.145133, -0.219089, 3.612580>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.145133, -0.219089, 3.612580>,
      < -0.145685, -0.215327, 3.643562>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.145685, -0.215327, 3.643562>,
      < -0.147063, -0.205927, 3.720980>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.147063, -0.205927, 3.720980>,
      < -0.156820, -0.139384, 4.269105>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.156820, -0.139384, 4.269105>,
      < -0.745220, -0.152080, 4.261100>
    }
    texture {parts_flaps2}
  }
  // parts_wings
  union {
    triangle {
      < -0.745220, -0.152080, 4.261100>,
      < -0.156820, -0.139384, 4.269105>,
      < 0.022471, -0.117855, 4.416588>
    }
    triangle {
      < -0.745220, -0.152080, 4.261100>,
      < 0.022471, -0.117855, 4.416588>,
      < -0.736098, -0.133140, 4.407556>
    }
    texture {parts_wings}
  }
  // parts_flaps2
  union {
    triangle {
      < 0.016235, -0.075266, 4.767378>,
      < 0.014858, -0.065869, 4.844786>,
      < 0.014307, -0.062108, 4.875757>
    }
    triangle {
      < 0.016235, -0.075266, 4.767378>,
      < 0.014307, -0.062108, 4.875757>,
      < 0.012930, -0.052711, 4.953165>
    }
    triangle {
      < 0.016235, -0.075266, 4.767378>,
      < 0.012930, -0.052711, 4.953165>,
      < -0.013276, 0.126090, 6.425924>
    }
    triangle {
      < 0.016235, -0.075266, 4.767378>,
      < -0.013276, 0.126090, 6.425924>,
      < -0.610013, 0.114151, 6.425516>
    }
    triangle {
      < 0.016235, -0.075266, 4.767378>,
      < -0.610013, 0.114151, 6.425516>,
      < -0.736098, -0.133140, 4.407556>
    }
    triangle {
      < 0.016235, -0.075266, 4.767378>,
      < -0.736098, -0.133140, 4.407556>,
      < 0.022471, -0.117855, 4.416588>
    }
    texture {parts_flaps2}
  }
  // parts_fuselage
  union {
    triangle {
      < -3.290702, 0.590519, 0.730708>,
      < -1.269130, 0.672541, 0.732004>,
      < -1.267235, 0.587587, 0.408083>
    }
    triangle {
      < -3.290702, 0.590519, 0.730708>,
      < -1.267235, 0.587587, 0.408083>,
      < -3.464144, 0.498452, 0.406676>
    }
    triangle {
      < -1.269130, 0.672541, 0.732004>,
      < -1.206828, 0.657004, 0.732022>,
      < -1.199591, 0.572268, 0.408105>
    }
    triangle {
      < -1.269130, 0.672541, 0.732004>,
      < -1.199591, 0.572268, 0.408105>,
      < -1.267235, 0.587587, 0.408083>
    }
    triangle {
      < -1.206828, 0.657004, 0.732022>,
      < -1.268120, 0.625750, 0.731948>,
      < -1.266300, 0.540795, 0.408029>
    }
    triangle {
      < -1.206828, 0.657004, 0.732022>,
      < -1.266300, 0.540795, 0.408029>,
      < -1.199591, 0.572268, 0.408105>
    }
    triangle {
      < -1.268120, 0.625750, 0.731948>,
      < -3.289891, 0.553292, 0.730664>,
      < -3.463400, 0.461222, 0.406632>
    }
    triangle {
      < -1.268120, 0.625750, 0.731948>,
      < -3.463400, 0.461222, 0.406632>,
      < -1.266300, 0.540795, 0.408029>
    }
    triangle {
      < -3.289891, 0.553292, 0.730664>,
      < -3.560323, 0.565828, 0.730519>,
      < -3.757200, 0.472811, 0.406471>
    }
    triangle {
      < -3.289891, 0.553292, 0.730664>,
      < -3.757200, 0.472811, 0.406471>,
      < -3.463400, 0.461222, 0.406632>
    }
    triangle {
      < -3.560323, 0.565828, 0.730519>,
      < -3.290702, 0.590519, 0.730708>,
      < -3.464144, 0.498452, 0.406676>
    }
    triangle {
      < -3.560323, 0.565828, 0.730519>,
      < -3.464144, 0.498452, 0.406676>,
      < -3.757200, 0.472811, 0.406471>
    }
    triangle {
      < -1.266300, 0.540795, 0.408029>,
      < -3.463400, 0.461222, 0.406632>,
      < -3.439404, 0.296543, 0.284639>
    }
    triangle {
      < -1.266300, 0.540795, 0.408029>,
      < -3.439404, 0.296543, 0.284639>,
      < -1.243800, 0.448991, 0.346918>
    }
    triangle {
      < -3.463400, 0.461222, 0.406632>,
      < -3.757200, 0.472811, 0.406471>,
      < -4.051579, 0.318451, 0.208261>
    }
    triangle {
      < -3.463400, 0.461222, 0.406632>,
      < -4.051579, 0.318451, 0.208261>,
      < -3.439404, 0.296543, 0.284639>
    }
    triangle {
      < -3.757200, 0.472811, 0.406471>,
      < -3.464144, 0.498452, 0.406676>,
      < -3.441592, 0.410183, 0.148181>
    }
    triangle {
      < -3.757200, 0.472811, 0.406471>,
      < -3.441592, 0.410183, 0.148181>,
      < -4.051579, 0.318451, 0.208261>
    }
    triangle {
      < -3.464144, 0.498452, 0.406676>,
      < -1.267235, 0.587587, 0.408083>,
      < -1.246555, 0.591830, 0.181695>
    }
    triangle {
      < -3.464144, 0.498452, 0.406676>,
      < -1.246555, 0.591830, 0.181695>,
      < -3.441592, 0.410183, 0.148181>
    }
    triangle {
      < -1.267235, 0.587587, 0.408083>,
      < -1.199591, 0.572268, 0.408105>,
      < -1.178287, 0.542251, 0.283445>
    }
    triangle {
      < -1.267235, 0.587587, 0.408083>,
      < -1.178287, 0.542251, 0.283445>,
      < -1.246555, 0.591830, 0.181695>
    }
    triangle {
      < -1.199591, 0.572268, 0.408105>,
      < -1.266300, 0.540795, 0.408029>,
      < -1.243800, 0.448991, 0.346918>
    }
    triangle {
      < -1.199591, 0.572268, 0.408105>,
      < -1.243800, 0.448991, 0.346918>,
      < -1.178287, 0.542251, 0.283445>
    }
    texture {parts_fuselage}
  }
  // parts_rudder
  union {
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.636479, 1.852214, 3.363346>,
      < -5.342458, 1.885169, 3.363558>
    }
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.342458, 1.885169, 3.363558>,
      < -5.342435, 1.885214, 3.325520>
    }
    triangle {
      < -5.151313, -0.234583, 3.362255>,
      < -5.342458, 1.885169, 3.363558>,
      < -5.636479, 1.852214, 3.363346>
    }
    triangle {
      < -5.151313, -0.234583, 3.362255>,
      < -5.636479, 1.852214, 3.363346>,
      < -5.678514, -0.149790, 3.362043>
    }
    triangle {
      < -5.151313, -0.234583, 3.362255>,
      < -5.678514, -0.149790, 3.362043>,
      < -5.677454, -0.175205, 3.362015>
    }
    triangle {
      < -5.151313, -0.234583, 3.362255>,
      < -5.677454, -0.175205, 3.362015>,
      < -5.674265, -0.334640, 3.361827>
    }
    triangle {
      < -5.151313, -0.234583, 3.362255>,
      < -5.674265, -0.334640, 3.361827>,
      < -5.146761, -0.434633, 3.362021>
    }
    triangle {
      < -5.151313, -0.234583, 3.362255>,
      < -5.146761, -0.434633, 3.362021>,
      < -5.150213, -0.262087, 3.362223>
    }
    triangle {
      < -5.674265, -0.334640, 3.361827>,
      < -5.674242, -0.334595, 3.323788>,
      < -5.146739, -0.434587, 3.323982>
    }
    triangle {
      < -5.674265, -0.334640, 3.361827>,
      < -5.146739, -0.434587, 3.323982>,
      < -5.146761, -0.434633, 3.362021>
    }
    triangle {
      < -5.674242, -0.334595, 3.323788>,
      < -5.677432, -0.175159, 3.323975>,
      < -5.150190, -0.262043, 3.324185>
    }
    triangle {
      < -5.674242, -0.334595, 3.323788>,
      < -5.150190, -0.262043, 3.324185>,
      < -5.146739, -0.434587, 3.323982>
    }
    triangle {
      < -5.677432, -0.175159, 3.323975>,
      < -5.678491, -0.149746, 3.324004>,
      < -5.151290, -0.234538, 3.324217>
    }
    triangle {
      < -5.677432, -0.175159, 3.323975>,
      < -5.151290, -0.234538, 3.324217>,
      < -5.150190, -0.262043, 3.324185>
    }
    triangle {
      < -5.678491, -0.149746, 3.324004>,
      < -5.636456, 1.852258, 3.325306>,
      < -5.342435, 1.885214, 3.325520>
    }
    triangle {
      < -5.678491, -0.149746, 3.324004>,
      < -5.342435, 1.885214, 3.325520>,
      < -5.151290, -0.234538, 3.324217>
    }
    triangle {
      < -4.747062, 1.784485, 3.364762>,
      < -4.742294, 1.792143, 3.322876>,
      < -4.890609, 1.886749, 3.314371>
    }
    triangle {
      < -4.747062, 1.784485, 3.364762>,
      < -4.890609, 1.886749, 3.314371>,
      < -4.922556, 1.893564, 3.365983>
    }
    triangle {
      < -4.344381, -0.544983, 3.365254>,
      < -4.225465, -0.443754, 3.365445>,
      < -4.227883, -0.322861, 3.365587>
    }
    triangle {
      < -4.344381, -0.544983, 3.365254>,
      < -4.227883, -0.322861, 3.365587>,
      < -4.348787, -0.325302, 3.385346>
    }
    texture {parts_rudder}
  }
  // parts_stabilizers
  union {
    triangle {
      < -4.347182, -0.311695, 0.339693>,
      < -4.367367, -0.286440, 0.339711>,
      < -4.369123, -0.289950, 3.301893>
    }
    triangle {
      < -4.347182, -0.311695, 0.339693>,
      < -4.369123, -0.289950, 3.301893>,
      < -4.348938, -0.315207, 3.301875>
    }
    texture {parts_stabilizers}
  }
  // parts_rudder
  union {
    triangle {
      < -4.225465, -0.443754, 3.365445>,
      < -4.225439, -0.443703, 3.321628>,
      < -4.227857, -0.322809, 3.321770>
    }
    triangle {
      < -4.225465, -0.443754, 3.365445>,
      < -4.227857, -0.322809, 3.321770>,
      < -4.227883, -0.322861, 3.365587>
    }
    triangle {
      < -4.225439, -0.443703, 3.321628>,
      < -4.225465, -0.443754, 3.365445>,
      < -4.344381, -0.544983, 3.365254>
    }
    triangle {
      < -4.225439, -0.443703, 3.321628>,
      < -4.344381, -0.544983, 3.365254>,
      < -4.344356, -0.544931, 3.321438>
    }
    triangle {
      < -4.227857, -0.322809, 3.321770>,
      < -4.225439, -0.443703, 3.321628>,
      < -4.344356, -0.544931, 3.321438>
    }
    triangle {
      < -4.227857, -0.322809, 3.321770>,
      < -4.344356, -0.544931, 3.321438>,
      < -4.348738, -0.325203, 3.301864>
    }
    triangle {
      < -5.146761, -0.434633, 3.362021>,
      < -5.146739, -0.434587, 3.323982>,
      < -4.503779, -0.574938, 3.301476>
    }
    triangle {
      < -5.146761, -0.434633, 3.362021>,
      < -4.503779, -0.574938, 3.301476>,
      < -4.503829, -0.575037, 3.384957>
    }
    triangle {
      < -5.146761, -0.434633, 3.362021>,
      < -4.503829, -0.575037, 3.384957>,
      < -4.344381, -0.544983, 3.365254>
    }
    triangle {
      < -5.146761, -0.434633, 3.362021>,
      < -4.344381, -0.544983, 3.365254>,
      < -4.348787, -0.325302, 3.385346>
    }
    triangle {
      < -5.146761, -0.434633, 3.362021>,
      < -4.348787, -0.325302, 3.385346>,
      < -5.150213, -0.262087, 3.362223>
    }
    triangle {
      < -4.344356, -0.544931, 3.321438>,
      < -4.503779, -0.574938, 3.301476>,
      < -5.146739, -0.434587, 3.323982>
    }
    triangle {
      < -4.344356, -0.544931, 3.321438>,
      < -5.146739, -0.434587, 3.323982>,
      < -5.150190, -0.262043, 3.324185>
    }
    triangle {
      < -4.344356, -0.544931, 3.321438>,
      < -5.150190, -0.262043, 3.324185>,
      < -4.348738, -0.325203, 3.301864>
    }
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -4.227883, -0.322861, 3.365587>,
      < -4.228083, -0.312864, 3.365599>
    }
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -4.228083, -0.312864, 3.365599>,
      < -4.747062, 1.784485, 3.364762>
    }
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -4.747062, 1.784485, 3.364762>,
      < -4.922556, 1.893564, 3.365983>
    }
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -4.922556, 1.893564, 3.365983>,
      < -5.342458, 1.885169, 3.363558>
    }
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -5.342458, 1.885169, 3.363558>,
      < -5.151313, -0.234583, 3.362255>
    }
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -5.151313, -0.234583, 3.362255>,
      < -4.348987, -0.315305, 3.385357>
    }
    triangle {
      < -5.733164, -0.263344, 3.301116>,
      < -5.750564, -0.264400, 3.301105>,
      < -5.150190, -0.262043, 3.324185>
    }
    triangle {
      < -5.733164, -0.263344, 3.301116>,
      < -5.150190, -0.262043, 3.324185>,
      < -5.151290, -0.234538, 3.324217>
    }
    texture {parts_rudder}
  }
  // parts_stabilizers
  union {
    triangle {
      < -5.750564, -0.264400, 3.301105>,
      < -5.748742, -0.260756, 0.226615>,
      < -5.166318, -0.258730, 0.226963>
    }
    triangle {
      < -5.750564, -0.264400, 3.301105>,
      < -5.166318, -0.258730, 0.226963>,
      < -5.150190, -0.262043, 3.324185>
    }
    texture {parts_stabilizers}
  }
  // parts_fuselage
  union {
    triangle {
      < -5.748742, -0.260756, 0.226615>,
      < -5.731342, -0.259700, 0.226627>,
      < -5.149455, -0.230867, 0.227005>
    }
    triangle {
      < -5.748742, -0.260756, 0.226615>,
      < -5.149455, -0.230867, 0.227005>,
      < -5.166318, -0.258730, 0.226963>
    }
    texture {parts_fuselage}
  }
  // parts_stabilizers
  union {
    triangle {
      < -5.731342, -0.259700, 0.226627>,
      < -5.733164, -0.263344, 3.301116>,
      < -5.151290, -0.234538, 3.324217>
    }
    triangle {
      < -5.731342, -0.259700, 0.226627>,
      < -5.151290, -0.234538, 3.324217>,
      < -5.149455, -0.230867, 0.227005>
    }
    texture {parts_stabilizers}
  }
  // parts_rudder
  union {
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.678491, -0.149746, 3.324004>,
      < -5.677432, -0.175159, 3.323975>
    }
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.677432, -0.175159, 3.323975>,
      < -5.674242, -0.334595, 3.323788>
    }
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.674242, -0.334595, 3.323788>,
      < -5.674265, -0.334640, 3.361827>
    }
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.674265, -0.334640, 3.361827>,
      < -5.677454, -0.175205, 3.362015>
    }
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.677454, -0.175205, 3.362015>,
      < -5.678514, -0.149790, 3.362043>
    }
    triangle {
      < -5.636456, 1.852258, 3.325306>,
      < -5.678514, -0.149790, 3.362043>,
      < -5.636479, 1.852214, 3.363346>
    }
    triangle {
      < -5.342435, 1.885214, 3.325520>,
      < -5.342458, 1.885169, 3.363558>,
      < -4.922556, 1.893564, 3.365983>
    }
    triangle {
      < -5.342435, 1.885214, 3.325520>,
      < -4.922556, 1.893564, 3.365983>,
      < -4.890609, 1.886749, 3.314371>
    }
    triangle {
      < -4.228057, -0.312812, 3.321782>,
      < -4.742294, 1.792143, 3.322876>,
      < -4.747062, 1.784485, 3.364762>
    }
    triangle {
      < -4.228057, -0.312812, 3.321782>,
      < -4.747062, 1.784485, 3.364762>,
      < -4.228083, -0.312864, 3.365599>
    }
    triangle {
      < -4.228057, -0.312812, 3.321782>,
      < -4.228083, -0.312864, 3.365599>,
      < -4.227883, -0.322861, 3.365587>
    }
    triangle {
      < -4.228057, -0.312812, 3.321782>,
      < -4.227883, -0.322861, 3.365587>,
      < -4.227857, -0.322809, 3.321770>
    }
    triangle {
      < -4.503829, -0.575037, 3.384957>,
      < -4.503779, -0.574938, 3.301476>,
      < -4.344356, -0.544931, 3.321438>
    }
    triangle {
      < -4.503829, -0.575037, 3.384957>,
      < -4.344356, -0.544931, 3.321438>,
      < -4.344381, -0.544983, 3.365254>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.480903, -0.244515, 3.301880>,
      < -4.788019, -0.202442, 3.301748>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.788019, -0.202442, 3.301748>,
      < -5.151290, -0.234538, 3.324217>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -5.151290, -0.234538, 3.324217>,
      < -5.342435, 1.885214, 3.325520>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -5.342435, 1.885214, 3.325520>,
      < -4.890609, 1.886749, 3.314371>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.890609, 1.886749, 3.314371>,
      < -4.742294, 1.792143, 3.322876>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.742294, 1.792143, 3.322876>,
      < -4.228057, -0.312812, 3.321782>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.228057, -0.312812, 3.321782>,
      < -4.227857, -0.322809, 3.321770>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.227857, -0.322809, 3.321770>,
      < -4.348738, -0.325203, 3.301864>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.348738, -0.325203, 3.301864>,
      < -4.348938, -0.315207, 3.301875>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.348938, -0.315207, 3.301875>,
      < -4.369123, -0.289950, 3.301893>
    }
    texture {parts_rudder}
  }
  // parts_stabilizers
  union {
    triangle {
      < -4.348938, -0.315207, 3.301875>,
      < -4.348738, -0.325203, 3.301864>,
      < -4.346982, -0.321692, 0.339681>
    }
    triangle {
      < -4.348938, -0.315207, 3.301875>,
      < -4.346982, -0.321692, 0.339681>,
      < -4.347182, -0.311695, 0.339693>
    }
    triangle {
      < -4.348738, -0.325203, 3.301864>,
      < -5.150190, -0.262043, 3.324185>,
      < -5.166318, -0.258730, 0.226963>
    }
    triangle {
      < -4.348738, -0.325203, 3.301864>,
      < -5.166318, -0.258730, 0.226963>,
      < -4.346982, -0.321692, 0.339681>
    }
    triangle {
      < -5.733164, -0.263344, 3.301116>,
      < -5.731342, -0.259700, 0.226627>,
      < -5.748742, -0.260756, 0.226615>
    }
    triangle {
      < -5.733164, -0.263344, 3.301116>,
      < -5.748742, -0.260756, 0.226615>,
      < -5.750564, -0.264400, 3.301105>
    }
    triangle {
      < -5.151290, -0.234538, 3.324217>,
      < -4.788019, -0.202442, 3.301748>,
      < -4.786264, -0.198931, 0.339567>
    }
    triangle {
      < -5.151290, -0.234538, 3.324217>,
      < -4.786264, -0.198931, 0.339567>,
      < -5.149455, -0.230867, 0.227005>
    }
    triangle {
      < -4.788019, -0.202442, 3.301748>,
      < -4.480903, -0.244515, 3.301880>,
      < -4.479147, -0.241005, 0.339699>
    }
    triangle {
      < -4.788019, -0.202442, 3.301748>,
      < -4.479147, -0.241005, 0.339699>,
      < -4.786264, -0.198931, 0.339567>
    }
    triangle {
      < -4.480903, -0.244515, 3.301880>,
      < -4.420017, -0.262596, 3.301895>,
      < -4.418261, -0.259085, 0.339713>
    }
    triangle {
      < -4.480903, -0.244515, 3.301880>,
      < -4.418261, -0.259085, 0.339713>,
      < -4.479147, -0.241005, 0.339699>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.369123, -0.289950, 3.301893>,
      < -4.367367, -0.286440, 0.339711>
    }
    triangle {
      < -4.420017, -0.262596, 3.301895>,
      < -4.367367, -0.286440, 0.339711>,
      < -4.418261, -0.259085, 0.339713>
    }
    texture {parts_stabilizers}
  }
  // parts_fuselage
  union {
    triangle {
      < -4.786264, -0.198931, 0.339567>,
      < -4.479147, -0.241005, 0.339699>,
      < -4.479108, -0.240927, 0.274186>
    }
    triangle {
      < -4.786264, -0.198931, 0.339567>,
      < -4.479108, -0.240927, 0.274186>,
      < -4.786203, -0.198811, 0.237789>
    }
    triangle {
      < -4.479147, -0.241005, 0.339699>,
      < -4.418261, -0.259085, 0.339713>,
      < -4.418226, -0.259014, 0.280105>
    }
    triangle {
      < -4.479147, -0.241005, 0.339699>,
      < -4.418226, -0.259014, 0.280105>,
      < -4.479108, -0.240927, 0.274186>
    }
    triangle {
      < -4.418261, -0.259085, 0.339713>,
      < -4.367367, -0.286440, 0.339711>,
      < -4.367322, -0.286350, 0.264074>
    }
    triangle {
      < -4.418261, -0.259085, 0.339713>,
      < -4.367322, -0.286350, 0.264074>,
      < -4.418226, -0.259014, 0.280105>
    }
    triangle {
      < -4.367367, -0.286440, 0.339711>,
      < -4.347182, -0.311695, 0.339693>,
      < -4.347127, -0.311585, 0.246469>
    }
    triangle {
      < -4.367367, -0.286440, 0.339711>,
      < -4.347127, -0.311585, 0.246469>,
      < -4.367322, -0.286350, 0.264074>
    }
    triangle {
      < -4.347182, -0.311695, 0.339693>,
      < -4.346982, -0.321692, 0.339681>,
      < -4.346814, -0.321354, 0.054877>
    }
    triangle {
      < -4.347182, -0.311695, 0.339693>,
      < -4.346814, -0.321354, 0.054877>,
      < -4.347127, -0.311585, 0.246469>
    }
    triangle {
      < -4.346982, -0.321692, 0.339681>,
      < -5.166318, -0.258730, 0.226963>,
      < -5.166206, -0.258506, 0.037319>
    }
    triangle {
      < -4.346982, -0.321692, 0.339681>,
      < -5.166206, -0.258506, 0.037319>,
      < -4.346814, -0.321354, 0.054877>
    }
    triangle {
      < -5.166318, -0.258730, 0.226963>,
      < -5.149455, -0.230867, 0.227005>,
      < -5.149426, -0.230811, 0.179504>
    }
    triangle {
      < -5.166318, -0.258730, 0.226963>,
      < -5.149426, -0.230811, 0.179504>,
      < -5.166206, -0.258506, 0.037319>
    }
    triangle {
      < -5.149455, -0.230867, 0.227005>,
      < -4.786264, -0.198931, 0.339567>,
      < -4.786203, -0.198811, 0.237789>
    }
    triangle {
      < -5.149455, -0.230867, 0.227005>,
      < -4.786203, -0.198811, 0.237789>,
      < -5.149426, -0.230811, 0.179504>
    }
    texture {parts_fuselage}
  }
  // parts_rudder
  union {
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -4.348987, -0.315305, 3.385357>,
      < -5.151313, -0.234583, 3.362255>
    }
    triangle {
      < -4.348787, -0.325302, 3.385346>,
      < -5.151313, -0.234583, 3.362255>,
      < -5.150213, -0.262087, 3.362223>
    }
    texture {parts_rudder}
  }
  // parts_fuselage
  union {
    triangle {
      < -5.152612, -0.217115, 0.192858>,
      < -5.751218, -0.166676, 0.149132>,
      < -5.750466, -0.203404, 0.120225>
    }
    triangle {
      < -5.152612, -0.217115, 0.192858>,
      < -5.750466, -0.203404, 0.120225>,
      < -5.149426, -0.230811, 0.179504>
    }
    triangle {
      < -5.152612, -0.217115, 0.192858>,
      < -5.149426, -0.230811, 0.179504>,
      < -4.786203, -0.198811, 0.237789>
    }
    triangle {
      < -6.106521, 0.035473, 0.012461>,
      < -6.106454, 0.032003, 0.018821>,
      < -5.978554, 0.100199, 0.047022>
    }
    triangle {
      < -6.106521, 0.035473, 0.012461>,
      < -5.978554, 0.100199, 0.047022>,
      < -5.978732, 0.109653, 0.029697>
    }
    triangle {
      < -6.106454, 0.032003, 0.018821>,
      < -6.106342, 0.026157, 0.025268>,
      < -5.978246, 0.084270, 0.064589>
    }
    triangle {
      < -6.106454, 0.032003, 0.018821>,
      < -5.978246, 0.084270, 0.064589>,
      < -5.978554, 0.100199, 0.047022>
    }
    triangle {
      < -6.106342, 0.026157, 0.025268>,
      < -6.105809, -0.000666, 0.031090>,
      < -5.976794, 0.011191, 0.080450>
    }
    triangle {
      < -6.106342, 0.026157, 0.025268>,
      < -5.976794, 0.011191, 0.080450>,
      < -5.978246, 0.084270, 0.064589>
    }
    triangle {
      < -6.105809, -0.000666, 0.031090>,
      < -6.105331, -0.024599, 0.033526>,
      < -5.975494, -0.054015, 0.087087>
    }
    triangle {
      < -6.105809, -0.000666, 0.031090>,
      < -5.975494, -0.054015, 0.087087>,
      < -5.976794, 0.011191, 0.080450>
    }
    triangle {
      < -6.105331, -0.024599, 0.033526>,
      < -6.105103, -0.035866, 0.027180>,
      < -5.974870, -0.084709, 0.069796>
    }
    triangle {
      < -6.105331, -0.024599, 0.033526>,
      < -5.974870, -0.084709, 0.069796>,
      < -5.975494, -0.054015, 0.087087>
    }
    triangle {
      < -6.105103, -0.035866, 0.027180>,
      < -6.104971, -0.042247, 0.021170>,
      < -5.974513, -0.102096, 0.053422>
    }
    triangle {
      < -6.105103, -0.035866, 0.027180>,
      < -5.974513, -0.102096, 0.053422>,
      < -5.974870, -0.084709, 0.069796>
    }
    triangle {
      < -6.104971, -0.042247, 0.021170>,
      < -6.104828, -0.049035, 0.007361>,
      < -5.974119, -0.120593, 0.015800>
    }
    triangle {
      < -6.104971, -0.042247, 0.021170>,
      < -5.974119, -0.120593, 0.015800>,
      < -5.974513, -0.102096, 0.053422>
    }
    triangle {
      < -6.104828, -0.049035, 0.007361>,
      < -6.104812, -0.049484, -0.004721>,
      < -5.974082, -0.121832, -0.004730>
    }
    triangle {
      < -6.104828, -0.049035, 0.007361>,
      < -5.974082, -0.121832, -0.004730>,
      < -5.974119, -0.120593, 0.015800>
    }
    triangle {
      < -6.106549, 0.037416, -0.004619>,
      < -6.106551, 0.037152, 0.006176>,
      < -5.978813, 0.114226, 0.012574>
    }
    triangle {
      < -6.106549, 0.037416, -0.004619>,
      < -5.978813, 0.114226, 0.012574>,
      < -5.978817, 0.114932, -0.004452>
    }
    triangle {
      < -6.106551, 0.037152, 0.006176>,
      < -6.106542, 0.036612, 0.008938>,
      < -5.978789, 0.112757, 0.020097>
    }
    triangle {
      < -6.106551, 0.037152, 0.006176>,
      < -5.978789, 0.112757, 0.020097>,
      < -5.978813, 0.114226, 0.012574>
    }
    triangle {
      < -6.106542, 0.036612, 0.008938>,
      < -6.106521, 0.035473, 0.012461>,
      < -5.978732, 0.109653, 0.029697>
    }
    triangle {
      < -6.106542, 0.036612, 0.008938>,
      < -5.978732, 0.109653, 0.029697>,
      < -5.978789, 0.112757, 0.020097>
    }
    triangle {
      < -5.978817, 0.114932, -0.004452>,
      < -5.978813, 0.114226, 0.012574>,
      < -5.757603, 0.156566, 0.019180>
    }
    triangle {
      < -5.978817, 0.114932, -0.004452>,
      < -5.757603, 0.156566, 0.019180>,
      < -5.757614, 0.157847, -0.004269>
    }
    triangle {
      < -5.978813, 0.114226, 0.012574>,
      < -5.978789, 0.112757, 0.020097>,
      < -5.757561, 0.153900, 0.037684>
    }
    triangle {
      < -5.978813, 0.114226, 0.012574>,
      < -5.757561, 0.153900, 0.037684>,
      < -5.757603, 0.156566, 0.019180>
    }
    triangle {
      < -5.978789, 0.112757, 0.020097>,
      < -5.978732, 0.109653, 0.029697>,
      < -5.757465, 0.148379, 0.060895>
    }
    triangle {
      < -5.978789, 0.112757, 0.020097>,
      < -5.757465, 0.148379, 0.060895>,
      < -5.757561, 0.153900, 0.037684>
    }
    triangle {
      < -5.978732, 0.109653, 0.029697>,
      < -5.978554, 0.100199, 0.047022>,
      < -5.757173, 0.132598, 0.100525>
    }
    triangle {
      < -5.978732, 0.109653, 0.029697>,
      < -5.757173, 0.132598, 0.100525>,
      < -5.757465, 0.148379, 0.060895>
    }
    triangle {
      < -5.978554, 0.100199, 0.047022>,
      < -5.978246, 0.084270, 0.064589>,
      < -5.756723, 0.108961, 0.136847>
    }
    triangle {
      < -5.978554, 0.100199, 0.047022>,
      < -5.756723, 0.108961, 0.136847>,
      < -5.757173, 0.132598, 0.100525>
    }
    triangle {
      < -5.978246, 0.084270, 0.064589>,
      < -5.976794, 0.011191, 0.080450>,
      < -5.754990, 0.021136, 0.174560>
    }
    triangle {
      < -5.978246, 0.084270, 0.064589>,
      < -5.754990, 0.021136, 0.174560>,
      < -5.756723, 0.108961, 0.136847>
    }
    triangle {
      < -5.976794, 0.011191, 0.080450>,
      < -5.975494, -0.054015, 0.087087>,
      < -5.752180, -0.119403, 0.174278>
    }
    triangle {
      < -5.976794, 0.011191, 0.080450>,
      < -5.752180, -0.119403, 0.174278>,
      < -5.754990, 0.021136, 0.174560>
    }
    triangle {
      < -5.975494, -0.054015, 0.087087>,
      < -5.974870, -0.084709, 0.069796>,
      < -5.751218, -0.166676, 0.149132>
    }
    triangle {
      < -5.975494, -0.054015, 0.087087>,
      < -5.751218, -0.166676, 0.149132>,
      < -5.752180, -0.119403, 0.174278>
    }
    triangle {
      < -5.974870, -0.084709, 0.069796>,
      < -5.974513, -0.102096, 0.053422>,
      < -5.750466, -0.203404, 0.120225>
    }
    triangle {
      < -5.974870, -0.084709, 0.069796>,
      < -5.750466, -0.203404, 0.120225>,
      < -5.751218, -0.166676, 0.149132>
    }
    triangle {
      < -5.974513, -0.102096, 0.053422>,
      < -5.974119, -0.120593, 0.015800>,
      < -5.750356, -0.206051, 0.029652>
    }
    triangle {
      < -5.974513, -0.102096, 0.053422>,
      < -5.750356, -0.206051, 0.029652>,
      < -5.750466, -0.203404, 0.120225>
    }
    triangle {
      < -5.974119, -0.120593, 0.015800>,
      < -5.974082, -0.121832, -0.004730>,
      < -5.750284, -0.208640, -0.004700>
    }
    triangle {
      < -5.974119, -0.120593, 0.015800>,
      < -5.750284, -0.208640, -0.004700>,
      < -5.750356, -0.206051, 0.029652>
    }
    triangle {
      < -5.166206, -0.258506, 0.037319>,
      < -5.750356, -0.206051, 0.029652>,
      < -5.750284, -0.208640, -0.004700>
    }
    triangle {
      < -5.166206, -0.258506, 0.037319>,
      < -5.750284, -0.208640, -0.004700>,
      < -4.346779, -0.321284, -0.004001>
    }
    triangle {
      < -5.166206, -0.258506, 0.037319>,
      < -4.346779, -0.321284, -0.004001>,
      < -4.346814, -0.321354, 0.054877>
    }
    triangle {
      < -5.757614, 0.157847, -0.004269>,
      < -5.757603, 0.156566, 0.019180>,
      < -4.359219, 0.299413, 0.039056>
    }
    triangle {
      < -5.757614, 0.157847, -0.004269>,
      < -4.359219, 0.299413, 0.039056>,
      < -4.359270, 0.303239, -0.003268>
    }
    triangle {
      < -5.757603, 0.156566, 0.019180>,
      < -5.757561, 0.153900, 0.037684>,
      < -4.359181, 0.296488, 0.072152>
    }
    triangle {
      < -5.757603, 0.156566, 0.019180>,
      < -4.359181, 0.296488, 0.072152>,
      < -4.359219, 0.299413, 0.039056>
    }
    triangle {
      < -5.757561, 0.153900, 0.037684>,
      < -5.757465, 0.148379, 0.060895>,
      < -4.359131, 0.292661, 0.115467>
    }
    triangle {
      < -5.757561, 0.153900, 0.037684>,
      < -4.359131, 0.292661, 0.115467>,
      < -4.359181, 0.296488, 0.072152>
    }
    triangle {
      < -5.757465, 0.148379, 0.060895>,
      < -5.757173, 0.132598, 0.100525>,
      < -4.358544, 0.261275, 0.181286>
    }
    triangle {
      < -5.757465, 0.148379, 0.060895>,
      < -4.358544, 0.261275, 0.181286>,
      < -4.359131, 0.292661, 0.115467>
    }
    triangle {
      < -5.757173, 0.132598, 0.100525>,
      < -5.756723, 0.108961, 0.136847>,
      < -4.357527, 0.209117, 0.223133>
    }
    triangle {
      < -5.757173, 0.132598, 0.100525>,
      < -4.357527, 0.209117, 0.223133>,
      < -4.358544, 0.261275, 0.181286>
    }
    triangle {
      < -5.756723, 0.108961, 0.136847>,
      < -5.754990, 0.021136, 0.174560>,
      < -4.355007, 0.081684, 0.270877>
    }
    triangle {
      < -5.756723, 0.108961, 0.136847>,
      < -4.355007, 0.081684, 0.270877>,
      < -4.357527, 0.209117, 0.223133>
    }
    triangle {
      < -5.754990, 0.021136, 0.174560>,
      < -5.752180, -0.119403, 0.174278>,
      < -4.349150, -0.211974, 0.295814>
    }
    triangle {
      < -5.754990, 0.021136, 0.174560>,
      < -4.349150, -0.211974, 0.295814>,
      < -4.355007, 0.081684, 0.270877>
    }
    triangle {
      < -5.752180, -0.119403, 0.174278>,
      < -5.751218, -0.166676, 0.149132>,
      < -5.152612, -0.217115, 0.192858>
    }
    triangle {
      < -5.752180, -0.119403, 0.174278>,
      < -5.152612, -0.217115, 0.192858>,
      < -4.786203, -0.198811, 0.237789>
    }
    triangle {
      < -5.752180, -0.119403, 0.174278>,
      < -4.786203, -0.198811, 0.237789>,
      < -4.479108, -0.240927, 0.274186>
    }
    triangle {
      < -5.752180, -0.119403, 0.174278>,
      < -4.479108, -0.240927, 0.274186>,
      < -4.418226, -0.259014, 0.280105>
    }
    triangle {
      < -5.752180, -0.119403, 0.174278>,
      < -4.418226, -0.259014, 0.280105>,
      < -4.348012, -0.268645, 0.288427>
    }
    triangle {
      < -5.752180, -0.119403, 0.174278>,
      < -4.348012, -0.268645, 0.288427>,
      < -4.349150, -0.211974, 0.295814>
    }
    triangle {
      < -4.418226, -0.259014, 0.280105>,
      < -4.367322, -0.286350, 0.264074>,
      < -4.347127, -0.311585, 0.246469>
    }
    triangle {
      < -4.418226, -0.259014, 0.280105>,
      < -4.347127, -0.311585, 0.246469>,
      < -4.348012, -0.268645, 0.288427>
    }
    triangle {
      < -5.750466, -0.203404, 0.120225>,
      < -5.750356, -0.206051, 0.029652>,
      < -5.166206, -0.258506, 0.037319>
    }
    triangle {
      < -5.750466, -0.203404, 0.120225>,
      < -5.166206, -0.258506, 0.037319>,
      < -5.149426, -0.230811, 0.179504>
    }
    triangle {
      < -4.349150, -0.211974, 0.295814>,
      < -4.348012, -0.268645, 0.288427>,
      < -3.426566, -0.347892, 0.367356>
    }
    triangle {
      < -4.349150, -0.211974, 0.295814>,
      < -3.426566, -0.347892, 0.367356>,
      < -3.428008, -0.276060, 0.376720>
    }
    triangle {
      < -4.348012, -0.268645, 0.288427>,
      < -4.347127, -0.311585, 0.246469>,
      < -3.425444, -0.402319, 0.314173>
    }
    triangle {
      < -4.348012, -0.268645, 0.288427>,
      < -3.425444, -0.402319, 0.314173>,
      < -3.426566, -0.347892, 0.367356>
    }
    triangle {
      < -4.347127, -0.311585, 0.246469>,
      < -4.346814, -0.321354, 0.054877>,
      < -3.425048, -0.414702, 0.071328>
    }
    triangle {
      < -4.347127, -0.311585, 0.246469>,
      < -3.425048, -0.414702, 0.071328>,
      < -3.425444, -0.402319, 0.314173>
    }
    triangle {
      < -4.359270, 0.303239, -0.003268>,
      < -4.359219, 0.299413, 0.039056>,
      < -3.441715, 0.419358, 0.051330>
    }
    triangle {
      < -4.359270, 0.303239, -0.003268>,
      < -3.441715, 0.419358, 0.051330>,
      < -3.441786, 0.424558, -0.002581>
    }
    triangle {
      < -4.359219, 0.299413, 0.039056>,
      < -4.359181, 0.296488, 0.072152>,
      < -3.441662, 0.415384, 0.093279>
    }
    triangle {
      < -4.359219, 0.299413, 0.039056>,
      < -3.441662, 0.415384, 0.093279>,
      < -3.441715, 0.419358, 0.051330>
    }
    triangle {
      < -4.359181, 0.296488, 0.072152>,
      < -4.359131, 0.292661, 0.115467>,
      < -3.441592, 0.410183, 0.148181>
    }
    triangle {
      < -4.359181, 0.296488, 0.072152>,
      < -3.441592, 0.410183, 0.148181>,
      < -3.441662, 0.415384, 0.093279>
    }
    triangle {
      < -4.359131, 0.292661, 0.115467>,
      < -4.358544, 0.261275, 0.181286>,
      < -4.051579, 0.318451, 0.208261>
    }
    triangle {
      < -4.359131, 0.292661, 0.115467>,
      < -4.051579, 0.318451, 0.208261>,
      < -3.441592, 0.410183, 0.148181>
    }
    triangle {
      < -4.358544, 0.261275, 0.181286>,
      < -4.357527, 0.209117, 0.223133>,
      < -3.439404, 0.296543, 0.284639>
    }
    triangle {
      < -4.358544, 0.261275, 0.181286>,
      < -3.439404, 0.296543, 0.284639>,
      < -4.051579, 0.318451, 0.208261>
    }
    triangle {
      < -4.357527, 0.209117, 0.223133>,
      < -4.355007, 0.081684, 0.270877>,
      < -3.435974, 0.123193, 0.345143>
    }
    triangle {
      < -4.357527, 0.209117, 0.223133>,
      < -3.435974, 0.123193, 0.345143>,
      < -3.439404, 0.296543, 0.284639>
    }
    triangle {
      < -4.355007, 0.081684, 0.270877>,
      < -4.349150, -0.211974, 0.295814>,
      < -3.428008, -0.276060, 0.376720>
    }
    triangle {
      < -4.355007, 0.081684, 0.270877>,
      < -3.428008, -0.276060, 0.376720>,
      < -3.435974, 0.123193, 0.345143>
    }
    triangle {
      < -3.439404, 0.296543, 0.284639>,
      < -3.435974, 0.123193, 0.345143>,
      < -1.239512, 0.231039, 0.462595>
    }
    triangle {
      < -3.439404, 0.296543, 0.284639>,
      < -1.239512, 0.231039, 0.462595>,
      < -1.243800, 0.448991, 0.346918>
    }
    triangle {
      < -3.435974, 0.123193, 0.345143>,
      < -3.428008, -0.276060, 0.376720>,
      < -1.229021, -0.294888, 0.504673>
    }
    triangle {
      < -3.435974, 0.123193, 0.345143>,
      < -1.229021, -0.294888, 0.504673>,
      < -1.239512, 0.231039, 0.462595>
    }
    triangle {
      < -3.428008, -0.276060, 0.376720>,
      < -3.426566, -0.347892, 0.367356>,
      < -1.226950, -0.398034, 0.492189>
    }
    triangle {
      < -3.428008, -0.276060, 0.376720>,
      < -1.226950, -0.398034, 0.492189>,
      < -1.229021, -0.294888, 0.504673>
    }
    triangle {
      < -3.426566, -0.347892, 0.367356>,
      < -3.425444, -0.402319, 0.314173>,
      < -1.225343, -0.476197, 0.421323>
    }
    triangle {
      < -3.426566, -0.347892, 0.367356>,
      < -1.225343, -0.476197, 0.421323>,
      < -1.226950, -0.398034, 0.492189>
    }
    triangle {
      < -3.425444, -0.402319, 0.314173>,
      < -3.425048, -0.414702, 0.071328>,
      < -1.224787, -0.494007, 0.097761>
    }
    triangle {
      < -3.425444, -0.402319, 0.314173>,
      < -1.224787, -0.494007, 0.097761>,
      < -1.225343, -0.476197, 0.421323>
    }
    triangle {
      < -3.441786, 0.424558, -0.002581>,
      < -3.441715, 0.419358, 0.051330>,
      < -1.246713, 0.603358, 0.064425>
    }
    triangle {
      < -3.441786, 0.424558, -0.002581>,
      < -1.246713, 0.603358, 0.064425>,
      < -1.246803, 0.609891, -0.001061>
    }
    triangle {
      < -3.441715, 0.419358, 0.051330>,
      < -3.441662, 0.415384, 0.093279>,
      < -1.246645, 0.598365, 0.115219>
    }
    triangle {
      < -3.441715, 0.419358, 0.051330>,
      < -1.246645, 0.598365, 0.115219>,
      < -1.246713, 0.603358, 0.064425>
    }
    triangle {
      < -3.441662, 0.415384, 0.093279>,
      < -3.441592, 0.410183, 0.148181>,
      < -1.246555, 0.591830, 0.181695>
    }
    triangle {
      < -3.441662, 0.415384, 0.093279>,
      < -1.246555, 0.591830, 0.181695>,
      < -1.246645, 0.598365, 0.115219>
    }
    triangle {
      < -3.290702, 0.590519, 0.730708>,
      < -3.560323, 0.565828, 0.730519>,
      < -3.289891, 0.553292, 0.730664>
    }
    triangle {
      < -3.290702, 0.590519, 0.730708>,
      < -3.289891, 0.553292, 0.730664>,
      < -1.268120, 0.625750, 0.731948>
    }
    triangle {
      < -3.290702, 0.590519, 0.730708>,
      < -1.268120, 0.625750, 0.731948>,
      < -1.206828, 0.657004, 0.732022>
    }
    triangle {
      < -3.290702, 0.590519, 0.730708>,
      < -1.206828, 0.657004, 0.732022>,
      < -1.269130, 0.672541, 0.732004>
    }
    texture {parts_fuselage}
  }
  // parts_wings
  union {
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.520686, 0.059198, 6.703282>,
      < 0.722460, 0.119892, 6.680013>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.722460, 0.119892, 6.680013>,
      < 0.723688, 0.124659, 6.695445>
    }
    triangle {
      < 0.520686, 0.059198, 6.703282>,
      < 0.508749, 0.055907, 6.693340>,
      < 0.703908, 0.114779, 6.664561>
    }
    triangle {
      < 0.520686, 0.059198, 6.703282>,
      < 0.703908, 0.114779, 6.664561>,
      < 0.722460, 0.119892, 6.680013>
    }
    triangle {
      < 0.508749, 0.055907, 6.693340>,
      < 0.469053, 0.053522, 6.688135>,
      < 0.642221, 0.111074, 6.656471>
    }
    triangle {
      < 0.508749, 0.055907, 6.693340>,
      < 0.642221, 0.111074, 6.656471>,
      < 0.703908, 0.114779, 6.664561>
    }
    triangle {
      < 0.469053, 0.053522, 6.688135>,
      < -0.140139, 0.041339, 6.687759>,
      < -0.301024, 0.092209, 6.655891>
    }
    triangle {
      < 0.469053, 0.053522, 6.688135>,
      < -0.301024, 0.092209, 6.655891>,
      < 0.642221, 0.111074, 6.656471>
    }
    triangle {
      < -0.140139, 0.041339, 6.687759>,
      < -0.208716, 0.041951, 6.694173>,
      < -0.407593, 0.093160, 6.665861>
    }
    triangle {
      < -0.140139, 0.041339, 6.687759>,
      < -0.407593, 0.093160, 6.665861>,
      < -0.301024, 0.092209, 6.655891>
    }
    triangle {
      < -0.208716, 0.041951, 6.694173>,
      < -0.172764, 0.043452, 6.696744>,
      < -0.351723, 0.095493, 6.669857>
    }
    triangle {
      < -0.208716, 0.041951, 6.694173>,
      < -0.351723, 0.095493, 6.669857>,
      < -0.407593, 0.093160, 6.665861>
    }
    triangle {
      < -0.172764, 0.043452, 6.696744>,
      < -0.132054, 0.045914, 6.702135>,
      < -0.288460, 0.099318, 6.678230>
    }
    triangle {
      < -0.172764, 0.043452, 6.696744>,
      < -0.288460, 0.099318, 6.678230>,
      < -0.351723, 0.095493, 6.669857>
    }
    triangle {
      < -0.132054, 0.045914, 6.702135>,
      < -0.095493, 0.048896, 6.709485>,
      < -0.231645, 0.103953, 6.689654>
    }
    triangle {
      < -0.132054, 0.045914, 6.702135>,
      < -0.231645, 0.103953, 6.689654>,
      < -0.288460, 0.099318, 6.678230>
    }
    triangle {
      < -0.095493, 0.048896, 6.709485>,
      < -0.055422, 0.051274, 6.714639>,
      < -0.169373, 0.107648, 6.697662>
    }
    triangle {
      < -0.095493, 0.048896, 6.709485>,
      < -0.169373, 0.107648, 6.697662>,
      < -0.231645, 0.103953, 6.689654>
    }
    triangle {
      < -0.055422, 0.051274, 6.714639>,
      < -0.018208, 0.053545, 6.719640>,
      < -0.111542, 0.111178, 6.705434>
    }
    triangle {
      < -0.055422, 0.051274, 6.714639>,
      < -0.111542, 0.111178, 6.705434>,
      < -0.169373, 0.107648, 6.697662>
    }
    triangle {
      < -0.018208, 0.053545, 6.719640>,
      < 0.021237, 0.055369, 6.723034>,
      < -0.050244, 0.114013, 6.710710>
    }
    triangle {
      < -0.018208, 0.053545, 6.719640>,
      < -0.050244, 0.114013, 6.710710>,
      < -0.111542, 0.111178, 6.705434>
    }
    triangle {
      < 0.021237, 0.055369, 6.723034>,
      < 0.130305, 0.061283, 6.735254>,
      < 0.115802, 0.123134, 6.729698>
    }
    triangle {
      < 0.021237, 0.055369, 6.723034>,
      < 0.115802, 0.123134, 6.729698>,
      < -0.050244, 0.114013, 6.710710>
    }
    triangle {
      < 0.130305, 0.061283, 6.735254>,
      < 0.258267, 0.066565, 6.744197>,
      < 0.314656, 0.131342, 6.743596>
    }
    triangle {
      < 0.130305, 0.061283, 6.735254>,
      < 0.314656, 0.131342, 6.743596>,
      < 0.115802, 0.123134, 6.729698>
    }
    triangle {
      < 0.258267, 0.066565, 6.744197>,
      < 0.372855, 0.067951, 6.741307>,
      < 0.492727, 0.133496, 6.739104>
    }
    triangle {
      < 0.258267, 0.066565, 6.744197>,
      < 0.492727, 0.133496, 6.739104>,
      < 0.314656, 0.131342, 6.743596>
    }
    triangle {
      < 0.372855, 0.067951, 6.741307>,
      < 0.483092, 0.066937, 6.730906>,
      < 0.664038, 0.131921, 6.722940>
    }
    triangle {
      < 0.372855, 0.067951, 6.741307>,
      < 0.664038, 0.131921, 6.722940>,
      < 0.492727, 0.133496, 6.739104>
    }
    triangle {
      < 0.483092, 0.066937, 6.730906>,
      < 0.511120, 0.065107, 6.723131>,
      < 0.707595, 0.129075, 6.710857>
    }
    triangle {
      < 0.483092, 0.066937, 6.730906>,
      < 0.707595, 0.129075, 6.710857>,
      < 0.664038, 0.131921, 6.722940>
    }
    triangle {
      < 0.511120, 0.065107, 6.723131>,
      < 0.521477, 0.062266, 6.713212>,
      < 0.723688, 0.124659, 6.695445>
    }
    triangle {
      < 0.511120, 0.065107, 6.723131>,
      < 0.723688, 0.124659, 6.695445>,
      < 0.707595, 0.129075, 6.710857>
    }
    triangle {
      < 0.492727, 0.133496, 6.739104>,
      < 0.664038, 0.131921, 6.722940>,
      < 0.819729, 0.232739, 6.650471>
    }
    triangle {
      < 0.492727, 0.133496, 6.739104>,
      < 0.819729, 0.232739, 6.650471>,
      < 0.597814, 0.245782, 6.663747>
    }
    triangle {
      < 0.664038, 0.131921, 6.722940>,
      < 0.707595, 0.129075, 6.710857>,
      < 0.876259, 0.220866, 6.640527>
    }
    triangle {
      < 0.664038, 0.131921, 6.722940>,
      < 0.876259, 0.220866, 6.640527>,
      < 0.819729, 0.232739, 6.650471>
    }
    triangle {
      < 0.707595, 0.129075, 6.710857>,
      < 0.723688, 0.124659, 6.695445>,
      < 0.897291, 0.204720, 6.627828>
    }
    triangle {
      < 0.707595, 0.129075, 6.710857>,
      < 0.897291, 0.204720, 6.627828>,
      < 0.876259, 0.220866, 6.640527>
    }
    triangle {
      < 0.723688, 0.124659, 6.695445>,
      < 0.722460, 0.119892, 6.680013>,
      < 0.895905, 0.188113, 6.615109>
    }
    triangle {
      < 0.723688, 0.124659, 6.695445>,
      < 0.895905, 0.188113, 6.615109>,
      < 0.897291, 0.204720, 6.627828>
    }
    triangle {
      < 0.722460, 0.119892, 6.680013>,
      < 0.703908, 0.114779, 6.664561>,
      < 0.872100, 0.171052, 6.602368>
    }
    triangle {
      < 0.722460, 0.119892, 6.680013>,
      < 0.872100, 0.171052, 6.602368>,
      < 0.895905, 0.188113, 6.615109>
    }
    triangle {
      < 0.703908, 0.114779, 6.664561>,
      < 0.642221, 0.111074, 6.656471>,
      < 0.792375, 0.160809, 6.595684>
    }
    triangle {
      < 0.703908, 0.114779, 6.664561>,
      < 0.792375, 0.160809, 6.595684>,
      < 0.872100, 0.171052, 6.602368>
    }
    triangle {
      < 0.642221, 0.111074, 6.656471>,
      < -0.301024, 0.092209, 6.655891>,
      < -0.536771, 0.134227, 6.594863>
    }
    triangle {
      < 0.642221, 0.111074, 6.656471>,
      < -0.536771, 0.134227, 6.594863>,
      < 0.792375, 0.160809, 6.595684>
    }
    triangle {
      < -0.301024, 0.092209, 6.655891>,
      < -0.407593, 0.093160, 6.665861>,
      < -0.552124, 0.144701, 6.603128>
    }
    triangle {
      < -0.301024, 0.092209, 6.655891>,
      < -0.552124, 0.144701, 6.603128>,
      < -0.536771, 0.134227, 6.594863>
    }
    triangle {
      < -0.407593, 0.093160, 6.665861>,
      < -0.351723, 0.095493, 6.669857>,
      < -0.522957, 0.149537, 6.606410>
    }
    triangle {
      < -0.407593, 0.093160, 6.665861>,
      < -0.522957, 0.149537, 6.606410>,
      < -0.552124, 0.144701, 6.603128>
    }
    triangle {
      < -0.351723, 0.095493, 6.669857>,
      < -0.288460, 0.099318, 6.678230>,
      < -0.444202, 0.160064, 6.613326>
    }
    triangle {
      < -0.351723, 0.095493, 6.669857>,
      < -0.444202, 0.160064, 6.613326>,
      < -0.522957, 0.149537, 6.606410>
    }
    triangle {
      < -0.288460, 0.099318, 6.678230>,
      < -0.231645, 0.103953, 6.689654>,
      < -0.373533, 0.173714, 6.622760>
    }
    triangle {
      < -0.288460, 0.099318, 6.678230>,
      < -0.373533, 0.173714, 6.622760>,
      < -0.444202, 0.160064, 6.613326>
    }
    triangle {
      < -0.231645, 0.103953, 6.689654>,
      < -0.169373, 0.107648, 6.697662>,
      < -0.296013, 0.183826, 6.629373>
    }
    triangle {
      < -0.231645, 0.103953, 6.689654>,
      < -0.296013, 0.183826, 6.629373>,
      < -0.373533, 0.173714, 6.622760>
    }
    triangle {
      < -0.169373, 0.107648, 6.697662>,
      < -0.111542, 0.111178, 6.705434>,
      < -0.224023, 0.193572, 6.635793>
    }
    triangle {
      < -0.169373, 0.107648, 6.697662>,
      < -0.224023, 0.193572, 6.635793>,
      < -0.296013, 0.183826, 6.629373>
    }
    triangle {
      < -0.111542, 0.111178, 6.705434>,
      < -0.050244, 0.114013, 6.710710>,
      < -0.147685, 0.200725, 6.640157>
    }
    triangle {
      < -0.111542, 0.111178, 6.705434>,
      < -0.147685, 0.200725, 6.640157>,
      < -0.224023, 0.193572, 6.635793>
    }
    triangle {
      < -0.050244, 0.114013, 6.710710>,
      < 0.115802, 0.123134, 6.729698>,
      < 0.110139, 0.226168, 6.655884>
    }
    triangle {
      < -0.050244, 0.114013, 6.710710>,
      < 0.110139, 0.226168, 6.655884>,
      < -0.147685, 0.200725, 6.640157>
    }
    triangle {
      < 0.115802, 0.123134, 6.729698>,
      < 0.314656, 0.131342, 6.743596>,
      < 0.367301, 0.246109, 6.667394>
    }
    triangle {
      < 0.115802, 0.123134, 6.729698>,
      < 0.367301, 0.246109, 6.667394>,
      < 0.110139, 0.226168, 6.655884>
    }
    triangle {
      < 0.314656, 0.131342, 6.743596>,
      < 0.492727, 0.133496, 6.739104>,
      < 0.597814, 0.245782, 6.663747>
    }
    triangle {
      < 0.314656, 0.131342, 6.743596>,
      < 0.597814, 0.245782, 6.663747>,
      < 0.367301, 0.246109, 6.667394>
    }
    triangle {
      < -0.147685, 0.200725, 6.640157>,
      < 0.110139, 0.226168, 6.655884>,
      < 0.110361, 0.239307, 6.419117>
    }
    triangle {
      < -0.147685, 0.200725, 6.640157>,
      < 0.110361, 0.239307, 6.419117>,
      < -0.176799, 0.205125, 6.420698>
    }
    triangle {
      < 0.110139, 0.226168, 6.655884>,
      < 0.367301, 0.246109, 6.667394>,
      < 0.396812, 0.265779, 6.418013>
    }
    triangle {
      < 0.110139, 0.226168, 6.655884>,
      < 0.396812, 0.265779, 6.418013>,
      < 0.110361, 0.239307, 6.419117>
    }
    triangle {
      < 0.367301, 0.246109, 6.667394>,
      < 0.597814, 0.245782, 6.663747>,
      < 0.653674, 0.263993, 6.418598>
    }
    triangle {
      < 0.367301, 0.246109, 6.667394>,
      < 0.653674, 0.263993, 6.418598>,
      < 0.396812, 0.265779, 6.418013>
    }
    triangle {
      < 0.597814, 0.245782, 6.663747>,
      < 0.819729, 0.232739, 6.650471>,
      < 0.901021, 0.244436, 6.420265>
    }
    triangle {
      < 0.597814, 0.245782, 6.663747>,
      < 0.901021, 0.244436, 6.420265>,
      < 0.653674, 0.263993, 6.418598>
    }
    triangle {
      < 0.819729, 0.232739, 6.650471>,
      < 0.876259, 0.220866, 6.640527>,
      < 0.964073, 0.227467, 6.421430>
    }
    triangle {
      < 0.819729, 0.232739, 6.650471>,
      < 0.964073, 0.227467, 6.421430>,
      < 0.901021, 0.244436, 6.420265>
    }
    triangle {
      < 0.876259, 0.220866, 6.640527>,
      < 0.897291, 0.204720, 6.627828>,
      < 0.987593, 0.204714, 6.422878>
    }
    triangle {
      < 0.876259, 0.220866, 6.640527>,
      < 0.987593, 0.204714, 6.422878>,
      < 0.964073, 0.227467, 6.421430>
    }
    triangle {
      < 0.897291, 0.204720, 6.627828>,
      < 0.895905, 0.188113, 6.615109>,
      < 0.986134, 0.181448, 6.424314>
    }
    triangle {
      < 0.897291, 0.204720, 6.627828>,
      < 0.986134, 0.181448, 6.424314>,
      < 0.987593, 0.204714, 6.422878>
    }
    triangle {
      < 0.895905, 0.188113, 6.615109>,
      < 0.872100, 0.171052, 6.602368>,
      < 0.959697, 0.157667, 6.425735>
    }
    triangle {
      < 0.895905, 0.188113, 6.615109>,
      < 0.959697, 0.157667, 6.425735>,
      < 0.986134, 0.181448, 6.424314>
    }
    triangle {
      < 0.872100, 0.171052, 6.602368>,
      < 0.792375, 0.160809, 6.595684>,
      < 0.870913, 0.143768, 6.426429>
    }
    triangle {
      < 0.872100, 0.171052, 6.602368>,
      < 0.870913, 0.143768, 6.426429>,
      < 0.959697, 0.157667, 6.425735>
    }
    triangle {
      < 0.870913, 0.143768, 6.426429>,
      < 0.792375, 0.160809, 6.595684>,
      < -0.536771, 0.134227, 6.594863>
    }
    triangle {
      < 0.870913, 0.143768, 6.426429>,
      < -0.536771, 0.134227, 6.594863>,
      < -0.610013, 0.114151, 6.425516>
    }
    triangle {
      < 0.870913, 0.143768, 6.426429>,
      < -0.610013, 0.114151, 6.425516>,
      < -0.013276, 0.126090, 6.425924>
    }
    triangle {
      < -0.536771, 0.134227, 6.594863>,
      < -0.552124, 0.144701, 6.603128>,
      < -0.610315, 0.129259, 6.424582>
    }
    triangle {
      < -0.536771, 0.134227, 6.594863>,
      < -0.610315, 0.129259, 6.424582>,
      < -0.610013, 0.114151, 6.425516>
    }
    triangle {
      < -0.552124, 0.144701, 6.603128>,
      < -0.522957, 0.149537, 6.606410>,
      < -0.542475, 0.136579, 6.424255>
    }
    triangle {
      < -0.552124, 0.144701, 6.603128>,
      < -0.542475, 0.136579, 6.424255>,
      < -0.610315, 0.129259, 6.424582>
    }
    triangle {
      < -0.522957, 0.149537, 6.606410>,
      < -0.444202, 0.160064, 6.613326>,
      < -0.465733, 0.150660, 6.423526>
    }
    triangle {
      < -0.522957, 0.149537, 6.606410>,
      < -0.465733, 0.150660, 6.423526>,
      < -0.542475, 0.136579, 6.424255>
    }
    triangle {
      < -0.444202, 0.160064, 6.613326>,
      < -0.373533, 0.173714, 6.622760>,
      < -0.396904, 0.169192, 6.422510>
    }
    triangle {
      < -0.444202, 0.160064, 6.613326>,
      < -0.396904, 0.169192, 6.422510>,
      < -0.465733, 0.150660, 6.423526>
    }
    triangle {
      < -0.373533, 0.173714, 6.622760>,
      < -0.296013, 0.183826, 6.629373>,
      < -0.321362, 0.182704, 6.421815>
    }
    triangle {
      < -0.373533, 0.173714, 6.622760>,
      < -0.321362, 0.182704, 6.421815>,
      < -0.396904, 0.169192, 6.422510>
    }
    triangle {
      < -0.296013, 0.183826, 6.629373>,
      < -0.224023, 0.193572, 6.635793>,
      < -0.251214, 0.195750, 6.421139>
    }
    triangle {
      < -0.296013, 0.183826, 6.629373>,
      < -0.251214, 0.195750, 6.421139>,
      < -0.321362, 0.182704, 6.421815>
    }
    triangle {
      < -0.224023, 0.193572, 6.635793>,
      < -0.147685, 0.200725, 6.640157>,
      < -0.176799, 0.205125, 6.420698>
    }
    triangle {
      < -0.224023, 0.193572, 6.635793>,
      < -0.176799, 0.205125, 6.420698>,
      < -0.251214, 0.195750, 6.421139>
    }
    triangle {
      < 0.177954, -0.234646, 2.095486>,
      < 0.598861, -0.195756, 2.095693>,
      < 0.605634, -0.219087, 1.816123>
    }
    triangle {
      < 0.177954, -0.234646, 2.095486>,
      < 0.605634, -0.219087, 1.816123>,
      < 0.180391, -0.258394, 1.815825>
    }
    triangle {
      < 0.598861, -0.195756, 2.095693>,
      < 0.976308, -0.198405, 2.095681>,
      < 0.986951, -0.221714, 1.816345>
    }
    triangle {
      < 0.598861, -0.195756, 2.095693>,
      < 0.986951, -0.221714, 1.816345>,
      < 0.605634, -0.219087, 1.816123>
    }
    triangle {
      < 0.976308, -0.198405, 2.095681>,
      < 1.269829, -0.221644, 2.095538>,
      < 1.343399, -0.233104, 2.025528>
    }
    triangle {
      < 0.976308, -0.198405, 2.095681>,
      < 1.343399, -0.233104, 2.025528>,
      < 1.350548, -0.244866, 1.886493>
    }
    triangle {
      < 0.976308, -0.198405, 2.095681>,
      < 1.350548, -0.244866, 1.886493>,
      < 1.284173, -0.245246, 1.816489>
    }
    triangle {
      < 0.976308, -0.198405, 2.095681>,
      < 1.284173, -0.245246, 1.816489>,
      < 0.986951, -0.221714, 1.816345>
    }
    texture {parts_wings}
  }
  // parts_gearbay
  union {
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.808852, -0.460303, 1.924383>,
      < 1.808576, -0.447002, 1.940288>
    }
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.808576, -0.447002, 1.940288>,
      < 1.808531, -0.445711, 1.971714>
    }
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.808531, -0.445711, 1.971714>,
      < 1.808759, -0.457588, 1.987581>
    }
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.808759, -0.457588, 1.987581>,
      < 1.809158, -0.477546, 1.987540>
    }
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.809158, -0.477546, 1.987540>,
      < 1.809330, -0.485659, 1.971627>
    }
    triangle {
      < 1.809105, -0.472955, 1.924370>,
      < 1.809330, -0.485659, 1.971627>,
      < 1.809348, -0.485622, 1.940259>
    }
    texture {parts_gearbay}
  }
  // parts_wings
  union {
    triangle {
      < -0.256657, -0.423115, 1.908410>,
      < -0.254759, -0.414596, 2.001437>,
      < -0.118120, -0.403385, 2.094525>
    }
    triangle {
      < -0.256657, -0.423115, 1.908410>,
      < -0.118120, -0.403385, 2.094525>,
      < -0.880584, -0.418620, 2.094168>
    }
    triangle {
      < -0.256657, -0.423115, 1.908410>,
      < -0.880584, -0.418620, 2.094168>,
      < -0.889014, -0.444245, 1.814975>
    }
    triangle {
      < -0.256657, -0.423115, 1.908410>,
      < -0.889014, -0.444245, 1.814975>,
      < -0.123813, -0.428941, 1.815447>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.881024, -0.396415, 2.094221>,
      < -0.889462, -0.421810, 1.815001>
    }
    triangle {
      < -0.880584, -0.418620, 2.094168>,
      < -0.889462, -0.421810, 1.815001>,
      < -0.889014, -0.444245, 1.814975>
    }
    triangle {
      < -0.881024, -0.396415, 2.094221>,
      < -0.781333, -0.385649, 2.094365>,
      < -0.788753, -0.410940, 1.815073>
    }
    triangle {
      < -0.881024, -0.396415, 2.094221>,
      < -0.788753, -0.410940, 1.815073>,
      < -0.889462, -0.421810, 1.815001>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.668560, -0.364946, 2.094540>,
      < -0.674828, -0.390029, 1.815166>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.674828, -0.390029, 1.815166>,
      < -0.788753, -0.410940, 1.815073>
    }
    triangle {
      < -0.668560, -0.364946, 2.094540>,
      < -0.567418, -0.337704, 2.094709>,
      < -0.572652, -0.362512, 1.815258>
    }
    triangle {
      < -0.668560, -0.364946, 2.094540>,
      < -0.572652, -0.362512, 1.815258>,
      < -0.674828, -0.390029, 1.815166>
    }
    triangle {
      < -0.567418, -0.337704, 2.094709>,
      < -0.051267, -0.317842, 2.095103>,
      < -0.055362, -0.342447, 1.815587>
    }
    triangle {
      < -0.567418, -0.337704, 2.094709>,
      < -0.055362, -0.342447, 1.815587>,
      < -0.572652, -0.362512, 1.815258>
    }
    triangle {
      < -0.051267, -0.317842, 2.095103>,
      < -0.353336, -0.298664, 2.094998>,
      < -0.356372, -0.323074, 1.815432>
    }
    triangle {
      < -0.051267, -0.317842, 2.095103>,
      < -0.356372, -0.323074, 1.815432>,
      < -0.055362, -0.342447, 1.815587>
    }
    triangle {
      < -0.353336, -0.298664, 2.094998>,
      < -0.243993, -0.284882, 2.095117>,
      < -0.245903, -0.309153, 1.815513>
    }
    triangle {
      < -0.353336, -0.298664, 2.094998>,
      < -0.245903, -0.309153, 1.815513>,
      < -0.356372, -0.323074, 1.815432>
    }
    triangle {
      < -0.243993, -0.284882, 2.095117>,
      < 0.177954, -0.234646, 2.095486>,
      < 0.180391, -0.258394, 1.815825>
    }
    triangle {
      < -0.243993, -0.284882, 2.095117>,
      < 0.180391, -0.258394, 1.815825>,
      < -0.245903, -0.309153, 1.815513>
    }
    triangle {
      < 0.110361, 0.239307, 6.419117>,
      < 0.396812, 0.265779, 6.418013>,
      < 0.598861, -0.195756, 2.095693>
    }
    triangle {
      < 0.110361, 0.239307, 6.419117>,
      < 0.598861, -0.195756, 2.095693>,
      < 0.177954, -0.234646, 2.095486>
    }
    triangle {
      < 0.396812, 0.265779, 6.418013>,
      < 0.653674, 0.263993, 6.418598>,
      < 0.976308, -0.198405, 2.095681>
    }
    triangle {
      < 0.396812, 0.265779, 6.418013>,
      < 0.976308, -0.198405, 2.095681>,
      < 0.598861, -0.195756, 2.095693>
    }
    triangle {
      < 0.653674, 0.263993, 6.418598>,
      < 0.901021, 0.244436, 6.420265>,
      < 1.332758, -0.219613, 2.164931>
    }
    triangle {
      < 0.653674, 0.263993, 6.418598>,
      < 1.332758, -0.219613, 2.164931>,
      < 1.269829, -0.221644, 2.095538>
    }
    triangle {
      < 0.653674, 0.263993, 6.418598>,
      < 1.269829, -0.221644, 2.095538>,
      < 0.976308, -0.198405, 2.095681>
    }
    triangle {
      < 1.332758, -0.219613, 2.164931>,
      < 0.901021, 0.244436, 6.420265>,
      < 0.964073, 0.227467, 6.421430>
    }
    triangle {
      < 1.332758, -0.219613, 2.164931>,
      < 0.964073, 0.227467, 6.421430>,
      < 1.432472, -0.252136, 2.095407>
    }
    triangle {
      < 1.332758, -0.219613, 2.164931>,
      < 1.432472, -0.252136, 2.095407>,
      < 1.370689, -0.235500, 2.095472>
    }
    triangle {
      < 0.964073, 0.227467, 6.421430>,
      < 0.987593, 0.204714, 6.422878>,
      < 1.467049, -0.285581, 2.095315>
    }
    triangle {
      < 0.964073, 0.227467, 6.421430>,
      < 1.467049, -0.285581, 2.095315>,
      < 1.432472, -0.252136, 2.095407>
    }
    triangle {
      < 0.987593, 0.204714, 6.422878>,
      < 0.986134, 0.181448, 6.424314>,
      < 1.464915, -0.319778, 2.095240>
    }
    triangle {
      < 0.987593, 0.204714, 6.422878>,
      < 1.464915, -0.319778, 2.095240>,
      < 1.467049, -0.285581, 2.095315>
    }
    triangle {
      < 0.986134, 0.181448, 6.424314>,
      < 0.959697, 0.157667, 6.425735>,
      < 1.426072, -0.354725, 2.095179>
    }
    triangle {
      < 0.986134, 0.181448, 6.424314>,
      < 1.426072, -0.354725, 2.095179>,
      < 1.464915, -0.319778, 2.095240>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 0.870913, 0.143768, 6.426429>,
      < 1.014235, -0.031352, 4.964720>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.014235, -0.031352, 4.964720>,
      < 1.021802, -0.040599, 4.887544>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.021802, -0.040599, 4.887544>,
      < 1.024837, -0.044305, 4.856603>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.024837, -0.044305, 4.856603>,
      < 1.032404, -0.053552, 4.779426>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.032404, -0.053552, 4.779426>,
      < 1.070821, -0.100492, 4.387614>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.070821, -0.100492, 4.387614>,
      < 1.137739, -0.182258, 3.705126>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.137739, -0.182258, 3.705126>,
      < 1.145314, -0.191512, 3.627879>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.145314, -0.191512, 3.627879>,
      < 1.148354, -0.195228, 3.596868>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.148354, -0.195228, 3.596868>,
      < 1.155929, -0.204483, 3.519621>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.155929, -0.204483, 3.519621>,
      < 1.213764, -0.275150, 2.929769>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.213764, -0.275150, 2.929769>,
      < 1.221331, -0.284395, 2.852600>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.221331, -0.284395, 2.852600>,
      < 1.224365, -0.288101, 2.821665>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.224365, -0.288101, 2.821665>,
      < 1.231930, -0.297347, 2.744495>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.231930, -0.297347, 2.744495>,
      < 1.295596, -0.375138, 2.095187>
    }
    triangle {
      < 0.959697, 0.157667, 6.425735>,
      < 1.295596, -0.375138, 2.095187>,
      < 1.426072, -0.354725, 2.095179>
    }
    triangle {
      < 1.032404, -0.053552, 4.779426>,
      < 0.971763, -0.049209, 4.825014>,
      < 0.062386, -0.068625, 4.814374>
    }
    triangle {
      < 1.032404, -0.053552, 4.779426>,
      < 0.062386, -0.068625, 4.814374>,
      < 0.016235, -0.075266, 4.767378>
    }
    triangle {
      < 1.032404, -0.053552, 4.779426>,
      < 0.016235, -0.075266, 4.767378>,
      < 0.022471, -0.117855, 4.416588>
    }
    triangle {
      < 1.032404, -0.053552, 4.779426>,
      < 0.022471, -0.117855, 4.416588>,
      < 1.070821, -0.100492, 4.387614>
    }
    texture {parts_wings}
  }
  // parts_flaps1
  union {
    triangle {
      < -0.745220, -0.152080, 4.261100>,
      < -0.736098, -0.133140, 4.407556>,
      < -0.610013, 0.114151, 6.425516>
    }
    triangle {
      < -0.745220, -0.152080, 4.261100>,
      < -0.610013, 0.114151, 6.425516>,
      < -0.610315, 0.129259, 6.424582>
    }
    triangle {
      < -0.745220, -0.152080, 4.261100>,
      < -0.610315, 0.129259, 6.424582>,
      < -0.881024, -0.396415, 2.094221>
    }
    triangle {
      < -0.745220, -0.152080, 4.261100>,
      < -0.881024, -0.396415, 2.094221>,
      < -0.880584, -0.418620, 2.094168>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.881024, -0.396415, 2.094221>,
      < -0.610315, 0.129259, 6.424582>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.610315, 0.129259, 6.424582>,
      < -0.542475, 0.136579, 6.424255>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.542475, 0.136579, 6.424255>,
      < -0.465733, 0.150660, 6.423526>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.465733, 0.150660, 6.423526>,
      < -0.396904, 0.169192, 6.422510>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.396904, 0.169192, 6.422510>,
      < -0.321362, 0.182704, 6.421815>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.321362, 0.182704, 6.421815>,
      < -0.251214, 0.195750, 6.421139>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.251214, 0.195750, 6.421139>,
      < -0.176799, 0.205125, 6.420698>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.176799, 0.205125, 6.420698>,
      < 0.110361, 0.239307, 6.419117>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < 0.110361, 0.239307, 6.419117>,
      < 0.177954, -0.234646, 2.095486>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < 0.177954, -0.234646, 2.095486>,
      < -0.243993, -0.284882, 2.095117>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.243993, -0.284882, 2.095117>,
      < -0.353336, -0.298664, 2.094998>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.353336, -0.298664, 2.094998>,
      < -0.051267, -0.317842, 2.095103>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.051267, -0.317842, 2.095103>,
      < -0.567418, -0.337704, 2.094709>
    }
    triangle {
      < -0.781333, -0.385649, 2.094365>,
      < -0.567418, -0.337704, 2.094709>,
      < -0.668560, -0.364946, 2.094540>
    }
    texture {parts_flaps1}
  }
  // parts_fuselage
  union {
    triangle {
      < -0.887305, -0.494883, 0.686611>,
      < -0.887756, -0.472394, 0.686638>,
      < -0.926060, -0.462096, 0.612714>
    }
    triangle {
      < -0.887305, -0.494883, 0.686611>,
      < -0.926060, -0.462096, 0.612714>,
      < -0.919488, -0.495432, 0.605877>
    }
    triangle {
      < 1.311164, -0.450915, 0.687966>,
      < -0.887305, -0.494883, 0.686611>,
      < -0.919488, -0.495432, 0.605877>
    }
    triangle {
      < 1.311164, -0.450915, 0.687966>,
      < -0.919488, -0.495432, 0.605877>,
      < 1.311291, -0.451855, 0.594307>
    }
    triangle {
      < 1.442965, -0.430235, 0.688069>,
      < 1.311164, -0.450915, 0.687966>,
      < 1.311291, -0.451855, 0.594307>
    }
    triangle {
      < 1.442965, -0.430235, 0.688069>,
      < 1.311291, -0.451855, 0.594307>,
      < 1.445411, -0.436911, 0.593266>
    }
    triangle {
      < 1.482207, -0.394838, 0.688134>,
      < 1.442965, -0.430235, 0.688069>,
      < 1.445411, -0.436911, 0.593266>
    }
    triangle {
      < 1.482207, -0.394838, 0.688134>,
      < 1.445411, -0.436911, 0.593266>,
      < 1.500433, -0.399452, 0.598182>
    }
    triangle {
      < 1.484389, -0.361180, 0.688176>,
      < 1.482207, -0.394838, 0.688134>,
      < 1.500433, -0.399452, 0.598182>
    }
    triangle {
      < 1.484389, -0.361180, 0.688176>,
      < 1.500433, -0.399452, 0.598182>,
      < 1.504556, -0.369324, 0.599055>
    }
    triangle {
      < 1.449485, -0.328018, 0.688194>,
      < 1.484389, -0.361180, 0.688176>,
      < 1.504556, -0.369324, 0.599055>
    }
    triangle {
      < 1.449485, -0.328018, 0.688194>,
      < 1.504556, -0.369324, 0.599055>,
      < 1.455598, -0.317628, 0.596380>
    }
    triangle {
      < 1.355846, -0.301069, 0.688170>,
      < 1.449485, -0.328018, 0.688194>,
      < 1.455598, -0.317628, 0.596380>
    }
    triangle {
      < 1.355846, -0.301069, 0.688170>,
      < 1.455598, -0.317628, 0.596380>,
      < 1.357304, -0.285857, 0.596371>
    }
    triangle {
      < 0.988647, -0.271751, 0.687987>,
      < 1.355846, -0.301069, 0.688170>,
      < 1.357304, -0.285857, 0.596371>
    }
    triangle {
      < 0.988647, -0.271751, 0.687987>,
      < 1.357304, -0.285857, 0.596371>,
      < 0.988805, -0.238950, 0.596626>
    }
    triangle {
      < 0.607333, -0.269259, 0.687764>,
      < 0.988647, -0.271751, 0.687987>,
      < 0.988805, -0.238950, 0.596626>
    }
    triangle {
      < 0.607333, -0.269259, 0.687764>,
      < 0.988805, -0.238950, 0.596626>,
      < 0.605983, -0.221162, 0.600279>
    }
    triangle {
      < 0.182091, -0.308641, 0.687467>,
      < 0.607333, -0.269259, 0.687764>,
      < 0.605983, -0.221162, 0.600279>
    }
    triangle {
      < 0.182091, -0.308641, 0.687467>,
      < 0.605983, -0.221162, 0.600279>,
      < 0.178855, -0.261722, 0.607080>
    }
    triangle {
      < -0.244202, -0.359499, 0.687154>,
      < 0.182091, -0.308641, 0.687467>,
      < 0.178855, -0.261722, 0.607080>
    }
    triangle {
      < -0.244202, -0.359499, 0.687154>,
      < 0.178855, -0.261722, 0.607080>,
      < -0.240576, -0.313612, 0.614276>
    }
    triangle {
      < -0.354670, -0.373449, 0.687071>,
      < -0.244202, -0.359499, 0.687154>,
      < -0.240576, -0.313612, 0.614276>
    }
    triangle {
      < -0.354670, -0.373449, 0.687071>,
      < -0.240576, -0.313612, 0.614276>,
      < -0.358112, -0.326856, 0.615007>
    }
    triangle {
      < -0.053658, -0.392863, 0.687227>,
      < -0.354670, -0.373449, 0.687071>,
      < -0.358112, -0.326856, 0.615007>
    }
    triangle {
      < -0.053658, -0.392863, 0.687227>,
      < -0.358112, -0.326856, 0.615007>,
      < -0.468378, -0.346642, 0.615979>
    }
    triangle {
      < -0.570948, -0.412970, 0.686896>,
      < -0.053658, -0.392863, 0.687227>,
      < -0.468378, -0.346642, 0.615979>
    }
    triangle {
      < -0.570948, -0.412970, 0.686896>,
      < -0.468378, -0.346642, 0.615979>,
      < -0.586994, -0.368787, 0.616561>
    }
    triangle {
      < -0.673123, -0.440548, 0.686803>,
      < -0.570948, -0.412970, 0.686896>,
      < -0.586994, -0.368787, 0.616561>
    }
    triangle {
      < -0.673123, -0.440548, 0.686803>,
      < -0.586994, -0.368787, 0.616561>,
      < -0.680885, -0.393662, 0.616019>
    }
    triangle {
      < -0.787046, -0.461503, 0.686710>,
      < -0.673123, -0.440548, 0.686803>,
      < -0.680885, -0.393662, 0.616019>
    }
    triangle {
      < -0.787046, -0.461503, 0.686710>,
      < -0.680885, -0.393662, 0.616019>,
      < -0.792056, -0.415257, 0.614399>
    }
    triangle {
      < -0.887756, -0.472394, 0.686638>,
      < -0.787046, -0.461503, 0.686710>,
      < -0.792056, -0.415257, 0.614399>
    }
    triangle {
      < -0.887756, -0.472394, 0.686638>,
      < -0.792056, -0.415257, 0.614399>,
      < -0.940982, -0.447601, 0.605459>
    }
    triangle {
      < -0.926060, -0.462096, 0.612714>,
      < -0.887756, -0.472394, 0.686638>,
      < -0.940982, -0.447601, 0.605459>
    }
    texture {parts_fuselage}
  }
  // parts_wings
  union {
    triangle {
      < -0.889462, -0.421810, 1.815001>,
      < -0.788753, -0.410940, 1.815073>,
      < -0.787046, -0.461503, 0.686710>
    }
    triangle {
      < -0.889462, -0.421810, 1.815001>,
      < -0.787046, -0.461503, 0.686710>,
      < -0.887756, -0.472394, 0.686638>
    }
    triangle {
      < -0.788753, -0.410940, 1.815073>,
      < -0.674828, -0.390029, 1.815166>,
      < -0.673123, -0.440548, 0.686803>
    }
    triangle {
      < -0.788753, -0.410940, 1.815073>,
      < -0.673123, -0.440548, 0.686803>,
      < -0.787046, -0.461503, 0.686710>
    }
    triangle {
      < -0.674828, -0.390029, 1.815166>,
      < -0.572652, -0.362512, 1.815258>,
      < -0.570948, -0.412970, 0.686896>
    }
    triangle {
      < -0.674828, -0.390029, 1.815166>,
      < -0.570948, -0.412970, 0.686896>,
      < -0.673123, -0.440548, 0.686803>
    }
    triangle {
      < -0.572652, -0.362512, 1.815258>,
      < -0.055362, -0.342447, 1.815587>,
      < -0.053658, -0.392863, 0.687227>
    }
    triangle {
      < -0.572652, -0.362512, 1.815258>,
      < -0.053658, -0.392863, 0.687227>,
      < -0.570948, -0.412970, 0.686896>
    }
    triangle {
      < -0.055362, -0.342447, 1.815587>,
      < -0.356372, -0.323074, 1.815432>,
      < -0.354670, -0.373449, 0.687071>
    }
    triangle {
      < -0.055362, -0.342447, 1.815587>,
      < -0.354670, -0.373449, 0.687071>,
      < -0.053658, -0.392863, 0.687227>
    }
    triangle {
      < -0.356372, -0.323074, 1.815432>,
      < -0.245903, -0.309153, 1.815513>,
      < -0.244202, -0.359499, 0.687154>
    }
    triangle {
      < -0.356372, -0.323074, 1.815432>,
      < -0.244202, -0.359499, 0.687154>,
      < -0.354670, -0.373449, 0.687071>
    }
    triangle {
      < -0.245903, -0.309153, 1.815513>,
      < 0.180391, -0.258394, 1.815825>,
      < 0.182091, -0.308641, 0.687467>
    }
    triangle {
      < -0.245903, -0.309153, 1.815513>,
      < 0.182091, -0.308641, 0.687467>,
      < -0.244202, -0.359499, 0.687154>
    }
    triangle {
      < 0.180391, -0.258394, 1.815825>,
      < 0.605634, -0.219087, 1.816123>,
      < 0.607333, -0.269259, 0.687764>
    }
    triangle {
      < 0.180391, -0.258394, 1.815825>,
      < 0.607333, -0.269259, 0.687764>,
      < 0.182091, -0.308641, 0.687467>
    }
    triangle {
      < 0.605634, -0.219087, 1.816123>,
      < 0.986951, -0.221714, 1.816345>,
      < 0.988647, -0.271751, 0.687987>
    }
    triangle {
      < 0.605634, -0.219087, 1.816123>,
      < 0.988647, -0.271751, 0.687987>,
      < 0.607333, -0.269259, 0.687764>
    }
    triangle {
      < 0.986951, -0.221714, 1.816345>,
      < 1.284173, -0.245246, 1.816489>,
      < 1.354251, -0.253910, 1.746400>
    }
    triangle {
      < 0.986951, -0.221714, 1.816345>,
      < 1.354251, -0.253910, 1.746400>,
      < 1.355846, -0.301069, 0.688170>
    }
    triangle {
      < 0.986951, -0.221714, 1.816345>,
      < 1.355846, -0.301069, 0.688170>,
      < 0.988647, -0.271751, 0.687987>
    }
    triangle {
      < 1.354251, -0.253910, 1.746400>,
      < 1.385345, -0.259265, 1.816537>,
      < 1.447753, -0.276226, 1.816565>
    }
    triangle {
      < 1.354251, -0.253910, 1.746400>,
      < 1.447753, -0.276226, 1.816565>,
      < 1.449485, -0.328018, 0.688194>
    }
    triangle {
      < 1.354251, -0.253910, 1.746400>,
      < 1.449485, -0.328018, 0.688194>,
      < 1.355846, -0.301069, 0.688170>
    }
    triangle {
      < 1.447753, -0.276226, 1.816565>,
      < 1.482669, -0.309913, 1.816542>,
      < 1.484389, -0.361180, 0.688176>
    }
    triangle {
      < 1.447753, -0.276226, 1.816565>,
      < 1.484389, -0.361180, 0.688176>,
      < 1.449485, -0.328018, 0.688194>
    }
    triangle {
      < 1.482669, -0.309913, 1.816542>,
      < 1.480502, -0.344325, 1.816494>,
      < 1.482207, -0.394838, 0.688134>
    }
    triangle {
      < 1.482669, -0.309913, 1.816542>,
      < 1.482207, -0.394838, 0.688134>,
      < 1.484389, -0.361180, 0.688176>
    }
    triangle {
      < 1.480502, -0.344325, 1.816494>,
      < 1.441257, -0.379639, 1.816431>,
      < 1.442965, -0.430235, 0.688069>
    }
    triangle {
      < 1.480502, -0.344325, 1.816494>,
      < 1.442965, -0.430235, 0.688069>,
      < 1.482207, -0.394838, 0.688134>
    }
    triangle {
      < 1.441257, -0.379639, 1.816431>,
      < 1.309456, -0.400276, 1.816330>,
      < 1.310169, -0.421400, 1.345644>
    }
    triangle {
      < 1.441257, -0.379639, 1.816431>,
      < 1.310169, -0.421400, 1.345644>,
      < 1.310287, -0.424896, 1.267733>
    }
    triangle {
      < 1.441257, -0.379639, 1.816431>,
      < 1.310287, -0.424896, 1.267733>,
      < 1.310333, -0.426295, 1.236563>
    }
    triangle {
      < 1.441257, -0.379639, 1.816431>,
      < 1.310333, -0.426295, 1.236563>,
      < 1.310451, -0.429792, 1.158653>
    }
    triangle {
      < 1.441257, -0.379639, 1.816431>,
      < 1.310451, -0.429792, 1.158653>,
      < 1.311164, -0.450915, 0.687966>
    }
    triangle {
      < 1.441257, -0.379639, 1.816431>,
      < 1.311164, -0.450915, 0.687966>,
      < 1.442965, -0.430235, 0.688069>
    }
    triangle {
      < 1.310451, -0.429792, 1.158653>,
      < 1.249941, -0.428902, 1.205363>,
      < -0.203080, -0.457962, 1.204468>
    }
    triangle {
      < 1.310451, -0.429792, 1.158653>,
      < -0.203080, -0.457962, 1.204468>,
      < -0.265572, -0.458512, 1.220010>
    }
    triangle {
      < 1.310451, -0.429792, 1.158653>,
      < -0.265572, -0.458512, 1.220010>,
      < -0.296812, -0.457737, 1.251158>
    }
    triangle {
      < 1.310451, -0.429792, 1.158653>,
      < -0.296812, -0.457737, 1.251158>,
      < -0.888160, -0.469564, 1.250793>
    }
    triangle {
      < 1.310451, -0.429792, 1.158653>,
      < -0.888160, -0.469564, 1.250793>,
      < -0.887305, -0.494883, 0.686611>
    }
    triangle {
      < 1.310451, -0.429792, 1.158653>,
      < -0.887305, -0.494883, 0.686611>,
      < 1.311164, -0.450915, 0.687966>
    }
    triangle {
      < -0.888160, -0.469564, 1.250793>,
      < -0.889014, -0.444245, 1.814975>,
      < -0.889462, -0.421810, 1.815001>
    }
    triangle {
      < -0.888160, -0.469564, 1.250793>,
      < -0.889462, -0.421810, 1.815001>,
      < -0.887756, -0.472394, 0.686638>
    }
    triangle {
      < -0.888160, -0.469564, 1.250793>,
      < -0.887756, -0.472394, 0.686638>,
      < -0.887305, -0.494883, 0.686611>
    }
    texture {parts_wings}
  }
  // parts_fuselage
  union {
    triangle {
      < -1.225343, -0.476197, 0.421323>,
      < -0.919488, -0.495432, 0.605877>,
      < -0.926060, -0.462096, 0.612714>
    }
    triangle {
      < -1.225343, -0.476197, 0.421323>,
      < -0.926060, -0.462096, 0.612714>,
      < -1.226950, -0.398034, 0.492189>
    }
    triangle {
      < 1.445411, -0.436911, 0.593266>,
      < 1.311291, -0.451855, 0.594307>,
      < 1.382392, -0.449179, 0.422901>
    }
    triangle {
      < 1.445411, -0.436911, 0.593266>,
      < 1.382392, -0.449179, 0.422901>,
      < 1.518077, -0.427907, 0.439334>
    }
    triangle {
      < 1.311291, -0.451855, 0.594307>,
      < -0.919488, -0.495432, 0.605877>,
      < -1.225343, -0.476197, 0.421323>
    }
    triangle {
      < 1.311291, -0.451855, 0.594307>,
      < -1.225343, -0.476197, 0.421323>,
      < 1.382392, -0.449179, 0.422901>
    }
    triangle {
      < -0.926060, -0.462096, 0.612714>,
      < -0.940982, -0.447601, 0.605459>,
      < -1.229021, -0.294888, 0.504673>
    }
    triangle {
      < -0.926060, -0.462096, 0.612714>,
      < -1.229021, -0.294888, 0.504673>,
      < -1.226950, -0.398034, 0.492189>
    }
    triangle {
      < -0.940982, -0.447601, 0.605459>,
      < -0.792056, -0.415257, 0.614399>,
      < -0.963987, -0.166429, 0.501568>
    }
    triangle {
      < -0.940982, -0.447601, 0.605459>,
      < -0.963987, -0.166429, 0.501568>,
      < -1.229021, -0.294888, 0.504673>
    }
    triangle {
      < -0.792056, -0.415257, 0.614399>,
      < -0.680885, -0.393662, 0.616019>,
      < -0.809941, -0.091102, 0.497015>
    }
    triangle {
      < -0.792056, -0.415257, 0.614399>,
      < -0.809941, -0.091102, 0.497015>,
      < -0.963987, -0.166429, 0.501568>
    }
    triangle {
      < -0.680885, -0.393662, 0.616019>,
      < -0.586994, -0.368787, 0.616561>,
      < -0.671206, -0.040574, 0.496355>
    }
    triangle {
      < -0.680885, -0.393662, 0.616019>,
      < -0.671206, -0.040574, 0.496355>,
      < -0.809941, -0.091102, 0.497015>
    }
    triangle {
      < -0.586994, -0.368787, 0.616561>,
      < -0.468378, -0.346642, 0.615979>,
      < -0.518942, 0.001439, 0.494464>
    }
    triangle {
      < -0.586994, -0.368787, 0.616561>,
      < -0.518942, 0.001439, 0.494464>,
      < -0.671206, -0.040574, 0.496355>
    }
    triangle {
      < -0.468378, -0.346642, 0.615979>,
      < -0.358112, -0.326856, 0.615007>,
      < -0.376999, 0.013815, 0.495009>
    }
    triangle {
      < -0.468378, -0.346642, 0.615979>,
      < -0.376999, 0.013815, 0.495009>,
      < -0.518942, 0.001439, 0.494464>
    }
    triangle {
      < -0.358112, -0.326856, 0.615007>,
      < -0.240576, -0.313612, 0.614276>,
      < -0.226400, 0.016774, 0.494345>
    }
    triangle {
      < -0.358112, -0.326856, 0.615007>,
      < -0.226400, 0.016774, 0.494345>,
      < -0.376999, 0.013815, 0.495009>
    }
    triangle {
      < -0.240576, -0.313612, 0.614276>,
      < 0.178855, -0.261722, 0.607080>,
      < 0.214773, -0.045399, 0.497611>
    }
    triangle {
      < -0.240576, -0.313612, 0.614276>,
      < 0.214773, -0.045399, 0.497611>,
      < -0.226400, 0.016774, 0.494345>
    }
    triangle {
      < 0.178855, -0.261722, 0.607080>,
      < 0.605983, -0.221162, 0.600279>,
      < 0.654799, -0.116009, 0.499625>
    }
    triangle {
      < 0.178855, -0.261722, 0.607080>,
      < 0.654799, -0.116009, 0.499625>,
      < 0.214773, -0.045399, 0.497611>
    }
    triangle {
      < 0.605983, -0.221162, 0.600279>,
      < 0.988805, -0.238950, 0.596626>,
      < 1.048821, -0.190768, 0.503228>
    }
    triangle {
      < 0.605983, -0.221162, 0.600279>,
      < 1.048821, -0.190768, 0.503228>,
      < 0.654799, -0.116009, 0.499625>
    }
    triangle {
      < 0.988805, -0.238950, 0.596626>,
      < 1.357304, -0.285857, 0.596371>,
      < 1.427877, -0.271556, 0.505487>
    }
    triangle {
      < 0.988805, -0.238950, 0.596626>,
      < 1.427877, -0.271556, 0.505487>,
      < 1.048821, -0.190768, 0.503228>
    }
    triangle {
      < 1.357304, -0.285857, 0.596371>,
      < 1.455598, -0.317628, 0.596380>,
      < 1.524913, -0.330742, 0.499687>
    }
    triangle {
      < 1.357304, -0.285857, 0.596371>,
      < 1.524913, -0.330742, 0.499687>,
      < 1.427877, -0.271556, 0.505487>
    }
    triangle {
      < 1.455598, -0.317628, 0.596380>,
      < 1.504556, -0.369324, 0.599055>,
      < 1.560920, -0.367737, 0.479587>
    }
    triangle {
      < 1.455598, -0.317628, 0.596380>,
      < 1.560920, -0.367737, 0.479587>,
      < 1.524913, -0.330742, 0.499687>
    }
    triangle {
      < 1.504556, -0.369324, 0.599055>,
      < 1.500433, -0.399452, 0.598182>,
      < 1.558589, -0.397582, 0.459472>
    }
    triangle {
      < 1.504556, -0.369324, 0.599055>,
      < 1.558589, -0.397582, 0.459472>,
      < 1.560920, -0.367737, 0.479587>
    }
    triangle {
      < 1.500433, -0.399452, 0.598182>,
      < 1.445411, -0.436911, 0.593266>,
      < 1.518077, -0.427907, 0.439334>
    }
    triangle {
      < 1.500433, -0.399452, 0.598182>,
      < 1.518077, -0.427907, 0.439334>,
      < 1.558589, -0.397582, 0.459472>
    }
    triangle {
      < 1.382392, -0.449179, 0.422901>,
      < 1.539992, -0.446028, 0.422997>,
      < 1.518077, -0.427907, 0.439334>
    }
    triangle {
      < 1.560920, -0.367737, 0.479587>,
      < 1.565163, -0.321606, 0.502176>,
      < 1.536890, -0.293490, 0.506314>
    }
    triangle {
      < 1.560920, -0.367737, 0.479587>,
      < 1.536890, -0.293490, 0.506314>,
      < 1.524913, -0.330742, 0.499687>
    }
    triangle {
      < 1.427877, -0.271556, 0.505487>,
      < 1.524913, -0.330742, 0.499687>,
      < 1.536890, -0.293490, 0.506314>
    }
    triangle {
      < 1.594260, -0.390096, 0.470279>,
      < 1.621394, -0.362130, 0.493920>,
      < 1.593322, -0.344073, 0.498045>
    }
    triangle {
      < 1.594260, -0.390096, 0.470279>,
      < 1.593322, -0.344073, 0.498045>,
      < 1.565163, -0.321606, 0.502176>
    }
    triangle {
      < 1.594260, -0.390096, 0.470279>,
      < 1.565163, -0.321606, 0.502176>,
      < 1.560920, -0.367737, 0.479587>
    }
    triangle {
      < 1.594260, -0.390096, 0.470279>,
      < 1.560920, -0.367737, 0.479587>,
      < 1.558589, -0.397582, 0.459472>
    }
    triangle {
      < 1.594260, -0.390096, 0.470279>,
      < 1.558589, -0.397582, 0.459472>,
      < 1.567126, -0.418061, 0.446638>
    }
    texture {parts_fuselage}
  }
  // parts_wings
  union {
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.511120, 0.065107, 6.723131>,
      < 0.483092, 0.066937, 6.730906>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.483092, 0.066937, 6.730906>,
      < 0.372855, 0.067951, 6.741307>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.372855, 0.067951, 6.741307>,
      < 0.258267, 0.066565, 6.744197>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.258267, 0.066565, 6.744197>,
      < 0.130305, 0.061283, 6.735254>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.130305, 0.061283, 6.735254>,
      < 0.021237, 0.055369, 6.723034>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.021237, 0.055369, 6.723034>,
      < -0.018208, 0.053545, 6.719640>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < -0.018208, 0.053545, 6.719640>,
      < -0.055422, 0.051274, 6.714639>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < -0.055422, 0.051274, 6.714639>,
      < -0.095493, 0.048896, 6.709485>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < -0.095493, 0.048896, 6.709485>,
      < -0.132054, 0.045914, 6.702135>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < -0.132054, 0.045914, 6.702135>,
      < -0.172764, 0.043452, 6.696744>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < -0.172764, 0.043452, 6.696744>,
      < -0.208716, 0.041951, 6.694173>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < -0.208716, 0.041951, 6.694173>,
      < -0.140139, 0.041339, 6.687759>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < -0.140139, 0.041339, 6.687759>,
      < 0.469053, 0.053522, 6.688135>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.469053, 0.053522, 6.688135>,
      < 0.508749, 0.055907, 6.693340>
    }
    triangle {
      < 0.521477, 0.062266, 6.713212>,
      < 0.508749, 0.055907, 6.693340>,
      < 0.520686, 0.059198, 6.703282>
    }
    texture {parts_wings}
  }
  // parts_fuselage
  union {
    triangle {
      < -1.246713, 0.603358, 0.064425>,
      < -1.246645, 0.598365, 0.115219>,
      < 1.515934, 0.765932, 0.128826>
    }
    triangle {
      < -1.246713, 0.603358, 0.064425>,
      < 1.515934, 0.765932, 0.128826>,
      < 1.515869, 0.770931, 0.072935>
    }
    triangle {
      < -1.246645, 0.598365, 0.115219>,
      < -1.246555, 0.591830, 0.181695>,
      < 1.516021, 0.759388, 0.201977>
    }
    triangle {
      < -1.246645, 0.598365, 0.115219>,
      < 1.516021, 0.759388, 0.201977>,
      < 1.515934, 0.765932, 0.128826>
    }
    triangle {
      < -1.246555, 0.591830, 0.181695>,
      < -1.178287, 0.542251, 0.283445>,
      < 1.517025, 0.705719, 0.313132>
    }
    triangle {
      < -1.246555, 0.591830, 0.181695>,
      < 1.517025, 0.705719, 0.313132>,
      < 1.516021, 0.759388, 0.201977>
    }
    triangle {
      < -1.178287, 0.542251, 0.283445>,
      < -1.243800, 0.448991, 0.346918>,
      < 1.518766, 0.616529, 0.383802>
    }
    triangle {
      < -1.178287, 0.542251, 0.283445>,
      < 1.518766, 0.616529, 0.383802>,
      < 1.517025, 0.705719, 0.313132>
    }
    triangle {
      < -1.243800, 0.448991, 0.346918>,
      < -1.239512, 0.231039, 0.462595>,
      < 1.523074, 0.398619, 0.464431>
    }
    triangle {
      < -1.243800, 0.448991, 0.346918>,
      < 1.523074, 0.398619, 0.464431>,
      < 1.518766, 0.616529, 0.383802>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < -1.229021, -0.294888, 0.504673>,
      < -0.963987, -0.166429, 0.501568>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < -0.963987, -0.166429, 0.501568>,
      < -0.809941, -0.091102, 0.497015>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < -0.809941, -0.091102, 0.497015>,
      < -0.671206, -0.040574, 0.496355>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < -0.671206, -0.040574, 0.496355>,
      < -0.518942, 0.001439, 0.494464>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < -0.518942, 0.001439, 0.494464>,
      < -0.376999, 0.013815, 0.495009>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < -0.376999, 0.013815, 0.495009>,
      < -0.226400, 0.016774, 0.494345>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < -0.226400, 0.016774, 0.494345>,
      < 0.214773, -0.045399, 0.497611>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < 0.214773, -0.045399, 0.497611>,
      < 0.654799, -0.116009, 0.499625>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < 0.654799, -0.116009, 0.499625>,
      < 1.048821, -0.190768, 0.503228>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < 1.048821, -0.190768, 0.503228>,
      < 1.427877, -0.271556, 0.505487>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < 1.427877, -0.271556, 0.505487>,
      < 1.536890, -0.293490, 0.506314>
    }
    triangle {
      < -1.239512, 0.231039, 0.462595>,
      < 1.536890, -0.293490, 0.506314>,
      < 1.523074, 0.398619, 0.464431>
    }
    triangle {
      < 1.518077, -0.427907, 0.439334>,
      < 1.539992, -0.446028, 0.422997>,
      < 1.567126, -0.418061, 0.446638>
    }
    triangle {
      < 1.518077, -0.427907, 0.439334>,
      < 1.567126, -0.418061, 0.446638>,
      < 1.558589, -0.397582, 0.459472>
    }
    triangle {
      < 1.382392, -0.449179, 0.422901>,
      < -1.225343, -0.476197, 0.421323>,
      < -1.224787, -0.494007, 0.097761>
    }
    triangle {
      < 1.382392, -0.449179, 0.422901>,
      < -1.224787, -0.494007, 0.097761>,
      < 1.541123, -0.492610, 0.099401>
    }
    triangle {
      < 1.382392, -0.449179, 0.422901>,
      < 1.541123, -0.492610, 0.099401>,
      < 1.539992, -0.446028, 0.422997>
    }
    triangle {
      < -1.246803, 0.609891, -0.001061>,
      < -1.246713, 0.603358, 0.064425>,
      < 1.515869, 0.770931, 0.072935>
    }
    triangle {
      < -1.246803, 0.609891, -0.001061>,
      < 1.515869, 0.770931, 0.072935>,
      < 1.515782, 0.777472, 0.000775>
    }
    triangle {
      < 1.515782, 0.777472, 0.000775>,
      < 1.515869, 0.770931, 0.072935>,
      < 3.182013, 0.832010, 0.074272>
    }
    triangle {
      < 1.515782, 0.777472, 0.000775>,
      < 3.182013, 0.832010, 0.074272>,
      < 3.181923, 0.838687, 0.002113>
    }
    triangle {
      < 1.515869, 0.770931, 0.072935>,
      < 1.515934, 0.765932, 0.128826>,
      < 3.182080, 0.826907, 0.130164>
    }
    triangle {
      < 1.515869, 0.770931, 0.072935>,
      < 3.182080, 0.826907, 0.130164>,
      < 3.182013, 0.832010, 0.074272>
    }
    triangle {
      < 1.515934, 0.765932, 0.128826>,
      < 1.516021, 0.759388, 0.201977>,
      < 3.182169, 0.820228, 0.203313>
    }
    triangle {
      < 1.515934, 0.765932, 0.128826>,
      < 3.182169, 0.820228, 0.203313>,
      < 3.182080, 0.826907, 0.130164>
    }
    triangle {
      < 1.516021, 0.759388, 0.201977>,
      < 1.517025, 0.705719, 0.313132>,
      < 3.183196, 0.765433, 0.314467>
    }
    triangle {
      < 1.516021, 0.759388, 0.201977>,
      < 3.183196, 0.765433, 0.314467>,
      < 3.182169, 0.820228, 0.203313>
    }
    triangle {
      < 1.517025, 0.705719, 0.313132>,
      < 1.518766, 0.616529, 0.383802>,
      < 3.184974, 0.674371, 0.385135>
    }
    triangle {
      < 1.517025, 0.705719, 0.313132>,
      < 3.184974, 0.674371, 0.385135>,
      < 3.183196, 0.765433, 0.314467>
    }
    triangle {
      < 1.518766, 0.616529, 0.383802>,
      < 1.523074, 0.398619, 0.464431>,
      < 3.189373, 0.451885, 0.465759>
    }
    triangle {
      < 1.518766, 0.616529, 0.383802>,
      < 3.189373, 0.451885, 0.465759>,
      < 3.184974, 0.674371, 0.385135>
    }
    triangle {
      < 1.523074, 0.398619, 0.464431>,
      < 1.536890, -0.293490, 0.506314>,
      < 3.204062, -0.283802, 0.507591>
    }
    triangle {
      < 1.523074, 0.398619, 0.464431>,
      < 3.204062, -0.283802, 0.507591>,
      < 3.189373, 0.451885, 0.465759>
    }
    triangle {
      < 1.536890, -0.293490, 0.506314>,
      < 1.565163, -0.321606, 0.502176>,
      < 1.593322, -0.344073, 0.498045>
    }
    triangle {
      < 1.536890, -0.293490, 0.506314>,
      < 1.593322, -0.344073, 0.498045>,
      < 1.621394, -0.362130, 0.493920>
    }
    triangle {
      < 1.536890, -0.293490, 0.506314>,
      < 1.621394, -0.362130, 0.493920>,
      < 3.205281, -0.344439, 0.495156>
    }
    triangle {
      < 1.536890, -0.293490, 0.506314>,
      < 3.205281, -0.344439, 0.495156>,
      < 3.204062, -0.283802, 0.507591>
    }
    triangle {
      < 1.621394, -0.362130, 0.493920>,
      < 1.594260, -0.390096, 0.470279>,
      < 1.567126, -0.418061, 0.446638>
    }
    triangle {
      < 1.621394, -0.362130, 0.493920>,
      < 1.567126, -0.418061, 0.446638>,
      < 1.539992, -0.446028, 0.422997>
    }
    triangle {
      < 1.621394, -0.362130, 0.493920>,
      < 1.539992, -0.446028, 0.422997>,
      < 3.206739, -0.415116, 0.424299>
    }
    triangle {
      < 1.621394, -0.362130, 0.493920>,
      < 3.206739, -0.415116, 0.424299>,
      < 3.205281, -0.344439, 0.495156>
    }
    triangle {
      < 1.539992, -0.446028, 0.422997>,
      < 1.541123, -0.492610, 0.099401>,
      < 3.207739, -0.455167, 0.100711>
    }
    triangle {
      < 1.539992, -0.446028, 0.422997>,
      < 3.207739, -0.455167, 0.100711>,
      < 3.206739, -0.415116, 0.424299>
    }
    triangle {
      < 3.204062, -0.283802, 0.507591>,
      < 3.205281, -0.344439, 0.495156>,
      < 3.441455, -0.339716, 0.495302>
    }
    triangle {
      < 3.204062, -0.283802, 0.507591>,
      < 3.441455, -0.339716, 0.495302>,
      < 3.440234, -0.279079, 0.507736>
    }
    triangle {
      < 3.205281, -0.344439, 0.495156>,
      < 3.206739, -0.415116, 0.424299>,
      < 3.442912, -0.410392, 0.424445>
    }
    triangle {
      < 3.205281, -0.344439, 0.495156>,
      < 3.442912, -0.410392, 0.424445>,
      < 3.441455, -0.339716, 0.495302>
    }
    triangle {
      < 3.206739, -0.415116, 0.424299>,
      < 3.207739, -0.455167, 0.100711>,
      < 3.443912, -0.450444, 0.100856>
    }
    triangle {
      < 3.206739, -0.415116, 0.424299>,
      < 3.443912, -0.450444, 0.100856>,
      < 3.442912, -0.410392, 0.424445>
    }
    triangle {
      < 3.181923, 0.838687, 0.002113>,
      < 3.182013, 0.832010, 0.074272>,
      < 3.418040, 0.843997, 0.074426>
    }
    triangle {
      < 3.181923, 0.838687, 0.002113>,
      < 3.418040, 0.843997, 0.074426>,
      < 3.417936, 0.851397, 0.002268>
    }
    triangle {
      < 3.182013, 0.832010, 0.074272>,
      < 3.182080, 0.826907, 0.130164>,
      < 3.418119, 0.838342, 0.130317>
    }
    triangle {
      < 3.182013, 0.832010, 0.074272>,
      < 3.418119, 0.838342, 0.130317>,
      < 3.418040, 0.843997, 0.074426>
    }
    triangle {
      < 3.182080, 0.826907, 0.130164>,
      < 3.182169, 0.820228, 0.203313>,
      < 3.418222, 0.830941, 0.203466>
    }
    triangle {
      < 3.182080, 0.826907, 0.130164>,
      < 3.418222, 0.830941, 0.203466>,
      < 3.418119, 0.838342, 0.130317>
    }
    triangle {
      < 3.182169, 0.820228, 0.203313>,
      < 3.183196, 0.765433, 0.314467>,
      < 3.419369, 0.770157, 0.314612>
    }
    triangle {
      < 3.182169, 0.820228, 0.203313>,
      < 3.419369, 0.770157, 0.314612>,
      < 3.418222, 0.830941, 0.203466>
    }
    triangle {
      < 3.183196, 0.765433, 0.314467>,
      < 3.184974, 0.674371, 0.385135>,
      < 3.421147, 0.679095, 0.385280>
    }
    triangle {
      < 3.183196, 0.765433, 0.314467>,
      < 3.421147, 0.679095, 0.385280>,
      < 3.419369, 0.770157, 0.314612>
    }
    triangle {
      < 3.184974, 0.674371, 0.385135>,
      < 3.189373, 0.451885, 0.465759>,
      < 3.425547, 0.456609, 0.465905>
    }
    triangle {
      < 3.184974, 0.674371, 0.385135>,
      < 3.425547, 0.456609, 0.465905>,
      < 3.421147, 0.679095, 0.385280>
    }
    triangle {
      < 3.189373, 0.451885, 0.465759>,
      < 3.204062, -0.283802, 0.507591>,
      < 3.440234, -0.279079, 0.507736>
    }
    triangle {
      < 3.189373, 0.451885, 0.465759>,
      < 3.440234, -0.279079, 0.507736>,
      < 3.425547, 0.456609, 0.465905>
    }
    triangle {
      < 5.245904, 0.689209, 0.278819>,
      < 5.400862, 0.660501, 0.315959>,
      < 5.358637, 0.703657, 0.241838>
    }
    triangle {
      < 5.075837, 0.678259, 0.315766>,
      < 5.400862, 0.660501, 0.315959>,
      < 5.245904, 0.689209, 0.278819>
    }
    triangle {
      < 3.650433, 0.777244, 0.260519>,
      < 3.419369, 0.770157, 0.314612>,
      < 3.986677, 0.748022, 0.285947>
    }
    triangle {
      < 3.418222, 0.830941, 0.203466>,
      < 3.419369, 0.770157, 0.314612>,
      < 3.650433, 0.777244, 0.260519>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 4.724340, 1.073383, 0.268163>,
      < 4.633105, 0.798443, 0.297445>,
      < 4.676779, 0.768064, 0.300680>
    }
    triangle {
      < 4.724340, 1.073383, 0.268163>,
      < 4.676779, 0.768064, 0.300680>,
      < 4.768705, 1.040163, 0.274698>
    }
    triangle {
      < 4.771751, 1.049718, 0.271009>,
      < 4.810774, 1.125934, 0.179830>,
      < 4.763298, 1.143357, 0.177774>
    }
    triangle {
      < 4.771751, 1.049718, 0.271009>,
      < 4.763298, 1.143357, 0.177774>,
      < 4.724340, 1.073383, 0.268163>
    }
    triangle {
      < 4.816707, 1.146821, 0.131353>,
      < 4.796057, 1.156596, 0.003709>,
      < 4.748710, 1.175359, 0.003701>
    }
    triangle {
      < 4.816707, 1.146821, 0.131353>,
      < 4.748710, 1.175359, 0.003701>,
      < 4.768553, 1.164607, 0.130071>
    }
    triangle {
      < 4.015025, 1.116888, 0.129188>,
      < 3.418040, 0.843997, 0.074426>,
      < 3.418119, 0.838342, 0.130317>
    }
    triangle {
      < 4.015025, 1.116888, 0.129188>,
      < 3.418119, 0.838342, 0.130317>,
      < 4.016248, 1.102053, 0.182199>
    }
    triangle {
      < 4.613595, 1.187080, 0.130025>,
      < 4.015025, 1.116888, 0.129188>,
      < 4.016248, 1.102053, 0.182199>
    }
    triangle {
      < 4.613595, 1.187080, 0.130025>,
      < 4.016248, 1.102053, 0.182199>,
      < 4.613960, 1.165229, 0.177664>
    }
    triangle {
      < 4.613960, 1.165229, 0.177664>,
      < 4.763298, 1.143357, 0.177774>,
      < 4.768553, 1.164607, 0.130071>
    }
    triangle {
      < 4.613960, 1.165229, 0.177664>,
      < 4.768553, 1.164607, 0.130071>,
      < 4.613595, 1.187080, 0.130025>
    }
    triangle {
      < 4.810774, 1.125934, 0.179830>,
      < 5.386101, 0.715409, 0.217154>,
      < 5.399794, 0.724130, 0.176696>
    }
    triangle {
      < 4.810774, 1.125934, 0.179830>,
      < 5.399794, 0.724130, 0.176696>,
      < 4.816707, 1.146821, 0.131353>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 4.612180, 0.732053, 0.303081>,
      < 4.637608, 0.721666, 0.307683>,
      < 4.676779, 0.768064, 0.300680>
    }
    triangle {
      < 4.612180, 0.732053, 0.303081>,
      < 4.676779, 0.768064, 0.300680>,
      < 4.633105, 0.798443, 0.297445>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 4.768705, 1.040163, 0.274698>,
      < 4.771751, 1.049718, 0.271009>,
      < 4.724340, 1.073383, 0.268163>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 5.400059, 0.707813, 0.229447>,
      < 4.624254, 0.714192, 0.203578>,
      < 5.399794, 0.724130, 0.176696>
    }
    triangle {
      < 5.400059, 0.707813, 0.229447>,
      < 5.399794, 0.724130, 0.176696>,
      < 5.386101, 0.715409, 0.217154>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 4.763298, 1.143357, 0.177774>,
      < 4.810774, 1.125934, 0.179830>,
      < 4.816707, 1.146821, 0.131353>
    }
    triangle {
      < 4.763298, 1.143357, 0.177774>,
      < 4.816707, 1.146821, 0.131353>,
      < 4.768553, 1.164607, 0.130071>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 4.637608, 0.721666, 0.307683>,
      < 4.637954, 0.702182, 0.315507>,
      < 5.075837, 0.678259, 0.315766>
    }
    triangle {
      < 4.637608, 0.721666, 0.307683>,
      < 5.075837, 0.678259, 0.315766>,
      < 4.676779, 0.768064, 0.300680>
    }
    texture {parts_fuselage}
  }
  // parts_cockpit
  union {
    triangle {
      < 4.615642, 1.068729, 0.271936>,
      < 4.633105, 0.798443, 0.297445>,
      < 4.724340, 1.073383, 0.268163>
    }
    triangle {
      < 4.613595, 1.187080, 0.130025>,
      < 4.613523, 1.195118, 0.003634>,
      < 4.045876, 1.128057, 0.003182>
    }
    triangle {
      < 4.613595, 1.187080, 0.130025>,
      < 4.045876, 1.128057, 0.003182>,
      < 4.015025, 1.116888, 0.129188>
    }
    triangle {
      < 4.615642, 1.068729, 0.271936>,
      < 4.613960, 1.165229, 0.177664>,
      < 4.016248, 1.102053, 0.182199>
    }
    triangle {
      < 4.615642, 1.068729, 0.271936>,
      < 4.016248, 1.102053, 0.182199>,
      < 3.981542, 1.046126, 0.271254>
    }
    triangle {
      < 4.612180, 0.732053, 0.303081>,
      < 4.633105, 0.798443, 0.297445>,
      < 4.615642, 1.068729, 0.271936>
    }
    triangle {
      < 4.612180, 0.732053, 0.303081>,
      < 4.615642, 1.068729, 0.271936>,
      < 3.981542, 1.046126, 0.271254>
    }
    triangle {
      < 4.612180, 0.732053, 0.303081>,
      < 3.981542, 1.046126, 0.271254>,
      < 3.986677, 0.748022, 0.285947>
    }
    triangle {
      < 4.768705, 1.040163, 0.274698>,
      < 5.075837, 0.678259, 0.315766>,
      < 5.245904, 0.689209, 0.278819>
    }
    triangle {
      < 4.768705, 1.040163, 0.274698>,
      < 5.245904, 0.689209, 0.278819>,
      < 5.358637, 0.703657, 0.241838>
    }
    triangle {
      < 4.768705, 1.040163, 0.274698>,
      < 5.358637, 0.703657, 0.241838>,
      < 4.771751, 1.049718, 0.271009>
    }
    triangle {
      < 4.771751, 1.049718, 0.271009>,
      < 5.358637, 0.703657, 0.241838>,
      < 5.386101, 0.715409, 0.217154>
    }
    triangle {
      < 4.771751, 1.049718, 0.271009>,
      < 5.386101, 0.715409, 0.217154>,
      < 4.810774, 1.125934, 0.179830>
    }
    triangle {
      < 5.075837, 0.678259, 0.315766>,
      < 4.768705, 1.040163, 0.274698>,
      < 4.676779, 0.768064, 0.300680>
    }
    triangle {
      < 4.615642, 1.068729, 0.271936>,
      < 4.724340, 1.073383, 0.268163>,
      < 4.763298, 1.143357, 0.177774>
    }
    triangle {
      < 4.615642, 1.068729, 0.271936>,
      < 4.763298, 1.143357, 0.177774>,
      < 4.613960, 1.165229, 0.177664>
    }
    triangle {
      < 4.045876, 1.128057, 0.003182>,
      < 3.417936, 0.851397, 0.002268>,
      < 3.418040, 0.843997, 0.074426>
    }
    triangle {
      < 4.045876, 1.128057, 0.003182>,
      < 3.418040, 0.843997, 0.074426>,
      < 4.015025, 1.116888, 0.129188>
    }
    triangle {
      < 3.981542, 1.046126, 0.271254>,
      < 3.418222, 0.830941, 0.203466>,
      < 3.650433, 0.777244, 0.260519>
    }
    triangle {
      < 3.981542, 1.046126, 0.271254>,
      < 3.650433, 0.777244, 0.260519>,
      < 3.986677, 0.748022, 0.285947>
    }
    triangle {
      < 4.748710, 1.175359, 0.003701>,
      < 4.613523, 1.195118, 0.003634>,
      < 4.613595, 1.187080, 0.130025>
    }
    triangle {
      < 4.748710, 1.175359, 0.003701>,
      < 4.613595, 1.187080, 0.130025>,
      < 4.768553, 1.164607, 0.130071>
    }
    triangle {
      < 5.399573, 0.741740, 0.003615>,
      < 4.796057, 1.156596, 0.003709>,
      < 4.816707, 1.146821, 0.131353>
    }
    triangle {
      < 5.399573, 0.741740, 0.003615>,
      < 4.816707, 1.146821, 0.131353>,
      < 5.399794, 0.724130, 0.176696>
    }
    triangle {
      < 3.418119, 0.838342, 0.130317>,
      < 3.418222, 0.830941, 0.203466>,
      < 3.981542, 1.046126, 0.271254>
    }
    triangle {
      < 3.418119, 0.838342, 0.130317>,
      < 3.981542, 1.046126, 0.271254>,
      < 4.016248, 1.102053, 0.182199>
    }
    texture {parts_cockpit}
  }
  // parts_fuselage
  union {
    triangle {
      < 4.637954, 0.702182, 0.315507>,
      < 4.637608, 0.721666, 0.307683>,
      < 4.612180, 0.732053, 0.303081>
    }
    triangle {
      < 4.637954, 0.702182, 0.315507>,
      < 4.612180, 0.732053, 0.303081>,
      < 3.986677, 0.748022, 0.285947>
    }
    triangle {
      < 4.637954, 0.702182, 0.315507>,
      < 3.986677, 0.748022, 0.285947>,
      < 3.419369, 0.770157, 0.314612>
    }
    triangle {
      < 5.075837, 0.678259, 0.315766>,
      < 4.637954, 0.702182, 0.315507>,
      < 3.419369, 0.770157, 0.314612>
    }
    triangle {
      < 5.075837, 0.678259, 0.315766>,
      < 3.419369, 0.770157, 0.314612>,
      < 3.421147, 0.679095, 0.385280>
    }
    triangle {
      < 5.075837, 0.678259, 0.315766>,
      < 3.421147, 0.679095, 0.385280>,
      < 5.402462, 0.569439, 0.386628>
    }
    triangle {
      < 5.075837, 0.678259, 0.315766>,
      < 5.402462, 0.569439, 0.386628>,
      < 5.400862, 0.660501, 0.315959>
    }
    triangle {
      < 3.421147, 0.679095, 0.385280>,
      < 3.425547, 0.456609, 0.465905>,
      < 5.406422, 0.346953, 0.467252>
    }
    triangle {
      < 3.421147, 0.679095, 0.385280>,
      < 5.406422, 0.346953, 0.467252>,
      < 5.402462, 0.569439, 0.386628>
    }
    triangle {
      < 3.425547, 0.456609, 0.465905>,
      < 3.440234, -0.279079, 0.507736>,
      < 5.416771, -0.229290, 0.509271>
    }
    triangle {
      < 3.425547, 0.456609, 0.465905>,
      < 5.416771, -0.229290, 0.509271>,
      < 5.406422, 0.346953, 0.467252>
    }
    triangle {
      < 3.440234, -0.279079, 0.507736>,
      < 3.441455, -0.339716, 0.495302>,
      < 5.417868, -0.289927, 0.496836>
    }
    triangle {
      < 3.440234, -0.279079, 0.507736>,
      < 5.417868, -0.289927, 0.496836>,
      < 5.416771, -0.229290, 0.509271>
    }
    triangle {
      < 3.441455, -0.339716, 0.495302>,
      < 3.442912, -0.410392, 0.424445>,
      < 5.419180, -0.360604, 0.425979>
    }
    triangle {
      < 3.441455, -0.339716, 0.495302>,
      < 5.419180, -0.360604, 0.425979>,
      < 5.417868, -0.289927, 0.496836>
    }
    triangle {
      < 3.442912, -0.410392, 0.424445>,
      < 3.443912, -0.450444, 0.100856>,
      < 5.420081, -0.400655, 0.102390>
    }
    triangle {
      < 3.442912, -0.410392, 0.424445>,
      < 5.420081, -0.400655, 0.102390>,
      < 5.419180, -0.360604, 0.425979>
    }
    triangle {
      < 5.386101, 0.715409, 0.217154>,
      < 5.358637, 0.703657, 0.241838>,
      < 5.400862, 0.660501, 0.315959>
    }
    triangle {
      < 5.386101, 0.715409, 0.217154>,
      < 5.400862, 0.660501, 0.315959>,
      < 5.400059, 0.707813, 0.229447>
    }
    triangle {
      < 6.911934, -0.079561, 0.015987>,
      < 6.911885, -0.077433, 0.034451>,
      < 6.815548, -0.137937, 0.098415>
    }
    triangle {
      < 6.911934, -0.079561, 0.015987>,
      < 6.815548, -0.137937, 0.098415>,
      < 6.815879, -0.154401, 0.035663>
    }
    triangle {
      < 6.911885, -0.077433, 0.034451>,
      < 6.911604, -0.062526, 0.056927>,
      < 6.815062, -0.112047, 0.137451>
    }
    triangle {
      < 6.911885, -0.077433, 0.034451>,
      < 6.815062, -0.112047, 0.137451>,
      < 6.815548, -0.137937, 0.098415>
    }
    triangle {
      < 6.911604, -0.062526, 0.056927>,
      < 6.910750, -0.015375, 0.066293>,
      < 6.813738, -0.039344, 0.164225>
    }
    triangle {
      < 6.911604, -0.062526, 0.056927>,
      < 6.813738, -0.039344, 0.164225>,
      < 6.815062, -0.112047, 0.137451>
    }
    triangle {
      < 6.910750, -0.015375, 0.066293>,
      < 6.910252, 0.012345, 0.064121>,
      < 6.811699, 0.074104, 0.155337>
    }
    triangle {
      < 6.910750, -0.015375, 0.066293>,
      < 6.811699, 0.074104, 0.155337>,
      < 6.813738, -0.039344, 0.164225>
    }
    triangle {
      < 6.910252, 0.012345, 0.064121>,
      < 6.909767, 0.039697, 0.053480>,
      < 6.810490, 0.142111, 0.128883>
    }
    triangle {
      < 6.910252, 0.012345, 0.064121>,
      < 6.810490, 0.142111, 0.128883>,
      < 6.811699, 0.074104, 0.155337>
    }
    triangle {
      < 6.909767, 0.039697, 0.053480>,
      < 6.909571, 0.050893, 0.044156>,
      < 6.810002, 0.169946, 0.105698>
    }
    triangle {
      < 6.909767, 0.039697, 0.053480>,
      < 6.810002, 0.169946, 0.105698>,
      < 6.810490, 0.142111, 0.128883>
    }
    triangle {
      < 6.909571, 0.050893, 0.044156>,
      < 6.909443, 0.058367, 0.029490>,
      < 6.809689, 0.188529, 0.069234>
    }
    triangle {
      < 6.909571, 0.050893, 0.044156>,
      < 6.809689, 0.188529, 0.069234>,
      < 6.810002, 0.169946, 0.105698>
    }
    triangle {
      < 6.909443, 0.058367, 0.029490>,
      < 6.909413, 0.060882, 0.003803>,
      < 6.809612, 0.194786, 0.003895>
    }
    triangle {
      < 6.909443, 0.058367, 0.029490>,
      < 6.809612, 0.194786, 0.003895>,
      < 6.809689, 0.188529, 0.069234>
    }
    triangle {
      < 6.810490, 0.142111, 0.128883>,
      < 6.810002, 0.169946, 0.105698>,
      < 6.454550, 0.350057, 0.203708>
    }
    triangle {
      < 6.810490, 0.142111, 0.128883>,
      < 6.454550, 0.350057, 0.203708>,
      < 6.455504, 0.295682, 0.248999>
    }
    triangle {
      < 6.810002, 0.169946, 0.105698>,
      < 6.809689, 0.188529, 0.069234>,
      < 6.453937, 0.386356, 0.132480>
    }
    triangle {
      < 6.810002, 0.169946, 0.105698>,
      < 6.453937, 0.386356, 0.132480>,
      < 6.454550, 0.350057, 0.203708>
    }
    triangle {
      < 6.809689, 0.188529, 0.069234>,
      < 6.809612, 0.194786, 0.003895>,
      < 6.453789, 0.398580, 0.003902>
    }
    triangle {
      < 6.809689, 0.188529, 0.069234>,
      < 6.453789, 0.398580, 0.003902>,
      < 6.453937, 0.386356, 0.132480>
    }
    triangle {
      < 6.815879, -0.154401, 0.035663>,
      < 6.815548, -0.137937, 0.098415>,
      < 6.465575, -0.263488, 0.240794>
    }
    triangle {
      < 6.815879, -0.154401, 0.035663>,
      < 6.465575, -0.263488, 0.240794>,
      < 6.466032, -0.283528, 0.066903>
    }
    triangle {
      < 6.815548, -0.137937, 0.098415>,
      < 6.815062, -0.112047, 0.137451>,
      < 6.464701, -0.217435, 0.319668>
    }
    triangle {
      < 6.815548, -0.137937, 0.098415>,
      < 6.464701, -0.217435, 0.319668>,
      < 6.465575, -0.263488, 0.240794>
    }
    triangle {
      < 6.815062, -0.112047, 0.137451>,
      < 6.813738, -0.039344, 0.164225>,
      < 6.463000, -0.123021, 0.323072>
    }
    triangle {
      < 6.815062, -0.112047, 0.137451>,
      < 6.463000, -0.123021, 0.323072>,
      < 6.464701, -0.217435, 0.319668>
    }
    triangle {
      < 6.813738, -0.039344, 0.164225>,
      < 6.811699, 0.074104, 0.155337>,
      < 6.457867, 0.162836, 0.300676>
    }
    triangle {
      < 6.813738, -0.039344, 0.164225>,
      < 6.457867, 0.162836, 0.300676>,
      < 6.463000, -0.123021, 0.323072>
    }
    triangle {
      < 6.811699, 0.074104, 0.155337>,
      < 6.810490, 0.142111, 0.128883>,
      < 6.455504, 0.295682, 0.248999>
    }
    triangle {
      < 6.811699, 0.074104, 0.155337>,
      < 6.455504, 0.295682, 0.248999>,
      < 6.457867, 0.162836, 0.300676>
    }
    triangle {
      < 6.464701, -0.217435, 0.319668>,
      < 6.463000, -0.123021, 0.323072>,
      < 6.063235, -0.177020, 0.424114>
    }
    triangle {
      < 6.464701, -0.217435, 0.319668>,
      < 6.063235, -0.177020, 0.424114>,
      < 6.064654, -0.255608, 0.416175>
    }
    triangle {
      < 6.463000, -0.123021, 0.323072>,
      < 6.457867, 0.162836, 0.300676>,
      < 6.055737, 0.240628, 0.391393>
    }
    triangle {
      < 6.463000, -0.123021, 0.323072>,
      < 6.055737, 0.240628, 0.391393>,
      < 6.063235, -0.177020, 0.424114>
    }
    triangle {
      < 6.457867, 0.162836, 0.300676>,
      < 6.455504, 0.295682, 0.248999>,
      < 6.052653, 0.413986, 0.323957>
    }
    triangle {
      < 6.457867, 0.162836, 0.300676>,
      < 6.052653, 0.413986, 0.323957>,
      < 6.055737, 0.240628, 0.391393>
    }
    triangle {
      < 6.455504, 0.295682, 0.248999>,
      < 6.454550, 0.350057, 0.203708>,
      < 6.051409, 0.484942, 0.264855>
    }
    triangle {
      < 6.455504, 0.295682, 0.248999>,
      < 6.051409, 0.484942, 0.264855>,
      < 6.052653, 0.413986, 0.323957>
    }
    triangle {
      < 6.454550, 0.350057, 0.203708>,
      < 6.453937, 0.386356, 0.132480>,
      < 6.050607, 0.532311, 0.171905>
    }
    triangle {
      < 6.454550, 0.350057, 0.203708>,
      < 6.050607, 0.532311, 0.171905>,
      < 6.051409, 0.484942, 0.264855>
    }
    triangle {
      < 6.453937, 0.386356, 0.132480>,
      < 6.453789, 0.398580, 0.003902>,
      < 6.050414, 0.548263, 0.003814>
    }
    triangle {
      < 6.453937, 0.386356, 0.132480>,
      < 6.050414, 0.548263, 0.003814>,
      < 6.050607, 0.532311, 0.171905>
    }
    triangle {
      < 6.466032, -0.283528, 0.066903>,
      < 6.465575, -0.263488, 0.240794>,
      < 6.065742, -0.313501, 0.332381>
    }
    triangle {
      < 6.466032, -0.283528, 0.066903>,
      < 6.065742, -0.313501, 0.332381>,
      < 6.066389, -0.341858, 0.086329>
    }
    triangle {
      < 6.465575, -0.263488, 0.240794>,
      < 6.464701, -0.217435, 0.319668>,
      < 6.064654, -0.255608, 0.416175>
    }
    triangle {
      < 6.465575, -0.263488, 0.240794>,
      < 6.064654, -0.255608, 0.416175>,
      < 6.065742, -0.313501, 0.332381>
    }
    triangle {
      < 6.066389, -0.341858, 0.086329>,
      < 6.065742, -0.313501, 0.332381>,
      < 5.419180, -0.360604, 0.425979>
    }
    triangle {
      < 6.066389, -0.341858, 0.086329>,
      < 5.419180, -0.360604, 0.425979>,
      < 5.420081, -0.400655, 0.102390>
    }
    triangle {
      < 6.065742, -0.313501, 0.332381>,
      < 6.064654, -0.255608, 0.416175>,
      < 5.417868, -0.289927, 0.496836>
    }
    triangle {
      < 6.065742, -0.313501, 0.332381>,
      < 5.417868, -0.289927, 0.496836>,
      < 5.419180, -0.360604, 0.425979>
    }
    triangle {
      < 6.064654, -0.255608, 0.416175>,
      < 6.063235, -0.177020, 0.424114>,
      < 5.416771, -0.229290, 0.509271>
    }
    triangle {
      < 6.064654, -0.255608, 0.416175>,
      < 5.416771, -0.229290, 0.509271>,
      < 5.417868, -0.289927, 0.496836>
    }
    triangle {
      < 6.063235, -0.177020, 0.424114>,
      < 6.055737, 0.240628, 0.391393>,
      < 5.406422, 0.346953, 0.467252>
    }
    triangle {
      < 6.063235, -0.177020, 0.424114>,
      < 5.406422, 0.346953, 0.467252>,
      < 5.416771, -0.229290, 0.509271>
    }
    triangle {
      < 6.055737, 0.240628, 0.391393>,
      < 6.052653, 0.413986, 0.323957>,
      < 5.402462, 0.569439, 0.386628>
    }
    triangle {
      < 6.055737, 0.240628, 0.391393>,
      < 5.402462, 0.569439, 0.386628>,
      < 5.406422, 0.346953, 0.467252>
    }
    triangle {
      < 6.052653, 0.413986, 0.323957>,
      < 6.051409, 0.484942, 0.264855>,
      < 5.400862, 0.660501, 0.315959>
    }
    triangle {
      < 6.052653, 0.413986, 0.323957>,
      < 5.400862, 0.660501, 0.315959>,
      < 5.402462, 0.569439, 0.386628>
    }
    triangle {
      < 6.051409, 0.484942, 0.264855>,
      < 6.050607, 0.532311, 0.171905>,
      < 4.624254, 0.714192, 0.203578>
    }
    triangle {
      < 6.051409, 0.484942, 0.264855>,
      < 4.624254, 0.714192, 0.203578>,
      < 5.400059, 0.707813, 0.229447>
    }
    triangle {
      < 6.051409, 0.484942, 0.264855>,
      < 5.400059, 0.707813, 0.229447>,
      < 5.400862, 0.660501, 0.315959>
    }
    triangle {
      < 4.624254, 0.714192, 0.203578>,
      < 6.050607, 0.532311, 0.171905>,
      < 6.050414, 0.548263, 0.003814>
    }
    triangle {
      < 4.624254, 0.714192, 0.203578>,
      < 6.050414, 0.548263, 0.003814>,
      < 5.399573, 0.741740, 0.003615>
    }
    triangle {
      < 4.624254, 0.714192, 0.203578>,
      < 5.399573, 0.741740, 0.003615>,
      < 5.399794, 0.724130, 0.176696>
    }
    texture {parts_fuselage}
  }
  rotate x*0
  rotate y*0
  rotate z*0
}
