
// This file is a POV V2.0 document that describes
// the image of cartoon-like woman. This image was
// converted from babem.obj found on avalon.chinalake.navy.mil
// by Keith Rule (keithr@lucy1.pen.tek.com).
//
// The original file "babem.obj" had no comments or restrictions
// associated with it, and no additional restrictions have been
// added to this version of the file.
//
// This file was automatically generated from babem.obj. Occasional
// warnings will be reported by povray about this file. These
// warnings, though annoying, do not affect the resultant raytraced
// image.

#include "colors.inc"
#include "textures.inc"

camera {
   location  <0, 10, 35>
   direction <0, 0,  1>
   up        <0, 1,  0>
   right   <4/3, 0,  0>
   look_at   <0, 0, 0>
}

light_source {<0, 10, 35> color White}
light_source {<0, 50, 0> color White}
light_source {<0, 50, 10> color White}

/* Sky */
sphere { <0, -39000, 0>, 40000
   inverse

   pigment {
      bozo
      turbulence 0.6
      colour_map {
         [0 0.5 colour red 0.4 green 0.5 blue 1
                colour red 0.4 green 0.5 blue 1.0]
         [0.5 0.7 colour red 0.4 green 0.5 blue 1
                  colour red 1 green 1 blue 1.0]
         [0.7 1 colour red 1 green 1 blue 1
                colour red 0.7 green 0.7 blue 0.7]
      }
      scale 500
      quick_color red 0.4 green 0.5 blue 1
   }
   finish {
      ambient 1
      diffuse 0
   }
}

// Ground
plane {
   y, -60
 
   pigment {
      granite
      color_map { [0.0 1.01 color White color Gold] }
      quick_color White
   }
   finish {
      reflection 0.15
      ambient 0.075  diffuse 0.5
   }

}


// Defintions for colors and textures of Babem object
#declare skin = texture {pigment{Flesh} finish {ambient 0.5 diffuse 0.25 roughness 0.5}}
#declare eye_white = texture {pigment{White} finish {Metal}}
#declare eye_black = texture {pigment{Black} finish {Metal}}
#declare lips = texture {pigment{Red} finish {ambient 0.5 diffuse 0.25 roughness 0.5}}
#declare hair = texture {pigment{Brown} finish {ambient 0.5 diffuse 0.25 roughness 0.5}}


#declare armr = texture {skin}
#declare arml = texture {skin}
#declare body = texture {skin}
#declare suit = texture {Chrome_Metal}
#declare brow = texture {Chrome_Metal}
#declare face = texture {skin}
#declare lash = texture {Chrome_Metal}
#declare uplip = texture {lips}
#declare lowlip = texture {lips}
#declare hair = texture {Chrome_Metal}
#declare white = texture {eye_white}
#declare pupil = texture {eye_black}
#declare iris = texture {Chrome_Metal}
#declare legr = texture {skin}
#declare legl = texture {skin}

// The following describes the babem object.
union {
  // armr
  union {
    triangle {
      < -2.631430, -5.021671, 1.121294>,
      < -2.641492, -5.023551, 1.151718>,
      < -2.631475, -5.189024, 1.144910>
    }
    triangle {
      < -2.631430, -5.021671, 1.121294>,
      < -2.631475, -5.189024, 1.144910>,
      < -2.637240, -5.188992, 1.115963>
    }
    triangle {
      < -2.641492, -5.023551, 1.151718>,
      < -2.631430, -5.021671, 1.121294>,
      < -2.641750, -5.009909, 1.175060>
    }
    triangle {
      < -2.711608, -4.528833, 1.228295>,
      < -2.668286, -4.735597, 1.220260>,
      < -2.643964, -4.725788, 1.080201>
    }
    triangle {
      < -2.711608, -4.528833, 1.228295>,
      < -2.643964, -4.725788, 1.080201>,
      < -2.694940, -4.534479, 1.074974>
    }
    triangle {
      < -2.973360, -4.269324, 1.317931>,
      < -2.902829, -4.522134, 1.286647>,
      < -2.791797, -4.524917, 1.292616>
    }
    triangle {
      < -2.973360, -4.269324, 1.317931>,
      < -2.791797, -4.524917, 1.292616>,
      < -2.849420, -4.258226, 1.321365>
    }
    triangle {
      < -2.857244, -4.750984, 1.276291>,
      < -2.747367, -4.744814, 1.283339>,
      < -2.791797, -4.524917, 1.292616>
    }
    triangle {
      < -2.857244, -4.750984, 1.276291>,
      < -2.791797, -4.524917, 1.292616>,
      < -2.902829, -4.522134, 1.286647>
    }
    triangle {
      < -2.799385, -5.042875, 1.209213>,
      < -2.709860, -5.038414, 1.211770>,
      < -2.716361, -5.024138, 1.237795>
    }
    triangle {
      < -2.799385, -5.042875, 1.209213>,
      < -2.716361, -5.024138, 1.237795>,
      < -2.815561, -5.029976, 1.234091>
    }
    triangle {
      < -2.711608, -4.528833, 1.228295>,
      < -2.694940, -4.534479, 1.074974>,
      < -2.695638, -4.264558, 1.100924>
    }
    triangle {
      < -2.711608, -4.528833, 1.228295>,
      < -2.695638, -4.264558, 1.100924>,
      < -2.756208, -4.246720, 1.254495>
    }
    triangle {
      < -2.799385, -5.042875, 1.209213>,
      < -2.832069, -5.040146, 1.196513>,
      < -2.798819, -5.210745, 1.199050>
    }
    triangle {
      < -2.799385, -5.042875, 1.209213>,
      < -2.798819, -5.210745, 1.199050>,
      < -2.794990, -5.219936, 1.222509>
    }
    triangle {
      < -2.794990, -5.219936, 1.222509>,
      < -2.756707, -5.252022, 1.199861>,
      < -2.697364, -5.274925, 1.189184>
    }
    triangle {
      < -2.794990, -5.219936, 1.222509>,
      < -2.697364, -5.274925, 1.189184>,
      < -2.709860, -5.038414, 1.211770>
    }
    triangle {
      < -2.794990, -5.219936, 1.222509>,
      < -2.709860, -5.038414, 1.211770>,
      < -2.799385, -5.042875, 1.209213>
    }
    triangle {
      < -2.799385, -5.042875, 1.209213>,
      < -2.815561, -5.029976, 1.234091>,
      < -2.832069, -5.040146, 1.196513>
    }
    triangle {
      < -2.902829, -4.522134, 1.286647>,
      < -3.029877, -4.546164, 1.187151>,
      < -3.003325, -4.727902, 1.148698>
    }
    triangle {
      < -2.902829, -4.522134, 1.286647>,
      < -3.003325, -4.727902, 1.148698>,
      < -2.857244, -4.750984, 1.276291>
    }
    triangle {
      < -3.163307, -4.271783, 1.217669>,
      < -3.168708, -4.360939, 1.148516>,
      < -3.029877, -4.546164, 1.187151>
    }
    triangle {
      < -3.163307, -4.271783, 1.217669>,
      < -3.029877, -4.546164, 1.187151>,
      < -2.902829, -4.522134, 1.286647>
    }
    triangle {
      < -3.163307, -4.271783, 1.217669>,
      < -2.902829, -4.522134, 1.286647>,
      < -2.973360, -4.269324, 1.317931>
    }
    triangle {
      < -3.163307, -4.271783, 1.217669>,
      < -3.310992, -4.389974, 1.185302>,
      < -3.168708, -4.360939, 1.148516>
    }
    triangle {
      < -3.163307, -4.271783, 1.217669>,
      < -3.446155, -4.248275, 1.191563>,
      < -3.310992, -4.389974, 1.185302>
    }
    triangle {
      < -3.163307, -4.271783, 1.217669>,
      < -3.171760, -4.101448, 1.247475>,
      < -3.446155, -4.248275, 1.191563>
    }
    triangle {
      < -3.163307, -4.271783, 1.217669>,
      < -2.973360, -4.269324, 1.317931>,
      < -3.171760, -4.101448, 1.247475>
    }
    triangle {
      < -2.849420, -4.258226, 1.321365>,
      < -2.903923, -3.680026, 1.129989>,
      < -2.973360, -4.269324, 1.317931>
    }
    triangle {
      < -2.695638, -4.264558, 1.100924>,
      < -2.713652, -3.719675, 0.943718>,
      < -2.903923, -3.680026, 1.129989>
    }
    triangle {
      < -2.695638, -4.264558, 1.100924>,
      < -2.903923, -3.680026, 1.129989>,
      < -2.756208, -4.246720, 1.254495>
    }
    triangle {
      < -2.747921, -4.290134, 0.909324>,
      < -2.704204, -3.806584, 0.684968>,
      < -2.713652, -3.719675, 0.943718>
    }
    triangle {
      < -2.747921, -4.290134, 0.909324>,
      < -2.713652, -3.719675, 0.943718>,
      < -2.695638, -4.264558, 1.100924>
    }
    triangle {
      < -2.643964, -4.725788, 1.080201>,
      < -2.703791, -4.743211, 0.972488>,
      < -2.741052, -4.560413, 0.984922>
    }
    triangle {
      < -2.643964, -4.725788, 1.080201>,
      < -2.741052, -4.560413, 0.984922>,
      < -2.694940, -4.534479, 1.074974>
    }
    triangle {
      < -2.741052, -4.560413, 0.984922>,
      < -2.747921, -4.290134, 0.909324>,
      < -2.695638, -4.264558, 1.100924>
    }
    triangle {
      < -2.741052, -4.560413, 0.984922>,
      < -2.695638, -4.264558, 1.100924>,
      < -2.694940, -4.534479, 1.074974>
    }
    triangle {
      < -3.201631, -3.744820, 1.164047>,
      < -3.483165, -3.822722, 1.044899>,
      < -3.446155, -4.248275, 1.191563>
    }
    triangle {
      < -3.201631, -3.744820, 1.164047>,
      < -3.446155, -4.248275, 1.191563>,
      < -3.171760, -4.101448, 1.247475>
    }
    triangle {
      < -3.235652, -4.565553, 1.006618>,
      < -3.073454, -4.431412, 0.941757>,
      < -3.168708, -4.360939, 1.148516>
    }
    triangle {
      < -3.235652, -4.565553, 1.006618>,
      < -3.168708, -4.360939, 1.148516>,
      < -3.310992, -4.389974, 1.185302>
    }
    triangle {
      < -3.235652, -4.565553, 1.006618>,
      < -3.310992, -4.389974, 1.185302>,
      < -3.348468, -4.497969, 1.145854>
    }
    triangle {
      < -2.993353, -4.579245, 0.974282>,
      < -3.029877, -4.546164, 1.187151>,
      < -3.168708, -4.360939, 1.148516>
    }
    triangle {
      < -2.993353, -4.579245, 0.974282>,
      < -3.168708, -4.360939, 1.148516>,
      < -3.073454, -4.431412, 0.941757>
    }
    triangle {
      < -2.955719, -4.779051, 0.972429>,
      < -3.003325, -4.727902, 1.148698>,
      < -3.029877, -4.546164, 1.187151>
    }
    triangle {
      < -2.955719, -4.779051, 0.972429>,
      < -3.029877, -4.546164, 1.187151>,
      < -2.993353, -4.579245, 0.974282>
    }
    triangle {
      < -2.839635, -5.003333, 0.986344>,
      < -2.899959, -5.015127, 1.172929>,
      < -3.003325, -4.727902, 1.148698>
    }
    triangle {
      < -2.839635, -5.003333, 0.986344>,
      < -3.003325, -4.727902, 1.148698>,
      < -2.955719, -4.779051, 0.972429>
    }
    triangle {
      < -2.823724, -5.203536, 1.130062>,
      < -2.899959, -5.015127, 1.172929>,
      < -2.839635, -5.003333, 0.986344>
    }
    triangle {
      < -2.741052, -4.560413, 0.984922>,
      < -2.993353, -4.579245, 0.974282>,
      < -2.899165, -4.345756, 0.831593>
    }
    triangle {
      < -2.741052, -4.560413, 0.984922>,
      < -2.899165, -4.345756, 0.831593>,
      < -2.747921, -4.290134, 0.909324>
    }
    triangle {
      < -2.703791, -4.743211, 0.972488>,
      < -2.955719, -4.779051, 0.972429>,
      < -2.993353, -4.579245, 0.974282>
    }
    triangle {
      < -2.703791, -4.743211, 0.972488>,
      < -2.993353, -4.579245, 0.974282>,
      < -2.741052, -4.560413, 0.984922>
    }
    triangle {
      < -2.676981, -5.016549, 0.977451>,
      < -2.839635, -5.003333, 0.986344>,
      < -2.955719, -4.779051, 0.972429>
    }
    triangle {
      < -2.676981, -5.016549, 0.977451>,
      < -2.955719, -4.779051, 0.972429>,
      < -2.703791, -4.743211, 0.972488>
    }
    triangle {
      < -2.676505, -5.230327, 1.135723>,
      < -2.759147, -5.241912, 1.167365>,
      < -2.823724, -5.203536, 1.130062>
    }
    triangle {
      < -2.676505, -5.230327, 1.135723>,
      < -2.823724, -5.203536, 1.130062>,
      < -2.671290, -5.134576, 1.004575>
    }
    triangle {
      < -2.823724, -5.203536, 1.130062>,
      < -2.759147, -5.241912, 1.167365>,
      < -2.798819, -5.210745, 1.199050>
    }
    triangle {
      < -2.990301, -3.784639, 0.396786>,
      < -2.704204, -3.806584, 0.684968>,
      < -2.747921, -4.290134, 0.909324>
    }
    triangle {
      < -2.990301, -3.784639, 0.396786>,
      < -2.747921, -4.290134, 0.909324>,
      < -2.899165, -4.345756, 0.831593>
    }
    triangle {
      < -3.197434, -4.219485, 0.539804>,
      < -2.990301, -3.784639, 0.396786>,
      < -3.073454, -4.431412, 0.941757>
    }
    triangle {
      < -2.899165, -4.345756, 0.831593>,
      < -2.993353, -4.579245, 0.974282>,
      < -3.073454, -4.431412, 0.941757>
    }
    triangle {
      < -3.483935, -4.776453, 1.166256>,
      < -3.324410, -4.776068, 1.013156>,
      < -3.235652, -4.565553, 1.006618>
    }
    triangle {
      < -3.483935, -4.776453, 1.166256>,
      < -3.235652, -4.565553, 1.006618>,
      < -3.348468, -4.497969, 1.145854>
    }
    triangle {
      < -3.535011, -4.937427, 1.154687>,
      < -3.369840, -4.918569, 1.022564>,
      < -3.324410, -4.776068, 1.013156>
    }
    triangle {
      < -3.535011, -4.937427, 1.154687>,
      < -3.324410, -4.776068, 1.013156>,
      < -3.483935, -4.776453, 1.166256>
    }
    triangle {
      < -3.637986, -5.299436, 1.165222>,
      < -3.486985, -5.292625, 1.048481>,
      < -3.369840, -4.918569, 1.022564>
    }
    triangle {
      < -3.637986, -5.299436, 1.165222>,
      < -3.369840, -4.918569, 1.022564>,
      < -3.535011, -4.937427, 1.154687>
    }
    triangle {
      < -3.637986, -5.299436, 1.165222>,
      < -3.545418, -5.692355, 1.088168>,
      < -3.459127, -5.660091, 1.004743>
    }
    triangle {
      < -3.637986, -5.299436, 1.165222>,
      < -3.459127, -5.660091, 1.004743>,
      < -3.486985, -5.292625, 1.048481>
    }
    triangle {
      < -3.492407, -5.893525, 1.037085>,
      < -3.427807, -5.874164, 0.987612>,
      < -3.459127, -5.660091, 1.004743>
    }
    triangle {
      < -3.492407, -5.893525, 1.037085>,
      < -3.459127, -5.660091, 1.004743>,
      < -3.545418, -5.692355, 1.088168>
    }
    triangle {
      < -3.654503, -4.904352, 1.111933>,
      < -3.535011, -4.937427, 1.154687>,
      < -3.483935, -4.776453, 1.166256>
    }
    triangle {
      < -3.654503, -4.904352, 1.111933>,
      < -3.483935, -4.776453, 1.166256>,
      < -3.653747, -4.749532, 1.108063>
    }
    triangle {
      < -3.654503, -4.904352, 1.111933>,
      < -3.749973, -5.313198, 1.098377>,
      < -3.637986, -5.299436, 1.165222>
    }
    triangle {
      < -3.654503, -4.904352, 1.111933>,
      < -3.637986, -5.299436, 1.165222>,
      < -3.535011, -4.937427, 1.154687>
    }
    triangle {
      < -3.632454, -5.713002, 1.037336>,
      < -3.545418, -5.692355, 1.088168>,
      < -3.637986, -5.299436, 1.165222>
    }
    triangle {
      < -3.632454, -5.713002, 1.037336>,
      < -3.637986, -5.299436, 1.165222>,
      < -3.749973, -5.313198, 1.098377>
    }
    triangle {
      < -3.550858, -5.907750, 0.973820>,
      < -3.531374, -5.903006, 0.994906>,
      < -3.553595, -5.892168, 0.986735>
    }
    triangle {
      < -3.518012, -6.067028, 0.920041>,
      < -3.531293, -6.078069, 0.882219>,
      < -3.513249, -6.071916, 0.875409>
    }
    triangle {
      < -3.518012, -6.067028, 0.920041>,
      < -3.513249, -6.071916, 0.875409>,
      < -3.505432, -6.057985, 0.920378>
    }
    triangle {
      < -3.782173, -4.912578, 0.915967>,
      < -3.813822, -5.323252, 0.919115>,
      < -3.826484, -5.322048, 1.027841>
    }
    triangle {
      < -3.782173, -4.912578, 0.915967>,
      < -3.826484, -5.322048, 1.027841>,
      < -3.761762, -4.904438, 1.035913>
    }
    triangle {
      < -3.683643, -5.717794, 0.871465>,
      < -3.701282, -5.729109, 0.969850>,
      < -3.826484, -5.322048, 1.027841>
    }
    triangle {
      < -3.683643, -5.717794, 0.871465>,
      < -3.826484, -5.322048, 1.027841>,
      < -3.813822, -5.323252, 0.919115>
    }
    triangle {
      < -3.605893, -5.908008, 0.839344>,
      < -3.610975, -5.919303, 0.919372>,
      < -3.624970, -5.907471, 0.927947>
    }
    triangle {
      < -3.605893, -5.908008, 0.839344>,
      < -3.624970, -5.907471, 0.927947>,
      < -3.609701, -5.892986, 0.836394>
    }
    triangle {
      < -3.653747, -4.749532, 1.108063>,
      < -3.483935, -4.776453, 1.166256>,
      < -3.348468, -4.497969, 1.145854>
    }
    triangle {
      < -3.653747, -4.749532, 1.108063>,
      < -3.348468, -4.497969, 1.145854>,
      < -3.549953, -4.498902, 1.149813>
    }
    triangle {
      < -3.756013, -4.691369, 0.949057>,
      < -3.626639, -4.463606, 1.089377>,
      < -3.768749, -4.368258, 0.884841>
    }
    triangle {
      < -3.483165, -3.822722, 1.044899>,
      < -3.700375, -3.896398, 0.812029>,
      < -3.768749, -4.368258, 0.884841>
    }
    triangle {
      < -3.483165, -3.822722, 1.044899>,
      < -3.768749, -4.368258, 0.884841>,
      < -3.446155, -4.248275, 1.191563>
    }
    triangle {
      < -3.444501, -3.301727, 0.923484>,
      < -3.613293, -3.303538, 0.713008>,
      < -3.700375, -3.896398, 0.812029>
    }
    triangle {
      < -3.444501, -3.301727, 0.923484>,
      < -3.700375, -3.896398, 0.812029>,
      < -3.483165, -3.822722, 1.044899>
    }
    triangle {
      < -3.201631, -3.744820, 1.164047>,
      < -3.222924, -3.353535, 1.002504>,
      < -3.444501, -3.301727, 0.923484>
    }
    triangle {
      < -3.201631, -3.744820, 1.164047>,
      < -3.444501, -3.301727, 0.923484>,
      < -3.483165, -3.822722, 1.044899>
    }
    triangle {
      < -2.713652, -3.719675, 0.943718>,
      < -2.876625, -3.360112, 0.793590>,
      < -2.999575, -3.309280, 0.968456>
    }
    triangle {
      < -2.713652, -3.719675, 0.943718>,
      < -2.999575, -3.309280, 0.968456>,
      < -2.903923, -3.680026, 1.129989>
    }
    triangle {
      < -3.783816, -3.880267, 0.562139>,
      < -3.700375, -3.896398, 0.812029>,
      < -3.613293, -3.303538, 0.713008>
    }
    triangle {
      < -3.783816, -3.880267, 0.562139>,
      < -3.613293, -3.303538, 0.713008>,
      < -3.675314, -3.326316, 0.542915>
    }
    triangle {
      < -3.870004, -4.337597, 0.578456>,
      < -3.768749, -4.368258, 0.884841>,
      < -3.700375, -3.896398, 0.812029>
    }
    triangle {
      < -3.870004, -4.337597, 0.578456>,
      < -3.700375, -3.896398, 0.812029>,
      < -3.783816, -3.880267, 0.562139>
    }
    triangle {
      < -3.870004, -4.337597, 0.578456>,
      < -3.978867, -4.556856, 0.590013>,
      < -3.768749, -4.368258, 0.884841>
    }
    triangle {
      < -3.978867, -4.556856, 0.590013>,
      < -3.803743, -4.753818, 0.693033>,
      < -3.768749, -4.368258, 0.884841>
    }
    triangle {
      < -3.803743, -4.753818, 0.693033>,
      < -3.710069, -4.766702, 0.790986>,
      < -3.768749, -4.368258, 0.884841>
    }
    triangle {
      < -3.756013, -4.691369, 0.949057>,
      < -3.768749, -4.368258, 0.884841>,
      < -3.710069, -4.766702, 0.790986>
    }
    triangle {
      < -3.650504, -4.915636, 0.760976>,
      < -3.649614, -5.325970, 0.777320>,
      < -3.813822, -5.323252, 0.919115>
    }
    triangle {
      < -3.650504, -4.915636, 0.760976>,
      < -3.813822, -5.323252, 0.919115>,
      < -3.782173, -4.912578, 0.915967>
    }
    triangle {
      < -3.553799, -5.655422, 0.761295>,
      < -3.683643, -5.717794, 0.871465>,
      < -3.813822, -5.323252, 0.919115>
    }
    triangle {
      < -3.553799, -5.655422, 0.761295>,
      < -3.813822, -5.323252, 0.919115>,
      < -3.649614, -5.325970, 0.777320>
    }
    triangle {
      < -3.605893, -5.908008, 0.839344>,
      < -3.609701, -5.892986, 0.836394>,
      < -3.572496, -5.890628, 0.808892>
    }
    triangle {
      < -3.756013, -4.691369, 0.949057>,
      < -3.710069, -4.766702, 0.790986>,
      < -3.650504, -4.915636, 0.760976>
    }
    triangle {
      < -3.756013, -4.691369, 0.949057>,
      < -3.650504, -4.915636, 0.760976>,
      < -3.782173, -4.912578, 0.915967>
    }
    triangle {
      < -3.803743, -4.753818, 0.693033>,
      < -3.806412, -4.871074, 0.669699>,
      < -3.650504, -4.915636, 0.760976>
    }
    triangle {
      < -3.803743, -4.753818, 0.693033>,
      < -3.650504, -4.915636, 0.760976>,
      < -3.710069, -4.766702, 0.790986>
    }
    triangle {
      < -3.806412, -4.871074, 0.669699>,
      < -3.736344, -5.360968, 0.650572>,
      < -3.603045, -5.366023, 0.721294>
    }
    triangle {
      < -3.806412, -4.871074, 0.669699>,
      < -3.603045, -5.366023, 0.721294>,
      < -3.650504, -4.915636, 0.760976>
    }
    triangle {
      < -3.420764, -5.762608, 0.600205>,
      < -3.333775, -5.706460, 0.656384>,
      < -3.603045, -5.366023, 0.721294>
    }
    triangle {
      < -3.420764, -5.762608, 0.600205>,
      < -3.603045, -5.366023, 0.721294>,
      < -3.736344, -5.360968, 0.650572>
    }
    triangle {
      < -3.253033, -5.914477, 0.560052>,
      < -3.215331, -5.910106, 0.568917>,
      < -3.196081, -5.881806, 0.617120>
    }
    triangle {
      < -3.253033, -5.914477, 0.560052>,
      < -3.196081, -5.881806, 0.617120>,
      < -3.333775, -5.706460, 0.656384>
    }
    triangle {
      < -3.253033, -5.914477, 0.560052>,
      < -3.333775, -5.706460, 0.656384>,
      < -3.420764, -5.762608, 0.600205>
    }
    triangle {
      < -3.074996, -6.055424, 0.520714>,
      < -3.098142, -5.994081, 0.570921>,
      < -3.132799, -6.015729, 0.561931>
    }
    triangle {
      < -3.074996, -6.055424, 0.520714>,
      < -3.132799, -6.015729, 0.561931>,
      < -3.140649, -6.052967, 0.521939>
    }
    triangle {
      < -3.149153, -6.054235, 0.444800>,
      < -3.149762, -6.017935, 0.402476>,
      < -3.108755, -5.980817, 0.380630>
    }
    triangle {
      < -3.149153, -6.054235, 0.444800>,
      < -3.108755, -5.980817, 0.380630>,
      < -3.086810, -6.058038, 0.437816>
    }
    triangle {
      < -3.420764, -5.762608, 0.600205>,
      < -3.736344, -5.360968, 0.650572>,
      < -3.787827, -5.377024, 0.557766>
    }
    triangle {
      < -3.420764, -5.762608, 0.600205>,
      < -3.787827, -5.377024, 0.557766>,
      < -3.453096, -5.787074, 0.509127>
    }
    triangle {
      < -3.871635, -4.874913, 0.579817>,
      < -3.787827, -5.377024, 0.557766>,
      < -3.736344, -5.360968, 0.650572>
    }
    triangle {
      < -3.871635, -4.874913, 0.579817>,
      < -3.736344, -5.360968, 0.650572>,
      < -3.806412, -4.871074, 0.669699>
    }
    triangle {
      < -3.806412, -4.871074, 0.669699>,
      < -3.803743, -4.753818, 0.693033>,
      < -3.872860, -4.762247, 0.594336>
    }
    triangle {
      < -3.806412, -4.871074, 0.669699>,
      < -3.872860, -4.762247, 0.594336>,
      < -3.871635, -4.874913, 0.579817>
    }
    triangle {
      < -3.310092, -5.947457, 0.499410>,
      < -3.253033, -5.914477, 0.560052>,
      < -3.420764, -5.762608, 0.600205>
    }
    triangle {
      < -3.310092, -5.947457, 0.499410>,
      < -3.420764, -5.762608, 0.600205>,
      < -3.453096, -5.787074, 0.509127>
    }
    triangle {
      < -3.819031, -4.756149, 0.303078>,
      < -3.848762, -4.753190, 0.476878>,
      < -3.978867, -4.556856, 0.590013>
    }
    triangle {
      < -3.978867, -4.556856, 0.590013>,
      < -3.879323, -4.471182, 0.367653>,
      < -3.819031, -4.756149, 0.303078>
    }
    triangle {
      < -3.879323, -4.471182, 0.367653>,
      < -3.935352, -4.474578, 0.199895>,
      < -3.819031, -4.756149, 0.303078>
    }
    triangle {
      < -3.749773, -4.510483, -0.012252>,
      < -3.820560, -4.589967, 0.087331>,
      < -3.935352, -4.474578, 0.199895>
    }
    triangle {
      < -3.935352, -4.474578, 0.199895>,
      < -3.873947, -4.364538, 0.447579>,
      < -3.858342, -4.321498, 0.208042>
    }
    triangle {
      < -3.935352, -4.474578, 0.199895>,
      < -3.879323, -4.471182, 0.367653>,
      < -3.873947, -4.364538, 0.447579>
    }
    triangle {
      < -3.978867, -4.556856, 0.590013>,
      < -3.870004, -4.337597, 0.578456>,
      < -3.873947, -4.364538, 0.447579>
    }
    triangle {
      < -3.822417, -4.339959, 0.033673>,
      < -3.819674, -4.385047, 0.030987>,
      < -3.935352, -4.474578, 0.199895>
    }
    triangle {
      < -3.822417, -4.339959, 0.033673>,
      < -3.935352, -4.474578, 0.199895>,
      < -3.858342, -4.321498, 0.208042>
    }
    triangle {
      < -3.822417, -4.339959, 0.033673>,
      < -3.855826, -4.343190, -0.131656>,
      < -3.819674, -4.385047, 0.030987>
    }
    triangle {
      < -3.855826, -4.343190, -0.131656>,
      < -3.749773, -4.510483, -0.012252>,
      < -3.819674, -4.385047, 0.030987>
    }
    triangle {
      < -3.879323, -4.471182, 0.367653>,
      < -3.978867, -4.556856, 0.590013>,
      < -3.873947, -4.364538, 0.447579>
    }
    triangle {
      < -3.819674, -4.385047, 0.030987>,
      < -3.749773, -4.510483, -0.012252>,
      < -3.935352, -4.474578, 0.199895>
    }
    triangle {
      < -3.603045, -5.366023, 0.721294>,
      < -3.446331, -5.286727, 0.646611>,
      < -3.498511, -4.881388, 0.657414>
    }
    triangle {
      < -3.603045, -5.366023, 0.721294>,
      < -3.498511, -4.881388, 0.657414>,
      < -3.650504, -4.915636, 0.760976>
    }
    triangle {
      < -3.446331, -5.286727, 0.646611>,
      < -3.603045, -5.366023, 0.721294>,
      < -3.333775, -5.706460, 0.656384>
    }
    triangle {
      < -3.446331, -5.286727, 0.646611>,
      < -3.333775, -5.706460, 0.656384>,
      < -3.260044, -5.662074, 0.586409>
    }
    triangle {
      < -3.058576, -5.974609, 0.422769>,
      < -3.142598, -5.814617, 0.395572>,
      < -3.139689, -5.825614, 0.561847>
    }
    triangle {
      < -3.058576, -5.974609, 0.422769>,
      < -3.139689, -5.825614, 0.561847>,
      < -3.033125, -5.970796, 0.526716>
    }
    triangle {
      < -3.142598, -5.814617, 0.395572>,
      < -3.280637, -5.636574, 0.412913>,
      < -3.260044, -5.662074, 0.586409>
    }
    triangle {
      < -3.142598, -5.814617, 0.395572>,
      < -3.260044, -5.662074, 0.586409>,
      < -3.139689, -5.825614, 0.561847>
    }
    triangle {
      < -3.475449, -5.305753, 0.445597>,
      < -3.446331, -5.286727, 0.646611>,
      < -3.260044, -5.662074, 0.586409>
    }
    triangle {
      < -3.475449, -5.305753, 0.445597>,
      < -3.260044, -5.662074, 0.586409>,
      < -3.280637, -5.636574, 0.412913>
    }
    triangle {
      < -3.446331, -5.286727, 0.646611>,
      < -3.475449, -5.305753, 0.445597>,
      < -3.519503, -4.890442, 0.426109>
    }
    triangle {
      < -3.446331, -5.286727, 0.646611>,
      < -3.519503, -4.890442, 0.426109>,
      < -3.498511, -4.881388, 0.657414>
    }
    triangle {
      < -3.196081, -5.881806, 0.617120>,
      < -3.139689, -5.825614, 0.561847>,
      < -3.260044, -5.662074, 0.586409>
    }
    triangle {
      < -3.196081, -5.881806, 0.617120>,
      < -3.260044, -5.662074, 0.586409>,
      < -3.333775, -5.706460, 0.656384>
    }
    triangle {
      < -3.215331, -5.910106, 0.568917>,
      < -3.132799, -6.015729, 0.561931>,
      < -3.098142, -5.994081, 0.570921>
    }
    triangle {
      < -3.215331, -5.910106, 0.568917>,
      < -3.098142, -5.994081, 0.570921>,
      < -3.196081, -5.881806, 0.617120>
    }
    triangle {
      < -3.081568, -6.072448, 0.477527>,
      < -3.033125, -5.970796, 0.526716>,
      < -3.074996, -6.055424, 0.520714>
    }
    triangle {
      < -3.081568, -6.072448, 0.477527>,
      < -3.058576, -5.974609, 0.422769>,
      < -3.033125, -5.970796, 0.526716>
    }
    triangle {
      < -3.081568, -6.072448, 0.477527>,
      < -3.086810, -6.058038, 0.437816>,
      < -3.058576, -5.974609, 0.422769>
    }
    triangle {
      < -3.139689, -5.825614, 0.561847>,
      < -3.196081, -5.881806, 0.617120>,
      < -3.098142, -5.994081, 0.570921>
    }
    triangle {
      < -3.139689, -5.825614, 0.561847>,
      < -3.098142, -5.994081, 0.570921>,
      < -3.033125, -5.970796, 0.526716>
    }
    triangle {
      < -3.414722, -5.838942, 0.821544>,
      < -3.459411, -5.707362, 0.829529>,
      < -3.481752, -5.641568, 0.833520>
    }
    triangle {
      < -3.414722, -5.838942, 0.821544>,
      < -3.481752, -5.641568, 0.833520>,
      < -3.459127, -5.660091, 1.004743>
    }
    triangle {
      < -3.414722, -5.838942, 0.821544>,
      < -3.459127, -5.660091, 1.004743>,
      < -3.427807, -5.874164, 0.987612>
    }
    triangle {
      < -3.495727, -5.568245, 0.844104>,
      < -3.531061, -5.368310, 0.853324>,
      < -3.543149, -5.294589, 0.850091>
    }
    triangle {
      < -3.495727, -5.568245, 0.844104>,
      < -3.543149, -5.294589, 0.850091>,
      < -3.486985, -5.292625, 1.048481>
    }
    triangle {
      < -3.495727, -5.568245, 0.844104>,
      < -3.486985, -5.292625, 1.048481>,
      < -3.459127, -5.660091, 1.004743>
    }
    triangle {
      < -3.495727, -5.568245, 0.844104>,
      < -3.459127, -5.660091, 1.004743>,
      < -3.481752, -5.641568, 0.833520>
    }
    triangle {
      < -3.486985, -5.292625, 1.048481>,
      < -3.543149, -5.294589, 0.850091>,
      < -3.522806, -5.152845, 0.852173>
    }
    triangle {
      < -3.486985, -5.292625, 1.048481>,
      < -3.522806, -5.152845, 0.852173>,
      < -3.525503, -4.858645, 0.856764>
    }
    triangle {
      < -3.486985, -5.292625, 1.048481>,
      < -3.525503, -4.858645, 0.856764>,
      < -3.369840, -4.918569, 1.022564>
    }
    triangle {
      < -3.413736, -6.028965, 0.915567>,
      < -3.416675, -6.008670, 0.825785>,
      < -3.414722, -5.838942, 0.821544>
    }
    triangle {
      < -3.413736, -6.028965, 0.915567>,
      < -3.414722, -5.838942, 0.821544>,
      < -3.427807, -5.874164, 0.987612>
    }
    triangle {
      < -3.473088, -6.035122, 0.967001>,
      < -3.413736, -6.028965, 0.915567>,
      < -3.427807, -5.874164, 0.987612>
    }
    triangle {
      < -3.473088, -6.035122, 0.967001>,
      < -3.427807, -5.874164, 0.987612>,
      < -3.492407, -5.893525, 1.037085>
    }
    triangle {
      < -3.482244, -6.080278, 0.862983>,
      < -3.416675, -6.008670, 0.825785>,
      < -3.413736, -6.028965, 0.915567>
    }
    triangle {
      < -3.482244, -6.080278, 0.862983>,
      < -3.479325, -6.050067, 0.813931>,
      < -3.477974, -6.002246, 0.777414>
    }
    triangle {
      < -3.482244, -6.080278, 0.862983>,
      < -3.477974, -6.002246, 0.777414>,
      < -3.416675, -6.008670, 0.825785>
    }
    triangle {
      < -3.505699, -5.855872, 0.747989>,
      < -3.414722, -5.838942, 0.821544>,
      < -3.416675, -6.008670, 0.825785>
    }
    triangle {
      < -3.505699, -5.855872, 0.747989>,
      < -3.416675, -6.008670, 0.825785>,
      < -3.477974, -6.002246, 0.777414>
    }
    triangle {
      < -3.414722, -5.838942, 0.821544>,
      < -3.505699, -5.855872, 0.747989>,
      < -3.553799, -5.655422, 0.761295>
    }
    triangle {
      < -3.414722, -5.838942, 0.821544>,
      < -3.553799, -5.655422, 0.761295>,
      < -3.481752, -5.641568, 0.833520>
    }
    triangle {
      < -3.414722, -5.838942, 0.821544>,
      < -3.481752, -5.641568, 0.833520>,
      < -3.459411, -5.707362, 0.829529>
    }
    triangle {
      < -3.649614, -5.325970, 0.777320>,
      < -3.543149, -5.294589, 0.850091>,
      < -3.531061, -5.368310, 0.853324>
    }
    triangle {
      < -3.649614, -5.325970, 0.777320>,
      < -3.531061, -5.368310, 0.853324>,
      < -3.495727, -5.568245, 0.844104>
    }
    triangle {
      < -3.649614, -5.325970, 0.777320>,
      < -3.495727, -5.568245, 0.844104>,
      < -3.481752, -5.641568, 0.833520>
    }
    triangle {
      < -3.649614, -5.325970, 0.777320>,
      < -3.481752, -5.641568, 0.833520>,
      < -3.553799, -5.655422, 0.761295>
    }
    triangle {
      < -3.498511, -4.881388, 0.657414>,
      < -3.376643, -4.703335, 0.631060>,
      < -3.525503, -4.858645, 0.856764>
    }
    triangle {
      < -3.324410, -4.776068, 1.013156>,
      < -3.369840, -4.918569, 1.022564>,
      < -3.525503, -4.858645, 0.856764>
    }
    triangle {
      < -3.324410, -4.776068, 1.013156>,
      < -3.525503, -4.858645, 0.856764>,
      < -3.376643, -4.703335, 0.631060>
    }
    triangle {
      < -3.680832, -4.871781, 0.372331>,
      < -3.641114, -5.319808, 0.383361>,
      < -3.749318, -5.362044, 0.458830>
    }
    triangle {
      < -3.680832, -4.871781, 0.372331>,
      < -3.749318, -5.362044, 0.458830>,
      < -3.840905, -4.872707, 0.474656>
    }
    triangle {
      < -3.340641, -5.701254, 0.360480>,
      < -3.410457, -5.758007, 0.415555>,
      < -3.749318, -5.362044, 0.458830>
    }
    triangle {
      < -3.340641, -5.701254, 0.360480>,
      < -3.749318, -5.362044, 0.458830>,
      < -3.641114, -5.319808, 0.383361>
    }
    triangle {
      < -3.298786, -5.763205, 0.362287>,
      < -3.215080, -5.887108, 0.365910>,
      < -3.230269, -5.937195, 0.415929>
    }
    triangle {
      < -3.298786, -5.763205, 0.362287>,
      < -3.230269, -5.937195, 0.415929>,
      < -3.263365, -5.932832, 0.427533>
    }
    triangle {
      < -3.298786, -5.763205, 0.362287>,
      < -3.263365, -5.932832, 0.427533>,
      < -3.410457, -5.758007, 0.415555>
    }
    triangle {
      < -3.298786, -5.763205, 0.362287>,
      < -3.410457, -5.758007, 0.415555>,
      < -3.340641, -5.701254, 0.360480>
    }
    triangle {
      < -3.848762, -4.753190, 0.476878>,
      < -3.819031, -4.756149, 0.303078>,
      < -3.680832, -4.871781, 0.372331>
    }
    triangle {
      < -3.848762, -4.753190, 0.476878>,
      < -3.680832, -4.871781, 0.372331>,
      < -3.840905, -4.872707, 0.474656>
    }
    triangle {
      < -3.525503, -4.858645, 0.856764>,
      < -3.650504, -4.915636, 0.760976>,
      < -3.498511, -4.881388, 0.657414>
    }
    triangle {
      < -2.970495, -5.783869, 0.066662>,
      < -3.039448, -5.784328, 0.022500>,
      < -3.142778, -5.673025, -0.013236>
    }
    triangle {
      < -2.970495, -5.783869, 0.066662>,
      < -3.142778, -5.673025, -0.013236>,
      < -3.068909, -5.644910, 0.031059>
    }
    triangle {
      < -3.058576, -5.974609, 0.422769>,
      < -3.108755, -5.980817, 0.380630>,
      < -3.215080, -5.887108, 0.365910>
    }
    triangle {
      < -3.058576, -5.974609, 0.422769>,
      < -3.215080, -5.887108, 0.365910>,
      < -3.142598, -5.814617, 0.395572>
    }
    triangle {
      < -3.215080, -5.887108, 0.365910>,
      < -3.298786, -5.763205, 0.362287>,
      < -3.340641, -5.701254, 0.360480>
    }
    triangle {
      < -3.215080, -5.887108, 0.365910>,
      < -3.340641, -5.701254, 0.360480>,
      < -3.280637, -5.636574, 0.412913>
    }
    triangle {
      < -3.215080, -5.887108, 0.365910>,
      < -3.280637, -5.636574, 0.412913>,
      < -3.142598, -5.814617, 0.395572>
    }
    triangle {
      < -3.641114, -5.319808, 0.383361>,
      < -3.475449, -5.305753, 0.445597>,
      < -3.280637, -5.636574, 0.412913>
    }
    triangle {
      < -3.641114, -5.319808, 0.383361>,
      < -3.280637, -5.636574, 0.412913>,
      < -3.340641, -5.701254, 0.360480>
    }
    triangle {
      < -3.475449, -5.305753, 0.445597>,
      < -3.641114, -5.319808, 0.383361>,
      < -3.680832, -4.871781, 0.372331>
    }
    triangle {
      < -3.475449, -5.305753, 0.445597>,
      < -3.680832, -4.871781, 0.372331>,
      < -3.519503, -4.890442, 0.426109>
    }
    triangle {
      < -3.230269, -5.937195, 0.415929>,
      < -3.215080, -5.887108, 0.365910>,
      < -3.108755, -5.980817, 0.380630>
    }
    triangle {
      < -3.230269, -5.937195, 0.415929>,
      < -3.108755, -5.980817, 0.380630>,
      < -3.149762, -6.017935, 0.402476>
    }
    triangle {
      < -3.819031, -4.756149, 0.303078>,
      < -3.780772, -4.825399, 0.276605>,
      < -3.639382, -4.865031, 0.294500>
    }
    triangle {
      < -3.819031, -4.756149, 0.303078>,
      < -3.639382, -4.865031, 0.294500>,
      < -3.456233, -4.759103, 0.296852>
    }
    triangle {
      < -3.780772, -4.825399, 0.276605>,
      < -3.657932, -5.225744, 0.214498>,
      < -3.548440, -5.201604, 0.264880>
    }
    triangle {
      < -3.780772, -4.825399, 0.276605>,
      < -3.548440, -5.201604, 0.264880>,
      < -3.639382, -4.865031, 0.294500>
    }
    triangle {
      < -3.325341, -5.552524, 0.188479>,
      < -3.261086, -5.535859, 0.221632>,
      < -3.548440, -5.201604, 0.264880>
    }
    triangle {
      < -3.325341, -5.552524, 0.188479>,
      < -3.548440, -5.201604, 0.264880>,
      < -3.657932, -5.225744, 0.214498>
    }
    triangle {
      < -3.141093, -5.708465, 0.163081>,
      < -3.120829, -5.685888, 0.204650>,
      < -3.261086, -5.535859, 0.221632>
    }
    triangle {
      < -3.141093, -5.708465, 0.163081>,
      < -3.261086, -5.535859, 0.221632>,
      < -3.325341, -5.552524, 0.188479>
    }
    triangle {
      < -3.141093, -5.708465, 0.163081>,
      < -3.325341, -5.552524, 0.188479>,
      < -3.155939, -5.701127, 0.156862>
    }
    triangle {
      < -2.993125, -5.820805, 0.134664>,
      < -3.012648, -5.771694, 0.178818>,
      < -3.049350, -5.791834, 0.168228>
    }
    triangle {
      < -2.993125, -5.820805, 0.134664>,
      < -3.049350, -5.791834, 0.168228>,
      < -3.049008, -5.820407, 0.137574>
    }
    triangle {
      < -3.142778, -5.673025, -0.013236>,
      < -3.039448, -5.784328, 0.022500>,
      < -3.074443, -5.803917, 0.041438>
    }
    triangle {
      < -3.142778, -5.673025, -0.013236>,
      < -3.074443, -5.803917, 0.041438>,
      < -3.170379, -5.716518, 0.044165>
    }
    triangle {
      < -3.485918, -4.811015, 0.098699>,
      < -3.497663, -4.709856, 0.057938>,
      < -3.364325, -4.533445, 0.058658>
    }
    triangle {
      < -3.485918, -4.811015, 0.098699>,
      < -3.364325, -4.533445, 0.058658>,
      < -3.403350, -4.639856, 0.372886>
    }
    triangle {
      < -3.485918, -4.811015, 0.098699>,
      < -3.403350, -4.639856, 0.372886>,
      < -3.456233, -4.759103, 0.296852>
    }
    triangle {
      < -3.438591, -5.169542, 0.211200>,
      < -3.436683, -5.143003, 0.049550>,
      < -3.453093, -5.032336, 0.065934>
    }
    triangle {
      < -3.438591, -5.169542, 0.211200>,
      < -3.453093, -5.032336, 0.065934>,
      < -3.485918, -4.811015, 0.098699>
    }
    triangle {
      < -3.438591, -5.169542, 0.211200>,
      < -3.485918, -4.811015, 0.098699>,
      < -3.456233, -4.759103, 0.296852>
    }
    triangle {
      < -3.012648, -5.771694, 0.178818>,
      < -2.993125, -5.820805, 0.134664>,
      < -2.980297, -5.779233, 0.151208>
    }
    triangle {
      < -3.004417, -5.843048, 0.100626>,
      < -3.017643, -5.834864, 0.063272>,
      < -2.970495, -5.783869, 0.066662>
    }
    triangle {
      < -3.687103, -4.663103, 0.023185>,
      < -3.497663, -4.709856, 0.057938>,
      < -3.485918, -4.811015, 0.098699>
    }
    triangle {
      < -3.453093, -5.032336, 0.065934>,
      < -3.436683, -5.143003, 0.049550>,
      < -3.551537, -5.148163, -0.029729>
    }
    triangle {
      < -3.453093, -5.032336, 0.065934>,
      < -3.551537, -5.148163, -0.029729>,
      < -3.687103, -4.663103, 0.023185>
    }
    triangle {
      < -3.453093, -5.032336, 0.065934>,
      < -3.687103, -4.663103, 0.023185>,
      < -3.485918, -4.811015, 0.098699>
    }
    triangle {
      < -3.436683, -5.143003, 0.049550>,
      < -3.193631, -5.464435, 0.034744>,
      < -3.293422, -5.510409, -0.017459>
    }
    triangle {
      < -3.436683, -5.143003, 0.049550>,
      < -3.293422, -5.510409, -0.017459>,
      < -3.551537, -5.148163, -0.029729>
    }
    triangle {
      < -3.068909, -5.644910, 0.031059>,
      < -3.142778, -5.673025, -0.013236>,
      < -3.243208, -5.564615, -0.016052>
    }
    triangle {
      < -3.068909, -5.644910, 0.031059>,
      < -3.243208, -5.564615, -0.016052>,
      < -3.293422, -5.510409, -0.017459>
    }
    triangle {
      < -3.068909, -5.644910, 0.031059>,
      < -3.293422, -5.510409, -0.017459>,
      < -3.193631, -5.464435, 0.034744>
    }
    triangle {
      < -3.436683, -5.143003, 0.049550>,
      < -3.438591, -5.169542, 0.211200>,
      < -3.196105, -5.510826, 0.175614>
    }
    triangle {
      < -3.436683, -5.143003, 0.049550>,
      < -3.196105, -5.510826, 0.175614>,
      < -3.193631, -5.464435, 0.034744>
    }
    triangle {
      < -3.193631, -5.464435, 0.034744>,
      < -3.196105, -5.510826, 0.175614>,
      < -3.063355, -5.657243, 0.162309>
    }
    triangle {
      < -3.193631, -5.464435, 0.034744>,
      < -3.063355, -5.657243, 0.162309>,
      < -3.068909, -5.644910, 0.031059>
    }
    triangle {
      < -2.980297, -5.779233, 0.151208>,
      < -2.970495, -5.783869, 0.066662>,
      < -3.068909, -5.644910, 0.031059>
    }
    triangle {
      < -2.980297, -5.779233, 0.151208>,
      < -3.068909, -5.644910, 0.031059>,
      < -3.063355, -5.657243, 0.162309>
    }
    triangle {
      < -3.049350, -5.791834, 0.168228>,
      < -3.012648, -5.771694, 0.178818>,
      < -3.120829, -5.685888, 0.204650>
    }
    triangle {
      < -3.049350, -5.791834, 0.168228>,
      < -3.120829, -5.685888, 0.204650>,
      < -3.141093, -5.708465, 0.163081>
    }
    triangle {
      < -3.155939, -5.701127, 0.156862>,
      < -3.325341, -5.552524, 0.188479>,
      < -3.388301, -5.580028, 0.124869>
    }
    triangle {
      < -3.155939, -5.701127, 0.156862>,
      < -3.388301, -5.580028, 0.124869>,
      < -3.216337, -5.726731, 0.118775>
    }
    triangle {
      < -3.325341, -5.552524, 0.188479>,
      < -3.657932, -5.225744, 0.214498>,
      < -3.711217, -5.239375, 0.133680>
    }
    triangle {
      < -3.325341, -5.552524, 0.188479>,
      < -3.711217, -5.239375, 0.133680>,
      < -3.388301, -5.580028, 0.124869>
    }
    triangle {
      < -3.833309, -4.794936, 0.174423>,
      < -3.711217, -5.239375, 0.133680>,
      < -3.657932, -5.225744, 0.214498>
    }
    triangle {
      < -3.833309, -4.794936, 0.174423>,
      < -3.657932, -5.225744, 0.214498>,
      < -3.780772, -4.825399, 0.276605>
    }
    triangle {
      < -3.780772, -4.825399, 0.276605>,
      < -3.819031, -4.756149, 0.303078>,
      < -3.866155, -4.683072, 0.186399>
    }
    triangle {
      < -3.780772, -4.825399, 0.276605>,
      < -3.866155, -4.683072, 0.186399>,
      < -3.833309, -4.794936, 0.174423>
    }
    triangle {
      < -3.142778, -5.673025, -0.013236>,
      < -3.170379, -5.716518, 0.044165>,
      < -3.196241, -5.713139, 0.055022>
    }
    triangle {
      < -3.142778, -5.673025, -0.013236>,
      < -3.196241, -5.713139, 0.055022>,
      < -3.380490, -5.552703, 0.040199>
    }
    triangle {
      < -3.142778, -5.673025, -0.013236>,
      < -3.380490, -5.552703, 0.040199>,
      < -3.293422, -5.510409, -0.017459>
    }
    triangle {
      < -3.142778, -5.673025, -0.013236>,
      < -3.293422, -5.510409, -0.017459>,
      < -3.243208, -5.564615, -0.016052>
    }
    triangle {
      < -3.293422, -5.510409, -0.017459>,
      < -3.380490, -5.552703, 0.040199>,
      < -3.677980, -5.215698, 0.044134>
    }
    triangle {
      < -3.293422, -5.510409, -0.017459>,
      < -3.677980, -5.215698, 0.044134>,
      < -3.551537, -5.148163, -0.029729>
    }
    triangle {
      < -3.791321, -4.745622, 0.078156>,
      < -3.687103, -4.663103, 0.023185>,
      < -3.551537, -5.148163, -0.029729>
    }
    triangle {
      < -3.791321, -4.745622, 0.078156>,
      < -3.551537, -5.148163, -0.029729>,
      < -3.677980, -5.215698, 0.044134>
    }
    triangle {
      < -3.820560, -4.589967, 0.087331>,
      < -3.749773, -4.510483, -0.012252>,
      < -3.687103, -4.663103, 0.023185>
    }
    triangle {
      < -3.820560, -4.589967, 0.087331>,
      < -3.687103, -4.663103, 0.023185>,
      < -3.791321, -4.745622, 0.078156>
    }
    triangle {
      < -3.271461, -4.097725, 0.273542>,
      < -3.068497, -3.694562, 0.097358>,
      < -2.990301, -3.784639, 0.396786>
    }
    triangle {
      < -3.271461, -4.097725, 0.273542>,
      < -2.990301, -3.784639, 0.396786>,
      < -3.197434, -4.219485, 0.539804>
    }
    triangle {
      < -3.243130, -4.046298, -0.017936>,
      < -3.135177, -3.696051, -0.089524>,
      < -3.068497, -3.694562, 0.097358>
    }
    triangle {
      < -3.243130, -4.046298, -0.017936>,
      < -3.068497, -3.694562, 0.097358>,
      < -3.271461, -4.097725, 0.273542>
    }
    triangle {
      < -3.400201, -4.446900, 0.368092>,
      < -3.358401, -4.331690, 0.072509>,
      < -3.243130, -4.046298, -0.017936>
    }
    triangle {
      < -3.400201, -4.446900, 0.368092>,
      < -3.243130, -4.046298, -0.017936>,
      < -3.271461, -4.097725, 0.273542>
    }
    triangle {
      < -3.400201, -4.446900, 0.368092>,
      < -3.271461, -4.097725, 0.273542>,
      < -3.354759, -4.407702, 0.529355>
    }
    triangle {
      < -3.403350, -4.639856, 0.372886>,
      < -3.364325, -4.533445, 0.058658>,
      < -3.358401, -4.331690, 0.072509>
    }
    triangle {
      < -3.403350, -4.639856, 0.372886>,
      < -3.358401, -4.331690, 0.072509>,
      < -3.400201, -4.446900, 0.368092>
    }
    triangle {
      < -3.354759, -4.407702, 0.529355>,
      < -3.376643, -4.703335, 0.631060>,
      < -3.403350, -4.639856, 0.372886>
    }
    triangle {
      < -3.354759, -4.407702, 0.529355>,
      < -3.403350, -4.639856, 0.372886>,
      < -3.400201, -4.446900, 0.368092>
    }
    triangle {
      < -3.512556, -4.651647, -0.028831>,
      < -3.364325, -4.533445, 0.058658>,
      < -3.497663, -4.709856, 0.057938>
    }
    triangle {
      < -3.314325, -4.027246, -0.205350>,
      < -3.243130, -4.046298, -0.017936>,
      < -3.358401, -4.331690, 0.072509>
    }
    triangle {
      < -3.314325, -4.027246, -0.205350>,
      < -3.358401, -4.331690, 0.072509>,
      < -3.377950, -4.242374, -0.231630>
    }
    triangle {
      < -3.364325, -4.533445, 0.058658>,
      < -3.412204, -4.449575, -0.235962>,
      < -3.377950, -4.242374, -0.231630>
    }
    triangle {
      < -3.364325, -4.533445, 0.058658>,
      < -3.377950, -4.242374, -0.231630>,
      < -3.358401, -4.331690, 0.072509>
    }
    triangle {
      < -3.197434, -4.219485, 0.539804>,
      < -3.271274, -4.553491, 0.845122>,
      < -3.354759, -4.407702, 0.529355>
    }
    triangle {
      < -3.197434, -4.219485, 0.539804>,
      < -3.354759, -4.407702, 0.529355>,
      < -3.271461, -4.097725, 0.273542>
    }
    triangle {
      < -3.324410, -4.776068, 1.013156>,
      < -3.271274, -4.553491, 0.845122>,
      < -3.235652, -4.565553, 1.006618>
    }
    triangle {
      < -3.235652, -4.565553, 1.006618>,
      < -3.271274, -4.553491, 0.845122>,
      < -3.197434, -4.219485, 0.539804>
    }
    triangle {
      < -3.235652, -4.565553, 1.006618>,
      < -3.197434, -4.219485, 0.539804>,
      < -3.073454, -4.431412, 0.941757>
    }
    triangle {
      < -3.519503, -4.890442, 0.426109>,
      < -3.680832, -4.871781, 0.372331>,
      < -3.456233, -4.759103, 0.296852>
    }
    triangle {
      < -3.376643, -4.703335, 0.631060>,
      < -3.498511, -4.881388, 0.657414>,
      < -3.519503, -4.890442, 0.426109>
    }
    triangle {
      < -3.376643, -4.703335, 0.631060>,
      < -3.519503, -4.890442, 0.426109>,
      < -3.403350, -4.639856, 0.372886>
    }
    triangle {
      < -3.456882, -4.897809, -0.101509>,
      < -3.446507, -4.873538, -0.272530>,
      < -3.461453, -4.561948, -0.246288>
    }
    triangle {
      < -3.456882, -4.897809, -0.101509>,
      < -3.461453, -4.561948, -0.246288>,
      < -3.461182, -4.657507, -0.083460>
    }
    triangle {
      < -3.346880, -5.130281, -0.120578>,
      < -3.313482, -5.125708, -0.277979>,
      < -3.446507, -4.873538, -0.272530>
    }
    triangle {
      < -3.346880, -5.130281, -0.120578>,
      < -3.446507, -4.873538, -0.272530>,
      < -3.456882, -4.897809, -0.101509>
    }
    triangle {
      < -3.313482, -5.125708, -0.277979>,
      < -3.346880, -5.130281, -0.120578>,
      < -3.177206, -5.312306, -0.124534>
    }
    triangle {
      < -3.313482, -5.125708, -0.277979>,
      < -3.177206, -5.312306, -0.124534>,
      < -3.164551, -5.300739, -0.279181>
    }
    triangle {
      < -3.111749, -5.413926, -0.159047>,
      < -3.091261, -5.417274, -0.244750>,
      < -3.164551, -5.300739, -0.279181>
    }
    triangle {
      < -3.111749, -5.413926, -0.159047>,
      < -3.164551, -5.300739, -0.279181>,
      < -3.177206, -5.312306, -0.124534>
    }
    triangle {
      < -3.446507, -4.873538, -0.272530>,
      < -3.541634, -4.902719, -0.361870>,
      < -3.557271, -4.575253, -0.314636>
    }
    triangle {
      < -3.446507, -4.873538, -0.272530>,
      < -3.557271, -4.575253, -0.314636>,
      < -3.461453, -4.561948, -0.246288>
    }
    triangle {
      < -3.313482, -5.125708, -0.277979>,
      < -3.389684, -5.170204, -0.347680>,
      < -3.541634, -4.902719, -0.361870>
    }
    triangle {
      < -3.313482, -5.125708, -0.277979>,
      < -3.541634, -4.902719, -0.361870>,
      < -3.446507, -4.873538, -0.272530>
    }
    triangle {
      < -3.389684, -5.170204, -0.347680>,
      < -3.313482, -5.125708, -0.277979>,
      < -3.164551, -5.300739, -0.279181>
    }
    triangle {
      < -3.389684, -5.170204, -0.347680>,
      < -3.164551, -5.300739, -0.279181>,
      < -3.218018, -5.361663, -0.309225>
    }
    triangle {
      < -3.091261, -5.417274, -0.244750>,
      < -3.140325, -5.456113, -0.279372>,
      < -3.218018, -5.361663, -0.309225>
    }
    triangle {
      < -3.091261, -5.417274, -0.244750>,
      < -3.218018, -5.361663, -0.309225>,
      < -3.164551, -5.300739, -0.279181>
    }
    triangle {
      < -3.103222, -5.487276, -0.207282>,
      < -3.091261, -5.417274, -0.244750>,
      < -3.111749, -5.413926, -0.159047>
    }
    triangle {
      < -3.108019, -5.480084, -0.249201>,
      < -3.140325, -5.456113, -0.279372>,
      < -3.091261, -5.417274, -0.244750>
    }
    triangle {
      < -3.111749, -5.413926, -0.159047>,
      < -3.177206, -5.312306, -0.124534>,
      < -3.189222, -5.387946, -0.109955>
    }
    triangle {
      < -3.111749, -5.413926, -0.159047>,
      < -3.189222, -5.387946, -0.109955>,
      < -3.137978, -5.462011, -0.134840>
    }
    triangle {
      < -3.222092, -5.389814, -0.142920>,
      < -3.165883, -5.481662, -0.152199>,
      < -3.137978, -5.462011, -0.134840>
    }
    triangle {
      < -3.222092, -5.389814, -0.142920>,
      < -3.137978, -5.462011, -0.134840>,
      < -3.189222, -5.387946, -0.109955>
    }
    triangle {
      < -3.623229, -4.962186, -0.131394>,
      < -3.427206, -5.250150, -0.136576>,
      < -3.375304, -5.186841, -0.084050>
    }
    triangle {
      < -3.623229, -4.962186, -0.131394>,
      < -3.375304, -5.186841, -0.084050>,
      < -3.544179, -4.939861, -0.066314>
    }
    triangle {
      < -3.512556, -4.651647, -0.028831>,
      < -3.707675, -4.638666, -0.073645>,
      < -3.623229, -4.962186, -0.131394>
    }
    triangle {
      < -3.512556, -4.651647, -0.028831>,
      < -3.623229, -4.962186, -0.131394>,
      < -3.544179, -4.939861, -0.066314>
    }
    triangle {
      < -3.242743, -5.367341, -0.267206>,
      < -3.233992, -5.380470, -0.256286>,
      < -3.281411, -5.411036, -0.210920>
    }
    triangle {
      < -3.242743, -5.367341, -0.267206>,
      < -3.281411, -5.411036, -0.210920>,
      < -3.293084, -5.396710, -0.214851>
    }
    triangle {
      < -3.452394, -5.270232, -0.219996>,
      < -3.671307, -4.971681, -0.225062>,
      < -3.604485, -4.949396, -0.307969>
    }
    triangle {
      < -3.452394, -5.270232, -0.219996>,
      < -3.604485, -4.949396, -0.307969>,
      < -3.404628, -5.236587, -0.286603>
    }
    triangle {
      < -3.732185, -4.634325, -0.180645>,
      < -3.663128, -4.621632, -0.262480>,
      < -3.604485, -4.949396, -0.307969>
    }
    triangle {
      < -3.732185, -4.634325, -0.180645>,
      < -3.604485, -4.949396, -0.307969>,
      < -3.671307, -4.971681, -0.225062>
    }
    triangle {
      < -3.755457, -4.503113, -0.158990>,
      < -3.671955, -4.474066, -0.276357>,
      < -3.663128, -4.621632, -0.262480>
    }
    triangle {
      < -3.755457, -4.503113, -0.158990>,
      < -3.663128, -4.621632, -0.262480>,
      < -3.732185, -4.634325, -0.180645>
    }
    triangle {
      < -3.855826, -4.343190, -0.131656>,
      < -3.671955, -4.474066, -0.276357>,
      < -3.755457, -4.503113, -0.158990>
    }
    triangle {
      < -3.553879, -4.454062, -0.313867>,
      < -3.412204, -4.449575, -0.235962>,
      < -3.461453, -4.561948, -0.246288>
    }
    triangle {
      < -3.553879, -4.454062, -0.313867>,
      < -3.461453, -4.561948, -0.246288>,
      < -3.557271, -4.575253, -0.314636>
    }
    triangle {
      < -3.693901, -3.916591, -0.115516>,
      < -3.465101, -3.953986, -0.273622>,
      < -3.715068, -4.365313, -0.273409>
    }
    triangle {
      < -3.693901, -3.916591, -0.115516>,
      < -3.715068, -4.365313, -0.273409>,
      < -3.855826, -4.343190, -0.131656>
    }
    triangle {
      < -3.553879, -4.454062, -0.313867>,
      < -3.571329, -4.367672, -0.316899>,
      < -3.377950, -4.242374, -0.231630>
    }
    triangle {
      < -3.553879, -4.454062, -0.313867>,
      < -3.377950, -4.242374, -0.231630>,
      < -3.412204, -4.449575, -0.235962>
    }
    triangle {
      < -3.423148, -3.594702, -0.219296>,
      < -3.208692, -3.670273, -0.155483>,
      < -3.314325, -4.027246, -0.205350>
    }
    triangle {
      < -3.423148, -3.594702, -0.219296>,
      < -3.314325, -4.027246, -0.205350>,
      < -3.465101, -3.953986, -0.273622>
    }
    triangle {
      < -3.400748, -3.266075, -0.161594>,
      < -3.101251, -3.307032, -0.110100>,
      < -3.208692, -3.670273, -0.155483>
    }
    triangle {
      < -3.400748, -3.266075, -0.161594>,
      < -3.208692, -3.670273, -0.155483>,
      < -3.423148, -3.594702, -0.219296>
    }
    triangle {
      < -3.135177, -3.696051, -0.089524>,
      < -3.208692, -3.670273, -0.155483>,
      < -3.101251, -3.307032, -0.110100>
    }
    triangle {
      < -3.243130, -4.046298, -0.017936>,
      < -3.314325, -4.027246, -0.205350>,
      < -3.208692, -3.670273, -0.155483>
    }
    triangle {
      < -3.243130, -4.046298, -0.017936>,
      < -3.208692, -3.670273, -0.155483>,
      < -3.135177, -3.696051, -0.089524>
    }
    triangle {
      < -3.101251, -3.307032, -0.110100>,
      < -3.000942, -3.360298, 0.240543>,
      < -3.068497, -3.694562, 0.097358>
    }
    triangle {
      < -3.101251, -3.307032, -0.110100>,
      < -3.068497, -3.694562, 0.097358>,
      < -3.135177, -3.696051, -0.089524>
    }
    triangle {
      < -3.000942, -3.360298, 0.240543>,
      < -2.948871, -3.072044, 0.233427>,
      < -2.914910, -3.123339, 0.588616>
    }
    triangle {
      < -3.000942, -3.360298, 0.240543>,
      < -2.914910, -3.123339, 0.588616>,
      < -2.853162, -3.365846, 0.637326>
    }
    triangle {
      < -3.000942, -3.360298, 0.240543>,
      < -2.853162, -3.365846, 0.637326>,
      < -2.923318, -3.466007, 0.391588>
    }
    triangle {
      < -2.853162, -3.365846, 0.637326>,
      < -2.704204, -3.806584, 0.684968>,
      < -2.923318, -3.466007, 0.391588>
    }
    triangle {
      < -2.990301, -3.784639, 0.396786>,
      < -3.068497, -3.694562, 0.097358>,
      < -3.000942, -3.360298, 0.240543>
    }
    triangle {
      < -2.713652, -3.719675, 0.943718>,
      < -2.704204, -3.806584, 0.684968>,
      < -2.853162, -3.365846, 0.637326>
    }
    triangle {
      < -2.713652, -3.719675, 0.943718>,
      < -2.853162, -3.365846, 0.637326>,
      < -2.876625, -3.360112, 0.793590>
    }
    triangle {
      < -3.423148, -3.594702, -0.219296>,
      < -3.752286, -3.343208, 0.085041>,
      < -3.599305, -3.225931, -0.043476>
    }
    triangle {
      < -3.465101, -3.953986, -0.273622>,
      < -3.693901, -3.916591, -0.115516>,
      < -3.752286, -3.343208, 0.085041>
    }
    triangle {
      < -3.465101, -3.953986, -0.273622>,
      < -3.752286, -3.343208, 0.085041>,
      < -3.423148, -3.594702, -0.219296>
    }
    triangle {
      < -3.870004, -4.337597, 0.578456>,
      < -3.783816, -3.880267, 0.562139>,
      < -3.789576, -3.907470, 0.254377>
    }
    triangle {
      < -3.870004, -4.337597, 0.578456>,
      < -3.789576, -3.907470, 0.254377>,
      < -3.858342, -4.321498, 0.208042>
    }
    triangle {
      < -3.870004, -4.337597, 0.578456>,
      < -3.858342, -4.321498, 0.208042>,
      < -3.873947, -4.364538, 0.447579>
    }
    triangle {
      < -3.789576, -3.907470, 0.254377>,
      < -3.703852, -3.358929, 0.249468>,
      < -3.752286, -3.343208, 0.085041>
    }
    triangle {
      < -3.789576, -3.907470, 0.254377>,
      < -3.752286, -3.343208, 0.085041>,
      < -3.693901, -3.916591, -0.115516>
    }
    triangle {
      < -3.783816, -3.880267, 0.562139>,
      < -3.675314, -3.326316, 0.542915>,
      < -3.703852, -3.358929, 0.249468>
    }
    triangle {
      < -3.783816, -3.880267, 0.562139>,
      < -3.703852, -3.358929, 0.249468>,
      < -3.789576, -3.907470, 0.254377>
    }
    triangle {
      < -3.744563, -2.991360, 0.261601>,
      < -3.722475, -2.954857, -0.047674>,
      < -3.752286, -3.343208, 0.085041>
    }
    triangle {
      < -3.744563, -2.991360, 0.261601>,
      < -3.752286, -3.343208, 0.085041>,
      < -3.703852, -3.358929, 0.249468>
    }
    triangle {
      < -3.661297, -3.005761, 0.488316>,
      < -3.744563, -2.991360, 0.261601>,
      < -3.703852, -3.358929, 0.249468>
    }
    triangle {
      < -3.661297, -3.005761, 0.488316>,
      < -3.703852, -3.358929, 0.249468>,
      < -3.675314, -3.326316, 0.542915>
    }
    triangle {
      < -3.612877, -3.003972, 0.647348>,
      < -3.661297, -3.005761, 0.488316>,
      < -3.675314, -3.326316, 0.542915>
    }
    triangle {
      < -3.612877, -3.003972, 0.647348>,
      < -3.675314, -3.326316, 0.542915>,
      < -3.613293, -3.303538, 0.713008>
    }
    triangle {
      < -3.822417, -4.339959, 0.033673>,
      < -3.858342, -4.321498, 0.208042>,
      < -3.789576, -3.907470, 0.254377>
    }
    triangle {
      < -3.822417, -4.339959, 0.033673>,
      < -3.789576, -3.907470, 0.254377>,
      < -3.693901, -3.916591, -0.115516>
    }
    triangle {
      < -3.822417, -4.339959, 0.033673>,
      < -3.693901, -3.916591, -0.115516>,
      < -3.855826, -4.343190, -0.131656>
    }
    triangle {
      < -3.261235, -3.085547, 0.931902>,
      < -3.459755, -3.017162, 0.863932>,
      < -3.444501, -3.301727, 0.923484>
    }
    triangle {
      < -3.261235, -3.085547, 0.931902>,
      < -3.444501, -3.301727, 0.923484>,
      < -3.222924, -3.353535, 1.002504>
    }
    triangle {
      < -3.459755, -3.017162, 0.863932>,
      < -3.612877, -3.003972, 0.647348>,
      < -3.613293, -3.303538, 0.713008>
    }
    triangle {
      < -3.459755, -3.017162, 0.863932>,
      < -3.613293, -3.303538, 0.713008>,
      < -3.444501, -3.301727, 0.923484>
    }
    triangle {
      < -2.999575, -3.309280, 0.968456>,
      < -3.031742, -3.107454, 0.928309>,
      < -3.261235, -3.085547, 0.931902>
    }
    triangle {
      < -2.999575, -3.309280, 0.968456>,
      < -3.261235, -3.085547, 0.931902>,
      < -3.222924, -3.353535, 1.002504>
    }
    triangle {
      < -3.201631, -3.744820, 1.164047>,
      < -2.903923, -3.680026, 1.129989>,
      < -2.999575, -3.309280, 0.968456>
    }
    triangle {
      < -3.201631, -3.744820, 1.164047>,
      < -2.999575, -3.309280, 0.968456>,
      < -3.222924, -3.353535, 1.002504>
    }
    triangle {
      < -2.914910, -3.123339, 0.588616>,
      < -2.759688, -2.284769, 0.472808>,
      < -2.940914, -2.243228, 0.777409>
    }
    triangle {
      < -2.914910, -3.123339, 0.588616>,
      < -2.940914, -2.243228, 0.777409>,
      < -3.031742, -3.107454, 0.928309>
    }
    triangle {
      < -2.914910, -3.123339, 0.588616>,
      < -3.031742, -3.107454, 0.928309>,
      < -2.999575, -3.309280, 0.968456>
    }
    triangle {
      < -2.914910, -3.123339, 0.588616>,
      < -2.999575, -3.309280, 0.968456>,
      < -2.876625, -3.360112, 0.793590>
    }
    triangle {
      < -2.914910, -3.123339, 0.588616>,
      < -2.876625, -3.360112, 0.793590>,
      < -2.853162, -3.365846, 0.637326>
    }
    triangle {
      < -3.048708, -3.013967, -0.064947>,
      < -2.948871, -3.072044, 0.233427>,
      < -3.000942, -3.360298, 0.240543>
    }
    triangle {
      < -3.048708, -3.013967, -0.064947>,
      < -3.000942, -3.360298, 0.240543>,
      < -3.101251, -3.307032, -0.110100>
    }
    triangle {
      < -2.906696, -2.229177, -0.106366>,
      < -2.796178, -2.243745, 0.149603>,
      < -2.948871, -3.072044, 0.233427>
    }
    triangle {
      < -2.906696, -2.229177, -0.106366>,
      < -2.948871, -3.072044, 0.233427>,
      < -3.048708, -3.013967, -0.064947>
    }
    triangle {
      < -2.914910, -3.123339, 0.588616>,
      < -2.948871, -3.072044, 0.233427>,
      < -2.796178, -2.243745, 0.149603>
    }
    triangle {
      < -2.914910, -3.123339, 0.588616>,
      < -2.796178, -2.243745, 0.149603>,
      < -2.759688, -2.284769, 0.472808>
    }
    triangle {
      < -3.400748, -3.266075, -0.161594>,
      < -3.423148, -3.594702, -0.219296>,
      < -3.599305, -3.225931, -0.043476>
    }
    triangle {
      < -3.360919, -2.933254, -0.166444>,
      < -3.048708, -3.013967, -0.064947>,
      < -3.101251, -3.307032, -0.110100>
    }
    triangle {
      < -3.360919, -2.933254, -0.166444>,
      < -3.101251, -3.307032, -0.110100>,
      < -3.400748, -3.266075, -0.161594>
    }
    triangle {
      < -3.283058, -2.214731, -0.242483>,
      < -2.906696, -2.229177, -0.106366>,
      < -3.048708, -3.013967, -0.064947>
    }
    triangle {
      < -3.283058, -2.214731, -0.242483>,
      < -3.048708, -3.013967, -0.064947>,
      < -3.360919, -2.933254, -0.166444>
    }
    triangle {
      < -3.722475, -2.954857, -0.047674>,
      < -3.360919, -2.933254, -0.166444>,
      < -3.400748, -3.266075, -0.161594>
    }
    triangle {
      < -3.722475, -2.954857, -0.047674>,
      < -3.400748, -3.266075, -0.161594>,
      < -3.599305, -3.225931, -0.043476>
    }
    triangle {
      < -3.647496, -2.193329, -0.109512>,
      < -3.283058, -2.214731, -0.242483>,
      < -3.360919, -2.933254, -0.166444>
    }
    triangle {
      < -3.647496, -2.193329, -0.109512>,
      < -3.360919, -2.933254, -0.166444>,
      < -3.722475, -2.954857, -0.047674>
    }
    triangle {
      < -3.744563, -2.991360, 0.261601>,
      < -3.739547, -2.255244, 0.220017>,
      < -3.647496, -2.193329, -0.109512>
    }
    triangle {
      < -3.744563, -2.991360, 0.261601>,
      < -3.647496, -2.193329, -0.109512>,
      < -3.722475, -2.954857, -0.047674>
    }
    triangle {
      < -3.661297, -3.005761, 0.488316>,
      < -3.672426, -2.254568, 0.464542>,
      < -3.739547, -2.255244, 0.220017>
    }
    triangle {
      < -3.661297, -3.005761, 0.488316>,
      < -3.739547, -2.255244, 0.220017>,
      < -3.744563, -2.991360, 0.261601>
    }
    triangle {
      < -3.612877, -3.003972, 0.647348>,
      < -3.610453, -2.236604, 0.675438>,
      < -3.672426, -2.254568, 0.464542>
    }
    triangle {
      < -3.612877, -3.003972, 0.647348>,
      < -3.672426, -2.254568, 0.464542>,
      < -3.661297, -3.005761, 0.488316>
    }
    triangle {
      < -3.459755, -3.017162, 0.863932>,
      < -3.450000, -2.224814, 0.871098>,
      < -3.610453, -2.236604, 0.675438>
    }
    triangle {
      < -3.459755, -3.017162, 0.863932>,
      < -3.610453, -2.236604, 0.675438>,
      < -3.612877, -3.003972, 0.647348>
    }
    triangle {
      < -3.459755, -3.017162, 0.863932>,
      < -3.261235, -3.085547, 0.931902>,
      < -3.105591, -2.217616, 0.883761>
    }
    triangle {
      < -3.459755, -3.017162, 0.863932>,
      < -3.105591, -2.217616, 0.883761>,
      < -3.450000, -2.224814, 0.871098>
    }
    triangle {
      < -2.940914, -2.243228, 0.777409>,
      < -3.105591, -2.217616, 0.883761>,
      < -3.261235, -3.085547, 0.931902>
    }
    triangle {
      < -2.940914, -2.243228, 0.777409>,
      < -3.261235, -3.085547, 0.931902>,
      < -3.031742, -3.107454, 0.928309>
    }
    triangle {
      < -2.846456, -1.229834, 0.857554>,
      < -3.236061, -1.194528, 0.988761>,
      < -3.450000, -2.224814, 0.871098>
    }
    triangle {
      < -2.846456, -1.229834, 0.857554>,
      < -3.450000, -2.224814, 0.871098>,
      < -3.105591, -2.217616, 0.883761>
    }
    triangle {
      < -2.940914, -2.243228, 0.777409>,
      < -2.603119, -1.251225, 0.631441>,
      < -2.846456, -1.229834, 0.857554>
    }
    triangle {
      < -2.940914, -2.243228, 0.777409>,
      < -2.846456, -1.229834, 0.857554>,
      < -3.105591, -2.217616, 0.883761>
    }
    triangle {
      < -2.759688, -2.284769, 0.472808>,
      < -2.462617, -1.263338, 0.278344>,
      < -2.603119, -1.251225, 0.631441>
    }
    triangle {
      < -2.759688, -2.284769, 0.472808>,
      < -2.603119, -1.251225, 0.631441>,
      < -2.940914, -2.243228, 0.777409>
    }
    triangle {
      < -2.796178, -2.243745, 0.149603>,
      < -2.489793, -1.260167, -0.053393>,
      < -2.462617, -1.263338, 0.278344>
    }
    triangle {
      < -2.796178, -2.243745, 0.149603>,
      < -2.462617, -1.263338, 0.278344>,
      < -2.759688, -2.284769, 0.472808>
    }
    triangle {
      < -2.906696, -2.229177, -0.106366>,
      < -2.746340, -1.238220, -0.282059>,
      < -2.489793, -1.260167, -0.053393>
    }
    triangle {
      < -2.906696, -2.229177, -0.106366>,
      < -2.489793, -1.260167, -0.053393>,
      < -2.796178, -2.243745, 0.149603>
    }
    triangle {
      < -3.647496, -2.193329, -0.109512>,
      < -3.680506, -1.156399, -0.148684>,
      < -3.249544, -1.193210, -0.446053>
    }
    triangle {
      < -3.647496, -2.193329, -0.109512>,
      < -3.249544, -1.193210, -0.446053>,
      < -3.283058, -2.214731, -0.242483>
    }
    triangle {
      < -2.906696, -2.229177, -0.106366>,
      < -3.283058, -2.214731, -0.242483>,
      < -3.249544, -1.193210, -0.446053>
    }
    triangle {
      < -2.906696, -2.229177, -0.106366>,
      < -3.249544, -1.193210, -0.446053>,
      < -2.746340, -1.238220, -0.282059>
    }
    triangle {
      < -3.739547, -2.255244, 0.220017>,
      < -3.799026, -1.145475, 0.247541>,
      < -3.680506, -1.156399, -0.148684>
    }
    triangle {
      < -3.739547, -2.255244, 0.220017>,
      < -3.680506, -1.156399, -0.148684>,
      < -3.647496, -2.193329, -0.109512>
    }
    triangle {
      < -3.672426, -2.254568, 0.464542>,
      < -3.763706, -1.148521, 0.569785>,
      < -3.799026, -1.145475, 0.247541>
    }
    triangle {
      < -3.672426, -2.254568, 0.464542>,
      < -3.799026, -1.145475, 0.247541>,
      < -3.739547, -2.255244, 0.220017>
    }
    triangle {
      < -3.610453, -2.236604, 0.675438>,
      < -3.580457, -1.165438, 0.825006>,
      < -3.763706, -1.148521, 0.569785>
    }
    triangle {
      < -3.610453, -2.236604, 0.675438>,
      < -3.763706, -1.148521, 0.569785>,
      < -3.672426, -2.254568, 0.464542>
    }
    triangle {
      < -3.450000, -2.224814, 0.871098>,
      < -3.236061, -1.194528, 0.988761>,
      < -3.580457, -1.165438, 0.825006>
    }
    triangle {
      < -3.450000, -2.224814, 0.871098>,
      < -3.580457, -1.165438, 0.825006>,
      < -3.610453, -2.236604, 0.675438>
    }
    triangle {
      < -3.236061, -1.194528, 0.988761>,
      < -3.079602, -0.272644, 0.990726>,
      < -3.584816, -0.259706, 0.871421>
    }
    triangle {
      < -3.236061, -1.194528, 0.988761>,
      < -3.584816, -0.259706, 0.871421>,
      < -3.580457, -1.165438, 0.825006>
    }
    triangle {
      < -2.846456, -1.229834, 0.857554>,
      < -2.599851, -0.304157, 0.877433>,
      < -3.079602, -0.272644, 0.990726>
    }
    triangle {
      < -2.846456, -1.229834, 0.857554>,
      < -3.079602, -0.272644, 0.990726>,
      < -3.236061, -1.194528, 0.988761>
    }
    triangle {
      < -2.603119, -1.251225, 0.631441>,
      < -2.374817, -0.345360, 0.504614>,
      < -2.599851, -0.304157, 0.877433>
    }
    triangle {
      < -2.603119, -1.251225, 0.631441>,
      < -2.599851, -0.304157, 0.877433>,
      < -2.846456, -1.229834, 0.857554>
    }
    triangle {
      < -2.462617, -1.263338, 0.278344>,
      < -2.270152, -0.378846, 0.098363>,
      < -2.374817, -0.345360, 0.504614>
    }
    triangle {
      < -2.462617, -1.263338, 0.278344>,
      < -2.374817, -0.345360, 0.504614>,
      < -2.603119, -1.251225, 0.631441>
    }
    triangle {
      < -2.489793, -1.260167, -0.053393>,
      < -2.377485, -0.347431, -0.200958>,
      < -2.270152, -0.378846, 0.098363>
    }
    triangle {
      < -2.489793, -1.260167, -0.053393>,
      < -2.270152, -0.378846, 0.098363>,
      < -2.462617, -1.263338, 0.278344>
    }
    triangle {
      < -2.746340, -1.238220, -0.282059>,
      < -2.692744, -0.302287, -0.429027>,
      < -2.377485, -0.347431, -0.200958>
    }
    triangle {
      < -2.746340, -1.238220, -0.282059>,
      < -2.377485, -0.347431, -0.200958>,
      < -2.489793, -1.260167, -0.053393>
    }
    triangle {
      < -3.249544, -1.193210, -0.446053>,
      < -3.150655, -0.294560, -0.511985>,
      < -2.692744, -0.302287, -0.429027>
    }
    triangle {
      < -3.249544, -1.193210, -0.446053>,
      < -2.692744, -0.302287, -0.429027>,
      < -2.746340, -1.238220, -0.282059>
    }
    triangle {
      < -3.680506, -1.156399, -0.148684>,
      < -3.493797, -0.241574, -0.177637>,
      < -3.150655, -0.294560, -0.511985>
    }
    triangle {
      < -3.680506, -1.156399, -0.148684>,
      < -3.150655, -0.294560, -0.511985>,
      < -3.249544, -1.193210, -0.446053>
    }
    triangle {
      < -3.799026, -1.145475, 0.247541>,
      < -3.644981, -0.239785, 0.250997>,
      < -3.493797, -0.241574, -0.177637>
    }
    triangle {
      < -3.799026, -1.145475, 0.247541>,
      < -3.493797, -0.241574, -0.177637>,
      < -3.680506, -1.156399, -0.148684>
    }
    triangle {
      < -3.763706, -1.148521, 0.569785>,
      < -3.704188, -0.251920, 0.601294>,
      < -3.644981, -0.239785, 0.250997>
    }
    triangle {
      < -3.763706, -1.148521, 0.569785>,
      < -3.644981, -0.239785, 0.250997>,
      < -3.799026, -1.145475, 0.247541>
    }
    triangle {
      < -3.580457, -1.165438, 0.825006>,
      < -3.584816, -0.259706, 0.871421>,
      < -3.704188, -0.251920, 0.601294>
    }
    triangle {
      < -3.580457, -1.165438, 0.825006>,
      < -3.704188, -0.251920, 0.601294>,
      < -3.763706, -1.148521, 0.569785>
    }
    triangle {
      < -3.111749, -5.413926, -0.159047>,
      < -3.137978, -5.462011, -0.134840>,
      < -3.121146, -5.484527, -0.155941>
    }
    triangle {
      < -2.606242, -4.997890, 1.062551>,
      < -2.676981, -5.016549, 0.977451>,
      < -2.703791, -4.743211, 0.972488>
    }
    triangle {
      < -2.606242, -4.997890, 1.062551>,
      < -2.703791, -4.743211, 0.972488>,
      < -2.643964, -4.725788, 1.080201>
    }
    triangle {
      < -3.571329, -4.367672, -0.316899>,
      < -3.553879, -4.454062, -0.313867>,
      < -3.671955, -4.474066, -0.276357>
    }
    triangle {
      < -3.571329, -4.367672, -0.316899>,
      < -3.671955, -4.474066, -0.276357>,
      < -3.715068, -4.365313, -0.273409>
    }
    triangle {
      < -3.553879, -4.454062, -0.313867>,
      < -3.557271, -4.575253, -0.314636>,
      < -3.663128, -4.621632, -0.262480>
    }
    triangle {
      < -3.553879, -4.454062, -0.313867>,
      < -3.663128, -4.621632, -0.262480>,
      < -3.671955, -4.474066, -0.276357>
    }
    triangle {
      < -3.557271, -4.575253, -0.314636>,
      < -3.541634, -4.902719, -0.361870>,
      < -3.604485, -4.949396, -0.307969>
    }
    triangle {
      < -3.557271, -4.575253, -0.314636>,
      < -3.604485, -4.949396, -0.307969>,
      < -3.663128, -4.621632, -0.262480>
    }
    triangle {
      < -3.389684, -5.170204, -0.347680>,
      < -3.404628, -5.236587, -0.286603>,
      < -3.604485, -4.949396, -0.307969>
    }
    triangle {
      < -3.389684, -5.170204, -0.347680>,
      < -3.604485, -4.949396, -0.307969>,
      < -3.541634, -4.902719, -0.361870>
    }
    triangle {
      < -3.227041, -5.375122, -0.272112>,
      < -3.233992, -5.380470, -0.256286>,
      < -3.242743, -5.367341, -0.267206>
    }
    triangle {
      < -3.218018, -5.361663, -0.309225>,
      < -3.140325, -5.456113, -0.279372>,
      < -3.159483, -5.465992, -0.270949>
    }
    triangle {
      < -3.218018, -5.361663, -0.309225>,
      < -3.159483, -5.465992, -0.270949>,
      < -3.227041, -5.375122, -0.272112>
    }
    triangle {
      < -3.749773, -4.510483, -0.012252>,
      < -3.707675, -4.638666, -0.073645>,
      < -3.687103, -4.663103, 0.023185>
    }
    triangle {
      < -3.707675, -4.638666, -0.073645>,
      < -3.512556, -4.651647, -0.028831>,
      < -3.497663, -4.709856, 0.057938>
    }
    triangle {
      < -3.707675, -4.638666, -0.073645>,
      < -3.497663, -4.709856, 0.057938>,
      < -3.687103, -4.663103, 0.023185>
    }
    triangle {
      < -3.544179, -4.939861, -0.066314>,
      < -3.456882, -4.897809, -0.101509>,
      < -3.461182, -4.657507, -0.083460>
    }
    triangle {
      < -3.544179, -4.939861, -0.066314>,
      < -3.461182, -4.657507, -0.083460>,
      < -3.512556, -4.651647, -0.028831>
    }
    triangle {
      < -3.346880, -5.130281, -0.120578>,
      < -3.456882, -4.897809, -0.101509>,
      < -3.544179, -4.939861, -0.066314>
    }
    triangle {
      < -3.346880, -5.130281, -0.120578>,
      < -3.544179, -4.939861, -0.066314>,
      < -3.375304, -5.186841, -0.084050>
    }
    triangle {
      < -3.346880, -5.130281, -0.120578>,
      < -3.375304, -5.186841, -0.084050>,
      < -3.189222, -5.387946, -0.109955>
    }
    triangle {
      < -3.346880, -5.130281, -0.120578>,
      < -3.189222, -5.387946, -0.109955>,
      < -3.177206, -5.312306, -0.124534>
    }
    triangle {
      < -3.550858, -5.907750, 0.973820>,
      < -3.522264, -6.025560, 0.965866>,
      < -3.505869, -6.028747, 0.966244>
    }
    triangle {
      < -3.550858, -5.907750, 0.973820>,
      < -3.505869, -6.028747, 0.966244>,
      < -3.531374, -5.903006, 0.994906>
    }
    triangle {
      < -3.522806, -5.152845, 0.852173>,
      < -3.543149, -5.294589, 0.850091>,
      < -3.649614, -5.325970, 0.777320>
    }
    triangle {
      < -3.522806, -5.152845, 0.852173>,
      < -3.649614, -5.325970, 0.777320>,
      < -3.650504, -4.915636, 0.760976>
    }
    triangle {
      < -3.522806, -5.152845, 0.852173>,
      < -3.650504, -4.915636, 0.760976>,
      < -3.525503, -4.858645, 0.856764>
    }
    triangle {
      < -3.012648, -5.771694, 0.178818>,
      < -2.980297, -5.779233, 0.151208>,
      < -3.063355, -5.657243, 0.162309>
    }
    triangle {
      < -3.012648, -5.771694, 0.178818>,
      < -3.063355, -5.657243, 0.162309>,
      < -3.120829, -5.685888, 0.204650>
    }
    triangle {
      < -3.238530, -5.390752, -0.159403>,
      < -3.222092, -5.389814, -0.142920>,
      < -3.253295, -5.378718, -0.152609>
    }
    triangle {
      < -3.000942, -3.360298, 0.240543>,
      < -2.923318, -3.466007, 0.391588>,
      < -2.990301, -3.784639, 0.396786>
    }
    triangle {
      < -3.063355, -5.657243, 0.162309>,
      < -3.196105, -5.510826, 0.175614>,
      < -3.261086, -5.535859, 0.221632>
    }
    triangle {
      < -3.063355, -5.657243, 0.162309>,
      < -3.261086, -5.535859, 0.221632>,
      < -3.120829, -5.685888, 0.204650>
    }
    triangle {
      < -3.548440, -5.201604, 0.264880>,
      < -3.261086, -5.535859, 0.221632>,
      < -3.196105, -5.510826, 0.175614>
    }
    triangle {
      < -3.548440, -5.201604, 0.264880>,
      < -3.196105, -5.510826, 0.175614>,
      < -3.438591, -5.169542, 0.211200>
    }
    triangle {
      < -3.548440, -5.201604, 0.264880>,
      < -3.438591, -5.169542, 0.211200>,
      < -3.456233, -4.759103, 0.296852>
    }
    triangle {
      < -3.548440, -5.201604, 0.264880>,
      < -3.456233, -4.759103, 0.296852>,
      < -3.639382, -4.865031, 0.294500>
    }
    triangle {
      < -3.519503, -4.890442, 0.426109>,
      < -3.456233, -4.759103, 0.296852>,
      < -3.403350, -4.639856, 0.372886>
    }
    triangle {
      < -3.456233, -4.759103, 0.296852>,
      < -3.680832, -4.871781, 0.372331>,
      < -3.819031, -4.756149, 0.303078>
    }
    triangle {
      < -3.074443, -5.803917, 0.041438>,
      < -3.039448, -5.784328, 0.022500>,
      < -3.017643, -5.834864, 0.063272>
    }
    triangle {
      < -3.074443, -5.803917, 0.041438>,
      < -3.017643, -5.834864, 0.063272>,
      < -3.061577, -5.826604, 0.076622>
    }
    triangle {
      < -3.159483, -5.465992, -0.270949>,
      < -3.140325, -5.456113, -0.279372>,
      < -3.108019, -5.480084, -0.249201>
    }
    triangle {
      < -3.159483, -5.465992, -0.270949>,
      < -3.108019, -5.480084, -0.249201>,
      < -3.137688, -5.489302, -0.242971>
    }
    triangle {
      < -3.562773, -6.024592, 0.815694>,
      < -3.605893, -5.908008, 0.839344>,
      < -3.572496, -5.890628, 0.808892>
    }
    triangle {
      < -3.562773, -6.024592, 0.815694>,
      < -3.572496, -5.890628, 0.808892>,
      < -3.534503, -6.017144, 0.802934>
    }
    triangle {
      < -3.364325, -4.533445, 0.058658>,
      < -3.461182, -4.657507, -0.083460>,
      < -3.461453, -4.561948, -0.246288>
    }
    triangle {
      < -3.364325, -4.533445, 0.058658>,
      < -3.461453, -4.561948, -0.246288>,
      < -3.412204, -4.449575, -0.235962>
    }
    triangle {
      < -3.364325, -4.533445, 0.058658>,
      < -3.512556, -4.651647, -0.028831>,
      < -3.461182, -4.657507, -0.083460>
    }
    triangle {
      < -3.803743, -4.753818, 0.693033>,
      < -3.978867, -4.556856, 0.590013>,
      < -3.872860, -4.762247, 0.594336>
    }
    triangle {
      < -3.571329, -4.367672, -0.316899>,
      < -3.465101, -3.953986, -0.273622>,
      < -3.314325, -4.027246, -0.205350>
    }
    triangle {
      < -3.571329, -4.367672, -0.316899>,
      < -3.314325, -4.027246, -0.205350>,
      < -3.377950, -4.242374, -0.231630>
    }
    triangle {
      < -3.324410, -4.776068, 1.013156>,
      < -3.376643, -4.703335, 0.631060>,
      < -3.354759, -4.407702, 0.529355>
    }
    triangle {
      < -3.324410, -4.776068, 1.013156>,
      < -3.354759, -4.407702, 0.529355>,
      < -3.271274, -4.553491, 0.845122>
    }
    triangle {
      < -2.990301, -3.784639, 0.396786>,
      < -2.899165, -4.345756, 0.831593>,
      < -3.073454, -4.431412, 0.941757>
    }
    triangle {
      < -2.903923, -3.680026, 1.129989>,
      < -3.201631, -3.744820, 1.164047>,
      < -3.171760, -4.101448, 1.247475>
    }
    triangle {
      < -2.903923, -3.680026, 1.129989>,
      < -3.171760, -4.101448, 1.247475>,
      < -2.973360, -4.269324, 1.317931>
    }
    triangle {
      < -3.465101, -3.953986, -0.273622>,
      < -3.571329, -4.367672, -0.316899>,
      < -3.715068, -4.365313, -0.273409>
    }
    triangle {
      < -2.704204, -3.806584, 0.684968>,
      < -2.990301, -3.784639, 0.396786>,
      < -2.923318, -3.466007, 0.391588>
    }
    triangle {
      < -3.146393, -6.072251, 0.535676>,
      < -3.151881, -6.024515, 0.556160>,
      < -3.226502, -5.923387, 0.560858>
    }
    triangle {
      < -3.146393, -6.072251, 0.535676>,
      < -3.226502, -5.923387, 0.560858>,
      < -3.285124, -5.948591, 0.498650>
    }
    triangle {
      < -3.146393, -6.072251, 0.535676>,
      < -3.285124, -5.948591, 0.498650>,
      < -3.150421, -6.097242, 0.485310>
    }
    triangle {
      < -3.610975, -5.919303, 0.919372>,
      < -3.605893, -5.908008, 0.839344>,
      < -3.562773, -6.024592, 0.815694>
    }
    triangle {
      < -3.610975, -5.919303, 0.919372>,
      < -3.562773, -6.024592, 0.815694>,
      < -3.538268, -6.066545, 0.844955>
    }
    triangle {
      < -3.610975, -5.919303, 0.919372>,
      < -3.538268, -6.066545, 0.844955>,
      < -3.531293, -6.078069, 0.882219>
    }
    triangle {
      < -3.060814, -5.828017, 0.134598>,
      < -3.071395, -5.801376, 0.160804>,
      < -3.155772, -5.712716, 0.152194>
    }
    triangle {
      < -3.060814, -5.828017, 0.134598>,
      < -3.155772, -5.712716, 0.152194>,
      < -3.196340, -5.733409, 0.114749>
    }
    triangle {
      < -3.060814, -5.828017, 0.134598>,
      < -3.196340, -5.733409, 0.114749>,
      < -3.067862, -5.842321, 0.111463>
    }
    triangle {
      < -3.281411, -5.411036, -0.210920>,
      < -3.233992, -5.380470, -0.256286>,
      < -3.169059, -5.470934, -0.266738>
    }
    triangle {
      < -3.281411, -5.411036, -0.210920>,
      < -3.169059, -5.470934, -0.266738>,
      < -3.143772, -5.500243, -0.240001>
    }
    triangle {
      < -3.281411, -5.411036, -0.210920>,
      < -3.143772, -5.500243, -0.240001>,
      < -3.144734, -5.510552, -0.212819>
    }
    triangle {
      < -3.146878, -5.507833, -0.185383>,
      < -3.175271, -5.486119, -0.157501>,
      < -3.238530, -5.390752, -0.159403>
    }
    triangle {
      < -3.146878, -5.507833, -0.185383>,
      < -3.238530, -5.390752, -0.159403>,
      < -3.281411, -5.411036, -0.210920>
    }
    triangle {
      < -3.146878, -5.507833, -0.185383>,
      < -3.281411, -5.411036, -0.210920>,
      < -3.144734, -5.510552, -0.212819>
    }
    triangle {
      < -3.281411, -5.411036, -0.210920>,
      < -3.238530, -5.390752, -0.159403>,
      < -3.253295, -5.378718, -0.152609>
    }
    triangle {
      < -3.281411, -5.411036, -0.210920>,
      < -3.253295, -5.378718, -0.152609>,
      < -3.293084, -5.396710, -0.214851>
    }
    triangle {
      < -3.427206, -5.250150, -0.136576>,
      < -3.623229, -4.962186, -0.131394>,
      < -3.671307, -4.971681, -0.225062>
    }
    triangle {
      < -3.427206, -5.250150, -0.136576>,
      < -3.671307, -4.971681, -0.225062>,
      < -3.452394, -5.270232, -0.219996>
    }
    triangle {
      < -3.732185, -4.634325, -0.180645>,
      < -3.671307, -4.971681, -0.225062>,
      < -3.623229, -4.962186, -0.131394>
    }
    triangle {
      < -3.732185, -4.634325, -0.180645>,
      < -3.623229, -4.962186, -0.131394>,
      < -3.707675, -4.638666, -0.073645>
    }
    triangle {
      < -3.707675, -4.638666, -0.073645>,
      < -3.749773, -4.510483, -0.012252>,
      < -3.755457, -4.503113, -0.158990>
    }
    triangle {
      < -3.707675, -4.638666, -0.073645>,
      < -3.755457, -4.503113, -0.158990>,
      < -3.732185, -4.634325, -0.180645>
    }
    triangle {
      < -3.749773, -4.510483, -0.012252>,
      < -3.855826, -4.343190, -0.131656>,
      < -3.755457, -4.503113, -0.158990>
    }
    triangle {
      < -3.715068, -4.365313, -0.273409>,
      < -3.671955, -4.474066, -0.276357>,
      < -3.855826, -4.343190, -0.131656>
    }
    triangle {
      < -3.820560, -4.589967, 0.087331>,
      < -3.791321, -4.745622, 0.078156>,
      < -3.833309, -4.794936, 0.174423>
    }
    triangle {
      < -3.820560, -4.589967, 0.087331>,
      < -3.833309, -4.794936, 0.174423>,
      < -3.866155, -4.683072, 0.186399>
    }
    triangle {
      < -3.791321, -4.745622, 0.078156>,
      < -3.677980, -5.215698, 0.044134>,
      < -3.711217, -5.239375, 0.133680>
    }
    triangle {
      < -3.791321, -4.745622, 0.078156>,
      < -3.711217, -5.239375, 0.133680>,
      < -3.833309, -4.794936, 0.174423>
    }
    triangle {
      < -3.380490, -5.552703, 0.040199>,
      < -3.388301, -5.580028, 0.124869>,
      < -3.711217, -5.239375, 0.133680>
    }
    triangle {
      < -3.380490, -5.552703, 0.040199>,
      < -3.711217, -5.239375, 0.133680>,
      < -3.677980, -5.215698, 0.044134>
    }
    triangle {
      < -3.216337, -5.726731, 0.118775>,
      < -3.388301, -5.580028, 0.124869>,
      < -3.380490, -5.552703, 0.040199>
    }
    triangle {
      < -3.216337, -5.726731, 0.118775>,
      < -3.380490, -5.552703, 0.040199>,
      < -3.196241, -5.713139, 0.055022>
    }
    triangle {
      < -3.192200, -5.730344, 0.057413>,
      < -3.095662, -5.813387, 0.051917>,
      < -3.072965, -5.834154, 0.082249>
    }
    triangle {
      < -3.192200, -5.730344, 0.057413>,
      < -3.072965, -5.834154, 0.082249>,
      < -3.067862, -5.842321, 0.111463>
    }
    triangle {
      < -3.192200, -5.730344, 0.057413>,
      < -3.067862, -5.842321, 0.111463>,
      < -3.196340, -5.733409, 0.114749>
    }
    triangle {
      < -3.866155, -4.683072, 0.186399>,
      < -3.935352, -4.474578, 0.199895>,
      < -3.820560, -4.589967, 0.087331>
    }
    triangle {
      < -3.848762, -4.753190, 0.476878>,
      < -3.872860, -4.762247, 0.594336>,
      < -3.978867, -4.556856, 0.590013>
    }
    triangle {
      < -3.848762, -4.753190, 0.476878>,
      < -3.840905, -4.872707, 0.474656>,
      < -3.871635, -4.874913, 0.579817>
    }
    triangle {
      < -3.848762, -4.753190, 0.476878>,
      < -3.871635, -4.874913, 0.579817>,
      < -3.872860, -4.762247, 0.594336>
    }
    triangle {
      < -3.840905, -4.872707, 0.474656>,
      < -3.749318, -5.362044, 0.458830>,
      < -3.787827, -5.377024, 0.557766>
    }
    triangle {
      < -3.840905, -4.872707, 0.474656>,
      < -3.787827, -5.377024, 0.557766>,
      < -3.871635, -4.874913, 0.579817>
    }
    triangle {
      < -3.453096, -5.787074, 0.509127>,
      < -3.787827, -5.377024, 0.557766>,
      < -3.749318, -5.362044, 0.458830>
    }
    triangle {
      < -3.453096, -5.787074, 0.509127>,
      < -3.749318, -5.362044, 0.458830>,
      < -3.410457, -5.758007, 0.415555>
    }
    triangle {
      < -3.310092, -5.947457, 0.499410>,
      < -3.453096, -5.787074, 0.509127>,
      < -3.410457, -5.758007, 0.415555>
    }
    triangle {
      < -3.310092, -5.947457, 0.499410>,
      < -3.410457, -5.758007, 0.415555>,
      < -3.263365, -5.932832, 0.427533>
    }
    triangle {
      < -3.246890, -5.951345, 0.425132>,
      < -3.171965, -6.034112, 0.406677>,
      < -3.155637, -6.079582, 0.445845>
    }
    triangle {
      < -3.246890, -5.951345, 0.425132>,
      < -3.155637, -6.079582, 0.445845>,
      < -3.150421, -6.097242, 0.485310>
    }
    triangle {
      < -3.246890, -5.951345, 0.425132>,
      < -3.150421, -6.097242, 0.485310>,
      < -3.285124, -5.948591, 0.498650>
    }
    triangle {
      < -3.518012, -6.067028, 0.920041>,
      < -3.522264, -6.025560, 0.965866>,
      < -3.550858, -5.907750, 0.973820>
    }
    triangle {
      < -3.518012, -6.067028, 0.920041>,
      < -3.550858, -5.907750, 0.973820>,
      < -3.610975, -5.919303, 0.919372>
    }
    triangle {
      < -3.518012, -6.067028, 0.920041>,
      < -3.610975, -5.919303, 0.919372>,
      < -3.531293, -6.078069, 0.882219>
    }
    triangle {
      < -3.610975, -5.919303, 0.919372>,
      < -3.550858, -5.907750, 0.973820>,
      < -3.553595, -5.892168, 0.986735>
    }
    triangle {
      < -3.610975, -5.919303, 0.919372>,
      < -3.553595, -5.892168, 0.986735>,
      < -3.624970, -5.907471, 0.927947>
    }
    triangle {
      < -3.632454, -5.713002, 1.037336>,
      < -3.749973, -5.313198, 1.098377>,
      < -3.826484, -5.322048, 1.027841>
    }
    triangle {
      < -3.632454, -5.713002, 1.037336>,
      < -3.826484, -5.322048, 1.027841>,
      < -3.701282, -5.729109, 0.969850>
    }
    triangle {
      < -3.761762, -4.904438, 1.035913>,
      < -3.826484, -5.322048, 1.027841>,
      < -3.749973, -5.313198, 1.098377>
    }
    triangle {
      < -3.761762, -4.904438, 1.035913>,
      < -3.749973, -5.313198, 1.098377>,
      < -3.654503, -4.904352, 1.111933>
    }
    triangle {
      < -3.819031, -4.756149, 0.303078>,
      < -3.935352, -4.474578, 0.199895>,
      < -3.866155, -4.683072, 0.186399>
    }
    triangle {
      < -3.310992, -4.389974, 1.185302>,
      < -3.446155, -4.248275, 1.191563>,
      < -3.549953, -4.498902, 1.149813>
    }
    triangle {
      < -3.310992, -4.389974, 1.185302>,
      < -3.549953, -4.498902, 1.149813>,
      < -3.348468, -4.497969, 1.145854>
    }
    triangle {
      < -3.446155, -4.248275, 1.191563>,
      < -3.626639, -4.463606, 1.089377>,
      < -3.549953, -4.498902, 1.149813>
    }
    triangle {
      < -3.446155, -4.248275, 1.191563>,
      < -3.768749, -4.368258, 0.884841>,
      < -3.626639, -4.463606, 1.089377>
    }
    triangle {
      < -3.756013, -4.691369, 0.949057>,
      < -3.730436, -4.714237, 1.047626>,
      < -3.626639, -4.463606, 1.089377>
    }
    triangle {
      < -3.756013, -4.691369, 0.949057>,
      < -3.782173, -4.912578, 0.915967>,
      < -3.761762, -4.904438, 1.035913>
    }
    triangle {
      < -3.756013, -4.691369, 0.949057>,
      < -3.761762, -4.904438, 1.035913>,
      < -3.730436, -4.714237, 1.047626>
    }
    triangle {
      < -3.654503, -4.904352, 1.111933>,
      < -3.653747, -4.749532, 1.108063>,
      < -3.730436, -4.714237, 1.047626>
    }
    triangle {
      < -3.654503, -4.904352, 1.111933>,
      < -3.730436, -4.714237, 1.047626>,
      < -3.761762, -4.904438, 1.035913>
    }
    triangle {
      < -3.653747, -4.749532, 1.108063>,
      < -3.549953, -4.498902, 1.149813>,
      < -3.626639, -4.463606, 1.089377>
    }
    triangle {
      < -3.653747, -4.749532, 1.108063>,
      < -3.626639, -4.463606, 1.089377>,
      < -3.730436, -4.714237, 1.047626>
    }
    triangle {
      < -3.146651, -6.076947, 0.485953>,
      < -3.081568, -6.072448, 0.477527>,
      < -3.074996, -6.055424, 0.520714>
    }
    triangle {
      < -3.146651, -6.076947, 0.485953>,
      < -3.074996, -6.055424, 0.520714>,
      < -3.140649, -6.052967, 0.521939>
    }
    triangle {
      < -3.086810, -6.058038, 0.437816>,
      < -3.081568, -6.072448, 0.477527>,
      < -3.146651, -6.076947, 0.485953>
    }
    triangle {
      < -3.086810, -6.058038, 0.437816>,
      < -3.146651, -6.076947, 0.485953>,
      < -3.149153, -6.054235, 0.444800>
    }
    triangle {
      < -3.053851, -5.841250, 0.105412>,
      < -3.004417, -5.843048, 0.100626>,
      < -2.993125, -5.820805, 0.134664>
    }
    triangle {
      < -3.053851, -5.841250, 0.105412>,
      < -2.993125, -5.820805, 0.134664>,
      < -3.049008, -5.820407, 0.137574>
    }
    triangle {
      < -3.017643, -5.834864, 0.063272>,
      < -3.004417, -5.843048, 0.100626>,
      < -3.053851, -5.841250, 0.105412>
    }
    triangle {
      < -3.017643, -5.834864, 0.063272>,
      < -3.053851, -5.841250, 0.105412>,
      < -3.061577, -5.826604, 0.076622>
    }
    triangle {
      < -3.226502, -5.923387, 0.560858>,
      < -3.151881, -6.024515, 0.556160>,
      < -3.132799, -6.015729, 0.561931>
    }
    triangle {
      < -3.226502, -5.923387, 0.560858>,
      < -3.132799, -6.015729, 0.561931>,
      < -3.215331, -5.910106, 0.568917>
    }
    triangle {
      < -3.226502, -5.923387, 0.560858>,
      < -3.215331, -5.910106, 0.568917>,
      < -3.253033, -5.914477, 0.560052>
    }
    triangle {
      < -3.285124, -5.948591, 0.498650>,
      < -3.226502, -5.923387, 0.560858>,
      < -3.253033, -5.914477, 0.560052>
    }
    triangle {
      < -3.285124, -5.948591, 0.498650>,
      < -3.253033, -5.914477, 0.560052>,
      < -3.310092, -5.947457, 0.499410>
    }
    triangle {
      < -3.246890, -5.951345, 0.425132>,
      < -3.285124, -5.948591, 0.498650>,
      < -3.310092, -5.947457, 0.499410>
    }
    triangle {
      < -3.246890, -5.951345, 0.425132>,
      < -3.310092, -5.947457, 0.499410>,
      < -3.263365, -5.932832, 0.427533>
    }
    triangle {
      < -3.246890, -5.951345, 0.425132>,
      < -3.263365, -5.932832, 0.427533>,
      < -3.230269, -5.937195, 0.415929>
    }
    triangle {
      < -3.171965, -6.034112, 0.406677>,
      < -3.246890, -5.951345, 0.425132>,
      < -3.230269, -5.937195, 0.415929>
    }
    triangle {
      < -3.171965, -6.034112, 0.406677>,
      < -3.230269, -5.937195, 0.415929>,
      < -3.149762, -6.017935, 0.402476>
    }
    triangle {
      < -3.155637, -6.079582, 0.445845>,
      < -3.171965, -6.034112, 0.406677>,
      < -3.149762, -6.017935, 0.402476>
    }
    triangle {
      < -3.155637, -6.079582, 0.445845>,
      < -3.149762, -6.017935, 0.402476>,
      < -3.149153, -6.054235, 0.444800>
    }
    triangle {
      < -3.150421, -6.097242, 0.485310>,
      < -3.155637, -6.079582, 0.445845>,
      < -3.149153, -6.054235, 0.444800>
    }
    triangle {
      < -3.150421, -6.097242, 0.485310>,
      < -3.149153, -6.054235, 0.444800>,
      < -3.146651, -6.076947, 0.485953>
    }
    triangle {
      < -3.146393, -6.072251, 0.535676>,
      < -3.150421, -6.097242, 0.485310>,
      < -3.146651, -6.076947, 0.485953>
    }
    triangle {
      < -3.146393, -6.072251, 0.535676>,
      < -3.146651, -6.076947, 0.485953>,
      < -3.140649, -6.052967, 0.521939>
    }
    triangle {
      < -3.151881, -6.024515, 0.556160>,
      < -3.146393, -6.072251, 0.535676>,
      < -3.140649, -6.052967, 0.521939>
    }
    triangle {
      < -3.151881, -6.024515, 0.556160>,
      < -3.140649, -6.052967, 0.521939>,
      < -3.132799, -6.015729, 0.561931>
    }
    triangle {
      < -3.196340, -5.733409, 0.114749>,
      < -3.155772, -5.712716, 0.152194>,
      < -3.155939, -5.701127, 0.156862>
    }
    triangle {
      < -3.196340, -5.733409, 0.114749>,
      < -3.155939, -5.701127, 0.156862>,
      < -3.216337, -5.726731, 0.118775>
    }
    triangle {
      < -3.192200, -5.730344, 0.057413>,
      < -3.196340, -5.733409, 0.114749>,
      < -3.216337, -5.726731, 0.118775>
    }
    triangle {
      < -3.192200, -5.730344, 0.057413>,
      < -3.216337, -5.726731, 0.118775>,
      < -3.196241, -5.713139, 0.055022>
    }
    triangle {
      < -3.192200, -5.730344, 0.057413>,
      < -3.196241, -5.713139, 0.055022>,
      < -3.170379, -5.716518, 0.044165>
    }
    triangle {
      < -3.095662, -5.813387, 0.051917>,
      < -3.192200, -5.730344, 0.057413>,
      < -3.170379, -5.716518, 0.044165>
    }
    triangle {
      < -3.095662, -5.813387, 0.051917>,
      < -3.170379, -5.716518, 0.044165>,
      < -3.074443, -5.803917, 0.041438>
    }
    triangle {
      < -3.072965, -5.834154, 0.082249>,
      < -3.095662, -5.813387, 0.051917>,
      < -3.074443, -5.803917, 0.041438>
    }
    triangle {
      < -3.072965, -5.834154, 0.082249>,
      < -3.074443, -5.803917, 0.041438>,
      < -3.061577, -5.826604, 0.076622>
    }
    triangle {
      < -3.067862, -5.842321, 0.111463>,
      < -3.072965, -5.834154, 0.082249>,
      < -3.061577, -5.826604, 0.076622>
    }
    triangle {
      < -3.067862, -5.842321, 0.111463>,
      < -3.061577, -5.826604, 0.076622>,
      < -3.053851, -5.841250, 0.105412>
    }
    triangle {
      < -3.060814, -5.828017, 0.134598>,
      < -3.067862, -5.842321, 0.111463>,
      < -3.053851, -5.841250, 0.105412>
    }
    triangle {
      < -3.060814, -5.828017, 0.134598>,
      < -3.053851, -5.841250, 0.105412>,
      < -3.049008, -5.820407, 0.137574>
    }
    triangle {
      < -3.071395, -5.801376, 0.160804>,
      < -3.060814, -5.828017, 0.134598>,
      < -3.049008, -5.820407, 0.137574>
    }
    triangle {
      < -3.071395, -5.801376, 0.160804>,
      < -3.049008, -5.820407, 0.137574>,
      < -3.049350, -5.791834, 0.168228>
    }
    triangle {
      < -3.155772, -5.712716, 0.152194>,
      < -3.071395, -5.801376, 0.160804>,
      < -3.049350, -5.791834, 0.168228>
    }
    triangle {
      < -3.155772, -5.712716, 0.152194>,
      < -3.049350, -5.791834, 0.168228>,
      < -3.141093, -5.708465, 0.163081>
    }
    triangle {
      < -3.155772, -5.712716, 0.152194>,
      < -3.141093, -5.708465, 0.163081>,
      < -3.155939, -5.701127, 0.156862>
    }
    triangle {
      < -3.108755, -5.980817, 0.380630>,
      < -3.058576, -5.974609, 0.422769>,
      < -3.086810, -6.058038, 0.437816>
    }
    triangle {
      < -3.098142, -5.994081, 0.570921>,
      < -3.074996, -6.055424, 0.520714>,
      < -3.033125, -5.970796, 0.526716>
    }
    triangle {
      < -3.039448, -5.784328, 0.022500>,
      < -2.970495, -5.783869, 0.066662>,
      < -3.017643, -5.834864, 0.063272>
    }
    triangle {
      < -3.108019, -5.480084, -0.249201>,
      < -3.103222, -5.487276, -0.207282>,
      < -3.132356, -5.501740, -0.210948>
    }
    triangle {
      < -3.108019, -5.480084, -0.249201>,
      < -3.132356, -5.501740, -0.210948>,
      < -3.137688, -5.489302, -0.242971>
    }
    triangle {
      < -3.111749, -5.413926, -0.159047>,
      < -3.121146, -5.484527, -0.155941>,
      < -3.103222, -5.487276, -0.207282>
    }
    triangle {
      < -3.169059, -5.470934, -0.266738>,
      < -3.233992, -5.380470, -0.256286>,
      < -3.227041, -5.375122, -0.272112>
    }
    triangle {
      < -3.169059, -5.470934, -0.266738>,
      < -3.227041, -5.375122, -0.272112>,
      < -3.159483, -5.465992, -0.270949>
    }
    triangle {
      < -3.143772, -5.500243, -0.240001>,
      < -3.169059, -5.470934, -0.266738>,
      < -3.159483, -5.465992, -0.270949>
    }
    triangle {
      < -3.143772, -5.500243, -0.240001>,
      < -3.159483, -5.465992, -0.270949>,
      < -3.137688, -5.489302, -0.242971>
    }
    triangle {
      < -3.144734, -5.510552, -0.212819>,
      < -3.143772, -5.500243, -0.240001>,
      < -3.137688, -5.489302, -0.242971>
    }
    triangle {
      < -3.144734, -5.510552, -0.212819>,
      < -3.137688, -5.489302, -0.242971>,
      < -3.132356, -5.501740, -0.210948>
    }
    triangle {
      < -3.146878, -5.507833, -0.185383>,
      < -3.144734, -5.510552, -0.212819>,
      < -3.132356, -5.501740, -0.210948>
    }
    triangle {
      < -3.146878, -5.507833, -0.185383>,
      < -3.132356, -5.501740, -0.210948>,
      < -3.147821, -5.495047, -0.170164>
    }
    triangle {
      < -3.175271, -5.486119, -0.157501>,
      < -3.146878, -5.507833, -0.185383>,
      < -3.147821, -5.495047, -0.170164>
    }
    triangle {
      < -3.175271, -5.486119, -0.157501>,
      < -3.147821, -5.495047, -0.170164>,
      < -3.165883, -5.481662, -0.152199>
    }
    triangle {
      < -3.238530, -5.390752, -0.159403>,
      < -3.175271, -5.486119, -0.157501>,
      < -3.165883, -5.481662, -0.152199>
    }
    triangle {
      < -3.238530, -5.390752, -0.159403>,
      < -3.165883, -5.481662, -0.152199>,
      < -3.222092, -5.389814, -0.142920>
    }
    triangle {
      < -3.227041, -5.375122, -0.272112>,
      < -3.242743, -5.367341, -0.267206>,
      < -3.404628, -5.236587, -0.286603>
    }
    triangle {
      < -3.227041, -5.375122, -0.272112>,
      < -3.404628, -5.236587, -0.286603>,
      < -3.389684, -5.170204, -0.347680>
    }
    triangle {
      < -3.227041, -5.375122, -0.272112>,
      < -3.389684, -5.170204, -0.347680>,
      < -3.218018, -5.361663, -0.309225>
    }
    triangle {
      < -3.293084, -5.396710, -0.214851>,
      < -3.452394, -5.270232, -0.219996>,
      < -3.404628, -5.236587, -0.286603>
    }
    triangle {
      < -3.293084, -5.396710, -0.214851>,
      < -3.404628, -5.236587, -0.286603>,
      < -3.242743, -5.367341, -0.267206>
    }
    triangle {
      < -3.253295, -5.378718, -0.152609>,
      < -3.427206, -5.250150, -0.136576>,
      < -3.452394, -5.270232, -0.219996>
    }
    triangle {
      < -3.253295, -5.378718, -0.152609>,
      < -3.452394, -5.270232, -0.219996>,
      < -3.293084, -5.396710, -0.214851>
    }
    triangle {
      < -3.222092, -5.389814, -0.142920>,
      < -3.189222, -5.387946, -0.109955>,
      < -3.375304, -5.186841, -0.084050>
    }
    triangle {
      < -3.222092, -5.389814, -0.142920>,
      < -3.375304, -5.186841, -0.084050>,
      < -3.427206, -5.250150, -0.136576>
    }
    triangle {
      < -3.222092, -5.389814, -0.142920>,
      < -3.427206, -5.250150, -0.136576>,
      < -3.253295, -5.378718, -0.152609>
    }
    triangle {
      < -3.103222, -5.487276, -0.207282>,
      < -3.108019, -5.480084, -0.249201>,
      < -3.091261, -5.417274, -0.244750>
    }
    triangle {
      < -3.147821, -5.495047, -0.170164>,
      < -3.132356, -5.501740, -0.210948>,
      < -3.103222, -5.487276, -0.207282>
    }
    triangle {
      < -3.147821, -5.495047, -0.170164>,
      < -3.103222, -5.487276, -0.207282>,
      < -3.121146, -5.484527, -0.155941>
    }
    triangle {
      < -3.165883, -5.481662, -0.152199>,
      < -3.147821, -5.495047, -0.170164>,
      < -3.121146, -5.484527, -0.155941>
    }
    triangle {
      < -3.165883, -5.481662, -0.152199>,
      < -3.121146, -5.484527, -0.155941>,
      < -3.137978, -5.462011, -0.134840>
    }
    triangle {
      < -3.004417, -5.843048, 0.100626>,
      < -2.970495, -5.783869, 0.066662>,
      < -2.993125, -5.820805, 0.134664>
    }
    triangle {
      < -2.980297, -5.779233, 0.151208>,
      < -2.993125, -5.820805, 0.134664>,
      < -2.970495, -5.783869, 0.066662>
    }
    triangle {
      < -3.522264, -6.025560, 0.965866>,
      < -3.518012, -6.067028, 0.920041>,
      < -3.505432, -6.057985, 0.920378>
    }
    triangle {
      < -3.522264, -6.025560, 0.965866>,
      < -3.505432, -6.057985, 0.920378>,
      < -3.505869, -6.028747, 0.966244>
    }
    triangle {
      < -3.534503, -6.017144, 0.802934>,
      < -3.523629, -6.052359, 0.836901>,
      < -3.538268, -6.066545, 0.844955>
    }
    triangle {
      < -3.534503, -6.017144, 0.802934>,
      < -3.538268, -6.066545, 0.844955>,
      < -3.562773, -6.024592, 0.815694>
    }
    triangle {
      < -3.531293, -6.078069, 0.882219>,
      < -3.538268, -6.066545, 0.844955>,
      < -3.523629, -6.052359, 0.836901>
    }
    triangle {
      < -3.531293, -6.078069, 0.882219>,
      < -3.523629, -6.052359, 0.836901>,
      < -3.513249, -6.071916, 0.875409>
    }
    triangle {
      < -3.553595, -5.892168, 0.986735>,
      < -3.632454, -5.713002, 1.037336>,
      < -3.701282, -5.729109, 0.969850>
    }
    triangle {
      < -3.553595, -5.892168, 0.986735>,
      < -3.701282, -5.729109, 0.969850>,
      < -3.624970, -5.907471, 0.927947>
    }
    triangle {
      < -3.531374, -5.903006, 0.994906>,
      < -3.492407, -5.893525, 1.037085>,
      < -3.545418, -5.692355, 1.088168>
    }
    triangle {
      < -3.531374, -5.903006, 0.994906>,
      < -3.545418, -5.692355, 1.088168>,
      < -3.632454, -5.713002, 1.037336>
    }
    triangle {
      < -3.531374, -5.903006, 0.994906>,
      < -3.632454, -5.713002, 1.037336>,
      < -3.553595, -5.892168, 0.986735>
    }
    triangle {
      < -3.473088, -6.035122, 0.967001>,
      < -3.492407, -5.893525, 1.037085>,
      < -3.531374, -5.903006, 0.994906>
    }
    triangle {
      < -3.473088, -6.035122, 0.967001>,
      < -3.531374, -5.903006, 0.994906>,
      < -3.505869, -6.028747, 0.966244>
    }
    triangle {
      < -3.445156, -6.069401, 0.925751>,
      < -3.473088, -6.035122, 0.967001>,
      < -3.505869, -6.028747, 0.966244>
    }
    triangle {
      < -3.445156, -6.069401, 0.925751>,
      < -3.505869, -6.028747, 0.966244>,
      < -3.505432, -6.057985, 0.920378>
    }
    triangle {
      < -3.482244, -6.080278, 0.862983>,
      < -3.445156, -6.069401, 0.925751>,
      < -3.505432, -6.057985, 0.920378>
    }
    triangle {
      < -3.482244, -6.080278, 0.862983>,
      < -3.505432, -6.057985, 0.920378>,
      < -3.513249, -6.071916, 0.875409>
    }
    triangle {
      < -3.479325, -6.050067, 0.813931>,
      < -3.482244, -6.080278, 0.862983>,
      < -3.513249, -6.071916, 0.875409>
    }
    triangle {
      < -3.479325, -6.050067, 0.813931>,
      < -3.513249, -6.071916, 0.875409>,
      < -3.523629, -6.052359, 0.836901>
    }
    triangle {
      < -3.477974, -6.002246, 0.777414>,
      < -3.479325, -6.050067, 0.813931>,
      < -3.523629, -6.052359, 0.836901>
    }
    triangle {
      < -3.477974, -6.002246, 0.777414>,
      < -3.523629, -6.052359, 0.836901>,
      < -3.534503, -6.017144, 0.802934>
    }
    triangle {
      < -3.505699, -5.855872, 0.747989>,
      < -3.477974, -6.002246, 0.777414>,
      < -3.534503, -6.017144, 0.802934>
    }
    triangle {
      < -3.505699, -5.855872, 0.747989>,
      < -3.534503, -6.017144, 0.802934>,
      < -3.572496, -5.890628, 0.808892>
    }
    triangle {
      < -3.572496, -5.890628, 0.808892>,
      < -3.609701, -5.892986, 0.836394>,
      < -3.683643, -5.717794, 0.871465>
    }
    triangle {
      < -3.572496, -5.890628, 0.808892>,
      < -3.683643, -5.717794, 0.871465>,
      < -3.553799, -5.655422, 0.761295>
    }
    triangle {
      < -3.572496, -5.890628, 0.808892>,
      < -3.553799, -5.655422, 0.761295>,
      < -3.505699, -5.855872, 0.747989>
    }
    triangle {
      < -3.624970, -5.907471, 0.927947>,
      < -3.701282, -5.729109, 0.969850>,
      < -3.683643, -5.717794, 0.871465>
    }
    triangle {
      < -3.624970, -5.907471, 0.927947>,
      < -3.683643, -5.717794, 0.871465>,
      < -3.609701, -5.892986, 0.836394>
    }
    triangle {
      < -3.413736, -6.028965, 0.915567>,
      < -3.473088, -6.035122, 0.967001>,
      < -3.445156, -6.069401, 0.925751>
    }
    triangle {
      < -3.413736, -6.028965, 0.915567>,
      < -3.445156, -6.069401, 0.925751>,
      < -3.482244, -6.080278, 0.862983>
    }
    triangle {
      < -2.711608, -4.528833, 1.228295>,
      < -2.756208, -4.246720, 1.254495>,
      < -2.849420, -4.258226, 1.321365>
    }
    triangle {
      < -2.711608, -4.528833, 1.228295>,
      < -2.849420, -4.258226, 1.321365>,
      < -2.791797, -4.524917, 1.292616>
    }
    triangle {
      < -2.668286, -4.735597, 1.220260>,
      < -2.711608, -4.528833, 1.228295>,
      < -2.791797, -4.524917, 1.292616>
    }
    triangle {
      < -2.668286, -4.735597, 1.220260>,
      < -2.791797, -4.524917, 1.292616>,
      < -2.747367, -4.744814, 1.283339>
    }
    triangle {
      < -2.709860, -5.038414, 1.211770>,
      < -2.641492, -5.023551, 1.151718>,
      < -2.641750, -5.009909, 1.175060>
    }
    triangle {
      < -2.709860, -5.038414, 1.211770>,
      < -2.641750, -5.009909, 1.175060>,
      < -2.716361, -5.024138, 1.237795>
    }
    triangle {
      < -2.668019, -5.252569, 1.168923>,
      < -2.631475, -5.189024, 1.144910>,
      < -2.641492, -5.023551, 1.151718>
    }
    triangle {
      < -2.668019, -5.252569, 1.168923>,
      < -2.641492, -5.023551, 1.151718>,
      < -2.709860, -5.038414, 1.211770>
    }
    triangle {
      < -2.668019, -5.252569, 1.168923>,
      < -2.709860, -5.038414, 1.211770>,
      < -2.697364, -5.274925, 1.189184>
    }
    triangle {
      < -2.756208, -4.246720, 1.254495>,
      < -2.903923, -3.680026, 1.129989>,
      < -2.849420, -4.258226, 1.321365>
    }
    triangle {
      < -2.668019, -5.252569, 1.168923>,
      < -2.676505, -5.230327, 1.135723>,
      < -2.637240, -5.188992, 1.115963>
    }
    triangle {
      < -2.668019, -5.252569, 1.168923>,
      < -2.637240, -5.188992, 1.115963>,
      < -2.631475, -5.189024, 1.144910>
    }
    triangle {
      < -2.759147, -5.241912, 1.167365>,
      < -2.756707, -5.252022, 1.199861>,
      < -2.794990, -5.219936, 1.222509>
    }
    triangle {
      < -2.759147, -5.241912, 1.167365>,
      < -2.794990, -5.219936, 1.222509>,
      < -2.798819, -5.210745, 1.199050>
    }
    triangle {
      < -2.756707, -5.252022, 1.199861>,
      < -2.759147, -5.241912, 1.167365>,
      < -2.697364, -5.274925, 1.189184>
    }
    triangle {
      < -2.697364, -5.274925, 1.189184>,
      < -2.676505, -5.230327, 1.135723>,
      < -2.668019, -5.252569, 1.168923>
    }
    triangle {
      < -2.676505, -5.230327, 1.135723>,
      < -2.697364, -5.274925, 1.189184>,
      < -2.759147, -5.241912, 1.167365>
    }
    triangle {
      < -2.857244, -4.750984, 1.276291>,
      < -3.003325, -4.727902, 1.148698>,
      < -2.899959, -5.015127, 1.172929>
    }
    triangle {
      < -2.857244, -4.750984, 1.276291>,
      < -2.899959, -5.015127, 1.172929>,
      < -2.832069, -5.040146, 1.196513>
    }
    triangle {
      < -2.857244, -4.750984, 1.276291>,
      < -2.832069, -5.040146, 1.196513>,
      < -2.815561, -5.029976, 1.234091>
    }
    triangle {
      < -2.747367, -4.744814, 1.283339>,
      < -2.857244, -4.750984, 1.276291>,
      < -2.815561, -5.029976, 1.234091>
    }
    triangle {
      < -2.747367, -4.744814, 1.283339>,
      < -2.815561, -5.029976, 1.234091>,
      < -2.716361, -5.024138, 1.237795>
    }
    triangle {
      < -2.668286, -4.735597, 1.220260>,
      < -2.747367, -4.744814, 1.283339>,
      < -2.716361, -5.024138, 1.237795>
    }
    triangle {
      < -2.668286, -4.735597, 1.220260>,
      < -2.716361, -5.024138, 1.237795>,
      < -2.641750, -5.009909, 1.175060>
    }
    triangle {
      < -2.606242, -4.997890, 1.062551>,
      < -2.643964, -4.725788, 1.080201>,
      < -2.668286, -4.735597, 1.220260>
    }
    triangle {
      < -2.606242, -4.997890, 1.062551>,
      < -2.668286, -4.735597, 1.220260>,
      < -2.641750, -5.009909, 1.175060>
    }
    triangle {
      < -2.606242, -4.997890, 1.062551>,
      < -2.641750, -5.009909, 1.175060>,
      < -2.631430, -5.021671, 1.121294>
    }
    triangle {
      < -2.671290, -5.134576, 1.004575>,
      < -2.606242, -4.997890, 1.062551>,
      < -2.631430, -5.021671, 1.121294>
    }
    triangle {
      < -2.671290, -5.134576, 1.004575>,
      < -2.631430, -5.021671, 1.121294>,
      < -2.637240, -5.188992, 1.115963>
    }
    triangle {
      < -2.798819, -5.210745, 1.199050>,
      < -2.832069, -5.040146, 1.196513>,
      < -2.899959, -5.015127, 1.172929>
    }
    triangle {
      < -2.798819, -5.210745, 1.199050>,
      < -2.899959, -5.015127, 1.172929>,
      < -2.823724, -5.203536, 1.130062>
    }
    triangle {
      < -2.839635, -5.003333, 0.986344>,
      < -2.671290, -5.134576, 1.004575>,
      < -2.823724, -5.203536, 1.130062>
    }
    triangle {
      < -2.676981, -5.016549, 0.977451>,
      < -2.671290, -5.134576, 1.004575>,
      < -2.839635, -5.003333, 0.986344>
    }
    triangle {
      < -2.637240, -5.188992, 1.115963>,
      < -2.676505, -5.230327, 1.135723>,
      < -2.671290, -5.134576, 1.004575>
    }
    triangle {
      < -2.676981, -5.016549, 0.977451>,
      < -2.606242, -4.997890, 1.062551>,
      < -2.671290, -5.134576, 1.004575>
    }
    triangle {
      < -3.752286, -3.343208, 0.085041>,
      < -3.722475, -2.954857, -0.047674>,
      < -3.599305, -3.225931, -0.043476>
    }
    triangle {
      < -2.389562, 2.108848, 0.916315>,
      < -2.598399, 1.087355, 0.771866>,
      < -2.263130, 0.883407, 0.490936>
    }
    triangle {
      < -2.389562, 2.108848, 0.916315>,
      < -2.263130, 0.883407, 0.490936>,
      < -1.972370, 1.836697, 0.565753>
    }
    triangle {
      < -2.143766, 1.777314, -0.509196>,
      < -2.509296, 0.791452, -0.366753>,
      < -2.695315, 0.795125, -0.528766>
    }
    triangle {
      < -2.143766, 1.777314, -0.509196>,
      < -2.695315, 0.795125, -0.528766>,
      < -2.428253, 1.875464, -0.657165>
    }
    triangle {
      < -3.449607, 2.346718, -0.186191>,
      < -3.501794, 0.872930, 0.183442>,
      < -3.390432, 0.999678, 0.681287>
    }
    triangle {
      < -3.449607, 2.346718, -0.186191>,
      < -3.390432, 0.999678, 0.681287>,
      < -3.272733, 2.381291, 0.328889>
    }
    triangle {
      < -3.014387, 0.793627, -0.615524>,
      < -2.695315, 0.795125, -0.528766>,
      < -2.698462, 0.226836, -0.462052>
    }
    triangle {
      < -3.014387, 0.793627, -0.615524>,
      < -2.698462, 0.226836, -0.462052>,
      < -3.044701, 0.253003, -0.572372>
    }
    triangle {
      < -2.209945, 0.778184, 0.038156>,
      < -2.263130, 0.883407, 0.490936>,
      < -2.311565, 0.195061, 0.464117>
    }
    triangle {
      < -2.209945, 0.778184, 0.038156>,
      < -2.311565, 0.195061, 0.464117>,
      < -2.216184, 0.190357, 0.053862>
    }
    triangle {
      < -3.501794, 0.872930, 0.183442>,
      < -3.265405, 0.844826, -0.361207>,
      < -3.342636, 0.270231, -0.195426>
    }
    triangle {
      < -3.501794, 0.872930, 0.183442>,
      < -3.342636, 0.270231, -0.195426>,
      < -3.540532, 0.306510, 0.212961>
    }
    triangle {
      < -3.265405, 0.844826, -0.361207>,
      < -3.206557, 2.266230, -0.609586>,
      < -2.746782, 2.012204, -0.739545>
    }
    triangle {
      < -3.265405, 0.844826, -0.361207>,
      < -2.746782, 2.012204, -0.739545>,
      < -3.014387, 0.793627, -0.615524>
    }
    triangle {
      < -2.428253, 1.875464, -0.657165>,
      < -2.746782, 2.012204, -0.739545>,
      < -2.639934, 3.343994, -0.854432>
    }
    triangle {
      < -2.428253, 1.875464, -0.657165>,
      < -2.639934, 3.343994, -0.854432>,
      < -2.165084, 3.125649, -0.780297>
    }
    triangle {
      < -2.746782, 2.012204, -0.739545>,
      < -3.206557, 2.266230, -0.609586>,
      < -2.996337, 3.476492, -0.710395>
    }
    triangle {
      < -2.746782, 2.012204, -0.739545>,
      < -2.996337, 3.476492, -0.710395>,
      < -2.639934, 3.343994, -0.854432>
    }
    triangle {
      < -2.888019, 2.319817, 0.752916>,
      < -2.389562, 2.108848, 0.916315>,
      < -2.256229, 3.153966, 0.978039>
    }
    triangle {
      < -2.888019, 2.319817, 0.752916>,
      < -2.256229, 3.153966, 0.978039>,
      < -2.725005, 3.444355, 0.907791>
    }
    triangle {
      < -2.389562, 2.108848, 0.916315>,
      < -1.972370, 1.836697, 0.565753>,
      < -1.701408, 2.969087, 0.537007>
    }
    triangle {
      < -2.389562, 2.108848, 0.916315>,
      < -1.701408, 2.969087, 0.537007>,
      < -2.256229, 3.153966, 0.978039>
    }
    triangle {
      < -1.972370, 1.836697, 0.565753>,
      < -1.912222, 1.693259, 0.090164>,
      < -1.634357, 2.874438, 0.030700>
    }
    triangle {
      < -1.972370, 1.836697, 0.565753>,
      < -1.634357, 2.874438, 0.030700>,
      < -1.701408, 2.969087, 0.537007>
    }
    triangle {
      < -1.912222, 1.693259, 0.090164>,
      < -2.143766, 1.777314, -0.509196>,
      < -1.918431, 2.981536, -0.605970>
    }
    triangle {
      < -1.912222, 1.693259, 0.090164>,
      < -1.918431, 2.981536, -0.605970>,
      < -1.634357, 2.874438, 0.030700>
    }
    triangle {
      < -2.143766, 1.777314, -0.509196>,
      < -2.428253, 1.875464, -0.657165>,
      < -2.165084, 3.125649, -0.780297>
    }
    triangle {
      < -2.143766, 1.777314, -0.509196>,
      < -2.165084, 3.125649, -0.780297>,
      < -1.918431, 2.981536, -0.605970>
    }
    triangle {
      < -3.250841, 3.550476, -0.160077>,
      < -2.996337, 3.476492, -0.710395>,
      < -3.206557, 2.266230, -0.609586>
    }
    triangle {
      < -3.250841, 3.550476, -0.160077>,
      < -3.206557, 2.266230, -0.609586>,
      < -3.449607, 2.346718, -0.186191>
    }
    triangle {
      < -2.598399, 1.087355, 0.771866>,
      < -2.389562, 2.108848, 0.916315>,
      < -2.888019, 2.319817, 0.752916>
    }
    triangle {
      < -2.598399, 1.087355, 0.771866>,
      < -2.888019, 2.319817, 0.752916>,
      < -3.075922, 0.958967, 0.780647>
    }
    triangle {
      < -2.888019, 2.319817, 0.752916>,
      < -3.272733, 2.381291, 0.328889>,
      < -3.390432, 0.999678, 0.681287>
    }
    triangle {
      < -2.888019, 2.319817, 0.752916>,
      < -3.390432, 0.999678, 0.681287>,
      < -3.075922, 0.958967, 0.780647>
    }
    triangle {
      < -2.209945, 0.778184, 0.038156>,
      < -1.912222, 1.693259, 0.090164>,
      < -1.972370, 1.836697, 0.565753>
    }
    triangle {
      < -2.209945, 0.778184, 0.038156>,
      < -1.972370, 1.836697, 0.565753>,
      < -2.263130, 0.883407, 0.490936>
    }
    triangle {
      < -2.509296, 0.791452, -0.366753>,
      < -2.143766, 1.777314, -0.509196>,
      < -1.912222, 1.693259, 0.090164>
    }
    triangle {
      < -2.509296, 0.791452, -0.366753>,
      < -1.912222, 1.693259, 0.090164>,
      < -2.209945, 0.778184, 0.038156>
    }
    triangle {
      < -3.206557, 2.266230, -0.609586>,
      < -3.265405, 0.844826, -0.361207>,
      < -3.501794, 0.872930, 0.183442>
    }
    triangle {
      < -3.206557, 2.266230, -0.609586>,
      < -3.501794, 0.872930, 0.183442>,
      < -3.449607, 2.346718, -0.186191>
    }
    triangle {
      < -3.014387, 0.793627, -0.615524>,
      < -2.746782, 2.012204, -0.739545>,
      < -2.428253, 1.875464, -0.657165>
    }
    triangle {
      < -3.014387, 0.793627, -0.615524>,
      < -2.428253, 1.875464, -0.657165>,
      < -2.695315, 0.795125, -0.528766>
    }
    triangle {
      < -2.725005, 3.444355, 0.907791>,
      < -3.084058, 3.588311, 0.444890>,
      < -3.272733, 2.381291, 0.328889>
    }
    triangle {
      < -2.725005, 3.444355, 0.907791>,
      < -3.272733, 2.381291, 0.328889>,
      < -2.888019, 2.319817, 0.752916>
    }
    triangle {
      < -3.084058, 3.588311, 0.444890>,
      < -3.250841, 3.550476, -0.160077>,
      < -3.449607, 2.346718, -0.186191>
    }
    triangle {
      < -3.084058, 3.588311, 0.444890>,
      < -3.449607, 2.346718, -0.186191>,
      < -3.272733, 2.381291, 0.328889>
    }
    triangle {
      < -3.079602, -0.272644, 0.990726>,
      < -3.044585, 0.246167, 0.965609>,
      < -3.536503, 0.279278, 0.840728>
    }
    triangle {
      < -3.079602, -0.272644, 0.990726>,
      < -3.536503, 0.279278, 0.840728>,
      < -3.584816, -0.259706, 0.871421>
    }
    triangle {
      < -2.599851, -0.304157, 0.877433>,
      < -2.593155, 0.210968, 0.846518>,
      < -3.044585, 0.246167, 0.965609>
    }
    triangle {
      < -2.599851, -0.304157, 0.877433>,
      < -3.044585, 0.246167, 0.965609>,
      < -3.079602, -0.272644, 0.990726>
    }
    triangle {
      < -2.377485, -0.347431, -0.200958>,
      < -2.367596, 0.201567, -0.269846>,
      < -2.216184, 0.190357, 0.053862>
    }
    triangle {
      < -2.377485, -0.347431, -0.200958>,
      < -2.216184, 0.190357, 0.053862>,
      < -2.270152, -0.378846, 0.098363>
    }
    triangle {
      < -2.692744, -0.302287, -0.429027>,
      < -2.698462, 0.226836, -0.462052>,
      < -2.367596, 0.201567, -0.269846>
    }
    triangle {
      < -2.692744, -0.302287, -0.429027>,
      < -2.367596, 0.201567, -0.269846>,
      < -2.377485, -0.347431, -0.200958>
    }
    triangle {
      < -2.692744, -0.302287, -0.429027>,
      < -3.150655, -0.294560, -0.511985>,
      < -3.044701, 0.253003, -0.572372>
    }
    triangle {
      < -2.692744, -0.302287, -0.429027>,
      < -3.044701, 0.253003, -0.572372>,
      < -2.698462, 0.226836, -0.462052>
    }
    triangle {
      < -3.342636, 0.270231, -0.195426>,
      < -3.044701, 0.253003, -0.572372>,
      < -3.150655, -0.294560, -0.511985>
    }
    triangle {
      < -3.342636, 0.270231, -0.195426>,
      < -3.150655, -0.294560, -0.511985>,
      < -3.493797, -0.241574, -0.177637>
    }
    triangle {
      < -3.644981, -0.239785, 0.250997>,
      < -3.540532, 0.306510, 0.212961>,
      < -3.342636, 0.270231, -0.195426>
    }
    triangle {
      < -3.644981, -0.239785, 0.250997>,
      < -3.342636, 0.270231, -0.195426>,
      < -3.493797, -0.241574, -0.177637>
    }
    triangle {
      < -3.704188, -0.251920, 0.601294>,
      < -3.607651, 0.297461, 0.466432>,
      < -3.540532, 0.306510, 0.212961>
    }
    triangle {
      < -3.704188, -0.251920, 0.601294>,
      < -3.540532, 0.306510, 0.212961>,
      < -3.644981, -0.239785, 0.250997>
    }
    triangle {
      < -3.584816, -0.259706, 0.871421>,
      < -3.536503, 0.279278, 0.840728>,
      < -3.607651, 0.297461, 0.466432>
    }
    triangle {
      < -3.584816, -0.259706, 0.871421>,
      < -3.607651, 0.297461, 0.466432>,
      < -3.704188, -0.251920, 0.601294>
    }
    triangle {
      < -2.374817, -0.345360, 0.504614>,
      < -2.270152, -0.378846, 0.098363>,
      < -2.216184, 0.190357, 0.053862>
    }
    triangle {
      < -2.374817, -0.345360, 0.504614>,
      < -2.216184, 0.190357, 0.053862>,
      < -2.311565, 0.195061, 0.464117>
    }
    triangle {
      < -2.593155, 0.210968, 0.846518>,
      < -2.599851, -0.304157, 0.877433>,
      < -2.374817, -0.345360, 0.504614>
    }
    triangle {
      < -2.593155, 0.210968, 0.846518>,
      < -2.374817, -0.345360, 0.504614>,
      < -2.311565, 0.195061, 0.464117>
    }
    triangle {
      < -3.075922, 0.958967, 0.780647>,
      < -3.390432, 0.999678, 0.681287>,
      < -3.536503, 0.279278, 0.840728>
    }
    triangle {
      < -3.075922, 0.958967, 0.780647>,
      < -3.536503, 0.279278, 0.840728>,
      < -3.044585, 0.246167, 0.965609>
    }
    triangle {
      < -3.390432, 0.999678, 0.681287>,
      < -3.501794, 0.872930, 0.183442>,
      < -3.607651, 0.297461, 0.466432>
    }
    triangle {
      < -3.390432, 0.999678, 0.681287>,
      < -3.607651, 0.297461, 0.466432>,
      < -3.536503, 0.279278, 0.840728>
    }
    triangle {
      < -3.501794, 0.872930, 0.183442>,
      < -3.540532, 0.306510, 0.212961>,
      < -3.607651, 0.297461, 0.466432>
    }
    triangle {
      < -3.265405, 0.844826, -0.361207>,
      < -3.014387, 0.793627, -0.615524>,
      < -3.044701, 0.253003, -0.572372>
    }
    triangle {
      < -3.265405, 0.844826, -0.361207>,
      < -3.044701, 0.253003, -0.572372>,
      < -3.342636, 0.270231, -0.195426>
    }
    triangle {
      < -2.695315, 0.795125, -0.528766>,
      < -2.509296, 0.791452, -0.366753>,
      < -2.367596, 0.201567, -0.269846>
    }
    triangle {
      < -2.695315, 0.795125, -0.528766>,
      < -2.367596, 0.201567, -0.269846>,
      < -2.698462, 0.226836, -0.462052>
    }
    triangle {
      < -2.509296, 0.791452, -0.366753>,
      < -2.209945, 0.778184, 0.038156>,
      < -2.216184, 0.190357, 0.053862>
    }
    triangle {
      < -2.509296, 0.791452, -0.366753>,
      < -2.216184, 0.190357, 0.053862>,
      < -2.367596, 0.201567, -0.269846>
    }
    triangle {
      < -2.263130, 0.883407, 0.490936>,
      < -2.598399, 1.087355, 0.771866>,
      < -2.593155, 0.210968, 0.846518>
    }
    triangle {
      < -2.263130, 0.883407, 0.490936>,
      < -2.593155, 0.210968, 0.846518>,
      < -2.311565, 0.195061, 0.464117>
    }
    triangle {
      < -2.598399, 1.087355, 0.771866>,
      < -3.075922, 0.958967, 0.780647>,
      < -3.044585, 0.246167, 0.965609>
    }
    triangle {
      < -2.598399, 1.087355, 0.771866>,
      < -3.044585, 0.246167, 0.965609>,
      < -2.593155, 0.210968, 0.846518>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.628688, 4.359907, 0.080430>,
      < -0.621848, 4.334342, -0.052589>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.621848, 4.334342, -0.052589>,
      < -0.657583, 4.405418, -0.219440>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.657583, 4.405418, -0.219440>,
      < -0.688163, 4.473297, -0.264860>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.688163, 4.473297, -0.264860>,
      < -0.742740, 4.598918, -0.284237>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.742740, 4.598918, -0.284237>,
      < -0.781006, 4.690696, -0.246708>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.781006, 4.690696, -0.246708>,
      < -0.804378, 4.755525, -0.102882>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.804378, 4.755525, -0.102882>,
      < -0.786055, 4.724414, 0.056300>
    }
    triangle {
      < -0.685862, 4.501311, 0.195476>,
      < -0.786055, 4.724414, 0.056300>,
      < -0.742877, 4.632720, 0.177629>
    }
    triangle {
      < -1.701408, 2.969087, 0.537007>,
      < -1.634357, 2.874438, 0.030700>,
      < -1.490032, 3.238568, 0.016042>
    }
    triangle {
      < -1.701408, 2.969087, 0.537007>,
      < -1.490032, 3.238568, 0.016042>,
      < -1.550448, 3.319478, 0.523618>
    }
    triangle {
      < -1.634357, 2.874438, 0.030700>,
      < -1.918431, 2.981536, -0.605970>,
      < -1.717249, 3.439875, -0.620639>
    }
    triangle {
      < -1.634357, 2.874438, 0.030700>,
      < -1.717249, 3.439875, -0.620639>,
      < -1.490032, 3.238568, 0.016042>
    }
    triangle {
      < -1.918431, 2.981536, -0.605970>,
      < -2.165084, 3.125649, -0.780297>,
      < -1.921670, 3.637146, -0.793953>
    }
    triangle {
      < -1.918431, 2.981536, -0.605970>,
      < -1.921670, 3.637146, -0.793953>,
      < -1.717249, 3.439875, -0.620639>
    }
    triangle {
      < -2.165084, 3.125649, -0.780297>,
      < -2.639934, 3.343994, -0.854432>,
      < -2.292840, 4.005073, -0.867892>
    }
    triangle {
      < -2.165084, 3.125649, -0.780297>,
      < -2.292840, 4.005073, -0.867892>,
      < -1.921670, 3.637146, -0.793953>
    }
    triangle {
      < -2.639934, 3.343994, -0.854432>,
      < -2.996337, 3.476492, -0.710395>,
      < -2.558318, 4.276166, -0.724688>
    }
    triangle {
      < -2.639934, 3.343994, -0.854432>,
      < -2.558318, 4.276166, -0.724688>,
      < -2.292840, 4.005073, -0.867892>
    }
    triangle {
      < -2.996337, 3.476492, -0.710395>,
      < -3.250841, 3.550476, -0.160077>,
      < -2.732883, 4.472814, -0.175871>
    }
    triangle {
      < -2.996337, 3.476492, -0.710395>,
      < -2.732883, 4.472814, -0.175871>,
      < -2.558318, 4.276166, -0.724688>
    }
    triangle {
      < -3.250841, 3.550476, -0.160077>,
      < -3.084058, 3.588311, 0.444890>,
      < -2.623926, 4.388504, 0.431542>
    }
    triangle {
      < -3.250841, 3.550476, -0.160077>,
      < -2.623926, 4.388504, 0.431542>,
      < -2.732883, 4.472814, -0.175871>
    }
    triangle {
      < -3.084058, 3.588311, 0.444890>,
      < -2.725005, 3.444355, 0.907791>,
      < -2.341161, 4.124658, 0.894512>
    }
    triangle {
      < -3.084058, 3.588311, 0.444890>,
      < -2.341161, 4.124658, 0.894512>,
      < -2.623926, 4.388504, 0.431542>
    }
    triangle {
      < -2.725005, 3.444355, 0.907791>,
      < -2.256229, 3.153966, 0.978039>,
      < -1.953159, 3.739673, 0.962616>
    }
    triangle {
      < -2.725005, 3.444355, 0.907791>,
      < -1.953159, 3.739673, 0.962616>,
      < -2.341161, 4.124658, 0.894512>
    }
    triangle {
      < -2.256229, 3.153966, 0.978039>,
      < -1.701408, 2.969087, 0.537007>,
      < -1.550448, 3.319478, 0.523618>
    }
    triangle {
      < -2.256229, 3.153966, 0.978039>,
      < -1.550448, 3.319478, 0.523618>,
      < -1.953159, 3.739673, 0.962616>
    }
    triangle {
      < -2.623926, 4.388504, 0.431542>,
      < -2.341161, 4.124658, 0.894512>,
      < -1.921392, 4.435579, 0.874178>
    }
    triangle {
      < -2.623926, 4.388504, 0.431542>,
      < -1.921392, 4.435579, 0.874178>,
      < -2.148929, 4.732874, 0.418104>
    }
    triangle {
      < -2.341161, 4.124658, 0.894512>,
      < -1.953159, 3.739673, 0.962616>,
      < -1.613344, 4.007860, 0.941017>
    }
    triangle {
      < -2.341161, 4.124658, 0.894512>,
      < -1.613344, 4.007860, 0.941017>,
      < -1.921392, 4.435579, 0.874178>
    }
    triangle {
      < -1.953159, 3.739673, 0.962616>,
      < -1.550448, 3.319478, 0.523618>,
      < -1.295038, 3.541559, 0.508972>
    }
    triangle {
      < -1.953159, 3.739673, 0.962616>,
      < -1.295038, 3.541559, 0.508972>,
      < -1.613344, 4.007860, 0.941017>
    }
    triangle {
      < -1.550448, 3.319478, 0.523618>,
      < -1.490032, 3.238568, 0.016042>,
      < -1.250166, 3.455350, 0.011792>
    }
    triangle {
      < -1.550448, 3.319478, 0.523618>,
      < -1.250166, 3.455350, 0.011792>,
      < -1.295038, 3.541559, 0.508972>
    }
    triangle {
      < -1.490032, 3.238568, 0.016042>,
      < -1.717249, 3.439875, -0.620639>,
      < -1.434622, 3.670614, -0.616165>
    }
    triangle {
      < -1.490032, 3.238568, 0.016042>,
      < -1.434622, 3.670614, -0.616165>,
      < -1.250166, 3.455350, 0.011792>
    }
    triangle {
      < -1.717249, 3.439875, -0.620639>,
      < -1.921670, 3.637146, -0.793953>,
      < -1.597707, 3.890364, -0.785028>
    }
    triangle {
      < -1.717249, 3.439875, -0.620639>,
      < -1.597707, 3.890364, -0.785028>,
      < -1.434622, 3.670614, -0.616165>
    }
    triangle {
      < -1.921670, 3.637146, -0.793953>,
      < -2.292840, 4.005073, -0.867892>,
      < -1.894666, 4.302699, -0.858074>
    }
    triangle {
      < -1.921670, 3.637146, -0.793953>,
      < -1.894666, 4.302699, -0.858074>,
      < -1.597707, 3.890364, -0.785028>
    }
    triangle {
      < -2.292840, 4.005073, -0.867892>,
      < -2.558318, 4.276166, -0.724688>,
      < -2.104079, 4.601659, -0.719015>
    }
    triangle {
      < -2.292840, 4.005073, -0.867892>,
      < -2.104079, 4.601659, -0.719015>,
      < -1.894666, 4.302699, -0.858074>
    }
    triangle {
      < -2.558318, 4.276166, -0.724688>,
      < -2.732883, 4.472814, -0.175871>,
      < -2.240090, 4.831474, -0.180282>
    }
    triangle {
      < -2.558318, 4.276166, -0.724688>,
      < -2.240090, 4.831474, -0.180282>,
      < -2.104079, 4.601659, -0.719015>
    }
    triangle {
      < -2.732883, 4.472814, -0.175871>,
      < -2.623926, 4.388504, 0.431542>,
      < -2.148929, 4.732874, 0.418104>
    }
    triangle {
      < -2.732883, 4.472814, -0.175871>,
      < -2.148929, 4.732874, 0.418104>,
      < -2.240090, 4.831474, -0.180282>
    }
    triangle {
      < -1.403898, 4.490224, -0.848257>,
      < -1.542589, 4.823540, -0.713341>,
      < -1.083963, 4.847274, -0.542113>
    }
    triangle {
      < -1.403898, 4.490224, -0.848257>,
      < -1.083963, 4.847274, -0.542113>,
      < -0.981854, 4.602366, -0.642257>
    }
    triangle {
      < -1.542589, 4.823540, -0.713341>,
      < -1.627299, 5.061404, -0.184693>,
      < -1.146336, 5.020259, -0.158321>
    }
    triangle {
      < -1.542589, 4.823540, -0.713341>,
      < -1.146336, 5.020259, -0.158321>,
      < -1.083963, 4.847274, -0.542113>
    }
    triangle {
      < -1.627299, 5.061404, -0.184693>,
      < -1.559017, 4.945367, 0.404666>,
      < -1.097437, 4.937255, 0.266447>
    }
    triangle {
      < -1.627299, 5.061404, -0.184693>,
      < -1.097437, 4.937255, 0.266447>,
      < -1.146336, 5.020259, -0.158321>
    }
    triangle {
      < -1.559017, 4.945367, 0.404666>,
      < -1.401560, 4.607304, 0.853844>,
      < -0.982223, 4.692563, 0.590206>
    }
    triangle {
      < -1.559017, 4.945367, 0.404666>,
      < -0.982223, 4.692563, 0.590206>,
      < -1.097437, 4.937255, 0.266447>
    }
    triangle {
      < -1.401560, 4.607304, 0.853844>,
      < -1.194571, 4.127187, 0.919418>,
      < -0.830078, 4.341913, 0.637832>
    }
    triangle {
      < -1.401560, 4.607304, 0.853844>,
      < -0.830078, 4.341913, 0.637832>,
      < -0.982223, 4.692563, 0.590206>
    }
    triangle {
      < -1.194571, 4.127187, 0.919418>,
      < -0.983645, 3.604900, 0.494325>,
      < -0.677512, 3.964583, 0.330837>
    }
    triangle {
      < -1.194571, 4.127187, 0.919418>,
      < -0.677512, 3.964583, 0.330837>,
      < -0.830078, 4.341913, 0.637832>
    }
    triangle {
      < -0.983645, 3.604900, 0.494325>,
      < -0.958410, 3.512180, 0.007543>,
      < -0.659258, 3.896364, -0.024115>
    }
    triangle {
      < -0.983645, 3.604900, 0.494325>,
      < -0.659258, 3.896364, -0.024115>,
      < -0.677512, 3.964583, 0.330837>
    }
    triangle {
      < -0.958410, 3.512180, 0.007543>,
      < -1.090767, 3.776647, -0.611690>,
      < -0.754616, 4.086032, -0.469351>
    }
    triangle {
      < -0.958410, 3.512180, 0.007543>,
      < -0.754616, 4.086032, -0.469351>,
      < -0.659258, 3.896364, -0.024115>
    }
    triangle {
      < -1.090767, 3.776647, -0.611690>,
      < -1.201642, 4.024040, -0.776104>,
      < -0.836218, 4.267161, -0.590551>
    }
    triangle {
      < -1.090767, 3.776647, -0.611690>,
      < -0.836218, 4.267161, -0.590551>,
      < -0.754616, 4.086032, -0.469351>
    }
    triangle {
      < -1.201642, 4.024040, -0.776104>,
      < -1.403898, 4.490224, -0.848257>,
      < -0.981854, 4.602366, -0.642257>
    }
    triangle {
      < -1.201642, 4.024040, -0.776104>,
      < -0.981854, 4.602366, -0.642257>,
      < -0.836218, 4.267161, -0.590551>
    }
    triangle {
      < -0.659258, 3.896364, -0.024115>,
      < -0.754616, 4.086032, -0.469351>,
      < -0.657583, 4.405418, -0.219440>
    }
    triangle {
      < -0.659258, 3.896364, -0.024115>,
      < -0.657583, 4.405418, -0.219440>,
      < -0.621848, 4.334342, -0.052589>
    }
    triangle {
      < -0.754616, 4.086032, -0.469351>,
      < -0.836218, 4.267161, -0.590551>,
      < -0.688163, 4.473297, -0.264860>
    }
    triangle {
      < -0.754616, 4.086032, -0.469351>,
      < -0.688163, 4.473297, -0.264860>,
      < -0.657583, 4.405418, -0.219440>
    }
    triangle {
      < -0.836218, 4.267161, -0.590551>,
      < -0.981854, 4.602366, -0.642257>,
      < -0.742740, 4.598918, -0.284237>
    }
    triangle {
      < -0.836218, 4.267161, -0.590551>,
      < -0.742740, 4.598918, -0.284237>,
      < -0.688163, 4.473297, -0.264860>
    }
    triangle {
      < -0.981854, 4.602366, -0.642257>,
      < -1.083963, 4.847274, -0.542113>,
      < -0.781006, 4.690696, -0.246708>
    }
    triangle {
      < -0.981854, 4.602366, -0.642257>,
      < -0.781006, 4.690696, -0.246708>,
      < -0.742740, 4.598918, -0.284237>
    }
    triangle {
      < -1.083963, 4.847274, -0.542113>,
      < -1.146336, 5.020259, -0.158321>,
      < -0.804378, 4.755525, -0.102882>
    }
    triangle {
      < -1.083963, 4.847274, -0.542113>,
      < -0.804378, 4.755525, -0.102882>,
      < -0.781006, 4.690696, -0.246708>
    }
    triangle {
      < -1.146336, 5.020259, -0.158321>,
      < -1.097437, 4.937255, 0.266447>,
      < -0.786055, 4.724414, 0.056300>
    }
    triangle {
      < -1.146336, 5.020259, -0.158321>,
      < -0.786055, 4.724414, 0.056300>,
      < -0.804378, 4.755525, -0.102882>
    }
    triangle {
      < -1.097437, 4.937255, 0.266447>,
      < -0.982223, 4.692563, 0.590206>,
      < -0.742877, 4.632720, 0.177629>
    }
    triangle {
      < -1.097437, 4.937255, 0.266447>,
      < -0.742877, 4.632720, 0.177629>,
      < -0.786055, 4.724414, 0.056300>
    }
    triangle {
      < -0.982223, 4.692563, 0.590206>,
      < -0.830078, 4.341913, 0.637832>,
      < -0.685862, 4.501311, 0.195476>
    }
    triangle {
      < -0.982223, 4.692563, 0.590206>,
      < -0.685862, 4.501311, 0.195476>,
      < -0.742877, 4.632720, 0.177629>
    }
    triangle {
      < -0.830078, 4.341913, 0.637832>,
      < -0.677512, 3.964583, 0.330837>,
      < -0.628688, 4.359907, 0.080430>
    }
    triangle {
      < -0.830078, 4.341913, 0.637832>,
      < -0.628688, 4.359907, 0.080430>,
      < -0.685862, 4.501311, 0.195476>
    }
    triangle {
      < -0.677512, 3.964583, 0.330837>,
      < -0.659258, 3.896364, -0.024115>,
      < -0.621848, 4.334342, -0.052589>
    }
    triangle {
      < -0.677512, 3.964583, 0.330837>,
      < -0.621848, 4.334342, -0.052589>,
      < -0.628688, 4.359907, 0.080430>
    }
    triangle {
      < -1.295038, 3.541559, 0.508972>,
      < -1.250166, 3.455350, 0.011792>,
      < -0.958410, 3.512180, 0.007543>
    }
    triangle {
      < -1.295038, 3.541559, 0.508972>,
      < -0.958410, 3.512180, 0.007543>,
      < -0.983645, 3.604900, 0.494325>
    }
    triangle {
      < -1.613344, 4.007860, 0.941017>,
      < -1.295038, 3.541559, 0.508972>,
      < -0.983645, 3.604900, 0.494325>
    }
    triangle {
      < -1.613344, 4.007860, 0.941017>,
      < -0.983645, 3.604900, 0.494325>,
      < -1.194571, 4.127187, 0.919418>
    }
    triangle {
      < -1.921392, 4.435579, 0.874178>,
      < -1.613344, 4.007860, 0.941017>,
      < -1.194571, 4.127187, 0.919418>
    }
    triangle {
      < -1.921392, 4.435579, 0.874178>,
      < -1.194571, 4.127187, 0.919418>,
      < -1.401560, 4.607304, 0.853844>
    }
    triangle {
      < -2.148929, 4.732874, 0.418104>,
      < -1.921392, 4.435579, 0.874178>,
      < -1.401560, 4.607304, 0.853844>
    }
    triangle {
      < -2.148929, 4.732874, 0.418104>,
      < -1.401560, 4.607304, 0.853844>,
      < -1.559017, 4.945367, 0.404666>
    }
    triangle {
      < -2.240090, 4.831474, -0.180282>,
      < -2.148929, 4.732874, 0.418104>,
      < -1.559017, 4.945367, 0.404666>
    }
    triangle {
      < -2.240090, 4.831474, -0.180282>,
      < -1.559017, 4.945367, 0.404666>,
      < -1.627299, 5.061404, -0.184693>
    }
    triangle {
      < -2.104079, 4.601659, -0.719015>,
      < -2.240090, 4.831474, -0.180282>,
      < -1.627299, 5.061404, -0.184693>
    }
    triangle {
      < -2.104079, 4.601659, -0.719015>,
      < -1.627299, 5.061404, -0.184693>,
      < -1.542589, 4.823540, -0.713341>
    }
    triangle {
      < -1.894666, 4.302699, -0.858074>,
      < -2.104079, 4.601659, -0.719015>,
      < -1.542589, 4.823540, -0.713341>
    }
    triangle {
      < -1.894666, 4.302699, -0.858074>,
      < -1.542589, 4.823540, -0.713341>,
      < -1.403898, 4.490224, -0.848257>
    }
    triangle {
      < -1.597707, 3.890364, -0.785028>,
      < -1.894666, 4.302699, -0.858074>,
      < -1.403898, 4.490224, -0.848257>
    }
    triangle {
      < -1.597707, 3.890364, -0.785028>,
      < -1.403898, 4.490224, -0.848257>,
      < -1.201642, 4.024040, -0.776104>
    }
    triangle {
      < -1.434622, 3.670614, -0.616165>,
      < -1.597707, 3.890364, -0.785028>,
      < -1.201642, 4.024040, -0.776104>
    }
    triangle {
      < -1.434622, 3.670614, -0.616165>,
      < -1.201642, 4.024040, -0.776104>,
      < -1.090767, 3.776647, -0.611690>
    }
    triangle {
      < -1.250166, 3.455350, 0.011792>,
      < -1.434622, 3.670614, -0.616165>,
      < -1.090767, 3.776647, -0.611690>
    }
    triangle {
      < -1.250166, 3.455350, 0.011792>,
      < -1.090767, 3.776647, -0.611690>,
      < -0.958410, 3.512180, 0.007543>
    }
    texture {armr}
  }
  // arml
  union {
    triangle {
      < 2.637240, -5.188992, 1.115963>,
      < 2.631475, -5.189024, 1.144910>,
      < 2.641492, -5.023551, 1.151718>
    }
    triangle {
      < 2.637240, -5.188992, 1.115963>,
      < 2.641492, -5.023551, 1.151718>,
      < 2.631430, -5.021671, 1.121294>
    }
    triangle {
      < 2.641750, -5.009909, 1.175060>,
      < 2.631430, -5.021671, 1.121294>,
      < 2.641492, -5.023551, 1.151718>
    }
    triangle {
      < 2.694940, -4.534479, 1.074974>,
      < 2.643964, -4.725788, 1.080201>,
      < 2.668286, -4.735597, 1.220260>
    }
    triangle {
      < 2.694940, -4.534479, 1.074974>,
      < 2.668286, -4.735597, 1.220260>,
      < 2.711608, -4.528833, 1.228295>
    }
    triangle {
      < 2.849420, -4.258226, 1.321365>,
      < 2.791797, -4.524917, 1.292616>,
      < 2.902829, -4.522134, 1.286647>
    }
    triangle {
      < 2.849420, -4.258226, 1.321365>,
      < 2.902829, -4.522134, 1.286647>,
      < 2.973360, -4.269324, 1.317931>
    }
    triangle {
      < 2.902829, -4.522134, 1.286647>,
      < 2.791797, -4.524917, 1.292616>,
      < 2.747367, -4.744814, 1.283339>
    }
    triangle {
      < 2.902829, -4.522134, 1.286647>,
      < 2.747367, -4.744814, 1.283339>,
      < 2.857244, -4.750984, 1.276291>
    }
    triangle {
      < 2.815561, -5.029976, 1.234091>,
      < 2.716361, -5.024138, 1.237795>,
      < 2.709860, -5.038414, 1.211770>
    }
    triangle {
      < 2.815561, -5.029976, 1.234091>,
      < 2.709860, -5.038414, 1.211770>,
      < 2.799385, -5.042875, 1.209213>
    }
    triangle {
      < 2.756208, -4.246720, 1.254495>,
      < 2.695638, -4.264558, 1.100924>,
      < 2.694940, -4.534479, 1.074974>
    }
    triangle {
      < 2.756208, -4.246720, 1.254495>,
      < 2.694940, -4.534479, 1.074974>,
      < 2.711608, -4.528833, 1.228295>
    }
    triangle {
      < 2.794990, -5.219936, 1.222509>,
      < 2.798819, -5.210745, 1.199050>,
      < 2.832069, -5.040146, 1.196513>
    }
    triangle {
      < 2.794990, -5.219936, 1.222509>,
      < 2.832069, -5.040146, 1.196513>,
      < 2.799385, -5.042875, 1.209213>
    }
    triangle {
      < 2.799385, -5.042875, 1.209213>,
      < 2.709860, -5.038414, 1.211770>,
      < 2.697364, -5.274925, 1.189184>
    }
    triangle {
      < 2.799385, -5.042875, 1.209213>,
      < 2.697364, -5.274925, 1.189184>,
      < 2.756707, -5.252022, 1.199861>
    }
    triangle {
      < 2.799385, -5.042875, 1.209213>,
      < 2.756707, -5.252022, 1.199861>,
      < 2.794990, -5.219936, 1.222509>
    }
    triangle {
      < 2.832069, -5.040146, 1.196513>,
      < 2.815561, -5.029976, 1.234091>,
      < 2.799385, -5.042875, 1.209213>
    }
    triangle {
      < 2.857244, -4.750984, 1.276291>,
      < 3.003325, -4.727902, 1.148698>,
      < 3.029877, -4.546164, 1.187151>
    }
    triangle {
      < 2.857244, -4.750984, 1.276291>,
      < 3.029877, -4.546164, 1.187151>,
      < 2.902829, -4.522134, 1.286647>
    }
    triangle {
      < 2.973360, -4.269324, 1.317931>,
      < 2.902829, -4.522134, 1.286647>,
      < 3.029877, -4.546164, 1.187151>
    }
    triangle {
      < 2.973360, -4.269324, 1.317931>,
      < 3.029877, -4.546164, 1.187151>,
      < 3.168708, -4.360939, 1.148516>
    }
    triangle {
      < 2.973360, -4.269324, 1.317931>,
      < 3.168708, -4.360939, 1.148516>,
      < 3.163307, -4.271783, 1.217669>
    }
    triangle {
      < 3.168708, -4.360939, 1.148516>,
      < 3.310992, -4.389974, 1.185302>,
      < 3.163307, -4.271783, 1.217669>
    }
    triangle {
      < 3.310992, -4.389974, 1.185302>,
      < 3.446155, -4.248275, 1.191563>,
      < 3.163307, -4.271783, 1.217669>
    }
    triangle {
      < 3.446155, -4.248275, 1.191563>,
      < 3.171760, -4.101448, 1.247475>,
      < 3.163307, -4.271783, 1.217669>
    }
    triangle {
      < 3.171760, -4.101448, 1.247475>,
      < 2.973360, -4.269324, 1.317931>,
      < 3.163307, -4.271783, 1.217669>
    }
    triangle {
      < 2.973360, -4.269324, 1.317931>,
      < 2.903923, -3.680026, 1.129989>,
      < 2.849420, -4.258226, 1.321365>
    }
    triangle {
      < 2.756208, -4.246720, 1.254495>,
      < 2.903923, -3.680026, 1.129989>,
      < 2.713652, -3.719675, 0.943718>
    }
    triangle {
      < 2.756208, -4.246720, 1.254495>,
      < 2.713652, -3.719675, 0.943718>,
      < 2.695638, -4.264558, 1.100924>
    }
    triangle {
      < 2.695638, -4.264558, 1.100924>,
      < 2.713652, -3.719675, 0.943718>,
      < 2.704204, -3.806584, 0.684968>
    }
    triangle {
      < 2.695638, -4.264558, 1.100924>,
      < 2.704204, -3.806584, 0.684968>,
      < 2.747921, -4.290134, 0.909324>
    }
    triangle {
      < 2.694940, -4.534479, 1.074974>,
      < 2.741052, -4.560413, 0.984922>,
      < 2.703791, -4.743211, 0.972488>
    }
    triangle {
      < 2.694940, -4.534479, 1.074974>,
      < 2.703791, -4.743211, 0.972488>,
      < 2.643964, -4.725788, 1.080201>
    }
    triangle {
      < 2.694940, -4.534479, 1.074974>,
      < 2.695638, -4.264558, 1.100924>,
      < 2.747921, -4.290134, 0.909324>
    }
    triangle {
      < 2.694940, -4.534479, 1.074974>,
      < 2.747921, -4.290134, 0.909324>,
      < 2.741052, -4.560413, 0.984922>
    }
    triangle {
      < 3.171760, -4.101448, 1.247475>,
      < 3.446155, -4.248275, 1.191563>,
      < 3.483165, -3.822722, 1.044899>
    }
    triangle {
      < 3.171760, -4.101448, 1.247475>,
      < 3.483165, -3.822722, 1.044899>,
      < 3.201631, -3.744820, 1.164047>
    }
    triangle {
      < 3.348468, -4.497969, 1.145854>,
      < 3.310992, -4.389974, 1.185302>,
      < 3.168708, -4.360939, 1.148516>
    }
    triangle {
      < 3.348468, -4.497969, 1.145854>,
      < 3.168708, -4.360939, 1.148516>,
      < 3.073454, -4.431412, 0.941757>
    }
    triangle {
      < 3.348468, -4.497969, 1.145854>,
      < 3.073454, -4.431412, 0.941757>,
      < 3.235652, -4.565553, 1.006618>
    }
    triangle {
      < 3.073454, -4.431412, 0.941757>,
      < 3.168708, -4.360939, 1.148516>,
      < 3.029877, -4.546164, 1.187151>
    }
    triangle {
      < 3.073454, -4.431412, 0.941757>,
      < 3.029877, -4.546164, 1.187151>,
      < 2.993353, -4.579245, 0.974282>
    }
    triangle {
      < 2.993353, -4.579245, 0.974282>,
      < 3.029877, -4.546164, 1.187151>,
      < 3.003325, -4.727902, 1.148698>
    }
    triangle {
      < 2.993353, -4.579245, 0.974282>,
      < 3.003325, -4.727902, 1.148698>,
      < 2.955719, -4.779051, 0.972429>
    }
    triangle {
      < 2.955719, -4.779051, 0.972429>,
      < 3.003325, -4.727902, 1.148698>,
      < 2.899959, -5.015127, 1.172929>
    }
    triangle {
      < 2.955719, -4.779051, 0.972429>,
      < 2.899959, -5.015127, 1.172929>,
      < 2.839635, -5.003333, 0.986344>
    }
    triangle {
      < 2.839635, -5.003333, 0.986344>,
      < 2.899959, -5.015127, 1.172929>,
      < 2.823724, -5.203536, 1.130062>
    }
    triangle {
      < 2.747921, -4.290134, 0.909324>,
      < 2.899165, -4.345756, 0.831593>,
      < 2.993353, -4.579245, 0.974282>
    }
    triangle {
      < 2.747921, -4.290134, 0.909324>,
      < 2.993353, -4.579245, 0.974282>,
      < 2.741052, -4.560413, 0.984922>
    }
    triangle {
      < 2.741052, -4.560413, 0.984922>,
      < 2.993353, -4.579245, 0.974282>,
      < 2.955719, -4.779051, 0.972429>
    }
    triangle {
      < 2.741052, -4.560413, 0.984922>,
      < 2.955719, -4.779051, 0.972429>,
      < 2.703791, -4.743211, 0.972488>
    }
    triangle {
      < 2.703791, -4.743211, 0.972488>,
      < 2.955719, -4.779051, 0.972429>,
      < 2.839635, -5.003333, 0.986344>
    }
    triangle {
      < 2.703791, -4.743211, 0.972488>,
      < 2.839635, -5.003333, 0.986344>,
      < 2.676981, -5.016549, 0.977451>
    }
    triangle {
      < 2.671290, -5.134576, 1.004575>,
      < 2.823724, -5.203536, 1.130062>,
      < 2.759147, -5.241912, 1.167365>
    }
    triangle {
      < 2.671290, -5.134576, 1.004575>,
      < 2.759147, -5.241912, 1.167365>,
      < 2.676505, -5.230327, 1.135723>
    }
    triangle {
      < 2.798819, -5.210745, 1.199050>,
      < 2.759147, -5.241912, 1.167365>,
      < 2.823724, -5.203536, 1.130062>
    }
    triangle {
      < 2.899165, -4.345756, 0.831593>,
      < 2.747921, -4.290134, 0.909324>,
      < 2.704204, -3.806584, 0.684968>
    }
    triangle {
      < 2.899165, -4.345756, 0.831593>,
      < 2.704204, -3.806584, 0.684968>,
      < 2.990301, -3.784639, 0.396786>
    }
    triangle {
      < 3.073454, -4.431412, 0.941757>,
      < 2.990301, -3.784639, 0.396786>,
      < 3.197434, -4.219485, 0.539804>
    }
    triangle {
      < 3.073454, -4.431412, 0.941757>,
      < 2.993353, -4.579245, 0.974282>,
      < 2.899165, -4.345756, 0.831593>
    }
    triangle {
      < 3.348468, -4.497969, 1.145854>,
      < 3.235652, -4.565553, 1.006618>,
      < 3.324410, -4.776068, 1.013156>
    }
    triangle {
      < 3.348468, -4.497969, 1.145854>,
      < 3.324410, -4.776068, 1.013156>,
      < 3.483935, -4.776453, 1.166256>
    }
    triangle {
      < 3.483935, -4.776453, 1.166256>,
      < 3.324410, -4.776068, 1.013156>,
      < 3.369840, -4.918569, 1.022564>
    }
    triangle {
      < 3.483935, -4.776453, 1.166256>,
      < 3.369840, -4.918569, 1.022564>,
      < 3.535011, -4.937427, 1.154687>
    }
    triangle {
      < 3.535011, -4.937427, 1.154687>,
      < 3.369840, -4.918569, 1.022564>,
      < 3.486985, -5.292625, 1.048481>
    }
    triangle {
      < 3.535011, -4.937427, 1.154687>,
      < 3.486985, -5.292625, 1.048481>,
      < 3.637986, -5.299436, 1.165222>
    }
    triangle {
      < 3.486985, -5.292625, 1.048481>,
      < 3.459127, -5.660091, 1.004743>,
      < 3.545418, -5.692355, 1.088168>
    }
    triangle {
      < 3.486985, -5.292625, 1.048481>,
      < 3.545418, -5.692355, 1.088168>,
      < 3.637986, -5.299436, 1.165222>
    }
    triangle {
      < 3.545418, -5.692355, 1.088168>,
      < 3.459127, -5.660091, 1.004743>,
      < 3.427807, -5.874164, 0.987612>
    }
    triangle {
      < 3.545418, -5.692355, 1.088168>,
      < 3.427807, -5.874164, 0.987612>,
      < 3.492407, -5.893525, 1.037085>
    }
    triangle {
      < 3.653747, -4.749532, 1.108063>,
      < 3.483935, -4.776453, 1.166256>,
      < 3.535011, -4.937427, 1.154687>
    }
    triangle {
      < 3.653747, -4.749532, 1.108063>,
      < 3.535011, -4.937427, 1.154687>,
      < 3.654503, -4.904352, 1.111933>
    }
    triangle {
      < 3.535011, -4.937427, 1.154687>,
      < 3.637986, -5.299436, 1.165222>,
      < 3.749973, -5.313198, 1.098377>
    }
    triangle {
      < 3.535011, -4.937427, 1.154687>,
      < 3.749973, -5.313198, 1.098377>,
      < 3.654503, -4.904352, 1.111933>
    }
    triangle {
      < 3.749973, -5.313198, 1.098377>,
      < 3.637986, -5.299436, 1.165222>,
      < 3.545418, -5.692355, 1.088168>
    }
    triangle {
      < 3.749973, -5.313198, 1.098377>,
      < 3.545418, -5.692355, 1.088168>,
      < 3.632454, -5.713002, 1.037336>
    }
    triangle {
      < 3.553595, -5.892168, 0.986735>,
      < 3.531374, -5.903006, 0.994906>,
      < 3.550858, -5.907750, 0.973820>
    }
    triangle {
      < 3.505432, -6.057985, 0.920378>,
      < 3.513249, -6.071916, 0.875409>,
      < 3.531293, -6.078069, 0.882219>
    }
    triangle {
      < 3.505432, -6.057985, 0.920378>,
      < 3.531293, -6.078069, 0.882219>,
      < 3.518012, -6.067028, 0.920041>
    }
    triangle {
      < 3.761762, -4.904438, 1.035913>,
      < 3.826484, -5.322048, 1.027841>,
      < 3.813822, -5.323252, 0.919115>
    }
    triangle {
      < 3.761762, -4.904438, 1.035913>,
      < 3.813822, -5.323252, 0.919115>,
      < 3.782173, -4.912578, 0.915967>
    }
    triangle {
      < 3.813822, -5.323252, 0.919115>,
      < 3.826484, -5.322048, 1.027841>,
      < 3.701282, -5.729109, 0.969850>
    }
    triangle {
      < 3.813822, -5.323252, 0.919115>,
      < 3.701282, -5.729109, 0.969850>,
      < 3.683643, -5.717794, 0.871465>
    }
    triangle {
      < 3.609701, -5.892986, 0.836394>,
      < 3.624970, -5.907471, 0.927947>,
      < 3.610975, -5.919303, 0.919372>
    }
    triangle {
      < 3.609701, -5.892986, 0.836394>,
      < 3.610975, -5.919303, 0.919372>,
      < 3.605893, -5.908008, 0.839344>
    }
    triangle {
      < 3.549953, -4.498902, 1.149813>,
      < 3.348468, -4.497969, 1.145854>,
      < 3.483935, -4.776453, 1.166256>
    }
    triangle {
      < 3.549953, -4.498902, 1.149813>,
      < 3.483935, -4.776453, 1.166256>,
      < 3.653747, -4.749532, 1.108063>
    }
    triangle {
      < 3.768749, -4.368258, 0.884841>,
      < 3.626639, -4.463606, 1.089377>,
      < 3.756013, -4.691369, 0.949057>
    }
    triangle {
      < 3.446155, -4.248275, 1.191563>,
      < 3.768749, -4.368258, 0.884841>,
      < 3.700375, -3.896398, 0.812029>
    }
    triangle {
      < 3.446155, -4.248275, 1.191563>,
      < 3.700375, -3.896398, 0.812029>,
      < 3.483165, -3.822722, 1.044899>
    }
    triangle {
      < 3.483165, -3.822722, 1.044899>,
      < 3.700375, -3.896398, 0.812029>,
      < 3.613293, -3.303538, 0.713008>
    }
    triangle {
      < 3.483165, -3.822722, 1.044899>,
      < 3.613293, -3.303538, 0.713008>,
      < 3.444501, -3.301727, 0.923484>
    }
    triangle {
      < 3.483165, -3.822722, 1.044899>,
      < 3.444501, -3.301727, 0.923484>,
      < 3.222924, -3.353535, 1.002504>
    }
    triangle {
      < 3.483165, -3.822722, 1.044899>,
      < 3.222924, -3.353535, 1.002504>,
      < 3.201631, -3.744820, 1.164047>
    }
    triangle {
      < 2.903923, -3.680026, 1.129989>,
      < 2.999575, -3.309280, 0.968456>,
      < 2.876625, -3.360112, 0.793590>
    }
    triangle {
      < 2.903923, -3.680026, 1.129989>,
      < 2.876625, -3.360112, 0.793590>,
      < 2.713652, -3.719675, 0.943718>
    }
    triangle {
      < 3.675314, -3.326316, 0.542915>,
      < 3.613293, -3.303538, 0.713008>,
      < 3.700375, -3.896398, 0.812029>
    }
    triangle {
      < 3.675314, -3.326316, 0.542915>,
      < 3.700375, -3.896398, 0.812029>,
      < 3.783816, -3.880267, 0.562139>
    }
    triangle {
      < 3.783816, -3.880267, 0.562139>,
      < 3.700375, -3.896398, 0.812029>,
      < 3.768749, -4.368258, 0.884841>
    }
    triangle {
      < 3.783816, -3.880267, 0.562139>,
      < 3.768749, -4.368258, 0.884841>,
      < 3.870004, -4.337597, 0.578456>
    }
    triangle {
      < 3.768749, -4.368258, 0.884841>,
      < 3.978867, -4.556856, 0.590013>,
      < 3.870004, -4.337597, 0.578456>
    }
    triangle {
      < 3.768749, -4.368258, 0.884841>,
      < 3.803743, -4.753818, 0.693033>,
      < 3.978867, -4.556856, 0.590013>
    }
    triangle {
      < 3.768749, -4.368258, 0.884841>,
      < 3.710069, -4.766702, 0.790986>,
      < 3.803743, -4.753818, 0.693033>
    }
    triangle {
      < 3.710069, -4.766702, 0.790986>,
      < 3.768749, -4.368258, 0.884841>,
      < 3.756013, -4.691369, 0.949057>
    }
    triangle {
      < 3.782173, -4.912578, 0.915967>,
      < 3.813822, -5.323252, 0.919115>,
      < 3.649614, -5.325970, 0.777320>
    }
    triangle {
      < 3.782173, -4.912578, 0.915967>,
      < 3.649614, -5.325970, 0.777320>,
      < 3.650504, -4.915636, 0.760976>
    }
    triangle {
      < 3.649614, -5.325970, 0.777320>,
      < 3.813822, -5.323252, 0.919115>,
      < 3.683643, -5.717794, 0.871465>
    }
    triangle {
      < 3.649614, -5.325970, 0.777320>,
      < 3.683643, -5.717794, 0.871465>,
      < 3.553799, -5.655422, 0.761295>
    }
    triangle {
      < 3.572496, -5.890628, 0.808892>,
      < 3.609701, -5.892986, 0.836394>,
      < 3.605893, -5.908008, 0.839344>
    }
    triangle {
      < 3.782173, -4.912578, 0.915967>,
      < 3.650504, -4.915636, 0.760976>,
      < 3.710069, -4.766702, 0.790986>
    }
    triangle {
      < 3.782173, -4.912578, 0.915967>,
      < 3.710069, -4.766702, 0.790986>,
      < 3.756013, -4.691369, 0.949057>
    }
    triangle {
      < 3.710069, -4.766702, 0.790986>,
      < 3.650504, -4.915636, 0.760976>,
      < 3.806412, -4.871074, 0.669699>
    }
    triangle {
      < 3.710069, -4.766702, 0.790986>,
      < 3.806412, -4.871074, 0.669699>,
      < 3.803743, -4.753818, 0.693033>
    }
    triangle {
      < 3.650504, -4.915636, 0.760976>,
      < 3.603045, -5.366023, 0.721294>,
      < 3.736344, -5.360968, 0.650572>
    }
    triangle {
      < 3.650504, -4.915636, 0.760976>,
      < 3.736344, -5.360968, 0.650572>,
      < 3.806412, -4.871074, 0.669699>
    }
    triangle {
      < 3.736344, -5.360968, 0.650572>,
      < 3.603045, -5.366023, 0.721294>,
      < 3.333775, -5.706460, 0.656384>
    }
    triangle {
      < 3.736344, -5.360968, 0.650572>,
      < 3.333775, -5.706460, 0.656384>,
      < 3.420764, -5.762608, 0.600205>
    }
    triangle {
      < 3.420764, -5.762608, 0.600205>,
      < 3.333775, -5.706460, 0.656384>,
      < 3.196081, -5.881806, 0.617120>
    }
    triangle {
      < 3.420764, -5.762608, 0.600205>,
      < 3.196081, -5.881806, 0.617120>,
      < 3.215331, -5.910106, 0.568917>
    }
    triangle {
      < 3.420764, -5.762608, 0.600205>,
      < 3.215331, -5.910106, 0.568917>,
      < 3.253033, -5.914477, 0.560052>
    }
    triangle {
      < 3.140649, -6.052967, 0.521939>,
      < 3.132799, -6.015729, 0.561931>,
      < 3.098142, -5.994081, 0.570921>
    }
    triangle {
      < 3.140649, -6.052967, 0.521939>,
      < 3.098142, -5.994081, 0.570921>,
      < 3.074996, -6.055424, 0.520714>
    }
    triangle {
      < 3.086810, -6.058038, 0.437816>,
      < 3.108755, -5.980817, 0.380630>,
      < 3.149762, -6.017935, 0.402476>
    }
    triangle {
      < 3.086810, -6.058038, 0.437816>,
      < 3.149762, -6.017935, 0.402476>,
      < 3.149153, -6.054235, 0.444800>
    }
    triangle {
      < 3.453096, -5.787074, 0.509127>,
      < 3.787827, -5.377024, 0.557766>,
      < 3.736344, -5.360968, 0.650572>
    }
    triangle {
      < 3.453096, -5.787074, 0.509127>,
      < 3.736344, -5.360968, 0.650572>,
      < 3.420764, -5.762608, 0.600205>
    }
    triangle {
      < 3.806412, -4.871074, 0.669699>,
      < 3.736344, -5.360968, 0.650572>,
      < 3.787827, -5.377024, 0.557766>
    }
    triangle {
      < 3.806412, -4.871074, 0.669699>,
      < 3.787827, -5.377024, 0.557766>,
      < 3.871635, -4.874913, 0.579817>
    }
    triangle {
      < 3.871635, -4.874913, 0.579817>,
      < 3.872860, -4.762247, 0.594336>,
      < 3.803743, -4.753818, 0.693033>
    }
    triangle {
      < 3.871635, -4.874913, 0.579817>,
      < 3.803743, -4.753818, 0.693033>,
      < 3.806412, -4.871074, 0.669699>
    }
    triangle {
      < 3.453096, -5.787074, 0.509127>,
      < 3.420764, -5.762608, 0.600205>,
      < 3.253033, -5.914477, 0.560052>
    }
    triangle {
      < 3.453096, -5.787074, 0.509127>,
      < 3.253033, -5.914477, 0.560052>,
      < 3.310092, -5.947457, 0.499410>
    }
    triangle {
      < 3.978867, -4.556856, 0.590013>,
      < 3.848762, -4.753190, 0.476878>,
      < 3.819031, -4.756149, 0.303078>
    }
    triangle {
      < 3.819031, -4.756149, 0.303078>,
      < 3.879323, -4.471182, 0.367653>,
      < 3.978867, -4.556856, 0.590013>
    }
    triangle {
      < 3.819031, -4.756149, 0.303078>,
      < 3.935352, -4.474578, 0.199895>,
      < 3.879323, -4.471182, 0.367653>
    }
    triangle {
      < 3.935352, -4.474578, 0.199895>,
      < 3.820560, -4.589967, 0.087331>,
      < 3.749773, -4.510483, -0.012252>
    }
    triangle {
      < 3.858342, -4.321498, 0.208042>,
      < 3.873947, -4.364538, 0.447579>,
      < 3.935352, -4.474578, 0.199895>
    }
    triangle {
      < 3.873947, -4.364538, 0.447579>,
      < 3.879323, -4.471182, 0.367653>,
      < 3.935352, -4.474578, 0.199895>
    }
    triangle {
      < 3.873947, -4.364538, 0.447579>,
      < 3.870004, -4.337597, 0.578456>,
      < 3.978867, -4.556856, 0.590013>
    }
    triangle {
      < 3.858342, -4.321498, 0.208042>,
      < 3.935352, -4.474578, 0.199895>,
      < 3.819674, -4.385047, 0.030987>
    }
    triangle {
      < 3.858342, -4.321498, 0.208042>,
      < 3.819674, -4.385047, 0.030987>,
      < 3.822417, -4.339959, 0.033673>
    }
    triangle {
      < 3.819674, -4.385047, 0.030987>,
      < 3.855826, -4.343190, -0.131656>,
      < 3.822417, -4.339959, 0.033673>
    }
    triangle {
      < 3.819674, -4.385047, 0.030987>,
      < 3.749773, -4.510483, -0.012252>,
      < 3.855826, -4.343190, -0.131656>
    }
    triangle {
      < 3.873947, -4.364538, 0.447579>,
      < 3.978867, -4.556856, 0.590013>,
      < 3.879323, -4.471182, 0.367653>
    }
    triangle {
      < 3.935352, -4.474578, 0.199895>,
      < 3.749773, -4.510483, -0.012252>,
      < 3.819674, -4.385047, 0.030987>
    }
    triangle {
      < 3.650504, -4.915636, 0.760976>,
      < 3.498511, -4.881388, 0.657414>,
      < 3.446331, -5.286727, 0.646611>
    }
    triangle {
      < 3.650504, -4.915636, 0.760976>,
      < 3.446331, -5.286727, 0.646611>,
      < 3.603045, -5.366023, 0.721294>
    }
    triangle {
      < 3.260044, -5.662074, 0.586409>,
      < 3.333775, -5.706460, 0.656384>,
      < 3.603045, -5.366023, 0.721294>
    }
    triangle {
      < 3.260044, -5.662074, 0.586409>,
      < 3.603045, -5.366023, 0.721294>,
      < 3.446331, -5.286727, 0.646611>
    }
    triangle {
      < 3.033125, -5.970796, 0.526716>,
      < 3.139689, -5.825614, 0.561847>,
      < 3.142598, -5.814617, 0.395572>
    }
    triangle {
      < 3.033125, -5.970796, 0.526716>,
      < 3.142598, -5.814617, 0.395572>,
      < 3.058576, -5.974609, 0.422769>
    }
    triangle {
      < 3.139689, -5.825614, 0.561847>,
      < 3.260044, -5.662074, 0.586409>,
      < 3.280637, -5.636574, 0.412913>
    }
    triangle {
      < 3.139689, -5.825614, 0.561847>,
      < 3.280637, -5.636574, 0.412913>,
      < 3.142598, -5.814617, 0.395572>
    }
    triangle {
      < 3.280637, -5.636574, 0.412913>,
      < 3.260044, -5.662074, 0.586409>,
      < 3.446331, -5.286727, 0.646611>
    }
    triangle {
      < 3.280637, -5.636574, 0.412913>,
      < 3.446331, -5.286727, 0.646611>,
      < 3.475449, -5.305753, 0.445597>
    }
    triangle {
      < 3.498511, -4.881388, 0.657414>,
      < 3.519503, -4.890442, 0.426109>,
      < 3.475449, -5.305753, 0.445597>
    }
    triangle {
      < 3.498511, -4.881388, 0.657414>,
      < 3.475449, -5.305753, 0.445597>,
      < 3.446331, -5.286727, 0.646611>
    }
    triangle {
      < 3.333775, -5.706460, 0.656384>,
      < 3.260044, -5.662074, 0.586409>,
      < 3.139689, -5.825614, 0.561847>
    }
    triangle {
      < 3.333775, -5.706460, 0.656384>,
      < 3.139689, -5.825614, 0.561847>,
      < 3.196081, -5.881806, 0.617120>
    }
    triangle {
      < 3.196081, -5.881806, 0.617120>,
      < 3.098142, -5.994081, 0.570921>,
      < 3.132799, -6.015729, 0.561931>
    }
    triangle {
      < 3.196081, -5.881806, 0.617120>,
      < 3.132799, -6.015729, 0.561931>,
      < 3.215331, -5.910106, 0.568917>
    }
    triangle {
      < 3.074996, -6.055424, 0.520714>,
      < 3.033125, -5.970796, 0.526716>,
      < 3.081568, -6.072448, 0.477527>
    }
    triangle {
      < 3.033125, -5.970796, 0.526716>,
      < 3.058576, -5.974609, 0.422769>,
      < 3.081568, -6.072448, 0.477527>
    }
    triangle {
      < 3.058576, -5.974609, 0.422769>,
      < 3.086810, -6.058038, 0.437816>,
      < 3.081568, -6.072448, 0.477527>
    }
    triangle {
      < 3.033125, -5.970796, 0.526716>,
      < 3.098142, -5.994081, 0.570921>,
      < 3.196081, -5.881806, 0.617120>
    }
    triangle {
      < 3.033125, -5.970796, 0.526716>,
      < 3.196081, -5.881806, 0.617120>,
      < 3.139689, -5.825614, 0.561847>
    }
    triangle {
      < 3.427807, -5.874164, 0.987612>,
      < 3.459127, -5.660091, 1.004743>,
      < 3.481752, -5.641568, 0.833520>
    }
    triangle {
      < 3.427807, -5.874164, 0.987612>,
      < 3.481752, -5.641568, 0.833520>,
      < 3.459411, -5.707362, 0.829529>
    }
    triangle {
      < 3.427807, -5.874164, 0.987612>,
      < 3.459411, -5.707362, 0.829529>,
      < 3.414722, -5.838942, 0.821544>
    }
    triangle {
      < 3.481752, -5.641568, 0.833520>,
      < 3.459127, -5.660091, 1.004743>,
      < 3.486985, -5.292625, 1.048481>
    }
    triangle {
      < 3.481752, -5.641568, 0.833520>,
      < 3.486985, -5.292625, 1.048481>,
      < 3.543149, -5.294589, 0.850091>
    }
    triangle {
      < 3.481752, -5.641568, 0.833520>,
      < 3.543149, -5.294589, 0.850091>,
      < 3.531061, -5.368310, 0.853324>
    }
    triangle {
      < 3.481752, -5.641568, 0.833520>,
      < 3.531061, -5.368310, 0.853324>,
      < 3.495727, -5.568245, 0.844104>
    }
    triangle {
      < 3.369840, -4.918569, 1.022564>,
      < 3.525503, -4.858645, 0.856764>,
      < 3.522806, -5.152845, 0.852173>
    }
    triangle {
      < 3.369840, -4.918569, 1.022564>,
      < 3.522806, -5.152845, 0.852173>,
      < 3.543149, -5.294589, 0.850091>
    }
    triangle {
      < 3.369840, -4.918569, 1.022564>,
      < 3.543149, -5.294589, 0.850091>,
      < 3.486985, -5.292625, 1.048481>
    }
    triangle {
      < 3.427807, -5.874164, 0.987612>,
      < 3.414722, -5.838942, 0.821544>,
      < 3.416675, -6.008670, 0.825785>
    }
    triangle {
      < 3.427807, -5.874164, 0.987612>,
      < 3.416675, -6.008670, 0.825785>,
      < 3.413736, -6.028965, 0.915567>
    }
    triangle {
      < 3.492407, -5.893525, 1.037085>,
      < 3.427807, -5.874164, 0.987612>,
      < 3.413736, -6.028965, 0.915567>
    }
    triangle {
      < 3.492407, -5.893525, 1.037085>,
      < 3.413736, -6.028965, 0.915567>,
      < 3.473088, -6.035122, 0.967001>
    }
    triangle {
      < 3.413736, -6.028965, 0.915567>,
      < 3.416675, -6.008670, 0.825785>,
      < 3.482244, -6.080278, 0.862983>
    }
    triangle {
      < 3.416675, -6.008670, 0.825785>,
      < 3.477974, -6.002246, 0.777414>,
      < 3.479325, -6.050067, 0.813931>
    }
    triangle {
      < 3.416675, -6.008670, 0.825785>,
      < 3.479325, -6.050067, 0.813931>,
      < 3.482244, -6.080278, 0.862983>
    }
    triangle {
      < 3.477974, -6.002246, 0.777414>,
      < 3.416675, -6.008670, 0.825785>,
      < 3.414722, -5.838942, 0.821544>
    }
    triangle {
      < 3.477974, -6.002246, 0.777414>,
      < 3.414722, -5.838942, 0.821544>,
      < 3.505699, -5.855872, 0.747989>
    }
    triangle {
      < 3.459411, -5.707362, 0.829529>,
      < 3.481752, -5.641568, 0.833520>,
      < 3.553799, -5.655422, 0.761295>
    }
    triangle {
      < 3.459411, -5.707362, 0.829529>,
      < 3.553799, -5.655422, 0.761295>,
      < 3.505699, -5.855872, 0.747989>
    }
    triangle {
      < 3.459411, -5.707362, 0.829529>,
      < 3.505699, -5.855872, 0.747989>,
      < 3.414722, -5.838942, 0.821544>
    }
    triangle {
      < 3.553799, -5.655422, 0.761295>,
      < 3.481752, -5.641568, 0.833520>,
      < 3.495727, -5.568245, 0.844104>
    }
    triangle {
      < 3.553799, -5.655422, 0.761295>,
      < 3.495727, -5.568245, 0.844104>,
      < 3.531061, -5.368310, 0.853324>
    }
    triangle {
      < 3.553799, -5.655422, 0.761295>,
      < 3.531061, -5.368310, 0.853324>,
      < 3.543149, -5.294589, 0.850091>
    }
    triangle {
      < 3.553799, -5.655422, 0.761295>,
      < 3.543149, -5.294589, 0.850091>,
      < 3.649614, -5.325970, 0.777320>
    }
    triangle {
      < 3.525503, -4.858645, 0.856764>,
      < 3.376643, -4.703335, 0.631060>,
      < 3.498511, -4.881388, 0.657414>
    }
    triangle {
      < 3.376643, -4.703335, 0.631060>,
      < 3.525503, -4.858645, 0.856764>,
      < 3.369840, -4.918569, 1.022564>
    }
    triangle {
      < 3.376643, -4.703335, 0.631060>,
      < 3.369840, -4.918569, 1.022564>,
      < 3.324410, -4.776068, 1.013156>
    }
    triangle {
      < 3.840905, -4.872707, 0.474656>,
      < 3.749318, -5.362044, 0.458830>,
      < 3.641114, -5.319808, 0.383361>
    }
    triangle {
      < 3.840905, -4.872707, 0.474656>,
      < 3.641114, -5.319808, 0.383361>,
      < 3.680832, -4.871781, 0.372331>
    }
    triangle {
      < 3.641114, -5.319808, 0.383361>,
      < 3.749318, -5.362044, 0.458830>,
      < 3.410457, -5.758007, 0.415555>
    }
    triangle {
      < 3.641114, -5.319808, 0.383361>,
      < 3.410457, -5.758007, 0.415555>,
      < 3.340641, -5.701254, 0.360480>
    }
    triangle {
      < 3.340641, -5.701254, 0.360480>,
      < 3.410457, -5.758007, 0.415555>,
      < 3.263365, -5.932832, 0.427533>
    }
    triangle {
      < 3.340641, -5.701254, 0.360480>,
      < 3.263365, -5.932832, 0.427533>,
      < 3.230269, -5.937195, 0.415929>
    }
    triangle {
      < 3.340641, -5.701254, 0.360480>,
      < 3.230269, -5.937195, 0.415929>,
      < 3.215080, -5.887108, 0.365910>
    }
    triangle {
      < 3.340641, -5.701254, 0.360480>,
      < 3.215080, -5.887108, 0.365910>,
      < 3.298786, -5.763205, 0.362287>
    }
    triangle {
      < 3.840905, -4.872707, 0.474656>,
      < 3.680832, -4.871781, 0.372331>,
      < 3.819031, -4.756149, 0.303078>
    }
    triangle {
      < 3.840905, -4.872707, 0.474656>,
      < 3.819031, -4.756149, 0.303078>,
      < 3.848762, -4.753190, 0.476878>
    }
    triangle {
      < 3.498511, -4.881388, 0.657414>,
      < 3.650504, -4.915636, 0.760976>,
      < 3.525503, -4.858645, 0.856764>
    }
    triangle {
      < 3.068909, -5.644910, 0.031059>,
      < 3.142778, -5.673025, -0.013236>,
      < 3.039448, -5.784328, 0.022500>
    }
    triangle {
      < 3.068909, -5.644910, 0.031059>,
      < 3.039448, -5.784328, 0.022500>,
      < 2.970495, -5.783869, 0.066662>
    }
    triangle {
      < 3.142598, -5.814617, 0.395572>,
      < 3.215080, -5.887108, 0.365910>,
      < 3.108755, -5.980817, 0.380630>
    }
    triangle {
      < 3.142598, -5.814617, 0.395572>,
      < 3.108755, -5.980817, 0.380630>,
      < 3.058576, -5.974609, 0.422769>
    }
    triangle {
      < 3.142598, -5.814617, 0.395572>,
      < 3.280637, -5.636574, 0.412913>,
      < 3.340641, -5.701254, 0.360480>
    }
    triangle {
      < 3.142598, -5.814617, 0.395572>,
      < 3.340641, -5.701254, 0.360480>,
      < 3.298786, -5.763205, 0.362287>
    }
    triangle {
      < 3.142598, -5.814617, 0.395572>,
      < 3.298786, -5.763205, 0.362287>,
      < 3.215080, -5.887108, 0.365910>
    }
    triangle {
      < 3.340641, -5.701254, 0.360480>,
      < 3.280637, -5.636574, 0.412913>,
      < 3.475449, -5.305753, 0.445597>
    }
    triangle {
      < 3.340641, -5.701254, 0.360480>,
      < 3.475449, -5.305753, 0.445597>,
      < 3.641114, -5.319808, 0.383361>
    }
    triangle {
      < 3.519503, -4.890442, 0.426109>,
      < 3.680832, -4.871781, 0.372331>,
      < 3.641114, -5.319808, 0.383361>
    }
    triangle {
      < 3.519503, -4.890442, 0.426109>,
      < 3.641114, -5.319808, 0.383361>,
      < 3.475449, -5.305753, 0.445597>
    }
    triangle {
      < 3.149762, -6.017935, 0.402476>,
      < 3.108755, -5.980817, 0.380630>,
      < 3.215080, -5.887108, 0.365910>
    }
    triangle {
      < 3.149762, -6.017935, 0.402476>,
      < 3.215080, -5.887108, 0.365910>,
      < 3.230269, -5.937195, 0.415929>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.639382, -4.865031, 0.294500>,
      < 3.780772, -4.825399, 0.276605>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.780772, -4.825399, 0.276605>,
      < 3.819031, -4.756149, 0.303078>
    }
    triangle {
      < 3.639382, -4.865031, 0.294500>,
      < 3.548440, -5.201604, 0.264880>,
      < 3.657932, -5.225744, 0.214498>
    }
    triangle {
      < 3.639382, -4.865031, 0.294500>,
      < 3.657932, -5.225744, 0.214498>,
      < 3.780772, -4.825399, 0.276605>
    }
    triangle {
      < 3.657932, -5.225744, 0.214498>,
      < 3.548440, -5.201604, 0.264880>,
      < 3.261086, -5.535859, 0.221632>
    }
    triangle {
      < 3.657932, -5.225744, 0.214498>,
      < 3.261086, -5.535859, 0.221632>,
      < 3.325341, -5.552524, 0.188479>
    }
    triangle {
      < 3.155939, -5.701127, 0.156862>,
      < 3.325341, -5.552524, 0.188479>,
      < 3.261086, -5.535859, 0.221632>
    }
    triangle {
      < 3.155939, -5.701127, 0.156862>,
      < 3.261086, -5.535859, 0.221632>,
      < 3.120829, -5.685888, 0.204650>
    }
    triangle {
      < 3.155939, -5.701127, 0.156862>,
      < 3.120829, -5.685888, 0.204650>,
      < 3.141093, -5.708465, 0.163081>
    }
    triangle {
      < 3.049008, -5.820407, 0.137574>,
      < 3.049350, -5.791834, 0.168228>,
      < 3.012648, -5.771694, 0.178818>
    }
    triangle {
      < 3.049008, -5.820407, 0.137574>,
      < 3.012648, -5.771694, 0.178818>,
      < 2.993125, -5.820805, 0.134664>
    }
    triangle {
      < 3.170379, -5.716518, 0.044165>,
      < 3.074443, -5.803917, 0.041438>,
      < 3.039448, -5.784328, 0.022500>
    }
    triangle {
      < 3.170379, -5.716518, 0.044165>,
      < 3.039448, -5.784328, 0.022500>,
      < 3.142778, -5.673025, -0.013236>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.403350, -4.639856, 0.372886>,
      < 3.364325, -4.533445, 0.058658>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.364325, -4.533445, 0.058658>,
      < 3.497663, -4.709856, 0.057938>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.497663, -4.709856, 0.057938>,
      < 3.485918, -4.811015, 0.098699>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.485918, -4.811015, 0.098699>,
      < 3.453093, -5.032336, 0.065934>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.453093, -5.032336, 0.065934>,
      < 3.436683, -5.143003, 0.049550>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.436683, -5.143003, 0.049550>,
      < 3.438591, -5.169542, 0.211200>
    }
    triangle {
      < 2.980297, -5.779233, 0.151208>,
      < 2.993125, -5.820805, 0.134664>,
      < 3.012648, -5.771694, 0.178818>
    }
    triangle {
      < 2.970495, -5.783869, 0.066662>,
      < 3.017643, -5.834864, 0.063272>,
      < 3.004417, -5.843048, 0.100626>
    }
    triangle {
      < 3.485918, -4.811015, 0.098699>,
      < 3.497663, -4.709856, 0.057938>,
      < 3.687103, -4.663103, 0.023185>
    }
    triangle {
      < 3.485918, -4.811015, 0.098699>,
      < 3.687103, -4.663103, 0.023185>,
      < 3.551537, -5.148163, -0.029729>
    }
    triangle {
      < 3.485918, -4.811015, 0.098699>,
      < 3.551537, -5.148163, -0.029729>,
      < 3.436683, -5.143003, 0.049550>
    }
    triangle {
      < 3.485918, -4.811015, 0.098699>,
      < 3.436683, -5.143003, 0.049550>,
      < 3.453093, -5.032336, 0.065934>
    }
    triangle {
      < 3.551537, -5.148163, -0.029729>,
      < 3.293422, -5.510409, -0.017459>,
      < 3.193631, -5.464435, 0.034744>
    }
    triangle {
      < 3.551537, -5.148163, -0.029729>,
      < 3.193631, -5.464435, 0.034744>,
      < 3.436683, -5.143003, 0.049550>
    }
    triangle {
      < 3.193631, -5.464435, 0.034744>,
      < 3.293422, -5.510409, -0.017459>,
      < 3.243208, -5.564615, -0.016052>
    }
    triangle {
      < 3.193631, -5.464435, 0.034744>,
      < 3.243208, -5.564615, -0.016052>,
      < 3.142778, -5.673025, -0.013236>
    }
    triangle {
      < 3.193631, -5.464435, 0.034744>,
      < 3.142778, -5.673025, -0.013236>,
      < 3.068909, -5.644910, 0.031059>
    }
    triangle {
      < 3.193631, -5.464435, 0.034744>,
      < 3.196105, -5.510826, 0.175614>,
      < 3.438591, -5.169542, 0.211200>
    }
    triangle {
      < 3.193631, -5.464435, 0.034744>,
      < 3.438591, -5.169542, 0.211200>,
      < 3.436683, -5.143003, 0.049550>
    }
    triangle {
      < 3.068909, -5.644910, 0.031059>,
      < 3.063355, -5.657243, 0.162309>,
      < 3.196105, -5.510826, 0.175614>
    }
    triangle {
      < 3.068909, -5.644910, 0.031059>,
      < 3.196105, -5.510826, 0.175614>,
      < 3.193631, -5.464435, 0.034744>
    }
    triangle {
      < 3.063355, -5.657243, 0.162309>,
      < 3.068909, -5.644910, 0.031059>,
      < 2.970495, -5.783869, 0.066662>
    }
    triangle {
      < 3.063355, -5.657243, 0.162309>,
      < 2.970495, -5.783869, 0.066662>,
      < 2.980297, -5.779233, 0.151208>
    }
    triangle {
      < 3.141093, -5.708465, 0.163081>,
      < 3.120829, -5.685888, 0.204650>,
      < 3.012648, -5.771694, 0.178818>
    }
    triangle {
      < 3.141093, -5.708465, 0.163081>,
      < 3.012648, -5.771694, 0.178818>,
      < 3.049350, -5.791834, 0.168228>
    }
    triangle {
      < 3.216337, -5.726731, 0.118775>,
      < 3.388301, -5.580028, 0.124869>,
      < 3.325341, -5.552524, 0.188479>
    }
    triangle {
      < 3.216337, -5.726731, 0.118775>,
      < 3.325341, -5.552524, 0.188479>,
      < 3.155939, -5.701127, 0.156862>
    }
    triangle {
      < 3.388301, -5.580028, 0.124869>,
      < 3.711217, -5.239375, 0.133680>,
      < 3.657932, -5.225744, 0.214498>
    }
    triangle {
      < 3.388301, -5.580028, 0.124869>,
      < 3.657932, -5.225744, 0.214498>,
      < 3.325341, -5.552524, 0.188479>
    }
    triangle {
      < 3.780772, -4.825399, 0.276605>,
      < 3.657932, -5.225744, 0.214498>,
      < 3.711217, -5.239375, 0.133680>
    }
    triangle {
      < 3.780772, -4.825399, 0.276605>,
      < 3.711217, -5.239375, 0.133680>,
      < 3.833309, -4.794936, 0.174423>
    }
    triangle {
      < 3.833309, -4.794936, 0.174423>,
      < 3.866155, -4.683072, 0.186399>,
      < 3.819031, -4.756149, 0.303078>
    }
    triangle {
      < 3.833309, -4.794936, 0.174423>,
      < 3.819031, -4.756149, 0.303078>,
      < 3.780772, -4.825399, 0.276605>
    }
    triangle {
      < 3.243208, -5.564615, -0.016052>,
      < 3.293422, -5.510409, -0.017459>,
      < 3.380490, -5.552703, 0.040199>
    }
    triangle {
      < 3.243208, -5.564615, -0.016052>,
      < 3.380490, -5.552703, 0.040199>,
      < 3.196241, -5.713139, 0.055022>
    }
    triangle {
      < 3.243208, -5.564615, -0.016052>,
      < 3.196241, -5.713139, 0.055022>,
      < 3.170379, -5.716518, 0.044165>
    }
    triangle {
      < 3.243208, -5.564615, -0.016052>,
      < 3.170379, -5.716518, 0.044165>,
      < 3.142778, -5.673025, -0.013236>
    }
    triangle {
      < 3.551537, -5.148163, -0.029729>,
      < 3.677980, -5.215698, 0.044134>,
      < 3.380490, -5.552703, 0.040199>
    }
    triangle {
      < 3.551537, -5.148163, -0.029729>,
      < 3.380490, -5.552703, 0.040199>,
      < 3.293422, -5.510409, -0.017459>
    }
    triangle {
      < 3.677980, -5.215698, 0.044134>,
      < 3.551537, -5.148163, -0.029729>,
      < 3.687103, -4.663103, 0.023185>
    }
    triangle {
      < 3.677980, -5.215698, 0.044134>,
      < 3.687103, -4.663103, 0.023185>,
      < 3.791321, -4.745622, 0.078156>
    }
    triangle {
      < 3.791321, -4.745622, 0.078156>,
      < 3.687103, -4.663103, 0.023185>,
      < 3.749773, -4.510483, -0.012252>
    }
    triangle {
      < 3.791321, -4.745622, 0.078156>,
      < 3.749773, -4.510483, -0.012252>,
      < 3.820560, -4.589967, 0.087331>
    }
    triangle {
      < 3.197434, -4.219485, 0.539804>,
      < 2.990301, -3.784639, 0.396786>,
      < 3.068497, -3.694562, 0.097358>
    }
    triangle {
      < 3.197434, -4.219485, 0.539804>,
      < 3.068497, -3.694562, 0.097358>,
      < 3.271461, -4.097725, 0.273542>
    }
    triangle {
      < 3.271461, -4.097725, 0.273542>,
      < 3.068497, -3.694562, 0.097358>,
      < 3.135177, -3.696051, -0.089524>
    }
    triangle {
      < 3.271461, -4.097725, 0.273542>,
      < 3.135177, -3.696051, -0.089524>,
      < 3.243130, -4.046298, -0.017936>
    }
    triangle {
      < 3.354759, -4.407702, 0.529355>,
      < 3.271461, -4.097725, 0.273542>,
      < 3.243130, -4.046298, -0.017936>
    }
    triangle {
      < 3.354759, -4.407702, 0.529355>,
      < 3.243130, -4.046298, -0.017936>,
      < 3.358401, -4.331690, 0.072509>
    }
    triangle {
      < 3.354759, -4.407702, 0.529355>,
      < 3.358401, -4.331690, 0.072509>,
      < 3.400201, -4.446900, 0.368092>
    }
    triangle {
      < 3.400201, -4.446900, 0.368092>,
      < 3.358401, -4.331690, 0.072509>,
      < 3.364325, -4.533445, 0.058658>
    }
    triangle {
      < 3.400201, -4.446900, 0.368092>,
      < 3.364325, -4.533445, 0.058658>,
      < 3.403350, -4.639856, 0.372886>
    }
    triangle {
      < 3.400201, -4.446900, 0.368092>,
      < 3.403350, -4.639856, 0.372886>,
      < 3.376643, -4.703335, 0.631060>
    }
    triangle {
      < 3.400201, -4.446900, 0.368092>,
      < 3.376643, -4.703335, 0.631060>,
      < 3.354759, -4.407702, 0.529355>
    }
    triangle {
      < 3.497663, -4.709856, 0.057938>,
      < 3.364325, -4.533445, 0.058658>,
      < 3.512556, -4.651647, -0.028831>
    }
    triangle {
      < 3.377950, -4.242374, -0.231630>,
      < 3.358401, -4.331690, 0.072509>,
      < 3.243130, -4.046298, -0.017936>
    }
    triangle {
      < 3.377950, -4.242374, -0.231630>,
      < 3.243130, -4.046298, -0.017936>,
      < 3.314325, -4.027246, -0.205350>
    }
    triangle {
      < 3.358401, -4.331690, 0.072509>,
      < 3.377950, -4.242374, -0.231630>,
      < 3.412204, -4.449575, -0.235962>
    }
    triangle {
      < 3.358401, -4.331690, 0.072509>,
      < 3.412204, -4.449575, -0.235962>,
      < 3.364325, -4.533445, 0.058658>
    }
    triangle {
      < 3.271461, -4.097725, 0.273542>,
      < 3.354759, -4.407702, 0.529355>,
      < 3.271274, -4.553491, 0.845122>
    }
    triangle {
      < 3.271461, -4.097725, 0.273542>,
      < 3.271274, -4.553491, 0.845122>,
      < 3.197434, -4.219485, 0.539804>
    }
    triangle {
      < 3.235652, -4.565553, 1.006618>,
      < 3.271274, -4.553491, 0.845122>,
      < 3.324410, -4.776068, 1.013156>
    }
    triangle {
      < 3.073454, -4.431412, 0.941757>,
      < 3.197434, -4.219485, 0.539804>,
      < 3.271274, -4.553491, 0.845122>
    }
    triangle {
      < 3.073454, -4.431412, 0.941757>,
      < 3.271274, -4.553491, 0.845122>,
      < 3.235652, -4.565553, 1.006618>
    }
    triangle {
      < 3.456233, -4.759103, 0.296852>,
      < 3.680832, -4.871781, 0.372331>,
      < 3.519503, -4.890442, 0.426109>
    }
    triangle {
      < 3.403350, -4.639856, 0.372886>,
      < 3.519503, -4.890442, 0.426109>,
      < 3.498511, -4.881388, 0.657414>
    }
    triangle {
      < 3.403350, -4.639856, 0.372886>,
      < 3.498511, -4.881388, 0.657414>,
      < 3.376643, -4.703335, 0.631060>
    }
    triangle {
      < 3.461182, -4.657507, -0.083460>,
      < 3.461453, -4.561948, -0.246288>,
      < 3.446507, -4.873538, -0.272530>
    }
    triangle {
      < 3.461182, -4.657507, -0.083460>,
      < 3.446507, -4.873538, -0.272530>,
      < 3.456882, -4.897809, -0.101509>
    }
    triangle {
      < 3.456882, -4.897809, -0.101509>,
      < 3.446507, -4.873538, -0.272530>,
      < 3.313482, -5.125708, -0.277979>
    }
    triangle {
      < 3.456882, -4.897809, -0.101509>,
      < 3.313482, -5.125708, -0.277979>,
      < 3.346880, -5.130281, -0.120578>
    }
    triangle {
      < 3.164551, -5.300739, -0.279181>,
      < 3.177206, -5.312306, -0.124534>,
      < 3.346880, -5.130281, -0.120578>
    }
    triangle {
      < 3.164551, -5.300739, -0.279181>,
      < 3.346880, -5.130281, -0.120578>,
      < 3.313482, -5.125708, -0.277979>
    }
    triangle {
      < 3.177206, -5.312306, -0.124534>,
      < 3.164551, -5.300739, -0.279181>,
      < 3.091261, -5.417274, -0.244750>
    }
    triangle {
      < 3.177206, -5.312306, -0.124534>,
      < 3.091261, -5.417274, -0.244750>,
      < 3.111749, -5.413926, -0.159047>
    }
    triangle {
      < 3.461453, -4.561948, -0.246288>,
      < 3.557271, -4.575253, -0.314636>,
      < 3.541634, -4.902719, -0.361870>
    }
    triangle {
      < 3.461453, -4.561948, -0.246288>,
      < 3.541634, -4.902719, -0.361870>,
      < 3.446507, -4.873538, -0.272530>
    }
    triangle {
      < 3.446507, -4.873538, -0.272530>,
      < 3.541634, -4.902719, -0.361870>,
      < 3.389684, -5.170204, -0.347680>
    }
    triangle {
      < 3.446507, -4.873538, -0.272530>,
      < 3.389684, -5.170204, -0.347680>,
      < 3.313482, -5.125708, -0.277979>
    }
    triangle {
      < 3.218018, -5.361663, -0.309225>,
      < 3.164551, -5.300739, -0.279181>,
      < 3.313482, -5.125708, -0.277979>
    }
    triangle {
      < 3.218018, -5.361663, -0.309225>,
      < 3.313482, -5.125708, -0.277979>,
      < 3.389684, -5.170204, -0.347680>
    }
    triangle {
      < 3.164551, -5.300739, -0.279181>,
      < 3.218018, -5.361663, -0.309225>,
      < 3.140325, -5.456113, -0.279372>
    }
    triangle {
      < 3.164551, -5.300739, -0.279181>,
      < 3.140325, -5.456113, -0.279372>,
      < 3.091261, -5.417274, -0.244750>
    }
    triangle {
      < 3.111749, -5.413926, -0.159047>,
      < 3.091261, -5.417274, -0.244750>,
      < 3.103222, -5.487276, -0.207282>
    }
    triangle {
      < 3.091261, -5.417274, -0.244750>,
      < 3.140325, -5.456113, -0.279372>,
      < 3.108019, -5.480084, -0.249201>
    }
    triangle {
      < 3.137978, -5.462011, -0.134840>,
      < 3.189222, -5.387946, -0.109955>,
      < 3.177206, -5.312306, -0.124534>
    }
    triangle {
      < 3.137978, -5.462011, -0.134840>,
      < 3.177206, -5.312306, -0.124534>,
      < 3.111749, -5.413926, -0.159047>
    }
    triangle {
      < 3.189222, -5.387946, -0.109955>,
      < 3.137978, -5.462011, -0.134840>,
      < 3.165883, -5.481662, -0.152199>
    }
    triangle {
      < 3.189222, -5.387946, -0.109955>,
      < 3.165883, -5.481662, -0.152199>,
      < 3.222092, -5.389814, -0.142920>
    }
    triangle {
      < 3.544179, -4.939861, -0.066314>,
      < 3.375304, -5.186841, -0.084050>,
      < 3.427206, -5.250150, -0.136576>
    }
    triangle {
      < 3.544179, -4.939861, -0.066314>,
      < 3.427206, -5.250150, -0.136576>,
      < 3.623229, -4.962186, -0.131394>
    }
    triangle {
      < 3.544179, -4.939861, -0.066314>,
      < 3.623229, -4.962186, -0.131394>,
      < 3.707675, -4.638666, -0.073645>
    }
    triangle {
      < 3.544179, -4.939861, -0.066314>,
      < 3.707675, -4.638666, -0.073645>,
      < 3.512556, -4.651647, -0.028831>
    }
    triangle {
      < 3.293084, -5.396710, -0.214851>,
      < 3.281411, -5.411036, -0.210920>,
      < 3.233992, -5.380470, -0.256286>
    }
    triangle {
      < 3.293084, -5.396710, -0.214851>,
      < 3.233992, -5.380470, -0.256286>,
      < 3.242743, -5.367341, -0.267206>
    }
    triangle {
      < 3.404628, -5.236587, -0.286603>,
      < 3.604485, -4.949396, -0.307969>,
      < 3.671307, -4.971681, -0.225062>
    }
    triangle {
      < 3.404628, -5.236587, -0.286603>,
      < 3.671307, -4.971681, -0.225062>,
      < 3.452394, -5.270232, -0.219996>
    }
    triangle {
      < 3.671307, -4.971681, -0.225062>,
      < 3.604485, -4.949396, -0.307969>,
      < 3.663128, -4.621632, -0.262480>
    }
    triangle {
      < 3.671307, -4.971681, -0.225062>,
      < 3.663128, -4.621632, -0.262480>,
      < 3.732185, -4.634325, -0.180645>
    }
    triangle {
      < 3.732185, -4.634325, -0.180645>,
      < 3.663128, -4.621632, -0.262480>,
      < 3.671955, -4.474066, -0.276357>
    }
    triangle {
      < 3.732185, -4.634325, -0.180645>,
      < 3.671955, -4.474066, -0.276357>,
      < 3.755457, -4.503113, -0.158990>
    }
    triangle {
      < 3.755457, -4.503113, -0.158990>,
      < 3.671955, -4.474066, -0.276357>,
      < 3.855826, -4.343190, -0.131656>
    }
    triangle {
      < 3.557271, -4.575253, -0.314636>,
      < 3.461453, -4.561948, -0.246288>,
      < 3.412204, -4.449575, -0.235962>
    }
    triangle {
      < 3.557271, -4.575253, -0.314636>,
      < 3.412204, -4.449575, -0.235962>,
      < 3.553879, -4.454062, -0.313867>
    }
    triangle {
      < 3.855826, -4.343190, -0.131656>,
      < 3.715068, -4.365313, -0.273409>,
      < 3.465101, -3.953986, -0.273622>
    }
    triangle {
      < 3.855826, -4.343190, -0.131656>,
      < 3.465101, -3.953986, -0.273622>,
      < 3.693901, -3.916591, -0.115516>
    }
    triangle {
      < 3.412204, -4.449575, -0.235962>,
      < 3.377950, -4.242374, -0.231630>,
      < 3.571329, -4.367672, -0.316899>
    }
    triangle {
      < 3.412204, -4.449575, -0.235962>,
      < 3.571329, -4.367672, -0.316899>,
      < 3.553879, -4.454062, -0.313867>
    }
    triangle {
      < 3.465101, -3.953986, -0.273622>,
      < 3.314325, -4.027246, -0.205350>,
      < 3.208692, -3.670273, -0.155483>
    }
    triangle {
      < 3.465101, -3.953986, -0.273622>,
      < 3.208692, -3.670273, -0.155483>,
      < 3.423148, -3.594702, -0.219296>
    }
    triangle {
      < 3.423148, -3.594702, -0.219296>,
      < 3.208692, -3.670273, -0.155483>,
      < 3.101251, -3.307032, -0.110100>
    }
    triangle {
      < 3.423148, -3.594702, -0.219296>,
      < 3.101251, -3.307032, -0.110100>,
      < 3.400748, -3.266075, -0.161594>
    }
    triangle {
      < 3.101251, -3.307032, -0.110100>,
      < 3.208692, -3.670273, -0.155483>,
      < 3.135177, -3.696051, -0.089524>
    }
    triangle {
      < 3.135177, -3.696051, -0.089524>,
      < 3.208692, -3.670273, -0.155483>,
      < 3.314325, -4.027246, -0.205350>
    }
    triangle {
      < 3.135177, -3.696051, -0.089524>,
      < 3.314325, -4.027246, -0.205350>,
      < 3.243130, -4.046298, -0.017936>
    }
    triangle {
      < 3.135177, -3.696051, -0.089524>,
      < 3.068497, -3.694562, 0.097358>,
      < 3.000942, -3.360298, 0.240543>
    }
    triangle {
      < 3.135177, -3.696051, -0.089524>,
      < 3.000942, -3.360298, 0.240543>,
      < 3.101251, -3.307032, -0.110100>
    }
    triangle {
      < 2.923318, -3.466007, 0.391588>,
      < 2.853162, -3.365846, 0.637326>,
      < 2.914910, -3.123339, 0.588616>
    }
    triangle {
      < 2.923318, -3.466007, 0.391588>,
      < 2.914910, -3.123339, 0.588616>,
      < 2.948871, -3.072044, 0.233427>
    }
    triangle {
      < 2.923318, -3.466007, 0.391588>,
      < 2.948871, -3.072044, 0.233427>,
      < 3.000942, -3.360298, 0.240543>
    }
    triangle {
      < 2.923318, -3.466007, 0.391588>,
      < 2.704204, -3.806584, 0.684968>,
      < 2.853162, -3.365846, 0.637326>
    }
    triangle {
      < 3.000942, -3.360298, 0.240543>,
      < 3.068497, -3.694562, 0.097358>,
      < 2.990301, -3.784639, 0.396786>
    }
    triangle {
      < 2.876625, -3.360112, 0.793590>,
      < 2.853162, -3.365846, 0.637326>,
      < 2.704204, -3.806584, 0.684968>
    }
    triangle {
      < 2.876625, -3.360112, 0.793590>,
      < 2.704204, -3.806584, 0.684968>,
      < 2.713652, -3.719675, 0.943718>
    }
    triangle {
      < 3.599305, -3.225931, -0.043476>,
      < 3.752286, -3.343208, 0.085041>,
      < 3.423148, -3.594702, -0.219296>
    }
    triangle {
      < 3.423148, -3.594702, -0.219296>,
      < 3.752286, -3.343208, 0.085041>,
      < 3.693901, -3.916591, -0.115516>
    }
    triangle {
      < 3.423148, -3.594702, -0.219296>,
      < 3.693901, -3.916591, -0.115516>,
      < 3.465101, -3.953986, -0.273622>
    }
    triangle {
      < 3.873947, -4.364538, 0.447579>,
      < 3.858342, -4.321498, 0.208042>,
      < 3.789576, -3.907470, 0.254377>
    }
    triangle {
      < 3.873947, -4.364538, 0.447579>,
      < 3.789576, -3.907470, 0.254377>,
      < 3.783816, -3.880267, 0.562139>
    }
    triangle {
      < 3.873947, -4.364538, 0.447579>,
      < 3.783816, -3.880267, 0.562139>,
      < 3.870004, -4.337597, 0.578456>
    }
    triangle {
      < 3.693901, -3.916591, -0.115516>,
      < 3.752286, -3.343208, 0.085041>,
      < 3.703852, -3.358929, 0.249468>
    }
    triangle {
      < 3.693901, -3.916591, -0.115516>,
      < 3.703852, -3.358929, 0.249468>,
      < 3.789576, -3.907470, 0.254377>
    }
    triangle {
      < 3.789576, -3.907470, 0.254377>,
      < 3.703852, -3.358929, 0.249468>,
      < 3.675314, -3.326316, 0.542915>
    }
    triangle {
      < 3.789576, -3.907470, 0.254377>,
      < 3.675314, -3.326316, 0.542915>,
      < 3.783816, -3.880267, 0.562139>
    }
    triangle {
      < 3.703852, -3.358929, 0.249468>,
      < 3.752286, -3.343208, 0.085041>,
      < 3.722475, -2.954857, -0.047674>
    }
    triangle {
      < 3.703852, -3.358929, 0.249468>,
      < 3.722475, -2.954857, -0.047674>,
      < 3.744563, -2.991360, 0.261601>
    }
    triangle {
      < 3.675314, -3.326316, 0.542915>,
      < 3.703852, -3.358929, 0.249468>,
      < 3.744563, -2.991360, 0.261601>
    }
    triangle {
      < 3.675314, -3.326316, 0.542915>,
      < 3.744563, -2.991360, 0.261601>,
      < 3.661297, -3.005761, 0.488316>
    }
    triangle {
      < 3.613293, -3.303538, 0.713008>,
      < 3.675314, -3.326316, 0.542915>,
      < 3.661297, -3.005761, 0.488316>
    }
    triangle {
      < 3.613293, -3.303538, 0.713008>,
      < 3.661297, -3.005761, 0.488316>,
      < 3.612877, -3.003972, 0.647348>
    }
    triangle {
      < 3.855826, -4.343190, -0.131656>,
      < 3.693901, -3.916591, -0.115516>,
      < 3.789576, -3.907470, 0.254377>
    }
    triangle {
      < 3.855826, -4.343190, -0.131656>,
      < 3.789576, -3.907470, 0.254377>,
      < 3.858342, -4.321498, 0.208042>
    }
    triangle {
      < 3.855826, -4.343190, -0.131656>,
      < 3.858342, -4.321498, 0.208042>,
      < 3.822417, -4.339959, 0.033673>
    }
    triangle {
      < 3.222924, -3.353535, 1.002504>,
      < 3.444501, -3.301727, 0.923484>,
      < 3.459755, -3.017162, 0.863932>
    }
    triangle {
      < 3.222924, -3.353535, 1.002504>,
      < 3.459755, -3.017162, 0.863932>,
      < 3.261235, -3.085547, 0.931902>
    }
    triangle {
      < 3.444501, -3.301727, 0.923484>,
      < 3.613293, -3.303538, 0.713008>,
      < 3.612877, -3.003972, 0.647348>
    }
    triangle {
      < 3.444501, -3.301727, 0.923484>,
      < 3.612877, -3.003972, 0.647348>,
      < 3.459755, -3.017162, 0.863932>
    }
    triangle {
      < 3.222924, -3.353535, 1.002504>,
      < 3.261235, -3.085547, 0.931902>,
      < 3.031742, -3.107454, 0.928309>
    }
    triangle {
      < 3.222924, -3.353535, 1.002504>,
      < 3.031742, -3.107454, 0.928309>,
      < 2.999575, -3.309280, 0.968456>
    }
    triangle {
      < 3.222924, -3.353535, 1.002504>,
      < 2.999575, -3.309280, 0.968456>,
      < 2.903923, -3.680026, 1.129989>
    }
    triangle {
      < 3.222924, -3.353535, 1.002504>,
      < 2.903923, -3.680026, 1.129989>,
      < 3.201631, -3.744820, 1.164047>
    }
    triangle {
      < 3.031742, -3.107454, 0.928309>,
      < 2.940914, -2.243228, 0.777409>,
      < 2.759688, -2.284769, 0.472808>
    }
    triangle {
      < 3.031742, -3.107454, 0.928309>,
      < 2.759688, -2.284769, 0.472808>,
      < 2.914910, -3.123339, 0.588616>
    }
    triangle {
      < 2.853162, -3.365846, 0.637326>,
      < 2.876625, -3.360112, 0.793590>,
      < 2.999575, -3.309280, 0.968456>
    }
    triangle {
      < 2.853162, -3.365846, 0.637326>,
      < 2.999575, -3.309280, 0.968456>,
      < 3.031742, -3.107454, 0.928309>
    }
    triangle {
      < 2.853162, -3.365846, 0.637326>,
      < 3.031742, -3.107454, 0.928309>,
      < 2.914910, -3.123339, 0.588616>
    }
    triangle {
      < 3.101251, -3.307032, -0.110100>,
      < 3.000942, -3.360298, 0.240543>,
      < 2.948871, -3.072044, 0.233427>
    }
    triangle {
      < 3.101251, -3.307032, -0.110100>,
      < 2.948871, -3.072044, 0.233427>,
      < 3.048708, -3.013967, -0.064947>
    }
    triangle {
      < 3.048708, -3.013967, -0.064947>,
      < 2.948871, -3.072044, 0.233427>,
      < 2.796178, -2.243745, 0.149603>
    }
    triangle {
      < 3.048708, -3.013967, -0.064947>,
      < 2.796178, -2.243745, 0.149603>,
      < 2.906696, -2.229177, -0.106366>
    }
    triangle {
      < 2.759688, -2.284769, 0.472808>,
      < 2.796178, -2.243745, 0.149603>,
      < 2.948871, -3.072044, 0.233427>
    }
    triangle {
      < 2.759688, -2.284769, 0.472808>,
      < 2.948871, -3.072044, 0.233427>,
      < 2.914910, -3.123339, 0.588616>
    }
    triangle {
      < 3.599305, -3.225931, -0.043476>,
      < 3.423148, -3.594702, -0.219296>,
      < 3.400748, -3.266075, -0.161594>
    }
    triangle {
      < 3.400748, -3.266075, -0.161594>,
      < 3.101251, -3.307032, -0.110100>,
      < 3.048708, -3.013967, -0.064947>
    }
    triangle {
      < 3.400748, -3.266075, -0.161594>,
      < 3.048708, -3.013967, -0.064947>,
      < 3.360919, -2.933254, -0.166444>
    }
    triangle {
      < 3.360919, -2.933254, -0.166444>,
      < 3.048708, -3.013967, -0.064947>,
      < 2.906696, -2.229177, -0.106366>
    }
    triangle {
      < 3.360919, -2.933254, -0.166444>,
      < 2.906696, -2.229177, -0.106366>,
      < 3.283058, -2.214731, -0.242483>
    }
    triangle {
      < 3.599305, -3.225931, -0.043476>,
      < 3.400748, -3.266075, -0.161594>,
      < 3.360919, -2.933254, -0.166444>
    }
    triangle {
      < 3.599305, -3.225931, -0.043476>,
      < 3.360919, -2.933254, -0.166444>,
      < 3.722475, -2.954857, -0.047674>
    }
    triangle {
      < 3.722475, -2.954857, -0.047674>,
      < 3.360919, -2.933254, -0.166444>,
      < 3.283058, -2.214731, -0.242483>
    }
    triangle {
      < 3.722475, -2.954857, -0.047674>,
      < 3.283058, -2.214731, -0.242483>,
      < 3.647496, -2.193329, -0.109512>
    }
    triangle {
      < 3.722475, -2.954857, -0.047674>,
      < 3.647496, -2.193329, -0.109512>,
      < 3.739547, -2.255244, 0.220017>
    }
    triangle {
      < 3.722475, -2.954857, -0.047674>,
      < 3.739547, -2.255244, 0.220017>,
      < 3.744563, -2.991360, 0.261601>
    }
    triangle {
      < 3.744563, -2.991360, 0.261601>,
      < 3.739547, -2.255244, 0.220017>,
      < 3.672426, -2.254568, 0.464542>
    }
    triangle {
      < 3.744563, -2.991360, 0.261601>,
      < 3.672426, -2.254568, 0.464542>,
      < 3.661297, -3.005761, 0.488316>
    }
    triangle {
      < 3.661297, -3.005761, 0.488316>,
      < 3.672426, -2.254568, 0.464542>,
      < 3.610453, -2.236604, 0.675438>
    }
    triangle {
      < 3.661297, -3.005761, 0.488316>,
      < 3.610453, -2.236604, 0.675438>,
      < 3.612877, -3.003972, 0.647348>
    }
    triangle {
      < 3.612877, -3.003972, 0.647348>,
      < 3.610453, -2.236604, 0.675438>,
      < 3.450000, -2.224814, 0.871098>
    }
    triangle {
      < 3.612877, -3.003972, 0.647348>,
      < 3.450000, -2.224814, 0.871098>,
      < 3.459755, -3.017162, 0.863932>
    }
    triangle {
      < 3.450000, -2.224814, 0.871098>,
      < 3.105591, -2.217616, 0.883761>,
      < 3.261235, -3.085547, 0.931902>
    }
    triangle {
      < 3.450000, -2.224814, 0.871098>,
      < 3.261235, -3.085547, 0.931902>,
      < 3.459755, -3.017162, 0.863932>
    }
    triangle {
      < 3.031742, -3.107454, 0.928309>,
      < 3.261235, -3.085547, 0.931902>,
      < 3.105591, -2.217616, 0.883761>
    }
    triangle {
      < 3.031742, -3.107454, 0.928309>,
      < 3.105591, -2.217616, 0.883761>,
      < 2.940914, -2.243228, 0.777409>
    }
    triangle {
      < 3.105591, -2.217616, 0.883761>,
      < 3.450000, -2.224814, 0.871098>,
      < 3.236061, -1.194528, 0.988761>
    }
    triangle {
      < 3.105591, -2.217616, 0.883761>,
      < 3.236061, -1.194528, 0.988761>,
      < 2.846456, -1.229834, 0.857554>
    }
    triangle {
      < 3.105591, -2.217616, 0.883761>,
      < 2.846456, -1.229834, 0.857554>,
      < 2.603119, -1.251225, 0.631441>
    }
    triangle {
      < 3.105591, -2.217616, 0.883761>,
      < 2.603119, -1.251225, 0.631441>,
      < 2.940914, -2.243228, 0.777409>
    }
    triangle {
      < 2.940914, -2.243228, 0.777409>,
      < 2.603119, -1.251225, 0.631441>,
      < 2.462617, -1.263338, 0.278344>
    }
    triangle {
      < 2.940914, -2.243228, 0.777409>,
      < 2.462617, -1.263338, 0.278344>,
      < 2.759688, -2.284769, 0.472808>
    }
    triangle {
      < 2.759688, -2.284769, 0.472808>,
      < 2.462617, -1.263338, 0.278344>,
      < 2.489793, -1.260167, -0.053393>
    }
    triangle {
      < 2.759688, -2.284769, 0.472808>,
      < 2.489793, -1.260167, -0.053393>,
      < 2.796178, -2.243745, 0.149603>
    }
    triangle {
      < 2.796178, -2.243745, 0.149603>,
      < 2.489793, -1.260167, -0.053393>,
      < 2.746340, -1.238220, -0.282059>
    }
    triangle {
      < 2.796178, -2.243745, 0.149603>,
      < 2.746340, -1.238220, -0.282059>,
      < 2.906696, -2.229177, -0.106366>
    }
    triangle {
      < 3.283058, -2.214731, -0.242483>,
      < 3.249544, -1.193210, -0.446053>,
      < 3.680506, -1.156399, -0.148684>
    }
    triangle {
      < 3.283058, -2.214731, -0.242483>,
      < 3.680506, -1.156399, -0.148684>,
      < 3.647496, -2.193329, -0.109512>
    }
    triangle {
      < 2.746340, -1.238220, -0.282059>,
      < 3.249544, -1.193210, -0.446053>,
      < 3.283058, -2.214731, -0.242483>
    }
    triangle {
      < 2.746340, -1.238220, -0.282059>,
      < 3.283058, -2.214731, -0.242483>,
      < 2.906696, -2.229177, -0.106366>
    }
    triangle {
      < 3.647496, -2.193329, -0.109512>,
      < 3.680506, -1.156399, -0.148684>,
      < 3.799026, -1.145475, 0.247541>
    }
    triangle {
      < 3.647496, -2.193329, -0.109512>,
      < 3.799026, -1.145475, 0.247541>,
      < 3.739547, -2.255244, 0.220017>
    }
    triangle {
      < 3.739547, -2.255244, 0.220017>,
      < 3.799026, -1.145475, 0.247541>,
      < 3.763706, -1.148521, 0.569785>
    }
    triangle {
      < 3.739547, -2.255244, 0.220017>,
      < 3.763706, -1.148521, 0.569785>,
      < 3.672426, -2.254568, 0.464542>
    }
    triangle {
      < 3.672426, -2.254568, 0.464542>,
      < 3.763706, -1.148521, 0.569785>,
      < 3.580457, -1.165438, 0.825006>
    }
    triangle {
      < 3.672426, -2.254568, 0.464542>,
      < 3.580457, -1.165438, 0.825006>,
      < 3.610453, -2.236604, 0.675438>
    }
    triangle {
      < 3.610453, -2.236604, 0.675438>,
      < 3.580457, -1.165438, 0.825006>,
      < 3.236061, -1.194528, 0.988761>
    }
    triangle {
      < 3.610453, -2.236604, 0.675438>,
      < 3.236061, -1.194528, 0.988761>,
      < 3.450000, -2.224814, 0.871098>
    }
    triangle {
      < 3.580457, -1.165438, 0.825006>,
      < 3.584816, -0.259706, 0.871421>,
      < 3.079602, -0.272644, 0.990726>
    }
    triangle {
      < 3.580457, -1.165438, 0.825006>,
      < 3.079602, -0.272644, 0.990726>,
      < 3.236061, -1.194528, 0.988761>
    }
    triangle {
      < 3.236061, -1.194528, 0.988761>,
      < 3.079602, -0.272644, 0.990726>,
      < 2.599851, -0.304157, 0.877433>
    }
    triangle {
      < 3.236061, -1.194528, 0.988761>,
      < 2.599851, -0.304157, 0.877433>,
      < 2.846456, -1.229834, 0.857554>
    }
    triangle {
      < 2.846456, -1.229834, 0.857554>,
      < 2.599851, -0.304157, 0.877433>,
      < 2.374817, -0.345360, 0.504614>
    }
    triangle {
      < 2.846456, -1.229834, 0.857554>,
      < 2.374817, -0.345360, 0.504614>,
      < 2.603119, -1.251225, 0.631441>
    }
    triangle {
      < 2.603119, -1.251225, 0.631441>,
      < 2.374817, -0.345360, 0.504614>,
      < 2.270152, -0.378846, 0.098363>
    }
    triangle {
      < 2.603119, -1.251225, 0.631441>,
      < 2.270152, -0.378846, 0.098363>,
      < 2.462617, -1.263338, 0.278344>
    }
    triangle {
      < 2.462617, -1.263338, 0.278344>,
      < 2.270152, -0.378846, 0.098363>,
      < 2.377485, -0.347431, -0.200958>
    }
    triangle {
      < 2.462617, -1.263338, 0.278344>,
      < 2.377485, -0.347431, -0.200958>,
      < 2.489793, -1.260167, -0.053393>
    }
    triangle {
      < 2.489793, -1.260167, -0.053393>,
      < 2.377485, -0.347431, -0.200958>,
      < 2.692744, -0.302287, -0.429027>
    }
    triangle {
      < 2.489793, -1.260167, -0.053393>,
      < 2.692744, -0.302287, -0.429027>,
      < 2.746340, -1.238220, -0.282059>
    }
    triangle {
      < 2.746340, -1.238220, -0.282059>,
      < 2.692744, -0.302287, -0.429027>,
      < 3.150655, -0.294560, -0.511985>
    }
    triangle {
      < 2.746340, -1.238220, -0.282059>,
      < 3.150655, -0.294560, -0.511985>,
      < 3.249544, -1.193210, -0.446053>
    }
    triangle {
      < 3.249544, -1.193210, -0.446053>,
      < 3.150655, -0.294560, -0.511985>,
      < 3.493797, -0.241574, -0.177637>
    }
    triangle {
      < 3.249544, -1.193210, -0.446053>,
      < 3.493797, -0.241574, -0.177637>,
      < 3.680506, -1.156399, -0.148684>
    }
    triangle {
      < 3.680506, -1.156399, -0.148684>,
      < 3.493797, -0.241574, -0.177637>,
      < 3.644981, -0.239785, 0.250997>
    }
    triangle {
      < 3.680506, -1.156399, -0.148684>,
      < 3.644981, -0.239785, 0.250997>,
      < 3.799026, -1.145475, 0.247541>
    }
    triangle {
      < 3.799026, -1.145475, 0.247541>,
      < 3.644981, -0.239785, 0.250997>,
      < 3.704188, -0.251920, 0.601294>
    }
    triangle {
      < 3.799026, -1.145475, 0.247541>,
      < 3.704188, -0.251920, 0.601294>,
      < 3.763706, -1.148521, 0.569785>
    }
    triangle {
      < 3.763706, -1.148521, 0.569785>,
      < 3.704188, -0.251920, 0.601294>,
      < 3.584816, -0.259706, 0.871421>
    }
    triangle {
      < 3.763706, -1.148521, 0.569785>,
      < 3.584816, -0.259706, 0.871421>,
      < 3.580457, -1.165438, 0.825006>
    }
    triangle {
      < 3.121146, -5.484527, -0.155941>,
      < 3.137978, -5.462011, -0.134840>,
      < 3.111749, -5.413926, -0.159047>
    }
    triangle {
      < 2.643964, -4.725788, 1.080201>,
      < 2.703791, -4.743211, 0.972488>,
      < 2.676981, -5.016549, 0.977451>
    }
    triangle {
      < 2.643964, -4.725788, 1.080201>,
      < 2.676981, -5.016549, 0.977451>,
      < 2.606242, -4.997890, 1.062551>
    }
    triangle {
      < 3.715068, -4.365313, -0.273409>,
      < 3.671955, -4.474066, -0.276357>,
      < 3.553879, -4.454062, -0.313867>
    }
    triangle {
      < 3.715068, -4.365313, -0.273409>,
      < 3.553879, -4.454062, -0.313867>,
      < 3.571329, -4.367672, -0.316899>
    }
    triangle {
      < 3.671955, -4.474066, -0.276357>,
      < 3.663128, -4.621632, -0.262480>,
      < 3.557271, -4.575253, -0.314636>
    }
    triangle {
      < 3.671955, -4.474066, -0.276357>,
      < 3.557271, -4.575253, -0.314636>,
      < 3.553879, -4.454062, -0.313867>
    }
    triangle {
      < 3.663128, -4.621632, -0.262480>,
      < 3.604485, -4.949396, -0.307969>,
      < 3.541634, -4.902719, -0.361870>
    }
    triangle {
      < 3.663128, -4.621632, -0.262480>,
      < 3.541634, -4.902719, -0.361870>,
      < 3.557271, -4.575253, -0.314636>
    }
    triangle {
      < 3.541634, -4.902719, -0.361870>,
      < 3.604485, -4.949396, -0.307969>,
      < 3.404628, -5.236587, -0.286603>
    }
    triangle {
      < 3.541634, -4.902719, -0.361870>,
      < 3.404628, -5.236587, -0.286603>,
      < 3.389684, -5.170204, -0.347680>
    }
    triangle {
      < 3.242743, -5.367341, -0.267206>,
      < 3.233992, -5.380470, -0.256286>,
      < 3.227041, -5.375122, -0.272112>
    }
    triangle {
      < 3.227041, -5.375122, -0.272112>,
      < 3.159483, -5.465992, -0.270949>,
      < 3.140325, -5.456113, -0.279372>
    }
    triangle {
      < 3.227041, -5.375122, -0.272112>,
      < 3.140325, -5.456113, -0.279372>,
      < 3.218018, -5.361663, -0.309225>
    }
    triangle {
      < 3.687103, -4.663103, 0.023185>,
      < 3.707675, -4.638666, -0.073645>,
      < 3.749773, -4.510483, -0.012252>
    }
    triangle {
      < 3.687103, -4.663103, 0.023185>,
      < 3.497663, -4.709856, 0.057938>,
      < 3.512556, -4.651647, -0.028831>
    }
    triangle {
      < 3.687103, -4.663103, 0.023185>,
      < 3.512556, -4.651647, -0.028831>,
      < 3.707675, -4.638666, -0.073645>
    }
    triangle {
      < 3.512556, -4.651647, -0.028831>,
      < 3.461182, -4.657507, -0.083460>,
      < 3.456882, -4.897809, -0.101509>
    }
    triangle {
      < 3.512556, -4.651647, -0.028831>,
      < 3.456882, -4.897809, -0.101509>,
      < 3.544179, -4.939861, -0.066314>
    }
    triangle {
      < 3.375304, -5.186841, -0.084050>,
      < 3.544179, -4.939861, -0.066314>,
      < 3.456882, -4.897809, -0.101509>
    }
    triangle {
      < 3.375304, -5.186841, -0.084050>,
      < 3.456882, -4.897809, -0.101509>,
      < 3.346880, -5.130281, -0.120578>
    }
    triangle {
      < 3.177206, -5.312306, -0.124534>,
      < 3.189222, -5.387946, -0.109955>,
      < 3.375304, -5.186841, -0.084050>
    }
    triangle {
      < 3.177206, -5.312306, -0.124534>,
      < 3.375304, -5.186841, -0.084050>,
      < 3.346880, -5.130281, -0.120578>
    }
    triangle {
      < 3.531374, -5.903006, 0.994906>,
      < 3.505869, -6.028747, 0.966244>,
      < 3.522264, -6.025560, 0.965866>
    }
    triangle {
      < 3.531374, -5.903006, 0.994906>,
      < 3.522264, -6.025560, 0.965866>,
      < 3.550858, -5.907750, 0.973820>
    }
    triangle {
      < 3.525503, -4.858645, 0.856764>,
      < 3.650504, -4.915636, 0.760976>,
      < 3.649614, -5.325970, 0.777320>
    }
    triangle {
      < 3.525503, -4.858645, 0.856764>,
      < 3.649614, -5.325970, 0.777320>,
      < 3.543149, -5.294589, 0.850091>
    }
    triangle {
      < 3.525503, -4.858645, 0.856764>,
      < 3.543149, -5.294589, 0.850091>,
      < 3.522806, -5.152845, 0.852173>
    }
    triangle {
      < 3.120829, -5.685888, 0.204650>,
      < 3.063355, -5.657243, 0.162309>,
      < 2.980297, -5.779233, 0.151208>
    }
    triangle {
      < 3.120829, -5.685888, 0.204650>,
      < 2.980297, -5.779233, 0.151208>,
      < 3.012648, -5.771694, 0.178818>
    }
    triangle {
      < 3.253295, -5.378718, -0.152609>,
      < 3.222092, -5.389814, -0.142920>,
      < 3.238530, -5.390752, -0.159403>
    }
    triangle {
      < 2.990301, -3.784639, 0.396786>,
      < 2.923318, -3.466007, 0.391588>,
      < 3.000942, -3.360298, 0.240543>
    }
    triangle {
      < 3.120829, -5.685888, 0.204650>,
      < 3.261086, -5.535859, 0.221632>,
      < 3.196105, -5.510826, 0.175614>
    }
    triangle {
      < 3.120829, -5.685888, 0.204650>,
      < 3.196105, -5.510826, 0.175614>,
      < 3.063355, -5.657243, 0.162309>
    }
    triangle {
      < 3.438591, -5.169542, 0.211200>,
      < 3.196105, -5.510826, 0.175614>,
      < 3.261086, -5.535859, 0.221632>
    }
    triangle {
      < 3.438591, -5.169542, 0.211200>,
      < 3.261086, -5.535859, 0.221632>,
      < 3.548440, -5.201604, 0.264880>
    }
    triangle {
      < 3.639382, -4.865031, 0.294500>,
      < 3.456233, -4.759103, 0.296852>,
      < 3.438591, -5.169542, 0.211200>
    }
    triangle {
      < 3.639382, -4.865031, 0.294500>,
      < 3.438591, -5.169542, 0.211200>,
      < 3.548440, -5.201604, 0.264880>
    }
    triangle {
      < 3.403350, -4.639856, 0.372886>,
      < 3.456233, -4.759103, 0.296852>,
      < 3.519503, -4.890442, 0.426109>
    }
    triangle {
      < 3.819031, -4.756149, 0.303078>,
      < 3.680832, -4.871781, 0.372331>,
      < 3.456233, -4.759103, 0.296852>
    }
    triangle {
      < 3.061577, -5.826604, 0.076622>,
      < 3.017643, -5.834864, 0.063272>,
      < 3.039448, -5.784328, 0.022500>
    }
    triangle {
      < 3.061577, -5.826604, 0.076622>,
      < 3.039448, -5.784328, 0.022500>,
      < 3.074443, -5.803917, 0.041438>
    }
    triangle {
      < 3.137688, -5.489302, -0.242971>,
      < 3.108019, -5.480084, -0.249201>,
      < 3.140325, -5.456113, -0.279372>
    }
    triangle {
      < 3.137688, -5.489302, -0.242971>,
      < 3.140325, -5.456113, -0.279372>,
      < 3.159483, -5.465992, -0.270949>
    }
    triangle {
      < 3.534503, -6.017144, 0.802934>,
      < 3.572496, -5.890628, 0.808892>,
      < 3.605893, -5.908008, 0.839344>
    }
    triangle {
      < 3.534503, -6.017144, 0.802934>,
      < 3.605893, -5.908008, 0.839344>,
      < 3.562773, -6.024592, 0.815694>
    }
    triangle {
      < 3.412204, -4.449575, -0.235962>,
      < 3.461453, -4.561948, -0.246288>,
      < 3.461182, -4.657507, -0.083460>
    }
    triangle {
      < 3.412204, -4.449575, -0.235962>,
      < 3.461182, -4.657507, -0.083460>,
      < 3.364325, -4.533445, 0.058658>
    }
    triangle {
      < 3.461182, -4.657507, -0.083460>,
      < 3.512556, -4.651647, -0.028831>,
      < 3.364325, -4.533445, 0.058658>
    }
    triangle {
      < 3.872860, -4.762247, 0.594336>,
      < 3.978867, -4.556856, 0.590013>,
      < 3.803743, -4.753818, 0.693033>
    }
    triangle {
      < 3.377950, -4.242374, -0.231630>,
      < 3.314325, -4.027246, -0.205350>,
      < 3.465101, -3.953986, -0.273622>
    }
    triangle {
      < 3.377950, -4.242374, -0.231630>,
      < 3.465101, -3.953986, -0.273622>,
      < 3.571329, -4.367672, -0.316899>
    }
    triangle {
      < 3.271274, -4.553491, 0.845122>,
      < 3.354759, -4.407702, 0.529355>,
      < 3.376643, -4.703335, 0.631060>
    }
    triangle {
      < 3.271274, -4.553491, 0.845122>,
      < 3.376643, -4.703335, 0.631060>,
      < 3.324410, -4.776068, 1.013156>
    }
    triangle {
      < 3.073454, -4.431412, 0.941757>,
      < 2.899165, -4.345756, 0.831593>,
      < 2.990301, -3.784639, 0.396786>
    }
    triangle {
      < 2.973360, -4.269324, 1.317931>,
      < 3.171760, -4.101448, 1.247475>,
      < 3.201631, -3.744820, 1.164047>
    }
    triangle {
      < 2.973360, -4.269324, 1.317931>,
      < 3.201631, -3.744820, 1.164047>,
      < 2.903923, -3.680026, 1.129989>
    }
    triangle {
      < 3.715068, -4.365313, -0.273409>,
      < 3.571329, -4.367672, -0.316899>,
      < 3.465101, -3.953986, -0.273622>
    }
    triangle {
      < 2.923318, -3.466007, 0.391588>,
      < 2.990301, -3.784639, 0.396786>,
      < 2.704204, -3.806584, 0.684968>
    }
    triangle {
      < 3.150421, -6.097242, 0.485310>,
      < 3.285124, -5.948591, 0.498650>,
      < 3.226502, -5.923387, 0.560858>
    }
    triangle {
      < 3.150421, -6.097242, 0.485310>,
      < 3.226502, -5.923387, 0.560858>,
      < 3.151881, -6.024515, 0.556160>
    }
    triangle {
      < 3.150421, -6.097242, 0.485310>,
      < 3.151881, -6.024515, 0.556160>,
      < 3.146393, -6.072251, 0.535676>
    }
    triangle {
      < 3.531293, -6.078069, 0.882219>,
      < 3.538268, -6.066545, 0.844955>,
      < 3.562773, -6.024592, 0.815694>
    }
    triangle {
      < 3.531293, -6.078069, 0.882219>,
      < 3.562773, -6.024592, 0.815694>,
      < 3.605893, -5.908008, 0.839344>
    }
    triangle {
      < 3.531293, -6.078069, 0.882219>,
      < 3.605893, -5.908008, 0.839344>,
      < 3.610975, -5.919303, 0.919372>
    }
    triangle {
      < 3.067862, -5.842321, 0.111463>,
      < 3.196340, -5.733409, 0.114749>,
      < 3.155772, -5.712716, 0.152194>
    }
    triangle {
      < 3.067862, -5.842321, 0.111463>,
      < 3.155772, -5.712716, 0.152194>,
      < 3.071395, -5.801376, 0.160804>
    }
    triangle {
      < 3.067862, -5.842321, 0.111463>,
      < 3.071395, -5.801376, 0.160804>,
      < 3.060814, -5.828017, 0.134598>
    }
    triangle {
      < 3.144734, -5.510552, -0.212819>,
      < 3.143772, -5.500243, -0.240001>,
      < 3.169059, -5.470934, -0.266738>
    }
    triangle {
      < 3.144734, -5.510552, -0.212819>,
      < 3.169059, -5.470934, -0.266738>,
      < 3.233992, -5.380470, -0.256286>
    }
    triangle {
      < 3.144734, -5.510552, -0.212819>,
      < 3.233992, -5.380470, -0.256286>,
      < 3.281411, -5.411036, -0.210920>
    }
    triangle {
      < 3.144734, -5.510552, -0.212819>,
      < 3.281411, -5.411036, -0.210920>,
      < 3.238530, -5.390752, -0.159403>
    }
    triangle {
      < 3.144734, -5.510552, -0.212819>,
      < 3.238530, -5.390752, -0.159403>,
      < 3.175271, -5.486119, -0.157501>
    }
    triangle {
      < 3.144734, -5.510552, -0.212819>,
      < 3.175271, -5.486119, -0.157501>,
      < 3.146878, -5.507833, -0.185383>
    }
    triangle {
      < 3.293084, -5.396710, -0.214851>,
      < 3.253295, -5.378718, -0.152609>,
      < 3.238530, -5.390752, -0.159403>
    }
    triangle {
      < 3.293084, -5.396710, -0.214851>,
      < 3.238530, -5.390752, -0.159403>,
      < 3.281411, -5.411036, -0.210920>
    }
    triangle {
      < 3.452394, -5.270232, -0.219996>,
      < 3.671307, -4.971681, -0.225062>,
      < 3.623229, -4.962186, -0.131394>
    }
    triangle {
      < 3.452394, -5.270232, -0.219996>,
      < 3.623229, -4.962186, -0.131394>,
      < 3.427206, -5.250150, -0.136576>
    }
    triangle {
      < 3.707675, -4.638666, -0.073645>,
      < 3.623229, -4.962186, -0.131394>,
      < 3.671307, -4.971681, -0.225062>
    }
    triangle {
      < 3.707675, -4.638666, -0.073645>,
      < 3.671307, -4.971681, -0.225062>,
      < 3.732185, -4.634325, -0.180645>
    }
    triangle {
      < 3.732185, -4.634325, -0.180645>,
      < 3.755457, -4.503113, -0.158990>,
      < 3.749773, -4.510483, -0.012252>
    }
    triangle {
      < 3.732185, -4.634325, -0.180645>,
      < 3.749773, -4.510483, -0.012252>,
      < 3.707675, -4.638666, -0.073645>
    }
    triangle {
      < 3.755457, -4.503113, -0.158990>,
      < 3.855826, -4.343190, -0.131656>,
      < 3.749773, -4.510483, -0.012252>
    }
    triangle {
      < 3.855826, -4.343190, -0.131656>,
      < 3.671955, -4.474066, -0.276357>,
      < 3.715068, -4.365313, -0.273409>
    }
    triangle {
      < 3.866155, -4.683072, 0.186399>,
      < 3.833309, -4.794936, 0.174423>,
      < 3.791321, -4.745622, 0.078156>
    }
    triangle {
      < 3.866155, -4.683072, 0.186399>,
      < 3.791321, -4.745622, 0.078156>,
      < 3.820560, -4.589967, 0.087331>
    }
    triangle {
      < 3.833309, -4.794936, 0.174423>,
      < 3.711217, -5.239375, 0.133680>,
      < 3.677980, -5.215698, 0.044134>
    }
    triangle {
      < 3.833309, -4.794936, 0.174423>,
      < 3.677980, -5.215698, 0.044134>,
      < 3.791321, -4.745622, 0.078156>
    }
    triangle {
      < 3.677980, -5.215698, 0.044134>,
      < 3.711217, -5.239375, 0.133680>,
      < 3.388301, -5.580028, 0.124869>
    }
    triangle {
      < 3.677980, -5.215698, 0.044134>,
      < 3.388301, -5.580028, 0.124869>,
      < 3.380490, -5.552703, 0.040199>
    }
    triangle {
      < 3.196241, -5.713139, 0.055022>,
      < 3.380490, -5.552703, 0.040199>,
      < 3.388301, -5.580028, 0.124869>
    }
    triangle {
      < 3.196241, -5.713139, 0.055022>,
      < 3.388301, -5.580028, 0.124869>,
      < 3.216337, -5.726731, 0.118775>
    }
    triangle {
      < 3.196340, -5.733409, 0.114749>,
      < 3.067862, -5.842321, 0.111463>,
      < 3.072965, -5.834154, 0.082249>
    }
    triangle {
      < 3.196340, -5.733409, 0.114749>,
      < 3.072965, -5.834154, 0.082249>,
      < 3.095662, -5.813387, 0.051917>
    }
    triangle {
      < 3.196340, -5.733409, 0.114749>,
      < 3.095662, -5.813387, 0.051917>,
      < 3.192200, -5.730344, 0.057413>
    }
    triangle {
      < 3.820560, -4.589967, 0.087331>,
      < 3.935352, -4.474578, 0.199895>,
      < 3.866155, -4.683072, 0.186399>
    }
    triangle {
      < 3.978867, -4.556856, 0.590013>,
      < 3.872860, -4.762247, 0.594336>,
      < 3.848762, -4.753190, 0.476878>
    }
    triangle {
      < 3.872860, -4.762247, 0.594336>,
      < 3.871635, -4.874913, 0.579817>,
      < 3.840905, -4.872707, 0.474656>
    }
    triangle {
      < 3.872860, -4.762247, 0.594336>,
      < 3.840905, -4.872707, 0.474656>,
      < 3.848762, -4.753190, 0.476878>
    }
    triangle {
      < 3.871635, -4.874913, 0.579817>,
      < 3.787827, -5.377024, 0.557766>,
      < 3.749318, -5.362044, 0.458830>
    }
    triangle {
      < 3.871635, -4.874913, 0.579817>,
      < 3.749318, -5.362044, 0.458830>,
      < 3.840905, -4.872707, 0.474656>
    }
    triangle {
      < 3.410457, -5.758007, 0.415555>,
      < 3.749318, -5.362044, 0.458830>,
      < 3.787827, -5.377024, 0.557766>
    }
    triangle {
      < 3.410457, -5.758007, 0.415555>,
      < 3.787827, -5.377024, 0.557766>,
      < 3.453096, -5.787074, 0.509127>
    }
    triangle {
      < 3.263365, -5.932832, 0.427533>,
      < 3.410457, -5.758007, 0.415555>,
      < 3.453096, -5.787074, 0.509127>
    }
    triangle {
      < 3.263365, -5.932832, 0.427533>,
      < 3.453096, -5.787074, 0.509127>,
      < 3.310092, -5.947457, 0.499410>
    }
    triangle {
      < 3.285124, -5.948591, 0.498650>,
      < 3.150421, -6.097242, 0.485310>,
      < 3.155637, -6.079582, 0.445845>
    }
    triangle {
      < 3.285124, -5.948591, 0.498650>,
      < 3.155637, -6.079582, 0.445845>,
      < 3.171965, -6.034112, 0.406677>
    }
    triangle {
      < 3.285124, -5.948591, 0.498650>,
      < 3.171965, -6.034112, 0.406677>,
      < 3.246890, -5.951345, 0.425132>
    }
    triangle {
      < 3.531293, -6.078069, 0.882219>,
      < 3.610975, -5.919303, 0.919372>,
      < 3.550858, -5.907750, 0.973820>
    }
    triangle {
      < 3.531293, -6.078069, 0.882219>,
      < 3.550858, -5.907750, 0.973820>,
      < 3.522264, -6.025560, 0.965866>
    }
    triangle {
      < 3.531293, -6.078069, 0.882219>,
      < 3.522264, -6.025560, 0.965866>,
      < 3.518012, -6.067028, 0.920041>
    }
    triangle {
      < 3.624970, -5.907471, 0.927947>,
      < 3.553595, -5.892168, 0.986735>,
      < 3.550858, -5.907750, 0.973820>
    }
    triangle {
      < 3.624970, -5.907471, 0.927947>,
      < 3.550858, -5.907750, 0.973820>,
      < 3.610975, -5.919303, 0.919372>
    }
    triangle {
      < 3.701282, -5.729109, 0.969850>,
      < 3.826484, -5.322048, 1.027841>,
      < 3.749973, -5.313198, 1.098377>
    }
    triangle {
      < 3.701282, -5.729109, 0.969850>,
      < 3.749973, -5.313198, 1.098377>,
      < 3.632454, -5.713002, 1.037336>
    }
    triangle {
      < 3.654503, -4.904352, 1.111933>,
      < 3.749973, -5.313198, 1.098377>,
      < 3.826484, -5.322048, 1.027841>
    }
    triangle {
      < 3.654503, -4.904352, 1.111933>,
      < 3.826484, -5.322048, 1.027841>,
      < 3.761762, -4.904438, 1.035913>
    }
    triangle {
      < 3.866155, -4.683072, 0.186399>,
      < 3.935352, -4.474578, 0.199895>,
      < 3.819031, -4.756149, 0.303078>
    }
    triangle {
      < 3.348468, -4.497969, 1.145854>,
      < 3.549953, -4.498902, 1.149813>,
      < 3.446155, -4.248275, 1.191563>
    }
    triangle {
      < 3.348468, -4.497969, 1.145854>,
      < 3.446155, -4.248275, 1.191563>,
      < 3.310992, -4.389974, 1.185302>
    }
    triangle {
      < 3.549953, -4.498902, 1.149813>,
      < 3.626639, -4.463606, 1.089377>,
      < 3.446155, -4.248275, 1.191563>
    }
    triangle {
      < 3.626639, -4.463606, 1.089377>,
      < 3.768749, -4.368258, 0.884841>,
      < 3.446155, -4.248275, 1.191563>
    }
    triangle {
      < 3.626639, -4.463606, 1.089377>,
      < 3.730436, -4.714237, 1.047626>,
      < 3.756013, -4.691369, 0.949057>
    }
    triangle {
      < 3.730436, -4.714237, 1.047626>,
      < 3.761762, -4.904438, 1.035913>,
      < 3.782173, -4.912578, 0.915967>
    }
    triangle {
      < 3.730436, -4.714237, 1.047626>,
      < 3.782173, -4.912578, 0.915967>,
      < 3.756013, -4.691369, 0.949057>
    }
    triangle {
      < 3.761762, -4.904438, 1.035913>,
      < 3.730436, -4.714237, 1.047626>,
      < 3.653747, -4.749532, 1.108063>
    }
    triangle {
      < 3.761762, -4.904438, 1.035913>,
      < 3.653747, -4.749532, 1.108063>,
      < 3.654503, -4.904352, 1.111933>
    }
    triangle {
      < 3.730436, -4.714237, 1.047626>,
      < 3.626639, -4.463606, 1.089377>,
      < 3.549953, -4.498902, 1.149813>
    }
    triangle {
      < 3.730436, -4.714237, 1.047626>,
      < 3.549953, -4.498902, 1.149813>,
      < 3.653747, -4.749532, 1.108063>
    }
    triangle {
      < 3.140649, -6.052967, 0.521939>,
      < 3.074996, -6.055424, 0.520714>,
      < 3.081568, -6.072448, 0.477527>
    }
    triangle {
      < 3.140649, -6.052967, 0.521939>,
      < 3.081568, -6.072448, 0.477527>,
      < 3.146651, -6.076947, 0.485953>
    }
    triangle {
      < 3.149153, -6.054235, 0.444800>,
      < 3.146651, -6.076947, 0.485953>,
      < 3.081568, -6.072448, 0.477527>
    }
    triangle {
      < 3.149153, -6.054235, 0.444800>,
      < 3.081568, -6.072448, 0.477527>,
      < 3.086810, -6.058038, 0.437816>
    }
    triangle {
      < 3.049008, -5.820407, 0.137574>,
      < 2.993125, -5.820805, 0.134664>,
      < 3.004417, -5.843048, 0.100626>
    }
    triangle {
      < 3.049008, -5.820407, 0.137574>,
      < 3.004417, -5.843048, 0.100626>,
      < 3.053851, -5.841250, 0.105412>
    }
    triangle {
      < 3.061577, -5.826604, 0.076622>,
      < 3.053851, -5.841250, 0.105412>,
      < 3.004417, -5.843048, 0.100626>
    }
    triangle {
      < 3.061577, -5.826604, 0.076622>,
      < 3.004417, -5.843048, 0.100626>,
      < 3.017643, -5.834864, 0.063272>
    }
    triangle {
      < 3.215331, -5.910106, 0.568917>,
      < 3.132799, -6.015729, 0.561931>,
      < 3.151881, -6.024515, 0.556160>
    }
    triangle {
      < 3.215331, -5.910106, 0.568917>,
      < 3.151881, -6.024515, 0.556160>,
      < 3.226502, -5.923387, 0.560858>
    }
    triangle {
      < 3.253033, -5.914477, 0.560052>,
      < 3.215331, -5.910106, 0.568917>,
      < 3.226502, -5.923387, 0.560858>
    }
    triangle {
      < 3.310092, -5.947457, 0.499410>,
      < 3.253033, -5.914477, 0.560052>,
      < 3.226502, -5.923387, 0.560858>
    }
    triangle {
      < 3.310092, -5.947457, 0.499410>,
      < 3.226502, -5.923387, 0.560858>,
      < 3.285124, -5.948591, 0.498650>
    }
    triangle {
      < 3.263365, -5.932832, 0.427533>,
      < 3.310092, -5.947457, 0.499410>,
      < 3.285124, -5.948591, 0.498650>
    }
    triangle {
      < 3.263365, -5.932832, 0.427533>,
      < 3.285124, -5.948591, 0.498650>,
      < 3.246890, -5.951345, 0.425132>
    }
    triangle {
      < 3.230269, -5.937195, 0.415929>,
      < 3.263365, -5.932832, 0.427533>,
      < 3.246890, -5.951345, 0.425132>
    }
    triangle {
      < 3.149762, -6.017935, 0.402476>,
      < 3.230269, -5.937195, 0.415929>,
      < 3.246890, -5.951345, 0.425132>
    }
    triangle {
      < 3.149762, -6.017935, 0.402476>,
      < 3.246890, -5.951345, 0.425132>,
      < 3.171965, -6.034112, 0.406677>
    }
    triangle {
      < 3.149153, -6.054235, 0.444800>,
      < 3.149762, -6.017935, 0.402476>,
      < 3.171965, -6.034112, 0.406677>
    }
    triangle {
      < 3.149153, -6.054235, 0.444800>,
      < 3.171965, -6.034112, 0.406677>,
      < 3.155637, -6.079582, 0.445845>
    }
    triangle {
      < 3.146651, -6.076947, 0.485953>,
      < 3.149153, -6.054235, 0.444800>,
      < 3.155637, -6.079582, 0.445845>
    }
    triangle {
      < 3.146651, -6.076947, 0.485953>,
      < 3.155637, -6.079582, 0.445845>,
      < 3.150421, -6.097242, 0.485310>
    }
    triangle {
      < 3.140649, -6.052967, 0.521939>,
      < 3.146651, -6.076947, 0.485953>,
      < 3.150421, -6.097242, 0.485310>
    }
    triangle {
      < 3.140649, -6.052967, 0.521939>,
      < 3.150421, -6.097242, 0.485310>,
      < 3.146393, -6.072251, 0.535676>
    }
    triangle {
      < 3.132799, -6.015729, 0.561931>,
      < 3.140649, -6.052967, 0.521939>,
      < 3.146393, -6.072251, 0.535676>
    }
    triangle {
      < 3.132799, -6.015729, 0.561931>,
      < 3.146393, -6.072251, 0.535676>,
      < 3.151881, -6.024515, 0.556160>
    }
    triangle {
      < 3.216337, -5.726731, 0.118775>,
      < 3.155939, -5.701127, 0.156862>,
      < 3.155772, -5.712716, 0.152194>
    }
    triangle {
      < 3.216337, -5.726731, 0.118775>,
      < 3.155772, -5.712716, 0.152194>,
      < 3.196340, -5.733409, 0.114749>
    }
    triangle {
      < 3.196241, -5.713139, 0.055022>,
      < 3.216337, -5.726731, 0.118775>,
      < 3.196340, -5.733409, 0.114749>
    }
    triangle {
      < 3.196241, -5.713139, 0.055022>,
      < 3.196340, -5.733409, 0.114749>,
      < 3.192200, -5.730344, 0.057413>
    }
    triangle {
      < 3.170379, -5.716518, 0.044165>,
      < 3.196241, -5.713139, 0.055022>,
      < 3.192200, -5.730344, 0.057413>
    }
    triangle {
      < 3.074443, -5.803917, 0.041438>,
      < 3.170379, -5.716518, 0.044165>,
      < 3.192200, -5.730344, 0.057413>
    }
    triangle {
      < 3.074443, -5.803917, 0.041438>,
      < 3.192200, -5.730344, 0.057413>,
      < 3.095662, -5.813387, 0.051917>
    }
    triangle {
      < 3.061577, -5.826604, 0.076622>,
      < 3.074443, -5.803917, 0.041438>,
      < 3.095662, -5.813387, 0.051917>
    }
    triangle {
      < 3.061577, -5.826604, 0.076622>,
      < 3.095662, -5.813387, 0.051917>,
      < 3.072965, -5.834154, 0.082249>
    }
    triangle {
      < 3.053851, -5.841250, 0.105412>,
      < 3.061577, -5.826604, 0.076622>,
      < 3.072965, -5.834154, 0.082249>
    }
    triangle {
      < 3.053851, -5.841250, 0.105412>,
      < 3.072965, -5.834154, 0.082249>,
      < 3.067862, -5.842321, 0.111463>
    }
    triangle {
      < 3.049008, -5.820407, 0.137574>,
      < 3.053851, -5.841250, 0.105412>,
      < 3.067862, -5.842321, 0.111463>
    }
    triangle {
      < 3.049008, -5.820407, 0.137574>,
      < 3.067862, -5.842321, 0.111463>,
      < 3.060814, -5.828017, 0.134598>
    }
    triangle {
      < 3.049350, -5.791834, 0.168228>,
      < 3.049008, -5.820407, 0.137574>,
      < 3.060814, -5.828017, 0.134598>
    }
    triangle {
      < 3.049350, -5.791834, 0.168228>,
      < 3.060814, -5.828017, 0.134598>,
      < 3.071395, -5.801376, 0.160804>
    }
    triangle {
      < 3.141093, -5.708465, 0.163081>,
      < 3.049350, -5.791834, 0.168228>,
      < 3.071395, -5.801376, 0.160804>
    }
    triangle {
      < 3.141093, -5.708465, 0.163081>,
      < 3.071395, -5.801376, 0.160804>,
      < 3.155772, -5.712716, 0.152194>
    }
    triangle {
      < 3.155939, -5.701127, 0.156862>,
      < 3.141093, -5.708465, 0.163081>,
      < 3.155772, -5.712716, 0.152194>
    }
    triangle {
      < 3.086810, -6.058038, 0.437816>,
      < 3.058576, -5.974609, 0.422769>,
      < 3.108755, -5.980817, 0.380630>
    }
    triangle {
      < 3.033125, -5.970796, 0.526716>,
      < 3.074996, -6.055424, 0.520714>,
      < 3.098142, -5.994081, 0.570921>
    }
    triangle {
      < 3.017643, -5.834864, 0.063272>,
      < 2.970495, -5.783869, 0.066662>,
      < 3.039448, -5.784328, 0.022500>
    }
    triangle {
      < 3.137688, -5.489302, -0.242971>,
      < 3.132356, -5.501740, -0.210948>,
      < 3.103222, -5.487276, -0.207282>
    }
    triangle {
      < 3.137688, -5.489302, -0.242971>,
      < 3.103222, -5.487276, -0.207282>,
      < 3.108019, -5.480084, -0.249201>
    }
    triangle {
      < 3.103222, -5.487276, -0.207282>,
      < 3.121146, -5.484527, -0.155941>,
      < 3.111749, -5.413926, -0.159047>
    }
    triangle {
      < 3.159483, -5.465992, -0.270949>,
      < 3.227041, -5.375122, -0.272112>,
      < 3.233992, -5.380470, -0.256286>
    }
    triangle {
      < 3.159483, -5.465992, -0.270949>,
      < 3.233992, -5.380470, -0.256286>,
      < 3.169059, -5.470934, -0.266738>
    }
    triangle {
      < 3.137688, -5.489302, -0.242971>,
      < 3.159483, -5.465992, -0.270949>,
      < 3.169059, -5.470934, -0.266738>
    }
    triangle {
      < 3.137688, -5.489302, -0.242971>,
      < 3.169059, -5.470934, -0.266738>,
      < 3.143772, -5.500243, -0.240001>
    }
    triangle {
      < 3.132356, -5.501740, -0.210948>,
      < 3.137688, -5.489302, -0.242971>,
      < 3.143772, -5.500243, -0.240001>
    }
    triangle {
      < 3.132356, -5.501740, -0.210948>,
      < 3.143772, -5.500243, -0.240001>,
      < 3.144734, -5.510552, -0.212819>
    }
    triangle {
      < 3.147821, -5.495047, -0.170164>,
      < 3.132356, -5.501740, -0.210948>,
      < 3.144734, -5.510552, -0.212819>
    }
    triangle {
      < 3.147821, -5.495047, -0.170164>,
      < 3.144734, -5.510552, -0.212819>,
      < 3.146878, -5.507833, -0.185383>
    }
    triangle {
      < 3.165883, -5.481662, -0.152199>,
      < 3.147821, -5.495047, -0.170164>,
      < 3.146878, -5.507833, -0.185383>
    }
    triangle {
      < 3.165883, -5.481662, -0.152199>,
      < 3.146878, -5.507833, -0.185383>,
      < 3.175271, -5.486119, -0.157501>
    }
    triangle {
      < 3.222092, -5.389814, -0.142920>,
      < 3.165883, -5.481662, -0.152199>,
      < 3.175271, -5.486119, -0.157501>
    }
    triangle {
      < 3.222092, -5.389814, -0.142920>,
      < 3.175271, -5.486119, -0.157501>,
      < 3.238530, -5.390752, -0.159403>
    }
    triangle {
      < 3.218018, -5.361663, -0.309225>,
      < 3.389684, -5.170204, -0.347680>,
      < 3.404628, -5.236587, -0.286603>
    }
    triangle {
      < 3.218018, -5.361663, -0.309225>,
      < 3.404628, -5.236587, -0.286603>,
      < 3.242743, -5.367341, -0.267206>
    }
    triangle {
      < 3.218018, -5.361663, -0.309225>,
      < 3.242743, -5.367341, -0.267206>,
      < 3.227041, -5.375122, -0.272112>
    }
    triangle {
      < 3.242743, -5.367341, -0.267206>,
      < 3.404628, -5.236587, -0.286603>,
      < 3.452394, -5.270232, -0.219996>
    }
    triangle {
      < 3.242743, -5.367341, -0.267206>,
      < 3.452394, -5.270232, -0.219996>,
      < 3.293084, -5.396710, -0.214851>
    }
    triangle {
      < 3.293084, -5.396710, -0.214851>,
      < 3.452394, -5.270232, -0.219996>,
      < 3.427206, -5.250150, -0.136576>
    }
    triangle {
      < 3.293084, -5.396710, -0.214851>,
      < 3.427206, -5.250150, -0.136576>,
      < 3.253295, -5.378718, -0.152609>
    }
    triangle {
      < 3.253295, -5.378718, -0.152609>,
      < 3.427206, -5.250150, -0.136576>,
      < 3.375304, -5.186841, -0.084050>
    }
    triangle {
      < 3.253295, -5.378718, -0.152609>,
      < 3.375304, -5.186841, -0.084050>,
      < 3.189222, -5.387946, -0.109955>
    }
    triangle {
      < 3.253295, -5.378718, -0.152609>,
      < 3.189222, -5.387946, -0.109955>,
      < 3.222092, -5.389814, -0.142920>
    }
    triangle {
      < 3.091261, -5.417274, -0.244750>,
      < 3.108019, -5.480084, -0.249201>,
      < 3.103222, -5.487276, -0.207282>
    }
    triangle {
      < 3.121146, -5.484527, -0.155941>,
      < 3.103222, -5.487276, -0.207282>,
      < 3.132356, -5.501740, -0.210948>
    }
    triangle {
      < 3.121146, -5.484527, -0.155941>,
      < 3.132356, -5.501740, -0.210948>,
      < 3.147821, -5.495047, -0.170164>
    }
    triangle {
      < 3.137978, -5.462011, -0.134840>,
      < 3.121146, -5.484527, -0.155941>,
      < 3.147821, -5.495047, -0.170164>
    }
    triangle {
      < 3.137978, -5.462011, -0.134840>,
      < 3.147821, -5.495047, -0.170164>,
      < 3.165883, -5.481662, -0.152199>
    }
    triangle {
      < 2.993125, -5.820805, 0.134664>,
      < 2.970495, -5.783869, 0.066662>,
      < 3.004417, -5.843048, 0.100626>
    }
    triangle {
      < 2.970495, -5.783869, 0.066662>,
      < 2.993125, -5.820805, 0.134664>,
      < 2.980297, -5.779233, 0.151208>
    }
    triangle {
      < 3.505869, -6.028747, 0.966244>,
      < 3.505432, -6.057985, 0.920378>,
      < 3.518012, -6.067028, 0.920041>
    }
    triangle {
      < 3.505869, -6.028747, 0.966244>,
      < 3.518012, -6.067028, 0.920041>,
      < 3.522264, -6.025560, 0.965866>
    }
    triangle {
      < 3.562773, -6.024592, 0.815694>,
      < 3.538268, -6.066545, 0.844955>,
      < 3.523629, -6.052359, 0.836901>
    }
    triangle {
      < 3.562773, -6.024592, 0.815694>,
      < 3.523629, -6.052359, 0.836901>,
      < 3.534503, -6.017144, 0.802934>
    }
    triangle {
      < 3.513249, -6.071916, 0.875409>,
      < 3.523629, -6.052359, 0.836901>,
      < 3.538268, -6.066545, 0.844955>
    }
    triangle {
      < 3.513249, -6.071916, 0.875409>,
      < 3.538268, -6.066545, 0.844955>,
      < 3.531293, -6.078069, 0.882219>
    }
    triangle {
      < 3.624970, -5.907471, 0.927947>,
      < 3.701282, -5.729109, 0.969850>,
      < 3.632454, -5.713002, 1.037336>
    }
    triangle {
      < 3.624970, -5.907471, 0.927947>,
      < 3.632454, -5.713002, 1.037336>,
      < 3.553595, -5.892168, 0.986735>
    }
    triangle {
      < 3.553595, -5.892168, 0.986735>,
      < 3.632454, -5.713002, 1.037336>,
      < 3.545418, -5.692355, 1.088168>
    }
    triangle {
      < 3.553595, -5.892168, 0.986735>,
      < 3.545418, -5.692355, 1.088168>,
      < 3.492407, -5.893525, 1.037085>
    }
    triangle {
      < 3.553595, -5.892168, 0.986735>,
      < 3.492407, -5.893525, 1.037085>,
      < 3.531374, -5.903006, 0.994906>
    }
    triangle {
      < 3.505869, -6.028747, 0.966244>,
      < 3.531374, -5.903006, 0.994906>,
      < 3.492407, -5.893525, 1.037085>
    }
    triangle {
      < 3.505869, -6.028747, 0.966244>,
      < 3.492407, -5.893525, 1.037085>,
      < 3.473088, -6.035122, 0.967001>
    }
    triangle {
      < 3.505432, -6.057985, 0.920378>,
      < 3.505869, -6.028747, 0.966244>,
      < 3.473088, -6.035122, 0.967001>
    }
    triangle {
      < 3.505432, -6.057985, 0.920378>,
      < 3.473088, -6.035122, 0.967001>,
      < 3.445156, -6.069401, 0.925751>
    }
    triangle {
      < 3.513249, -6.071916, 0.875409>,
      < 3.505432, -6.057985, 0.920378>,
      < 3.445156, -6.069401, 0.925751>
    }
    triangle {
      < 3.513249, -6.071916, 0.875409>,
      < 3.445156, -6.069401, 0.925751>,
      < 3.482244, -6.080278, 0.862983>
    }
    triangle {
      < 3.523629, -6.052359, 0.836901>,
      < 3.513249, -6.071916, 0.875409>,
      < 3.482244, -6.080278, 0.862983>
    }
    triangle {
      < 3.523629, -6.052359, 0.836901>,
      < 3.482244, -6.080278, 0.862983>,
      < 3.479325, -6.050067, 0.813931>
    }
    triangle {
      < 3.534503, -6.017144, 0.802934>,
      < 3.523629, -6.052359, 0.836901>,
      < 3.479325, -6.050067, 0.813931>
    }
    triangle {
      < 3.534503, -6.017144, 0.802934>,
      < 3.479325, -6.050067, 0.813931>,
      < 3.477974, -6.002246, 0.777414>
    }
    triangle {
      < 3.572496, -5.890628, 0.808892>,
      < 3.534503, -6.017144, 0.802934>,
      < 3.477974, -6.002246, 0.777414>
    }
    triangle {
      < 3.572496, -5.890628, 0.808892>,
      < 3.477974, -6.002246, 0.777414>,
      < 3.505699, -5.855872, 0.747989>
    }
    triangle {
      < 3.505699, -5.855872, 0.747989>,
      < 3.553799, -5.655422, 0.761295>,
      < 3.683643, -5.717794, 0.871465>
    }
    triangle {
      < 3.505699, -5.855872, 0.747989>,
      < 3.683643, -5.717794, 0.871465>,
      < 3.609701, -5.892986, 0.836394>
    }
    triangle {
      < 3.505699, -5.855872, 0.747989>,
      < 3.609701, -5.892986, 0.836394>,
      < 3.572496, -5.890628, 0.808892>
    }
    triangle {
      < 3.609701, -5.892986, 0.836394>,
      < 3.683643, -5.717794, 0.871465>,
      < 3.701282, -5.729109, 0.969850>
    }
    triangle {
      < 3.609701, -5.892986, 0.836394>,
      < 3.701282, -5.729109, 0.969850>,
      < 3.624970, -5.907471, 0.927947>
    }
    triangle {
      < 3.445156, -6.069401, 0.925751>,
      < 3.473088, -6.035122, 0.967001>,
      < 3.413736, -6.028965, 0.915567>
    }
    triangle {
      < 3.482244, -6.080278, 0.862983>,
      < 3.445156, -6.069401, 0.925751>,
      < 3.413736, -6.028965, 0.915567>
    }
    triangle {
      < 2.791797, -4.524917, 1.292616>,
      < 2.849420, -4.258226, 1.321365>,
      < 2.756208, -4.246720, 1.254495>
    }
    triangle {
      < 2.791797, -4.524917, 1.292616>,
      < 2.756208, -4.246720, 1.254495>,
      < 2.711608, -4.528833, 1.228295>
    }
    triangle {
      < 2.747367, -4.744814, 1.283339>,
      < 2.791797, -4.524917, 1.292616>,
      < 2.711608, -4.528833, 1.228295>
    }
    triangle {
      < 2.747367, -4.744814, 1.283339>,
      < 2.711608, -4.528833, 1.228295>,
      < 2.668286, -4.735597, 1.220260>
    }
    triangle {
      < 2.716361, -5.024138, 1.237795>,
      < 2.641750, -5.009909, 1.175060>,
      < 2.641492, -5.023551, 1.151718>
    }
    triangle {
      < 2.716361, -5.024138, 1.237795>,
      < 2.641492, -5.023551, 1.151718>,
      < 2.709860, -5.038414, 1.211770>
    }
    triangle {
      < 2.697364, -5.274925, 1.189184>,
      < 2.709860, -5.038414, 1.211770>,
      < 2.641492, -5.023551, 1.151718>
    }
    triangle {
      < 2.697364, -5.274925, 1.189184>,
      < 2.641492, -5.023551, 1.151718>,
      < 2.631475, -5.189024, 1.144910>
    }
    triangle {
      < 2.697364, -5.274925, 1.189184>,
      < 2.631475, -5.189024, 1.144910>,
      < 2.668019, -5.252569, 1.168923>
    }
    triangle {
      < 2.849420, -4.258226, 1.321365>,
      < 2.903923, -3.680026, 1.129989>,
      < 2.756208, -4.246720, 1.254495>
    }
    triangle {
      < 2.631475, -5.189024, 1.144910>,
      < 2.637240, -5.188992, 1.115963>,
      < 2.676505, -5.230327, 1.135723>
    }
    triangle {
      < 2.631475, -5.189024, 1.144910>,
      < 2.676505, -5.230327, 1.135723>,
      < 2.668019, -5.252569, 1.168923>
    }
    triangle {
      < 2.798819, -5.210745, 1.199050>,
      < 2.794990, -5.219936, 1.222509>,
      < 2.756707, -5.252022, 1.199861>
    }
    triangle {
      < 2.798819, -5.210745, 1.199050>,
      < 2.756707, -5.252022, 1.199861>,
      < 2.759147, -5.241912, 1.167365>
    }
    triangle {
      < 2.697364, -5.274925, 1.189184>,
      < 2.759147, -5.241912, 1.167365>,
      < 2.756707, -5.252022, 1.199861>
    }
    triangle {
      < 2.668019, -5.252569, 1.168923>,
      < 2.676505, -5.230327, 1.135723>,
      < 2.697364, -5.274925, 1.189184>
    }
    triangle {
      < 2.759147, -5.241912, 1.167365>,
      < 2.697364, -5.274925, 1.189184>,
      < 2.676505, -5.230327, 1.135723>
    }
    triangle {
      < 2.815561, -5.029976, 1.234091>,
      < 2.832069, -5.040146, 1.196513>,
      < 2.899959, -5.015127, 1.172929>
    }
    triangle {
      < 2.815561, -5.029976, 1.234091>,
      < 2.899959, -5.015127, 1.172929>,
      < 3.003325, -4.727902, 1.148698>
    }
    triangle {
      < 2.815561, -5.029976, 1.234091>,
      < 3.003325, -4.727902, 1.148698>,
      < 2.857244, -4.750984, 1.276291>
    }
    triangle {
      < 2.716361, -5.024138, 1.237795>,
      < 2.815561, -5.029976, 1.234091>,
      < 2.857244, -4.750984, 1.276291>
    }
    triangle {
      < 2.716361, -5.024138, 1.237795>,
      < 2.857244, -4.750984, 1.276291>,
      < 2.747367, -4.744814, 1.283339>
    }
    triangle {
      < 2.641750, -5.009909, 1.175060>,
      < 2.716361, -5.024138, 1.237795>,
      < 2.747367, -4.744814, 1.283339>
    }
    triangle {
      < 2.641750, -5.009909, 1.175060>,
      < 2.747367, -4.744814, 1.283339>,
      < 2.668286, -4.735597, 1.220260>
    }
    triangle {
      < 2.631430, -5.021671, 1.121294>,
      < 2.641750, -5.009909, 1.175060>,
      < 2.668286, -4.735597, 1.220260>
    }
    triangle {
      < 2.631430, -5.021671, 1.121294>,
      < 2.668286, -4.735597, 1.220260>,
      < 2.643964, -4.725788, 1.080201>
    }
    triangle {
      < 2.631430, -5.021671, 1.121294>,
      < 2.643964, -4.725788, 1.080201>,
      < 2.606242, -4.997890, 1.062551>
    }
    triangle {
      < 2.637240, -5.188992, 1.115963>,
      < 2.631430, -5.021671, 1.121294>,
      < 2.606242, -4.997890, 1.062551>
    }
    triangle {
      < 2.637240, -5.188992, 1.115963>,
      < 2.606242, -4.997890, 1.062551>,
      < 2.671290, -5.134576, 1.004575>
    }
    triangle {
      < 2.823724, -5.203536, 1.130062>,
      < 2.899959, -5.015127, 1.172929>,
      < 2.832069, -5.040146, 1.196513>
    }
    triangle {
      < 2.823724, -5.203536, 1.130062>,
      < 2.832069, -5.040146, 1.196513>,
      < 2.798819, -5.210745, 1.199050>
    }
    triangle {
      < 2.823724, -5.203536, 1.130062>,
      < 2.671290, -5.134576, 1.004575>,
      < 2.839635, -5.003333, 0.986344>
    }
    triangle {
      < 2.839635, -5.003333, 0.986344>,
      < 2.671290, -5.134576, 1.004575>,
      < 2.676981, -5.016549, 0.977451>
    }
    triangle {
      < 2.671290, -5.134576, 1.004575>,
      < 2.676505, -5.230327, 1.135723>,
      < 2.637240, -5.188992, 1.115963>
    }
    triangle {
      < 2.671290, -5.134576, 1.004575>,
      < 2.606242, -4.997890, 1.062551>,
      < 2.676981, -5.016549, 0.977451>
    }
    triangle {
      < 3.599305, -3.225931, -0.043476>,
      < 3.722475, -2.954857, -0.047674>,
      < 3.752286, -3.343208, 0.085041>
    }
    triangle {
      < 1.972370, 1.836697, 0.565753>,
      < 2.263130, 0.883407, 0.490936>,
      < 2.598399, 1.087355, 0.771866>
    }
    triangle {
      < 1.972370, 1.836697, 0.565753>,
      < 2.598399, 1.087355, 0.771866>,
      < 2.389562, 2.108848, 0.916315>
    }
    triangle {
      < 2.428253, 1.875464, -0.657165>,
      < 2.695315, 0.795125, -0.528766>,
      < 2.509296, 0.791452, -0.366753>
    }
    triangle {
      < 2.428253, 1.875464, -0.657165>,
      < 2.509296, 0.791452, -0.366753>,
      < 2.143766, 1.777314, -0.509196>
    }
    triangle {
      < 3.272733, 2.381291, 0.328889>,
      < 3.390432, 0.999678, 0.681287>,
      < 3.501794, 0.872930, 0.183442>
    }
    triangle {
      < 3.272733, 2.381291, 0.328889>,
      < 3.501794, 0.872930, 0.183442>,
      < 3.449607, 2.346718, -0.186191>
    }
    triangle {
      < 3.044701, 0.253003, -0.572372>,
      < 2.698462, 0.226836, -0.462052>,
      < 2.695315, 0.795125, -0.528766>
    }
    triangle {
      < 3.044701, 0.253003, -0.572372>,
      < 2.695315, 0.795125, -0.528766>,
      < 3.014387, 0.793627, -0.615524>
    }
    triangle {
      < 2.216184, 0.190357, 0.053862>,
      < 2.311565, 0.195061, 0.464117>,
      < 2.263130, 0.883407, 0.490936>
    }
    triangle {
      < 2.216184, 0.190357, 0.053862>,
      < 2.263130, 0.883407, 0.490936>,
      < 2.209945, 0.778184, 0.038156>
    }
    triangle {
      < 3.540532, 0.306510, 0.212961>,
      < 3.342636, 0.270231, -0.195426>,
      < 3.265405, 0.844826, -0.361207>
    }
    triangle {
      < 3.540532, 0.306510, 0.212961>,
      < 3.265405, 0.844826, -0.361207>,
      < 3.501794, 0.872930, 0.183442>
    }
    triangle {
      < 3.014387, 0.793627, -0.615524>,
      < 2.746782, 2.012204, -0.739545>,
      < 3.206557, 2.266230, -0.609586>
    }
    triangle {
      < 3.014387, 0.793627, -0.615524>,
      < 3.206557, 2.266230, -0.609586>,
      < 3.265405, 0.844826, -0.361207>
    }
    triangle {
      < 2.165084, 3.125649, -0.780297>,
      < 2.639934, 3.343994, -0.854432>,
      < 2.746782, 2.012204, -0.739545>
    }
    triangle {
      < 2.165084, 3.125649, -0.780297>,
      < 2.746782, 2.012204, -0.739545>,
      < 2.428253, 1.875464, -0.657165>
    }
    triangle {
      < 2.639934, 3.343994, -0.854432>,
      < 2.996337, 3.476492, -0.710395>,
      < 3.206557, 2.266230, -0.609586>
    }
    triangle {
      < 2.639934, 3.343994, -0.854432>,
      < 3.206557, 2.266230, -0.609586>,
      < 2.746782, 2.012204, -0.739545>
    }
    triangle {
      < 2.725005, 3.444355, 0.907791>,
      < 2.256229, 3.153966, 0.978039>,
      < 2.389562, 2.108848, 0.916315>
    }
    triangle {
      < 2.725005, 3.444355, 0.907791>,
      < 2.389562, 2.108848, 0.916315>,
      < 2.888019, 2.319817, 0.752916>
    }
    triangle {
      < 2.256229, 3.153966, 0.978039>,
      < 1.701408, 2.969087, 0.537007>,
      < 1.972370, 1.836697, 0.565753>
    }
    triangle {
      < 2.256229, 3.153966, 0.978039>,
      < 1.972370, 1.836697, 0.565753>,
      < 2.389562, 2.108848, 0.916315>
    }
    triangle {
      < 1.701408, 2.969087, 0.537007>,
      < 1.634357, 2.874438, 0.030700>,
      < 1.912222, 1.693259, 0.090164>
    }
    triangle {
      < 1.701408, 2.969087, 0.537007>,
      < 1.912222, 1.693259, 0.090164>,
      < 1.972370, 1.836697, 0.565753>
    }
    triangle {
      < 1.634357, 2.874438, 0.030700>,
      < 1.918431, 2.981536, -0.605970>,
      < 2.143766, 1.777314, -0.509196>
    }
    triangle {
      < 1.634357, 2.874438, 0.030700>,
      < 2.143766, 1.777314, -0.509196>,
      < 1.912222, 1.693259, 0.090164>
    }
    triangle {
      < 1.918431, 2.981536, -0.605970>,
      < 2.165084, 3.125649, -0.780297>,
      < 2.428253, 1.875464, -0.657165>
    }
    triangle {
      < 1.918431, 2.981536, -0.605970>,
      < 2.428253, 1.875464, -0.657165>,
      < 2.143766, 1.777314, -0.509196>
    }
    triangle {
      < 3.449607, 2.346718, -0.186191>,
      < 3.206557, 2.266230, -0.609586>,
      < 2.996337, 3.476492, -0.710395>
    }
    triangle {
      < 3.449607, 2.346718, -0.186191>,
      < 2.996337, 3.476492, -0.710395>,
      < 3.250841, 3.550476, -0.160077>
    }
    triangle {
      < 3.075922, 0.958967, 0.780647>,
      < 2.888019, 2.319817, 0.752916>,
      < 2.389562, 2.108848, 0.916315>
    }
    triangle {
      < 3.075922, 0.958967, 0.780647>,
      < 2.389562, 2.108848, 0.916315>,
      < 2.598399, 1.087355, 0.771866>
    }
    triangle {
      < 3.075922, 0.958967, 0.780647>,
      < 3.390432, 0.999678, 0.681287>,
      < 3.272733, 2.381291, 0.328889>
    }
    triangle {
      < 3.075922, 0.958967, 0.780647>,
      < 3.272733, 2.381291, 0.328889>,
      < 2.888019, 2.319817, 0.752916>
    }
    triangle {
      < 2.263130, 0.883407, 0.490936>,
      < 1.972370, 1.836697, 0.565753>,
      < 1.912222, 1.693259, 0.090164>
    }
    triangle {
      < 2.263130, 0.883407, 0.490936>,
      < 1.912222, 1.693259, 0.090164>,
      < 2.209945, 0.778184, 0.038156>
    }
    triangle {
      < 2.209945, 0.778184, 0.038156>,
      < 1.912222, 1.693259, 0.090164>,
      < 2.143766, 1.777314, -0.509196>
    }
    triangle {
      < 2.209945, 0.778184, 0.038156>,
      < 2.143766, 1.777314, -0.509196>,
      < 2.509296, 0.791452, -0.366753>
    }
    triangle {
      < 3.449607, 2.346718, -0.186191>,
      < 3.501794, 0.872930, 0.183442>,
      < 3.265405, 0.844826, -0.361207>
    }
    triangle {
      < 3.449607, 2.346718, -0.186191>,
      < 3.265405, 0.844826, -0.361207>,
      < 3.206557, 2.266230, -0.609586>
    }
    triangle {
      < 2.695315, 0.795125, -0.528766>,
      < 2.428253, 1.875464, -0.657165>,
      < 2.746782, 2.012204, -0.739545>
    }
    triangle {
      < 2.695315, 0.795125, -0.528766>,
      < 2.746782, 2.012204, -0.739545>,
      < 3.014387, 0.793627, -0.615524>
    }
    triangle {
      < 2.888019, 2.319817, 0.752916>,
      < 3.272733, 2.381291, 0.328889>,
      < 3.084058, 3.588311, 0.444890>
    }
    triangle {
      < 2.888019, 2.319817, 0.752916>,
      < 3.084058, 3.588311, 0.444890>,
      < 2.725005, 3.444355, 0.907791>
    }
    triangle {
      < 3.272733, 2.381291, 0.328889>,
      < 3.449607, 2.346718, -0.186191>,
      < 3.250841, 3.550476, -0.160077>
    }
    triangle {
      < 3.272733, 2.381291, 0.328889>,
      < 3.250841, 3.550476, -0.160077>,
      < 3.084058, 3.588311, 0.444890>
    }
    triangle {
      < 3.584816, -0.259706, 0.871421>,
      < 3.536503, 0.279278, 0.840728>,
      < 3.044585, 0.246167, 0.965609>
    }
    triangle {
      < 3.584816, -0.259706, 0.871421>,
      < 3.044585, 0.246167, 0.965609>,
      < 3.079602, -0.272644, 0.990726>
    }
    triangle {
      < 3.079602, -0.272644, 0.990726>,
      < 3.044585, 0.246167, 0.965609>,
      < 2.593155, 0.210968, 0.846518>
    }
    triangle {
      < 3.079602, -0.272644, 0.990726>,
      < 2.593155, 0.210968, 0.846518>,
      < 2.599851, -0.304157, 0.877433>
    }
    triangle {
      < 2.270152, -0.378846, 0.098363>,
      < 2.216184, 0.190357, 0.053862>,
      < 2.367596, 0.201567, -0.269846>
    }
    triangle {
      < 2.270152, -0.378846, 0.098363>,
      < 2.367596, 0.201567, -0.269846>,
      < 2.377485, -0.347431, -0.200958>
    }
    triangle {
      < 2.377485, -0.347431, -0.200958>,
      < 2.367596, 0.201567, -0.269846>,
      < 2.698462, 0.226836, -0.462052>
    }
    triangle {
      < 2.377485, -0.347431, -0.200958>,
      < 2.698462, 0.226836, -0.462052>,
      < 2.692744, -0.302287, -0.429027>
    }
    triangle {
      < 2.698462, 0.226836, -0.462052>,
      < 3.044701, 0.253003, -0.572372>,
      < 3.150655, -0.294560, -0.511985>
    }
    triangle {
      < 2.698462, 0.226836, -0.462052>,
      < 3.150655, -0.294560, -0.511985>,
      < 2.692744, -0.302287, -0.429027>
    }
    triangle {
      < 3.493797, -0.241574, -0.177637>,
      < 3.150655, -0.294560, -0.511985>,
      < 3.044701, 0.253003, -0.572372>
    }
    triangle {
      < 3.493797, -0.241574, -0.177637>,
      < 3.044701, 0.253003, -0.572372>,
      < 3.342636, 0.270231, -0.195426>
    }
    triangle {
      < 3.493797, -0.241574, -0.177637>,
      < 3.342636, 0.270231, -0.195426>,
      < 3.540532, 0.306510, 0.212961>
    }
    triangle {
      < 3.493797, -0.241574, -0.177637>,
      < 3.540532, 0.306510, 0.212961>,
      < 3.644981, -0.239785, 0.250997>
    }
    triangle {
      < 3.644981, -0.239785, 0.250997>,
      < 3.540532, 0.306510, 0.212961>,
      < 3.607651, 0.297461, 0.466432>
    }
    triangle {
      < 3.644981, -0.239785, 0.250997>,
      < 3.607651, 0.297461, 0.466432>,
      < 3.704188, -0.251920, 0.601294>
    }
    triangle {
      < 3.704188, -0.251920, 0.601294>,
      < 3.607651, 0.297461, 0.466432>,
      < 3.536503, 0.279278, 0.840728>
    }
    triangle {
      < 3.704188, -0.251920, 0.601294>,
      < 3.536503, 0.279278, 0.840728>,
      < 3.584816, -0.259706, 0.871421>
    }
    triangle {
      < 2.311565, 0.195061, 0.464117>,
      < 2.216184, 0.190357, 0.053862>,
      < 2.270152, -0.378846, 0.098363>
    }
    triangle {
      < 2.311565, 0.195061, 0.464117>,
      < 2.270152, -0.378846, 0.098363>,
      < 2.374817, -0.345360, 0.504614>
    }
    triangle {
      < 2.311565, 0.195061, 0.464117>,
      < 2.374817, -0.345360, 0.504614>,
      < 2.599851, -0.304157, 0.877433>
    }
    triangle {
      < 2.311565, 0.195061, 0.464117>,
      < 2.599851, -0.304157, 0.877433>,
      < 2.593155, 0.210968, 0.846518>
    }
    triangle {
      < 3.044585, 0.246167, 0.965609>,
      < 3.536503, 0.279278, 0.840728>,
      < 3.390432, 0.999678, 0.681287>
    }
    triangle {
      < 3.044585, 0.246167, 0.965609>,
      < 3.390432, 0.999678, 0.681287>,
      < 3.075922, 0.958967, 0.780647>
    }
    triangle {
      < 3.536503, 0.279278, 0.840728>,
      < 3.607651, 0.297461, 0.466432>,
      < 3.501794, 0.872930, 0.183442>
    }
    triangle {
      < 3.536503, 0.279278, 0.840728>,
      < 3.501794, 0.872930, 0.183442>,
      < 3.390432, 0.999678, 0.681287>
    }
    triangle {
      < 3.607651, 0.297461, 0.466432>,
      < 3.540532, 0.306510, 0.212961>,
      < 3.501794, 0.872930, 0.183442>
    }
    triangle {
      < 3.342636, 0.270231, -0.195426>,
      < 3.044701, 0.253003, -0.572372>,
      < 3.014387, 0.793627, -0.615524>
    }
    triangle {
      < 3.342636, 0.270231, -0.195426>,
      < 3.014387, 0.793627, -0.615524>,
      < 3.265405, 0.844826, -0.361207>
    }
    triangle {
      < 2.698462, 0.226836, -0.462052>,
      < 2.367596, 0.201567, -0.269846>,
      < 2.509296, 0.791452, -0.366753>
    }
    triangle {
      < 2.698462, 0.226836, -0.462052>,
      < 2.509296, 0.791452, -0.366753>,
      < 2.695315, 0.795125, -0.528766>
    }
    triangle {
      < 2.367596, 0.201567, -0.269846>,
      < 2.216184, 0.190357, 0.053862>,
      < 2.209945, 0.778184, 0.038156>
    }
    triangle {
      < 2.367596, 0.201567, -0.269846>,
      < 2.209945, 0.778184, 0.038156>,
      < 2.509296, 0.791452, -0.366753>
    }
    triangle {
      < 2.311565, 0.195061, 0.464117>,
      < 2.593155, 0.210968, 0.846518>,
      < 2.598399, 1.087355, 0.771866>
    }
    triangle {
      < 2.311565, 0.195061, 0.464117>,
      < 2.598399, 1.087355, 0.771866>,
      < 2.263130, 0.883407, 0.490936>
    }
    triangle {
      < 2.593155, 0.210968, 0.846518>,
      < 3.044585, 0.246167, 0.965609>,
      < 3.075922, 0.958967, 0.780647>
    }
    triangle {
      < 2.593155, 0.210968, 0.846518>,
      < 3.075922, 0.958967, 0.780647>,
      < 2.598399, 1.087355, 0.771866>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.786055, 4.724414, 0.056300>,
      < 0.804378, 4.755525, -0.102882>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.804378, 4.755525, -0.102882>,
      < 0.781006, 4.690696, -0.246708>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.781006, 4.690696, -0.246708>,
      < 0.742740, 4.598918, -0.284237>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.742740, 4.598918, -0.284237>,
      < 0.688163, 4.473297, -0.264860>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.688163, 4.473297, -0.264860>,
      < 0.657583, 4.405418, -0.219440>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.657583, 4.405418, -0.219440>,
      < 0.621848, 4.334342, -0.052589>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.621848, 4.334342, -0.052589>,
      < 0.628688, 4.359907, 0.080430>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.628688, 4.359907, 0.080430>,
      < 0.685862, 4.501311, 0.195476>
    }
    triangle {
      < 1.550448, 3.319478, 0.523618>,
      < 1.490032, 3.238568, 0.016042>,
      < 1.634357, 2.874438, 0.030700>
    }
    triangle {
      < 1.550448, 3.319478, 0.523618>,
      < 1.634357, 2.874438, 0.030700>,
      < 1.701408, 2.969087, 0.537007>
    }
    triangle {
      < 1.490032, 3.238568, 0.016042>,
      < 1.717249, 3.439875, -0.620639>,
      < 1.918431, 2.981536, -0.605970>
    }
    triangle {
      < 1.490032, 3.238568, 0.016042>,
      < 1.918431, 2.981536, -0.605970>,
      < 1.634357, 2.874438, 0.030700>
    }
    triangle {
      < 1.717249, 3.439875, -0.620639>,
      < 1.921670, 3.637146, -0.793953>,
      < 2.165084, 3.125649, -0.780297>
    }
    triangle {
      < 1.717249, 3.439875, -0.620639>,
      < 2.165084, 3.125649, -0.780297>,
      < 1.918431, 2.981536, -0.605970>
    }
    triangle {
      < 1.921670, 3.637146, -0.793953>,
      < 2.292840, 4.005073, -0.867892>,
      < 2.639934, 3.343994, -0.854432>
    }
    triangle {
      < 1.921670, 3.637146, -0.793953>,
      < 2.639934, 3.343994, -0.854432>,
      < 2.165084, 3.125649, -0.780297>
    }
    triangle {
      < 2.292840, 4.005073, -0.867892>,
      < 2.558318, 4.276166, -0.724688>,
      < 2.996337, 3.476492, -0.710395>
    }
    triangle {
      < 2.292840, 4.005073, -0.867892>,
      < 2.996337, 3.476492, -0.710395>,
      < 2.639934, 3.343994, -0.854432>
    }
    triangle {
      < 2.558318, 4.276166, -0.724688>,
      < 2.732883, 4.472814, -0.175871>,
      < 3.250841, 3.550476, -0.160077>
    }
    triangle {
      < 2.558318, 4.276166, -0.724688>,
      < 3.250841, 3.550476, -0.160077>,
      < 2.996337, 3.476492, -0.710395>
    }
    triangle {
      < 2.732883, 4.472814, -0.175871>,
      < 2.623926, 4.388504, 0.431542>,
      < 3.084058, 3.588311, 0.444890>
    }
    triangle {
      < 2.732883, 4.472814, -0.175871>,
      < 3.084058, 3.588311, 0.444890>,
      < 3.250841, 3.550476, -0.160077>
    }
    triangle {
      < 2.623926, 4.388504, 0.431542>,
      < 2.341161, 4.124658, 0.894512>,
      < 2.725005, 3.444355, 0.907791>
    }
    triangle {
      < 2.623926, 4.388504, 0.431542>,
      < 2.725005, 3.444355, 0.907791>,
      < 3.084058, 3.588311, 0.444890>
    }
    triangle {
      < 2.341161, 4.124658, 0.894512>,
      < 1.953159, 3.739673, 0.962616>,
      < 2.256229, 3.153966, 0.978039>
    }
    triangle {
      < 2.341161, 4.124658, 0.894512>,
      < 2.256229, 3.153966, 0.978039>,
      < 2.725005, 3.444355, 0.907791>
    }
    triangle {
      < 1.953159, 3.739673, 0.962616>,
      < 1.550448, 3.319478, 0.523618>,
      < 1.701408, 2.969087, 0.537007>
    }
    triangle {
      < 1.953159, 3.739673, 0.962616>,
      < 1.701408, 2.969087, 0.537007>,
      < 2.256229, 3.153966, 0.978039>
    }
    triangle {
      < 2.148929, 4.732874, 0.418104>,
      < 1.921392, 4.435579, 0.874178>,
      < 2.341161, 4.124658, 0.894512>
    }
    triangle {
      < 2.148929, 4.732874, 0.418104>,
      < 2.341161, 4.124658, 0.894512>,
      < 2.623926, 4.388504, 0.431542>
    }
    triangle {
      < 1.921392, 4.435579, 0.874178>,
      < 1.613344, 4.007860, 0.941017>,
      < 1.953159, 3.739673, 0.962616>
    }
    triangle {
      < 1.921392, 4.435579, 0.874178>,
      < 1.953159, 3.739673, 0.962616>,
      < 2.341161, 4.124658, 0.894512>
    }
    triangle {
      < 1.613344, 4.007860, 0.941017>,
      < 1.295038, 3.541559, 0.508972>,
      < 1.550448, 3.319478, 0.523618>
    }
    triangle {
      < 1.613344, 4.007860, 0.941017>,
      < 1.550448, 3.319478, 0.523618>,
      < 1.953159, 3.739673, 0.962616>
    }
    triangle {
      < 1.295038, 3.541559, 0.508972>,
      < 1.250166, 3.455350, 0.011792>,
      < 1.490032, 3.238568, 0.016042>
    }
    triangle {
      < 1.295038, 3.541559, 0.508972>,
      < 1.490032, 3.238568, 0.016042>,
      < 1.550448, 3.319478, 0.523618>
    }
    triangle {
      < 1.250166, 3.455350, 0.011792>,
      < 1.434622, 3.670614, -0.616165>,
      < 1.717249, 3.439875, -0.620639>
    }
    triangle {
      < 1.250166, 3.455350, 0.011792>,
      < 1.717249, 3.439875, -0.620639>,
      < 1.490032, 3.238568, 0.016042>
    }
    triangle {
      < 1.434622, 3.670614, -0.616165>,
      < 1.597707, 3.890364, -0.785028>,
      < 1.921670, 3.637146, -0.793953>
    }
    triangle {
      < 1.434622, 3.670614, -0.616165>,
      < 1.921670, 3.637146, -0.793953>,
      < 1.717249, 3.439875, -0.620639>
    }
    triangle {
      < 1.597707, 3.890364, -0.785028>,
      < 1.894666, 4.302699, -0.858074>,
      < 2.292840, 4.005073, -0.867892>
    }
    triangle {
      < 1.597707, 3.890364, -0.785028>,
      < 2.292840, 4.005073, -0.867892>,
      < 1.921670, 3.637146, -0.793953>
    }
    triangle {
      < 1.894666, 4.302699, -0.858074>,
      < 2.104079, 4.601659, -0.719015>,
      < 2.558318, 4.276166, -0.724688>
    }
    triangle {
      < 1.894666, 4.302699, -0.858074>,
      < 2.558318, 4.276166, -0.724688>,
      < 2.292840, 4.005073, -0.867892>
    }
    triangle {
      < 2.104079, 4.601659, -0.719015>,
      < 2.240090, 4.831474, -0.180282>,
      < 2.732883, 4.472814, -0.175871>
    }
    triangle {
      < 2.104079, 4.601659, -0.719015>,
      < 2.732883, 4.472814, -0.175871>,
      < 2.558318, 4.276166, -0.724688>
    }
    triangle {
      < 2.240090, 4.831474, -0.180282>,
      < 2.148929, 4.732874, 0.418104>,
      < 2.623926, 4.388504, 0.431542>
    }
    triangle {
      < 2.240090, 4.831474, -0.180282>,
      < 2.623926, 4.388504, 0.431542>,
      < 2.732883, 4.472814, -0.175871>
    }
    triangle {
      < 0.981854, 4.602366, -0.642257>,
      < 1.083963, 4.847274, -0.542113>,
      < 1.542589, 4.823540, -0.713341>
    }
    triangle {
      < 0.981854, 4.602366, -0.642257>,
      < 1.542589, 4.823540, -0.713341>,
      < 1.403898, 4.490224, -0.848257>
    }
    triangle {
      < 1.083963, 4.847274, -0.542113>,
      < 1.146336, 5.020259, -0.158321>,
      < 1.627299, 5.061404, -0.184693>
    }
    triangle {
      < 1.083963, 4.847274, -0.542113>,
      < 1.627299, 5.061404, -0.184693>,
      < 1.542589, 4.823540, -0.713341>
    }
    triangle {
      < 1.146336, 5.020259, -0.158321>,
      < 1.097437, 4.937255, 0.266447>,
      < 1.559017, 4.945367, 0.404666>
    }
    triangle {
      < 1.146336, 5.020259, -0.158321>,
      < 1.559017, 4.945367, 0.404666>,
      < 1.627299, 5.061404, -0.184693>
    }
    triangle {
      < 1.097437, 4.937255, 0.266447>,
      < 0.982223, 4.692563, 0.590206>,
      < 1.401560, 4.607304, 0.853844>
    }
    triangle {
      < 1.097437, 4.937255, 0.266447>,
      < 1.401560, 4.607304, 0.853844>,
      < 1.559017, 4.945367, 0.404666>
    }
    triangle {
      < 0.982223, 4.692563, 0.590206>,
      < 0.830078, 4.341913, 0.637832>,
      < 1.194571, 4.127187, 0.919418>
    }
    triangle {
      < 0.982223, 4.692563, 0.590206>,
      < 1.194571, 4.127187, 0.919418>,
      < 1.401560, 4.607304, 0.853844>
    }
    triangle {
      < 0.830078, 4.341913, 0.637832>,
      < 0.677512, 3.964583, 0.330837>,
      < 0.983645, 3.604900, 0.494325>
    }
    triangle {
      < 0.830078, 4.341913, 0.637832>,
      < 0.983645, 3.604900, 0.494325>,
      < 1.194571, 4.127187, 0.919418>
    }
    triangle {
      < 0.677512, 3.964583, 0.330837>,
      < 0.659258, 3.896364, -0.024115>,
      < 0.958410, 3.512180, 0.007543>
    }
    triangle {
      < 0.677512, 3.964583, 0.330837>,
      < 0.958410, 3.512180, 0.007543>,
      < 0.983645, 3.604900, 0.494325>
    }
    triangle {
      < 0.659258, 3.896364, -0.024115>,
      < 0.754616, 4.086032, -0.469351>,
      < 1.090767, 3.776647, -0.611690>
    }
    triangle {
      < 0.659258, 3.896364, -0.024115>,
      < 1.090767, 3.776647, -0.611690>,
      < 0.958410, 3.512180, 0.007543>
    }
    triangle {
      < 0.754616, 4.086032, -0.469351>,
      < 0.836218, 4.267161, -0.590551>,
      < 1.201642, 4.024040, -0.776104>
    }
    triangle {
      < 0.754616, 4.086032, -0.469351>,
      < 1.201642, 4.024040, -0.776104>,
      < 1.090767, 3.776647, -0.611690>
    }
    triangle {
      < 0.836218, 4.267161, -0.590551>,
      < 0.981854, 4.602366, -0.642257>,
      < 1.403898, 4.490224, -0.848257>
    }
    triangle {
      < 0.836218, 4.267161, -0.590551>,
      < 1.403898, 4.490224, -0.848257>,
      < 1.201642, 4.024040, -0.776104>
    }
    triangle {
      < 0.621848, 4.334342, -0.052589>,
      < 0.657583, 4.405418, -0.219440>,
      < 0.754616, 4.086032, -0.469351>
    }
    triangle {
      < 0.621848, 4.334342, -0.052589>,
      < 0.754616, 4.086032, -0.469351>,
      < 0.659258, 3.896364, -0.024115>
    }
    triangle {
      < 0.657583, 4.405418, -0.219440>,
      < 0.688163, 4.473297, -0.264860>,
      < 0.836218, 4.267161, -0.590551>
    }
    triangle {
      < 0.657583, 4.405418, -0.219440>,
      < 0.836218, 4.267161, -0.590551>,
      < 0.754616, 4.086032, -0.469351>
    }
    triangle {
      < 0.688163, 4.473297, -0.264860>,
      < 0.742740, 4.598918, -0.284237>,
      < 0.981854, 4.602366, -0.642257>
    }
    triangle {
      < 0.688163, 4.473297, -0.264860>,
      < 0.981854, 4.602366, -0.642257>,
      < 0.836218, 4.267161, -0.590551>
    }
    triangle {
      < 0.742740, 4.598918, -0.284237>,
      < 0.781006, 4.690696, -0.246708>,
      < 1.083963, 4.847274, -0.542113>
    }
    triangle {
      < 0.742740, 4.598918, -0.284237>,
      < 1.083963, 4.847274, -0.542113>,
      < 0.981854, 4.602366, -0.642257>
    }
    triangle {
      < 0.781006, 4.690696, -0.246708>,
      < 0.804378, 4.755525, -0.102882>,
      < 1.146336, 5.020259, -0.158321>
    }
    triangle {
      < 0.781006, 4.690696, -0.246708>,
      < 1.146336, 5.020259, -0.158321>,
      < 1.083963, 4.847274, -0.542113>
    }
    triangle {
      < 0.804378, 4.755525, -0.102882>,
      < 0.786055, 4.724414, 0.056300>,
      < 1.097437, 4.937255, 0.266447>
    }
    triangle {
      < 0.804378, 4.755525, -0.102882>,
      < 1.097437, 4.937255, 0.266447>,
      < 1.146336, 5.020259, -0.158321>
    }
    triangle {
      < 0.786055, 4.724414, 0.056300>,
      < 0.742877, 4.632720, 0.177629>,
      < 0.982223, 4.692563, 0.590206>
    }
    triangle {
      < 0.786055, 4.724414, 0.056300>,
      < 0.982223, 4.692563, 0.590206>,
      < 1.097437, 4.937255, 0.266447>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.685862, 4.501311, 0.195476>,
      < 0.830078, 4.341913, 0.637832>
    }
    triangle {
      < 0.742877, 4.632720, 0.177629>,
      < 0.830078, 4.341913, 0.637832>,
      < 0.982223, 4.692563, 0.590206>
    }
    triangle {
      < 0.685862, 4.501311, 0.195476>,
      < 0.628688, 4.359907, 0.080430>,
      < 0.677512, 3.964583, 0.330837>
    }
    triangle {
      < 0.685862, 4.501311, 0.195476>,
      < 0.677512, 3.964583, 0.330837>,
      < 0.830078, 4.341913, 0.637832>
    }
    triangle {
      < 0.628688, 4.359907, 0.080430>,
      < 0.621848, 4.334342, -0.052589>,
      < 0.659258, 3.896364, -0.024115>
    }
    triangle {
      < 0.628688, 4.359907, 0.080430>,
      < 0.659258, 3.896364, -0.024115>,
      < 0.677512, 3.964583, 0.330837>
    }
    triangle {
      < 0.983645, 3.604900, 0.494325>,
      < 0.958410, 3.512180, 0.007543>,
      < 1.250166, 3.455350, 0.011792>
    }
    triangle {
      < 0.983645, 3.604900, 0.494325>,
      < 1.250166, 3.455350, 0.011792>,
      < 1.295038, 3.541559, 0.508972>
    }
    triangle {
      < 1.194571, 4.127187, 0.919418>,
      < 0.983645, 3.604900, 0.494325>,
      < 1.295038, 3.541559, 0.508972>
    }
    triangle {
      < 1.194571, 4.127187, 0.919418>,
      < 1.295038, 3.541559, 0.508972>,
      < 1.613344, 4.007860, 0.941017>
    }
    triangle {
      < 1.401560, 4.607304, 0.853844>,
      < 1.194571, 4.127187, 0.919418>,
      < 1.613344, 4.007860, 0.941017>
    }
    triangle {
      < 1.401560, 4.607304, 0.853844>,
      < 1.613344, 4.007860, 0.941017>,
      < 1.921392, 4.435579, 0.874178>
    }
    triangle {
      < 1.559017, 4.945367, 0.404666>,
      < 1.401560, 4.607304, 0.853844>,
      < 1.921392, 4.435579, 0.874178>
    }
    triangle {
      < 1.559017, 4.945367, 0.404666>,
      < 1.921392, 4.435579, 0.874178>,
      < 2.148929, 4.732874, 0.418104>
    }
    triangle {
      < 1.627299, 5.061404, -0.184693>,
      < 1.559017, 4.945367, 0.404666>,
      < 2.148929, 4.732874, 0.418104>
    }
    triangle {
      < 1.627299, 5.061404, -0.184693>,
      < 2.148929, 4.732874, 0.418104>,
      < 2.240090, 4.831474, -0.180282>
    }
    triangle {
      < 1.542589, 4.823540, -0.713341>,
      < 1.627299, 5.061404, -0.184693>,
      < 2.240090, 4.831474, -0.180282>
    }
    triangle {
      < 1.542589, 4.823540, -0.713341>,
      < 2.240090, 4.831474, -0.180282>,
      < 2.104079, 4.601659, -0.719015>
    }
    triangle {
      < 1.403898, 4.490224, -0.848257>,
      < 1.542589, 4.823540, -0.713341>,
      < 2.104079, 4.601659, -0.719015>
    }
    triangle {
      < 1.403898, 4.490224, -0.848257>,
      < 2.104079, 4.601659, -0.719015>,
      < 1.894666, 4.302699, -0.858074>
    }
    triangle {
      < 1.201642, 4.024040, -0.776104>,
      < 1.403898, 4.490224, -0.848257>,
      < 1.894666, 4.302699, -0.858074>
    }
    triangle {
      < 1.201642, 4.024040, -0.776104>,
      < 1.894666, 4.302699, -0.858074>,
      < 1.597707, 3.890364, -0.785028>
    }
    triangle {
      < 1.090767, 3.776647, -0.611690>,
      < 1.201642, 4.024040, -0.776104>,
      < 1.597707, 3.890364, -0.785028>
    }
    triangle {
      < 1.090767, 3.776647, -0.611690>,
      < 1.597707, 3.890364, -0.785028>,
      < 1.434622, 3.670614, -0.616165>
    }
    triangle {
      < 0.958410, 3.512180, 0.007543>,
      < 1.090767, 3.776647, -0.611690>,
      < 1.434622, 3.670614, -0.616165>
    }
    triangle {
      < 0.958410, 3.512180, 0.007543>,
      < 1.434622, 3.670614, -0.616165>,
      < 1.250166, 3.455350, 0.011792>
    }
    texture {arml}
  }
  // body
  union {
    triangle {
      < -1.615866, 0.932848, 0.867042>,
      < -1.665409, 0.937255, 0.408684>,
      < -1.567689, 0.343412, 0.374270>
    }
    triangle {
      < -1.615866, 0.932848, 0.867042>,
      < -1.567689, 0.343412, 0.374270>,
      < -1.667724, 0.325124, 0.861139>
    }
    triangle {
      < -1.667724, 0.325124, 0.861139>,
      < -1.630292, 0.298432, 0.980606>,
      < -1.616949, 0.940626, 1.106850>
    }
    triangle {
      < -1.667724, 0.325124, 0.861139>,
      < -1.616949, 0.940626, 1.106850>,
      < -1.615866, 0.932848, 0.867042>
    }
    triangle {
      < -1.630292, 0.298432, 0.980606>,
      < -1.368342, 0.290731, 1.693234>,
      < -1.323336, 0.948244, 1.694737>
    }
    triangle {
      < -1.630292, 0.298432, 0.980606>,
      < -1.323336, 0.948244, 1.694737>,
      < -1.616949, 0.940626, 1.106850>
    }
    triangle {
      < -1.368342, 0.290731, 1.693234>,
      < -0.855725, 0.305926, 2.111272>,
      < -0.912253, 0.961551, 2.075965>
    }
    triangle {
      < -1.368342, 0.290731, 1.693234>,
      < -0.912253, 0.961551, 2.075965>,
      < -1.323336, 0.948244, 1.694737>
    }
    triangle {
      < -1.567689, 0.343412, 0.374270>,
      < -1.665409, 0.937255, 0.408684>,
      < -1.421312, 0.928829, 0.106105>
    }
    triangle {
      < -1.567689, 0.343412, 0.374270>,
      < -1.421312, 0.928829, 0.106105>,
      < -1.324927, 0.351883, 0.083510>
    }
    triangle {
      < -1.324927, 0.351883, 0.083510>,
      < -1.421312, 0.928829, 0.106105>,
      < -1.153018, 0.924817, -0.087208>
    }
    triangle {
      < -1.324927, 0.351883, 0.083510>,
      < -1.153018, 0.924817, -0.087208>,
      < -1.023351, 0.346405, -0.053167>
    }
    triangle {
      < -1.023351, 0.346405, -0.053167>,
      < -1.153018, 0.924817, -0.087208>,
      < -0.761863, 0.935459, -0.192583>
    }
    triangle {
      < -1.023351, 0.346405, -0.053167>,
      < -0.761863, 0.935459, -0.192583>,
      < -0.676174, 0.356651, -0.147042>
    }
    triangle {
      < -0.676174, 0.356651, -0.147042>,
      < -0.761863, 0.935459, -0.192583>,
      < -0.281991, 0.951491, -0.199283>
    }
    triangle {
      < -0.676174, 0.356651, -0.147042>,
      < -0.281991, 0.951491, -0.199283>,
      < -0.264625, 0.388178, -0.173283>
    }
    triangle {
      < -0.264625, 0.388178, -0.173283>,
      < 0.000000, 0.418408, -0.112867>,
      < 0.000000, -0.390384, -0.205530>
    }
    triangle {
      < -0.264625, 0.388178, -0.173283>,
      < 0.000000, -0.390384, -0.205530>,
      < -0.256247, -0.378244, -0.343827>
    }
    triangle {
      < -1.835413, -0.461101, 0.782676>,
      < -1.734500, -0.418211, 0.226525>,
      < -2.043287, -1.081142, 0.138327>
    }
    triangle {
      < -1.835413, -0.461101, 0.782676>,
      < -2.043287, -1.081142, 0.138327>,
      < -2.151950, -1.167999, 0.746909>
    }
    triangle {
      < -1.615223, -0.478884, 1.642453>,
      < -1.835413, -0.461101, 0.782676>,
      < -2.151950, -1.167999, 0.746909>
    }
    triangle {
      < -1.615223, -0.478884, 1.642453>,
      < -2.151950, -1.167999, 0.746909>,
      < -1.923485, -1.252392, 1.567173>
    }
    triangle {
      < -1.923485, -1.252392, 1.567173>,
      < -1.321224, -1.299337, 2.064278>,
      < -1.088540, -0.502982, 2.096247>
    }
    triangle {
      < -1.923485, -1.252392, 1.567173>,
      < -1.088540, -0.502982, 2.096247>,
      < -1.615223, -0.478884, 1.642453>
    }
    triangle {
      < -1.088540, -0.502982, 2.096247>,
      < -0.585927, -0.662367, 2.272740>,
      < -0.461192, 0.053048, 2.272134>
    }
    triangle {
      < -1.088540, -0.502982, 2.096247>,
      < -0.461192, 0.053048, 2.272134>,
      < -0.855725, 0.305926, 2.111272>
    }
    triangle {
      < -0.079880, -0.668916, 2.137583>,
      < -0.066715, -0.604138, 2.139349>,
      < -0.461192, 0.053048, 2.272134>
    }
    triangle {
      < -0.079880, -0.668916, 2.137583>,
      < -0.461192, 0.053048, 2.272134>,
      < -0.585927, -0.662367, 2.272740>
    }
    triangle {
      < -0.030486, -0.538444, 2.142306>,
      < 0.000000, -0.518706, 2.144231>,
      < 0.000000, 0.286501, 2.168349>
    }
    triangle {
      < -0.030486, -0.538444, 2.142306>,
      < 0.000000, 0.286501, 2.168349>,
      < -0.265781, 0.220905, 2.228825>
    }
    triangle {
      < -2.043287, -1.081142, 0.138327>,
      < -1.734500, -0.418211, 0.226525>,
      < -1.477786, -0.393219, -0.084196>
    }
    triangle {
      < -2.043287, -1.081142, 0.138327>,
      < -1.477786, -0.393219, -0.084196>,
      < -1.738288, -1.045818, -0.291013>
    }
    triangle {
      < -1.738288, -1.045818, -0.291013>,
      < -1.477786, -0.393219, -0.084196>,
      < -1.134307, -0.395637, -0.215442>
    }
    triangle {
      < -1.738288, -1.045818, -0.291013>,
      < -1.134307, -0.395637, -0.215442>,
      < -1.392307, -1.028841, -0.524928>
    }
    triangle {
      < -1.392307, -1.028841, -0.524928>,
      < -1.134307, -0.395637, -0.215442>,
      < -0.775331, -0.395819, -0.293731>
    }
    triangle {
      < -1.392307, -1.028841, -0.524928>,
      < -0.775331, -0.395819, -0.293731>,
      < -0.939213, -1.034800, -0.593414>
    }
    triangle {
      < -0.939213, -1.034800, -0.593414>,
      < -0.775331, -0.395819, -0.293731>,
      < -0.256247, -0.378244, -0.343827>
    }
    triangle {
      < -0.939213, -1.034800, -0.593414>,
      < -0.256247, -0.378244, -0.343827>,
      < -0.341460, -1.035609, -0.696119>
    }
    triangle {
      < -0.341460, -1.035609, -0.696119>,
      < -0.256247, -0.378244, -0.343827>,
      < 0.000000, -0.390384, -0.205530>
    }
    triangle {
      < -0.341460, -1.035609, -0.696119>,
      < 0.000000, -0.390384, -0.205530>,
      < 0.000000, -1.028896, -0.709965>
    }
    triangle {
      < -2.151950, -1.167999, 0.746909>,
      < -2.043287, -1.081142, 0.138327>,
      < -2.287189, -1.739374, 0.014049>
    }
    triangle {
      < -2.151950, -1.167999, 0.746909>,
      < -2.287189, -1.739374, 0.014049>,
      < -2.375054, -1.787838, 0.744887>
    }
    triangle {
      < -2.043287, -1.081142, 0.138327>,
      < -1.738288, -1.045818, -0.291013>,
      < -1.993370, -1.706865, -0.610222>
    }
    triangle {
      < -2.043287, -1.081142, 0.138327>,
      < -1.993370, -1.706865, -0.610222>,
      < -2.287189, -1.739374, 0.014049>
    }
    triangle {
      < -1.993370, -1.706865, -0.610222>,
      < -1.738288, -1.045818, -0.291013>,
      < -1.392307, -1.028841, -0.524928>
    }
    triangle {
      < -1.993370, -1.706865, -0.610222>,
      < -1.392307, -1.028841, -0.524928>,
      < -1.527554, -1.725683, -0.939297>
    }
    triangle {
      < -1.527554, -1.725683, -0.939297>,
      < -1.392307, -1.028841, -0.524928>,
      < -0.939213, -1.034800, -0.593414>
    }
    triangle {
      < -1.527554, -1.725683, -0.939297>,
      < -0.939213, -1.034800, -0.593414>,
      < -1.029656, -1.729898, -1.124603>
    }
    triangle {
      < -1.029656, -1.729898, -1.124603>,
      < -0.939213, -1.034800, -0.593414>,
      < -0.341460, -1.035609, -0.696119>
    }
    triangle {
      < -1.029656, -1.729898, -1.124603>,
      < -0.341460, -1.035609, -0.696119>,
      < -0.411529, -1.732547, -1.211711>
    }
    triangle {
      < -0.411529, -1.732547, -1.211711>,
      < -0.341460, -1.035609, -0.696119>,
      < 0.000000, -1.028896, -0.709965>
    }
    triangle {
      < -0.411529, -1.732547, -1.211711>,
      < 0.000000, -1.028896, -0.709965>,
      < 0.000000, -1.725303, -1.284663>
    }
    triangle {
      < -1.923485, -1.252392, 1.567173>,
      < -2.151950, -1.167999, 0.746909>,
      < -2.375054, -1.787838, 0.744887>
    }
    triangle {
      < -1.923485, -1.252392, 1.567173>,
      < -2.375054, -1.787838, 0.744887>,
      < -1.992056, -1.958319, 1.606111>
    }
    triangle {
      < -1.321224, -1.299337, 2.064278>,
      < -1.923485, -1.252392, 1.567173>,
      < -1.992056, -1.958319, 1.606111>
    }
    triangle {
      < -1.321224, -1.299337, 2.064278>,
      < -1.992056, -1.958319, 1.606111>,
      < -1.469949, -2.124545, 2.087185>
    }
    triangle {
      < -1.321224, -1.299337, 2.064278>,
      < -0.473522, -1.293983, 2.269722>,
      < -0.585927, -0.662367, 2.272740>
    }
    triangle {
      < -1.321224, -1.299337, 2.064278>,
      < -0.585927, -0.662367, 2.272740>,
      < -1.088540, -0.502982, 2.096247>
    }
    triangle {
      < -0.473522, -1.293983, 2.269722>,
      < -0.891979, -2.200235, 2.236348>,
      < -0.380002, -2.254292, 2.142292>
    }
    triangle {
      < -0.473522, -1.293983, 2.269722>,
      < -0.380002, -2.254292, 2.142292>,
      < -0.200286, -1.505385, 2.203278>
    }
    triangle {
      < -0.062370, -0.719194, 2.139291>,
      < -0.079880, -0.668916, 2.137583>,
      < -0.585927, -0.662367, 2.272740>
    }
    triangle {
      < -0.062370, -0.719194, 2.139291>,
      < -0.585927, -0.662367, 2.272740>,
      < -0.473522, -1.293983, 2.269722>
    }
    triangle {
      < -0.473522, -1.293983, 2.269722>,
      < -0.200286, -1.505385, 2.203278>,
      < -0.034745, -0.781618, 2.138963>
    }
    triangle {
      < -0.473522, -1.293983, 2.269722>,
      < -0.034745, -0.781618, 2.138963>,
      < -0.062370, -0.719194, 2.139291>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -2.483908, -2.205232, 0.700965>,
      < -2.375054, -1.787838, 0.744887>,
      < -2.287189, -1.739374, 0.014049>
    }
    triangle {
      < -2.483908, -2.205232, 0.700965>,
      < -2.287189, -1.739374, 0.014049>,
      < -2.418596, -2.189365, -0.047748>
    }
    triangle {
      < -2.418596, -2.189365, -0.047748>,
      < -2.287189, -1.739374, 0.014049>,
      < -1.993370, -1.706865, -0.610222>
    }
    triangle {
      < -2.418596, -2.189365, -0.047748>,
      < -1.993370, -1.706865, -0.610222>,
      < -2.141889, -2.239871, -0.700709>
    }
    triangle {
      < -2.141889, -2.239871, -0.700709>,
      < -1.993370, -1.706865, -0.610222>,
      < -1.527554, -1.725683, -0.939297>
    }
    triangle {
      < -2.141889, -2.239871, -0.700709>,
      < -1.527554, -1.725683, -0.939297>,
      < -1.700081, -2.345231, -1.189734>
    }
    triangle {
      < -1.700081, -2.345231, -1.189734>,
      < -1.527554, -1.725683, -0.939297>,
      < -1.029656, -1.729898, -1.124603>
    }
    triangle {
      < -1.700081, -2.345231, -1.189734>,
      < -1.029656, -1.729898, -1.124603>,
      < -1.134340, -2.406512, -1.430779>
    }
    triangle {
      < -1.134340, -2.406512, -1.430779>,
      < -1.029656, -1.729898, -1.124603>,
      < -0.411529, -1.732547, -1.211711>
    }
    triangle {
      < -1.134340, -2.406512, -1.430779>,
      < -0.411529, -1.732547, -1.211711>,
      < -0.484518, -2.407809, -1.519681>
    }
    triangle {
      < -0.484518, -2.407809, -1.519681>,
      < -0.411529, -1.732547, -1.211711>,
      < 0.000000, -1.725303, -1.284663>
    }
    triangle {
      < -0.484518, -2.407809, -1.519681>,
      < 0.000000, -1.725303, -1.284663>,
      < 0.000000, -2.406300, -1.528150>
    }
    triangle {
      < -2.375054, -1.787838, 0.744887>,
      < -2.483908, -2.205232, 0.700965>,
      < -2.081050, -2.344766, 1.611613>
    }
    triangle {
      < -2.375054, -1.787838, 0.744887>,
      < -2.081050, -2.344766, 1.611613>,
      < -1.992056, -1.958319, 1.606111>
    }
    triangle {
      < -1.992056, -1.958319, 1.606111>,
      < -2.081050, -2.344766, 1.611613>,
      < -1.498155, -2.624723, 1.975203>
    }
    triangle {
      < -1.992056, -1.958319, 1.606111>,
      < -1.498155, -2.624723, 1.975203>,
      < -1.469949, -2.124545, 2.087185>
    }
    triangle {
      < -1.469949, -2.124545, 2.087185>,
      < -1.498155, -2.624723, 1.975203>,
      < -0.976975, -2.842957, 2.054101>
    }
    triangle {
      < -1.469949, -2.124545, 2.087185>,
      < -0.976975, -2.842957, 2.054101>,
      < -0.891979, -2.200235, 2.236348>
    }
    triangle {
      < -0.891979, -2.200235, 2.236348>,
      < -0.976975, -2.842957, 2.054101>,
      < -0.369286, -2.906036, 2.035651>
    }
    triangle {
      < -0.891979, -2.200235, 2.236348>,
      < -0.369286, -2.906036, 2.035651>,
      < -0.380002, -2.254292, 2.142292>
    }
    triangle {
      < -0.380002, -2.254292, 2.142292>,
      < -0.369286, -2.906036, 2.035651>,
      < 0.000000, -2.913937, 2.005210>
    }
    triangle {
      < -0.380002, -2.254292, 2.142292>,
      < 0.000000, -2.913937, 2.005210>,
      < 0.000000, -2.270840, 2.094989>
    }
    triangle {
      < -2.418596, -2.189365, -0.047748>,
      < -2.141889, -2.239871, -0.700709>,
      < -2.200008, -2.698764, -0.788438>
    }
    triangle {
      < -2.418596, -2.189365, -0.047748>,
      < -2.200008, -2.698764, -0.788438>,
      < -2.505751, -2.631844, -0.128317>
    }
    triangle {
      < -2.533123, -2.555095, 0.678978>,
      < -2.483908, -2.205232, 0.700965>,
      < -2.418596, -2.189365, -0.047748>
    }
    triangle {
      < -2.533123, -2.555095, 0.678978>,
      < -2.418596, -2.189365, -0.047748>,
      < -2.505751, -2.631844, -0.128317>
    }
    triangle {
      < -2.505751, -2.631844, -0.128317>,
      < -2.547276, -2.972060, -0.173055>,
      < -2.533123, -2.555095, 0.678978>
    }
    triangle {
      < -2.483908, -2.205232, 0.700965>,
      < -2.533123, -2.555095, 0.678978>,
      < -2.099578, -2.632143, 1.627991>
    }
    triangle {
      < -2.483908, -2.205232, 0.700965>,
      < -2.099578, -2.632143, 1.627991>,
      < -2.081050, -2.344766, 1.611613>
    }
    triangle {
      < -2.081050, -2.344766, 1.611613>,
      < -2.099578, -2.632143, 1.627991>,
      < -1.505880, -3.041700, 1.916351>
    }
    triangle {
      < -2.081050, -2.344766, 1.611613>,
      < -1.505880, -3.041700, 1.916351>,
      < -1.498155, -2.624723, 1.975203>
    }
    triangle {
      < -1.498155, -2.624723, 1.975203>,
      < -1.505880, -3.041700, 1.916351>,
      < -1.017310, -3.521789, 1.843347>
    }
    triangle {
      < -1.498155, -2.624723, 1.975203>,
      < -1.017310, -3.521789, 1.843347>,
      < -0.976975, -2.842957, 2.054101>
    }
    triangle {
      < -0.976975, -2.842957, 2.054101>,
      < -1.017310, -3.521789, 1.843347>,
      < -0.354142, -3.532827, 1.804350>
    }
    triangle {
      < -0.976975, -2.842957, 2.054101>,
      < -0.354142, -3.532827, 1.804350>,
      < -0.369286, -2.906036, 2.035651>
    }
    triangle {
      < -0.369286, -2.906036, 2.035651>,
      < -0.354142, -3.532827, 1.804350>,
      < 0.000000, -3.538705, 1.784168>
    }
    triangle {
      < -0.369286, -2.906036, 2.035651>,
      < 0.000000, -3.538705, 1.784168>,
      < 0.000000, -2.913937, 2.005210>
    }
    triangle {
      < -2.547276, -2.972060, -0.173055>,
      < -2.505751, -2.631844, -0.128317>,
      < -2.200008, -2.698764, -0.788438>
    }
    triangle {
      < -2.547276, -2.972060, -0.173055>,
      < -2.200008, -2.698764, -0.788438>,
      < -2.223733, -3.181419, -0.836420>
    }
    triangle {
      < -2.547276, -2.972060, -0.173055>,
      < -2.223733, -3.181419, -0.836420>,
      < -2.248718, -3.572636, -0.898282>
    }
    triangle {
      < -0.711234, -4.646127, -0.783033>,
      < -0.889220, -4.246559, -1.401602>,
      < -0.311111, -4.381596, -1.212254>
    }
    triangle {
      < -0.711234, -4.646127, -0.783033>,
      < -0.311111, -4.381596, -1.212254>,
      < -0.255535, -4.694487, -0.625129>
    }
    triangle {
      < -0.255535, -4.694487, -0.625129>,
      < -0.311111, -4.381596, -1.212254>,
      < 0.000000, -4.407779, -1.010952>
    }
    triangle {
      < -0.255535, -4.694487, -0.625129>,
      < 0.000000, -4.407779, -1.010952>,
      < 0.000000, -4.602162, -0.492641>
    }
    triangle {
      < -0.711234, -4.646127, -0.783033>,
      < -0.255535, -4.694487, -0.625129>,
      < -0.298104, -4.734981, -0.329984>
    }
    triangle {
      < -0.711234, -4.646127, -0.783033>,
      < -1.494346, -4.284712, -1.156904>,
      < -1.724837, -3.932333, -1.297691>
    }
    triangle {
      < -0.711234, -4.646127, -0.783033>,
      < -1.724837, -3.932333, -1.297691>,
      < -0.889220, -4.246559, -1.401602>
    }
    triangle {
      < -2.248718, -3.572636, -0.898282>,
      < -1.724837, -3.932333, -1.297691>,
      < -1.494346, -4.284712, -1.156904>
    }
    triangle {
      < -1.724837, -3.932333, -1.297691>,
      < -2.248718, -3.572636, -0.898282>,
      < -2.223733, -3.181419, -0.836420>
    }
    triangle {
      < -1.724837, -3.932333, -1.297691>,
      < -2.223733, -3.181419, -0.836420>,
      < -1.776117, -3.430998, -1.332718>
    }
    triangle {
      < -1.776117, -3.430998, -1.332718>,
      < -1.089705, -3.611076, -1.668545>,
      < -0.889220, -4.246559, -1.401602>
    }
    triangle {
      < -1.776117, -3.430998, -1.332718>,
      < -0.889220, -4.246559, -1.401602>,
      < -1.724837, -3.932333, -1.297691>
    }
    triangle {
      < -0.889220, -4.246559, -1.401602>,
      < -1.089705, -3.611076, -1.668545>,
      < -0.450691, -3.743277, -1.622213>
    }
    triangle {
      < -0.889220, -4.246559, -1.401602>,
      < -0.450691, -3.743277, -1.622213>,
      < -0.311111, -4.381596, -1.212254>
    }
    triangle {
      < -0.311111, -4.381596, -1.212254>,
      < -0.450691, -3.743277, -1.622213>,
      < 0.000000, -3.830920, -1.463827>
    }
    triangle {
      < -0.311111, -4.381596, -1.212254>,
      < 0.000000, -3.830920, -1.463827>,
      < 0.000000, -4.407779, -1.010952>
    }
    triangle {
      < -2.223733, -3.181419, -0.836420>,
      < -2.200008, -2.698764, -0.788438>,
      < -1.806353, -2.795094, -1.285055>
    }
    triangle {
      < -2.223733, -3.181419, -0.836420>,
      < -1.806353, -2.795094, -1.285055>,
      < -1.776117, -3.430998, -1.332718>
    }
    triangle {
      < -1.806353, -2.795094, -1.285055>,
      < -2.200008, -2.698764, -0.788438>,
      < -2.141889, -2.239871, -0.700709>
    }
    triangle {
      < -1.806353, -2.795094, -1.285055>,
      < -2.141889, -2.239871, -0.700709>,
      < -1.700081, -2.345231, -1.189734>
    }
    triangle {
      < -1.806353, -2.795094, -1.285055>,
      < -1.700081, -2.345231, -1.189734>,
      < -1.134340, -2.406512, -1.430779>
    }
    triangle {
      < -1.806353, -2.795094, -1.285055>,
      < -1.134340, -2.406512, -1.430779>,
      < -1.178743, -2.926280, -1.626145>
    }
    triangle {
      < -1.178743, -2.926280, -1.626145>,
      < -1.134340, -2.406512, -1.430779>,
      < -0.484518, -2.407809, -1.519681>
    }
    triangle {
      < -1.178743, -2.926280, -1.626145>,
      < -0.484518, -2.407809, -1.519681>,
      < -0.467621, -3.071518, -1.721816>
    }
    triangle {
      < -0.467621, -3.071518, -1.721816>,
      < -0.484518, -2.407809, -1.519681>,
      < 0.000000, -2.406300, -1.528150>
    }
    triangle {
      < -0.467621, -3.071518, -1.721816>,
      < 0.000000, -2.406300, -1.528150>,
      < 0.000000, -3.133061, -1.622910>
    }
    triangle {
      < -1.806353, -2.795094, -1.285055>,
      < -1.178743, -2.926280, -1.626145>,
      < -1.089705, -3.611076, -1.668545>
    }
    triangle {
      < -1.806353, -2.795094, -1.285055>,
      < -1.089705, -3.611076, -1.668545>,
      < -1.776117, -3.430998, -1.332718>
    }
    triangle {
      < -1.178743, -2.926280, -1.626145>,
      < -0.467621, -3.071518, -1.721816>,
      < -0.450691, -3.743277, -1.622213>
    }
    triangle {
      < -1.178743, -2.926280, -1.626145>,
      < -0.450691, -3.743277, -1.622213>,
      < -1.089705, -3.611076, -1.668545>
    }
    triangle {
      < -0.467621, -3.071518, -1.721816>,
      < 0.000000, -3.133061, -1.622910>,
      < 0.000000, -3.830920, -1.463827>
    }
    triangle {
      < -0.467621, -3.071518, -1.721816>,
      < 0.000000, -3.830920, -1.463827>,
      < -0.450691, -3.743277, -1.622213>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -1.615866, 0.932848, 0.867042>,
      < -1.740981, 1.647860, 0.799099>,
      < -1.783412, 1.641130, 0.296395>
    }
    triangle {
      < -1.615866, 0.932848, 0.867042>,
      < -1.783412, 1.641130, 0.296395>,
      < -1.665409, 0.937255, 0.408684>
    }
    triangle {
      < -1.665409, 0.937255, 0.408684>,
      < -1.783412, 1.641130, 0.296395>,
      < -1.504927, 1.630030, -0.114216>
    }
    triangle {
      < -1.665409, 0.937255, 0.408684>,
      < -1.504927, 1.630030, -0.114216>,
      < -1.421312, 0.928829, 0.106105>
    }
    triangle {
      < -1.615866, 0.932848, 0.867042>,
      < -1.616949, 0.940626, 1.106850>,
      < -1.677819, 1.606148, 1.232651>
    }
    triangle {
      < -1.615866, 0.932848, 0.867042>,
      < -1.677819, 1.606148, 1.232651>,
      < -1.740981, 1.647860, 0.799099>
    }
    triangle {
      < -1.677819, 1.606148, 1.232651>,
      < -1.616949, 0.940626, 1.106850>,
      < -1.323336, 0.948244, 1.694737>
    }
    triangle {
      < -1.677819, 1.606148, 1.232651>,
      < -1.323336, 0.948244, 1.694737>,
      < -1.547569, 1.567267, 1.812724>
    }
    triangle {
      < -1.547569, 1.567267, 1.812724>,
      < -1.323336, 0.948244, 1.694737>,
      < -0.912253, 0.961551, 2.075965>
    }
    triangle {
      < -1.547569, 1.567267, 1.812724>,
      < -0.912253, 0.961551, 2.075965>,
      < -1.076726, 1.438651, 2.082249>
    }
    triangle {
      < -1.076726, 1.438651, 2.082249>,
      < -0.912253, 0.961551, 2.075965>,
      < -0.273146, 0.985146, 2.250294>
    }
    triangle {
      < -1.076726, 1.438651, 2.082249>,
      < -0.273146, 0.985146, 2.250294>,
      < -0.419190, 1.558822, 2.240149>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -1.273308, 4.980906, -0.154589>,
      < -1.141270, 5.206872, -0.527612>,
      < -1.431619, 4.809371, -0.508151>
    }
    triangle {
      < -1.273308, 4.980906, -0.154589>,
      < -1.431619, 4.809371, -0.508151>,
      < -1.590628, 4.955067, -0.063853>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -1.590628, 4.955067, -0.063853>,
      < -1.431619, 4.809371, -0.508151>,
      < -1.715634, 4.757394, -0.424567>
    }
    triangle {
      < -1.590628, 4.955067, -0.063853>,
      < -1.715634, 4.757394, -0.424567>,
      < -2.241364, 4.609824, -0.315852>
    }
    triangle {
      < -1.590628, 4.955067, -0.063853>,
      < -2.241364, 4.609824, -0.315852>,
      < -2.228878, 4.708693, 0.205954>
    }
    triangle {
      < -2.228878, 4.708693, 0.205954>,
      < -2.241364, 4.609824, -0.315852>,
      < -2.424494, 4.345810, -0.180659>
    }
    triangle {
      < -2.228878, 4.708693, 0.205954>,
      < -2.424494, 4.345810, -0.180659>,
      < -2.482014, 4.415555, 0.265006>
    }
    triangle {
      < -1.311563, 4.775741, -0.821882>,
      < -1.129160, 4.772320, -1.039785>,
      < -1.672387, 4.390581, -0.737402>
    }
    triangle {
      < -1.715634, 4.757394, -0.424567>,
      < -1.672387, 4.390581, -0.737402>,
      < -2.029075, 4.281486, -0.593433>
    }
    triangle {
      < -1.715634, 4.757394, -0.424567>,
      < -2.029075, 4.281486, -0.593433>,
      < -2.241364, 4.609824, -0.315852>
    }
    triangle {
      < -2.241364, 4.609824, -0.315852>,
      < -2.029075, 4.281486, -0.593433>,
      < -2.268412, 4.117446, -0.395912>
    }
    triangle {
      < -2.241364, 4.609824, -0.315852>,
      < -2.268412, 4.117446, -0.395912>,
      < -2.424494, 4.345810, -0.180659>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -2.268412, 4.117446, -0.395912>,
      < -2.029075, 4.281486, -0.593433>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -2.029075, 4.281486, -0.593433>,
      < -1.998452, 3.933387, -0.729109>
    }
    triangle {
      < -1.998452, 3.933387, -0.729109>,
      < -1.692724, 4.074691, -0.865690>,
      < -1.713060, 3.430965, -0.885488>
    }
    triangle {
      < -1.998452, 3.933387, -0.729109>,
      < -1.713060, 3.430965, -0.885488>,
      < -2.015426, 3.432471, -0.791534>
    }
    triangle {
      < -2.015426, 3.432471, -0.791534>,
      < -2.083994, 3.764152, -0.526183>,
      < -1.998452, 3.933387, -0.729109>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -2.015426, 3.432471, -0.791534>,
      < -1.952047, 3.541013, -0.074353>
    }
    triangle {
      < -2.015426, 3.432471, -0.791534>,
      < -1.713060, 3.430965, -0.885488>,
      < -1.691266, 2.802418, -0.566645>
    }
    triangle {
      < -2.015426, 3.432471, -0.791534>,
      < -1.691266, 2.802418, -0.566645>,
      < -2.010648, 2.861194, -0.415499>
    }
    triangle {
      < -2.010648, 2.861194, -0.415499>,
      < -1.691266, 2.802418, -0.566645>,
      < -1.595705, 1.961731, -0.268515>
    }
    triangle {
      < -2.010648, 2.861194, -0.415499>,
      < -1.595705, 1.961731, -0.268515>,
      < -1.908859, 1.975836, 0.203519>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -1.908859, 1.975836, 0.203519>,
      < -1.595705, 1.961731, -0.268515>,
      < -1.504927, 1.630030, -0.114216>
    }
    triangle {
      < -1.908859, 1.975836, 0.203519>,
      < -1.504927, 1.630030, -0.114216>,
      < -1.783412, 1.641130, 0.296395>
    }
    triangle {
      < -1.273308, 4.980906, -0.154589>,
      < -1.590628, 4.955067, -0.063853>,
      < -1.642918, 4.803511, 0.728624>
    }
    triangle {
      < -1.273308, 4.980906, -0.154589>,
      < -1.642918, 4.803511, 0.728624>,
      < -1.280519, 4.880578, 0.625888>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -1.642918, 4.803511, 0.728624>,
      < -1.590628, 4.955067, -0.063853>,
      < -2.228878, 4.708693, 0.205954>
    }
    triangle {
      < -1.642918, 4.803511, 0.728624>,
      < -2.228878, 4.708693, 0.205954>,
      < -2.129827, 4.617327, 0.666721>
    }
    triangle {
      < -2.129827, 4.617327, 0.666721>,
      < -2.228878, 4.708693, 0.205954>,
      < -2.482014, 4.415555, 0.265006>
    }
    triangle {
      < -2.129827, 4.617327, 0.666721>,
      < -2.482014, 4.415555, 0.265006>,
      < -2.374932, 4.311445, 0.581421>
    }
    triangle {
      < -2.129827, 4.617327, 0.666721>,
      < -2.374932, 4.311445, 0.581421>,
      < -2.101572, 3.803901, 0.799654>
    }
    triangle {
      < -2.129827, 4.617327, 0.666721>,
      < -2.101572, 3.803901, 0.799654>,
      < -1.908825, 4.226878, 0.992491>
    }
    triangle {
      < -2.129827, 4.617327, 0.666721>,
      < -1.908825, 4.226878, 0.992491>,
      < -1.630815, 4.470064, 1.089594>
    }
    triangle {
      < -2.129827, 4.617327, 0.666721>,
      < -1.630815, 4.470064, 1.089594>,
      < -1.642918, 4.803511, 0.728624>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -1.280519, 4.880578, 0.625888>,
      < -1.642918, 4.803511, 0.728624>,
      < -1.630815, 4.470064, 1.089594>
    }
    triangle {
      < -1.280519, 4.880578, 0.625888>,
      < -1.630815, 4.470064, 1.089594>,
      < -1.075780, 4.530769, 1.081253>
    }
    triangle {
      < -1.075780, 4.530769, 1.081253>,
      < -1.630815, 4.470064, 1.089594>,
      < -1.733052, 3.843242, 1.490024>
    }
    triangle {
      < -1.075780, 4.530769, 1.081253>,
      < -1.733052, 3.843242, 1.490024>,
      < -1.166408, 4.151222, 1.507141>
    }
    triangle {
      < -1.166408, 4.151222, 1.507141>,
      < -1.733052, 3.843242, 1.490024>,
      < -1.729397, 3.438161, 1.929313>
    }
    triangle {
      < -1.166408, 4.151222, 1.507141>,
      < -1.729397, 3.438161, 1.929313>,
      < -1.254015, 3.672732, 2.033899>
    }
    triangle {
      < -2.030171, 3.025035, 1.895856>,
      < -1.729397, 3.438161, 1.929313>,
      < -1.733052, 3.843242, 1.490024>
    }
    triangle {
      < -2.030171, 3.025035, 1.895856>,
      < -1.733052, 3.843242, 1.490024>,
      < -2.078001, 3.237533, 1.523019>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -1.803902, 3.890965, 1.209492>,
      < -1.733052, 3.843242, 1.490024>,
      < -1.630815, 4.470064, 1.089594>
    }
    triangle {
      < -2.101572, 3.803901, 0.799654>,
      < -1.803902, 3.890965, 1.209492>,
      < -1.908825, 4.226878, 0.992491>
    }
    triangle {
      < -1.908825, 4.226878, 0.992491>,
      < -1.803902, 3.890965, 1.209492>,
      < -1.630815, 4.470064, 1.089594>
    }
    triangle {
      < -2.078001, 3.237533, 1.523019>,
      < -1.984582, 3.398288, 1.216279>,
      < -2.161230, 2.999388, 1.153979>
    }
    triangle {
      < -2.078001, 3.237533, 1.523019>,
      < -2.161230, 2.999388, 1.153979>,
      < -2.163962, 2.786233, 1.464963>
    }
    triangle {
      < -2.163962, 2.786233, 1.464963>,
      < -2.161230, 2.999388, 1.153979>,
      < -2.190560, 2.382803, 1.200480>
    }
    triangle {
      < -1.908859, 1.975836, 0.203519>,
      < -2.107250, 2.950416, -0.048552>,
      < -2.010648, 2.861194, -0.415499>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -2.078001, 3.237533, 1.523019>,
      < -2.163962, 2.786233, 1.464963>,
      < -2.132606, 2.497405, 1.932280>
    }
    triangle {
      < -2.078001, 3.237533, 1.523019>,
      < -2.132606, 2.497405, 1.932280>,
      < -2.030171, 3.025035, 1.895856>
    }
    triangle {
      < -2.006081, 1.993751, 2.030076>,
      < -1.677819, 1.606148, 1.232651>,
      < -1.547569, 1.567267, 1.812724>
    }
    triangle {
      < -2.006081, 1.993751, 2.030076>,
      < -1.547569, 1.567267, 1.812724>,
      < -1.729165, 1.620013, 2.150219>
    }
    triangle {
      < -1.729165, 1.620013, 2.150219>,
      < -1.547569, 1.567267, 1.812724>,
      < -1.076726, 1.438651, 2.082249>
    }
    triangle {
      < -1.729165, 1.620013, 2.150219>,
      < -1.076726, 1.438651, 2.082249>,
      < -1.153635, 1.411296, 2.337730>
    }
    triangle {
      < -1.076726, 1.438651, 2.082249>,
      < -0.419190, 1.558822, 2.240149>,
      < -0.609266, 1.571267, 2.470921>
    }
    triangle {
      < -1.076726, 1.438651, 2.082249>,
      < -0.609266, 1.571267, 2.470921>,
      < -1.153635, 1.411296, 2.337730>
    }
    triangle {
      < 0.000000, 1.685680, 2.416312>,
      < -0.327114, 1.835370, 2.517562>,
      < -0.609266, 1.571267, 2.470921>
    }
    triangle {
      < 0.000000, 1.685680, 2.416312>,
      < -0.609266, 1.571267, 2.470921>,
      < -0.419190, 1.558822, 2.240149>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.000000, 1.685680, 2.416312>,
      < -0.419190, 1.558822, 2.240149>,
      < -0.273146, 0.985146, 2.250294>
    }
    triangle {
      < 0.000000, 1.685680, 2.416312>,
      < -0.273146, 0.985146, 2.250294>,
      < 0.000000, 0.993340, 2.372072>
    }
    triangle {
      < 0.000000, 0.993340, 2.372072>,
      < -0.273146, 0.985146, 2.250294>,
      < -0.337486, 0.598394, 2.259545>
    }
    triangle {
      < 0.000000, 0.993340, 2.372072>,
      < -0.337486, 0.598394, 2.259545>,
      < 0.000000, 0.727521, 2.268319>
    }
    triangle {
      < -0.530772, 5.383664, 0.658299>,
      < -0.905925, 5.384666, 0.300302>,
      < -0.901685, 5.050315, 0.474962>
    }
    triangle {
      < -0.530772, 5.383664, 0.658299>,
      < -0.901685, 5.050315, 0.474962>,
      < -0.592030, 4.903543, 0.706935>
    }
    triangle {
      < -0.901685, 5.050315, 0.474962>,
      < -1.045609, 5.199104, -0.198289>,
      < -1.273308, 4.980906, -0.154589>
    }
    triangle {
      < -0.901685, 5.050315, 0.474962>,
      < -1.273308, 4.980906, -0.154589>,
      < -1.280519, 4.880578, 0.625888>
    }
    triangle {
      < -0.901685, 5.050315, 0.474962>,
      < -0.980451, 4.731833, 0.748578>,
      < -0.567755, 4.556178, 1.015865>
    }
    triangle {
      < -0.901685, 5.050315, 0.474962>,
      < -0.567755, 4.556178, 1.015865>,
      < -0.592030, 4.903543, 0.706935>
    }
    triangle {
      < -0.592030, 4.903543, 0.706935>,
      < -0.567755, 4.556178, 1.015865>,
      < -0.239564, 4.400696, 1.076866>
    }
    triangle {
      < -0.592030, 4.903543, 0.706935>,
      < -0.239564, 4.400696, 1.076866>,
      < -0.318251, 4.703004, 0.749029>
    }
    triangle {
      < -0.318251, 4.703004, 0.749029>,
      < -0.239564, 4.400696, 1.076866>,
      < 0.000000, 4.301218, 1.043969>
    }
    triangle {
      < -0.318251, 4.703004, 0.749029>,
      < 0.000000, 4.301218, 1.043969>,
      < 0.000000, 4.550397, 0.793884>
    }
    triangle {
      < 0.000000, 5.382403, 0.794159>,
      < -0.265362, 5.383006, 0.783565>,
      < -0.318251, 4.703004, 0.749029>
    }
    triangle {
      < 0.000000, 5.382403, 0.794159>,
      < -0.318251, 4.703004, 0.749029>,
      < 0.000000, 4.550397, 0.793884>
    }
    triangle {
      < 0.000000, 4.301218, 1.043969>,
      < -0.239564, 4.400696, 1.076866>,
      < -0.253314, 4.127854, 1.326707>
    }
    triangle {
      < 0.000000, 4.301218, 1.043969>,
      < -0.253314, 4.127854, 1.326707>,
      < 0.000000, 3.949126, 1.241518>
    }
    triangle {
      < -0.291500, 3.867945, 1.625626>,
      < -0.253314, 4.127854, 1.326707>,
      < -0.721114, 4.322491, 1.143144>
    }
    triangle {
      < -0.291500, 3.867945, 1.625626>,
      < -0.721114, 4.322491, 1.143144>,
      < -0.769272, 4.095025, 1.528387>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.769272, 4.095025, 1.528387>,
      < -1.166408, 4.151222, 1.507141>,
      < -1.254015, 3.672732, 2.033899>
    }
    triangle {
      < -0.769272, 4.095025, 1.528387>,
      < -1.254015, 3.672732, 2.033899>,
      < -0.867752, 3.665836, 2.143286>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.721114, 4.322491, 1.143144>,
      < -1.075780, 4.530769, 1.081253>,
      < -0.769272, 4.095025, 1.528387>
    }
    triangle {
      < -0.117154, 2.882724, 2.450977>,
      < 0.000000, 2.841461, 2.262791>,
      < 0.000000, 3.400058, 1.856756>
    }
    triangle {
      < -0.117154, 2.882724, 2.450977>,
      < 0.000000, 3.400058, 1.856756>,
      < -0.403846, 3.560652, 2.096469>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.130649, 2.233726, 2.523536>,
      < 0.000000, 2.346143, 2.432790>,
      < 0.000000, 2.841461, 2.262791>
    }
    triangle {
      < -0.130649, 2.233726, 2.523536>,
      < 0.000000, 2.841461, 2.262791>,
      < -0.117154, 2.882724, 2.450977>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.855725, 0.305926, 2.111272>,
      < -0.337486, 0.598394, 2.259545>,
      < -0.273146, 0.985146, 2.250294>
    }
    triangle {
      < -0.855725, 0.305926, 2.111272>,
      < -0.273146, 0.985146, 2.250294>,
      < -0.912253, 0.961551, 2.075965>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.300352, 2.215570, 2.937709>,
      < -1.138060, 2.263262, 2.977416>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.138060, 2.263262, 2.977416>,
      < -1.053943, 2.341998, 2.991321>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.053943, 2.341998, 2.991321>,
      < -0.995371, 2.460758, 2.993102>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -0.995371, 2.460758, 2.993102>,
      < -0.991348, 2.644941, 2.971471>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -0.991348, 2.644941, 2.971471>,
      < -1.098083, 2.820125, 2.919829>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.098083, 2.820125, 2.919829>,
      < -1.215121, 2.878408, 2.879739>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.215121, 2.878408, 2.879739>,
      < -1.330277, 2.880464, 2.847128>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.330277, 2.880464, 2.847128>,
      < -1.472001, 2.810532, 2.815948>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.472001, 2.810532, 2.815948>,
      < -1.561671, 2.687367, 2.805973>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.561671, 2.687367, 2.805973>,
      < -1.592209, 2.530067, 2.816833>
    }
    triangle {
      < -1.471932, 2.277794, 2.881806>,
      < -1.592209, 2.530067, 2.816833>,
      < -1.554488, 2.379914, 2.845989>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.253314, 4.127854, 1.326707>,
      < -0.239564, 4.400696, 1.076866>,
      < -0.567755, 4.556178, 1.015865>
    }
    triangle {
      < -0.253314, 4.127854, 1.326707>,
      < -0.567755, 4.556178, 1.015865>,
      < -0.721114, 4.322491, 1.143144>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.000000, -4.317713, 1.255605>,
      < 0.000000, -3.538705, 1.784168>,
      < -0.354142, -3.532827, 1.804350>
    }
    triangle {
      < 0.000000, -4.317713, 1.255605>,
      < -0.354142, -3.532827, 1.804350>,
      < -0.348594, -4.288053, 1.255976>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.331188, 1.952469, -0.721568>,
      < -0.411851, 2.697264, -1.079330>,
      < 0.000000, 2.731128, -1.011640>
    }
    triangle {
      < -0.331188, 1.952469, -0.721568>,
      < 0.000000, 2.731128, -1.011640>,
      < 0.000000, 1.960532, -0.707811>
    }
    triangle {
      < 0.000000, 2.731128, -1.011640>,
      < -0.411851, 2.697264, -1.079330>,
      < -0.417627, 3.427953, -1.320746>
    }
    triangle {
      < 0.000000, 2.731128, -1.011640>,
      < -0.417627, 3.427953, -1.320746>,
      < 0.000000, 3.436128, -1.272225>
    }
    triangle {
      < 0.000000, 3.436128, -1.272225>,
      < -0.417627, 3.427953, -1.320746>,
      < -0.394958, 4.177176, -1.359815>
    }
    triangle {
      < 0.000000, 3.436128, -1.272225>,
      < -0.394958, 4.177176, -1.359815>,
      < 0.000000, 4.183734, -1.306784>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.000000, 4.779373, -1.250972>,
      < -0.372289, 4.772006, -1.286856>,
      < -0.406415, 5.139683, -1.193436>
    }
    triangle {
      < 0.000000, 4.779373, -1.250972>,
      < -0.406415, 5.139683, -1.193436>,
      < 0.000000, 5.159589, -1.245507>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -1.286229, 2.733644, -0.800674>,
      < -0.842364, 2.705815, -0.972412>,
      < -0.881610, 1.952035, -0.642381>
    }
    triangle {
      < -1.286229, 2.733644, -0.800674>,
      < -0.881610, 1.952035, -0.642381>,
      < -1.278406, 1.953809, -0.458386>
    }
    triangle {
      < -1.278406, 1.953809, -0.458386>,
      < -1.595705, 1.961731, -0.268515>,
      < -1.691266, 2.802418, -0.566645>
    }
    triangle {
      < -1.278406, 1.953809, -0.458386>,
      < -1.691266, 2.802418, -0.566645>,
      < -1.286229, 2.733644, -0.800674>
    }
    triangle {
      < -0.842364, 2.705815, -0.972412>,
      < -0.411851, 2.697264, -1.079330>,
      < -0.331188, 1.952469, -0.721568>
    }
    triangle {
      < -0.842364, 2.705815, -0.972412>,
      < -0.331188, 1.952469, -0.721568>,
      < -0.881610, 1.952035, -0.642381>
    }
    triangle {
      < -0.411851, 2.697264, -1.079330>,
      < -0.842364, 2.705815, -0.972412>,
      < -0.833102, 3.427677, -1.228459>
    }
    triangle {
      < -0.411851, 2.697264, -1.079330>,
      < -0.833102, 3.427677, -1.228459>,
      < -0.417627, 3.427953, -1.320746>
    }
    triangle {
      < -0.833102, 3.427677, -1.228459>,
      < -0.842364, 2.705815, -0.972412>,
      < -1.286229, 2.733644, -0.800674>
    }
    triangle {
      < -0.833102, 3.427677, -1.228459>,
      < -1.286229, 2.733644, -0.800674>,
      < -1.311612, 3.428961, -1.057804>
    }
    triangle {
      < -1.311612, 3.428961, -1.057804>,
      < -1.286229, 2.733644, -0.800674>,
      < -1.691266, 2.802418, -0.566645>
    }
    triangle {
      < -1.311612, 3.428961, -1.057804>,
      < -1.691266, 2.802418, -0.566645>,
      < -1.713060, 3.430965, -0.885488>
    }
    triangle {
      < -1.311612, 3.428961, -1.057804>,
      < -1.713060, 3.430965, -0.885488>,
      < -1.692724, 4.074691, -0.865690>
    }
    triangle {
      < -1.311612, 3.428961, -1.057804>,
      < -1.692724, 4.074691, -0.865690>,
      < -1.220386, 4.176666, -1.094361>
    }
    triangle {
      < -1.220386, 4.176666, -1.094361>,
      < -0.759639, 4.176108, -1.275736>,
      < -0.833102, 3.427677, -1.228459>
    }
    triangle {
      < -1.220386, 4.176666, -1.094361>,
      < -0.833102, 3.427677, -1.228459>,
      < -1.311612, 3.428961, -1.057804>
    }
    triangle {
      < -0.759639, 4.176108, -1.275736>,
      < -0.394958, 4.177176, -1.359815>,
      < -0.417627, 3.427953, -1.320746>
    }
    triangle {
      < -0.759639, 4.176108, -1.275736>,
      < -0.417627, 3.427953, -1.320746>,
      < -0.833102, 3.427677, -1.228459>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.905801, 5.111265, -0.938432>,
      < -0.733256, 5.140341, -1.143047>,
      < -0.686176, 4.772114, -1.228553>
    }
    triangle {
      < -0.905801, 5.111265, -0.938432>,
      < -0.686176, 4.772114, -1.228553>,
      < -1.129160, 4.772320, -1.039785>
    }
    triangle {
      < -0.733256, 5.140341, -1.143047>,
      < -0.406415, 5.139683, -1.193436>,
      < -0.372289, 4.772006, -1.286856>
    }
    triangle {
      < -0.733256, 5.140341, -1.143047>,
      < -0.372289, 4.772006, -1.286856>,
      < -0.686176, 4.772114, -1.228553>
    }
    triangle {
      < -1.209537, 1.626351, -0.268946>,
      < -1.278406, 1.953809, -0.458386>,
      < -0.881610, 1.952035, -0.642381>
    }
    triangle {
      < -1.209537, 1.626351, -0.268946>,
      < -0.881610, 1.952035, -0.642381>,
      < -0.870650, 1.624373, -0.491663>
    }
    triangle {
      < -0.870650, 1.624373, -0.491663>,
      < -0.881610, 1.952035, -0.642381>,
      < -0.331188, 1.952469, -0.721568>
    }
    triangle {
      < -0.870650, 1.624373, -0.491663>,
      < -0.331188, 1.952469, -0.721568>,
      < -0.347101, 1.625607, -0.536655>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.347101, 1.625607, -0.536655>,
      < -0.281991, 0.951491, -0.199283>,
      < -0.761863, 0.935459, -0.192583>
    }
    triangle {
      < -0.347101, 1.625607, -0.536655>,
      < -0.761863, 0.935459, -0.192583>,
      < -0.870650, 1.624373, -0.491663>
    }
    triangle {
      < -0.870650, 1.624373, -0.491663>,
      < -0.761863, 0.935459, -0.192583>,
      < -1.153018, 0.924817, -0.087208>
    }
    triangle {
      < -0.870650, 1.624373, -0.491663>,
      < -1.153018, 0.924817, -0.087208>,
      < -1.209537, 1.626351, -0.268946>
    }
    triangle {
      < -1.209537, 1.626351, -0.268946>,
      < -1.153018, 0.924817, -0.087208>,
      < -1.421312, 0.928829, 0.106105>
    }
    triangle {
      < -1.209537, 1.626351, -0.268946>,
      < -1.421312, 0.928829, 0.106105>,
      < -1.504927, 1.630030, -0.114216>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -1.504927, 1.630030, -0.114216>,
      < -1.595705, 1.961731, -0.268515>,
      < -1.278406, 1.953809, -0.458386>
    }
    triangle {
      < -1.504927, 1.630030, -0.114216>,
      < -1.278406, 1.953809, -0.458386>,
      < -1.209537, 1.626351, -0.268946>
    }
    triangle {
      < 0.000000, 1.633274, -0.388205>,
      < -0.347101, 1.625607, -0.536655>,
      < -0.331188, 1.952469, -0.721568>
    }
    triangle {
      < 0.000000, 1.633274, -0.388205>,
      < -0.331188, 1.952469, -0.721568>,
      < 0.000000, 1.960532, -0.707811>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.000000, 1.633274, -0.388205>,
      < 0.000000, 0.959683, -0.069663>,
      < -0.281991, 0.951491, -0.199283>
    }
    triangle {
      < 0.000000, 1.633274, -0.388205>,
      < -0.281991, 0.951491, -0.199283>,
      < -0.347101, 1.625607, -0.536655>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -2.163962, 2.786233, 1.464963>,
      < -2.190560, 2.382803, 1.200480>,
      < -2.006081, 1.993751, 2.030076>
    }
    triangle {
      < -2.163962, 2.786233, 1.464963>,
      < -2.006081, 1.993751, 2.030076>,
      < -2.132606, 2.497405, 1.932280>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -1.672387, 4.390581, -0.737402>,
      < -1.715634, 4.757394, -0.424567>,
      < -1.431619, 4.809371, -0.508151>
    }
    triangle {
      < -1.672387, 4.390581, -0.737402>,
      < -1.431619, 4.809371, -0.508151>,
      < -1.311563, 4.775741, -0.821882>
    }
    triangle {
      < -0.980451, 4.731833, 0.748578>,
      < -1.075780, 4.530769, 1.081253>,
      < -0.721114, 4.322491, 1.143144>
    }
    triangle {
      < -0.980451, 4.731833, 0.748578>,
      < -0.721114, 4.322491, 1.143144>,
      < -0.567755, 4.556178, 1.015865>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.179637, -4.620719, 0.468996>,
      < -0.298104, -4.734981, -0.329984>,
      < -0.255535, -4.694487, -0.625129>
    }
    triangle {
      < -0.179637, -4.620719, 0.468996>,
      < -0.255535, -4.694487, -0.625129>,
      < 0.000000, -4.602162, -0.492641>
    }
    triangle {
      < -0.179637, -4.620719, 0.468996>,
      < 0.000000, -4.602162, -0.492641>,
      < 0.000000, -4.651278, 0.474008>
    }
    triangle {
      < -0.179637, -4.620719, 0.468996>,
      < 0.000000, -4.651278, 0.474008>,
      < 0.000000, -4.317713, 1.255605>
    }
    triangle {
      < -0.179637, -4.620719, 0.468996>,
      < 0.000000, -4.317713, 1.255605>,
      < -0.348594, -4.288053, 1.255976>
    }
    triangle {
      < -1.311563, 4.775741, -0.821882>,
      < -1.431619, 4.809371, -0.508151>,
      < -1.141270, 5.206872, -0.527612>
    }
    triangle {
      < -1.311563, 4.775741, -0.821882>,
      < -1.141270, 5.206872, -0.527612>,
      < -1.044887, 5.189893, -0.787099>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.733256, 5.140341, -1.143047>,
      < -0.905801, 5.111265, -0.938432>,
      < -0.855210, 5.383354, -0.726514>
    }
    triangle {
      < -0.733256, 5.140341, -1.143047>,
      < -0.855210, 5.383354, -0.726514>,
      < -0.647537, 5.383266, -0.933723>
    }
    triangle {
      < -0.406415, 5.139683, -1.193436>,
      < -0.733256, 5.140341, -1.143047>,
      < -0.647537, 5.383266, -0.933723>
    }
    triangle {
      < -0.406415, 5.139683, -1.193436>,
      < -0.647537, 5.383266, -0.933723>,
      < -0.429972, 5.383253, -1.057937>
    }
    triangle {
      < 0.000000, 5.159589, -1.245507>,
      < -0.406415, 5.139683, -1.193436>,
      < -0.429972, 5.383253, -1.057937>
    }
    triangle {
      < 0.000000, 5.159589, -1.245507>,
      < -0.429972, 5.383253, -1.057937>,
      < 0.000000, 5.383317, -1.144730>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < -0.364813, 6.559850, 0.003741>,
      < -0.370275, 6.538164, 0.118853>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < -0.370275, 6.538164, 0.118853>,
      < -0.324684, 6.512660, 0.254128>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < -0.324684, 6.512660, 0.254128>,
      < -0.189822, 6.487049, 0.386961>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < -0.189822, 6.487049, 0.386961>,
      < -0.094412, 6.477975, 0.433420>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < -0.094412, 6.477975, 0.433420>,
      < 0.000000, 6.477004, 0.437311>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < 0.000000, 6.477004, 0.437311>,
      < 0.000000, 6.614027, -0.282431>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < 0.000000, 6.614027, -0.282431>,
      < -0.153586, 6.607885, -0.250214>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < -0.153586, 6.607885, -0.250214>,
      < -0.231797, 6.599135, -0.204098>
    }
    triangle {
      < -0.333556, 6.576173, -0.082966>,
      < -0.231797, 6.599135, -0.204098>,
      < -0.306453, 6.584560, -0.127167>
    }
    triangle {
      < -1.045609, 5.199104, -0.198289>,
      < -0.901685, 5.050315, 0.474962>,
      < -0.905925, 5.384666, 0.300302>
    }
    triangle {
      < -1.045609, 5.199104, -0.198289>,
      < -0.905925, 5.384666, 0.300302>,
      < -1.032748, 5.384184, -0.063988>
    }
    triangle {
      < -1.141270, 5.206872, -0.527612>,
      < -1.045609, 5.199104, -0.198289>,
      < -1.032748, 5.384184, -0.063988>
    }
    triangle {
      < -1.141270, 5.206872, -0.527612>,
      < -1.032748, 5.384184, -0.063988>,
      < -1.017555, 5.383738, -0.373970>
    }
    triangle {
      < -1.044887, 5.189893, -0.787099>,
      < -1.141270, 5.206872, -0.527612>,
      < -1.017555, 5.383738, -0.373970>
    }
    triangle {
      < -1.044887, 5.189893, -0.787099>,
      < -1.017555, 5.383738, -0.373970>,
      < -0.930606, 5.383365, -0.607457>
    }
    triangle {
      < -0.905801, 5.111265, -0.938432>,
      < -1.044887, 5.189893, -0.787099>,
      < -0.930606, 5.383365, -0.607457>
    }
    triangle {
      < -0.905801, 5.111265, -0.938432>,
      < -0.930606, 5.383365, -0.607457>,
      < -0.855210, 5.383354, -0.726514>
    }
    triangle {
      < -1.141270, 5.206872, -0.527612>,
      < -1.273308, 4.980906, -0.154589>,
      < -1.045609, 5.199104, -0.198289>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -1.129160, 4.772320, -1.039785>,
      < -1.311563, 4.775741, -0.821882>,
      < -1.044887, 5.189893, -0.787099>
    }
    triangle {
      < -1.129160, 4.772320, -1.039785>,
      < -1.044887, 5.189893, -0.787099>,
      < -0.905801, 5.111265, -0.938432>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -1.604052, -4.133869, 0.986076>,
      < -1.741470, -3.998837, 1.006610>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -1.741470, -3.998837, 1.006610>,
      < -1.908456, -3.883644, 0.925504>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -1.908456, -3.883644, 0.925504>,
      < -2.030397, -3.861973, 0.658580>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -2.030397, -3.861973, 0.658580>,
      < -2.034378, -3.979250, 0.418934>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -2.034378, -3.979250, 0.418934>,
      < -1.950404, -4.145929, 0.209101>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -1.950404, -4.145929, 0.209101>,
      < -1.738226, -4.347697, 0.140237>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -1.738226, -4.347697, 0.140237>,
      < -1.517964, -4.450105, 0.247368>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -1.517964, -4.450105, 0.247368>,
      < -1.401765, -4.475097, 0.374795>
    }
    triangle {
      < -1.415966, -4.349393, 0.820869>,
      < -1.401765, -4.475097, 0.374795>,
      < -1.368444, -4.442959, 0.599520>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.318251, 4.703004, 0.749029>,
      < -0.265362, 5.383006, 0.783565>,
      < -0.530772, 5.383664, 0.658299>
    }
    triangle {
      < -0.318251, 4.703004, 0.749029>,
      < -0.530772, 5.383664, 0.658299>,
      < -0.592030, 4.903543, 0.706935>
    }
    triangle {
      < 0.000000, 3.949126, 1.241518>,
      < -0.253314, 4.127854, 1.326707>,
      < -0.291500, 3.867945, 1.625626>
    }
    triangle {
      < 0.000000, 3.949126, 1.241518>,
      < -0.291500, 3.867945, 1.625626>,
      < 0.000000, 3.661831, 1.566266>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.769272, 4.095025, 1.528387>,
      < -0.867752, 3.665836, 2.143286>,
      < -0.475173, 3.470336, 2.277757>
    }
    triangle {
      < -0.769272, 4.095025, 1.528387>,
      < -0.475173, 3.470336, 2.277757>,
      < -0.403846, 3.560652, 2.096469>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.291500, 3.867945, 1.625626>,
      < -0.403846, 3.560652, 2.096469>,
      < 0.000000, 3.400058, 1.856756>
    }
    triangle {
      < -0.291500, 3.867945, 1.625626>,
      < 0.000000, 3.400058, 1.856756>,
      < 0.000000, 3.661831, 1.566266>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.117154, 2.882724, 2.450977>,
      < -0.403846, 3.560652, 2.096469>,
      < -0.475173, 3.470336, 2.277757>
    }
    triangle {
      < -0.327114, 1.835370, 2.517562>,
      < 0.000000, 1.685680, 2.416312>,
      < 0.000000, 2.346143, 2.432790>
    }
    triangle {
      < -0.327114, 1.835370, 2.517562>,
      < 0.000000, 2.346143, 2.432790>,
      < -0.130649, 2.233726, 2.523536>
    }
    triangle {
      < -2.006081, 1.993751, 2.030076>,
      < -2.190560, 2.382803, 1.200480>,
      < -1.677819, 1.606148, 1.232651>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.000000, -1.527481, 2.176464>,
      < -0.200286, -1.505385, 2.203278>,
      < -0.380002, -2.254292, 2.142292>
    }
    triangle {
      < 0.000000, -1.527481, 2.176464>,
      < -0.380002, -2.254292, 2.142292>,
      < 0.000000, -2.270840, 2.094989>
    }
    triangle {
      < -0.200286, -1.505385, 2.203278>,
      < 0.000000, -1.527481, 2.176464>,
      < 0.000000, -0.786156, 2.144047>
    }
    triangle {
      < -0.200286, -1.505385, 2.203278>,
      < 0.000000, -0.786156, 2.144047>,
      < -0.034745, -0.781618, 2.138963>
    }
    triangle {
      < -2.015426, 3.432471, -0.791534>,
      < -2.010648, 2.861194, -0.415499>,
      < -2.107250, 2.950416, -0.048552>
    }
    triangle {
      < -2.015426, 3.432471, -0.791534>,
      < -2.107250, 2.950416, -0.048552>,
      < -1.952047, 3.541013, -0.074353>
    }
    triangle {
      < -2.101572, 3.803901, 0.799654>,
      < -1.939731, 3.584849, 0.361395>,
      < -1.984582, 3.398288, 1.216279>
    }
    triangle {
      < -1.733052, 3.843242, 1.490024>,
      < -1.803902, 3.890965, 1.209492>,
      < -1.984582, 3.398288, 1.216279>
    }
    triangle {
      < -1.733052, 3.843242, 1.490024>,
      < -1.984582, 3.398288, 1.216279>,
      < -2.078001, 3.237533, 1.523019>
    }
    triangle {
      < -1.939731, 3.584849, 0.361395>,
      < -2.134239, 2.999644, 0.500486>,
      < -2.161230, 2.999388, 1.153979>
    }
    triangle {
      < -1.939731, 3.584849, 0.361395>,
      < -2.161230, 2.999388, 1.153979>,
      < -1.984582, 3.398288, 1.216279>
    }
    triangle {
      < -1.952047, 3.541013, -0.074353>,
      < -2.107250, 2.950416, -0.048552>,
      < -2.134239, 2.999644, 0.500486>
    }
    triangle {
      < -1.952047, 3.541013, -0.074353>,
      < -2.134239, 2.999644, 0.500486>,
      < -1.939731, 3.584849, 0.361395>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -1.740981, 1.647860, 0.799099>,
      < -1.677819, 1.606148, 1.232651>
    }
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -1.677819, 1.606148, 1.232651>,
      < -2.190560, 2.382803, 1.200480>
    }
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -1.908859, 1.975836, 0.203519>,
      < -1.783412, 1.641130, 0.296395>
    }
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -1.783412, 1.641130, 0.296395>,
      < -1.740981, 1.647860, 0.799099>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -2.134239, 2.999644, 0.500486>,
      < -2.107250, 2.950416, -0.048552>
    }
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -2.107250, 2.950416, -0.048552>,
      < -1.908859, 1.975836, 0.203519>
    }
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -2.190560, 2.382803, 1.200480>,
      < -2.161230, 2.999388, 1.153979>
    }
    triangle {
      < -1.985498, 2.028215, 0.709301>,
      < -2.161230, 2.999388, 1.153979>,
      < -2.134239, 2.999644, 0.500486>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -1.952047, 3.541013, -0.074353>,
      < -1.939731, 3.584849, 0.361395>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -1.939731, 3.584849, 0.361395>,
      < -2.101572, 3.803901, 0.799654>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -2.101572, 3.803901, 0.799654>,
      < -2.374932, 4.311445, 0.581421>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -2.374932, 4.311445, 0.581421>,
      < -2.482014, 4.415555, 0.265006>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -2.482014, 4.415555, 0.265006>,
      < -2.424494, 4.345810, -0.180659>
    }
    triangle {
      < -2.083994, 3.764152, -0.526183>,
      < -2.424494, 4.345810, -0.180659>,
      < -2.268412, 4.117446, -0.395912>
    }
    triangle {
      < -1.984582, 3.398288, 1.216279>,
      < -1.803902, 3.890965, 1.209492>,
      < -2.101572, 3.803901, 0.799654>
    }
    triangle {
      < -1.692724, 4.074691, -0.865690>,
      < -1.998452, 3.933387, -0.729109>,
      < -2.029075, 4.281486, -0.593433>
    }
    triangle {
      < -1.692724, 4.074691, -0.865690>,
      < -2.029075, 4.281486, -0.593433>,
      < -1.672387, 4.390581, -0.737402>
    }
    triangle {
      < -1.220386, 4.176666, -1.094361>,
      < -1.692724, 4.074691, -0.865690>,
      < -1.672387, 4.390581, -0.737402>
    }
    triangle {
      < -1.220386, 4.176666, -1.094361>,
      < -1.672387, 4.390581, -0.737402>,
      < -1.129160, 4.772320, -1.039785>
    }
    triangle {
      < -0.759639, 4.176108, -1.275736>,
      < -1.220386, 4.176666, -1.094361>,
      < -1.129160, 4.772320, -1.039785>
    }
    triangle {
      < -0.759639, 4.176108, -1.275736>,
      < -1.129160, 4.772320, -1.039785>,
      < -0.686176, 4.772114, -1.228553>
    }
    triangle {
      < -0.394958, 4.177176, -1.359815>,
      < -0.759639, 4.176108, -1.275736>,
      < -0.686176, 4.772114, -1.228553>
    }
    triangle {
      < -0.394958, 4.177176, -1.359815>,
      < -0.686176, 4.772114, -1.228553>,
      < -0.372289, 4.772006, -1.286856>
    }
    triangle {
      < 0.000000, 4.183734, -1.306784>,
      < -0.394958, 4.177176, -1.359815>,
      < -0.372289, 4.772006, -1.286856>
    }
    triangle {
      < 0.000000, 4.183734, -1.306784>,
      < -0.372289, 4.772006, -1.286856>,
      < 0.000000, 4.779373, -1.250972>
    }
    triangle {
      < -0.676174, 0.356651, -0.147042>,
      < -0.264625, 0.388178, -0.173283>,
      < -0.256247, -0.378244, -0.343827>
    }
    triangle {
      < -0.676174, 0.356651, -0.147042>,
      < -0.256247, -0.378244, -0.343827>,
      < -0.775331, -0.395819, -0.293731>
    }
    triangle {
      < -1.023351, 0.346405, -0.053167>,
      < -0.676174, 0.356651, -0.147042>,
      < -0.775331, -0.395819, -0.293731>
    }
    triangle {
      < -1.023351, 0.346405, -0.053167>,
      < -0.775331, -0.395819, -0.293731>,
      < -1.134307, -0.395637, -0.215442>
    }
    triangle {
      < -1.324927, 0.351883, 0.083510>,
      < -1.023351, 0.346405, -0.053167>,
      < -1.134307, -0.395637, -0.215442>
    }
    triangle {
      < -1.324927, 0.351883, 0.083510>,
      < -1.134307, -0.395637, -0.215442>,
      < -1.477786, -0.393219, -0.084196>
    }
    triangle {
      < -1.567689, 0.343412, 0.374270>,
      < -1.324927, 0.351883, 0.083510>,
      < -1.477786, -0.393219, -0.084196>
    }
    triangle {
      < -1.567689, 0.343412, 0.374270>,
      < -1.477786, -0.393219, -0.084196>,
      < -1.734500, -0.418211, 0.226525>
    }
    triangle {
      < -1.667724, 0.325124, 0.861139>,
      < -1.567689, 0.343412, 0.374270>,
      < -1.734500, -0.418211, 0.226525>
    }
    triangle {
      < -1.667724, 0.325124, 0.861139>,
      < -1.734500, -0.418211, 0.226525>,
      < -1.835413, -0.461101, 0.782676>
    }
    triangle {
      < -1.630292, 0.298432, 0.980606>,
      < -1.667724, 0.325124, 0.861139>,
      < -1.835413, -0.461101, 0.782676>
    }
    triangle {
      < -1.368342, 0.290731, 1.693234>,
      < -1.630292, 0.298432, 0.980606>,
      < -1.835413, -0.461101, 0.782676>
    }
    triangle {
      < -1.368342, 0.290731, 1.693234>,
      < -1.835413, -0.461101, 0.782676>,
      < -1.615223, -0.478884, 1.642453>
    }
    triangle {
      < -0.855725, 0.305926, 2.111272>,
      < -1.368342, 0.290731, 1.693234>,
      < -1.615223, -0.478884, 1.642453>
    }
    triangle {
      < -0.855725, 0.305926, 2.111272>,
      < -1.615223, -0.478884, 1.642453>,
      < -1.088540, -0.502982, 2.096247>
    }
    triangle {
      < -0.337486, 0.598394, 2.259545>,
      < -0.855725, 0.305926, 2.111272>,
      < -0.461192, 0.053048, 2.272134>
    }
    triangle {
      < 0.000000, 0.727521, 2.268319>,
      < -0.337486, 0.598394, 2.259545>,
      < -0.265781, 0.220905, 2.228825>
    }
    triangle {
      < 0.000000, 0.727521, 2.268319>,
      < -0.265781, 0.220905, 2.228825>,
      < 0.000000, 0.286501, 2.168349>
    }
    triangle {
      < -0.265781, 0.220905, 2.228825>,
      < -0.337486, 0.598394, 2.259545>,
      < -0.461192, 0.053048, 2.272134>
    }
    triangle {
      < -0.066715, -0.604138, 2.139349>,
      < -0.030486, -0.538444, 2.142306>,
      < -0.265781, 0.220905, 2.228825>
    }
    triangle {
      < -0.066715, -0.604138, 2.139349>,
      < -0.265781, 0.220905, 2.228825>,
      < -0.461192, 0.053048, 2.272134>
    }
    triangle {
      < 0.000000, -0.760712, 2.040363>,
      < 0.000000, -0.550260, 2.040503>,
      < -0.015988, -0.566989, 2.039040>
    }
    triangle {
      < 0.000000, -0.760712, 2.040363>,
      < -0.015988, -0.566989, 2.039040>,
      < -0.043521, -0.616914, 2.036793>
    }
    triangle {
      < 0.000000, -0.760712, 2.040363>,
      < -0.043521, -0.616914, 2.036793>,
      < -0.053526, -0.666143, 2.035450>
    }
    triangle {
      < 0.000000, -0.760712, 2.040363>,
      < -0.053526, -0.666143, 2.035450>,
      < -0.040219, -0.704352, 2.036748>
    }
    triangle {
      < 0.000000, -0.760712, 2.040363>,
      < -0.040219, -0.704352, 2.036748>,
      < -0.019225, -0.758992, 2.036500>
    }
    triangle {
      < 0.000000, 0.418408, -0.112867>,
      < -0.264625, 0.388178, -0.173283>,
      < -0.281991, 0.951491, -0.199283>
    }
    triangle {
      < 0.000000, 0.418408, -0.112867>,
      < -0.281991, 0.951491, -0.199283>,
      < 0.000000, 0.959683, -0.069663>
    }
    triangle {
      < -0.473522, -1.293983, 2.269722>,
      < -1.321224, -1.299337, 2.064278>,
      < -1.469949, -2.124545, 2.087185>
    }
    triangle {
      < -0.473522, -1.293983, 2.269722>,
      < -1.469949, -2.124545, 2.087185>,
      < -0.891979, -2.200235, 2.236348>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.348594, -4.288053, 1.255976>,
      < -0.354142, -3.532827, 1.804350>,
      < -1.017310, -3.521789, 1.843347>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.769272, 4.095025, 1.528387>,
      < -0.403846, 3.560652, 2.096469>,
      < -0.291500, 3.867945, 1.625626>
    }
    triangle {
      < -0.980451, 4.731833, 0.748578>,
      < -0.901685, 5.050315, 0.474962>,
      < -1.280519, 4.880578, 0.625888>
    }
    triangle {
      < -1.075780, 4.530769, 1.081253>,
      < -0.980451, 4.731833, 0.748578>,
      < -1.280519, 4.880578, 0.625888>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.769272, 4.095025, 1.528387>,
      < -1.075780, 4.530769, 1.081253>,
      < -1.166408, 4.151222, 1.507141>
    }
    triangle {
      < -2.547276, -2.972060, -0.173055>,
      < -2.248718, -3.572636, -0.898282>,
      < -2.151490, -3.938636, -0.313752>
    }
    triangle {
      < -2.547276, -2.972060, -0.173055>,
      < -2.151490, -3.938636, -0.313752>,
      < -2.340441, -3.563589, 0.158397>
    }
    triangle {
      < -2.248718, -3.572636, -0.898282>,
      < -1.494346, -4.284712, -1.156904>,
      < -1.674065, -4.392637, -0.468703>
    }
    triangle {
      < -2.248718, -3.572636, -0.898282>,
      < -1.674065, -4.392637, -0.468703>,
      < -2.151490, -3.938636, -0.313752>
    }
    triangle {
      < -1.494346, -4.284712, -1.156904>,
      < -0.711234, -4.646127, -0.783033>,
      < -1.178450, -4.623069, -0.227645>
    }
    triangle {
      < -1.494346, -4.284712, -1.156904>,
      < -1.178450, -4.623069, -0.227645>,
      < -1.674065, -4.392637, -0.468703>
    }
    triangle {
      < -0.711234, -4.646127, -0.783033>,
      < -0.298104, -4.734981, -0.329984>,
      < -0.916989, -4.679303, 0.059080>
    }
    triangle {
      < -0.711234, -4.646127, -0.783033>,
      < -0.916989, -4.679303, 0.059080>,
      < -1.178450, -4.623069, -0.227645>
    }
    triangle {
      < -0.298104, -4.734981, -0.329984>,
      < -0.179637, -4.620719, 0.468996>,
      < -0.842014, -4.606988, 0.564737>
    }
    triangle {
      < -0.298104, -4.734981, -0.329984>,
      < -0.842014, -4.606988, 0.564737>,
      < -0.916989, -4.679303, 0.059080>
    }
    triangle {
      < -0.179637, -4.620719, 0.468996>,
      < -0.348594, -4.288053, 1.255976>,
      < -0.948943, -4.396451, 1.062799>
    }
    triangle {
      < -0.179637, -4.620719, 0.468996>,
      < -0.948943, -4.396451, 1.062799>,
      < -0.842014, -4.606988, 0.564737>
    }
    triangle {
      < -0.348594, -4.288053, 1.255976>,
      < -1.017310, -3.521789, 1.843347>,
      < -1.372159, -3.911500, 1.434534>
    }
    triangle {
      < -0.348594, -4.288053, 1.255976>,
      < -1.372159, -3.911500, 1.434534>,
      < -0.948943, -4.396451, 1.062799>
    }
    triangle {
      < -1.017310, -3.521789, 1.843347>,
      < -1.505880, -3.041700, 1.916351>,
      < -1.681364, -3.607662, 1.480737>
    }
    triangle {
      < -1.017310, -3.521789, 1.843347>,
      < -1.681364, -3.607662, 1.480737>,
      < -1.372159, -3.911500, 1.434534>
    }
    triangle {
      < -1.505880, -3.041700, 1.916351>,
      < -2.099578, -2.632143, 1.627991>,
      < -2.057103, -3.348463, 1.298239>
    }
    triangle {
      < -1.505880, -3.041700, 1.916351>,
      < -2.057103, -3.348463, 1.298239>,
      < -1.681364, -3.607662, 1.480737>
    }
    triangle {
      < -2.099578, -2.632143, 1.627991>,
      < -2.533123, -2.555095, 0.678978>,
      < -2.331484, -3.299701, 0.697630>
    }
    triangle {
      < -2.099578, -2.632143, 1.627991>,
      < -2.331484, -3.299701, 0.697630>,
      < -2.057103, -3.348463, 1.298239>
    }
    triangle {
      < -2.533123, -2.555095, 0.678978>,
      < -2.547276, -2.972060, -0.173055>,
      < -2.340441, -3.563589, 0.158397>
    }
    triangle {
      < -2.533123, -2.555095, 0.678978>,
      < -2.340441, -3.563589, 0.158397>,
      < -2.331484, -3.299701, 0.697630>
    }
    triangle {
      < -1.681364, -3.607662, 1.480737>,
      < -2.057103, -3.348463, 1.298239>,
      < -1.908456, -3.883644, 0.925504>
    }
    triangle {
      < -1.681364, -3.607662, 1.480737>,
      < -1.908456, -3.883644, 0.925504>,
      < -1.741470, -3.998837, 1.006610>
    }
    triangle {
      < -2.057103, -3.348463, 1.298239>,
      < -2.331484, -3.299701, 0.697630>,
      < -2.030397, -3.861973, 0.658580>
    }
    triangle {
      < -2.057103, -3.348463, 1.298239>,
      < -2.030397, -3.861973, 0.658580>,
      < -1.908456, -3.883644, 0.925504>
    }
    triangle {
      < -2.331484, -3.299701, 0.697630>,
      < -2.340441, -3.563589, 0.158397>,
      < -2.034378, -3.979250, 0.418934>
    }
    triangle {
      < -2.331484, -3.299701, 0.697630>,
      < -2.034378, -3.979250, 0.418934>,
      < -2.030397, -3.861973, 0.658580>
    }
    triangle {
      < -2.340441, -3.563589, 0.158397>,
      < -2.151490, -3.938636, -0.313752>,
      < -1.950404, -4.145929, 0.209101>
    }
    triangle {
      < -2.340441, -3.563589, 0.158397>,
      < -1.950404, -4.145929, 0.209101>,
      < -2.034378, -3.979250, 0.418934>
    }
    triangle {
      < -2.151490, -3.938636, -0.313752>,
      < -1.674065, -4.392637, -0.468703>,
      < -1.738226, -4.347697, 0.140237>
    }
    triangle {
      < -2.151490, -3.938636, -0.313752>,
      < -1.738226, -4.347697, 0.140237>,
      < -1.950404, -4.145929, 0.209101>
    }
    triangle {
      < -1.674065, -4.392637, -0.468703>,
      < -1.178450, -4.623069, -0.227645>,
      < -1.517964, -4.450105, 0.247368>
    }
    triangle {
      < -1.674065, -4.392637, -0.468703>,
      < -1.517964, -4.450105, 0.247368>,
      < -1.738226, -4.347697, 0.140237>
    }
    triangle {
      < -1.178450, -4.623069, -0.227645>,
      < -0.916989, -4.679303, 0.059080>,
      < -1.401765, -4.475097, 0.374795>
    }
    triangle {
      < -1.178450, -4.623069, -0.227645>,
      < -1.401765, -4.475097, 0.374795>,
      < -1.517964, -4.450105, 0.247368>
    }
    triangle {
      < -0.916989, -4.679303, 0.059080>,
      < -0.842014, -4.606988, 0.564737>,
      < -1.368444, -4.442959, 0.599520>
    }
    triangle {
      < -0.916989, -4.679303, 0.059080>,
      < -1.368444, -4.442959, 0.599520>,
      < -1.401765, -4.475097, 0.374795>
    }
    triangle {
      < -0.842014, -4.606988, 0.564737>,
      < -0.948943, -4.396451, 1.062799>,
      < -1.415966, -4.349393, 0.820869>
    }
    triangle {
      < -0.842014, -4.606988, 0.564737>,
      < -1.415966, -4.349393, 0.820869>,
      < -1.368444, -4.442959, 0.599520>
    }
    triangle {
      < -0.948943, -4.396451, 1.062799>,
      < -1.372159, -3.911500, 1.434534>,
      < -1.604052, -4.133869, 0.986076>
    }
    triangle {
      < -0.948943, -4.396451, 1.062799>,
      < -1.604052, -4.133869, 0.986076>,
      < -1.415966, -4.349393, 0.820869>
    }
    triangle {
      < -1.372159, -3.911500, 1.434534>,
      < -1.681364, -3.607662, 1.480737>,
      < -1.741470, -3.998837, 1.006610>
    }
    triangle {
      < -1.372159, -3.911500, 1.434534>,
      < -1.741470, -3.998837, 1.006610>,
      < -1.604052, -4.133869, 0.986076>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < -0.030486, -0.538444, 2.142306>,
      < -0.066715, -0.604138, 2.139349>,
      < -0.043521, -0.616914, 2.036793>
    }
    triangle {
      < -0.030486, -0.538444, 2.142306>,
      < -0.043521, -0.616914, 2.036793>,
      < -0.015988, -0.566989, 2.039040>
    }
    triangle {
      < -0.066715, -0.604138, 2.139349>,
      < -0.079880, -0.668916, 2.137583>,
      < -0.053526, -0.666143, 2.035450>
    }
    triangle {
      < -0.066715, -0.604138, 2.139349>,
      < -0.053526, -0.666143, 2.035450>,
      < -0.043521, -0.616914, 2.036793>
    }
    triangle {
      < -0.079880, -0.668916, 2.137583>,
      < -0.062370, -0.719194, 2.139291>,
      < -0.040219, -0.704352, 2.036748>
    }
    triangle {
      < -0.079880, -0.668916, 2.137583>,
      < -0.040219, -0.704352, 2.036748>,
      < -0.053526, -0.666143, 2.035450>
    }
    triangle {
      < -0.062370, -0.719194, 2.139291>,
      < -0.034745, -0.781618, 2.138963>,
      < -0.019225, -0.758992, 2.036500>
    }
    triangle {
      < -0.062370, -0.719194, 2.139291>,
      < -0.019225, -0.758992, 2.036500>,
      < -0.040219, -0.704352, 2.036748>
    }
    triangle {
      < -0.034745, -0.781618, 2.138963>,
      < 0.000000, -0.786156, 2.144047>,
      < 0.000000, -0.760712, 2.040363>
    }
    triangle {
      < -0.034745, -0.781618, 2.138963>,
      < 0.000000, -0.760712, 2.040363>,
      < -0.019225, -0.758992, 2.036500>
    }
    triangle {
      < 0.000000, -0.518706, 2.144231>,
      < -0.030486, -0.538444, 2.142306>,
      < -0.015988, -0.566989, 2.039040>
    }
    triangle {
      < 0.000000, -0.518706, 2.144231>,
      < -0.015988, -0.566989, 2.039040>,
      < 0.000000, -0.550260, 2.040503>
    }
    triangle {
      < -0.429972, 5.383253, -1.057937>,
      < -0.647537, 5.383266, -0.933723>,
      < -0.580662, 6.226851, -0.647512>
    }
    triangle {
      < -0.429972, 5.383253, -1.057937>,
      < -0.580662, 6.226851, -0.647512>,
      < -0.385395, 6.248701, -0.762645>
    }
    triangle {
      < -0.647537, 5.383266, -0.933723>,
      < -0.855210, 5.383354, -0.726514>,
      < -0.767051, 6.190462, -0.455439>
    }
    triangle {
      < -0.647537, 5.383266, -0.933723>,
      < -0.767051, 6.190462, -0.455439>,
      < -0.580662, 6.226851, -0.647512>
    }
    triangle {
      < -0.855210, 5.383354, -0.726514>,
      < -0.930606, 5.383365, -0.607457>,
      < -0.834720, 6.169515, -0.345086>
    }
    triangle {
      < -0.855210, 5.383354, -0.726514>,
      < -0.834720, 6.169515, -0.345086>,
      < -0.767051, 6.190462, -0.455439>
    }
    triangle {
      < -0.930606, 5.383365, -0.607457>,
      < -1.017555, 5.383738, -0.373970>,
      < -0.912757, 6.128767, -0.128607>
    }
    triangle {
      < -0.930606, 5.383365, -0.607457>,
      < -0.912757, 6.128767, -0.128607>,
      < -0.834720, 6.169515, -0.345086>
    }
    triangle {
      < -1.017555, 5.383738, -0.373970>,
      < -1.032748, 5.384184, -0.063988>,
      < -0.926393, 6.074624, 0.158787>
    }
    triangle {
      < -1.017555, 5.383738, -0.373970>,
      < -0.926393, 6.074624, 0.158787>,
      < -0.912757, 6.128767, -0.128607>
    }
    triangle {
      < -1.032748, 5.384184, -0.063988>,
      < -0.905925, 5.384666, 0.300302>,
      < -0.812568, 6.010952, 0.496523>
    }
    triangle {
      < -1.032748, 5.384184, -0.063988>,
      < -0.812568, 6.010952, 0.496523>,
      < -0.926393, 6.074624, 0.158787>
    }
    triangle {
      < -0.905925, 5.384666, 0.300302>,
      < -0.530772, 5.383664, 0.658299>,
      < -0.475865, 5.947012, 0.828165>
    }
    triangle {
      < -0.905925, 5.384666, 0.300302>,
      < -0.475865, 5.947012, 0.828165>,
      < -0.812568, 6.010952, 0.496523>
    }
    triangle {
      < -0.530772, 5.383664, 0.658299>,
      < -0.265362, 5.383006, 0.783565>,
      < -0.237656, 5.924357, 0.944155>
    }
    triangle {
      < -0.530772, 5.383664, 0.658299>,
      < -0.237656, 5.924357, 0.944155>,
      < -0.475865, 5.947012, 0.828165>
    }
    triangle {
      < -0.265362, 5.383006, 0.783565>,
      < 0.000000, 5.382403, 0.794159>,
      < 0.000000, 5.921931, 0.953869>
    }
    triangle {
      < -0.265362, 5.383006, 0.783565>,
      < 0.000000, 5.921931, 0.953869>,
      < -0.237656, 5.924357, 0.944155>
    }
    triangle {
      < 0.000000, 5.383317, -1.144730>,
      < -0.429972, 5.383253, -1.057937>,
      < -0.385395, 6.248701, -0.762645>
    }
    triangle {
      < 0.000000, 5.383317, -1.144730>,
      < -0.385395, 6.248701, -0.762645>,
      < 0.000000, 6.264034, -0.843081>
    }
    triangle {
      < -0.237656, 5.924357, 0.944155>,
      < 0.000000, 5.921931, 0.953869>,
      < 0.000000, 6.270975, 0.779844>
    }
    triangle {
      < -0.237656, 5.924357, 0.944155>,
      < 0.000000, 6.270975, 0.779844>,
      < -0.179404, 6.272811, 0.772493>
    }
    triangle {
      < 0.000000, 6.264034, -0.843081>,
      < -0.385395, 6.248701, -0.762645>,
      < -0.291215, 6.518277, -0.519228>
    }
    triangle {
      < 0.000000, 6.264034, -0.843081>,
      < -0.291215, 6.518277, -0.519228>,
      < 0.000000, 6.529882, -0.580102>
    }
    triangle {
      < -0.385395, 6.248701, -0.762645>,
      < -0.580662, 6.226851, -0.647512>,
      < -0.438994, 6.501739, -0.432095>
    }
    triangle {
      < -0.385395, 6.248701, -0.762645>,
      < -0.438994, 6.501739, -0.432095>,
      < -0.291215, 6.518277, -0.519228>
    }
    triangle {
      < -0.580662, 6.226851, -0.647512>,
      < -0.767051, 6.190462, -0.455439>,
      < -0.580055, 6.474204, -0.286733>
    }
    triangle {
      < -0.580662, 6.226851, -0.647512>,
      < -0.580055, 6.474204, -0.286733>,
      < -0.438994, 6.501739, -0.432095>
    }
    triangle {
      < -0.767051, 6.190462, -0.455439>,
      < -0.834720, 6.169515, -0.345086>,
      < -0.631267, 6.458348, -0.203216>
    }
    triangle {
      < -0.767051, 6.190462, -0.455439>,
      < -0.631267, 6.458348, -0.203216>,
      < -0.580055, 6.474204, -0.286733>
    }
    triangle {
      < -0.834720, 6.169515, -0.345086>,
      < -0.912757, 6.128767, -0.128607>,
      < -0.690326, 6.427511, -0.039383>
    }
    triangle {
      < -0.834720, 6.169515, -0.345086>,
      < -0.690326, 6.427511, -0.039383>,
      < -0.631267, 6.458348, -0.203216>
    }
    triangle {
      < -0.912757, 6.128767, -0.128607>,
      < -0.926393, 6.074624, 0.158787>,
      < -0.700646, 6.386535, 0.178120>
    }
    triangle {
      < -0.912757, 6.128767, -0.128607>,
      < -0.700646, 6.386535, 0.178120>,
      < -0.690326, 6.427511, -0.039383>
    }
    triangle {
      < -0.926393, 6.074624, 0.158787>,
      < -0.812568, 6.010952, 0.496523>,
      < -0.614502, 6.338346, 0.433721>
    }
    triangle {
      < -0.926393, 6.074624, 0.158787>,
      < -0.614502, 6.338346, 0.433721>,
      < -0.700646, 6.386535, 0.178120>
    }
    triangle {
      < -0.812568, 6.010952, 0.496523>,
      < -0.475865, 5.947012, 0.828165>,
      < -0.359682, 6.289955, 0.684710>
    }
    triangle {
      < -0.812568, 6.010952, 0.496523>,
      < -0.359682, 6.289955, 0.684710>,
      < -0.614502, 6.338346, 0.433721>
    }
    triangle {
      < -0.475865, 5.947012, 0.828165>,
      < -0.237656, 5.924357, 0.944155>,
      < -0.179404, 6.272811, 0.772493>
    }
    triangle {
      < -0.475865, 5.947012, 0.828165>,
      < -0.179404, 6.272811, 0.772493>,
      < -0.359682, 6.289955, 0.684710>
    }
    triangle {
      < -0.700646, 6.386535, 0.178120>,
      < -0.614502, 6.338346, 0.433721>,
      < -0.324684, 6.512660, 0.254128>
    }
    triangle {
      < -0.700646, 6.386535, 0.178120>,
      < -0.324684, 6.512660, 0.254128>,
      < -0.370275, 6.538164, 0.118853>
    }
    triangle {
      < -0.614502, 6.338346, 0.433721>,
      < -0.359682, 6.289955, 0.684710>,
      < -0.189822, 6.487049, 0.386961>
    }
    triangle {
      < -0.614502, 6.338346, 0.433721>,
      < -0.189822, 6.487049, 0.386961>,
      < -0.324684, 6.512660, 0.254128>
    }
    triangle {
      < -0.359682, 6.289955, 0.684710>,
      < -0.179404, 6.272811, 0.772493>,
      < -0.094412, 6.477975, 0.433420>
    }
    triangle {
      < -0.359682, 6.289955, 0.684710>,
      < -0.094412, 6.477975, 0.433420>,
      < -0.189822, 6.487049, 0.386961>
    }
    triangle {
      < -0.179404, 6.272811, 0.772493>,
      < 0.000000, 6.270975, 0.779844>,
      < 0.000000, 6.477004, 0.437311>
    }
    triangle {
      < -0.179404, 6.272811, 0.772493>,
      < 0.000000, 6.477004, 0.437311>,
      < -0.094412, 6.477975, 0.433420>
    }
    triangle {
      < 0.000000, 6.529882, -0.580102>,
      < -0.291215, 6.518277, -0.519228>,
      < -0.153586, 6.607885, -0.250214>
    }
    triangle {
      < 0.000000, 6.529882, -0.580102>,
      < -0.153586, 6.607885, -0.250214>,
      < 0.000000, 6.614027, -0.282431>
    }
    triangle {
      < -0.291215, 6.518277, -0.519228>,
      < -0.438994, 6.501739, -0.432095>,
      < -0.231797, 6.599135, -0.204098>
    }
    triangle {
      < -0.291215, 6.518277, -0.519228>,
      < -0.231797, 6.599135, -0.204098>,
      < -0.153586, 6.607885, -0.250214>
    }
    triangle {
      < -0.438994, 6.501739, -0.432095>,
      < -0.580055, 6.474204, -0.286733>,
      < -0.306453, 6.584560, -0.127167>
    }
    triangle {
      < -0.438994, 6.501739, -0.432095>,
      < -0.306453, 6.584560, -0.127167>,
      < -0.231797, 6.599135, -0.204098>
    }
    triangle {
      < -0.580055, 6.474204, -0.286733>,
      < -0.631267, 6.458348, -0.203216>,
      < -0.333556, 6.576173, -0.082966>
    }
    triangle {
      < -0.580055, 6.474204, -0.286733>,
      < -0.333556, 6.576173, -0.082966>,
      < -0.306453, 6.584560, -0.127167>
    }
    triangle {
      < -0.631267, 6.458348, -0.203216>,
      < -0.690326, 6.427511, -0.039383>,
      < -0.364813, 6.559850, 0.003741>
    }
    triangle {
      < -0.631267, 6.458348, -0.203216>,
      < -0.364813, 6.559850, 0.003741>,
      < -0.333556, 6.576173, -0.082966>
    }
    triangle {
      < -0.690326, 6.427511, -0.039383>,
      < -0.700646, 6.386535, 0.178120>,
      < -0.370275, 6.538164, 0.118853>
    }
    triangle {
      < -0.690326, 6.427511, -0.039383>,
      < -0.370275, 6.538164, 0.118853>,
      < -0.364813, 6.559850, 0.003741>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < -0.117154, 2.882724, 2.450977>,
      < -0.475173, 3.470336, 2.277757>,
      < -0.791250, 3.144629, 2.729348>
    }
    triangle {
      < -0.117154, 2.882724, 2.450977>,
      < -0.791250, 3.144629, 2.729348>,
      < -0.543989, 2.738802, 2.848981>
    }
    triangle {
      < -0.475173, 3.470336, 2.277757>,
      < -0.867752, 3.665836, 2.143286>,
      < -1.062379, 3.279649, 2.636478>
    }
    triangle {
      < -0.475173, 3.470336, 2.277757>,
      < -1.062379, 3.279649, 2.636478>,
      < -0.791250, 3.144629, 2.729348>
    }
    triangle {
      < -0.867752, 3.665836, 2.143286>,
      < -1.254015, 3.672732, 2.033899>,
      < -1.329147, 3.284411, 2.560931>
    }
    triangle {
      < -0.867752, 3.665836, 2.143286>,
      < -1.329147, 3.284411, 2.560931>,
      < -1.062379, 3.279649, 2.636478>
    }
    triangle {
      < -1.254015, 3.672732, 2.033899>,
      < -1.729397, 3.438161, 1.929313>,
      < -1.657463, 3.122408, 2.488700>
    }
    triangle {
      < -1.254015, 3.672732, 2.033899>,
      < -1.657463, 3.122408, 2.488700>,
      < -1.329147, 3.284411, 2.560931>
    }
    triangle {
      < -1.729397, 3.438161, 1.929313>,
      < -2.030171, 3.025035, 1.895856>,
      < -1.865189, 2.837087, 2.465593>
    }
    triangle {
      < -1.729397, 3.438161, 1.929313>,
      < -1.865189, 2.837087, 2.465593>,
      < -1.657463, 3.122408, 2.488700>
    }
    triangle {
      < -2.030171, 3.025035, 1.895856>,
      < -2.132606, 2.497405, 1.932280>,
      < -1.935934, 2.472686, 2.490749>
    }
    triangle {
      < -2.030171, 3.025035, 1.895856>,
      < -1.935934, 2.472686, 2.490749>,
      < -1.865189, 2.837087, 2.465593>
    }
    triangle {
      < -2.132606, 2.497405, 1.932280>,
      < -2.006081, 1.993751, 2.030076>,
      < -1.848552, 2.124844, 2.558292>
    }
    triangle {
      < -2.132606, 2.497405, 1.932280>,
      < -1.848552, 2.124844, 2.558292>,
      < -1.935934, 2.472686, 2.490749>
    }
    triangle {
      < -2.006081, 1.993751, 2.030076>,
      < -1.729165, 1.620013, 2.150219>,
      < -1.657303, 1.888275, 2.641266>
    }
    triangle {
      < -2.006081, 1.993751, 2.030076>,
      < -1.657303, 1.888275, 2.641266>,
      < -1.848552, 2.124844, 2.558292>
    }
    triangle {
      < -1.729165, 1.620013, 2.150219>,
      < -1.153635, 1.411296, 2.337730>,
      < -1.259821, 1.744127, 2.770769>
    }
    triangle {
      < -1.729165, 1.620013, 2.150219>,
      < -1.259821, 1.744127, 2.770769>,
      < -1.657303, 1.888275, 2.641266>
    }
    triangle {
      < -1.153635, 1.411296, 2.337730>,
      < -0.609266, 1.571267, 2.470921>,
      < -0.883860, 1.854609, 2.862755>
    }
    triangle {
      < -1.153635, 1.411296, 2.337730>,
      < -0.883860, 1.854609, 2.862755>,
      < -1.259821, 1.744127, 2.770769>
    }
    triangle {
      < -0.609266, 1.571267, 2.470921>,
      < -0.327114, 1.835370, 2.517562>,
      < -0.688995, 2.037009, 2.894967>
    }
    triangle {
      < -0.609266, 1.571267, 2.470921>,
      < -0.688995, 2.037009, 2.894967>,
      < -0.883860, 1.854609, 2.862755>
    }
    triangle {
      < -0.327114, 1.835370, 2.517562>,
      < -0.130649, 2.233726, 2.523536>,
      < -0.553309, 2.312128, 2.899093>
    }
    triangle {
      < -0.327114, 1.835370, 2.517562>,
      < -0.553309, 2.312128, 2.899093>,
      < -0.688995, 2.037009, 2.894967>
    }
    triangle {
      < -0.130649, 2.233726, 2.523536>,
      < -0.117154, 2.882724, 2.450977>,
      < -0.543989, 2.738802, 2.848981>
    }
    triangle {
      < -0.130649, 2.233726, 2.523536>,
      < -0.543989, 2.738802, 2.848981>,
      < -0.553309, 2.312128, 2.899093>
    }
    triangle {
      < -0.883860, 1.854609, 2.862755>,
      < -0.688995, 2.037009, 2.894967>,
      < -1.053943, 2.341998, 2.991321>
    }
    triangle {
      < -0.883860, 1.854609, 2.862755>,
      < -1.053943, 2.341998, 2.991321>,
      < -1.138060, 2.263262, 2.977416>
    }
    triangle {
      < -0.688995, 2.037009, 2.894967>,
      < -0.553309, 2.312128, 2.899093>,
      < -0.995371, 2.460758, 2.993102>
    }
    triangle {
      < -0.688995, 2.037009, 2.894967>,
      < -0.995371, 2.460758, 2.993102>,
      < -1.053943, 2.341998, 2.991321>
    }
    triangle {
      < -0.553309, 2.312128, 2.899093>,
      < -0.543989, 2.738802, 2.848981>,
      < -0.991348, 2.644941, 2.971471>
    }
    triangle {
      < -0.553309, 2.312128, 2.899093>,
      < -0.991348, 2.644941, 2.971471>,
      < -0.995371, 2.460758, 2.993102>
    }
    triangle {
      < -0.543989, 2.738802, 2.848981>,
      < -0.791250, 3.144629, 2.729348>,
      < -1.098083, 2.820125, 2.919829>
    }
    triangle {
      < -0.543989, 2.738802, 2.848981>,
      < -1.098083, 2.820125, 2.919829>,
      < -0.991348, 2.644941, 2.971471>
    }
    triangle {
      < -0.791250, 3.144629, 2.729348>,
      < -1.062379, 3.279649, 2.636478>,
      < -1.215121, 2.878408, 2.879739>
    }
    triangle {
      < -0.791250, 3.144629, 2.729348>,
      < -1.215121, 2.878408, 2.879739>,
      < -1.098083, 2.820125, 2.919829>
    }
    triangle {
      < -1.062379, 3.279649, 2.636478>,
      < -1.329147, 3.284411, 2.560931>,
      < -1.330277, 2.880464, 2.847128>
    }
    triangle {
      < -1.062379, 3.279649, 2.636478>,
      < -1.330277, 2.880464, 2.847128>,
      < -1.215121, 2.878408, 2.879739>
    }
    triangle {
      < -1.329147, 3.284411, 2.560931>,
      < -1.657463, 3.122408, 2.488700>,
      < -1.472001, 2.810532, 2.815948>
    }
    triangle {
      < -1.329147, 3.284411, 2.560931>,
      < -1.472001, 2.810532, 2.815948>,
      < -1.330277, 2.880464, 2.847128>
    }
    triangle {
      < -1.657463, 3.122408, 2.488700>,
      < -1.865189, 2.837087, 2.465593>,
      < -1.561671, 2.687367, 2.805973>
    }
    triangle {
      < -1.657463, 3.122408, 2.488700>,
      < -1.561671, 2.687367, 2.805973>,
      < -1.472001, 2.810532, 2.815948>
    }
    triangle {
      < -1.865189, 2.837087, 2.465593>,
      < -1.935934, 2.472686, 2.490749>,
      < -1.592209, 2.530067, 2.816833>
    }
    triangle {
      < -1.865189, 2.837087, 2.465593>,
      < -1.592209, 2.530067, 2.816833>,
      < -1.561671, 2.687367, 2.805973>
    }
    triangle {
      < -1.935934, 2.472686, 2.490749>,
      < -1.848552, 2.124844, 2.558292>,
      < -1.554488, 2.379914, 2.845989>
    }
    triangle {
      < -1.935934, 2.472686, 2.490749>,
      < -1.554488, 2.379914, 2.845989>,
      < -1.592209, 2.530067, 2.816833>
    }
    triangle {
      < -1.848552, 2.124844, 2.558292>,
      < -1.657303, 1.888275, 2.641266>,
      < -1.471932, 2.277794, 2.881806>
    }
    triangle {
      < -1.848552, 2.124844, 2.558292>,
      < -1.471932, 2.277794, 2.881806>,
      < -1.554488, 2.379914, 2.845989>
    }
    triangle {
      < -1.657303, 1.888275, 2.641266>,
      < -1.259821, 1.744127, 2.770769>,
      < -1.300352, 2.215570, 2.937709>
    }
    triangle {
      < -1.657303, 1.888275, 2.641266>,
      < -1.300352, 2.215570, 2.937709>,
      < -1.471932, 2.277794, 2.881806>
    }
    triangle {
      < -1.259821, 1.744127, 2.770769>,
      < -0.883860, 1.854609, 2.862755>,
      < -1.138060, 2.263262, 2.977416>
    }
    triangle {
      < -1.259821, 1.744127, 2.770769>,
      < -1.138060, 2.263262, 2.977416>,
      < -1.300352, 2.215570, 2.937709>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 1.667724, 0.325124, 0.861139>,
      < 1.567689, 0.343412, 0.374270>,
      < 1.665409, 0.937255, 0.408684>
    }
    triangle {
      < 1.667724, 0.325124, 0.861139>,
      < 1.665409, 0.937255, 0.408684>,
      < 1.615866, 0.932848, 0.867042>
    }
    triangle {
      < 1.615866, 0.932848, 0.867042>,
      < 1.616949, 0.940626, 1.106850>,
      < 1.630292, 0.298432, 0.980606>
    }
    triangle {
      < 1.615866, 0.932848, 0.867042>,
      < 1.630292, 0.298432, 0.980606>,
      < 1.667724, 0.325124, 0.861139>
    }
    triangle {
      < 1.616949, 0.940626, 1.106850>,
      < 1.323336, 0.948244, 1.694737>,
      < 1.368342, 0.290731, 1.693234>
    }
    triangle {
      < 1.616949, 0.940626, 1.106850>,
      < 1.368342, 0.290731, 1.693234>,
      < 1.630292, 0.298432, 0.980606>
    }
    triangle {
      < 1.323336, 0.948244, 1.694737>,
      < 0.912253, 0.961551, 2.075965>,
      < 0.855725, 0.305926, 2.111272>
    }
    triangle {
      < 1.323336, 0.948244, 1.694737>,
      < 0.855725, 0.305926, 2.111272>,
      < 1.368342, 0.290731, 1.693234>
    }
    triangle {
      < 1.324927, 0.351883, 0.083510>,
      < 1.421312, 0.928829, 0.106105>,
      < 1.665409, 0.937255, 0.408684>
    }
    triangle {
      < 1.324927, 0.351883, 0.083510>,
      < 1.665409, 0.937255, 0.408684>,
      < 1.567689, 0.343412, 0.374270>
    }
    triangle {
      < 1.023351, 0.346405, -0.053167>,
      < 1.153018, 0.924817, -0.087208>,
      < 1.421312, 0.928829, 0.106105>
    }
    triangle {
      < 1.023351, 0.346405, -0.053167>,
      < 1.421312, 0.928829, 0.106105>,
      < 1.324927, 0.351883, 0.083510>
    }
    triangle {
      < 0.676174, 0.356651, -0.147042>,
      < 0.761863, 0.935459, -0.192583>,
      < 1.153018, 0.924817, -0.087208>
    }
    triangle {
      < 0.676174, 0.356651, -0.147042>,
      < 1.153018, 0.924817, -0.087208>,
      < 1.023351, 0.346405, -0.053167>
    }
    triangle {
      < 0.264625, 0.388178, -0.173283>,
      < 0.281991, 0.951491, -0.199283>,
      < 0.761863, 0.935459, -0.192583>
    }
    triangle {
      < 0.264625, 0.388178, -0.173283>,
      < 0.761863, 0.935459, -0.192583>,
      < 0.676174, 0.356651, -0.147042>
    }
    triangle {
      < 0.256247, -0.378244, -0.343827>,
      < 0.000000, -0.390384, -0.205530>,
      < 0.000000, 0.418408, -0.112867>
    }
    triangle {
      < 0.256247, -0.378244, -0.343827>,
      < 0.000000, 0.418408, -0.112867>,
      < 0.264625, 0.388178, -0.173283>
    }
    triangle {
      < 2.151950, -1.167999, 0.746909>,
      < 2.043287, -1.081142, 0.138327>,
      < 1.734500, -0.418211, 0.226525>
    }
    triangle {
      < 2.151950, -1.167999, 0.746909>,
      < 1.734500, -0.418211, 0.226525>,
      < 1.835413, -0.461101, 0.782676>
    }
    triangle {
      < 1.923485, -1.252392, 1.567173>,
      < 2.151950, -1.167999, 0.746909>,
      < 1.835413, -0.461101, 0.782676>
    }
    triangle {
      < 1.923485, -1.252392, 1.567173>,
      < 1.835413, -0.461101, 0.782676>,
      < 1.615223, -0.478884, 1.642453>
    }
    triangle {
      < 1.615223, -0.478884, 1.642453>,
      < 1.088540, -0.502982, 2.096247>,
      < 1.321224, -1.299337, 2.064278>
    }
    triangle {
      < 1.615223, -0.478884, 1.642453>,
      < 1.321224, -1.299337, 2.064278>,
      < 1.923485, -1.252392, 1.567173>
    }
    triangle {
      < 0.855725, 0.305926, 2.111272>,
      < 0.461192, 0.053048, 2.272134>,
      < 0.585927, -0.662367, 2.272740>
    }
    triangle {
      < 0.855725, 0.305926, 2.111272>,
      < 0.585927, -0.662367, 2.272740>,
      < 1.088540, -0.502982, 2.096247>
    }
    triangle {
      < 0.585927, -0.662367, 2.272740>,
      < 0.461192, 0.053048, 2.272134>,
      < 0.066715, -0.604138, 2.139349>
    }
    triangle {
      < 0.585927, -0.662367, 2.272740>,
      < 0.066715, -0.604138, 2.139349>,
      < 0.079880, -0.668916, 2.137583>
    }
    triangle {
      < 0.265781, 0.220905, 2.228825>,
      < 0.000000, 0.286501, 2.168349>,
      < 0.000000, -0.518706, 2.144231>
    }
    triangle {
      < 0.265781, 0.220905, 2.228825>,
      < 0.000000, -0.518706, 2.144231>,
      < 0.030486, -0.538444, 2.142306>
    }
    triangle {
      < 1.738288, -1.045818, -0.291013>,
      < 1.477786, -0.393219, -0.084196>,
      < 1.734500, -0.418211, 0.226525>
    }
    triangle {
      < 1.738288, -1.045818, -0.291013>,
      < 1.734500, -0.418211, 0.226525>,
      < 2.043287, -1.081142, 0.138327>
    }
    triangle {
      < 1.392307, -1.028841, -0.524928>,
      < 1.134307, -0.395637, -0.215442>,
      < 1.477786, -0.393219, -0.084196>
    }
    triangle {
      < 1.392307, -1.028841, -0.524928>,
      < 1.477786, -0.393219, -0.084196>,
      < 1.738288, -1.045818, -0.291013>
    }
    triangle {
      < 0.939213, -1.034800, -0.593414>,
      < 0.775331, -0.395819, -0.293731>,
      < 1.134307, -0.395637, -0.215442>
    }
    triangle {
      < 0.939213, -1.034800, -0.593414>,
      < 1.134307, -0.395637, -0.215442>,
      < 1.392307, -1.028841, -0.524928>
    }
    triangle {
      < 0.341460, -1.035609, -0.696119>,
      < 0.256247, -0.378244, -0.343827>,
      < 0.775331, -0.395819, -0.293731>
    }
    triangle {
      < 0.341460, -1.035609, -0.696119>,
      < 0.775331, -0.395819, -0.293731>,
      < 0.939213, -1.034800, -0.593414>
    }
    triangle {
      < 0.000000, -1.028896, -0.709965>,
      < 0.000000, -0.390384, -0.205530>,
      < 0.256247, -0.378244, -0.343827>
    }
    triangle {
      < 0.000000, -1.028896, -0.709965>,
      < 0.256247, -0.378244, -0.343827>,
      < 0.341460, -1.035609, -0.696119>
    }
    triangle {
      < 2.375054, -1.787838, 0.744887>,
      < 2.287189, -1.739374, 0.014049>,
      < 2.043287, -1.081142, 0.138327>
    }
    triangle {
      < 2.375054, -1.787838, 0.744887>,
      < 2.043287, -1.081142, 0.138327>,
      < 2.151950, -1.167999, 0.746909>
    }
    triangle {
      < 2.287189, -1.739374, 0.014049>,
      < 1.993370, -1.706865, -0.610222>,
      < 1.738288, -1.045818, -0.291013>
    }
    triangle {
      < 2.287189, -1.739374, 0.014049>,
      < 1.738288, -1.045818, -0.291013>,
      < 2.043287, -1.081142, 0.138327>
    }
    triangle {
      < 1.527554, -1.725683, -0.939297>,
      < 1.392307, -1.028841, -0.524928>,
      < 1.738288, -1.045818, -0.291013>
    }
    triangle {
      < 1.527554, -1.725683, -0.939297>,
      < 1.738288, -1.045818, -0.291013>,
      < 1.993370, -1.706865, -0.610222>
    }
    triangle {
      < 1.029656, -1.729898, -1.124603>,
      < 0.939213, -1.034800, -0.593414>,
      < 1.392307, -1.028841, -0.524928>
    }
    triangle {
      < 1.029656, -1.729898, -1.124603>,
      < 1.392307, -1.028841, -0.524928>,
      < 1.527554, -1.725683, -0.939297>
    }
    triangle {
      < 0.411529, -1.732547, -1.211711>,
      < 0.341460, -1.035609, -0.696119>,
      < 0.939213, -1.034800, -0.593414>
    }
    triangle {
      < 0.411529, -1.732547, -1.211711>,
      < 0.939213, -1.034800, -0.593414>,
      < 1.029656, -1.729898, -1.124603>
    }
    triangle {
      < 0.000000, -1.725303, -1.284663>,
      < 0.000000, -1.028896, -0.709965>,
      < 0.341460, -1.035609, -0.696119>
    }
    triangle {
      < 0.000000, -1.725303, -1.284663>,
      < 0.341460, -1.035609, -0.696119>,
      < 0.411529, -1.732547, -1.211711>
    }
    triangle {
      < 1.992056, -1.958319, 1.606111>,
      < 2.375054, -1.787838, 0.744887>,
      < 2.151950, -1.167999, 0.746909>
    }
    triangle {
      < 1.992056, -1.958319, 1.606111>,
      < 2.151950, -1.167999, 0.746909>,
      < 1.923485, -1.252392, 1.567173>
    }
    triangle {
      < 1.469949, -2.124545, 2.087185>,
      < 1.992056, -1.958319, 1.606111>,
      < 1.923485, -1.252392, 1.567173>
    }
    triangle {
      < 1.469949, -2.124545, 2.087185>,
      < 1.923485, -1.252392, 1.567173>,
      < 1.321224, -1.299337, 2.064278>
    }
    triangle {
      < 1.088540, -0.502982, 2.096247>,
      < 0.585927, -0.662367, 2.272740>,
      < 0.473522, -1.293983, 2.269722>
    }
    triangle {
      < 1.088540, -0.502982, 2.096247>,
      < 0.473522, -1.293983, 2.269722>,
      < 1.321224, -1.299337, 2.064278>
    }
    triangle {
      < 0.200286, -1.505385, 2.203278>,
      < 0.380002, -2.254292, 2.142292>,
      < 0.891979, -2.200235, 2.236348>
    }
    triangle {
      < 0.200286, -1.505385, 2.203278>,
      < 0.891979, -2.200235, 2.236348>,
      < 0.473522, -1.293983, 2.269722>
    }
    triangle {
      < 0.473522, -1.293983, 2.269722>,
      < 0.585927, -0.662367, 2.272740>,
      < 0.079880, -0.668916, 2.137583>
    }
    triangle {
      < 0.473522, -1.293983, 2.269722>,
      < 0.079880, -0.668916, 2.137583>,
      < 0.062370, -0.719194, 2.139291>
    }
    triangle {
      < 0.062370, -0.719194, 2.139291>,
      < 0.034745, -0.781618, 2.138963>,
      < 0.200286, -1.505385, 2.203278>
    }
    triangle {
      < 0.062370, -0.719194, 2.139291>,
      < 0.200286, -1.505385, 2.203278>,
      < 0.473522, -1.293983, 2.269722>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 2.418596, -2.189365, -0.047748>,
      < 2.287189, -1.739374, 0.014049>,
      < 2.375054, -1.787838, 0.744887>
    }
    triangle {
      < 2.418596, -2.189365, -0.047748>,
      < 2.375054, -1.787838, 0.744887>,
      < 2.483908, -2.205232, 0.700965>
    }
    triangle {
      < 2.141889, -2.239871, -0.700709>,
      < 1.993370, -1.706865, -0.610222>,
      < 2.287189, -1.739374, 0.014049>
    }
    triangle {
      < 2.141889, -2.239871, -0.700709>,
      < 2.287189, -1.739374, 0.014049>,
      < 2.418596, -2.189365, -0.047748>
    }
    triangle {
      < 1.700081, -2.345231, -1.189734>,
      < 1.527554, -1.725683, -0.939297>,
      < 1.993370, -1.706865, -0.610222>
    }
    triangle {
      < 1.700081, -2.345231, -1.189734>,
      < 1.993370, -1.706865, -0.610222>,
      < 2.141889, -2.239871, -0.700709>
    }
    triangle {
      < 1.134340, -2.406512, -1.430779>,
      < 1.029656, -1.729898, -1.124603>,
      < 1.527554, -1.725683, -0.939297>
    }
    triangle {
      < 1.134340, -2.406512, -1.430779>,
      < 1.527554, -1.725683, -0.939297>,
      < 1.700081, -2.345231, -1.189734>
    }
    triangle {
      < 0.484518, -2.407809, -1.519681>,
      < 0.411529, -1.732547, -1.211711>,
      < 1.029656, -1.729898, -1.124603>
    }
    triangle {
      < 0.484518, -2.407809, -1.519681>,
      < 1.029656, -1.729898, -1.124603>,
      < 1.134340, -2.406512, -1.430779>
    }
    triangle {
      < 0.000000, -2.406300, -1.528150>,
      < 0.000000, -1.725303, -1.284663>,
      < 0.411529, -1.732547, -1.211711>
    }
    triangle {
      < 0.000000, -2.406300, -1.528150>,
      < 0.411529, -1.732547, -1.211711>,
      < 0.484518, -2.407809, -1.519681>
    }
    triangle {
      < 1.992056, -1.958319, 1.606111>,
      < 2.081050, -2.344766, 1.611613>,
      < 2.483908, -2.205232, 0.700965>
    }
    triangle {
      < 1.992056, -1.958319, 1.606111>,
      < 2.483908, -2.205232, 0.700965>,
      < 2.375054, -1.787838, 0.744887>
    }
    triangle {
      < 1.469949, -2.124545, 2.087185>,
      < 1.498155, -2.624723, 1.975203>,
      < 2.081050, -2.344766, 1.611613>
    }
    triangle {
      < 1.469949, -2.124545, 2.087185>,
      < 2.081050, -2.344766, 1.611613>,
      < 1.992056, -1.958319, 1.606111>
    }
    triangle {
      < 0.891979, -2.200235, 2.236348>,
      < 0.976975, -2.842957, 2.054101>,
      < 1.498155, -2.624723, 1.975203>
    }
    triangle {
      < 0.891979, -2.200235, 2.236348>,
      < 1.498155, -2.624723, 1.975203>,
      < 1.469949, -2.124545, 2.087185>
    }
    triangle {
      < 0.380002, -2.254292, 2.142292>,
      < 0.369286, -2.906036, 2.035651>,
      < 0.976975, -2.842957, 2.054101>
    }
    triangle {
      < 0.380002, -2.254292, 2.142292>,
      < 0.976975, -2.842957, 2.054101>,
      < 0.891979, -2.200235, 2.236348>
    }
    triangle {
      < 0.000000, -2.270840, 2.094989>,
      < 0.000000, -2.913937, 2.005210>,
      < 0.369286, -2.906036, 2.035651>
    }
    triangle {
      < 0.000000, -2.270840, 2.094989>,
      < 0.369286, -2.906036, 2.035651>,
      < 0.380002, -2.254292, 2.142292>
    }
    triangle {
      < 2.505751, -2.631844, -0.128317>,
      < 2.200008, -2.698764, -0.788438>,
      < 2.141889, -2.239871, -0.700709>
    }
    triangle {
      < 2.505751, -2.631844, -0.128317>,
      < 2.141889, -2.239871, -0.700709>,
      < 2.418596, -2.189365, -0.047748>
    }
    triangle {
      < 2.505751, -2.631844, -0.128317>,
      < 2.418596, -2.189365, -0.047748>,
      < 2.483908, -2.205232, 0.700965>
    }
    triangle {
      < 2.505751, -2.631844, -0.128317>,
      < 2.483908, -2.205232, 0.700965>,
      < 2.533123, -2.555095, 0.678978>
    }
    triangle {
      < 2.533123, -2.555095, 0.678978>,
      < 2.547276, -2.972060, -0.173055>,
      < 2.505751, -2.631844, -0.128317>
    }
    triangle {
      < 2.081050, -2.344766, 1.611613>,
      < 2.099578, -2.632143, 1.627991>,
      < 2.533123, -2.555095, 0.678978>
    }
    triangle {
      < 2.081050, -2.344766, 1.611613>,
      < 2.533123, -2.555095, 0.678978>,
      < 2.483908, -2.205232, 0.700965>
    }
    triangle {
      < 1.498155, -2.624723, 1.975203>,
      < 1.505880, -3.041700, 1.916351>,
      < 2.099578, -2.632143, 1.627991>
    }
    triangle {
      < 1.498155, -2.624723, 1.975203>,
      < 2.099578, -2.632143, 1.627991>,
      < 2.081050, -2.344766, 1.611613>
    }
    triangle {
      < 0.976975, -2.842957, 2.054101>,
      < 1.017310, -3.521789, 1.843347>,
      < 1.505880, -3.041700, 1.916351>
    }
    triangle {
      < 0.976975, -2.842957, 2.054101>,
      < 1.505880, -3.041700, 1.916351>,
      < 1.498155, -2.624723, 1.975203>
    }
    triangle {
      < 0.369286, -2.906036, 2.035651>,
      < 0.354142, -3.532827, 1.804350>,
      < 1.017310, -3.521789, 1.843347>
    }
    triangle {
      < 0.369286, -2.906036, 2.035651>,
      < 1.017310, -3.521789, 1.843347>,
      < 0.976975, -2.842957, 2.054101>
    }
    triangle {
      < 0.000000, -2.913937, 2.005210>,
      < 0.000000, -3.538705, 1.784168>,
      < 0.354142, -3.532827, 1.804350>
    }
    triangle {
      < 0.000000, -2.913937, 2.005210>,
      < 0.354142, -3.532827, 1.804350>,
      < 0.369286, -2.906036, 2.035651>
    }
    triangle {
      < 2.223733, -3.181419, -0.836420>,
      < 2.200008, -2.698764, -0.788438>,
      < 2.505751, -2.631844, -0.128317>
    }
    triangle {
      < 2.223733, -3.181419, -0.836420>,
      < 2.505751, -2.631844, -0.128317>,
      < 2.547276, -2.972060, -0.173055>
    }
    triangle {
      < 2.248718, -3.572636, -0.898282>,
      < 2.223733, -3.181419, -0.836420>,
      < 2.547276, -2.972060, -0.173055>
    }
    triangle {
      < 0.255535, -4.694487, -0.625129>,
      < 0.311111, -4.381596, -1.212254>,
      < 0.889220, -4.246559, -1.401602>
    }
    triangle {
      < 0.255535, -4.694487, -0.625129>,
      < 0.889220, -4.246559, -1.401602>,
      < 0.711234, -4.646127, -0.783033>
    }
    triangle {
      < 0.000000, -4.602162, -0.492641>,
      < 0.000000, -4.407779, -1.010952>,
      < 0.311111, -4.381596, -1.212254>
    }
    triangle {
      < 0.000000, -4.602162, -0.492641>,
      < 0.311111, -4.381596, -1.212254>,
      < 0.255535, -4.694487, -0.625129>
    }
    triangle {
      < 0.298104, -4.734981, -0.329984>,
      < 0.255535, -4.694487, -0.625129>,
      < 0.711234, -4.646127, -0.783033>
    }
    triangle {
      < 0.889220, -4.246559, -1.401602>,
      < 1.724837, -3.932333, -1.297691>,
      < 1.494346, -4.284712, -1.156904>
    }
    triangle {
      < 0.889220, -4.246559, -1.401602>,
      < 1.494346, -4.284712, -1.156904>,
      < 0.711234, -4.646127, -0.783033>
    }
    triangle {
      < 1.494346, -4.284712, -1.156904>,
      < 1.724837, -3.932333, -1.297691>,
      < 2.248718, -3.572636, -0.898282>
    }
    triangle {
      < 1.776117, -3.430998, -1.332718>,
      < 2.223733, -3.181419, -0.836420>,
      < 2.248718, -3.572636, -0.898282>
    }
    triangle {
      < 1.776117, -3.430998, -1.332718>,
      < 2.248718, -3.572636, -0.898282>,
      < 1.724837, -3.932333, -1.297691>
    }
    triangle {
      < 1.724837, -3.932333, -1.297691>,
      < 0.889220, -4.246559, -1.401602>,
      < 1.089705, -3.611076, -1.668545>
    }
    triangle {
      < 1.724837, -3.932333, -1.297691>,
      < 1.089705, -3.611076, -1.668545>,
      < 1.776117, -3.430998, -1.332718>
    }
    triangle {
      < 0.311111, -4.381596, -1.212254>,
      < 0.450691, -3.743277, -1.622213>,
      < 1.089705, -3.611076, -1.668545>
    }
    triangle {
      < 0.311111, -4.381596, -1.212254>,
      < 1.089705, -3.611076, -1.668545>,
      < 0.889220, -4.246559, -1.401602>
    }
    triangle {
      < 0.000000, -4.407779, -1.010952>,
      < 0.000000, -3.830920, -1.463827>,
      < 0.450691, -3.743277, -1.622213>
    }
    triangle {
      < 0.000000, -4.407779, -1.010952>,
      < 0.450691, -3.743277, -1.622213>,
      < 0.311111, -4.381596, -1.212254>
    }
    triangle {
      < 1.776117, -3.430998, -1.332718>,
      < 1.806353, -2.795094, -1.285055>,
      < 2.200008, -2.698764, -0.788438>
    }
    triangle {
      < 1.776117, -3.430998, -1.332718>,
      < 2.200008, -2.698764, -0.788438>,
      < 2.223733, -3.181419, -0.836420>
    }
    triangle {
      < 1.700081, -2.345231, -1.189734>,
      < 2.141889, -2.239871, -0.700709>,
      < 2.200008, -2.698764, -0.788438>
    }
    triangle {
      < 1.700081, -2.345231, -1.189734>,
      < 2.200008, -2.698764, -0.788438>,
      < 1.806353, -2.795094, -1.285055>
    }
    triangle {
      < 1.178743, -2.926280, -1.626145>,
      < 1.134340, -2.406512, -1.430779>,
      < 1.700081, -2.345231, -1.189734>
    }
    triangle {
      < 1.178743, -2.926280, -1.626145>,
      < 1.700081, -2.345231, -1.189734>,
      < 1.806353, -2.795094, -1.285055>
    }
    triangle {
      < 0.467621, -3.071518, -1.721816>,
      < 0.484518, -2.407809, -1.519681>,
      < 1.134340, -2.406512, -1.430779>
    }
    triangle {
      < 0.467621, -3.071518, -1.721816>,
      < 1.134340, -2.406512, -1.430779>,
      < 1.178743, -2.926280, -1.626145>
    }
    triangle {
      < 0.000000, -3.133061, -1.622910>,
      < 0.000000, -2.406300, -1.528150>,
      < 0.484518, -2.407809, -1.519681>
    }
    triangle {
      < 0.000000, -3.133061, -1.622910>,
      < 0.484518, -2.407809, -1.519681>,
      < 0.467621, -3.071518, -1.721816>
    }
    triangle {
      < 1.776117, -3.430998, -1.332718>,
      < 1.089705, -3.611076, -1.668545>,
      < 1.178743, -2.926280, -1.626145>
    }
    triangle {
      < 1.776117, -3.430998, -1.332718>,
      < 1.178743, -2.926280, -1.626145>,
      < 1.806353, -2.795094, -1.285055>
    }
    triangle {
      < 1.089705, -3.611076, -1.668545>,
      < 0.450691, -3.743277, -1.622213>,
      < 0.467621, -3.071518, -1.721816>
    }
    triangle {
      < 1.089705, -3.611076, -1.668545>,
      < 0.467621, -3.071518, -1.721816>,
      < 1.178743, -2.926280, -1.626145>
    }
    triangle {
      < 0.450691, -3.743277, -1.622213>,
      < 0.000000, -3.830920, -1.463827>,
      < 0.000000, -3.133061, -1.622910>
    }
    triangle {
      < 0.450691, -3.743277, -1.622213>,
      < 0.000000, -3.133061, -1.622910>,
      < 0.467621, -3.071518, -1.721816>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 1.665409, 0.937255, 0.408684>,
      < 1.783412, 1.641130, 0.296395>,
      < 1.740981, 1.647860, 0.799099>
    }
    triangle {
      < 1.665409, 0.937255, 0.408684>,
      < 1.740981, 1.647860, 0.799099>,
      < 1.615866, 0.932848, 0.867042>
    }
    triangle {
      < 1.421312, 0.928829, 0.106105>,
      < 1.504927, 1.630030, -0.114216>,
      < 1.783412, 1.641130, 0.296395>
    }
    triangle {
      < 1.421312, 0.928829, 0.106105>,
      < 1.783412, 1.641130, 0.296395>,
      < 1.665409, 0.937255, 0.408684>
    }
    triangle {
      < 1.740981, 1.647860, 0.799099>,
      < 1.677819, 1.606148, 1.232651>,
      < 1.616949, 0.940626, 1.106850>
    }
    triangle {
      < 1.740981, 1.647860, 0.799099>,
      < 1.616949, 0.940626, 1.106850>,
      < 1.615866, 0.932848, 0.867042>
    }
    triangle {
      < 1.547569, 1.567267, 1.812724>,
      < 1.323336, 0.948244, 1.694737>,
      < 1.616949, 0.940626, 1.106850>
    }
    triangle {
      < 1.547569, 1.567267, 1.812724>,
      < 1.616949, 0.940626, 1.106850>,
      < 1.677819, 1.606148, 1.232651>
    }
    triangle {
      < 1.076726, 1.438651, 2.082249>,
      < 0.912253, 0.961551, 2.075965>,
      < 1.323336, 0.948244, 1.694737>
    }
    triangle {
      < 1.076726, 1.438651, 2.082249>,
      < 1.323336, 0.948244, 1.694737>,
      < 1.547569, 1.567267, 1.812724>
    }
    triangle {
      < 0.419190, 1.558822, 2.240149>,
      < 0.273146, 0.985146, 2.250294>,
      < 0.912253, 0.961551, 2.075965>
    }
    triangle {
      < 0.419190, 1.558822, 2.240149>,
      < 0.912253, 0.961551, 2.075965>,
      < 1.076726, 1.438651, 2.082249>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.590628, 4.955067, -0.063853>,
      < 1.431619, 4.809371, -0.508151>,
      < 1.141270, 5.206872, -0.527612>
    }
    triangle {
      < 1.590628, 4.955067, -0.063853>,
      < 1.141270, 5.206872, -0.527612>,
      < 1.273308, 4.980906, -0.154589>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 1.715634, 4.757394, -0.424567>,
      < 1.431619, 4.809371, -0.508151>,
      < 1.590628, 4.955067, -0.063853>
    }
    triangle {
      < 2.228878, 4.708693, 0.205954>,
      < 2.241364, 4.609824, -0.315852>,
      < 1.715634, 4.757394, -0.424567>
    }
    triangle {
      < 2.228878, 4.708693, 0.205954>,
      < 1.715634, 4.757394, -0.424567>,
      < 1.590628, 4.955067, -0.063853>
    }
    triangle {
      < 2.482014, 4.415555, 0.265006>,
      < 2.424494, 4.345810, -0.180659>,
      < 2.241364, 4.609824, -0.315852>
    }
    triangle {
      < 2.482014, 4.415555, 0.265006>,
      < 2.241364, 4.609824, -0.315852>,
      < 2.228878, 4.708693, 0.205954>
    }
    triangle {
      < 1.672387, 4.390581, -0.737402>,
      < 1.129160, 4.772320, -1.039785>,
      < 1.311563, 4.775741, -0.821882>
    }
    triangle {
      < 2.241364, 4.609824, -0.315852>,
      < 2.029075, 4.281486, -0.593433>,
      < 1.672387, 4.390581, -0.737402>
    }
    triangle {
      < 2.241364, 4.609824, -0.315852>,
      < 1.672387, 4.390581, -0.737402>,
      < 1.715634, 4.757394, -0.424567>
    }
    triangle {
      < 2.424494, 4.345810, -0.180659>,
      < 2.268412, 4.117446, -0.395912>,
      < 2.029075, 4.281486, -0.593433>
    }
    triangle {
      < 2.424494, 4.345810, -0.180659>,
      < 2.029075, 4.281486, -0.593433>,
      < 2.241364, 4.609824, -0.315852>
    }
    triangle {
      < 1.998452, 3.933387, -0.729109>,
      < 2.029075, 4.281486, -0.593433>,
      < 2.268412, 4.117446, -0.395912>
    }
    triangle {
      < 1.998452, 3.933387, -0.729109>,
      < 2.268412, 4.117446, -0.395912>,
      < 2.083994, 3.764152, -0.526183>
    }
    triangle {
      < 2.015426, 3.432471, -0.791534>,
      < 1.713060, 3.430965, -0.885488>,
      < 1.692724, 4.074691, -0.865690>
    }
    triangle {
      < 2.015426, 3.432471, -0.791534>,
      < 1.692724, 4.074691, -0.865690>,
      < 1.998452, 3.933387, -0.729109>
    }
    triangle {
      < 1.998452, 3.933387, -0.729109>,
      < 2.083994, 3.764152, -0.526183>,
      < 2.015426, 3.432471, -0.791534>
    }
    triangle {
      < 1.952047, 3.541013, -0.074353>,
      < 2.015426, 3.432471, -0.791534>,
      < 2.083994, 3.764152, -0.526183>
    }
    triangle {
      < 2.010648, 2.861194, -0.415499>,
      < 1.691266, 2.802418, -0.566645>,
      < 1.713060, 3.430965, -0.885488>
    }
    triangle {
      < 2.010648, 2.861194, -0.415499>,
      < 1.713060, 3.430965, -0.885488>,
      < 2.015426, 3.432471, -0.791534>
    }
    triangle {
      < 1.908859, 1.975836, 0.203519>,
      < 1.595705, 1.961731, -0.268515>,
      < 1.691266, 2.802418, -0.566645>
    }
    triangle {
      < 1.908859, 1.975836, 0.203519>,
      < 1.691266, 2.802418, -0.566645>,
      < 2.010648, 2.861194, -0.415499>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.783412, 1.641130, 0.296395>,
      < 1.504927, 1.630030, -0.114216>,
      < 1.595705, 1.961731, -0.268515>
    }
    triangle {
      < 1.783412, 1.641130, 0.296395>,
      < 1.595705, 1.961731, -0.268515>,
      < 1.908859, 1.975836, 0.203519>
    }
    triangle {
      < 1.280519, 4.880578, 0.625888>,
      < 1.642918, 4.803511, 0.728624>,
      < 1.590628, 4.955067, -0.063853>
    }
    triangle {
      < 1.280519, 4.880578, 0.625888>,
      < 1.590628, 4.955067, -0.063853>,
      < 1.273308, 4.980906, -0.154589>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 2.129827, 4.617327, 0.666721>,
      < 2.228878, 4.708693, 0.205954>,
      < 1.590628, 4.955067, -0.063853>
    }
    triangle {
      < 2.129827, 4.617327, 0.666721>,
      < 1.590628, 4.955067, -0.063853>,
      < 1.642918, 4.803511, 0.728624>
    }
    triangle {
      < 2.374932, 4.311445, 0.581421>,
      < 2.482014, 4.415555, 0.265006>,
      < 2.228878, 4.708693, 0.205954>
    }
    triangle {
      < 2.374932, 4.311445, 0.581421>,
      < 2.228878, 4.708693, 0.205954>,
      < 2.129827, 4.617327, 0.666721>
    }
    triangle {
      < 1.908825, 4.226878, 0.992491>,
      < 2.101572, 3.803901, 0.799654>,
      < 2.374932, 4.311445, 0.581421>
    }
    triangle {
      < 1.908825, 4.226878, 0.992491>,
      < 2.374932, 4.311445, 0.581421>,
      < 2.129827, 4.617327, 0.666721>
    }
    triangle {
      < 1.642918, 4.803511, 0.728624>,
      < 1.630815, 4.470064, 1.089594>,
      < 1.908825, 4.226878, 0.992491>
    }
    triangle {
      < 1.642918, 4.803511, 0.728624>,
      < 1.908825, 4.226878, 0.992491>,
      < 2.129827, 4.617327, 0.666721>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.075780, 4.530769, 1.081253>,
      < 1.630815, 4.470064, 1.089594>,
      < 1.642918, 4.803511, 0.728624>
    }
    triangle {
      < 1.075780, 4.530769, 1.081253>,
      < 1.642918, 4.803511, 0.728624>,
      < 1.280519, 4.880578, 0.625888>
    }
    triangle {
      < 1.166408, 4.151222, 1.507141>,
      < 1.733052, 3.843242, 1.490024>,
      < 1.630815, 4.470064, 1.089594>
    }
    triangle {
      < 1.166408, 4.151222, 1.507141>,
      < 1.630815, 4.470064, 1.089594>,
      < 1.075780, 4.530769, 1.081253>
    }
    triangle {
      < 1.254015, 3.672732, 2.033899>,
      < 1.729397, 3.438161, 1.929313>,
      < 1.733052, 3.843242, 1.490024>
    }
    triangle {
      < 1.254015, 3.672732, 2.033899>,
      < 1.733052, 3.843242, 1.490024>,
      < 1.166408, 4.151222, 1.507141>
    }
    triangle {
      < 2.078001, 3.237533, 1.523019>,
      < 1.733052, 3.843242, 1.490024>,
      < 1.729397, 3.438161, 1.929313>
    }
    triangle {
      < 2.078001, 3.237533, 1.523019>,
      < 1.729397, 3.438161, 1.929313>,
      < 2.030171, 3.025035, 1.895856>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 1.630815, 4.470064, 1.089594>,
      < 1.733052, 3.843242, 1.490024>,
      < 1.803902, 3.890965, 1.209492>
    }
    triangle {
      < 1.908825, 4.226878, 0.992491>,
      < 1.803902, 3.890965, 1.209492>,
      < 2.101572, 3.803901, 0.799654>
    }
    triangle {
      < 1.630815, 4.470064, 1.089594>,
      < 1.803902, 3.890965, 1.209492>,
      < 1.908825, 4.226878, 0.992491>
    }
    triangle {
      < 2.163962, 2.786233, 1.464963>,
      < 2.161230, 2.999388, 1.153979>,
      < 1.984582, 3.398288, 1.216279>
    }
    triangle {
      < 2.163962, 2.786233, 1.464963>,
      < 1.984582, 3.398288, 1.216279>,
      < 2.078001, 3.237533, 1.523019>
    }
    triangle {
      < 2.190560, 2.382803, 1.200480>,
      < 2.161230, 2.999388, 1.153979>,
      < 2.163962, 2.786233, 1.464963>
    }
    triangle {
      < 2.010648, 2.861194, -0.415499>,
      < 2.107250, 2.950416, -0.048552>,
      < 1.908859, 1.975836, 0.203519>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 2.030171, 3.025035, 1.895856>,
      < 2.132606, 2.497405, 1.932280>,
      < 2.163962, 2.786233, 1.464963>
    }
    triangle {
      < 2.030171, 3.025035, 1.895856>,
      < 2.163962, 2.786233, 1.464963>,
      < 2.078001, 3.237533, 1.523019>
    }
    triangle {
      < 1.729165, 1.620013, 2.150219>,
      < 1.547569, 1.567267, 1.812724>,
      < 1.677819, 1.606148, 1.232651>
    }
    triangle {
      < 1.729165, 1.620013, 2.150219>,
      < 1.677819, 1.606148, 1.232651>,
      < 2.006081, 1.993751, 2.030076>
    }
    triangle {
      < 1.153635, 1.411296, 2.337730>,
      < 1.076726, 1.438651, 2.082249>,
      < 1.547569, 1.567267, 1.812724>
    }
    triangle {
      < 1.153635, 1.411296, 2.337730>,
      < 1.547569, 1.567267, 1.812724>,
      < 1.729165, 1.620013, 2.150219>
    }
    triangle {
      < 1.153635, 1.411296, 2.337730>,
      < 0.609266, 1.571267, 2.470921>,
      < 0.419190, 1.558822, 2.240149>
    }
    triangle {
      < 1.153635, 1.411296, 2.337730>,
      < 0.419190, 1.558822, 2.240149>,
      < 1.076726, 1.438651, 2.082249>
    }
    triangle {
      < 0.419190, 1.558822, 2.240149>,
      < 0.609266, 1.571267, 2.470921>,
      < 0.327114, 1.835370, 2.517562>
    }
    triangle {
      < 0.419190, 1.558822, 2.240149>,
      < 0.327114, 1.835370, 2.517562>,
      < 0.000000, 1.685680, 2.416312>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.000000, 0.993340, 2.372072>,
      < 0.273146, 0.985146, 2.250294>,
      < 0.419190, 1.558822, 2.240149>
    }
    triangle {
      < 0.000000, 0.993340, 2.372072>,
      < 0.419190, 1.558822, 2.240149>,
      < 0.000000, 1.685680, 2.416312>
    }
    triangle {
      < 0.000000, 0.727521, 2.268319>,
      < 0.337486, 0.598394, 2.259545>,
      < 0.273146, 0.985146, 2.250294>
    }
    triangle {
      < 0.000000, 0.727521, 2.268319>,
      < 0.273146, 0.985146, 2.250294>,
      < 0.000000, 0.993340, 2.372072>
    }
    triangle {
      < 0.592030, 4.903543, 0.706935>,
      < 0.901685, 5.050315, 0.474962>,
      < 0.905925, 5.384666, 0.300302>
    }
    triangle {
      < 0.592030, 4.903543, 0.706935>,
      < 0.905925, 5.384666, 0.300302>,
      < 0.530772, 5.383664, 0.658299>
    }
    triangle {
      < 1.280519, 4.880578, 0.625888>,
      < 1.273308, 4.980906, -0.154589>,
      < 1.045609, 5.199104, -0.198289>
    }
    triangle {
      < 1.280519, 4.880578, 0.625888>,
      < 1.045609, 5.199104, -0.198289>,
      < 0.901685, 5.050315, 0.474962>
    }
    triangle {
      < 0.592030, 4.903543, 0.706935>,
      < 0.567755, 4.556178, 1.015865>,
      < 0.980451, 4.731833, 0.748578>
    }
    triangle {
      < 0.592030, 4.903543, 0.706935>,
      < 0.980451, 4.731833, 0.748578>,
      < 0.901685, 5.050315, 0.474962>
    }
    triangle {
      < 0.318251, 4.703004, 0.749029>,
      < 0.239564, 4.400696, 1.076866>,
      < 0.567755, 4.556178, 1.015865>
    }
    triangle {
      < 0.318251, 4.703004, 0.749029>,
      < 0.567755, 4.556178, 1.015865>,
      < 0.592030, 4.903543, 0.706935>
    }
    triangle {
      < 0.000000, 4.550397, 0.793884>,
      < 0.000000, 4.301218, 1.043969>,
      < 0.239564, 4.400696, 1.076866>
    }
    triangle {
      < 0.000000, 4.550397, 0.793884>,
      < 0.239564, 4.400696, 1.076866>,
      < 0.318251, 4.703004, 0.749029>
    }
    triangle {
      < 0.000000, 4.550397, 0.793884>,
      < 0.318251, 4.703004, 0.749029>,
      < 0.265362, 5.383006, 0.783565>
    }
    triangle {
      < 0.000000, 4.550397, 0.793884>,
      < 0.265362, 5.383006, 0.783565>,
      < 0.000000, 5.382403, 0.794159>
    }
    triangle {
      < 0.000000, 3.949126, 1.241518>,
      < 0.253314, 4.127854, 1.326707>,
      < 0.239564, 4.400696, 1.076866>
    }
    triangle {
      < 0.000000, 3.949126, 1.241518>,
      < 0.239564, 4.400696, 1.076866>,
      < 0.000000, 4.301218, 1.043969>
    }
    triangle {
      < 0.769272, 4.095025, 1.528387>,
      < 0.721114, 4.322491, 1.143144>,
      < 0.253314, 4.127854, 1.326707>
    }
    triangle {
      < 0.769272, 4.095025, 1.528387>,
      < 0.253314, 4.127854, 1.326707>,
      < 0.291500, 3.867945, 1.625626>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.867752, 3.665836, 2.143286>,
      < 1.254015, 3.672732, 2.033899>,
      < 1.166408, 4.151222, 1.507141>
    }
    triangle {
      < 0.867752, 3.665836, 2.143286>,
      < 1.166408, 4.151222, 1.507141>,
      < 0.769272, 4.095025, 1.528387>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.769272, 4.095025, 1.528387>,
      < 1.075780, 4.530769, 1.081253>,
      < 0.721114, 4.322491, 1.143144>
    }
    triangle {
      < 0.403846, 3.560652, 2.096469>,
      < 0.000000, 3.400058, 1.856756>,
      < 0.000000, 2.841461, 2.262791>
    }
    triangle {
      < 0.403846, 3.560652, 2.096469>,
      < 0.000000, 2.841461, 2.262791>,
      < 0.117154, 2.882724, 2.450977>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.117154, 2.882724, 2.450977>,
      < 0.000000, 2.841461, 2.262791>,
      < 0.000000, 2.346143, 2.432790>
    }
    triangle {
      < 0.117154, 2.882724, 2.450977>,
      < 0.000000, 2.346143, 2.432790>,
      < 0.130649, 2.233726, 2.523536>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.912253, 0.961551, 2.075965>,
      < 0.273146, 0.985146, 2.250294>,
      < 0.337486, 0.598394, 2.259545>
    }
    triangle {
      < 0.912253, 0.961551, 2.075965>,
      < 0.337486, 0.598394, 2.259545>,
      < 0.855725, 0.305926, 2.111272>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.592209, 2.530067, 2.816833>,
      < 1.561671, 2.687367, 2.805973>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.561671, 2.687367, 2.805973>,
      < 1.472001, 2.810532, 2.815948>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.472001, 2.810532, 2.815948>,
      < 1.330277, 2.880464, 2.847128>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.330277, 2.880464, 2.847128>,
      < 1.215121, 2.878408, 2.879739>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.215121, 2.878408, 2.879739>,
      < 1.098083, 2.820125, 2.919829>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.098083, 2.820125, 2.919829>,
      < 0.991348, 2.644941, 2.971471>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 0.991348, 2.644941, 2.971471>,
      < 0.995371, 2.460758, 2.993102>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 0.995371, 2.460758, 2.993102>,
      < 1.053943, 2.341998, 2.991321>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.053943, 2.341998, 2.991321>,
      < 1.138060, 2.263262, 2.977416>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.138060, 2.263262, 2.977416>,
      < 1.300352, 2.215570, 2.937709>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.300352, 2.215570, 2.937709>,
      < 1.471932, 2.277794, 2.881806>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.721114, 4.322491, 1.143144>,
      < 0.567755, 4.556178, 1.015865>,
      < 0.239564, 4.400696, 1.076866>
    }
    triangle {
      < 0.721114, 4.322491, 1.143144>,
      < 0.239564, 4.400696, 1.076866>,
      < 0.253314, 4.127854, 1.326707>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.348594, -4.288053, 1.255976>,
      < 0.354142, -3.532827, 1.804350>,
      < 0.000000, -3.538705, 1.784168>
    }
    triangle {
      < 0.348594, -4.288053, 1.255976>,
      < 0.000000, -3.538705, 1.784168>,
      < 0.000000, -4.317713, 1.255605>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.000000, 1.960532, -0.707811>,
      < 0.000000, 2.731128, -1.011640>,
      < 0.411851, 2.697264, -1.079330>
    }
    triangle {
      < 0.000000, 1.960532, -0.707811>,
      < 0.411851, 2.697264, -1.079330>,
      < 0.331188, 1.952469, -0.721568>
    }
    triangle {
      < 0.000000, 3.436128, -1.272225>,
      < 0.417627, 3.427953, -1.320746>,
      < 0.411851, 2.697264, -1.079330>
    }
    triangle {
      < 0.000000, 3.436128, -1.272225>,
      < 0.411851, 2.697264, -1.079330>,
      < 0.000000, 2.731128, -1.011640>
    }
    triangle {
      < 0.000000, 4.183734, -1.306784>,
      < 0.394958, 4.177176, -1.359815>,
      < 0.417627, 3.427953, -1.320746>
    }
    triangle {
      < 0.000000, 4.183734, -1.306784>,
      < 0.417627, 3.427953, -1.320746>,
      < 0.000000, 3.436128, -1.272225>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.000000, 5.159589, -1.245507>,
      < 0.406415, 5.139683, -1.193436>,
      < 0.372289, 4.772006, -1.286856>
    }
    triangle {
      < 0.000000, 5.159589, -1.245507>,
      < 0.372289, 4.772006, -1.286856>,
      < 0.000000, 4.779373, -1.250972>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 1.278406, 1.953809, -0.458386>,
      < 0.881610, 1.952035, -0.642381>,
      < 0.842364, 2.705815, -0.972412>
    }
    triangle {
      < 1.278406, 1.953809, -0.458386>,
      < 0.842364, 2.705815, -0.972412>,
      < 1.286229, 2.733644, -0.800674>
    }
    triangle {
      < 1.286229, 2.733644, -0.800674>,
      < 1.691266, 2.802418, -0.566645>,
      < 1.595705, 1.961731, -0.268515>
    }
    triangle {
      < 1.286229, 2.733644, -0.800674>,
      < 1.595705, 1.961731, -0.268515>,
      < 1.278406, 1.953809, -0.458386>
    }
    triangle {
      < 0.881610, 1.952035, -0.642381>,
      < 0.331188, 1.952469, -0.721568>,
      < 0.411851, 2.697264, -1.079330>
    }
    triangle {
      < 0.881610, 1.952035, -0.642381>,
      < 0.411851, 2.697264, -1.079330>,
      < 0.842364, 2.705815, -0.972412>
    }
    triangle {
      < 0.417627, 3.427953, -1.320746>,
      < 0.833102, 3.427677, -1.228459>,
      < 0.842364, 2.705815, -0.972412>
    }
    triangle {
      < 0.417627, 3.427953, -1.320746>,
      < 0.842364, 2.705815, -0.972412>,
      < 0.411851, 2.697264, -1.079330>
    }
    triangle {
      < 1.311612, 3.428961, -1.057804>,
      < 1.286229, 2.733644, -0.800674>,
      < 0.842364, 2.705815, -0.972412>
    }
    triangle {
      < 1.311612, 3.428961, -1.057804>,
      < 0.842364, 2.705815, -0.972412>,
      < 0.833102, 3.427677, -1.228459>
    }
    triangle {
      < 1.713060, 3.430965, -0.885488>,
      < 1.691266, 2.802418, -0.566645>,
      < 1.286229, 2.733644, -0.800674>
    }
    triangle {
      < 1.713060, 3.430965, -0.885488>,
      < 1.286229, 2.733644, -0.800674>,
      < 1.311612, 3.428961, -1.057804>
    }
    triangle {
      < 1.220386, 4.176666, -1.094361>,
      < 1.692724, 4.074691, -0.865690>,
      < 1.713060, 3.430965, -0.885488>
    }
    triangle {
      < 1.220386, 4.176666, -1.094361>,
      < 1.713060, 3.430965, -0.885488>,
      < 1.311612, 3.428961, -1.057804>
    }
    triangle {
      < 1.311612, 3.428961, -1.057804>,
      < 0.833102, 3.427677, -1.228459>,
      < 0.759639, 4.176108, -1.275736>
    }
    triangle {
      < 1.311612, 3.428961, -1.057804>,
      < 0.759639, 4.176108, -1.275736>,
      < 1.220386, 4.176666, -1.094361>
    }
    triangle {
      < 0.833102, 3.427677, -1.228459>,
      < 0.417627, 3.427953, -1.320746>,
      < 0.394958, 4.177176, -1.359815>
    }
    triangle {
      < 0.833102, 3.427677, -1.228459>,
      < 0.394958, 4.177176, -1.359815>,
      < 0.759639, 4.176108, -1.275736>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.129160, 4.772320, -1.039785>,
      < 0.686176, 4.772114, -1.228553>,
      < 0.733256, 5.140341, -1.143047>
    }
    triangle {
      < 1.129160, 4.772320, -1.039785>,
      < 0.733256, 5.140341, -1.143047>,
      < 0.905801, 5.111265, -0.938432>
    }
    triangle {
      < 0.686176, 4.772114, -1.228553>,
      < 0.372289, 4.772006, -1.286856>,
      < 0.406415, 5.139683, -1.193436>
    }
    triangle {
      < 0.686176, 4.772114, -1.228553>,
      < 0.406415, 5.139683, -1.193436>,
      < 0.733256, 5.140341, -1.143047>
    }
    triangle {
      < 0.870650, 1.624373, -0.491663>,
      < 0.881610, 1.952035, -0.642381>,
      < 1.278406, 1.953809, -0.458386>
    }
    triangle {
      < 0.870650, 1.624373, -0.491663>,
      < 1.278406, 1.953809, -0.458386>,
      < 1.209537, 1.626351, -0.268946>
    }
    triangle {
      < 0.347101, 1.625607, -0.536655>,
      < 0.331188, 1.952469, -0.721568>,
      < 0.881610, 1.952035, -0.642381>
    }
    triangle {
      < 0.347101, 1.625607, -0.536655>,
      < 0.881610, 1.952035, -0.642381>,
      < 0.870650, 1.624373, -0.491663>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.870650, 1.624373, -0.491663>,
      < 0.761863, 0.935459, -0.192583>,
      < 0.281991, 0.951491, -0.199283>
    }
    triangle {
      < 0.870650, 1.624373, -0.491663>,
      < 0.281991, 0.951491, -0.199283>,
      < 0.347101, 1.625607, -0.536655>
    }
    triangle {
      < 1.209537, 1.626351, -0.268946>,
      < 1.153018, 0.924817, -0.087208>,
      < 0.761863, 0.935459, -0.192583>
    }
    triangle {
      < 1.209537, 1.626351, -0.268946>,
      < 0.761863, 0.935459, -0.192583>,
      < 0.870650, 1.624373, -0.491663>
    }
    triangle {
      < 1.504927, 1.630030, -0.114216>,
      < 1.421312, 0.928829, 0.106105>,
      < 1.153018, 0.924817, -0.087208>
    }
    triangle {
      < 1.504927, 1.630030, -0.114216>,
      < 1.153018, 0.924817, -0.087208>,
      < 1.209537, 1.626351, -0.268946>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.209537, 1.626351, -0.268946>,
      < 1.278406, 1.953809, -0.458386>,
      < 1.595705, 1.961731, -0.268515>
    }
    triangle {
      < 1.209537, 1.626351, -0.268946>,
      < 1.595705, 1.961731, -0.268515>,
      < 1.504927, 1.630030, -0.114216>
    }
    triangle {
      < 0.000000, 1.960532, -0.707811>,
      < 0.331188, 1.952469, -0.721568>,
      < 0.347101, 1.625607, -0.536655>
    }
    triangle {
      < 0.000000, 1.960532, -0.707811>,
      < 0.347101, 1.625607, -0.536655>,
      < 0.000000, 1.633274, -0.388205>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.347101, 1.625607, -0.536655>,
      < 0.281991, 0.951491, -0.199283>,
      < 0.000000, 0.959683, -0.069663>
    }
    triangle {
      < 0.347101, 1.625607, -0.536655>,
      < 0.000000, 0.959683, -0.069663>,
      < 0.000000, 1.633274, -0.388205>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 2.132606, 2.497405, 1.932280>,
      < 2.006081, 1.993751, 2.030076>,
      < 2.190560, 2.382803, 1.200480>
    }
    triangle {
      < 2.132606, 2.497405, 1.932280>,
      < 2.190560, 2.382803, 1.200480>,
      < 2.163962, 2.786233, 1.464963>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 1.311563, 4.775741, -0.821882>,
      < 1.431619, 4.809371, -0.508151>,
      < 1.715634, 4.757394, -0.424567>
    }
    triangle {
      < 1.311563, 4.775741, -0.821882>,
      < 1.715634, 4.757394, -0.424567>,
      < 1.672387, 4.390581, -0.737402>
    }
    triangle {
      < 0.567755, 4.556178, 1.015865>,
      < 0.721114, 4.322491, 1.143144>,
      < 1.075780, 4.530769, 1.081253>
    }
    triangle {
      < 0.567755, 4.556178, 1.015865>,
      < 1.075780, 4.530769, 1.081253>,
      < 0.980451, 4.731833, 0.748578>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.000000, -4.651278, 0.474008>,
      < 0.000000, -4.602162, -0.492641>,
      < 0.255535, -4.694487, -0.625129>
    }
    triangle {
      < 0.000000, -4.651278, 0.474008>,
      < 0.255535, -4.694487, -0.625129>,
      < 0.298104, -4.734981, -0.329984>
    }
    triangle {
      < 0.000000, -4.651278, 0.474008>,
      < 0.298104, -4.734981, -0.329984>,
      < 0.179637, -4.620719, 0.468996>
    }
    triangle {
      < 0.348594, -4.288053, 1.255976>,
      < 0.000000, -4.317713, 1.255605>,
      < 0.000000, -4.651278, 0.474008>
    }
    triangle {
      < 0.348594, -4.288053, 1.255976>,
      < 0.000000, -4.651278, 0.474008>,
      < 0.179637, -4.620719, 0.468996>
    }
    triangle {
      < 1.044887, 5.189893, -0.787099>,
      < 1.141270, 5.206872, -0.527612>,
      < 1.431619, 4.809371, -0.508151>
    }
    triangle {
      < 1.044887, 5.189893, -0.787099>,
      < 1.431619, 4.809371, -0.508151>,
      < 1.311563, 4.775741, -0.821882>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.647537, 5.383266, -0.933723>,
      < 0.855210, 5.383354, -0.726514>,
      < 0.905801, 5.111265, -0.938432>
    }
    triangle {
      < 0.647537, 5.383266, -0.933723>,
      < 0.905801, 5.111265, -0.938432>,
      < 0.733256, 5.140341, -1.143047>
    }
    triangle {
      < 0.429972, 5.383253, -1.057937>,
      < 0.647537, 5.383266, -0.933723>,
      < 0.733256, 5.140341, -1.143047>
    }
    triangle {
      < 0.429972, 5.383253, -1.057937>,
      < 0.733256, 5.140341, -1.143047>,
      < 0.406415, 5.139683, -1.193436>
    }
    triangle {
      < 0.000000, 5.383317, -1.144730>,
      < 0.429972, 5.383253, -1.057937>,
      < 0.406415, 5.139683, -1.193436>
    }
    triangle {
      < 0.000000, 5.383317, -1.144730>,
      < 0.406415, 5.139683, -1.193436>,
      < 0.000000, 5.159589, -1.245507>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.231797, 6.599135, -0.204098>,
      < 0.153586, 6.607885, -0.250214>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.153586, 6.607885, -0.250214>,
      < 0.000000, 6.614027, -0.282431>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.000000, 6.614027, -0.282431>,
      < 0.000000, 6.477004, 0.437311>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.000000, 6.477004, 0.437311>,
      < 0.094412, 6.477975, 0.433420>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.094412, 6.477975, 0.433420>,
      < 0.189822, 6.487049, 0.386961>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.189822, 6.487049, 0.386961>,
      < 0.324684, 6.512660, 0.254128>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.324684, 6.512660, 0.254128>,
      < 0.370275, 6.538164, 0.118853>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.370275, 6.538164, 0.118853>,
      < 0.364813, 6.559850, 0.003741>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.364813, 6.559850, 0.003741>,
      < 0.333556, 6.576173, -0.082966>
    }
    triangle {
      < 1.032748, 5.384184, -0.063988>,
      < 0.905925, 5.384666, 0.300302>,
      < 0.901685, 5.050315, 0.474962>
    }
    triangle {
      < 1.032748, 5.384184, -0.063988>,
      < 0.901685, 5.050315, 0.474962>,
      < 1.045609, 5.199104, -0.198289>
    }
    triangle {
      < 1.017555, 5.383738, -0.373970>,
      < 1.032748, 5.384184, -0.063988>,
      < 1.045609, 5.199104, -0.198289>
    }
    triangle {
      < 1.017555, 5.383738, -0.373970>,
      < 1.045609, 5.199104, -0.198289>,
      < 1.141270, 5.206872, -0.527612>
    }
    triangle {
      < 0.930606, 5.383365, -0.607457>,
      < 1.017555, 5.383738, -0.373970>,
      < 1.141270, 5.206872, -0.527612>
    }
    triangle {
      < 0.930606, 5.383365, -0.607457>,
      < 1.141270, 5.206872, -0.527612>,
      < 1.044887, 5.189893, -0.787099>
    }
    triangle {
      < 0.855210, 5.383354, -0.726514>,
      < 0.930606, 5.383365, -0.607457>,
      < 1.044887, 5.189893, -0.787099>
    }
    triangle {
      < 0.855210, 5.383354, -0.726514>,
      < 1.044887, 5.189893, -0.787099>,
      < 0.905801, 5.111265, -0.938432>
    }
    triangle {
      < 1.045609, 5.199104, -0.198289>,
      < 1.273308, 4.980906, -0.154589>,
      < 1.141270, 5.206872, -0.527612>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.905801, 5.111265, -0.938432>,
      < 1.044887, 5.189893, -0.787099>,
      < 1.311563, 4.775741, -0.821882>
    }
    triangle {
      < 0.905801, 5.111265, -0.938432>,
      < 1.311563, 4.775741, -0.821882>,
      < 1.129160, 4.772320, -1.039785>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.401765, -4.475097, 0.374795>,
      < 1.517964, -4.450105, 0.247368>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.517964, -4.450105, 0.247368>,
      < 1.738226, -4.347697, 0.140237>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.738226, -4.347697, 0.140237>,
      < 1.950404, -4.145929, 0.209101>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.950404, -4.145929, 0.209101>,
      < 2.034378, -3.979250, 0.418934>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 2.034378, -3.979250, 0.418934>,
      < 2.030397, -3.861973, 0.658580>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 2.030397, -3.861973, 0.658580>,
      < 1.908456, -3.883644, 0.925504>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.908456, -3.883644, 0.925504>,
      < 1.741470, -3.998837, 1.006610>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.741470, -3.998837, 1.006610>,
      < 1.604052, -4.133869, 0.986076>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.604052, -4.133869, 0.986076>,
      < 1.415966, -4.349393, 0.820869>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.592030, 4.903543, 0.706935>,
      < 0.530772, 5.383664, 0.658299>,
      < 0.265362, 5.383006, 0.783565>
    }
    triangle {
      < 0.592030, 4.903543, 0.706935>,
      < 0.265362, 5.383006, 0.783565>,
      < 0.318251, 4.703004, 0.749029>
    }
    triangle {
      < 0.000000, 3.661831, 1.566266>,
      < 0.291500, 3.867945, 1.625626>,
      < 0.253314, 4.127854, 1.326707>
    }
    triangle {
      < 0.000000, 3.661831, 1.566266>,
      < 0.253314, 4.127854, 1.326707>,
      < 0.000000, 3.949126, 1.241518>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.403846, 3.560652, 2.096469>,
      < 0.475173, 3.470336, 2.277757>,
      < 0.867752, 3.665836, 2.143286>
    }
    triangle {
      < 0.403846, 3.560652, 2.096469>,
      < 0.867752, 3.665836, 2.143286>,
      < 0.769272, 4.095025, 1.528387>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.000000, 3.661831, 1.566266>,
      < 0.000000, 3.400058, 1.856756>,
      < 0.403846, 3.560652, 2.096469>
    }
    triangle {
      < 0.000000, 3.661831, 1.566266>,
      < 0.403846, 3.560652, 2.096469>,
      < 0.291500, 3.867945, 1.625626>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.475173, 3.470336, 2.277757>,
      < 0.403846, 3.560652, 2.096469>,
      < 0.117154, 2.882724, 2.450977>
    }
    triangle {
      < 0.130649, 2.233726, 2.523536>,
      < 0.000000, 2.346143, 2.432790>,
      < 0.000000, 1.685680, 2.416312>
    }
    triangle {
      < 0.130649, 2.233726, 2.523536>,
      < 0.000000, 1.685680, 2.416312>,
      < 0.327114, 1.835370, 2.517562>
    }
    triangle {
      < 1.677819, 1.606148, 1.232651>,
      < 2.190560, 2.382803, 1.200480>,
      < 2.006081, 1.993751, 2.030076>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.000000, -2.270840, 2.094989>,
      < 0.380002, -2.254292, 2.142292>,
      < 0.200286, -1.505385, 2.203278>
    }
    triangle {
      < 0.000000, -2.270840, 2.094989>,
      < 0.200286, -1.505385, 2.203278>,
      < 0.000000, -1.527481, 2.176464>
    }
    triangle {
      < 0.034745, -0.781618, 2.138963>,
      < 0.000000, -0.786156, 2.144047>,
      < 0.000000, -1.527481, 2.176464>
    }
    triangle {
      < 0.034745, -0.781618, 2.138963>,
      < 0.000000, -1.527481, 2.176464>,
      < 0.200286, -1.505385, 2.203278>
    }
    triangle {
      < 1.952047, 3.541013, -0.074353>,
      < 2.107250, 2.950416, -0.048552>,
      < 2.010648, 2.861194, -0.415499>
    }
    triangle {
      < 1.952047, 3.541013, -0.074353>,
      < 2.010648, 2.861194, -0.415499>,
      < 2.015426, 3.432471, -0.791534>
    }
    triangle {
      < 1.984582, 3.398288, 1.216279>,
      < 1.939731, 3.584849, 0.361395>,
      < 2.101572, 3.803901, 0.799654>
    }
    triangle {
      < 2.078001, 3.237533, 1.523019>,
      < 1.984582, 3.398288, 1.216279>,
      < 1.803902, 3.890965, 1.209492>
    }
    triangle {
      < 2.078001, 3.237533, 1.523019>,
      < 1.803902, 3.890965, 1.209492>,
      < 1.733052, 3.843242, 1.490024>
    }
    triangle {
      < 1.984582, 3.398288, 1.216279>,
      < 2.161230, 2.999388, 1.153979>,
      < 2.134239, 2.999644, 0.500486>
    }
    triangle {
      < 1.984582, 3.398288, 1.216279>,
      < 2.134239, 2.999644, 0.500486>,
      < 1.939731, 3.584849, 0.361395>
    }
    triangle {
      < 1.939731, 3.584849, 0.361395>,
      < 2.134239, 2.999644, 0.500486>,
      < 2.107250, 2.950416, -0.048552>
    }
    triangle {
      < 1.939731, 3.584849, 0.361395>,
      < 2.107250, 2.950416, -0.048552>,
      < 1.952047, 3.541013, -0.074353>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 2.190560, 2.382803, 1.200480>,
      < 1.677819, 1.606148, 1.232651>,
      < 1.740981, 1.647860, 0.799099>
    }
    triangle {
      < 2.190560, 2.382803, 1.200480>,
      < 1.740981, 1.647860, 0.799099>,
      < 1.985498, 2.028215, 0.709301>
    }
    triangle {
      < 1.740981, 1.647860, 0.799099>,
      < 1.783412, 1.641130, 0.296395>,
      < 1.908859, 1.975836, 0.203519>
    }
    triangle {
      < 1.740981, 1.647860, 0.799099>,
      < 1.908859, 1.975836, 0.203519>,
      < 1.985498, 2.028215, 0.709301>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 1.908859, 1.975836, 0.203519>,
      < 2.107250, 2.950416, -0.048552>,
      < 2.134239, 2.999644, 0.500486>
    }
    triangle {
      < 1.908859, 1.975836, 0.203519>,
      < 2.134239, 2.999644, 0.500486>,
      < 1.985498, 2.028215, 0.709301>
    }
    triangle {
      < 2.134239, 2.999644, 0.500486>,
      < 2.161230, 2.999388, 1.153979>,
      < 2.190560, 2.382803, 1.200480>
    }
    triangle {
      < 2.134239, 2.999644, 0.500486>,
      < 2.190560, 2.382803, 1.200480>,
      < 1.985498, 2.028215, 0.709301>
    }
    triangle {
      < 2.268412, 4.117446, -0.395912>,
      < 2.424494, 4.345810, -0.180659>,
      < 2.482014, 4.415555, 0.265006>
    }
    triangle {
      < 2.268412, 4.117446, -0.395912>,
      < 2.482014, 4.415555, 0.265006>,
      < 2.374932, 4.311445, 0.581421>
    }
    triangle {
      < 2.268412, 4.117446, -0.395912>,
      < 2.374932, 4.311445, 0.581421>,
      < 2.101572, 3.803901, 0.799654>
    }
    triangle {
      < 2.268412, 4.117446, -0.395912>,
      < 2.101572, 3.803901, 0.799654>,
      < 1.939731, 3.584849, 0.361395>
    }
    triangle {
      < 2.268412, 4.117446, -0.395912>,
      < 1.939731, 3.584849, 0.361395>,
      < 1.952047, 3.541013, -0.074353>
    }
    triangle {
      < 2.268412, 4.117446, -0.395912>,
      < 1.952047, 3.541013, -0.074353>,
      < 2.083994, 3.764152, -0.526183>
    }
    triangle {
      < 2.101572, 3.803901, 0.799654>,
      < 1.803902, 3.890965, 1.209492>,
      < 1.984582, 3.398288, 1.216279>
    }
    triangle {
      < 1.672387, 4.390581, -0.737402>,
      < 2.029075, 4.281486, -0.593433>,
      < 1.998452, 3.933387, -0.729109>
    }
    triangle {
      < 1.672387, 4.390581, -0.737402>,
      < 1.998452, 3.933387, -0.729109>,
      < 1.692724, 4.074691, -0.865690>
    }
    triangle {
      < 1.129160, 4.772320, -1.039785>,
      < 1.672387, 4.390581, -0.737402>,
      < 1.692724, 4.074691, -0.865690>
    }
    triangle {
      < 1.129160, 4.772320, -1.039785>,
      < 1.692724, 4.074691, -0.865690>,
      < 1.220386, 4.176666, -1.094361>
    }
    triangle {
      < 0.686176, 4.772114, -1.228553>,
      < 1.129160, 4.772320, -1.039785>,
      < 1.220386, 4.176666, -1.094361>
    }
    triangle {
      < 0.686176, 4.772114, -1.228553>,
      < 1.220386, 4.176666, -1.094361>,
      < 0.759639, 4.176108, -1.275736>
    }
    triangle {
      < 0.372289, 4.772006, -1.286856>,
      < 0.686176, 4.772114, -1.228553>,
      < 0.759639, 4.176108, -1.275736>
    }
    triangle {
      < 0.372289, 4.772006, -1.286856>,
      < 0.759639, 4.176108, -1.275736>,
      < 0.394958, 4.177176, -1.359815>
    }
    triangle {
      < 0.000000, 4.779373, -1.250972>,
      < 0.372289, 4.772006, -1.286856>,
      < 0.394958, 4.177176, -1.359815>
    }
    triangle {
      < 0.000000, 4.779373, -1.250972>,
      < 0.394958, 4.177176, -1.359815>,
      < 0.000000, 4.183734, -1.306784>
    }
    triangle {
      < 0.775331, -0.395819, -0.293731>,
      < 0.256247, -0.378244, -0.343827>,
      < 0.264625, 0.388178, -0.173283>
    }
    triangle {
      < 0.775331, -0.395819, -0.293731>,
      < 0.264625, 0.388178, -0.173283>,
      < 0.676174, 0.356651, -0.147042>
    }
    triangle {
      < 1.134307, -0.395637, -0.215442>,
      < 0.775331, -0.395819, -0.293731>,
      < 0.676174, 0.356651, -0.147042>
    }
    triangle {
      < 1.134307, -0.395637, -0.215442>,
      < 0.676174, 0.356651, -0.147042>,
      < 1.023351, 0.346405, -0.053167>
    }
    triangle {
      < 1.477786, -0.393219, -0.084196>,
      < 1.134307, -0.395637, -0.215442>,
      < 1.023351, 0.346405, -0.053167>
    }
    triangle {
      < 1.477786, -0.393219, -0.084196>,
      < 1.023351, 0.346405, -0.053167>,
      < 1.324927, 0.351883, 0.083510>
    }
    triangle {
      < 1.734500, -0.418211, 0.226525>,
      < 1.477786, -0.393219, -0.084196>,
      < 1.324927, 0.351883, 0.083510>
    }
    triangle {
      < 1.734500, -0.418211, 0.226525>,
      < 1.324927, 0.351883, 0.083510>,
      < 1.567689, 0.343412, 0.374270>
    }
    triangle {
      < 1.835413, -0.461101, 0.782676>,
      < 1.734500, -0.418211, 0.226525>,
      < 1.567689, 0.343412, 0.374270>
    }
    triangle {
      < 1.835413, -0.461101, 0.782676>,
      < 1.567689, 0.343412, 0.374270>,
      < 1.667724, 0.325124, 0.861139>
    }
    triangle {
      < 1.835413, -0.461101, 0.782676>,
      < 1.667724, 0.325124, 0.861139>,
      < 1.630292, 0.298432, 0.980606>
    }
    triangle {
      < 1.615223, -0.478884, 1.642453>,
      < 1.835413, -0.461101, 0.782676>,
      < 1.630292, 0.298432, 0.980606>
    }
    triangle {
      < 1.615223, -0.478884, 1.642453>,
      < 1.630292, 0.298432, 0.980606>,
      < 1.368342, 0.290731, 1.693234>
    }
    triangle {
      < 1.088540, -0.502982, 2.096247>,
      < 1.615223, -0.478884, 1.642453>,
      < 1.368342, 0.290731, 1.693234>
    }
    triangle {
      < 1.088540, -0.502982, 2.096247>,
      < 1.368342, 0.290731, 1.693234>,
      < 0.855725, 0.305926, 2.111272>
    }
    triangle {
      < 0.461192, 0.053048, 2.272134>,
      < 0.855725, 0.305926, 2.111272>,
      < 0.337486, 0.598394, 2.259545>
    }
    triangle {
      < 0.000000, 0.286501, 2.168349>,
      < 0.265781, 0.220905, 2.228825>,
      < 0.337486, 0.598394, 2.259545>
    }
    triangle {
      < 0.000000, 0.286501, 2.168349>,
      < 0.337486, 0.598394, 2.259545>,
      < 0.000000, 0.727521, 2.268319>
    }
    triangle {
      < 0.461192, 0.053048, 2.272134>,
      < 0.337486, 0.598394, 2.259545>,
      < 0.265781, 0.220905, 2.228825>
    }
    triangle {
      < 0.461192, 0.053048, 2.272134>,
      < 0.265781, 0.220905, 2.228825>,
      < 0.030486, -0.538444, 2.142306>
    }
    triangle {
      < 0.461192, 0.053048, 2.272134>,
      < 0.030486, -0.538444, 2.142306>,
      < 0.066715, -0.604138, 2.139349>
    }
    triangle {
      < 0.019225, -0.758992, 2.036500>,
      < 0.040219, -0.704352, 2.036748>,
      < 0.053526, -0.666143, 2.035450>
    }
    triangle {
      < 0.019225, -0.758992, 2.036500>,
      < 0.053526, -0.666143, 2.035450>,
      < 0.043521, -0.616914, 2.036793>
    }
    triangle {
      < 0.019225, -0.758992, 2.036500>,
      < 0.043521, -0.616914, 2.036793>,
      < 0.015988, -0.566989, 2.039040>
    }
    triangle {
      < 0.019225, -0.758992, 2.036500>,
      < 0.015988, -0.566989, 2.039040>,
      < 0.000000, -0.550260, 2.040503>
    }
    triangle {
      < 0.019225, -0.758992, 2.036500>,
      < 0.000000, -0.550260, 2.040503>,
      < 0.000000, -0.760712, 2.040363>
    }
    triangle {
      < 0.000000, 0.959683, -0.069663>,
      < 0.281991, 0.951491, -0.199283>,
      < 0.264625, 0.388178, -0.173283>
    }
    triangle {
      < 0.000000, 0.959683, -0.069663>,
      < 0.264625, 0.388178, -0.173283>,
      < 0.000000, 0.418408, -0.112867>
    }
    triangle {
      < 0.891979, -2.200235, 2.236348>,
      < 1.469949, -2.124545, 2.087185>,
      < 1.321224, -1.299337, 2.064278>
    }
    triangle {
      < 0.891979, -2.200235, 2.236348>,
      < 1.321224, -1.299337, 2.064278>,
      < 0.473522, -1.293983, 2.269722>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.017310, -3.521789, 1.843347>,
      < 0.354142, -3.532827, 1.804350>,
      < 0.348594, -4.288053, 1.255976>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.291500, 3.867945, 1.625626>,
      < 0.403846, 3.560652, 2.096469>,
      < 0.769272, 4.095025, 1.528387>
    }
    triangle {
      < 1.280519, 4.880578, 0.625888>,
      < 0.901685, 5.050315, 0.474962>,
      < 0.980451, 4.731833, 0.748578>
    }
    triangle {
      < 1.280519, 4.880578, 0.625888>,
      < 0.980451, 4.731833, 0.748578>,
      < 1.075780, 4.530769, 1.081253>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 1.166408, 4.151222, 1.507141>,
      < 1.075780, 4.530769, 1.081253>,
      < 0.769272, 4.095025, 1.528387>
    }
    triangle {
      < 2.340441, -3.563589, 0.158397>,
      < 2.151490, -3.938636, -0.313752>,
      < 2.248718, -3.572636, -0.898282>
    }
    triangle {
      < 2.340441, -3.563589, 0.158397>,
      < 2.248718, -3.572636, -0.898282>,
      < 2.547276, -2.972060, -0.173055>
    }
    triangle {
      < 2.151490, -3.938636, -0.313752>,
      < 1.674065, -4.392637, -0.468703>,
      < 1.494346, -4.284712, -1.156904>
    }
    triangle {
      < 2.151490, -3.938636, -0.313752>,
      < 1.494346, -4.284712, -1.156904>,
      < 2.248718, -3.572636, -0.898282>
    }
    triangle {
      < 1.674065, -4.392637, -0.468703>,
      < 1.178450, -4.623069, -0.227645>,
      < 0.711234, -4.646127, -0.783033>
    }
    triangle {
      < 1.674065, -4.392637, -0.468703>,
      < 0.711234, -4.646127, -0.783033>,
      < 1.494346, -4.284712, -1.156904>
    }
    triangle {
      < 1.178450, -4.623069, -0.227645>,
      < 0.916989, -4.679303, 0.059080>,
      < 0.298104, -4.734981, -0.329984>
    }
    triangle {
      < 1.178450, -4.623069, -0.227645>,
      < 0.298104, -4.734981, -0.329984>,
      < 0.711234, -4.646127, -0.783033>
    }
    triangle {
      < 0.916989, -4.679303, 0.059080>,
      < 0.842014, -4.606988, 0.564737>,
      < 0.179637, -4.620719, 0.468996>
    }
    triangle {
      < 0.916989, -4.679303, 0.059080>,
      < 0.179637, -4.620719, 0.468996>,
      < 0.298104, -4.734981, -0.329984>
    }
    triangle {
      < 0.842014, -4.606988, 0.564737>,
      < 0.948943, -4.396451, 1.062799>,
      < 0.348594, -4.288053, 1.255976>
    }
    triangle {
      < 0.842014, -4.606988, 0.564737>,
      < 0.348594, -4.288053, 1.255976>,
      < 0.179637, -4.620719, 0.468996>
    }
    triangle {
      < 0.948943, -4.396451, 1.062799>,
      < 1.372159, -3.911500, 1.434534>,
      < 1.017310, -3.521789, 1.843347>
    }
    triangle {
      < 0.948943, -4.396451, 1.062799>,
      < 1.017310, -3.521789, 1.843347>,
      < 0.348594, -4.288053, 1.255976>
    }
    triangle {
      < 1.372159, -3.911500, 1.434534>,
      < 1.681364, -3.607662, 1.480737>,
      < 1.505880, -3.041700, 1.916351>
    }
    triangle {
      < 1.372159, -3.911500, 1.434534>,
      < 1.505880, -3.041700, 1.916351>,
      < 1.017310, -3.521789, 1.843347>
    }
    triangle {
      < 1.681364, -3.607662, 1.480737>,
      < 2.057103, -3.348463, 1.298239>,
      < 2.099578, -2.632143, 1.627991>
    }
    triangle {
      < 1.681364, -3.607662, 1.480737>,
      < 2.099578, -2.632143, 1.627991>,
      < 1.505880, -3.041700, 1.916351>
    }
    triangle {
      < 2.057103, -3.348463, 1.298239>,
      < 2.331484, -3.299701, 0.697630>,
      < 2.533123, -2.555095, 0.678978>
    }
    triangle {
      < 2.057103, -3.348463, 1.298239>,
      < 2.533123, -2.555095, 0.678978>,
      < 2.099578, -2.632143, 1.627991>
    }
    triangle {
      < 2.331484, -3.299701, 0.697630>,
      < 2.340441, -3.563589, 0.158397>,
      < 2.547276, -2.972060, -0.173055>
    }
    triangle {
      < 2.331484, -3.299701, 0.697630>,
      < 2.547276, -2.972060, -0.173055>,
      < 2.533123, -2.555095, 0.678978>
    }
    triangle {
      < 1.741470, -3.998837, 1.006610>,
      < 1.908456, -3.883644, 0.925504>,
      < 2.057103, -3.348463, 1.298239>
    }
    triangle {
      < 1.741470, -3.998837, 1.006610>,
      < 2.057103, -3.348463, 1.298239>,
      < 1.681364, -3.607662, 1.480737>
    }
    triangle {
      < 1.908456, -3.883644, 0.925504>,
      < 2.030397, -3.861973, 0.658580>,
      < 2.331484, -3.299701, 0.697630>
    }
    triangle {
      < 1.908456, -3.883644, 0.925504>,
      < 2.331484, -3.299701, 0.697630>,
      < 2.057103, -3.348463, 1.298239>
    }
    triangle {
      < 2.030397, -3.861973, 0.658580>,
      < 2.034378, -3.979250, 0.418934>,
      < 2.340441, -3.563589, 0.158397>
    }
    triangle {
      < 2.030397, -3.861973, 0.658580>,
      < 2.340441, -3.563589, 0.158397>,
      < 2.331484, -3.299701, 0.697630>
    }
    triangle {
      < 2.034378, -3.979250, 0.418934>,
      < 1.950404, -4.145929, 0.209101>,
      < 2.151490, -3.938636, -0.313752>
    }
    triangle {
      < 2.034378, -3.979250, 0.418934>,
      < 2.151490, -3.938636, -0.313752>,
      < 2.340441, -3.563589, 0.158397>
    }
    triangle {
      < 1.950404, -4.145929, 0.209101>,
      < 1.738226, -4.347697, 0.140237>,
      < 1.674065, -4.392637, -0.468703>
    }
    triangle {
      < 1.950404, -4.145929, 0.209101>,
      < 1.674065, -4.392637, -0.468703>,
      < 2.151490, -3.938636, -0.313752>
    }
    triangle {
      < 1.738226, -4.347697, 0.140237>,
      < 1.517964, -4.450105, 0.247368>,
      < 1.178450, -4.623069, -0.227645>
    }
    triangle {
      < 1.738226, -4.347697, 0.140237>,
      < 1.178450, -4.623069, -0.227645>,
      < 1.674065, -4.392637, -0.468703>
    }
    triangle {
      < 1.517964, -4.450105, 0.247368>,
      < 1.401765, -4.475097, 0.374795>,
      < 0.916989, -4.679303, 0.059080>
    }
    triangle {
      < 1.517964, -4.450105, 0.247368>,
      < 0.916989, -4.679303, 0.059080>,
      < 1.178450, -4.623069, -0.227645>
    }
    triangle {
      < 1.401765, -4.475097, 0.374795>,
      < 1.368444, -4.442959, 0.599520>,
      < 0.842014, -4.606988, 0.564737>
    }
    triangle {
      < 1.401765, -4.475097, 0.374795>,
      < 0.842014, -4.606988, 0.564737>,
      < 0.916989, -4.679303, 0.059080>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 1.415966, -4.349393, 0.820869>,
      < 0.948943, -4.396451, 1.062799>
    }
    triangle {
      < 1.368444, -4.442959, 0.599520>,
      < 0.948943, -4.396451, 1.062799>,
      < 0.842014, -4.606988, 0.564737>
    }
    triangle {
      < 1.415966, -4.349393, 0.820869>,
      < 1.604052, -4.133869, 0.986076>,
      < 1.372159, -3.911500, 1.434534>
    }
    triangle {
      < 1.415966, -4.349393, 0.820869>,
      < 1.372159, -3.911500, 1.434534>,
      < 0.948943, -4.396451, 1.062799>
    }
    triangle {
      < 1.604052, -4.133869, 0.986076>,
      < 1.741470, -3.998837, 1.006610>,
      < 1.681364, -3.607662, 1.480737>
    }
    triangle {
      < 1.604052, -4.133869, 0.986076>,
      < 1.681364, -3.607662, 1.480737>,
      < 1.372159, -3.911500, 1.434534>
    }
    texture {suit}
  }
  // body
  union {
    triangle {
      < 0.015988, -0.566989, 2.039040>,
      < 0.043521, -0.616914, 2.036793>,
      < 0.066715, -0.604138, 2.139349>
    }
    triangle {
      < 0.015988, -0.566989, 2.039040>,
      < 0.066715, -0.604138, 2.139349>,
      < 0.030486, -0.538444, 2.142306>
    }
    triangle {
      < 0.043521, -0.616914, 2.036793>,
      < 0.053526, -0.666143, 2.035450>,
      < 0.079880, -0.668916, 2.137583>
    }
    triangle {
      < 0.043521, -0.616914, 2.036793>,
      < 0.079880, -0.668916, 2.137583>,
      < 0.066715, -0.604138, 2.139349>
    }
    triangle {
      < 0.053526, -0.666143, 2.035450>,
      < 0.040219, -0.704352, 2.036748>,
      < 0.062370, -0.719194, 2.139291>
    }
    triangle {
      < 0.053526, -0.666143, 2.035450>,
      < 0.062370, -0.719194, 2.139291>,
      < 0.079880, -0.668916, 2.137583>
    }
    triangle {
      < 0.040219, -0.704352, 2.036748>,
      < 0.019225, -0.758992, 2.036500>,
      < 0.034745, -0.781618, 2.138963>
    }
    triangle {
      < 0.040219, -0.704352, 2.036748>,
      < 0.034745, -0.781618, 2.138963>,
      < 0.062370, -0.719194, 2.139291>
    }
    triangle {
      < 0.019225, -0.758992, 2.036500>,
      < 0.000000, -0.760712, 2.040363>,
      < 0.000000, -0.786156, 2.144047>
    }
    triangle {
      < 0.019225, -0.758992, 2.036500>,
      < 0.000000, -0.786156, 2.144047>,
      < 0.034745, -0.781618, 2.138963>
    }
    triangle {
      < 0.000000, -0.550260, 2.040503>,
      < 0.015988, -0.566989, 2.039040>,
      < 0.030486, -0.538444, 2.142306>
    }
    triangle {
      < 0.000000, -0.550260, 2.040503>,
      < 0.030486, -0.538444, 2.142306>,
      < 0.000000, -0.518706, 2.144231>
    }
    triangle {
      < 0.385395, 6.248701, -0.762645>,
      < 0.580662, 6.226851, -0.647512>,
      < 0.647537, 5.383266, -0.933723>
    }
    triangle {
      < 0.385395, 6.248701, -0.762645>,
      < 0.647537, 5.383266, -0.933723>,
      < 0.429972, 5.383253, -1.057937>
    }
    triangle {
      < 0.580662, 6.226851, -0.647512>,
      < 0.767051, 6.190462, -0.455439>,
      < 0.855210, 5.383354, -0.726514>
    }
    triangle {
      < 0.580662, 6.226851, -0.647512>,
      < 0.855210, 5.383354, -0.726514>,
      < 0.647537, 5.383266, -0.933723>
    }
    triangle {
      < 0.767051, 6.190462, -0.455439>,
      < 0.834720, 6.169515, -0.345086>,
      < 0.930606, 5.383365, -0.607457>
    }
    triangle {
      < 0.767051, 6.190462, -0.455439>,
      < 0.930606, 5.383365, -0.607457>,
      < 0.855210, 5.383354, -0.726514>
    }
    triangle {
      < 0.834720, 6.169515, -0.345086>,
      < 0.912757, 6.128767, -0.128607>,
      < 1.017555, 5.383738, -0.373970>
    }
    triangle {
      < 0.834720, 6.169515, -0.345086>,
      < 1.017555, 5.383738, -0.373970>,
      < 0.930606, 5.383365, -0.607457>
    }
    triangle {
      < 0.912757, 6.128767, -0.128607>,
      < 0.926393, 6.074624, 0.158787>,
      < 1.032748, 5.384184, -0.063988>
    }
    triangle {
      < 0.912757, 6.128767, -0.128607>,
      < 1.032748, 5.384184, -0.063988>,
      < 1.017555, 5.383738, -0.373970>
    }
    triangle {
      < 0.926393, 6.074624, 0.158787>,
      < 0.812568, 6.010952, 0.496523>,
      < 0.905925, 5.384666, 0.300302>
    }
    triangle {
      < 0.926393, 6.074624, 0.158787>,
      < 0.905925, 5.384666, 0.300302>,
      < 1.032748, 5.384184, -0.063988>
    }
    triangle {
      < 0.812568, 6.010952, 0.496523>,
      < 0.475865, 5.947012, 0.828165>,
      < 0.530772, 5.383664, 0.658299>
    }
    triangle {
      < 0.812568, 6.010952, 0.496523>,
      < 0.530772, 5.383664, 0.658299>,
      < 0.905925, 5.384666, 0.300302>
    }
    triangle {
      < 0.475865, 5.947012, 0.828165>,
      < 0.237656, 5.924357, 0.944155>,
      < 0.265362, 5.383006, 0.783565>
    }
    triangle {
      < 0.475865, 5.947012, 0.828165>,
      < 0.265362, 5.383006, 0.783565>,
      < 0.530772, 5.383664, 0.658299>
    }
    triangle {
      < 0.237656, 5.924357, 0.944155>,
      < 0.000000, 5.921931, 0.953869>,
      < 0.000000, 5.382403, 0.794159>
    }
    triangle {
      < 0.237656, 5.924357, 0.944155>,
      < 0.000000, 5.382403, 0.794159>,
      < 0.265362, 5.383006, 0.783565>
    }
    triangle {
      < 0.000000, 6.264034, -0.843081>,
      < 0.385395, 6.248701, -0.762645>,
      < 0.429972, 5.383253, -1.057937>
    }
    triangle {
      < 0.000000, 6.264034, -0.843081>,
      < 0.429972, 5.383253, -1.057937>,
      < 0.000000, 5.383317, -1.144730>
    }
    triangle {
      < 0.179404, 6.272811, 0.772493>,
      < 0.000000, 6.270975, 0.779844>,
      < 0.000000, 5.921931, 0.953869>
    }
    triangle {
      < 0.179404, 6.272811, 0.772493>,
      < 0.000000, 5.921931, 0.953869>,
      < 0.237656, 5.924357, 0.944155>
    }
    triangle {
      < 0.000000, 6.529882, -0.580102>,
      < 0.291215, 6.518277, -0.519228>,
      < 0.385395, 6.248701, -0.762645>
    }
    triangle {
      < 0.000000, 6.529882, -0.580102>,
      < 0.385395, 6.248701, -0.762645>,
      < 0.000000, 6.264034, -0.843081>
    }
    triangle {
      < 0.291215, 6.518277, -0.519228>,
      < 0.438994, 6.501739, -0.432095>,
      < 0.580662, 6.226851, -0.647512>
    }
    triangle {
      < 0.291215, 6.518277, -0.519228>,
      < 0.580662, 6.226851, -0.647512>,
      < 0.385395, 6.248701, -0.762645>
    }
    triangle {
      < 0.438994, 6.501739, -0.432095>,
      < 0.580055, 6.474204, -0.286733>,
      < 0.767051, 6.190462, -0.455439>
    }
    triangle {
      < 0.438994, 6.501739, -0.432095>,
      < 0.767051, 6.190462, -0.455439>,
      < 0.580662, 6.226851, -0.647512>
    }
    triangle {
      < 0.580055, 6.474204, -0.286733>,
      < 0.631267, 6.458348, -0.203216>,
      < 0.834720, 6.169515, -0.345086>
    }
    triangle {
      < 0.580055, 6.474204, -0.286733>,
      < 0.834720, 6.169515, -0.345086>,
      < 0.767051, 6.190462, -0.455439>
    }
    triangle {
      < 0.631267, 6.458348, -0.203216>,
      < 0.690326, 6.427511, -0.039383>,
      < 0.912757, 6.128767, -0.128607>
    }
    triangle {
      < 0.631267, 6.458348, -0.203216>,
      < 0.912757, 6.128767, -0.128607>,
      < 0.834720, 6.169515, -0.345086>
    }
    triangle {
      < 0.690326, 6.427511, -0.039383>,
      < 0.700646, 6.386535, 0.178120>,
      < 0.926393, 6.074624, 0.158787>
    }
    triangle {
      < 0.690326, 6.427511, -0.039383>,
      < 0.926393, 6.074624, 0.158787>,
      < 0.912757, 6.128767, -0.128607>
    }
    triangle {
      < 0.700646, 6.386535, 0.178120>,
      < 0.614502, 6.338346, 0.433721>,
      < 0.812568, 6.010952, 0.496523>
    }
    triangle {
      < 0.700646, 6.386535, 0.178120>,
      < 0.812568, 6.010952, 0.496523>,
      < 0.926393, 6.074624, 0.158787>
    }
    triangle {
      < 0.614502, 6.338346, 0.433721>,
      < 0.359682, 6.289955, 0.684710>,
      < 0.475865, 5.947012, 0.828165>
    }
    triangle {
      < 0.614502, 6.338346, 0.433721>,
      < 0.475865, 5.947012, 0.828165>,
      < 0.812568, 6.010952, 0.496523>
    }
    triangle {
      < 0.359682, 6.289955, 0.684710>,
      < 0.179404, 6.272811, 0.772493>,
      < 0.237656, 5.924357, 0.944155>
    }
    triangle {
      < 0.359682, 6.289955, 0.684710>,
      < 0.237656, 5.924357, 0.944155>,
      < 0.475865, 5.947012, 0.828165>
    }
    triangle {
      < 0.370275, 6.538164, 0.118853>,
      < 0.324684, 6.512660, 0.254128>,
      < 0.614502, 6.338346, 0.433721>
    }
    triangle {
      < 0.370275, 6.538164, 0.118853>,
      < 0.614502, 6.338346, 0.433721>,
      < 0.700646, 6.386535, 0.178120>
    }
    triangle {
      < 0.324684, 6.512660, 0.254128>,
      < 0.189822, 6.487049, 0.386961>,
      < 0.359682, 6.289955, 0.684710>
    }
    triangle {
      < 0.324684, 6.512660, 0.254128>,
      < 0.359682, 6.289955, 0.684710>,
      < 0.614502, 6.338346, 0.433721>
    }
    triangle {
      < 0.189822, 6.487049, 0.386961>,
      < 0.094412, 6.477975, 0.433420>,
      < 0.179404, 6.272811, 0.772493>
    }
    triangle {
      < 0.189822, 6.487049, 0.386961>,
      < 0.179404, 6.272811, 0.772493>,
      < 0.359682, 6.289955, 0.684710>
    }
    triangle {
      < 0.094412, 6.477975, 0.433420>,
      < 0.000000, 6.477004, 0.437311>,
      < 0.000000, 6.270975, 0.779844>
    }
    triangle {
      < 0.094412, 6.477975, 0.433420>,
      < 0.000000, 6.270975, 0.779844>,
      < 0.179404, 6.272811, 0.772493>
    }
    triangle {
      < 0.000000, 6.614027, -0.282431>,
      < 0.153586, 6.607885, -0.250214>,
      < 0.291215, 6.518277, -0.519228>
    }
    triangle {
      < 0.000000, 6.614027, -0.282431>,
      < 0.291215, 6.518277, -0.519228>,
      < 0.000000, 6.529882, -0.580102>
    }
    triangle {
      < 0.153586, 6.607885, -0.250214>,
      < 0.231797, 6.599135, -0.204098>,
      < 0.438994, 6.501739, -0.432095>
    }
    triangle {
      < 0.153586, 6.607885, -0.250214>,
      < 0.438994, 6.501739, -0.432095>,
      < 0.291215, 6.518277, -0.519228>
    }
    triangle {
      < 0.231797, 6.599135, -0.204098>,
      < 0.306453, 6.584560, -0.127167>,
      < 0.580055, 6.474204, -0.286733>
    }
    triangle {
      < 0.231797, 6.599135, -0.204098>,
      < 0.580055, 6.474204, -0.286733>,
      < 0.438994, 6.501739, -0.432095>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.333556, 6.576173, -0.082966>,
      < 0.631267, 6.458348, -0.203216>
    }
    triangle {
      < 0.306453, 6.584560, -0.127167>,
      < 0.631267, 6.458348, -0.203216>,
      < 0.580055, 6.474204, -0.286733>
    }
    triangle {
      < 0.333556, 6.576173, -0.082966>,
      < 0.364813, 6.559850, 0.003741>,
      < 0.690326, 6.427511, -0.039383>
    }
    triangle {
      < 0.333556, 6.576173, -0.082966>,
      < 0.690326, 6.427511, -0.039383>,
      < 0.631267, 6.458348, -0.203216>
    }
    triangle {
      < 0.364813, 6.559850, 0.003741>,
      < 0.370275, 6.538164, 0.118853>,
      < 0.700646, 6.386535, 0.178120>
    }
    triangle {
      < 0.364813, 6.559850, 0.003741>,
      < 0.700646, 6.386535, 0.178120>,
      < 0.690326, 6.427511, -0.039383>
    }
    texture {body}
  }
  // suit
  union {
    triangle {
      < 0.543989, 2.738802, 2.848981>,
      < 0.791250, 3.144629, 2.729348>,
      < 0.475173, 3.470336, 2.277757>
    }
    triangle {
      < 0.543989, 2.738802, 2.848981>,
      < 0.475173, 3.470336, 2.277757>,
      < 0.117154, 2.882724, 2.450977>
    }
    triangle {
      < 0.791250, 3.144629, 2.729348>,
      < 1.062379, 3.279649, 2.636478>,
      < 0.867752, 3.665836, 2.143286>
    }
    triangle {
      < 0.791250, 3.144629, 2.729348>,
      < 0.867752, 3.665836, 2.143286>,
      < 0.475173, 3.470336, 2.277757>
    }
    triangle {
      < 1.062379, 3.279649, 2.636478>,
      < 1.329147, 3.284411, 2.560931>,
      < 1.254015, 3.672732, 2.033899>
    }
    triangle {
      < 1.062379, 3.279649, 2.636478>,
      < 1.254015, 3.672732, 2.033899>,
      < 0.867752, 3.665836, 2.143286>
    }
    triangle {
      < 1.329147, 3.284411, 2.560931>,
      < 1.657463, 3.122408, 2.488700>,
      < 1.729397, 3.438161, 1.929313>
    }
    triangle {
      < 1.329147, 3.284411, 2.560931>,
      < 1.729397, 3.438161, 1.929313>,
      < 1.254015, 3.672732, 2.033899>
    }
    triangle {
      < 1.657463, 3.122408, 2.488700>,
      < 1.865189, 2.837087, 2.465593>,
      < 2.030171, 3.025035, 1.895856>
    }
    triangle {
      < 1.657463, 3.122408, 2.488700>,
      < 2.030171, 3.025035, 1.895856>,
      < 1.729397, 3.438161, 1.929313>
    }
    triangle {
      < 1.865189, 2.837087, 2.465593>,
      < 1.935934, 2.472686, 2.490749>,
      < 2.132606, 2.497405, 1.932280>
    }
    triangle {
      < 1.865189, 2.837087, 2.465593>,
      < 2.132606, 2.497405, 1.932280>,
      < 2.030171, 3.025035, 1.895856>
    }
    triangle {
      < 1.935934, 2.472686, 2.490749>,
      < 1.848552, 2.124844, 2.558292>,
      < 2.006081, 1.993751, 2.030076>
    }
    triangle {
      < 1.935934, 2.472686, 2.490749>,
      < 2.006081, 1.993751, 2.030076>,
      < 2.132606, 2.497405, 1.932280>
    }
    triangle {
      < 1.848552, 2.124844, 2.558292>,
      < 1.657303, 1.888275, 2.641266>,
      < 1.729165, 1.620013, 2.150219>
    }
    triangle {
      < 1.848552, 2.124844, 2.558292>,
      < 1.729165, 1.620013, 2.150219>,
      < 2.006081, 1.993751, 2.030076>
    }
    triangle {
      < 1.657303, 1.888275, 2.641266>,
      < 1.259821, 1.744127, 2.770769>,
      < 1.153635, 1.411296, 2.337730>
    }
    triangle {
      < 1.657303, 1.888275, 2.641266>,
      < 1.153635, 1.411296, 2.337730>,
      < 1.729165, 1.620013, 2.150219>
    }
    triangle {
      < 1.259821, 1.744127, 2.770769>,
      < 0.883860, 1.854609, 2.862755>,
      < 0.609266, 1.571267, 2.470921>
    }
    triangle {
      < 1.259821, 1.744127, 2.770769>,
      < 0.609266, 1.571267, 2.470921>,
      < 1.153635, 1.411296, 2.337730>
    }
    triangle {
      < 0.883860, 1.854609, 2.862755>,
      < 0.688995, 2.037009, 2.894967>,
      < 0.327114, 1.835370, 2.517562>
    }
    triangle {
      < 0.883860, 1.854609, 2.862755>,
      < 0.327114, 1.835370, 2.517562>,
      < 0.609266, 1.571267, 2.470921>
    }
    triangle {
      < 0.688995, 2.037009, 2.894967>,
      < 0.553309, 2.312128, 2.899093>,
      < 0.130649, 2.233726, 2.523536>
    }
    triangle {
      < 0.688995, 2.037009, 2.894967>,
      < 0.130649, 2.233726, 2.523536>,
      < 0.327114, 1.835370, 2.517562>
    }
    triangle {
      < 0.553309, 2.312128, 2.899093>,
      < 0.543989, 2.738802, 2.848981>,
      < 0.117154, 2.882724, 2.450977>
    }
    triangle {
      < 0.553309, 2.312128, 2.899093>,
      < 0.117154, 2.882724, 2.450977>,
      < 0.130649, 2.233726, 2.523536>
    }
    triangle {
      < 1.138060, 2.263262, 2.977416>,
      < 1.053943, 2.341998, 2.991321>,
      < 0.688995, 2.037009, 2.894967>
    }
    triangle {
      < 1.138060, 2.263262, 2.977416>,
      < 0.688995, 2.037009, 2.894967>,
      < 0.883860, 1.854609, 2.862755>
    }
    triangle {
      < 1.053943, 2.341998, 2.991321>,
      < 0.995371, 2.460758, 2.993102>,
      < 0.553309, 2.312128, 2.899093>
    }
    triangle {
      < 1.053943, 2.341998, 2.991321>,
      < 0.553309, 2.312128, 2.899093>,
      < 0.688995, 2.037009, 2.894967>
    }
    triangle {
      < 0.995371, 2.460758, 2.993102>,
      < 0.991348, 2.644941, 2.971471>,
      < 0.543989, 2.738802, 2.848981>
    }
    triangle {
      < 0.995371, 2.460758, 2.993102>,
      < 0.543989, 2.738802, 2.848981>,
      < 0.553309, 2.312128, 2.899093>
    }
    triangle {
      < 0.991348, 2.644941, 2.971471>,
      < 1.098083, 2.820125, 2.919829>,
      < 0.791250, 3.144629, 2.729348>
    }
    triangle {
      < 0.991348, 2.644941, 2.971471>,
      < 0.791250, 3.144629, 2.729348>,
      < 0.543989, 2.738802, 2.848981>
    }
    triangle {
      < 1.098083, 2.820125, 2.919829>,
      < 1.215121, 2.878408, 2.879739>,
      < 1.062379, 3.279649, 2.636478>
    }
    triangle {
      < 1.098083, 2.820125, 2.919829>,
      < 1.062379, 3.279649, 2.636478>,
      < 0.791250, 3.144629, 2.729348>
    }
    triangle {
      < 1.215121, 2.878408, 2.879739>,
      < 1.330277, 2.880464, 2.847128>,
      < 1.329147, 3.284411, 2.560931>
    }
    triangle {
      < 1.215121, 2.878408, 2.879739>,
      < 1.329147, 3.284411, 2.560931>,
      < 1.062379, 3.279649, 2.636478>
    }
    triangle {
      < 1.330277, 2.880464, 2.847128>,
      < 1.472001, 2.810532, 2.815948>,
      < 1.657463, 3.122408, 2.488700>
    }
    triangle {
      < 1.330277, 2.880464, 2.847128>,
      < 1.657463, 3.122408, 2.488700>,
      < 1.329147, 3.284411, 2.560931>
    }
    triangle {
      < 1.472001, 2.810532, 2.815948>,
      < 1.561671, 2.687367, 2.805973>,
      < 1.865189, 2.837087, 2.465593>
    }
    triangle {
      < 1.472001, 2.810532, 2.815948>,
      < 1.865189, 2.837087, 2.465593>,
      < 1.657463, 3.122408, 2.488700>
    }
    triangle {
      < 1.561671, 2.687367, 2.805973>,
      < 1.592209, 2.530067, 2.816833>,
      < 1.935934, 2.472686, 2.490749>
    }
    triangle {
      < 1.561671, 2.687367, 2.805973>,
      < 1.935934, 2.472686, 2.490749>,
      < 1.865189, 2.837087, 2.465593>
    }
    triangle {
      < 1.592209, 2.530067, 2.816833>,
      < 1.554488, 2.379914, 2.845989>,
      < 1.848552, 2.124844, 2.558292>
    }
    triangle {
      < 1.592209, 2.530067, 2.816833>,
      < 1.848552, 2.124844, 2.558292>,
      < 1.935934, 2.472686, 2.490749>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.471932, 2.277794, 2.881806>,
      < 1.657303, 1.888275, 2.641266>
    }
    triangle {
      < 1.554488, 2.379914, 2.845989>,
      < 1.657303, 1.888275, 2.641266>,
      < 1.848552, 2.124844, 2.558292>
    }
    triangle {
      < 1.471932, 2.277794, 2.881806>,
      < 1.300352, 2.215570, 2.937709>,
      < 1.259821, 1.744127, 2.770769>
    }
    triangle {
      < 1.471932, 2.277794, 2.881806>,
      < 1.259821, 1.744127, 2.770769>,
      < 1.657303, 1.888275, 2.641266>
    }
    triangle {
      < 1.300352, 2.215570, 2.937709>,
      < 1.138060, 2.263262, 2.977416>,
      < 0.883860, 1.854609, 2.862755>
    }
    triangle {
      < 1.300352, 2.215570, 2.937709>,
      < 0.883860, 1.854609, 2.862755>,
      < 1.259821, 1.744127, 2.770769>
    }
    texture {suit}
  }
  // brow
  union {
    triangle {
      < -1.357290, 8.101020, 1.469618>,
      < -1.388592, 8.182241, 1.451023>,
      < -1.409607, 7.862576, 1.257887>
    }
    texture {brow}
  }
  // face
  union {
    triangle {
      < -1.409607, 7.862576, 1.257887>,
      < -1.627951, 8.161976, 1.121192>,
      < -1.671171, 7.887857, 0.950860>
    }
    triangle {
      < -1.409607, 7.862576, 1.257887>,
      < -1.671171, 7.887857, 0.950860>,
      < -1.405386, 7.700283, 1.147116>
    }
    triangle {
      < -1.405386, 7.700283, 1.147116>,
      < -1.671171, 7.887857, 0.950860>,
      < -1.643261, 7.568371, 0.779994>
    }
    triangle {
      < -1.405386, 7.700283, 1.147116>,
      < -1.643261, 7.568371, 0.779994>,
      < -1.408726, 7.507695, 1.076182>
    }
    triangle {
      < -1.408726, 7.507695, 1.076182>,
      < -1.643261, 7.568371, 0.779994>,
      < -1.605012, 7.227119, 0.718601>
    }
    triangle {
      < -1.408726, 7.507695, 1.076182>,
      < -1.605012, 7.227119, 0.718601>,
      < -1.399494, 7.234042, 1.061630>
    }
    triangle {
      < -1.399494, 7.234042, 1.061630>,
      < -1.605012, 7.227119, 0.718601>,
      < -1.589390, 7.029233, 0.920003>
    }
    triangle {
      < -1.589390, 7.029233, 0.920003>,
      < -1.574759, 6.922855, 1.114138>,
      < -1.387584, 7.136969, 1.118825>
    }
    triangle {
      < -1.589390, 7.029233, 0.920003>,
      < -1.387584, 7.136969, 1.118825>,
      < -1.399494, 7.234042, 1.061630>
    }
    triangle {
      < -1.387584, 7.136969, 1.118825>,
      < -1.574759, 6.922855, 1.114138>,
      < -1.478820, 6.789691, 1.350577>
    }
    triangle {
      < -1.387584, 7.136969, 1.118825>,
      < -1.478820, 6.789691, 1.350577>,
      < -1.280479, 7.023159, 1.386668>
    }
    triangle {
      < -1.280479, 7.023159, 1.386668>,
      < -1.478820, 6.789691, 1.350577>,
      < -1.335770, 6.729196, 1.536853>
    }
    triangle {
      < -1.280479, 7.023159, 1.386668>,
      < -1.335770, 6.729196, 1.536853>,
      < -1.198544, 6.961119, 1.558410>
    }
    triangle {
      < -1.198544, 6.961119, 1.558410>,
      < -1.335770, 6.729196, 1.536853>,
      < -1.135794, 6.699510, 1.720270>
    }
    triangle {
      < -1.198544, 6.961119, 1.558410>,
      < -1.135794, 6.699510, 1.720270>,
      < -1.118692, 6.924029, 1.657216>
    }
    triangle {
      < -0.951907, 6.931507, 1.737461>,
      < -1.118692, 6.924029, 1.657216>,
      < -1.135794, 6.699510, 1.720270>
    }
    triangle {
      < -0.951907, 6.931507, 1.737461>,
      < -1.135794, 6.699510, 1.720270>,
      < -0.951037, 6.754210, 1.815196>
    }
    triangle {
      < -0.951907, 6.931507, 1.737461>,
      < -0.951037, 6.754210, 1.815196>,
      < -0.662825, 6.855032, 1.902023>
    }
    triangle {
      < -0.951907, 6.931507, 1.737461>,
      < -0.662825, 6.855032, 1.902023>,
      < -0.719866, 7.048229, 1.813486>
    }
    triangle {
      < -0.719866, 7.048229, 1.813486>,
      < -0.662825, 6.855032, 1.902023>,
      < -0.449960, 6.979241, 2.004734>
    }
    triangle {
      < -0.719866, 7.048229, 1.813486>,
      < -0.449960, 6.979241, 2.004734>,
      < -0.447231, 6.990836, 2.011483>
    }
    triangle {
      < -0.719866, 7.048229, 1.813486>,
      < -0.447231, 6.990836, 2.011483>,
      < -0.521476, 7.142691, 1.913740>
    }
    triangle {
      < -0.521476, 7.142691, 1.913740>,
      < -0.447231, 6.990836, 2.011483>,
      < -0.442106, 6.988012, 2.018156>
    }
    triangle {
      < -0.521476, 7.142691, 1.913740>,
      < -0.442106, 6.988012, 2.018156>,
      < -0.354659, 7.089078, 2.130837>
    }
    triangle {
      < -0.521476, 7.142691, 1.913740>,
      < -0.354659, 7.089078, 2.130837>,
      < -0.387626, 7.321533, 1.906235>
    }
    triangle {
      < -0.387626, 7.321533, 1.906235>,
      < -0.354659, 7.089078, 2.130837>,
      < -0.153202, 7.152060, 2.290502>
    }
    triangle {
      < -0.387626, 7.321533, 1.906235>,
      < -0.153202, 7.152060, 2.290502>,
      < -0.157000, 7.376499, 2.096611>
    }
    triangle {
      < -0.157000, 7.376499, 2.096611>,
      < -0.153202, 7.152060, 2.290502>,
      < 0.000000, 7.193865, 2.291512>
    }
    triangle {
      < -0.157000, 7.376499, 2.096611>,
      < 0.000000, 7.193865, 2.291512>,
      < 0.000000, 7.409155, 2.088706>
    }
    triangle {
      < 0.000000, 7.409155, 2.088706>,
      < 0.000000, 7.533475, 1.994006>,
      < -0.157640, 7.519312, 1.979869>
    }
    triangle {
      < 0.000000, 7.409155, 2.088706>,
      < -0.157640, 7.519312, 1.979869>,
      < -0.157000, 7.376499, 2.096611>
    }
    triangle {
      < -0.157000, 7.376499, 2.096611>,
      < -0.157640, 7.519312, 1.979869>,
      < -0.304954, 7.487044, 1.942316>
    }
    triangle {
      < -0.157000, 7.376499, 2.096611>,
      < -0.304954, 7.487044, 1.942316>,
      < -0.387626, 7.321533, 1.906235>
    }
    triangle {
      < -0.387626, 7.321533, 1.906235>,
      < -0.304954, 7.487044, 1.942316>,
      < -0.424517, 7.538349, 1.816898>
    }
    triangle {
      < -0.387626, 7.321533, 1.906235>,
      < -0.424517, 7.538349, 1.816898>,
      < -0.451272, 7.419964, 1.813993>
    }
    triangle {
      < -0.451272, 7.419964, 1.813993>,
      < -0.523796, 7.315795, 1.789738>,
      < -0.521476, 7.142691, 1.913740>
    }
    triangle {
      < -0.451272, 7.419964, 1.813993>,
      < -0.521476, 7.142691, 1.913740>,
      < -0.387626, 7.321533, 1.906235>
    }
    triangle {
      < -0.521476, 7.142691, 1.913740>,
      < -0.523796, 7.315795, 1.789738>,
      < -0.654784, 7.207671, 1.729157>
    }
    triangle {
      < -0.521476, 7.142691, 1.913740>,
      < -0.654784, 7.207671, 1.729157>,
      < -0.719866, 7.048229, 1.813486>
    }
    triangle {
      < -0.719866, 7.048229, 1.813486>,
      < -0.654784, 7.207671, 1.729157>,
      < -0.772975, 7.160594, 1.638789>
    }
    triangle {
      < -0.719866, 7.048229, 1.813486>,
      < -0.772975, 7.160594, 1.638789>,
      < -0.951907, 6.931507, 1.737461>
    }
    triangle {
      < -1.118692, 6.924029, 1.657216>,
      < -0.883035, 7.151428, 1.545997>,
      < -0.995386, 7.168216, 1.444232>
    }
    triangle {
      < -1.118692, 6.924029, 1.657216>,
      < -0.995386, 7.168216, 1.444232>,
      < -1.198544, 6.961119, 1.558410>
    }
    triangle {
      < -1.198544, 6.961119, 1.558410>,
      < -0.995386, 7.168216, 1.444232>,
      < -1.061896, 7.223755, 1.329039>
    }
    triangle {
      < -1.198544, 6.961119, 1.558410>,
      < -1.061896, 7.223755, 1.329039>,
      < -1.280479, 7.023159, 1.386668>
    }
    triangle {
      < -0.426586, 7.851128, 1.845632>,
      < -0.352145, 7.886268, 1.969402>,
      < -0.467566, 8.143847, 1.989871>
    }
    triangle {
      < -0.426586, 7.851128, 1.845632>,
      < -0.467566, 8.143847, 1.989871>,
      < -0.503766, 8.017214, 1.905862>
    }
    triangle {
      < -0.503766, 8.017214, 1.905862>,
      < -0.467566, 8.143847, 1.989871>,
      < -0.668233, 8.257164, 1.947022>
    }
    triangle {
      < -0.503766, 8.017214, 1.905862>,
      < -0.668233, 8.257164, 1.947022>,
      < -0.674197, 8.108939, 1.873312>
    }
    triangle {
      < -0.674197, 8.108939, 1.873312>,
      < -0.668233, 8.257164, 1.947022>,
      < -0.906598, 8.304548, 1.847251>
    }
    triangle {
      < -0.674197, 8.108939, 1.873312>,
      < -0.906598, 8.304548, 1.847251>,
      < -0.857921, 8.152600, 1.795877>
    }
    triangle {
      < -0.857921, 8.152600, 1.795877>,
      < -0.906598, 8.304548, 1.847251>,
      < -1.157783, 8.273422, 1.698323>
    }
    triangle {
      < -0.857921, 8.152600, 1.795877>,
      < -1.157783, 8.273422, 1.698323>,
      < -1.044607, 8.070682, 1.641520>
    }
    triangle {
      < -1.044607, 8.070682, 1.641520>,
      < -1.157783, 8.273422, 1.698323>,
      < -1.357290, 8.101020, 1.469618>
    }
    triangle {
      < -1.044607, 8.070682, 1.641520>,
      < -1.357290, 8.101020, 1.469618>,
      < -1.143256, 7.950388, 1.448727>
    }
    triangle {
      < -1.143256, 7.950388, 1.448727>,
      < -1.357290, 8.101020, 1.469618>,
      < -1.409607, 7.862576, 1.257887>
    }
    triangle {
      < -1.143256, 7.950388, 1.448727>,
      < -1.409607, 7.862576, 1.257887>,
      < -1.228102, 7.784869, 1.308105>
    }
    triangle {
      < -1.228102, 7.784869, 1.308105>,
      < -1.409607, 7.862576, 1.257887>,
      < -1.405386, 7.700283, 1.147116>
    }
    triangle {
      < -1.228102, 7.784869, 1.308105>,
      < -1.405386, 7.700283, 1.147116>,
      < -1.228105, 7.667838, 1.228434>
    }
    triangle {
      < -1.228105, 7.667838, 1.228434>,
      < -1.405386, 7.700283, 1.147116>,
      < -1.408726, 7.507695, 1.076182>
    }
    triangle {
      < -1.228105, 7.667838, 1.228434>,
      < -1.408726, 7.507695, 1.076182>,
      < -1.181628, 7.493562, 1.203781>
    }
    triangle {
      < -0.589018, 7.915383, 1.940367>,
      < -0.510838, 8.009660, 1.903327>,
      < -0.676756, 8.098582, 1.873053>
    }
    triangle {
      < -0.589018, 7.915383, 1.940367>,
      < -0.676756, 8.098582, 1.873053>,
      < -0.707084, 7.951528, 1.950182>
    }
    texture {face}
  }
  // lash
  union {
    triangle {
      < -1.217140, 7.601475, 1.575520>,
      < -1.226924, 7.611438, 1.536010>,
      < -1.221656, 7.535584, 1.310366>
    }
    triangle {
      < -1.217140, 7.601475, 1.575520>,
      < -1.221656, 7.535584, 1.310366>,
      < -1.217879, 7.502439, 1.321256>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < -0.707084, 7.951528, 1.950182>,
      < -0.676756, 8.098582, 1.873053>,
      < -0.858304, 8.142274, 1.796644>
    }
    triangle {
      < -0.707084, 7.951528, 1.950182>,
      < -0.858304, 8.142274, 1.796644>,
      < -0.947594, 7.934773, 1.906125>
    }
    triangle {
      < -0.947594, 7.934773, 1.906125>,
      < -0.858304, 8.142274, 1.796644>,
      < -1.042285, 8.061223, 1.643898>
    }
    triangle {
      < -0.947594, 7.934773, 1.906125>,
      < -1.042285, 8.061223, 1.643898>,
      < -1.057697, 7.885696, 1.814647>
    }
    triangle {
      < -1.057697, 7.885696, 1.814647>,
      < -1.042285, 8.061223, 1.643898>,
      < -1.138931, 7.943057, 1.452462>
    }
    triangle {
      < -1.057697, 7.885696, 1.814647>,
      < -1.138931, 7.943057, 1.452462>,
      < -1.137249, 7.793068, 1.671500>
    }
    triangle {
      < -1.137249, 7.793068, 1.671500>,
      < -1.138931, 7.943057, 1.452462>,
      < -1.222239, 7.779233, 1.314082>
    }
    triangle {
      < -1.137249, 7.793068, 1.671500>,
      < -1.222239, 7.779233, 1.314082>,
      < -1.183912, 7.723730, 1.527919>
    }
    triangle {
      < -1.190138, 7.595891, 1.288325>,
      < -1.221443, 7.665048, 1.236122>,
      < -1.177549, 7.502185, 1.213440>
    }
    triangle {
      < -0.424517, 7.538349, 1.816898>,
      < -0.304954, 7.487044, 1.942316>,
      < -0.288781, 7.670419, 1.938340>
    }
    triangle {
      < -0.424517, 7.538349, 1.816898>,
      < -0.288781, 7.670419, 1.938340>,
      < -0.411911, 7.705149, 1.823261>
    }
    triangle {
      < -0.424517, 7.538349, 1.816898>,
      < -0.411911, 7.705149, 1.823261>,
      < -0.416886, 7.691145, 1.819102>
    }
    triangle {
      < -0.411911, 7.705149, 1.823261>,
      < -0.288781, 7.670419, 1.938340>,
      < -0.352145, 7.886268, 1.969402>
    }
    triangle {
      < -0.411911, 7.705149, 1.823261>,
      < -0.352145, 7.886268, 1.969402>,
      < -0.426586, 7.851128, 1.845632>
    }
    triangle {
      < -1.152053, 7.377617, 1.209565>,
      < -1.181628, 7.493562, 1.203781>,
      < -1.408726, 7.507695, 1.076182>
    }
    triangle {
      < -1.152053, 7.377617, 1.209565>,
      < -1.408726, 7.507695, 1.076182>,
      < -1.399494, 7.234042, 1.061630>
    }
    triangle {
      < -1.399494, 7.234042, 1.061630>,
      < -1.387584, 7.136969, 1.118825>,
      < -1.113253, 7.297450, 1.266328>
    }
    triangle {
      < -1.399494, 7.234042, 1.061630>,
      < -1.113253, 7.297450, 1.266328>,
      < -1.152053, 7.377617, 1.209565>
    }
    texture {face}
  }
  // brow
  union {
    triangle {
      < -1.357290, 8.101020, 1.469618>,
      < -1.157783, 8.273422, 1.698323>,
      < -1.177990, 8.341700, 1.692121>
    }
    triangle {
      < -1.357290, 8.101020, 1.469618>,
      < -1.177990, 8.341700, 1.692121>,
      < -1.388592, 8.182241, 1.451023>
    }
    texture {brow}
  }
  // face
  union {
    triangle {
      < -1.428928, 8.385238, 1.410104>,
      < -1.208542, 8.514754, 1.669742>,
      < -1.392183, 8.540370, 1.434910>
    }
    texture {face}
  }
  // brow
  union {
    triangle {
      < -1.177990, 8.341700, 1.692121>,
      < -1.157783, 8.273422, 1.698323>,
      < -0.906598, 8.304548, 1.847251>
    }
    triangle {
      < -1.177990, 8.341700, 1.692121>,
      < -0.906598, 8.304548, 1.847251>,
      < -0.929884, 8.357011, 1.841744>
    }
    triangle {
      < -0.929884, 8.357011, 1.841744>,
      < -0.906598, 8.304548, 1.847251>,
      < -0.668233, 8.257164, 1.947022>
    }
    texture {brow}
  }
  // face
  union {
    triangle {
      < -0.333965, 8.356596, 2.043825>,
      < -0.467566, 8.143847, 1.989871>,
      < -0.352145, 7.886268, 1.969402>
    }
    triangle {
      < -0.333965, 8.356596, 2.043825>,
      < -0.352145, 7.886268, 1.969402>,
      < -0.213985, 8.046092, 2.044847>
    }
    triangle {
      < -0.213985, 8.046092, 2.044847>,
      < -0.352145, 7.886268, 1.969402>,
      < -0.288781, 7.670419, 1.938340>
    }
    triangle {
      < -0.213985, 8.046092, 2.044847>,
      < -0.288781, 7.670419, 1.938340>,
      < -0.170791, 7.702956, 1.977541>
    }
    triangle {
      < -0.170791, 7.702956, 1.977541>,
      < -0.288781, 7.670419, 1.938340>,
      < -0.304954, 7.487044, 1.942316>
    }
    triangle {
      < -0.170791, 7.702956, 1.977541>,
      < -0.304954, 7.487044, 1.942316>,
      < -0.157640, 7.519312, 1.979869>
    }
    triangle {
      < -0.157640, 7.519312, 1.979869>,
      < 0.000000, 7.533475, 1.994006>,
      < 0.000000, 7.734456, 2.022061>
    }
    triangle {
      < -0.157640, 7.519312, 1.979869>,
      < 0.000000, 7.734456, 2.022061>,
      < -0.170791, 7.702956, 1.977541>
    }
    triangle {
      < -0.170791, 7.702956, 1.977541>,
      < 0.000000, 7.734456, 2.022061>,
      < 0.000000, 8.097105, 2.066933>
    }
    triangle {
      < -0.170791, 7.702956, 1.977541>,
      < 0.000000, 8.097105, 2.066933>,
      < -0.213985, 8.046092, 2.044847>
    }
    triangle {
      < -0.213985, 8.046092, 2.044847>,
      < 0.000000, 8.097105, 2.066933>,
      < 0.000000, 8.479736, 2.073225>
    }
    triangle {
      < -0.213985, 8.046092, 2.044847>,
      < 0.000000, 8.479736, 2.073225>,
      < -0.333965, 8.356596, 2.043825>
    }
    triangle {
      < -0.333965, 8.356596, 2.043825>,
      < 0.000000, 8.479736, 2.073225>,
      < -0.383177, 8.650391, 2.030931>
    }
    triangle {
      < -0.333965, 8.356596, 2.043825>,
      < -0.383177, 8.650391, 2.030931>,
      < -0.680408, 8.556564, 1.960871>
    }
    triangle {
      < -0.383177, 8.650391, 2.030931>,
      < 0.000000, 8.479736, 2.073225>,
      < 0.000000, 8.854424, 2.009160>
    }
    triangle {
      < -0.668233, 8.257164, 1.947022>,
      < -0.467566, 8.143847, 1.989871>,
      < -0.333965, 8.356596, 2.043825>
    }
    triangle {
      < -0.668233, 8.257164, 1.947022>,
      < -0.333965, 8.356596, 2.043825>,
      < -0.680408, 8.556564, 1.960871>
    }
    triangle {
      < -1.428928, 8.385238, 1.410104>,
      < -1.392183, 8.540370, 1.434910>,
      < -1.647696, 8.606560, 0.948423>
    }
    triangle {
      < -1.428928, 8.385238, 1.410104>,
      < -1.647696, 8.606560, 0.948423>,
      < -1.627951, 8.161976, 1.121192>
    }
    triangle {
      < -1.627951, 8.161976, 1.121192>,
      < -1.647696, 8.606560, 0.948423>,
      < -1.795683, 8.213724, 0.643136>
    }
    triangle {
      < -1.627951, 8.161976, 1.121192>,
      < -1.795683, 8.213724, 0.643136>,
      < -1.671171, 7.887857, 0.950860>
    }
    triangle {
      < -1.671171, 7.887857, 0.950860>,
      < -1.795683, 8.213724, 0.643136>,
      < -1.727092, 7.776976, 0.344528>
    }
    triangle {
      < -1.671171, 7.887857, 0.950860>,
      < -1.727092, 7.776976, 0.344528>,
      < -1.643261, 7.568371, 0.779994>
    }
    triangle {
      < -1.643261, 7.568371, 0.779994>,
      < -1.727092, 7.776976, 0.344528>,
      < -1.639386, 7.174335, 0.448677>
    }
    triangle {
      < -1.643261, 7.568371, 0.779994>,
      < -1.639386, 7.174335, 0.448677>,
      < -1.605012, 7.227119, 0.718601>
    }
    triangle {
      < -1.795683, 8.213724, 0.643136>,
      < -1.828851, 8.531735, 0.231749>,
      < -1.811272, 8.350312, 0.257340>
    }
    triangle {
      < -1.795683, 8.213724, 0.643136>,
      < -1.811272, 8.350312, 0.257340>,
      < -1.727092, 7.776976, 0.344528>
    }
    triangle {
      < -1.828851, 8.531735, 0.231749>,
      < -1.795683, 8.213724, 0.643136>,
      < -1.647696, 8.606560, 0.948423>
    }
    triangle {
      < -1.828851, 8.531735, 0.231749>,
      < -1.647696, 8.606560, 0.948423>,
      < -1.792122, 8.717618, 0.442839>
    }
    triangle {
      < -1.828851, 8.531735, 0.231749>,
      < -1.792122, 8.717618, 0.442839>,
      < -1.805840, 8.641598, 0.263489>
    }
    triangle {
      < -1.605012, 7.227119, 0.718601>,
      < -1.639386, 7.174335, 0.448677>,
      < -1.685030, 6.993190, 0.456504>
    }
    triangle {
      < -1.605012, 7.227119, 0.718601>,
      < -1.685030, 6.993190, 0.456504>,
      < -1.665081, 6.813934, 0.713635>
    }
    triangle {
      < -1.605012, 7.227119, 0.718601>,
      < -1.665081, 6.813934, 0.713635>,
      < -1.589390, 7.029233, 0.920003>
    }
    triangle {
      < -1.589390, 7.029233, 0.920003>,
      < -1.665081, 6.813934, 0.713635>,
      < -1.641878, 6.680877, 0.963337>
    }
    triangle {
      < -1.589390, 7.029233, 0.920003>,
      < -1.641878, 6.680877, 0.963337>,
      < -1.574759, 6.922855, 1.114138>
    }
    triangle {
      < -1.574759, 6.922855, 1.114138>,
      < -1.641878, 6.680877, 0.963337>,
      < -1.567187, 6.531720, 1.241760>
    }
    triangle {
      < -1.574759, 6.922855, 1.114138>,
      < -1.567187, 6.531720, 1.241760>,
      < -1.478820, 6.789691, 1.350577>
    }
    triangle {
      < -1.478820, 6.789691, 1.350577>,
      < -1.567187, 6.531720, 1.241760>,
      < -1.392018, 6.465443, 1.495378>
    }
    triangle {
      < -1.478820, 6.789691, 1.350577>,
      < -1.392018, 6.465443, 1.495378>,
      < -1.335770, 6.729196, 1.536853>
    }
    triangle {
      < -1.335770, 6.729196, 1.536853>,
      < -1.392018, 6.465443, 1.495378>,
      < -1.117530, 6.487579, 1.748186>
    }
    triangle {
      < -1.335770, 6.729196, 1.536853>,
      < -1.117530, 6.487579, 1.748186>,
      < -1.135794, 6.699510, 1.720270>
    }
    triangle {
      < -1.135794, 6.699510, 1.720270>,
      < -1.117530, 6.487579, 1.748186>,
      < -0.928687, 6.544118, 1.858133>
    }
    triangle {
      < -1.135794, 6.699510, 1.720270>,
      < -0.928687, 6.544118, 1.858133>,
      < -0.951037, 6.754210, 1.815196>
    }
    triangle {
      < -0.951037, 6.754210, 1.815196>,
      < -0.928687, 6.544118, 1.858133>,
      < -0.609789, 6.660050, 1.950922>
    }
    triangle {
      < -0.951037, 6.754210, 1.815196>,
      < -0.609789, 6.660050, 1.950922>,
      < -0.662825, 6.855032, 1.902023>
    }
    triangle {
      < -0.662825, 6.855032, 1.902023>,
      < -0.609789, 6.660050, 1.950922>,
      < -0.459376, 6.802716, 1.999871>
    }
    triangle {
      < -0.662825, 6.855032, 1.902023>,
      < -0.459376, 6.802716, 1.999871>,
      < -0.449960, 6.979241, 2.004734>
    }
    triangle {
      < -0.449324, 6.929481, 2.051343>,
      < -0.463406, 6.824869, 2.024403>,
      < -0.448093, 6.801496, 2.038748>
    }
    triangle {
      < -0.449324, 6.929481, 2.051343>,
      < -0.448093, 6.801496, 2.038748>,
      < -0.412490, 6.840874, 2.088102>
    }
    triangle {
      < -0.412490, 6.840874, 2.088102>,
      < -0.314778, 6.869460, 2.248066>,
      < -0.334718, 6.960837, 2.252813>
    }
    triangle {
      < -0.412490, 6.840874, 2.088102>,
      < -0.334718, 6.960837, 2.252813>,
      < -0.449324, 6.929481, 2.051343>
    }
    triangle {
      < -0.334718, 6.960837, 2.252813>,
      < -0.314778, 6.869460, 2.248066>,
      < -0.178745, 6.866331, 2.385348>
    }
    triangle {
      < -0.334718, 6.960837, 2.252813>,
      < -0.178745, 6.866331, 2.385348>,
      < -0.165973, 6.990763, 2.401286>
    }
    triangle {
      < -0.165973, 6.990763, 2.401286>,
      < -0.178745, 6.866331, 2.385348>,
      < 0.000000, 6.869957, 2.417860>
    }
    triangle {
      < -0.165973, 6.990763, 2.401286>,
      < 0.000000, 6.869957, 2.417860>,
      < 0.000000, 7.013479, 2.418046>
    }
    texture {face}
  }
  // uplip
  union {
    triangle {
      < -0.772033, 6.187246, 1.871334>,
      < -0.781087, 6.165960, 1.864745>,
      < -0.768347, 6.166550, 1.872100>
    }
    triangle {
      < -0.768347, 6.166550, 1.872100>,
      < -0.755565, 6.180678, 1.881653>,
      < -0.772033, 6.187246, 1.871334>
    }
    triangle {
      < -0.634607, 6.189641, 1.969897>,
      < -0.632465, 6.147034, 1.925617>,
      < -0.496583, 6.127518, 1.979135>
    }
    triangle {
      < -0.634607, 6.189641, 1.969897>,
      < -0.496583, 6.127518, 1.979135>,
      < -0.513649, 6.198605, 2.058142>
    }
    texture {uplip}
  }
  // face
  union {
    triangle {
      < -0.530713, 6.263931, 2.096829>,
      < -0.374646, 6.335971, 2.215456>,
      < -0.407699, 6.583720, 2.123532>
    }
    triangle {
      < -0.530713, 6.263931, 2.096829>,
      < -0.407699, 6.583720, 2.123532>,
      < -0.610265, 6.408909, 2.035973>
    }
    triangle {
      < -0.610265, 6.408909, 2.035973>,
      < -0.407699, 6.583720, 2.123532>,
      < -0.447613, 6.770525, 2.014438>
    }
    triangle {
      < -0.610265, 6.408909, 2.035973>,
      < -0.447613, 6.770525, 2.014438>,
      < -0.459376, 6.802716, 1.999871>
    }
    triangle {
      < -0.610265, 6.408909, 2.035973>,
      < -0.459376, 6.802716, 1.999871>,
      < -0.609789, 6.660050, 1.950922>
    }
    triangle {
      < -0.447613, 6.770525, 2.014438>,
      < -0.407699, 6.583720, 2.123532>,
      < -0.266413, 6.719081, 2.118316>
    }
    triangle {
      < -0.266413, 6.719081, 2.118316>,
      < -0.407699, 6.583720, 2.123532>,
      < -0.374646, 6.335971, 2.215456>
    }
    triangle {
      < -0.266413, 6.719081, 2.118316>,
      < -0.374646, 6.335971, 2.215456>,
      < -0.185747, 6.376217, 2.308307>
    }
    triangle {
      < -0.266413, 6.719081, 2.118316>,
      < -0.185747, 6.376217, 2.308307>,
      < -0.135082, 6.628557, 2.158507>
    }
    triangle {
      < -0.135082, 6.628557, 2.158507>,
      < -0.185747, 6.376217, 2.308307>,
      < 0.000000, 6.385907, 2.297638>
    }
    triangle {
      < -0.135082, 6.628557, 2.158507>,
      < 0.000000, 6.385907, 2.297638>,
      < 0.000000, 6.613321, 2.141114>
    }
    triangle {
      < 0.000000, 6.676259, 2.183194>,
      < 0.000000, 6.869957, 2.417860>,
      < -0.178745, 6.866331, 2.385348>
    }
    triangle {
      < 0.000000, 6.676259, 2.183194>,
      < -0.178745, 6.866331, 2.385348>,
      < -0.134601, 6.677120, 2.183006>
    }
    triangle {
      < -0.134601, 6.677120, 2.183006>,
      < -0.178745, 6.866331, 2.385348>,
      < -0.314778, 6.869460, 2.248066>
    }
    triangle {
      < -0.134601, 6.677120, 2.183006>,
      < -0.314778, 6.869460, 2.248066>,
      < -0.263747, 6.748829, 2.144173>
    }
    triangle {
      < -0.412490, 6.840874, 2.088102>,
      < -0.448093, 6.801496, 2.038748>,
      < -0.263747, 6.748829, 2.144173>
    }
    triangle {
      < -0.412490, 6.840874, 2.088102>,
      < -0.263747, 6.748829, 2.144173>,
      < -0.314778, 6.869460, 2.248066>
    }
    triangle {
      < -0.638888, 6.093111, 1.912075>,
      < -0.863689, 5.912329, 1.797569>,
      < -0.512566, 5.982536, 1.942181>
    }
    texture {face}
  }
  // lowlip
  union {
    triangle {
      < -0.512566, 5.982536, 1.942181>,
      < -0.380141, 5.935607, 2.048533>,
      < -0.369221, 6.000530, 2.109117>
    }
    triangle {
      < -0.512566, 5.982536, 1.942181>,
      < -0.369221, 6.000530, 2.109117>,
      < -0.505941, 6.036611, 1.965279>
    }
    triangle {
      < -0.369221, 6.000530, 2.109117>,
      < -0.380141, 5.935607, 2.048533>,
      < -0.210797, 5.903279, 2.116179>
    }
    triangle {
      < -0.369221, 6.000530, 2.109117>,
      < -0.210797, 5.903279, 2.116179>,
      < -0.192374, 5.979699, 2.170825>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < -0.161882, 6.163558, 2.150136>,
      < -0.174788, 6.243392, 2.268390>,
      < -0.344701, 6.235855, 2.198796>
    }
    triangle {
      < -0.161882, 6.163558, 2.150136>,
      < -0.344701, 6.235855, 2.198796>,
      < -0.314755, 6.159932, 2.117626>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < -0.358301, 6.097709, 2.127077>,
      < -0.173951, 6.088375, 2.182847>,
      < -0.161882, 6.163558, 2.150136>
    }
    triangle {
      < -0.358301, 6.097709, 2.127077>,
      < -0.161882, 6.163558, 2.150136>,
      < -0.314755, 6.159932, 2.117626>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < -0.161882, 6.163558, 2.150136>,
      < 0.000000, 6.157406, 2.167072>,
      < 0.000000, 6.234792, 2.271523>
    }
    triangle {
      < -0.161882, 6.163558, 2.150136>,
      < 0.000000, 6.234792, 2.271523>,
      < -0.174788, 6.243392, 2.268390>
    }
    triangle {
      < -0.496583, 6.127518, 1.979135>,
      < -0.314755, 6.159932, 2.117626>,
      < -0.344701, 6.235855, 2.198796>
    }
    triangle {
      < -0.496583, 6.127518, 1.979135>,
      < -0.344701, 6.235855, 2.198796>,
      < -0.513649, 6.198605, 2.058142>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < 0.000000, 5.866322, 2.025527>,
      < 0.000000, 5.899922, 2.142435>,
      < -0.210797, 5.903279, 2.116179>
    }
    triangle {
      < 0.000000, 5.866322, 2.025527>,
      < -0.210797, 5.903279, 2.116179>,
      < -0.204979, 5.862878, 1.991291>
    }
    triangle {
      < -0.204979, 5.862878, 1.991291>,
      < -0.210797, 5.903279, 2.116179>,
      < -0.380141, 5.935607, 2.048533>
    }
    triangle {
      < -0.204979, 5.862878, 1.991291>,
      < -0.380141, 5.935607, 2.048533>,
      < -0.376618, 5.897822, 1.994641>
    }
    triangle {
      < -0.376618, 5.897822, 1.994641>,
      < -0.380141, 5.935607, 2.048533>,
      < -0.512566, 5.982536, 1.942181>
    }
    triangle {
      < -0.210797, 5.903279, 2.116179>,
      < 0.000000, 5.899922, 2.142435>,
      < 0.000000, 5.979388, 2.192696>
    }
    triangle {
      < -0.210797, 5.903279, 2.116179>,
      < 0.000000, 5.979388, 2.192696>,
      < -0.192374, 5.979699, 2.170825>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < -0.512566, 5.982536, 1.942181>,
      < -0.863689, 5.912329, 1.797569>,
      < -0.890778, 5.801272, 1.751339>
    }
    triangle {
      < -0.512566, 5.982536, 1.942181>,
      < -0.890778, 5.801272, 1.751339>,
      < -0.619415, 5.708832, 1.905872>
    }
    triangle {
      < -0.619415, 5.708832, 1.905872>,
      < -0.500890, 5.684086, 1.970804>,
      < -0.376618, 5.897822, 1.994641>
    }
    triangle {
      < -0.619415, 5.708832, 1.905872>,
      < -0.376618, 5.897822, 1.994641>,
      < -0.512566, 5.982536, 1.942181>
    }
    triangle {
      < -0.376618, 5.897822, 1.994641>,
      < -0.500890, 5.684086, 1.970804>,
      < -0.285482, 5.691689, 2.000125>
    }
    triangle {
      < -0.376618, 5.897822, 1.994641>,
      < -0.285482, 5.691689, 2.000125>,
      < -0.204979, 5.862878, 1.991291>
    }
    triangle {
      < -0.204979, 5.862878, 1.991291>,
      < -0.285482, 5.691689, 2.000125>,
      < 0.000000, 5.697412, 2.020346>
    }
    triangle {
      < -0.204979, 5.862878, 1.991291>,
      < 0.000000, 5.697412, 2.020346>,
      < 0.000000, 5.866322, 2.025527>
    }
    triangle {
      < 0.000000, 5.697412, 2.020346>,
      < -0.285482, 5.691689, 2.000125>,
      < -0.299098, 5.436183, 1.813015>
    }
    triangle {
      < 0.000000, 5.697412, 2.020346>,
      < -0.299098, 5.436183, 1.813015>,
      < 0.000000, 5.417133, 1.837040>
    }
    triangle {
      < -0.299098, 5.436183, 1.813015>,
      < -0.285482, 5.691689, 2.000125>,
      < -0.500890, 5.684086, 1.970804>
    }
    triangle {
      < -0.299098, 5.436183, 1.813015>,
      < -0.500890, 5.684086, 1.970804>,
      < -0.490305, 5.467333, 1.770523>
    }
    triangle {
      < -0.490305, 5.467333, 1.770523>,
      < -0.500890, 5.684086, 1.970804>,
      < -0.619415, 5.708832, 1.905872>
    }
    triangle {
      < -0.490305, 5.467333, 1.770523>,
      < -0.619415, 5.708832, 1.905872>,
      < -0.570045, 5.492799, 1.740637>
    }
    triangle {
      < -0.570045, 5.492799, 1.740637>,
      < -0.619415, 5.708832, 1.905872>,
      < -0.890778, 5.801272, 1.751339>
    }
    triangle {
      < -0.570045, 5.492799, 1.740637>,
      < -0.890778, 5.801272, 1.751339>,
      < -0.844120, 5.597366, 1.613849>
    }
    triangle {
      < -0.844120, 5.597366, 1.613849>,
      < -0.890778, 5.801272, 1.751339>,
      < -1.057001, 5.928176, 1.601641>
    }
    triangle {
      < -0.844120, 5.597366, 1.613849>,
      < -1.057001, 5.928176, 1.601641>,
      < -1.027071, 5.713632, 1.408967>
    }
    triangle {
      < -1.057001, 5.928176, 1.601641>,
      < -0.890778, 5.801272, 1.751339>,
      < -0.863689, 5.912329, 1.797569>
    }
    texture {face}
  }
  // lowlip
  union {
    triangle {
      < -0.781087, 6.165960, 1.864745>,
      < -0.770194, 6.151618, 1.867306>,
      < -0.768347, 6.166550, 1.872100>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < 0.000000, 5.417133, 1.837040>,
      < -0.299098, 5.436183, 1.813015>,
      < -0.241309, 5.392804, 1.475121>
    }
    triangle {
      < 0.000000, 5.417133, 1.837040>,
      < -0.241309, 5.392804, 1.475121>,
      < 0.000000, 5.374960, 1.515602>
    }
    triangle {
      < -0.241309, 5.392804, 1.475121>,
      < -0.299098, 5.436183, 1.813015>,
      < -0.490305, 5.467333, 1.770523>
    }
    triangle {
      < -0.241309, 5.392804, 1.475121>,
      < -0.490305, 5.467333, 1.770523>,
      < -0.414913, 5.421336, 1.426451>
    }
    triangle {
      < -0.414913, 5.421336, 1.426451>,
      < -0.490305, 5.467333, 1.770523>,
      < -0.570045, 5.492799, 1.740637>
    }
    triangle {
      < -0.414913, 5.421336, 1.426451>,
      < -0.570045, 5.492799, 1.740637>,
      < -0.844120, 5.597366, 1.613849>
    }
    triangle {
      < -0.414913, 5.421336, 1.426451>,
      < -0.844120, 5.597366, 1.613849>,
      < -0.652058, 5.520360, 1.283692>
    }
    triangle {
      < -0.652058, 5.520360, 1.283692>,
      < -0.844120, 5.597366, 1.613849>,
      < -1.027071, 5.713632, 1.408967>
    }
    triangle {
      < -0.652058, 5.520360, 1.283692>,
      < -1.027071, 5.713632, 1.408967>,
      < -0.878470, 5.593192, 1.103604>
    }
    triangle {
      < -0.878470, 5.593192, 1.103604>,
      < -1.027071, 5.713632, 1.408967>,
      < -1.209406, 5.866593, 1.153412>
    }
    triangle {
      < -0.878470, 5.593192, 1.103604>,
      < -1.209406, 5.866593, 1.153412>,
      < -1.029236, 5.699072, 0.873728>
    }
    triangle {
      < -1.029236, 5.699072, 0.873728>,
      < -1.209406, 5.866593, 1.153412>,
      < -1.340582, 6.020861, 0.876453>
    }
    triangle {
      < -1.029236, 5.699072, 0.873728>,
      < -1.340582, 6.020861, 0.876453>,
      < -1.118836, 5.844531, 0.602834>
    }
    triangle {
      < -1.118836, 5.844531, 0.602834>,
      < -1.340582, 6.020861, 0.876453>,
      < -1.450135, 6.122812, 0.637919>
    }
    triangle {
      < -1.118836, 5.844531, 0.602834>,
      < -1.450135, 6.122812, 0.637919>,
      < -1.238348, 5.940702, 0.472670>
    }
    triangle {
      < -1.238348, 5.940702, 0.472670>,
      < -1.450135, 6.122812, 0.637919>,
      < -1.506171, 6.198785, 0.484386>
    }
    triangle {
      < -1.506171, 6.198785, 0.484386>,
      < -1.450135, 6.122812, 0.637919>,
      < -1.552103, 6.299576, 0.746761>
    }
    triangle {
      < -1.506171, 6.198785, 0.484386>,
      < -1.552103, 6.299576, 0.746761>,
      < -1.676612, 6.440908, 0.456156>
    }
    triangle {
      < -1.552103, 6.299576, 0.746761>,
      < -1.450135, 6.122812, 0.637919>,
      < -1.340582, 6.020861, 0.876453>
    }
    triangle {
      < -1.552103, 6.299576, 0.746761>,
      < -1.340582, 6.020861, 0.876453>,
      < -1.442532, 6.188966, 1.009076>
    }
    triangle {
      < -1.442532, 6.188966, 1.009076>,
      < -1.340582, 6.020861, 0.876453>,
      < -1.209406, 5.866593, 1.153412>
    }
    triangle {
      < -1.442532, 6.188966, 1.009076>,
      < -1.209406, 5.866593, 1.153412>,
      < -1.272932, 6.064259, 1.297129>
    }
    triangle {
      < -1.272932, 6.064259, 1.297129>,
      < -1.209406, 5.866593, 1.153412>,
      < -1.027071, 5.713632, 1.408967>
    }
    triangle {
      < -1.272932, 6.064259, 1.297129>,
      < -1.027071, 5.713632, 1.408967>,
      < -1.057001, 5.928176, 1.601641>
    }
    triangle {
      < -1.057001, 5.928176, 1.601641>,
      < -1.055449, 6.154773, 1.692849>,
      < -1.322479, 6.246337, 1.393343>
    }
    triangle {
      < -1.057001, 5.928176, 1.601641>,
      < -1.322479, 6.246337, 1.393343>,
      < -1.272932, 6.064259, 1.297129>
    }
    triangle {
      < -1.322479, 6.246337, 1.393343>,
      < -1.055449, 6.154773, 1.692849>,
      < -1.117530, 6.487579, 1.748186>
    }
    triangle {
      < -1.322479, 6.246337, 1.393343>,
      < -1.117530, 6.487579, 1.748186>,
      < -1.392018, 6.465443, 1.495378>
    }
    triangle {
      < -1.322479, 6.246337, 1.393343>,
      < -1.467817, 6.358039, 1.105599>,
      < -1.442532, 6.188966, 1.009076>
    }
    triangle {
      < -1.322479, 6.246337, 1.393343>,
      < -1.442532, 6.188966, 1.009076>,
      < -1.272932, 6.064259, 1.297129>
    }
    triangle {
      < -1.552103, 6.299576, 0.746761>,
      < -1.586969, 6.487923, 0.838833>,
      < -1.686646, 6.625117, 0.584895>
    }
    triangle {
      < -1.552103, 6.299576, 0.746761>,
      < -1.686646, 6.625117, 0.584895>,
      < -1.676612, 6.440908, 0.456156>
    }
    triangle {
      < -1.686646, 6.625117, 0.584895>,
      < -1.728852, 6.717050, 0.456330>,
      < -1.676612, 6.440908, 0.456156>
    }
    triangle {
      < -1.586969, 6.487923, 0.838833>,
      < -1.552103, 6.299576, 0.746761>,
      < -1.442532, 6.188966, 1.009076>
    }
    triangle {
      < -1.586969, 6.487923, 0.838833>,
      < -1.442532, 6.188966, 1.009076>,
      < -1.467817, 6.358039, 1.105599>
    }
    triangle {
      < 0.000000, 5.492510, 0.895761>,
      < 0.000000, 5.374960, 1.515602>,
      < -0.241309, 5.392804, 1.475121>
    }
    triangle {
      < 0.000000, 5.492510, 0.895761>,
      < -0.241309, 5.392804, 1.475121>,
      < -0.163951, 5.515416, 0.883127>
    }
    triangle {
      < -0.163951, 5.515416, 0.883127>,
      < -0.241309, 5.392804, 1.475121>,
      < -0.414913, 5.421336, 1.426451>
    }
    triangle {
      < -0.163951, 5.515416, 0.883127>,
      < -0.414913, 5.421336, 1.426451>,
      < -0.323968, 5.542478, 0.860668>
    }
    triangle {
      < -0.323968, 5.542478, 0.860668>,
      < -0.414913, 5.421336, 1.426451>,
      < -0.652058, 5.520360, 1.283692>
    }
    triangle {
      < -0.323968, 5.542478, 0.860668>,
      < -0.652058, 5.520360, 1.283692>,
      < -0.462977, 5.564999, 0.816277>
    }
    triangle {
      < -0.462977, 5.564999, 0.816277>,
      < -0.652058, 5.520360, 1.283692>,
      < -0.878470, 5.593192, 1.103604>
    }
    triangle {
      < -0.462977, 5.564999, 0.816277>,
      < -0.878470, 5.593192, 1.103604>,
      < -0.660893, 5.657573, 0.748836>
    }
    triangle {
      < -0.660893, 5.657573, 0.748836>,
      < -0.878470, 5.593192, 1.103604>,
      < -1.029236, 5.699072, 0.873728>
    }
    triangle {
      < -0.660893, 5.657573, 0.748836>,
      < -1.029236, 5.699072, 0.873728>,
      < -0.820922, 5.721953, 0.622226>
    }
    triangle {
      < -0.820922, 5.721953, 0.622226>,
      < -1.029236, 5.699072, 0.873728>,
      < -1.118836, 5.844531, 0.602834>
    }
    triangle {
      < -0.820922, 5.721953, 0.622226>,
      < -1.118836, 5.844531, 0.602834>,
      < -1.038925, 5.856872, 0.438530>
    }
    triangle {
      < -1.038925, 5.856872, 0.438530>,
      < -1.118836, 5.844531, 0.602834>,
      < -1.238348, 5.940702, 0.472670>
    }
    triangle {
      < -0.820922, 5.721953, 0.622226>,
      < -1.038925, 5.856872, 0.438530>,
      < -0.488515, 5.798268, 0.415098>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < -2.695209, 6.053171, -0.865855>,
      < -2.826619, 5.660984, -0.490157>,
      < -2.515584, 6.509755, -0.147248>
    }
    triangle {
      < -2.695209, 6.053171, -0.865855>,
      < -2.515584, 6.509755, -0.147248>,
      < -2.500422, 6.632197, -0.524128>
    }
    triangle {
      < -2.500422, 6.632197, -0.524128>,
      < -2.359352, 6.851682, -1.027979>,
      < -2.614723, 6.416059, -1.296192>
    }
    triangle {
      < -2.500422, 6.632197, -0.524128>,
      < -2.614723, 6.416059, -1.296192>,
      < -2.695209, 6.053171, -0.865855>
    }
    triangle {
      < -2.500422, 6.632197, -0.524128>,
      < -2.321589, 7.224392, -0.390974>,
      < -2.273029, 7.262681, -0.865403>
    }
    triangle {
      < -2.500422, 6.632197, -0.524128>,
      < -2.273029, 7.262681, -0.865403>,
      < -2.359352, 6.851682, -1.027979>
    }
    triangle {
      < -2.321589, 7.224392, -0.390974>,
      < -2.294293, 7.756798, -0.426940>,
      < -2.254496, 7.761235, -0.753907>
    }
    triangle {
      < -2.321589, 7.224392, -0.390974>,
      < -2.254496, 7.761235, -0.753907>,
      < -2.273029, 7.262681, -0.865403>
    }
    triangle {
      < -2.273029, 7.262681, -0.865403>,
      < -2.254496, 7.761235, -0.753907>,
      < -2.250164, 7.753303, -1.416556>
    }
    triangle {
      < -2.273029, 7.262681, -0.865403>,
      < -2.250164, 7.753303, -1.416556>,
      < -2.227957, 7.259726, -1.477074>
    }
    triangle {
      < -2.227957, 7.259726, -1.477074>,
      < -1.935595, 7.177408, -2.135517>,
      < -2.233644, 7.054286, -1.552961>
    }
    triangle {
      < -2.233644, 7.054286, -1.552961>,
      < -1.935595, 7.177408, -2.135517>,
      < -2.219475, 6.816071, -1.663349>
    }
    triangle {
      < -2.219475, 6.816071, -1.663349>,
      < -2.614723, 6.416059, -1.296192>,
      < -2.359352, 6.851682, -1.027979>
    }
    triangle {
      < -2.219475, 6.816071, -1.663349>,
      < -2.359352, 6.851682, -1.027979>,
      < -2.233644, 7.054286, -1.552961>
    }
    triangle {
      < -2.233644, 7.054286, -1.552961>,
      < -2.359352, 6.851682, -1.027979>,
      < -2.273029, 7.262681, -0.865403>
    }
    triangle {
      < -2.233644, 7.054286, -1.552961>,
      < -2.273029, 7.262681, -0.865403>,
      < -2.227957, 7.259726, -1.477074>
    }
    triangle {
      < -2.227957, 7.259726, -1.477074>,
      < -2.250164, 7.753303, -1.416556>,
      < -2.126979, 7.757913, -1.940661>
    }
    triangle {
      < -2.227957, 7.259726, -1.477074>,
      < -2.126979, 7.757913, -1.940661>,
      < -1.935595, 7.177408, -2.135517>
    }
    triangle {
      < -2.126979, 7.757913, -1.940661>,
      < -2.250164, 7.753303, -1.416556>,
      < -2.158943, 8.562037, -1.256461>
    }
    triangle {
      < -2.126979, 7.757913, -1.940661>,
      < -2.158943, 8.562037, -1.256461>,
      < -2.097196, 8.656051, -1.801888>
    }
    triangle {
      < -2.097196, 8.656051, -1.801888>,
      < -2.158943, 8.562037, -1.256461>,
      < -2.049096, 9.113437, -1.064185>
    }
    triangle {
      < -2.097196, 8.656051, -1.801888>,
      < -2.049096, 9.113437, -1.064185>,
      < -1.926966, 9.320498, -1.541335>
    }
    triangle {
      < -2.049096, 9.113437, -1.064185>,
      < -2.158943, 8.562037, -1.256461>,
      < -2.193563, 8.457726, -0.654384>
    }
    triangle {
      < -2.049096, 9.113437, -1.064185>,
      < -2.193563, 8.457726, -0.654384>,
      < -2.157858, 8.891205, -0.589506>
    }
    triangle {
      < -2.193563, 8.457726, -0.654384>,
      < -2.158943, 8.562037, -1.256461>,
      < -2.250164, 7.753303, -1.416556>
    }
    triangle {
      < -2.193563, 8.457726, -0.654384>,
      < -2.250164, 7.753303, -1.416556>,
      < -2.254496, 7.761235, -0.753907>
    }
    triangle {
      < -2.254496, 7.761235, -0.753907>,
      < -2.294293, 7.756798, -0.426940>,
      < -2.287188, 8.423973, -0.499452>
    }
    triangle {
      < -2.254496, 7.761235, -0.753907>,
      < -2.287188, 8.423973, -0.499452>,
      < -2.193563, 8.457726, -0.654384>
    }
    triangle {
      < -2.193563, 8.457726, -0.654384>,
      < -2.287188, 8.423973, -0.499452>,
      < -2.292505, 8.873673, -0.424492>
    }
    triangle {
      < -2.193563, 8.457726, -0.654384>,
      < -2.292505, 8.873673, -0.424492>,
      < -2.157858, 8.891205, -0.589506>
    }
    triangle {
      < -2.292505, 8.873673, -0.424492>,
      < -2.287188, 8.423973, -0.499452>,
      < -2.350794, 8.405975, -0.338027>
    }
    triangle {
      < -2.292505, 8.873673, -0.424492>,
      < -2.350794, 8.405975, -0.338027>,
      < -2.319053, 8.823269, -0.286861>
    }
    triangle {
      < -2.319053, 8.823269, -0.286861>,
      < -2.350794, 8.405975, -0.338027>,
      < -2.264757, 8.360371, 0.036182>
    }
    triangle {
      < -2.319053, 8.823269, -0.286861>,
      < -2.264757, 8.360371, 0.036182>,
      < -2.249767, 8.695644, 0.019894>
    }
    triangle {
      < -2.264757, 8.360371, 0.036182>,
      < -2.350794, 8.405975, -0.338027>,
      < -2.334304, 7.767658, -0.289991>
    }
    triangle {
      < -2.264757, 8.360371, 0.036182>,
      < -2.334304, 7.767658, -0.289991>,
      < -2.207831, 7.787432, 0.130303>
    }
    triangle {
      < -2.334304, 7.767658, -0.289991>,
      < -2.350794, 8.405975, -0.338027>,
      < -2.287188, 8.423973, -0.499452>
    }
    triangle {
      < -2.334304, 7.767658, -0.289991>,
      < -2.287188, 8.423973, -0.499452>,
      < -2.294293, 7.756798, -0.426940>
    }
    triangle {
      < -2.334304, 7.767658, -0.289991>,
      < -2.294293, 7.756798, -0.426940>,
      < -2.321589, 7.224392, -0.390974>
    }
    triangle {
      < -2.334304, 7.767658, -0.289991>,
      < -2.321589, 7.224392, -0.390974>,
      < -2.331083, 7.195605, -0.180993>
    }
    triangle {
      < -2.331083, 7.195605, -0.180993>,
      < -2.321589, 7.224392, -0.390974>,
      < -2.500422, 6.632197, -0.524128>
    }
    triangle {
      < -2.331083, 7.195605, -0.180993>,
      < -2.500422, 6.632197, -0.524128>,
      < -2.515584, 6.509755, -0.147248>
    }
    triangle {
      < -2.515584, 6.509755, -0.147248>,
      < -2.330512, 6.299601, 0.262144>,
      < -2.197367, 7.172413, 0.273125>
    }
    triangle {
      < -2.515584, 6.509755, -0.147248>,
      < -2.197367, 7.172413, 0.273125>,
      < -2.331083, 7.195605, -0.180993>
    }
    triangle {
      < -2.207831, 7.787432, 0.130303>,
      < -2.334304, 7.767658, -0.289991>,
      < -2.331083, 7.195605, -0.180993>
    }
    triangle {
      < -2.207831, 7.787432, 0.130303>,
      < -2.331083, 7.195605, -0.180993>,
      < -2.197367, 7.172413, 0.273125>
    }
    triangle {
      < -2.330512, 6.299601, 0.262144>,
      < -2.515584, 6.509755, -0.147248>,
      < -2.826619, 5.660984, -0.490157>
    }
    triangle {
      < -2.330512, 6.299601, 0.262144>,
      < -2.826619, 5.660984, -0.490157>,
      < -2.542333, 5.326556, -0.002924>
    }
    triangle {
      < -2.542333, 5.326556, -0.002924>,
      < -2.826619, 5.660984, -0.490157>,
      < -2.951908, 4.766716, -1.262379>
    }
    triangle {
      < -2.542333, 5.326556, -0.002924>,
      < -2.951908, 4.766716, -1.262379>,
      < -2.399125, 4.275225, -0.760437>
    }
    triangle {
      < -2.951908, 4.766716, -1.262379>,
      < -2.826619, 5.660984, -0.490157>,
      < -2.695209, 6.053171, -0.865855>
    }
    triangle {
      < -2.951908, 4.766716, -1.262379>,
      < -2.695209, 6.053171, -0.865855>,
      < -2.968071, 5.401118, -1.732358>
    }
    triangle {
      < -2.968071, 5.401118, -1.732358>,
      < -2.695209, 6.053171, -0.865855>,
      < -2.614723, 6.416059, -1.296192>
    }
    triangle {
      < -2.968071, 5.401118, -1.732358>,
      < -2.614723, 6.416059, -1.296192>,
      < -2.568169, 5.879606, -1.879941>
    }
    triangle {
      < -2.568169, 5.879606, -1.879941>,
      < -2.614723, 6.416059, -1.296192>,
      < -2.219475, 6.816071, -1.663349>
    }
    triangle {
      < -2.568169, 5.879606, -1.879941>,
      < -2.219475, 6.816071, -1.663349>,
      < -2.251399, 6.389997, -2.022340>
    }
    triangle {
      < -2.251399, 6.389997, -2.022340>,
      < -2.219475, 6.816071, -1.663349>,
      < -1.935595, 7.177408, -2.135517>
    }
    triangle {
      < -2.251399, 6.389997, -2.022340>,
      < -1.935595, 7.177408, -2.135517>,
      < -1.809644, 6.943704, -2.198517>
    }
    triangle {
      < -1.809644, 6.943704, -2.198517>,
      < -1.613503, 6.780987, -2.334113>,
      < -2.064757, 6.140160, -2.288342>
    }
    triangle {
      < -1.809644, 6.943704, -2.198517>,
      < -2.064757, 6.140160, -2.288342>,
      < -2.251399, 6.389997, -2.022340>
    }
    triangle {
      < -2.251399, 6.389997, -2.022340>,
      < -2.064757, 6.140160, -2.288342>,
      < -2.543283, 5.618077, -2.285651>
    }
    triangle {
      < -2.251399, 6.389997, -2.022340>,
      < -2.543283, 5.618077, -2.285651>,
      < -2.568169, 5.879606, -1.879941>
    }
    triangle {
      < -2.568169, 5.879606, -1.879941>,
      < -2.543283, 5.618077, -2.285651>,
      < -2.807642, 5.119742, -2.192055>
    }
    triangle {
      < -2.568169, 5.879606, -1.879941>,
      < -2.807642, 5.119742, -2.192055>,
      < -2.968071, 5.401118, -1.732358>
    }
    triangle {
      < -2.968071, 5.401118, -1.732358>,
      < -2.807642, 5.119742, -2.192055>,
      < -2.771923, 4.394222, -1.718391>
    }
    triangle {
      < -2.968071, 5.401118, -1.732358>,
      < -2.771923, 4.394222, -1.718391>,
      < -2.951908, 4.766716, -1.262379>
    }
    triangle {
      < -2.951908, 4.766716, -1.262379>,
      < -2.771923, 4.394222, -1.718391>,
      < -2.320945, 3.991879, -1.246104>
    }
    triangle {
      < -2.951908, 4.766716, -1.262379>,
      < -2.320945, 3.991879, -1.246104>,
      < -2.399125, 4.275225, -0.760437>
    }
    triangle {
      < -2.399125, 4.275225, -0.760437>,
      < -2.320945, 3.991879, -1.246104>,
      < -1.797362, 3.947582, -0.884269>
    }
    triangle {
      < -2.399125, 4.275225, -0.760437>,
      < -1.797362, 3.947582, -0.884269>,
      < -1.883869, 4.253895, -0.493437>
    }
    triangle {
      < -1.883869, 4.253895, -0.493437>,
      < -1.797362, 3.947582, -0.884269>,
      < -1.350401, 4.000060, -0.637910>
    }
    triangle {
      < -1.883869, 4.253895, -0.493437>,
      < -1.350401, 4.000060, -0.637910>,
      < -1.462984, 4.192017, -0.341670>
    }
    triangle {
      < -2.542333, 5.326556, -0.002924>,
      < -2.399125, 4.275225, -0.760437>,
      < -1.883869, 4.253895, -0.493437>
    }
    triangle {
      < -2.542333, 5.326556, -0.002924>,
      < -1.883869, 4.253895, -0.493437>,
      < -1.922380, 4.961071, 0.309447>
    }
    triangle {
      < -1.922380, 4.961071, 0.309447>,
      < -1.883869, 4.253895, -0.493437>,
      < -1.462984, 4.192017, -0.341670>
    }
    triangle {
      < -1.922380, 4.961071, 0.309447>,
      < -1.462984, 4.192017, -0.341670>,
      < -1.523759, 4.906872, 0.371754>
    }
    triangle {
      < -1.523759, 4.906872, 0.371754>,
      < -1.462984, 4.192017, -0.341670>,
      < -1.156556, 4.295053, -0.244954>
    }
    triangle {
      < -1.523759, 4.906872, 0.371754>,
      < -1.156556, 4.295053, -0.244954>,
      < -1.148426, 4.840314, 0.283156>
    }
    triangle {
      < -1.462984, 4.192017, -0.341670>,
      < -1.350401, 4.000060, -0.637910>,
      < -1.109287, 4.222658, -0.389658>
    }
    triangle {
      < -1.462984, 4.192017, -0.341670>,
      < -1.109287, 4.222658, -0.389658>,
      < -1.156556, 4.295053, -0.244954>
    }
    triangle {
      < -1.148426, 4.840314, 0.283156>,
      < -1.238348, 5.940702, 0.472670>,
      < -1.506171, 6.198785, 0.484386>
    }
    triangle {
      < -1.148426, 4.840314, 0.283156>,
      < -1.506171, 6.198785, 0.484386>,
      < -1.523759, 4.906872, 0.371754>
    }
    triangle {
      < -1.523759, 4.906872, 0.371754>,
      < -1.506171, 6.198785, 0.484386>,
      < -1.917271, 6.096984, 0.562636>
    }
    triangle {
      < -1.523759, 4.906872, 0.371754>,
      < -1.917271, 6.096984, 0.562636>,
      < -1.922380, 4.961071, 0.309447>
    }
    triangle {
      < -1.922380, 4.961071, 0.309447>,
      < -1.917271, 6.096984, 0.562636>,
      < -2.330512, 6.299601, 0.262144>
    }
    triangle {
      < -1.922380, 4.961071, 0.309447>,
      < -2.330512, 6.299601, 0.262144>,
      < -2.542333, 5.326556, -0.002924>
    }
    triangle {
      < -2.330512, 6.299601, 0.262144>,
      < -1.917271, 6.096984, 0.562636>,
      < -1.926717, 7.188261, 0.448640>
    }
    triangle {
      < -2.330512, 6.299601, 0.262144>,
      < -1.926717, 7.188261, 0.448640>,
      < -2.197367, 7.172413, 0.273125>
    }
    triangle {
      < -2.197367, 7.172413, 0.273125>,
      < -1.926717, 7.188261, 0.448640>,
      < -2.000672, 7.805625, 0.339448>
    }
    triangle {
      < -2.197367, 7.172413, 0.273125>,
      < -2.000672, 7.805625, 0.339448>,
      < -2.207831, 7.787432, 0.130303>
    }
    triangle {
      < -2.207831, 7.787432, 0.130303>,
      < -2.000672, 7.805625, 0.339448>,
      < -2.041171, 8.328996, 0.197016>
    }
    triangle {
      < -2.207831, 7.787432, 0.130303>,
      < -2.041171, 8.328996, 0.197016>,
      < -2.264757, 8.360371, 0.036182>
    }
    triangle {
      < -2.041171, 8.328996, 0.197016>,
      < -2.000672, 7.805625, 0.339448>,
      < -1.727092, 7.776976, 0.344528>
    }
    triangle {
      < -2.041171, 8.328996, 0.197016>,
      < -1.727092, 7.776976, 0.344528>,
      < -1.811272, 8.350312, 0.257340>
    }
    triangle {
      < -1.811272, 8.350312, 0.257340>,
      < -1.828851, 8.531735, 0.231749>,
      < -2.028868, 8.632567, 0.168562>
    }
    triangle {
      < -1.811272, 8.350312, 0.257340>,
      < -2.028868, 8.632567, 0.168562>,
      < -2.041171, 8.328996, 0.197016>
    }
    triangle {
      < -2.041171, 8.328996, 0.197016>,
      < -2.028868, 8.632567, 0.168562>,
      < -2.249767, 8.695644, 0.019894>
    }
    triangle {
      < -2.041171, 8.328996, 0.197016>,
      < -2.249767, 8.695644, 0.019894>,
      < -2.264757, 8.360371, 0.036182>
    }
    triangle {
      < -1.926717, 7.188261, 0.448640>,
      < -1.639386, 7.174335, 0.448677>,
      < -1.727092, 7.776976, 0.344528>
    }
    triangle {
      < -1.926717, 7.188261, 0.448640>,
      < -1.727092, 7.776976, 0.344528>,
      < -2.000672, 7.805625, 0.339448>
    }
    triangle {
      < -1.828851, 8.531735, 0.231749>,
      < -1.805840, 8.641598, 0.263489>,
      < -2.012497, 8.790535, 0.229861>
    }
    triangle {
      < -1.828851, 8.531735, 0.231749>,
      < -2.012497, 8.790535, 0.229861>,
      < -2.028868, 8.632567, 0.168562>
    }
    triangle {
      < -2.028868, 8.632567, 0.168562>,
      < -2.012497, 8.790535, 0.229861>,
      < -2.270350, 8.936516, 0.163526>
    }
    triangle {
      < -2.028868, 8.632567, 0.168562>,
      < -2.270350, 8.936516, 0.163526>,
      < -2.249767, 8.695644, 0.019894>
    }
    triangle {
      < -2.270350, 8.936516, 0.163526>,
      < -2.012497, 8.790535, 0.229861>,
      < -1.971650, 8.855663, 0.465910>
    }
    triangle {
      < -2.270350, 8.936516, 0.163526>,
      < -1.971650, 8.855663, 0.465910>,
      < -2.185188, 9.002164, 0.402722>
    }
    triangle {
      < -1.971650, 8.855663, 0.465910>,
      < -1.792122, 8.717618, 0.442839>,
      < -1.647696, 8.606560, 0.948423>
    }
    triangle {
      < -1.971650, 8.855663, 0.465910>,
      < -1.647696, 8.606560, 0.948423>,
      < -1.891534, 8.777411, 1.002220>
    }
    triangle {
      < -1.891534, 8.777411, 1.002220>,
      < -1.647696, 8.606560, 0.948423>,
      < -1.392183, 8.540370, 1.434910>
    }
    triangle {
      < -1.891534, 8.777411, 1.002220>,
      < -1.392183, 8.540370, 1.434910>,
      < -1.601344, 8.730423, 1.554419>
    }
    triangle {
      < -1.319051, 8.701921, 1.933999>,
      < -1.002136, 8.526634, 1.800382>,
      < -0.680408, 8.556564, 1.960871>
    }
    triangle {
      < -1.319051, 8.701921, 1.933999>,
      < -0.680408, 8.556564, 1.960871>,
      < -0.987856, 8.710015, 2.176044>
    }
    triangle {
      < -0.987856, 8.710015, 2.176044>,
      < -0.680408, 8.556564, 1.960871>,
      < -0.383177, 8.650391, 2.030931>
    }
    triangle {
      < -0.987856, 8.710015, 2.176044>,
      < -0.383177, 8.650391, 2.030931>,
      < -0.599243, 8.796925, 2.396621>
    }
    triangle {
      < -0.599243, 8.796925, 2.396621>,
      < -0.383177, 8.650391, 2.030931>,
      < 0.000000, 8.854424, 2.009160>
    }
    triangle {
      < -0.599243, 8.796925, 2.396621>,
      < 0.000000, 8.854424, 2.009160>,
      < -0.255350, 8.975057, 2.381315>
    }
    triangle {
      < -0.255350, 8.975057, 2.381315>,
      < 0.000000, 8.854424, 2.009160>,
      < 0.000000, 9.107080, 2.288430>
    }
    triangle {
      < -2.012497, 8.790535, 0.229861>,
      < -1.805840, 8.641598, 0.263489>,
      < -1.792122, 8.717618, 0.442839>
    }
    triangle {
      < -2.012497, 8.790535, 0.229861>,
      < -1.792122, 8.717618, 0.442839>,
      < -1.971650, 8.855663, 0.465910>
    }
    triangle {
      < -2.185188, 9.002164, 0.402722>,
      < -1.971650, 8.855663, 0.465910>,
      < -1.891534, 8.777411, 1.002220>
    }
    triangle {
      < -2.185188, 9.002164, 0.402722>,
      < -1.891534, 8.777411, 1.002220>,
      < -2.055095, 9.063828, 0.960787>
    }
    triangle {
      < -2.055095, 9.063828, 0.960787>,
      < -1.891534, 8.777411, 1.002220>,
      < -1.601344, 8.730423, 1.554419>
    }
    triangle {
      < -2.055095, 9.063828, 0.960787>,
      < -1.601344, 8.730423, 1.554419>,
      < -1.708395, 9.040586, 1.591635>
    }
    triangle {
      < -1.708395, 9.040586, 1.591635>,
      < -1.601344, 8.730423, 1.554419>,
      < -1.319051, 8.701921, 1.933999>
    }
    triangle {
      < -1.708395, 9.040586, 1.591635>,
      < -1.319051, 8.701921, 1.933999>,
      < -1.446800, 9.073135, 1.973879>
    }
    triangle {
      < -1.446800, 9.073135, 1.973879>,
      < -1.319051, 8.701921, 1.933999>,
      < -0.987856, 8.710015, 2.176044>
    }
    triangle {
      < -1.446800, 9.073135, 1.973879>,
      < -0.987856, 8.710015, 2.176044>,
      < -1.101010, 9.105548, 2.348224>
    }
    triangle {
      < -1.101010, 9.105548, 2.348224>,
      < -0.987856, 8.710015, 2.176044>,
      < -0.599243, 8.796925, 2.396621>
    }
    triangle {
      < -1.101010, 9.105548, 2.348224>,
      < -0.599243, 8.796925, 2.396621>,
      < -0.699663, 9.205090, 2.602089>
    }
    triangle {
      < -0.699663, 9.205090, 2.602089>,
      < -0.599243, 8.796925, 2.396621>,
      < -0.255350, 8.975057, 2.381315>
    }
    triangle {
      < -0.699663, 9.205090, 2.602089>,
      < -0.255350, 8.975057, 2.381315>,
      < -0.249266, 9.331985, 2.524297>
    }
    triangle {
      < -2.249767, 8.695644, 0.019894>,
      < -2.270350, 8.936516, 0.163526>,
      < -2.282247, 9.100043, -0.083286>
    }
    triangle {
      < -2.249767, 8.695644, 0.019894>,
      < -2.282247, 9.100043, -0.083286>,
      < -2.319053, 8.823269, -0.286861>
    }
    triangle {
      < -2.319053, 8.823269, -0.286861>,
      < -2.282247, 9.100043, -0.083286>,
      < -2.286398, 9.164603, -0.229685>
    }
    triangle {
      < -2.319053, 8.823269, -0.286861>,
      < -2.286398, 9.164603, -0.229685>,
      < -2.292505, 8.873673, -0.424492>
    }
    triangle {
      < -2.282247, 9.100043, -0.083286>,
      < -2.270350, 8.936516, 0.163526>,
      < -2.185188, 9.002164, 0.402722>
    }
    triangle {
      < -2.282247, 9.100043, -0.083286>,
      < -2.185188, 9.002164, 0.402722>,
      < -2.284901, 9.250681, 0.267759>
    }
    triangle {
      < -2.284901, 9.250681, 0.267759>,
      < -2.185188, 9.002164, 0.402722>,
      < -2.055095, 9.063828, 0.960787>
    }
    triangle {
      < -2.284901, 9.250681, 0.267759>,
      < -2.055095, 9.063828, 0.960787>,
      < -2.056396, 9.225585, 0.884461>
    }
    triangle {
      < -2.056396, 9.225585, 0.884461>,
      < -2.055095, 9.063828, 0.960787>,
      < -1.708395, 9.040586, 1.591635>
    }
    triangle {
      < -2.056396, 9.225585, 0.884461>,
      < -1.708395, 9.040586, 1.591635>,
      < -1.733561, 9.311479, 1.537561>
    }
    triangle {
      < -1.733561, 9.311479, 1.537561>,
      < -1.708395, 9.040586, 1.591635>,
      < -1.446800, 9.073135, 1.973879>
    }
    triangle {
      < -1.733561, 9.311479, 1.537561>,
      < -1.446800, 9.073135, 1.973879>,
      < -1.465756, 9.403043, 1.874206>
    }
    triangle {
      < -1.465756, 9.403043, 1.874206>,
      < -1.446800, 9.073135, 1.973879>,
      < -1.101010, 9.105548, 2.348224>
    }
    triangle {
      < -1.465756, 9.403043, 1.874206>,
      < -1.101010, 9.105548, 2.348224>,
      < -1.137060, 9.513208, 2.292973>
    }
    triangle {
      < -1.137060, 9.513208, 2.292973>,
      < -1.101010, 9.105548, 2.348224>,
      < -0.699663, 9.205090, 2.602089>
    }
    triangle {
      < -1.137060, 9.513208, 2.292973>,
      < -0.699663, 9.205090, 2.602089>,
      < -0.732736, 9.619038, 2.624132>
    }
    triangle {
      < -0.732736, 9.619038, 2.624132>,
      < -0.699663, 9.205090, 2.602089>,
      < -0.249266, 9.331985, 2.524297>
    }
    triangle {
      < -0.732736, 9.619038, 2.624132>,
      < -0.249266, 9.331985, 2.524297>,
      < -0.261909, 9.676860, 2.534168>
    }
    triangle {
      < -0.261909, 9.676860, 2.534168>,
      < -0.249266, 9.331985, 2.524297>,
      < 0.000000, 9.425873, 2.379832>
    }
    triangle {
      < -0.261909, 9.676860, 2.534168>,
      < 0.000000, 9.425873, 2.379832>,
      < 0.000000, 9.676222, 2.368930>
    }
    triangle {
      < -0.255350, 8.975057, 2.381315>,
      < 0.000000, 9.107080, 2.288430>,
      < 0.000000, 9.425873, 2.379832>
    }
    triangle {
      < -0.255350, 8.975057, 2.381315>,
      < 0.000000, 9.425873, 2.379832>,
      < -0.249266, 9.331985, 2.524297>
    }
    triangle {
      < 0.000000, 8.905552, -3.064667>,
      < 0.000000, 7.624628, -2.870633>,
      < -0.469544, 7.723520, -2.859780>
    }
    triangle {
      < 0.000000, 8.905552, -3.064667>,
      < -0.469544, 7.723520, -2.859780>,
      < -0.434081, 8.903049, -3.029997>
    }
    triangle {
      < -0.434081, 8.903049, -3.029997>,
      < -0.469544, 7.723520, -2.859780>,
      < -0.804466, 8.007513, -2.919087>
    }
    triangle {
      < -0.434081, 8.903049, -3.029997>,
      < -0.804466, 8.007513, -2.919087>,
      < -0.968716, 8.279623, -2.944191>
    }
    triangle {
      < -0.968716, 8.279623, -2.944191>,
      < -1.047604, 8.860490, -2.939014>,
      < -0.434081, 8.903049, -3.029997>
    }
    triangle {
      < -1.047604, 8.860490, -2.939014>,
      < -0.968716, 8.279623, -2.944191>,
      < -1.268084, 7.926604, -2.755030>
    }
    triangle {
      < -1.047604, 8.860490, -2.939014>,
      < -1.268084, 7.926604, -2.755030>,
      < -1.568699, 7.815787, -2.585501>
    }
    triangle {
      < -1.047604, 8.860490, -2.939014>,
      < -1.568699, 7.815787, -2.585501>,
      < -1.630740, 8.748152, -2.586531>
    }
    triangle {
      < -1.630740, 8.748152, -2.586531>,
      < -1.568699, 7.815787, -2.585501>,
      < -2.126979, 7.757913, -1.940661>
    }
    triangle {
      < -1.630740, 8.748152, -2.586531>,
      < -2.126979, 7.757913, -1.940661>,
      < -2.097196, 8.656051, -1.801888>
    }
    triangle {
      < -2.097196, 8.656051, -1.801888>,
      < -1.926966, 9.320498, -1.541335>,
      < -1.514965, 9.554935, -2.259202>
    }
    triangle {
      < -2.097196, 8.656051, -1.801888>,
      < -1.514965, 9.554935, -2.259202>,
      < -1.630740, 8.748152, -2.586531>
    }
    triangle {
      < -1.630740, 8.748152, -2.586531>,
      < -1.514965, 9.554935, -2.259202>,
      < -1.026081, 9.603339, -2.643369>
    }
    triangle {
      < -1.630740, 8.748152, -2.586531>,
      < -1.026081, 9.603339, -2.643369>,
      < -1.047604, 8.860490, -2.939014>
    }
    triangle {
      < -1.047604, 8.860490, -2.939014>,
      < -1.026081, 9.603339, -2.643369>,
      < -0.446711, 9.532402, -2.810143>
    }
    triangle {
      < -1.047604, 8.860490, -2.939014>,
      < -0.446711, 9.532402, -2.810143>,
      < -0.434081, 8.903049, -3.029997>
    }
    triangle {
      < -0.434081, 8.903049, -3.029997>,
      < -0.446711, 9.532402, -2.810143>,
      < 0.000000, 9.582272, -2.824734>
    }
    triangle {
      < -0.434081, 8.903049, -3.029997>,
      < 0.000000, 9.582272, -2.824734>,
      < 0.000000, 8.905552, -3.064667>
    }
    triangle {
      < -1.268084, 7.926604, -2.755030>,
      < -1.442480, 7.603398, -2.575616>,
      < -1.568699, 7.815787, -2.585501>
    }
    triangle {
      < -1.568699, 7.815787, -2.585501>,
      < -1.442480, 7.603398, -2.575616>,
      < -1.935595, 7.177408, -2.135517>
    }
    triangle {
      < -1.568699, 7.815787, -2.585501>,
      < -1.935595, 7.177408, -2.135517>,
      < -2.126979, 7.757913, -1.940661>
    }
    triangle {
      < -1.935595, 7.177408, -2.135517>,
      < -1.442480, 7.603398, -2.575616>,
      < -1.809644, 6.943704, -2.198517>
    }
    triangle {
      < -1.809644, 6.943704, -2.198517>,
      < -1.442480, 7.603398, -2.575616>,
      < -1.211628, 7.371768, -2.620786>
    }
    triangle {
      < -1.809644, 6.943704, -2.198517>,
      < -1.211628, 7.371768, -2.620786>,
      < -1.613503, 6.780987, -2.334113>
    }
    triangle {
      < -1.613503, 6.780987, -2.334113>,
      < -1.211628, 7.371768, -2.620786>,
      < -1.403973, 6.678395, -2.479017>
    }
    triangle {
      < -1.403973, 6.678395, -2.479017>,
      < -1.211628, 7.371768, -2.620786>,
      < -1.007608, 7.261537, -2.675797>
    }
    triangle {
      < -1.403973, 6.678395, -2.479017>,
      < -1.007608, 7.261537, -2.675797>,
      < -1.181260, 6.567130, -2.555930>
    }
    triangle {
      < -1.181260, 6.567130, -2.555930>,
      < -1.007608, 7.261537, -2.675797>,
      < -0.441592, 7.157158, -2.704895>
    }
    triangle {
      < -1.181260, 6.567130, -2.555930>,
      < -0.441592, 7.157158, -2.704895>,
      < -0.507013, 6.480210, -2.627249>
    }
    triangle {
      < -0.507013, 6.480210, -2.627249>,
      < -0.441592, 7.157158, -2.704895>,
      < 0.000000, 7.103825, -2.743361>
    }
    triangle {
      < -0.507013, 6.480210, -2.627249>,
      < 0.000000, 7.103825, -2.743361>,
      < 0.000000, 6.404224, -2.712183>
    }
    triangle {
      < 0.000000, 7.103825, -2.743361>,
      < -0.441592, 7.157158, -2.704895>,
      < -0.469544, 7.723520, -2.859780>
    }
    triangle {
      < 0.000000, 7.103825, -2.743361>,
      < -0.469544, 7.723520, -2.859780>,
      < 0.000000, 7.624628, -2.870633>
    }
    triangle {
      < -0.469544, 7.723520, -2.859780>,
      < -0.441592, 7.157158, -2.704895>,
      < -1.007608, 7.261537, -2.675797>
    }
    triangle {
      < -0.469544, 7.723520, -2.859780>,
      < -1.007608, 7.261537, -2.675797>,
      < -0.804466, 8.007513, -2.919087>
    }
    triangle {
      < -0.968716, 8.279623, -2.944191>,
      < -0.804466, 8.007513, -2.919087>,
      < -1.007608, 7.261537, -2.675797>
    }
    triangle {
      < -0.968716, 8.279623, -2.944191>,
      < -1.007608, 7.261537, -2.675797>,
      < -1.211628, 7.371768, -2.620786>
    }
    triangle {
      < -0.968716, 8.279623, -2.944191>,
      < -1.211628, 7.371768, -2.620786>,
      < -1.442480, 7.603398, -2.575616>
    }
    triangle {
      < -0.968716, 8.279623, -2.944191>,
      < -1.442480, 7.603398, -2.575616>,
      < -1.268084, 7.926604, -2.755030>
    }
    triangle {
      < 0.000000, 6.404224, -2.712183>,
      < 0.000000, 5.577987, -2.943249>,
      < -0.629737, 5.668156, -2.875407>
    }
    triangle {
      < 0.000000, 6.404224, -2.712183>,
      < -0.629737, 5.668156, -2.875407>,
      < -0.507013, 6.480210, -2.627249>
    }
    triangle {
      < -0.507013, 6.480210, -2.627249>,
      < -0.629737, 5.668156, -2.875407>,
      < -1.383150, 5.848190, -2.730564>
    }
    triangle {
      < -0.507013, 6.480210, -2.627249>,
      < -1.383150, 5.848190, -2.730564>,
      < -1.181260, 6.567130, -2.555930>
    }
    triangle {
      < -1.181260, 6.567130, -2.555930>,
      < -1.383150, 5.848190, -2.730564>,
      < -1.812413, 5.978925, -2.594764>
    }
    triangle {
      < -1.181260, 6.567130, -2.555930>,
      < -1.812413, 5.978925, -2.594764>,
      < -1.403973, 6.678395, -2.479017>
    }
    triangle {
      < -1.403973, 6.678395, -2.479017>,
      < -1.812413, 5.978925, -2.594764>,
      < -2.064757, 6.140160, -2.288342>
    }
    triangle {
      < -1.403973, 6.678395, -2.479017>,
      < -2.064757, 6.140160, -2.288342>,
      < -1.613503, 6.780987, -2.334113>
    }
    triangle {
      < 0.000000, 5.577987, -2.943249>,
      < 0.000000, 5.020720, -3.259467>,
      < -0.798679, 5.106549, -3.156878>
    }
    triangle {
      < 0.000000, 5.577987, -2.943249>,
      < -0.798679, 5.106549, -3.156878>,
      < -0.629737, 5.668156, -2.875407>
    }
    triangle {
      < -0.629737, 5.668156, -2.875407>,
      < -0.798679, 5.106549, -3.156878>,
      < -1.649015, 5.307382, -2.979003>
    }
    triangle {
      < -0.629737, 5.668156, -2.875407>,
      < -1.649015, 5.307382, -2.979003>,
      < -1.383150, 5.848190, -2.730564>
    }
    triangle {
      < -1.383150, 5.848190, -2.730564>,
      < -1.649015, 5.307382, -2.979003>,
      < -2.241066, 5.455282, -2.807144>
    }
    triangle {
      < -1.383150, 5.848190, -2.730564>,
      < -2.241066, 5.455282, -2.807144>,
      < -1.812413, 5.978925, -2.594764>
    }
    triangle {
      < -1.812413, 5.978925, -2.594764>,
      < -2.241066, 5.455282, -2.807144>,
      < -2.543283, 5.618077, -2.285651>
    }
    triangle {
      < -1.812413, 5.978925, -2.594764>,
      < -2.543283, 5.618077, -2.285651>,
      < -2.064757, 6.140160, -2.288342>
    }
    triangle {
      < -2.543283, 5.618077, -2.285651>,
      < -2.241066, 5.455282, -2.807144>,
      < -2.435137, 4.892701, -2.746463>
    }
    triangle {
      < -2.543283, 5.618077, -2.285651>,
      < -2.435137, 4.892701, -2.746463>,
      < -2.807642, 5.119742, -2.192055>
    }
    triangle {
      < -2.435137, 4.892701, -2.746463>,
      < -2.241066, 5.455282, -2.807144>,
      < -1.649015, 5.307382, -2.979003>
    }
    triangle {
      < -2.435137, 4.892701, -2.746463>,
      < -1.649015, 5.307382, -2.979003>,
      < -1.800736, 4.722509, -3.002015>
    }
    triangle {
      < -1.800736, 4.722509, -3.002015>,
      < -1.649015, 5.307382, -2.979003>,
      < -0.798679, 5.106549, -3.156878>
    }
    triangle {
      < -1.800736, 4.722509, -3.002015>,
      < -0.798679, 5.106549, -3.156878>,
      < -0.894068, 4.551052, -3.116934>
    }
    triangle {
      < -0.894068, 4.551052, -3.116934>,
      < -0.798679, 5.106549, -3.156878>,
      < 0.000000, 5.020720, -3.259467>
    }
    triangle {
      < -0.894068, 4.551052, -3.116934>,
      < 0.000000, 5.020720, -3.259467>,
      < 0.000000, 4.458508, -3.182819>
    }
    triangle {
      < 0.000000, 4.458508, -3.182819>,
      < 0.000000, 3.626533, -2.862228>,
      < -0.959599, 3.783694, -2.768924>
    }
    triangle {
      < 0.000000, 4.458508, -3.182819>,
      < -0.959599, 3.783694, -2.768924>,
      < -0.894068, 4.551052, -3.116934>
    }
    triangle {
      < -0.894068, 4.551052, -3.116934>,
      < -0.959599, 3.783694, -2.768924>,
      < -1.888283, 3.938280, -2.489334>
    }
    triangle {
      < -0.894068, 4.551052, -3.116934>,
      < -1.888283, 3.938280, -2.489334>,
      < -1.800736, 4.722509, -3.002015>
    }
    triangle {
      < -1.800736, 4.722509, -3.002015>,
      < -1.888283, 3.938280, -2.489334>,
      < -2.394799, 4.114178, -2.171901>
    }
    triangle {
      < -1.800736, 4.722509, -3.002015>,
      < -2.394799, 4.114178, -2.171901>,
      < -2.435137, 4.892701, -2.746463>
    }
    triangle {
      < -2.435137, 4.892701, -2.746463>,
      < -2.394799, 4.114178, -2.171901>,
      < -2.771923, 4.394222, -1.718391>
    }
    triangle {
      < -2.435137, 4.892701, -2.746463>,
      < -2.771923, 4.394222, -1.718391>,
      < -2.807642, 5.119742, -2.192055>
    }
    triangle {
      < -2.771923, 4.394222, -1.718391>,
      < -2.394799, 4.114178, -2.171901>,
      < -2.141117, 3.745879, -1.649152>
    }
    triangle {
      < -2.771923, 4.394222, -1.718391>,
      < -2.141117, 3.745879, -1.649152>,
      < -2.320945, 3.991879, -1.246104>
    }
    triangle {
      < -2.141117, 3.745879, -1.649152>,
      < -2.394799, 4.114178, -2.171901>,
      < -1.888283, 3.938280, -2.489334>
    }
    triangle {
      < -2.141117, 3.745879, -1.649152>,
      < -1.888283, 3.938280, -2.489334>,
      < -1.754788, 3.591762, -1.875521>
    }
    triangle {
      < -1.754788, 3.591762, -1.875521>,
      < -1.888283, 3.938280, -2.489334>,
      < -0.959599, 3.783694, -2.768924>
    }
    triangle {
      < -1.754788, 3.591762, -1.875521>,
      < -0.959599, 3.783694, -2.768924>,
      < -0.810586, 3.425251, -2.206288>
    }
    triangle {
      < -0.810586, 3.425251, -2.206288>,
      < -0.959599, 3.783694, -2.768924>,
      < 0.000000, 3.626533, -2.862228>
    }
    triangle {
      < -0.810586, 3.425251, -2.206288>,
      < 0.000000, 3.626533, -2.862228>,
      < 0.000000, 3.301184, -2.361485>
    }
    triangle {
      < -0.810586, 3.425251, -2.206288>,
      < -0.740513, 3.381576, -1.620888>,
      < -1.410822, 3.628767, -1.366164>
    }
    triangle {
      < -0.810586, 3.425251, -2.206288>,
      < -1.410822, 3.628767, -1.366164>,
      < -1.754788, 3.591762, -1.875521>
    }
    triangle {
      < -1.754788, 3.591762, -1.875521>,
      < -1.410822, 3.628767, -1.366164>,
      < -1.737683, 3.779556, -1.074812>
    }
    triangle {
      < -1.754788, 3.591762, -1.875521>,
      < -1.737683, 3.779556, -1.074812>,
      < -2.141117, 3.745879, -1.649152>
    }
    triangle {
      < -2.141117, 3.745879, -1.649152>,
      < -1.737683, 3.779556, -1.074812>,
      < -1.797362, 3.947582, -0.884269>
    }
    triangle {
      < -2.141117, 3.745879, -1.649152>,
      < -1.797362, 3.947582, -0.884269>,
      < -2.320945, 3.991879, -1.246104>
    }
    triangle {
      < 0.000000, 9.582272, -2.824734>,
      < -0.446711, 9.532402, -2.810143>,
      < -0.312674, 10.106316, -2.341642>
    }
    triangle {
      < 0.000000, 9.582272, -2.824734>,
      < -0.312674, 10.106316, -2.341642>,
      < 0.000000, 10.103044, -2.437498>
    }
    triangle {
      < -0.312674, 10.106316, -2.341642>,
      < -0.446711, 9.532402, -2.810143>,
      < -1.026081, 9.603339, -2.643369>
    }
    triangle {
      < -0.312674, 10.106316, -2.341642>,
      < -1.026081, 9.603339, -2.643369>,
      < -0.801285, 10.138000, -2.101213>
    }
    triangle {
      < -0.801285, 10.138000, -2.101213>,
      < -1.026081, 9.603339, -2.643369>,
      < -1.514965, 9.554935, -2.259202>
    }
    triangle {
      < -0.801285, 10.138000, -2.101213>,
      < -1.514965, 9.554935, -2.259202>,
      < -1.352927, 10.028240, -1.712292>
    }
    triangle {
      < -1.352927, 10.028240, -1.712292>,
      < -1.514965, 9.554935, -2.259202>,
      < -1.926966, 9.320498, -1.541335>
    }
    triangle {
      < -1.352927, 10.028240, -1.712292>,
      < -1.926966, 9.320498, -1.541335>,
      < -1.721511, 9.733690, -1.174845>
    }
    triangle {
      < -1.721511, 9.733690, -1.174845>,
      < -1.926966, 9.320498, -1.541335>,
      < -2.049096, 9.113437, -1.064185>
    }
    triangle {
      < -1.721511, 9.733690, -1.174845>,
      < -2.049096, 9.113437, -1.064185>,
      < -1.901165, 9.490677, -0.758218>
    }
    triangle {
      < -1.901165, 9.490677, -0.758218>,
      < -2.049096, 9.113437, -1.064185>,
      < -2.157858, 8.891205, -0.589506>
    }
    triangle {
      < -1.901165, 9.490677, -0.758218>,
      < -2.157858, 8.891205, -0.589506>,
      < -2.127863, 9.054000, -0.469666>
    }
    triangle {
      < -1.901165, 9.490677, -0.758218>,
      < -2.127863, 9.054000, -0.469666>,
      < -2.047613, 9.230265, -0.380456>
    }
    triangle {
      < -2.047613, 9.230265, -0.380456>,
      < -2.127863, 9.054000, -0.469666>,
      < -2.157858, 8.891205, -0.589506>
    }
    triangle {
      < -2.047613, 9.230265, -0.380456>,
      < -2.157858, 8.891205, -0.589506>,
      < -2.292505, 8.873673, -0.424492>
    }
    triangle {
      < -2.047613, 9.230265, -0.380456>,
      < -2.292505, 8.873673, -0.424492>,
      < -2.286398, 9.164603, -0.229685>
    }
    triangle {
      < -0.312674, 10.106316, -2.341642>,
      < -0.801285, 10.138000, -2.101213>,
      < -0.512046, 10.486948, -1.404077>
    }
    triangle {
      < -0.312674, 10.106316, -2.341642>,
      < -0.512046, 10.486948, -1.404077>,
      < -0.256023, 10.441054, -1.625575>
    }
    triangle {
      < -0.512046, 10.486948, -1.404077>,
      < -0.801285, 10.138000, -2.101213>,
      < -1.352927, 10.028240, -1.712292>
    }
    triangle {
      < -0.512046, 10.486948, -1.404077>,
      < -1.352927, 10.028240, -1.712292>,
      < -1.095283, 10.363935, -0.991215>
    }
    triangle {
      < -1.095283, 10.363935, -0.991215>,
      < -1.352927, 10.028240, -1.712292>,
      < -1.721511, 9.733690, -1.174845>
    }
    triangle {
      < -1.095283, 10.363935, -0.991215>,
      < -1.721511, 9.733690, -1.174845>,
      < -1.595059, 10.016598, -0.523450>
    }
    triangle {
      < -1.595059, 10.016598, -0.523450>,
      < -1.721511, 9.733690, -1.174845>,
      < -1.901165, 9.490677, -0.758218>
    }
    triangle {
      < -1.595059, 10.016598, -0.523450>,
      < -1.901165, 9.490677, -0.758218>,
      < -1.775840, 9.758400, -0.294073>
    }
    triangle {
      < -1.775840, 9.758400, -0.294073>,
      < -1.901165, 9.490677, -0.758218>,
      < -2.047613, 9.230265, -0.380456>
    }
    triangle {
      < -1.775840, 9.758400, -0.294073>,
      < -2.047613, 9.230265, -0.380456>,
      < -1.959134, 9.398203, -0.008383>
    }
    triangle {
      < -1.959134, 9.398203, -0.008383>,
      < -2.047613, 9.230265, -0.380456>,
      < -2.286398, 9.164603, -0.229685>
    }
    triangle {
      < -1.959134, 9.398203, -0.008383>,
      < -2.286398, 9.164603, -0.229685>,
      < -2.252386, 9.379482, 0.153680>
    }
    triangle {
      < -2.252386, 9.379482, 0.153680>,
      < -2.286398, 9.164603, -0.229685>,
      < -2.282247, 9.100043, -0.083286>
    }
    triangle {
      < -2.252386, 9.379482, 0.153680>,
      < -2.282247, 9.100043, -0.083286>,
      < -2.284901, 9.250681, 0.267759>
    }
    triangle {
      < -0.512046, 10.486948, -1.404077>,
      < -1.095283, 10.363935, -0.991215>,
      < -0.730800, 10.500572, -0.462674>
    }
    triangle {
      < -0.512046, 10.486948, -1.404077>,
      < -0.730800, 10.500572, -0.462674>,
      < -0.282734, 10.530972, -1.248772>
    }
    triangle {
      < -0.282734, 10.530972, -1.248772>,
      < -0.730800, 10.500572, -0.462674>,
      < -0.504874, 10.493316, -0.312871>
    }
    triangle {
      < -0.504874, 10.493316, -0.312871>,
      < -0.275809, 10.487108, -0.299676>,
      < -0.282734, 10.530972, -1.248772>
    }
    triangle {
      < -0.282734, 10.530972, -1.248772>,
      < -0.275809, 10.487108, -0.299676>,
      < 0.000000, 10.428140, -0.147974>
    }
    triangle {
      < -0.282734, 10.530972, -1.248772>,
      < 0.000000, 10.428140, -0.147974>,
      < 0.000000, 10.556360, -1.255870>
    }
    triangle {
      < -0.282734, 10.530972, -1.248772>,
      < -0.256023, 10.441054, -1.625575>,
      < -0.512046, 10.486948, -1.404077>
    }
    triangle {
      < -0.504874, 10.493316, -0.312871>,
      < -0.730800, 10.500572, -0.462674>,
      < -1.327421, 10.210172, 0.149119>
    }
    triangle {
      < -0.504874, 10.493316, -0.312871>,
      < -1.327421, 10.210172, 0.149119>,
      < -0.882110, 10.198242, 0.534316>
    }
    triangle {
      < -0.882110, 10.198242, 0.534316>,
      < -0.506844, 10.207478, 0.621239>,
      < -0.275809, 10.487108, -0.299676>
    }
    triangle {
      < -0.882110, 10.198242, 0.534316>,
      < -0.275809, 10.487108, -0.299676>,
      < -0.504874, 10.493316, -0.312871>
    }
    triangle {
      < -0.275809, 10.487108, -0.299676>,
      < -0.506844, 10.207478, 0.621239>,
      < -0.274110, 10.197698, 0.669496>
    }
    triangle {
      < -0.274110, 10.197698, 0.669496>,
      < 0.000000, 10.129307, 0.640858>,
      < 0.000000, 10.428140, -0.147974>
    }
    triangle {
      < -0.274110, 10.197698, 0.669496>,
      < 0.000000, 10.428140, -0.147974>,
      < -0.275809, 10.487108, -0.299676>
    }
    triangle {
      < -0.730800, 10.500572, -0.462674>,
      < -1.095283, 10.363935, -0.991215>,
      < -1.595059, 10.016598, -0.523450>
    }
    triangle {
      < -0.730800, 10.500572, -0.462674>,
      < -1.595059, 10.016598, -0.523450>,
      < -1.327421, 10.210172, 0.149119>
    }
    triangle {
      < -1.327421, 10.210172, 0.149119>,
      < -1.595059, 10.016598, -0.523450>,
      < -1.775840, 9.758400, -0.294073>
    }
    triangle {
      < -1.327421, 10.210172, 0.149119>,
      < -1.775840, 9.758400, -0.294073>,
      < -1.477108, 9.966330, 0.362745>
    }
    triangle {
      < -1.477108, 9.966330, 0.362745>,
      < -1.775840, 9.758400, -0.294073>,
      < -1.959134, 9.398203, -0.008383>
    }
    triangle {
      < -1.477108, 9.966330, 0.362745>,
      < -1.959134, 9.398203, -0.008383>,
      < -1.755289, 9.487906, 0.677609>
    }
    triangle {
      < -1.755289, 9.487906, 0.677609>,
      < -1.959134, 9.398203, -0.008383>,
      < -2.252386, 9.379482, 0.153680>
    }
    triangle {
      < -1.755289, 9.487906, 0.677609>,
      < -2.252386, 9.379482, 0.153680>,
      < -1.935464, 9.390430, 0.837203>
    }
    triangle {
      < -1.935464, 9.390430, 0.837203>,
      < -2.252386, 9.379482, 0.153680>,
      < -2.284901, 9.250681, 0.267759>
    }
    triangle {
      < -1.935464, 9.390430, 0.837203>,
      < -2.284901, 9.250681, 0.267759>,
      < -2.056396, 9.225585, 0.884461>
    }
    triangle {
      < -0.882110, 10.198242, 0.534316>,
      < -1.327421, 10.210172, 0.149119>,
      < -1.477108, 9.966330, 0.362745>
    }
    triangle {
      < -0.882110, 10.198242, 0.534316>,
      < -1.477108, 9.966330, 0.362745>,
      < -1.103107, 10.000225, 0.919427>
    }
    triangle {
      < -0.882110, 10.198242, 0.534316>,
      < -1.103107, 10.000225, 0.919427>,
      < -1.086055, 10.010103, 0.967558>
    }
    triangle {
      < -1.103107, 10.000225, 0.919427>,
      < -1.477108, 9.966330, 0.362745>,
      < -1.755289, 9.487906, 0.677609>
    }
    triangle {
      < -1.103107, 10.000225, 0.919427>,
      < -1.755289, 9.487906, 0.677609>,
      < -1.449702, 9.772484, 1.224917>
    }
    triangle {
      < -1.103107, 10.000225, 0.919427>,
      < -1.449702, 9.772484, 1.224917>,
      < -1.099944, 9.986621, 0.982247>
    }
    triangle {
      < -1.449702, 9.772484, 1.224917>,
      < -1.338807, 9.885557, 1.425528>,
      < -1.105226, 9.995815, 1.016037>
    }
    triangle {
      < -1.449702, 9.772484, 1.224917>,
      < -1.105226, 9.995815, 1.016037>,
      < -1.099944, 9.986621, 0.982247>
    }
    triangle {
      < -1.449702, 9.772484, 1.224917>,
      < -1.667624, 9.513432, 1.415407>,
      < -1.420564, 9.691097, 1.678985>
    }
    triangle {
      < -1.449702, 9.772484, 1.224917>,
      < -1.420564, 9.691097, 1.678985>,
      < -1.338807, 9.885557, 1.425528>
    }
    triangle {
      < -1.449702, 9.772484, 1.224917>,
      < -1.755289, 9.487906, 0.677609>,
      < -1.935464, 9.390430, 0.837203>
    }
    triangle {
      < -1.449702, 9.772484, 1.224917>,
      < -1.935464, 9.390430, 0.837203>,
      < -1.667624, 9.513432, 1.415407>
    }
    triangle {
      < -1.733561, 9.311479, 1.537561>,
      < -1.667624, 9.513432, 1.415407>,
      < -1.935464, 9.390430, 0.837203>
    }
    triangle {
      < -1.733561, 9.311479, 1.537561>,
      < -1.935464, 9.390430, 0.837203>,
      < -2.056396, 9.225585, 0.884461>
    }
    triangle {
      < -1.733561, 9.311479, 1.537561>,
      < -1.465756, 9.403043, 1.874206>,
      < -1.420564, 9.691097, 1.678985>
    }
    triangle {
      < -1.733561, 9.311479, 1.537561>,
      < -1.420564, 9.691097, 1.678985>,
      < -1.667624, 9.513432, 1.415407>
    }
    triangle {
      < -1.465756, 9.403043, 1.874206>,
      < -1.137060, 9.513208, 2.292973>,
      < -1.128255, 9.897694, 2.124563>
    }
    triangle {
      < -1.465756, 9.403043, 1.874206>,
      < -1.128255, 9.897694, 2.124563>,
      < -1.420564, 9.691097, 1.678985>
    }
    triangle {
      < -1.338807, 9.885557, 1.425528>,
      < -1.033270, 10.098597, 1.766723>,
      < -0.861416, 10.225743, 1.316271>
    }
    triangle {
      < -1.338807, 9.885557, 1.425528>,
      < -0.861416, 10.225743, 1.316271>,
      < -1.084894, 10.020005, 1.020502>
    }
    triangle {
      < -1.338807, 9.885557, 1.425528>,
      < -1.084894, 10.020005, 1.020502>,
      < -1.105226, 9.995815, 1.016037>
    }
    triangle {
      < -1.084894, 10.020005, 1.020502>,
      < -0.861416, 10.225743, 1.316271>,
      < -0.684999, 10.033707, 1.161263>
    }
    triangle {
      < -0.683422, 10.023827, 1.109206>,
      < -0.506844, 10.207478, 0.621239>,
      < -0.882110, 10.198242, 0.534316>
    }
    triangle {
      < -0.683422, 10.023827, 1.109206>,
      < -0.882110, 10.198242, 0.534316>,
      < -1.086055, 10.010103, 0.967558>
    }
    triangle {
      < -0.506844, 10.207478, 0.621239>,
      < -0.683422, 10.023827, 1.109206>,
      < -0.343630, 9.996747, 1.136028>
    }
    triangle {
      < -0.506844, 10.207478, 0.621239>,
      < -0.343630, 9.996747, 1.136028>,
      < -0.274110, 10.197698, 0.669496>
    }
    triangle {
      < -0.274110, 10.197698, 0.669496>,
      < -0.343630, 9.996747, 1.136028>,
      < 0.000000, 9.961681, 1.162321>
    }
    triangle {
      < -0.274110, 10.197698, 0.669496>,
      < 0.000000, 9.961681, 1.162321>,
      < 0.000000, 10.129307, 0.640858>
    }
    triangle {
      < -0.254090, 10.268738, 1.602070>,
      < -0.343488, 10.005959, 1.188529>,
      < -0.344938, 10.006336, 1.188239>
    }
    triangle {
      < -0.254090, 10.268738, 1.602070>,
      < -0.344938, 10.006336, 1.188239>,
      < -0.462446, 10.313475, 1.547025>
    }
    triangle {
      < -0.462446, 10.313475, 1.547025>,
      < -0.344938, 10.006336, 1.188239>,
      < -0.684999, 10.033707, 1.161263>
    }
    triangle {
      < -0.462446, 10.313475, 1.547025>,
      < -0.684999, 10.033707, 1.161263>,
      < -0.861416, 10.225743, 1.316271>
    }
    triangle {
      < -0.861416, 10.225743, 1.316271>,
      < -1.033270, 10.098597, 1.766723>,
      < -0.547649, 10.323700, 2.058094>
    }
    triangle {
      < -0.861416, 10.225743, 1.316271>,
      < -0.547649, 10.323700, 2.058094>,
      < -0.462446, 10.313475, 1.547025>
    }
    triangle {
      < -0.547649, 10.323700, 2.058094>,
      < -1.033270, 10.098597, 1.766723>,
      < -1.128255, 9.897694, 2.124563>
    }
    triangle {
      < -0.547649, 10.323700, 2.058094>,
      < -1.128255, 9.897694, 2.124563>,
      < -0.655658, 10.001616, 2.429456>
    }
    triangle {
      < -0.655658, 10.001616, 2.429456>,
      < -0.263420, 9.947759, 2.352102>,
      < -0.213677, 10.232553, 2.038405>
    }
    triangle {
      < -0.655658, 10.001616, 2.429456>,
      < -0.213677, 10.232553, 2.038405>,
      < -0.547649, 10.323700, 2.058094>
    }
    triangle {
      < -1.128255, 9.897694, 2.124563>,
      < -1.033270, 10.098597, 1.766723>,
      < -1.338807, 9.885557, 1.425528>
    }
    triangle {
      < -1.128255, 9.897694, 2.124563>,
      < -1.338807, 9.885557, 1.425528>,
      < -1.420564, 9.691097, 1.678985>
    }
    triangle {
      < -1.137060, 9.513208, 2.292973>,
      < -0.732736, 9.619038, 2.624132>,
      < -0.655658, 10.001616, 2.429456>
    }
    triangle {
      < -1.137060, 9.513208, 2.292973>,
      < -0.655658, 10.001616, 2.429456>,
      < -1.128255, 9.897694, 2.124563>
    }
    triangle {
      < -0.254090, 10.268738, 1.602070>,
      < -0.462446, 10.313475, 1.547025>,
      < -0.547649, 10.323700, 2.058094>
    }
    triangle {
      < -0.254090, 10.268738, 1.602070>,
      < -0.547649, 10.323700, 2.058094>,
      < -0.213677, 10.232553, 2.038405>
    }
    triangle {
      < -0.213677, 10.232553, 2.038405>,
      < 0.000000, 10.109884, 2.025559>,
      < 0.000000, 10.138660, 1.618270>
    }
    triangle {
      < -0.213677, 10.232553, 2.038405>,
      < 0.000000, 10.138660, 1.618270>,
      < -0.254090, 10.268738, 1.602070>
    }
    triangle {
      < 0.000000, 10.109884, 2.025559>,
      < -0.213677, 10.232553, 2.038405>,
      < -0.263420, 9.947759, 2.352102>
    }
    triangle {
      < 0.000000, 10.109884, 2.025559>,
      < -0.263420, 9.947759, 2.352102>,
      < 0.000000, 9.868969, 2.276780>
    }
    triangle {
      < -0.263420, 9.947759, 2.352102>,
      < -0.655658, 10.001616, 2.429456>,
      < -0.732736, 9.619038, 2.624132>
    }
    triangle {
      < -0.263420, 9.947759, 2.352102>,
      < -0.732736, 9.619038, 2.624132>,
      < -0.261909, 9.676860, 2.534168>
    }
    triangle {
      < 0.000000, 4.222149, -0.712363>,
      < -0.499061, 4.222472, -0.703218>,
      < -0.637588, 3.615422, -1.159366>
    }
    triangle {
      < 0.000000, 4.222149, -0.712363>,
      < -0.637588, 3.615422, -1.159366>,
      < 0.000000, 3.556864, -1.285038>
    }
    triangle {
      < 0.000000, 3.556864, -1.285038>,
      < -0.637588, 3.615422, -1.159366>,
      < -0.740513, 3.381576, -1.620888>
    }
    triangle {
      < 0.000000, 3.556864, -1.285038>,
      < -0.740513, 3.381576, -1.620888>,
      < 0.000000, 3.252037, -1.835155>
    }
    triangle {
      < -1.099824, 3.816411, -0.941113>,
      < -0.860388, 4.222589, -0.582402>,
      < -1.109287, 4.222658, -0.389658>
    }
    triangle {
      < -1.099824, 3.816411, -0.941113>,
      < -1.109287, 4.222658, -0.389658>,
      < -1.350401, 4.000060, -0.637910>
    }
    triangle {
      < -1.350401, 4.000060, -0.637910>,
      < -1.737683, 3.779556, -1.074812>,
      < -1.410822, 3.628767, -1.366164>
    }
    triangle {
      < -1.350401, 4.000060, -0.637910>,
      < -1.410822, 3.628767, -1.366164>,
      < -1.099824, 3.816411, -0.941113>
    }
    triangle {
      < -1.099824, 3.816411, -0.941113>,
      < -1.410822, 3.628767, -1.366164>,
      < -0.740513, 3.381576, -1.620888>
    }
    triangle {
      < -1.099824, 3.816411, -0.941113>,
      < -0.740513, 3.381576, -1.620888>,
      < -0.637588, 3.615422, -1.159366>
    }
    triangle {
      < -1.737683, 3.779556, -1.074812>,
      < -1.350401, 4.000060, -0.637910>,
      < -1.797362, 3.947582, -0.884269>
    }
    triangle {
      < -0.810586, 3.425251, -2.206288>,
      < 0.000000, 3.301184, -2.361485>,
      < 0.000000, 3.252037, -1.835155>
    }
    triangle {
      < -0.810586, 3.425251, -2.206288>,
      < 0.000000, 3.252037, -1.835155>,
      < -0.740513, 3.381576, -1.620888>
    }
    triangle {
      < -1.392183, 8.540370, 1.434910>,
      < -1.208542, 8.514754, 1.669742>,
      < -1.002136, 8.526634, 1.800382>
    }
    triangle {
      < -1.392183, 8.540370, 1.434910>,
      < -1.002136, 8.526634, 1.800382>,
      < -1.319051, 8.701921, 1.933999>
    }
    triangle {
      < -1.392183, 8.540370, 1.434910>,
      < -1.319051, 8.701921, 1.933999>,
      < -1.601344, 8.730423, 1.554419>
    }
    triangle {
      < -1.148426, 4.840314, 0.283156>,
      < -1.038925, 5.856872, 0.438530>,
      < -1.238348, 5.940702, 0.472670>
    }
    triangle {
      < -1.676612, 6.440908, 0.456156>,
      < -1.917271, 6.096984, 0.562636>,
      < -1.506171, 6.198785, 0.484386>
    }
    triangle {
      < -0.343488, 10.005959, 1.188529>,
      < -0.254090, 10.268738, 1.602070>,
      < 0.000000, 10.138660, 1.618270>
    }
    triangle {
      < -0.343488, 10.005959, 1.188529>,
      < 0.000000, 10.138660, 1.618270>,
      < 0.000000, 9.970675, 1.215246>
    }
    triangle {
      < -0.860388, 4.222589, -0.582402>,
      < -1.099824, 3.816411, -0.941113>,
      < -0.637588, 3.615422, -1.159366>
    }
    triangle {
      < -0.860388, 4.222589, -0.582402>,
      < -0.637588, 3.615422, -1.159366>,
      < -0.499061, 4.222472, -0.703218>
    }
    triangle {
      < -1.926717, 7.188261, 0.448640>,
      < -1.685030, 6.993190, 0.456504>,
      < -1.639386, 7.174335, 0.448677>
    }
    triangle {
      < -1.917271, 6.096984, 0.562636>,
      < -1.676612, 6.440908, 0.456156>,
      < -1.728852, 6.717050, 0.456330>
    }
    triangle {
      < -1.917271, 6.096984, 0.562636>,
      < -1.728852, 6.717050, 0.456330>,
      < -1.926717, 7.188261, 0.448640>
    }
    texture {hair}
  }
  // lash
  union {
    triangle {
      < -1.226924, 7.611438, 1.536010>,
      < -1.217140, 7.601475, 1.575520>,
      < -1.199642, 7.673470, 1.737281>
    }
    triangle {
      < -1.226924, 7.611438, 1.536010>,
      < -1.199642, 7.673470, 1.737281>,
      < -1.205264, 7.688103, 1.703732>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < -1.221443, 7.665048, 1.236122>,
      < -1.190138, 7.595891, 1.288325>,
      < -1.183912, 7.723730, 1.527919>
    }
    triangle {
      < -1.221443, 7.665048, 1.236122>,
      < -1.183912, 7.723730, 1.527919>,
      < -1.222239, 7.779233, 1.314082>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < -1.156556, 4.295053, -0.244954>,
      < -0.813469, 4.923323, 0.096762>,
      < -1.148426, 4.840314, 0.283156>
    }
    triangle {
      < -0.488515, 5.798268, 0.415098>,
      < -1.038925, 5.856872, 0.438530>,
      < -1.148426, 4.840314, 0.283156>
    }
    triangle {
      < -0.488515, 5.798268, 0.415098>,
      < -1.148426, 4.840314, 0.283156>,
      < -0.813469, 4.923323, 0.096762>
    }
    triangle {
      < -0.382808, 5.030048, -0.142889>,
      < -0.499061, 4.222472, -0.703218>,
      < 0.000000, 4.222149, -0.712363>
    }
    triangle {
      < -0.382808, 5.030048, -0.142889>,
      < 0.000000, 4.222149, -0.712363>,
      < 0.000000, 5.124914, -0.355912>
    }
    triangle {
      < -0.259731, 5.798376, 0.405359>,
      < -0.382808, 5.030048, -0.142889>,
      < 0.000000, 5.124914, -0.355912>
    }
    triangle {
      < -0.259731, 5.798376, 0.405359>,
      < 0.000000, 5.124914, -0.355912>,
      < 0.000000, 5.798498, 0.394301>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < -0.163951, 5.515416, 0.883127>,
      < -0.259731, 5.798376, 0.405359>,
      < 0.000000, 5.798498, 0.394301>
    }
    triangle {
      < -0.163951, 5.515416, 0.883127>,
      < 0.000000, 5.798498, 0.394301>,
      < 0.000000, 5.492510, 0.895761>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < -0.813469, 4.923323, 0.096762>,
      < -0.860388, 4.222589, -0.582402>,
      < -0.499061, 4.222472, -0.703218>
    }
    triangle {
      < -0.813469, 4.923323, 0.096762>,
      < -0.499061, 4.222472, -0.703218>,
      < -0.382808, 5.030048, -0.142889>
    }
    triangle {
      < -0.488515, 5.798268, 0.415098>,
      < -0.813469, 4.923323, 0.096762>,
      < -0.382808, 5.030048, -0.142889>
    }
    triangle {
      < -0.488515, 5.798268, 0.415098>,
      < -0.382808, 5.030048, -0.142889>,
      < -0.259731, 5.798376, 0.405359>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < -0.462977, 5.564999, 0.816277>,
      < -0.488515, 5.798268, 0.415098>,
      < -0.259731, 5.798376, 0.405359>
    }
    triangle {
      < -0.462977, 5.564999, 0.816277>,
      < -0.259731, 5.798376, 0.405359>,
      < -0.323968, 5.542478, 0.860668>
    }
    triangle {
      < -0.259731, 5.798376, 0.405359>,
      < -0.163951, 5.515416, 0.883127>,
      < -0.323968, 5.542478, 0.860668>
    }
    triangle {
      < -0.488515, 5.798268, 0.415098>,
      < -0.462977, 5.564999, 0.816277>,
      < -0.660893, 5.657573, 0.748836>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < -0.860388, 4.222589, -0.582402>,
      < -0.813469, 4.923323, 0.096762>,
      < -1.109287, 4.222658, -0.389658>
    }
    triangle {
      < -0.813469, 4.923323, 0.096762>,
      < -1.156556, 4.295053, -0.244954>,
      < -1.109287, 4.222658, -0.389658>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < -0.820922, 5.721953, 0.622226>,
      < -0.488515, 5.798268, 0.415098>,
      < -0.660893, 5.657573, 0.748836>
    }
    triangle {
      < -1.467817, 6.358039, 1.105599>,
      < -1.322479, 6.246337, 1.393343>,
      < -1.392018, 6.465443, 1.495378>
    }
    triangle {
      < -1.467817, 6.358039, 1.105599>,
      < -1.392018, 6.465443, 1.495378>,
      < -1.567187, 6.531720, 1.241760>
    }
    triangle {
      < -1.586969, 6.487923, 0.838833>,
      < -1.467817, 6.358039, 1.105599>,
      < -1.567187, 6.531720, 1.241760>
    }
    triangle {
      < -1.586969, 6.487923, 0.838833>,
      < -1.567187, 6.531720, 1.241760>,
      < -1.641878, 6.680877, 0.963337>
    }
    triangle {
      < -1.686646, 6.625117, 0.584895>,
      < -1.586969, 6.487923, 0.838833>,
      < -1.641878, 6.680877, 0.963337>
    }
    triangle {
      < -1.686646, 6.625117, 0.584895>,
      < -1.641878, 6.680877, 0.963337>,
      < -1.665081, 6.813934, 0.713635>
    }
    triangle {
      < -1.728852, 6.717050, 0.456330>,
      < -1.686646, 6.625117, 0.584895>,
      < -1.665081, 6.813934, 0.713635>
    }
    triangle {
      < -1.728852, 6.717050, 0.456330>,
      < -1.665081, 6.813934, 0.713635>,
      < -1.685030, 6.993190, 0.456504>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < -1.926717, 7.188261, 0.448640>,
      < -1.728852, 6.717050, 0.456330>,
      < -1.685030, 6.993190, 0.456504>
    }
    triangle {
      < 0.000000, 9.868969, 2.276780>,
      < -0.263420, 9.947759, 2.352102>,
      < -0.261909, 9.676860, 2.534168>
    }
    triangle {
      < 0.000000, 9.868969, 2.276780>,
      < -0.261909, 9.676860, 2.534168>,
      < 0.000000, 9.676222, 2.368930>
    }
    triangle {
      < -0.343488, 10.005959, 1.188529>,
      < -0.343630, 9.996747, 1.136028>,
      < -0.344938, 10.006336, 1.188239>
    }
    triangle {
      < -1.084894, 10.020005, 1.020502>,
      < -1.086055, 10.010103, 0.967558>,
      < -1.103107, 10.000225, 0.919427>
    }
    triangle {
      < -1.084894, 10.020005, 1.020502>,
      < -1.103107, 10.000225, 0.919427>,
      < -1.099944, 9.986621, 0.982247>
    }
    triangle {
      < -1.084894, 10.020005, 1.020502>,
      < -1.099944, 9.986621, 0.982247>,
      < -1.105226, 9.995815, 1.016037>
    }
    triangle {
      < -0.343488, 10.005959, 1.188529>,
      < 0.000000, 9.970675, 1.215246>,
      < 0.000000, 9.961681, 1.162321>
    }
    triangle {
      < -0.343488, 10.005959, 1.188529>,
      < 0.000000, 9.961681, 1.162321>,
      < -0.343630, 9.996747, 1.136028>
    }
    triangle {
      < -0.684999, 10.033707, 1.161263>,
      < -0.344938, 10.006336, 1.188239>,
      < -0.343630, 9.996747, 1.136028>
    }
    triangle {
      < -0.684999, 10.033707, 1.161263>,
      < -0.343630, 9.996747, 1.136028>,
      < -0.683422, 10.023827, 1.109206>
    }
    triangle {
      < -0.683422, 10.023827, 1.109206>,
      < -1.086055, 10.010103, 0.967558>,
      < -1.084894, 10.020005, 1.020502>
    }
    triangle {
      < -0.683422, 10.023827, 1.109206>,
      < -1.084894, 10.020005, 1.020502>,
      < -0.684999, 10.033707, 1.161263>
    }
    triangle {
      < -0.256023, 10.441054, -1.625575>,
      < -0.282734, 10.530972, -1.248772>,
      < 0.000000, 10.556360, -1.255870>
    }
    triangle {
      < -0.256023, 10.441054, -1.625575>,
      < 0.000000, 10.556360, -1.255870>,
      < 0.000000, 10.395161, -1.847075>
    }
    triangle {
      < -0.312674, 10.106316, -2.341642>,
      < -0.256023, 10.441054, -1.625575>,
      < 0.000000, 10.395161, -1.847075>
    }
    triangle {
      < -0.312674, 10.106316, -2.341642>,
      < 0.000000, 10.395161, -1.847075>,
      < 0.000000, 10.103044, -2.437498>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < -0.510838, 8.009660, 1.903327>,
      < -0.589018, 7.915383, 1.940367>,
      < -0.494802, 7.844838, 1.903134>
    }
    triangle {
      < -0.510838, 8.009660, 1.903327>,
      < -0.494802, 7.844838, 1.903134>,
      < -0.434879, 7.848812, 1.844686>
    }
    texture {face}
  }
  // lash
  union {
    triangle {
      < -0.628197, 7.862329, 1.999484>,
      < -0.608820, 7.884941, 2.001511>,
      < -0.738160, 7.909727, 2.052032>
    }
    triangle {
      < -0.628197, 7.862329, 1.999484>,
      < -0.738160, 7.909727, 2.052032>,
      < -0.760872, 7.878096, 2.044034>
    }
    triangle {
      < -0.608820, 7.884941, 2.001511>,
      < -0.628197, 7.862329, 1.999484>,
      < -0.507243, 7.816108, 1.909368>
    }
    triangle {
      < -0.608820, 7.884941, 2.001511>,
      < -0.507243, 7.816108, 1.909368>,
      < -0.505429, 7.826012, 1.931554>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < -0.434879, 7.848812, 1.844686>,
      < -0.494802, 7.844838, 1.903134>,
      < -0.421266, 7.715384, 1.824796>
    }
    triangle {
      < -1.113253, 7.297450, 1.266328>,
      < -1.387584, 7.136969, 1.118825>,
      < -1.280479, 7.023159, 1.386668>
    }
    triangle {
      < -1.113253, 7.297450, 1.266328>,
      < -1.280479, 7.023159, 1.386668>,
      < -1.061896, 7.223755, 1.329039>
    }
    triangle {
      < -0.883035, 7.151428, 1.545997>,
      < -1.118692, 6.924029, 1.657216>,
      < -0.951907, 6.931507, 1.737461>
    }
    triangle {
      < -0.883035, 7.151428, 1.545997>,
      < -0.951907, 6.931507, 1.737461>,
      < -0.772975, 7.160594, 1.638789>
    }
    triangle {
      < -0.165973, 6.990763, 2.401286>,
      < 0.000000, 7.013479, 2.418046>,
      < 0.000000, 7.193865, 2.291512>
    }
    triangle {
      < -0.165973, 6.990763, 2.401286>,
      < 0.000000, 7.193865, 2.291512>,
      < -0.153202, 7.152060, 2.290502>
    }
    triangle {
      < -0.334718, 6.960837, 2.252813>,
      < -0.165973, 6.990763, 2.401286>,
      < -0.153202, 7.152060, 2.290502>
    }
    triangle {
      < -0.334718, 6.960837, 2.252813>,
      < -0.153202, 7.152060, 2.290502>,
      < -0.354659, 7.089078, 2.130837>
    }
    triangle {
      < -0.449324, 6.929481, 2.051343>,
      < -0.334718, 6.960837, 2.252813>,
      < -0.354659, 7.089078, 2.130837>
    }
    triangle {
      < -0.449324, 6.929481, 2.051343>,
      < -0.354659, 7.089078, 2.130837>,
      < -0.442106, 6.988012, 2.018156>
    }
    triangle {
      < -0.449324, 6.929481, 2.051343>,
      < -0.442106, 6.988012, 2.018156>,
      < -0.440409, 6.970834, 2.025113>
    }
    triangle {
      < -0.463406, 6.824869, 2.024403>,
      < -0.449324, 6.929481, 2.051343>,
      < -0.440409, 6.970834, 2.025113>
    }
    triangle {
      < -0.929884, 8.357011, 1.841744>,
      < -0.668233, 8.257164, 1.947022>,
      < -0.680408, 8.556564, 1.960871>
    }
    triangle {
      < -0.929884, 8.357011, 1.841744>,
      < -0.680408, 8.556564, 1.960871>,
      < -1.002136, 8.526634, 1.800382>
    }
    triangle {
      < -1.177990, 8.341700, 1.692121>,
      < -0.929884, 8.357011, 1.841744>,
      < -1.002136, 8.526634, 1.800382>
    }
    triangle {
      < -1.177990, 8.341700, 1.692121>,
      < -1.002136, 8.526634, 1.800382>,
      < -1.208542, 8.514754, 1.669742>
    }
    triangle {
      < -1.388592, 8.182241, 1.451023>,
      < -1.177990, 8.341700, 1.692121>,
      < -1.208542, 8.514754, 1.669742>
    }
    triangle {
      < -1.388592, 8.182241, 1.451023>,
      < -1.208542, 8.514754, 1.669742>,
      < -1.428928, 8.385238, 1.410104>
    }
    triangle {
      < -1.409607, 7.862576, 1.257887>,
      < -1.388592, 8.182241, 1.451023>,
      < -1.428928, 8.385238, 1.410104>
    }
    triangle {
      < -1.409607, 7.862576, 1.257887>,
      < -1.428928, 8.385238, 1.410104>,
      < -1.627951, 8.161976, 1.121192>
    }
    triangle {
      < -0.447613, 6.770525, 2.014438>,
      < -0.448093, 6.801496, 2.038748>,
      < -0.463406, 6.824869, 2.024403>
    }
    triangle {
      < -0.447613, 6.770525, 2.014438>,
      < -0.463406, 6.824869, 2.024403>,
      < -0.459376, 6.802716, 1.999871>
    }
    triangle {
      < -0.449960, 6.979241, 2.004734>,
      < -0.440409, 6.970834, 2.025113>,
      < -0.442106, 6.988012, 2.018156>
    }
    triangle {
      < -0.449960, 6.979241, 2.004734>,
      < -0.442106, 6.988012, 2.018156>,
      < -0.447231, 6.990836, 2.011483>
    }
    triangle {
      < 0.000000, 6.676259, 2.183194>,
      < -0.134601, 6.677120, 2.183006>,
      < -0.135082, 6.628557, 2.158507>
    }
    triangle {
      < 0.000000, 6.676259, 2.183194>,
      < -0.135082, 6.628557, 2.158507>,
      < 0.000000, 6.613321, 2.141114>
    }
    triangle {
      < -0.134601, 6.677120, 2.183006>,
      < -0.263747, 6.748829, 2.144173>,
      < -0.266413, 6.719081, 2.118316>
    }
    triangle {
      < -0.134601, 6.677120, 2.183006>,
      < -0.266413, 6.719081, 2.118316>,
      < -0.135082, 6.628557, 2.158507>
    }
    triangle {
      < -0.263747, 6.748829, 2.144173>,
      < -0.448093, 6.801496, 2.038748>,
      < -0.447613, 6.770525, 2.014438>
    }
    triangle {
      < -0.263747, 6.748829, 2.144173>,
      < -0.447613, 6.770525, 2.014438>,
      < -0.266413, 6.719081, 2.118316>
    }
    triangle {
      < -0.463406, 6.824869, 2.024403>,
      < -0.440409, 6.970834, 2.025113>,
      < -0.449960, 6.979241, 2.004734>
    }
    triangle {
      < -0.463406, 6.824869, 2.024403>,
      < -0.449960, 6.979241, 2.004734>,
      < -0.459376, 6.802716, 1.999871>
    }
    texture {face}
  }
  // white
  union {
    triangle {
      < -0.994898, 7.771222, 1.434833>,
      < -1.063235, 7.760682, 1.524284>,
      < -1.105440, 7.671899, 1.384026>
    }
    texture {white}
  }
  // face
  union {
    triangle {
      < -0.411911, 7.705149, 1.823261>,
      < -0.421266, 7.715384, 1.824796>,
      < -0.420309, 7.701636, 1.819372>
    }
    triangle {
      < -0.411911, 7.705149, 1.823261>,
      < -0.420309, 7.701636, 1.819372>,
      < -0.416886, 7.691145, 1.819102>
    }
    triangle {
      < -1.177549, 7.502185, 1.213440>,
      < -1.181628, 7.493562, 1.203781>,
      < -1.172679, 7.476350, 1.209460>
    }
    triangle {
      < -1.042285, 8.061223, 1.643898>,
      < -0.858304, 8.142274, 1.796644>,
      < -0.857921, 8.152600, 1.795877>
    }
    triangle {
      < -1.042285, 8.061223, 1.643898>,
      < -0.857921, 8.152600, 1.795877>,
      < -1.044607, 8.070682, 1.641520>
    }
    triangle {
      < -0.858304, 8.142274, 1.796644>,
      < -0.676756, 8.098582, 1.873053>,
      < -0.674197, 8.108939, 1.873312>
    }
    triangle {
      < -0.858304, 8.142274, 1.796644>,
      < -0.674197, 8.108939, 1.873312>,
      < -0.857921, 8.152600, 1.795877>
    }
    triangle {
      < -0.676756, 8.098582, 1.873053>,
      < -0.510838, 8.009660, 1.903327>,
      < -0.503766, 8.017214, 1.905862>
    }
    triangle {
      < -0.676756, 8.098582, 1.873053>,
      < -0.503766, 8.017214, 1.905862>,
      < -0.674197, 8.108939, 1.873312>
    }
    triangle {
      < -0.510838, 8.009660, 1.903327>,
      < -0.434879, 7.848812, 1.844686>,
      < -0.426586, 7.851128, 1.845632>
    }
    triangle {
      < -0.510838, 8.009660, 1.903327>,
      < -0.426586, 7.851128, 1.845632>,
      < -0.503766, 8.017214, 1.905862>
    }
    triangle {
      < -0.411911, 7.705149, 1.823261>,
      < -0.426586, 7.851128, 1.845632>,
      < -0.434879, 7.848812, 1.844686>
    }
    triangle {
      < -0.411911, 7.705149, 1.823261>,
      < -0.434879, 7.848812, 1.844686>,
      < -0.421266, 7.715384, 1.824796>
    }
    triangle {
      < -1.138931, 7.943057, 1.452462>,
      < -1.042285, 8.061223, 1.643898>,
      < -1.044607, 8.070682, 1.641520>
    }
    triangle {
      < -1.138931, 7.943057, 1.452462>,
      < -1.044607, 8.070682, 1.641520>,
      < -1.143256, 7.950388, 1.448727>
    }
    triangle {
      < -1.222239, 7.779233, 1.314082>,
      < -1.138931, 7.943057, 1.452462>,
      < -1.143256, 7.950388, 1.448727>
    }
    triangle {
      < -1.222239, 7.779233, 1.314082>,
      < -1.143256, 7.950388, 1.448727>,
      < -1.228102, 7.784869, 1.308105>
    }
    triangle {
      < -1.221443, 7.665048, 1.236122>,
      < -1.222239, 7.779233, 1.314082>,
      < -1.228102, 7.784869, 1.308105>
    }
    triangle {
      < -1.221443, 7.665048, 1.236122>,
      < -1.228102, 7.784869, 1.308105>,
      < -1.228105, 7.667838, 1.228434>
    }
    triangle {
      < -1.177549, 7.502185, 1.213440>,
      < -1.221443, 7.665048, 1.236122>,
      < -1.228105, 7.667838, 1.228434>
    }
    triangle {
      < -1.177549, 7.502185, 1.213440>,
      < -1.228105, 7.667838, 1.228434>,
      < -1.181628, 7.493562, 1.203781>
    }
    texture {face}
  }
  // lowlip
  union {
    triangle {
      < 0.000000, 6.157406, 2.167072>,
      < -0.161882, 6.163558, 2.150136>,
      < -0.173951, 6.088375, 2.182847>
    }
    triangle {
      < 0.000000, 6.157406, 2.167072>,
      < -0.173951, 6.088375, 2.182847>,
      < 0.000000, 6.091110, 2.200333>
    }
    triangle {
      < -0.499316, 6.095293, 1.973400>,
      < -0.358301, 6.097709, 2.127077>,
      < -0.314755, 6.159932, 2.117626>
    }
    triangle {
      < -0.499316, 6.095293, 1.973400>,
      < -0.314755, 6.159932, 2.117626>,
      < -0.496583, 6.127518, 1.979135>
    }
    triangle {
      < -0.632465, 6.147034, 1.925617>,
      < -0.633832, 6.130921, 1.922750>,
      < -0.499316, 6.095293, 1.973400>
    }
    triangle {
      < -0.632465, 6.147034, 1.925617>,
      < -0.499316, 6.095293, 1.973400>,
      < -0.496583, 6.127518, 1.979135>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < -0.174788, 6.243392, 2.268390>,
      < 0.000000, 6.234792, 2.271523>,
      < 0.000000, 6.385907, 2.297638>
    }
    triangle {
      < -0.174788, 6.243392, 2.268390>,
      < 0.000000, 6.385907, 2.297638>,
      < -0.185747, 6.376217, 2.308307>
    }
    triangle {
      < -0.344701, 6.235855, 2.198796>,
      < -0.174788, 6.243392, 2.268390>,
      < -0.185747, 6.376217, 2.308307>
    }
    triangle {
      < -0.344701, 6.235855, 2.198796>,
      < -0.185747, 6.376217, 2.308307>,
      < -0.374646, 6.335971, 2.215456>
    }
    triangle {
      < -0.513649, 6.198605, 2.058142>,
      < -0.344701, 6.235855, 2.198796>,
      < -0.374646, 6.335971, 2.215456>
    }
    triangle {
      < -0.513649, 6.198605, 2.058142>,
      < -0.374646, 6.335971, 2.215456>,
      < -0.530713, 6.263931, 2.096829>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < -0.192374, 5.979699, 2.170825>,
      < 0.000000, 5.979388, 2.192696>,
      < 0.000000, 6.091110, 2.200333>
    }
    triangle {
      < -0.192374, 5.979699, 2.170825>,
      < 0.000000, 6.091110, 2.200333>,
      < -0.173951, 6.088375, 2.182847>
    }
    triangle {
      < -0.369221, 6.000530, 2.109117>,
      < -0.192374, 5.979699, 2.170825>,
      < -0.173951, 6.088375, 2.182847>
    }
    triangle {
      < -0.369221, 6.000530, 2.109117>,
      < -0.173951, 6.088375, 2.182847>,
      < -0.358301, 6.097709, 2.127077>
    }
    triangle {
      < -0.505941, 6.036611, 1.965279>,
      < -0.369221, 6.000530, 2.109117>,
      < -0.358301, 6.097709, 2.127077>
    }
    triangle {
      < -0.505941, 6.036611, 1.965279>,
      < -0.358301, 6.097709, 2.127077>,
      < -0.499316, 6.095293, 1.973400>
    }
    triangle {
      < -0.636121, 6.117154, 1.916293>,
      < -0.505941, 6.036611, 1.965279>,
      < -0.499316, 6.095293, 1.973400>
    }
    triangle {
      < -0.636121, 6.117154, 1.916293>,
      < -0.499316, 6.095293, 1.973400>,
      < -0.633832, 6.130921, 1.922750>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < -0.742783, 6.194807, 1.891206>,
      < -0.530713, 6.263931, 2.096829>,
      < -0.610265, 6.408909, 2.035973>
    }
    triangle {
      < -0.775718, 6.207943, 1.870568>,
      < -0.742783, 6.194807, 1.891206>,
      < -0.610265, 6.408909, 2.035973>
    }
    triangle {
      < -0.775718, 6.207943, 1.870568>,
      < -0.610265, 6.408909, 2.035973>,
      < -0.609789, 6.660050, 1.950922>
    }
    triangle {
      < -0.775718, 6.207943, 1.870568>,
      < -0.609789, 6.660050, 1.950922>,
      < -0.928687, 6.544118, 1.858133>
    }
    triangle {
      < -0.793829, 6.165370, 1.857392>,
      < -0.775718, 6.207943, 1.870568>,
      < -0.928687, 6.544118, 1.858133>
    }
    triangle {
      < -0.793829, 6.165370, 1.857392>,
      < -0.928687, 6.544118, 1.858133>,
      < -1.117530, 6.487579, 1.748186>
    }
    triangle {
      < -0.793829, 6.165370, 1.857392>,
      < -1.117530, 6.487579, 1.748186>,
      < -1.055449, 6.154773, 1.692849>
    }
    triangle {
      < -0.772042, 6.136685, 1.862512>,
      < -0.793829, 6.165370, 1.857392>,
      < -1.055449, 6.154773, 1.692849>
    }
    triangle {
      < -0.772042, 6.136685, 1.862512>,
      < -1.055449, 6.154773, 1.692849>,
      < -1.057001, 5.928176, 1.601641>
    }
    triangle {
      < -0.772042, 6.136685, 1.862512>,
      < -1.057001, 5.928176, 1.601641>,
      < -0.863689, 5.912329, 1.797569>
    }
    texture {face}
  }
  // uplip
  union {
    triangle {
      < -0.742783, 6.194807, 1.891206>,
      < -0.634607, 6.189641, 1.969897>,
      < -0.513649, 6.198605, 2.058142>
    }
    triangle {
      < -0.742783, 6.194807, 1.891206>,
      < -0.513649, 6.198605, 2.058142>,
      < -0.530713, 6.263931, 2.096829>
    }
    triangle {
      < -0.772033, 6.187246, 1.871334>,
      < -0.755565, 6.180678, 1.881653>,
      < -0.742783, 6.194807, 1.891206>
    }
    triangle {
      < -0.772033, 6.187246, 1.871334>,
      < -0.742783, 6.194807, 1.891206>,
      < -0.775718, 6.207943, 1.870568>
    }
    triangle {
      < -0.781087, 6.165960, 1.864745>,
      < -0.772033, 6.187246, 1.871334>,
      < -0.775718, 6.207943, 1.870568>
    }
    triangle {
      < -0.781087, 6.165960, 1.864745>,
      < -0.775718, 6.207943, 1.870568>,
      < -0.793829, 6.165370, 1.857392>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < -0.770194, 6.151618, 1.867306>,
      < -0.781087, 6.165960, 1.864745>,
      < -0.793829, 6.165370, 1.857392>
    }
    triangle {
      < -0.770194, 6.151618, 1.867306>,
      < -0.793829, 6.165370, 1.857392>,
      < -0.772042, 6.136685, 1.862512>
    }
    triangle {
      < -0.505941, 6.036611, 1.965279>,
      < -0.636121, 6.117154, 1.916293>,
      < -0.638888, 6.093111, 1.912075>
    }
    triangle {
      < -0.505941, 6.036611, 1.965279>,
      < -0.638888, 6.093111, 1.912075>,
      < -0.512566, 5.982536, 1.942181>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < -0.634607, 6.189641, 1.969897>,
      < -0.742783, 6.194807, 1.891206>,
      < -0.755565, 6.180678, 1.881653>
    }
    triangle {
      < -0.632465, 6.147034, 1.925617>,
      < -0.634607, 6.189641, 1.969897>,
      < -0.755565, 6.180678, 1.881653>
    }
    triangle {
      < -0.632465, 6.147034, 1.925617>,
      < -0.755565, 6.180678, 1.881653>,
      < -0.768347, 6.166550, 1.872100>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < -0.633832, 6.130921, 1.922750>,
      < -0.632465, 6.147034, 1.925617>,
      < -0.768347, 6.166550, 1.872100>
    }
    triangle {
      < -0.636121, 6.117154, 1.916293>,
      < -0.633832, 6.130921, 1.922750>,
      < -0.768347, 6.166550, 1.872100>
    }
    triangle {
      < -0.636121, 6.117154, 1.916293>,
      < -0.768347, 6.166550, 1.872100>,
      < -0.770194, 6.151618, 1.867306>
    }
    triangle {
      < -0.638888, 6.093111, 1.912075>,
      < -0.636121, 6.117154, 1.916293>,
      < -0.770194, 6.151618, 1.867306>
    }
    triangle {
      < -0.638888, 6.093111, 1.912075>,
      < -0.770194, 6.151618, 1.867306>,
      < -0.772042, 6.136685, 1.862512>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < -0.863689, 5.912329, 1.797569>,
      < -0.638888, 6.093111, 1.912075>,
      < -0.772042, 6.136685, 1.862512>
    }
    texture {face}
  }
  // lash
  union {
    triangle {
      < -0.760872, 7.878096, 2.044034>,
      < -0.738160, 7.909727, 2.052032>,
      < -0.937265, 7.893220, 2.055827>
    }
    triangle {
      < -0.760872, 7.878096, 2.044034>,
      < -0.937265, 7.893220, 2.055827>,
      < -0.932368, 7.861390, 2.048698>
    }
    triangle {
      < -0.932368, 7.861390, 2.048698>,
      < -0.937265, 7.893220, 2.055827>,
      < -1.069781, 7.824396, 1.948702>
    }
    triangle {
      < -0.932368, 7.861390, 2.048698>,
      < -1.069781, 7.824396, 1.948702>,
      < -1.060592, 7.804728, 1.966757>
    }
    triangle {
      < -1.060592, 7.804728, 1.966757>,
      < -1.069781, 7.824396, 1.948702>,
      < -1.148209, 7.762268, 1.851506>
    }
    triangle {
      < -1.060592, 7.804728, 1.966757>,
      < -1.148209, 7.762268, 1.851506>,
      < -1.138348, 7.745724, 1.881467>
    }
    triangle {
      < -1.138348, 7.745724, 1.881467>,
      < -1.148209, 7.762268, 1.851506>,
      < -1.205264, 7.688103, 1.703732>
    }
    triangle {
      < -1.138348, 7.745724, 1.881467>,
      < -1.205264, 7.688103, 1.703732>,
      < -1.199642, 7.673470, 1.737281>
    }
    triangle {
      < -1.063235, 7.760682, 1.524284>,
      < -1.138348, 7.745724, 1.881467>,
      < -1.199642, 7.673470, 1.737281>
    }
    triangle {
      < -1.063235, 7.760682, 1.524284>,
      < -1.199642, 7.673470, 1.737281>,
      < -1.105440, 7.671899, 1.384026>
    }
    triangle {
      < -1.013992, 7.843918, 1.540775>,
      < -1.060592, 7.804728, 1.966757>,
      < -1.138348, 7.745724, 1.881467>
    }
    triangle {
      < -1.013992, 7.843918, 1.540775>,
      < -1.138348, 7.745724, 1.881467>,
      < -1.063235, 7.760682, 1.524284>
    }
    triangle {
      < -0.889687, 7.871883, 1.691399>,
      < -0.932368, 7.861390, 2.048698>,
      < -1.060592, 7.804728, 1.966757>
    }
    triangle {
      < -0.889687, 7.871883, 1.691399>,
      < -1.060592, 7.804728, 1.966757>,
      < -1.013992, 7.843918, 1.540775>
    }
    triangle {
      < -0.717503, 7.892157, 1.751828>,
      < -0.760872, 7.878096, 2.044034>,
      < -0.932368, 7.861390, 2.048698>
    }
    triangle {
      < -0.717503, 7.892157, 1.751828>,
      < -0.932368, 7.861390, 2.048698>,
      < -0.889687, 7.871883, 1.691399>
    }
    triangle {
      < -0.591037, 7.864429, 1.782977>,
      < -0.628197, 7.862329, 1.999484>,
      < -0.760872, 7.878096, 2.044034>
    }
    triangle {
      < -0.591037, 7.864429, 1.782977>,
      < -0.760872, 7.878096, 2.044034>,
      < -0.717503, 7.892157, 1.751828>
    }
    triangle {
      < -0.491586, 7.802804, 1.763913>,
      < -0.507243, 7.816108, 1.909368>,
      < -0.628197, 7.862329, 1.999484>
    }
    triangle {
      < -0.491586, 7.802804, 1.763913>,
      < -0.628197, 7.862329, 1.999484>,
      < -0.591037, 7.864429, 1.782977>
    }
    triangle {
      < -0.420309, 7.701636, 1.819372>,
      < -0.507243, 7.816108, 1.909368>,
      < -0.491586, 7.802804, 1.763913>
    }
    triangle {
      < -0.420309, 7.701636, 1.819372>,
      < -0.491586, 7.802804, 1.763913>,
      < -0.443239, 7.754848, 1.756084>
    }
    triangle {
      < -0.421266, 7.715384, 1.824796>,
      < -0.494802, 7.844838, 1.903134>,
      < -0.505429, 7.826012, 1.931554>
    }
    triangle {
      < -0.494802, 7.844838, 1.903134>,
      < -0.589018, 7.915383, 1.940367>,
      < -0.608820, 7.884941, 2.001511>
    }
    triangle {
      < -0.494802, 7.844838, 1.903134>,
      < -0.608820, 7.884941, 2.001511>,
      < -0.505429, 7.826012, 1.931554>
    }
    triangle {
      < -0.589018, 7.915383, 1.940367>,
      < -0.707084, 7.951528, 1.950182>,
      < -0.738160, 7.909727, 2.052032>
    }
    triangle {
      < -0.589018, 7.915383, 1.940367>,
      < -0.738160, 7.909727, 2.052032>,
      < -0.608820, 7.884941, 2.001511>
    }
    triangle {
      < -0.707084, 7.951528, 1.950182>,
      < -0.947594, 7.934773, 1.906125>,
      < -0.937265, 7.893220, 2.055827>
    }
    triangle {
      < -0.707084, 7.951528, 1.950182>,
      < -0.937265, 7.893220, 2.055827>,
      < -0.738160, 7.909727, 2.052032>
    }
    triangle {
      < -0.947594, 7.934773, 1.906125>,
      < -1.057697, 7.885696, 1.814647>,
      < -1.069781, 7.824396, 1.948702>
    }
    triangle {
      < -0.947594, 7.934773, 1.906125>,
      < -1.069781, 7.824396, 1.948702>,
      < -0.937265, 7.893220, 2.055827>
    }
    triangle {
      < -1.057697, 7.885696, 1.814647>,
      < -1.137249, 7.793068, 1.671500>,
      < -1.148209, 7.762268, 1.851506>
    }
    triangle {
      < -1.057697, 7.885696, 1.814647>,
      < -1.148209, 7.762268, 1.851506>,
      < -1.069781, 7.824396, 1.948702>
    }
    triangle {
      < -1.137249, 7.793068, 1.671500>,
      < -1.183912, 7.723730, 1.527919>,
      < -1.205264, 7.688103, 1.703732>
    }
    triangle {
      < -1.137249, 7.793068, 1.671500>,
      < -1.205264, 7.688103, 1.703732>,
      < -1.148209, 7.762268, 1.851506>
    }
    triangle {
      < -1.183912, 7.723730, 1.527919>,
      < -1.190138, 7.595891, 1.288325>,
      < -1.226924, 7.611438, 1.536010>
    }
    triangle {
      < -1.183912, 7.723730, 1.527919>,
      < -1.226924, 7.611438, 1.536010>,
      < -1.205264, 7.688103, 1.703732>
    }
    triangle {
      < -1.190138, 7.595891, 1.288325>,
      < -1.177549, 7.502185, 1.213440>,
      < -1.221656, 7.535584, 1.310366>
    }
    triangle {
      < -1.190138, 7.595891, 1.288325>,
      < -1.221656, 7.535584, 1.310366>,
      < -1.226924, 7.611438, 1.536010>
    }
    triangle {
      < -1.177549, 7.502185, 1.213440>,
      < -1.172679, 7.476350, 1.209460>,
      < -1.217879, 7.502439, 1.321256>
    }
    triangle {
      < -1.177549, 7.502185, 1.213440>,
      < -1.217879, 7.502439, 1.321256>,
      < -1.221656, 7.535584, 1.310366>
    }
    triangle {
      < -1.125417, 7.594946, 1.294461>,
      < -1.217140, 7.601475, 1.575520>,
      < -1.217879, 7.502439, 1.321256>
    }
    triangle {
      < -1.125417, 7.594946, 1.294461>,
      < -1.217879, 7.502439, 1.321256>,
      < -1.172679, 7.476350, 1.209460>
    }
    triangle {
      < -1.125417, 7.594946, 1.294461>,
      < -1.172679, 7.476350, 1.209460>,
      < -1.118055, 7.492085, 1.170550>
    }
    triangle {
      < -1.105440, 7.671899, 1.384026>,
      < -1.199642, 7.673470, 1.737281>,
      < -1.217140, 7.601475, 1.575520>
    }
    triangle {
      < -1.105440, 7.671899, 1.384026>,
      < -1.217140, 7.601475, 1.575520>,
      < -1.125417, 7.594946, 1.294461>
    }
    triangle {
      < -0.507243, 7.816108, 1.909368>,
      < -0.420309, 7.701636, 1.819372>,
      < -0.421266, 7.715384, 1.824796>
    }
    triangle {
      < -0.507243, 7.816108, 1.909368>,
      < -0.421266, 7.715384, 1.824796>,
      < -0.505429, 7.826012, 1.931554>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < -1.152053, 7.377617, 1.209565>,
      < -1.172679, 7.476350, 1.209460>,
      < -1.181628, 7.493562, 1.203781>
    }
    triangle {
      < -1.061896, 7.223755, 1.329039>,
      < -0.995386, 7.168216, 1.444232>,
      < -0.948267, 7.196994, 1.395385>
    }
    triangle {
      < -1.061896, 7.223755, 1.329039>,
      < -0.948267, 7.196994, 1.395385>,
      < -1.011962, 7.250182, 1.285068>
    }
    triangle {
      < -0.995386, 7.168216, 1.444232>,
      < -0.883035, 7.151428, 1.545997>,
      < -0.840671, 7.180917, 1.492842>
    }
    triangle {
      < -0.995386, 7.168216, 1.444232>,
      < -0.840671, 7.180917, 1.492842>,
      < -0.948267, 7.196994, 1.395385>
    }
    triangle {
      < -0.883035, 7.151428, 1.545997>,
      < -0.772975, 7.160594, 1.638789>,
      < -0.735270, 7.189694, 1.581706>
    }
    triangle {
      < -0.883035, 7.151428, 1.545997>,
      < -0.735270, 7.189694, 1.581706>,
      < -0.840671, 7.180917, 1.492842>
    }
    triangle {
      < -0.772975, 7.160594, 1.638789>,
      < -0.654784, 7.207671, 1.729157>,
      < -0.622082, 7.234779, 1.668249>
    }
    triangle {
      < -0.772975, 7.160594, 1.638789>,
      < -0.622082, 7.234779, 1.668249>,
      < -0.735270, 7.189694, 1.581706>
    }
    triangle {
      < -0.654784, 7.207671, 1.729157>,
      < -0.523796, 7.315795, 1.789738>,
      < -0.496639, 7.338326, 1.726266>
    }
    triangle {
      < -0.654784, 7.207671, 1.729157>,
      < -0.496639, 7.338326, 1.726266>,
      < -0.622082, 7.234779, 1.668249>
    }
    triangle {
      < -0.523796, 7.315795, 1.789738>,
      < -0.451272, 7.419964, 1.813993>,
      < -0.427185, 7.438086, 1.749493>
    }
    triangle {
      < -0.523796, 7.315795, 1.789738>,
      < -0.427185, 7.438086, 1.749493>,
      < -0.496639, 7.338326, 1.726266>
    }
    triangle {
      < -0.451272, 7.419964, 1.813993>,
      < -0.424517, 7.538349, 1.816898>,
      < -0.401563, 7.551459, 1.752276>
    }
    triangle {
      < -0.451272, 7.419964, 1.813993>,
      < -0.401563, 7.551459, 1.752276>,
      < -0.427185, 7.438086, 1.749493>
    }
    triangle {
      < -0.424517, 7.538349, 1.816898>,
      < -0.416886, 7.691145, 1.819102>,
      < -0.394255, 7.697788, 1.754387>
    }
    triangle {
      < -0.424517, 7.538349, 1.816898>,
      < -0.394255, 7.697788, 1.754387>,
      < -0.401563, 7.551459, 1.752276>
    }
    triangle {
      < -0.416886, 7.691145, 1.819102>,
      < -0.420309, 7.701636, 1.819372>,
      < -0.443239, 7.754848, 1.756084>
    }
    triangle {
      < -0.416886, 7.691145, 1.819102>,
      < -0.443239, 7.754848, 1.756084>,
      < -0.394255, 7.697788, 1.754387>
    }
    triangle {
      < -1.172679, 7.476350, 1.209460>,
      < -1.152053, 7.377617, 1.209565>,
      < -1.098302, 7.397531, 1.170651>
    }
    triangle {
      < -1.172679, 7.476350, 1.209460>,
      < -1.098302, 7.397531, 1.170651>,
      < -1.118055, 7.492085, 1.170550>
    }
    triangle {
      < -1.152053, 7.377617, 1.209565>,
      < -1.113253, 7.297450, 1.266328>,
      < -1.061145, 7.320757, 1.225011>
    }
    triangle {
      < -1.152053, 7.377617, 1.209565>,
      < -1.061145, 7.320757, 1.225011>,
      < -1.098302, 7.397531, 1.170651>
    }
    triangle {
      < -1.113253, 7.297450, 1.266328>,
      < -1.061896, 7.223755, 1.329039>,
      < -1.011962, 7.250182, 1.285068>
    }
    triangle {
      < -1.113253, 7.297450, 1.266328>,
      < -1.011962, 7.250182, 1.285068>,
      < -1.061145, 7.320757, 1.225011>
    }
    texture {face}
  }
  // white
  union {
    triangle {
      < -1.118055, 7.492085, 1.170550>,
      < -1.098302, 7.397531, 1.170651>,
      < -1.015349, 7.592010, 1.399268>
    }
    triangle {
      < -1.118055, 7.492085, 1.170550>,
      < -1.015349, 7.592010, 1.399268>,
      < -1.019243, 7.647663, 1.402761>
    }
    triangle {
      < -1.098302, 7.397531, 1.170651>,
      < -1.061145, 7.320757, 1.225011>,
      < -1.004205, 7.535050, 1.400969>
    }
    triangle {
      < -1.098302, 7.397531, 1.170651>,
      < -1.004205, 7.535050, 1.400969>,
      < -1.015349, 7.592010, 1.399268>
    }
    triangle {
      < -1.061145, 7.320757, 1.225011>,
      < -1.011962, 7.250182, 1.285068>,
      < -0.979657, 7.472168, 1.411874>
    }
    triangle {
      < -1.061145, 7.320757, 1.225011>,
      < -0.979657, 7.472168, 1.411874>,
      < -1.004205, 7.535050, 1.400969>
    }
    triangle {
      < -1.011962, 7.250182, 1.285068>,
      < -0.948267, 7.196994, 1.395385>,
      < -0.928312, 7.399922, 1.441460>
    }
    triangle {
      < -1.011962, 7.250182, 1.285068>,
      < -0.928312, 7.399922, 1.441460>,
      < -0.979657, 7.472168, 1.411874>
    }
    triangle {
      < -0.948267, 7.196994, 1.395385>,
      < -0.840671, 7.180917, 1.492842>,
      < -0.836103, 7.338300, 1.502381>
    }
    triangle {
      < -0.948267, 7.196994, 1.395385>,
      < -0.836103, 7.338300, 1.502381>,
      < -0.928312, 7.399922, 1.441460>
    }
    triangle {
      < -0.840671, 7.180917, 1.492842>,
      < -0.735270, 7.189694, 1.581706>,
      < -0.722661, 7.329017, 1.584938>
    }
    triangle {
      < -0.840671, 7.180917, 1.492842>,
      < -0.722661, 7.329017, 1.584938>,
      < -0.836103, 7.338300, 1.502381>
    }
    triangle {
      < -0.735270, 7.189694, 1.581706>,
      < -0.622082, 7.234779, 1.668249>,
      < -0.613150, 7.390597, 1.672701>
    }
    triangle {
      < -0.735270, 7.189694, 1.581706>,
      < -0.613150, 7.390597, 1.672701>,
      < -0.722661, 7.329017, 1.584938>
    }
    triangle {
      < -0.622082, 7.234779, 1.668249>,
      < -0.496639, 7.338326, 1.726266>,
      < -0.544075, 7.512550, 1.737560>
    }
    triangle {
      < -0.622082, 7.234779, 1.668249>,
      < -0.544075, 7.512550, 1.737560>,
      < -0.613150, 7.390597, 1.672701>
    }
    triangle {
      < -0.496639, 7.338326, 1.726266>,
      < -0.427185, 7.438086, 1.749493>,
      < -0.532773, 7.604802, 1.756439>
    }
    triangle {
      < -0.496639, 7.338326, 1.726266>,
      < -0.532773, 7.604802, 1.756439>,
      < -0.544075, 7.512550, 1.737560>
    }
    triangle {
      < -0.427185, 7.438086, 1.749493>,
      < -0.401563, 7.551459, 1.752276>,
      < -0.543324, 7.687379, 1.758104>
    }
    triangle {
      < -0.427185, 7.438086, 1.749493>,
      < -0.543324, 7.687379, 1.758104>,
      < -0.532773, 7.604802, 1.756439>
    }
    triangle {
      < -0.401563, 7.551459, 1.752276>,
      < -0.394255, 7.697788, 1.754387>,
      < -0.575525, 7.773652, 1.758058>
    }
    triangle {
      < -0.401563, 7.551459, 1.752276>,
      < -0.575525, 7.773652, 1.758058>,
      < -0.543324, 7.687379, 1.758104>
    }
    triangle {
      < -0.394255, 7.697788, 1.754387>,
      < -0.443239, 7.754848, 1.756084>,
      < -0.595789, 7.809468, 1.761040>
    }
    triangle {
      < -0.394255, 7.697788, 1.754387>,
      < -0.595789, 7.809468, 1.761040>,
      < -0.575525, 7.773652, 1.758058>
    }
    triangle {
      < -0.443239, 7.754848, 1.756084>,
      < -0.491586, 7.802804, 1.763913>,
      < -0.616873, 7.837595, 1.764843>
    }
    triangle {
      < -0.443239, 7.754848, 1.756084>,
      < -0.616873, 7.837595, 1.764843>,
      < -0.595789, 7.809468, 1.761040>
    }
    triangle {
      < -0.491586, 7.802804, 1.763913>,
      < -0.591037, 7.864429, 1.782977>,
      < -0.656399, 7.872271, 1.761561>
    }
    triangle {
      < -0.491586, 7.802804, 1.763913>,
      < -0.656399, 7.872271, 1.761561>,
      < -0.616873, 7.837595, 1.764843>
    }
    triangle {
      < -1.105440, 7.671899, 1.384026>,
      < -1.125417, 7.594946, 1.294461>,
      < -1.014899, 7.713530, 1.413494>
    }
    triangle {
      < -1.105440, 7.671899, 1.384026>,
      < -1.014899, 7.713530, 1.413494>,
      < -0.994898, 7.771222, 1.434833>
    }
    triangle {
      < -1.125417, 7.594946, 1.294461>,
      < -1.118055, 7.492085, 1.170550>,
      < -1.019243, 7.647663, 1.402761>
    }
    triangle {
      < -1.125417, 7.594946, 1.294461>,
      < -1.019243, 7.647663, 1.402761>,
      < -1.014899, 7.713530, 1.413494>
    }
    triangle {
      < -0.717503, 7.892157, 1.751828>,
      < -0.656399, 7.872271, 1.761561>,
      < -0.591037, 7.864429, 1.782977>
    }
    triangle {
      < -1.063235, 7.760682, 1.524284>,
      < -0.994898, 7.771222, 1.434833>,
      < -1.013992, 7.843918, 1.540775>
    }
    texture {white}
  }
  // pupil
  union {
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.818944, 7.789495, 1.672746>,
      < -0.842403, 7.787000, 1.655058>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.842403, 7.787000, 1.655058>,
      < -0.889972, 7.766613, 1.614091>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.889972, 7.766613, 1.614091>,
      < -0.917461, 7.731203, 1.582556>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.917461, 7.731203, 1.582556>,
      < -0.930311, 7.659766, 1.549553>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.930311, 7.659766, 1.549553>,
      < -0.926413, 7.626187, 1.541182>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.926413, 7.626187, 1.541182>,
      < -0.918499, 7.599118, 1.537862>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.918499, 7.599118, 1.537862>,
      < -0.906489, 7.573089, 1.537832>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.906489, 7.573089, 1.537832>,
      < -0.888326, 7.546027, 1.541881>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.888326, 7.546027, 1.541881>,
      < -0.858262, 7.516508, 1.553663>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.858262, 7.516508, 1.553663>,
      < -0.811886, 7.492251, 1.578918>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.811886, 7.492251, 1.578918>,
      < -0.759238, 7.488568, 1.615526>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.759238, 7.488568, 1.615526>,
      < -0.709400, 7.513154, 1.659521>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.709400, 7.513154, 1.659521>,
      < -0.677384, 7.565431, 1.699922>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.677384, 7.565431, 1.699922>,
      < -0.671052, 7.607735, 1.718547>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.671052, 7.607735, 1.718547>,
      < -0.675565, 7.648775, 1.728959>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.675565, 7.648775, 1.728959>,
      < -0.691969, 7.695099, 1.732584>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.691969, 7.695099, 1.732584>,
      < -0.712901, 7.728924, 1.728796>
    }
    triangle {
      < -0.774665, 7.778907, 1.701043>,
      < -0.712901, 7.728924, 1.728796>,
      < -0.734636, 7.753027, 1.721197>
    }
    texture {pupil}
  }
  // iris
  union {
    triangle {
      < -1.013992, 7.843918, 1.540775>,
      < -0.889972, 7.766613, 1.614091>,
      < -0.842403, 7.787000, 1.655058>
    }
    triangle {
      < -1.013992, 7.843918, 1.540775>,
      < -0.842403, 7.787000, 1.655058>,
      < -0.889687, 7.871883, 1.691399>
    }
    triangle {
      < -0.994898, 7.771222, 1.434833>,
      < -1.014899, 7.713530, 1.413494>,
      < -0.930311, 7.659766, 1.549553>
    }
    triangle {
      < -0.994898, 7.771222, 1.434833>,
      < -0.930311, 7.659766, 1.549553>,
      < -0.917461, 7.731203, 1.582556>
    }
    triangle {
      < -1.014899, 7.713530, 1.413494>,
      < -1.019243, 7.647663, 1.402761>,
      < -0.926413, 7.626187, 1.541182>
    }
    triangle {
      < -1.014899, 7.713530, 1.413494>,
      < -0.926413, 7.626187, 1.541182>,
      < -0.930311, 7.659766, 1.549553>
    }
    triangle {
      < -1.019243, 7.647663, 1.402761>,
      < -1.015349, 7.592010, 1.399268>,
      < -0.918499, 7.599118, 1.537862>
    }
    triangle {
      < -1.019243, 7.647663, 1.402761>,
      < -0.918499, 7.599118, 1.537862>,
      < -0.926413, 7.626187, 1.541182>
    }
    triangle {
      < -1.015349, 7.592010, 1.399268>,
      < -1.004205, 7.535050, 1.400969>,
      < -0.906489, 7.573089, 1.537832>
    }
    triangle {
      < -1.015349, 7.592010, 1.399268>,
      < -0.906489, 7.573089, 1.537832>,
      < -0.918499, 7.599118, 1.537862>
    }
    triangle {
      < -1.004205, 7.535050, 1.400969>,
      < -0.979657, 7.472168, 1.411874>,
      < -0.888326, 7.546027, 1.541881>
    }
    triangle {
      < -1.004205, 7.535050, 1.400969>,
      < -0.888326, 7.546027, 1.541881>,
      < -0.906489, 7.573089, 1.537832>
    }
    triangle {
      < -0.979657, 7.472168, 1.411874>,
      < -0.928312, 7.399922, 1.441460>,
      < -0.858262, 7.516508, 1.553663>
    }
    triangle {
      < -0.979657, 7.472168, 1.411874>,
      < -0.858262, 7.516508, 1.553663>,
      < -0.888326, 7.546027, 1.541881>
    }
    triangle {
      < -0.928312, 7.399922, 1.441460>,
      < -0.836103, 7.338300, 1.502381>,
      < -0.811886, 7.492251, 1.578918>
    }
    triangle {
      < -0.928312, 7.399922, 1.441460>,
      < -0.811886, 7.492251, 1.578918>,
      < -0.858262, 7.516508, 1.553663>
    }
    triangle {
      < -0.836103, 7.338300, 1.502381>,
      < -0.722661, 7.329017, 1.584938>,
      < -0.759238, 7.488568, 1.615526>
    }
    triangle {
      < -0.836103, 7.338300, 1.502381>,
      < -0.759238, 7.488568, 1.615526>,
      < -0.811886, 7.492251, 1.578918>
    }
    triangle {
      < -0.722661, 7.329017, 1.584938>,
      < -0.613150, 7.390597, 1.672701>,
      < -0.709400, 7.513154, 1.659521>
    }
    triangle {
      < -0.722661, 7.329017, 1.584938>,
      < -0.709400, 7.513154, 1.659521>,
      < -0.759238, 7.488568, 1.615526>
    }
    triangle {
      < -0.613150, 7.390597, 1.672701>,
      < -0.544075, 7.512550, 1.737560>,
      < -0.677384, 7.565431, 1.699922>
    }
    triangle {
      < -0.613150, 7.390597, 1.672701>,
      < -0.677384, 7.565431, 1.699922>,
      < -0.709400, 7.513154, 1.659521>
    }
    triangle {
      < -0.544075, 7.512550, 1.737560>,
      < -0.532773, 7.604802, 1.756439>,
      < -0.671052, 7.607735, 1.718547>
    }
    triangle {
      < -0.544075, 7.512550, 1.737560>,
      < -0.671052, 7.607735, 1.718547>,
      < -0.677384, 7.565431, 1.699922>
    }
    triangle {
      < -0.532773, 7.604802, 1.756439>,
      < -0.543324, 7.687379, 1.758104>,
      < -0.675565, 7.648775, 1.728959>
    }
    triangle {
      < -0.532773, 7.604802, 1.756439>,
      < -0.675565, 7.648775, 1.728959>,
      < -0.671052, 7.607735, 1.718547>
    }
    triangle {
      < -0.543324, 7.687379, 1.758104>,
      < -0.575525, 7.773652, 1.758058>,
      < -0.691969, 7.695099, 1.732584>
    }
    triangle {
      < -0.543324, 7.687379, 1.758104>,
      < -0.691969, 7.695099, 1.732584>,
      < -0.675565, 7.648775, 1.728959>
    }
    triangle {
      < -0.575525, 7.773652, 1.758058>,
      < -0.595789, 7.809468, 1.761040>,
      < -0.712901, 7.728924, 1.728796>
    }
    triangle {
      < -0.575525, 7.773652, 1.758058>,
      < -0.712901, 7.728924, 1.728796>,
      < -0.691969, 7.695099, 1.732584>
    }
    triangle {
      < -0.595789, 7.809468, 1.761040>,
      < -0.616873, 7.837595, 1.764843>,
      < -0.734636, 7.753027, 1.721197>
    }
    triangle {
      < -0.595789, 7.809468, 1.761040>,
      < -0.734636, 7.753027, 1.721197>,
      < -0.712901, 7.728924, 1.728796>
    }
    triangle {
      < -0.616873, 7.837595, 1.764843>,
      < -0.656399, 7.872271, 1.761561>,
      < -0.774665, 7.778907, 1.701043>
    }
    triangle {
      < -0.616873, 7.837595, 1.764843>,
      < -0.774665, 7.778907, 1.701043>,
      < -0.734636, 7.753027, 1.721197>
    }
    triangle {
      < -0.656399, 7.872271, 1.761561>,
      < -0.717503, 7.892157, 1.751828>,
      < -0.818944, 7.789495, 1.672746>
    }
    triangle {
      < -0.656399, 7.872271, 1.761561>,
      < -0.818944, 7.789495, 1.672746>,
      < -0.774665, 7.778907, 1.701043>
    }
    triangle {
      < -0.717503, 7.892157, 1.751828>,
      < -0.889687, 7.871883, 1.691399>,
      < -0.842403, 7.787000, 1.655058>
    }
    triangle {
      < -0.717503, 7.892157, 1.751828>,
      < -0.842403, 7.787000, 1.655058>,
      < -0.818944, 7.789495, 1.672746>
    }
    triangle {
      < -0.889972, 7.766613, 1.614091>,
      < -1.013992, 7.843918, 1.540775>,
      < -0.994898, 7.771222, 1.434833>
    }
    triangle {
      < -0.889972, 7.766613, 1.614091>,
      < -0.994898, 7.771222, 1.434833>,
      < -0.917461, 7.731203, 1.582556>
    }
    texture {iris}
  }
  // brow
  union {
    triangle {
      < 1.409607, 7.862576, 1.257887>,
      < 1.388592, 8.182241, 1.451023>,
      < 1.357290, 8.101020, 1.469618>
    }
    texture {brow}
  }
  // face
  union {
    triangle {
      < 1.405386, 7.700283, 1.147116>,
      < 1.671171, 7.887857, 0.950860>,
      < 1.627951, 8.161976, 1.121192>
    }
    triangle {
      < 1.405386, 7.700283, 1.147116>,
      < 1.627951, 8.161976, 1.121192>,
      < 1.409607, 7.862576, 1.257887>
    }
    triangle {
      < 1.408726, 7.507695, 1.076182>,
      < 1.643261, 7.568371, 0.779994>,
      < 1.671171, 7.887857, 0.950860>
    }
    triangle {
      < 1.408726, 7.507695, 1.076182>,
      < 1.671171, 7.887857, 0.950860>,
      < 1.405386, 7.700283, 1.147116>
    }
    triangle {
      < 1.399494, 7.234042, 1.061630>,
      < 1.605012, 7.227119, 0.718601>,
      < 1.643261, 7.568371, 0.779994>
    }
    triangle {
      < 1.399494, 7.234042, 1.061630>,
      < 1.643261, 7.568371, 0.779994>,
      < 1.408726, 7.507695, 1.076182>
    }
    triangle {
      < 1.589390, 7.029233, 0.920003>,
      < 1.605012, 7.227119, 0.718601>,
      < 1.399494, 7.234042, 1.061630>
    }
    triangle {
      < 1.399494, 7.234042, 1.061630>,
      < 1.387584, 7.136969, 1.118825>,
      < 1.574759, 6.922855, 1.114138>
    }
    triangle {
      < 1.399494, 7.234042, 1.061630>,
      < 1.574759, 6.922855, 1.114138>,
      < 1.589390, 7.029233, 0.920003>
    }
    triangle {
      < 1.280479, 7.023159, 1.386668>,
      < 1.478820, 6.789691, 1.350577>,
      < 1.574759, 6.922855, 1.114138>
    }
    triangle {
      < 1.280479, 7.023159, 1.386668>,
      < 1.574759, 6.922855, 1.114138>,
      < 1.387584, 7.136969, 1.118825>
    }
    triangle {
      < 1.198544, 6.961119, 1.558410>,
      < 1.335770, 6.729196, 1.536853>,
      < 1.478820, 6.789691, 1.350577>
    }
    triangle {
      < 1.198544, 6.961119, 1.558410>,
      < 1.478820, 6.789691, 1.350577>,
      < 1.280479, 7.023159, 1.386668>
    }
    triangle {
      < 1.118692, 6.924029, 1.657216>,
      < 1.135794, 6.699510, 1.720270>,
      < 1.335770, 6.729196, 1.536853>
    }
    triangle {
      < 1.118692, 6.924029, 1.657216>,
      < 1.335770, 6.729196, 1.536853>,
      < 1.198544, 6.961119, 1.558410>
    }
    triangle {
      < 0.951037, 6.754210, 1.815196>,
      < 1.135794, 6.699510, 1.720270>,
      < 1.118692, 6.924029, 1.657216>
    }
    triangle {
      < 0.951037, 6.754210, 1.815196>,
      < 1.118692, 6.924029, 1.657216>,
      < 0.951907, 6.931507, 1.737461>
    }
    triangle {
      < 0.719866, 7.048229, 1.813486>,
      < 0.662825, 6.855032, 1.902023>,
      < 0.951037, 6.754210, 1.815196>
    }
    triangle {
      < 0.719866, 7.048229, 1.813486>,
      < 0.951037, 6.754210, 1.815196>,
      < 0.951907, 6.931507, 1.737461>
    }
    triangle {
      < 0.521476, 7.142691, 1.913740>,
      < 0.447231, 6.990836, 2.011483>,
      < 0.449960, 6.979241, 2.004734>
    }
    triangle {
      < 0.521476, 7.142691, 1.913740>,
      < 0.449960, 6.979241, 2.004734>,
      < 0.662825, 6.855032, 1.902023>
    }
    triangle {
      < 0.521476, 7.142691, 1.913740>,
      < 0.662825, 6.855032, 1.902023>,
      < 0.719866, 7.048229, 1.813486>
    }
    triangle {
      < 0.387626, 7.321533, 1.906235>,
      < 0.354659, 7.089078, 2.130837>,
      < 0.442106, 6.988012, 2.018156>
    }
    triangle {
      < 0.387626, 7.321533, 1.906235>,
      < 0.442106, 6.988012, 2.018156>,
      < 0.447231, 6.990836, 2.011483>
    }
    triangle {
      < 0.387626, 7.321533, 1.906235>,
      < 0.447231, 6.990836, 2.011483>,
      < 0.521476, 7.142691, 1.913740>
    }
    triangle {
      < 0.157000, 7.376499, 2.096611>,
      < 0.153202, 7.152060, 2.290502>,
      < 0.354659, 7.089078, 2.130837>
    }
    triangle {
      < 0.157000, 7.376499, 2.096611>,
      < 0.354659, 7.089078, 2.130837>,
      < 0.387626, 7.321533, 1.906235>
    }
    triangle {
      < 0.000000, 7.409155, 2.088706>,
      < 0.000000, 7.193865, 2.291512>,
      < 0.153202, 7.152060, 2.290502>
    }
    triangle {
      < 0.000000, 7.409155, 2.088706>,
      < 0.153202, 7.152060, 2.290502>,
      < 0.157000, 7.376499, 2.096611>
    }
    triangle {
      < 0.157000, 7.376499, 2.096611>,
      < 0.157640, 7.519312, 1.979869>,
      < 0.000000, 7.533475, 1.994006>
    }
    triangle {
      < 0.157000, 7.376499, 2.096611>,
      < 0.000000, 7.533475, 1.994006>,
      < 0.000000, 7.409155, 2.088706>
    }
    triangle {
      < 0.387626, 7.321533, 1.906235>,
      < 0.304954, 7.487044, 1.942316>,
      < 0.157640, 7.519312, 1.979869>
    }
    triangle {
      < 0.387626, 7.321533, 1.906235>,
      < 0.157640, 7.519312, 1.979869>,
      < 0.157000, 7.376499, 2.096611>
    }
    triangle {
      < 0.451272, 7.419964, 1.813993>,
      < 0.424517, 7.538349, 1.816898>,
      < 0.304954, 7.487044, 1.942316>
    }
    triangle {
      < 0.451272, 7.419964, 1.813993>,
      < 0.304954, 7.487044, 1.942316>,
      < 0.387626, 7.321533, 1.906235>
    }
    triangle {
      < 0.387626, 7.321533, 1.906235>,
      < 0.521476, 7.142691, 1.913740>,
      < 0.523796, 7.315795, 1.789738>
    }
    triangle {
      < 0.387626, 7.321533, 1.906235>,
      < 0.523796, 7.315795, 1.789738>,
      < 0.451272, 7.419964, 1.813993>
    }
    triangle {
      < 0.719866, 7.048229, 1.813486>,
      < 0.654784, 7.207671, 1.729157>,
      < 0.523796, 7.315795, 1.789738>
    }
    triangle {
      < 0.719866, 7.048229, 1.813486>,
      < 0.523796, 7.315795, 1.789738>,
      < 0.521476, 7.142691, 1.913740>
    }
    triangle {
      < 0.951907, 6.931507, 1.737461>,
      < 0.772975, 7.160594, 1.638789>,
      < 0.654784, 7.207671, 1.729157>
    }
    triangle {
      < 0.951907, 6.931507, 1.737461>,
      < 0.654784, 7.207671, 1.729157>,
      < 0.719866, 7.048229, 1.813486>
    }
    triangle {
      < 1.198544, 6.961119, 1.558410>,
      < 0.995386, 7.168216, 1.444232>,
      < 0.883035, 7.151428, 1.545997>
    }
    triangle {
      < 1.198544, 6.961119, 1.558410>,
      < 0.883035, 7.151428, 1.545997>,
      < 1.118692, 6.924029, 1.657216>
    }
    triangle {
      < 1.280479, 7.023159, 1.386668>,
      < 1.061896, 7.223755, 1.329039>,
      < 0.995386, 7.168216, 1.444232>
    }
    triangle {
      < 1.280479, 7.023159, 1.386668>,
      < 0.995386, 7.168216, 1.444232>,
      < 1.198544, 6.961119, 1.558410>
    }
    triangle {
      < 0.503766, 8.017214, 1.905862>,
      < 0.467566, 8.143847, 1.989871>,
      < 0.352145, 7.886268, 1.969402>
    }
    triangle {
      < 0.503766, 8.017214, 1.905862>,
      < 0.352145, 7.886268, 1.969402>,
      < 0.426586, 7.851128, 1.845632>
    }
    triangle {
      < 0.674197, 8.108939, 1.873312>,
      < 0.668233, 8.257164, 1.947022>,
      < 0.467566, 8.143847, 1.989871>
    }
    triangle {
      < 0.674197, 8.108939, 1.873312>,
      < 0.467566, 8.143847, 1.989871>,
      < 0.503766, 8.017214, 1.905862>
    }
    triangle {
      < 0.857921, 8.152600, 1.795877>,
      < 0.906598, 8.304548, 1.847251>,
      < 0.668233, 8.257164, 1.947022>
    }
    triangle {
      < 0.857921, 8.152600, 1.795877>,
      < 0.668233, 8.257164, 1.947022>,
      < 0.674197, 8.108939, 1.873312>
    }
    triangle {
      < 1.044607, 8.070682, 1.641520>,
      < 1.157783, 8.273422, 1.698323>,
      < 0.906598, 8.304548, 1.847251>
    }
    triangle {
      < 1.044607, 8.070682, 1.641520>,
      < 0.906598, 8.304548, 1.847251>,
      < 0.857921, 8.152600, 1.795877>
    }
    triangle {
      < 1.143256, 7.950388, 1.448727>,
      < 1.357290, 8.101020, 1.469618>,
      < 1.157783, 8.273422, 1.698323>
    }
    triangle {
      < 1.143256, 7.950388, 1.448727>,
      < 1.157783, 8.273422, 1.698323>,
      < 1.044607, 8.070682, 1.641520>
    }
    triangle {
      < 1.228102, 7.784869, 1.308105>,
      < 1.409607, 7.862576, 1.257887>,
      < 1.357290, 8.101020, 1.469618>
    }
    triangle {
      < 1.228102, 7.784869, 1.308105>,
      < 1.357290, 8.101020, 1.469618>,
      < 1.143256, 7.950388, 1.448727>
    }
    triangle {
      < 1.228105, 7.667838, 1.228434>,
      < 1.405386, 7.700283, 1.147116>,
      < 1.409607, 7.862576, 1.257887>
    }
    triangle {
      < 1.228105, 7.667838, 1.228434>,
      < 1.409607, 7.862576, 1.257887>,
      < 1.228102, 7.784869, 1.308105>
    }
    triangle {
      < 1.181628, 7.493562, 1.203781>,
      < 1.408726, 7.507695, 1.076182>,
      < 1.405386, 7.700283, 1.147116>
    }
    triangle {
      < 1.181628, 7.493562, 1.203781>,
      < 1.405386, 7.700283, 1.147116>,
      < 1.228105, 7.667838, 1.228434>
    }
    triangle {
      < 0.707084, 7.951528, 1.950182>,
      < 0.676756, 8.098582, 1.873053>,
      < 0.510838, 8.009660, 1.903327>
    }
    triangle {
      < 0.707084, 7.951528, 1.950182>,
      < 0.510838, 8.009660, 1.903327>,
      < 0.589018, 7.915383, 1.940367>
    }
    texture {face}
  }
  // lash
  union {
    triangle {
      < 1.217879, 7.502439, 1.321256>,
      < 1.221656, 7.535584, 1.310366>,
      < 1.226924, 7.611438, 1.536010>
    }
    triangle {
      < 1.217879, 7.502439, 1.321256>,
      < 1.226924, 7.611438, 1.536010>,
      < 1.217140, 7.601475, 1.575520>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < 0.947594, 7.934773, 1.906125>,
      < 0.858304, 8.142274, 1.796644>,
      < 0.676756, 8.098582, 1.873053>
    }
    triangle {
      < 0.947594, 7.934773, 1.906125>,
      < 0.676756, 8.098582, 1.873053>,
      < 0.707084, 7.951528, 1.950182>
    }
    triangle {
      < 1.057697, 7.885696, 1.814647>,
      < 1.042285, 8.061223, 1.643898>,
      < 0.858304, 8.142274, 1.796644>
    }
    triangle {
      < 1.057697, 7.885696, 1.814647>,
      < 0.858304, 8.142274, 1.796644>,
      < 0.947594, 7.934773, 1.906125>
    }
    triangle {
      < 1.137249, 7.793068, 1.671500>,
      < 1.138931, 7.943057, 1.452462>,
      < 1.042285, 8.061223, 1.643898>
    }
    triangle {
      < 1.137249, 7.793068, 1.671500>,
      < 1.042285, 8.061223, 1.643898>,
      < 1.057697, 7.885696, 1.814647>
    }
    triangle {
      < 1.183912, 7.723730, 1.527919>,
      < 1.222239, 7.779233, 1.314082>,
      < 1.138931, 7.943057, 1.452462>
    }
    triangle {
      < 1.183912, 7.723730, 1.527919>,
      < 1.138931, 7.943057, 1.452462>,
      < 1.137249, 7.793068, 1.671500>
    }
    triangle {
      < 1.177549, 7.502185, 1.213440>,
      < 1.221443, 7.665048, 1.236122>,
      < 1.190138, 7.595891, 1.288325>
    }
    triangle {
      < 0.416886, 7.691145, 1.819102>,
      < 0.411911, 7.705149, 1.823261>,
      < 0.288781, 7.670419, 1.938340>
    }
    triangle {
      < 0.416886, 7.691145, 1.819102>,
      < 0.288781, 7.670419, 1.938340>,
      < 0.304954, 7.487044, 1.942316>
    }
    triangle {
      < 0.416886, 7.691145, 1.819102>,
      < 0.304954, 7.487044, 1.942316>,
      < 0.424517, 7.538349, 1.816898>
    }
    triangle {
      < 0.426586, 7.851128, 1.845632>,
      < 0.352145, 7.886268, 1.969402>,
      < 0.288781, 7.670419, 1.938340>
    }
    triangle {
      < 0.426586, 7.851128, 1.845632>,
      < 0.288781, 7.670419, 1.938340>,
      < 0.411911, 7.705149, 1.823261>
    }
    triangle {
      < 1.399494, 7.234042, 1.061630>,
      < 1.408726, 7.507695, 1.076182>,
      < 1.181628, 7.493562, 1.203781>
    }
    triangle {
      < 1.399494, 7.234042, 1.061630>,
      < 1.181628, 7.493562, 1.203781>,
      < 1.152053, 7.377617, 1.209565>
    }
    triangle {
      < 1.152053, 7.377617, 1.209565>,
      < 1.113253, 7.297450, 1.266328>,
      < 1.387584, 7.136969, 1.118825>
    }
    triangle {
      < 1.152053, 7.377617, 1.209565>,
      < 1.387584, 7.136969, 1.118825>,
      < 1.399494, 7.234042, 1.061630>
    }
    texture {face}
  }
  // brow
  union {
    triangle {
      < 1.388592, 8.182241, 1.451023>,
      < 1.177990, 8.341700, 1.692121>,
      < 1.157783, 8.273422, 1.698323>
    }
    triangle {
      < 1.388592, 8.182241, 1.451023>,
      < 1.157783, 8.273422, 1.698323>,
      < 1.357290, 8.101020, 1.469618>
    }
    texture {brow}
  }
  // face
  union {
    triangle {
      < 1.392183, 8.540370, 1.434910>,
      < 1.208542, 8.514754, 1.669742>,
      < 1.428928, 8.385238, 1.410104>
    }
    texture {face}
  }
  // brow
  union {
    triangle {
      < 0.929884, 8.357011, 1.841744>,
      < 0.906598, 8.304548, 1.847251>,
      < 1.157783, 8.273422, 1.698323>
    }
    triangle {
      < 0.929884, 8.357011, 1.841744>,
      < 1.157783, 8.273422, 1.698323>,
      < 1.177990, 8.341700, 1.692121>
    }
    triangle {
      < 0.668233, 8.257164, 1.947022>,
      < 0.906598, 8.304548, 1.847251>,
      < 0.929884, 8.357011, 1.841744>
    }
    texture {brow}
  }
  // face
  union {
    triangle {
      < 0.213985, 8.046092, 2.044847>,
      < 0.352145, 7.886268, 1.969402>,
      < 0.467566, 8.143847, 1.989871>
    }
    triangle {
      < 0.213985, 8.046092, 2.044847>,
      < 0.467566, 8.143847, 1.989871>,
      < 0.333965, 8.356596, 2.043825>
    }
    triangle {
      < 0.170791, 7.702956, 1.977541>,
      < 0.288781, 7.670419, 1.938340>,
      < 0.352145, 7.886268, 1.969402>
    }
    triangle {
      < 0.170791, 7.702956, 1.977541>,
      < 0.352145, 7.886268, 1.969402>,
      < 0.213985, 8.046092, 2.044847>
    }
    triangle {
      < 0.157640, 7.519312, 1.979869>,
      < 0.304954, 7.487044, 1.942316>,
      < 0.288781, 7.670419, 1.938340>
    }
    triangle {
      < 0.157640, 7.519312, 1.979869>,
      < 0.288781, 7.670419, 1.938340>,
      < 0.170791, 7.702956, 1.977541>
    }
    triangle {
      < 0.170791, 7.702956, 1.977541>,
      < 0.000000, 7.734456, 2.022061>,
      < 0.000000, 7.533475, 1.994006>
    }
    triangle {
      < 0.170791, 7.702956, 1.977541>,
      < 0.000000, 7.533475, 1.994006>,
      < 0.157640, 7.519312, 1.979869>
    }
    triangle {
      < 0.213985, 8.046092, 2.044847>,
      < 0.000000, 8.097105, 2.066933>,
      < 0.000000, 7.734456, 2.022061>
    }
    triangle {
      < 0.213985, 8.046092, 2.044847>,
      < 0.000000, 7.734456, 2.022061>,
      < 0.170791, 7.702956, 1.977541>
    }
    triangle {
      < 0.333965, 8.356596, 2.043825>,
      < 0.000000, 8.479736, 2.073225>,
      < 0.000000, 8.097105, 2.066933>
    }
    triangle {
      < 0.333965, 8.356596, 2.043825>,
      < 0.000000, 8.097105, 2.066933>,
      < 0.213985, 8.046092, 2.044847>
    }
    triangle {
      < 0.680408, 8.556564, 1.960871>,
      < 0.383177, 8.650391, 2.030931>,
      < 0.000000, 8.479736, 2.073225>
    }
    triangle {
      < 0.680408, 8.556564, 1.960871>,
      < 0.000000, 8.479736, 2.073225>,
      < 0.333965, 8.356596, 2.043825>
    }
    triangle {
      < 0.000000, 8.854424, 2.009160>,
      < 0.000000, 8.479736, 2.073225>,
      < 0.383177, 8.650391, 2.030931>
    }
    triangle {
      < 0.680408, 8.556564, 1.960871>,
      < 0.333965, 8.356596, 2.043825>,
      < 0.467566, 8.143847, 1.989871>
    }
    triangle {
      < 0.680408, 8.556564, 1.960871>,
      < 0.467566, 8.143847, 1.989871>,
      < 0.668233, 8.257164, 1.947022>
    }
    triangle {
      < 1.627951, 8.161976, 1.121192>,
      < 1.647696, 8.606560, 0.948423>,
      < 1.392183, 8.540370, 1.434910>
    }
    triangle {
      < 1.627951, 8.161976, 1.121192>,
      < 1.392183, 8.540370, 1.434910>,
      < 1.428928, 8.385238, 1.410104>
    }
    triangle {
      < 1.671171, 7.887857, 0.950860>,
      < 1.795683, 8.213724, 0.643136>,
      < 1.647696, 8.606560, 0.948423>
    }
    triangle {
      < 1.671171, 7.887857, 0.950860>,
      < 1.647696, 8.606560, 0.948423>,
      < 1.627951, 8.161976, 1.121192>
    }
    triangle {
      < 1.643261, 7.568371, 0.779994>,
      < 1.727092, 7.776976, 0.344528>,
      < 1.795683, 8.213724, 0.643136>
    }
    triangle {
      < 1.643261, 7.568371, 0.779994>,
      < 1.795683, 8.213724, 0.643136>,
      < 1.671171, 7.887857, 0.950860>
    }
    triangle {
      < 1.605012, 7.227119, 0.718601>,
      < 1.639386, 7.174335, 0.448677>,
      < 1.727092, 7.776976, 0.344528>
    }
    triangle {
      < 1.605012, 7.227119, 0.718601>,
      < 1.727092, 7.776976, 0.344528>,
      < 1.643261, 7.568371, 0.779994>
    }
    triangle {
      < 1.727092, 7.776976, 0.344528>,
      < 1.811272, 8.350312, 0.257340>,
      < 1.828851, 8.531735, 0.231749>
    }
    triangle {
      < 1.727092, 7.776976, 0.344528>,
      < 1.828851, 8.531735, 0.231749>,
      < 1.795683, 8.213724, 0.643136>
    }
    triangle {
      < 1.805840, 8.641598, 0.263489>,
      < 1.792122, 8.717618, 0.442839>,
      < 1.647696, 8.606560, 0.948423>
    }
    triangle {
      < 1.805840, 8.641598, 0.263489>,
      < 1.647696, 8.606560, 0.948423>,
      < 1.795683, 8.213724, 0.643136>
    }
    triangle {
      < 1.805840, 8.641598, 0.263489>,
      < 1.795683, 8.213724, 0.643136>,
      < 1.828851, 8.531735, 0.231749>
    }
    triangle {
      < 1.589390, 7.029233, 0.920003>,
      < 1.665081, 6.813934, 0.713635>,
      < 1.685030, 6.993190, 0.456504>
    }
    triangle {
      < 1.589390, 7.029233, 0.920003>,
      < 1.685030, 6.993190, 0.456504>,
      < 1.639386, 7.174335, 0.448677>
    }
    triangle {
      < 1.589390, 7.029233, 0.920003>,
      < 1.639386, 7.174335, 0.448677>,
      < 1.605012, 7.227119, 0.718601>
    }
    triangle {
      < 1.574759, 6.922855, 1.114138>,
      < 1.641878, 6.680877, 0.963337>,
      < 1.665081, 6.813934, 0.713635>
    }
    triangle {
      < 1.574759, 6.922855, 1.114138>,
      < 1.665081, 6.813934, 0.713635>,
      < 1.589390, 7.029233, 0.920003>
    }
    triangle {
      < 1.478820, 6.789691, 1.350577>,
      < 1.567187, 6.531720, 1.241760>,
      < 1.641878, 6.680877, 0.963337>
    }
    triangle {
      < 1.478820, 6.789691, 1.350577>,
      < 1.641878, 6.680877, 0.963337>,
      < 1.574759, 6.922855, 1.114138>
    }
    triangle {
      < 1.335770, 6.729196, 1.536853>,
      < 1.392018, 6.465443, 1.495378>,
      < 1.567187, 6.531720, 1.241760>
    }
    triangle {
      < 1.335770, 6.729196, 1.536853>,
      < 1.567187, 6.531720, 1.241760>,
      < 1.478820, 6.789691, 1.350577>
    }
    triangle {
      < 1.135794, 6.699510, 1.720270>,
      < 1.117530, 6.487579, 1.748186>,
      < 1.392018, 6.465443, 1.495378>
    }
    triangle {
      < 1.135794, 6.699510, 1.720270>,
      < 1.392018, 6.465443, 1.495378>,
      < 1.335770, 6.729196, 1.536853>
    }
    triangle {
      < 0.951037, 6.754210, 1.815196>,
      < 0.928687, 6.544118, 1.858133>,
      < 1.117530, 6.487579, 1.748186>
    }
    triangle {
      < 0.951037, 6.754210, 1.815196>,
      < 1.117530, 6.487579, 1.748186>,
      < 1.135794, 6.699510, 1.720270>
    }
    triangle {
      < 0.662825, 6.855032, 1.902023>,
      < 0.609789, 6.660050, 1.950922>,
      < 0.928687, 6.544118, 1.858133>
    }
    triangle {
      < 0.662825, 6.855032, 1.902023>,
      < 0.928687, 6.544118, 1.858133>,
      < 0.951037, 6.754210, 1.815196>
    }
    triangle {
      < 0.449960, 6.979241, 2.004734>,
      < 0.459376, 6.802716, 1.999871>,
      < 0.609789, 6.660050, 1.950922>
    }
    triangle {
      < 0.449960, 6.979241, 2.004734>,
      < 0.609789, 6.660050, 1.950922>,
      < 0.662825, 6.855032, 1.902023>
    }
    triangle {
      < 0.412490, 6.840874, 2.088102>,
      < 0.448093, 6.801496, 2.038748>,
      < 0.463406, 6.824869, 2.024403>
    }
    triangle {
      < 0.412490, 6.840874, 2.088102>,
      < 0.463406, 6.824869, 2.024403>,
      < 0.449324, 6.929481, 2.051343>
    }
    triangle {
      < 0.449324, 6.929481, 2.051343>,
      < 0.334718, 6.960837, 2.252813>,
      < 0.314778, 6.869460, 2.248066>
    }
    triangle {
      < 0.449324, 6.929481, 2.051343>,
      < 0.314778, 6.869460, 2.248066>,
      < 0.412490, 6.840874, 2.088102>
    }
    triangle {
      < 0.165973, 6.990763, 2.401286>,
      < 0.178745, 6.866331, 2.385348>,
      < 0.314778, 6.869460, 2.248066>
    }
    triangle {
      < 0.165973, 6.990763, 2.401286>,
      < 0.314778, 6.869460, 2.248066>,
      < 0.334718, 6.960837, 2.252813>
    }
    triangle {
      < 0.000000, 7.013479, 2.418046>,
      < 0.000000, 6.869957, 2.417860>,
      < 0.178745, 6.866331, 2.385348>
    }
    triangle {
      < 0.000000, 7.013479, 2.418046>,
      < 0.178745, 6.866331, 2.385348>,
      < 0.165973, 6.990763, 2.401286>
    }
    texture {face}
  }
  // uplip
  union {
    triangle {
      < 0.768347, 6.166550, 1.872100>,
      < 0.781087, 6.165960, 1.864745>,
      < 0.772033, 6.187246, 1.871334>
    }
    triangle {
      < 0.772033, 6.187246, 1.871334>,
      < 0.755565, 6.180678, 1.881653>,
      < 0.768347, 6.166550, 1.872100>
    }
    triangle {
      < 0.513649, 6.198605, 2.058142>,
      < 0.496583, 6.127518, 1.979135>,
      < 0.632465, 6.147034, 1.925617>
    }
    triangle {
      < 0.513649, 6.198605, 2.058142>,
      < 0.632465, 6.147034, 1.925617>,
      < 0.634607, 6.189641, 1.969897>
    }
    texture {uplip}
  }
  // face
  union {
    triangle {
      < 0.610265, 6.408909, 2.035973>,
      < 0.407699, 6.583720, 2.123532>,
      < 0.374646, 6.335971, 2.215456>
    }
    triangle {
      < 0.610265, 6.408909, 2.035973>,
      < 0.374646, 6.335971, 2.215456>,
      < 0.530713, 6.263931, 2.096829>
    }
    triangle {
      < 0.609789, 6.660050, 1.950922>,
      < 0.459376, 6.802716, 1.999871>,
      < 0.447613, 6.770525, 2.014438>
    }
    triangle {
      < 0.609789, 6.660050, 1.950922>,
      < 0.447613, 6.770525, 2.014438>,
      < 0.407699, 6.583720, 2.123532>
    }
    triangle {
      < 0.609789, 6.660050, 1.950922>,
      < 0.407699, 6.583720, 2.123532>,
      < 0.610265, 6.408909, 2.035973>
    }
    triangle {
      < 0.266413, 6.719081, 2.118316>,
      < 0.407699, 6.583720, 2.123532>,
      < 0.447613, 6.770525, 2.014438>
    }
    triangle {
      < 0.135082, 6.628557, 2.158507>,
      < 0.185747, 6.376217, 2.308307>,
      < 0.374646, 6.335971, 2.215456>
    }
    triangle {
      < 0.135082, 6.628557, 2.158507>,
      < 0.374646, 6.335971, 2.215456>,
      < 0.407699, 6.583720, 2.123532>
    }
    triangle {
      < 0.135082, 6.628557, 2.158507>,
      < 0.407699, 6.583720, 2.123532>,
      < 0.266413, 6.719081, 2.118316>
    }
    triangle {
      < 0.000000, 6.613321, 2.141114>,
      < 0.000000, 6.385907, 2.297638>,
      < 0.185747, 6.376217, 2.308307>
    }
    triangle {
      < 0.000000, 6.613321, 2.141114>,
      < 0.185747, 6.376217, 2.308307>,
      < 0.135082, 6.628557, 2.158507>
    }
    triangle {
      < 0.134601, 6.677120, 2.183006>,
      < 0.178745, 6.866331, 2.385348>,
      < 0.000000, 6.869957, 2.417860>
    }
    triangle {
      < 0.134601, 6.677120, 2.183006>,
      < 0.000000, 6.869957, 2.417860>,
      < 0.000000, 6.676259, 2.183194>
    }
    triangle {
      < 0.263747, 6.748829, 2.144173>,
      < 0.314778, 6.869460, 2.248066>,
      < 0.178745, 6.866331, 2.385348>
    }
    triangle {
      < 0.263747, 6.748829, 2.144173>,
      < 0.178745, 6.866331, 2.385348>,
      < 0.134601, 6.677120, 2.183006>
    }
    triangle {
      < 0.314778, 6.869460, 2.248066>,
      < 0.263747, 6.748829, 2.144173>,
      < 0.448093, 6.801496, 2.038748>
    }
    triangle {
      < 0.314778, 6.869460, 2.248066>,
      < 0.448093, 6.801496, 2.038748>,
      < 0.412490, 6.840874, 2.088102>
    }
    triangle {
      < 0.512566, 5.982536, 1.942181>,
      < 0.863689, 5.912329, 1.797569>,
      < 0.638888, 6.093111, 1.912075>
    }
    texture {face}
  }
  // lowlip
  union {
    triangle {
      < 0.505941, 6.036611, 1.965279>,
      < 0.369221, 6.000530, 2.109117>,
      < 0.380141, 5.935607, 2.048533>
    }
    triangle {
      < 0.505941, 6.036611, 1.965279>,
      < 0.380141, 5.935607, 2.048533>,
      < 0.512566, 5.982536, 1.942181>
    }
    triangle {
      < 0.192374, 5.979699, 2.170825>,
      < 0.210797, 5.903279, 2.116179>,
      < 0.380141, 5.935607, 2.048533>
    }
    triangle {
      < 0.192374, 5.979699, 2.170825>,
      < 0.380141, 5.935607, 2.048533>,
      < 0.369221, 6.000530, 2.109117>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < 0.314755, 6.159932, 2.117626>,
      < 0.344701, 6.235855, 2.198796>,
      < 0.174788, 6.243392, 2.268390>
    }
    triangle {
      < 0.314755, 6.159932, 2.117626>,
      < 0.174788, 6.243392, 2.268390>,
      < 0.161882, 6.163558, 2.150136>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < 0.314755, 6.159932, 2.117626>,
      < 0.161882, 6.163558, 2.150136>,
      < 0.173951, 6.088375, 2.182847>
    }
    triangle {
      < 0.314755, 6.159932, 2.117626>,
      < 0.173951, 6.088375, 2.182847>,
      < 0.358301, 6.097709, 2.127077>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < 0.174788, 6.243392, 2.268390>,
      < 0.000000, 6.234792, 2.271523>,
      < 0.000000, 6.157406, 2.167072>
    }
    triangle {
      < 0.174788, 6.243392, 2.268390>,
      < 0.000000, 6.157406, 2.167072>,
      < 0.161882, 6.163558, 2.150136>
    }
    triangle {
      < 0.513649, 6.198605, 2.058142>,
      < 0.344701, 6.235855, 2.198796>,
      < 0.314755, 6.159932, 2.117626>
    }
    triangle {
      < 0.513649, 6.198605, 2.058142>,
      < 0.314755, 6.159932, 2.117626>,
      < 0.496583, 6.127518, 1.979135>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < 0.204979, 5.862878, 1.991291>,
      < 0.210797, 5.903279, 2.116179>,
      < 0.000000, 5.899922, 2.142435>
    }
    triangle {
      < 0.204979, 5.862878, 1.991291>,
      < 0.000000, 5.899922, 2.142435>,
      < 0.000000, 5.866322, 2.025527>
    }
    triangle {
      < 0.376618, 5.897822, 1.994641>,
      < 0.380141, 5.935607, 2.048533>,
      < 0.210797, 5.903279, 2.116179>
    }
    triangle {
      < 0.376618, 5.897822, 1.994641>,
      < 0.210797, 5.903279, 2.116179>,
      < 0.204979, 5.862878, 1.991291>
    }
    triangle {
      < 0.512566, 5.982536, 1.942181>,
      < 0.380141, 5.935607, 2.048533>,
      < 0.376618, 5.897822, 1.994641>
    }
    triangle {
      < 0.192374, 5.979699, 2.170825>,
      < 0.000000, 5.979388, 2.192696>,
      < 0.000000, 5.899922, 2.142435>
    }
    triangle {
      < 0.192374, 5.979699, 2.170825>,
      < 0.000000, 5.899922, 2.142435>,
      < 0.210797, 5.903279, 2.116179>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < 0.619415, 5.708832, 1.905872>,
      < 0.890778, 5.801272, 1.751339>,
      < 0.863689, 5.912329, 1.797569>
    }
    triangle {
      < 0.619415, 5.708832, 1.905872>,
      < 0.863689, 5.912329, 1.797569>,
      < 0.512566, 5.982536, 1.942181>
    }
    triangle {
      < 0.512566, 5.982536, 1.942181>,
      < 0.376618, 5.897822, 1.994641>,
      < 0.500890, 5.684086, 1.970804>
    }
    triangle {
      < 0.512566, 5.982536, 1.942181>,
      < 0.500890, 5.684086, 1.970804>,
      < 0.619415, 5.708832, 1.905872>
    }
    triangle {
      < 0.204979, 5.862878, 1.991291>,
      < 0.285482, 5.691689, 2.000125>,
      < 0.500890, 5.684086, 1.970804>
    }
    triangle {
      < 0.204979, 5.862878, 1.991291>,
      < 0.500890, 5.684086, 1.970804>,
      < 0.376618, 5.897822, 1.994641>
    }
    triangle {
      < 0.000000, 5.866322, 2.025527>,
      < 0.000000, 5.697412, 2.020346>,
      < 0.285482, 5.691689, 2.000125>
    }
    triangle {
      < 0.000000, 5.866322, 2.025527>,
      < 0.285482, 5.691689, 2.000125>,
      < 0.204979, 5.862878, 1.991291>
    }
    triangle {
      < 0.000000, 5.417133, 1.837040>,
      < 0.299098, 5.436183, 1.813015>,
      < 0.285482, 5.691689, 2.000125>
    }
    triangle {
      < 0.000000, 5.417133, 1.837040>,
      < 0.285482, 5.691689, 2.000125>,
      < 0.000000, 5.697412, 2.020346>
    }
    triangle {
      < 0.490305, 5.467333, 1.770523>,
      < 0.500890, 5.684086, 1.970804>,
      < 0.285482, 5.691689, 2.000125>
    }
    triangle {
      < 0.490305, 5.467333, 1.770523>,
      < 0.285482, 5.691689, 2.000125>,
      < 0.299098, 5.436183, 1.813015>
    }
    triangle {
      < 0.570045, 5.492799, 1.740637>,
      < 0.619415, 5.708832, 1.905872>,
      < 0.500890, 5.684086, 1.970804>
    }
    triangle {
      < 0.570045, 5.492799, 1.740637>,
      < 0.500890, 5.684086, 1.970804>,
      < 0.490305, 5.467333, 1.770523>
    }
    triangle {
      < 0.844120, 5.597366, 1.613849>,
      < 0.890778, 5.801272, 1.751339>,
      < 0.619415, 5.708832, 1.905872>
    }
    triangle {
      < 0.844120, 5.597366, 1.613849>,
      < 0.619415, 5.708832, 1.905872>,
      < 0.570045, 5.492799, 1.740637>
    }
    triangle {
      < 1.027071, 5.713632, 1.408967>,
      < 1.057001, 5.928176, 1.601641>,
      < 0.890778, 5.801272, 1.751339>
    }
    triangle {
      < 1.027071, 5.713632, 1.408967>,
      < 0.890778, 5.801272, 1.751339>,
      < 0.844120, 5.597366, 1.613849>
    }
    triangle {
      < 0.863689, 5.912329, 1.797569>,
      < 0.890778, 5.801272, 1.751339>,
      < 1.057001, 5.928176, 1.601641>
    }
    texture {face}
  }
  // lowlip
  union {
    triangle {
      < 0.768347, 6.166550, 1.872100>,
      < 0.770194, 6.151618, 1.867306>,
      < 0.781087, 6.165960, 1.864745>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < 0.000000, 5.374960, 1.515602>,
      < 0.241309, 5.392804, 1.475121>,
      < 0.299098, 5.436183, 1.813015>
    }
    triangle {
      < 0.000000, 5.374960, 1.515602>,
      < 0.299098, 5.436183, 1.813015>,
      < 0.000000, 5.417133, 1.837040>
    }
    triangle {
      < 0.414913, 5.421336, 1.426451>,
      < 0.490305, 5.467333, 1.770523>,
      < 0.299098, 5.436183, 1.813015>
    }
    triangle {
      < 0.414913, 5.421336, 1.426451>,
      < 0.299098, 5.436183, 1.813015>,
      < 0.241309, 5.392804, 1.475121>
    }
    triangle {
      < 0.570045, 5.492799, 1.740637>,
      < 0.490305, 5.467333, 1.770523>,
      < 0.414913, 5.421336, 1.426451>
    }
    triangle {
      < 0.652058, 5.520360, 1.283692>,
      < 0.844120, 5.597366, 1.613849>,
      < 0.570045, 5.492799, 1.740637>
    }
    triangle {
      < 0.652058, 5.520360, 1.283692>,
      < 0.570045, 5.492799, 1.740637>,
      < 0.414913, 5.421336, 1.426451>
    }
    triangle {
      < 0.878470, 5.593192, 1.103604>,
      < 1.027071, 5.713632, 1.408967>,
      < 0.844120, 5.597366, 1.613849>
    }
    triangle {
      < 0.878470, 5.593192, 1.103604>,
      < 0.844120, 5.597366, 1.613849>,
      < 0.652058, 5.520360, 1.283692>
    }
    triangle {
      < 1.029236, 5.699072, 0.873728>,
      < 1.209406, 5.866593, 1.153412>,
      < 1.027071, 5.713632, 1.408967>
    }
    triangle {
      < 1.029236, 5.699072, 0.873728>,
      < 1.027071, 5.713632, 1.408967>,
      < 0.878470, 5.593192, 1.103604>
    }
    triangle {
      < 1.118836, 5.844531, 0.602834>,
      < 1.340582, 6.020861, 0.876453>,
      < 1.209406, 5.866593, 1.153412>
    }
    triangle {
      < 1.118836, 5.844531, 0.602834>,
      < 1.209406, 5.866593, 1.153412>,
      < 1.029236, 5.699072, 0.873728>
    }
    triangle {
      < 1.238348, 5.940702, 0.472670>,
      < 1.450135, 6.122812, 0.637919>,
      < 1.340582, 6.020861, 0.876453>
    }
    triangle {
      < 1.238348, 5.940702, 0.472670>,
      < 1.340582, 6.020861, 0.876453>,
      < 1.118836, 5.844531, 0.602834>
    }
    triangle {
      < 1.506171, 6.198785, 0.484386>,
      < 1.450135, 6.122812, 0.637919>,
      < 1.238348, 5.940702, 0.472670>
    }
    triangle {
      < 1.676612, 6.440908, 0.456156>,
      < 1.552103, 6.299576, 0.746761>,
      < 1.450135, 6.122812, 0.637919>
    }
    triangle {
      < 1.676612, 6.440908, 0.456156>,
      < 1.450135, 6.122812, 0.637919>,
      < 1.506171, 6.198785, 0.484386>
    }
    triangle {
      < 1.442532, 6.188966, 1.009076>,
      < 1.340582, 6.020861, 0.876453>,
      < 1.450135, 6.122812, 0.637919>
    }
    triangle {
      < 1.442532, 6.188966, 1.009076>,
      < 1.450135, 6.122812, 0.637919>,
      < 1.552103, 6.299576, 0.746761>
    }
    triangle {
      < 1.272932, 6.064259, 1.297129>,
      < 1.209406, 5.866593, 1.153412>,
      < 1.340582, 6.020861, 0.876453>
    }
    triangle {
      < 1.272932, 6.064259, 1.297129>,
      < 1.340582, 6.020861, 0.876453>,
      < 1.442532, 6.188966, 1.009076>
    }
    triangle {
      < 1.057001, 5.928176, 1.601641>,
      < 1.027071, 5.713632, 1.408967>,
      < 1.209406, 5.866593, 1.153412>
    }
    triangle {
      < 1.057001, 5.928176, 1.601641>,
      < 1.209406, 5.866593, 1.153412>,
      < 1.272932, 6.064259, 1.297129>
    }
    triangle {
      < 1.272932, 6.064259, 1.297129>,
      < 1.322479, 6.246337, 1.393343>,
      < 1.055449, 6.154773, 1.692849>
    }
    triangle {
      < 1.272932, 6.064259, 1.297129>,
      < 1.055449, 6.154773, 1.692849>,
      < 1.057001, 5.928176, 1.601641>
    }
    triangle {
      < 1.392018, 6.465443, 1.495378>,
      < 1.117530, 6.487579, 1.748186>,
      < 1.055449, 6.154773, 1.692849>
    }
    triangle {
      < 1.392018, 6.465443, 1.495378>,
      < 1.055449, 6.154773, 1.692849>,
      < 1.322479, 6.246337, 1.393343>
    }
    triangle {
      < 1.272932, 6.064259, 1.297129>,
      < 1.442532, 6.188966, 1.009076>,
      < 1.467817, 6.358039, 1.105599>
    }
    triangle {
      < 1.272932, 6.064259, 1.297129>,
      < 1.467817, 6.358039, 1.105599>,
      < 1.322479, 6.246337, 1.393343>
    }
    triangle {
      < 1.676612, 6.440908, 0.456156>,
      < 1.686646, 6.625117, 0.584895>,
      < 1.586969, 6.487923, 0.838833>
    }
    triangle {
      < 1.676612, 6.440908, 0.456156>,
      < 1.586969, 6.487923, 0.838833>,
      < 1.552103, 6.299576, 0.746761>
    }
    triangle {
      < 1.676612, 6.440908, 0.456156>,
      < 1.728852, 6.717050, 0.456330>,
      < 1.686646, 6.625117, 0.584895>
    }
    triangle {
      < 1.467817, 6.358039, 1.105599>,
      < 1.442532, 6.188966, 1.009076>,
      < 1.552103, 6.299576, 0.746761>
    }
    triangle {
      < 1.467817, 6.358039, 1.105599>,
      < 1.552103, 6.299576, 0.746761>,
      < 1.586969, 6.487923, 0.838833>
    }
    triangle {
      < 0.163951, 5.515416, 0.883127>,
      < 0.241309, 5.392804, 1.475121>,
      < 0.000000, 5.374960, 1.515602>
    }
    triangle {
      < 0.163951, 5.515416, 0.883127>,
      < 0.000000, 5.374960, 1.515602>,
      < 0.000000, 5.492510, 0.895761>
    }
    triangle {
      < 0.323968, 5.542478, 0.860668>,
      < 0.414913, 5.421336, 1.426451>,
      < 0.241309, 5.392804, 1.475121>
    }
    triangle {
      < 0.323968, 5.542478, 0.860668>,
      < 0.241309, 5.392804, 1.475121>,
      < 0.163951, 5.515416, 0.883127>
    }
    triangle {
      < 0.462977, 5.564999, 0.816277>,
      < 0.652058, 5.520360, 1.283692>,
      < 0.414913, 5.421336, 1.426451>
    }
    triangle {
      < 0.462977, 5.564999, 0.816277>,
      < 0.414913, 5.421336, 1.426451>,
      < 0.323968, 5.542478, 0.860668>
    }
    triangle {
      < 0.660893, 5.657573, 0.748836>,
      < 0.878470, 5.593192, 1.103604>,
      < 0.652058, 5.520360, 1.283692>
    }
    triangle {
      < 0.660893, 5.657573, 0.748836>,
      < 0.652058, 5.520360, 1.283692>,
      < 0.462977, 5.564999, 0.816277>
    }
    triangle {
      < 0.820922, 5.721953, 0.622226>,
      < 1.029236, 5.699072, 0.873728>,
      < 0.878470, 5.593192, 1.103604>
    }
    triangle {
      < 0.820922, 5.721953, 0.622226>,
      < 0.878470, 5.593192, 1.103604>,
      < 0.660893, 5.657573, 0.748836>
    }
    triangle {
      < 1.038925, 5.856872, 0.438530>,
      < 1.118836, 5.844531, 0.602834>,
      < 1.029236, 5.699072, 0.873728>
    }
    triangle {
      < 1.038925, 5.856872, 0.438530>,
      < 1.029236, 5.699072, 0.873728>,
      < 0.820922, 5.721953, 0.622226>
    }
    triangle {
      < 1.238348, 5.940702, 0.472670>,
      < 1.118836, 5.844531, 0.602834>,
      < 1.038925, 5.856872, 0.438530>
    }
    triangle {
      < 0.488515, 5.798268, 0.415098>,
      < 1.038925, 5.856872, 0.438530>,
      < 0.820922, 5.721953, 0.622226>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < 2.500422, 6.632197, -0.524128>,
      < 2.515584, 6.509755, -0.147248>,
      < 2.826619, 5.660984, -0.490157>
    }
    triangle {
      < 2.500422, 6.632197, -0.524128>,
      < 2.826619, 5.660984, -0.490157>,
      < 2.695209, 6.053171, -0.865855>
    }
    triangle {
      < 2.695209, 6.053171, -0.865855>,
      < 2.614723, 6.416059, -1.296192>,
      < 2.359352, 6.851682, -1.027979>
    }
    triangle {
      < 2.695209, 6.053171, -0.865855>,
      < 2.359352, 6.851682, -1.027979>,
      < 2.500422, 6.632197, -0.524128>
    }
    triangle {
      < 2.359352, 6.851682, -1.027979>,
      < 2.273029, 7.262681, -0.865403>,
      < 2.321589, 7.224392, -0.390974>
    }
    triangle {
      < 2.359352, 6.851682, -1.027979>,
      < 2.321589, 7.224392, -0.390974>,
      < 2.500422, 6.632197, -0.524128>
    }
    triangle {
      < 2.273029, 7.262681, -0.865403>,
      < 2.254496, 7.761235, -0.753907>,
      < 2.294293, 7.756798, -0.426940>
    }
    triangle {
      < 2.273029, 7.262681, -0.865403>,
      < 2.294293, 7.756798, -0.426940>,
      < 2.321589, 7.224392, -0.390974>
    }
    triangle {
      < 2.227957, 7.259726, -1.477074>,
      < 2.250164, 7.753303, -1.416556>,
      < 2.254496, 7.761235, -0.753907>
    }
    triangle {
      < 2.227957, 7.259726, -1.477074>,
      < 2.254496, 7.761235, -0.753907>,
      < 2.273029, 7.262681, -0.865403>
    }
    triangle {
      < 2.233644, 7.054286, -1.552961>,
      < 1.935595, 7.177408, -2.135517>,
      < 2.227957, 7.259726, -1.477074>
    }
    triangle {
      < 2.219475, 6.816071, -1.663349>,
      < 1.935595, 7.177408, -2.135517>,
      < 2.233644, 7.054286, -1.552961>
    }
    triangle {
      < 2.233644, 7.054286, -1.552961>,
      < 2.359352, 6.851682, -1.027979>,
      < 2.614723, 6.416059, -1.296192>
    }
    triangle {
      < 2.233644, 7.054286, -1.552961>,
      < 2.614723, 6.416059, -1.296192>,
      < 2.219475, 6.816071, -1.663349>
    }
    triangle {
      < 2.227957, 7.259726, -1.477074>,
      < 2.273029, 7.262681, -0.865403>,
      < 2.359352, 6.851682, -1.027979>
    }
    triangle {
      < 2.227957, 7.259726, -1.477074>,
      < 2.359352, 6.851682, -1.027979>,
      < 2.233644, 7.054286, -1.552961>
    }
    triangle {
      < 1.935595, 7.177408, -2.135517>,
      < 2.126979, 7.757913, -1.940661>,
      < 2.250164, 7.753303, -1.416556>
    }
    triangle {
      < 1.935595, 7.177408, -2.135517>,
      < 2.250164, 7.753303, -1.416556>,
      < 2.227957, 7.259726, -1.477074>
    }
    triangle {
      < 2.097196, 8.656051, -1.801888>,
      < 2.158943, 8.562037, -1.256461>,
      < 2.250164, 7.753303, -1.416556>
    }
    triangle {
      < 2.097196, 8.656051, -1.801888>,
      < 2.250164, 7.753303, -1.416556>,
      < 2.126979, 7.757913, -1.940661>
    }
    triangle {
      < 1.926966, 9.320498, -1.541335>,
      < 2.049096, 9.113437, -1.064185>,
      < 2.158943, 8.562037, -1.256461>
    }
    triangle {
      < 1.926966, 9.320498, -1.541335>,
      < 2.158943, 8.562037, -1.256461>,
      < 2.097196, 8.656051, -1.801888>
    }
    triangle {
      < 2.157858, 8.891205, -0.589506>,
      < 2.193563, 8.457726, -0.654384>,
      < 2.158943, 8.562037, -1.256461>
    }
    triangle {
      < 2.157858, 8.891205, -0.589506>,
      < 2.158943, 8.562037, -1.256461>,
      < 2.049096, 9.113437, -1.064185>
    }
    triangle {
      < 2.254496, 7.761235, -0.753907>,
      < 2.250164, 7.753303, -1.416556>,
      < 2.158943, 8.562037, -1.256461>
    }
    triangle {
      < 2.254496, 7.761235, -0.753907>,
      < 2.158943, 8.562037, -1.256461>,
      < 2.193563, 8.457726, -0.654384>
    }
    triangle {
      < 2.193563, 8.457726, -0.654384>,
      < 2.287188, 8.423973, -0.499452>,
      < 2.294293, 7.756798, -0.426940>
    }
    triangle {
      < 2.193563, 8.457726, -0.654384>,
      < 2.294293, 7.756798, -0.426940>,
      < 2.254496, 7.761235, -0.753907>
    }
    triangle {
      < 2.157858, 8.891205, -0.589506>,
      < 2.292505, 8.873673, -0.424492>,
      < 2.287188, 8.423973, -0.499452>
    }
    triangle {
      < 2.157858, 8.891205, -0.589506>,
      < 2.287188, 8.423973, -0.499452>,
      < 2.193563, 8.457726, -0.654384>
    }
    triangle {
      < 2.319053, 8.823269, -0.286861>,
      < 2.350794, 8.405975, -0.338027>,
      < 2.287188, 8.423973, -0.499452>
    }
    triangle {
      < 2.319053, 8.823269, -0.286861>,
      < 2.287188, 8.423973, -0.499452>,
      < 2.292505, 8.873673, -0.424492>
    }
    triangle {
      < 2.249767, 8.695644, 0.019894>,
      < 2.264757, 8.360371, 0.036182>,
      < 2.350794, 8.405975, -0.338027>
    }
    triangle {
      < 2.249767, 8.695644, 0.019894>,
      < 2.350794, 8.405975, -0.338027>,
      < 2.319053, 8.823269, -0.286861>
    }
    triangle {
      < 2.207831, 7.787432, 0.130303>,
      < 2.334304, 7.767658, -0.289991>,
      < 2.350794, 8.405975, -0.338027>
    }
    triangle {
      < 2.207831, 7.787432, 0.130303>,
      < 2.350794, 8.405975, -0.338027>,
      < 2.264757, 8.360371, 0.036182>
    }
    triangle {
      < 2.294293, 7.756798, -0.426940>,
      < 2.287188, 8.423973, -0.499452>,
      < 2.350794, 8.405975, -0.338027>
    }
    triangle {
      < 2.294293, 7.756798, -0.426940>,
      < 2.350794, 8.405975, -0.338027>,
      < 2.334304, 7.767658, -0.289991>
    }
    triangle {
      < 2.331083, 7.195605, -0.180993>,
      < 2.321589, 7.224392, -0.390974>,
      < 2.294293, 7.756798, -0.426940>
    }
    triangle {
      < 2.331083, 7.195605, -0.180993>,
      < 2.294293, 7.756798, -0.426940>,
      < 2.334304, 7.767658, -0.289991>
    }
    triangle {
      < 2.515584, 6.509755, -0.147248>,
      < 2.500422, 6.632197, -0.524128>,
      < 2.321589, 7.224392, -0.390974>
    }
    triangle {
      < 2.515584, 6.509755, -0.147248>,
      < 2.321589, 7.224392, -0.390974>,
      < 2.331083, 7.195605, -0.180993>
    }
    triangle {
      < 2.331083, 7.195605, -0.180993>,
      < 2.197367, 7.172413, 0.273125>,
      < 2.330512, 6.299601, 0.262144>
    }
    triangle {
      < 2.331083, 7.195605, -0.180993>,
      < 2.330512, 6.299601, 0.262144>,
      < 2.515584, 6.509755, -0.147248>
    }
    triangle {
      < 2.197367, 7.172413, 0.273125>,
      < 2.331083, 7.195605, -0.180993>,
      < 2.334304, 7.767658, -0.289991>
    }
    triangle {
      < 2.197367, 7.172413, 0.273125>,
      < 2.334304, 7.767658, -0.289991>,
      < 2.207831, 7.787432, 0.130303>
    }
    triangle {
      < 2.542333, 5.326556, -0.002924>,
      < 2.826619, 5.660984, -0.490157>,
      < 2.515584, 6.509755, -0.147248>
    }
    triangle {
      < 2.542333, 5.326556, -0.002924>,
      < 2.515584, 6.509755, -0.147248>,
      < 2.330512, 6.299601, 0.262144>
    }
    triangle {
      < 2.399125, 4.275225, -0.760437>,
      < 2.951908, 4.766716, -1.262379>,
      < 2.826619, 5.660984, -0.490157>
    }
    triangle {
      < 2.399125, 4.275225, -0.760437>,
      < 2.826619, 5.660984, -0.490157>,
      < 2.542333, 5.326556, -0.002924>
    }
    triangle {
      < 2.968071, 5.401118, -1.732358>,
      < 2.695209, 6.053171, -0.865855>,
      < 2.826619, 5.660984, -0.490157>
    }
    triangle {
      < 2.968071, 5.401118, -1.732358>,
      < 2.826619, 5.660984, -0.490157>,
      < 2.951908, 4.766716, -1.262379>
    }
    triangle {
      < 2.568169, 5.879606, -1.879941>,
      < 2.614723, 6.416059, -1.296192>,
      < 2.695209, 6.053171, -0.865855>
    }
    triangle {
      < 2.568169, 5.879606, -1.879941>,
      < 2.695209, 6.053171, -0.865855>,
      < 2.968071, 5.401118, -1.732358>
    }
    triangle {
      < 2.251399, 6.389997, -2.022340>,
      < 2.219475, 6.816071, -1.663349>,
      < 2.614723, 6.416059, -1.296192>
    }
    triangle {
      < 2.251399, 6.389997, -2.022340>,
      < 2.614723, 6.416059, -1.296192>,
      < 2.568169, 5.879606, -1.879941>
    }
    triangle {
      < 1.809644, 6.943704, -2.198517>,
      < 1.935595, 7.177408, -2.135517>,
      < 2.219475, 6.816071, -1.663349>
    }
    triangle {
      < 1.809644, 6.943704, -2.198517>,
      < 2.219475, 6.816071, -1.663349>,
      < 2.251399, 6.389997, -2.022340>
    }
    triangle {
      < 2.251399, 6.389997, -2.022340>,
      < 2.064757, 6.140160, -2.288342>,
      < 1.613503, 6.780987, -2.334113>
    }
    triangle {
      < 2.251399, 6.389997, -2.022340>,
      < 1.613503, 6.780987, -2.334113>,
      < 1.809644, 6.943704, -2.198517>
    }
    triangle {
      < 2.568169, 5.879606, -1.879941>,
      < 2.543283, 5.618077, -2.285651>,
      < 2.064757, 6.140160, -2.288342>
    }
    triangle {
      < 2.568169, 5.879606, -1.879941>,
      < 2.064757, 6.140160, -2.288342>,
      < 2.251399, 6.389997, -2.022340>
    }
    triangle {
      < 2.968071, 5.401118, -1.732358>,
      < 2.807642, 5.119742, -2.192055>,
      < 2.543283, 5.618077, -2.285651>
    }
    triangle {
      < 2.968071, 5.401118, -1.732358>,
      < 2.543283, 5.618077, -2.285651>,
      < 2.568169, 5.879606, -1.879941>
    }
    triangle {
      < 2.951908, 4.766716, -1.262379>,
      < 2.771923, 4.394222, -1.718391>,
      < 2.807642, 5.119742, -2.192055>
    }
    triangle {
      < 2.951908, 4.766716, -1.262379>,
      < 2.807642, 5.119742, -2.192055>,
      < 2.968071, 5.401118, -1.732358>
    }
    triangle {
      < 2.399125, 4.275225, -0.760437>,
      < 2.320945, 3.991879, -1.246104>,
      < 2.771923, 4.394222, -1.718391>
    }
    triangle {
      < 2.399125, 4.275225, -0.760437>,
      < 2.771923, 4.394222, -1.718391>,
      < 2.951908, 4.766716, -1.262379>
    }
    triangle {
      < 1.883869, 4.253895, -0.493437>,
      < 1.797362, 3.947582, -0.884269>,
      < 2.320945, 3.991879, -1.246104>
    }
    triangle {
      < 1.883869, 4.253895, -0.493437>,
      < 2.320945, 3.991879, -1.246104>,
      < 2.399125, 4.275225, -0.760437>
    }
    triangle {
      < 1.462984, 4.192017, -0.341670>,
      < 1.350401, 4.000060, -0.637910>,
      < 1.797362, 3.947582, -0.884269>
    }
    triangle {
      < 1.462984, 4.192017, -0.341670>,
      < 1.797362, 3.947582, -0.884269>,
      < 1.883869, 4.253895, -0.493437>
    }
    triangle {
      < 1.922380, 4.961071, 0.309447>,
      < 1.883869, 4.253895, -0.493437>,
      < 2.399125, 4.275225, -0.760437>
    }
    triangle {
      < 1.922380, 4.961071, 0.309447>,
      < 2.399125, 4.275225, -0.760437>,
      < 2.542333, 5.326556, -0.002924>
    }
    triangle {
      < 1.523759, 4.906872, 0.371754>,
      < 1.462984, 4.192017, -0.341670>,
      < 1.883869, 4.253895, -0.493437>
    }
    triangle {
      < 1.523759, 4.906872, 0.371754>,
      < 1.883869, 4.253895, -0.493437>,
      < 1.922380, 4.961071, 0.309447>
    }
    triangle {
      < 1.148426, 4.840314, 0.283156>,
      < 1.156556, 4.295053, -0.244954>,
      < 1.462984, 4.192017, -0.341670>
    }
    triangle {
      < 1.148426, 4.840314, 0.283156>,
      < 1.462984, 4.192017, -0.341670>,
      < 1.523759, 4.906872, 0.371754>
    }
    triangle {
      < 1.156556, 4.295053, -0.244954>,
      < 1.109287, 4.222658, -0.389658>,
      < 1.350401, 4.000060, -0.637910>
    }
    triangle {
      < 1.156556, 4.295053, -0.244954>,
      < 1.350401, 4.000060, -0.637910>,
      < 1.462984, 4.192017, -0.341670>
    }
    triangle {
      < 1.523759, 4.906872, 0.371754>,
      < 1.506171, 6.198785, 0.484386>,
      < 1.238348, 5.940702, 0.472670>
    }
    triangle {
      < 1.523759, 4.906872, 0.371754>,
      < 1.238348, 5.940702, 0.472670>,
      < 1.148426, 4.840314, 0.283156>
    }
    triangle {
      < 1.922380, 4.961071, 0.309447>,
      < 1.917271, 6.096984, 0.562636>,
      < 1.506171, 6.198785, 0.484386>
    }
    triangle {
      < 1.922380, 4.961071, 0.309447>,
      < 1.506171, 6.198785, 0.484386>,
      < 1.523759, 4.906872, 0.371754>
    }
    triangle {
      < 2.542333, 5.326556, -0.002924>,
      < 2.330512, 6.299601, 0.262144>,
      < 1.917271, 6.096984, 0.562636>
    }
    triangle {
      < 2.542333, 5.326556, -0.002924>,
      < 1.917271, 6.096984, 0.562636>,
      < 1.922380, 4.961071, 0.309447>
    }
    triangle {
      < 2.197367, 7.172413, 0.273125>,
      < 1.926717, 7.188261, 0.448640>,
      < 1.917271, 6.096984, 0.562636>
    }
    triangle {
      < 2.197367, 7.172413, 0.273125>,
      < 1.917271, 6.096984, 0.562636>,
      < 2.330512, 6.299601, 0.262144>
    }
    triangle {
      < 2.207831, 7.787432, 0.130303>,
      < 2.000672, 7.805625, 0.339448>,
      < 1.926717, 7.188261, 0.448640>
    }
    triangle {
      < 2.207831, 7.787432, 0.130303>,
      < 1.926717, 7.188261, 0.448640>,
      < 2.197367, 7.172413, 0.273125>
    }
    triangle {
      < 2.264757, 8.360371, 0.036182>,
      < 2.041171, 8.328996, 0.197016>,
      < 2.000672, 7.805625, 0.339448>
    }
    triangle {
      < 2.264757, 8.360371, 0.036182>,
      < 2.000672, 7.805625, 0.339448>,
      < 2.207831, 7.787432, 0.130303>
    }
    triangle {
      < 1.811272, 8.350312, 0.257340>,
      < 1.727092, 7.776976, 0.344528>,
      < 2.000672, 7.805625, 0.339448>
    }
    triangle {
      < 1.811272, 8.350312, 0.257340>,
      < 2.000672, 7.805625, 0.339448>,
      < 2.041171, 8.328996, 0.197016>
    }
    triangle {
      < 2.041171, 8.328996, 0.197016>,
      < 2.028868, 8.632567, 0.168562>,
      < 1.828851, 8.531735, 0.231749>
    }
    triangle {
      < 2.041171, 8.328996, 0.197016>,
      < 1.828851, 8.531735, 0.231749>,
      < 1.811272, 8.350312, 0.257340>
    }
    triangle {
      < 2.264757, 8.360371, 0.036182>,
      < 2.249767, 8.695644, 0.019894>,
      < 2.028868, 8.632567, 0.168562>
    }
    triangle {
      < 2.264757, 8.360371, 0.036182>,
      < 2.028868, 8.632567, 0.168562>,
      < 2.041171, 8.328996, 0.197016>
    }
    triangle {
      < 2.000672, 7.805625, 0.339448>,
      < 1.727092, 7.776976, 0.344528>,
      < 1.639386, 7.174335, 0.448677>
    }
    triangle {
      < 2.000672, 7.805625, 0.339448>,
      < 1.639386, 7.174335, 0.448677>,
      < 1.926717, 7.188261, 0.448640>
    }
    triangle {
      < 2.028868, 8.632567, 0.168562>,
      < 2.012497, 8.790535, 0.229861>,
      < 1.805840, 8.641598, 0.263489>
    }
    triangle {
      < 2.028868, 8.632567, 0.168562>,
      < 1.805840, 8.641598, 0.263489>,
      < 1.828851, 8.531735, 0.231749>
    }
    triangle {
      < 2.249767, 8.695644, 0.019894>,
      < 2.270350, 8.936516, 0.163526>,
      < 2.012497, 8.790535, 0.229861>
    }
    triangle {
      < 2.249767, 8.695644, 0.019894>,
      < 2.012497, 8.790535, 0.229861>,
      < 2.028868, 8.632567, 0.168562>
    }
    triangle {
      < 2.185188, 9.002164, 0.402722>,
      < 1.971650, 8.855663, 0.465910>,
      < 2.012497, 8.790535, 0.229861>
    }
    triangle {
      < 2.185188, 9.002164, 0.402722>,
      < 2.012497, 8.790535, 0.229861>,
      < 2.270350, 8.936516, 0.163526>
    }
    triangle {
      < 1.891534, 8.777411, 1.002220>,
      < 1.647696, 8.606560, 0.948423>,
      < 1.792122, 8.717618, 0.442839>
    }
    triangle {
      < 1.891534, 8.777411, 1.002220>,
      < 1.792122, 8.717618, 0.442839>,
      < 1.971650, 8.855663, 0.465910>
    }
    triangle {
      < 1.601344, 8.730423, 1.554419>,
      < 1.392183, 8.540370, 1.434910>,
      < 1.647696, 8.606560, 0.948423>
    }
    triangle {
      < 1.601344, 8.730423, 1.554419>,
      < 1.647696, 8.606560, 0.948423>,
      < 1.891534, 8.777411, 1.002220>
    }
    triangle {
      < 0.987856, 8.710015, 2.176044>,
      < 0.680408, 8.556564, 1.960871>,
      < 1.002136, 8.526634, 1.800382>
    }
    triangle {
      < 0.987856, 8.710015, 2.176044>,
      < 1.002136, 8.526634, 1.800382>,
      < 1.319051, 8.701921, 1.933999>
    }
    triangle {
      < 0.599243, 8.796925, 2.396621>,
      < 0.383177, 8.650391, 2.030931>,
      < 0.680408, 8.556564, 1.960871>
    }
    triangle {
      < 0.599243, 8.796925, 2.396621>,
      < 0.680408, 8.556564, 1.960871>,
      < 0.987856, 8.710015, 2.176044>
    }
    triangle {
      < 0.255350, 8.975057, 2.381315>,
      < 0.000000, 8.854424, 2.009160>,
      < 0.383177, 8.650391, 2.030931>
    }
    triangle {
      < 0.255350, 8.975057, 2.381315>,
      < 0.383177, 8.650391, 2.030931>,
      < 0.599243, 8.796925, 2.396621>
    }
    triangle {
      < 0.000000, 9.107080, 2.288430>,
      < 0.000000, 8.854424, 2.009160>,
      < 0.255350, 8.975057, 2.381315>
    }
    triangle {
      < 1.971650, 8.855663, 0.465910>,
      < 1.792122, 8.717618, 0.442839>,
      < 1.805840, 8.641598, 0.263489>
    }
    triangle {
      < 1.971650, 8.855663, 0.465910>,
      < 1.805840, 8.641598, 0.263489>,
      < 2.012497, 8.790535, 0.229861>
    }
    triangle {
      < 2.055095, 9.063828, 0.960787>,
      < 1.891534, 8.777411, 1.002220>,
      < 1.971650, 8.855663, 0.465910>
    }
    triangle {
      < 2.055095, 9.063828, 0.960787>,
      < 1.971650, 8.855663, 0.465910>,
      < 2.185188, 9.002164, 0.402722>
    }
    triangle {
      < 1.708395, 9.040586, 1.591635>,
      < 1.601344, 8.730423, 1.554419>,
      < 1.891534, 8.777411, 1.002220>
    }
    triangle {
      < 1.708395, 9.040586, 1.591635>,
      < 1.891534, 8.777411, 1.002220>,
      < 2.055095, 9.063828, 0.960787>
    }
    triangle {
      < 1.446800, 9.073135, 1.973879>,
      < 1.319051, 8.701921, 1.933999>,
      < 1.601344, 8.730423, 1.554419>
    }
    triangle {
      < 1.446800, 9.073135, 1.973879>,
      < 1.601344, 8.730423, 1.554419>,
      < 1.708395, 9.040586, 1.591635>
    }
    triangle {
      < 1.101010, 9.105548, 2.348224>,
      < 0.987856, 8.710015, 2.176044>,
      < 1.319051, 8.701921, 1.933999>
    }
    triangle {
      < 1.101010, 9.105548, 2.348224>,
      < 1.319051, 8.701921, 1.933999>,
      < 1.446800, 9.073135, 1.973879>
    }
    triangle {
      < 0.699663, 9.205090, 2.602089>,
      < 0.599243, 8.796925, 2.396621>,
      < 0.987856, 8.710015, 2.176044>
    }
    triangle {
      < 0.699663, 9.205090, 2.602089>,
      < 0.987856, 8.710015, 2.176044>,
      < 1.101010, 9.105548, 2.348224>
    }
    triangle {
      < 0.249266, 9.331985, 2.524297>,
      < 0.255350, 8.975057, 2.381315>,
      < 0.599243, 8.796925, 2.396621>
    }
    triangle {
      < 0.249266, 9.331985, 2.524297>,
      < 0.599243, 8.796925, 2.396621>,
      < 0.699663, 9.205090, 2.602089>
    }
    triangle {
      < 2.319053, 8.823269, -0.286861>,
      < 2.282247, 9.100043, -0.083286>,
      < 2.270350, 8.936516, 0.163526>
    }
    triangle {
      < 2.319053, 8.823269, -0.286861>,
      < 2.270350, 8.936516, 0.163526>,
      < 2.249767, 8.695644, 0.019894>
    }
    triangle {
      < 2.292505, 8.873673, -0.424492>,
      < 2.286398, 9.164603, -0.229685>,
      < 2.282247, 9.100043, -0.083286>
    }
    triangle {
      < 2.292505, 8.873673, -0.424492>,
      < 2.282247, 9.100043, -0.083286>,
      < 2.319053, 8.823269, -0.286861>
    }
    triangle {
      < 2.284901, 9.250681, 0.267759>,
      < 2.185188, 9.002164, 0.402722>,
      < 2.270350, 8.936516, 0.163526>
    }
    triangle {
      < 2.284901, 9.250681, 0.267759>,
      < 2.270350, 8.936516, 0.163526>,
      < 2.282247, 9.100043, -0.083286>
    }
    triangle {
      < 2.056396, 9.225585, 0.884461>,
      < 2.055095, 9.063828, 0.960787>,
      < 2.185188, 9.002164, 0.402722>
    }
    triangle {
      < 2.056396, 9.225585, 0.884461>,
      < 2.185188, 9.002164, 0.402722>,
      < 2.284901, 9.250681, 0.267759>
    }
    triangle {
      < 1.733561, 9.311479, 1.537561>,
      < 1.708395, 9.040586, 1.591635>,
      < 2.055095, 9.063828, 0.960787>
    }
    triangle {
      < 1.733561, 9.311479, 1.537561>,
      < 2.055095, 9.063828, 0.960787>,
      < 2.056396, 9.225585, 0.884461>
    }
    triangle {
      < 1.465756, 9.403043, 1.874206>,
      < 1.446800, 9.073135, 1.973879>,
      < 1.708395, 9.040586, 1.591635>
    }
    triangle {
      < 1.465756, 9.403043, 1.874206>,
      < 1.708395, 9.040586, 1.591635>,
      < 1.733561, 9.311479, 1.537561>
    }
    triangle {
      < 1.137060, 9.513208, 2.292973>,
      < 1.101010, 9.105548, 2.348224>,
      < 1.446800, 9.073135, 1.973879>
    }
    triangle {
      < 1.137060, 9.513208, 2.292973>,
      < 1.446800, 9.073135, 1.973879>,
      < 1.465756, 9.403043, 1.874206>
    }
    triangle {
      < 0.732736, 9.619038, 2.624132>,
      < 0.699663, 9.205090, 2.602089>,
      < 1.101010, 9.105548, 2.348224>
    }
    triangle {
      < 0.732736, 9.619038, 2.624132>,
      < 1.101010, 9.105548, 2.348224>,
      < 1.137060, 9.513208, 2.292973>
    }
    triangle {
      < 0.261909, 9.676860, 2.534168>,
      < 0.249266, 9.331985, 2.524297>,
      < 0.699663, 9.205090, 2.602089>
    }
    triangle {
      < 0.261909, 9.676860, 2.534168>,
      < 0.699663, 9.205090, 2.602089>,
      < 0.732736, 9.619038, 2.624132>
    }
    triangle {
      < 0.000000, 9.676222, 2.368930>,
      < 0.000000, 9.425873, 2.379832>,
      < 0.249266, 9.331985, 2.524297>
    }
    triangle {
      < 0.000000, 9.676222, 2.368930>,
      < 0.249266, 9.331985, 2.524297>,
      < 0.261909, 9.676860, 2.534168>
    }
    triangle {
      < 0.249266, 9.331985, 2.524297>,
      < 0.000000, 9.425873, 2.379832>,
      < 0.000000, 9.107080, 2.288430>
    }
    triangle {
      < 0.249266, 9.331985, 2.524297>,
      < 0.000000, 9.107080, 2.288430>,
      < 0.255350, 8.975057, 2.381315>
    }
    triangle {
      < 0.434081, 8.903049, -3.029997>,
      < 0.469544, 7.723520, -2.859780>,
      < 0.000000, 7.624628, -2.870633>
    }
    triangle {
      < 0.434081, 8.903049, -3.029997>,
      < 0.000000, 7.624628, -2.870633>,
      < 0.000000, 8.905552, -3.064667>
    }
    triangle {
      < 0.968716, 8.279623, -2.944191>,
      < 0.804466, 8.007513, -2.919087>,
      < 0.469544, 7.723520, -2.859780>
    }
    triangle {
      < 0.968716, 8.279623, -2.944191>,
      < 0.469544, 7.723520, -2.859780>,
      < 0.434081, 8.903049, -3.029997>
    }
    triangle {
      < 0.434081, 8.903049, -3.029997>,
      < 1.047604, 8.860490, -2.939014>,
      < 0.968716, 8.279623, -2.944191>
    }
    triangle {
      < 1.630740, 8.748152, -2.586531>,
      < 1.568699, 7.815787, -2.585501>,
      < 1.268084, 7.926604, -2.755030>
    }
    triangle {
      < 1.630740, 8.748152, -2.586531>,
      < 1.268084, 7.926604, -2.755030>,
      < 0.968716, 8.279623, -2.944191>
    }
    triangle {
      < 1.630740, 8.748152, -2.586531>,
      < 0.968716, 8.279623, -2.944191>,
      < 1.047604, 8.860490, -2.939014>
    }
    triangle {
      < 2.097196, 8.656051, -1.801888>,
      < 2.126979, 7.757913, -1.940661>,
      < 1.568699, 7.815787, -2.585501>
    }
    triangle {
      < 2.097196, 8.656051, -1.801888>,
      < 1.568699, 7.815787, -2.585501>,
      < 1.630740, 8.748152, -2.586531>
    }
    triangle {
      < 1.630740, 8.748152, -2.586531>,
      < 1.514965, 9.554935, -2.259202>,
      < 1.926966, 9.320498, -1.541335>
    }
    triangle {
      < 1.630740, 8.748152, -2.586531>,
      < 1.926966, 9.320498, -1.541335>,
      < 2.097196, 8.656051, -1.801888>
    }
    triangle {
      < 1.047604, 8.860490, -2.939014>,
      < 1.026081, 9.603339, -2.643369>,
      < 1.514965, 9.554935, -2.259202>
    }
    triangle {
      < 1.047604, 8.860490, -2.939014>,
      < 1.514965, 9.554935, -2.259202>,
      < 1.630740, 8.748152, -2.586531>
    }
    triangle {
      < 0.434081, 8.903049, -3.029997>,
      < 0.446711, 9.532402, -2.810143>,
      < 1.026081, 9.603339, -2.643369>
    }
    triangle {
      < 0.434081, 8.903049, -3.029997>,
      < 1.026081, 9.603339, -2.643369>,
      < 1.047604, 8.860490, -2.939014>
    }
    triangle {
      < 0.000000, 8.905552, -3.064667>,
      < 0.000000, 9.582272, -2.824734>,
      < 0.446711, 9.532402, -2.810143>
    }
    triangle {
      < 0.000000, 8.905552, -3.064667>,
      < 0.446711, 9.532402, -2.810143>,
      < 0.434081, 8.903049, -3.029997>
    }
    triangle {
      < 1.568699, 7.815787, -2.585501>,
      < 1.442480, 7.603398, -2.575616>,
      < 1.268084, 7.926604, -2.755030>
    }
    triangle {
      < 2.126979, 7.757913, -1.940661>,
      < 1.935595, 7.177408, -2.135517>,
      < 1.442480, 7.603398, -2.575616>
    }
    triangle {
      < 2.126979, 7.757913, -1.940661>,
      < 1.442480, 7.603398, -2.575616>,
      < 1.568699, 7.815787, -2.585501>
    }
    triangle {
      < 1.809644, 6.943704, -2.198517>,
      < 1.442480, 7.603398, -2.575616>,
      < 1.935595, 7.177408, -2.135517>
    }
    triangle {
      < 1.613503, 6.780987, -2.334113>,
      < 1.211628, 7.371768, -2.620786>,
      < 1.442480, 7.603398, -2.575616>
    }
    triangle {
      < 1.613503, 6.780987, -2.334113>,
      < 1.442480, 7.603398, -2.575616>,
      < 1.809644, 6.943704, -2.198517>
    }
    triangle {
      < 1.403973, 6.678395, -2.479017>,
      < 1.211628, 7.371768, -2.620786>,
      < 1.613503, 6.780987, -2.334113>
    }
    triangle {
      < 1.181260, 6.567130, -2.555930>,
      < 1.007608, 7.261537, -2.675797>,
      < 1.211628, 7.371768, -2.620786>
    }
    triangle {
      < 1.181260, 6.567130, -2.555930>,
      < 1.211628, 7.371768, -2.620786>,
      < 1.403973, 6.678395, -2.479017>
    }
    triangle {
      < 0.507013, 6.480210, -2.627249>,
      < 0.441592, 7.157158, -2.704895>,
      < 1.007608, 7.261537, -2.675797>
    }
    triangle {
      < 0.507013, 6.480210, -2.627249>,
      < 1.007608, 7.261537, -2.675797>,
      < 1.181260, 6.567130, -2.555930>
    }
    triangle {
      < 0.000000, 6.404224, -2.712183>,
      < 0.000000, 7.103825, -2.743361>,
      < 0.441592, 7.157158, -2.704895>
    }
    triangle {
      < 0.000000, 6.404224, -2.712183>,
      < 0.441592, 7.157158, -2.704895>,
      < 0.507013, 6.480210, -2.627249>
    }
    triangle {
      < 0.000000, 7.624628, -2.870633>,
      < 0.469544, 7.723520, -2.859780>,
      < 0.441592, 7.157158, -2.704895>
    }
    triangle {
      < 0.000000, 7.624628, -2.870633>,
      < 0.441592, 7.157158, -2.704895>,
      < 0.000000, 7.103825, -2.743361>
    }
    triangle {
      < 0.804466, 8.007513, -2.919087>,
      < 1.007608, 7.261537, -2.675797>,
      < 0.441592, 7.157158, -2.704895>
    }
    triangle {
      < 0.804466, 8.007513, -2.919087>,
      < 0.441592, 7.157158, -2.704895>,
      < 0.469544, 7.723520, -2.859780>
    }
    triangle {
      < 1.268084, 7.926604, -2.755030>,
      < 1.442480, 7.603398, -2.575616>,
      < 1.211628, 7.371768, -2.620786>
    }
    triangle {
      < 1.268084, 7.926604, -2.755030>,
      < 1.211628, 7.371768, -2.620786>,
      < 1.007608, 7.261537, -2.675797>
    }
    triangle {
      < 1.268084, 7.926604, -2.755030>,
      < 1.007608, 7.261537, -2.675797>,
      < 0.804466, 8.007513, -2.919087>
    }
    triangle {
      < 1.268084, 7.926604, -2.755030>,
      < 0.804466, 8.007513, -2.919087>,
      < 0.968716, 8.279623, -2.944191>
    }
    triangle {
      < 0.507013, 6.480210, -2.627249>,
      < 0.629737, 5.668156, -2.875407>,
      < 0.000000, 5.577987, -2.943249>
    }
    triangle {
      < 0.507013, 6.480210, -2.627249>,
      < 0.000000, 5.577987, -2.943249>,
      < 0.000000, 6.404224, -2.712183>
    }
    triangle {
      < 1.181260, 6.567130, -2.555930>,
      < 1.383150, 5.848190, -2.730564>,
      < 0.629737, 5.668156, -2.875407>
    }
    triangle {
      < 1.181260, 6.567130, -2.555930>,
      < 0.629737, 5.668156, -2.875407>,
      < 0.507013, 6.480210, -2.627249>
    }
    triangle {
      < 1.403973, 6.678395, -2.479017>,
      < 1.812413, 5.978925, -2.594764>,
      < 1.383150, 5.848190, -2.730564>
    }
    triangle {
      < 1.403973, 6.678395, -2.479017>,
      < 1.383150, 5.848190, -2.730564>,
      < 1.181260, 6.567130, -2.555930>
    }
    triangle {
      < 1.613503, 6.780987, -2.334113>,
      < 2.064757, 6.140160, -2.288342>,
      < 1.812413, 5.978925, -2.594764>
    }
    triangle {
      < 1.613503, 6.780987, -2.334113>,
      < 1.812413, 5.978925, -2.594764>,
      < 1.403973, 6.678395, -2.479017>
    }
    triangle {
      < 0.629737, 5.668156, -2.875407>,
      < 0.798679, 5.106549, -3.156878>,
      < 0.000000, 5.020720, -3.259467>
    }
    triangle {
      < 0.629737, 5.668156, -2.875407>,
      < 0.000000, 5.020720, -3.259467>,
      < 0.000000, 5.577987, -2.943249>
    }
    triangle {
      < 1.383150, 5.848190, -2.730564>,
      < 1.649015, 5.307382, -2.979003>,
      < 0.798679, 5.106549, -3.156878>
    }
    triangle {
      < 1.383150, 5.848190, -2.730564>,
      < 0.798679, 5.106549, -3.156878>,
      < 0.629737, 5.668156, -2.875407>
    }
    triangle {
      < 1.812413, 5.978925, -2.594764>,
      < 2.241066, 5.455282, -2.807144>,
      < 1.649015, 5.307382, -2.979003>
    }
    triangle {
      < 1.812413, 5.978925, -2.594764>,
      < 1.649015, 5.307382, -2.979003>,
      < 1.383150, 5.848190, -2.730564>
    }
    triangle {
      < 2.064757, 6.140160, -2.288342>,
      < 2.543283, 5.618077, -2.285651>,
      < 2.241066, 5.455282, -2.807144>
    }
    triangle {
      < 2.064757, 6.140160, -2.288342>,
      < 2.241066, 5.455282, -2.807144>,
      < 1.812413, 5.978925, -2.594764>
    }
    triangle {
      < 2.807642, 5.119742, -2.192055>,
      < 2.435137, 4.892701, -2.746463>,
      < 2.241066, 5.455282, -2.807144>
    }
    triangle {
      < 2.807642, 5.119742, -2.192055>,
      < 2.241066, 5.455282, -2.807144>,
      < 2.543283, 5.618077, -2.285651>
    }
    triangle {
      < 1.800736, 4.722509, -3.002015>,
      < 1.649015, 5.307382, -2.979003>,
      < 2.241066, 5.455282, -2.807144>
    }
    triangle {
      < 1.800736, 4.722509, -3.002015>,
      < 2.241066, 5.455282, -2.807144>,
      < 2.435137, 4.892701, -2.746463>
    }
    triangle {
      < 0.894068, 4.551052, -3.116934>,
      < 0.798679, 5.106549, -3.156878>,
      < 1.649015, 5.307382, -2.979003>
    }
    triangle {
      < 0.894068, 4.551052, -3.116934>,
      < 1.649015, 5.307382, -2.979003>,
      < 1.800736, 4.722509, -3.002015>
    }
    triangle {
      < 0.000000, 4.458508, -3.182819>,
      < 0.000000, 5.020720, -3.259467>,
      < 0.798679, 5.106549, -3.156878>
    }
    triangle {
      < 0.000000, 4.458508, -3.182819>,
      < 0.798679, 5.106549, -3.156878>,
      < 0.894068, 4.551052, -3.116934>
    }
    triangle {
      < 0.894068, 4.551052, -3.116934>,
      < 0.959599, 3.783694, -2.768924>,
      < 0.000000, 3.626533, -2.862228>
    }
    triangle {
      < 0.894068, 4.551052, -3.116934>,
      < 0.000000, 3.626533, -2.862228>,
      < 0.000000, 4.458508, -3.182819>
    }
    triangle {
      < 1.800736, 4.722509, -3.002015>,
      < 1.888283, 3.938280, -2.489334>,
      < 0.959599, 3.783694, -2.768924>
    }
    triangle {
      < 1.800736, 4.722509, -3.002015>,
      < 0.959599, 3.783694, -2.768924>,
      < 0.894068, 4.551052, -3.116934>
    }
    triangle {
      < 2.435137, 4.892701, -2.746463>,
      < 2.394799, 4.114178, -2.171901>,
      < 1.888283, 3.938280, -2.489334>
    }
    triangle {
      < 2.435137, 4.892701, -2.746463>,
      < 1.888283, 3.938280, -2.489334>,
      < 1.800736, 4.722509, -3.002015>
    }
    triangle {
      < 2.807642, 5.119742, -2.192055>,
      < 2.771923, 4.394222, -1.718391>,
      < 2.394799, 4.114178, -2.171901>
    }
    triangle {
      < 2.807642, 5.119742, -2.192055>,
      < 2.394799, 4.114178, -2.171901>,
      < 2.435137, 4.892701, -2.746463>
    }
    triangle {
      < 2.320945, 3.991879, -1.246104>,
      < 2.141117, 3.745879, -1.649152>,
      < 2.394799, 4.114178, -2.171901>
    }
    triangle {
      < 2.320945, 3.991879, -1.246104>,
      < 2.394799, 4.114178, -2.171901>,
      < 2.771923, 4.394222, -1.718391>
    }
    triangle {
      < 1.754788, 3.591762, -1.875521>,
      < 1.888283, 3.938280, -2.489334>,
      < 2.394799, 4.114178, -2.171901>
    }
    triangle {
      < 1.754788, 3.591762, -1.875521>,
      < 2.394799, 4.114178, -2.171901>,
      < 2.141117, 3.745879, -1.649152>
    }
    triangle {
      < 0.810586, 3.425251, -2.206288>,
      < 0.959599, 3.783694, -2.768924>,
      < 1.888283, 3.938280, -2.489334>
    }
    triangle {
      < 0.810586, 3.425251, -2.206288>,
      < 1.888283, 3.938280, -2.489334>,
      < 1.754788, 3.591762, -1.875521>
    }
    triangle {
      < 0.000000, 3.301184, -2.361485>,
      < 0.000000, 3.626533, -2.862228>,
      < 0.959599, 3.783694, -2.768924>
    }
    triangle {
      < 0.000000, 3.301184, -2.361485>,
      < 0.959599, 3.783694, -2.768924>,
      < 0.810586, 3.425251, -2.206288>
    }
    triangle {
      < 1.754788, 3.591762, -1.875521>,
      < 1.410822, 3.628767, -1.366164>,
      < 0.740513, 3.381576, -1.620888>
    }
    triangle {
      < 1.754788, 3.591762, -1.875521>,
      < 0.740513, 3.381576, -1.620888>,
      < 0.810586, 3.425251, -2.206288>
    }
    triangle {
      < 2.141117, 3.745879, -1.649152>,
      < 1.737683, 3.779556, -1.074812>,
      < 1.410822, 3.628767, -1.366164>
    }
    triangle {
      < 2.141117, 3.745879, -1.649152>,
      < 1.410822, 3.628767, -1.366164>,
      < 1.754788, 3.591762, -1.875521>
    }
    triangle {
      < 2.320945, 3.991879, -1.246104>,
      < 1.797362, 3.947582, -0.884269>,
      < 1.737683, 3.779556, -1.074812>
    }
    triangle {
      < 2.320945, 3.991879, -1.246104>,
      < 1.737683, 3.779556, -1.074812>,
      < 2.141117, 3.745879, -1.649152>
    }
    triangle {
      < 0.000000, 10.103044, -2.437498>,
      < 0.312674, 10.106316, -2.341642>,
      < 0.446711, 9.532402, -2.810143>
    }
    triangle {
      < 0.000000, 10.103044, -2.437498>,
      < 0.446711, 9.532402, -2.810143>,
      < 0.000000, 9.582272, -2.824734>
    }
    triangle {
      < 0.801285, 10.138000, -2.101213>,
      < 1.026081, 9.603339, -2.643369>,
      < 0.446711, 9.532402, -2.810143>
    }
    triangle {
      < 0.801285, 10.138000, -2.101213>,
      < 0.446711, 9.532402, -2.810143>,
      < 0.312674, 10.106316, -2.341642>
    }
    triangle {
      < 1.352927, 10.028240, -1.712292>,
      < 1.514965, 9.554935, -2.259202>,
      < 1.026081, 9.603339, -2.643369>
    }
    triangle {
      < 1.352927, 10.028240, -1.712292>,
      < 1.026081, 9.603339, -2.643369>,
      < 0.801285, 10.138000, -2.101213>
    }
    triangle {
      < 1.721511, 9.733690, -1.174845>,
      < 1.926966, 9.320498, -1.541335>,
      < 1.514965, 9.554935, -2.259202>
    }
    triangle {
      < 1.721511, 9.733690, -1.174845>,
      < 1.514965, 9.554935, -2.259202>,
      < 1.352927, 10.028240, -1.712292>
    }
    triangle {
      < 1.901165, 9.490677, -0.758218>,
      < 2.049096, 9.113437, -1.064185>,
      < 1.926966, 9.320498, -1.541335>
    }
    triangle {
      < 1.901165, 9.490677, -0.758218>,
      < 1.926966, 9.320498, -1.541335>,
      < 1.721511, 9.733690, -1.174845>
    }
    triangle {
      < 2.047613, 9.230265, -0.380456>,
      < 2.127863, 9.054000, -0.469666>,
      < 2.157858, 8.891205, -0.589506>
    }
    triangle {
      < 2.047613, 9.230265, -0.380456>,
      < 2.157858, 8.891205, -0.589506>,
      < 2.049096, 9.113437, -1.064185>
    }
    triangle {
      < 2.047613, 9.230265, -0.380456>,
      < 2.049096, 9.113437, -1.064185>,
      < 1.901165, 9.490677, -0.758218>
    }
    triangle {
      < 2.286398, 9.164603, -0.229685>,
      < 2.292505, 8.873673, -0.424492>,
      < 2.157858, 8.891205, -0.589506>
    }
    triangle {
      < 2.286398, 9.164603, -0.229685>,
      < 2.157858, 8.891205, -0.589506>,
      < 2.127863, 9.054000, -0.469666>
    }
    triangle {
      < 2.286398, 9.164603, -0.229685>,
      < 2.127863, 9.054000, -0.469666>,
      < 2.047613, 9.230265, -0.380456>
    }
    triangle {
      < 0.256023, 10.441054, -1.625575>,
      < 0.512046, 10.486948, -1.404077>,
      < 0.801285, 10.138000, -2.101213>
    }
    triangle {
      < 0.256023, 10.441054, -1.625575>,
      < 0.801285, 10.138000, -2.101213>,
      < 0.312674, 10.106316, -2.341642>
    }
    triangle {
      < 1.095283, 10.363935, -0.991215>,
      < 1.352927, 10.028240, -1.712292>,
      < 0.801285, 10.138000, -2.101213>
    }
    triangle {
      < 1.095283, 10.363935, -0.991215>,
      < 0.801285, 10.138000, -2.101213>,
      < 0.512046, 10.486948, -1.404077>
    }
    triangle {
      < 1.595059, 10.016598, -0.523450>,
      < 1.721511, 9.733690, -1.174845>,
      < 1.352927, 10.028240, -1.712292>
    }
    triangle {
      < 1.595059, 10.016598, -0.523450>,
      < 1.352927, 10.028240, -1.712292>,
      < 1.095283, 10.363935, -0.991215>
    }
    triangle {
      < 1.775840, 9.758400, -0.294073>,
      < 1.901165, 9.490677, -0.758218>,
      < 1.721511, 9.733690, -1.174845>
    }
    triangle {
      < 1.775840, 9.758400, -0.294073>,
      < 1.721511, 9.733690, -1.174845>,
      < 1.595059, 10.016598, -0.523450>
    }
    triangle {
      < 1.959134, 9.398203, -0.008383>,
      < 2.047613, 9.230265, -0.380456>,
      < 1.901165, 9.490677, -0.758218>
    }
    triangle {
      < 1.959134, 9.398203, -0.008383>,
      < 1.901165, 9.490677, -0.758218>,
      < 1.775840, 9.758400, -0.294073>
    }
    triangle {
      < 2.252386, 9.379482, 0.153680>,
      < 2.286398, 9.164603, -0.229685>,
      < 2.047613, 9.230265, -0.380456>
    }
    triangle {
      < 2.252386, 9.379482, 0.153680>,
      < 2.047613, 9.230265, -0.380456>,
      < 1.959134, 9.398203, -0.008383>
    }
    triangle {
      < 2.284901, 9.250681, 0.267759>,
      < 2.282247, 9.100043, -0.083286>,
      < 2.286398, 9.164603, -0.229685>
    }
    triangle {
      < 2.284901, 9.250681, 0.267759>,
      < 2.286398, 9.164603, -0.229685>,
      < 2.252386, 9.379482, 0.153680>
    }
    triangle {
      < 0.282734, 10.530972, -1.248772>,
      < 0.730800, 10.500572, -0.462674>,
      < 1.095283, 10.363935, -0.991215>
    }
    triangle {
      < 0.282734, 10.530972, -1.248772>,
      < 1.095283, 10.363935, -0.991215>,
      < 0.512046, 10.486948, -1.404077>
    }
    triangle {
      < 0.504874, 10.493316, -0.312871>,
      < 0.730800, 10.500572, -0.462674>,
      < 0.282734, 10.530972, -1.248772>
    }
    triangle {
      < 0.282734, 10.530972, -1.248772>,
      < 0.275809, 10.487108, -0.299676>,
      < 0.504874, 10.493316, -0.312871>
    }
    triangle {
      < 0.000000, 10.556360, -1.255870>,
      < 0.000000, 10.428140, -0.147974>,
      < 0.275809, 10.487108, -0.299676>
    }
    triangle {
      < 0.000000, 10.556360, -1.255870>,
      < 0.275809, 10.487108, -0.299676>,
      < 0.282734, 10.530972, -1.248772>
    }
    triangle {
      < 0.512046, 10.486948, -1.404077>,
      < 0.256023, 10.441054, -1.625575>,
      < 0.282734, 10.530972, -1.248772>
    }
    triangle {
      < 0.882110, 10.198242, 0.534316>,
      < 1.327421, 10.210172, 0.149119>,
      < 0.730800, 10.500572, -0.462674>
    }
    triangle {
      < 0.882110, 10.198242, 0.534316>,
      < 0.730800, 10.500572, -0.462674>,
      < 0.504874, 10.493316, -0.312871>
    }
    triangle {
      < 0.504874, 10.493316, -0.312871>,
      < 0.275809, 10.487108, -0.299676>,
      < 0.506844, 10.207478, 0.621239>
    }
    triangle {
      < 0.504874, 10.493316, -0.312871>,
      < 0.506844, 10.207478, 0.621239>,
      < 0.882110, 10.198242, 0.534316>
    }
    triangle {
      < 0.274110, 10.197698, 0.669496>,
      < 0.506844, 10.207478, 0.621239>,
      < 0.275809, 10.487108, -0.299676>
    }
    triangle {
      < 0.275809, 10.487108, -0.299676>,
      < 0.000000, 10.428140, -0.147974>,
      < 0.000000, 10.129307, 0.640858>
    }
    triangle {
      < 0.275809, 10.487108, -0.299676>,
      < 0.000000, 10.129307, 0.640858>,
      < 0.274110, 10.197698, 0.669496>
    }
    triangle {
      < 1.327421, 10.210172, 0.149119>,
      < 1.595059, 10.016598, -0.523450>,
      < 1.095283, 10.363935, -0.991215>
    }
    triangle {
      < 1.327421, 10.210172, 0.149119>,
      < 1.095283, 10.363935, -0.991215>,
      < 0.730800, 10.500572, -0.462674>
    }
    triangle {
      < 1.477108, 9.966330, 0.362745>,
      < 1.775840, 9.758400, -0.294073>,
      < 1.595059, 10.016598, -0.523450>
    }
    triangle {
      < 1.477108, 9.966330, 0.362745>,
      < 1.595059, 10.016598, -0.523450>,
      < 1.327421, 10.210172, 0.149119>
    }
    triangle {
      < 1.755289, 9.487906, 0.677609>,
      < 1.959134, 9.398203, -0.008383>,
      < 1.775840, 9.758400, -0.294073>
    }
    triangle {
      < 1.755289, 9.487906, 0.677609>,
      < 1.775840, 9.758400, -0.294073>,
      < 1.477108, 9.966330, 0.362745>
    }
    triangle {
      < 1.935464, 9.390430, 0.837203>,
      < 2.252386, 9.379482, 0.153680>,
      < 1.959134, 9.398203, -0.008383>
    }
    triangle {
      < 1.935464, 9.390430, 0.837203>,
      < 1.959134, 9.398203, -0.008383>,
      < 1.755289, 9.487906, 0.677609>
    }
    triangle {
      < 2.056396, 9.225585, 0.884461>,
      < 2.284901, 9.250681, 0.267759>,
      < 2.252386, 9.379482, 0.153680>
    }
    triangle {
      < 2.056396, 9.225585, 0.884461>,
      < 2.252386, 9.379482, 0.153680>,
      < 1.935464, 9.390430, 0.837203>
    }
    triangle {
      < 1.086055, 10.010103, 0.967558>,
      < 1.103107, 10.000225, 0.919427>,
      < 1.477108, 9.966330, 0.362745>
    }
    triangle {
      < 1.086055, 10.010103, 0.967558>,
      < 1.477108, 9.966330, 0.362745>,
      < 1.327421, 10.210172, 0.149119>
    }
    triangle {
      < 1.086055, 10.010103, 0.967558>,
      < 1.327421, 10.210172, 0.149119>,
      < 0.882110, 10.198242, 0.534316>
    }
    triangle {
      < 1.099944, 9.986621, 0.982247>,
      < 1.449702, 9.772484, 1.224917>,
      < 1.755289, 9.487906, 0.677609>
    }
    triangle {
      < 1.099944, 9.986621, 0.982247>,
      < 1.755289, 9.487906, 0.677609>,
      < 1.477108, 9.966330, 0.362745>
    }
    triangle {
      < 1.099944, 9.986621, 0.982247>,
      < 1.477108, 9.966330, 0.362745>,
      < 1.103107, 10.000225, 0.919427>
    }
    triangle {
      < 1.099944, 9.986621, 0.982247>,
      < 1.105226, 9.995815, 1.016037>,
      < 1.338807, 9.885557, 1.425528>
    }
    triangle {
      < 1.099944, 9.986621, 0.982247>,
      < 1.338807, 9.885557, 1.425528>,
      < 1.449702, 9.772484, 1.224917>
    }
    triangle {
      < 1.338807, 9.885557, 1.425528>,
      < 1.420564, 9.691097, 1.678985>,
      < 1.667624, 9.513432, 1.415407>
    }
    triangle {
      < 1.338807, 9.885557, 1.425528>,
      < 1.667624, 9.513432, 1.415407>,
      < 1.449702, 9.772484, 1.224917>
    }
    triangle {
      < 1.667624, 9.513432, 1.415407>,
      < 1.935464, 9.390430, 0.837203>,
      < 1.755289, 9.487906, 0.677609>
    }
    triangle {
      < 1.667624, 9.513432, 1.415407>,
      < 1.755289, 9.487906, 0.677609>,
      < 1.449702, 9.772484, 1.224917>
    }
    triangle {
      < 2.056396, 9.225585, 0.884461>,
      < 1.935464, 9.390430, 0.837203>,
      < 1.667624, 9.513432, 1.415407>
    }
    triangle {
      < 2.056396, 9.225585, 0.884461>,
      < 1.667624, 9.513432, 1.415407>,
      < 1.733561, 9.311479, 1.537561>
    }
    triangle {
      < 1.667624, 9.513432, 1.415407>,
      < 1.420564, 9.691097, 1.678985>,
      < 1.465756, 9.403043, 1.874206>
    }
    triangle {
      < 1.667624, 9.513432, 1.415407>,
      < 1.465756, 9.403043, 1.874206>,
      < 1.733561, 9.311479, 1.537561>
    }
    triangle {
      < 1.420564, 9.691097, 1.678985>,
      < 1.128255, 9.897694, 2.124563>,
      < 1.137060, 9.513208, 2.292973>
    }
    triangle {
      < 1.420564, 9.691097, 1.678985>,
      < 1.137060, 9.513208, 2.292973>,
      < 1.465756, 9.403043, 1.874206>
    }
    triangle {
      < 1.105226, 9.995815, 1.016037>,
      < 1.084894, 10.020005, 1.020502>,
      < 0.861416, 10.225743, 1.316271>
    }
    triangle {
      < 1.105226, 9.995815, 1.016037>,
      < 0.861416, 10.225743, 1.316271>,
      < 1.033270, 10.098597, 1.766723>
    }
    triangle {
      < 1.105226, 9.995815, 1.016037>,
      < 1.033270, 10.098597, 1.766723>,
      < 1.338807, 9.885557, 1.425528>
    }
    triangle {
      < 0.684999, 10.033707, 1.161263>,
      < 0.861416, 10.225743, 1.316271>,
      < 1.084894, 10.020005, 1.020502>
    }
    triangle {
      < 1.086055, 10.010103, 0.967558>,
      < 0.882110, 10.198242, 0.534316>,
      < 0.506844, 10.207478, 0.621239>
    }
    triangle {
      < 1.086055, 10.010103, 0.967558>,
      < 0.506844, 10.207478, 0.621239>,
      < 0.683422, 10.023827, 1.109206>
    }
    triangle {
      < 0.274110, 10.197698, 0.669496>,
      < 0.343630, 9.996747, 1.136028>,
      < 0.683422, 10.023827, 1.109206>
    }
    triangle {
      < 0.274110, 10.197698, 0.669496>,
      < 0.683422, 10.023827, 1.109206>,
      < 0.506844, 10.207478, 0.621239>
    }
    triangle {
      < 0.000000, 10.129307, 0.640858>,
      < 0.000000, 9.961681, 1.162321>,
      < 0.343630, 9.996747, 1.136028>
    }
    triangle {
      < 0.000000, 10.129307, 0.640858>,
      < 0.343630, 9.996747, 1.136028>,
      < 0.274110, 10.197698, 0.669496>
    }
    triangle {
      < 0.462446, 10.313475, 1.547025>,
      < 0.344938, 10.006336, 1.188239>,
      < 0.343488, 10.005959, 1.188529>
    }
    triangle {
      < 0.462446, 10.313475, 1.547025>,
      < 0.343488, 10.005959, 1.188529>,
      < 0.254090, 10.268738, 1.602070>
    }
    triangle {
      < 0.861416, 10.225743, 1.316271>,
      < 0.684999, 10.033707, 1.161263>,
      < 0.344938, 10.006336, 1.188239>
    }
    triangle {
      < 0.861416, 10.225743, 1.316271>,
      < 0.344938, 10.006336, 1.188239>,
      < 0.462446, 10.313475, 1.547025>
    }
    triangle {
      < 0.462446, 10.313475, 1.547025>,
      < 0.547649, 10.323700, 2.058094>,
      < 1.033270, 10.098597, 1.766723>
    }
    triangle {
      < 0.462446, 10.313475, 1.547025>,
      < 1.033270, 10.098597, 1.766723>,
      < 0.861416, 10.225743, 1.316271>
    }
    triangle {
      < 0.655658, 10.001616, 2.429456>,
      < 1.128255, 9.897694, 2.124563>,
      < 1.033270, 10.098597, 1.766723>
    }
    triangle {
      < 0.655658, 10.001616, 2.429456>,
      < 1.033270, 10.098597, 1.766723>,
      < 0.547649, 10.323700, 2.058094>
    }
    triangle {
      < 0.547649, 10.323700, 2.058094>,
      < 0.213677, 10.232553, 2.038405>,
      < 0.263420, 9.947759, 2.352102>
    }
    triangle {
      < 0.547649, 10.323700, 2.058094>,
      < 0.263420, 9.947759, 2.352102>,
      < 0.655658, 10.001616, 2.429456>
    }
    triangle {
      < 1.420564, 9.691097, 1.678985>,
      < 1.338807, 9.885557, 1.425528>,
      < 1.033270, 10.098597, 1.766723>
    }
    triangle {
      < 1.420564, 9.691097, 1.678985>,
      < 1.033270, 10.098597, 1.766723>,
      < 1.128255, 9.897694, 2.124563>
    }
    triangle {
      < 1.128255, 9.897694, 2.124563>,
      < 0.655658, 10.001616, 2.429456>,
      < 0.732736, 9.619038, 2.624132>
    }
    triangle {
      < 1.128255, 9.897694, 2.124563>,
      < 0.732736, 9.619038, 2.624132>,
      < 1.137060, 9.513208, 2.292973>
    }
    triangle {
      < 0.213677, 10.232553, 2.038405>,
      < 0.547649, 10.323700, 2.058094>,
      < 0.462446, 10.313475, 1.547025>
    }
    triangle {
      < 0.213677, 10.232553, 2.038405>,
      < 0.462446, 10.313475, 1.547025>,
      < 0.254090, 10.268738, 1.602070>
    }
    triangle {
      < 0.254090, 10.268738, 1.602070>,
      < 0.000000, 10.138660, 1.618270>,
      < 0.000000, 10.109884, 2.025559>
    }
    triangle {
      < 0.254090, 10.268738, 1.602070>,
      < 0.000000, 10.109884, 2.025559>,
      < 0.213677, 10.232553, 2.038405>
    }
    triangle {
      < 0.000000, 9.868969, 2.276780>,
      < 0.263420, 9.947759, 2.352102>,
      < 0.213677, 10.232553, 2.038405>
    }
    triangle {
      < 0.000000, 9.868969, 2.276780>,
      < 0.213677, 10.232553, 2.038405>,
      < 0.000000, 10.109884, 2.025559>
    }
    triangle {
      < 0.261909, 9.676860, 2.534168>,
      < 0.732736, 9.619038, 2.624132>,
      < 0.655658, 10.001616, 2.429456>
    }
    triangle {
      < 0.261909, 9.676860, 2.534168>,
      < 0.655658, 10.001616, 2.429456>,
      < 0.263420, 9.947759, 2.352102>
    }
    triangle {
      < 0.000000, 3.556864, -1.285038>,
      < 0.637588, 3.615422, -1.159366>,
      < 0.499061, 4.222472, -0.703218>
    }
    triangle {
      < 0.000000, 3.556864, -1.285038>,
      < 0.499061, 4.222472, -0.703218>,
      < 0.000000, 4.222149, -0.712363>
    }
    triangle {
      < 0.000000, 3.252037, -1.835155>,
      < 0.740513, 3.381576, -1.620888>,
      < 0.637588, 3.615422, -1.159366>
    }
    triangle {
      < 0.000000, 3.252037, -1.835155>,
      < 0.637588, 3.615422, -1.159366>,
      < 0.000000, 3.556864, -1.285038>
    }
    triangle {
      < 1.350401, 4.000060, -0.637910>,
      < 1.109287, 4.222658, -0.389658>,
      < 0.860388, 4.222589, -0.582402>
    }
    triangle {
      < 1.350401, 4.000060, -0.637910>,
      < 0.860388, 4.222589, -0.582402>,
      < 1.099824, 3.816411, -0.941113>
    }
    triangle {
      < 1.099824, 3.816411, -0.941113>,
      < 1.410822, 3.628767, -1.366164>,
      < 1.737683, 3.779556, -1.074812>
    }
    triangle {
      < 1.099824, 3.816411, -0.941113>,
      < 1.737683, 3.779556, -1.074812>,
      < 1.350401, 4.000060, -0.637910>
    }
    triangle {
      < 0.637588, 3.615422, -1.159366>,
      < 0.740513, 3.381576, -1.620888>,
      < 1.410822, 3.628767, -1.366164>
    }
    triangle {
      < 0.637588, 3.615422, -1.159366>,
      < 1.410822, 3.628767, -1.366164>,
      < 1.099824, 3.816411, -0.941113>
    }
    triangle {
      < 1.797362, 3.947582, -0.884269>,
      < 1.350401, 4.000060, -0.637910>,
      < 1.737683, 3.779556, -1.074812>
    }
    triangle {
      < 0.740513, 3.381576, -1.620888>,
      < 0.000000, 3.252037, -1.835155>,
      < 0.000000, 3.301184, -2.361485>
    }
    triangle {
      < 0.740513, 3.381576, -1.620888>,
      < 0.000000, 3.301184, -2.361485>,
      < 0.810586, 3.425251, -2.206288>
    }
    triangle {
      < 1.601344, 8.730423, 1.554419>,
      < 1.319051, 8.701921, 1.933999>,
      < 1.002136, 8.526634, 1.800382>
    }
    triangle {
      < 1.601344, 8.730423, 1.554419>,
      < 1.002136, 8.526634, 1.800382>,
      < 1.208542, 8.514754, 1.669742>
    }
    triangle {
      < 1.601344, 8.730423, 1.554419>,
      < 1.208542, 8.514754, 1.669742>,
      < 1.392183, 8.540370, 1.434910>
    }
    triangle {
      < 1.238348, 5.940702, 0.472670>,
      < 1.038925, 5.856872, 0.438530>,
      < 1.148426, 4.840314, 0.283156>
    }
    triangle {
      < 1.506171, 6.198785, 0.484386>,
      < 1.917271, 6.096984, 0.562636>,
      < 1.676612, 6.440908, 0.456156>
    }
    triangle {
      < 0.000000, 9.970675, 1.215246>,
      < 0.000000, 10.138660, 1.618270>,
      < 0.254090, 10.268738, 1.602070>
    }
    triangle {
      < 0.000000, 9.970675, 1.215246>,
      < 0.254090, 10.268738, 1.602070>,
      < 0.343488, 10.005959, 1.188529>
    }
    triangle {
      < 0.499061, 4.222472, -0.703218>,
      < 0.637588, 3.615422, -1.159366>,
      < 1.099824, 3.816411, -0.941113>
    }
    triangle {
      < 0.499061, 4.222472, -0.703218>,
      < 1.099824, 3.816411, -0.941113>,
      < 0.860388, 4.222589, -0.582402>
    }
    triangle {
      < 1.639386, 7.174335, 0.448677>,
      < 1.685030, 6.993190, 0.456504>,
      < 1.926717, 7.188261, 0.448640>
    }
    triangle {
      < 1.926717, 7.188261, 0.448640>,
      < 1.728852, 6.717050, 0.456330>,
      < 1.676612, 6.440908, 0.456156>
    }
    triangle {
      < 1.926717, 7.188261, 0.448640>,
      < 1.676612, 6.440908, 0.456156>,
      < 1.917271, 6.096984, 0.562636>
    }
    texture {hair}
  }
  // lash
  union {
    triangle {
      < 1.205264, 7.688103, 1.703732>,
      < 1.199642, 7.673470, 1.737281>,
      < 1.217140, 7.601475, 1.575520>
    }
    triangle {
      < 1.205264, 7.688103, 1.703732>,
      < 1.217140, 7.601475, 1.575520>,
      < 1.226924, 7.611438, 1.536010>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < 1.222239, 7.779233, 1.314082>,
      < 1.183912, 7.723730, 1.527919>,
      < 1.190138, 7.595891, 1.288325>
    }
    triangle {
      < 1.222239, 7.779233, 1.314082>,
      < 1.190138, 7.595891, 1.288325>,
      < 1.221443, 7.665048, 1.236122>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < 1.148426, 4.840314, 0.283156>,
      < 0.813469, 4.923323, 0.096762>,
      < 1.156556, 4.295053, -0.244954>
    }
    triangle {
      < 0.813469, 4.923323, 0.096762>,
      < 1.148426, 4.840314, 0.283156>,
      < 1.038925, 5.856872, 0.438530>
    }
    triangle {
      < 0.813469, 4.923323, 0.096762>,
      < 1.038925, 5.856872, 0.438530>,
      < 0.488515, 5.798268, 0.415098>
    }
    triangle {
      < 0.000000, 5.124914, -0.355912>,
      < 0.000000, 4.222149, -0.712363>,
      < 0.499061, 4.222472, -0.703218>
    }
    triangle {
      < 0.000000, 5.124914, -0.355912>,
      < 0.499061, 4.222472, -0.703218>,
      < 0.382808, 5.030048, -0.142889>
    }
    triangle {
      < 0.000000, 5.798498, 0.394301>,
      < 0.000000, 5.124914, -0.355912>,
      < 0.382808, 5.030048, -0.142889>
    }
    triangle {
      < 0.000000, 5.798498, 0.394301>,
      < 0.382808, 5.030048, -0.142889>,
      < 0.259731, 5.798376, 0.405359>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < 0.000000, 5.492510, 0.895761>,
      < 0.000000, 5.798498, 0.394301>,
      < 0.259731, 5.798376, 0.405359>
    }
    triangle {
      < 0.000000, 5.492510, 0.895761>,
      < 0.259731, 5.798376, 0.405359>,
      < 0.163951, 5.515416, 0.883127>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < 0.382808, 5.030048, -0.142889>,
      < 0.499061, 4.222472, -0.703218>,
      < 0.860388, 4.222589, -0.582402>
    }
    triangle {
      < 0.382808, 5.030048, -0.142889>,
      < 0.860388, 4.222589, -0.582402>,
      < 0.813469, 4.923323, 0.096762>
    }
    triangle {
      < 0.259731, 5.798376, 0.405359>,
      < 0.382808, 5.030048, -0.142889>,
      < 0.813469, 4.923323, 0.096762>
    }
    triangle {
      < 0.259731, 5.798376, 0.405359>,
      < 0.813469, 4.923323, 0.096762>,
      < 0.488515, 5.798268, 0.415098>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < 0.323968, 5.542478, 0.860668>,
      < 0.259731, 5.798376, 0.405359>,
      < 0.488515, 5.798268, 0.415098>
    }
    triangle {
      < 0.323968, 5.542478, 0.860668>,
      < 0.488515, 5.798268, 0.415098>,
      < 0.462977, 5.564999, 0.816277>
    }
    triangle {
      < 0.323968, 5.542478, 0.860668>,
      < 0.163951, 5.515416, 0.883127>,
      < 0.259731, 5.798376, 0.405359>
    }
    triangle {
      < 0.660893, 5.657573, 0.748836>,
      < 0.462977, 5.564999, 0.816277>,
      < 0.488515, 5.798268, 0.415098>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < 1.109287, 4.222658, -0.389658>,
      < 0.813469, 4.923323, 0.096762>,
      < 0.860388, 4.222589, -0.582402>
    }
    triangle {
      < 1.109287, 4.222658, -0.389658>,
      < 1.156556, 4.295053, -0.244954>,
      < 0.813469, 4.923323, 0.096762>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < 0.660893, 5.657573, 0.748836>,
      < 0.488515, 5.798268, 0.415098>,
      < 0.820922, 5.721953, 0.622226>
    }
    triangle {
      < 1.567187, 6.531720, 1.241760>,
      < 1.392018, 6.465443, 1.495378>,
      < 1.322479, 6.246337, 1.393343>
    }
    triangle {
      < 1.567187, 6.531720, 1.241760>,
      < 1.322479, 6.246337, 1.393343>,
      < 1.467817, 6.358039, 1.105599>
    }
    triangle {
      < 1.641878, 6.680877, 0.963337>,
      < 1.567187, 6.531720, 1.241760>,
      < 1.467817, 6.358039, 1.105599>
    }
    triangle {
      < 1.641878, 6.680877, 0.963337>,
      < 1.467817, 6.358039, 1.105599>,
      < 1.586969, 6.487923, 0.838833>
    }
    triangle {
      < 1.665081, 6.813934, 0.713635>,
      < 1.641878, 6.680877, 0.963337>,
      < 1.586969, 6.487923, 0.838833>
    }
    triangle {
      < 1.665081, 6.813934, 0.713635>,
      < 1.586969, 6.487923, 0.838833>,
      < 1.686646, 6.625117, 0.584895>
    }
    triangle {
      < 1.685030, 6.993190, 0.456504>,
      < 1.665081, 6.813934, 0.713635>,
      < 1.686646, 6.625117, 0.584895>
    }
    triangle {
      < 1.685030, 6.993190, 0.456504>,
      < 1.686646, 6.625117, 0.584895>,
      < 1.728852, 6.717050, 0.456330>
    }
    texture {face}
  }
  // hair
  union {
    triangle {
      < 1.685030, 6.993190, 0.456504>,
      < 1.728852, 6.717050, 0.456330>,
      < 1.926717, 7.188261, 0.448640>
    }
    triangle {
      < 0.000000, 9.676222, 2.368930>,
      < 0.261909, 9.676860, 2.534168>,
      < 0.263420, 9.947759, 2.352102>
    }
    triangle {
      < 0.000000, 9.676222, 2.368930>,
      < 0.263420, 9.947759, 2.352102>,
      < 0.000000, 9.868969, 2.276780>
    }
    triangle {
      < 0.344938, 10.006336, 1.188239>,
      < 0.343630, 9.996747, 1.136028>,
      < 0.343488, 10.005959, 1.188529>
    }
    triangle {
      < 1.105226, 9.995815, 1.016037>,
      < 1.099944, 9.986621, 0.982247>,
      < 1.103107, 10.000225, 0.919427>
    }
    triangle {
      < 1.105226, 9.995815, 1.016037>,
      < 1.103107, 10.000225, 0.919427>,
      < 1.086055, 10.010103, 0.967558>
    }
    triangle {
      < 1.105226, 9.995815, 1.016037>,
      < 1.086055, 10.010103, 0.967558>,
      < 1.084894, 10.020005, 1.020502>
    }
    triangle {
      < 0.343630, 9.996747, 1.136028>,
      < 0.000000, 9.961681, 1.162321>,
      < 0.000000, 9.970675, 1.215246>
    }
    triangle {
      < 0.343630, 9.996747, 1.136028>,
      < 0.000000, 9.970675, 1.215246>,
      < 0.343488, 10.005959, 1.188529>
    }
    triangle {
      < 0.683422, 10.023827, 1.109206>,
      < 0.343630, 9.996747, 1.136028>,
      < 0.344938, 10.006336, 1.188239>
    }
    triangle {
      < 0.683422, 10.023827, 1.109206>,
      < 0.344938, 10.006336, 1.188239>,
      < 0.684999, 10.033707, 1.161263>
    }
    triangle {
      < 0.684999, 10.033707, 1.161263>,
      < 1.084894, 10.020005, 1.020502>,
      < 1.086055, 10.010103, 0.967558>
    }
    triangle {
      < 0.684999, 10.033707, 1.161263>,
      < 1.086055, 10.010103, 0.967558>,
      < 0.683422, 10.023827, 1.109206>
    }
    triangle {
      < 0.000000, 10.395161, -1.847075>,
      < 0.000000, 10.556360, -1.255870>,
      < 0.282734, 10.530972, -1.248772>
    }
    triangle {
      < 0.000000, 10.395161, -1.847075>,
      < 0.282734, 10.530972, -1.248772>,
      < 0.256023, 10.441054, -1.625575>
    }
    triangle {
      < 0.000000, 10.103044, -2.437498>,
      < 0.000000, 10.395161, -1.847075>,
      < 0.256023, 10.441054, -1.625575>
    }
    triangle {
      < 0.000000, 10.103044, -2.437498>,
      < 0.256023, 10.441054, -1.625575>,
      < 0.312674, 10.106316, -2.341642>
    }
    texture {hair}
  }
  // face
  union {
    triangle {
      < 0.434879, 7.848812, 1.844686>,
      < 0.494802, 7.844838, 1.903134>,
      < 0.589018, 7.915383, 1.940367>
    }
    triangle {
      < 0.434879, 7.848812, 1.844686>,
      < 0.589018, 7.915383, 1.940367>,
      < 0.510838, 8.009660, 1.903327>
    }
    texture {face}
  }
  // lash
  union {
    triangle {
      < 0.760872, 7.878096, 2.044034>,
      < 0.738160, 7.909727, 2.052032>,
      < 0.608820, 7.884941, 2.001511>
    }
    triangle {
      < 0.760872, 7.878096, 2.044034>,
      < 0.608820, 7.884941, 2.001511>,
      < 0.628197, 7.862329, 1.999484>
    }
    triangle {
      < 0.505429, 7.826012, 1.931554>,
      < 0.507243, 7.816108, 1.909368>,
      < 0.628197, 7.862329, 1.999484>
    }
    triangle {
      < 0.505429, 7.826012, 1.931554>,
      < 0.628197, 7.862329, 1.999484>,
      < 0.608820, 7.884941, 2.001511>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < 0.421266, 7.715384, 1.824796>,
      < 0.494802, 7.844838, 1.903134>,
      < 0.434879, 7.848812, 1.844686>
    }
    triangle {
      < 1.061896, 7.223755, 1.329039>,
      < 1.280479, 7.023159, 1.386668>,
      < 1.387584, 7.136969, 1.118825>
    }
    triangle {
      < 1.061896, 7.223755, 1.329039>,
      < 1.387584, 7.136969, 1.118825>,
      < 1.113253, 7.297450, 1.266328>
    }
    triangle {
      < 0.772975, 7.160594, 1.638789>,
      < 0.951907, 6.931507, 1.737461>,
      < 1.118692, 6.924029, 1.657216>
    }
    triangle {
      < 0.772975, 7.160594, 1.638789>,
      < 1.118692, 6.924029, 1.657216>,
      < 0.883035, 7.151428, 1.545997>
    }
    triangle {
      < 0.153202, 7.152060, 2.290502>,
      < 0.000000, 7.193865, 2.291512>,
      < 0.000000, 7.013479, 2.418046>
    }
    triangle {
      < 0.153202, 7.152060, 2.290502>,
      < 0.000000, 7.013479, 2.418046>,
      < 0.165973, 6.990763, 2.401286>
    }
    triangle {
      < 0.354659, 7.089078, 2.130837>,
      < 0.153202, 7.152060, 2.290502>,
      < 0.165973, 6.990763, 2.401286>
    }
    triangle {
      < 0.354659, 7.089078, 2.130837>,
      < 0.165973, 6.990763, 2.401286>,
      < 0.334718, 6.960837, 2.252813>
    }
    triangle {
      < 0.440409, 6.970834, 2.025113>,
      < 0.442106, 6.988012, 2.018156>,
      < 0.354659, 7.089078, 2.130837>
    }
    triangle {
      < 0.440409, 6.970834, 2.025113>,
      < 0.354659, 7.089078, 2.130837>,
      < 0.334718, 6.960837, 2.252813>
    }
    triangle {
      < 0.440409, 6.970834, 2.025113>,
      < 0.334718, 6.960837, 2.252813>,
      < 0.449324, 6.929481, 2.051343>
    }
    triangle {
      < 0.440409, 6.970834, 2.025113>,
      < 0.449324, 6.929481, 2.051343>,
      < 0.463406, 6.824869, 2.024403>
    }
    triangle {
      < 1.002136, 8.526634, 1.800382>,
      < 0.680408, 8.556564, 1.960871>,
      < 0.668233, 8.257164, 1.947022>
    }
    triangle {
      < 1.002136, 8.526634, 1.800382>,
      < 0.668233, 8.257164, 1.947022>,
      < 0.929884, 8.357011, 1.841744>
    }
    triangle {
      < 1.208542, 8.514754, 1.669742>,
      < 1.002136, 8.526634, 1.800382>,
      < 0.929884, 8.357011, 1.841744>
    }
    triangle {
      < 1.208542, 8.514754, 1.669742>,
      < 0.929884, 8.357011, 1.841744>,
      < 1.177990, 8.341700, 1.692121>
    }
    triangle {
      < 1.428928, 8.385238, 1.410104>,
      < 1.208542, 8.514754, 1.669742>,
      < 1.177990, 8.341700, 1.692121>
    }
    triangle {
      < 1.428928, 8.385238, 1.410104>,
      < 1.177990, 8.341700, 1.692121>,
      < 1.388592, 8.182241, 1.451023>
    }
    triangle {
      < 1.627951, 8.161976, 1.121192>,
      < 1.428928, 8.385238, 1.410104>,
      < 1.388592, 8.182241, 1.451023>
    }
    triangle {
      < 1.627951, 8.161976, 1.121192>,
      < 1.388592, 8.182241, 1.451023>,
      < 1.409607, 7.862576, 1.257887>
    }
    triangle {
      < 0.459376, 6.802716, 1.999871>,
      < 0.463406, 6.824869, 2.024403>,
      < 0.448093, 6.801496, 2.038748>
    }
    triangle {
      < 0.459376, 6.802716, 1.999871>,
      < 0.448093, 6.801496, 2.038748>,
      < 0.447613, 6.770525, 2.014438>
    }
    triangle {
      < 0.447231, 6.990836, 2.011483>,
      < 0.442106, 6.988012, 2.018156>,
      < 0.440409, 6.970834, 2.025113>
    }
    triangle {
      < 0.447231, 6.990836, 2.011483>,
      < 0.440409, 6.970834, 2.025113>,
      < 0.449960, 6.979241, 2.004734>
    }
    triangle {
      < 0.000000, 6.613321, 2.141114>,
      < 0.135082, 6.628557, 2.158507>,
      < 0.134601, 6.677120, 2.183006>
    }
    triangle {
      < 0.000000, 6.613321, 2.141114>,
      < 0.134601, 6.677120, 2.183006>,
      < 0.000000, 6.676259, 2.183194>
    }
    triangle {
      < 0.135082, 6.628557, 2.158507>,
      < 0.266413, 6.719081, 2.118316>,
      < 0.263747, 6.748829, 2.144173>
    }
    triangle {
      < 0.135082, 6.628557, 2.158507>,
      < 0.263747, 6.748829, 2.144173>,
      < 0.134601, 6.677120, 2.183006>
    }
    triangle {
      < 0.266413, 6.719081, 2.118316>,
      < 0.447613, 6.770525, 2.014438>,
      < 0.448093, 6.801496, 2.038748>
    }
    triangle {
      < 0.266413, 6.719081, 2.118316>,
      < 0.448093, 6.801496, 2.038748>,
      < 0.263747, 6.748829, 2.144173>
    }
    triangle {
      < 0.459376, 6.802716, 1.999871>,
      < 0.449960, 6.979241, 2.004734>,
      < 0.440409, 6.970834, 2.025113>
    }
    triangle {
      < 0.459376, 6.802716, 1.999871>,
      < 0.440409, 6.970834, 2.025113>,
      < 0.463406, 6.824869, 2.024403>
    }
    texture {face}
  }
  // white
  union {
    triangle {
      < 1.105440, 7.671899, 1.384026>,
      < 1.063235, 7.760682, 1.524284>,
      < 0.994898, 7.771222, 1.434833>
    }
    texture {white}
  }
  // face
  union {
    triangle {
      < 0.416886, 7.691145, 1.819102>,
      < 0.420309, 7.701636, 1.819372>,
      < 0.421266, 7.715384, 1.824796>
    }
    triangle {
      < 0.416886, 7.691145, 1.819102>,
      < 0.421266, 7.715384, 1.824796>,
      < 0.411911, 7.705149, 1.823261>
    }
    triangle {
      < 1.172679, 7.476350, 1.209460>,
      < 1.181628, 7.493562, 1.203781>,
      < 1.177549, 7.502185, 1.213440>
    }
    triangle {
      < 1.044607, 8.070682, 1.641520>,
      < 0.857921, 8.152600, 1.795877>,
      < 0.858304, 8.142274, 1.796644>
    }
    triangle {
      < 1.044607, 8.070682, 1.641520>,
      < 0.858304, 8.142274, 1.796644>,
      < 1.042285, 8.061223, 1.643898>
    }
    triangle {
      < 0.857921, 8.152600, 1.795877>,
      < 0.674197, 8.108939, 1.873312>,
      < 0.676756, 8.098582, 1.873053>
    }
    triangle {
      < 0.857921, 8.152600, 1.795877>,
      < 0.676756, 8.098582, 1.873053>,
      < 0.858304, 8.142274, 1.796644>
    }
    triangle {
      < 0.674197, 8.108939, 1.873312>,
      < 0.503766, 8.017214, 1.905862>,
      < 0.510838, 8.009660, 1.903327>
    }
    triangle {
      < 0.674197, 8.108939, 1.873312>,
      < 0.510838, 8.009660, 1.903327>,
      < 0.676756, 8.098582, 1.873053>
    }
    triangle {
      < 0.503766, 8.017214, 1.905862>,
      < 0.426586, 7.851128, 1.845632>,
      < 0.434879, 7.848812, 1.844686>
    }
    triangle {
      < 0.503766, 8.017214, 1.905862>,
      < 0.434879, 7.848812, 1.844686>,
      < 0.510838, 8.009660, 1.903327>
    }
    triangle {
      < 0.421266, 7.715384, 1.824796>,
      < 0.434879, 7.848812, 1.844686>,
      < 0.426586, 7.851128, 1.845632>
    }
    triangle {
      < 0.421266, 7.715384, 1.824796>,
      < 0.426586, 7.851128, 1.845632>,
      < 0.411911, 7.705149, 1.823261>
    }
    triangle {
      < 1.143256, 7.950388, 1.448727>,
      < 1.044607, 8.070682, 1.641520>,
      < 1.042285, 8.061223, 1.643898>
    }
    triangle {
      < 1.143256, 7.950388, 1.448727>,
      < 1.042285, 8.061223, 1.643898>,
      < 1.138931, 7.943057, 1.452462>
    }
    triangle {
      < 1.228102, 7.784869, 1.308105>,
      < 1.143256, 7.950388, 1.448727>,
      < 1.138931, 7.943057, 1.452462>
    }
    triangle {
      < 1.228102, 7.784869, 1.308105>,
      < 1.138931, 7.943057, 1.452462>,
      < 1.222239, 7.779233, 1.314082>
    }
    triangle {
      < 1.228105, 7.667838, 1.228434>,
      < 1.228102, 7.784869, 1.308105>,
      < 1.222239, 7.779233, 1.314082>
    }
    triangle {
      < 1.228105, 7.667838, 1.228434>,
      < 1.222239, 7.779233, 1.314082>,
      < 1.221443, 7.665048, 1.236122>
    }
    triangle {
      < 1.181628, 7.493562, 1.203781>,
      < 1.228105, 7.667838, 1.228434>,
      < 1.221443, 7.665048, 1.236122>
    }
    triangle {
      < 1.181628, 7.493562, 1.203781>,
      < 1.221443, 7.665048, 1.236122>,
      < 1.177549, 7.502185, 1.213440>
    }
    texture {face}
  }
  // lowlip
  union {
    triangle {
      < 0.000000, 6.091110, 2.200333>,
      < 0.173951, 6.088375, 2.182847>,
      < 0.161882, 6.163558, 2.150136>
    }
    triangle {
      < 0.000000, 6.091110, 2.200333>,
      < 0.161882, 6.163558, 2.150136>,
      < 0.000000, 6.157406, 2.167072>
    }
    triangle {
      < 0.496583, 6.127518, 1.979135>,
      < 0.314755, 6.159932, 2.117626>,
      < 0.358301, 6.097709, 2.127077>
    }
    triangle {
      < 0.496583, 6.127518, 1.979135>,
      < 0.358301, 6.097709, 2.127077>,
      < 0.499316, 6.095293, 1.973400>
    }
    triangle {
      < 0.496583, 6.127518, 1.979135>,
      < 0.499316, 6.095293, 1.973400>,
      < 0.633832, 6.130921, 1.922750>
    }
    triangle {
      < 0.496583, 6.127518, 1.979135>,
      < 0.633832, 6.130921, 1.922750>,
      < 0.632465, 6.147034, 1.925617>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < 0.185747, 6.376217, 2.308307>,
      < 0.000000, 6.385907, 2.297638>,
      < 0.000000, 6.234792, 2.271523>
    }
    triangle {
      < 0.185747, 6.376217, 2.308307>,
      < 0.000000, 6.234792, 2.271523>,
      < 0.174788, 6.243392, 2.268390>
    }
    triangle {
      < 0.374646, 6.335971, 2.215456>,
      < 0.185747, 6.376217, 2.308307>,
      < 0.174788, 6.243392, 2.268390>
    }
    triangle {
      < 0.374646, 6.335971, 2.215456>,
      < 0.174788, 6.243392, 2.268390>,
      < 0.344701, 6.235855, 2.198796>
    }
    triangle {
      < 0.530713, 6.263931, 2.096829>,
      < 0.374646, 6.335971, 2.215456>,
      < 0.344701, 6.235855, 2.198796>
    }
    triangle {
      < 0.530713, 6.263931, 2.096829>,
      < 0.344701, 6.235855, 2.198796>,
      < 0.513649, 6.198605, 2.058142>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < 0.173951, 6.088375, 2.182847>,
      < 0.000000, 6.091110, 2.200333>,
      < 0.000000, 5.979388, 2.192696>
    }
    triangle {
      < 0.173951, 6.088375, 2.182847>,
      < 0.000000, 5.979388, 2.192696>,
      < 0.192374, 5.979699, 2.170825>
    }
    triangle {
      < 0.358301, 6.097709, 2.127077>,
      < 0.173951, 6.088375, 2.182847>,
      < 0.192374, 5.979699, 2.170825>
    }
    triangle {
      < 0.358301, 6.097709, 2.127077>,
      < 0.192374, 5.979699, 2.170825>,
      < 0.369221, 6.000530, 2.109117>
    }
    triangle {
      < 0.499316, 6.095293, 1.973400>,
      < 0.358301, 6.097709, 2.127077>,
      < 0.369221, 6.000530, 2.109117>
    }
    triangle {
      < 0.499316, 6.095293, 1.973400>,
      < 0.369221, 6.000530, 2.109117>,
      < 0.505941, 6.036611, 1.965279>
    }
    triangle {
      < 0.633832, 6.130921, 1.922750>,
      < 0.499316, 6.095293, 1.973400>,
      < 0.505941, 6.036611, 1.965279>
    }
    triangle {
      < 0.633832, 6.130921, 1.922750>,
      < 0.505941, 6.036611, 1.965279>,
      < 0.636121, 6.117154, 1.916293>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < 0.610265, 6.408909, 2.035973>,
      < 0.530713, 6.263931, 2.096829>,
      < 0.742783, 6.194807, 1.891206>
    }
    triangle {
      < 0.928687, 6.544118, 1.858133>,
      < 0.609789, 6.660050, 1.950922>,
      < 0.610265, 6.408909, 2.035973>
    }
    triangle {
      < 0.928687, 6.544118, 1.858133>,
      < 0.610265, 6.408909, 2.035973>,
      < 0.742783, 6.194807, 1.891206>
    }
    triangle {
      < 0.928687, 6.544118, 1.858133>,
      < 0.742783, 6.194807, 1.891206>,
      < 0.775718, 6.207943, 1.870568>
    }
    triangle {
      < 1.055449, 6.154773, 1.692849>,
      < 1.117530, 6.487579, 1.748186>,
      < 0.928687, 6.544118, 1.858133>
    }
    triangle {
      < 1.055449, 6.154773, 1.692849>,
      < 0.928687, 6.544118, 1.858133>,
      < 0.775718, 6.207943, 1.870568>
    }
    triangle {
      < 1.055449, 6.154773, 1.692849>,
      < 0.775718, 6.207943, 1.870568>,
      < 0.793829, 6.165370, 1.857392>
    }
    triangle {
      < 0.863689, 5.912329, 1.797569>,
      < 1.057001, 5.928176, 1.601641>,
      < 1.055449, 6.154773, 1.692849>
    }
    triangle {
      < 0.863689, 5.912329, 1.797569>,
      < 1.055449, 6.154773, 1.692849>,
      < 0.793829, 6.165370, 1.857392>
    }
    triangle {
      < 0.863689, 5.912329, 1.797569>,
      < 0.793829, 6.165370, 1.857392>,
      < 0.772042, 6.136685, 1.862512>
    }
    texture {face}
  }
  // uplip
  union {
    triangle {
      < 0.530713, 6.263931, 2.096829>,
      < 0.513649, 6.198605, 2.058142>,
      < 0.634607, 6.189641, 1.969897>
    }
    triangle {
      < 0.530713, 6.263931, 2.096829>,
      < 0.634607, 6.189641, 1.969897>,
      < 0.742783, 6.194807, 1.891206>
    }
    triangle {
      < 0.775718, 6.207943, 1.870568>,
      < 0.742783, 6.194807, 1.891206>,
      < 0.755565, 6.180678, 1.881653>
    }
    triangle {
      < 0.775718, 6.207943, 1.870568>,
      < 0.755565, 6.180678, 1.881653>,
      < 0.772033, 6.187246, 1.871334>
    }
    triangle {
      < 0.793829, 6.165370, 1.857392>,
      < 0.775718, 6.207943, 1.870568>,
      < 0.772033, 6.187246, 1.871334>
    }
    triangle {
      < 0.793829, 6.165370, 1.857392>,
      < 0.772033, 6.187246, 1.871334>,
      < 0.781087, 6.165960, 1.864745>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < 0.772042, 6.136685, 1.862512>,
      < 0.793829, 6.165370, 1.857392>,
      < 0.781087, 6.165960, 1.864745>
    }
    triangle {
      < 0.772042, 6.136685, 1.862512>,
      < 0.781087, 6.165960, 1.864745>,
      < 0.770194, 6.151618, 1.867306>
    }
    triangle {
      < 0.512566, 5.982536, 1.942181>,
      < 0.638888, 6.093111, 1.912075>,
      < 0.636121, 6.117154, 1.916293>
    }
    triangle {
      < 0.512566, 5.982536, 1.942181>,
      < 0.636121, 6.117154, 1.916293>,
      < 0.505941, 6.036611, 1.965279>
    }
    texture {lowlip}
  }
  // uplip
  union {
    triangle {
      < 0.755565, 6.180678, 1.881653>,
      < 0.742783, 6.194807, 1.891206>,
      < 0.634607, 6.189641, 1.969897>
    }
    triangle {
      < 0.768347, 6.166550, 1.872100>,
      < 0.755565, 6.180678, 1.881653>,
      < 0.634607, 6.189641, 1.969897>
    }
    triangle {
      < 0.768347, 6.166550, 1.872100>,
      < 0.634607, 6.189641, 1.969897>,
      < 0.632465, 6.147034, 1.925617>
    }
    texture {uplip}
  }
  // lowlip
  union {
    triangle {
      < 0.768347, 6.166550, 1.872100>,
      < 0.632465, 6.147034, 1.925617>,
      < 0.633832, 6.130921, 1.922750>
    }
    triangle {
      < 0.770194, 6.151618, 1.867306>,
      < 0.768347, 6.166550, 1.872100>,
      < 0.633832, 6.130921, 1.922750>
    }
    triangle {
      < 0.770194, 6.151618, 1.867306>,
      < 0.633832, 6.130921, 1.922750>,
      < 0.636121, 6.117154, 1.916293>
    }
    triangle {
      < 0.772042, 6.136685, 1.862512>,
      < 0.770194, 6.151618, 1.867306>,
      < 0.636121, 6.117154, 1.916293>
    }
    triangle {
      < 0.772042, 6.136685, 1.862512>,
      < 0.636121, 6.117154, 1.916293>,
      < 0.638888, 6.093111, 1.912075>
    }
    texture {lowlip}
  }
  // face
  union {
    triangle {
      < 0.772042, 6.136685, 1.862512>,
      < 0.638888, 6.093111, 1.912075>,
      < 0.863689, 5.912329, 1.797569>
    }
    texture {face}
  }
  // lash
  union {
    triangle {
      < 0.932368, 7.861390, 2.048698>,
      < 0.937265, 7.893220, 2.055827>,
      < 0.738160, 7.909727, 2.052032>
    }
    triangle {
      < 0.932368, 7.861390, 2.048698>,
      < 0.738160, 7.909727, 2.052032>,
      < 0.760872, 7.878096, 2.044034>
    }
    triangle {
      < 1.060592, 7.804728, 1.966757>,
      < 1.069781, 7.824396, 1.948702>,
      < 0.937265, 7.893220, 2.055827>
    }
    triangle {
      < 1.060592, 7.804728, 1.966757>,
      < 0.937265, 7.893220, 2.055827>,
      < 0.932368, 7.861390, 2.048698>
    }
    triangle {
      < 1.138348, 7.745724, 1.881467>,
      < 1.148209, 7.762268, 1.851506>,
      < 1.069781, 7.824396, 1.948702>
    }
    triangle {
      < 1.138348, 7.745724, 1.881467>,
      < 1.069781, 7.824396, 1.948702>,
      < 1.060592, 7.804728, 1.966757>
    }
    triangle {
      < 1.199642, 7.673470, 1.737281>,
      < 1.205264, 7.688103, 1.703732>,
      < 1.148209, 7.762268, 1.851506>
    }
    triangle {
      < 1.199642, 7.673470, 1.737281>,
      < 1.148209, 7.762268, 1.851506>,
      < 1.138348, 7.745724, 1.881467>
    }
    triangle {
      < 1.105440, 7.671899, 1.384026>,
      < 1.199642, 7.673470, 1.737281>,
      < 1.138348, 7.745724, 1.881467>
    }
    triangle {
      < 1.105440, 7.671899, 1.384026>,
      < 1.138348, 7.745724, 1.881467>,
      < 1.063235, 7.760682, 1.524284>
    }
    triangle {
      < 1.063235, 7.760682, 1.524284>,
      < 1.138348, 7.745724, 1.881467>,
      < 1.060592, 7.804728, 1.966757>
    }
    triangle {
      < 1.063235, 7.760682, 1.524284>,
      < 1.060592, 7.804728, 1.966757>,
      < 1.013992, 7.843918, 1.540775>
    }
    triangle {
      < 1.013992, 7.843918, 1.540775>,
      < 1.060592, 7.804728, 1.966757>,
      < 0.932368, 7.861390, 2.048698>
    }
    triangle {
      < 1.013992, 7.843918, 1.540775>,
      < 0.932368, 7.861390, 2.048698>,
      < 0.889687, 7.871883, 1.691399>
    }
    triangle {
      < 0.889687, 7.871883, 1.691399>,
      < 0.932368, 7.861390, 2.048698>,
      < 0.760872, 7.878096, 2.044034>
    }
    triangle {
      < 0.889687, 7.871883, 1.691399>,
      < 0.760872, 7.878096, 2.044034>,
      < 0.717503, 7.892157, 1.751828>
    }
    triangle {
      < 0.717503, 7.892157, 1.751828>,
      < 0.760872, 7.878096, 2.044034>,
      < 0.628197, 7.862329, 1.999484>
    }
    triangle {
      < 0.717503, 7.892157, 1.751828>,
      < 0.628197, 7.862329, 1.999484>,
      < 0.591037, 7.864429, 1.782977>
    }
    triangle {
      < 0.591037, 7.864429, 1.782977>,
      < 0.628197, 7.862329, 1.999484>,
      < 0.507243, 7.816108, 1.909368>
    }
    triangle {
      < 0.591037, 7.864429, 1.782977>,
      < 0.507243, 7.816108, 1.909368>,
      < 0.491586, 7.802804, 1.763913>
    }
    triangle {
      < 0.443239, 7.754848, 1.756084>,
      < 0.491586, 7.802804, 1.763913>,
      < 0.507243, 7.816108, 1.909368>
    }
    triangle {
      < 0.443239, 7.754848, 1.756084>,
      < 0.507243, 7.816108, 1.909368>,
      < 0.420309, 7.701636, 1.819372>
    }
    triangle {
      < 0.505429, 7.826012, 1.931554>,
      < 0.494802, 7.844838, 1.903134>,
      < 0.421266, 7.715384, 1.824796>
    }
    triangle {
      < 0.505429, 7.826012, 1.931554>,
      < 0.608820, 7.884941, 2.001511>,
      < 0.589018, 7.915383, 1.940367>
    }
    triangle {
      < 0.505429, 7.826012, 1.931554>,
      < 0.589018, 7.915383, 1.940367>,
      < 0.494802, 7.844838, 1.903134>
    }
    triangle {
      < 0.608820, 7.884941, 2.001511>,
      < 0.738160, 7.909727, 2.052032>,
      < 0.707084, 7.951528, 1.950182>
    }
    triangle {
      < 0.608820, 7.884941, 2.001511>,
      < 0.707084, 7.951528, 1.950182>,
      < 0.589018, 7.915383, 1.940367>
    }
    triangle {
      < 0.738160, 7.909727, 2.052032>,
      < 0.937265, 7.893220, 2.055827>,
      < 0.947594, 7.934773, 1.906125>
    }
    triangle {
      < 0.738160, 7.909727, 2.052032>,
      < 0.947594, 7.934773, 1.906125>,
      < 0.707084, 7.951528, 1.950182>
    }
    triangle {
      < 0.937265, 7.893220, 2.055827>,
      < 1.069781, 7.824396, 1.948702>,
      < 1.057697, 7.885696, 1.814647>
    }
    triangle {
      < 0.937265, 7.893220, 2.055827>,
      < 1.057697, 7.885696, 1.814647>,
      < 0.947594, 7.934773, 1.906125>
    }
    triangle {
      < 1.069781, 7.824396, 1.948702>,
      < 1.148209, 7.762268, 1.851506>,
      < 1.137249, 7.793068, 1.671500>
    }
    triangle {
      < 1.069781, 7.824396, 1.948702>,
      < 1.137249, 7.793068, 1.671500>,
      < 1.057697, 7.885696, 1.814647>
    }
    triangle {
      < 1.148209, 7.762268, 1.851506>,
      < 1.205264, 7.688103, 1.703732>,
      < 1.183912, 7.723730, 1.527919>
    }
    triangle {
      < 1.148209, 7.762268, 1.851506>,
      < 1.183912, 7.723730, 1.527919>,
      < 1.137249, 7.793068, 1.671500>
    }
    triangle {
      < 1.205264, 7.688103, 1.703732>,
      < 1.226924, 7.611438, 1.536010>,
      < 1.190138, 7.595891, 1.288325>
    }
    triangle {
      < 1.205264, 7.688103, 1.703732>,
      < 1.190138, 7.595891, 1.288325>,
      < 1.183912, 7.723730, 1.527919>
    }
    triangle {
      < 1.226924, 7.611438, 1.536010>,
      < 1.221656, 7.535584, 1.310366>,
      < 1.177549, 7.502185, 1.213440>
    }
    triangle {
      < 1.226924, 7.611438, 1.536010>,
      < 1.177549, 7.502185, 1.213440>,
      < 1.190138, 7.595891, 1.288325>
    }
    triangle {
      < 1.221656, 7.535584, 1.310366>,
      < 1.217879, 7.502439, 1.321256>,
      < 1.172679, 7.476350, 1.209460>
    }
    triangle {
      < 1.221656, 7.535584, 1.310366>,
      < 1.172679, 7.476350, 1.209460>,
      < 1.177549, 7.502185, 1.213440>
    }
    triangle {
      < 1.118055, 7.492085, 1.170550>,
      < 1.172679, 7.476350, 1.209460>,
      < 1.217879, 7.502439, 1.321256>
    }
    triangle {
      < 1.118055, 7.492085, 1.170550>,
      < 1.217879, 7.502439, 1.321256>,
      < 1.217140, 7.601475, 1.575520>
    }
    triangle {
      < 1.118055, 7.492085, 1.170550>,
      < 1.217140, 7.601475, 1.575520>,
      < 1.125417, 7.594946, 1.294461>
    }
    triangle {
      < 1.125417, 7.594946, 1.294461>,
      < 1.217140, 7.601475, 1.575520>,
      < 1.199642, 7.673470, 1.737281>
    }
    triangle {
      < 1.125417, 7.594946, 1.294461>,
      < 1.199642, 7.673470, 1.737281>,
      < 1.105440, 7.671899, 1.384026>
    }
    triangle {
      < 0.505429, 7.826012, 1.931554>,
      < 0.421266, 7.715384, 1.824796>,
      < 0.420309, 7.701636, 1.819372>
    }
    triangle {
      < 0.505429, 7.826012, 1.931554>,
      < 0.420309, 7.701636, 1.819372>,
      < 0.507243, 7.816108, 1.909368>
    }
    texture {lash}
  }
  // face
  union {
    triangle {
      < 1.181628, 7.493562, 1.203781>,
      < 1.172679, 7.476350, 1.209460>,
      < 1.152053, 7.377617, 1.209565>
    }
    triangle {
      < 1.011962, 7.250182, 1.285068>,
      < 0.948267, 7.196994, 1.395385>,
      < 0.995386, 7.168216, 1.444232>
    }
    triangle {
      < 1.011962, 7.250182, 1.285068>,
      < 0.995386, 7.168216, 1.444232>,
      < 1.061896, 7.223755, 1.329039>
    }
    triangle {
      < 0.948267, 7.196994, 1.395385>,
      < 0.840671, 7.180917, 1.492842>,
      < 0.883035, 7.151428, 1.545997>
    }
    triangle {
      < 0.948267, 7.196994, 1.395385>,
      < 0.883035, 7.151428, 1.545997>,
      < 0.995386, 7.168216, 1.444232>
    }
    triangle {
      < 0.840671, 7.180917, 1.492842>,
      < 0.735270, 7.189694, 1.581706>,
      < 0.772975, 7.160594, 1.638789>
    }
    triangle {
      < 0.840671, 7.180917, 1.492842>,
      < 0.772975, 7.160594, 1.638789>,
      < 0.883035, 7.151428, 1.545997>
    }
    triangle {
      < 0.735270, 7.189694, 1.581706>,
      < 0.622082, 7.234779, 1.668249>,
      < 0.654784, 7.207671, 1.729157>
    }
    triangle {
      < 0.735270, 7.189694, 1.581706>,
      < 0.654784, 7.207671, 1.729157>,
      < 0.772975, 7.160594, 1.638789>
    }
    triangle {
      < 0.622082, 7.234779, 1.668249>,
      < 0.496639, 7.338326, 1.726266>,
      < 0.523796, 7.315795, 1.789738>
    }
    triangle {
      < 0.622082, 7.234779, 1.668249>,
      < 0.523796, 7.315795, 1.789738>,
      < 0.654784, 7.207671, 1.729157>
    }
    triangle {
      < 0.496639, 7.338326, 1.726266>,
      < 0.427185, 7.438086, 1.749493>,
      < 0.451272, 7.419964, 1.813993>
    }
    triangle {
      < 0.496639, 7.338326, 1.726266>,
      < 0.451272, 7.419964, 1.813993>,
      < 0.523796, 7.315795, 1.789738>
    }
    triangle {
      < 0.427185, 7.438086, 1.749493>,
      < 0.401563, 7.551459, 1.752276>,
      < 0.424517, 7.538349, 1.816898>
    }
    triangle {
      < 0.427185, 7.438086, 1.749493>,
      < 0.424517, 7.538349, 1.816898>,
      < 0.451272, 7.419964, 1.813993>
    }
    triangle {
      < 0.401563, 7.551459, 1.752276>,
      < 0.394255, 7.697788, 1.754387>,
      < 0.416886, 7.691145, 1.819102>
    }
    triangle {
      < 0.401563, 7.551459, 1.752276>,
      < 0.416886, 7.691145, 1.819102>,
      < 0.424517, 7.538349, 1.816898>
    }
    triangle {
      < 0.394255, 7.697788, 1.754387>,
      < 0.443239, 7.754848, 1.756084>,
      < 0.420309, 7.701636, 1.819372>
    }
    triangle {
      < 0.394255, 7.697788, 1.754387>,
      < 0.420309, 7.701636, 1.819372>,
      < 0.416886, 7.691145, 1.819102>
    }
    triangle {
      < 1.118055, 7.492085, 1.170550>,
      < 1.098302, 7.397531, 1.170651>,
      < 1.152053, 7.377617, 1.209565>
    }
    triangle {
      < 1.118055, 7.492085, 1.170550>,
      < 1.152053, 7.377617, 1.209565>,
      < 1.172679, 7.476350, 1.209460>
    }
    triangle {
      < 1.098302, 7.397531, 1.170651>,
      < 1.061145, 7.320757, 1.225011>,
      < 1.113253, 7.297450, 1.266328>
    }
    triangle {
      < 1.098302, 7.397531, 1.170651>,
      < 1.113253, 7.297450, 1.266328>,
      < 1.152053, 7.377617, 1.209565>
    }
    triangle {
      < 1.061145, 7.320757, 1.225011>,
      < 1.011962, 7.250182, 1.285068>,
      < 1.061896, 7.223755, 1.329039>
    }
    triangle {
      < 1.061145, 7.320757, 1.225011>,
      < 1.061896, 7.223755, 1.329039>,
      < 1.113253, 7.297450, 1.266328>
    }
    texture {face}
  }
  // white
  union {
    triangle {
      < 1.019243, 7.647663, 1.402761>,
      < 1.015349, 7.592010, 1.399268>,
      < 1.098302, 7.397531, 1.170651>
    }
    triangle {
      < 1.019243, 7.647663, 1.402761>,
      < 1.098302, 7.397531, 1.170651>,
      < 1.118055, 7.492085, 1.170550>
    }
    triangle {
      < 1.015349, 7.592010, 1.399268>,
      < 1.004205, 7.535050, 1.400969>,
      < 1.061145, 7.320757, 1.225011>
    }
    triangle {
      < 1.015349, 7.592010, 1.399268>,
      < 1.061145, 7.320757, 1.225011>,
      < 1.098302, 7.397531, 1.170651>
    }
    triangle {
      < 1.004205, 7.535050, 1.400969>,
      < 0.979657, 7.472168, 1.411874>,
      < 1.011962, 7.250182, 1.285068>
    }
    triangle {
      < 1.004205, 7.535050, 1.400969>,
      < 1.011962, 7.250182, 1.285068>,
      < 1.061145, 7.320757, 1.225011>
    }
    triangle {
      < 0.979657, 7.472168, 1.411874>,
      < 0.928312, 7.399922, 1.441460>,
      < 0.948267, 7.196994, 1.395385>
    }
    triangle {
      < 0.979657, 7.472168, 1.411874>,
      < 0.948267, 7.196994, 1.395385>,
      < 1.011962, 7.250182, 1.285068>
    }
    triangle {
      < 0.928312, 7.399922, 1.441460>,
      < 0.836103, 7.338300, 1.502381>,
      < 0.840671, 7.180917, 1.492842>
    }
    triangle {
      < 0.928312, 7.399922, 1.441460>,
      < 0.840671, 7.180917, 1.492842>,
      < 0.948267, 7.196994, 1.395385>
    }
    triangle {
      < 0.836103, 7.338300, 1.502381>,
      < 0.722661, 7.329017, 1.584938>,
      < 0.735270, 7.189694, 1.581706>
    }
    triangle {
      < 0.836103, 7.338300, 1.502381>,
      < 0.735270, 7.189694, 1.581706>,
      < 0.840671, 7.180917, 1.492842>
    }
    triangle {
      < 0.722661, 7.329017, 1.584938>,
      < 0.613150, 7.390597, 1.672701>,
      < 0.622082, 7.234779, 1.668249>
    }
    triangle {
      < 0.722661, 7.329017, 1.584938>,
      < 0.622082, 7.234779, 1.668249>,
      < 0.735270, 7.189694, 1.581706>
    }
    triangle {
      < 0.613150, 7.390597, 1.672701>,
      < 0.544075, 7.512550, 1.737560>,
      < 0.496639, 7.338326, 1.726266>
    }
    triangle {
      < 0.613150, 7.390597, 1.672701>,
      < 0.496639, 7.338326, 1.726266>,
      < 0.622082, 7.234779, 1.668249>
    }
    triangle {
      < 0.544075, 7.512550, 1.737560>,
      < 0.532773, 7.604802, 1.756439>,
      < 0.427185, 7.438086, 1.749493>
    }
    triangle {
      < 0.544075, 7.512550, 1.737560>,
      < 0.427185, 7.438086, 1.749493>,
      < 0.496639, 7.338326, 1.726266>
    }
    triangle {
      < 0.532773, 7.604802, 1.756439>,
      < 0.543324, 7.687379, 1.758104>,
      < 0.401563, 7.551459, 1.752276>
    }
    triangle {
      < 0.532773, 7.604802, 1.756439>,
      < 0.401563, 7.551459, 1.752276>,
      < 0.427185, 7.438086, 1.749493>
    }
    triangle {
      < 0.543324, 7.687379, 1.758104>,
      < 0.575525, 7.773652, 1.758058>,
      < 0.394255, 7.697788, 1.754387>
    }
    triangle {
      < 0.543324, 7.687379, 1.758104>,
      < 0.394255, 7.697788, 1.754387>,
      < 0.401563, 7.551459, 1.752276>
    }
    triangle {
      < 0.575525, 7.773652, 1.758058>,
      < 0.595789, 7.809468, 1.761040>,
      < 0.443239, 7.754848, 1.756084>
    }
    triangle {
      < 0.575525, 7.773652, 1.758058>,
      < 0.443239, 7.754848, 1.756084>,
      < 0.394255, 7.697788, 1.754387>
    }
    triangle {
      < 0.595789, 7.809468, 1.761040>,
      < 0.616873, 7.837595, 1.764843>,
      < 0.491586, 7.802804, 1.763913>
    }
    triangle {
      < 0.595789, 7.809468, 1.761040>,
      < 0.491586, 7.802804, 1.763913>,
      < 0.443239, 7.754848, 1.756084>
    }
    triangle {
      < 0.616873, 7.837595, 1.764843>,
      < 0.656399, 7.872271, 1.761561>,
      < 0.591037, 7.864429, 1.782977>
    }
    triangle {
      < 0.616873, 7.837595, 1.764843>,
      < 0.591037, 7.864429, 1.782977>,
      < 0.491586, 7.802804, 1.763913>
    }
    triangle {
      < 0.994898, 7.771222, 1.434833>,
      < 1.014899, 7.713530, 1.413494>,
      < 1.125417, 7.594946, 1.294461>
    }
    triangle {
      < 0.994898, 7.771222, 1.434833>,
      < 1.125417, 7.594946, 1.294461>,
      < 1.105440, 7.671899, 1.384026>
    }
    triangle {
      < 1.014899, 7.713530, 1.413494>,
      < 1.019243, 7.647663, 1.402761>,
      < 1.118055, 7.492085, 1.170550>
    }
    triangle {
      < 1.014899, 7.713530, 1.413494>,
      < 1.118055, 7.492085, 1.170550>,
      < 1.125417, 7.594946, 1.294461>
    }
    triangle {
      < 0.591037, 7.864429, 1.782977>,
      < 0.656399, 7.872271, 1.761561>,
      < 0.717503, 7.892157, 1.751828>
    }
    triangle {
      < 1.013992, 7.843918, 1.540775>,
      < 0.994898, 7.771222, 1.434833>,
      < 1.063235, 7.760682, 1.524284>
    }
    texture {white}
  }
  // pupil
  union {
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.712901, 7.728924, 1.728796>,
      < 0.691969, 7.695099, 1.732584>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.691969, 7.695099, 1.732584>,
      < 0.675565, 7.648775, 1.728959>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.675565, 7.648775, 1.728959>,
      < 0.671052, 7.607735, 1.718547>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.671052, 7.607735, 1.718547>,
      < 0.677384, 7.565431, 1.699922>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.677384, 7.565431, 1.699922>,
      < 0.709400, 7.513154, 1.659521>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.709400, 7.513154, 1.659521>,
      < 0.759238, 7.488568, 1.615526>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.759238, 7.488568, 1.615526>,
      < 0.811886, 7.492251, 1.578918>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.811886, 7.492251, 1.578918>,
      < 0.858262, 7.516508, 1.553663>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.858262, 7.516508, 1.553663>,
      < 0.888326, 7.546027, 1.541881>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.888326, 7.546027, 1.541881>,
      < 0.906489, 7.573089, 1.537832>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.906489, 7.573089, 1.537832>,
      < 0.918499, 7.599118, 1.537862>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.918499, 7.599118, 1.537862>,
      < 0.926413, 7.626187, 1.541182>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.926413, 7.626187, 1.541182>,
      < 0.930311, 7.659766, 1.549553>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.930311, 7.659766, 1.549553>,
      < 0.917461, 7.731203, 1.582556>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.917461, 7.731203, 1.582556>,
      < 0.889972, 7.766613, 1.614091>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.889972, 7.766613, 1.614091>,
      < 0.842403, 7.787000, 1.655058>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.842403, 7.787000, 1.655058>,
      < 0.818944, 7.789495, 1.672746>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.818944, 7.789495, 1.672746>,
      < 0.774665, 7.778907, 1.701043>
    }
    texture {pupil}
  }
  // iris
  union {
    triangle {
      < 0.889687, 7.871883, 1.691399>,
      < 0.842403, 7.787000, 1.655058>,
      < 0.889972, 7.766613, 1.614091>
    }
    triangle {
      < 0.889687, 7.871883, 1.691399>,
      < 0.889972, 7.766613, 1.614091>,
      < 1.013992, 7.843918, 1.540775>
    }
    triangle {
      < 0.917461, 7.731203, 1.582556>,
      < 0.930311, 7.659766, 1.549553>,
      < 1.014899, 7.713530, 1.413494>
    }
    triangle {
      < 0.917461, 7.731203, 1.582556>,
      < 1.014899, 7.713530, 1.413494>,
      < 0.994898, 7.771222, 1.434833>
    }
    triangle {
      < 0.930311, 7.659766, 1.549553>,
      < 0.926413, 7.626187, 1.541182>,
      < 1.019243, 7.647663, 1.402761>
    }
    triangle {
      < 0.930311, 7.659766, 1.549553>,
      < 1.019243, 7.647663, 1.402761>,
      < 1.014899, 7.713530, 1.413494>
    }
    triangle {
      < 0.926413, 7.626187, 1.541182>,
      < 0.918499, 7.599118, 1.537862>,
      < 1.015349, 7.592010, 1.399268>
    }
    triangle {
      < 0.926413, 7.626187, 1.541182>,
      < 1.015349, 7.592010, 1.399268>,
      < 1.019243, 7.647663, 1.402761>
    }
    triangle {
      < 0.918499, 7.599118, 1.537862>,
      < 0.906489, 7.573089, 1.537832>,
      < 1.004205, 7.535050, 1.400969>
    }
    triangle {
      < 0.918499, 7.599118, 1.537862>,
      < 1.004205, 7.535050, 1.400969>,
      < 1.015349, 7.592010, 1.399268>
    }
    triangle {
      < 0.906489, 7.573089, 1.537832>,
      < 0.888326, 7.546027, 1.541881>,
      < 0.979657, 7.472168, 1.411874>
    }
    triangle {
      < 0.906489, 7.573089, 1.537832>,
      < 0.979657, 7.472168, 1.411874>,
      < 1.004205, 7.535050, 1.400969>
    }
    triangle {
      < 0.888326, 7.546027, 1.541881>,
      < 0.858262, 7.516508, 1.553663>,
      < 0.928312, 7.399922, 1.441460>
    }
    triangle {
      < 0.888326, 7.546027, 1.541881>,
      < 0.928312, 7.399922, 1.441460>,
      < 0.979657, 7.472168, 1.411874>
    }
    triangle {
      < 0.858262, 7.516508, 1.553663>,
      < 0.811886, 7.492251, 1.578918>,
      < 0.836103, 7.338300, 1.502381>
    }
    triangle {
      < 0.858262, 7.516508, 1.553663>,
      < 0.836103, 7.338300, 1.502381>,
      < 0.928312, 7.399922, 1.441460>
    }
    triangle {
      < 0.811886, 7.492251, 1.578918>,
      < 0.759238, 7.488568, 1.615526>,
      < 0.722661, 7.329017, 1.584938>
    }
    triangle {
      < 0.811886, 7.492251, 1.578918>,
      < 0.722661, 7.329017, 1.584938>,
      < 0.836103, 7.338300, 1.502381>
    }
    triangle {
      < 0.759238, 7.488568, 1.615526>,
      < 0.709400, 7.513154, 1.659521>,
      < 0.613150, 7.390597, 1.672701>
    }
    triangle {
      < 0.759238, 7.488568, 1.615526>,
      < 0.613150, 7.390597, 1.672701>,
      < 0.722661, 7.329017, 1.584938>
    }
    triangle {
      < 0.709400, 7.513154, 1.659521>,
      < 0.677384, 7.565431, 1.699922>,
      < 0.544075, 7.512550, 1.737560>
    }
    triangle {
      < 0.709400, 7.513154, 1.659521>,
      < 0.544075, 7.512550, 1.737560>,
      < 0.613150, 7.390597, 1.672701>
    }
    triangle {
      < 0.677384, 7.565431, 1.699922>,
      < 0.671052, 7.607735, 1.718547>,
      < 0.532773, 7.604802, 1.756439>
    }
    triangle {
      < 0.677384, 7.565431, 1.699922>,
      < 0.532773, 7.604802, 1.756439>,
      < 0.544075, 7.512550, 1.737560>
    }
    triangle {
      < 0.671052, 7.607735, 1.718547>,
      < 0.675565, 7.648775, 1.728959>,
      < 0.543324, 7.687379, 1.758104>
    }
    triangle {
      < 0.671052, 7.607735, 1.718547>,
      < 0.543324, 7.687379, 1.758104>,
      < 0.532773, 7.604802, 1.756439>
    }
    triangle {
      < 0.675565, 7.648775, 1.728959>,
      < 0.691969, 7.695099, 1.732584>,
      < 0.575525, 7.773652, 1.758058>
    }
    triangle {
      < 0.675565, 7.648775, 1.728959>,
      < 0.575525, 7.773652, 1.758058>,
      < 0.543324, 7.687379, 1.758104>
    }
    triangle {
      < 0.691969, 7.695099, 1.732584>,
      < 0.712901, 7.728924, 1.728796>,
      < 0.595789, 7.809468, 1.761040>
    }
    triangle {
      < 0.691969, 7.695099, 1.732584>,
      < 0.595789, 7.809468, 1.761040>,
      < 0.575525, 7.773652, 1.758058>
    }
    triangle {
      < 0.712901, 7.728924, 1.728796>,
      < 0.734636, 7.753027, 1.721197>,
      < 0.616873, 7.837595, 1.764843>
    }
    triangle {
      < 0.712901, 7.728924, 1.728796>,
      < 0.616873, 7.837595, 1.764843>,
      < 0.595789, 7.809468, 1.761040>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.774665, 7.778907, 1.701043>,
      < 0.656399, 7.872271, 1.761561>
    }
    triangle {
      < 0.734636, 7.753027, 1.721197>,
      < 0.656399, 7.872271, 1.761561>,
      < 0.616873, 7.837595, 1.764843>
    }
    triangle {
      < 0.774665, 7.778907, 1.701043>,
      < 0.818944, 7.789495, 1.672746>,
      < 0.717503, 7.892157, 1.751828>
    }
    triangle {
      < 0.774665, 7.778907, 1.701043>,
      < 0.717503, 7.892157, 1.751828>,
      < 0.656399, 7.872271, 1.761561>
    }
    triangle {
      < 0.818944, 7.789495, 1.672746>,
      < 0.842403, 7.787000, 1.655058>,
      < 0.889687, 7.871883, 1.691399>
    }
    triangle {
      < 0.818944, 7.789495, 1.672746>,
      < 0.889687, 7.871883, 1.691399>,
      < 0.717503, 7.892157, 1.751828>
    }
    triangle {
      < 0.917461, 7.731203, 1.582556>,
      < 0.994898, 7.771222, 1.434833>,
      < 1.013992, 7.843918, 1.540775>
    }
    triangle {
      < 0.917461, 7.731203, 1.582556>,
      < 1.013992, 7.843918, 1.540775>,
      < 0.889972, 7.766613, 1.614091>
    }
    texture {iris}
  }
  // legr
  union {
    triangle {
      < -1.300814, -14.712014, 0.513934>,
      < -1.305812, -15.344311, 0.504918>,
      < -0.889343, -15.344277, 0.470349>
    }
    triangle {
      < -1.300814, -14.712014, 0.513934>,
      < -0.889343, -15.344277, 0.470349>,
      < -0.926533, -14.682714, 0.270446>
    }
    triangle {
      < -1.800015, -15.344841, -0.049262>,
      < -1.701655, -15.344854, 0.246782>,
      < -1.681067, -14.709235, 0.431913>
    }
    triangle {
      < -1.800015, -15.344841, -0.049262>,
      < -1.681067, -14.709235, 0.431913>,
      < -1.834913, -14.700462, -0.114861>
    }
    triangle {
      < -1.766149, -15.344839, -0.538318>,
      < -1.800015, -15.344841, -0.049262>,
      < -1.834913, -14.700462, -0.114861>
    }
    triangle {
      < -1.766149, -15.344839, -0.538318>,
      < -1.834913, -14.700462, -0.114861>,
      < -1.695713, -14.682818, -0.573428>
    }
    triangle {
      < -1.411221, -15.344837, -0.728461>,
      < -1.621508, -15.344833, -0.686742>,
      < -1.695713, -14.682818, -0.573428>
    }
    triangle {
      < -1.411221, -15.344837, -0.728461>,
      < -1.695713, -14.682818, -0.573428>,
      < -1.405404, -14.700474, -0.800741>
    }
    triangle {
      < -1.115799, -15.344839, -0.663476>,
      < -1.411221, -15.344837, -0.728461>,
      < -1.405404, -14.700474, -0.800741>
    }
    triangle {
      < -1.115799, -15.344839, -0.663476>,
      < -1.405404, -14.700474, -0.800741>,
      < -0.940527, -14.703373, -0.826540>
    }
    triangle {
      < -0.918349, -15.344844, -0.308478>,
      < -1.115799, -15.344839, -0.663476>,
      < -0.940527, -14.703373, -0.826540>
    }
    triangle {
      < -0.918349, -15.344844, -0.308478>,
      < -0.940527, -14.703373, -0.826540>,
      < -0.738949, -14.691372, -0.469249>
    }
    triangle {
      < -0.768594, -15.344837, 0.001376>,
      < -0.918349, -15.344844, -0.308478>,
      < -0.738949, -14.691372, -0.469249>
    }
    triangle {
      < -0.768594, -15.344837, 0.001376>,
      < -0.738949, -14.691372, -0.469249>,
      < -0.714355, -14.685491, -0.016596>
    }
    triangle {
      < -0.664697, -15.344782, 0.311132>,
      < -0.768594, -15.344837, 0.001376>,
      < -0.714355, -14.685491, -0.016596>
    }
    triangle {
      < -0.664697, -15.344782, 0.311132>,
      < -0.714355, -14.685491, -0.016596>,
      < -0.926533, -14.682714, 0.270446>
    }
    triangle {
      < -1.501738, -15.344625, 0.448596>,
      < -1.681067, -14.709235, 0.431913>,
      < -1.701655, -15.344854, 0.246782>
    }
    triangle {
      < -0.331154, -17.092710, 2.664728>,
      < -0.276788, -17.107136, 2.189710>,
      < -0.217487, -16.956699, 2.005404>
    }
    triangle {
      < -0.331154, -17.092710, 2.664728>,
      < -0.217487, -16.956699, 2.005404>,
      < -0.279272, -16.944326, 2.725533>
    }
    triangle {
      < -0.279272, -16.944326, 2.725533>,
      < -0.681794, -16.892210, 2.815598>,
      < -0.743558, -17.083874, 2.762392>
    }
    triangle {
      < -0.279272, -16.944326, 2.725533>,
      < -0.743558, -17.083874, 2.762392>,
      < -0.331154, -17.092710, 2.664728>
    }
    triangle {
      < -0.290367, -16.716606, 2.243387>,
      < -0.728951, -16.653225, 2.259426>,
      < -0.654614, -16.782988, 2.825098>
    }
    triangle {
      < -0.290367, -16.716606, 2.243387>,
      < -0.654614, -16.782988, 2.825098>,
      < -0.266916, -16.818619, 2.731232>
    }
    triangle {
      < -0.428679, -16.739271, 1.287170>,
      < -0.349626, -16.575434, 1.478129>,
      < -0.232294, -16.750608, 1.724192>
    }
    triangle {
      < -0.407685, -16.430656, 1.712788>,
      < -0.768374, -16.405407, 1.778333>,
      < -0.728951, -16.653225, 2.259426>
    }
    triangle {
      < -0.407685, -16.430656, 1.712788>,
      < -0.728951, -16.653225, 2.259426>,
      < -0.290367, -16.716606, 2.243387>
    }
    triangle {
      < -1.072773, -16.533684, -0.828105>,
      < -1.019051, -16.840240, -0.816229>,
      < -1.393320, -16.833019, -0.947343>
    }
    triangle {
      < -1.072773, -16.533684, -0.828105>,
      < -1.393320, -16.833019, -0.947343>,
      < -1.416780, -16.527496, -0.942118>
    }
    triangle {
      < -0.879499, -15.898948, 0.918308>,
      < -0.746115, -16.151922, 1.298564>,
      < -0.546007, -16.330189, 1.133261>
    }
    triangle {
      < -0.879499, -15.898948, 0.918308>,
      < -0.546007, -16.330189, 1.133261>,
      < -0.595395, -16.045792, 0.751345>
    }
    triangle {
      < -0.689875, -16.277122, 0.111016>,
      < -0.717694, -16.558420, 0.562759>,
      < -0.812176, -16.548635, 0.208392>
    }
    triangle {
      < -1.971499, -16.848463, 1.710856>,
      < -1.930710, -16.857740, 0.931825>,
      < -1.882541, -17.050430, 0.924226>
    }
    triangle {
      < -1.971499, -16.848463, 1.710856>,
      < -1.882541, -17.050430, 0.924226>,
      < -1.935684, -17.038061, 1.704207>
    }
    triangle {
      < -1.383448, -17.023645, -0.864695>,
      < -1.393320, -16.833019, -0.947343>,
      < -1.019051, -16.840240, -0.816229>
    }
    triangle {
      < -1.383448, -17.023645, -0.864695>,
      < -1.019051, -16.840240, -0.816229>,
      < -1.054880, -17.013353, -0.753056>
    }
    triangle {
      < -1.812056, -16.522848, -0.859946>,
      < -1.823185, -16.843313, -0.839047>,
      < -1.947950, -16.840218, -0.602489>
    }
    triangle {
      < -1.812056, -16.522848, -0.859946>,
      < -1.947950, -16.840218, -0.602489>,
      < -1.938057, -16.522331, -0.646666>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -1.054880, -17.013353, -0.753056>,
      < -1.019051, -16.840240, -0.816229>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -1.019051, -16.840240, -0.816229>,
      < -0.916546, -16.842817, -0.215803>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -0.916546, -16.842817, -0.215803>,
      < -0.936331, -16.827877, 0.405523>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -0.936331, -16.827877, 0.405523>,
      < -1.151274, -17.021595, 0.563225>
    }
    triangle {
      < -0.906715, -17.045294, 1.084803>,
      < -1.151274, -17.021595, 0.563225>,
      < -0.936331, -16.827877, 0.405523>
    }
    triangle {
      < -0.906715, -17.045294, 1.084803>,
      < -0.936331, -16.827877, 0.405523>,
      < -0.779473, -16.876310, 0.842545>
    }
    triangle {
      < -0.906715, -17.045294, 1.084803>,
      < -0.779473, -16.876310, 0.842545>,
      < -0.315054, -16.966997, 1.524682>
    }
    triangle {
      < -0.906715, -17.045294, 1.084803>,
      < -0.315054, -16.966997, 1.524682>,
      < -0.311356, -17.072100, 1.659588>
    }
    triangle {
      < -0.311356, -17.072100, 1.659588>,
      < -0.315054, -16.966997, 1.524682>,
      < -0.217487, -16.956699, 2.005404>
    }
    triangle {
      < -0.311356, -17.072100, 1.659588>,
      < -0.217487, -16.956699, 2.005404>,
      < -0.276788, -17.107136, 2.189710>
    }
    triangle {
      < -0.349626, -16.575434, 1.478129>,
      < -0.407685, -16.430656, 1.712788>,
      < -0.290367, -16.716606, 2.243387>
    }
    triangle {
      < -0.349626, -16.575434, 1.478129>,
      < -0.290367, -16.716606, 2.243387>,
      < -0.232294, -16.750608, 1.724192>
    }
    triangle {
      < -1.952909, -16.542427, 0.216444>,
      < -1.938057, -16.522331, -0.646666>,
      < -1.947950, -16.840218, -0.602489>
    }
    triangle {
      < -1.952909, -16.542427, 0.216444>,
      < -1.947950, -16.840218, -0.602489>,
      < -1.936865, -16.847431, 0.308599>
    }
    triangle {
      < -1.938057, -16.522331, -0.646666>,
      < -1.952909, -16.542427, 0.216444>,
      < -1.931898, -16.313671, 0.040689>
    }
    triangle {
      < -1.938057, -16.522331, -0.646666>,
      < -1.931898, -16.313671, 0.040689>,
      < -1.891111, -16.286882, -0.638589>
    }
    triangle {
      < -0.546007, -16.330189, 1.133261>,
      < -0.746115, -16.151922, 1.298564>,
      < -0.407685, -16.430656, 1.712788>
    }
    triangle {
      < -0.546007, -16.330189, 1.133261>,
      < -0.407685, -16.430656, 1.712788>,
      < -0.349626, -16.575434, 1.478129>
    }
    triangle {
      < -0.573176, -16.427046, 0.836848>,
      < -0.546007, -16.330189, 1.133261>,
      < -0.349626, -16.575434, 1.478129>
    }
    triangle {
      < -0.573176, -16.427046, 0.836848>,
      < -0.349626, -16.575434, 1.478129>,
      < -0.428679, -16.739271, 1.287170>
    }
    triangle {
      < -0.717694, -16.558420, 0.562759>,
      < -0.573176, -16.427046, 0.836848>,
      < -0.428679, -16.739271, 1.287170>
    }
    triangle {
      < -0.812176, -16.548635, 0.208392>,
      < -0.873921, -16.551208, -0.277316>,
      < -0.870206, -16.331730, -0.319355>
    }
    triangle {
      < -0.812176, -16.548635, 0.208392>,
      < -0.870206, -16.331730, -0.319355>,
      < -0.689875, -16.277122, 0.111016>
    }
    triangle {
      < -0.873921, -16.551208, -0.277316>,
      < -1.072773, -16.533684, -0.828105>,
      < -1.107970, -16.294109, -0.812431>
    }
    triangle {
      < -0.873921, -16.551208, -0.277316>,
      < -1.107970, -16.294109, -0.812431>,
      < -0.870206, -16.331730, -0.319355>
    }
    triangle {
      < -0.843662, -15.580988, 0.594391>,
      < -0.879499, -15.898948, 0.918308>,
      < -0.595395, -16.045792, 0.751345>
    }
    triangle {
      < -0.573147, -15.763307, 0.422360>,
      < -0.843662, -15.580988, 0.594391>,
      < -0.595395, -16.045792, 0.751345>
    }
    triangle {
      < -0.573147, -15.763307, 0.422360>,
      < -0.595395, -16.045792, 0.751345>,
      < -0.575628, -16.146772, 0.559437>
    }
    triangle {
      < -0.689875, -16.277122, 0.111016>,
      < -0.573147, -15.763307, 0.422360>,
      < -0.575628, -16.146772, 0.559437>
    }
    triangle {
      < -1.776353, -16.870106, 2.277083>,
      < -1.971499, -16.848463, 1.710856>,
      < -1.935684, -17.038061, 1.704207>
    }
    triangle {
      < -1.776353, -16.870106, 2.277083>,
      < -1.935684, -17.038061, 1.704207>,
      < -1.757828, -17.043219, 2.237183>
    }
    triangle {
      < -1.776353, -16.870106, 2.277083>,
      < -1.757828, -17.043219, 2.237183>,
      < -1.371213, -17.053534, 2.586804>
    }
    triangle {
      < -1.776353, -16.870106, 2.277083>,
      < -1.371213, -17.053534, 2.586804>,
      < -1.388503, -16.894844, 2.630507>
    }
    triangle {
      < -1.070847, -16.891695, 2.791938>,
      < -1.388503, -16.894844, 2.630507>,
      < -1.371213, -17.053534, 2.586804>
    }
    triangle {
      < -1.070847, -16.891695, 2.791938>,
      < -1.371213, -17.053534, 2.586804>,
      < -1.043674, -17.060688, 2.717835>
    }
    triangle {
      < -0.681794, -16.892210, 2.815598>,
      < -1.070847, -16.891695, 2.791938>,
      < -1.043674, -17.060688, 2.717835>
    }
    triangle {
      < -0.681794, -16.892210, 2.815598>,
      < -1.043674, -17.060688, 2.717835>,
      < -0.743558, -17.083874, 2.762392>
    }
    triangle {
      < -1.947950, -16.840218, -0.602489>,
      < -1.823185, -16.843313, -0.839047>,
      < -1.791076, -17.016422, -0.767800>
    }
    triangle {
      < -1.947950, -16.840218, -0.602489>,
      < -1.791076, -17.016422, -0.767800>,
      < -1.915842, -17.029818, -0.563066>
    }
    triangle {
      < -1.947950, -16.840218, -0.602489>,
      < -1.915842, -17.029818, -0.563066>,
      < -1.897343, -17.039093, 0.289599>
    }
    triangle {
      < -1.947950, -16.840218, -0.602489>,
      < -1.897343, -17.039093, 0.289599>,
      < -1.936865, -16.847431, 0.308599>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -1.151274, -17.021595, 0.563225>,
      < -1.897343, -17.039093, 0.289599>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -1.897343, -17.039093, 0.289599>,
      < -1.915842, -17.029818, -0.563066>
    }
    triangle {
      < -1.930710, -16.857740, 0.931825>,
      < -1.936865, -16.847431, 0.308599>,
      < -1.897343, -17.039093, 0.289599>
    }
    triangle {
      < -1.930710, -16.857740, 0.931825>,
      < -1.897343, -17.039093, 0.289599>,
      < -1.882541, -17.050430, 0.924226>
    }
    triangle {
      < -1.856797, -15.897838, 0.323091>,
      < -1.940277, -15.920394, -0.031324>,
      < -1.931898, -16.313671, 0.040689>
    }
    triangle {
      < -1.856797, -15.897838, 0.323091>,
      < -1.931898, -16.313671, 0.040689>,
      < -1.867600, -16.218853, 0.441845>
    }
    triangle {
      < -1.867600, -16.218853, 0.441845>,
      < -1.772568, -16.093166, 0.679117>,
      < -1.613225, -16.002491, 0.815926>
    }
    triangle {
      < -1.867600, -16.218853, 0.441845>,
      < -1.613225, -16.002491, 0.815926>,
      < -1.581096, -15.803278, 0.539515>
    }
    triangle {
      < -1.867600, -16.218853, 0.441845>,
      < -1.581096, -15.803278, 0.539515>,
      < -1.856797, -15.897838, 0.323091>
    }
    triangle {
      < -1.613225, -16.002491, 0.815926>,
      < -1.772568, -16.093166, 0.679117>,
      < -1.793585, -16.272459, 1.038232>
    }
    triangle {
      < -1.613225, -16.002491, 0.815926>,
      < -1.793585, -16.272459, 1.038232>,
      < -1.615712, -16.181786, 1.188342>
    }
    triangle {
      < -1.360004, -15.908727, 0.911886>,
      < -1.613225, -16.002491, 0.815926>,
      < -1.615712, -16.181786, 1.188342>
    }
    triangle {
      < -1.360004, -15.908727, 0.911886>,
      < -1.615712, -16.181786, 1.188342>,
      < -1.376081, -16.120996, 1.285251>
    }
    triangle {
      < -0.879499, -15.898948, 0.918308>,
      < -1.360004, -15.908727, 0.911886>,
      < -1.376081, -16.120996, 1.285251>
    }
    triangle {
      < -0.879499, -15.898948, 0.918308>,
      < -1.376081, -16.120996, 1.285251>,
      < -1.017865, -16.109667, 1.315659>
    }
    triangle {
      < -0.879499, -15.898948, 0.918308>,
      < -1.017865, -16.109667, 1.315659>,
      < -0.746115, -16.151922, 1.298564>
    }
    triangle {
      < -1.907846, -16.537790, 0.856772>,
      < -1.930710, -16.857740, 0.931825>,
      < -1.914657, -16.662985, 1.258638>
    }
    triangle {
      < -1.777546, -16.521307, 1.368371>,
      < -1.793585, -16.272459, 1.038232>,
      < -1.907846, -16.537790, 0.856772>
    }
    triangle {
      < -1.793585, -16.272459, 1.038232>,
      < -1.777546, -16.521307, 1.368371>,
      < -1.587325, -16.467213, 1.565508>
    }
    triangle {
      < -1.793585, -16.272459, 1.038232>,
      < -1.587325, -16.467213, 1.565508>,
      < -1.615712, -16.181786, 1.188342>
    }
    triangle {
      < -1.378573, -16.430637, 1.676192>,
      < -1.376081, -16.120996, 1.285251>,
      < -1.615712, -16.181786, 1.188342>
    }
    triangle {
      < -1.378573, -16.430637, 1.676192>,
      < -1.615712, -16.181786, 1.188342>,
      < -1.587325, -16.467213, 1.565508>
    }
    triangle {
      < -1.376081, -16.120996, 1.285251>,
      < -1.378573, -16.430637, 1.676192>,
      < -1.035183, -16.405399, 1.759327>
    }
    triangle {
      < -1.376081, -16.120996, 1.285251>,
      < -1.035183, -16.405399, 1.759327>,
      < -1.017865, -16.109667, 1.315659>
    }
    triangle {
      < -0.768374, -16.405407, 1.778333>,
      < -0.746115, -16.151922, 1.298564>,
      < -1.017865, -16.109667, 1.315659>
    }
    triangle {
      < -0.768374, -16.405407, 1.778333>,
      < -1.017865, -16.109667, 1.315659>,
      < -1.035183, -16.405399, 1.759327>
    }
    triangle {
      < -1.864329, -16.617907, 1.554815>,
      < -1.777546, -16.521307, 1.368371>,
      < -1.907846, -16.537790, 0.856772>
    }
    triangle {
      < -1.864329, -16.617907, 1.554815>,
      < -1.907846, -16.537790, 0.856772>,
      < -1.914657, -16.662985, 1.258638>
    }
    triangle {
      < -1.864329, -16.617907, 1.554815>,
      < -1.628723, -16.621517, 1.932459>,
      < -1.587325, -16.467213, 1.565508>
    }
    triangle {
      < -1.864329, -16.617907, 1.554815>,
      < -1.587325, -16.467213, 1.565508>,
      < -1.777546, -16.521307, 1.368371>
    }
    triangle {
      < -1.369638, -16.610191, 2.057869>,
      < -1.378573, -16.430637, 1.676192>,
      < -1.587325, -16.467213, 1.565508>
    }
    triangle {
      < -1.369638, -16.610191, 2.057869>,
      < -1.587325, -16.467213, 1.565508>,
      < -1.628723, -16.621517, 1.932459>
    }
    triangle {
      < -1.369638, -16.610191, 2.057869>,
      < -1.014823, -16.623846, 2.204896>,
      < -1.035183, -16.405399, 1.759327>
    }
    triangle {
      < -1.369638, -16.610191, 2.057869>,
      < -1.035183, -16.405399, 1.759327>,
      < -1.378573, -16.430637, 1.676192>
    }
    triangle {
      < -0.728951, -16.653225, 2.259426>,
      < -0.768374, -16.405407, 1.778333>,
      < -1.035183, -16.405399, 1.759327>
    }
    triangle {
      < -0.728951, -16.653225, 2.259426>,
      < -1.035183, -16.405399, 1.759327>,
      < -1.014823, -16.623846, 2.204896>
    }
    triangle {
      < -1.628723, -16.621517, 1.932459>,
      < -1.864329, -16.617907, 1.554815>,
      < -1.971499, -16.848463, 1.710856>
    }
    triangle {
      < -1.628723, -16.621517, 1.932459>,
      < -1.971499, -16.848463, 1.710856>,
      < -1.776353, -16.870106, 2.277083>
    }
    triangle {
      < -1.369638, -16.610191, 2.057869>,
      < -1.628723, -16.621517, 1.932459>,
      < -1.776353, -16.870106, 2.277083>
    }
    triangle {
      < -1.369638, -16.610191, 2.057869>,
      < -1.776353, -16.870106, 2.277083>,
      < -1.388503, -16.894844, 2.630507>
    }
    triangle {
      < -1.014823, -16.623846, 2.204896>,
      < -1.369638, -16.610191, 2.057869>,
      < -1.388503, -16.894844, 2.630507>
    }
    triangle {
      < -1.014823, -16.623846, 2.204896>,
      < -1.388503, -16.894844, 2.630507>,
      < -1.070847, -16.891695, 2.791938>
    }
    triangle {
      < -0.728951, -16.653225, 2.259426>,
      < -1.014823, -16.623846, 2.204896>,
      < -1.070847, -16.891695, 2.791938>
    }
    triangle {
      < -0.728951, -16.653225, 2.259426>,
      < -1.070847, -16.891695, 2.791938>,
      < -0.681794, -16.892210, 2.815598>
    }
    triangle {
      < -1.416780, -16.527496, -0.942118>,
      < -1.463711, -16.266281, -0.902691>,
      < -1.107970, -16.294109, -0.812431>
    }
    triangle {
      < -1.416780, -16.527496, -0.942118>,
      < -1.107970, -16.294109, -0.812431>,
      < -1.072773, -16.533684, -0.828105>
    }
    triangle {
      < -1.393320, -16.833019, -0.947343>,
      < -1.823185, -16.843313, -0.839047>,
      < -1.812056, -16.522848, -0.859946>
    }
    triangle {
      < -1.393320, -16.833019, -0.947343>,
      < -1.812056, -16.522848, -0.859946>,
      < -1.416780, -16.527496, -0.942118>
    }
    triangle {
      < -0.428679, -16.739271, 1.287170>,
      < -0.232294, -16.750608, 1.724192>,
      < -0.217487, -16.956699, 2.005404>
    }
    triangle {
      < -0.428679, -16.739271, 1.287170>,
      < -0.217487, -16.956699, 2.005404>,
      < -0.315054, -16.966997, 1.524682>
    }
    triangle {
      < -0.428679, -16.739271, 1.287170>,
      < -0.315054, -16.966997, 1.524682>,
      < -0.779473, -16.876310, 0.842545>
    }
    triangle {
      < -0.428679, -16.739271, 1.287170>,
      < -0.779473, -16.876310, 0.842545>,
      < -0.717694, -16.558420, 0.562759>
    }
    triangle {
      < -0.717694, -16.558420, 0.562759>,
      < -0.779473, -16.876310, 0.842545>,
      < -0.936331, -16.827877, 0.405523>
    }
    triangle {
      < -0.717694, -16.558420, 0.562759>,
      < -0.936331, -16.827877, 0.405523>,
      < -0.812176, -16.548635, 0.208392>
    }
    triangle {
      < -0.873921, -16.551208, -0.277316>,
      < -0.812176, -16.548635, 0.208392>,
      < -0.936331, -16.827877, 0.405523>
    }
    triangle {
      < -0.873921, -16.551208, -0.277316>,
      < -0.936331, -16.827877, 0.405523>,
      < -0.916546, -16.842817, -0.215803>
    }
    triangle {
      < -0.873921, -16.551208, -0.277316>,
      < -0.916546, -16.842817, -0.215803>,
      < -1.019051, -16.840240, -0.816229>
    }
    triangle {
      < -0.873921, -16.551208, -0.277316>,
      < -1.019051, -16.840240, -0.816229>,
      < -1.072773, -16.533684, -0.828105>
    }
    triangle {
      < -0.654614, -16.782988, 2.825098>,
      < -0.681794, -16.892210, 2.815598>,
      < -0.279272, -16.944326, 2.725533>
    }
    triangle {
      < -0.654614, -16.782988, 2.825098>,
      < -0.279272, -16.944326, 2.725533>,
      < -0.266916, -16.818619, 2.731232>
    }
    triangle {
      < -1.416780, -16.527496, -0.942118>,
      < -1.812056, -16.522848, -0.859946>,
      < -1.716935, -16.258036, -0.844744>
    }
    triangle {
      < -1.416780, -16.527496, -0.942118>,
      < -1.716935, -16.258036, -0.844744>,
      < -1.463711, -16.266281, -0.902691>
    }
    triangle {
      < -1.393320, -16.833019, -0.947343>,
      < -1.383448, -17.023645, -0.864695>,
      < -1.791076, -17.016422, -0.767800>
    }
    triangle {
      < -1.393320, -16.833019, -0.947343>,
      < -1.791076, -17.016422, -0.767800>,
      < -1.823185, -16.843313, -0.839047>
    }
    triangle {
      < -1.864329, -16.617907, 1.554815>,
      < -1.914657, -16.662985, 1.258638>,
      < -1.930710, -16.857740, 0.931825>
    }
    triangle {
      < -1.864329, -16.617907, 1.554815>,
      < -1.930710, -16.857740, 0.931825>,
      < -1.971499, -16.848463, 1.710856>
    }
    triangle {
      < -1.907846, -16.537790, 0.856772>,
      < -1.952909, -16.542427, 0.216444>,
      < -1.936865, -16.847431, 0.308599>
    }
    triangle {
      < -1.907846, -16.537790, 0.856772>,
      < -1.936865, -16.847431, 0.308599>,
      < -1.930710, -16.857740, 0.931825>
    }
    triangle {
      < -0.290367, -16.716606, 2.243387>,
      < -0.266916, -16.818619, 2.731232>,
      < -0.279272, -16.944326, 2.725533>
    }
    triangle {
      < -0.290367, -16.716606, 2.243387>,
      < -0.279272, -16.944326, 2.725533>,
      < -0.217487, -16.956699, 2.005404>
    }
    triangle {
      < -0.232294, -16.750608, 1.724192>,
      < -0.290367, -16.716606, 2.243387>,
      < -0.217487, -16.956699, 2.005404>
    }
    triangle {
      < -0.407685, -16.430656, 1.712788>,
      < -0.746115, -16.151922, 1.298564>,
      < -0.768374, -16.405407, 1.778333>
    }
    triangle {
      < -0.575628, -16.146772, 0.559437>,
      < -0.595395, -16.045792, 0.751345>,
      < -0.546007, -16.330189, 1.133261>
    }
    triangle {
      < -0.575628, -16.146772, 0.559437>,
      < -0.546007, -16.330189, 1.133261>,
      < -0.573176, -16.427046, 0.836848>
    }
    triangle {
      < -0.689875, -16.277122, 0.111016>,
      < -0.575628, -16.146772, 0.559437>,
      < -0.573176, -16.427046, 0.836848>
    }
    triangle {
      < -0.689875, -16.277122, 0.111016>,
      < -0.573176, -16.427046, 0.836848>,
      < -0.717694, -16.558420, 0.562759>
    }
    triangle {
      < -0.879499, -15.898948, 0.918308>,
      < -0.843662, -15.580988, 0.594391>,
      < -1.345166, -15.595141, 0.634045>
    }
    triangle {
      < -0.879499, -15.898948, 0.918308>,
      < -1.345166, -15.595141, 0.634045>,
      < -1.360004, -15.908727, 0.911886>
    }
    triangle {
      < -1.360004, -15.908727, 0.911886>,
      < -1.345166, -15.595141, 0.634045>,
      < -1.581096, -15.803278, 0.539515>
    }
    triangle {
      < -1.360004, -15.908727, 0.911886>,
      < -1.581096, -15.803278, 0.539515>,
      < -1.613225, -16.002491, 0.815926>
    }
    triangle {
      < -1.891111, -16.286882, -0.638589>,
      < -1.716935, -16.258036, -0.844744>,
      < -1.812056, -16.522848, -0.859946>
    }
    triangle {
      < -1.891111, -16.286882, -0.638589>,
      < -1.812056, -16.522848, -0.859946>,
      < -1.938057, -16.522331, -0.646666>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -0.906715, -17.045294, 1.084803>,
      < -0.311356, -17.072100, 1.659588>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -0.311356, -17.072100, 1.659588>,
      < -0.276788, -17.107136, 2.189710>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -0.276788, -17.107136, 2.189710>,
      < -0.331154, -17.092710, 2.664728>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -0.331154, -17.092710, 2.664728>,
      < -0.743558, -17.083874, 2.762392>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -0.743558, -17.083874, 2.762392>,
      < -1.043674, -17.060688, 2.717835>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -1.043674, -17.060688, 2.717835>,
      < -1.371213, -17.053534, 2.586804>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -1.371213, -17.053534, 2.586804>,
      < -1.757828, -17.043219, 2.237183>
    }
    triangle {
      < -1.882541, -17.050430, 0.924226>,
      < -1.757828, -17.043219, 2.237183>,
      < -1.935684, -17.038061, 1.704207>
    }
    triangle {
      < -0.728951, -16.653225, 2.259426>,
      < -0.681794, -16.892210, 2.815598>,
      < -0.654614, -16.782988, 2.825098>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -1.915842, -17.029818, -0.563066>,
      < -1.791076, -17.016422, -0.767800>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -1.791076, -17.016422, -0.767800>,
      < -1.383448, -17.023645, -0.864695>
    }
    triangle {
      < -1.006726, -17.017984, -0.182553>,
      < -1.383448, -17.023645, -0.864695>,
      < -1.054880, -17.013353, -0.753056>
    }
    triangle {
      < -0.906715, -17.045294, 1.084803>,
      < -1.882541, -17.050430, 0.924226>,
      < -1.151274, -17.021595, 0.563225>
    }
    triangle {
      < -1.151274, -17.021595, 0.563225>,
      < -1.882541, -17.050430, 0.924226>,
      < -1.897343, -17.039093, 0.289599>
    }
    triangle {
      < -0.698256, -15.923849, 0.026701>,
      < -0.689875, -16.277122, 0.111016>,
      < -0.870206, -16.331730, -0.319355>
    }
    triangle {
      < -0.698256, -15.923849, 0.026701>,
      < -0.870206, -16.331730, -0.319355>,
      < -0.878589, -15.894060, -0.327680>
    }
    triangle {
      < -0.870206, -16.331730, -0.319355>,
      < -1.107970, -16.294109, -0.812431>,
      < -1.116355, -15.854812, -0.733294>
    }
    triangle {
      < -0.870206, -16.331730, -0.319355>,
      < -1.116355, -15.854812, -0.733294>,
      < -0.878589, -15.894060, -0.327680>
    }
    triangle {
      < -1.107970, -16.294109, -0.812431>,
      < -1.463711, -16.266281, -0.902691>,
      < -1.472099, -15.846555, -0.807462>
    }
    triangle {
      < -1.107970, -16.294109, -0.812431>,
      < -1.472099, -15.846555, -0.807462>,
      < -1.116355, -15.854812, -0.733294>
    }
    triangle {
      < -1.463711, -16.266281, -0.902691>,
      < -1.716935, -16.258036, -0.844744>,
      < -1.725320, -15.850518, -0.759745>
    }
    triangle {
      < -1.463711, -16.266281, -0.902691>,
      < -1.725320, -15.850518, -0.759745>,
      < -1.472099, -15.846555, -0.807462>
    }
    triangle {
      < -1.716935, -16.258036, -0.844744>,
      < -1.891111, -16.286882, -0.638589>,
      < -1.899495, -15.867600, -0.590210>
    }
    triangle {
      < -1.716935, -16.258036, -0.844744>,
      < -1.899495, -15.867600, -0.590210>,
      < -1.725320, -15.850518, -0.759745>
    }
    triangle {
      < -1.891111, -16.286882, -0.638589>,
      < -1.931898, -16.313671, 0.040689>,
      < -1.940277, -15.920394, -0.031324>
    }
    triangle {
      < -1.891111, -16.286882, -0.638589>,
      < -1.940277, -15.920394, -0.031324>,
      < -1.899495, -15.867600, -0.590210>
    }
    triangle {
      < -0.698256, -15.923849, 0.026701>,
      < -0.573147, -15.763307, 0.422360>,
      < -0.689875, -16.277122, 0.111016>
    }
    triangle {
      < -1.940277, -15.920394, -0.031324>,
      < -1.856797, -15.897838, 0.323091>,
      < -1.701655, -15.344854, 0.246782>
    }
    triangle {
      < -1.940277, -15.920394, -0.031324>,
      < -1.701655, -15.344854, 0.246782>,
      < -1.800015, -15.344841, -0.049262>
    }
    triangle {
      < -1.856797, -15.897838, 0.323091>,
      < -1.581096, -15.803278, 0.539515>,
      < -1.501738, -15.344625, 0.448596>
    }
    triangle {
      < -1.856797, -15.897838, 0.323091>,
      < -1.501738, -15.344625, 0.448596>,
      < -1.701655, -15.344854, 0.246782>
    }
    triangle {
      < -1.581096, -15.803278, 0.539515>,
      < -1.345166, -15.595141, 0.634045>,
      < -1.305812, -15.344311, 0.504918>
    }
    triangle {
      < -1.581096, -15.803278, 0.539515>,
      < -1.305812, -15.344311, 0.504918>,
      < -1.501738, -15.344625, 0.448596>
    }
    triangle {
      < -1.345166, -15.595141, 0.634045>,
      < -0.843662, -15.580988, 0.594391>,
      < -0.889343, -15.344277, 0.470349>
    }
    triangle {
      < -1.345166, -15.595141, 0.634045>,
      < -0.889343, -15.344277, 0.470349>,
      < -1.305812, -15.344311, 0.504918>
    }
    triangle {
      < -0.843662, -15.580988, 0.594391>,
      < -0.573147, -15.763307, 0.422360>,
      < -0.664697, -15.344782, 0.311132>
    }
    triangle {
      < -0.843662, -15.580988, 0.594391>,
      < -0.664697, -15.344782, 0.311132>,
      < -0.889343, -15.344277, 0.470349>
    }
    triangle {
      < -0.573147, -15.763307, 0.422360>,
      < -0.698256, -15.923849, 0.026701>,
      < -0.768594, -15.344837, 0.001376>
    }
    triangle {
      < -0.573147, -15.763307, 0.422360>,
      < -0.768594, -15.344837, 0.001376>,
      < -0.664697, -15.344782, 0.311132>
    }
    triangle {
      < -0.768594, -15.344837, 0.001376>,
      < -0.698256, -15.923849, 0.026701>,
      < -0.878589, -15.894060, -0.327680>
    }
    triangle {
      < -0.768594, -15.344837, 0.001376>,
      < -0.878589, -15.894060, -0.327680>,
      < -0.918349, -15.344844, -0.308478>
    }
    triangle {
      < -0.878589, -15.894060, -0.327680>,
      < -1.116355, -15.854812, -0.733294>,
      < -1.115799, -15.344839, -0.663476>
    }
    triangle {
      < -0.878589, -15.894060, -0.327680>,
      < -1.115799, -15.344839, -0.663476>,
      < -0.918349, -15.344844, -0.308478>
    }
    triangle {
      < -1.116355, -15.854812, -0.733294>,
      < -1.472099, -15.846555, -0.807462>,
      < -1.411221, -15.344837, -0.728461>
    }
    triangle {
      < -1.116355, -15.854812, -0.733294>,
      < -1.411221, -15.344837, -0.728461>,
      < -1.115799, -15.344839, -0.663476>
    }
    triangle {
      < -1.472099, -15.846555, -0.807462>,
      < -1.725320, -15.850518, -0.759745>,
      < -1.621508, -15.344833, -0.686742>
    }
    triangle {
      < -1.472099, -15.846555, -0.807462>,
      < -1.621508, -15.344833, -0.686742>,
      < -1.411221, -15.344837, -0.728461>
    }
    triangle {
      < -1.725320, -15.850518, -0.759745>,
      < -1.899495, -15.867600, -0.590210>,
      < -1.766149, -15.344839, -0.538318>
    }
    triangle {
      < -1.725320, -15.850518, -0.759745>,
      < -1.766149, -15.344839, -0.538318>,
      < -1.621508, -15.344833, -0.686742>
    }
    triangle {
      < -1.899495, -15.867600, -0.590210>,
      < -1.940277, -15.920394, -0.031324>,
      < -1.800015, -15.344841, -0.049262>
    }
    triangle {
      < -1.899495, -15.867600, -0.590210>,
      < -1.800015, -15.344841, -0.049262>,
      < -1.766149, -15.344839, -0.538318>
    }
    triangle {
      < -1.975347, -7.812831, 1.241284>,
      < -2.443700, -7.794046, 0.570322>,
      < -2.263930, -8.512464, 0.590685>
    }
    triangle {
      < -1.975347, -7.812831, 1.241284>,
      < -2.263930, -8.512464, 0.590685>,
      < -1.933751, -8.505154, 1.083439>
    }
    triangle {
      < -2.443700, -7.794046, 0.570322>,
      < -2.479350, -7.832503, -0.152257>,
      < -2.328718, -8.622602, -0.163540>
    }
    triangle {
      < -2.443700, -7.794046, 0.570322>,
      < -2.328718, -8.622602, -0.163540>,
      < -2.263930, -8.512464, 0.590685>
    }
    triangle {
      < -2.479350, -7.832503, -0.152257>,
      < -2.044399, -7.905108, -0.789951>,
      < -1.895853, -8.798336, -0.801008>
    }
    triangle {
      < -2.479350, -7.832503, -0.152257>,
      < -1.895853, -8.798336, -0.801008>,
      < -2.328718, -8.622602, -0.163540>
    }
    triangle {
      < -2.044399, -7.905108, -0.789951>,
      < -1.252770, -8.003237, -0.934381>,
      < -1.244147, -8.856845, -0.855775>
    }
    triangle {
      < -2.044399, -7.905108, -0.789951>,
      < -1.244147, -8.856845, -0.855775>,
      < -1.895853, -8.798336, -0.801008>
    }
    triangle {
      < -1.252770, -8.003237, -0.934381>,
      < -0.700721, -8.056448, -0.504861>,
      < -0.796331, -8.874737, -0.488902>
    }
    triangle {
      < -1.252770, -8.003237, -0.934381>,
      < -0.796331, -8.874737, -0.488902>,
      < -1.244147, -8.856845, -0.855775>
    }
    triangle {
      < -0.700721, -8.056448, -0.504861>,
      < -0.370201, -8.109273, 0.418486>,
      < -0.513613, -8.778045, 0.117577>
    }
    triangle {
      < -0.700721, -8.056448, -0.504861>,
      < -0.513613, -8.778045, 0.117577>,
      < -0.796331, -8.874737, -0.488902>
    }
    triangle {
      < -1.336529, -7.864736, 1.430424>,
      < -1.975347, -7.812831, 1.241284>,
      < -1.933751, -8.505154, 1.083439>
    }
    triangle {
      < -1.336529, -7.864736, 1.430424>,
      < -1.933751, -8.505154, 1.083439>,
      < -1.222692, -8.558242, 1.154920>
    }
    triangle {
      < -1.933751, -8.505154, 1.083439>,
      < -2.263930, -8.512464, 0.590685>,
      < -2.261867, -8.909725, 0.696070>
    }
    triangle {
      < -1.933751, -8.505154, 1.083439>,
      < -2.261867, -8.909725, 0.696070>,
      < -1.908992, -8.895303, 1.178878>
    }
    triangle {
      < -2.263930, -8.512464, 0.590685>,
      < -2.328718, -8.622602, -0.163540>,
      < -2.319101, -9.021067, -0.176046>
    }
    triangle {
      < -2.263930, -8.512464, 0.590685>,
      < -2.319101, -9.021067, -0.176046>,
      < -2.261867, -8.909725, 0.696070>
    }
    triangle {
      < -2.328718, -8.622602, -0.163540>,
      < -1.895853, -8.798336, -0.801008>,
      < -1.874532, -9.173381, -0.803333>
    }
    triangle {
      < -2.328718, -8.622602, -0.163540>,
      < -1.874532, -9.173381, -0.803333>,
      < -2.319101, -9.021067, -0.176046>
    }
    triangle {
      < -1.895853, -8.798336, -0.801008>,
      < -1.244147, -8.856845, -0.855775>,
      < -1.236629, -9.214582, -0.817226>
    }
    triangle {
      < -1.895853, -8.798336, -0.801008>,
      < -1.236629, -9.214582, -0.817226>,
      < -1.874532, -9.173381, -0.803333>
    }
    triangle {
      < -1.244147, -8.856845, -0.855775>,
      < -0.796331, -8.874737, -0.488902>,
      < -0.800694, -9.208599, -0.417761>
    }
    triangle {
      < -1.244147, -8.856845, -0.855775>,
      < -0.800694, -9.208599, -0.417761>,
      < -1.236629, -9.214582, -0.817226>
    }
    triangle {
      < -0.796331, -8.874737, -0.488902>,
      < -0.513613, -8.778045, 0.117577>,
      < -0.549594, -9.182402, 0.089109>
    }
    triangle {
      < -0.796331, -8.874737, -0.488902>,
      < -0.549594, -9.182402, 0.089109>,
      < -0.800694, -9.208599, -0.417761>
    }
    triangle {
      < -0.513613, -8.778045, 0.117577>,
      < -0.668801, -8.649164, 0.894079>,
      < -0.690342, -9.021214, 0.823269>
    }
    triangle {
      < -0.513613, -8.778045, 0.117577>,
      < -0.690342, -9.021214, 0.823269>,
      < -0.549594, -9.182402, 0.089109>
    }
    triangle {
      < -0.668801, -8.649164, 0.894079>,
      < -1.222692, -8.558242, 1.154920>,
      < -1.180465, -8.898202, 1.212831>
    }
    triangle {
      < -0.668801, -8.649164, 0.894079>,
      < -1.180465, -8.898202, 1.212831>,
      < -0.690342, -9.021214, 0.823269>
    }
    triangle {
      < -1.222692, -8.558242, 1.154920>,
      < -1.933751, -8.505154, 1.083439>,
      < -1.908992, -8.895303, 1.178878>
    }
    triangle {
      < -1.222692, -8.558242, 1.154920>,
      < -1.908992, -8.895303, 1.178878>,
      < -1.180465, -8.898202, 1.212831>
    }
    triangle {
      < -1.908992, -8.895303, 1.178878>,
      < -2.261867, -8.909725, 0.696070>,
      < -2.206087, -9.431392, 0.614165>
    }
    triangle {
      < -1.908992, -8.895303, 1.178878>,
      < -2.206087, -9.431392, 0.614165>,
      < -1.876215, -9.446047, 1.079474>
    }
    triangle {
      < -2.261867, -8.909725, 0.696070>,
      < -2.319101, -9.021067, -0.176046>,
      < -2.281945, -9.478472, -0.308398>
    }
    triangle {
      < -2.261867, -8.909725, 0.696070>,
      < -2.281945, -9.478472, -0.308398>,
      < -2.206087, -9.431392, 0.614165>
    }
    triangle {
      < -2.319101, -9.021067, -0.176046>,
      < -1.874532, -9.173381, -0.803333>,
      < -1.821774, -9.510803, -0.894916>
    }
    triangle {
      < -2.319101, -9.021067, -0.176046>,
      < -1.821774, -9.510803, -0.894916>,
      < -2.281945, -9.478472, -0.308398>
    }
    triangle {
      < -1.874532, -9.173381, -0.803333>,
      < -1.236629, -9.214582, -0.817226>,
      < -1.160604, -9.510589, -0.900778>
    }
    triangle {
      < -1.874532, -9.173381, -0.803333>,
      < -1.160604, -9.510589, -0.900778>,
      < -1.821774, -9.510803, -0.894916>
    }
    triangle {
      < -1.236629, -9.214582, -0.817226>,
      < -0.800694, -9.208599, -0.417761>,
      < -0.746533, -9.528240, -0.513452>
    }
    triangle {
      < -1.236629, -9.214582, -0.817226>,
      < -0.746533, -9.528240, -0.513452>,
      < -1.160604, -9.510589, -0.900778>
    }
    triangle {
      < -0.800694, -9.208599, -0.417761>,
      < -0.549594, -9.182402, 0.089109>,
      < -0.578598, -9.525470, 0.004078>
    }
    triangle {
      < -0.800694, -9.208599, -0.417761>,
      < -0.578598, -9.525470, 0.004078>,
      < -0.746533, -9.528240, -0.513452>
    }
    triangle {
      < -0.549594, -9.182402, 0.089109>,
      < -0.690342, -9.021214, 0.823269>,
      < -0.689378, -9.522341, 0.730052>
    }
    triangle {
      < -0.549594, -9.182402, 0.089109>,
      < -0.689378, -9.522341, 0.730052>,
      < -0.578598, -9.525470, 0.004078>
    }
    triangle {
      < -0.690342, -9.021214, 0.823269>,
      < -1.180465, -8.898202, 1.212831>,
      < -1.162261, -9.475252, 1.131596>
    }
    triangle {
      < -0.690342, -9.021214, 0.823269>,
      < -1.162261, -9.475252, 1.131596>,
      < -0.689378, -9.522341, 0.730052>
    }
    triangle {
      < -1.180465, -8.898202, 1.212831>,
      < -1.908992, -8.895303, 1.178878>,
      < -1.876215, -9.446047, 1.079474>
    }
    triangle {
      < -1.180465, -8.898202, 1.212831>,
      < -1.876215, -9.446047, 1.079474>,
      < -1.162261, -9.475252, 1.131596>
    }
    triangle {
      < -1.876215, -9.446047, 1.079474>,
      < -2.206087, -9.431392, 0.614165>,
      < -2.122164, -9.988276, 0.401886>
    }
    triangle {
      < -1.876215, -9.446047, 1.079474>,
      < -2.122164, -9.988276, 0.401886>,
      < -1.760825, -10.078956, 0.801509>
    }
    triangle {
      < -2.206087, -9.431392, 0.614165>,
      < -2.281945, -9.478472, -0.308398>,
      < -2.289495, -9.935560, -0.547479>
    }
    triangle {
      < -2.206087, -9.431392, 0.614165>,
      < -2.289495, -9.935560, -0.547479>,
      < -2.122164, -9.988276, 0.401886>
    }
    triangle {
      < -2.281945, -9.478472, -0.308398>,
      < -1.821774, -9.510803, -0.894916>,
      < -1.838400, -9.877200, -1.134759>
    }
    triangle {
      < -2.281945, -9.478472, -0.308398>,
      < -1.838400, -9.877200, -1.134759>,
      < -2.289495, -9.935560, -0.547479>
    }
    triangle {
      < -1.821774, -9.510803, -0.894916>,
      < -1.160604, -9.510589, -0.900778>,
      < -1.077830, -9.847917, -1.085750>
    }
    triangle {
      < -1.821774, -9.510803, -0.894916>,
      < -1.077830, -9.847917, -1.085750>,
      < -1.838400, -9.877200, -1.134759>
    }
    triangle {
      < -1.160604, -9.510589, -0.900778>,
      < -0.746533, -9.528240, -0.513452>,
      < -0.669742, -9.888981, -0.621261>
    }
    triangle {
      < -1.160604, -9.510589, -0.900778>,
      < -0.669742, -9.888981, -0.621261>,
      < -1.077830, -9.847917, -1.085750>
    }
    triangle {
      < -0.746533, -9.528240, -0.513452>,
      < -0.578598, -9.525470, 0.004078>,
      < -0.593296, -10.017845, -0.131055>
    }
    triangle {
      < -0.746533, -9.528240, -0.513452>,
      < -0.593296, -10.017845, -0.131055>,
      < -0.669742, -9.888981, -0.621261>
    }
    triangle {
      < -0.578598, -9.525470, 0.004078>,
      < -0.689378, -9.522341, 0.730052>,
      < -0.876520, -10.155484, 0.512643>
    }
    triangle {
      < -0.578598, -9.525470, 0.004078>,
      < -0.876520, -10.155484, 0.512643>,
      < -0.593296, -10.017845, -0.131055>
    }
    triangle {
      < -0.689378, -9.522341, 0.730052>,
      < -1.162261, -9.475252, 1.131596>,
      < -1.271736, -10.158121, 0.823681>
    }
    triangle {
      < -0.689378, -9.522341, 0.730052>,
      < -1.271736, -10.158121, 0.823681>,
      < -0.876520, -10.155484, 0.512643>
    }
    triangle {
      < -1.162261, -9.475252, 1.131596>,
      < -1.876215, -9.446047, 1.079474>,
      < -1.760825, -10.078956, 0.801509>
    }
    triangle {
      < -1.162261, -9.475252, 1.131596>,
      < -1.760825, -10.078956, 0.801509>,
      < -1.271736, -10.158121, 0.823681>
    }
    triangle {
      < -1.760825, -10.078956, 0.801509>,
      < -2.122164, -9.988276, 0.401886>,
      < -2.303299, -10.987743, 0.162974>
    }
    triangle {
      < -1.760825, -10.078956, 0.801509>,
      < -2.303299, -10.987743, 0.162974>,
      < -1.879315, -11.014043, 0.636238>
    }
    triangle {
      < -2.122164, -9.988276, 0.401886>,
      < -2.289495, -9.935560, -0.547479>,
      < -2.479603, -10.952571, -0.796086>
    }
    triangle {
      < -2.122164, -9.988276, 0.401886>,
      < -2.479603, -10.952571, -0.796086>,
      < -2.303299, -10.987743, 0.162974>
    }
    triangle {
      < -2.289495, -9.935560, -0.547479>,
      < -1.838400, -9.877200, -1.134759>,
      < -1.895554, -10.882447, -1.356951>
    }
    triangle {
      < -2.289495, -9.935560, -0.547479>,
      < -1.895554, -10.882447, -1.356951>,
      < -2.479603, -10.952571, -0.796086>
    }
    triangle {
      < -1.838400, -9.877200, -1.134759>,
      < -1.077830, -9.847917, -1.085750>,
      < -1.018189, -10.820683, -1.391078>
    }
    triangle {
      < -1.838400, -9.877200, -1.134759>,
      < -1.018189, -10.820683, -1.391078>,
      < -1.895554, -10.882447, -1.356951>
    }
    triangle {
      < -1.077830, -9.847917, -1.085750>,
      < -0.669742, -9.888981, -0.621261>,
      < -0.420288, -10.969921, -1.070736>
    }
    triangle {
      < -1.077830, -9.847917, -1.085750>,
      < -0.420288, -10.969921, -1.070736>,
      < -1.018189, -10.820683, -1.391078>
    }
    triangle {
      < -0.669742, -9.888981, -0.621261>,
      < -0.593296, -10.017845, -0.131055>,
      < -0.513669, -10.879103, -0.239414>
    }
    triangle {
      < -0.669742, -9.888981, -0.621261>,
      < -0.513669, -10.879103, -0.239414>,
      < -0.420288, -10.969921, -1.070736>
    }
    triangle {
      < -0.593296, -10.017845, -0.131055>,
      < -0.876520, -10.155484, 0.512643>,
      < -0.971880, -10.929044, 0.381113>
    }
    triangle {
      < -0.593296, -10.017845, -0.131055>,
      < -0.971880, -10.929044, 0.381113>,
      < -0.513669, -10.879103, -0.239414>
    }
    triangle {
      < -0.876520, -10.155484, 0.512643>,
      < -1.271736, -10.158121, 0.823681>,
      < -1.410989, -10.981870, 0.638458>
    }
    triangle {
      < -0.876520, -10.155484, 0.512643>,
      < -1.410989, -10.981870, 0.638458>,
      < -0.971880, -10.929044, 0.381113>
    }
    triangle {
      < -1.271736, -10.158121, 0.823681>,
      < -1.760825, -10.078956, 0.801509>,
      < -1.879315, -11.014043, 0.636238>
    }
    triangle {
      < -1.271736, -10.158121, 0.823681>,
      < -1.879315, -11.014043, 0.636238>,
      < -1.410989, -10.981870, 0.638458>
    }
    triangle {
      < -1.879315, -11.014043, 0.636238>,
      < -2.303299, -10.987743, 0.162974>,
      < -2.319475, -12.265036, 0.028441>
    }
    triangle {
      < -1.879315, -11.014043, 0.636238>,
      < -2.319475, -12.265036, 0.028441>,
      < -1.930729, -12.288463, 0.535954>
    }
    triangle {
      < -2.303299, -10.987743, 0.162974>,
      < -2.479603, -10.952571, -0.796086>,
      < -2.416574, -12.218311, -0.751097>
    }
    triangle {
      < -2.303299, -10.987743, 0.162974>,
      < -2.416574, -12.218311, -0.751097>,
      < -2.319475, -12.265036, 0.028441>
    }
    triangle {
      < -2.479603, -10.952571, -0.796086>,
      < -1.895554, -10.882447, -1.356951>,
      < -1.811200, -12.109874, -1.365803>
    }
    triangle {
      < -2.479603, -10.952571, -0.796086>,
      < -1.811200, -12.109874, -1.365803>,
      < -2.416574, -12.218311, -0.751097>
    }
    triangle {
      < -1.895554, -10.882447, -1.356951>,
      < -1.018189, -10.820683, -1.391078>,
      < -0.924678, -12.135973, -1.352007>
    }
    triangle {
      < -1.895554, -10.882447, -1.356951>,
      < -0.924678, -12.135973, -1.352007>,
      < -1.811200, -12.109874, -1.365803>
    }
    triangle {
      < -1.018189, -10.820683, -1.391078>,
      < -0.420288, -10.969921, -1.070736>,
      < -0.417049, -12.179820, -0.980798>
    }
    triangle {
      < -1.018189, -10.820683, -1.391078>,
      < -0.417049, -12.179820, -0.980798>,
      < -0.924678, -12.135973, -1.352007>
    }
    triangle {
      < -0.420288, -10.969921, -1.070736>,
      < -0.513669, -10.879103, -0.239414>,
      < -0.524598, -12.191697, -0.215008>
    }
    triangle {
      < -0.420288, -10.969921, -1.070736>,
      < -0.524598, -12.191697, -0.215008>,
      < -0.417049, -12.179820, -0.980798>
    }
    triangle {
      < -0.513669, -10.879103, -0.239414>,
      < -0.971880, -10.929044, 0.381113>,
      < -0.975866, -12.250301, 0.349836>
    }
    triangle {
      < -0.513669, -10.879103, -0.239414>,
      < -0.975866, -12.250301, 0.349836>,
      < -0.524598, -12.191697, -0.215008>
    }
    triangle {
      < -0.971880, -10.929044, 0.381113>,
      < -1.410989, -10.981870, 0.638458>,
      < -1.441757, -12.279470, 0.620154>
    }
    triangle {
      < -0.971880, -10.929044, 0.381113>,
      < -1.441757, -12.279470, 0.620154>,
      < -0.975866, -12.250301, 0.349836>
    }
    triangle {
      < -1.410989, -10.981870, 0.638458>,
      < -1.879315, -11.014043, 0.636238>,
      < -1.930729, -12.288463, 0.535954>
    }
    triangle {
      < -1.410989, -10.981870, 0.638458>,
      < -1.930729, -12.288463, 0.535954>,
      < -1.441757, -12.279470, 0.620154>
    }
    triangle {
      < -1.930729, -12.288463, 0.535954>,
      < -2.319475, -12.265036, 0.028441>,
      < -2.132106, -13.432380, -0.011457>
    }
    triangle {
      < -1.930729, -12.288463, 0.535954>,
      < -2.132106, -13.432380, -0.011457>,
      < -1.795750, -13.435624, 0.456447>
    }
    triangle {
      < -2.319475, -12.265036, 0.028441>,
      < -2.416574, -12.218311, -0.751097>,
      < -2.207716, -13.416903, -0.705194>
    }
    triangle {
      < -2.319475, -12.265036, 0.028441>,
      < -2.207716, -13.416903, -0.705194>,
      < -2.132106, -13.432380, -0.011457>
    }
    triangle {
      < -2.416574, -12.218311, -0.751097>,
      < -1.811200, -12.109874, -1.365803>,
      < -1.644140, -13.444264, -1.030593>
    }
    triangle {
      < -2.416574, -12.218311, -0.751097>,
      < -1.644140, -13.444264, -1.030593>,
      < -2.207716, -13.416903, -0.705194>
    }
    triangle {
      < -1.811200, -12.109874, -1.365803>,
      < -0.924678, -12.135973, -1.352007>,
      < -0.964788, -13.430838, -1.009000>
    }
    triangle {
      < -1.811200, -12.109874, -1.365803>,
      < -0.964788, -13.430838, -1.009000>,
      < -1.644140, -13.444264, -1.030593>
    }
    triangle {
      < -0.924678, -12.135973, -1.352007>,
      < -0.417049, -12.179820, -0.980798>,
      < -0.626622, -13.410682, -0.678529>
    }
    triangle {
      < -0.924678, -12.135973, -1.352007>,
      < -0.626622, -13.410682, -0.678529>,
      < -0.964788, -13.430838, -1.009000>
    }
    triangle {
      < -0.417049, -12.179820, -0.980798>,
      < -0.524598, -12.191697, -0.215008>,
      < -0.666406, -13.403359, -0.168696>
    }
    triangle {
      < -0.417049, -12.179820, -0.980798>,
      < -0.666406, -13.403359, -0.168696>,
      < -0.626622, -13.410682, -0.678529>
    }
    triangle {
      < -0.524598, -12.191697, -0.215008>,
      < -0.975866, -12.250301, 0.349836>,
      < -1.024282, -13.374157, 0.251626>
    }
    triangle {
      < -0.524598, -12.191697, -0.215008>,
      < -1.024282, -13.374157, 0.251626>,
      < -0.666406, -13.403359, -0.168696>
    }
    triangle {
      < -0.975866, -12.250301, 0.349836>,
      < -1.441757, -12.279470, 0.620154>,
      < -1.404174, -13.393355, 0.531376>
    }
    triangle {
      < -0.975866, -12.250301, 0.349836>,
      < -1.404174, -13.393355, 0.531376>,
      < -1.024282, -13.374157, 0.251626>
    }
    triangle {
      < -1.441757, -12.279470, 0.620154>,
      < -1.930729, -12.288463, 0.535954>,
      < -1.795750, -13.435624, 0.456447>
    }
    triangle {
      < -1.441757, -12.279470, 0.620154>,
      < -1.795750, -13.435624, 0.456447>,
      < -1.404174, -13.393355, 0.531376>
    }
    triangle {
      < -1.795750, -13.435624, 0.456447>,
      < -2.132106, -13.432380, -0.011457>,
      < -1.834913, -14.700462, -0.114861>
    }
    triangle {
      < -1.795750, -13.435624, 0.456447>,
      < -1.834913, -14.700462, -0.114861>,
      < -1.681067, -14.709235, 0.431913>
    }
    triangle {
      < -2.132106, -13.432380, -0.011457>,
      < -2.207716, -13.416903, -0.705194>,
      < -1.695713, -14.682818, -0.573428>
    }
    triangle {
      < -2.132106, -13.432380, -0.011457>,
      < -1.695713, -14.682818, -0.573428>,
      < -1.834913, -14.700462, -0.114861>
    }
    triangle {
      < -2.207716, -13.416903, -0.705194>,
      < -1.644140, -13.444264, -1.030593>,
      < -1.405404, -14.700474, -0.800741>
    }
    triangle {
      < -2.207716, -13.416903, -0.705194>,
      < -1.405404, -14.700474, -0.800741>,
      < -1.695713, -14.682818, -0.573428>
    }
    triangle {
      < -1.644140, -13.444264, -1.030593>,
      < -0.964788, -13.430838, -1.009000>,
      < -0.940527, -14.703373, -0.826540>
    }
    triangle {
      < -1.644140, -13.444264, -1.030593>,
      < -0.940527, -14.703373, -0.826540>,
      < -1.405404, -14.700474, -0.800741>
    }
    triangle {
      < -0.964788, -13.430838, -1.009000>,
      < -0.626622, -13.410682, -0.678529>,
      < -0.738949, -14.691372, -0.469249>
    }
    triangle {
      < -0.964788, -13.430838, -1.009000>,
      < -0.738949, -14.691372, -0.469249>,
      < -0.940527, -14.703373, -0.826540>
    }
    triangle {
      < -0.626622, -13.410682, -0.678529>,
      < -0.666406, -13.403359, -0.168696>,
      < -0.714355, -14.685491, -0.016596>
    }
    triangle {
      < -0.626622, -13.410682, -0.678529>,
      < -0.714355, -14.685491, -0.016596>,
      < -0.738949, -14.691372, -0.469249>
    }
    triangle {
      < -0.666406, -13.403359, -0.168696>,
      < -1.024282, -13.374157, 0.251626>,
      < -0.926533, -14.682714, 0.270446>
    }
    triangle {
      < -0.666406, -13.403359, -0.168696>,
      < -0.926533, -14.682714, 0.270446>,
      < -0.714355, -14.685491, -0.016596>
    }
    triangle {
      < -1.024282, -13.374157, 0.251626>,
      < -1.404174, -13.393355, 0.531376>,
      < -1.300814, -14.712014, 0.513934>
    }
    triangle {
      < -1.024282, -13.374157, 0.251626>,
      < -1.300814, -14.712014, 0.513934>,
      < -0.926533, -14.682714, 0.270446>
    }
    triangle {
      < -1.404174, -13.393355, 0.531376>,
      < -1.795750, -13.435624, 0.456447>,
      < -1.681067, -14.709235, 0.431913>
    }
    triangle {
      < -1.404174, -13.393355, 0.531376>,
      < -1.681067, -14.709235, 0.431913>,
      < -1.300814, -14.712014, 0.513934>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -1.092823, -2.408535, 0.645399>,
      < -0.835474, -2.586065, 0.770395>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -0.835474, -2.586065, 0.770395>,
      < -0.623694, -2.794169, 0.738749>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -0.623694, -2.794169, 0.738749>,
      < -0.333827, -3.126321, 0.484142>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -0.333827, -3.126321, 0.484142>,
      < -0.260589, -3.270522, 0.143011>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -0.260589, -3.270522, 0.143011>,
      < -0.311941, -3.320051, -0.203322>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -0.311941, -3.320051, -0.203322>,
      < -0.491020, -3.281535, -0.399705>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -0.491020, -3.281535, -0.399705>,
      < -0.830475, -3.124872, -0.561766>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -0.830475, -3.124872, -0.561766>,
      < -1.157471, -2.816209, -0.449662>
    }
    triangle {
      < -1.280752, -2.375137, 0.234031>,
      < -1.157471, -2.816209, -0.449662>,
      < -1.286888, -2.555879, -0.135298>
    }
    triangle {
      < -1.490880, -4.280551, -1.158483>,
      < -0.705662, -4.641968, -0.784613>,
      < -0.819039, -5.241535, -0.756786>
    }
    triangle {
      < -1.490880, -4.280551, -1.158483>,
      < -0.819039, -5.241535, -0.756786>,
      < -1.633359, -5.011849, -1.124489>
    }
    triangle {
      < -0.705662, -4.641968, -0.784613>,
      < -0.291355, -4.730822, -0.331563>,
      < -0.390210, -5.298005, -0.311211>
    }
    triangle {
      < -0.705662, -4.641968, -0.784613>,
      < -0.390210, -5.298005, -0.311211>,
      < -0.819039, -5.241535, -0.756786>
    }
    triangle {
      < -0.291355, -4.730822, -0.331563>,
      < -0.173907, -4.616560, 0.467417>,
      < -0.144891, -5.235314, 0.474587>
    }
    triangle {
      < -0.291355, -4.730822, -0.331563>,
      < -0.144891, -5.235314, 0.474587>,
      < -0.390210, -5.298005, -0.311211>
    }
    triangle {
      < -0.173907, -4.616560, 0.467417>,
      < -0.345180, -4.283892, 1.254397>,
      < -0.325606, -5.023898, 1.248583>
    }
    triangle {
      < -0.173907, -4.616560, 0.467417>,
      < -0.325606, -5.023898, 1.248583>,
      < -0.144891, -5.235314, 0.474587>
    }
    triangle {
      < -0.345180, -4.283892, 1.254397>,
      < -1.013912, -3.517628, 1.841768>,
      < -1.146627, -4.527002, 1.826264>
    }
    triangle {
      < -0.345180, -4.283892, 1.254397>,
      < -1.146627, -4.527002, 1.826264>,
      < -0.325606, -5.023898, 1.248583>
    }
    triangle {
      < -1.013912, -3.517628, 1.841768>,
      < -1.502483, -3.037540, 1.914772>,
      < -1.652500, -4.221898, 1.898064>
    }
    triangle {
      < -1.013912, -3.517628, 1.841768>,
      < -1.652500, -4.221898, 1.898064>,
      < -1.146627, -4.527002, 1.826264>
    }
    triangle {
      < -1.502483, -3.037540, 1.914772>,
      < -2.096180, -2.627983, 1.626412>,
      < -2.266314, -3.961618, 1.614461>
    }
    triangle {
      < -1.502483, -3.037540, 1.914772>,
      < -2.266314, -3.961618, 1.614461>,
      < -1.652500, -4.221898, 1.898064>
    }
    triangle {
      < -2.096180, -2.627983, 1.626412>,
      < -2.529726, -2.550935, 0.677398>,
      < -2.714527, -3.912652, 0.681104>
    }
    triangle {
      < -2.096180, -2.627983, 1.626412>,
      < -2.714527, -3.912652, 0.681104>,
      < -2.266314, -3.961618, 1.614461>
    }
    triangle {
      < -2.529726, -2.550935, 0.677398>,
      < -2.543879, -2.967900, -0.174635>,
      < -2.729159, -4.177640, -0.156872>
    }
    triangle {
      < -2.529726, -2.550935, 0.677398>,
      < -2.729159, -4.177640, -0.156872>,
      < -2.714527, -3.912652, 0.681104>
    }
    triangle {
      < -2.543879, -2.967900, -0.174635>,
      < -2.245321, -3.568475, -0.899862>,
      < -2.418961, -4.559316, -0.870134>
    }
    triangle {
      < -2.543879, -2.967900, -0.174635>,
      < -2.418961, -4.559316, -0.870134>,
      < -2.729159, -4.177640, -0.156872>
    }
    triangle {
      < -2.245321, -3.568475, -0.899862>,
      < -1.490880, -4.280551, -1.158483>,
      < -1.633359, -5.011849, -1.124489>
    }
    triangle {
      < -2.245321, -3.568475, -0.899862>,
      < -1.633359, -5.011849, -1.124489>,
      < -2.418961, -4.559316, -0.870134>
    }
    triangle {
      < -0.173907, -4.616560, 0.467417>,
      < -0.291355, -4.730822, -0.331563>,
      < -0.198166, -4.076481, -0.348682>
    }
    triangle {
      < -0.173907, -4.616560, 0.467417>,
      < -0.198166, -4.076481, -0.348682>,
      < -0.101138, -3.982895, 0.305712>
    }
    triangle {
      < -0.291355, -4.730822, -0.331563>,
      < -0.705662, -4.641968, -0.784613>,
      < -0.536535, -4.003706, -0.719747>
    }
    triangle {
      < -0.291355, -4.730822, -0.331563>,
      < -0.536535, -4.003706, -0.719747>,
      < -0.198166, -4.076481, -0.348682>
    }
    triangle {
      < -0.705662, -4.641968, -0.784613>,
      < -1.490880, -4.280551, -1.158483>,
      < -1.177932, -3.707692, -1.025960>
    }
    triangle {
      < -0.705662, -4.641968, -0.784613>,
      < -1.177932, -3.707692, -1.025960>,
      < -0.536535, -4.003706, -0.719747>
    }
    triangle {
      < -1.490880, -4.280551, -1.158483>,
      < -2.245321, -3.568475, -0.899862>,
      < -1.795790, -3.124475, -0.814140>
    }
    triangle {
      < -1.490880, -4.280551, -1.158483>,
      < -1.795790, -3.124475, -0.814140>,
      < -1.177932, -3.707692, -1.025960>
    }
    triangle {
      < -2.245321, -3.568475, -0.899862>,
      < -2.543879, -2.967900, -0.174635>,
      < -2.040321, -2.632582, -0.220152>
    }
    triangle {
      < -2.245321, -3.568475, -0.899862>,
      < -2.040321, -2.632582, -0.220152>,
      < -1.795790, -3.124475, -0.814140>
    }
    triangle {
      < -2.543879, -2.967900, -0.174635>,
      < -2.529726, -2.550935, 0.677398>,
      < -2.028729, -2.291073, 0.477694>
    }
    triangle {
      < -2.543879, -2.967900, -0.174635>,
      < -2.028729, -2.291073, 0.477694>,
      < -2.040321, -2.632582, -0.220152>
    }
    triangle {
      < -2.529726, -2.550935, 0.677398>,
      < -2.096180, -2.627983, 1.626412>,
      < -1.673639, -2.354178, 1.254971>
    }
    triangle {
      < -2.529726, -2.550935, 0.677398>,
      < -1.673639, -2.354178, 1.254971>,
      < -2.028729, -2.291073, 0.477694>
    }
    triangle {
      < -2.096180, -2.627983, 1.626412>,
      < -1.502483, -3.037540, 1.914772>,
      < -1.187379, -2.689620, 1.491149>
    }
    triangle {
      < -2.096180, -2.627983, 1.626412>,
      < -1.187379, -2.689620, 1.491149>,
      < -1.673639, -2.354178, 1.254971>
    }
    triangle {
      < -1.502483, -3.037540, 1.914772>,
      < -1.013912, -3.517628, 1.841768>,
      < -0.787222, -3.082830, 1.431356>
    }
    triangle {
      < -1.502483, -3.037540, 1.914772>,
      < -0.787222, -3.082830, 1.431356>,
      < -1.187379, -2.689620, 1.491149>
    }
    triangle {
      < -1.013912, -3.517628, 1.841768>,
      < -0.345180, -4.283892, 1.254397>,
      < -0.239519, -3.710428, 0.950277>
    }
    triangle {
      < -1.013912, -3.517628, 1.841768>,
      < -0.239519, -3.710428, 0.950277>,
      < -0.787222, -3.082830, 1.431356>
    }
    triangle {
      < -0.345180, -4.283892, 1.254397>,
      < -0.173907, -4.616560, 0.467417>,
      < -0.101138, -3.982895, 0.305712>
    }
    triangle {
      < -0.345180, -4.283892, 1.254397>,
      < -0.101138, -3.982895, 0.305712>,
      < -0.239519, -3.710428, 0.950277>
    }
    triangle {
      < -1.187379, -2.689620, 1.491149>,
      < -0.787222, -3.082830, 1.431356>,
      < -0.623694, -2.794169, 0.738749>
    }
    triangle {
      < -1.187379, -2.689620, 1.491149>,
      < -0.623694, -2.794169, 0.738749>,
      < -0.835474, -2.586065, 0.770395>
    }
    triangle {
      < -0.787222, -3.082830, 1.431356>,
      < -0.239519, -3.710428, 0.950277>,
      < -0.333827, -3.126321, 0.484142>
    }
    triangle {
      < -0.787222, -3.082830, 1.431356>,
      < -0.333827, -3.126321, 0.484142>,
      < -0.623694, -2.794169, 0.738749>
    }
    triangle {
      < -0.239519, -3.710428, 0.950277>,
      < -0.101138, -3.982895, 0.305712>,
      < -0.260589, -3.270522, 0.143011>
    }
    triangle {
      < -0.239519, -3.710428, 0.950277>,
      < -0.260589, -3.270522, 0.143011>,
      < -0.333827, -3.126321, 0.484142>
    }
    triangle {
      < -0.101138, -3.982895, 0.305712>,
      < -0.198166, -4.076481, -0.348682>,
      < -0.311941, -3.320051, -0.203322>
    }
    triangle {
      < -0.101138, -3.982895, 0.305712>,
      < -0.311941, -3.320051, -0.203322>,
      < -0.260589, -3.270522, 0.143011>
    }
    triangle {
      < -0.198166, -4.076481, -0.348682>,
      < -0.536535, -4.003706, -0.719747>,
      < -0.491020, -3.281535, -0.399705>
    }
    triangle {
      < -0.198166, -4.076481, -0.348682>,
      < -0.491020, -3.281535, -0.399705>,
      < -0.311941, -3.320051, -0.203322>
    }
    triangle {
      < -0.536535, -4.003706, -0.719747>,
      < -1.177932, -3.707692, -1.025960>,
      < -0.830475, -3.124872, -0.561766>
    }
    triangle {
      < -0.536535, -4.003706, -0.719747>,
      < -0.830475, -3.124872, -0.561766>,
      < -0.491020, -3.281535, -0.399705>
    }
    triangle {
      < -1.177932, -3.707692, -1.025960>,
      < -1.795790, -3.124475, -0.814140>,
      < -1.157471, -2.816209, -0.449662>
    }
    triangle {
      < -1.177932, -3.707692, -1.025960>,
      < -1.157471, -2.816209, -0.449662>,
      < -0.830475, -3.124872, -0.561766>
    }
    triangle {
      < -1.795790, -3.124475, -0.814140>,
      < -2.040321, -2.632582, -0.220152>,
      < -1.286888, -2.555879, -0.135298>
    }
    triangle {
      < -1.795790, -3.124475, -0.814140>,
      < -1.286888, -2.555879, -0.135298>,
      < -1.157471, -2.816209, -0.449662>
    }
    triangle {
      < -2.040321, -2.632582, -0.220152>,
      < -2.028729, -2.291073, 0.477694>,
      < -1.280752, -2.375137, 0.234031>
    }
    triangle {
      < -2.040321, -2.632582, -0.220152>,
      < -1.280752, -2.375137, 0.234031>,
      < -1.286888, -2.555879, -0.135298>
    }
    triangle {
      < -2.028729, -2.291073, 0.477694>,
      < -1.673639, -2.354178, 1.254971>,
      < -1.092823, -2.408535, 0.645399>
    }
    triangle {
      < -2.028729, -2.291073, 0.477694>,
      < -1.092823, -2.408535, 0.645399>,
      < -1.280752, -2.375137, 0.234031>
    }
    triangle {
      < -1.673639, -2.354178, 1.254971>,
      < -1.187379, -2.689620, 1.491149>,
      < -0.835474, -2.586065, 0.770395>
    }
    triangle {
      < -1.673639, -2.354178, 1.254971>,
      < -0.835474, -2.586065, 0.770395>,
      < -1.092823, -2.408535, 0.645399>
    }
    triangle {
      < -2.714527, -3.912652, 0.681104>,
      < -2.729159, -4.177640, -0.156872>,
      < -2.754859, -5.943292, -0.172624>
    }
    triangle {
      < -2.714527, -3.912652, 0.681104>,
      < -2.754859, -5.943292, -0.172624>,
      < -2.739188, -5.936777, 0.614674>
    }
    triangle {
      < -2.729159, -4.177640, -0.156872>,
      < -2.418961, -4.559316, -0.870134>,
      < -2.407583, -5.928294, -0.821781>
    }
    triangle {
      < -2.729159, -4.177640, -0.156872>,
      < -2.407583, -5.928294, -0.821781>,
      < -2.754859, -5.943292, -0.172624>
    }
    triangle {
      < -2.418961, -4.559316, -0.870134>,
      < -1.633359, -5.011849, -1.124489>,
      < -1.573807, -5.939421, -1.060754>
    }
    triangle {
      < -2.418961, -4.559316, -0.870134>,
      < -1.573807, -5.939421, -1.060754>,
      < -2.407583, -5.928294, -0.821781>
    }
    triangle {
      < -1.633359, -5.011849, -1.124489>,
      < -0.819039, -5.241535, -0.756786>,
      < -0.723337, -5.969450, -0.736258>
    }
    triangle {
      < -1.633359, -5.011849, -1.124489>,
      < -0.723337, -5.969450, -0.736258>,
      < -1.573807, -5.939421, -1.060754>
    }
    triangle {
      < -0.819039, -5.241535, -0.756786>,
      < -0.390210, -5.298005, -0.311211>,
      < -0.266087, -5.970837, -0.317630>
    }
    triangle {
      < -0.819039, -5.241535, -0.756786>,
      < -0.266087, -5.970837, -0.317630>,
      < -0.723337, -5.969450, -0.736258>
    }
    triangle {
      < -0.390210, -5.298005, -0.311211>,
      < -0.144891, -5.235314, 0.474587>,
      < -0.134620, -5.969052, 0.420646>
    }
    triangle {
      < -0.390210, -5.298005, -0.311211>,
      < -0.134620, -5.969052, 0.420646>,
      < -0.266087, -5.970837, -0.317630>
    }
    triangle {
      < -0.144891, -5.235314, 0.474587>,
      < -0.325606, -5.023898, 1.248583>,
      < -0.325007, -5.963856, 1.147833>
    }
    triangle {
      < -0.144891, -5.235314, 0.474587>,
      < -0.325007, -5.963856, 1.147833>,
      < -0.134620, -5.969052, 0.420646>
    }
    triangle {
      < -0.325606, -5.023898, 1.248583>,
      < -1.146627, -4.527002, 1.826264>,
      < -1.064737, -5.951882, 1.690577>
    }
    triangle {
      < -0.325606, -5.023898, 1.248583>,
      < -1.064737, -5.951882, 1.690577>,
      < -0.325007, -5.963856, 1.147833>
    }
    triangle {
      < -1.146627, -4.527002, 1.826264>,
      < -1.652500, -4.221898, 1.898064>,
      < -1.601838, -5.944381, 1.758035>
    }
    triangle {
      < -1.146627, -4.527002, 1.826264>,
      < -1.601838, -5.944381, 1.758035>,
      < -1.064737, -5.951882, 1.690577>
    }
    triangle {
      < -1.652500, -4.221898, 1.898064>,
      < -2.266314, -3.961618, 1.614461>,
      < -2.256385, -5.937982, 1.491583>
    }
    triangle {
      < -1.652500, -4.221898, 1.898064>,
      < -2.256385, -5.937982, 1.491583>,
      < -1.601838, -5.944381, 1.758035>
    }
    triangle {
      < -2.266314, -3.961618, 1.614461>,
      < -2.714527, -3.912652, 0.681104>,
      < -2.739188, -5.936777, 0.614674>
    }
    triangle {
      < -2.266314, -3.961618, 1.614461>,
      < -2.739188, -5.936777, 0.614674>,
      < -2.256385, -5.937982, 1.491583>
    }
    triangle {
      < -1.064737, -5.951882, 1.690577>,
      < -1.601838, -5.944381, 1.758035>,
      < -1.572043, -7.025036, 1.519979>
    }
    triangle {
      < -1.064737, -5.951882, 1.690577>,
      < -1.572043, -7.025036, 1.519979>,
      < -1.090635, -7.031658, 1.460434>
    }
    triangle {
      < -1.601838, -5.944381, 1.758035>,
      < -2.256385, -5.937982, 1.491583>,
      < -2.160972, -7.019388, 1.284782>
    }
    triangle {
      < -1.601838, -5.944381, 1.758035>,
      < -2.160972, -7.019388, 1.284782>,
      < -1.572043, -7.025036, 1.519979>
    }
    triangle {
      < -2.256385, -5.937982, 1.491583>,
      < -2.739188, -5.936777, 0.614674>,
      < -2.599437, -7.018324, 0.510732>
    }
    triangle {
      < -2.256385, -5.937982, 1.491583>,
      < -2.599437, -7.018324, 0.510732>,
      < -2.160972, -7.019388, 1.284782>
    }
    triangle {
      < -2.739188, -5.936777, 0.614674>,
      < -2.754859, -5.943292, -0.172624>,
      < -2.613849, -7.024075, -0.184219>
    }
    triangle {
      < -2.739188, -5.936777, 0.614674>,
      < -2.613849, -7.024075, -0.184219>,
      < -2.599437, -7.018324, 0.510732>
    }
    triangle {
      < -2.754859, -5.943292, -0.172624>,
      < -2.407583, -5.928294, -0.821781>,
      < -2.313214, -7.032358, -0.775741>
    }
    triangle {
      < -2.754859, -5.943292, -0.172624>,
      < -2.313214, -7.032358, -0.775741>,
      < -2.613849, -7.024075, -0.184219>
    }
    triangle {
      < -2.407583, -5.928294, -0.821781>,
      < -1.573807, -5.939421, -1.060754>,
      < -1.561767, -7.042181, -0.986682>
    }
    triangle {
      < -2.407583, -5.928294, -0.821781>,
      < -1.561767, -7.042181, -0.986682>,
      < -2.313214, -7.032358, -0.775741>
    }
    triangle {
      < -1.573807, -5.939421, -1.060754>,
      < -0.723337, -5.969450, -0.736258>,
      < -0.781060, -7.047165, -0.681739>
    }
    triangle {
      < -1.573807, -5.939421, -1.060754>,
      < -0.781060, -7.047165, -0.681739>,
      < -1.561767, -7.042181, -0.986682>
    }
    triangle {
      < -0.723337, -5.969450, -0.736258>,
      < -0.266087, -5.970837, -0.317630>,
      < -0.368183, -7.048390, -0.312215>
    }
    triangle {
      < -0.723337, -5.969450, -0.736258>,
      < -0.368183, -7.048390, -0.312215>,
      < -0.781060, -7.047165, -0.681739>
    }
    triangle {
      < -0.266087, -5.970837, -0.317630>,
      < -0.134620, -5.969052, 0.420646>,
      < -0.249018, -7.046814, 0.339463>
    }
    triangle {
      < -0.266087, -5.970837, -0.317630>,
      < -0.249018, -7.046814, 0.339463>,
      < -0.368183, -7.048390, -0.312215>
    }
    triangle {
      < -0.134620, -5.969052, 0.420646>,
      < -0.325007, -5.963856, 1.147833>,
      < -0.423105, -7.042226, 0.981353>
    }
    triangle {
      < -0.134620, -5.969052, 0.420646>,
      < -0.423105, -7.042226, 0.981353>,
      < -0.249018, -7.046814, 0.339463>
    }
    triangle {
      < -0.325007, -5.963856, 1.147833>,
      < -1.064737, -5.951882, 1.690577>,
      < -1.090635, -7.031658, 1.460434>
    }
    triangle {
      < -0.325007, -5.963856, 1.147833>,
      < -1.090635, -7.031658, 1.460434>,
      < -0.423105, -7.042226, 0.981353>
    }
    triangle {
      < -1.336529, -7.864736, 1.430424>,
      < -1.572043, -7.025036, 1.519979>,
      < -2.160972, -7.019388, 1.284782>
    }
    triangle {
      < -1.336529, -7.864736, 1.430424>,
      < -2.160972, -7.019388, 1.284782>,
      < -1.975347, -7.812831, 1.241284>
    }
    triangle {
      < -2.599437, -7.018324, 0.510732>,
      < -2.443700, -7.794046, 0.570322>,
      < -1.975347, -7.812831, 1.241284>
    }
    triangle {
      < -2.599437, -7.018324, 0.510732>,
      < -1.975347, -7.812831, 1.241284>,
      < -2.160972, -7.019388, 1.284782>
    }
    triangle {
      < -1.252770, -8.003237, -0.934381>,
      < -2.044399, -7.905108, -0.789951>,
      < -2.313214, -7.032358, -0.775741>
    }
    triangle {
      < -1.252770, -8.003237, -0.934381>,
      < -2.313214, -7.032358, -0.775741>,
      < -1.561767, -7.042181, -0.986682>
    }
    triangle {
      < -0.700721, -8.056448, -0.504861>,
      < -1.252770, -8.003237, -0.934381>,
      < -1.561767, -7.042181, -0.986682>
    }
    triangle {
      < -0.700721, -8.056448, -0.504861>,
      < -1.561767, -7.042181, -0.986682>,
      < -0.781060, -7.047165, -0.681739>
    }
    triangle {
      < -0.249018, -7.046814, 0.339463>,
      < -0.370201, -8.109273, 0.418486>,
      < -0.700721, -8.056448, -0.504861>
    }
    triangle {
      < -0.249018, -7.046814, 0.339463>,
      < -0.700721, -8.056448, -0.504861>,
      < -0.368183, -7.048390, -0.312215>
    }
    triangle {
      < -2.313214, -7.032358, -0.775741>,
      < -2.044399, -7.905108, -0.789951>,
      < -2.479350, -7.832503, -0.152257>
    }
    triangle {
      < -2.313214, -7.032358, -0.775741>,
      < -2.479350, -7.832503, -0.152257>,
      < -2.613849, -7.024075, -0.184219>
    }
    triangle {
      < -2.443700, -7.794046, 0.570322>,
      < -2.599437, -7.018324, 0.510732>,
      < -2.613849, -7.024075, -0.184219>
    }
    triangle {
      < -2.443700, -7.794046, 0.570322>,
      < -2.613849, -7.024075, -0.184219>,
      < -2.479350, -7.832503, -0.152257>
    }
    triangle {
      < -0.608883, -8.006459, 1.159099>,
      < -0.423105, -7.042226, 0.981353>,
      < -1.090635, -7.031658, 1.460434>
    }
    triangle {
      < -0.608883, -8.006459, 1.159099>,
      < -0.668801, -8.649164, 0.894079>,
      < -0.513613, -8.778045, 0.117577>
    }
    triangle {
      < -0.608883, -8.006459, 1.159099>,
      < -0.513613, -8.778045, 0.117577>,
      < -0.370201, -8.109273, 0.418486>
    }
    triangle {
      < -0.608883, -8.006459, 1.159099>,
      < -1.336529, -7.864736, 1.430424>,
      < -1.222692, -8.558242, 1.154920>
    }
    triangle {
      < -0.608883, -8.006459, 1.159099>,
      < -1.222692, -8.558242, 1.154920>,
      < -0.668801, -8.649164, 0.894079>
    }
    triangle {
      < -0.608883, -8.006459, 1.159099>,
      < -1.090635, -7.031658, 1.460434>,
      < -1.572043, -7.025036, 1.519979>
    }
    triangle {
      < -0.608883, -8.006459, 1.159099>,
      < -1.572043, -7.025036, 1.519979>,
      < -1.336529, -7.864736, 1.430424>
    }
    triangle {
      < -1.867600, -16.218853, 0.441845>,
      < -1.931898, -16.313671, 0.040689>,
      < -1.952909, -16.542427, 0.216444>
    }
    triangle {
      < -1.867600, -16.218853, 0.441845>,
      < -1.952909, -16.542427, 0.216444>,
      < -1.907846, -16.537790, 0.856772>
    }
    triangle {
      < -1.772568, -16.093166, 0.679117>,
      < -1.867600, -16.218853, 0.441845>,
      < -1.907846, -16.537790, 0.856772>
    }
    triangle {
      < -1.772568, -16.093166, 0.679117>,
      < -1.907846, -16.537790, 0.856772>,
      < -1.793585, -16.272459, 1.038232>
    }
    triangle {
      < -1.681067, -14.709235, 0.431913>,
      < -1.501738, -15.344625, 0.448596>,
      < -1.305812, -15.344311, 0.504918>
    }
    triangle {
      < -1.681067, -14.709235, 0.431913>,
      < -1.305812, -15.344311, 0.504918>,
      < -1.300814, -14.712014, 0.513934>
    }
    triangle {
      < -0.926533, -14.682714, 0.270446>,
      < -0.889343, -15.344277, 0.470349>,
      < -0.664697, -15.344782, 0.311132>
    }
    triangle {
      < -1.695713, -14.682818, -0.573428>,
      < -1.621508, -15.344833, -0.686742>,
      < -1.766149, -15.344839, -0.538318>
    }
    triangle {
      < -0.423105, -7.042226, 0.981353>,
      < -0.608883, -8.006459, 1.159099>,
      < -0.370201, -8.109273, 0.418486>
    }
    triangle {
      < -0.423105, -7.042226, 0.981353>,
      < -0.370201, -8.109273, 0.418486>,
      < -0.249018, -7.046814, 0.339463>
    }
    triangle {
      < -0.700721, -8.056448, -0.504861>,
      < -0.781060, -7.047165, -0.681739>,
      < -0.368183, -7.048390, -0.312215>
    }
    texture {legr}
  }
  // legl
  union {
    triangle {
      < 0.926533, -14.682714, 0.270446>,
      < 0.889343, -15.344277, 0.470349>,
      < 1.305812, -15.344311, 0.504918>
    }
    triangle {
      < 0.926533, -14.682714, 0.270446>,
      < 1.305812, -15.344311, 0.504918>,
      < 1.300814, -14.712014, 0.513934>
    }
    triangle {
      < 1.834913, -14.700462, -0.114861>,
      < 1.681067, -14.709235, 0.431913>,
      < 1.701655, -15.344854, 0.246782>
    }
    triangle {
      < 1.834913, -14.700462, -0.114861>,
      < 1.701655, -15.344854, 0.246782>,
      < 1.800015, -15.344841, -0.049262>
    }
    triangle {
      < 1.695713, -14.682818, -0.573428>,
      < 1.834913, -14.700462, -0.114861>,
      < 1.800015, -15.344841, -0.049262>
    }
    triangle {
      < 1.695713, -14.682818, -0.573428>,
      < 1.800015, -15.344841, -0.049262>,
      < 1.766149, -15.344839, -0.538318>
    }
    triangle {
      < 1.405404, -14.700474, -0.800741>,
      < 1.695713, -14.682818, -0.573428>,
      < 1.621508, -15.344833, -0.686742>
    }
    triangle {
      < 1.405404, -14.700474, -0.800741>,
      < 1.621508, -15.344833, -0.686742>,
      < 1.411221, -15.344837, -0.728461>
    }
    triangle {
      < 0.940527, -14.703373, -0.826540>,
      < 1.405404, -14.700474, -0.800741>,
      < 1.411221, -15.344837, -0.728461>
    }
    triangle {
      < 0.940527, -14.703373, -0.826540>,
      < 1.411221, -15.344837, -0.728461>,
      < 1.115799, -15.344839, -0.663476>
    }
    triangle {
      < 0.738949, -14.691372, -0.469249>,
      < 0.940527, -14.703373, -0.826540>,
      < 1.115799, -15.344839, -0.663476>
    }
    triangle {
      < 0.738949, -14.691372, -0.469249>,
      < 1.115799, -15.344839, -0.663476>,
      < 0.918349, -15.344844, -0.308478>
    }
    triangle {
      < 0.714355, -14.685491, -0.016596>,
      < 0.738949, -14.691372, -0.469249>,
      < 0.918349, -15.344844, -0.308478>
    }
    triangle {
      < 0.714355, -14.685491, -0.016596>,
      < 0.918349, -15.344844, -0.308478>,
      < 0.768594, -15.344837, 0.001376>
    }
    triangle {
      < 0.926533, -14.682714, 0.270446>,
      < 0.714355, -14.685491, -0.016596>,
      < 0.768594, -15.344837, 0.001376>
    }
    triangle {
      < 0.926533, -14.682714, 0.270446>,
      < 0.768594, -15.344837, 0.001376>,
      < 0.664697, -15.344782, 0.311132>
    }
    triangle {
      < 1.701655, -15.344854, 0.246782>,
      < 1.681067, -14.709235, 0.431913>,
      < 1.501738, -15.344625, 0.448596>
    }
    triangle {
      < 0.279272, -16.944326, 2.725533>,
      < 0.217487, -16.956699, 2.005404>,
      < 0.276788, -17.107136, 2.189710>
    }
    triangle {
      < 0.279272, -16.944326, 2.725533>,
      < 0.276788, -17.107136, 2.189710>,
      < 0.331154, -17.092710, 2.664728>
    }
    triangle {
      < 0.331154, -17.092710, 2.664728>,
      < 0.743558, -17.083874, 2.762392>,
      < 0.681794, -16.892210, 2.815598>
    }
    triangle {
      < 0.331154, -17.092710, 2.664728>,
      < 0.681794, -16.892210, 2.815598>,
      < 0.279272, -16.944326, 2.725533>
    }
    triangle {
      < 0.266916, -16.818619, 2.731232>,
      < 0.654614, -16.782988, 2.825098>,
      < 0.728951, -16.653225, 2.259426>
    }
    triangle {
      < 0.266916, -16.818619, 2.731232>,
      < 0.728951, -16.653225, 2.259426>,
      < 0.290367, -16.716606, 2.243387>
    }
    triangle {
      < 0.232294, -16.750608, 1.724192>,
      < 0.349626, -16.575434, 1.478129>,
      < 0.428679, -16.739271, 1.287170>
    }
    triangle {
      < 0.290367, -16.716606, 2.243387>,
      < 0.728951, -16.653225, 2.259426>,
      < 0.768374, -16.405407, 1.778333>
    }
    triangle {
      < 0.290367, -16.716606, 2.243387>,
      < 0.768374, -16.405407, 1.778333>,
      < 0.407685, -16.430656, 1.712788>
    }
    triangle {
      < 1.416780, -16.527496, -0.942118>,
      < 1.393320, -16.833019, -0.947343>,
      < 1.019051, -16.840240, -0.816229>
    }
    triangle {
      < 1.416780, -16.527496, -0.942118>,
      < 1.019051, -16.840240, -0.816229>,
      < 1.072773, -16.533684, -0.828105>
    }
    triangle {
      < 0.595395, -16.045792, 0.751345>,
      < 0.546007, -16.330189, 1.133261>,
      < 0.746115, -16.151922, 1.298564>
    }
    triangle {
      < 0.595395, -16.045792, 0.751345>,
      < 0.746115, -16.151922, 1.298564>,
      < 0.879499, -15.898948, 0.918308>
    }
    triangle {
      < 0.812176, -16.548635, 0.208392>,
      < 0.717694, -16.558420, 0.562759>,
      < 0.689875, -16.277122, 0.111016>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 1.882541, -17.050430, 0.924226>,
      < 1.930710, -16.857740, 0.931825>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 1.930710, -16.857740, 0.931825>,
      < 1.971499, -16.848463, 1.710856>
    }
    triangle {
      < 1.054880, -17.013353, -0.753056>,
      < 1.019051, -16.840240, -0.816229>,
      < 1.393320, -16.833019, -0.947343>
    }
    triangle {
      < 1.054880, -17.013353, -0.753056>,
      < 1.393320, -16.833019, -0.947343>,
      < 1.383448, -17.023645, -0.864695>
    }
    triangle {
      < 1.938057, -16.522331, -0.646666>,
      < 1.947950, -16.840218, -0.602489>,
      < 1.823185, -16.843313, -0.839047>
    }
    triangle {
      < 1.938057, -16.522331, -0.646666>,
      < 1.823185, -16.843313, -0.839047>,
      < 1.812056, -16.522848, -0.859946>
    }
    triangle {
      < 0.916546, -16.842817, -0.215803>,
      < 1.019051, -16.840240, -0.816229>,
      < 1.054880, -17.013353, -0.753056>
    }
    triangle {
      < 0.916546, -16.842817, -0.215803>,
      < 1.054880, -17.013353, -0.753056>,
      < 1.006726, -17.017984, -0.182553>
    }
    triangle {
      < 1.151274, -17.021595, 0.563225>,
      < 0.936331, -16.827877, 0.405523>,
      < 0.916546, -16.842817, -0.215803>
    }
    triangle {
      < 1.151274, -17.021595, 0.563225>,
      < 0.916546, -16.842817, -0.215803>,
      < 1.006726, -17.017984, -0.182553>
    }
    triangle {
      < 0.779473, -16.876310, 0.842545>,
      < 0.936331, -16.827877, 0.405523>,
      < 1.151274, -17.021595, 0.563225>
    }
    triangle {
      < 0.779473, -16.876310, 0.842545>,
      < 1.151274, -17.021595, 0.563225>,
      < 0.906715, -17.045294, 1.084803>
    }
    triangle {
      < 0.311356, -17.072100, 1.659588>,
      < 0.315054, -16.966997, 1.524682>,
      < 0.779473, -16.876310, 0.842545>
    }
    triangle {
      < 0.311356, -17.072100, 1.659588>,
      < 0.779473, -16.876310, 0.842545>,
      < 0.906715, -17.045294, 1.084803>
    }
    triangle {
      < 0.276788, -17.107136, 2.189710>,
      < 0.217487, -16.956699, 2.005404>,
      < 0.315054, -16.966997, 1.524682>
    }
    triangle {
      < 0.276788, -17.107136, 2.189710>,
      < 0.315054, -16.966997, 1.524682>,
      < 0.311356, -17.072100, 1.659588>
    }
    triangle {
      < 0.232294, -16.750608, 1.724192>,
      < 0.290367, -16.716606, 2.243387>,
      < 0.407685, -16.430656, 1.712788>
    }
    triangle {
      < 0.232294, -16.750608, 1.724192>,
      < 0.407685, -16.430656, 1.712788>,
      < 0.349626, -16.575434, 1.478129>
    }
    triangle {
      < 1.936865, -16.847431, 0.308599>,
      < 1.947950, -16.840218, -0.602489>,
      < 1.938057, -16.522331, -0.646666>
    }
    triangle {
      < 1.936865, -16.847431, 0.308599>,
      < 1.938057, -16.522331, -0.646666>,
      < 1.952909, -16.542427, 0.216444>
    }
    triangle {
      < 1.891111, -16.286882, -0.638589>,
      < 1.931898, -16.313671, 0.040689>,
      < 1.952909, -16.542427, 0.216444>
    }
    triangle {
      < 1.891111, -16.286882, -0.638589>,
      < 1.952909, -16.542427, 0.216444>,
      < 1.938057, -16.522331, -0.646666>
    }
    triangle {
      < 0.349626, -16.575434, 1.478129>,
      < 0.407685, -16.430656, 1.712788>,
      < 0.746115, -16.151922, 1.298564>
    }
    triangle {
      < 0.349626, -16.575434, 1.478129>,
      < 0.746115, -16.151922, 1.298564>,
      < 0.546007, -16.330189, 1.133261>
    }
    triangle {
      < 0.428679, -16.739271, 1.287170>,
      < 0.349626, -16.575434, 1.478129>,
      < 0.546007, -16.330189, 1.133261>
    }
    triangle {
      < 0.428679, -16.739271, 1.287170>,
      < 0.546007, -16.330189, 1.133261>,
      < 0.573176, -16.427046, 0.836848>
    }
    triangle {
      < 0.428679, -16.739271, 1.287170>,
      < 0.573176, -16.427046, 0.836848>,
      < 0.717694, -16.558420, 0.562759>
    }
    triangle {
      < 0.689875, -16.277122, 0.111016>,
      < 0.870206, -16.331730, -0.319355>,
      < 0.873921, -16.551208, -0.277316>
    }
    triangle {
      < 0.689875, -16.277122, 0.111016>,
      < 0.873921, -16.551208, -0.277316>,
      < 0.812176, -16.548635, 0.208392>
    }
    triangle {
      < 0.870206, -16.331730, -0.319355>,
      < 1.107970, -16.294109, -0.812431>,
      < 1.072773, -16.533684, -0.828105>
    }
    triangle {
      < 0.870206, -16.331730, -0.319355>,
      < 1.072773, -16.533684, -0.828105>,
      < 0.873921, -16.551208, -0.277316>
    }
    triangle {
      < 0.595395, -16.045792, 0.751345>,
      < 0.879499, -15.898948, 0.918308>,
      < 0.843662, -15.580988, 0.594391>
    }
    triangle {
      < 0.575628, -16.146772, 0.559437>,
      < 0.595395, -16.045792, 0.751345>,
      < 0.843662, -15.580988, 0.594391>
    }
    triangle {
      < 0.575628, -16.146772, 0.559437>,
      < 0.843662, -15.580988, 0.594391>,
      < 0.573147, -15.763307, 0.422360>
    }
    triangle {
      < 0.575628, -16.146772, 0.559437>,
      < 0.573147, -15.763307, 0.422360>,
      < 0.689875, -16.277122, 0.111016>
    }
    triangle {
      < 1.757828, -17.043219, 2.237183>,
      < 1.935684, -17.038061, 1.704207>,
      < 1.971499, -16.848463, 1.710856>
    }
    triangle {
      < 1.757828, -17.043219, 2.237183>,
      < 1.971499, -16.848463, 1.710856>,
      < 1.776353, -16.870106, 2.277083>
    }
    triangle {
      < 1.388503, -16.894844, 2.630507>,
      < 1.371213, -17.053534, 2.586804>,
      < 1.757828, -17.043219, 2.237183>
    }
    triangle {
      < 1.388503, -16.894844, 2.630507>,
      < 1.757828, -17.043219, 2.237183>,
      < 1.776353, -16.870106, 2.277083>
    }
    triangle {
      < 1.043674, -17.060688, 2.717835>,
      < 1.371213, -17.053534, 2.586804>,
      < 1.388503, -16.894844, 2.630507>
    }
    triangle {
      < 1.043674, -17.060688, 2.717835>,
      < 1.388503, -16.894844, 2.630507>,
      < 1.070847, -16.891695, 2.791938>
    }
    triangle {
      < 0.743558, -17.083874, 2.762392>,
      < 1.043674, -17.060688, 2.717835>,
      < 1.070847, -16.891695, 2.791938>
    }
    triangle {
      < 0.743558, -17.083874, 2.762392>,
      < 1.070847, -16.891695, 2.791938>,
      < 0.681794, -16.892210, 2.815598>
    }
    triangle {
      < 1.915842, -17.029818, -0.563066>,
      < 1.791076, -17.016422, -0.767800>,
      < 1.823185, -16.843313, -0.839047>
    }
    triangle {
      < 1.915842, -17.029818, -0.563066>,
      < 1.823185, -16.843313, -0.839047>,
      < 1.947950, -16.840218, -0.602489>
    }
    triangle {
      < 1.936865, -16.847431, 0.308599>,
      < 1.897343, -17.039093, 0.289599>,
      < 1.915842, -17.029818, -0.563066>
    }
    triangle {
      < 1.936865, -16.847431, 0.308599>,
      < 1.915842, -17.029818, -0.563066>,
      < 1.947950, -16.840218, -0.602489>
    }
    triangle {
      < 1.915842, -17.029818, -0.563066>,
      < 1.897343, -17.039093, 0.289599>,
      < 1.151274, -17.021595, 0.563225>
    }
    triangle {
      < 1.915842, -17.029818, -0.563066>,
      < 1.151274, -17.021595, 0.563225>,
      < 1.006726, -17.017984, -0.182553>
    }
    triangle {
      < 1.882541, -17.050430, 0.924226>,
      < 1.897343, -17.039093, 0.289599>,
      < 1.936865, -16.847431, 0.308599>
    }
    triangle {
      < 1.882541, -17.050430, 0.924226>,
      < 1.936865, -16.847431, 0.308599>,
      < 1.930710, -16.857740, 0.931825>
    }
    triangle {
      < 1.867600, -16.218853, 0.441845>,
      < 1.931898, -16.313671, 0.040689>,
      < 1.940277, -15.920394, -0.031324>
    }
    triangle {
      < 1.867600, -16.218853, 0.441845>,
      < 1.940277, -15.920394, -0.031324>,
      < 1.856797, -15.897838, 0.323091>
    }
    triangle {
      < 1.856797, -15.897838, 0.323091>,
      < 1.581096, -15.803278, 0.539515>,
      < 1.613225, -16.002491, 0.815926>
    }
    triangle {
      < 1.856797, -15.897838, 0.323091>,
      < 1.613225, -16.002491, 0.815926>,
      < 1.772568, -16.093166, 0.679117>
    }
    triangle {
      < 1.856797, -15.897838, 0.323091>,
      < 1.772568, -16.093166, 0.679117>,
      < 1.867600, -16.218853, 0.441845>
    }
    triangle {
      < 1.615712, -16.181786, 1.188342>,
      < 1.793585, -16.272459, 1.038232>,
      < 1.772568, -16.093166, 0.679117>
    }
    triangle {
      < 1.615712, -16.181786, 1.188342>,
      < 1.772568, -16.093166, 0.679117>,
      < 1.613225, -16.002491, 0.815926>
    }
    triangle {
      < 1.376081, -16.120996, 1.285251>,
      < 1.615712, -16.181786, 1.188342>,
      < 1.613225, -16.002491, 0.815926>
    }
    triangle {
      < 1.376081, -16.120996, 1.285251>,
      < 1.613225, -16.002491, 0.815926>,
      < 1.360004, -15.908727, 0.911886>
    }
    triangle {
      < 1.017865, -16.109667, 1.315659>,
      < 1.376081, -16.120996, 1.285251>,
      < 1.360004, -15.908727, 0.911886>
    }
    triangle {
      < 1.017865, -16.109667, 1.315659>,
      < 1.360004, -15.908727, 0.911886>,
      < 0.879499, -15.898948, 0.918308>
    }
    triangle {
      < 0.746115, -16.151922, 1.298564>,
      < 1.017865, -16.109667, 1.315659>,
      < 0.879499, -15.898948, 0.918308>
    }
    triangle {
      < 1.914657, -16.662985, 1.258638>,
      < 1.930710, -16.857740, 0.931825>,
      < 1.907846, -16.537790, 0.856772>
    }
    triangle {
      < 1.907846, -16.537790, 0.856772>,
      < 1.793585, -16.272459, 1.038232>,
      < 1.777546, -16.521307, 1.368371>
    }
    triangle {
      < 1.615712, -16.181786, 1.188342>,
      < 1.587325, -16.467213, 1.565508>,
      < 1.777546, -16.521307, 1.368371>
    }
    triangle {
      < 1.615712, -16.181786, 1.188342>,
      < 1.777546, -16.521307, 1.368371>,
      < 1.793585, -16.272459, 1.038232>
    }
    triangle {
      < 1.587325, -16.467213, 1.565508>,
      < 1.615712, -16.181786, 1.188342>,
      < 1.376081, -16.120996, 1.285251>
    }
    triangle {
      < 1.587325, -16.467213, 1.565508>,
      < 1.376081, -16.120996, 1.285251>,
      < 1.378573, -16.430637, 1.676192>
    }
    triangle {
      < 1.017865, -16.109667, 1.315659>,
      < 1.035183, -16.405399, 1.759327>,
      < 1.378573, -16.430637, 1.676192>
    }
    triangle {
      < 1.017865, -16.109667, 1.315659>,
      < 1.378573, -16.430637, 1.676192>,
      < 1.376081, -16.120996, 1.285251>
    }
    triangle {
      < 1.035183, -16.405399, 1.759327>,
      < 1.017865, -16.109667, 1.315659>,
      < 0.746115, -16.151922, 1.298564>
    }
    triangle {
      < 1.035183, -16.405399, 1.759327>,
      < 0.746115, -16.151922, 1.298564>,
      < 0.768374, -16.405407, 1.778333>
    }
    triangle {
      < 1.914657, -16.662985, 1.258638>,
      < 1.907846, -16.537790, 0.856772>,
      < 1.777546, -16.521307, 1.368371>
    }
    triangle {
      < 1.914657, -16.662985, 1.258638>,
      < 1.777546, -16.521307, 1.368371>,
      < 1.864329, -16.617907, 1.554815>
    }
    triangle {
      < 1.777546, -16.521307, 1.368371>,
      < 1.587325, -16.467213, 1.565508>,
      < 1.628723, -16.621517, 1.932459>
    }
    triangle {
      < 1.777546, -16.521307, 1.368371>,
      < 1.628723, -16.621517, 1.932459>,
      < 1.864329, -16.617907, 1.554815>
    }
    triangle {
      < 1.628723, -16.621517, 1.932459>,
      < 1.587325, -16.467213, 1.565508>,
      < 1.378573, -16.430637, 1.676192>
    }
    triangle {
      < 1.628723, -16.621517, 1.932459>,
      < 1.378573, -16.430637, 1.676192>,
      < 1.369638, -16.610191, 2.057869>
    }
    triangle {
      < 1.378573, -16.430637, 1.676192>,
      < 1.035183, -16.405399, 1.759327>,
      < 1.014823, -16.623846, 2.204896>
    }
    triangle {
      < 1.378573, -16.430637, 1.676192>,
      < 1.014823, -16.623846, 2.204896>,
      < 1.369638, -16.610191, 2.057869>
    }
    triangle {
      < 1.014823, -16.623846, 2.204896>,
      < 1.035183, -16.405399, 1.759327>,
      < 0.768374, -16.405407, 1.778333>
    }
    triangle {
      < 1.014823, -16.623846, 2.204896>,
      < 0.768374, -16.405407, 1.778333>,
      < 0.728951, -16.653225, 2.259426>
    }
    triangle {
      < 1.776353, -16.870106, 2.277083>,
      < 1.971499, -16.848463, 1.710856>,
      < 1.864329, -16.617907, 1.554815>
    }
    triangle {
      < 1.776353, -16.870106, 2.277083>,
      < 1.864329, -16.617907, 1.554815>,
      < 1.628723, -16.621517, 1.932459>
    }
    triangle {
      < 1.388503, -16.894844, 2.630507>,
      < 1.776353, -16.870106, 2.277083>,
      < 1.628723, -16.621517, 1.932459>
    }
    triangle {
      < 1.388503, -16.894844, 2.630507>,
      < 1.628723, -16.621517, 1.932459>,
      < 1.369638, -16.610191, 2.057869>
    }
    triangle {
      < 1.070847, -16.891695, 2.791938>,
      < 1.388503, -16.894844, 2.630507>,
      < 1.369638, -16.610191, 2.057869>
    }
    triangle {
      < 1.070847, -16.891695, 2.791938>,
      < 1.369638, -16.610191, 2.057869>,
      < 1.014823, -16.623846, 2.204896>
    }
    triangle {
      < 0.681794, -16.892210, 2.815598>,
      < 1.070847, -16.891695, 2.791938>,
      < 1.014823, -16.623846, 2.204896>
    }
    triangle {
      < 0.681794, -16.892210, 2.815598>,
      < 1.014823, -16.623846, 2.204896>,
      < 0.728951, -16.653225, 2.259426>
    }
    triangle {
      < 1.072773, -16.533684, -0.828105>,
      < 1.107970, -16.294109, -0.812431>,
      < 1.463711, -16.266281, -0.902691>
    }
    triangle {
      < 1.072773, -16.533684, -0.828105>,
      < 1.463711, -16.266281, -0.902691>,
      < 1.416780, -16.527496, -0.942118>
    }
    triangle {
      < 1.416780, -16.527496, -0.942118>,
      < 1.812056, -16.522848, -0.859946>,
      < 1.823185, -16.843313, -0.839047>
    }
    triangle {
      < 1.416780, -16.527496, -0.942118>,
      < 1.823185, -16.843313, -0.839047>,
      < 1.393320, -16.833019, -0.947343>
    }
    triangle {
      < 0.315054, -16.966997, 1.524682>,
      < 0.217487, -16.956699, 2.005404>,
      < 0.232294, -16.750608, 1.724192>
    }
    triangle {
      < 0.315054, -16.966997, 1.524682>,
      < 0.232294, -16.750608, 1.724192>,
      < 0.428679, -16.739271, 1.287170>
    }
    triangle {
      < 0.717694, -16.558420, 0.562759>,
      < 0.779473, -16.876310, 0.842545>,
      < 0.315054, -16.966997, 1.524682>
    }
    triangle {
      < 0.717694, -16.558420, 0.562759>,
      < 0.315054, -16.966997, 1.524682>,
      < 0.428679, -16.739271, 1.287170>
    }
    triangle {
      < 0.812176, -16.548635, 0.208392>,
      < 0.936331, -16.827877, 0.405523>,
      < 0.779473, -16.876310, 0.842545>
    }
    triangle {
      < 0.812176, -16.548635, 0.208392>,
      < 0.779473, -16.876310, 0.842545>,
      < 0.717694, -16.558420, 0.562759>
    }
    triangle {
      < 0.916546, -16.842817, -0.215803>,
      < 0.936331, -16.827877, 0.405523>,
      < 0.812176, -16.548635, 0.208392>
    }
    triangle {
      < 0.916546, -16.842817, -0.215803>,
      < 0.812176, -16.548635, 0.208392>,
      < 0.873921, -16.551208, -0.277316>
    }
    triangle {
      < 1.072773, -16.533684, -0.828105>,
      < 1.019051, -16.840240, -0.816229>,
      < 0.916546, -16.842817, -0.215803>
    }
    triangle {
      < 1.072773, -16.533684, -0.828105>,
      < 0.916546, -16.842817, -0.215803>,
      < 0.873921, -16.551208, -0.277316>
    }
    triangle {
      < 0.266916, -16.818619, 2.731232>,
      < 0.279272, -16.944326, 2.725533>,
      < 0.681794, -16.892210, 2.815598>
    }
    triangle {
      < 0.266916, -16.818619, 2.731232>,
      < 0.681794, -16.892210, 2.815598>,
      < 0.654614, -16.782988, 2.825098>
    }
    triangle {
      < 1.463711, -16.266281, -0.902691>,
      < 1.716935, -16.258036, -0.844744>,
      < 1.812056, -16.522848, -0.859946>
    }
    triangle {
      < 1.463711, -16.266281, -0.902691>,
      < 1.812056, -16.522848, -0.859946>,
      < 1.416780, -16.527496, -0.942118>
    }
    triangle {
      < 1.823185, -16.843313, -0.839047>,
      < 1.791076, -17.016422, -0.767800>,
      < 1.383448, -17.023645, -0.864695>
    }
    triangle {
      < 1.823185, -16.843313, -0.839047>,
      < 1.383448, -17.023645, -0.864695>,
      < 1.393320, -16.833019, -0.947343>
    }
    triangle {
      < 1.971499, -16.848463, 1.710856>,
      < 1.930710, -16.857740, 0.931825>,
      < 1.914657, -16.662985, 1.258638>
    }
    triangle {
      < 1.971499, -16.848463, 1.710856>,
      < 1.914657, -16.662985, 1.258638>,
      < 1.864329, -16.617907, 1.554815>
    }
    triangle {
      < 1.930710, -16.857740, 0.931825>,
      < 1.936865, -16.847431, 0.308599>,
      < 1.952909, -16.542427, 0.216444>
    }
    triangle {
      < 1.930710, -16.857740, 0.931825>,
      < 1.952909, -16.542427, 0.216444>,
      < 1.907846, -16.537790, 0.856772>
    }
    triangle {
      < 0.217487, -16.956699, 2.005404>,
      < 0.279272, -16.944326, 2.725533>,
      < 0.266916, -16.818619, 2.731232>
    }
    triangle {
      < 0.217487, -16.956699, 2.005404>,
      < 0.266916, -16.818619, 2.731232>,
      < 0.290367, -16.716606, 2.243387>
    }
    triangle {
      < 0.217487, -16.956699, 2.005404>,
      < 0.290367, -16.716606, 2.243387>,
      < 0.232294, -16.750608, 1.724192>
    }
    triangle {
      < 0.768374, -16.405407, 1.778333>,
      < 0.746115, -16.151922, 1.298564>,
      < 0.407685, -16.430656, 1.712788>
    }
    triangle {
      < 0.573176, -16.427046, 0.836848>,
      < 0.546007, -16.330189, 1.133261>,
      < 0.595395, -16.045792, 0.751345>
    }
    triangle {
      < 0.573176, -16.427046, 0.836848>,
      < 0.595395, -16.045792, 0.751345>,
      < 0.575628, -16.146772, 0.559437>
    }
    triangle {
      < 0.717694, -16.558420, 0.562759>,
      < 0.573176, -16.427046, 0.836848>,
      < 0.575628, -16.146772, 0.559437>
    }
    triangle {
      < 0.717694, -16.558420, 0.562759>,
      < 0.575628, -16.146772, 0.559437>,
      < 0.689875, -16.277122, 0.111016>
    }
    triangle {
      < 1.360004, -15.908727, 0.911886>,
      < 1.345166, -15.595141, 0.634045>,
      < 0.843662, -15.580988, 0.594391>
    }
    triangle {
      < 1.360004, -15.908727, 0.911886>,
      < 0.843662, -15.580988, 0.594391>,
      < 0.879499, -15.898948, 0.918308>
    }
    triangle {
      < 1.613225, -16.002491, 0.815926>,
      < 1.581096, -15.803278, 0.539515>,
      < 1.345166, -15.595141, 0.634045>
    }
    triangle {
      < 1.613225, -16.002491, 0.815926>,
      < 1.345166, -15.595141, 0.634045>,
      < 1.360004, -15.908727, 0.911886>
    }
    triangle {
      < 1.938057, -16.522331, -0.646666>,
      < 1.812056, -16.522848, -0.859946>,
      < 1.716935, -16.258036, -0.844744>
    }
    triangle {
      < 1.938057, -16.522331, -0.646666>,
      < 1.716935, -16.258036, -0.844744>,
      < 1.891111, -16.286882, -0.638589>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 1.757828, -17.043219, 2.237183>,
      < 1.371213, -17.053534, 2.586804>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 1.371213, -17.053534, 2.586804>,
      < 1.043674, -17.060688, 2.717835>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 1.043674, -17.060688, 2.717835>,
      < 0.743558, -17.083874, 2.762392>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 0.743558, -17.083874, 2.762392>,
      < 0.331154, -17.092710, 2.664728>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 0.331154, -17.092710, 2.664728>,
      < 0.276788, -17.107136, 2.189710>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 0.276788, -17.107136, 2.189710>,
      < 0.311356, -17.072100, 1.659588>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 0.311356, -17.072100, 1.659588>,
      < 0.906715, -17.045294, 1.084803>
    }
    triangle {
      < 1.935684, -17.038061, 1.704207>,
      < 0.906715, -17.045294, 1.084803>,
      < 1.882541, -17.050430, 0.924226>
    }
    triangle {
      < 0.654614, -16.782988, 2.825098>,
      < 0.681794, -16.892210, 2.815598>,
      < 0.728951, -16.653225, 2.259426>
    }
    triangle {
      < 1.054880, -17.013353, -0.753056>,
      < 1.383448, -17.023645, -0.864695>,
      < 1.791076, -17.016422, -0.767800>
    }
    triangle {
      < 1.054880, -17.013353, -0.753056>,
      < 1.791076, -17.016422, -0.767800>,
      < 1.915842, -17.029818, -0.563066>
    }
    triangle {
      < 1.054880, -17.013353, -0.753056>,
      < 1.915842, -17.029818, -0.563066>,
      < 1.006726, -17.017984, -0.182553>
    }
    triangle {
      < 1.151274, -17.021595, 0.563225>,
      < 1.882541, -17.050430, 0.924226>,
      < 0.906715, -17.045294, 1.084803>
    }
    triangle {
      < 1.897343, -17.039093, 0.289599>,
      < 1.882541, -17.050430, 0.924226>,
      < 1.151274, -17.021595, 0.563225>
    }
    triangle {
      < 0.878589, -15.894060, -0.327680>,
      < 0.870206, -16.331730, -0.319355>,
      < 0.689875, -16.277122, 0.111016>
    }
    triangle {
      < 0.878589, -15.894060, -0.327680>,
      < 0.689875, -16.277122, 0.111016>,
      < 0.698256, -15.923849, 0.026701>
    }
    triangle {
      < 0.878589, -15.894060, -0.327680>,
      < 1.116355, -15.854812, -0.733294>,
      < 1.107970, -16.294109, -0.812431>
    }
    triangle {
      < 0.878589, -15.894060, -0.327680>,
      < 1.107970, -16.294109, -0.812431>,
      < 0.870206, -16.331730, -0.319355>
    }
    triangle {
      < 1.116355, -15.854812, -0.733294>,
      < 1.472099, -15.846555, -0.807462>,
      < 1.463711, -16.266281, -0.902691>
    }
    triangle {
      < 1.116355, -15.854812, -0.733294>,
      < 1.463711, -16.266281, -0.902691>,
      < 1.107970, -16.294109, -0.812431>
    }
    triangle {
      < 1.472099, -15.846555, -0.807462>,
      < 1.725320, -15.850518, -0.759745>,
      < 1.716935, -16.258036, -0.844744>
    }
    triangle {
      < 1.472099, -15.846555, -0.807462>,
      < 1.716935, -16.258036, -0.844744>,
      < 1.463711, -16.266281, -0.902691>
    }
    triangle {
      < 1.725320, -15.850518, -0.759745>,
      < 1.899495, -15.867600, -0.590210>,
      < 1.891111, -16.286882, -0.638589>
    }
    triangle {
      < 1.725320, -15.850518, -0.759745>,
      < 1.891111, -16.286882, -0.638589>,
      < 1.716935, -16.258036, -0.844744>
    }
    triangle {
      < 1.899495, -15.867600, -0.590210>,
      < 1.940277, -15.920394, -0.031324>,
      < 1.931898, -16.313671, 0.040689>
    }
    triangle {
      < 1.899495, -15.867600, -0.590210>,
      < 1.931898, -16.313671, 0.040689>,
      < 1.891111, -16.286882, -0.638589>
    }
    triangle {
      < 0.689875, -16.277122, 0.111016>,
      < 0.573147, -15.763307, 0.422360>,
      < 0.698256, -15.923849, 0.026701>
    }
    triangle {
      < 1.800015, -15.344841, -0.049262>,
      < 1.701655, -15.344854, 0.246782>,
      < 1.856797, -15.897838, 0.323091>
    }
    triangle {
      < 1.800015, -15.344841, -0.049262>,
      < 1.856797, -15.897838, 0.323091>,
      < 1.940277, -15.920394, -0.031324>
    }
    triangle {
      < 1.701655, -15.344854, 0.246782>,
      < 1.501738, -15.344625, 0.448596>,
      < 1.581096, -15.803278, 0.539515>
    }
    triangle {
      < 1.701655, -15.344854, 0.246782>,
      < 1.581096, -15.803278, 0.539515>,
      < 1.856797, -15.897838, 0.323091>
    }
    triangle {
      < 1.501738, -15.344625, 0.448596>,
      < 1.305812, -15.344311, 0.504918>,
      < 1.345166, -15.595141, 0.634045>
    }
    triangle {
      < 1.501738, -15.344625, 0.448596>,
      < 1.345166, -15.595141, 0.634045>,
      < 1.581096, -15.803278, 0.539515>
    }
    triangle {
      < 1.305812, -15.344311, 0.504918>,
      < 0.889343, -15.344277, 0.470349>,
      < 0.843662, -15.580988, 0.594391>
    }
    triangle {
      < 1.305812, -15.344311, 0.504918>,
      < 0.843662, -15.580988, 0.594391>,
      < 1.345166, -15.595141, 0.634045>
    }
    triangle {
      < 0.889343, -15.344277, 0.470349>,
      < 0.664697, -15.344782, 0.311132>,
      < 0.573147, -15.763307, 0.422360>
    }
    triangle {
      < 0.889343, -15.344277, 0.470349>,
      < 0.573147, -15.763307, 0.422360>,
      < 0.843662, -15.580988, 0.594391>
    }
    triangle {
      < 0.664697, -15.344782, 0.311132>,
      < 0.768594, -15.344837, 0.001376>,
      < 0.698256, -15.923849, 0.026701>
    }
    triangle {
      < 0.664697, -15.344782, 0.311132>,
      < 0.698256, -15.923849, 0.026701>,
      < 0.573147, -15.763307, 0.422360>
    }
    triangle {
      < 0.918349, -15.344844, -0.308478>,
      < 0.878589, -15.894060, -0.327680>,
      < 0.698256, -15.923849, 0.026701>
    }
    triangle {
      < 0.918349, -15.344844, -0.308478>,
      < 0.698256, -15.923849, 0.026701>,
      < 0.768594, -15.344837, 0.001376>
    }
    triangle {
      < 0.918349, -15.344844, -0.308478>,
      < 1.115799, -15.344839, -0.663476>,
      < 1.116355, -15.854812, -0.733294>
    }
    triangle {
      < 0.918349, -15.344844, -0.308478>,
      < 1.116355, -15.854812, -0.733294>,
      < 0.878589, -15.894060, -0.327680>
    }
    triangle {
      < 1.115799, -15.344839, -0.663476>,
      < 1.411221, -15.344837, -0.728461>,
      < 1.472099, -15.846555, -0.807462>
    }
    triangle {
      < 1.115799, -15.344839, -0.663476>,
      < 1.472099, -15.846555, -0.807462>,
      < 1.116355, -15.854812, -0.733294>
    }
    triangle {
      < 1.411221, -15.344837, -0.728461>,
      < 1.621508, -15.344833, -0.686742>,
      < 1.725320, -15.850518, -0.759745>
    }
    triangle {
      < 1.411221, -15.344837, -0.728461>,
      < 1.725320, -15.850518, -0.759745>,
      < 1.472099, -15.846555, -0.807462>
    }
    triangle {
      < 1.621508, -15.344833, -0.686742>,
      < 1.766149, -15.344839, -0.538318>,
      < 1.899495, -15.867600, -0.590210>
    }
    triangle {
      < 1.621508, -15.344833, -0.686742>,
      < 1.899495, -15.867600, -0.590210>,
      < 1.725320, -15.850518, -0.759745>
    }
    triangle {
      < 1.766149, -15.344839, -0.538318>,
      < 1.800015, -15.344841, -0.049262>,
      < 1.940277, -15.920394, -0.031324>
    }
    triangle {
      < 1.766149, -15.344839, -0.538318>,
      < 1.940277, -15.920394, -0.031324>,
      < 1.899495, -15.867600, -0.590210>
    }
    triangle {
      < 1.933751, -8.505154, 1.083439>,
      < 2.263930, -8.512464, 0.590685>,
      < 2.443700, -7.794046, 0.570322>
    }
    triangle {
      < 1.933751, -8.505154, 1.083439>,
      < 2.443700, -7.794046, 0.570322>,
      < 1.975347, -7.812831, 1.241284>
    }
    triangle {
      < 2.263930, -8.512464, 0.590685>,
      < 2.328718, -8.622602, -0.163540>,
      < 2.479350, -7.832503, -0.152257>
    }
    triangle {
      < 2.263930, -8.512464, 0.590685>,
      < 2.479350, -7.832503, -0.152257>,
      < 2.443700, -7.794046, 0.570322>
    }
    triangle {
      < 2.328718, -8.622602, -0.163540>,
      < 1.895853, -8.798336, -0.801008>,
      < 2.044399, -7.905108, -0.789951>
    }
    triangle {
      < 2.328718, -8.622602, -0.163540>,
      < 2.044399, -7.905108, -0.789951>,
      < 2.479350, -7.832503, -0.152257>
    }
    triangle {
      < 1.895853, -8.798336, -0.801008>,
      < 1.244147, -8.856845, -0.855775>,
      < 1.252770, -8.003237, -0.934381>
    }
    triangle {
      < 1.895853, -8.798336, -0.801008>,
      < 1.252770, -8.003237, -0.934381>,
      < 2.044399, -7.905108, -0.789951>
    }
    triangle {
      < 1.244147, -8.856845, -0.855775>,
      < 0.796331, -8.874737, -0.488902>,
      < 0.700721, -8.056448, -0.504861>
    }
    triangle {
      < 1.244147, -8.856845, -0.855775>,
      < 0.700721, -8.056448, -0.504861>,
      < 1.252770, -8.003237, -0.934381>
    }
    triangle {
      < 0.796331, -8.874737, -0.488902>,
      < 0.513613, -8.778045, 0.117577>,
      < 0.370201, -8.109273, 0.418486>
    }
    triangle {
      < 0.796331, -8.874737, -0.488902>,
      < 0.370201, -8.109273, 0.418486>,
      < 0.700721, -8.056448, -0.504861>
    }
    triangle {
      < 1.222692, -8.558242, 1.154920>,
      < 1.933751, -8.505154, 1.083439>,
      < 1.975347, -7.812831, 1.241284>
    }
    triangle {
      < 1.222692, -8.558242, 1.154920>,
      < 1.975347, -7.812831, 1.241284>,
      < 1.336529, -7.864736, 1.430424>
    }
    triangle {
      < 1.908992, -8.895303, 1.178878>,
      < 2.261867, -8.909725, 0.696070>,
      < 2.263930, -8.512464, 0.590685>
    }
    triangle {
      < 1.908992, -8.895303, 1.178878>,
      < 2.263930, -8.512464, 0.590685>,
      < 1.933751, -8.505154, 1.083439>
    }
    triangle {
      < 2.261867, -8.909725, 0.696070>,
      < 2.319101, -9.021067, -0.176046>,
      < 2.328718, -8.622602, -0.163540>
    }
    triangle {
      < 2.261867, -8.909725, 0.696070>,
      < 2.328718, -8.622602, -0.163540>,
      < 2.263930, -8.512464, 0.590685>
    }
    triangle {
      < 2.319101, -9.021067, -0.176046>,
      < 1.874532, -9.173381, -0.803333>,
      < 1.895853, -8.798336, -0.801008>
    }
    triangle {
      < 2.319101, -9.021067, -0.176046>,
      < 1.895853, -8.798336, -0.801008>,
      < 2.328718, -8.622602, -0.163540>
    }
    triangle {
      < 1.874532, -9.173381, -0.803333>,
      < 1.236629, -9.214582, -0.817226>,
      < 1.244147, -8.856845, -0.855775>
    }
    triangle {
      < 1.874532, -9.173381, -0.803333>,
      < 1.244147, -8.856845, -0.855775>,
      < 1.895853, -8.798336, -0.801008>
    }
    triangle {
      < 1.236629, -9.214582, -0.817226>,
      < 0.800694, -9.208599, -0.417761>,
      < 0.796331, -8.874737, -0.488902>
    }
    triangle {
      < 1.236629, -9.214582, -0.817226>,
      < 0.796331, -8.874737, -0.488902>,
      < 1.244147, -8.856845, -0.855775>
    }
    triangle {
      < 0.800694, -9.208599, -0.417761>,
      < 0.549594, -9.182402, 0.089109>,
      < 0.513613, -8.778045, 0.117577>
    }
    triangle {
      < 0.800694, -9.208599, -0.417761>,
      < 0.513613, -8.778045, 0.117577>,
      < 0.796331, -8.874737, -0.488902>
    }
    triangle {
      < 0.549594, -9.182402, 0.089109>,
      < 0.690342, -9.021214, 0.823269>,
      < 0.668801, -8.649164, 0.894079>
    }
    triangle {
      < 0.549594, -9.182402, 0.089109>,
      < 0.668801, -8.649164, 0.894079>,
      < 0.513613, -8.778045, 0.117577>
    }
    triangle {
      < 0.690342, -9.021214, 0.823269>,
      < 1.180465, -8.898202, 1.212831>,
      < 1.222692, -8.558242, 1.154920>
    }
    triangle {
      < 0.690342, -9.021214, 0.823269>,
      < 1.222692, -8.558242, 1.154920>,
      < 0.668801, -8.649164, 0.894079>
    }
    triangle {
      < 1.180465, -8.898202, 1.212831>,
      < 1.908992, -8.895303, 1.178878>,
      < 1.933751, -8.505154, 1.083439>
    }
    triangle {
      < 1.180465, -8.898202, 1.212831>,
      < 1.933751, -8.505154, 1.083439>,
      < 1.222692, -8.558242, 1.154920>
    }
    triangle {
      < 1.876215, -9.446047, 1.079474>,
      < 2.206087, -9.431392, 0.614165>,
      < 2.261867, -8.909725, 0.696070>
    }
    triangle {
      < 1.876215, -9.446047, 1.079474>,
      < 2.261867, -8.909725, 0.696070>,
      < 1.908992, -8.895303, 1.178878>
    }
    triangle {
      < 2.206087, -9.431392, 0.614165>,
      < 2.281945, -9.478472, -0.308398>,
      < 2.319101, -9.021067, -0.176046>
    }
    triangle {
      < 2.206087, -9.431392, 0.614165>,
      < 2.319101, -9.021067, -0.176046>,
      < 2.261867, -8.909725, 0.696070>
    }
    triangle {
      < 2.281945, -9.478472, -0.308398>,
      < 1.821774, -9.510803, -0.894916>,
      < 1.874532, -9.173381, -0.803333>
    }
    triangle {
      < 2.281945, -9.478472, -0.308398>,
      < 1.874532, -9.173381, -0.803333>,
      < 2.319101, -9.021067, -0.176046>
    }
    triangle {
      < 1.821774, -9.510803, -0.894916>,
      < 1.160604, -9.510589, -0.900778>,
      < 1.236629, -9.214582, -0.817226>
    }
    triangle {
      < 1.821774, -9.510803, -0.894916>,
      < 1.236629, -9.214582, -0.817226>,
      < 1.874532, -9.173381, -0.803333>
    }
    triangle {
      < 1.160604, -9.510589, -0.900778>,
      < 0.746533, -9.528240, -0.513452>,
      < 0.800694, -9.208599, -0.417761>
    }
    triangle {
      < 1.160604, -9.510589, -0.900778>,
      < 0.800694, -9.208599, -0.417761>,
      < 1.236629, -9.214582, -0.817226>
    }
    triangle {
      < 0.746533, -9.528240, -0.513452>,
      < 0.578598, -9.525470, 0.004078>,
      < 0.549594, -9.182402, 0.089109>
    }
    triangle {
      < 0.746533, -9.528240, -0.513452>,
      < 0.549594, -9.182402, 0.089109>,
      < 0.800694, -9.208599, -0.417761>
    }
    triangle {
      < 0.578598, -9.525470, 0.004078>,
      < 0.689378, -9.522341, 0.730052>,
      < 0.690342, -9.021214, 0.823269>
    }
    triangle {
      < 0.578598, -9.525470, 0.004078>,
      < 0.690342, -9.021214, 0.823269>,
      < 0.549594, -9.182402, 0.089109>
    }
    triangle {
      < 0.689378, -9.522341, 0.730052>,
      < 1.162261, -9.475252, 1.131596>,
      < 1.180465, -8.898202, 1.212831>
    }
    triangle {
      < 0.689378, -9.522341, 0.730052>,
      < 1.180465, -8.898202, 1.212831>,
      < 0.690342, -9.021214, 0.823269>
    }
    triangle {
      < 1.162261, -9.475252, 1.131596>,
      < 1.876215, -9.446047, 1.079474>,
      < 1.908992, -8.895303, 1.178878>
    }
    triangle {
      < 1.162261, -9.475252, 1.131596>,
      < 1.908992, -8.895303, 1.178878>,
      < 1.180465, -8.898202, 1.212831>
    }
    triangle {
      < 1.760825, -10.078956, 0.801509>,
      < 2.122164, -9.988276, 0.401886>,
      < 2.206087, -9.431392, 0.614165>
    }
    triangle {
      < 1.760825, -10.078956, 0.801509>,
      < 2.206087, -9.431392, 0.614165>,
      < 1.876215, -9.446047, 1.079474>
    }
    triangle {
      < 2.122164, -9.988276, 0.401886>,
      < 2.289495, -9.935560, -0.547479>,
      < 2.281945, -9.478472, -0.308398>
    }
    triangle {
      < 2.122164, -9.988276, 0.401886>,
      < 2.281945, -9.478472, -0.308398>,
      < 2.206087, -9.431392, 0.614165>
    }
    triangle {
      < 2.289495, -9.935560, -0.547479>,
      < 1.838400, -9.877200, -1.134759>,
      < 1.821774, -9.510803, -0.894916>
    }
    triangle {
      < 2.289495, -9.935560, -0.547479>,
      < 1.821774, -9.510803, -0.894916>,
      < 2.281945, -9.478472, -0.308398>
    }
    triangle {
      < 1.838400, -9.877200, -1.134759>,
      < 1.077830, -9.847917, -1.085750>,
      < 1.160604, -9.510589, -0.900778>
    }
    triangle {
      < 1.838400, -9.877200, -1.134759>,
      < 1.160604, -9.510589, -0.900778>,
      < 1.821774, -9.510803, -0.894916>
    }
    triangle {
      < 1.077830, -9.847917, -1.085750>,
      < 0.669742, -9.888981, -0.621261>,
      < 0.746533, -9.528240, -0.513452>
    }
    triangle {
      < 1.077830, -9.847917, -1.085750>,
      < 0.746533, -9.528240, -0.513452>,
      < 1.160604, -9.510589, -0.900778>
    }
    triangle {
      < 0.669742, -9.888981, -0.621261>,
      < 0.593296, -10.017845, -0.131055>,
      < 0.578598, -9.525470, 0.004078>
    }
    triangle {
      < 0.669742, -9.888981, -0.621261>,
      < 0.578598, -9.525470, 0.004078>,
      < 0.746533, -9.528240, -0.513452>
    }
    triangle {
      < 0.593296, -10.017845, -0.131055>,
      < 0.876520, -10.155484, 0.512643>,
      < 0.689378, -9.522341, 0.730052>
    }
    triangle {
      < 0.593296, -10.017845, -0.131055>,
      < 0.689378, -9.522341, 0.730052>,
      < 0.578598, -9.525470, 0.004078>
    }
    triangle {
      < 0.876520, -10.155484, 0.512643>,
      < 1.271736, -10.158121, 0.823681>,
      < 1.162261, -9.475252, 1.131596>
    }
    triangle {
      < 0.876520, -10.155484, 0.512643>,
      < 1.162261, -9.475252, 1.131596>,
      < 0.689378, -9.522341, 0.730052>
    }
    triangle {
      < 1.271736, -10.158121, 0.823681>,
      < 1.760825, -10.078956, 0.801509>,
      < 1.876215, -9.446047, 1.079474>
    }
    triangle {
      < 1.271736, -10.158121, 0.823681>,
      < 1.876215, -9.446047, 1.079474>,
      < 1.162261, -9.475252, 1.131596>
    }
    triangle {
      < 1.879315, -11.014043, 0.636238>,
      < 2.303299, -10.987743, 0.162974>,
      < 2.122164, -9.988276, 0.401886>
    }
    triangle {
      < 1.879315, -11.014043, 0.636238>,
      < 2.122164, -9.988276, 0.401886>,
      < 1.760825, -10.078956, 0.801509>
    }
    triangle {
      < 2.303299, -10.987743, 0.162974>,
      < 2.479603, -10.952571, -0.796086>,
      < 2.289495, -9.935560, -0.547479>
    }
    triangle {
      < 2.303299, -10.987743, 0.162974>,
      < 2.289495, -9.935560, -0.547479>,
      < 2.122164, -9.988276, 0.401886>
    }
    triangle {
      < 2.479603, -10.952571, -0.796086>,
      < 1.895554, -10.882447, -1.356951>,
      < 1.838400, -9.877200, -1.134759>
    }
    triangle {
      < 2.479603, -10.952571, -0.796086>,
      < 1.838400, -9.877200, -1.134759>,
      < 2.289495, -9.935560, -0.547479>
    }
    triangle {
      < 1.895554, -10.882447, -1.356951>,
      < 1.018189, -10.820683, -1.391078>,
      < 1.077830, -9.847917, -1.085750>
    }
    triangle {
      < 1.895554, -10.882447, -1.356951>,
      < 1.077830, -9.847917, -1.085750>,
      < 1.838400, -9.877200, -1.134759>
    }
    triangle {
      < 1.018189, -10.820683, -1.391078>,
      < 0.420288, -10.969921, -1.070736>,
      < 0.669742, -9.888981, -0.621261>
    }
    triangle {
      < 1.018189, -10.820683, -1.391078>,
      < 0.669742, -9.888981, -0.621261>,
      < 1.077830, -9.847917, -1.085750>
    }
    triangle {
      < 0.420288, -10.969921, -1.070736>,
      < 0.513669, -10.879103, -0.239414>,
      < 0.593296, -10.017845, -0.131055>
    }
    triangle {
      < 0.420288, -10.969921, -1.070736>,
      < 0.593296, -10.017845, -0.131055>,
      < 0.669742, -9.888981, -0.621261>
    }
    triangle {
      < 0.513669, -10.879103, -0.239414>,
      < 0.971880, -10.929044, 0.381113>,
      < 0.876520, -10.155484, 0.512643>
    }
    triangle {
      < 0.513669, -10.879103, -0.239414>,
      < 0.876520, -10.155484, 0.512643>,
      < 0.593296, -10.017845, -0.131055>
    }
    triangle {
      < 0.971880, -10.929044, 0.381113>,
      < 1.410989, -10.981870, 0.638458>,
      < 1.271736, -10.158121, 0.823681>
    }
    triangle {
      < 0.971880, -10.929044, 0.381113>,
      < 1.271736, -10.158121, 0.823681>,
      < 0.876520, -10.155484, 0.512643>
    }
    triangle {
      < 1.410989, -10.981870, 0.638458>,
      < 1.879315, -11.014043, 0.636238>,
      < 1.760825, -10.078956, 0.801509>
    }
    triangle {
      < 1.410989, -10.981870, 0.638458>,
      < 1.760825, -10.078956, 0.801509>,
      < 1.271736, -10.158121, 0.823681>
    }
    triangle {
      < 1.930729, -12.288463, 0.535954>,
      < 2.319475, -12.265036, 0.028441>,
      < 2.303299, -10.987743, 0.162974>
    }
    triangle {
      < 1.930729, -12.288463, 0.535954>,
      < 2.303299, -10.987743, 0.162974>,
      < 1.879315, -11.014043, 0.636238>
    }
    triangle {
      < 2.319475, -12.265036, 0.028441>,
      < 2.416574, -12.218311, -0.751097>,
      < 2.479603, -10.952571, -0.796086>
    }
    triangle {
      < 2.319475, -12.265036, 0.028441>,
      < 2.479603, -10.952571, -0.796086>,
      < 2.303299, -10.987743, 0.162974>
    }
    triangle {
      < 2.416574, -12.218311, -0.751097>,
      < 1.811200, -12.109874, -1.365803>,
      < 1.895554, -10.882447, -1.356951>
    }
    triangle {
      < 2.416574, -12.218311, -0.751097>,
      < 1.895554, -10.882447, -1.356951>,
      < 2.479603, -10.952571, -0.796086>
    }
    triangle {
      < 1.811200, -12.109874, -1.365803>,
      < 0.924678, -12.135973, -1.352007>,
      < 1.018189, -10.820683, -1.391078>
    }
    triangle {
      < 1.811200, -12.109874, -1.365803>,
      < 1.018189, -10.820683, -1.391078>,
      < 1.895554, -10.882447, -1.356951>
    }
    triangle {
      < 0.924678, -12.135973, -1.352007>,
      < 0.417049, -12.179820, -0.980798>,
      < 0.420288, -10.969921, -1.070736>
    }
    triangle {
      < 0.924678, -12.135973, -1.352007>,
      < 0.420288, -10.969921, -1.070736>,
      < 1.018189, -10.820683, -1.391078>
    }
    triangle {
      < 0.417049, -12.179820, -0.980798>,
      < 0.524598, -12.191697, -0.215008>,
      < 0.513669, -10.879103, -0.239414>
    }
    triangle {
      < 0.417049, -12.179820, -0.980798>,
      < 0.513669, -10.879103, -0.239414>,
      < 0.420288, -10.969921, -1.070736>
    }
    triangle {
      < 0.524598, -12.191697, -0.215008>,
      < 0.975866, -12.250301, 0.349836>,
      < 0.971880, -10.929044, 0.381113>
    }
    triangle {
      < 0.524598, -12.191697, -0.215008>,
      < 0.971880, -10.929044, 0.381113>,
      < 0.513669, -10.879103, -0.239414>
    }
    triangle {
      < 0.975866, -12.250301, 0.349836>,
      < 1.441757, -12.279470, 0.620154>,
      < 1.410989, -10.981870, 0.638458>
    }
    triangle {
      < 0.975866, -12.250301, 0.349836>,
      < 1.410989, -10.981870, 0.638458>,
      < 0.971880, -10.929044, 0.381113>
    }
    triangle {
      < 1.441757, -12.279470, 0.620154>,
      < 1.930729, -12.288463, 0.535954>,
      < 1.879315, -11.014043, 0.636238>
    }
    triangle {
      < 1.441757, -12.279470, 0.620154>,
      < 1.879315, -11.014043, 0.636238>,
      < 1.410989, -10.981870, 0.638458>
    }
    triangle {
      < 1.795750, -13.435624, 0.456447>,
      < 2.132106, -13.432380, -0.011457>,
      < 2.319475, -12.265036, 0.028441>
    }
    triangle {
      < 1.795750, -13.435624, 0.456447>,
      < 2.319475, -12.265036, 0.028441>,
      < 1.930729, -12.288463, 0.535954>
    }
    triangle {
      < 2.132106, -13.432380, -0.011457>,
      < 2.207716, -13.416903, -0.705194>,
      < 2.416574, -12.218311, -0.751097>
    }
    triangle {
      < 2.132106, -13.432380, -0.011457>,
      < 2.416574, -12.218311, -0.751097>,
      < 2.319475, -12.265036, 0.028441>
    }
    triangle {
      < 2.207716, -13.416903, -0.705194>,
      < 1.644140, -13.444264, -1.030593>,
      < 1.811200, -12.109874, -1.365803>
    }
    triangle {
      < 2.207716, -13.416903, -0.705194>,
      < 1.811200, -12.109874, -1.365803>,
      < 2.416574, -12.218311, -0.751097>
    }
    triangle {
      < 1.644140, -13.444264, -1.030593>,
      < 0.964788, -13.430838, -1.009000>,
      < 0.924678, -12.135973, -1.352007>
    }
    triangle {
      < 1.644140, -13.444264, -1.030593>,
      < 0.924678, -12.135973, -1.352007>,
      < 1.811200, -12.109874, -1.365803>
    }
    triangle {
      < 0.964788, -13.430838, -1.009000>,
      < 0.626622, -13.410682, -0.678529>,
      < 0.417049, -12.179820, -0.980798>
    }
    triangle {
      < 0.964788, -13.430838, -1.009000>,
      < 0.417049, -12.179820, -0.980798>,
      < 0.924678, -12.135973, -1.352007>
    }
    triangle {
      < 0.626622, -13.410682, -0.678529>,
      < 0.666406, -13.403359, -0.168696>,
      < 0.524598, -12.191697, -0.215008>
    }
    triangle {
      < 0.626622, -13.410682, -0.678529>,
      < 0.524598, -12.191697, -0.215008>,
      < 0.417049, -12.179820, -0.980798>
    }
    triangle {
      < 0.666406, -13.403359, -0.168696>,
      < 1.024282, -13.374157, 0.251626>,
      < 0.975866, -12.250301, 0.349836>
    }
    triangle {
      < 0.666406, -13.403359, -0.168696>,
      < 0.975866, -12.250301, 0.349836>,
      < 0.524598, -12.191697, -0.215008>
    }
    triangle {
      < 1.024282, -13.374157, 0.251626>,
      < 1.404174, -13.393355, 0.531376>,
      < 1.441757, -12.279470, 0.620154>
    }
    triangle {
      < 1.024282, -13.374157, 0.251626>,
      < 1.441757, -12.279470, 0.620154>,
      < 0.975866, -12.250301, 0.349836>
    }
    triangle {
      < 1.404174, -13.393355, 0.531376>,
      < 1.795750, -13.435624, 0.456447>,
      < 1.930729, -12.288463, 0.535954>
    }
    triangle {
      < 1.404174, -13.393355, 0.531376>,
      < 1.930729, -12.288463, 0.535954>,
      < 1.441757, -12.279470, 0.620154>
    }
    triangle {
      < 1.681067, -14.709235, 0.431913>,
      < 1.834913, -14.700462, -0.114861>,
      < 2.132106, -13.432380, -0.011457>
    }
    triangle {
      < 1.681067, -14.709235, 0.431913>,
      < 2.132106, -13.432380, -0.011457>,
      < 1.795750, -13.435624, 0.456447>
    }
    triangle {
      < 1.834913, -14.700462, -0.114861>,
      < 1.695713, -14.682818, -0.573428>,
      < 2.207716, -13.416903, -0.705194>
    }
    triangle {
      < 1.834913, -14.700462, -0.114861>,
      < 2.207716, -13.416903, -0.705194>,
      < 2.132106, -13.432380, -0.011457>
    }
    triangle {
      < 1.695713, -14.682818, -0.573428>,
      < 1.405404, -14.700474, -0.800741>,
      < 1.644140, -13.444264, -1.030593>
    }
    triangle {
      < 1.695713, -14.682818, -0.573428>,
      < 1.644140, -13.444264, -1.030593>,
      < 2.207716, -13.416903, -0.705194>
    }
    triangle {
      < 1.405404, -14.700474, -0.800741>,
      < 0.940527, -14.703373, -0.826540>,
      < 0.964788, -13.430838, -1.009000>
    }
    triangle {
      < 1.405404, -14.700474, -0.800741>,
      < 0.964788, -13.430838, -1.009000>,
      < 1.644140, -13.444264, -1.030593>
    }
    triangle {
      < 0.940527, -14.703373, -0.826540>,
      < 0.738949, -14.691372, -0.469249>,
      < 0.626622, -13.410682, -0.678529>
    }
    triangle {
      < 0.940527, -14.703373, -0.826540>,
      < 0.626622, -13.410682, -0.678529>,
      < 0.964788, -13.430838, -1.009000>
    }
    triangle {
      < 0.738949, -14.691372, -0.469249>,
      < 0.714355, -14.685491, -0.016596>,
      < 0.666406, -13.403359, -0.168696>
    }
    triangle {
      < 0.738949, -14.691372, -0.469249>,
      < 0.666406, -13.403359, -0.168696>,
      < 0.626622, -13.410682, -0.678529>
    }
    triangle {
      < 0.714355, -14.685491, -0.016596>,
      < 0.926533, -14.682714, 0.270446>,
      < 1.024282, -13.374157, 0.251626>
    }
    triangle {
      < 0.714355, -14.685491, -0.016596>,
      < 1.024282, -13.374157, 0.251626>,
      < 0.666406, -13.403359, -0.168696>
    }
    triangle {
      < 0.926533, -14.682714, 0.270446>,
      < 1.300814, -14.712014, 0.513934>,
      < 1.404174, -13.393355, 0.531376>
    }
    triangle {
      < 0.926533, -14.682714, 0.270446>,
      < 1.404174, -13.393355, 0.531376>,
      < 1.024282, -13.374157, 0.251626>
    }
    triangle {
      < 1.300814, -14.712014, 0.513934>,
      < 1.681067, -14.709235, 0.431913>,
      < 1.795750, -13.435624, 0.456447>
    }
    triangle {
      < 1.300814, -14.712014, 0.513934>,
      < 1.795750, -13.435624, 0.456447>,
      < 1.404174, -13.393355, 0.531376>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 1.157471, -2.816209, -0.449662>,
      < 0.830475, -3.124872, -0.561766>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 0.830475, -3.124872, -0.561766>,
      < 0.491020, -3.281535, -0.399705>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 0.491020, -3.281535, -0.399705>,
      < 0.311941, -3.320051, -0.203322>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 0.311941, -3.320051, -0.203322>,
      < 0.260589, -3.270522, 0.143011>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 0.260589, -3.270522, 0.143011>,
      < 0.333827, -3.126321, 0.484142>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 0.333827, -3.126321, 0.484142>,
      < 0.623694, -2.794169, 0.738749>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 0.623694, -2.794169, 0.738749>,
      < 0.835474, -2.586065, 0.770395>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 0.835474, -2.586065, 0.770395>,
      < 1.092823, -2.408535, 0.645399>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 1.092823, -2.408535, 0.645399>,
      < 1.280752, -2.375137, 0.234031>
    }
    triangle {
      < 1.633359, -5.011849, -1.124489>,
      < 0.819039, -5.241535, -0.756786>,
      < 0.705662, -4.641968, -0.784613>
    }
    triangle {
      < 1.633359, -5.011849, -1.124489>,
      < 0.705662, -4.641968, -0.784613>,
      < 1.490880, -4.280551, -1.158483>
    }
    triangle {
      < 0.819039, -5.241535, -0.756786>,
      < 0.390210, -5.298005, -0.311211>,
      < 0.291355, -4.730822, -0.331563>
    }
    triangle {
      < 0.819039, -5.241535, -0.756786>,
      < 0.291355, -4.730822, -0.331563>,
      < 0.705662, -4.641968, -0.784613>
    }
    triangle {
      < 0.390210, -5.298005, -0.311211>,
      < 0.144891, -5.235314, 0.474587>,
      < 0.173907, -4.616560, 0.467417>
    }
    triangle {
      < 0.390210, -5.298005, -0.311211>,
      < 0.173907, -4.616560, 0.467417>,
      < 0.291355, -4.730822, -0.331563>
    }
    triangle {
      < 0.144891, -5.235314, 0.474587>,
      < 0.325606, -5.023898, 1.248583>,
      < 0.345180, -4.283892, 1.254397>
    }
    triangle {
      < 0.144891, -5.235314, 0.474587>,
      < 0.345180, -4.283892, 1.254397>,
      < 0.173907, -4.616560, 0.467417>
    }
    triangle {
      < 0.325606, -5.023898, 1.248583>,
      < 1.146627, -4.527002, 1.826264>,
      < 1.013912, -3.517628, 1.841768>
    }
    triangle {
      < 0.325606, -5.023898, 1.248583>,
      < 1.013912, -3.517628, 1.841768>,
      < 0.345180, -4.283892, 1.254397>
    }
    triangle {
      < 1.146627, -4.527002, 1.826264>,
      < 1.652500, -4.221898, 1.898064>,
      < 1.502483, -3.037540, 1.914772>
    }
    triangle {
      < 1.146627, -4.527002, 1.826264>,
      < 1.502483, -3.037540, 1.914772>,
      < 1.013912, -3.517628, 1.841768>
    }
    triangle {
      < 1.652500, -4.221898, 1.898064>,
      < 2.266314, -3.961618, 1.614461>,
      < 2.096180, -2.627983, 1.626412>
    }
    triangle {
      < 1.652500, -4.221898, 1.898064>,
      < 2.096180, -2.627983, 1.626412>,
      < 1.502483, -3.037540, 1.914772>
    }
    triangle {
      < 2.266314, -3.961618, 1.614461>,
      < 2.714527, -3.912652, 0.681104>,
      < 2.529726, -2.550935, 0.677398>
    }
    triangle {
      < 2.266314, -3.961618, 1.614461>,
      < 2.529726, -2.550935, 0.677398>,
      < 2.096180, -2.627983, 1.626412>
    }
    triangle {
      < 2.714527, -3.912652, 0.681104>,
      < 2.729159, -4.177640, -0.156872>,
      < 2.543879, -2.967900, -0.174635>
    }
    triangle {
      < 2.714527, -3.912652, 0.681104>,
      < 2.543879, -2.967900, -0.174635>,
      < 2.529726, -2.550935, 0.677398>
    }
    triangle {
      < 2.729159, -4.177640, -0.156872>,
      < 2.418961, -4.559316, -0.870134>,
      < 2.245321, -3.568475, -0.899862>
    }
    triangle {
      < 2.729159, -4.177640, -0.156872>,
      < 2.245321, -3.568475, -0.899862>,
      < 2.543879, -2.967900, -0.174635>
    }
    triangle {
      < 2.418961, -4.559316, -0.870134>,
      < 1.633359, -5.011849, -1.124489>,
      < 1.490880, -4.280551, -1.158483>
    }
    triangle {
      < 2.418961, -4.559316, -0.870134>,
      < 1.490880, -4.280551, -1.158483>,
      < 2.245321, -3.568475, -0.899862>
    }
    triangle {
      < 0.101138, -3.982895, 0.305712>,
      < 0.198166, -4.076481, -0.348682>,
      < 0.291355, -4.730822, -0.331563>
    }
    triangle {
      < 0.101138, -3.982895, 0.305712>,
      < 0.291355, -4.730822, -0.331563>,
      < 0.173907, -4.616560, 0.467417>
    }
    triangle {
      < 0.198166, -4.076481, -0.348682>,
      < 0.536535, -4.003706, -0.719747>,
      < 0.705662, -4.641968, -0.784613>
    }
    triangle {
      < 0.198166, -4.076481, -0.348682>,
      < 0.705662, -4.641968, -0.784613>,
      < 0.291355, -4.730822, -0.331563>
    }
    triangle {
      < 0.536535, -4.003706, -0.719747>,
      < 1.177932, -3.707692, -1.025960>,
      < 1.490880, -4.280551, -1.158483>
    }
    triangle {
      < 0.536535, -4.003706, -0.719747>,
      < 1.490880, -4.280551, -1.158483>,
      < 0.705662, -4.641968, -0.784613>
    }
    triangle {
      < 1.177932, -3.707692, -1.025960>,
      < 1.795790, -3.124475, -0.814140>,
      < 2.245321, -3.568475, -0.899862>
    }
    triangle {
      < 1.177932, -3.707692, -1.025960>,
      < 2.245321, -3.568475, -0.899862>,
      < 1.490880, -4.280551, -1.158483>
    }
    triangle {
      < 1.795790, -3.124475, -0.814140>,
      < 2.040321, -2.632582, -0.220152>,
      < 2.543879, -2.967900, -0.174635>
    }
    triangle {
      < 1.795790, -3.124475, -0.814140>,
      < 2.543879, -2.967900, -0.174635>,
      < 2.245321, -3.568475, -0.899862>
    }
    triangle {
      < 2.040321, -2.632582, -0.220152>,
      < 2.028729, -2.291073, 0.477694>,
      < 2.529726, -2.550935, 0.677398>
    }
    triangle {
      < 2.040321, -2.632582, -0.220152>,
      < 2.529726, -2.550935, 0.677398>,
      < 2.543879, -2.967900, -0.174635>
    }
    triangle {
      < 2.028729, -2.291073, 0.477694>,
      < 1.673639, -2.354178, 1.254971>,
      < 2.096180, -2.627983, 1.626412>
    }
    triangle {
      < 2.028729, -2.291073, 0.477694>,
      < 2.096180, -2.627983, 1.626412>,
      < 2.529726, -2.550935, 0.677398>
    }
    triangle {
      < 1.673639, -2.354178, 1.254971>,
      < 1.187379, -2.689620, 1.491149>,
      < 1.502483, -3.037540, 1.914772>
    }
    triangle {
      < 1.673639, -2.354178, 1.254971>,
      < 1.502483, -3.037540, 1.914772>,
      < 2.096180, -2.627983, 1.626412>
    }
    triangle {
      < 1.187379, -2.689620, 1.491149>,
      < 0.787222, -3.082830, 1.431356>,
      < 1.013912, -3.517628, 1.841768>
    }
    triangle {
      < 1.187379, -2.689620, 1.491149>,
      < 1.013912, -3.517628, 1.841768>,
      < 1.502483, -3.037540, 1.914772>
    }
    triangle {
      < 0.787222, -3.082830, 1.431356>,
      < 0.239519, -3.710428, 0.950277>,
      < 0.345180, -4.283892, 1.254397>
    }
    triangle {
      < 0.787222, -3.082830, 1.431356>,
      < 0.345180, -4.283892, 1.254397>,
      < 1.013912, -3.517628, 1.841768>
    }
    triangle {
      < 0.239519, -3.710428, 0.950277>,
      < 0.101138, -3.982895, 0.305712>,
      < 0.173907, -4.616560, 0.467417>
    }
    triangle {
      < 0.239519, -3.710428, 0.950277>,
      < 0.173907, -4.616560, 0.467417>,
      < 0.345180, -4.283892, 1.254397>
    }
    triangle {
      < 0.835474, -2.586065, 0.770395>,
      < 0.623694, -2.794169, 0.738749>,
      < 0.787222, -3.082830, 1.431356>
    }
    triangle {
      < 0.835474, -2.586065, 0.770395>,
      < 0.787222, -3.082830, 1.431356>,
      < 1.187379, -2.689620, 1.491149>
    }
    triangle {
      < 0.623694, -2.794169, 0.738749>,
      < 0.333827, -3.126321, 0.484142>,
      < 0.239519, -3.710428, 0.950277>
    }
    triangle {
      < 0.623694, -2.794169, 0.738749>,
      < 0.239519, -3.710428, 0.950277>,
      < 0.787222, -3.082830, 1.431356>
    }
    triangle {
      < 0.333827, -3.126321, 0.484142>,
      < 0.260589, -3.270522, 0.143011>,
      < 0.101138, -3.982895, 0.305712>
    }
    triangle {
      < 0.333827, -3.126321, 0.484142>,
      < 0.101138, -3.982895, 0.305712>,
      < 0.239519, -3.710428, 0.950277>
    }
    triangle {
      < 0.260589, -3.270522, 0.143011>,
      < 0.311941, -3.320051, -0.203322>,
      < 0.198166, -4.076481, -0.348682>
    }
    triangle {
      < 0.260589, -3.270522, 0.143011>,
      < 0.198166, -4.076481, -0.348682>,
      < 0.101138, -3.982895, 0.305712>
    }
    triangle {
      < 0.311941, -3.320051, -0.203322>,
      < 0.491020, -3.281535, -0.399705>,
      < 0.536535, -4.003706, -0.719747>
    }
    triangle {
      < 0.311941, -3.320051, -0.203322>,
      < 0.536535, -4.003706, -0.719747>,
      < 0.198166, -4.076481, -0.348682>
    }
    triangle {
      < 0.491020, -3.281535, -0.399705>,
      < 0.830475, -3.124872, -0.561766>,
      < 1.177932, -3.707692, -1.025960>
    }
    triangle {
      < 0.491020, -3.281535, -0.399705>,
      < 1.177932, -3.707692, -1.025960>,
      < 0.536535, -4.003706, -0.719747>
    }
    triangle {
      < 0.830475, -3.124872, -0.561766>,
      < 1.157471, -2.816209, -0.449662>,
      < 1.795790, -3.124475, -0.814140>
    }
    triangle {
      < 0.830475, -3.124872, -0.561766>,
      < 1.795790, -3.124475, -0.814140>,
      < 1.177932, -3.707692, -1.025960>
    }
    triangle {
      < 1.157471, -2.816209, -0.449662>,
      < 1.286888, -2.555879, -0.135298>,
      < 2.040321, -2.632582, -0.220152>
    }
    triangle {
      < 1.157471, -2.816209, -0.449662>,
      < 2.040321, -2.632582, -0.220152>,
      < 1.795790, -3.124475, -0.814140>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 1.280752, -2.375137, 0.234031>,
      < 2.028729, -2.291073, 0.477694>
    }
    triangle {
      < 1.286888, -2.555879, -0.135298>,
      < 2.028729, -2.291073, 0.477694>,
      < 2.040321, -2.632582, -0.220152>
    }
    triangle {
      < 1.280752, -2.375137, 0.234031>,
      < 1.092823, -2.408535, 0.645399>,
      < 1.673639, -2.354178, 1.254971>
    }
    triangle {
      < 1.280752, -2.375137, 0.234031>,
      < 1.673639, -2.354178, 1.254971>,
      < 2.028729, -2.291073, 0.477694>
    }
    triangle {
      < 1.092823, -2.408535, 0.645399>,
      < 0.835474, -2.586065, 0.770395>,
      < 1.187379, -2.689620, 1.491149>
    }
    triangle {
      < 1.092823, -2.408535, 0.645399>,
      < 1.187379, -2.689620, 1.491149>,
      < 1.673639, -2.354178, 1.254971>
    }
    triangle {
      < 2.739188, -5.936777, 0.614674>,
      < 2.754859, -5.943292, -0.172624>,
      < 2.729159, -4.177640, -0.156872>
    }
    triangle {
      < 2.739188, -5.936777, 0.614674>,
      < 2.729159, -4.177640, -0.156872>,
      < 2.714527, -3.912652, 0.681104>
    }
    triangle {
      < 2.754859, -5.943292, -0.172624>,
      < 2.407583, -5.928294, -0.821781>,
      < 2.418961, -4.559316, -0.870134>
    }
    triangle {
      < 2.754859, -5.943292, -0.172624>,
      < 2.418961, -4.559316, -0.870134>,
      < 2.729159, -4.177640, -0.156872>
    }
    triangle {
      < 2.407583, -5.928294, -0.821781>,
      < 1.573807, -5.939421, -1.060754>,
      < 1.633359, -5.011849, -1.124489>
    }
    triangle {
      < 2.407583, -5.928294, -0.821781>,
      < 1.633359, -5.011849, -1.124489>,
      < 2.418961, -4.559316, -0.870134>
    }
    triangle {
      < 1.573807, -5.939421, -1.060754>,
      < 0.723337, -5.969450, -0.736258>,
      < 0.819039, -5.241535, -0.756786>
    }
    triangle {
      < 1.573807, -5.939421, -1.060754>,
      < 0.819039, -5.241535, -0.756786>,
      < 1.633359, -5.011849, -1.124489>
    }
    triangle {
      < 0.723337, -5.969450, -0.736258>,
      < 0.266087, -5.970837, -0.317630>,
      < 0.390210, -5.298005, -0.311211>
    }
    triangle {
      < 0.723337, -5.969450, -0.736258>,
      < 0.390210, -5.298005, -0.311211>,
      < 0.819039, -5.241535, -0.756786>
    }
    triangle {
      < 0.266087, -5.970837, -0.317630>,
      < 0.134620, -5.969052, 0.420646>,
      < 0.144891, -5.235314, 0.474587>
    }
    triangle {
      < 0.266087, -5.970837, -0.317630>,
      < 0.144891, -5.235314, 0.474587>,
      < 0.390210, -5.298005, -0.311211>
    }
    triangle {
      < 0.134620, -5.969052, 0.420646>,
      < 0.325007, -5.963856, 1.147833>,
      < 0.325606, -5.023898, 1.248583>
    }
    triangle {
      < 0.134620, -5.969052, 0.420646>,
      < 0.325606, -5.023898, 1.248583>,
      < 0.144891, -5.235314, 0.474587>
    }
    triangle {
      < 0.325007, -5.963856, 1.147833>,
      < 1.064737, -5.951882, 1.690577>,
      < 1.146627, -4.527002, 1.826264>
    }
    triangle {
      < 0.325007, -5.963856, 1.147833>,
      < 1.146627, -4.527002, 1.826264>,
      < 0.325606, -5.023898, 1.248583>
    }
    triangle {
      < 1.064737, -5.951882, 1.690577>,
      < 1.601838, -5.944381, 1.758035>,
      < 1.652500, -4.221898, 1.898064>
    }
    triangle {
      < 1.064737, -5.951882, 1.690577>,
      < 1.652500, -4.221898, 1.898064>,
      < 1.146627, -4.527002, 1.826264>
    }
    triangle {
      < 1.601838, -5.944381, 1.758035>,
      < 2.256385, -5.937982, 1.491583>,
      < 2.266314, -3.961618, 1.614461>
    }
    triangle {
      < 1.601838, -5.944381, 1.758035>,
      < 2.266314, -3.961618, 1.614461>,
      < 1.652500, -4.221898, 1.898064>
    }
    triangle {
      < 2.256385, -5.937982, 1.491583>,
      < 2.739188, -5.936777, 0.614674>,
      < 2.714527, -3.912652, 0.681104>
    }
    triangle {
      < 2.256385, -5.937982, 1.491583>,
      < 2.714527, -3.912652, 0.681104>,
      < 2.266314, -3.961618, 1.614461>
    }
    triangle {
      < 1.090635, -7.031658, 1.460434>,
      < 1.572043, -7.025036, 1.519979>,
      < 1.601838, -5.944381, 1.758035>
    }
    triangle {
      < 1.090635, -7.031658, 1.460434>,
      < 1.601838, -5.944381, 1.758035>,
      < 1.064737, -5.951882, 1.690577>
    }
    triangle {
      < 1.572043, -7.025036, 1.519979>,
      < 2.160972, -7.019388, 1.284782>,
      < 2.256385, -5.937982, 1.491583>
    }
    triangle {
      < 1.572043, -7.025036, 1.519979>,
      < 2.256385, -5.937982, 1.491583>,
      < 1.601838, -5.944381, 1.758035>
    }
    triangle {
      < 2.160972, -7.019388, 1.284782>,
      < 2.599437, -7.018324, 0.510732>,
      < 2.739188, -5.936777, 0.614674>
    }
    triangle {
      < 2.160972, -7.019388, 1.284782>,
      < 2.739188, -5.936777, 0.614674>,
      < 2.256385, -5.937982, 1.491583>
    }
    triangle {
      < 2.599437, -7.018324, 0.510732>,
      < 2.613849, -7.024075, -0.184219>,
      < 2.754859, -5.943292, -0.172624>
    }
    triangle {
      < 2.599437, -7.018324, 0.510732>,
      < 2.754859, -5.943292, -0.172624>,
      < 2.739188, -5.936777, 0.614674>
    }
    triangle {
      < 2.613849, -7.024075, -0.184219>,
      < 2.313214, -7.032358, -0.775741>,
      < 2.407583, -5.928294, -0.821781>
    }
    triangle {
      < 2.613849, -7.024075, -0.184219>,
      < 2.407583, -5.928294, -0.821781>,
      < 2.754859, -5.943292, -0.172624>
    }
    triangle {
      < 2.313214, -7.032358, -0.775741>,
      < 1.561767, -7.042181, -0.986682>,
      < 1.573807, -5.939421, -1.060754>
    }
    triangle {
      < 2.313214, -7.032358, -0.775741>,
      < 1.573807, -5.939421, -1.060754>,
      < 2.407583, -5.928294, -0.821781>
    }
    triangle {
      < 1.561767, -7.042181, -0.986682>,
      < 0.781060, -7.047165, -0.681739>,
      < 0.723337, -5.969450, -0.736258>
    }
    triangle {
      < 1.561767, -7.042181, -0.986682>,
      < 0.723337, -5.969450, -0.736258>,
      < 1.573807, -5.939421, -1.060754>
    }
    triangle {
      < 0.781060, -7.047165, -0.681739>,
      < 0.368183, -7.048390, -0.312215>,
      < 0.266087, -5.970837, -0.317630>
    }
    triangle {
      < 0.781060, -7.047165, -0.681739>,
      < 0.266087, -5.970837, -0.317630>,
      < 0.723337, -5.969450, -0.736258>
    }
    triangle {
      < 0.368183, -7.048390, -0.312215>,
      < 0.249018, -7.046814, 0.339463>,
      < 0.134620, -5.969052, 0.420646>
    }
    triangle {
      < 0.368183, -7.048390, -0.312215>,
      < 0.134620, -5.969052, 0.420646>,
      < 0.266087, -5.970837, -0.317630>
    }
    triangle {
      < 0.249018, -7.046814, 0.339463>,
      < 0.423105, -7.042226, 0.981353>,
      < 0.325007, -5.963856, 1.147833>
    }
    triangle {
      < 0.249018, -7.046814, 0.339463>,
      < 0.325007, -5.963856, 1.147833>,
      < 0.134620, -5.969052, 0.420646>
    }
    triangle {
      < 0.423105, -7.042226, 0.981353>,
      < 1.090635, -7.031658, 1.460434>,
      < 1.064737, -5.951882, 1.690577>
    }
    triangle {
      < 0.423105, -7.042226, 0.981353>,
      < 1.064737, -5.951882, 1.690577>,
      < 0.325007, -5.963856, 1.147833>
    }
    triangle {
      < 1.975347, -7.812831, 1.241284>,
      < 2.160972, -7.019388, 1.284782>,
      < 1.572043, -7.025036, 1.519979>
    }
    triangle {
      < 1.975347, -7.812831, 1.241284>,
      < 1.572043, -7.025036, 1.519979>,
      < 1.336529, -7.864736, 1.430424>
    }
    triangle {
      < 2.160972, -7.019388, 1.284782>,
      < 1.975347, -7.812831, 1.241284>,
      < 2.443700, -7.794046, 0.570322>
    }
    triangle {
      < 2.160972, -7.019388, 1.284782>,
      < 2.443700, -7.794046, 0.570322>,
      < 2.599437, -7.018324, 0.510732>
    }
    triangle {
      < 1.561767, -7.042181, -0.986682>,
      < 2.313214, -7.032358, -0.775741>,
      < 2.044399, -7.905108, -0.789951>
    }
    triangle {
      < 1.561767, -7.042181, -0.986682>,
      < 2.044399, -7.905108, -0.789951>,
      < 1.252770, -8.003237, -0.934381>
    }
    triangle {
      < 0.781060, -7.047165, -0.681739>,
      < 1.561767, -7.042181, -0.986682>,
      < 1.252770, -8.003237, -0.934381>
    }
    triangle {
      < 0.781060, -7.047165, -0.681739>,
      < 1.252770, -8.003237, -0.934381>,
      < 0.700721, -8.056448, -0.504861>
    }
    triangle {
      < 0.368183, -7.048390, -0.312215>,
      < 0.700721, -8.056448, -0.504861>,
      < 0.370201, -8.109273, 0.418486>
    }
    triangle {
      < 0.368183, -7.048390, -0.312215>,
      < 0.370201, -8.109273, 0.418486>,
      < 0.249018, -7.046814, 0.339463>
    }
    triangle {
      < 2.613849, -7.024075, -0.184219>,
      < 2.479350, -7.832503, -0.152257>,
      < 2.044399, -7.905108, -0.789951>
    }
    triangle {
      < 2.613849, -7.024075, -0.184219>,
      < 2.044399, -7.905108, -0.789951>,
      < 2.313214, -7.032358, -0.775741>
    }
    triangle {
      < 2.479350, -7.832503, -0.152257>,
      < 2.613849, -7.024075, -0.184219>,
      < 2.599437, -7.018324, 0.510732>
    }
    triangle {
      < 2.479350, -7.832503, -0.152257>,
      < 2.599437, -7.018324, 0.510732>,
      < 2.443700, -7.794046, 0.570322>
    }
    triangle {
      < 1.090635, -7.031658, 1.460434>,
      < 0.423105, -7.042226, 0.981353>,
      < 0.608883, -8.006459, 1.159099>
    }
    triangle {
      < 0.370201, -8.109273, 0.418486>,
      < 0.513613, -8.778045, 0.117577>,
      < 0.668801, -8.649164, 0.894079>
    }
    triangle {
      < 0.370201, -8.109273, 0.418486>,
      < 0.668801, -8.649164, 0.894079>,
      < 0.608883, -8.006459, 1.159099>
    }
    triangle {
      < 0.668801, -8.649164, 0.894079>,
      < 1.222692, -8.558242, 1.154920>,
      < 1.336529, -7.864736, 1.430424>
    }
    triangle {
      < 0.668801, -8.649164, 0.894079>,
      < 1.336529, -7.864736, 1.430424>,
      < 0.608883, -8.006459, 1.159099>
    }
    triangle {
      < 1.336529, -7.864736, 1.430424>,
      < 1.572043, -7.025036, 1.519979>,
      < 1.090635, -7.031658, 1.460434>
    }
    triangle {
      < 1.336529, -7.864736, 1.430424>,
      < 1.090635, -7.031658, 1.460434>,
      < 0.608883, -8.006459, 1.159099>
    }
    triangle {
      < 1.907846, -16.537790, 0.856772>,
      < 1.952909, -16.542427, 0.216444>,
      < 1.931898, -16.313671, 0.040689>
    }
    triangle {
      < 1.907846, -16.537790, 0.856772>,
      < 1.931898, -16.313671, 0.040689>,
      < 1.867600, -16.218853, 0.441845>
    }
    triangle {
      < 1.793585, -16.272459, 1.038232>,
      < 1.907846, -16.537790, 0.856772>,
      < 1.867600, -16.218853, 0.441845>
    }
    triangle {
      < 1.793585, -16.272459, 1.038232>,
      < 1.867600, -16.218853, 0.441845>,
      < 1.772568, -16.093166, 0.679117>
    }
    triangle {
      < 1.300814, -14.712014, 0.513934>,
      < 1.305812, -15.344311, 0.504918>,
      < 1.501738, -15.344625, 0.448596>
    }
    triangle {
      < 1.300814, -14.712014, 0.513934>,
      < 1.501738, -15.344625, 0.448596>,
      < 1.681067, -14.709235, 0.431913>
    }
    triangle {
      < 0.664697, -15.344782, 0.311132>,
      < 0.889343, -15.344277, 0.470349>,
      < 0.926533, -14.682714, 0.270446>
    }
    triangle {
      < 1.766149, -15.344839, -0.538318>,
      < 1.621508, -15.344833, -0.686742>,
      < 1.695713, -14.682818, -0.573428>
    }
    triangle {
      < 0.249018, -7.046814, 0.339463>,
      < 0.370201, -8.109273, 0.418486>,
      < 0.608883, -8.006459, 1.159099>
    }
    triangle {
      < 0.249018, -7.046814, 0.339463>,
      < 0.608883, -8.006459, 1.159099>,
      < 0.423105, -7.042226, 0.981353>
    }
    triangle {
      < 0.368183, -7.048390, -0.312215>,
      < 0.781060, -7.047165, -0.681739>,
      < 0.700721, -8.056448, -0.504861>
    }
    texture {legl}
  }
  rotate x*0
  rotate y*0
  rotate z*0
}
